SET CACHE_SIZE 131072;         
;              
CREATE USER IF NOT EXISTS "SA" SALT '5780908c936caf1f' HASH '23eed9704e1619fe12004d0b8f5d9e47208d489979719c055d1feb0222e365b9' ADMIN;          
CREATE CACHED TABLE "PUBLIC"."ANTIFAM_HMMER3_RAW_MATCH"(
    "ID" BIGINT NOT NULL,
    "LOC_FRAGMENT_DCS_TATUS" VARCHAR(255),
    "LOCATION_END" INTEGER,
    "LOCATION_START" INTEGER,
    "MODEL_ID" VARCHAR(255),
    "NUMERIC_SEQUENCE_ID" BIGINT,
    "SEQUENCE_ID" VARCHAR(255),
    "SIGNATURE_LIBRARY" VARCHAR(255),
    "SIG_LIB_RELEASE" VARCHAR(255),
    "EVALUE" DOUBLE NOT NULL,
    "HMM_BOUNDS" VARCHAR(2),
    "HMM_END" INTEGER NOT NULL,
    "HMM_START" INTEGER NOT NULL,
    "LOCATION_SCORE" DOUBLE NOT NULL,
    "SCORE" DOUBLE NOT NULL,
    "DOMAIN_BIAS" DOUBLE NOT NULL,
    "DOMAIN_CE_VALUE" DOUBLE NOT NULL,
    "DOMAIN_IE_VALUE" DOUBLE NOT NULL,
    "ENVELOPE_END" INTEGER NOT NULL,
    "ENVELOPE_START" INTEGER NOT NULL,
    "EXPECTED_ACCURACY" DOUBLE NOT NULL,
    "FULL_SEQUENCE_BIAS" DOUBLE NOT NULL,
    "SPLIT_GROUP" BINARY
);   
ALTER TABLE "PUBLIC"."ANTIFAM_HMMER3_RAW_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_E" PRIMARY KEY("ID");      
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.ANTIFAM_HMMER3_RAW_MATCH; 
CREATE INDEX "PUBLIC"."ANTIFAM_RW_SEQ_IDX" ON "PUBLIC"."ANTIFAM_HMMER3_RAW_MATCH"("SEQUENCE_ID");              
CREATE INDEX "PUBLIC"."ANTIFAM_RW_NUM_SEQ_IDX" ON "PUBLIC"."ANTIFAM_HMMER3_RAW_MATCH"("NUMERIC_SEQUENCE_ID");  
CREATE INDEX "PUBLIC"."ANTIFAM_RW_MODEL_IDX" ON "PUBLIC"."ANTIFAM_HMMER3_RAW_MATCH"("MODEL_ID");               
CREATE INDEX "PUBLIC"."ANTIFAM_RW_SIGLIB_IDX" ON "PUBLIC"."ANTIFAM_HMMER3_RAW_MATCH"("SIGNATURE_LIBRARY");     
CREATE INDEX "PUBLIC"."ANTIFAM_RW_SIGLIB_REL_IDX" ON "PUBLIC"."ANTIFAM_HMMER3_RAW_MATCH"("SIG_LIB_RELEASE");   
CREATE CACHED TABLE "PUBLIC"."BLAST_PRODOM_LOCATION"(
    "ID" BIGINT NOT NULL,
    "LOC_END" INTEGER NOT NULL,
    "LOC_START" INTEGER NOT NULL,
    "MATCH_ID" BIGINT NOT NULL,
    "EVALUE" DOUBLE NOT NULL,
    "SCORE" DOUBLE NOT NULL
); 
ALTER TABLE "PUBLIC"."BLAST_PRODOM_LOCATION" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_4" PRIMARY KEY("ID");         
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.BLAST_PRODOM_LOCATION;    
CREATE CACHED TABLE "PUBLIC"."BLAST_PRODOM_LOCATION_FRAGMENT"(
    "ID" BIGINT NOT NULL,
    "DC_STATUS" VARCHAR(255) NOT NULL,
    "LOC_END" INTEGER NOT NULL,
    "LOC_START" INTEGER NOT NULL,
    "LOCATION_ID" BIGINT NOT NULL
);         
ALTER TABLE "PUBLIC"."BLAST_PRODOM_LOCATION_FRAGMENT" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_9" PRIMARY KEY("ID");
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.BLAST_PRODOM_LOCATION_FRAGMENT;           
CREATE CACHED TABLE "PUBLIC"."BLAST_PRODOM_MATCH"(
    "ID" BIGINT NOT NULL,
    "SIGNATURE_MODELS" VARCHAR(255),
    "PROTEIN_ID" BIGINT NOT NULL,
    "SIGNATURE_ID" BIGINT NOT NULL
);      
ALTER TABLE "PUBLIC"."BLAST_PRODOM_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_2" PRIMARY KEY("ID");            
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.BLAST_PRODOM_MATCH;       
CREATE CACHED TABLE "PUBLIC"."CDD_RAW_MATCH"(
    "ID" BIGINT NOT NULL,
    "LOC_FRAGMENT_DCS_TATUS" VARCHAR(255),
    "LOCATION_END" INTEGER,
    "LOCATION_START" INTEGER,
    "MODEL_ID" VARCHAR(255),
    "NUMERIC_SEQUENCE_ID" BIGINT,
    "SEQUENCE_ID" VARCHAR(255),
    "SIGNATURE_LIBRARY" VARCHAR(255),
    "SIG_LIB_RELEASE" VARCHAR(255),
    "BIT_SCORE" DOUBLE,
    "DEFINITION_LINE" VARCHAR(255),
    "EVALUE" DOUBLE,
    "HIT_TYPE" INTEGER,
    "INCOMPLETE" VARCHAR(255),
    "PSSM_ID" VARCHAR(255),
    "SESSION_NUMBER" INTEGER,
    "SHORT_NAME" VARCHAR(255),
    "SUPERFAMILY_PSSMID" VARCHAR(255)
);
ALTER TABLE "PUBLIC"."CDD_RAW_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_2A" PRIMARY KEY("ID");
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.CDD_RAW_MATCH;            
CREATE INDEX "PUBLIC"."CDD_RW_SEQ_IDX" ON "PUBLIC"."CDD_RAW_MATCH"("SEQUENCE_ID");             
CREATE INDEX "PUBLIC"."CDD_RW_NUM_SEQ_IDX" ON "PUBLIC"."CDD_RAW_MATCH"("NUMERIC_SEQUENCE_ID"); 
CREATE INDEX "PUBLIC"."CDD_RW_MODEL_IDX" ON "PUBLIC"."CDD_RAW_MATCH"("MODEL_ID");              
CREATE INDEX "PUBLIC"."CDD_RW_SIGLIB_IDX" ON "PUBLIC"."CDD_RAW_MATCH"("SIGNATURE_LIBRARY");    
CREATE INDEX "PUBLIC"."CDD_RW_SIGLIB_REL_IDX" ON "PUBLIC"."CDD_RAW_MATCH"("SIG_LIB_RELEASE");  
CREATE CACHED TABLE "PUBLIC"."CDD_RAW_SITE"(
    "ID" BIGINT NOT NULL,
    "FIRST_START" INTEGER,
    "LAST_END" INTEGER,
    "MODEL_ID" VARCHAR(255),
    "NUMERIC_SEQUENCE_ID" BIGINT,
    "RESIDUES" VARCHAR(6000) NOT NULL,
    "SEQUENCE_ID" VARCHAR(255),
    "SIGNATURE_LIBRARY" VARCHAR(255),
    "SIG_LIB_RELEASE" VARCHAR(255),
    "TITLE" VARCHAR(255),
    "COMPLETE_SIZE" INTEGER,
    "HIT_TYPE" INTEGER,
    "MAPPED_SIZE" INTEGER,
    "PSSM_ID" VARCHAR(255),
    "SESSION_NUMBER" INTEGER
);
ALTER TABLE "PUBLIC"."CDD_RAW_SITE" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_C" PRIMARY KEY("ID");  
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.CDD_RAW_SITE;             
CREATE INDEX "PUBLIC"."CDD_RW_S_SEQ_IDX" ON "PUBLIC"."CDD_RAW_SITE"("SEQUENCE_ID");            
CREATE INDEX "PUBLIC"."CDD_RW_S_NUM_SEQ_IDX" ON "PUBLIC"."CDD_RAW_SITE"("NUMERIC_SEQUENCE_ID");
CREATE INDEX "PUBLIC"."CDD_RW_S_MODEL_IDX" ON "PUBLIC"."CDD_RAW_SITE"("MODEL_ID");             
CREATE INDEX "PUBLIC"."CDD_RW_S_SIGLIB_IDX" ON "PUBLIC"."CDD_RAW_SITE"("SIGNATURE_LIBRARY");   
CREATE INDEX "PUBLIC"."CDD_RW_S_SIGLIB_REL_IDX" ON "PUBLIC"."CDD_RAW_SITE"("SIG_LIB_RELEASE"); 
CREATE CACHED TABLE "PUBLIC"."COILS_LOCATION"(
    "ID" BIGINT NOT NULL,
    "LOC_END" INTEGER NOT NULL,
    "LOC_START" INTEGER NOT NULL,
    "MATCH_ID" BIGINT NOT NULL
);   
ALTER TABLE "PUBLIC"."COILS_LOCATION" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_F" PRIMARY KEY("ID");
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.COILS_LOCATION;           
CREATE CACHED TABLE "PUBLIC"."COILS_LOCATION_FRAGMENT"(
    "ID" BIGINT NOT NULL,
    "DC_STATUS" VARCHAR(255) NOT NULL,
    "LOC_END" INTEGER NOT NULL,
    "LOC_START" INTEGER NOT NULL,
    "LOCATION_ID" BIGINT NOT NULL
);
ALTER TABLE "PUBLIC"."COILS_LOCATION_FRAGMENT" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_FD" PRIMARY KEY("ID");      
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.COILS_LOCATION_FRAGMENT;  
CREATE CACHED TABLE "PUBLIC"."COILS_MATCH"(
    "ID" BIGINT NOT NULL,
    "SIGNATURE_MODELS" VARCHAR(255),
    "PROTEIN_ID" BIGINT NOT NULL,
    "SIGNATURE_ID" BIGINT NOT NULL
);             
ALTER TABLE "PUBLIC"."COILS_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_45" PRIMARY KEY("ID");  
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.COILS_MATCH;              
CREATE CACHED TABLE "PUBLIC"."ENTRY"(
    "ID" BIGINT NOT NULL,
    "ABSTRACT_FIRST_CHUNK" VARCHAR(4000),
    "ACCESSION" VARCHAR(255) NOT NULL,
    "CREATED" TIMESTAMP,
    "DESCRIPTION_FIRST_CHUNK" VARCHAR(4000),
    "NAME" VARCHAR(255),
    "TYPE" INTEGER,
    "UPDATED" TIMESTAMP
); 
ALTER TABLE "PUBLIC"."ENTRY" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_3" PRIMARY KEY("ID");         
-- 37771 +/- SELECT COUNT(*) FROM PUBLIC.ENTRY;
INSERT INTO "PUBLIC"."ENTRY" VALUES
(1, NULL, 'IPR003567', NULL, 'Cytochrome c-type biogenesis protein', 'Cyt_c_biogenesis', 4, NULL),
(2, NULL, 'IPR003005', NULL, 'Amphiphysin', 'Amphiphysin', 4, NULL),
(3, NULL, 'IPR007166', NULL, 'Class III signal peptide motif', 'Class3_signal_pept_motif', 2, NULL),
(4, NULL, 'IPR006527', NULL, 'F-box associated domain, type 1', 'F-box-assoc_dom_typ1', 3, NULL),
(5, NULL, 'IPR000890', NULL, 'Aliphatic acid kinase, short-chain', 'Aliphatic_acid_kin_short-chain', 4, NULL),
(6, NULL, 'IPR004891', NULL, 'Mercury transport protein MerC', 'Mercury-R_MerC', 4, NULL),
(7, NULL, 'IPR003557', NULL, 'Cytochrome c-type biogenesis protein CcmC', 'Cyt_c_biogenesis_CcmC', 4, NULL),
(8, NULL, 'IPR006568', NULL, 'PSP, proline-rich', 'PSP_pro-rich', 3, NULL),
(9, NULL, 'IPR005920', NULL, 'Imidazolonepropionase', 'HutI', 4, NULL),
(10, NULL, 'IPR005967', NULL, 'Thiamin/thiamin pyrophosphate ABC transporter, substrate-binding protein, Proteobacteria', 'ThiB', 4, NULL),
(11, NULL, 'IPR003023', NULL, 'Amphiphysin 2', 'Amphiphysin_2', 4, NULL),
(12, NULL, 'IPR007655', NULL, 'Surface lipoprotein assembly modifier', 'Slam', 4, NULL),
(13, NULL, 'IPR007664', NULL, 'Poxvirus A28', 'Poxvirus_A28', 4, NULL),
(14, NULL, 'IPR005431', NULL, 'Gamma-aminobutyric-acid A receptor, alpha 1 subunit', 'GABBAa1_rcpt', 4, NULL),
(15, NULL, 'IPR006573', NULL, 'Neuralized homology repeat (NHR) domain', 'NHR_dom', 3, NULL),
(16, NULL, 'IPR003583', NULL, 'Helix-hairpin-helix DNA-binding motif, class 1', 'Hlx-hairpin-Hlx_DNA-bd_motif', 3, NULL),
(17, NULL, 'IPR003597', NULL, 'Immunoglobulin C1-set', 'Ig_C1-set', 3, NULL),
(18, NULL, 'IPR003578', NULL, 'Small GTPase Rho', 'Small_GTPase_Rho', 4, NULL),
(19, NULL, 'IPR000909', NULL, 'Phosphatidylinositol-specific phospholipase C, X domain', 'PLipase_C_PInositol-sp_X_dom', 3, NULL),
(20, NULL, 'IPR007167', NULL, 'Ferrous iron transporter FeoA domain', 'Fe-transptr_FeoA', 3, NULL),
(21, NULL, 'IPR006536', NULL, 'HnRNP-L/PTB', 'HnRNP-L/PTB', 4, NULL),
(22, NULL, 'IPR002222', NULL, 'Ribosomal protein S19/S15', 'Ribosomal_S19', 4, NULL),
(23, NULL, 'IPR003035', NULL, 'RWP-RK domain', 'RWP-RK_dom', 3, NULL),
(24, NULL, 'IPR000981', NULL, 'Neurohypophysial hormone', 'Neurhyp_horm', 4, NULL),
(25, NULL, 'IPR000905', NULL, 'Gcp-like domain', 'Gcp-like_dom', 3, NULL),
(26, NULL, 'IPR007115', NULL, '6-pyruvoyl tetrahydropterin synthase/QueD family', '6-PTP_synth/QueD', 4, NULL),
(27, NULL, 'IPR007099', NULL, 'RNA-directed RNA polymerase, negative-strand RNA virus', 'RNA-dir_pol_NSvirus', 3, NULL),
(28, NULL, 'IPR000939', NULL, 'Adenoviral fibre protein, repeat/shaft region', 'Adenobir_fibre_prot_rpt/shaft', 7, NULL),
(29, NULL, 'IPR003038', NULL, 'DAD/Ost2', 'DAD/Ost2', 4, NULL),
(30, NULL, 'IPR007157', NULL, 'PspA/IM30', 'PspA_IM30', 4, NULL),
(31, NULL, 'IPR007142', NULL, 'Haemagglutinin-esterase glycoprotein, core', 'Hemagglutn-estrase_core', 3, NULL),
(32, NULL, 'IPR000363', NULL, 'Alpha 1D adrenoceptor', 'ADRA1D_rcpt', 4, NULL),
(33, NULL, 'IPR002255', NULL, 'Flavin monooxygenase (FMO) 3', 'Flavin_mOase_3', 4, NULL),
(34, NULL, 'IPR001278', NULL, 'Arginine-tRNA ligase', 'Arg-tRNA-ligase', 4, NULL),
(35, NULL, 'IPR003563', NULL, 'Oxidized purine nucleoside triphosphate', '8ODP', 4, NULL),
(36, NULL, 'IPR005422', NULL, 'Voltage-dependent calcium channel, gamma-2 subunit', 'VDCC_g2su', 4, NULL),
(37, NULL, 'IPR007143', NULL, 'Vacuolar protein sorting-associated Vps28', 'Vps28', 4, NULL),
(38, NULL, 'IPR002167', NULL, 'Graves disease carrier protein', 'Graves_DC', 4, NULL),
(39, NULL, 'IPR000343', NULL, 'Glutamyl-tRNA reductase', '4pyrrol_synth_GluRdtase', 4, NULL),
(40, NULL, 'IPR034553', NULL, 'Mitochondrial import receptor subunit TOM5 homologue, viridiplantae', 'TOM5_viridi', 4, NULL),
(41, NULL, 'IPR006576', NULL, 'BRK domain', 'BRK_domain', 3, NULL),
(42, NULL, 'IPR000988', NULL, 'Ribosomal protein L24e-related', 'Ribosomal_L24e-rel', 4, NULL),
(43, NULL, 'IPR003020', NULL, 'Bicarbonate transporter, eukaryotic', 'HCO3_transpt_euk', 4, NULL),
(44, NULL, 'IPR000371', NULL, 'P2Y3 purinoceptor', 'P2Y3_rcpt', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(45, NULL, 'IPR005434', NULL, 'Gamma-aminobutyric-acid A receptor, alpha 4 subunit', 'GABBAa4_rcpt', 4, NULL),
(46, NULL, 'IPR007159', NULL, 'SpoVT-AbrB domain', 'SpoVT-AbrB_dom', 3, NULL),
(47, NULL, 'IPR000352', NULL, 'Peptide chain release factor class I', 'Pep_chain_release_fac_I', 3, NULL),
(48, NULL, 'IPR007300', NULL, 'CidB/LrgB family', 'CidB/LrgB', 4, NULL),
(49, NULL, 'IPR007650', NULL, 'Zf-FLZ domain', 'Zf-FLZ_dom', 3, NULL),
(50, NULL, 'IPR002238', NULL, 'CC chemokine receptor 3', 'Chemokine_CCR3', 4, NULL),
(51, NULL, 'IPR001371', NULL, 'Glycoside hydrolase, family 14B, plant', 'Glyco_hydro_14B_pln', 4, NULL),
(52, NULL, 'IPR003594', NULL, 'Histidine kinase/HSP90-like ATPase', 'HATPase_C', 3, NULL),
(53, NULL, 'IPR006531', NULL, 'Gp5/Type VI secretion system Vgr protein, OB-fold domain', 'Gp5/Vgr_OB', 3, NULL),
(54, NULL, 'IPR005432', NULL, 'Gamma-aminobutyric-acid A receptor, alpha 2 subunit', 'GABBAa2_rcpt', 4, NULL),
(55, NULL, 'IPR006522', NULL, 'Phage virion morphogensis protein', 'Phage_virion_morphogenesis', 4, NULL),
(56, NULL, 'IPR007125', NULL, 'Histone H2A/H2B/H3', 'Histone_H2A/H2B/H3', 3, NULL),
(57, NULL, 'IPR007162', NULL, 'Protein of unknown function DUF366', 'DUF366', 4, NULL),
(58, NULL, 'IPR002208', NULL, 'SecY/SEC61-alpha family', 'SecY/SEC61-alpha', 4, NULL),
(59, NULL, 'IPR000877', NULL, 'Proteinase inhibitor I12, Bowman-Birk', 'Prot_inh_BBI', 3, NULL),
(60, NULL, 'IPR007097', NULL, 'RNA-directed RNA polymerase, reovirus', 'RNA-dir_pol_reovirus', 3, NULL),
(61, NULL, 'IPR005433', NULL, 'Gamma-aminobutyric-acid A receptor, alpha 3 subunit', 'GABBAa3_rcpt', 4, NULL),
(62, NULL, 'IPR006540', NULL, 'Bacteriocin, lactococcin 972', 'Lactococcin_972', 4, NULL),
(63, NULL, 'IPR006554', NULL, 'Helicase-like, DEXD box c2 type', 'Helicase-like_DEXD_c2', 3, NULL),
(64, NULL, 'IPR003036', NULL, 'Core shell protein Gag P30', 'Gag_P30', 3, NULL),
(65, NULL, 'IPR007659', NULL, 'Keratin, high-sulphur matrix protein', 'Keratin_matx', 4, NULL),
(66, NULL, 'IPR006582', NULL, 'MD domain', 'MD_domain', 3, NULL),
(67, NULL, 'IPR006585', NULL, 'Fucolectin tachylectin-4 pentraxin-1', 'FTP1', 3, NULL),
(68, NULL, 'IPR007645', NULL, 'RNA polymerase Rpb2, domain 3', 'RNA_pol_Rpb2_3', 3, NULL),
(69, NULL, 'IPR005435', NULL, 'Gamma-aminobutyric-acid A receptor, alpha 5 subunit', 'GABBAa5_rcpt', 4, NULL),
(70, NULL, 'IPR005922', NULL, 'Phenylalanine ammonia-lyase', 'Phe_NH3-lyase', 4, NULL),
(71, NULL, 'IPR003034', NULL, 'SAP domain', 'SAP_dom', 3, NULL),
(72, NULL, 'IPR034534', NULL, 'Bleomycin-like antibiotic biosynthesis, pyrimidine ring methyltransferase', 'Pyrimidine_methyltransferase', 4, NULL),
(73, NULL, 'IPR004894', NULL, 'Borrelia outer surface protein D OspD', 'OspD', 4, NULL),
(74, NULL, 'IPR002217', NULL, 'Lipoprotein LPP20', 'Lipo_LPP20', 4, NULL),
(75, NULL, 'IPR005913', NULL, 'dTDP-4-dehydrorhamnose reductase family', 'dTDP_dehydrorham_reduct', 4, NULL),
(76, NULL, 'IPR000874', NULL, 'Bombesin/neuromedin-B/ranatensin peptide family', 'Bombesin', 4, NULL),
(77, NULL, 'IPR005441', NULL, 'Preproghrelin peptide', 'Preproghrelin', 4, NULL),
(78, NULL, 'IPR007081', NULL, 'RNA polymerase Rpb1, domain 5', 'RNA_pol_Rpb1_5', 3, NULL),
(79, NULL, 'IPR000351', NULL, 'Neuropeptide Y1 receptor', 'NPY1_rcpt', 4, NULL),
(80, NULL, 'IPR000999', NULL, 'Ribonuclease III domain', 'RNase_III_dom', 3, NULL),
(81, NULL, 'IPR007123', NULL, 'Gelsolin-like domain', 'Gelsolin-like_dom', 3, NULL),
(82, NULL, 'IPR007129', NULL, 'Ubiquinol-cytochrome c chaperone, CBP3', 'Ubiqinol_cyt_c_chaperone_CPB3', 4, NULL),
(83, NULL, 'IPR007136', NULL, 'Protein of unknown function DUF347', 'DUF347', 7, NULL),
(84, NULL, 'IPR007085', NULL, 'DNA/pantothenate metabolism flavoprotein, C-terminal', 'DNA/pantothenate-metab_flavo_C', 3, NULL),
(85, NULL, 'IPR023918', NULL, 'Colanic acid biosynthesis, pyruvyl transferase, WcaK', 'Colanic_acid_synth_WcaK', 4, NULL),
(86, NULL, 'IPR005447', NULL, 'Voltage-dependent calcium channel, N-type, alpha-1 subunit', 'VDCC_N_a1su', 4, NULL),
(87, NULL, 'IPR000374', NULL, 'Phosphatidate cytidylyltransferase', 'PC_trans', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(88, NULL, 'IPR002190', NULL, 'MAGE homology domain', 'MHD_dom', 3, NULL),
(89, NULL, 'IPR000839', NULL, 'Porin, Oms28 type', 'Porin_Oms28', 4, NULL),
(90, NULL, 'IPR004895', NULL, 'Prenylated rab acceptor PRA1', 'Prenylated_rab_accept_PRA1', 4, NULL),
(91, NULL, 'IPR002244', NULL, 'Chloride channel ClC-2', 'Cl-channel-2', 4, NULL),
(92, NULL, 'IPR001270', NULL, 'ClpA/B family', 'ClpA/B', 4, NULL),
(93, NULL, 'IPR007135', NULL, 'Ubiquitin-like-conjugating enzyme Atg3/Atg10', 'Atg3/Atg10', 4, NULL),
(94, NULL, 'IPR002242', NULL, 'Chloride channel ClC-0', 'Cl_channel-0', 4, NULL),
(95, NULL, 'IPR007119', NULL, 'Phage minor structural protein, N-terminal domain', 'Phage_minor_struct_N', 3, NULL),
(96, NULL, 'IPR003593', NULL, 'AAA+ ATPase domain', 'AAA+_ATPase', 3, NULL),
(97, NULL, 'IPR006523', NULL, 'Transcription activator RinA', 'RinA', 4, NULL),
(98, NULL, 'IPR005964', NULL, 'Bacterial glucose/galactose transporter', 'Glc/Gal_transptr_bac', 4, NULL),
(99, NULL, 'IPR005436', NULL, 'Gamma-aminobutyric-acid A receptor, alpha 6 subunit', 'GABBAa6_rcpt', 4, NULL),
(100, NULL, 'IPR001275', NULL, 'DM DNA-binding domain', 'DM_DNA-bd', 3, NULL),
(101, NULL, 'IPR034577', NULL, 'Protein NIM1-INTERACTING 2', 'NIMIN-2', 4, NULL),
(102, NULL, 'IPR005428', NULL, 'CD36/scavenger receptor class B member 1', 'CD36/SCARB1/SNMP1', 4, NULL),
(103, NULL, 'IPR002197', NULL, 'DNA binding HTH domain,  Fis-type', 'HTH_Fis', 3, NULL),
(104, NULL, 'IPR001302', NULL, 'Photosystem I reaction centre subunit VIII', 'PSI_PsaI', 4, NULL),
(105, NULL, 'IPR005921', NULL, 'Histidine ammonia-lyase', 'HutH', 4, NULL),
(106, NULL, 'IPR007154', NULL, 'Protein of unknown function DUF356', 'DUF356', 4, NULL),
(107, NULL, 'IPR001285', NULL, 'Synaptophysin/synaptoporin', 'Synaptophysin/porin', 4, NULL),
(108, NULL, 'IPR007094', NULL, 'RNA-directed RNA polymerase,  catalytic domain', 'RNA-dir_pol_PSvirus', 3, NULL),
(109, NULL, 'IPR005933', NULL, 'Delta-1-pyrroline-5-carboxylate dehydrogenase 3', 'Delta1-pyrroline-5-COlate_DH-3', 3, NULL),
(110, NULL, 'IPR005939', NULL, 'Beta-lactamase hydrolase-like protein, phosphatase-like domain', 'BLH_phosphatase-like', 3, NULL),
(111, NULL, 'IPR001283', NULL, 'Cysteine-rich  secretory protein-related', 'CRISP-related', 4, NULL),
(112, NULL, 'IPR003018', NULL, 'GAF domain', 'GAF', 3, NULL),
(113, NULL, 'IPR034563', NULL, 'Protein PALE CRESS', 'PALE_CRESS', 4, NULL),
(114, NULL, 'IPR006570', NULL, 'SPK domain', 'SPK_dom', 3, NULL),
(115, NULL, 'IPR006538', NULL, 'Cobalt chelatase, CobT subunit', 'CobT', 4, NULL),
(116, NULL, 'IPR001320', NULL, 'Ionotropic glutamate receptor', 'Iontro_rcpt', 3, NULL),
(117, NULL, 'IPR003560', NULL, '2,3-dihydro-2,3-dihydroxybenzoate dehydrogenase', 'DHB_DH', 4, NULL),
(118, NULL, 'IPR006546', NULL, 'Sex-lethal splicing factor', 'Sxl', 4, NULL),
(119, NULL, 'IPR001314', NULL, 'Peptidase S1A, chymotrypsin family', 'Peptidase_S1A', 4, NULL),
(120, NULL, 'IPR000358', NULL, 'Ribonucleotide reductase small subunit family', 'RNR_small_fam', 4, NULL),
(121, NULL, 'IPR005908', NULL, 'Glucose-1-phosphate thymidylyltransferase, long form', 'G1P_thy_trans_l', 4, NULL),
(122, NULL, 'IPR004889', NULL, 'H2-forming N5,N10-methylenetetrahydromethanopterin dehydrogenase, C-terminal', 'HMD_C', 3, NULL),
(123, NULL, 'IPR024675', NULL, 'Eukaryotic translation initiation factor 3 subunit G, N-terminal', 'eIF3g_N', 3, NULL),
(124, NULL, 'IPR007130', NULL, 'Diacylglycerol acyltransferase', 'DAGAT', 4, NULL),
(125, NULL, 'IPR024708', NULL, 'Catalase active site', 'Catalase_AS', 0, NULL),
(126, NULL, 'IPR006551', NULL, 'Polynucleotide 3''-phosphatase', 'Polynucleotide_phosphatase', 3, NULL),
(127, NULL, 'IPR000346', NULL, 'Hyperglycemic hormone type 1', 'Hyperglycemic1', 4, NULL),
(128, NULL, 'IPR007117', NULL, 'Expansin, cellulose-binding-like domain', 'Expansin_CBD', 3, NULL),
(129, NULL, 'IPR007161', NULL, 'Putative heavy-metal chelation domain', 'DUF364', 3, NULL),
(130, NULL, 'IPR005440', NULL, 'Gamma-aminobutyric-acid A receptor, gamma 3 subunit', 'GABBAg3_rcpt', 4, NULL),
(131, NULL, 'IPR000935', NULL, 'Thrombin receptor', 'Thrmbn_rcpt', 4, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(132, NULL, 'IPR007126', NULL, 'Borrelia REV', 'Borrelia_REV', 4, NULL),
(133, NULL, 'IPR001338', NULL, 'Hydrophobin', 'Hydrophobin', 4, NULL),
(134, NULL, 'IPR000845', NULL, 'Nucleoside phosphorylase domain', 'Nucleoside_phosphorylase_d', 3, NULL),
(135, NULL, 'IPR004887', NULL, 'Glutathione synthase, substrate-binding domain', 'GSH_synth_subst-bd', 3, NULL),
(136, NULL, 'IPR002251', NULL, 'Chloride channel ClC-plant', 'Cl_channel_pln', 4, NULL),
(137, NULL, 'IPR000852', NULL, 'Glycoside hydrolase, family 52', 'Glyco_hydro_52', 4, NULL),
(138, NULL, 'IPR005944', NULL, 'Proline iminopeptidase', 'Pro_iminopeptidase', 4, NULL),
(139, NULL, 'IPR007657', NULL, 'Glycosyltransferase 61', 'Glycosyltransferase_61', 4, NULL),
(140, NULL, 'IPR005929', NULL, 'Ribulokinase', 'Ribulokinase', 4, NULL),
(141, NULL, 'IPR003021', NULL, 'Rad1/Rec1/Rad17', 'Rad1_Rec1_Rad17', 4, NULL),
(142, NULL, 'IPR022761', NULL, 'Fumarate lyase, N-terminal', 'Fumarate_lyase_N', 3, NULL),
(143, NULL, 'IPR002189', NULL, 'F-actin-capping protein subunit alpha', 'CapZ_alpha', 4, NULL),
(144, NULL, 'IPR002235', NULL, 'CXC chemokine receptor 6', 'Chemokine_CXCR6', 4, NULL),
(145, NULL, 'IPR007146', NULL, 'Sas10/Utp3/C1D', 'Sas10/Utp3/C1D', 4, NULL),
(146, NULL, 'IPR001013', NULL, 'Neurokinin NK3 receptor', 'NK3_rcpt', 4, NULL),
(147, NULL, 'IPR007666', NULL, 'ADP-specific phosphofructokinase/glucokinase', 'ADP_PFK/GK', 4, NULL),
(148, NULL, 'IPR003024', NULL, 'Sodium bicarbonate cotransporter', 'Na/HCO3_transpt', 4, NULL),
(149, NULL, 'IPR001292', NULL, 'Estrogen receptor', 'Estr_rcpt', 4, NULL),
(150, NULL, 'IPR006518', NULL, 'Trypanosome RHS', 'Trypano_RHS', 4, NULL),
(151, NULL, 'IPR007298', NULL, 'Copper resistance lipoprotein NlpE', 'Cu-R_lipoprotein_NlpE', 4, NULL),
(152, NULL, 'IPR000995', NULL, 'Muscarinic acetylcholine receptor family', 'Musac_Ach_rcpt', 4, NULL),
(153, NULL, 'IPR002245', NULL, 'Chloride channel ClC-3', 'Cl_channel-3', 4, NULL),
(154, NULL, 'IPR007140', NULL, 'Protein of unknown function DUF350', 'DUF350', 7, NULL),
(155, NULL, 'IPR002226', NULL, 'Catalase haem-binding site', 'Catalase_haem_BS', 1, NULL),
(156, NULL, 'IPR007149', NULL, 'Leo1-like protein', 'Leo1', 4, NULL),
(157, NULL, 'IPR002275', NULL, 'Chemerin-like receptor 2', 'CML2', 4, NULL),
(158, NULL, 'IPR006529', NULL, 'U2 snRNP auxilliary factor, large subunit, splicing factor', 'U2AF_lg', 4, NULL),
(159, NULL, 'IPR004885', NULL, 'Protein of unknown function FRD2', 'FRD2', 4, NULL),
(160, NULL, 'IPR005957', NULL, 'Tyrosine aminotransferase', 'Tyrosine_aminoTrfase', 4, NULL),
(161, NULL, 'IPR006524', NULL, 'Putative autolysin regulatory protein ArpU-like', 'ArpU-like', 4, NULL),
(162, NULL, 'IPR007144', NULL, 'Small-subunit processome, Utp11', 'SSU_processome_Utp11', 4, NULL),
(163, NULL, 'IPR003019', NULL, 'Metallothionein', 'Metalthion', 4, NULL),
(164, NULL, 'IPR003585', NULL, 'Neurexin/syndecan/glycophorin C', 'Neurexin-like', 3, NULL),
(165, NULL, 'IPR000871', NULL, 'Beta-lactamase, class-A', 'Beta-lactam_class-A', 4, NULL),
(166, NULL, 'IPR005443', NULL, 'Voltage-dependent calcium channel, L-type, beta-1 subunit', 'VDCC_L_b1su', 4, NULL),
(167, NULL, 'IPR002232', NULL, '5-Hydroxytryptamine 6 receptor', '5HT6_rcpt', 4, NULL),
(168, NULL, 'IPR007080', NULL, 'RNA polymerase Rpb1, domain 1', 'RNA_pol_Rpb1_1', 3, NULL),
(169, NULL, 'IPR007649', NULL, 'Domain of unknown function DUF591', 'DUF591', 3, NULL),
(170, NULL, 'IPR005426', NULL, 'Potassium channel, voltage-dependent, beta subunit, KCNE3', 'K_chnl_volt-dep_bsu_KCNE3', 4, NULL),
(171, NULL, 'IPR000914', NULL, 'Solute-binding protein family 5 domain', 'SBP_5_dom', 3, NULL),
(172, NULL, 'IPR000832', NULL, 'GPCR, family 2, secretin-like', 'GPCR_2_secretin-like', 4, NULL),
(173, NULL, 'IPR005909', NULL, 'Archaeosine synthase subunit beta', 'RaSEA', 4, NULL),
(174, NULL, 'IPR000850', NULL, 'Adenylate kinase/UMP-CMP kinase', 'Adenylat/UMP-CMP_kin', 4, NULL),
(175, NULL, 'IPR000952', NULL, 'AB hydrolase 4, conserved site', 'AB_hydrolase_4_CS', 2, NULL),
(176, NULL, 'IPR005917', NULL, 'Phosphomevalonate kinase, bacteria', 'Pmev_kinase_bact', 4, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(177, NULL, 'IPR000878', NULL, 'Tetrapyrrole methylase', '4pyrrol_Mease', 3, NULL),
(178, NULL, 'IPR000837', NULL, 'AP-1 transcription factor', 'AP-1', 4, NULL),
(179, NULL, 'IPR001304', NULL, 'C-type lectin-like', 'C-type_lectin-like', 3, NULL),
(180, NULL, 'IPR002292', NULL, 'Ornithine/putrescine carbamoyltransferase', 'Orn/put_carbamltrans', 4, NULL),
(181, NULL, 'IPR006550', NULL, 'Bifunctional polynucleotide phosphatase/kinase PNKP', 'PNKP', 4, NULL),
(182, NULL, 'IPR006565', NULL, 'Bromodomain associated domain', 'BTP', 3, NULL),
(183, NULL, 'IPR006548', NULL, 'Splicing factor ELAV/Hu', 'ELAD_HU_SF', 4, NULL),
(184, NULL, 'IPR003016', NULL, '2-oxo acid dehydrogenase, lipoyl-binding site', '2-oxoA_DH_lipoyl-BS', 1, NULL),
(185, NULL, 'IPR000341', NULL, 'Phosphatidylinositol 3-kinase Ras-binding (PI3K RBD) domain', 'PI3K_Ras-bd_dom', 3, NULL),
(186, NULL, 'IPR000362', NULL, 'Fumarate lyase family', 'Fumarate_lyase_fam', 4, NULL),
(187, NULL, 'IPR001266', NULL, 'Ribosomal protein S19e', 'Ribosomal_S19e', 4, NULL),
(188, NULL, 'IPR001305', NULL, 'Heat shock protein DnaJ, cysteine-rich domain', 'HSP_DnaJ_Cys-rich_dom', 3, NULL),
(189, NULL, 'IPR007648', NULL, 'Mitochondrial ATPase inhibitor', 'ATPase_inhibitor_mt', 4, NULL),
(190, NULL, 'IPR006520', NULL, 'Distal tail protein, N-terminal', 'Dit_N', 3, NULL),
(191, NULL, 'IPR002277', NULL, 'Lysophosphatidic acid receptor EDG-2', 'LPA_rcpt_EDG2', 4, NULL),
(192, NULL, 'IPR005952', NULL, 'Phosphoglycerate mutase 1', 'Phosphogly_mut1', 4, NULL),
(193, NULL, 'IPR001273', NULL, 'Aromatic amino acid hydroxylase', 'ArAA_hydroxylase', 4, NULL),
(194, NULL, 'IPR006563', NULL, 'POX domain', 'POX_dom', 3, NULL),
(195, NULL, 'IPR006555', NULL, 'ATP-dependent helicase, C-terminal', 'ATP-dep_Helicase_C', 3, NULL),
(196, NULL, 'IPR006535', NULL, 'HnRNP R/Q splicing factor', 'HnRNP_R/Q_splicing_fac', 4, NULL),
(197, NULL, 'IPR005427', NULL, 'Salmonella/Shigella invasin protein C', 'BacInvasinC', 4, NULL),
(198, NULL, 'IPR001267', NULL, 'Thymidine kinase', 'Thymidine_kinase', 4, NULL),
(199, NULL, 'IPR000960', NULL, 'Flavin monooxygenase FMO', 'Flavin_mOase', 4, NULL),
(200, NULL, 'IPR006578', NULL, 'MADF domain', 'MADF-dom', 3, NULL),
(201, NULL, 'IPR003591', NULL, 'Leucine-rich repeat, typical subtype', 'Leu-rich_rpt_typical-subtyp', 7, NULL),
(202, NULL, 'IPR007158', NULL, 'tRNA (pseudouridine(54)-N(1))-methyltransferase,  TrmY', 'TrmY', 4, NULL),
(203, NULL, 'IPR007165', NULL, 'Mycobacterial 4 TMS phage holin, superfamily IV', 'Phage_holin_4_2', 4, NULL),
(204, NULL, 'IPR005424', NULL, 'Potassium voltage-gated channel subfamily E member 1', 'KCNE1', 4, NULL),
(205, NULL, 'IPR005923', NULL, 'Formiminoglutamase', 'HutG', 4, NULL),
(206, NULL, 'IPR002200', NULL, 'Elicitin', 'Elicitin', 4, NULL),
(207, NULL, 'IPR005948', NULL, 'Thiamine/thiamin pyrophosphate-binding periplasmic protein, ABC transporter', 'ThiB-like', 4, NULL),
(208, NULL, 'IPR005958', NULL, 'Tyrosine/nicotianamine aminotransferase', 'TyrNic_aminoTrfase', 4, NULL),
(209, NULL, 'IPR007669', NULL, 'Carbohydrate sulfotransferase Chst-1', 'Chst-1', 4, NULL),
(210, NULL, 'IPR002171', NULL, 'Ribosomal protein L2', 'Ribosomal_L2', 4, NULL),
(211, NULL, 'IPR000834', NULL, 'Peptidase M14, carboxypeptidase A', 'Peptidase_M14', 3, NULL),
(212, NULL, 'IPR002298', NULL, 'DNA polymerase A', 'DNA_polymerase_A', 4, NULL),
(213, NULL, 'IPR003562', NULL, 'Mutator MutX protein', 'Mutator_MutX_prot', 4, NULL),
(214, NULL, 'IPR005960', NULL, 'Phenylalanine-4-hydroxylase, monomeric form', 'Phe-4-hydroxylase_mono', 4, NULL),
(215, NULL, 'IPR007663', NULL, 'Baculoviridae p74', 'Baculo_p74', 4, NULL),
(216, NULL, 'IPR006577', NULL, 'UAS', 'UAS', 3, NULL),
(217, NULL, 'IPR002155', NULL, 'Thiolase', 'Thiolase', 4, NULL),
(218, NULL, 'IPR005932', NULL, '1-pyrroline-5-carboxylate dehydrogenase', 'RocA', 4, NULL),
(219, NULL, 'IPR003602', NULL, 'DNA topoisomerase, type IA, DNA-binding domain', 'Topo_IA_DNA-bd_dom', 3, NULL),
(220, NULL, 'IPR000924', NULL, 'Glutamyl/glutaminyl-tRNA synthetase', 'Glu/Gln-tRNA-synth', 4, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(221, NULL, 'IPR000847', NULL, 'Transcription regulator HTH, LysR', 'Tscrpt_reg_HTH_LysR', 3, NULL),
(222, NULL, 'IPR000868', NULL, 'Isochorismatase-like', 'Isochorismatase-like', 3, NULL),
(223, NULL, 'IPR005429', NULL, 'Lysosome membrane protein II', 'LimpII', 4, NULL),
(224, NULL, 'IPR005927', NULL, 'Tagatose 1,6-diphosphate aldolase', 'Tag_1.6-dipho_adolase', 4, NULL),
(225, NULL, 'IPR000966', NULL, 'Metallothionein, family 5, Diptera', 'Metalthion_5', 4, NULL),
(226, NULL, 'IPR001269', NULL, 'tRNA-dihydrouridine synthase', 'DUS_fam', 4, NULL),
(227, NULL, 'IPR003027', NULL, 'Exonuclease Rec1, Ustilaginaceae', 'Rec1_exonuc_Ustilaginaceae', 4, NULL),
(228, NULL, 'IPR006579', NULL, 'Pre-C2HC  domain', 'Pre_C2HC_dom', 3, NULL),
(229, NULL, 'IPR003006', NULL, 'Immunoglobulin/major histocompatibility complex, conserved site', 'Ig/MHC_CS', 2, NULL),
(230, NULL, 'IPR005914', NULL, 'Acetoacetyl-CoA synthase', 'Acac_CoA_synth', 4, NULL),
(231, NULL, 'IPR005946', NULL, 'Ribose-phosphate pyrophosphokinase', 'Rib-P_diPkinase', 4, NULL),
(232, NULL, 'IPR005907', NULL, 'Glucose-1-phosphate thymidylyltransferase, short form', 'G1P_thy_trans_s', 4, NULL),
(233, NULL, 'IPR006574', NULL, 'SPRY-associated', 'PRY', 3, NULL),
(234, NULL, 'IPR003587', NULL, 'Hint domain N-terminal', 'Hint_dom_N', 3, NULL),
(235, NULL, 'IPR002202', NULL, 'Hydroxymethylglutaryl-CoA reductase, class I/II', 'HMG_CoA_Rdtase', 4, NULL),
(236, NULL, 'IPR005437', NULL, 'Gamma-aminobutyric acid receptor subunit gamma-1/4', 'GABRG-1/4', 4, NULL),
(237, NULL, 'IPR005963', NULL, 'Tryptophan 5-monooxygenase', 'Trp_5_mOase', 4, NULL),
(238, NULL, 'IPR003604', NULL, 'Matrin/U1-C-like, C2H2-type zinc finger', 'Matrin/U1-like-C_Znf_C2H2', 3, NULL),
(239, NULL, 'IPR002210', NULL, 'Major capsid L1 (late) protein, Papillomavirus', 'Capsid_L1_Papillomavir', 4, NULL),
(240, NULL, 'IPR007164', NULL, 'GTP-dependent dephospho-CoA kinase', 'GTP-dep_dephospho-CoA_kin', 4, NULL),
(241, NULL, 'IPR000965', NULL, 'GPR domain', 'GPR_dom', 3, NULL),
(242, NULL, 'IPR006553', NULL, 'Leucine-rich repeat, cysteine-containing subtype', 'Leu-rich_rpt_Cys-con_subtyp', 7, NULL),
(243, NULL, 'IPR001322', NULL, 'Lamin tail domain', 'Lamin_tail_dom', 3, NULL),
(244, NULL, 'IPR001287', NULL, 'Nitrite reductase, copper-type', 'NO2-reductase_Cu', 4, NULL),
(245, NULL, 'IPR005942', NULL, 'Daunorubicin resistance ABC transporter membrane protein', 'Daunbcin-R_ABC-transpt', 4, NULL),
(246, NULL, 'IPR007163', NULL, 'Protein of unknown function DUF368', 'DUF368', 4, NULL),
(247, NULL, 'IPR000922', NULL, 'D-galactoside/L-rhamnose binding SUEL lectin domain', 'Lectin_gal-bd_dom', 3, NULL),
(248, NULL, 'IPR034586', NULL, 'GTPase activating protein complex, subunit Bfa1/Byr4', 'Bfa1/Byr4', 4, NULL),
(249, NULL, 'IPR003568', NULL, 'Cytochrome c-type biogenesis protein CcmF', 'Cyt_c_biogenesis_CcmF', 4, NULL),
(250, NULL, 'IPR002192', NULL, 'Pyruvate phosphate dikinase, AMP/ATP-binding', 'PPDK_AMP/ATP-bd', 3, NULL),
(251, NULL, 'IPR003033', NULL, 'SCP2 sterol-binding domain', 'SCP2_sterol-bd_dom', 3, NULL),
(252, NULL, 'IPR007145', NULL, 'Microtubule-associated protein, MAP65/Ase1/PRC1', 'MAP65_Ase1_PRC1', 4, NULL),
(253, NULL, 'IPR003595', NULL, 'Protein-tyrosine phosphatase, catalytic', 'Tyr_Pase_cat', 3, NULL),
(254, NULL, 'IPR006525', NULL, 'Cystatin-related, plant', 'Cystatin-related_pln', 3, NULL),
(255, NULL, 'IPR003559', NULL, 'Cytolethal distending toxin C', 'CDtoxinC', 4, NULL),
(256, NULL, 'IPR005446', NULL, 'Voltage-dependent calcium channel, L-type, alpha-1 subunit', 'VDCC_L_a1su', 4, NULL),
(257, NULL, 'IPR006564', NULL, 'Zinc finger, PMZ-type', 'Znf_PMZ', 3, NULL),
(258, NULL, 'IPR007138', NULL, 'Antibiotic biosynthesis monooxygenase domain', 'ABM_dom', 3, NULL),
(259, NULL, 'IPR002173', NULL, 'Carbohydrate/purine kinase, PfkB, conserved site', 'Carboh/pur_kinase_PfkB_CS', 2, NULL),
(260, NULL, 'IPR000897', NULL, 'Signal recognition particle, SRP54 subunit, GTPase domain', 'SRP54_GTPase_dom', 3, NULL),
(261, NULL, 'IPR005950', NULL, 'Molybdate ABC transporter, substrate-binding protein', 'ModA', 4, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(262, NULL, 'IPR003010', NULL, 'Carbon-nitrogen hydrolase', 'C-N_Hydrolase', 3, NULL),
(263, NULL, 'IPR001303', NULL, 'Class II aldolase/adducin N-terminal', 'Aldolase_II/adducin_N', 3, NULL),
(264, NULL, 'IPR006569', NULL, 'CID domain', 'CID_dom', 3, NULL),
(265, NULL, 'IPR003025', NULL, 'Transcription factor Otx', 'Otx_TF', 4, NULL),
(266, NULL, 'IPR000344', NULL, '7TM GPCR, serpentine receptor class a (Sra)', '7TM_GPCR_serpentine_rcpt_Sra', 4, NULL),
(267, NULL, 'IPR007153', NULL, 'Adenosine specific kinase', 'Adenosine_kinase', 4, NULL),
(268, NULL, 'IPR006575', NULL, 'RWD domain', 'RWD-domain', 3, NULL),
(269, NULL, 'IPR006534', NULL, 'P-type ATPase, subfamily IIIA', 'P-type_ATPase_IIIA', 4, NULL),
(270, NULL, 'IPR002159', NULL, 'CD36 family', 'CD36_fam', 4, NULL),
(271, NULL, 'IPR007083', NULL, 'RNA polymerase Rpb1, domain 4', 'RNA_pol_Rpb1_4', 3, NULL),
(272, NULL, 'IPR007668', NULL, 'RFX1 transcription activation region', 'RFX1_trans_act', 3, NULL),
(273, NULL, 'IPR003574', NULL, 'Interleukin-6', 'IL-6', 4, NULL),
(274, NULL, 'IPR006537', NULL, 'Cobaltochelatase subunit CobS', 'PD_CobS', 4, NULL),
(275, NULL, 'IPR034037', NULL, 'Tumor necrosis factor receptor 21, death domain', 'TNFRSF21_death', 3, NULL),
(276, NULL, 'IPR006526', NULL, 'Exported protein, PHISTa/b/c, conserved domain, Plasmodium', 'Export_prot_PHISTa/b/c', 3, NULL),
(277, NULL, 'IPR003558', NULL, 'Cytolethal distending toxin A/C', 'CDtoxinA/C', 4, NULL),
(278, NULL, 'IPR002236', NULL, 'CC chemokine receptor 1', 'Chemokine_CCR1', 4, NULL),
(279, NULL, 'IPR000354', NULL, 'Involucrin repeat', 'Involucrin_rpt', 7, NULL),
(280, NULL, 'IPR000376', NULL, 'Prostaglandin D receptor', 'Pglndn_D_rcpt', 4, NULL),
(281, NULL, 'IPR000983', NULL, 'Bacterial general secretion pathway protein G-type pilin', 'Bac_GSPG_pilin', 4, NULL),
(282, NULL, 'IPR006581', NULL, 'VPS10', 'VPS10', 3, NULL),
(283, NULL, 'IPR005956', NULL, '4-hydroxyphenylpyruvate dioxygenase', '4OHPhenylPyrv_dOase', 4, NULL),
(284, NULL, 'IPR001301', NULL, 'Geminivirus AL1 replication-associated protein, CLV type', 'Gemini_AL1_CLV', 4, NULL),
(285, NULL, 'IPR002156', NULL, 'Ribonuclease H domain', 'RNaseH_domain', 3, NULL),
(286, NULL, 'IPR005962', NULL, 'Tyrosine 3-monooxygenase', 'Tyr_3_mOase', 4, NULL),
(287, NULL, 'IPR003022', NULL, 'Transcription factor Otx2', 'Otx2_TF', 4, NULL),
(288, NULL, 'IPR006583', NULL, 'PAN-3 domain', 'PAN-3_domain', 3, NULL),
(289, NULL, 'IPR002227', NULL, 'Tyrosinase copper-binding domain', 'Tyrosinase_Cu-bd', 3, NULL),
(290, NULL, 'IPR007133', NULL, 'RNA polymerase II associated factor Paf1', 'RNA_pol_II-assoc_Paf1', 4, NULL),
(291, NULL, 'IPR006588', NULL, 'Peptide N glycanase, PAW domain', 'Peptide_N_glycanase_PAW_dom', 3, NULL),
(292, NULL, 'IPR007667', NULL, 'Hypoxia induced protein, domain', 'Hypoxia_induced_domain', 3, NULL),
(293, NULL, 'IPR000368', NULL, 'Sucrose synthase', 'Sucrose_synth', 3, NULL),
(294, NULL, 'IPR007646', NULL, 'RNA polymerase Rpb2, domain 4', 'RNA_pol_Rpb2_4', 3, NULL),
(295, NULL, 'IPR004897', NULL, 'P/V phosphoprotein, paramyxoviral', 'P/V_Pprotein_paramyxoviral', 4, NULL),
(296, NULL, 'IPR007111', NULL, 'NACHT nucleoside triphosphatase', 'NACHT_NTPase', 3, NULL),
(297, NULL, 'IPR001325', NULL, 'Interleukin-4/interleukin-13', 'IL-4/IL-13', 4, NULL),
(298, NULL, 'IPR034332', NULL, 'Uracil phosphoribosyltransferase, bacterial-type', 'Upp_B', 4, NULL),
(299, NULL, 'IPR000409', NULL, 'BEACH domain', 'BEACH_dom', 3, NULL),
(300, NULL, 'IPR034057', NULL, 'Tumor necrosis factor receptor 9, N-terminal, teleost', 'TNFRSF9_N_teleost', 3, NULL),
(301, NULL, 'IPR005966', NULL, 'D-cysteine desulfhydrase', 'D-Cys_desShydrase', 4, NULL),
(302, NULL, 'IPR003569', NULL, 'Probable cytochrome c biosynthesis protein, plants', 'Cyt_c_biogenesis_plant', 4, NULL),
(303, NULL, 'IPR005959', NULL, 'Fumarylacetoacetase', 'Fumarylacetoacetase', 4, NULL),
(304, NULL, 'IPR000944', NULL, 'Transcription regulator Rrf2', 'Tscrpt_reg_Rrf2', 4, NULL),
(305, NULL, 'IPR002160', NULL, 'Proteinase inhibitor I3, Kunitz legume', 'Prot_inh_Kunz-lg', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(306, NULL, 'IPR006519', NULL, 'Ribosomal protein L11, bacterial-type', 'Ribosomal_L11_bac-typ', 4, NULL),
(307, NULL, 'IPR000340', NULL, 'Dual specificity phosphatase, catalytic domain', 'Dual-sp_phosphatase_cat-dom', 3, NULL),
(308, NULL, 'IPR001307', NULL, 'Thiosulphate sulfurtransferase, conserved site', 'Thiosulphate_STrfase_CS', 2, NULL),
(309, NULL, 'IPR007137', NULL, 'Resuscitation-promoting factor, domain of unknown function DUF348', 'DUF348', 3, NULL),
(310, NULL, 'IPR004890', NULL, 'Mycoplasma lipoprotein, C-terminal', 'Lipoprotein_10_C', 3, NULL),
(311, NULL, 'IPR000819', NULL, 'Peptidase M17, leucyl aminopeptidase, C-terminal', 'Peptidase_M17_C', 3, NULL),
(312, NULL, 'IPR005928', NULL, '6-phospho-beta-galactosidase', '6P-beta-galactosidase', 4, NULL),
(313, NULL, 'IPR007653', NULL, 'Signal peptidase complex subunit 3', 'SPC3', 4, NULL),
(314, NULL, 'IPR034535', NULL, 'RBM15B, RNA recognition motif 2', 'RBM15B_RRM2', 3, NULL),
(315, NULL, 'IPR007122', NULL, 'Villin/Gelsolin', 'Villin/Gelsolin', 4, NULL),
(316, NULL, 'IPR034590', NULL, 'POLYCHOME/GIGAS CELL1', 'POLYCHOME/GIG1', 4, NULL),
(317, NULL, 'IPR001312', NULL, 'Hexokinase', 'Hexokinase', 4, NULL),
(318, NULL, 'IPR007156', NULL, 'MamQ/LemA', 'MamQ_LemA', 4, NULL),
(319, NULL, 'IPR005930', NULL, 'Pyruvate carboxylase', 'Pyruv_COase', 4, NULL),
(320, NULL, 'IPR001268', NULL, 'NADH:ubiquinone oxidoreductase, 30kDa subunit', 'NADH_UbQ_OxRdtase_30kDa_su', 3, NULL),
(321, NULL, 'IPR007147', NULL, 'Transcription factor Vhr', 'TF_Vhr', 4, NULL),
(322, NULL, 'IPR002154', NULL, 'Neuregulin, C-terminal', 'Neuregulin_C', 3, NULL),
(323, NULL, 'IPR001315', NULL, 'CARD domain', 'CARD', 3, NULL),
(324, NULL, 'IPR000841', NULL, 'Peptidase M23A, B-lytic metalloendopeptidase', 'Pept_M23A_Blytic', 4, NULL),
(325, NULL, 'IPR000977', NULL, 'DNA ligase, ATP-dependent', 'DNA_ligase_ATP-dep', 4, NULL),
(326, NULL, 'IPR034536', NULL, 'RBM15B, RNA recognition motif 3', 'RBM15B_RRM3', 3, NULL),
(327, NULL, 'IPR003582', NULL, 'ShKT domain', 'ShKT_dom', 3, NULL),
(328, NULL, 'IPR007112', NULL, 'Expansin/pollen allergen, DPBB domain', 'Expansin/allergen_DPBB_dom', 3, NULL),
(329, NULL, 'IPR006571', NULL, 'TLDc domain', 'TLDc_dom', 3, NULL),
(330, NULL, 'IPR007160', NULL, 'Domain of unknown function DUF362', 'DUF362', 3, NULL),
(331, NULL, 'IPR002281', NULL, 'Protease-activated receptor 2', 'Pro_rcpt_2', 4, NULL),
(332, NULL, 'IPR000912', NULL, 'Herpesvirus major capsid protein', 'Herpes_MCP', 4, NULL),
(333, NULL, 'IPR003028', NULL, 'Sodium:neurotransmitter symporter, glycine, type 1', 'Na/ntran_symport_glycine_GLY1', 4, NULL),
(334, NULL, 'IPR005938', NULL, 'AAA ATPase, CDC48 family', 'AAA_ATPase_CDC48', 4, NULL),
(335, NULL, 'IPR005935', NULL, 'Diphosphomevalonate/phosphomevalonate decarboxylase', 'Mev_decarb', 4, NULL),
(336, NULL, 'IPR002201', NULL, 'Glycosyl transferase, family 9', 'Glyco_trans_9', 4, NULL),
(337, NULL, 'IPR000911', NULL, 'Ribosomal protein L11/L12', 'Ribosomal_L11/L12', 4, NULL),
(338, NULL, 'IPR007109', NULL, 'Brix domain', 'Brix', 3, NULL),
(339, NULL, 'IPR002288', NULL, 'DNA gyrase B subunit, C-terminal', 'DNA_gyrase_B_C', 3, NULL),
(340, NULL, 'IPR002230', NULL, 'Cannabinoid receptor family', 'Cnbnoid_rcpt', 4, NULL),
(341, NULL, 'IPR007096', NULL, 'RNA-directed RNA polymerase, catalytic domain,  bacteriophage', 'RNA-dir_Rpol_cat_phage', 3, NULL),
(342, NULL, 'IPR006590', NULL, 'RNA polymerase Rpb4/RPC9, core', 'RNA_pol_Rpb4/RPC9_core', 3, NULL),
(343, NULL, 'IPR005961', NULL, 'Phenylalanine-4-hydroxylase, tetrameric form', 'Phe-4-hydroxylase_tetra', 4, NULL),
(344, NULL, 'IPR004886', NULL, 'Glucanosyltransferase', 'Glucanosyltransferase', 4, NULL),
(345, NULL, 'IPR001018', NULL, 'Beta-lactamase, class-B, conserved site', 'Beta-lactamase_class-B_CS', 2, NULL),
(346, NULL, 'IPR000825', NULL, 'SUF system FeS cluster assembly, SufBD', 'SUF_FeS_clus_asmbl_SufBD', 4, NULL),
(347, NULL, 'IPR006586', NULL, 'ADAM, cysteine-rich domain', 'ADAM_Cys-rich', 3, NULL),
(348, NULL, 'IPR007174', NULL, 'Las1', 'Las1', 4, NULL),
(349, NULL, 'IPR004893', NULL, 'Nitrogen fixation protein NifW', 'NifW', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(350, NULL, 'IPR001265', NULL, 'Formin homology family, Cappuccino subfamily', 'Formin_Cappuccino_subfam', 4, NULL),
(351, NULL, 'IPR002279', NULL, 'Melatonin receptor type 1C', 'Mel_rcpt_1C', 4, NULL),
(352, NULL, 'IPR002258', NULL, 'Chemerin-like receptor 1', 'CML1', 4, NULL),
(353, NULL, 'IPR000888', NULL, 'dTDP-4-dehydrorhamnose 3,5-epimerase-related', 'dTDP_sugar_isom', 4, NULL),
(354, NULL, 'IPR002261', NULL, 'Gap junction alpha-1 protein (Cx43)', 'Connexin43', 4, NULL),
(355, NULL, 'IPR006539', NULL, 'P-type ATPase, subfamily IV', 'P-type_ATPase_IV', 4, NULL),
(356, NULL, 'IPR005965', NULL, '1-aminocyclopropane-1-carboxylate deaminase', 'ACP_carboxylate_deaminase', 4, NULL),
(357, NULL, 'IPR006528', NULL, 'Phage head morphogenesis domain', 'Phage_head_morphogenesis_dom', 3, NULL),
(358, NULL, 'IPR002153', NULL, 'Transient receptor potential channel, canonical', 'TRPC_channel', 4, NULL),
(359, NULL, 'IPR005947', NULL, 'Thiamine ABC transporter, permease protein', 'ThiP_ABC_transpt', 4, NULL),
(360, NULL, 'IPR003570', NULL, 'Cytochrome c-type biogenesis protein NrfE', 'Cyt_c_biogenesis_NrfE', 4, NULL),
(361, NULL, 'IPR002297', NULL, 'DNA-directed DNA-polymerase, family A, mitochondria', 'DNA-dir_DNA_pol_A_mt', 4, NULL),
(362, NULL, 'IPR001003', NULL, 'MHC class II, alpha chain, N-terminal', 'MHC_II_a_N', 3, NULL),
(363, NULL, 'IPR006542', NULL, 'Protein of unknown function DUF1093', 'DUF1093', 4, NULL),
(364, NULL, 'IPR005425', NULL, 'Potassium channel, voltage-dependent, beta subunit, KCNE2', 'K_chnl_volt-dep_bsu_KCNE2', 4, NULL),
(365, NULL, 'IPR003026', NULL, 'Transcription factor Otx1', 'Otx1_TF', 4, NULL),
(366, NULL, 'IPR006521', NULL, 'Tail protein I', 'Tail_protein_I', 4, NULL),
(367, NULL, 'IPR034338', NULL, 'Glutathione S-transferases, subfamily 4, C-terminal', 'GST_4_C', 3, NULL),
(368, NULL, 'IPR005931', NULL, 'Delta-1-pyrroline-5-carboxylate dehydrogenase', 'P5CDH/ALDH4A1', 4, NULL),
(369, NULL, 'IPR000827', NULL, 'CC chemokine, conserved site', 'Chemokine_CC_CS', 2, NULL),
(370, NULL, 'IPR003032', NULL, 'Ryanodine receptor Ryr', 'Ryanodine_rcpt', 3, NULL),
(371, NULL, 'IPR005953', NULL, 'ATP synthase, F0 complex, subunit C, bacterial/chloroplast', 'ATP_synth_csu_bac/chlpt', 4, NULL),
(372, NULL, 'IPR002195', NULL, 'Dihydroorotase, conserved site', 'Dihydroorotase_CS', 2, NULL),
(373, NULL, 'IPR001288', NULL, 'Translation initiation factor 3', 'Translation_initiation_fac_3', 4, NULL),
(374, NULL, 'IPR005430', NULL, 'P pili tip fibrillum PapF protein', 'P_pili_tip_PapF', 4, NULL),
(375, NULL, 'IPR006560', NULL, 'AWS domain', 'AWS_dom', 3, NULL),
(376, NULL, 'IPR002165', NULL, 'Plexin repeat', 'Plexin_repeat', 7, NULL),
(377, NULL, 'IPR004888', NULL, 'Glycoside hydrolase family 63', 'Glycoside_hydrolase_63', 4, NULL),
(378, NULL, 'IPR003599', NULL, 'Immunoglobulin subtype', 'Ig_sub', 3, NULL),
(379, NULL, 'IPR005448', NULL, 'Voltage-dependent calcium channel, P/Q-type, alpha-1 A', 'CACNA1A', 4, NULL),
(380, NULL, 'IPR006532', NULL, 'Poly-U binding splicing factor, PUF60-like', 'PUF60-like', 4, NULL),
(381, NULL, 'IPR034325', NULL, 'S-100', 'S-100_dom', 3, NULL),
(382, NULL, 'IPR002247', NULL, 'Chloride channel ClC-5', 'Cl_channel-5', 4, NULL),
(383, NULL, 'IPR006558', NULL, 'LamG-like jellyroll fold', 'LamG-like', 3, NULL),
(384, NULL, 'IPR001329', NULL, 'Glycoside hydrolase family 56, bee venom hyaluronidase', 'Venom_Hyaluronidase', 4, NULL),
(385, NULL, 'IPR005945', NULL, 'Proline-specific peptidase', 'Pro_imino_pep', 4, NULL),
(386, NULL, 'IPR005949', NULL, 'Formate acetyltransferase', 'Form_AcTrfase', 4, NULL),
(387, NULL, 'IPR005444', NULL, 'Voltage-dependent calcium channel, L-type, beta-2 subunit', 'VDCC_L_b2su', 4, NULL),
(388, NULL, 'IPR007150', NULL, 'Checkpoint protein Hus1/Mec3', 'Hus1/Mec3', 4, NULL),
(389, NULL, 'IPR007132', NULL, 'Protein of unknown function DUF346', 'DUF346', 7, NULL),
(390, NULL, 'IPR005445', NULL, 'Voltage-dependent calcium channel, T-type, alpha-1 subunit', 'VDCC_T_a1', 4, NULL),
(391, NULL, 'IPR000962', NULL, 'Zinc finger, DksA/TraR C4-type', 'Znf_DskA_TraR', 3, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(392, NULL, 'IPR000355', NULL, 'Chemokine receptor family', 'Chemokine_rcpt', 4, NULL),
(393, NULL, 'IPR003603', NULL, 'U2A''/phosphoprotein 32 family A, C-terminal', 'U2A''_phosphoprotein32A_C', 3, NULL),
(394, NULL, 'IPR007079', NULL, 'Succinylarginine dihydrolase', 'SuccinylArg_d-Hdrlase_AstB', 4, NULL),
(395, NULL, 'IPR005919', NULL, 'Higher eukaryotic phosphomevalonate kinase', 'Pmev_kin_anim', 4, NULL),
(396, NULL, 'IPR007128', NULL, 'Nuclear MIS12/MIND complex subunit PMF1/Nnf1', 'PMF1/Nnf1', 4, NULL),
(397, NULL, 'IPR002260', NULL, 'Gap junction delta-2 protein (Cx36)', 'Connexin36', 4, NULL),
(398, NULL, 'IPR002240', NULL, 'CC chemokine receptor 5', 'Chemokine_CCR5', 4, NULL),
(399, NULL, 'IPR002249', NULL, 'Chloride channel ClC-7', 'Cl_channel-7', 4, NULL),
(400, NULL, 'IPR007127', NULL, 'RNA polymerase sigma factor 70, region 1.1', 'RNA_pol_sigma_70_r1_1', 3, NULL),
(401, NULL, 'IPR007110', NULL, 'Immunoglobulin-like domain', 'Ig-like_dom', 3, NULL),
(402, NULL, 'IPR005915', NULL, 'Tandem five-TM protein', 'Tandem_5TM', 4, NULL),
(403, NULL, 'IPR002231', NULL, '5-hydroxytryptamine receptor family', '5HT_rcpt', 4, NULL),
(404, NULL, 'IPR007173', NULL, 'D-arabinono-1,4-lactone oxidase, C-terminal domain', 'ALO_C', 3, NULL),
(405, NULL, 'IPR002214', NULL, 'Hantavirus nucleocapsid protein', 'Hanta_nucleocap', 4, NULL),
(406, NULL, 'IPR000978', NULL, 'Adenoviral fibre protein, knob', 'Adeno_fibre_knob', 3, NULL),
(407, NULL, 'IPR005912', NULL, 'tRNA pseudouridine synthase, Pus10', 'Pus10', 4, NULL),
(408, NULL, 'IPR000937', NULL, 'Icosahedral viral capsid protein, S domain', 'Capsid_prot_S-dom_vir', 3, NULL),
(409, NULL, 'IPR007148', NULL, 'Small-subunit processome, Utp12', 'SSU_processome_Utp12', 3, NULL),
(410, NULL, 'IPR007662', NULL, 'Reovirus sigma C capsid protein, C-terminal', 'SigmaC_C', 3, NULL),
(411, NULL, 'IPR000843', NULL, 'LacI-type HTH domain', 'HTH_LacI', 3, NULL),
(412, NULL, 'IPR005954', NULL, 'Histidinol-phosphatase', 'HisB_N', 3, NULL),
(413, NULL, 'IPR034551', NULL, 'Mucin-20', 'MUC20', 4, NULL),
(414, NULL, 'IPR000830', NULL, 'Peripherin/rom-1', 'Peripherin/rom-1', 4, NULL),
(415, NULL, 'IPR007172', NULL, 'Domain of unknown function DUF374', 'DUF374', 3, NULL),
(416, NULL, 'IPR007169', NULL, 'Extracellular matrix regulatory protein A-like', 'RemA-like', 4, NULL),
(417, NULL, 'IPR005941', NULL, 'Succinyl-diaminopimelate desuccinylase, proteobacteria', 'DapE_proteobac', 4, NULL),
(418, NULL, 'IPR007100', NULL, 'Birnavirus RNA-directed RNA polymerase, palm domain', 'Birnavirus_RdRp_palm', 3, NULL),
(419, NULL, 'IPR006572', NULL, 'Zinc finger, DBF-type', 'Znf_DBF', 3, NULL),
(420, NULL, 'IPR003586', NULL, 'Hint domain C-terminal', 'Hint_dom_C', 3, NULL),
(421, NULL, 'IPR007652', NULL, 'Alpha 1,4-glycosyltransferase domain', 'A1-4-GlycosylTfrase_dom', 3, NULL),
(422, NULL, 'IPR000864', NULL, 'Proteinase inhibitor I13, potato inhibitor I', 'Prot_inh_pot1', 4, NULL),
(423, NULL, 'IPR004896', NULL, 'PucC-related', 'PucC-rel', 4, NULL),
(424, NULL, 'IPR002206', NULL, 'Opsin, pineal type', 'Opsin_pineal', 4, NULL),
(425, NULL, 'IPR000986', NULL, 'Neuropeptide Y6 receptor', 'NeuroY6_rcpt', 4, NULL),
(426, NULL, 'IPR005943', NULL, 'Daunorubicin resistance protein C', 'Daunbcin-R_C', 4, NULL),
(427, NULL, 'IPR007656', NULL, 'GTD-binding domain', 'GTD-bd', 3, NULL),
(428, NULL, 'IPR002274', NULL, 'Thyrotropin receptor', 'TSH_rcpt', 4, NULL),
(429, NULL, 'IPR005926', NULL, 'Tagatose-6-phosphate kinase', 'LacC', 4, NULL),
(430, NULL, 'IPR000920', NULL, 'Myelin P0 protein-related', 'Myelin_P0-rel', 4, NULL),
(431, NULL, 'IPR003601', NULL, 'DNA topoisomerase, type IA, domain 2', 'Topo_IA_2', 3, NULL),
(432, NULL, 'IPR005937', NULL, '26S proteasome regulatory subunit P45-like', '26S_Psome_P45-like', 4, NULL),
(433, NULL, 'IPR007131', NULL, 'SLA1 homology domain 1, SHD1', 'SHD1', 3, NULL),
(434, NULL, 'IPR007152', NULL, 'Protein of unknown function DUF354', 'DUF354', 4, NULL),
(435, NULL, 'IPR003566', NULL, 'T-cell surface glycoprotein CD5', 'Tcell_CD5', 4, NULL),
(436, NULL, 'IPR005906', NULL, 'Lysine biosynthesis protein LysW', 'LysW', 4, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(437, NULL, 'IPR007660', NULL, 'Chordopoxvirinae D3 protein', 'Pox_D3', 4, NULL),
(438, NULL, 'IPR001333', NULL, 'Peptidase M32, carboxypeptidase Taq', 'Peptidase_M32_Taq', 4, NULL),
(439, NULL, 'IPR003598', NULL, 'Immunoglobulin subtype 2', 'Ig_sub2', 3, NULL),
(440, NULL, 'IPR007121', NULL, 'RNA polymerase, beta subunit, conserved site', 'RNA_pol_bsu_CS', 2, NULL),
(441, NULL, 'IPR006543', NULL, 'Histidinol-phosphate phosphatase', 'Histidinol-phos', 3, NULL),
(442, NULL, 'IPR007118', NULL, 'Expansin/Lol pI', 'Expan_Lol_pI', 4, NULL),
(443, NULL, 'IPR006547', NULL, 'Nitrate reductase, beta subunit', 'NO3_Rdtase_bsu', 4, NULL),
(444, NULL, 'IPR000855', NULL, 'Peptidase C5, adenain', 'Peptidase_C5', 4, NULL),
(445, NULL, 'IPR006545', NULL, 'EYA domain', 'EYA_dom', 3, NULL),
(446, NULL, 'IPR005442', NULL, 'Glutathione S-transferase, omega-class', 'GST_omega', 4, NULL),
(447, NULL, 'IPR007170', NULL, 'Stage V sporulation protein G', 'SpoVG', 4, NULL),
(448, NULL, 'IPR005936', NULL, 'Peptidase, FtsH', 'FtsH', 4, NULL),
(449, NULL, 'IPR005940', NULL, 'Anthranilate phosphoribosyl transferase', 'Anthranilate_Pribosyl_Tfrase', 4, NULL),
(450, NULL, 'IPR034561', NULL, 'Negative regulator of systemic acquired resistance SNI1', 'SNI1', 4, NULL),
(451, NULL, 'IPR005925', NULL, 'Agmatinase-related', 'Agmatinase-rel', 4, NULL),
(452, NULL, 'IPR005439', NULL, 'Gamma-aminobutyric-acid A receptor, gamma 2 subunit', 'GABBAg2_rcpt', 4, NULL),
(453, NULL, 'IPR001318', NULL, 'Inhibin, beta C subunit', 'Inhibin_betaC', 4, NULL),
(454, NULL, 'IPR001309', NULL, 'Peptidase C14,  p20 domain', 'Pept_C14_p20', 3, NULL),
(455, NULL, 'IPR003017', NULL, 'Amphiphysin, isoform 1', 'Amphiphysin_1', 4, NULL),
(456, NULL, 'IPR000883', NULL, 'Cytochrome c oxidase subunit I', 'Cyt_C_Oxase_1', 4, NULL),
(457, NULL, 'IPR007175', NULL, 'Ribonuclease P subunit, Rpr2/Snm1/Rpp21', 'Rpr2/Snm1/Rpp21', 4, NULL),
(458, NULL, 'IPR000369', NULL, 'Potassium channel, voltage-dependent, beta subunit, KCNE', 'K_chnl_KCNE', 4, NULL),
(459, NULL, 'IPR003029', NULL, 'S1 domain', 'S1_domain', 3, NULL),
(460, NULL, 'IPR006544', NULL, 'P-type ATPase, subfamily  V', 'P-type_TPase_V', 4, NULL),
(461, NULL, 'IPR003572', NULL, 'Snake cytotoxin, cobra-type', 'Cytotoxin_Cobra', 4, NULL),
(462, NULL, 'IPR000366', NULL, 'GPCR fungal pheromone mating factor, STE2', 'GPCR_STE2', 4, NULL),
(463, NULL, 'IPR001372', NULL, 'Dynein light chain, type 1/2', 'Dynein_light_chain_typ-1/2', 4, NULL),
(464, NULL, 'IPR005423', NULL, 'Voltage-dependent calcium channel, gamma-4 subunit', 'VDCC_g4su', 4, NULL),
(465, NULL, 'IPR002157', NULL, 'Cobalamin (vitamin B12)-binding protein', 'Cbl-bd_prot', 4, NULL),
(466, NULL, 'IPR005438', NULL, 'Gamma-aminobutyric-acid A receptor, gamma 1 subunit', 'GABBAg1_rcpt', 4, NULL),
(467, NULL, 'IPR002194', NULL, 'Chaperonin TCP-1, conserved site', 'Chaperonin_TCP-1_CS', 2, NULL),
(468, NULL, 'IPR006530', NULL, 'YD repeat', 'YD', 7, NULL),
(469, NULL, 'IPR005951', NULL, 'Retinal-specific ATP-binding cassette transporter', 'ABCA4/ABCR', 4, NULL),
(470, NULL, 'IPR006566', NULL, 'FBD domain', 'FBD', 3, NULL),
(471, NULL, 'IPR007084', NULL, 'BRICHOS domain', 'BRICHOS_dom', 3, NULL),
(472, NULL, 'IPR006561', NULL, 'DZF domain', 'DZF_dom', 3, NULL),
(473, NULL, 'IPR005911', NULL, 'Protein YhcC-like', 'YhcC-like', 4, NULL),
(474, NULL, 'IPR007654', NULL, 'NAD-dependent histone deacetylase Sir2, N-terminal', 'NAD-dep_histone_deAcase_SIR2_N', 3, NULL),
(475, NULL, 'IPR006584', NULL, 'Cellulose binding, type IV', 'Cellulose-bd_IV', 3, NULL),
(476, NULL, 'IPR000942', NULL, 'Geminivirus AL2 coat protein, MSV type', 'Gemini_AL2', 4, NULL),
(477, NULL, 'IPR007647', NULL, 'RNA polymerase Rpb2, domain 5', 'RNA_pol_Rpb2_5', 3, NULL),
(478, NULL, 'IPR007658', NULL, 'Protein of unknown function DUF594', 'DUF594', 4, NULL),
(479, NULL, 'IPR003012', NULL, 'Tetracycline transcriptional regulator, TetR', 'Tet_transcr_reg_TetR', 4, NULL),
(480, NULL, 'IPR002233', NULL, 'Adrenoceptor family', 'ADR_fam', 4, NULL),
(481, NULL, 'IPR002223', NULL, 'Pancreatic trypsin inhibitor Kunitz domain', 'Kunitz_BPTI', 3, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(482, NULL, 'IPR002228', NULL, 'Muscarinic acetylcholine receptor M1', 'Musac_Ach_M1_rcpt', 4, NULL),
(483, NULL, 'IPR006541', NULL, 'Bacteriocin-associated integral membrane protein', 'Bacteriocin_ass', 4, NULL),
(484, NULL, 'IPR002262', NULL, 'Gap junction alpha-3 protein (Cx46)', 'Connexin46', 4, NULL),
(485, NULL, 'IPR005955', NULL, 'Glutathione S-transferases, class Zeta', 'GST_Zeta', 4, NULL),
(486, NULL, 'IPR006549', NULL, 'HAD-superfamily hydrolase,subfamily IIIA', 'HAD-SF_hydro_IIIA', 3, NULL),
(487, NULL, 'IPR005905', NULL, 'D-alanine--D-alanine ligase', 'D_ala_D_ala', 4, NULL),
(488, NULL, 'IPR002177', NULL, 'DNA-binding protein Dps', 'DPS_DNA-bd', 4, NULL),
(489, NULL, 'IPR003564', NULL, 'Dihydroneopterin triphosphate diphosphatase', 'DHNTPase', 4, NULL),
(490, NULL, 'IPR006533', NULL, 'Type VI secretion system, RhsGE-associated Vgr protein', 'T6SS_Vgr_RhsGE', 4, NULL),
(491, NULL, 'IPR007139', NULL, 'Protein of unknown function DUF349', 'DUF349', 7, NULL),
(492, NULL, 'IPR007171', NULL, 'Protein of unknown function DUF371', 'DUF371', 4, NULL),
(493, NULL, 'IPR002211', NULL, 'Lymphocyte-specific protein', 'Lymphspecific', 4, NULL),
(494, NULL, 'IPR007168', NULL, 'Phage shock protein, PspC, N-terminal', 'Phageshock_PspC_N', 3, NULL),
(495, NULL, 'IPR006580', NULL, 'Zinc finger, TTF-type', 'Znf_TTF', 3, NULL),
(496, NULL, 'IPR003605', NULL, 'GS domain', 'GS_dom', 3, NULL),
(497, NULL, 'IPR002169', NULL, 'Peptidase M9A/M9B, collagenase, bacterial', 'Peptidase_M9A/M9B', 4, NULL),
(498, NULL, 'IPR007651', NULL, 'Lipin, N-terminal', 'Lipin_N', 3, NULL),
(499, NULL, 'IPR001332', NULL, 'Arterivirus GP5 envelope glycoprotein', 'Arteri_GP5', 4, NULL),
(500, NULL, 'IPR000957', NULL, 'Sulphate/thiosulphate-binding, conserved site', 'Sulphate/thiosulphate-bd_CS', 2, NULL),
(501, NULL, 'IPR023650', NULL, 'Beta-lactamase, class-A active site', 'Beta-lactam_class-A_AS', 0, NULL),
(502, NULL, 'IPR005494', NULL, 'Glutathionylspermidine synthase, pre-ATP-grasp-like domain', 'GSPS_pre-ATP-grasp-like_dom', 3, NULL),
(503, NULL, 'IPR003619', NULL, 'MAD homology 1, Dwarfin-type', 'MAD_homology1_Dwarfin-type', 3, NULL),
(504, NULL, 'IPR002513', NULL, 'Tn3 transposase DDE domain', 'Tn3_Tnp_DDE_dom', 3, NULL),
(505, NULL, 'IPR007673', NULL, 'Condensin subunit 1', 'Condensin_cplx_su1', 4, NULL),
(506, NULL, 'IPR003616', NULL, 'Post-SET domain', 'Post-SET_dom', 3, NULL),
(507, NULL, 'IPR034392', NULL, 'TatSF1-like, RNA recognition motif 1', 'TatSF1-like_RRM1', 3, NULL),
(508, NULL, 'IPR005451', NULL, 'Voltage-dependent calcium channel, L-type, alpha-1C subunit', 'VDCC_L_a1csu', 4, NULL),
(509, NULL, 'IPR009581', NULL, 'FAM20, C-terminal', 'FAM20_C', 3, NULL),
(510, NULL, 'IPR005502', NULL, 'ADP-ribosylation/Crystallin J1', 'Ribosyl_crysJ1', 4, NULL),
(511, NULL, 'IPR004009', NULL, 'Myosin, N-terminal, SH3-like', 'Myosin_N', 3, NULL),
(512, NULL, 'IPR008221', NULL, 'Urease', 'Urease', 4, NULL),
(513, NULL, 'IPR003996', NULL, 'RTX toxin-activating protein C, bacteria', 'RTX_toxin-activating_protC_bac', 4, NULL),
(514, NULL, 'IPR009578', NULL, 'Cell surface antigen I/II A repeat', 'Surface_Ag_I_II_A_rpt', 7, NULL),
(515, NULL, 'IPR004610', NULL, 'Bacterial RecJ exonuclease', 'RecJ', 4, NULL),
(516, NULL, 'IPR004970', NULL, 'Peptidase C57, Vaccinia virus protein I7', 'Peptidase_C57', 4, NULL),
(517, NULL, 'IPR004593', NULL, 'Nuclease SbcCD subunit D', 'SbcD', 4, NULL),
(518, NULL, 'IPR005478', NULL, 'Transketolase, bacterial-like', 'Transketolase_bac-like', 4, NULL),
(519, NULL, 'IPR003049', NULL, 'P2X6 purinoceptor', 'P2X6_purnocptor', 4, NULL),
(520, NULL, 'IPR005486', NULL, 'Glucokinase regulatory protein, conserved site', 'Glucokinase_regulatory_CS', 2, NULL),
(521, NULL, 'IPR003052', NULL, 'GPCR, family 2, corticotropin releasing factor receptor, type 1', 'GPCR_2_CRF1_rcpt', 4, NULL),
(522, NULL, 'IPR005498', NULL, 'Type IV secretion system, VirB10 / TraB / TrbI', 'T4SS_VirB10/TraB/TrbI', 4, NULL),
(523, NULL, 'IPR003624', NULL, 'Leukemia inhibitory factor', 'Leukemia_IF', 4, NULL),
(524, NULL, 'IPR002496', NULL, 'Phosphoribosyl-AMP cyclohydrolase domain', 'PRib_AMP_CycHydrolase_dom', 3, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(525, NULL, 'IPR000292', NULL, 'Formate/nitrite transporter', 'For/NO2_transpt', 4, NULL),
(526, NULL, 'IPR002519', NULL, 'Hepatitis C virus, Envelope glycoprotein E1', 'HCV_Env', 3, NULL),
(527, NULL, 'IPR004608', NULL, 'Methylmalonyl-CoA mutase, beta chain', 'MMCoA_mutase_b', 4, NULL),
(528, NULL, 'IPR000264', NULL, 'ALB/AFP/VDB', 'ALB/AFP/VDB', 4, NULL),
(529, NULL, 'IPR005475', NULL, 'Transketolase-like, pyrimidine-binding domain', 'Transketolase-like_Pyr-bd', 3, NULL),
(530, NULL, 'IPR003059', NULL, 'Colicin lysis protein', 'Lysis_col', 4, NULL),
(531, NULL, 'IPR004013', NULL, 'PHP domain', 'PHP_dom', 3, NULL),
(532, NULL, 'IPR004601', NULL, 'UV-endonuclease UvdE', 'UvdE', 4, NULL),
(533, NULL, 'IPR004056', NULL, 'Potassium channel, voltage dependent, Kv4.3', 'K_chnl_volt-dep_Kv4.3', 4, NULL),
(534, NULL, 'IPR005480', NULL, 'Carbamoyl-phosphate synthetase, large subunit oligomerisation domain', 'CarbamoylP_synth_lsu_oligo', 3, NULL),
(535, NULL, 'IPR008217', NULL, 'Ccc1 family', 'Ccc1_fam', 4, NULL),
(536, NULL, 'IPR004050', NULL, 'Potassium channel, voltage dependent, Kv1.3', 'K_chnl_volt-dep_Kv1.3', 4, NULL),
(537, NULL, 'IPR005015', NULL, 'Thermostable direct haemolysin, vibrio', 'Thermostable_hemolysn_vibrio', 4, NULL),
(538, NULL, 'IPR000329', NULL, 'Uteroglobin', 'Uteroglobin', 4, NULL),
(539, NULL, 'IPR003084', NULL, 'Histone deacetylase', 'His_deacetylse_1', 4, NULL),
(540, NULL, 'IPR001241', NULL, 'DNA topoisomerase, type IIA', 'Topo_IIA', 4, NULL),
(541, NULL, 'IPR005328', NULL, 'Sic protein repeat', 'Sic', 7, NULL),
(542, NULL, 'IPR004577', NULL, '8-oxoguanine DNA-glycosylase', 'Ogg1', 4, NULL),
(543, NULL, 'IPR008231', NULL, 'Probable chaperone CsaA', 'CsaA', 4, NULL),
(544, NULL, 'IPR007675', NULL, 'Poxvirus F15', 'Poxvirus_F15', 4, NULL),
(545, NULL, 'IPR003069', NULL, 'Ecdysteroid receptor', 'Ecdystd_rcpt', 4, NULL),
(546, NULL, 'IPR004585', NULL, 'DNA recombination/repair protein Rad52', 'DNA_recomb/repair_Rad52', 4, NULL),
(547, NULL, 'IPR002525', NULL, 'Transposase, IS111A/IS1328/IS1533, N-terminal', 'Transposase_N', 3, NULL),
(548, NULL, 'IPR004012', NULL, 'RUN domain', 'Run_dom', 3, NULL),
(549, NULL, 'IPR002528', NULL, 'Multi antimicrobial extrusion protein', 'MATE_fam', 4, NULL),
(550, NULL, 'IPR002481', NULL, 'Ferric-uptake regulator', 'FUR', 4, NULL),
(551, NULL, 'IPR001232', NULL, 'S-phase kinase-associated protein 1-like', 'SKP1-like', 4, NULL),
(552, NULL, 'IPR005468', NULL, 'Avidin/streptavidin', 'Avidin/str', 4, NULL),
(553, NULL, 'IPR004996', NULL, 'DNA helicase/primase complex-associated protein', 'HSV_HEPA', 4, NULL),
(554, NULL, 'IPR034388', NULL, 'Star-PAP, RNA recognition motif', 'Star-PAP_RRM', 3, NULL),
(555, NULL, 'IPR005506', NULL, 'Protein of unknown function DUF312, ALF', 'DUF312_ALF', 7, NULL),
(556, NULL, 'IPR004586', NULL, 'RecBCD enzyme subunit RecB', 'RecB', 4, NULL),
(557, NULL, 'IPR007678', NULL, 'Poxvirus G5', 'Poxvirus_G5', 4, NULL),
(558, NULL, 'IPR004015', NULL, 'SKI-interacting protein SKIP, SNW domain', 'SKI-int_prot_SKIP_SNW-dom', 3, NULL),
(559, NULL, 'IPR000328', NULL, 'Retroviral envelope protein GP41-like', 'GP41-like', 3, NULL),
(560, NULL, 'IPR009579', NULL, 'Protein of unknown function DUF1192', 'DUF1192', 4, NULL),
(561, NULL, 'IPR007671', NULL, 'Selenoprotein P, N-terminal', 'Selenoprotein-P_N', 3, NULL),
(562, NULL, 'IPR004971', NULL, 'mRNA (guanine-N(7))-methyltransferase domain', 'mRNA_G-N7_MeTrfase_dom', 3, NULL),
(563, NULL, 'IPR001243', NULL, 'Rusticyanin', 'Rusticyanin', 4, NULL),
(564, NULL, 'IPR004584', NULL, 'DNA repair protein Rad50, eukaryotes', 'Rad50_eukaryotes', 4, NULL),
(565, NULL, 'IPR002475', NULL, 'Bcl2-like', 'Bcl2-like', 4, NULL),
(566, NULL, 'IPR005496', NULL, 'Integral membrane protein TerC', 'Integral_membrane_TerC', 4, NULL),
(567, NULL, 'IPR000322', NULL, 'Glycoside hydrolase family 31', 'Glyco_hydro_31', 4, NULL),
(568, NULL, 'IPR008213', NULL, 'CpcD-like domain', 'CpcD-like_dom', 3, NULL),
(569, NULL, 'IPR002960', NULL, 'Lymphotoxin-alpha', 'TNF_beta', 4, NULL),
(570, NULL, 'IPR004042', NULL, 'Intein DOD homing endonuclease', 'Intein_endonuc', 3, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(571, NULL, 'IPR001299', NULL, 'Ependymin', 'Ependymin', 4, NULL),
(572, NULL, 'IPR004199', NULL, 'Beta galactosidase small chain/ domain 5', 'B-gal_small/dom_5', 3, NULL),
(573, NULL, 'IPR009567', NULL, 'Store-operated calcium entry-associated regulatory factor', 'SARAF', 4, NULL),
(574, NULL, 'IPR007184', NULL, 'Mannoside phosphorylase', 'Mannoside_phosphorylase', 4, NULL),
(575, NULL, 'IPR023659', NULL, 'Coenzyme F420:L-glutamate ligase, archaeal', 'F420_ligase_CofE_arc', 4, NULL),
(576, NULL, 'IPR004029', NULL, 'UreE urease accessory, N-terminal', 'UreE_N', 3, NULL),
(577, NULL, 'IPR004565', NULL, 'Outer membrane lipoprotein LolB', 'OM_lipoprot_LolB', 4, NULL),
(578, NULL, 'IPR002520', NULL, 'Adhesin lipoprotein', 'Lipoprotein_7', 4, NULL),
(579, NULL, 'IPR003046', NULL, 'P2X3 purinoceptor', 'P2X3_purnocptor', 4, NULL),
(580, NULL, 'IPR005483', NULL, 'Carbamoyl-phosphate synthase large subunit, CPSase domain', 'CbamoylP_synth_lsu_CPSase_dom', 3, NULL),
(581, NULL, 'IPR004612', NULL, 'Holliday junction resolvase RecU', 'Resolv_RecU', 4, NULL),
(582, NULL, 'IPR002964', NULL, 'Adhesive plaque protein', 'Adhesive_plaq', 4, NULL),
(583, NULL, 'IPR009574', NULL, 'Protein of unknown function DUF1189', 'DUF1189', 4, NULL),
(584, NULL, 'IPR034393', NULL, 'TatSF1-like', 'TatSF1-like', 4, NULL),
(585, NULL, 'IPR004058', NULL, 'Zeta tubulin', 'Zeta_tubulin', 4, NULL),
(586, NULL, 'IPR004028', NULL, 'Retroviral Gag polyprotein, M', 'Gag_M', 3, NULL),
(587, NULL, 'IPR024711', NULL, 'Catalase, mono-functional, haem-containing, clades 1 and 3', 'Catalase_clade1/3', 4, NULL),
(588, NULL, 'IPR002962', NULL, 'Peropsin', 'Peropsin', 4, NULL),
(589, NULL, 'IPR001295', NULL, 'Dihydroorotate dehydrogenase, conserved site', 'Dihydroorotate_DH_CS', 2, NULL),
(590, NULL, 'IPR004031', NULL, 'PMP-22/EMP/MP20/Claudin superfamily', 'PMP22/EMP/MP20/Claudin', 4, NULL),
(591, NULL, 'IPR004552', NULL, '1-acyl-sn-glycerol-3-phosphate acyltransferase', 'AGP_acyltrans', 3, NULL),
(592, NULL, 'IPR017951', NULL, 'Urease alpha subunit, C-terminal', 'Urease_asu_c', 3, NULL),
(593, NULL, 'IPR000268', NULL, 'DNA-directed RNA polymerase subunit RPABC5/Rpb10', 'RPABC5/Rpb10', 4, NULL),
(594, NULL, 'IPR004060', NULL, 'Orexin receptor 2', 'Orexin_rcpt_2', 4, NULL),
(595, NULL, 'IPR000315', NULL, 'B-box-type zinc finger', 'Znf_B-box', 3, NULL),
(596, NULL, 'IPR007684', NULL, 'Zinc finger, Ogr/Delta-type', 'Znf_Ogr/Delta', 3, NULL),
(597, NULL, 'IPR007670', NULL, 'Protein of unknown function DUF596', 'DUF596', 4, NULL),
(598, NULL, 'IPR002480', NULL, 'DAHP synthetase, class II', 'DAHP_synth_2', 4, NULL),
(599, NULL, 'IPR022838', NULL, 'GTP cyclohydrolase FolE2', 'GTP_cyclohydrolase_FolE2', 4, NULL),
(600, NULL, 'IPR002500', NULL, 'Phosphoadenosine phosphosulphate reductase', 'PAPS_reduct', 3, NULL),
(601, NULL, 'IPR000296', NULL, 'Cation-dependent mannose-6-phosphate receptor', 'Man-6-P_rcpt_cation_dep', 4, NULL),
(602, NULL, 'IPR005488', NULL, 'N-acetylmuramic acid 6-phosphate etherase MurQ', 'Etherase_MurQ', 4, NULL),
(603, NULL, 'IPR003617', NULL, 'Transcription elongation factor, TFIIS/CRSP70, N-terminal, sub-type', 'TFIIS/CRSP70_N_sub', 3, NULL),
(604, NULL, 'IPR002508', NULL, 'N-acetylmuramoyl-L-alanine amidase, catalytic domain', 'MurNAc-LAA_cat', 3, NULL),
(605, NULL, 'IPR002533', NULL, 'Alphavirus E3 spike glycoprotein', 'Alpha_E3_glycop', 3, NULL),
(606, NULL, 'IPR000291', NULL, 'D-alanine--D-alanine ligase/VANA/B/C, conserved site', 'D-Ala_lig_Van_CS', 2, NULL),
(607, NULL, 'IPR002968', NULL, 'Alpha-1-microglobulin', 'A1-microglobln', 4, NULL),
(608, NULL, 'IPR008242', NULL, 'Bifunctional P-protein, chorismate mutase/prephenate dehydratase', 'Chor_mutase/pphenate_deHydtase', 4, NULL),
(609, NULL, 'IPR008215', NULL, 'Tachykinin domain', 'Tachykinin_dom', 3, NULL),
(610, NULL, 'IPR008216', NULL, 'Tachykinin family', 'Tachykinin_fam', 4, NULL),
(611, NULL, 'IPR002969', NULL, 'Apolipoprotein D', 'ApolipopD', 4, NULL),
(612, NULL, 'IPR003995', NULL, 'RTX toxin determinant A', 'RTX_toxin_determinant-A', 4, NULL),
(613, NULL, 'IPR004570', NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', 'Phosphatidylglycerol_P_synth', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(614, NULL, 'IPR002498', NULL, 'Phosphatidylinositol-4-phosphate 5-kinase, core', 'PInositol-4-P-5-kinase_core', 3, NULL),
(615, NULL, 'IPR000866', NULL, 'Alkyl hydroperoxide reductase subunit C/ Thiol specific antioxidant', 'AhpC/TSA', 3, NULL),
(616, NULL, 'IPR005501', NULL, 'LamB/YcsF/PxpA-like', 'LamB/YcsF/PxpA-like', 4, NULL),
(617, NULL, 'IPR004564', NULL, 'Outer membrane lipoprotein carrier protein LolA-like', 'OM_lipoprot_carrier_LolA-like', 4, NULL),
(618, NULL, 'IPR003055', NULL, 'Nucleoside-specific channel-forming protein Tsx', 'Channel_Tsx', 4, NULL),
(619, NULL, 'IPR000318', NULL, 'Nitrogenase component 1, conserved site', 'Nase_comp1_CS', 2, NULL),
(620, NULL, 'IPR005467', NULL, 'Histidine kinase domain', 'His_kinase_dom', 3, NULL),
(621, NULL, 'IPR004560', NULL, 'L-ribulose-5-phosphate 3-epimerase', 'L-Ru-5P_3-Epase', 4, NULL),
(622, NULL, 'IPR000283', NULL, 'NADH:ubiquinone oxidoreductase, 75kDa subunit, conserved site', 'NADH_UbQ_OxRdtase_75kDa_su_CS', 2, NULL),
(623, NULL, 'IPR003056', NULL, 'GPCR, family 2, ADGRE2/ADGRE5', 'GPCR_2_ADGRE2_ADGRE5', 4, NULL),
(624, NULL, 'IPR001253', NULL, 'Translation initiation factor 1A (eIF-1A)', 'TIF_eIF-1A', 4, NULL),
(625, NULL, 'IPR004057', NULL, 'Epsilon tubulin', 'Epsilon_tubulin', 4, NULL),
(626, NULL, 'IPR009569', NULL, 'Amino acid synthesis, putative', 'AA_synth_put', 4, NULL),
(627, NULL, 'IPR004982', NULL, 'WTF family', 'WTF', 4, NULL),
(628, NULL, 'IPR002507', NULL, 'Reovirus non-structural protein sigma NS', 'Reovirus_polyG_pol', 4, NULL),
(629, NULL, 'IPR004579', NULL, 'ERCC1/RAD10/SWI10 family', 'ERCC1/RAD10/SWI10', 4, NULL),
(630, NULL, 'IPR005454', NULL, 'Profilin1/2/3, vertebrate', 'Profilin1/2/3_vertebrate', 4, NULL),
(631, NULL, 'IPR005450', NULL, 'Voltage-dependent calcium channel, L-type, alpha-1S subunit', 'VDCC_L_a1ssu', 4, NULL),
(632, NULL, 'IPR002961', NULL, 'Lymphotoxin-beta', 'TNF_C', 4, NULL),
(633, NULL, 'IPR004583', NULL, 'DNA repair protein Rad4', 'DNA_repair_Rad4', 4, NULL),
(634, NULL, 'IPR004998', NULL, 'Herpesvirus transcription activation factor', 'Herpes_TAF50', 4, NULL),
(635, NULL, 'IPR004568', NULL, 'Phosphopantetheine-protein transferase domain', 'Ppantetheine-prot_Trfase_dom', 3, NULL),
(636, NULL, 'IPR007681', NULL, 'Ran-interacting Mog1 protein', 'Mog1', 4, NULL),
(637, NULL, 'IPR004993', NULL, 'GH3 family', 'GH3', 4, NULL),
(638, NULL, 'IPR003045', NULL, 'P2X2 purinoceptor', 'P2X2_purnocptor', 4, NULL),
(639, NULL, 'IPR005002', NULL, 'Phosphomannomutase', 'PMM', 4, NULL),
(640, NULL, 'IPR005011', NULL, 'SNU66/SART1 family', 'SNU66/SART1', 4, NULL),
(641, NULL, 'IPR023662', NULL, 'Rhomboid protease GlpG', 'Rhomboid_protease_GlpG', 4, NULL),
(642, NULL, 'IPR000298', NULL, 'Cytochrome c oxidase subunit III-like', 'Cyt_c_oxidase-like_su3', 3, NULL),
(643, NULL, 'IPR004037', NULL, 'Ribosomal protein L7Ae conserved site', 'Ribosomal_L7Ae_CS', 2, NULL),
(644, NULL, 'IPR004049', NULL, 'Potassium channel, voltage dependent, Kv1.2', 'K_chnl_volt-dep_Kv1.2', 4, NULL),
(645, NULL, 'IPR005007', NULL, 'Poxvirus L3/FP4', 'Poxvirus_L3/FP4', 4, NULL),
(646, NULL, 'IPR005463', NULL, 'Transient receptor potential channel, canonical 7', 'TRPC7_channel', 4, NULL),
(647, NULL, 'IPR000335', NULL, 'Bleomycin resistance protein', 'Bleomycin-R', 4, NULL),
(648, NULL, 'IPR003618', NULL, 'Transcription elongation factor S-II, central domain', 'TFIIS_cen_dom', 3, NULL),
(649, NULL, 'IPR002532', NULL, 'Hantavirus glycoprotein Gc', 'Hanta_Gc', 3, NULL),
(650, NULL, 'IPR003067', NULL, 'Plasmodium circumsporozoite protein', 'Crcmsprzoite', 4, NULL),
(651, NULL, 'IPR005456', NULL, 'Pre-pro melanin-concentrating hormone', 'Prepro-melanin_conc_hormone', 4, NULL),
(652, NULL, 'IPR008248', NULL, 'Protein-glutamate methylesterase/protein-glutamine glutaminase, CheB type', 'CheB-like', 4, NULL),
(653, NULL, 'IPR000272', NULL, 'Ion-transport regulator, FXYD motif', 'Ion-transport_regulator_FXYD', 4, NULL),
(654, NULL, 'IPR005482', NULL, 'Biotin carboxylase, C-terminal', 'Biotin_COase_C', 3, NULL),
(655, NULL, 'IPR007182', NULL, 'Na+/H+ antiporter MnhB subunit-related protein', 'MnhB', 3, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(656, NULL, 'IPR002515', NULL, 'Zinc finger, C2H2C-type', 'Znf_C2H2C', 7, NULL),
(657, NULL, 'IPR005485', NULL, 'Ribosomal protein L5 eukaryotic/L18 archaeal', 'Rbsml_L5_euk/L18_arc', 4, NULL),
(658, NULL, 'IPR002478', NULL, 'PUA domain', 'PUA', 3, NULL),
(659, NULL, 'IPR005503', NULL, 'Flagellar basal body-associated protein FliL', 'FliL', 4, NULL),
(660, NULL, 'IPR004547', NULL, 'Glucosamine-6-phosphate isomerase', 'Glucosamine6P_isomerase', 4, NULL),
(661, NULL, 'IPR002505', NULL, 'Phosphate acetyl/butaryl transferase', 'PTA_PTB', 3, NULL),
(662, NULL, 'IPR034350', NULL, 'NUCL, RNA recognition motif 2', 'NUCL_RRM2', 3, NULL),
(663, NULL, 'IPR009582', NULL, 'Signal peptidase complex subunit 2', 'Spc2/SPCS2', 4, NULL),
(664, NULL, 'IPR007177', NULL, '16S/18S rRNA aminocarboxypropyltransferase Tsr3, C-terminal', 'Tsr3_C', 3, NULL),
(665, NULL, 'IPR008219', NULL, 'Proline dehydrogenase, bacteria and archaea', 'PRODH_bac_arc', 4, NULL),
(666, NULL, 'IPR002514', NULL, 'Transposase IS3/IS911family', 'Transposase_8', 4, NULL),
(667, NULL, 'IPR000247', NULL, 'Cucumovirus coat protein', 'Cucumovirus_coat', 4, NULL),
(668, NULL, 'IPR003607', NULL, 'HD/PDEase domain', 'HD/PDEase_dom', 3, NULL),
(669, NULL, 'IPR005466', NULL, 'P2Y14 purinoceptor', 'P2Y14_rcpt', 4, NULL),
(670, NULL, 'IPR005490', NULL, 'L,D-transpeptidase catalytic domain', 'LD_TPept_cat_dom', 3, NULL),
(671, NULL, 'IPR004968', NULL, 'DNA primase/nucleoside triphosphatase, C-terminal', 'DNA_primase/NTPase_C', 3, NULL),
(672, NULL, 'IPR000237', NULL, 'GRIP domain', 'GRIP_dom', 3, NULL),
(673, NULL, 'IPR008229', NULL, 'tRNA nucleotidyltransferase, archaea', 'CCA-adding_arc', 4, NULL),
(674, NULL, 'IPR002522', NULL, 'Hepatitis C virus, Core protein, N-terminal', 'HCV_core_N', 3, NULL),
(675, NULL, 'IPR001242', NULL, 'Condensation domain', 'Condensatn', 3, NULL),
(676, NULL, 'IPR002229', NULL, 'Blood group Rhesus C/E/D polypeptide', 'RhesusRHD', 4, NULL),
(677, NULL, 'IPR004573', NULL, 'rRNA small subunit methyltransferase B', 'rRNA_ssu_MeTfrase_B', 4, NULL),
(678, NULL, 'IPR003614', NULL, 'Knottin, scorpion toxin-like', 'Scorpion_toxin-like', 3, NULL),
(679, NULL, 'IPR004985', NULL, 'Adenovirus E3-15', 'Adeno_E3-15', 4, NULL),
(680, NULL, 'IPR005010', NULL, 'Rhabdovirus M1 matrix protein', 'Rhabdo_M1', 4, NULL),
(681, NULL, 'IPR002538', NULL, 'Bromovirus movement protein', 'Bromo_MP', 4, NULL),
(682, NULL, 'IPR003077', NULL, 'Peroxisome proliferator-activated receptor gamma', 'PPAR-gamma', 4, NULL),
(683, NULL, 'IPR008251', NULL, 'Chromo shadow domain', 'Chromo_shadow_dom', 3, NULL),
(684, NULL, 'IPR002486', NULL, 'Nematode cuticle collagen, N-terminal', 'Col_cuticle_N', 3, NULL),
(685, NULL, 'IPR000231', NULL, 'Ribosomal protein L30e', 'Ribosomal_L30e', 4, NULL),
(686, NULL, 'IPR007679', NULL, 'Domain of unknown function DUF569', 'DUF569', 3, NULL),
(687, NULL, 'IPR002490', NULL, 'V-type  ATPase, V0 complex, 116kDa subunit family', 'V-ATPase_116kDa_su', 4, NULL),
(688, NULL, 'IPR023636', NULL, 'Urocanase conserved site', 'Urocanase_CS', 2, NULL),
(689, NULL, 'IPR000232', NULL, 'Heat shock factor (HSF)-type, DNA-binding', 'HSF_DNA-bd', 3, NULL),
(690, NULL, 'IPR002491', NULL, 'ABC transporter periplasmic binding domain', 'ABC_transptr_periplasmic_BD', 3, NULL),
(691, NULL, 'IPR002524', NULL, 'Cation efflux protein', 'Cation_efflux', 4, NULL),
(692, NULL, 'IPR004598', NULL, 'Transcription factor TFIIH subunit p52/Tfb2', 'TFIIH_p52/Tfb2', 4, NULL),
(693, NULL, 'IPR004047', NULL, 'Melanin-concentrating hormone receptor 1', 'MCHR1', 4, NULL),
(694, NULL, 'IPR005457', NULL, 'Transient receptor potential channel, canonical 1', 'TRPC1_channel', 4, NULL),
(695, NULL, 'IPR000234', NULL, 'Herpesvirus Glycoprotein B', 'Herpes_Glycoprot_B', 4, NULL),
(696, NULL, 'IPR004559', NULL, 'Heme chaperone HemW-like', 'HemW-like', 4, NULL),
(697, NULL, 'IPR001264', NULL, 'Glycosyl transferase, family 51', 'Glyco_trans_51', 3, NULL),
(698, NULL, 'IPR008240', NULL, 'Chorismate mutase, periplasmic', 'Chorismate_mutase_periplasmic', 4, NULL),
(699, NULL, 'IPR004554', NULL, 'Hydroxymethylglutaryl-CoA reductase, eukaryotic/archaeal type', 'HMG_CoA_Rdtase_eu_arc', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(700, NULL, 'IPR005453', NULL, 'Pollen allergen Lol p2', 'Allergen_Lolp2', 4, NULL),
(701, NULL, 'IPR005492', NULL, 'Leucine-rich glioma-inactivated , EPTP repeat', 'EPTP', 7, NULL),
(702, NULL, 'IPR008244', NULL, 'Bifunctional chorismate mutase/prephenate dehydrogenase T-protein', 'Chor_mut/prephenate_DH_T', 4, NULL),
(703, NULL, 'IPR003093', NULL, 'Apoptosis regulator, Bcl-2 protein, BH4', 'Bcl2_BH4', 3, NULL),
(704, NULL, 'IPR004011', NULL, 'GYR motif', 'Gyr_motif', 2, NULL),
(705, NULL, 'IPR000306', NULL, 'FYVE zinc finger', 'Znf_FYVE', 3, NULL),
(706, NULL, 'IPR004053', NULL, 'Potassium voltage-gated channel subfamily A member 6', 'KCNA6', 4, NULL),
(707, NULL, 'IPR007180', NULL, 'Domain of unknown function DUF382', 'DUF382', 3, NULL),
(708, NULL, 'IPR000324', NULL, 'Vitamin D receptor', 'VitD_rcpt', 4, NULL),
(709, NULL, 'IPR004017', NULL, 'Cysteine-rich domain', 'Cys_rich_dom', 3, NULL),
(710, NULL, 'IPR023661', NULL, 'Bifunctional F420 biosynthesis protein FbiB', 'FbiB', 4, NULL),
(711, NULL, 'IPR005469', NULL, 'Avidin', 'Avidin', 4, NULL),
(712, NULL, 'IPR003070', NULL, 'Orphan nuclear receptor', 'Nuc_orph_rcpt', 4, NULL),
(713, NULL, 'IPR002477', NULL, 'Peptidoglycan binding-like', 'Peptidoglycan-bd-like', 3, NULL),
(714, NULL, 'IPR008228', NULL, 'Uncharacterised conserved protein UCP006173', 'UCP006173', 4, NULL),
(715, NULL, 'IPR034352', NULL, 'Rim4/Msa1, RNA recognition motif 1', 'Rim4_RRM1', 3, NULL),
(716, NULL, 'IPR005008', NULL, 'Poxvirus rifampicin-resistance', 'Poxvirus_Rif-R', 4, NULL),
(717, NULL, 'IPR003081', NULL, 'Glutathione S-transferase, Mu class', 'GST_mu', 4, NULL),
(718, NULL, 'IPR005464', NULL, 'Psychosine receptor', 'Psych_rcpt', 4, NULL),
(719, NULL, 'IPR004010', NULL, 'Double Cache domain 2', 'Double_Cache_2', 3, NULL),
(720, NULL, 'IPR008226', NULL, 'Mini-ribonuclease 3 family', 'Mini3_fam', 4, NULL),
(721, NULL, 'IPR005407', NULL, 'Potassium channel subfamily K member 9', 'KCNK9', 4, NULL),
(722, NULL, 'IPR003075', NULL, 'Peroxisome proliferator-activated receptor, beta', '1Cnucl_rcpt_B', 4, NULL),
(723, NULL, 'IPR003082', NULL, 'Glutathione S-transferase, Pi class', 'GST_pi', 4, NULL),
(724, NULL, 'IPR023656', NULL, 'IMP biosynthesis enzyme PurP', 'IMP_biosynth_PurP', 4, NULL),
(725, NULL, 'IPR009576', NULL, 'Biofilm formation YgiB', 'Biofilm_formation_YgiB', 4, NULL),
(726, NULL, 'IPR005005', NULL, 'Poxvirus F12L', 'Poxvirus_F12L', 4, NULL),
(727, NULL, 'IPR004064', NULL, 'EDG-6 sphingosine 1-phosphate receptor', 'EDG6_rcpt', 4, NULL),
(728, NULL, 'IPR034351', NULL, 'Nrp1, RNA recognition motif', 'Nrp1_RRM', 3, NULL),
(729, NULL, 'IPR003611', NULL, 'Nuclease associated modular domain 3', 'NUMOD3', 3, NULL),
(730, NULL, 'IPR004569', NULL, 'Pyridoxal phosphate (active vitamin B6) biosynthesis PdxJ', 'PyrdxlP_synth_PdxJ', 4, NULL),
(731, NULL, 'IPR000314', NULL, 'Gastrin receptor', 'Gastrin_rcpt', 4, NULL),
(732, NULL, 'IPR005000', NULL, 'HpcH/HpaI aldolase/citrate lyase domain', 'Aldolase/citrate-lyase_domain', 3, NULL),
(733, NULL, 'IPR000233', NULL, 'Cadherin, Y-type LIR-motif', 'Cadherin_Y-type_LIR', 3, NULL),
(734, NULL, 'IPR007676', NULL, 'Ribophorin I', 'Ribophorin_I', 4, NULL),
(735, NULL, 'IPR000239', NULL, 'GPCR kinase', 'GPCR_kinase', 4, NULL),
(736, NULL, 'IPR004566', NULL, 'Pantothenate kinase', 'PanK', 4, NULL),
(737, NULL, 'IPR004550', NULL, 'L-asparaginase, type II', 'AsnASE_II', 4, NULL),
(738, NULL, 'IPR008241', NULL, 'Salicylate biosynthesis protein PchB', 'Isochorismate_pyruvate-lyase', 4, NULL),
(739, NULL, 'IPR004553', NULL, 'Hydroxymethylglutaryl-CoA reductase, bacterial-type', 'HMG_CoA_Rdtase_bac-typ', 4, NULL),
(740, NULL, 'IPR004988', NULL, 'Protein of unknown function DUF273', 'DUF273', 4, NULL),
(741, NULL, 'IPR034394', NULL, 'MAN1, RNA recognition motif', 'Man1_RRM', 3, NULL),
(742, NULL, 'IPR005481', NULL, 'Biotin carboxylase-like, N-terminal domain', 'BC-like_N', 3, NULL),
(743, NULL, 'IPR004063', NULL, 'EDG-5 sphingosine 1-phosphate receptor', 'EDG5_rcpt', 4, NULL),
(744, NULL, 'IPR007178', NULL, 'Archaeal transcription elongation factor Spt4', 'Spt4_arch', 4, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(745, NULL, 'IPR005507', NULL, 'Human herpesvirus 6 immediate early protein', 'HHV6-IE', 4, NULL),
(746, NULL, 'IPR023654', NULL, 'Ribosomal protein L32e, archaeal', 'Ribosomal_L32e_arc', 4, NULL),
(747, NULL, 'IPR004548', NULL, 'Peptide chain release factor 3', 'PrfC', 4, NULL),
(748, NULL, 'IPR002487', NULL, 'Transcription factor, K-box', 'TF_Kbox', 3, NULL),
(749, NULL, 'IPR004000', NULL, 'Actin family', 'Actin', 4, NULL),
(750, NULL, 'IPR004006', NULL, 'DhaK domain', 'DhaK_dom', 3, NULL),
(751, NULL, 'IPR004591', NULL, 'Replication factor A protein 1', 'Rfa1', 4, NULL),
(752, NULL, 'IPR003087', NULL, 'Neutrophil gelatinase-associated lipocalin/epididymal-specific lipocalin-12', 'LCN2/LCN12', 4, NULL),
(753, NULL, 'IPR007685', NULL, 'RelA/SpoT', 'RelA_SpoT', 3, NULL),
(754, NULL, 'IPR000266', NULL, 'Ribosomal protein S17/S11', 'Ribosomal_S17/S11', 4, NULL),
(755, NULL, 'IPR000244', NULL, 'Ribosomal protein L9', 'Ribosomal_L9', 4, NULL),
(756, NULL, 'IPR004611', NULL, 'DNA primase-related protein', 'DNA_primase-rel', 4, NULL),
(757, NULL, 'IPR005495', NULL, 'Permease LptG/LptF-related', 'LptG/LptF_permease', 4, NULL),
(758, NULL, 'IPR009572', NULL, 'Protein of unknown function DUF1187', 'DUF1187', 4, NULL),
(759, NULL, 'IPR004990', NULL, 'ELF protein', 'ELF', 4, NULL),
(760, NULL, 'IPR000270', NULL, 'PB1 domain', 'PB1_dom', 3, NULL),
(761, NULL, 'IPR005513', NULL, 'Late embryogenesis abundant protein, LEA_1 subgroup', 'LEA_1', 4, NULL),
(762, NULL, 'IPR005009', NULL, 'Poxvirus mRNA capping enzyme, small subunit', 'Poxvirus_mRNA-cap_ssu', 4, NULL),
(763, NULL, 'IPR004018', NULL, 'RPEL repeat', 'RPEL_repeat', 7, NULL),
(764, NULL, 'IPR008249', NULL, 'Uncharacterised protein family UPF0231', 'UPF0231', 4, NULL),
(765, NULL, 'IPR005458', NULL, 'Transient receptor potential channel, canonical 2', 'TRPC2_channel', 4, NULL),
(766, NULL, 'IPR004969', NULL, 'Poxvirus I1', 'Poxvirus_I1', 4, NULL),
(767, NULL, 'IPR007674', NULL, 'Poxvirus 36kDa major membrane', 'Poxvirus_36kDa_major_membrane', 3, NULL),
(768, NULL, 'IPR004563', NULL, 'Apolipoprotein N-acyltransferase', 'Apolipo_AcylTrfase', 4, NULL),
(769, NULL, 'IPR004999', NULL, 'Herpesvirus capsid shell protein 1', 'Herpes_1', 4, NULL),
(770, NULL, 'IPR007672', NULL, 'Selenoprotein P, C-terminal', 'SelP_C', 3, NULL),
(771, NULL, 'IPR000269', NULL, 'Copper amine oxidase', 'Cu_amine_oxidase', 4, NULL),
(772, NULL, 'IPR004001', NULL, 'Actin, conserved site', 'Actin_CS', 2, NULL),
(773, NULL, 'IPR004977', NULL, 'Ribosomal protein S25', 'Ribosomal_S25', 4, NULL),
(774, NULL, 'IPR002489', NULL, 'Glutamate synthase, alpha subunit, C-terminal', 'Glu_synth_asu_C', 3, NULL),
(775, NULL, 'IPR008250', NULL, 'P-type ATPase, A domain superfamily', 'ATPase_P-typ_transduc_dom_A_sf', 5, NULL),
(776, NULL, 'IPR023669', NULL, 'Ribosomal protein L1, archaea', 'Ribosomal_L1_arc', 4, NULL),
(777, NULL, 'IPR002510', NULL, 'Metalloprotease TldD/E, N-terminal domain', 'Metalloprtase-TldD/E_N', 3, NULL),
(778, NULL, 'IPR004992', NULL, 'Ethanolamine utilization protein EutN/carboxysome shell vertex protein CcmL', 'EutN_CcmL', 4, NULL),
(779, NULL, 'IPR001235', NULL, 'Blue (type 1) copper protein, plastocyanin-type', 'Copper_blue_Plastocyanin', 4, NULL),
(780, NULL, 'IPR004572', NULL, 'Protoporphyrinogen oxidase', 'Protoporphyrinogen_oxidase', 4, NULL),
(781, NULL, 'IPR004980', NULL, 'Tenuivirus movement protein, NS4', 'Tenui_NS4', 4, NULL),
(782, NULL, 'IPR005479', NULL, 'Carbamoyl-phosphate synthetase large subunit-like, ATP-binding domain', 'CbamoylP_synth_lsu-like_ATP-bd', 3, NULL),
(783, NULL, 'IPR004555', NULL, 'Glucose-6-phosphate dehydrogenase assembly protein OpcA', 'G6PDH_assembly_OpcA', 4, NULL),
(784, NULL, 'IPR004567', NULL, 'Type II pantothenate kinase', 'Type_II_PanK', 4, NULL),
(785, NULL, 'IPR004580', NULL, 'DNA repair protein Rad18, fungi', 'Rad18_fungi', 4, NULL),
(786, NULL, 'IPR005477', NULL, 'Deoxyxylulose-5-phosphate synthase', 'Dxylulose-5-P_synthase', 4, NULL),
(787, NULL, 'IPR008218', NULL, 'ATPase, V1 complex, subunit F', 'ATPase_V1-cplx_f_g_su', 4, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(788, NULL, 'IPR001233', NULL, 'RNA-splicing ligase, RtcB', 'RtcB', 4, NULL),
(789, NULL, 'IPR023670', NULL, 'Tyrosine recombinase XerS', 'Recomb_XerS', 4, NULL),
(790, NULL, 'IPR001228', NULL, '2-C-methyl-D-erythritol 4-phosphate cytidylyltransferase', 'IspD', 4, NULL),
(791, NULL, 'IPR007183', NULL, 'Uncharacterised protein family UPF0280', 'UPF0280', 4, NULL),
(792, NULL, 'IPR001245', NULL, 'Serine-threonine/tyrosine-protein kinase, catalytic domain', 'Ser-Thr/Tyr_kinase_cat_dom', 3, NULL),
(793, NULL, 'IPR003050', NULL, 'P2X7 purinoceptor', 'P2X7_purinoceptor', 4, NULL),
(794, NULL, 'IPR004986', NULL, 'Caulimovirus virion-associated protein', 'Caulimo_virion-assoc', 4, NULL),
(795, NULL, 'IPR004059', NULL, 'Orexin/Hypocretin receptor type 1', 'OX1R', 4, NULL),
(796, NULL, 'IPR002517', NULL, 'Tospovirus nucleocapsid protein', 'Tospo_nucleocap', 4, NULL),
(797, NULL, 'IPR002527', NULL, 'Picornavirus 2B protein', 'Pico_P2B', 3, NULL),
(798, NULL, 'IPR004582', NULL, 'Checkpoint protein Rad17/Rad24', 'Checkpoint_prot_Rad17_Rad24', 4, NULL),
(799, NULL, 'IPR002523', NULL, 'Mg2+ transporter protein, CorA-like/Zinc transport protein ZntB', 'MgTranspt_CorA/ZnTranspt_ZntB', 4, NULL),
(800, NULL, 'IPR023674', NULL, 'Ribosomal protein L1-like', 'Ribosomal_L1-like', 5, NULL),
(801, NULL, 'IPR000308', NULL, '14-3-3 protein', '14-3-3', 4, NULL),
(802, NULL, 'IPR005461', NULL, 'Transient receptor potential channel, canonical 5', 'TRPC5_channel', 4, NULL),
(803, NULL, 'IPR000304', NULL, 'Pyrroline-5-carboxylate reductase', 'Pyrroline-COOH_reductase', 4, NULL),
(804, NULL, 'IPR004023', NULL, 'Mago nashi protein', 'Mago_nashi', 4, NULL),
(805, NULL, 'IPR001247', NULL, 'Exoribonuclease, phosphorolytic domain 1', 'ExoRNase_PH_dom1', 3, NULL),
(806, NULL, 'IPR002521', NULL, 'Hepatitis C virus, Core protein, C-terminal', 'HCV_Core_C', 3, NULL),
(807, NULL, 'IPR004976', NULL, 'Poly(A) polymerase catalytic subunit, Poxviridae', 'Poxviridae_polyA_pol_cat', 4, NULL),
(808, NULL, 'IPR000305', NULL, 'GIY-YIG endonuclease', 'GIY-YIG_endonuc', 3, NULL),
(809, NULL, 'IPR003078', NULL, 'Retinoic acid receptor', 'Retinoic_acid_rcpt', 4, NULL),
(810, NULL, 'IPR003090', NULL, 'Alpha-crystallin, N-terminal', 'Alpha-crystallin_N', 3, NULL),
(811, NULL, 'IPR004035', NULL, 'Endonuclease III, iron-sulphur binding site', 'Endouclease-III_FeS-bd_BS', 1, NULL),
(812, NULL, 'IPR004592', NULL, 'Nuclease SbcC, gammaproteobacteria type', 'SbcC_gammaproteobac_type', 4, NULL),
(813, NULL, 'IPR004054', NULL, 'Potassium channel, voltage dependent, Kv4.1', 'K_chnl_volt-dep_Kv4.1', 4, NULL),
(814, NULL, 'IPR001238', NULL, 'DNA-binding, RecF', 'DNA-binding_RecF', 4, NULL),
(815, NULL, 'IPR002504', NULL, 'NAD kinase', 'NADK', 4, NULL),
(816, NULL, 'IPR024712', NULL, 'Catalase, mono-functional, haem-containing, clade 2', 'Catalase_clade2', 4, NULL),
(817, NULL, 'IPR000310', NULL, 'Orn/Lys/Arg decarboxylase, major domain', 'Orn/Lys/Arg_deCO2ase_major_dom', 3, NULL),
(818, NULL, 'IPR004604', NULL, 'DNA recombination/repair protein RecN', 'DNA_recomb/repair_RecN', 4, NULL),
(819, NULL, 'IPR005003', NULL, 'Bacteriophage lambda, Tail fiber protein, repeat-1', 'Phage_lambda_Stf-r1', 7, NULL),
(820, NULL, 'IPR000242', NULL, 'Tyrosine-specific protein phosphatase, PTPase domain', 'PTP_cat', 3, NULL),
(821, NULL, 'IPR005511', NULL, 'Senescence marker protein-30 (SMP-30)', 'SMP-30', 4, NULL),
(822, NULL, 'IPR003043', NULL, 'Uroporphiryn-III C-methyltransferase, conserved site', 'Uropor_MeTrfase_CS', 2, NULL),
(823, NULL, 'IPR004032', NULL, 'PMP-22/EMP/MP20', 'PMP22_EMP_MP20', 4, NULL),
(824, NULL, 'IPR000320', NULL, 'Hedgehog, N-terminal signalling domain', 'Hedgehog_signalling_dom', 3, NULL),
(825, NULL, 'IPR007176', NULL, 'Protein of unknown function DUF365', 'DUF365', 4, NULL),
(826, NULL, 'IPR002531', NULL, 'Hepatitis C virus, Non-structural protein E2/NS1', 'HCV_NS1', 3, NULL),
(827, NULL, 'IPR003072', NULL, 'Orphan nuclear receptor, NOR1 type', 'NOR1_rcpt', 4, NULL),
(828, NULL, 'IPR003074', NULL, 'Peroxisome proliferator-activated receptor', '1Cnucl_rcpt', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(829, NULL, 'IPR004991', NULL, 'Aerolysin-like toxin', 'Aerolysin-like', 4, NULL),
(830, NULL, 'IPR006592', NULL, 'RNA polymerase, N-terminal', 'RNA_pol_N', 3, NULL),
(831, NULL, 'IPR005001', NULL, 'RNA-binding protein Hfq', 'Hfq', 4, NULL),
(832, NULL, 'IPR002963', NULL, 'Expansin', 'Expansin', 4, NULL),
(833, NULL, 'IPR005510', NULL, 'CRISPR type III-associated RAMP protein Csm4', 'Csm4', 4, NULL),
(834, NULL, 'IPR004978', NULL, 'Stanniocalcin', 'Stanniocalcin', 4, NULL),
(835, NULL, 'IPR004574', NULL, 'Alkylated DNA repair protein AlkB', 'Alkb', 4, NULL),
(836, NULL, 'IPR022837', NULL, 'Protein-methionine-sulfoxide reductase subunit MsrQ-like', 'MsrQ-like', 4, NULL),
(837, NULL, 'IPR004984', NULL, 'Mycoplasma lipoprotein, central domain', 'Mycoplasma_lipoprotein_cen_dom', 3, NULL),
(838, NULL, 'IPR004033', NULL, 'UbiE/COQ5 methyltransferase', 'UbiE/COQ5_MeTrFase', 4, NULL),
(839, NULL, 'IPR002499', NULL, 'Major vault protein, N-terminal', 'Vault_N', 7, NULL),
(840, NULL, 'IPR005489', NULL, 'Protein of unknown function DUF257', 'DUF257', 4, NULL),
(841, NULL, 'IPR004589', NULL, 'DNA helicase, ATP-dependent, RecQ type', 'DNA_helicase_ATP-dep_RecQ', 4, NULL),
(842, NULL, 'IPR002511', NULL, 'Geminivirus V2 protein', 'Gemini_V2', 4, NULL),
(843, NULL, 'IPR003609', NULL, 'PAN/Apple domain', 'Pan_app', 3, NULL),
(844, NULL, 'IPR003620', NULL, 'Urocortin/corticotropin-releasing factor', 'Urocortin_CRF', 4, NULL),
(845, NULL, 'IPR004014', NULL, 'Cation-transporting P-type ATPase, N-terminal', 'ATPase_P-typ_cation-transptr_N', 3, NULL),
(846, NULL, 'IPR003993', NULL, 'Treacle protein domain', 'Treacle_dom', 3, NULL),
(847, NULL, 'IPR007682', NULL, 'Lantibiotic, type A, Lactobacillales-type', 'Lantibiotic_typ-A_Lactobact', 4, NULL),
(848, NULL, 'IPR003615', NULL, 'HNH nuclease', 'HNH_nuc', 3, NULL),
(849, NULL, 'IPR008238', NULL, 'Chorismate mutase, AroQ class, eukaryotic type', 'Chorismate_mutase_AroQ_euk', 4, NULL),
(850, NULL, 'IPR004052', NULL, 'Potassium channel, voltage dependent, Kv1.5', 'K_chnl_volt-dep_Kv1.5', 4, NULL),
(851, NULL, 'IPR034349', NULL, 'NUCL, RNA recognition motif 1', 'NUCL_RRM1', 3, NULL),
(852, NULL, 'IPR004981', NULL, 'Tryptophan 2,3-dioxygenase', 'Trp_2_3_dOase', 4, NULL),
(853, NULL, 'IPR002495', NULL, 'Glycosyl transferase, family 8', 'Glyco_trans_8', 4, NULL),
(854, NULL, 'IPR002493', NULL, 'Herpesvirus UL25', 'Herpes_UL25', 4, NULL),
(855, NULL, 'IPR004575', NULL, 'Cdk-activating kinase assembly factor MAT1/Tfb3', 'MAT1/Tfb3', 4, NULL),
(856, NULL, 'IPR000331', NULL, 'Rap/Ran-GAP domain', 'Rap/Ran_GAP_dom', 3, NULL),
(857, NULL, 'IPR003065', NULL, 'Surface presentation of antigens protein SpaK', 'Invas_SpaK', 4, NULL),
(858, NULL, 'IPR004596', NULL, 'Cell division suppressor protein, SulA', 'Cell_div_suppressor_SulA', 4, NULL),
(859, NULL, 'IPR005512', NULL, 'PRONE domain', 'PRONE_dom', 3, NULL),
(860, NULL, 'IPR002492', NULL, 'Transposase, Tc1-like', 'Transposase_Tc1-like', 3, NULL),
(861, NULL, 'IPR034353', NULL, 'ABT1/ESF2, RNA recognition motif', 'ABT1/ESF2_RRM', 3, NULL),
(862, NULL, 'IPR004055', NULL, 'Potassium channel, voltage dependent, Kv4.2', 'K_chnl_volt-dep_Kv4.2', 4, NULL),
(863, NULL, 'IPR005460', NULL, 'Transient receptor potential channel, canonical 4', 'TRPC4_channel', 4, NULL),
(864, NULL, 'IPR004979', NULL, 'Transcription factor AP-2', 'TF_AP2', 4, NULL),
(865, NULL, 'IPR009580', NULL, 'GPI biosynthesis protein Pig-F', 'GPI_biosynthesis_protein_Pig-F', 4, NULL),
(866, NULL, 'IPR003063', NULL, 'Cloacin immunity protein family', 'Cloacn_immnty_fam', 4, NULL),
(867, NULL, 'IPR005449', NULL, 'Voltage-dependent calcium channel, R-type, alpha-1 subunit', 'VDCC_R_a1su', 4, NULL),
(868, NULL, 'IPR002483', NULL, 'PWI domain', 'PWI_dom', 3, NULL),
(869, NULL, 'IPR002506', NULL, 'Hepatitis delta virus delta antigen', 'HDV_ag', 4, NULL),
(870, NULL, 'IPR023637', NULL, 'Urocanase', 'Urocanase', 4, NULL),
(871, NULL, 'IPR004590', NULL, 'DNA single-strand annealing protein RecT', 'ssDNA_annealing_RecT', 4, NULL),
(872, NULL, 'IPR000271', NULL, 'Ribosomal protein L34', 'Ribosomal_L34', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(873, NULL, 'IPR004609', NULL, 'ATP-dependent DNA helicase RecG', 'ATP-dep_DNA_helicase_RecG', 4, NULL),
(874, NULL, 'IPR000332', NULL, 'Beta 2 adrenoceptor', 'ADRB2_rcpt', 4, NULL),
(875, NULL, 'IPR004021', NULL, 'HIN-200/IF120x', 'HIN200/IF120x', 3, NULL),
(876, NULL, 'IPR004562', NULL, 'Lipoyltransferase/lipoate-protein ligase', 'LipoylTrfase_LipoateP_Ligase', 4, NULL),
(877, NULL, 'IPR000277', NULL, 'Cys/Met metabolism, pyridoxal phosphate-dependent enzyme', 'Cys/Met-Metab_PyrdxlP-dep_enz', 4, NULL),
(878, NULL, 'IPR004545', NULL, 'PA2G4 family', 'PA2G4', 4, NULL),
(879, NULL, 'IPR005491', NULL, 'ENT domain', 'ENT_dom', 3, NULL),
(880, NULL, 'IPR000301', NULL, 'Tetraspanin, animals', 'Tetraspanin_animals', 4, NULL),
(881, NULL, 'IPR002484', NULL, 'Arterivirus nucleocapsid', 'Arte_nucleocap', 4, NULL),
(882, NULL, 'IPR000275', NULL, 'Coagulin', 'Coagulin', 4, NULL),
(883, NULL, 'IPR004588', NULL, '4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase, bacterial-type', 'IspG_bac-typ', 4, NULL),
(884, NULL, 'IPR005016', NULL, 'Serine incorporator/TMS membrane protein', 'TDE1/TMS', 4, NULL),
(885, NULL, 'IPR002494', NULL, 'Keratin-associated protein', 'KAP', 4, NULL),
(886, NULL, 'IPR008220', NULL, 'Homoserine/serine acetyltransferase MetX-like', 'HAT_MetX-like', 4, NULL),
(887, NULL, 'IPR004557', NULL, 'Eukaryotic/archaeal PrmC-related', 'PrmC-related', 4, NULL),
(888, NULL, 'IPR004606', NULL, 'Molybdenum-pterin binding domain', 'Mop_domain', 3, NULL),
(889, NULL, 'IPR005452', NULL, 'Voltage-dependent calcium channel, L-type, alpha-1D subunit', 'LVDCC_a1dsu', 4, NULL),
(890, NULL, 'IPR005499', NULL, '6-carboxyhexanoate--CoA ligase', 'BioW', 4, NULL),
(891, NULL, 'IPR004997', NULL, 'Herpesvirus polymerase accessory protein', 'Herpes_PAP', 4, NULL),
(892, NULL, 'IPR002488', NULL, 'Geminivirus C4 protein', 'Gemini_C4', 4, NULL),
(893, NULL, 'IPR003096', NULL, 'Smooth muscle protein/calponin', 'SM22_calponin', 4, NULL),
(894, NULL, 'IPR009573', NULL, 'FeGP cofactor biosynthesis protein, methyltransferase HcgC', 'HcgC', 4, NULL),
(895, NULL, 'IPR003076', NULL, 'Peroxisome proliferator-activated receptor alpha', 'PPAR-alpha', 4, NULL),
(896, NULL, 'IPR004973', NULL, 'DNA-directed RNA polymerase, 18kDa subunit, poxviral', 'DNA-dir_RNA_pol_18kDa_poxviral', 4, NULL),
(897, NULL, 'IPR002501', NULL, 'Pseudouridine synthase II, N-terminal', 'PsdUridine_synth_N', 3, NULL),
(898, NULL, 'IPR009571', NULL, 'Membrane protein SUR7/Rim9-like, fungi', 'SUR7/Rim9-like_fungi', 4, NULL),
(899, NULL, 'IPR022835', NULL, 'Chaperone modulatory protein CbpM', 'CbpM', 4, NULL),
(900, NULL, 'IPR008243', NULL, 'Chorismate mutase, AroH class', 'Chorismate_mutase_AroH', 4, NULL),
(901, NULL, 'IPR007677', NULL, 'Gasdermin', 'Gasdermin', 4, NULL),
(902, NULL, 'IPR005474', NULL, 'Transketolase, N-terminal', 'Transketolase_N', 3, NULL),
(903, NULL, 'IPR004595', NULL, 'TFIIH C1-like domain', 'TFIIH_C1-like_dom', 3, NULL),
(904, NULL, 'IPR004995', NULL, 'Bacillus/Clostridium Ger spore germination protein', 'Spore_Ger', 4, NULL),
(905, NULL, 'IPR004576', NULL, 'Transcription-repair coupling factor', 'Mfd', 4, NULL),
(906, NULL, 'IPR023665', NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase, prokaryotes', 'ApgAM_prokaryotes', 4, NULL),
(907, NULL, 'IPR004038', NULL, 'Ribosomal protein L7Ae/L30e/S12e/Gadd45', 'Ribosomal_L7Ae/L30e/S12e/Gad45', 3, NULL),
(908, NULL, 'IPR004972', NULL, 'Major core protein 4b', 'P4B', 4, NULL),
(909, NULL, 'IPR004602', NULL, 'UvrABC system subunit A', 'UvrA', 4, NULL),
(910, NULL, 'IPR005484', NULL, 'Ribosomal protein L18', 'Ribosomal_L18', 4, NULL),
(911, NULL, 'IPR004027', NULL, 'SEC-C motif', 'SEC_C_motif', 2, NULL),
(912, NULL, 'IPR004025', NULL, 'Fungal ribotoxin', 'Fun_ribotoxin', 4, NULL),
(913, NULL, 'IPR002539', NULL, 'MaoC-like dehydratase domain', 'MaoC-like_dom', 3, NULL),
(914, NULL, 'IPR005004', NULL, 'Poxvirus C4/C10', 'Poxvirus_C4/C10', 4, NULL),
(915, NULL, 'IPR003071', NULL, 'Orphan nuclear receptor, HMR type', 'Nuc_orp_HMR_rcpt', 4, NULL),
(916, NULL, 'IPR034356', NULL, 'Slt11, RNA recognition motif', 'Slt11_RRM', 3, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(917, NULL, 'IPR002516', NULL, 'Glycosyl transferase, family 11', 'Glyco_trans_11', 4, NULL),
(918, NULL, 'IPR004543', NULL, 'Translation elongation factor EFG/EF2, archaeal', 'Transl_elong_EFG/EF2_arc', 4, NULL),
(919, NULL, 'IPR009577', NULL, 'Putative small multi-drug export', 'Sm_multidrug_ex', 4, NULL),
(920, NULL, 'IPR009575', NULL, 'Melon necrotic spot virus P7B', 'MNSV_P7B', 4, NULL),
(921, NULL, 'IPR001294', NULL, 'Phytochrome', 'Phytochrome', 4, NULL),
(922, NULL, 'IPR004600', NULL, 'TFIIH subunit Tfb4/GTF2H3', 'TFIIH_Tfb4/GTF2H3', 4, NULL),
(923, NULL, 'IPR000307', NULL, 'Ribosomal protein S16', 'Ribosomal_S16', 4, NULL),
(924, NULL, 'IPR005006', NULL, 'Poxvirus J1', 'Poxvirus_J1', 4, NULL),
(925, NULL, 'IPR004987', NULL, 'Protein of unknown function DUF272', 'DUF272', 4, NULL),
(926, NULL, 'IPR004004', NULL, 'Helicase/polymerase/peptidase polyprotein, Calicivirus-type', 'Helic/Pol/Pept_Calicivir-typ', 4, NULL),
(927, NULL, 'IPR000313', NULL, 'PWWP domain', 'PWWP_dom', 3, NULL),
(928, NULL, 'IPR003083', NULL, 'S-crystallin', 'S-crystallin', 4, NULL),
(929, NULL, 'IPR009570', NULL, 'Stage III sporulation protein AC', 'Spore_III_AC', 4, NULL),
(930, NULL, 'IPR004026', NULL, 'Ada DNA repair, metal-binding', 'Ada_DNA_repair_Zn-bd', 3, NULL),
(931, NULL, 'IPR009568', NULL, 'Protein of unknown function DUF1184', 'DUF1184', 4, NULL),
(932, NULL, 'IPR004061', NULL, 'Sphingosine 1-phosphate receptor', 'S1P_rcpt', 4, NULL),
(933, NULL, 'IPR003080', NULL, 'Glutathione S-transferase, alpha class', 'GST_alpha', 4, NULL),
(934, NULL, 'IPR003994', NULL, 'Ubiquitously expressed transcript protein UXT', 'UXT', 4, NULL),
(935, NULL, 'IPR004546', NULL, 'Restriction endonuclease, type I, methylase subunit', 'Restrct_endonuc_T1M', 4, NULL),
(936, NULL, 'IPR004983', NULL, 'Mlp lipoprotein', 'Mlp', 4, NULL),
(937, NULL, 'IPR004597', NULL, 'DNA-3-methyladenine glycosylase I', 'Tag', 4, NULL),
(938, NULL, 'IPR007181', NULL, 'Dihydroneopterin aldolase MtpD, C-terminal domain', 'MtpD_C', 3, NULL),
(939, NULL, 'IPR004605', NULL, 'DNA helicase, Holliday junction RuvB-type', 'DNA_helicase_Holl-junc_RuvB', 4, NULL),
(940, NULL, 'IPR005497', NULL, 'Cytochrome b6-f complex, subunit 8', 'Cytochrome_b6-f_cplx_su8', 4, NULL),
(941, NULL, 'IPR004544', NULL, 'Translation initiation factor aIF-2, archaea', 'TF_aIF-2_arc', 4, NULL),
(942, NULL, 'IPR005013', NULL, 'Dolichyl-diphosphooligosaccharide--protein glycosyltransferase 48kDa subunit', 'DDOST_48_kDa_subunit', 4, NULL),
(943, NULL, 'IPR002535', NULL, 'Flavivirus polyprotein propeptide', 'Flavi_propep', 3, NULL),
(944, NULL, 'IPR018113', NULL, 'Phosphotransferase system EIIB, cysteine phosphorylation site', 'PTrfase_EIIB_Cys', 2, NULL),
(945, NULL, 'IPR001229', NULL, 'Jacalin-like lectin domain', 'Jacalin-like_lectin_dom', 3, NULL),
(946, NULL, 'IPR001231', NULL, 'CD44 antigen', 'CD44_antigen', 4, NULL),
(947, NULL, 'IPR004048', NULL, 'Potassium channel, voltage dependent, Kv1.1', 'K_chnl_volt-dep_Kv1.1', 4, NULL),
(948, NULL, 'IPR003085', NULL, 'Acetoin utilization protein AcuC', 'AcuC', 4, NULL),
(949, NULL, 'IPR004005', NULL, 'Calicivirus coat protein', 'Calicivirus_coat', 3, NULL),
(950, NULL, 'IPR004030', NULL, 'Nitric oxide synthase, N-terminal', 'NOS_N', 3, NULL),
(951, NULL, 'IPR005493', NULL, 'Ribonuclease E inhibitor RraA/RraA-like protein', 'RraA/RraA-like', 4, NULL),
(952, NULL, 'IPR005455', NULL, 'Profilin', 'PFN', 4, NULL),
(953, NULL, 'IPR004975', NULL, 'Poxvirus VLTF2, trans-activator', 'Poxvirus_VLTF2', 4, NULL),
(954, NULL, 'IPR004556', NULL, 'Methyltransferase HemK-like', 'HemK-like', 4, NULL),
(955, NULL, 'IPR008225', NULL, 'Coenzyme F420:L-glutamate ligase', 'F420-0_g-glutamyl_ligase', 4, NULL),
(956, NULL, 'IPR008339', NULL, 'Dishevelled family', 'Dishevelled_fam', 4, NULL),
(957, NULL, 'IPR004607', NULL, 'Phosphoribosylglycinamide formyltransferase', 'GART', 4, NULL),
(958, NULL, 'IPR023673', NULL, 'Ribosomal protein L1, conserved site', 'Ribosomal_L1_CS', 2, NULL),
(959, NULL, 'IPR004974', NULL, 'RNA polymerase-associated transcription specificity factor Rap94', 'Pox_Rap94', 4, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(960, NULL, 'IPR005459', NULL, 'Transient receptor potential channel, canonical  3', 'TRPC3_channel', 4, NULL),
(961, NULL, 'IPR006591', NULL, 'RNA polymerase archaeal subunit P/eukaryotic subunit RPABC4', 'RNAP_P/RPABC4', 4, NULL),
(962, NULL, 'IPR000240', NULL, 'Serpin B9/maspin', 'Serpin_B9/Maspin', 4, NULL),
(963, NULL, 'IPR003048', NULL, 'P2X5 purinoceptor', 'P2X5_purnocptor', 4, NULL),
(964, NULL, 'IPR004046', NULL, 'Glutathione S-transferase, C-terminal', 'GST_C', 3, NULL),
(965, NULL, 'IPR004043', NULL, 'LCCL domain', 'LCCL', 3, NULL),
(966, NULL, 'IPR004062', NULL, 'EDG-3 sphingosine 1-phosphate receptor', 'EDG3_rcpt', 4, NULL),
(967, NULL, 'IPR004044', NULL, 'K Homology domain, type 2', 'KH_dom_type_2', 3, NULL),
(968, NULL, 'IPR004549', NULL, 'Acetyl-CoA carboxylase, biotin carboxylase', 'Acetyl_CoA_COase_biotin_COase', 4, NULL),
(969, NULL, 'IPR023672', NULL, 'Ribosomal protein L2, archaeal-type', 'Ribosomal_L2_arc', 4, NULL),
(970, NULL, 'IPR007185', NULL, 'DNA polymerase alpha/delta/epsilon, subunit B', 'DNA_pol_a/d/e_bsu', 3, NULL),
(971, NULL, 'IPR004603', NULL, 'DNA mismatch endonuclease VSR', 'DNA_mismatch_endonuc_vsr', 4, NULL),
(972, NULL, 'IPR004019', NULL, 'YLP motif', 'YLP_motif', 2, NULL),
(973, NULL, 'IPR008223', NULL, 'Urease, gamma-beta subunit', 'Urease_gamma-beta_su', 4, NULL),
(974, NULL, 'IPR002509', NULL, 'NodB homology domain', 'NODB_dom', 3, NULL),
(975, NULL, 'IPR024729', NULL, 'Ubiquitin carboxyl-terminal hydrolase 7, ICP0-binding domain', 'USP7_ICP0-binding_dom', 3, NULL),
(976, NULL, 'IPR002512', NULL, 'Rotavirus A/C, non-structural protein 5', 'Rotavirus_A/C_NSP5', 4, NULL),
(977, NULL, 'IPR004551', NULL, 'Diphthine synthase', 'Dphthn_synthase', 4, NULL),
(978, NULL, 'IPR004045', NULL, 'Glutathione S-transferase, N-terminal', 'Glutathione_S-Trfase_N', 3, NULL),
(979, NULL, 'IPR004007', NULL, 'DhaL domain', 'DhaL_dom', 3, NULL),
(980, NULL, 'IPR004041', NULL, 'NAF domain', 'NAF_dom', 3, NULL),
(981, NULL, 'IPR002530', NULL, 'Zein seed storage protein', 'Zein', 4, NULL),
(982, NULL, 'IPR003094', NULL, 'Fructose-2,6-bisphosphatase', '6Pfruct_kin', 4, NULL),
(983, NULL, 'IPR005500', NULL, 'Protein of unknown function DUF309', 'DUF309', 4, NULL),
(984, NULL, 'IPR004561', NULL, 'Isochorismate synthase', 'IsoChor_synthase', 4, NULL),
(985, NULL, 'IPR000327', NULL, 'POU-specific domain', 'POU_dom', 3, NULL),
(986, NULL, 'IPR005508', NULL, 'B3 domain-containing protein At2g31720-like', 'At2g31720-like', 4, NULL),
(987, NULL, 'IPR000229', NULL, 'Nucleocapsid protein, arenaviridae', 'Nucleocapsid_arenaviridae', 4, NULL),
(988, NULL, 'IPR005509', NULL, 'A-factor biosynthesis hotdog domain', 'AfsA_hotdog_dom', 3, NULL),
(989, NULL, 'IPR000281', NULL, 'Helix-turn-helix protein RpiR', 'HTH_RpiR', 3, NULL),
(990, NULL, 'IPR004036', NULL, 'Endonuclease III-like, conserved site-2', 'Endonuclease-III-like_CS2', 2, NULL),
(991, NULL, 'IPR002534', NULL, 'Hantavirus glycoprotein Gn', 'Hanta_Gn', 3, NULL),
(992, NULL, 'IPR005462', NULL, 'Transient receptor potential channel, canonical 6', 'TRPC6_channel', 4, NULL),
(993, NULL, 'IPR007680', NULL, 'Arabinofuranosyltransferase, central domain', 'Arabino_trans_central', 3, NULL),
(994, NULL, 'IPR002502', NULL, 'N-acetylmuramoyl-L-alanine amidase domain', 'Amidase_domain', 3, NULL),
(995, NULL, 'IPR003092', NULL, 'Two pore domain potassium channel, TASK family', '2pore_dom_K_chnl_TASK', 4, NULL),
(996, NULL, 'IPR004020', NULL, 'DAPIN domain', 'DAPIN', 3, NULL),
(997, NULL, 'IPR005471', NULL, 'Transcription regulator IclR, N-terminal', 'Tscrpt_reg_IclR_N', 3, NULL),
(998, NULL, 'IPR002518', NULL, 'Hepatitis C virus, Non-structural protein NS2', 'HCV_NS2', 3, NULL),
(999, NULL, 'IPR003610', NULL, 'Carbohydrate-binding module family 5/12', 'CBM_fam5/12', 3, NULL),
(1000, NULL, 'IPR003613', NULL, 'U-box domain', 'Ubox_domain', 3, NULL),
(1001, NULL, 'IPR007760', NULL, 'Manganese catalase', 'Mn_catalase', 4, NULL),
(1002, NULL, 'IPR006633', NULL, 'Carbohydrate-binding/sugar hydrolysis domain', 'Carb-bd_sugar_hydrolysis-dom', 3, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(1003, NULL, 'IPR002144', NULL, 'GPCR, family 2, secretin receptor', 'GPCR_2_secretin_rcpt', 4, NULL),
(1004, NULL, 'IPR006598', NULL, 'Glycosyl transferase CAP10 domain', 'CAP10', 3, NULL),
(1005, NULL, 'IPR005990', NULL, 'Inosine-5''-monophosphate dehydrogenase', 'IMP_DH', 4, NULL),
(1006, NULL, 'IPR007721', NULL, 'D-ribose pyranase RbsD/L-fucose mutarotase FucU', 'RbsD_FucU', 4, NULL),
(1007, NULL, 'IPR001257', NULL, 'Parvovirus non-structural protein 1, helicase domain', 'Parvovirus_NS1_helicase', 3, NULL),
(1008, NULL, 'IPR006635', NULL, 'NEAT domain', 'NEAT_dom', 3, NULL),
(1009, NULL, 'IPR007711', NULL, 'Toxin HigB-1', 'HigB-1', 4, NULL),
(1010, NULL, 'IPR001212', NULL, 'Somatomedin B domain', 'Somatomedin_B_dom', 3, NULL),
(1011, NULL, 'IPR007714', NULL, 'CFA20 domain', 'CFA20_dom', 3, NULL),
(1012, NULL, 'IPR003658', NULL, 'Anti-sigma factor antagonist', 'Anti-sigma_ant', 4, NULL),
(1013, NULL, 'IPR002052', NULL, 'DNA methylase, N-6 adenine-specific, conserved site', 'DNA_methylase_N6_adenine_CS', 2, NULL),
(1014, NULL, 'IPR007195', NULL, 'TolB, N-terminal', 'TolB_N', 3, NULL),
(1015, NULL, 'IPR034619', NULL, 'L-lyxonate dehydratase', 'L-lyxonate_dehydratase', 4, NULL),
(1016, NULL, 'IPR007197', NULL, 'Radical SAM', 'rSAM', 3, NULL),
(1017, NULL, 'IPR005030', NULL, 'Herpesvirus leader protein', 'Herpes_LP', 3, NULL),
(1018, NULL, 'IPR002104', NULL, 'Integrase, catalytic domain', 'Integrase_catalytic', 3, NULL),
(1019, NULL, 'IPR006603', NULL, 'PQ-loop repeat', 'PQ-loop_rpt', 7, NULL),
(1020, NULL, 'IPR001183', NULL, 'Muscarinic acetylcholine receptor M3', 'Musac_Ach_M3_rcpt', 4, NULL),
(1021, NULL, 'IPR006594', NULL, 'LIS1 homology motif', 'LisH', 3, NULL),
(1022, NULL, 'IPR005973', NULL, 'Nitrogenase MoFe cofactor biosynthesis protein NifE', 'NifE', 4, NULL),
(1023, NULL, 'IPR001038', NULL, 'Glycoprotein C/ glycoprotein A', 'GA_GC', 4, NULL),
(1024, NULL, 'IPR006005', NULL, 'Glutamate synthase, NADH/NADPH, small subunit 1', 'Glut_synth_ssu1', 4, NULL),
(1025, NULL, 'IPR034360', NULL, 'Vip1-like, RNA recognition motif, plant', 'Vip1-like_RRM_plant', 3, NULL),
(1026, NULL, 'IPR006599', NULL, 'CARP motif', 'CARP_motif', 3, NULL),
(1027, NULL, 'IPR006031', NULL, 'XYPPX repeat', 'XYPPX', 7, NULL),
(1028, NULL, 'IPR001171', NULL, 'Sterol biosynthesis ERG24/DHCR-like', 'ERG24_DHCR-like', 4, NULL),
(1029, NULL, 'IPR007203', NULL, 'ORMDL family', 'ORMDL', 4, NULL),
(1030, NULL, 'IPR002142', NULL, 'Peptidase S49', 'Peptidase_S49', 3, NULL),
(1031, NULL, 'IPR007731', NULL, 'Protein of unknown function DUF669', 'DUF669', 4, NULL),
(1032, NULL, 'IPR006600', NULL, 'HTH CenpB-type DNA-binding domain', 'HTH_CenpB_DNA-bd_dom', 3, NULL),
(1033, NULL, 'IPR001100', NULL, 'Pyridine nucleotide-disulphide oxidoreductase, class I', 'Pyr_nuc-diS_OxRdtase', 4, NULL),
(1034, NULL, 'IPR006629', NULL, 'LPS-induced tumour necrosis factor alpha factor', 'LITAF', 3, NULL),
(1035, NULL, 'IPR002069', NULL, 'Interferon gamma', 'Interferon_gamma', 4, NULL),
(1036, NULL, 'IPR007708', NULL, 'Lariat debranching enzyme, C-terminal', 'DBR1_C', 3, NULL),
(1037, NULL, 'IPR004485', NULL, 'Cobalamin biosynthesis CobD/CbiB', 'Cobalamin_biosynth_CobD/CbiB', 4, NULL),
(1038, NULL, 'IPR002132', NULL, 'Ribosomal protein L5', 'Ribosomal_L5', 4, NULL),
(1039, NULL, 'IPR005987', NULL, 'Ribonuclease T', 'RNase_T', 4, NULL),
(1040, NULL, 'IPR001151', NULL, 'G protein-coupled receptor 6', 'GPR6', 4, NULL),
(1041, NULL, 'IPR005979', NULL, 'Light-dependent protochlorophyllide reductase', 'Prochl_reduct', 4, NULL),
(1042, NULL, 'IPR001154', NULL, 'DNA topoisomerase II, eukaryotic-type', 'TopoII_euk', 4, NULL),
(1043, NULL, 'IPR007752', NULL, 'Virulence factor ActA', 'Virulence_actor_ActA', 4, NULL),
(1044, NULL, 'IPR004487', NULL, 'Clp protease, ATP-binding subunit ClpX', 'Clp_protease_ATP-bd_su_ClpX', 4, NULL),
(1045, NULL, 'IPR000227', NULL, 'Angiotensinogen', 'Angiotensinogen', 4, NULL),
(1046, NULL, 'IPR007715', NULL, 'Ubiquinone biosynthesis protein Coq4', 'Coq4', 4, NULL),
(1047, NULL, 'IPR001199', NULL, 'Cytochrome b5-like heme/steroid binding domain', 'Cyt_B5-like_heme/steroid-bd', 3, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(1048, NULL, 'IPR002183', NULL, 'Interleukin-3', 'IL-3', 4, NULL),
(1049, NULL, 'IPR003663', NULL, 'Sugar/inositol transporter', 'Sugar/inositol_transpt', 4, NULL),
(1050, NULL, 'IPR007716', NULL, 'NPL4, zinc-binding putative', 'NPL4_Zn-bd_put', 3, NULL),
(1051, NULL, 'IPR007767', NULL, 'Protein of unknown function DUF684', 'DUF684', 4, NULL),
(1052, NULL, 'IPR006015', NULL, 'Universal stress protein A family', 'Universal_stress_UspA', 4, NULL),
(1053, NULL, 'IPR001189', NULL, 'Manganese/iron superoxide dismutase', 'Mn/Fe_SOD', 4, NULL),
(1054, NULL, 'IPR006611', NULL, 'Protein of unknown function DUF1431, cysteine-rich, Drosophila', 'DUF1431_DROsp', 4, NULL),
(1055, NULL, 'IPR001039', NULL, 'MHC class I alpha chain, alpha1 alpha2 domains', 'MHC_I_a_a1/a2', 3, NULL),
(1056, NULL, 'IPR005029', NULL, 'Herpesvirus UL47', 'Herpes_UL47', 4, NULL),
(1057, NULL, 'IPR007188', NULL, 'Actin-related protein 2/3 complex subunit 2', 'ARPC2', 4, NULL),
(1058, NULL, 'IPR004494', NULL, 'MauM/NapG ferredoxin-type protein', 'MauM_NapG', 4, NULL),
(1059, NULL, 'IPR002098', NULL, 'Seminal vesicle protein I', 'SVP_I', 7, NULL),
(1060, NULL, 'IPR006597', NULL, 'Sel1-like repeat', 'Sel1-like', 7, NULL),
(1061, NULL, 'IPR005025', NULL, 'NADPH-dependent FMN reductase-like', 'FMN_Rdtase-like', 3, NULL),
(1062, NULL, 'IPR006650', NULL, 'Adenosine/AMP deaminase active site', 'A/AMP_deam_AS', 0, NULL),
(1063, NULL, 'IPR007208', NULL, 'Na(+)/H(+) antiporter subunit F-like', 'MrpF/PhaF-like', 4, NULL),
(1064, NULL, 'IPR007739', NULL, 'Rhamnan synthesis F', 'RgpF', 4, NULL),
(1065, NULL, 'IPR005980', NULL, 'Nitrogenase cofactor biosynthesis protein NifB', 'Nase_CF_NifB', 4, NULL),
(1066, NULL, 'IPR002054', NULL, 'DNA-directed DNA polymerase X', 'DNA-dir_DNA_pol_X', 3, NULL),
(1067, NULL, 'IPR001218', NULL, 'Nucleocapsid protein, coronavirus', 'Nucleocap_CoV', 4, NULL),
(1068, NULL, 'IPR007202', NULL, '4Fe-4S domain', '4Fe-4S_dom', 3, NULL),
(1069, NULL, 'IPR001098', NULL, 'DNA-directed DNA polymerase, family A, palm domain', 'DNA-dir_DNA_pol_A_palm_dom', 3, NULL),
(1070, NULL, 'IPR003675', NULL, 'Type II CAAX prenyl endopeptidase Rce1-like', 'Rce1-like', 4, NULL),
(1071, NULL, 'IPR006011', NULL, 'Syntaxin, N-terminal domain', 'Syntaxin_N', 3, NULL),
(1072, NULL, 'IPR034359', NULL, 'MTHFSD, RNA recognition motif', 'MTHFSD_RRM', 3, NULL),
(1073, NULL, 'IPR003671', NULL, 'Spindlin/spermiogenesis-specific protein', 'SPIN/Ssty', 4, NULL),
(1074, NULL, 'IPR017954', NULL, 'Lipid-binding serum glycoprotein, conserved site', 'Lipid-bd_serum_glycop_CS', 2, NULL),
(1075, NULL, 'IPR006024', NULL, 'Opioid neuropeptide precursor', 'Opioid_neupept', 4, NULL),
(1076, NULL, 'IPR007757', NULL, 'MT-A70-like', 'MT-A70-like', 4, NULL),
(1077, NULL, 'IPR003680', NULL, 'Flavodoxin-like fold', 'Flavodoxin_fold', 3, NULL),
(1078, NULL, 'IPR007733', NULL, 'Agouti', 'Agouti', 4, NULL),
(1079, NULL, 'IPR001117', NULL, 'Multicopper oxidase, second cupredoxin domain', 'Cu-oxidase_2nd', 3, NULL),
(1080, NULL, 'IPR006621', NULL, 'Nose resistant-to-fluoxetine protein, N-terminal', 'Nose-resist-to-fluoxetine_N', 3, NULL),
(1081, NULL, 'IPR006653', NULL, 'Tryptophan synthase, beta chain, conserved site', 'Trp_synth_b_CS', 2, NULL),
(1082, NULL, 'IPR003661', NULL, 'Signal transduction histidine kinase, dimerisation/phosphoacceptor domain', 'HisK_dim/P', 3, NULL),
(1083, NULL, 'IPR007204', NULL, 'Actin-related protein 2/3 complex subunit 3', 'ARPC3', 4, NULL),
(1084, NULL, 'IPR002139', NULL, 'Ribokinase/fructokinase', 'Ribo/fructo_kinase', 4, NULL),
(1085, NULL, 'IPR005975', NULL, 'Nitrogenase molybdenum-iron cofactor biosynthesis protein', 'Nase_Mo-Fe_CF', 4, NULL),
(1086, NULL, 'IPR006032', NULL, 'Ribosomal protein S12/S23', 'Ribosomal_S12/S23', 4, NULL),
(1087, NULL, 'IPR007764', NULL, 'Herpesvirus UL43', 'Herpes_UL43', 4, NULL),
(1088, NULL, 'IPR001208', NULL, 'MCM domain', 'MCM_dom', 3, NULL),
(1089, NULL, 'IPR003678', NULL, 'Putative outer membrane protein', 'Put_OMP', 4, NULL),
(1090, NULL, 'IPR006628', NULL, 'Purine-rich element binding protein family', 'PUR-bd_fam', 4, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(1091, NULL, 'IPR006656', NULL, 'Molybdopterin oxidoreductase', 'Mopterin_OxRdtase', 3, NULL),
(1092, NULL, 'IPR000249', NULL, 'Bacterial microcompartment domain', 'BMC_dom', 3, NULL),
(1093, NULL, 'IPR005027', NULL, 'Glycosyl transferase, family 43', 'Glyco_trans_43', 4, NULL),
(1094, NULL, 'IPR002123', NULL, 'Phospholipid/glycerol acyltransferase', 'Plipid/glycerol_acylTrfase', 3, NULL),
(1095, NULL, 'IPR002080', NULL, 'Seminal vesicle protein II, conserved site', 'SVP_II_CS', 2, NULL),
(1096, NULL, 'IPR001203', NULL, 'Aldehyde ferredoxin oxidoreductase, C-terminal', 'OxRdtase_Ald_Fedxn_C', 3, NULL),
(1097, NULL, 'IPR007201', NULL, 'Mei2-like, C-terminal RNA recognition motif', 'Mei2-like_Rrm_C', 3, NULL),
(1098, NULL, 'IPR001194', NULL, 'cDENN domain', 'cDENN_dom', 3, NULL),
(1099, NULL, 'IPR007778', NULL, 'Dictyostelium REP', 'Dict_REP', 4, NULL),
(1100, NULL, 'IPR002073', NULL, '3''5''-cyclic nucleotide phosphodiesterase, catalytic domain', 'PDEase_catalytic_dom', 3, NULL),
(1101, NULL, 'IPR002071', NULL, 'Thermonuclease active site', 'Thermonucl_AS', 0, NULL),
(1102, NULL, 'IPR006658', NULL, 'Molybdopterin guanine dinucleotide-containing S/N-oxide reductase', 'BisC', 4, NULL),
(1103, NULL, 'IPR007687', NULL, 'Methyl-coenzyme M reductase, protein C', 'Me_CoM_Rdtase_prot-C', 4, NULL),
(1104, NULL, 'IPR002063', NULL, 'Haemerythrin', 'Haemerythrin', 4, NULL),
(1105, NULL, 'IPR000196', NULL, 'Ribosomal protein L19/L19e', 'Ribosomal_L19/L19e', 3, NULL),
(1106, NULL, 'IPR001165', NULL, 'T4-type lysozyme', 'T4-type_lysozyme', 4, NULL),
(1107, NULL, 'IPR007209', NULL, 'RNase L inhibitor RLI-like, possible metal-binding domain', 'RNaseL-inhib-like_metal-bd_dom', 3, NULL),
(1108, NULL, 'IPR007191', NULL, 'Exocyst complex component Sec8, N-terminal', 'Sec8_exocyst_N', 3, NULL),
(1109, NULL, 'IPR001163', NULL, 'LSM domain, eukaryotic/archaea-type', 'LSM_dom_euk/arc', 3, NULL),
(1110, NULL, 'IPR003101', NULL, 'Coactivator CBP, KIX domain', 'KIX_dom', 3, NULL),
(1111, NULL, 'IPR007712', NULL, 'Toxin-antitoxin system, RelE/ParE toxin family', 'RelE/ParE_toxin', 4, NULL),
(1112, NULL, 'IPR002116', NULL, 'Melittin/ Api allergen', 'Melittin/Api_allergen', 4, NULL),
(1113, NULL, 'IPR006637', NULL, 'Clostridial hydrophobic repeat', 'ChW', 7, NULL),
(1114, NULL, 'IPR001180', NULL, 'Citron homology (CNH) domain', 'CNH_dom', 3, NULL),
(1115, NULL, 'IPR005983', NULL, 'Potassium channel, voltage-dependent, beta subunit, KCNAB', 'K_chnl_volt-dep_bsu_KCNAB', 4, NULL),
(1116, NULL, 'IPR001123', NULL, 'Amino acid exporter protein, LeuE-type', 'LeuE-type', 4, NULL),
(1117, NULL, 'IPR005994', NULL, 'Guanosine monophosphate reductase, type2', 'GuaC_type_2', 4, NULL),
(1118, NULL, 'IPR006027', NULL, 'NusB/RsmB/TIM44', 'NusB_RsmB_TIM44', 3, NULL),
(1119, NULL, 'IPR001259', NULL, 'Proteinase inhibitor I27, calpastatin', 'Prot_inh_calpain', 7, NULL),
(1120, NULL, 'IPR001164', NULL, 'Arf GTPase activating protein', 'ArfGAP_dom', 3, NULL),
(1121, NULL, 'IPR007756', NULL, 'RICH domain', 'RICH', 3, NULL),
(1122, NULL, 'IPR006019', NULL, 'Phosphotyrosine interaction  domain, Shc-like', 'PID_Shc-like', 3, NULL),
(1123, NULL, 'IPR034357', NULL, 'Yra1/Mlo3, RNA recognition motif', 'Yra1/Mlo3_RRM', 3, NULL),
(1124, NULL, 'IPR006631', NULL, 'Protein of unknown function DM4/12', 'DM4_12', 4, NULL),
(1125, NULL, 'IPR007750', NULL, 'Protein of unknown function DUF674', 'DUF674', 4, NULL),
(1126, NULL, 'IPR002141', NULL, 'Influenza virus nucleoprotein (NP)', 'Flu_NP', 4, NULL),
(1127, NULL, 'IPR001261', NULL, 'ArgE/DapE/ACY1/CPG2/YscS, conserved site', 'ArgE/DapE_CS', 2, NULL),
(1128, NULL, 'IPR002152', NULL, 'Glycoside hydrolase, family 23', 'Glyco_hydro_23', 4, NULL),
(1129, NULL, 'IPR007686', NULL, 'YutG/PgpA domain', 'YutG/PgpA', 3, NULL),
(1130, NULL, 'IPR002134', NULL, 'Histidine-rich calcium-binding repeat', 'His-rich_Ca-bd_rpt', 7, NULL),
(1131, NULL, 'IPR006626', NULL, 'Parallel beta-helix repeat', 'PbH1', 7, NULL),
(1132, NULL, 'IPR034397', NULL, 'Prp24, RNA recognition motif1', 'Prp24_RRM1', 3, NULL),
(1133, NULL, 'IPR007704', NULL, 'GPI mannosyltransferase 1', 'PIG-M', 4, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(1134, NULL, 'IPR005970', NULL, 'Light-independent protochlorophyllide reductase, N subunit', 'Protochl_reductN', 4, NULL),
(1135, NULL, 'IPR001226', NULL, 'Flavodoxin, conserved site', 'Flavodoxin_CS', 2, NULL),
(1136, NULL, 'IPR006593', NULL, 'Cytochrome b561/ferric reductase transmembrane', 'Cyt_b561/ferric_Rdtase_TM', 3, NULL),
(1137, NULL, 'IPR006008', NULL, 'Inner membrane-spanning protein YciB', 'YciB', 4, NULL),
(1138, NULL, 'IPR003626', NULL, 'Parathyroid hormone-related protein', 'PTH-rel', 4, NULL),
(1139, NULL, 'IPR005982', NULL, 'Thioredoxin reductase', 'Thioredox_Rdtase', 4, NULL),
(1140, NULL, 'IPR007777', NULL, 'Protein of unknown function DUF685', 'DUF685', 4, NULL),
(1141, NULL, 'IPR005020', NULL, 'Protein LIN-8', 'LIN-8', 4, NULL),
(1142, NULL, 'IPR007772', NULL, 'Beak and feather disease virus (BFDV), Orf5', 'BFDV_Orf5', 4, NULL),
(1143, NULL, 'IPR007706', NULL, 'Epstein-Barr virus nuclear antigen 3/4/6', 'EBNA-3/4/6', 4, NULL),
(1144, NULL, 'IPR007722', NULL, 'mRNA decapping protein 2, Box A domain', 'DCP2_BoxA', 3, NULL),
(1145, NULL, 'IPR007754', NULL, 'N-acetylglucosaminyltransferase II', 'GlcNAc_II', 4, NULL),
(1146, NULL, 'IPR007741', NULL, 'Ribosomal protein/NADH dehydrogenase domain', 'Ribosome/NADH_DH', 3, NULL),
(1147, NULL, 'IPR007743', NULL, 'Immunity-related GTPases-like', 'Immunity-related_GTPase-like', 4, NULL),
(1148, NULL, 'IPR007561', NULL, 'Cell division protein SepF/SepF-related', 'Cell_div_SepF/SepF-rel', 4, NULL),
(1149, NULL, 'IPR001031', NULL, 'Thioesterase', 'Thioesterase', 3, NULL),
(1150, NULL, 'IPR002146', NULL, 'ATP synthase, F0 complex, subunit b/b'', bacterial/chloroplast', 'ATP_synth_b/b''su_bac/chlpt', 4, NULL),
(1151, NULL, 'IPR006003', NULL, 'FGGY carbohydrate kinase, pentulose kinase', 'FGGY_RbtK-like', 4, NULL),
(1152, NULL, 'IPR002077', NULL, 'Voltage-dependent calcium channel, alpha-1 subunit', 'VDCCAlpha1', 4, NULL),
(1153, NULL, 'IPR001137', NULL, 'Glycoside hydrolase family 11', 'Glyco_hydro_11', 4, NULL),
(1154, NULL, 'IPR001072', NULL, 'RNA ligase, Pab1020 family', 'RNA_ligase_Pab1020', 4, NULL),
(1155, NULL, 'IPR007732', NULL, 'Cytochrome b558 alpha-subunit', 'Cyt_b558_asu', 4, NULL),
(1156, NULL, 'IPR003654', NULL, 'OAR domain', 'OAR_dom', 3, NULL),
(1157, NULL, 'IPR006614', NULL, 'Peroxin/Ferlin domain', 'Peroxin/Ferlin', 3, NULL),
(1158, NULL, 'IPR003100', NULL, 'PAZ domain', 'PAZ_dom', 3, NULL),
(1159, NULL, 'IPR006639', NULL, 'Presenilin/signal peptide peptidase', 'Preselin/SPP', 4, NULL),
(1160, NULL, 'IPR007748', NULL, 'Autographa californica nuclear polyhedrosis virus (AcMNPV), Orf109', 'AcMNPV_Orf109', 4, NULL),
(1161, NULL, 'IPR007726', NULL, 'SS18, N-terminal', 'SS18_N', 3, NULL),
(1162, NULL, 'IPR001096', NULL, 'Peptidase C13, legumain', 'Peptidase_C13', 4, NULL),
(1163, NULL, 'IPR001623', NULL, 'DnaJ domain', 'DnaJ_domain', 3, NULL),
(1164, NULL, 'IPR006606', NULL, 'Bardet-Biedl syndrome 5 protein', 'BBL5', 4, NULL),
(1165, NULL, 'IPR006013', NULL, 'Antifreeze, type III', 'Antifreeze_III', 4, NULL),
(1166, NULL, 'IPR004483', NULL, 'Helicase SMUBP-2/Hcs1-like', 'SMUBP-2/Hcs1-like', 4, NULL),
(1167, NULL, 'IPR001133', NULL, 'NADH-ubiquinone oxidoreductase chain 4L/K', 'NADH_UbQ_OxRdtase_chain4L/K', 4, NULL),
(1168, NULL, 'IPR006615', NULL, 'Peptidase C19, ubiquitin-specific peptidase, DUSP domain', 'Pept_C19_DUSP', 3, NULL),
(1169, NULL, 'IPR006028', NULL, 'Gamma-aminobutyric acid A receptor/Glycine receptor alpha', 'GABAA/Glycine_rcpt', 4, NULL),
(1170, NULL, 'IPR005978', NULL, 'Nodulation ABC transporter, NodI', 'ABC_transptNodI', 4, NULL),
(1171, NULL, 'IPR001217', NULL, 'Transcription factor STAT', 'STAT', 4, NULL),
(1172, NULL, 'IPR007713', NULL, 'TMP repeat', 'TMP_rpt', 7, NULL),
(1173, NULL, 'IPR001193', NULL, 'Membrane-bound transcription factor site-2 protease', 'MBTPS2', 4, NULL),
(1174, NULL, 'IPR007779', NULL, 'Rotavirus VP2', 'Rotavirus_VP2', 4, NULL),
(1175, NULL, 'IPR000192', NULL, 'Aminotransferase class V domain', 'Aminotrans_V_dom', 3, NULL),
(1176, NULL, 'IPR006640', NULL, 'SprT-like', 'SprT-like_domain', 3, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(1177, NULL, 'IPR000228', NULL, 'RNA 3''-terminal phosphate cyclase', 'RNA3''_term_phos_cyc', 4, NULL),
(1178, NULL, 'IPR006012', NULL, 'Syntaxin/epimorphin, conserved site', 'Syntaxin/epimorphin_CS', 2, NULL),
(1179, NULL, 'IPR001141', NULL, 'Ribosomal protein L27e', 'Ribosomal_L27e', 4, NULL),
(1180, NULL, 'IPR006608', NULL, 'Domain of unknown function DM14', 'DM14', 3, NULL),
(1181, NULL, 'IPR002112', NULL, 'Transcription factor Jun', 'Leuzip_Jun', 4, NULL),
(1182, NULL, 'IPR002095', NULL, 'Monellin, B chain', 'Monellin_B', 4, NULL),
(1183, NULL, 'IPR000209', NULL, 'Peptidase S8/S53 domain', 'Peptidase_S8/S53_dom', 3, NULL),
(1184, NULL, 'IPR003673', NULL, 'CoA-transferase family III', 'CoA-Trfase_fam_III', 4, NULL),
(1185, NULL, 'IPR004495', NULL, 'Methionyl-tRNA synthetase, beta subunit, C-terminal', 'Met-tRNA-synth_bsu_C', 3, NULL),
(1186, NULL, 'IPR001184', NULL, 'Somatostatin receptor 5', 'Somatstn_rcpt_5', 4, NULL),
(1187, NULL, 'IPR007728', NULL, 'Pre-SET domain', 'Pre-SET_dom', 3, NULL),
(1188, NULL, 'IPR003679', NULL, 'Aminoglycoside N(3)-acetyltransferase', 'Amioglycoside_AcTrfase', 4, NULL),
(1189, NULL, 'IPR001077', NULL, 'O-methyltransferase domain', 'O_MeTrfase_dom', 3, NULL),
(1190, NULL, 'IPR007749', NULL, 'Protein of unknown function DUF677', 'DUF677', 4, NULL),
(1191, NULL, 'IPR003677', NULL, 'SXP/RAL-2 family protein Ani s 5-like, cation-binding domain', 'ANIS5_cation-bd', 3, NULL),
(1192, NULL, 'IPR006610', NULL, 'Domain of unknown function DM7', 'DM7', 3, NULL),
(1193, NULL, 'IPR007755', NULL, 'Poxvirus A11', 'Poxvirus_A11', 4, NULL),
(1194, NULL, 'IPR006000', NULL, 'Xylulokinase', 'Xylulokinase', 4, NULL),
(1195, NULL, 'IPR005981', NULL, 'ABC-2 type transporter, NodJ', 'ABC_transptNodJ', 4, NULL),
(1196, NULL, 'IPR003669', NULL, 'Thymidylate synthase ThyX', 'Thymidylate_synthase_ThyX', 4, NULL),
(1197, NULL, 'IPR006638', NULL, 'Elp3/MiaA/NifB-like, radical SAM core domain', 'Elp3/MiaA/NifB-like_rSAM', 3, NULL),
(1198, NULL, 'IPR005031', NULL, 'Coenzyme Q-binding protein COQ10, START domain', 'COQ10_START', 3, NULL),
(1199, NULL, 'IPR005017', NULL, 'Outer membrane protein transport protein (OMPP1/FadL/TodX)', 'OMPP1/FadL/TodX', 4, NULL),
(1200, NULL, 'IPR002100', NULL, 'Transcription factor, MADS-box', 'TF_MADSbox', 3, NULL),
(1201, NULL, 'IPR001065', NULL, 'Muscarinic acetylcholine receptor M2', 'Musac_Ach_M2_rcpt', 4, NULL),
(1202, NULL, 'IPR005033', NULL, 'YEATS', 'YEATS', 4, NULL),
(1203, NULL, 'IPR001128', NULL, 'Cytochrome P450', 'Cyt_P450', 4, NULL),
(1204, NULL, 'IPR001173', NULL, 'Glycosyltransferase 2-like', 'Glyco_trans_2-like', 3, NULL),
(1205, NULL, 'IPR007196', NULL, 'CCR4-Not complex component, Not1, C-terminal', 'CCR4-Not_Not1_C', 3, NULL),
(1206, NULL, 'IPR006654', NULL, 'Tryptophan synthase, beta chain', 'Trp_synth_beta', 4, NULL),
(1207, NULL, 'IPR006655', NULL, 'Molybdopterin oxidoreductase, prokaryotic, conserved site', 'Mopterin_OxRdtase_prok_CS', 2, NULL),
(1208, NULL, 'IPR006018', NULL, 'Caldesmon/lymphocyte specific protein', 'Caldesmon_LSP', 4, NULL),
(1209, NULL, 'IPR007763', NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 12', 'NDUFA12', 4, NULL),
(1210, NULL, 'IPR006636', NULL, 'Heat shock chaperonin-binding', 'STI1_HS-bd', 3, NULL),
(1211, NULL, 'IPR001178', NULL, 'Pesticidal crystal protein, central domain', 'Pest_cryst_cen_dom', 3, NULL),
(1212, NULL, 'IPR005018', NULL, 'DOMON domain', 'DOMON_domain', 3, NULL),
(1213, NULL, 'IPR002185', NULL, 'Dopamine D4 receptor', 'Dopamine_D4_rcpt', 4, NULL),
(1214, NULL, 'IPR007717', NULL, 'Nuclear pore localisation protein NPL4, C-terminal', 'NPL4_C', 3, NULL),
(1215, NULL, 'IPR002147', NULL, '5-Hydroxytryptamine 1B receptor', '5HT1B_rcpt', 4, NULL),
(1216, NULL, 'IPR002075', NULL, 'Nuclear transport factor 2 domain', 'NTF2_dom', 3, NULL),
(1217, NULL, 'IPR007562', NULL, 'Transglutaminase-like domain', 'Transglutaminase-like_domain', 3, NULL),
(1218, NULL, 'IPR006607', NULL, 'Protein of unknown function DM15', 'DM15', 7, NULL),
(1219, NULL, 'IPR001025', NULL, 'Bromo adjacent homology (BAH) domain', 'BAH_dom', 3, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(1220, NULL, 'IPR007707', NULL, 'Transforming acidic coiled-coil-containing protein, C-terminal', 'TACC_C', 3, NULL),
(1221, NULL, 'IPR000204', NULL, 'Orexin receptor family', 'Orexin_rcpt', 4, NULL),
(1222, NULL, 'IPR003635', NULL, 'Neurokinin-B/Tachykinin-3', 'Neurokinin-B/TAC3', 4, NULL),
(1223, NULL, 'IPR034539', NULL, 'ACF, RNA recognition motif 3', 'ACF_RRM3', 3, NULL),
(1224, NULL, 'IPR034620', NULL, 'cis-3-Hydroxy-L-proline dehydratase', 'Cis-3-h-L-Pro_dehydratase', 4, NULL),
(1225, NULL, 'IPR005022', NULL, 'Viral trans-activator protein', 'Pox_TAP', 4, NULL),
(1226, NULL, 'IPR007689', NULL, 'A-alpha-Y mating type-dependent binding domain', 'AalphaY_mating_typ-dep-bd-dom', 3, NULL),
(1227, NULL, 'IPR007709', NULL, 'N-formylglutamate amidohydrolase', 'N-FG_amidohydro', 4, NULL),
(1228, NULL, 'IPR003657', NULL, 'WRKY domain', 'WRKY_dom', 3, NULL),
(1229, NULL, 'IPR001111', NULL, 'TGF-beta, propeptide', 'TGF-b_propeptide', 3, NULL),
(1230, NULL, 'IPR034362', NULL, 'PHIP1, RNA recognition motif 2', 'PHIP1_RRM2', 3, NULL),
(1231, NULL, 'IPR001213', NULL, 'Mouse mammary tumour virus superantigen', 'MMTV_SAg', 4, NULL),
(1232, NULL, 'IPR001179', NULL, 'FKBP-type peptidyl-prolyl cis-trans isomerase domain', 'PPIase_FKBP_dom', 3, NULL),
(1233, NULL, 'IPR007774', NULL, 'Putative nitrogen fixation protein', 'Put_N_fixation', 4, NULL),
(1234, NULL, 'IPR005986', NULL, 'Aspartate-semialdehyde dehydrogenase, beta-type', 'Asp_semialdehyde_DH_beta', 4, NULL),
(1235, NULL, 'IPR005999', NULL, 'Glycerol kinase', 'Glycerol_kin', 4, NULL),
(1236, NULL, 'IPR001188', NULL, 'Spermidine/putrescine-binding periplasmic protein', 'Sperm_putr-bd', 4, NULL),
(1237, NULL, 'IPR006623', NULL, 'Testicular haploid expressed repeat', 'THEG', 7, NULL),
(1238, NULL, 'IPR006620', NULL, 'Prolyl 4-hydroxylase, alpha subunit', 'Pro_4_hyd_alph', 3, NULL),
(1239, NULL, 'IPR003309', NULL, 'SCAN domain', 'SCAN_dom', 3, NULL),
(1240, NULL, 'IPR003073', NULL, 'Orphan nuclear receptor, NURR type', 'NURR_rcpt', 4, NULL),
(1241, NULL, 'IPR006007', NULL, 'Inorganic carbon transporter', 'Inorganic_carbon_transpt', 4, NULL),
(1242, NULL, 'IPR024617', NULL, 'Domain of unknown function DUF3870', 'DUF3870', 3, NULL),
(1243, NULL, 'IPR001182', NULL, 'Probable peptidoglycan glycosyltransferase FtsW/RodA', 'FtsW/RodA', 4, NULL),
(1244, NULL, 'IPR001040', NULL, 'Translation Initiation factor eIF- 4e', 'TIF_eIF_4E', 4, NULL),
(1245, NULL, 'IPR002081', NULL, 'Cryptochrome/DNA photolyase class 1', 'Cryptochrome/DNA_photolyase_1', 4, NULL),
(1246, NULL, 'IPR001126', NULL, 'UmuC domain', 'UmuC', 3, NULL),
(1247, NULL, 'IPR006644', NULL, 'Dystroglycan-type cadherin-like', 'Cadg', 3, NULL),
(1248, NULL, 'IPR001191', NULL, 'Geminivirus AL1, replication-associated protein', 'Gemini_AL1_REP', 4, NULL),
(1249, NULL, 'IPR007699', NULL, 'SGS domain', 'SGS_dom', 3, NULL),
(1250, NULL, 'IPR001070', NULL, 'Polyomavirus coat protein VP2', 'Polyoma_coat_VP2', 4, NULL),
(1251, NULL, 'IPR002082', NULL, 'Aspartate carbamoyltransferase', 'Asp_carbamoyltransf', 4, NULL),
(1252, NULL, 'IPR000257', NULL, 'Uroporphyrinogen decarboxylase (URO-D)', 'Uroporphyrinogen_deCOase', 3, NULL),
(1253, NULL, 'IPR001034', NULL, 'DeoR-type HTH domain', 'DeoR_HTH', 3, NULL),
(1254, NULL, 'IPR001129', NULL, 'Membrane-associated, eicosanoid/glutathione metabolism (MAPEG) protein', 'Membr-assoc_MAPEG', 4, NULL),
(1255, NULL, 'IPR005992', NULL, 'IMP dehydrogenase-related 2', 'IMP_DH-rel2', 4, NULL),
(1256, NULL, 'IPR001196', NULL, 'Ribosomal protein L15, conserved site', 'Ribosomal_L15_CS', 2, NULL),
(1257, NULL, 'IPR005984', NULL, 'Phospholamban', 'PLB', 4, NULL),
(1258, NULL, 'IPR007771', NULL, 'Protein of unknown function DUF680', 'DUF680', 4, NULL),
(1259, NULL, 'IPR002061', NULL, 'Scorpion long chain toxin/defensin', 'Scorpion_toxinL/defensin', 4, NULL),
(1260, NULL, 'IPR003105', NULL, 'SRA-YDG', 'SRA_YDG', 3, NULL),
(1261, NULL, 'IPR007698', NULL, 'Alanine dehydrogenase/pyridine nucleotide transhydrogenase, NAD(H)-binding domain', 'AlaDH/PNT_NAD(H)-bd', 3, NULL),
(1262, NULL, 'IPR002126', NULL, 'Cadherin-like', 'Cadherin-like_dom', 3, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(1263, NULL, 'IPR002087', NULL, 'Anti-proliferative protein', 'Anti_prolifrtn', 3, NULL),
(1264, NULL, 'IPR000261', NULL, 'EH domain', 'EH_dom', 3, NULL),
(1265, NULL, 'IPR001161', NULL, 'Helicase XPB/Ssl2', 'XPB/Ssl2', 4, NULL),
(1266, NULL, 'IPR006009', NULL, 'N-acetylglucosaminyltransferase, MurG', 'GlcNAc_MurG', 4, NULL),
(1267, NULL, 'IPR007705', NULL, 'Vesicle transport v-SNARE, N-terminal', 'Vesicle_trsprt_v-SNARE_N', 3, NULL),
(1268, NULL, 'IPR006630', NULL, 'La-type HTH domain', 'La_HTH', 3, NULL),
(1269, NULL, 'IPR002113', NULL, 'ADP/ATP carrier protein, eukaryotic type', 'ADT_euk_type', 4, NULL),
(1270, NULL, 'IPR005021', NULL, 'Terminase large subunit-like', 'Terminase_largesu-like', 4, NULL),
(1271, NULL, 'IPR034396', NULL, 'Yra2, RNA recognition motif', 'Yra2_RRM', 3, NULL),
(1272, NULL, 'IPR003666', NULL, 'Photosystem I PsaF, reaction centre subunit III', 'PSI_PsaF', 4, NULL),
(1273, NULL, 'IPR002186', NULL, 'Neocarzinostatin family', 'Neocarzinostatin_fam', 4, NULL),
(1274, NULL, 'IPR002044', NULL, 'Carbohydrate binding module family 20', 'CBM_fam20', 3, NULL),
(1275, NULL, 'IPR001158', NULL, 'DIX domain', 'DIX', 3, NULL),
(1276, NULL, 'IPR001153', NULL, 'Barwin domain', 'Barwin_dom', 3, NULL),
(1277, NULL, 'IPR001162', NULL, 'UvrC, RNAse H endonuclease domain', 'UvrC_RNase_H_dom', 3, NULL),
(1278, NULL, 'IPR001037', NULL, 'Integrase, C-terminal, retroviral', 'Integrase_C_retrovir', 3, NULL),
(1279, NULL, 'IPR005968', NULL, 'Thiamine ABC transporter, ATP-binding protein ThiQ', 'Thiamine_ABC_ThiQ', 4, NULL),
(1280, NULL, 'IPR006002', NULL, 'Gluconate kinase', 'Gluconate_kinase', 4, NULL),
(1281, NULL, 'IPR006026', NULL, 'Peptidase, metallopeptidase', 'Peptidase_Metallo', 3, NULL),
(1282, NULL, 'IPR001109', NULL, 'Hydrogenase expression/formation protein, HupF/HypC', 'Hydrogenase_HupF/HypC', 4, NULL),
(1283, NULL, 'IPR007718', NULL, 'Srp40, C-terminal', 'Srp40_C', 3, NULL),
(1284, NULL, 'IPR005976', NULL, 'Nitrogenase molybdenum-iron protein beta chain', 'Nase_Mo-Fe_CF_bsu', 4, NULL),
(1285, NULL, 'IPR001202', NULL, 'WW domain', 'WW_dom', 3, NULL),
(1286, NULL, 'IPR001075', NULL, 'NIF system FeS cluster assembly, NifU, C-terminal', 'NIF_FeS_clus_asmbl_NifU_C', 3, NULL),
(1287, NULL, 'IPR001054', NULL, 'Adenylyl cyclase class-3/4/guanylyl cyclase', 'A/G_cyclase', 3, NULL),
(1288, NULL, 'IPR006612', NULL, 'THAP-type zinc finger', 'THAP_Znf', 3, NULL),
(1289, NULL, 'IPR005985', NULL, 'Bacteriocin transport accessory protein', 'PedC_BrcD', 4, NULL),
(1290, NULL, 'IPR007702', NULL, 'Janus', 'Janus', 4, NULL),
(1291, NULL, 'IPR003647', NULL, 'Intron encoded nuclease repeat', 'Intron_nuc_1_rpt', 7, NULL),
(1292, NULL, 'IPR007734', NULL, 'Heparan sulphate 2-O-sulfotransferase', 'Heparan_SO4_2-O-STrfase', 4, NULL),
(1293, NULL, 'IPR004489', NULL, 'Succinate dehydrogenase/fumarate reductase iron-sulphur protein', 'Succ_DH/fum_Rdtase_Fe-S', 4, NULL),
(1294, NULL, 'IPR002051', NULL, 'Haem oxygenase', 'Haem_Oase', 4, NULL),
(1295, NULL, 'IPR007737', NULL, 'Mga helix-turn-helix domain', 'Mga_HTH', 3, NULL),
(1296, NULL, 'IPR001205', NULL, 'RNA-directed RNA polymerase,  C-terminal domain', 'RNA-dir_pol_C', 3, NULL),
(1297, NULL, 'IPR006029', NULL, 'Neurotransmitter-gated ion-channel transmembrane domain', 'Neurotrans-gated_channel_TM', 3, NULL),
(1298, NULL, 'IPR007724', NULL, 'Poly(ADP-ribose) glycohydrolase', 'Poly_GlycHdrlase', 4, NULL),
(1299, NULL, 'IPR003668', NULL, 'Rotavirus non-structural protein 2', 'Rotavirus_NSP2', 4, NULL),
(1300, NULL, 'IPR001170', NULL, 'Adenylyl cyclase class-4/guanylyl cyclase', 'ANPR/GUC', 4, NULL),
(1301, NULL, 'IPR003107', NULL, 'HAT (Half-A-TPR) repeat', 'HAT', 7, NULL),
(1302, NULL, 'IPR000262', NULL, 'FMN-dependent dehydrogenase', 'FMN-dep_DH', 3, NULL),
(1303, NULL, 'IPR002049', NULL, 'Laminin-type EGF domain', 'LE_dom', 3, NULL),
(1304, NULL, 'IPR007775', NULL, 'Leukocyte-specific transcript 1, LST-1', 'Leukocyte-sp_tscrpt_1_LST1', 4, NULL),
(1305, NULL, 'IPR003670', NULL, 'African swine fever virus, TBK1 inhibitor DP96R', 'ASFV_DP96R', 4, NULL),
(1306, NULL, 'IPR006004', NULL, 'Glutamate synthase (NADPH), homotetrameric', 'Glut_synth_NADPH', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(1307, NULL, 'IPR024725', NULL, 'E3 ubiquitin ligase EDD, ubiquitin-associated domain', 'E3_UbLigase_EDD_UBA', 3, NULL),
(1308, NULL, 'IPR005974', NULL, 'Nitrogenase alpha chain', 'Nase_asu', 4, NULL),
(1309, NULL, 'IPR002101', NULL, 'Myristoylated alanine-rich C-kinase substrate MARCKS', 'MARCKS', 4, NULL),
(1310, NULL, 'IPR002117', NULL, 'p53 tumour suppressor family', 'p53_tumour_suppressor', 4, NULL),
(1311, NULL, 'IPR001119', NULL, 'S-layer homology domain', 'SLH_dom', 3, NULL),
(1312, NULL, 'IPR007782', NULL, 'Vitamin K-dependent gamma-carboxylase', 'VKG_COase', 4, NULL),
(1313, NULL, 'IPR005024', NULL, 'Snf7 family', 'Snf7_fam', 4, NULL),
(1314, NULL, 'IPR017953', NULL, 'Carbohydrate kinase, predicted, conserved site', 'Carbohydrate_kinase_pred_CS', 2, NULL),
(1315, NULL, 'IPR004491', NULL, 'Heat shock protein HslU', 'HslU', 4, NULL),
(1316, NULL, 'IPR002006', NULL, 'Hepatitis core antigen', 'Hepatitis_core', 4, NULL),
(1317, NULL, 'IPR001195', NULL, 'Glycophorin', 'Glycophorin', 4, NULL),
(1318, NULL, 'IPR007735', NULL, 'Pecanex, C-terminal', 'Pecanex_C', 3, NULL),
(1319, NULL, 'IPR007745', NULL, 'Cytochrome c oxidase copper chaperone', 'Cyt_c_oxidase_Cu-chaperone', 4, NULL),
(1320, NULL, 'IPR003667', NULL, 'NqrDE/RnfAE', 'NqrDE/RnfAE', 4, NULL),
(1321, NULL, 'IPR007720', NULL, 'Phosphatidylinositol N-acetylglucosaminyltransferase subunit Q/GPI1', 'PigQ/GPI1', 4, NULL),
(1322, NULL, 'IPR006619', NULL, 'Peptidoglycan recognition protein family domain, metazoa/bacteria', 'PGRP_domain_met/bac', 3, NULL),
(1323, NULL, 'IPR001174', NULL, 'Galactokinase/homoserine kinase', 'Galkinase', 4, NULL),
(1324, NULL, 'IPR007205', NULL, 'Protein HGH1 N-terminal', 'Protein_HGH1_N', 3, NULL),
(1325, NULL, 'IPR007692', NULL, 'DNA helicase, DnaB type', 'DNA_helicase_DnaB', 4, NULL),
(1326, NULL, 'IPR007761', NULL, 'Mannitol repressor MtlR-like', 'MtlR-like', 4, NULL),
(1327, NULL, 'IPR007770', NULL, 'Protein DMP', 'DMP', 4, NULL),
(1328, NULL, 'IPR007753', NULL, 'Orbivirus VP4 core', 'Orbi_VP4', 4, NULL),
(1329, NULL, 'IPR003625', NULL, 'Parathyroid hormone', 'PTH', 4, NULL),
(1330, NULL, 'IPR005993', NULL, 'GMP reductase', 'GMPR', 4, NULL),
(1331, NULL, 'IPR007751', NULL, 'Domain of unknown function DUF676, lipase-like', 'DUF676_lipase-like', 3, NULL),
(1332, NULL, 'IPR007688', NULL, 'Plasmid  conjugal transfer TrbL/VirB6', 'Conjugal_tfr_TrbL/VirB6', 4, NULL),
(1333, NULL, 'IPR006016', NULL, 'UspA', 'UspA', 3, NULL),
(1334, NULL, 'IPR003656', NULL, 'Zinc finger, BED-type', 'Znf_BED', 3, NULL),
(1335, NULL, 'IPR007695', NULL, 'DNA mismatch repair protein MutS-like, N-terminal', 'DNA_mismatch_repair_MutS-lik_N', 3, NULL),
(1336, NULL, 'IPR002079', NULL, 'Gag polyprotein, inner coat protein p12', 'Gag_p12', 3, NULL),
(1337, NULL, 'IPR007769', NULL, 'Poxvirus A19', 'Poxvirus_A19', 4, NULL),
(1338, NULL, 'IPR001166', NULL, 'Hyperglycemic hormone', 'Hyperglycemic', 4, NULL),
(1339, NULL, 'IPR007725', NULL, 'Timeless, C-terminal', 'TIMELESS_C', 3, NULL),
(1340, NULL, 'IPR001067', NULL, 'Nuclear translocator', 'Nuc_translocat', 4, NULL),
(1341, NULL, 'IPR003674', NULL, 'Oligosaccharyl transferase, STT3 subunit', 'Oligo_trans_STT3', 4, NULL),
(1342, NULL, 'IPR001147', NULL, 'Ribosomal protein L21e', 'Ribosomal_L21e', 4, NULL),
(1343, NULL, 'IPR001211', NULL, 'Phospholipase A2', 'PLipase_A2', 4, NULL),
(1344, NULL, 'IPR002182', NULL, 'NB-ARC', 'NB-ARC', 3, NULL),
(1345, NULL, 'IPR001157', NULL, 'Flavivirus non-structural protein NS1', 'Flavi_NS1', 3, NULL),
(1346, NULL, 'IPR005019', NULL, 'Methyladenine glycosylase', 'Adenine_glyco', 4, NULL),
(1347, NULL, 'IPR034618', NULL, 'D-galactarolactone cycloisomerase', 'GLI', 4, NULL),
(1348, NULL, 'IPR006595', NULL, 'CTLH, C-terminal LisH motif', 'CTLH_C', 3, NULL),
(1349, NULL, 'IPR001135', NULL, 'NADH-quinone oxidoreductase, subunit D', 'NADH_Q_OxRdtase_suD', 3, NULL),
(1350, NULL, 'IPR002041', NULL, 'Ran GTPase', 'Ran_GTPase', 4, NULL),
(1351, NULL, 'IPR000195', NULL, 'Rab-GTPase-TBC domain', 'Rab-GTPase-TBC_dom', 3, NULL),
(1352, NULL, 'IPR006634', NULL, 'TRAM/LAG1/CLN8 homology domain', 'TLC-dom', 3, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(1353, NULL, 'IPR001186', NULL, 'Bradykinin receptor B1', 'Brdyknn_1_rcpt', 4, NULL),
(1354, NULL, 'IPR001185', NULL, 'Large-conductance mechanosensitive channel', 'MS_channel', 4, NULL),
(1355, NULL, 'IPR003660', NULL, 'HAMP domain', 'HAMP_dom', 3, NULL),
(1356, NULL, 'IPR006657', NULL, 'Molybdopterin dinucleotide-binding domain', 'MoPterin_dinucl-bd_dom', 3, NULL),
(1357, NULL, 'IPR001062', NULL, 'Transcription antitermination protein, NusG', 'Transcrpt_antiterm_NusG', 4, NULL),
(1358, NULL, 'IPR034605', NULL, 'PGC-1', 'PGC-1', 4, NULL),
(1359, NULL, 'IPR007710', NULL, 'Nucleoside 2-deoxyribosyltransferase', 'Nucleoside_deoxyribTrfase', 4, NULL),
(1360, NULL, 'IPR001107', NULL, 'Band 7 domain', 'Band_7', 3, NULL),
(1361, NULL, 'IPR006652', NULL, 'Kelch repeat type 1', 'Kelch_1', 7, NULL),
(1362, NULL, 'IPR017957', NULL, 'P-type trefoil, conserved site', 'P_trefoil_CS', 2, NULL),
(1363, NULL, 'IPR001192', NULL, 'Phosphoinositide phospholipase C family', 'PI-PLC_fam', 4, NULL),
(1364, NULL, 'IPR004493', NULL, 'Leucyl-tRNA synthetase, class Ia, archaeal/eukaryotic cytosolic', 'Leu-tRNA-synth_Ia_arc/euk', 4, NULL),
(1365, NULL, 'IPR007192', NULL, 'Cdc23', 'APC8', 3, NULL),
(1366, NULL, 'IPR001177', NULL, 'DNA helicase E1, C-terminal, Papillomavirus', 'PPV_DNA_helicase_E1_C', 3, NULL),
(1367, NULL, 'IPR003645', NULL, 'Follistatin-like, N-terminal', 'Fol_N', 3, NULL),
(1368, NULL, 'IPR002048', NULL, 'EF-hand domain', 'EF_hand_dom', 3, NULL),
(1369, NULL, 'IPR007768', NULL, 'Suppressor of fused', 'Suppressor_of_fused', 4, NULL),
(1370, NULL, 'IPR007693', NULL, 'DNA helicase, DnaB-like, N-terminal', 'DNA_helicase_DnaB-like_N', 3, NULL),
(1371, NULL, 'IPR001204', NULL, 'Phosphate transporter', 'Phos_transporter', 4, NULL),
(1372, NULL, 'IPR007780', NULL, 'NAD-glutamate dehydrogenase, bacteria', 'NAD_Glu_DH_bac', 4, NULL),
(1373, NULL, 'IPR003651', NULL, 'Endonuclease III-like, iron-sulphur cluster loop motif', 'Endonuclease3_FeS-loop_motif', 2, NULL),
(1374, NULL, 'IPR002137', NULL, 'Beta-lactamase, class-D active site', 'Beta-lactam_class-D_AS', 0, NULL),
(1375, NULL, 'IPR007690', NULL, 'Type II secretion system protein GspM', 'T2SS_GspM', 4, NULL),
(1376, NULL, 'IPR001181', NULL, 'Interleukin-7', 'IL-7', 4, NULL),
(1377, NULL, 'IPR001152', NULL, 'Beta-thymosin', 'Beta-thymosin', 4, NULL),
(1378, NULL, 'IPR001190', NULL, 'SRCR domain', 'SRCR', 3, NULL),
(1379, NULL, 'IPR007759', NULL, 'ASXL, HARE-HTH domain', 'Asxl_HARE-HTH', 3, NULL),
(1380, NULL, 'IPR006627', NULL, 'TDU repeat', 'TDU_repeat', 7, NULL),
(1381, NULL, 'IPR007765', NULL, 'Baculovirus p24 capsid', 'Baculo_p24', 4, NULL),
(1382, NULL, 'IPR004490', NULL, 'Glycolate oxidase subunit GlcD', 'GlcD', 4, NULL),
(1383, NULL, 'IPR003106', NULL, 'Leucine zipper, homeobox-associated', 'Leu_zip_homeo', 3, NULL),
(1384, NULL, 'IPR007199', NULL, 'Replication factor-A protein 1, N-terminal', 'Rep_factor-A_N', 3, NULL),
(1385, NULL, 'IPR024651', NULL, 'FAD-containing D-sorbitol dehydrogenase small subunit', 'FAD-SLDH_ssu', 4, NULL),
(1386, NULL, 'IPR006642', NULL, 'Rad18,  zinc finger UBZ4-type', 'Rad18_UBZ4', 3, NULL),
(1387, NULL, 'IPR001168', NULL, 'Adrenocorticotrophin (ACTH) receptor', 'ACTH_rcpt', 4, NULL),
(1388, NULL, 'IPR007746', NULL, 'Broad mercury transporter MerE', 'MerE', 4, NULL),
(1389, NULL, 'IPR005972', NULL, 'Nitrogenase molybdenum-iron protein alpha chain', 'Nase_Mo-Fe_asu', 4, NULL),
(1390, NULL, 'IPR007736', NULL, 'Caleosin-related', 'Caleosin-related', 4, NULL),
(1391, NULL, 'IPR007742', NULL, 'Periplasmic copper-binding protein NosD, beta helix domain', 'NosD_dom', 3, NULL),
(1392, NULL, 'IPR005997', NULL, 'Ribosomal protein L30, archaeal', 'Ribosomal_L30_arc', 4, NULL),
(1393, NULL, 'IPR007198', NULL, 'Ssl1-like', 'Ssl1-like', 3, NULL),
(1394, NULL, 'IPR006605', NULL, 'G2 nidogen/fibulin G2F', 'G2_nidogen/fibulin_G2F', 3, NULL),
(1395, NULL, 'IPR006020', NULL, 'PTB/PI domain', 'PTB/PI_dom', 3, NULL),
(1396, NULL, 'IPR007696', NULL, 'DNA mismatch repair protein MutS, core', 'DNA_mismatch_repair_MutS_core', 3, NULL),
(1397, NULL, 'IPR003646', NULL, 'SH3-like domain, bacterial-type', 'SH3-like_bac-type', 3, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(1398, NULL, 'IPR007781', NULL, 'Alpha-N-acetylglucosaminidase', 'NAGLU', 4, NULL),
(1399, NULL, 'IPR002043', NULL, 'Uracil-DNA glycosylase family 1', 'UDG_fam1', 4, NULL),
(1400, NULL, 'IPR001078', NULL, '2-oxoacid dehydrogenase acyltransferase, catalytic domain', '2-oxoacid_DH_actylTfrase', 3, NULL),
(1401, NULL, 'IPR005991', NULL, 'GMP reductase-like', 'GUAB1-like', 4, NULL),
(1402, NULL, 'IPR007691', NULL, 'UDP-3-O-[3-hydroxymyristoyl] glucosamine N-acyltransferase LpxD', 'LpxD', 4, NULL),
(1403, NULL, 'IPR034554', NULL, 'Mitochondrial import receptor subunit TOM6 homologue, plants', 'TOM6_plants', 4, NULL),
(1404, NULL, 'IPR003650', NULL, 'Orange domain', 'Orange_dom', 3, NULL),
(1405, NULL, 'IPR002042', NULL, 'Uricase', 'Uricase', 4, NULL),
(1406, NULL, 'IPR002120', NULL, 'Thyrotropin-releasing hormone receptor', 'TRH_rcpt_1', 4, NULL),
(1407, NULL, 'IPR000198', NULL, 'Rho GTPase-activating protein domain', 'RhoGAP_dom', 3, NULL),
(1408, NULL, 'IPR002122', NULL, 'Melanocortin 3 receptor', 'Mcort_3_rcpt', 4, NULL),
(1409, NULL, 'IPR005969', NULL, 'Light-independent protochlorophyllide reductase, B subunit', 'Protochl_reductB', 4, NULL),
(1410, NULL, 'IPR002047', NULL, 'Adipokinetic hormone, conserved site', 'Adipokinetic_hormone_CS', 2, NULL),
(1411, NULL, 'IPR007729', NULL, '2-keto-3-deoxy-galactonokinase', 'DGOK', 4, NULL),
(1412, NULL, 'IPR001114', NULL, 'Adenylosuccinate synthetase', 'Adenylosuccinate_synthetase', 4, NULL),
(1413, NULL, 'IPR001200', NULL, 'Phosducin', 'Phosducin', 4, NULL),
(1414, NULL, 'IPR001210', NULL, 'Ribosomal protein S17e', 'Ribosomal_S17e', 4, NULL),
(1415, NULL, 'IPR005026', NULL, 'SAPAP family', 'SAPAP', 4, NULL),
(1416, NULL, 'IPR003655', NULL, 'Ancestral KRAB domain', 'aKRAB', 3, NULL),
(1417, NULL, 'IPR002093', NULL, 'BRCA2 repeat', 'BRCA2_repeat', 7, NULL),
(1418, NULL, 'IPR001060', NULL, 'FCH domain', 'FCH_dom', 3, NULL),
(1419, NULL, 'IPR006001', NULL, 'Carbohydrate kinase, thermoresistant glucokinase', 'Therm_gnt_kin', 4, NULL),
(1420, NULL, 'IPR006006', NULL, 'Glutamate synthase NADPH small chain-like', 'GltD-like', 4, NULL),
(1421, NULL, 'IPR004486', NULL, 'CO dehydrogenase/acetyl-CoA synthase delta subunit', 'CO_DH/Ac-CoA_synth_dsu', 4, NULL),
(1422, NULL, 'IPR002115', NULL, 'Protein-tyrosine phosphatase, low molecular weight, mammalian', 'Tyr_Pase_low_mol_wt_mml', 4, NULL),
(1423, NULL, 'IPR001849', NULL, 'Pleckstrin homology domain', 'PH_domain', 3, NULL),
(1424, NULL, 'IPR002083', NULL, 'MATH/TRAF domain', 'MATH/TRAF_dom', 3, NULL),
(1425, NULL, 'IPR001090', NULL, 'Ephrin receptor ligand binding domain', 'Ephrin_rcpt_lig-bd_dom', 3, NULL),
(1426, NULL, 'IPR007120', NULL, 'DNA-directed RNA polymerase, subunit 2, hybrid-binding domain', 'DNA-dir_RNAP_su2_dom', 3, NULL),
(1427, NULL, 'IPR006624', NULL, 'Beta-propeller repeat TECPR', 'Beta-propeller_rpt_TECPR', 7, NULL),
(1428, NULL, 'IPR003649', NULL, 'B-box, C-terminal', 'Bbox_C', 3, NULL),
(1429, NULL, 'IPR001207', NULL, 'Transposase, mutator type', 'Transposase_mutator', 4, NULL),
(1430, NULL, 'IPR007187', NULL, 'Nucleoporin, Nup133/Nup155-like, C-terminal', 'Nucleoporin_Nup133/Nup155_C', 3, NULL),
(1431, NULL, 'IPR001115', NULL, 'Alpha 1B adrenoceptor', 'ADRA1B_rcpt', 4, NULL),
(1432, NULL, 'IPR007703', NULL, 'Per os infectivity factor 3', 'PIF3', 4, NULL),
(1433, NULL, 'IPR007727', NULL, 'Spo12', 'Spo12', 4, NULL),
(1434, NULL, 'IPR034358', NULL, 'Vip1, RNA recognition motif', 'Vip1_RRM', 3, NULL),
(1435, NULL, 'IPR001029', NULL, 'Flagellin, N-terminal domain', 'Flagellin_N', 3, NULL),
(1436, NULL, 'IPR007207', NULL, 'CCR4-Not complex component, Not N-terminal domain', 'Not_N', 3, NULL),
(1437, NULL, 'IPR001155', NULL, 'NADH:flavin oxidoreductase/NADH oxidase, N-terminal', 'OxRdtase_FMN_N', 3, NULL),
(1438, NULL, 'IPR007701', NULL, 'Interferon-related developmental regulator, N-terminal', 'Interferon-rel_develop_reg_N', 3, NULL),
(1439, NULL, 'IPR007773', NULL, 'Autographa californica nuclear polyhedrosis virus (AcMNPV), P18', 'AcMNPV_P18', 4, NULL),
(1440, NULL, 'IPR006602', NULL, 'DM10 domain', 'DM10_dom', 3, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(1441, NULL, 'IPR002121', NULL, 'HRDC domain', 'HRDC_dom', 3, NULL),
(1442, NULL, 'IPR002129', NULL, 'Pyridoxal phosphate-dependent decarboxylase', 'PyrdxlP-dep_de-COase', 4, NULL),
(1443, NULL, 'IPR034538', NULL, 'ACF, RNA recognition motif 1', 'ACF_RRM1', 3, NULL),
(1444, NULL, 'IPR003099', NULL, 'Prephenate dehydrogenase', 'Prephen_DH', 3, NULL),
(1445, NULL, 'IPR005996', NULL, 'Ribosomal protein L30, bacterial-type', 'Ribosomal_L30_bac-type', 4, NULL),
(1446, NULL, 'IPR005023', NULL, 'Viral late protein H2', 'Pox_LP_H2', 4, NULL),
(1447, NULL, 'IPR005971', NULL, 'Light-independent protochlorophyllide reductase, iron-sulphur ATP-binding protein', 'Protochlorophyllide_ATP-bd', 4, NULL),
(1448, NULL, 'IPR007194', NULL, 'Transport protein particle (TRAPP) component', 'TRAPP_component', 4, NULL),
(1449, NULL, 'IPR002089', NULL, 'Influenza virus matrix protein 2', 'Flu_M2', 4, NULL),
(1450, NULL, 'IPR001094', NULL, 'Flavodoxin-like', 'Flavdoxin-like', 3, NULL),
(1451, NULL, 'IPR007719', NULL, 'Phytochelatin synthase, N-terminal catalytic domain', 'PCS_N', 3, NULL),
(1452, NULL, 'IPR001187', NULL, 'Tissue factor', 'Tissue_factor', 4, NULL),
(1453, NULL, 'IPR004484', NULL, 'Cobyrinic acid a,c-diamide synthase CbiA', 'CbiA_synth', 4, NULL),
(1454, NULL, 'IPR005989', NULL, 'Sucrose/H+ symporter, plant', 'Suc_symporter_pln', 4, NULL),
(1455, NULL, 'IPR002059', NULL, 'Cold-shock protein, DNA-binding', 'CSP_DNA-bd', 3, NULL),
(1456, NULL, 'IPR007730', NULL, 'Sporulation-like domain', 'SPOR-like_dom', 3, NULL),
(1457, NULL, 'IPR006641', NULL, 'YqgF/RNase H-like domain', 'YqgF/RNaseH-like_dom', 3, NULL),
(1458, NULL, 'IPR005028', NULL, 'Herpesvirus intermediate/early protein 2/3', 'Herpes_IE2_3', 3, NULL),
(1459, NULL, 'IPR007747', NULL, 'Menin', 'Menin', 4, NULL),
(1460, NULL, 'IPR006643', NULL, 'Zasp-like motif', 'Zasp-like_motif', 3, NULL),
(1461, NULL, 'IPR001223', NULL, 'Glycoside hydrolase family 18, catalytic domain', 'Glyco_hydro18_cat', 3, NULL),
(1462, NULL, 'IPR001160', NULL, 'Peptidase M20C, Xaa-His dipeptidase', 'Peptidase_M20C', 4, NULL),
(1463, NULL, 'IPR003097', NULL, 'Sulfite reductase [NADPH] flavoprotein alpha-component-like, FAD-binding', 'CysJ-like_FAD-binding', 3, NULL),
(1464, NULL, 'IPR005977', NULL, 'Nitrogenase iron protein NifH', 'Nitrogenase_Fe_NifH', 4, NULL),
(1465, NULL, 'IPR001172', NULL, 'Flagellar motor switch FliN/Type III secretion HrcQb', 'FliN_T3SS_HrcQb', 4, NULL),
(1466, NULL, 'IPR007758', NULL, 'Nucleoporin, NSP1-like, C-terminal', 'Nucleoporin_NSP1_C', 3, NULL),
(1467, NULL, 'IPR006601', NULL, 'Uncharacterised protein family DM11, Drosophila melanogaster', 'Uncharacterised_DM11_DROME', 4, NULL),
(1468, NULL, 'IPR007560', NULL, 'Restriction endonuclease type IV,  Mrr', 'Restrct_endonuc_IV_Mrr', 3, NULL),
(1469, NULL, 'IPR007206', NULL, 'Protein HGH1 C-terminal', 'Protein_HGH1_C', 3, NULL),
(1470, NULL, 'IPR001156', NULL, 'Transferrin-like domain', 'Transferrin-like_dom', 3, NULL),
(1471, NULL, 'IPR003103', NULL, 'BAG domain', 'BAG_domain', 3, NULL),
(1472, NULL, 'IPR003644', NULL, 'Na-Ca exchanger/integrin-beta4', 'Calx_beta', 3, NULL),
(1473, NULL, 'IPR004488', NULL, 'Magnesium/cobalt transport protein CorA', 'Mg/Co-transport_prot_CorA', 4, NULL),
(1474, NULL, 'IPR001104', NULL, '3-oxo-5-alpha-steroid 4-dehydrogenase, C-terminal', '3-oxo-5_a-steroid_4-DH_C', 3, NULL),
(1475, NULL, 'IPR002180', NULL, 'Lumazine/riboflavin synthase', 'LS/RS', 4, NULL),
(1476, NULL, 'IPR000202', NULL, 'GPCR, family 3, metabotropic glutamate receptor 5', 'GPCR_3_mGluR5', 4, NULL),
(1477, NULL, 'IPR034361', NULL, 'PHIP1, RNA recognition motif 1', 'PHIP1_RRM1', 3, NULL),
(1478, NULL, 'IPR001209', NULL, 'Ribosomal protein S14', 'Ribosomal_S14', 4, NULL),
(1479, NULL, 'IPR002119', NULL, 'Histone H2A', 'Histone_H2A', 4, NULL),
(1480, NULL, 'IPR005995', NULL, 'Phosphoglycerate mutase, 2,3-bisphosphoglycerate-independent', 'Pgm_bpd_ind', 4, NULL),
(1481, NULL, 'IPR003652', NULL, 'Ataxin, AXH domain', 'Ataxin_AXH_dom', 3, NULL),
(1482, NULL, 'IPR006616', NULL, 'DM9 repeat', 'DM9_repeat', 7, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(1483, NULL, 'IPR002109', NULL, 'Glutaredoxin', 'Glutaredoxin', 3, NULL),
(1484, NULL, 'IPR000200', NULL, 'Peptidase C10, streptopain', 'Peptidase_C10', 4, NULL),
(1485, NULL, 'IPR002110', NULL, 'Ankyrin repeat', 'Ankyrin_rpt', 7, NULL),
(1486, NULL, 'IPR024724', NULL, 'Molybdenum cofactor biosynthesis protein F, N-terminal', 'MoaF_N', 3, NULL),
(1487, NULL, 'IPR002084', NULL, 'Methionine repressor MetJ', 'Met_repressor_MetJ', 4, NULL),
(1488, NULL, 'IPR007740', NULL, 'Ribosomal protein L49/IMG2', 'Ribosomal_L49/IMG2', 4, NULL),
(1489, NULL, 'IPR005998', NULL, 'Ribosomal protein L7, eukaryotic', 'Ribosomal_L7_euk', 4, NULL),
(1490, NULL, 'IPR006017', NULL, 'Caldesmon', 'Caldesmon', 4, NULL),
(1491, NULL, 'IPR001197', NULL, 'Ribosomal protein L10e', 'Ribosomal_L10e', 4, NULL),
(1492, NULL, 'IPR007694', NULL, 'DNA helicase, DnaB-like, C-terminal', 'DNA_helicase_DnaB-like_C', 3, NULL),
(1493, NULL, 'IPR002131', NULL, 'Glycoprotein hormone receptor family', 'Gphrmn_rcpt_fam', 4, NULL),
(1494, NULL, 'IPR006645', NULL, 'NusG, N-terminal', 'NGN_dom', 3, NULL),
(1495, NULL, 'IPR003110', NULL, 'Phosphorylated immunoreceptor signalling ITAM', 'Phos_immunorcpt_sig_ITAM', 7, NULL),
(1496, NULL, 'IPR007700', NULL, 'Domain of unknown function DUF668', 'DUF668', 3, NULL),
(1497, NULL, 'IPR003653', NULL, 'Ulp1 protease family, C-terminal catalytic domain', 'Peptidase_C48_C', 3, NULL),
(1498, NULL, 'IPR007193', NULL, 'Up-frameshift suppressor 2, C-terminal', 'Upf2/Nmd2_C', 3, NULL),
(1499, NULL, 'IPR001022', NULL, 'Tobamoviral movement protein', 'TMV_movement', 4, NULL),
(1500, NULL, 'IPR001139', NULL, 'Glycoside hydrolase family 30', 'Glyco_hydro_30', 4, NULL),
(1501, NULL, 'IPR004536', NULL, 'Selenophosphate synthetase', 'SPS/SelD', 4, NULL),
(1502, NULL, 'IPR004121', NULL, 'Human herpesvirus K1 glycoprotein, C-terminal', 'K1_C', 3, NULL),
(1503, NULL, 'IPR003121', NULL, 'SWIB/MDM2 domain', 'SWIB_MDM2_domain', 3, NULL),
(1504, NULL, 'IPR009608', NULL, 'Bradykinin', 'Bradykinin', 4, NULL),
(1505, NULL, 'IPR034022', NULL, 'Tumour necrosis factor receptor 4, N-terminal', 'TNFRSF4_N', 3, NULL),
(1506, NULL, 'IPR010950', NULL, 'Chorismate mutase, archaeal', 'Chorismate_mutase_arc', 3, NULL),
(1507, NULL, 'IPR009609', NULL, 'Phosphonate metabolism PhnG', 'Phosphonate_metab_PhnG', 4, NULL),
(1508, NULL, 'IPR002566', NULL, 'Surface antigen msp4', 'Surface_Ag_msp4', 4, NULL),
(1509, NULL, 'IPR004105', NULL, 'Histidine kinase  CheA-like, homodimeric domain', 'CheA-like_dim', 3, NULL),
(1510, NULL, 'IPR003124', NULL, 'WH2 domain', 'WH2_dom', 3, NULL),
(1511, NULL, 'IPR005526', NULL, 'Septum formation inhibitor MinC, C-terminal', 'Septum_form_inhib_MinC_C', 3, NULL),
(1512, NULL, 'IPR005550', NULL, 'Kinetochore protein Ndc80', 'Kinetochore_Ndc80', 4, NULL),
(1513, NULL, 'IPR004526', NULL, 'Glutamyl-tRNA synthetase, archaeal/eukaryotic cytosolic', 'Glu-tRNA-synth_arc/euk', 4, NULL),
(1514, NULL, 'IPR004934', NULL, 'Tropomodulin', 'TMOD', 4, NULL),
(1515, NULL, 'IPR009605', NULL, 'Domain of unknown function DUF1216', 'DUF1216', 3, NULL),
(1516, NULL, 'IPR002605', NULL, 'Adenovirus penton base protein', 'Adeno_Penton_B', 4, NULL),
(1517, NULL, 'IPR003694', NULL, 'NAD(+) synthetase', 'NAD_synthase', 4, NULL),
(1518, NULL, 'IPR005548', NULL, 'Cell division protein FtsQ/DivIB, C-terminal', 'Cell_div_FtsQ/DivIB_C', 3, NULL),
(1519, NULL, 'IPR005575', NULL, 'Statherin', 'Statherin', 4, NULL),
(1520, NULL, 'IPR022824', NULL, 'Multidrug resistance protein MdtA', 'Multidrug-R_MdtA', 4, NULL),
(1521, NULL, 'IPR004066', NULL, 'Lysophosphatidic acid receptor EDG-4', 'LPA_rcpt_EDG4', 4, NULL),
(1522, NULL, 'IPR002606', NULL, 'Riboflavin kinase, bacterial', 'Riboflavin_kinase_bac', 4, NULL),
(1523, NULL, 'IPR005582', NULL, 'Chromosome partition protein MukF', 'Chromosome_partition_MukF', 4, NULL),
(1524, NULL, 'IPR004917', NULL, 'Aphid transmission protein', 'Caulimo_AT', 4, NULL),
(1525, NULL, 'IPR005572', NULL, 'Anti sigma-E protein RseA, N-terminal', 'Anti-sigma_E_RseA_N', 3, NULL),
(1526, NULL, 'IPR000164', NULL, 'Histone H3/CENP-A', 'Histone_H3/CENP-A', 4, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(1527, NULL, 'IPR000161', NULL, 'Vasopressin V2 receptor', 'Vprsn_rcpt_V2', 4, NULL),
(1528, NULL, 'IPR005546', NULL, 'Autotransporter beta-domain', 'Autotransporte_beta', 3, NULL),
(1529, NULL, 'IPR001134', NULL, 'Netrin domain', 'Netrin_domain', 3, NULL),
(1530, NULL, 'IPR002580', NULL, 'Herpesvirus UL24', 'Herpes_UL24', 4, NULL),
(1531, NULL, 'IPR002588', NULL, 'Alphavirus-like methyltransferase (MT) domain', 'Alphavirus-like_MT_dom', 3, NULL),
(1532, NULL, 'IPR004900', NULL, 'Poxvirus P35', 'Poxvirus_P35', 4, NULL),
(1533, NULL, 'IPR002611', NULL, 'IstB-like ATP-binding protein', 'IstB_ATP-bd', 3, NULL),
(1534, NULL, 'IPR000158', NULL, 'Cell division protein FtsZ', 'Cell_div_FtsZ', 4, NULL),
(1535, NULL, 'IPR002608', NULL, 'Paramyxovirus non-structural protein C', 'Paramyxo_C', 4, NULL),
(1536, NULL, 'IPR004070', NULL, 'CXC chemokine receptor 3', 'Chemokine_CXCR3', 4, NULL),
(1537, NULL, 'IPR005561', NULL, 'ANTAR domain', 'ANTAR', 3, NULL),
(1538, NULL, 'IPR003191', NULL, 'Guanylate-binding protein/Atlastin, C-terminal', 'Guanylate-bd/ATL_C', 3, NULL),
(1539, NULL, 'IPR000163', NULL, 'Prohibitin', 'Prohibitin', 4, NULL),
(1540, NULL, 'IPR003691', NULL, 'Putative fluoride ion transporter CrcB', 'CrcB', 4, NULL),
(1541, NULL, 'IPR003189', NULL, 'Shiga-like toxin, beta subunit', 'SLT_beta', 4, NULL),
(1542, NULL, 'IPR004114', NULL, 'THUMP domain', 'THUMP_dom', 3, NULL),
(1543, NULL, 'IPR004096', NULL, '4-vinyl reductase, 4VR', 'V4R', 3, NULL),
(1544, NULL, 'IPR005532', NULL, 'Sulfatase-modifying factor enzyme', 'SUMF_dom', 3, NULL),
(1545, NULL, 'IPR003165', NULL, 'Piwi domain', 'Piwi', 3, NULL),
(1546, NULL, 'IPR034374', NULL, 'G3BP1, RNA recognition motif', 'G3BP1_RRM', 3, NULL),
(1547, NULL, 'IPR009587', NULL, 'Protein of unknown function DUF1198', 'DUF1198', 4, NULL),
(1548, NULL, 'IPR000136', NULL, 'Oleosin', 'Oleosin', 4, NULL),
(1549, NULL, 'IPR003157', NULL, 'Acyl transferase, LuxD', 'LuxD', 4, NULL),
(1550, NULL, 'IPR004091', NULL, 'Chemotaxis methyl-accepting receptor, methyl-accepting site', 'Chemotax_Me-accpt_rcpt_Me-site', 6, NULL),
(1551, NULL, 'IPR009588', NULL, 'Feline immunodeficiency virus, Orf3', 'FIV_Orf3', 4, NULL),
(1552, NULL, 'IPR003113', NULL, 'Phosphatidylinositol 3-kinase, adaptor-binding domain', 'PI3K_ABD', 3, NULL),
(1553, NULL, 'IPR003681', NULL, 'Glycophorin-binding protein', 'Glycophorin-bd', 7, NULL),
(1554, NULL, 'IPR003202', NULL, 'DNA polymerase processivity factor (UL42)', 'Herpes_UL42', 4, NULL),
(1555, NULL, 'IPR006660', NULL, 'Arsenate reductase-like', 'Arsenate_reductase-like', 4, NULL),
(1556, NULL, 'IPR005587', NULL, 'Uncharacterised protein family UPF0304, YfbU', 'UPF0304_YfbU', 4, NULL),
(1557, NULL, 'IPR004098', NULL, 'Prp18', 'Prp18', 3, NULL),
(1558, NULL, 'IPR004909', NULL, 'Viral heat shock protein Hsp90 homologue', 'Vir_Hsp90', 4, NULL),
(1559, NULL, 'IPR004120', NULL, 'HTLV Tax', 'Tax', 4, NULL),
(1560, NULL, 'IPR000155', NULL, 'Melanocortin 4 receptor', 'Mcort_rcpt_4', 4, NULL),
(1561, NULL, 'IPR004068', NULL, 'CC chemokine receptor 8', 'Chemokine_CCR8', 4, NULL),
(1562, NULL, 'IPR004905', NULL, 'Tombusvirus p19 core protein', 'Tombusvirus_p19', 4, NULL),
(1563, NULL, 'IPR023219', NULL, 'Hepatocyte nuclear factor 1, N-terminal domain superfamily', 'HNF1_dimer_N_dom_sf', 5, NULL),
(1564, NULL, 'IPR004073', NULL, 'GPCR, family 3, vomeronasal receptor, type 2', 'GPCR_3_vmron_rcpt_2', 4, NULL),
(1565, NULL, 'IPR002612', NULL, 'Adenovirus large t-antigen, E1B 55kDa protein', 'Adeno_E1B_55kDa', 4, NULL),
(1566, NULL, 'IPR000143', NULL, 'Geminivirus MSV 27Kd coat protein', 'Gemcoat_MSV', 4, NULL),
(1567, NULL, 'IPR002591', NULL, 'Type I phosphodiesterase/nucleotide pyrophosphatase/phosphate transferase', 'Phosphodiest/P_Trfase', 4, NULL),
(1568, NULL, 'IPR003177', NULL, 'Cytochrome c oxidase subunit VIIa, metazoa', 'Cytc_oxidase_su7a_met', 4, NULL),
(1569, NULL, 'IPR003156', NULL, 'DHHA1 domain', 'DHHA1_dom', 3, NULL),
(1570, NULL, 'IPR004528', NULL, '3-deoxy-D-manno-octulosonate cytidylyltransferase', 'KdsB', 4, NULL),
(1571, NULL, 'IPR009618', NULL, 'Erp protein', 'Erp', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(1572, NULL, 'IPR004514', NULL, 'Glutamine-tRNA synthetase', 'Gln-tRNA-synth', 4, NULL),
(1573, NULL, 'IPR007573', NULL, 'QWRF family', 'QWRF', 4, NULL),
(1574, NULL, 'IPR002600', NULL, 'Herpesvirus UL7-like', 'Herpes_UL7', 4, NULL),
(1575, NULL, 'IPR009591', NULL, 'Movement protein p6, Beet yellows virus', 'Beet_yellows_virus_p6', 4, NULL),
(1576, NULL, 'IPR002577', NULL, 'Helix-turn-helix, HxlR type', 'HTH_HxlR', 3, NULL),
(1577, NULL, 'IPR005516', NULL, 'Remorin, C-terminal', 'Remorin_C', 3, NULL),
(1578, NULL, 'IPR001136', NULL, 'Merozoite surface protein 2', 'MSA2', 4, NULL),
(1579, NULL, 'IPR009604', NULL, 'LsmAD domain', 'LsmAD_domain', 3, NULL),
(1580, NULL, 'IPR004089', NULL, 'Methyl-accepting chemotaxis protein (MCP) signalling domain', 'MCPsignal_dom', 3, NULL),
(1581, NULL, 'IPR003166', NULL, 'Transcription factor TFIIE beta subunit, DNA-binding domain', 'TFIIE_bsu_DNA-bd', 3, NULL),
(1582, NULL, 'IPR004092', NULL, 'Mbt repeat', 'Mbt', 7, NULL),
(1583, NULL, 'IPR004517', NULL, 'ATP phosphoribosyltransferase regulatory subunit', 'HisZ', 4, NULL),
(1584, NULL, 'IPR009629', NULL, 'Erythrovirus X', 'Erythrovirus_X', 4, NULL),
(1585, NULL, 'IPR000123', NULL, 'RNA-directed DNA polymerase (reverse transcriptase), msDNA', 'Reverse_transcriptase_msDNA', 4, NULL),
(1586, NULL, 'IPR005551', NULL, 'Apo-citrate lyase phosphoribosyl-dephospho-CoA transferase', 'CitX', 4, NULL),
(1587, NULL, 'IPR004519', NULL, 'DNA-directed RNA polymerase, subunit E/RPC8', 'RNAP_E/RPC8', 4, NULL),
(1588, NULL, 'IPR004932', NULL, 'Retrieval of early ER protein Rer1', 'Rer1', 4, NULL),
(1589, NULL, 'IPR004123', NULL, 'Dim1 family', 'Dim1', 4, NULL),
(1590, NULL, 'IPR002595', NULL, 'African swine fever virus, MGF360', 'ASFV_MGF360', 4, NULL),
(1591, NULL, 'IPR003119', NULL, 'Saposin A-type domain', 'SAP_A', 3, NULL),
(1592, NULL, 'IPR004929', NULL, 'Spanin, inner membrane subunit', 'I-spanin', 4, NULL),
(1593, NULL, 'IPR004923', NULL, 'Iron permease FTR1/Fip1/EfeU', 'FTR1/Fip1/EfeU', 4, NULL),
(1594, NULL, 'IPR005578', NULL, 'Yif1 family', 'Yif1_fam', 4, NULL),
(1595, NULL, 'IPR003112', NULL, 'Olfactomedin-like domain', 'Olfac-like_dom', 3, NULL),
(1596, NULL, 'IPR004067', NULL, 'CC chemokine receptor 6', 'Chemokine_CCR6', 4, NULL),
(1597, NULL, 'IPR009619', NULL, 'Cell division protein CrgA', 'CrgA', 4, NULL),
(1598, NULL, 'IPR003151', NULL, 'PIK-related kinase, FAT', 'PIK-rel_kinase_FAT', 3, NULL),
(1599, NULL, 'IPR010951', NULL, 'Chorismate mutase, bacteria', 'CM_bact', 4, NULL),
(1600, NULL, 'IPR003115', NULL, 'ParB/Sulfiredoxin', 'ParB/Sulfiredoxin_dom', 3, NULL),
(1601, NULL, 'IPR034029', NULL, 'Tumour necrosis factor receptor 10A/B, death domain', 'TNFRSF10A/B_death', 3, NULL),
(1602, NULL, 'IPR001132', NULL, 'SMAD domain, Dwarfin-type', 'SMAD_dom_Dwarfin-type', 3, NULL),
(1603, NULL, 'IPR006676', NULL, 'tRNA-splicing endonuclease', 'tRNA_splic', 4, NULL),
(1604, NULL, 'IPR005553', NULL, 'Cytoadherence-linked asexual protein', 'CLAG', 4, NULL),
(1605, NULL, 'IPR007578', NULL, 'Herpesvirus U10', 'Herpes_U10', 4, NULL),
(1606, NULL, 'IPR003686', NULL, 'Photosystem II PsbI', 'PSII_PsbI', 4, NULL),
(1607, NULL, 'IPR000185', NULL, 'Protein translocase subunit SecA', 'SecA', 4, NULL),
(1608, NULL, 'IPR002585', NULL, 'Cytochrome ubiquinol oxidase subunit 1', 'Cyt-d_ubiquinol_oxidase_su_1', 4, NULL),
(1609, NULL, 'IPR004102', NULL, 'Poly(ADP-ribose) polymerase, regulatory domain', 'Poly(ADP-ribose)pol_reg_dom', 3, NULL),
(1610, NULL, 'IPR005515', NULL, 'Vitelline membrane outer layer protein I (VOMI)', 'VOMI', 4, NULL),
(1611, NULL, 'IPR006678', NULL, 'tRNA intron endonuclease, N-terminal', 'tRNA_intron_Endonuc_N', 3, NULL),
(1612, NULL, 'IPR002615', NULL, 'Photosystem I PsaJ, reaction centre subunit IX', 'PSI_PsaJ', 4, NULL),
(1613, NULL, 'IPR004943', NULL, 'Lepidopteran low molecular weight lipoprotein', 'Lipoprotein_11', 4, NULL),
(1614, NULL, 'IPR005520', NULL, 'Attacin, N-terminal', 'Attacin_N', 3, NULL),
(1615, NULL, 'IPR010949', NULL, 'TonB-dependent haemoglobin/transferrin/lactoferrin receptor', 'TonB_Hb/transfer/lactofer_rcpt', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(1616, NULL, 'IPR009627', NULL, 'Uncharacterised protein family UPF0259', 'UPF0259', 4, NULL),
(1617, NULL, 'IPR004529', NULL, 'Phenylalanyl-tRNA synthetase, class IIc, alpha subunit', 'Phe-tRNA-synth_IIc_asu', 4, NULL),
(1618, NULL, 'IPR004915', NULL, 'Nonstructural protein NS-S, bunyaviral', 'NS-S_bunyaviral', 4, NULL),
(1619, NULL, 'IPR004103', NULL, 'Polysaccharide lyase family 8, C-terminal', 'Lyase_8_C', 3, NULL),
(1620, NULL, 'IPR000177', NULL, 'Apple domain', 'Apple', 3, NULL),
(1621, NULL, 'IPR000180', NULL, 'Membrane dipeptidase, active site', 'Dipep_AS', 0, NULL),
(1622, NULL, 'IPR004931', NULL, 'Prothymosin/parathymosin', 'Pro/parathymosin', 4, NULL),
(1623, NULL, 'IPR002557', NULL, 'Chitin binding domain', 'Chitin-bd_dom', 3, NULL),
(1624, NULL, 'IPR000131', NULL, 'ATP synthase, F1 complex, gamma subunit', 'ATP_synth_F1_gsu', 4, NULL),
(1625, NULL, 'IPR004518', NULL, 'NTP pyrophosphohydrolase MazG, putative catalytic core', 'MazG_cat', 3, NULL),
(1626, NULL, 'IPR004533', NULL, 'CDP-diacylglycerol--serine O-phosphatidyltransferase', 'CDP-diaglyc--ser_O-PTrfase', 4, NULL),
(1627, NULL, 'IPR002614', NULL, 'Inner layer core protein VP3, Orbivirus', 'Inner_layer_core_VP3_Orbivir', 4, NULL),
(1628, NULL, 'IPR004099', NULL, 'Pyridine nucleotide-disulphide oxidoreductase, dimerisation domain', 'Pyr_nucl-diS_OxRdtase_dimer', 3, NULL),
(1629, NULL, 'IPR004117', NULL, 'Olfactory receptor, insect', '7tm6_olfct_rcpt', 4, NULL),
(1630, NULL, 'IPR004540', NULL, 'Translation elongation factor EFG/EF2', 'Transl_elong_EFG/EF2', 4, NULL),
(1631, NULL, 'IPR024730', NULL, 'Merozoite surface protein, EGF domain 1', 'MSP1_EGF_1', 3, NULL),
(1632, NULL, 'IPR005529', NULL, 'Protein of unknown function DUF321', 'DUF321', 7, NULL),
(1633, NULL, 'IPR002560', NULL, 'Transposase IS204/IS1001/IS1096/IS1165, DDE domain', 'Transposase_DDE', 3, NULL),
(1634, NULL, 'IPR004503', NULL, 'Serine-tRNA ligase type 2, archaea', 'Ser-tRNA-ligase_2_arc', 4, NULL),
(1635, NULL, 'IPR004908', NULL, 'ATPase, V1 complex, subunit H', 'ATPase_V1-cplx_hsu', 4, NULL),
(1636, NULL, 'IPR001130', NULL, '3''-5'' ssDNA/RNA exonuclease TatD-like', 'TatD-like', 4, NULL),
(1637, NULL, 'IPR004527', NULL, 'Glutamate-tRNA ligase, bacterial/mitochondrial', 'Glu-tRNA-ligase_bac/mito', 4, NULL),
(1638, NULL, 'IPR000212', NULL, 'DNA helicase, UvrD/REP type', 'DNA_helicase_UvrD/REP', 4, NULL),
(1639, NULL, 'IPR002597', NULL, 'Herpesvirus major envelope glycoprotein', 'Herpes_env', 4, NULL),
(1640, NULL, 'IPR002565', NULL, 'Orbivirus NS3', 'Orbi_NS3', 4, NULL),
(1641, NULL, 'IPR007572', NULL, 'Uncharacterised protein family Ycf20', 'Uncharacterised_Ycf20', 4, NULL),
(1642, NULL, 'IPR003190', NULL, 'Aspartate decarboxylase', 'Asp_decarbox', 4, NULL),
(1643, NULL, 'IPR000001', NULL, 'Kringle', 'Kringle', 3, NULL),
(1644, NULL, 'IPR005536', NULL, 'Peptidase C25, Ig-like domain', 'Peptidase_C25_Ig-like_domain', 3, NULL),
(1645, NULL, 'IPR002575', NULL, 'Aminoglycoside phosphotransferase', 'Aminoglycoside_PTrfase', 3, NULL),
(1646, NULL, 'IPR003200', NULL, 'Nicotinate-nucleotide-dimethylbenzimidazole phosphoribosyltransferase', 'Nict_dMeBzImd_PRibTrfase', 4, NULL),
(1647, NULL, 'IPR004926', NULL, 'Late embryogenesis abundant protein, LEA_3 subgroup', 'LEA_3', 4, NULL),
(1648, NULL, 'IPR004910', NULL, 'Yippee/Mis18/Cereblon', 'Yippee/Mis18/Cereblon', 3, NULL),
(1649, NULL, 'IPR010948', NULL, 'TonB-dependent lactoferrin/transferrin receptor', 'TonB_lacto/transferrin_rcpt', 4, NULL),
(1650, NULL, 'IPR002554', NULL, 'Protein phosphatase 2A, regulatory B subunit, B56', 'PP2A_B56', 4, NULL),
(1651, NULL, 'IPR010943', NULL, 'Xanthosine phosphorylase', 'Xanthosine_phosphorylase', 4, NULL),
(1652, NULL, 'IPR005563', NULL, 'Assembly protein', 'A_protein', 4, NULL),
(1653, NULL, 'IPR004944', NULL, 'Cyclin-dependent kinase 5 activator', 'CDK5_activator', 4, NULL),
(1654, NULL, 'IPR005570', NULL, 'RNA polymerase, Rpb8', 'RNA_pol_Rpb8', 4, NULL),
(1655, NULL, 'IPR003126', NULL, 'Zinc finger, UBR-type', 'Znf_UBR', 3, NULL),
(1656, NULL, 'IPR004530', NULL, 'Phenylalanyl-tRNA synthetase, class IIc, mitochondrial', 'Phe-tRNA-synth_IIc_mito', 4, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(1657, NULL, 'IPR004087', NULL, 'K Homology domain', 'KH_dom', 3, NULL),
(1658, NULL, 'IPR005535', NULL, 'Cyclotide', 'Cyclotide', 4, NULL),
(1659, NULL, 'IPR034005', NULL, 'Peptidyl-dipeptidase DCP', 'M3A_DCP', 4, NULL),
(1660, NULL, 'IPR000125', NULL, 'Glycoside hydrolase, family 14A, bacterial', 'Glyco_hydro_14A_bac', 4, NULL),
(1661, NULL, 'IPR002552', NULL, 'Spike glycoprotein S2, coronavirus', 'Spike_S2_CoV', 3, NULL),
(1662, NULL, 'IPR002553', NULL, 'Clathrin/coatomer adaptor, adaptin-like, N-terminal', 'Clathrin/coatomer_adapt-like_N', 3, NULL),
(1663, NULL, 'IPR005559', NULL, 'CG-1 DNA-binding domain', 'CG-1_dom', 3, NULL),
(1664, NULL, 'IPR000147', NULL, 'Angiotensin II receptor type 2', 'ATII_AT2_rcpt', 4, NULL),
(1665, NULL, 'IPR004919', NULL, 'Domain of unknown function DUF262', 'DUF262', 3, NULL),
(1666, NULL, 'IPR009596', NULL, 'Domain of unknown function DUF1204', 'DUF1204', 3, NULL),
(1667, NULL, 'IPR003695', NULL, 'Ppx/GppA phosphatase', 'Ppx_GppA', 3, NULL),
(1668, NULL, 'IPR009610', NULL, 'CbtA toxin of type IV toxin-antitoxin system', 'CbtA_toxin', 4, NULL),
(1669, NULL, 'IPR009623', NULL, 'Uncharacterised protein family UPF0242, N-terminal', 'UPF0242_N', 3, NULL),
(1670, NULL, 'IPR003154', NULL, 'S1/P1 nuclease', 'S1/P1nuclease', 4, NULL),
(1671, NULL, 'IPR004506', NULL, 'tRNA-specific 2-thiouridylase', 'tRNA-specific_2-thiouridylase', 4, NULL),
(1672, NULL, 'IPR000121', NULL, 'PEP-utilising enzyme, C-terminal', 'PEP_util_C', 3, NULL),
(1673, NULL, 'IPR007568', NULL, 'RTA-like protein', 'RTA1', 4, NULL),
(1674, NULL, 'IPR009599', NULL, 'Protein of unknown function DUF1207', 'DUF1207', 4, NULL),
(1675, NULL, 'IPR004927', NULL, 'Alkylmercury lyase', 'MerB', 4, NULL),
(1676, NULL, 'IPR007582', NULL, 'TFIID subunit TAF5, NTD2 domain', 'TFIID_NTD2', 3, NULL),
(1677, NULL, 'IPR002545', NULL, 'CheW-like domain', 'CheW-lke_dom', 3, NULL),
(1678, NULL, 'IPR002594', NULL, 'Glycoside hydrolase family 12', 'GH12', 4, NULL),
(1679, NULL, 'IPR004520', NULL, 'tRNA modification GTPase MnmE', 'GTPase_MnmE', 4, NULL),
(1680, NULL, 'IPR004100', NULL, 'ATPase, F1/V1/A1 complex, alpha/beta subunit, N-terminal domain', 'ATPase_F1/V1/A1_a/bsu_N', 3, NULL),
(1681, NULL, 'IPR006675', NULL, 'HDIG domain', 'HDIG_dom', 3, NULL),
(1682, NULL, 'IPR003130', NULL, 'Dynamin GTPase effector', 'GED', 3, NULL),
(1683, NULL, 'IPR002574', NULL, 'M matrix/glycoprotein, coronavirus', 'M_CoV', 4, NULL),
(1684, NULL, 'IPR004500', NULL, 'Prolyl-tRNA synthetase, class IIa, bacterial-type', 'Pro-tRNA-synth_IIa_bac-type', 4, NULL),
(1685, NULL, 'IPR004521', NULL, 'Uncharacterised domain CHP00451', 'Uncharacterised_CHP00451', 3, NULL),
(1686, NULL, 'IPR009622', NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex assembly factor 4', 'NDUFAF4', 4, NULL),
(1687, NULL, 'IPR007566', NULL, 'Phosphoenolpyruvate carboxylase, archaeal-type', 'PEP_COase_arc-type', 4, NULL),
(1688, NULL, 'IPR004111', NULL, 'Tetracycline repressor TetR, C-terminal', 'Repressor_TetR_C', 3, NULL),
(1689, NULL, 'IPR000217', NULL, 'Tubulin', 'Tubulin', 4, NULL),
(1690, NULL, 'IPR002558', NULL, 'I/LWEQ domain', 'ILWEQ_dom', 3, NULL),
(1691, NULL, 'IPR003685', NULL, 'Photosystem I PsaD', 'PsaD', 4, NULL),
(1692, NULL, 'IPR006673', NULL, 'Mnh complex subunit C1', 'Mnh_C1_su', 4, NULL),
(1693, NULL, 'IPR004535', NULL, 'Translation elongation factor, selenocysteine-specific', 'Transl_elong_SelB', 4, NULL),
(1694, NULL, 'IPR003137', NULL, 'PA domain', 'PA_domain', 3, NULL),
(1695, NULL, 'IPR005543', NULL, 'PASTA domain', 'PASTA_dom', 3, NULL),
(1696, NULL, 'IPR009614', NULL, 'Toxin YoeB', 'YoeB_toxin', 4, NULL),
(1697, NULL, 'IPR004126', NULL, 'Phospholipase A2 inhibitor', 'PLipase_A2_inh', 3, NULL),
(1698, NULL, 'IPR005555', NULL, 'M-factor', 'M-factor', 4, NULL),
(1699, NULL, 'IPR004538', NULL, 'Haemolysin A /rRNA methyltransferase TlyA', 'Haemolysin_A/TlyA', 4, NULL),
(1700, NULL, 'IPR003128', NULL, 'Villin headpiece', 'Villin_headpiece', 3, NULL),
(1701, NULL, 'IPR007574', NULL, 'Phycobilisome degradation protein NblA', 'NblA', 4, NULL),
(1702, NULL, 'IPR000132', NULL, 'Nitrilase/cyanide hydratase, conserved site', 'Nitrilase/CN_hydratase_CS', 2, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(1703, NULL, 'IPR004113', NULL, 'FAD-linked oxidase, C-terminal', 'FAD-linked_oxidase_C', 3, NULL),
(1704, NULL, 'IPR004084', NULL, 'Meiosis-specific protein Spo11', 'Meiosis_Spo11', 3, NULL),
(1705, NULL, 'IPR005579', NULL, 'Cgr1-like', 'Cgr1-like', 4, NULL),
(1706, NULL, 'IPR002550', NULL, 'CNNM, transmembrane domain', 'CNNM', 3, NULL),
(1707, NULL, 'IPR002582', NULL, 'Holo-[acyl carrier protein] synthase', 'ACPS', 4, NULL),
(1708, NULL, 'IPR005567', NULL, 'Fushi tarazu, N-terminal', 'FTZ_N', 3, NULL),
(1709, NULL, 'IPR000118', NULL, 'Granulin', 'Granulin', 3, NULL),
(1710, NULL, 'IPR009589', NULL, 'Sublancin immunity protein SunI', 'SunI', 4, NULL),
(1711, NULL, 'IPR004515', NULL, 'Phosphoheptose isomerase', 'Phosphoheptose_Isoase', 4, NULL),
(1712, NULL, 'IPR009602', NULL, 'CBY1-interacting BAR domain-containing protein/FAM92', 'CBAR/FAM92', 4, NULL),
(1713, NULL, 'IPR007567', NULL, 'Mid2 domain', 'Mid2_dom', 3, NULL),
(1714, NULL, 'IPR005530', NULL, 'SPW repeat', 'SPW', 7, NULL),
(1715, NULL, 'IPR003117', NULL, 'cAMP-dependent protein kinase regulatory subunit, dimerization-anchoring domain', 'cAMP_dep_PK_reg_su_I/II_a/b', 3, NULL),
(1716, NULL, 'IPR009607', NULL, 'Enhancer of polycomb, C-terminal', 'Enhancer_polycomb_C', 3, NULL),
(1717, NULL, 'IPR010954', NULL, 'Chorismate mutase, Firmicutes/Deinococcus', 'Chorismate_mutase_GmP-bac', 3, NULL),
(1718, NULL, 'IPR009601', NULL, 'Centromere protein R', 'CENP-R', 4, NULL),
(1719, NULL, 'IPR009590', NULL, 'Protein Gp5, N-terminal OB-fold domain', 'Gp5_OB_N', 3, NULL),
(1720, NULL, 'IPR001122', NULL, 'Flavivirus capsid protein C', 'Flavi_capsidC', 3, NULL),
(1721, NULL, 'IPR003186', NULL, 'Proteasome activator PA28, C-terminal domain', 'PA28_C', 3, NULL),
(1722, NULL, 'IPR005574', NULL, 'RNA polymerase subunit Rpb4/RPC9', 'Rpb4/RPC9', 4, NULL),
(1723, NULL, 'IPR004085', NULL, 'DNA topoisomerase VI, subunit A', 'TopoVI_A', 4, NULL),
(1724, NULL, 'IPR005585', NULL, 'Protein of unknown function DUF327', 'DUF327', 4, NULL),
(1725, NULL, 'IPR009603', NULL, 'Microtubule associated protein Futsch', 'MAP_Futsch', 7, NULL),
(1726, NULL, 'IPR034184', NULL, 'Putative acyl-CoA dehydrogenase AidB', 'AidB', 4, NULL),
(1727, NULL, 'IPR007570', NULL, 'Uncharacterised protein family Ycf23', 'Uncharacterised_Ycf23', 4, NULL),
(1728, NULL, 'IPR004941', NULL, 'FP protein', 'FP', 4, NULL),
(1729, NULL, 'IPR004525', NULL, 'Elongation factor P--(R)-beta-lysine ligase', 'EpmA', 4, NULL),
(1730, NULL, 'IPR005540', NULL, 'KNOX1', 'KNOX1', 3, NULL),
(1731, NULL, 'IPR005558', NULL, 'Crustacean neurohormone H', 'Crust_neurhormone_H', 3, NULL),
(1732, NULL, 'IPR000176', NULL, 'mRNA methyltransferase-like', 'mRNA_MeTrfase-like', 4, NULL),
(1733, NULL, 'IPR005552', NULL, 'Scramblase', 'Scramblase', 4, NULL),
(1734, NULL, 'IPR005534', NULL, 'Curli production assembly/transport component CsgG', 'Curli_assmbl/transp-comp_CsgG', 4, NULL),
(1735, NULL, 'IPR005538', NULL, 'LrgA/CidA family', 'LrgA/CidA', 4, NULL),
(1736, NULL, 'IPR006679', NULL, 'Adenine deaminase', 'Adenine_deam', 4, NULL),
(1737, NULL, 'IPR000178', NULL, 'Translation initiation factor IF-2, bacterial-like', 'TF_IF2_bacterial-like', 4, NULL),
(1738, NULL, 'IPR004531', NULL, 'Phenylalanyl-tRNA synthetase, class IIc, beta subunit, archaeal/eukaryotic type', 'Phe-tRNA-synth_IIc_bsu_arc_euk', 4, NULL),
(1739, NULL, 'IPR005554', NULL, 'NOL6/Upt22', 'NOL6/Upt22', 4, NULL),
(1740, NULL, 'IPR005568', NULL, 'Ribosomal protein L6, N-terminal', 'Ribosomal_L6_N', 3, NULL),
(1741, NULL, 'IPR004072', NULL, 'Vomeronasal receptor, type 1', 'Vmron_rcpt_1', 4, NULL),
(1742, NULL, 'IPR004933', NULL, 'Type specific antigen', 'TSA', 4, NULL),
(1743, NULL, 'IPR004898', NULL, 'Pectate lyase PlyH/PlyE-like', 'Pectate_lyase_PlyH/PlyE-like', 4, NULL),
(1744, NULL, 'IPR009600', NULL, 'GPI transamidase subunit PIG-U', 'PIG-U', 4, NULL),
(1745, NULL, 'IPR005533', NULL, 'AMOP domain', 'AMOP_dom', 3, NULL),
(1746, NULL, 'IPR005524', NULL, 'Predicted permease DUF318', 'DUF318', 4, NULL),
(1747, NULL, 'IPR004086', NULL, 'P pili tip fibrillum PapE protein, Enterobacteriaceae', 'P_pili_tip_fibrillum_PapE', 4, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(1748, NULL, 'IPR005542', NULL, 'PBX, PBC domain', 'PBX_PBC_dom', 3, NULL),
(1749, NULL, 'IPR005523', NULL, 'Domain of unknown function DUF317, SPDY', 'DUF317_SPDY', 3, NULL),
(1750, NULL, 'IPR002556', NULL, 'Arterivirus GP3 envelope glycoprotein', 'Arteri_GP3', 4, NULL),
(1751, NULL, 'IPR002603', NULL, 'ET repeat', 'ET_repeat', 7, NULL),
(1752, NULL, 'IPR002561', NULL, 'Filoviruses glycoprotein, extracellular domain', 'GPC_filovir-type_extra_dom', 3, NULL),
(1753, NULL, 'IPR009595', NULL, 'Bacteriophage DNA replication protein Gp16.7', 'Phage_DNA_replic_GP16.7', 4, NULL),
(1754, NULL, 'IPR004508', NULL, 'Thioredoxin-independent 5''-adenylylsulphate reductase', 'Thioredoxin-indep_APS_Rdtase', 4, NULL),
(1755, NULL, 'IPR000213', NULL, 'Vitamin D-binding protein', 'VitD-bd', 4, NULL),
(1756, NULL, 'IPR000184', NULL, 'Bacterial surface antigen (D15)', 'Bac_surfAg_D15', 3, NULL),
(1757, NULL, 'IPR000222', NULL, 'PPM-type phosphatase, divalent cation binding', 'PP2C_BS', 1, NULL),
(1758, NULL, 'IPR034622', NULL, '4R-hydroxyproline betaine 2-epimerase', '4R-hPro_betaine_2-epimerase', 4, NULL),
(1759, NULL, 'IPR004116', NULL, 'Amelogenin', 'Amelogenin', 4, NULL),
(1760, NULL, 'IPR003143', NULL, 'Cytochrome cd1-nitrite reductase, C-terminal domain superfamily', 'Cyt_cd1_C_sf', 5, NULL),
(1761, NULL, 'IPR003193', NULL, 'ADP-ribosyl cyclase (CD38/157)', 'ADP-ribosyl_cyclase', 4, NULL),
(1762, NULL, 'IPR004077', NULL, 'Interleukin-1 receptor type II', 'IL-1_rcpt_II-typ', 4, NULL),
(1763, NULL, 'IPR004532', NULL, 'Phenylalanine-tRNA ligase, class IIc, beta subunit, bacterial type', 'Phe-tRNA-ligase_IIc_bsu_bact', 4, NULL),
(1764, NULL, 'IPR002601', NULL, 'C6 domain', 'C6_domain', 3, NULL),
(1765, NULL, 'IPR005517', NULL, 'Translation elongation factor EFG/EF2, domain IV', 'Transl_elong_EFG/EF2_IV', 3, NULL),
(1766, NULL, 'IPR005560', NULL, 'Protein of unknown function DUF326', 'DUF326', 7, NULL),
(1767, NULL, 'IPR004911', NULL, 'Gamma interferon inducible lysosomal thiol reductase GILT', 'Interferon-induced_GILT', 4, NULL),
(1768, NULL, 'IPR003688', NULL, 'Type IV secretion system protein TraG/VirD4', 'TraG/VirD4', 4, NULL),
(1769, NULL, 'IPR003146', NULL, 'Carboxypeptidase, activation peptide', 'M14A_act_pep', 3, NULL),
(1770, NULL, 'IPR002541', NULL, 'Cytochrome c assembly protein', 'Cyt_c_assembly', 3, NULL),
(1771, NULL, 'IPR000167', NULL, 'Dehydrin', 'Dehydrin', 4, NULL),
(1772, NULL, 'IPR000170', NULL, 'High potential iron-sulphur protein', 'High_potential_FeS_prot', 3, NULL),
(1773, NULL, 'IPR009625', NULL, 'FeGP cofactor biosynthesis protein HcgF', 'HcgF', 4, NULL),
(1774, NULL, 'IPR004524', NULL, 'Aspartate-tRNA ligase, type 1', 'Asp-tRNA-ligase_1', 4, NULL),
(1775, NULL, 'IPR009617', NULL, 'Seipin family', 'Seipin', 4, NULL),
(1776, NULL, 'IPR005528', NULL, 'Chaplin domain', 'ChpA-H', 3, NULL),
(1777, NULL, 'IPR010944', NULL, 'AMP nucleosidase, putative', 'AMN-like', 4, NULL),
(1778, NULL, 'IPR004125', NULL, 'Signal recognition particle, SRP54 subunit, M-domain', 'Signal_recog_particle_SRP54_M', 3, NULL),
(1779, NULL, 'IPR006659', NULL, 'Arsenate reductase', 'Arsenate_reductase', 4, NULL),
(1780, NULL, 'IPR004080', NULL, 'Foot-and-mouth disease virus VP1 coat', 'FMDV_VP1_coat', 3, NULL),
(1781, NULL, 'IPR003132', NULL, 'Protein A, Ig-binding domain', 'Protein_A_Ig-bd', 3, NULL),
(1782, NULL, 'IPR004542', NULL, 'Translation elongation factor EF1B, beta chain, archaeal', 'Transl_elong_EF1B_B_arc', 4, NULL),
(1783, NULL, 'IPR000151', NULL, 'Ciliary neurotrophic factor, CNTF', 'Ciliary_neurotrophic_fac_CNTF', 4, NULL),
(1784, NULL, 'IPR003171', NULL, 'Methylenetetrahydrofolate reductase-like', 'Mehydrof_redctse-like', 4, NULL),
(1785, NULL, 'IPR002544', NULL, 'FMRFamide-related peptide-like', 'FMRFamid-related_peptide-like', 4, NULL),
(1786, NULL, 'IPR006665', NULL, 'OmpA-like domain', 'OmpA-like', 3, NULL),
(1787, NULL, 'IPR000120', NULL, 'Amidase', 'Amidase', 4, NULL),
(1788, NULL, 'IPR002583', NULL, 'Ribosomal protein S20', 'Ribosomal_S20', 4, NULL),
(1789, NULL, 'IPR006674', NULL, 'HD domain', 'HD_domain', 3, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(1790, NULL, 'IPR002592', NULL, 'Viral attachment sigma 1, reoviral', 'Vir_attach_sigma1_reovir', 4, NULL),
(1791, NULL, 'IPR002610', NULL, 'Peptidase S54, rhomboid', 'Peptidase_S54_rhomboid', 4, NULL),
(1792, NULL, 'IPR009613', NULL, 'Lipase maturation factor', 'LMF', 4, NULL),
(1793, NULL, 'IPR002571', NULL, 'Heat-inducible transcription repressor HrcA', 'HrcA', 4, NULL),
(1794, NULL, 'IPR000160', NULL, 'GGDEF domain', 'GGDEF_dom', 3, NULL),
(1795, NULL, 'IPR005522', NULL, 'Inositol polyphosphate kinase', 'IPK', 4, NULL),
(1796, NULL, 'IPR002547', NULL, 'tRNA-binding domain', 'tRNA-bd_dom', 3, NULL),
(1797, NULL, 'IPR000142', NULL, 'P2Y purinoceptor 1', 'P2Y1_rcpt', 4, NULL),
(1798, NULL, 'IPR003182', NULL, 'RNA2 polyprotein', 'RNA2_polyprotein', 4, NULL),
(1799, NULL, 'IPR004107', NULL, 'Integrase, SAM-like, N-terminal', 'Integrase_SAM-like_N', 3, NULL),
(1800, NULL, 'IPR003683', NULL, 'Cytochrome b6/f complex, subunit 5', 'Cyt_6/f_cplx_su5', 4, NULL),
(1801, NULL, 'IPR007580', NULL, 'Poxvirus T4 protein, N-terminal', 'Poxvirus_T4p_N', 3, NULL),
(1802, NULL, 'IPR004946', NULL, 'Cucumovirus protein 2B', 'Cucumo_2B', 4, NULL),
(1803, NULL, 'IPR000153', NULL, 'Reovirus, outer capsid sigma 3', 'Reo_capsid_sigma3', 4, NULL),
(1804, NULL, 'IPR009615', NULL, 'Viral desmoplakin, N-terminal', 'Desmo_N', 3, NULL),
(1805, NULL, 'IPR004522', NULL, 'Asparagine-tRNA ligase', 'Asn-tRNA-ligase', 4, NULL),
(1806, NULL, 'IPR003140', NULL, 'Phospholipase/carboxylesterase/thioesterase', 'PLipase/COase/thioEstase', 3, NULL),
(1807, NULL, 'IPR004071', NULL, 'Cysteinyl leukotriene receptor', 'Cyst_leuk_rcpt', 4, NULL),
(1808, NULL, 'IPR005527', NULL, 'Cell division topological specificity factor MinE', 'MinE', 4, NULL),
(1809, NULL, 'IPR009594', NULL, 'Transcription regulator HTH, AraC, N-terminal', 'Tscrpt_reg_HTH_AraC_N', 3, NULL),
(1810, NULL, 'IPR010953', NULL, 'Citrate synthase, type I', 'Citrate_synthase_typ-I', 4, NULL),
(1811, NULL, 'IPR005564', NULL, 'Major capsid protein GpE', 'Major_capsid_GpE', 4, NULL),
(1812, NULL, 'IPR004918', NULL, 'Cdc37', 'Cdc37', 4, NULL),
(1813, NULL, 'IPR008252', NULL, 'Peptidase S15, X-Pro dipeptidyl-peptidase', 'Pept_S15_Xpro', 4, NULL),
(1814, NULL, 'IPR004127', NULL, 'Prefoldin alpha-like', 'Prefoldin_subunit_alpha', 4, NULL),
(1815, NULL, 'IPR004079', NULL, 'Gonadoliberin I precursor', 'Gonadoliberin_I_precursor', 4, NULL),
(1816, NULL, 'IPR003176', NULL, 'Adenovirus DNA-binding, all-alpha domain', 'Adenovirus_DNA-bd_a', 3, NULL),
(1817, NULL, 'IPR004095', NULL, 'TGS', 'TGS', 3, NULL),
(1818, NULL, 'IPR002567', NULL, 'Envelope glycoprotein K', 'GK', 4, NULL),
(1819, NULL, 'IPR003692', NULL, 'Hydantoinase B/oxoprolinase', 'Hydantoinase_B', 3, NULL),
(1820, NULL, 'IPR004507', NULL, 'Flavin prenyltransferase UbiX-like', 'UbiX-like', 4, NULL),
(1821, NULL, 'IPR009592', NULL, 'Protein of unknown function DUF1202', 'DUF1202', 4, NULL),
(1822, NULL, 'IPR005537', NULL, 'CRISPR type III-associated protein', 'RAMP_III_fam', 4, NULL),
(1823, NULL, 'IPR004902', NULL, 'Rhabdovirus nucleoprotein', 'Rhabdo_ncap_2', 4, NULL),
(1824, NULL, 'IPR004124', NULL, 'Glycoside hydrolase, family 33, N-terminal', 'Glyco_hydro_33_N', 3, NULL),
(1825, NULL, 'IPR000218', NULL, 'Ribosomal protein L14P', 'Ribosomal_L14P', 4, NULL),
(1826, NULL, 'IPR004509', NULL, 'Competence protein ComEA, helix-hairpin-helix domain', 'Competence_ComEA_HhH', 3, NULL),
(1827, NULL, 'IPR004097', NULL, 'DHHA2 domain', 'DHHA2', 3, NULL),
(1828, NULL, 'IPR004537', NULL, 'Tellurite resistance methyltransferase, TehB', 'Tellurite-R_MeTrfase_TehB', 4, NULL),
(1829, NULL, 'IPR005584', NULL, 'DNA gyrase inhibitor YacG', 'DNA_gyrase_inhibitor_YacG', 4, NULL),
(1830, NULL, 'IPR004922', NULL, 'ESAG protein', 'ESAG', 4, NULL),
(1831, NULL, 'IPR004504', NULL, 'DNA repair protein RadA', 'DNA_repair_RadA', 4, NULL),
(1832, NULL, 'IPR002542', NULL, 'Domain of unknown function DUF19', 'DUF19', 3, NULL),
(1833, NULL, 'IPR009598', NULL, 'Bladder cancer-related BC10', 'BC10', 4, NULL),
(1834, NULL, 'IPR002569', NULL, 'Peptide methionine sulphoxide reductase MsrA domain', 'Met_Sox_Rdtase_MsrA_dom', 3, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(1835, NULL, 'IPR002543', NULL, 'FtsK domain', 'FtsK_dom', 3, NULL),
(1836, NULL, 'IPR004074', NULL, 'Interleukin-1 receptor type I/II', 'IL-1_rcpt_I/II-typ', 4, NULL),
(1837, NULL, 'IPR008915', NULL, 'Peptidase M50', 'Peptidase_M50', 3, NULL),
(1838, NULL, 'IPR005588', NULL, 'MucB/RseB', 'MucB_RseB', 4, NULL),
(1839, NULL, 'IPR005566', NULL, 'Hydrophobic abundant protein (HAP)', 'HAP', 4, NULL),
(1840, NULL, 'IPR004104', NULL, 'Gfo/Idh/MocA-like oxidoreductase, C-terminal', 'Gfo/Idh/MocA-like_OxRdtase_C', 3, NULL),
(1841, NULL, 'IPR000182', NULL, 'GNAT domain', 'GNAT_dom', 3, NULL),
(1842, NULL, 'IPR009620', NULL, 'Uncharacterised protein family UPF0236', 'UPF0236', 4, NULL),
(1843, NULL, 'IPR004083', NULL, 'Regulatory associated protein of TOR', 'Raptor', 4, NULL),
(1844, NULL, 'IPR005586', NULL, 'ABC-type transport auxiliary lipoprotein component', 'ABC_trans_aux', 3, NULL),
(1845, NULL, 'IPR006671', NULL, 'Cyclin, N-terminal', 'Cyclin_N', 3, NULL),
(1846, NULL, 'IPR009626', NULL, 'Major intrinsically disordered Notch2-binding receptor 1-like, C-terminal', 'MINAR1-like_C', 3, NULL),
(1847, NULL, 'IPR000149', NULL, 'Haemagglutinin, influenzavirus A', 'Hemagglutn_influenz_A', 4, NULL),
(1848, NULL, 'IPR006669', NULL, 'Magnesium transporter MgtE', 'MgtE_transporter', 4, NULL),
(1849, NULL, 'IPR004935', NULL, 'Tymovirus 45/70kDa protein', '45/70kDa_tymovirus', 4, NULL),
(1850, NULL, 'IPR003123', NULL, 'VPS9 domain', 'VPS9', 3, NULL),
(1851, NULL, 'IPR001277', NULL, 'CXC chemokine receptor 4/atypical chemokine receptor 2', 'CXCR4/ACKR2', 4, NULL),
(1852, NULL, 'IPR003174', NULL, 'Alpha trans-inducing protein (Alpha-TIF)', 'Alpha_TIF', 4, NULL),
(1853, NULL, 'IPR009631', NULL, 'CGLD27-like', 'CGLD27-like', 4, NULL),
(1854, NULL, 'IPR000157', NULL, 'Toll/interleukin-1 receptor homology (TIR) domain', 'TIR_dom', 3, NULL),
(1855, NULL, 'IPR004534', NULL, 'L-seryl-tRNA(Sec) selenium transferase', 'SelA_trans', 4, NULL),
(1856, NULL, 'IPR004937', NULL, 'Urea transporter', 'Urea_transporter', 4, NULL),
(1857, NULL, 'IPR004497', NULL, 'NADH-plastoquinone oxidoreductase, subunit I', 'NADH_plast_OxRdtase_su_I', 4, NULL),
(1858, NULL, 'IPR007577', NULL, 'Glycosyltransferase, DXD sugar-binding motif', 'GlycoTrfase_DXD_sugar-bd_CS', 2, NULL),
(1859, NULL, 'IPR003150', NULL, 'DNA-binding RFX-type winged-helix domain', 'DNA-bd_RFX', 3, NULL),
(1860, NULL, 'IPR003159', NULL, 'Polysaccharide lyase family 8, central domain', 'Lyase_8_central_dom', 3, NULL),
(1861, NULL, 'IPR004928', NULL, 'Photosystem I PsaH, reaction centre subunit VI', 'PSI_PsaH', 4, NULL),
(1862, NULL, 'IPR005583', NULL, 'Peroxide stress protein YaaA', 'YaaA', 4, NULL),
(1863, NULL, 'IPR002596', NULL, 'Plasmid partition protein', 'Plasmid_parti', 4, NULL),
(1864, NULL, 'IPR007563', NULL, 'Protein of unknown function DUF554', 'DUF554', 4, NULL),
(1865, NULL, 'IPR004076', NULL, 'Interleukin-1 receptor type 1', 'IL-1_rcpt_I-typ', 4, NULL),
(1866, NULL, 'IPR000186', NULL, 'Interleukin-5', 'IL-5', 4, NULL),
(1867, NULL, 'IPR006677', NULL, 'tRNA intron endonuclease, catalytic domain-like', 'tRNA_intron_Endonuc_cat-like', 3, NULL),
(1868, NULL, 'IPR004541', NULL, 'Translation elongation factor EFTu/EF1A, bacterial/organelle', 'Transl_elong_EFTu/EF1A_bac/org', 4, NULL),
(1869, NULL, 'IPR003184', NULL, 'Major secreted virus protein, 35kDa', 'Orthopox_35kDa', 4, NULL),
(1870, NULL, 'IPR004496', NULL, 'Ferredoxin-type protein NapF', 'NapF', 4, NULL),
(1871, NULL, 'IPR007579', NULL, 'Poxvirus T4 protein, C-terminal', 'Poxvirus_T4p_C', 3, NULL),
(1872, NULL, 'IPR004090', NULL, 'Chemotaxis methyl-accepting receptor', 'Chemotax_Me-accpt_rcpt', 4, NULL),
(1873, NULL, 'IPR002540', NULL, 'Peptidase S30, polyprotein P1, potyvirus', 'Pept_S30_P1_potyvir', 3, NULL),
(1874, NULL, 'IPR008422', NULL, 'Homeobox KN domain', 'Homeobox_KN_domain', 3, NULL),
(1875, NULL, 'IPR007564', NULL, 'Uncharacterised protein family UPF0212', 'UPF0212', 4, NULL),
(1876, NULL, 'IPR005573', NULL, 'Anti sigma-E protein RseA, C-terminal', 'Anti-sigma_E_RseA_C', 3, NULL),
(1877, NULL, 'IPR004913', NULL, 'Herpesvirus glycoprotein J', 'Herpes_gJ', 4, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(1878, NULL, 'IPR005518', NULL, 'Remorin, N-terminal', 'Remorin_N', 3, NULL),
(1879, NULL, 'IPR003152', NULL, 'FATC domain', 'FATC_dom', 3, NULL),
(1880, NULL, 'IPR009612', NULL, 'IcmF-related', 'IcmF-related', 3, NULL),
(1881, NULL, 'IPR004912', NULL, 'Adenoviral core protein VII', 'Adeno_VII', 4, NULL),
(1882, NULL, 'IPR004101', NULL, 'Mur ligase, C-terminal', 'Mur_ligase_C', 3, NULL),
(1883, NULL, 'IPR003181', NULL, 'Large coat protein', 'Como_LCP', 4, NULL),
(1884, NULL, 'IPR000210', NULL, 'BTB/POZ domain', 'BTB/POZ_dom', 3, NULL),
(1885, NULL, 'IPR005580', NULL, 'DEAD box helicase DbpA/CsdA, RNA-binding domain', 'DbpA/CsdA_RNA-bd_dom', 3, NULL),
(1886, NULL, 'IPR005565', NULL, 'Haemolysin activator HlyB, C-terminal', 'Hemolysn_activator_HlyB_C', 3, NULL),
(1887, NULL, 'IPR002551', NULL, 'Spike glycoprotein S1, coronavirus', 'Spike_S1_CoV', 3, NULL),
(1888, NULL, 'IPR004899', NULL, 'Pertactin, central region', 'Pertactin_central', 3, NULL),
(1889, NULL, 'IPR002602', NULL, 'Domain of unknown function DB', 'DB', 3, NULL),
(1890, NULL, 'IPR003682', NULL, 'rRNA small subunit methyltransferase G', 'rRNA_ssu_MeTfrase_G', 4, NULL),
(1891, NULL, 'IPR009606', NULL, 'DESIGUAL/Modifying wall lignin-1/2', 'DEAL/Modifying_wall_lignin1/2', 4, NULL),
(1892, NULL, 'IPR000215', NULL, 'Serpin family', 'Serpin_fam', 4, NULL),
(1893, NULL, 'IPR002593', NULL, 'Domain of unknown function DX', 'DX', 3, NULL),
(1894, NULL, 'IPR004901', NULL, 'Reversibly glycosylated polypeptide', 'RGP', 4, NULL),
(1895, NULL, 'IPR004088', NULL, 'K Homology domain, type 1', 'KH_dom_type_1', 3, NULL),
(1896, NULL, 'IPR004512', NULL, 'Ribosomal RNA methyltransferase E, gammaproteobacteria', 'rRNA_MeTrfase_gammaproteobac', 4, NULL),
(1897, NULL, 'IPR005549', NULL, 'Kinetochore protein Nuf2, N-terminal', 'Kinetochore_Nuf2_N', 3, NULL),
(1898, NULL, 'IPR004939', NULL, 'APC10/DOC domain', 'APC_su10/DOC_dom', 3, NULL),
(1899, NULL, 'IPR004122', NULL, 'Barrier- to-autointegration factor, BAF', 'BAF_prot', 4, NULL),
(1900, NULL, 'IPR004942', NULL, 'Roadblock/LAMTOR2 domain', 'Roadblock/LAMTOR2_dom', 3, NULL),
(1901, NULL, 'IPR002579', NULL, 'Peptide methionine sulphoxide reductase MrsB domain', 'Met_Sox_Rdtase_MsrB_dom', 3, NULL),
(1902, NULL, 'IPR004119', NULL, 'Ecdysteroid kinase-like', 'EcKL', 4, NULL),
(1903, NULL, 'IPR005557', NULL, 'Colicin immunity protein', 'Colicin_im', 4, NULL),
(1904, NULL, 'IPR004907', NULL, 'ATPase, V1 complex, subunit C', 'ATPase_V1-cplx_csu', 4, NULL),
(1905, NULL, 'IPR007576', NULL, 'CITED', 'CITED', 4, NULL),
(1906, NULL, 'IPR003689', NULL, 'Zinc/iron permease', 'ZIP', 4, NULL),
(1907, NULL, 'IPR002587', NULL, 'Myo-inositol-1-phosphate synthase', 'Myo-inos-1-P_Synthase', 4, NULL),
(1908, NULL, 'IPR006668', NULL, 'Magnesium transporter, MgtE intracellular domain', 'Mg_transptr_MgtE_intracell_dom', 3, NULL),
(1909, NULL, 'IPR004940', NULL, 'Adhesin P1, C-terminal domain', 'Adhesin_P1_C', 3, NULL),
(1910, NULL, 'IPR004513', NULL, 'Cell division protein FtsX', 'ABC_transpt_FtsX', 4, NULL),
(1911, NULL, 'IPR004499', NULL, 'Proline-tRNA ligase, class IIa, archaeal-type', 'Pro-tRNA-ligase_IIa_arc-type', 4, NULL),
(1912, NULL, 'IPR004511', NULL, 'Phosphoadenosine phosphosulphate/adenosine 5''-phosphosulphate reductase', 'PAPS/APS_Rdtase', 4, NULL),
(1913, NULL, 'IPR007565', NULL, '(5-formylfuran-3-yl)methyl phosphate synthase', '4HFCP_synth', 4, NULL),
(1914, NULL, 'IPR004925', NULL, 'HpaB/PvcC/4-BUDH', 'HpaB/PvcC/4-BUDH', 4, NULL),
(1915, NULL, 'IPR004936', NULL, 'Herpesvirus UL21', 'Herpes_UL21', 4, NULL),
(1916, NULL, 'IPR005569', NULL, 'Arc-like DNA binding domain', 'Arc_DNA-bd_dom', 3, NULL),
(1917, NULL, 'IPR009584', NULL, 'Citrus tristeza virus 6kDa protein', 'CTV_6kDa', 4, NULL),
(1918, NULL, 'IPR004945', NULL, 'Coronavirus 6B/7B protein', 'Corona_6B_7B', 4, NULL),
(1919, NULL, 'IPR021160', NULL, 'Mitogen-activated protein (MAP) kinase kinase kinase kinase', 'MAPKKKK', 4, NULL),
(1920, NULL, 'IPR004093', NULL, 'Staphylokinase', 'SAK', 4, NULL),
(1921, NULL, 'IPR005556', NULL, 'SUN family', 'SUN', 4, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(1922, NULL, 'IPR005539', NULL, 'ELK domain', 'ELK_dom', 3, NULL),
(1923, NULL, 'IPR007575', NULL, 'SchA/CurD-like domain', 'SchA_CurD-like', 3, NULL),
(1924, NULL, 'IPR004938', NULL, 'Xyloglucan fucosyltransferase', 'XG_FTase', 4, NULL),
(1925, NULL, 'IPR003139', NULL, 'Delta-retroviral matrix protein', 'D_retro_matrix', 3, NULL),
(1926, NULL, 'IPR004065', NULL, 'Lysophosphatidic acid receptor', 'LPA_rcpt', 4, NULL),
(1927, NULL, 'IPR005571', NULL, 'RNA polymerase, Rpb5, N-terminal', 'RNA_pol_Rpb5_N', 3, NULL),
(1928, NULL, 'IPR009624', NULL, 'Uncharacterised protein family UPF0253', 'UPF0253', 4, NULL),
(1929, NULL, 'IPR004082', NULL, 'Protein OBERON', 'OBERON', 4, NULL),
(1930, NULL, 'IPR003162', NULL, 'Transcription initiation factor TAFII31', 'TFIID-31', 4, NULL),
(1931, NULL, 'IPR004502', NULL, 'Thioredoxins/glutaredoxin', 'Thio_glut', 4, NULL),
(1932, NULL, 'IPR003173', NULL, 'Transcriptional coactivator p15 (PC4), C-terminal', 'PC4_C', 3, NULL),
(1933, NULL, 'IPR003204', NULL, 'Cytochrome c oxidase, subunit Va/VI', 'Cyt_c_oxidase_su5A/6', 4, NULL),
(1934, NULL, 'IPR006664', NULL, 'Outer membrane protein, bacterial', 'OMP_bac', 3, NULL),
(1935, NULL, 'IPR000190', NULL, 'Angiotensin II receptor type 1', 'ATII_AT1_rcpt', 4, NULL),
(1936, NULL, 'IPR003136', NULL, 'Cytidylate kinase', 'Cytidylate_kin', 4, NULL),
(1937, NULL, 'IPR005541', NULL, 'KNOX2', 'KNOX2', 3, NULL),
(1938, NULL, 'IPR002572', NULL, 'Domain of unknown function DUF22', 'DUF22', 3, NULL),
(1939, NULL, 'IPR009630', NULL, 'Protein of unknown function DUF1229', 'DUF1229', 4, NULL),
(1940, NULL, 'IPR004115', NULL, 'GAD-like domain superfamily', 'GAD-like_sf', 5, NULL),
(1941, NULL, 'IPR002563', NULL, 'Flavin reductase like domain', 'Flavin_Rdtase-like_dom', 3, NULL),
(1942, NULL, 'IPR005521', NULL, 'Attacin, C-terminal', 'Attacin_C', 3, NULL),
(1943, NULL, 'IPR002589', NULL, 'Macro domain', 'Macro_dom', 3, NULL),
(1944, NULL, 'IPR001127', NULL, 'Phosphotransferase system, sugar-specific permease EIIA type 1', 'PTS_EIIA_1_perm', 3, NULL),
(1945, NULL, 'IPR000189', NULL, 'Prokaryotic transglycosylase, active site', 'Transglyc_AS', 0, NULL),
(1946, NULL, 'IPR004501', NULL, 'Phosphotransferase system, EIIC component, type 3', 'PTS_EIIC_3', 3, NULL),
(1947, NULL, 'IPR002586', NULL, 'CobQ/CobB/MinD/ParA nucleotide binding domain', 'CobQ/CobB/MinD/ParA_Nub-bd_dom', 3, NULL),
(1948, NULL, 'IPR009628', NULL, 'Bacteriophage tail tape measure, N-terminal', 'Phage_tape_measure_N', 3, NULL),
(1949, NULL, 'IPR000156', NULL, 'Ran binding domain', 'Ran_bind_dom', 3, NULL),
(1950, NULL, 'IPR007581', NULL, 'Endonuclease V', 'Endonuclease-V', 4, NULL),
(1951, NULL, 'IPR002568', NULL, 'Carlavirus nucleic acid-binding protein', 'Carla-bd', 4, NULL),
(1952, NULL, 'IPR005519', NULL, 'Acid phosphatase, class B-like', 'Acid_phosphat_B-like', 4, NULL),
(1953, NULL, 'IPR004539', NULL, 'Translation elongation factor EF1A, eukaryotic/archaeal', 'Transl_elong_EF1A_euk/arc', 4, NULL),
(1954, NULL, 'IPR034006', NULL, 'Oligopeptidase F type 2', 'M3B_PepF_2', 4, NULL),
(1955, NULL, 'IPR003179', NULL, 'Methyl-coenzyme M reductase, beta subunit', 'Me_CoM_Rdtase_bsu', 4, NULL),
(1956, NULL, 'IPR034020', NULL, 'Tumour necrosis factor receptor 9, N-terminal', 'TNFRSF9_N', 3, NULL),
(1957, NULL, 'IPR005562', NULL, 'SpoVA', 'SpoVA', 4, NULL),
(1958, NULL, 'IPR003175', NULL, 'Cyclin-dependent kinase inhibitor domain', 'CDI_dom', 3, NULL),
(1959, NULL, 'IPR009621', NULL, 'Uncharacterised protein family UPF0239', 'UPF0239', 4, NULL),
(1960, NULL, 'IPR004069', NULL, 'CC chemokine receptor 9', 'Chemokine_CCR9', 4, NULL),
(1961, NULL, 'IPR004094', NULL, 'Antistasin-like domain', 'Antistasin-like', 3, NULL),
(1962, NULL, 'IPR003169', NULL, 'GYF domain', 'GYF', 3, NULL),
(1963, NULL, 'IPR004903', NULL, 'Lactobacillus surface layer protein', 'S-layer_prot', 4, NULL),
(1964, NULL, 'IPR004516', NULL, 'Histidine-tRNA ligase/ATP phosphoribosyltransferase regulatory subunit', 'HisRS/HisZ', 4, NULL),
(1965, NULL, 'IPR010945', NULL, 'Malate dehydrogenase, type 2', 'Malate_DH_type2', 4, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(1966, NULL, 'IPR001124', NULL, 'Lipid-binding serum glycoprotein, C-terminal', 'Lipid-bd_serum_glycop_C', 3, NULL),
(1967, NULL, 'IPR004118', NULL, 'Hepatitis TT virus, Orf2/Gyrovirus Vp2', 'HEV_TT_virus_Orf2/Gyrovir_Vp2', 4, NULL),
(1968, NULL, 'IPR008254', NULL, 'Flavodoxin/nitric oxide synthase', 'Flavodoxin/NO_synth', 3, NULL),
(1969, NULL, 'IPR000145', NULL, 'Outer capsid protein VP5, Orbivirus', 'Capsid_VP5_Orbivir', 4, NULL),
(1970, NULL, 'IPR004498', NULL, 'Ribosomal protein L11 methyltransferase', 'Ribosomal_PrmA_MeTrfase', 4, NULL),
(1971, NULL, 'IPR004109', NULL, 'Hepatitis C virus, NS3 protease, Peptidase S29', 'NS3_Peptidase_S29', 3, NULL),
(1972, NULL, 'IPR004108', NULL, 'Iron hydrogenase, large subunit, C-terminal', 'Fe_hydrogenase_lsu_C', 3, NULL),
(1973, NULL, 'IPR010946', NULL, 'Geranylgeranylglyceryl phosphate synthase', 'GGGP_synth', 4, NULL),
(1974, NULL, 'IPR002559', NULL, 'Transposase, IS4-like', 'Transposase_11', 3, NULL),
(1975, NULL, 'IPR005576', NULL, 'RNA polymerase Rpb7-like , N-terminal', 'Rpb7-like_N', 3, NULL),
(1976, NULL, 'IPR005514', NULL, 'Chymotrypsin family Peptidase-S1', 'DUF316', 4, NULL),
(1977, NULL, 'IPR002549', NULL, 'Transmembrane protein TqsA-like', 'AI-2E-like', 4, NULL),
(1978, NULL, 'IPR003148', NULL, 'Regulator of K+ conductance, N-terminal', 'RCK_N', 3, NULL),
(1979, NULL, 'IPR007569', NULL, 'Domain of unknown function DUF559', 'DUF559', 3, NULL),
(1980, NULL, 'IPR034026', NULL, 'ESAT-6 secretion machinery protein EssA', 'EssA', 4, NULL),
(1981, NULL, 'IPR005531', NULL, 'Alkaline shock protein Asp23', 'Asp23', 4, NULL),
(1982, NULL, 'IPR010952', NULL, 'Chorismate mutase, gammaproteobacteria', 'CM_P_1', 3, NULL),
(1983, NULL, 'IPR003170', NULL, 'UDP-N-acetylenolpyruvoylglucosamine reductase', 'MurB', 4, NULL),
(1984, NULL, 'IPR000119', NULL, 'Histone-like DNA-binding protein', 'Hist_DNA-bd', 4, NULL),
(1985, NULL, 'IPR002546', NULL, 'Myogenic muscle-specific protein, N-terminal', 'MyoD_N', 3, NULL),
(1986, NULL, 'IPR009597', NULL, 'Domain of unknown function DUF1206', 'DUF1206', 3, NULL),
(1987, NULL, 'IPR004523', NULL, 'Aspartate-tRNA synthetase, type 2', 'Asp-tRNA_synthase_2', 4, NULL),
(1988, NULL, 'IPR000154', NULL, 'Prostanoid EP3 receptor type 3', 'EP3_rcpt_3', 4, NULL),
(1989, NULL, 'IPR009593', NULL, 'Protein of unknown function DUF1203', 'DUF1203', 4, NULL),
(1990, NULL, 'IPR004914', NULL, 'Antirestriction protein', 'Antirestrict', 4, NULL),
(1991, NULL, 'IPR006667', NULL, 'SLC41A/MgtE, integral membrane domain', 'SLC41_membr_dom', 3, NULL),
(1992, NULL, 'IPR003133', NULL, 'T antigen, Ori-binding', 'T_Ag_DNA-bd', 3, NULL),
(1993, NULL, 'IPR003168', NULL, 'Nitrile hydratase, beta subunit', 'Nitrile_hydratase_bsu', 4, NULL),
(1994, NULL, 'IPR000039', NULL, 'Ribosomal protein L18e', 'Ribosomal_L18e', 4, NULL),
(1995, NULL, 'IPR003164', NULL, 'Clathrin adaptor, alpha-adaptin, appendage, C-terminal subdomain', 'Clathrin_a-adaptin_app_sub_C', 3, NULL),
(1996, NULL, 'IPR003172', NULL, 'MD-2-related lipid-recognition domain', 'ML_dom', 3, NULL),
(1997, NULL, 'IPR002548', NULL, 'Alphavirus E1 glycoprotein', 'Alpha_E1_glycop', 3, NULL),
(1998, NULL, 'IPR004078', NULL, 'Interleukin-1 binding protein', 'IL-1-bd', 4, NULL),
(1999, NULL, 'IPR004930', NULL, 'Pneumovirus nucleocapsid protein', 'Pneumo_ncap', 4, NULL),
(2000, NULL, 'IPR005545', NULL, 'YCII-related', 'YCII', 3, NULL),
(2001, NULL, 'IPR010100', NULL, 'TonB-dependent copper receptor', 'TonB-dep_Cu_rcpt', 4, NULL),
(2002, NULL, 'IPR001364', NULL, 'Haemagglutinin, influenzavirus A/B', 'Hemagglutn_influenz_A/B', 4, NULL),
(2003, NULL, 'IPR003754', NULL, 'Tetrapyrrole biosynthesis, uroporphyrinogen III synthase', '4pyrrol_synth_uPrphyn_synth', 3, NULL),
(2004, NULL, 'IPR001020', NULL, 'Phosphotransferase system, HPr histidine phosphorylation site', 'PTS_HPr_His_P_site', 6, NULL),
(2005, NULL, 'IPR001952', NULL, 'Alkaline phosphatase', 'Alkaline_phosphatase', 4, NULL),
(2006, NULL, 'IPR001323', NULL, 'Erythropoietin/thrombopoietin', 'EPO_TPO', 4, NULL),
(2007, NULL, 'IPR003741', NULL, 'LUD domain', 'LUD_dom', 3, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(2008, NULL, 'IPR001006', NULL, 'Procollagen-lysine 5-dioxygenase, conserved site', 'Procol_lys_dOase', 2, NULL),
(2009, NULL, 'IPR005070', NULL, 'Foamy virus envelope protein', 'Foamy_env', 4, NULL),
(2010, NULL, 'IPR005068', NULL, 'Bacteriophage lambda, Tail fiber protein, repeat-2', 'Phage_lambda_Stf-r2', 7, NULL),
(2011, NULL, 'IPR001958', NULL, 'Tetracycline resistance protein TetA/multidrug resistance protein MdtG', 'Tet-R_TetA/multi-R_MdtG', 4, NULL),
(2012, NULL, 'IPR006716', NULL, 'ERG2/sigma1 receptor-like', 'ERG2_sigma1_rcpt-like', 4, NULL),
(2013, NULL, 'IPR007831', NULL, 'Type II secretion system protein GspE, N-terminal', 'T2SS_GspE_N', 3, NULL),
(2014, NULL, 'IPR001041', NULL, '2Fe-2S ferredoxin-type iron-sulfur binding domain', '2Fe-2S_ferredoxin-type', 3, NULL),
(2015, NULL, 'IPR007793', NULL, 'DivIVA family', 'DivIVA_fam', 4, NULL),
(2016, NULL, 'IPR005043', NULL, 'Exportin-2, C-terminal', 'XPO2_C', 3, NULL),
(2017, NULL, 'IPR010099', NULL, 'Epimerase family protein SDR39U1', 'SDR39U1', 4, NULL),
(2018, NULL, 'IPR003730', NULL, 'Multi-copper polyphenol oxidoreductase', 'Cu_polyphenol_OxRdtase', 4, NULL),
(2019, NULL, 'IPR001296', NULL, 'Glycosyl transferase, family 1', 'Glyco_trans_1', 3, NULL),
(2020, NULL, 'IPR002017', NULL, 'Spectrin repeat', 'Spectrin_repeat', 7, NULL),
(2021, NULL, 'IPR001370', NULL, 'BIR repeat', 'BIR_rpt', 7, NULL),
(2022, NULL, 'IPR001989', NULL, 'Radical-activating enzyme, conserved site', 'Radical_activat_CS', 2, NULL),
(2023, NULL, 'IPR010090', NULL, 'Phage tail tape measure protein', 'Phage_tape_meas', 3, NULL),
(2024, NULL, 'IPR001011', NULL, 'Acid phosphatase, class A, bacterial', 'Acid_Pase_classA_bac', 4, NULL),
(2025, NULL, 'IPR004634', NULL, 'Peptidase S49, protease IV', 'Pept_S49_pIV', 4, NULL),
(2026, NULL, 'IPR006719', NULL, 'DEC-1 protein, N-terminal', 'DEC-1_N', 3, NULL),
(2027, NULL, 'IPR003766', NULL, 'Uronate isomerase', 'Uronate_isomerase', 4, NULL),
(2028, NULL, 'IPR001224', NULL, 'Vasopressin V1A receptor', 'Vprs_V1A_rcpt', 4, NULL),
(2029, NULL, 'IPR001246', NULL, 'Lipoxygenase, plant', 'LipOase_plant', 4, NULL),
(2030, NULL, 'IPR003704', NULL, 'CO dehydrogenase beta subunit/acetyl-CoA synthase epsilon subunit', 'CO_DH_CoA_synth', 4, NULL),
(2031, NULL, 'IPR001093', NULL, 'IMP dehydrogenase/GMP reductase', 'IMP_DH_GMPRt', 3, NULL),
(2032, NULL, 'IPR001073', NULL, 'C1q domain', 'C1q_dom', 3, NULL),
(2033, NULL, 'IPR007839', NULL, 'GTP cyclohydrolase III', 'GTP_CycHdrlase_3', 4, NULL),
(2034, NULL, 'IPR007787', NULL, 'Protein of unknown function DUF687', 'DUF687', 4, NULL),
(2035, NULL, 'IPR003734', NULL, 'Domain of unknown function DUF155', 'DUF155', 3, NULL),
(2036, NULL, 'IPR001280', NULL, 'Photosystem I PsaA/PsaB', 'PSI_PsaA/B', 4, NULL),
(2037, NULL, 'IPR010094', NULL, 'Transposase (putative), N-terminal', 'Transposase_put_N', 3, NULL),
(2038, NULL, 'IPR023273', NULL, 'RNA (C5-cytosine) methyltransferase, NOP2', 'RCMT_NOP2', 4, NULL),
(2039, NULL, 'IPR010973', NULL, 'Phosphotransferase system, sucrose-specific IIBC component', 'PTS_IIBC_sucr', 3, NULL),
(2040, NULL, 'IPR010112', NULL, 'Anthranilate synthase, bacteria', 'TrpE-G_bact', 4, NULL),
(2041, NULL, 'IPR007792', NULL, 'Type IV secretion system, VirB3 / TrbD / AvhB', 'T4SS_VirB3/TrbD/AvhB', 4, NULL),
(2042, NULL, 'IPR004614', NULL, 'Phosphate acetyltransferase', 'P_AcTrfase', 3, NULL),
(2043, NULL, 'IPR003735', NULL, 'Metal-sensitive transcriptional repressor', 'Metal_Tscrpt_repr', 4, NULL),
(2044, NULL, 'IPR007788', NULL, 'Glutaminyl-peptide cyclotransferase', 'QCT', 4, NULL),
(2045, NULL, 'IPR002003', NULL, 'Gas vesicle protein GvpC', 'Gas-vesicle_GvpC', 7, NULL),
(2046, NULL, 'IPR003732', NULL, 'D-aminoacyl-tRNA deacylase DTD', 'Daa-tRNA_deacyls_DTD', 4, NULL),
(2047, NULL, 'IPR001337', NULL, 'Tobacco mosaic virus-like, coat protein', 'TMV-like_coat', 4, NULL),
(2048, NULL, 'IPR010965', NULL, 'HesB-related, selonoprotein', 'HesB-rel_seleno', 4, NULL),
(2049, NULL, 'IPR005037', NULL, 'Pre-mRNA-splicing factor 38', 'PRP38', 4, NULL),
(2050, NULL, 'IPR001316', NULL, 'Peptidase S1A, streptogrisin', 'Pept_S1A_streptogrisin', 4, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(2051, NULL, 'IPR001300', NULL, 'Peptidase C2, calpain, catalytic domain', 'Peptidase_C2_calpain_cat', 3, NULL),
(2052, NULL, 'IPR003723', NULL, 'Precorrin-6x reductase', 'Precorrin-6x_reduct', 4, NULL),
(2053, NULL, 'IPR005038', NULL, 'Octapeptide repeat', 'Octapeptide', 7, NULL),
(2054, NULL, 'IPR010966', NULL, 'Na(+)-translocating NADH-quinone reductase subunit B', 'NqrB', 4, NULL),
(2055, NULL, 'IPR004622', NULL, 'DNA polymerase III, delta prime subunit', 'DNA_pol_HolB', 3, NULL),
(2056, NULL, 'IPR006706', NULL, 'Extensin domain', 'Extensin_dom', 3, NULL),
(2057, NULL, 'IPR007629', NULL, 'Herpesvirus UL20, egress protein', 'Herpes_UL20', 4, NULL),
(2058, NULL, 'IPR003717', NULL, 'Recombination protein O, RecO', 'RecO', 4, NULL),
(2059, NULL, 'IPR003719', NULL, 'Phenazine biosynthesis PhzF protein', 'Phenazine_PhzF', 4, NULL),
(2060, NULL, 'IPR001009', NULL, 'Influenza RNA-dependent RNA polymerase subunit PA', 'PA/PA-X', 4, NULL),
(2061, NULL, 'IPR000007', NULL, 'Tubby, C-terminal', 'Tubby_C', 3, NULL),
(2062, NULL, 'IPR001047', NULL, 'Ribosomal protein S8e', 'Ribosomal_S8e', 4, NULL),
(2063, NULL, 'IPR007810', NULL, 'Pep3/Vps18/deep orange', 'Pep3_Vps18', 3, NULL),
(2064, NULL, 'IPR001289', NULL, 'Nuclear transcription factor Y subunit A', 'NFYA', 4, NULL),
(2065, NULL, 'IPR001082', NULL, 'Fimbrial protein pilin', 'Pilin', 4, NULL),
(2066, NULL, 'IPR007844', NULL, 'AsmA', 'AsmA', 3, NULL),
(2067, NULL, 'IPR005049', NULL, 'STELLO-like', 'STL-like', 4, NULL),
(2068, NULL, 'IPR002014', NULL, 'VHS domain', 'VHS_dom', 3, NULL),
(2069, NULL, 'IPR004638', NULL, 'Drug resistance transporter EmrB-like', 'EmrB-like', 4, NULL),
(2070, NULL, 'IPR002008', NULL, 'DNA polymerase family X, beta-like', 'DNA_pol_X_beta-like', 4, NULL),
(2071, NULL, 'IPR003745', NULL, 'Protein of unknown function DUF166', 'DUF166', 4, NULL),
(2072, NULL, 'IPR007790', NULL, 'Late expression factor 4', 'LEF-4', 4, NULL),
(2073, NULL, 'IPR003760', NULL, 'ABC transporter substrate-binding protein PnrA-like', 'PnrA-like', 3, NULL),
(2074, NULL, 'IPR010084', NULL, 'Beta-hydroxyacyl-(acyl-carrier-protein) dehydratase FabZ', 'FabZ', 4, NULL),
(2075, NULL, 'IPR007632', NULL, 'Anoctamin', 'Anoctamin', 4, NULL),
(2076, NULL, 'IPR007794', NULL, 'Ribosome receptor lysine/proline rich', 'Rib_rcpt_KP', 3, NULL),
(2077, NULL, 'IPR005066', NULL, 'Moybdenum cofactor oxidoreductase, dimerisation', 'MoCF_OxRdtse_dimer', 3, NULL),
(2078, NULL, 'IPR004625', NULL, 'Pyridoxine kinase', 'PyrdxlKinase', 4, NULL),
(2079, NULL, 'IPR001896', NULL, 'Plant virus coat protein', 'Plant_vir_prot', 4, NULL),
(2080, NULL, 'IPR005036', NULL, 'CBM21 (carbohydrate binding type-21) domain', 'CBM21_dom', 3, NULL),
(2081, NULL, 'IPR005062', NULL, 'SAC3/GANP/THP3, conserved domain', 'SAC3/GANP/THP3_conserved', 3, NULL),
(2082, NULL, 'IPR006693', NULL, 'Partial AB-hydrolase lipase domain', 'AB_hydrolase_lipase', 3, NULL),
(2083, NULL, 'IPR006718', NULL, 'Dec-1 repeat', 'DEC-1_REPEAT', 7, NULL),
(2084, NULL, 'IPR001368', NULL, 'TNFR/NGFR cysteine-rich region', 'TNFR/NGFR_Cys_rich_reg', 3, NULL),
(2085, NULL, 'IPR010104', NULL, 'Bacterial TonB-dependent receptor', 'TonB_rcpt_bac', 4, NULL),
(2086, NULL, 'IPR010961', NULL, 'Tetrapyrrole biosynthesis, 5-aminolevulinic acid synthase', '4pyrrol_synth_NH2levulA_synth', 3, NULL),
(2087, NULL, 'IPR003708', NULL, 'Bacterial protein export chaperone SecB', 'SecB', 4, NULL),
(2088, NULL, 'IPR010108', NULL, 'Lycopene cyclase, beta/epsilon', 'Lycopene_cyclase_b/e', 4, NULL),
(2089, NULL, 'IPR003726', NULL, 'Homocysteine-binding domain', 'HCY_dom', 3, NULL),
(2090, NULL, 'IPR010085', NULL, 'Crotonyl-CoA reductase', 'Crot_CoA_red', 4, NULL),
(2091, NULL, 'IPR003212', NULL, 'DNA-binding 7kDa protein', 'DNA-bd_7kDa_arc', 4, NULL),
(2092, NULL, 'IPR007805', NULL, 'Gas vesicle protein GvpK', 'Gas-vesicle_GvpK', 4, NULL),
(2093, NULL, 'IPR001064', NULL, 'Beta/gamma crystallin', 'Beta/gamma_crystallin', 3, NULL),
(2094, NULL, 'IPR005048', NULL, 'Domain of unknown function DUF287', 'DUF287', 3, NULL),
(2095, NULL, 'IPR003720', NULL, 'tRNA sulfurtransferase ThiI', 'tRNA_STrfase', 4, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(2096, NULL, 'IPR003211', NULL, 'AmiS/UreI transporter', 'AmiSUreI_transpt', 4, NULL),
(2097, NULL, 'IPR001014', NULL, 'Ribosomal protein L23/L25, conserved site', 'Ribosomal_L23/L25_CS', 2, NULL),
(2098, NULL, 'IPR010111', NULL, 'Kynureninase', 'Kynureninase', 4, NULL),
(2099, NULL, 'IPR010083', NULL, 'Beta-hydroxyacyl-(acyl-carrier-protein) dehydratase FabA', 'FabA', 4, NULL),
(2100, NULL, 'IPR001326', NULL, 'Translation elongation factor EF1B, beta/delta chains, conserved site', 'Transl_elong_EF1B_B/D_CS', 2, NULL),
(2101, NULL, 'IPR007811', NULL, 'DNA-directed RNA polymerase III subunit RPC4', 'RPC4', 4, NULL),
(2102, NULL, 'IPR001254', NULL, 'Serine proteases, trypsin domain', 'Trypsin_dom', 3, NULL),
(2103, NULL, 'IPR007846', NULL, 'RNA-recognition motif (RRM) Nup35-type domain', 'RRM_NUP35_dom', 3, NULL),
(2104, NULL, 'IPR001999', NULL, 'Osteonectin-like, conserved site', 'Osteonectin_CS', 2, NULL),
(2105, NULL, 'IPR001901', NULL, 'Protein translocase complex, SecE/Sec61-gamma subunit', 'Translocase_SecE/Sec61-g', 4, NULL),
(2106, NULL, 'IPR000003', NULL, 'Retinoid X receptor/HNF4', 'Retinoid-X_rcpt/HNF4', 4, NULL),
(2107, NULL, 'IPR001116', NULL, 'Somatostatin receptor 1', 'Somatstn_rcpt_1', 4, NULL),
(2108, NULL, 'IPR003722', NULL, 'Cobalamin biosynthesis precorrin-8X methylmutase CobH/CbiC', 'Cbl_synth_CobH/CbiC', 3, NULL),
(2109, NULL, 'IPR010957', NULL, 'Gamma/beta/epsilon proteobacterial P-protein, chorismate mutase domain', 'G/b/e-P-prot_chorismate_mutase', 3, NULL),
(2110, NULL, 'IPR001046', NULL, 'NRAMP family', 'NRAMP_fam', 4, NULL),
(2111, NULL, 'IPR007833', NULL, 'Capsule polysaccharide biosynthesis', 'Capsule_polysaccharide_synth', 4, NULL),
(2112, NULL, 'IPR007784', NULL, 'Per os infectivity factor', 'PIR', 4, NULL),
(2113, NULL, 'IPR007638', NULL, 'Glutaminyl-tRNA synthetase, class Ib, non-specific RNA-binding domain 2', 'Gln-tRNA-synth_Ib_RNA-bd_2', 3, NULL),
(2114, NULL, 'IPR007823', NULL, 'Ribosomal RNA processing protein 8', 'RRP8', 4, NULL),
(2115, NULL, 'IPR001898', NULL, 'Solute carrier family 13', 'SLC13A/DASS', 4, NULL),
(2116, NULL, 'IPR001349', NULL, 'Cytochrome c oxidase, subunit VIa', 'Cyt_c_oxidase_su6a', 4, NULL),
(2117, NULL, 'IPR002036', NULL, 'Endoribonuclease YbeY', 'YbeY', 4, NULL),
(2118, NULL, 'IPR006730', NULL, 'Sestrin', 'Sestrin', 4, NULL),
(2119, NULL, 'IPR007643', NULL, 'Dictyostelium spore coat protein, N-terminal', 'Dict_spore_N', 3, NULL),
(2120, NULL, 'IPR010091', NULL, 'Thiazolinyl imide reductase', 'Thiazolinyl_imide_reductase', 4, NULL),
(2121, NULL, 'IPR007854', NULL, 'Pre-mRNA polyadenylation factor Fip1 domain', 'Fip1_dom', 3, NULL),
(2122, NULL, 'IPR001150', NULL, 'Glycine radical domain', 'Gly_radical', 3, NULL),
(2123, NULL, 'IPR007798', NULL, 'Ameloblastin precursor', 'Amelin', 4, NULL),
(2124, NULL, 'IPR001932', NULL, 'PPM-type phosphatase-like domain', 'PPM-type_phosphatase-like_dom', 3, NULL),
(2125, NULL, 'IPR001963', NULL, 'Glycoprotein VP7', 'VP7', 4, NULL),
(2126, NULL, 'IPR007789', NULL, 'Protein of unknown function DUF688', 'DUF688', 4, NULL),
(2127, NULL, 'IPR001308', NULL, 'Electron transfer flavoprotein alpha subunit/FixB', 'ETF_a/FixB', 4, NULL),
(2128, NULL, 'IPR003213', NULL, 'Cytochrome c oxidase, subunit VIb', 'Cyt_c_oxidase_su6B', 4, NULL),
(2129, NULL, 'IPR003746', NULL, 'Protein of unknown function DUF167', 'DUF167', 4, NULL),
(2130, NULL, 'IPR001010', NULL, 'Thionin', 'Thionin', 4, NULL),
(2131, NULL, 'IPR001012', NULL, 'UBX domain', 'UBX_dom', 3, NULL),
(2132, NULL, 'IPR010089', NULL, 'Flavoprotein WrbA-like', 'Flavoprotein_WrbA-like', 4, NULL),
(2133, NULL, 'IPR006690', NULL, 'Outer membrane protein, OmpA-like, conserved site', 'OMPA-like_CS', 2, NULL),
(2134, NULL, 'IPR001385', NULL, 'Rotavirus A/C, major capsid protein VP6', 'Rotavirus_A/C_VP6', 4, NULL),
(2135, NULL, 'IPR007814', NULL, '1,2-phenylacetyl-CoA epoxidase, subunit A/C', 'PaaA_PaaC', 4, NULL),
(2136, NULL, 'IPR004629', NULL, 'Glycosyl transferase WecG/TagA/CpsF', 'WecG_TagA_CpsF', 4, NULL),
(2137, NULL, 'IPR007852', NULL, 'Cdc73/Parafibromin', 'Cdc73/Parafibromin', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(2138, NULL, 'IPR001972', NULL, 'Stomatin/HflK family', 'Stomatin_HflK_fam', 4, NULL),
(2139, NULL, 'IPR005041', NULL, 'Adenovirus E3B protein', 'Adeno_E3B', 4, NULL),
(2140, NULL, 'IPR002012', NULL, 'Gonadotropin-releasing hormone', 'GnRH', 2, NULL),
(2141, NULL, 'IPR003697', NULL, 'Nucleoside triphosphate pyrophosphatase Maf-like protein', 'Maf-like', 4, NULL),
(2142, NULL, 'IPR001088', NULL, 'Glycoside hydrolase, family 4', 'Glyco_hydro_4', 4, NULL),
(2143, NULL, 'IPR010963', NULL, 'Poly(R)-hydroxyalkanoic acid synthase, class I', 'PHA_synth_I', 4, NULL),
(2144, NULL, 'IPR001358', NULL, 'Neuropeptide Y2 receptor', 'NPY2_rcpt', 4, NULL),
(2145, NULL, 'IPR002016', NULL, 'Haem peroxidase', 'Haem_peroxidase', 3, NULL),
(2146, NULL, 'IPR001262', NULL, 'Hyperglycemic hormone type 2', 'Hyperglycemic2', 4, NULL),
(2147, NULL, 'IPR001929', NULL, 'Germin', 'Germin', 4, NULL),
(2148, NULL, 'IPR001279', NULL, 'Metallo-beta-lactamase', 'Metallo-B-lactamas', 3, NULL),
(2149, NULL, 'IPR001955', NULL, 'Pancreatic hormone-like', 'Pancreatic_hormone-like', 4, NULL),
(2150, NULL, 'IPR001390', NULL, 'Gamma-aminobutyric-acid A receptor, alpha subunit', 'GABAAa_rcpt', 4, NULL),
(2151, NULL, 'IPR001978', NULL, 'Troponin', 'Troponin', 4, NULL),
(2152, NULL, 'IPR007827', NULL, 'Protein of unknown function DUF694', 'DUF705', 4, NULL),
(2153, NULL, 'IPR035895', NULL, 'HPr-like superfamily', 'HPr-like_sf', 5, NULL),
(2154, NULL, 'IPR010075', NULL, 'Phosphoribosylformylglycinamidine synthase subunit PurQ', 'PRibForGlyAmidine_synth_PurQ', 4, NULL),
(2155, NULL, 'IPR010113', NULL, 'Nif-specific regulatory protein', 'Nif-specific_regulatory_prot', 4, NULL),
(2156, NULL, 'IPR010073', NULL, 'Phosphoribosylformylglycinamidine synthase PurL', 'PurL_large', 4, NULL),
(2157, NULL, 'IPR002019', NULL, 'Urease, beta subunit', 'Urease_beta', 4, NULL),
(2158, NULL, 'IPR001239', NULL, 'Proteinase inhibitor I1, Kazal-type, metazoa', 'Prot_inh_Kazal-m', 4, NULL),
(2159, NULL, 'IPR003731', NULL, 'Dinitrogenase iron-molybdenum cofactor biosynthesis', 'Di-Nase_FeMo-co_biosynth', 3, NULL),
(2160, NULL, 'IPR001931', NULL, 'Ribosomal protein S21e', 'Ribosomal_S21e', 4, NULL),
(2161, NULL, 'IPR003712', NULL, 'Cyanate lyase, C-terminal', 'Cyanate_lyase_C', 3, NULL),
(2162, NULL, 'IPR001059', NULL, 'Translation elongation factor P/YeiP, central', 'Transl_elong_P/YeiP_cen', 3, NULL),
(2163, NULL, 'IPR004630', NULL, 'Uncharacterised protein family UPF0324, bacteria', 'UPF0324_bac', 4, NULL),
(2164, NULL, 'IPR000006', NULL, 'Metallothionein, vertebrate', 'Metalthion_vert', 4, NULL),
(2165, NULL, 'IPR005057', NULL, 'Poxvirus E8', 'Poxvirus_E8', 4, NULL),
(2166, NULL, 'IPR006722', NULL, 'Trafficking protein particle complex subunit 2', 'Sedlin', 4, NULL),
(2167, NULL, 'IPR001895', NULL, 'Ras guanine-nucleotide exchange factors catalytic domain', 'RASGEF_cat_dom', 3, NULL),
(2168, NULL, 'IPR010088', NULL, 'Ribonucleotide reductase-associated flavodoxin, putative', 'RNR_flavodoxin', 4, NULL),
(2169, NULL, 'IPR006712', NULL, 'HD-ZIP protein, N-terminal', 'HD-ZIP_N', 3, NULL),
(2170, NULL, 'IPR010976', NULL, 'Beta-phosphoglucomutase hydrolase', 'B-phosphoglucomutase_hydrolase', 3, NULL),
(2171, NULL, 'IPR028348', NULL, 'FAD dependent protein', 'FAD-binding_protein', 4, NULL),
(2172, NULL, 'IPR006692', NULL, 'Coatomer, WD associated region', 'Coatomer_WD-assoc_reg', 3, NULL),
(2173, NULL, 'IPR007853', NULL, 'Zinc finger, DNL-type', 'Znf_DNL-typ', 3, NULL),
(2174, NULL, 'IPR001282', NULL, 'Glucose-6-phosphate dehydrogenase', 'G6P_DH', 4, NULL),
(2175, NULL, 'IPR006708', NULL, 'Pex19 protein', 'Pex19', 4, NULL),
(2176, NULL, 'IPR004641', NULL, 'Ribonuclease HIII', 'RNase_HIII', 4, NULL),
(2177, NULL, 'IPR005053', NULL, 'MobA/MobL protein', 'MobA_MobL', 3, NULL),
(2178, NULL, 'IPR007835', NULL, 'MOFRL domain', 'MOFRL', 3, NULL),
(2179, NULL, 'IPR007836', NULL, 'Ribosomal protein L41', 'Ribosomal_L41', 4, NULL),
(2180, NULL, 'IPR007845', NULL, 'Haemin-degrading HemS/ChuX domain', 'HemS/ChuX_dom', 3, NULL),
(2181, NULL, 'IPR001248', NULL, 'Purine-cytosine permease', 'Pur-cyt_permease', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(2182, NULL, 'IPR007474', NULL, 'ApaG domain', 'ApaG_domain', 3, NULL),
(2183, NULL, 'IPR010110', NULL, 'Shikimate dehydrogenase, AroM-type', 'Shikimate_DH_AroM-type', 3, NULL),
(2184, NULL, 'IPR004624', NULL, 'Protein YjdM', 'YjdM', 4, NULL),
(2185, NULL, 'IPR007630', NULL, 'RNA polymerase sigma-70 region 4', 'RNA_pol_sigma70_r4', 3, NULL),
(2186, NULL, 'IPR003208', NULL, 'Diol/glycerol dehydratase/dehydratase reactivating factor', 'Dehydtase/Dehydtase_re', 4, NULL),
(2187, NULL, 'IPR003721', NULL, 'Pantoate-beta-alanine ligase', 'Pantoate_ligase', 4, NULL),
(2188, NULL, 'IPR006714', NULL, 'Flagellar filament outer layer protein FlaA', 'FlaA', 4, NULL),
(2189, NULL, 'IPR003696', NULL, 'Carbamoyltransferase', 'Carbtransf_dom', 3, NULL),
(2190, NULL, 'IPR006728', NULL, 'Immunity protein YezG-like', 'YezG-like', 4, NULL),
(2191, NULL, 'IPR007834', NULL, 'DSS1/SEM1', 'DSS1_SEM1', 4, NULL),
(2192, NULL, 'IPR010109', NULL, 'Citrate synthase, eukaryotic-type', 'Citrate_synthase_euk', 4, NULL),
(2193, NULL, 'IPR001933', NULL, 'Neuropeptide Y4 receptor', 'NPY4_rcpt', 4, NULL),
(2194, NULL, 'IPR005065', NULL, 'Platelet-activating factor acetylhydrolase-like', 'PAF_acetylhydro-like', 4, NULL),
(2195, NULL, 'IPR003709', NULL, 'Peptidase M15B', 'Pept_M15B', 3, NULL),
(2196, NULL, 'IPR002001', NULL, 'GPCR, family 2, diuretic hormone receptor', 'GPCR_2_diuretic_rcpt', 4, NULL),
(2197, NULL, 'IPR007783', NULL, 'Eukaryotic translation initiation factor 3 subunit D', 'eIF3d', 4, NULL),
(2198, NULL, 'IPR001099', NULL, 'Chalcone/stilbene synthase, N-terminal', 'Chalcone/stilbene_synt_N', 3, NULL),
(2199, NULL, 'IPR007627', NULL, 'RNA polymerase sigma-70 region 2', 'RNA_pol_sigma70_r2', 3, NULL),
(2200, NULL, 'IPR003752', NULL, 'Disulphide bond formation protein DsbB/BdbC', 'DiS_bond_form_DsbB/BdbC', 4, NULL),
(2201, NULL, 'IPR010098', NULL, 'Glycyl radical enzyme, PFL2/glycerol dehydratase family', 'PFL2/GDeHydtase_fam', 4, NULL),
(2202, NULL, 'IPR003209', NULL, 'Methenyltetrahydromethanopterin cyclohydrolase', 'METHMP_CycHdrlase', 4, NULL),
(2203, NULL, 'IPR005067', NULL, 'Fatty acid desaturase, type 2', 'Fatty_acid_desaturase-2', 4, NULL),
(2204, NULL, 'IPR003761', NULL, 'Exonuclease VII, small subunit', 'Exonuc_VII_S', 4, NULL),
(2205, NULL, 'IPR001947', NULL, 'Scorpion short chain toxin, potassium channel inhibitor', 'Scorpion_toxinS_K_inh', 4, NULL),
(2206, NULL, 'IPR007812', NULL, 'Type II secretion system protein GspL', 'T2SS_protein-GspL', 4, NULL),
(2207, NULL, 'IPR001319', NULL, 'Nuclear transition protein 1', 'Nuclear_transition_prot1', 4, NULL),
(2208, NULL, 'IPR001146', NULL, 'Geminivirus AL1 replication-associated protein, MSV type', 'Gemini_AL1_MSV', 4, NULL),
(2209, NULL, 'IPR003750', NULL, 'Putative RNA methyltransferase', 'Put_MeTrfase', 4, NULL),
(2210, NULL, 'IPR007475', NULL, 'Ubiquinone biosynthesis accessory factor UbiK', 'UbiK', 4, NULL),
(2211, NULL, 'IPR002038', NULL, 'Osteopontin', 'Osteopontin', 4, NULL),
(2212, NULL, 'IPR004618', NULL, 'Aspartate--ammonia ligase', 'AsnA', 4, NULL),
(2213, NULL, 'IPR003714', NULL, 'PhoH-like protein', 'PhoH', 3, NULL),
(2214, NULL, 'IPR001988', NULL, 'Caulimovirus coat protein', 'Caulimo_coat', 4, NULL),
(2215, NULL, 'IPR006703', NULL, 'AIG1-type guanine nucleotide-binding (G) domain', 'G_AIG1', 3, NULL),
(2216, NULL, 'IPR004616', NULL, 'Leucyl/phenylalanyl-tRNA-protein transferase', 'Leu/Phe-tRNA_Trfase', 4, NULL),
(2217, NULL, 'IPR001387', NULL, 'Cro/C1-type helix-turn-helix domain', 'Cro/C1-type_HTH', 3, NULL),
(2218, NULL, 'IPR006715', NULL, 'PEA3-type ETS-domain transcription factor, N-terminal', 'ETS_PEA3_N', 3, NULL),
(2219, NULL, 'IPR007832', NULL, 'RNA polymerase Rpc34', 'RNA_pol_Rpc34', 4, NULL),
(2220, NULL, 'IPR001396', NULL, 'Metallothionein, family 4, echinoidea', 'Metalthion_4_echinoidea', 4, NULL),
(2221, NULL, 'IPR001252', NULL, 'Malate dehydrogenase, active site', 'Malate_DH_AS', 0, NULL),
(2222, NULL, 'IPR005055', NULL, 'Insect odorant-binding protein A10/Ejaculatory bulb-specific protein 3', 'A10/PebIII', 4, NULL),
(2223, NULL, 'IPR007807', NULL, 'Helicase domain', 'Helicase_dom', 3, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(2224, NULL, 'IPR007639', NULL, 'Glutaminyl-tRNA synthetase, class Ib, non-specific RNA-binding domain, N-terminal', 'Gln-tRNA-synth_Ib_RNA-bd_N', 3, NULL),
(2225, NULL, 'IPR001392', NULL, 'Clathrin adaptor, mu subunit', 'Clathrin_mu', 4, NULL),
(2226, NULL, 'IPR003757', NULL, 'Photosystem I PsaL, reaction centre subunit XI', 'PSI_PsaL', 3, NULL),
(2227, NULL, 'IPR001981', NULL, 'Colipase', 'Colipase', 4, NULL),
(2228, NULL, 'IPR001959', NULL, 'Probable transposase, IS891/IS1136/IS1341', 'Transposase', 3, NULL),
(2229, NULL, 'IPR007803', NULL, 'Aspartyl/asparaginy/proline hydroxylase', 'Asp/Arg/Pro-Hydrxlase', 3, NULL),
(2230, NULL, 'IPR007641', NULL, 'RNA polymerase Rpb2, domain 7', 'RNA_pol_Rpb2_7', 3, NULL),
(2231, NULL, 'IPR001330', NULL, 'PFTB repeat', 'PFTB_repeat', 7, NULL),
(2232, NULL, 'IPR001938', NULL, 'Thaumatin family', 'Thaumatin', 4, NULL),
(2233, NULL, 'IPR001044', NULL, 'XPG/Rad2 endonuclease, eukaryotes', 'XPG/Rad2_eukaryotes', 4, NULL),
(2234, NULL, 'IPR007813', NULL, 'Type IV pilus inner membrane component PilN', 'PilN', 4, NULL),
(2235, NULL, 'IPR003725', NULL, 'Molybdenum-binding protein ModE, N-terminal', 'ModE-bd_N', 3, NULL),
(2236, NULL, 'IPR007818', NULL, 'SHI protein family', 'SHI', 4, NULL),
(2237, NULL, 'IPR007795', NULL, 'Type VII secretion system EccB', 'T7SS_EccB', 4, NULL),
(2238, NULL, 'IPR002031', NULL, 'Peptidase A22A, presenilin 1', 'Pept_A22A_PS1', 4, NULL),
(2239, NULL, 'IPR001953', NULL, 'Sodium/hydrogen exchanger 2/4', 'NHE-2/4', 4, NULL),
(2240, NULL, 'IPR010967', NULL, 'Na(+)-translocating NADH-quinone reductase subunit E', 'NqrE', 4, NULL),
(2241, NULL, 'IPR005034', NULL, 'Dicer dimerisation domain', 'Dicer_dimerisation_dom', 3, NULL),
(2242, NULL, 'IPR006699', NULL, 'Glycerol uptake operon antiterminator', 'GlpP', 4, NULL),
(2243, NULL, 'IPR006709', NULL, 'Small-subunit processome, Utp14', 'SSU_processome_Utp14', 4, NULL),
(2244, NULL, 'IPR005063', NULL, 'Transposase, IS1', 'Transposase_27', 4, NULL),
(2245, NULL, 'IPR003758', NULL, 'Tetraacyldisaccharide 4''-kinase', 'LpxK', 4, NULL),
(2246, NULL, 'IPR001971', NULL, 'Ribosomal protein S11', 'Ribosomal_S11', 4, NULL),
(2247, NULL, 'IPR001236', NULL, 'Lactate/malate dehydrogenase, N-terminal', 'Lactate/malate_DH_N', 3, NULL),
(2248, NULL, 'IPR001256', NULL, 'GPCR, family 3, metabotropic glutamate receptor 1', 'GPCR_3_mGluR1', 4, NULL),
(2249, NULL, 'IPR004619', NULL, 'Type III pantothenate kinase', 'Type_III_PanK', 4, NULL),
(2250, NULL, 'IPR007637', NULL, 'Restriction endonuclease, type II, DpnII-like', 'Restrct_endonuc_II_DpnII-like', 3, NULL),
(2251, NULL, 'IPR007791', NULL, 'Co-chaperone DjlA, N-terminal', 'DjlA_N', 3, NULL),
(2252, NULL, 'IPR004640', NULL, 'Co-chaperone Hsc20', 'HscB', 4, NULL),
(2253, NULL, 'IPR001936', NULL, 'Ras GTPase-activating domain', 'RasGAP_dom', 3, NULL),
(2254, NULL, 'IPR007633', NULL, 'Bacteriophage P2, Holin', 'Phage_P2_Holin', 4, NULL),
(2255, NULL, 'IPR001080', NULL, '3Fe-4S ferredoxin', '3Fe4S_ferredoxin', 4, NULL),
(2256, NULL, 'IPR003759', NULL, 'Cobalamin (vitamin B12)-binding module, cap domain', 'Cbl-bd_cap', 3, NULL),
(2257, NULL, 'IPR001361', NULL, 'Gp90 envelope polyprotein of equine infectious anemia virus (EIAV)', 'Gp90_EIAV', 4, NULL),
(2258, NULL, 'IPR005056', NULL, 'Pneumovirus matrix protein', 'Pneu_matrix', 4, NULL),
(2259, NULL, 'IPR004635', NULL, 'Peptidase S49, SppA', 'Pept_S49_SppA', 3, NULL),
(2260, NULL, 'IPR010102', NULL, 'Succinate semialdehyde dehydrogenase', 'Succ_semiAld_DH', 4, NULL),
(2261, NULL, 'IPR004631', NULL, '4-aminobutyrate aminotransferase, eukaryotic', '4NH2But_aminotransferase_euk', 4, NULL),
(2262, NULL, 'IPR007826', NULL, 'Photosystem II PsbM', 'PSII_PsbM', 4, NULL),
(2263, NULL, 'IPR005064', NULL, 'Bordetella uptake gene', 'BUG', 4, NULL),
(2264, NULL, 'IPR001902', NULL, 'SLC26A/SulP transporter', 'SLC26A/SulP_fam', 4, NULL),
(2265, NULL, 'IPR001220', NULL, 'Legume lectin domain', 'Legume_lectin_dom', 3, NULL),
(2266, NULL, 'IPR010076', NULL, 'Pimeloyl-[acyl-carrier protein] methyl ester esterase', 'BioH', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(2267, NULL, 'IPR001263', NULL, 'Phosphoinositide 3-kinase, accessory (PIK) domain', 'PI3K_accessory_dom', 3, NULL),
(2268, NULL, 'IPR003703', NULL, 'Acyl-CoA thioesterase', 'Acyl_CoA_thio', 4, NULL),
(2269, NULL, 'IPR010971', NULL, 'Ubiquinone biosynthesis hydroxylase UbiH/COQ6', 'UbiH/COQ6', 4, NULL),
(2270, NULL, 'IPR002011', NULL, 'Tyrosine-protein kinase, receptor class II, conserved site', 'Tyr_kinase_rcpt_2_CS', 2, NULL),
(2271, NULL, 'IPR010087', NULL, 'Flavodoxin, short chain', 'Flav_short', 4, NULL),
(2272, NULL, 'IPR005042', NULL, 'TAL effector repeat', 'TAL_effector_rpt', 7, NULL),
(2273, NULL, 'IPR034446', NULL, 'Fibronectin type III domain-containing protein 10', 'Fndc10', 4, NULL),
(2274, NULL, 'IPR007800', NULL, 'Protein of unknown function DUF693', 'DUF693', 4, NULL),
(2275, NULL, 'IPR001951', NULL, 'Histone H4', 'Histone_H4', 4, NULL),
(2276, NULL, 'IPR007849', NULL, 'ATPase assembly factor ATP10', 'ATP10', 4, NULL),
(2277, NULL, 'IPR001997', NULL, 'Calponin/LIMCH1', 'Calponin/LIMCH1', 4, NULL),
(2278, NULL, 'IPR007635', NULL, 'Tis11B-like protein, N-terminal', 'Tis11B_N', 3, NULL),
(2279, NULL, 'IPR001050', NULL, 'Syndecan', 'Syndecan', 4, NULL),
(2280, NULL, 'IPR010103', NULL, 'Clustered lipoprotein, Treponema denticola', 'Clustered_lipoprot_TREDE', 4, NULL),
(2281, NULL, 'IPR001962', NULL, 'Asparagine synthase', 'Asn_synthase', 3, NULL),
(2282, NULL, 'IPR007644', NULL, 'RNA polymerase, beta subunit, protrusion', 'RNA_pol_bsu_protrusion', 3, NULL),
(2283, NULL, 'IPR001007', NULL, 'VWFC domain', 'VWF_dom', 3, NULL),
(2284, NULL, 'IPR010093', NULL, 'SinI-like, DNA-binding domain', 'SinI_DNA-bd', 3, NULL),
(2285, NULL, 'IPR004632', NULL, '4-aminobutyrate aminotransferase, bacterial', '4NH2But_aminotransferase_bac', 4, NULL),
(2286, NULL, 'IPR001908', NULL, 'Melanocortin receptor 3-5', 'MC3-5R', 4, NULL),
(2287, NULL, 'IPR001089', NULL, 'CXC chemokine', 'Chemokine_CXC', 4, NULL),
(2288, NULL, 'IPR010096', NULL, 'NAD(P)H-quinone oxidoreductase, subunit N/subunit 2', 'NADH-Q_OxRdtase_suN/2', 4, NULL),
(2289, NULL, 'IPR001021', NULL, 'Ribosomal protein L25, long-form', 'Ribosomal_L25_long', 4, NULL),
(2290, NULL, 'IPR007816', NULL, 'ResB-like domain', 'ResB-like_domain', 3, NULL),
(2291, NULL, 'IPR006711', NULL, 'Hox9, N-terminal activation domain', 'Hox9_activation_N', 3, NULL),
(2292, NULL, 'IPR001286', NULL, 'Glycoside hydrolase, family 59', 'Glyco_hydro_59', 4, NULL),
(2293, NULL, 'IPR001907', NULL, 'ATP-dependent Clp protease proteolytic subunit', 'ClpP', 4, NULL),
(2294, NULL, 'IPR001142', NULL, 'Yeast membrane protein DUP/COS', 'DUP/COS', 4, NULL),
(2295, NULL, 'IPR001015', NULL, 'Ferrochelatase', 'Ferrochelatase', 4, NULL),
(2296, NULL, 'IPR004617', NULL, 'Bis(5''-nucleosyl)-tetraphosphatase, symmetrical', 'ApaH', 4, NULL),
(2297, NULL, 'IPR006727', NULL, 'Herpesvirus BMRF2 protein', 'Herpes_BMRF2', 4, NULL),
(2298, NULL, 'IPR010092', NULL, 'Chlorinating enzyme', 'Chlorin_enz', 4, NULL),
(2299, NULL, 'IPR003711', NULL, 'CarD-like/TRCF, RNAP-interacting domain', 'CarD-like/TRCF_RID', 3, NULL),
(2300, NULL, 'IPR001900', NULL, 'Ribonuclease II/R', 'RNase_II/R', 3, NULL),
(2301, NULL, 'IPR001063', NULL, 'Ribosomal protein L22/L17', 'Ribosomal_L22', 4, NULL),
(2302, NULL, 'IPR005059', NULL, 'DNA-directed RNA polymerase, 35kDa subunit, poxviral', 'DNA-dir_RNA_pol_35kDa_poxviral', 4, NULL),
(2303, NULL, 'IPR007636', NULL, 'Restriction endonuclease, type II, XhoI', 'Restrct_endonuc_II_XhoI', 4, NULL),
(2304, NULL, 'IPR001084', NULL, 'Microtubule associated protein,  tubulin-binding repeat', 'MAP_tubulin-bd_rpt', 7, NULL),
(2305, NULL, 'IPR010972', NULL, 'Beta-phosphoglucomutase', 'Beta-phosphoglucomutase', 4, NULL),
(2306, NULL, 'IPR004639', NULL, 'Tetrapyrrole biosynthesis, glutamate-1-semialdehyde aminotransferase', '4pyrrol_synth_GluAld_NH2Trfase', 4, NULL),
(2307, NULL, 'IPR006717', NULL, 'Adenovirus E1B protein, N-terminal', 'Adeno_E1B_55K_N', 3, NULL),
(2308, NULL, 'IPR005046', NULL, 'Protein of unknown function DUF285', 'DUF285', 4, NULL),
(2309, NULL, 'IPR010975', NULL, 'Phosphotransferase system, alpha-glucoside-specific IIBC component', 'PTS_IIBC_a_glc', 4, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(2310, NULL, 'IPR007848', NULL, 'Methyltransferase small domain', 'Small_mtfrase_dom', 3, NULL),
(2311, NULL, 'IPR001234', NULL, 'GPCR, family 3, metabotropic glutamate receptor 3', 'GPCR_3_mGluR3', 4, NULL),
(2312, NULL, 'IPR001095', NULL, 'Acetyl-CoA carboxylase, alpha subunit', 'Acetyl_CoA_COase_a_su', 4, NULL),
(2313, NULL, 'IPR001249', NULL, 'Acetyl-CoA biotin carboxyl carrier', 'AcCoA_biotinCC', 4, NULL),
(2314, NULL, 'IPR001057', NULL, 'Glutamate/acetylglutamate kinase', 'Glu/AcGlu_kinase', 4, NULL),
(2315, NULL, 'IPR001313', NULL, 'Pumilio RNA-binding repeat', 'Pumilio_RNA-bd_rpt', 7, NULL),
(2316, NULL, 'IPR001352', NULL, 'Ribonuclease HII/HIII', 'RNase_HII/HIII', 4, NULL),
(2317, NULL, 'IPR004626', NULL, 'RarD protein', 'RarD', 4, NULL),
(2318, NULL, 'IPR007828', NULL, 'Inositol oxygenase', 'Inositol_oxygenase', 4, NULL),
(2319, NULL, 'IPR006684', NULL, 'Acyl-CoA thioester hydrolase YbgC/YbaW family', 'YbgC/YbaW', 4, NULL),
(2320, NULL, 'IPR010095', NULL, 'Transposase IS605, OrfB, C-terminal', 'Transposase_IS605_OrfB_C', 3, NULL),
(2321, NULL, 'IPR005061', NULL, 'Vacuolar protein sorting-associated protein Ist1', 'Ist1', 4, NULL),
(2322, NULL, 'IPR006685', NULL, 'Mechanosensitive ion channel MscS', 'MscS_channel', 4, NULL),
(2323, NULL, 'IPR003706', NULL, 'CstA, N-terminal domain', 'CstA_N', 3, NULL),
(2324, NULL, 'IPR006687', NULL, 'Small GTPase superfamily, SAR1-type', 'Small_GTPase_SAR1', 4, NULL),
(2325, NULL, 'IPR010962', NULL, 'Putative 8-amino-7-oxononanoate synthase, Archaea/Firmicutes type', 'AONS_Archaea/Firmicutes', 4, NULL),
(2326, NULL, 'IPR001298', NULL, 'Filamin/ABP280 repeat', 'Filamin/ABP280_rpt', 7, NULL),
(2327, NULL, 'IPR007806', NULL, 'Mobile element transfer', 'SpdB', 4, NULL),
(2328, NULL, 'IPR010074', NULL, 'Phosphoribosylformylglycinamidine subunit PurL', 'PRibForGlyAmidine_synth_PurL', 4, NULL),
(2329, NULL, 'IPR010079', NULL, 'Xanthine phosphoribosyltransferase', 'Xanthine_PRibTrfase', 4, NULL),
(2330, NULL, 'IPR006689', NULL, 'Small GTPase superfamily, ARF/SAR type', 'Small_GTPase_ARF/SAR', 4, NULL),
(2331, NULL, 'IPR006724', NULL, 'Phage tail tube protein 1', 'Phage_TTP', 4, NULL),
(2332, NULL, 'IPR010081', NULL, 'Diaminopropionate ammonia-lyase', 'DiNH2opropionate_NH3_lyase', 4, NULL),
(2333, NULL, 'IPR010107', NULL, 'Glutamate decarboxylase', 'Glutamate_decarboxylase', 4, NULL),
(2334, NULL, 'IPR001105', NULL, 'Thromboxane receptor', 'Thbox_rcpt', 4, NULL),
(2335, NULL, 'IPR001045', NULL, 'Spermidine/spermine synthases', 'Spermi_synthase', 4, NULL),
(2336, NULL, 'IPR001069', NULL, '5-Hydroxytryptamine 7 receptor', '5HT_7_rcpt', 4, NULL),
(2337, NULL, 'IPR007786', NULL, 'Late expression factor 9', 'LEF-9', 4, NULL),
(2338, NULL, 'IPR001144', NULL, 'Heat-labile enterotoxin, A chain', 'Enterotoxin_A', 4, NULL),
(2339, NULL, 'IPR003751', NULL, 'Translational regulator CsrA', 'CsrA', 4, NULL),
(2340, NULL, 'IPR007808', NULL, 'Transcription elongation factor 1', 'Elf1', 4, NULL),
(2341, NULL, 'IPR007829', NULL, 'TM2 domain', 'TM2', 3, NULL),
(2342, NULL, 'IPR007824', NULL, 'Paraflagellar rod', 'Flagellar_rod', 4, NULL),
(2343, NULL, 'IPR001110', NULL, 'Uncharacterised protein family UPF0012, conserved site', 'UPF0012_CS', 2, NULL),
(2344, NULL, 'IPR004613', NULL, 'Ribonuclease J', 'RNase_J', 4, NULL),
(2345, NULL, 'IPR001008', NULL, 'Metallothionein, mollusc', 'Metalthion_mollusc', 4, NULL),
(2346, NULL, 'IPR001222', NULL, 'Zinc finger, TFIIS-type', 'Znf_TFIIS', 3, NULL),
(2347, NULL, 'IPR006694', NULL, 'Fatty acid hydroxylase', 'Fatty_acid_hydroxylase', 3, NULL),
(2348, NULL, 'IPR001334', NULL, 'E6 early regulatory protein', 'E6', 4, NULL),
(2349, NULL, 'IPR001346', NULL, 'Interferon regulatory factor DNA-binding domain', 'Interferon_reg_fact_DNA-bd_dom', 3, NULL),
(2350, NULL, 'IPR001055', NULL, 'Adrenodoxin', 'Adrenodoxin', 4, NULL),
(2351, NULL, 'IPR005044', NULL, 'Protein of unknown function DUF282, Caenorhabditis species', 'DUF282_CAE_spp', 4, NULL),
(2352, NULL, 'IPR007855', NULL, 'RNA-dependent RNA polymerase, eukaryotic-type', 'RNA-dep_RNA_pol_euk-typ', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(2353, NULL, 'IPR034188', NULL, 'Broad-specificity linear acyl-CoA dehydrogenase FadE5-like', 'FadE5-like', 4, NULL),
(2354, NULL, 'IPR010106', NULL, 'Recombination-promoting nuclease RpnA', 'RpnA', 4, NULL),
(2355, NULL, 'IPR007809', NULL, 'FlgN-like protein', 'FlgN-like', 4, NULL),
(2356, NULL, 'IPR003718', NULL, 'OsmC/Ohr family', 'OsmC/Ohr_fam', 4, NULL),
(2357, NULL, 'IPR005050', NULL, 'Early nodulin 93 ENOD93 protein', 'Enod93', 4, NULL),
(2358, NULL, 'IPR007785', NULL, 'Anamorsin', 'Anamorsin', 4, NULL),
(2359, NULL, 'IPR006680', NULL, 'Amidohydrolase-related', 'Amidohydro-rel', 3, NULL),
(2360, NULL, 'IPR003764', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 'GlcNAc_6-P_deAcase', 4, NULL),
(2361, NULL, 'IPR004633', NULL, 'Na/Pi-cotransporter II-related/YqeW-like protein', 'NaPi_cotrn-rel/YqeW-like', 4, NULL),
(2362, NULL, 'IPR004615', NULL, 'DNA polymerase III, psi subunit', 'DNA_pol_III_psi', 4, NULL),
(2363, NULL, 'IPR007634', NULL, 'RNA polymerase sigma factor 54, DNA-binding', 'RNA_pol_sigma_54_DNA-bd', 3, NULL),
(2364, NULL, 'IPR007817', NULL, 'Isocyanide synthase/Spore wall maturation protein DIT1', 'Isocyanide_synthase_DIT1', 4, NULL),
(2365, NULL, 'IPR007841', NULL, 'Uncharacterised protein family UPF0210', 'UPF0210', 4, NULL),
(2366, NULL, 'IPR003753', NULL, 'Exonuclease VII, large subunit', 'Exonuc_VII_L', 4, NULL),
(2367, NULL, 'IPR033989', NULL, 'CD209-like, C-type lectin-like domain', 'CD209-like_CTLD', 3, NULL),
(2368, NULL, 'IPR004620', NULL, '5,10-methylenetetrahydrofolate reductase', 'MTHF_reductase_bac', 4, NULL),
(2369, NULL, 'IPR010969', NULL, 'Cysteine desulfurase-related, unknown function', 'Cys_dSase-rel_unknwn_funct', 4, NULL),
(2370, NULL, 'IPR003206', NULL, 'Diol/glycerol dehydratase, large subunit', 'Diol/glycerol_deHydtase_lsu', 3, NULL),
(2371, NULL, 'IPR007631', NULL, 'RNA polymerase sigma factor 70, non-essential domain', 'RNA_pol_sigma_70_non-ess', 3, NULL),
(2372, NULL, 'IPR001897', NULL, 'Porin, gammaproteobacterial', 'Porin_gammaproteobac', 4, NULL),
(2373, NULL, 'IPR004628', NULL, 'Mannonate dehydratase', 'Man_deHydtase', 4, NULL),
(2374, NULL, 'IPR001998', NULL, 'Xylose isomerase', 'Xylose_isomerase', 4, NULL),
(2375, NULL, 'IPR001970', NULL, 'Sodium/hydrogen exchanger 1-like', 'NHE-1-like', 4, NULL),
(2376, NULL, 'IPR001258', NULL, 'NHL repeat', 'NHL_repeat', 7, NULL),
(2377, NULL, 'IPR001353', NULL, 'Proteasome, subunit alpha/beta', 'Proteasome_sua/b', 4, NULL),
(2378, NULL, 'IPR001383', NULL, 'Ribosomal protein L28', 'Ribosomal_L28', 4, NULL),
(2379, NULL, 'IPR007476', NULL, 'Putative exonuclease, RdgC', 'RdgC', 4, NULL),
(2380, NULL, 'IPR003744', NULL, 'Queuosine precursor transporter', 'YhhQ', 4, NULL),
(2381, NULL, 'IPR010101', NULL, 'TonB-dependent vitamin B12 transporter BtuB', 'B12_transptr_BtuB', 4, NULL),
(2382, NULL, 'IPR001373', NULL, 'Cullin, N-terminal', 'Cullin_N', 3, NULL),
(2383, NULL, 'IPR003716', NULL, 'DNA-directed RNA polymerase, omega subunit', 'DNA-dir_RNA_pol_omega', 4, NULL),
(2384, NULL, 'IPR005054', NULL, 'Nepovirus coat protein', 'Nepo_coat', 3, NULL),
(2385, NULL, 'IPR001310', NULL, 'Histidine triad (HIT) protein', 'Histidine_triad_HIT', 4, NULL),
(2386, NULL, 'IPR005039', NULL, 'Antirepressor protein, C-terminal', 'Ant_C', 3, NULL),
(2387, NULL, 'IPR001079', NULL, 'Galectin, carbohydrate recognition domain', 'Galectin_CRD', 3, NULL),
(2388, NULL, 'IPR010958', NULL, 'Chorismate mutase, high GC Gram-positive bacteria/archaeal', 'Chorismate_mutase_highGC-bac', 3, NULL),
(2389, NULL, 'IPR010970', NULL, 'Cysteine desulfurase, SufS', 'Cys_dSase_SufS', 4, NULL),
(2390, NULL, 'IPR034279', NULL, 'Copper resistance protein, third cupredoxin domain', 'CuRO_3_CopA', 3, NULL),
(2391, NULL, 'IPR001017', NULL, 'Dehydrogenase, E1 component', 'DH_E1', 3, NULL),
(2392, NULL, 'IPR010086', NULL, 'Flavodoxin, long chain', 'Flavodoxin_lc', 4, NULL),
(2393, NULL, 'IPR001894', NULL, 'Cathelicidin-like', 'Cathelicidin-like', 4, NULL),
(2394, NULL, 'IPR006697', NULL, 'RecBCD enzyme subunit RecC', 'RecC', 4, NULL),
(2395, NULL, 'IPR010960', NULL, 'Flavocytochrome c', 'Flavocytochrome_c', 4, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(2396, NULL, 'IPR001941', NULL, 'Pro-opiomelanocortin', 'PMOC', 4, NULL),
(2397, NULL, 'IPR005047', NULL, '7TM GPCR, serpentine receptor class xa (Srxa)', '7TM_GPCR_serpentine_rcpt_Srxa', 4, NULL),
(2398, NULL, 'IPR023222', NULL, 'PsbQ-like domain superfamily', 'PsbQ-like_dom_sf', 5, NULL),
(2399, NULL, 'IPR001321', NULL, 'Hypoxia-inducible factor-1 alpha', 'HIF-1_alpha', 4, NULL),
(2400, NULL, 'IPR010078', NULL, 'Pur operon repressor', 'PurR_Bsub', 4, NULL),
(2401, NULL, 'IPR001969', NULL, 'Aspartic peptidase, active site', 'Aspartic_peptidase_AS', 0, NULL),
(2402, NULL, 'IPR002009', NULL, 'Bromovirus coat protein', 'Bromo_CP', 4, NULL),
(2403, NULL, 'IPR003700', NULL, 'Ketopantoate hydroxymethyltransferase', 'Pantoate_hydroxy_MeTrfase', 4, NULL),
(2404, NULL, 'IPR001148', NULL, 'Alpha carbonic anhydrase domain', 'CA_dom', 3, NULL),
(2405, NULL, 'IPR007837', NULL, 'DNA damage-inducible protein DinB', 'DinB', 4, NULL),
(2406, NULL, 'IPR005051', NULL, 'Herpesvirus UL46', 'Herpes_UL46', 4, NULL),
(2407, NULL, 'IPR003710', NULL, 'Ketopantoate reductase ApbA/PanE', 'ApbA', 4, NULL),
(2408, NULL, 'IPR010077', NULL, 'Herpes virus tegument protein', 'Herpes_virus_tegument', 4, NULL),
(2409, NULL, 'IPR003739', NULL, 'Lysine-2,3-aminomutase/glutamate 2,3-aminomutase', 'Lys_aminomutase/Glu_NH3_mut', 4, NULL),
(2410, NULL, 'IPR006707', NULL, 'Type VII secretion system membrane protein EccD', 'T7SS_EccD', 4, NULL),
(2411, NULL, 'IPR003740', NULL, 'Uncharacterised membrane protein YitT', 'YitT', 4, NULL),
(2412, NULL, 'IPR004636', NULL, 'Acetylornithine/Succinylornithine transaminase family', 'AcOrn/SuccOrn_fam', 4, NULL),
(2413, NULL, 'IPR003713', NULL, 'Flagellar protein FliS', 'FliS', 4, NULL),
(2414, NULL, 'IPR004623', NULL, 'Potassium-transporting ATPase A chain', 'KdpA', 4, NULL),
(2415, NULL, 'IPR003698', NULL, 'Lipoyl synthase', 'Lipoyl_synth', 4, NULL),
(2416, NULL, 'IPR006704', NULL, 'Leukocyte surface antigen CD47', 'CD47', 4, NULL),
(2417, NULL, 'IPR001976', NULL, 'Ribosomal protein S24e', 'Ribosomal_S24e', 4, NULL),
(2418, NULL, 'IPR006698', NULL, 'Uncharacterised protein family UPF0229', 'UPF0229', 4, NULL),
(2419, NULL, 'IPR001138', NULL, 'Zn(2)-C6 fungal-type DNA-binding domain', 'Zn2-C6_fun-type_DNA-bd', 3, NULL),
(2420, NULL, 'IPR003702', NULL, 'Acetyl-CoA hydrolase/transferase, N-terminal', 'ActCoA_hydro_N', 3, NULL),
(2421, NULL, 'IPR001048', NULL, 'Aspartate/glutamate/uridylate kinase', 'Asp/Glu/Uridylate_kinase', 3, NULL),
(2422, NULL, 'IPR007820', NULL, 'AbrB family', 'AbrB_fam', 4, NULL),
(2423, NULL, 'IPR005060', NULL, 'Rhabdovirus matrix protein', 'Rhabdo_matrix', 4, NULL),
(2424, NULL, 'IPR006683', NULL, 'Thioesterase domain', 'Thioestr_dom', 3, NULL),
(2425, NULL, 'IPR002035', NULL, 'von Willebrand factor, type A', 'VWF_A', 3, NULL),
(2426, NULL, 'IPR001991', NULL, 'Sodium:dicarboxylate symporter', 'Na-dicarboxylate_symporter', 4, NULL),
(2427, NULL, 'IPR001106', NULL, 'Aromatic amino acid lyase', 'Aromatic_Lyase', 4, NULL),
(2428, NULL, 'IPR007850', NULL, 'RCSD', 'RCSD', 4, NULL),
(2429, NULL, 'IPR005035', NULL, 'Herpesvirus UL3', 'Herpes_UL3', 4, NULL),
(2430, NULL, 'IPR001085', NULL, 'Serine hydroxymethyltransferase', 'Ser_HO-MeTrfase', 4, NULL),
(2431, NULL, 'IPR004621', NULL, 'Eukaryotic-type methylenetetrahydrofolate reductase', 'Fadh2_euk', 4, NULL),
(2432, NULL, 'IPR005058', NULL, 'Poxvirus P4A', 'Poxvirus_P4A', 4, NULL),
(2433, NULL, 'IPR007640', NULL, 'Herpesvirus capsid vertex component 1', 'UL17-like', 4, NULL),
(2434, NULL, 'IPR003770', NULL, 'Endolytic murein transglycosylase', 'MLTG-like', 4, NULL),
(2435, NULL, 'IPR001940', NULL, 'Peptidase S1C', 'Peptidase_S1C', 4, NULL),
(2436, NULL, 'IPR007477', NULL, 'SAB domain', 'SAB_dom', 3, NULL),
(2437, NULL, 'IPR010964', NULL, 'Peptidase M20A, peptidase V-related', 'M20A_pepV-rel', 4, NULL),
(2438, NULL, 'IPR003767', NULL, 'Malate/L-lactate dehydrogenase-like', 'Malate/L-lactate_DH-like', 4, NULL),
(2439, NULL, 'IPR007822', NULL, 'Lanthionine synthetase C-like', 'LANC-like', 4, NULL),
(2440, NULL, 'IPR001058', NULL, 'Synuclein', 'Synuclein', 4, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(2441, NULL, 'IPR001965', NULL, 'Zinc finger, PHD-type', 'Znf_PHD', 3, NULL),
(2442, NULL, 'IPR003763', NULL, 'CDP-diacylglycerol pyrophosphatase', 'CDP-diacylglyc_Pase', 4, NULL),
(2443, NULL, 'IPR001328', NULL, 'Peptidyl-tRNA hydrolase', 'Pept_tRNA_hydro', 4, NULL),
(2444, NULL, 'IPR003701', NULL, 'DNA double-strand break repair protein Mre11', 'Mre11', 4, NULL),
(2445, NULL, 'IPR005052', NULL, 'Legume-like lectin', 'Lectin_leg', 3, NULL),
(2446, NULL, 'IPR034054', NULL, 'PrcA catalytic domain', 'Pep_S8_PrcA', 3, NULL),
(2447, NULL, 'IPR001024', NULL, 'PLAT/LH2 domain', 'PLAT/LH2_dom', 3, NULL),
(2448, NULL, 'IPR001240', NULL, 'N-(5''phosphoribosyl) anthranilate isomerase (PRAI) domain', 'PRAI_dom', 3, NULL),
(2449, NULL, 'IPR006721', NULL, 'ATP synthase, F1 complex, epsilon  subunit, mitochondrial', 'ATP_synth_F1_esu_mt', 4, NULL),
(2450, NULL, 'IPR007815', NULL, 'Erythromycin esterase', 'Emycin_Estase', 4, NULL),
(2451, NULL, 'IPR006725', NULL, 'Per os infectivity factor 2', 'PIF2', 4, NULL),
(2452, NULL, 'IPR007825', NULL, 'Major outer membrane precursor, Legionella pneumophila-type', 'Major_OMP_Legionella', 4, NULL),
(2453, NULL, 'IPR006682', NULL, 'Conserved hypothetical protein CHP00267', 'CHP00267', 4, NULL),
(2454, NULL, 'IPR001083', NULL, 'Copper fist DNA-binding domain', 'Cu_fist_DNA-bd_dom', 3, NULL),
(2455, NULL, 'IPR006710', NULL, 'Glycoside hydrolase, family 43', 'Glyco_hydro_43', 4, NULL),
(2456, NULL, 'IPR010974', NULL, 'Phosphotransferase system, N-acetylglucosamine-specific IIBC component', 'PTS_IIBC_nag', 3, NULL),
(2457, NULL, 'IPR010080', NULL, 'Thioester reductase-like domain', 'Thioester_reductase-like_dom', 3, NULL),
(2458, NULL, 'IPR001995', NULL, 'Peptidase A2A, retrovirus, catalytic', 'Peptidase_A2_cat', 3, NULL),
(2459, NULL, 'IPR001112', NULL, 'Endothelin receptor B', 'ETB_rcpt', 4, NULL),
(2460, NULL, 'IPR001260', NULL, 'Coproporphyrinogen III oxidase, aerobic', 'Coprogen_oxidase_aer', 4, NULL),
(2461, NULL, 'IPR001244', NULL, 'Prostaglandin DP receptor', 'Prostglndn_DP_rcpt', 4, NULL),
(2462, NULL, 'IPR001949', NULL, 'NADH:ubiquinone oxidoreductase, 51kDa subunit, conserved site', 'NADH-UbQ_OxRdtase_51kDa_CS', 2, NULL),
(2463, NULL, 'IPR002024', NULL, 'Bacterioferritin', 'Bacterioferritin', 4, NULL),
(2464, NULL, 'IPR006691', NULL, 'DNA gyrase/topoisomerase IV, subunit A, C-terminal repeat', 'GyrA/parC_rep', 7, NULL),
(2465, NULL, 'IPR001214', NULL, 'SET domain', 'SET_dom', 3, NULL),
(2466, NULL, 'IPR004637', NULL, '2,4-diaminobutyrate 4-transaminase', 'Dat', 4, NULL),
(2467, NULL, 'IPR007797', NULL, 'AF4/FMR2 family', 'AF4/FMR2', 4, NULL),
(2468, NULL, 'IPR006696', NULL, 'Protein of unknown function DUF423', 'DUF423', 4, NULL),
(2469, NULL, 'IPR006726', NULL, 'Para-hydroxybenzoic acid efflux pump subunit AaeB/fusaric acid resistance protein', 'PHBA_efflux_AaeB/fusaric-R', 4, NULL),
(2470, NULL, 'IPR001331', NULL, 'Guanine-nucleotide dissociation stimulator, CDC24, conserved site', 'GDS_CDC24_CS', 2, NULL),
(2471, NULL, 'IPR010105', NULL, 'TonB-dependent siderophore receptor', 'TonB_sidphr_rcpt', 4, NULL),
(2472, NULL, 'IPR006713', NULL, 'Adhesin, Dr-family', 'Adhesin_Dr', 4, NULL),
(2473, NULL, 'IPR007642', NULL, 'RNA polymerase Rpb2, domain 2', 'RNA_pol_Rpb2_2', 3, NULL),
(2474, NULL, 'IPR005069', NULL, 'Nucleotide-diphospho-sugar transferase', 'Nucl-diP-sugar_transferase', 3, NULL),
(2475, NULL, 'IPR010968', NULL, 'Ion-translocating oxidoreductase complex subunit E', 'RnfE', 4, NULL),
(2476, NULL, 'IPR007802', NULL, 'Cytochrome b6-f complex subunit 6', 'Cyt_b6/f_cplx_su6', 4, NULL),
(2477, NULL, 'IPR006686', NULL, 'Mechanosensitive ion channel MscS, conserved site', 'MscS_channel_CS', 2, NULL),
(2478, NULL, 'IPR002030', NULL, 'Mitochondrial carrier UCP-like', 'Mit_uncoupling_UCP-like', 4, NULL),
(2479, NULL, 'IPR005045', NULL, 'CDC50/LEM3 family', 'CDC50/LEM3_fam', 4, NULL),
(2480, NULL, 'IPR004627', NULL, 'L-threonine 3-dehydrogenase', 'L-Threonine_3-DHase', 4, NULL),
(2481, NULL, 'IPR001216', NULL, 'Cysteine synthase/cystathionine beta-synthase, pyridoxal-phosphate attachment site', 'P-phosphate_BS', 1, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(2482, NULL, 'IPR002020', NULL, 'Citrate synthase', 'Citrate_synthase', 4, NULL),
(2483, NULL, 'IPR002002', NULL, 'Octopamine receptor', 'Octopmn_rcpt', 4, NULL),
(2484, NULL, 'IPR001103', NULL, 'Androgen receptor', 'Andrgn_rcpt', 4, NULL),
(2485, NULL, 'IPR006723', NULL, 'Islet cell autoantigen Ica1, C-terminal', 'Islet_autoAg_Ica1_C', 3, NULL),
(2486, NULL, 'IPR001973', NULL, 'P2Y6 purinoceptor', 'P2Y6_rcpt', 4, NULL),
(2487, NULL, 'IPR003765', NULL, 'Nitrate reductase chaperone, NarJ', 'NO3_reductase_chaperone_NarJ', 4, NULL),
(2488, NULL, 'IPR007804', NULL, 'Gas vesicle protein GvpG', 'Gas-vesicle_GvpG', 4, NULL),
(2489, NULL, 'IPR006702', NULL, 'Casparian strip membrane protein domain', 'CASP_dom', 3, NULL),
(2490, NULL, 'IPR007799', NULL, 'Baculovirus p47', 'Baculo_p47', 4, NULL),
(2491, NULL, 'IPR006720', NULL, 'Dec-1 protein, C-terminal', 'DEC-1_C', 3, NULL),
(2492, NULL, 'IPR006700', NULL, 'Ribosomal RNA small subunit methyltransferase E', 'RsmE', 4, NULL),
(2493, NULL, 'IPR001943', NULL, 'UVR domain', 'UVR_dom', 3, NULL),
(2494, NULL, 'IPR007801', NULL, 'Uncharacterised protein family UPF0276', 'UPF0276', 4, NULL),
(2495, NULL, 'IPR007796', NULL, 'Herpesvirus major outer envelope glycoprotein', 'Herpes_BLLF1', 4, NULL),
(2496, NULL, 'IPR001053', NULL, 'CXC chemokine receptor 5', 'Chemokine_CXCR5', 4, NULL),
(2497, NULL, 'IPR007842', NULL, 'HEPN domain', 'HEPN_dom', 3, NULL),
(2498, NULL, 'IPR007838', NULL, 'Cell division protein ZapA-like', 'Cell_div_ZapA-like', 4, NULL),
(2499, NULL, 'IPR010097', NULL, 'Malate dehydrogenase, type 1', 'Malate_DH_type1', 4, NULL),
(2500, NULL, 'IPR001945', NULL, 'RAD3/XPD family', 'RAD3/XPD', 4, NULL),
(2501, NULL, 'IPR003230', NULL, 'D-alanyl carrier protein', 'DltC', 4, NULL),
(2502, NULL, 'IPR004155', NULL, 'PBS lyase HEAT-like repeat', 'PBS_lyase_HEAT', 7, NULL),
(2503, NULL, 'IPR004956', NULL, 'Foamy virus BEL 1/2 protein', 'Foamy_BEL', 4, NULL),
(2504, NULL, 'IPR002618', NULL, 'UDPGP family', 'UDPGP_fam', 4, NULL),
(2505, NULL, 'IPR004966', NULL, 'Pox virus Ag35 surface protein', 'Pox_Ag35', 4, NULL),
(2506, NULL, 'IPR005624', NULL, 'Corrinoid adenosyltransferase PduO/GlcC-like', 'PduO/GlcC-like', 4, NULL),
(2507, NULL, 'IPR000010', NULL, 'Cystatin domain', 'Cystatin_dom', 3, NULL),
(2508, NULL, 'IPR026008', NULL, 'Uridine kinase', 'Uridine_kinase_', 4, NULL),
(2509, NULL, 'IPR004654', NULL, 'Glucokinase ROK', 'ROK_glcA', 4, NULL),
(2510, NULL, 'IPR000090', NULL, 'Flagellar motor switch protein FliG', 'Flg_Motor_Flig', 4, NULL),
(2511, NULL, 'IPR006741', NULL, 'Accessory gene regulator B', 'AgrB', 4, NULL),
(2512, NULL, 'IPR002677', NULL, 'Ribosomal protein L32p', 'Ribosomal_L32p', 4, NULL),
(2513, NULL, 'IPR005657', NULL, 'Triabin/Procalin', 'Triabi/Procalin', 4, NULL),
(2514, NULL, 'IPR017907', NULL, 'Zinc finger, RING-type, conserved site', 'Znf_RING_CS', 2, NULL),
(2515, NULL, 'IPR004131', NULL, 'Pyrophosphate-energised proton pump', 'PPase-energised_H-pump', 4, NULL),
(2516, NULL, 'IPR003127', NULL, 'SoHo domain', 'SoHo_dom', 3, NULL),
(2517, NULL, 'IPR002625', NULL, 'Smr domain', 'Smr_dom', 3, NULL),
(2518, NULL, 'IPR031350', NULL, 'Fungal STAND N-terminal Goodbye domain', 'Goodbye_dom', 3, NULL),
(2519, NULL, 'IPR004948', NULL, 'Nucleoside-triphosphatase, THEP1 type', 'Nuc-triphosphatase_THEP1', 4, NULL),
(2520, NULL, 'IPR004168', NULL, 'PPAK motif', 'PPAK_motif', 7, NULL),
(2521, NULL, 'IPR005628', NULL, 'General secretion pathway protein K', 'GspK', 4, NULL),
(2522, NULL, 'IPR002649', NULL, 'tRNA (guanine-N1-)-methyltransferase, bacteria', 'tRNA_m1G_MeTrfase_bac', 4, NULL),
(2523, NULL, 'IPR004193', NULL, 'Glycoside hydrolase, family 13, N-terminal', 'Glyco_hydro_13_N', 3, NULL),
(2524, NULL, 'IPR006755', NULL, 'Suppressor of silencing P0', 'Virus_P0', 4, NULL),
(2525, NULL, 'IPR004659', NULL, 'Ribonuclease E/G', 'RNase_E/G', 4, NULL),
(2526, NULL, 'IPR006093', NULL, 'Oxygen oxidoreductase covalent FAD-binding site', 'Oxy_OxRdtase_FAD_BS', 1, NULL),
(2527, NULL, 'IPR000105', NULL, 'Mu opioid receptor', 'Mu_opioid_rcpt', 4, NULL),
(2528, NULL, 'IPR007600', NULL, 'Baculovirus polyhedron envelope protein PEP, N-terminal', 'Baculo_PEP_N', 3, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(2529, NULL, 'IPR005655', NULL, 'Herpesvirus UL37', 'Herpes_UL37', 4, NULL),
(2530, NULL, 'IPR007584', NULL, 'Herpesvirus UL35', 'Herpes_UL35', 4, NULL),
(2531, NULL, 'IPR004138', NULL, 'HSV U79 / HCMV P34', 'U79_P34', 4, NULL),
(2532, NULL, 'IPR006756', NULL, 'Phenol hydroxylase', 'Phenol_hydroxylase', 4, NULL),
(2533, NULL, 'IPR004177', NULL, 'DDHD domain', 'DDHD_dom', 3, NULL),
(2534, NULL, 'IPR004197', NULL, 'Cellulase,  Ig-like domain', 'Cellulase_Ig-like', 3, NULL),
(2535, NULL, 'IPR006042', NULL, 'Xanthine/uracil permease', 'Xan_ur_permease', 4, NULL),
(2536, NULL, 'IPR005604', NULL, 'Bacteriophage T7 tail fibre protein', 'Phage_T7_tail_fibre', 4, NULL),
(2537, NULL, 'IPR007607', NULL, 'Bactofilin A/B', 'BacA/B', 4, NULL),
(2538, NULL, 'IPR004182', NULL, 'GRAM domain', 'GRAM', 3, NULL),
(2539, NULL, 'IPR005615', NULL, 'Glutathione synthase', 'Glutathione_synthase', 4, NULL),
(2540, NULL, 'IPR006099', NULL, 'Methylmalonyl-CoA mutase, alpha/beta chain, catalytic', 'MeMalonylCoA_mutase_a/b_cat', 3, NULL),
(2541, NULL, 'IPR000011', NULL, 'Ubiquitin/SUMO-activating enzyme E1-like', 'UBQ/SUMO-activ_enz_E1-like', 4, NULL),
(2542, NULL, 'IPR000111', NULL, 'Glycoside hydrolase family 27/36, conserved site', 'Glyco_hydro_27/36_CS', 2, NULL),
(2543, NULL, 'IPR002682', NULL, 'Photosystem II PsbJ', 'PSII_PsbJ', 4, NULL),
(2544, NULL, 'IPR006747', NULL, 'Protein of unknown function DUF599', 'DUF599', 4, NULL),
(2545, NULL, 'IPR006058', NULL, '2Fe-2S ferredoxin, iron-sulphur binding site', '2Fe2S_fd_BS', 1, NULL),
(2546, NULL, 'IPR006035', NULL, 'Ureohydrolase', 'Ureohydrolase', 4, NULL),
(2547, NULL, 'IPR000020', NULL, 'Anaphylatoxin/fibulin', 'Anaphylatoxin/fibulin', 3, NULL),
(2548, NULL, 'IPR000095', NULL, 'CRIB domain', 'CRIB_dom', 3, NULL),
(2549, NULL, 'IPR003141', NULL, 'Polymerase/histidinol phosphatase, N-terminal', 'Pol/His_phosphatase_N', 3, NULL),
(2550, NULL, 'IPR007608', NULL, 'Senescence regulator S40', 'Senescence_reg_S40', 4, NULL),
(2551, NULL, 'IPR005603', NULL, 'Coronavirus nonstructural protein NS4', 'Corona_NS4', 4, NULL),
(2552, NULL, 'IPR004162', NULL, 'E3 ubiquitin-protein ligase SINA-like, animal', 'SINA-like_animal', 4, NULL),
(2553, NULL, 'IPR030861', NULL, 'Phosphotransferase RcsD', 'Ptransferase_RcsD', 4, NULL),
(2554, NULL, 'IPR006739', NULL, 'Protein of unknown function DUF603', 'DUF603', 4, NULL),
(2555, NULL, 'IPR003231', NULL, 'Acyl carrier protein (ACP)', 'Acyl_carrier', 4, NULL),
(2556, NULL, 'IPR005590', NULL, 'Protein of unknown function DUF333', 'DUF333', 4, NULL),
(2557, NULL, 'IPR005619', NULL, 'Uncharacterised protein family, YajG', 'Uncharacterised_YajG', 4, NULL),
(2558, NULL, 'IPR034450', NULL, 'Adipogenesis regulatory factor', 'ADIRF', 4, NULL),
(2559, NULL, 'IPR004133', NULL, 'DAN', 'DAN', 3, NULL),
(2560, NULL, 'IPR007611', NULL, 'Herpesvirus tegument protein U30', 'Herpes_U30', 4, NULL),
(2561, NULL, 'IPR006067', NULL, 'Nitrite/sulphite reductase 4Fe-4S domain', 'NO2/SO3_Rdtase_4Fe4S_dom', 3, NULL),
(2562, NULL, 'IPR006073', NULL, 'GTP binding domain', 'GTP-bd', 3, NULL),
(2563, NULL, 'IPR003183', NULL, 'Methyl-coenzyme M reductase, alpha subunit, N-terminal', 'Me_CoM_Rdtase_asu_N', 3, NULL),
(2564, NULL, 'IPR007599', NULL, 'Derlin', 'DER1', 4, NULL),
(2565, NULL, 'IPR017921', NULL, 'Zinc finger, CTCHY-type', 'Znf_CTCHY', 3, NULL),
(2566, NULL, 'IPR005594', NULL, 'Trimeric autotransporter adhesin YadA-like, C-terminal membrane anchor domain', 'YadA_C', 3, NULL),
(2567, NULL, 'IPR002640', NULL, 'Arylesterase', 'Arylesterase', 4, NULL),
(2568, NULL, 'IPR006044', NULL, '11-S seed storage protein, plant', '11S_seedstore_pln', 4, NULL),
(2569, NULL, 'IPR007619', NULL, 'Herpesvirus U44', 'Herpes_U44', 4, NULL),
(2570, NULL, 'IPR007620', NULL, 'Herpesvirus UL56', 'Herpes_UL56', 4, NULL),
(2571, NULL, 'IPR004143', NULL, 'Biotinyl protein ligase (BPL) and lipoyl protein ligase (LPL), catalytic domain', 'BPL_LPL_catalytic', 3, NULL),
(2572, NULL, 'IPR005627', NULL, 'Copper homeostasis protein CutC', 'Cu_homeostasis_CutC', 4, NULL),
(2573, NULL, 'IPR005651', NULL, 'Trm112-like', 'Trm112-like', 4, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(2574, NULL, 'IPR000059', NULL, 'NUDIX hydrolase, NudL, conserved site', 'NUDIX_hydrolase_NudL_CS', 2, NULL),
(2575, NULL, 'IPR002672', NULL, 'Ribosomal protein L28e', 'Ribosomal_L28e', 4, NULL),
(2576, NULL, 'IPR000093', NULL, 'DNA recombination protein RecR', 'DNA_Rcmb_RecR', 4, NULL),
(2577, NULL, 'IPR000057', NULL, 'CXC chemokine receptor 2', 'Chemokine_CXCR2', 4, NULL),
(2578, NULL, 'IPR000009', NULL, 'Protein phosphatase 2A regulatory subunit PR55', 'PP2A_PR55', 4, NULL),
(2579, NULL, 'IPR005654', NULL, 'ATPase, AFG1-like', 'ATPase_AFG1-like', 4, NULL),
(2580, NULL, 'IPR004965', NULL, 'Paralemmin', 'Paralemmin', 4, NULL),
(2581, NULL, 'IPR006083', NULL, 'Phosphoribulokinase/uridine kinase', 'PRK/URK', 3, NULL),
(2582, NULL, 'IPR007603', NULL, 'Choline transporter-like', 'Choline_transptr-like', 4, NULL),
(2583, NULL, 'IPR002639', NULL, 'Urease accessory protein UreF', 'UreF', 4, NULL),
(2584, NULL, 'IPR006754', NULL, 'Poxvirus I3 ssDNA-binding', 'Poxvirus_I3_ssDNA-bd', 4, NULL),
(2585, NULL, 'IPR006068', NULL, 'Cation-transporting P-type ATPase, C-terminal', 'ATPase_P-typ_cation-transptr_C', 3, NULL),
(2586, NULL, 'IPR005652', NULL, 'Photosynthetic reaction centre, H subunit', 'Photo_RC_H', 4, NULL),
(2587, NULL, 'IPR006062', NULL, 'Histidine biosynthesis protein', 'His_biosynth', 4, NULL),
(2588, NULL, 'IPR006048', NULL, 'Alpha-amylase/branching enzyme, C-terminal all beta', 'A-amylase/branching_C', 3, NULL),
(2589, NULL, 'IPR007626', NULL, 'Herpesvirus viron egress-type', 'Herpesvirus_viron_egress-type', 4, NULL),
(2590, NULL, 'IPR002631', NULL, 'Plasmid replication protein', 'Plasmid_rep', 4, NULL),
(2591, NULL, 'IPR006037', NULL, 'Regulator of K+ conductance, C-terminal', 'RCK_C', 3, NULL),
(2592, NULL, 'IPR007588', NULL, 'Zinc finger, FLYWCH-type', 'Znf_FLYWCH', 3, NULL),
(2593, NULL, 'IPR005613', NULL, 'Actin interacting protein 3, C-terminal', 'AIP3_C', 3, NULL),
(2594, NULL, 'IPR004146', NULL, 'DC1', 'DC1', 3, NULL),
(2595, NULL, 'IPR006041', NULL, 'Pollen allergen Ole e 1 family', 'Pollen_Ole_e1_allergen', 4, NULL),
(2596, NULL, 'IPR006065', NULL, 'Glycoside hydrolase, family 41', 'Glyco_hydro_41', 4, NULL),
(2597, NULL, 'IPR000194', NULL, 'ATPase, F1/V1/A1 complex, alpha/beta subunit, nucleotide-binding domain', 'ATPase_F1/V1/A1_a/bsu_nucl-bd', 3, NULL),
(2598, NULL, 'IPR017948', NULL, 'Transforming growth factor beta, conserved site', 'TGFb_CS', 2, NULL),
(2599, NULL, 'IPR004186', NULL, 'Epstein Barr virus nuclear antigen-1, DNA-binding', 'EBNA1_DNA-bd', 3, NULL),
(2600, NULL, 'IPR004675', NULL, 'Alkylhydroperoxidase AhpD core', 'AhpD_core', 3, NULL),
(2601, NULL, 'IPR000018', NULL, 'P2Y purinoceptor 4', 'P2Y4', 4, NULL),
(2602, NULL, 'IPR000066', NULL, 'Antenna complex, alpha/beta subunit', 'Antenna_a/b', 3, NULL),
(2603, NULL, 'IPR007623', NULL, 'Brain-expressed X-linked protein', 'BEX', 4, NULL),
(2604, NULL, 'IPR003134', NULL, 'Hs1/Cortactin', 'Hs1_Cortactin', 7, NULL),
(2605, NULL, 'IPR005634', NULL, 'Male specific sperm protein', 'MSSP', 4, NULL),
(2606, NULL, 'IPR004145', NULL, 'Domain of unknown function DUF243', 'DUF243', 3, NULL),
(2607, NULL, 'IPR002423', NULL, 'Chaperonin Cpn60/GroEL/TCP-1 family', 'Cpn60/GroEL/TCP-1', 4, NULL),
(2608, NULL, 'IPR004185', NULL, 'Glycoside hydrolase, family 13, N-terminal Ig-like domain', 'Glyco_hydro_13_lg-like_dom', 3, NULL),
(2609, NULL, 'IPR006733', NULL, 'Baculovirus occlusion-derived virus envelope, E56', 'Baculo_ODV-E56', 4, NULL),
(2610, NULL, 'IPR004661', NULL, 'L-ribulose-5-phosphate 4-epimerase', 'AraD', 4, NULL),
(2611, NULL, 'IPR005610', NULL, 'Photosystem II Psb28, class 1', 'PSII_Psb28_class-1', 4, NULL),
(2612, NULL, 'IPR006086', NULL, 'XPG-I domain', 'XPG-I_dom', 3, NULL),
(2613, NULL, 'IPR004670', NULL, 'Na+/H+ antiporter NhaA', 'NhaA', 4, NULL),
(2614, NULL, 'IPR002642', NULL, 'Lysophospholipase, catalytic domain', 'LysoPLipase_cat_dom', 3, NULL),
(2615, NULL, 'IPR004142', NULL, 'NDRG', 'NDRG', 4, NULL),
(2616, NULL, 'IPR005600', NULL, 'Gal4 dimerisation domain', 'Gal4_dimer_dom', 3, NULL),
(2617, NULL, 'IPR004642', NULL, 'Serine dehydratase, alpha subunit', 'Ser_deHydtase_asu', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(2618, NULL, 'IPR005635', NULL, 'Inner centromere protein, ARK-binding domain', 'Inner_centromere_prot_ARK-bd', 3, NULL),
(2619, NULL, 'IPR003111', NULL, 'Lon protease, N-terminal domain', 'Lon_prtase_N', 3, NULL),
(2620, NULL, 'IPR004666', NULL, 'Ribosomal S6 modification enzyme RimK/Lysine biosynthesis enzyme LysX', 'RpS6_RimK/Lys_biosynth_LsyX', 4, NULL),
(2621, NULL, 'IPR000082', NULL, 'SEA domain', 'SEA_dom', 3, NULL),
(2622, NULL, 'IPR017923', NULL, 'Transcription factor IIS, N-terminal', 'TFIIS_N', 3, NULL),
(2623, NULL, 'IPR006746', NULL, '26S proteasome non-ATPase regulatory subunit Rpn12', '26S_Psome_Rpn12', 4, NULL),
(2624, NULL, 'IPR004645', NULL, 'DNA-binding protein Tfx, archaea', 'Tfx_DNA-bd_arc', 4, NULL),
(2625, NULL, 'IPR004662', NULL, 'Acetylglutamate kinase family', 'AcgluKinase_fam', 4, NULL),
(2626, NULL, 'IPR002659', NULL, 'Glycosyl transferase, family 31', 'Glyco_trans_31', 4, NULL),
(2627, NULL, 'IPR004947', NULL, 'Deoxyribonuclease II', 'DNase_II', 4, NULL),
(2628, NULL, 'IPR017893', NULL, 'DBB domain', 'DBB_domain', 3, NULL),
(2629, NULL, 'IPR005592', NULL, 'Mono-/di-acylglycerol lipase, N-terminal', 'Mono/diacylglycerol_lipase_N', 3, NULL),
(2630, NULL, 'IPR002689', NULL, 'Cytomegalovirus glycoprotein L', 'Cytomegalo_gL', 4, NULL),
(2631, NULL, 'IPR006094', NULL, 'FAD linked oxidase, N-terminal', 'Oxid_FAD_bind_N', 3, NULL),
(2632, NULL, 'IPR002624', NULL, 'Deoxynucleoside kinase', 'DCK/DGK', 4, NULL),
(2633, NULL, 'IPR006743', NULL, 'Mycoplasma hyorhinis VlpA repeat', 'VlpA_repeat', 7, NULL),
(2634, NULL, 'IPR004650', NULL, 'HisA/HisF-like protein, archaeal', 'HisA/F-archaeal', 4, NULL),
(2635, NULL, 'IPR007592', NULL, 'GLABROUS1 enhancer-binding protein family', 'GEBP', 4, NULL),
(2636, NULL, 'IPR007616', NULL, 'Herpesvirus U59/UL88', 'Herpes_U59/UL88', 4, NULL),
(2637, NULL, 'IPR006060', NULL, 'Maltose/Cyclodextrin ABC transporter, substrate-binding protein', 'Maltose/Cyclodextrin-bd', 4, NULL),
(2638, NULL, 'IPR005611', NULL, 'Amb V Allergen', 'Amb_V_allergen', 4, NULL),
(2639, NULL, 'IPR006056', NULL, 'RidA family', 'RidA', 4, NULL),
(2640, NULL, 'IPR019842', NULL, 'Uricase, conserved site', 'Uricase_CS', 2, NULL),
(2641, NULL, 'IPR005623', NULL, 'Chaperone NapD, nitrate reductase assembly', 'Chaperone_NapD_NO3_reduct', 4, NULL),
(2642, NULL, 'IPR004154', NULL, 'Anticodon-binding', 'Anticodon-bd', 3, NULL),
(2643, NULL, 'IPR031349', NULL, 'General transcription factor TFIIH, subunit Tfb6', 'Tfb6', 4, NULL),
(2644, NULL, 'IPR005644', NULL, 'NolW-like', 'NolW-like', 3, NULL),
(2645, NULL, 'IPR034121', NULL, 'Glioma pathogenesis-related protein 1-like, SCP domain', 'SCP_GLIPR-1-like', 3, NULL),
(2646, NULL, 'IPR031356', NULL, 'Stealth protein CR4, conserved region 4', 'Stealth_CR4', 3, NULL),
(2647, NULL, 'IPR004170', NULL, 'WWE domain', 'WWE-dom', 3, NULL),
(2648, NULL, 'IPR004176', NULL, 'Clp,  repeat (R) domain', 'Clp_R_dom', 3, NULL),
(2649, NULL, 'IPR003122', NULL, 'Chemotaxis methyl-accepting receptor Tar-related, ligand-binding', 'Tar_rcpt_lig-bd', 3, NULL),
(2650, NULL, 'IPR006074', NULL, 'GTP1/OBG, conserved site', 'GTP1-OBG_CS', 2, NULL),
(2651, NULL, 'IPR004672', NULL, 'Na(+)/H(+) antiporter NhaD', 'Na(+)/H(+)_antiporter_NhaD', 4, NULL),
(2652, NULL, 'IPR002634', NULL, 'BolA protein', 'BolA', 4, NULL),
(2653, NULL, 'IPR002683', NULL, 'PsbP, C-terminal', 'PsbP_C', 3, NULL),
(2654, NULL, 'IPR004161', NULL, 'Translation elongation factor EFTu-like, domain 2', 'EFTu-like_2', 3, NULL),
(2655, NULL, 'IPR006753', NULL, 'Nanovirus coat protein', 'Nanovirus_coat', 4, NULL),
(2656, NULL, 'IPR004663', NULL, 'Lon protease, archaeal', 'Lon_arc', 4, NULL),
(2657, NULL, 'IPR031354', NULL, 'Bromodomain protein 4, C-terminal', 'BRD4_CDT', 3, NULL),
(2658, NULL, 'IPR004150', NULL, 'NAD-dependent DNA ligase, OB-fold', 'NAD_DNA_ligase_OB', 3, NULL),
(2659, NULL, 'IPR003109', NULL, 'GoLoco motif', 'GoLoco_motif', 2, NULL),
(2660, NULL, 'IPR005631', NULL, 'Flavinator of succinate dehydrogenase', 'SDH', 4, NULL),
(2661, NULL, 'IPR000077', NULL, 'Ribosomal protein L39e', 'Ribosomal_L39', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(2662, NULL, 'IPR000101', NULL, 'Gamma-glutamyltranspeptidase', 'GGT_peptidase', 4, NULL),
(2663, NULL, 'IPR006046', NULL, 'Alpha amylase', 'Alpha_amylase', 4, NULL),
(2664, NULL, 'IPR007590', NULL, 'Saf4/Yju2 protein', 'Saf4/Yju2', 4, NULL),
(2665, NULL, 'IPR003120', NULL, 'Transcription factor Ste12', 'Ste12', 4, NULL),
(2666, NULL, 'IPR006096', NULL, 'Glutamate/phenylalanine/leucine/valine dehydrogenase, C-terminal', 'Glu/Leu/Phe/Val_DH_C', 3, NULL),
(2667, NULL, 'IPR005633', NULL, 'Ribosomal protein L23/L25, N-terminal', 'Ribosomal_L23/L25_N', 3, NULL),
(2668, NULL, 'IPR004957', NULL, 'Gag polyprotein', 'Gag', 4, NULL),
(2669, NULL, 'IPR007597', NULL, 'CheC-like protein', 'CheC', 3, NULL),
(2670, NULL, 'IPR004147', NULL, 'ABC1 atypical kinase-like domain', 'ABC1_dom', 3, NULL),
(2671, NULL, 'IPR004158', NULL, 'Protein of unknown function DUF247, plant', 'DUF247_pln', 4, NULL),
(2672, NULL, 'IPR004644', NULL, 'Iron-sulphur-dependent L-serine dehydratase single chain form', 'Fe-S_L-Ser_mono', 4, NULL),
(2673, NULL, 'IPR004651', NULL, 'Histidine biosynthesis, HisF', 'HisF', 4, NULL),
(2674, NULL, 'IPR006079', NULL, 'Lantibiotic, Type A, Bacillales-type', 'Lantibiotic_typ-A_Bacillales', 4, NULL),
(2675, NULL, 'IPR002671', NULL, 'Ribosomal protein L22e', 'Ribosomal_L22e', 4, NULL),
(2676, NULL, 'IPR002680', NULL, 'Alternative oxidase', 'AOX', 4, NULL),
(2677, NULL, 'IPR005641', NULL, 'Hexon-associated protein IX', 'Hexon_assoc_IX', 4, NULL),
(2678, NULL, 'IPR007604', NULL, 'CP2 transcription factor', 'CP2', 3, NULL),
(2679, NULL, 'IPR000013', NULL, 'Peptidase M7, snapalysin', 'Peptidase_M7', 4, NULL),
(2680, NULL, 'IPR002621', NULL, 'Geminivirus infecting protein', 'Gemini_mov', 4, NULL),
(2681, NULL, 'IPR004643', NULL, 'Iron-sulphur-dependent L-serine dehydratase beta subunit', 'Fe-S_L-Ser_bsu', 4, NULL),
(2682, NULL, 'IPR003774', NULL, 'Protein of unknown function UPF0301', 'UPF0301', 4, NULL),
(2683, NULL, 'IPR017892', NULL, 'Protein kinase, C-terminal', 'Pkinase_C', 3, NULL),
(2684, NULL, 'IPR004653', NULL, 'tRNA-dihydrouridine(20/20a) synthase', 'DusA', 4, NULL),
(2685, NULL, 'IPR007617', NULL, 'Viral beta C/D-like', 'Viral_beta_CD', 4, NULL),
(2686, NULL, 'IPR003251', NULL, 'Rubrerythrin, diiron-binding domain', 'Rr_diiron-bd_dom', 3, NULL),
(2687, NULL, 'IPR005626', NULL, 'Recombinase Flp protein, C-terminal', 'Recombinase_Flp_C', 3, NULL),
(2688, NULL, 'IPR006737', NULL, 'Motilin/ghrelin-associated peptide', 'Motilin_assoc', 3, NULL),
(2689, NULL, 'IPR004175', NULL, 'RNA 2'',3''-cyclic phosphodiesterase', 'RNA_CPDase', 4, NULL),
(2690, NULL, 'IPR005645', NULL, 'Serine hydrolase FSH', 'FSH_dom', 3, NULL),
(2691, NULL, 'IPR006089', NULL, 'Acyl-CoA dehydrogenase, conserved site', 'Acyl-CoA_DH_CS', 2, NULL),
(2692, NULL, 'IPR003147', NULL, 'Protein L, Ig light chain-binding', 'B1_Ig_chn-bd', 7, NULL),
(2693, NULL, 'IPR003180', NULL, 'Methylpurine-DNA glycosylase', 'MPG', 4, NULL),
(2694, NULL, 'IPR003777', NULL, 'XdhC- CoxI', 'XdhC_CoxI', 3, NULL),
(2695, NULL, 'IPR034103', NULL, 'Sm-like protein Lsm8', 'Lsm8', 3, NULL),
(2696, NULL, 'IPR006097', NULL, 'Glutamate/phenylalanine/leucine/valine dehydrogenase, dimerisation domain', 'Glu/Leu/Phe/Val_DH_dimer_dom', 3, NULL),
(2697, NULL, 'IPR003138', NULL, 'Picornavirus coat protein VP4', 'Pico_P1A', 4, NULL),
(2698, NULL, 'IPR005606', NULL, 'Sec20', 'Sec20', 4, NULL),
(2699, NULL, 'IPR003245', NULL, 'Phytocyanin domain', 'Phytocyanin_dom', 3, NULL),
(2700, NULL, 'IPR004202', NULL, 'Cytochrome c oxidase subunit VIIc', 'COX7C/Cox8', 4, NULL),
(2701, NULL, 'IPR003114', NULL, 'Phox-associated domain', 'Phox_assoc', 3, NULL),
(2702, NULL, 'IPR005629', NULL, 'Beta-glucan synthesis-associated protein Skn1/Kre6/Sbg1', 'Skn1/Kre6/Sbg1', 4, NULL),
(2703, NULL, 'IPR000037', NULL, 'SsrA-binding protein', 'SsrA-bd_prot', 4, NULL),
(2704, NULL, 'IPR031353', NULL, 'NACHT-NTPase, sigma domain', 'NACHT_sigma', 3, NULL),
(2705, NULL, 'IPR006036', NULL, 'Potassium uptake protein TrkA', 'K_uptake_TrkA', 4, NULL),
(2706, NULL, 'IPR031355', NULL, 'Protein of unknown function DUF5102', 'DUF5102', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(2707, NULL, 'IPR007612', NULL, 'LURP-one-related', 'LOR', 4, NULL),
(2708, NULL, 'IPR000048', NULL, 'IQ motif, EF-hand binding site', 'IQ_motif_EF-hand-BS', 1, NULL),
(2709, NULL, 'IPR000040', NULL, 'Acute myeloid leukemia 1 protein (AML1)/Runt', 'AML1_Runt', 4, NULL),
(2710, NULL, 'IPR000069', NULL, 'Envelope glycoprotein M, flavivirus', 'Env_glycoprot_M_flavivir', 3, NULL),
(2711, NULL, 'IPR003226', NULL, 'Metal-dependent protein hydrolase', 'Met-dep_prot_hydro', 4, NULL),
(2712, NULL, 'IPR007594', NULL, 'RFT1', 'RFT1', 4, NULL),
(2713, NULL, 'IPR002635', NULL, 'Chorion protein', 'Chorion', 4, NULL),
(2714, NULL, 'IPR017945', NULL, 'DHBP synthase RibB-like alpha/beta domain superfamily', 'DHBP_synth_RibB-like_a/b_dom', 5, NULL),
(2715, NULL, 'IPR005647', NULL, 'Meiotic nuclear division protein 1', 'Mnd1', 4, NULL),
(2716, NULL, 'IPR004140', NULL, 'Exocyst complex component Exo70', 'Exo70', 4, NULL),
(2717, NULL, 'IPR006045', NULL, 'Cupin 1', 'Cupin_1', 3, NULL),
(2718, NULL, 'IPR017916', NULL, 'Steadiness box (SB) domain', 'SB_dom', 3, NULL),
(2719, NULL, 'IPR000008', NULL, 'C2 domain', 'C2_dom', 3, NULL),
(2720, NULL, 'IPR034452', NULL, 'Transmembrane protein PVRIG', 'TM_PVRIG', 4, NULL),
(2721, NULL, 'IPR002636', NULL, 'Protein from unkown function DUF29', 'DUF29', 4, NULL),
(2722, NULL, 'IPR004655', NULL, 'Beta-ketoacyl-[acyl-carrier-protein] synthase III', 'FabH', 4, NULL),
(2723, NULL, 'IPR006076', NULL, 'FAD dependent oxidoreductase', 'FAD-dep_OxRdtase', 3, NULL),
(2724, NULL, 'IPR002648', NULL, 'Adenylate dimethylallyltransferase', 'Tzs', 4, NULL),
(2725, NULL, 'IPR002685', NULL, 'Glycosyl transferase, family 15', 'Glyco_trans_15', 4, NULL),
(2726, NULL, 'IPR003224', NULL, 'RING finger protein Z, zinc finger', 'Z_RING_Znf', 3, NULL),
(2727, NULL, 'IPR002645', NULL, 'STAS domain', 'STAS_dom', 3, NULL),
(2728, NULL, 'IPR000036', NULL, 'Peptidase A26, omptin', 'Peptidase_A26_omptin', 4, NULL),
(2729, NULL, 'IPR004958', NULL, 'Herpesvirus UL4', 'Herpes_UL4', 4, NULL),
(2730, NULL, 'IPR017925', NULL, 'Dihydrofolate reductase conserved site', 'DHFR_CS', 2, NULL),
(2731, NULL, 'IPR004967', NULL, 'Poxvirus C7/F8A', 'Poxvirus_C7/F8A', 4, NULL),
(2732, NULL, 'IPR000086', NULL, 'NUDIX hydrolase domain', 'NUDIX_hydrolase_dom', 3, NULL),
(2733, NULL, 'IPR003108', NULL, 'GAR domain', 'GAR_dom', 3, NULL),
(2734, NULL, 'IPR000070', NULL, 'Pectinesterase, catalytic', 'Pectinesterase_cat', 3, NULL),
(2735, NULL, 'IPR005632', NULL, 'Chaperone protein Skp', 'Chaperone_Skp', 4, NULL),
(2736, NULL, 'IPR005642', NULL, 'Lysine exporter LysO', 'LysO', 4, NULL),
(2737, NULL, 'IPR005601', NULL, 'Tail fibre protein p36', 'Tail_fibre_p36', 4, NULL),
(2738, NULL, 'IPR005636', NULL, 'DTW', 'DTW', 3, NULL),
(2739, NULL, 'IPR002413', NULL, 'Venom allergen 5-like', 'V5_allergen-like', 4, NULL),
(2740, NULL, 'IPR000074', NULL, 'Apolipoprotein A/E', 'ApoA_E', 4, NULL),
(2741, NULL, 'IPR005602', NULL, 'Protein of unknown function DUF334', 'DUF334', 4, NULL),
(2742, NULL, 'IPR004671', NULL, 'Na+/H+ antiporter NhaB', 'Na+/H+_antiporter_NhaB', 4, NULL),
(2743, NULL, 'IPR005653', NULL, 'Organic solvent tolerance-like, N-terminal', 'OstA-like_N', 3, NULL),
(2744, NULL, 'IPR004194', NULL, 'Restriction endonuclease, type II, BamHI', 'Restrct_endonuc_II_BamHI', 4, NULL),
(2745, NULL, 'IPR017949', NULL, 'Thaumatin, conserved site', 'Thaumatin_CS', 2, NULL),
(2746, NULL, 'IPR006034', NULL, 'Asparaginase/glutaminase-like', 'Asparaginase/glutaminase-like', 4, NULL),
(2747, NULL, 'IPR006752', NULL, 'Archaeal flagella protein FlaD/E domain', 'Arch_fla_DE', 3, NULL),
(2748, NULL, 'IPR000079', NULL, 'High mobility group protein HMGN', 'HMGN_fam', 4, NULL),
(2749, NULL, 'IPR002646', NULL, 'Poly A polymerase, head domain', 'PolA_pol_head_dom', 3, NULL),
(2750, NULL, 'IPR004169', NULL, 'Spider toxin', 'Spidertoxin', 4, NULL),
(2751, NULL, 'IPR006102', NULL, 'Glycoside hydrolase, family 2, immunoglobulin-like beta-sandwich', 'Glyco_hydro_2_Ig-like', 3, NULL),
(2752, NULL, 'IPR007598', NULL, 'Domain of unknown function DUF577', 'DUF577', 3, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(2753, NULL, 'IPR005617', NULL, 'Groucho/TLE, N-terminal Q-rich domain', 'Groucho/TLE_N', 3, NULL),
(2754, NULL, 'IPR005648', NULL, 'Flagellar hook capping protein', 'FlgD', 4, NULL),
(2755, NULL, 'IPR007601', NULL, 'Baculovirus polyhedron envelope protein PEP, C-terminal', 'Baculo_PEP_C', 3, NULL),
(2756, NULL, 'IPR004656', NULL, 'Putative condensing enzyme FabH-related', 'FabH-rel', 4, NULL),
(2757, NULL, 'IPR031351', NULL, 'NWD2, HET-s N-terminal domain', 'NWD2_N', 3, NULL),
(2758, NULL, 'IPR004167', NULL, 'Peripheral subunit-binding domain', 'PSBD', 3, NULL),
(2759, NULL, 'IPR005649', NULL, 'Chorion 2', 'Chorion_2', 4, NULL),
(2760, NULL, 'IPR002690', NULL, 'Herpesvirus capsid protein 2', 'Herpes_capsid_2', 4, NULL),
(2761, NULL, 'IPR004184', NULL, 'Pyruvate formate lyase domain', 'PFL_dom', 3, NULL),
(2762, NULL, 'IPR006064', NULL, 'Cytokinin glycosidase', 'Glycosidase', 3, NULL),
(2763, NULL, 'IPR002678', NULL, 'DUF34/NIF3', 'DUF34/NIF3', 4, NULL),
(2764, NULL, 'IPR001028', NULL, 'Glycoprotein phospholipase D', 'Gprt_PLipase_D', 4, NULL),
(2765, NULL, 'IPR007622', NULL, 'Herpesvirus UL55', 'Herpes_UL55', 4, NULL),
(2766, NULL, 'IPR002660', NULL, 'Herpesvirus portal protein', 'Herpes_Portal', 4, NULL),
(2767, NULL, 'IPR002661', NULL, 'Ribosome recycling factor', 'Ribosome_recyc_fac', 4, NULL),
(2768, NULL, 'IPR005637', NULL, 'TAP C-terminal (TAP-C) domain', 'TAP_C_dom', 3, NULL),
(2769, NULL, 'IPR006736', NULL, 'Protein of unknown function DUF601', 'DUF601', 4, NULL),
(2770, NULL, 'IPR002669', NULL, 'Urease accessory protein UreD', 'UreD', 4, NULL),
(2771, NULL, 'IPR005616', NULL, 'CcmH/CycL/Ccl2/NrfF family', 'CcmH/CycL/Ccl2/NrfF', 4, NULL),
(2772, NULL, 'IPR034105', NULL, 'Sm-like protein Lsm3', 'Lsm3', 3, NULL),
(2773, NULL, 'IPR002674', NULL, 'Ribosomal protein L37ae', 'Ribosomal_L37ae', 4, NULL),
(2774, NULL, 'IPR005638', NULL, 'Pesticidal crystal protein, C-terminal', 'Pest_crys_C', 3, NULL),
(2775, NULL, 'IPR004136', NULL, 'Nitronate monooxygenase', 'NMO', 3, NULL),
(2776, NULL, 'IPR003235', NULL, 'Nematode insulin-like peptide, beta type', 'Nem_insulin-like_b-type', 4, NULL),
(2777, NULL, 'IPR004953', NULL, 'EB1, C-terminal', 'EB1_C', 3, NULL),
(2778, NULL, 'IPR004959', NULL, 'Bacterial effector protein IpgB-like', 'Bac_effector_IpgB-like', 4, NULL),
(2779, NULL, 'IPR005591', NULL, 'Nitrate reductase cytochrome c-type subunit NapB', 'NapB', 4, NULL),
(2780, NULL, 'IPR004960', NULL, 'Bacterial lipid A biosynthesis acyltransferase', 'LipA_acyltrans', 4, NULL),
(2781, NULL, 'IPR000054', NULL, 'Ribosomal protein L31e', 'Ribosomal_L31e', 4, NULL),
(2782, NULL, 'IPR004952', NULL, 'Uncharacterised protein family UPF0460', 'UPF0460', 4, NULL),
(2783, NULL, 'IPR000025', NULL, 'Melatonin receptor family', 'Melatonin_rcpt', 4, NULL),
(2784, NULL, 'IPR004173', NULL, '3H domain', '3H_domain', 3, NULL),
(2785, NULL, 'IPR004178', NULL, 'Calmodulin-binding domain', 'CaM-bd_dom', 3, NULL),
(2786, NULL, 'IPR005593', NULL, 'Xylulose 5-phosphate/Fructose 6-phosphate phosphoketolase', 'Xul5P/Fru6P_PKetolase', 4, NULL),
(2787, NULL, 'IPR004153', NULL, 'CXCXC repeat', 'CXCXC_repeat', 7, NULL),
(2788, NULL, 'IPR002622', NULL, 'Transposase, Synechocystis PCC 6803', 'Transposase_14', 3, NULL),
(2789, NULL, 'IPR002638', NULL, 'Quinolinate phosphoribosyl transferase, C-terminal', 'Quinolinate_PRibosylTrfase_C', 3, NULL),
(2790, NULL, 'IPR002681', NULL, 'Coat protein, Ilarvirus', 'Coat_Ilarvirus', 4, NULL),
(2791, NULL, 'IPR002652', NULL, 'Importin-alpha, importin-beta-binding domain', 'Importin-a_IBB', 3, NULL),
(2792, NULL, 'IPR006731', NULL, 'Herpesvirus phosphoprotein 85 (HHV6-7 U14/HCMV UL25)', 'Herpes_pp85', 4, NULL),
(2793, NULL, 'IPR002656', NULL, 'Acyltransferase 3 domain', 'Acyl_transf_3_dom', 3, NULL),
(2794, NULL, 'IPR007609', NULL, 'ssRNA positive strand viral 18kDa cysteine-rich protein', 'Viral_P18', 4, NULL),
(2795, NULL, 'IPR006101', NULL, 'Glycoside hydrolase, family 2', 'Glyco_hydro_2', 4, NULL),
(2796, NULL, 'IPR005599', NULL, 'GPI mannosyltransferase', 'GPI_mannosylTrfase', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(2797, NULL, 'IPR006050', NULL, 'DNA photolyase, N-terminal', 'DNA_photolyase_N', 3, NULL),
(2798, NULL, 'IPR004152', NULL, 'GAT domain', 'GAT_dom', 3, NULL),
(2799, NULL, 'IPR017944', NULL, 'KaiA/RbsU helical domain superfamily', 'KaiA/RbsU_helical_domain_sf', 5, NULL),
(2800, NULL, 'IPR017920', NULL, 'COMM domain', 'COMM', 3, NULL),
(2801, NULL, 'IPR003135', NULL, 'ATP-grasp fold, ATP-dependent carboxylate-amine ligase-type', 'ATP-grasp_carboxylate-amine', 3, NULL),
(2802, NULL, 'IPR002619', NULL, 'Domain of unknown function CX', 'CX', 3, NULL),
(2803, NULL, 'IPR006744', NULL, 'Poxvirus A12', 'Poxvirus_A12', 4, NULL),
(2804, NULL, 'IPR003125', NULL, 'Domain of unknown function WSN', 'WSN', 3, NULL),
(2805, NULL, 'IPR005595', NULL, 'Translocon-associated protein (TRAP), alpha subunit', 'TRAP_alpha', 4, NULL),
(2806, NULL, 'IPR000021', NULL, 'Hok/gef cell toxic protein', 'Hok/gef_toxin', 4, NULL),
(2807, NULL, 'IPR004139', NULL, 'Glycosyl transferase, family 13', 'Glyco_trans_13', 4, NULL),
(2808, NULL, 'IPR007605', NULL, 'Microvirus lysis protein (E)', 'Micrvir_lysisE', 4, NULL),
(2809, NULL, 'IPR006052', NULL, 'Tumour necrosis factor domain', 'TNF_dom', 3, NULL),
(2810, NULL, 'IPR004955', NULL, 'Baculovirus Gp64, envelope glycoprotein', 'Baculovirus_Gp64', 4, NULL),
(2811, NULL, 'IPR023211', NULL, 'DNA polymerase, palm domain superfamily', 'DNA_pol_palm_dom_sf', 5, NULL),
(2812, NULL, 'IPR007615', NULL, 'Adenovirus E4 30/34kDa protein', 'Adenovirus_E4_30/34', 4, NULL),
(2813, NULL, 'IPR002644', NULL, 'Photosystem II PsbZ, reaction centre', 'PSII_PsbZ', 4, NULL),
(2814, NULL, 'IPR002415', NULL, 'H/ACA ribonucleoprotein complex, subunit Nhp2-like', 'H/ACA_rnp_Nhp2-like', 4, NULL),
(2815, NULL, 'IPR004189', NULL, 'Bacteriophage Mu, transposase', 'Phage_Mu_transposase', 3, NULL),
(2816, NULL, 'IPR001036', NULL, 'Acriflavin resistance protein', 'Acrflvin-R', 4, NULL),
(2817, NULL, 'IPR002662', NULL, 'Birnavirus VP2 protein', 'Birna_VP2', 4, NULL),
(2818, NULL, 'IPR002629', NULL, 'Cobalamin-independent methionine synthase MetE, C-terminal/archaeal', 'Met_Synth_C/arc', 3, NULL),
(2819, NULL, 'IPR004190', NULL, 'DNA polymerase processivity factor', 'DNA_pol_proc_fac', 3, NULL),
(2820, NULL, 'IPR004668', NULL, 'Anaerobic c4-dicarboxylate membrane transporter', 'Anaer_Dcu_memb_transpt', 4, NULL),
(2821, NULL, 'IPR000072', NULL, 'PDGF/VEGF domain', 'PDGF/VEGF_dom', 3, NULL),
(2822, NULL, 'IPR017939', NULL, 'Gamma-glutamylcyclotransferase', 'G-Glutamylcylcotransferase', 4, NULL),
(2823, NULL, 'IPR004166', NULL, 'MHCK/EF2 kinase', 'MHCK_EF2_kinase', 3, NULL),
(2824, NULL, 'IPR004950', NULL, 'Protein of unknown function DUF267, Caenorhabditis species', 'DUF267_CAE_spp', 4, NULL),
(2825, NULL, 'IPR004159', NULL, 'Putative S-adenosyl-L-methionine-dependent methyltransferase', 'Put_SAM_MeTrfase', 4, NULL),
(2826, NULL, 'IPR006080', NULL, 'Beta/alpha-defensin, C-terminal', 'Beta/alpha-defensin_C', 3, NULL),
(2827, NULL, 'IPR007587', NULL, 'SIT4 phosphatase-associated protein family', 'SAPS', 4, NULL),
(2828, NULL, 'IPR005618', NULL, 'Outer membrane protein, OmpW', 'OMPW', 4, NULL),
(2829, NULL, 'IPR006091', NULL, 'Acyl-CoA oxidase/dehydrogenase, middle domain', 'Acyl-CoA_Oxase/DH_mid-dom', 3, NULL),
(2830, NULL, 'IPR007593', NULL, 'CD225/Dispanin family', 'CD225/Dispanin_fam', 4, NULL),
(2831, NULL, 'IPR007624', NULL, 'RNA polymerase sigma-70 region 3', 'RNA_pol_sigma70_r3', 3, NULL),
(2832, NULL, 'IPR002684', NULL, 'Biotin synthase/Biotin biosynthesis bifunctional protein BioAB', 'Biotin_synth/BioAB', 4, NULL),
(2833, NULL, 'IPR005598', NULL, 'ATP synthase protein I', 'ATP_synth_I', 4, NULL),
(2834, NULL, 'IPR007602', NULL, 'Bluetongue virus nonstructural protein NS2', 'BTV_NS2', 4, NULL),
(2835, NULL, 'IPR005589', NULL, 'Alternative ribosome-rescue factor A', 'ArfA', 4, NULL),
(2836, NULL, 'IPR004964', NULL, 'Phenazine biosynthesis protein A/B', 'PhzA_PhzB', 4, NULL),
(2837, NULL, 'IPR006070', NULL, 'Threonylcarbamoyl-AMP synthase-like domain', 'Sua5-like_dom', 3, NULL),
(2838, NULL, 'IPR004149', NULL, 'Zinc-finger, NAD-dependent DNA ligase C4-type', 'Znf_DNAligase_C4', 3, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(2839, NULL, 'IPR007606', NULL, 'Type III secretion system effector', 'T3SS_effector', 4, NULL),
(2840, NULL, 'IPR005656', NULL, 'MmgE/PrpD', 'MmgE_PrpD', 4, NULL),
(2841, NULL, 'IPR006738', NULL, 'Motilin/ghrelin', 'Motilin_ghrelin', 3, NULL),
(2842, NULL, 'IPR000044', NULL, 'Uncharacterised lipoprotein MG045', 'Uncharacterised_lipoprot_MG045', 4, NULL),
(2843, NULL, 'IPR004137', NULL, 'Hydroxylamine reductase/Ni-containing CO dehydrogenase', 'HCP/CODH', 4, NULL),
(2844, NULL, 'IPR004183', NULL, 'Extradiol ring-cleavage dioxygenase, class III enzyme, subunit B', 'Xdiol_dOase_suB', 3, NULL),
(2845, NULL, 'IPR000091', NULL, 'Huntingtin', 'Huntingtin', 4, NULL),
(2846, NULL, 'IPR004660', NULL, 'Pyruvate dehydrogenase E1 component', 'PDH_E1', 4, NULL),
(2847, NULL, 'IPR030863', NULL, '1,4-dihydroxy-2-naphthoyl-CoA hydrolase, MenI', 'MenI', 4, NULL),
(2848, NULL, 'IPR006066', NULL, 'Nitrite/sulphite reductase iron-sulphur/sirohaem-binding site', 'NO2/SO3_Rdtase_FeS/sirohaem_BS', 1, NULL),
(2849, NULL, 'IPR006742', NULL, 'Mating factor alpha, C-terminal repeat', 'Mating_factor_alpha_C', 7, NULL),
(2850, NULL, 'IPR004674', NULL, 'Alkylhydroperoxidase AhpD', 'AhpD', 4, NULL),
(2851, NULL, 'IPR006085', NULL, 'XPG, N-terminal', 'XPG_DNA_repair_N', 3, NULL),
(2852, NULL, 'IPR006053', NULL, 'Tumour necrosis factor', 'TNF', 4, NULL),
(2853, NULL, 'IPR006072', NULL, 'Odorant/pheromone binding protein, Lepidoptera', 'Odorant/phero-bd_Lep', 4, NULL),
(2854, NULL, 'IPR004163', NULL, 'Coenzyme A transferase binding site', 'CoA_transf_BS', 1, NULL),
(2855, NULL, 'IPR006084', NULL, 'XPG/Rad2 endonuclease', 'XPG/Rad2', 4, NULL),
(2856, NULL, 'IPR007586', NULL, 'Poxvirus VP8/L4R, nucleic acid binding', 'VP8_pox_nuc-bd', 4, NULL),
(2857, NULL, 'IPR006081', NULL, 'Alpha-defensin, C-terminal', 'Alpha-defensin_C', 3, NULL),
(2858, NULL, 'IPR005643', NULL, 'Jun-like transcription factor', 'JNK', 3, NULL),
(2859, NULL, 'IPR006748', NULL, 'Aminoglycoside/hydroxyurea antibiotic resistance kinase', 'NH2Glyco/OHUrea_AB-resist_kin', 4, NULL),
(2860, NULL, 'IPR005658', NULL, 'Proteinase inhibitor I11, ecotin', 'Prot_inh_ecotin', 4, NULL),
(2861, NULL, 'IPR022608', NULL, 'Transcription regulator SplA', 'Tscrpt_reg_SplA', 4, NULL),
(2862, NULL, 'IPR000064', NULL, 'Endopeptidase, NLPC/P60 domain', 'NLP_P60_dom', 3, NULL),
(2863, NULL, 'IPR004188', NULL, 'Phenylalanine-tRNA ligase, class II, N-terminal', 'Phe-tRNA_ligase_II_N', 3, NULL),
(2864, NULL, 'IPR004192', NULL, 'Cytochrome b-c1 complex subunit Rieske, transmembrane domain', 'Rieske_TM', 3, NULL),
(2865, NULL, 'IPR006082', NULL, 'Phosphoribulokinase', 'PRK', 4, NULL),
(2866, NULL, 'IPR004148', NULL, 'BAR domain', 'BAR_dom', 3, NULL),
(2867, NULL, 'IPR002654', NULL, 'Glycosyl transferase, family 25', 'Glyco_trans_25', 4, NULL),
(2868, NULL, 'IPR004961', NULL, 'Lipase chaperone', 'Lipase_chaperone', 4, NULL),
(2869, NULL, 'IPR003773', NULL, 'Menaquinone biosynthesis enzyme', 'Menaquinone_biosynth', 4, NULL),
(2870, NULL, 'IPR000034', NULL, 'Laminin IV', 'Laminin_IV', 3, NULL),
(2871, NULL, 'IPR005612', NULL, 'CCAAT-binding factor', 'CCAAT-binding_factor', 3, NULL),
(2872, NULL, 'IPR031352', NULL, 'NACHT-NTPase and P-loop NTPases, N-terminal domain', 'SesA', 3, NULL),
(2873, NULL, 'IPR002620', NULL, 'Alphavirus nsp2 protease (nsp2pro) domain', 'Alphavirus_nsp2pro', 3, NULL),
(2874, NULL, 'IPR004181', NULL, 'Zinc finger, MIZ-type', 'Znf_MIZ', 3, NULL),
(2875, NULL, 'IPR030864', NULL, 'Transcriptional regulatory protein RcsB', 'RcsB', 4, NULL),
(2876, NULL, 'IPR002616', NULL, 'tRNA-guanine(15) transglycosylase-like', 'tRNA_ribo_trans-like', 3, NULL),
(2877, NULL, 'IPR004132', NULL, 'Kinetoplastid membrane protein 11', 'KMP11', 4, NULL),
(2878, NULL, 'IPR002637', NULL, 'Ham1-like protein', 'Ham1p-like', 4, NULL),
(2879, NULL, 'IPR000052', NULL, 'Potex/carlavirus coat protein', 'Pltvir_coat', 3, NULL),
(2880, NULL, 'IPR006059', NULL, 'Bacterial extracellular solute-binding protein', 'SBP', 4, NULL),
(2881, NULL, 'IPR006740', NULL, 'Protein of unknown function DUF604', 'DUF604', 4, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(2882, NULL, 'IPR005605', NULL, 'Sporulation-specific protein Spo7', 'Spo7', 4, NULL),
(2883, NULL, 'IPR005650', NULL, 'BlaI transcriptional regulatory family', 'BlaI_family', 4, NULL),
(2884, NULL, 'IPR004658', NULL, 'Outer membrane lipoprotein Slp', 'OMP_Slp', 4, NULL),
(2885, NULL, 'IPR007614', NULL, 'Retinin-like protein', 'Retinin_C', 4, NULL),
(2886, NULL, 'IPR004179', NULL, 'Sec63 domain', 'Sec63-dom', 3, NULL),
(2887, NULL, 'IPR001033', NULL, 'Alpha-catenin', 'Alpha_catenin', 4, NULL),
(2888, NULL, 'IPR002655', NULL, 'Acyl-CoA oxidase, C-terminal', 'Acyl-CoA_oxidase_C', 3, NULL),
(2889, NULL, 'IPR003220', NULL, 'InsA N-terminal domain', 'InsA_N_dom', 3, NULL),
(2890, NULL, 'IPR024962', NULL, 'YukD-like', 'YukD-like', 4, NULL),
(2891, NULL, 'IPR006103', NULL, 'Glycoside hydrolase family 2, catalytic domain', 'Glyco_hydro_2_cat', 3, NULL),
(2892, NULL, 'IPR002663', NULL, 'Birnavirus VP3 protein', 'Birna_VP3', 4, NULL),
(2893, NULL, 'IPR005639', NULL, 'Pesticidal crystal protein, N-terminal', 'Pest_crys_N', 3, NULL),
(2894, NULL, 'IPR001032', NULL, 'Leghaemoglobin', 'Leghaemoglobin', 4, NULL),
(2895, NULL, 'IPR000046', NULL, 'Neurokinin NK1 receptor', 'NK1_rcpt', 4, NULL),
(2896, NULL, 'IPR034104', NULL, 'Sm-like protein Lsm1', 'Lsm1', 3, NULL),
(2897, NULL, 'IPR002666', NULL, 'Reduced folate carrier', 'Folate_carrier', 4, NULL),
(2898, NULL, 'IPR004963', NULL, 'Pectinacetylesterase/NOTUM', 'PAE/NOTUM', 4, NULL),
(2899, NULL, 'IPR006047', NULL, 'Glycosyl hydrolase, family 13, catalytic domain', 'Glyco_hydro_13_cat_dom', 3, NULL),
(2900, NULL, 'IPR004648', NULL, 'Tetrapeptide transporter, OPT1/isp4', 'Oligpept_transpt', 4, NULL),
(2901, NULL, 'IPR002417', NULL, 'Viral spike glycoprotein', 'Spike_prot', 4, NULL),
(2902, NULL, 'IPR005621', NULL, 'Negative modulator of initiation of replication SeqA', 'SeqA', 4, NULL),
(2903, NULL, 'IPR002420', NULL, 'C2 phosphatidylinositol 3-kinase-type domain', 'PI3K-type_C2_dom', 3, NULL),
(2904, NULL, 'IPR000023', NULL, 'Phosphofructokinase domain', 'Phosphofructokinase_dom', 3, NULL),
(2905, NULL, 'IPR000114', NULL, 'Ribosomal protein L16', 'Ribosomal_L16', 4, NULL),
(2906, NULL, 'IPR005614', NULL, 'NrfD family', 'NrfD_fam', 4, NULL),
(2907, NULL, 'IPR005630', NULL, 'Terpene synthase, metal-binding domain', 'Terpene_synthase_metal-bd', 3, NULL),
(2908, NULL, 'IPR006735', NULL, 'Replication termination factor 2', 'Rtf2', 4, NULL),
(2909, NULL, 'IPR007583', NULL, 'GRASP55/65', 'GRASP55_65', 4, NULL),
(2910, NULL, 'IPR000084', NULL, 'PE-PGRS family, N-terminal', 'PE-PGRS_N', 3, NULL),
(2911, NULL, 'IPR007585', NULL, 'Poxvirus E2', 'Poxvirus_E2', 4, NULL),
(2912, NULL, 'IPR003178', NULL, 'Methyl-coenzyme M reductase, gamma subunit', 'Me_CoM_Rdtase_gsu', 4, NULL),
(2913, NULL, 'IPR004151', NULL, '7TM GPCR, serpentine receptor class e (Sre)', '7TM_GPCR_serpentine_rcpt_Sre', 4, NULL),
(2914, NULL, 'IPR006033', NULL, 'Type I L-asparaginase family', 'AsnA_fam', 4, NULL),
(2915, NULL, 'IPR005607', NULL, 'BSD domain', 'BSD_dom', 3, NULL),
(2916, NULL, 'IPR000092', NULL, 'Polyprenyl synthetase', 'Polyprenyl_synt', 4, NULL),
(2917, NULL, 'IPR002687', NULL, 'Nop domain', 'Nop_dom', 3, NULL),
(2918, NULL, 'IPR006077', NULL, 'Vinculin/alpha-catenin', 'Vinculin/catenin', 4, NULL),
(2919, NULL, 'IPR004134', NULL, 'Peptidase C1B, bleomycin hydrolase', 'Peptidase_C1B', 4, NULL),
(2920, NULL, 'IPR004172', NULL, 'L27 domain', 'L27_dom', 3, NULL),
(2921, NULL, 'IPR007589', NULL, 'Baculovirus major capsid protein VP39', 'Baculo_VP39', 4, NULL),
(2922, NULL, 'IPR004647', NULL, 'Fe-S hydro-lyase, tartrate dehydratase beta-type, catalytic domain', 'Fe-S_hydro-lyase_TtdB-typ_cat', 3, NULL),
(2923, NULL, 'IPR002675', NULL, 'Ribosomal protein L38e', 'Ribosomal_L38e', 4, NULL),
(2924, NULL, 'IPR006040', NULL, 'Allergen Ole e 1, conserved site', 'Allergen_Ole_e_I_CS', 2, NULL),
(2925, NULL, 'IPR004201', NULL, 'CDC48, domain 2', 'Cdc48_dom2', 3, NULL),
(2926, NULL, 'IPR006751', NULL, 'TAFII55 protein, conserved region', 'TAFII55_prot_cons_reg', 3, NULL),
(2927, NULL, 'IPR004652', NULL, 'tRNA-dihydrouridine synthase, TIM-barrel, NifR3', 'tRNA_dU_NifR3', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(2928, NULL, 'IPR000061', NULL, 'SWAP/Surp', 'Surp', 3, NULL),
(2929, NULL, 'IPR000012', NULL, 'Retroviral VpR/VpX protein', 'RetroV_VpR/X', 4, NULL),
(2930, NULL, 'IPR004180', NULL, 'Protein of unknown function DUF226, Borrelia species', 'DUF226_BOR_spp', 4, NULL),
(2931, NULL, 'IPR004649', NULL, 'Ribonuclease H2, subunit A', 'RNase_H2_suA', 4, NULL),
(2932, NULL, 'IPR003225', NULL, 'Viral protein of unknown function DUF325', 'DUF325', 4, NULL),
(2933, NULL, 'IPR002686', NULL, 'Transposase IS200-like', 'Transposase_17', 3, NULL),
(2934, NULL, 'IPR000085', NULL, 'Bacterial DNA recombination protein RuvA', 'RuvA', 4, NULL),
(2935, NULL, 'IPR003131', NULL, 'Potassium channel tetramerisation-type BTB domain', 'T1-type_BTB', 3, NULL),
(2936, NULL, 'IPR005608', NULL, 'Adenovirus core-capsid bridging protein V', 'Adeno_V', 4, NULL),
(2937, NULL, 'IPR004669', NULL, 'C4-dicarboxylate anaerobic carrier', 'C4_dicarb_anaerob_car', 4, NULL),
(2938, NULL, 'IPR006750', NULL, 'Putative inner membrane exporter, YdcZ', 'YdcZ', 4, NULL),
(2939, NULL, 'IPR004951', NULL, 'Protein of unknown function DUF268, Caenorhabditis species', 'DUF268_CAE_spp', 4, NULL),
(2940, NULL, 'IPR000047', NULL, 'Helix-turn-helix motif', 'HTH_motif', 2, NULL),
(2941, NULL, 'IPR006734', NULL, 'PLATZ transcription factor', 'PLATZ', 4, NULL),
(2942, NULL, 'IPR007625', NULL, 'Herpesvirus UL51', 'Herpes_UL51', 4, NULL),
(2943, NULL, 'IPR004665', NULL, 'Transcription termination factor Rho', 'Term_rho', 4, NULL),
(2944, NULL, 'IPR004130', NULL, 'GPN-loop GTPase', 'Gpn', 4, NULL),
(2945, NULL, 'IPR004160', NULL, 'Translation elongation factor EFTu/EF1A, C-terminal', 'Transl_elong_EFTu/EF1A_C', 3, NULL),
(2946, NULL, 'IPR004191', NULL, 'Integrase, Tn916-type, N-terminal DNA binding', 'Integrase_Tn916-type_DNA-bd_N', 3, NULL),
(2947, NULL, 'IPR000030', NULL, 'PPE family', 'PPE_family', 3, NULL),
(2948, NULL, 'IPR017950', NULL, 'Urease active site', 'Urease_AS', 0, NULL),
(2949, NULL, 'IPR003142', NULL, 'Biotin protein ligase, C-terminal', 'BPL_C', 3, NULL),
(2950, NULL, 'IPR007621', NULL, 'TPM domain', 'TPM_dom', 3, NULL),
(2951, NULL, 'IPR002630', NULL, 'Orbivirus non-structural protein NS1/hydrophobic tubular protein', 'Orbi_NS1', 4, NULL),
(2952, NULL, 'IPR002650', NULL, 'Sulphate adenylyltransferase', 'Sulphate_adenylyltransferase', 3, NULL),
(2953, NULL, 'IPR007595', NULL, 'Csa family', 'Csa', 4, NULL),
(2954, NULL, 'IPR003263', NULL, 'CD40 ligand', 'CD40L', 4, NULL),
(2955, NULL, 'IPR006749', NULL, 'Pox virus E6 protein', 'Pox_E6', 4, NULL),
(2956, NULL, 'IPR004954', NULL, 'Putative mucin/carbohydrate-binding domain', 'Mucin-bd', 3, NULL),
(2957, NULL, 'IPR004198', NULL, 'Zinc finger, C5HC2-type', 'Znf_C5HC2', 3, NULL),
(2958, NULL, 'IPR005646', NULL, 'Flagellar assembly protein A', 'FapA', 4, NULL),
(2959, NULL, 'IPR002641', NULL, 'Patatin-like phospholipase domain', 'PNPLA_dom', 3, NULL),
(2960, NULL, 'IPR006054', NULL, 'DNA polymerase III epsilon subunit, exonuclease domain', 'DnaQ', 3, NULL),
(2961, NULL, 'IPR003228', NULL, 'Transcription initiation factor TFIID subunit 12 domain', 'TFIID_TAF12_dom', 3, NULL),
(2962, NULL, 'IPR000076', NULL, 'K/Cl co-transporter', 'KCL_cotranspt', 4, NULL),
(2963, NULL, 'IPR006061', NULL, 'Solute-binding family 1, conserved site', 'SBP_1_CS', 2, NULL),
(2964, NULL, 'IPR002653', NULL, 'Zinc finger, A20-type', 'Znf_A20', 3, NULL),
(2965, NULL, 'IPR005625', NULL, 'PepSY-associated TM protein', 'PepSY-ass_TM', 4, NULL),
(2966, NULL, 'IPR004165', NULL, 'Coenzyme A transferase family I', 'CoA_trans_fam_I', 4, NULL),
(2967, NULL, 'IPR004667', NULL, 'ADP/ATP carrier protein, bacterial type', 'ADP_ATP_car_bac_type', 4, NULL),
(2968, NULL, 'IPR004646', NULL, 'Fe-S hydro-lyase, tartrate dehydratase alpha-type, catalytic domain', 'Fe-S_hydro-lyase_TtdA-typ_cat', 3, NULL),
(2969, NULL, 'IPR002421', NULL, '5''-3'' exonuclease', '5-3_exonuclease', 3, NULL),
(2970, NULL, 'IPR030878', NULL, 'Ribosomal protein L15', 'Ribosomal_L15', 4, NULL),
(2971, NULL, 'IPR000089', NULL, 'Biotin/lipoyl attachment', 'Biotin_lipoyl', 3, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(2972, NULL, 'IPR007618', NULL, 'Herpesvirus UL87, N-terminal', 'Herpes_UL87_N', 3, NULL),
(2973, NULL, 'IPR000026', NULL, 'Guanine-specific ribonuclease N1/T1/U2', 'Gua-sp_ribonuclease_N1/T1/U2', 4, NULL),
(2974, NULL, 'IPR000110', NULL, 'Ribosomal protein S1', 'Ribosomal_S1', 4, NULL),
(2975, NULL, 'IPR003118', NULL, 'Pointed domain', 'Pointed_dom', 3, NULL),
(2976, NULL, 'IPR002679', NULL, 'Closterovirus coat protein', 'Closter_coat', 4, NULL),
(2977, NULL, 'IPR000049', NULL, 'Electron transfer flavoprotein, beta-subunit, conserved site', 'ET-Flavoprotein_bsu_CS', 2, NULL),
(2978, NULL, 'IPR002633', NULL, 'Bacteriocin, class IIa', 'Bacteriocin_IIa', 4, NULL),
(2979, NULL, 'IPR007610', NULL, 'Broad bean mottle virus, Gp1, N-terminal', 'BBMV_Gp1_N', 3, NULL),
(2980, NULL, 'IPR002676', NULL, 'RimM, N-terminal', 'RimM_N', 3, NULL),
(2981, NULL, 'IPR006732', NULL, 'Poxvirus O1', 'Poxvirus_O1', 4, NULL),
(2982, NULL, 'IPR004156', NULL, 'Organic anion transporter polypeptide', 'OATP', 4, NULL),
(2983, NULL, 'IPR004164', NULL, 'Coenzyme A transferase active site', 'CoA_transf_AS', 0, NULL),
(2984, NULL, 'IPR005597', NULL, 'Satellite tobacco necrosis virus coat protein-like', 'Satellite_CP-like', 4, NULL),
(2985, NULL, 'IPR003222', NULL, 'Antitermination protein Q', 'Antitermntn', 4, NULL),
(2986, NULL, 'IPR004673', NULL, 'L-rhamnose-proton symport, RhaT', 'L-rhamnose-proton_sym_RhaT', 4, NULL),
(2987, NULL, 'IPR004196', NULL, 'Scaffold protein D', 'Scaffold_D', 4, NULL),
(2988, NULL, 'IPR007596', NULL, 'Viral A-type inclusion protein repeat', 'Pox_A_type_inc', 7, NULL),
(2989, NULL, 'IPR002643', NULL, 'Polyomavirus agnoprotein', 'Polyoma_agno', 4, NULL),
(2990, NULL, 'IPR000056', NULL, 'Ribulose-phosphate 3-epimerase-like', 'Ribul_P_3_epim-like', 4, NULL),
(2991, NULL, 'IPR004174', NULL, 'Head-to-tail joining protein W', 'GpW', 4, NULL),
(2992, NULL, 'IPR003116', NULL, 'Raf-like Ras-binding', 'RBD_dom', 3, NULL),
(2993, NULL, 'IPR006098', NULL, 'Methylmalonyl-CoA mutase, alpha chain, catalytic', 'MMCoA_mutase_a_cat', 3, NULL),
(2994, NULL, 'IPR002673', NULL, 'Ribosomal protein L29e', 'Ribosomal_L29e', 4, NULL),
(2995, NULL, 'IPR003256', NULL, 'Ribosomal protein L24', 'Ribosomal_L24', 4, NULL),
(2996, NULL, 'IPR000081', NULL, 'Peptidase C3, picornavirus core protein 2A', 'Peptidase_C3', 3, NULL),
(2997, NULL, 'IPR002628', NULL, 'Photosystem II PsbO, manganese-stabilising', 'PSII_MSP', 4, NULL),
(2998, NULL, 'IPR004657', NULL, '1,4-dihydroxy-2-naphthoate octaprenyltransferase', 'MenA', 4, NULL),
(2999, NULL, 'IPR006063', NULL, 'HisA, bacterial-type', 'HisA_bact_arch', 4, NULL),
(3000, NULL, 'IPR004203', NULL, 'Cytochrome c oxidase subunit IV family', 'Cyt_c_oxidase_su4_fam', 4, NULL),
(3001, NULL, 'IPR000996', NULL, 'Clathrin light chain', 'Clathrin_L-chain', 4, NULL),
(3002, NULL, 'IPR001587', NULL, 'Ribonuclease J, conserved site', 'RNase_J_CS', 2, NULL),
(3003, NULL, 'IPR001661', NULL, 'Glycoside hydrolase, family 37', 'Glyco_hydro_37', 4, NULL),
(3004, NULL, 'IPR001620', NULL, 'Dopamine D3 receptor', 'Dopamine_D3_rcpt', 4, NULL),
(3005, NULL, 'IPR001780', NULL, 'Ribosomal protein L35A', 'Ribosomal_L35A', 4, NULL),
(3006, NULL, 'IPR001000', NULL, 'Glycoside hydrolase family 10 domain', 'GH10_dom', 3, NULL),
(3007, NULL, 'IPR003855', NULL, 'Potassium transporter', 'K+_transporter', 4, NULL),
(3008, NULL, 'IPR004704', NULL, 'Phosphotransferase system, mannose/fructose/sorbose family IID component', 'PTS_IID_man', 4, NULL),
(3009, NULL, 'IPR001463', NULL, 'Sodium:alanine symporter', 'Na/Ala_symport', 4, NULL),
(3010, NULL, 'IPR004681', NULL, 'TRAP transporter large membrane protein DctM', 'TRAP_DctM', 4, NULL),
(3011, NULL, 'IPR006773', NULL, 'Proteasomal ubiquitin receptor Rpn13/ADRM1', 'Rpn13/ADRM1', 4, NULL),
(3012, NULL, 'IPR001680', NULL, 'WD40 repeat', 'WD40_repeat', 7, NULL),
(3013, NULL, 'IPR001699', NULL, 'T-box transcription factor', 'TF_T-box', 4, NULL),
(3014, NULL, 'IPR001509', NULL, 'NAD-dependent epimerase/dehydratase', 'Epimerase_deHydtase', 3, NULL),
(3015, NULL, 'IPR001690', NULL, 'Autoinducer synthase', 'Autoind_synthase', 4, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(3016, NULL, 'IPR001480', NULL, 'Bulb-type lectin domain', 'Bulb-type_lectin_dom', 3, NULL),
(3017, NULL, 'IPR003299', NULL, 'Flagellar calcium-binding protein calflagin', 'Calflagin-bd', 4, NULL),
(3018, NULL, 'IPR006763', NULL, 'Antigen 332 repeat', 'Ag332', 7, NULL),
(3019, NULL, 'IPR004688', NULL, 'Transition metal uptake transporter nickel/cobalt', 'Ni/Co_transpt', 4, NULL),
(3020, NULL, 'IPR000989', NULL, 'Replication protein', 'Rep', 4, NULL),
(3021, NULL, 'IPR001672', NULL, 'Phosphoglucose isomerase (PGI)', 'G6P_Isomerase', 4, NULL),
(3022, NULL, 'IPR007871', NULL, 'Methyltransferase TRM13', 'Methyltransferase_TRM13', 3, NULL),
(3023, NULL, 'IPR007900', NULL, 'Transcription initiation factor TFIID component TAF4, C-terminal', 'TAF4_C', 3, NULL),
(3024, NULL, 'IPR003291', NULL, 'GPCR, family 2, glucagon receptor', 'GPCR_2_glucagon_rcpt', 4, NULL),
(3025, NULL, 'IPR003295', NULL, 'Interleukin-1 alpha', 'IL-1_alpha', 4, NULL),
(3026, NULL, 'IPR001434', NULL, 'Large cysteine-rich periplasmic protein OmcB-like, DUF11 domain', 'OmcB-like_DUF11', 3, NULL),
(3027, NULL, 'IPR000938', NULL, 'CAP Gly-rich domain', 'CAP-Gly_domain', 3, NULL),
(3028, NULL, 'IPR007866', NULL, 'TRIC channel', 'TRIC_channel', 4, NULL),
(3029, NULL, 'IPR003808', NULL, 'Fe-S metabolism associated domain, SufE-like', 'Fe-S_metab-assoc_dom', 3, NULL),
(3030, NULL, 'IPR004692', NULL, 'Preprotein translocase SecG subunit', 'SecG', 4, NULL),
(3031, NULL, 'IPR006768', NULL, 'Cwf19-like, C-terminal domain-1', 'Cwf19-like_C_dom-1', 3, NULL),
(3032, NULL, 'IPR003271', NULL, 'Potassium channel, inwardly rectifying, Kir2.1', 'K_chnl_inward-rec_Kir2.1', 4, NULL),
(3033, NULL, 'IPR003859', NULL, 'Beta-1,4-galactosyltransferase', 'Galactosyl_T', 4, NULL),
(3034, NULL, 'IPR000971', NULL, 'Globin', 'Globin', 3, NULL),
(3035, NULL, 'IPR034166', NULL, 'Npl3, RNA recognition motif 1', 'Npl3_RRM1', 3, NULL),
(3036, NULL, 'IPR006774', NULL, 'BAF1 / ABF1 chromatin reorganising factor', 'BAF1_ABF1', 4, NULL),
(3037, NULL, 'IPR003275', NULL, 'Potassium channel, inwardly rectifying, Kir3.2', 'K_chnl_inward-rec_Kir3.2', 4, NULL),
(3038, NULL, 'IPR000917', NULL, 'Sulfatase, N-terminal', 'Sulfatase_N', 3, NULL),
(3039, NULL, 'IPR001766', NULL, 'Fork head domain', 'Fork_head_dom', 3, NULL),
(3040, NULL, 'IPR007915', NULL, 'Oligosaccharyltransferase complex subunit', 'TMEM258/Ost5', 4, NULL),
(3041, NULL, 'IPR001708', NULL, 'Membrane  insertase YidC/ALB3/OXA1/COX18', 'YidC/ALB3/OXA1/COX18', 4, NULL),
(3042, NULL, 'IPR003205', NULL, 'Cytochrome c oxidase, subunit 8', 'Cyt_c_oxidase_su8', 4, NULL),
(3043, NULL, 'IPR000898', NULL, 'Indoleamine 2,3-dioxygenase', 'Indolamine_dOase', 4, NULL),
(3044, NULL, 'IPR000967', NULL, 'Zinc finger, NF-X1-type', 'Znf_NFX1', 3, NULL),
(3045, NULL, 'IPR004713', NULL, 'Calcium/proton exchanger', 'CaH_exchang', 4, NULL),
(3046, NULL, 'IPR001466', NULL, 'Beta-lactamase-related', 'Beta-lactam-related', 3, NULL),
(3047, NULL, 'IPR004723', NULL, '8-amino-7-oxononanoate synthase,  Archaea/Proteobacteria type', 'AONS_Archaea/Proteobacteria', 4, NULL),
(3048, NULL, 'IPR001668', NULL, 'Plasmid recombination enzyme', 'Mob_Pre', 4, NULL),
(3049, NULL, 'IPR007882', NULL, 'Microtubule-associated protein 6', 'MAP6', 4, NULL),
(3050, NULL, 'IPR001676', NULL, 'Picornavirus capsid', 'Picornavirus_capsid', 3, NULL),
(3051, NULL, 'IPR000930', NULL, 'Peptidase S3, togavirin', 'Peptidase_S3', 3, NULL),
(3052, NULL, 'IPR001604', NULL, 'DNA/RNA non-specific endonuclease', 'DNA/RNA_non-sp_Endonuclease', 3, NULL),
(3053, NULL, 'IPR001654', NULL, 'Marek''s disease glycoprotein A', 'Marek_A', 4, NULL),
(3054, NULL, 'IPR001445', NULL, 'Acetylcholinesterase, insect', 'Acylcholinesterase_insect', 4, NULL),
(3055, NULL, 'IPR006780', NULL, 'YABBY protein', 'YABBY', 4, NULL),
(3056, NULL, 'IPR007883', NULL, 'Protein of unknown function DUF713', 'DUF713', 4, NULL),
(3057, NULL, 'IPR003197', NULL, 'Cytochrome b-c1 complex subunit 7', 'QCR7', 4, NULL),
(3058, NULL, 'IPR001705', NULL, 'Ribosomal protein L33', 'Ribosomal_L33', 4, NULL),
(3059, NULL, 'IPR001736', NULL, 'Phospholipase D/Transphosphatidylase', 'PLipase_D/transphosphatidylase', 3, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(3060, NULL, 'IPR003840', NULL, 'DNA replication helicase domain', 'DNA_helicase_dom', 3, NULL),
(3061, NULL, 'IPR003825', NULL, 'Colicin V production, CvpA', 'Colicin-V_CvpA', 4, NULL),
(3062, NULL, 'IPR003783', NULL, 'Regulatory protein RecX', 'Regulatory_RecX', 4, NULL),
(3063, NULL, 'IPR001753', NULL, 'Enoyl-CoA hydratase/isomerase', 'Enoyl-CoA_hydra/iso', 4, NULL),
(3064, NULL, 'IPR007912', NULL, 'Adenovirus E3A', 'Adeno_E3A', 4, NULL),
(3065, NULL, 'IPR007919', NULL, 'Uncharacterised protein family UPF0220', 'UPF0220', 4, NULL),
(3066, NULL, 'IPR000915', NULL, '60S ribosomal protein L6E', '60S_ribosomal_L6E', 4, NULL),
(3067, NULL, 'IPR003849', NULL, 'Preprotein translocase YajC', 'Preprotein_translocase_YajC', 4, NULL),
(3068, NULL, 'IPR003201', NULL, 'Transposase Tn5, dimerisation', 'Transposase_Tn5', 3, NULL),
(3069, NULL, 'IPR003192', NULL, 'Porin, LamB-type', 'Porin_LamB', 4, NULL),
(3070, NULL, 'IPR000969', NULL, 'FACT complex subunit SSRP1/POB3', 'SSRP1/POB3', 4, NULL),
(3071, NULL, 'IPR001615', NULL, 'Delta-endotoxin CytB', 'Endotoxin_CytB', 4, NULL),
(3072, NULL, 'IPR006776', NULL, 'Sporulation-specific cell division protein SsgB', 'SsgB', 4, NULL),
(3073, NULL, 'IPR007874', NULL, 'Septum formation inhibitor MinC, N-terminal', 'MinC_N', 3, NULL),
(3074, NULL, 'IPR007906', NULL, 'Glycosylation-dependent cell adhesion molecule 1', 'GLYCAM-1', 4, NULL),
(3075, NULL, 'IPR001730', NULL, 'Potyvirus NIa protease (NIa-pro) domain', 'Potyv_NIa-pro_dom', 3, NULL),
(3076, NULL, 'IPR004700', NULL, 'Phosphotransferase system, mannose/fructose/sorbose family, IIC subunit', 'PTS_IIC_man', 4, NULL),
(3077, NULL, 'IPR007868', NULL, 'Hom-end-associated Hint', 'Hom_end_hint', 3, NULL),
(3078, NULL, 'IPR003301', NULL, 'Vaccinia virus D10, decapping enzyme', 'Vaccinia_D10_decapping', 4, NULL),
(3079, NULL, 'IPR001544', NULL, 'Aminotransferase class IV', 'Aminotrans_IV', 4, NULL),
(3080, NULL, 'IPR007864', NULL, 'Urease accessory protein UreE, C-terminal domain', 'UreE_C_dom', 3, NULL),
(3081, NULL, 'IPR003846', NULL, 'Protein adenylyltransferase SelO', 'SelO', 4, NULL),
(3082, NULL, 'IPR007898', NULL, 'RNA polymerase I-specific transcription initiation factor Rrn10, Saccharomycetes', 'Rrn10_Saccharomycetes', 4, NULL),
(3083, NULL, 'IPR007863', NULL, 'Peptidase M16, C-terminal', 'Peptidase_M16_C', 3, NULL),
(3084, NULL, 'IPR001796', NULL, 'Dihydrofolate reductase domain', 'DHFR_dom', 3, NULL),
(3085, NULL, 'IPR004701', NULL, 'Phosphotransferase system, mannose-type IIA component', 'PTS_EIIA_man-typ', 3, NULL),
(3086, NULL, 'IPR003194', NULL, 'Transcription initiation factor IIA, gamma subunit', 'TFIIA_gsu', 4, NULL),
(3087, NULL, 'IPR007893', NULL, 'Spore coat protein U', 'Spore_coat_U', 3, NULL),
(3088, NULL, 'IPR001764', NULL, 'Glycoside hydrolase, family 3, N-terminal', 'Glyco_hydro_3_N', 3, NULL),
(3089, NULL, 'IPR003185', NULL, 'Proteasome activator PA28, N-terminal domain', 'Proteasome_activ_PA28_N', 3, NULL),
(3090, NULL, 'IPR001663', NULL, 'Aromatic-ring-hydroxylating dioxygenase, alpha subunit', 'Rng_hydr_dOase-A', 4, NULL),
(3091, NULL, 'IPR007896', NULL, 'Chlorhexidine efflux transporter', 'BTP_bacteria', 3, NULL),
(3092, NULL, 'IPR001761', NULL, 'Periplasmic binding protein/LacI sugar binding domain', 'Peripla_BP/Lac1_sug-bd_dom', 3, NULL),
(3093, NULL, 'IPR000974', NULL, 'Glycoside hydrolase, family 22, lysozyme', 'Glyco_hydro_22_lys', 4, NULL),
(3094, NULL, 'IPR001624', NULL, 'Flagellar hook-basal body complex protein FliE', 'FliE', 4, NULL),
(3095, NULL, 'IPR001636', NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', 'SAICAR_synth', 4, NULL),
(3096, NULL, 'IPR001497', NULL, 'Methylated-DNA-[protein]-cysteine S-methyltransferase, active site', 'MethylDNA_cys_MeTrfase_AS', 0, NULL),
(3097, NULL, 'IPR000982', NULL, 'Viral matrix protein', 'Matrix', 4, NULL),
(3098, NULL, 'IPR003837', NULL, 'Glu-tRNAGln amidotransferase C subunit', 'Asp/Glu-ADT_csu', 4, NULL),
(3099, NULL, 'IPR007910', NULL, 'Protein of unknown function DUF735', 'DUF735', 4, NULL),
(3100, NULL, 'IPR001674', NULL, 'GMP synthase, C-terminal', 'GMP_synth_C', 3, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(3101, NULL, 'IPR001580', NULL, 'Calreticulin/calnexin', 'Calret/calnex', 4, NULL),
(3102, NULL, 'IPR004718', NULL, 'Phosphotransferase system, mannitol-specific enzyme IIC', 'PTS_IIC_mtl', 3, NULL),
(3103, NULL, 'IPR001571', NULL, 'GPCR, family 2, vasoactive intestinal peptide receptor', 'GPCR_2_VIP_rcpt', 4, NULL),
(3104, NULL, 'IPR034282', NULL, 'Copper resistance protein CopA, second cupredoxin domain', 'CuRO_2_CopA', 3, NULL),
(3105, NULL, 'IPR001447', NULL, 'Arylamine N-acetyltransferase', 'Arylamine_N-AcTrfase', 4, NULL),
(3106, NULL, 'IPR000949', NULL, 'ELM2 domain', 'ELM2_dom', 3, NULL),
(3107, NULL, 'IPR004722', NULL, 'Dihydroorotase', 'DHOase', 4, NULL),
(3108, NULL, 'IPR001505', NULL, 'Copper centre Cu(A)', 'Copper_CuA', 1, NULL),
(3109, NULL, 'IPR003815', NULL, 'S-ribosylhomocysteinase (LuxS)', 'S-ribosylhomocysteinase', 4, NULL),
(3110, NULL, 'IPR001673', NULL, 'Dictyostelium (slime mold) repeat', 'S_mold_repeat', 7, NULL),
(3111, NULL, 'IPR003272', NULL, 'Potassium channel, inwardly rectifying, Kir2.2', 'K_chnl_inward-rec_Kir2.2', 4, NULL),
(3112, NULL, 'IPR004705', NULL, 'Cation/H+ exchanger, CPA1 family, bacteria', 'Cation/H_exchanger_CPA1_bac', 4, NULL),
(3113, NULL, 'IPR004719', NULL, 'Phosphotransferase system, maltose/glucose-specific subfamily IIC component', 'PTS_maltose/Glc_sub_IIC', 3, NULL),
(3114, NULL, 'IPR001670', NULL, 'Alcohol dehydrogenase, iron-type/glycerol dehydrogenase GldA', 'ADH_Fe/GldA', 3, NULL),
(3115, NULL, 'IPR001626', NULL, 'ABC transporter, TroCD-like', 'ABC_TroCD', 4, NULL),
(3116, NULL, 'IPR000979', NULL, 'Phosphodiesterase MJ0936/Vps29', 'Phosphodiesterase_MJ0936/Vps29', 4, NULL),
(3117, NULL, 'IPR003796', NULL, 'Ribonucleotide reductase regulator NrdR-like', 'RNR_NrdR-like', 4, NULL),
(3118, NULL, 'IPR001762', NULL, 'Disintegrin domain', 'Disintegrin_dom', 3, NULL),
(3119, NULL, 'IPR001478', NULL, 'PDZ domain', 'PDZ', 3, NULL),
(3120, NULL, 'IPR034544', NULL, 'Heterogeneous nuclear ribonucleoprotein Q, RNA recognition motif 1', 'hnRNPQ_RRM1', 3, NULL),
(3121, NULL, 'IPR007858', NULL, 'Dpy-30 motif', 'Dpy-30_motif', 2, NULL),
(3122, NULL, 'IPR001574', NULL, 'Ribosome-inactivating protein', 'Ribosome_inactivat_prot', 4, NULL),
(3123, NULL, 'IPR001779', NULL, 'Two pore domain potassium channel, TWIK-1', '2pore_dom_K_chnl_TWIK1', 4, NULL),
(3124, NULL, 'IPR002114', NULL, 'Phosphotransferase system, HPr serine phosphorylation site', 'PTS_HPr_Ser_P_site', 6, NULL),
(3125, NULL, 'IPR001645', NULL, 'Folylpolyglutamate synthetase', 'Folylpolyglutamate_synth', 4, NULL),
(3126, NULL, 'IPR006757', NULL, 'Opioid growth factor receptor (OGFr) conserved domain', 'OGF_rcpt', 3, NULL),
(3127, NULL, 'IPR006786', NULL, 'Pinin/SDK/MemA protein', 'Pinin_SDK_MemA', 3, NULL),
(3128, NULL, 'IPR004690', NULL, 'Malonate transporter MadL subunit', 'Maln_transptMadL', 4, NULL),
(3129, NULL, 'IPR000932', NULL, 'Photosystem antenna protein-like', 'PS_antenna-like', 4, NULL),
(3130, NULL, 'IPR001704', NULL, 'Prepro-orexin', 'Orexin', 4, NULL),
(3131, NULL, 'IPR001677', NULL, 'Transferrin-binding protein B, C-lobe/N-lobe beta barrel domain', 'TbpB_B_D', 3, NULL),
(3132, NULL, 'IPR004708', NULL, 'Aspartate ammonia-lyase', 'ApsA', 4, NULL),
(3133, NULL, 'IPR003802', NULL, 'Sporulation regulator WhiA', 'Sporulation_regulator_WhiA', 4, NULL),
(3134, NULL, 'IPR004695', NULL, 'Transporter protein SLAC1/Mae1/ Ssu1/TehA', 'SLAC1/Mae1/Ssu1/TehA', 4, NULL),
(3135, NULL, 'IPR001401', NULL, 'Dynamin, GTPase domain', 'Dynamin_GTPase', 3, NULL),
(3136, NULL, 'IPR001531', NULL, 'Zinc-dependent phospholipase C', 'Zn_PLipaseC', 3, NULL),
(3137, NULL, 'IPR001767', NULL, 'Hedgehog protein, Hint domain', 'Hedgehog_Hint', 3, NULL),
(3138, NULL, 'IPR007927', NULL, 'Protein of unknown function DUF722', 'DUF722', 4, NULL),
(3139, NULL, 'IPR001799', NULL, 'Ephrin receptor-binding domain', 'Ephrin_RBD', 3, NULL),
(3140, NULL, 'IPR000998', NULL, 'MAM domain', 'MAM_dom', 3, NULL),
(3141, NULL, 'IPR004679', NULL, '2-hydroxycarboxylate transporter', '2-OHcarboxylate_transport', 4, NULL),
(3142, NULL, 'IPR003821', NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', 'DXP_reductoisomerase', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(3143, NULL, 'IPR007920', NULL, 'Protein of unknown function UPF0223', 'UPF0223', 4, NULL),
(3144, NULL, 'IPR000860', NULL, 'Porphobilinogen deaminase', 'HemC', 4, NULL),
(3145, NULL, 'IPR001545', NULL, 'Gonadotropin, beta subunit', 'Gonadotropin_bsu', 4, NULL),
(3146, NULL, 'IPR001665', NULL, 'Norovirus peptidase C37', 'Norovirus_pept_C37', 3, NULL),
(3147, NULL, 'IPR000895', NULL, 'Transthyretin/hydroxyisourate hydrolase', 'Transthyretin/HIU_hydrolase', 4, NULL),
(3148, NULL, 'IPR007876', NULL, 'Neuraminyllactose-binding hemagglutinin', 'NeuraminylLac-bd_hemagglutn', 4, NULL),
(3149, NULL, 'IPR001681', NULL, 'Neurokinin receptor', 'Neurokn_rcpt', 4, NULL),
(3150, NULL, 'IPR000976', NULL, 'Wilm''s tumour protein, N-terminal', 'Wilms_tumour_N', 3, NULL),
(3151, NULL, 'IPR006761', NULL, 'Twisted gastrulation (Tsg) protein', 'Tsg', 4, NULL),
(3152, NULL, 'IPR003838', NULL, 'ABC3 transporter permease protein domain', 'ABC3_permease_dom', 3, NULL),
(3153, NULL, 'IPR001743', NULL, 'Photosystem II PsbT', 'PSII_PsbT', 4, NULL),
(3154, NULL, 'IPR004721', NULL, 'Dihydroorotase homodimeric type', 'DHOdimr', 4, NULL),
(3155, NULL, 'IPR003785', NULL, 'Creatininase/formamide hydrolase', 'Creatininase/forma_Hydrolase', 4, NULL),
(3156, NULL, 'IPR003793', NULL, 'UPF0166', 'UPF0166', 4, NULL),
(3157, NULL, 'IPR003804', NULL, 'L-lactate permease', 'Lactate_perm', 4, NULL),
(3158, NULL, 'IPR007875', NULL, 'Sprouty', 'Sprouty', 4, NULL),
(3159, NULL, 'IPR000968', NULL, 'Influenza nuclear export protein NS2', 'Flu_NS2', 4, NULL),
(3160, NULL, 'IPR003835', NULL, 'Glycosyl transferase, family 19', 'Glyco_trans_19', 4, NULL),
(3161, NULL, 'IPR006777', NULL, 'Minor spike protein', 'Microvir_H', 4, NULL),
(3162, NULL, 'IPR004683', NULL, 'Type III secretion system substrate exporter FlhB-like', 'T3SS_FlhB-rel', 4, NULL),
(3163, NULL, 'IPR001724', NULL, 'Glycosyl hydrolase 58', 'Glycl_Hydrolase_58', 4, NULL),
(3164, NULL, 'IPR001439', NULL, 'Hyaluronidase PH20/Hyaluronidase-5', 'Hyaluronidase_PH20/Hyal5', 4, NULL),
(3165, NULL, 'IPR007867', NULL, 'Glucose-methanol-choline oxidoreductase, C-terminal', 'GMC_OxRtase_C', 3, NULL),
(3166, NULL, 'IPR006772', NULL, 'Herpesvirus BTRF1 protein', 'Herpes_BTRF1', 4, NULL),
(3167, NULL, 'IPR004686', NULL, 'Tricarboxylate/iron carrier', 'Mtc', 4, NULL),
(3168, NULL, 'IPR006779', NULL, 'DNA binding protein S1FA', 'S1FA_DNA-bd', 4, NULL),
(3169, NULL, 'IPR006787', NULL, 'Pinin/SDK', 'Pinin_SDK_N', 3, NULL),
(3170, NULL, 'IPR003857', NULL, 'Major outer sheath protein, N-terminal', 'MOSP_N', 3, NULL),
(3171, NULL, 'IPR003823', NULL, 'CP12 domain', 'CP12_dom', 3, NULL),
(3172, NULL, 'IPR034167', NULL, 'Nab3, RNA recognition motif', 'Nab3_RRM', 3, NULL),
(3173, NULL, 'IPR001721', NULL, 'Threonine dehydratase, ACT-like domain', 'TD_ACT-like', 3, NULL),
(3174, NULL, 'IPR007887', NULL, 'NTF2-like N-terminal transpeptidase', 'MecA_N', 3, NULL),
(3175, NULL, 'IPR001775', NULL, 'GspD/PilQ family', 'GspD/PilQ', 4, NULL),
(3176, NULL, 'IPR001448', NULL, 'Small acid-soluble spore protein, alpha/beta-type', 'SASP_alpha/beta-type', 4, NULL),
(3177, NULL, 'IPR001698', NULL, 'F-actin-capping protein subunit beta', 'CAPZB', 4, NULL),
(3178, NULL, 'IPR001567', NULL, 'Peptidase M3A/M3B catalytic domain', 'Pept_M3A_M3B_dom', 3, NULL),
(3179, NULL, 'IPR003297', NULL, 'Interleukin-1 receptor antagonist/Interleukin-36', 'IL-1RA/IL-36', 4, NULL),
(3180, NULL, 'IPR001471', NULL, 'AP2/ERF domain', 'AP2/ERF_dom', 3, NULL),
(3181, NULL, 'IPR001802', NULL, 'Mercuric transport protein periplasmic component/copper chaperone CopZ', 'MerP/CopZ', 4, NULL),
(3182, NULL, 'IPR003829', NULL, 'Pirin, N-terminal domain', 'Pirin_N_dom', 3, NULL),
(3183, NULL, 'IPR003805', NULL, 'Adenosylcobinamide-GDP ribazoletransferase', 'CobS', 4, NULL),
(3184, NULL, 'IPR004703', NULL, 'Phosphotransferase system, sugar-specific permease component', 'PTS_sugar-sp_permease', 4, NULL),
(3185, NULL, 'IPR001602', NULL, 'Uncharacterised protein family UPF0047, YjbQ', 'UPF0047_YjbQ', 4, NULL),
(3186, NULL, 'IPR001638', NULL, 'Solute-binding protein  family 3/N-terminal domain of MltF', 'Solute-binding_3/MltF_N', 3, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(3187, NULL, 'IPR006783', NULL, 'Transposase, ISC1217', 'Transposase_ISC1217', 4, NULL),
(3188, NULL, 'IPR000900', NULL, 'Nebulin repeat', 'Nebulin_repeat', 7, NULL),
(3189, NULL, 'IPR000973', NULL, 'T-cell surface antigen CD4', 'CD4', 4, NULL),
(3190, NULL, 'IPR001589', NULL, 'Actinin-type actin-binding domain, conserved site', 'Actinin_actin-bd_CS', 2, NULL),
(3191, NULL, 'IPR001555', NULL, 'Phosphoribosylglycinamide formyltransferase, active site', 'GART_AS', 0, NULL),
(3192, NULL, 'IPR004685', NULL, 'Branched-chain amino acid transport system II carrier protein', 'Brnchd-chn_aa_trnsp_Livcs', 4, NULL),
(3193, NULL, 'IPR000990', NULL, 'Innexin', 'Innexin', 4, NULL),
(3194, NULL, 'IPR007895', NULL, 'MASE1', 'MASE1', 3, NULL),
(3195, NULL, 'IPR003826', NULL, 'S-adenosylmethionine decarboxylase family, prokaryotic', 'AdoMetDC_fam_prok', 4, NULL),
(3196, NULL, 'IPR003834', NULL, 'Cytochrome C biogenesis protein, transmembrane domain', 'Cyt_c_assmbl_TM_dom', 3, NULL),
(3197, NULL, 'IPR003782', NULL, 'Copper chaperone SCO1/SenC', 'SCO1/SenC', 4, NULL),
(3198, NULL, 'IPR003847', NULL, 'Putative antitoxin', 'Put_antitoxin', 4, NULL),
(3199, NULL, 'IPR007861', NULL, 'DNA mismatch repair protein MutS, clamp', 'DNA_mismatch_repair_MutS_clamp', 3, NULL),
(3200, NULL, 'IPR000933', NULL, 'Glycoside hydrolase, family 29', 'Glyco_hydro_29', 4, NULL),
(3201, NULL, 'IPR003814', NULL, 'Formylmethanofuran dehydrogenase, subunit E domain', 'FmdEsu_dom', 3, NULL),
(3202, NULL, 'IPR001689', NULL, 'Flagellar motor switch protein FliM', 'Flag_FliM', 4, NULL),
(3203, NULL, 'IPR003303', NULL, 'Filaggrin', 'Filaggrin', 4, NULL),
(3204, NULL, 'IPR015793', NULL, 'Pyruvate kinase, barrel', 'Pyrv_Knase_brl', 3, NULL),
(3205, NULL, 'IPR003841', NULL, 'Sodium-dependent phosphate transport protein', 'Na/Pi_transpt', 4, NULL),
(3206, NULL, 'IPR006233', NULL, 'Cystathionine beta-lyase, bacterial', 'Cys_b_lyase_bac', 4, NULL),
(3207, NULL, 'IPR001656', NULL, 'Pseudouridine synthase, TruD', 'PsdUridine_synth_TruD', 4, NULL),
(3208, NULL, 'IPR003819', NULL, 'TauD/TfdA-like domain', 'TauD/TfdA-like', 3, NULL),
(3209, NULL, 'IPR004715', NULL, 'Phosphotransferase system, IIA component fructose subfamily', 'PTS_IIA_fruc', 3, NULL),
(3210, NULL, 'IPR003831', NULL, 'Protein of unknown function DUF211', 'DUF211', 4, NULL),
(3211, NULL, 'IPR007857', NULL, 'Protein arginine N-methyltransferase PRMT5', 'Arg_MeTrfase_PRMT5', 4, NULL),
(3212, NULL, 'IPR003188', NULL, 'Phosphotransferase system, lactose/cellobiose-type IIA subunit', 'PTS_IIA_lac/cel', 4, NULL),
(3213, NULL, 'IPR003274', NULL, 'Potassium channel, inwardly rectifying, Kir3.1', 'K_chnl_inward-rec_Kir3.1', 4, NULL),
(3214, NULL, 'IPR000931', NULL, 'Adenovirus fibre protein', 'Adeno_fibre', 4, NULL),
(3215, NULL, 'IPR001443', NULL, 'Staphylocoagulase repeat', 'Staphylcoagulase_rpt', 7, NULL),
(3216, NULL, 'IPR007892', NULL, 'CHASE4', 'CHASE4', 3, NULL),
(3217, NULL, 'IPR001455', NULL, 'TusA-like domain', 'TusA-like', 3, NULL),
(3218, NULL, 'IPR001474', NULL, 'GTP cyclohydrolase I', 'GTP_CycHdrlase_I', 4, NULL),
(3219, NULL, 'IPR004697', NULL, 'p-Aminobenzoyl-glutamate transport protein AbgT', 'AbgT', 4, NULL),
(3220, NULL, 'IPR000992', NULL, 'Stress-induced protein SRP1/TIP1', 'SRP1_TIP1', 4, NULL),
(3221, NULL, 'IPR007856', NULL, 'Saposin-like type B, region 1', 'SapB_1', 3, NULL),
(3222, NULL, 'IPR003786', NULL, 'Sulfur carrier protein FdhD', 'FdhD', 4, NULL),
(3223, NULL, 'IPR007918', NULL, 'Mitochondrial distribution/morphology family 35/apoptosis', 'MDM35_apoptosis', 4, NULL),
(3224, NULL, 'IPR003861', NULL, 'E4 protein', 'Papilloma_E4', 4, NULL),
(3225, NULL, 'IPR000948', NULL, 'Ribosomal protein L7Ae, prokaryotes', 'Ribosomal_L7Ae_prok', 4, NULL),
(3226, NULL, 'IPR004698', NULL, 'Zinc/iron permease, fungal/plant', 'Zn/Fe_permease_fun/pln', 4, NULL),
(3227, NULL, 'IPR001683', NULL, 'Phox homology', 'PX_dom', 3, NULL),
(3228, NULL, 'IPR007877', NULL, 'Protein of unknown function DUF707', 'DUF707', 4, NULL),
(3229, NULL, 'IPR006760', NULL, 'Endosulphine', 'Endosulphine', 4, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(3230, NULL, 'IPR001752', NULL, 'Kinesin motor domain', 'Kinesin_motor_dom', 3, NULL),
(3231, NULL, 'IPR003300', NULL, 'Viral protein D9', 'Viral_VD9', 4, NULL),
(3232, NULL, 'IPR001640', NULL, 'Phosphatidylglycerol--prolipoprotein diacylglyceryl transferase Lgt', 'Lgt', 4, NULL),
(3233, NULL, 'IPR000985', NULL, 'Legume lectin, alpha chain, conserved site', 'Lectin_LegA_CS', 2, NULL),
(3234, NULL, 'IPR003822', NULL, 'Paired amphipathic helix', 'PAH', 7, NULL),
(3235, NULL, 'IPR004678', NULL, 'Cytochrome c oxidase cbb3-type, subunit III', 'Cyt_c_oxidase_cbb3_su3', 4, NULL),
(3236, NULL, 'IPR001684', NULL, 'Ribosomal protein L27', 'Ribosomal_L27', 4, NULL),
(3237, NULL, 'IPR003780', NULL, 'COX15/CtaA family', 'COX15/CtaA_fam', 4, NULL),
(3238, NULL, 'IPR003813', NULL, 'F420-non-reducing hydrogenase iron-sulfur subunit D', 'MvhD/FlpD', 3, NULL),
(3239, NULL, 'IPR001424', NULL, 'Superoxide dismutase, copper/zinc binding domain', 'SOD_Cu_Zn_dom', 3, NULL),
(3240, NULL, 'IPR003298', NULL, 'Apical membrane antigen 1', 'Apmem_Ag1', 4, NULL),
(3241, NULL, 'IPR003856', NULL, 'Polysaccharide chain length determinant N-terminal domain', 'LPS_length_determ_N_term', 3, NULL),
(3242, NULL, 'IPR003273', NULL, 'Potassium channel, inwardly rectifying, Kir2.3', 'K_chnl_inward-rec_Kir2.3', 4, NULL),
(3243, NULL, 'IPR003787', NULL, 'Sulphur relay, DsrE/F-like', 'Sulphur_relay_DsrE/F-like', 4, NULL),
(3244, NULL, 'IPR001718', NULL, 'CC chemokine receptor 7', 'Chemokine_CCR7', 4, NULL),
(3245, NULL, 'IPR001002', NULL, 'Chitin-binding, type 1', 'Chitin-bd_1', 3, NULL),
(3246, NULL, 'IPR001510', NULL, 'Zinc finger, PARP-type', 'Znf_PARP', 3, NULL),
(3247, NULL, 'IPR007897', NULL, 'PHB accumulation regulatory', 'PHB_accumulat', 3, NULL),
(3248, NULL, 'IPR001710', NULL, 'Pro-adrenomedullin', 'Pro-ADM', 4, NULL),
(3249, NULL, 'IPR007890', NULL, 'CHASE2', 'CHASE2', 3, NULL),
(3250, NULL, 'IPR000945', NULL, 'Dopamine beta-hydroxylase-like', 'DBH-like', 4, NULL),
(3251, NULL, 'IPR007921', NULL, 'CHAP domain', 'CHAP_dom', 3, NULL),
(3252, NULL, 'IPR001570', NULL, 'Peptidase M4, C-terminal', 'Peptidase_M4_C_domain', 3, NULL),
(3253, NULL, 'IPR001630', NULL, 'cAMP response element binding (CREB) protein', 'Leuzip_CREB', 4, NULL),
(3254, NULL, 'IPR006764', NULL, 'S-adenosyl-L-methionine dependent methyltransferase, SAV2177 type', 'SAM_dep_MeTrfase_SAV2177_type', 4, NULL),
(3255, NULL, 'IPR007878', NULL, 'Coronavirus NS2A', 'Coronavirus_NS2A', 4, NULL),
(3256, NULL, 'IPR001635', NULL, 'Flagellar hook-length control protein FliK', 'Flag_hook_Flik', 4, NULL),
(3257, NULL, 'IPR006790', NULL, 'Baculovirus Gp41, glycoprotein', 'Baculovirus_Gp41', 4, NULL),
(3258, NULL, 'IPR001468', NULL, 'Indole-3-glycerol phosphate synthase, conserved site', 'Indole-3-GlycerolPSynthase_CS', 2, NULL),
(3259, NULL, 'IPR000923', NULL, 'Blue (type 1) copper domain', 'BlueCu_1', 3, NULL),
(3260, NULL, 'IPR003820', NULL, 'Potassium-transporting ATPase C chain', 'KdpC', 4, NULL),
(3261, NULL, 'IPR004677', NULL, 'Cytochrome c oxidase cbb3-type, subunit I', 'Cyt_c_oxidase_cbb3_su1', 4, NULL),
(3262, NULL, 'IPR001740', NULL, 'GPCR family 2, EMR1-like receptor', 'GPCR_2_EMR1-like_rcpt', 4, NULL),
(3263, NULL, 'IPR000941', NULL, 'Enolase', 'Enolase', 4, NULL),
(3264, NULL, 'IPR007926', NULL, 'Borrelia P83100', 'Borrelia_P83', 4, NULL),
(3265, NULL, 'IPR001609', NULL, 'Myosin head, motor domain', 'Myosin_head_motor_dom', 3, NULL),
(3266, NULL, 'IPR000928', NULL, 'SNAP-25 domain', 'SNAP-25_dom', 3, NULL),
(3267, NULL, 'IPR000975', NULL, 'Interleukin-1 family', 'IL-1_fam', 4, NULL),
(3268, NULL, 'IPR000980', NULL, 'SH2 domain', 'SH2', 3, NULL),
(3269, NULL, 'IPR003285', NULL, 'Eukaryotic peptide chain release factor GTP-binding subunit', 'Sup35', 4, NULL),
(3270, NULL, 'IPR007865', NULL, 'Aminopeptidase P, N-terminal', 'Aminopep_P_N', 3, NULL),
(3271, NULL, 'IPR007873', NULL, 'Glycosyltransferase, ALG3', 'Glycosyltransferase_ALG3', 4, NULL),
(3272, NULL, 'IPR006785', NULL, 'Peroxisome membrane anchor protein Pex14p, N-terminal', 'Pex14_N', 3, NULL),
(3273, NULL, 'IPR001628', NULL, 'Zinc finger, nuclear hormone receptor-type', 'Znf_hrmn_rcpt', 3, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(3274, NULL, 'IPR001789', NULL, 'Signal transduction response regulator, receiver domain', 'Sig_transdc_resp-reg_receiver', 3, NULL),
(3275, NULL, 'IPR001731', NULL, 'Delta-aminolevulinic acid dehydratase', 'ALAD', 4, NULL),
(3276, NULL, 'IPR003807', NULL, 'Domain of unknown function DUF202', 'DUF202', 3, NULL),
(3277, NULL, 'IPR000906', NULL, 'ZU5 domain', 'ZU5_dom', 3, NULL),
(3278, NULL, 'IPR003282', NULL, 'Type III secretion system lipoprotein HrcJ/YscJ', 'T3SS_HrcJ/YscJ', 4, NULL),
(3279, NULL, 'IPR000919', NULL, 'Neutrophil cytosol factor P40', 'p40phox', 4, NULL),
(3280, NULL, 'IPR007886', NULL, 'Alanine dehydrogenase/pyridine nucleotide transhydrogenase, N-terminal', 'AlaDH/PNT_N', 3, NULL),
(3281, NULL, 'IPR003289', NULL, 'GPCR, family 2, calcitonin gene-related peptide, type 1 receptor', 'GPCR_2_CGRP1_rcpt', 4, NULL),
(3282, NULL, 'IPR001650', NULL, 'Helicase, C-terminal', 'Helicase_C', 3, NULL),
(3283, NULL, 'IPR003287', NULL, 'GPCR, family 2, calcitonin receptor family', 'GCPR_2_calcitonin_rcpt_fam', 4, NULL),
(3284, NULL, 'IPR006758', NULL, 'Poxvirus A32', 'A32L', 4, NULL),
(3285, NULL, 'IPR004694', NULL, 'Hydroxy amino acid transporter', 'Hydroxy_aa_transpt', 4, NULL),
(3286, NULL, 'IPR007869', NULL, 'Homing endonuclease PI-Sce', 'Homing_endonuc_PI-Sce', 3, NULL),
(3287, NULL, 'IPR001707', NULL, 'Chloramphenicol acetyltransferase', 'Cmp_AcTrfase', 4, NULL),
(3288, NULL, 'IPR006770', NULL, 'Opioid growth factor receptor repeat', 'OGF_rcpt_rpt', 7, NULL),
(3289, NULL, 'IPR003163', NULL, 'Transcription regulator HTH, APSES-type DNA-binding domain', 'Tscrpt_reg_HTH_APSES-type', 3, NULL),
(3290, NULL, 'IPR007894', NULL, 'MASE2', 'MASE2', 3, NULL),
(3291, NULL, 'IPR003203', NULL, 'Cobinamide kinase/cobinamide phosphate guanyltransferase', 'Cobinamide_kinase/P_G-Trfase', 4, NULL),
(3292, NULL, 'IPR007862', NULL, 'Adenylate kinase, active site lid domain', 'Adenylate_kinase_lid-dom', 3, NULL),
(3293, NULL, 'IPR004709', NULL, 'Na+/H+ exchanger', 'NaH_exchanger', 4, NULL),
(3294, NULL, 'IPR003848', NULL, 'Domain of unknown function DUF218', 'DUF218', 3, NULL),
(3295, NULL, 'IPR001694', NULL, 'NADH:ubiquinone oxidoreductase, subunit 1/F420H2 oxidoreductase subunit H', 'NADH_UbQ_OxRdtase_su1/FPO', 4, NULL),
(3296, NULL, 'IPR001529', NULL, 'DNA-directed RNA polymerase, M/15kDa subunit', 'DNA-dir_RNA_pol_M/15kDasu', 3, NULL),
(3297, NULL, 'IPR001678', NULL, 'SAM-dependent methyltransferase RsmB/NOP2-type', 'MeTrfase_RsmB/NOP2', 3, NULL),
(3298, NULL, 'IPR007922', NULL, 'Protein of unknown function DUF721/UPF0232', 'DUF721/UPF0232', 4, NULL),
(3299, NULL, 'IPR004707', NULL, 'Membrane transport protein MmpL family', 'MmpL_fam', 4, NULL),
(3300, NULL, 'IPR001706', NULL, 'Ribosomal protein L35, non-mitochondrial', 'Ribosomal_L35_non-mt', 4, NULL),
(3301, NULL, 'IPR004680', NULL, 'Citrate transporter-like domain', 'Cit_transptr-like_dom', 3, NULL),
(3302, NULL, 'IPR006765', NULL, 'Polyketide synthesis cyclase', 'Polyketide_synth_cyclase', 4, NULL),
(3303, NULL, 'IPR001757', NULL, 'P-type ATPase', 'P_typ_ATPase', 4, NULL),
(3304, NULL, 'IPR003851', NULL, 'Zinc finger, Dof-type', 'Znf_Dof', 3, NULL),
(3305, NULL, 'IPR006767', NULL, 'Cwf19-like protein, C-terminal domain-2', 'Cwf19-like_C_dom-2', 3, NULL),
(3306, NULL, 'IPR001496', NULL, 'SOCS box domain', 'SOCS_box', 3, NULL),
(3307, NULL, 'IPR007914', NULL, 'Uncharacterised protein family UPF0193', 'UPF0193', 4, NULL),
(3308, NULL, 'IPR001750', NULL, 'NADH:quinone oxidoreductase/Mrp antiporter, membrane subunit', 'ND/Mrp_mem', 3, NULL),
(3309, NULL, 'IPR001457', NULL, 'NADH:ubiquinone/plastoquinone oxidoreductase, chain 6', 'NADH_UbQ/plastoQ_OxRdtase_su6', 4, NULL),
(3310, NULL, 'IPR000994', NULL, 'Peptidase M24', 'Pept_M24', 3, NULL),
(3311, NULL, 'IPR006789', NULL, 'Actin-related protein 2/3 complex subunit 5', 'ARPC5', 4, NULL),
(3312, NULL, 'IPR003284', NULL, 'Salmonella virulence plasmid 65kDa B protein', 'Sal_SpvB', 4, NULL),
(3313, NULL, 'IPR001441', NULL, 'Decaprenyl diphosphate synthase-like', 'UPP_synth-like', 4, NULL),
(3314, NULL, 'IPR003277', NULL, 'Potassium channel, inwardly rectifying, Kir3.4', 'K_chnl_inward-rec_Kir3.4', 4, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(3315, NULL, 'IPR004706', NULL, 'Arsenical-resistance protein Acr3', 'Arsenical-R_Acr3', 4, NULL),
(3316, NULL, 'IPR003288', NULL, 'GPCR, family 2, growth hormone-releasing hormone receptor', 'GPCR_2_GHRH_rcpt', 4, NULL),
(3317, NULL, 'IPR001504', NULL, 'Bradykinin receptor B2', 'Brdyknn_2_rcpt', 4, NULL),
(3318, NULL, 'IPR003207', NULL, 'Propanediol/glycerol dehydratase, small subunit', 'Ppandiol/glycerol_DeHydtase_su', 4, NULL),
(3319, NULL, 'IPR001765', NULL, 'Carbonic anhydrase', 'Carbonic_anhydrase', 4, NULL),
(3320, NULL, 'IPR006781', NULL, 'Apolipoprotein C-I', 'ApoC-I', 4, NULL),
(3321, NULL, 'IPR001727', NULL, 'Gdt1 family', 'Gdt1', 4, NULL),
(3322, NULL, 'IPR001791', NULL, 'Laminin G domain', 'Laminin_G', 3, NULL),
(3323, NULL, 'IPR000858', NULL, 'S-locus glycoprotein domain', 'S_locus_glycoprot_dom', 3, NULL),
(3324, NULL, 'IPR001409', NULL, 'Glucocorticoid receptor', 'Glcrtcd_rcpt', 4, NULL),
(3325, NULL, 'IPR006766', NULL, 'Protein EXORDIUM-like', 'EXORDIUM-like', 4, NULL),
(3326, NULL, 'IPR001772', NULL, 'Kinase associated domain 1 (KA1)', 'KA1_dom', 3, NULL),
(3327, NULL, 'IPR001751', NULL, 'S100/Calcium binding protein 7/8-like, conserved site', 'S100/CaBP7/8-like_CS', 2, NULL),
(3328, NULL, 'IPR006792', NULL, 'Vicilin, N-terminal', 'Vicilin_N', 3, NULL),
(3329, NULL, 'IPR004720', NULL, 'Phosphotransferase system, sorbose subfamily IIB component', 'PTS_IIB_sorbose-sp', 3, NULL),
(3330, NULL, 'IPR003265', NULL, 'HhH-GPD domain', 'HhH-GPD_domain', 3, NULL),
(3331, NULL, 'IPR003276', NULL, 'Potassium channel, inwardly rectifying, Kir3.3', 'K_chnl_inward-rec_Kir3.3', 4, NULL),
(3332, NULL, 'IPR001737', NULL, 'Ribosomal RNA adenine methyltransferase KsgA/Erm', 'KsgA/Erm', 4, NULL),
(3333, NULL, 'IPR001675', NULL, 'Glycosyl transferase family 29', 'Glyco_trans_29', 4, NULL),
(3334, NULL, 'IPR007905', NULL, 'Emopamil-binding protein', 'EBP', 4, NULL),
(3335, NULL, 'IPR003196', NULL, 'Transcription initiation factor IIF, beta subunit', 'TFIIF_beta', 4, NULL),
(3336, NULL, 'IPR003842', NULL, 'Vacuolating cytotoxin', 'Vacuolating_cytotoxin', 4, NULL),
(3337, NULL, 'IPR003290', NULL, 'GPCR, family 2, glucagon-like peptide-1/glucagon receptor', 'GPCR_2_GLP1/glucagon_rcpt', 4, NULL),
(3338, NULL, 'IPR001759', NULL, 'Pentraxin-related', 'Pentraxin-related', 4, NULL),
(3339, NULL, 'IPR000859', NULL, 'CUB domain', 'CUB_dom', 3, NULL),
(3340, NULL, 'IPR000953', NULL, 'Chromo/chromo shadow domain', 'Chromo/chromo_shadow_dom', 3, NULL),
(3341, NULL, 'IPR007923', NULL, 'Herpesvirus glycoprotein L, N-terminal', 'Herpes_gL_N', 3, NULL),
(3342, NULL, 'IPR006788', NULL, 'Rab effector MyRIP/Melanophilin', 'Myrip/Melanophilin', 3, NULL),
(3343, NULL, 'IPR006793', NULL, 'FaeA-like protein', 'FaeA', 4, NULL),
(3344, NULL, 'IPR001437', NULL, 'Transcription elongation factor, GreA/GreB, C-terminal', 'Tscrpt_elong_fac_GreA/B_C', 3, NULL),
(3345, NULL, 'IPR000997', NULL, 'Cholinesterase', 'Cholinesterase', 4, NULL),
(3346, NULL, 'IPR007881', NULL, 'UNC-50', 'UNC-50', 4, NULL),
(3347, NULL, 'IPR001726', NULL, 'DNA nucleotidylexotransferase (TdT) / DNA-directed DNA/RNA polymerase mu', 'TdT/Mu', 4, NULL),
(3348, NULL, 'IPR004702', NULL, 'Phosphotransferease, sorbitol phosphotransferase enzyme II', 'PTS_sorb_EIIBC', 4, NULL),
(3349, NULL, 'IPR003149', NULL, 'Iron hydrogenase, small subunit', 'Fe_hydrogenase_ssu', 3, NULL),
(3350, NULL, 'IPR000863', NULL, 'Sulfotransferase domain', 'Sulfotransferase_dom', 3, NULL),
(3351, NULL, 'IPR000903', NULL, 'Glycylpeptide N-tetradecanoyltransferase', 'NMT', 4, NULL),
(3352, NULL, 'IPR001739', NULL, 'Methyl-CpG DNA binding', 'Methyl_CpG_DNA-bd', 3, NULL),
(3353, NULL, 'IPR003781', NULL, 'CoA-binding', 'CoA-bd', 3, NULL),
(3354, NULL, 'IPR004714', NULL, 'Cytochrome oxidase maturation protein cbb3-type', 'Cyt_oxidase_maturation_cbb3', 4, NULL),
(3355, NULL, 'IPR001548', NULL, 'Peptidase M2, peptidyl-dipeptidase A', 'Peptidase_M2', 4, NULL),
(3356, NULL, 'IPR003158', NULL, 'Photosynthetic reaction centre, cytochrome c subunit', 'Photosyn_RC_cyt_c-su', 4, NULL),
(3357, NULL, 'IPR001733', NULL, 'Peptidase S26B', 'Peptidase_S26B', 4, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(3358, NULL, 'IPR001004', NULL, 'Alpha 1A adrenoceptor', 'ADRA1A_rcpt', 4, NULL),
(3359, NULL, 'IPR003280', NULL, 'Two pore domain potassium channel', '2pore_dom_K_chnl', 4, NULL),
(3360, NULL, 'IPR003844', NULL, 'Uncharacterised protein family UPF0060', 'UPF0060', 4, NULL),
(3361, NULL, 'IPR001637', NULL, 'Glutamine synthetase class-I, adenylation site', 'Gln_synth_I_adenylation_site', 2, NULL),
(3362, NULL, 'IPR000894', NULL, 'Ribulose bisphosphate carboxylase small subunit, domain', 'RuBisCO_ssu_dom', 3, NULL),
(3363, NULL, 'IPR003830', NULL, '(2R)-phospho-3-sulpholactate synthase, ComA', 'ComA_synth', 4, NULL),
(3364, NULL, 'IPR001422', NULL, 'Neuromodulin (GAP-43)', 'Neuromodulin', 4, NULL),
(3365, NULL, 'IPR001686', NULL, 'Peptidase A22A, presenilin, nematode type', 'Pept_A22A_Ceel', 4, NULL),
(3366, NULL, 'IPR003816', NULL, 'Nitrate reductase, gamma subunit', 'Nitrate_red_gam', 4, NULL),
(3367, NULL, 'IPR001494', NULL, 'Importin-beta, N-terminal domain', 'Importin-beta_N', 3, NULL),
(3368, NULL, 'IPR001717', NULL, 'Anion exchange protein', 'Anion_exchange', 4, NULL),
(3369, NULL, 'IPR004687', NULL, 'Lysosomal-associated transmembrane protein 4/5', 'LAPTM4/5', 4, NULL),
(3370, NULL, 'IPR006759', NULL, 'Glycosyl transferase family 54', 'Glyco_transf_54', 4, NULL),
(3371, NULL, 'IPR007908', NULL, 'Outer membrane protein 2, Brucella', 'OMP2_Brucella', 4, NULL),
(3372, NULL, 'IPR007928', NULL, 'Choristoneura fumiferana antifreeze', 'Antifreeze_CF', 4, NULL),
(3373, NULL, 'IPR000896', NULL, 'Hemocyanin/hexamerin middle domain', 'Hemocyanin/hexamerin_mid_dom', 3, NULL),
(3374, NULL, 'IPR001514', NULL, 'DNA-directed RNA polymerase, 30-40kDa subunit, conserved site', 'DNA-dir_RNA_pol_30-40kDasu_CS', 2, NULL),
(3375, NULL, 'IPR001482', NULL, 'Type II/IV secretion system protein', 'T2SS/T4SS', 3, NULL),
(3376, NULL, 'IPR003854', NULL, 'Gibberellin regulated protein', 'GASA', 4, NULL),
(3377, NULL, 'IPR000908', NULL, 'Acetylcholinesterase, fish/snake', 'Acylcholinesterase_fish/snake', 4, NULL),
(3378, NULL, 'IPR003864', NULL, 'CSC1/OSCA1-like, 7TM region', 'CSC1/OSCA1-like_7TM', 3, NULL),
(3379, NULL, 'IPR006784', NULL, 'Coronavirus Orf3', 'Coronavirus_Orf3', 4, NULL),
(3380, NULL, 'IPR003283', NULL, 'Type III secretion system outer membrane, SpaO', 'T3SS_OMP_SpaO', 4, NULL),
(3381, NULL, 'IPR006775', NULL, 'Glycosyl-hydrolase family 116, catalytic region', 'GH116_catalytic', 3, NULL),
(3382, NULL, 'IPR001558', NULL, 'HIV negative factor Nef', 'HIV_Nef', 4, NULL),
(3383, NULL, 'IPR001701', NULL, 'Glycoside hydrolase family 9', 'Glyco_hydro_9', 4, NULL),
(3384, NULL, 'IPR003860', NULL, 'Haemagglutinin-esterase glycoprotein, haemagglutinin domain', 'Hemagglutn-estrase_hemagglutn', 3, NULL),
(3385, NULL, 'IPR001407', NULL, 'Influenza RNA-dependent RNA polymerase subunit PB1', 'RNA_pol_PB1_influenza', 4, NULL),
(3386, NULL, 'IPR001735', NULL, 'Opsin RH1/RH2', 'Opsin_RH1/RH2', 4, NULL),
(3387, NULL, 'IPR007899', NULL, 'CHAD domain', 'CHAD_dom', 3, NULL),
(3388, NULL, 'IPR003836', NULL, 'Glucokinase', 'Glucokinase', 4, NULL),
(3389, NULL, 'IPR001516', NULL, 'NADH-Ubiquinone oxidoreductase (complex I), chain 5 N-terminal', 'Proton_antipo_N', 3, NULL),
(3390, NULL, 'IPR001679', NULL, 'NAD-dependent DNA ligase', 'DNAligase', 4, NULL),
(3391, NULL, 'IPR024620', NULL, 'Domain of unknown function DUF3869', 'DUF3869', 3, NULL),
(3392, NULL, 'IPR003850', NULL, 'Phosphoribosylformylglycinamidine synthase subunit PurS', 'PurS', 4, NULL),
(3393, NULL, 'IPR001728', NULL, 'Thyroid hormone receptor', 'ThyrH_rcpt', 4, NULL),
(3394, NULL, 'IPR003292', NULL, 'GPCR, family 2, glucagon-like peptide-1 receptor', 'GPCR_2_GLP1_rcpt', 4, NULL),
(3395, NULL, 'IPR001432', NULL, 'Muscarinic acetylcholine receptor M4', 'Musac_Ach_M4_rcpt', 4, NULL),
(3396, NULL, 'IPR001427', NULL, 'Pancreatic ribonuclease', 'RNaseA', 4, NULL),
(3397, NULL, 'IPR003852', NULL, 'Signal transduction histidine kinase, osmosensitive K+ channel sensor, N-terminal', 'Sig_transdc_His_kinase_KdpD_N', 3, NULL),
(3398, NULL, 'IPR001470', NULL, 'Bacteriochlorophyll c-binding protein', 'Bchl_c-bd', 4, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(3399, NULL, 'IPR001715', NULL, 'Calponin homology domain', 'CH-domain', 3, NULL),
(3400, NULL, 'IPR007885', NULL, 'MgpC adhesin', 'MgpC', 4, NULL),
(3401, NULL, 'IPR000904', NULL, 'Sec7 domain', 'Sec7_dom', 3, NULL),
(3402, NULL, 'IPR001722', NULL, 'Glycoside hydrolase, family 7', 'Glyco_hydro_7', 4, NULL),
(3403, NULL, 'IPR001535', NULL, 'Arenavirus glycoprotein', 'Arena_glycoprot', 4, NULL),
(3404, NULL, 'IPR001713', NULL, 'Proteinase inhibitor I25A, stefin', 'Prot_inh_stefin', 4, NULL),
(3405, NULL, 'IPR007880', NULL, 'Spiralin', 'Spiralin', 4, NULL),
(3406, NULL, 'IPR006769', NULL, 'Calcium uniporter protein, C-terminal', 'MCU_C', 3, NULL),
(3407, NULL, 'IPR003279', NULL, 'Potassium channel, inwardly rectifying, Kir6.2', 'K_chnl_inward-rec_Kir6.2', 4, NULL),
(3408, NULL, 'IPR000940', NULL, 'Methyltransferase, NNMT/PNMT/TEMT', 'NNMT_TEMT_trans', 4, NULL),
(3409, NULL, 'IPR007891', NULL, 'CHASE3', 'CHASE3', 3, NULL),
(3410, NULL, 'IPR001693', NULL, 'Calcitonin peptide-like', 'Calcitonin_peptide-like', 3, NULL),
(3411, NULL, 'IPR003810', NULL, 'Putative manganese efflux pump', 'Mntp/YtaF', 4, NULL),
(3412, NULL, 'IPR001405', NULL, 'Uncharacterised protein family UPF0758', 'UPF0758', 4, NULL),
(3413, NULL, 'IPR001754', NULL, 'Orotidine 5''-phosphate decarboxylase domain', 'OMPdeCOase_dom', 3, NULL),
(3414, NULL, 'IPR001695', NULL, 'Lysyl oxidase', 'Lysyl_oxidase', 4, NULL),
(3415, NULL, 'IPR001658', NULL, 'Gonadotrophin-releasing hormone receptor family', 'GphnRH_fam_rcpt', 4, NULL),
(3416, NULL, 'IPR004693', NULL, 'Silicon transporter', 'Silicon_transpt', 4, NULL),
(3417, NULL, 'IPR000913', NULL, 'Neurokinin NK2 receptor', 'NK2_rcpt', 4, NULL),
(3418, NULL, 'IPR007902', NULL, 'Centromere protein Chl4/mis15/CENP-N', 'Chl4/mis15/CENP-N', 4, NULL),
(3419, NULL, 'IPR004696', NULL, 'Triose phosphate/phosphoenolpyruvate translocator', 'Tpt_PEP_transl', 4, NULL),
(3420, NULL, 'IPR003269', NULL, 'Potassium channel, inwardly rectifying, Kir1.2', 'K_chnl_inward-rec_Kir1.2', 4, NULL),
(3421, NULL, 'IPR004676', NULL, 'Cadmium resistance transporter', 'Cd-R_transporter', 4, NULL),
(3422, NULL, 'IPR001712', NULL, 'Type III secretion system FHIPEP', 'T3SS_FHIPEP', 4, NULL),
(3423, NULL, 'IPR007889', NULL, 'DNA binding HTH domain, Psq-type', 'HTH_Psq', 3, NULL),
(3424, NULL, 'IPR001729', NULL, 'Pulmonary surfactant-associated protein C', 'SP-C', 4, NULL),
(3425, NULL, 'IPR003798', NULL, 'DNA recombination RmuC', 'DNA_recombination_RmuC', 4, NULL),
(3426, NULL, 'IPR003839', NULL, '7TM GPCR, serpentine receptor class u (Sru)', '7TM_GPCR_serpentine_rcpt_Sru', 4, NULL),
(3427, NULL, 'IPR001564', NULL, 'Nucleoside diphosphate kinase', 'Nucleoside_diP_kinase', 4, NULL),
(3428, NULL, 'IPR007879', NULL, 'FAD-linked sulfhydryl oxidase', 'Baculo_p33', 4, NULL),
(3429, NULL, 'IPR004711', NULL, 'Benzoate transporter', 'Benzoate_Transporter', 4, NULL),
(3430, NULL, 'IPR006771', NULL, 'Blastomyces yeast-phase-specific protein', 'Bys1', 4, NULL),
(3431, NULL, 'IPR003824', NULL, 'Undecaprenyl-diphosphatase UppP', 'UppP', 4, NULL),
(3432, NULL, 'IPR001518', NULL, 'Argininosuccinate synthase', 'Arginosuc_synth', 4, NULL),
(3433, NULL, 'IPR007872', NULL, 'DPH-type metal-binding  domain', 'DPH_MB_dom', 3, NULL),
(3434, NULL, 'IPR001398', NULL, 'Macrophage migration inhibitory factor', 'Macrophage_inhib_fac', 4, NULL),
(3435, NULL, 'IPR003187', NULL, 'Phospholipase A1', 'PLipase_A1', 4, NULL),
(3436, NULL, 'IPR006762', NULL, 'Gtr1/RagA G protein', 'Gtr1_RagA', 4, NULL),
(3437, NULL, 'IPR001742', NULL, 'Outer capsid protein VP2, Orbivirus', 'Capsid_VP2_Orbivir', 4, NULL),
(3438, NULL, 'IPR001711', NULL, 'Phospholipase C, phosphatidylinositol-specific, Y domain', 'PLipase_C_Pinositol-sp_Y', 3, NULL),
(3439, NULL, 'IPR000032', NULL, 'Phosphocarrier protein HPr-like', 'HPr-like', 3, NULL),
(3440, NULL, 'IPR001769', NULL, 'Gingipain', 'Gingipain', 3, NULL),
(3441, NULL, 'IPR001607', NULL, 'Zinc finger, UBP-type', 'Znf_UBP', 3, NULL),
(3442, NULL, 'IPR004684', NULL, '2-keto-3-deoxygluconate permease', '2keto-3dGluconate_permease', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(3443, NULL, 'IPR001578', NULL, 'Peptidase C12, ubiquitin carboxyl-terminal hydrolase', 'Peptidase_C12_UCH', 3, NULL),
(3444, NULL, 'IPR006795', NULL, 'Thiostrepton-resistance methylase, N-terminal', 'Thiostrepton-R_Mease_TSNR_N', 3, NULL),
(3445, NULL, 'IPR000956', NULL, 'Stathmin family', 'Stathmin_fam', 4, NULL),
(3446, NULL, 'IPR000961', NULL, 'AGC-kinase, C-terminal', 'AGC-kinase_C', 3, NULL),
(3447, NULL, 'IPR001696', NULL, 'Voltage gated sodium channel, alpha subunit', 'Na_channel_asu', 4, NULL),
(3448, NULL, 'IPR001763', NULL, 'Rhodanese-like domain', 'Rhodanese-like_dom', 3, NULL),
(3449, NULL, 'IPR000943', NULL, 'RNA polymerase sigma-70', 'RNA_pol_sigma70', 3, NULL),
(3450, NULL, 'IPR001500', NULL, 'Alpha-1-acid glycoprotein', 'A1A_glycop', 4, NULL),
(3451, NULL, 'IPR001697', NULL, 'Pyruvate kinase', 'Pyr_Knase', 4, NULL),
(3452, NULL, 'IPR003812', NULL, 'Fido domain', 'Fido', 3, NULL),
(3453, NULL, 'IPR003801', NULL, 'GTP cyclohydrolase FolE2/MptA', 'GTP_cyclohydrolase_FolE2/MptA', 4, NULL),
(3454, NULL, 'IPR034548', NULL, 'Heterogeneous nuclear ribonucleoprotein Q, RNA recognition motif 2', 'hnRNPQ_RRM2', 3, NULL),
(3455, NULL, 'IPR006782', NULL, 'Platelet-derived growth factor, N-terminal', 'PDGF_N', 3, NULL),
(3456, NULL, 'IPR001774', NULL, 'Delta/Serrate/lag-2 (DSL) protein', 'DSL', 3, NULL),
(3457, NULL, 'IPR001782', NULL, 'Flagellar P-ring protein', 'Flag_FlgI', 4, NULL),
(3458, NULL, 'IPR001594', NULL, 'Palmitoyltransferase, DHHC domain', 'Palmitoyltrfase_DHHC', 3, NULL),
(3459, NULL, 'IPR003210', NULL, 'Signal recognition particle, SRP14 subunit', 'Signal_recog_particle_SRP14', 4, NULL),
(3460, NULL, 'IPR000925', NULL, 'Major surface glycoprotein G', 'G_prot', 4, NULL),
(3461, NULL, 'IPR004710', NULL, 'Bile acid:sodium symporter', 'Bilac:Na_transpt', 4, NULL),
(3462, NULL, 'IPR001402', NULL, 'Prolactin-releasing peptide receptor', 'Prolrel_pep_rcpt', 4, NULL),
(3463, NULL, 'IPR001714', NULL, 'Peptidase M24, methionine aminopeptidase', 'Pept_M24_MAP', 4, NULL),
(3464, NULL, 'IPR007860', NULL, 'DNA mismatch repair protein MutS, connector domain', 'DNA_mmatch_repair_MutS_con_dom', 3, NULL),
(3465, NULL, 'IPR001613', NULL, 'Flavin amine oxidase', 'Flavin_amine_oxidase', 4, NULL),
(3466, NULL, 'IPR004699', NULL, 'Phosphotransferase system, enzyme II sorbitol-specific factor', 'PTS_IID_sorb', 4, NULL),
(3467, NULL, 'IPR034168', NULL, 'Peptidyl-prolyl cis-trans isomerase E, RNA recognition motif', 'PPIE_RRM', 3, NULL),
(3468, NULL, 'IPR000936', NULL, 'Alphavirus E2 glycoprotein', 'Alpha_E2_glycop', 4, NULL),
(3469, NULL, 'IPR001688', NULL, 'GPCR, family 2, calcitonin receptor', 'GPCR_2_calcitonin_rcpt', 4, NULL),
(3470, NULL, 'IPR004691', NULL, 'Malonate/sodium symporter MadM subunit', 'Mal/Na_symporter_MadM', 4, NULL),
(3471, NULL, 'IPR000984', NULL, 'G protein-coupled receptor 3', 'GPR3', 4, NULL),
(3472, NULL, 'IPR000921', NULL, 'Histamine H1 receptor', 'Histamine_H1_rcpt', 4, NULL),
(3473, NULL, 'IPR003293', NULL, 'Nudix hydrolase 6-like', 'Nudix_hydrolase6-like', 4, NULL),
(3474, NULL, 'IPR001521', NULL, 'Opsin, blue sensitive', 'Opsin_blue', 4, NULL),
(3475, NULL, 'IPR001460', NULL, 'Penicillin-binding protein, transpeptidase', 'PCN-bd_Tpept', 3, NULL),
(3476, NULL, 'IPR001647', NULL, 'DNA-binding HTH domain, TetR-type', 'HTH_TetR', 3, NULL),
(3477, NULL, 'IPR003153', NULL, 'Adaptor protein Cbl, N-terminal helical', 'Adaptor_Cbl_N_hlx', 3, NULL),
(3478, NULL, 'IPR006791', NULL, 'Pox virus D2 protein', 'Pox_D2', 4, NULL),
(3479, NULL, 'IPR007884', NULL, 'Protein-L-histidine N-pros-methyltransferase', 'METL9', 4, NULL),
(3480, NULL, 'IPR001591', NULL, 'Influenza RNA-dependent RNA polymerase subunit PB2', 'INV_PB2', 4, NULL),
(3481, NULL, 'IPR003863', NULL, 'Domain of unknown function DUF220', 'DUF220', 3, NULL),
(3482, NULL, 'IPR003270', NULL, 'Potassium channel, inwardly rectifying, Kir1.3', 'K_chnl_inward-rec_Kir1.3', 4, NULL),
(3483, NULL, 'IPR003817', NULL, 'Phosphatidylserine decarboxylase-related', 'PS_Dcarbxylase', 4, NULL),
(3484, NULL, 'IPR001709', NULL, 'Flavoprotein pyridine nucleotide cytochrome reductase', 'Flavoprot_Pyr_Nucl_cyt_Rdtase', 3, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(3485, NULL, 'IPR001732', NULL, 'UDP-glucose/GDP-mannose dehydrogenase, N-terminal', 'UDP-Glc/GDP-Man_DH_N', 3, NULL),
(3486, NULL, 'IPR001585', NULL, 'Transaldolase/Fructose-6-phosphate aldolase', 'TAL/FSA', 4, NULL),
(3487, NULL, 'IPR003784', NULL, 'BioY protein', 'BioY', 4, NULL),
(3488, NULL, 'IPR007925', NULL, 'Relaxosome protein TraM', 'TRelaxosome_TraM', 4, NULL),
(3489, NULL, 'IPR004682', NULL, 'TRAP transporter solute receptor, DctP family', 'TRAP_DctP', 4, NULL),
(3490, NULL, 'IPR006794', NULL, 'Transcriptional activator, Zfx / Zfy domain', 'Transcrp_activ_Zfx/Zfy-dom', 3, NULL),
(3491, NULL, 'IPR001738', NULL, 'Rab protein geranylgeranyltransferase component A', 'Rab_escort', 4, NULL),
(3492, NULL, 'IPR001671', NULL, 'Melanocortin/ACTH receptor', 'Melcrt_ACTH_rcpt', 4, NULL),
(3493, NULL, 'IPR004716', NULL, 'Phosphotransferase system, glucitol/sorbitol-specific IIA component', 'PTS_IIA_glucitol/sorbitol-sp', 4, NULL),
(3494, NULL, 'IPR000926', NULL, 'GTP cyclohydrolase II, RibA', 'RibA', 4, NULL),
(3495, NULL, 'IPR001702', NULL, 'Porin, Gram-negative type', 'Porin_Gram-ve', 4, NULL),
(3496, NULL, 'IPR003778', NULL, 'Carboxyltransferase domain, subdomain A and B', 'CT_A_B', 3, NULL),
(3497, NULL, 'IPR000972', NULL, 'Octamer-binding transcription factor', 'TF_octamer', 4, NULL),
(3498, NULL, 'IPR001692', NULL, 'Histidinol dehydrogenase, conserved site', 'Histidinol_DH_CS', 2, NULL),
(3499, NULL, 'IPR001719', NULL, 'AP endonuclease 2', 'AP_endonuc_2', 4, NULL),
(3500, NULL, 'IPR001760', NULL, 'Opsin', 'Opsin', 4, NULL),
(3501, NULL, 'IPR000174', NULL, 'CXC chemokine receptor 1/2', 'Chemokine_CXCR_1/2', 4, NULL),
(3502, NULL, 'IPR007546', NULL, 'Protein of unknown function DUF503', 'DUF503', 4, NULL),
(3503, NULL, 'IPR001644', NULL, 'C3a anaphylatoxin chemotactic receptor', 'Anaphtx_C3AR1', 4, NULL),
(3504, NULL, 'IPR000722', NULL, 'RNA polymerase, alpha subunit', 'RNA_pol_asu', 3, NULL),
(3505, NULL, 'IPR005659', NULL, 'Chemoreceptor glutamine deamidase CheD', 'Chemorcpt_Glu_NH3ase_CheD', 4, NULL),
(3506, NULL, 'IPR006288', NULL, 'Transcription factor S', 'TFS', 4, NULL),
(3507, NULL, 'IPR000223', NULL, 'Peptidase S26A, signal peptidase I', 'Pept_S26A_signal_pept_1', 4, NULL),
(3508, NULL, 'IPR000640', NULL, 'Elongation factor EFG, domain V-like', 'EFG_V-like', 3, NULL),
(3509, NULL, 'IPR005704', NULL, 'Ribosomal protein S3, bacterial-type', 'Ribosomal_S3_bac-typ', 4, NULL),
(3510, NULL, 'IPR000701', NULL, 'Succinate dehydrogenase/fumarate reductase type B, transmembrane subunit', 'SuccDH_FuR_B_TM-su', 4, NULL),
(3511, NULL, 'IPR024635', NULL, 'Gonadotropin hormone receptor, transmembrane domain', 'GnHR_TM', 3, NULL),
(3512, NULL, 'IPR004232', NULL, 'Nitrile hydratase alpha /Thiocyanate hydrolase gamma', 'CN_Hdrtase_a/SCN_Hdrlase_g', 3, NULL),
(3513, NULL, 'IPR006834', NULL, 'VITF-3 subunit protein', 'Pox_A8', 4, NULL),
(3514, NULL, 'IPR000221', NULL, 'Protamine P1', 'Protamine_P1', 4, NULL),
(3515, NULL, 'IPR005703', NULL, 'Ribosomal protein S3, eukaryotic/archaeal', 'Ribosomal_S3_euk/arc', 4, NULL),
(3516, NULL, 'IPR007553', NULL, '2-thiouracil desulfurase', '2-thiour_desulf', 4, NULL),
(3517, NULL, 'IPR004255', NULL, 'O-acyltransferase, WSD1-like, N-terminal', 'O-acyltransferase_WSD1_N', 3, NULL),
(3518, NULL, 'IPR002715', NULL, 'Nascent polypeptide-associated complex NAC domain', 'Nas_poly-pep-assoc_cplx_dom', 3, NULL),
(3519, NULL, 'IPR006797', NULL, 'PRELI/MSF1 domain', 'PRELI/MSF1_dom', 3, NULL),
(3520, NULL, 'IPR007401', NULL, 'Protein of unknown function DUF454', 'DUF454', 4, NULL),
(3521, NULL, 'IPR006849', NULL, 'Elongator complex protein 1', 'Elp1', 4, NULL),
(3522, NULL, 'IPR006843', NULL, 'Plastid lipid-associated protein/fibrillin conserved domain', 'PAP/fibrillin_dom', 3, NULL),
(3523, NULL, 'IPR005673', NULL, 'Phosphate ABC transporter, substrate-binding protein PstS', 'ABC_phos-bd_PstS', 4, NULL),
(3524, NULL, 'IPR004727', NULL, 'Calcium-activated chloride channel protein, chordata', 'CLCA_chordata', 4, NULL),
(3525, NULL, 'IPR000742', NULL, 'EGF-like domain', 'EGF-like_dom', 3, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(3526, NULL, 'IPR004730', NULL, 'Transaldolase type 1', 'Transaldolase_1', 4, NULL),
(3527, NULL, 'IPR005702', NULL, 'Exopolysaccharide synthesis protein', 'EPS_synthesis', 3, NULL),
(3528, NULL, 'IPR006845', NULL, 'Pex, N-terminal', 'Pex_N', 3, NULL),
(3529, NULL, 'IPR006278', NULL, 'Sarcosine oxidase subunit beta', 'SoxB', 4, NULL),
(3530, NULL, 'IPR004236', NULL, 'Peptidase S1A, alpha-lytic prodomain', 'Pept_S1_alpha_lytic', 3, NULL),
(3531, NULL, 'IPR002753', NULL, 'Uncharacterised protein family UPF0058', 'UPF0058', 4, NULL),
(3532, NULL, 'IPR004206', NULL, 'mRNA triphosphatase Cet1-like', 'mRNA_triPase_Cet1', 3, NULL),
(3533, NULL, 'IPR000109', NULL, 'Proton-dependent oligopeptide transporter family', 'POT_fam', 4, NULL),
(3534, NULL, 'IPR006800', NULL, 'Pellino family', 'Pellino_fam', 4, NULL),
(3535, NULL, 'IPR004724', NULL, 'Epithelial sodium channel, chordates', 'ENaC_chordates', 4, NULL),
(3536, NULL, 'IPR000165', NULL, 'Glucoamylase', 'Glucoamylase', 4, NULL),
(3537, NULL, 'IPR003313', NULL, 'AraC-type arabinose-binding/dimerisation domain', 'AraC-bd', 3, NULL),
(3538, NULL, 'IPR002702', NULL, 'Translation repressor RegA', 'Transl_repress_RegA', 4, NULL),
(3539, NULL, 'IPR004215', NULL, 'Prokaryotic glutathione synthetase, N-terminal', 'GSHS_N', 3, NULL),
(3540, NULL, 'IPR004222', NULL, 'Methane monooxygenase, gamma chain', 'Me_mOase_g', 4, NULL),
(3541, NULL, 'IPR002726', NULL, 'CDP-archaeol synthase, archaea', 'CarS_archaea', 4, NULL),
(3542, NULL, 'IPR000779', NULL, 'Interleukin-2', 'IL-2', 4, NULL),
(3543, NULL, 'IPR000199', NULL, 'Peptidase C3A/C3B, picornaviral', 'Peptidase_C3A/C3B_picornavir', 3, NULL),
(3544, NULL, 'IPR007422', NULL, 'Cysteine protease Prp', 'Peptidase_Prp', 4, NULL),
(3545, NULL, 'IPR006284', NULL, 'Glutathione synthetase, prokaryotic', 'Glut_synth_pro', 4, NULL),
(3546, NULL, 'IPR005706', NULL, 'Ribosomal protein S2, bacteria/mitochondria/plastid', 'Ribosomal_S2_bac/mit/plastid', 4, NULL),
(3547, NULL, 'IPR005678', NULL, 'Mitochondrial inner membrane translocase complex, subunit Tim17', 'Tim17', 4, NULL),
(3548, NULL, 'IPR000035', NULL, 'Alkylbase DNA glycosidase, conserved site', 'Alkylbase_DNA_glycsylse_CS', 2, NULL),
(3549, NULL, 'IPR005679', NULL, 'Ribosomal protein S12, bacterial-type', 'Ribosomal_S12_bac', 4, NULL),
(3550, NULL, 'IPR006273', NULL, 'Orotate phosphoribosyltransferase, bacterial', 'Orotate_PRibTrfase_bac', 4, NULL),
(3551, NULL, 'IPR006274', NULL, 'Carbamoyl-phosphate synthase, small subunit', 'CarbamoylP_synth_ssu', 4, NULL),
(3552, NULL, 'IPR024621', NULL, 'Inner membrane mitoribosome receptor Mba1, mitochondrial', 'Mba1', 4, NULL),
(3553, NULL, 'IPR004248', NULL, 'Borrelia plasmid, OrfD', 'Borrelia_plasmid_OrfD', 4, NULL),
(3554, NULL, 'IPR002730', NULL, 'Ribonuclease P protein subunit Rpp29/RNP1', 'Rpp29/RNP1', 4, NULL),
(3555, NULL, 'IPR034572', NULL, 'Protein MULTIPLE CHLOROPLAST DIVISION SITE 1', 'MCD1', 4, NULL),
(3556, NULL, 'IPR007551', NULL, 'Protein of unknown function DUF520', 'DUF520', 4, NULL),
(3557, NULL, 'IPR006847', NULL, 'Translation initiation factor IF-2, N-terminal', 'IF2_N', 3, NULL),
(3558, NULL, 'IPR004269', NULL, 'Folate receptor', 'Folate_rcpt', 4, NULL),
(3559, NULL, 'IPR000691', NULL, 'Proteinase inhibitor I16, Streptomyces subtilisin-type inhibitor', 'Prot_inh_I16_SSI', 4, NULL),
(3560, NULL, 'IPR000128', NULL, 'Progesterone receptor', 'Progest_rcpt', 4, NULL),
(3561, NULL, 'IPR007547', NULL, 'Uncharacterised protein family UPF0248', 'UPF0248', 4, NULL),
(3562, NULL, 'IPR005688', NULL, 'Chloroplast protein import component Toc34', 'Toc34', 4, NULL),
(3563, NULL, 'IPR000764', NULL, 'Uridine kinase-like', 'Uridine_kinase-like', 4, NULL),
(3564, NULL, 'IPR006838', NULL, 'FAR-17a/AIG1-like protein', 'Far-17a_AIG1', 4, NULL),
(3565, NULL, 'IPR007431', NULL, 'Acyl carrier protein phosphodiesterase', 'ACP_PD', 4, NULL),
(3566, NULL, 'IPR005716', NULL, 'Ribosomal protein S5/S7, eukaryotic/archaeal', 'Ribosomal_S5/S7_euk/arc', 4, NULL),
(3567, NULL, 'IPR024634', NULL, 'Internalin,  N-terminal', 'Internalin_N', 3, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(3568, NULL, 'IPR006248', NULL, 'Aconitase, mitochondrial-like', 'Aconitase_mito-like', 4, NULL),
(3569, NULL, 'IPR000100', NULL, 'Ribonuclease P', 'RNase_P', 4, NULL),
(3570, NULL, 'IPR007423', NULL, 'Selenoprotein, putative', 'Sel_put', 4, NULL),
(3571, NULL, 'IPR004731', NULL, 'Transaldolase type 3B/Fructose-6-phosphate aldolase', 'Transaldolase_3B/F6P_aldolase', 4, NULL),
(3572, NULL, 'IPR000678', NULL, 'Nuclear transition protein 2', 'TP2', 4, NULL),
(3573, NULL, 'IPR000053', NULL, 'Thymidine/pyrimidine-nucleoside phosphorylase', 'Thymidine/pyrmidine_PPase', 4, NULL),
(3574, NULL, 'IPR006861', NULL, 'Hyaluronan/mRNA-binding protein', 'HABP4_PAIRBP1-bd', 3, NULL),
(3575, NULL, 'IPR001641', NULL, 'Spumavirus aspartic protease A9', 'Spumavirus_A9', 3, NULL),
(3576, NULL, 'IPR002747', NULL, 'S-adenosyl-l-methionine hydroxide adenosyltransferase', 'SAM_OH_AdoTrfase', 4, NULL),
(3577, NULL, 'IPR006238', NULL, 'Cystathionine beta-lyase, eukaryotic', 'Cys_b_lyase_euk', 4, NULL),
(3578, NULL, 'IPR034558', NULL, 'p54nrb, RNA recognition motif 2', 'p54nrb_RRM2', 3, NULL),
(3579, NULL, 'IPR004231', NULL, 'Carboxypeptidase A inhibitor-like', 'COpept_A_inh-like', 3, NULL),
(3580, NULL, 'IPR005662', NULL, 'GTP-binding protein Era', 'GTP-bd_Era', 4, NULL),
(3581, NULL, 'IPR007392', NULL, 'D-galactarate/Altronate dehydratase, C-terminal', 'Gal/Altron_deHydtase_C', 3, NULL),
(3582, NULL, 'IPR004270', NULL, 'Papillomavirus E5, alphapapillomavirus', 'Papilloma_E5_alpha', 4, NULL),
(3583, NULL, 'IPR006818', NULL, 'Histone chaperone ASF1-like', 'ASF1-like', 4, NULL),
(3584, NULL, 'IPR007397', NULL, 'F-box associated (FBA) domain', 'F-box-assoc_dom', 3, NULL),
(3585, NULL, 'IPR000641', NULL, 'CbxX/CfxQ', 'CbxX/CfxQ', 4, NULL),
(3586, NULL, 'IPR000058', NULL, 'Zinc finger, AN1-type', 'Znf_AN1', 3, NULL),
(3587, NULL, 'IPR006805', NULL, 'Anthranilate synthase component I, N-terminal', 'Anth_synth_I_N', 3, NULL),
(3588, NULL, 'IPR000705', NULL, 'Galactokinase', 'Galactokinase', 4, NULL),
(3589, NULL, 'IPR006280', NULL, 'Sarcosine oxidase, gamma subunit, heterotetrameric', 'SoxG_het', 4, NULL),
(3590, NULL, 'IPR006263', NULL, 'Cytidine deaminase, homodimeric', 'Cyt_deam_dimer', 4, NULL),
(3591, NULL, 'IPR005667', NULL, 'Sulphate ABC transporter permease protein 2', 'Sulph_transpt2', 4, NULL),
(3592, NULL, 'IPR005690', NULL, 'Translocase of chloroplast Toc86/159', 'Toc86_159', 4, NULL),
(3593, NULL, 'IPR004726', NULL, 'Degenerin', 'Deg-1', 4, NULL),
(3594, NULL, 'IPR007555', NULL, 'Protein of unknown function DUF499', 'DUF499', 4, NULL),
(3595, NULL, 'IPR000719', NULL, 'Protein kinase domain', 'Prot_kinase_dom', 3, NULL),
(3596, NULL, 'IPR004216', NULL, 'L-fucose/L-arabinose isomerase, C-terminal', 'Fuc/Ara_isomerase_C', 5, NULL),
(3597, NULL, 'IPR005664', NULL, 'Tetrahydrodipicolinate N-succinyltransferase, transferase hexapeptide repeat family', 'DapD_Trfase_Hexpep_rpt_fam', 4, NULL),
(3598, NULL, 'IPR000138', NULL, 'Hydroxymethylglutaryl-CoA lyase, active site', 'HMG_CoA_lyase_AS', 0, NULL),
(3599, NULL, 'IPR000714', NULL, 'Equine herpesvirus protein of unknown function', 'EHV_Unk', 4, NULL),
(3600, NULL, 'IPR003308', NULL, 'Integrase, N-terminal zinc-binding domain', 'Integrase_Zn-bd_dom_N', 3, NULL),
(3601, NULL, 'IPR006259', NULL, 'Adenylate kinase subfamily', 'Adenyl_kin_sub', 4, NULL),
(3602, NULL, 'IPR000697', NULL, 'WH1/EVH1 domain', 'WH1/EVH1_dom', 3, NULL),
(3603, NULL, 'IPR004213', NULL, 'Flt3 ligand', 'Flt3_lig', 4, NULL),
(3604, NULL, 'IPR006270', NULL, 'Streptococcal histidine triad repeat', 'Strep_his_triad_rpt', 7, NULL),
(3605, NULL, 'IPR006842', NULL, 'Transposase (putative), YhgA-like', 'Transposase_31', 3, NULL),
(3606, NULL, 'IPR000679', NULL, 'Zinc finger, GATA-type', 'Znf_GATA', 3, NULL),
(3607, NULL, 'IPR007398', NULL, 'Pimeloyl-ACP methyl esterase BioG', 'BioG', 4, NULL),
(3608, NULL, 'IPR006854', NULL, 'Phosphoprotein F17', 'Phosphoprotein_F17', 4, NULL),
(3609, NULL, 'IPR006799', NULL, 'Anti-Mullerian hormone, N-terminal', 'AMH_N', 3, NULL),
(3610, NULL, 'IPR007544', NULL, 'Type 1 encapsulin shell protein', 'ENCAP', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(3611, NULL, 'IPR000073', NULL, 'Alpha/beta hydrolase fold-1', 'AB_hydrolase_1', 3, NULL),
(3612, NULL, 'IPR000687', NULL, 'RIO kinase', 'RIO_kinase', 3, NULL),
(3613, NULL, 'IPR004265', NULL, 'Dirigent protein', 'Dirigent', 4, NULL),
(3614, NULL, 'IPR000133', NULL, 'ER lumen protein retaining receptor', 'ER_ret_rcpt', 4, NULL),
(3615, NULL, 'IPR000141', NULL, 'Prostaglandin F receptor', 'PglndnF_rcpt', 4, NULL),
(3616, NULL, 'IPR000065', NULL, 'Leptin', 'Leptin', 4, NULL),
(3617, NULL, 'IPR000769', NULL, 'Regulatory protein Rop', 'Regulatory_Rop', 4, NULL),
(3618, NULL, 'IPR007432', NULL, 'Protein of unknown function DUF480', 'DUF480', 4, NULL),
(3619, NULL, 'IPR034173', NULL, 'SHARP, RNA recognition motif 2', 'SHARP_RRM2', 3, NULL),
(3620, NULL, 'IPR005707', NULL, 'Ribosomal protein S2, eukaryotic/archaeal', 'Ribosomal_S2_euk/arc', 4, NULL),
(3621, NULL, 'IPR005693', NULL, 'Virulence factor Mce protein', 'Mce', 4, NULL),
(3622, NULL, 'IPR004211', NULL, 'Recombination endonuclease VII', 'Endonuclease_7', 4, NULL),
(3623, NULL, 'IPR006243', NULL, 'Photosystem I PsaA', 'PSI_PsaA', 4, NULL),
(3624, NULL, 'IPR000724', NULL, 'IgG-binding B', 'IgG-bd_B', 3, NULL),
(3625, NULL, 'IPR004260', NULL, 'Pyrimidine dimer DNA glycosylase', 'Pyr-dimer_DNA_glycosylase', 4, NULL),
(3626, NULL, 'IPR004263', NULL, 'Exostosin-like', 'Exostosin', 4, NULL),
(3627, NULL, 'IPR007412', NULL, 'Anti-sigma-28 factor, FlgM', 'FlgM', 4, NULL),
(3628, NULL, 'IPR007414', NULL, 'Protein of unknown function DUF468', 'DUF468', 4, NULL),
(3629, NULL, 'IPR006247', NULL, 'Phycocyanin, beta subunit', 'Phycocyanin_b', 4, NULL),
(3630, NULL, 'IPR006293', NULL, 'DNA helicase, ATP-dependent, RecQ type, bacterial', 'DNA_helicase_ATP-dep_RecQ_bac', 4, NULL),
(3631, NULL, 'IPR006836', NULL, 'Protein of unknown function DUF612', 'DUF612', 4, NULL),
(3632, NULL, 'IPR004264', NULL, 'Transposase, Tnp1/En/Spm-like', 'Transposase_23', 3, NULL),
(3633, NULL, 'IPR000740', NULL, 'GrpE nucleotide exchange factor', 'GrpE', 4, NULL),
(3634, NULL, 'IPR000144', NULL, 'GPCR, family 3, metabotropic glutamate receptor 8', 'GPCR_3_mGluR8', 4, NULL),
(3635, NULL, 'IPR002744', NULL, 'MIP18 family-like', 'MIP18-like', 3, NULL),
(3636, NULL, 'IPR005686', NULL, 'Mitochondrial import receptor subunit Tom40, fungi', 'Tom40_fungi', 4, NULL),
(3637, NULL, 'IPR007402', NULL, 'Protein of unknown function DUF455', 'DUF455', 4, NULL),
(3638, NULL, 'IPR007435', NULL, 'Protein of unknown function DUF484', 'DUF484', 4, NULL),
(3639, NULL, 'IPR000203', NULL, 'GPS motif', 'GPS', 3, NULL),
(3640, NULL, 'IPR006262', NULL, 'Cytidine deaminase, homotetrameric', 'Cyt_deam_tetra', 4, NULL),
(3641, NULL, 'IPR006802', NULL, 'Radial spokehead-like protein', 'Radial_spoke', 4, NULL),
(3642, NULL, 'IPR000760', NULL, 'Inositol monophosphatase-like', 'Inositol_monophosphatase-like', 4, NULL),
(3643, NULL, 'IPR007413', NULL, 'Protein of unknown function DUF463, YcjX-like protein', 'DUF463_YcjX', 4, NULL),
(3644, NULL, 'IPR000680', NULL, 'Borrelia lipoprotein', 'Borrelia_lipo', 4, NULL),
(3645, NULL, 'IPR000674', NULL, 'Aldehyde oxidase/xanthine dehydrogenase, a/b hammerhead', 'Ald_Oxase/Xan_DH_a/b', 3, NULL),
(3646, NULL, 'IPR004237', NULL, 'Fibronectin binding repeat', 'Fibron_repeat-bd', 7, NULL),
(3647, NULL, 'IPR007407', NULL, 'Protein of unknown function DUF459', 'DUF459', 4, NULL),
(3648, NULL, 'IPR004258', NULL, 'Duffy-binding-like domain', 'DBL', 3, NULL),
(3649, NULL, 'IPR002756', NULL, '4-[[4-(2-aminoethyl)phenoxy]-methyl]-2-furanmethanamine-glutamate synthase', 'MfnF', 4, NULL),
(3650, NULL, 'IPR002703', NULL, 'Levivirus coat protein', 'Levivir_coat', 4, NULL),
(3651, NULL, 'IPR000700', NULL, 'PAS-associated, C-terminal', 'PAS-assoc_C', 3, NULL),
(3652, NULL, 'IPR006848', NULL, 'Transcription regulator, putative, lactococcus phage-type', 'Transcrpt_reg_put_lact_phage', 4, NULL),
(3653, NULL, 'IPR002737', NULL, 'MEMO1 family', 'MEMO1_fam', 4, NULL),
(3654, NULL, 'IPR007416', NULL, 'YggL 50S ribosome-binding protein', 'YggL_50S_bp', 4, NULL),
(3655, NULL, 'IPR006234', NULL, 'O-succinylhomoserine sulfhydrylase', 'O-succ-hSer_sulfhydrylase', 4, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(3656, NULL, 'IPR005699', NULL, 'Chaperone lipoprotein, PulS/OutS', 'Chap_lipoprot_PulS/OutS', 4, NULL),
(3657, NULL, 'IPR006245', NULL, 'Allophycocyanin, beta subunit', 'ApcB', 4, NULL),
(3658, NULL, 'IPR004238', NULL, 'Late embryogenesis abundant protein, LEA_4 subgroup', 'LEA_4', 4, NULL),
(3659, NULL, 'IPR004230', NULL, 'DNA mismatch repair protein MutH', 'DNA_mismatch_repair_MutH', 4, NULL),
(3660, NULL, 'IPR006266', NULL, 'UMP-CMP kinase', 'UMP_CMP_kinase', 4, NULL),
(3661, NULL, 'IPR002710', NULL, 'Dilute domain', 'Dilute_dom', 3, NULL),
(3662, NULL, 'IPR000071', NULL, 'Immunodeficiency lentiviral matrix, N-terminal', 'Lentvrl_matrix_N', 3, NULL),
(3663, NULL, 'IPR007545', NULL, 'LOR/SDH bifunctional enzyme, conserved domain', 'LOR/SDH_bifunc_enz_cons_dom', 3, NULL),
(3664, NULL, 'IPR002733', NULL, 'AMMECR1 domain', 'AMMECR1_domain', 3, NULL),
(3665, NULL, 'IPR003310', NULL, 'G/T mismatch-specific thymine DNA glycosylasee TDG-like, eukaryotes', 'TDG-like_euk', 4, NULL),
(3666, NULL, 'IPR002706', NULL, 'DNA-repair protein Xrcc1, N-terminal', 'Xrcc1_N', 3, NULL),
(3667, NULL, 'IPR000060', NULL, 'BCCT transporter family', 'BCCT_transptr', 4, NULL),
(3668, NULL, 'IPR006852', NULL, 'Protein of unknown function DUF616', 'DUF616', 4, NULL),
(3669, NULL, 'IPR006855', NULL, 'Vertebrate-like NAGS Gcn5-related N-acetyltransferase (GNAT) domain', 'Vertebrate-like_GNAT_dom', 3, NULL),
(3670, NULL, 'IPR002748', NULL, 'Cobalt-precorrin-5B C(1)-methyltransferase CbiD', 'CbiD', 4, NULL),
(3671, NULL, 'IPR007418', NULL, 'Protein of unknown function DUF474', 'DUF474', 4, NULL),
(3672, NULL, 'IPR005675', NULL, 'Citramalate synthase', 'Citramal_synthase', 4, NULL),
(3673, NULL, 'IPR005687', NULL, 'Mitochondrial outer membrane translocase complex, subunit Tom70', 'Tom70', 4, NULL),
(3674, NULL, 'IPR006813', NULL, 'Glycosyl transferase, family 17', 'Glyco_trans_17', 4, NULL),
(3675, NULL, 'IPR007433', NULL, 'Protein of unknown function DUF481', 'DUF481', 4, NULL),
(3676, NULL, 'IPR002729', NULL, 'CRISPR-associated protein Cas1', 'CRISPR-assoc_Cas1', 4, NULL),
(3677, NULL, 'IPR007390', NULL, 'Sporulation stage V, protein R', 'Spore_V_R', 4, NULL),
(3678, NULL, 'IPR003306', NULL, 'WIF domain', 'WIF', 3, NULL),
(3679, NULL, 'IPR003311', NULL, 'AUX/IAA protein', 'AUX_IAA', 4, NULL),
(3680, NULL, 'IPR007396', NULL, 'Transcriptional regulator PAI 2-type', 'TR_PAI2-type', 4, NULL),
(3681, NULL, 'IPR002742', NULL, 'Desulfoferrodoxin, ferrous iron-binding domain', 'Desulfoferrodoxin_Fe-bd_dom', 3, NULL),
(3682, NULL, 'IPR002736', NULL, 'Triphosphoribosyl-dephospho-CoA protein', 'CitG', 4, NULL),
(3683, NULL, 'IPR004233', NULL, 'FokI, recognition domain, subdomain 2', 'FokI_D2', 3, NULL),
(3684, NULL, 'IPR004210', NULL, 'BESS motif', 'BESS_motif', 3, NULL),
(3685, NULL, 'IPR006255', NULL, 'Dihydrolipoamide succinyltransferase', 'SucB', 4, NULL),
(3686, NULL, 'IPR006289', NULL, 'Transcription elongation factor, TFIIS', 'TFSII', 4, NULL),
(3687, NULL, 'IPR006822', NULL, 'Coatomer, epsilon subunit', 'Coatomer_esu', 4, NULL),
(3688, NULL, 'IPR005669', NULL, 'Thiosulphate/Sulfate-binding protein', 'Thiosulph/SO4-bd', 4, NULL),
(3689, NULL, 'IPR006839', NULL, 'Ribosome-associated, YjgA', 'Ribosome-assoc_YjgA', 4, NULL),
(3690, NULL, 'IPR006835', NULL, 'Domain of unknown function DUF575', 'DUF575', 3, NULL),
(3691, NULL, 'IPR007393', NULL, 'YlxR domain', 'YlxR_dom', 3, NULL),
(3692, NULL, 'IPR006242', NULL, 'Putative pyrophosphorylase ModD', 'ModD', 4, NULL),
(3693, NULL, 'IPR004207', NULL, 'Ferredoxin thioredoxin reductase, alpha chain', 'Fd_thioredoxin_Rdtase_alpha', 3, NULL),
(3694, NULL, 'IPR002713', NULL, 'FF domain', 'FF_domain', 3, NULL),
(3695, NULL, 'IPR034568', NULL, 'Mediator of RNA polymerase II transcription subunit 30', 'MED30', 4, NULL),
(3696, NULL, 'IPR007554', NULL, 'CDP-glycerol glycerophosphotransferase', 'Glycerophosphate_synth', 4, NULL),
(3697, NULL, 'IPR006846', NULL, 'Ribosomal protein S30', 'Ribosomal_S30', 4, NULL),
(3698, NULL, 'IPR004732', NULL, 'Transaldolase type 2', 'Transaldolase_2', 4, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(3699, NULL, 'IPR004243', NULL, 'Minor capsid protein VI', 'McpVI', 4, NULL),
(3700, NULL, 'IPR004271', NULL, 'Influenza C virus M1 protein', 'CM1', 4, NULL),
(3701, NULL, 'IPR007415', NULL, 'Nitrogenase MoFe maturation protein, NifZ', 'Nitrogenase_MoFe_mat_NifZ', 4, NULL),
(3702, NULL, 'IPR005668', NULL, '2-isopropylmalate synthase', 'IPM_Synthase', 4, NULL),
(3703, NULL, 'IPR004728', NULL, 'Translocation protein Sec62', 'Sec62', 4, NULL),
(3704, NULL, 'IPR004261', NULL, 'Hepatitis E virus structural protein 2', 'SP2', 4, NULL),
(3705, NULL, 'IPR005710', NULL, 'Ribosomal protein S4/S9, eukaryotic/archaeal', 'Ribosomal_S4/S9_euk/arc', 4, NULL),
(3706, NULL, 'IPR000225', NULL, 'Armadillo', 'Armadillo', 7, NULL),
(3707, NULL, 'IPR000638', NULL, 'Gas vesicle protein GvpA', 'Gas-vesicle_GvpA', 4, NULL),
(3708, NULL, 'IPR005683', NULL, 'Mitochondrial import receptor subunit Tom22', 'Tom22', 4, NULL),
(3709, NULL, 'IPR000083', NULL, 'Fibronectin, type I', 'Fibronectin_type1', 3, NULL),
(3710, NULL, 'IPR006827', NULL, 'Lantibiotic dehydratase, N-terminal', 'Lant_deHydtase_N', 3, NULL),
(3711, NULL, 'IPR000126', NULL, 'Serine proteases, V8 family, serine active site', 'V8_ser_AS', 0, NULL),
(3712, NULL, 'IPR000068', NULL, 'GPCR, family 3, extracellular calcium-sensing receptor-related', 'GPCR_3_Ca_sens_rcpt-rel', 4, NULL),
(3713, NULL, 'IPR006295', NULL, 'DNA primase, DnaG', 'DNA_primase_DnaG', 3, NULL),
(3714, NULL, 'IPR005701', NULL, 'Polysaccharide export protein MPA1-like', 'MPA1-like', 4, NULL),
(3715, NULL, 'IPR005692', NULL, 'Chloroplast protein import component Tic22', 'Tic22', 4, NULL),
(3716, NULL, 'IPR002694', NULL, 'Zinc finger, CHC2-type', 'Znf_CHC2', 3, NULL),
(3717, NULL, 'IPR005661', NULL, 'Na+-transporting methylmalonyl-CoA/oxaloacetate decarboxylase, beta subunit', 'OadB_MmdB', 4, NULL),
(3718, NULL, 'IPR002735', NULL, 'Translation initiation factor IF2/IF5 domain', 'Transl_init_fac_IF2/IF5_dom', 3, NULL),
(3719, NULL, 'IPR004229', NULL, 'Methylamine dehydrogenase light chain', 'MeN_DH_Ltc', 4, NULL),
(3720, NULL, 'IPR002751', NULL, 'Metal transport protein CbiM/NikMN', 'CbiM/NikMN', 4, NULL),
(3721, NULL, 'IPR004244', NULL, 'Transposase, L1', 'Transposase_22', 4, NULL),
(3722, NULL, 'IPR005680', NULL, 'Ribosomal protein S23, eukaryotic/archaeal', 'Ribosomal_S23_euk/arc', 4, NULL),
(3723, NULL, 'IPR000731', NULL, 'Sterol-sensing domain', 'SSD', 3, NULL),
(3724, NULL, 'IPR000671', NULL, 'Peptidase A31 family', 'Peptidase_A31', 4, NULL),
(3725, NULL, 'IPR004208', NULL, 'Influenza non-structural protein (NS1)', 'NS1', 4, NULL),
(3726, NULL, 'IPR007408', NULL, 'Protein of unknown function DUF460', 'DUF460', 4, NULL),
(3727, NULL, 'IPR006798', NULL, 'Poxvirus F16', 'Poxvirus_F16', 4, NULL),
(3728, NULL, 'IPR005670', NULL, 'Phosphate transport system permease protein 1', 'Phosp_transpt1', 4, NULL),
(3729, NULL, 'IPR000124', NULL, 'Spermadhesin', 'Spermadhesin', 4, NULL),
(3730, NULL, 'IPR000743', NULL, 'Glycoside hydrolase, family 28', 'Glyco_hydro_28', 4, NULL),
(3731, NULL, 'IPR000703', NULL, 'Proenkephalin A', 'Proenkphlin_A', 4, NULL),
(3732, NULL, 'IPR005677', NULL, 'Fumarate hydratase, class II', 'Fum_hydII', 4, NULL),
(3733, NULL, 'IPR000776', NULL, 'Precursor fusion glycoprotein F0, Paramyxoviridae', 'Fusion_F0_Paramyxovir', 4, NULL),
(3734, NULL, 'IPR002717', NULL, 'Histone acetyltransferase domain, MYST-type', 'HAT_MYST-type', 3, NULL),
(3735, NULL, 'IPR006830', NULL, 'InvH outer membrane lipoprotein', 'InvH', 4, NULL),
(3736, NULL, 'IPR006271', NULL, 'Phosphoserine aminotransferase, Methanosarcina-type', 'Pser_aminoTfrase_methanosarc', 4, NULL),
(3737, NULL, 'IPR006821', NULL, 'Intermediate filament head, DNA-binding domain', 'Intermed_filament_DNA-bd', 3, NULL),
(3738, NULL, 'IPR002711', NULL, 'HNH endonuclease', 'HNH', 3, NULL),
(3739, NULL, 'IPR006261', NULL, 'dNTP triphosphohydrolase', 'dNTPase', 4, NULL),
(3740, NULL, 'IPR005666', NULL, 'Sulphate transport system permease protein 1', 'Sulph_transpt1', 3, NULL),
(3741, NULL, 'IPR000043', NULL, 'Adenosylhomocysteinase-like', 'Adenosylhomocysteinase-like', 4, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(3742, NULL, 'IPR006283', NULL, 'Thiamine-monophosphate kinase-like', 'ThiL-like', 4, NULL),
(3743, NULL, 'IPR003305', NULL, 'Carbohydrate-binding, CenC-like', 'CenC_carb-bd', 3, NULL),
(3744, NULL, 'IPR005705', NULL, 'Polysaccharide export inner-membrane protein, BexC/CtrB/KpsE/VexD', 'BexC_CtrB_KpsE_VexD', 4, NULL),
(3745, NULL, 'IPR002734', NULL, 'Bacterial bifunctional deaminase-reductase, C-terminal', 'RibDG_C', 3, NULL),
(3746, NULL, 'IPR000211', NULL, 'Geminivirus BL1 movement protein', 'Gemini_BL', 4, NULL),
(3747, NULL, 'IPR007403', NULL, 'Protein of unknown function DUF456', 'DUF456', 4, NULL),
(3748, NULL, 'IPR007436', NULL, 'Protein of unknown function DUF485', 'DUF485', 4, NULL),
(3749, NULL, 'IPR006290', NULL, 'Heavy metal sensor kinase', 'CztS_silS_copS', 4, NULL),
(3750, NULL, 'IPR000183', NULL, 'Ornithine/DAP/Arg decarboxylase', 'Orn/DAP/Arg_de-COase', 4, NULL),
(3751, NULL, 'IPR000723', NULL, 'G protein-coupled receptor 3/6/12 orphan', 'GPR_3/6/12_orphan', 4, NULL),
(3752, NULL, 'IPR002724', NULL, 'Pyruvoyl-dependent arginine decarboxylase', 'Pyruvoyl-dep_arg_deCO2ase', 4, NULL),
(3753, NULL, 'IPR000677', NULL, 'Chitinase-like', 'Chitinase-like', 4, NULL),
(3754, NULL, 'IPR006823', NULL, 'Neutral/alkaline nonlysosomal ceramidase', 'Ceramidase_alk', 4, NULL),
(3755, NULL, 'IPR005700', NULL, 'Exopolysaccharide biosynthesis protein ExoP-like', 'EPS_ExoP-like', 4, NULL),
(3756, NULL, 'IPR000718', NULL, 'Peptidase M13', 'Peptidase_M13', 4, NULL),
(3757, NULL, 'IPR002693', NULL, 'Paramyxovirinae P phosphoprotein C-terminal domain', 'Paramyxo_PProtein_C', 3, NULL),
(3758, NULL, 'IPR004256', NULL, 'Domain of unknown function DUF234, DEXX-box ATPase C-terminal', 'DUF234_ATPase_C', 3, NULL),
(3759, NULL, 'IPR005696', NULL, 'Secretion protein MesE/LcnD', 'MesE/LcnD', 4, NULL),
(3760, NULL, 'IPR004235', NULL, 'Scytalone dehydratase', 'Scytalone_dehydratase', 4, NULL),
(3761, NULL, 'IPR000710', NULL, 'Peptidase S6, IgA endopeptidase', 'Peptidase_S6', 4, NULL),
(3762, NULL, 'IPR004257', NULL, 'Equine arteritis virus (EAV), glycoprotein 4', 'Equine_arteritis_virus_Gp4', 4, NULL),
(3763, NULL, 'IPR034564', NULL, 'U2 small nuclear ribonucleoprotein B'''', RNA recognition motif 1', 'U2B''''_RRM1', 3, NULL),
(3764, NULL, 'IPR002723', NULL, 'N(4)-bis(aminopropyl)spermidine synthase, C-terminal', 'BpsA_C', 3, NULL),
(3765, NULL, 'IPR006286', NULL, 'Deglycase PfpI', 'C56_PfpI', 4, NULL),
(3766, NULL, 'IPR005689', NULL, 'Chloroplast envelope protein translocase, IAP75', 'IAP75', 4, NULL),
(3767, NULL, 'IPR000738', NULL, 'WHEP-TRS domain', 'WHEP-TRS_dom', 3, NULL),
(3768, NULL, 'IPR006860', NULL, 'FecR protein', 'FecR', 3, NULL),
(3769, NULL, 'IPR000175', NULL, 'Sodium:neurotransmitter symporter', 'Na/ntran_symport', 4, NULL),
(3770, NULL, 'IPR004242', NULL, 'Transposon, En/Spm-like', 'Transposase_21', 4, NULL),
(3771, NULL, 'IPR002698', NULL, '5-formyltetrahydrofolate cyclo-ligase', 'FTHF_cligase', 4, NULL),
(3772, NULL, 'IPR006276', NULL, 'Cobalamin-independent methionine synthase', 'Cobalamin-indep_Met_synthase', 4, NULL),
(3773, NULL, 'IPR000104', NULL, 'Antifreeze protein, type I', 'Antifreeze_1', 4, NULL),
(3774, NULL, 'IPR007548', NULL, 'Protein of unknown function DUF505', 'DUF505', 4, NULL),
(3775, NULL, 'IPR006253', NULL, 'Malate synthase G', 'Malate_synthG', 4, NULL),
(3776, NULL, 'IPR000683', NULL, 'Gfo/Idh/MocA-like oxidoreductase, N-terminal', 'Gfo/Idh/MocA-like_OxRdtase_N', 3, NULL),
(3777, NULL, 'IPR002692', NULL, 'Penicillin/GL-7-ACA/AHL/aculeacin-A acylase', 'S45', 4, NULL),
(3778, NULL, 'IPR006258', NULL, 'Dihydrolipoamide dehydrogenase', 'Lipoamide_DH', 4, NULL),
(3779, NULL, 'IPR004209', NULL, 'Ferredoxin thioredoxin reductase catalytic beta subunit', 'FTR_bsu', 4, NULL),
(3780, NULL, 'IPR034172', NULL, 'SHARP, RNA recognition motif 1', 'SHARP_RRM1', 3, NULL),
(3781, NULL, 'IPR007430', NULL, 'Bacterial virulence protein VirB8', 'VirB8', 3, NULL),
(3782, NULL, 'IPR007400', NULL, 'PrpF protein', 'PrpF_protein', 4, NULL),
(3783, NULL, 'IPR004217', NULL, 'Tim10-like', 'Tim10-like', 3, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(3784, NULL, 'IPR004218', NULL, 'Prokaryotic glutathione synthetase, ATP-binding', 'GSHS_ATP-bd', 3, NULL),
(3785, NULL, 'IPR000031', NULL, 'PurE domain', 'PurE_dom', 3, NULL),
(3786, NULL, 'IPR002731', NULL, 'ATPase, BadF/BadG/BcrA/BcrD type', 'ATPase_BadF', 3, NULL),
(3787, NULL, 'IPR000014', NULL, 'PAS domain', 'PAS', 3, NULL),
(3788, NULL, 'IPR006291', NULL, 'Transcriptional regulatory protein PcoR, heavy metal response', 'PcoR', 4, NULL),
(3789, NULL, 'IPR004219', NULL, 'TT viral protein of unknown function', 'TTvirus_Unk', 4, NULL),
(3790, NULL, 'IPR000219', NULL, 'Dbl homology (DH) domain', 'DH-domain', 3, NULL),
(3791, NULL, 'IPR002720', NULL, 'Retinoblastoma-associated protein, A-box', 'RB_A', 3, NULL),
(3792, NULL, 'IPR000112', NULL, 'GPCR, family 3, metabotropic glutamate receptor 6', 'GPCR_3__mGluR6', 4, NULL),
(3793, NULL, 'IPR006841', NULL, 'Coronavirus nonstructural protein NS2', 'Corona_NS2', 4, NULL),
(3794, NULL, 'IPR003307', NULL, 'W2 domain', 'W2_domain', 3, NULL),
(3795, NULL, 'IPR007394', NULL, 'Putative helix-turn-helix protein, YlxM/p13-like', 'UPF0122', 4, NULL),
(3796, NULL, 'IPR034565', NULL, 'Putative cell wall protein', 'Put_cell_wall', 4, NULL),
(3797, NULL, 'IPR002739', NULL, 'Uncharacterised protein family UPF0201', 'UPF0201', 4, NULL),
(3798, NULL, 'IPR005685', NULL, 'Integration host factor, beta subunit', 'IHF_beta', 4, NULL),
(3799, NULL, 'IPR006244', NULL, 'Photosystem I PsaB', 'PSI_PsaB', 4, NULL),
(3800, NULL, 'IPR000116', NULL, 'High mobility group protein HMGA', 'HMGA', 4, NULL),
(3801, NULL, 'IPR000732', NULL, 'Rhodopsin', 'Rhodopsin', 4, NULL),
(3802, NULL, 'IPR000689', NULL, 'Ubiquinone biosynthesis monooxygenase COQ6', 'UbQ_mOase_COQ6', 4, NULL),
(3803, NULL, 'IPR006825', NULL, 'Eclosion hormone', 'Eclosion', 4, NULL),
(3804, NULL, 'IPR007419', NULL, 'BFD-like [2Fe-2S]-binding domain', 'BFD-like_2Fe2S-bd_dom', 3, NULL),
(3805, NULL, 'IPR002725', NULL, 'YgjP-like, metallopeptidase domain', 'YgjP-like_metallopeptidase', 3, NULL),
(3806, NULL, 'IPR006812', NULL, 'Glycine reductase complex selenoprotein A', 'GRDA', 4, NULL),
(3807, NULL, 'IPR002732', NULL, 'Holliday junction resolvase Hjc', 'Hjc', 4, NULL),
(3808, NULL, 'IPR006853', NULL, 'Poxin, virus', 'Poxin_vir', 4, NULL),
(3809, NULL, 'IPR005665', NULL, 'Protein-export membrane protein SecF, bacterial', 'SecF_bac', 4, NULL),
(3810, NULL, 'IPR006809', NULL, 'TAFII28-like protein domain', 'TAFII28_dom', 3, NULL),
(3811, NULL, 'IPR006815', NULL, 'Microvirus J protein-like', 'Microvir_J-like', 4, NULL),
(3812, NULL, 'IPR006279', NULL, 'Sarcosine oxidase, delta subunit, heterotetrameric', 'SoxD', 4, NULL),
(3813, NULL, 'IPR034363', NULL, 'eIF3B, RNA recognition motif', 'eIF3B_RRM', 3, NULL),
(3814, NULL, 'IPR004234', NULL, 'FokI, recognition domain, subdomain 1', 'FokI_D1', 3, NULL),
(3815, NULL, 'IPR034566', NULL, 'Type 2 DNA topoisomerase 6 subunit B-like, plants', 'MTOPVIB_plant', 4, NULL),
(3816, NULL, 'IPR006292', NULL, 'Ribonuclease D', 'RNase_D', 4, NULL),
(3817, NULL, 'IPR006828', NULL, 'Association with the SNF1 complex (ASC) domain', 'ASC_dom', 3, NULL),
(3818, NULL, 'IPR006819', NULL, 'Agrobacterium VirD5 protein', 'Agro_VirD5', 4, NULL),
(3819, NULL, 'IPR005671', NULL, '2-isopropylmalate synthase, bacterial-type', 'LeuA_bact_synth', 4, NULL),
(3820, NULL, 'IPR002716', NULL, 'PIN domain', 'PIN_dom', 3, NULL),
(3821, NULL, 'IPR006240', NULL, '3''(2''),5''-bisphosphate nucleotidase CysQ', 'CysQ', 4, NULL),
(3822, NULL, 'IPR004240', NULL, 'Nonaspanin (TM9SF)', 'EMP70', 4, NULL),
(3823, NULL, 'IPR000115', NULL, 'Phosphoribosylglycinamide synthetase', 'PRibGlycinamide_synth', 4, NULL),
(3824, NULL, 'IPR004224', NULL, 'Fumarate reductase type B, transmembrane subunit', 'Fum_red_B_TM', 4, NULL),
(3825, NULL, 'IPR004254', NULL, 'AdipoR/Haemolysin-III-related', 'AdipoR/HlyIII-related', 4, NULL),
(3826, NULL, 'IPR006264', NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', 'EPSP_synthase', 4, NULL),
(3827, NULL, 'IPR004227', NULL, 'Formiminotransferase catalytic domain', 'Formiminotransferase_cat', 3, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(3828, NULL, 'IPR006260', NULL, 'TonB/TolA, C-terminal', 'TonB/TolA_C', 3, NULL),
(3829, NULL, 'IPR006249', NULL, 'Aconitase/Iron-responsive element-binding protein 2', 'Aconitase/IRP2', 4, NULL),
(3830, NULL, 'IPR034552', NULL, 'p54nrb, RNA recognition motif 1', 'p54nrb_RRM1', 3, NULL),
(3831, NULL, 'IPR002746', NULL, 'Uncharacterised protein family UPF0216', 'UPF0216', 4, NULL),
(3832, NULL, 'IPR000709', NULL, 'Leu/Ile/Val-binding protein', 'Leu_Ile_Val-bd', 4, NULL),
(3833, NULL, 'IPR006285', NULL, 'Ubiquitin-like modifier-activating enzyme Atg7', 'Atg7', 4, NULL),
(3834, NULL, 'IPR005684', NULL, 'Integration host factor, alpha subunit', 'IHF_alpha', 4, NULL),
(3835, NULL, 'IPR005695', NULL, 'Cobalt/zinc/cadmium resistance protein CzcB', 'Co/Zn/Cd_resistance_CzcB', 4, NULL),
(3836, NULL, 'IPR000685', NULL, 'Ribulose bisphosphate carboxylase, large subunit, C-terminal', 'RuBisCO_lsu_C', 3, NULL),
(3837, NULL, 'IPR007405', NULL, 'Bacteriophage KVP40, Orf299', 'Phage_KVP40_Orf299', 4, NULL),
(3838, NULL, 'IPR005708', NULL, 'Homogentisate 1,2-dioxygenase', 'Homogentis_dOase', 4, NULL),
(3839, NULL, 'IPR006267', NULL, 'Adenylate kinase, isozyme 1/5', 'AK1/5', 4, NULL),
(3840, NULL, 'IPR002701', NULL, 'Chorismate mutase II, prokaryotic-type', 'CM_II_prokaryot', 3, NULL),
(3841, NULL, 'IPR024632', NULL, 'Phospholipase D, C-terminal', 'PLipase_D_C', 3, NULL),
(3842, NULL, 'IPR004251', NULL, 'Pox virus entry-fusion-complex G9/A16', 'Pox_virus_G9/A16', 4, NULL),
(3843, NULL, 'IPR000208', NULL, 'RNA-directed RNA polymerase, flavivirus', 'RNA-dir_pol_flavivirus', 3, NULL),
(3844, NULL, 'IPR002708', NULL, 'Homocysteine biosynthesis enzyme, sulfur-incorporation', 'HcyBio', 3, NULL),
(3845, NULL, 'IPR005711', NULL, 'Ribosomal protein S5, eukaryotic/archaeal', 'Ribosomal_S5_euk/arc', 4, NULL),
(3846, NULL, 'IPR022874', NULL, 'Valine-tRNA ligase, type 2', 'Valine-tRNA_ligase_type_2', 4, NULL),
(3847, NULL, 'IPR000096', NULL, 'Serum amyloid A protein', 'Serum_amyloid_A', 4, NULL),
(3848, NULL, 'IPR002749', NULL, 'Protein of unknown function DUF63', 'DUF63', 4, NULL),
(3849, NULL, 'IPR004241', NULL, 'Autophagy protein Atg8 ubiquitin-like', 'Atg8-like', 4, NULL),
(3850, NULL, 'IPR004228', NULL, 'Phycoerythrin alpha chain', 'Phycoerythr_a', 3, NULL),
(3851, NULL, 'IPR006252', NULL, 'Malate synthase A', 'Malate_synthA', 4, NULL),
(3852, NULL, 'IPR000055', NULL, 'Type I restriction modification DNA specificity domain', 'Restrct_endonuc_typeI_TRD', 3, NULL),
(3853, NULL, 'IPR006856', NULL, 'Mating-type protein MAT alpha 1, HMG-box', 'MATalpha_HMGbox', 3, NULL),
(3854, NULL, 'IPR002740', NULL, 'EVE domain', 'EVE_domain', 3, NULL),
(3855, NULL, 'IPR004212', NULL, 'GTF2I-like repeat', 'GTF2I', 7, NULL),
(3856, NULL, 'IPR000045', NULL, 'Prepilin type IV endopeptidase, peptidase domain', 'Prepilin_IV_endopep_pep', 3, NULL),
(3857, NULL, 'IPR007420', NULL, 'Protein of unknown function DUF465', 'DUF465', 4, NULL),
(3858, NULL, 'IPR006796', NULL, 'Dickkopf, N-terminal cysteine-rich', 'Dickkopf_N', 3, NULL),
(3859, NULL, 'IPR003304', NULL, 'Prostanoid EP3 receptor, type 1', 'EP3_rcpt_1', 4, NULL),
(3860, NULL, 'IPR000698', NULL, 'Arrestin', 'Arrestin', 4, NULL),
(3861, NULL, 'IPR006811', NULL, 'RNA polymerase II subunit A', 'RNA_pol_II_suA', 4, NULL),
(3862, NULL, 'IPR000639', NULL, 'Epoxide hydrolase-like', 'Epox_hydrolase-like', 4, NULL),
(3863, NULL, 'IPR000643', NULL, 'Iodothyronine deiodinase', 'Iodothyronine_deiodinase', 4, NULL),
(3864, NULL, 'IPR004247', NULL, 'Lentiviral Vpr-like protein', 'Lentiviral_Vpr-like', 4, NULL),
(3865, NULL, 'IPR004725', NULL, 'Apoptosis regulator, Bcl-2/ BclX', 'Bcl2/BclX', 4, NULL),
(3866, NULL, 'IPR006808', NULL, 'ATP synthase, F0 complex, subunit G, mitochondrial', 'ATP_synth_F0_gsu_mt', 4, NULL),
(3867, NULL, 'IPR000172', NULL, 'Glucose-methanol-choline oxidoreductase, N-terminal', 'GMC_OxRdtase_N', 3, NULL),
(3868, NULL, 'IPR000757', NULL, 'Glycoside hydrolase family 16', 'GH16', 3, NULL),
(3869, NULL, 'IPR000637', NULL, 'HMG-I/HMG-Y, DNA-binding, conserved site', 'HMGI/Y_DNA-bd_CS', 2, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(3870, NULL, 'IPR006816', NULL, 'ELMO domain', 'ELMO_dom', 3, NULL),
(3871, NULL, 'IPR005672', NULL, 'Phosphate transport system permease protein PstA', 'Phosphate_PstA', 4, NULL),
(3872, NULL, 'IPR005714', NULL, 'ATPase, type III secretion system, FliI/YscN', 'ATPase_T3SS_FliI/YscN', 4, NULL),
(3873, NULL, 'IPR006272', NULL, 'Phosphoserine aminotransferase, Mycobacterial-type', 'Pser_aminoTfrase_mycobac', 4, NULL),
(3874, NULL, 'IPR002738', NULL, 'RNase P subunit p30', 'RNase_P_p30', 4, NULL),
(3875, NULL, 'IPR006287', NULL, 'Protein/nucleic acid deglycase DJ-1', 'DJ-1', 4, NULL),
(3876, NULL, 'IPR007409', NULL, 'Restriction endonuclease, type I, HsdR, N-terminal', 'Restrct_endonuc_type1_HsdR_N', 3, NULL),
(3877, NULL, 'IPR007417', NULL, 'Protein of unknown function DUF473', 'DUF473', 4, NULL),
(3878, NULL, 'IPR006840', NULL, 'Glutathione-specific gamma-glutamylcyclotransferase', 'ChaC', 4, NULL),
(3879, NULL, 'IPR006858', NULL, 'Chicken anaemia virus VP-3 protein', 'CAV_VP3', 4, NULL),
(3880, NULL, 'IPR004223', NULL, 'Vitamin B12-dependent methionine synthase, activation domain', 'VitB12-dep_Met_synth_activ_dom', 3, NULL),
(3881, NULL, 'IPR034562', NULL, 'U2 small nuclear ribonucleoprotein B'''', RNA recognition motif  2', 'U2B''''_RRM2', 3, NULL),
(3882, NULL, 'IPR006294', NULL, '2'',3''-cyclic-nucleotide 2''-phosphodiesterase/3''-nucleotidase', 'Cyc_nuc_PDE_nucleotidase', 4, NULL),
(3883, NULL, 'IPR006829', NULL, 'LXG domain', 'LXG_dom', 3, NULL),
(3884, NULL, 'IPR000102', NULL, 'Neuraxin/MAP1B repeat', 'MAP1B_neuraxin', 7, NULL),
(3885, NULL, 'IPR006235', NULL, 'O-acetylhomoserine/O-acetylserine sulfhydrylase', 'OAc-hSer/O-AcSer_sulfhydrylase', 4, NULL),
(3886, NULL, 'IPR000777', NULL, 'Human immunodeficiency virus 1, envelope glycoprotein Gp120', 'HIV1_Gp120', 3, NULL),
(3887, NULL, 'IPR024628', NULL, 'Sulphotransferase Stf0, domain', 'Sulfotransferase_Stf0_dom', 3, NULL),
(3888, NULL, 'IPR006237', NULL, 'L-methionine gamma-lyase', 'L-Met_gamma_lys', 4, NULL),
(3889, NULL, 'IPR007429', NULL, 'Protein of unknown function DUF478', 'DUF478', 4, NULL),
(3890, NULL, 'IPR007434', NULL, 'Peptidogalycan biosysnthesis/recognition', 'FemAB-like', 4, NULL),
(3891, NULL, 'IPR000067', NULL, 'Flagellar M-ring protein FliF', 'FlgMring_FliF', 4, NULL),
(3892, NULL, 'IPR006862', NULL, 'Acyl-CoA thioester hydrolase/bile acid-CoA amino acid N-acetyltransferase', 'Thio_Ohase/aa_AcTrfase', 3, NULL),
(3893, NULL, 'IPR005713', NULL, 'Ribosomal protein S19A/S15e', 'Ribosomal_S19A/S15e', 4, NULL),
(3894, NULL, 'IPR007406', NULL, 'MukB, N-terminal domain', 'MukB_N_dom', 3, NULL),
(3895, NULL, 'IPR002705', NULL, 'Peptidase C30/C16,  Betacoronavirus', 'Pept_C30/C16_B_coronavir', 3, NULL),
(3896, NULL, 'IPR006275', NULL, 'Carbamoyl-phosphate synthase, large subunit', 'CarbamoylP_synth_lsu', 4, NULL),
(3897, NULL, 'IPR004204', NULL, 'Cytochrome c oxidase subunit 6C', 'COX6C', 4, NULL),
(3898, NULL, 'IPR007404', NULL, 'LexA-binding, inner membrane-associated putative hydrolase', 'YdjM-like', 4, NULL),
(3899, NULL, 'IPR000214', NULL, 'Zinc finger, DNA glycosylase/AP lyase-type', 'Znf_DNA_glyclase/AP_lyase', 3, NULL),
(3900, NULL, 'IPR006814', NULL, 'Photosystem II PsbR', 'PSII_PsbR', 4, NULL),
(3901, NULL, 'IPR002750', NULL, 'CobE/GbiG C-terminal domain', 'CobE/GbiG_C', 3, NULL),
(3902, NULL, 'IPR004221', NULL, 'Restriction endonuclease, type II, EcoRI', 'Restrct_endonuc_II_EcoRI', 4, NULL),
(3903, NULL, 'IPR002718', NULL, 'Outer membrane protein, Helicobacter', 'OMP_Helicobacter', 4, NULL),
(3904, NULL, 'IPR004737', NULL, 'Nitrate transporter NarK/NarU-like', 'NO3_transporter_NarK/NarU-like', 4, NULL),
(3905, NULL, 'IPR007437', NULL, 'Protein of unknown function DUF486', 'DUF486', 4, NULL),
(3906, NULL, 'IPR006277', NULL, 'Sarcosine oxidase, alpha subunit', 'Sarcosine_oxidase_asu', 4, NULL),
(3907, NULL, 'IPR004252', NULL, 'Probable transposase, Ptta/En/Spm, plant', 'Probable_transposase_24', 4, NULL),
(3908, NULL, 'IPR006246', NULL, 'Phycocyanin, alpha subunit', 'Phycocyanin_a', 4, NULL),
(3909, NULL, 'IPR000098', NULL, 'Interleukin-10', 'IL-10', 4, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(3910, NULL, 'IPR004268', NULL, 'Peptidoglycan biosynthesis protein MurJ', 'MurJ', 4, NULL),
(3911, NULL, 'IPR006850', NULL, 'Domain of unknown function DUF562', 'DUF562', 3, NULL),
(3912, NULL, 'IPR002745', NULL, 'Phosphotransferase KptA/Tpt1', 'Ptrans_KptA/Tpt1', 4, NULL),
(3913, NULL, 'IPR000187', NULL, 'Corticotropin-releasing factor', 'CRF', 3, NULL),
(3914, NULL, 'IPR006282', NULL, 'Thiamin pyrophosphokinase', 'Thi_PPkinase', 4, NULL),
(3915, NULL, 'IPR000169', NULL, 'Cysteine peptidase, cysteine active site', 'Pept_cys_AS', 0, NULL),
(3916, NULL, 'IPR006833', NULL, 'Ammonia monooxygenase/particulate methane monooxygenase, subunit B', 'NH3_CH4_mOase_B', 4, NULL),
(3917, NULL, 'IPR006241', NULL, 'Photosystem II cytochrome b559, beta subunit', 'PSII_cyt_b559_bsu', 4, NULL),
(3918, NULL, 'IPR000715', NULL, 'Glycosyl transferase, family 4', 'Glycosyl_transferase_4', 4, NULL),
(3919, NULL, 'IPR004267', NULL, 'Influenza C virus M2 protein', 'CM2', 4, NULL),
(3920, NULL, 'IPR004239', NULL, 'Protein of unknown function DUF228', 'DUF228', 4, NULL),
(3921, NULL, 'IPR007411', NULL, 'Elongation factor P hydroxylase', 'EpmC', 4, NULL),
(3922, NULL, 'IPR006254', NULL, 'Isocitrate lyase', 'Isocitrate_lyase', 4, NULL),
(3923, NULL, 'IPR006268', NULL, 'Phospho-2-dehydro-3-deoxyheptonate aldolase, subtype 2', 'DAHP_syn_2', 3, NULL),
(3924, NULL, 'IPR000734', NULL, 'Triacylglycerol lipase family', 'TAG_lipase', 4, NULL),
(3925, NULL, 'IPR006269', NULL, '3-deoxy-8-phosphooctulonate synthase', 'KDO8P_synthase', 4, NULL),
(3926, NULL, 'IPR000684', NULL, 'RNA polymerase II, heptapeptide repeat, eukaryotic', 'RNA_pol_II_repeat_euk', 7, NULL),
(3927, NULL, 'IPR007428', NULL, 'MlaA lipoprotein', 'MlaA', 4, NULL),
(3928, NULL, 'IPR005691', NULL, 'Chloroplast protein import component Tic20', 'Tic20', 4, NULL),
(3929, NULL, 'IPR000693', NULL, 'Sea anemone toxin', 'Anenome_toxin', 4, NULL),
(3930, NULL, 'IPR004734', NULL, 'Multidrug resistance protein', 'Multidrug-R', 4, NULL),
(3931, NULL, 'IPR006281', NULL, 'Sarcosine oxidase, monomeric', 'SoxA_mon', 4, NULL),
(3932, NULL, 'IPR002719', NULL, 'Retinoblastoma-associated protein, B-box', 'RB_B', 3, NULL),
(3933, NULL, 'IPR005676', NULL, 'Aspartate-semialdehyde dehydrogenase, peptidoglycan lacking', 'Asp_semi-ald_DH_pep-lack', 4, NULL),
(3934, NULL, 'IPR004736', NULL, 'MFS transporter, metabolite:H symporter', 'MHS_symport', 4, NULL),
(3935, NULL, 'IPR006859', NULL, 'Influenza B matrix protein 2', 'Flu_B_M2', 4, NULL),
(3936, NULL, 'IPR000028', NULL, 'Chloroperoxidase', 'Chloroperoxidase', 3, NULL),
(3937, NULL, 'IPR004733', NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase', 'PurM_cligase', 4, NULL),
(3938, NULL, 'IPR006820', NULL, 'Caudal-like activation domain', 'Caudal_activation_dom', 3, NULL),
(3939, NULL, 'IPR007391', NULL, 'Vancomycin resistance VanW', 'Vancomycin_resist_VanW', 4, NULL),
(3940, NULL, 'IPR007557', NULL, 'PSP1, C-terminal', 'PSP1_C', 3, NULL),
(3941, NULL, 'IPR000148', NULL, 'Papillomavirus E7', 'Papilloma_E7', 4, NULL),
(3942, NULL, 'IPR005712', NULL, 'Ribosomal protein S5, bacterial-type', 'Ribosomal_S5_bac-type', 4, NULL),
(3943, NULL, 'IPR005715', NULL, 'Glutamate 5-kinase/delta-1-pyrroline-5-carboxylate synthase', 'Glu_5kinase/COase_Synthase', 4, NULL),
(3944, NULL, 'IPR000644', NULL, 'CBS domain', 'CBS_dom', 3, NULL),
(3945, NULL, 'IPR000146', NULL, 'Fructose-1,6-bisphosphatase class 1', 'FBPase_class-1', 4, NULL),
(3946, NULL, 'IPR000152', NULL, 'EGF-type aspartate/asparagine hydroxylation site', 'EGF-type_Asp/Asn_hydroxyl_site', 6, NULL),
(3947, NULL, 'IPR007410', NULL, 'Copper chaperone PCuAC', 'PCuAC', 4, NULL),
(3948, NULL, 'IPR002699', NULL, 'ATPase, V1 complex, subunit D', 'V_ATPase_D', 4, NULL),
(3949, NULL, 'IPR002704', NULL, 'Peptidase C7 domain', 'Peptidase_C7_dom', 3, NULL),
(3950, NULL, 'IPR002695', NULL, 'Bifunctional purine biosynthesis protein PurH-like', 'PurH-like', 4, NULL),
(3951, NULL, 'IPR007556', NULL, 'Protein of unknown function DUF483', 'DUF483', 4, NULL),
(3952, NULL, 'IPR006824', NULL, 'DNA helicase, Baculovirus', 'DNA_helicase_Baculovir', 4, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(3953, NULL, 'IPR006837', NULL, 'Divergent polysaccharide deacetylase', 'Divergent_DAC', 4, NULL),
(3954, NULL, 'IPR006804', NULL, 'BCL7', 'BCL7', 4, NULL),
(3955, NULL, 'IPR006817', NULL, 'Lipoprotein leucine-zipper', 'Lipoprotein_leucine-zipper_dom', 3, NULL),
(3956, NULL, 'IPR002696', NULL, 'Putative membrane protein insertion efficiency factor', 'Membr_insert_effic_factor', 4, NULL),
(3957, NULL, 'IPR006803', NULL, 'Poxvirus I5', 'Poxvirus_I5', 4, NULL),
(3958, NULL, 'IPR006257', NULL, 'Dihydrolipoyllysine-residue acetyltransferase component of pyruvate dehydrogenase complex', 'LAT1', 4, NULL),
(3959, NULL, 'IPR000772', NULL, 'Ricin B, lectin domain', 'Ricin_B_lectin', 3, NULL),
(3960, NULL, 'IPR001642', NULL, 'Neuromedin B receptor', 'NeuroB_rcpt', 4, NULL),
(3961, NULL, 'IPR007395', NULL, 'Putative neutral zinc metallopeptidase', 'Zn_peptidase_2', 4, NULL),
(3962, NULL, 'IPR006256', NULL, 'Dihydrolipoamide acetyltransferase pyruvate dehydrogenase complex', 'AcTrfase_Pyrv_DH_cplx', 4, NULL),
(3963, NULL, 'IPR006806', NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 5', 'NDUFA5', 4, NULL),
(3964, NULL, 'IPR004205', NULL, 'Cytochrome b-c1 complex subunit 8', 'Cyt_bc1_su8', 4, NULL),
(3965, NULL, 'IPR000162', NULL, 'GPCR, family 3, metabotropic glutamate receptor', 'GPCR_3_mtglu_rcpt', 4, NULL),
(3966, NULL, 'IPR004220', NULL, '5-carboxymethyl-2-hydroxymuconate isomerase', '5-COMe_2-OHmuconate_Isoase', 4, NULL),
(3967, NULL, 'IPR005694', NULL, 'Efflux pump membrane protein', 'Efflux_pump_mem', 4, NULL),
(3968, NULL, 'IPR000711', NULL, 'ATPase, OSCP/delta subunit', 'ATPase_OSCP/dsu', 4, NULL),
(3969, NULL, 'IPR002727', NULL, 'Protein of unknown function DUF47', 'DUF47', 4, NULL),
(3970, NULL, 'IPR005674', NULL, 'CocE/Serine esterase', 'CocE/Ser_esterase', 4, NULL),
(3971, NULL, 'IPR000673', NULL, 'Signal transduction response regulator, chemotaxis, protein-glutamate methylesterase', 'Sig_transdc_resp-reg_Me-estase', 3, NULL),
(3972, NULL, 'IPR000675', NULL, 'Cutinase/acetylxylan esterase', 'Cutinase/axe', 4, NULL),
(3973, NULL, 'IPR005697', NULL, 'Homoserine O-succinyltransferase MetA', 'HST_MetA', 4, NULL),
(3974, NULL, 'IPR006239', NULL, '3(2),5 -bisphosphate nucleotidase HAL2', 'Bisphos_HAL2', 4, NULL),
(3975, NULL, 'IPR006250', NULL, 'Aconitase, putative', 'Aconitase_put', 4, NULL),
(3976, NULL, 'IPR000150', NULL, 'Cof family', 'Cof', 4, NULL),
(3977, NULL, 'IPR000780', NULL, 'MCP methyltransferase, CheR-type', 'CheR_MeTrfase', 3, NULL),
(3978, NULL, 'IPR005709', NULL, 'Ribosomal protein S4, bacterial-type', 'Ribosomal_S4_bac-type', 4, NULL),
(3979, NULL, 'IPR000201', NULL, 'Hepadnaviral P protein, N-terminal', 'DNApol_viral_N', 3, NULL),
(3980, NULL, 'IPR007427', NULL, 'Protein of unknown function DUF475', 'DUF475', 4, NULL),
(3981, NULL, 'IPR006251', NULL, 'Homoaconitase/3-isopropylmalate dehydratase, large subunit', 'Homoacnase/IPMdehydase_lsu', 4, NULL),
(3982, NULL, 'IPR000206', NULL, 'Ribosomal protein L7/L12', 'Ribosomal_L7/12', 4, NULL),
(3983, NULL, 'IPR006851', NULL, 'Protein of unknown function DUF613', 'DUF613', 4, NULL),
(3984, NULL, 'IPR004226', NULL, 'Tubulin binding cofactor A', 'TBCA', 4, NULL),
(3985, NULL, 'IPR002712', NULL, 'Toxin CcdB', 'CcdB', 4, NULL),
(3986, NULL, 'IPR004245', NULL, 'Protein of unknown function DUF229', 'DUF229', 4, NULL),
(3987, NULL, 'IPR006236', NULL, 'D-3-phosphoglycerate dehydrogenase', 'PGDH', 4, NULL),
(3988, NULL, 'IPR001639', NULL, 'Type II secretion system protein GspC', 'T2SS_protein-GspC', 4, NULL),
(3989, NULL, 'IPR005681', NULL, 'Mitochondrial inner membrane translocase complex, subunit Tim23', 'Tim23', 4, NULL),
(3990, NULL, 'IPR004250', NULL, 'Somatostatin', 'Somatostatin', 4, NULL),
(3991, NULL, 'IPR007421', NULL, 'Schlafen, AlbA_2 domain', 'Schlafen_AlbA_2_dom', 3, NULL),
(3992, NULL, 'IPR000159', NULL, 'Ras-associating (RA) domain', 'RA_dom', 3, NULL),
(3993, NULL, 'IPR007549', NULL, 'Domain of unknown function DUF512', 'DUF512', 3, NULL),
(3994, NULL, 'IPR000770', NULL, 'SAND domain', 'SAND_dom', 3, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(3995, NULL, 'IPR000197', NULL, 'Zinc finger, TAZ-type', 'Znf_TAZ', 3, NULL),
(3996, NULL, 'IPR006801', NULL, 'Apolipoprotein A-II (ApoA-II)', 'ApoA-II', 4, NULL),
(3997, NULL, 'IPR000713', NULL, 'Mur ligase, N-terminal catalytic domain', 'Mur_ligase_N', 3, NULL),
(3998, NULL, 'IPR002755', NULL, 'DNA primase, small subunit', 'DNA_primase_S', 4, NULL),
(3999, NULL, 'IPR004214', NULL, 'Conotoxin', 'Conotoxin', 4, NULL),
(4000, NULL, 'IPR005663', NULL, 'Monovalent cation proton antiporter subunit A', 'MrpA/MnhA1/PhaAB', 4, NULL),
(4001, NULL, 'IPR005267', NULL, 'Glycerol-3-phosphate transporter', 'G3P_transporter', 4, NULL),
(4002, NULL, 'IPR010206', NULL, 'Poly(A) polymerase I', 'PolA_pol_I', 4, NULL),
(4003, NULL, 'IPR010237', NULL, 'Pyrimidine 5-nucleotidase', 'Pyr-5-nucltdase', 4, NULL),
(4004, NULL, 'IPR003373', NULL, 'Ferrous iron transport protein B', 'Fe2_transport_prot-B', 4, NULL),
(4005, NULL, 'IPR010221', NULL, 'VCBS repeat', 'VCBS_rpt', 7, NULL),
(4006, NULL, 'IPR004827', NULL, 'Basic-leucine zipper domain', 'bZIP', 3, NULL),
(4007, NULL, 'IPR003896', NULL, 'Bacterial exotoxin B', 'Bacterial_exotoxin_B', 4, NULL),
(4008, NULL, 'IPR001811', NULL, 'Chemokine interleukin-8-like domain', 'Chemokine_IL8-like_dom', 3, NULL),
(4009, NULL, 'IPR003332', NULL, 'Decorin-binding protein', 'Decorin-bd', 4, NULL),
(4010, NULL, 'IPR010187', NULL, 'Selenoprotein B, glycine/betaine/sarcosine/D-proline reductase family', 'Various_sel_PB', 4, NULL),
(4011, NULL, 'IPR010184', NULL, 'CRISPR-associated protein, MJ0385', 'CRISPR-assoc_prot_MJ0385', 4, NULL),
(4012, NULL, 'IPR001840', NULL, 'Anaphylatoxin, complement system domain', 'Anaphylatoxn_comp_syst_dom', 3, NULL),
(4013, NULL, 'IPR010177', NULL, 'Doubled CXXCH motif', 'Paired_CXXCH_1', 3, NULL),
(4014, NULL, 'IPR002763', NULL, 'Protein of unknown function DUF72', 'DUF72', 4, NULL),
(4015, NULL, 'IPR010175', NULL, '[LysW]-lysine/[LysW]-ornithine hydrolase', 'LysK', 4, NULL),
(4016, NULL, 'IPR007989', NULL, 'Protein of unknown function DUF730', 'DUF730', 4, NULL),
(4017, NULL, 'IPR007987', NULL, 'Poxvirus A21', 'Poxvirus_A21', 4, NULL),
(4018, NULL, 'IPR007933', NULL, 'Transcription activator CII', 'Transcrpt_activ_CII', 4, NULL),
(4019, NULL, 'IPR034365', NULL, 'AtC3H46-like,  RNA recognition motif', 'AtC3H46-like_RRM', 3, NULL),
(4020, NULL, 'IPR005262', NULL, 'Conserved hypothetical protein CHP00661', 'CHP00661', 3, NULL),
(4021, NULL, 'IPR007952', NULL, 'Poxvirus A3L', 'Poxvirus_A3L', 4, NULL),
(4022, NULL, 'IPR005155', NULL, 'UPF0113, PUA domain', 'UPF0113_PUA', 3, NULL),
(4023, NULL, 'IPR001911', NULL, 'Ribosomal protein S21', 'Ribosomal_S21', 4, NULL),
(4024, NULL, 'IPR007949', NULL, 'SDA1 domain', 'SDA1_dom', 3, NULL),
(4025, NULL, 'IPR003195', NULL, 'Transcription initiation factor IID, subunit 13', 'TFIID_TAF13', 4, NULL),
(4026, NULL, 'IPR000655', NULL, 'Regulatory protein cro', 'Cro', 4, NULL),
(4027, NULL, 'IPR005260', NULL, 'Aspartate kinase, monofunctional class', 'Asp_kin_monofn', 4, NULL),
(4028, NULL, 'IPR003317', NULL, 'Cytochrome ubiquinol oxidase subunit 2', 'Cyt-d_oxidase_su2', 4, NULL),
(4029, NULL, 'IPR010210', NULL, '2-amino-3,7-dideoxy-D-threo-hept-6-ulosonate synthase', 'ADH_synthase', 4, NULL),
(4030, NULL, 'IPR010194', NULL, 'Anti-sigma F factor', 'Anti-sigma_F', 4, NULL),
(4031, NULL, 'IPR005275', NULL, 'L-fucose-proton symporter FucP', 'Lfuc_symporter_FucP', 4, NULL),
(4032, NULL, 'IPR004812', NULL, 'Drug resistance transporter Bcr/CmlA subfamily', 'Efflux_drug-R_Bcr/CmlA', 4, NULL),
(4033, NULL, 'IPR004826', NULL, 'Basic leucine zipper domain, Maf-type', 'bZIP_Maf', 3, NULL),
(4034, NULL, 'IPR007974', NULL, 'Tenuivirus movement protein', 'Tenui_movmnt_prot', 4, NULL),
(4035, NULL, 'IPR010231', NULL, 'SUF system FeS cluster assembly, SufB', 'SUF_FeS_clus_asmbl_SufB', 4, NULL),
(4036, NULL, 'IPR003889', NULL, 'FY-rich, C-terminal', 'FYrich_C', 3, NULL),
(4037, NULL, 'IPR004823', NULL, 'TATA box binding protein associated factor (TAF), histone-like fold domain', 'TAF_TATA-bd_Histone-like_dom', 3, NULL),
(4038, NULL, 'IPR007972', NULL, 'Mitochondrial fission regulator 1', 'Mtfr1', 4, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(4039, NULL, 'IPR001131', NULL, 'Peptidase M24B, X-Pro dipeptidase/aminopeptidase P, conserved site', 'Peptidase_M24B_aminopep-P_CS', 2, NULL),
(4040, NULL, 'IPR000751', NULL, 'M-phase inducer phosphatase', 'MPI_Phosphatase', 4, NULL),
(4041, NULL, 'IPR001818', NULL, 'Peptidase M10, metallopeptidase', 'Pept_M10_metallopeptidase', 3, NULL),
(4042, NULL, 'IPR005273', NULL, 'Uracil-DNA glycosylase family 4', 'Ura-DNA_glyco_family4', 3, NULL),
(4043, NULL, 'IPR001841', NULL, 'Zinc finger, RING-type', 'Znf_RING', 3, NULL),
(4044, NULL, 'IPR003382', NULL, 'Flavoprotein', 'Flavoprotein', 3, NULL),
(4045, NULL, 'IPR004841', NULL, 'Amino acid permease/ SLC12A domain', 'AA-permease/SLC12A_dom', 3, NULL),
(4046, NULL, 'IPR010181', NULL, 'CGCAxxGCC motif', 'CGCAxxGCC_motif', 4, NULL),
(4047, NULL, 'IPR001888', NULL, 'Transposase, type 1', 'Transposase_1', 4, NULL),
(4048, NULL, 'IPR003326', NULL, 'TRA-1 regulated', 'TRA-1_regulated', 4, NULL),
(4049, NULL, 'IPR010176', NULL, 'CxxxxCH...CXXCH motif, Geobacter sulfurreducens', 'C4xCH_C2xCH_motif_GEOSU', 7, NULL),
(4050, NULL, 'IPR003381', NULL, 'Shutoff protein L4', 'L4', 4, NULL),
(4051, NULL, 'IPR001506', NULL, 'Peptidase M12A', 'Peptidase_M12A', 3, NULL),
(4052, NULL, 'IPR007980', NULL, 'Ribosomal protein VAR1', 'Ribosomal_VAR1', 4, NULL),
(4053, NULL, 'IPR004830', NULL, 'Leucine rich repeat variant', 'LRR_variant', 7, NULL),
(4054, NULL, 'IPR003314', NULL, 'Mu-type HTH domain', 'Mu-type_HTH', 3, NULL),
(4055, NULL, 'IPR007951', NULL, 'Keratin-associated protein, PMG type', 'KRTAP_PMG', 4, NULL),
(4056, NULL, 'IPR000117', NULL, 'Kappa casein', 'Casein_kappa', 4, NULL),
(4057, NULL, 'IPR005146', NULL, 'B3/B4 tRNA-binding domain', 'B3/B4_tRNA-bd', 3, NULL),
(4058, NULL, 'IPR003344', NULL, 'Big-1 (bacterial Ig-like domain 1) domain', 'Big_1_dom', 3, NULL),
(4059, NULL, 'IPR001865', NULL, 'Ribosomal protein S2', 'Ribosomal_S2', 4, NULL),
(4060, NULL, 'IPR003893', NULL, 'Iroquois-class homeodomain protein', 'Iroquois_homeo', 3, NULL),
(4061, NULL, 'IPR003383', NULL, 'Circovirus capsid protein', 'Circovirus_capsid', 4, NULL),
(4062, NULL, 'IPR001956', NULL, 'Carbohydrate-binding module 3', 'CBM3', 3, NULL),
(4063, NULL, 'IPR010218', NULL, 'NADH dehydrogenase, subunit C', 'NADH_DH_suC', 4, NULL),
(4064, NULL, 'IPR010212', NULL, 'Probable transcription termination protein NusA, archaeal', 'NusA_arc', 4, NULL),
(4065, NULL, 'IPR000775', NULL, 'Bindin', 'Bindin', 4, NULL),
(4066, NULL, 'IPR005259', NULL, 'Primosomal protein N''', 'PriA', 4, NULL),
(4067, NULL, 'IPR000959', NULL, 'POLO box domain', 'POLO_box_dom', 3, NULL),
(4068, NULL, 'IPR034174', NULL, 'SHARP, RNA recognition motif 3', 'SHARP_RRM3', 3, NULL),
(4069, NULL, 'IPR001885', NULL, 'Lipoxygenase, mammalian', 'LipOase_mml', 4, NULL),
(4070, NULL, 'IPR003875', NULL, 'Paramyxoviridae nonstructural protein C', 'Paramyxovir_NSC', 4, NULL),
(4071, NULL, 'IPR010182', NULL, 'N-formyl-4-amino-5-aminomethyl-2-methylpyrimidine deformylase/Succinyl-diaminopimelate desuccinylase', 'ArgE/DapE', 4, NULL),
(4072, NULL, 'IPR010214', NULL, 'Transcription termination factor NusA, C-terminal duplication', 'Tscrpt_termin_fac_NusA_C_rpt', 7, NULL),
(4073, NULL, 'IPR003903', NULL, 'Ubiquitin interacting motif', 'UIM_dom', 2, NULL),
(4074, NULL, 'IPR003894', NULL, 'TAFH/NHR1', 'TAFH_NHR1', 3, NULL),
(4075, NULL, 'IPR008001', NULL, 'Macrophage colony stimulating factor-1', 'MCSF-1', 4, NULL),
(4076, NULL, 'IPR003338', NULL, 'CDC48, N-terminal subdomain', 'CDC4_N-term_subdom', 3, NULL),
(4077, NULL, 'IPR034574', NULL, 'Succinate dehydrogenase subunit 6, mitochondrial', 'SDH6', 4, NULL),
(4078, NULL, 'IPR001830', NULL, 'Glycosyl transferase, family 20', 'Glyco_trans_20', 4, NULL),
(4079, NULL, 'IPR005160', NULL, 'Ku70/Ku80 C-terminal arm', 'Ku_C', 3, NULL),
(4080, NULL, 'IPR001954', NULL, 'Gliadin/LMW glutenin', 'Glia_glutenin', 4, NULL),
(4081, NULL, 'IPR005153', NULL, 'MbtH-like domain', 'MbtH-like_dom', 3, NULL),
(4082, NULL, 'IPR010230', NULL, 'FeS cluster assembly SUF system, ATPase SufC', 'FeS-cluster_ATPase_SufC', 4, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(4083, NULL, 'IPR010196', NULL, 'o-Succinylbenzoate synthase, MenC type1', 'OSB_synthase_MenC1', 4, NULL),
(4084, NULL, 'IPR007995', NULL, 'Protein of unknown function DUF742', 'DUF742', 4, NULL),
(4085, NULL, 'IPR004825', NULL, 'Insulin', 'Insulin', 4, NULL),
(4086, NULL, 'IPR003334', NULL, 'GPCR, family 2, latrophilin, C-terminal', 'GPCR_2_latrophilin_rcpt_C', 3, NULL),
(4087, NULL, 'IPR007943', NULL, 'Aspartyl beta-hydroxylase/Triadin domain', 'Asp-B-hydro/Triadin_dom', 3, NULL),
(4088, NULL, 'IPR001863', NULL, 'Glypican', 'Glypican', 4, NULL),
(4089, NULL, 'IPR003901', NULL, 'Methyl-coenzyme M reductase, protein D', 'Me_CoM_Rdtase_D', 4, NULL),
(4090, NULL, 'IPR001807', NULL, 'Chloride channel, voltage gated', 'Cl-channel_volt-gated', 4, NULL),
(4091, NULL, 'IPR010178', NULL, 'Integral membrane protein 1906', 'Integral_membrane_1906', 4, NULL),
(4092, NULL, 'IPR001944', NULL, 'Glycoside hydrolase, family 35', 'Glycoside_Hdrlase_35', 4, NULL),
(4093, NULL, 'IPR003356', NULL, 'DNA methylase, adenine-specific', 'DNA_methylase_A-5', 3, NULL),
(4094, NULL, 'IPR003416', NULL, 'MgtC/SapB/SrpB/YhiD family', 'MgtC/SapB/SrpB/YhiD_fam', 4, NULL),
(4095, NULL, 'IPR001977', NULL, 'Dephospho-CoA kinase', 'Depp_CoAkinase', 4, NULL),
(4096, NULL, 'IPR007991', NULL, 'RNA polymerase I specific transcription initiation factor RRN3', 'RNA_pol_I_trans_ini_fac_RRN3', 4, NULL),
(4097, NULL, 'IPR002759', NULL, 'RNase P subunit Pop5/Rpp14/Rnp2-like', 'Pop5/Rpp14/Rnp2-like', 4, NULL),
(4098, NULL, 'IPR005263', NULL, '4-hydroxy-tetrahydrodipicolinate synthase, DapA', 'DapA', 4, NULL),
(4099, NULL, 'IPR007988', NULL, 'Sperm-associated antigen 11 A/B', 'Sperm_Ag_11A_B', 4, NULL),
(4100, NULL, 'IPR003890', NULL, 'MIF4G-like, type 3', 'MIF4G-like_typ-3', 3, NULL),
(4101, NULL, 'IPR010228', NULL, 'NADH:ubiquinone oxidoreductase, subunit G', 'NADH_UbQ_OxRdtase_Gsu', 4, NULL),
(4102, NULL, 'IPR001102', NULL, 'Transglutaminase, N-terminal', 'Transglutaminase_N', 3, NULL),
(4103, NULL, 'IPR001919', NULL, 'Carbohydrate-binding type-2 domain', 'CBD2', 3, NULL),
(4104, NULL, 'IPR001857', NULL, 'Ribosomal protein L19', 'Ribosomal_L19', 4, NULL),
(4105, NULL, 'IPR003388', NULL, 'Reticulon', 'Reticulon', 3, NULL),
(4106, NULL, 'IPR000907', NULL, 'Lipoxygenase', 'LipOase', 4, NULL),
(4107, NULL, 'IPR003883', NULL, 'Repetitive proline-rich cell wall protein repeat', 'Pro_rich_cell_wall_rpt', 7, NULL),
(4108, NULL, 'IPR001867', NULL, 'OmpR/PhoB-type DNA-binding domain', 'OmpR/PhoB-type_DNA-bd', 3, NULL),
(4109, NULL, 'IPR001912', NULL, 'Ribosomal protein S4/S9, N-terminal', 'Ribosomal_S4/S9_N', 3, NULL),
(4110, NULL, 'IPR005266', NULL, 'Uncharacterised protein family UPF0128', 'UPF0128', 4, NULL),
(4111, NULL, 'IPR001930', NULL, 'Peptidase M1, alanine aminopeptidase/leukotriene A4 hydrolase', 'Peptidase_M1', 4, NULL),
(4112, NULL, 'IPR005152', NULL, 'Lipase, secreted', 'Lipase_secreted', 4, NULL),
(4113, NULL, 'IPR001879', NULL, 'GPCR, family 2, extracellular hormone receptor domain', 'GPCR_2_extracellular_dom', 3, NULL),
(4114, NULL, 'IPR004828', NULL, 'Apidaecin', 'Apidaecin', 7, NULL),
(4115, NULL, 'IPR003887', NULL, 'LEM domain', 'LEM_dom', 3, NULL),
(4116, NULL, 'IPR001844', NULL, 'Chaperonin Cpn60/GroEL', 'Cpn60/GroEL', 4, NULL),
(4117, NULL, 'IPR005282', NULL, 'Lysosomal cystine transporter', 'LC_transporter', 4, NULL),
(4118, NULL, 'IPR005150', NULL, 'Cellulose synthase', 'Cellulose_synth', 4, NULL),
(4119, NULL, 'IPR007970', NULL, 'Protein of unknown function DUF733', 'DUF733', 4, NULL),
(4120, NULL, 'IPR004809', NULL, 'Glutamine synthetase type I', 'Gln_synth_I', 4, NULL),
(4121, NULL, 'IPR001087', NULL, 'GDSL lipase/esterase', 'GDSL', 4, NULL),
(4122, NULL, 'IPR001859', NULL, 'Trypanosoma cruzi ribosomal protein P2-like', 'T.cruzi_P2-like', 4, NULL),
(4123, NULL, 'IPR002761', NULL, 'Diphthamide synthase domain', 'Diphthami_syn_dom', 3, NULL),
(4124, NULL, 'IPR000653', NULL, 'DegT/DnrJ/EryC1/StrS aminotransferase', 'DegT/StrS_aminotransferase', 4, NULL),
(4125, NULL, 'IPR005154', NULL, 'Alpha glucuronidase, N-terminal', 'Glyco_hydro_67_aGlcAse_N', 3, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(4126, NULL, 'IPR010236', NULL, 'ISC system FeS cluster assembly, HscA chaperone', 'ISC_FeS_clus_asmbl_HscA', 4, NULL),
(4127, NULL, 'IPR007944', NULL, 'Flagellar transcriptional activator FlhC', 'FlhC', 4, NULL),
(4128, NULL, 'IPR003316', NULL, 'E2F/DP family, winged-helix DNA-binding domain', 'E2F_WHTH_DNA-bd_dom', 3, NULL),
(4129, NULL, 'IPR034482', NULL, 'Mrd1, RNA recognition motif 3', 'Mrd1_RRM3', 3, NULL),
(4130, NULL, 'IPR003340', NULL, 'B3 DNA binding domain', 'B3_DNA-bd', 3, NULL),
(4131, NULL, 'IPR005271', NULL, 'Carboxy-S-adenosyl-L-methionine synthase', 'CmoA', 4, NULL),
(4132, NULL, 'IPR001851', NULL, 'ABC transporter, permease', 'ABC_transp_permease', 4, NULL),
(4133, NULL, 'IPR034050', NULL, 'Tumor necrosis factor receptor 25, N-terminal', 'TNFRSF25_N', 3, NULL),
(4134, NULL, 'IPR010205', NULL, 'Na(+)-translocating NADH-quinone reductase subunit F', 'NqrF', 4, NULL),
(4135, NULL, 'IPR003872', NULL, 'Major outer sheath protein, C-terminal', 'MOSP_C', 3, NULL),
(4136, NULL, 'IPR001922', NULL, 'Dopamine D2 receptor', 'Dopamine_D2_rcpt', 4, NULL),
(4137, NULL, 'IPR004813', NULL, 'Oligopeptide transporter, OPT superfamily', 'OPT', 4, NULL),
(4138, NULL, 'IPR007982', NULL, 'Tombusvirus movement', 'Tombusvirus_movement', 4, NULL),
(4139, NULL, 'IPR010235', NULL, 'Probable ribonuclease HepT', 'HepT', 4, NULL),
(4140, NULL, 'IPR007953', NULL, 'Holin-like, BlyB', 'Holin-like_BlyB', 4, NULL),
(4141, NULL, 'IPR001864', NULL, 'Trypanothione reductase', 'Trypnth_redctse', 4, NULL),
(4142, NULL, 'IPR004837', NULL, 'Sodium/calcium exchanger membrane region', 'NaCa_Exmemb', 3, NULL),
(4143, NULL, 'IPR001852', NULL, 'Pyridoxal 5''-phosphate synthase subunit PdxS/SNZ', 'PdxS/SNZ', 4, NULL),
(4144, NULL, 'IPR010220', NULL, 'CO2 hydration', 'CO2_hydration', 4, NULL),
(4145, NULL, 'IPR004274', NULL, 'FCP1 homology domain', 'FCP1_dom', 3, NULL),
(4146, NULL, 'IPR000650', NULL, 'Geminivirus AR1 coat protein', 'Gem_coat_AR1', 4, NULL),
(4147, NULL, 'IPR000312', NULL, 'Glycosyl transferase, family 3', 'Glycosyl_Trfase_fam3', 3, NULL),
(4148, NULL, 'IPR005256', NULL, 'Anthranilate synthase component I, PabB-like', 'Anth_synth_I_PabB', 4, NULL),
(4149, NULL, 'IPR003318', NULL, 'Glycoside hydrolase, family 70, catalytic domain', 'Glyco_hydro70cat', 3, NULL),
(4150, NULL, 'IPR003322', NULL, 'Beta-retroviral matrix protein', 'B_retro_matrix', 3, NULL),
(4151, NULL, 'IPR003327', NULL, 'Leucine zipper, Myc', 'Myc-LZ', 3, NULL),
(4152, NULL, 'IPR005293', NULL, 'Antigen peptide transporter 2', 'Tap2/ABCB3', 4, NULL),
(4153, NULL, 'IPR000395', NULL, 'Botulinum/Tetanus toxin, catalytic chain', 'Bot/tetX_LC', 3, NULL),
(4154, NULL, 'IPR010217', NULL, 'NAD(P)H-quinone oxidoreductase subunit 5, organellar chromatophore 2', 'NU5C2', 4, NULL),
(4155, NULL, 'IPR010193', NULL, 'Serine-protein kinase RsbW', 'RsbW', 4, NULL),
(4156, NULL, 'IPR004811', NULL, 'RelA/SpoT family', 'RelA/Spo_fam', 4, NULL),
(4157, NULL, 'IPR003387', NULL, 'Nodulin', 'Nodulin', 4, NULL),
(4158, NULL, 'IPR004808', NULL, 'AP endonuclease 1', 'AP_endonuc_1', 4, NULL),
(4159, NULL, 'IPR000762', NULL, 'Midkine heparin-binding growth factor', 'Midkine_heparin-bd_GF', 4, NULL),
(4160, NULL, 'IPR005294', NULL, 'ATP synthase, F1 complex, alpha subunit', 'ATP_synth_F1_asu', 4, NULL),
(4161, NULL, 'IPR007930', NULL, 'Protein of unknown function DUF724', 'DUF724', 4, NULL),
(4162, NULL, 'IPR001872', NULL, 'Peptidase A8, signal peptidase II', 'Peptidase_A8', 4, NULL),
(4163, NULL, 'IPR003376', NULL, 'Peridinin-chlorophyll A binding protein', 'Peridinin-chlorophyll-bd_prot', 4, NULL),
(4164, NULL, 'IPR010213', NULL, 'Transcription termination factor NusA', 'Tscrpt_termination_fac_NusA', 3, NULL),
(4165, NULL, 'IPR001923', NULL, 'Prostanoid EP2 receptor', 'Prostglndn_EP2_rcpt', 4, NULL),
(4166, NULL, 'IPR034366', NULL, 'Protein xmas, RNA recognition motif', 'XMAS_RRM', 3, NULL),
(4167, NULL, 'IPR005290', NULL, 'Ribosomal protein S15, bacterial-type', 'Ribosomal_S15_bac-type', 4, NULL),
(4168, NULL, 'IPR003390', NULL, 'DNA integrity scanning protein, DisA, N-terminal', 'DNA_integrity_scan_DisA_N', 3, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(4169, NULL, 'IPR003359', NULL, 'Photosystem I Ycf4, assembly', 'PSI_Ycf4_assembly', 4, NULL),
(4170, NULL, 'IPR010204', NULL, 'Na(+)-translocating NADH-quinone reductase subunit C', 'NqrC', 4, NULL),
(4171, NULL, 'IPR004836', NULL, 'Sodium/calcium exchanger protein', 'Na_Ca_Ex', 4, NULL),
(4172, NULL, 'IPR003365', NULL, 'Viral replication-associated protein, N-terminal', 'Viral_rep_N', 3, NULL),
(4173, NULL, 'IPR001826', NULL, 'RHS protein', 'RHS', 4, NULL),
(4174, NULL, 'IPR001928', NULL, 'Endothelin-like toxin', 'Endothln-like_toxin', 3, NULL),
(4175, NULL, 'IPR010211', NULL, 'Redox-sensitive transcriptional activator SoxR', 'Redox-sen_tscrpt-act_SoxR', 4, NULL),
(4176, NULL, 'IPR007979', NULL, 'Type II restriction enzyme NlaIII/ICEA1', 'NlaIII/ICEA1', 4, NULL),
(4177, NULL, 'IPR007998', NULL, 'Protein of unknown function DUF719', 'DUF719', 4, NULL),
(4178, NULL, 'IPR002760', NULL, 'Putative O-antigen polymerase', 'O_anti_polymase', 4, NULL),
(4179, NULL, 'IPR001788', NULL, 'Tymovirus, RNA-dependent RNA polymerase', 'Tymovirus_RNA-dep_RNA_pol', 3, NULL),
(4180, NULL, 'IPR010191', NULL, 'IMP cyclohydrolase', 'IMP_cyclohydrolase', 4, NULL),
(4181, NULL, 'IPR007945', NULL, 'Neuroendocrine 7B2 precursor', 'Secretogranin_V', 4, NULL),
(4182, NULL, 'IPR024641', NULL, 'Hepatocyte growth factor-regulated tyrosine kinase substrate, helical domain', 'HRS_helical', 3, NULL),
(4183, NULL, 'IPR003892', NULL, 'Ubiquitin system component CUE', 'CUE', 3, NULL),
(4184, NULL, 'IPR007966', NULL, 'Protein of unknown function DUF720', 'DUF720', 4, NULL),
(4185, NULL, 'IPR001850', NULL, 'Flavivirus NS3, petidase S7', 'Flavivirus_NS3_S7', 3, NULL),
(4186, NULL, 'IPR010203', NULL, 'Regulator of ribonuclease activity A', 'RraA', 4, NULL),
(4187, NULL, 'IPR007973', NULL, 'Pilus assembly TraE', 'Pilus_assembly_TraE', 4, NULL),
(4188, NULL, 'IPR001805', NULL, 'Adenosine kinase', 'Adenokinase', 4, NULL),
(4189, NULL, 'IPR007931', NULL, 'Protein TsetseEP', 'TsetseEP', 3, NULL),
(4190, NULL, 'IPR004843', NULL, 'Calcineurin-like phosphoesterase domain, ApaH type', 'Calcineurin-like_PHP_ApaH', 3, NULL),
(4191, NULL, 'IPR005145', NULL, 'Threonylcarbamoyl-AMP synthase, C-terminal domain', 'Sua5_C', 3, NULL),
(4192, NULL, 'IPR003379', NULL, 'Carboxylase, conserved domain', 'Carboxylase_cons_dom', 3, NULL),
(4193, NULL, 'IPR005143', NULL, 'Transcription factor LuxR-like, autoinducer-binding domain', 'TF_LuxR_autoind-bd_dom', 3, NULL),
(4194, NULL, 'IPR008000', NULL, 'Rhamnose/fucose mutarotase', 'Rham/fucose_mutarotase', 4, NULL),
(4195, NULL, 'IPR003369', NULL, 'Sec-independent protein translocase protein TatA/B/E', 'TatA/B/E', 4, NULL),
(4196, NULL, 'IPR010188', NULL, 'HisA/PriA, Actinobacteria', 'HisA/PriA_Actinobacteria', 4, NULL),
(4197, NULL, 'IPR006866', NULL, 'Domain of unknown function DUF627, N-terminal', 'DUF627_N', 3, NULL),
(4198, NULL, 'IPR001829', NULL, 'Pili assembly chaperone, bacterial', 'Pili_assmbl_chaperone_bac', 4, NULL),
(4199, NULL, 'IPR003343', NULL, 'Bacterial Ig-like domain, group 2', 'Big_2', 3, NULL),
(4200, NULL, 'IPR001839', NULL, 'Transforming growth factor-beta, C-terminal', 'TGF-b_C', 3, NULL),
(4201, NULL, 'IPR005265', NULL, 'Protoporphyrinogen oxidase HemJ-like', 'HemJ-like', 4, NULL),
(4202, NULL, 'IPR007955', NULL, 'Bystin', 'Bystin', 4, NULL),
(4203, NULL, 'IPR001920', NULL, 'Asp/Glu racemase', 'Asp/Glu_race', 5, NULL),
(4204, NULL, 'IPR007968', NULL, 'Tobacco rattle virus, 16 kDa protein', 'Tobacco_rattle_virus_16kDa', 4, NULL),
(4205, NULL, 'IPR001873', NULL, 'Epithelial sodium channel', 'ENaC', 4, NULL),
(4206, NULL, 'IPR010222', NULL, 'RNA helicase HrpA', 'RNA_helicase_HrpA', 4, NULL),
(4207, NULL, 'IPR008002', NULL, 'Herpesvirus, Orf30', 'Herpes_Orf30', 4, NULL),
(4208, NULL, 'IPR005272', NULL, 'Conserved hypothetical protein CHP00743', 'CHP00743', 4, NULL),
(4209, NULL, 'IPR007967', NULL, 'GSKIP domain', 'GSKIP_dom', 3, NULL),
(4210, NULL, 'IPR001903', NULL, 'Rhabdovirus  glycoprotein', 'Rhabd_glycop', 4, NULL),
(4211, NULL, 'IPR003368', NULL, 'Polymorphic outer membrane protein repeat', 'POMP_repeat', 7, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(4212, NULL, 'IPR002102', NULL, 'Cellulosome anchoring protein, cohesin domain', 'Cohesin_dom', 3, NULL),
(4213, NULL, 'IPR000256', NULL, 'Influenza A virus NS1 protein', 'NS1A', 4, NULL),
(4214, NULL, 'IPR007963', NULL, 'Peptidase M61, catalytic domain', 'Peptidase_M61_catalytic', 3, NULL),
(4215, NULL, 'IPR016013', NULL, 'Binary exotoxin A, clostridial type', 'Binary_toxinA_clost-typ', 4, NULL),
(4216, NULL, 'IPR007990', NULL, 'Prolactin-inducible protein', 'PIP', 4, NULL),
(4217, NULL, 'IPR001030', NULL, 'Aconitase/3-isopropylmalate dehydratase large subunit, alpha/beta/alpha domain', 'Acoase/IPM_deHydtase_lsu_aba', 3, NULL),
(4218, NULL, 'IPR034175', NULL, 'SHARP, RNA recognition motif 4', 'SHARP_RRM4', 3, NULL),
(4219, NULL, 'IPR001884', NULL, 'Translation elongation factor IF5A-like', 'IF5A-like', 4, NULL),
(4220, NULL, 'IPR006463', NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase MiaB', 'MiaB_methiolase', 4, NULL),
(4221, NULL, 'IPR001946', NULL, 'Alpha 2A adrenoceptor', 'ADRA2A_rcpt', 4, NULL),
(4222, NULL, 'IPR001858', NULL, 'Phosphatidylethanolamine-binding, conserved site', 'Phosphatidylethanolamine-bd_CS', 2, NULL),
(4223, NULL, 'IPR005144', NULL, 'ATP-cone domain', 'ATP-cone_dom', 3, NULL),
(4224, NULL, 'IPR003902', NULL, 'Transcription regulator GCM domain', 'Tscrpt_reg_GCM', 3, NULL),
(4225, NULL, 'IPR003378', NULL, 'Fringe-like', 'Fringe-like', 4, NULL),
(4226, NULL, 'IPR005148', NULL, 'Arginyl tRNA synthetase N-terminal domain', 'Arg-tRNA-synth_N', 3, NULL),
(4227, NULL, 'IPR000646', NULL, 'Pre-hexon-linking protein VIII', 'Adeno_PVIII', 4, NULL),
(4228, NULL, 'IPR007946', NULL, 'A1 cistron-splicing factor, AAR2', 'AAR2', 4, NULL),
(4229, NULL, 'IPR000560', NULL, 'Histidine phosphatase superfamily, clade-2', 'His_Pase_clade-2', 4, NULL),
(4230, NULL, 'IPR007981', NULL, 'Peptidase A5, thermopsin', 'Peptidase_A5', 4, NULL),
(4231, NULL, 'IPR007962', NULL, 'Bombinin', 'Bombinin', 4, NULL),
(4232, NULL, 'IPR001889', NULL, 'Herpesvirus thymidine kinase', 'Herpes_TK', 4, NULL),
(4233, NULL, 'IPR005151', NULL, 'Tail specific protease', 'Tail-specific_protease', 3, NULL),
(4234, NULL, 'IPR004806', NULL, 'UV excision repair protein Rad23', 'Rad23', 4, NULL),
(4235, NULL, 'IPR007934', NULL, 'Alpha-L-arabinofuranosidase B, arabinose-binding domain', 'AbfB_ABD', 3, NULL),
(4236, NULL, 'IPR007938', NULL, 'Baculovirus occlusion-derived virus envelope, E25', 'Baculo_ODV-E25', 4, NULL),
(4237, NULL, 'IPR001819', NULL, 'Chromogranin A/B', 'Chromogranin_AB', 4, NULL),
(4238, NULL, 'IPR003354', NULL, 'Small/middle T-antigen', 'Papo_T_antigen', 3, NULL),
(4239, NULL, 'IPR003873', NULL, 'Envelope small membrane protein, coronavirus', 'E_protein_CoV', 4, NULL),
(4240, NULL, 'IPR010199', NULL, 'Sulphite reductase [NADPH] flavoprotein, alpha chain', 'CysJ', 4, NULL),
(4241, NULL, 'IPR010186', NULL, 'Glycine reductase, selenoprotein B', 'Gly_red_sel_B', 4, NULL),
(4242, NULL, 'IPR010216', NULL, 'Transcription antitermination protein, NusG, mycoplasmataceae', 'Transcrpt_antiterm_NusG_myco', 4, NULL),
(4243, NULL, 'IPR010226', NULL, 'NADH-quinone oxidoreductase, chain I', 'NADH_quinone_OxRdtase_chainI', 4, NULL),
(4244, NULL, 'IPR000648', NULL, 'Oxysterol-binding protein', 'Oxysterol-bd', 4, NULL),
(4245, NULL, 'IPR000290', NULL, 'Colicin immunity protein/pyocin immunity protein', 'Colicin_pyocin', 4, NULL),
(4246, NULL, 'IPR004845', NULL, 'Type II secretion system protein GspD, conserved site', 'T2SS_GspD_CS', 2, NULL),
(4247, NULL, 'IPR001887', NULL, 'Barnase', 'Barnase', 4, NULL),
(4248, NULL, 'IPR006865', NULL, 'Domain of unknown function DUF629', 'DUF629', 3, NULL),
(4249, NULL, 'IPR004171', NULL, 'cAMP-dependent protein kinase inhibitor', 'cAMP_dep_PKI', 4, NULL),
(4250, NULL, 'IPR010179', NULL, 'CRISPR-associated protein Cse3', 'CRISPR-assoc_prot_Cse3', 4, NULL),
(4251, NULL, 'IPR001801', NULL, 'Histone-like protein H-NS', 'Histone_HNS', 4, NULL),
(4252, NULL, 'IPR001803', NULL, 'Orbivirus inner capsid protein VP7', 'Orbi_VP7_capsid', 4, NULL),
(4253, NULL, 'IPR001870', NULL, 'B30.2/SPRY domain', 'B30.2/SPRY', 3, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(4254, NULL, 'IPR001937', NULL, 'Galactose-1-phosphate uridyl transferase, class I', 'GalP_UDPtransf1', 4, NULL),
(4255, NULL, 'IPR007929', NULL, 'Protein of unknown function DUF723', 'DUF723', 4, NULL),
(4256, NULL, 'IPR010185', NULL, 'NADPH-dependent F420 reductase', 'NpdG', 4, NULL),
(4257, NULL, 'IPR003869', NULL, 'Polysaccharide biosynthesis protein, CapD-like domain', 'Polysac_CapD-like', 3, NULL),
(4258, NULL, 'IPR005280', NULL, 'Homoserine kinase, type II', 'Homoserine_kinase_II', 4, NULL),
(4259, NULL, 'IPR000413', NULL, 'Integrin alpha chain', 'Integrin_alpha', 4, NULL),
(4260, NULL, 'IPR001925', NULL, 'Porin, eukaryotic type', 'Porin_Euk', 4, NULL),
(4261, NULL, 'IPR001910', NULL, 'Inosine/uridine-preferring nucleoside hydrolase domain', 'Inosine/uridine_hydrolase_dom', 3, NULL),
(4262, NULL, 'IPR007957', NULL, 'African swine fever virus L11L', 'ASFV_L11L', 4, NULL),
(4263, NULL, 'IPR004817', NULL, 'Sodium/potassium/calcium exchanger 1', 'SLC24A1', 4, NULL),
(4264, NULL, 'IPR001848', NULL, 'Ribosomal protein S10', 'Ribosomal_S10', 4, NULL),
(4265, NULL, 'IPR000596', NULL, 'Cholecystokinin receptor type A', 'Cholcy_rcpt_A', 4, NULL),
(4266, NULL, 'IPR004842', NULL, 'SLC12A transporter family', 'SLC12A_fam', 4, NULL),
(4267, NULL, 'IPR003384', NULL, 'Hepatitis E virus Orf2, capsid', 'HEV_Orf2', 4, NULL),
(4268, NULL, 'IPR004840', NULL, 'Amino acid permease, conserved site', 'Amoino_acid_permease_CS', 2, NULL),
(4269, NULL, 'IPR017958', NULL, 'Glutamyl-tRNA(Gln) amidotransferase, subunit B, conserved site', 'Gln-tRNA_amidoTrfase_suB_CS', 2, NULL),
(4270, NULL, 'IPR007932', NULL, 'Receptor-recognising protein Gp38', 'Receptor-recog_Gp38', 4, NULL),
(4271, NULL, 'IPR003362', NULL, 'Bacterial sugar transferase', 'Bact_transf', 3, NULL),
(4272, NULL, 'IPR003342', NULL, 'Glycosyl transferase family 39/83', 'Glyco_trans_39/83', 3, NULL),
(4273, NULL, 'IPR003329', NULL, 'Acylneuraminate cytidylyltransferase', 'Cytidylyl_trans', 4, NULL),
(4274, NULL, 'IPR010198', NULL, '1,4-Dihydroxy-2-naphthoyl-CoA synthase, MenB', 'DHNA-CoA_synthase_MenB', 4, NULL),
(4275, NULL, 'IPR001950', NULL, 'SUI1 domain', 'SUI1', 3, NULL),
(4276, NULL, 'IPR005288', NULL, 'L-aspartate oxidase', 'NadB', 4, NULL),
(4277, NULL, 'IPR010190', NULL, 'Diaminopimelate dehydrogenase, Ddh', 'Diaminopimelate_DH_Ddh', 4, NULL),
(4278, NULL, 'IPR010197', NULL, 'o-Succinylbenzoate synthase, MenC type 2', 'OSB_synthase_MenC_2', 4, NULL),
(4279, NULL, 'IPR005286', NULL, 'Cell division protein  FtsE, ATP-binding', 'Cell_div_FtsE_ATP-bd', 4, NULL),
(4280, NULL, 'IPR001787', NULL, 'Ribosomal protein L21', 'Ribosomal_L21', 4, NULL),
(4281, NULL, 'IPR010225', NULL, 'ATP-dependent helicase HrpB', 'HrpB', 4, NULL),
(4282, NULL, 'IPR004816', NULL, 'Hydroxymethylglutaryl-CoA reductase, metazoan', 'HMG_CoA_Rdtase_metazoan', 4, NULL),
(4283, NULL, 'IPR003346', NULL, 'Transposase, IS116/IS110/IS902', 'Transposase_20', 4, NULL),
(4284, NULL, 'IPR003325', NULL, 'TerD domain', 'TerD', 3, NULL),
(4285, NULL, 'IPR005147', NULL, 'tRNA synthetase, B5-domain', 'tRNA_synthase_B5-dom', 3, NULL),
(4286, NULL, 'IPR004558', NULL, 'Oxygen-independent coproporphyrinogen III oxidase HemN', 'Coprogen_oxidase_HemN', 4, NULL),
(4287, NULL, 'IPR007999', NULL, 'Protein of unknown function DUF745', 'DUF745', 4, NULL),
(4288, NULL, 'IPR003351', NULL, 'Dishevelled protein domain', 'Dishevelled_protein_dom', 3, NULL),
(4289, NULL, 'IPR007954', NULL, 'Baculovirus immediate-early', 'Baculo_IE-1', 4, NULL),
(4290, NULL, 'IPR003900', NULL, 'KID repeat', 'KID_repeat', 7, NULL),
(4291, NULL, 'IPR007438', NULL, 'Protein of unknown function DUF488', 'DUF488', 4, NULL),
(4292, NULL, 'IPR005161', NULL, 'Ku70/Ku80, N-terminal alpha/beta', 'Ku_N', 3, NULL),
(4293, NULL, 'IPR000501', NULL, 'Tripartite terminase subunit 1', 'UL28/UL56', 4, NULL),
(4294, NULL, 'IPR010180', NULL, 'CRISPR-associated protein, CXXC-CXXC', 'CRISPR-assoc_prot_CXXC-CXXC', 4, NULL),
(4295, NULL, 'IPR002762', NULL, 'Sirohydrochlorin cobaltochelatase CbiX-like', 'CbiX-like', 4, NULL),
(4296, NULL, 'IPR001855', NULL, 'Beta defensin type', 'Defensin_beta-typ', 4, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(4297, NULL, 'IPR000259', NULL, 'Fimbrial-type adhesion domain', 'Adhesion_dom_fimbrial', 3, NULL),
(4298, NULL, 'IPR004807', NULL, 'UvrABC system, subunit B', 'UvrB', 4, NULL),
(4299, NULL, 'IPR003374', NULL, 'ApbE-like superfamily', 'ApbE-like_sf', 5, NULL),
(4300, NULL, 'IPR001835', NULL, 'Heat-labile enterotoxin, B chain', 'Enterotoxin_B', 4, NULL),
(4301, NULL, 'IPR007959', NULL, 'Dinoflagellate luciferase, N-terminal', 'Dino_Luciferase_N', 3, NULL),
(4302, NULL, 'IPR003331', NULL, 'UDP-N-acetylglucosamine 2-epimerase domain', 'UDP_GlcNAc_Epimerase_2_dom', 3, NULL),
(4303, NULL, 'IPR007937', NULL, 'RNA polymerase, 22kDa subunit, poxviral', 'RNA_Pol_22kDa_poxvir', 4, NULL),
(4304, NULL, 'IPR002792', NULL, 'TRAM domain', 'TRAM_dom', 3, NULL),
(4305, NULL, 'IPR001862', NULL, 'Membrane attack complex component/perforin/complement C9', 'MAC_perforin', 4, NULL),
(4306, NULL, 'IPR005281', NULL, 'Monovalent cation:proton antiporter, subunit B', 'CPA3_sub_B', 4, NULL),
(4307, NULL, 'IPR003879', NULL, 'Butyrophylin-like, SPRY domain', 'Butyrophylin_SPRY', 3, NULL),
(4308, NULL, 'IPR001866', NULL, 'Papillomavirus E2, N-terminal', 'PPV_E2_N', 3, NULL),
(4309, NULL, 'IPR000265', NULL, 'Prostanoid EP3 receptor', 'Prostglndn_EP3_rcpt', 4, NULL),
(4310, NULL, 'IPR001834', NULL, 'NADH:cytochrome b5 reductase-like', 'CBR-like', 4, NULL),
(4311, NULL, 'IPR000246', NULL, 'Peptidase T2, asparaginase 2', 'Peptidase_T2', 4, NULL),
(4312, NULL, 'IPR007947', NULL, 'CD164-related protein', 'CD164_MGC24', 4, NULL),
(4313, NULL, 'IPR003448', NULL, 'Molybdopterin biosynthesis MoaE', 'Mopterin_biosynth_MoaE', 4, NULL),
(4314, NULL, 'IPR003888', NULL, 'FY-rich, N-terminal', 'FYrich_N', 3, NULL),
(4315, NULL, 'IPR005268', NULL, 'Conserved hypothetical protein CHP00725', 'CHP00725', 4, NULL),
(4316, NULL, 'IPR004195', NULL, 'Head decoration protein D', 'Head_decoration_D', 4, NULL),
(4317, NULL, 'IPR007996', NULL, 'Vesivirus VP2', 'Vesivirus_VP2', 4, NULL),
(4318, NULL, 'IPR001869', NULL, 'Thiol-activated cytolysin', 'Thiol_cytolysin', 4, NULL),
(4319, NULL, 'IPR010192', NULL, '2-succinylbenzoate--CoA ligase', 'MenE', 4, NULL),
(4320, NULL, 'IPR003375', NULL, 'Photosystem I PsaE, reaction centre subunit IV', 'PSI_PsaE', 4, NULL),
(4321, NULL, 'IPR003330', NULL, 'Major surface glycoprotein MSG', 'MSG', 4, NULL),
(4322, NULL, 'IPR004835', NULL, 'Chitin synthase', 'Chitin_synth', 4, NULL),
(4323, NULL, 'IPR000512', NULL, 'Diphtheria toxin (NAD+-dipthamide ADP-ribosyltransferase)', 'Diphtheria_toxin', 4, NULL),
(4324, NULL, 'IPR010233', NULL, 'Ubiquinone biosynthesis O-methyltransferase', 'UbiG_MeTrfase', 4, NULL),
(4325, NULL, 'IPR001800', NULL, 'Lipoprotein, OspC-type', 'Lipoprotein_OspC', 4, NULL),
(4326, NULL, 'IPR001854', NULL, 'Ribosomal protein L29/L35', 'Ribosomal_L29/L35', 4, NULL),
(4327, NULL, 'IPR005279', NULL, 'Dipeptide/tripeptide permease', 'Dipep/tripep_permease', 4, NULL),
(4328, NULL, 'IPR007941', NULL, 'Protein of unknown function DUF726', 'DUF726', 4, NULL),
(4329, NULL, 'IPR005292', NULL, 'Multi drug resistance-associated protein', 'Multidrug-R_assoc', 4, NULL),
(4330, NULL, 'IPR001809', NULL, 'Outer surface lipoprotein, Borrelia', 'OM_lipoprot_Borrelia', 4, NULL),
(4331, NULL, 'IPR010195', NULL, 'Uncharacterised peroxidase-related', 'Uncharacterised_peroxidase-rel', 4, NULL),
(4332, NULL, 'IPR010234', NULL, 'Phasin, subfamily 2', 'Phasin_subfam-2', 4, NULL),
(4333, NULL, 'IPR010208', NULL, 'Ion-translocating oxidoreductase complex, subunit RnfC/RsxC', 'Ion_transpt_RnfC/RsxC', 4, NULL),
(4334, NULL, 'IPR005158', NULL, 'Bacterial transcriptional activator domain', 'BTAD', 3, NULL),
(4335, NULL, 'IPR000652', NULL, 'Triosephosphate isomerase', 'Triosephosphate_isomerase', 4, NULL),
(4336, NULL, 'IPR002818', NULL, 'DJ-1/PfpI', 'DJ-1/PfpI', 3, NULL),
(4337, NULL, 'IPR001916', NULL, 'Glycoside hydrolase, family 22', 'Glyco_hydro_22', 4, NULL),
(4338, NULL, 'IPR006864', NULL, 'LMP repeat', 'LMP_rpt', 7, NULL),
(4339, NULL, 'IPR010183', NULL, 'Bacteriophage lambda, Recombination protein bet', 'Phage_lambda_Bet', 4, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(4340, NULL, 'IPR023119', NULL, 'Multihaem cytochrome, PRC subunit superfamily', 'Multihaem_cyt_PRC_cyt_su-like', 5, NULL),
(4341, NULL, 'IPR001828', NULL, 'Receptor, ligand binding region', 'ANF_lig-bd_rcpt', 3, NULL),
(4342, NULL, 'IPR003874', NULL, 'CDC45 family', 'CDC45', 4, NULL),
(4343, NULL, 'IPR007960', NULL, 'Taste receptor type 2', 'TAS2R', 4, NULL),
(4344, NULL, 'IPR000626', NULL, 'Ubiquitin-like domain', 'Ubiquitin-like_dom', 3, NULL),
(4345, NULL, 'IPR003102', NULL, 'Coactivator CBP, pKID', 'Coactivator_CBP_pKID', 3, NULL),
(4346, NULL, 'IPR001909', NULL, 'Krueppel-associated box', 'KRAB', 3, NULL),
(4347, NULL, 'IPR007975', NULL, 'Baculovirus pp39', 'Baculo_pp39', 4, NULL),
(4348, NULL, 'IPR000916', NULL, 'Bet v I/Major latex protein', 'Bet_v_I/MLP', 3, NULL),
(4349, NULL, 'IPR000433', NULL, 'Zinc finger, ZZ-type', 'Znf_ZZ', 3, NULL),
(4350, NULL, 'IPR001881', NULL, 'EGF-like calcium-binding domain', 'EGF-like_Ca-bd_dom', 3, NULL),
(4351, NULL, 'IPR007971', NULL, 'Major structural subunit of bundle-forming pilus', 'Bundlin', 4, NULL),
(4352, NULL, 'IPR007978', NULL, 'Baculovirus occlusion-derived virus envelope EC27', 'Baculo_ODV-E27', 4, NULL),
(4353, NULL, 'IPR003389', NULL, 'Adenovirus packaging protein 1', 'Adeno_IVa2', 4, NULL),
(4354, NULL, 'IPR005287', NULL, 'Conserved hypothetical protein CHP00375', 'CHP00375', 4, NULL),
(4355, NULL, 'IPR001926', NULL, 'Tryptophan synthase beta chain-like, PALP domain', 'TrpB-like_PALP', 3, NULL),
(4356, NULL, 'IPR000542', NULL, 'Acyltransferase ChoActase/COT/CPT', 'Carn_acyl_trans', 4, NULL),
(4357, NULL, 'IPR007984', NULL, 'DNA-directed RNA polymerase, 19kDa subunit, poxviral', 'DNA-dir_RNA_Pol_19kDa_poxvir', 4, NULL),
(4358, NULL, 'IPR003899', NULL, 'Bordetella pertussis toxin B', 'ToxinB_BORPE', 4, NULL),
(4359, NULL, 'IPR001860', NULL, 'Glycoside hydrolase, family 34', 'Glyco_hydro_34', 4, NULL),
(4360, NULL, 'IPR001980', NULL, 'Phosphopantetheine adenylyltransferase', 'PPAT', 4, NULL),
(4361, NULL, 'IPR034573', NULL, 'Succinate dehydrogenase subunit 7, mitochondrial', 'SDH7', 4, NULL),
(4362, NULL, 'IPR007977', NULL, 'Poxvirus P21 membrane', 'Poxvirus_P21', 4, NULL),
(4363, NULL, 'IPR001921', NULL, 'Ribosomal protein L7A/L8', 'Ribosomal_L7A/L8', 4, NULL),
(4364, NULL, 'IPR001967', NULL, 'Peptidase S11, D-alanyl-D-alanine carboxypeptidase A, N-terminal', 'Peptidase_S11_N', 3, NULL),
(4365, NULL, 'IPR001795', NULL, 'RNA-directed RNA polymerase, luteovirus', 'RNA-dir_pol_luteovirus', 4, NULL),
(4366, NULL, 'IPR001837', NULL, 'Adenylate cyclase-associated CAP', 'Adenylate_cyclase-assoc_CAP', 4, NULL),
(4367, NULL, 'IPR005274', NULL, 'Inner membrane protein YhjD', 'IM_pro_YhjD', 4, NULL),
(4368, NULL, 'IPR007956', NULL, 'Malonyl-CoA decarboxylase, C-terminal', 'Malonyl_CoA_deC_C', 3, NULL),
(4369, NULL, 'IPR001893', NULL, 'Cysteine-rich Golgi apparatus protein 1 repeat', 'Cys-rich_GLG1_repeat', 7, NULL),
(4370, NULL, 'IPR004805', NULL, 'DNA polymerase III, alpha subunit', 'PolC_alpha', 4, NULL),
(4371, NULL, 'IPR001875', NULL, 'Death effector domain', 'DED_dom', 3, NULL),
(4372, NULL, 'IPR002758', NULL, 'Na+/H+ antiporter subunit E', 'Cation_antiport_E', 4, NULL),
(4373, NULL, 'IPR001784', NULL, 'Bunyavirus nucleocapsid (N) protein', 'Bunya_nucleocap', 4, NULL),
(4374, NULL, 'IPR010200', NULL, 'HflC', 'HflC', 4, NULL),
(4375, NULL, 'IPR001824', NULL, 'Tyrosine-protein kinase, receptor class III, conserved site', 'Tyr_kinase_rcpt_3_CS', 2, NULL),
(4376, NULL, 'IPR000929', NULL, 'Dopamine receptor family', 'Dopamine_rcpt', 4, NULL),
(4377, NULL, 'IPR003367', NULL, 'Thrombospondin, type 3-like repeat', 'Thrombospondin_3-like_rpt', 7, NULL),
(4378, NULL, 'IPR010209', NULL, 'Ion-translocating oxidoreductase complex, subunit RnfG/RsxG', 'Ion_transpt_RnfG/RsxG', 4, NULL),
(4379, NULL, 'IPR004273', NULL, 'Dynein heavy chain region D6 P-loop domain', 'Dynein_heavy_D6_P-loop', 3, NULL),
(4380, NULL, 'IPR007992', NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit, CybS', 'CybS', 4, NULL),
(4381, NULL, 'IPR010232', NULL, 'Probable protein kinase UbiB', 'UbiB', 4, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(4382, NULL, 'IPR000586', NULL, 'Somatostatin receptor family', 'Somatstn_rcpt', 4, NULL),
(4383, NULL, 'IPR001842', NULL, 'Peptidase M36, fungalysin', 'Peptidase_M36', 4, NULL),
(4384, NULL, 'IPR001964', NULL, 'Luteovirus VPG protein', 'Luteo_VPG', 4, NULL),
(4385, NULL, 'IPR004815', NULL, 'Lon protease, bacterial/eukaryotic-type', 'Lon_bac/euk-typ', 4, NULL),
(4386, NULL, 'IPR002765', NULL, 'Uncharacterised protein family UPF0145, YbjQ-like', 'UPF0145_YbjQ-like', 4, NULL),
(4387, NULL, 'IPR001948', NULL, 'Peptidase M18', 'Peptidase_M18', 4, NULL),
(4388, NULL, 'IPR002303', NULL, 'Valine-tRNA ligase', 'Valyl-tRNA_ligase', 4, NULL),
(4389, NULL, 'IPR003347', NULL, 'JmjC domain', 'JmjC_dom', 3, NULL),
(4390, NULL, 'IPR007985', NULL, 'Haemolysin expression modulating, HHA', 'Hemolysn_expr_modulating_HHA', 4, NULL),
(4391, NULL, 'IPR005277', NULL, 'Uncharacterised protein family, Major Facilitator Superfamily MSF4', 'Uncharacterised_MSF4', 4, NULL),
(4392, NULL, 'IPR003319', NULL, 'ATP synthase YMF19-like, N-terminal', 'YMF19-like_N', 3, NULL),
(4393, NULL, 'IPR001005', NULL, 'SANT/Myb domain', 'SANT/Myb', 3, NULL),
(4394, NULL, 'IPR005270', NULL, 'tRNA-dihydrouridine synthase, TIM-barrel, NifR3-related', 'tRNA_dU_NifR3-rel', 4, NULL),
(4395, NULL, 'IPR010223', NULL, 'ATP binding protein MinD', 'MinD', 4, NULL),
(4396, NULL, 'IPR005264', NULL, 'N-acetylneuraminate lyase', 'NanA', 4, NULL),
(4397, NULL, 'IPR003358', NULL, 'tRNA (guanine-N-7) methyltransferase, Trmb type', 'tRNA_(Gua-N-7)_MeTrfase_Trmb', 4, NULL),
(4398, NULL, 'IPR000735', NULL, 'Alpha 2C adrenoceptor', 'ADRA2C_rcpt', 4, NULL),
(4399, NULL, 'IPR010215', NULL, 'Transcription antitermination protein RfaH', 'Transcription_antiterm_RfaH', 4, NULL),
(4400, NULL, 'IPR005269', NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase LOG', 'LOG', 4, NULL),
(4401, NULL, 'IPR001892', NULL, 'Ribosomal protein S13', 'Ribosomal_S13', 4, NULL),
(4402, NULL, 'IPR001846', NULL, 'von Willebrand factor, type D domain', 'VWF_type-D', 3, NULL),
(4403, NULL, 'IPR004814', NULL, 'Oligopeptide transporter OPT', 'Oligopep_transpt', 4, NULL),
(4404, NULL, 'IPR003352', NULL, 'Phosphotransferase system, EIIC', 'PTS_EIIC', 3, NULL),
(4405, NULL, 'IPR034486', NULL, 'hnRNP A2/B1, RNA recognition motif 1', 'hnRNPA2B1_RRM1', 3, NULL),
(4406, NULL, 'IPR001966', NULL, 'Gastrin-releasing peptide receptor', 'Gastrin_pep_rcpt', 4, NULL),
(4407, NULL, 'IPR005284', NULL, 'Pigment precursor permease/Protein ATP-binding cassette sub-family G', 'Pigment_permease/Abcg', 4, NULL),
(4408, NULL, 'IPR003876', NULL, 'Arginine deiminase', 'Arg_deiminase', 4, NULL),
(4409, NULL, 'IPR007935', NULL, 'Tobravirus 2B', 'Tobravirus_2B', 4, NULL),
(4410, NULL, 'IPR001786', NULL, 'GPCR, family 3, metabotropic glutamate receptor 4', 'GPCR_3_mGluR4', 4, NULL),
(4411, NULL, 'IPR005257', NULL, 'Anthranilate synthase component I, TrpE-like, bacterial', 'Anth_synth_I_TrpE', 4, NULL),
(4412, NULL, 'IPR007958', NULL, 'Scorpion short chain toxin, chloride channel inhibitor', 'Scorpion_toxinS_Cl_inh', 4, NULL),
(4413, NULL, 'IPR000401', NULL, '[Phe13]-bombesin receptor', 'BRS4', 4, NULL),
(4414, NULL, 'IPR010224', NULL, 'ATP binding protein MinD, archaea', 'MinD_archaea', 4, NULL),
(4415, NULL, 'IPR003360', NULL, 'US22-like', 'US22-like', 4, NULL),
(4416, NULL, 'IPR003345', NULL, 'M protein repeat', 'M_repeat', 7, NULL),
(4417, NULL, 'IPR003789', NULL, 'Aspartyl/glutamyl-tRNA amidotransferase subunit B-like', 'Asn/Gln_tRNA_amidoTrase-B-like', 5, NULL),
(4418, NULL, 'IPR001816', NULL, 'Translation elongation factor EFTs/EF1B', 'Transl_elong_EFTs/EF1B', 4, NULL),
(4419, NULL, 'IPR003372', NULL, 'Photosystem II PsbL', 'PSII_PsbL', 4, NULL),
(4420, NULL, 'IPR005285', NULL, 'Pleiotropic drug resistance protein PDR/CDR', 'Drug-R_PDR/CDR', 4, NULL),
(4421, NULL, 'IPR003333', NULL, 'Mycolic acid cyclopropane synthase', 'Mycolic_cyclopropane_synthase', 4, NULL),
(4422, NULL, 'IPR001847', NULL, 'Peptidase S21', 'Peptidase_S21', 4, NULL),
(4423, NULL, 'IPR013275', NULL, 'Peptidase M12B, ADAM-TS2', 'Pept_M12B_ADAM-TS2', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(4424, NULL, 'IPR001790', NULL, 'Ribosomal protein L10P', 'Ribosomal_L10P', 4, NULL),
(4425, NULL, 'IPR003742', NULL, 'RNA methyltransferase RlmH', 'RlmH-like', 4, NULL),
(4426, NULL, 'IPR001878', NULL, 'Zinc finger, CCHC-type', 'Znf_CCHC', 3, NULL),
(4427, NULL, 'IPR003361', NULL, 'Acetaldehyde dehydrogenase', 'Acetaldehyde_dehydrogenase', 4, NULL),
(4428, NULL, 'IPR000245', NULL, 'V-ATPase proteolipid subunit', 'ATPase_proteolipid_csu', 4, NULL),
(4429, NULL, 'IPR003353', NULL, 'Phosphotransferase system, fructose-specific IIB subunit', 'PTS_IIB_fruc', 3, NULL),
(4430, NULL, 'IPR001783', NULL, 'Lumazine-binding protein', 'Lumazine-bd', 4, NULL),
(4431, NULL, 'IPR001827', NULL, 'Homeobox protein, antennapedia type, conserved site', 'Homeobox_Antennapedia_CS', 2, NULL),
(4432, NULL, 'IPR001913', NULL, 'Equine arteritis virus GP2b envelope glycoprotein', 'Equi_arteri_GP2b', 4, NULL),
(4433, NULL, 'IPR007439', NULL, 'Chemotaxis phosphatase, CheZ', 'Chemotax_Pase_CheZ', 4, NULL),
(4434, NULL, 'IPR007940', NULL, 'SH3-binding 5', 'SH3BP5', 4, NULL),
(4435, NULL, 'IPR005149', NULL, 'Transcription regulator PadR, N-terminal', 'Tscrpt_reg_PadR_N', 3, NULL),
(4436, NULL, 'IPR007961', NULL, 'Herpesvirus latent membrane 1', 'Herpes_LMP1', 4, NULL),
(4437, NULL, 'IPR007964', NULL, 'MICOS complex subunit MIC19/MIC25', 'MIC19/MIC25', 4, NULL),
(4438, NULL, 'IPR003321', NULL, 'Cytochrome c552', 'Cyt_c552', 4, NULL),
(4439, NULL, 'IPR003871', NULL, 'Domain of unknown function DUF223', 'DUF223', 3, NULL),
(4440, NULL, 'IPR001820', NULL, 'Protease inhibitor I35 (TIMP)', 'TIMP', 4, NULL),
(4441, NULL, 'IPR001831', NULL, 'Immunodeficiency virus transactivating regulatory protein (Tat)', 'IV_Tat', 4, NULL),
(4442, NULL, 'IPR000420', NULL, 'Yeast PIR protein repeat', 'Yeast_PIR', 7, NULL),
(4443, NULL, 'IPR000778', NULL, 'Cytochrome b245, heavy chain', 'Cyt_b245_heavy_chain', 4, NULL),
(4444, NULL, 'IPR002764', NULL, 'CRISPR-associated protein Cas7/Cst2/DevR, subtype I-a/Apern', 'Cas7/Cst2/DevR_sub_I-a/Apern', 4, NULL),
(4445, NULL, 'IPR001853', NULL, 'DSBA-like thioredoxin domain', 'DSBA-like_thioredoxin_dom', 3, NULL),
(4446, NULL, 'IPR003886', NULL, 'NIDO domain', 'NIDO_dom', 3, NULL),
(4447, NULL, 'IPR003898', NULL, 'Bordetella pertussis toxin A', 'Borpert_toxA', 4, NULL),
(4448, NULL, 'IPR005159', NULL, 'WCCH motif', 'WCCH', 3, NULL),
(4449, NULL, 'IPR003687', NULL, 'Photosystem II PsbK', 'PSII_PsbK', 4, NULL),
(4450, NULL, 'IPR003386', NULL, 'Lecithin:cholesterol/phospholipid:diacylglycerol acyltransferase', 'LACT/PDAT_acylTrfase', 4, NULL),
(4451, NULL, 'IPR001906', NULL, 'Terpene synthase, N-terminal domain', 'Terpene_synth_N', 3, NULL),
(4452, NULL, 'IPR001975', NULL, 'Ribosomal protein L40e', 'Ribosomal_L40e', 3, NULL),
(4453, NULL, 'IPR003884', NULL, 'Factor I / membrane attack complex', 'FacI_MAC', 3, NULL),
(4454, NULL, 'IPR004834', NULL, 'Fungal chitin synthase', 'Chitin_synth_fun', 4, NULL),
(4455, NULL, 'IPR007440', NULL, 'Chorismate--pyruvate lyase', 'Chorismate--pyruvate_lyase', 4, NULL),
(4456, NULL, 'IPR010189', NULL, 'Shikimate kinase, archaea', 'SK_arc', 4, NULL),
(4457, NULL, 'IPR004810', NULL, 'Formyltetrahydrofolate deformylase', 'PurU', 4, NULL),
(4458, NULL, 'IPR000802', NULL, 'Arsenical pump membrane protein,  ArsB', 'Arsenical_pump_ArsB', 4, NULL),
(4459, NULL, 'IPR001957', NULL, 'Chromosomal replication control, initiator DnaA', 'Chromosome_initiator_DnaA', 4, NULL),
(4460, NULL, 'IPR001874', NULL, 'Dehydroquinase, class II', 'DHquinase_II', 4, NULL),
(4461, NULL, 'IPR010227', NULL, 'NADH-quinone oxidoreductase, chain M/4', 'NADH_Q_OxRdtase_chainM/4', 4, NULL),
(4462, NULL, 'IPR005283', NULL, 'Peroxysomal long chain fatty acyl transporter', 'FA_transporter', 4, NULL),
(4463, NULL, 'IPR003366', NULL, 'CUB-like domain', 'CUB-like_dom', 3, NULL),
(4464, NULL, 'IPR010207', NULL, 'Ion-translocating oxidoreductase complex, RnfB/RsxB', 'Elect_transpt_cplx_RnfB/RsxB', 4, NULL),
(4465, NULL, 'IPR007936', NULL, 'Virulence-associated E', 'VirE', 4, NULL),
(4466, NULL, 'IPR005261', NULL, 'Conserved hypothetical protein CHP00659', 'CHP00659', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(4467, NULL, 'IPR001890', NULL, 'RNA-binding, CRM domain', 'RNA-binding_CRM', 3, NULL),
(4468, NULL, 'IPR001856', NULL, 'Somatostatin receptor 3', 'Somatstn_rcpt_3', 4, NULL),
(4469, NULL, 'IPR004821', NULL, 'Cytidyltransferase-like domain', 'Cyt_trans-like', 3, NULL),
(4470, NULL, 'IPR007969', NULL, 'Domain of unknown function DUF732', 'DUF732', 3, NULL),
(4471, NULL, 'IPR007986', NULL, 'NINE', 'NINE', 4, NULL),
(4472, NULL, 'IPR007942', NULL, 'Phospholipase-like', 'PLipase-like', 4, NULL),
(4473, NULL, 'IPR001792', NULL, 'Acylphosphatase-like domain', 'Acylphosphatase-like_dom', 3, NULL),
(4474, NULL, 'IPR001915', NULL, 'Peptidase M48', 'Peptidase_M48', 3, NULL),
(4475, NULL, 'IPR004838', NULL, 'Aminotransferases, class-I, pyridoxal-phosphate-binding site', 'NHTrfase_class1_PyrdxlP-BS', 1, NULL),
(4476, NULL, 'IPR001883', NULL, 'GPCR, family 3, metabotropic glutamate receptor 7', 'GPCR_3_mGluR7', 4, NULL),
(4477, NULL, 'IPR001206', NULL, 'Diacylglycerol kinase, catalytic domain', 'Diacylglycerol_kinase_cat_dom', 3, NULL),
(4478, NULL, 'IPR001086', NULL, 'Prephenate dehydratase', 'Preph_deHydtase', 3, NULL),
(4479, NULL, 'IPR007948', NULL, 'Protein of unknown function DUF736', 'DUF736', 4, NULL),
(4480, NULL, 'IPR004832', NULL, 'TCL1/MTCP1', 'TCL1_MTCP1', 4, NULL),
(4481, NULL, 'IPR003337', NULL, 'Trehalose-phosphatase', 'Trehalose_PPase', 4, NULL),
(4482, NULL, 'IPR001821', NULL, '[NiFe]-hydrogenase, small subunit', 'NiFe_hydrogenase_ssu', 4, NULL),
(4483, NULL, 'IPR003385', NULL, 'Glycoside hydrolase, family 77', 'Glyco_hydro_77', 4, NULL),
(4484, NULL, 'IPR001845', NULL, 'HTH ArsR-type DNA-binding domain', 'HTH_ArsR_DNA-bd_dom', 3, NULL),
(4485, NULL, 'IPR007939', NULL, 'Copper resistance B precursor', 'Cu-R_B_prcur', 4, NULL),
(4486, NULL, 'IPR001843', NULL, 'Fragilysin', 'Fragilysin', 4, NULL),
(4487, NULL, 'IPR001882', NULL, 'Biotin-binding site', 'Biotin_BS', 1, NULL),
(4488, NULL, 'IPR003339', NULL, 'ABC/ECF transporter, transmembrane component', 'ABC/ECF_trnsptr_transmembrane', 4, NULL),
(4489, NULL, 'IPR000236', NULL, 'Transactivation protein X', 'Transactivation_prot_X', 4, NULL),
(4490, NULL, 'IPR003323', NULL, 'OTU domain', 'OTU_dom', 3, NULL),
(4491, NULL, 'IPR003341', NULL, 'Cysteine rich repeat, tripleX', 'Cys_rich_tripleX', 7, NULL),
(4492, NULL, 'IPR004839', NULL, 'Aminotransferase, class I/classII', 'Aminotransferase_I/II', 3, NULL),
(4493, NULL, 'IPR010229', NULL, 'Peptidase M38, beta-aspartyl dipeptidase', 'Pept_M38_dipep', 4, NULL),
(4494, NULL, 'IPR000615', NULL, 'Bestrophin', 'Bestrophin', 4, NULL),
(4495, NULL, 'IPR034025', NULL, 'ADAM10/ADAM17 catalytic domain', 'ADAM10_ADAM17', 3, NULL),
(4496, NULL, 'IPR003349', NULL, 'JmjN domain', 'JmjN', 3, NULL),
(4497, NULL, 'IPR007965', NULL, 'Gcn5-related N-acetyltransferase (GNAT) domain, ATAT-type', 'GNAT_ATAT', 3, NULL),
(4498, NULL, 'IPR003350', NULL, 'CUT domain', 'CUT_dom', 3, NULL),
(4499, NULL, 'IPR001001', NULL, 'DNA polymerase III, beta sliding clamp', 'DNA_polIII_beta', 4, NULL),
(4500, NULL, 'IPR010201', NULL, 'HflK', 'HflK', 4, NULL),
(4501, NULL, 'IPR007322', NULL, 'RNA-dependent RNA polymerase, bunyaviral', 'RNA_pol_bunyavir', 3, NULL),
(4502, NULL, 'IPR000870', NULL, 'Homoserine kinase', 'Homoserine_kinase', 4, NULL),
(4503, NULL, 'IPR000842', NULL, 'Phosphoribosyl pyrophosphate synthetase, conserved site', 'PRib_PP_synth_CS', 2, NULL),
(4504, NULL, 'IPR000299', NULL, 'FERM domain', 'FERM_domain', 3, NULL),
(4505, NULL, 'IPR006896', NULL, 'Sec23/Sec24, trunk domain', 'Sec23/24_trunk_dom', 3, NULL),
(4506, NULL, 'IPR007320', NULL, 'Programmed cell death protein 2, C-terminal', 'PDCD2_C', 3, NULL),
(4507, NULL, 'IPR006307', NULL, 'Type III exporter system, secretion apparatus protein BsaZ', 'BsaZ', 4, NULL),
(4508, NULL, 'IPR004318', NULL, 'Rhoptry-associated protein 1', 'RAP-1', 4, NULL),
(4509, NULL, 'IPR004281', NULL, 'Interleukin-12 alpha', 'IL-12_alpha', 4, NULL),
(4510, NULL, 'IPR004294', NULL, 'Carotenoid oxygenase', 'Carotenoid_Oase', 4, NULL),
(4511, NULL, 'IPR004338', NULL, 'Ion-translocating oxidoreductase NqrB/RnfD', 'NqrB/RnfD', 4, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(4512, NULL, 'IPR005720', NULL, 'Dihydroorotate dehydrogenase domain', 'Dihydroorotate_DH', 3, NULL),
(4513, NULL, 'IPR007302', NULL, 'Circularly permuted ATPgrasp domain', 'CP_ATPgrasp', 3, NULL),
(4514, NULL, 'IPR007450', NULL, 'Lipoprotein SmpA/OmlA', 'Lipoprotein_SmpA/OmlA', 3, NULL),
(4515, NULL, 'IPR000316', NULL, 'Plant EC metallothionein-like protein, family 15', 'Metallthion_15', 4, NULL),
(4516, NULL, 'IPR006357', NULL, 'HAD-superfamily hydrolase, subfamily IIA', 'HAD-SF_hydro_IIA', 4, NULL),
(4517, NULL, 'IPR000811', NULL, 'Glycosyl transferase, family 35', 'Glyco_trans_35', 4, NULL),
(4518, NULL, 'IPR000836', NULL, 'Phosphoribosyltransferase domain', 'PRibTrfase_dom', 3, NULL),
(4519, NULL, 'IPR005169', NULL, 'CagA exotoxin, phosphopeptide substrate mimic region', 'CagA_C', 3, NULL),
(4520, NULL, 'IPR004284', NULL, 'Birnavirus VP5 protein', 'Birna_VP5', 4, NULL),
(4521, NULL, 'IPR004280', NULL, 'Herpesvirus UL95', 'Herpes_UL95', 4, NULL),
(4522, NULL, 'IPR000356', NULL, 'P2Y2 purinoceptor', 'P2Y2_rcpt', 4, NULL),
(4523, NULL, 'IPR004279', NULL, 'Perilipin', 'Perilipin', 4, NULL),
(4524, NULL, 'IPR006880', NULL, 'INO80 complex subunit B-like conserved region', 'INO80B_C', 3, NULL),
(4525, NULL, 'IPR000427', NULL, 'Papillomavirus E2, C-terminal', 'Papillomavirus_E2_C', 3, NULL),
(4526, NULL, 'IPR006328', NULL, 'L-2-Haloacid dehalogenase', '2-HAD', 4, NULL),
(4527, NULL, 'IPR004316', NULL, 'SWEET sugar transporter', 'SWEET_sugar_transpr', 4, NULL),
(4528, NULL, 'IPR006343', NULL, 'DnaD domain', 'DnaD_dom', 3, NULL),
(4529, NULL, 'IPR002021', NULL, 'Paramyxovirus nucleocapsid protein', 'Paramyx_ncap', 4, NULL),
(4530, NULL, 'IPR000826', NULL, 'Formyl peptide receptor-related', 'Formyl_rcpt-rel', 4, NULL),
(4531, NULL, 'IPR006894', NULL, 'HupH hydrogenase expression protein, C-terminal', 'HupH_Hydgase_express_prot_C', 3, NULL),
(4532, NULL, 'IPR005757', NULL, 'Murein peptide ligase', 'Mpl', 4, NULL),
(4533, NULL, 'IPR000280', NULL, 'Pestivirus NS3, peptidase S31', 'Pestivirus_NS3_S31', 3, NULL),
(4534, NULL, 'IPR006901', NULL, 'tRNA methyltransferase TrmK', 'TrmK', 4, NULL),
(4535, NULL, 'IPR004304', NULL, 'Acetamidase/Formamidase', 'FmdA_AmdA', 4, NULL),
(4536, NULL, 'IPR002811', NULL, 'Aspartate dehydrogenase', 'Asp_DH', 3, NULL),
(4537, NULL, 'IPR006878', NULL, 'BRRF1, herpesviridae', 'Herpes_BBRF1', 4, NULL),
(4538, NULL, 'IPR006297', NULL, 'Elongation factor 4', 'EF-4', 4, NULL),
(4539, NULL, 'IPR007461', NULL, 'Ysc84 actin-binding domain', 'Ysc84_actin-binding', 3, NULL),
(4540, NULL, 'IPR004277', NULL, 'Phosphatidyl serine synthase', 'PSS', 4, NULL),
(4541, NULL, 'IPR000361', NULL, 'FeS cluster biogenesis', 'FeS_biogenesis', 3, NULL),
(4542, NULL, 'IPR034634', NULL, 'Connexin, C-terminal', 'Connexin_C', 5, NULL),
(4543, NULL, 'IPR007304', NULL, 'TAP46-like protein', 'TAP46-like', 4, NULL),
(4544, NULL, 'IPR000879', NULL, 'Guanylin', 'Guanylin', 4, NULL),
(4545, NULL, 'IPR000796', NULL, 'Aspartate/other aminotransferase', 'Asp_trans', 4, NULL),
(4546, NULL, 'IPR007319', NULL, 'Small-subunit processome, Utp21', 'SSU_processome_Utp21', 3, NULL),
(4547, NULL, 'IPR005737', NULL, 'DNA topoisomerase IV, subunit B, Gram-negative', 'TopoIV_B_Gneg', 4, NULL),
(4548, NULL, 'IPR006320', NULL, 'Phosphotransferase system, IIA-like nitrogen-regulatory protein PtsN', 'PTS_Nitro_regul', 4, NULL),
(4549, NULL, 'IPR004282', NULL, 'Chloroplast envelope membrane protein, CemA', 'CemA', 4, NULL),
(4550, NULL, 'IPR006330', NULL, 'Adenosine/adenine deaminase', 'Ado/ade_deaminase', 4, NULL),
(4551, NULL, 'IPR006334', NULL, 'Glutamate--cysteine ligase, monofunctional', 'Glut_cys_ligase', 4, NULL),
(4552, NULL, 'IPR000814', NULL, 'TATA-box binding protein', 'TBP', 4, NULL),
(4553, NULL, 'IPR005770', NULL, 'Phosphate/phosphite/phosphonate ABC transporter, periplasmic binding protein', 'PhnD', 4, NULL),
(4554, NULL, 'IPR000786', NULL, 'Green fluorescent protein, GFP', 'Green_fluorescent_prot', 4, NULL),
(4555, NULL, 'IPR006875', NULL, 'Sarcoglycan complex subunit protein', 'Sarcoglycan', 4, NULL),
(4556, NULL, 'IPR002803', NULL, 'Fructose-1,6-bisphosphatase, class V', 'FBPase_V', 4, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(4557, NULL, 'IPR006885', NULL, 'NADH dehydrogenase ubiquinone Fe-S protein 4, mitochondrial', 'NADH_UbQ_FeS_4_mit', 4, NULL),
(4558, NULL, 'IPR006924', NULL, 'Ribosomal protein PSRP-3/Ycf65', 'Ribosomal_PSRP3/Ycf65', 4, NULL),
(4559, NULL, 'IPR005722', NULL, 'ATP synthase, F1 complex, beta subunit', 'ATP_synth_F1_bsu', 4, NULL),
(4560, NULL, 'IPR002023', NULL, 'NADH-quinone oxidoreductase subunit E-like', 'NuoE-like', 4, NULL),
(4561, NULL, 'IPR000829', NULL, 'DAGK family', 'DAGK', 4, NULL),
(4562, NULL, 'IPR006329', NULL, 'AMP deaminase', 'AMPD', 4, NULL),
(4563, NULL, 'IPR000789', NULL, 'Cyclin-dependent kinase, regulatory subunit', 'Cyclin-dep_kinase_reg-sub', 4, NULL),
(4564, NULL, 'IPR006324', NULL, 'Glutathione reductase', 'GSHR', 4, NULL),
(4565, NULL, 'IPR000881', NULL, 'Myotoxin', 'Myotoxin', 4, NULL),
(4566, NULL, 'IPR000390', NULL, 'Small drug/metabolite transporter protein family', 'Small_drug/metabolite_transptr', 4, NULL),
(4567, NULL, 'IPR001990', NULL, 'Chromogranin A/B/C', 'Granin', 4, NULL),
(4568, NULL, 'IPR004315', NULL, 'Male Drosophila accessory gland secretory protein', 'Male_ac_gland_sc', 4, NULL),
(4569, NULL, 'IPR000235', NULL, 'Ribosomal protein S5/S7', 'Ribosomal_S5/S7', 4, NULL),
(4570, NULL, 'IPR002780', NULL, 'Hydrogenase formation HypD protein', 'Hyd_form_HypD', 4, NULL),
(4571, NULL, 'IPR000357', NULL, 'HEAT repeat', 'HEAT', 7, NULL),
(4572, NULL, 'IPR006337', NULL, 'D-glucosaminate-6-phosphate ammonia lyase DgaE-like', 'DgaE-like', 4, NULL),
(4573, NULL, 'IPR006899', NULL, 'Hepatocyte nuclear factor 1, N-terminal', 'HNF-1_N', 3, NULL),
(4574, NULL, 'IPR000851', NULL, 'Ribosomal protein S5', 'Ribosomal_S5', 4, NULL),
(4575, NULL, 'IPR000844', NULL, 'ATP-binding cassette subfamily C member 8', 'ABCC8', 4, NULL),
(4576, NULL, 'IPR006351', NULL, '3-amino-5-hydroxybenzoic acid synthesis-related', 'AHBA_synth-like', 4, NULL),
(4577, NULL, 'IPR004292', NULL, 'Adenoviral packaging protein 3-like', 'L1-like', 4, NULL),
(4578, NULL, 'IPR002816', NULL, 'TraB/PrgY/GumN family', 'TraB/PrgY/GumN_fam', 4, NULL),
(4579, NULL, 'IPR003690', NULL, 'Transcription termination factor, mitochondrial/chloroplastic', 'MTERF', 4, NULL),
(4580, NULL, 'IPR000887', NULL, 'KDPG/KHG aldolase', 'Aldlse_KDPG_KHG', 4, NULL),
(4581, NULL, 'IPR007451', NULL, 'High frequency lysogenization protein HflD', 'HflD', 4, NULL),
(4582, NULL, 'IPR004276', NULL, 'Glycosyltransferase family 28, N-terminal domain', 'GlycoTrans_28_N', 3, NULL),
(4583, NULL, 'IPR002013', NULL, 'SAC domain', 'SAC_dom', 3, NULL),
(4584, NULL, 'IPR006303', NULL, 'Flagellar biosynthesis protein FliR', 'FliR', 4, NULL),
(4585, NULL, 'IPR007311', NULL, 'ST7', 'ST7', 4, NULL),
(4586, NULL, 'IPR005168', NULL, 'Bunyavirus glycoprotein G2', 'Bunya_G2', 3, NULL),
(4587, NULL, 'IPR006313', NULL, 'Deferrochelatase', 'EfeB/EfeN', 4, NULL),
(4588, NULL, 'IPR005738', NULL, 'DNA topoisomerase III', 'TopoIII', 4, NULL),
(4589, NULL, 'IPR004301', NULL, 'Nucleoplasmin family', 'Nucleoplasmin', 4, NULL),
(4590, NULL, 'IPR005744', NULL, 'Hly-III', 'Hy-lIII', 4, NULL),
(4591, NULL, 'IPR002793', NULL, 'Endonuclease NucS', 'Endonuclease_NucS', 4, NULL),
(4592, NULL, 'IPR002781', NULL, 'Transmembrane protein TauE-like', 'TM_pro_TauE-like', 4, NULL),
(4593, NULL, 'IPR005732', NULL, 'Ribosomal protein S19, bacterial-type', 'Ribosomal_S19_bac-type', 4, NULL),
(4594, NULL, 'IPR006876', NULL, 'LMBR1-like membrane protein', 'LMBR1-like_membr_prot', 4, NULL),
(4595, NULL, 'IPR005171', NULL, 'Cytochrome C oxidase subunit IV, prokaryotes', 'Cyt_c_oxidase_su4_prok', 4, NULL),
(4596, NULL, 'IPR000241', NULL, 'Ribosomal RNA large subunit methyltransferase K/L-like, FLD domain', 'RlmKL-like_FLD', 3, NULL),
(4597, NULL, 'IPR000412', NULL, 'ABC-2 transporter', 'ABC_2_transport', 4, NULL),
(4598, NULL, 'IPR001748', NULL, 'G10 protein', 'G10', 4, NULL),
(4599, NULL, 'IPR002825', NULL, 'Peptidase S49, serine-peptidase prokaryotes', 'Pept_S49_ser-pept_pro', 4, NULL),
(4600, NULL, 'IPR000785', NULL, 'Herpsevirus envelope glycoprotein M', 'Herpes_glycop_M', 4, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(4601, NULL, 'IPR005725', NULL, 'ATPase, V1 complex, subunit A', 'ATPase_V1-cplx_asu', 4, NULL),
(4602, NULL, 'IPR006902', NULL, 'Umbravirus long distance movement protein', 'Umbravirus_LDM', 4, NULL),
(4603, NULL, 'IPR006892', NULL, 'Geminivirus AC4/5, conserved domain 1', 'Gemini_AC4_5_cons_dom_1', 3, NULL),
(4604, NULL, 'IPR000250', NULL, 'Peptidase G1', 'Peptidase_G1', 4, NULL),
(4605, NULL, 'IPR002826', NULL, '6-hydroxymethylpterin diphosphokinase MptE-like', 'MptE-like', 3, NULL),
(4606, NULL, 'IPR000875', NULL, 'Cecropin', 'Cecropin', 4, NULL),
(4607, NULL, 'IPR006887', NULL, 'Serine/threonine-protein phosphatase 4 regulatory subunit 3-like, central domain', 'P4R3-like_central_dom', 3, NULL),
(4608, NULL, 'IPR000317', NULL, 'Peptidase C24, Calicivirus polyprotein Orf1', 'Peptidase_C24', 3, NULL),
(4609, NULL, 'IPR000828', NULL, 'Monellin, A chain', 'Monellin_A', 4, NULL),
(4610, NULL, 'IPR000892', NULL, 'Ribosomal protein S26e', 'Ribosomal_S26e', 4, NULL),
(4611, NULL, 'IPR000869', NULL, 'Fungi-IV metallothionein, family 11', 'Metalthion_11', 4, NULL),
(4612, NULL, 'IPR000848', NULL, 'GPCR, cAMP-type', 'GPCR_cAMP', 3, NULL),
(4613, NULL, 'IPR007305', NULL, 'Vesicle transport protein, Got1/SFT2-like', 'Vesicle_transpt_Got1/SFT2', 4, NULL),
(4614, NULL, 'IPR000817', NULL, 'Prion protein', 'Prion', 4, NULL),
(4615, NULL, 'IPR004296', NULL, 'DUF236 repeat', 'DUF236', 7, NULL),
(4616, NULL, 'IPR006314', NULL, 'Dyp-type peroxidase', 'Dyp_peroxidase', 4, NULL),
(4617, NULL, 'IPR004310', NULL, 'Equine arteritis virus Gp3', 'EAV_Gp3', 4, NULL),
(4618, NULL, 'IPR007465', NULL, 'Protein of unknown function DUF508', 'DUF508', 4, NULL),
(4619, NULL, 'IPR002004', NULL, 'Polyadenylate-binding protein/Hyperplastic disc protein', 'PABP_HYD', 3, NULL),
(4620, NULL, 'IPR005165', NULL, 'Anthrax toxin, edema factor, central', 'Anthrax_toxin_edema_cen', 3, NULL),
(4621, NULL, 'IPR007457', NULL, 'Fe(II) trafficking protein YggX', 'Fe_traffick_prot_YggX', 4, NULL),
(4622, NULL, 'IPR000258', NULL, 'Bacterial ice-nucleation, octamer repeat', 'Ice_nucleatn', 7, NULL),
(4623, NULL, 'IPR000793', NULL, 'ATP synthase, alpha subunit, C-terminal', 'ATP_synth_asu_C', 3, NULL),
(4624, NULL, 'IPR006331', NULL, 'Adenosine deaminase-related growth factor', 'ADGF', 4, NULL),
(4625, NULL, 'IPR002813', NULL, 'Arginine biosynthesis protein ArgJ', 'Arg_biosynth_ArgJ', 4, NULL),
(4626, NULL, 'IPR000867', NULL, 'Insulin-like growth factor-binding protein, IGFBP', 'IGFBP-like', 3, NULL),
(4627, NULL, 'IPR000876', NULL, 'Ribosomal protein S4e', 'Ribosomal_S4e', 4, NULL),
(4628, NULL, 'IPR000872', NULL, 'Tafazzin', 'Tafazzin', 4, NULL),
(4629, NULL, 'IPR004306', NULL, 'Domain of unknown function DUF237', 'DUF237', 3, NULL),
(4630, NULL, 'IPR004343', NULL, 'Plus-3 domain', 'Plus-3_dom', 3, NULL),
(4631, NULL, 'IPR000248', NULL, 'Angiotensin II receptor family', 'ATII_rcpt', 4, NULL),
(4632, NULL, 'IPR000889', NULL, 'Glutathione peroxidase', 'Glutathione_peroxidase', 4, NULL),
(4633, NULL, 'IPR006871', NULL, 'ssDNA-binding protein, baculovirus', 'ssDNA-bd_baculovirus', 4, NULL),
(4634, NULL, 'IPR000853', NULL, 'Metallothionein, family 6, nematoda', 'Metalthion_nemt', 4, NULL),
(4635, NULL, 'IPR006310', NULL, '3''-5'' exonuclease DinG', 'DinG', 4, NULL),
(4636, NULL, 'IPR006302', NULL, 'Type III secretion protein HrcV', 'T3SS_HrcV', 4, NULL),
(4637, NULL, 'IPR002809', NULL, 'Integral membrane protein EMC3/TMCO1-like', 'EMC3/TMCO1', 4, NULL),
(4638, NULL, 'IPR000375', NULL, 'Dynamin stalk domain', 'Dynamin_stalk', 3, NULL),
(4639, NULL, 'IPR002804', NULL, 'Archease', 'Archease', 4, NULL),
(4640, NULL, 'IPR000820', NULL, 'Proto-oncogene Mas', 'Proto-oncogene_Mas', 4, NULL),
(4641, NULL, 'IPR002786', NULL, 'Inosine/xanthosine triphosphatase', 'Non_canon_purine_NTPase', 4, NULL),
(4642, NULL, 'IPR006315', NULL, 'Outer membrane autotransporter barrel', 'OM_autotransptr_brl', 3, NULL),
(4643, NULL, 'IPR000798', NULL, 'Ezrin/radixin/moesin-like', 'Ez/rad/moesin-like', 4, NULL),
(4644, NULL, 'IPR006326', NULL, 'UDP-glycosyltransferase, MGT-like', 'UDPGT_MGT-like', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(4645, NULL, 'IPR005164', NULL, 'Allantoicase', 'Allantoicase', 4, NULL),
(4646, NULL, 'IPR006316', NULL, 'Tryptophan synthase, beta chain-like', 'Trp_synth_b-like', 4, NULL),
(4647, NULL, 'IPR007459', NULL, 'DNA polymerase III chi subunit, HolC', 'DNA_pol3_chi', 4, NULL),
(4648, NULL, 'IPR005726', NULL, 'ATP synthase alpha chain, archaea', 'ATP_synth_asu_arc', 4, NULL),
(4649, NULL, 'IPR004307', NULL, 'TspO/MBR-related protein', 'TspO_MBR', 4, NULL),
(4650, NULL, 'IPR005730', NULL, 'Carboxynorspermidine decarboxylase', 'Nsp_de-COase', 4, NULL),
(4651, NULL, 'IPR034592', NULL, 'Coiled-coil domain-containing protein 91', 'CCDC91', 4, NULL),
(4652, NULL, 'IPR005162', NULL, 'Retrotransposon gag domain', 'Retrotrans_gag_dom', 3, NULL),
(4653, NULL, 'IPR007456', NULL, 'Smg', 'Smg', 4, NULL),
(4654, NULL, 'IPR002769', NULL, 'Translation initiation factor IF6', 'eIF6', 4, NULL),
(4655, NULL, 'IPR000788', NULL, 'Ribonucleotide reductase large subunit, C-terminal', 'RNR_lg_C', 3, NULL),
(4656, NULL, 'IPR002770', NULL, 'Formylmethanofuran: tetrahydromethanopterin formyltransferase Ftr, C-terminal', 'ForMFR_H4MPT_ForTrfase_C', 3, NULL),
(4657, NULL, 'IPR034113', NULL, 'Golgi-associated plant pathogenesis-related protein 1, SCP domain', 'SCP_GAPR1-like', 3, NULL),
(4658, NULL, 'IPR007303', NULL, 'TIP41-like protein', 'TIP41-like', 4, NULL),
(4659, NULL, 'IPR006882', NULL, 'Herpesvirus Orf11', 'Herpes_Orf11', 4, NULL),
(4660, NULL, 'IPR024643', NULL, 'Histone deacetylase, glutamine rich N-terminal domain', 'Hist_deacetylase_Gln_rich_N', 3, NULL),
(4661, NULL, 'IPR006923', NULL, 'Baculoviridae late expression factor 5, N-terminal', 'Baculo_LEF5_N', 3, NULL),
(4662, NULL, 'IPR005769', NULL, 'ABC transporter, permease PhnE/PtxC', 'PhnE/PtxC', 4, NULL),
(4663, NULL, 'IPR006908', NULL, 'Herpesvirus UL49 tegument protein', 'Herpes_UL49', 4, NULL),
(4664, NULL, 'IPR002778', NULL, 'Signal recognition particle, SRP19 subunit', 'Signal_recog_particle_SRP19', 4, NULL),
(4665, NULL, 'IPR002820', NULL, 'Molybdopterin cofactor biosynthesis C (MoaC) domain', 'Mopterin_CF_biosynth-C_dom', 3, NULL),
(4666, NULL, 'IPR000749', NULL, 'ATP:guanido phosphotransferase', 'ATP-guanido_PTrfase', 4, NULL),
(4667, NULL, 'IPR004319', NULL, 'Domain of unknown function DUF240', 'DUF240', 3, NULL),
(4668, NULL, 'IPR000394', NULL, 'RNA polymerase sigma factor 54', 'RNA_pol_sigma_54', 4, NULL),
(4669, NULL, 'IPR006881', NULL, 'Plasmid encoded RepA protein', 'RepA_C', 4, NULL),
(4670, NULL, 'IPR000823', NULL, 'Plant peroxidase', 'Peroxidase_pln', 4, NULL),
(4671, NULL, 'IPR002000', NULL, 'Lysosome-associated membrane glycoprotein', 'Lysosome-assoc_membr_glycop', 4, NULL),
(4672, NULL, 'IPR002810', NULL, 'NfeD-like, C-terminal domain', 'NfeD-like_C', 3, NULL),
(4673, NULL, 'IPR005733', NULL, 'DNA topoisomerase I, bacterial-type', 'TopoI_bac-type', 4, NULL),
(4674, NULL, 'IPR002773', NULL, 'Deoxyhypusine synthase', 'Deoxyhypusine_synthase', 4, NULL),
(4675, NULL, 'IPR006309', NULL, 'DNA polymerase 3, epsilon subunit', 'DnaQ_proteo', 4, NULL),
(4676, NULL, 'IPR006870', NULL, 'Rhabdovirus matrix protein M', 'Rhabdo_M', 4, NULL),
(4677, NULL, 'IPR005743', NULL, 'DNA gyrase, subunit A', 'GyrA', 4, NULL),
(4678, NULL, 'IPR007313', NULL, 'FxsA cytoplasmic membrane protein', 'FxsA', 4, NULL),
(4679, NULL, 'IPR002801', NULL, 'Aspartate transcarbamylase regulatory subunit', 'Asp_carbamoylTrfase_reg', 4, NULL),
(4680, NULL, 'IPR004302', NULL, 'Cellulose/chitin-binding protein, N-terminal', 'Cellulose/chitin-bd_N', 3, NULL),
(4681, NULL, 'IPR004337', NULL, 'Capsid, astroviral', 'Capsid_astroviral', 4, NULL),
(4682, NULL, 'IPR004293', NULL, 'Coronavirus Orf3a/b', 'Coronavirus_Orf3a/b', 4, NULL),
(4683, NULL, 'IPR004331', NULL, 'SPX domain', 'SPX_dom', 3, NULL),
(4684, NULL, 'IPR000748', NULL, 'Pseudouridine synthase, RsuA/RluB/E/F', 'PsdUridine_synth_RsuA/RluB/E/F', 4, NULL),
(4685, NULL, 'IPR002010', NULL, 'Type III secretion system inner membrane R protein', 'T3SS_IM_R', 4, NULL),
(4686, NULL, 'IPR000399', NULL, 'TPP-binding enzyme, conserved site', 'TPP-bd_CS', 2, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(4687, NULL, 'IPR001812', NULL, 'Trypanosome variant surface glycoprotein, A-type, N-terminal domain', 'Trypano_VSG_A_N_dom', 3, NULL),
(4688, NULL, 'IPR000434', NULL, 'Polycystic kidney disease type 1 protein', 'PC1', 4, NULL),
(4689, NULL, 'IPR007458', NULL, 'Protein of unknown function DUF496', 'DUF496', 4, NULL),
(4690, NULL, 'IPR005741', NULL, 'DNA topoisomerase IV subunit A, Gram-positive', 'TopoIV_A_Gpos', 4, NULL),
(4691, NULL, 'IPR004342', NULL, 'EXS, C-terminal', 'EXS_C', 3, NULL),
(4692, NULL, 'IPR000347', NULL, 'Metallothionein, family 15, plant', 'Metalthion_15p', 4, NULL),
(4693, NULL, 'IPR005717', NULL, 'Ribosomal protein S7, bacterial/organellar-type', 'Ribosomal_S7_bac/org-type', 4, NULL),
(4694, NULL, 'IPR031363', NULL, 'Transmembrane protein 252', 'TMEM252', 4, NULL),
(4695, NULL, 'IPR005750', NULL, 'UDP-N-acetylglucosamine 1-carboxyvinyltransferase', 'UDP_GlcNAc_COvinyl_MurA', 4, NULL),
(4696, NULL, 'IPR005773', NULL, 'Yop virulence translocation protein R', 'YopR', 4, NULL),
(4697, NULL, 'IPR007446', NULL, 'Type IV pilus inner membrane component PilP', 'PilP', 4, NULL),
(4698, NULL, 'IPR000885', NULL, 'Fibrillar collagen, C-terminal', 'Fib_collagen_C', 3, NULL),
(4699, NULL, 'IPR005760', NULL, 'A/G-specific adenine glycosylase MutY', 'A/G_AdeGlyc_MutY', 4, NULL),
(4700, NULL, 'IPR005774', NULL, 'UTP-glucose pyrophosphorylase, regulatory subunit', 'GalF', 4, NULL),
(4701, NULL, 'IPR000372', NULL, 'Leucine-rich repeat N-terminal domain', 'LRRNT', 3, NULL),
(4702, NULL, 'IPR006344', NULL, 'RecBCD enzyme subunit RecD', 'RecD', 4, NULL),
(4703, NULL, 'IPR001985', NULL, 'S-adenosylmethionine decarboxylase', 'S-AdoMet_decarboxylase', 4, NULL),
(4704, NULL, 'IPR006917', NULL, 'SOUL haem-binding protein', 'SOUL_haem-bd', 4, NULL),
(4705, NULL, 'IPR005758', NULL, 'UDP-N-acetylmuramate--L-alanine ligase', 'UDP-N-AcMur_Ala_ligase_MurC', 4, NULL),
(4706, NULL, 'IPR006869', NULL, 'Domain of unknown function DUF547', 'DUF547', 3, NULL),
(4707, NULL, 'IPR000849', NULL, 'Sugar phosphate transporter', 'Sugar_P_transporter', 4, NULL),
(4708, NULL, 'IPR000807', NULL, 'Imidazoleglycerol-phosphate dehydratase', 'ImidazoleglycerolP_deHydtase', 4, NULL),
(4709, NULL, 'IPR000386', NULL, 'Haemagglutinin, influenzavirus B', 'Hemagglutn_influenz_B', 4, NULL),
(4710, NULL, 'IPR006335', NULL, 'Glutathione biosynthesis bifunctional protein GshAB', 'Glut_biosynth', 4, NULL),
(4711, NULL, 'IPR000402', NULL, 'Sodium/potassium-transporting ATPase subunit beta', 'Na/K_ATPase_sub_beta', 4, NULL),
(4712, NULL, 'IPR000799', NULL, 'Steroidogenic acute regulatory protein-like', 'StAR-like', 4, NULL),
(4713, NULL, 'IPR004330', NULL, 'FAR1 DNA binding domain', 'FAR1_DNA_bnd_dom', 3, NULL),
(4714, NULL, 'IPR004298', NULL, 'Nicotianamine synthase', 'Nicotian_synth', 4, NULL),
(4715, NULL, 'IPR006353', NULL, 'HAD-superfamily hydrolase, subfamily IIA, CECR5', 'HAD-SF_hydro_IIA_CECR5', 4, NULL),
(4716, NULL, 'IPR006911', NULL, 'Armadillo repeat-containing domain', 'ARM-rpt_dom', 3, NULL),
(4717, NULL, 'IPR004335', NULL, 'Protein of unknown function DUF244', 'DUF244', 4, NULL),
(4718, NULL, 'IPR007449', NULL, 'ZipA, C-terminal FtsZ-binding domain', 'ZipA_FtsZ-bd_C', 3, NULL),
(4719, NULL, 'IPR000319', NULL, 'Aspartate-semialdehyde dehydrogenase, conserved site', 'Asp-semialdehyde_DH_CS', 2, NULL),
(4720, NULL, 'IPR005166', NULL, 'Rous sarcoma virus, Gp95, envelope protein', 'RSV_p95_env', 4, NULL),
(4721, NULL, 'IPR034575', NULL, 'Outer envelope pore protein 21', 'OEP21', 4, NULL),
(4722, NULL, 'IPR006352', NULL, 'Phosphoglucosamine mutase, bacterial type', 'GlmM_bact', 4, NULL),
(4723, NULL, 'IPR005173', NULL, 'DMRTA motif', 'DMA', 3, NULL),
(4724, NULL, 'IPR007452', NULL, 'Translocation and assembly module TamB', 'TamB', 4, NULL),
(4725, NULL, 'IPR007463', NULL, 'Protein of unknown function DUF507', 'DUF507', 4, NULL),
(4726, NULL, 'IPR004283', NULL, 'Late expression factor 2', 'Lef-2', 4, NULL),
(4727, NULL, 'IPR000263', NULL, 'Geminivirus AR1/BR1 coat protein', 'GV_A/BR1_coat', 4, NULL),
(4728, NULL, 'IPR005749', NULL, 'Ribosomal protein L15, bacterial-type', 'Ribosomal_L15_bac-type', 4, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(4729, NULL, 'IPR000873', NULL, 'AMP-dependent synthetase/ligase', 'AMP-dep_Synth/Lig', 3, NULL),
(4730, NULL, 'IPR006889', NULL, 'Nonstructural protein NSM', 'Bunya_NSM', 4, NULL),
(4731, NULL, 'IPR002772', NULL, 'Glycoside hydrolase family 3 C-terminal domain', 'Glyco_hydro_3_C', 3, NULL),
(4732, NULL, 'IPR006355', NULL, 'HAD hydrolase, LHPP/HDHD2', 'LHPP/HDHD2', 4, NULL),
(4733, NULL, 'IPR000891', NULL, 'Pyruvate carboxyltransferase', 'PYR_CT', 3, NULL),
(4734, NULL, 'IPR004339', NULL, 'UL49-related protein', 'UL49', 4, NULL),
(4735, NULL, 'IPR004313', NULL, 'Acireductone dioxygenase ARD family', 'ARD', 4, NULL),
(4736, NULL, 'IPR006332', NULL, 'Quinol oxidase subunit II', 'QoxA', 4, NULL),
(4737, NULL, 'IPR000752', NULL, 'Flavivirus non-structural protein NS2A', 'Flavi_NS2A', 3, NULL),
(4738, NULL, 'IPR002802', NULL, 'Protein of unknown function DUF99', 'DUF99', 4, NULL),
(4739, NULL, 'IPR007462', NULL, 'Protein CONTINUOUS VASCULAR RING 1-like', 'COV1-like', 4, NULL),
(4740, NULL, 'IPR000840', NULL, 'Gamma-retroviral matrix protein', 'G_retro_matrix', 3, NULL),
(4741, NULL, 'IPR006926', NULL, 'Vps16, N-terminal', 'Vps16_N', 3, NULL),
(4742, NULL, 'IPR005163', NULL, 'YiiM-like, 3-alpha helix domain', 'YiiM-like_3-alpha_domain', 3, NULL),
(4743, NULL, 'IPR001986', NULL, 'Enolpyruvate transferase domain', 'Enolpyruvate_Tfrase_dom', 3, NULL),
(4744, NULL, 'IPR006900', NULL, 'Sec23/Sec24, helical domain', 'Sec23/24_helical_dom', 3, NULL),
(4745, NULL, 'IPR000370', NULL, 'Prostacyclin (prostanoid IP) receptor', 'Prostglndn_IP_rcpt', 4, NULL),
(4746, NULL, 'IPR006323', NULL, 'Phosphonoacetaldehyde hydrolase', 'Phosphonoacetald_hydro', 4, NULL),
(4747, NULL, 'IPR000293', NULL, 'Channel forming colicin, C-terminal cytotoxic', 'Channel_colicin_C', 3, NULL),
(4748, NULL, 'IPR002790', NULL, 'Conserved hypothetical protein CHP00288', 'CHP00288', 4, NULL),
(4749, NULL, 'IPR005761', NULL, 'UDP-N-acetylmuramoylalanyl-D-glutamate-2,6-diaminopimelate ligase', 'UDP-N-AcMur-Glu-dNH2Pim_ligase', 4, NULL),
(4750, NULL, 'IPR006349', NULL, '2-phosphoglycolate phosphatase, eukaryotic', 'PGP_euk', 4, NULL),
(4751, NULL, 'IPR000794', NULL, 'Beta-ketoacyl synthase', 'Beta-ketoacyl_synthase', 4, NULL),
(4752, NULL, 'IPR000333', NULL, 'Ser/Thr protein kinase, TGFB receptor', 'TGFB_receptor', 4, NULL),
(4753, NULL, 'IPR002797', NULL, 'Polysaccharide biosynthesis protein', 'Polysacc_synth', 4, NULL),
(4754, NULL, 'IPR006898', NULL, 'Hepatocyte nuclear factor 1, alpha isoform C-terminal', 'HNF1a_C', 3, NULL),
(4755, NULL, 'IPR000353', NULL, 'MHC class II, beta chain, N-terminal', 'MHC_II_b_N', 3, NULL),
(4756, NULL, 'IPR006907', NULL, 'Disks large homolog 5, N-terminal', 'DLG5_N', 3, NULL),
(4757, NULL, 'IPR006891', NULL, 'Type III secretion protein EspF', 'T3SS_EspF', 7, NULL),
(4758, NULL, 'IPR007444', NULL, 'Glucan biosynthesis, periplasmic, MdoG C-terminal', 'Glucan_biosyn_MdoG_C', 3, NULL),
(4759, NULL, 'IPR002791', NULL, 'Damage-control phosphatase ARMT1-like, metal-binding domain', 'ARMT1-like_metal-bd', 3, NULL),
(4760, NULL, 'IPR006354', NULL, 'HAD-superfamily hydrolase, subfamily IIA, hypothetical 1', 'HAD-SF_hydro_IIA_hyp1', 4, NULL),
(4761, NULL, 'IPR000367', NULL, 'G-protein alpha subunit, group S', 'Gprotein_alpha_S', 4, NULL),
(4762, NULL, 'IPR000334', NULL, 'Glycoside hydrolase, family 45', 'Glyco_hydro_45', 3, NULL),
(4763, NULL, 'IPR005729', NULL, 'Ribosomal protein S10, eukaryotic/archaeal', 'Ribosomal_S10_euk/arc', 4, NULL),
(4764, NULL, 'IPR002015', NULL, 'Proteasome/cyclosome repeat', 'Proteasome/cyclosome_rpt', 7, NULL),
(4765, NULL, 'IPR006341', NULL, 'Acid-soluble spore protein, gamma-type', 'Spore_gamma', 4, NULL),
(4766, NULL, 'IPR002798', NULL, 'Stage II sporulation protein M-like', 'SpoIIM-like', 4, NULL),
(4767, NULL, 'IPR004300', NULL, 'Glycoside hydrolase family 57, N-terminal domain', 'Glyco_hydro_57_N', 3, NULL),
(4768, NULL, 'IPR000857', NULL, 'MyTH4 domain', 'MyTH4_dom', 3, NULL),
(4769, NULL, 'IPR000397', NULL, 'Heat shock protein Hsp33', 'Heat_shock_Hsp33', 4, NULL),
(4770, NULL, 'IPR004321', NULL, 'V-D-J recombination activating protein 2', 'RAG2', 4, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(4771, NULL, 'IPR006325', NULL, 'Signal recognition particle, SRP54 subunit, eukaryotic', 'SRP54_euk', 4, NULL),
(4772, NULL, 'IPR006925', NULL, 'Vps16, C-terminal', 'Vps16_C', 3, NULL),
(4773, NULL, 'IPR006317', NULL, 'Ubiquinol-cytochrome c reductase, iron-sulphur subunit', 'Ubiquinol_cyt_c_Rdtase_Fe-S-su', 3, NULL),
(4774, NULL, 'IPR006345', NULL, 'RecD-like DNA helicase', 'DNA_helicase_RecD-like', 4, NULL),
(4775, NULL, 'IPR005768', NULL, 'Specific amino acids and opine-binding periplasmic protein, ABC transporter', 'Lys_Arg_Orn-bd', 4, NULL),
(4776, NULL, 'IPR006340', NULL, 'Protein of unknown function  DUF436', 'DUF436', 4, NULL),
(4777, NULL, 'IPR006879', NULL, 'Carbohydrate deacetylase YdjC-like', 'YdjC-like', 4, NULL),
(4778, NULL, 'IPR005766', NULL, 'Delta l-pyrroline-5-carboxylate synthetase', 'P5_carboxy_syn', 4, NULL),
(4779, NULL, 'IPR004317', NULL, 'Sigma1/sigma2, reoviral', 'Sigma_1_2_reovir', 4, NULL),
(4780, NULL, 'IPR005721', NULL, 'Ribosomal protein L22/L17, eukaryotic/archaeal', 'Ribosomal_L22/L17_euk/arc', 4, NULL),
(4781, NULL, 'IPR000833', NULL, 'Alpha-amylase inhibitor', 'A-amylase_inhib', 4, NULL),
(4782, NULL, 'IPR000406', NULL, 'Rho protein GDP-dissociation inhibitor', 'Rho_GDI', 4, NULL),
(4783, NULL, 'IPR005759', NULL, 'Endonuclease III', 'Nth', 4, NULL),
(4784, NULL, 'IPR006874', NULL, 'Protein of unknown function DUF621', 'DUF621', 4, NULL),
(4785, NULL, 'IPR000821', NULL, 'Alanine racemase', 'Ala_racemase', 4, NULL),
(4786, NULL, 'IPR005736', NULL, 'Reverse gyrase', 'Reverse_gyrase', 4, NULL),
(4787, NULL, 'IPR005724', NULL, 'ATPase, A1 complex, beta subunit', 'ATPase_A1-cplx_bsu', 4, NULL),
(4788, NULL, 'IPR004278', NULL, 'Putative RNA polymerase (calciviral)/capsid protein', 'RNA_pol/capsid', 4, NULL),
(4789, NULL, 'IPR001781', NULL, 'Zinc finger, LIM-type', 'Znf_LIM', 3, NULL),
(4790, NULL, 'IPR000392', NULL, 'NifH/frxC family', 'NifH/frxC', 4, NULL),
(4791, NULL, 'IPR001746', NULL, 'Polyhedrin', 'Polyhedrin', 4, NULL),
(4792, NULL, 'IPR007308', NULL, 'Rtr1/RPAP2 domain', 'Rtr1/RPAP2_dom', 3, NULL),
(4793, NULL, 'IPR000330', NULL, 'SNF2, N-terminal', 'SNF2_N', 3, NULL),
(4794, NULL, 'IPR007310', NULL, 'Aerobactin siderophore biosynthesis, IucA/IucC, N-terminal', 'Aerobactin_biosyn_IucA/IucC_N', 3, NULL),
(4795, NULL, 'IPR004320', NULL, 'Protein BPS1, chloroplastic', 'BPS1_pln', 4, NULL),
(4796, NULL, 'IPR000387', NULL, 'Tyrosine-specific protein phosphatases domain', 'Tyr_Pase_dom', 3, NULL),
(4797, NULL, 'IPR005772', NULL, 'ATPase, V1 complex, subunit F, eukaryotic', 'ATPase_V1-cplx_fsu_euk', 4, NULL),
(4798, NULL, 'IPR002782', NULL, 'Mut7-C RNAse domain', 'Mut7-C_RNAse_dom', 3, NULL),
(4799, NULL, 'IPR005753', NULL, 'DNA helicase, ATP-dependent, UvrD type', 'DNA_helicase_ATP-dep_UvrD', 4, NULL),
(4800, NULL, 'IPR006327', NULL, 'Phosphotransferase system, fructose IIC component', 'PTS_IIC_fruc', 3, NULL),
(4801, NULL, 'IPR002795', NULL, 'S-adenosylmethionine synthetase, archaea', 'S-AdoMet_synthetase_arc', 4, NULL),
(4802, NULL, 'IPR006312', NULL, 'Sec-independent protein translocase protein TatA/E', 'TatA/E', 4, NULL),
(4803, NULL, 'IPR007448', NULL, 'Regulator of RNA polymerase sigma(70) subunit, Rsd/AlgQ', 'Sigma70_reg_Rsd_AlgQ', 4, NULL),
(4804, NULL, 'IPR001810', NULL, 'F-box domain', 'F-box_dom', 3, NULL),
(4805, NULL, 'IPR004305', NULL, 'Thiaminase-2/PQQC', 'Thiaminase-2/PQQC', 3, NULL),
(4806, NULL, 'IPR000753', NULL, 'Clusterin-like', 'Clusterin-like', 4, NULL),
(4807, NULL, 'IPR002817', NULL, 'Phosphomethylpyrimidine synthase ThiC/5-hydroxybenzimidazole synthase BzaA/B', 'ThiC/BzaA/B', 4, NULL),
(4808, NULL, 'IPR006910', NULL, 'Rad21/Rec8-like protein, N-terminal', 'Rad21_Rec8_N', 3, NULL),
(4809, NULL, 'IPR006350', NULL, 'Intron endonuclease, group I', 'Intron_endoG1', 4, NULL),
(4810, NULL, 'IPR005775', NULL, 'P-type ATPase subfamily IIC, subunit alpha', 'P-type_ATPase_IIC', 4, NULL),
(4811, NULL, 'IPR000286', NULL, 'Histone deacetylase family', 'His_deacetylse', 4, NULL),
(4812, NULL, 'IPR007315', NULL, 'GPI mannosyltransferase 2', 'PIG-V/Gpi18', 4, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(4813, NULL, 'IPR000831', NULL, 'Trp repressor', 'Trp_repress', 4, NULL),
(4814, NULL, 'IPR004303', NULL, 'Protein-arginine deiminase', 'PAD', 4, NULL),
(4815, NULL, 'IPR006909', NULL, 'Rad21/Rec8-like protein, C-terminal, eukaryotic', 'Rad21/Rec8_C_eu', 3, NULL),
(4816, NULL, 'IPR006895', NULL, 'Zinc finger, Sec23/Sec24-type', 'Znf_Sec23_Sec24', 3, NULL),
(4817, NULL, 'IPR007306', NULL, 'tRNA A64-2''-O-ribosylphosphate transferase', 'Rit1', 4, NULL),
(4818, NULL, 'IPR006914', NULL, 'VENN motif-containing domain', 'VENN_dom', 3, NULL),
(4819, NULL, 'IPR007443', NULL, 'Penicillin-binding protein activator LpoA', 'LpoA', 4, NULL),
(4820, NULL, 'IPR007471', NULL, 'N-end aminoacyl transferase, N-terminal', 'N-end_Aminoacyl_Trfase_N', 3, NULL),
(4821, NULL, 'IPR005739', NULL, 'DNA topoisomerase I, archeal-type', 'TopoI_arch', 4, NULL),
(4822, NULL, 'IPR000260', NULL, 'NADH:ubiquinone oxidoreductase chain 4, N-terminal', 'NADH4_N', 3, NULL),
(4823, NULL, 'IPR006333', NULL, 'Cytochrome o ubiquinol oxidase subunit II', 'Cyt_o_ubiquinol_oxidase_su2', 4, NULL),
(4824, NULL, 'IPR006886', NULL, 'DNA-directed RNA polymerase III subunit Rpc5', 'RNA_pol_III_Rpc5', 4, NULL),
(4825, NULL, 'IPR004333', NULL, 'SBP domain', 'SBP_dom', 3, NULL),
(4826, NULL, 'IPR002789', NULL, 'Helicase HerA, central domain', 'HerA_central', 3, NULL),
(4827, NULL, 'IPR002821', NULL, 'Hydantoinase A/oxoprolinase', 'Hydantoinase_A', 3, NULL),
(4828, NULL, 'IPR007312', NULL, 'Phosphoesterase', 'Phosphoesterase', 4, NULL),
(4829, NULL, 'IPR004336', NULL, 'Respiratory synctial virus non-structural protein NS2', 'RSV_NS2', 4, NULL),
(4830, NULL, 'IPR000432', NULL, 'DNA mismatch repair protein MutS, C-terminal', 'DNA_mismatch_repair_MutS_C', 3, NULL),
(4831, NULL, 'IPR007472', NULL, 'N-end rule aminoacyl transferase, C-terminal', 'N-end_Aminoacyl_Trfase_C', 3, NULL),
(4832, NULL, 'IPR006300', NULL, 'Flagellar basal-body rod protein FlgB', 'FlgB', 4, NULL),
(4833, NULL, 'IPR006868', NULL, 'Domain of unknown function DUF630', 'DUF630', 3, NULL),
(4834, NULL, 'IPR006872', NULL, 'Late protein H7, poxvirus', 'Poxvirus_H7', 4, NULL),
(4835, NULL, 'IPR006301', NULL, 'Flagellar biosynthesis protein FlhA', 'FlhA', 4, NULL),
(4836, NULL, 'IPR006884', NULL, 'Fzo/mitofusin HR2 domain', 'Fzo/mitofusin_HR2', 3, NULL),
(4837, NULL, 'IPR005748', NULL, 'DNA mismatch repair protein MutS', 'DNA_mismatch_repair_MutS', 4, NULL),
(4838, NULL, 'IPR005734', NULL, 'DNA topoisomerase VI, subunit B', 'TopoVI_B', 4, NULL),
(4839, NULL, 'IPR000782', NULL, 'FAS1 domain', 'FAS1_domain', 3, NULL),
(4840, NULL, 'IPR002767', NULL, 'Thiamine-binding protein', 'Thiamine_BP', 3, NULL),
(4841, NULL, 'IPR000824', NULL, 'Transcription attenuation protein MtrB', 'MtrB', 4, NULL),
(4842, NULL, 'IPR005752', NULL, 'ATP-dependent DNA helicase Rep', 'Helicase_Rep', 4, NULL),
(4843, NULL, 'IPR001806', NULL, 'Small GTPase', 'Small_GTPase', 4, NULL),
(4844, NULL, 'IPR000336', NULL, 'Flavivirus/Alphavirus glycoprotein, immunoglobulin-like domain superfamily', 'Flavivir/Alphavir_Ig-like_sf', 5, NULL),
(4845, NULL, 'IPR001996', NULL, 'Phosphotransferase system, IIB component, type 1', 'PTS_IIB_1', 3, NULL),
(4846, NULL, 'IPR000750', NULL, 'Proenkephalin B', 'Proenkphlin_B', 4, NULL),
(4847, NULL, 'IPR004285', NULL, 'Herpesvirus UL87, C-terminal', 'Herpes_UL87_C', 3, NULL),
(4848, NULL, 'IPR006338', NULL, 'Thioredoxin/glutathione reductase selenoprotein', 'Thioredoxin/glutathione_Rdtase', 4, NULL),
(4849, NULL, 'IPR005762', NULL, 'UDP-N-acetylmuramoylalanine-D-glutamate ligase MurD', 'MurD', 4, NULL),
(4850, NULL, 'IPR000337', NULL, 'GPCR, family 3', 'GPCR_3', 4, NULL),
(4851, NULL, 'IPR005751', NULL, 'ATP-dependent DNA helicase PcrA', 'ATP-dep_DNA_helicase_PcrA', 4, NULL),
(4852, NULL, 'IPR002794', NULL, 'Protein of unknown function DUF92, TMEM19', 'DUF92_TMEM19', 4, NULL),
(4853, NULL, 'IPR004312', NULL, 'Arabidopsis retrotransposon Orf1', 'ATHILA_Orf1', 4, NULL),
(4854, NULL, 'IPR001815', NULL, 'Trichovirus movement protein', 'Trichovirus_mp', 4, NULL),
(4855, NULL, 'IPR001817', NULL, 'Vasopressin receptor', 'Vasoprsn_rcpt', 4, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(4856, NULL, 'IPR004308', NULL, 'Glutamate-cysteine ligase catalytic subunit', 'GCS', 4, NULL),
(4857, NULL, 'IPR000238', NULL, 'Ribosome-binding factor A', 'RbfA', 4, NULL),
(4858, NULL, 'IPR007453', NULL, 'Sulphur transfer protein DsrC/TusE', 'DsrC/TusE', 4, NULL),
(4859, NULL, 'IPR005719', NULL, 'Dihydroorotate dehydrogenase, class 2', 'Dihydroorotate_DH_2', 4, NULL),
(4860, NULL, 'IPR000403', NULL, 'Phosphatidylinositol 3-/4-kinase, catalytic domain', 'PI3/4_kinase_cat_dom', 3, NULL),
(4861, NULL, 'IPR005723', NULL, 'ATPase, V1 complex, subunit B', 'ATPase_V1-cplx_bsu', 4, NULL),
(4862, NULL, 'IPR006336', NULL, 'Glutamate--cysteine ligase, GCS2', 'GCS2', 4, NULL),
(4863, NULL, 'IPR004327', NULL, 'Phosphotyrosyl phosphatase activator, PTPA', 'Phstyr_phstse_ac', 4, NULL),
(4864, NULL, 'IPR007466', NULL, 'Peptidyl-arginine deiminase, Porphyromonas-type', 'Peptidyl-Arg-deiminase_porph', 4, NULL),
(4865, NULL, 'IPR006890', NULL, 'Sulphydryl oxidase, FAD-linked, ERV1/ALR-type', 'Sulphydryl_Oase_FAD-link_ERV1', 4, NULL),
(4866, NULL, 'IPR000276', NULL, 'G protein-coupled receptor, rhodopsin-like', 'GPCR_Rhodpsn', 4, NULL),
(4867, NULL, 'IPR005771', NULL, 'UTP--glucose-1-phosphate uridylyltransferase, bacterial/archaeal-type', 'GalU_uridylyltTrfase_bac/arc', 4, NULL),
(4868, NULL, 'IPR007473', NULL, 'Ribosomal RNA large subunit methyltransferase J', 'RlmJ', 4, NULL),
(4869, NULL, 'IPR001992', NULL, 'T2SS_GspF/T4SS_PilC conserved site', 'T2SS_GspF/T4SS_PilC_CS', 2, NULL),
(4870, NULL, 'IPR000813', NULL, '7Fe ferredoxin', '7Fe_ferredoxin', 4, NULL),
(4871, NULL, 'IPR000657', NULL, 'Geminivirus AL3 coat protein', 'Gemini_AL3', 4, NULL),
(4872, NULL, 'IPR004332', NULL, 'Transposase, MuDR, plant', 'Transposase_MuDR', 3, NULL),
(4873, NULL, 'IPR004297', NULL, 'Systemic acquired resistance protein SAR', 'Sar8_2', 4, NULL),
(4874, NULL, 'IPR006318', NULL, 'Phosphotransferase system, enzyme I-like', 'PTS_EI-like', 3, NULL),
(4875, NULL, 'IPR002775', NULL, 'DNA/RNA-binding protein Alba-like', 'DNA/RNA-bd_Alba-like', 3, NULL),
(4876, NULL, 'IPR005777', NULL, 'Acetyl-S-ACP:malonate ACP transferase', 'MadA', 4, NULL),
(4877, NULL, 'IPR006893', NULL, 'Citrus tristeza virus P23 protein', 'CTV_P23', 4, NULL),
(4878, NULL, 'IPR006915', NULL, 'Domain of unknown function DUF637, haemagglutinin putative', 'DUF637_hemagglutn_put', 3, NULL),
(4879, NULL, 'IPR031362', NULL, 'Protein BNIP5', 'BNIP5', 4, NULL),
(4880, NULL, 'IPR007455', NULL, 'Serglycin', 'Serglycin', 4, NULL),
(4881, NULL, 'IPR002812', NULL, '3-dehydroquinate synthase', 'DHQ_synth', 4, NULL),
(4882, NULL, 'IPR000254', NULL, 'Cellulose-binding domain, fungal', 'Cellulose-bd_dom_fun', 3, NULL),
(4883, NULL, 'IPR035896', NULL, 'AN1-like Zinc finger', 'AN1-like_Znf', 5, NULL),
(4884, NULL, 'IPR004314', NULL, 'Neprosin', 'Neprosin', 3, NULL),
(4885, NULL, 'IPR006322', NULL, 'Glutathione reductase, eukaryote/bacterial', 'Glutathione_Rdtase_euk/bac', 4, NULL),
(4886, NULL, 'IPR000289', NULL, 'Ribosomal protein S28e', 'Ribosomal_S28e', 4, NULL),
(4887, NULL, 'IPR004344', NULL, 'Tubulin-tyrosine ligase/Tubulin polyglutamylase', 'TTL/TTLL_fam', 4, NULL),
(4888, NULL, 'IPR002808', NULL, 'Adenosylcobinamide amidohydrolase, CbiZ', 'AdoCbi_amidolase', 4, NULL),
(4889, NULL, 'IPR005170', NULL, 'Transporter-associated domain', 'Transptr-assoc_dom', 3, NULL),
(4890, NULL, 'IPR000383', NULL, 'Xaa-Pro dipeptidyl-peptidase-like domain', 'Xaa-Pro-like_dom', 3, NULL),
(4891, NULL, 'IPR005756', NULL, 'Ribosomal protein L26/L24, eukaryotic/archaeal', 'Ribosomal_L26/L24P_euk/arc', 4, NULL),
(4892, NULL, 'IPR004290', NULL, 'Herpesvirus UL79', 'Herpes_UL79', 4, NULL),
(4893, NULL, 'IPR007470', NULL, 'Putative uroporphyrinogen-III C-methyltransferase HemX', 'HemX', 4, NULL),
(4894, NULL, 'IPR007454', NULL, 'Uncharacterised protein family UPF0250, YbeD-like', 'UPF0250_YbeD-like', 4, NULL),
(4895, NULL, 'IPR002771', NULL, 'Multiple antibiotic resistance (MarC)-related', 'Multi_antbiot-R_MarC', 4, NULL),
(4896, NULL, 'IPR006916', NULL, 'Popeye protein', 'Popeye_prot', 4, NULL),
(4897, NULL, 'IPR005763', NULL, 'L-fucose isomerase', 'Fucose_isomerase', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(4898, NULL, 'IPR000884', NULL, 'Thrombospondin type-1 (TSP1) repeat', 'TSP1_rpt', 7, NULL),
(4899, NULL, 'IPR000253', NULL, 'Forkhead-associated (FHA) domain', 'FHA_dom', 3, NULL),
(4900, NULL, 'IPR000818', NULL, 'TEA/ATTS domain', 'TEA/ATTS_dom', 3, NULL),
(4901, NULL, 'IPR007441', NULL, 'Ethanolamine utilisation protein EutH', 'EutH', 4, NULL),
(4902, NULL, 'IPR007460', NULL, 'Ribonuclease toxin, BrnT, of type II toxin-antitoxin system', 'BrnT_toxin', 4, NULL),
(4903, NULL, 'IPR006918', NULL, 'COBRA, plant', 'COBRA_pln', 4, NULL),
(4904, NULL, 'IPR002815', NULL, 'Spo11/DNA topoisomerase VI subunit A', 'Spo11/TopoVI_A', 4, NULL),
(4905, NULL, 'IPR002800', NULL, 'Chorismate pyruvate-lyase Rv2949c-like', 'Rv2949c-like', 4, NULL),
(4906, NULL, 'IPR006873', NULL, 'Protein of unknown function DUF620', 'DUF620', 4, NULL),
(4907, NULL, 'IPR007317', NULL, 'Golgi to ER traffic protein 4', 'GET4', 4, NULL),
(4908, NULL, 'IPR000747', NULL, 'Homeobox domain engrailed', 'Homeobox_engrailed', 3, NULL),
(4909, NULL, 'IPR005747', NULL, 'Endonuclease MutS2', 'MutS2', 4, NULL),
(4910, NULL, 'IPR006913', NULL, 'CENP-V/GFA domain', 'CENP-V/GFA', 3, NULL),
(4911, NULL, 'IPR004291', NULL, 'Transposase IS66, central domain', 'Transposase_IS66_central', 3, NULL),
(4912, NULL, 'IPR000297', NULL, 'Peptidyl-prolyl cis-trans isomerase, PpiC-type', 'PPIase_PpiC', 3, NULL),
(4913, NULL, 'IPR006311', NULL, 'Twin-arginine translocation pathway, signal sequence', 'TAT_signal', 2, NULL),
(4914, NULL, 'IPR004846', NULL, 'Type II/III secretion system', 'T2SS/T3SS', 4, NULL),
(4915, NULL, 'IPR004286', NULL, 'Herpesvirus UL16/UL94', 'Herpes_UL16/UL94', 4, NULL),
(4916, NULL, 'IPR000784', NULL, 'Late protein L2', 'Late_L2', 4, NULL),
(4917, NULL, 'IPR006897', NULL, 'Hepatocyte nuclear factor 1, beta isoform, C-terminal', 'HNF1b_C', 3, NULL),
(4918, NULL, 'IPR006920', NULL, 'Poxvirus A9', 'Poxvirus_A9', 4, NULL),
(4919, NULL, 'IPR006905', NULL, 'Flavin-dependent halogenase', 'Flavin_halogenase', 4, NULL),
(4920, NULL, 'IPR005740', NULL, 'DNA topoisomerase 4 subunit B, Firmicutes/Mollicutes', 'ParE_type2', 4, NULL),
(4921, NULL, 'IPR000838', NULL, 'RNA polymerase sigma factor 70, ECF, conserved site', 'RNA_pol_sigma70_ECF_CS', 2, NULL),
(4922, NULL, 'IPR000274', NULL, 'Adenylate cyclase, class-I', 'Adenylate_cyclase_1', 4, NULL),
(4923, NULL, 'IPR005735', NULL, 'Zinc finger, LSD1-type', 'Znf_LSD1', 3, NULL),
(4924, NULL, 'IPR000787', NULL, 'Peptidase M29', 'Peptidase_M29', 4, NULL),
(4925, NULL, 'IPR000835', NULL, 'MarR-type HTH domain', 'HTH_MarR-typ', 3, NULL),
(4926, NULL, 'IPR005727', NULL, 'Ribosomal protein L22, bacterial/chloroplast-type', 'Ribosomal_L22_bac/chlpt-type', 4, NULL),
(4927, NULL, 'IPR006306', NULL, 'Type III secretion protein HrpO', 'T3SS_HrpO', 4, NULL),
(4928, NULL, 'IPR005764', NULL, 'Adenine phosphoribosyl transferase', 'Ade_phspho_trans', 4, NULL),
(4929, NULL, 'IPR004334', NULL, 'Poxvirus E5R', 'Poxvirus_E5R', 4, NULL),
(4930, NULL, 'IPR000425', NULL, 'Major intrinsic protein', 'MIP', 4, NULL),
(4931, NULL, 'IPR004299', NULL, 'Membrane bound O-acyl transferase, MBOAT', 'MBOAT_fam', 4, NULL),
(4932, NULL, 'IPR000243', NULL, 'Peptidase T1A, proteasome beta-subunit', 'Pept_T1A_subB', 4, NULL),
(4933, NULL, 'IPR006906', NULL, 'Timeless, N-terminal', 'Timeless_N', 3, NULL),
(4934, NULL, 'IPR000421', NULL, 'Coagulation factor 5/8 C-terminal domain', 'FA58C', 3, NULL),
(4935, NULL, 'IPR006922', NULL, 'Mobilization protein MbeB-like', 'MbeB-like', 4, NULL),
(4936, NULL, 'IPR000321', NULL, 'Delta opioid receptor', 'Delta_opi_rcpt', 4, NULL),
(4937, NULL, 'IPR002823', NULL, 'Protein of unknown function DUF112, transmembrane', 'DUF112_TM', 4, NULL),
(4938, NULL, 'IPR005745', NULL, 'Ribosomal protein L14P, bacterial-type', 'Ribosomal_L14P_bac-type', 4, NULL),
(4939, NULL, 'IPR006342', NULL, 'Methyltransferase FkbM', 'FkbM_mtfrase', 3, NULL),
(4940, NULL, 'IPR005765', NULL, 'Uracil phosphoribosyl transferase', 'Ura_phspho_trans', 4, NULL),
(4941, NULL, 'IPR007309', NULL, 'B-block binding subunit of TFIIIC', 'TFIIIC_Bblock-bd', 3, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(4942, NULL, 'IPR006883', NULL, 'Per os infectivity factor 4', 'AcMNPV_PIF-4', 4, NULL),
(4943, NULL, 'IPR023214', NULL, 'HAD superfamily', 'HAD_sf', 5, NULL),
(4944, NULL, 'IPR005755', NULL, 'Ribosomal protein L13, eukaryotic/archaeal', 'Ribosomal_L13_euk/arc', 4, NULL),
(4945, NULL, 'IPR006867', NULL, 'Domain of unknown function DUF632', 'DUF632', 3, NULL),
(4946, NULL, 'IPR000801', NULL, 'Esterase-like', 'Esterase-like', 4, NULL),
(4947, NULL, 'IPR005167', NULL, 'Bunyavirus glycoprotein G1', 'Bunya_G1', 3, NULL),
(4948, NULL, 'IPR005172', NULL, 'CRC domain', 'CRC', 3, NULL),
(4949, NULL, 'IPR004341', NULL, 'CAT RNA-binding domain', 'CAT_RNA-bd_dom', 3, NULL),
(4950, NULL, 'IPR004329', NULL, 'CcmE/CycJ protein', 'CcmE', 4, NULL),
(4951, NULL, 'IPR007464', NULL, 'Bacteriocin, class IId', 'Bacteriocin_IId', 4, NULL),
(4952, NULL, 'IPR023212', NULL, 'Heat shock protein Hsp33, helix hairpin bin domain superfamily', 'Hsp33_helix_hairpin_bin_dom_sf', 5, NULL),
(4953, NULL, 'IPR005754', NULL, 'Sortase family', 'Sortase', 4, NULL),
(4954, NULL, 'IPR001749', NULL, 'GPCR, family 2, gastric inhibitory polypeptide receptor', 'GPCR_2_GIP_rcpt', 4, NULL),
(4955, NULL, 'IPR002784', NULL, 'Ribosomal protein L14e domain', 'Ribosomal_L14e_dom', 3, NULL),
(4956, NULL, 'IPR006308', NULL, 'DNA polymerase III, alpha subunit, Gram-positive type', 'PolC_gram_pos', 4, NULL),
(4957, NULL, 'IPR000349', NULL, 'Large envelope protein S', 'HBV_HBSAG', 4, NULL),
(4958, NULL, 'IPR007445', NULL, 'Type IV pilus inner membrane component PilO', 'PilO', 4, NULL),
(4959, NULL, 'IPR006304', NULL, 'Type III secretion protein SpaR/YscT', 'T3SS_SpaR/YscT', 4, NULL),
(4960, NULL, 'IPR031357', NULL, 'Stealth protein CR3, conserved region 3', 'Stealth_CR3', 3, NULL),
(4961, NULL, 'IPR000326', NULL, 'Phosphatidic acid phosphatase type 2/haloperoxidase', 'P_Acid_Pase_2/haloperoxidase', 3, NULL),
(4962, NULL, 'IPR002777', NULL, 'Prefoldin beta-like', 'PFD_beta-like', 4, NULL),
(4963, NULL, 'IPR000846', NULL, 'Dihydrodipicolinate reductase, N-terminal', 'DapB_N', 3, NULL),
(4964, NULL, 'IPR002774', NULL, 'Flagellin, archaea', 'Flagellin_arc', 4, NULL),
(4965, NULL, 'IPR000300', NULL, 'Inositol polyphosphate-related phosphatase', 'IPPc', 3, NULL),
(4966, NULL, 'IPR007307', NULL, 'Low temperature viability protein Ltv1', 'Ltv1', 4, NULL),
(4967, NULL, 'IPR006904', NULL, 'Protein of unknown function DUF716', 'DUF716', 4, NULL),
(4968, NULL, 'IPR006912', NULL, 'Harbinger transposase-derived protein', 'Harbinger_derived_prot', 4, NULL),
(4969, NULL, 'IPR004323', NULL, 'Divalent ion tolerance protein, CutA', 'Ion_tolerance_CutA', 4, NULL),
(4970, NULL, 'IPR004324', NULL, 'Folate-biopterin transporter', 'FBT', 4, NULL),
(4971, NULL, 'IPR006346', NULL, '2-phosphoglycolate phosphatase-like, prokaryotic', 'PGPase/MupP', 4, NULL),
(4972, NULL, 'IPR031360', NULL, 'Tryptophan transporter TrpP', 'TrpP', 4, NULL),
(4973, NULL, 'IPR004322', NULL, 'Plasmid replicase, bacterial', 'Plasmid_replicase_bac', 4, NULL),
(4974, NULL, 'IPR006298', NULL, 'GTP-binding protein TypA', 'TypA_GTP-bd', 4, NULL),
(4975, NULL, 'IPR004275', NULL, 'Frog antimicrobial peptide, propeptide', 'Frog_antimicrobial_propeptide', 3, NULL),
(4976, NULL, 'IPR004288', NULL, 'Competence protein, ComC', 'Competence_ComC', 4, NULL),
(4977, NULL, 'IPR004328', NULL, 'BRO1 domain', 'BRO1_dom', 3, NULL),
(4978, NULL, 'IPR006299', NULL, 'Flagellar basal-body rod protein FlgC', 'FlgC', 4, NULL),
(4979, NULL, 'IPR006319', NULL, 'Phosphoenolpyruvate synthase', 'PEP_synth', 4, NULL),
(4980, NULL, 'IPR004289', NULL, 'Herpesvirus UL92', 'Herpes_UL92', 4, NULL),
(4981, NULL, 'IPR005728', NULL, 'Rickettsial palindromic element', 'Rickett_RPE', 3, NULL),
(4982, NULL, 'IPR006305', NULL, 'Flagellar biosynthesis protein FliQ', 'FliQ', 4, NULL),
(4983, NULL, 'IPR006356', NULL, 'HAD-superfamily hydrolase, subfamily IIA, hypothetical 3', 'HAD-SF_hydro_IIA_hyp3', 4, NULL),
(4984, NULL, 'IPR007314', NULL, 'Haem-binding uptake, Tiki superfamily, ChaN', 'Cofac_haem-bd_dom', 3, NULL),
(4985, NULL, 'IPR006321', NULL, 'Pilus retraction protein PilT/PilU', 'PilT/PilU', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(4986, NULL, 'IPR005776', NULL, 'Oxaloacetate decarboxylase, alpha subunit', 'OadA', 4, NULL),
(4987, NULL, 'IPR006888', NULL, 'XLR/SYCP3/FAM9 domain', 'XLR/SYCP3/FAM9_dom', 3, NULL),
(4988, NULL, 'IPR005742', NULL, 'DNA topoisomerase IV, subunit A, Gram-negative', 'TopoIV_A_Gneg', 4, NULL),
(4989, NULL, 'IPR007301', NULL, 'TQO small subunit DoxD', 'DoxD', 3, NULL),
(4990, NULL, 'IPR001747', NULL, 'Vitellogenin, N-terminal', 'Vitellogenin_N', 3, NULL),
(4991, NULL, 'IPR000805', NULL, 'Glycoside hydrolase family 26', 'Glyco_hydro_26', 4, NULL),
(4992, NULL, 'IPR007318', NULL, 'Phospholipid methyltransferase', 'Phopholipid_MeTrfase', 4, NULL),
(4993, NULL, 'IPR004311', NULL, 'Vacuolating cytotoxin, putative', 'Vacuolating_cytotoxin_put', 3, NULL),
(4994, NULL, 'IPR002805', NULL, 'Nicotinate-nucleotide-dimethylbenzimidazole phosphoribosyltransferase, archaeal type', 'Nict_dMeBzImd_PRibTrfase_arc', 4, NULL),
(4995, NULL, 'IPR000294', NULL, 'Gamma-carboxyglutamic acid-rich (GLA) domain', 'GLA_domain', 3, NULL),
(4996, NULL, 'IPR000407', NULL, 'Nucleoside phosphatase GDA1/CD39', 'GDA1_CD39_NTPase', 4, NULL),
(4997, NULL, 'IPR005746', NULL, 'Thioredoxin', 'Thioredoxin', 4, NULL),
(4998, NULL, 'IPR004326', NULL, 'Mlo-related protein', 'Mlo', 4, NULL),
(4999, NULL, 'IPR006921', NULL, 'Interferon-related developmental regulator, C-terminal', 'Interferon-rel_develop_reg_C', 3, NULL),
(5000, NULL, 'IPR000323', NULL, 'Copper type II, ascorbate-dependent monooxygenase, N-terminal', 'Cu2_ascorb_mOase_N', 3, NULL),
(5001, NULL, 'IPR001621', NULL, 'Fungal ligninase', 'Ligninase', 4, NULL),
(5002, NULL, 'IPR008003', NULL, 'Protein of unknown function DUF739', 'DUF739', 4, NULL),
(5003, NULL, 'IPR003404', NULL, 'Envelope glycoprotein E, Fc-binding domain', 'Herpes_glycopE_Fc', 3, NULL),
(5004, NULL, 'IPR007326', NULL, 'Lipoprotein-associated domain', 'Lipoprotein-assoc_dom', 3, NULL),
(5005, NULL, 'IPR008031', NULL, 'Monomethylamine methyltransferase MtmB', 'MtmB_MeTrfase', 4, NULL),
(5006, NULL, 'IPR006928', NULL, 'Herpesvirus large tegument protein, USP domain', 'Herpes_teg_USP', 3, NULL),
(5007, NULL, 'IPR001660', NULL, 'Sterile alpha motif domain', 'SAM', 3, NULL),
(5008, NULL, 'IPR001563', NULL, 'Peptidase S10, serine carboxypeptidase', 'Peptidase_S10', 4, NULL),
(5009, NULL, 'IPR002088', NULL, 'Protein prenyltransferase, alpha subunit', 'Prenyl_trans_a', 7, NULL),
(5010, NULL, 'IPR010911', NULL, 'Rab-binding domain', 'Rab_BD', 3, NULL),
(5011, NULL, 'IPR008067', NULL, 'Cytochrome P450, E-class, group I, CYP2A-like', 'Cyt_P450_E_grp-I_CYP2A-like', 4, NULL),
(5012, NULL, 'IPR004786', NULL, '6-phosphogluconate dehydratase', '6-phosphgluc_deHydtase', 4, NULL),
(5013, NULL, 'IPR005298', NULL, 'MAP domain', 'MAP_dom', 3, NULL),
(5014, NULL, 'IPR010038', NULL, 'MoaD, archaeal-type', 'MoaD_arc-typ', 4, NULL),
(5015, NULL, 'IPR005199', NULL, 'Glycoside hydrolase, family 79', 'Glyco_hydro_79', 4, NULL),
(5016, NULL, 'IPR007325', NULL, 'Kynurenine formamidase/cyclase-like', 'KFase/CYL', 4, NULL),
(5017, NULL, 'IPR005312', NULL, 'Protein of unknown function DUF1759', 'DUF1759', 4, NULL),
(5018, NULL, 'IPR004757', NULL, 'Ethanolamine permease', 'EtNH_permease', 4, NULL),
(5019, NULL, 'IPR004759', NULL, 'Glutamate:g-aminobutyrate antiporter', 'Glu_antiport', 4, NULL),
(5020, NULL, 'IPR010245', NULL, 'Chlorophyllide reductase subunit Y', 'BchY', 4, NULL),
(5021, NULL, 'IPR002176', NULL, 'Crossover junction endodeoxyribonuclease RuvC', 'X-over_junc_endoDNase_RuvC', 4, NULL),
(5022, NULL, 'IPR003433', NULL, 'Capsid protein VP4', 'Capsid_VP4_densovirus', 4, NULL),
(5023, NULL, 'IPR001666', NULL, 'Phosphatidylinositol transfer protein', 'PI_transfer', 4, NULL),
(5024, NULL, 'IPR001568', NULL, 'Ribonuclease T2-like', 'RNase_T2-like', 4, NULL),
(5025, NULL, 'IPR010912', NULL, 'Spen paralogue/orthologue C-terminal, metazoa', 'SPOC_met', 3, NULL),
(5026, NULL, 'IPR008011', NULL, 'Complex 1 LYR protein domain', 'Complex1_LYR_dom', 3, NULL),
(5027, NULL, 'IPR002967', NULL, 'Delta tubulin', 'Delta_tubulin', 4, NULL),
(5028, NULL, 'IPR003432', NULL, 'Replication terminator protein', 'RTP', 4, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(5029, NULL, 'IPR008027', NULL, 'Cytochrome b-c1 complex subunit 9', 'QCR9', 4, NULL),
(5030, NULL, 'IPR003392', NULL, 'Protein patched/dispatched', 'Ptc/Disp', 4, NULL),
(5031, NULL, 'IPR004788', NULL, 'Ribose 5-phosphate isomerase, type A', 'Ribose5P_isomerase_type_A', 4, NULL),
(5032, NULL, 'IPR002053', NULL, 'Glycoside hydrolase, family 25', 'Glyco_hydro_25', 4, NULL),
(5033, NULL, 'IPR008004', NULL, 'Protein OCTOPUS-like', 'OCTOPUS-like', 4, NULL),
(5034, NULL, 'IPR010029', NULL, 'Galactonolactone dehydrogenase', 'GL_DH', 4, NULL),
(5035, NULL, 'IPR008012', NULL, 'Proteasome maturation factor Ump1', 'Ump1', 4, NULL),
(5036, NULL, 'IPR004785', NULL, 'Ribose 5-phosphate isomerase B', 'RpiB', 4, NULL),
(5037, NULL, 'IPR002828', NULL, 'Survival protein SurE-like phosphatase/nucleotidase', 'SurE-like_Pase/nucleotidase', 3, NULL),
(5038, NULL, 'IPR006927', NULL, 'Protein of unknown function DUF639', 'DUF639', 4, NULL),
(5039, NULL, 'IPR002170', NULL, 'GPCR, family 2, parathyroid hormone receptor', 'GPCR_2_parathyroid_rcpt', 4, NULL),
(5040, NULL, 'IPR004741', NULL, 'Oxalate/formate antiporter family transporter', 'Oxa_For_antiport_fam_transptr', 4, NULL),
(5041, NULL, 'IPR001584', NULL, 'Integrase, catalytic core', 'Integrase_cat-core', 3, NULL),
(5042, NULL, 'IPR007328', NULL, 'Foot protein 3', 'Mfp-3', 4, NULL),
(5043, NULL, 'IPR005186', NULL, 'FlaG protein', 'FlaG', 4, NULL),
(5044, NULL, 'IPR006932', NULL, 'Holliday junction resolvase, A22', 'HJ-resolvase_A22', 4, NULL),
(5045, NULL, 'IPR005207', NULL, 'Herpesvirus UL14-like', 'Herpes_UL14', 4, NULL),
(5046, NULL, 'IPR008047', NULL, 'Mini-chromosome maintenance complex protein 4', 'MCM_4', 4, NULL),
(5047, NULL, 'IPR004764', NULL, 'Hydrophobe/amphiphile efflux-1 HAE1', 'HAE1', 4, NULL),
(5048, NULL, 'IPR003395', NULL, 'RecF/RecN/SMC, N-terminal', 'RecF/RecN/SMC_N', 3, NULL),
(5049, NULL, 'IPR010050', NULL, '5-methylthioadenosine/S-adenosylhomocysteine nucleosidase, putative', 'MTA_SAH_nuc_hyp', 4, NULL),
(5050, NULL, 'IPR004769', NULL, 'Adenylosuccinate lyase', 'Pur_lyase', 4, NULL),
(5051, NULL, 'IPR002026', NULL, 'Urease, gamma/gamma-beta subunit', 'Urease_gamma/gamma-beta_su', 4, NULL),
(5052, NULL, 'IPR003446', NULL, 'Plasmid replication initiation, RepA', 'Plasmid_replication_init_RepA', 4, NULL),
(5053, NULL, 'IPR007338', NULL, 'Protein of unknown function DUF416', 'DUF416', 4, NULL),
(5054, NULL, 'IPR002107', NULL, 'Rotavirus non-structural protein 4', 'Rotavirus_NSP4', 4, NULL),
(5055, NULL, 'IPR004792', NULL, '3-Dehydro-bile acid delta(4,6)-reductase-like', 'BaiN-like', 4, NULL),
(5056, NULL, 'IPR003442', NULL, 'tRNA threonylcarbamoyl adenosine modification protein TsaE', 'T6A_TsaE', 4, NULL),
(5057, NULL, 'IPR024662', NULL, 'Trafficking protein particle complex II-specific subunit 65', 'Trs65', 4, NULL),
(5058, NULL, 'IPR001598', NULL, 'Transposase, IS30, conserved site', 'Transposase_IS30_CS', 2, NULL),
(5059, NULL, 'IPR004771', NULL, 'K+/H+ exchanger', 'K/H_exchanger', 3, NULL),
(5060, NULL, 'IPR034663', NULL, 'Classical Protein Kinase C alpha, catalytic domain', 'cPKC_alpha', 3, NULL),
(5061, NULL, 'IPR004756', NULL, 'Amino acid permease subfamily', 'AA_permease', 4, NULL),
(5062, NULL, 'IPR005214', NULL, 'IBV 3A protein', 'IBV_3A', 4, NULL),
(5063, NULL, 'IPR001391', NULL, 'Opsin lateral eye type', 'Opsin_lateye', 4, NULL),
(5064, NULL, 'IPR010051', NULL, 'Periplasmic nitrate reductase, large subunit', 'Periplasm_NO3_reductase_lsu', 4, NULL),
(5065, NULL, 'IPR001734', NULL, 'Sodium/solute symporter', 'Na/solute_symporter', 4, NULL),
(5066, NULL, 'IPR001227', NULL, 'Acyl transferase domain superfamily', 'Ac_transferase_dom_sf', 5, NULL),
(5067, NULL, 'IPR008065', NULL, 'Pro-FMRFamide-related neuropeptide FF', 'NPFF', 4, NULL),
(5068, NULL, 'IPR008005', NULL, 'Per os infectivity factor 6', 'PIF6', 4, NULL),
(5069, NULL, 'IPR008030', NULL, 'NmrA-like domain', 'NmrA-like', 3, NULL),
(5070, NULL, 'IPR004768', NULL, 'Oligopeptide transporter', 'Oligopep_transport', 4, NULL),
(5071, NULL, 'IPR002065', NULL, 'Thiol peroxidase Tpx', 'TPX', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(5072, NULL, 'IPR008056', NULL, 'Tapasin', 'Tapasin', 4, NULL),
(5073, NULL, 'IPR004363', NULL, 'Methylglyoxal synthase', 'Methylgl_synth', 4, NULL),
(5074, NULL, 'IPR004349', NULL, 'Vanadium/alternative nitrogenase delta subunit', 'V/Nase_d_su', 4, NULL),
(5075, NULL, 'IPR004357', NULL, 'Type IV secretion system CagX conjugation protein', 'IVSec_CagX', 4, NULL),
(5076, NULL, 'IPR001632', NULL, 'G-protein, beta subunit', 'Gprotein_B', 3, NULL),
(5077, NULL, 'IPR001771', NULL, 'GPCR, family 2, vasoactive intestinal peptide receptor 1', 'GPCR_2_VIP_rcpt_1', 4, NULL),
(5078, NULL, 'IPR001056', NULL, 'Photosystem II reaction centre protein H', 'PSII_PsbH', 4, NULL),
(5079, NULL, 'IPR005185', NULL, 'Inner membrane component domain', 'YccF', 3, NULL),
(5080, NULL, 'IPR004761', NULL, 'Spore germination GerAB', 'Spore_GerAB', 4, NULL),
(5081, NULL, 'IPR001565', NULL, 'Synaptotagmin', 'Synaptotagmin', 3, NULL),
(5082, NULL, 'IPR004784', NULL, 'Galactose-6-phosphate isomerase subunit LacB', 'LacB', 4, NULL),
(5083, NULL, 'IPR004353', NULL, 'Vacuolar fusion protein Mon1', 'Mon1', 4, NULL),
(5084, NULL, 'IPR002068', NULL, 'Alpha crystallin/Hsp20 domain', 'A-crystallin/Hsp20_dom', 3, NULL),
(5085, NULL, 'IPR003429', NULL, 'Baculovirus p35, apoptosis preventing protein', 'Baculovirus_p35', 4, NULL),
(5086, NULL, 'IPR008024', NULL, 'YiaAB two helix', 'YiaAB', 3, NULL),
(5087, NULL, 'IPR004787', NULL, 'Competence protein ComEA', 'Competence_ComE', 4, NULL),
(5088, NULL, 'IPR010023', NULL, 'KdsC family', 'KdsC_fam', 4, NULL),
(5089, NULL, 'IPR005195', NULL, 'Glycoside hydrolase, family 65, central catalytic', 'Glyco_hydro_65_M', 3, NULL),
(5090, NULL, 'IPR004375', NULL, 'NanQ anomerase/TabA/YiaL family', 'NanQ/TabA/YiaL', 4, NULL),
(5091, NULL, 'IPR002191', NULL, 'Bacterial export protein family 3', 'Bac_export_3', 4, NULL),
(5092, NULL, 'IPR005306', NULL, 'Nepovirus coat protein, N-terminal', 'Nepo_coat_N', 3, NULL),
(5093, NULL, 'IPR004780', NULL, 'Signal recognition particle protein', 'SRP', 4, NULL),
(5094, NULL, 'IPR001562', NULL, 'Zinc finger, Btk motif', 'Znf_Btk_motif', 2, NULL),
(5095, NULL, 'IPR001627', NULL, 'Sema domain', 'Semap_dom', 3, NULL),
(5096, NULL, 'IPR002125', NULL, 'Cytidine and deoxycytidylate deaminase domain', 'CMP_dCMP_dom', 3, NULL),
(5097, NULL, 'IPR004373', NULL, 'Peptide chain release factor 1', 'RF-1', 4, NULL),
(5098, NULL, 'IPR003427', NULL, 'Histidine decarboxylase proenzyme', 'His_de-COase_proenz', 4, NULL),
(5099, NULL, 'IPR001566', NULL, '23S rRNA (uracil(1939)-C(5))-methyltransferase RlmD', '23S_rRNA_MeTrfase_RlmD', 4, NULL),
(5100, NULL, 'IPR004789', NULL, 'Acetolactate synthase, small subunit', 'Acetalactate_synth_ssu', 4, NULL),
(5101, NULL, 'IPR010024', NULL, 'Conserved hypothetical protein CHP1671', 'CHP16711', 4, NULL),
(5102, NULL, 'IPR008014', NULL, 'Glycogen synthase kinase-3 binding protein', 'GSK3-bd', 4, NULL),
(5103, NULL, 'IPR004358', NULL, 'Signal transduction histidine kinase-related protein, C-terminal', 'Sig_transdc_His_kin-like_C', 3, NULL),
(5104, NULL, 'IPR002164', NULL, 'Nucleosome assembly protein (NAP)', 'NAP_family', 4, NULL),
(5105, NULL, 'IPR010037', NULL, 'FkbH domain', 'FkbH_domain', 3, NULL),
(5106, NULL, 'IPR010044', NULL, 'Methylthioadenosine phosphorylase  (MTAP)', 'MTAP', 4, NULL),
(5107, NULL, 'IPR001662', NULL, 'Elongation factor 1B gamma, C-terminal', 'EF1B_G_C', 3, NULL),
(5108, NULL, 'IPR005314', NULL, 'Peptidase C50, separase', 'Peptidase_C50', 4, NULL),
(5109, NULL, 'IPR004765', NULL, 'NPC1-like', 'NPC1-like', 4, NULL),
(5110, NULL, 'IPR002835', NULL, 'Phosphoenolpyruvate guanylyltransferase CofC', 'CofC', 4, NULL),
(5111, NULL, 'IPR004346', NULL, 'CagE, TrbE, VirB component of type IV transporter system', 'CagE_TrbE_VirB', 4, NULL),
(5112, NULL, 'IPR001579', NULL, 'Glycosyl hydrolases family 18 (GH18) active site', 'Glyco_hydro_18_chit_AS', 0, NULL),
(5113, NULL, 'IPR002058', NULL, 'PAP/25A-associated', 'PAP_assoc', 3, NULL),
(5114, NULL, 'IPR008062', NULL, 'Inward rectifier potassium channel 13', 'KCNJ13', 4, NULL),
(5115, NULL, 'IPR005317', NULL, 'Dipeptidyl-peptidase 3', 'Dipeptidyl-peptase3', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(5116, NULL, 'IPR004374', NULL, 'Peptide chain release factor 2', 'PrfB', 4, NULL),
(5117, NULL, 'IPR002145', NULL, 'Ribbon-helix-helix protein, CopG', 'CopG', 3, NULL),
(5118, NULL, 'IPR004742', NULL, 'Sialic acid transporter', 'SA_transporter', 4, NULL),
(5119, NULL, 'IPR002837', NULL, 'Protein of unknown function DUF123', 'DUF123', 4, NULL),
(5120, NULL, 'IPR002367', NULL, 'Nociceptin', 'Nociceptin', 4, NULL),
(5121, NULL, 'IPR001101', NULL, 'Plectin repeat', 'Plectin_repeat', 7, NULL),
(5122, NULL, 'IPR002474', NULL, 'Carbamoyl-phosphate synthase small subunit, N-terminal domain', 'CarbamoylP_synth_ssu_N', 3, NULL),
(5123, NULL, 'IPR001559', NULL, 'Phosphotriesterase', 'Phosphotriesterase', 4, NULL),
(5124, NULL, 'IPR002103', NULL, 'Bacterial luciferase/NFP', 'Luciferase_bac/NFP', 4, NULL),
(5125, NULL, 'IPR004794', NULL, 'Riboflavin biosynthesis protein RibD', 'Eubact_RibD', 4, NULL),
(5126, NULL, 'IPR001590', NULL, 'Peptidase M12B, ADAM/reprolysin', 'Peptidase_M12B', 3, NULL),
(5127, NULL, 'IPR002057', NULL, 'Isopenicillin N synthase, conserved site', 'Isopenicillin-N_synth_CS', 2, NULL),
(5128, NULL, 'IPR008018', NULL, 'Bacteriophage tail attachment protein FII', 'Phage_tail_attach_FII', 4, NULL),
(5129, NULL, 'IPR003434', NULL, 'Arterivirus GP2a envelope protein', 'Arteri_GP2a', 4, NULL),
(5130, NULL, 'IPR002037', NULL, 'Glycoside hydrolase, family 8', 'Glyco_hydro_8', 4, NULL),
(5131, NULL, 'IPR005303', NULL, 'MOSC, N-terminal beta barrel', 'MOSC_N', 3, NULL),
(5132, NULL, 'IPR002668', NULL, 'Concentrative nucleoside transporter N-terminal domain', 'CNT_N_dom', 3, NULL),
(5133, NULL, 'IPR010248', NULL, 'Histidine utilization repressor', 'His_ut_repres', 4, NULL),
(5134, NULL, 'IPR008053', NULL, 'Voltage gated sodium channel, alpha-5 subunit', 'Na_channel_a5su', 4, NULL),
(5135, NULL, 'IPR008037', NULL, 'Pacifastin domain', 'Pacifastin_dom', 3, NULL),
(5136, NULL, 'IPR008057', NULL, 'Gamma-aminobutyric-acid A receptor, Rho', 'GABAAa_rho_rcpt', 4, NULL),
(5137, NULL, 'IPR003413', NULL, 'Type II secretion system protein GspI, C-terminal', 'T2SS_GspI_C', 3, NULL),
(5138, NULL, 'IPR003403', NULL, 'Herpesvirus immediate early protein', 'IE68', 4, NULL),
(5139, NULL, 'IPR010251', NULL, 'Magnesium-protoporphyrin IX methyltransferase', 'Mg_prot_MeTrfase', 4, NULL),
(5140, NULL, 'IPR004361', NULL, 'Glyoxalase I', 'Glyoxalase_1', 4, NULL),
(5141, NULL, 'IPR002151', NULL, 'Kinesin light chain', 'Kinesin_light', 4, NULL),
(5142, NULL, 'IPR003423', NULL, 'Outer membrane efflux protein', 'OMP_efflux', 4, NULL),
(5143, NULL, 'IPR001669', NULL, 'Arginine repressor', 'Arg_repress', 4, NULL),
(5144, NULL, 'IPR005311', NULL, 'Penicillin-binding protein, dimerisation domain', 'PBP_dimer', 3, NULL),
(5145, NULL, 'IPR005175', NULL, 'PPC domain', 'PPC_dom', 3, NULL),
(5146, NULL, 'IPR002060', NULL, 'Squalene/phytoene synthase', 'Squ/phyt_synthse', 4, NULL),
(5147, NULL, 'IPR004345', NULL, 'TB2/DP1/HVA22-related protein', 'TB2_DP1_HVA22', 4, NULL),
(5148, NULL, 'IPR002018', NULL, 'Carboxylesterase, type B', 'CarbesteraseB', 3, NULL),
(5149, NULL, 'IPR005182', NULL, 'Domain of unknown function DUF304', 'DUF304', 3, NULL),
(5150, NULL, 'IPR001250', NULL, 'Mannose-6-phosphate isomerase, type I', 'Man6P_Isoase-1', 4, NULL),
(5151, NULL, 'IPR004749', NULL, 'Organic cation transport protein/SVOP', 'Orgcat_transp/SVOP', 4, NULL),
(5152, NULL, 'IPR005177', NULL, 'Bifunctional kinase-pyrophosphorylase', 'Kinase-pyrophosphorylase', 4, NULL),
(5153, NULL, 'IPR003462', NULL, 'Ornithine cyclodeaminase/mu-crystallin', 'ODC_Mu_crystall', 4, NULL),
(5154, NULL, 'IPR003430', NULL, 'Propane/methane/phenol/toluene hydroxylase', 'Phenol_Hydrox', 4, NULL),
(5155, NULL, 'IPR005192', NULL, 'Glycoside hydrolase, family 49, C-terminal', 'Glyco_hydro_49_C', 3, NULL),
(5156, NULL, 'IPR002452', NULL, 'Alpha tubulin', 'Alpha_tubulin', 4, NULL),
(5157, NULL, 'IPR010246', NULL, 'Chlorophyllide reductase iron protein subunit X', 'BchX', 4, NULL),
(5158, NULL, 'IPR008055', NULL, 'Neurotensin/neuromedin N', 'NeurotensiN', 4, NULL),
(5159, NULL, 'IPR004791', NULL, 'UvrABC system, subunit C', 'UvrC', 4, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(5160, NULL, 'IPR001599', NULL, 'Alpha-2-macroglobulin', 'Macroglobln_a2', 3, NULL),
(5161, NULL, 'IPR008054', NULL, 'Voltage gated sodium channel, alpha-8 subunit', 'Na_channel_a8su', 4, NULL),
(5162, NULL, 'IPR002358', NULL, 'Ribosomal protein L6, conserved site', 'Ribosomal_L6_CS', 2, NULL),
(5163, NULL, 'IPR001237', NULL, '43kDa postsynaptic protein', 'Postsynaptic', 4, NULL),
(5164, NULL, 'IPR003426', NULL, 'Bacteriochlorophyll A protein', 'BChl_A', 4, NULL),
(5165, NULL, 'IPR008035', NULL, 'L-proline 3-hydroxylase, C-terminal', 'Pro_3_hydrox_C', 3, NULL),
(5166, NULL, 'IPR005318', NULL, 'Outer membrane porin, bacterial', 'OM_porin_bac', 4, NULL),
(5167, NULL, 'IPR003417', NULL, 'Core-binding factor, beta subunit', 'CBF_beta', 4, NULL),
(5168, NULL, 'IPR001091', NULL, 'Restriction/modification DNA-methyltransferase', 'RM_Methyltransferase', 4, NULL),
(5169, NULL, 'IPR010910', NULL, 'Nitrate/nitrite sensing protein, bacterial', 'Nitrate/nitrite_sensing_bac', 3, NULL),
(5170, NULL, 'IPR003407', NULL, 'Merozoite antigen', 'Merozoite_Agen', 4, NULL),
(5171, NULL, 'IPR003418', NULL, 'Fumarate reductase, subunit D', 'Fumarate_red_D', 4, NULL),
(5172, NULL, 'IPR003460', NULL, 'Insect antifreeze protein motif', 'Insect_antifreeze_prot_motif', 7, NULL),
(5173, NULL, 'IPR010054', NULL, 'Type II secretion system  protein GspG', 'Type2_sec_GspG', 4, NULL),
(5174, NULL, 'IPR005308', NULL, 'Orn/Lys/Arg decarboxylase, N-terminal', 'OKR_de-COase_N', 3, NULL),
(5175, NULL, 'IPR001758', NULL, 'Prostanoid EP4 receptor', 'Prost_EP4_rcpt', 4, NULL),
(5176, NULL, 'IPR001561', NULL, 'Influenza matrix M1, N-terminal', 'Flu_matrix_M1_N', 3, NULL),
(5177, NULL, 'IPR010035', NULL, 'ThiS, thiamine-biosynthesis', 'Thi_S', 4, NULL),
(5178, NULL, 'IPR008007', NULL, 'Peptidase M42', 'Peptidase_M42', 4, NULL),
(5179, NULL, 'IPR010026', NULL, 'Phage holin, LL-H family', 'Phage_holin_LL-H', 4, NULL),
(5180, NULL, 'IPR001655', NULL, 'Neutrophil cytosol factor 1', 'P47PHOX', 4, NULL),
(5181, NULL, 'IPR010031', NULL, 'L-gulonolactone/D-arabinono-1,4-lactone oxidase-like', 'FAD_lactone_oxidase-like', 4, NULL),
(5182, NULL, 'IPR004783', NULL, 'Galactose-6-phosphate isomerase subunit LacA', 'LacA', 4, NULL),
(5183, NULL, 'IPR010036', NULL, 'Magnesium-dependent phosphatase-1, eukaryotic/archaeal-type', 'MDP_1_eu_arc', 4, NULL),
(5184, NULL, 'IPR004745', NULL, 'Na-dependent inorganic phosphate cotransporter', 'Pi_cotranspt', 4, NULL),
(5185, NULL, 'IPR007335', NULL, 'Protein of unknown function DUF413', 'DUF413', 4, NULL),
(5186, NULL, 'IPR002284', NULL, 'GPCR, family 2, vasoactive intestinal peptide receptor 2', 'GPCR_2_VIP_rcpt_2', 4, NULL),
(5187, NULL, 'IPR008034', NULL, 'Delta-hemolysin', 'Delta_lysin', 4, NULL),
(5188, NULL, 'IPR003410', NULL, 'HYR domain', 'HYR_dom', 3, NULL),
(5189, NULL, 'IPR002161', NULL, 'Pyridoxal 5''-phosphate synthase subunit PdxT/SNO', 'PdxT/SNO', 4, NULL),
(5190, NULL, 'IPR001648', NULL, 'Ribosomal protein S18', 'Ribosomal_S18', 4, NULL),
(5191, NULL, 'IPR010249', NULL, 'Bacteriochlorophyll 4-vinyl reductase', 'BchJ', 4, NULL),
(5192, NULL, 'IPR004738', NULL, 'Phosphate permease', 'Phos_permease', 4, NULL),
(5193, NULL, 'IPR006930', NULL, 'Herpesvirus pp38 phosphoprotein', 'Herpes_pp38', 4, NULL),
(5194, NULL, 'IPR004775', NULL, 'Na(+)/H(+) antiporter subunit D1', 'MnhD1', 4, NULL),
(5195, NULL, 'IPR003445', NULL, 'Cation transporter', 'Cat_transpt', 4, NULL),
(5196, NULL, 'IPR002076', NULL, 'ELO family', 'ELO_fam', 4, NULL),
(5197, NULL, 'IPR008008', NULL, 'Domain of unknown function DUF746', 'DUF746', 3, NULL),
(5198, NULL, 'IPR003393', NULL, 'Ammonia monooxygenase/particulate methane monooxygenase, subunit A', 'NH3_CH4_mOase_A', 4, NULL),
(5199, NULL, 'IPR008032', NULL, 'Protein of unknown function DUF749', 'DUF749', 4, NULL),
(5200, NULL, 'IPR008015', NULL, 'GMP phosphodiesterase, delta subunit', 'PDED_dom', 3, NULL),
(5201, NULL, 'IPR008020', NULL, 'Capsid protein G8P', 'G8P', 4, NULL),
(5202, NULL, 'IPR003447', NULL, 'FemABX peptidyl transferase', 'FEMABX', 4, NULL),
(5203, NULL, 'IPR001619', NULL, 'Sec1-like protein', 'Sec1-like', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(5204, NULL, 'IPR002408', NULL, 'Natriuretic peptide, brain type', 'Natriuretic_peptide_brain', 4, NULL),
(5205, NULL, 'IPR004798', NULL, 'Calcium/proton exchanger CAX-like', 'CAX-like', 4, NULL),
(5206, NULL, 'IPR010016', NULL, 'KipI family', 'KipI_fam', 4, NULL),
(5207, NULL, 'IPR010030', NULL, 'L-gulonolactone oxidase, plant', 'GULO_Plant', 4, NULL),
(5208, NULL, 'IPR001651', NULL, 'Gastrin/cholecystokinin peptide hormone', 'Gastrin/CCK', 3, NULL),
(5209, NULL, 'IPR001569', NULL, 'Ribosomal protein L37e', 'Ribosomal_L37e', 4, NULL),
(5210, NULL, 'IPR004754', NULL, 'Amino acid antiporter', 'Amino_acid_antiprt', 4, NULL),
(5211, NULL, 'IPR003420', NULL, 'Methanol dehydrogenase, beta subunit', 'Meth_DH_bsu', 4, NULL),
(5212, NULL, 'IPR004772', NULL, 'TrkH potassium transport family', 'TrkH', 4, NULL),
(5213, NULL, 'IPR001608', NULL, 'Alanine racemase, N-terminal', 'Ala_racemase_N', 3, NULL),
(5214, NULL, 'IPR002140', NULL, 'Ribosome maturation protein Sdo1/SBDS', 'Sdo1/SBDS', 4, NULL),
(5215, NULL, 'IPR003457', NULL, 'Mercuric transport protein MerT', 'Transprt_MerT', 4, NULL),
(5216, NULL, 'IPR001524', NULL, 'Glycoside hydrolase, family 6, conserved site', 'Glyco_hydro_6_CS', 2, NULL),
(5217, NULL, 'IPR002340', NULL, 'Hemoglobin, zeta', 'Hemoglobin_zeta', 4, NULL),
(5218, NULL, 'IPR004773', NULL, 'Potassium/sodium  transporter Trk/HKT', 'K/Na_transp_Trk/HKT', 4, NULL),
(5219, NULL, 'IPR001793', NULL, 'Retinal pigment epithelium GPCR', 'RPE_GPCR', 4, NULL),
(5220, NULL, 'IPR003400', NULL, 'Biopolymer transport protein ExbD/TolR', 'ExbD', 4, NULL),
(5221, NULL, 'IPR005176', NULL, 'Potentiating neddylation domain', 'PONY_dom', 3, NULL),
(5222, NULL, 'IPR001605', NULL, 'Pleckstrin homology domain, spectrin-type', 'PH_dom-spectrin-type', 3, NULL),
(5223, NULL, 'IPR008051', NULL, 'Voltage gated sodium channel, alpha-1 subunit', 'Na_channel_a1su', 4, NULL),
(5224, NULL, 'IPR003450', NULL, 'Replication origin-binding protein', 'Replication_origin-bd', 3, NULL),
(5225, NULL, 'IPR003437', NULL, 'Glycine dehydrogenase (decarboxylating)', 'GcvP', 4, NULL),
(5226, NULL, 'IPR002138', NULL, 'Peptidase C14, caspase non-catalytic subunit p10', 'Pept_C14_p10', 3, NULL),
(5227, NULL, 'IPR001611', NULL, 'Leucine-rich repeat', 'Leu-rich_rpt', 7, NULL),
(5228, NULL, 'IPR008049', NULL, 'DNA replication licensing factor Mcm6', 'MCM6', 4, NULL),
(5229, NULL, 'IPR007330', NULL, 'MIT domain', 'MIT_dom', 3, NULL),
(5230, NULL, 'IPR004364', NULL, 'Aminoacyl-tRNA synthetase, class II (D/K/N)', 'Aa-tRNA-synt_II', 3, NULL),
(5231, NULL, 'IPR008028', NULL, 'Sarcolipin', 'Sarcolipin', 4, NULL),
(5232, NULL, 'IPR013146', NULL, 'LEM-like domain', 'LEM-like_dom', 3, NULL),
(5233, NULL, 'IPR002130', NULL, 'Cyclophilin-type peptidyl-prolyl cis-trans isomerase domain', 'Cyclophilin-type_PPIase_dom', 3, NULL),
(5234, NULL, 'IPR004372', NULL, 'Acetate/propionate kinase', 'Ac/propionate_kinase', 4, NULL),
(5235, NULL, 'IPR003443', NULL, 'Interleukin-15/Interleukin-21 family', 'IL-15/IL-21_fam', 4, NULL),
(5236, NULL, 'IPR001426', NULL, 'Tyrosine-protein kinase, receptor class V, conserved site', 'Tyr_kinase_rcpt_V_CS', 2, NULL),
(5237, NULL, 'IPR001614', NULL, 'Myelin proteolipid protein PLP', 'Myelin_PLP', 4, NULL),
(5238, NULL, 'IPR010025', NULL, 'HAD-superfamily phosphatase, subfamily IIIB, AphA', 'HAD-SF_ppase_IIIB_AphA', 4, NULL),
(5239, NULL, 'IPR008063', NULL, 'Fas receptor', 'Fas_rcpt', 4, NULL),
(5240, NULL, 'IPR008060', NULL, 'Glycine receptor beta', 'Glycine_rcpt_B', 4, NULL),
(5241, NULL, 'IPR001667', NULL, 'DDH domain', 'DDH_dom', 3, NULL),
(5242, NULL, 'IPR002072', NULL, 'Nerve growth factor-related', 'Nerve_growth_factor-rel', 3, NULL),
(5243, NULL, 'IPR008066', NULL, 'Cytochrome P450, E-class, group I, CYP1', 'Cyt_P450_E_grp-I_CYP1', 4, NULL),
(5244, NULL, 'IPR001905', NULL, 'Ammonium transporter', 'Ammonium_transpt', 4, NULL),
(5245, NULL, 'IPR010028', NULL, 'Acid phosphatase, plant', 'Acid_phosphatase_pln', 4, NULL),
(5246, NULL, 'IPR001593', NULL, 'Ribosomal protein S3Ae', 'Ribosomal_S3Ae', 4, NULL),
(5247, NULL, 'IPR002062', NULL, 'Oxytocin receptor', 'Oxytocn_rcpt', 4, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(5248, NULL, 'IPR002253', NULL, 'Flavin monooxygenase (FMO) 1', 'Flavin_mOase_1', 4, NULL),
(5249, NULL, 'IPR002074', NULL, 'Somatostatin receptor 2', 'Somatstn_rcpt_2', 4, NULL),
(5250, NULL, 'IPR010057', NULL, 'Transcription activator MutR, C-terminal', 'Transcription_activator_MutR_C', 3, NULL),
(5251, NULL, 'IPR008041', NULL, 'Peptidase C23', 'Peptidase_C23', 3, NULL),
(5252, NULL, 'IPR008042', NULL, 'Retrotransposon, Pao', 'Retrotrans_Pao', 4, NULL),
(5253, NULL, 'IPR002099', NULL, 'DNA mismatch repair protein family, N-terminal', 'DNA_mismatch_repair_N', 3, NULL),
(5254, NULL, 'IPR003428', NULL, 'Mitochondrial glycoprotein', 'MAM33', 4, NULL),
(5255, NULL, 'IPR002469', NULL, 'Dipeptidylpeptidase IV, N-terminal domain', 'Peptidase_S9B_N', 3, NULL),
(5256, NULL, 'IPR008026', NULL, 'Herpesvirus ICP47', 'Herpes_ICP47', 4, NULL),
(5257, NULL, 'IPR002033', NULL, 'Sec-independent periplasmic protein translocase TatC', 'TatC', 4, NULL),
(5258, NULL, 'IPR008052', NULL, 'Voltage gated sodium channel, alpha-4 subunit, mammalian', 'Na_channel_a4su_mammal', 4, NULL),
(5259, NULL, 'IPR002831', NULL, 'Transcription regulator TrmB, N-terminal', 'Tscrpt_reg_TrmB_N', 3, NULL),
(5260, NULL, 'IPR008068', NULL, 'Cytochrome P450, E-class, group I, CYP2B-like', 'Cyt_P450_E_grp-I_CYP2B-like', 4, NULL),
(5261, NULL, 'IPR008016', NULL, 'Portal protein Gp10', 'Gp10', 4, NULL),
(5262, NULL, 'IPR010055', NULL, 'Type II secretion system protein GspJ', 'T2SS_protein-GspJ', 4, NULL),
(5263, NULL, 'IPR003425', NULL, 'CCB3/YggT', 'CCB3/YggT', 4, NULL),
(5264, NULL, 'IPR001592', NULL, 'Potyvirus coat protein', 'Poty_coat', 4, NULL),
(5265, NULL, 'IPR005178', NULL, 'Organic solute transporter subunit alpha/Transmembrane protein 184', 'Ostalpha/TMEM184C', 4, NULL),
(5266, NULL, 'IPR001581', NULL, 'Leukemia inhibitory factor /oncostatin', 'Leukemia_IF/oncostatin', 4, NULL),
(5267, NULL, 'IPR005300', NULL, 'Lytic transglycosylase MltA, domain B', 'MltA_B', 3, NULL),
(5268, NULL, 'IPR005196', NULL, 'Glycoside hydrolase, family 65, N-terminal', 'Glyco_hydro_65_N', 3, NULL),
(5269, NULL, 'IPR005202', NULL, 'Transcription factor GRAS', 'TF_GRAS', 4, NULL),
(5270, NULL, 'IPR008043', NULL, 'Peptidase C21', 'Peptidase_C21', 3, NULL),
(5271, NULL, 'IPR004739', NULL, 'GMP synthase, glutamine amidotransferase', 'GMP_synth_GATase', 3, NULL),
(5272, NULL, 'IPR010239', NULL, 'Conserved hypothetical protein CHP02001', 'CHP02001', 4, NULL),
(5273, NULL, 'IPR001723', NULL, 'Nuclear hormone receptor', 'Nuclear_hrmn_rcpt', 4, NULL),
(5274, NULL, 'IPR001525', NULL, 'C-5 cytosine methyltransferase', 'C5_MeTfrase', 4, NULL),
(5275, NULL, 'IPR002034', NULL, 'Alpha-isopropylmalate/homocitrate synthase, conserved site', 'AIPM/Hcit_synth_CS', 2, NULL),
(5276, NULL, 'IPR010052', NULL, 'Type II secretion system protein GspI', 'T2SS_protein-GspI', 4, NULL),
(5277, NULL, 'IPR008048', NULL, 'DNA replication licensing factor Mcm5', 'MCM5', 4, NULL),
(5278, NULL, 'IPR002391', NULL, 'Annexin A4', 'ANX4', 4, NULL),
(5279, NULL, 'IPR001272', NULL, 'Phosphoenolpyruvate carboxykinase, ATP-utilising', 'PEP_carboxykinase_ATP', 4, NULL),
(5280, NULL, 'IPR003441', NULL, 'NAC domain', 'NAC-dom', 3, NULL),
(5281, NULL, 'IPR001108', NULL, 'Peptidase A22A, presenilin', 'Peptidase_A22A', 4, NULL),
(5282, NULL, 'IPR002148', NULL, 'Rotavirus non-structural protein 1', 'Rotavirus_NSP1', 4, NULL),
(5283, NULL, 'IPR008050', NULL, 'DNA replication licensing factor Mcm7', 'MCM7', 4, NULL),
(5284, NULL, 'IPR004770', NULL, 'Na+/H+ antiporter NhaC', 'Na/H_antiport_NhaC', 4, NULL),
(5285, NULL, 'IPR004347', NULL, 'Pup ligase/deamidase', 'Pup_ligase/deamidase', 4, NULL),
(5286, NULL, 'IPR004356', NULL, 'Adhesin operon regulatory protein', 'Adhesin_operon_reg_prot', 4, NULL),
(5287, NULL, 'IPR004367', NULL, 'Cyclin, C-terminal domain', 'Cyclin_C-dom', 3, NULL),
(5288, NULL, 'IPR003449', NULL, 'Coronavirus protein 7', 'Corona_7', 4, NULL),
(5289, NULL, 'IPR010056', NULL, 'Phage replisome organiser, N-terminal domain', 'Phage_rep_org__N', 3, NULL),
(5290, NULL, 'IPR002836', NULL, 'PDCD5-like', 'PDCD5-like', 4, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(5291, NULL, 'IPR005213', NULL, 'HGWP repeat', 'HGWP_repeat', 7, NULL),
(5292, NULL, 'IPR004352', NULL, 'Glycoside-hydrolase family GH114, TIM-barrel domain', 'GH114_TIM-barrel', 3, NULL),
(5293, NULL, 'IPR002133', NULL, 'S-adenosylmethionine synthetase', 'S-AdoMet_synthetase', 4, NULL),
(5294, NULL, 'IPR008025', NULL, 'CPI-17', 'CPI-17', 4, NULL),
(5295, NULL, 'IPR004743', NULL, 'Monocarboxylate transporter', 'MCT', 4, NULL),
(5296, NULL, 'IPR005174', NULL, 'Domain unknown function DUF295', 'DUF295', 3, NULL),
(5297, NULL, 'IPR005181', NULL, 'Sialate O-acetylesterase domain', 'SASA', 3, NULL),
(5298, NULL, 'IPR004755', NULL, 'Cationic amino acid transport permease', 'Cat_AA_permease', 4, NULL),
(5299, NULL, 'IPR004778', NULL, 'Homoserine/Threonine efflux protein', 'Homoserine/Threonine_efflux', 4, NULL),
(5300, NULL, 'IPR002830', NULL, 'UbiD decarboxylyase family', 'UbiD', 4, NULL),
(5301, NULL, 'IPR010238', NULL, 'NIF system FeS cluster assembly, NifU', 'NIF_FeS_clus_asmbl_NifU', 4, NULL),
(5302, NULL, 'IPR007331', NULL, 'Htaa', 'Htaa', 3, NULL),
(5303, NULL, 'IPR003452', NULL, 'Stem cell factor', 'SCF', 4, NULL),
(5304, NULL, 'IPR010914', NULL, 'RsgA GTPase domain', 'RsgA_GTPase_dom', 3, NULL),
(5305, NULL, 'IPR010048', NULL, 'Hydroxylamine reductase', 'Hydroxylam_reduct', 4, NULL),
(5306, NULL, 'IPR002204', NULL, '3-hydroxyisobutyrate dehydrogenase-related, conserved site', '3-OH-isobutyrate_DH-rel_CS', 2, NULL),
(5307, NULL, 'IPR010046', NULL, 'Oxidoreductase alpha (molybdopterin) subunit', 'Mopterin_OxRdtse_a_bac', 4, NULL),
(5308, NULL, 'IPR005184', NULL, 'Domain of unknown function DUF306, Meta/HslJ', 'DUF306_Meta_HslJ', 3, NULL),
(5309, NULL, 'IPR005310', NULL, 'PapG, carbohydrate-binding domain', 'PapG_carb-bd_N', 3, NULL),
(5310, NULL, 'IPR001657', NULL, 'Hedgehog protein', 'Hedgehog', 4, NULL),
(5311, NULL, 'IPR001538', NULL, 'Mannose-6-phosphate isomerase, type II, C-terminal', 'Man6P_isomerase-2_C', 3, NULL),
(5312, NULL, 'IPR003459', NULL, 'Borrelia plasmid, OrfA', 'Borrelia_plasmid_OrfA', 4, NULL),
(5313, NULL, 'IPR004360', NULL, 'Glyoxalase/fosfomycin resistance/dioxygenase domain', 'Glyas_Fos-R_dOase_dom', 3, NULL),
(5314, NULL, 'IPR008010', NULL, 'Tapt1 family', 'Tatp1', 4, NULL),
(5315, NULL, 'IPR005189', NULL, 'Focal adhesion kinase, targeting (FAT) domain', 'Focal_adhesion_kin_target_dom', 3, NULL),
(5316, NULL, 'IPR003436', NULL, 'Chordopoxvirus fusion protein/multifunctional envelope protein A27', 'Chordopox_Fusion/A27', 4, NULL),
(5317, NULL, 'IPR008070', NULL, 'Cytochrome P450, E-class, group I, CYP2E-like', 'Cyt_P450_E_grp-I_CYP2E-like', 4, NULL),
(5318, NULL, 'IPR008019', NULL, 'Apolipoprotein C-II', 'Apo-CII', 4, NULL),
(5319, NULL, 'IPR005304', NULL, 'Ribosomal biogenesis, methyltransferase, EMG1/NEP1', 'Rbsml_bgen_MeTrfase_EMG1/NEP1', 4, NULL),
(5320, NULL, 'IPR008023', NULL, 'Protein of unknown function DUF748', 'DUF748', 4, NULL),
(5321, NULL, 'IPR003421', NULL, 'Opine dehydrogenase', 'Opine_DH', 3, NULL),
(5322, NULL, 'IPR008029', NULL, 'Bacteriophage T7, Gp3, endodeoxynuclease I', 'Phage_T7_Gp3_endoDNaseI', 4, NULL),
(5323, NULL, 'IPR004766', NULL, 'Transmembrane receptor, patched', 'TM_rcpt_patched', 4, NULL),
(5324, NULL, 'IPR003458', NULL, 'Bacteriophage T4, Gp38, tail fibre assembly', 'Phage_T4_Gp38_tail_assem', 4, NULL),
(5325, NULL, 'IPR001550', NULL, 'Transcription antiterminator, conserved site', 'Transcrpt_antitermin_CS', 2, NULL),
(5326, NULL, 'IPR002056', NULL, 'Protein import receptor MAS20', 'MAS20', 4, NULL),
(5327, NULL, 'IPR002272', NULL, 'Follicle stimulating hormone receptor', 'FSH_rcpt', 4, NULL),
(5328, NULL, 'IPR007337', NULL, 'RelB antitoxin/Antitoxin DinJ', 'RelB/DinJ', 4, NULL),
(5329, NULL, 'IPR003454', NULL, 'Monooxygenase component MmoB/DmpM', 'MOase_MmoB_DmpM', 4, NULL),
(5330, NULL, 'IPR001612', NULL, 'Caveolin', 'Caveolin', 4, NULL),
(5331, NULL, 'IPR005183', NULL, 'Domain of unknown function DUF305, CopM-like', 'DUF305_CopM-like', 3, NULL),
(5332, NULL, 'IPR006933', NULL, 'HAP1, N-terminal', 'HAP1_N', 3, NULL),
(5333, NULL, 'IPR001560', NULL, 'Bombesin receptor type 3', 'Bombesin_rcpt_3', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(5334, NULL, 'IPR004751', NULL, 'Drug antiporter protein', 'Drug_antiport', 4, NULL),
(5335, NULL, 'IPR007327', NULL, 'Tumour protein D52', 'TPD52', 4, NULL),
(5336, NULL, 'IPR004355', NULL, 'Type IV secretion system CagA exotoxin', 'IVSec_CagA', 4, NULL),
(5337, NULL, 'IPR010242', NULL, 'Transcription factor HTH,  IscR', 'TF_HTH_IscR', 4, NULL),
(5338, NULL, 'IPR010022', NULL, 'Protein of unknown function XkdX', 'XkdX', 4, NULL),
(5339, NULL, 'IPR005203', NULL, 'Hemocyanin, C-terminal', 'Hemocyanin_C', 3, NULL),
(5340, NULL, 'IPR008061', NULL, 'Potassium channel, inwardly rectifying, Kir5', 'K_chnl_inward-rec_Kir5', 4, NULL),
(5341, NULL, 'IPR004762', NULL, 'Amino acid permease, fungi', 'Amino_acid_permease_fungi', 4, NULL),
(5342, NULL, 'IPR001297', NULL, 'Phycobilisome linker domain', 'PBS_linker_dom', 3, NULL),
(5343, NULL, 'IPR004259', NULL, 'Phosphoprotein', 'PP_M1', 4, NULL),
(5344, NULL, 'IPR003451', NULL, '4-hydroxy-3-methylbut-2-enyl diphosphate reductase', 'LytB/IspH', 4, NULL),
(5345, NULL, 'IPR005313', NULL, 'Peptidase N2', 'Peptidase_N2', 4, NULL),
(5346, NULL, 'IPR001927', NULL, 'Sodium:galactoside symporter', 'Na/Gal_symport', 3, NULL),
(5347, NULL, 'IPR001588', NULL, 'Casein, alpha/beta', 'Casein', 4, NULL),
(5348, NULL, 'IPR004369', NULL, 'Prolyl-tRNA editing protein, YbaK/EbsC', 'Prolyl-tRNA_editing_YbaK/EbsC', 4, NULL),
(5349, NULL, 'IPR003414', NULL, 'Polyphosphate kinase', 'PP_kinase', 4, NULL),
(5350, NULL, 'IPR008069', NULL, 'Cytochrome P450, E-class, group I, CYP2D-like', 'Cyt_P450_E_grp-I_CYP2D-like', 4, NULL),
(5351, NULL, 'IPR001631', NULL, 'DNA topoisomerase I', 'TopoI', 4, NULL),
(5352, NULL, 'IPR008036', NULL, 'Conotoxin, mu-type', 'Conotoxin_mu-typ', 4, NULL),
(5353, NULL, 'IPR007332', NULL, 'Protein of unknown function DUF411', 'DUF411', 4, NULL),
(5354, NULL, 'IPR008040', NULL, 'Hydantoinase/oxoprolinase, N-terminal', 'Hydant_A_N', 3, NULL),
(5355, NULL, 'IPR004750', NULL, 'Sugar efflux', 'Sugar_efflux', 4, NULL),
(5356, NULL, 'IPR003440', NULL, 'Glycosyl transferase, family 48', 'Glyco_trans_48', 4, NULL),
(5357, NULL, 'IPR004797', NULL, 'Competence protein ComEC/Rec2', 'Competence_ComEC/Rec2', 4, NULL),
(5358, NULL, 'IPR005295', NULL, 'IBV 3B protein', 'IBV_3B', 4, NULL),
(5359, NULL, 'IPR001616', NULL, 'Alphaherpesvirus alkaline exonuclease', 'Herpes_alk_exo', 4, NULL),
(5360, NULL, 'IPR003439', NULL, 'ABC transporter-like, ATP-binding domain', 'ABC_transporter-like_ATP-bd', 3, NULL),
(5361, NULL, 'IPR002399', NULL, 'Cytochrome P450, mitochondrial', 'Cyt_P450_mitochondrial', 4, NULL),
(5362, NULL, 'IPR003435', NULL, 'Chaperonin-like RbcX', 'Chaperonin_RcbX', 4, NULL),
(5363, NULL, 'IPR002108', NULL, 'Actin-depolymerising factor homology domain', 'ADF-H', 3, NULL),
(5364, NULL, 'IPR023220', NULL, 'Type IV secretion system, VirB5-domain', 'T4SS_VirB5-domain', 5, NULL),
(5365, NULL, 'IPR003409', NULL, 'MORN motif', 'MORN', 7, NULL),
(5366, NULL, 'IPR001646', NULL, 'Pentapeptide repeat', '5peptide_repeat', 7, NULL),
(5367, NULL, 'IPR001577', NULL, 'Peptidase M8, leishmanolysin', 'Peptidase_M8', 4, NULL),
(5368, NULL, 'IPR005200', NULL, 'Endo-1,3(4)-beta-glucanase', 'Endo-beta-glucanase', 4, NULL),
(5369, NULL, 'IPR004746', NULL, 'Major facilitator superfamily, aromatic acid:H+ symporter family', 'MFS_AAHS', 4, NULL),
(5370, NULL, 'IPR007334', NULL, 'Uncharacterised protein family UPF0208', 'UPF0208', 4, NULL),
(5371, NULL, 'IPR003453', NULL, 'ABC transport permease subunit MlaE, Proteobacteria', 'ABC_MlaE_Proteobac', 4, NULL),
(5372, NULL, 'IPR004747', NULL, 'Cyanate transport system protein', 'Cyan_transport', 4, NULL),
(5373, NULL, 'IPR002457', NULL, 'GPCR family 3, gamma-aminobutyric acid receptor, type B2', 'GPCR_3_GABA_rcpt_B2', 4, NULL),
(5374, NULL, 'IPR010241', NULL, 'Ferredoxin [2Fe-2S], plant', 'Fd_pln', 4, NULL),
(5375, NULL, 'IPR003444', NULL, 'Transcriptional regulator MraZ', 'MraZ', 4, NULL),
(5376, NULL, 'IPR001891', NULL, 'Malic oxidoreductase', 'Malic_OxRdtase', 4, NULL),
(5377, NULL, 'IPR005180', NULL, 'Domain of unknown function DUF302', 'DUF302', 3, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(5378, NULL, 'IPR001573', NULL, 'A kinase-anchoring protein AKAP5 and AKAP12, calmodulin (CaM)-binding motif', 'AKAP_WSK', 3, NULL),
(5379, NULL, 'IPR008013', NULL, 'GATA-type transcription activator, N-terminal', 'GATA_N', 3, NULL),
(5380, NULL, 'IPR008006', NULL, 'Peptidase M26, N-terminal domain', 'Peptidase_M26_N_dom', 3, NULL),
(5381, NULL, 'IPR010021', NULL, 'Phosphatidylglycerophosphate phosphatase', 'PGPP1/Gep4', 4, NULL),
(5382, NULL, 'IPR008059', NULL, 'Gamma-aminobutyric-acid A receptor, Rho2', 'GABAAa_rho2_rcpt', 4, NULL),
(5383, NULL, 'IPR008017', NULL, 'Atracotoxin, delta', 'Atracotoxin_delta', 4, NULL),
(5384, NULL, 'IPR002090', NULL, 'Sodium/hydrogen exchanger 6/7/9', 'NHE-6/7/9', 4, NULL),
(5385, NULL, 'IPR002958', NULL, 'Occludin', 'Occludin', 4, NULL),
(5386, NULL, 'IPR003406', NULL, 'Glycosyl transferase, family 14', 'Glyco_trans_14', 4, NULL),
(5387, NULL, 'IPR003438', NULL, 'Glial cell line-derived neurotrophic factor receptor', 'GDNF_rcpt', 4, NULL),
(5388, NULL, 'IPR001400', NULL, 'Somatotropin/prolactin', 'Somatotropin/Prolactin', 4, NULL),
(5389, NULL, 'IPR007329', NULL, 'FMN-binding', 'FMN-bd', 3, NULL),
(5390, NULL, 'IPR010020', NULL, 'Integral membrane protein, YccS/YhfK', 'Integral_membrane_YCCS_YHJK', 4, NULL),
(5391, NULL, 'IPR005305', NULL, 'Nepovirus coat protein, C-terminal', 'Nepo_coat_C', 3, NULL),
(5392, NULL, 'IPR002219', NULL, 'Protein kinase C-like, phorbol ester/diacylglycerol-binding domain', 'PE/DAG-bd', 3, NULL),
(5393, NULL, 'IPR010243', NULL, 'DNA-directed RNA polymerase beta subunit, bacterial-type', 'RNA_pol_bsu_bac', 4, NULL),
(5394, NULL, 'IPR010908', NULL, 'Longin domain', 'Longin_dom', 3, NULL),
(5395, NULL, 'IPR010027', NULL, 'Tail assembly protein G', 'Tail_assembly_G', 3, NULL),
(5396, NULL, 'IPR010033', NULL, 'HAD-superfamily phosphatase, subfamily IIIC', 'HAD_SF_ppase_IIIC', 3, NULL),
(5397, NULL, 'IPR001576', NULL, 'Phosphoglycerate kinase', 'Phosphoglycerate_kinase', 4, NULL),
(5398, NULL, 'IPR002166', NULL, 'RNA dependent RNA polymerase, hepatitis C virus', 'RNA_pol_HCV', 4, NULL),
(5399, NULL, 'IPR004350', NULL, 'Potassium channel, voltage dependent, Kv2.1', 'K_chnl_volt-dep_Kv2.1', 4, NULL),
(5400, NULL, 'IPR002028', NULL, 'Tryptophan synthase, alpha chain', 'Trp_synthase_suA', 4, NULL),
(5401, NULL, 'IPR002078', NULL, 'RNA polymerase sigma factor 54 interaction domain', 'Sigma_54_int', 3, NULL),
(5402, NULL, 'IPR005309', NULL, 'PapG, chaperone-binding', 'PapG_chaper-bd_C', 3, NULL),
(5403, NULL, 'IPR002150', NULL, 'Ribosomal protein L31', 'Ribosomal_L31', 4, NULL),
(5404, NULL, 'IPR003391', NULL, 'Adenoviral preterminal protein', 'Adeno_preterminal', 4, NULL),
(5405, NULL, 'IPR001610', NULL, 'PAC motif', 'PAC', 7, NULL),
(5406, NULL, 'IPR004779', NULL, 'Carboxylate/Amino Acid/Amine Transporter', 'CO/AA/NH_transpt', 4, NULL),
(5407, NULL, 'IPR002833', NULL, 'Peptidyl-tRNA hydrolase, PTH2', 'PTH2', 4, NULL),
(5408, NULL, 'IPR003415', NULL, 'Telomere-binding protein, alpha subunit, Spirotrichea', 'Telomere-bd_alpha', 4, NULL),
(5409, NULL, 'IPR001019', NULL, 'Guanine nucleotide binding protein (G-protein), alpha subunit', 'Gprotein_alpha_su', 4, NULL),
(5410, NULL, 'IPR001876', NULL, 'Zinc finger, RanBP2-type', 'Znf_RanBP2', 3, NULL),
(5411, NULL, 'IPR005302', NULL, 'Molybdenum cofactor sulfurase, C-terminal', 'MoCF_Sase_C', 3, NULL),
(5412, NULL, 'IPR006931', NULL, 'Calcipressin', 'Calcipressin', 4, NULL),
(5413, NULL, 'IPR004793', NULL, 'Desulfoferrodoxin', 'Desulfoferrodoxin_rbo', 4, NULL),
(5414, NULL, 'IPR004777', NULL, 'L-lysine exporter/arginine exporter', 'Lys/arg_exporter', 4, NULL),
(5415, NULL, 'IPR008022', NULL, 'DicB', 'DicB', 4, NULL),
(5416, NULL, 'IPR004753', NULL, 'Cell shape determining protein MreB', 'MreB', 4, NULL),
(5417, NULL, 'IPR003411', NULL, 'Triple gene block 3', 'TGBp3', 4, NULL),
(5418, NULL, 'IPR002045', NULL, 'Metallothionein, crustacean', 'Metalthion_crustacean', 4, NULL),
(5419, NULL, 'IPR003461', NULL, 'Keratin', 'Keratin', 4, NULL),
(5420, NULL, 'IPR002105', NULL, 'Dockerin type I repeat', 'Dockerin_1_rpt', 7, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(5421, NULL, 'IPR002136', NULL, 'Ribosomal protein L4/L1e', 'Ribosomal_L4/L1e', 4, NULL),
(5422, NULL, 'IPR005212', NULL, 'dTDP-4-dehydro-6-deoxy-alpha-D-glucopyranose 2,3-dehydratase', 'EvaA-like', 3, NULL),
(5423, NULL, 'IPR002842', NULL, 'V-type ATPase subunit E', 'ATPase_V1_Esu', 4, NULL),
(5424, NULL, 'IPR010240', NULL, 'Cysteine desulfurase IscS', 'Cys_deSase_IscS', 4, NULL),
(5425, NULL, 'IPR010247', NULL, 'N-formylglutamate deformylase', 'HutG_amidohyd', 4, NULL),
(5426, NULL, 'IPR010252', NULL, 'Formimidoylglutamate deiminase', 'HutF', 4, NULL),
(5427, NULL, 'IPR002128', NULL, 'NADH:ubiquinone/plastoquinone oxidoreductase, chloroplast chain 5, C-terminal', 'NADH_UbQ_OxRdtase_chlpt_su5_C', 3, NULL),
(5428, NULL, 'IPR001293', NULL, 'Zinc finger, TRAF-type', 'Znf_TRAF', 3, NULL),
(5429, NULL, 'IPR004763', NULL, 'Cation efflux system CzcA/CusA/SilA/NccA/HelA/CnrA', 'CzcA/CusA/SilA/NccA/HelA/CnrA', 4, NULL),
(5430, NULL, 'IPR004796', NULL, 'Phosphotransferase system, cellobiose-type IIC component', 'PTS_IIC_cello', 4, NULL),
(5431, NULL, 'IPR008021', NULL, 'Attachment protein G3P, N-terminal', 'Attachment_G3P_N', 3, NULL),
(5432, NULL, 'IPR002168', NULL, 'Lipase, GDXG, putative histidine active site', 'Lipase_GDXG_HIS_AS', 0, NULL),
(5433, NULL, 'IPR002843', NULL, 'ATPase, V0 complex,  c/d subunit', 'ATPase_V0-cplx_csu/dsu', 4, NULL),
(5434, NULL, 'IPR002022', NULL, 'Pectate lyase', 'Pec_lyase', 3, NULL),
(5435, NULL, 'IPR004748', NULL, 'Polyol permease', 'Polyol_permease', 4, NULL),
(5436, NULL, 'IPR002175', NULL, 'Endothelin receptor A', 'ETA_rcpt', 4, NULL),
(5437, NULL, 'IPR003422', NULL, 'Cytochrome b-c1 complex, subunit 6', 'Cyt_b-c1_6', 4, NULL),
(5438, NULL, 'IPR005208', NULL, 'Herpesvirus tripartite terminase subunit 2', 'Herpes_TT2', 4, NULL),
(5439, NULL, 'IPR010043', NULL, 'Bifunctional uridylyltransferase/uridylyl-removing enzyme', 'UTase/UR', 4, NULL),
(5440, NULL, 'IPR010049', NULL, 'MTA/SAH nucleosidase', 'MTA_SAH_Nsdase', 4, NULL),
(5441, NULL, 'IPR001586', NULL, 'Beta-lactamase, class-C active site', 'Beta-lactam_class-C_AS', 0, NULL),
(5442, NULL, 'IPR001634', NULL, 'Adenosine receptor', 'Adenosn_rcpt', 4, NULL),
(5443, NULL, 'IPR002070', NULL, 'Transcription factor, Brachyury', 'TF_Brachyury', 4, NULL),
(5444, NULL, 'IPR007336', NULL, 'Der GTPase-activating protein YihI', 'YihI', 4, NULL),
(5445, NULL, 'IPR010014', NULL, 'Diphthamide synthesis DHP2', 'DHP2', 4, NULL),
(5446, NULL, 'IPR010253', NULL, 'Geranylgeranyl reductase, plant/prokaryotic', 'BchP_ChlP_pln/prok', 4, NULL),
(5447, NULL, 'IPR007324', NULL, 'Sugar-binding domain, putative', 'Sugar-bd_dom_put', 3, NULL),
(5448, NULL, 'IPR002838', NULL, 'Mitochondrial biogenesis protein AIM24', 'AIM24', 4, NULL),
(5449, NULL, 'IPR003398', NULL, 'Photosystem II PsbN', 'PSII_PsbN', 4, NULL),
(5450, NULL, 'IPR002124', NULL, 'Cytochrome c oxidase, subunit Vb', 'Cyt_c_oxidase_su5b', 4, NULL),
(5451, NULL, 'IPR004368', NULL, 'Translation initiation factor IF-1', 'TIF_IF1', 4, NULL),
(5452, NULL, 'IPR005204', NULL, 'Hemocyanin, N-terminal', 'Hemocyanin_N', 3, NULL),
(5453, NULL, 'IPR002092', NULL, 'DNA-directed RNA polymerase, phage-type', 'DNA-dir_Rpol_phage-type', 4, NULL),
(5454, NULL, 'IPR003394', NULL, 'Porin, opacity type', 'Porin_opacity', 3, NULL),
(5455, NULL, 'IPR010045', NULL, 'Phosphopentomutase', 'DeoB', 4, NULL),
(5456, NULL, 'IPR008045', NULL, 'DNA replication licensing factor Mcm2', 'MCM2', 4, NULL),
(5457, NULL, 'IPR004365', NULL, 'OB-fold nucleic acid binding domain, AA-tRNA synthetase-type', 'NA-bd_OB_tRNA', 3, NULL),
(5458, NULL, 'IPR004752', NULL, 'AmpG-like permease/Acetyl-coenzyme A transporter 1', 'AmpG_permease/AT-1', 4, NULL),
(5459, NULL, 'IPR001770', NULL, 'G-protein, gamma subunit', 'Gprotein-gamma', 4, NULL),
(5460, NULL, 'IPR010039', NULL, 'Capsule biosynthesis phosphatase', 'EcbF_BcbF', 4, NULL),
(5461, NULL, 'IPR002840', NULL, 'Aconitase X swivel domain, putative', 'AcnX_swivel_put', 3, NULL),
(5462, NULL, 'IPR001436', NULL, 'Alpha crystallin/Small heat shock protein, animal type', 'Alpha-crystallin/sHSP_animal', 4, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(5463, NULL, 'IPR003412', NULL, 'Arterivirus GP4 envelope glycoprotein', 'Arteri_GP4', 4, NULL),
(5464, NULL, 'IPR002829', NULL, 'Protein of unknown function DUF116', 'DUF116', 4, NULL),
(5465, NULL, 'IPR004767', NULL, 'Protein-export membrane protein SecD/SecF-like, archaeal-type', 'SecD/SecF-like_arc', 4, NULL),
(5466, NULL, 'IPR002172', NULL, 'Low-density lipoprotein (LDL) receptor class A repeat', 'LDrepeatLR_classA_rpt', 7, NULL),
(5467, NULL, 'IPR008046', NULL, 'DNA replication licensing factor Mcm3', 'Mcm3', 4, NULL),
(5468, NULL, 'IPR008044', NULL, 'Bacteriophage lysin', 'Phage_lysin', 3, NULL),
(5469, NULL, 'IPR005301', NULL, 'MOB kinase activator family', 'MOB_kinase_act_fam', 4, NULL),
(5470, NULL, 'IPR004776', NULL, 'Membrane transport protein', 'Mem_trans', 4, NULL),
(5471, NULL, 'IPR005297', NULL, 'Lipoprotein repeat', 'Lipoprotein_repeat', 7, NULL),
(5472, NULL, 'IPR003463', NULL, 'Paralytic/GBP/PSP peptide', 'GBP_PSP', 4, NULL),
(5473, NULL, 'IPR002143', NULL, 'Ribosomal protein L1', 'Ribosomal_L1', 4, NULL),
(5474, NULL, 'IPR003399', NULL, 'Mce/MlaD', 'Mce/MlaD', 3, NULL),
(5475, NULL, 'IPR004782', NULL, 'L-fucose phosphate aldolase', 'FucA', 4, NULL),
(5476, NULL, 'IPR003424', NULL, 'Egg-laying hormone/atrial gland peptide', 'ELH', 4, NULL),
(5477, NULL, 'IPR010909', NULL, 'PLAC', 'PLAC', 3, NULL),
(5478, NULL, 'IPR010019', NULL, 'Integral membrane protein, YccS', 'Integral_membrane_YccS', 4, NULL),
(5479, NULL, 'IPR001633', NULL, 'EAL domain', 'EAL_dom', 3, NULL),
(5480, NULL, 'IPR004790', NULL, 'Isocitrate dehydrogenase NADP-dependent', 'Isocitrate_DH_NADP', 4, NULL),
(5481, NULL, 'IPR003431', NULL, 'Beta propeller phytase', 'BP_Phytase', 3, NULL),
(5482, NULL, 'IPR005319', NULL, 'Peptidase S48, DNA-binding transcriptional activator HetR', 'Pept_S48_HetR', 4, NULL),
(5483, NULL, 'IPR004354', NULL, 'Meiotic recombination protein Rec114', 'Meiotic_Rec114', 4, NULL),
(5484, NULL, 'IPR008058', NULL, 'Gamma-aminobutyric-acid A receptor, Rho1', 'GABAAa_rho1_rcpt', 4, NULL),
(5485, NULL, 'IPR005296', NULL, 'IBV 3C protein', 'IBV_3C', 4, NULL),
(5486, NULL, 'IPR004370', NULL, '4-oxalocrotonate tautomerase', '4-oxalocrotonate_tautomerase', 3, NULL),
(5487, NULL, 'IPR010047', NULL, 'Ni-containing CO dehydrogenase', 'CODH', 4, NULL),
(5488, NULL, 'IPR005190', NULL, 'Glutamate-ammonia ligase adenylyltransferase, repeated domain', 'GlnE_rpt_dom', 3, NULL),
(5489, NULL, 'IPR002067', NULL, 'Mitochondrial carrier protein', 'Mit_carrier', 4, NULL),
(5490, NULL, 'IPR005299', NULL, 'SAM dependent carboxyl methyltransferase', 'MeTrfase_7', 4, NULL),
(5491, NULL, 'IPR005315', NULL, 'Peptidase C8, hypovirus', 'Peptidase_C8', 4, NULL),
(5492, NULL, 'IPR023213', NULL, 'Chloramphenicol acetyltransferase-like domain superfamily', 'CAT-like_dom_sf', 5, NULL),
(5493, NULL, 'IPR002657', NULL, 'Bile acid:sodium symporter/arsenical resistance protein  Acr3', 'BilAc:Na_symport/Acr3', 4, NULL),
(5494, NULL, 'IPR004760', NULL, 'L-type amino acid transporter', 'L_AA_transporter', 4, NULL),
(5495, NULL, 'IPR001917', NULL, 'Aminotransferase, class-II, pyridoxal-phosphate binding site', 'Aminotrans_II_pyridoxalP_BS', 1, NULL),
(5496, NULL, 'IPR004740', NULL, 'Nucleoside:H+ symporter', 'Nuc_H_symport', 4, NULL),
(5497, NULL, 'IPR001606', NULL, 'ARID DNA-binding domain', 'ARID_dom', 3, NULL),
(5498, NULL, 'IPR004758', NULL, 'Amino acid transporter', 'AA_transporter', 4, NULL),
(5499, NULL, 'IPR010244', NULL, 'Chlorophyllide reductase subunit Z', 'BchZ', 4, NULL),
(5500, NULL, 'IPR010017', NULL, 'tRNA U34 carboxymethyltransferase', 'CmoB', 4, NULL),
(5501, NULL, 'IPR006387', NULL, 'CPW-WPC domain', 'CPW_WPC_dom', 3, NULL),
(5502, NULL, 'IPR005788', NULL, 'Disulphide isomerase', 'Disulphide_isomerase', 3, NULL),
(5503, NULL, 'IPR006376', NULL, 'Copper-resistance protein CopA', 'Cu-R_CopA', 4, NULL),
(5504, NULL, 'IPR002860', NULL, 'BNR repeat', 'BNR_rpt', 7, NULL),
(5505, NULL, 'IPR004390', NULL, 'Signal-recognition particle receptor FtsY', 'SR_rcpt_FtsY', 4, NULL),
(5506, NULL, 'IPR006366', NULL, 'Uroporphyrin-III C-methyltransferase', 'CobA/CysG_C', 3, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(5507, NULL, 'IPR002241', NULL, 'Glycoside hydrolase, family 27', 'Glyco_hydro_27', 4, NULL),
(5508, NULL, 'IPR002866', NULL, 'Maturase MatK', 'Maturase_MatK', 4, NULL),
(5509, NULL, 'IPR000593', NULL, 'RasGAP protein, C-terminal', 'RasGAP_C', 3, NULL),
(5510, NULL, 'IPR006400', NULL, 'Squalene hopene cyclase', 'Hopene-cyclase', 4, NULL),
(5511, NULL, 'IPR002884', NULL, 'P domain', 'P_dom', 3, NULL),
(5512, NULL, 'IPR006369', NULL, 'Protohaem IX farnesyltransferase', 'Protohaem_IX_farnesylTrfase', 4, NULL),
(5513, NULL, 'IPR005778', NULL, 'Tetrahydromethanopterin S-methyltransferase subunit A, MtrA', 'MtrA', 4, NULL),
(5514, NULL, 'IPR002878', NULL, 'Domain of unknown function DUF35, OB-fold, C-terminal', 'DUF35_OB-fold_C', 3, NULL),
(5515, NULL, 'IPR006373', NULL, 'Variant surface antigen Rifin', 'VSA_Rifin', 4, NULL),
(5516, NULL, 'IPR000577', NULL, 'Carbohydrate kinase, FGGY', 'Carb_kinase_FGGY', 4, NULL),
(5517, NULL, 'IPR005843', NULL, 'Alpha-D-phosphohexomutase, C-terminal', 'A-D-PHexomutase_C', 3, NULL),
(5518, NULL, 'IPR006401', NULL, '2,5-diamino-6-hydroxy-4-(5-phosphoribosylamino)pyrimidine 1-reductase, archaeal', 'Rib_reduct_arc', 4, NULL),
(5519, NULL, 'IPR005802', NULL, 'Aminodeoxychorismate synthase, component I', 'ADC_synth_comp_1', 4, NULL),
(5520, NULL, 'IPR000576', NULL, 'LacY/RafB permease family', 'LacY/RafB_perm_fam', 4, NULL),
(5521, NULL, 'IPR004804', NULL, 'tRNA-guanine(15) transglycosylase', 'TgtA', 4, NULL),
(5522, NULL, 'IPR006966', NULL, 'Peroxin-3', 'Peroxin-3', 4, NULL),
(5523, NULL, 'IPR000529', NULL, 'Ribosomal protein S6', 'Ribosomal_S6', 4, NULL),
(5524, NULL, 'IPR005323', NULL, 'Pullulanase, carbohydrate-binding module 41', 'CBM41_pullulanase', 3, NULL),
(5525, NULL, 'IPR006995', NULL, 'ATP synthase, F0 complex, subunit J', 'ATP_synth_F0_jsu', 4, NULL),
(5526, NULL, 'IPR002844', NULL, 'F420-dependent methylenetetrahydromethanopterin dehydrogenase', 'MTD', 4, NULL),
(5527, NULL, 'IPR006994', NULL, 'TCF25/Rqc1', 'TCF25/Rqc1', 4, NULL),
(5528, NULL, 'IPR000538', NULL, 'Link domain', 'Link_dom', 3, NULL),
(5529, NULL, 'IPR004801', NULL, 'Phosphotransferase system, lactose-specific IIC component', 'LacE', 3, NULL),
(5530, NULL, 'IPR007340', NULL, 'Opacity-associated protein A', 'Opacity-associatedA', 3, NULL),
(5531, NULL, 'IPR000630', NULL, 'Ribosomal protein S8', 'Ribosomal_S8', 4, NULL),
(5532, NULL, 'IPR013520', NULL, 'Exonuclease, RNase T/DNA polymerase III', 'Exonuclease_RNaseT/DNA_pol3', 3, NULL),
(5533, NULL, 'IPR000476', NULL, 'Glycoprotein hormone alpha chain', 'Glyco_hormone', 4, NULL),
(5534, NULL, 'IPR000487', NULL, 'Flavivirus non-structural protein NS2B', 'Flavi_NS2B', 3, NULL),
(5535, NULL, 'IPR006390', NULL, 'Dihydropteroate synthase domain', 'DHP_synth_dom', 3, NULL),
(5536, NULL, 'IPR000604', NULL, 'Major outer membrane protein, Chlamydia', 'Major_OMP_Chlamydia', 4, NULL),
(5537, NULL, 'IPR006368', NULL, 'GDP-mannose 4,6-dehydratase', 'GDP_Man_deHydtase', 4, NULL),
(5538, NULL, 'IPR006372', NULL, 'Bacteriochlorophyll/chlorophyll synthetase', 'Chl_synth', 4, NULL),
(5539, NULL, 'IPR034010', NULL, 'DGCR2-like, C-type lectin-like domain', 'DGCR2-like_CTLD', 3, NULL),
(5540, NULL, 'IPR004393', NULL, 'Nicotinate-nucleotide pyrophosphorylase', 'NadC', 4, NULL),
(5541, NULL, 'IPR005336', NULL, 'Mitochondrial pyruvate carrier', 'MPC', 4, NULL),
(5542, NULL, 'IPR006371', NULL, '4-hydroxybenzoate polyprenyltransferase-related', 'HB_polyprenyl-transferase-rel', 4, NULL),
(5543, NULL, 'IPR006953', NULL, 'Vesicle tethering protein Uso1/P115-like , head domain', 'Vesicle_Uso1_P115_head', 3, NULL),
(5544, NULL, 'IPR000522', NULL, 'ABC transporter, permease protein, BtuC-like', 'ABC_transptr_permease_BtuC', 4, NULL),
(5545, NULL, 'IPR007364', NULL, 'Protein arginine N-methyltransferase SFM1-like', 'SFM1-like', 4, NULL),
(5546, NULL, 'IPR005835', NULL, 'Nucleotidyl transferase domain', 'NTP_transferase_dom', 3, NULL),
(5547, NULL, 'IPR007365', NULL, 'Transferrin receptor-like, dimerisation domain', 'TFR-like_dimer_dom', 3, NULL),
(5548, NULL, 'IPR006984', NULL, 'rRNA-processing protein Fcf1/Utp23', 'Fcf1/Utp23', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(5549, NULL, 'IPR002213', NULL, 'UDP-glucuronosyl/UDP-glucosyltransferase', 'UDP_glucos_trans', 4, NULL),
(5550, NULL, 'IPR007373', NULL, 'Thiamin pyrophosphokinase, thiamin-binding domain', 'Thiamin_PyroPKinase_B1-bd', 3, NULL),
(5551, NULL, 'IPR015795', NULL, 'Pyruvate kinase, C-terminal', 'Pyrv_Knase_C', 3, NULL),
(5552, NULL, 'IPR000493', NULL, 'Inositol 1,4,5-trisphosphate receptor', 'InsP3_rcpt', 4, NULL),
(5553, NULL, 'IPR002250', NULL, 'Chloride channel ClC-K', 'Cl_channel-K', 4, NULL),
(5554, NULL, 'IPR004405', NULL, 'Translation release factor  pelota', 'Transl-rel_pelota', 4, NULL),
(5555, NULL, 'IPR034649', NULL, 'Hsp70-interacting protein, N-terminal', 'Hip_N', 3, NULL),
(5556, NULL, 'IPR006396', NULL, 'Glutamate mutase epsilon subunit', 'Glu_mut_E', 4, NULL),
(5557, NULL, 'IPR006379', NULL, 'HAD-superfamily hydrolase, subfamily IIB', 'HAD-SF_hydro_IIB', 4, NULL),
(5558, NULL, 'IPR005846', NULL, 'Alpha-D-phosphohexomutase, alpha/beta/alpha domain III', 'A-D-PHexomutase_a/b/a-III', 3, NULL),
(5559, NULL, 'IPR006360', NULL, 'Methyltransferase MtaA/CmuA', 'Mtase_MtaA_CmuA', 3, NULL),
(5560, NULL, 'IPR006978', NULL, 'Archaeal Nre, N-terminal', 'Nre_N', 3, NULL),
(5561, NULL, 'IPR002861', NULL, 'Reeler domain', 'Reeler_dom', 3, NULL),
(5562, NULL, 'IPR001490', NULL, 'Hepatitis C virus, Non-structural protein NS4b', 'HCV_NS4b', 3, NULL),
(5563, NULL, 'IPR006988', NULL, 'Nab, N-terminal', 'Nab_N', 3, NULL),
(5564, NULL, 'IPR000602', NULL, 'Glycoside hydrolase family 38, N-terminal domain', 'Glyco_hydro_38_N', 3, NULL),
(5565, NULL, 'IPR000668', NULL, 'Peptidase C1A, papain C-terminal', 'Peptidase_C1A_C', 3, NULL),
(5566, NULL, 'IPR001551', NULL, 'Cannabinoid receptor type 2', 'Canbinoid_rcpt_2', 4, NULL),
(5567, NULL, 'IPR007375', NULL, 'Sarcosine oxidase, gamma subunit', 'SoxG', 4, NULL),
(5568, NULL, 'IPR002850', NULL, 'PIN family, putative toxin-antitoxin system toxin component', 'PIN_toxin-like', 4, NULL),
(5569, NULL, 'IPR007372', NULL, 'Lipid/polyisoprenoid-binding, YceI-like', 'Lipid/polyisoprenoid-bd_YceI', 3, NULL),
(5570, NULL, 'IPR034376', NULL, 'G3BP2, RNA recognition motif', 'G3BP2_RRM', 3, NULL),
(5571, NULL, 'IPR000537', NULL, 'UbiA prenyltransferase family', 'UbiA_prenyltransferase', 4, NULL),
(5572, NULL, 'IPR005332', NULL, 'Tomato bushy stunt virus (TBSV), p22, movement protein', 'TBSV_p22', 4, NULL),
(5573, NULL, 'IPR004402', NULL, 'Purine nucleoside phosphorylase DeoD-type', 'DeoD-type', 4, NULL),
(5574, NULL, 'IPR002888', NULL, '[2Fe-2S]-binding', '2Fe-2S-bd', 3, NULL),
(5575, NULL, 'IPR004398', NULL, 'RNA methyltransferase, RsmD', 'RNA_MeTrfase_RsmD', 4, NULL),
(5576, NULL, 'IPR000599', NULL, 'G protein-coupled receptor 12', 'GPR12', 4, NULL),
(5577, NULL, 'IPR002315', NULL, 'Glycyl-tRNA synthetase', 'tRNA-synt_gly', 4, NULL),
(5578, NULL, 'IPR006936', NULL, 'ALOG domain', 'ALOG_dom', 3, NULL),
(5579, NULL, 'IPR002857', NULL, 'Zinc finger, CXXC-type', 'Znf_CXXC', 3, NULL),
(5580, NULL, 'IPR006957', NULL, 'Ethylene insensitive 3', 'EIN3', 4, NULL),
(5581, NULL, 'IPR005830', NULL, 'Aerolysin', 'Aerolysn', 4, NULL),
(5582, NULL, 'IPR002207', NULL, 'Class I peroxidase', 'Peroxidase_I', 4, NULL),
(5583, NULL, 'IPR000489', NULL, 'Pterin-binding domain', 'Pterin-binding_dom', 3, NULL),
(5584, NULL, 'IPR006407', NULL, '1,4-alpha-glucan-branching enzyme, GlgB', 'GlgB', 4, NULL),
(5585, NULL, 'IPR005790', NULL, 'DNA polymerase III, delta subunit', 'DNA_polIII_delta', 4, NULL),
(5586, NULL, 'IPR000552', NULL, 'Ribosomal protein L44e', 'Ribosomal_L44e', 4, NULL),
(5587, NULL, 'IPR006947', NULL, 'Alliinase, EGF-like domain', 'EGF_alliinase', 3, NULL),
(5588, NULL, 'IPR000515', NULL, 'ABC transporter type 1, transmembrane domain MetI-like', 'MetI-like', 3, NULL),
(5589, NULL, 'IPR004386', NULL, 'Toxin-antitoxin system, YafQ-like toxin', 'Toxin_YafQ-like', 4, NULL),
(5590, NULL, 'IPR005819', NULL, 'Linker histone H1/H5', 'H1/H5', 4, NULL),
(5591, NULL, 'IPR022834', NULL, '8-amino-7-oxononanoate synthase, Proteobacteria', 'AONS_Proteobacteria', 4, NULL),
(5592, NULL, 'IPR000509', NULL, 'Ribosomal protein L36e', 'Ribosomal_L36e', 4, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(5593, NULL, 'IPR000611', NULL, 'Neuropeptide Y receptor family', 'NPY_rcpt', 4, NULL),
(5594, NULL, 'IPR005836', NULL, 'ADP-glucose pyrophosphorylase, conserved site', 'ADP_Glu_pyroP_CS', 2, NULL),
(5595, NULL, 'IPR000582', NULL, 'Acyl-CoA-binding protein, ACBP', 'Acyl-CoA-binding_protein', 3, NULL),
(5596, NULL, 'IPR000555', NULL, 'JAB1/MPN/MOV34 metalloenzyme domain', 'JAMM/MPN+_dom', 3, NULL),
(5597, NULL, 'IPR002881', NULL, 'Domain of unknown function DUF58', 'DUF58', 3, NULL),
(5598, NULL, 'IPR000471', NULL, 'Interferon alpha/beta/delta', 'Interferon_alpha/beta/delta', 4, NULL),
(5599, NULL, 'IPR007370', NULL, 'Glutamate--cysteine ligase', 'Glu_cys_ligase', 3, NULL),
(5600, NULL, 'IPR004799', NULL, 'Periplasmic protein thiol:disulphide oxidoreductase DsbE', 'Periplasmic_diS_OxRdtase_DsbE', 4, NULL),
(5601, NULL, 'IPR007374', NULL, 'ASCH domain', 'ASCH_domain', 3, NULL),
(5602, NULL, 'IPR006362', NULL, 'Cobalamin (vitamin B12) biosynthesis CobM/CbiF, precorrin-4 C11-methyltransferase', 'Cbl_synth_CobM/CibF', 3, NULL),
(5603, NULL, 'IPR000440', NULL, 'NADH:ubiquinone/plastoquinone oxidoreductase, chain 3', 'NADH_UbQ/plastoQ_OxRdtase_su3', 4, NULL),
(5604, NULL, 'IPR000492', NULL, 'Protamine-2', 'PRM2', 4, NULL),
(5605, NULL, 'IPR004394', NULL, 'Protein Iojap/ribosomal silencing factor RsfS', 'Iojap/RsfS/C7orf30', 4, NULL),
(5606, NULL, 'IPR000580', NULL, 'TSC-22 / Dip / Bun', 'TSC-22_Dip_Bun', 4, NULL),
(5607, NULL, 'IPR002890', NULL, 'Macroglobulin domain', 'MG2', 3, NULL),
(5608, NULL, 'IPR006411', NULL, 'Fructose-bisphosphate aldolase, class II, yeast/E. coli subtype', 'Fruct_bisP_bact', 4, NULL),
(5609, NULL, 'IPR006965', NULL, 'Adenovirus Gp19K', 'Adenovirus_Gp19K', 4, NULL),
(5610, NULL, 'IPR006949', NULL, 'Baseplate protein J-like', 'Baseplate_J-like', 3, NULL),
(5611, NULL, 'IPR027258', NULL, 'Mitogen-activated protein kinase kinase kinase 13', 'MAPKKK13', 4, NULL),
(5612, NULL, 'IPR001489', NULL, 'Heat-stable enterotoxin, STa', 'Heat-stable_enterotox_STa', 4, NULL),
(5613, NULL, 'IPR002867', NULL, 'IBR domain', 'IBR_dom', 3, NULL),
(5614, NULL, 'IPR006410', NULL, 'Conserved hypothetical protein CHP01519, Plasmodium falciparum (isolate 3D7)', 'CHP01519_PLAF7', 4, NULL),
(5615, NULL, 'IPR000541', NULL, 'Cytoplasmic tRNA 2-thiolation protein 1', 'Ncs6/Tuc1/Ctu1', 4, NULL),
(5616, NULL, 'IPR002246', NULL, 'Chloride channel ClC-4', 'Cl_channel-4', 4, NULL),
(5617, NULL, 'IPR022833', NULL, 'Uncharacterised protein family UPF0757, YmgG', 'UPF0757_YmgG', 4, NULL),
(5618, NULL, 'IPR000545', NULL, 'Lactalbumin', 'Lactalbumin', 4, NULL),
(5619, NULL, 'IPR000594', NULL, 'THIF-type NAD/FAD binding fold', 'ThiF_NAD_FAD-bd', 3, NULL),
(5620, NULL, 'IPR006985', NULL, 'Receptor activity modifying protein', 'RAMP', 4, NULL),
(5621, NULL, 'IPR004392', NULL, 'Hydrogenase maturation factor HypB', 'Hyd_mat_HypB', 4, NULL),
(5622, NULL, 'IPR007383', NULL, 'Protein of unknown function DUF445', 'DUF445', 4, NULL),
(5623, NULL, 'IPR002883', NULL, 'CBM10/dockerin domain', 'CBM10/Dockerin_dom', 3, NULL),
(5624, NULL, 'IPR001556', NULL, 'Bombesin receptor-like', 'Bombsn_rcpt-like', 4, NULL),
(5625, NULL, 'IPR000528', NULL, 'Plant non-specific lipid-transfer protein/Par allergen', 'Plant_nsLTP', 4, NULL),
(5626, NULL, 'IPR001528', NULL, 'Flavivirus non-structural protein NS4B', 'Flavi_NS4B', 3, NULL),
(5627, NULL, 'IPR001543', NULL, 'Flagellar motor switch protein FliN-like, C-terminal domain', 'FliN-like_C', 3, NULL),
(5628, NULL, 'IPR004802', NULL, 'tRNA pseudouridine synthase B family', 'tRNA_PsdUridine_synth_B_fam', 4, NULL),
(5629, NULL, 'IPR001547', NULL, 'Glycoside hydrolase, family 5', 'Glyco_hydro_5', 3, NULL),
(5630, NULL, 'IPR005826', NULL, 'Potassium channel, voltage dependent, Kv2.2', 'K_chnl_volt-dep_Kv2.2', 4, NULL),
(5631, NULL, 'IPR000571', NULL, 'Zinc finger, CCCH-type', 'Znf_CCCH', 3, NULL),
(5632, NULL, 'IPR000597', NULL, 'Ribosomal protein L3', 'Ribosomal_L3', 4, NULL),
(5633, NULL, 'IPR004381', NULL, 'Glycerate kinase', 'Glycerate_kinase', 4, NULL),
(5634, NULL, 'IPR006974', NULL, 'Protein of unknown function DUF648', 'DUF648', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(5635, NULL, 'IPR002845', NULL, 'tRNA ribose 2''-O-methyltransferase, aTrm56', 'tRNA_mtfrase_aTrm56', 4, NULL),
(5636, NULL, 'IPR000525', NULL, 'Initiator Rep protein', 'Initiator_Rep_prot', 3, NULL),
(5637, NULL, 'IPR000527', NULL, 'Flagellar L-ring protein', 'Flag_Lring', 4, NULL),
(5638, NULL, 'IPR002873', NULL, 'Rotavirus non-structural protein NSP3', 'Rotavirus_NSP3', 4, NULL),
(5639, NULL, 'IPR000547', NULL, 'Clathrin, heavy chain/VPS, 7-fold repeat', 'Clathrin_H-chain/VPS_repeat', 7, NULL),
(5640, NULL, 'IPR006975', NULL, 'NifQ', 'NifQ', 4, NULL),
(5641, NULL, 'IPR002270', NULL, 'Gap junction beta-4 protein (Cx30.3)', 'Connexin-30.3', 4, NULL),
(5642, NULL, 'IPR004376', NULL, 'Conserved hypothetical protein CHP00024, phosphoesterase-like', 'CHP00024_Pesterase-like', 4, NULL),
(5643, NULL, 'IPR006969', NULL, 'Stigma-specific protein Stig1', 'Stig1', 4, NULL),
(5644, NULL, 'IPR002254', NULL, 'Flavin monooxygenase (FMO) 2', 'Flavin_mOase_2', 4, NULL),
(5645, NULL, 'IPR004396', NULL, 'Ribosome-binding ATPase YchF/Obg-like ATPase 1', 'ATPase_YchF/OLA1', 4, NULL),
(5646, NULL, 'IPR000533', NULL, 'Tropomyosin', 'Tropomyosin', 4, NULL),
(5647, NULL, 'IPR006394', NULL, 'Glutamate mutase sigma subunit', 'GlmS', 4, NULL),
(5648, NULL, 'IPR006951', NULL, 'Protein of unknown function DUF643', 'DUF643', 4, NULL),
(5649, NULL, 'IPR005825', NULL, 'Ribosomal protein L24/L26, conserved site', 'Ribosomal_L24/26_CS', 2, NULL),
(5650, NULL, 'IPR006970', NULL, 'PT repeat', 'PT', 7, NULL),
(5651, NULL, 'IPR002291', NULL, 'Phosphorylase kinase, gamma catalytic subunit', 'Phosph_kin_gamma', 4, NULL),
(5652, NULL, 'IPR006393', NULL, 'Sepiapterin reductase', 'Sepiapterin_red', 4, NULL),
(5653, NULL, 'IPR005797', NULL, 'Cytochrome b/b6, N-terminal', 'Cyt_b/b6_N', 3, NULL),
(5654, NULL, 'IPR000627', NULL, 'Intradiol ring-cleavage dioxygenase, C-terminal', 'Intradiol_dOase_C', 3, NULL),
(5655, NULL, 'IPR005814', NULL, 'Aminotransferase class-III', 'Aminotrans_3', 4, NULL),
(5656, NULL, 'IPR006363', NULL, 'Precorrin-3B C17-methyltransferase domain', 'Cbl_synth_CobJ/CibH_dom', 3, NULL),
(5657, NULL, 'IPR002225', NULL, '3-beta hydroxysteroid dehydrogenase/isomerase', '3Beta_OHSteriod_DH/Estase', 3, NULL),
(5658, NULL, 'IPR000579', NULL, 'Cation-transporting P-type ATPase A/B', 'Cation-trans_P-type_ATPase_A/B', 4, NULL),
(5659, NULL, 'IPR000506', NULL, 'Ketol-acid reductoisomerase, C-terminal', 'KARI_C', 3, NULL),
(5660, NULL, 'IPR005809', NULL, 'Succinate--CoA synthetase, beta subunit', 'Succ_CoA_synthase_bsu', 4, NULL),
(5661, NULL, 'IPR005801', NULL, 'ADC synthase', 'ADC_synthase', 5, NULL),
(5662, NULL, 'IPR005798', NULL, 'Cytochrome b/b6, C-terminal', 'Cyt_b/b6_C', 3, NULL),
(5663, NULL, 'IPR002289', NULL, 'Gamma-aminobutyric-acid A receptor, beta subunit', 'GABAAb_rcpt', 4, NULL),
(5664, NULL, 'IPR004406', NULL, 'Aconitase B', 'Aconitase_B', 4, NULL),
(5665, NULL, 'IPR006359', NULL, 'Transcription elongation factor GreA', 'Tscrpt_elong_fac_GreA', 4, NULL),
(5666, NULL, 'IPR000592', NULL, 'Ribosomal protein S27', 'Ribosomal_S27', 4, NULL),
(5667, NULL, 'IPR000559', NULL, 'Formate-tetrahydrofolate ligase, FTHFS', 'Formate_THF_ligase', 4, NULL),
(5668, NULL, 'IPR002868', NULL, 'Hepatitis C virus, Non-structural 5a protein', 'HCV_NS5a', 3, NULL),
(5669, NULL, 'IPR034650', NULL, 'YuaB-like', 'YuaB-like', 4, NULL),
(5670, NULL, 'IPR005810', NULL, 'Succinyl-CoA ligase, alpha subunit', 'CoA_lig_alpha', 4, NULL),
(5671, NULL, 'IPR000504', NULL, 'RNA recognition motif domain', 'RRM_dom', 3, NULL),
(5672, NULL, 'IPR002184', NULL, '7TM GPCR, serpentine receptor class b (Srb)', '7TM_GPCR_serpentine_rcpt_Srb', 4, NULL),
(5673, NULL, 'IPR002313', NULL, 'Lysine-tRNA ligase, class II', 'Lys-tRNA-ligase_II', 4, NULL),
(5674, NULL, 'IPR000663', NULL, 'Natriuretic peptide', 'Natr_peptide', 4, NULL),
(5675, NULL, 'IPR005334', NULL, 'Dynein light chain Tctex-1 like', 'Tctex-1-like', 4, NULL),
(5676, NULL, 'IPR007348', NULL, 'CopC domain', 'CopC_dom', 3, NULL),
(5677, NULL, 'IPR004385', NULL, 'Nucleoside diphosphate pyrophosphatase', 'NDP_pyrophosphatase', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(5678, NULL, 'IPR000585', NULL, 'Hemopexin-like domain', 'Hemopexin-like_dom', 3, NULL),
(5679, NULL, 'IPR007368', NULL, 'Domain of unknown function DUF434', 'DUF434', 3, NULL),
(5680, NULL, 'IPR005815', NULL, 'Adenosylmethionine--8-amino-7-oxononanoate aminotransferase BioA', 'BioA', 4, NULL),
(5681, NULL, 'IPR000603', NULL, 'Movement protein', 'MPV', 4, NULL),
(5682, NULL, 'IPR000584', NULL, 'Voltage-dependent calcium channel, L-type, beta subunit', 'VDCC_L_bsu', 4, NULL),
(5683, NULL, 'IPR004378', NULL, 'F420H(2)-dependent quinone reductase', 'F420H2_quin_Rdtase', 4, NULL),
(5684, NULL, 'IPR005321', NULL, 'Peptidase S58, DmpA', 'Peptidase_S58_DmpA', 4, NULL),
(5685, NULL, 'IPR023772', NULL, 'DNA-binding HTH domain, TetR-type, conserved site', 'DNA-bd_HTH_TetR-type_CS', 2, NULL),
(5686, NULL, 'IPR006950', NULL, 'Rotavirus non-structural protein 6', 'Rotavirus_NSP6', 4, NULL),
(5687, NULL, 'IPR000587', NULL, 'Creatinase, N-terminal', 'Creatinase_N', 3, NULL),
(5688, NULL, 'IPR005817', NULL, 'Wnt', 'Wnt', 4, NULL),
(5689, NULL, 'IPR007381', NULL, 'Taxis protein CheF1/F2', 'CheF1/F2', 4, NULL),
(5690, NULL, 'IPR006939', NULL, 'SNF5/SMARCB1/INI1', 'SNF5', 4, NULL),
(5691, NULL, 'IPR002257', NULL, 'Flavin monooxygenase (FMO) 5', 'Flavin_mOase_5', 4, NULL),
(5692, NULL, 'IPR002252', NULL, 'Glycoside hydrolase family 36', 'Glyco_hydro_36', 4, NULL),
(5693, NULL, 'IPR002243', NULL, 'Chloride channel ClC-1', 'Cl_channel-1', 4, NULL),
(5694, NULL, 'IPR000589', NULL, 'Ribosomal protein S15', 'Ribosomal_S15', 4, NULL),
(5695, NULL, 'IPR007379', NULL, 'Tim44-like domain', 'Tim44-like_dom', 3, NULL),
(5696, NULL, 'IPR000510', NULL, 'Nitrogenase/oxidoreductase, component 1', 'Nase/OxRdtase_comp1', 3, NULL),
(5697, NULL, 'IPR007345', NULL, 'Polysaccharide pyruvyl transferase', 'Polysacch_pyruvyl_Trfase', 3, NULL),
(5698, NULL, 'IPR000526', NULL, 'Auxin-binding protein', 'Auxin-bd', 4, NULL),
(5699, NULL, 'IPR005792', NULL, 'Protein disulphide isomerase', 'Prot_disulphide_isomerase', 4, NULL),
(5700, NULL, 'IPR005845', NULL, 'Alpha-D-phosphohexomutase, alpha/beta/alpha domain II', 'A-D-PHexomutase_a/b/a-II', 3, NULL),
(5701, NULL, 'IPR007354', NULL, 'Bisanhydrobacterioruberin hydratase CruF-like', 'CruF-like', 4, NULL),
(5702, NULL, 'IPR000612', NULL, 'Proteolipid membrane potential modulator', 'PMP3', 4, NULL),
(5703, NULL, 'IPR004803', NULL, 'tRNA-guanine transglycosylase', 'TGT', 4, NULL),
(5704, NULL, 'IPR000635', NULL, 'Viral ssDNA-binding protein', 'Viral_ssDNA-bd', 4, NULL),
(5705, NULL, 'IPR006979', NULL, 'Archaeal Nre, C-terminal', 'Nre_C', 3, NULL),
(5706, NULL, 'IPR006395', NULL, 'Methylaspartate ammonia-lyase', 'Me_Asp_am_lyase', 4, NULL),
(5707, NULL, 'IPR034204', NULL, 'Subtilisin SUB1-like catalytic domain', 'PfSUB1-like_cat_dom', 3, NULL),
(5708, NULL, 'IPR007349', NULL, 'Domain of unknown function DUF418', 'DUF418', 3, NULL),
(5709, NULL, 'IPR005333', NULL, 'Transcription factor, TCP', 'Transcription_factor_TCP', 4, NULL),
(5710, NULL, 'IPR006412', NULL, 'Fructose-bisphosphate aldolase, class II, Calvin cycle subtype', 'Fruct_bisP_Calv', 4, NULL),
(5711, NULL, 'IPR034141', NULL, 'Ribonuclease M5-like, TOPRIM domain', 'TOPRIM_RNase_M5-like', 3, NULL),
(5712, NULL, 'IPR004380', NULL, 'Aspartate racemase', 'Asp_race', 4, NULL),
(5713, NULL, 'IPR002874', NULL, 'Alphaherpesvirus glycoprotein I', 'Herpes_gI', 4, NULL),
(5714, NULL, 'IPR000610', NULL, '5-Hydroxytryptamine 1A receptor', '5HT1A_rcpt', 4, NULL),
(5715, NULL, 'IPR034623', NULL, 'Galactarate dehydratase 3', 'Galactarate_dehydratase_3', 4, NULL),
(5716, NULL, 'IPR000572', NULL, 'Oxidoreductase, molybdopterin-binding domain', 'OxRdtase_Mopterin-bd_dom', 3, NULL),
(5717, NULL, 'IPR005837', NULL, 'Flagellar transport protein FliP', 'FliP', 4, NULL),
(5718, NULL, 'IPR005327', NULL, 'Small hydrophobic protein', 'SHP', 4, NULL),
(5719, NULL, 'IPR005329', NULL, 'Sorting nexin, N-terminal', 'Sorting_nexin_N', 3, NULL),
(5720, NULL, 'IPR006968', NULL, 'Root UVB sensitive family', 'RUS_fam', 4, NULL),
(5721, NULL, 'IPR002880', NULL, 'Pyruvate flavodoxin/ferredoxin oxidoreductase, pyrimidine binding domain', 'Pyrv_Fd/Flavodoxin_OxRdtase_N', 3, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(5722, NULL, 'IPR002293', NULL, 'Amino acid/polyamine transporter I', 'AA/rel_permease1', 4, NULL),
(5723, NULL, 'IPR006367', NULL, 'Sirohaem synthase, N-terminal', 'Sirohaem_synthase_N', 3, NULL),
(5724, NULL, 'IPR002872', NULL, 'Proline dehydrogenase domain', 'Proline_DH_dom', 3, NULL),
(5725, NULL, 'IPR006377', NULL, 'Catabolite control protein A', 'CcpA', 4, NULL),
(5726, NULL, 'IPR005781', NULL, 'Photosynthetic reaction centre, M subunit', 'Photo_RC_M', 4, NULL),
(5727, NULL, 'IPR005838', NULL, 'Type III secretion system inner membrane P protein', 'T3SS_IM_P', 4, NULL),
(5728, NULL, 'IPR005784', NULL, 'D-amino acid aminotransferase', 'D_amino_transT', 4, NULL),
(5729, NULL, 'IPR002849', NULL, 'Protein of unknown function DUF131', 'DUF131', 4, NULL),
(5730, NULL, 'IPR000601', NULL, 'PKD domain', 'PKD_dom', 3, NULL),
(5731, NULL, 'IPR004399', NULL, 'Hydroxymethylpyrimidine kinase/phosphomethylpyrimidine kinase domain', 'HMP/HMP-P_kinase_dom', 3, NULL),
(5732, NULL, 'IPR002871', NULL, 'NIF system FeS cluster assembly, NifU, N-terminal', 'NIF_FeS_clus_asmbl_NifU_N', 3, NULL),
(5733, NULL, 'IPR005805', NULL, 'Rieske iron-sulphur protein, C-terminal', 'Rieske_Fe-S_prot_C', 3, NULL),
(5734, NULL, 'IPR002282', NULL, 'Platelet-activating factor receptor', 'PAF_rcpt', 4, NULL),
(5735, NULL, 'IPR006409', NULL, 'Glycerol-3-phosphate cytidylyltransferase', 'G3P_cytidylTrfase', 4, NULL),
(5736, NULL, 'IPR006982', NULL, 'Glutamate synthase, central-N', 'Glu_synth_centr_N', 3, NULL),
(5737, NULL, 'IPR000628', NULL, 'Vasopressin V1B receptor', 'Vprs_rcpt_V1B', 4, NULL),
(5738, NULL, 'IPR000536', NULL, 'Nuclear hormone receptor, ligand-binding domain', 'Nucl_hrmn_rcpt_lig-bd', 3, NULL),
(5739, NULL, 'IPR000468', NULL, 'Barstar (barnase inhibitor)', 'Barstar', 3, NULL),
(5740, NULL, 'IPR006384', NULL, 'HAD hydrolase, subfamily IA, Pyridoxal phosphate phosphatase-like', 'HAD_hydro_PyrdxlP_Pase-like', 4, NULL),
(5741, NULL, 'IPR005828', NULL, 'Major facilitator,  sugar transporter-like', 'MFS_sugar_transport-like', 4, NULL),
(5742, NULL, 'IPR007341', NULL, 'Transglycosylase-associated protein', 'Transgly_assoc', 4, NULL),
(5743, NULL, 'IPR001523', NULL, 'Paired domain', 'Paired_dom', 3, NULL),
(5744, NULL, 'IPR006941', NULL, 'Ribonuclease CAF1', 'RNase_CAF1', 4, NULL),
(5745, NULL, 'IPR000483', NULL, 'Cysteine-rich flanking region, C-terminal', 'Cys-rich_flank_reg_C', 3, NULL),
(5746, NULL, 'IPR006940', NULL, 'Securin sister-chromatid separation inhibitor', 'Securin_separation_inhibitor', 4, NULL),
(5747, NULL, 'IPR004400', NULL, 'Urease accessory protein UreG', 'UreG', 4, NULL),
(5748, NULL, 'IPR006399', NULL, 'Riboflavin synthase, archaeal', 'Ribfl_synth_arc', 4, NULL),
(5749, NULL, 'IPR002259', NULL, 'Equilibrative nucleoside transporter', 'Eqnu_transpt', 4, NULL),
(5750, NULL, 'IPR002248', NULL, 'Chloride channel ClC-6', 'Cl_channel-6', 4, NULL),
(5751, NULL, 'IPR000458', NULL, 'Mucin-like glycoprotein', 'Tryp_mucin', 4, NULL),
(5752, NULL, 'IPR001557', NULL, 'L-lactate/malate dehydrogenase', 'L-lactate/malate_DH', 4, NULL),
(5753, NULL, 'IPR005785', NULL, 'Branched-chain amino acid aminotransferase I', 'B_amino_transI', 4, NULL),
(5754, NULL, 'IPR006989', NULL, 'NAB co-repressor, domain', 'NAB_co-repressor_dom', 3, NULL),
(5755, NULL, 'IPR002869', NULL, 'Pyruvate-flavodoxin oxidoreductase, central domain', 'Pyrv_flavodox_OxRed_cen', 5, NULL),
(5756, NULL, 'IPR005831', NULL, 'Aerolysin/haemolysin toxin, conserved site', 'Aerolysin/haemolysin_CS', 2, NULL),
(5757, NULL, 'IPR000554', NULL, 'Ribosomal protein S7e', 'Ribosomal_S7e', 4, NULL),
(5758, NULL, 'IPR000622', NULL, 'K/Cl co-transporter 1', 'KCC1', 4, NULL),
(5759, NULL, 'IPR006962', NULL, 'P48 protein, Baculovirus', 'P48_Baculovir', 4, NULL),
(5760, NULL, 'IPR007378', NULL, 'Tic22-like', 'Tic22-like', 4, NULL),
(5761, NULL, 'IPR000629', NULL, 'ATP-dependent RNA helicase DEAD-box, conserved site', 'RNA-helicase_DEAD-box_CS', 2, NULL),
(5762, NULL, 'IPR001546', NULL, 'GPCR fungal pheromone A receptor', 'GPCR_Pheromne_A_rcpt', 4, NULL),
(5763, NULL, 'IPR005841', NULL, 'Alpha-D-phosphohexomutase superfamily', 'Alpha-D-phosphohexomutase_SF', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(5764, NULL, 'IPR000563', NULL, 'Flagellar assembly protein FliH', 'Flag_FliH', 4, NULL),
(5765, NULL, 'IPR006386', NULL, 'HAD-superfamily hydrolase, subfamily IB, PSPase-like, archaeal', 'HAD-SF_hydro_IB_PSP-like_arc', 4, NULL),
(5766, NULL, 'IPR000472', NULL, 'Activin types I and II receptor domain', 'Activin_recp', 3, NULL),
(5767, NULL, 'IPR007351', NULL, 'Uncharacterised protein YjbR', 'YjbR', 4, NULL),
(5768, NULL, 'IPR002278', NULL, 'Melatonin receptor 1A/1B', 'Mel_1A/1B_rcpt', 4, NULL),
(5769, NULL, 'IPR007339', NULL, 'Inner membrane protein RclC-like', 'RclC-like', 4, NULL),
(5770, NULL, 'IPR002234', NULL, 'Anaphylatoxin chemotactic receptor, C3a/C5a1/C5a2', 'Anphylx_rcpt_C3a/C5a1-2', 4, NULL),
(5771, NULL, 'IPR007369', NULL, 'Peptidase A22B, signal peptide peptidase', 'Peptidase_A22B_SPP', 4, NULL),
(5772, NULL, 'IPR005791', NULL, 'Protein translocase subunit SecD', 'SecD', 4, NULL),
(5773, NULL, 'IPR006935', NULL, 'Helicase/UvrB, N-terminal', 'Helicase/UvrB_N', 3, NULL),
(5774, NULL, 'IPR000620', NULL, 'EamA domain', 'EamA_dom', 3, NULL),
(5775, NULL, 'IPR002280', NULL, 'Melatonin-related receptor 1X', 'Mel_rcpt_1X', 4, NULL),
(5776, NULL, 'IPR002877', NULL, 'Ribosomal RNA methyltransferase, FtsJ domain', 'RNA_MeTrfase_FtsJ_dom', 3, NULL),
(5777, NULL, 'IPR002263', NULL, 'Gap junction alpha-4 protein (Cx37)', 'Connexin37', 4, NULL),
(5778, NULL, 'IPR007367', NULL, 'Protein of unknown function DUF433', 'DUF433', 4, NULL),
(5779, NULL, 'IPR006964', NULL, 'NUDE domain', 'NUDE_dom', 3, NULL),
(5780, NULL, 'IPR005827', NULL, 'Potassium channel, voltage dependent, KCNQ1', 'K_chnl_volt-dep_KCQN1', 4, NULL),
(5781, NULL, 'IPR000591', NULL, 'DEP domain', 'DEP_dom', 3, NULL),
(5782, NULL, 'IPR006398', NULL, '2-hydroxy-3-oxopropionate reductase', 'Tartro_sem_red', 4, NULL),
(5783, NULL, 'IPR000621', NULL, 'Melanocortin 5 receptor', 'Melancort_rcpt_5', 4, NULL),
(5784, NULL, 'IPR006942', NULL, 'TH1 protein', 'TH1', 4, NULL),
(5785, NULL, 'IPR000557', NULL, 'Calponin repeat', 'Calponin_repeat', 7, NULL),
(5786, NULL, 'IPR002882', NULL, '2-phospho-L-lactate transferase CofD', 'CofD', 4, NULL),
(5787, NULL, 'IPR027257', NULL, 'Mitogen-activated protein kinase kinase kinase 12', 'MAPKKK12', 4, NULL),
(5788, NULL, 'IPR000631', NULL, 'ATP/ADP-dependent (S)-NAD(P)H-hydrate dehydratase', 'CARKD', 4, NULL),
(5789, NULL, 'IPR000618', NULL, 'Insect cuticle protein', 'Insect_cuticle', 4, NULL),
(5790, NULL, 'IPR001530', NULL, 'Geminivirus BR1 coat protein', 'Gemini_BR1', 4, NULL),
(5791, NULL, 'IPR002295', NULL, 'N4/N6-methyltransferase, Type III restriction-modification enzyme EcoPI Mod subunit-like', 'N4/N6-MTase_EcoPI_Mod-like', 4, NULL),
(5792, NULL, 'IPR004387', NULL, 'Peptidase M50, putative membrane-associated zinc metallopeptidase', 'Pept_M50_Zn', 4, NULL),
(5793, NULL, 'IPR002855', NULL, 'Phosphopantoate/pantothenate synthetase', 'PPS/PS', 4, NULL),
(5794, NULL, 'IPR006397', NULL, 'Glyoxylate carboligase', 'Glyox_carbo_lig', 4, NULL),
(5795, NULL, 'IPR002862', NULL, 'Domain of unknown function DUF16', 'DUF16', 3, NULL),
(5796, NULL, 'IPR004389', NULL, 'Ribosomal protein L18, bacterial-type', 'Ribosomal_L18_bac-type', 4, NULL),
(5797, NULL, 'IPR007355', NULL, 'Protein of unknown function DUF424', 'DUF424', 4, NULL),
(5798, NULL, 'IPR005844', NULL, 'Alpha-D-phosphohexomutase, alpha/beta/alpha domain I', 'A-D-PHexomutase_a/b/a-I', 3, NULL),
(5799, NULL, 'IPR000566', NULL, 'Lipocalin/cytosolic fatty-acid binding domain', 'Lipocln_cytosolic_FA-bd_dom', 3, NULL),
(5800, NULL, 'IPR000524', NULL, 'Transcription regulator HTH, GntR', 'Tscrpt_reg_HTH_GntR', 3, NULL),
(5801, NULL, 'IPR024639', NULL, 'DNA polymerase epsilon subunit B, N-terminal', 'DNA_pol_e_bsu_N', 3, NULL),
(5802, NULL, 'IPR000625', NULL, 'Anti-repression trans-activator protein, REV protein', 'REV_protein', 4, NULL),
(5803, NULL, 'IPR001522', NULL, 'Fatty acid desaturase type 1, conserved site', 'FADS-1_CS', 2, NULL),
(5804, NULL, 'IPR007353', NULL, 'Protein of unknown function DUF421', 'DUF421', 4, NULL),
(5805, NULL, 'IPR005807', NULL, 'SecE subunit of protein translocation complex, bacterial-like', 'SecE_bac', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(5806, NULL, 'IPR000491', NULL, 'Inhibin, beta A subunit', 'Inhibin_betaA', 4, NULL),
(5807, NULL, 'IPR002220', NULL, 'DapA-like', 'DapA-like', 4, NULL),
(5808, NULL, 'IPR002852', NULL, 'Uncharacterised protein family UPF0251', 'UPF0251', 4, NULL),
(5809, NULL, 'IPR005795', NULL, 'Major pollen allergen Lol pI', 'LolPI', 4, NULL),
(5810, NULL, 'IPR007360', NULL, 'Invasion gene expression up-regulator, SirB', 'SirB', 4, NULL),
(5811, NULL, 'IPR000531', NULL, 'TonB-dependent receptor-like, beta-barrel', 'TonB-dep_rcpt_b-brl', 3, NULL),
(5812, NULL, 'IPR006980', NULL, 'Ammonia monooxygenase/particulate methane monooxygenase, subunit C', 'NH3_CH4_mOase_C', 4, NULL),
(5813, NULL, 'IPR006986', NULL, 'Nab1, C-terminal', 'Nab1_C', 3, NULL),
(5814, NULL, 'IPR002864', NULL, 'Acyl-ACP thioesterase', 'Acyl-ACP_thioesterase', 4, NULL),
(5815, NULL, 'IPR000568', NULL, 'ATP synthase, F0 complex, subunit A', 'ATP_synth_F0_asu', 4, NULL),
(5816, NULL, 'IPR002239', NULL, 'CC chemokine receptor 4', 'Chemokine_CCR4', 4, NULL),
(5817, NULL, 'IPR007343', NULL, 'Uncharacterised protein family, zinc metallopeptidase putative', 'Uncharacterised_pept_Zn_put', 4, NULL),
(5818, NULL, 'IPR006944', NULL, 'Bacteriophage/Gene transfer agent portal protein', 'Phage/GTA_portal', 4, NULL),
(5819, NULL, 'IPR005803', NULL, 'Fatty acid desaturase type 2, conserved site', 'FADS-2_CS', 2, NULL),
(5820, NULL, 'IPR006961', NULL, 'Harpin, HrpN/Z', 'HrpN/Z', 4, NULL),
(5821, NULL, 'IPR007358', NULL, 'Nucleoid-associated protein NdpA', 'Nucleoid_associated_NdpA', 4, NULL),
(5822, NULL, 'IPR034177', NULL, 'PPARGC1B, RNA recognition motif', 'PPARGC1B_RRM', 3, NULL),
(5823, NULL, 'IPR000484', NULL, 'Photosynthetic reaction centre, L/M', 'Photo_RC_L/M', 4, NULL),
(5824, NULL, 'IPR024726', NULL, 'Ferric siderophore reductase, C-terminal', 'FhuF_C', 3, NULL),
(5825, NULL, 'IPR005839', NULL, 'Methylthiotransferase', 'Methylthiotransferase', 4, NULL),
(5826, NULL, 'IPR002885', NULL, 'Pentatricopeptide repeat', 'Pentatricopeptide_repeat', 7, NULL),
(5827, NULL, 'IPR006406', NULL, 'Nicotinate phosphoribosyltransferase', 'Nic_PRibTrfase', 4, NULL),
(5828, NULL, 'IPR002256', NULL, 'Flavin monooxygenase (FMO) 4', 'Flavin_mOase_4', 4, NULL),
(5829, NULL, 'IPR001542', NULL, 'Defensin, invertebrate/fungal', 'Defensin_invertebrate/fungal', 3, NULL),
(5830, NULL, 'IPR004409', NULL, 'Biotin operon repressor, helix-turn-helix domain', 'Biotin_operon_repress_HTH', 3, NULL),
(5831, NULL, 'IPR006960', NULL, 'Major non-capsid protein, tenuivirus', 'Major_non-capsid_tenuivirus', 4, NULL),
(5832, NULL, 'IPR007342', NULL, 'Pseudouridine-5''-phosphate glycosidase', 'PsuG', 4, NULL),
(5833, NULL, 'IPR024705', NULL, 'Spermatogenesis-associated protein 20', 'Ssp411', 4, NULL),
(5834, NULL, 'IPR005811', NULL, 'ATP-citrate lyase/succinyl-CoA ligase', 'CoA_ligase', 3, NULL),
(5835, NULL, 'IPR000609', NULL, '7TM GPCR, serpentine receptor class g (Srg)', '7TM_GPCR_serpentine_rcpt_Srg', 4, NULL),
(5836, NULL, 'IPR000588', NULL, 'Peptidase A3A, cauliflower mosaic virus-type', 'Pept_A3A', 3, NULL),
(5837, NULL, 'IPR006959', NULL, 'Protein of unknown function DUF645', 'DUF645', 4, NULL),
(5838, NULL, 'IPR007361', NULL, 'Domain of unknown function DUF427', 'DUF427', 3, NULL),
(5839, NULL, 'IPR004391', NULL, 'Glutamate racemase', 'Glu_race', 4, NULL),
(5840, NULL, 'IPR005335', NULL, 'Terminase small subunit', 'Terminase_ssu', 4, NULL),
(5841, NULL, 'IPR000562', NULL, 'Fibronectin type II domain', 'FN_type2_dom', 3, NULL),
(5842, NULL, 'IPR000558', NULL, 'Histone H2B', 'Histone_H2B', 4, NULL),
(5843, NULL, 'IPR007376', NULL, 'dsDNA mimic, putative', 'dsDNA_mimic_put', 4, NULL),
(5844, NULL, 'IPR006361', NULL, 'Uroporphyrinogen decarboxylase HemE', 'Uroporphyrinogen_deCO2ase_HemE', 4, NULL),
(5845, NULL, 'IPR000549', NULL, 'Photosystem I reaction center subunit V/PsaK', 'PSI_PsaG/PsaK', 4, NULL),
(5846, NULL, 'IPR002876', NULL, 'Transcriptional regulator TACO1-like', 'Transcrip_reg_TACO1-like', 4, NULL),
(5847, NULL, 'IPR006370', NULL, '4-hydroxybenzoate polyprenyltransferase-like', 'HB_polyprenyltransferase-like', 4, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(5848, NULL, 'IPR000488', NULL, 'Death domain', 'Death_domain', 3, NULL),
(5849, NULL, 'IPR034011', NULL, 'Attractin-like, C-type lectin-like domain', 'Attractin-like_CTLD', 3, NULL),
(5850, NULL, 'IPR006382', NULL, 'Phosphoglycolate phosphatase', 'PGPase', 4, NULL),
(5851, NULL, 'IPR005848', NULL, 'Urease, alpha subunit', 'Urease_asu', 4, NULL),
(5852, NULL, 'IPR006954', NULL, 'Moulting cycle MLT-10-like protein', 'MLT-10-like', 4, NULL),
(5853, NULL, 'IPR002318', NULL, 'Alanine-tRNA ligase, class IIc', 'Ala-tRNA-lgiase_IIc', 4, NULL),
(5854, NULL, 'IPR001537', NULL, 'tRNA/rRNA methyltransferase, SpoU type', 'SpoU_MeTrfase', 3, NULL),
(5855, NULL, 'IPR000498', NULL, 'Outer membrane protein OmpA-like, transmembrane domain', 'OmpA-like_TM_dom', 3, NULL),
(5856, NULL, 'IPR005849', NULL, 'Galactose-1-phosphate uridyl transferase, N-terminal', 'GalP_Utransf_N', 3, NULL),
(5857, NULL, 'IPR006958', NULL, 'Mak16 protein', 'Mak16', 4, NULL),
(5858, NULL, 'IPR002848', NULL, 'Translin family', 'Translin_fam', 4, NULL),
(5859, NULL, 'IPR004413', NULL, 'Aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase, B subunit', 'Apn/Gln-ADT_bsu', 4, NULL),
(5860, NULL, 'IPR001534', NULL, 'Transthyretin-like', 'Transthyretin-like', 4, NULL),
(5861, NULL, 'IPR000605', NULL, 'Helicase, superfamily 3, single-stranded DNA/RNA virus', 'Helicase_SF3_ssDNA/RNA_vir', 3, NULL),
(5862, NULL, 'IPR000497', NULL, 'Dopamine D5 receptor', 'Dopamine_D5_rcpt', 4, NULL),
(5863, NULL, 'IPR005326', NULL, 'Plectin/S10, N-terminal', 'S10_plectin_N', 3, NULL),
(5864, NULL, 'IPR004383', NULL, 'Ribosomal RNA large subunit methyltransferase RlmN/Cfr', 'rRNA_lsu_MTrfase_RlmN/Cfr', 4, NULL),
(5865, NULL, 'IPR000550', NULL, '7,8-Dihydro-6-hydroxymethylpterin-pyrophosphokinase, HPPK', 'Hppk', 3, NULL),
(5866, NULL, 'IPR006405', NULL, 'Nicotinate phosphoribosyltransferase pncB-type', 'Nic_PRibTrfase_pncB', 4, NULL),
(5867, NULL, 'IPR007352', NULL, 'Protein of unknown function DUF420', 'DUF420', 4, NULL),
(5868, NULL, 'IPR006993', NULL, 'SH3-binding, glutamic acid-rich protein', 'Glut_rich_SH3-bd', 4, NULL),
(5869, NULL, 'IPR002178', NULL, 'PTS EIIA type-2 domain', 'PTS_EIIA_type-2_dom', 3, NULL),
(5870, NULL, 'IPR000614', NULL, 'Free Met sulfoxide reductase conserved site', 'FRMsr_CS', 2, NULL),
(5871, NULL, 'IPR002285', NULL, 'GPCR, family 2, pituitary adenylate cyclase activating polypeptide type 1 receptor', 'GPCR_2_PACAP_1_rcpt', 4, NULL),
(5872, NULL, 'IPR000573', NULL, 'Aconitase A/isopropylmalate dehydratase small subunit, swivel domain', 'AconitaseA/IPMdHydase_ssu_swvl', 3, NULL),
(5873, NULL, 'IPR000664', NULL, 'Lethal(2) giant larvae protein', 'Lethal2_giant', 4, NULL),
(5874, NULL, 'IPR006963', NULL, 'Molybdopterin oxidoreductase, 4Fe-4S domain', 'Mopterin_OxRdtase_4Fe-4S_dom', 3, NULL),
(5875, NULL, 'IPR006990', NULL, 'Tweety', 'Tweety', 4, NULL),
(5876, NULL, 'IPR006385', NULL, 'HAD-superfamily hydrolase,  subfamily IB, SerB1-like', 'HAD_hydro_SerB1', 4, NULL),
(5877, NULL, 'IPR005789', NULL, 'Threonine dehydratase, catabolic', 'Thr_deHydtase_catblc', 4, NULL),
(5878, NULL, 'IPR000523', NULL, 'Magnesium chelatase ChlI-like, catalytic domain', 'Mg_chelatse_chII-like_cat_dom', 3, NULL),
(5879, NULL, 'IPR000490', NULL, 'Glycoside hydrolase family 17', 'Glyco_hydro_17', 4, NULL),
(5880, NULL, 'IPR007357', NULL, 'Photolyase PhrB-like', 'PhrB-like', 4, NULL),
(5881, NULL, 'IPR006408', NULL, 'P-type ATPase, subfamily IIB', 'P-type_ATPase_IIB', 4, NULL),
(5882, NULL, 'IPR006948', NULL, 'Alliinase, C-terminal', 'Alliinase_C', 3, NULL),
(5883, NULL, 'IPR002196', NULL, 'Glycoside hydrolase, family 24', 'Glyco_hydro_24', 4, NULL),
(5884, NULL, 'IPR005320', NULL, 'Peptidase S51', 'Peptidase_S51', 4, NULL),
(5885, NULL, 'IPR005822', NULL, 'Ribosomal protein L13', 'Ribosomal_L13', 4, NULL),
(5886, NULL, 'IPR005783', NULL, 'Methylmalonyl-CoA decarboxylase, alpha subunit', 'MemalonylCoA_decase_suA', 4, NULL),
(5887, NULL, 'IPR000617', NULL, 'Napin/ 2S seed storage protein/Conglutin', 'Napin/2SS/CON', 4, NULL),
(5888, NULL, 'IPR002870', NULL, 'Peptidase M12B, propeptide', 'Peptidase_M12B_N', 3, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(5889, NULL, 'IPR000551', NULL, 'MerR-type HTH domain', 'MerR-type_HTH_dom', 3, NULL),
(5890, NULL, 'IPR002187', NULL, 'Nitrogen regulatory protein PII', 'N-reg_PII', 4, NULL),
(5891, NULL, 'IPR000438', NULL, 'Acetyl-CoA carboxylase carboxyl transferase, beta subunit', 'Acetyl_CoA_COase_Trfase_b_su', 4, NULL),
(5892, NULL, 'IPR000463', NULL, 'Cytosolic fatty-acid binding', 'Fatty_acid-bd', 3, NULL),
(5893, NULL, 'IPR000633', NULL, 'Vinculin, conserved site', 'Vinculin_CS', 2, NULL),
(5894, NULL, 'IPR001533', NULL, 'Pterin 4 alpha carbinolamine dehydratase', 'Pterin_deHydtase', 4, NULL),
(5895, NULL, 'IPR000532', NULL, 'Glucagon/GIP/secretin/VIP', 'Glucagon_GIP_secretin_VIP', 3, NULL),
(5896, NULL, 'IPR000530', NULL, 'Ribosomal protein S12e', 'Ribosomal_S12e', 4, NULL),
(5897, NULL, 'IPR034142', NULL, 'Reverse gyrase, TOPRIM domain', 'TOPRIM_RevGyr', 3, NULL),
(5898, NULL, 'IPR006358', NULL, 'Transcription elongation factor GreB', 'Tscrpt_elong_fac_GreB', 4, NULL),
(5899, NULL, 'IPR000659', NULL, 'Pyridoxamine 5''-phosphate oxidase', 'Pyridox_Oxase', 4, NULL),
(5900, NULL, 'IPR007350', NULL, 'Transposase, Tc5, C-terminal', 'Transposase_Tc5_C', 3, NULL),
(5901, NULL, 'IPR000548', NULL, 'Myelin basic protein', 'Myelin_BP', 4, NULL),
(5902, NULL, 'IPR006971', NULL, 'Poxvirus M2', 'Poxvirus_M2', 4, NULL),
(5903, NULL, 'IPR034624', NULL, 'Xylonate dehydratase 2', 'Xylonate_dehydratase_2', 4, NULL),
(5904, NULL, 'IPR000595', NULL, 'Cyclic nucleotide-binding domain', 'cNMP-bd_dom', 3, NULL),
(5905, NULL, 'IPR007366', NULL, 'Protein of unknown function DUF432', 'DUF432', 4, NULL),
(5906, NULL, 'IPR005325', NULL, 'Protein of unknown function DUF308, membrane', 'DUF308_memb', 7, NULL),
(5907, NULL, 'IPR000569', NULL, 'HECT domain', 'HECT_dom', 3, NULL),
(5908, NULL, 'IPR005780', NULL, 'Tetrahydromethanopterin S-methyltransferase, subunit E', 'MeTrfase_E', 4, NULL),
(5909, NULL, 'IPR002847', NULL, 'Coenzyme F420:L-glutamate ligase-like domain', 'F420-0_gamma-glut_ligase-dom', 3, NULL),
(5910, NULL, 'IPR005324', NULL, 'Ribosomal protein S5, C-terminal', 'Ribosomal_S5_C', 3, NULL),
(5911, NULL, 'IPR005824', NULL, 'KOW', 'KOW', 3, NULL),
(5912, NULL, 'IPR007346', NULL, 'Endonuclease I', 'Endonuclease-I', 4, NULL),
(5913, NULL, 'IPR000535', NULL, 'Major sperm protein (MSP) domain', 'MSP_dom', 3, NULL),
(5914, NULL, 'IPR005330', NULL, 'MHYT domain', 'MHYT_dom', 3, NULL),
(5915, NULL, 'IPR004412', NULL, 'Glutamyl-tRNA(Gln) amidotransferase A subunit', 'GatA', 4, NULL),
(5916, NULL, 'IPR004379', NULL, 'UDP-galactopyranose mutase', 'UDP-GALP_mutase', 4, NULL),
(5917, NULL, 'IPR005840', NULL, 'Ribosomal protein S12 methylthiotransferase RimO', 'Ribosomal_S12_MeSTrfase_RimO', 4, NULL),
(5918, NULL, 'IPR006375', NULL, 'Mannose-1-phosphate guanylyltransferase/mannose-6-phosphate isomerase', 'Man1P_GuaTrfase/Man6P_Isoase', 4, NULL),
(5919, NULL, 'IPR007359', NULL, 'Positive regulator of sigma(E), RseC/MucC', 'SigmaE_reg_RseC_MucC', 4, NULL),
(5920, NULL, 'IPR006946', NULL, 'DUF642 L-galactono-1,4-lactone-responsive gene 2-like domain', 'DGR2-like_dom', 3, NULL),
(5921, NULL, 'IPR005786', NULL, 'Branched-chain amino acid aminotransferase II', 'B_amino_transII', 4, NULL),
(5922, NULL, 'IPR034125', NULL, 'RBM6, RNA recognition motif 2', 'RBM6_RRM2', 3, NULL),
(5923, NULL, 'IPR004404', NULL, 'Dihydroxy-acid dehydratase', 'DihydroxyA_deHydtase', 4, NULL),
(5924, NULL, 'IPR002889', NULL, 'Carbohydrate-binding WSC', 'WSC_carb-bd', 3, NULL),
(5925, NULL, 'IPR034202', NULL, 'Subtilisin Carlsberg-like catalytic domain', 'Subtilisin_Carlsberg-like', 3, NULL),
(5926, NULL, 'IPR006364', NULL, 'Precorrin-2 C(20)-methyltransferase domain', 'CobI/CbiL/CobIJ_dom', 3, NULL),
(5927, NULL, 'IPR005787', NULL, 'Threonine dehydratase, biosynthetic', 'Thr_deHydtase_biosynth', 4, NULL),
(5928, NULL, 'IPR002306', NULL, 'Tryptophan-tRNA ligase', 'Trp-tRNA-ligase', 4, NULL),
(5929, NULL, 'IPR007382', NULL, 'Uncharacterised protein family UPF0756, transmembrame', 'UPF0756_TM', 4, NULL),
(5930, NULL, 'IPR034189', NULL, 'MARF1, RNA recognition motif 1', 'MARF1_RRM1', 3, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(5931, NULL, 'IPR000608', NULL, 'Ubiquitin-conjugating enzyme E2', 'UBQ-conjugat_E2', 3, NULL),
(5932, NULL, 'IPR006365', NULL, 'Cobalamin (vitamin B12) biosynthesis CobL/Precorrin-6Y C(5,15)-methyltransferase', 'Cbl_synth_CobL', 4, NULL),
(5933, NULL, 'IPR007344', NULL, 'GrpB/Dephospho-CoA kinase', 'GrpB/CoaE', 4, NULL),
(5934, NULL, 'IPR007362', NULL, 'Protein of unknown function DUF429', 'DUF429', 4, NULL),
(5935, NULL, 'IPR004384', NULL, 'RNA methyltransferase TrmJ/LasT', 'RNA_MeTrfase_TrmJ/LasT', 4, NULL),
(5936, NULL, 'IPR007380', NULL, 'Domain of unknown function DUF438', 'DUF438', 3, NULL),
(5937, NULL, 'IPR005782', NULL, 'P-type ATPase, subfamily  IIA, SERCA-type', 'P-type_ATPase_IIA', 4, NULL),
(5938, NULL, 'IPR007371', NULL, 'Thiamin pyrophosphokinase, catalytic domain', 'TPK_catalytic', 3, NULL),
(5939, NULL, 'IPR034144', NULL, 'DNA topoisomerase 3-like, TOPRIM domain', 'TOPRIM_TopoIII', 3, NULL),
(5940, NULL, 'IPR000443', NULL, 'Islet amyloid polypeptide', 'IAPP', 4, NULL),
(5941, NULL, 'IPR002181', NULL, 'Fibrinogen, alpha/beta/gamma chain, C-terminal globular domain', 'Fibrinogen_a/b/g_C_dom', 3, NULL),
(5942, NULL, 'IPR006956', NULL, 'Poxvirus L5', 'Poxvirus_L5', 4, NULL),
(5943, NULL, 'IPR006380', NULL, 'Sucrose phosphatase-like domain', 'SPP-like_dom', 3, NULL),
(5944, NULL, 'IPR000534', NULL, 'Semialdehyde dehydrogenase, NAD-binding', 'Semialdehyde_DH_NAD-bd', 3, NULL),
(5945, NULL, 'IPR005821', NULL, 'Ion transport domain', 'Ion_trans_dom', 3, NULL),
(5946, NULL, 'IPR002276', NULL, 'G protein-coupled receptor 4 orphan', 'GPR4_orph', 4, NULL),
(5947, NULL, 'IPR024666', NULL, 'HnRNP M, nuclear localisation signal', 'HnRNP_M_PY-NLS', 3, NULL),
(5948, NULL, 'IPR000600', NULL, 'ROK family', 'ROK', 4, NULL),
(5949, NULL, 'IPR000539', NULL, 'Frizzled/Smoothened, transmembrane domain', 'Frizzled/Smoothened_TM', 3, NULL),
(5950, NULL, 'IPR004410', NULL, 'Malonyl CoA-acyl carrier protein transacylase, FabD-type', 'Malonyl_CoA-ACP_transAc_FabD', 4, NULL),
(5951, NULL, 'IPR004408', NULL, 'Biotin--acetyl-CoA-carboxylase ligase', 'Biotin_CoA_COase_ligase', 4, NULL),
(5952, NULL, 'IPR007384', NULL, 'Protein of unknown function UCP006257', 'UCP006257', 4, NULL),
(5953, NULL, 'IPR000590', NULL, 'Hydroxymethylglutaryl-coenzyme A synthase, active site', 'HMG_CoA_synt_AS', 0, NULL),
(5954, NULL, 'IPR006389', NULL, 'Early transcribed membrane protein (ETRAMP)', 'ETRAMP', 4, NULL),
(5955, NULL, 'IPR004411', NULL, 'Peptidase A31, coenzyme F420-reducing hydrogenase delta subunit', 'Pept_A31_F420-red_hyd_d', 4, NULL),
(5956, NULL, 'IPR006955', NULL, 'Uso1/p115-like vesicle tethering protein, C-terminal', 'Uso1_p115_C', 3, NULL),
(5957, NULL, 'IPR002205', NULL, 'DNA topoisomerase, type IIA,  domain A', 'Topo_IIA_dom_A', 3, NULL),
(5958, NULL, 'IPR006391', NULL, 'P-type ATPase, B chain, subfamily IA', 'P-type_ATPase_bsu_IA', 4, NULL),
(5959, NULL, 'IPR007356', NULL, 'tRNA (guanine-N1-)-methyltransferase, eukaryotic', 'tRNA_m1G_MeTrfase_euk', 4, NULL),
(5960, NULL, 'IPR006934', NULL, 'Baculovirus occlusion-derived virus envelope, E66', 'Baculo_ODV-E66', 4, NULL),
(5961, NULL, 'IPR002853', NULL, 'Transcription initiation factor IIE subunit alpha, N-terminal', 'TFIIE_asu', 3, NULL),
(5962, NULL, 'IPR006938', NULL, 'Protein of unknown function DUF624', 'DUF624', 4, NULL),
(5963, NULL, 'IPR000581', NULL, 'Dihydroxy-acid/6-phosphogluconate dehydratase', 'DiOHA_6PGluconate_deHydtase', 4, NULL),
(5964, NULL, 'IPR000519', NULL, 'P-type trefoil domain', 'P_trefoil_dom', 3, NULL),
(5965, NULL, 'IPR006972', NULL, 'Secretion system effector C, SseC-like', 'SseC', 4, NULL),
(5966, NULL, 'IPR006973', NULL, 'Pre-mRNA-splicing factor  Cwf15/Cwc15', 'Cwf_Cwc_15', 4, NULL),
(5967, NULL, 'IPR002209', NULL, 'Fibroblast growth factor family', 'Fibroblast_GF_fam', 4, NULL),
(5968, NULL, 'IPR006374', NULL, 'Variant surface antigen Stevor', 'VSA_Stevor', 4, NULL),
(5969, NULL, 'IPR000670', NULL, 'Urotensin II receptor', 'Urot_II_rcpt', 4, NULL),
(5970, NULL, 'IPR004403', NULL, 'Peptide chain release factor eRF1/aRF1', 'Peptide_chain-rel_eRF1/aRF1', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(5971, NULL, 'IPR001487', NULL, 'Bromodomain', 'Bromodomain', 3, NULL),
(5972, NULL, 'IPR002846', NULL, 'NrpR regulatory domain', 'NRD', 3, NULL),
(5973, NULL, 'IPR000574', NULL, 'Tymovirus coat protein', 'Tymo_coat', 3, NULL),
(5974, NULL, 'IPR002859', NULL, 'PKD/REJ-like domain', 'PKD/REJ-like', 3, NULL),
(5975, NULL, 'IPR005813', NULL, 'Ribosomal protein L20', 'Ribosomal_L20', 4, NULL),
(5976, NULL, 'IPR005779', NULL, 'Tetrahydromethanopterin S-methyltransferase, subunit D', 'MeTrfase_D', 4, NULL),
(5977, NULL, 'IPR005818', NULL, 'Linker histone H1/H5, domain H15', 'Histone_H1/H5_H15', 3, NULL),
(5978, NULL, 'IPR006983', NULL, 'MbeD/MobD-like', 'MbeD_MobD', 4, NULL),
(5979, NULL, 'IPR002237', NULL, 'CC chemokine receptor 2', 'Chemokine_CCR2', 4, NULL),
(5980, NULL, 'IPR000540', NULL, 'Flagellar motor protein MotA, conserved site', 'Flag_MotA_CS', 2, NULL),
(5981, NULL, 'IPR001539', NULL, 'Peptidase U32', 'Peptidase_U32', 4, NULL),
(5982, NULL, 'IPR000556', NULL, 'Glycoside hydrolase, 48F', 'Glyco_hydro_48F', 4, NULL),
(5983, NULL, 'IPR002273', NULL, 'Lutropin-choriogonadotropic hormone receptor', 'LSH_rcpt', 4, NULL),
(5984, NULL, 'IPR006977', NULL, 'Yip1 domain', 'Yip1_dom', 3, NULL),
(5985, NULL, 'IPR000565', NULL, 'DNA topoisomerase, type IIA, subunit B', 'Topo_IIA_B', 4, NULL),
(5986, NULL, 'IPR000544', NULL, 'Octanoyltransferase', 'Octanoyltransferase', 4, NULL),
(5987, NULL, 'IPR007347', NULL, 'Sporulation stage V, protein S', 'SpoVS', 4, NULL),
(5988, NULL, 'IPR000479', NULL, 'Cation-independent mannose-6-phosphate receptor repeat', 'CIMR_rpt', 7, NULL),
(5989, NULL, 'IPR006943', NULL, 'Domain of unknown function DUF641, plant', 'DUF641_pln', 3, NULL),
(5990, NULL, 'IPR004800', NULL, 'Phosphosugar isomerase, KdsD/KpsF-type', 'KdsD/KpsF-type', 4, NULL),
(5991, NULL, 'IPR004401', NULL, 'Nucleoid-associated protein YbaB/EbfC family', 'YbaB/EbfC', 4, NULL),
(5992, NULL, 'IPR001554', NULL, 'Glycoside hydrolase, family 14', 'Glyco_hydro_14', 4, NULL),
(5993, NULL, 'IPR006976', NULL, 'VanZ-like', 'VanZ-like', 3, NULL),
(5994, NULL, 'IPR006381', NULL, 'HAD-superfamily hydrolase, superfamily IIB, MPGP', 'HAD-SF-IIB-MPGP', 4, NULL),
(5995, NULL, 'IPR005322', NULL, 'Peptidase C69, dipeptidase A', 'Peptidase_C69', 4, NULL),
(5996, NULL, 'IPR006952', NULL, 'Retinal cGMP phosphodiesterase, gamma subunit', 'PDE6_gamma', 4, NULL),
(5997, NULL, 'IPR000623', NULL, 'Shikimate kinase/Threonine synthase-like 1', 'Shikimate_kinase/TSH1', 4, NULL),
(5998, NULL, 'IPR000447', NULL, 'FAD-dependent glycerol-3-phosphate dehydrogenase', 'G3P_DH_FAD-dep', 4, NULL),
(5999, NULL, 'IPR004377', NULL, 'ABC transporter, permease protein DrrB/DrrC', 'ABC_transpt_DrrB/DrrC', 4, NULL),
(6000, NULL, 'IPR002218', NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG-related', 'MnmG-rel', 4, NULL),
(6001, NULL, 'IPR003743', NULL, 'C4-type zinc ribbon domain', 'Zf-RING_7', 3, NULL),
(6002, NULL, 'IPR003471', NULL, 'Adenovirus E3 region protein CR1', 'Adeno_E3_CR1', 3, NULL),
(6003, NULL, 'IPR003910', NULL, 'GPCR, family 2, orphan receptor, GPR1/GPR3/GPR5', 'GPR1/GPR3/GPR5', 4, NULL),
(6004, NULL, 'IPR002321', NULL, 'Cytochrome c, class II', 'Cyt_c_II', 4, NULL),
(6005, NULL, 'IPR002902', NULL, 'Gnk2-homologous domain', 'GNK2', 3, NULL),
(6006, NULL, 'IPR003664', NULL, 'Fatty acid synthesis PlsX protein', 'FA_synthesis', 4, NULL),
(6007, NULL, 'IPR007222', NULL, 'Signal recognition particle receptor, alpha subunit, N-terminal', 'Sig_recog_particle_rcpt_asu_N', 3, NULL),
(6008, NULL, 'IPR002898', NULL, 'MotA/TolQ/ExbB proton channel', 'MotA_ExbB_proton_chnl', 3, NULL),
(6009, NULL, 'IPR003933', NULL, 'Epithelial membrane protein 2', 'EMP-2', 4, NULL),
(6010, NULL, 'IPR034433', NULL, 'Vomeromodulin', 'Vomeromodulin', 4, NULL),
(6011, NULL, 'IPR003919', NULL, 'Cellulose synthase, subunit A', 'Cell_synth_A', 4, NULL),
(6012, NULL, 'IPR006469', NULL, 'NifC-like ABC-type porter', 'NifC_ABC_porter', 4, NULL),
(6013, NULL, 'IPR003923', NULL, 'Transcription initiation factor TFIID, 23-30kDa subunit', 'TFIID_30kDa', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(6014, NULL, 'IPR009076', NULL, 'FKBP12-rapamycin binding domain', 'FRB_dom', 3, NULL),
(6015, NULL, 'IPR034398', NULL, 'Prp24, RNA recognition motif2', 'Prp24_RRM2', 3, NULL),
(6016, NULL, 'IPR002323', NULL, 'Cytochrome c, class IE', 'Cyt_CIE', 4, NULL),
(6017, NULL, 'IPR006471', NULL, 'Formate dehydrogenase, gamma subunit', 'Formate_DH_gsu', 4, NULL),
(6018, NULL, 'IPR006489', NULL, 'Plasmodium yoelii repeat of length 46', 'PY-rept-46', 7, NULL),
(6019, NULL, 'IPR003932', NULL, 'Epithelial membrane protein EMP-1', 'EMP_1', 4, NULL),
(6020, NULL, 'IPR003519', NULL, 'OspF/SpvC', 'OspF/SpvC', 4, NULL),
(6021, NULL, 'IPR002310', NULL, 'Glycine-tRNA ligase, alpha subunit', 'Gly-tRNA_ligase_asu', 4, NULL),
(6022, NULL, 'IPR002299', NULL, 'Porin, Neisseria sp. type', 'Porin_Neis', 4, NULL),
(6023, NULL, 'IPR005371', NULL, 'Uncharacterised protein family UPF0181', 'UPF0181', 4, NULL),
(6024, NULL, 'IPR009084', NULL, 'B transposition protein, C-terminal', 'B_transpositn_C', 3, NULL),
(6025, NULL, 'IPR002374', NULL, 'cGMP-dependent kinase', 'cGMP_dep_kinase', 4, NULL),
(6026, NULL, 'IPR001462', NULL, 'Hepadnaviral P protein, C-terminal', 'DNApol_viral_C', 3, NULL),
(6027, NULL, 'IPR009051', NULL, 'Alpha-helical ferredoxin', 'Helical_ferredxn', 5, NULL),
(6028, NULL, 'IPR002327', NULL, 'Cytochrome c, class IA/ IB', 'Cyt_c_1A/1B', 4, NULL),
(6029, NULL, 'IPR009064', NULL, 'Pheromone, protozoan', 'Pheromone_protoz', 4, NULL),
(6030, NULL, 'IPR009078', NULL, 'Ferritin-like superfamily', 'Ferritin-like_SF', 5, NULL),
(6031, NULL, 'IPR002264', NULL, 'Gap junction alpha-5 protein (Cx40)', 'Connexin40', 4, NULL),
(6032, NULL, 'IPR002893', NULL, 'Zinc finger, MYND-type', 'Znf_MYND', 3, NULL),
(6033, NULL, 'IPR003550', NULL, 'Claudin-4', 'Claudin4', 4, NULL),
(6034, NULL, 'IPR002906', NULL, 'Ribosomal protein S27a', 'Ribosomal_S27a', 3, NULL),
(6035, NULL, 'IPR002362', NULL, 'Light-harvesting protein B beta chain', 'LHB-1/5', 4, NULL),
(6036, NULL, 'IPR003736', NULL, 'Phenylacetic acid degradation-related domain', 'PAAI_dom', 3, NULL),
(6037, NULL, 'IPR003795', NULL, 'Protein of unknown function DUF192', 'DUF192', 4, NULL),
(6038, NULL, 'IPR003565', NULL, 'Bis(5''-nucleosyl)-tetraphosphatase', 'Tetra_PHTase', 4, NULL),
(6039, NULL, 'IPR005343', NULL, 'Nucleolar complex protein 2', 'Noc2', 4, NULL),
(6040, NULL, 'IPR008076', NULL, 'Cyanate hydratase', 'Cyanase', 4, NULL),
(6041, NULL, 'IPR001507', NULL, 'Zona pellucida domain', 'ZP_dom', 3, NULL),
(6042, NULL, 'IPR003797', NULL, 'DegV', 'DegV', 4, NULL),
(6043, NULL, 'IPR003492', NULL, 'Batten''s disease protein Cln3', 'Battenin_disease_Cln3', 4, NULL),
(6044, NULL, 'IPR008087', NULL, 'Autoimmune regulator, AIRE', 'AIRE', 4, NULL),
(6045, NULL, 'IPR006473', NULL, 'Peptidase C58, YopT-type domain', 'Peptidase_C58_Yopt', 3, NULL),
(6046, NULL, 'IPR002918', NULL, 'Lipase EstA/Esterase EstB', 'Lipase_EstA/Esterase_EstB', 4, NULL),
(6047, NULL, 'IPR003473', NULL, 'Quinolinate synthetase A', 'NadA', 4, NULL),
(6048, NULL, 'IPR005341', NULL, 'Mitochondrial import inner membrane translocase subunit Tim16', 'Tim16', 4, NULL),
(6049, NULL, 'IPR008088', NULL, 'Alpha giardin', 'Alpha_giardin', 4, NULL),
(6050, NULL, 'IPR034422', NULL, 'HydE/PylB-like', 'HydE/PylB-like', 4, NULL),
(6051, NULL, 'IPR008115', NULL, 'Septin 7', 'Septin7', 4, NULL),
(6052, NULL, 'IPR034191', NULL, 'MARF1, RNA recognition motif 2', 'MARF1_RRM2', 3, NULL),
(6053, NULL, 'IPR001513', NULL, 'Adenosine A2A receptor', 'Adeno_A2A_rcpt', 4, NULL),
(6054, NULL, 'IPR008125', NULL, 'Streptothricin acetyltransferase', 'Streptothricin_AcTrfase', 4, NULL),
(6055, NULL, 'IPR002317', NULL, 'Serine-tRNA ligase, type1', 'Ser-tRNA-ligase_type_1', 4, NULL),
(6056, NULL, 'IPR005337', NULL, 'RapZ-like family', 'RapZ-like', 4, NULL),
(6057, NULL, 'IPR002345', NULL, 'Lipocalin', 'Lipocalin', 4, NULL),
(6058, NULL, 'IPR003464', NULL, 'Muconolactone delta-isomerase', 'Muconolactone_d_Isoase', 4, NULL),
(6059, NULL, 'IPR003897', NULL, 'Clostridium enterotoxin', 'Clenterotox', 4, NULL),
(6060, NULL, 'IPR003921', NULL, 'Cellulose synthase, subunit C', 'Cell_synth_C', 4, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(6061, NULL, 'IPR009086', NULL, 'Bacteriocin AS-48', 'Bacteriocin_AS48', 5, NULL),
(6062, NULL, 'IPR008094', NULL, 'Claudin-15', 'Claudin15', 4, NULL),
(6063, NULL, 'IPR008109', NULL, 'P2Y13 purinoceptor', 'P2Y13_rcpt', 4, NULL),
(6064, NULL, 'IPR009072', NULL, 'Histone-fold', 'Histone-fold', 5, NULL),
(6065, NULL, 'IPR034428', NULL, 'ThiH/NocL/HydG-like', 'ThiH/NoCL/HydG-like', 4, NULL),
(6066, NULL, 'IPR003833', NULL, 'Carboxyltransferase domain, subdomain C and D', 'CT_C_D', 3, NULL),
(6067, NULL, 'IPR003729', NULL, 'Bifunctional nuclease domain', 'Bi_nuclease_dom', 3, NULL),
(6068, NULL, 'IPR002390', NULL, 'Annexin A3', 'ANX3', 4, NULL),
(6069, NULL, 'IPR002331', NULL, 'Pancreatic lipase', 'Lipase_panc', 4, NULL),
(6070, NULL, 'IPR009094', NULL, 'Disulphide bond isomerase DsbC/G, N-terminal domain superfamily', 'DiS-bond_isomerase_DsbC/G_N_sf', 5, NULL),
(6071, NULL, 'IPR023933', NULL, 'Glycoside hydrolase, family 2, beta-galactosidase', 'Glyco_hydro_2_beta_Galsidase', 4, NULL),
(6072, NULL, 'IPR006494', NULL, 'Plasmodium subtelomeric PST-A', 'PST_A', 4, NULL),
(6073, NULL, 'IPR005376', NULL, 'Adenovirus DNA-binding, zinc-binding domain', 'Adenovirus_DNA-bd_zn-bd', 3, NULL),
(6074, NULL, 'IPR008275', NULL, 'CoA enzyme activase', 'CoA_E_activase', 3, NULL),
(6075, NULL, 'IPR003561', NULL, 'Mutator MutT', 'Mutator_MutT', 4, NULL),
(6076, NULL, 'IPR034252', NULL, 'Ephrin-A ectodomain', 'Ephrin-A_Ecto', 3, NULL),
(6077, NULL, 'IPR003370', NULL, 'Chromate transporter', 'Chromate_transpt', 4, NULL),
(6078, NULL, 'IPR002376', NULL, 'Formyl transferase, N-terminal', 'Formyl_transf_N', 3, NULL),
(6079, NULL, 'IPR008128', NULL, 'Glycine receptor alpha1', 'Glycine_rcpt_A1', 4, NULL),
(6080, NULL, 'IPR002915', NULL, 'DeoC/FbaB/LacD aldolase', 'DeoC/FbaB/LacD_aldolase', 4, NULL),
(6081, NULL, 'IPR005361', NULL, 'Uncharacterised protein family UPF0158', 'UPF0158', 4, NULL),
(6082, NULL, 'IPR024647', NULL, 'DNA polymerase alpha catalytic subunit, N-terminal domain', 'DNA_pol_a_cat_su_N', 3, NULL),
(6083, NULL, 'IPR009053', NULL, 'Prefoldin', 'Prefoldin', 5, NULL),
(6084, NULL, 'IPR005350', NULL, 'Uncharacterised protein family UPF0137', 'UPF0137', 4, NULL),
(6085, NULL, 'IPR002347', NULL, 'Short-chain dehydrogenase/reductase SDR', 'SDR_fam', 4, NULL),
(6086, NULL, 'IPR003672', NULL, 'CobN/magnesium chelatase', 'CobN/Mg_chltase', 4, NULL),
(6087, NULL, 'IPR008131', NULL, 'Early E3 14.5kDa protein', 'Adeno_E3_14_5', 4, NULL),
(6088, NULL, 'IPR002316', NULL, 'Proline-tRNA ligase, class IIa', 'Pro-tRNA-ligase_IIa', 4, NULL),
(6089, NULL, 'IPR009060', NULL, 'UBA-like superfamily', 'UBA-like_sf', 5, NULL),
(6090, NULL, 'IPR002397', NULL, 'Cytochrome P450, B-class', 'Cyt_P450_B', 4, NULL),
(6091, NULL, 'IPR003738', NULL, 'SOS response associated peptidase (SRAP)', 'SRAP', 4, NULL),
(6092, NULL, 'IPR001484', NULL, 'Pyrokinin, conserved site', 'Pyrokinin_CS', 2, NULL),
(6093, NULL, 'IPR005374', NULL, 'Bublin coiled-coil protein-like, eukaryota', 'BBLN_eukaryota', 4, NULL),
(6094, NULL, 'IPR002371', NULL, 'Flagellar hook-associated protein 1', 'FlgK', 4, NULL),
(6095, NULL, 'IPR009061', NULL, 'Putative DNA-binding domain superfamily', 'DNA-bd_dom_put_sf', 5, NULL),
(6096, NULL, 'IPR008107', NULL, 'Mycoplasma P48 major surface lipoprotein', 'Mycoplasma_p48', 4, NULL),
(6097, NULL, 'IPR002267', NULL, 'Gap junction beta-1 protein (Cx32)', 'Connexin32', 4, NULL),
(6098, NULL, 'IPR003914', NULL, 'Rabaptin', 'Rabaptin', 4, NULL),
(6099, NULL, 'IPR010058', NULL, 'Uridine phosphorylase', 'Uridine_phosphorylase', 4, NULL),
(6100, NULL, 'IPR010072', NULL, 'D-alanine--D-alanyl carrier protein ligase', 'DltA', 4, NULL),
(6101, NULL, 'IPR034642', NULL, 'Proteasome subunit alpha6', 'Proteasome_subunit_alpha6', 4, NULL),
(6102, NULL, 'IPR002388', NULL, 'Annexin A1', 'ANX1', 4, NULL),
(6103, NULL, 'IPR002320', NULL, 'Threonine-tRNA ligase, class IIa', 'Thr-tRNA-ligase_IIa', 4, NULL),
(6104, NULL, 'IPR003906', NULL, 'Galanin receptor 1', 'GAL1_rcpt', 4, NULL),
(6105, NULL, 'IPR002319', NULL, 'Phenylalanyl-tRNA synthetase', 'Phenylalanyl-tRNA_Synthase', 3, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(6106, NULL, 'IPR008113', NULL, 'Septin 2', 'Septin2', 4, NULL),
(6107, NULL, 'IPR003929', NULL, 'Calcium-activated potassium channel BK, alpha subunit', 'K_chnl_BK_asu', 3, NULL),
(6108, NULL, 'IPR003737', NULL, 'N-acetylglucosaminyl phosphatidylinositol deacetylase-related', 'GlcNAc_PI_deacetylase-related', 4, NULL),
(6109, NULL, 'IPR003728', NULL, 'Ribosome maturation factor RimP', 'Ribosome_maturation_RimP', 4, NULL),
(6110, NULL, 'IPR008117', NULL, 'Micronemal protein 1', 'Microneme_MIC1', 4, NULL),
(6111, NULL, 'IPR002912', NULL, 'ACT domain', 'ACT_dom', 3, NULL),
(6112, NULL, 'IPR003528', NULL, 'Long hematopoietin receptor, single chain, conserved site', 'Long_hematopoietin_rcpt_CS', 2, NULL),
(6113, NULL, 'IPR034652', NULL, 'Signal recognition particle subunit SRP68, RNA-binding domain', 'SRP68-RBD', 3, NULL),
(6114, NULL, 'IPR001517', NULL, 'Luteovirus group 1 coat protein', 'Luteo_coat', 4, NULL),
(6115, NULL, 'IPR002398', NULL, 'Peptidase C14 family', 'Pept_C14', 4, NULL),
(6116, NULL, 'IPR008126', NULL, 'Outer membrane adhesion, Yersinia', 'OM_adhesion_Yersinia', 4, NULL),
(6117, NULL, 'IPR008130', NULL, 'Glycine receptor alpha3', 'Glycine_rcpt_A3', 4, NULL),
(6118, NULL, 'IPR007217', NULL, 'Per1-like', 'Per1-like', 4, NULL),
(6119, NULL, 'IPR001456', NULL, 'Helper component proteinase', 'HC-pro', 4, NULL),
(6120, NULL, 'IPR006483', NULL, 'CRISPR-associated  Cas3-type HD domain', 'CRISPR-assoc_Cas3_HD', 3, NULL),
(6121, NULL, 'IPR002338', NULL, 'Hemoglobin, alpha-type', 'Hemoglobin_a-typ', 4, NULL),
(6122, NULL, 'IPR003684', NULL, 'Porin, alpha proteobacteria type', 'Porin_alphabac', 4, NULL),
(6123, NULL, 'IPR003749', NULL, 'Sulfur carrier ThiS/MoaD-like', 'ThiS/MoaD-like', 4, NULL),
(6124, NULL, 'IPR003924', NULL, 'GPCR, family 2, latrophilin', 'GPCR_2_latrophilin', 4, NULL),
(6125, NULL, 'IPR005368', NULL, 'Uncharacterised protein family UPF0175', 'UPF0175', 4, NULL),
(6126, NULL, 'IPR003520', NULL, 'Salmonella/Shigella invasion protein E', 'Invas_InvE', 4, NULL),
(6127, NULL, 'IPR002903', NULL, 'Ribosomal RNA small subunit methyltransferase H', 'RsmH', 4, NULL),
(6128, NULL, 'IPR024646', NULL, 'Angiomotin, C-terminal', 'Angiomotin_C', 3, NULL),
(6129, NULL, 'IPR003768', NULL, 'Segregation and condensation protein A', 'ScpA', 4, NULL),
(6130, NULL, 'IPR006477', NULL, 'Variant antigen yir/bir/cir', 'Yir_bir_cir', 4, NULL),
(6131, NULL, 'IPR006481', NULL, 'Bacteriophage lambda, GpS, holin', 'Phage_lambda_GpS_holin', 4, NULL),
(6132, NULL, 'IPR001469', NULL, 'ATP synthase, F1 complex, delta/epsilon subunit', 'ATP_synth_F1_dsu/esu', 4, NULL),
(6133, NULL, 'IPR005370', NULL, 'Uncharacterised protein family UPF0180', 'UPF0180', 4, NULL),
(6134, NULL, 'IPR003676', NULL, 'Small auxin-up RNA', 'SAUR_fam', 4, NULL),
(6135, NULL, 'IPR023935', NULL, 'Replication factor C, large subunit', 'Rep_factor-C_lsu', 4, NULL),
(6136, NULL, 'IPR003380', NULL, 'SKI/SNO/DAC domain', 'SKI/SNO/DAC', 3, NULL),
(6137, NULL, 'IPR008073', NULL, 'Potassium channel subfamily K member 15', 'TASK5', 4, NULL),
(6138, NULL, 'IPR009079', NULL, 'Four-helical cytokine-like, core', '4_helix_cytokine-like_core', 5, NULL),
(6139, NULL, 'IPR008079', NULL, 'Voltage-dependent calcium channel, L-type, beta-3 subunit', 'VDCC_L_b3su', 4, NULL),
(6140, NULL, 'IPR002339', NULL, 'Hemoglobin, pi', 'Hemoglobin_pi', 4, NULL),
(6141, NULL, 'IPR003927', NULL, 'Claudin-16', 'Claudin16', 4, NULL),
(6142, NULL, 'IPR003571', NULL, 'Snake three-finger toxin', 'Snake_3FTx', 4, NULL),
(6143, NULL, 'IPR003223', NULL, 'Flagellin phase1 repressor', 'Flag1_repressor', 4, NULL),
(6144, NULL, 'IPR001414', NULL, 'G-protein coupled receptor 143', 'GPR143', 4, NULL),
(6145, NULL, 'IPR002330', NULL, 'Lipoprotein lipase', 'Lipo_Lipase', 4, NULL),
(6146, NULL, 'IPR002919', NULL, 'Trypsin Inhibitor-like, cysteine rich domain', 'TIL_dom', 3, NULL),
(6147, NULL, 'IPR009091', NULL, 'Regulator of chromosome condensation 1/beta-lactamase-inhibitor protein II', 'RCC1/BLIP-II', 5, NULL),
(6148, NULL, 'IPR008132', NULL, '5-hydroxytryptamine 3 receptor', '5HT3_rcpt', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(6149, NULL, 'IPR003790', NULL, 'Glycosyl hydrolase-like 10', 'GHL10', 3, NULL),
(6150, NULL, 'IPR010064', NULL, 'Bacteriophage HK97-gp10, putative tail-component', 'HK97-gp10_tail', 4, NULL),
(6151, NULL, 'IPR010061', NULL, 'Methylmalonate-semialdehyde dehydrogenase', 'MeMal-semiAld_DH', 4, NULL),
(6152, NULL, 'IPR002355', NULL, 'Multicopper oxidase, copper-binding site', 'Cu_oxidase_Cu_BS', 1, NULL),
(6153, NULL, 'IPR008111', NULL, 'RNA-binding motif protein 8', 'RNA-bd_8', 4, NULL),
(6154, NULL, 'IPR003518', NULL, 'Salmonella plasmid virulence SpvA', 'Sal_SpvA', 4, NULL),
(6155, NULL, 'IPR002913', NULL, 'START domain', 'START_lipid-bd_dom', 3, NULL),
(6156, NULL, 'IPR003497', NULL, 'BRO N-terminal domain', 'BRO_N_domain', 3, NULL),
(6157, NULL, 'IPR008095', NULL, 'MHC class II transactivator', 'MHC_II_transact', 4, NULL),
(6158, NULL, 'IPR003912', NULL, 'Protease-activated receptor', 'Protea_act_rcpt', 4, NULL),
(6159, NULL, 'IPR009081', NULL, 'Phosphopantetheine binding ACP domain', 'PP-bd_ACP', 3, NULL),
(6160, NULL, 'IPR005381', NULL, 'Zinc finger-XS domain', 'Znf-XS_domain', 3, NULL),
(6161, NULL, 'IPR008083', NULL, 'CD34 antigen', 'CD34', 4, NULL),
(6162, NULL, 'IPR008102', NULL, 'Histamine H4 receptor', 'Histamine_H4_rcpt', 4, NULL),
(6163, NULL, 'IPR008124', NULL, 'Streptokinase', 'SK', 4, NULL),
(6164, NULL, 'IPR009052', NULL, 'DNA polymerase III-theta, bacterial', 'DNA_pol_III_theta_bac', 4, NULL),
(6165, NULL, 'IPR002361', NULL, 'Antenna complex, alpha subunit conserved site', 'Antenna_alpha_CS', 2, NULL),
(6166, NULL, 'IPR034661', NULL, 'Atypical protein kinase C iota type, catalytic domain', 'aPKC_iota', 3, NULL),
(6167, NULL, 'IPR003486', NULL, 'Nucleocapsid N protein', 'Nairo_nucleocap', 4, NULL),
(6168, NULL, 'IPR003791', NULL, 'Protein of unknown function UPF0178', 'UPF0178', 4, NULL),
(6169, NULL, 'IPR003514', NULL, 'Microviridae F protein', 'Microviridae_protein_F', 4, NULL),
(6170, NULL, 'IPR014349', NULL, 'Rieske iron-sulphur protein', 'Rieske_Fe-S_prot', 4, NULL),
(6171, NULL, 'IPR008120', NULL, 'Dense granule Gra7 protein', 'Dense_granule_Gra7_protein', 4, NULL),
(6172, NULL, 'IPR002266', NULL, 'Gap junction alpha-8 protein (Cx50)', 'Connexin50', 4, NULL),
(6173, NULL, 'IPR006485', NULL, 'Bacteriophage holin', 'Phage_holin', 4, NULL),
(6174, NULL, 'IPR013152', NULL, 'Gastrin/cholecystokinin, conserved site', 'Gastrin/cholecystokinin_CS', 2, NULL),
(6175, NULL, 'IPR008103', NULL, 'KiSS-1 peptide receptor', 'KiSS_1_rcpt', 4, NULL),
(6176, NULL, 'IPR005188', NULL, 'Influenza C non-structural protein NS2', 'Flu_C_NS2', 3, NULL),
(6177, NULL, 'IPR002328', NULL, 'Alcohol dehydrogenase, zinc-type, conserved site', 'ADH_Zn_CS', 2, NULL),
(6178, NULL, 'IPR008080', NULL, 'Parvalbumin', 'Parvalbumin', 4, NULL),
(6179, NULL, 'IPR003915', NULL, 'Polycystic kidney disease type 2 protein', 'PKD_2', 4, NULL),
(6180, NULL, 'IPR006464', NULL, 'N-acetyltransferase RimI/Ard1', 'AcTrfase_RimI/Ard1', 4, NULL),
(6181, NULL, 'IPR006466', NULL, 'MiaB-like tRNA modifying enzyme, archaeal-type', 'MiaB-like_B', 4, NULL),
(6182, NULL, 'IPR006491', NULL, 'Plasmodium yoelii subtelomeric PYST-C2', 'PYST_C2', 3, NULL),
(6183, NULL, 'IPR008129', NULL, 'Glycine receptor alpha2', 'Glycine_rcpt_A2', 4, NULL),
(6184, NULL, 'IPR008121', NULL, 'Transcription factor AP-2 alpha, N-terminal', 'TF_AP2_alpha_N', 3, NULL),
(6185, NULL, 'IPR002909', NULL, 'IPT domain', 'IPT_dom', 3, NULL),
(6186, NULL, 'IPR003511', NULL, 'HORMA domain', 'HORMA_dom', 3, NULL),
(6187, NULL, 'IPR002387', NULL, 'Plastocyanin', 'Plastocyanin', 4, NULL),
(6188, NULL, 'IPR003499', NULL, 'Probable DNA packing protein, N-terminal', 'DNA_pack_N', 3, NULL),
(6189, NULL, 'IPR007221', NULL, 'Rod shape-determining protein MreC', 'MreC', 4, NULL),
(6190, NULL, 'IPR010059', NULL, 'Uridine phosphorylase, eukaryotic', 'Uridine_phosphorylase_euk', 4, NULL),
(6191, NULL, 'IPR005353', NULL, 'Uncharacterised protein family UPF0146', 'UPF0146', 4, NULL),
(6192, NULL, 'IPR007212', NULL, 'Cysteine-rich small domain', 'Zf-like', 3, NULL),
(6193, NULL, 'IPR009077', NULL, 'Proteasome activator PA28', 'Proteasome_activ_PA28', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(6194, NULL, 'IPR008096', NULL, 'Cytotoxic T-lymphocyte antigen 4', 'CTLA4', 4, NULL),
(6195, NULL, 'IPR003516', NULL, 'Fanconi anaemia group A protein', 'FANCA', 4, NULL),
(6196, NULL, 'IPR006470', NULL, 'Formate dehydrogenase iron-sulphur subunit, Proteobacteria', 'Formate_DH_bsu_Proteobacteria', 4, NULL),
(6197, NULL, 'IPR007213', NULL, 'Methyltransferase Ppm1/Ppm2/Tcmp', 'Ppm1/Ppm2/Tcmp', 4, NULL),
(6198, NULL, 'IPR006490', NULL, 'Phage major tail protein, phi13 family', 'Maj_tail_phi13', 4, NULL),
(6199, NULL, 'IPR003930', NULL, 'Potassium channel, calcium-activated, BK, beta subunit', 'K_chnl_Ca-activ_BK_bsu', 4, NULL),
(6200, NULL, 'IPR007210', NULL, 'ABC-type glycine betaine transport system, substrate-binding domain', 'ABC_Gly_betaine_transp_sub-bd', 3, NULL),
(6201, NULL, 'IPR006487', NULL, 'Bacteriophage lambda, Tail tip protein L', 'Phage_lambda_L', 4, NULL),
(6202, NULL, 'IPR003907', NULL, 'Galanin receptor 2', 'GAL2_rcpt', 4, NULL),
(6203, NULL, 'IPR003779', NULL, 'Carboxymuconolactone decarboxylase-like', 'CMD-like', 3, NULL),
(6204, NULL, 'IPR002895', NULL, 'Paramecium surface antigen', 'Paramecium_SA', 7, NULL),
(6205, NULL, 'IPR009056', NULL, 'Cytochrome c-like domain', 'Cyt_c-like_dom', 3, NULL),
(6206, NULL, 'IPR002406', NULL, 'Natriuretic peptide, C type', 'C_natriurtcpep', 4, NULL),
(6207, NULL, 'IPR005349', NULL, 'TMEM14 family', 'TMEM14', 4, NULL),
(6208, NULL, 'IPR003715', NULL, 'Polysaccharide export protein', 'Poly_export', 4, NULL),
(6209, NULL, 'IPR002335', NULL, 'Myoglobin', 'Myoglobin', 4, NULL),
(6210, NULL, 'IPR003278', NULL, 'Potassium channel, inwardly rectifying, Kir6.1', 'K_chnl_inward-rec_Kir6.1', 4, NULL),
(6211, NULL, 'IPR006495', NULL, 'Citrate lyase acyl carrier protein CitD', 'CitD', 4, NULL),
(6212, NULL, 'IPR007219', NULL, 'Transcription factor domain, fungi', 'Transcription_factor_dom_fun', 3, NULL),
(6213, NULL, 'IPR002332', NULL, 'Nitrogen regulatory protein P-II, urydylation site', 'N-reg_PII_urydylation_site', 6, NULL),
(6214, NULL, 'IPR002386', NULL, 'Amicyanin/Pseudoazurin', 'Amicyanin/Pseudoazurin', 4, NULL),
(6215, NULL, 'IPR006474', NULL, 'Helicase Cas3, CRISPR-associated, core', 'Helicase_Cas3_CRISPR-ass_core', 3, NULL),
(6216, NULL, 'IPR006488', NULL, 'Uncharacterised domain PYST-C1, N-terminal', 'Uncharacterised_PYST-C1_N', 3, NULL),
(6217, NULL, 'IPR003524', NULL, 'Phospho-N-acetylmuramoyl-pentapeptide transferase', 'PNAcMuramoyl-5peptid_Trfase', 4, NULL),
(6218, NULL, 'IPR034641', NULL, 'Polysaccharide lyase family 11', 'RGL11', 4, NULL),
(6219, NULL, 'IPR008092', NULL, 'Ribosomal protein S29, mitochondrial', 'Ribosomal_S29_mit', 4, NULL),
(6220, NULL, 'IPR002359', NULL, 'Ribosomal protein L6, conserved site-2', 'Ribosomal_L6_CS2', 2, NULL),
(6221, NULL, 'IPR008108', NULL, 'Phosphatase IpgD/SopB', 'IpgD/SopB', 4, NULL),
(6222, NULL, 'IPR034261', NULL, 'CNOT4, RNA recognition motif', 'CNOT4_RRM', 3, NULL),
(6223, NULL, 'IPR003522', NULL, 'Type III secretion system outer membrane pore YscC/HrcC', 'T3SS_OM_pore_YscC', 4, NULL),
(6224, NULL, 'IPR005344', NULL, 'TMEM33/Pom33 family', 'TMEM33/Pom33', 4, NULL),
(6225, NULL, 'IPR003509', NULL, 'Uncharacterised protein family UPF0102', 'UPF0102', 4, NULL),
(6226, NULL, 'IPR002900', NULL, 'Domain of unknown function DUF38/FTH, Caenorhabditis species', 'DUF38/FTH_CAE_spp', 3, NULL),
(6227, NULL, 'IPR003920', NULL, 'Cellulose synthase, subunit B', 'Cell_synth_B', 4, NULL),
(6228, NULL, 'IPR008276', NULL, 'Concentrative nucleoside transporter', 'C_nuclsd_transpt', 4, NULL),
(6229, NULL, 'IPR023635', NULL, 'Peptide deformylase', 'Peptide_deformylase', 4, NULL),
(6230, NULL, 'IPR008077', NULL, 'GPCR, family 2, brain-specific angiogenesis inhibitor', 'GPCR_2_brain_angio_inhib', 4, NULL),
(6231, NULL, 'IPR003510', NULL, 'Fumarate reductase, subunit C', 'Fumarate_red_C', 4, NULL),
(6232, NULL, 'IPR001452', NULL, 'SH3 domain', 'SH3_domain', 3, NULL),
(6233, NULL, 'IPR009071', NULL, 'High mobility group box domain', 'HMG_box_dom', 3, NULL),
(6234, NULL, 'IPR034262', NULL, 'TRMT2A, RNA recognition motif', 'TRMT2A_RRM', 3, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(6235, NULL, 'IPR003503', NULL, 'Glial cell line-derived neurotrophic factor receptor, alpha 1', 'GDNF_rcpt_A1', 4, NULL),
(6236, NULL, 'IPR004849', NULL, '6-phosphogluconate dehydrogenase, YqeC-type', '6DGDH_YqeC', 4, NULL),
(6237, NULL, 'IPR010071', NULL, 'Amino acid adenylation domain', 'AA_adenyl_domain', 3, NULL),
(6238, NULL, 'IPR009050', NULL, 'Globin-like superfamily', 'Globin-like_sf', 5, NULL),
(6239, NULL, 'IPR002300', NULL, 'Aminoacyl-tRNA synthetase, class Ia', 'aa-tRNA-synth_Ia', 3, NULL),
(6240, NULL, 'IPR001519', NULL, 'Ferritin', 'Ferritin', 4, NULL),
(6241, NULL, 'IPR001503', NULL, 'Glycosyl transferase family 10', 'Glyco_trans_10', 4, NULL),
(6242, NULL, 'IPR003496', NULL, 'ABA/WDS induced protein', 'ABA_WDS', 4, NULL),
(6243, NULL, 'IPR008105', NULL, 'C chemokine', 'Chemokine_XCL1/XCL2', 4, NULL),
(6244, NULL, 'IPR003870', NULL, 'Domain of unknown function DUF222', 'DUF222', 3, NULL),
(6245, NULL, 'IPR005366', NULL, 'ER membrane protein complex subunit 8/9', 'EMC8/9', 4, NULL),
(6246, NULL, 'IPR003755', NULL, 'HPr(Ser)  kinase/phosphorylase', 'HPr(Ser)_kin/Pase', 4, NULL),
(6247, NULL, 'IPR008253', NULL, 'Marvel domain', 'Marvel', 3, NULL),
(6248, NULL, 'IPR006478', NULL, 'Formate dehydrogenase, alpha subunit', 'Formate_DH_asu', 4, NULL),
(6249, NULL, 'IPR002363', NULL, 'Ribosomal protein L10, eubacterial, conserved site', 'Ribosomal_L10_eubac_CS', 2, NULL),
(6250, NULL, 'IPR008133', NULL, '5-hydroxytryptamine 3 receptor, A subunit', '5HT3_rcpt_A', 4, NULL),
(6251, NULL, 'IPR003470', NULL, 'Adenovirus E3 region protein CR2', 'Adeno_E3_CR2', 3, NULL),
(6252, NULL, 'IPR003515', NULL, 'Major spike protein G', 'Spike_G', 4, NULL),
(6253, NULL, 'IPR003495', NULL, 'CobW/HypB/UreG, nucleotide-binding domain', 'CobW/HypB/UreG_dom', 3, NULL),
(6254, NULL, 'IPR001515', NULL, 'Ribosomal protein L32e', 'Ribosomal_L32e', 4, NULL),
(6255, NULL, 'IPR002394', NULL, 'Nicotinic acetylcholine receptor', 'Nicotinic_acetylcholine_rcpt', 4, NULL),
(6256, NULL, 'IPR005345', NULL, 'PHF5-like', 'PHF5', 4, NULL),
(6257, NULL, 'IPR002314', NULL, 'Aminoacyl-tRNA synthetase, class II (G/ P/ S/T)', 'aa-tRNA-synt_IIb', 3, NULL),
(6258, NULL, 'IPR003934', NULL, 'Epithelial membrane protein EMP-3', 'EMP_3', 4, NULL),
(6259, NULL, 'IPR008135', NULL, 'Competence-induced protein CinA', 'Competence-induced_CinA', 4, NULL),
(6260, NULL, 'IPR001499', NULL, 'GPCR fungal pheromone mating factor, STE3', 'GPCR_STE3', 4, NULL),
(6261, NULL, 'IPR005352', NULL, 'Erg28', 'Erg28', 4, NULL),
(6262, NULL, 'IPR003776', NULL, 'YcaO-like domain', 'YcaO-like_dom', 3, NULL),
(6263, NULL, 'IPR003827', NULL, 'tRNA wybutosine-synthesizing protein', 'tRNA_yW-synthesising', 3, NULL),
(6264, NULL, 'IPR003508', NULL, 'CIDE-N domain', 'CIDE-N_dom', 3, NULL),
(6265, NULL, 'IPR002307', NULL, 'Tyrosine-tRNA ligase', 'Tyr-tRNA-ligase', 4, NULL),
(6266, NULL, 'IPR002336', NULL, 'Erythrocruorin', 'Erythrocruorin', 4, NULL),
(6267, NULL, 'IPR001483', NULL, 'Urotensin II', 'Urotensin_II', 4, NULL),
(6268, NULL, 'IPR003775', NULL, 'Flagellar assembly factor FliW', 'Flagellar_assembly_factor_FliW', 4, NULL),
(6269, NULL, 'IPR003487', NULL, 'Phosphoprotein, pneumoviral', 'Pprotein_pneumovir', 4, NULL),
(6270, NULL, 'IPR002344', NULL, 'Lupus La protein', 'Lupus_La', 4, NULL),
(6271, NULL, 'IPR008114', NULL, 'Septin 3', 'Septin3', 4, NULL),
(6272, NULL, 'IPR001493', NULL, 'Peptidase A22A, presenilin 2', 'Pept_A22A_PS2', 4, NULL),
(6273, NULL, 'IPR001465', NULL, 'Malate synthase', 'Malate_synthase', 4, NULL),
(6274, NULL, 'IPR007218', NULL, 'DNA polymerase delta, subunit 4', 'DNA_pol_delta_4', 4, NULL),
(6275, NULL, 'IPR003828', NULL, 'Epoxyqueuosine reductase QueH', 'QueH', 4, NULL),
(6276, NULL, 'IPR003501', NULL, 'Phosphotransferase system, EIIB component, type 2/3', 'PTS_EIIB_2/3', 3, NULL),
(6277, NULL, 'IPR002904', NULL, 'Lysine-tRNA ligase', 'Lys-tRNA-ligase', 4, NULL),
(6278, NULL, 'IPR001453', NULL, 'MoaB/Mog domain', 'MoaB/Mog_dom', 3, NULL),
(6279, NULL, 'IPR009083', NULL, 'Transcription factor IIA, alpha-helical domain', 'TFIIA_a-hlx', 5, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(6280, NULL, 'IPR002265', NULL, 'Gap junction alpha-6 protein (Cx45)', 'Connexin45', 4, NULL),
(6281, NULL, 'IPR003555', NULL, 'Claudin-11', 'Claudin11', 4, NULL),
(6282, NULL, 'IPR002365', NULL, 'Terpene synthase, conserved site', 'Terpene_synthase_CS', 2, NULL),
(6283, NULL, 'IPR009069', NULL, 'Cysteine alpha-hairpin motif superfamily', 'Cys_alpha_HP_mot_SF', 5, NULL),
(6284, NULL, 'IPR003491', NULL, 'Replication initiation factor', 'Rep_trans', 4, NULL),
(6285, NULL, 'IPR003877', NULL, 'SPRY domain', 'SPRY_dom', 3, NULL),
(6286, NULL, 'IPR007214', NULL, 'YbaK/aminoacyl-tRNA synthetase-associated domain', 'YbaK/aa-tRNA-synth-assoc-dom', 3, NULL),
(6287, NULL, 'IPR006475', NULL, 'Citrate lyase, beta subunit, bacteria', 'Citrate_lyase_beta_bac', 4, NULL),
(6288, NULL, 'IPR003527', NULL, 'Mitogen-activated protein (MAP) kinase, conserved site', 'MAP_kinase_CS', 2, NULL),
(6289, NULL, 'IPR002905', NULL, 'tRNA methyltransferase, Trm1', 'Trm1', 4, NULL),
(6290, NULL, 'IPR003811', NULL, 'Glycerol-3-phosphate acyltransferase, PlsY', 'G3P_acylTferase_PlsY', 4, NULL),
(6291, NULL, 'IPR002401', NULL, 'Cytochrome P450, E-class, group I', 'Cyt_P450_E_grp-I', 4, NULL),
(6292, NULL, 'IPR003474', NULL, 'Gluconate transporter', 'Glcn_transporter', 4, NULL),
(6293, NULL, 'IPR003724', NULL, 'ATP:cob(I)alamin adenosyltransferase CobA/CobO/BtuR', 'CblAdoTrfase_CobA', 4, NULL),
(6294, NULL, 'IPR003832', NULL, 'Protein of unknown function DUF212', 'DUF212', 4, NULL),
(6295, NULL, 'IPR001477', NULL, 'Viral small hydrophobic protein', 'SH', 4, NULL),
(6296, NULL, 'IPR009073', NULL, 'Co-chaperone HscB, C-terminal oligomerisation domain', 'HscB_oligo_C', 3, NULL),
(6297, NULL, 'IPR009087', NULL, 'Rab geranylgeranyltransferase, alpha subunit, insert-domain', 'RabGGT_asu_insert-domain', 3, NULL),
(6298, NULL, 'IPR008112', NULL, 'Relaxin receptor', 'Relaxin_rcpt', 4, NULL),
(6299, NULL, 'IPR003788', NULL, 'Protein arginine methyltransferase NDUFAF7', 'NDUFAF7', 4, NULL),
(6300, NULL, 'IPR007215', NULL, 'Sulphur relay, TusB/DsrH', 'Sulphur_relay_TusB/DsrH', 4, NULL),
(6301, NULL, 'IPR003909', NULL, 'G protein-coupled receptor 37 orphan', 'GPR37_orph', 4, NULL),
(6302, NULL, 'IPR005362', NULL, 'Uncharacterised protein family UPF0164', 'UPF0164', 4, NULL),
(6303, NULL, 'IPR005338', NULL, 'Anhydro-N-acetylmuramic acid kinase', 'Anhydro_N_Ac-Mur_kinase', 4, NULL),
(6304, NULL, 'IPR008081', NULL, 'Cytoplasmic FMR1-interacting', 'Cytoplasmic_FMR1-int', 4, NULL),
(6305, NULL, 'IPR001501', NULL, 'Nickel-dependent hydrogenase, large subunit', 'Ni-dep_hyd_lsu', 4, NULL),
(6306, NULL, 'IPR007000', NULL, 'Phospholipase B-like', 'PLipase_B-like', 4, NULL),
(6307, NULL, 'IPR007003', NULL, 'Protein of unknown function DUF655', 'DUF655', 4, NULL),
(6308, NULL, 'IPR002901', NULL, 'Mannosyl-glycoprotein endo-beta-N-acetylglucosamidase-like domain', 'MGlyc_endo_b_GlcNAc-like_dom', 3, NULL),
(6309, NULL, 'IPR008101', NULL, 'Gamma-aminobutyric-acid A receptor theta subunit', 'GABAAt_rcpt', 4, NULL),
(6310, NULL, 'IPR007211', NULL, 'Protein of unknown function DUF378', 'DUF378', 4, NULL),
(6311, NULL, 'IPR010060', NULL, 'Non-ribosomal peptide synthase', 'NRPS_synth', 3, NULL),
(6312, NULL, 'IPR003494', NULL, 'SHS2 domain inserted in FtsA', 'SHS2_FtsA', 3, NULL),
(6313, NULL, 'IPR002305', NULL, 'Aminoacyl-tRNA synthetase, class Ic', 'aa-tRNA-synth_Ic', 4, NULL),
(6314, NULL, 'IPR005359', NULL, 'Protein with unknown function UPF0154', 'UPF0154', 4, NULL),
(6315, NULL, 'IPR005354', NULL, 'Uncharacterised protein family UPF0147', 'UPF0147', 4, NULL),
(6316, NULL, 'IPR005187', NULL, 'Influenza C non-structural protein NS1', 'Flu_C_NS1', 3, NULL),
(6317, NULL, 'IPR007387', NULL, 'TRAP transporter, small membrane protein DctQ', 'TRAP_DctQ', 4, NULL),
(6318, NULL, 'IPR008100', NULL, 'Gamma-aminobutyric-acid A receptor pi subunit', 'GABAAp_rcpt', 4, NULL),
(6319, NULL, 'IPR005373', NULL, 'Phagosome assembly factor 1', 'PHAF1', 4, NULL),
(6320, NULL, 'IPR009080', NULL, 'Aminoacyl-tRNA synthetase, class Ia, anticodon-binding', 'tRNAsynth_Ia_anticodon-bd', 5, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(6321, NULL, 'IPR005193', NULL, 'Glycoside hydrolase, family 62, arabinosidase', 'GH62_arabinosidase', 4, NULL),
(6322, NULL, 'IPR009067', NULL, 'TAFII-230 TBP-binding', 'TAF_II_230-bd', 3, NULL),
(6323, NULL, 'IPR005358', NULL, 'Putative zinc- or iron-chelating domain containing protein', 'Puta_zinc/iron-chelating_dom', 4, NULL),
(6324, NULL, 'IPR002372', NULL, 'Pyrrolo-quinoline quinone repeat', 'PQQ_repeat', 7, NULL),
(6325, NULL, 'IPR034278', NULL, 'RBM3/CIRBP, RNA recognition motif', 'RBM3/CIRBP_RRM', 3, NULL),
(6326, NULL, 'IPR002384', NULL, 'Osteocalcin/matrix Gla protein', 'Osteocalcin/MGP', 4, NULL),
(6327, NULL, 'IPR003478', NULL, 'Outer capsid sigma 1s', 'Capsid_sigma_1s', 4, NULL),
(6328, NULL, 'IPR001508', NULL, 'Ionotropic glutamate receptor, metazoa', 'Iono_rcpt_met', 4, NULL),
(6329, NULL, 'IPR005379', NULL, 'Factor of DNA methylation 1-5/IDN2 , domain XH', 'FDM1-5/IDN2_XH', 3, NULL),
(6330, NULL, 'IPR006467', NULL, 'MiaB-like tRNA modifying enzyme', 'MiaB-like_C', 4, NULL),
(6331, NULL, 'IPR006482', NULL, 'CRISPR-associated protein Cas7, subtype I-B/I-C', 'Cas7_Csh2/Csh2', 4, NULL),
(6332, NULL, 'IPR002333', NULL, 'Hepatic lipase', 'Lipase_hep', 4, NULL),
(6333, NULL, 'IPR003505', NULL, 'Glial cell line-derived neurotrophic factor receptor, alpha 3', 'GDNF_rcpt_A3', 4, NULL),
(6334, NULL, 'IPR003467', NULL, 'Fimbrial, major/minor subunit', 'Fimbrial_K88', 4, NULL),
(6335, NULL, 'IPR006476', NULL, 'Conserved hypothetical protein CHP01589, plant', 'CHP01589_pln', 4, NULL),
(6336, NULL, 'IPR034264', NULL, 'RBM48, RNA recognition motif', 'RBM48_RRM', 3, NULL),
(6337, NULL, 'IPR001481', NULL, 'Prostanoid EP3 receptor, type 2', 'EP3_rcpt_2', 4, NULL),
(6338, NULL, 'IPR003517', NULL, 'Cysteine-rich outer membrane protein 3, Chlamydia', 'Cys-rich_OMP3_Chlamydia', 4, NULL),
(6339, NULL, 'IPR008116', NULL, 'Sequence-specific single-strand DNA-binding protein', 'SSDP_DNA-bd', 4, NULL),
(6340, NULL, 'IPR008118', NULL, 'Dense granule Gra2 protein', 'Gra2_protein', 4, NULL),
(6341, NULL, 'IPR003493', NULL, 'Herpesvirus glycoprotein H', 'Herpes_gH', 4, NULL),
(6342, NULL, 'IPR001461', NULL, 'Aspartic peptidase A1 family', 'Aspartic_peptidase_A1', 4, NULL),
(6343, NULL, 'IPR002354', NULL, 'Interleukin-4', 'IL-4', 4, NULL),
(6344, NULL, 'IPR001415', NULL, 'Parathyroid hormone/parathyroid hormone-related protein', 'PTH/PTH-rel', 4, NULL),
(6345, NULL, 'IPR009092', NULL, 'Telokin-like protein, Tlp20, baculovirus', 'Telokin-like_Tlp20_baculovir', 4, NULL),
(6346, NULL, 'IPR009095', NULL, 'TRADD, N-terminal', 'TRADD_N', 3, NULL),
(6347, NULL, 'IPR003908', NULL, 'Galanin receptor 3', 'Galnin_3_rcpt', 4, NULL),
(6348, NULL, 'IPR002908', NULL, 'Frataxin/CyaY', 'Frataxin/CyaY', 4, NULL),
(6349, NULL, 'IPR002326', NULL, 'Cytochrome c1', 'Cyt_c1', 4, NULL),
(6350, NULL, 'IPR003905', NULL, 'Growth hormone secretagogue receptor/motilin receptor', 'GHS-R/MTLR', 4, NULL),
(6351, NULL, 'IPR003485', NULL, 'Herpesvirus US2, varicellovirus-type', 'Herpes_US2_varicellovirus', 4, NULL),
(6352, NULL, 'IPR009093', NULL, 'Bacteriophage P22 tailspike, N-terminal', 'P22_tailspike_N', 3, NULL),
(6353, NULL, 'IPR002352', NULL, 'Eosinophil major basic protein', 'Eosinophil_major_basic', 4, NULL),
(6354, NULL, 'IPR003502', NULL, 'Interleukin-1 propeptide', 'IL-1_propep', 3, NULL),
(6355, NULL, 'IPR005369', NULL, 'Uncharacterised protein family UPF0179', 'UPF0179', 4, NULL),
(6356, NULL, 'IPR003498', NULL, 'Probable DNA packing protein, C-terminal', 'DNA_pack_C', 3, NULL),
(6357, NULL, 'IPR001512', NULL, 'Somatostatin receptor 4', 'Somatstn_rcpt_4', 4, NULL),
(6358, NULL, 'IPR002410', NULL, 'Peptidase S33', 'Peptidase_S33', 4, NULL),
(6359, NULL, 'IPR006479', NULL, 'Holin', 'Holin', 4, NULL),
(6360, NULL, 'IPR003904', NULL, 'Apelin receptor', 'Apelin_rcpt', 4, NULL),
(6361, NULL, 'IPR022789', NULL, 'Antitoxin ParD', 'ParD', 4, NULL),
(6362, NULL, 'IPR003882', NULL, 'Pistil-specific extensin-like protein', 'Pistil_extensin', 4, NULL),
(6363, NULL, 'IPR001486', NULL, 'Truncated hemoglobin', 'Hemoglobin_trunc', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(6364, NULL, 'IPR010068', NULL, 'Taurine ABC transporter, substrate-binding protein TauA', 'Peri-bd_TauA', 4, NULL),
(6365, NULL, 'IPR003490', NULL, 'Rhabdovirus non-virion protein', 'Rhabd_NV', 4, NULL),
(6366, NULL, 'IPR003699', NULL, 'S-adenosylmethionine:tRNA ribosyltransferase-isomerase,  QueA', 'QueA', 4, NULL),
(6367, NULL, 'IPR008071', NULL, 'Cytochrome P450, E-class, group I, CYP2J-like', 'Cyt_P450_E_grp-I_CYP2J-like', 4, NULL),
(6368, NULL, 'IPR001464', NULL, 'Annexin', 'Annexin', 4, NULL),
(6369, NULL, 'IPR006468', NULL, 'Nitrate reductase, alpha subunit', 'NarG', 4, NULL),
(6370, NULL, 'IPR001475', NULL, 'ATP-binding cassette subfamily C member 9', 'ABCC9', 4, NULL),
(6371, NULL, 'IPR003806', NULL, 'ATP-grasp fold, PylC-type', 'ATP-grasp_PylC-type', 3, NULL),
(6372, NULL, 'IPR003762', NULL, 'L-arabinose isomerase', 'Lara_isomerase', 4, NULL),
(6373, NULL, 'IPR003705', NULL, 'Cobalt transport protein CbiN', 'CbiN', 4, NULL),
(6374, NULL, 'IPR008104', NULL, 'Macrophage infectivity potentiator', 'INFPOTNTIATR', 4, NULL),
(6375, NULL, 'IPR002353', NULL, 'Type-2 ice-structuring protein', 'AntifreezeII', 4, NULL),
(6376, NULL, 'IPR001413', NULL, 'Dopamine D1 receptor', 'Dopamine_D1_rcpt', 4, NULL),
(6377, NULL, 'IPR005351', NULL, 'PAT complex subunit Asterix', 'ASTER', 4, NULL),
(6378, NULL, 'IPR003477', NULL, 'mRNA interferase PemK-like', 'PemK-like', 4, NULL),
(6379, NULL, 'IPR003769', NULL, 'Adaptor protein ClpS, core', 'ClpS_core', 3, NULL),
(6380, NULL, 'IPR008078', NULL, 'GPCR family 2, Ig-hepta-like receptor', 'GPCR_2_Ig-hepta-like_rcpt', 4, NULL),
(6381, NULL, 'IPR002910', NULL, 'Floricaula/leafy protein', 'FLO_LFY', 4, NULL),
(6382, NULL, 'IPR003521', NULL, 'ICln', 'ICln', 4, NULL),
(6383, NULL, 'IPR002312', NULL, 'Aspartyl/Asparaginyl-tRNA synthetase, class IIb', 'Asp/Asn-tRNA-synth_IIb', 4, NULL),
(6384, NULL, 'IPR009088', NULL, 'Transcription factor IIA, beta-barrel', 'TFIIA_b-brl', 5, NULL),
(6385, NULL, 'IPR003513', NULL, 'Scaffold protein B', 'Phage_B', 4, NULL),
(6386, NULL, 'IPR003512', NULL, 'Bacteriophage M13, G5P, DNA-binding', 'Phage_M13_G5P_DNA-bd', 4, NULL),
(6387, NULL, 'IPR008122', NULL, 'Transcription factor AP-2 beta', 'TF_AP2_beta', 4, NULL),
(6388, NULL, 'IPR008090', NULL, 'Ferric iron reductase', 'Fe_iron_reduct', 4, NULL),
(6389, NULL, 'IPR003918', NULL, 'NADH:ubiquinone oxidoreductase', 'NADH_UbQ_OxRdtase', 4, NULL),
(6390, NULL, 'IPR006492', NULL, 'Plasmodium yoelii subtelomeric PYST-D', 'PYST_D', 4, NULL),
(6391, NULL, 'IPR004847', NULL, 'Na(+)/H(+) antiporter subunit E1', 'Antiport_suE1', 4, NULL),
(6392, NULL, 'IPR007386', NULL, 'Protein of unknown function DUF447', 'DUF447', 4, NULL),
(6393, NULL, 'IPR009049', NULL, 'Argininosuccinate lyase', 'Argininosuccinate_lyase', 4, NULL),
(6394, NULL, 'IPR001451', NULL, 'Hexapeptide repeat', 'Hexapep', 7, NULL),
(6395, NULL, 'IPR002334', NULL, 'Vespid venom allergen phospholipase A1', 'Allerg_PlipaseA1', 4, NULL),
(6396, NULL, 'IPR010067', NULL, 'Aliphatic sulfonates-binding protein', 'ABC_SsuA_sub-bd', 4, NULL),
(6397, NULL, 'IPR034436', NULL, '3-Methyl-2-indolic acid methyltransferase, NocN/NosN-like', 'NocN/NosN-like', 4, NULL),
(6398, NULL, 'IPR002325', NULL, 'Cytochrome f', 'Cyt_f', 4, NULL),
(6399, NULL, 'IPR002343', NULL, 'Paraneoplastic encephalomyelitis antigen', 'Hud_Sxl_RNA', 4, NULL),
(6400, NULL, 'IPR009063', NULL, 'Immunoglobulin/albumin-binding domain superfamily', 'Ig/albumin-bd_sf', 5, NULL),
(6401, NULL, 'IPR003066', NULL, 'Salmonella invasion protein InvJ', 'Invas_InvJ', 4, NULL),
(6402, NULL, 'IPR005346', NULL, 'RnfH protein', 'RnfH', 4, NULL),
(6403, NULL, 'IPR001479', NULL, 'Quinoprotein dehydrogenase, conserved site', 'Quinoprotein_DH_CS', 2, NULL),
(6404, NULL, 'IPR003925', NULL, 'Claudin-6', 'Claudin6', 4, NULL),
(6405, NULL, 'IPR003377', NULL, 'Cornichon', 'Cornichon', 4, NULL),
(6406, NULL, 'IPR002351', NULL, 'Nitrophorin domain', 'Nitrophorin_domain', 3, NULL),
(6407, NULL, 'IPR023931', NULL, 'Multidrug resistance protein MdtC', 'Multidrug-R_MdtC', 4, NULL),
(6408, NULL, 'IPR003468', NULL, 'Cytochrome c oxidase, monohaem subunit/FixO', 'Cyt_c_oxidase_monohaem-su/FixO', 4, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(6409, NULL, 'IPR003481', NULL, 'Flagellar hook-associated protein 2, N-terminal', 'FliD_N', 3, NULL),
(6410, NULL, 'IPR005365', NULL, 'Nitrogen permease regulator 3', 'Npr3', 4, NULL),
(6411, NULL, 'IPR003891', NULL, 'Initiation factor eIF-4 gamma, MA3', 'Initiation_fac_eIF4g_MI', 3, NULL),
(6412, NULL, 'IPR004848', NULL, 'African swine fever virus, family 110', 'ASFV_fam_110', 4, NULL),
(6413, NULL, 'IPR003488', NULL, 'DNA recombination-mediator protein A', 'DprA', 4, NULL),
(6414, NULL, 'IPR034654', NULL, 'MltA, 3D domain', 'MltA_3D', 3, NULL),
(6415, NULL, 'IPR008123', NULL, 'Transcription factor AP-2 gamma', 'TF_AP2_gamma', 4, NULL),
(6416, NULL, 'IPR006486', NULL, 'Plasmodium yoelii subtelomeric PYST-A', 'PYST_A', 4, NULL),
(6417, NULL, 'IPR001520', NULL, '5-Hydroxytryptamine 4 receptor', '5HT4_rcpt', 4, NULL),
(6418, NULL, 'IPR008127', NULL, 'Glycine receptor alpha', 'Glycine_rcpt_A', 4, NULL),
(6419, NULL, 'IPR002322', NULL, 'Cytochrome c, class III', 'Cyt_c_III', 4, NULL),
(6420, NULL, 'IPR002324', NULL, 'Cytochrome c, class ID', 'Cyt_c_ID', 4, NULL),
(6421, NULL, 'IPR002346', NULL, 'Molybdopterin dehydrogenase, FAD-binding', 'Mopterin_DH_FAD-bd', 3, NULL),
(6422, NULL, 'IPR003475', NULL, 'Insect protein of unknown function', 'Insect_Unk', 4, NULL),
(6423, NULL, 'IPR007385', NULL, 'Prokaryotic chromosome segregation/condensation protein MukE', 'Scp_MukE', 4, NULL),
(6424, NULL, 'IPR002896', NULL, 'Herpesvirus glycoprotein D/GG/GX domain', 'Herpes_glycop_dom', 3, NULL),
(6425, NULL, 'IPR003913', NULL, 'Tuberin', 'Tuberin', 4, NULL),
(6426, NULL, 'IPR008110', NULL, 'Porphyromonas gingivalis fimbrillin protein', 'Fimbrillin', 4, NULL),
(6427, NULL, 'IPR006465', NULL, 'Oligosaccharide amylase', 'Oligosac_amylase', 4, NULL),
(6428, NULL, 'IPR001492', NULL, 'Flagellin', 'Flagellin', 4, NULL),
(6429, NULL, 'IPR008136', NULL, 'CinA, C-terminal', 'CinA_C', 3, NULL),
(6430, NULL, 'IPR001458', NULL, 'GPCR, family 3, metabotropic glutamate receptor 2', 'GPCR_3_mGluR2', 4, NULL),
(6431, NULL, 'IPR002368', NULL, 'Outer membrane protein, OmpA', 'OmpA', 4, NULL),
(6432, NULL, 'IPR008072', NULL, 'Cytochrome P450, E-class, CYP3A', 'Cyt_P450_E_CYP3A', 4, NULL),
(6433, NULL, 'IPR003482', NULL, 'Transcription factor WhiB', 'Whib', 4, NULL),
(6434, NULL, 'IPR007220', NULL, 'Origin recognition complex, subunit 2', 'ORC2', 4, NULL),
(6435, NULL, 'IPR005380', NULL, 'XS domain', 'XS_domain', 3, NULL),
(6436, NULL, 'IPR008119', NULL, 'Dense granule Gra6 protein', 'Gra6_protein', 4, NULL),
(6437, NULL, 'IPR009068', NULL, 'S15/NS1, RNA-binding', 'S15_NS1_RNA-bd', 5, NULL),
(6438, NULL, 'IPR003483', NULL, 'Borrelia outer surface protein E/F', 'OspEF', 4, NULL),
(6439, NULL, 'IPR005378', NULL, 'Vacuolar protein sorting-associated protein 35', 'Vps35', 4, NULL),
(6440, NULL, 'IPR003526', NULL, '2-C-methyl-D-erythritol 2,4-cyclodiphosphate synthase', 'MECDP_synthase', 3, NULL),
(6441, NULL, 'IPR008093', NULL, 'T cell antigen CD28', 'CD28', 4, NULL),
(6442, NULL, 'IPR002302', NULL, 'Leucine-tRNA ligase', 'Leu-tRNA-ligase', 4, NULL),
(6443, NULL, 'IPR008099', NULL, 'Gamma-aminobutyric-acid A receptor epsilon subunit', 'GABAAe_rcpt', 4, NULL),
(6444, NULL, 'IPR003523', NULL, 'Transcription factor COE', 'Transcription_factor_COE', 4, NULL),
(6445, NULL, 'IPR002369', NULL, 'Integrin beta subunit, VWA domain', 'Integrin_bsu_VWA', 3, NULL),
(6446, NULL, 'IPR003079', NULL, 'Nuclear receptor ROR', 'ROR_rcpt', 4, NULL),
(6447, NULL, 'IPR009062', NULL, 'Smac/DIABLO-like superfamily', 'Smac/DIABLO-like_sf', 5, NULL),
(6448, NULL, 'IPR003469', NULL, 'Glycoside hydrolase, family 68', 'Glyco_hydro_68', 4, NULL),
(6449, NULL, 'IPR008086', NULL, 'Proteinase inhibitor I15, leech antistasin', 'Prot_inh_I15_antistasin_leech', 4, NULL),
(6450, NULL, 'IPR006472', NULL, 'Citrate lyase, alpha subunit', 'Citrate_lyase_asu', 4, NULL),
(6451, NULL, 'IPR003479', NULL, 'Pre-hexon-linking protein IIIa', 'Hex_IIIa', 4, NULL),
(6452, NULL, 'IPR007001', NULL, 'Bacterial shufflon protein, N-terminal', 'Shufflon_N', 3, NULL),
(6453, NULL, 'IPR008075', NULL, 'Lipocalin-interacting membrane receptor', 'LIMR', 4, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(6454, NULL, 'IPR006480', NULL, 'Bacteriophage holin family', 'Phage_holin_4_1', 4, NULL),
(6455, NULL, 'IPR009057', NULL, 'Homeobox-like domain superfamily', 'Homeobox-like_sf', 5, NULL),
(6456, NULL, 'IPR005339', NULL, 'GINS complex, subunit Psf1', 'GINS_Psf1', 4, NULL),
(6457, NULL, 'IPR023927', NULL, '2,3-diaminopropionate biosynthesis protein SbnA', 'SbnA', 4, NULL),
(6458, NULL, 'IPR003917', NULL, 'NADH:ubiquinone oxidoreductase, chain 2', 'NADH_UbQ_OxRdtase_chain2', 4, NULL),
(6459, NULL, 'IPR007223', NULL, 'Peroxin 13, N-terminal', 'Peroxin-13_N', 3, NULL),
(6460, NULL, 'IPR010062', NULL, '5,10-methenyltetrahydromethanopterin hydrogenase', 'HMD_', 4, NULL),
(6461, NULL, 'IPR002337', NULL, 'Hemoglobin, beta-type', 'Hemoglobin_b', 4, NULL),
(6462, NULL, 'IPR008074', NULL, 'Two pore domain potassium channel, TRAAK', '2pore_dom_K_chnl_TRAAK', 4, NULL),
(6463, NULL, 'IPR002914', NULL, 'Pollen allergen Poa p IX/Phl p VI', 'Poa_pIX/Phl_pVI', 3, NULL),
(6464, NULL, 'IPR006997', NULL, 'Baculovirus Y142 protein', 'Baculo_Y142', 4, NULL),
(6465, NULL, 'IPR010065', NULL, 'Amino acid ABC transporter, permease protein, 3-TM domain', 'AA_ABC_transptr_permease_3TM', 3, NULL),
(6466, NULL, 'IPR006493', NULL, 'Holin, BlyA', 'Holin_BlyA', 4, NULL),
(6467, NULL, 'IPR008274', NULL, 'Aldehyde oxidase/xanthine dehydrogenase, first molybdopterin binding domain', 'AldOxase/xan_DH_MoCoBD1', 3, NULL),
(6468, NULL, 'IPR002366', NULL, 'Alpha-defensin  propeptide', 'Alpha-defensin_propep', 3, NULL),
(6469, NULL, 'IPR010069', NULL, 'Toxin CdiA-like, Filamentous hemagglutinin motif repeats', 'CdiA_FHA1_rpt', 7, NULL),
(6470, NULL, 'IPR009089', NULL, 'XRCC4, N-terminal domain superfamily', 'XRCC4_N_sf', 5, NULL),
(6471, NULL, 'IPR003484', NULL, 'N-acyltransferase NodA', 'NodA', 4, NULL),
(6472, NULL, 'IPR002364', NULL, 'Quinone oxidoreductase/zeta-crystallin, conserved site', 'Quin_OxRdtase/zeta-crystal_CS', 2, NULL),
(6473, NULL, 'IPR010063', NULL, 'H(2)-forming methylenetetrahydromethanopterin dehydrogenase-related protein', 'HMDII/III', 4, NULL),
(6474, NULL, 'IPR001498', NULL, 'Impact, N-terminal', 'Impact_N', 3, NULL),
(6475, NULL, 'IPR006998', NULL, 'DltD', 'DltD', 4, NULL),
(6476, NULL, 'IPR003748', NULL, 'Protein of unknown function DUF169', 'DUF169', 4, NULL),
(6477, NULL, 'IPR009075', NULL, 'Acyl-CoA dehydrogenase/oxidase C-terminal', 'AcylCo_DH/oxidase_C', 3, NULL),
(6478, NULL, 'IPR002402', NULL, 'Cytochrome P450, E-class, group II', 'Cyt_P450_E_grp-II', 4, NULL),
(6479, NULL, 'IPR003507', NULL, 'Peptidase family S66', 'S66_fam', 4, NULL),
(6480, NULL, 'IPR003489', NULL, 'Ribosome hibernation promoting factor/RaiA', 'RHF/RaiA', 4, NULL),
(6481, NULL, 'IPR005363', NULL, 'Uncharacterised protein family UPF0167', 'UPF0167', 4, NULL),
(6482, NULL, 'IPR003500', NULL, 'Sugar-phosphate isomerase, RpiB/LacA/LacB family', 'RpiB_LacA_LacB', 4, NULL),
(6483, NULL, 'IPR002891', NULL, 'Adenylyl-sulfate kinase', 'APS_kinase', 4, NULL),
(6484, NULL, 'IPR034126', NULL, 'RNA-binding protein Musashi homologue, RNA recognition motif 2', 'MSI_RRM2', 3, NULL),
(6485, NULL, 'IPR003472', NULL, 'Virion membrane protein, poxvirus L1-related', 'Virion_mem_poxvirus_L1', 4, NULL),
(6486, NULL, 'IPR003465', NULL, 'Proteinase inhibitor I20', 'Prot_inh_I20', 4, NULL),
(6487, NULL, 'IPR008098', NULL, 'Gamma-aminobutyric-acid A receptor delta subunit', 'GABAAd_rcpt', 4, NULL),
(6488, NULL, 'IPR009066', NULL, 'Alpha-2-macroglobulin receptor-associated protein, domain 1', 'MG_RAP_rcpt_1', 3, NULL),
(6489, NULL, 'IPR002350', NULL, 'Kazal domain', 'Kazal_dom', 3, NULL),
(6490, NULL, 'IPR006484', NULL, 'Plasmodium yoelii subtelomeric PYST-B', 'PYST_B', 4, NULL),
(6491, NULL, 'IPR002301', NULL, 'Isoleucine-tRNA ligase', 'Ile-tRNA-ligase', 4, NULL),
(6492, NULL, 'IPR003772', NULL, 'Large ribosomal RNA subunit accumulation protein YceD', 'YceD', 4, NULL),
(6493, NULL, 'IPR002392', NULL, 'Annexin A5', 'ANX5', 4, NULL),
(6494, NULL, 'IPR008134', NULL, '5-hydroxytryptamine 3 receptor, B subunit', '5HT3_rcpt_B', 4, NULL),
(6495, NULL, 'IPR002822', NULL, 'Nickel insertion protein', 'Ni_insertion', 4, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(6496, NULL, 'IPR003476', NULL, 'Glycoside hydrolase, family 42', 'Glyco_hydro_42', 4, NULL),
(6497, NULL, 'IPR003928', NULL, 'Claudin-18', 'Claudin18', 4, NULL),
(6498, NULL, 'IPR008106', NULL, 'Neisseria toxin MafB', 'Adhesin_MafB', 4, NULL),
(6499, NULL, 'IPR003506', NULL, 'Chlamydia cysteine-rich outer membrane protein 6', 'Chlam_OMP6', 4, NULL),
(6500, NULL, 'IPR003504', NULL, 'Glial cell line-derived neurotrophic factor receptor alpha 2', 'GDNF_rcpt_a2', 4, NULL),
(6501, NULL, 'IPR007245', NULL, 'GPI transamidase component PIG-T', 'PIG-T', 4, NULL),
(6502, NULL, 'IPR007052', NULL, 'CS domain', 'CS_dom', 3, NULL),
(6503, NULL, 'IPR000436', NULL, 'Sushi/SCR/CCP domain', 'Sushi_SCR_CCP_dom', 3, NULL),
(6504, NULL, 'IPR006423', NULL, '5-nucleotidase lipoprotein e(P4)', 'Lipo_e_P4', 4, NULL),
(6505, NULL, 'IPR007259', NULL, 'Gamma-tubulin complex component protein', 'GCP', 4, NULL),
(6506, NULL, 'IPR002470', NULL, 'Peptidase S9A, prolyl oligopeptidase', 'Peptidase_S9A', 4, NULL),
(6507, NULL, 'IPR034439', NULL, 'Diuretic hormone class 2-like', 'DH2-like', 4, NULL),
(6508, NULL, 'IPR000453', NULL, 'Chorismate synthase', 'Chorismate_synth', 4, NULL),
(6509, NULL, 'IPR002393', NULL, 'Annexin A6', 'ANX6', 4, NULL),
(6510, NULL, 'IPR002957', NULL, 'Keratin, type I', 'Keratin_I', 4, NULL),
(6511, NULL, 'IPR005382', NULL, 'CC chemokine receptor 10', 'Chemokine_CCR10', 4, NULL),
(6512, NULL, 'IPR006432', NULL, 'Portal protein, putative, A118-type', 'Portal_putative_A118-type', 4, NULL),
(6513, NULL, 'IPR005331', NULL, 'Sulfotransferase', 'Sulfotransferase', 4, NULL),
(6514, NULL, 'IPR034530', NULL, 'Hopanoid C2-methyltransferase, HpnP-like', 'HpnP-like', 4, NULL),
(6515, NULL, 'IPR005205', NULL, 'Herpesvirus ICP4-like protein, C-terminal', 'Herpes_ICP4_C', 3, NULL),
(6516, NULL, 'IPR002948', NULL, 'Thiazide-sensitive Na-K-Cl co-transporter', 'SLC12A3', 4, NULL),
(6517, NULL, 'IPR000418', NULL, 'Ets domain', 'Ets_dom', 3, NULL),
(6518, NULL, 'IPR006426', NULL, 'Asparagine synthase, glutamine-hydrolyzing', 'Asn_synth_AEB', 4, NULL),
(6519, NULL, 'IPR000481', NULL, 'GPCR fungal pheromone B alpha receptor', 'GPCR_Pheromne_B_alpha_rcpt', 4, NULL),
(6520, NULL, 'IPR002396', NULL, 'Selectin superfamily', 'Selectin_superfamily', 4, NULL),
(6521, NULL, 'IPR006446', NULL, 'Rhamnosyltransferase', 'RhaTrfase', 4, NULL),
(6522, NULL, 'IPR000704', NULL, 'Casein kinase II, regulatory subunit', 'Casein_kinase_II_reg-sub', 4, NULL),
(6523, NULL, 'IPR005867', NULL, 'Photosystem II protein D1', 'PSII_D1', 4, NULL),
(6524, NULL, 'IPR007260', NULL, 'Putative N-acetylmannosamine-6-phosphate epimerase', 'NanE', 4, NULL),
(6525, NULL, 'IPR000422', NULL, '3,4-dihydroxy-2-butanone 4-phosphate synthase, RibB', 'DHBP_synthase_RibB', 4, NULL),
(6526, NULL, 'IPR007037', NULL, 'Siderophore-interacting protein, C-terminal domain', 'SIP_C', 3, NULL),
(6527, NULL, 'IPR000662', NULL, 'Capsid protein VP1,Polyomavirus', 'Capsid_VP1_Polyomavir', 4, NULL),
(6528, NULL, 'IPR006431', NULL, 'Bacteriophage tail tape measure, C-terminal', 'Phage_tape_meas_C', 3, NULL),
(6529, NULL, 'IPR000426', NULL, 'Proteasome alpha-subunit, N-terminal domain', 'Proteasome_asu_N', 3, NULL),
(6530, NULL, 'IPR005898', NULL, 'Cyclic peptide transporter', 'Cyc_pep_transpt', 4, NULL),
(6531, NULL, 'IPR000717', NULL, 'Proteasome component (PCI) domain', 'PCI_dom', 3, NULL),
(6532, NULL, 'IPR007233', NULL, 'Trafficking protein particle complex subunit', 'TRAPPC', 4, NULL),
(6533, NULL, 'IPR006513', NULL, 'Conserved hypothetical protein CHP01626, YtfJ', 'CHP01626_YtfJ', 4, NULL),
(6534, NULL, 'IPR002450', NULL, 'von Ebner''s gland protein/ Bos/Can allergen', 'von_Ebner_gland', 4, NULL),
(6535, NULL, 'IPR000396', NULL, 'Cyclic-AMP phosphodiesterase, class-II', 'Pdiesterase2', 4, NULL),
(6536, NULL, 'IPR005210', NULL, 'Herpesvirus large tegument protein deneddylase', 'Herpes_LT_deneddylase', 3, NULL),
(6537, NULL, 'IPR034443', NULL, 'Meiotically up-regulated protein PB1A10.08', 'PB1A10.08', 4, NULL),
(6538, NULL, 'IPR007048', NULL, 'IraD/Gp25-like', 'IraD/Gp25-like', 3, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(6539, NULL, 'IPR035892', NULL, 'C2 domain superfamily', 'C2_domain_sf', 5, NULL),
(6540, NULL, 'IPR005884', NULL, 'Fumarate reductase, flavoprotein subunit', 'Fum_red_fp', 4, NULL),
(6541, NULL, 'IPR000768', NULL, 'NAD:arginine ADP-ribosyltransferase, ART', 'ART', 4, NULL),
(6542, NULL, 'IPR007249', NULL, 'Dopey, N-terminal', 'Dopey_N', 3, NULL),
(6543, NULL, 'IPR001379', NULL, 'Egg lysin (Sperm-lysin)', 'Egg_lysin', 4, NULL),
(6544, NULL, 'IPR002442', NULL, 'Fructose transporter, type 5 (GLUT5)', 'Fru_transpt_5', 4, NULL),
(6545, NULL, 'IPR007019', NULL, 'Surfeit locus 6', 'SURF6', 4, NULL),
(6546, NULL, 'IPR006436', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase, type II', 'Glyceraldehyde-3-P_DH_2_arc', 4, NULL),
(6547, NULL, 'IPR002395', NULL, 'HMW kininogen', 'Kininogen', 4, NULL),
(6548, NULL, 'IPR002444', NULL, 'Solute carrier family 12 member 2', 'NKCC1', 4, NULL),
(6549, NULL, 'IPR007067', NULL, 'Tail sheath protein', 'Tail_sheath', 4, NULL),
(6550, NULL, 'IPR007224', NULL, 'Transcription initiation factor Rrn11', 'TIF_Rrn11', 4, NULL),
(6551, NULL, 'IPR005211', NULL, 'Herpesvirus envelope glycoprotein N domain', 'Herpes_glycoprotein_N_domain', 3, NULL),
(6552, NULL, 'IPR001431', NULL, 'Peptidase M16, zinc-binding site', 'Pept_M16_Zn_BS', 1, NULL),
(6553, NULL, 'IPR000475', NULL, 'Retroviral Vif (Viral infectivity) protein', 'Vif', 4, NULL),
(6554, NULL, 'IPR007049', NULL, 'Carbohydrate-selective porin OprB', 'Carb-sel_porin_OprB', 4, NULL),
(6555, NULL, 'IPR002268', NULL, 'Gap junction beta-2 protein (Cx26)', 'Connexin26', 4, NULL),
(6556, NULL, 'IPR006511', NULL, 'SHORT INTERNODES, C-terminal', 'SHI_C', 3, NULL),
(6557, NULL, 'IPR002953', NULL, 'Filoviridae VP35 protein', 'Filo_VP35', 4, NULL),
(6558, NULL, 'IPR005902', NULL, 'Putative DNA-binding protein, HU-related', 'HU_DNA-bd_put', 4, NULL),
(6559, NULL, 'IPR005383', NULL, 'Atypical chemokine receptor 4', 'ACKR4', 4, NULL),
(6560, NULL, 'IPR007007', NULL, 'Ninjurin', 'Ninjurin', 4, NULL),
(6561, NULL, 'IPR000665', NULL, 'Haemagglutinin/haemagglutinin-neuraminidase, paramyxovirus', 'Hemagglutn/HN', 4, NULL),
(6562, NULL, 'IPR006433', NULL, 'Prohead protease', 'Prohead_protease', 4, NULL),
(6563, NULL, 'IPR007042', NULL, 'SERRATE/Ars2 , C-terminal', 'SERRATE/Ars2_C', 3, NULL),
(6564, NULL, 'IPR000816', NULL, 'Peptidase C15, pyroglutamyl peptidase I', 'Peptidase_C15', 4, NULL),
(6565, NULL, 'IPR007266', NULL, 'Endoplasmic reticulum oxidoreductin 1', 'Ero1', 4, NULL),
(6566, NULL, 'IPR007054', NULL, 'Lysis protein S', 'Lysis_S', 4, NULL),
(6567, NULL, 'IPR000511', NULL, 'Holocytochrome c/c1 synthase', 'Holocyt_c/c1_synthase', 4, NULL),
(6568, NULL, 'IPR000672', NULL, 'Tetrahydrofolate dehydrogenase/cyclohydrolase', 'THF_DH/CycHdrlase', 4, NULL),
(6569, NULL, 'IPR000741', NULL, 'Fructose-bisphosphate aldolase, class-I', 'FBA_I', 4, NULL),
(6570, NULL, 'IPR002435', NULL, 'Sodium:neurotransmitter symporter, noradrenaline', 'Na/ntran_symport_noradrenaline', 4, NULL),
(6571, NULL, 'IPR006451', NULL, 'Glycogen debranching enzyme, archaeal type', 'Glycogen_debranch_arc', 4, NULL),
(6572, NULL, 'IPR005855', NULL, 'Glucosamine-fructose-6-phosphate aminotransferase, isomerising', 'GlmS_trans', 4, NULL),
(6573, NULL, 'IPR002955', NULL, 'Microtubule-associated protein Tau', 'Tau', 4, NULL),
(6574, NULL, 'IPR007064', NULL, 'Nmd3, N-terminal', 'Nmd3_N', 3, NULL),
(6575, NULL, 'IPR000756', NULL, 'Diacylglycerol kinase, accessory domain', 'Diacylglycerol_kin_accessory', 3, NULL),
(6576, NULL, 'IPR000467', NULL, 'G-patch domain', 'G_patch_dom', 3, NULL),
(6577, NULL, 'IPR000795', NULL, 'Translational (tr)-type GTP-binding domain', 'T_Tr_GTP-bd_dom', 3, NULL),
(6578, NULL, 'IPR007253', NULL, 'Putative cell wall binding repeat 2', 'Cell_wall-bd_2', 7, NULL),
(6579, NULL, 'IPR000454', NULL, 'ATP synthase, F0 complex, subunit C', 'ATP_synth_F0_csu', 4, NULL),
(6580, NULL, 'IPR002448', NULL, 'Lipocalin, OBP-like', 'OBP-like', 4, NULL),
(6581, NULL, 'IPR000424', NULL, 'Primosome PriB/single-strand DNA-binding', 'Primosome_PriB/ssb', 4, NULL),
(6582, NULL, 'IPR005903', NULL, '2-desacetyl-2-hydroxyethyl bacteriochlorophyllide a dehydrogenase', 'BchC', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(6583, NULL, 'IPR005899', NULL, 'Sodium ion-translocating decarboxylase', 'Na_pump_deCOase', 4, NULL),
(6584, NULL, 'IPR000388', NULL, 'Sulphonylurea receptor', 'Sulphorea_rcpt', 4, NULL),
(6585, NULL, 'IPR000634', NULL, 'Serine/threonine dehydratase, pyridoxal-phosphate-binding site', 'Ser/Thr_deHydtase_PyrdxlP-BS', 1, NULL),
(6586, NULL, 'IPR007066', NULL, 'RNA polymerase Rpb1, domain 3', 'RNA_pol_Rpb1_3', 3, NULL),
(6587, NULL, 'IPR002453', NULL, 'Beta tubulin', 'Beta_tubulin', 4, NULL),
(6588, NULL, 'IPR002939', NULL, 'Chaperone DnaJ, C-terminal', 'DnaJ_C', 3, NULL),
(6589, NULL, 'IPR007036', NULL, 'Succinylglutamate desuccinylase/aspartoacylase', 'Aste_AspA', 4, NULL),
(6590, NULL, 'IPR002381', NULL, 'Ribonuclease PH, bacterial-type', 'RNase_PH_bac-type', 4, NULL),
(6591, NULL, 'IPR006420', NULL, 'NAD pyrophosphatase/5-nucleotidase NadN', 'NadN', 4, NULL),
(6592, NULL, 'IPR000485', NULL, 'AsnC-type HTH domain', 'AsnC-type_HTH_dom', 3, NULL),
(6593, NULL, 'IPR006510', NULL, 'Zinc finger, lateral root primordium type 1', 'Znf_LRP1', 3, NULL),
(6594, NULL, 'IPR005852', NULL, 'Phosphoglucomutase, alpha-D-glucose specific', 'PGM_a-D-Glc-sp', 4, NULL),
(6595, NULL, 'IPR005886', NULL, 'UDP-glucose 4-epimerase', 'UDP_G4E', 4, NULL),
(6596, NULL, 'IPR002921', NULL, 'Fungal lipase-like domain', 'Fungal_lipase-like', 3, NULL),
(6597, NULL, 'IPR006454', NULL, 'S-layer protein', 'S_layer_MJ', 4, NULL),
(6598, NULL, 'IPR002271', NULL, 'Gap junction beta-5 protein (Cx31.1)', 'Connexin311', 4, NULL),
(6599, NULL, 'IPR000792', NULL, 'Transcription regulator LuxR, C-terminal', 'Tscrpt_reg_LuxR_C', 3, NULL),
(6600, NULL, 'IPR005885', NULL, 'tRNA guanine(10)-N2-dimethyltransferase', 'TrmG10', 4, NULL),
(6601, NULL, 'IPR001418', NULL, 'Opioid receptor', 'Opioid_rcpt', 4, NULL),
(6602, NULL, 'IPR007011', NULL, 'Late embryogenesis abundant protein, SMP subgroup domain', 'LEA_SMP_dom', 3, NULL),
(6603, NULL, 'IPR006450', NULL, 'Phage protein of unkonwn function', 'Phage_HK022_Gp6', 4, NULL),
(6604, NULL, 'IPR000699', NULL, 'RIH domain', 'RIH_dom', 3, NULL),
(6605, NULL, 'IPR003064', NULL, 'Norrie disease protein', 'Norrie_dis', 4, NULL),
(6606, NULL, 'IPR007040', NULL, 'Ribosome modulation factor', 'Ribosome_modulation_factor', 4, NULL),
(6607, NULL, 'IPR006457', NULL, 'S-layer family duplication domain', 'S_layer-rel_Mac', 3, NULL),
(6608, NULL, 'IPR000745', NULL, 'Hepatitis C virus, Non-structural protein NS4a', 'HCV_NS4a', 3, NULL),
(6609, NULL, 'IPR002426', NULL, 'Alcohol dehydrogenase, Ceratitis-type', 'ADH_Ceratitis-type', 4, NULL),
(6610, NULL, 'IPR005874', NULL, 'Eukaryotic translation initiation factor SUI1', 'SUI1_euk', 4, NULL),
(6611, NULL, 'IPR001393', NULL, 'Calsequestrin', 'Calsequestrin', 4, NULL),
(6612, NULL, 'IPR002938', NULL, 'FAD-binding domain', 'FAD-bd', 3, NULL),
(6613, NULL, 'IPR003529', NULL, 'Long hematopoietin receptor, Gp130 family 2, conserved site', 'Hematopoietin_rcpt_Gp130_CS', 2, NULL),
(6614, NULL, 'IPR003532', NULL, 'Short hematopoietin receptor, family 2, conserved site', 'Short_hematopoietin_rcpt_2_CS', 2, NULL),
(6615, NULL, 'IPR007060', NULL, 'Septum formation initiator FtsL/DivIC', 'FtsL/DivIC', 4, NULL),
(6616, NULL, 'IPR005793', NULL, 'Formyl transferase, C-terminal', 'Formyl_trans_C', 3, NULL),
(6617, NULL, 'IPR000462', NULL, 'CDP-alcohol phosphatidyltransferase', 'CDP-OH_P_trans', 4, NULL),
(6618, NULL, 'IPR000797', NULL, 'Bunyavirus non-structural protein NS-s', 'Bunya_NSs', 4, NULL),
(6619, NULL, 'IPR001382', NULL, 'Glycoside hydrolase family 47', 'Glyco_hydro_47', 4, NULL),
(6620, NULL, 'IPR005375', NULL, 'Ubiquitin-fold modifier 1', 'UFM1', 4, NULL),
(6621, NULL, 'IPR000400', NULL, 'Glycoside hydrolase, family 46', 'Glyco_hydro_46', 4, NULL),
(6622, NULL, 'IPR007009', NULL, 'Shq1 protein domain', 'Shq1_dom', 3, NULL),
(6623, NULL, 'IPR006516', NULL, 'Replication-associated protein G2P', 'G2P', 4, NULL),
(6624, NULL, 'IPR000460', NULL, 'Neuroligin', 'Nlgn', 4, NULL),
(6625, NULL, 'IPR000477', NULL, 'Reverse transcriptase domain', 'RT_dom', 3, NULL),
(6626, NULL, 'IPR001442', NULL, 'Collagen IV, non-collagenous', 'Collagen_IV_NC', 3, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(6627, NULL, 'IPR007236', NULL, 'SlyX', 'SlyX', 4, NULL),
(6628, NULL, 'IPR005865', NULL, 'Tetrahydromethanopterin S-methyltransferase, subunit C', 'THM_MeTrfase_su_C', 4, NULL),
(6629, NULL, 'IPR000455', NULL, '5-Hydroxytryptamine 2A receptor', '5HT2A_rcpt', 4, NULL),
(6630, NULL, 'IPR007055', NULL, 'BON domain', 'BON_dom', 3, NULL),
(6631, NULL, 'IPR007050', NULL, 'Bacterioopsin activator-type, HTH domain', 'HTH_bacterioopsin', 3, NULL),
(6632, NULL, 'IPR002946', NULL, 'Intracellular chloride channel', 'CLIC', 4, NULL),
(6633, NULL, 'IPR007065', NULL, 'HPP', 'HPP', 4, NULL),
(6634, NULL, 'IPR002379', NULL, 'V-ATPase proteolipid subunit C-like domain', 'ATPase_proteolipid_c-like_dom', 3, NULL),
(6635, NULL, 'IPR023116', NULL, 'Phosphonoacetate hydrolase, insert domain superfamily', 'Phosphonoacetate_hydro_insert', 5, NULL),
(6636, NULL, 'IPR002447', NULL, 'Beta-lactoglobulin', 'Blactoglobulin', 4, NULL),
(6637, NULL, 'IPR000505', NULL, '5-Hydroxytryptamine 1D receptor', '5HT1D_rcpt', 4, NULL),
(6638, NULL, 'IPR007240', NULL, 'Autophagy-related protein 17', 'Atg17', 4, NULL),
(6639, NULL, 'IPR006462', NULL, 'Protein MS5', 'MS5', 4, NULL),
(6640, NULL, 'IPR007226', NULL, 'SRS domain', 'SRS_dom', 3, NULL),
(6641, NULL, 'IPR000431', NULL, '5-Hydroxytryptamine 5B receptor', '5HT5B_rcpt', 4, NULL),
(6642, NULL, 'IPR002454', NULL, 'Gamma tubulin', 'Gamma_tubulin', 4, NULL),
(6643, NULL, 'IPR007038', NULL, 'Hydrogenase/Urease accessory protein HupE/UreJ protein', 'HupE_UreJ', 4, NULL),
(6644, NULL, 'IPR000696', NULL, 'Peptidase A6, nodavirus coat protein', 'Peptidase_A6', 4, NULL),
(6645, NULL, 'IPR000647', NULL, 'CTF transcription factor/nuclear factor 1', 'CTF/NFI', 4, NULL),
(6646, NULL, 'IPR006440', NULL, 'Death on curing protein', 'Doc', 4, NULL),
(6647, NULL, 'IPR002935', NULL, 'Class I-like SAM-dependent O-methyltransferase', 'SAM_O-MeTrfase', 4, NULL),
(6648, NULL, 'IPR000404', NULL, 'Flavivirus non-structural protein NS4A', 'Flavi_NS4A', 3, NULL),
(6649, NULL, 'IPR007237', NULL, 'CD20-like family', 'CD20-like', 4, NULL),
(6650, NULL, 'IPR007010', NULL, 'Poly(A) polymerase, RNA-binding domain', 'PolA_pol_RNA-bd_dom', 3, NULL),
(6651, NULL, 'IPR007053', NULL, 'LRAT domain', 'LRAT_dom', 3, NULL),
(6652, NULL, 'IPR003057', NULL, 'Invertebrate colouration protein', 'Invtbrt_color', 4, NULL),
(6653, NULL, 'IPR005882', NULL, 'Bifunctional UDP-N-acetylglucosamine pyrophosphorylase/glucosamine-1-phosphate N-acetyltransferase', 'Bifunctional_GlmU', 4, NULL),
(6654, NULL, 'IPR006461', NULL, 'PLAC8 motif-containing protein', 'PLAC_motif_containing', 4, NULL),
(6655, NULL, 'IPR002941', NULL, 'DNA methylase N-4/N-6', 'DNA_methylase_N4/N6', 3, NULL),
(6656, NULL, 'IPR000429', NULL, 'Proteinase inhibitor I14, hirudin', 'Prot_inh_hirudin', 4, NULL),
(6657, NULL, 'IPR000435', NULL, 'Tektin', 'Tektin', 4, NULL),
(6658, NULL, 'IPR001381', NULL, '3-dehydroquinate dehydratase type I', 'DHquinase_I', 4, NULL),
(6659, NULL, 'IPR007021', NULL, 'Domain of unknown function DUF659', 'DUF659', 3, NULL),
(6660, NULL, 'IPR005887', NULL, 'Alpha-1,2-mannosidase, putative', 'Alpha_mannosidase', 4, NULL),
(6661, NULL, 'IPR007045', NULL, '5-keto 4-deoxyuronate isomerase', 'KduI', 4, NULL),
(6662, NULL, 'IPR007061', NULL, 'Protein of unknown function DUF664', 'DUF664', 4, NULL),
(6663, NULL, 'IPR000380', NULL, 'DNA topoisomerase, type IA', 'Topo_IA', 4, NULL),
(6664, NULL, 'IPR007246', NULL, 'GPI transamidase component Gaa1', 'Gaa1', 4, NULL),
(6665, NULL, 'IPR005868', NULL, 'Photosystem II D2 protein', 'PSII_PsbD/D2', 4, NULL),
(6666, NULL, 'IPR000804', NULL, 'Clathrin adaptor complex, small chain', 'Clathrin_sm-chain_CS', 2, NULL),
(6667, NULL, 'IPR007252', NULL, 'Nuclear pore protein 84/107', 'Nup84/Nup107', 4, NULL),
(6668, NULL, 'IPR006430', NULL, 'Phage portal protein PBSX family', 'Phage_portal_PBSX', 4, NULL),
(6669, NULL, 'IPR000439', NULL, 'Ribosomal protein L15e', 'Ribosomal_L15e', 4, NULL),
(6670, NULL, 'IPR002929', NULL, 'Potato leaf roll virus readthrough protein', 'PLrV_ORF5', 4, NULL),
(6671, NULL, 'IPR007062', NULL, 'Protein phosphatase inhibitor 2 (IPP-2)', 'PPI-2', 4, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(6672, NULL, 'IPR002466', NULL, 'Adenosine deaminase/editase', 'A_deamin', 3, NULL),
(6673, NULL, 'IPR007229', NULL, 'Nicotinate phosphoribosyltransferase family', 'Nic_PRibTrfase-Fam', 4, NULL),
(6674, NULL, 'IPR002433', NULL, 'Ornithine decarboxylase', 'Orn_de-COase', 4, NULL),
(6675, NULL, 'IPR000651', NULL, 'Ras-like guanine nucleotide exchange factor, N-terminal', 'Ras-like_Gua-exchang_fac_N', 3, NULL),
(6676, NULL, 'IPR006415', NULL, 'P-type ATPase, subfamily IIIB', 'P-type_ATPase_IIIB', 4, NULL),
(6677, NULL, 'IPR000389', NULL, 'Small hydrophilic plant seed protein', 'Small_hydrophilic_seed_prot', 4, NULL),
(6678, NULL, 'IPR001384', NULL, 'Peptidase M35, deuterolysin', 'Peptidase_M35', 4, NULL),
(6679, NULL, 'IPR000382', NULL, 'Peptidase S39B, luteovirus', 'Peptidase_S39B_luteovirus', 3, NULL),
(6680, NULL, 'IPR000385', NULL, 'MoaA/NifB/PqqE, iron-sulphur binding, conserved site', 'MoaA_NifB_PqqE_Fe-S-bd_CS', 2, NULL),
(6681, NULL, 'IPR002446', NULL, 'Lipocalin, bacterial', 'Lipocalin_bac', 4, NULL),
(6682, NULL, 'IPR000774', NULL, 'Peptidyl-prolyl cis-trans isomerase, FKBP-type, N-terminal', 'PPIase_FKBP_N', 3, NULL),
(6683, NULL, 'IPR005878', NULL, 'Ribosomal protein L1, bacterial-type', 'Ribosom_L1_bac-type', 4, NULL),
(6684, NULL, 'IPR007034', NULL, 'Ribosome biogenesis protein BMS1/TSR1, C-terminal', 'BMS1_TSR1_C', 3, NULL),
(6685, NULL, 'IPR005386', NULL, 'EDG-8 sphingosine 1-phosphate receptor', 'EDG8_S1P_rcpt', 4, NULL),
(6686, NULL, 'IPR001419', NULL, 'HMW glutenin', 'Glutenin', 4, NULL),
(6687, NULL, 'IPR005860', NULL, 'L-threonine-O-3-phosphate decarboxylase', 'CobD', 4, NULL),
(6688, NULL, 'IPR002443', NULL, 'Solute carrier family 12 member 1/2', 'SLC12A1/SLC12A2', 4, NULL),
(6689, NULL, 'IPR006448', NULL, 'Putative phage terminase, small subunit, P27 family', 'Phage_term_ssu_P27', 4, NULL),
(6690, NULL, 'IPR006437', NULL, 'Bacteriophage terminase, large subunit', 'Phage_terminase_lsu', 4, NULL),
(6691, NULL, 'IPR005900', NULL, '6-phosphogluconolactonase, DevB-type', '6-phosphogluconolactonase_DevB', 3, NULL),
(6692, NULL, 'IPR000405', NULL, 'Galanin receptor family', 'Galanin_rcpt', 4, NULL),
(6693, NULL, 'IPR005856', NULL, 'Cysteine synthase', 'Cys_synth', 4, NULL),
(6694, NULL, 'IPR005888', NULL, 'dTDP-glucose 4,6-dehydratase', 'dTDP_Gluc_deHydtase', 4, NULL),
(6695, NULL, 'IPR000727', NULL, 'Target SNARE coiled-coil homology domain', 'T_SNARE_dom', 3, NULL),
(6696, NULL, 'IPR006418', NULL, 'Nicotinamide-nucleotide adenylyltransferase, archaeal type', 'NMN_Atrans_arc', 4, NULL),
(6697, NULL, 'IPR000708', NULL, 'Prostanoid EP1 receptor', 'Prostglndn_EP1_rcpt', 4, NULL),
(6698, NULL, 'IPR007029', NULL, 'YHS domain', 'YHS_dom', 3, NULL),
(6699, NULL, 'IPR006498', NULL, 'Tail tube protein', 'Tail_tube', 4, NULL),
(6700, NULL, 'IPR007257', NULL, 'DNA replication complex GINS protein Psf2', 'GINS_Psf2', 4, NULL),
(6701, NULL, 'IPR000773', NULL, 'Granulocyte-macrophage colony-stimulating factor', 'GM_colony-stim-fac', 4, NULL),
(6702, NULL, 'IPR005901', NULL, 'GLPGLI family protein', 'GLPGLI', 4, NULL),
(6703, NULL, 'IPR005883', NULL, 'Type IV pilus inner membrane component PilM', 'PilM', 4, NULL),
(6704, NULL, 'IPR005896', NULL, 'Glucan exporter ATP-binding protein, NdvA', 'NdvA', 4, NULL),
(6705, NULL, 'IPR002416', NULL, 'Type II secretion system protein GspH', 'T2SS_protein-GspH', 4, NULL),
(6706, NULL, 'IPR005892', NULL, 'Glycine betaine transport ATP-binding subunit', 'Gly-betaine_transp_ATP-bd', 4, NULL),
(6707, NULL, 'IPR000486', NULL, 'Extradiol ring-cleavage dioxygenase, class I /II', 'Xdiol_ring_cleave_dOase_1/2', 2, NULL),
(6708, NULL, 'IPR002472', NULL, 'Palmitoyl protein thioesterase', 'Palm_thioest', 4, NULL),
(6709, NULL, 'IPR007234', NULL, 'Vps53, N-terminal', 'Vps53_N', 3, NULL),
(6710, NULL, 'IPR005854', NULL, 'Amidophosphoribosyltransferase', 'PurF', 4, NULL),
(6711, NULL, 'IPR007020', NULL, 'Protein of unknown function DUF658', 'DUF658', 4, NULL),
(6712, NULL, 'IPR007231', NULL, 'Nucleoporin interacting component Nup93/Nic96', 'Nucleoporin_int_Nup93/Nic96', 4, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(6713, NULL, 'IPR000503', NULL, 'Histamine H2 receptor', 'Histamine_H2_rcpt', 4, NULL),
(6714, NULL, 'IPR002471', NULL, 'Peptidase S9, serine active site', 'Pept_S9_AS', 0, NULL),
(6715, NULL, 'IPR000706', NULL, 'N-acetyl-gamma-glutamyl-phosphate reductase, type 1', 'AGPR_type-1', 4, NULL),
(6716, NULL, 'IPR002269', NULL, 'Gap junction beta-3 protein (Cx31)', 'Connexin31', 4, NULL),
(6717, NULL, 'IPR007035', NULL, 'Peptidase M55, D-aminopeptidase', 'Peptidase_M55', 4, NULL),
(6718, NULL, 'IPR023120', NULL, 'Winged helix-turn-helix transcription repressor, HrcA, inserted dimerising domain superfamily', 'WHTH_transcript_rep_HrcA_IDD', 5, NULL),
(6719, NULL, 'IPR005194', NULL, 'Glycoside hydrolase family 65, C-terminal', 'Glyco_hydro_65_C', 3, NULL),
(6720, NULL, 'IPR007255', NULL, 'Conserved oligomeric Golgi complex subunit 8', 'COG8', 4, NULL),
(6721, NULL, 'IPR007013', NULL, 'DNA polymerase processivity factor, herpesviridae', 'DNA_pol_proc_fac_herpes', 4, NULL),
(6722, NULL, 'IPR000393', NULL, 'Neuropeptide Y5 receptor', 'NPY5_rcpt', 4, NULL),
(6723, NULL, 'IPR000465', NULL, 'XPA', 'XPA', 4, NULL),
(6724, NULL, 'IPR003054', NULL, 'Keratin, type II', 'Keratin_II', 4, NULL),
(6725, NULL, 'IPR006512', NULL, 'YidE/YbjL duplication', 'YidE_YbjL', 3, NULL),
(6726, NULL, 'IPR007247', NULL, 'Ureidoglycolate lyase', 'Ureidogly_lyase', 4, NULL),
(6727, NULL, 'IPR034265', NULL, 'MCM3AP, RNA recognition motif', 'MCM3AP_RRM', 3, NULL),
(6728, NULL, 'IPR005794', NULL, 'Methionyl-tRNA formyltransferase', 'Fmt', 4, NULL),
(6729, NULL, 'IPR002411', NULL, 'Cereal allergen/alpha-amylase inhibitor, rice type', 'Allergen/amylase_inhib_rice', 4, NULL),
(6730, NULL, 'IPR005823', NULL, 'Ribosomal protein L13, bacterial-type', 'Ribosomal_L13_bac-type', 4, NULL),
(6731, NULL, 'IPR006501', NULL, 'Pectinesterase inhibitor domain', 'Pectinesterase_inhib_dom', 3, NULL),
(6732, NULL, 'IPR005859', NULL, 'Cysteine synthase CysK', 'CysK', 4, NULL),
(6733, NULL, 'IPR007069', NULL, 'Transposase, IS801/IS1294', 'Transposase_32', 4, NULL),
(6734, NULL, 'IPR034529', NULL, 'Cytidylyl-2-hydroxyethylphosphonate methyltransferase fom3-like', 'Fom3-like', 4, NULL),
(6735, NULL, 'IPR000514', NULL, 'Glycoside hydrolase, family 39', 'Glyco_hydro_39', 4, NULL),
(6736, NULL, 'IPR000015', NULL, 'Outer membrane usher protein', 'Fimb_usher', 4, NULL),
(6737, NULL, 'IPR000744', NULL, 'NSF attachment protein', 'NSF_attach', 4, NULL),
(6738, NULL, 'IPR034276', NULL, 'Gar2, RNA recognition motif 2', 'Gar2_RRM2', 3, NULL),
(6739, NULL, 'IPR007012', NULL, 'Poly(A) polymerase, central domain', 'PolA_pol_cen_dom', 3, NULL),
(6740, NULL, 'IPR005893', NULL, 'Spermidine/putrescine ABC transporter, ATP-binding subunit', 'Sp_pt_ABC_ATP-bd', 4, NULL),
(6741, NULL, 'IPR006503', NULL, 'Nitrogenase-associated protein', 'Nase-assoc', 4, NULL),
(6742, NULL, 'IPR000737', NULL, 'Proteinase inhibitor I7, squash', 'Prot_inh_squash', 4, NULL),
(6743, NULL, 'IPR007027', NULL, 'Poxvirus F11', 'Poxvirus_F11', 4, NULL),
(6744, NULL, 'IPR007004', NULL, 'Beet necrotic yellow vein virus, p31', 'BNYVV_p31', 4, NULL),
(6745, NULL, 'IPR034192', NULL, 'SREK1, RNA recognition motif 2', 'SREK1_RRM2', 3, NULL),
(6746, NULL, 'IPR006428', NULL, 'Portal protein, SPP1-type', 'Portal_SPP1-type', 4, NULL),
(6747, NULL, 'IPR006443', NULL, 'Formate dehydrogenase-N, alpha subunit', 'Formate-DH-alph_fdnG', 4, NULL),
(6748, NULL, 'IPR006417', NULL, 'Nicotinamide-nucleotide adenylyltransferase', 'NadR_NMN_Atrans', 3, NULL),
(6749, NULL, 'IPR001420', NULL, 'X opioid receptor', 'X_opioid_rcpt', 4, NULL),
(6750, NULL, 'IPR000755', NULL, 'D-alanyl-D-alanine dipeptidase', 'A_A_dipeptidase', 4, NULL),
(6751, NULL, 'IPR002931', NULL, 'Transglutaminase-like', 'Transglutaminase-like', 3, NULL),
(6752, NULL, 'IPR005877', NULL, 'YSIRK Gram-positive signal peptide', 'YSIRK_signal_dom', 3, NULL),
(6753, NULL, 'IPR006441', NULL, 'Bacteriophage P2, capsid', 'Phage_P2_GpN', 4, NULL),
(6754, NULL, 'IPR006459', NULL, 'Casparian strip membrane protein', 'CASP/CASPL', 4, NULL),
(6755, NULL, 'IPR005863', NULL, 'UDP-N-acetylmuramoyl-tripeptide--D-alanyl-D-alanine ligase', 'UDP-N-AcMur_synth', 4, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(6756, NULL, 'IPR000667', NULL, 'Peptidase S13, D-Ala-D-Ala carboxypeptidase C', 'Peptidase_S13', 4, NULL),
(6757, NULL, 'IPR002434', NULL, 'Sodium:neurotransmitter symporter, taurine', 'Na/ntran_symport_taurine', 4, NULL),
(6758, NULL, 'IPR001421', NULL, 'ATP synthase protein 8, metazoa', 'ATP8_metazoa', 4, NULL),
(6759, NULL, 'IPR000702', NULL, 'Ribosomal protein L6', 'Ribosomal_L6', 4, NULL),
(6760, NULL, 'IPR003044', NULL, 'P2X1 purinoceptor', 'P2X1_purnocptor', 4, NULL),
(6761, NULL, 'IPR005894', NULL, 'Daunorubicin resistance ABC transporter ATP-binding subunit DrrA', 'DrrA', 4, NULL),
(6762, NULL, 'IPR000516', NULL, 'Nickel-dependent hydrogenase b-type cytochrome subunit', 'Ni-dep_Hydgase_cyt-B', 4, NULL),
(6763, NULL, 'IPR000682', NULL, 'Protein-L-isoaspartate(D-aspartate) O-methyltransferase', 'PCMT', 4, NULL),
(6764, NULL, 'IPR007258', NULL, 'Vps52', 'Vps52', 4, NULL),
(6765, NULL, 'IPR002942', NULL, 'RNA-binding S4 domain', 'S4_RNA-bd', 3, NULL),
(6766, NULL, 'IPR006424', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase, type I', 'Glyceraldehyde-3-P_DH_1', 4, NULL),
(6767, NULL, 'IPR002441', NULL, 'Glucose transporter, type 4 (GLUT4)', 'Glc_transpt_4', 4, NULL),
(6768, NULL, 'IPR002954', NULL, 'Salmonella surface presentation of antigen M protein', 'Salm_SPAgM', 4, NULL),
(6769, NULL, 'IPR000473', NULL, 'Ribosomal protein L36', 'Ribosomal_L36', 4, NULL),
(6770, NULL, 'IPR000766', NULL, 'Galactose-1-phosphate uridyl transferase, class II', 'GalP_uridyl_Trfase_II', 4, NULL),
(6771, NULL, 'IPR007263', NULL, 'DCC1-like thiol-disulfide oxidoreductase family', 'DCC1-like', 4, NULL),
(6772, NULL, 'IPR002925', NULL, 'Dienelactone hydrolase', 'Dienelactn_hydro', 3, NULL),
(6773, NULL, 'IPR001388', NULL, 'Synaptobrevin-like', 'Synaptobrevin-like', 4, NULL),
(6774, NULL, 'IPR001251', NULL, 'CRAL-TRIO lipid binding domain', 'CRAL-TRIO_dom', 3, NULL),
(6775, NULL, 'IPR000721', NULL, 'Retroviral nucleocapsid  Gag protein p24, N-terminal', 'Gag_p24_N', 3, NULL),
(6776, NULL, 'IPR000812', NULL, 'Transcription factor TFIIB', 'TFIIB', 4, NULL),
(6777, NULL, 'IPR000642', NULL, 'Peptidase M41', 'Peptidase_M41', 3, NULL),
(6778, NULL, 'IPR006435', NULL, 'HAD-superfamily hydrolase, subfamily IF, YfhB', 'HAD-SF_hydro_IF_YfhB', 4, NULL),
(6779, NULL, 'IPR002449', NULL, 'Retinol binding protein/Purpurin', 'Retinol-bd/Purpurin', 4, NULL),
(6780, NULL, 'IPR002425', NULL, 'Alcohol dehydrogenase, Drosophila-type', 'ADH_Drosophila-type', 4, NULL),
(6781, NULL, 'IPR007243', NULL, 'Atg6/Beclin', 'Atg6/Beclin', 4, NULL),
(6782, NULL, 'IPR001433', NULL, 'Oxidoreductase FAD/NAD(P)-binding', 'OxRdtase_FAD/NAD-bd', 3, NULL),
(6783, NULL, 'IPR023613', NULL, 'Nitrophorin', 'Nitrophorin', 4, NULL),
(6784, NULL, 'IPR000466', NULL, 'Adenosine A3 receptor', 'Adeno_A3_rcpt', 4, NULL),
(6785, NULL, 'IPR000688', NULL, 'Hydrogenase maturation factor HypA/HybF', 'HypA/HybF', 4, NULL),
(6786, NULL, 'IPR007235', NULL, 'Glycosyl transferase, family 28, C-terminal', 'Glyco_trans_28_C', 3, NULL),
(6787, NULL, 'IPR005864', NULL, 'ATP synthase, F0 complex, subunit b, bacterial', 'ATP_synth_F0_bsu_bac', 4, NULL),
(6788, NULL, 'IPR000754', NULL, 'Ribosomal protein S9', 'Ribosomal_S9', 4, NULL),
(6789, NULL, 'IPR002959', NULL, 'Tumour necrosis factor alpha', 'TNF_alpha', 4, NULL),
(6790, NULL, 'IPR002970', NULL, 'Tick histamine-binding protein', 'Tick_his-bd', 4, NULL),
(6791, NULL, 'IPR002456', NULL, 'GPCR family 3, gamma-aminobutyric acid receptor, type B1', 'GPCR_3_GABA_rcpt_B1', 4, NULL),
(6792, NULL, 'IPR002460', NULL, 'Alpha-synuclein', 'Synuclein_alpha', 4, NULL),
(6793, NULL, 'IPR006429', NULL, 'Phage portal protein, lambda family', 'Phage_lambda_portal', 4, NULL),
(6794, NULL, 'IPR000470', NULL, 'CbxX/CfxQ, monofunctional', 'CbxX/CfqX_mono', 4, NULL),
(6795, NULL, 'IPR003053', NULL, 'GPCR, family 2, corticotropin releasing factor receptor, type 2', 'GPCR_2_CRF2_rcpt', 4, NULL),
(6796, NULL, 'IPR002462', NULL, 'Gamma-synuclein', 'Synuclein_gamma', 4, NULL),
(6797, NULL, 'IPR005881', NULL, 'Serine O-acetyltransferase', 'Ser_O-AcTrfase', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(6798, NULL, 'IPR023272', NULL, 'Cytochrome C oxidase, subunit VIIB domain superfamily', 'Cyt_c_oxidase_suVIIB_dom_sf', 5, NULL),
(6799, NULL, 'IPR001429', NULL, 'P2X purinoreceptor', 'P2X_purnocptor', 4, NULL),
(6800, NULL, 'IPR035889', NULL, 'Light-harvesting complex', 'Light-harvesting_complex', 5, NULL),
(6801, NULL, 'IPR000681', NULL, 'Beta 3 adrenoceptor', 'ADRB3_rcpt', 4, NULL),
(6802, NULL, 'IPR005879', NULL, 'Ribosomal protein L1, mitochondrial', 'Ribosomal_L1_mit', 4, NULL),
(6803, NULL, 'IPR005871', NULL, 'Photosynthetic reaction centre, L subunit', 'Photo_RC_L', 4, NULL),
(6804, NULL, 'IPR007026', NULL, 'CC domain', 'CC_domain', 3, NULL),
(6805, NULL, 'IPR002928', NULL, 'Myosin tail', 'Myosin_tail', 3, NULL),
(6806, NULL, 'IPR003531', NULL, 'Short hematopoietin receptor, family 1, conserved site', 'Hempt_rcpt_S_F1_CS', 2, NULL),
(6807, NULL, 'IPR007051', NULL, 'CHORD domain', 'CHORD_dom', 3, NULL),
(6808, NULL, 'IPR001377', NULL, 'Ribosomal protein S6e', 'Ribosomal_S6e', 4, NULL),
(6809, NULL, 'IPR000378', NULL, 'Opsin red/green sensitive', 'Opsin_red/grn', 4, NULL),
(6810, NULL, 'IPR000417', NULL, 'Hydroxyethylthiazole kinase', 'Hyethyz_kinase', 4, NULL),
(6811, NULL, 'IPR005197', NULL, 'Glycoside hydrolase family 71', 'Glyco_hydro_71', 4, NULL),
(6812, NULL, 'IPR003060', NULL, 'Pyocin S killer protein', 'Pyocin_killer', 4, NULL),
(6813, NULL, 'IPR007262', NULL, 'Vps55/LEPROT', 'Vps55/LEPROT', 4, NULL),
(6814, NULL, 'IPR002951', NULL, 'Atrophin-like', 'Atrophin-like', 4, NULL),
(6815, NULL, 'IPR005861', NULL, 'Histidinol-phosphate aminotransferase family', 'HisP_aminotrans', 4, NULL),
(6816, NULL, 'IPR007018', NULL, 'Mediator complex, subunit Med6', 'Mediator_Med6', 4, NULL),
(6817, NULL, 'IPR002924', NULL, 'Adenovirus small t-antigen, E1B 19kDa protein', 'Adenovir_t-Ag_E1B_19kDa', 4, NULL),
(6818, NULL, 'IPR002427', NULL, 'Alcohol dehydrogenase-related', 'ADH-rel', 4, NULL),
(6819, NULL, 'IPR000730', NULL, 'Proliferating cell nuclear antigen, PCNA', 'Pr_cel_nuc_antig', 4, NULL),
(6820, NULL, 'IPR002463', NULL, 'Ornatin', 'Ornatin', 4, NULL),
(6821, NULL, 'IPR007264', NULL, 'H/ACA ribonucleoprotein complex, subunit Nop10', 'H/ACA_rnp_Nop10', 4, NULL),
(6822, NULL, 'IPR000502', NULL, 'Muscarinic acetylcholine receptor M5', 'Musac_Ach_M5_rcpt', 4, NULL),
(6823, NULL, 'IPR002455', NULL, 'GPCR family 3, GABA-B receptor', 'GPCR3_GABA-B', 4, NULL),
(6824, NULL, 'IPR000391', NULL, 'Ring-hydroxylating dioxygenase beta subunit', 'Rng_hydr_dOase-bsu', 4, NULL),
(6825, NULL, 'IPR000507', NULL, 'Beta 1 adrenoceptor', 'ADRB1_rcpt', 4, NULL),
(6826, NULL, 'IPR006442', NULL, 'Type II toxin-antitoxin system, antitoxin Phd/YefM', 'Antitoxin_Phd/YefM', 4, NULL),
(6827, NULL, 'IPR002436', NULL, 'Sodium:neurotransmitter symporter, dopamine', 'Na/ntran_symport_dopamine', 4, NULL),
(6828, NULL, 'IPR001595', NULL, 'Mycoplasma-specific lipoprotein, type 3', 'Lipoprotein_3', 4, NULL),
(6829, NULL, 'IPR034268', NULL, 'RBM25, RNA recognition motif', 'RBM25_RRM', 3, NULL),
(6830, NULL, 'IPR000415', NULL, 'Nitroreductase-like', 'Nitroreductase-like', 5, NULL),
(6831, NULL, 'IPR002937', NULL, 'Amine oxidase', 'Amino_oxidase', 3, NULL),
(6832, NULL, 'IPR003061', NULL, 'Colicin E1 (microcin) immunity protein', 'Microcin', 4, NULL),
(6833, NULL, 'IPR007023', NULL, 'Ribosomal biogenesis regulatory protein', 'Ribosom_reg', 4, NULL),
(6834, NULL, 'IPR000645', NULL, 'Type II secretion system protein GspN, conserved site', 'T2SS_GspN_CS', 2, NULL),
(6835, NULL, 'IPR007250', NULL, 'Heat shock protein 9/12', 'HSP9_HSP12', 4, NULL),
(6836, NULL, 'IPR001412', NULL, 'Aminoacyl-tRNA synthetase, class I, conserved site', 'aa-tRNA-synth_I_CS', 2, NULL),
(6837, NULL, 'IPR002956', NULL, 'Bride of sevenless protein', 'Bride_of_7less', 4, NULL),
(6838, NULL, 'IPR006414', NULL, 'P-type ATPase, subfamily IID', 'P-type_ATPase_IID', 4, NULL),
(6839, NULL, 'IPR000791', NULL, 'Acetate transporter GPR1/FUN34/SatP family', 'Gpr1/Fun34/SatP', 4, NULL),
(6840, NULL, 'IPR000456', NULL, 'Ribosomal protein L17', 'Ribosomal_L17', 4, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(6841, NULL, 'IPR000800', NULL, 'Notch domain', 'Notch_dom', 3, NULL),
(6842, NULL, 'IPR000781', NULL, 'Enhancer of rudimentary', 'ERH', 4, NULL),
(6843, NULL, 'IPR006422', NULL, 'D-erythrose-4-phosphate dehydrogenase', 'E4P_DH_bac', 4, NULL),
(6844, NULL, 'IPR002468', NULL, 'Peptidase M24A, methionine aminopeptidase, subfamily 2', 'Pept_M24A_MAP2', 4, NULL),
(6845, NULL, 'IPR000690', NULL, 'Matrin/U1-C, C2H2-type zinc finger', 'Matrin/U1-C_Znf_C2H2', 3, NULL),
(6846, NULL, 'IPR007241', NULL, 'Autophagy-related protein 9', 'Autophagy-rel_prot_9', 4, NULL),
(6847, NULL, 'IPR000518', NULL, 'Metallothionein, family 14, prokaryote', 'Metalthion_fam14_prok', 4, NULL),
(6848, NULL, 'IPR000806', NULL, 'Rab GDI protein', 'RabGDI', 4, NULL),
(6849, NULL, 'IPR005372', NULL, 'Uncharacterised protein family UPF0182', 'UPF0182', 4, NULL),
(6850, NULL, 'IPR005857', NULL, 'Cystathionine beta-synthase', 'Cysta_beta_synth', 4, NULL),
(6851, NULL, 'IPR005388', NULL, 'G2A lysophosphatidylcholine receptor', 'G2A_lysphc_rcpt', 4, NULL),
(6852, NULL, 'IPR034272', NULL, 'Gar2, RNA recognition motif 1', 'Gar2_RRM1', 3, NULL),
(6853, NULL, 'IPR001440', NULL, 'Tetratricopeptide repeat 1', 'TPR_1', 7, NULL),
(6854, NULL, 'IPR007059', NULL, 'DMSO reductase anchor subunit (DmsC)', 'DmsC', 4, NULL),
(6855, NULL, 'IPR007227', NULL, 'Cell shape-determining protein MreD', 'Cell_shape_determining_MreD', 4, NULL),
(6856, NULL, 'IPR002429', NULL, 'Cytochrome c oxidase subunit II-like C-terminal', 'CcO_II-like_C', 3, NULL),
(6857, NULL, 'IPR006456', NULL, 'ZF-HD homeobox protein, Cys/His-rich dimerisation domain', 'ZF_HD_homeobox_Cys/His_dimer', 3, NULL),
(6858, NULL, 'IPR005890', NULL, 'Nitrate transport ATP-binding subunit C/D', 'NO3_transporter_ATP-bd', 4, NULL),
(6859, NULL, 'IPR005880', NULL, 'Ribosomal protein L2, bacterial/organellar-type', 'Ribosomal_L2_bac/org-type', 4, NULL),
(6860, NULL, 'IPR006419', NULL, 'Nicotinamide mononucleotide transporter PnuC', 'NMN_transpt_PnuC', 4, NULL),
(6861, NULL, 'IPR000408', NULL, 'Regulator of chromosome condensation, RCC1', 'Reg_chr_condens', 7, NULL),
(6862, NULL, 'IPR007025', NULL, 'Late expression factor 8 (LEF-8)', 'LEF-8', 4, NULL),
(6863, NULL, 'IPR001380', NULL, 'Ribosomal protein L13e', 'Ribosomal_L13e', 4, NULL),
(6864, NULL, 'IPR000377', NULL, '5-Hydroxytryptamine 2C receptor', '5HT2C_rcpt', 4, NULL),
(6865, NULL, 'IPR000761', NULL, 'Melanocyte-stimulating hormone receptor', 'MSH_rcpt', 4, NULL),
(6866, NULL, 'IPR000783', NULL, 'RNA polymerase, subunit H/Rpb5 C-terminal', 'RNA_pol_subH/Rpb5_C', 3, NULL),
(6867, NULL, 'IPR023645', NULL, 'D-aminopeptidase', 'DAP', 4, NULL),
(6868, NULL, 'IPR007041', NULL, 'Arginine N-succinyltransferase AstA/AruG', 'Arg_succinylTrfase_AstA/AruG', 4, NULL),
(6869, NULL, 'IPR000416', NULL, 'Haemagglutinin outer capsid protein VP4, concanavalin-like domain', 'VP4_concanavalin-like', 3, NULL),
(6870, NULL, 'IPR005904', NULL, 'Hypoxanthine phosphoribosyl transferase', 'Hxn_phspho_trans', 4, NULL),
(6871, NULL, 'IPR005869', NULL, 'Photosystem II CP43 reaction centre protein', 'PSII_PsbC', 4, NULL),
(6872, NULL, 'IPR005201', NULL, 'Glycoside hydrolase, family 85', 'Glyco_hydro_85', 3, NULL),
(6873, NULL, 'IPR006413', NULL, 'P-type ATPase, subfamily IIA, PMR1-type', 'P-type_ATPase_IIA_PMR1', 4, NULL),
(6874, NULL, 'IPR007014', NULL, 'FUN14', 'FUN14', 4, NULL),
(6875, NULL, 'IPR007044', NULL, 'Cyclodeaminase/cyclohydrolase', 'Cyclodeamin/CycHdrlase', 3, NULL),
(6876, NULL, 'IPR005804', NULL, 'Fatty acid desaturase domain', 'FA_desaturase_dom', 3, NULL),
(6877, NULL, 'IPR005897', NULL, 'Peptidase C39, ABC-type bacteriocin transporter', 'Pept_C39_ABC_bacteriocin', 4, NULL),
(6878, NULL, 'IPR007016', NULL, 'O-antigen ligase-related', 'O-antigen_ligase-related', 4, NULL),
(6879, NULL, 'IPR002922', NULL, 'Thiazole biosynthetic enzyme Thi4 family', 'Thi4_fam', 4, NULL),
(6880, NULL, 'IPR002944', NULL, 'Sodium:neurotransmitter symporter, inebriated', 'Na/ntran_symport_inebriated', 4, NULL),
(6881, NULL, 'IPR005866', NULL, 'Tetrahydromethanopterin S-methyltransferase, subunit G', 'THM_MeTrfase_su_G', 4, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(6882, NULL, 'IPR000810', NULL, 'Cannabinoid receptor type 1', 'Canbinoid_rcpt_1', 4, NULL),
(6883, NULL, 'IPR005387', NULL, 'CX3C chemokine receptor 1', 'Chemokine_CX3CR1', 4, NULL),
(6884, NULL, 'IPR007225', NULL, 'Exocyst complex component EXOC6/Sec15', 'EXOC6/Sec15', 4, NULL),
(6885, NULL, 'IPR000669', NULL, 'Mannitol dehydrogenase', 'Mannitol_DH', 4, NULL),
(6886, NULL, 'IPR006447', NULL, 'Myb domain, plants', 'Myb_dom_plants', 3, NULL),
(6887, NULL, 'IPR007238', NULL, 'DNA primase large subunit, eukaryotic/archaeal', 'DNA_primase_lsu_euk/arc', 4, NULL),
(6888, NULL, 'IPR006509', NULL, 'Splicing factor, RBM39-like', 'RBM39_SF', 4, NULL),
(6889, NULL, 'IPR007039', NULL, 'Conjugal transfer TrbC/type IV secretion VirB2', 'TrbC/VirB2', 4, NULL),
(6890, NULL, 'IPR005875', NULL, 'Phosphoribosylaminoimidazole carboxylase, ATPase subunit', 'PurK', 3, NULL),
(6891, NULL, 'IPR002464', NULL, 'DNA/RNA helicase, ATP-dependent, DEAH-box type, conserved site', 'DNA/RNA_helicase_DEAH_CS', 2, NULL),
(6892, NULL, 'IPR006445', NULL, 'Phage-associated protein HI1409', 'Phage-assoc_HI1409', 4, NULL),
(6893, NULL, 'IPR006515', NULL, 'Polyadenylate binding protein, human types 1, 2, 3, 4', 'PABP_1234', 4, NULL),
(6894, NULL, 'IPR000445', NULL, 'Helix-hairpin-helix motif', 'HhH_motif', 2, NULL),
(6895, NULL, 'IPR000469', NULL, 'G-protein alpha subunit, group 12/13', 'Gprotein_alpha_12/13', 4, NULL),
(6896, NULL, 'IPR002467', NULL, 'Peptidase M24A, methionine aminopeptidase, subfamily 1', 'Pept_M24A_MAP1', 4, NULL),
(6897, NULL, 'IPR002949', NULL, 'Cytochrome P450, E-class, CYP24A, mitochondrial', 'Cyt_P450_E_CYP24A_mit', 4, NULL),
(6898, NULL, 'IPR007232', NULL, 'DNA repair protein Rad52/59/22', 'Rad52_Rad59_Rad22', 4, NULL),
(6899, NULL, 'IPR007033', NULL, 'RAB6-interacting golgin', 'GORAB', 4, NULL),
(6900, NULL, 'IPR000482', NULL, '5-Hydroxytryptamine 2B receptor', '5HT2B_rcpt', 4, NULL),
(6901, NULL, 'IPR007046', NULL, 'RNA polymerase sigma factor 54, core-binding domain', 'RNA_pol_sigma_54_core-bd', 3, NULL),
(6902, NULL, 'IPR002403', NULL, 'Cytochrome P450, E-class, group IV', 'Cyt_P450_E_grp-IV', 4, NULL),
(6903, NULL, 'IPR007230', NULL, 'Nuclear pore complex protein Nup98-Nup96-like, autopeptidase S59 domain', 'Nup98_auto-Pept-S59_dom', 3, NULL),
(6904, NULL, 'IPR000499', NULL, 'Endothelin receptor family', 'Endthln_rcpt', 4, NULL),
(6905, NULL, 'IPR006499', NULL, 'Reticulocyte binding protein', 'Reticulocyte-bd', 4, NULL),
(6906, NULL, 'IPR007024', NULL, 'BLUF domain', 'BLUF_domain', 3, NULL),
(6907, NULL, 'IPR002461', NULL, 'Beta-synuclein', 'Synuclein_beta', 4, NULL),
(6908, NULL, 'IPR007015', NULL, 'DNA polymerase V/Myb-binding protein 1A', 'DNA_pol_V/MYBBP1A', 4, NULL),
(6909, NULL, 'IPR001389', NULL, 'Flocculin', 'Flocculin', 7, NULL),
(6910, NULL, 'IPR007047', NULL, 'Flp/Fap pilin component', 'Flp_Fap', 4, NULL),
(6911, NULL, 'IPR000716', NULL, 'Thyroglobulin type-1', 'Thyroglobulin_1', 3, NULL),
(6912, NULL, 'IPR006425', NULL, 'Glucoamylase, bacterial', 'Glucoamylase_bac', 4, NULL),
(6913, NULL, 'IPR002445', NULL, 'Solute carrier family 12 member 1', 'Slc12a1', 4, NULL),
(6914, NULL, 'IPR007251', NULL, 'Low affinity iron permease, Fet4', 'Iron_permease_Fet4', 4, NULL),
(6915, NULL, 'IPR003530', NULL, 'Long hematopoietin receptor, soluble alpha chain, conserved site', 'Hematopoietin_rcpt_L_F3_CS', 2, NULL),
(6916, NULL, 'IPR007256', NULL, 'TM1367-like', 'TM1367-like', 4, NULL),
(6917, NULL, 'IPR000686', NULL, 'Fanconi anaemia group C protein', 'FANCC', 4, NULL),
(6918, NULL, 'IPR002389', NULL, 'Annexin A2', 'ANX2', 4, NULL),
(6919, NULL, 'IPR000500', NULL, 'Connexin', 'Connexin', 4, NULL),
(6920, NULL, 'IPR006496', NULL, 'Conserved hypothetical protein CHP01609, Plasmodium spp', 'CHP01606_Plasmodium_spp', 4, NULL),
(6921, NULL, 'IPR000649', NULL, 'Initiation factor 2B-related', 'IF-2B-related', 4, NULL),
(6922, NULL, 'IPR006438', NULL, 'HAD hydrolase, TIGR01548 family', 'HAD-SF_TIGR01548', 4, NULL),
(6923, NULL, 'IPR006449', NULL, 'Squalene synthase-like', 'Squal_synth-like', 4, NULL),
(6924, NULL, 'IPR005876', NULL, 'Cobalt transport protein ATP-binding subunit', 'Co_trans_ATP-bd', 4, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(6925, NULL, 'IPR001444', NULL, 'Flagellar basal body rod protein, N-terminal', 'Flag_bb_rod_N', 3, NULL),
(6926, NULL, 'IPR032922', NULL, 'Protein SON', 'SON', 4, NULL),
(6927, NULL, 'IPR000771', NULL, 'Fructose-bisphosphate aldolase, class-II', 'FBA_II', 4, NULL),
(6928, NULL, 'IPR006502', NULL, 'Protein of unknown function PDDEXK-like', 'PDDEXK-like', 4, NULL),
(6929, NULL, 'IPR002930', NULL, 'Glycine cleavage system H-protein', 'GCV_H', 4, NULL),
(6930, NULL, 'IPR034441', NULL, 'Bursicon subunit beta', 'Bursicon_suB', 4, NULL),
(6931, NULL, 'IPR005895', NULL, 'ABC transporter, haem export, CcmA', 'ABC_transptr_haem_export_CcmA', 4, NULL),
(6932, NULL, 'IPR005889', NULL, 'Nitrate transport permease', 'NtrB', 4, NULL),
(6933, NULL, 'IPR000763', NULL, 'Catalase-peroxidase haem', 'Catalase_peroxidase', 4, NULL),
(6934, NULL, 'IPR006439', NULL, 'HAD hydrolase, subfamily IA', 'HAD-SF_hydro_IA', 4, NULL),
(6935, NULL, 'IPR034438', NULL, '4-Hydroxyphenylacetate decarboxylase activase', '4-hPhe_decarboxylase_activase', 4, NULL),
(6936, NULL, 'IPR000448', NULL, 'Rhabdovirus nucleocapsid', 'Rhabdo_ncapsid', 3, NULL),
(6937, NULL, 'IPR007031', NULL, 'Poxvirus VLTF3, late transcription factor', 'Poxvirus_VLTF3', 4, NULL),
(6938, NULL, 'IPR007244', NULL, '-alpha-acetyltransferase 35, NatC auxiliary subunit', 'Naa35/Mak10', 4, NULL),
(6939, NULL, 'IPR005850', NULL, 'Galactose-1-phosphate uridyl transferase, C-terminal', 'GalP_Utransf_C', 3, NULL),
(6940, NULL, 'IPR005829', NULL, 'Sugar transporter, conserved site', 'Sugar_transporter_CS', 2, NULL),
(6941, NULL, 'IPR005872', NULL, 'Archaeal/bacterial translation initiation factor SUI1', 'SUI1_arc_bac', 4, NULL),
(6942, NULL, 'IPR006500', NULL, 'DNA primase, phage/plasmid', 'DNA_primase_phage/plasmid', 3, NULL),
(6943, NULL, 'IPR002933', NULL, 'Peptidase M20', 'Peptidase_M20', 4, NULL),
(6944, NULL, 'IPR007008', NULL, 'Poxvirus A6', 'Poxvirus_A6', 4, NULL),
(6945, NULL, 'IPR003533', NULL, 'Doublecortin domain', 'Doublecortin_dom', 3, NULL),
(6946, NULL, 'IPR000720', NULL, 'Peptidylglycine alpha-hydroxylating monooxygenase/peptidyl-hydroxyglycine alpha-amidating lyase', 'PHM/PAL', 4, NULL),
(6947, NULL, 'IPR007265', NULL, 'Conserved oligomeric Golgi complex, subunit 3', 'COG_su3', 4, NULL),
(6948, NULL, 'IPR000452', NULL, 'Kappa opioid receptor', 'Kappa_opi_rcpt', 4, NULL),
(6949, NULL, 'IPR005862', NULL, 'Formate-dependent phosphoribosylglycinamide formyltransferase', 'PurT', 4, NULL),
(6950, NULL, 'IPR002407', NULL, 'Natriuretic peptide, atrial type', 'Natriuretic_peptide_atrial', 4, NULL),
(6951, NULL, 'IPR002440', NULL, 'Glucose transporter, type 2 (GLUT2)', 'Glc_transpt_2', 4, NULL),
(6952, NULL, 'IPR000725', NULL, 'Olfactory receptor', 'Olfact_rcpt', 4, NULL),
(6953, NULL, 'IPR001416', NULL, 'Atypical chemokine receptor 3', 'ACKR3', 4, NULL),
(6954, NULL, 'IPR006458', NULL, 'Ovate  protein family, C-terminal', 'Ovate_C', 3, NULL),
(6955, NULL, 'IPR002934', NULL, 'Polymerase, nucleotidyl transferase domain', 'Polymerase_NTP_transf_dom', 3, NULL),
(6956, NULL, 'IPR007005', NULL, 'XAP5 protein', 'XAP5', 4, NULL),
(6957, NULL, 'IPR013273', NULL, 'ADAMTS/ADAMTS-like', 'ADAMTS/ADAMTS-like', 4, NULL),
(6958, NULL, 'IPR007032', NULL, 'Poxvirus A51', 'Poxvirus_A51', 4, NULL),
(6959, NULL, 'IPR000654', NULL, 'G-protein alpha subunit, group Q', 'Gprotein_alpha_Q', 4, NULL),
(6960, NULL, 'IPR006434', NULL, 'Pyrimidine 5''-nucleotidase, eukaryotic', 'Pyrimidine_nucleotidase_eu', 4, NULL),
(6961, NULL, 'IPR003051', NULL, 'GPCR, family 2, corticotropin releasing factor receptor', 'GPCR_2_CRF_rcpt', 4, NULL),
(6962, NULL, 'IPR005858', NULL, 'Cysteine synthase CysM', 'CysM', 4, NULL),
(6963, NULL, 'IPR000428', NULL, 'Copper ion binding protein', 'Cu-bd', 4, NULL),
(6964, NULL, 'IPR005870', NULL, 'Cytochrome b6/f complex, subunit IV', 'Cyt_b6/f_cplx_suIV', 4, NULL),
(6965, NULL, 'IPR005206', NULL, 'Herpesvirus ICP4-like protein, N-terminal', 'Herpes_ICP4_N', 3, NULL),
(6966, NULL, 'IPR006421', NULL, 'Glycogen debranching enzyme, metazoa', 'Glycogen_debranch_met', 4, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(6967, NULL, 'IPR005873', NULL, 'DENR family, eukaryotes', 'DENR_eukaryotes', 4, NULL),
(6968, NULL, 'IPR001435', NULL, 'Adenosine A2B receptor', 'Adeno_A2B_rcpt', 4, NULL),
(6969, NULL, 'IPR003047', NULL, 'P2X4 purinoceptor', 'P2X4_purnocptor', 4, NULL),
(6970, NULL, 'IPR007239', NULL, 'Autophagy-related protein 5', 'Atg5', 4, NULL),
(6971, NULL, 'IPR000451', NULL, 'NF-kappa-B/Dorsal', 'NFkB/Dor', 4, NULL),
(6972, NULL, 'IPR006427', NULL, 'Phage portal protein, HK97', 'Portal_HK97', 4, NULL),
(6973, NULL, 'IPR005385', NULL, 'Lysophosphatidic acid receptor EDG-7', 'LPA_rcpt_EDG7', 4, NULL),
(6974, NULL, 'IPR006497', NULL, 'Bacteriophage lambda, Replication protein O, N-terminal', 'Phage_lambda_VrpO_N', 3, NULL),
(6975, NULL, 'IPR002404', NULL, 'IRS-type PTB domain', 'IRS_PTB', 3, NULL),
(6976, NULL, 'IPR000494', NULL, 'Receptor L-domain', 'Rcpt_L-dom', 3, NULL),
(6977, NULL, 'IPR001425', NULL, 'Archaeal/bacterial/fungal rhodopsins', 'Arc/bac/fun_rhodopsins', 4, NULL),
(6978, NULL, 'IPR000692', NULL, 'rRNA 2''-O-methyltransferase fibrillarin-like', 'Fibrillarin', 4, NULL),
(6979, NULL, 'IPR002562', NULL, '3''-5'' exonuclease domain', '3''-5''_exonuclease_dom', 3, NULL),
(6980, NULL, 'IPR006514', NULL, 'IRX15/IRX15L/IGXM', 'IRX15/IRX15L/IGXM', 4, NULL),
(6981, NULL, 'IPR002945', NULL, 'Glucose transporter, type 3 (GLUT3)', 'Glc_transpt_3', 4, NULL),
(6982, NULL, 'IPR001423', NULL, 'Lysophospholipase patatin, conserved site', 'LysoPLipase_patatin_CS', 2, NULL),
(6983, NULL, 'IPR002418', NULL, 'Transcription regulator Myc', 'Tscrpt_reg_Myc', 4, NULL),
(6984, NULL, 'IPR002439', NULL, 'Glucose transporter, type 1 (GLUT1)', 'Glu_transpt_1', 4, NULL),
(6985, NULL, 'IPR002932', NULL, 'Glutamate synthase domain', 'Glu_synthdom', 3, NULL),
(6986, NULL, 'IPR006517', NULL, 'Archaeophage PsiM2, terminase large subunit', 'Arc_phage_PsiM2_terminase_lsu', 4, NULL),
(6987, NULL, 'IPR005384', NULL, 'Duffy antigen/chemokine receptor', 'Duffy_chemokine_rcpt', 4, NULL),
(6988, NULL, 'IPR000758', NULL, 'Virulence-related outer membrane protein', 'Enterovir_OMP', 4, NULL),
(6989, NULL, 'IPR000398', NULL, 'Thymidylate synthase', 'Thymidylate_synthase', 4, NULL),
(6990, NULL, 'IPR006460', NULL, 'Protein MIZU-KUSSEI 1-like, plant', 'MIZ1-like_pln', 4, NULL),
(6991, NULL, 'IPR005891', NULL, 'DevC protein', 'DevC', 4, NULL),
(6992, NULL, 'IPR007254', NULL, 'Protein of unknown function DUF373', 'DUF373', 4, NULL),
(6993, NULL, 'IPR001446', NULL, '5-lipoxygenase-activating protein', '5_LipOase_AP', 4, NULL),
(6994, NULL, 'IPR006455', NULL, 'Homeodomain, ZF-HD class', 'Homeodomain_ZF_HD', 3, NULL),
(6995, NULL, 'IPR000480', NULL, 'Glutelin', 'Glutelin', 4, NULL),
(6996, NULL, 'IPR005198', NULL, 'Glycoside hydrolase, family 76', 'Glyco_hydro_76', 4, NULL),
(6997, NULL, 'IPR006452', NULL, 'Formate dehydrogenase accessory protein', 'Formate_DH_accessory', 4, NULL),
(6998, NULL, 'IPR007248', NULL, 'Mpv17/PMP22', 'Mpv17_PMP22', 4, NULL),
(6999, NULL, 'IPR000808', NULL, 'Mrp, conserved site', 'Mrp_CS', 2, NULL),
(7000, NULL, 'IPR007242', NULL, 'Ubiquitin-like protein Atg12', 'Atg12', 4, NULL),
(7001, NULL, 'IPR003951', NULL, 'Peptidase C58, Yersinia/Haemophilus virulence surface antigen', 'Peptidase_C58', 4, NULL),
(7002, NULL, 'IPR005401', NULL, 'Potassium channel, voltage-dependent, beta subunit, KCNAB2', 'K_chnl_volt-dep_bsu_KCNAB2', 4, NULL),
(7003, NULL, 'IPR005405', NULL, 'Potassium channel, voltage dependent, Kv3.4', 'K_chnl_volt-dep_Kv3.4', 4, NULL),
(7004, NULL, 'IPR004450', NULL, 'Threonine synthase-like', 'Thr_synthase-like', 4, NULL),
(7005, NULL, 'IPR012151', NULL, 'Protein-tyrosine phosphatase, non-receptor type-3, -4', 'Tyr_Pase_non-rcpt_typ-3/4', 4, NULL),
(7006, NULL, 'IPR008197', NULL, 'WAP-type ''four-disulfide core'' domain', 'WAP_dom', 3, NULL),
(7007, NULL, 'IPR004466', NULL, 'Ribonuclease M5', 'RNase_M5', 4, NULL),
(7008, NULL, 'IPR014711', NULL, 'DNA topoisomerase I, catalytic core, alpha-helical subdomain, eukaryotic-type', 'TopoI_cat_a-hlx-sub_euk', 5, NULL),
(7009, NULL, 'IPR005142', NULL, 'eRF1 domain 3', 'eRF1_3', 3, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(7010, NULL, 'IPR007280', NULL, 'Peptidase, C-terminal, archaeal/bacterial', 'Peptidase_C_arc/bac', 3, NULL),
(7011, NULL, 'IPR004438', NULL, 'Peptidase M3B, oligoendopeptidase F', 'Peptidase_M3B', 4, NULL),
(7012, NULL, 'IPR002986', NULL, 'Diaminopimelate decarboxylase, LysA', 'DAP_deCOOHase_LysA', 4, NULL),
(7013, NULL, 'IPR005133', NULL, 'Na+/H+ antiporter subunit G', 'PhaG_MnhG_YufB', 4, NULL),
(7014, NULL, 'IPR014397', NULL, 'L-2-aminoadipate reductase', 'Lys2', 4, NULL),
(7015, NULL, 'IPR012179', NULL, '[NiFe]-hydrogenase-3-type complex Ech, subunit EchD', 'NiFe-hyd_3_EchD', 4, NULL),
(7016, NULL, 'IPR014000', NULL, 'DNA helicase E1, N-terminal, Papillomavirus', 'PPV_DNA_helicase_E1_N', 3, NULL),
(7017, NULL, 'IPR015413', NULL, 'Methionyl/Leucyl tRNA synthetase', 'Methionyl/Leucyl_tRNA_Synth', 3, NULL),
(7018, NULL, 'IPR005403', NULL, 'Potassium channel, voltage dependent, Kv3.1', 'K_chnl_volt-dep_Kv3.1', 4, NULL),
(7019, NULL, 'IPR008154', NULL, 'Amyloidogenic glycoprotein, extracellular', 'Amyloid_glyco_extra', 3, NULL),
(7020, NULL, 'IPR004878', NULL, 'Otopetrin', 'Otopetrin', 4, NULL),
(7021, NULL, 'IPR007072', NULL, 'Rhamnosyl O-methyltransferase/Cephalosporin hydroxylase', 'Rhamnosyl_O-MeTrfase_CmcI', 4, NULL),
(7022, NULL, 'IPR001355', NULL, 'CXC chemokine receptor 1', 'Chemokine_CXCR1', 4, NULL),
(7023, NULL, 'IPR017959', NULL, 'Aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase, subunit B /E', 'Asn/Gln-tRNA_amidoTrfase_suB/E', 4, NULL),
(7024, NULL, 'IPR002971', NULL, 'Major urinary protein', 'Maj_urinary', 4, NULL),
(7025, NULL, 'IPR004854', NULL, 'Ubiquitin fusion degradation protein Ufd1-like', 'Ufd1-like', 4, NULL),
(7026, NULL, 'IPR003959', NULL, 'ATPase, AAA-type, core', 'ATPase_AAA_core', 3, NULL),
(7027, NULL, 'IPR015422', NULL, 'Pyridoxal phosphate-dependent transferase, small domain', 'PyrdxlP-dep_Trfase_small', 5, NULL),
(7028, NULL, 'IPR003988', NULL, 'Intercellular adhesion molecule', 'ICAM', 3, NULL),
(7029, NULL, 'IPR008210', NULL, 'Phosphoenolpyruvate carboxykinase, N-terminal', 'PEP_carboxykinase_N', 5, NULL),
(7030, NULL, 'IPR012166', NULL, 'Uncharacterised protein family RocB', 'Uncharacterised_RocB', 4, NULL),
(7031, NULL, 'IPR007289', NULL, 'Jaagsiekte sheep retrovirus, Vpu', 'JSRV_Vpu', 4, NULL),
(7032, NULL, 'IPR015420', NULL, 'Peptidase S1A, nudel', 'Peptidase_S1A_nudel', 3, NULL),
(7033, NULL, 'IPR003549', NULL, 'Claudin-3', 'Claudin3', 4, NULL),
(7034, NULL, 'IPR005140', NULL, 'eRF1 domain 1/Pelota-like', 'eRF1_1_Pelota', 3, NULL),
(7035, NULL, 'IPR002982', NULL, 'Sodium:neurotransmitter symporter, GABA, GAT-3', 'Na/ntran_symport_GABA_GAT3', 4, NULL),
(7036, NULL, 'IPR004449', NULL, 'Phosphohistidine phosphatase SixA', 'SixA', 4, NULL),
(7037, NULL, 'IPR007281', NULL, 'Mre11, DNA-binding', 'Mre11_DNA-bd', 3, NULL),
(7038, NULL, 'IPR004453', NULL, 'Epoxyqueuosine reductase QueG', 'QueG', 4, NULL),
(7039, NULL, 'IPR005390', NULL, 'Neuromedin U receptor', 'NeuromedU_rcpt', 4, NULL),
(7040, NULL, 'IPR002438', NULL, 'Neutral amino acid SLC6 transporter', 'Neutral_aa_SLC6', 4, NULL),
(7041, NULL, 'IPR034674', NULL, 'Serine/threonine-protein kinase Kin4/ppk1, catalytic domain', 'STK_Kin4/ppk1', 3, NULL),
(7042, NULL, 'IPR012144', NULL, 'Nitric-oxide synthase, eukaryote', 'NOS_euk', 4, NULL),
(7043, NULL, 'IPR007284', NULL, 'Ground-like domain', 'Ground-like_dom', 3, NULL),
(7044, NULL, 'IPR007071', NULL, 'A-kinase anchoring protein 95 (AKAP95)', 'AKAP95', 4, NULL),
(7045, NULL, 'IPR008144', NULL, 'Guanylate kinase-like domain', 'Guanylate_kin-like_dom', 3, NULL),
(7046, NULL, 'IPR034532', NULL, 'OxsB-like', 'OxsB-like', 4, NULL),
(7047, NULL, 'IPR034645', NULL, 'FCA, RNA recognition motif 2', 'FCA_RRM2', 3, NULL),
(7048, NULL, 'IPR003542', NULL, 'Enterobactin synthetase-like, component D', 'Enbac_synth_compD-like', 4, NULL),
(7049, NULL, 'IPR002977', NULL, 'Anion exchange protein 1', 'Anion_exchange_1', 4, NULL),
(7050, NULL, 'IPR001345', NULL, 'Phosphoglycerate/bisphosphoglycerate mutase, active site', 'PG/BPGM_mutase_AS', 0, NULL),
(7051, NULL, 'IPR013086', NULL, 'Sodium:neurotransmitter symporter, serotonin, N-terminal', 'Na/ntran_symport_serotonin_N', 3, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(7052, NULL, 'IPR003968', NULL, 'Potassium channel, voltage dependent, Kv', 'K_chnl_volt-dep_Kv', 4, NULL),
(7053, NULL, 'IPR034456', NULL, 'Mediator of RNA polymerase II transcription subunit 28', 'MED28', 4, NULL),
(7054, NULL, 'IPR008143', NULL, 'Alanine dehydrogenase/pyridine nucleotide transhydrogenase, conserved site-2', 'Ala_DH/PNT_CS2', 2, NULL),
(7055, NULL, 'IPR034697', NULL, 'Baseplate wedge protein gp7', 'GP7_T4', 4, NULL),
(7056, NULL, 'IPR003947', NULL, 'Potassium channel, voltage dependent, KCNQ2', 'K_chnl_volt-dep_KCNQ2', 4, NULL),
(7057, NULL, 'IPR004859', NULL, 'Xrn1, N-terminal', 'Xrn1_N', 3, NULL),
(7058, NULL, 'IPR013061', NULL, 'Tryptophan/tryrosine permease, conserved site', 'Trp/try_permease_CS', 2, NULL),
(7059, NULL, 'IPR003984', NULL, 'Neurotensin receptor', 'NT_rcpt', 4, NULL),
(7060, NULL, 'IPR004472', NULL, 'Dethiobiotin synthase BioD', 'DTB_synth_BioD', 4, NULL),
(7061, NULL, 'IPR001363', NULL, 'Proteinase inhibitor I25C, fetuin, conserved site', 'Prot_inh_fetuin_CS', 2, NULL),
(7062, NULL, 'IPR008152', NULL, 'Clathrin adaptor, alpha/beta/gamma-adaptin, appendage, Ig-like subdomain', 'Clathrin_a/b/g-adaptin_app_Ig', 3, NULL),
(7063, NULL, 'IPR013088', NULL, 'Zinc finger, NHR/GATA-type', 'Znf_NHR/GATA', 5, NULL),
(7064, NULL, 'IPR012163', NULL, 'Sialyltransferase', 'Sialyl_trans', 4, NULL),
(7065, NULL, 'IPR003545', NULL, 'Telomerase reverse transcriptase', 'Telomerase_RT', 4, NULL),
(7066, NULL, 'IPR001403', NULL, 'Parvovirus coat protein VP2', 'Parvovirus_coat', 3, NULL),
(7067, NULL, 'IPR003895', NULL, 'Type III secretion system, invasin protein B', 'T3SS_invasion_prot_B', 4, NULL),
(7068, NULL, 'IPR003944', NULL, 'Protease-activated receptor 4', 'Prot_act_rcpt_4', 4, NULL),
(7069, NULL, 'IPR003992', NULL, 'Pertactin autotransporter', 'Pertactin', 4, NULL),
(7070, NULL, 'IPR004463', NULL, 'UDP-3-O-acyl N-acetylglucosamine deacetylase', 'UDP-acyl_GlcNac_deAcase', 4, NULL),
(7071, NULL, 'IPR013986', NULL, 'DExx box DNA helicase domain superfamily', 'DExx_box_DNA_helicase_dom_sf', 5, NULL),
(7072, NULL, 'IPR005406', NULL, 'Potassium channel subfamily K member 3', 'KCNK3', 4, NULL),
(7073, NULL, 'IPR005416', NULL, 'Type III secretion chaperone SycE', 'T3SS_chp_SycE', 4, NULL),
(7074, NULL, 'IPR017961', NULL, 'DNA polymerase, Y-family, little finger domain', 'DNA_pol_Y-fam_little_finger', 3, NULL),
(7075, NULL, 'IPR004456', NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase', 'Pglycerate_mutase_ApgM', 4, NULL),
(7076, NULL, 'IPR004879', NULL, 'Domain of unknown function DUF255', 'DUF255', 3, NULL),
(7077, NULL, 'IPR001339', NULL, 'mRNA capping enzyme, adenylation domain', 'mRNA_cap_enzyme_adenylation', 3, NULL),
(7078, NULL, 'IPR016089', NULL, 'Chalcone isomerase, orthogonal bundle domain superfamily', 'Chalcone_isomerase_bundle_sf', 5, NULL),
(7079, NULL, 'IPR023790', NULL, 'Chloride channel, voltage-gated, ClcB', 'Cl-channel_volt-gated_ClcB', 4, NULL),
(7080, NULL, 'IPR004446', NULL, 'D,D-heptose 1,7-bisphosphate phosphatase', 'Heptose_bisP_phosphatase', 4, NULL),
(7081, NULL, 'IPR023301', NULL, 'Ammonia/methane monooxygenase, subunitB, N-terminal', 'NH3_CH4_mOase_suB_N', 5, NULL),
(7082, NULL, 'IPR005396', NULL, 'Neuropeptide FF receptor, type 1', 'NPFF_rcpt_1', 4, NULL),
(7083, NULL, 'IPR004482', NULL, 'Mg chelatase-related protein', 'Mg_chelat-rel', 4, NULL),
(7084, NULL, 'IPR012846', NULL, 'Acetolactate synthase, large subunit, biosynthetic', 'Acetolactate_synth_lsu', 4, NULL),
(7085, NULL, 'IPR015877', NULL, 'Cdk-activating kinase assembly factor MAT1, centre', 'Cdk-activating_kinase_MAT1_cen', 3, NULL),
(7086, NULL, 'IPR003937', NULL, 'Potassium channel, voltage dependent, KCNQ', 'K_chnl_volt-dep_KCNQ', 4, NULL),
(7087, NULL, 'IPR003949', NULL, 'Potassium channel, voltage-dependent, EAG', 'K_chnl_volt-dep_EAG', 4, NULL),
(7088, NULL, 'IPR007296', NULL, 'Domain of unknown function DUF403', 'DUF403', 3, NULL),
(7089, NULL, 'IPR017947', NULL, 'Aryldialkylphosphatase, zinc-binding site', 'AryldialkylPase_Zn-BS', 1, NULL),
(7090, NULL, 'IPR005138', NULL, 'Aerolysin/Pertussis toxin domain', 'APT_dom', 3, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(7091, NULL, 'IPR004447', NULL, 'C-terminal-processing peptidase S41A', 'Peptidase_S41A', 4, NULL),
(7092, NULL, 'IPR013523', NULL, 'Histone acetyltransferase HAT1, C-terminal', 'Hist_AcTrfase_HAT1_C', 5, NULL),
(7093, NULL, 'IPR004867', NULL, 'Chitobiase C-terminal domain', 'CHB_C_dom', 3, NULL),
(7094, NULL, 'IPR035082', NULL, 'Nrap protein domain 1', 'Nrap_D1', 3, NULL),
(7095, NULL, 'IPR001365', NULL, 'Adenosine deaminase domain', 'A_deaminase_dom', 3, NULL),
(7096, NULL, 'IPR004422', NULL, 'Beta-ribofuranosylphenol 5''-phosphate synthase', 'RFAP_synthase', 4, NULL),
(7097, NULL, 'IPR008139', NULL, 'Saposin B type domain', 'SaposinB_dom', 3, NULL),
(7098, NULL, 'IPR015889', NULL, 'Intradiol ring-cleavage dioxygenase, core', 'Intradiol_dOase_core', 5, NULL),
(7099, NULL, 'IPR004856', NULL, 'Glycosyl transferase, ALG6/ALG8', 'Glyco_trans_ALG6/ALG8', 4, NULL),
(7100, NULL, 'IPR005122', NULL, 'Uracil-DNA glycosylase-like', 'Uracil-DNA_glycosylase-like', 3, NULL),
(7101, NULL, 'IPR012157', NULL, 'Uncharacterised conserved protein, CBS/CP12', 'UCP_CBS_CP12', 4, NULL),
(7102, NULL, 'IPR034198', NULL, 'CELF1/2, RNA recognition motif 2', 'CELF1/2_RRM2', 3, NULL),
(7103, NULL, 'IPR012170', NULL, 'TFIIH subunit Ssl1/p44', 'TFIIH_SSL1/p44', 4, NULL),
(7104, NULL, 'IPR003987', NULL, 'Intercellular adhesion molecule/vascular cell adhesion molecule, N-terminal', 'ICAM_VCAM_N', 3, NULL),
(7105, NULL, 'IPR003554', NULL, 'Claudin-10', 'Claudin10', 4, NULL),
(7106, NULL, 'IPR005412', NULL, 'DNA-binding protein Fis', 'Fis_DNA-bd', 4, NULL),
(7107, NULL, 'IPR003546', NULL, 'Type III secreted modular tyrosine phosphatase, SptP/YopH', 'Tyr_Pase_SptP/YopH', 4, NULL),
(7108, NULL, 'IPR034690', NULL, 'Endolysin T4 type', 'Endolysin_T4_type', 4, NULL),
(7109, NULL, 'IPR007293', NULL, 'Flagellar protein FlgP', 'FlgP', 4, NULL),
(7110, NULL, 'IPR014399', NULL, 'Cyclin CLN', 'Cyclin_CLN', 4, NULL),
(7111, NULL, 'IPR002978', NULL, 'Anion exchange protein 2', 'Anion_exchange_2', 4, NULL),
(7112, NULL, 'IPR034662', NULL, 'Atypical Protein Kinase C zeta, catalytic domain', 'aPKC_zeta', 3, NULL),
(7113, NULL, 'IPR003972', NULL, 'Potassium channel, voltage dependent, Kv1', 'K_chnl_volt-dep_Kv1', 4, NULL),
(7114, NULL, 'IPR004436', NULL, 'Isocitrate dehydrogenase NADP-dependent, monomeric', 'Isocitrate_DH_NADP_mono', 4, NULL),
(7115, NULL, 'IPR008168', NULL, 'Cytochrome c, class IC', 'Cyt_C_IC', 4, NULL),
(7116, NULL, 'IPR012180', NULL, 'Predicted bifunctional ATPase/phosphotransferase', 'Bifunc_ATPase/PTrfase', 4, NULL),
(7117, NULL, 'IPR003011', NULL, 'Cell cycle checkpoint protein, Rad1', 'Cell_cycle_checkpoint_Rad1', 4, NULL),
(7118, NULL, 'IPR015883', NULL, 'Glycoside hydrolase family 20, catalytic domain', 'Glyco_hydro_20_cat', 3, NULL),
(7119, NULL, 'IPR012844', NULL, 'Dihydroxyacetone kinase phosphotransferase subunit, N-terminal domain', 'DhaM_N', 3, NULL),
(7120, NULL, 'IPR005402', NULL, 'Potassium channel, voltage-dependent, beta subunit, KCNAB3', 'K_chnl_volt-dep_bsu_KCNAB3', 4, NULL),
(7121, NULL, 'IPR013068', NULL, 'Galanin message associated peptide (GMAP)', 'GMAP', 3, NULL),
(7122, NULL, 'IPR034240', NULL, 'eIF3G, RNA recognition motif', 'eIF3G_RRM', 3, NULL),
(7123, NULL, 'IPR007292', NULL, 'Nuclear fusion protein Kar5', 'Nuclear_fusion_Kar5', 4, NULL),
(7124, NULL, 'IPR007073', NULL, 'RNA polymerase Rpb1, domain 7', 'RNA_pol_Rpb1_7', 3, NULL),
(7125, NULL, 'IPR002981', NULL, 'Sodium:neurotransmitter symporter, GABA, GAT-2', 'Na/ntran_symport_GABA_GAT2', 4, NULL),
(7126, NULL, 'IPR015915', NULL, 'Kelch-type beta propeller', 'Kelch-typ_b-propeller', 5, NULL),
(7127, NULL, 'IPR001397', NULL, '5-Hydroxytryptamine 5A receptor', '5HT5A_rcpt', 4, NULL),
(7128, NULL, 'IPR008205', NULL, 'Geranylgeranylglyceryl phosphate synthase/Heptaprenylglyceryl phosphate synthase', 'GGGP_HepGP_synthase', 4, NULL),
(7129, NULL, 'IPR004457', NULL, 'Zinc finger, ZPR1-type', 'Znf_ZPR1', 3, NULL),
(7130, NULL, 'IPR008179', NULL, 'Phosphoribosyl-ATP pyrophosphohydrolase', 'HisE', 4, NULL),
(7131, NULL, 'IPR012845', NULL, 'RNA polymerase sigma factor, FliA/WhiG', 'RNA_pol_sigma_FliA_WhiG', 4, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(7132, NULL, 'IPR003971', NULL, 'Potassium channel, voltage dependent, Kv9', 'K_chnl_volt-dep_Kv9', 4, NULL),
(7133, NULL, 'IPR003970', NULL, 'Potassium channel, voltage dependent, Kv8.1', 'K_chnl_volt-dep_Kv8.1', 4, NULL),
(7134, NULL, 'IPR008173', NULL, 'Adenylyl cyclase CyaB', 'Adenylyl_cyclase_CyaB', 4, NULL),
(7135, NULL, 'IPR034210', NULL, 'Cytochrome c oxidase subunit 2, C-terminal', 'CcO_II_C', 3, NULL),
(7136, NULL, 'IPR007287', NULL, 'Sof1-like protein', 'Sof1', 3, NULL),
(7137, NULL, 'IPR014404', NULL, 'A-agglutinin-binding subunit Aga2', 'Aga2', 4, NULL),
(7138, NULL, 'IPR008142', NULL, 'Alanine dehydrogenase/NAD(P) transhydrogenase, conserved site-1', 'AlaDH/PNT_CS1', 2, NULL),
(7139, NULL, 'IPR000726', NULL, 'Glycoside hydrolase, family 19, catalytic', 'Glyco_hydro_19_cat', 3, NULL),
(7140, NULL, 'IPR006508', NULL, 'Pseudouridine synthase, RluA-like', 'PsdUridine_synth_RluA-like', 4, NULL),
(7141, NULL, 'IPR001374', NULL, 'R3H domain', 'R3H_dom', 3, NULL),
(7142, NULL, 'IPR004850', NULL, 'NtA (N-terminal agrin) domain', 'NtA_dom', 3, NULL),
(7143, NULL, 'IPR005410', NULL, 'Two pore domain potassium channel, THIK', '2pore_dom_K_chnl_THIK', 4, NULL),
(7144, NULL, 'IPR003973', NULL, 'Potassium channel, voltage dependent, Kv2', 'K_chnl_volt-dep_Kv2', 4, NULL),
(7145, NULL, 'IPR001348', NULL, 'ATP phosphoribosyltransferase HisG', 'ATP_PRibTrfase_HisG', 4, NULL),
(7146, NULL, 'IPR004431', NULL, '3-isopropylmalate dehydratase, small subunit', '3-IsopropMal_deHydase_ssu', 4, NULL),
(7147, NULL, 'IPR008138', NULL, 'Saposin B type, region 2', 'SapB_2', 3, NULL),
(7148, NULL, 'IPR003013', NULL, 'Erythropoietin', 'Erythroptn', 4, NULL),
(7149, NULL, 'IPR012173', NULL, 'U3 small nucleolar ribonucleoprotein complex, subunit Mpp10', 'Mpp10', 4, NULL),
(7150, NULL, 'IPR001375', NULL, 'Peptidase S9, prolyl oligopeptidase, catalytic domain', 'Peptidase_S9', 3, NULL),
(7151, NULL, 'IPR012177', NULL, 'Thiamine triphosphatase, eukaryotes', 'ThTPase_euk', 4, NULL),
(7152, NULL, 'IPR034199', NULL, 'CELF1/2, RNA recognition motif 3', 'CELF1/2_RRM3', 3, NULL),
(7153, NULL, 'IPR005400', NULL, 'Potassium channel, voltage-dependent, beta subunit, KCNAB1', 'K_chnl_volt-dep_bsu_KCNAB1', 4, NULL),
(7154, NULL, 'IPR002976', NULL, 'Plant G-protein, alpha subunit', 'Plant_Gprotein_alpha', 4, NULL),
(7155, NULL, 'IPR014709', NULL, 'Glutathione synthase, C-terminal, eukaryotic', 'Glutathione_synthase_C_euk', 5, NULL),
(7156, NULL, 'IPR003963', NULL, 'Bi-component toxin, staphylococci', 'Bi-component_toxin_staph', 4, NULL),
(7157, NULL, 'IPR015414', NULL, 'Transmembrane protein TMEM64', 'TMEM64', 4, NULL),
(7158, NULL, 'IPR004858', NULL, 'Multigene family 505', 'MGF_505', 4, NULL),
(7159, NULL, 'IPR005141', NULL, 'eRF1 domain 2', 'eRF1_2', 3, NULL),
(7160, NULL, 'IPR012847', NULL, 'Sucrose phosphatase, plant/cyanobacteria', 'Sucrose_phosphatase_pln/cyn', 4, NULL),
(7161, NULL, 'IPR003967', NULL, 'Potassium channel, voltage-dependent, ERG', 'K_chnl_volt-dep_ERG', 4, NULL),
(7162, NULL, 'IPR015425', NULL, 'Formin, FH2 domain', 'FH2_Formin', 3, NULL),
(7163, NULL, 'IPR012178', NULL, 'Replication factor C subunit 1', 'RFC1', 4, NULL),
(7164, NULL, 'IPR015878', NULL, 'S-adenosyl-L-homocysteine hydrolase, NAD binding domain', 'Ado_hCys_hydrolase_NAD-bd', 3, NULL),
(7165, NULL, 'IPR008175', NULL, 'Galanin precursor', 'Galanin_pre', 4, NULL),
(7166, NULL, 'IPR015917', NULL, 'Peptidase C14A, caspase catalytic domain', 'Pept_C14A', 3, NULL),
(7167, NULL, 'IPR013083', NULL, 'Zinc finger, RING/FYVE/PHD-type', 'Znf_RING/FYVE/PHD', 5, NULL),
(7168, NULL, 'IPR002985', NULL, 'Arginine decarboxylase', 'Arg_decrbxlase', 4, NULL),
(7169, NULL, 'IPR034244', NULL, 'Rrt5, RNA recognition motif 1', 'Rrt5_RRM1', 3, NULL),
(7170, NULL, 'IPR023711', NULL, 'Transcription regulator HTH, UlaR', 'Tscrpt_reg_HTH_UlaR', 4, NULL),
(7171, NULL, 'IPR008160', NULL, 'Collagen triple helix repeat', 'Collagen', 7, NULL),
(7172, NULL, 'IPR003540', NULL, 'ADP ribosyltransferase', 'ADP-ribosyltransferase', 3, NULL),
(7173, NULL, 'IPR013507', NULL, 'DNA mismatch repair protein,  S5 domain 2-like', 'DNA_mismatch_S5_2-like', 3, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(7174, NULL, 'IPR007075', NULL, 'RNA polymerase Rpb1, domain 6', 'RNA_pol_Rpb1_6', 3, NULL),
(7175, NULL, 'IPR001399', NULL, 'VP6 blue-tongue virus inner capsid protein', 'Orbi_VP6', 4, NULL),
(7176, NULL, 'IPR003552', NULL, 'Claudin-7', 'Claudin7', 4, NULL),
(7177, NULL, 'IPR003985', NULL, 'Neurotensin type 1 receptor', 'NT1_rcpt', 4, NULL),
(7178, NULL, 'IPR012167', NULL, 'Cyclin, epsilonretrovirus', 'Cyclin_epsilonretrovir', 4, NULL),
(7179, NULL, 'IPR004441', NULL, 'RNA methyltransferase TrmH family', 'rRNA_MeTrfase_TrmH', 4, NULL),
(7180, NULL, 'IPR004853', NULL, 'Sugar phosphate transporter domain', 'Sugar_P_trans_dom', 3, NULL),
(7181, NULL, 'IPR007267', NULL, 'GtrA-like protein', 'GtrA', 3, NULL),
(7182, NULL, 'IPR008147', NULL, 'Glutamine synthetase, N-terminal domain', 'Gln_synt_N', 3, NULL),
(7183, NULL, 'IPR004872', NULL, 'Lipoprotein NlpA family', 'Lipoprotein_NlpA', 4, NULL),
(7184, NULL, 'IPR008189', NULL, 'rRNA small subunit methyltransferase I', 'rRNA_ssu_MeTfrase_I', 4, NULL),
(7185, NULL, 'IPR034648', NULL, 'CELF-3/4/5/6, RNA recognition motif 1', 'CELF3/4/5/6_RRM1', 3, NULL),
(7186, NULL, 'IPR003942', NULL, 'Left- Right determination factor', 'LRDF', 4, NULL),
(7187, NULL, 'IPR007288', NULL, 'Influenzavirus B, glycoprotein NB', 'InfluenzaB_glycoprotein_NB', 4, NULL),
(7188, NULL, 'IPR005418', NULL, 'Tight junction protein ZO-1', 'ZO-1', 4, NULL),
(7189, NULL, 'IPR003943', NULL, 'Protease-activated receptor 3', 'Prot_act_rcpt_3', 4, NULL),
(7190, NULL, 'IPR001406', NULL, 'Pseudouridine synthase I, TruA', 'PsdUridine_synth_TruA', 4, NULL),
(7191, NULL, 'IPR004458', NULL, 'Translation initiation factor 2, beta subunit', 'TIF2_bsu_arc', 4, NULL),
(7192, NULL, 'IPR003975', NULL, 'Potassium channel, voltage dependent, Kv4', 'K_chnl_volt-dep_Kv4', 4, NULL),
(7193, NULL, 'IPR001343', NULL, 'RTX calcium-binding nonapeptide repeat', 'Hemolysn_Ca-bd', 7, NULL),
(7194, NULL, 'IPR004416', NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', 'MnmG', 4, NULL),
(7195, NULL, 'IPR004419', NULL, 'Peptidase A31, hydrogenase expression/formation protein', 'Pept_A31_hyd_express', 4, NULL),
(7196, NULL, 'IPR015888', NULL, 'L-fucose isomerase, C-terminal', 'Fuc_isomerase_C', 3, NULL),
(7197, NULL, 'IPR007269', NULL, 'Isoprenylcysteine carboxyl methyltransferase', 'ICMT_MeTrfase', 4, NULL),
(7198, NULL, 'IPR005399', NULL, 'Potassium channel, voltage-dependent, beta subunit, KCNAB-related', 'K_chnl_volt-dep_bsu_KCNAB-rel', 4, NULL),
(7199, NULL, 'IPR002988', NULL, 'Protein G-related albumin-binding (GA) module', 'GA_module', 3, NULL),
(7200, NULL, 'IPR012171', NULL, 'Fatty acid desaturase', 'Fatty_acid_desaturase', 4, NULL),
(7201, NULL, 'IPR005126', NULL, 'NapC/NirT cytochrome c, N-terminal', 'NapC/NirT_cyt_c_N', 3, NULL),
(7202, NULL, 'IPR004471', NULL, 'Branched-chain amino acid transport, AzlC', 'Brnchd-chn_aa_trnsp_AzlC', 4, NULL),
(7203, NULL, 'IPR015415', NULL, 'Vps4 oligomerisation, C-terminal', 'Vps4_C', 3, NULL),
(7204, NULL, 'IPR003979', NULL, 'Tropoelastin', 'Tropoelastin', 4, NULL),
(7205, NULL, 'IPR014395', NULL, 'Penicillin/GL-7-ACA/AHL acylase', 'Pen/GL7ACA/AHL_acylase', 4, NULL),
(7206, NULL, 'IPR008148', NULL, 'DNA photolyase class 2', 'DNA_photolyase_2', 4, NULL),
(7207, NULL, 'IPR008181', NULL, 'Deoxyuridine triphosphate nucleotidohydrolase', 'dUTPase', 4, NULL),
(7208, NULL, 'IPR001342', NULL, 'Homoserine dehydrogenase, catalytic', 'HDH_cat', 3, NULL),
(7209, NULL, 'IPR007276', NULL, 'Nucleolar protein 14', 'Nop14', 4, NULL),
(7210, NULL, 'IPR014727', NULL, 'DNA topoisomerase I, catalytic core, alpha/beta subdomain', 'TopoI_cat_a/b-sub_euk', 5, NULL),
(7211, NULL, 'IPR004468', NULL, 'CTP synthase', 'CTP_synthase', 4, NULL),
(7212, NULL, 'IPR007076', NULL, 'TfoX, N-terminal', 'TfoX_N', 3, NULL),
(7213, NULL, 'IPR002989', NULL, 'Mycobacterial pentapeptide repeat', 'Mycobac_pentapep', 7, NULL),
(7214, NULL, 'IPR015419', NULL, 'CTAG/Pcc1 family', 'CTAG/Pcc1', 4, NULL),
(7215, NULL, 'IPR003939', NULL, 'Transforming growth factor beta-1 proprotein', 'TGFb1', 4, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(7216, NULL, 'IPR004417', NULL, 'Methylenetetrahydrofolate--tRNA-(uracil-5-)-methyltransferase TrmFO', 'TrmFO', 4, NULL),
(7217, NULL, 'IPR004469', NULL, 'Phosphoserine phosphatase', 'PSP', 4, NULL),
(7218, NULL, 'IPR015879', NULL, 'Aromatic-ring-hydroxylating dioxygenase, alpha subunit, C-terminal domain', 'Ring_hydroxy_dOase_asu_C_dom', 3, NULL),
(7219, NULL, 'IPR000033', NULL, 'LDLR class B repeat', 'LDLR_classB_rpt', 7, NULL),
(7220, NULL, 'IPR015884', NULL, 'Malic enzyme, conserved site', 'Malic_enzyme_CS', 2, NULL),
(7221, NULL, 'IPR008183', NULL, 'Aldose 1-/Glucose-6-phosphate 1-epimerase', 'Aldose_1/G6P_1-epimerase', 4, NULL),
(7222, NULL, 'IPR003008', NULL, 'Tubulin/FtsZ, GTPase domain', 'Tubulin_FtsZ_GTPase', 3, NULL),
(7223, NULL, 'IPR035080', NULL, 'Lacto-N-biose phosphorylase-like, N-terminal TIM barrel domain', 'Lact_bio_phlase-like_N', 3, NULL),
(7224, NULL, 'IPR007070', NULL, 'GPI ethanolamine phosphate transferase 1', 'GPI_EtnP_transferase_1', 4, NULL),
(7225, NULL, 'IPR005413', NULL, 'Low calcium response V antigen', 'LowCa_resp_V_Ag', 4, NULL),
(7226, NULL, 'IPR008158', NULL, 'Protein translocase SEC61 complex,  gamma subunit', 'Translocase_Sec61-g', 4, NULL),
(7227, NULL, 'IPR003982', NULL, 'Leukotriene B4 type 2 receptor', 'Leukotriene_B4_typ-2_rcpt', 4, NULL),
(7228, NULL, 'IPR004871', NULL, 'Cleavage/polyadenylation specificity factor, A subunit, C-terminal', 'Cleavage/polyA-sp_fac_asu_C', 3, NULL),
(7229, NULL, 'IPR003958', NULL, 'Transcription factor CBF/NF-Y/archaeal histone domain', 'CBFA_NFYB_domain', 3, NULL),
(7230, NULL, 'IPR003954', NULL, 'RNA recognition motif domain, eukaryote', 'RRM_dom_euk', 3, NULL),
(7231, NULL, 'IPR015416', NULL, 'Zinc finger, H2C2-type, histone UAS binding', 'Znf_H2C2_histone_UAS-bd', 3, NULL),
(7232, NULL, 'IPR004437', NULL, 'ParB/RepB/Spo0J partition protein', 'ParB/RepB/Spo0J', 3, NULL),
(7233, NULL, 'IPR014403', NULL, 'Vegetative storage protein/acid phosphatase', 'APS1/VSP', 4, NULL),
(7234, NULL, 'IPR002979', NULL, 'Anion exchange protein 3', 'Anion_exchange_3', 4, NULL),
(7235, NULL, 'IPR031358', NULL, 'Stealth protein CR1, conserved region 1', 'Stealth_CR1', 3, NULL),
(7236, NULL, 'IPR008203', NULL, 'AF2212-like', 'AF2212-like', 4, NULL),
(7237, NULL, 'IPR008174', NULL, 'Galanin', 'Galanin', 3, NULL),
(7238, NULL, 'IPR008146', NULL, 'Glutamine synthetase, catalytic domain', 'Gln_synth_cat_dom', 3, NULL),
(7239, NULL, 'IPR003535', NULL, 'Intimin/invasin bacterial adhesion mediator protein', 'Intimin/invasin_bac', 4, NULL),
(7240, NULL, 'IPR003977', NULL, 'E3 ubiquitin-protein ligase parkin', 'Parkin', 4, NULL),
(7241, NULL, 'IPR004869', NULL, 'Membrane transport protein MMPL domain', 'MMPL_dom', 3, NULL),
(7242, NULL, 'IPR002980', NULL, 'Sodium:neurotransmitter symporter, GABA, GAT-1', 'Na/ntran_symport_GABA_GAT1', 4, NULL),
(7243, NULL, 'IPR007273', NULL, 'SCAMP', 'SCAMP', 4, NULL),
(7244, NULL, 'IPR014041', NULL, 'ESCRT-II complex, Vps25 subunit, N-terminal winged helix', 'ESCRT-II_cplx_Vps25-sub_N', 5, NULL),
(7245, NULL, 'IPR004881', NULL, 'Ribosome biogenesis GTPase RsgA', 'Ribosome_biogen_GTPase_RsgA', 4, NULL),
(7246, NULL, 'IPR007277', NULL, 'Svp26/Tex261', 'Svp26/Tex261', 4, NULL),
(7247, NULL, 'IPR004883', NULL, 'Lateral organ boundaries, LOB', 'LOB', 3, NULL),
(7248, NULL, 'IPR008166', NULL, 'Glycosyltransferase family 92', 'Glyco_transf_92', 4, NULL),
(7249, NULL, 'IPR034660', NULL, 'DinB/YfiT-like putative metalloenzymes', 'DinB/YfiT-like', 5, NULL),
(7250, NULL, 'IPR004462', NULL, 'Desulfoferrodoxin, N-terminal domain', 'Desulfoferrodoxin_N', 3, NULL),
(7251, NULL, 'IPR004480', NULL, 'Monothiol glutaredoxin-related', 'Monothiol_GRX-rel', 4, NULL),
(7252, NULL, 'IPR015418', NULL, 'Chromatin modification-related protein Eaf6', 'Eaf6', 4, NULL),
(7253, NULL, 'IPR005129', NULL, 'SIMIBI class G3E GTPase, ArgK/MeaB', 'GTPase_ArgK', 4, NULL),
(7254, NULL, 'IPR023726', NULL, 'Threonine/serine transporter TdcC', 'Thr/Ser_transpt_TdcC', 4, NULL),
(7255, NULL, 'IPR008201', NULL, 'Ribonuclease HepT-like', 'HepT-like', 4, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(7256, NULL, 'IPR001408', NULL, 'G-protein alpha subunit, group I', 'Gprotein_alpha_I', 4, NULL),
(7257, NULL, 'IPR001344', NULL, 'Chlorophyll A-B binding protein, plant and chromista', 'Chloro_AB-bd_pln', 4, NULL),
(7258, NULL, 'IPR005411', NULL, 'Claudin-2', 'Claudin2', 4, NULL),
(7259, NULL, 'IPR005398', NULL, 'Tubby, N-terminal', 'Tubby_N', 3, NULL),
(7260, NULL, 'IPR012148', NULL, 'Aromatic prenyltransferase DMATS-type, fungi', 'DMATS-type_fun', 4, NULL),
(7261, NULL, 'IPR003953', NULL, 'FAD-dependent oxidoreductase 2, FAD binding domain', 'FAD-binding_2', 3, NULL),
(7262, NULL, 'IPR008193', NULL, 'DNA-directed RNA polymerase Rpb11, 13-16kDa subunit, conserved site', 'RNA_pol_Rpb11_13-16kDa_CS', 2, NULL),
(7263, NULL, 'IPR003544', NULL, 'Cytochrome c-type biogenesis protein CcmB', 'Cyt_c_biogenesis_CcmB', 4, NULL),
(7264, NULL, 'IPR015886', NULL, 'DNA glycosylase/AP lyase, H2TH DNA-binding', 'DNA_glyclase/AP_lyase_DNA-bd', 3, NULL),
(7265, NULL, 'IPR004460', NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit alpha', 'CDHA', 4, NULL),
(7266, NULL, 'IPR023706', NULL, 'Para-hydroxybenzoic acid efflux pump, subunit AaeB', 'PHBA_efflux_pump_AaeB', 4, NULL),
(7267, NULL, 'IPR034695', NULL, 'Baseplate wedge protein gp10', 'BP10_T4', 4, NULL),
(7268, NULL, 'IPR006506', NULL, 'Conserved hypothetical protein CHP01619', 'CHP01619', 4, NULL),
(7269, NULL, 'IPR015424', NULL, 'Pyridoxal phosphate-dependent transferase', 'PyrdxlP-dep_Trfase', 5, NULL),
(7270, NULL, 'IPR023680', NULL, 'Purine ribonucleoside efflux pump, NepI', 'MFS_NepI', 4, NULL),
(7271, NULL, 'IPR002974', NULL, 'Cytochrome P450, E-class, CYP52', 'Cyt_P450_E_CYP52', 4, NULL),
(7272, NULL, 'IPR034247', NULL, 'Rrt5, RNA recognition motif 2', 'Rrt5_RRM2', 3, NULL),
(7273, NULL, 'IPR001360', NULL, 'Glycoside hydrolase family 1', 'Glyco_hydro_1', 4, NULL),
(7274, NULL, 'IPR002999', NULL, 'Tudor domain', 'Tudor', 3, NULL),
(7275, NULL, 'IPR004434', NULL, 'Isocitrate dehydrogenase NAD-dependent', 'Isocitrate_DH_NAD', 4, NULL),
(7276, NULL, 'IPR005421', NULL, 'Voltage-dependent calcium channel, gamma-1 subunit', 'VDCC_g1su', 4, NULL),
(7277, NULL, 'IPR003966', NULL, 'Prothrombin/thrombin', 'Prothrombin/thrombin', 4, NULL),
(7278, NULL, 'IPR004459', NULL, 'Cobyric acid synthase CobQ', 'CobQ_synth', 4, NULL),
(7279, NULL, 'IPR007295', NULL, 'Domain of unknown function DUF402', 'DUF402', 3, NULL),
(7280, NULL, 'IPR012147', NULL, 'Phosphate acetyl/butyryltransferase', 'P_Ac_Bu_trans', 4, NULL),
(7281, NULL, 'IPR001351', NULL, 'Ribosomal protein S3, C-terminal', 'Ribosomal_S3_C', 3, NULL),
(7282, NULL, 'IPR014392', NULL, 'Protein-tyrosine phosphatase, non-receptor type-14/21', 'PTP_non-rcpt_14/21', 4, NULL),
(7283, NULL, 'IPR002983', NULL, 'Sodium:neurotransmitter symporter, betaine', 'Na/ntran_symport_betaine', 4, NULL),
(7284, NULL, 'IPR004421', NULL, 'Carbamoyltransferase, HypF-type', 'Carbamoyltransferase_HypF', 4, NULL),
(7285, NULL, 'IPR004864', NULL, 'Late embryogenesis abundant protein, LEA_2 subgroup', 'LEA_2', 3, NULL),
(7286, NULL, 'IPR035890', NULL, 'Anti-sigma-28 factor FlgM superfamily', 'Anti-sigma-28_factor_FlgM_sf', 5, NULL),
(7287, NULL, 'IPR003950', NULL, 'Potassium channel, voltage-dependent, ELK', 'K_chnl_volt-dep_ELK', 4, NULL),
(7288, NULL, 'IPR024670', NULL, 'B-cell lymphoma 9, beta-catenin binding domain', 'BCL9_beta-catenin-bd_dom', 3, NULL),
(7289, NULL, 'IPR008187', NULL, 'Vpu protein', 'Vpu', 4, NULL),
(7290, NULL, 'IPR012152', NULL, 'Protein-tyrosine phosphatase, non-receptor type-6, -11', 'Tyr_Pase_non-rcpt_typ-6/11', 4, NULL),
(7291, NULL, 'IPR003537', NULL, 'Type III secretion system effector protein YopE-like', 'YopE-like', 4, NULL),
(7292, NULL, 'IPR003945', NULL, 'NADH-quinone oxidoreductase, chain 5-like', 'NU5C-like', 4, NULL),
(7293, NULL, 'IPR034236', NULL, 'Caa3-type Cytochrome c oxidase subunit II, cupredoxin domain', 'CuRO_CcO_Caa3_II', 3, NULL),
(7294, NULL, 'IPR034461', NULL, 'Adropin', 'Adropin', 4, NULL),
(7295, NULL, 'IPR004473', NULL, 'Restriction endonuclease, type I, HsdR', 'Restrct_endonuc_typeI_HsdR', 4, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(7296, NULL, 'IPR034444', NULL, 'NADH-ubiquinone oxidoreductase 17.8kDa subunit', 'Nuo17.8', 4, NULL),
(7297, NULL, 'IPR004852', NULL, 'Di-haem cytochrome c peroxidase', 'Di-haem_cyt_c_peroxidsae', 3, NULL),
(7298, NULL, 'IPR034531', NULL, 'Methylation of yatakemycin, YtkT', 'Methylation_of_yatakemycin', 4, NULL),
(7299, NULL, 'IPR023227', NULL, 'S-adenosyl-l-methionine hydroxide adenosyltransferase, C-terminal domain superfamily', 'SAM_OH_AdoTrfase_C_sf', 5, NULL),
(7300, NULL, 'IPR023687', NULL, 'Oxaloacetate decarboxylase, bacterial', 'Oxaloacetate_deCOase_bac', 4, NULL),
(7301, NULL, 'IPR003989', NULL, 'Vascular cell adhesion molecule-1', 'VCAM-1', 4, NULL),
(7302, NULL, 'IPR004454', NULL, 'HD-related protein', 'HD-related', 4, NULL),
(7303, NULL, 'IPR013765', NULL, 'DNA recombination and repair protein RecA', 'DNA_recomb/repair_RecA', 4, NULL),
(7304, NULL, 'IPR001394', NULL, 'Peptidase C19, ubiquitin carboxyl-terminal hydrolase', 'Peptidase_C19_UCH', 3, NULL),
(7305, NULL, 'IPR008195', NULL, 'Ribosomal protein L34Ae', 'Ribosomal_L34Ae', 4, NULL),
(7306, NULL, 'IPR004420', NULL, 'Peptidase A31, hydrogenase maturation protease HycI', 'Pept_A31_hyd_mat_HycI', 4, NULL),
(7307, NULL, 'IPR004461', NULL, 'CO dehydrogenase/acetyl-CoA synthase complex beta subunit', 'CO_DH/Ac-CoA_synth_bsu', 4, NULL),
(7308, NULL, 'IPR002987', NULL, 'Sodium/calcium exchanger, isoform 1', 'NaCa_exhngr1', 4, NULL),
(7309, NULL, 'IPR004875', NULL, 'DDE superfamily endonuclease domain', 'DDE_SF_endonuclease_dom', 3, NULL),
(7310, NULL, 'IPR023699', NULL, 'Transcription activator HTH, RhaR', 'Tscrpt_act_RhaR', 4, NULL),
(7311, NULL, 'IPR014751', NULL, 'DNA repair protein XRCC4-like, C-terminal', 'XRCC4-like_C', 5, NULL),
(7312, NULL, 'IPR004882', NULL, 'Luc7-related', 'Luc7-rel', 4, NULL),
(7313, NULL, 'IPR015412', NULL, 'Autophagy-related protein 2/VPS13, C-terminal', 'Atg2/VPS13_C', 3, NULL),
(7314, NULL, 'IPR005127', NULL, 'Giardia variant-specific surface protein', 'Giardia_VSP', 4, NULL),
(7315, NULL, 'IPR007272', NULL, 'Sulphur transport domain', 'Sulf_transp', 3, NULL),
(7316, NULL, 'IPR005130', NULL, 'Serine dehydratase-like, alpha subunit', 'Ser_deHydtase-like_asu', 3, NULL),
(7317, NULL, 'IPR007268', NULL, 'Rad9/Ddc1', 'Rad9/Ddc1', 4, NULL),
(7318, NULL, 'IPR004855', NULL, 'Transcription factor IIA, alpha/beta subunit', 'TFIIA_asu/bsu', 4, NULL),
(7319, NULL, 'IPR005391', NULL, 'Neuromedin U receptor, type 1', 'NeuromedU_rcpt_1', 4, NULL),
(7320, NULL, 'IPR005123', NULL, 'Oxoglutarate/iron-dependent dioxygenase', 'Oxoglu/Fe-dep_dioxygenase', 3, NULL),
(7321, NULL, 'IPR023721', NULL, 'Multidrug resistance protein MdtD', 'Multi-R_MdtD', 4, NULL),
(7322, NULL, 'IPR006505', NULL, 'Phage nucleotide-binding protein', 'Phage_nucleotide-bp', 4, NULL),
(7323, NULL, 'IPR005135', NULL, 'Endonuclease/exonuclease/phosphatase', 'Endo/exonuclease/phosphatase', 3, NULL),
(7324, NULL, 'IPR016174', NULL, 'Di-haem cytochrome, transmembrane', 'Di-haem_cyt_TM', 5, NULL),
(7325, NULL, 'IPR004443', NULL, 'YjeF N-terminal domain', 'YjeF_N_dom', 3, NULL),
(7326, NULL, 'IPR004866', NULL, 'Chitobiase/beta-hexosaminidases, N-terminal domain', 'CHB/HEX_N_dom', 3, NULL),
(7327, NULL, 'IPR005419', NULL, 'Tight junction protein ZO-2', 'ZO-2', 4, NULL),
(7328, NULL, 'IPR007078', NULL, 'Haem exporter protein D (CcmD)', 'Haem_export_protD_CcmD', 4, NULL),
(7329, NULL, 'IPR035891', NULL, 'CheY-binding domain of CheA', 'CheY-binding_CheA', 5, NULL),
(7330, NULL, 'IPR004435', NULL, 'Molybdopterin-guanine dinucleotide biosynthesis protein B (MobB) domain', 'MobB_dom', 3, NULL),
(7331, NULL, 'IPR013499', NULL, 'DNA topoisomerase I, eukaryotic-type', 'TopoI_euk', 3, NULL),
(7332, NULL, 'IPR007077', NULL, 'TfoX, C-terminal', 'TfoX_C', 3, NULL),
(7333, NULL, 'IPR003548', NULL, 'Claudin-1', 'Claudin1', 4, NULL),
(7334, NULL, 'IPR004429', NULL, 'Isopropylmalate dehydrogenase', 'Isopropylmalate_DH', 4, NULL),
(7335, NULL, 'IPR034696', NULL, 'Antiholin T4 type', 'RI_T4', 4, NULL),
(7336, NULL, 'IPR012156', NULL, 'Cold shock, CspA', 'Cold_shock_CspA', 4, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(7337, NULL, 'IPR014401', NULL, 'Ribosomal protein S6, eukaryotic', 'Ribosomal_S6_euk', 4, NULL),
(7338, NULL, 'IPR004476', NULL, 'Ribonuclease II/ribonuclease R', 'RNase_II/RNase_R', 4, NULL),
(7339, NULL, 'IPR012176', NULL, 'Bifunctional nitroreductase/nicotinate-nucleotide-dimethylbenzimidazole, phosphoribosyltransferase', 'NRdtase/NN_dMeBzImd_PRibTrfase', 4, NULL),
(7340, NULL, 'IPR006504', NULL, 'Transcriptional regulator Spx/MgsR', 'Tscrpt_reg_Spx/MgsR', 4, NULL),
(7341, NULL, 'IPR023770', NULL, '5-deoxy-glucuronate isomerase, Bacilli', 'IolB_Bacilli', 4, NULL),
(7342, NULL, 'IPR034643', NULL, 'Mitochondrial ribosomal protein S7, plants', 'RPS7_plant', 4, NULL),
(7343, NULL, 'IPR005134', NULL, 'Uncharacterised protein family UPF0114', 'UPF0114', 4, NULL),
(7344, NULL, 'IPR004870', NULL, 'Nucleoporin, Nup155-like', 'Nucleoporin_Nup155', 4, NULL),
(7345, NULL, 'IPR008200', NULL, 'Neuromedin U, C-terminal', 'NMU_C', 3, NULL),
(7346, NULL, 'IPR004868', NULL, 'DNA-directed DNA polymerase, family B, mitochondria/virus', 'DNA-dir_DNA_pol_B_mt/vir', 3, NULL),
(7347, NULL, 'IPR013992', NULL, 'Adenylate cyclase-associated CAP, N-terminal', 'Adenylate_cyclase-assoc_CAP_N', 3, NULL),
(7348, NULL, 'IPR005394', NULL, 'P2Y12 purinoceptor', 'P2Y12_rcpt', 4, NULL),
(7349, NULL, 'IPR003004', NULL, 'GspF/PilC family', 'GspF/PilC', 4, NULL),
(7350, NULL, 'IPR013085', NULL, 'U1-C, C2H2-type zinc finger', 'U1-CZ_Znf_C2H2', 3, NULL),
(7351, NULL, 'IPR003553', NULL, 'Claudin-9', 'Claudin9', 4, NULL),
(7352, NULL, 'IPR001350', NULL, 'G10D orphan receptor', 'G10D_rcpt', 4, NULL),
(7353, NULL, 'IPR014049', NULL, 'Glutathione synthase, N-terminal, eukaryotic', 'Glutathione_synthase_N_euk', 5, NULL),
(7354, NULL, 'IPR006507', NULL, 'Uncharacterised protein family UPF0283', 'UPF0283', 4, NULL),
(7355, NULL, 'IPR005393', NULL, 'XC chemokine receptor 1', 'Chemokine_XCR1', 4, NULL),
(7356, NULL, 'IPR023710', NULL, 'Probable phosphatase YcdX', 'Phosphatase_YcdX_put', 4, NULL),
(7357, NULL, 'IPR003940', NULL, 'Transforming growth factor beta-2 proprotein', 'TGFb2', 4, NULL),
(7358, NULL, 'IPR001359', NULL, 'Synapsin', 'Synapsin', 4, NULL),
(7359, NULL, 'IPR007278', NULL, 'Domain of unknown function DUF397', 'DUF397', 3, NULL),
(7360, NULL, 'IPR003938', NULL, 'Potassium channel, voltage-dependent, EAG/ELK/ERG', 'K_chnl_volt-dep_EAG/ELK/ERG', 4, NULL),
(7361, NULL, 'IPR004865', NULL, 'HSR domain', 'HSR_dom', 3, NULL),
(7362, NULL, 'IPR005392', NULL, 'Neuromedin U receptor, type 2', 'NeuromedU_rcpt_2', 4, NULL),
(7363, NULL, 'IPR000207', NULL, 'Alpha 2B adrenoceptor', 'ADRA2B_rcpt', 4, NULL),
(7364, NULL, 'IPR005131', NULL, 'Serine dehydratase beta chain', 'Ser_deHydtase_bsu', 3, NULL),
(7365, NULL, 'IPR004426', NULL, 'Conserved hypothetical protein CHP00062', 'CHP00062', 4, NULL),
(7366, NULL, 'IPR023697', NULL, 'Multidrug resistance protein MdtL', 'Multidrug-R_MdtL', 4, NULL),
(7367, NULL, 'IPR014402', NULL, 'Transcription factor, Skn7-like', 'Sig_transdc_resp-reg_Skn7', 4, NULL),
(7368, NULL, 'IPR015417', NULL, 'Glycine/sarcosine/betaine reductase complex, protein B, subunit alpha/ beta', 'Gly_reductase_pB_sua/b', 4, NULL),
(7369, NULL, 'IPR013524', NULL, 'Runt domain', 'Runt_dom', 3, NULL),
(7370, NULL, 'IPR008153', NULL, 'Gamma-adaptin ear (GAE) domain', 'GAE_dom', 3, NULL),
(7371, NULL, 'IPR003965', NULL, 'Fatty acid synthase', 'Fatty_acid_synthase', 3, NULL),
(7372, NULL, 'IPR007294', NULL, 'Protein of unknown function DUF401', 'DUF401', 4, NULL),
(7373, NULL, 'IPR004433', NULL, '2-succinyl-5-enolpyruvyl-6-hydroxy-3-cyclohexene-1-carboxylic-acid synthase', 'MenaQ_synth_MenD', 4, NULL),
(7374, NULL, 'IPR015869', NULL, 'Transcription antitermination protein, NusG, bacteria, conserved site', 'Transcrpt_antiterm_NusG_bac_CS', 2, NULL),
(7375, NULL, 'IPR005139', NULL, 'Peptide chain release factor', 'PCRF', 3, NULL),
(7376, NULL, 'IPR003980', NULL, 'Histamine H3 receptor', 'Histamine_H3_rcpt', 4, NULL),
(7377, NULL, 'IPR001404', NULL, 'Heat shock protein Hsp90 family', 'Hsp90_fam', 4, NULL),
(7378, NULL, 'IPR007282', NULL, 'NOT2/NOT3/NOT5, C-terminal', 'NOT2/3/5_C', 3, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(7379, NULL, 'IPR034681', NULL, 'Isochorismate synthase MenF', 'MenF', 4, NULL),
(7380, NULL, 'IPR001068', NULL, 'Adenosine A1 receptor', 'Adeno_A1_rcpt', 4, NULL),
(7381, NULL, 'IPR004414', NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit E', 'GatE', 4, NULL),
(7382, NULL, 'IPR017887', NULL, 'Transcription factor TCP subgroup', 'TF_TCP_subgr', 3, NULL),
(7383, NULL, 'IPR004884', NULL, 'Protein of unknown function DUF261', 'DUF261', 4, NULL),
(7384, NULL, 'IPR002993', NULL, 'Ornithine decarboxylase antizyme', 'ODC_AZ', 4, NULL),
(7385, NULL, 'IPR003969', NULL, 'Potassium channel, voltage dependent, Kv6', 'K_chnl_volt-dep_Kv6', 4, NULL),
(7386, NULL, 'IPR005409', NULL, 'Two pore domain potassium channel, TWIK-2', '2pore_dom_K_chnl_TWIK2', 4, NULL),
(7387, NULL, 'IPR023692', NULL, 'Multidrug resistance protein MdtG', 'Mutidrug-R_MdtG', 4, NULL),
(7388, NULL, 'IPR013514', NULL, 'Protein of unknown function DUF3199, YqbG', 'DUF3199_YqbG', 4, NULL),
(7389, NULL, 'IPR003961', NULL, 'Fibronectin type III', 'FN3_dom', 3, NULL),
(7390, NULL, 'IPR005404', NULL, 'Potassium channel, voltage dependent, Kv3.3', 'K_chnl_volt-dep_Kv3.3', 4, NULL),
(7391, NULL, 'IPR004464', NULL, 'Fructose-1,6-bisphosphatase class 2/Sedoheputulose-1,7-bisphosphatase', 'FBPase_class-2/SBPase', 4, NULL),
(7392, NULL, 'IPR034455', NULL, 'Biogenesis of lysosome-related organelles complex 1, subunit CNL1', 'CNL1', 4, NULL),
(7393, NULL, 'IPR024728', NULL, 'DNA polymerase type-Y, HhH motif', 'PolY_HhH_motif', 2, NULL),
(7394, NULL, 'IPR012159', NULL, 'Inner membrane protein YejM', 'YejM', 4, NULL),
(7395, NULL, 'IPR003539', NULL, 'Cytolethal distending toxin B', 'CD_toxinB', 4, NULL),
(7396, NULL, 'IPR008141', NULL, 'Alanine dehydrogenase', 'Ala_DH', 4, NULL),
(7397, NULL, 'IPR004424', NULL, '4-diphosphocytidyl-2C-methyl-D-erythritol kinase', 'IspE', 4, NULL),
(7398, NULL, 'IPR015421', NULL, 'Pyridoxal phosphate-dependent transferase, major domain', 'PyrdxlP-dep_Trfase_major', 5, NULL),
(7399, NULL, 'IPR003536', NULL, 'Translocated intimin receptor, central domain', 'Transloc_intimin_rcpt_cen_dom', 3, NULL),
(7400, NULL, 'IPR004477', NULL, 'ComEC/Rec2-related protein', 'ComEC_N', 3, NULL),
(7401, NULL, 'IPR004860', NULL, 'Homing endonuclease, LAGLIDADG', 'LAGLIDADG_2', 3, NULL),
(7402, NULL, 'IPR004418', NULL, 'Homoaconitase, mitochondrial', 'Homoaconitase_mito', 4, NULL),
(7403, NULL, 'IPR023727', NULL, 'Lysophospholipid transporter LplT', 'LysoPLipid__transptr_LplT', 4, NULL),
(7404, NULL, 'IPR003936', NULL, 'Peripheral myelin protein PMP22', 'PMP22', 4, NULL),
(7405, NULL, 'IPR003956', NULL, 'Transcription factor, NFYB/HAP3, conserved site', 'Transcrpt_fac_NFYB/HAP3_CS', 2, NULL),
(7406, NULL, 'IPR004445', NULL, 'Sodium/glutamate symport carrier protein GltS', 'GltS', 4, NULL),
(7407, NULL, 'IPR003991', NULL, 'Pertactin virulence factor family', 'Pertactin_virulence_factor', 4, NULL),
(7408, NULL, 'IPR004430', NULL, '3-isopropylmalate dehydratase, large subunit', '3-IsopropMal_deHydase_lsu', 4, NULL),
(7409, NULL, 'IPR004876', NULL, 'Corona nucleocapsid I', 'Corona_nucI', 4, NULL),
(7410, NULL, 'IPR003978', NULL, 'Thrombopoietin', 'Thrombopoietin', 4, NULL),
(7411, NULL, 'IPR007274', NULL, 'Ctr copper transporter', 'Cop_transporter', 4, NULL),
(7412, NULL, 'IPR001367', NULL, 'Iron dependent repressor, metal binding and dimerisation domain', 'Fe_dep_repressor', 3, NULL),
(7413, NULL, 'IPR013055', NULL, 'Tachykinin/Neurokinin-like, conserved site', 'Tachy_Neuro_lke_CS', 2, NULL),
(7414, NULL, 'IPR005397', NULL, 'Neuropeptide FF receptor, type 2', 'NPFF_rcpt_2', 4, NULL),
(7415, NULL, 'IPR003547', NULL, 'Serine/threonine protein kinase, yersinia-type', 'Ser/thr_kinase_yersinia-type', 4, NULL),
(7416, NULL, 'IPR004475', NULL, 'DNA polymerase II large subunit DP2', 'PolC_DP2', 4, NULL),
(7417, NULL, 'IPR001341', NULL, 'Aspartate kinase', 'Asp_kinase', 3, NULL),
(7418, NULL, 'IPR000496', NULL, 'Bradykinin receptor family', 'Brdyknn_rcpt', 4, NULL),
(7419, NULL, 'IPR001362', NULL, 'Glycoside hydrolase, family 32', 'Glyco_hydro_32', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(7420, NULL, 'IPR004481', NULL, 'Sodium/potassium/calcium exchanger', 'K/Na/Ca-exchanger', 4, NULL),
(7421, NULL, 'IPR002975', NULL, 'Fungal G-protein, alpha subunit', 'Fungi_Gprotein_alpha', 4, NULL),
(7422, NULL, 'IPR007275', NULL, 'YTH domain', 'YTH_domain', 3, NULL),
(7423, NULL, 'IPR002995', NULL, 'Surfeit locus 4', 'Surf4', 4, NULL),
(7424, NULL, 'IPR005420', NULL, 'Tight junction protein ZO-3', 'ZO-3', 4, NULL),
(7425, NULL, 'IPR003952', NULL, 'Fumarate reductase/succinate dehydrogenase, FAD-binding site', 'FRD_SDH_FAD_BS', 1, NULL),
(7426, NULL, 'IPR008150', NULL, 'Phytoene dehydrogenase, bacterial-type, conserved site', 'Phytoene_DH_bac_CS', 2, NULL),
(7427, NULL, 'IPR014748', NULL, 'Enoyl-CoA hydratase, C-terminal', 'Enoyl-CoA_hydra_C', 5, NULL),
(7428, NULL, 'IPR023766', NULL, 'D-phenylhydantoinase', 'D_phenylhydantoinase', 4, NULL),
(7429, NULL, 'IPR023709', NULL, 'Guanosine-5''-triphosphate,3''-diphosphate pyrophosphatase', 'Guo-5TP_3DP_PyrP', 4, NULL),
(7430, NULL, 'IPR004425', NULL, 'Conserved hypothetical protein CHP00061', 'CHP00061', 4, NULL),
(7431, NULL, 'IPR005417', NULL, 'Tight junction protein ZO', 'ZO', 4, NULL),
(7432, NULL, 'IPR007271', NULL, 'Nucleotide-sugar transporter', 'Nuc_sug_transpt', 4, NULL),
(7433, NULL, 'IPR013503', NULL, 'Circadian clock KaiC, bacteria', 'Circadian_KaiC_bact', 4, NULL),
(7434, NULL, 'IPR003986', NULL, 'Neurotensin type 2 receptor', 'NT2_rcpt', 4, NULL),
(7435, NULL, 'IPR017888', NULL, 'CYC/TB1, R domain', 'CYC/TB1_R_domain', 3, NULL),
(7436, NULL, 'IPR005395', NULL, 'Neuropeptide FF receptor family', 'NPFF_rcpt', 4, NULL),
(7437, NULL, 'IPR003964', NULL, 'Carbamate kinase', 'Carb_kinase', 4, NULL),
(7438, NULL, 'IPR005124', NULL, 'Vacuolar (H+)-ATPase G subunit', 'V-ATPase_G', 4, NULL),
(7439, NULL, 'IPR012153', NULL, 'Tyrosine-protein phosphatase non-receptor type 13', 'PTPN13', 4, NULL),
(7440, NULL, 'IPR005415', NULL, 'Type III secretion system, low calcium response, chaperone LcrH/SycD', 'T3SS_Ca_resp_chp_LcrH/SycD', 4, NULL),
(7441, NULL, 'IPR015882', NULL, 'Beta-hexosaminidase, bacterial type, N-terminal', 'HEX_bac_N', 3, NULL),
(7442, NULL, 'IPR004451', NULL, 'Conserved hypothetical protein CHP00270', 'CHP00270', 4, NULL),
(7443, NULL, 'IPR004465', NULL, 'Ribonucleotide reductase Class Ib, NrdI', 'RNR_NrdI', 4, NULL),
(7444, NULL, 'IPR013504', NULL, 'Methylamine/Aralkylamine dehydrogenase light chain, C-terminal domain', 'MADH/AADH_Ltc_C_dom', 3, NULL),
(7445, NULL, 'IPR015876', NULL, 'Acyl-CoA desaturase', 'Acyl-CoA_DS', 4, NULL),
(7446, NULL, 'IPR005137', NULL, 'Membrane complex biogenesis protein, BtpA family', 'BtpA', 4, NULL),
(7447, NULL, 'IPR035903', NULL, 'HesB-like domain superfamily', 'HesB-like_dom_sf', 5, NULL),
(7448, NULL, 'IPR004467', NULL, 'Orotate phosphoribosyl transferase domain', 'Or_phspho_trans_dom', 3, NULL),
(7449, NULL, 'IPR005389', NULL, 'OGR1 sphingosylphosphorylcholine receptor', 'OGR1_rcpt', 4, NULL),
(7450, NULL, 'IPR008176', NULL, 'Defensin, plant', 'Defensin_plant', 4, NULL),
(7451, NULL, 'IPR002984', NULL, 'Sodium:neurotransmitter symporter, creatine', 'Na/ntran_symport_creatine', 4, NULL),
(7452, NULL, 'IPR031359', NULL, 'NWD NACHT-NTPase, N-terminal', 'NACHT_N', 3, NULL),
(7453, NULL, 'IPR008145', NULL, 'Guanylate kinase/L-type calcium channel beta subunit', 'GK/Ca_channel_bsu', 3, NULL),
(7454, NULL, 'IPR008155', NULL, 'Amyloidogenic glycoprotein', 'Amyloid_glyco', 4, NULL),
(7455, NULL, 'IPR002994', NULL, 'Surfeit locus 1/Shy1', 'Surf1/Shy1', 4, NULL),
(7456, NULL, 'IPR003981', NULL, 'Leukotriene B4 receptor', 'Leukotriene_B4_rcpt', 4, NULL),
(7457, NULL, 'IPR015887', NULL, 'DNA glycosylase/AP lyase, zinc finger domain, DNA-binding site', 'DNA_glyclase_Znf_dom_DNA_BS', 1, NULL),
(7458, NULL, 'IPR003960', NULL, 'ATPase, AAA-type, conserved site', 'ATPase_AAA_CS', 2, NULL),
(7459, NULL, 'IPR004439', NULL, 'Isocitrate dehydrogenase NADP-dependent, dimeric, prokaryotic', 'Isocitrate_DH_NADP_dimer_prok', 4, NULL),
(7460, NULL, 'IPR004470', NULL, 'Zinc finger, ZPR1-type, subgroup', 'Znf_ZPR1-type_subgr', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(7461, NULL, 'IPR003541', NULL, 'Anthrax toxin, lethal/endema factor', 'Anthrax_toxin_lethal/edema', 4, NULL),
(7462, NULL, 'IPR004452', NULL, '4Fe-4S binding protein', '4Fe-4S-bd', 4, NULL),
(7463, NULL, 'IPR008162', NULL, 'Inorganic pyrophosphatase', 'Pyrophosphatase', 4, NULL),
(7464, NULL, 'IPR012160', NULL, 'Lipoteichoic acid synthase-like', 'LtaS-like', 4, NULL),
(7465, NULL, 'IPR034205', NULL, 'Nitrous-oxide reductase, C-terminal', 'N2OR_C', 3, NULL),
(7466, NULL, 'IPR004861', NULL, 'Atypical dual-specificity phosphatase Siw14-like', 'Siw14-like', 4, NULL),
(7467, NULL, 'IPR004474', NULL, 'Cell envelope-related transcriptional attenuator domain', 'LytR_CpsA_psr', 3, NULL),
(7468, NULL, 'IPR007290', NULL, 'Arv1 protein', 'Arv1', 4, NULL),
(7469, NULL, 'IPR008207', NULL, 'Signal transduction histidine kinase, phosphotransfer (Hpt) domain', 'Sig_transdc_His_kin_Hpt_dom', 3, NULL),
(7470, NULL, 'IPR005121', NULL, 'Ferrodoxin-fold anticodon-binding domain', 'Fdx_antiC-bd', 3, NULL),
(7471, NULL, 'IPR012165', NULL, 'Cytochrome-c3 hydrogenase, gamma subunit', 'Cyt_c3_hydrogenase_gsu', 4, NULL),
(7472, NULL, 'IPR014394', NULL, 'Coagulation factor XII/hepatocyte growth factor activator', 'Coagulation_fac_XII/HGFA', 4, NULL),
(7473, NULL, 'IPR003000', NULL, 'Sirtuin family', 'Sirtuin', 4, NULL),
(7474, NULL, 'IPR001347', NULL, 'SIS domain', 'SIS_dom', 3, NULL),
(7475, NULL, 'IPR013078', NULL, 'Histidine phosphatase superfamily, clade-1', 'His_Pase_superF_clade-1', 4, NULL),
(7476, NULL, 'IPR012175', NULL, 'Xanthine dehydrogenase, small subunit, bacteria', 'Xanth_DH_ssu_bac', 4, NULL),
(7477, NULL, 'IPR003948', NULL, 'Potassium channel, voltage dependent, KCNQ3', 'K_chnl_volt-dep_KCNQ3', 4, NULL),
(7478, NULL, 'IPR017872', NULL, 'Pyrimidine-nucleoside phosphorylase, conserved site', 'Pyrmidine_PPase_CS', 2, NULL),
(7479, NULL, 'IPR008164', NULL, 'Repeat of unknown function XGLTT', 'XGLTT_repeat', 7, NULL),
(7480, NULL, 'IPR008209', NULL, 'Phosphoenolpyruvate carboxykinase, GTP-utilising', 'PEP_carboxykinase_GTP', 4, NULL),
(7481, NULL, 'IPR003976', NULL, 'Two pore domain potassium channel, TREK', '2pore_dom_K_chnl_TREK', 4, NULL),
(7482, NULL, 'IPR003538', NULL, 'Gram-negative bacterial TonB protein', 'TonB', 4, NULL),
(7483, NULL, 'IPR001357', NULL, 'BRCT domain', 'BRCT_dom', 3, NULL),
(7484, NULL, 'IPR003935', NULL, 'Lens fibre membrane intrinsic protein', 'LMIP', 4, NULL),
(7485, NULL, 'IPR003974', NULL, 'Potassium channel, voltage dependent, Kv3', 'K_chnl_volt-dep_Kv3', 4, NULL),
(7486, NULL, 'IPR005128', NULL, 'Alpha-acetolactate decarboxylase', 'Acetolactate_a_deCO2ase', 4, NULL),
(7487, NULL, 'IPR003543', NULL, 'Macrophage scavenger receptor, Class A-I/II', 'SR-AI/II', 4, NULL),
(7488, NULL, 'IPR017964', NULL, 'DNA-directed DNA polymerase, family B, conserved site', 'DNA-dir_DNA_pol_B_CS', 2, NULL),
(7489, NULL, 'IPR034691', NULL, 'Endolysin lambda type', 'Endolysin_lambda_type', 4, NULL),
(7490, NULL, 'IPR012162', NULL, 'Polyribonucleotide nucleotidyltransferase', 'PNPase', 4, NULL),
(7491, NULL, 'IPR003551', NULL, 'Claudin-5', 'Claudin5', 4, NULL),
(7492, NULL, 'IPR003983', NULL, 'Leukotriene B4 type 1 receptor', 'Leukotriene_B4_typ-1_rcpt', 4, NULL),
(7493, NULL, 'IPR005408', NULL, 'Two pore domain potassium channel, TWIK family', '2pore_dom_K_chnl_TWIK', 4, NULL),
(7494, NULL, 'IPR004873', NULL, 'BURP domain', 'BURP_dom', 3, NULL),
(7495, NULL, 'IPR007074', NULL, 'LicD family', 'LicD_fam', 4, NULL),
(7496, NULL, 'IPR001356', NULL, 'Homeobox domain', 'Homeobox_dom', 3, NULL),
(7497, NULL, 'IPR008211', NULL, 'Laminin, N-terminal', 'Laminin_N', 3, NULL),
(7498, NULL, 'IPR012164', NULL, 'DNA-directed RNA polymerase subunit/transcription factor S', 'Rpa12/Rpb9/Rpc10/TFS', 4, NULL),
(7499, NULL, 'IPR007291', NULL, 'Capsid protein', 'Capsid_protein', 4, NULL),
(7500, NULL, 'IPR005414', NULL, 'Guanine nucleotide exchange factor SopE', 'SopE', 4, NULL),
(7501, NULL, 'IPR012346', NULL, 'p53/RUNT-type transcription factor, DNA-binding domain superfamily', 'p53/RUNT-type_TF_DNA-bd_sf', 5, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(7502, NULL, 'IPR008313', NULL, 'Metal-independent alpha-mannosidase', 'GH125', 4, NULL),
(7503, NULL, 'IPR023934', NULL, 'Luciferase-like monooxygenase, FMN-dependent, putative', 'LLM_FMN-dep_put', 4, NULL),
(7504, NULL, 'IPR008907', NULL, 'P25-alpha', 'P25-alpha', 4, NULL),
(7505, NULL, 'IPR023731', NULL, 'Global transcriptional regulator Spx', 'Spx', 4, NULL),
(7506, NULL, 'IPR008311', NULL, 'Uncharacterised conserved protein UCP028101', 'UCP028101', 4, NULL),
(7507, NULL, 'IPR008882', NULL, 'Procyclic acidic repetitive', 'Trypano_PARP', 4, NULL),
(7508, NULL, 'IPR011403', NULL, 'Pyrophosphate-dependent phosphofructokinase TM0289 type', 'PPi-PFK_TM0289', 4, NULL),
(7509, NULL, 'IPR018237', NULL, 'Myelin proteolipid protein PLP, conserved site', 'Myelin_PLP_CS', 2, NULL),
(7510, NULL, 'IPR008381', NULL, 'Succinate dehydrogenase assembly factor 3, mitochondrial', 'SDHAF3/Sdh7', 4, NULL),
(7511, NULL, 'IPR013727', NULL, 'Two-component sensor kinase, N-terminal', '2CSK_N', 3, NULL),
(7512, NULL, 'IPR014431', NULL, 'Tellurite resistance methyltransferase, TehB type-2', 'Tellurite-R_TehB-2', 4, NULL),
(7513, NULL, 'IPR015019', NULL, 'Ragulator complex protein LAMTOR3', 'LAMTOR3', 4, NULL),
(7514, NULL, 'IPR015050', NULL, 'Bypass of forespore C, C-terminal', 'BofC_C', 3, NULL),
(7515, NULL, 'IPR008894', NULL, 'Sugar 3,4-ketoisomerase QdtA, cupin domain', 'QdtA_cupin_dom', 3, NULL),
(7516, NULL, 'IPR023736', NULL, 'Antiholin-like protein LrgA', 'Antiholin-like_LrgA', 4, NULL),
(7517, NULL, 'IPR008905', NULL, 'Eukaryotic translation initiation factor 3 subunit C, N-terminal domain', 'EIF3C_N_dom', 3, NULL),
(7518, NULL, 'IPR013738', NULL, 'Beta-galactosidase trimerisation', 'Beta_galactosidase_Trimer', 3, NULL),
(7519, NULL, 'IPR015042', NULL, 'BPS (Between PH and SH2) domain', 'BPS-dom', 3, NULL),
(7520, NULL, 'IPR018214', NULL, 'Glutamyl-tRNA reductase, conserved site', 'GluRdtase_CS', 2, NULL),
(7521, NULL, 'IPR010927', NULL, 'Type IV conjugative transfer system protein TraH', 'T4SS_TraH', 4, NULL),
(7522, NULL, 'IPR009106', NULL, 'CART satiety factor', 'CART', 4, NULL),
(7523, NULL, 'IPR015894', NULL, 'Guanylate-binding protein, N-terminal', 'Guanylate-bd_N', 3, NULL),
(7524, NULL, 'IPR010302', NULL, 'U5-like protein, herpesvirus', 'U5-like_protein_herpesevirus', 4, NULL),
(7525, NULL, 'IPR008883', NULL, 'Ubiquitin E2 variant, N-terminal', 'UEV_N', 3, NULL),
(7526, NULL, 'IPR008379', NULL, 'Band 4.1, C-terminal', 'Band_4.1_C', 3, NULL),
(7527, NULL, 'IPR018197', NULL, 'Glycerate kinase, restriction-enzyme-like fold', 'Glycerate_kinase_RE-like', 5, NULL),
(7528, NULL, 'IPR009039', NULL, 'EAR', 'EAR', 7, NULL),
(7529, NULL, 'IPR014418', NULL, 'Putative type 4B encapsulin shell protein', 'ENCP4', 4, NULL),
(7530, NULL, 'IPR008326', NULL, 'Uncharacterised conserved protein UCP034852', 'UCP034852', 4, NULL),
(7531, NULL, 'IPR008895', NULL, 'Vps72/YL1 family', 'Vps72/YL1', 4, NULL),
(7532, NULL, 'IPR013962', NULL, 'DASH complex subunit Dam1', 'DASH_Dam1', 4, NULL),
(7533, NULL, 'IPR023149', NULL, 'Trans-aconitate 2-methyltransferase, C-terminal', 'Trans_acon_MeTrfase_C', 5, NULL),
(7534, NULL, 'IPR024702', NULL, 'Uncharacterised conserved protein YmfJ', 'Uncharacterised_YmfJ', 4, NULL),
(7535, NULL, 'IPR015048', NULL, 'Domain of unknown function DUF1899', 'DUF1899', 3, NULL),
(7536, NULL, 'IPR008312', NULL, 'Type VI secretion system sheath protein TssB1', 'T6SS_TssB1', 4, NULL),
(7537, NULL, 'IPR010266', NULL, 'NnrS', 'NnrS', 4, NULL),
(7538, NULL, 'IPR010273', NULL, 'Protein of unknown function DUF881', 'DUF881', 4, NULL),
(7539, NULL, 'IPR034702', NULL, 'Large tegument protein deneddylase', 'HSV_LTP', 4, NULL),
(7540, NULL, 'IPR015009', NULL, 'Vinculin-binding site-containing domain', 'Vinculin-bd_dom', 3, NULL),
(7541, NULL, 'IPR018206', NULL, 'Electron transfer flavoprotein subunit alpha, conserved site', 'ETF_asu_C_CS', 2, NULL),
(7542, NULL, 'IPR008388', NULL, 'V0 complex accessory subunit Ac45', 'Ac45_acc_su', 4, NULL),
(7543, NULL, 'IPR015005', NULL, 'Domain of unknown function DUF1854', 'DUF1854', 3, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(7544, NULL, 'IPR012341', NULL, 'Six-hairpin glycosidase-like superfamily', '6hp_glycosidase-like_sf', 5, NULL),
(7545, NULL, 'IPR008318', NULL, 'Uncharacterised conserved protein UCP030820', 'UCP030820', 4, NULL),
(7546, NULL, 'IPR015892', NULL, 'Carbonic anhydrase, prokaryotic-like, conserved site', 'Carbonic_anhydrase_CS', 2, NULL),
(7547, NULL, 'IPR014434', NULL, 'Monothiol glutaredoxin', 'Monothiol_GRX', 4, NULL),
(7548, NULL, 'IPR010929', NULL, 'CDR ABC transporter', 'PDR_CDR_ABC', 3, NULL),
(7549, NULL, 'IPR023929', NULL, 'Di-heme enzyme, MXAN0977', 'Di-heme_enz_MXAN0977', 4, NULL),
(7550, NULL, 'IPR012338', NULL, 'Beta-lactamase/transpeptidase-like', 'Beta-lactam/transpept-like', 5, NULL),
(7551, NULL, 'IPR008351', NULL, 'Mitogen-activated protein (MAP) kinase, JNK', 'MAPK_JNK', 4, NULL),
(7552, NULL, 'IPR018226', NULL, 'Barwin, conserved site', 'Barwin_CS', 2, NULL),
(7553, NULL, 'IPR011396', NULL, 'Uncharacterised conserved protein UCP030850', 'UCP030850', 4, NULL),
(7554, NULL, 'IPR015898', NULL, 'G-protein gamma-like domain', 'G-protein_gamma-like_dom', 3, NULL),
(7555, NULL, 'IPR010926', NULL, 'Class I myosin tail homology domain', 'Myosin_TH1', 3, NULL),
(7556, NULL, 'IPR013749', NULL, 'Pyridoxamine kinase/Phosphomethylpyrimidine kinase', 'PM/HMP-P_kinase-1', 3, NULL),
(7557, NULL, 'IPR013974', NULL, 'SAF domain', 'SAF', 3, NULL),
(7558, NULL, 'IPR008881', NULL, 'Trigger factor, ribosome-binding, bacterial', 'Trigger_fac_ribosome-bd_bac', 3, NULL),
(7559, NULL, 'IPR013758', NULL, 'DNA topoisomerase, type IIA, domain A, alpha-beta', 'Topo_IIA_A/C_ab', 5, NULL),
(7560, NULL, 'IPR009099', NULL, 'Beta-lactamase-inhibitor protein BLIP', 'Beta-lactamas_inhib', 4, NULL),
(7561, NULL, 'IPR013943', NULL, 'Mitochondrial protein Pet127', 'Pet127', 4, NULL),
(7562, NULL, 'IPR010931', NULL, 'Lactococcus lactis RepB, C-terminal', 'L_lactis_RepB_C', 3, NULL),
(7563, NULL, 'IPR008864', NULL, 'Nucleocapsid, Tenuivirus', 'Nucleocapsid_Tenuivirus', 4, NULL),
(7564, NULL, 'IPR013745', NULL, 'TORC2 component Bit61/PRR5', 'Bit61/PRR5', 4, NULL),
(7565, NULL, 'IPR014435', NULL, 'N(4)-bis(aminopropyl)spermidine synthase', 'BpsA', 4, NULL),
(7566, NULL, 'IPR018184', NULL, 'Integrin alpha chain, C-terminal cytoplasmic region, conserved site', 'Integrin_alpha_C_CS', 2, NULL),
(7567, NULL, 'IPR015896', NULL, 'Tetrapyrrole biosynthesis, glutamyl-tRNA reductase, dimerisation domain', '4pyrrol_synth_GluRdtase_dimer', 3, NULL),
(7568, NULL, 'IPR008891', NULL, 'Viral nucleic acid binding', 'Viral_NABP', 4, NULL),
(7569, NULL, 'IPR015799', NULL, 'Influenza matrix M1, N-terminal subdomain 2', 'Flu_matrix_M1_N_sub2', 5, NULL),
(7570, NULL, 'IPR013744', NULL, 'Fusarinine C esterase SidJ', 'SidJ', 4, NULL),
(7571, NULL, 'IPR010298', NULL, 'NYN/PIN ribonuclease, YacP-like', 'YacP-like', 4, NULL),
(7572, NULL, 'IPR011404', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase, XF0274', 'PPi-PFK_XF0274', 4, NULL),
(7573, NULL, 'IPR010933', NULL, 'NADH dehydrogenase subunit 2, C-terminal', 'NADH_DH_su2_C', 3, NULL),
(7574, NULL, 'IPR014428', NULL, 'Holliday junction resolvase Hjc, archaeal', 'Hjc_arc', 4, NULL),
(7575, NULL, 'IPR011546', NULL, 'Peptidase M41, FtsH extracellular', 'Pept_M41_FtsH_extracell', 3, NULL),
(7576, NULL, 'IPR012339', NULL, 'Bacteriophage T4, Gp32, single-stranded DNA-binding domain', 'Phage_T4_Gp32_ssDNA-bd', 3, NULL),
(7577, NULL, 'IPR035940', NULL, 'CAP superfamily', 'CAP_sf', 5, NULL),
(7578, NULL, 'IPR011397', NULL, 'Intramembrane metalloprotease YhfC', 'YhfC', 4, NULL),
(7579, NULL, 'IPR008876', NULL, 'Relaxosome protein TraY', 'TraY', 4, NULL),
(7580, NULL, 'IPR013947', NULL, 'Mediator complex, subunit Med14', 'Mediator_Med14', 4, NULL),
(7581, NULL, 'IPR008908', NULL, 'Sarcoglycan alpha/epsilon', 'Sarcoglycan_alpha/epsilon', 4, NULL),
(7582, NULL, 'IPR015034', NULL, 'Basophilic leukemia-expressed protein Bles03-like', 'Bles03', 4, NULL),
(7583, NULL, 'IPR013973', NULL, 'PglZ domain', 'PglZ_dom', 3, NULL),
(7584, NULL, 'IPR008363', NULL, 'Paraoxonase1', 'Paraoxonase1', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(7585, NULL, 'IPR023816', NULL, 'CRISPR-associated protein CYA0889', 'CRISPR-assoc_CYA0889', 4, NULL),
(7586, NULL, 'IPR010282', NULL, 'Uncharacterised protein family HutD/Ves', 'Uncharacterised_HutD/Ves', 4, NULL),
(7587, NULL, 'IPR008380', NULL, 'HAD-superfamily hydrolase, subfamily IG, 5''-nucleotidase', 'HAD-SF_hydro_IG_5-nucl', 4, NULL),
(7588, NULL, 'IPR010304', NULL, 'Survival motor neuron, Tudor domain', 'SMN_Tudor', 3, NULL),
(7589, NULL, 'IPR013953', NULL, 'FACT complex subunit Spt16 domain', 'FACT_Spt16', 3, NULL),
(7590, NULL, 'IPR018221', NULL, 'Glycoside hydrolase family 9, His active site', 'Glyco_hydro_9_His_AS', 0, NULL),
(7591, NULL, 'IPR023187', NULL, 'Transcriptional regulator MarR-type, conserved site', 'Tscrpt_reg_MarR-type_CS', 2, NULL),
(7592, NULL, 'IPR023719', NULL, 'Aliphatic amidase', 'Aliphatic_amidase', 4, NULL),
(7593, NULL, 'IPR014441', NULL, 'Uncharacterised conserved protein UCP006425, beta-propeller-type', 'UCP006425_b-propeller', 4, NULL),
(7594, NULL, 'IPR012926', NULL, 'Ion channel TACAN/TMEM120B', 'TACAN/TMEM120B', 4, NULL),
(7595, NULL, 'IPR013139', NULL, 'Omega-atracotoxin, conserved site-2', 'Omega_atracotoxin_CS2', 2, NULL),
(7596, NULL, 'IPR013948', NULL, 'DNA replication regulator Sld3, C-terminal', 'DNA_replication_reg_Sld3_C', 3, NULL),
(7597, NULL, 'IPR018222', NULL, 'Nuclear transport factor 2, eukaryote', 'Nuclear_transport_factor_2_euk', 3, NULL),
(7598, NULL, 'IPR008384', NULL, 'Actin-related protein 2/3 complex subunit 4', 'ARPC4', 4, NULL),
(7599, NULL, 'IPR008897', NULL, 'Yeast trans-acting factor', 'Rep_fungi', 4, NULL),
(7600, NULL, 'IPR008909', NULL, 'DALR anticodon binding', 'DALR_anticod-bd', 3, NULL),
(7601, NULL, 'IPR015012', NULL, 'Phenylalanine zipper', 'Phe_ZIP', 3, NULL),
(7602, NULL, 'IPR008345', NULL, 'Transient receptor potential cation channel subfamily V member 6', 'TrpV6', 4, NULL),
(7603, NULL, 'IPR011399', NULL, 'Nitrous oxide reductase expression regulator NosR', 'NosR', 4, NULL),
(7604, NULL, 'IPR018234', NULL, 'GTP cyclohydrolase I, conserved site', 'GTP_CycHdrlase_I_CS', 2, NULL),
(7605, NULL, 'IPR013760', NULL, 'DNA topoisomerase, type IIA-like domain superfamily', 'Topo_IIA-like_dom_sf', 5, NULL),
(7606, NULL, 'IPR013763', NULL, 'Cyclin-like', 'Cyclin-like', 3, NULL),
(7607, NULL, 'IPR008278', NULL, '4''-phosphopantetheinyl transferase domain', '4-PPantetheinyl_Trfase_dom', 3, NULL),
(7608, NULL, 'IPR013746', NULL, 'Hydroxymethylglutaryl-coenzyme A synthase, C-terminal domain', 'HMG_CoA_synt_C_dom', 3, NULL),
(7609, NULL, 'IPR010275', NULL, 'Protein of unknown function DUF882', 'DUF882', 4, NULL),
(7610, NULL, 'IPR014992', NULL, 'Domain of unknown function DUF1842', 'DUF1842', 3, NULL),
(7611, NULL, 'IPR032466', NULL, 'Metal-dependent hydrolase', 'Metal_Hydrolase', 5, NULL),
(7612, NULL, 'IPR015011', NULL, 'Threonyl-tRNA synthetase, editing domain, archaea', 'Threonyl-tRNA_syn_edit_dom_arc', 3, NULL),
(7613, NULL, 'IPR010284', NULL, 'Photosystem II reaction centre protein Ycf12', 'PSII_Ycf12_core-subunit', 4, NULL),
(7614, NULL, 'IPR032469', NULL, 'Endophilin-A3, BAR domain', 'Endophilin-A3_BAR', 3, NULL),
(7615, NULL, 'IPR015020', NULL, 'Rv2525c-like, glycoside hydrolase-like domain', 'Rv2525c-like_Glyco_Hydro-like', 3, NULL),
(7616, NULL, 'IPR013967', NULL, 'Rad54, N-terminal', 'Rad54_N', 3, NULL),
(7617, NULL, 'IPR010265', NULL, 'Bacteriophage lambda, Tail tip protein M', 'Phage_lambda_TipM', 4, NULL),
(7618, NULL, 'IPR008875', NULL, 'TraX', 'TraX', 4, NULL),
(7619, NULL, 'IPR017884', NULL, 'SANT domain', 'SANT_dom', 3, NULL),
(7620, NULL, 'IPR015043', NULL, 'Bacteriophage PRD1, P5, spike N-terminal', 'Phage_PRD1_P5_spike_N', 3, NULL),
(7621, NULL, 'IPR018220', NULL, 'Adenylosuccinate synthase, GTP-binding site', 'Adenylosuccin_syn_GTP-bd', 1, NULL),
(7622, NULL, 'IPR018185', NULL, 'Gas vesicle C repeat', 'Gas_vesicle_C_repeat', 7, NULL),
(7623, NULL, 'IPR010930', NULL, 'Flagellar basal-body/hook protein, C-terminal domain', 'Flg_bb/hook_C_dom', 3, NULL),
(7624, NULL, 'IPR012917', NULL, 'Protein of unknown function DUF3294', 'DUF3294', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(7625, NULL, 'IPR008903', NULL, 'Hemagglutinin component HA-17', 'HA-17_C_botulinum', 4, NULL),
(7626, NULL, 'IPR009100', NULL, 'Acyl-CoA dehydrogenase/oxidase, N-terminal and middle domain superfamily', 'AcylCoA_DH/oxidase_NM_dom', 5, NULL),
(7627, NULL, 'IPR012347', NULL, 'Ferritin-like', 'Ferritin-like', 5, NULL),
(7628, NULL, 'IPR010935', NULL, 'SMCs flexible hinge', 'SMC_hinge', 3, NULL),
(7629, NULL, 'IPR008375', NULL, 'Staphylococcus aureus exotoxin', 'Staph_exotoxin', 4, NULL),
(7630, NULL, 'IPR010280', NULL, '(Uracil-5)-methyltransferase family', 'U5_MeTrfase_fam', 4, NULL),
(7631, NULL, 'IPR013805', NULL, 'GrpE nucleotide exchange factor, coiled-coil', 'GrpE_coiled_coil', 5, NULL),
(7632, NULL, 'IPR013136', NULL, 'WSTF/Acf1/Cbp146', 'WSTF_Acf1_Cbp146', 3, NULL),
(7633, NULL, 'IPR010286', NULL, 'METTL16/RlmF family', 'METTL16/RlmF', 4, NULL),
(7634, NULL, 'IPR018161', NULL, 'Wnt protein, conserved site', 'Wnt_CS', 2, NULL),
(7635, NULL, 'IPR010281', NULL, 'Protein of unknown function DUF885', 'DUF885', 4, NULL),
(7636, NULL, 'IPR011400', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 'EIF3B', 4, NULL),
(7637, NULL, 'IPR013961', NULL, 'RAI1-like', 'RAI1', 3, NULL),
(7638, NULL, 'IPR012345', NULL, 'STAT transcription factor, DNA-binding, N-terminal', 'STAT_TF_DNA-bd_N', 5, NULL),
(7639, NULL, 'IPR008866', NULL, 'Bacteriophage lambda, GpA-like', 'Phage_lambda_GpA-like', 4, NULL),
(7640, NULL, 'IPR010300', NULL, 'Cysteine dioxygenase type I', 'CDO_1', 4, NULL),
(7641, NULL, 'IPR014987', NULL, 'Uncharacterised protein family YfcL', 'UPF_YfcL', 4, NULL),
(7642, NULL, 'IPR018181', NULL, 'Heat shock protein 70, conserved site', 'Heat_shock_70_CS', 2, NULL),
(7643, NULL, 'IPR023734', NULL, 'Polyisoprenyl-teichoic acid--peptidoglycan teichoic acid transferase TagU', 'TagU', 4, NULL),
(7644, NULL, 'IPR008323', NULL, 'Uncharacterised conserved protein UCP033563', 'UCP033563', 4, NULL),
(7645, NULL, 'IPR014989', NULL, 'Protein of unknown function DUF1839', 'DUF1839', 4, NULL),
(7646, NULL, 'IPR008391', NULL, 'Acetyl xylan esterase', 'AXE1_dom', 3, NULL),
(7647, NULL, 'IPR012928', NULL, 'Clostridium neurotoxin, receptor binding N-terminal', 'Toxin_rcpt-bd_N', 3, NULL),
(7648, NULL, 'IPR013965', NULL, 'DASH complex subunit Dad3', 'DASH_Dad3', 4, NULL),
(7649, NULL, 'IPR013740', NULL, 'Redoxin', 'Redoxin', 3, NULL),
(7650, NULL, 'IPR013751', NULL, 'Beta-ketoacyl-[acyl-carrier-protein] synthase III, N-terminal', 'ACP_syn_III_N', 3, NULL),
(7651, NULL, 'IPR032489', NULL, 'Domain of unknown function DUF5048', 'DUF5048', 3, NULL),
(7652, NULL, 'IPR014009', NULL, 'PIK-related kinase', 'PIK_FAT', 3, NULL),
(7653, NULL, 'IPR013137', NULL, 'Zinc finger, TFIIB-type', 'Znf_TFIIB', 3, NULL),
(7654, NULL, 'IPR012927', NULL, 'ShET2 enterotoxin, N-terminal', 'Toxin_15_N', 3, NULL),
(7655, NULL, 'IPR009107', NULL, 'Protein-L-isoaspartyl O-methyltransferase, C-terminal', 'PIM_MeTrfase_C', 5, NULL),
(7656, NULL, 'IPR008383', NULL, 'Apoptosis inhibitory 5', 'API5', 4, NULL),
(7657, NULL, 'IPR035097', NULL, 'Peptidase M29, N-terminal', 'M29_N-terminal', 5, NULL),
(7658, NULL, 'IPR011549', NULL, 'Riboflavin-specific deaminase, C-terminal', 'RibD_C', 3, NULL),
(7659, NULL, 'IPR008399', NULL, 'Anthrax toxin receptor, C-terminal', 'Anthrax_toxin_rcpt_C', 3, NULL),
(7660, NULL, 'IPR015016', NULL, 'Splicing factor 3B subunit 1', 'SF3b_su1', 3, NULL),
(7661, NULL, 'IPR012337', NULL, 'Ribonuclease H-like superfamily', 'RNaseH-like_sf', 5, NULL),
(7662, NULL, 'IPR008893', NULL, 'WGR domain', 'WGR_domain', 3, NULL),
(7663, NULL, 'IPR008325', NULL, 'EipA-like', 'EipA-like', 4, NULL),
(7664, NULL, 'IPR010297', NULL, 'Protein of unknown function DUF900, hydrolase-like', 'DUF900_hydrolase', 4, NULL),
(7665, NULL, 'IPR008397', NULL, 'Alginate lyase domain', 'Alginate_lyase_dom', 3, NULL),
(7666, NULL, 'IPR014419', NULL, 'Heme utilization protein HutZ', 'HutZ', 4, NULL),
(7667, NULL, 'IPR015041', NULL, 'Osmosensory transporter coiled coil', 'Osmo_CC', 3, NULL),
(7668, NULL, 'IPR018177', NULL, 'L-lactate dehydrogenase, active site', 'L-lactate_DH_AS', 0, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(7669, NULL, 'IPR023728', NULL, 'Small heat shock protein IbpA', 'HSP20_IbpA', 4, NULL),
(7670, NULL, 'IPR013750', NULL, 'GHMP kinase, C-terminal domain', 'GHMP_kinase_C_dom', 3, NULL),
(7671, NULL, 'IPR015032', NULL, 'Thoeris protein ThsB, TIR-like domain', 'ThsB__TIR-like_domain', 3, NULL),
(7672, NULL, 'IPR018215', NULL, 'ClpP, Ser active site', 'ClpP_Ser_AS', 0, NULL),
(7673, NULL, 'IPR010260', NULL, 'DNA-binding transcriptional activator AlpA', 'AlpA', 4, NULL),
(7674, NULL, 'IPR010264', NULL, 'Plant self-incompatibility S1', 'Self-incomp_S1', 4, NULL),
(7675, NULL, 'IPR013730', NULL, 'Fyv7/TAP26', 'Fyv7/TAP26', 4, NULL),
(7676, NULL, 'IPR015036', NULL, 'E3 ubiquitin-protein ligase NRDP1', 'NRDP1', 3, NULL),
(7677, NULL, 'IPR010934', NULL, 'NADH dehydrogenase subunit 5, C-terminal', 'NADH_DH_su5_C', 3, NULL),
(7678, NULL, 'IPR013971', NULL, 'HalX domain', 'HalX_domain', 3, NULL),
(7679, NULL, 'IPR008880', NULL, 'Trigger factor, C-terminal', 'Trigger_fac_C', 3, NULL),
(7680, NULL, 'IPR008392', NULL, 'Drosophila accessory gland-specific peptide 26Ab', 'Acp26Ab', 4, NULL),
(7681, NULL, 'IPR008350', NULL, 'Mitogen-activated protein (MAP) kinase, ERK3/4', 'MAPK_ERK3/4', 4, NULL),
(7682, NULL, 'IPR008344', NULL, 'Transient receptor potential cation channel subfamily V member 5/6', 'TRPV5/TRPV6', 4, NULL),
(7683, NULL, 'IPR015033', NULL, 'HBS1-like protein, N-terminal', 'HBS1-like_N', 3, NULL),
(7684, NULL, 'IPR011538', NULL, 'NADH-ubiquinone oxidoreductase 51kDa subunit, FMN-binding domain', 'Nuo51_FMN-bd', 3, NULL),
(7685, NULL, 'IPR008896', NULL, 'Protein TIC214', 'TIC214', 4, NULL),
(7686, NULL, 'IPR008354', NULL, 'Glucose-fructose oxidoreductase, bacterial', 'Glc-Fru_OxRdtase_bac', 4, NULL),
(7687, NULL, 'IPR008868', NULL, 'Bacterial TniB', 'TniB', 4, NULL),
(7688, NULL, 'IPR008389', NULL, 'ATPase, V0 complex, subunit e1/e2', 'ATPase_V0-cplx_e1/e2_su', 4, NULL),
(7689, NULL, 'IPR008869', NULL, 'Toluene tolerance Ttg2/phospholipid-binding protein MlaC', 'MlaC/ttg2D', 4, NULL),
(7690, NULL, 'IPR014409', NULL, 'Signal transduction histidine kinase, hybrid-type, aerobic respiration control ArcB', 'Sig_transdc_His_kin_hyb_ArcB', 4, NULL),
(7691, NULL, 'IPR014440', NULL, 'HCCA isomerase/glutathione S-transferase kappa', 'HCCAis_GSTk', 4, NULL),
(7692, NULL, 'IPR015004', NULL, 'MesX', 'MesX', 4, NULL),
(7693, NULL, 'IPR010268', NULL, 'Archaeal PaREP1', 'PaREP1', 4, NULL),
(7694, NULL, 'IPR024736', NULL, 'Oestrogen-type nuclear receptor final C-terminal domain', 'Oestrogen-typ_rcpt_final_C_dom', 3, NULL),
(7695, NULL, 'IPR008900', NULL, 'Zona occludens toxin, N-terminal', 'Zot_N', 3, NULL),
(7696, NULL, 'IPR013731', NULL, 'Opacity-associated protein A, N-terminal', 'OapA_N', 3, NULL),
(7697, NULL, 'IPR015022', NULL, 'Microtubule-associated serine/threonine-protein kinase, domain', 'MA_Ser/Thr_Kinase_dom', 3, NULL),
(7698, NULL, 'IPR008372', NULL, 'Voltage-dependent calcium channel, gamma-8 subunit', 'VDCC_g8su', 4, NULL),
(7699, NULL, 'IPR011402', NULL, 'Phospholipase D, plant', 'PLipase_D_pln', 4, NULL),
(7700, NULL, 'IPR014407', NULL, '5-methylcytosine restriction system component, bacterial', 'McrC_bac', 4, NULL),
(7701, NULL, 'IPR013739', NULL, 'Beta-galactosidase C-terminal', 'Beta_galactosidase_C', 3, NULL),
(7702, NULL, 'IPR013735', NULL, 'Transcription factor NusA, N-terminal', 'TF_NusA_N', 3, NULL),
(7703, NULL, 'IPR015021', NULL, 'Domain of unknown function DUF1907', 'DUF1907', 3, NULL),
(7704, NULL, 'IPR012336', NULL, 'Thioredoxin-like fold', 'Thioredoxin-like_fold', 3, NULL),
(7705, NULL, 'IPR014996', NULL, 'Transcriptional regulator AcaB', 'AcaB', 4, NULL),
(7706, NULL, 'IPR012001', NULL, 'Thiamine pyrophosphate enzyme, N-terminal TPP-binding domain', 'Thiamin_PyroP_enz_TPP-bd_dom', 3, NULL),
(7707, NULL, 'IPR013741', NULL, 'Repressor KorB domain', 'KorB_domain', 3, NULL),
(7708, NULL, 'IPR010271', NULL, 'Toxin-coregulated pilus subunit TcpA', 'TcpA', 4, NULL),
(7709, NULL, 'IPR008872', NULL, 'Insecticidal crystal toxin', 'Toxin_P42', 3, NULL),
(7710, NULL, 'IPR008887', NULL, 'Uncharacterised protein family UPF0228', 'UPF0228', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(7711, NULL, 'IPR011539', NULL, 'Rel homology domain (RHD), DNA-binding domain', 'RHD_DNA_bind_dom', 3, NULL),
(7712, NULL, 'IPR008348', NULL, 'Transient receptor potential cation channel subfamily V member 4', 'TrpV4', 4, NULL),
(7713, NULL, 'IPR008878', NULL, 'Transposase IS66, Orf2', 'Transposase_IS66_Orf2', 4, NULL),
(7714, NULL, 'IPR008320', NULL, 'Uncharacterised conserved protein UCP032025', 'UCP032025', 4, NULL),
(7715, NULL, 'IPR018224', NULL, 'Ependymin, conserved site', 'Ependymin_CS', 2, NULL),
(7716, NULL, 'IPR008361', NULL, 'Melanin-concentrating hormone receptor', 'MCH_rcpt', 4, NULL),
(7717, NULL, 'IPR014991', NULL, 'Protein of unknown function DUF1840', 'DUF1840', 4, NULL),
(7718, NULL, 'IPR014426', NULL, 'Uncharacterised protein family UPF0282, hydrolase, metallo-beta-lactamase', 'UPF0282_hydrls', 4, NULL),
(7719, NULL, 'IPR008912', NULL, 'Uncharacterised protein family CoxE-like', 'Uncharacterised_CoxE', 4, NULL),
(7720, NULL, 'IPR013963', NULL, 'DASH complex subunit Dad2', 'DASH_Dad2', 4, NULL),
(7721, NULL, 'IPR017898', NULL, 'Vacuolar protein sorting-associated, VPS28, N-terminal', 'VPS28_N', 3, NULL),
(7722, NULL, 'IPR008376', NULL, 'Synembryn', 'Synembryn', 3, NULL),
(7723, NULL, 'IPR008888', NULL, 'Ustilago B locus mating-type', 'Ustilago_mating', 3, NULL),
(7724, NULL, 'IPR012352', NULL, 'Interleukin-10, additional helical', 'IL-10_add_hlx', 5, NULL),
(7725, NULL, 'IPR015895', NULL, 'Glutamyl-tRNA reductase, N-terminal', '4pyrrol_synth_GluRdtase_N', 3, NULL),
(7726, NULL, 'IPR018212', NULL, 'Sodium/solute symporter, conserved site', 'Na/solute_symporter_CS', 2, NULL),
(7727, NULL, 'IPR014990', NULL, 'Protein of unknown function DUF1838', 'DUF1838', 4, NULL),
(7728, NULL, 'IPR016050', NULL, 'Proteasome beta-type subunit, conserved site', 'Proteasome_bsu_CS', 2, NULL),
(7729, NULL, 'IPR010938', NULL, 'Protein of unknown function DUF1131', 'DUF1131', 4, NULL),
(7730, NULL, 'IPR008365', NULL, 'Prostanoid receptor', 'Prostanoid_rcpt', 4, NULL),
(7731, NULL, 'IPR013819', NULL, 'Lipoxygenase, C-terminal', 'LipOase_C', 3, NULL),
(7732, NULL, 'IPR008338', NULL, 'Capsule biosynthesis protein CapC', 'Capsule_biosynth_CapC', 4, NULL),
(7733, NULL, 'IPR013964', NULL, 'DASH complex subunit Ask1', 'DASH_Ask1', 4, NULL),
(7734, NULL, 'IPR008359', NULL, 'Linker-for-activation of T cells (LAT) protein', 'Linker_for_activat_Tcells_prot', 4, NULL),
(7735, NULL, 'IPR012924', NULL, 'TfuA-like, core', 'TfuA_core', 3, NULL),
(7736, NULL, 'IPR018227', NULL, 'Amino acid/polyamine transporter 2', 'Amino_acid_transport_2', 4, NULL),
(7737, NULL, 'IPR017891', NULL, 'Insulin-like growth factor binding protein, N-terminal, Cys-rich conserved site', 'Insulin_GF-bd_Cys-rich_CS', 2, NULL),
(7738, NULL, 'IPR008319', NULL, 'GyrI-like cyclopropanoid cyclopropyl hydrolase Lin2189-like', 'GyrI-like_CCH_Lin2189-like', 4, NULL),
(7739, NULL, 'IPR013815', NULL, 'ATP-grasp fold, subdomain 1', 'ATP_grasp_subdomain_1', 5, NULL),
(7740, NULL, 'IPR008342', NULL, 'Dishevelled-3', 'DVL3', 4, NULL),
(7741, NULL, 'IPR013950', NULL, 'Kinetochore Mis14/Nsl1', 'Mis14/Nsl1', 4, NULL),
(7742, NULL, 'IPR008914', NULL, 'Phosphatidylethanolamine-binding protein', 'PEBP', 4, NULL),
(7743, NULL, 'IPR010272', NULL, 'Type VI secretion system TssF', 'T6SS_TssF', 4, NULL),
(7744, NULL, 'IPR013756', NULL, 'Flaviviral glycoprotein E, central domain, subdomain 2', 'GlyE_cen_dom_subdom2', 5, NULL),
(7745, NULL, 'IPR014010', NULL, 'REJ domain', 'REJ_dom', 3, NULL),
(7746, NULL, 'IPR010279', NULL, 'Inner membrane protein YqjD/ElaB', 'YqjD/ElaB', 4, NULL),
(7747, NULL, 'IPR008874', NULL, 'Enterobacterial TraT complement resistance', 'TraT_complement-R', 4, NULL),
(7748, NULL, 'IPR011401', NULL, 'Phosphoesterase, YvnB', 'Pesterase_YvnB', 4, NULL),
(7749, NULL, 'IPR008343', NULL, 'Mitogen-activated protein (MAP) kinase phosphatase', 'MKP', 4, NULL),
(7750, NULL, 'IPR018202', NULL, 'Serine carboxypeptidase, serine active site', 'Ser_caboxypep_ser_AS', 0, NULL),
(7751, NULL, 'IPR014438', NULL, 'Glucan biosynthesis protein MdoG/MdoD', 'Glucan_biosyn_MdoG/MdoD', 4, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(7752, NULL, 'IPR009103', NULL, 'Olfactory marker protein', 'Olfactory_marker', 4, NULL),
(7753, NULL, 'IPR010263', NULL, 'Type VI secretion system TssK', 'T6SS_TssK', 4, NULL),
(7754, NULL, 'IPR010296', NULL, 'Protein of unknown function DUF899, thioredoxin-like', 'DUF899_thioredox', 4, NULL),
(7755, NULL, 'IPR015044', NULL, 'Bacteriophage PRD1, spike protein P5, C-terminal', 'Phage_PRD1_P5_C', 3, NULL),
(7756, NULL, 'IPR014998', NULL, 'Protein of unknown function DUF1848', 'DUF1848', 4, NULL),
(7757, NULL, 'IPR013748', NULL, 'Replication factor C, C-terminal', 'Rep_factorC_C', 3, NULL),
(7758, NULL, 'IPR018235', NULL, 'Bacterial luciferase, conserved site', 'Bacterial_luciferase_CS', 2, NULL),
(7759, NULL, 'IPR009105', NULL, 'Colicin E3-like ribonuclease domain', 'Colicin_E3_ribonuclease', 3, NULL),
(7760, NULL, 'IPR015017', NULL, 'Protein of unknown function DUF1904', 'DUF1904', 4, NULL),
(7761, NULL, 'IPR013957', NULL, 'U4/U6.U5 small nuclear ribonucleoprotein 27kDa protein', 'SNRNP27', 3, NULL),
(7762, NULL, 'IPR023818', NULL, 'Conserved hypothetical protein CHP03890, nif11/cupin domain-containing', 'Nif11_cupin', 4, NULL),
(7763, NULL, 'IPR008341', NULL, 'Dishevelled-2', 'DVL2', 4, NULL),
(7764, NULL, 'IPR011395', NULL, 'Alpha glucuronidase', 'Glyco_hydro_67_aGlcAse', 4, NULL),
(7765, NULL, 'IPR008394', NULL, 'Enterobacteria AfaD invasin', 'AfaD', 4, NULL),
(7766, NULL, 'IPR010940', NULL, 'Magnesium-protoporphyrin IX methyltransferase, C-terminal', 'Mg_prot_MeTrfase_C', 3, NULL),
(7767, NULL, 'IPR015037', NULL, 'Protein of unknown function DUF1919', 'DUF1919', 4, NULL),
(7768, NULL, 'IPR018230', NULL, 'BUD31/G10-related, conserved site', 'BUD31/G10-rel_CS', 2, NULL),
(7769, NULL, 'IPR013762', NULL, 'Integrase-like, catalytic domain superfamily', 'Integrase-like_cat_sf', 5, NULL),
(7770, NULL, 'IPR018228', NULL, 'Deoxyribonuclease, TatD-related, conserved site', 'DNase_TatD-rel_CS', 2, NULL),
(7771, NULL, 'IPR013954', NULL, 'Polynucleotide kinase 3 phosphatase', 'PNK3P', 4, NULL),
(7772, NULL, 'IPR012921', NULL, 'Spen paralogue and orthologue SPOC, C-terminal', 'SPOC_C', 3, NULL),
(7773, NULL, 'IPR008892', NULL, 'Cold-regulated 413 protein', 'COR413', 4, NULL),
(7774, NULL, 'IPR011392', NULL, 'Tellurite resistance, TerY', 'Tellurite-R_TerY', 4, NULL),
(7775, NULL, 'IPR011537', NULL, 'NADH ubiquinone oxidoreductase, F subunit', 'NADH-UbQ_OxRdtase_suF', 4, NULL),
(7776, NULL, 'IPR010294', NULL, 'ADAMTS/ADAMTS-like, Spacer 1', 'ADAMTS_spacer1', 3, NULL),
(7777, NULL, 'IPR013978', NULL, 'MEKHLA', 'MEKHLA', 3, NULL),
(7778, NULL, 'IPR015013', NULL, 'Transforming growth factor beta receptor 2 ectodomain', 'Transforming_GF_b_rcpt_2_ecto', 3, NULL),
(7779, NULL, 'IPR010276', NULL, 'Allatostatin', 'Allatostatin', 4, NULL),
(7780, NULL, 'IPR018209', NULL, 'Pyruvate kinase, active site', 'Pyrv_Knase_AS', 0, NULL),
(7781, NULL, 'IPR018176', NULL, 'Tryptophanase, conserved site', 'Tryptophanase_CS', 2, NULL),
(7782, NULL, 'IPR018225', NULL, 'Transaldolase, active site', 'Transaldolase_AS', 0, NULL),
(7783, NULL, 'IPR008358', NULL, 'Signal transduction histidine kinase/phosphatase, lantibiotic regulatory protein MprB', 'Sig_transdc_His_kin/Pase_MprB', 4, NULL),
(7784, NULL, 'IPR013969', NULL, 'Oligosaccharide biosynthesis protein Alg14-like', 'Oligosacch_biosynth_Alg14', 4, NULL),
(7785, NULL, 'IPR015823', NULL, 'Methyl-coenzyme M reductase, alpha subunit, N-terminal subdomain 2', 'Me_CoM_Rdtase_asu_N_sub2', 5, NULL),
(7786, NULL, 'IPR008910', NULL, 'Conserved TM helix', 'TM_helix', 7, NULL),
(7787, NULL, 'IPR015000', NULL, 'EipB-like', 'EipB-like', 4, NULL),
(7788, NULL, 'IPR008378', NULL, 'Ubiquitous surface protein', 'Ubiq_surface', 4, NULL),
(7789, NULL, 'IPR015040', NULL, 'Bcl-x interacting, BH3 domain', 'Bcl-x_interacting_BH3_dom', 3, NULL),
(7790, NULL, 'IPR015008', NULL, 'ROCK, Rho binding domain', 'ROCK_Rho-bd_dom', 3, NULL),
(7791, NULL, 'IPR013818', NULL, 'Lipase', 'Lipase', 3, NULL),
(7792, NULL, 'IPR013759', NULL, 'DNA topoisomerase, type IIA, subunit B, C-terminal', 'Topo_IIA_B_C', 5, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(7793, NULL, 'IPR010295', NULL, 'Protein of unknown function DUF898', 'DUF898', 4, NULL),
(7794, NULL, 'IPR008390', NULL, 'AWPM-19-like', 'AWPM-19', 4, NULL),
(7795, NULL, 'IPR015029', NULL, 'Monodechloroaminopyrrolnitrin synthase PrnB', 'PrnB', 4, NULL),
(7796, NULL, 'IPR008349', NULL, 'Mitogen-activated protein (MAP) kinase, ERK1/2', 'MAPK_ERK1/2', 4, NULL),
(7797, NULL, 'IPR013960', NULL, 'DASH complex subunit Duo1', 'DASH_Duo1', 4, NULL),
(7798, NULL, 'IPR015026', NULL, 'Protein of unknown function DUF1912', 'DUF1912', 4, NULL),
(7799, NULL, 'IPR015027', NULL, 'Receptor-binding protein of phage tail base-plate Siphoviridae, head', 'Caudo_bapla_RBP', 3, NULL),
(7800, NULL, 'IPR015897', NULL, 'CHK kinase-like', 'CHK_kinase-like', 3, NULL),
(7801, NULL, 'IPR034705', NULL, 'Cytoplasmic envelopment protein 3', 'HSV_CEP3_betahv', 4, NULL),
(7802, NULL, 'IPR008369', NULL, 'Voltage-dependent calcium channel, gamma-5 subunit', 'VDCC_g5su', 4, NULL),
(7803, NULL, 'IPR008373', NULL, 'Saposin', 'Saposin', 4, NULL),
(7804, NULL, 'IPR008321', NULL, 'Uncharacterised conserved protein UCP032146', 'UCP032146', 4, NULL),
(7805, NULL, 'IPR008317', NULL, 'Uncharacterised conserved protein UCP030561', 'UCP030561', 4, NULL),
(7806, NULL, 'IPR013952', NULL, 'Protein of unknown function DUF1776, fungi', 'DUF1776_fun', 4, NULL),
(7807, NULL, 'IPR015031', NULL, 'Capsid protein VP4, Picornavirus', 'Capsid_VP4_Picornavir', 3, NULL),
(7808, NULL, 'IPR010928', NULL, 'Tyrosinase co-factor MelC1', 'MelC1', 4, NULL),
(7809, NULL, 'IPR012916', NULL, 'RED-like, N-terminal', 'RED_N', 3, NULL),
(7810, NULL, 'IPR008889', NULL, 'VQ', 'VQ', 3, NULL),
(7811, NULL, 'IPR008370', NULL, 'Voltage-dependent calcium channel, gamma-6 subunit', 'VDCC_g6su', 4, NULL),
(7812, NULL, 'IPR008367', NULL, 'Regucalcin', 'Regucalcin', 4, NULL),
(7813, NULL, 'IPR010293', NULL, 'Na+-dependent bicarbonate transporter superfamily', 'Sbt_1', 4, NULL),
(7814, NULL, 'IPR035942', NULL, 'Lp2179-like superfamily', 'Lp2179-like_sf', 5, NULL),
(7815, NULL, 'IPR010261', NULL, 'Tir chaperone protein (CesT) family', 'Tir_chaperone', 4, NULL),
(7816, NULL, 'IPR008871', NULL, 'Totivirus coat', 'Totivirus_coat', 4, NULL),
(7817, NULL, 'IPR008886', NULL, 'Uncharacterised protein family UPF0227/Esterase YqiA', 'UPF0227/Esterase_YqiA', 4, NULL),
(7818, NULL, 'IPR013752', NULL, 'Ketopantoate reductase, C-terminal domain', 'KPA_reductase', 3, NULL),
(7819, NULL, 'IPR008355', NULL, 'Interferon gamma receptor alpha subunit', 'Interferon_gamma_rcpt_asu', 4, NULL),
(7820, NULL, 'IPR015899', NULL, 'UDP-galactopyranose mutase, C-terminal', 'UDP-GalPyranose_mutase_C', 3, NULL),
(7821, NULL, 'IPR008867', NULL, 'Thiazole synthase', 'ThiG', 4, NULL),
(7822, NULL, 'IPR013944', NULL, 'Oxidoreductase putative, C-terminal', 'OxRdtase_put_C', 3, NULL),
(7823, NULL, 'IPR013135', NULL, 'Vitelline membrane cysteine-rich domain', 'Vitelline_membr_Cys-rich-dom', 3, NULL),
(7824, NULL, 'IPR018168', NULL, 'Ubiquinone biosynthesis hydroxylase, UbiH/UbiF/VisC/COQ6, conserved site', 'Ubi_Hdrlase_CS', 2, NULL),
(7825, NULL, 'IPR010270', NULL, 'Bacteriophage P2, GpM', 'Phage_P2_GpM', 4, NULL),
(7826, NULL, 'IPR010287', NULL, 'Protein of unknown function DUF892, YciF-like', 'DUF892_YciF-like', 4, NULL),
(7827, NULL, 'IPR015015', NULL, 'F-actin binding', 'F-actin-binding', 3, NULL),
(7828, NULL, 'IPR015010', NULL, 'Rap1 Myb domain', 'Rap1_Myb_dom', 3, NULL),
(7829, NULL, 'IPR013966', NULL, 'DASH complex subunit Spc34', 'Spc34', 4, NULL),
(7830, NULL, 'IPR009919', NULL, 'Protein of unknown function DUF1455', 'DUF1455', 4, NULL),
(7831, NULL, 'IPR015024', NULL, 'PoNi, N-terminal', 'PoNi_N', 3, NULL),
(7832, NULL, 'IPR014414', NULL, 'Envelope glycoprotein precursor/M polyprotein precursor, Tospovirus type', 'M_poly_TospoV', 4, NULL),
(7833, NULL, 'IPR014993', NULL, 'Protein of unknown function DUF1841', 'DUF1841', 4, NULL),
(7834, NULL, 'IPR018233', NULL, 'Calsequestrin, conserved site', 'Calsequestrin_CS', 2, NULL),
(7835, NULL, 'IPR008364', NULL, 'Paraoxonase2', 'Paraoxonase2', 4, NULL),
(7836, NULL, 'IPR013968', NULL, 'Polyketide synthase, ketoreductase domain', 'PKS_KR', 3, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(7837, NULL, 'IPR014412', NULL, 'Genome polyprotein, Flavivirus', 'Gen_Poly_FLV', 4, NULL),
(7838, NULL, 'IPR014410', NULL, 'Adenovirus early E1A protein', 'Aden_E1A', 4, NULL),
(7839, NULL, 'IPR010941', NULL, 'Poly-beta-hydroxybutyrate polymerase, N-terminal domain', 'PhaC_N', 3, NULL),
(7840, NULL, 'IPR013945', NULL, 'V-type ATPase assembly factor Pkr1', 'Pkr1', 4, NULL),
(7841, NULL, 'IPR014430', NULL, 'Sterol desaturase Scs7', 'Scs7', 4, NULL),
(7842, NULL, 'IPR014436', NULL, 'Extradiol aromatic ring-opening dioxygenase, DODA-type', 'Extradiol_dOase_DODA', 4, NULL),
(7843, NULL, 'IPR008356', NULL, 'Protein-tyrosine phosphatase, KIM-containing', 'Tyr_Pase_KIM-con', 4, NULL),
(7844, NULL, 'IPR032490', NULL, 'Domain of unknown function DUF5047', 'DUF5047', 3, NULL),
(7845, NULL, 'IPR008385', NULL, 'African swine fever virus, Inner membrane protein p54', 'ASFV_p54', 4, NULL),
(7846, NULL, 'IPR009101', NULL, 'Gurmarin/antifungal peptide', 'Gurmarin/antifun_pep', 5, NULL),
(7847, NULL, 'IPR008899', NULL, 'Zinc finger, piccolo-type', 'Znf_piccolo', 3, NULL),
(7848, NULL, 'IPR013737', NULL, 'Bacterial alpha-L-rhamnosidase N-terminal', 'Bac_rhamnosid_N', 3, NULL),
(7849, NULL, 'IPR015002', NULL, 'T6SS immunity protein Tdi1, C-terminal', 'T6SS_Tdi1_C', 3, NULL),
(7850, NULL, 'IPR015007', NULL, 'Nuclear pore complex, NUP2/50/61', 'NUP2/50/61', 3, NULL),
(7851, NULL, 'IPR008913', NULL, 'Zinc finger, CHY-type', 'Znf_CHY', 3, NULL),
(7852, NULL, 'IPR015046', NULL, 'Lactococcin-A immunity protein-like', 'LciA_Immunity-like', 4, NULL),
(7853, NULL, 'IPR015049', NULL, 'Trimerisation motif', 'Trimer_CC', 3, NULL),
(7854, NULL, 'IPR009113', NULL, 'Outer capsid protein Mu1/VP4', 'Mu1/VP4', 4, NULL),
(7855, NULL, 'IPR013958', NULL, 'DASH complex subunit Dad1', 'DASH_Dad1', 4, NULL),
(7856, NULL, 'IPR015045', NULL, 'Mannosyltransferase/phosphorylase 1-like, Leishmania', 'MPT-1-like_LmxM', 4, NULL),
(7857, NULL, 'IPR023148', NULL, 'tRNA (guanine-N(1)-)-methyltransferase, C-terminal domain superfamily', 'tRNA_m1G_MeTrfase_C_sf', 5, NULL),
(7858, NULL, 'IPR018211', NULL, 'Alcohol dehydrogenase, iron-type, conserved site', 'ADH_Fe_CS', 2, NULL),
(7859, NULL, 'IPR013956', NULL, 'E3 ubiquitin ligase Bre1', 'E3_ubiquit_lig_Bre1', 4, NULL),
(7860, NULL, 'IPR012918', NULL, 'RTP801-like', 'RTP801-like', 4, NULL),
(7861, NULL, 'IPR008386', NULL, 'ATP synthase, F0 complex, subunit E, mitochondrial', 'ATP_synth_F0_esu_mt', 4, NULL),
(7862, NULL, 'IPR013732', NULL, 'Protein-arginine deiminase (PAD), N-terminal', 'PAD_N', 3, NULL),
(7863, NULL, 'IPR008884', NULL, 'Macrocin-O-methyltransferase', 'TylF_MeTrfase', 4, NULL),
(7864, NULL, 'IPR010274', NULL, 'Orthopoxvirus A36R', 'Orthopox_A36R', 4, NULL),
(7865, NULL, 'IPR034698', NULL, 'Baseplate wedge protein gp6', 'GP6_T4', 4, NULL),
(7866, NULL, 'IPR008865', NULL, 'DNA replication terminus site-binding protein', 'DNA_replication_term_site-bd', 4, NULL),
(7867, NULL, 'IPR014433', NULL, 'Nickel insertion ATPase/GTPase (CO dehydrogenase maturation factor), CooC type', 'CooC', 4, NULL),
(7868, NULL, 'IPR014413', NULL, 'M polyprotein precursor, Orthobunyavirus type', 'M_poly_OrthobunV', 4, NULL),
(7869, NULL, 'IPR008374', NULL, 'SF-assemblin/beta-giardin', 'SF_assemblin/giardin_b', 4, NULL),
(7870, NULL, 'IPR012925', NULL, 'TipAS antibiotic-recognition domain', 'TipAS_dom', 3, NULL),
(7871, NULL, 'IPR010269', NULL, 'Type VI secretion system TssC-like', 'T6SS_TssC-like', 4, NULL),
(7872, NULL, 'IPR009920', NULL, 'Heptaprenyl diphosphate synthase subunit 1', 'HEPPP_synth_su1', 4, NULL),
(7873, NULL, 'IPR015035', NULL, 'Domain of unknown function DUF1918', 'DUF1918', 3, NULL),
(7874, NULL, 'IPR013734', NULL, 'Transcription factor Nrm1/Whi5', 'TF_Nrm1/Whi5', 2, NULL),
(7875, NULL, 'IPR013736', NULL, 'Xaa-Pro dipeptidyl-peptidase, C-terminal', 'Xaa-Pro_dipept_C', 3, NULL),
(7876, NULL, 'IPR013821', NULL, 'Potassium channel, voltage dependent, KCNQ, C-terminal', 'K_chnl_volt-dep_KCNQ_C', 3, NULL),
(7877, NULL, 'IPR015003', NULL, 'Protein of unknown function DUF1853', 'DUF1853', 4, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(7878, NULL, 'IPR018216', NULL, 'Cathelicidin, conserved site', 'Cathelicidin_CS', 2, NULL),
(7879, NULL, 'IPR013729', NULL, 'Multiprotein bridging factor 1, N-terminal', 'MBF1_N', 3, NULL),
(7880, NULL, 'IPR010301', NULL, 'Ribosomal RNA processing protein 1-like', 'RRP1-like', 4, NULL),
(7881, NULL, 'IPR013761', NULL, 'Sterile alpha motif/pointed domain superfamily', 'SAM/pointed_sf', 5, NULL),
(7882, NULL, 'IPR010285', NULL, 'DNA helicase Pif1-like', 'DNA_helicase_pif1-like', 4, NULL),
(7883, NULL, 'IPR008901', NULL, 'Alkaline ceramidase', 'ACER', 4, NULL),
(7884, NULL, 'IPR008398', NULL, 'Allexivirus 40kDa', 'Allexi_40kDa', 4, NULL),
(7885, NULL, 'IPR008314', NULL, 'N(4)-acetylcytidine amidohydrolase', 'AC4CH', 4, NULL),
(7886, NULL, 'IPR014416', NULL, 'DNA-directed DNA polymerase, family B, phi29-like virus', 'DNA-dir_DNA_polB_phi29_vir', 4, NULL),
(7887, NULL, 'IPR008902', NULL, 'Alpha-L-rhamnosidase, concanavalin-like domain', 'Rhamnosid_concanavalin', 3, NULL),
(7888, NULL, 'IPR008330', NULL, 'Peptidase M17, peptidase B', 'Pept_M17_PepB', 4, NULL),
(7889, NULL, 'IPR014997', NULL, 'Protein of unknown function DUF1847', 'DUF1847', 4, NULL),
(7890, NULL, 'IPR023095', NULL, 'Adenine-specific methyltransferase, domain 2', 'Ade_MeTrfase_dom_2', 5, NULL),
(7891, NULL, 'IPR012923', NULL, 'Chromosome segregation in meiosis protein 3', 'Csm3', 3, NULL),
(7892, NULL, 'IPR010303', NULL, 'CREB-binding protein/p300, atypical RING domain', 'RING_CBP-p300', 3, NULL),
(7893, NULL, 'IPR008371', NULL, 'Voltage-dependent calcium channel, gamma-7 subunit', 'VDCC_g7su', 4, NULL),
(7894, NULL, 'IPR013949', NULL, 'U3 small nucleolar RNA-associated protein 6', 'Utp6', 4, NULL),
(7895, NULL, 'IPR013747', NULL, 'Beta-ketoacyl-[acyl-carrier-protein] synthase III, C-terminal', 'ACP_syn_III_C', 3, NULL),
(7896, NULL, 'IPR009109', NULL, 'Ran-GTPase activating protein 1, C-terminal', 'Ran_GTPase_activating_1_C', 3, NULL),
(7897, NULL, 'IPR009110', NULL, 'Nuclear receptor coactivator, interlocking', 'Nuc_rcpt_coact', 5, NULL),
(7898, NULL, 'IPR014417', NULL, 'Integrase, predicted', 'Integrase_predicted', 4, NULL),
(7899, NULL, 'IPR013728', NULL, 'Domain of unknown function DUF1735', 'DUF1735', 3, NULL),
(7900, NULL, 'IPR013141', NULL, 'Conotoxin-I, conserved site', 'Conotoxin-I_CS', 2, NULL),
(7901, NULL, 'IPR023932', NULL, 'Uncharacterised protein family, CE1759', 'Uncharacterised_CE1759', 4, NULL),
(7902, NULL, 'IPR015014', NULL, 'PhoQ Sensor', 'PhoQ_Sensor', 3, NULL),
(7903, NULL, 'IPR013743', NULL, 'Nap binding NBP1, fungi', 'NBP1_fun', 4, NULL),
(7904, NULL, 'IPR012349', NULL, 'FMN-binding split barrel', 'Split_barrel_FMN-bd', 5, NULL),
(7905, NULL, 'IPR009038', NULL, 'GOLD domain', 'GOLD_dom', 3, NULL),
(7906, NULL, 'IPR015018', NULL, 'Protein of unknown function DUF1905', 'DUF1905', 4, NULL),
(7907, NULL, 'IPR014999', NULL, 'Uncharacterised protein family UPF0371', 'UPF0371', 4, NULL),
(7908, NULL, 'IPR013140', NULL, 'Huwentoxin, conserved site-1', 'Huwentoxin_CS1', 2, NULL),
(7909, NULL, 'IPR009111', NULL, 'Quinohemoprotein amine dehydrogenase, alpha subunit, domain 2', 'QH-AmDH_asu_dom2', 3, NULL),
(7910, NULL, 'IPR014995', NULL, 'Protein of unknown function DUF1844', 'DUF1844', 4, NULL),
(7911, NULL, 'IPR018229', NULL, 'Rhodopsin, retinal binding site', 'Rhodopsin_retinal_BS', 1, NULL),
(7912, NULL, 'IPR008898', NULL, 'YopD-like', 'YopD-like', 4, NULL),
(7913, NULL, 'IPR010262', NULL, 'Arylsulfotransferase, bacteria', 'Arylsulfotransferase_bact', 4, NULL),
(7914, NULL, 'IPR013946', NULL, 'Nuclear control of ATP synthase 2', 'NCA2', 4, NULL),
(7915, NULL, 'IPR009040', NULL, 'Ferritin-like diiron domain', 'Ferritin-like_diiron', 3, NULL),
(7916, NULL, 'IPR008382', NULL, 'SPHK1-interactor/A-kinase anchor 110kDa', 'SPHK1-interactor_AKAP_110', 4, NULL),
(7917, NULL, 'IPR013813', NULL, 'Endoribonuclease L-PSP/chorismate mutase-like', 'Endoribo_LPSP/chorism_mut-like', 3, NULL),
(7918, NULL, 'IPR018165', NULL, 'Alanyl-tRNA synthetase, class IIc, core domain', 'Ala-tRNA-synth_IIc_core', 3, NULL),
(7919, NULL, 'IPR013972', NULL, 'YcbB domain', 'YcbB', 3, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(7920, NULL, 'IPR015047', NULL, 'Synaptojanin-1/2, RNA recognition motif', 'SYNJ1/2_RRM', 3, NULL),
(7921, NULL, 'IPR016019', NULL, 'Guanine nucleotide exchange factor SopE, GEF domain', 'SopE_GEF_dom', 3, NULL),
(7922, NULL, 'IPR010290', NULL, 'Transmembrane secretion effector', 'TM_effector', 4, NULL),
(7923, NULL, 'IPR014422', NULL, 'Cobalamin (vitamin B12) biosynthesis, bifunctional CbiH/CbiC', 'Cbl_synth_bifunc_CbiH/CbiC', 4, NULL),
(7924, NULL, 'IPR023617', NULL, 'Tyrosine-tRNA ligase, archaeal/eukaryotic-type', 'Tyr-tRNA-ligase_arc/euk-type', 4, NULL),
(7925, NULL, 'IPR008366', NULL, 'Nuclear factor of activated T cells (NFAT)', 'NFAT', 4, NULL),
(7926, NULL, 'IPR010291', NULL, 'Ion channel regulatory protein, UNC-93', 'Ion_channel_UNC-93', 4, NULL),
(7927, NULL, 'IPR008395', NULL, 'Agenet-like domain', 'Agenet-like_dom', 3, NULL),
(7928, NULL, 'IPR008337', NULL, 'Capsule biosynthesis protein CapB', 'Capsule_biosynth_CapB', 4, NULL),
(7929, NULL, 'IPR023817', NULL, 'Frankia-40 domain', 'Frankia_40_dom', 3, NULL),
(7930, NULL, 'IPR008368', NULL, 'Voltage-dependent calcium channel, gamma subunit', 'VDCC_gsu', 4, NULL),
(7931, NULL, 'IPR009104', NULL, 'Sea anemone actinoporin-like', 'Anemon_actinoporin-like', 4, NULL),
(7932, NULL, 'IPR015038', NULL, 'Glutarate 2-hydroxylase GlaH', 'GlaH', 4, NULL),
(7933, NULL, 'IPR008873', NULL, 'TraA', 'TraA', 4, NULL),
(7934, NULL, 'IPR014988', NULL, 'Uncharacterised protein family, YqcI/YcgG', 'Uncharacterised_YqcI/YcgG', 4, NULL),
(7935, NULL, 'IPR013959', NULL, 'DASH complex subunit Dad4', 'DASH_Dad4', 4, NULL),
(7936, NULL, 'IPR013977', NULL, 'Glycine cleavage T-protein, C-terminal barrel domain', 'GCV_T_C', 3, NULL),
(7937, NULL, 'IPR008377', NULL, 'Trypanosome sialidase', 'Sialidase_trypan', 4, NULL),
(7938, NULL, 'IPR013970', NULL, 'Replication factor A protein 3', 'Rfa2', 4, NULL),
(7939, NULL, 'IPR008362', NULL, 'Melanin-concentrating hormone 2 receptor', 'MCH2_receptor', 4, NULL),
(7940, NULL, 'IPR013942', NULL, 'Mediator complex, subunit Med19, fungi', 'Mediator_Med19_fun', 4, NULL),
(7941, NULL, 'IPR008353', NULL, 'Peptidase S1B, exfoliative toxin', 'Peptidase_S1B_tx', 4, NULL),
(7942, NULL, 'IPR008327', NULL, 'Signal transduction response regulator, antiterminator', 'Sig_transdc_resp-reg_antiterm', 4, NULL),
(7943, NULL, 'IPR015030', NULL, 'Retinoblastoma-associated protein, C-terminal', 'RB_C', 3, NULL),
(7944, NULL, 'IPR010292', NULL, 'Uncharacterised protein family CreA', 'Uncharacterised_CreA', 4, NULL),
(7945, NULL, 'IPR008911', NULL, 'Short scorpion toxin, potassium channel inhibitor alpha-KTx 8/9', 'Toxin_alpha-KTx_8/9', 4, NULL),
(7946, NULL, 'IPR013742', NULL, 'Whirly transcription factor', 'Whirly', 4, NULL),
(7947, NULL, 'IPR009918', NULL, 'Protein of unknown function DUF1454', 'DUF1454', 4, NULL),
(7948, NULL, 'IPR023722', NULL, 'Enterobactin exporter, EntS', 'Enterobactin_exp_EntS', 4, NULL),
(7949, NULL, 'IPR015025', NULL, 'PoNi, C-terminal', 'PoNi_C', 3, NULL),
(7950, NULL, 'IPR013755', NULL, 'Flaviviral glycoprotein E, central domain, subdomain 1', 'Flav_gly_cen_dom_subdom1', 5, NULL),
(7951, NULL, 'IPR011405', NULL, 'Pyrophosphate-dependent phosphofructokinase SMc01852 type', 'PPi-PFK_SMc01852', 4, NULL),
(7952, NULL, 'IPR013976', NULL, 'Metal-dependent hydrolase HDOD', 'HDOD', 3, NULL),
(7953, NULL, 'IPR010932', NULL, 'Large T antigen, polyomavirus, C-terminal', 'Lg_T_Ag_Polyomavir_C', 3, NULL),
(7954, NULL, 'IPR014001', NULL, 'Helicase superfamily 1/2, ATP-binding domain', 'Helicase_ATP-bd', 3, NULL),
(7955, NULL, 'IPR012000', NULL, 'Thiamine pyrophosphate enzyme, central domain', 'Thiamin_PyroP_enz_cen_dom', 3, NULL),
(7956, NULL, 'IPR013733', NULL, 'Protein-arginine deiminase (PAD), central domain', 'Prot_Arg_deaminase_cen_dom', 3, NULL),
(7957, NULL, 'IPR008346', NULL, 'Transient receptor potential cation channel subfamily V member 5', 'TRPV5', 4, NULL),
(7958, NULL, 'IPR008322', NULL, 'Uncharacterised protein family UPF0261', 'UPF0261', 4, NULL),
(7959, NULL, 'IPR009112', NULL, 'GTP cyclohydrolase I, feedback regulatory protein', 'GTP_CycHdrlase_I_reg', 4, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(7960, NULL, 'IPR014408', NULL, 'Signal transduction c-di-GMP phosphodiesterase, EAL/HD-GYP domain-containing', 'dGMP_Pdiesterase_EAL/HD-GYP', 4, NULL),
(7961, NULL, 'IPR008906', NULL, 'HAT, C-terminal dimerisation domain', 'HATC_C_dom', 3, NULL),
(7962, NULL, 'IPR008310', NULL, 'UPF0735 ACT domain-containing protein', 'UPF0735_ACT_dom-cont', 4, NULL),
(7963, NULL, 'IPR012682', NULL, 'Transcription regulator Myc, N-terminal', 'Tscrpt_reg_Myc_N', 3, NULL),
(7964, NULL, 'IPR013806', NULL, 'Kringle-like fold', 'Kringle-like', 5, NULL),
(7965, NULL, 'IPR035083', NULL, 'Nucleocapsid, N-terminal, Arenaviridae', 'Nucleocapsid_N_arenaviridae', 3, NULL),
(7966, NULL, 'IPR010288', NULL, 'Bacterial ABC transporter EcsB', 'EcsB_ABC', 4, NULL),
(7967, NULL, 'IPR008347', NULL, 'Transient receptor potential cation channel subfamily V member 1-4', 'TrpV1-4', 4, NULL),
(7968, NULL, 'IPR008357', NULL, 'Lantibiotic leader peptide-processing serine protease', 'Lanit_process', 4, NULL),
(7969, NULL, 'IPR012348', NULL, 'Ribonucleotide reductase-like', 'RNR-like', 5, NULL),
(7970, NULL, 'IPR013134', NULL, 'RAD50, zinc hook', 'Zn_hook_RAD50', 3, NULL),
(7971, NULL, 'IPR012920', NULL, 'Ribosomal RNA methyltransferase, SPB1-like, C-terminal', 'rRNA_MeTfrase_SPB1-like_C', 3, NULL),
(7972, NULL, 'IPR018208', NULL, 'Glycoside hydrolase family 11, active site 1', 'GH11_AS_1', 0, NULL),
(7973, NULL, 'IPR008393', NULL, 'Adenovirus late L2 mu core', 'Adenovirus_late_L2_mu_core', 4, NULL),
(7974, NULL, 'IPR010259', NULL, 'Peptidase S8 propeptide/proteinase inhibitor I9', 'S8pro/Inhibitor_I9', 3, NULL),
(7975, NULL, 'IPR010278', NULL, 'Varicellovirus Gp2, glycoprotein', 'Varicellovirus_Gp2_glycop', 4, NULL),
(7976, NULL, 'IPR013757', NULL, 'DNA topoisomerase, type IIA, alpha-helical domain superfamily', 'Topo_IIA_A_a_sf', 5, NULL),
(7977, NULL, 'IPR008879', NULL, 'Coat protein, trichovirus/vitivirus', 'Coat_protein_tricho/vitivirus', 4, NULL),
(7978, NULL, 'IPR008352', NULL, 'Mitogen-activated protein (MAP) kinase p38-like', 'MAPK_p38-like', 4, NULL),
(7979, NULL, 'IPR012922', NULL, 'ORF D-335-like', 'ORF_D-335', 3, NULL),
(7980, NULL, 'IPR010267', NULL, 'Chordopoxvirus A20R', 'Chordopox_A20R', 4, NULL),
(7981, NULL, 'IPR015811', NULL, 'Methyl-coenzyme M reductase, alpha subunit, N-terminal subdomain 1', 'Me_CoM_Rdtase_asu_N_sub1', 5, NULL),
(7982, NULL, 'IPR018236', NULL, 'SAICAR synthetase, conserved site', 'SAICAR_synthetase_CS', 2, NULL),
(7983, NULL, 'IPR012919', NULL, 'SUN domain', 'SUN_dom', 3, NULL),
(7984, NULL, 'IPR013955', NULL, 'Replication factor A, C-terminal', 'Rep_factor-A_C', 3, NULL),
(7985, NULL, 'IPR018164', NULL, 'Alanyl-tRNA synthetase, class IIc, N-terminal', 'Ala-tRNA-synth_IIc_N', 3, NULL),
(7986, NULL, 'IPR018223', NULL, 'Argininosuccinate synthase, conserved site', 'Arginosuc_synth_CS', 2, NULL),
(7987, NULL, 'IPR014994', NULL, 'Domain of unknown function DUF1843', 'DUF1843', 3, NULL),
(7988, NULL, 'IPR013951', NULL, 'Histone deacetylation protein Rxt3', 'Rxt3', 4, NULL),
(7989, NULL, 'IPR008387', NULL, 'ATP synthase-coupling factor 6, mitochondrial', 'ATP_synth_f6_mt', 4, NULL),
(7990, NULL, 'IPR016049', NULL, 'RNA polymerase Rpc34-like', 'RNA_pol_Rpc34-like', 4, NULL),
(7991, NULL, 'IPR015001', NULL, 'Protein of unknown function DUF1850', 'DUF1850', 4, NULL),
(7992, NULL, 'IPR018232', NULL, 'Glycoside hydrolase, family 37, conserved site', 'Glyco_hydro_37_CS', 2, NULL),
(7993, NULL, 'IPR008890', NULL, 'Vibrio cholerae RfbT', 'V_cholerae_RfbT', 4, NULL),
(7994, NULL, 'IPR015039', NULL, 'Neutrophil cytosol factor 1, C-terminal', 'NCF1_C', 3, NULL),
(7995, NULL, 'IPR013808', NULL, 'Transglutaminase, active site', 'Transglutaminase_AS', 0, NULL),
(7996, NULL, 'IPR014424', NULL, 'Uncharacterised conserved protein UCP004897, ACT- type', 'UCP004897_ACT', 4, NULL),
(7997, NULL, 'IPR012344', NULL, 'Matrix protein, lentiviral and alpha-retroviral, N-terminal', 'Matrix_HIV/RSV_N', 5, NULL),
(7998, NULL, 'IPR008316', NULL, 'Uncharacterised conserved protein UCP029876', 'UCP029876', 4, NULL),
(7999, NULL, 'IPR012340', NULL, 'Nucleic acid-binding, OB-fold', 'NA-bd_OB-fold', 5, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(8000, NULL, 'IPR013975', NULL, 'Transcription regulator BetR, N-terminal', 'Tscrpt_reg_BetR_N', 3, NULL),
(8001, NULL, 'IPR009946', NULL, 'Autographa californica nuclear polyhedrosis virus, Orf4', 'AcMNPV_Orf4', 4, NULL),
(8002, NULL, 'IPR010985', NULL, 'Ribbon-helix-helix', 'Ribbon_hlx_hlx', 5, NULL),
(8003, NULL, 'IPR015520', NULL, 'Imaginal disc growth factor', 'IDGF', 4, NULL),
(8004, NULL, 'IPR010559', NULL, 'Signal transduction histidine kinase, internal region', 'Sig_transdc_His_kin_internal', 3, NULL),
(8005, NULL, 'IPR009435', NULL, 'Acid shock', 'Asr', 7, NULL),
(8006, NULL, 'IPR009924', NULL, 'Protein of unknown function DUF1459', 'DUF1459', 4, NULL),
(8007, NULL, 'IPR010601', NULL, 'Protein of unknown function DUF1182', 'DUF1182', 4, NULL),
(8008, NULL, 'IPR009401', NULL, 'Mediator complex subunit Med13, C-terminal', 'Med13_C', 3, NULL),
(8009, NULL, 'IPR011416', NULL, 'Predicted RNA-binding protein YdrC-type, Chlamydia', 'YdrC-type_chlamyd', 4, NULL),
(8010, NULL, 'IPR014572', NULL, 'Uncharacterised conserved protein UCP032673', 'UCP032673', 4, NULL),
(8011, NULL, 'IPR024133', NULL, 'Transmembrane protein 138', 'TM_138', 4, NULL),
(8012, NULL, 'IPR014586', NULL, 'Uncharacterised conserved protein UCP033909', 'UCP033909', 4, NULL),
(8013, NULL, 'IPR014637', NULL, 'Sorting nexin-5/6/32', 'SNX5/SNX6/SNX32', 4, NULL),
(8014, NULL, 'IPR014610', NULL, 'Globin, extracellular', 'Haemoglobin_extracell', 4, NULL),
(8015, NULL, 'IPR011714', NULL, 'Seven residue repeat', 'Seve_residue_repeat', 7, NULL),
(8016, NULL, 'IPR035118', NULL, 'Inclusion membrane protein E', 'IncE', 4, NULL),
(8017, NULL, 'IPR034062', NULL, 'Tumor necrosis factor receptor 26, N-terminal', 'TNFRSF26_N', 3, NULL),
(8018, NULL, 'IPR035107', NULL, 'tRNA thiolation protein, TtcA/Ctu1 type', 'tRNA_thiolation_TtcA_Ctu1', 4, NULL),
(8019, NULL, 'IPR010308', NULL, 'TRP, C-terminal', 'TRP_C', 3, NULL),
(8020, NULL, 'IPR014636', NULL, 'RNase H, phosphoglycerate mutase domain-containing', 'RNaseH/PGlycerate_mutase', 4, NULL),
(8021, NULL, 'IPR014606', NULL, 'D,D-heptose 7-phosphate kinase', 'Heptose_7-P_kinase', 4, NULL),
(8022, NULL, 'IPR018247', NULL, 'EF-Hand 1, calcium-binding site', 'EF_Hand_1_Ca_BS', 1, NULL),
(8023, NULL, 'IPR010560', NULL, 'Neogenin, C-terminal', 'Neogenin_C', 3, NULL),
(8024, NULL, 'IPR009443', NULL, 'Nuclear pore complex interacting protein', 'NPIP', 4, NULL),
(8025, NULL, 'IPR023954', NULL, 'C4-dicarboxylate transport protein', 'C4_dicarb_transport', 4, NULL),
(8026, NULL, 'IPR012932', NULL, 'Vitamin K epoxide reductase', 'VKOR', 3, NULL),
(8027, NULL, 'IPR009436', NULL, 'Type-1 angiotensin II receptor-associated protein', 'AGTRAP', 4, NULL),
(8028, NULL, 'IPR010989', NULL, 'SNARE', 'SNARE', 5, NULL),
(8029, NULL, 'IPR015939', NULL, 'Fumarate reductase/succinate dehydrogenase flavoprotein-like, C-terminal', 'Fum_Rdtase/Succ_DH_flav-like_C', 3, NULL),
(8030, NULL, 'IPR011704', NULL, 'ATPase, dynein-related, AAA domain', 'ATPase_dyneun-rel_AAA', 3, NULL),
(8031, NULL, 'IPR023948', NULL, 'Glutathione-regulated potassium-efflux system ancillary protein KefF', 'K_H_efflux_KefF', 4, NULL),
(8032, NULL, 'IPR009409', NULL, 'Protein of unknown function DUF1059', 'DUF1059', 4, NULL),
(8033, NULL, 'IPR009954', NULL, 'Protein of unknown function DUF1482', 'DUF1482', 4, NULL),
(8034, NULL, 'IPR009962', NULL, 'Protein of unknown function DUF1488', 'DUF1488', 4, NULL),
(8035, NULL, 'IPR010551', NULL, 'Glucose-6-phosphate isomerase, prokaryote', 'G6P_isomerase_prok', 3, NULL),
(8036, NULL, 'IPR012931', NULL, 'TraG, N-terminal, Proteobacteria', 'TraG_N_Proteobacteria', 3, NULL),
(8037, NULL, 'IPR009423', NULL, 'NADH dehydrogenase [ubiquinone] 1 subunit C2, NDUC2', 'NDUC2', 4, NULL),
(8038, NULL, 'IPR012945', NULL, 'Tubulin binding cofactor C-like domain', 'Tubulin-bd_cofactor_C_dom', 3, NULL),
(8039, NULL, 'IPR009396', NULL, 'Pigment-dispersing hormone', 'Pigment_DH', 4, NULL),
(8040, NULL, 'IPR023859', NULL, 'DNA-binding protein, curved-DNA', 'DNA-bd_curved-DNA', 4, NULL),
(8041, NULL, 'IPR014582', NULL, 'Uncharacterised conserved protein UCP033535, periplasmic lipoprotein', 'UCP033535_lipo', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(8042, NULL, 'IPR009969', NULL, 'Pneumovirus M2-2', 'Pneumo_M2-2', 4, NULL),
(8043, NULL, 'IPR018310', NULL, 'Putative endonuclease, Z1 domain', 'Put_endonuclease_Z1-dom', 3, NULL),
(8044, NULL, 'IPR012940', NULL, 'Nucleic acid binding NABP', 'NABP', 3, NULL),
(8045, NULL, 'IPR017894', NULL, 'HTH domain, IS21 transposase-type', 'HTH_IS21_transposase_type', 3, NULL),
(8046, NULL, 'IPR035099', NULL, 'Anthrax toxin, edema factor, C-terminal', 'Anthrax_toxin_C-terminal', 5, NULL),
(8047, NULL, 'IPR014575', NULL, 'Type III secretion system, secreted protein EspD', 'T3SS_EspD', 4, NULL),
(8048, NULL, 'IPR014576', NULL, 'Predicted phosphoesterase, YhaO type', 'Pesterase_YhaO', 4, NULL),
(8049, NULL, 'IPR009939', NULL, 'Fungal chitosanase', 'Chitosanase_fungal', 4, NULL),
(8050, NULL, 'IPR024700', NULL, 'Uncharacterised conserved protein, UCP020217', 'UCP020217', 4, NULL),
(8051, NULL, 'IPR009981', NULL, 'Protein of unknown function DUF1505', 'DUF1505', 4, NULL),
(8052, NULL, 'IPR010596', NULL, 'Methuselah, N-terminal domain', 'Methuselah_N_dom', 3, NULL),
(8053, NULL, 'IPR011407', NULL, '10-formyltetrahydrofolate dehydrogenase', '10_FTHF_DH', 4, NULL),
(8054, NULL, 'IPR009428', NULL, 'Beta-catenin-interacting ICAT domain', 'ICAT_dom', 3, NULL),
(8055, NULL, 'IPR009928', NULL, 'Primosomal DnaI, N-terminal', 'DnaI_N', 3, NULL),
(8056, NULL, 'IPR010978', NULL, 'Class I and II aminoacyl-tRNA synthetase, tRNA-binding arm', 'tRNA-bd_arm', 5, NULL),
(8057, NULL, 'IPR014607', NULL, 'Alkane 1-monooxygenase, rubredoxin-type', 'Alk_mOase_rubredoxin-type', 4, NULL),
(8058, NULL, 'IPR018306', NULL, 'Bacteriophage T5, Orf172 DNA-binding', 'Phage_T5_Orf172_DNA-bd', 3, NULL),
(8059, NULL, 'IPR009979', NULL, 'Bovine Lentivirus VIF', 'Lenti_VIF_2', 4, NULL),
(8060, NULL, 'IPR034741', NULL, 'Terpene cyclase-like 1, C-terminal domain', 'Terpene_cyclase-like_1_C', 3, NULL),
(8061, NULL, 'IPR009971', NULL, 'Protein of unknown function DUF1496', 'DUF1496', 4, NULL),
(8062, NULL, 'IPR015948', NULL, 'Bacteriophage PRD1, P2, C-terminal', 'Phage_PRD1_P2_C', 5, NULL),
(8063, NULL, 'IPR009418', NULL, 'Protein of unknown function DUF1067', 'DUF1067', 4, NULL),
(8064, NULL, 'IPR010980', NULL, 'Cytochrome c/b562', 'Cyt_c/b562', 5, NULL),
(8065, NULL, 'IPR014352', NULL, 'FERM/acyl-CoA-binding protein superfamily', 'FERM/acyl-CoA-bd_prot_sf', 5, NULL),
(8066, NULL, 'IPR009434', NULL, 'Neuroendocrine secretory protein 55', 'NESP55', 4, NULL),
(8067, NULL, 'IPR009973', NULL, 'Seadornavirus VP7', 'Seadorna_VP7', 4, NULL),
(8068, NULL, 'IPR024138', NULL, 'Pericentriolar material 1 protein', 'Pericentriolar_Pcm1', 4, NULL),
(8069, NULL, 'IPR012929', NULL, 'Nucleoprotein TPR/MLP1', 'TPR/MLP1', 3, NULL),
(8070, NULL, 'IPR010579', NULL, 'MHC class I, alpha chain, C-terminal', 'MHC_I_a_C', 3, NULL),
(8071, NULL, 'IPR011531', NULL, 'Bicarbonate transporter-like, transmembrane domain', 'HCO3_transpt-like_TM_dom', 3, NULL),
(8072, NULL, 'IPR011412', NULL, 'Coronamic acid biosynthesis thioesterase CmaT', 'CmaT_thioesters', 4, NULL),
(8073, NULL, 'IPR023952', NULL, 'Inosose dehydratase', 'IolE', 4, NULL),
(8074, NULL, 'IPR010310', NULL, 'Type VII secretion system ESAT-6-like', 'T7SS_ESAT-6-like', 4, NULL),
(8075, NULL, 'IPR023174', NULL, '3''5''-cyclic nucleotide phosphodiesterase, conserved site', 'PDEase_CS', 2, NULL),
(8076, NULL, 'IPR014755', NULL, 'Copper resistance protein CopC/internalin, immunoglobulin-like', 'Cu-Rt/internalin_Ig-like', 5, NULL),
(8077, NULL, 'IPR010550', NULL, 'Deoxycytidine triphosphate deaminase, bacterial', 'dCTP_deam_bac', 4, NULL),
(8078, NULL, 'IPR010563', NULL, 'Pilus assembly TraK', 'Pilus_assembly_TraK', 4, NULL),
(8079, NULL, 'IPR010582', NULL, 'Catalase immune-responsive domain', 'Catalase_immune_responsive', 3, NULL),
(8080, NULL, 'IPR011411', NULL, 'NTP Pyrophosphohydrolase MazG-related', 'MazG-related', 4, NULL),
(8081, NULL, 'IPR009388', NULL, 'Photosystem II PsbY', 'PSII_PsbY', 4, NULL),
(8082, NULL, 'IPR009422', NULL, 'Gem-associated protein 6', 'Gemin6', 4, NULL),
(8083, NULL, 'IPR018349', NULL, 'Peptidase M24A, methionine aminopeptidase, subfamily 2, binding site', 'Pept_M24A_MAP2_BS', 1, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(8084, NULL, 'IPR014645', NULL, 'Target of Myb protein 1', 'TOM1', 4, NULL),
(8085, NULL, 'IPR009398', NULL, 'Adenylate cyclase, conserved domain', 'Adcy_conserved_dom', 3, NULL),
(8086, NULL, 'IPR012930', NULL, 'TraC-like', 'TraC', 4, NULL),
(8087, NULL, 'IPR009395', NULL, 'Biogenesis of lysosome-related organelles complex 1 subunit 1', 'BLOC1S1', 4, NULL),
(8088, NULL, 'IPR015505', NULL, 'Coronin', 'Coronin', 4, NULL),
(8089, NULL, 'IPR014578', NULL, 'Predicted phosphoesterase, CT488 type', 'Pesterase_CT488', 4, NULL),
(8090, NULL, 'IPR023865', NULL, 'Aliphatic acid kinase, short-chain, conserved site', 'Aliphatic_acid_kinase_CS', 2, NULL),
(8091, NULL, 'IPR009932', NULL, 'RCS1', 'RCS1', 4, NULL),
(8092, NULL, 'IPR014591', NULL, 'Uncharacterised conserved protein UCP034455', 'UCP034455', 4, NULL),
(8093, NULL, 'IPR011711', NULL, 'GntR, C-terminal', 'GntR_C', 3, NULL),
(8094, NULL, 'IPR010574', NULL, 'L-alanine exporter AlaE', 'Ala_export_AlaE', 4, NULL),
(8095, NULL, 'IPR013848', NULL, 'Methylthiotransferase, N-terminal', 'Methylthiotransferase_N', 3, NULL),
(8096, NULL, 'IPR014577', NULL, 'Uncharacterised conserved protein UCP033093, metallophosphoesterase-type', 'UCP033093_metalloPase', 4, NULL),
(8097, NULL, 'IPR024063', NULL, 'Proteinase inhibitor I46, leech metallocarboxypeptidase inhibitor', 'Prot_inh_LCI', 5, NULL),
(8098, NULL, 'IPR014588', NULL, 'ATPase, Atu1862 type, predicted', 'ATPase_Atu1862_pred', 4, NULL),
(8099, NULL, 'IPR010573', NULL, 'Major facilitator transporter Str1/Tri12-like', 'MFS_Str1/Tri12-like', 4, NULL),
(8100, NULL, 'IPR018307', NULL, 'AVL9/DENND6 domain', 'ABL9/DENND6_dom', 3, NULL),
(8101, NULL, 'IPR009927', NULL, 'Protein of unknown function DUF1464', 'DUF1464', 4, NULL),
(8102, NULL, 'IPR011705', NULL, 'BTB/Kelch-associated', 'BACK', 3, NULL),
(8103, NULL, 'IPR018272', NULL, 'PRANC domain', 'PRANC_domain', 3, NULL),
(8104, NULL, 'IPR009982', NULL, 'Seadornavirus VP6', 'Seadorna_VP6', 4, NULL),
(8105, NULL, 'IPR009959', NULL, 'Polyketide cyclase SnoaL-like', 'Cyclase_SnoaL-like', 4, NULL),
(8106, NULL, 'IPR009972', NULL, 'Protein of unknown function DUF1497', 'DUF1497', 4, NULL),
(8107, NULL, 'IPR015955', NULL, 'Lactate dehydrogenase/glycoside hydrolase, family 4, C-terminal', 'Lactate_DH/Glyco_Ohase_4_C', 5, NULL),
(8108, NULL, 'IPR013791', NULL, 'RNA 3''-terminal phosphate cyclase, insert domain', 'RNA3''-term_phos_cycl_insert', 3, NULL),
(8109, NULL, 'IPR009944', NULL, 'Amastin surface glycoprotein', 'Amastin', 4, NULL),
(8110, NULL, 'IPR018288', NULL, 'F420-dehydrogenase, subunit FpoO', 'F420H2-DH_FpoO', 4, NULL),
(8111, NULL, 'IPR010611', NULL, '3D domain', '3D_dom', 3, NULL),
(8112, NULL, 'IPR013856', NULL, 'Peptidase M4 domain', 'Peptidase_M4_domain', 3, NULL),
(8113, NULL, 'IPR023893', NULL, 'Quinone modification maturase, putative', 'Q_mod_maturase_put', 4, NULL),
(8114, NULL, 'IPR010981', NULL, 'SinR repressor/SinI anti-repressor, dimerisation domain', 'SinR/SinI_dimer_dom', 3, NULL),
(8115, NULL, 'IPR023922', NULL, 'Sulphate-starvation-induced SfnB', 'S04_starv_induced_SfnB', 4, NULL),
(8116, NULL, 'IPR012934', NULL, 'Zinc finger, AD-type', 'Znf_AD', 3, NULL),
(8117, NULL, 'IPR010561', NULL, 'Protein LIN-9/Protein ALWAYS EARLY', 'LIN-9/ALY1', 4, NULL),
(8118, NULL, 'IPR010571', NULL, 'Outer membrane lipoprotein, Omp19, bacterial', 'OM_lipoprot_Omp19_bac', 4, NULL),
(8119, NULL, 'IPR023930', NULL, 'Putative heme d1 biosynthesis protein, NirJ1', 'NirJ1', 4, NULL),
(8120, NULL, 'IPR033144', NULL, 'Cathepsin D', 'Cathepsin_D', 4, NULL),
(8121, NULL, 'IPR015958', NULL, 'Potassium transporter Trk, fungi', 'Trk_fungi', 4, NULL),
(8122, NULL, 'IPR010591', NULL, 'ATP11', 'ATP11', 4, NULL),
(8123, NULL, 'IPR018311', NULL, 'Autoinducer synthesis, conserved site', 'Autoind_synth_CS', 2, NULL),
(8124, NULL, 'IPR015946', NULL, 'K homology domain-like, alpha/beta', 'KH_dom-like_a/b', 5, NULL),
(8125, NULL, 'IPR013044', NULL, 'Domain of unknown function DUF1548', 'DUF1548', 3, NULL),
(8126, NULL, 'IPR015943', NULL, 'WD40/YVTN repeat-like-containing domain superfamily', 'WD40/YVTN_repeat-like_dom_sf', 5, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(8127, NULL, 'IPR014592', NULL, 'Predicted P-loop ATP-binding protein, VCA0200', 'P-loop_UCP034888', 4, NULL),
(8128, NULL, 'IPR012943', NULL, 'Centrosomin, N-terminal motif 1', 'Cnn_1N', 3, NULL),
(8129, NULL, 'IPR009941', NULL, 'Protein of unknown function DUF1473', 'DUF1473', 4, NULL),
(8130, NULL, 'IPR024032', NULL, 'His-Xaa-Ser system radical SAM maturase HxsC', 'rSAM_paired_HxsC', 4, NULL),
(8131, NULL, 'IPR015947', NULL, 'PUA-like superfamily', 'PUA-like_sf', 5, NULL),
(8132, NULL, 'IPR014579', NULL, 'Predicted 5''-nucleotidase, SA0022 type', '5NTD_SA0022', 4, NULL),
(8133, NULL, 'IPR011598', NULL, 'Myc-type, basic helix-loop-helix (bHLH) domain', 'bHLH_dom', 3, NULL),
(8134, NULL, 'IPR009397', NULL, 'Vesiculovirus matrix', 'Vesiculo_matrix', 4, NULL),
(8135, NULL, 'IPR010307', NULL, 'Laminin domain II', 'Laminin_dom_II', 3, NULL),
(8136, NULL, 'IPR009938', NULL, 'Nmi/IFP 35 domain, N-terminal', 'Nmi/IFP35_N', 3, NULL),
(8137, NULL, 'IPR011706', NULL, 'Multicopper oxidase, C-terminal', 'Cu-oxidase_C', 3, NULL),
(8138, NULL, 'IPR017903', NULL, 'COS domain', 'COS_domain', 3, NULL),
(8139, NULL, 'IPR014647', NULL, 'CST complex  subunit Stn1', 'Stn1', 4, NULL),
(8140, NULL, 'IPR023856', NULL, 'Bacilliredoxin reductase Bdr', 'Bdr', 4, NULL),
(8141, NULL, 'IPR015517', NULL, 'Deoxycytidylate deaminase-related', 'dCMP_deaminase-rel', 4, NULL),
(8142, NULL, 'IPR009444', NULL, 'Conjugal transfer, TraD, alpha-type', 'Conjugal_tfr_TraD_a-type', 4, NULL),
(8143, NULL, 'IPR015914', NULL, 'Purple acid phosphatase, N-terminal', 'Purple_acid_Pase_N', 3, NULL),
(8144, NULL, 'IPR014565', NULL, 'Exopolysaccharide biosynthesis, EpsL, firmicutes', 'EpsL_firmicutes', 4, NULL),
(8145, NULL, 'IPR009976', NULL, 'Exocyst complex component Sec10-like', 'Sec10-like', 4, NULL),
(8146, NULL, 'IPR010603', NULL, 'Zinc finger, ClpX C4-type', 'Znf_CppX_C4', 3, NULL),
(8147, NULL, 'IPR023959', NULL, 'Lipoprotein LpqB', 'Lipoprotein_LpqB', 4, NULL),
(8148, NULL, 'IPR034841', NULL, 'DPE2, CBM20 domain 2', 'CBM20_DPE2_2', 3, NULL),
(8149, NULL, 'IPR018243', NULL, 'Neuromodulin, palmitoylation site', 'Neuromodulin_palmitoyl_site', 6, NULL),
(8150, NULL, 'IPR009430', NULL, 'Gas vesicle protein GvpL/GvpF', 'Gas-vesicle_GvpL/GvpF', 4, NULL),
(8151, NULL, 'IPR010604', NULL, 'Plant AUGMIN subunit 7', 'Plant_AUG7', 4, NULL),
(8152, NULL, 'IPR010607', NULL, 'Protein of unknown function DUF1194', 'DUF1194', 4, NULL),
(8153, NULL, 'IPR023911', NULL, 'Uncharacterised protein family, AIR synthase-related', 'UPF_AIR_synthase-rel', 4, NULL),
(8154, NULL, 'IPR009978', NULL, 'Putative Na+/H+ antiporter', 'Na_H_antiport_3', 4, NULL),
(8155, NULL, 'IPR010605', NULL, 'Protein of unknown function DUF1191', 'DUF1191', 4, NULL),
(8156, NULL, 'IPR014569', NULL, 'Ubiquinol-cytochrome c chaperone, CBP3-related', 'Ubq_cyt-c_CBP3-rel', 4, NULL),
(8157, NULL, 'IPR009960', NULL, 'Fungal fruit body lectin', 'Fruit_body_lectin_fun', 4, NULL),
(8158, NULL, 'IPR009379', NULL, 'Structural protein VP1/VP3', 'VP1_VP3', 4, NULL),
(8159, NULL, 'IPR009967', NULL, 'Flagellum biosynthesis repressor FlbT', 'Flagellum_FlbT', 4, NULL),
(8160, NULL, 'IPR010987', NULL, 'Glutathione S-transferase, C-terminal-like', 'Glutathione-S-Trfase_C-like', 3, NULL),
(8161, NULL, 'IPR010305', NULL, 'Protein of unknown function DUF903', 'DUF903', 4, NULL),
(8162, NULL, 'IPR024062', NULL, 'Bacteriophage PBS2, uracil-glycosylase inhibitor', 'Phage_PBS2_Ugi', 5, NULL),
(8163, NULL, 'IPR034056', NULL, 'PatG/PatA-like domain', 'Pep_S8_PatG/PatA-like', 3, NULL),
(8164, NULL, 'IPR011415', NULL, 'Predicted bifunctional spore maturation protein, fused SpmA/SpmB', 'SpmA_SpmB', 4, NULL),
(8165, NULL, 'IPR009406', NULL, 'Protein of unknown function DUF1056', 'DUF1056', 4, NULL),
(8166, NULL, 'IPR015525', NULL, 'Breast cancer type 2 susceptibility protein', 'BRCA2', 4, NULL),
(8167, NULL, 'IPR009389', NULL, 'Protein of unknown function DUF1045', 'DUF1045', 4, NULL),
(8168, NULL, 'IPR018270', NULL, 'Concentrative nucleoside transporter, metazoan/bacterial', 'C_nuclsd_transpt_met_bac', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(8169, NULL, 'IPR012946', NULL, 'X8 domain', 'X8', 3, NULL),
(8170, NULL, 'IPR011708', NULL, 'Bacterial DNA polymerase III, alpha subunit, NTPase domain', 'DNA_pol3_alpha_NTPase_dom', 3, NULL),
(8171, NULL, 'IPR009378', NULL, 'Condensin II complex subunit H2, N-terminal', 'H2_N', 3, NULL),
(8172, NULL, 'IPR009935', NULL, 'Protein of unknown function DUF1467', 'DUF1467', 4, NULL),
(8173, NULL, 'IPR024131', NULL, 'Uncharacterised protein family UPF0489', 'UPF0489', 4, NULL),
(8174, NULL, 'IPR014580', NULL, 'Uncharacterised conserved protein UCP033199', 'UCP033199', 4, NULL),
(8175, NULL, 'IPR014587', NULL, 'Uncharacterised conserved protein UCP034077', 'UCP034077', 4, NULL),
(8176, NULL, 'IPR035100', NULL, 'Transcription elongation factor, IIS-type', 'TF_IIS-typ', 4, NULL),
(8177, NULL, 'IPR015814', NULL, 'Phosphogluconate dehydrogenase, NAD-binding, putative, C-terminal', 'Pgluconate_DH_NAD-bd_C', 3, NULL),
(8178, NULL, 'IPR023229', NULL, 'Type II secretion system protein GspM, periplasmic domain superfamily', 'T2SS_M_periplasmic_sf', 5, NULL),
(8179, NULL, 'IPR018238', NULL, 'Glycoside hydrolase, family 14, conserved site', 'Glyco_hydro_14_CS', 2, NULL),
(8180, NULL, 'IPR015953', NULL, 'Methane monooxygenase, gamma chain, domain 2', 'Me_mOase_g_dom2', 5, NULL),
(8181, NULL, 'IPR015506', NULL, 'Dishevelled-related protein', 'Dsh/Dvl-rel', 4, NULL),
(8182, NULL, 'IPR009931', NULL, 'Curtovirus V2', 'Curto_V2', 4, NULL),
(8183, NULL, 'IPR011709', NULL, 'DEAD-box helicase, OB fold', 'DEAD-box_helicase_OB_fold', 3, NULL),
(8184, NULL, 'IPR014648', NULL, 'Neuropilin', 'Neuropilin', 4, NULL),
(8185, NULL, 'IPR023172', NULL, 'Peptidase S51, dipeptidase E', 'Peptidase_S51_dipeptidase-E', 4, NULL),
(8186, NULL, 'IPR018354', NULL, 'Snake toxin, conserved site', 'Snake_toxin_con_site', 2, NULL),
(8187, NULL, 'IPR010595', NULL, 'Protein of unknown function DUF1161', 'DUF1161', 4, NULL),
(8188, NULL, 'IPR009975', NULL, 'Mycoplasma P30', 'P30', 4, NULL),
(8189, NULL, 'IPR010587', NULL, 'Melanoplus sanguinipes entomopoxvirus (MsEPV), Orf214', 'MsEPV_Orf214', 4, NULL),
(8190, NULL, 'IPR013801', NULL, 'STAT transcription factor, DNA-binding', 'STAT_TF_DNA-bd', 3, NULL),
(8191, NULL, 'IPR023898', NULL, 'YydF/SAG 2028', 'YydF/SAG_2028', 4, NULL),
(8192, NULL, 'IPR010562', NULL, 'Haemolymph juvenile hormone binding', 'Haemolymph_juvenile_hormone-bd', 4, NULL),
(8193, NULL, 'IPR014603', NULL, 'Formate dehydrogenase iron-sulphur subunit', 'Formate_DH_Fe-S_su', 4, NULL),
(8194, NULL, 'IPR013853', NULL, 'Galactitol permease IIC component', 'GatC', 4, NULL),
(8195, NULL, 'IPR010564', NULL, 'Protein of unknown function DUF1137', 'DUF1137', 4, NULL),
(8196, NULL, 'IPR035116', NULL, 'Protein of unknown function DUF5510', 'DUF5510', 4, NULL),
(8197, NULL, 'IPR009985', NULL, 'Crinivirus P26', 'Crinivirus_P26', 4, NULL),
(8198, NULL, 'IPR015912', NULL, 'Phosphofructokinase, conserved site', 'Phosphofructokinase_CS', 2, NULL),
(8199, NULL, 'IPR018394', NULL, 'Cryptochrome/DNA photolyase class 1, conserved site, C-terminal', 'DNA_photolyase_1_CS_C', 2, NULL),
(8200, NULL, 'IPR009425', NULL, 'Single-strand annealing protein SAK3', 'SSAP_Sak3', 4, NULL),
(8201, NULL, 'IPR009956', NULL, 'Post-segregation antitoxin CcdA', 'Post-segregation_anti-tox_CcdA', 4, NULL),
(8202, NULL, 'IPR023914', NULL, 'Pyrrolysine biosynthesis protein PylD', 'Pyrrolys_PylD', 4, NULL),
(8203, NULL, 'IPR023944', NULL, 'Anaerobic nitric oxide reductase transcription regulator', 'NorR', 4, NULL),
(8204, NULL, 'IPR014756', NULL, 'Immunoglobulin E-set', 'Ig_E-set', 5, NULL),
(8205, NULL, 'IPR014581', NULL, 'Uncharacterised conserved protein UCP033303', 'UCP033303', 4, NULL),
(8206, NULL, 'IPR010600', NULL, 'Inter-alpha-trypsin inhibitor heavy chain, C-terminal', 'ITI_HC_C', 3, NULL),
(8207, NULL, 'IPR018330', NULL, 'RecT family', 'RecT_fam', 4, NULL),
(8208, NULL, 'IPR023956', NULL, 'Acireductone dioxygenase ARD, bacteria', 'ARD_bac', 4, NULL),
(8209, NULL, 'IPR014631', NULL, 'Cellular repressor of E1A-stimulated genes (CREG)', 'CREG', 4, NULL),
(8210, NULL, 'IPR015940', NULL, 'Ubiquitin-associated domain', 'UBA', 3, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(8211, NULL, 'IPR014567', NULL, 'Uncharacterised conserved protein UCP031900', 'UCP031900', 4, NULL),
(8212, NULL, 'IPR034746', NULL, 'POTRA domain', 'POTRA', 3, NULL),
(8213, NULL, 'IPR018274', NULL, 'PEP-utilising enzyme, active site', 'PEP_util_AS', 0, NULL),
(8214, NULL, 'IPR013792', NULL, 'RNA 3''-terminal phosphate cyclase/enolpyruvate transferase, alpha/beta', 'RNA3''P_cycl/enolpyr_Trfase_a/b', 5, NULL),
(8215, NULL, 'IPR013046', NULL, 'Phage baseplate assembly protein V/Gp45', 'GpV/Gp45', 4, NULL),
(8216, NULL, 'IPR023946', NULL, 'Endo-type membrane-bound lytic murein transglycosylase A', 'EmtA', 4, NULL),
(8217, NULL, 'IPR015950', NULL, 'Chemokine-binding M3, subdomain 1, viral', 'Chemokine-bd_M3_sub1_vir', 5, NULL),
(8218, NULL, 'IPR010991', NULL, 'p53, tetramerisation domain', 'p53_tetrameristn', 3, NULL),
(8219, NULL, 'IPR015957', NULL, 'Cytolethal distending toxin A', 'CDtoxinA', 4, NULL),
(8220, NULL, 'IPR018245', NULL, 'Gonadotropin, beta subunit, conserved site', 'Gonadotropin_bsu_CS', 2, NULL),
(8221, NULL, 'IPR011265', NULL, 'GABA permease', 'GABA_permease', 4, NULL),
(8222, NULL, 'IPR010992', NULL, 'Integration host factor (IHF)-like DNA-binding domain superfamily', 'IHF-like_DNA-bd_dom_sf', 5, NULL),
(8223, NULL, 'IPR014444', NULL, 'Damage-control phosphatase PH1575-like', 'PH1575-like', 4, NULL),
(8224, NULL, 'IPR015919', NULL, 'Cadherin-like superfamily', 'Cadherin-like_sf', 5, NULL),
(8225, NULL, 'IPR023891', NULL, 'Pyrrolysine biosynthesis protein PylB', 'Pyrrolys_PylB', 4, NULL),
(8226, NULL, 'IPR011566', NULL, 'Ubiquinone biosynthesis protein Coq7', 'Ubq_synth_Coq7', 4, NULL),
(8227, NULL, 'IPR023170', NULL, 'Helix-hairpin-helix, base-excision DNA repair, C-terminal', 'HhH_base_excis_C', 5, NULL),
(8228, NULL, 'IPR014571', NULL, 'Uncharacterised conserved protein UCP032620', 'UCP032620', 4, NULL),
(8229, NULL, 'IPR009420', NULL, 'Flagellar protein FlhE', 'FlhE', 4, NULL),
(8230, NULL, 'IPR014605', NULL, 'Signal transduction response regulator PhyR-like, alphaproteobacteria', 'Sig_resp-reg_PhyR', 4, NULL),
(8231, NULL, 'IPR009970', NULL, 'Histone H1-like nucleoprotein HC2', 'HC2', 4, NULL),
(8232, NULL, 'IPR012935', NULL, 'Zinc finger, C3HC-like', 'Znf_C3HC-like', 3, NULL),
(8233, NULL, 'IPR012947', NULL, 'Threonyl/alanyl tRNA synthetase, SAD', 'tRNA_SAD', 3, NULL),
(8234, NULL, 'IPR009963', NULL, 'Protein of unknown function DUF1490', 'DUF1490', 4, NULL),
(8235, NULL, 'IPR009968', NULL, 'Protein of unknown function DUF1494', 'DUF1494', 4, NULL),
(8236, NULL, 'IPR010594', NULL, 'Autographa californica nuclear polyhedrosis virus (AcMNPV), Ac75', 'AcMNPV_Ac75', 4, NULL),
(8237, NULL, 'IPR011548', NULL, '3-hydroxyisobutyrate dehydrogenase', 'HIBADH', 4, NULL),
(8238, NULL, 'IPR010610', NULL, 'Erythromycin biosynthesis protein CIII-like, central', 'EryCIII-like_central', 3, NULL),
(8239, NULL, 'IPR013274', NULL, 'Peptidase M12B, ADAM-TS1', 'Pept_M12B_ADAM-TS1', 4, NULL),
(8240, NULL, 'IPR023225', NULL, 'Salmonella invasion protein A, chaperone-binding', 'SipA_chaperone-bd', 5, NULL),
(8241, NULL, 'IPR009980', NULL, 'Human herpesvirus U26', 'Herpes_U26', 4, NULL),
(8242, NULL, 'IPR015911', NULL, 'Phosphoglycerate kinase, conserved site', 'Phosphoglycerate_kinase_CS', 2, NULL),
(8243, NULL, 'IPR034708', NULL, 'Envelope glycoprotein L', 'HSV_GL_alphagamma', 4, NULL),
(8244, NULL, 'IPR012939', NULL, 'Glycosyl hydrolase family 92', 'Glyco_hydro_92', 3, NULL),
(8245, NULL, 'IPR011406', NULL, 'Globin, trematode', 'Globin_trematode', 4, NULL),
(8246, NULL, 'IPR018319', NULL, 'L-seryl-tRNA selenium transferase-like', 'SelA-like', 4, NULL),
(8247, NULL, 'IPR010608', NULL, 'Protein of unknown function DUF1195', 'DUF1195', 4, NULL),
(8248, NULL, 'IPR010557', NULL, 'Protein of unknown function DUF1133', 'DUF1133', 4, NULL),
(8249, NULL, 'IPR009446', NULL, 'Mitochondrial genome maintenance protein Mgm101', 'Mgm101', 4, NULL),
(8250, NULL, 'IPR009986', NULL, 'Sigma factor-binding transcriptional regulator Crl', 'Tscrpt_reg_Crl', 4, NULL),
(8251, NULL, 'IPR014573', NULL, 'Uncharacterised conserved protein UCP032806', 'UCP032806', 4, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(8252, NULL, 'IPR010982', NULL, 'Lambda repressor-like, DNA-binding domain superfamily', 'Lambda_DNA-bd_dom_sf', 5, NULL),
(8253, NULL, 'IPR010613', NULL, 'Pescadillo', 'PES', 4, NULL),
(8254, NULL, 'IPR013092', NULL, 'Connexin, N-terminal', 'Connexin_N', 3, NULL),
(8255, NULL, 'IPR012997', NULL, 'Rare lipoprotein A', 'RplA', 3, NULL),
(8256, NULL, 'IPR018246', NULL, 'AP endonuclease 2, zinc binding site', 'AP_endonuc_F2_Zn_BS', 1, NULL),
(8257, NULL, 'IPR009966', NULL, 'Prosystemin/Systemin', 'Prosystemin/Systemin', 4, NULL),
(8258, NULL, 'IPR014646', NULL, 'Replication factor A protein 2', 'Rfa2/RPA32', 4, NULL),
(8259, NULL, 'IPR009930', NULL, 'Structural protein Vp10, Seadornavirus', 'Seadorna_Vp10', 4, NULL),
(8260, NULL, 'IPR009921', NULL, 'Domain of unknown function DUF1456', 'DUF1456', 3, NULL),
(8261, NULL, 'IPR009945', NULL, 'ATPase inhibitor subunit zeta', 'ATPase_inh_sub_z', 4, NULL),
(8262, NULL, 'IPR014602', NULL, 'Uncharacterised conserved protein UCP036226', 'UCP036226', 4, NULL),
(8263, NULL, 'IPR010306', NULL, 'Alpha-D-ribose 1-methylphosphonate 5-phosphate C-P-lyase', 'PhnJ', 4, NULL),
(8264, NULL, 'IPR018321', NULL, 'Glucosamine-6-phosphate isomerase, conserved site', 'Glucosamine6P_isomerase_CS', 2, NULL),
(8265, NULL, 'IPR010570', NULL, 'UpxZ family', 'UpxZ_fam', 4, NULL),
(8266, NULL, 'IPR011707', NULL, 'Multicopper oxidase, N-terminal', 'Cu-oxidase_N', 3, NULL),
(8267, NULL, 'IPR012936', NULL, 'Endoplasmic reticulum vesicle transporter, C-terminal', 'Erv_C', 3, NULL),
(8268, NULL, 'IPR009419', NULL, 'Viral polyprotein, parechovirus P3A', 'VPP_parechovir_P3A', 3, NULL),
(8269, NULL, 'IPR014608', NULL, 'ATP-citrate synthase', 'ATP-citrate_synthase', 4, NULL),
(8270, NULL, 'IPR024135', NULL, 'Ragulator complex protein LAMTOR5', 'LAMTOR5', 4, NULL),
(8271, NULL, 'IPR014570', NULL, 'Encapsidation protein CP3', 'Encapsidation_CP3', 4, NULL),
(8272, NULL, 'IPR012944', NULL, 'RagB/SusD domain', 'SusD_RagB_dom', 3, NULL),
(8273, NULL, 'IPR010609', NULL, 'Gp5, C-terminal', 'Gp5_C', 7, NULL),
(8274, NULL, 'IPR034717', NULL, 'Ribonucleotide reductase large subunit, Alphaherpesviruses', 'HSV_RIR1', 4, NULL),
(8275, NULL, 'IPR011710', NULL, 'Coatomer beta subunit, C-terminal', 'Coatomer_bsu_C', 3, NULL),
(8276, NULL, 'IPR010586', NULL, 'Type 3 secretion system stator protein', 'T3SS_stator_protein', 4, NULL),
(8277, NULL, 'IPR011712', NULL, 'Signal transduction histidine kinase, subgroup 3, dimerisation and phosphoacceptor domain', 'Sig_transdc_His_kin_sub3_dim/P', 3, NULL),
(8278, NULL, 'IPR015932', NULL, 'Aconitase, domain 2', 'Aconitase_dom2', 5, NULL),
(8279, NULL, 'IPR011414', NULL, 'Uncharacterised conserved protein UCP036541', 'UCP036541_AIR', 4, NULL),
(8280, NULL, 'IPR010555', NULL, 'CSPG5, sulphate attachment domain', 'CSPG5_S_attach_dom', 3, NULL),
(8281, NULL, 'IPR009953', NULL, 'Dinitrogenase reductase ADP-ribosyltransferase', 'DRA_trans', 4, NULL),
(8282, NULL, 'IPR010572', NULL, 'Prophage tail endopeptidase', 'Prophage_Tail', 3, NULL),
(8283, NULL, 'IPR010583', NULL, 'MltA-interacting MipA', 'MipA', 4, NULL),
(8284, NULL, 'IPR009445', NULL, 'TMEM85/ER membrane protein complex subunit 4', 'TMEM85/Emc4', 4, NULL),
(8285, NULL, 'IPR009942', NULL, 'Protein of unknown function DUF1474', 'DUF1474', 4, NULL),
(8286, NULL, 'IPR009957', NULL, 'Protein of unknown function DUF1484', 'DUF1484', 4, NULL),
(8287, NULL, 'IPR024128', NULL, 'T-cell surface glycoprotein CD3 zeta subunit', 'T-cell_CD3_zeta', 4, NULL),
(8288, NULL, 'IPR009410', NULL, 'Allene oxide cyclase', 'Allene_ox_cyc', 4, NULL),
(8289, NULL, 'IPR023949', NULL, 'RNA polymerase-associated protein RapA', 'Helicase_RapA', 4, NULL),
(8290, NULL, 'IPR010568', NULL, 'Chlorovirus glycoprotein repeat', 'Chlorovirusi_glycop_rpt', 7, NULL),
(8291, NULL, 'IPR009424', NULL, 'Arabinogalactan protein 16/20/22/41', 'AGP16/20/22/41', 4, NULL),
(8292, NULL, 'IPR011611', NULL, 'Carbohydrate kinase PfkB', 'PfkB_dom', 3, NULL),
(8293, NULL, 'IPR034699', NULL, 'DNA-directed DNA polymerase T7', 'DPOL_T7', 4, NULL),
(8294, NULL, 'IPR011759', NULL, 'Cytochrome C oxidase subunit II, transmembrane domain', 'Cyt_c_oxidase_su2_TM_dom', 3, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(8295, NULL, 'IPR018276', NULL, 'DET1- and DDB1-associated protein 1, N-terminal', 'DDA1_N', 3, NULL),
(8296, NULL, 'IPR009382', NULL, 'Coleoptericin', 'Coleoptericin', 4, NULL),
(8297, NULL, 'IPR014640', NULL, 'Imidazole glycerol phosphate synthase HisHF', 'IGPS_HisHF', 4, NULL),
(8298, NULL, 'IPR034711', NULL, 'DNA replication helicase, Herpesvirus', 'HSV_HELI', 4, NULL),
(8299, NULL, 'IPR024130', NULL, 'DAP1/DAPL1', 'DAP1/DAPL1', 4, NULL),
(8300, NULL, 'IPR018240', NULL, 'Clathrin adaptor, mu subunit, conserved site', 'Clathrin_mu_CS', 2, NULL),
(8301, NULL, 'IPR009417', NULL, 'Rice tungro bacilliform virus P12', 'RTBV_P12', 4, NULL),
(8302, NULL, 'IPR012942', NULL, 'SRR1-like domain', 'SRR1-like', 3, NULL),
(8303, NULL, 'IPR009447', NULL, 'Phosphatidylinositol anchor biosynthesis protein PIGW/GWT1', 'PIGW/GWT1', 4, NULL),
(8304, NULL, 'IPR009394', NULL, 'DNA repair protein MmcB-like', 'MmcB-like', 4, NULL),
(8305, NULL, 'IPR009977', NULL, 'Mig-14', 'Mig-14', 4, NULL),
(8306, NULL, 'IPR018241', NULL, 'Anion exchange, conserved site', 'Anion_exchange_CS', 2, NULL),
(8307, NULL, 'IPR023958', NULL, 'Malate dehydrogenase, type 1, bacterial', 'Malate_DH_type1_bac', 4, NULL),
(8308, NULL, 'IPR010581', NULL, 'Protein of unknown function DUF1152', 'DUF1152', 4, NULL),
(8309, NULL, 'IPR011410', NULL, 'Nucleoside diphosphate kinase 7', 'NDPK7', 4, NULL),
(8310, NULL, 'IPR034743', NULL, 'RH1 domain', 'RH1', 3, NULL),
(8311, NULL, 'IPR034707', NULL, 'Envelope glycoprotein N', 'HSV_GN', 4, NULL),
(8312, NULL, 'IPR015926', NULL, 'Cytolysin/lectin', 'Cytolysin/lectin', 5, NULL),
(8313, NULL, 'IPR011610', NULL, 'S-adenosyl-L-methionine-dependent methyltransferase, putative', 'CHP00027_methylltransferase', 4, NULL),
(8314, NULL, 'IPR009415', NULL, 'Omega-atracotoxin', 'Omega-atracotox', 4, NULL),
(8315, NULL, 'IPR009983', NULL, 'Uncharacterised protein family UPF0358', 'UPF0358', 4, NULL),
(8316, NULL, 'IPR017899', NULL, 'Vacuolar protein sorting-associated, VPS28, C-terminal', 'VPS28_C', 3, NULL),
(8317, NULL, 'IPR010558', NULL, 'Caenorhabditis elegans ly-6-related', 'Ly-6-related', 4, NULL),
(8318, NULL, 'IPR015527', NULL, 'Peptidase C26, gamma-glutamyl hydrolase', 'Pept_C26_g-glut_hydrolase', 4, NULL),
(8319, NULL, 'IPR009391', NULL, '23S rRNA methylase leader peptide', 'ErmCL', 4, NULL),
(8320, NULL, 'IPR009400', NULL, 'TFIIH subunit TTDA/Tfb5', 'TFIIH_TTDA/Tfb5', 4, NULL),
(8321, NULL, 'IPR014635', NULL, 'Alpha-amylase, MalS type', 'A_amylase_MalS', 4, NULL),
(8322, NULL, 'IPR010593', NULL, 'Protein of unknown function DUF1159', 'DUF1159', 4, NULL),
(8323, NULL, 'IPR009416', NULL, 'ESAT-6-like protein, Mycobacterium', 'ESAT-6-like_Myco', 4, NULL),
(8324, NULL, 'IPR010566', NULL, 'Haemolysin-type calcium binding-related', 'Haemolys_ca-bd', 3, NULL),
(8325, NULL, 'IPR011408', NULL, 'Aldehyde dehydrogenase', 'Aldehyde_DH', 4, NULL),
(8326, NULL, 'IPR009933', NULL, 'T-DNA border endonuclease VirD1', 'VirD1', 4, NULL),
(8327, NULL, 'IPR010578', NULL, 'Single-minded, C-terminal', 'SIM_C', 3, NULL),
(8328, NULL, 'IPR010619', NULL, 'Threonine/serine exporter-like, N-terminal domain', 'ThrE-like_N', 3, NULL),
(8329, NULL, 'IPR013154', NULL, 'Alcohol dehydrogenase, N-terminal', 'ADH_N', 3, NULL),
(8330, NULL, 'IPR010592', NULL, 'Extracytoplasmic thiamine-binding lipoprotein', 'CypI', 4, NULL),
(8331, NULL, 'IPR015500', NULL, 'Peptidase S8, subtilisin-related', 'Peptidase_S8_subtilisin-rel', 4, NULL),
(8332, NULL, 'IPR009922', NULL, 'Protein of unknown function DUF1457', 'DUF1457', 4, NULL),
(8333, NULL, 'IPR009402', NULL, 'Orthopoxvirus A47', 'Orthopox_A47', 4, NULL),
(8334, NULL, 'IPR009438', NULL, 'Phytosulfokine', 'Phytosulfokine', 4, NULL),
(8335, NULL, 'IPR009385', NULL, 'Protein PsiB', 'Plasmid_inh_PsiB', 4, NULL),
(8336, NULL, 'IPR009413', NULL, 'Hemolysin, aegerolysin type', 'Aegerolysin-typ', 4, NULL),
(8337, NULL, 'IPR018393', NULL, 'NADH-plastoquinone oxidoreductase, chain 5 subgroup', 'NADHpl_OxRdtase_5_subgr', 4, NULL),
(8338, NULL, 'IPR009437', NULL, 'Lamprin', 'Lamprin', 4, NULL),
(8339, NULL, 'IPR009407', NULL, 'Viral polyprotein, parechovirus P3B', 'VPP_parechovir_P3B', 3, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(8340, NULL, 'IPR018313', NULL, 'Solute-binding protein family 3, conserved site', 'SBP_3_CS', 2, NULL),
(8341, NULL, 'IPR014612', NULL, 'Ribonucleases P/MRP protein subunit Rpp20/Pop7', 'Pop7/Rpp20', 4, NULL),
(8342, NULL, 'IPR009380', NULL, 'Protein of unknown function DUF1036', 'DUF1036', 4, NULL),
(8343, NULL, 'IPR010979', NULL, 'Ribosomal protein S13-like, H2TH', 'Ribosomal_S13-like_H2TH', 5, NULL),
(8344, NULL, 'IPR023962', NULL, 'Probable phosphoketolase', 'Phosphoketolase', 4, NULL),
(8345, NULL, 'IPR011703', NULL, 'ATPase, AAA-3', 'ATPase_AAA-3', 3, NULL),
(8346, NULL, 'IPR013151', NULL, 'Immunoglobulin', 'Immunoglobulin', 3, NULL),
(8347, NULL, 'IPR014597', NULL, 'ABC transporter, periplasmic substrate-binding protein, predicted', 'ABC_tp_sb', 4, NULL),
(8348, NULL, 'IPR018335', NULL, 'Transcription regulator HTH, Crp-type, conserved site', 'Tscrpt_reg_HTH_Crp-type_CS', 2, NULL),
(8349, NULL, 'IPR013849', NULL, 'DNA helicase, Holliday junction RuvA type, domain I, bacterial', 'DNA_helicase_Holl-junc_RuvA_I', 3, NULL),
(8350, NULL, 'IPR012933', NULL, 'HicA mRNA interferase family', 'HicA_mRNA_interferase', 4, NULL),
(8351, NULL, 'IPR018338', NULL, 'Carbonic anhydrase, alpha-class, conserved site', 'Carbonic_anhydrase_a-class_CS', 2, NULL),
(8352, NULL, 'IPR023947', NULL, 'Glutathione-regulated potassium-efflux system ancillary protein KefG', 'K_H_efflux_KefG', 4, NULL),
(8353, NULL, 'IPR035144', NULL, 'Proteasome subunit alpha 1', 'Proteasome_alpha1', 4, NULL),
(8354, NULL, 'IPR018312', NULL, 'Chromosomal replication control, initiator DnaA, conserved site', 'Chromosome_initiator_DnaA_CS', 2, NULL),
(8355, NULL, 'IPR009926', NULL, 'Type III secretion system flagellar brake protein YcgR, PilZN domain', 'T3SS_YcgR_PilZN', 3, NULL),
(8356, NULL, 'IPR015815', NULL, '3-hydroxyisobutyrate dehydrogenase-related', 'HIBADH-related', 4, NULL),
(8357, NULL, 'IPR035117', NULL, 'Inclusion membrane protein D', 'IncD', 4, NULL),
(8358, NULL, 'IPR014564', NULL, 'Uncharacterised conserved protein UCP031503, transmembrane', 'UCP031503_TM', 4, NULL),
(8359, NULL, 'IPR014593', NULL, 'Uncharacterised conserved protein UCP034961, SH3-2', 'UCP034961_SH3_2', 4, NULL),
(8360, NULL, 'IPR010614', NULL, 'DEAD2', 'DEAD_2', 3, NULL),
(8361, NULL, 'IPR011024', NULL, 'Gamma-crystallin-like', 'G_crystallin-like', 5, NULL),
(8362, NULL, 'IPR009405', NULL, 'Vibrio cholerae toxin co-regulated pilus biosynthesis F', 'TcpF', 4, NULL),
(8363, NULL, 'IPR009426', NULL, 'Barley yellow dwarf virus (BYDV), Gp6', 'BYDV_Gp6', 4, NULL),
(8364, NULL, 'IPR023620', NULL, 'Small protein B', 'SmpB', 5, NULL),
(8365, NULL, 'IPR009414', NULL, 'Protein of unknown function DUF1064', 'DUF1064', 4, NULL),
(8366, NULL, 'IPR010615', NULL, 'Herpesvirus UL97', 'Herpes_UL97', 3, NULL),
(8367, NULL, 'IPR009433', NULL, 'Filovirus membrane-associated VP24', 'Filo_VP24', 4, NULL),
(8368, NULL, 'IPR015956', NULL, 'Penicillin-binding protein, C-terminal domain superfamily', 'Peniciliin-bd_prot_C_sf', 5, NULL),
(8369, NULL, 'IPR023554', NULL, 'ATP-dependent RNA helicase RhlB type', 'RNA_helicase_ATP-dep_RhlB', 4, NULL),
(8370, NULL, 'IPR035119', NULL, 'Inclusion membrane protein F', 'IncF', 4, NULL),
(8371, NULL, 'IPR010070', NULL, 'Sporulation protein YjcZ-like', 'YjcZ-like', 4, NULL),
(8372, NULL, 'IPR015510', NULL, 'Peptidoglycan recognition protein', 'PGRP', 4, NULL),
(8373, NULL, 'IPR010565', NULL, 'Muskelin, N-terminal', 'Muskelin_N', 3, NULL),
(8374, NULL, 'IPR009440', NULL, 'Plasmid segregation protein ParM/StbA', 'Plasmid_segregation_ParM/StbA', 3, NULL),
(8375, NULL, 'IPR017904', NULL, 'ADF/Cofilin', 'ADF/Cofilin', 4, NULL),
(8376, NULL, 'IPR009949', NULL, 'Sapovirus VP3', 'Sapovirus_VP3', 4, NULL),
(8377, NULL, 'IPR009923', NULL, 'Dodecin', 'Dodecin', 4, NULL),
(8378, NULL, 'IPR009381', NULL, 'Trehalose catabolism protein, ThuA, prokaryote', 'Trehalose_catabolism_ThuA_prok', 4, NULL),
(8379, NULL, 'IPR010584', NULL, 'Exodeoxyribonuclease 8', 'ExoDNase_VIII', 4, NULL),
(8380, NULL, 'IPR015813', NULL, 'Pyruvate/Phosphoenolpyruvate kinase-like domain superfamily', 'Pyrv/PenolPyrv_Kinase-like_dom', 5, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(8381, NULL, 'IPR018239', NULL, 'NAD-dependent DNA ligase, active site', 'DNA_ligase_AS', 0, NULL),
(8382, NULL, 'IPR011557', NULL, 'DNA gyrase, subunit B', 'GyrB', 4, NULL),
(8383, NULL, 'IPR016020', NULL, 'Translation initiation factor 3, subunit 12, N-terminal, eukaryotic', 'Transl_init_fac_sub12_N_euk', 5, NULL),
(8384, NULL, 'IPR009952', NULL, 'Uroplakin-2', 'Uroplakin-2', 4, NULL),
(8385, NULL, 'IPR011713', NULL, 'Leucine-rich repeat 3', 'Leu-rich_rpt_3', 7, NULL),
(8386, NULL, 'IPR009961', NULL, 'Protein of unknown function DUF1487', 'DUF1487', 4, NULL),
(8387, NULL, 'IPR018320', NULL, 'DNA polymerase 1', 'DNA_polymerase_1', 4, NULL),
(8388, NULL, 'IPR034058', NULL, 'TagA/B/C/D, peptidase domain', 'TagA/B/C/D_pept_dom', 3, NULL),
(8389, NULL, 'IPR010598', NULL, 'D-glucuronyl C5-epimerase, C-terminal', 'C5-epim_C', 3, NULL),
(8390, NULL, 'IPR012938', NULL, 'Glucose/Sorbosone dehydrogenase', 'Glc/Sorbosone_DH', 3, NULL),
(8391, NULL, 'IPR009386', NULL, 'Protein of unknown function DUF1043', 'DUF1043', 4, NULL),
(8392, NULL, 'IPR015507', NULL, 'Ribosomal RNA large subunit methyltransferase E', 'rRNA-MeTfrase_E', 4, NULL),
(8393, NULL, 'IPR018244', NULL, 'Allergen V5/Tpx-1-related, conserved site', 'Allrgn_V5/Tpx1_CS', 2, NULL),
(8394, NULL, 'IPR010575', NULL, 'KorB, C-terminal', 'KorB_C', 3, NULL),
(8395, NULL, 'IPR011608', NULL, 'PRD domain', 'PRD', 3, NULL),
(8396, NULL, 'IPR010588', NULL, 'Myb-related protein P/transcription factor Y1, C-terminal', 'Myb-rel_proteinP/Y1_C', 3, NULL),
(8397, NULL, 'IPR023890', NULL, 'Pyrrolysine biosynthesis protein PylC', 'Pyrrolys_PylC', 4, NULL),
(8398, NULL, 'IPR015944', NULL, 'Glycine-tRNA ligase, beta subunit', 'Gly-tRNA-synth_bsu', 4, NULL),
(8399, NULL, 'IPR035098', NULL, 'YNR034W-A/EGO2 superfamily', 'YNR034W-A/EGO2_sf', 5, NULL),
(8400, NULL, 'IPR009974', NULL, 'Vaccinia virus, B6', 'Vaccinia_virus_B6', 4, NULL),
(8401, NULL, 'IPR018309', NULL, 'Transcription regulator PadR, C-terminal', 'Tscrpt_reg_PadR_C', 3, NULL),
(8402, NULL, 'IPR009987', NULL, 'PilM, inner membrane', 'IM_PilM', 4, NULL),
(8403, NULL, 'IPR014651', NULL, 'Uncharacterised conserved protein, 2xCBS, MJ1404 type', 'UCP036983_2CBS_MJ1404', 4, NULL),
(8404, NULL, 'IPR009427', NULL, 'Uncharacterised conserved protein UCP020357', 'UCP020357', 4, NULL),
(8405, NULL, 'IPR014600', NULL, 'Uncharacterised conserved protein UCP035905, membrane protein', 'UCP035905_mem', 4, NULL),
(8406, NULL, 'IPR009439', NULL, 'Red chlorophyll catabolite reductase', 'RCC_reductase', 4, NULL),
(8407, NULL, 'IPR015910', NULL, 'Inosine/uridine-preferring nucleoside hydrolase, conserved site', 'I/U_nuclsd_hydro_CS', 2, NULL),
(8408, NULL, 'IPR014598', NULL, 'Uncharacterised conserved protein UCP035865', 'UCP035865', 4, NULL),
(8409, NULL, 'IPR009390', NULL, 'Macrodomain Ter protein, MatP', 'MatP', 4, NULL),
(8410, NULL, 'IPR010617', NULL, 'Endosomal/lysomomal potassium channel TMEM175', 'TMEM175', 4, NULL),
(8411, NULL, 'IPR023188', NULL, 'DNA-binding protein Dps, conserved site', 'DPS_DNA-bd_CS', 2, NULL),
(8412, NULL, 'IPR009958', NULL, 'Conotoxin, alpha-type', 'Conotoxin_a-typ', 4, NULL),
(8413, NULL, 'IPR010569', NULL, 'Myotubularin-like, phosphatase domain', 'Myotubularin-like_Pase_dom', 3, NULL),
(8414, NULL, 'IPR010309', NULL, 'E3 ubiquitin ligase, domain of unknown function DUF908', 'E3_Ub_ligase_DUF908', 3, NULL),
(8415, NULL, 'IPR009964', NULL, 'Protein of unknown function DUF1491', 'DUF1491', 4, NULL),
(8416, NULL, 'IPR011529', NULL, 'Glutamate 5-kinase', 'Glu_5kinase', 4, NULL),
(8417, NULL, 'IPR015952', NULL, 'Methane monooxygenase, gamma chain, domain 1', 'Me_mOase_g_dom1', 5, NULL),
(8418, NULL, 'IPR009948', NULL, 'Syd', 'Syd', 4, NULL),
(8419, NULL, 'IPR013153', NULL, 'PrkA AAA domain', 'Prk_AAA_dom', 3, NULL),
(8420, NULL, 'IPR015526', NULL, 'Frizzled/secreted frizzled-related protein', 'Frizzled/SFRP', 4, NULL),
(8421, NULL, 'IPR009441', NULL, 'P40 nucleoprotein, Borna disease virus', 'P40_nucleoprot_BD-vir', 4, NULL),
(8422, NULL, 'IPR024132', NULL, 'Akirin', 'Akirin', 4, NULL),
(8423, NULL, 'IPR014746', NULL, 'Glutamine synthetase/guanido kinase, catalytic domain', 'Gln_synth/guanido_kin_cat_dom', 5, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(8424, NULL, 'IPR009925', NULL, 'Protein of unknown function DUF1463', 'DUF1463', 4, NULL),
(8425, NULL, 'IPR013130', NULL, 'Ferric reductase transmembrane component-like domain', 'Fe3_Rdtase_TM_dom', 3, NULL),
(8426, NULL, 'IPR011607', NULL, 'Methylglyoxal synthase-like domain', 'MGS-like_dom', 3, NULL),
(8427, NULL, 'IPR013847', NULL, 'POU domain', 'POU', 3, NULL),
(8428, NULL, 'IPR015933', NULL, 'Aconitase B, HEAT-like domain', 'Aconitase_B_HEAT-like_dom', 3, NULL),
(8429, NULL, 'IPR015942', NULL, 'Asp/Glu/hydantoin racemase', 'Asp/Glu/hydantoin_racemase', 4, NULL),
(8430, NULL, 'IPR015550', NULL, 'Glucagon', 'Glucagon', 4, NULL),
(8431, NULL, 'IPR018334', NULL, 'ArsR-type transcription regulator, HTH motif', 'ArsR_HTH', 2, NULL),
(8432, NULL, 'IPR010599', NULL, 'Connector enhancer of kinase suppressor of ras 2/3 domain', 'CNK2/3_dom', 3, NULL),
(8433, NULL, 'IPR010606', NULL, 'Mib-herc2', 'Mib_Herc2', 3, NULL),
(8434, NULL, 'IPR023224', NULL, 'Salmonella invasion protein A, C-terminal actin-binding domain superfamily', 'SipA_actin-bd_C_sf', 5, NULL),
(8435, NULL, 'IPR014638', NULL, 'Double C2 protein, alpha/beta/gamma', 'Doc2', 4, NULL),
(8436, NULL, 'IPR009403', NULL, 'Protein of unknown function UPF0637', 'UPF0637', 4, NULL),
(8437, NULL, 'IPR018314', NULL, 'Bacterial Fmu (Sun)/eukaryotic nucleolar NOL1/Nop2p, conserved site', 'Fmu/NOL1/Nop2p_CS', 2, NULL),
(8438, NULL, 'IPR009431', NULL, 'Neuronal vesicle trafficking-associated protein', 'NSG', 4, NULL),
(8439, NULL, 'IPR014574', NULL, 'Uncharacterised conserved protein UCP032908', 'UCP032908', 4, NULL),
(8440, NULL, 'IPR015954', NULL, 'Bacteriophage RNA-type, capsid', 'Phage_RNA-type_capsid', 5, NULL),
(8441, NULL, 'IPR009404', NULL, 'Coronavirus 5a', 'Corona_5a', 4, NULL),
(8442, NULL, 'IPR009383', NULL, 'Protein of unknown function DUF1040', 'DUF1040', 4, NULL),
(8443, NULL, 'IPR014584', NULL, 'Uncharacterised conserved protein UCP033729', 'UCP033729', 4, NULL),
(8444, NULL, 'IPR015927', NULL, 'Peptidase S24/S26A/S26B/S26C', 'Peptidase_S24_S26A/B/C', 3, NULL),
(8445, NULL, 'IPR013048', NULL, 'Meiotic recombination, Spo11', 'Meiotic_Spo11', 4, NULL),
(8446, NULL, 'IPR023861', NULL, 'Chloride channel, ClcA', 'Cl-channel_ClcA', 4, NULL),
(8447, NULL, 'IPR014590', NULL, 'Uncharacterised conserved protein MORN repeat-containing', 'UCP034300_MORN_rpt-cont', 4, NULL),
(8448, NULL, 'IPR010567', NULL, 'Clostridium P47 protein', 'Clostridium_P47', 4, NULL),
(8449, NULL, 'IPR009955', NULL, 'Liver-expressed antimicrobial peptide 2', 'LEAP-2', 4, NULL),
(8450, NULL, 'IPR009384', NULL, 'Swarming motility protein SwrD-like', 'SwrD-like', 4, NULL),
(8451, NULL, 'IPR011413', NULL, 'Uncharacterised conserved protein UCP036540', 'UCP036540_AIR', 4, NULL),
(8452, NULL, 'IPR018392', NULL, 'LysM domain', 'LysM_dom', 3, NULL),
(8453, NULL, 'IPR024059', NULL, 'YopX-like, N-terminal', 'YopX-like_N', 5, NULL),
(8454, NULL, 'IPR015920', NULL, 'Cellobiose dehydrogenase, cytochrome domain', 'Cellobiose_DH_cyt', 3, NULL),
(8455, NULL, 'IPR009950', NULL, 'Protein of unknown function DUF1480', 'DUF1480', 4, NULL),
(8456, NULL, 'IPR009951', NULL, 'Host-nuclease inhibitor protein Gam', 'Host-nuc_inhib_Gam', 4, NULL),
(8457, NULL, 'IPR024065', NULL, 'DNA topoisomerase V, catalytic domain superfamily', 'TopoV_catalytic_dom_sf', 5, NULL),
(8458, NULL, 'IPR023919', NULL, 'Nitrilase-related, sll0784', 'Nitrile-rel_sll0784', 4, NULL),
(8459, NULL, 'IPR014583', NULL, 'Uncharacterised protein family, Sir2-like', 'Uncharacterised_Sir2-like', 4, NULL),
(8460, NULL, 'IPR012937', NULL, 'Terminal nucleotidyltransferase', 'TET5', 4, NULL),
(8461, NULL, 'IPR015529', NULL, 'Interleukin-18', 'IL-18', 4, NULL),
(8462, NULL, 'IPR015908', NULL, 'Allantoicase domain', 'Allantoicase_dom', 3, NULL),
(8463, NULL, 'IPR009432', NULL, 'Protein of unknown function DUF1075', 'DUF1075', 4, NULL),
(8464, NULL, 'IPR010585', NULL, 'DNA repair protein XRCC4', 'DNA_repair_prot_XRCC4', 4, NULL),
(8465, NULL, 'IPR023940', NULL, 'Dihydrodipicolinate reductase', 'DHDPR_bac', 4, NULL),
(8466, NULL, 'IPR009387', NULL, 'Toxin HigB-2', 'HigB-2', 4, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(8467, NULL, 'IPR033995', NULL, 'Tumor necrosis factor receptor superfamily member 1A, N-terminal, teleost', 'TNFRSF1A_N_teleost', 3, NULL),
(8468, NULL, 'IPR034715', NULL, 'Ribonucleotide reductase small subunit, Herpesvirus', 'HSV_RIR2', 4, NULL),
(8469, NULL, 'IPR012941', NULL, 'Phenol hydroxylase, C-terminal dimerisation domain', 'Phe_hydrox_C_dim_dom', 3, NULL),
(8470, NULL, 'IPR009947', NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 7', 'NDUA7', 4, NULL),
(8471, NULL, 'IPR034744', NULL, 'RH2 domain', 'RH2', 3, NULL),
(8472, NULL, 'IPR013155', NULL, 'Methionyl/Valyl/Leucyl/Isoleucyl-tRNA synthetase, anticodon-binding', 'M/V/L/I-tRNA-synth_anticd-bd', 3, NULL),
(8473, NULL, 'IPR010590', NULL, 'Protein of unknown function DUF1158', 'DUF1158', 4, NULL),
(8474, NULL, 'IPR009412', NULL, 'Protein of unknown function DUF1062', 'DUF1062', 4, NULL),
(8475, NULL, 'IPR012281', NULL, 'Phospholipid biosynthesis protein, PlsX-like', 'Phospholipid_synth_PlsX-like', 4, NULL),
(8476, NULL, 'IPR013049', NULL, 'Spo11/DNA topoisomerase VI, subunit A, N-terminal', 'Spo11/TopoVI_A_N', 3, NULL),
(8477, NULL, 'IPR009937', NULL, 'Putative Actinobacterial Holin-X, holin superfamily III', 'Phage_holin_3_6', 4, NULL),
(8478, NULL, 'IPR009936', NULL, 'Protein of unknown function DUF1468', 'DUF1468', 4, NULL),
(8479, NULL, 'IPR009392', NULL, 'Drosophila ACP53EA', 'ACP53EA', 4, NULL),
(8480, NULL, 'IPR009929', NULL, 'Type III secretion sytem,YscO', 'T3SS_YscO', 4, NULL),
(8481, NULL, 'IPR010602', NULL, 'Protein of unknown function DUF1186', 'DUF1186', 4, NULL),
(8482, NULL, 'IPR009429', NULL, 'Baculovirus LEF-11', 'Baculo_LEF-11', 4, NULL),
(8483, NULL, 'IPR014596', NULL, 'Uncharacterised conserved protein UCP035836', 'UCP035836', 4, NULL),
(8484, NULL, 'IPR034716', NULL, 'Ribonucleoside-diphosphate reductase large subunit-like protein, Betaherpesviruses', 'HSV_RIR1_betahv', 4, NULL),
(8485, NULL, 'IPR018350', NULL, 'Transcription factor COE, conserved site', 'Transcription_factor_COE_CS', 2, NULL),
(8486, NULL, 'IPR009943', NULL, 'Protein of unknown function DUF1475', 'DUF1475', 4, NULL),
(8487, NULL, 'IPR013150', NULL, 'Transcription factor TFIIB, cyclin-like domain', 'TFIIB_cyclin', 3, NULL),
(8488, NULL, 'IPR015949', NULL, 'Bacteriophage PRD1, P2, N-terminal', 'Phage_PRD1_P2_N', 5, NULL),
(8489, NULL, 'IPR023666', NULL, 'Phosphoglucosamine mutase, archaeal', 'GlmM_arc', 4, NULL),
(8490, NULL, 'IPR010618', NULL, 'Resuscitation-promoting factor, core lysozyme-like domain', 'RPF', 3, NULL),
(8491, NULL, 'IPR014628', NULL, 'Mannose-6-phosphate isomerase, Firmicutes type, short form', 'Man6P_isomerase_Firm_short', 4, NULL),
(8492, NULL, 'IPR010580', NULL, 'Stress-associated endoplasmic reticulum protein', 'ER_stress-assoc', 4, NULL),
(8493, NULL, 'IPR015528', NULL, 'Interleukin-12 beta', 'IL-12_beta', 4, NULL),
(8494, NULL, 'IPR010620', NULL, 'Beta-propeller repeat', 'SBBP_repeat', 7, NULL),
(8495, NULL, 'IPR014644', NULL, 'Protein arginine N-methyltransferase PRMT7', 'MeTrfase_PRMT7', 4, NULL),
(8496, NULL, 'IPR023960', NULL, 'Cytochrome b6-f complex iron-sulfur subunit', 'Cyt_b6_f_Rieske', 4, NULL),
(8497, NULL, 'IPR009421', NULL, 'Maize streak virus, 21.7kDa', 'Maize_streak_virus_21.7kDa', 4, NULL),
(8498, NULL, 'IPR014601', NULL, 'Transcriptional regulator with MarR-type HTH domain', 'Trans_reg_MarR_HTH', 4, NULL),
(8499, NULL, 'IPR009448', NULL, 'UDP-glucose:Glycoprotein Glucosyltransferase', 'UDP-g_GGtrans', 4, NULL),
(8500, NULL, 'IPR011612', NULL, 'Urease alpha-subunit, N-terminal domain', 'Urease_alpha_N_dom', 3, NULL),
(8501, NULL, 'IPR010258', NULL, 'Conjugal transfer, TrbG/VirB9/CagX', 'Conjugal_tfr_TrbG/VirB9/CagX', 4, NULL),
(8502, NULL, 'IPR008958', NULL, 'Transglutaminase, C-terminal', 'Transglutaminase_C', 3, NULL),
(8503, NULL, 'IPR011716', NULL, 'Tetratricopeptide TPR-3', 'TPR-3', 7, NULL),
(8504, NULL, 'IPR014783', NULL, 'Copper type II, ascorbate-dependent monooxygenase, histidine-cluster-2 conserved site', 'Cu2_ascorb_mOase_CS-2', 2, NULL),
(8505, NULL, 'IPR010995', NULL, 'DNA repair Rad51/transcription factor NusA, alpha-helical', 'DNA_repair_Rad51/TF_NusA_a-hlx', 5, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(8506, NULL, 'IPR011001', NULL, 'Saposin-like', 'Saposin-like', 5, NULL),
(8507, NULL, 'IPR014178', NULL, 'Fatty acid response transcription factor FadR', 'FA-response_TF_FadR', 4, NULL),
(8508, NULL, 'IPR011547', NULL, 'SLC26A/SulP transporter domain', 'SLC26A/SulP_dom', 3, NULL),
(8509, NULL, 'IPR008947', NULL, 'Phospholipase C/P1 nuclease domain superfamily', 'PLipase_C/P1_nuclease_dom_sf', 5, NULL),
(8510, NULL, 'IPR015098', NULL, 'EBP50, C-terminal', 'EBP50_C-term', 3, NULL),
(8511, NULL, 'IPR011878', NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit  D', 'GatD', 4, NULL),
(8512, NULL, 'IPR008259', NULL, 'FMN-dependent alpha-hydroxy acid dehydrogenase, active site', 'FMN_hydac_DH_AS', 0, NULL),
(8513, NULL, 'IPR034498', NULL, 'Bacteriochlorophyll C8 methyltransferase', 'Bacteriochlorophyll_C8_MT', 4, NULL),
(8514, NULL, 'IPR014276', NULL, '2-oxoglutarate dehydrogenase, E2 component', '2-oxoglutarate_DH_E2', 4, NULL),
(8515, NULL, 'IPR034840', NULL, 'DPE2, CBM20 domain 1', 'CBM20_DPE2_1', 3, NULL),
(8516, NULL, 'IPR008272', NULL, '4-hydroxybenzoyl-CoA thioesterase, active site', 'HB-CoA_thioesterase_AS', 0, NULL),
(8517, NULL, 'IPR012743', NULL, '4-coumarate--CoA ligase', '4_coum_CoA_lig', 4, NULL),
(8518, NULL, 'IPR011530', NULL, 'Ribosomal RNA adenine dimethylase', 'rRNA_adenine_dimethylase', 4, NULL),
(8519, NULL, 'IPR008410', NULL, 'Cellulose synthase operon C, C-terminal', 'BCSC_C', 3, NULL),
(8520, NULL, 'IPR015059', NULL, 'Calcium-dependent cell adhesion molecule, N-terminal', 'Ca_cell_adhesion_N_dom', 3, NULL),
(8521, NULL, 'IPR015082', NULL, 'Protein of unknown function DUF1896', 'DUF1896', 4, NULL),
(8522, NULL, 'IPR008402', NULL, 'Anaphase-promoting complex subunit  15/mnd2', 'APC_su15/mnd2', 4, NULL),
(8523, NULL, 'IPR011892', NULL, 'Cytidylate kinase, putative', 'Cyt_kin_arch', 4, NULL),
(8524, NULL, 'IPR008266', NULL, 'Tyrosine-protein kinase, active site', 'Tyr_kinase_AS', 0, NULL),
(8525, NULL, 'IPR014193', NULL, 'Uncharacterised domain CHP02828, putative membrane fusion protein', 'CHP02828_mem_fusion', 3, NULL),
(8526, NULL, 'IPR023041', NULL, 'Glucose receptor Git3, N-terminal', 'Glucose_rcpt_Git3_N', 3, NULL),
(8527, NULL, 'IPR014027', NULL, 'UDP-glucose/GDP-mannose dehydrogenase, C-terminal', 'UDP-Glc/GDP-Man_DH_C', 3, NULL),
(8528, NULL, 'IPR015433', NULL, 'Phosphatidylinositol kinase', 'PI_Kinase', 4, NULL),
(8529, NULL, 'IPR023234', NULL, 'NarG-like domain', 'NarG-like_domain', 3, NULL),
(8530, NULL, 'IPR010365', NULL, 'Protein of unknown function DUF961', 'DUF961', 4, NULL),
(8531, NULL, 'IPR009996', NULL, 'Regulatory protein YycH', 'YycH', 3, NULL),
(8532, NULL, 'IPR014273', NULL, 'Isocitrate dehydrogenase, alphaproteobacteria-type', 'Isocitrate_DH_aproteobac-typ', 4, NULL),
(8533, NULL, 'IPR008448', NULL, 'DNA-directed RNA polymerase, 7kDa polypeptide, chordopoxviral', 'RNA_pol_7kDa_chordopoxvir', 4, NULL),
(8534, NULL, 'IPR015089', NULL, 'Cytochrome b-c1 complex subunit 10', 'UQCR', 4, NULL),
(8535, NULL, 'IPR011006', NULL, 'CheY-like superfamily', 'CheY-like_superfamily', 5, NULL),
(8536, NULL, 'IPR011552', NULL, 'Tellurite resistance protein TehA/malic acid transport protein', 'TehA/Mae1', 4, NULL),
(8537, NULL, 'IPR010353', NULL, 'Phenol 2-monooxygenase, auxiliary component DmpK', 'DmpK', 4, NULL),
(8538, NULL, 'IPR008405', NULL, 'Apolipoprotein L', 'ApoL', 4, NULL),
(8539, NULL, 'IPR010009', NULL, 'Apolipophorin-III', 'ApoLp-III', 4, NULL),
(8540, NULL, 'IPR011890', NULL, 'Structural maintenance of chromosomes protein, prokaryotic', 'SMC_prok', 4, NULL),
(8541, NULL, 'IPR010371', NULL, 'YBR137W-like', 'YBR137W-like', 4, NULL),
(8542, NULL, 'IPR008962', NULL, 'PapD-like superfamily', 'PapD-like_sf', 5, NULL),
(8543, NULL, 'IPR010325', NULL, 'Rhamnogalacturonate lyase', 'Rhamnogal_lyase', 4, NULL),
(8544, NULL, 'IPR008416', NULL, 'Baculovirus VP1054', 'Baculo_VP1054', 4, NULL),
(8545, NULL, 'IPR010328', NULL, 'Protein of unknown function DUF928', 'DUF928', 4, NULL),
(8546, NULL, 'IPR008927', NULL, '6-phosphogluconate dehydrogenase-like, C-terminal domain superfamily', '6-PGluconate_DH-like_C_sf', 5, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(8547, NULL, 'IPR011002', NULL, 'Flagellar motor switch protein FliG, alpha-helical', 'FliG_a-hlx', 5, NULL),
(8548, NULL, 'IPR034072', NULL, 'DNA-binding protein SMUBP-2, R3H domain', 'R3H_Smubp-2', 3, NULL),
(8549, NULL, 'IPR035206', NULL, 'Proteasome subunit beta 2', 'Proteasome_beta2', 4, NULL),
(8550, NULL, 'IPR014287', NULL, 'Nitrogenase iron-iron, accessory protein AnfO', 'Nase_Fe-Fe_AnfO', 4, NULL),
(8551, NULL, 'IPR008403', NULL, 'Apolipoprotein CIII', 'Apo-CIII', 4, NULL),
(8552, NULL, 'IPR013288', NULL, 'Cytochrome c oxidase subunit IV', 'Cyt_c_oxidase_su4', 4, NULL),
(8553, NULL, 'IPR012739', NULL, 'Pyrrolysyl-tRNA ligase', 'Pyrrolysyl-tRNA_ligase', 4, NULL),
(8554, NULL, 'IPR014275', NULL, 'ATPase, A1A0, subunit H', 'ATPase_A1A0-cplx_hsu', 4, NULL),
(8555, NULL, 'IPR010340', NULL, 'Herpesvirus UL11/UL32', 'Herpes_UL11/UL32', 4, NULL),
(8556, NULL, 'IPR008918', NULL, 'Helix-hairpin-helix motif, class 2', 'HhH2', 2, NULL),
(8557, NULL, 'IPR014185', NULL, 'Glutathione-dependent formaldehyde-activating enzyme', 'Formald_GSH', 4, NULL),
(8558, NULL, 'IPR008423', NULL, 'P21 molecular chaperone, Bacillus thuringiensis', 'P21_molc_chaperone_B_thur', 4, NULL),
(8559, NULL, 'IPR014283', NULL, 'Ferredoxin III 4[4Fe-4S], nif-specific', 'FdIII_4_nif', 4, NULL),
(8560, NULL, 'IPR014167', NULL, 'Tol-Pal system protein TolB', 'Tol-Pal_TolB', 4, NULL),
(8561, NULL, 'IPR009994', NULL, 'Phloem filament PP1', 'PP1', 3, NULL),
(8562, NULL, 'IPR010315', NULL, 'Protein of unknown function DUF915, hydrolase-like', 'DUF915_hydro-like', 4, NULL),
(8563, NULL, 'IPR008922', NULL, 'Di-copper centre-containing domain superfamily', 'Di-copper_centre_dom_sf', 5, NULL),
(8564, NULL, 'IPR010006', NULL, 'Bacteriophage P4, Psu, polarity suppression protein', 'Phage_P4_Psu', 4, NULL),
(8565, NULL, 'IPR008269', NULL, 'Peptidase S16, Lon proteolytic domain', 'Lon_proteolytic', 3, NULL),
(8566, NULL, 'IPR013294', NULL, 'Protein LBH', 'LBH', 4, NULL),
(8567, NULL, 'IPR035201', NULL, 'Cell division control protein 24, OB domain 1', 'Cdc24_OB1', 3, NULL),
(8568, NULL, 'IPR015072', NULL, 'Outer capsid protein VP9/VP10/VP11', 'VP9/VP10/VP11', 4, NULL),
(8569, NULL, 'IPR024230', NULL, 'GspL, cytoplasmic actin-ATPase-like domain', 'GspL_cyto_dom', 3, NULL),
(8570, NULL, 'IPR015075', NULL, 'Acetylaranotin biosynthesis cluster protein L', 'AtaL', 4, NULL),
(8571, NULL, 'IPR009045', NULL, 'Hedgehog signalling/DD-peptidase zinc-binding domain superfamily', 'Hedgehog_sig/DD-Pept_Zn-bd_sf', 5, NULL),
(8572, NULL, 'IPR008953', NULL, 'Iron hydrogenase, small subunit HydB-type', 'Fe_hydrogenase_HydB', 5, NULL),
(8573, NULL, 'IPR034670', NULL, 'Checkpoint kinase 1, catalytic domain', 'Chk1_catalytic_dom', 3, NULL),
(8574, NULL, 'IPR008427', NULL, 'Extracellular membrane protein, CFEM domain', 'Extracellular_membr_CFEM_dom', 3, NULL),
(8575, NULL, 'IPR008421', NULL, 'Borrelia lipoprotein paralogus family 54/60', 'Borrelia_lipoprotein_PFam54/60', 4, NULL),
(8576, NULL, 'IPR014179', NULL, 'PfaD family protein', 'PfaD_fam', 4, NULL),
(8577, NULL, 'IPR008300', NULL, 'Phosphate propanoyltransferase', 'PTAC', 4, NULL),
(8578, NULL, 'IPR010005', NULL, 'Formate hydrogenlyase maturation HycH', 'Formate_DH_maturation_HycH', 4, NULL),
(8579, NULL, 'IPR011010', NULL, 'DNA breaking-rejoining enzyme, catalytic core', 'DNA_brk_join_enz', 5, NULL),
(8580, NULL, 'IPR011889', NULL, 'Bacterial surface protein 26-residue repeat', 'Liste_lipo_26', 7, NULL),
(8581, NULL, 'IPR034060', NULL, 'Tumor necrosis factor receptor 27, N-terminal', 'TNFRSF27_N', 3, NULL),
(8582, NULL, 'IPR008964', NULL, 'Invasin/intimin cell-adhesion fragments', 'Invasin/intimin_cell_adhesion', 5, NULL),
(8583, NULL, 'IPR008442', NULL, 'Propeptide, carboxypeptidase Y', 'Propeptide_carboxypepY', 3, NULL),
(8584, NULL, 'IPR014291', NULL, 'SUF system FeS cluster assembly associated', 'SUF_FeS_clus_asmbl-assoc', 4, NULL),
(8585, NULL, 'IPR014292', NULL, 'Acyltransferase, WS/DGAT/MGAT', 'Acyl_transf_WS/DGAT', 4, NULL),
(8586, NULL, 'IPR014777', NULL, 'Tetrapyrrole methylase, subdomain 1', '4pyrrole_Mease_sub1', 5, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(8587, NULL, 'IPR008419', NULL, 'Benyvirus p25/p26', 'BNYVV_p25/p26', 4, NULL),
(8588, NULL, 'IPR010001', NULL, 'SigmaK-factor processing regulatory BofA', 'BofA', 4, NULL),
(8589, NULL, 'IPR010311', NULL, 'Reovirus core-spike lambda-2', 'Reovirus_L2', 4, NULL),
(8590, NULL, 'IPR011879', NULL, 'Signal transduction response regulator, phosphate regulon transcriptional regulatory protein PhoB', 'Sig_transdc_resp-reg_PhoB', 4, NULL),
(8591, NULL, 'IPR010255', NULL, 'Haem peroxidase superfamily', 'Haem_peroxidase_sf', 5, NULL),
(8592, NULL, 'IPR015067', NULL, 'Protein of unknown function DUF1893, TM1506-like', 'DUF1893_TM1506-like', 4, NULL),
(8593, NULL, 'IPR014286', NULL, 'RNA polymerase sigma-70 RpoE type', 'RNA_pol_sigma70_RpoE', 4, NULL),
(8594, NULL, 'IPR013161', NULL, 'Benzylsuccinate synthase gamma subunit', 'BssC', 4, NULL),
(8595, NULL, 'IPR012548', NULL, 'Microtubule-associated tyrosine carboxypeptidase', 'MATCAP', 4, NULL),
(8596, NULL, 'IPR034491', NULL, 'Anaerobic Ser-type sulfatase-maturating enzyme', 'Anaerob_Ser_sulfatase-maturase', 4, NULL),
(8597, NULL, 'IPR013769', NULL, 'Band 3 cytoplasmic domain', 'Band3_cytoplasmic_dom', 3, NULL),
(8598, NULL, 'IPR013282', NULL, 'Bcl-2-related protein A1', 'Bcl2A1', 4, NULL),
(8599, NULL, 'IPR013311', NULL, 'Cysteinyl leukotriene receptor 2', 'CLT2_recept', 4, NULL),
(8600, NULL, 'IPR010012', NULL, 'Spasmodic peptide gm9a', 'Toxin_11', 4, NULL),
(8601, NULL, 'IPR013528', NULL, 'Hydroxymethylglutaryl-coenzyme A synthase, N-terminal', 'HMG_CoA_synth_N', 3, NULL),
(8602, NULL, 'IPR012737', NULL, 'Dihydroxyacetone kinase, subunit L', 'DhaK_L_YcgS', 3, NULL),
(8603, NULL, 'IPR015078', NULL, 'DP-EP family', 'DP-EP', 4, NULL),
(8604, NULL, 'IPR011885', NULL, 'Periplasmic nitrate reductase c-type cytochrome, NapC/NirT', 'NO3Rdtase_cyt_c_NapC/NirT', 4, NULL),
(8605, NULL, 'IPR014285', NULL, 'Nitrogen fixation negative regulator NifL', 'N_fixation_neg-reg_NifL', 4, NULL),
(8606, NULL, 'IPR013157', NULL, 'Aurein antibiotic peptide family', 'Aurein_antimicrobial_peptide', 4, NULL),
(8607, NULL, 'IPR010318', NULL, 'Protein of unknown function DUF917', 'DUF917', 4, NULL),
(8608, NULL, 'IPR014289', NULL, 'RNA polymerase sigma-24-related', 'RNA_pol_sigma-24-rel', 4, NULL),
(8609, NULL, 'IPR024231', NULL, 'Poxvirus poly(A) polymerase nucleotidyltransferase domain', 'Pox_polyA_pol_nucTrfase', 3, NULL),
(8610, NULL, 'IPR008302', NULL, 'Exo-beta-N-acetylmuramidase NamZ', 'NamZ', 4, NULL),
(8611, NULL, 'IPR013314', NULL, 'Globin, lamprey/hagfish type', 'Globin_lamprey/hagfish', 4, NULL),
(8612, NULL, 'IPR012550', NULL, 'Protein of unknown function DUF1706', 'DUF1706', 4, NULL),
(8613, NULL, 'IPR023128', NULL, 'Protein N-terminal glutamine amidohydrolase, alpha beta roll', 'Prot_N_Gln_amidohydro_ab_roll', 3, NULL),
(8614, NULL, 'IPR008270', NULL, 'Glycosyl hydrolases family 25, active site', 'Glyco_hydro_25_AS', 0, NULL),
(8615, NULL, 'IPR012541', NULL, 'DBP10, C-terminal', 'DBP10_C', 3, NULL),
(8616, NULL, 'IPR009995', NULL, 'Protein of unknown function DUF1512', 'DUF1512', 4, NULL),
(8617, NULL, 'IPR010363', NULL, 'Domain of unknown function DUF959, collagen XVIII, N-terminal', 'DUF959_COL18_N', 3, NULL),
(8618, NULL, 'IPR014189', NULL, 'Quinone oxidoreductase PIG3', 'Quinone_OxRdtase_PIG3', 4, NULL),
(8619, NULL, 'IPR013310', NULL, 'Cysteinyl leukotriene receptor 1', 'CLT1_recept', 4, NULL),
(8620, NULL, 'IPR008257', NULL, 'Peptidase M19', 'Pept_M19', 4, NULL),
(8621, NULL, 'IPR015076', NULL, 'Vasopressin V1 receptor, C-terminal', 'V1R_C', 3, NULL),
(8622, NULL, 'IPR011888', NULL, 'Anaerobic dimethyl sulphoxide reductase, subunit A, DmsA/YnfE', 'Anaer_DMSO_reductase', 4, NULL),
(8623, NULL, 'IPR013301', NULL, 'Wnt-8 protein', 'Wnt8', 4, NULL),
(8624, NULL, 'IPR014274', NULL, 'Peptidyl-prolyl cis-trans isomerase, EpsD-type', 'PPIase_EpsD', 4, NULL),
(8625, NULL, 'IPR010332', NULL, 'ATPase terminase subunit, putative', 'ATPase_terminase-su_put', 4, NULL),
(8626, NULL, 'IPR008289', NULL, 'Pentafunctional AroM protein', 'Pentafunct_AroM', 4, NULL),
(8627, NULL, 'IPR008929', NULL, 'Chondroitin AC/alginate lyase', 'Chondroitin_lyas', 5, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(8628, NULL, 'IPR013291', NULL, 'Myeloid transforming gene-related protein-1 (MTGR1)', 'MTGR1', 4, NULL),
(8629, NULL, 'IPR012744', NULL, 'Nitrite reductase [NAD(P)H] large subunit, NirB', 'Nitri_red_NirB', 3, NULL),
(8630, NULL, 'IPR011005', NULL, 'Dihydropteroate synthase-like', 'Dihydropteroate_synth-like', 5, NULL),
(8631, NULL, 'IPR011343', NULL, 'Deoxyribose-phosphate aldolase', 'DeoC', 4, NULL),
(8632, NULL, 'IPR013299', NULL, 'Neuropeptide W precursor', 'Neuropept_W_pre', 4, NULL),
(8633, NULL, 'IPR011894', NULL, '2-oxoacid:acceptor oxidoreductase, gamma subunit, pyruvate/2-ketoisovalerate', 'PorC_KorC', 3, NULL),
(8634, NULL, 'IPR008449', NULL, 'Chorion S36/S38', 'Chorion_S36/S28', 4, NULL),
(8635, NULL, 'IPR013290', NULL, 'Protein CBFA2T1', 'CBFA2T1', 4, NULL),
(8636, NULL, 'IPR010333', NULL, 'Bacterial virulence', 'VirJ', 3, NULL),
(8637, NULL, 'IPR013303', NULL, 'Wnt-9a protein', 'Wnt9a', 4, NULL),
(8638, NULL, 'IPR012546', NULL, 'Protein of unknown function DUF1699', 'DUF1699', 4, NULL),
(8639, NULL, 'IPR015476', NULL, 'Calcitonin gene-related peptide', 'Calcitonin_gene-rel_peptide', 4, NULL),
(8640, NULL, 'IPR014272', NULL, 'ATPase, V0 complex, c subunit', 'ATPase_V0-cplx_c_su', 4, NULL),
(8641, NULL, 'IPR012540', NULL, 'Cuticle 7 isoform', 'Cuticle_2', 4, NULL),
(8642, NULL, 'IPR013156', NULL, 'Pseudin antimicrobial peptide', 'Antimicrobial_19', 4, NULL),
(8643, NULL, 'IPR010366', NULL, 'Arginine ADP-riboxanase OspC1-4', 'OspC1-4', 4, NULL),
(8644, NULL, 'IPR010339', NULL, 'TIP49, P-loop domain', 'TIP49_P-loop', 3, NULL),
(8645, NULL, 'IPR014188', NULL, 'Acrylyl-CoA reductase AcuI', 'Acrylyl-CoA_reductase_AcuI', 4, NULL),
(8646, NULL, 'IPR012538', NULL, 'Cytochrome c oxidase polypeptide 2A', 'Cyt_c_oxidase_su2a', 4, NULL),
(8647, NULL, 'IPR015088', NULL, 'Zinc finger, DNA-directed DNA polymerase, family B, alpha', 'Znf_DNA-dir_DNA_pol_B_alpha', 3, NULL),
(8648, NULL, 'IPR015449', NULL, 'Potassium channel, calcium-activated, SK', 'K_chnl_Ca-activ_SK', 4, NULL),
(8649, NULL, 'IPR010334', NULL, 'mRNA-decapping enzyme subunit 1', 'Dcp1', 4, NULL),
(8650, NULL, 'IPR008291', NULL, 'Glucoamylase, starch-binding', 'Glucoamylase_SBD', 4, NULL),
(8651, NULL, 'IPR010924', NULL, 'DNA-directed RNA polymerase subunit Rpo4', 'Rpo4', 4, NULL),
(8652, NULL, 'IPR014196', NULL, 'Stage II sporulation protein M', 'SpoIIM', 4, NULL),
(8653, NULL, 'IPR008921', NULL, 'DNA polymerase III, clamp loader complex, gamma/delta/delta subunit, C-terminal', 'DNA_pol3_clamp-load_cplx_C', 5, NULL),
(8654, NULL, 'IPR010324', NULL, 'Dam-replacing', 'DRP', 4, NULL),
(8655, NULL, 'IPR024156', NULL, 'Small GTPase superfamily, ARF type', 'Small_GTPase_ARF', 4, NULL),
(8656, NULL, 'IPR010008', NULL, 'Vibrio phage CTX, RstB', 'Vibrio_Phage_CTX_RstB', 4, NULL),
(8657, NULL, 'IPR008308', NULL, 'Uncharacterised conserved protein UCP021350', 'UCP021350', 4, NULL),
(8658, NULL, 'IPR014175', NULL, 'Conserved hypothetical protein CHP02808', 'CHP02808', 4, NULL),
(8659, NULL, 'IPR009992', NULL, 'Acyltransferase Tri3/Sat12/Sat16/Mac1', 'Tri3/Sat12/Sat16/Mac1', 4, NULL),
(8660, NULL, 'IPR010003', NULL, 'HARP domain', 'HARP_dom', 3, NULL),
(8661, NULL, 'IPR034497', NULL, 'Bacteriochlorophyll C12 methyltransferase', 'Bacteriochlorophyll_C12_MT', 4, NULL),
(8662, NULL, 'IPR034854', NULL, 'RBM12, RNA recognition motif 5', 'RBM12_RRM5', 3, NULL),
(8663, NULL, 'IPR010336', NULL, 'Baculoviridae ME53', 'Baculo_ME53', 4, NULL),
(8664, NULL, 'IPR010342', NULL, 'Protein of unknown function DUF938', 'DUF938', 4, NULL),
(8665, NULL, 'IPR010352', NULL, 'Protein of unknown function DUF945', 'DUF945', 4, NULL),
(8666, NULL, 'IPR008949', NULL, 'Isoprenoid synthase domain superfamily', 'Isoprenoid_synthase_dom_sf', 5, NULL),
(8667, NULL, 'IPR015069', NULL, '2H-phosphodiesterase-like, Domain of unknown function DUF1868', '2H-PEstase_DUF1868', 3, NULL),
(8668, NULL, 'IPR015086', NULL, 'Bacteriophage T4, Gp59, helicase assembly protein, C-terminal', 'Phage_T4_Gp59_C', 3, NULL),
(8669, NULL, 'IPR015468', NULL, 'CD8 alpha subunit', 'CD8_asu', 4, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(8670, NULL, 'IPR011884', NULL, 'Phenylacetate-CoA oxygenase/reductase, PaaK subunit', 'PA_CoA_Oase5', 4, NULL),
(8671, NULL, 'IPR013292', NULL, 'Protein CBFA2T3', 'CBFA2T3', 4, NULL),
(8672, NULL, 'IPR010915', NULL, 'Polyhydroxyalkanoate depolymerase', 'PHB_depoly_PhaZ', 4, NULL),
(8673, NULL, 'IPR014284', NULL, 'RNA polymerase sigma-70 like domain', 'RNA_pol_sigma-70_dom', 3, NULL),
(8674, NULL, 'IPR008963', NULL, 'Purple acid phosphatase-like, N-terminal', 'Purple_acid_Pase-like_N', 5, NULL),
(8675, NULL, 'IPR015061', NULL, 'Domain of unknown function DUF1882', 'DUF1882', 3, NULL),
(8676, NULL, 'IPR009997', NULL, 'Movement protein R3', 'MP_R3', 4, NULL),
(8677, NULL, 'IPR008429', NULL, 'Cleft lip and palate transmembrane 1', 'CLPTM1', 4, NULL),
(8678, NULL, 'IPR035203', NULL, 'Cell division control protein 24, OB domain 3', 'Cdc24_OB3', 3, NULL),
(8679, NULL, 'IPR008261', NULL, 'Iodothyronine deiodinase, active site', 'Iodothyronine_deiodinase_AS', 0, NULL),
(8680, NULL, 'IPR015085', NULL, 'Bacteriophage T4, Gp59, helicase assembly protein, N-terminal', 'Phage_T4_Gp59_N', 3, NULL),
(8681, NULL, 'IPR015962', NULL, 'Mu1 membrane penetration protein, domain II', 'Mu1_membr_pen_domII', 5, NULL),
(8682, NULL, 'IPR010343', NULL, 'Aromatic acid exporter family member 1', 'ArAE_1', 4, NULL),
(8683, NULL, 'IPR008294', NULL, 'Meprin alpha/beta subunit', 'Meprin', 4, NULL),
(8684, NULL, 'IPR015100', NULL, 'Anti-Sigma Factor A', 'AsiA', 4, NULL),
(8685, NULL, 'IPR013312', NULL, 'G protein-coupled receptor 40-related receptor', 'GPR40-rel_orph', 4, NULL),
(8686, NULL, 'IPR014194', NULL, 'Sporulation stage III, protein AE', 'Spore_III_AE', 4, NULL),
(8687, NULL, 'IPR013280', NULL, 'Apoptosis regulator, Bcl-W', 'Apop_reg_BclW', 4, NULL),
(8688, NULL, 'IPR015053', NULL, 'Protein of unknown function DUF1871', 'DUF1871', 4, NULL),
(8689, NULL, 'IPR010917', NULL, 'TonB-dependent receptor, conserved site', 'TonB_rcpt_CS', 2, NULL),
(8690, NULL, 'IPR023819', NULL, 'Peptide-modifying radical SAM enzyme putative, AF0577', 'Pep-mod_rSAM_AF0577', 4, NULL),
(8691, NULL, 'IPR014181', NULL, 'Omega-3 polyunsaturated fatty acid synthase-like', 'Omega3_polyunsat_FA_synth-like', 3, NULL),
(8692, NULL, 'IPR013525', NULL, 'ABC-2 type transporter', 'ABC_2_trans', 3, NULL),
(8693, NULL, 'IPR010004', NULL, 'Uncharacterised protein family Ycf66', 'Uncharacterised_Ycf66', 4, NULL),
(8694, NULL, 'IPR010327', NULL, 'FldB/FldC dehydratase alpha/beta subunit', 'FldB/FldC_alpha/beta', 4, NULL),
(8695, NULL, 'IPR013278', NULL, 'Apoptosis regulator, Bcl-2', 'Apop_reg_Bcl2', 4, NULL),
(8696, NULL, 'IPR011886', NULL, 'Ferredoxin-type protein, NapH/MauN family', 'NapH_MauN', 4, NULL),
(8697, NULL, 'IPR013284', NULL, 'Beta-catenin', 'Beta-catenin', 4, NULL),
(8698, NULL, 'IPR015096', NULL, 'Far upstream element-binding protein, C-terminal', 'FUBP_C', 3, NULL),
(8699, NULL, 'IPR014170', NULL, 'TonB system transport protein ExbD type-1', 'TonB_ExbD_1', 4, NULL),
(8700, NULL, 'IPR008944', NULL, 'Bacteriophage T4, Gp59, helicase assembly protein', 'Phage_T4_Gp59', 4, NULL),
(8701, NULL, 'IPR010011', NULL, 'Nuclear receptor coactivator, DUF1518', 'NCO_DUF1518', 3, NULL),
(8702, NULL, 'IPR011556', NULL, 'Glutamate--cysteine ligase, plant-type', 'Glut_cys_lig_pln_type', 4, NULL),
(8703, NULL, 'IPR035204', NULL, 'NADH-ubiquinone oxidoreductase 11kDa subunit', 'NDUFB11', 4, NULL),
(8704, NULL, 'IPR014169', NULL, 'Peptidoglycan-associated lipoprotein, C-terminal', 'Pal_lipo_C', 3, NULL),
(8705, NULL, 'IPR015084', NULL, 'Quinohemoprotein amine dehydrogenase, gamma subunit, structural domain', 'QH-AmDH_gsu_dom', 3, NULL),
(8706, NULL, 'IPR013159', NULL, 'Chromosomal replication initiator, DnaA C-terminal', 'DnaA_C', 3, NULL),
(8707, NULL, 'IPR015094', NULL, 'Integrase, lambda-type, N-terminal DNA-binding', 'Integrase_lambda-typ_DNA-bd_N', 3, NULL),
(8708, NULL, 'IPR008268', NULL, 'Peptidase S16, active site', 'Peptidase_S16_AS', 0, NULL),
(8709, NULL, 'IPR010312', NULL, 'GTP-sensing transcriptional pleiotropic repressor CodY, N-terminal', 'GTP_sensing_CodY_N', 3, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(8710, NULL, 'IPR012741', NULL, 'Methyltransferase cognate corrinoid protein', 'Corrinoid_p', 3, NULL),
(8711, NULL, 'IPR013283', NULL, 'RLI1', 'RLI1', 4, NULL),
(8712, NULL, 'IPR024285', NULL, 'Schizont-infected cell agglutination, extracellular beta domain', 'SICA_extracell_b', 3, NULL),
(8713, NULL, 'IPR034856', NULL, 'RBM12, RNA recognition motif 4', 'RBM12_RRM4', 3, NULL),
(8714, NULL, 'IPR008920', NULL, 'Transcription regulator FadR/GntR, C-terminal', 'TF_FadR/GntR_C', 5, NULL),
(8715, NULL, 'IPR012543', NULL, 'Protein of unknown function DUF1694', 'DUF1694', 4, NULL),
(8716, NULL, 'IPR010000', NULL, 'Caerin 1', 'Caerin_1', 3, NULL),
(8717, NULL, 'IPR034754', NULL, 'Gemini of Cajal bodies-associated protein 8', 'GEMIN8', 4, NULL),
(8718, NULL, 'IPR010997', NULL, 'HRDC-like superfamily', 'HRDC-like_sf', 5, NULL),
(8719, NULL, 'IPR008411', NULL, 'Bovine immunodeficiency virus surface envelope', 'BIV_Surface_Envelope', 4, NULL),
(8720, NULL, 'IPR013293', NULL, 'Nervy', 'Nervy', 4, NULL),
(8721, NULL, 'IPR013297', NULL, 'Neuropeptide B/W precursor family', 'Neuropept_BW_pre', 4, NULL),
(8722, NULL, 'IPR015080', NULL, 'Protein of unknown function DUF1892', 'DUF1892', 4, NULL),
(8723, NULL, 'IPR014288', NULL, 'RNA polymerase sigma-B factor', 'RNA_pol_sigma-B', 4, NULL),
(8724, NULL, 'IPR035200', NULL, 'Cell division control protein 24, OB domain 2', 'Cdc24_OB2', 3, NULL),
(8725, NULL, 'IPR013170', NULL, 'mRNA splicing factor Cwf21 domain', 'mRNA_splic_Cwf21_dom', 3, NULL),
(8726, NULL, 'IPR008438', NULL, 'Myozenin', 'MYOZ', 4, NULL),
(8727, NULL, 'IPR015083', NULL, 'Polyketide synthase, docking domain', 'Polyketide_synth_docking', 3, NULL),
(8728, NULL, 'IPR008447', NULL, 'Protein L2', 'Prot_L2', 4, NULL),
(8729, NULL, 'IPR008414', NULL, 'Hemolysin BL-binding component', 'HBL', 4, NULL),
(8730, NULL, 'IPR008264', NULL, 'Beta-glucanase', 'Beta_glucanase', 4, NULL),
(8731, NULL, 'IPR013289', NULL, 'CBFA2T family', 'CBFA2T1/2/3', 4, NULL),
(8732, NULL, 'IPR008408', NULL, 'Brain acid soluble protein 1', 'BASP1', 4, NULL),
(8733, NULL, 'IPR013171', NULL, 'Cytidine/deoxycytidylate deaminase, zinc-binding domain', 'Cyd/dCyd_deaminase_Zn-bd', 3, NULL),
(8734, NULL, 'IPR024270', NULL, 'Urocortin II/III', 'Urocortin_II/III', 4, NULL),
(8735, NULL, 'IPR011532', NULL, 'Sec-independent protein translocase TatC, archaeal', 'TatC_arc', 4, NULL),
(8736, NULL, 'IPR014278', NULL, 'Nitrogenase iron-iron, delta subunit', 'Nase_Fe-Fe_dsu', 4, NULL),
(8737, NULL, 'IPR008409', NULL, 'Pre-mRNA-splicing factor SPF27', 'SPF27', 4, NULL),
(8738, NULL, 'IPR009990', NULL, 'Pardaxin', 'Pardaxin', 4, NULL),
(8739, NULL, 'IPR023821', NULL, 'Radical SAM, TatD-associated', 'rSAM_TatD-assoc', 4, NULL),
(8740, NULL, 'IPR010316', NULL, 'DNA-3-methyladenine glycosylase AlkA, N-terminal', 'AlkA_N', 3, NULL),
(8741, NULL, 'IPR013529', NULL, 'Glycoside hydrolase, family 42, N-terminal', 'Glyco_hydro_42_N', 3, NULL),
(8742, NULL, 'IPR023129', NULL, 'MTH889-like domain superfamily', 'MTH889-like_dom_sf', 5, NULL),
(8743, NULL, 'IPR010354', NULL, 'Oleate hydratase', 'Oleate_hydratase', 4, NULL),
(8744, NULL, 'IPR013295', NULL, 'Myelin and lymphocyte (MAL) protein', 'MAL', 4, NULL),
(8745, NULL, 'IPR008952', NULL, 'Tetraspanin, EC2 domain superfamily', 'Tetraspanin_EC2_sf', 5, NULL),
(8746, NULL, 'IPR010346', NULL, 'Spanin, outer membrane subunit', 'O-spanin', 4, NULL),
(8747, NULL, 'IPR008924', NULL, 'Methyl-coenzyme M reductase, alpha/beta subunit, C-terminal', 'Me_CoM_Rdtase_asu/bsu_C', 5, NULL),
(8748, NULL, 'IPR015065', NULL, 'Surface composition regulator', 'GlgS', 4, NULL),
(8749, NULL, 'IPR015056', NULL, 'Nuclear receptor-binding factor 2, C-terminal', 'NRBF2_C', 3, NULL),
(8750, NULL, 'IPR014780', NULL, 'tRNA pseudouridine synthase II, TruB', 'tRNA_psdUridine_synth_TruB', 4, NULL),
(8751, NULL, 'IPR013309', NULL, 'Wnt inhibitory factor (WIF)-1', 'Wnt-inh', 4, NULL),
(8752, NULL, 'IPR015063', NULL, 'USP8 dimerisation domain', 'USP8_dimer', 3, NULL),
(8753, NULL, 'IPR008939', NULL, 'Lytic transglycosylase, superhelical U-shaped', 'Lytic_TGlycosylase_superhlx_U', 5, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(8754, NULL, 'IPR008426', NULL, 'Centromere protein H, C-terminal', 'CENP-H_C', 3, NULL),
(8755, NULL, 'IPR008966', NULL, 'Adhesion domain superfamily', 'Adhesion_dom_sf', 5, NULL),
(8756, NULL, 'IPR012552', NULL, 'DVL', 'DVL', 4, NULL),
(8757, NULL, 'IPR015077', NULL, 'Domain of unknown function DUF1858', 'DUF1858', 3, NULL),
(8758, NULL, 'IPR011342', NULL, 'Shikimate dehydrogenase', 'Shikimate_DH', 4, NULL),
(8759, NULL, 'IPR013162', NULL, 'CD80-like, immunoglobulin C2-set', 'CD80_C2-set', 3, NULL),
(8760, NULL, 'IPR035205', NULL, 'Protein of unknown function DUF5320', 'DUF5320', 4, NULL),
(8761, NULL, 'IPR014186', NULL, 'S-formylglutathione hydrolase', 'S-formylglutathione_hydrol', 4, NULL),
(8762, NULL, 'IPR014176', NULL, 'Phasin, subfamily 3', 'Phasin_subfam-3', 4, NULL),
(8763, NULL, 'IPR015068', NULL, 'Protein of unknown function DUF1877', 'DUF1877', 4, NULL),
(8764, NULL, 'IPR013305', NULL, 'ABC transporter Tap-like', 'ABC_Tap-like', 4, NULL),
(8765, NULL, 'IPR009989', NULL, 'TrbM', 'TrbM', 4, NULL),
(8766, NULL, 'IPR010002', NULL, 'Poneritoxin', 'Poneritoxin', 4, NULL),
(8767, NULL, 'IPR008430', NULL, 'Cytotoxic necrotizing factor, Rho-activating domain', 'CNF_Rho-act', 3, NULL),
(8768, NULL, 'IPR008916', NULL, 'Retrovirus capsid, C-terminal', 'Retrov_capsid_C', 5, NULL),
(8769, NULL, 'IPR013167', NULL, 'Conserved oligomeric Golgi complex, subunit 4', 'COG_su4', 3, NULL),
(8770, NULL, 'IPR015960', NULL, 'Mu1 membrane penetration protein, domain IV', 'Mu1_membr_pen_domIV', 5, NULL),
(8771, NULL, 'IPR014190', NULL, 'Leukotriene B4 12-hydroxydehydrogenase/15-oxo-prostaglandin 13-reductase', 'PTGR1', 4, NULL),
(8772, NULL, 'IPR014174', NULL, 'CRISPR-associated protein, Cas6-related', 'CRISPR-assoc_prot_Cas6-rel', 4, NULL),
(8773, NULL, 'IPR013164', NULL, 'Cadherin, N-terminal', 'Cadherin_N', 3, NULL),
(8774, NULL, 'IPR013281', NULL, 'Apoptosis regulator, Mcl-1', 'Apop_reg_Mc1', 4, NULL),
(8775, NULL, 'IPR011340', NULL, 'Cysteine desulfurase-related', 'Cys_dSase-rel', 4, NULL),
(8776, NULL, 'IPR024283', NULL, 'Translocase of chloroplast 159/132, membrane anchor domain', 'TOC159_MAD', 3, NULL),
(8777, NULL, 'IPR009991', NULL, 'Dynactin subunit 3', 'DCTN3', 4, NULL),
(8778, NULL, 'IPR012738', NULL, 'Transcription regulator DhaS', 'Tscrpt_reg_DhaS', 4, NULL),
(8779, NULL, 'IPR015458', NULL, 'MDM4', 'MDM4', 4, NULL),
(8780, NULL, 'IPR014294', NULL, 'RNA polymerase sigma-W, bacillaceae', 'RNA_pol_sigma-W_bacilli', 4, NULL),
(8781, NULL, 'IPR011715', NULL, 'Tyrosine aminotransferase ubiquitination region', 'Tyr_aminoTrfase_ubiquitination', 3, NULL),
(8782, NULL, 'IPR008404', NULL, 'Apovitellenin I', 'Apo-VLDL-II', 4, NULL),
(8783, NULL, 'IPR015058', NULL, 'Protein of unknown function DUF1878', 'DUF1878', 4, NULL),
(8784, NULL, 'IPR023250', NULL, 'Cyclin-dependent kinase 2-interacting protein', 'Cyclin-dep_Kinase_2_interact', 4, NULL),
(8785, NULL, 'IPR010351', NULL, 'Protein of unknown function DUF943', 'DUF943', 4, NULL),
(8786, NULL, 'IPR013296', NULL, 'HSPB1-associated protein 1', 'HSPB1-associated_protein_1', 4, NULL),
(8787, NULL, 'IPR024281', NULL, 'Bacteriophage T7-like virion assembly protein', 'Phage_T7-like_viron_assmbl', 4, NULL),
(8788, NULL, 'IPR008926', NULL, 'Ribonucleotide reductase R1 subunit, N-terminal', 'RNR_R1-su_N', 5, NULL),
(8789, NULL, 'IPR015965', NULL, 'tRNA ligase, phosphodiesterase', 'tRNA_lig_PDEase', 3, NULL),
(8790, NULL, 'IPR014295', NULL, 'Anti-sigma factor', 'Anti-sigma', 4, NULL),
(8791, NULL, 'IPR010367', NULL, 'Poxvirus G3', 'Poxvirus_G3', 4, NULL),
(8792, NULL, 'IPR024648', NULL, 'Peptidase A2E, retrotransposon', 'Pept_A2E_retrotransp', 4, NULL),
(8793, NULL, 'IPR024268', NULL, 'rRNA methyltransferase AviRa', 'AviRa', 4, NULL),
(8794, NULL, 'IPR015097', NULL, 'Lung surfactant protein D coiled-coil trimerisation', 'Surfac_D-trimer', 3, NULL),
(8795, NULL, 'IPR015062', NULL, 'Protein of unknown function DUF1885', 'DUF1885', 4, NULL),
(8796, NULL, 'IPR008965', NULL, 'CBM2/CBM3, carbohydrate-binding domain superfamily', 'CBM2/CBM3_carb-bd_dom_sf', 5, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(8797, NULL, 'IPR015446', NULL, 'Bone morphogenetic protein 1/tolloid-like protein', 'BMP_1/tolloid-like', 4, NULL),
(8798, NULL, 'IPR013158', NULL, 'APOBEC-like, N-terminal', 'APOBEC_N', 3, NULL),
(8799, NULL, 'IPR014198', NULL, 'Stage III sporulation protein AB', 'Spore_III_AB', 4, NULL),
(8800, NULL, 'IPR015445', NULL, 'TATA-Box binding protein-like', 'TBP-like', 4, NULL),
(8801, NULL, 'IPR014180', NULL, 'Sugar isomerase, AgaS', 'Sugar_isomerase_AgaS', 4, NULL),
(8802, NULL, 'IPR013277', NULL, 'Peptidase M12B, ADAM-TS8', 'Pept_M12B_ADAM-TS8', 4, NULL),
(8803, NULL, 'IPR015093', NULL, 'Protein of unknown function DUF1887', 'DUF1887', 4, NULL),
(8804, NULL, 'IPR014280', NULL, 'Nitrogenase iron-iron, beta subunit', 'Nase_Fe-Fe_bsu', 4, NULL),
(8805, NULL, 'IPR015087', NULL, 'Necrosis inducing protein-1', 'NIP1', 4, NULL),
(8806, NULL, 'IPR013172', NULL, 'Bomanin', 'Bomanin', 4, NULL),
(8807, NULL, 'IPR010347', NULL, 'Tyrosyl-DNA phosphodiesterase I', 'Tdp1', 4, NULL),
(8808, NULL, 'IPR014782', NULL, 'Peptidase M1, membrane alanine aminopeptidase', 'Peptidase_M1_dom', 3, NULL),
(8809, NULL, 'IPR015102', NULL, 'Transcriptional regulator HTH-type, FeoC', 'Tscrpt_reg_HTH_FeoC', 3, NULL),
(8810, NULL, 'IPR010321', NULL, 'Protein of unknown function DUF922', 'DUF922', 4, NULL),
(8811, NULL, 'IPR023820', NULL, 'Radical SAM GDL-associated', 'rSAM_GDL-assoc', 4, NULL),
(8812, NULL, 'IPR014281', NULL, 'Nitrogenase vanadium-iron protein beta chain', 'Nase_VnfK', 4, NULL),
(8813, NULL, 'IPR008415', NULL, 'Nucleopolyhedrovirus late expression factor 3', 'Baculo_LEF-3', 4, NULL),
(8814, NULL, 'IPR008919', NULL, 'Retrovirus capsid, N-terminal', 'Retrov_capsid_N', 5, NULL),
(8815, NULL, 'IPR012551', NULL, 'Protein of unknown function DUF1707', 'DUF1707', 4, NULL),
(8816, NULL, 'IPR011004', NULL, 'Trimeric LpxA-like superfamily', 'Trimer_LpxA-like_sf', 5, NULL),
(8817, NULL, 'IPR011011', NULL, 'Zinc finger, FYVE/PHD-type', 'Znf_FYVE_PHD', 5, NULL),
(8818, NULL, 'IPR011881', NULL, '1,2-phenylacetyl-CoA epoxidase, subunit A', 'PaaA', 4, NULL),
(8819, NULL, 'IPR034756', NULL, 'Type II secretion system (T2SS), protein M subtype b', 'T2SSM_b', 4, NULL),
(8820, NULL, 'IPR014776', NULL, 'Tetrapyrrole methylase, subdomain 2', '4pyrrole_Mease_sub2', 5, NULL),
(8821, NULL, 'IPR010364', NULL, 'Uncharacterised protein family, inner membrane CreD', 'Uncharacterised_IM_CreD', 4, NULL),
(8822, NULL, 'IPR010314', NULL, 'E3 ubiquitin ligase, domain of unknown function DUF913', 'E3_Ub_ligase_DUF913', 3, NULL),
(8823, NULL, 'IPR015090', NULL, 'Bacterial epsilon antitoxin', 'Epsilon_antitox', 4, NULL),
(8824, NULL, 'IPR008445', NULL, 'Core protein A15', 'A15', 4, NULL),
(8825, NULL, 'IPR008303', NULL, 'Putative methanogenesis marker protein 14', 'Methan_mark_14', 4, NULL),
(8826, NULL, 'IPR015051', NULL, 'Protein YoaG', 'YoaG', 4, NULL),
(8827, NULL, 'IPR010317', NULL, 'Protein of unknown function DUF916, cell surface putative', 'DUF916', 4, NULL),
(8828, NULL, 'IPR014166', NULL, 'Tol-Pal system-associated acyl-CoA thioesterase', 'Tol-Pal_acyl-CoA_thioesterase', 4, NULL),
(8829, NULL, 'IPR013276', NULL, 'Peptidase M12B, ADAM-TS5', 'Pept_M12B_ADAM-TS5', 4, NULL),
(8830, NULL, 'IPR014187', NULL, 'Alcohol dehydrogenase, zinc-binding type 2', 'ADH_Zn_typ-2', 4, NULL),
(8831, NULL, 'IPR015057', NULL, 'Rv2632c-like', 'Rv2632c-like', 4, NULL),
(8832, NULL, 'IPR012545', NULL, 'Protein of unknown function DUF1697', 'DUF1697', 4, NULL),
(8833, NULL, 'IPR015070', NULL, 'DJBP, EF-hand domain', 'EF_hand_DJBP', 3, NULL),
(8834, NULL, 'IPR014784', NULL, 'Copper type II, ascorbate-dependent monooxygenase-like, C-terminal', 'Cu2_ascorb_mOase-like_C', 5, NULL),
(8835, NULL, 'IPR011254', NULL, 'Prismane-like superfamily', 'Prismane-like_sf', 5, NULL),
(8836, NULL, 'IPR014177', NULL, 'Putative formate dehydrogenase, TAT signal-containing', 'Formate_DH_TAT-contain', 4, NULL),
(8837, NULL, 'IPR011893', NULL, 'Selenoprotein, Rdx-type', 'Selenoprotein_Rdx-typ', 4, NULL),
(8838, NULL, 'IPR011008', NULL, 'Dimeric alpha-beta barrel', 'Dimeric_a/b-barrel', 5, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(8839, NULL, 'IPR008917', NULL, 'Transcription factor, Skn-1-like, DNA-binding domain superfamily', 'TF_DNA-bd_sf', 5, NULL),
(8840, NULL, 'IPR013298', NULL, 'Neuropeptide B precursor', 'Neuropept_B_pre', 4, NULL),
(8841, NULL, 'IPR010349', NULL, 'L-asparaginase II', 'Asparaginase_II', 4, NULL),
(8842, NULL, 'IPR011887', NULL, 'Trimethylamine-N-oxide reductase TorA', 'TorA', 4, NULL),
(8843, NULL, 'IPR008441', NULL, 'AfumC-like glycosyltransferase', 'AfumC-like_glycosyl_Trfase', 4, NULL),
(8844, NULL, 'IPR009993', NULL, 'TDP-N-acetylfucosamine:lipid II N-acetylfucosaminyltransferase', 'WecF', 4, NULL),
(8845, NULL, 'IPR008428', NULL, 'Chondroitin N-acetylgalactosaminyltransferase', 'Chond_GalNAc', 4, NULL),
(8846, NULL, 'IPR023233', NULL, 'Herpesvirus major capsid protein, upper domain superfamily', 'Herpes_MCP_upper_sf', 5, NULL),
(8847, NULL, 'IPR012539', NULL, 'Crustacean cuticle', 'Cuticle_1', 4, NULL),
(8848, NULL, 'IPR008446', NULL, 'Chordopoxvirus G2', 'Chordopox_G2', 4, NULL),
(8849, NULL, 'IPR010923', NULL, 'tRNA threonylcarbamoyladenosine biosynthesis protein SUA5', 'T(6)A37_SUA5', 4, NULL),
(8850, NULL, 'IPR013166', NULL, 'Citrate lyase ligase, C-terminal', 'Citrate_lyase_ligase_C', 3, NULL),
(8851, NULL, 'IPR015060', NULL, 'Protein of unknown function DUF1870', 'DUF1870', 4, NULL),
(8852, NULL, 'IPR013302', NULL, 'Wnt-10 protein', 'Wnt10', 4, NULL),
(8853, NULL, 'IPR014026', NULL, 'UDP-glucose/GDP-mannose dehydrogenase, dimerisation', 'UDP-Glc/GDP-Man_DH_dimer', 3, NULL),
(8854, NULL, 'IPR010330', NULL, 'Competence-induced protein CoiA-like', 'CoiA-like', 4, NULL),
(8855, NULL, 'IPR015103', NULL, 'Protein-tyrosine phosphatase, YopH, N-terminal', 'ProtTyrPase_YopH_N', 3, NULL),
(8856, NULL, 'IPR013530', NULL, 'Protein-arginine deiminase, C-terminal', 'PAD_C', 3, NULL),
(8857, NULL, 'IPR013279', NULL, 'Apoptosis regulator, Bcl-X', 'Apop_reg_BclX', 4, NULL),
(8858, NULL, 'IPR010010', NULL, 'Photosystem I PsaM, reaction centre', 'PSI_PsaM', 4, NULL),
(8859, NULL, 'IPR017859', NULL, 'Treacle protein', 'Treacle', 4, NULL),
(8860, NULL, 'IPR008444', NULL, 'Chlamydia virulence plasmid protein pGP3', 'Chlamydia_pGP3', 4, NULL),
(8861, NULL, 'IPR014182', NULL, 'Alcohol dehydrogenase, zinc-binding type 1', 'ADH_Zn_typ-1', 4, NULL),
(8862, NULL, 'IPR008424', NULL, 'Immunoglobulin C2-set', 'Ig_C2-set', 3, NULL),
(8863, NULL, 'IPR015095', NULL, 'Alkylated DNA repair protein AlkB, homologue 8, N-terminal', 'AlkB_hom8_N', 3, NULL),
(8864, NULL, 'IPR014293', NULL, 'RNA polymerase sigma-70, actinobacteria', 'RNA_pol_sigma70_actinobac', 4, NULL),
(8865, NULL, 'IPR008263', NULL, 'Glycoside hydrolase, family 16, active site', 'GH16_AS', 0, NULL),
(8866, NULL, 'IPR013168', NULL, 'Cpl-7 lysozyme, C-terminal', 'Cpl_7_lyso_C', 3, NULL),
(8867, NULL, 'IPR008437', NULL, 'Minor structural protein, calicivirus', 'Minor_structural_calicivir', 4, NULL),
(8868, NULL, 'IPR015961', NULL, 'Mu1 membrane penetration protein, domain I', 'Mu1_membr_pen_domI', 5, NULL),
(8869, NULL, 'IPR008288', NULL, 'Poly [ADP-ribose] polymerase', 'PARP', 4, NULL),
(8870, NULL, 'IPR010319', NULL, 'Transglutaminase-like cysteine peptidase, predicted', 'Transglutaminase-like_Cys_pept', 4, NULL),
(8871, NULL, 'IPR023786', NULL, '3-(3-hydroxy-phenyl)propionate/3-hydroxycinnamic acid hydroxylase', '3-HPP/3HCI_hydroxylase', 4, NULL),
(8872, NULL, 'IPR011251', NULL, 'Luciferase-like domain', 'Luciferase-like_dom', 3, NULL),
(8873, NULL, 'IPR008936', NULL, 'Rho GTPase activation protein', 'Rho_GTPase_activation_prot', 5, NULL),
(8874, NULL, 'IPR012740', NULL, 'Trimethylamine methyltransferase, Methanosarcina', 'MttB_Methanosar', 4, NULL),
(8875, NULL, 'IPR012544', NULL, 'Bacterial Pleckstrin homology domain', 'PHb', 3, NULL),
(8876, NULL, 'IPR011882', NULL, '1,2-phenylacetyl-CoA epoxidase, subunit C', 'PaaC', 4, NULL),
(8877, NULL, 'IPR010358', NULL, 'BRCA1-A complex subunit BRE', 'BRE', 4, NULL),
(8878, NULL, 'IPR008309', NULL, 'Uncharacterised conserved protein UCP025560', 'UCP025560', 4, NULL),
(8879, NULL, 'IPR010007', NULL, 'SPAN-X family', 'SPAN-X_fam', 4, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(8880, NULL, 'IPR010999', NULL, 'Retroviral matrix protein', 'Retrovr_matrix', 5, NULL),
(8881, NULL, 'IPR008925', NULL, 'Aminoacyl-tRNA synthetase, class I, anticodon-binding superfamily', 'aa_tRNA-synth_I_cd-bd_sf', 5, NULL),
(8882, NULL, 'IPR014168', NULL, 'Tol-Pal system protein TolR', 'Tol-Pal_TolR', 4, NULL),
(8883, NULL, 'IPR008406', NULL, 'Dormancy/auxin associated protein', 'DRM/ARP', 4, NULL),
(8884, NULL, 'IPR008265', NULL, 'Lipase, GDSL, active site', 'Lipase_GDSL_AS', 0, NULL),
(8885, NULL, 'IPR015079', NULL, 'Protein of unknown function DUF1889', 'DUF1889', 4, NULL),
(8886, NULL, 'IPR013287', NULL, 'Claudin-12', 'Claudin12', 4, NULL),
(8887, NULL, 'IPR012554', NULL, 'Degradation enzyme regulation protein DegQ', 'DegQ', 4, NULL),
(8888, NULL, 'IPR008299', NULL, 'Prephenate dehydrogenase/arogenate dehydrogenase', 'Prep_DH/arog_DH', 4, NULL),
(8889, NULL, 'IPR008407', NULL, 'Branched-chain amino acid transport, AzlD', 'Brnchd-chn_aa_trnsp_AzlD', 4, NULL),
(8890, NULL, 'IPR015074', NULL, 'Protein of unknown function DUF1867', 'DUF1867', 4, NULL),
(8891, NULL, 'IPR008425', NULL, 'Cyclin-dependent kinase inhibitor 3', 'CDK_inhib_3', 4, NULL),
(8892, NULL, 'IPR023621', NULL, 'Ribosomal protein L31e domain superfamily', 'Ribosomal_L31e_dom_sf', 5, NULL),
(8893, NULL, 'IPR011717', NULL, 'Tetratricopeptide TPR-4', 'TPR-4', 7, NULL),
(8894, NULL, 'IPR008431', NULL, 'Cyclic nucleotide phosphodiesterase', 'CNPase', 4, NULL),
(8895, NULL, 'IPR034753', NULL, 'hSac2 domain', 'hSac2', 3, NULL),
(8896, NULL, 'IPR010369', NULL, 'Protein SOSEKI', 'SOK', 4, NULL),
(8897, NULL, 'IPR012537', NULL, 'Chloramphenicol resistance gene leader peptide', 'Cmp-R_leader', 4, NULL),
(8898, NULL, 'IPR013304', NULL, 'Wnt-16 protein', 'Wnt16', 4, NULL),
(8899, NULL, 'IPR010329', NULL, '3-hydroxyanthranilic acid dioxygenase', '3hydroanth_dOase', 4, NULL),
(8900, NULL, 'IPR008292', NULL, 'Haptoglobin', 'Haptoglobin', 4, NULL),
(8901, NULL, 'IPR008954', NULL, 'Moesin tail domain superfamily', 'Moesin_tail_sf', 5, NULL),
(8902, NULL, 'IPR008297', NULL, 'Notch', 'Notch', 4, NULL),
(8903, NULL, 'IPR008258', NULL, 'Transglycosylase SLT domain 1', 'Transglycosylase_SLT_dom_1', 3, NULL),
(8904, NULL, 'IPR008256', NULL, 'Peptidase S1B', 'Peptidase_S1B', 4, NULL),
(8905, NULL, 'IPR012542', NULL, 'DTHCT', 'DTHCT', 3, NULL),
(8906, NULL, 'IPR008271', NULL, 'Serine/threonine-protein kinase, active site', 'Ser/Thr_kinase_AS', 0, NULL),
(8907, NULL, 'IPR015824', NULL, 'Phosphoglycerate kinase, N-terminal', 'Phosphoglycerate_kinase_N', 5, NULL),
(8908, NULL, 'IPR008932', NULL, 'Ribosomal protein L7/L12, oligomerisation', 'Ribosomal_L7/L12_oligo', 3, NULL),
(8909, NULL, 'IPR014282', NULL, 'Nitrogen fixation protein NifM', 'Nitrogen_fix_NifM', 4, NULL),
(8910, NULL, 'IPR008440', NULL, 'Agglutinin-like  protein repeat', 'Agglutinin-like_ALS_rpt', 7, NULL),
(8911, NULL, 'IPR011880', NULL, 'Phenylacetate-CoA ligase', 'PA_CoA_ligase', 4, NULL),
(8912, NULL, 'IPR013169', NULL, 'mRNA splicing factor Cwf18-like', 'mRNA_splic_Cwf18-like', 4, NULL),
(8913, NULL, 'IPR034855', NULL, 'RBM12, RNA recognition motif 3', 'RBM12_RRM3', 3, NULL),
(8914, NULL, 'IPR012549', NULL, 'Phosphoethanolamine transferase, N-terminal', 'EptA-like_N', 3, NULL),
(8915, NULL, 'IPR033988', NULL, 'CEL-1-like C-type lectin-like domain', 'CEL1-like_CTLD', 3, NULL),
(8916, NULL, 'IPR010335', NULL, 'Mesothelin', 'Mesothelin', 4, NULL),
(8917, NULL, 'IPR008948', NULL, 'L-Aspartase-like', 'L-Aspartase-like', 5, NULL),
(8918, NULL, 'IPR011009', NULL, 'Protein kinase-like domain superfamily', 'Kinase-like_dom_sf', 5, NULL),
(8919, NULL, 'IPR013313', NULL, 'GPR40 receptor fatty acid', 'GPR40_recept_FA', 4, NULL),
(8920, NULL, 'IPR008412', NULL, 'Bone sialoprotein 2', 'BSP_II', 4, NULL),
(8921, NULL, 'IPR014171', NULL, 'TonB system transport protein ExbD type-2', 'TonB_ExbD_2', 4, NULL),
(8922, NULL, 'IPR009999', NULL, 'Protein of unknown function DUF1514', 'DUF1514', 4, NULL),
(8923, NULL, 'IPR010359', NULL, 'IrrE N-terminal-like domain', 'IrrE_HExxH', 3, NULL),
(8924, NULL, 'IPR010350', NULL, 'Thioredoxin-like ferredoxin, bacteria', 'Aim32/Apd1-like_bac', 4, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(8925, NULL, 'IPR011533', NULL, 'Oxygen-dependent choline dehydrogenase', 'BetA', 4, NULL),
(8926, NULL, 'IPR023126', NULL, 'HP0242-like superfamily', 'HP0242-like_sf', 5, NULL),
(8927, NULL, 'IPR015066', NULL, 'Domain of unknown function DUF1902', 'DUF1902', 3, NULL),
(8928, NULL, 'IPR015099', NULL, 'Exotoxin A catalytic domain', 'Exotox-A_cataly_dom', 3, NULL),
(8929, NULL, 'IPR010996', NULL, 'DNA polymerase beta-like, N-terminal domain', 'DNA_pol_b-like_N', 3, NULL),
(8930, NULL, 'IPR035233', NULL, 'Protein of unknown function DUF5443', 'DUF5443', 4, NULL),
(8931, NULL, 'IPR010998', NULL, 'Integrase/recombinase, N-terminal', 'Integrase_recombinase_N', 5, NULL),
(8932, NULL, 'IPR008930', NULL, 'Terpenoid cyclases/protein prenyltransferase alpha-alpha toroid', 'Terpenoid_cyclase/PrenylTrfase', 5, NULL),
(8933, NULL, 'IPR011257', NULL, 'DNA glycosylase', 'DNA_glycosylase', 5, NULL),
(8934, NULL, 'IPR015071', NULL, 'Bypass-of-forespore C, N-terminal', 'BOFC_N', 3, NULL),
(8935, NULL, 'IPR008306', NULL, 'Uncharacterised conserved protein UCP018008', 'UCP018008', 4, NULL),
(8936, NULL, 'IPR008928', NULL, 'Six-hairpin glycosidase superfamily', '6-hairpin_glycosidase_sf', 5, NULL),
(8937, NULL, 'IPR008434', NULL, 'Magnesium-protoporphyrin IX monomethyl ester [oxidative] cyclase', 'AcsF', 4, NULL),
(8938, NULL, 'IPR010994', NULL, 'RuvA domain 2-like', 'RuvA_2-like', 5, NULL),
(8939, NULL, 'IPR014172', NULL, 'TonB-system energizer ExbB type-2', 'TonB_ExbB_2', 4, NULL),
(8940, NULL, 'IPR010344', NULL, 'Exopolysaccharide biosynthesis protein YbjH', 'YbjH', 4, NULL),
(8941, NULL, 'IPR008304', NULL, 'Uncharacterised conserved protein UCP017998', 'UCP017998', 4, NULL),
(8942, NULL, 'IPR008307', NULL, 'Uncharacterised conserved protein UCP018957', 'UCP018957', 4, NULL),
(8943, NULL, 'IPR013300', NULL, 'Wnt-7 protein', 'Wnt7', 4, NULL),
(8944, NULL, 'IPR008417', NULL, 'B-cell receptor-associated protein 29/31', 'BAP29/BAP31', 4, NULL),
(8945, NULL, 'IPR009988', NULL, 'Domain of unknown function DUF1510', 'DUF1510', 3, NULL),
(8946, NULL, 'IPR014781', NULL, 'Anthrax toxin, lethal/endema factor, N-/C-terminal', 'Anthrax_toxin_lethal/edema_N/C', 3, NULL),
(8947, NULL, 'IPR010313', NULL, 'Glycine N-acyltransferase', 'Glycine_N-acyltransferase', 4, NULL),
(8948, NULL, 'IPR024280', NULL, 'FAM167', 'FAM167', 4, NULL),
(8949, NULL, 'IPR008935', NULL, 'Virus capsid protein, alpha-helical', 'Virus_capsid_a-hlx_vir', 5, NULL),
(8950, NULL, 'IPR008401', NULL, 'Apc13', 'Apc13', 4, NULL),
(8951, NULL, 'IPR010341', NULL, 'Protein of unknown function DUF936, plant', 'DUF936_pln', 4, NULL),
(8952, NULL, 'IPR014173', NULL, 'Peptidase C11, Clostripain Clostridium species', 'Pept_C11_CLOspp', 4, NULL),
(8953, NULL, 'IPR008432', NULL, 'Cytochrome c oxidase subunit 5c', 'COX5C', 4, NULL),
(8954, NULL, 'IPR008435', NULL, 'Corticotropin-releasing factor-binding protein', 'CRF-bd', 4, NULL),
(8955, NULL, 'IPR014191', NULL, 'Anaerobic ribonucleoside-triphosphate reductase activator', 'Anaer_RNR_activator', 4, NULL),
(8956, NULL, 'IPR010360', NULL, 'Protein of unknown function DUF956', 'DUF956', 4, NULL),
(8957, NULL, 'IPR010368', NULL, 'Control of competence regulator ComK, YlbF/YmcA', 'Com_YlbF', 4, NULL),
(8958, NULL, 'IPR012553', NULL, 'Defensin-like peptide', 'Defensin_3', 4, NULL),
(8959, NULL, 'IPR015073', NULL, 'Domain of unknown function DUF1883', 'DUF1883', 3, NULL),
(8960, NULL, 'IPR024284', NULL, 'Protein of unknown function DUF3826', 'DUF3826', 4, NULL),
(8961, NULL, 'IPR016018', NULL, 'Guanine nucleotide exchange factor SopE, N-terminal domain', 'SopE_N_dom', 3, NULL),
(8962, NULL, 'IPR009998', NULL, 'YfaZ', 'YfaZ', 4, NULL),
(8963, NULL, 'IPR010254', NULL, 'B12-dependent dehydratases, beta subunit', 'B12-dep_deHydtase_bsu', 5, NULL),
(8964, NULL, 'IPR014290', NULL, 'SUF system FeS cluster assembly regulator', 'SUF_FeS_clus_asmbl_reg', 4, NULL),
(8965, NULL, 'IPR010323', NULL, 'Protein of unknown function DUF924', 'DUF924', 4, NULL),
(8966, NULL, 'IPR008436', NULL, 'Chlamydia 15kDa cysteine-rich outer membrane', 'CRPA', 4, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(8967, NULL, 'IPR013307', NULL, 'Superantigen, staphylococcal/streptococcal toxin, bacterial', 'Superantigen_bac', 4, NULL),
(8968, NULL, 'IPR008433', NULL, 'Cytochrome C oxidase, subunit VIIB', 'Cyt_c_oxidase_suVIIB', 4, NULL),
(8969, NULL, 'IPR024645', NULL, 'Mitochondrial export protein Som1', 'Mitochondr_Som1', 4, NULL),
(8970, NULL, 'IPR015806', NULL, 'Pyruvate kinase, insert domain superfamily', 'Pyrv_Knase_insert_dom_sf', 5, NULL),
(8971, NULL, 'IPR010357', NULL, 'Thioredoxin domain-containing protein 17-like domain', 'TXNDC17_dom', 3, NULL),
(8972, NULL, 'IPR014183', NULL, 'Alcohol dehydrogenase class III', 'ADH_3', 4, NULL),
(8973, NULL, 'IPR015963', NULL, 'Uridylate kinase, bacteria', 'Uridylate_kinase_bac', 4, NULL),
(8974, NULL, 'IPR010326', NULL, 'Exocyst complex component EXOC3/Sec6', 'EXOC3/Sec6', 4, NULL),
(8975, NULL, 'IPR008420', NULL, 'Borrelia membrane P13', 'Borrelia_P13', 4, NULL),
(8976, NULL, 'IPR008296', NULL, 'Tissue factor pathway inhibitor-like', 'TFPI-like', 4, NULL),
(8977, NULL, 'IPR014184', NULL, 'Formaldehyde dehydrogenase, glutathione-independent', 'HCHO_DH_non_GSH', 4, NULL),
(8978, NULL, 'IPR015055', NULL, 'STIV B116-like', 'STIV_B116-like', 4, NULL),
(8979, NULL, 'IPR011883', NULL, 'Phenylacetate-CoA oxygenase, PaaJ subunit', 'PA_CoA_Oase4', 4, NULL),
(8980, NULL, 'IPR010331', NULL, 'Exopolysaccharide synthesis, ExoD', 'ExoD', 4, NULL),
(8981, NULL, 'IPR010345', NULL, 'Interleukin-17 family', 'IL-17_fam', 4, NULL),
(8982, NULL, 'IPR013173', NULL, 'DNA primase DnaG, DnaB-binding domain', 'DNA_primase_DnaG_DnaB-bd_dom', 3, NULL),
(8983, NULL, 'IPR012742', NULL, 'Alanine dehydrogenase, Archaeoglobus-type', 'Ala_DH_archaeglobus', 4, NULL),
(8984, NULL, 'IPR008956', NULL, 'Protease A inhibitor IA3 domain superfamily', 'IA3_dom_sf', 5, NULL),
(8985, NULL, 'IPR008400', NULL, 'Anthrax toxin receptor, extracellular domain', 'Anthrax_toxin_rcpt_extracel', 3, NULL),
(8986, NULL, 'IPR008942', NULL, 'ENTH/VHS', 'ENTH_VHS', 5, NULL),
(8987, NULL, 'IPR014197', NULL, 'Sporulation protein YunB', 'Sporulation_prot_YunB', 4, NULL),
(8988, NULL, 'IPR014279', NULL, 'Nitrogenase vanadium-iron, delta subunit', 'Nase_V-Fe_dsu', 4, NULL),
(8989, NULL, 'IPR008937', NULL, 'Ras-like guanine nucleotide exchange factor', 'Ras-like_GEF', 4, NULL),
(8990, NULL, 'IPR012547', NULL, 'PD-(D/E)XK nuclease superfamily 9', 'PDDEXK_9', 4, NULL),
(8991, NULL, 'IPR008290', NULL, 'Phosphatidylinositol 3-kinase, Vps34 type', 'PI3K_Vps34', 4, NULL),
(8992, NULL, 'IPR015091', NULL, 'Surfactant protein C, N-terminal propeptide', 'Surfactant_protein_propep', 3, NULL),
(8993, NULL, 'IPR011256', NULL, 'Regulatory factor, effector binding domain superfamily', 'Reg_factor_effector_dom_sf', 5, NULL),
(8994, NULL, 'IPR014195', NULL, 'Sporulation stage III, protein AG', 'Spore_III_AG', 4, NULL),
(8995, NULL, 'IPR014277', NULL, 'Orc1/Cdc6-type DNA replication protein, archaea', 'Orc1/Cdc6_arc', 4, NULL),
(8996, NULL, 'IPR015064', NULL, 'Sporulation inhibitor A', 'Sda', 4, NULL),
(8997, NULL, 'IPR008439', NULL, 'Campylobacter major outer membrane', 'Campylo_MOMP', 4, NULL),
(8998, NULL, 'IPR034858', NULL, 'RBM12B, RNA recognition motif 3', 'RBM12B_RRM3', 3, NULL),
(8999, NULL, 'IPR015443', NULL, 'Aldose 1-epimerase', 'Aldose_1-epimerase', 4, NULL),
(9000, NULL, 'IPR010918', NULL, 'PurM-like, C-terminal domain', 'PurM-like_C_dom', 3, NULL),
(9001, NULL, 'IPR013436', NULL, 'Mobile mystery protein B', 'Mobile_mystery_prot_B', 4, NULL),
(9002, NULL, 'IPR012596', NULL, 'Bacteriophage T4, Y12G', 'Phage_T4_Y12G', 4, NULL),
(9003, NULL, 'IPR010372', NULL, 'DNA polymerase III delta, N-terminal', 'DNA_pol3_delta_N', 3, NULL),
(9004, NULL, 'IPR010623', NULL, 'Type VI secretion system IcmF, C-terminal', 'IcmF_C', 3, NULL),
(9005, NULL, 'IPR011015', NULL, 'LEM/LEM-like domain superfamily', 'LEM/LEM-like_dom_sf', 5, NULL),
(9006, NULL, 'IPR008979', NULL, 'Galactose-binding-like domain superfamily', 'Galactose-bd-like_sf', 5, NULL),
(9007, NULL, 'IPR010378', NULL, 'Trafficking protein particle complex subunit 13', 'TRAPPC13', 4, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(9008, NULL, 'IPR011019', NULL, 'KIND domain', 'KIND_dom', 3, NULL),
(9009, NULL, 'IPR009502', NULL, 'Secretion monitor', 'SecM', 4, NULL),
(9010, NULL, 'IPR012601', NULL, 'Spermatozal protamine type', 'Spermatozal_protamine_typ', 4, NULL),
(9011, NULL, 'IPR015970', NULL, 'P40 nucleoprotein, subdomain 2, Borna disease virus', 'P40_nucleoprot_sub2_BD-vir', 5, NULL),
(9012, NULL, 'IPR009475', NULL, 'Protein of unknown function DUF1096', 'DUF1096', 4, NULL),
(9013, NULL, 'IPR012591', NULL, 'PRO8NT domain', 'PRO8NT', 3, NULL),
(9014, NULL, 'IPR010434', NULL, 'Protein of unknown function DUF1033', 'DUF1033', 4, NULL),
(9015, NULL, 'IPR010666', NULL, 'Zinc finger, GRF-type', 'Znf_GRF', 3, NULL),
(9016, NULL, 'IPR013418', NULL, 'CRISPR-associated protein Csd2', 'CRISPR-assoc_prot_Csd2', 4, NULL),
(9017, NULL, 'IPR011042', NULL, 'Six-bladed beta-propeller, TolB-like', '6-blade_b-propeller_TolB-like', 5, NULL),
(9018, NULL, 'IPR009458', NULL, 'Ectatomin', 'Ectatomin', 4, NULL),
(9019, NULL, 'IPR012561', NULL, 'Ferlin B-domain', 'Ferlin_B-domain', 3, NULL),
(9020, NULL, 'IPR009509', NULL, 'Protein of unknown function DUF1132', 'DUF1132', 4, NULL),
(9021, NULL, 'IPR009461', NULL, 'Non-structural protein NSP16, coronavirus-like', 'NSP16_CoV-like', 3, NULL),
(9022, NULL, 'IPR009489', NULL, 'PAR1', 'PAR1', 4, NULL),
(9023, NULL, 'IPR012570', NULL, 'Leucine operon leader peptide', 'Leu_leader', 4, NULL),
(9024, NULL, 'IPR010381', NULL, 'Putative pyroglutamyl peptidase 1', 'PgaPase_1', 4, NULL),
(9025, NULL, 'IPR013456', NULL, 'D-xylose ABC transporter, substrate-binding protein', 'XylF', 4, NULL),
(9026, NULL, 'IPR010401', NULL, 'Glycogen debranching enzyme', 'AGL/Gdb1', 4, NULL),
(9027, NULL, 'IPR011047', NULL, 'Quinoprotein alcohol dehydrogenase-like superfamily', 'Quinoprotein_ADH-like_supfam', 5, NULL),
(9028, NULL, 'IPR010391', NULL, 'DNA damage-inducible protein DinI-like', 'DNA_damage-inducible_DinI-like', 4, NULL),
(9029, NULL, 'IPR010679', NULL, 'Domain of unknown function DUF1254', 'DUF1254', 3, NULL),
(9030, NULL, 'IPR018454', NULL, 'Phosphotransferase system, glucitol/sorbitol-specific IIA component, subgroup', 'PTS_IIA_glucitol/sorbitol_sub', 4, NULL),
(9031, NULL, 'IPR014205', NULL, 'Sporulation protein YtaF', 'Spore_YtaF', 4, NULL),
(9032, NULL, 'IPR010432', NULL, 'RDD', 'RDD', 3, NULL),
(9033, NULL, 'IPR019752', NULL, 'Pyruvate/ketoisovalerate oxidoreductase, catalytic domain', 'Pyrv/ketoisovalerate_OxRed_cat', 3, NULL),
(9034, NULL, 'IPR009486', NULL, 'Purine nucleoside permease', 'Pur_nuclsid_perm', 4, NULL),
(9035, NULL, 'IPR035045', NULL, 'SHB, SH2 domain', 'SHB_SH2', 3, NULL),
(9036, NULL, 'IPR009501', NULL, 'Uncharacterised conserved protein UCP020269', 'UCP020269', 4, NULL),
(9037, NULL, 'IPR035052', NULL, 'SLAP, SH2 domain', 'SLAP_SH2', 3, NULL),
(9038, NULL, 'IPR010652', NULL, 'Domain of unknown function DUF1232', 'DUF1232', 3, NULL),
(9039, NULL, 'IPR013837', NULL, 'ATP synthase, F0 complex, subunit B', 'ATP_synth_F0_suB', 4, NULL),
(9040, NULL, 'IPR010653', NULL, 'NlpB/DapX lipoprotein', 'NlpB/DapX', 4, NULL),
(9041, NULL, 'IPR010399', NULL, 'Tify domain', 'Tify_dom', 3, NULL),
(9042, NULL, 'IPR011020', NULL, 'HTTM', 'HTTM', 3, NULL),
(9043, NULL, 'IPR010680', NULL, 'TraH-2', 'TraH_2', 4, NULL),
(9044, NULL, 'IPR011059', NULL, 'Metal-dependent hydrolase, composite domain superfamily', 'Metal-dep_hydrolase_composite', 5, NULL),
(9045, NULL, 'IPR012586', NULL, 'P120R repeat', 'P120R_rpt', 7, NULL),
(9046, NULL, 'IPR011053', NULL, 'Single hybrid motif', 'Single_hybrid_motif', 5, NULL),
(9047, NULL, 'IPR013420', NULL, 'CRISPR-associated protein Csh1, C-terminal', 'CRISPR-assoc_prot_Csh1_C', 3, NULL),
(9048, NULL, 'IPR009450', NULL, 'Phosphatidylinositol N-acetylglucosaminyltransferase subunit C', 'Plno_GlcNAc_GPI2', 4, NULL),
(9049, NULL, 'IPR013459', NULL, 'Rhamnose ABC transporter, substrate-binding protein RhaS', 'RhaS', 4, NULL),
(9050, NULL, 'IPR014207', NULL, 'Cytochrome o ubiquinol oxidase, subunit I', 'Cyt_c_ubiqinol_oxidase_su1', 4, NULL),
(9051, NULL, 'IPR011029', NULL, 'Death-like domain superfamily', 'DEATH-like_dom_sf', 5, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(9052, NULL, 'IPR013417', NULL, 'Conserved hypothetical protein CHP02588', 'CHP02588', 4, NULL),
(9053, NULL, 'IPR013431', NULL, 'Delta-60 repeat', 'Delta_60_rpt', 7, NULL),
(9054, NULL, 'IPR011146', NULL, 'HIT-like domain', 'HIT-like', 3, NULL),
(9055, NULL, 'IPR011014', NULL, 'Mechanosensitive ion channel MscS, transmembrane-2', 'MscS_channel_TM-2', 5, NULL),
(9056, NULL, 'IPR009469', NULL, 'RNA polymerase, N-terminal, coronavirus', 'RNA_pol_N_CoV', 3, NULL),
(9057, NULL, 'IPR018502', NULL, 'Annexin repeat', 'Annexin_repeat', 7, NULL),
(9058, NULL, 'IPR008982', NULL, 'Adenovirus pIV-like, attachment domain', 'Adenovirus_pIV-like_att', 5, NULL),
(9059, NULL, 'IPR013441', NULL, 'Tyrosine phenol-lyase', 'Tyr_phenol_ly', 4, NULL),
(9060, NULL, 'IPR011021', NULL, 'Arrestin-like, N-terminal', 'Arrestin-like_N', 3, NULL),
(9061, NULL, 'IPR013132', NULL, 'N-acetylneuraminic acid synthase, N-terminal', 'Neu5Ac_N', 3, NULL),
(9062, NULL, 'IPR012565', NULL, 'Histidine operon leader peptide', 'His_leader', 4, NULL),
(9063, NULL, 'IPR011055', NULL, 'Duplicated hybrid motif', 'Dup_hybrid_motif', 5, NULL),
(9064, NULL, 'IPR015990', NULL, 'ADP-specific phosphofructokinase/glucokinase, archaeal', 'ADP_PFK/GK_arc', 4, NULL),
(9065, NULL, 'IPR010393', NULL, 'Protein of unknown function DUF991, YecM-like', 'DUF991_YecM-like', 4, NULL),
(9066, NULL, 'IPR012563', NULL, 'Gns', 'Gns', 4, NULL),
(9067, NULL, 'IPR010677', NULL, 'Human herpes virus type 4, BALF1', 'HHV-4_BALF1', 4, NULL),
(9068, NULL, 'IPR009467', NULL, 'Putative glycolipid-binding protein', 'Glycolipid-bd_prot_put', 4, NULL),
(9069, NULL, 'IPR014012', NULL, 'Helicase/SANT-associated domain', 'HSA_dom', 3, NULL),
(9070, NULL, 'IPR010435', NULL, 'Fn3-like domain', 'Fn3_5', 3, NULL),
(9071, NULL, 'IPR014202', NULL, 'Sporulation stage II, protein R', 'Spore_II_R', 4, NULL),
(9072, NULL, 'IPR013509', NULL, 'Ribonucleotide reductase large subunit, N-terminal', 'RNR_lsu_N', 3, NULL),
(9073, NULL, 'IPR023231', NULL, 'GSKIP domain superfamily', 'GSKIP_dom_sf', 5, NULL),
(9074, NULL, 'IPR013450', NULL, 'L-fuculokinase', 'Fuculokinase', 4, NULL),
(9075, NULL, 'IPR013082', NULL, 'Photosystem II cytochrome b559, alpha subunit, lumenal region', 'PSII_cytb559_asu_lum', 3, NULL),
(9076, NULL, 'IPR010665', NULL, 'Protein of unknown function DUF1240', 'DUF1240', 4, NULL),
(9077, NULL, 'IPR010625', NULL, 'CHCH', 'CHCH', 3, NULL),
(9078, NULL, 'IPR009508', NULL, 'Transcription activator, Churchill', 'Transcrpt_activator_Churchill', 4, NULL),
(9079, NULL, 'IPR011048', NULL, 'Cytochrome cd1-nitrite reductase-like, haem d1 domain superfamily', 'Haem_d1_sf', 5, NULL),
(9080, NULL, 'IPR023557', NULL, '4-deoxy-4-formamido-L-arabinose-phosphoundecaprenol deformylase ArnD, probable', 'ArnD', 4, NULL),
(9081, NULL, 'IPR011017', NULL, 'TRASH domain', 'TRASH_dom', 3, NULL),
(9082, NULL, 'IPR018942', NULL, 'Seminal vesicle protein repeat', 'Seminal_vesicle_protein_repeat', 7, NULL),
(9083, NULL, 'IPR010636', NULL, 'Cerato-ulmin hydrophobin family', 'Cerato-ulmin_hydrophobin', 4, NULL),
(9084, NULL, 'IPR035042', NULL, 'SHE, SH2 domain', 'SHE_SH2', 3, NULL),
(9085, NULL, 'IPR009492', NULL, 'TniQ', 'TniQ', 4, NULL),
(9086, NULL, 'IPR009468', NULL, 'Protein of unknown function DUF1090', 'DUF1090', 4, NULL),
(9087, NULL, 'IPR018528', NULL, 'Prephenate dehydratase, conserved site', 'Preph_deHydtase_CS', 2, NULL),
(9088, NULL, 'IPR010383', NULL, 'Glycosyl hydrolase 94', 'Glyco_hydrolase_94', 3, NULL),
(9089, NULL, 'IPR014052', NULL, 'DNA primase, small subunit, eukaryotic/archaeal', 'DNA_primase_ssu_euk/arc', 4, NULL),
(9090, NULL, 'IPR010402', NULL, 'CCT domain', 'CCT_domain', 3, NULL),
(9091, NULL, 'IPR014020', NULL, 'Tensin phosphatase, C2 domain', 'Tensin_C2-dom', 3, NULL),
(9092, NULL, 'IPR010426', NULL, 'Trimethylamine methyltransferase', 'MTTB_MeTrfase', 4, NULL),
(9093, NULL, 'IPR008969', NULL, 'Carboxypeptidase-like, regulatory domain superfamily', 'CarboxyPept-like_regulatory', 5, NULL),
(9094, NULL, 'IPR010674', NULL, 'Nucleolar GTP-binding protein 1, Rossman-fold domain', 'NOG1_Rossman_fold_dom', 3, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(9095, NULL, 'IPR014004', NULL, 'Transport-associated and nodulation domain, bacteria', 'Transpt-assoc_nodulatn_dom_bac', 3, NULL),
(9096, NULL, 'IPR016002', NULL, 'Succinate dehydrogenase cytochrome b558 subunit, Firmicute', 'Succ_DH_cyt_b558_Firmicute', 4, NULL),
(9097, NULL, 'IPR010427', NULL, 'Protein of unknown function DUF1023', 'DUF1023', 4, NULL),
(9098, NULL, 'IPR011032', NULL, 'GroES-like superfamily', 'GroES-like_sf', 5, NULL),
(9099, NULL, 'IPR009500', NULL, 'Protein of unknown function DUF1118', 'DUF1118', 4, NULL),
(9100, NULL, 'IPR009465', NULL, 'Spondin, N-terminal', 'Spondin_N', 3, NULL),
(9101, NULL, 'IPR010650', NULL, 'PrkA C-terminal domain', 'PrkA_C_dom', 3, NULL),
(9102, NULL, 'IPR010388', NULL, 'Anaerobic cobalt chelatase', 'Anaerobic_Co-chelatase', 4, NULL),
(9103, NULL, 'IPR015972', NULL, 'Ribosomal protein L19/L19e, domain 1', 'Ribosomal_L19/L19e_dom1', 5, NULL),
(9104, NULL, 'IPR024288', NULL, 'Schizont-infected cell agglutination, C-terminal domain', 'SICA_C', 3, NULL),
(9105, NULL, 'IPR013149', NULL, 'Alcohol dehydrogenase-like, C-terminal', 'ADH-like_C', 3, NULL),
(9106, NULL, 'IPR013430', NULL, 'Toxin-antitoxin system, antidote protein, HigA', 'Toxin_antidote_HigA', 4, NULL),
(9107, NULL, 'IPR010410', NULL, 'Protein of unknown function DUF1005', 'DUF1005', 4, NULL),
(9108, NULL, 'IPR009476', NULL, 'Protein of unknown function DUF1097', 'DUF1097', 4, NULL),
(9109, NULL, 'IPR010634', NULL, 'Protein of unknown function DUF1223', 'DUF1223', 4, NULL),
(9110, NULL, 'IPR009497', NULL, 'Regulator protein, PHA-1', 'Regulator_protein_PHA-1', 4, NULL),
(9111, NULL, 'IPR010390', NULL, 'ABC-2 transporter-like', 'ABC-2_transporter-like', 4, NULL),
(9112, NULL, 'IPR010628', NULL, 'Ethanolamine ammonia-lyase heavy chain', 'EutB', 4, NULL),
(9113, NULL, 'IPR010635', NULL, 'Heparan sulphate 6-sulfotransferase/Protein-tyrosine sulfotransferase', 'Heparan_SO4-6-sulfoTrfase', 4, NULL),
(9114, NULL, 'IPR012558', NULL, 'Erythromycin resistance leader peptide-1', 'Emycin-R_leader_pep1', 4, NULL),
(9115, NULL, 'IPR018938', NULL, 'Glycophorin, conserved site', 'Glycophorin_CS', 2, NULL),
(9116, NULL, 'IPR011035', NULL, 'Ribosomal protein L25/Gln-tRNA synthetase, anti-codon-binding domain superfamily', 'Ribosomal_L25/Gln-tRNA_synth', 5, NULL),
(9117, NULL, 'IPR010683', NULL, 'Protein of unknown function DUF1262', 'DUF1262', 4, NULL),
(9118, NULL, 'IPR012562', NULL, 'GUCT', 'GUCT', 3, NULL),
(9119, NULL, 'IPR015993', NULL, 'CDP-diacylglycerol pyrophosphatase, proteobacterial', 'CDP-diacylglyc_Pase_proteobac', 4, NULL),
(9120, NULL, 'IPR010392', NULL, 'Satellite virus coat', 'Satellite_virus_coat', 4, NULL),
(9121, NULL, 'IPR009517', NULL, 'Borna disease virus P24', 'BDV_P24', 4, NULL),
(9122, NULL, 'IPR014212', NULL, 'RNA polymerase sigma-G type', 'RNA_pol_sigma-G', 4, NULL),
(9123, NULL, 'IPR009494', NULL, 'Protein of unknown function DUF1108', 'DUF1108', 4, NULL),
(9124, NULL, 'IPR010621', NULL, 'Domain of unknown function DUF1214', 'DUF1214', 3, NULL),
(9125, NULL, 'IPR014044', NULL, 'CAP domain', 'CAP_domain', 3, NULL),
(9126, NULL, 'IPR010407', NULL, 'Signaling lymphocytic activation molecule, N-terminal', 'Sig_lymph_act_molc_N', 3, NULL),
(9127, NULL, 'IPR011045', NULL, 'Nitrous oxide reductase, N-terminal', 'N2O_reductase_N', 5, NULL),
(9128, NULL, 'IPR013448', NULL, 'L-rhamnose mutarotase', 'L-rhamnose_mutarotase', 4, NULL),
(9129, NULL, 'IPR014039', NULL, 'Translation elongation factor EFTs/EF1B, dimerisation', 'Transl_elong_EFTs/EF1B_dimer', 3, NULL),
(9130, NULL, 'IPR010639', NULL, 'Actin-rearrangement-inducing factor', 'Actin-rearrang-inducing_fac', 4, NULL),
(9131, NULL, 'IPR010630', NULL, 'Olduvai domain', 'Olduvai_dom', 3, NULL),
(9132, NULL, 'IPR014732', NULL, 'Orotidine 5''-phosphate decarboxylase', 'OMPdecase', 4, NULL),
(9133, NULL, 'IPR013427', NULL, 'Haem-binding domain, putative', 'Haem-bd_dom_put', 3, NULL),
(9134, NULL, 'IPR012597', NULL, 'Fungal mating-type pheromone', 'Pheromone', 4, NULL),
(9135, NULL, 'IPR034862', NULL, 'Fungal Mei2-like, RNA recognition motif 3', 'Fungal_Mei2-like_RRM3', 3, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(9136, NULL, 'IPR016142', NULL, 'Citrate synthase-like, large alpha subdomain', 'Citrate_synth-like_lrg_a-sub', 5, NULL),
(9137, NULL, 'IPR014018', NULL, 'SecA motor DEAD', 'SecA_motor_DEAD', 3, NULL),
(9138, NULL, 'IPR011034', NULL, 'Formyl transferase-like, C-terminal domain superfamily', 'Formyl_transferase-like_C_sf', 5, NULL),
(9139, NULL, 'IPR016025', NULL, 'Clathrin heavy chain, N-terminal', 'Clathrin_H-chain_N', 5, NULL),
(9140, NULL, 'IPR018498', NULL, 'Peripherin/rom-1, conserved site', 'Peripherin/rom-1_CS', 2, NULL),
(9141, NULL, 'IPR010420', NULL, 'CASTOR/POLLUX/SYM8 ion channel, conserved domain', 'CASTOR/POLLUX/SYM8_dom', 3, NULL),
(9142, NULL, 'IPR010433', NULL, 'Plant specific eukaryotic initiation factor 4B', 'EIF-4B_pln', 4, NULL),
(9143, NULL, 'IPR013421', NULL, 'CRISPR-associated protein Cas5, HALMA', 'CRISPR-assoc_prot_Cas5_HALMA', 4, NULL),
(9144, NULL, 'IPR013415', NULL, 'CRISPR-associated protein Cas5, bacterial', 'Cas5_bac', 4, NULL),
(9145, NULL, 'IPR012556', NULL, 'Entericidin A/B', 'Entericidin', 4, NULL),
(9146, NULL, 'IPR016054', NULL, 'Ly-6 antigen/uPA receptor-like', 'LY6_UPA_recep-like', 3, NULL),
(9147, NULL, 'IPR019770', NULL, 'Eukaryotic translation initiation factor 4E (eIF-4E), conserved site', 'TIF_eIF_4E_CS', 2, NULL),
(9148, NULL, 'IPR012573', NULL, 'Meleagrin/Cygnin', 'Meleagrin/Cygnin', 4, NULL),
(9149, NULL, 'IPR010657', NULL, 'ImpA, N-terminal', 'ImpA_N', 3, NULL),
(9150, NULL, 'IPR009479', NULL, 'Human herpesvirus U55', 'Herpes_U55', 4, NULL),
(9151, NULL, 'IPR011025', NULL, 'G protein alpha subunit, helical insertion', 'GproteinA_insert', 5, NULL),
(9152, NULL, 'IPR009505', NULL, 'Neural chondroitin sulphate proteoglycan cytoplasmic', 'Neural_ProG_Cyt', 3, NULL),
(9153, NULL, 'IPR014726', NULL, 'Ribosomal protein L2, domain 3', 'Ribosomal_L2_dom3', 5, NULL),
(9154, NULL, 'IPR010428', NULL, 'Zincin-like metallopeptidase', 'Zincin_1', 4, NULL),
(9155, NULL, 'IPR009488', NULL, 'Protein of unknown function DUF1104', 'DUF1104', 4, NULL),
(9156, NULL, 'IPR016075', NULL, 'RNA polymerase, phosphoprotein P, C-terminal XD, paramyxovirinae', 'RNA_pol_Pprot-P_XD_paramyxovir', 5, NULL),
(9157, NULL, 'IPR018494', NULL, 'Oxysterol-binding protein, conserved site', 'Oxysterol-bd_CS', 2, NULL),
(9158, NULL, 'IPR035049', NULL, 'EAT-2, SH2 domain', 'EAT2_SH2', 3, NULL),
(9159, NULL, 'IPR016032', NULL, 'Signal transduction response regulator, C-terminal effector', 'Sig_transdc_resp-reg_C-effctor', 5, NULL),
(9160, NULL, 'IPR010673', NULL, 'Protein of unknown function UPF0346', 'UPF0346', 4, NULL),
(9161, NULL, 'IPR024293', NULL, 'SAC3 helical domain', 'SAC3_helical', 3, NULL),
(9162, NULL, 'IPR010678', NULL, 'U3 small nucleolar RNA-associated protein 25', 'UTP25', 4, NULL),
(9163, NULL, 'IPR014200', NULL, 'RNA polymerase sigma-E type', 'RNA_pol_sigma-E', 4, NULL),
(9164, NULL, 'IPR011061', NULL, 'Hirudin/antistatin', 'Hirudin/antistatin', 5, NULL),
(9165, NULL, 'IPR013798', NULL, 'Indole-3-glycerol phosphate synthase domain', 'Indole-3-glycerol_P_synth_dom', 3, NULL),
(9166, NULL, 'IPR010424', NULL, 'Acetate kinase EutQ', 'EutQ', 4, NULL),
(9167, NULL, 'IPR010400', NULL, 'PITH domain', 'PITH_dom', 3, NULL),
(9168, NULL, 'IPR018933', NULL, 'Netrin module, non-TIMP type', 'Netrin_module_non-TIMP', 3, NULL),
(9169, NULL, 'IPR009459', NULL, 'MucBP domain', 'MucBP_dom', 3, NULL),
(9170, NULL, 'IPR023168', NULL, 'Aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase, C-terminal, domain 2', 'GatB_Yqey_C_2', 5, NULL),
(9171, NULL, 'IPR010418', NULL, 'ECSIT', 'ECSIT', 4, NULL),
(9172, NULL, 'IPR011145', NULL, 'Scavenger mRNA decapping enzyme, N-terminal', 'Scavenger_mRNA_decap_enz_N', 5, NULL),
(9173, NULL, 'IPR009453', NULL, 'IMP-specific 5-nucleotidase', 'ISN1', 4, NULL),
(9174, NULL, 'IPR013447', NULL, 'Rhamnulose-1-phosphate aldolase', 'Rhamnulose-1-P_Aldolase', 4, NULL),
(9175, NULL, 'IPR015848', NULL, 'Polyribonucleotide nucleotidyltransferase, RNA-binding domain', 'PNPase_PH_RNA-bd_bac/org-type', 3, NULL),
(9176, NULL, 'IPR012555', NULL, 'Major transforming E5', 'EPV_E5', 4, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(9177, NULL, 'IPR015987', NULL, 'Uncharacterised conserved protein UCP022704', 'UCP022704', 4, NULL),
(9178, NULL, 'IPR010646', NULL, 'Uncharacterised protein family UPF0257', 'UPF0257', 4, NULL),
(9179, NULL, 'IPR012600', NULL, 'Gingipain propeptide', 'Propeptide_C25', 3, NULL),
(9180, NULL, 'IPR010627', NULL, 'Peptidase A24A, N-terminal', 'Pept_A24A_N', 3, NULL),
(9181, NULL, 'IPR013434', NULL, 'Conserved hypothetical protein CHP02611', 'CHP02611', 4, NULL),
(9182, NULL, 'IPR013445', NULL, 'CDP-glucose 4,6-dehydratase', 'CDP_4_6_deHydtase', 4, NULL),
(9183, NULL, 'IPR013433', NULL, 'Putative polyhydroxyalkanoic acid system protein', 'PHA_gran_rgn', 4, NULL),
(9184, NULL, 'IPR014210', NULL, 'Cytochrome o ubiquinol oxidase subunit IV', 'Cyt_o_ubiqinol_oxidase_su4', 4, NULL),
(9185, NULL, 'IPR014032', NULL, 'Peptidase A24A, prepilin type IV, bacterial', 'Peptidase_A24A_bac', 4, NULL),
(9186, NULL, 'IPR010373', NULL, 'Protein of unknown function DUF968', 'DUF968', 4, NULL),
(9187, NULL, 'IPR014017', NULL, 'UvrD-like DNA helicase, C-terminal', 'DNA_helicase_UvrD-like_C', 3, NULL),
(9188, NULL, 'IPR010380', NULL, 'Protein of unknown function DUF975', 'DUF975', 4, NULL),
(9189, NULL, 'IPR008977', NULL, 'PHM/PNGase F domain superfamily', 'PHM/PNGase_F_dom_sf', 5, NULL),
(9190, NULL, 'IPR009464', NULL, 'PCAF, N-terminal', 'PCAF_N', 3, NULL),
(9191, NULL, 'IPR009471', NULL, 'Teneurin intracellular, N-terminal', 'Ten_N', 3, NULL),
(9192, NULL, 'IPR009477', NULL, 'Baculovirus Ac102', 'Baculo_Ac102', 4, NULL),
(9193, NULL, 'IPR011030', NULL, 'Lipovitellin-phosvitin complex, superhelical domain', 'Lipovitellin_superhlx_dom', 5, NULL),
(9194, NULL, 'IPR012598', NULL, 'Plasmodium-MYXSPDY', 'Plasmod_MYXSPDY', 7, NULL),
(9195, NULL, 'IPR010643', NULL, 'Helical and beta-bridge domain', 'HBB', 3, NULL),
(9196, NULL, 'IPR013408', NULL, 'CRISPR system single-strand-specific deoxyribonuclease Cas10/Csm1', 'Cas10/Csm1', 4, NULL),
(9197, NULL, 'IPR016143', NULL, 'Citrate synthase-like, small alpha subdomain', 'Citrate_synth-like_sm_a-sub', 5, NULL),
(9198, NULL, 'IPR013410', NULL, 'CRISPR-associated RAMP Cmr4', 'CRISPR-assoc_RAMP_Cmr4', 4, NULL),
(9199, NULL, 'IPR010423', NULL, 'Ookinete surface antigen, EGF domain', 'Pvs25/Psv28_EGF', 3, NULL),
(9200, NULL, 'IPR015973', NULL, 'Ribosomal protein L19e, domain 2', 'Ribosomal_L19e_dom2', 5, NULL),
(9201, NULL, 'IPR015938', NULL, 'Glycine N-acyltransferase, N-terminal', 'Glycine_N-acyltransferase_N', 3, NULL),
(9202, NULL, 'IPR015984', NULL, 'Cytochrome c prime, subgroup', 'Cyt_c_prime_subgr', 4, NULL),
(9203, NULL, 'IPR012567', NULL, 'IlvGEDA operon leader peptide', 'IlvGEDA_leader', 4, NULL),
(9204, NULL, 'IPR009480', NULL, 'Equine infectious anaemia virus S2', 'Equine_IAV_S2', 4, NULL),
(9205, NULL, 'IPR011033', NULL, 'PRC-barrel-like superfamily', 'PRC_barrel-like_sf', 5, NULL),
(9206, NULL, 'IPR010406', NULL, 'Protein of unknown function DUF1003', 'DUF1003', 4, NULL),
(9207, NULL, 'IPR009495', NULL, 'Anti-sigma-F factor NrsF', 'NrsF', 4, NULL),
(9208, NULL, 'IPR010656', NULL, 'TRAP C4-dicarboxylate transport system permease DctM subunit', 'DctM', 3, NULL),
(9209, NULL, 'IPR015969', NULL, 'P40 nucleoprotein, subdomain 1, Borna disease virus', 'P40_nucleoprot_sub1_BD-vir', 5, NULL),
(9210, NULL, 'IPR018499', NULL, 'Tetraspanin/Peripherin', 'Tetraspanin/Peripherin', 4, NULL),
(9211, NULL, 'IPR010408', NULL, 'Haemagglutinin-esterase glycoprotein, infectious salmon anaemia virus-type', 'Hemagglutn-estrase_ISAV-type', 4, NULL),
(9212, NULL, 'IPR010622', NULL, 'FAST kinase leucine-rich', 'FAST_Leu-rich', 3, NULL),
(9213, NULL, 'IPR015991', NULL, 'Uncharacterised hydrolase TatD-type', 'Hydrolase_TatD-type', 4, NULL),
(9214, NULL, 'IPR011016', NULL, 'Zinc finger, RING-CH-type', 'Znf_RING-CH', 3, NULL),
(9215, NULL, 'IPR011057', NULL, 'Mss4-like superfamily', 'Mss4-like_sf', 5, NULL),
(9216, NULL, 'IPR035090', NULL, 'Phosphorylase pyridoxal-phosphate attachment site', 'Pyridoxal_P_attach_site', 2, NULL),
(9217, NULL, 'IPR010375', NULL, 'Cyclic-di-AMP receptor', 'CdAMP_rec', 4, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(9218, NULL, 'IPR009511', NULL, 'Mad1/Cdc20-bound-Mad2 binding protein', 'MAD1/Cdc20-bound-Mad2-bd', 4, NULL),
(9219, NULL, 'IPR010640', NULL, 'Low temperature requirement A', 'Low_temperature_requirement_A', 4, NULL),
(9220, NULL, 'IPR010419', NULL, 'Carbon monoxide dehydrogenase subunit G', 'CO_DH_gsu', 4, NULL),
(9221, NULL, 'IPR012585', NULL, 'Anticodon nuclease activator  Stp', 'Stp', 4, NULL),
(9222, NULL, 'IPR015482', NULL, 'Syntrophin', 'Syntrophin', 4, NULL),
(9223, NULL, 'IPR034556', NULL, 'S-adenosyl-L-methionine-dependent tRNA 4-demethylwyosine synthase', 'tRNA_wybutosine-synthase', 4, NULL),
(9224, NULL, 'IPR016031', NULL, 'Tryptophan RNA-binding attenuator protein-like domain superfamily', 'Trp_RNA-bd_attenuator-like_dom', 5, NULL),
(9225, NULL, 'IPR013980', NULL, 'MANSC domain', 'MANSC_dom', 3, NULL),
(9226, NULL, 'IPR009463', NULL, 'Domain of unknown function DUF1087', 'DUF1087', 3, NULL),
(9227, NULL, 'IPR014203', NULL, 'Sporulation stage V, protein AC', 'Spore_V_AC', 4, NULL),
(9228, NULL, 'IPR012587', NULL, 'RNA helicase p68 repeat', 'P68_rpt', 7, NULL),
(9229, NULL, 'IPR010421', NULL, 'Transcriptional cell cycle regulator TrcR', 'TrcR', 4, NULL),
(9230, NULL, 'IPR013406', NULL, 'Conserved hypothetical protein CHP02574, addiction module', 'CHP02574_addiction_mod', 4, NULL),
(9231, NULL, 'IPR013458', NULL, 'Aldose 1-epimerase, bacterial', 'Ald_epimerase_bac', 4, NULL),
(9232, NULL, 'IPR010377', NULL, 'Initiation control protein YabA', 'YabA', 4, NULL),
(9233, NULL, 'IPR009456', NULL, 'Moricin family', 'Moricin_fam', 4, NULL),
(9234, NULL, 'IPR012584', NULL, 'NUC205 domain', 'NUC205', 3, NULL),
(9235, NULL, 'IPR010438', NULL, 'Bor', 'Lambda_Bor', 4, NULL),
(9236, NULL, 'IPR018456', NULL, 'PTR2 family proton/oligopeptide symporter, conserved site', 'PTR2_symporter_CS', 2, NULL),
(9237, NULL, 'IPR010629', NULL, 'Insect allergen-related', 'Ins_allergen', 4, NULL),
(9238, NULL, 'IPR012589', NULL, 'Plasma membrane ATPase proteolipid', 'Pmp1/Pmp2', 4, NULL),
(9239, NULL, 'IPR010412', NULL, 'Protein of unknown function DUF1007', 'DUF1007', 4, NULL),
(9240, NULL, 'IPR010626', NULL, 'Protein of unknown function DUF1217', 'DUF1217', 4, NULL),
(9241, NULL, 'IPR016005', NULL, 'Phosphomevalonate kinase Erg8', 'Erg8', 4, NULL),
(9242, NULL, 'IPR012577', NULL, 'NIPSNAP', 'NIPSNAP', 3, NULL),
(9243, NULL, 'IPR009462', NULL, 'CHD subfamily II, SANT-like domain', 'CHD_II_SANT-like', 3, NULL),
(9244, NULL, 'IPR012559', NULL, 'Erythromycin resistance leader peptide-2', 'Emycin-R_leader_pep2', 4, NULL),
(9245, NULL, 'IPR013416', NULL, 'Conserved hypothetical protein CHP02587, putative integral membrane', 'CHP02587_IM', 4, NULL),
(9246, NULL, 'IPR012582', NULL, 'DNA-dependent protein kinase catalytic subunit, CC3', 'DNAPKcs_CC3', 3, NULL),
(9247, NULL, 'IPR013413', NULL, 'CRISPR-associated protein, NE0113', 'CRISPR-assoc_prot_NE0113', 4, NULL),
(9248, NULL, 'IPR013446', NULL, 'Glucose-1-phosphate cytidylyltransferase', 'G1P_cyt_trans', 4, NULL),
(9249, NULL, 'IPR010385', NULL, 'Protein of unknown function DUF982', 'DUF982', 4, NULL),
(9250, NULL, 'IPR010416', NULL, 'Protein of unknown function DUF1010', 'DUF1010', 4, NULL),
(9251, NULL, 'IPR010637', NULL, 'Sif', 'Sif', 4, NULL),
(9252, NULL, 'IPR010654', NULL, 'Bacteriophage lambda tail assembly I', 'Phage_lambda_tail_I', 4, NULL),
(9253, NULL, 'IPR010645', NULL, 'Uncharacterised MFS-type transporter YbfB', 'MFS_4', 3, NULL),
(9254, NULL, 'IPR024049', NULL, 'eRF1, domain 1', 'eRF1_1_sf', 5, NULL),
(9255, NULL, 'IPR009449', NULL, 'GDP/GTP exchange factor Sec2, N-terminal', 'Sec2_N', 3, NULL),
(9256, NULL, 'IPR010672', NULL, 'IMP biosynthesis enzyme PurP, N-terminal', 'IMP_biosynth_PurP_N', 3, NULL),
(9257, NULL, 'IPR018939', NULL, 'Autophagy-related protein 27', 'Autophagy-rel_prot_27', 4, NULL),
(9258, NULL, 'IPR008971', NULL, 'HSP40/DnaJ peptide-binding', 'HSP40/DnaJ_pept-bd', 5, NULL),
(9259, NULL, 'IPR009499', NULL, 'Protein of unknown function DUF1116', 'DUF1116', 4, NULL),
(9260, NULL, 'IPR011051', NULL, 'RmlC-like cupin domain superfamily', 'RmlC_Cupin_sf', 5, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(9261, NULL, 'IPR010684', NULL, 'RNA polymerase II transcription factor SIII, subunit A', 'RNA_pol_II_trans_fac_SIII_A', 4, NULL),
(9262, NULL, 'IPR010660', NULL, 'Notch, NOD domain', 'Notch_NOD_dom', 3, NULL),
(9263, NULL, 'IPR011041', NULL, 'Soluble quinoprotein glucose/sorbosone dehydrogenase', 'Quinoprot_gluc/sorb_DH', 5, NULL),
(9264, NULL, 'IPR010386', NULL, 'tRNA-hydroxylase MiaE', 'tRNA-Hydrxlase_MiaE', 4, NULL),
(9265, NULL, 'IPR009474', NULL, 'Bacilliredoxins BrxB/BrxA', 'BrxB/BrxA', 4, NULL),
(9266, NULL, 'IPR010394', NULL, '5-nucleotidase', '5-nucleotidase', 4, NULL),
(9267, NULL, 'IPR010644', NULL, 'Heme-dependent peroxidase ChdC/CLD', 'ChdC/CLD', 4, NULL),
(9268, NULL, 'IPR010648', NULL, 'Uncharacterised protein family UPF0270', 'UPF0270', 4, NULL),
(9269, NULL, 'IPR009514', NULL, 'Nucleoid disruption protein', 'Phage_Ndd', 4, NULL),
(9270, NULL, 'IPR011058', NULL, 'Cyanovirin-N', 'Cyanovirin-N', 3, NULL),
(9271, NULL, 'IPR010651', NULL, 'Sugar transport protein', 'Sugar_transport', 4, NULL),
(9272, NULL, 'IPR011050', NULL, 'Pectin lyase fold/virulence factor', 'Pectin_lyase_fold/virulence', 5, NULL),
(9273, NULL, 'IPR010691', NULL, 'Probable ECA polymerase WzyE', 'WzyE', 4, NULL),
(9274, NULL, 'IPR018464', NULL, 'Centromere protein O', 'CENP-O', 4, NULL),
(9275, NULL, 'IPR016033', NULL, 'DNA polymerase II large subunit DP2, N-terminal', 'PolC_DP2_N', 3, NULL),
(9276, NULL, 'IPR034880', NULL, 'La-related protein 6, RNA recognition motif', 'LARP6_RRM', 3, NULL),
(9277, NULL, 'IPR010649', NULL, 'Nitrate/trimethylamine N-oxide reductase NapE/TorE', 'NapE_TorE', 4, NULL),
(9278, NULL, 'IPR009498', NULL, 'Bacteriophage 4268, Orf1, C-terminal', 'Phage_4268_Orf1_C', 3, NULL),
(9279, NULL, 'IPR013412', NULL, 'CRISPR-associated RAMP Csm3', 'CRISPR-assoc_RAMP_Csm3', 4, NULL),
(9280, NULL, 'IPR015982', NULL, 'Baseplate structural protein Gp11, N-terminal domain superfamily', 'Baseplate_struct_Gp11_N_sf', 5, NULL),
(9281, NULL, 'IPR011037', NULL, 'Pyruvate kinase-like, insert domain superfamily', 'Pyrv_Knase-like_insert_dom_sf', 5, NULL),
(9282, NULL, 'IPR012595', NULL, 'PetM of cytochrome b6/f complex subunit 7', 'PetM_cyt_b6/f_cplx_su7', 4, NULL),
(9283, NULL, 'IPR012575', NULL, 'NADH dehydrogenase [ubiquinone] 1 beta subcomplex subunit 1, NDUB1', 'NDUB1', 4, NULL),
(9284, NULL, 'IPR009490', NULL, 'Protein of unknown function DUF1106', 'DUF1106', 4, NULL),
(9285, NULL, 'IPR034547', NULL, 'Tte1186a maturase', 'Tte1186a_maturase', 4, NULL),
(9286, NULL, 'IPR010397', NULL, 'Protein of unknown function DUF996', 'DUF996', 4, NULL),
(9287, NULL, 'IPR010417', NULL, 'Embryo-specific ATS3', 'Embryo-specific_ATS3', 4, NULL),
(9288, NULL, 'IPR013440', NULL, 'Tryptophanase', 'TNase', 4, NULL),
(9289, NULL, 'IPR012576', NULL, 'NADH dehydrogenase [ubiquinone] 1 beta subcomplex subunit 3', 'NDUFB3', 4, NULL),
(9290, NULL, 'IPR018450', NULL, 'Romo1/Mgr2', 'Romo1/Mgr2', 4, NULL),
(9291, NULL, 'IPR013426', NULL, 'Exosortase, EpsH-like', 'EpsH-like', 4, NULL),
(9292, NULL, 'IPR011012', NULL, 'Longin-like domain superfamily', 'Longin-like_dom_sf', 5, NULL),
(9293, NULL, 'IPR015986', NULL, 'Sortase B, Firmicutes', 'SrtB_Firmicute', 4, NULL),
(9294, NULL, 'IPR010661', NULL, 'Reverse transcriptase thumb', 'RVT_thumb', 3, NULL),
(9295, NULL, 'IPR012579', NULL, 'Nucleolar protein 7, C-terminal', 'NOL7_C', 3, NULL),
(9296, NULL, 'IPR010632', NULL, 'Domain of unknown function DUF1221', 'DUF1221', 3, NULL),
(9297, NULL, 'IPR012568', NULL, 'KI67R', 'KI67R', 7, NULL),
(9298, NULL, 'IPR013437', NULL, 'Probable peptidoglycan glycosyltransferase FtsW', 'FtsW', 4, NULL),
(9299, NULL, 'IPR012574', NULL, 'ATP synthase subunit ATP5MJ, mitochondrial', 'ATP5MJ', 4, NULL),
(9300, NULL, 'IPR013438', NULL, 'Sporulation stage V, protein E', 'SpoVE', 4, NULL),
(9301, NULL, 'IPR012560', NULL, 'Ferlin A-domain', 'Ferlin_A-domain', 3, NULL),
(9302, NULL, 'IPR009513', NULL, 'PerB', 'PerB', 4, NULL),
(9303, NULL, 'IPR010431', NULL, 'Fascin', 'Fascin', 4, NULL),
(9304, NULL, 'IPR015496', NULL, 'Ubiquilin', 'Ubiquilin', 4, NULL),
(9305, NULL, 'IPR016053', NULL, 'Haem oxygenase-like', 'Haem_Oase-like', 4, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(9306, NULL, 'IPR014013', NULL, 'Helicase superfamily 1/2, ATP-binding domain, DinG/Rad3-type', 'Helic_SF1/SF2_ATP-bd_DinG/Rad3', 3, NULL),
(9307, NULL, 'IPR010405', NULL, 'Cofactor of BRCA1', 'COBRA1', 4, NULL),
(9308, NULL, 'IPR009466', NULL, 'Non-structural protein 14, coronavirus', 'NSP14_CoV', 3, NULL),
(9309, NULL, 'IPR013404', NULL, 'Competence operon E, ComEB', 'Competence_ComEB', 4, NULL),
(9310, NULL, 'IPR018496', NULL, 'Pseudouridine synthase, RsuA/RluB/E/F, conserved site', 'PsdUridine_synth_RsuA/RluB_CS', 2, NULL),
(9311, NULL, 'IPR015486', NULL, 'Interleukin-2 receptor alpha', 'IL-2_rcpt_alpha', 4, NULL),
(9312, NULL, 'IPR013519', NULL, 'Integrin alpha beta-propellor', 'Int_alpha_beta-p', 7, NULL),
(9313, NULL, 'IPR013452', NULL, 'Xylose isomerase, bacterial-type', 'Xylose_isom_bac', 4, NULL),
(9314, NULL, 'IPR011043', NULL, 'Galactose oxidase/kelch, beta-propeller', 'Gal_Oxase/kelch_b-propeller', 5, NULL),
(9315, NULL, 'IPR011060', NULL, 'Ribulose-phosphate binding barrel', 'RibuloseP-bd_barrel', 5, NULL),
(9316, NULL, 'IPR012569', NULL, 'Leucine-rich repeat-containing adjacent domain', 'LRR-contain_adjacent_dom', 3, NULL),
(9317, NULL, 'IPR010387', NULL, 'Queuosine precursor transporter QueT', 'QueT', 4, NULL),
(9318, NULL, 'IPR012566', NULL, 'IlvB leader peptide', 'IlvB_leader', 4, NULL),
(9319, NULL, 'IPR024296', NULL, 'Protein of unknown function DUF2710', 'DUF2710', 4, NULL),
(9320, NULL, 'IPR034557', NULL, 'Threonylcarbamoyladenosine tRNA methylthiotransferase', 'ThrcA_tRNA_MEthiotransferase', 4, NULL),
(9321, NULL, 'IPR013144', NULL, 'CRA domain', 'CRA_dom', 3, NULL),
(9322, NULL, 'IPR009451', NULL, 'Amine dehydrogenase heavy chain', 'Metamine_DH_Hvc', 4, NULL),
(9323, NULL, 'IPR010667', NULL, 'Bacteriophage T4, Gp19, tail tube', 'Phage_T4_Gp19', 4, NULL),
(9324, NULL, 'IPR024295', NULL, 'Protein of unknown function DUF2705', 'DUF2705', 4, NULL),
(9325, NULL, 'IPR010396', NULL, 'Orthopoxvirus A5', 'Orthopox_A5', 4, NULL),
(9326, NULL, 'IPR010658', NULL, 'Nodulin-like', 'Nodulin-like', 3, NULL),
(9327, NULL, 'IPR009470', NULL, 'Chitinase, C-terminal', 'Chi_C', 3, NULL),
(9328, NULL, 'IPR009510', NULL, 'Type III secretion system, secretion protein  K', 'T3SS_K', 4, NULL),
(9329, NULL, 'IPR010642', NULL, 'Invasion protein B', 'Invasion_prot_B', 4, NULL),
(9330, NULL, 'IPR010374', NULL, 'Protein of unknown function DUF969', 'DUF969', 4, NULL),
(9331, NULL, 'IPR013455', NULL, 'ABC transporter, D-xylose, ATP-binding protein', 'ABC_transptr_xylose_ATP-bd', 4, NULL),
(9332, NULL, 'IPR013407', NULL, 'CRISPR-associated protein Cmr2', 'CRISPR-assoc_prot_Cmr2', 4, NULL),
(9333, NULL, 'IPR015985', NULL, 'Tellurite resistance methyltransferase TehB-like domain', 'TehB-like_dom', 3, NULL),
(9334, NULL, 'IPR011013', NULL, 'Galactose mutarotase-like domain superfamily', 'Gal_mutarotase_sf_dom', 5, NULL),
(9335, NULL, 'IPR014213', NULL, 'Sporulation stage V, protein T', 'SpoVT', 4, NULL),
(9336, NULL, 'IPR011026', NULL, 'Actin nucleation-promoting factor WAS, C-terminal', 'WAS_C', 5, NULL),
(9337, NULL, 'IPR009491', NULL, 'Protein of unknown function DUF1107', 'DUF1107', 4, NULL),
(9338, NULL, 'IPR012745', NULL, 'Pseudoazurin', 'Pseudoazurin', 4, NULL),
(9339, NULL, 'IPR012590', NULL, 'POPLD domain', 'POPLD_dom', 3, NULL),
(9340, NULL, 'IPR010675', NULL, 'RNA methyltransferase bin3, C-terminal', 'Bin3_C', 3, NULL),
(9341, NULL, 'IPR013454', NULL, 'Bifunctional rhamnulose-1-phosphate aldolase/alcohol dehydrogenase', 'Bifunc_RhaD/ADH', 4, NULL),
(9342, NULL, 'IPR013457', NULL, 'Rhamnose isomerase-related', 'Rhamnose_iso-rel', 4, NULL),
(9343, NULL, 'IPR010662', NULL, 'Putative hydrolase RBBP9/YdeN', 'Hydrolase_RBBP9/YdeN', 4, NULL),
(9344, NULL, 'IPR013409', NULL, 'CRISPR-associated protein Csx3', 'CRISPR-assoc_prot_Csx3', 4, NULL),
(9345, NULL, 'IPR013419', NULL, 'CRISPR-associated protein Csh2', 'CRISPR-assoc_prot_Csh2', 4, NULL),
(9346, NULL, 'IPR014211', NULL, 'Stage III sporulation protein AD', 'Spore_III_AD', 4, NULL),
(9347, NULL, 'IPR013512', NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase, N-terminal', 'DXP_reductoisomerase_N', 3, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(9348, NULL, 'IPR014724', NULL, 'RNA polymerase Rpb2, OB-fold', 'RNA_pol_RPB2_OB-fold', 5, NULL),
(9349, NULL, 'IPR013425', NULL, 'Autotransporter-associated beta strand repeat', 'Autotrns_rpt', 7, NULL),
(9350, NULL, 'IPR010382', NULL, 'Protein of unknown function DUF977', 'DUF977', 4, NULL),
(9351, NULL, 'IPR034048', NULL, 'Tumor necrosis factor receptor 19-like, N-terminal', 'TNFRSF19L_N', 3, NULL),
(9352, NULL, 'IPR018935', NULL, 'RIO kinase, conserved site', 'RIO_kinase_CS', 2, NULL),
(9353, NULL, 'IPR010409', NULL, 'GAGA-binding transcriptional activator', 'GAGA-bd_tscrpt_act', 4, NULL),
(9354, NULL, 'IPR015976', NULL, 'Bacteriophage T4, Gp11, C-terminal finger domain', 'Phage_T4_Gp11_C', 5, NULL),
(9355, NULL, 'IPR013460', NULL, 'Lactaldehyde reductase', 'Lactal_redase', 4, NULL),
(9356, NULL, 'IPR008978', NULL, 'HSP20-like chaperone', 'HSP20-like_chaperone', 5, NULL),
(9357, NULL, 'IPR012557', NULL, 'Heat stable enterotoxin, EAST1', 'Heat-stable_enterotox_EAST1', 4, NULL),
(9358, NULL, 'IPR009454', NULL, 'Lipid transport, open beta-sheet', 'Lipid_transpt_open_b-sht', 3, NULL),
(9359, NULL, 'IPR021123', NULL, 'Type III secretion, needle-protein-like', 'T3SS_needle-like', 4, NULL),
(9360, NULL, 'IPR010422', NULL, 'Coiled-coil domain-containing protein 124/Oxs1', 'Ccdc124/Oxs1', 4, NULL),
(9361, NULL, 'IPR012580', NULL, 'NUC153', 'NUC153', 3, NULL),
(9362, NULL, 'IPR014043', NULL, 'Acyl transferase', 'Acyl_transferase', 3, NULL),
(9363, NULL, 'IPR010411', NULL, 'Phage tail assembly chaperone Gp13-like', 'TAC_Gp13-like', 4, NULL),
(9364, NULL, 'IPR014199', NULL, 'Sporulation protein YtxC', 'Spore_YtxC', 4, NULL),
(9365, NULL, 'IPR034859', NULL, 'RBM26, RNA recognition motif 1', 'RBM26_RRM1', 3, NULL),
(9366, NULL, 'IPR012747', NULL, 'MocE Rieske [2Fe-2S]', 'MocE_2FeS', 4, NULL),
(9367, NULL, 'IPR013423', NULL, 'Conserved hypothetical protein CHP02594', 'CHP02594', 4, NULL),
(9368, NULL, 'IPR013449', NULL, 'Rhamnulokinase', 'Rhamnulokinase', 4, NULL),
(9369, NULL, 'IPR008980', NULL, 'Viral capsid/haemagglutinin protein', 'Capsid_hemagglutn', 5, NULL),
(9370, NULL, 'IPR009493', NULL, 'Escherichia phage P2, Tail assembly protein E''', 'P2_GpE''', 4, NULL),
(9371, NULL, 'IPR014201', NULL, 'Sporulation stage IV, protein A', 'Spore_IV_A', 4, NULL),
(9372, NULL, 'IPR018941', NULL, 'Tyrosine-protein kinase, receptor Tie-2, Ig-like domain 1, N-terminal', 'Tyr_kin_Tie2_Ig-like_dom-1_N', 3, NULL),
(9373, NULL, 'IPR010664', NULL, 'Lipopolysaccharide assembly, LptC-related', 'LipoPS_assembly_LptC-rel', 4, NULL),
(9374, NULL, 'IPR016047', NULL, 'Peptidase M23', 'Peptidase_M23', 3, NULL),
(9375, NULL, 'IPR010398', NULL, 'Protein of unknown function DUF997', 'DUF997', 4, NULL),
(9376, NULL, 'IPR009455', NULL, 'ATP synthase YMF19, uncharacterised, C-terminal', 'YMF19', 3, NULL),
(9377, NULL, 'IPR024650', NULL, 'Peptidase A2B, Ty3 transposon peptidase', 'Peptidase_A2B', 4, NULL),
(9378, NULL, 'IPR010376', NULL, 'Gamma-butyrobetaine hydroxylase-like, N-terminal', 'GBBH-like_N', 3, NULL),
(9379, NULL, 'IPR013453', NULL, 'Xylose isomerase, actinobacteria', 'XylA_actinobac', 4, NULL),
(9380, NULL, 'IPR013822', NULL, 'Signal recognition particle SRP54, helical bundle', 'Signal_recog_particl_SRP54_hlx', 3, NULL),
(9381, NULL, 'IPR035046', NULL, 'SHD, SH2 domain', 'SHD_SH2', 3, NULL),
(9382, NULL, 'IPR012592', NULL, 'PROCN domain', 'PROCN', 3, NULL),
(9383, NULL, 'IPR014209', NULL, 'RNA polymerase sigma-K type', 'RNA_pol_sigma-K', 4, NULL),
(9384, NULL, 'IPR018947', NULL, 'Neuromodulin gap junction N-terminal', 'Neuromodulin_gap-junction_N', 3, NULL),
(9385, NULL, 'IPR010663', NULL, 'Zinc finger, FPG/IleRS-type', 'Znf_FPG/IleRS', 3, NULL),
(9386, NULL, 'IPR013429', NULL, 'Putative regulatory protein, FmdB, Zinc ribbon domain', 'Regulatory_FmdB_Zinc_ribbon', 3, NULL),
(9387, NULL, 'IPR012602', NULL, 'PyrBI operon leader peptide', 'PyrBI_leader', 4, NULL),
(9388, NULL, 'IPR018463', NULL, 'Centromere protein Cenp-F, N-terminal', 'Centromere_CenpF_N', 3, NULL),
(9389, NULL, 'IPR010379', NULL, 'Septation ring formation regulator EzrA', 'EzrA', 4, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(9390, NULL, 'IPR014033', NULL, 'Arginase', 'Arginase', 4, NULL),
(9391, NULL, 'IPR008981', NULL, 'F-MuLV receptor-binding', 'FMuLV_rcpt-bd', 5, NULL),
(9392, NULL, 'IPR008972', NULL, 'Cupredoxin', 'Cupredoxin', 5, NULL),
(9393, NULL, 'IPR010671', NULL, 'Disaggregatase-related repeat', 'Disaggr-rel_rpt', 7, NULL),
(9394, NULL, 'IPR015974', NULL, 'Ribosomal protein L19e, domain 3', 'Ribosomal_L19e_dom3', 5, NULL),
(9395, NULL, 'IPR018461', NULL, 'Na+/H+ antiporter, NhaC-like, C-terminal', 'Na/H_Antiport_NhaC-like_C', 3, NULL),
(9396, NULL, 'IPR010430', NULL, 'Protein of unknown function DUF1028', 'DUF1028', 4, NULL),
(9397, NULL, 'IPR013443', NULL, 'Putative CRISPR-associated protein, VVA1548 family', 'CRISPR-assoc_prot_put_VVA1548', 4, NULL),
(9398, NULL, 'IPR010686', NULL, 'Oil body-associated protein-like', 'OBAP-like', 4, NULL),
(9399, NULL, 'IPR012564', NULL, 'Herpesvirus UL74, glycoprotein', 'Herpes_UL74', 4, NULL),
(9400, NULL, 'IPR018936', NULL, 'Phosphatidylinositol 3/4-kinase, conserved site', 'PI3/4_kinase_CS', 2, NULL),
(9401, NULL, 'IPR015847', NULL, 'Exoribonuclease, phosphorolytic domain 2', 'ExoRNase_PH_dom2', 3, NULL),
(9402, NULL, 'IPR009452', NULL, 'Pneumovirus matrix 2-1', 'Pneumovirus_M2-1', 4, NULL),
(9403, NULL, 'IPR008967', NULL, 'p53-like transcription factor, DNA-binding domain superfamily', 'p53-like_TF_DNA-bd_sf', 5, NULL),
(9404, NULL, 'IPR012571', NULL, 'Mitochondrial distribution and morphology protein family 31/32, fungi', 'Mdm31/Mdm32', 4, NULL),
(9405, NULL, 'IPR012572', NULL, 'Mad3/Bub1 homology region 2', 'Mad3/Bub1_II', 3, NULL),
(9406, NULL, 'IPR013414', NULL, 'CRISPR-associated protein Cas7,  subtype I-B/Tneap', 'Cas7/Cst2/DevR_sub_I-B/Tneap', 4, NULL),
(9407, NULL, 'IPR013428', NULL, 'Putative membrane-bound dehydrogenase', 'Membrane-bound_put_N', 3, NULL),
(9408, NULL, 'IPR010624', NULL, 'KaiC domain', 'KaiC_dom', 3, NULL),
(9409, NULL, 'IPR009473', NULL, 'Orthopoxvirus A49', 'Orthopox_A49', 4, NULL),
(9410, NULL, 'IPR013461', NULL, 'ATP-dependent Clp protease ATP-binding subunit ClpA', 'ClpA', 4, NULL),
(9411, NULL, 'IPR016041', NULL, 'CO dehydrogenase/acetyl-CoA synthase delta subunit, TIM barrel', 'Ac-CoA_synth_d_su_TIM-brl', 3, NULL),
(9412, NULL, 'IPR010384', NULL, 'MtfA family', 'MtfA_fam', 4, NULL),
(9413, NULL, 'IPR009503', NULL, 'Protein of unknown function DUF1125', 'DUF1125', 4, NULL),
(9414, NULL, 'IPR013462', NULL, 'Gas vesicle protein GvpN', 'Gas-vesicle_GvpN', 4, NULL),
(9415, NULL, 'IPR009507', NULL, 'Protein of unknown function UPF0435', 'UPF0435', 4, NULL),
(9416, NULL, 'IPR010685', NULL, 'Domain of unknown function DUF1263', 'DUF1263', 3, NULL),
(9417, NULL, 'IPR012593', NULL, 'Pea-VEAacid', 'Pea-VEAacid', 4, NULL),
(9418, NULL, 'IPR009487', NULL, 'Orthopoxvirus A43R', 'Orthopox_A43R', 4, NULL),
(9419, NULL, 'IPR011052', NULL, 'Proteinase/amylase inhibitor domain superfamily', 'Proteinase_amylase_inhib_sf', 5, NULL),
(9420, NULL, 'IPR015499', NULL, 'Cholecystokinin-like', 'CCK-like', 4, NULL),
(9421, NULL, 'IPR012588', NULL, 'Exosome-associated factor Rrp6, N-terminal', 'Exosome-assoc_fac_Rrp6_N', 3, NULL),
(9422, NULL, 'IPR018482', NULL, 'Zinc finger C4H2 domain-containing protein', 'Znf-C4H2', 4, NULL),
(9423, NULL, 'IPR011049', NULL, 'Serralysin-like metalloprotease, C-terminal', 'Serralysin-like_metalloprot_C', 5, NULL),
(9424, NULL, 'IPR015996', NULL, 'Uncharacterised conserved protein UCP028451', 'UCP028451', 4, NULL),
(9425, NULL, 'IPR014206', NULL, 'Cytochrome o ubiquinol oxidase, subunit III', 'Cyt_c_ubiqinol_oxidase_su3', 4, NULL),
(9426, NULL, 'IPR010415', NULL, 'LpxI, C-terminal', 'LpxI_C', 3, NULL),
(9427, NULL, 'IPR015988', NULL, 'STAT transcription factor, coiled coil', 'STAT_TF_coiled-coil', 5, NULL),
(9428, NULL, 'IPR009515', NULL, 'Protein of unknown function DUF1138', 'DUF1138', 4, NULL),
(9429, NULL, 'IPR013442', NULL, 'CRISPR system ring nuclease SSO1393-like', 'SSO1393-like', 3, NULL),
(9430, NULL, 'IPR018946', NULL, 'PhoD-like phosphatase,  metallophosphatase domain', 'PhoD-like_MPP', 3, NULL),
(9431, NULL, 'IPR034863', NULL, 'Fungal Mei2-like, RNA recognition motif 2', 'Fungal_Mei2-like_RRM2', 3, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(9432, NULL, 'IPR010414', NULL, 'Protein FRG1', 'FRG1', 4, NULL),
(9433, NULL, 'IPR014204', NULL, 'Sporulation stage V, protein AE', 'Spore_V_AE', 4, NULL),
(9434, NULL, 'IPR015995', NULL, 'Microcystin LR degradation protein MlrC, N-terminal', 'MlrC_N', 3, NULL),
(9435, NULL, 'IPR013444', NULL, 'Helicase Cas3, CRISPR-associated, Anaes-subtype', 'Helicase_Cas3_CRISPR-ass_Anaes', 4, NULL),
(9436, NULL, 'IPR023694', NULL, 'Agmatinase', 'Agmatinase', 4, NULL),
(9437, NULL, 'IPR018940', NULL, 'Elongation factor 1 beta central acidic region, eukaryote', 'EF-1_beta_acid_region_euk', 3, NULL),
(9438, NULL, 'IPR013148', NULL, 'Glycosyl hydrolase family 32, N-terminal', 'Glyco_hydro_32_N', 3, NULL),
(9439, NULL, 'IPR016052', NULL, 'YgiW/YdeI', 'YgiW/YdeI', 4, NULL),
(9440, NULL, 'IPR015966', NULL, 'tRNA ligase, kinase domain, fungi', 'tRNA_lig_kin_fungi', 3, NULL),
(9441, NULL, 'IPR018480', NULL, 'Phospho-N-acetylmuramoyl-pentapeptide transferase, conserved site', 'PNAcMuramoyl-5peptid_Trfase_CS', 2, NULL),
(9442, NULL, 'IPR014014', NULL, 'RNA helicase, DEAD-box type, Q motif', 'RNA_helicase_DEAD_Q_motif', 3, NULL),
(9443, NULL, 'IPR013846', NULL, 'mRNA capping enzyme, C-terminal', 'mRNA_cap_enzyme_C', 3, NULL),
(9444, NULL, 'IPR016030', NULL, 'Cobalamin adenosyltransferase-like', 'CblAdoTrfase-like', 3, NULL),
(9445, NULL, 'IPR009460', NULL, 'Ryanodine Receptor TM 4-6', 'Ryanrecept_TM4-6', 3, NULL),
(9446, NULL, 'IPR010690', NULL, 'Putative stage IV sporulation YqfD', 'YqfD', 4, NULL),
(9447, NULL, 'IPR014003', NULL, 'DM16 repeat', 'DM16_repeat', 7, NULL),
(9448, NULL, 'IPR009506', NULL, 'Protein of unknown function DUF1127', 'DUF1127', 4, NULL),
(9449, NULL, 'IPR009483', NULL, 'Type III secretion systems tip complex components', 'IpaD', 4, NULL),
(9450, NULL, 'IPR010437', NULL, 'Type III secretion system SsaH', 'T3SS_SsaH', 4, NULL),
(9451, NULL, 'IPR011044', NULL, 'Quinoprotein amine dehydrogenase, beta chain-like', 'Quino_amine_DH_bsu', 5, NULL),
(9452, NULL, 'IPR014016', NULL, 'UvrD-like helicase, ATP-binding domain', 'UvrD-like_ATP-bd', 3, NULL),
(9453, NULL, 'IPR014015', NULL, 'Helicase, superfamily 3, DNA virus', 'Helicase_SF3_DNA-vir', 3, NULL),
(9454, NULL, 'IPR013432', NULL, 'Putative addiction module antidote', 'Doc_partner', 4, NULL),
(9455, NULL, 'IPR012578', NULL, 'Nuclear pore complex component', 'Nucl_pore_cmplx', 4, NULL),
(9456, NULL, 'IPR010655', NULL, 'Pre-mRNA cleavage complex subunit Clp1, C-terminal', 'Clp1_C', 3, NULL),
(9457, NULL, 'IPR012583', NULL, 'Pre-rRNA-processing protein RIX1, N-terminal', 'RIX1_N', 3, NULL),
(9458, NULL, 'IPR009472', NULL, 'Tab2-like', 'Tab2-like', 4, NULL),
(9459, NULL, 'IPR009485', NULL, 'Borna disease virus P10', 'BDV_P10', 4, NULL),
(9460, NULL, 'IPR011022', NULL, 'Arrestin C-terminal-like domain', 'Arrestin_C-like', 3, NULL),
(9461, NULL, 'IPR009482', NULL, 'Protein of unknown function DUF1102', 'DUF1102', 4, NULL),
(9462, NULL, 'IPR011054', NULL, 'Rudiment single hybrid motif', 'Rudment_hybrid_motif', 5, NULL),
(9463, NULL, 'IPR010659', NULL, 'Reverse transcriptase connection', 'RVT_connect', 3, NULL),
(9464, NULL, 'IPR011040', NULL, 'Sialidase', 'Sialidase', 3, NULL),
(9465, NULL, 'IPR010404', NULL, 'Chromophore lyase CpcT/CpeT', 'CpcT/CpeT', 4, NULL),
(9466, NULL, 'IPR008974', NULL, 'TRAF-like', 'TRAF-like', 5, NULL),
(9467, NULL, 'IPR009457', NULL, 'THH1/TOM1/TOM3 domain', 'THH1/TOM1/TOM3_dom', 3, NULL),
(9468, NULL, 'IPR024185', NULL, '5-formyltetrahydrofolate cyclo-ligase-like domain superfamily', 'FTHF_cligase-like_sf', 5, NULL),
(9469, NULL, 'IPR010633', NULL, 'Bacteriophage lambda, GpZ, minor tail', 'Phage_lambda_GpZ', 4, NULL),
(9470, NULL, 'IPR018497', NULL, 'Peptidase M13, C-terminal domain', 'Peptidase_M13_C', 3, NULL),
(9471, NULL, 'IPR014208', NULL, 'Sporulation stage III, transcriptional regulator SpoIIID', 'Spore_III_D', 4, NULL),
(9472, NULL, 'IPR010436', NULL, 'Herpesvirus UL84', 'Herpes_UL84', 4, NULL),
(9473, NULL, 'IPR009496', NULL, 'Repulsive guidance molecule, C-terminal', 'RGM_C', 3, NULL),
(9474, NULL, 'IPR014714', NULL, 'Glutamate mutase E subunit, C-terminal domain superfamily', 'Glu_mut_E_C_dom_sf', 5, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(9475, NULL, 'IPR009484', NULL, 'Protein of unknown function DUF1103', 'DUF1103', 7, NULL),
(9476, NULL, 'IPR023160', NULL, 'Ribonuclease HII, helix-loop-helix cap domain superfamily', 'RNase_HII_hlx-loop-hlx_cap_dom', 5, NULL),
(9477, NULL, 'IPR018495', NULL, 'Succinate dehydrogenase, cytochrome b subunit, conserved site', 'Succ_DH_cyt_bsu_CS', 2, NULL),
(9478, NULL, 'IPR013451', NULL, 'L-rhamnose catabolism isomerase', 'L_rhamnose_iso', 4, NULL),
(9479, NULL, 'IPR013422', NULL, 'CRISPR-associated protein Cas5, N-terminal', 'CRISPR-assoc_prot_Cas5_N', 3, NULL),
(9480, NULL, 'IPR018493', NULL, 'Gas vesicle protein GvpA, conserved site', 'Gas-vesicle_GvpA_CS', 2, NULL),
(9481, NULL, 'IPR015971', NULL, 'Nucleocapsid, Phlebovirus', 'Nucleocapsid_Phlebovirus', 4, NULL),
(9482, NULL, 'IPR013405', NULL, 'Type III secretion system regulator, LcrR', 'T3SS_LcrR', 4, NULL),
(9483, NULL, 'IPR023251', NULL, 'Pre-mRNA-splicing factor Brr1', 'Brr1', 4, NULL),
(9484, NULL, 'IPR016003', NULL, 'Photosystem II cytochrome c-550 precursor', 'PSII_cyt_c550', 4, NULL),
(9485, NULL, 'IPR013411', NULL, 'CRISPR-associated RAMP TM1809', 'CRISPR-assoc_RAMP_TM1809', 4, NULL),
(9486, NULL, 'IPR010682', NULL, 'Plant self-incompatibility response', 'SCRL', 4, NULL),
(9487, NULL, 'IPR014712', NULL, 'ANTH domain superfamily', 'ANTH_dom_sf', 5, NULL),
(9488, NULL, 'IPR012599', NULL, 'Peptidase C1A, propeptide', 'Propeptide_C1A', 3, NULL),
(9489, NULL, 'IPR011039', NULL, 'Transcription Factor IIF, Rap30/Rap74, interaction', 'TFIIF_interaction', 5, NULL),
(9490, NULL, 'IPR013435', NULL, 'Mobile mystery protein A', 'Mobile_mystery_prot_A', 4, NULL),
(9491, NULL, 'IPR010425', NULL, 'Capsule biosynthesis GfcC-like, C-terminal', 'Caps_synth_GfcC-like_C', 3, NULL),
(9492, NULL, 'IPR009516', NULL, 'Raspberry bushy dwarf virus coat', 'RBDV_coat', 4, NULL),
(9493, NULL, 'IPR010681', NULL, 'Plethodontid receptivity factor PRF/cardiotrophin-like', 'PRF/CT', 4, NULL),
(9494, NULL, 'IPR015994', NULL, 'Phosphoenolpyruvate carboxykinase (ATP), conserved site', 'PEPCK_ATP_CS', 2, NULL),
(9495, NULL, 'IPR035044', NULL, 'SHF, SH2 domain', 'SHF_SH2', 3, NULL),
(9496, NULL, 'IPR010389', NULL, 'Urate oxidase N-terminal', 'Urate_ox_N', 3, NULL),
(9497, NULL, 'IPR010413', NULL, 'Intracellular heme transport protein HutX-like', 'HutX-like', 4, NULL),
(9498, NULL, 'IPR015484', NULL, 'CD3 protein, epsilon/gamma/delta subunit', 'CD3_esu/gsu/dsu', 4, NULL),
(9499, NULL, 'IPR016084', NULL, 'Haem oxygenase-like, multi-helical', 'Haem_Oase-like_multi-hlx', 5, NULL),
(9500, NULL, 'IPR013424', NULL, 'PEP-CTERM protein-sorting domain', 'PEP_exosort_dom', 3, NULL),
(9501, NULL, 'IPR014328', NULL, 'Restriction endonuclease, type II, Alw26I/Eco31I/Esp3I', 'Restrct_endonuc_II_Alw26I', 4, NULL),
(9502, NULL, 'IPR009163', NULL, 'Ap4A phosphorylase 1/2', 'Ap4A_phos1/2', 4, NULL),
(9503, NULL, 'IPR023303', NULL, 'Ammonia/methane monooxygenase, subunit B, C-terminal', 'NH3_CH4_mOase_suB_C', 5, NULL),
(9504, NULL, 'IPR015145', NULL, 'L27-N', 'L27_N', 3, NULL),
(9505, NULL, 'IPR015832', NULL, 'Uncharacterised conserved protein UCP006363, ACT-type', 'UCP006363_ACT', 4, NULL),
(9506, NULL, 'IPR014484', NULL, 'Uncharacterised conserved protein UCP016792', 'UCP016792', 4, NULL),
(9507, NULL, 'IPR023827', NULL, 'Peptidase S8, subtilisin,  Asp-active site', 'Peptidase_S8_Asp-AS', 0, NULL),
(9508, NULL, 'IPR034598', NULL, 'D-Glucarate dehydratase-like', 'GlucD-like', 4, NULL),
(9509, NULL, 'IPR014317', NULL, 'Transcription activator PspF', 'Transcription_activator_PspF', 4, NULL),
(9510, NULL, 'IPR009028', NULL, 'Coatomer/calthrin adaptor appendage, C-terminal subdomain', 'Coatomer/calthrin_app_sub_C', 5, NULL),
(9511, NULL, 'IPR015121', NULL, 'DNA fragmentation factor 45kDa, middle domain', 'DNA_fragmentation_mid_dom', 3, NULL),
(9512, NULL, 'IPR009194', NULL, 'Corrinoid adenosyltransferase EutT', 'AdoTrfase_EutT', 4, NULL),
(9513, NULL, 'IPR014315', NULL, 'ABC transporter, membrane fusion protein, DevB type', 'ABC_heterocyst_DevB', 4, NULL),
(9514, NULL, 'IPR014464', NULL, 'Conserved virulence factor B', 'CvfB_fam', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(9515, NULL, 'IPR009519', NULL, 'Fiji disease virus, Vp7-2', 'FDV_Vp7-2', 4, NULL),
(9516, NULL, 'IPR013860', NULL, 'Nitrogen regulatory protein areA, GATA-like domain', 'AreA_GATA', 3, NULL),
(9517, NULL, 'IPR015137', NULL, 'Stannin cytoplasmic', 'SNN_cytoplasm', 3, NULL),
(9518, NULL, 'IPR012788', NULL, '4-carboxymuconolactone decarboxylase', 'Decarb_PcaC', 3, NULL),
(9519, NULL, 'IPR035372', NULL, 'Malonyl-CoA decarboxylase, N-terminal', 'MCD_N', 3, NULL),
(9520, NULL, 'IPR014327', NULL, 'RNA polymerase sigma-70, Bacteroidetes type', 'RNA_pol_sigma70_bacteroid', 4, NULL),
(9521, NULL, 'IPR015157', NULL, 'Translation machinery associated TMA7', 'TMA7', 4, NULL),
(9522, NULL, 'IPR009164', NULL, 'Fructose-1,6-bisphosphatase class 3', 'FBPtase_class3', 4, NULL),
(9523, NULL, 'IPR008279', NULL, 'PEP-utilising enzyme, mobile domain', 'PEP-util_enz_mobile_dom', 3, NULL),
(9524, NULL, 'IPR009003', NULL, 'Peptidase S1, PA clan', 'Peptidase_S1_PA', 5, NULL),
(9525, NULL, 'IPR013515', NULL, 'Phytochrome, central region', 'Phytochrome_cen-reg', 3, NULL),
(9526, NULL, 'IPR012620', NULL, 'Tryptophanese operon leader peptide', 'Trp_operon_leader_peptide', 4, NULL),
(9527, NULL, 'IPR008284', NULL, 'Molybdenum cofactor biosynthesis, conserved site', 'MoCF_biosynth_CS', 2, NULL),
(9528, NULL, 'IPR014447', NULL, 'Uncharacterised conserved protein UCP006909', 'UCP006909', 4, NULL),
(9529, NULL, 'IPR012793', NULL, 'Beta-ketoadipyl CoA thiolase', 'PcaF', 4, NULL),
(9530, NULL, 'IPR010753', NULL, 'Domain of unknown function DUF1330', 'DUF1330', 3, NULL),
(9531, NULL, 'IPR009521', NULL, 'Orthopoxvirus F6', 'Orthopox_F6', 4, NULL),
(9532, NULL, 'IPR014307', NULL, 'Xanthine dehydrogenase, small subunit', 'Xanthine_DH_ssu', 3, NULL),
(9533, NULL, 'IPR009174', NULL, 'Orthopoxvirus, Protein K7', 'Orthopox_K7', 4, NULL),
(9534, NULL, 'IPR015138', NULL, 'Salmonella invasion protein A, N-terminal', 'SipA_N', 3, NULL),
(9535, NULL, 'IPR015576', NULL, 'Spermine synthase, animal', 'Spermine_synthase_animal', 4, NULL),
(9536, NULL, 'IPR012751', NULL, 'CspD, cold shock', 'CspD', 4, NULL),
(9537, NULL, 'IPR035943', NULL, 'XisI-like superfamily', 'XisI-like_sf', 5, NULL),
(9538, NULL, 'IPR013872', NULL, 'p53 transactivation domain', 'p53_transactivation_domain', 3, NULL),
(9539, NULL, 'IPR024692', NULL, 'Phosphotransferase system, enzyme I', 'PTS_EI', 4, NULL),
(9540, NULL, 'IPR014314', NULL, 'Succinate dehydrogenase, cytochrome b556 subunit', 'Succ_DH_cytb556', 4, NULL),
(9541, NULL, 'IPR015166', NULL, 'Protein of unknown function DUF1922', 'DUF1922', 4, NULL),
(9542, NULL, 'IPR014299', NULL, 'Pentapeptide MXKDX repeat protein', 'Penta_MxKDx', 4, NULL),
(9543, NULL, 'IPR012626', NULL, 'Spider insecticidal peptide', 'Spider_insecticidal_peptide', 4, NULL),
(9544, NULL, 'IPR009009', NULL, 'RlpA-like protein, double-psi beta-barrel domain', 'RlpA-like_DPBB', 3, NULL),
(9545, NULL, 'IPR008157', NULL, 'Annexin A11', 'ANX11', 4, NULL),
(9546, NULL, 'IPR012605', NULL, 'RepA1 leader peptide Tap', 'RepA1_leader_peptide_Tap', 4, NULL),
(9547, NULL, 'IPR012763', NULL, 'DNA polymerase III, subunit gamma/ tau, N-terminal', 'DNA_pol_III_sug/sutau_N', 3, NULL),
(9548, NULL, 'IPR035322', NULL, 'Male Flower Specific protein 18', 'MFS18', 4, NULL),
(9549, NULL, 'IPR010695', NULL, 'Fas apoptotic inhibitory molecule 1', 'FAIM1', 4, NULL),
(9550, NULL, 'IPR014627', NULL, 'Uncharacterised conserved protein UCP036888, signal transduction HD-GYP-like, PA5346 type', 'UCP036888_HDGYP-like', 4, NULL),
(9551, NULL, 'IPR015109', NULL, 'Restriction endonuclease, type II, EcoRII, C-terminal', 'Restrct_endonuc_II_EcoRII_C', 3, NULL),
(9552, NULL, 'IPR013861', NULL, 'TMEM115/Pdh1/Rbl19', 'TMEM115/Pdh1/Rbl19', 4, NULL),
(9553, NULL, 'IPR035325', NULL, 'Protein of unknown function DUF5385', 'DUF5385', 4, NULL),
(9554, NULL, 'IPR015128', NULL, 'Aurora-A binding', 'Aurora-A-bd', 3, NULL),
(9555, NULL, 'IPR010737', NULL, 'Four-carbon acid sugar kinase, N-terminal domain', '4-carb_acid_sugar_kinase_N', 3, NULL),
(9556, NULL, 'IPR011626', NULL, 'Alpha-macroglobulin-like, TED domain', 'Alpha-macroglobulin_TED', 3, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(9557, NULL, 'IPR014319', NULL, 'Phage shock protein, PspA', 'Phageshock_PspA', 4, NULL),
(9558, NULL, 'IPR012769', NULL, 'Trehalose-6-phosphate hydrolase', 'Trehalose_TreC', 4, NULL),
(9559, NULL, 'IPR012623', NULL, 'Conotoxin O-superfamily', 'Toxin_18', 4, NULL),
(9560, NULL, 'IPR012779', NULL, 'Peptidase M1, alanyl aminopeptidase', 'Peptidase_M1_pepN', 4, NULL),
(9561, NULL, 'IPR011269', NULL, 'Putative purine nucleotide phosphorylase', 'PUNP', 4, NULL),
(9562, NULL, 'IPR035305', NULL, 'Herpesvirus glycoprotein H, C-terminal', 'Herpes_glycoH_C', 3, NULL),
(9563, NULL, 'IPR012754', NULL, 'DNA-directed RNA polymerase, subunit beta-prime, bacterial type', 'DNA-dir_RpoC_beta_prime_bact', 4, NULL),
(9564, NULL, 'IPR009153', NULL, 'Cytochrome cL', 'Cyt_cL', 4, NULL),
(9565, NULL, 'IPR012752', NULL, 'dTDP-fucosamine acetyltransferase WecD', 'AcTrfase_WecD', 4, NULL),
(9566, NULL, 'IPR014325', NULL, 'RNA polymerase sigma-E factor, actinobacteria', 'RNA_pol_sigma-E_actinobac', 4, NULL),
(9567, NULL, 'IPR014457', NULL, 'Uncharacterised conserved protein UCP010260', 'UCP010260', 4, NULL),
(9568, NULL, 'IPR009190', NULL, 'Protein of unknown function DUF1462', 'DUF1462', 4, NULL),
(9569, NULL, 'IPR008999', NULL, 'Actin-crosslinking', 'Actin-crosslinking', 5, NULL),
(9570, NULL, 'IPR015159', NULL, 'Recombination protein 107', 'Rec107', 4, NULL),
(9571, NULL, 'IPR015158', NULL, 'Bud22 domain', 'Bud22_dom', 3, NULL),
(9572, NULL, 'IPR010740', NULL, 'Endomucin', 'Endomucin', 4, NULL),
(9573, NULL, 'IPR009030', NULL, 'Growth factor receptor cysteine-rich domain superfamily', 'Growth_fac_rcpt_cys_sf', 5, NULL),
(9574, NULL, 'IPR009528', NULL, 'BsuBI/PstI restriction endonuclease domain', 'Restrct_endonuc_II_BsuBI_C', 3, NULL),
(9575, NULL, 'IPR015107', NULL, 'Protein-glutamine gamma-glutamyltransferase', 'Transglut_prok', 4, NULL),
(9576, NULL, 'IPR014047', NULL, 'Chromate transporter, long chain', 'Chr_Tranpt_l_chain', 4, NULL),
(9577, NULL, 'IPR012749', NULL, 'dTDP-4-amino-4,6-dideoxygalactose transaminase WecE-like', 'WecE-like', 4, NULL),
(9578, NULL, 'IPR010719', NULL, 'Putative rRNA methylase', 'rRNA_methylase', 4, NULL),
(9579, NULL, 'IPR012750', NULL, 'Undecaprenyl-phosphate alpha-N-acetylglucosaminyl 1-phosphatetransferase', 'ECA_WecA-rel', 4, NULL),
(9580, NULL, 'IPR015133', NULL, 'Effector protein HopAB, E3 ubiquitin ligase domain', 'E3_ubiquit_lig_AvrPtoB', 3, NULL),
(9581, NULL, 'IPR009019', NULL, 'K homology domain superfamily, prokaryotic type', 'KH_sf_prok-type', 5, NULL),
(9582, NULL, 'IPR012617', NULL, 'Apoptosis-antagonizing transcription factor, C-terminal', 'AATF_C', 3, NULL),
(9583, NULL, 'IPR009185', NULL, 'Predicted nucleotidyltransferase', 'Nucleotidl_trans', 4, NULL),
(9584, NULL, 'IPR014326', NULL, 'RNA polymerase sigma-70 factor,  Planctomycetaceae', 'RNA_pol_sigma-70_Plancto', 4, NULL),
(9585, NULL, 'IPR012762', NULL, 'Ubiquinone biosynthesis protein COQ9', 'Ubiq_biosynth_COQ9', 4, NULL),
(9586, NULL, 'IPR014305', NULL, 'RNA polymerase sigma-G type, actinobacteria', 'RNA_pol_sigma-G_actinobac', 4, NULL),
(9587, NULL, 'IPR012609', NULL, 'Sporulation stage V, protein M', 'Spore_V_M', 4, NULL),
(9588, NULL, 'IPR035375', NULL, 'MatP, C-terminal ribbon-helix-helix domain', 'MatP_C', 3, NULL),
(9589, NULL, 'IPR010743', NULL, 'Methionine biosynthesis MetW', 'Methionine_synth_MetW', 4, NULL),
(9590, NULL, 'IPR010756', NULL, 'Telomere length and silencing protein 1', 'Tls1', 4, NULL),
(9591, NULL, 'IPR015129', NULL, 'Titin, Z repeat', 'Titin_Z_rpt', 7, NULL),
(9592, NULL, 'IPR012614', NULL, 'Small acid-soluble spore protein, SspP', 'SASP_SspP', 4, NULL),
(9593, NULL, 'IPR014046', NULL, 'Diadenylate cyclase', 'C-di-AMP_synthase', 4, NULL),
(9594, NULL, 'IPR011262', NULL, 'DNA-directed RNA polymerase, insert domain', 'DNA-dir_RNA_pol_insert', 3, NULL),
(9595, NULL, 'IPR013869', NULL, 'Protein of unknown function DUF1757', 'DUF1757', 4, NULL),
(9596, NULL, 'IPR008989', NULL, 'Myosin S1 fragment, N-terminal', 'Myosin_S1_N', 5, NULL),
(9597, NULL, 'IPR009176', NULL, 'Vaccinia virus, B7/C8', 'Vaccinia_virus_B7/C8', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(9598, NULL, 'IPR009015', NULL, 'L-fucose isomerase, N-terminal/central domain superfamily', 'Fucose_isomerase_N/cen_sf', 5, NULL),
(9599, NULL, 'IPR015135', NULL, 'Stannin transmembrane', 'SNN_transmemb', 3, NULL),
(9600, NULL, 'IPR009159', NULL, 'Dihydrofolate reductase, type II', 'Dhfr_type_II', 4, NULL),
(9601, NULL, 'IPR012622', NULL, 'Potassium channel toxin gamma/Ergtoxin', 'Ergtoxin', 4, NULL),
(9602, NULL, 'IPR034080', NULL, 'Protease P7-like, domain', 'Protease_P7-like_dom', 3, NULL),
(9603, NULL, 'IPR012756', NULL, 'DNA-directed RNA polymerase, subunit beta''''', 'DNA-dir_RpoC2_beta_pp', 4, NULL),
(9604, NULL, 'IPR014309', NULL, 'Xanthine dehydrogenase, molybdopterin binding subunit', 'Xanthine_DH_Mopterin-bd_su', 3, NULL),
(9605, NULL, 'IPR011270', NULL, 'Purine nucleoside phosphorylase I, inosine/guanosine-specific', 'Pur_Nuc_Pase_Ino/Guo-sp', 4, NULL),
(9606, NULL, 'IPR011273', NULL, 'Malate dehydrogenase, NADP-dependent, plants', 'Malate_DH_NADP-dep_pln', 4, NULL),
(9607, NULL, 'IPR035371', NULL, 'Nrap protein, domain 6', 'Nrap_D6', 3, NULL),
(9608, NULL, 'IPR023824', NULL, 'Conserved hypothetical protein CHP04073, exosortase-affiliated', 'CHP04073_exosortase-affil', 4, NULL),
(9609, NULL, 'IPR008286', NULL, 'Orn/Lys/Arg decarboxylase, C-terminal', 'Prn/Lys/Arg_de-COase_C', 3, NULL),
(9610, NULL, 'IPR009169', NULL, 'Calreticulin', 'Calreticulin', 4, NULL),
(9611, NULL, 'IPR023882', NULL, 'Colanic acid biosynthesis WcaM', 'Colanic_acid_synth_WcaM', 4, NULL),
(9612, NULL, 'IPR011271', NULL, 'AMP nucleosidase', 'AMP_nucleosidase', 4, NULL),
(9613, NULL, 'IPR012776', NULL, 'Trimethyllysine dioxygenase', 'Trimethyllysine_dOase', 4, NULL),
(9614, NULL, 'IPR009010', NULL, 'Aspartate decarboxylase-like domain superfamily', 'Asp_de-COase-like_dom_sf', 5, NULL),
(9615, NULL, 'IPR010710', NULL, 'Protein of unknown function DUF1289', 'DUF1289', 4, NULL),
(9616, NULL, 'IPR009524', NULL, 'Protein of unknown function DUF1143', 'DUF1143', 4, NULL),
(9617, NULL, 'IPR010738', NULL, 'Protein of unknown function DUF1310', 'DUF1310', 4, NULL),
(9618, NULL, 'IPR012618', NULL, 'Tetracycline resistance leader peptide, TetL', 'Tet-R_leader_TetL', 4, NULL),
(9619, NULL, 'IPR015139', NULL, 'Cag pathogenicity island protein, CagZ', 'CagPAI_CagZ', 4, NULL),
(9620, NULL, 'IPR015152', NULL, 'Growth hormone/erythropoietin receptor, ligand binding', 'Growth/epo_recpt_lig-bind', 3, NULL),
(9621, NULL, 'IPR012764', NULL, 'Glucosylglycerol-phosphate synthase', 'Gluc_glyc_Psyn', 4, NULL),
(9622, NULL, 'IPR012782', NULL, 'Acetolactate synthase, catabolic', 'Acetolactate_synth_catblc', 4, NULL),
(9623, NULL, 'IPR015117', NULL, 'Ig protease IdeS', 'IdeS', 3, NULL),
(9624, NULL, 'IPR012786', NULL, 'Protocatechuate 3,4-dioxygenase, alpha subunit', 'Protocat_dOase_a', 4, NULL),
(9625, NULL, 'IPR023879', NULL, 'Quinohemoprotein amine dehydrogenase, beta subunit', 'QH-AmDH_bsu', 4, NULL),
(9626, NULL, 'IPR015143', NULL, 'L27-1', 'L27_1', 3, NULL),
(9627, NULL, 'IPR014465', NULL, 'Uncharacterised conserved protein UCP012622', 'UCP012622', 4, NULL),
(9628, NULL, 'IPR011127', NULL, 'D-alanine--D-alanine ligase, N-terminal domain', 'Dala_Dala_lig_N', 3, NULL),
(9629, NULL, 'IPR010723', NULL, 'HemN, C-terminal', 'HemN_C', 3, NULL),
(9630, NULL, 'IPR014466', NULL, 'Predicted transcriptional regulator, AF1742 type', 'Txn_rg_UCP012876', 4, NULL),
(9631, NULL, 'IPR034001', NULL, 'ATP-binding cassette transporter, PDR-like subfamily G, domain 1', 'ABCG_PDR_1', 3, NULL),
(9632, NULL, 'IPR015122', NULL, 'Excisionase from transposon Tn916', 'Tn916-Xis', 4, NULL),
(9633, NULL, 'IPR008984', NULL, 'SMAD/FHA domain superfamily', 'SMAD_FHA_dom_sf', 5, NULL),
(9634, NULL, 'IPR009001', NULL, 'Translation elongation factor EF1A/initiation factor IF2gamma, C-terminal', 'Transl_elong_EF1A/Init_IF2_C', 5, NULL),
(9635, NULL, 'IPR009166', NULL, 'Annexin A13', 'ANX13', 4, NULL),
(9636, NULL, 'IPR010741', NULL, 'Protein of unknown function DUF1314', 'DUF1314', 4, NULL),
(9637, NULL, 'IPR015141', NULL, 'Phospholipase A2, prokaryotic/fungal', 'PLipase_A2_prok/fun', 4, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(9638, NULL, 'IPR012780', NULL, 'Carbon-monoxide dehydrogenase, large subunit', 'CO_Mo_DH_lsu', 4, NULL),
(9639, NULL, 'IPR008283', NULL, 'Peptidase M17, leucyl aminopeptidase, N-terminal', 'Peptidase_M17_N', 3, NULL),
(9640, NULL, 'IPR009025', NULL, 'DNA-directed RNA polymerase, RBP11-like dimerisation domain', 'RBP11-like_dimer', 3, NULL),
(9641, NULL, 'IPR011129', NULL, 'Cold shock domain', 'CSD', 3, NULL),
(9642, NULL, 'IPR008993', NULL, 'Tissue inhibitor of metalloproteinases-like, OB-fold', 'TIMP-like_OB-fold', 5, NULL),
(9643, NULL, 'IPR015161', NULL, 'Streptomyces killer toxin-like, beta/gamma crystallin', 'Sklp_toxin_b/g_crystallin', 3, NULL),
(9644, NULL, 'IPR012772', NULL, 'L-2,4-diaminobutyric acid acetyltransferase', 'Ectoine_EctA', 4, NULL),
(9645, NULL, 'IPR012603', NULL, 'RBB1NT', 'RBB1NT', 3, NULL),
(9646, NULL, 'IPR010692', NULL, 'RTX iron-regulated FrpC', 'FrpC', 4, NULL),
(9647, NULL, 'IPR015127', NULL, 'Gastric H+/K+-transporter P-type ATPase, N-terminal', 'ATPase_P-typ_H/K-transp_N', 3, NULL),
(9648, NULL, 'IPR011274', NULL, 'Malate dehydrogenase, NAD-dependent, cytosolic', 'Malate_DH_NAD-dep_euk', 4, NULL),
(9649, NULL, 'IPR012616', NULL, 'CDP-alcohol phosphatidyltransferase, C-terminal', 'CDP-OH_P_trans_C', 3, NULL),
(9650, NULL, 'IPR014303', NULL, 'RNA polymerase sigma-70, ECF type', 'RNA_pol_sigma-70_ECF', 4, NULL),
(9651, NULL, 'IPR009522', NULL, 'Nucleocapsid, Phlebovirus/Tenuivirus', 'Capsid_Phlebovir/Tenuivir', 4, NULL),
(9652, NULL, 'IPR013795', NULL, 'DNA/RNA-binding protein Alba', 'DNA/RNA-bd_Alba', 4, NULL),
(9653, NULL, 'IPR014048', NULL, 'Methylated-DNA-[protein]-cysteine S-methyltransferase, DNA binding', 'MethylDNA_cys_MeTrfase_DNA-bd', 3, NULL),
(9654, NULL, 'IPR015827', NULL, 'Alpha-(1,6)-fucosyltransferase', 'Fut8', 4, NULL),
(9655, NULL, 'IPR015156', NULL, 'Malto-oligosyltrehalose trehalohydrolase, archaeal, C-terminal', 'Maltooligo_trehalose_arc_C', 3, NULL),
(9656, NULL, 'IPR013863', NULL, 'Vacuolar import/degradation Vid27, C-terminal', 'VID27_C', 3, NULL),
(9657, NULL, 'IPR012784', NULL, 'RNA polymerase-binding transcription factor DksA', 'DksA_RNA_pol-bd', 4, NULL),
(9658, NULL, 'IPR014320', NULL, 'Phage shock protein, PspC', 'Phageshock_PspC', 4, NULL),
(9659, NULL, 'IPR012791', NULL, '3-oxoacid CoA-transferase, subunit B', '3-oxoacid_CoA-transf_B', 3, NULL),
(9660, NULL, 'IPR012628', NULL, 'Magi 5 toxic peptide', 'Toxin_23', 4, NULL),
(9661, NULL, 'IPR014296', NULL, 'RNA polymerase sigma-M, bacillaceae', 'RNA_pol_sigma-M_bacilli', 4, NULL),
(9662, NULL, 'IPR011078', NULL, 'Pyridoxal phosphate homeostasis protein', 'PyrdxlP_homeostasis', 4, NULL),
(9663, NULL, 'IPR012757', NULL, 'DNA-directed RNA polymerase subunit Rpo1C', 'RPO1C', 4, NULL),
(9664, NULL, 'IPR013858', NULL, 'Peptidase M10 serralysin, C-terminal', 'Peptidase_M10B_C', 3, NULL),
(9665, NULL, 'IPR014301', NULL, 'TMAO reductase system,  periplasmic protein TorT', 'TMAO_TorT', 4, NULL),
(9666, NULL, 'IPR011625', NULL, 'Alpha-2-macroglobulin, bait region domain', 'A2M_N_BRD', 3, NULL),
(9667, NULL, 'IPR010699', NULL, 'Protein of unknown function DUF1275', 'DUF1275', 4, NULL),
(9668, NULL, 'IPR024114', NULL, 'Islet cell autoantigen 1/Ica1-like', 'Islet_autoAg_Ica1/Ica1-like', 4, NULL),
(9669, NULL, 'IPR010760', NULL, 'DNA repair protein, Swi5', 'DNA-repair_Swi5', 4, NULL),
(9670, NULL, 'IPR009033', NULL, 'Calreticulin/calnexin, P domain superfamily', 'Calreticulin/calnexin_P_dom_sf', 5, NULL),
(9671, NULL, 'IPR010758', NULL, 'Trans-2-enoyl-CoA reductase', 'Trans-2-enoyl-CoA_reductase', 4, NULL),
(9672, NULL, 'IPR024162', NULL, 'Adaptor protein Cbl', 'Adaptor_Cbl', 4, NULL),
(9673, NULL, 'IPR014323', NULL, 'Phage shock protein, PspE', 'Phageshock_PspE', 4, NULL),
(9674, NULL, 'IPR011199', NULL, 'Bacillithiol biosynthesis BshC', 'Bacillithiol_biosynth_BshC', 4, NULL),
(9675, NULL, 'IPR009523', NULL, 'Prokineticin', 'Prokineticin', 4, NULL),
(9676, NULL, 'IPR023826', NULL, 'Rhomboid-like serine protease, proteobacteria', 'Rhom-like_SP_proteobac', 4, NULL),
(9677, NULL, 'IPR015113', NULL, 'Staphostatin B', 'Staphostatin_B', 3, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(9678, NULL, 'IPR013876', NULL, 'TFIIH p62 subunit, N-terminal', 'TFIIH_BTF_p62_N', 3, NULL),
(9679, NULL, 'IPR011620', NULL, 'Signal transduction histidine kinase, 5TM receptor LytS, transmembrane region', 'Sig_transdc_His_kinase_LytS_TM', 3, NULL),
(9680, NULL, 'IPR010694', NULL, 'Uncharacterised protein family VirK', 'Uncharacterised_VirK', 4, NULL),
(9681, NULL, 'IPR014310', NULL, 'Signal transduction histidine kinase, phosphate regulon sensor PhoR', 'Sig_transdc_His_kinase_PhoR', 4, NULL),
(9682, NULL, 'IPR014472', NULL, 'Choline/ethanolamine phosphotransferase', 'CHOPT', 4, NULL),
(9683, NULL, 'IPR015167', NULL, 'Domain of unknown function DUF1923', 'DUF1923', 3, NULL),
(9684, NULL, 'IPR014308', NULL, 'Xanthine dehydrogenase accessory protein XdhC', 'Xanthine_DH_XdhC', 4, NULL),
(9685, NULL, 'IPR013868', NULL, 'Tethering factor for nuclear proteasome Cut8/Sts1', 'Cut8/Sts1_fam', 4, NULL),
(9686, NULL, 'IPR009173', NULL, 'Chemokine-binding protein, viral', 'Chemkine-bd_vir', 4, NULL),
(9687, NULL, 'IPR009014', NULL, 'Transketolase C-terminal/Pyruvate-ferredoxin oxidoreductase domain II', 'Transketo_C/PFOR_II', 5, NULL),
(9688, NULL, 'IPR023825', NULL, 'CRISPR-associated RAMP BGP1436', 'CRISPR-assoc_RAMP_BGP1436', 4, NULL),
(9689, NULL, 'IPR010746', NULL, 'Commelina yellow mottle virus, Orf1', 'CYMV_Orf1', 4, NULL),
(9690, NULL, 'IPR012794', NULL, 'Beta-ketoadipate transcriptional regulator, PcaR/PcaU/PobR', 'PcaR_PcaU', 4, NULL),
(9691, NULL, 'IPR012758', NULL, 'DNA-directed RNA polymerase subunit Rpo1N', 'RPO1N', 4, NULL),
(9692, NULL, 'IPR015116', NULL, 'Cdc42 binding domain-like', 'Cdc42-bd-like', 3, NULL),
(9693, NULL, 'IPR012765', NULL, 'Glucosylglycerol-phospate 3-phosphatase', 'GGPPase', 4, NULL),
(9694, NULL, 'IPR009162', NULL, 'RNA polymerase, 30kDa subunit, chordopox-type', 'RNA_pol_30_chordopoxvir-type', 4, NULL),
(9695, NULL, 'IPR015105', NULL, 'Type-2 restriction enzyme NgoMIV', 'NgoMIV', 4, NULL),
(9696, NULL, 'IPR012775', NULL, 'Gamma-butyrobetaine hydroxylase', 'GBBH', 4, NULL),
(9697, NULL, 'IPR023881', NULL, 'N-acetyl-alpha-D-glucosaminyl L-malate synthase BshA', 'Thiol_BshA', 4, NULL),
(9698, NULL, 'IPR023828', NULL, 'Peptidase S8, subtilisin, Ser-active site', 'Peptidase_S8_Ser-AS', 0, NULL),
(9699, NULL, 'IPR035323', NULL, 'Facilitor Of iron transport 1/2', 'Fit1_2', 4, NULL),
(9700, NULL, 'IPR012625', NULL, 'Huwentoxin-II family', 'Toxin_20', 4, NULL),
(9701, NULL, 'IPR009187', NULL, 'Non-homologous end joining protein Ku, prokaryotic type', 'Prok_Ku', 4, NULL),
(9702, NULL, 'IPR014300', NULL, 'RNA polymerase sigma-V type', 'RNA_pol_sigma-V', 4, NULL),
(9703, NULL, 'IPR015136', NULL, 'Stannin unstructured linker', 'SNN_linker', 3, NULL),
(9704, NULL, 'IPR010754', NULL, 'Optic atrophy 3-like', 'OPA3-like', 4, NULL),
(9705, NULL, 'IPR015155', NULL, 'PLAA family ubiquitin binding domain', 'PFU', 3, NULL),
(9706, NULL, 'IPR015151', NULL, 'Beta-adaptin appendage, C-terminal subdomain', 'B-adaptin_app_sub_C', 3, NULL),
(9707, NULL, 'IPR012613', NULL, 'Small acid-soluble spore protein, SspO', 'SASP_SspO', 4, NULL),
(9708, NULL, 'IPR015590', NULL, 'Aldehyde dehydrogenase domain', 'Aldehyde_DH_dom', 3, NULL),
(9709, NULL, 'IPR014306', NULL, 'Hydroxyisourate hydrolase', 'Hydroxyisourate_hydrolase', 4, NULL),
(9710, NULL, 'IPR010734', NULL, 'Copine, C-terminal', 'Copine_C', 3, NULL),
(9711, NULL, 'IPR013871', NULL, 'Cysteine-rich secretory protein', 'Cysteine_rich_secretory', 3, NULL),
(9712, NULL, 'IPR009167', NULL, 'Erythropoietin receptor', 'Erythropoietin_rcpt', 4, NULL),
(9713, NULL, 'IPR010762', NULL, 'Capsid protein, T4-like bacteriophage-like', 'Gp23/Gp24_T4-like', 4, NULL),
(9714, NULL, 'IPR015163', NULL, 'Cdc6, C-terminal', 'Cdc6_C', 3, NULL),
(9715, NULL, 'IPR014324', NULL, 'ABC transporter ATP-binding subunit, DevA type', 'ABC_heterocyst_DevA', 4, NULL),
(9716, NULL, 'IPR009000', NULL, 'Translation protein, beta-barrel domain superfamily', 'Transl_B-barrel_sf', 5, NULL),
(9717, NULL, 'IPR010712', NULL, 'Arsenical-resistance operon trans-acting repressor ArsD', 'Arsenical-R_ArsD', 4, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(9718, NULL, 'IPR011272', NULL, 'Lactate dehydrogenase, protist', 'Lactate_DH_protist', 4, NULL),
(9719, NULL, 'IPR014459', NULL, 'Transcriptional activator VP30, Filoviridae type', 'VP30_FiloV', 4, NULL),
(9720, NULL, 'IPR015104', NULL, 'Beta-2-glycoprotein-1 fifth domain', 'Sushi_2', 3, NULL),
(9721, NULL, 'IPR013873', NULL, 'Cdc37, C-terminal', 'Cdc37_C', 3, NULL),
(9722, NULL, 'IPR012783', NULL, 'Zinc finger, C4 DksA/TraR-type', 'Znf_C4_TraR', 4, NULL),
(9723, NULL, 'IPR034587', NULL, 'D-mannonate dehydratase', 'MAND', 4, NULL),
(9724, NULL, 'IPR024694', NULL, 'PurE, prokaryotic type', 'PurE_prokaryotes', 4, NULL),
(9725, NULL, 'IPR014623', NULL, 'Transcription factor TFIIIC  subunit Tfc7/tau55', 'Tfc7/tau55', 4, NULL),
(9726, NULL, 'IPR008990', NULL, 'Electron transport accessory-like domain superfamily', 'Elect_transpt_acc-like_dom_sf', 5, NULL),
(9727, NULL, 'IPR013862', NULL, 'Inositolphosphorylceramide synthase subunit Kei1', 'Kei1', 4, NULL),
(9728, NULL, 'IPR015108', NULL, 'Bacteriophage PRD1, P3', 'Phage_PRD1_P3', 4, NULL),
(9729, NULL, 'IPR010764', NULL, 'Protein of unknown function DUF1347', 'DUF1347', 4, NULL),
(9730, NULL, 'IPR009518', NULL, 'Photosystem II PsbX', 'PSII_PsbX', 4, NULL),
(9731, NULL, 'IPR010733', NULL, 'Domain of unknown function DUF1308', 'DUF1308', 3, NULL),
(9732, NULL, 'IPR012777', NULL, 'Leukotriene A4 hydrolase/leucine aminopeptidase', 'LTA4H', 4, NULL),
(9733, NULL, 'IPR010720', NULL, 'Alpha-L-arabinofuranosidase, C-terminal', 'Alpha-L-AF_C', 3, NULL),
(9734, NULL, 'IPR034108', NULL, 'Peptidase M35-like domain, Proteobacteria', 'Pept_M35-like_proteobacteria', 3, NULL),
(9735, NULL, 'IPR024207', NULL, 'Protein CotJB, domain', 'CotJB_dom', 3, NULL),
(9736, NULL, 'IPR015578', NULL, 'Neurotrophin-3', 'Neurotrophin-3', 4, NULL),
(9737, NULL, 'IPR010714', NULL, 'Coatomer, alpha subunit, C-terminal', 'Coatomer_asu_C', 3, NULL),
(9738, NULL, 'IPR014621', NULL, 'Uncharacterised conserved protein UCP036778, sugar epimerase-type', 'UCP036778_sugar_epimerase', 4, NULL),
(9739, NULL, 'IPR009526', NULL, 'Protein of unknown function DUF1146', 'DUF1146', 4, NULL),
(9740, NULL, 'IPR014626', NULL, 'Signal transduction response regulator with modified HD-GYP domain, putative', 'Sig_transdc_resp-reg_put', 4, NULL),
(9741, NULL, 'IPR008986', NULL, 'EV matrix protein', 'EV_matrix', 4, NULL),
(9742, NULL, 'IPR035376', NULL, 'NigD-like, C-terminal beta sandwich domain', 'NigD_C', 3, NULL),
(9743, NULL, 'IPR014453', NULL, 'Inhibitor of vertebrate lysozyme', 'Inhibitor_vertebrate_lysozyme', 4, NULL),
(9744, NULL, 'IPR009165', NULL, 'S-adenosylmethionine decarboxylase, bacterial', 'S-AdoMet_deCO2ase_bac', 4, NULL),
(9745, NULL, 'IPR034084', NULL, 'Thermitase-like, domain', 'Thermitase-like_dom', 3, NULL),
(9746, NULL, 'IPR010718', NULL, 'Protein of unknown function DUF1294', 'DUF1294', 4, NULL),
(9747, NULL, 'IPR012624', NULL, 'Conotoxin I-superfamily', 'Toxin_19', 4, NULL),
(9748, NULL, 'IPR014624', NULL, 'Predicted 26S proteasome regulatory complex, non-ATPase subcomplex, subunit s5a, Plasmodium', '26S_protsm_s5a', 4, NULL),
(9749, NULL, 'IPR014470', NULL, 'Uncharacterised conserved protein UCP01500', 'UCP01500', 4, NULL),
(9750, NULL, 'IPR015130', NULL, 'D-Lysine 5,6-aminomutase alpha subunit', 'Lys-AminoMut_A', 3, NULL),
(9751, NULL, 'IPR012770', NULL, 'Trehalose operon transcriptional repressor', 'TreR', 4, NULL),
(9752, NULL, 'IPR010711', NULL, 'Group XII secretory phospholipase A2 precursor', 'PLA2G12', 4, NULL),
(9753, NULL, 'IPR008280', NULL, 'Tubulin/FtsZ, C-terminal', 'Tub_FtsZ_C', 5, NULL),
(9754, NULL, 'IPR014311', NULL, 'Guanine deaminase', 'Guanine_deaminase', 4, NULL),
(9755, NULL, 'IPR009032', NULL, 'Vpu protein cytoplasmic domain superfamily', 'Vpu_cyt_dom_sf', 5, NULL),
(9756, NULL, 'IPR012606', NULL, 'Ribosomal protein S13/S15, N-terminal', 'Ribosomal_S13/S15_N', 3, NULL),
(9757, NULL, 'IPR011128', NULL, 'Glycerol-3-phosphate dehydrogenase, NAD-dependent, N-terminal', 'G3P_DH_NAD-dep_N', 3, NULL),
(9758, NULL, 'IPR014456', NULL, 'Uncharacterised conserved protein UCP010244, integral membrane protein', 'UCP010244_IM', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(9759, NULL, 'IPR009022', NULL, 'Elongation factor G, domain III', 'EFG_III', 3, NULL),
(9760, NULL, 'IPR014318', NULL, 'Phage shock protein, PspG', 'Phageshock_PspG', 4, NULL),
(9761, NULL, 'IPR009016', NULL, 'Iron hydrogenase', 'Fe_hydrogenase', 5, NULL),
(9762, NULL, 'IPR014468', NULL, 'Uncharacterised conserved protein UCP014979', 'UCP014979', 4, NULL),
(9763, NULL, 'IPR014051', NULL, 'Phosphoesterase, HXTX', 'Phosphoesterase_HXTX', 3, NULL),
(9764, NULL, 'IPR015142', NULL, 'Smac/DIABLO protein', 'Smac_DIABLO', 4, NULL),
(9765, NULL, 'IPR015170', NULL, 'Protein of unknown function DUF1924, Cytochrome c-type protein SHP-like', 'DUF1924_SHP', 4, NULL),
(9766, NULL, 'IPR009160', NULL, 'Acyl-CoA desaturase, haem/steroid binding domain-containing', 'Acyl-CoA_deSatase_haem/ster-bd', 4, NULL),
(9767, NULL, 'IPR015126', NULL, 'Mu DNA binding, I gamma subdomain', 'Mu_I-gamma', 3, NULL),
(9768, NULL, 'IPR009034', NULL, 'Fungal dockerin domain superfamily', 'Dockerin_dom_fun_sf', 5, NULL),
(9769, NULL, 'IPR012612', NULL, 'Small acid-soluble spore protein, SspN', 'SASP_SspN', 4, NULL),
(9770, NULL, 'IPR012611', NULL, 'Small acid-soluble spore protein, SspK', 'SASP_SspK', 4, NULL),
(9771, NULL, 'IPR012773', NULL, 'Ectoine biosynthetic protein', 'Ectoine_EctB', 4, NULL),
(9772, NULL, 'IPR014449', NULL, 'Uncharacterised conserved protein UCP007050, HI0931', 'UCP007050_HI0931', 4, NULL),
(9773, NULL, 'IPR013803', NULL, 'Amyloidogenic glycoprotein, amyloid-beta peptide', 'Amyloid_glyco_Abeta', 3, NULL),
(9774, NULL, 'IPR012789', NULL, '3-carboxy-cis,cis-muconate cycloisomerase', 'Protocat_PcaB', 4, NULL),
(9775, NULL, 'IPR034138', NULL, 'Nucleolar protein 8, RNA recognition motif', 'NOP8_RRM', 3, NULL),
(9776, NULL, 'IPR024160', NULL, 'Bin3-type S-adenosyl-L-methionine binding domain', 'BIN3_SAM-bd_dom', 3, NULL),
(9777, NULL, 'IPR012608', NULL, 'Sex peptide', 'Sex_peptide', 4, NULL),
(9778, NULL, 'IPR009161', NULL, 'ATP-dependent 6-phosphofructokinase, eukaryotic-type', '6-Pfructokinase_euk', 4, NULL),
(9779, NULL, 'IPR010763', NULL, '2-dehydro-3-deoxy-phosphogluconate aldolase', 'DgaF', 4, NULL),
(9780, NULL, 'IPR013802', NULL, 'Formiminotransferase, C-terminal subdomain', 'Formiminotransferase_C', 3, NULL),
(9781, NULL, 'IPR024159', NULL, 'Adaptor protein Cbl, PTB domain', 'Cbl_PTB', 3, NULL),
(9782, NULL, 'IPR035329', NULL, 'Rotavirus VP4 helical domain', 'VP4_helical', 3, NULL),
(9783, NULL, 'IPR024111', NULL, 'PEX5/PEX5L', 'PEX5/PEX5L', 4, NULL),
(9784, NULL, 'IPR009018', NULL, 'Signal recognition particle, SRP9/SRP14 subunit', 'Signal_recog_particle_SRP9/14', 5, NULL),
(9785, NULL, 'IPR009152', NULL, 'Cytochrome bc1 complex, cytochrome c subunit', 'bc1_cytC-su', 4, NULL),
(9786, NULL, 'IPR024272', NULL, 'MAFF2-related', 'MAFF-rel', 4, NULL),
(9787, NULL, 'IPR015106', NULL, 'Pas factor saposin domain', 'Pas_Saposin', 3, NULL),
(9788, NULL, 'IPR014622', NULL, 'Uncharacterised conserved protein UCP036794, erythromycin esterase-type', 'UCP036794_erythomycin', 4, NULL),
(9789, NULL, 'IPR009197', NULL, 'Microcystin LR degradation protein MlrC', 'MlrC', 4, NULL),
(9790, NULL, 'IPR014321', NULL, 'Phage shock protein, PspD', 'Phageshock_PspD', 4, NULL),
(9791, NULL, 'IPR010706', NULL, 'Fatty acid cis-trans isomerase', 'Fatty_acid_cis-trans_isomerase', 4, NULL),
(9792, NULL, 'IPR012607', NULL, 'Ribosomal protein S22', 'Ribosomal_S22', 4, NULL),
(9793, NULL, 'IPR011126', NULL, 'HPr(Ser) kinase/phosphorylase, N-terminal', 'Hpr_kin/Pase_Hpr_N', 3, NULL),
(9794, NULL, 'IPR035321', NULL, 'Protein of unknown function DUF5373', 'DUF5373', 4, NULL),
(9795, NULL, 'IPR023942', NULL, '3-keto-L-gulonate-6-phosphate decarboxylase, UlaD', '3-keto-L-gulonate6Pdecase_UlaD', 4, NULL),
(9796, NULL, 'IPR011201', NULL, 'Zinc-ribbon domain, bacteria', 'Zinc-ribbon_6_bact', 3, NULL),
(9797, NULL, 'IPR011267', NULL, 'Vegetative storage protein', 'Veg_Stor_Prot', 4, NULL),
(9798, NULL, 'IPR015153', NULL, 'EF-hand domain, type 1', 'EF-hand_dom_typ1', 3, NULL),
(9799, NULL, 'IPR012768', NULL, 'Malto-oligosyltrehalose trehalohydrolase', 'Trehalose_TreZ', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(9800, NULL, 'IPR010724', NULL, 'Replication initiator A, N-terminal', 'RepA_N', 3, NULL),
(9801, NULL, 'IPR012610', NULL, 'Small acid-soluble spore protein, SspH', 'SASP_SspH', 4, NULL),
(9802, NULL, 'IPR013874', NULL, 'Cdc37, Hsp90 binding', 'Cdc37_Hsp90-bd', 3, NULL),
(9803, NULL, 'IPR014450', NULL, 'Uncharacterised conserved protein UCP008210', 'UCP008210', 4, NULL),
(9804, NULL, 'IPR013870', NULL, 'Ribosomal protein L37, mitochondrial', 'Ribosomal_L37_mit', 4, NULL),
(9805, NULL, 'IPR010696', NULL, 'Protein of unknown function DUF1272', 'DUF1272', 4, NULL),
(9806, NULL, 'IPR011268', NULL, 'Purine nucleoside phosphorylase', 'Purine_phosphorylase', 4, NULL),
(9807, NULL, 'IPR010732', NULL, 'Type VI secretion, TssG-like', 'T6SS_TssG-like', 4, NULL),
(9808, NULL, 'IPR009008', NULL, 'Valyl/Leucyl/Isoleucyl-tRNA synthetase, editing domain', 'Val/Leu/Ile-tRNA-synth_edit', 5, NULL),
(9809, NULL, 'IPR010722', NULL, 'Biotin and thiamin synthesis-associated domain', 'BATS_dom', 3, NULL),
(9810, NULL, 'IPR014483', NULL, 'Fis-like DNA-binding domain-containing signal transduction response regulator, predicted', 'Sig_transdc_resp-reg_prd', 4, NULL),
(9811, NULL, 'IPR010725', NULL, 'Domain of unknown function DUF1299', 'DUF1299', 3, NULL),
(9812, NULL, 'IPR010736', NULL, 'Sperm-tail PG-rich repeat', 'SHIPPO-rpt', 7, NULL),
(9813, NULL, 'IPR035370', NULL, 'Nrap protein, domain 5', 'Nrap_D5', 3, NULL),
(9814, NULL, 'IPR034593', NULL, 'D-galactonate dehydratase DgoD-like', 'DgoD-like', 4, NULL),
(9815, NULL, 'IPR014313', NULL, 'Aldehyde oxidase', 'Aldehyde_oxidase', 4, NULL),
(9816, NULL, 'IPR011263', NULL, 'DNA-directed RNA polymerase, RpoA/D/Rpb3-type', 'DNA-dir_RNA_pol_RpoA/D/Rpb3', 3, NULL),
(9817, NULL, 'IPR014297', NULL, 'Dimethylsulphoxide reductase, chain B', 'DMSO_DmsB', 4, NULL),
(9818, NULL, 'IPR034589', NULL, 'D-mannonate dehydratase-like', 'D-mannonate_dehydratase-like', 4, NULL),
(9819, NULL, 'IPR035306', NULL, 'Ribosomal protein S12', 'Ribosomal_S12', 4, NULL),
(9820, NULL, 'IPR013866', NULL, 'Sphingolipid delta4-desaturase, N-terminal', 'Sphingolipid_d4-desaturase_N', 3, NULL),
(9821, NULL, 'IPR009006', NULL, 'Alanine racemase/group IV decarboxylase, C-terminal', 'Ala_racemase/Decarboxylase_C', 5, NULL),
(9822, NULL, 'IPR013516', NULL, 'Phytochrome chromophore binding site', 'Phyto_chromo_BS', 1, NULL),
(9823, NULL, 'IPR015124', NULL, 'Trehalose 2-sulfotransferase', 'Stf0', 4, NULL),
(9824, NULL, 'IPR009029', NULL, 'Hydroxymethylglutaryl-CoA reductase, class I/II, substrate-binding domain superfamily', 'HMG_CoA_Rdtase_sub-bd_dom_sf', 5, NULL),
(9825, NULL, 'IPR035326', NULL, 'Phage tail sheath protein, beta-sandwich domain', 'Phage_sheath_beta', 3, NULL),
(9826, NULL, 'IPR010730', NULL, 'Heterokaryon incompatibility', 'HET', 3, NULL),
(9827, NULL, 'IPR009158', NULL, 'Glycerol-3-phosphate dehydrogenase, GlpB subunit', 'G3P_DH_GlpB_su', 4, NULL),
(9828, NULL, 'IPR024206', NULL, 'Gurmarin/antimicrobial peptide', 'Gurmarin/antimicrobial_peptd', 4, NULL),
(9829, NULL, 'IPR015169', NULL, 'Adhesion molecule, immunoglobulin-like', 'Adhes-Ig-like', 3, NULL),
(9830, NULL, 'IPR035327', NULL, 'AlphaC, C-terminal', 'AlphaC_C', 3, NULL),
(9831, NULL, 'IPR014480', NULL, 'Mannan endo-1,6-alpha-mannosidase', 'Mannan-1_6-alpha_mannosidase', 4, NULL),
(9832, NULL, 'IPR024089', NULL, 'Proline dehydrogenase PutA, domain I/II', 'PRODH_PutA_dom_I/II', 5, NULL),
(9833, NULL, 'IPR015118', NULL, '5-aminolevulinate synthase presequence', '5aminolev_synth_preseq', 3, NULL),
(9834, NULL, 'IPR012760', NULL, 'RNA polymerase sigma factor RpoD, C-terminal', 'RNA_pol_sigma_RpoD_C', 3, NULL),
(9835, NULL, 'IPR009195', NULL, 'Uncharacterised protein family YjbK', 'Uncharacterised_YjbK', 4, NULL),
(9836, NULL, 'IPR015112', NULL, 'Staphostatin A', 'Staphostatin_A', 3, NULL),
(9837, NULL, 'IPR009047', NULL, 'Methyl-coenzyme M reductase, alpha subunit, C-terminal', 'Me_CoM_Rdtase_asu_C', 3, NULL),
(9838, NULL, 'IPR010716', NULL, 'RecQ helicase-like 5', 'RECQ5', 3, NULL),
(9839, NULL, 'IPR011130', NULL, 'SecA, preprotein cross-linking domain', 'SecA_preprotein_X-link_dom', 3, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(9840, NULL, 'IPR013867', NULL, 'Telomere repeat-binding factor, dimerisation domain', 'Telomere_rpt-bd_fac_dimer_dom', 3, NULL),
(9841, NULL, 'IPR014759', NULL, 'Helicase, superfamily 3, single-stranded RNA virus', 'Helicase_SF3_ssRNA_vir', 3, NULL),
(9842, NULL, 'IPR014329', NULL, 'M6 adenine DNA methyltransferase, Alw26I', 'M6_adenine_DNA_mtrans_Alw26I', 4, NULL),
(9843, NULL, 'IPR012796', NULL, 'Lysidine-tRNA(Ile) synthetase, C-terminal', 'Lysidine-tRNA-synth_C', 3, NULL),
(9844, NULL, 'IPR015172', NULL, 'MIF4G-like, type 1', 'MIF4G-like_typ-1', 3, NULL),
(9845, NULL, 'IPR035309', NULL, 'Proteasome activator complex subunit 4', 'PSME4', 4, NULL),
(9846, NULL, 'IPR014002', NULL, 'Agenet domain, plant type', 'Agenet_dom_plant', 3, NULL),
(9847, NULL, 'IPR035374', NULL, 'Protein VraX', 'VraX', 4, NULL),
(9848, NULL, 'IPR015148', NULL, 'Bacteriophage PP7, coat', 'Phage_PP7_coat', 4, NULL),
(9849, NULL, 'IPR010702', NULL, 'Periplasmic pectate lyase', 'Pectate_lyase_2', 4, NULL),
(9850, NULL, 'IPR015146', NULL, 'Ribonucleotide reductase, stirrup', 'RNR_stirrup', 3, NULL),
(9851, NULL, 'IPR012761', NULL, 'RNA polymerase sigma factor RpoS', 'RNA_pol_sigma_RpoS', 4, NULL),
(9852, NULL, 'IPR034599', NULL, 'Gluconate dehydratase', 'Gluconate_dehydratase', 4, NULL),
(9853, NULL, 'IPR011197', NULL, 'Uncharacterised conserved protein UCP012318', 'UCP012318', 4, NULL),
(9854, NULL, 'IPR010749', NULL, 'Protein of unknown function DUF1323', 'DUF1323', 4, NULL),
(9855, NULL, 'IPR011202', NULL, 'Uncharacterised conserved protein UCP014677', 'UCP014677', 4, NULL),
(9856, NULL, 'IPR012792', NULL, '3-oxoacid CoA-transferase, subunit A', '3-oxoacid_CoA-transf_A', 3, NULL),
(9857, NULL, 'IPR010729', NULL, 'Ribosomal protein L47, mitochondrial', 'Ribosomal_L47_mit', 4, NULL),
(9858, NULL, 'IPR015111', NULL, 'Hut operon regulatory protein HutP', 'Regulatory_HutP', 4, NULL),
(9859, NULL, 'IPR015154', NULL, 'EF-hand domain, type 2', 'EF-hand_dom_typ2', 3, NULL),
(9860, NULL, 'IPR024110', NULL, 'Immunoglobulin J chain', 'Ig_J', 4, NULL),
(9861, NULL, 'IPR034559', NULL, 'Spore photoproduct lyase, Clostridia type', 'Spore_PP_lysase_Clostridia', 4, NULL),
(9862, NULL, 'IPR013865', NULL, 'Protein FAM32A', 'FAM32A', 4, NULL),
(9863, NULL, 'IPR014451', NULL, 'Uncharacterised conserved protein UCP008455', 'UCP008455', 4, NULL),
(9864, NULL, 'IPR014481', NULL, 'Uncharacterised conserved protein UCP016662, toprim-type', 'UCP016662_toprim', 4, NULL),
(9865, NULL, 'IPR010751', NULL, 'Plasmid replication initiator protein TrfA', 'TrfA', 4, NULL),
(9866, NULL, 'IPR014478', NULL, 'Putative membrane protein, NMB1733 type', 'UCP016195', 4, NULL),
(9867, NULL, 'IPR015110', NULL, 'YopE, N-terminal domain', 'YopE_N_dom', 3, NULL),
(9868, NULL, 'IPR023171', NULL, 'Na+/H+ antiporter domain superfamily', 'Na/H_antiporter_dom_sf', 5, NULL),
(9869, NULL, 'IPR015168', NULL, 'SsuA/THI5-like', 'SsuA/THI5', 3, NULL),
(9870, NULL, 'IPR012766', NULL, 'Alpha,alpha-trehalose-phosphate synthase', 'Trehalose_OtsA', 4, NULL),
(9871, NULL, 'IPR014461', NULL, 'Vacuolar protein sorting-associated protein 17, Vps17', 'Retromer_complex_Vps17', 4, NULL),
(9872, NULL, 'IPR008156', NULL, 'Annexin A10', 'ANX10', 4, NULL),
(9873, NULL, 'IPR015147', NULL, 'PI-PfuI intein endonuclease, subdomain', 'PI-PfuI_intein_endonucl_subdom', 3, NULL),
(9874, NULL, 'IPR034560', NULL, 'Spore photoproduct lyase, Bacilli type', 'Spore_PP_lysase_Bacilli', 4, NULL),
(9875, NULL, 'IPR014462', NULL, 'Phage-associated protein Gp45', 'Phage_Mu_Gp45', 4, NULL),
(9876, NULL, 'IPR011623', NULL, '7TM-DISM receptor, extracellular domain, type 1', '7TMR_DISM_rcpt_extracell_dom1', 3, NULL),
(9877, NULL, 'IPR014460', NULL, 'Signal transduction response regulator, predicted, VieB', 'Sig_transdc_resp-reg_VieB', 4, NULL),
(9878, NULL, 'IPR012604', NULL, 'RBM1CTR', 'RBM1CTR', 3, NULL),
(9879, NULL, 'IPR009177', NULL, 'Orthopoxvirus C5', 'Orthopox_C5', 4, NULL),
(9880, NULL, 'IPR009004', NULL, 'Transposase, Mu, C-terminal', 'Transposase_Mu_C', 5, NULL),
(9881, NULL, 'IPR014445', NULL, 'Glutamine-dependent NAD(+) synthetase', 'Gln-dep_NAD_synthase', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(9882, NULL, 'IPR024161', NULL, 'Zinc finger, nanos-type', 'Znf_nanos-typ', 3, NULL),
(9883, NULL, 'IPR009188', NULL, '[NiFe]-hydrogenase maturation factor, HypX/HoxX type', 'NiFe-hyd_mat_HypX/HoxX', 4, NULL),
(9884, NULL, 'IPR012748', NULL, 'Rieske-like [2Fe-2S] domain, NirD-type', 'Rieske-like_NirD', 3, NULL),
(9885, NULL, 'IPR009520', NULL, 'Protein of unknown function DUF1140', 'DUF1140', 4, NULL),
(9886, NULL, 'IPR024137', NULL, 'Histone deacetylase complex subunit SAP130', 'His_deAcase_cplx_SAP130', 4, NULL),
(9887, NULL, 'IPR008998', NULL, 'Agglutinin domain', 'Agglutinin', 3, NULL),
(9888, NULL, 'IPR015144', NULL, 'Type III secretion system effector delivery regulator TyeA', 'T3SS_TyeA', 3, NULL),
(9889, NULL, 'IPR012774', NULL, 'Ectoine dioxygenase', 'EctD', 4, NULL),
(9890, NULL, 'IPR009527', NULL, 'Circovirus 2, Orf1', 'Circovirus2_Orf1', 4, NULL),
(9891, NULL, 'IPR024088', NULL, 'Tyrosine-tRNA ligase, bacterial-type', 'Tyr-tRNA-ligase_bac-type', 4, NULL),
(9892, NULL, 'IPR012795', NULL, 'tRNA(Ile)-lysidine synthase, N-terminal', 'tRNA_Ile_lys_synt_N', 3, NULL),
(9893, NULL, 'IPR010727', NULL, 'Protein of unknown function DUF1302', 'DUF1302', 4, NULL),
(9894, NULL, 'IPR015165', NULL, 'Glucan 1,4-alpha-maltotetraohydrolase, domain C', 'AMT4_domain_C', 3, NULL),
(9895, NULL, 'IPR010750', NULL, 'SGF29 tudor-like domain', 'SGF29_tudor-like_dom', 3, NULL),
(9896, NULL, 'IPR012627', NULL, 'Magi peptide toxin', 'Toxin_22', 4, NULL),
(9897, NULL, 'IPR010693', NULL, 'Divergent 4Fe-4S mono-cluster', 'Divergent_4Fe-4S_mono-cluster', 3, NULL),
(9898, NULL, 'IPR011622', NULL, '7TM-DISM receptor, extracellular domain, type 2', '7TMR_DISM_rcpt_extracell_dom2', 3, NULL),
(9899, NULL, 'IPR008992', NULL, 'Enterotoxin', 'Enterotoxin', 5, NULL),
(9900, NULL, 'IPR014302', NULL, 'Signal transduction histidine kinase, TMAO sensor TorS', 'Sig_transdc_His_kinase_TorS', 4, NULL),
(9901, NULL, 'IPR011624', NULL, 'Metal-dependent phosphohydrolase, 7TM extracellular domain', 'Metal-dep_PHydrolase_7TM_extra', 3, NULL),
(9902, NULL, 'IPR014304', NULL, 'RNA polymerase sigma-Z type', 'RNA_pol_sigma-Z', 4, NULL),
(9903, NULL, 'IPR010708', NULL, '5''(3'')-deoxyribonucleotidase', '5''(3'')-deoxyribonucleotidase', 4, NULL),
(9904, NULL, 'IPR009186', NULL, 'Predicted nickel metalloenzyme maturation factor, AIR synthase-related', 'Ni_metllenz_mat', 4, NULL),
(9905, NULL, 'IPR011260', NULL, 'RNA polymerase, alpha subunit, C-terminal', 'RNAP_asu_C', 3, NULL),
(9906, NULL, 'IPR024691', NULL, 'Micronemal protein 1, galectin-like domain', 'MIC1_galectin-like_dom', 3, NULL),
(9907, NULL, 'IPR013857', NULL, 'NADH:ubiquinone oxidoreductase intermediate-associated protein 30', 'NADH-UbQ_OxRdtase-assoc_prot30', 3, NULL),
(9908, NULL, 'IPR011200', NULL, 'Uncharacterised conserved protein UCP012608', 'UCP012608', 4, NULL),
(9909, NULL, 'IPR008996', NULL, 'Cytokine IL1/FGF', 'IL1/FGF', 5, NULL),
(9910, NULL, 'IPR012767', NULL, 'Maltooligosyl trehalose synthase', 'Trehalose_TreY', 4, NULL),
(9911, NULL, 'IPR009193', NULL, 'Bacterial microcompartment shell protein, EutL/PduB type', 'EutL_PduB', 4, NULL),
(9912, NULL, 'IPR012771', NULL, 'Trehalose operon repressor', 'Trehalos_R_gpbac', 4, NULL),
(9913, NULL, 'IPR009017', NULL, 'Green fluorescent protein', 'GFP', 5, NULL),
(9914, NULL, 'IPR012615', NULL, 'Trematode Eggshell Synthesis', 'TES', 4, NULL),
(9915, NULL, 'IPR009191', NULL, 'Diol dehydratase-reactivating factor large subunit', 'DDRA', 4, NULL),
(9916, NULL, 'IPR009024', NULL, 'Methyl-coenzyme M reductase, ferredoxin-like fold', 'Me_CoM_Rdtase_Fd-like_fold', 5, NULL),
(9917, NULL, 'IPR014476', NULL, 'AT-hook motif nuclear-localized protein 15-29', 'AHL15-29', 4, NULL),
(9918, NULL, 'IPR023823', NULL, 'Conserved hypothetical protein CHP04066, peptide maturation system', 'CHP04066_peptide_maturation', 4, NULL),
(9919, NULL, 'IPR015115', NULL, 'Centromere protein CENP-B, C-terminal domain', 'CenpB_C', 3, NULL),
(9920, NULL, 'IPR008987', NULL, 'Baseplate structural protein Gp9/Gp10', 'Baseplate_struct_prot_Gp9/10', 4, NULL),
(9921, NULL, 'IPR012621', NULL, 'Mitochondrial import receptor subunit TOM7', 'Tom7', 4, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(9922, NULL, 'IPR015134', NULL, 'Calcineurin-binding protein cabin-1, MEF2-binding domain', 'MEF2-bd', 3, NULL),
(9923, NULL, 'IPR014448', NULL, 'Anti-adapter protein IraM', 'Anti-adapter_IraM', 4, NULL),
(9924, NULL, 'IPR014455', NULL, 'DNA methylase, N-6 adenine-specific, MK1259 type', 'N6_adenine_Mtase_MK1259', 4, NULL),
(9925, NULL, 'IPR010697', NULL, 'YspA SLOG family', 'YspA', 4, NULL),
(9926, NULL, 'IPR009012', NULL, 'GrpE nucleotide exchange factor, head', 'GrpE_head', 5, NULL),
(9927, NULL, 'IPR015160', NULL, 'Heat-stable enterotoxin B, secretory', 'STb_secrete', 4, NULL),
(9928, NULL, 'IPR009155', NULL, 'Cytochrome b562', 'Cyt_b562', 4, NULL),
(9929, NULL, 'IPR010713', NULL, 'Xyloglucan endo-transglycosylase, C-terminal', 'XET_C', 3, NULL),
(9930, NULL, 'IPR015120', NULL, 'Siah interacting protein, N-terminal', 'Siah-Interact_N', 3, NULL),
(9931, NULL, 'IPR012759', NULL, 'RNA polymerase sigma factor RpoH, proteobacteria', 'RNA_pol_sigma_RpoH_proteobac', 4, NULL),
(9932, NULL, 'IPR015171', NULL, 'Cyclomaltodextrinase, N-terminal', 'Cyc-maltodext_N', 3, NULL),
(9933, NULL, 'IPR014316', NULL, 'Trimethylamine N-oxide reductase system, TorE', 'TMAO_TorE', 4, NULL),
(9934, NULL, 'IPR009192', NULL, 'Diol/glycerol dehydratase reactivating factor, small subunit', 'Diol/glycerol_deHydtase_re_ssu', 4, NULL),
(9935, NULL, 'IPR009175', NULL, 'Poxvirus I2', 'Poxvirus_I2', 4, NULL),
(9936, NULL, 'IPR013518', NULL, 'Potassium channel, inwardly rectifying, Kir, cytoplasmic', 'K_chnl_inward-rec_Kir_cyto', 5, NULL),
(9937, NULL, 'IPR014312', NULL, 'Succinate dehydrogenase, hydrophobic membrane anchor', 'Succ_DH_anchor', 4, NULL),
(9938, NULL, 'IPR008988', NULL, 'Transcriptional repressor, C-terminal', 'Transcriptional_repressor_C', 5, NULL),
(9939, NULL, 'IPR009183', NULL, 'Uncharacterised conserved protein UCP004962', 'UCP004962', 4, NULL),
(9940, NULL, 'IPR034106', NULL, 'Peptidyl-Lys endopeptidase-like domain', 'M35_peptidyl-Lys-like', 3, NULL),
(9941, NULL, 'IPR009525', NULL, 'Protein of unknown function DUF1145', 'DUF1145', 4, NULL),
(9942, NULL, 'IPR009154', NULL, 'Membrane-bound tetrahaem cytochrome TorC/YecK', 'Membr-bd_4haem_cyt_TorC', 4, NULL),
(9943, NULL, 'IPR014298', NULL, 'RNA polymerase sigma-X type', 'RNA_pol_sigma-X', 4, NULL),
(9944, NULL, 'IPR016007', NULL, 'Alpha-L-rhamnosidase', 'Alpha_rhamnosid', 4, NULL),
(9945, NULL, 'IPR024690', NULL, 'Nitrile hydratase beta subunit domain', 'CN_hydtase_beta_dom', 3, NULL),
(9946, NULL, 'IPR010742', NULL, 'Respirasome Complex Assembly Factor 1', 'RCAF1', 4, NULL),
(9947, NULL, 'IPR015123', NULL, 'Bcr-Abl oncoprotein oligomerisation', 'Bcr-Abl_oncoprot_oligo', 3, NULL),
(9948, NULL, 'IPR014625', NULL, 'Filoviruses glycoprotein', 'GPC_FiloV', 4, NULL),
(9949, NULL, 'IPR015131', NULL, 'Killer toxin, Kp4', 'Killer_tox_Kp4', 3, NULL),
(9950, NULL, 'IPR012630', NULL, 'Hefutoxin', 'Toxin_25', 4, NULL),
(9951, NULL, 'IPR009031', NULL, 'Carbohydrate binding module family 10', 'CBM_fam10', 3, NULL),
(9952, NULL, 'IPR009198', NULL, 'Uncharacterised conserved protein UCP014484, transmembrane', 'UCP014484_TM', 4, NULL),
(9953, NULL, 'IPR010744', NULL, 'Bacteriophage CI repressor, N-terminal', 'Phage_CI_N', 3, NULL),
(9954, NULL, 'IPR015150', NULL, 'Haemadin', 'Haemadin', 4, NULL),
(9955, NULL, 'IPR012785', NULL, 'Protocatechuate 3,4-dioxygenase, beta subunit', 'Protocat_dOase_b', 4, NULL),
(9956, NULL, 'IPR024695', NULL, 'Uncharacterised conserved protein, UCP038861', 'UCP038861', 4, NULL),
(9957, NULL, 'IPR009172', NULL, 'Orthopoxvirus C13', 'Orthopox_C13', 4, NULL),
(9958, NULL, 'IPR010752', NULL, 'Protein of unknown function DUF1329', 'DUF1329', 4, NULL),
(9959, NULL, 'IPR016008', NULL, 'Amine dehydrogenase light chain', 'Amine_DH_Ltc', 4, NULL),
(9960, NULL, 'IPR024158', NULL, 'Mitochondrial import protein TIM15', 'Mt_import_TIM15', 4, NULL),
(9961, NULL, 'IPR009181', NULL, 'Uncharacterised conserved protein UCP004929, methanogenesis', 'UCP004929_methan', 4, NULL),
(9962, NULL, 'IPR009157', NULL, 'Ferredoxin zinc-binding', 'Fd_Zn-bd', 4, NULL),
(9963, NULL, 'IPR010707', NULL, 'Protein of unknown function DUF1285', 'DUF1285', 4, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(9964, NULL, 'IPR015125', NULL, 'Tumour suppressor p53-binding protein-1 Tudor domain', '53-BP1_Tudor', 3, NULL),
(9965, NULL, 'IPR014469', NULL, 'Protein of unknown function DUF2271', 'DUF2271', 4, NULL),
(9966, NULL, 'IPR008983', NULL, 'Tumour necrosis factor-like domain superfamily', 'Tumour_necrosis_fac-like_dom', 5, NULL),
(9967, NULL, 'IPR009013', NULL, 'Attachment protein shaft domain superfamily', 'Attachment_protein_shaft_sf', 5, NULL),
(9968, NULL, 'IPR011621', NULL, 'Metal-dependent phosphohydrolase, 7TM intracellular domain', 'Metal-dep_PHydrolase_7TM_intra', 3, NULL),
(9969, NULL, 'IPR012619', NULL, 'Myoactive tetradecapeptides', 'Tetradecapep', 4, NULL),
(9970, NULL, 'IPR012755', NULL, 'DNA-directed RNA polymerase, subunit gamma', 'DNA-dir_RpoC1_gamma', 4, NULL),
(9971, NULL, 'IPR012629', NULL, 'Conotoxin TVIIAGS', 'Conotoxin_TVIIAGS', 4, NULL),
(9972, NULL, 'IPR035328', NULL, 'Protein of unknown function DUF3048, C-terminal domain', 'DUF3048_C', 3, NULL),
(9973, NULL, 'IPR015828', NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 10, mitochondrial', 'NDUFA10', 4, NULL),
(9974, NULL, 'IPR012781', NULL, 'D-fructose-responsive transcription factor', 'Fruct_sucro_rep', 4, NULL),
(9975, NULL, 'IPR014620', NULL, 'Thymidylate synthase, archaea', 'Thymidylate_synthase_arc', 4, NULL),
(9976, NULL, 'IPR010761', NULL, 'Clc protein-like', 'Clc_prot-like', 4, NULL),
(9977, NULL, 'IPR010721', NULL, 'Probable O-methyltransferase UstE-like', 'UstE-like', 4, NULL),
(9978, NULL, 'IPR015929', NULL, 'Aconitase B, swivel', 'Aconitase_B_swivel', 3, NULL),
(9979, NULL, 'IPR014458', NULL, 'Uncharacterised protein family, phage P2-GpU-fusion', 'Unchr_Phage_P2-GpU-fusion', 4, NULL),
(9980, NULL, 'IPR009179', NULL, 'Protein E3', 'E3L', 4, NULL),
(9981, NULL, 'IPR008995', NULL, 'Molybdate/tungstate binding, C-terminal', 'Mo/tungstate-bd_C_term_dom', 5, NULL),
(9982, NULL, 'IPR015164', NULL, 'K cyclin, C-terminal', 'K-cyclin_C', 3, NULL),
(9983, NULL, 'IPR035373', NULL, 'Alpha galactosidase A, C-terminal beta-sandwich domain', 'Melibiase/NAGA_C', 3, NULL),
(9984, NULL, 'IPR034730', NULL, 'ATP-dependent RNA helicase DHX29', 'DHX29', 4, NULL),
(9985, NULL, 'IPR015149', NULL, 'Thrombomodulin-like, EGF-like', 'Tme5_EGF-like', 3, NULL),
(9986, NULL, 'IPR013875', NULL, 'Mitochondrial import protein Pam17', 'Pam17', 4, NULL),
(9987, NULL, 'IPR014322', NULL, 'RNA polymerase sigma-B/F/G type', 'RNA_pol_sigma-B/F/G', 4, NULL),
(9988, NULL, 'IPR013859', NULL, 'SWI/SNF and RSC complexes subunit Ssr4, N-terminal', 'Ssr4_N', 3, NULL),
(9989, NULL, 'IPR009199', NULL, 'PhoPQ-activated pathogenicity-related protein, PqaA type', 'PhoPQ-act_pathogen-rel_PqaA', 4, NULL),
(9990, NULL, 'IPR008991', NULL, 'Translation protein SH3-like domain superfamily', 'Translation_prot_SH3-like_sf', 5, NULL),
(9991, NULL, 'IPR012778', NULL, 'Peptidase M1, aminopeptidase', 'Pept_M1_aminopeptidase', 4, NULL),
(9992, NULL, 'IPR009023', NULL, 'Hydroxymethylglutaryl-CoA reductase, class I/II, NAD/NADP-binding domain superfamily', 'HMG_CoA_Rdtase_NAD(P)-bd_sf', 5, NULL),
(9993, NULL, 'IPR015132', NULL, 'L27-2', 'L27_2', 3, NULL),
(9994, NULL, 'IPR012787', NULL, 'Pca transcription factor PcaQ', 'TF_PcaQ', 4, NULL),
(9995, NULL, 'IPR009170', NULL, 'PR domain zinc finger protein 2', 'PRDM2', 4, NULL),
(9996, NULL, 'IPR009027', NULL, 'Ribosomal protein L9/RNase H1, N-terminal', 'Ribosomal_L9/RNase_H1_N', 5, NULL),
(9997, NULL, 'IPR035324', NULL, 'Protein of unknown function DUF5381', 'DUF5381', 4, NULL),
(9998, NULL, 'IPR023822', NULL, 'Radical SAM, TatD-associated, bacteria', 'rSAM_TatD-assoc_bac', 4, NULL),
(9999, NULL, 'IPR015162', NULL, 'CheY binding', 'CheY-binding', 3, NULL),
(10000, NULL, 'IPR009011', NULL, 'Mannose-6-phosphate receptor binding domain superfamily', 'Man6P_isomerase_rcpt-bd_dom_sf', 5, NULL),
(10001, NULL, 'IPR012644', NULL, 'Conserved hypothetical protein CHP02300, FYDLN acid', 'CHP02300_FYDLN_acid', 4, NULL),
(10002, NULL, 'IPR007488', NULL, 'Protein of unknown function DUF535', 'DUF535', 4, NULL),
(10003, NULL, 'IPR011307', NULL, 'Tetrahydromethanopterin S-methyltransferase, subunit F', 'MeTrfase_F', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(10004, NULL, 'IPR013464', NULL, 'Conserved hypothetical protein CHP02642', 'CHP02642', 4, NULL),
(10005, NULL, 'IPR012649', NULL, 'Phosphonopyruvate hydrolase', 'PPH', 4, NULL),
(10006, NULL, 'IPR011302', NULL, 'Iron-binding protein IscA, proteobacteria', 'IscA_proteobacteria', 4, NULL),
(10007, NULL, 'IPR011281', NULL, 'Succinate dehydrogenase, flavoprotein subunit', 'Succ_DH_flav_su_fwd', 4, NULL),
(10008, NULL, 'IPR012645', NULL, 'Conserved hypothetical protein CHP02301', 'CHP02301', 4, NULL),
(10009, NULL, 'IPR009565', NULL, 'Protein of unknown function DUF1180', 'DUF1180', 4, NULL),
(10010, NULL, 'IPR009558', NULL, 'Protein of unknown function DUF1175', 'DUF1175', 4, NULL),
(10011, NULL, 'IPR015841', NULL, 'RNA-directed RNA polymerase, tospovirus', 'RNA-dir_pol_tospovirus', 4, NULL),
(10012, NULL, 'IPR005079', NULL, 'Peptidase C45', 'Peptidase_C45', 4, NULL),
(10013, NULL, 'IPR006129', NULL, 'Adhesin B', 'AdhesinB', 4, NULL),
(10014, NULL, 'IPR010455', NULL, 'Bacteriophage 82, GpQ', 'Phage_82_GpQ', 4, NULL),
(10015, NULL, 'IPR011289', NULL, 'Fructose-1,6-bisphosphate aldolase, class 2', 'Fruc_bis_ald_class-2', 4, NULL),
(10016, NULL, 'IPR006113', NULL, '6-phosphogluconate dehydrogenase, decarboxylating', '6PGDH_Gnd/GntZ', 4, NULL),
(10017, NULL, 'IPR009200', NULL, 'Protein of unknown function DUF1269, membrane associated', 'DUF1269_membrane', 4, NULL),
(10018, NULL, 'IPR023178', NULL, 'Orbivirus inner capsid protein VP7, C-terminal', 'Orbi_VP7_capsid_C', 5, NULL),
(10019, NULL, 'IPR034140', NULL, 'Ecto-NOX disulfide-thiol exchanger, RNA recognition motif', 'ENOX_RRM', 3, NULL),
(10020, NULL, 'IPR013990', NULL, 'Water stress and hypersensitive response domain', 'WHy-dom', 3, NULL),
(10021, NULL, 'IPR009561', NULL, 'Protein of unknown function DUF1177', 'DUF1177', 4, NULL),
(10022, NULL, 'IPR012650', NULL, 'Conserved hypothetical protein CHP02328', 'CHP02328', 4, NULL),
(10023, NULL, 'IPR006149', NULL, 'EB domain', 'EB_dom', 3, NULL),
(10024, NULL, 'IPR009148', NULL, 'Streptococcal non-M secreted SibA', 'SibA', 4, NULL),
(10025, NULL, 'IPR010497', NULL, 'Epoxide hydrolase, N-terminal', 'Epoxide_hydro_N', 3, NULL),
(10026, NULL, 'IPR010465', NULL, 'DRF autoregulatory', 'Drf_DAD', 3, NULL),
(10027, NULL, 'IPR011278', NULL, '2-methylcitrate synthase/citrate synthase type I', '2-MeCitrate/Citrate_synth_II', 4, NULL),
(10028, NULL, 'IPR016088', NULL, 'Chalcone isomerase, 3-layer sandwich', 'Chalcone_isomerase_3-sand', 5, NULL),
(10029, NULL, 'IPR011066', NULL, 'Mechanosensitive ion channel MscS, C-terminal', 'MscS_channel_C', 5, NULL),
(10030, NULL, 'IPR010921', NULL, 'Trp repressor/replication initiator', 'Trp_repressor/repl_initiator', 5, NULL),
(10031, NULL, 'IPR013478', NULL, 'Methylamine dehydrogenase accessory protein MauD', 'MeN_DH_accessory', 4, NULL),
(10032, NULL, 'IPR011316', NULL, 'Predicted [NiFe]-hydrogenase-3-type complex Eha, membrane protein EhaC', 'Prd_NiFe_hyd_3_EhaC', 4, NULL),
(10033, NULL, 'IPR014330', NULL, 'RNA-binding S4-related,YaaA', 'RNA-bd_S4-rel_YaaA', 4, NULL),
(10034, NULL, 'IPR006135', NULL, 'Type III secretion system substrate exporter', 'T3SS_substrate_exporter', 4, NULL),
(10035, NULL, 'IPR013490', NULL, 'CRISPR-associated RAMP Csx10', 'CRISPR-assoc_RAMP_Csx10', 4, NULL),
(10036, NULL, 'IPR006144', NULL, 'Secretion protein HlyD, conserved site', 'Secretion_HlyD_CS', 2, NULL),
(10037, NULL, 'IPR011599', NULL, 'Prefoldin alpha subunit, archaea-type', 'PFD_alpha_archaea', 4, NULL),
(10038, NULL, 'IPR011768', NULL, 'Translation elongation factor P', 'Transl_elongation_fac_P', 4, NULL),
(10039, NULL, 'IPR012999', NULL, 'Pyridine nucleotide-disulphide oxidoreductase, class I, active site', 'Pyr_OxRdtase_I_AS', 0, NULL),
(10040, NULL, 'IPR011074', NULL, 'CRAL/TRIO, N-terminal domain', 'CRAL/TRIO_N_dom', 3, NULL),
(10041, NULL, 'IPR016087', NULL, 'Chalcone isomerase', 'Chalcone_isomerase', 3, NULL),
(10042, NULL, 'IPR012634', NULL, 'PhTx neurotoxin', 'Toxin_29', 4, NULL),
(10043, NULL, 'IPR023941', NULL, 'Glutathione-regulated potassium-efflux system protein KefC', 'K_H_efflux_KefC', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(10044, NULL, 'IPR015837', NULL, 'Uncharacterised conserved protein UCP026622, CAAX protease-type', 'UCP026622_CAAX_protease', 4, NULL),
(10045, NULL, 'IPR009138', NULL, 'Neural cell adhesion', 'Neural_cell_adh', 4, NULL),
(10046, NULL, 'IPR023884', NULL, 'Colanic acid biosynthesis, glycosyl transferase, WcaL', 'Colanic_acid_synth_WcaL', 4, NULL),
(10047, NULL, 'IPR016085', NULL, 'Protease inhibitor, beta-barrel domain', 'Protease_inh_b-brl_dom', 5, NULL),
(10048, NULL, 'IPR009121', NULL, 'Beta-secretase BACE2', 'BACE2', 4, NULL),
(10049, NULL, 'IPR011994', NULL, 'Cytidylate kinase domain', 'Cytidylate_kinase_dom', 3, NULL),
(10050, NULL, 'IPR011279', NULL, 'Chorismate mutase, Gram-positive', 'Chorismate_mutase_GmP', 3, NULL),
(10051, NULL, 'IPR006108', NULL, '3-hydroxyacyl-CoA dehydrogenase, C-terminal', '3HC_DH_C', 3, NULL),
(10052, NULL, 'IPR014335', NULL, 'Ectoine utilization protein EutD', 'Ectoine_EutD', 4, NULL),
(10053, NULL, 'IPR023717', NULL, 'Prolyl-tRNA synthetase, class IIa, type 1', 'Pro-tRNA-Synthase_IIa_type1', 4, NULL),
(10054, NULL, 'IPR023716', NULL, 'Proline-tRNA ligase, class IIa, type 2', 'Prolyl-tRNA_ligase_IIa_type2', 4, NULL),
(10055, NULL, 'IPR015834', NULL, 'Uncharacterised conserved protein UCP016642', 'UCP016642', 4, NULL),
(10056, NULL, 'IPR009117', NULL, 'Annexin A14,  fungal', 'ANX14', 4, NULL),
(10057, NULL, 'IPR034835', NULL, 'Beta-amylase, CBM20 domain', 'CBM20_beta_amylase', 3, NULL),
(10058, NULL, 'IPR007504', NULL, 'H/ACA ribonucleoprotein complex, subunit Gar1/Naf1', 'H/ACA_rnp_Gar1/Naf1', 4, NULL),
(10059, NULL, 'IPR011293', NULL, 'Ion-translocating oxidoreductase complex, subunit  RnfA/RsxA', 'Ion_transpt_RnfA/RsxA', 4, NULL),
(10060, NULL, 'IPR006142', NULL, 'Intein', 'INTEIN', 3, NULL),
(10061, NULL, 'IPR023562', NULL, 'Clp protease proteolytic subunit /Translocation-enhancing protein TepA', 'ClpP/TepA', 4, NULL),
(10062, NULL, 'IPR012004', NULL, 'Pyrophosphate-dependent phosphofructokinase TP0108-type', 'PyroP-dep_PFK_TP0108', 4, NULL),
(10063, NULL, 'IPR009125', NULL, 'ATP synthase membrane subunit K', 'ATPMK', 4, NULL),
(10064, NULL, 'IPR009221', NULL, 'Corrinoid adenosyltransferase PduO', 'PduO', 4, NULL),
(10065, NULL, 'IPR035298', NULL, '26S Proteasome non-ATPase regulatory subunit 13', 'PSMD13', 4, NULL),
(10066, NULL, 'IPR023563', NULL, 'Ribosomal protein L13, conserved site', 'Ribosomal_L13_CS', 2, NULL),
(10067, NULL, 'IPR012638', NULL, 'Tryptophan leader peptide', 'Trp_leader1', 4, NULL),
(10068, NULL, 'IPR015838', NULL, 'Uncharacterised conserved protein UCP027923, rubrerythrin-type', 'UCP027923_rubrerythrin', 4, NULL),
(10069, NULL, 'IPR006116', NULL, '2-5OAS/ClassI-CCAase, nucleotidyltransferase domain', 'NT_2-5OAS_ClassI-CCAase', 3, NULL),
(10070, NULL, 'IPR014488', NULL, 'Uncharacterised conserved protein UCP017371', 'UCP017371', 4, NULL),
(10071, NULL, 'IPR023740', NULL, 'Spermidine export protein MdtJ', 'Spermidine_export_MdtJ', 4, NULL),
(10072, NULL, 'IPR006146', NULL, '5''-Nucleotidase, conserved site', '5''-Nucleotdase_CS', 2, NULL),
(10073, NULL, 'IPR010503', NULL, 'Type II heat-labile enterotoxin, B subunit', 'LT-IIB', 4, NULL),
(10074, NULL, 'IPR024109', NULL, 'Tryptophan-tRNA ligase, bacterial-type', 'Trp-tRNA-ligase_bac-type', 4, NULL),
(10075, NULL, 'IPR006120', NULL, 'Resolvase, HTH domain', 'Resolvase_HTH_dom', 3, NULL),
(10076, NULL, 'IPR013991', NULL, 'PhnA protein N-terminal, proteobacterial', 'PhnaA_N_proteobac', 3, NULL),
(10077, NULL, 'IPR007484', NULL, 'Peptidase M28', 'Peptidase_M28', 3, NULL),
(10078, NULL, 'IPR011295', NULL, '2-polyprenyl-6-methoxyphenol 4-hydroxylase', 'UbiH', 4, NULL),
(10079, NULL, 'IPR013479', NULL, 'ADP-ribosyl-dinitrogen reductase hydrolase', 'ADP-ribosyl_diN_reduct_hydro', 4, NULL),
(10080, NULL, 'IPR012637', NULL, 'Waglerin', 'Toxin_33', 4, NULL),
(10081, NULL, 'IPR010977', NULL, 'Aromatic-L-amino-acid decarboxylase', 'Aromatic_deC', 4, NULL),
(10082, NULL, 'IPR014614', NULL, 'Uncharacterised conserved protein UCP036654', 'UCP036654', 4, NULL),
(10083, NULL, 'IPR035301', NULL, 'L1 transposable element, trimerization domain', 'L1_trimer', 3, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(10084, NULL, 'IPR010472', NULL, 'Formin, FH3 domain', 'FH3_dom', 3, NULL),
(10085, NULL, 'IPR013491', NULL, 'Tape measure protein N-terminal', 'Tape_meas_N', 3, NULL),
(10086, NULL, 'IPR014331', NULL, 'RNA polymerase sigma-70 ECF-like, Rhodopirellula baltica', 'RNA_pol_sigma70_ECF_RHOBA', 4, NULL),
(10087, NULL, 'IPR009206', NULL, 'Nucleotidase, putative', 'Nucleotidase_putative', 4, NULL),
(10088, NULL, 'IPR015840', NULL, 'DNA methyase, ParB domain-containing', 'DNA_MeTrfase_ParB', 4, NULL),
(10089, NULL, 'IPR010445', NULL, 'Lipopolysaccharide assembly protein A domain', 'LapA_dom', 3, NULL),
(10090, NULL, 'IPR005072', NULL, 'Peptidase M44, metalloendopeptidase G1', 'Peptidase_M44', 4, NULL),
(10091, NULL, 'IPR012635', NULL, 'Parabutoxin', 'Parabutoxin', 4, NULL),
(10092, NULL, 'IPR012653', NULL, 'Dimethylamine methyltransferase MtbB', 'Dimeth_MeTrfase_MtbB', 4, NULL),
(10093, NULL, 'IPR013473', NULL, 'Lon-like protease BrxL', 'BrxL', 4, NULL),
(10094, NULL, 'IPR007487', NULL, 'ABC transporter, substrate-binding protein', 'ABC_transpt-bd', 4, NULL),
(10095, NULL, 'IPR005097', NULL, 'Saccharopine dehydrogenase, NADP binding domain', 'Sacchrp_dh_NADP', 3, NULL),
(10096, NULL, 'IPR006158', NULL, 'Cobalamin (vitamin B12)-binding domain', 'Cobalamin-bd', 3, NULL),
(10097, NULL, 'IPR011311', NULL, 'Predicted [NiFe]-hydrogenase-3-type complex Eha, membrane protein EhaG', 'Prd_NiFe_hyd_3_EhaG', 4, NULL),
(10098, NULL, 'IPR012681', NULL, 'Nucleobase cation symporter-1, NCS1', 'NCS1', 4, NULL),
(10099, NULL, 'IPR012657', NULL, '23S rRNA-intervening sequence protein', '23S_rRNA-intervening_sequence', 4, NULL),
(10100, NULL, 'IPR009147', NULL, 'Cystic fibrosis transmembrane conductance regulator', 'CFTR/ABCC7', 4, NULL),
(10101, NULL, 'IPR006122', NULL, 'Heavy metal-associated domain, copper ion-binding', 'HMA_Cu_ion-bd', 3, NULL),
(10102, NULL, 'IPR009532', NULL, 'SepQ', 'SepQ', 4, NULL),
(10103, NULL, 'IPR011284', NULL, '3-oxoacyl-(acyl-carrier-protein) reductase', '3oxo_ACP_reduc', 4, NULL),
(10104, NULL, 'IPR013475', NULL, 'Amicyanin, Paracoccus/Methylobacterium', 'Amicyanin_Para/Methyl', 4, NULL),
(10105, NULL, 'IPR016055', NULL, 'Alpha-D-phosphohexomutase, alpha/beta/alpha I/II/III', 'A-D-PHexomutase_a/b/a-I/II/III', 5, NULL),
(10106, NULL, 'IPR010443', NULL, 'Restriction endonuclease, type II, Tsp45I', 'Restrct_endonuc_II_Tsp45I', 4, NULL),
(10107, NULL, 'IPR009533', NULL, 'FAM107', 'FAM107', 4, NULL),
(10108, NULL, 'IPR009141', NULL, 'Wnt-3 protein', 'Wnt3', 4, NULL),
(10109, NULL, 'IPR034882', NULL, 'CENP-B, dimerisation domain superfamily', 'Dimerisation_CENP-B_sf', 5, NULL),
(10110, NULL, 'IPR006168', NULL, 'Glycerol-3-phosphate dehydrogenase, NAD-dependent', 'G3P_DH_NAD-dep', 4, NULL),
(10111, NULL, 'IPR006127', NULL, 'Periplasmic solute binding protein, ZnuA-like', 'ZnuA-like', 4, NULL),
(10112, NULL, 'IPR009530', NULL, 'Protein of unknown function DUF1149', 'DUF1149', 4, NULL),
(10113, NULL, 'IPR007480', NULL, 'Protein of unknown function DUF529', 'DUF529', 7, NULL),
(10114, NULL, 'IPR010474', NULL, 'AP-3 complex subunit delta domain, metazoa', 'AP3D_dom_metazoa', 3, NULL),
(10115, NULL, 'IPR007503', NULL, 'Protein of unknown function DUF530', 'DUF530', 4, NULL),
(10116, NULL, 'IPR010500', NULL, 'Hepcidin', 'Hepcidin', 4, NULL),
(10117, NULL, 'IPR015835', NULL, 'Hydroxymethyl pyrimidine (HMP)/thiamine binding protein', 'HMP/thiamine-bd', 4, NULL),
(10118, NULL, 'IPR014491', NULL, 'Curli production protein CsgC', 'Curli_production_prot_CsgC', 4, NULL),
(10119, NULL, 'IPR014339', NULL, 'Regulator of ribonuclease activity A, gammaproteobacteria', 'RraA_gpbac', 4, NULL),
(10120, NULL, 'IPR014334', NULL, 'Ectoine utilization protein EutC', 'Ectoine_EutC', 4, NULL),
(10121, NULL, 'IPR011288', NULL, 'D-tagatose-bisphosphate aldolase, class II, subunit KbaY/GatY', 'TagBP_ald_KbaY/GatY', 4, NULL),
(10122, NULL, 'IPR011301', NULL, 'PTS system, maltose/glucose-specific IIBC component', 'PTS_Mal/Glc-sp_IIBC_component', 4, NULL),
(10123, NULL, 'IPR005080', NULL, 'Peptidase A25, germination protease', 'Peptidase_A25', 4, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(10124, NULL, 'IPR011275', NULL, 'Malate dehydrogenase, type 3', 'Malate_DH_type3', 4, NULL),
(10125, NULL, 'IPR015844', NULL, 'Pantothenate kinase, acetyl-CoA regulated, two-domain type', 'PanK_long', 4, NULL),
(10126, NULL, 'IPR013485', NULL, 'Molybdenum cofactor biosynthesis protein A, archaea', 'MoaA_arc', 4, NULL),
(10127, NULL, 'IPR023132', NULL, 'Sama2622-like superfamily', 'Sama2622-like_sf', 5, NULL),
(10128, NULL, 'IPR011070', NULL, 'Globular protein, non-globular alpha/beta subunit', 'Globular_prot_asu/bsu', 5, NULL),
(10129, NULL, 'IPR010461', NULL, 'Competence protein ComK', 'ComK', 4, NULL),
(10130, NULL, 'IPR011063', NULL, 'tRNA(Ile)-lysidine/2-thiocytidine synthase, N-terminal', 'TilS/TtcA_N', 3, NULL),
(10131, NULL, 'IPR005083', NULL, 'Serine/Threonine acetyltransferase, YopJ', 'Ser/Thr_AcTrfase', 4, NULL),
(10132, NULL, 'IPR011300', NULL, 'Phosphotransferase system, IIBC component', 'PTS_IIBC', 3, NULL),
(10133, NULL, 'IPR016057', NULL, 'Pheromone Er-2/Er-23, protozoan', 'Pheromone_Er2/Er23_protoz', 5, NULL),
(10134, NULL, 'IPR009566', NULL, 'Protein of unknown function DUF1181', 'DUF1181', 4, NULL),
(10135, NULL, 'IPR007506', NULL, 'Aconitase X catalytic domain, putative', 'AcnX_catalytic_put', 3, NULL),
(10136, NULL, 'IPR010462', NULL, 'Ectoine synthase', 'Ectoine_synth', 4, NULL),
(10137, NULL, 'IPR007486', NULL, 'Inner membrane protein YebE', 'YebE', 4, NULL),
(10138, NULL, 'IPR010451', NULL, 'Acetoacetate decarboxylase', 'Acetoacetate_decarboxylase', 4, NULL),
(10139, NULL, 'IPR010511', NULL, 'Lytic murein transglycosylase D , lipid attachment domain', 'MltD_lipid-attach', 3, NULL),
(10140, NULL, 'IPR009205', NULL, 'Predicted archaeal flagellar protein C', 'FlaC_arc', 4, NULL),
(10141, NULL, 'IPR009560', NULL, 'Protein of unknown function DUF1176', 'DUF1176', 4, NULL),
(10142, NULL, 'IPR009540', NULL, 'Basal layer antifungal peptide', 'BAP', 4, NULL),
(10143, NULL, 'IPR011292', NULL, 'Na(+)-translocating NADH-quinone reductase subunit D', 'NqrD', 4, NULL),
(10144, NULL, 'IPR012640', NULL, 'Membrane lipoprotein, lipid attachment site', 'Membr_lipoprot_lipid_attach_CS', 2, NULL),
(10145, NULL, 'IPR015967', NULL, 'Recombination protein RecR, conserved site', 'Rcmb_RecR_CS', 2, NULL),
(10146, NULL, 'IPR013489', NULL, 'CRISPR-associated protein Csm6', 'CRISPR-assoc_prot_Csm6', 4, NULL),
(10147, NULL, 'IPR034852', NULL, 'NBR1, PB1 domain', 'PB1_NBR1', 3, NULL),
(10148, NULL, 'IPR006169', NULL, 'GTP1/OBG domain', 'GTP1_OBG_dom', 3, NULL),
(10149, NULL, 'IPR009203', NULL, 'Knr4/Smi1 family', 'Knr4/Smi1', 4, NULL),
(10150, NULL, 'IPR010916', NULL, 'TonB box, conserved site', 'TonB_box_CS', 2, NULL),
(10151, NULL, 'IPR009135', NULL, 'Vascular endothelial growth factor receptor 1 (VEGFR1)', 'VEGFR1_rcpt', 4, NULL),
(10152, NULL, 'IPR016082', NULL, 'Ribosomal protein L30, ferredoxin-like fold domain', 'Ribosomal_L30_ferredoxin-like', 3, NULL),
(10153, NULL, 'IPR011067', NULL, 'Plasmid maintenance toxin/Cell growth inhibitor', 'Plasmid_toxin/cell-grow_inhib', 5, NULL),
(10154, NULL, 'IPR012006', NULL, 'tRNA nucleotidyltransferase, proteobacteria', 'CCA_bact', 4, NULL),
(10155, NULL, 'IPR013467', NULL, 'Retron Ec78 putative HNH endonuclease-like', 'HNH78-like', 4, NULL),
(10156, NULL, 'IPR007498', NULL, 'Intermembrane transport protein PqiA-like', 'PqiA-like', 4, NULL),
(10157, NULL, 'IPR010495', NULL, 'Haem-binding HasA', 'HasA_haem-bd', 4, NULL),
(10158, NULL, 'IPR009142', NULL, 'Wnt-4 protein', 'Wnt4', 4, NULL),
(10159, NULL, 'IPR009201', NULL, 'Virion core protein, vaccinia E11L type', 'Virion_core', 4, NULL),
(10160, NULL, 'IPR009538', NULL, 'Plasmalemma vesicle-associated protein', 'PV-1', 4, NULL),
(10161, NULL, 'IPR007492', NULL, 'LytTR DNA-binding domain', 'LytTR_DNA-bd_dom', 3, NULL),
(10162, NULL, 'IPR006136', NULL, 'Flagellar biosynthetic protein FlhB', 'FlhB', 4, NULL),
(10163, NULL, 'IPR011540', NULL, 'AbgT, Proteobacteria', 'AbgT_Proteobac', 4, NULL),
(10164, NULL, 'IPR007483', NULL, 'Hamartin', 'Hamartin', 4, NULL),
(10165, NULL, 'IPR024696', NULL, 'Uncharacterised conserved protein, UCP038601', 'UCP038601', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(10166, NULL, 'IPR013471', NULL, 'Ribonuclease Z/BN', 'RNase_Z/BN', 4, NULL),
(10167, NULL, 'IPR009548', NULL, 'PRKR-interacting protein 1', 'Prkrip1', 4, NULL),
(10168, NULL, 'IPR013470', NULL, 'Ribonuclease Z, Thermotoga maritima', 'RNase_Z_THEMA', 4, NULL),
(10169, NULL, 'IPR011551', NULL, 'NTP pyrophosphohydrolase MazG', 'NTP_PyrPHydrolase_MazG', 4, NULL),
(10170, NULL, 'IPR007505', NULL, 'PD-(D/E)XK nuclease superfamily  7', 'PDDEXK_7', 4, NULL),
(10171, NULL, 'IPR009543', NULL, 'Vacuolar protein sorting-associated protein 13, VPS13 adaptor binding domain', 'VPS13_VAB', 3, NULL),
(10172, NULL, 'IPR006115', NULL, '6-phosphogluconate dehydrogenase, NADP-binding', '6PGDH_NADP-bd', 3, NULL),
(10173, NULL, 'IPR010489', NULL, 'Effector protein NleG', 'Effector_NleG', 4, NULL),
(10174, NULL, 'IPR007495', NULL, '(Na+)-NQR maturation factor NqrM', 'NqrM', 4, NULL),
(10175, NULL, 'IPR010920', NULL, 'LSM domain superfamily', 'LSM_dom_sf', 5, NULL),
(10176, NULL, 'IPR015839', NULL, 'Bifunctional chloromethane dehalogenation methyltransferase corrinoid-binding protein CmuA', 'CmuA', 4, NULL),
(10177, NULL, 'IPR009216', NULL, 'Virulence factor SrfB', 'Virulence_factor_SrfB', 4, NULL),
(10178, NULL, 'IPR006126', NULL, 'Staphylococcal enterotoxin/Streptococcal pyrogenic exotoxin, conserved site', 'Staph/Strept_toxin_CS', 2, NULL),
(10179, NULL, 'IPR005078', NULL, 'Peptidase C54', 'Peptidase_C54', 4, NULL),
(10180, NULL, 'IPR011312', NULL, 'Uncharacterised conserved protein UCP019164, methanogenesis', 'UCP019164_menthan', 4, NULL),
(10181, NULL, 'IPR010479', NULL, 'BH3-interacting domain death agonist', 'BID', 4, NULL),
(10182, NULL, 'IPR009132', NULL, 'Trace amine associated receptor family', 'TAAR_fam', 4, NULL),
(10183, NULL, 'IPR012002', NULL, 'Desulforedoxin', 'Desulforedoxin', 4, NULL),
(10184, NULL, 'IPR012647', NULL, 'RNA ligase, Rnl2', 'RNA_lig_RNL2', 4, NULL),
(10185, NULL, 'IPR023760', NULL, 'Holin-like protein CidA', 'Holin-like_CidA', 4, NULL),
(10186, NULL, 'IPR013042', NULL, 'Domain of unknown function DUF1592', 'DUF1592', 3, NULL),
(10187, NULL, 'IPR006117', NULL, '2-5-oligoadenylate synthetase, C-terminal  conserved site', '2-5OAS_C_CS', 2, NULL),
(10188, NULL, 'IPR006118', NULL, 'Recombinase, conserved site', 'Recombinase_CS', 2, NULL),
(10189, NULL, 'IPR012655', NULL, 'Uncharacterised protein YrzI', 'YrzI', 4, NULL),
(10190, NULL, 'IPR013482', NULL, 'Molybdenum cofactor guanylyltransferase', 'Molybde_CF_guanTrfase', 4, NULL),
(10191, NULL, 'IPR005084', NULL, 'Carbohydrate binding module family 6', 'CMB_fam6', 3, NULL),
(10192, NULL, 'IPR011305', NULL, 'Predicted [NiFe]-hydrogenase-3-type complex Eha, membrane protein EhaL', 'Prd_NiFe_hyd_3_EhaL', 4, NULL),
(10193, NULL, 'IPR011140', NULL, 'Autonomous glycyl radical cofactor GrcA', 'Glycyl_radical_cofactor_GrcA', 4, NULL),
(10194, NULL, 'IPR013469', NULL, 'Ribonuclease BN', 'Rnase_BN', 4, NULL),
(10195, NULL, 'IPR005093', NULL, 'RNA-directed RNA polymerase beta-chain', 'RNArep_beta', 4, NULL),
(10196, NULL, 'IPR016024', NULL, 'Armadillo-type fold', 'ARM-type_fold', 5, NULL),
(10197, NULL, 'IPR006110', NULL, 'RNA polymerase, subunit omega/Rpo6/RPB6', 'Pol_omega/Rpo6/RPB6', 4, NULL),
(10198, NULL, 'IPR016062', NULL, 'Hypothetical protein TM1410-related', 'TM1410-rel', 4, NULL),
(10199, NULL, 'IPR010512', NULL, 'Protein of unknown function DUF1091', 'DUF1091', 4, NULL),
(10200, NULL, 'IPR006128', NULL, 'Adhesion lipoprotein', 'Lipoprotein_4', 4, NULL),
(10201, NULL, 'IPR009115', NULL, 'Annexin A8', 'ANX8', 4, NULL),
(10202, NULL, 'IPR009551', NULL, 'Protein wntless', 'Wntless', 4, NULL),
(10203, NULL, 'IPR012651', NULL, 'Thiamine transporter ThiT', 'Thia_Transptr_ThiT', 4, NULL),
(10204, NULL, 'IPR023176', NULL, 'Orbivirus inner capsid protein VP7, N-terminal', 'Orbi_VP7_capsid_N', 5, NULL),
(10205, NULL, 'IPR012641', NULL, 'Cysteine rich domain, Polydnavirus', 'Polydnavirus_Cys-rich', 3, NULL),
(10206, NULL, 'IPR011149', NULL, 'DNA polymerase II small subunit, archaeal', 'Pol2_small_arc', 4, NULL),
(10207, NULL, 'IPR013465', NULL, 'Thymidine phosphorylase', 'Thymidine_Pase', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(10208, NULL, 'IPR014337', NULL, 'Ectoine/Hydroxyectoine ABC transporter, substrate-binding protein EhuB', 'Ectoine_EhuB', 4, NULL),
(10209, NULL, 'IPR024697', NULL, 'Uncharacterised conserved protein, UCP037923', 'UCP037923', 4, NULL),
(10210, NULL, 'IPR011310', NULL, 'Lipopolysaccharide core heptose(II)-phosphate phosphatase', 'LipoPS_heptP_Pase', 4, NULL),
(10211, NULL, 'IPR007499', NULL, 'Essential recombination function protein', 'ERF_bacteria_virus', 4, NULL),
(10212, NULL, 'IPR010457', NULL, 'Immunoglobulin C2-set-like, ligand-binding', 'IgC2-like_lig-bd', 3, NULL),
(10213, NULL, 'IPR034146', NULL, 'snRNP35, RNA recognition motif', 'snRNP35_RRM', 3, NULL),
(10214, NULL, 'IPR013472', NULL, 'Conserved hypothetical protein CHP02652', 'CHP02652', 4, NULL),
(10215, NULL, 'IPR011297', NULL, 'Phosphotransferase system, beta-glucoside-specific IIABC component', 'PTS_IIABC_b_glu', 4, NULL),
(10216, NULL, 'IPR014615', NULL, 'Extracellular sulfatase', 'Extracellular_sulfatase', 4, NULL),
(10217, NULL, 'IPR011143', NULL, 'Ganglioside GM2 synthase', 'GM2_synthase', 4, NULL),
(10218, NULL, 'IPR010919', NULL, 'SAND-like domain superfamily', 'SAND-like_dom_sf', 5, NULL),
(10219, NULL, 'IPR023735', NULL, 'Uncharacterised nudix hydrolase NudL', 'Nudix_NudL', 4, NULL),
(10220, NULL, 'IPR011071', NULL, 'Polysaccharide lyase family 8-like, C-terminal', 'Lyase_8-like_C', 5, NULL),
(10221, NULL, 'IPR011291', NULL, 'Peptidase M20A, peptidase V', 'Pept_M20A_peptidaseV', 4, NULL),
(10222, NULL, 'IPR009537', NULL, 'Domain of unknown function DUF1156', 'DUF1156', 3, NULL),
(10223, NULL, 'IPR011318', NULL, 'Predicted [NiFe]-hydrogenase-3-type complex Eha, membrane protein EhaI', 'Prd_NiFe_hyd_3_EhaI', 4, NULL),
(10224, NULL, 'IPR014619', NULL, 'Deoxycytidylate hydroxymethylase', 'Deoxycytidylate_hydroxyMease', 4, NULL),
(10225, NULL, 'IPR013480', NULL, 'Nitrogen fixation protein NifX', 'NifX', 4, NULL),
(10226, NULL, 'IPR009146', NULL, 'Groucho/transducin-like enhancer', 'Groucho_enhance', 4, NULL),
(10227, NULL, 'IPR014338', NULL, 'Uncharacterised domain CHP02996, repeat-companion domain', 'CHP02996_rpt-companion-dom', 3, NULL),
(10228, NULL, 'IPR011313', NULL, 'Predicted [NiFe]-hydrogenase-3-type complex Eha, membrane protein EhaF', 'Prd_NiFe_hyd_3_EhaF', 4, NULL),
(10229, NULL, 'IPR034135', NULL, 'Renin-like domain', 'Renin-like_dom', 3, NULL),
(10230, NULL, 'IPR016090', NULL, 'Phospholipase A2 domain', 'PLipase_A2_dom', 3, NULL),
(10231, NULL, 'IPR023569', NULL, 'Prokineticin domain', 'Prokineticin_domain', 3, NULL),
(10232, NULL, 'IPR016091', NULL, 'Superantigen toxin, C-terminal', 'SuperAg_toxin_C', 5, NULL),
(10233, NULL, 'IPR010470', NULL, 'Beet necrotic yellow vein virus, movement protein TGB3', 'BNYVV_TGB3', 4, NULL),
(10234, NULL, 'IPR013494', NULL, 'Conserved hypothetical protein CHP02678', 'CHP02678', 4, NULL),
(10235, NULL, 'IPR007479', NULL, 'ISC system FeS cluster assembly, IscX', 'ISC_FeS_clus_asmbl_IscsX', 4, NULL),
(10236, NULL, 'IPR012646', NULL, 'RNA ligase, DRB0094', 'RNA_ligase_DRB0094', 4, NULL),
(10237, NULL, 'IPR011583', NULL, 'Chitinase II', 'Chitinase_II', 3, NULL),
(10238, NULL, 'IPR016072', NULL, 'SKP1 component, dimerisation', 'Skp1_comp_dimer', 3, NULL),
(10239, NULL, 'IPR009133', NULL, 'Trace amine associated receptor 1', 'TAAR1', 4, NULL),
(10240, NULL, 'IPR010442', NULL, 'PET domain', 'PET_domain', 3, NULL),
(10241, NULL, 'IPR012642', NULL, 'Transcription regulator Wos2-domain', 'Tscrpt_reg_Wos2-domain', 3, NULL),
(10242, NULL, 'IPR010507', NULL, 'Zinc finger, MYM-type', 'Znf_MYM', 3, NULL),
(10243, NULL, 'IPR010493', NULL, 'Serine acetyltransferase, N-terminal', 'Ser_AcTrfase_N', 3, NULL),
(10244, NULL, 'IPR012658', NULL, 'Conserved hypothetical protein CHP02443', 'CHP02443', 4, NULL),
(10245, NULL, 'IPR005081', NULL, 'Sigma-E processing peptidase SpoIIGA', 'SpoIIGA', 4, NULL),
(10246, NULL, 'IPR023558', NULL, 'Tryptophan RNA-binding attenuator protein domain', 'Trp_RNA-bd_attenuator_dom', 3, NULL),
(10247, NULL, 'IPR011141', NULL, 'Polyketide synthase, type III', 'Polyketide_synthase_type-III', 4, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(10248, NULL, 'IPR005094', NULL, 'Endonuclease relaxase, MobA/VirD2', 'Endonuclease_MobA/VirD2', 4, NULL),
(10249, NULL, 'IPR007489', NULL, 'Domain of unknown function DUF536', 'DUF536', 3, NULL),
(10250, NULL, 'IPR011138', NULL, 'Succinate dehydrogenase cytochrome b558 subunit', 'Cytochrome_b-558', 4, NULL),
(10251, NULL, 'IPR006167', NULL, 'DNA repair protein XPF', 'XPF', 4, NULL),
(10252, NULL, 'IPR010486', NULL, 'HNS-dependent expression A/B', 'HNS-dep_expression_A/B', 4, NULL),
(10253, NULL, 'IPR011276', NULL, 'TonB-dependent haem/haemoglobin receptor', 'TonB_haem/Hb_rcpt', 4, NULL),
(10254, NULL, 'IPR006134', NULL, 'DNA-directed DNA polymerase, family B, multifunctional domain', 'DNA-dir_DNA_pol_B_multi_dom', 3, NULL),
(10255, NULL, 'IPR013468', NULL, 'Conserved hypothetical protein CHP02647', 'CHP02647', 4, NULL),
(10256, NULL, 'IPR011298', NULL, 'FeS assembly scaffold SufA, proteobacteria', 'SufA_proteobacteria', 4, NULL),
(10257, NULL, 'IPR010458', NULL, 'Trichodiene synthase, ascomycetes', 'TRI5_ascomyc', 4, NULL),
(10258, NULL, 'IPR010471', NULL, 'Protein of unknown function DUF1068', 'DUF1068', 4, NULL),
(10259, NULL, 'IPR009557', NULL, 'Repeat of unknown function DUF1174', 'DUF1174', 7, NULL),
(10260, NULL, 'IPR023732', NULL, 'Probable [Fe-S]-dependent transcriptional repressor', 'FeoC', 4, NULL),
(10261, NULL, 'IPR007507', NULL, '3-deoxy-D-manno-octulosonic-acid transferase, N-terminal', 'Glycos_transf_N', 3, NULL),
(10262, NULL, 'IPR009529', NULL, 'Maize streak virus, 13.1kDa', 'Maize_streak_virus_13.1kDa', 4, NULL),
(10263, NULL, 'IPR009126', NULL, 'Cholecystokinin receptor', 'Cholcskin_rcpt', 4, NULL),
(10264, NULL, 'IPR009536', NULL, 'Cucumber mosaic virus, OrfIIB', 'CucumberMosaicV_OrfIIB', 4, NULL),
(10265, NULL, 'IPR014333', NULL, 'Ectoine utilization protein EutB', 'Ectoine_EutB', 4, NULL),
(10266, NULL, 'IPR010498', NULL, 'Fimbrial protein SefA', 'SefA', 4, NULL),
(10267, NULL, 'IPR010502', NULL, 'Carbohydrate-binding domain, family 9', 'Carb-bd_dom_fam9', 3, NULL),
(10268, NULL, 'IPR034851', NULL, 'Dual specificity mitogen-activated protein kinase kinase 5, PB1 domain', 'PB1_MAP2K5', 3, NULL),
(10269, NULL, 'IPR009145', NULL, 'U2 auxiliary factor small subunit', 'U2AF_small', 4, NULL),
(10270, NULL, 'IPR010483', NULL, 'Alpha-2-macroglobulin RAP, C-terminal', 'Alpha_2_MRAP_C', 3, NULL),
(10271, NULL, 'IPR009118', NULL, 'Annexin D, plant', 'AnnexinD_plant', 4, NULL),
(10272, NULL, 'IPR009534', NULL, 'Protein of unknown function DUF1153', 'DUF1153', 4, NULL),
(10273, NULL, 'IPR011285', NULL, '3-oxoacyl-(acyl-carrier-protein) reductase, putative', 'FabG-rel', 4, NULL),
(10274, NULL, 'IPR013492', NULL, 'CRISPR system subtype II-B RNA-guided endonuclease Cas9/Csx12', 'CRISPR-assoc_Cas9/Csx12', 4, NULL),
(10275, NULL, 'IPR011306', NULL, 'Probable [NiFe]-hydrogenase-type-3 Eha complex membrane subunit A', 'Prd_NiFe_hyd_3_EhaA', 4, NULL),
(10276, NULL, 'IPR006109', NULL, 'Glycerol-3-phosphate dehydrogenase, NAD-dependent, C-terminal', 'G3P_DH_NAD-dep_C', 3, NULL),
(10277, NULL, 'IPR009119', NULL, 'Beta-secretase BACE', 'BACE', 4, NULL),
(10278, NULL, 'IPR006150', NULL, 'Cysteine-rich repeat', 'Cys_repeat_1', 7, NULL),
(10279, NULL, 'IPR006123', NULL, 'Staphylococcal/Streptococcal toxin, beta-grasp domain', 'Toxin_b-grasp_Staph/Strep', 3, NULL),
(10280, NULL, 'IPR011299', NULL, 'PTS system glucose-specific IIBC component', 'PTS_IIBC_glc', 3, NULL),
(10281, NULL, 'IPR013989', NULL, 'Development/cell death domain', 'Dev_and_cell_death_domain', 3, NULL),
(10282, NULL, 'IPR010453', NULL, 'RNA polymerase, arenaviral', 'RNA_pol_arenavir', 4, NULL),
(10283, NULL, 'IPR005077', NULL, 'Peptidase C11, clostripain', 'Peptidase_C11', 4, NULL),
(10284, NULL, 'IPR024741', NULL, 'Condensin-2 complex subunit G2', 'Condensin2_G2', 4, NULL),
(10285, NULL, 'IPR024224', NULL, 'DENND6', 'DENND6', 4, NULL),
(10286, NULL, 'IPR005088', NULL, 'Carbohydrate binding module family 15', 'CBM_fam15', 3, NULL),
(10287, NULL, 'IPR010491', NULL, 'PRP1 splicing factor, N-terminal', 'PRP1_N', 3, NULL),
(10288, NULL, 'IPR005090', NULL, 'Replication protein C', 'Rep_C', 4, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(10289, NULL, 'IPR006104', NULL, 'Glycosyl hydrolases family 2, sugar binding domain', 'Glyco_hydro_2_N', 3, NULL),
(10290, NULL, 'IPR012633', NULL, 'SFI toxin', 'Toxin_28', 4, NULL),
(10291, NULL, 'IPR016063', NULL, 'Extracellular protein', 'Extracellular_prot', 4, NULL),
(10292, NULL, 'IPR013823', NULL, 'Ribosomal protein L7/L12, C-terminal', 'Ribosomal_L7/L12_C', 3, NULL),
(10293, NULL, 'IPR007482', NULL, 'Protein-tyrosine phosphatase-like, PTPLA', 'Tyr_Pase-like_PTPLA', 4, NULL),
(10294, NULL, 'IPR013797', NULL, 'Maltooligosyl trehalose synthase, domain 4', 'Maltooligo_trehalose_synth_4', 5, NULL),
(10295, NULL, 'IPR011294', NULL, '3-hydroxybutyrate dehydrogenase', '3-OHbutyrate_DH', 4, NULL),
(10296, NULL, 'IPR024738', NULL, 'Transcriptional coactivator Hfi1/Transcriptional adapter 1', 'Hfi1/Tada1', 4, NULL),
(10297, NULL, 'IPR009150', NULL, 'Neuropeptide B/W receptor family', 'Neuropept_B/W_rcpt', 4, NULL),
(10298, NULL, 'IPR006162', NULL, 'Phosphopantetheine attachment site', 'Ppantetheine_attach_site', 6, NULL),
(10299, NULL, 'IPR009542', NULL, 'Signal peptidase complex subunit 1', 'Spc1/SPCS1', 4, NULL),
(10300, NULL, 'IPR014485', NULL, 'Predicted phosphoesterase, C1039.02 type', 'Pesterase_C1039', 4, NULL),
(10301, NULL, 'IPR010487', NULL, 'Neugrin/Rrg9', 'NGRN/Rrg9', 4, NULL),
(10302, NULL, 'IPR012636', NULL, 'Tamulustoxin', 'Toxin_32', 4, NULL),
(10303, NULL, 'IPR015843', NULL, 'RNA-directed RNA polymerase, nairovirus', 'RNA-dir_pol_nairovirus', 4, NULL),
(10304, NULL, 'IPR016067', NULL, 'S-adenosylmethionine decarboxylase, core', 'S-AdoMet_deCO2ase_core', 5, NULL),
(10305, NULL, 'IPR010468', NULL, 'Hormone-sensitive lipase, N-terminal', 'HSL_N', 3, NULL),
(10306, NULL, 'IPR024277', NULL, 'Domain of unknown function DUF3821', 'DUF3821', 3, NULL),
(10307, NULL, 'IPR010452', NULL, 'Isocitrate dehydrogenase kinasephosphatase', 'Isocitrate_DH_AceK', 4, NULL),
(10308, NULL, 'IPR010482', NULL, 'Peroxin domain', 'Peroxin', 3, NULL),
(10309, NULL, 'IPR009545', NULL, 'Tight junction protein, claudin-like', 'Claudin-like', 4, NULL),
(10310, NULL, 'IPR005089', NULL, 'Carbohydrate-binding module family 19', 'CBM_fam19', 3, NULL),
(10311, NULL, 'IPR007501', NULL, 'Protein of unknown function DUF531', 'DUF531', 4, NULL),
(10312, NULL, 'IPR010473', NULL, 'Formin, GTPase-binding domain', 'GTPase-bd', 3, NULL),
(10313, NULL, 'IPR011150', NULL, 'Cutinase, monofunctional', 'Cutinase_monf', 4, NULL),
(10314, NULL, 'IPR010505', NULL, 'Molybdenum cofactor synthesis C-terminal', 'Mob_synth_C', 3, NULL),
(10315, NULL, 'IPR011277', NULL, 'Chorismate mutase, T-protein', 'CM_T', 3, NULL),
(10316, NULL, 'IPR034853', NULL, 'Neutrophil cytosol factor P40, PB1 domain', 'PB1_P40', 3, NULL),
(10317, NULL, 'IPR006170', NULL, 'Pheromone/general odorant binding protein', 'PBP/GOBP', 4, NULL),
(10318, NULL, 'IPR009214', NULL, 'Protein of unknown function DUF1129', 'DUF1129', 4, NULL),
(10319, NULL, 'IPR011079', NULL, 'Alanine racemase, C-terminal', 'Ala_racemase_C', 3, NULL),
(10320, NULL, 'IPR006165', NULL, 'Ku70', 'Ku70', 4, NULL),
(10321, NULL, 'IPR016071', NULL, 'Staphylococcal nuclease (SNase-like), OB-fold', 'Staphylococal_nuclease_OB-fold', 3, NULL),
(10322, NULL, 'IPR006114', NULL, '6-phosphogluconate dehydrogenase, C-terminal', '6PGDH_C', 3, NULL),
(10323, NULL, 'IPR009209', NULL, 'Epsilon toxin', 'Epsilon_toxin', 4, NULL),
(10324, NULL, 'IPR006164', NULL, 'Ku70/Ku80 beta-barrel domain', 'Ku70/Ku80_beta-barrel_dom', 3, NULL),
(10325, NULL, 'IPR016066', NULL, 'Alpha-D-phosphohexomutase, conserved site', 'A-D-PHexomutase_CS', 2, NULL),
(10326, NULL, 'IPR011317', NULL, 'Predicted [NiFe]-hydrogenase-3-type complex Eha, membrane protein EhaE', 'Prd_NiFe_hyd_3_EhaE', 4, NULL),
(10327, NULL, 'IPR013476', NULL, 'Methylamine dehydrogenase heavy chain', 'MeN_DH_Hvc', 4, NULL),
(10328, NULL, 'IPR011576', NULL, 'Pyridoxamine 5''-phosphate oxidase, putative', 'Pyridox_Oxase_put', 3, NULL),
(10329, NULL, 'IPR011308', NULL, 'Predicted [NiFe]-hydrogenase-3-type complex Eha, membrane protein EhaD', 'Prd_NiFe_hyd_3_EhaD', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(10330, NULL, 'IPR009556', NULL, 'Microneme Etmic-2', 'Microneme_Etmic-2', 4, NULL),
(10331, NULL, 'IPR010508', NULL, 'Neurobeachin-like, DUF1088', 'NBEA-like_DUF1088', 3, NULL),
(10332, NULL, 'IPR007494', NULL, 'Glutaredoxin 2, C-terminal', 'Glutaredoxin2_C', 3, NULL),
(10333, NULL, 'IPR009562', NULL, 'Protein of unknown function DUF1178', 'DUF1178', 4, NULL),
(10334, NULL, 'IPR009218', NULL, 'Predicted HD phosphohydrolase', 'HD_phosphohydro', 4, NULL),
(10335, NULL, 'IPR011258', NULL, 'BPG-independent PGAM, N-terminal', 'BPG-indep_PGM_N', 3, NULL),
(10336, NULL, 'IPR009219', NULL, 'Bacteriophytochrome, CheY-like', 'Bactrphtchr_CheY', 4, NULL),
(10337, NULL, 'IPR010490', NULL, 'Conserved oligomeric Golgi complex subunit 6', 'COG6', 4, NULL),
(10338, NULL, 'IPR013043', NULL, 'Domain of unknown function DUF1595', 'DUF1595', 3, NULL),
(10339, NULL, 'IPR016058', NULL, 'Pheromone Er-1, protozoan', 'Pheromone_Er1_protoz', 5, NULL),
(10340, NULL, 'IPR034190', NULL, 'Subtilisin domain, cyanobacteria-type', 'Peptidase_S8_6', 3, NULL),
(10341, NULL, 'IPR014487', NULL, 'Protein of unknown function DUF3151', 'DUF3151', 4, NULL),
(10342, NULL, 'IPR005082', NULL, 'Peptidase U9, T4 prohead protease', 'Peptidase_U9_T4_prohead', 4, NULL),
(10343, NULL, 'IPR013484', NULL, 'Molybdenum cofactor biosynthesis protein B, proteobacteria', 'MoaB_proteobac', 4, NULL),
(10344, NULL, 'IPR013488', NULL, 'CRISPR-associated protein Csx9', 'CRISPR-assoc_prot_Csx9', 4, NULL),
(10345, NULL, 'IPR011287', NULL, 'Poly(R)-hydroxyalkanoic acid synthase, class II', 'PHA_synth_II', 4, NULL),
(10346, NULL, 'IPR009143', NULL, 'Wnt-6 protein', 'Wnt6', 4, NULL),
(10347, NULL, 'IPR011282', NULL, '2-amino-3-ketobutyrate coenzyme A ligase', '2am3keto_CoA_ligase', 4, NULL),
(10348, NULL, 'IPR011068', NULL, 'Nucleotidyltransferase, class I-like, C-terminal', 'NuclTrfase_I-like_C', 5, NULL),
(10349, NULL, 'IPR023559', NULL, 'Flagellar transcriptional activator FlhD', 'Flagellar_FlhD', 4, NULL),
(10350, NULL, 'IPR011134', NULL, 'Allophycocyanin linker protein', 'Allophyco_linker', 4, NULL),
(10351, NULL, 'IPR010449', NULL, 'NUMB domain', 'Numb_domain', 3, NULL),
(10352, NULL, 'IPR009211', NULL, 'Type VI secretion system accessory component TagJ', 'TagJ', 4, NULL),
(10353, NULL, 'IPR009208', NULL, 'Mosquitocidal toxin', 'Mtx2_tox', 4, NULL),
(10354, NULL, 'IPR006111', NULL, 'Archaeal Rpo6/eukaryotic RPB6 RNA polymerase subunit', 'Rpo6/Rpb6', 4, NULL),
(10355, NULL, 'IPR005085', NULL, 'Carbohydrate binding module family 25', 'CBM25', 3, NULL),
(10356, NULL, 'IPR007481', NULL, 'Stringent starvation protein B', 'SspB', 4, NULL),
(10357, NULL, 'IPR015842', NULL, 'RNA-directed RNA polymerase, tenuivirus', 'RNA-dir_pol_tenuivirus', 4, NULL),
(10358, NULL, 'IPR006131', NULL, 'Aspartate/ornithine carbamoyltransferase, Asp/Orn-binding domain', 'Asp_carbamoyltransf_Asp/Orn-bd', 3, NULL),
(10359, NULL, 'IPR009550', NULL, 'VirE3', 'VirE3', 4, NULL),
(10360, NULL, 'IPR006119', NULL, 'Resolvase, N-terminal catalytic domain', 'Resolv_N', 3, NULL),
(10361, NULL, 'IPR010506', NULL, 'DMAP1-binding domain', 'DMAP1-bd', 3, NULL),
(10362, NULL, 'IPR023943', NULL, 'Enolase-phosphatase E1', 'Enolase-ppase_E1', 4, NULL),
(10363, NULL, 'IPR015845', NULL, 'Agropine synthesis reductase', 'Mas1', 4, NULL),
(10364, NULL, 'IPR009531', NULL, 'Protein of unknown function DUF1150', 'DUF1150', 4, NULL),
(10365, NULL, 'IPR013483', NULL, 'Molybdenum cofactor biosynthesis protein A', 'MoaA', 4, NULL),
(10366, NULL, 'IPR023937', NULL, 'Bis(5''-nucleosyl)-tetraphosphatase PrpE', 'Bis(5''-nucleosyl)-tetraP_PrpE', 4, NULL),
(10367, NULL, 'IPR011613', NULL, 'GH15-like domain', 'GH15-like', 3, NULL),
(10368, NULL, 'IPR016064', NULL, 'NAD kinase/diacylglycerol kinase-like domain superfamily', 'NAD/diacylglycerol_kinase_sf', 5, NULL),
(10369, NULL, 'IPR014617', NULL, 'Predicted membrane protein, Bacillus YphA type', 'YphA_Bacsu', 4, NULL),
(10370, NULL, 'IPR006140', NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase, NAD-binding domain', 'D-isomer_DH_NAD-bd', 3, NULL),
(10371, NULL, 'IPR006156', NULL, 'Dihydroneopterin aldolase', 'Dihydroneopterin_aldolase', 4, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(10372, NULL, 'IPR010504', NULL, 'Arfaptin homology (AH) domain', 'AH_dom', 3, NULL),
(10373, NULL, 'IPR011065', NULL, 'Kunitz inhibitor STI-like superfamily', 'Kunitz_inhibitor_STI-like_sf', 5, NULL),
(10374, NULL, 'IPR005071', NULL, 'Transmembrane glycoprotein', 'Glycoprotein', 4, NULL),
(10375, NULL, 'IPR009210', NULL, 'Activating signal cointegrator 1 complex subunit 1', 'ASCC1', 4, NULL),
(10376, NULL, 'IPR006141', NULL, 'Intein N-terminal splicing region', 'Intein_N', 6, NULL),
(10377, NULL, 'IPR010480', NULL, 'Pepsin inhibitor-3-like repeated domain', 'Pepsin-I3', 3, NULL),
(10378, NULL, 'IPR009535', NULL, 'Phospholipase C-beta, conserved site', 'PLC-beta_CS', 2, NULL),
(10379, NULL, 'IPR013474', NULL, 'Circadian clock protein KaiB', 'Circ_KaiB', 4, NULL),
(10380, NULL, 'IPR012643', NULL, 'Wound-inducible basic', 'Wound_ind', 4, NULL),
(10381, NULL, 'IPR010481', NULL, 'Cdc24/Scd1, N-terminal', 'Cdc24/Scd1_N', 3, NULL),
(10382, NULL, 'IPR012003', NULL, 'ATP-dependent 6-phosphofructokinase, prokaryotic-type', 'ATP_PFK_prok-type', 4, NULL),
(10383, NULL, 'IPR035897', NULL, 'Toll/interleukin-1 receptor homology (TIR) domain superfamily', 'Toll_tir_struct_dom_sf', 5, NULL),
(10384, NULL, 'IPR006159', NULL, 'Methylmalonyl-CoA mutase, C-terminal', 'Acid_CoA_mut_C', 3, NULL),
(10385, NULL, 'IPR007485', NULL, 'LPS-assembly lipoprotein LptE', 'LPS_assembly_LptE', 4, NULL),
(10386, NULL, 'IPR016068', NULL, 'Translin, N-terminal', 'Translin_N', 5, NULL),
(10387, NULL, 'IPR006161', NULL, 'Conserved hypothetical protein CHP00336', 'CHP00366', 4, NULL),
(10388, NULL, 'IPR011601', NULL, 'UDP-N-acetylenolpyruvoylglucosamine reductase, C-terminal', 'MurB_C', 3, NULL),
(10389, NULL, 'IPR011290', NULL, 'Nitrogenase iron-iron protein, alpha chain', 'Nase_Fe-Fe_asu', 4, NULL),
(10390, NULL, 'IPR010510', NULL, 'FGF binding 1', 'FGF1-bd', 4, NULL),
(10391, NULL, 'IPR005091', NULL, 'Major surface protein 1B', 'MSP1b', 4, NULL),
(10392, NULL, 'IPR010492', NULL, 'GINS complex, subunit Psf3', 'GINS_Psf3', 4, NULL),
(10393, NULL, 'IPR011314', NULL, 'Predicted [NiFe]-hydrogenase-3-type complex Eha, membrane protein EhaB', 'Prd_NiFe_hyd_3_EhaB', 4, NULL),
(10394, NULL, 'IPR016095', NULL, 'Ribosomal protein L1, 3-layer alpha/beta-sandwich', 'Ribosomal_L1_3-a/b-sand', 5, NULL),
(10395, NULL, 'IPR007502', NULL, 'Helicase-associated domain', 'Helicase-assoc_dom', 3, NULL),
(10396, NULL, 'IPR012632', NULL, 'Scorpion calcine', 'Scorpion_calcine', 4, NULL),
(10397, NULL, 'IPR011319', NULL, 'Predicted [NiFe]-hydrogenase-3-type complex Eha, membrane protein EhaK', 'Prd_NiFe_hyd_3_EhaK', 4, NULL),
(10398, NULL, 'IPR034836', NULL, 'Glucoamylase, CBM20 domain', 'CBM20_glucoamylase', 3, NULL),
(10399, NULL, 'IPR014332', NULL, 'Ectoine utilization protein EutA', 'Ectoine_EutA', 4, NULL),
(10400, NULL, 'IPR010448', NULL, 'Torsin', 'Torsin', 4, NULL),
(10401, NULL, 'IPR009122', NULL, 'Desmosomal cadherin', 'Desmosomal_cadherin', 4, NULL),
(10402, NULL, 'IPR034143', NULL, 'snRNP70, RNA recognition motif', 'snRNP70_RRM', 3, NULL),
(10403, NULL, 'IPR012280', NULL, 'Semialdehyde dehydrogenase, dimerisation domain', 'Semialdhyde_DH_dimer_dom', 3, NULL),
(10404, NULL, 'IPR005095', NULL, 'EspA-like secreted protein', 'EspA', 4, NULL),
(10405, NULL, 'IPR023774', NULL, 'Putative metal-dependent hydrolase YfiT', 'Put_metal_dep_hydrolase_YfiT', 4, NULL),
(10406, NULL, 'IPR023737', NULL, 'Spermidine export protein MdtI', 'Spermidine_export_MdtI', 4, NULL),
(10407, NULL, 'IPR011315', NULL, 'NTP pyrophosphohydrolase MazG-related, Rhizobiaceae-type', 'MazG-related_Rhizo-type', 4, NULL),
(10408, NULL, 'IPR010494', NULL, 'Repeat of unknown function DUF1079', 'DUF1079', 7, NULL),
(10409, NULL, 'IPR013032', NULL, 'EGF-like, conserved site', 'EGF-like_CS', 2, NULL),
(10410, NULL, 'IPR013493', NULL, 'Conserved hypothetical protein CHP02677', 'CHP02677', 4, NULL),
(10411, NULL, 'IPR013477', NULL, 'Homocitrate synthase NifV-like', 'NifV/FrbC', 4, NULL),
(10412, NULL, 'IPR006133', NULL, 'DNA-directed DNA polymerase, family B, exonuclease domain', 'DNA-dir_DNA_pol_B_exonuc', 3, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(10413, NULL, 'IPR009553', NULL, 'Protein of unknown function DUF1173', 'DUF1173', 4, NULL),
(10414, NULL, 'IPR006137', NULL, 'NADH:ubiquinone oxidoreductase-like, 20kDa subunit', 'NADH_UbQ_OxRdtase-like_20kDa', 3, NULL),
(10415, NULL, 'IPR011286', NULL, '2-dehydro-3-deoxy-D-gluconate 5-dehydrogenase', '2-deoxy-D-gluc_3_DH', 4, NULL),
(10416, NULL, 'IPR010463', NULL, 'Protein of unknown function DUF1057', 'DUF1057', 4, NULL),
(10417, NULL, 'IPR016069', NULL, 'Translin, C-terminal', 'Translin_C', 5, NULL),
(10418, NULL, 'IPR010441', NULL, 'CH-like domain in sperm protein', 'CH_2', 3, NULL),
(10419, NULL, 'IPR006106', NULL, 'Cereal seed allergen/grain softness/trypsin and alpha-amylase inhibitor', 'Allergen/soft/tryp_amyl_inhib', 4, NULL),
(10420, NULL, 'IPR009136', NULL, 'Vascular endothelial growth factor receptor 2 (VEGFR2)', 'VEGFR2_rcpt', 4, NULL),
(10421, NULL, 'IPR010444', NULL, 'Bacteriophage lambda Kil', 'Phage_lambda_Kil', 4, NULL),
(10422, NULL, 'IPR010450', NULL, 'Neurexophilin', 'Nxph', 4, NULL),
(10423, NULL, 'IPR010466', NULL, 'Protein of unknown function DUF1058', 'DUF1058', 4, NULL),
(10424, NULL, 'IPR005074', NULL, 'Peptidase C39, bacteriocin processing', 'Peptidase_C39', 3, NULL),
(10425, NULL, 'IPR013487', NULL, 'CRISPR-associated protein Csx8', 'CRISPR-assoc_prot_Csx8', 4, NULL),
(10426, NULL, 'IPR012631', NULL, 'Conotoxin T-superfamily', 'Toxin_26', 4, NULL),
(10427, NULL, 'IPR006143', NULL, 'RND efflux pump, membrane fusion protein', 'RND_pump_MFP', 4, NULL),
(10428, NULL, 'IPR014336', NULL, 'N-alpha-acetyl diaminobutyrate deacetylase DoeB', 'DoeB', 4, NULL),
(10429, NULL, 'IPR013496', NULL, 'Conserved hypothetical protein CHP02680', 'CHP02680', 4, NULL),
(10430, NULL, 'IPR009554', NULL, 'Phage shock protein B', 'Phageshock_PspB', 4, NULL),
(10431, NULL, 'IPR015833', NULL, 'DNA-directed DNA polymerase, family B, mitochondrial linear plasmid', 'DNA-dir_DNA_pol_B_mt_lin_plsmd', 4, NULL),
(10432, NULL, 'IPR011064', NULL, 'Allophycocyanin linker chain', 'Allophyco_linker_chain', 5, NULL),
(10433, NULL, 'IPR012652', NULL, 'Energy coupling factor transporter S component ThiW', 'ThiW', 4, NULL),
(10434, NULL, 'IPR010488', NULL, 'Zeta toxin domain', 'Zeta_toxin_domain', 3, NULL),
(10435, NULL, 'IPR012648', NULL, 'T4 RNA ligase 1', 'Rnl1', 4, NULL),
(10436, NULL, 'IPR011147', NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase', 'Bifunc_aspartokin/hSer_DH', 4, NULL),
(10437, NULL, 'IPR014492', NULL, 'Poly(A) polymerase', 'PolyA_polymerase', 4, NULL),
(10438, NULL, 'IPR013495', NULL, 'Conserved hypothetical protein CHP02679', 'CHP02679', 4, NULL),
(10439, NULL, 'IPR006155', NULL, 'Josephin domain', 'Josephin', 3, NULL),
(10440, NULL, 'IPR009544', NULL, 'Protein of unknown function DUF1163', 'DUF1163', 4, NULL),
(10441, NULL, 'IPR009559', NULL, 'Lactococcus phage c2, major capsid protein', 'Lactococcus_phage_c2_MCP', 4, NULL),
(10442, NULL, 'IPR009114', NULL, 'Angiomotin', 'Angiomotin', 4, NULL),
(10443, NULL, 'IPR007497', NULL, 'Interleukin-1 receptor-associated kinase 1-binding protein 1/DUF541', 'SIMPL/DUF541', 4, NULL),
(10444, NULL, 'IPR006075', NULL, 'Aspartyl/Glutamyl-tRNA(Gln) amidotransferase, subunit B/E, catalytic', 'Asn/Gln-tRNA_Trfase_suB/E_cat', 3, NULL),
(10445, NULL, 'IPR010499', NULL, 'Bacterial transcription activator, effector binding', 'AraC_E-bd', 3, NULL),
(10446, NULL, 'IPR010513', NULL, 'KEN domain', 'KEN_dom', 3, NULL),
(10447, NULL, 'IPR034749', NULL, 'DNA-directed DNA polymerase T4 type', 'DPOL_T4', 4, NULL),
(10448, NULL, 'IPR034831', NULL, 'Laforin, CBM20 domain', 'CBM20_laforin', 3, NULL),
(10449, NULL, 'IPR016073', NULL, 'SKP1 component, POZ domain', 'Skp1_comp_POZ', 3, NULL),
(10450, NULL, 'IPR005073', NULL, 'Peptidase M74, penicillin-insensitive murein endopeptidase', 'Peptidase_M74', 4, NULL),
(10451, NULL, 'IPR009547', NULL, 'Tenuivirus PVC2', 'Tenui_PVC2', 4, NULL),
(10452, NULL, 'IPR014490', NULL, 'DNA-binding protein from starved cells-like', 'Dps-like', 4, NULL),
(10453, NULL, 'IPR005096', NULL, 'Protein of unknown function DUF276', 'DUF276', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(10454, NULL, 'IPR006138', NULL, 'NADH-ubiquinone oxidoreductase, 20 Kd subunit', 'NADH_UQ_OxRdtase_20Kd_su', 4, NULL),
(10455, NULL, 'IPR010454', NULL, 'Bacteriophage NinH', 'Phage_NinH', 4, NULL),
(10456, NULL, 'IPR013466', NULL, 'Thymidine phosphorylase/AMP phosphorylase', 'Thymidine/AMP_Pase', 4, NULL),
(10457, NULL, 'IPR012656', NULL, 'Conserved hypothetical protein CHP02421, QEGLA', 'CHP02421_QEGLA', 4, NULL),
(10458, NULL, 'IPR007490', NULL, 'Poxvirus B22', 'Poxvirus_B22', 4, NULL),
(10459, NULL, 'IPR005087', NULL, 'Carbohydrate binding module family 11', 'CBM_fam11', 3, NULL),
(10460, NULL, 'IPR006157', NULL, 'Dihydroneopterin aldolase/epimerase domain', 'FolB_dom', 3, NULL),
(10461, NULL, 'IPR011283', NULL, 'Acetoacetyl-CoA reductase', 'Acetoacetyl-CoA_reductase', 4, NULL),
(10462, NULL, 'IPR011280', NULL, 'Succinate dehydrogenase/fumarate reductase flavoprotein subunit, low-GC Gram-positive bacteria', 'Succ_DH/Fum_Rdt_flav_su', 4, NULL),
(10463, NULL, 'IPR009539', NULL, 'Vang-like protein', 'VANGL', 4, NULL),
(10464, NULL, 'IPR010446', NULL, 'Beta-1,4-N-acetylgalactosaminyltransferase', 'GalNAc_Trfase_b', 4, NULL),
(10465, NULL, 'IPR006160', NULL, 'Short chain fatty acid transporter AtoE', 'SCFA_transpt_AtoE', 4, NULL),
(10466, NULL, 'IPR007493', NULL, 'Protein of unknown function DUF538', 'DUF538', 4, NULL),
(10467, NULL, 'IPR006132', NULL, 'Aspartate/ornithine carbamoyltransferase, carbamoyl-P binding', 'Asp/Orn_carbamoyltranf_P-bd', 3, NULL),
(10468, NULL, 'IPR009215', NULL, 'TIM-barrel domain, IGPS-like', 'TIM-br_IGPS-like', 3, NULL),
(10469, NULL, 'IPR011152', NULL, 'Phosphoesterase MJ0912', 'Pesterase_MJ0912', 4, NULL),
(10470, NULL, 'IPR009212', NULL, 'Methylthioribose kinase', 'Methylthioribose_kinase', 4, NULL),
(10471, NULL, 'IPR012654', NULL, 'Conserved hypothetical protein CHP02391', 'CHP02391', 3, NULL),
(10472, NULL, 'IPR013481', NULL, 'Conserved hypothetical protein CHP02664, nitrate reductase-associated', 'CHP02664_NO3_red', 4, NULL),
(10473, NULL, 'IPR006121', NULL, 'Heavy metal-associated domain, HMA', 'HMA_dom', 3, NULL),
(10474, NULL, 'IPR006095', NULL, 'Glutamate/phenylalanine/leucine/valine dehydrogenase', 'Glu/Leu/Phe/Val_DH', 4, NULL),
(10475, NULL, 'IPR012639', NULL, 'Tryptophan operon leader peptide', 'Trp_leader2', 4, NULL),
(10476, NULL, 'IPR011579', NULL, 'ATPase domain', 'ATPase_dom', 3, NULL),
(10477, NULL, 'IPR013486', NULL, 'Sporulation stage II protein D, amidase enhancer LytB', 'SpoIID/LytB', 4, NULL),
(10478, NULL, 'IPR024742', NULL, 'Glycogen debranching enzyme, bacterial and archaeal type, N-terminal', 'Glycogen_debranch_N', 3, NULL),
(10479, NULL, 'IPR009207', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-37 specific', 'SET7_MeTrfase', 4, NULL),
(10480, NULL, 'IPR010439', NULL, 'MUN domain', 'MUN_dom', 3, NULL),
(10481, NULL, 'IPR011296', NULL, 'Phosphotransferase system, trehalose-specific IIBC component', 'PTS_IIBC_treh', 3, NULL),
(10482, NULL, 'IPR005092', NULL, 'Trans-activating transcriptional regulator', 'TATR', 4, NULL),
(10483, NULL, 'IPR009116', NULL, 'Annexin A9', 'ANX9', 4, NULL),
(10484, NULL, 'IPR011072', NULL, 'HR1 rho-binding domain', 'HR1_rho-bd', 3, NULL),
(10485, NULL, 'IPR009220', NULL, 'Probable bifunctional tRNA threonylcarbamoyladenosine biosynthesis protein', 'tRNA_threonyl_synthase/kinase', 4, NULL),
(10486, NULL, 'IPR013039', NULL, 'Domain of unknown function DUF1588', 'DUF1588', 3, NULL),
(10487, NULL, 'IPR010496', NULL, '3-keto-disaccharide hydrolase', '3-keto-disaccharide_hydrolase', 3, NULL),
(10488, NULL, 'IPR006139', NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase, catalytic domain', 'D-isomer_2_OHA_DH_cat_dom', 3, NULL),
(10489, NULL, 'IPR009140', NULL, 'Wnt-2 protein', 'Wnt2', 4, NULL),
(10490, NULL, 'IPR009563', NULL, 'Sjoegren syndrome/scleroderma autoantigen 1', 'SSSCA1', 4, NULL),
(10491, NULL, 'IPR009139', NULL, 'Wnt-1 protein', 'Wnt1', 4, NULL),
(10492, NULL, 'IPR006166', NULL, 'ERCC4 domain', 'ERCC4_domain', 3, NULL),
(10493, NULL, 'IPR005076', NULL, 'Glycosyl transferase, family 6', 'Glyco_trans_6', 4, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(10494, NULL, 'IPR005086', NULL, 'Carbohydrate binding module family 17/28', 'CBM_fam_17/28', 3, NULL),
(10495, NULL, 'IPR010447', NULL, 'Herpesvirus IR6', 'Herpes_IR6', 4, NULL),
(10496, NULL, 'IPR006151', NULL, 'Quinate/shikimate 5-dehydrogenase/glutamyl-tRNA reductase', 'Shikm_DH/Glu-tRNA_Rdtase', 3, NULL),
(10497, NULL, 'IPR016056', NULL, 'Pheromone Er-23, protozoan', 'Pheromone_Er23_protoz', 5, NULL),
(10498, NULL, 'IPR006130', NULL, 'Aspartate/ornithine carbamoyltransferase', 'Asp/Orn_carbamoylTrfase', 4, NULL),
(10499, NULL, 'IPR009564', NULL, 'Protein of unknown function DUF1179', 'DUF1179', 4, NULL),
(10500, NULL, 'IPR010475', NULL, 'Adipokinetic hormone/red pigment-concentrating hormone', 'AKH/RPCH_hormone', 4, NULL),
(10501, NULL, 'IPR014228', NULL, 'Sporulation protein, polysaccharide deacetylase, YlxY', 'Spore_polysacc_deacetyl_YlxY', 4, NULL),
(10502, NULL, 'IPR011229', NULL, 'Cell cycle protein GpsB', 'Cell_cycle_GpsB', 4, NULL),
(10503, NULL, 'IPR009636', NULL, 'Capsid assembly scaffolding protein', 'SCAF', 4, NULL),
(10504, NULL, 'IPR014214', NULL, 'Dipicolinic acid synthetase, subunit B', 'Dipicolinic_acid_synth_B', 4, NULL),
(10505, NULL, 'IPR011632', NULL, 'Domain of unknown function DUF1601', 'DUF1601', 3, NULL),
(10506, NULL, 'IPR015184', NULL, 'Quinohemoprotein amine dehydrogenase, alpha subunit domain IV', 'QH-AmDH_asu_dom_IV', 3, NULL),
(10507, NULL, 'IPR010132', NULL, 'ATPase, type I secretion system, HlyB', 'ATPase_T1SS_HlyB', 4, NULL),
(10508, NULL, 'IPR015178', NULL, 'Alpha-amylase/4-alpha-glucanotransferase, central domain', 'A-amylase/a-glucTrfase_central', 3, NULL),
(10509, NULL, 'IPR011194', NULL, 'Uncharacterised protein family UPF0306', 'UPF0306', 4, NULL),
(10510, NULL, 'IPR007512', NULL, 'MICOS complex subunit Mic10', 'Mic10', 4, NULL),
(10511, NULL, 'IPR011192', NULL, 'Rubisco  LSMT methyltransferase, plant', 'Rubisco_LSMT_MeTrfase_plant', 4, NULL),
(10512, NULL, 'IPR005114', NULL, 'Helicase-associated', 'Helicase_assoc', 3, NULL),
(10513, NULL, 'IPR010805', NULL, 'Kaposi s sarcoma-associated herpesvirus K8', 'KSHV_K8', 4, NULL),
(10514, NULL, 'IPR007528', NULL, 'RINT-1/Tip20', 'RINT1_Tip20', 4, NULL),
(10515, NULL, 'IPR012015', NULL, 'Uncharacterised conserved protein HTH transcriptional regulator, archaea', 'UCP_HTH_arc', 4, NULL),
(10516, NULL, 'IPR011075', NULL, 'Tetracyclin repressor-like, C-terminal domain', 'TetR_C', 3, NULL),
(10517, NULL, 'IPR023714', NULL, 'Zinc transport protein ZntB', 'Zn_transp_ZntB', 4, NULL),
(10518, NULL, 'IPR007537', NULL, 'tRNAHis guanylyltransferase Thg1', 'tRNAHis_GuaTrfase_Thg1', 4, NULL),
(10519, NULL, 'IPR023751', NULL, 'L-fucose mutarotase', 'L-fucose_mutarotase', 4, NULL),
(10520, NULL, 'IPR015206', NULL, '3-mercaptopyruvate sulfurtransferase, C-terminal domain', 'SulfurTase_C', 3, NULL),
(10521, NULL, 'IPR024652', NULL, 'Trichodiene synthase', 'Trichodiene_synth', 4, NULL),
(10522, NULL, 'IPR011668', NULL, 'Small zinc finger protein HVO_2753-like, zinc-binding pocket', 'HVO_2753-like_ZBP', 3, NULL),
(10523, NULL, 'IPR011661', NULL, 'Sulphur oxygenase reductase', 'S_Oase_red', 4, NULL),
(10524, NULL, 'IPR015197', NULL, 'Peptide-N-glycosidase F, C-terminal', 'PngaseF_C', 3, NULL),
(10525, NULL, 'IPR011666', NULL, 'G patch domain-containing protein, N-terminal', 'DUF1604', 3, NULL),
(10526, NULL, 'IPR010122', NULL, 'Hydroxymethylglutaryl-CoA synthase, eukaryotic', 'HMG_CoA_synthase_euk', 4, NULL),
(10527, NULL, 'IPR010153', NULL, 'CRISPR-associated protein, Cas5a type', 'CRISPR-assoc_prot_Cas5a-typ', 4, NULL),
(10528, NULL, 'IPR011630', NULL, 'Nucleotide modification associated domain 1', 'DUF1599', 3, NULL),
(10529, NULL, 'IPR012021', NULL, 'Uncharacterised conserved protein UCP005278', 'UCP005278', 4, NULL),
(10530, NULL, 'IPR011195', NULL, 'Uncharacterised conserved protein UCP010256', 'UCP010256', 4, NULL),
(10531, NULL, 'IPR015221', NULL, 'Ubiquitin-related modifier 1', 'Urm1', 4, NULL),
(10532, NULL, 'IPR011642', NULL, 'Nucleoside transporter/FeoB GTPase, Gate domain', 'Gate_dom', 3, NULL),
(10533, NULL, 'IPR024735', NULL, 'Conjugative transposon protein TcpC', 'TcpC', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(10534, NULL, 'IPR010131', NULL, 'RND efflux system, outer membrane lipoprotein, NodT', 'RND_efflux_OM_lipoprot_NodT', 4, NULL),
(10535, NULL, 'IPR015201', NULL, 'Antimicrobial protein MiAMP1', 'Antimicrobial_MiAMP1', 4, NULL),
(10536, NULL, 'IPR011239', NULL, 'Phosphoesterase cyanobacterial, all2852', 'Pesterase_cyn', 4, NULL),
(10537, NULL, 'IPR010808', NULL, 'Chemotaxis protein CheA, P2 response regulator-binding', 'CheA_P2-bd', 3, NULL),
(10538, NULL, 'IPR023969', NULL, 'Conserved hypothetical protein CHP04072, B12-binding/radical SAM-type', 'CHP04072_B12-bd/rSAM', 4, NULL),
(10539, NULL, 'IPR011638', NULL, 'Sorbitol phosphotransferase enzyme II, C-terminal', 'PTS_EIIBC_GUT_C', 3, NULL),
(10540, NULL, 'IPR015231', NULL, 'Protein of unknown function DUF1934', 'DUF1934', 4, NULL),
(10541, NULL, 'IPR034603', NULL, 'Dipeptide epimerase', 'Dipeptide_epimerase', 4, NULL),
(10542, NULL, 'IPR011673', NULL, 'Protein of unknown function DUF1615', 'DUF1615', 4, NULL),
(10543, NULL, 'IPR012666', NULL, 'Cobalt transporter subunit CbtA, putative', 'CbtA_put', 4, NULL),
(10544, NULL, 'IPR014243', NULL, 'Transcription factor, RsfA', 'DNA_bind_RsfA', 4, NULL),
(10545, NULL, 'IPR011082', NULL, 'Exosome-associated factor Rrp47/DNA strand repair C1D', 'Exosome-assoc_fac/DNA_repair', 4, NULL),
(10546, NULL, 'IPR005100', NULL, 'NGN domain', 'NGN-domain', 3, NULL),
(10547, NULL, 'IPR014499', NULL, 'Diadenylate cyclase, DacZ-type', 'DAC_DacZ', 4, NULL),
(10548, NULL, 'IPR012010', NULL, 'Urease, gamma subunit', 'Urease_gamma', 4, NULL),
(10549, NULL, 'IPR011657', NULL, 'Concentrative nucleoside transporter C-terminal domain', 'CNT_C_dom', 3, NULL),
(10550, NULL, 'IPR011214', NULL, 'Uncharacterised conserved protein UCP020967', 'UCP020967', 4, NULL),
(10551, NULL, 'IPR014222', NULL, 'Cytochrome c oxidase, subunit II', 'Cyt_c_oxidase_su2', 3, NULL),
(10552, NULL, 'IPR012033', NULL, 'Uncharacterised conserved protein UCP006600', 'UCP006600', 4, NULL),
(10553, NULL, 'IPR015235', NULL, 'Domain of unknown function DUF1937', 'DUF1937', 3, NULL),
(10554, NULL, 'IPR034607', NULL, 'Coiled-coil domain-containing protein 127', 'CCDC127', 4, NULL),
(10555, NULL, 'IPR010824', NULL, 'Protein of unknown function DUF1425', 'DUF1425', 4, NULL),
(10556, NULL, 'IPR010167', NULL, 'Amino-acid N-acetyltransferase', 'NH2A_AcTrfase', 4, NULL),
(10557, NULL, 'IPR011177', NULL, 'Transcription initiation factor TFIID subunit 1, animal', 'TAF1_animal', 4, NULL),
(10558, NULL, 'IPR015226', NULL, 'Type III effector HopF2', 'T3_effector_HopF2', 4, NULL),
(10559, NULL, 'IPR007508', NULL, 'D-aminoacyl-tRNA deacylase DtdA', 'DtdA', 4, NULL),
(10560, NULL, 'IPR014226', NULL, 'Sporulation integral membrane protein YlbJ', 'Spore_IM_YlbJ', 4, NULL),
(10561, NULL, 'IPR010798', NULL, 'Triadin', 'Triadin', 4, NULL),
(10562, NULL, 'IPR015230', NULL, 'Carbapenam-3-carboxylate synthase, N-terminal', 'CarA_N', 3, NULL),
(10563, NULL, 'IPR011577', NULL, 'Cytochrome b561, bacterial/Ni-hydrogenase', 'Cyt_b561_bac/Ni-Hgenase', 3, NULL),
(10564, NULL, 'IPR034604', NULL, 'Serine/Arginine-related protein 53', 'SRRP53', 4, NULL),
(10565, NULL, 'IPR011636', NULL, 'Thiosulphate:quinone oxidoreductase small subunit DoxA', 'DoxA', 3, NULL),
(10566, NULL, 'IPR007530', NULL, 'Aminoglycoside 6-adenylyltransferase', 'Aminoglycoside_adenylylTfrase', 4, NULL),
(10567, NULL, 'IPR007539', NULL, 'Domain of unknown function DUF551', 'DUF551', 3, NULL),
(10568, NULL, 'IPR023964', NULL, 'Bacteriocin precursor, CLOSPO-01332, putative', 'Bacteriocin_CLOSPO-01332_put', 4, NULL),
(10569, NULL, 'IPR011344', NULL, 'Single-stranded DNA-binding protein', 'ssDNA-bd', 4, NULL),
(10570, NULL, 'IPR011227', NULL, 'Uncharacterised conserved protein UCP029730', 'UCP029730', 4, NULL),
(10571, NULL, 'IPR023755', NULL, 'Heme A synthase, type 1', 'HemeA_Synthase_type1', 4, NULL),
(10572, NULL, 'IPR007543', NULL, 'LptD, C-terminal', 'LptD_C', 3, NULL),
(10573, NULL, 'IPR007538', NULL, 'dATP/dGTP diphosphohydrolase MazZ', 'dATP/dGTP_dipphydrolase_MazZ', 3, NULL),
(10574, NULL, 'IPR010777', NULL, 'PipA', 'PipA', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(10575, NULL, 'IPR015423', NULL, 'Influenza matrix M1, N-terminal subdomain 1', 'Flu_matrix_M1_N_sub1', 5, NULL),
(10576, NULL, 'IPR033992', NULL, 'Natural killer cell receptor-like, C-type lectin-like domain', 'NKR-like_CTLD', 3, NULL),
(10577, NULL, 'IPR010818', NULL, 'Protein of unknown function DUF1420', 'DUF1420', 4, NULL),
(10578, NULL, 'IPR009641', NULL, 'Vaccinia virus, A37', 'Vaccinia_virus_A37', 4, NULL),
(10579, NULL, 'IPR016099', NULL, 'Prismane-like, alpha/beta-sandwich', 'Prismane-like_a/b-sand', 5, NULL),
(10580, NULL, 'IPR011223', NULL, 'Uncharacterised conserved protein UCP028770', 'UCP028770', 4, NULL),
(10581, NULL, 'IPR012016', NULL, 'Aconitase X subunit 2, putative', 'AcnX_sub2_put', 4, NULL),
(10582, NULL, 'IPR010156', NULL, 'CRISPR-associated protein, Cas6', 'CRISPR-assoc_prot_Cas6', 4, NULL),
(10583, NULL, 'IPR011554', NULL, 'Hydroxymethylglutaryl-CoA synthase, prokaryotic', 'HMG_CoA_synthase_prok', 4, NULL),
(10584, NULL, 'IPR012022', NULL, 'Protein of unknown function UCP005295', 'UCP005295', 4, NULL),
(10585, NULL, 'IPR024703', NULL, 'Fascin, metazoans', 'Fascin_metazoans', 4, NULL),
(10586, NULL, 'IPR010126', NULL, 'Esterase, PHB depolymerase', 'Esterase_phb', 4, NULL),
(10587, NULL, 'IPR014237', NULL, 'Anti-sigma F factor antagonist', 'Anti-sigma_F_ant', 4, NULL),
(10588, NULL, 'IPR011081', NULL, 'Bacterial Ig-like domain', 'Big_4', 3, NULL),
(10589, NULL, 'IPR010163', NULL, 'CRISPR locus-related putative DNA-binding protein Csa3', 'Csa3', 4, NULL),
(10590, NULL, 'IPR010166', NULL, 'Transcriptional regulator SarA/Rot', 'SarA/Rot', 3, NULL),
(10591, NULL, 'IPR011651', NULL, 'Notch ligand, N-terminal domain', 'Notch_ligand_N', 3, NULL),
(10592, NULL, 'IPR010148', NULL, 'CRISPR-associated protein, CT1975', 'CRISPR-assoc_prot_CT1975', 4, NULL),
(10593, NULL, 'IPR011696', NULL, 'Huwentoxin-1 family', 'Huwentoxin-1', 4, NULL),
(10594, NULL, 'IPR011160', NULL, 'Sphingomyelin phosphodiesterase', 'Sphingomy_PDE', 4, NULL),
(10595, NULL, 'IPR007536', NULL, 'Ribosomal RNA small subunit methyltransferase J', '16SrRNA_methylTrfase_J', 4, NULL),
(10596, NULL, 'IPR007521', NULL, 'Choline kinase, N-terminal', 'Choline_kin_N', 3, NULL),
(10597, NULL, 'IPR010823', NULL, 'Portal protein Gp20', 'Portal_Gp20', 4, NULL),
(10598, NULL, 'IPR011171', NULL, 'Glia maturation factor', 'GMF', 4, NULL),
(10599, NULL, 'IPR011244', NULL, 'Bifunctional argininosuccinate lyase/acetyltransferase', 'ASAL_AGS_AcTrfase', 4, NULL),
(10600, NULL, 'IPR012660', NULL, 'Thioesterase, putative', 'YiiD_C', 3, NULL),
(10601, NULL, 'IPR011246', NULL, 'Bifunctional diaminopimelate decarboxylase/aspartate kinase', 'DAP_dec_asp_kin', 4, NULL),
(10602, NULL, 'IPR011175', NULL, 'Alpha-s2 casein', 'Alpha-s2_casein', 4, NULL),
(10603, NULL, 'IPR023757', NULL, '3D-(3,5/4)-trihydroxycyclohexane-1,2-dione hydrolase, Firmicutes', 'THcHDO_hydrolase_firmi', 4, NULL),
(10604, NULL, 'IPR011225', NULL, 'Type IV secretory pathway, VirJ component', 'IV_sec_VirJ', 4, NULL),
(10605, NULL, 'IPR015185', NULL, 'Exotoxin A, binding', 'Exotox-A_bind', 3, NULL),
(10606, NULL, 'IPR015192', NULL, 'Switch protein XOL-1, N-terminal', 'Xol-1_N', 3, NULL),
(10607, NULL, 'IPR011719', NULL, 'Conserved hypothetical protein CHP02058', 'CHP02058', 4, NULL),
(10608, NULL, 'IPR012025', NULL, 'Uncharacterised conserved protein UCP005642, methanogenesis', 'UCP005642_methan', 4, NULL),
(10609, NULL, 'IPR012662', NULL, 'Conserved hypothetical protein CHP02449', 'CHP02449', 4, NULL),
(10610, NULL, 'IPR011721', NULL, 'Conserved hypothetical protein CHP02096', 'CHP02096', 4, NULL),
(10611, NULL, 'IPR007519', NULL, 'Bul1, N-terminal', 'Bul1_N', 3, NULL),
(10612, NULL, 'IPR034884', NULL, 'Mitochondrial cytochrome c oxidase subunit VIc/VIIs', 'Cytochrome_c_oxidase_VIc/VIIs', 3, NULL),
(10613, NULL, 'IPR009635', NULL, 'Neural proliferation differentiation control-1', 'NPDC1', 4, NULL),
(10614, NULL, 'IPR010173', NULL, 'CRISPR-associated protein Csm5', 'CRISPR-assoc_Csm5', 4, NULL),
(10615, NULL, 'IPR011628', NULL, 'Cleaved adhesin', 'Cleaved_adhesin', 3, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(10616, NULL, 'IPR011684', NULL, 'Protein Networked (NET), actin-binding (NAB) domain', 'NAB', 3, NULL),
(10617, NULL, 'IPR011230', NULL, 'Phosphoesterase At2g46880', 'Pesterase_At2g46', 4, NULL),
(10618, NULL, 'IPR011683', NULL, 'Glycosyl hydrolase family 53', 'Glyco_hydro_53', 4, NULL),
(10619, NULL, 'IPR011176', NULL, 'Complement control protein C3/B5', 'CCP_VACV_C3/B5', 4, NULL),
(10620, NULL, 'IPR011240', NULL, 'Phosphoesterase-related protein YunD', 'Pesterase_YunD', 4, NULL),
(10621, NULL, 'IPR014494', NULL, 'Predicted Fe-S oxidoreductase, NifB/MoaA-like family, euryarchaeota type', 'Fe-S_OxRdtase_NifB-like_arc', 4, NULL),
(10622, NULL, 'IPR035053', NULL, 'RPK118-like, kinase domain', 'STK_RPK118-like', 3, NULL),
(10623, NULL, 'IPR011259', NULL, 'Ezrin/radixin/moesin, C-terminal', 'ERM_C_dom', 3, NULL),
(10624, NULL, 'IPR015200', NULL, 'Sliding clamp, C-terminal', 'Sliding_clamp_C', 3, NULL),
(10625, NULL, 'IPR035904', NULL, 'Chorismate synthase AroC superfamily', 'Chorismate_synth_AroC_sf', 5, NULL),
(10626, NULL, 'IPR023618', NULL, 'Photosystem I PsaG/PsaK domain, chloroplastic', 'PSI_PsaG/PsaK_dom', 5, NULL),
(10627, NULL, 'IPR010158', NULL, 'Amidase, carbamoylase-type', 'Amidase_Cbmase', 4, NULL),
(10628, NULL, 'IPR014216', NULL, 'ABC transporter, CydDC cysteine exporter (CydDC-E) family, permease/ATP-binding protein CydD', 'ABC_transptr_CydD', 4, NULL),
(10629, NULL, 'IPR014223', NULL, 'ABC transporter, CydDC cysteine exporter (CydDC-E) family, permease/ATP-binding protein CydC', 'ABC_CydC', 4, NULL),
(10630, NULL, 'IPR015195', NULL, 'SLIDE domain', 'SLIDE', 3, NULL),
(10631, NULL, 'IPR015227', NULL, 'Mitogen, Yersinia pseudotuberculosis', 'Mitogen_YERPS', 4, NULL),
(10632, NULL, 'IPR010792', NULL, 'Protein of unknown function DUF1389', 'DUF1389', 4, NULL),
(10633, NULL, 'IPR023750', NULL, 'RbsD-like superfamily', 'RbsD-like_sf', 5, NULL),
(10634, NULL, 'IPR014497', NULL, 'Methylmalonyl-CoA decarboxylase, delta subunit', 'MeMalonyl-CoA_deCOase_dsu', 4, NULL),
(10635, NULL, 'IPR010164', NULL, 'Ornithine aminotransferase', 'Orn_aminotrans', 4, NULL),
(10636, NULL, 'IPR011672', NULL, 'Protein of unknown function DUF1614', 'DUF1614', 4, NULL),
(10637, NULL, 'IPR011689', NULL, 'PaRep2b', 'PaRep2b', 3, NULL),
(10638, NULL, 'IPR012032', NULL, 'Uncharacterised conserved protein UCP006598', 'UCP006598', 4, NULL),
(10639, NULL, 'IPR007534', NULL, 'Acyl-protein synthetase, LuxE', 'LuxE', 3, NULL),
(10640, NULL, 'IPR007540', NULL, 'Fimbrial major subunit, CS1-type', 'Fimbrial_CS1-type', 4, NULL),
(10641, NULL, 'IPR011648', NULL, 'Circadian clock protein KaiA', 'Circadian_clock_KaiA', 4, NULL),
(10642, NULL, 'IPR010172', NULL, 'CRISPR-associated protein, TM1791', 'CRISPR-assoc_prot_TM1791', 4, NULL),
(10643, NULL, 'IPR010165', NULL, 'CRISPR-associated protein, TM1793', 'CRISPR-assoc_prot_TM1793', 4, NULL),
(10644, NULL, 'IPR007513', NULL, 'Uncharacterised protein family SERF, N-terminal', 'Uncharacterised_SERF_N', 3, NULL),
(10645, NULL, 'IPR011694', NULL, 'Tick salivary peptide group 1', 'TSGP1', 4, NULL),
(10646, NULL, 'IPR011233', NULL, 'Tellurite/Phi/PacB toxicity protection, TerW', 'Tellurite_resist_TerW', 4, NULL),
(10647, NULL, 'IPR014501', NULL, 'Uncharacterised conserved protein UCP019317', 'UCP019317', 4, NULL),
(10648, NULL, 'IPR014500', NULL, 'Uncharacterised conserved protein UCP019307, cupin-type', 'UCP019307_cupin', 4, NULL),
(10649, NULL, 'IPR013800', NULL, 'STAT transcription factor, all-alpha domain', 'STAT_TF_alpha', 3, NULL),
(10650, NULL, 'IPR010789', NULL, 'Terminase small subunit, Skunalikevirus-type', 'Terminase_ssu_Skunalikevirus', 4, NULL),
(10651, NULL, 'IPR016100', NULL, 'Prismane, alpha-bundle', 'Prismane_a-bundle', 5, NULL),
(10652, NULL, 'IPR011676', NULL, 'Domain of unknown function DUF1618', 'DUF1618', 3, NULL),
(10653, NULL, 'IPR010791', NULL, 'AttH domain', 'AttH_dom', 3, NULL),
(10654, NULL, 'IPR011238', NULL, 'Bacterial microcompartment shell protein PduT', 'Micro_shell_prot_PduT', 4, NULL),
(10655, NULL, 'IPR011245', NULL, 'Butyrate kinase', 'Butyrate_kin', 4, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(10656, NULL, 'IPR010159', NULL, 'N-acyl-L-amino-acid amidohydrolase', 'N-acyl_aa_amidohydrolase', 4, NULL),
(10657, NULL, 'IPR010769', NULL, 'Ribosomal RNA aminoglycoside-resistance methyltransferase, Gram-negative bacteria', 'rRNA_MeTrfase_GmN_bac', 4, NULL),
(10658, NULL, 'IPR011191', NULL, 'Uncharacterised protein family Treponema vWA', 'Uncharacterised_Tp_vWA', 4, NULL),
(10659, NULL, 'IPR011695', NULL, 'Tash protein, PEST motif', 'Tash_PEST_motif', 2, NULL),
(10660, NULL, 'IPR012661', NULL, 'Conserved hypothetical protein CHP02448', 'CHP02448', 4, NULL),
(10661, NULL, 'IPR010779', NULL, 'Protein of unknown function DUF1372', 'DUF1372', 4, NULL),
(10662, NULL, 'IPR010138', NULL, 'UDP-2,3-diacylglucosamine hydrolase', 'UDP-diacylglucosamine_Hdrlase', 4, NULL),
(10663, NULL, 'IPR010116', NULL, 'Anthranilate synthase component I, archaeal type', 'Anthranilate_synth_I_arc_typ', 4, NULL),
(10664, NULL, 'IPR005119', NULL, 'LysR, substrate-binding', 'LysR_subst-bd', 3, NULL),
(10665, NULL, 'IPR007535', NULL, 'Catechol dioxygenase, N-terminal', 'Catechol_dOase_N', 3, NULL),
(10666, NULL, 'IPR007531', NULL, 'Dysbindin', 'Dysbindin', 4, NULL),
(10667, NULL, 'IPR010780', NULL, 'Protein of unknown function DUF1375', 'DUF1375', 4, NULL),
(10668, NULL, 'IPR010793', NULL, 'Ribosomal protein L37/S30', 'Ribosomal_L37/S30', 4, NULL),
(10669, NULL, 'IPR011179', NULL, 'Isopentenyl-diphosphate delta-isomerase, FMN-dependent', 'IPdP_isomerase', 4, NULL),
(10670, NULL, 'IPR010795', NULL, 'Prenylcysteine lyase', 'Prenylcys_lyase', 3, NULL),
(10671, NULL, 'IPR011641', NULL, 'Tyrosine-protein kinase ephrin type A/B receptor-like', 'Tyr-kin_ephrin_A/B_rcpt-like', 3, NULL),
(10672, NULL, 'IPR023966', NULL, 'Arginine beta-hydroxylase, Fe2/alpha-ketoglutarate-dependent', 'Arginine_beta-hydroxylase', 4, NULL),
(10673, NULL, 'IPR010134', NULL, 'Polyhydroxyalkanoate synthesis repressor PhaR', 'PHA_reg_PhaR', 4, NULL),
(10674, NULL, 'IPR010812', NULL, 'Hypersensitivity response secretion-like, HrpJ', 'HrpJ-like', 3, NULL),
(10675, NULL, 'IPR011189', NULL, 'Uncharacterised conserved protein, caspase-like', 'UCP_caspase_lke', 4, NULL),
(10676, NULL, 'IPR011167', NULL, 'Iron-dependent fumarate hydratase', 'Fe_dep_fumarate_hydratase', 4, NULL),
(10677, NULL, 'IPR014215', NULL, 'Dipicolinic acid synthetase subunit A', 'Dipicolinic_acid_synth_A', 4, NULL),
(10678, NULL, 'IPR011722', NULL, 'Hemimethylated DNA-binding domain', 'Hemimethylated_DNA-bd_dom', 3, NULL),
(10679, NULL, 'IPR011235', NULL, 'MepB-like', 'MepB-like', 4, NULL),
(10680, NULL, 'IPR011170', NULL, 'Growth factor, vaccinia C11R type', 'GF_C11R', 4, NULL),
(10681, NULL, 'IPR012017', NULL, 'Uncharacterised conserved protein UCP004977', 'UCP004977', 4, NULL),
(10682, NULL, 'IPR010130', NULL, 'Type I secretion outer membrane protein, TolC', 'T1SS_OMP_TolC', 4, NULL),
(10683, NULL, 'IPR023955', NULL, 'D-tagatose-bisphosphate aldolase, class II, subunit GatY', 'TagBP_aldolase_GatY', 4, NULL),
(10684, NULL, 'IPR011664', NULL, 'Abortive infection system protein AbiD/AbiF-like', 'Abi_system_AbiD/AbiF-like', 4, NULL),
(10685, NULL, 'IPR011629', NULL, 'Zinc chaperone CobW-like, C-terminal', 'CobW-like_C', 3, NULL),
(10686, NULL, 'IPR011215', NULL, 'Tellurite-like stress resistance cysteine protease StiP', 'StiP', 4, NULL),
(10687, NULL, 'IPR023252', NULL, 'Aurora borealis protein', 'Aurora_borealis_protein', 4, NULL),
(10688, NULL, 'IPR015214', NULL, 'Pesticidal crystal protein, central domain, Cry2A/18', 'Pest_cryst_cen_dom_Cry2A/18', 3, NULL),
(10689, NULL, 'IPR023963', NULL, 'Methanobactin precursor, Mb-OB3b', 'Methanobactin_OB3b', 4, NULL),
(10690, NULL, 'IPR014240', NULL, 'Regulatory protein, YteA family', 'YteA', 4, NULL),
(10691, NULL, 'IPR011183', NULL, 'Pyrophosphate-dependent phosphofructokinase PfpB', 'PfpB_PPi_PFK', 4, NULL),
(10692, NULL, 'IPR011724', NULL, 'Cyd operon protein YbgT', 'Cyd_oper_YbgT', 4, NULL),
(10693, NULL, 'IPR015191', NULL, 'Translation elongation factor SelB, winged helix, type 3', 'Elong_fac_SelB-wing-hlx_typ-3', 3, NULL),
(10694, NULL, 'IPR010157', NULL, 'CRISPR type I-A/APERN-associated protein Csa5', 'CRISPR-assoc_Cas5', 4, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(10695, NULL, 'IPR014231', NULL, 'Sporulation protein YpjB', 'Spore_YpjB', 4, NULL),
(10696, NULL, 'IPR012014', NULL, 'Retroelement-encoded protein, env-related', 'Retroelement_env', 4, NULL),
(10697, NULL, 'IPR010800', NULL, 'Glycine rich protein', 'GRP', 4, NULL),
(10698, NULL, 'IPR013497', NULL, 'DNA topoisomerase, type IA, central', 'Topo_IA_cen', 3, NULL),
(10699, NULL, 'IPR011206', NULL, 'Citrate lyase beta subunit-like', 'Citrate_lyase_beta/mcl1/mcl2', 4, NULL),
(10700, NULL, 'IPR011219', NULL, 'Rubisco-cytochrome methylase MET', 'Rubisco-cyt_methylase_MET', 4, NULL),
(10701, NULL, 'IPR034887', NULL, 'LARP7, RNA recognition motif 1', 'LARP7_RRM1', 3, NULL),
(10702, NULL, 'IPR012038', NULL, 'Uncharacterised conserved protein UCP009471', 'UCP009471', 4, NULL),
(10703, NULL, 'IPR015173', NULL, 'Bacteriophage T4, Gp12', 'Phage_T4_Gp12', 3, NULL),
(10704, NULL, 'IPR011182', NULL, 'L-aspartate dehydrogenase', 'L-Asp_DH', 4, NULL),
(10705, NULL, 'IPR007527', NULL, 'Zinc finger, SWIM-type', 'Znf_SWIM', 3, NULL),
(10706, NULL, 'IPR011639', NULL, 'Type II restriction enzyme and methyltransferase RM.Eco57I-like', 'RM_methylase_Eco57I-like', 3, NULL),
(10707, NULL, 'IPR010816', NULL, 'Heterokaryon incompatibility Het-C', 'Het-C', 4, NULL),
(10708, NULL, 'IPR012030', NULL, 'Uncharacterised conserved protein UCP006563', 'UCP006563', 4, NULL),
(10709, NULL, 'IPR011688', NULL, 'PVL Orf50 family', 'PVL_Orf50', 4, NULL),
(10710, NULL, 'IPR011723', NULL, 'Zinc finger/thioredoxin putative', 'Znf/thioredoxin_put', 3, NULL),
(10711, NULL, 'IPR010801', NULL, 'Fibronectin-attachment', 'FAP', 4, NULL),
(10712, NULL, 'IPR015213', NULL, 'Cholesterol oxidase, substrate-binding', 'Cholesterol_OX_subst-bd', 3, NULL),
(10713, NULL, 'IPR010146', NULL, 'CRISPR-associated protein, Csn2-type', 'CRISPR-assoc_prot_Csn2-typ', 4, NULL),
(10714, NULL, 'IPR015177', NULL, 'Lyase, catalytic', 'Lyase_catalyt', 3, NULL),
(10715, NULL, 'IPR011174', NULL, 'Ezrin/radixin/moesin', 'ERM', 4, NULL),
(10716, NULL, 'IPR010161', NULL, 'Peptidase M20B, tripeptide aminopeptidase', 'Peptidase_M20B', 4, NULL),
(10717, NULL, 'IPR011217', NULL, 'Streptogramin lyase', 'Streptogrm_lyase', 4, NULL),
(10718, NULL, 'IPR010765', NULL, 'Protein of unknown function DUF1350', 'DUF1350', 4, NULL),
(10719, NULL, 'IPR012037', NULL, 'Alpha/beta-hydrolase family', 'Alpha/beta-hydrolase_fam', 4, NULL),
(10720, NULL, 'IPR007524', NULL, 'Pectate lyase, N-terminal', 'Pec_lyase_N', 3, NULL),
(10721, NULL, 'IPR023965', NULL, 'Capreomycidine synthase', 'Capreomycidine_synthase', 4, NULL),
(10722, NULL, 'IPR014239', NULL, 'Spore germination YpeB', 'Spore_YpeB', 4, NULL),
(10723, NULL, 'IPR016097', NULL, 'Domain of unknown function DUF695', 'DUF695', 3, NULL),
(10724, NULL, 'IPR007541', NULL, 'Uncharacterised protein family, basic secretory protein', 'Uncharacterised_BSP', 4, NULL),
(10725, NULL, 'IPR015182', NULL, 'Quinohemoprotein amine dehydrogenase, alpha subunit, haem binding domain', 'QH-AmDH_asu_heme-bd_dom', 3, NULL),
(10726, NULL, 'IPR011536', NULL, 'Ferredoxin 2Fe-2S type, proteobacteria', 'Fdx_isc', 4, NULL),
(10727, NULL, 'IPR010169', NULL, 'Acetylornithine deacetylase ArgE', 'AcOrn-deacetyl', 4, NULL),
(10728, NULL, 'IPR015234', NULL, 'Domain of unknown function DUF1936', 'DUF1936', 3, NULL),
(10729, NULL, 'IPR011076', NULL, 'Malate synthase superfamily', 'Malate_synth_sf', 5, NULL),
(10730, NULL, 'IPR010775', NULL, 'Protein of unknown function DUF1365', 'DUF1365', 4, NULL),
(10731, NULL, 'IPR014232', NULL, 'Sporulation stage V, protein K', 'Spore_V_K', 4, NULL),
(10732, NULL, 'IPR023742', NULL, 'Iron-sulfur cluster repair protein YftE', 'FeS-repair_YftE', 4, NULL),
(10733, NULL, 'IPR010115', NULL, 'Phosphoenolpyruvate transferase/2-phospho-L-lactate transferase', 'FbiA/CofD', 4, NULL),
(10734, NULL, 'IPR011650', NULL, 'Peptidase M20, dimerisation domain', 'Peptidase_M20_dimer', 3, NULL),
(10735, NULL, 'IPR010770', NULL, 'Ecd family', 'Ecd', 4, NULL),
(10736, NULL, 'IPR012036', NULL, 'Bacteriophage Mu, Probable terminase, large subunit gp28', 'Phage_Mu_Gp28', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(10737, NULL, 'IPR015193', NULL, 'Switch protein XOL-1, GHMP-like', 'Xol-1_GHMP-like', 3, NULL),
(10738, NULL, 'IPR011681', NULL, 'GcrA cell cycle regulator', 'GcrA', 4, NULL),
(10739, NULL, 'IPR011645', NULL, 'Haem NO binding associated', 'HNOB_dom_associated', 3, NULL),
(10740, NULL, 'IPR015180', NULL, 'Bacteriophage T4, Gp27, baseplate hub, C-terminal', 'Phage_T4_Gp27_C', 3, NULL),
(10741, NULL, 'IPR009639', NULL, 'Peptidase A24A-predicted, C-terminal archaea', 'Pept_A24A_C_arc', 3, NULL),
(10742, NULL, 'IPR034193', NULL, 'Proteinase K-like catalytic domain', 'PCSK9_ProteinaseK-like', 3, NULL),
(10743, NULL, 'IPR005118', NULL, 'Transcription-repair-coupling factor, C-terminal domain', 'TRCF_C', 3, NULL),
(10744, NULL, 'IPR007522', NULL, 'CRISPR-associated protein TM1795', 'CRISPR-assoc_prot_TM1795', 4, NULL),
(10745, NULL, 'IPR015174', NULL, 'MIF4G-like, type 2', 'MIF4G-like_typ-2', 3, NULL),
(10746, NULL, 'IPR010137', NULL, 'Acyl-[acyl-carrier-protein]--UDP-N-acetylglucosamine O-acyltransferase', 'Lipid_A_LpxA', 4, NULL),
(10747, NULL, 'IPR011213', NULL, 'Nicotinic acid mononucleotide biosynthesis protein', 'NMN_biosyn', 4, NULL),
(10748, NULL, 'IPR023968', NULL, 'Bacteriocin precursor, CLI3235 family, putative', 'Bacteriocin_CLI3235', 4, NULL),
(10749, NULL, 'IPR011207', NULL, 'Orthopoxvirus protein F1', 'Orthopox_F1', 4, NULL),
(10750, NULL, 'IPR010778', NULL, 'Protein of unknown function DUF1368', 'DUF1368', 4, NULL),
(10751, NULL, 'IPR007523', NULL, 'NDUFAF3/Mth938 domain-containing protein', 'NDUFAF3/AAMDC', 4, NULL),
(10752, NULL, 'IPR005111', NULL, 'MoeA, C-terminal, domain IV', 'MoeA_C_domain_IV', 3, NULL),
(10753, NULL, 'IPR005116', NULL, 'Transport-associated OB, type 1', 'Transp-assoc_OB_typ1', 3, NULL),
(10754, NULL, 'IPR013022', NULL, 'Xylose isomerase-like, TIM barrel domain', 'Xyl_isomerase-like_TIM-brl', 3, NULL),
(10755, NULL, 'IPR010819', NULL, 'N-acylglucosamine 2-epimerase/Cellobiose 2-epimerase', 'AGE/CE', 4, NULL),
(10756, NULL, 'IPR023971', NULL, 'Conserved hypothetical protein CHP04081, GSU1558', 'CHP04081_GSU1558', 4, NULL),
(10757, NULL, 'IPR015187', NULL, 'BRCA2, OB1', 'BRCA2_OB_1', 3, NULL),
(10758, NULL, 'IPR015189', NULL, 'Translation elongation factor SelB, winged helix, type 1', 'Elong_fac_SelB-wing-hlx_typ-1', 3, NULL),
(10759, NULL, 'IPR014217', NULL, 'Sporulation stage III, protein AA', 'Spore_III_AA', 4, NULL),
(10760, NULL, 'IPR010136', NULL, 'N-acetyl-gamma-glutamyl-phosphate reductase, type 2', 'AGPR_type-2', 4, NULL),
(10761, NULL, 'IPR011228', NULL, 'Uncharacterised conserved protein UCP029766', 'UCP029766', 4, NULL),
(10762, NULL, 'IPR010806', NULL, 'Poxvirus, TNF receptor-II, C-terminal', 'Poxvirus_TNF-rcpt-II_C', 3, NULL),
(10763, NULL, 'IPR010139', NULL, 'Imidazole glycerol phosphate synthase, subunit H', 'Imidazole-glycPsynth_HisH', 4, NULL),
(10764, NULL, 'IPR013766', NULL, 'Thioredoxin domain', 'Thioredoxin_domain', 3, NULL),
(10765, NULL, 'IPR011680', NULL, 'Fasciculation and elongation protein zeta, FEZ', 'FEZ', 4, NULL),
(10766, NULL, 'IPR011163', NULL, 'Peptidase S1A, enteropeptidase', 'Pept_S1A_enterop', 4, NULL),
(10767, NULL, 'IPR011698', NULL, 'CobB/CobQ-like glutamine amidotransferase', 'GATase_3', 3, NULL),
(10768, NULL, 'IPR012013', NULL, 'Integrin beta-4 subunit', 'Integrin_bsu-4', 4, NULL),
(10769, NULL, 'IPR015225', NULL, 'tRNA pseudouridine synthase II, TruB, subfamily 2, C-terminal', 'tRNA_psdUridine_synth_fam2_C', 3, NULL),
(10770, NULL, 'IPR010809', NULL, 'Flagellar hook-associated protein 2, C-terminal', 'FliD_C', 3, NULL),
(10771, NULL, 'IPR011662', NULL, 'Secretin/TonB, short N-terminal domain', 'Secretin/TonB_short_N', 3, NULL),
(10772, NULL, 'IPR015181', NULL, 'Bacteriophage T4, Gp27, baseplate hub, N-terminal', 'Phage_T4_Gp27_N', 3, NULL),
(10773, NULL, 'IPR007511', NULL, 'Protein of unknown function DUF501', 'DUF501', 4, NULL),
(10774, NULL, 'IPR007515', NULL, 'Mss4', 'Mss4', 4, NULL),
(10775, NULL, 'IPR011304', NULL, 'L-lactate dehydrogenase', 'L-lactate_DH', 4, NULL),
(10776, NULL, 'IPR010155', NULL, 'CRISPR pre-crRNA endoribonuclease Cas5d', 'CRISPR-assoc_prot_Cas5d', 4, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(10777, NULL, 'IPR011682', NULL, 'Glycosyl hydrolase family 38, C-terminal', 'Glyco_hydro_38_C', 3, NULL),
(10778, NULL, 'IPR011701', NULL, 'Major facilitator superfamily', 'MFS', 4, NULL),
(10779, NULL, 'IPR015232', NULL, 'Domain of unknown function DUF1935', 'DUF1935', 3, NULL),
(10780, NULL, 'IPR014227', NULL, 'Putative transport protein YtvI-like', 'YtvI-like', 4, NULL),
(10781, NULL, 'IPR010766', NULL, 'DRTGG', 'DRTGG', 3, NULL),
(10782, NULL, 'IPR011241', NULL, 'Bifunctional acetylglutamate kinase/N-acetyl-gamma-glutamyl-phosphate reductase', 'NAGK/NAGSA', 4, NULL),
(10783, NULL, 'IPR014496', NULL, 'Uncharacterised conserved protein UCP018863', 'UCP018863', 4, NULL),
(10784, NULL, 'IPR014233', NULL, 'Quinol oxidase subunit I', 'QoxB', 4, NULL),
(10785, NULL, 'IPR015176', NULL, 'Lyase, N-terminal', 'Lyase_N', 3, NULL),
(10786, NULL, 'IPR011188', NULL, 'Uncharacterised protein family UPF0302', 'UPF0302', 4, NULL),
(10787, NULL, 'IPR014218', NULL, 'RNA polymerase sigma-H type', 'RNA_pol_sigma-H', 4, NULL),
(10788, NULL, 'IPR011243', NULL, 'N-acetylglutamate synthase, animal', 'GlcNAc_Synth_met', 4, NULL),
(10789, NULL, 'IPR010815', NULL, 'Protein of unknown function DUF1418', 'DUF1418', 4, NULL),
(10790, NULL, 'IPR011159', NULL, 'Phosphoprotein phosphatase PPZ/Ppq1', 'PPPtase_PPZ/Ppq1', 4, NULL),
(10791, NULL, 'IPR007542', NULL, 'Major capsid protein, C-terminal', 'MCP_C', 3, NULL),
(10792, NULL, 'IPR014495', NULL, 'Uncharacterised conserved protein UCP018671', 'UCP018671', 4, NULL),
(10793, NULL, 'IPR014234', NULL, 'N-acetylmuramoyl-L-alanine amidase CwlD', 'Spore_CwlD', 4, NULL),
(10794, NULL, 'IPR011677', NULL, 'Tectonic domain', 'Tectonic_dom', 3, NULL),
(10795, NULL, 'IPR015199', NULL, 'DNA polymerase III, delta subunit, C-terminal', 'DNA_pol_III_delta_C', 3, NULL),
(10796, NULL, 'IPR010767', NULL, 'Campylobacter phage CGC-2007, Cje0229', 'Phage_CGC-2007_Cje0229', 4, NULL),
(10797, NULL, 'IPR011690', NULL, 'Phosphate-starvation-induced PsiF repeat', 'P_starv_induced_PsiF', 7, NULL),
(10798, NULL, 'IPR011656', NULL, 'Notch, NODP domain', 'Notch_NODP_dom', 3, NULL),
(10799, NULL, 'IPR005110', NULL, 'MoeA, N-terminal and linker domain', 'MoeA_linker/N', 3, NULL),
(10800, NULL, 'IPR021127', NULL, 'CRISPR-associated endonuclease Cas2', 'CRISPR_associated_Cas2', 4, NULL),
(10801, NULL, 'IPR015194', NULL, 'ISWI, HAND domain', 'ISWI_HAND-dom', 3, NULL),
(10802, NULL, 'IPR010772', NULL, 'Protein of unknown function DUF1359', 'DUF1359', 4, NULL),
(10803, NULL, 'IPR010114', NULL, 'DNA-binding transcriptional regulator NtrC', 'Transcript_reg_NtrC', 4, NULL),
(10804, NULL, 'IPR011687', NULL, 'Ribosome biogenesis protein Nop53/GLTSCR2', 'Nop53/GLTSCR2', 4, NULL),
(10805, NULL, 'IPR007516', NULL, 'Coenzyme F420 hydrogenase/dehydrogenase beta subunit, N-terminal', 'Co_F420_Hydgase/DH_bsu_N', 3, NULL),
(10806, NULL, 'IPR015224', NULL, 'Talin, central', 'Talin_cent', 3, NULL),
(10807, NULL, 'IPR011649', NULL, 'KaiB domain', 'KaiB_domain', 3, NULL),
(10808, NULL, 'IPR011534', NULL, 'Aspartate-semialdehyde dehydrogenase, gamma-type', 'Asp_ADH_gamma-type', 4, NULL),
(10809, NULL, 'IPR010811', NULL, 'Domain of unknown function DUF1409', 'DUF1409', 3, NULL),
(10810, NULL, 'IPR005106', NULL, 'Aspartate/homoserine dehydrogenase, NAD-binding', 'Asp/hSer_DH_NAD-bd', 3, NULL),
(10811, NULL, 'IPR011667', NULL, 'Uncharacterised protein family UPF0329', 'UPF0329', 4, NULL),
(10812, NULL, 'IPR011678', NULL, 'ER membrane protein complex subunit 1, C-terminal', 'EMC1_C', 3, NULL),
(10813, NULL, 'IPR015217', NULL, 'Invasin, domain 3', 'Invasin_dom_3', 3, NULL),
(10814, NULL, 'IPR023741', NULL, 'Lipoate-protein ligase A', 'Lipoate_ligase_A', 4, NULL),
(10815, NULL, 'IPR011767', NULL, 'Glutaredoxin active site', 'GLR_AS', 0, NULL),
(10816, NULL, 'IPR005103', NULL, 'Auxiliary Activity family 9', 'AA9', 4, NULL),
(10817, NULL, 'IPR015183', NULL, 'Quinohemoprotein amine dehydrogenase, alpha subunit domain III', 'QH-AmDH_asu_dom_III', 3, NULL),
(10818, NULL, 'IPR010117', NULL, 'Para-aminobenzoate synthase', 'PabB_fungal', 4, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(10819, NULL, 'IPR011640', NULL, 'Ferrous iron transport protein B, C-terminal', 'Fe2_transport_prot_B_C', 3, NULL),
(10820, NULL, 'IPR005216', NULL, 'Citrate lyase ligase', 'Citrate_lyase_ligase', 4, NULL),
(10821, NULL, 'IPR011248', NULL, 'Serine/alanine racemase', 'Serine/alanine_racemase', 4, NULL),
(10822, NULL, 'IPR011665', NULL, 'Brf1, TBP-binding domain', 'BRF1_TBP-bd_dom', 3, NULL),
(10823, NULL, 'IPR034960', NULL, 'Testin, LIM domain 3', 'LIM3_Testin', 3, NULL),
(10824, NULL, 'IPR011172', NULL, 'Poxvirus, TNF-alpha receptor-II', 'Poxvirus_TNF_rcpt-II', 4, NULL),
(10825, NULL, 'IPR005112', NULL, 'dDENN domain', 'dDENN_dom', 3, NULL),
(10826, NULL, 'IPR011644', NULL, 'Heme NO-binding', 'Heme_NO-bd', 3, NULL),
(10827, NULL, 'IPR015196', NULL, 'Peptide-N-glycosidase F, N-terminal', 'PngaseF_N', 3, NULL),
(10828, NULL, 'IPR023756', NULL, 'Glyoxylate/hydroxypyruvate reductase B', 'Glyo/OHPyrv_Rdtase_B', 4, NULL),
(10829, NULL, 'IPR011653', NULL, 'Lipoprotein protein 35', 'Lipoprotein_p35', 4, NULL),
(10830, NULL, 'IPR014235', NULL, 'Peptidoglycan-N-acetylmuramic acid deacetylase PdaA', 'Spore_PdaA', 4, NULL),
(10831, NULL, 'IPR011718', NULL, 'Glutamate--cysteine ligase GshA', 'GshA', 4, NULL),
(10832, NULL, 'IPR016098', NULL, 'Cyclase-associated protein CAP/septum formation inhibitor MinC, C-terminal', 'CAP/MinC_C', 5, NULL),
(10833, NULL, 'IPR023754', NULL, 'Heme A synthase, type 2', 'HemeA_Synthase_type2', 4, NULL),
(10834, NULL, 'IPR005104', NULL, 'Winged helix-turn-helix transcription repressor, HrcA DNA-binding domain', 'WHTH_HrcA_DNA-bd', 3, NULL),
(10835, NULL, 'IPR005113', NULL, 'uDENN domain', 'uDENN_dom', 3, NULL),
(10836, NULL, 'IPR015233', NULL, 'Orange carotenoid-binding protein, N-terminal', 'Orange_carotenoid-bd_N', 3, NULL),
(10837, NULL, 'IPR010794', NULL, 'Maltose operon periplasmic', 'MalM', 4, NULL),
(10838, NULL, 'IPR012665', NULL, 'Trehalose synthase', 'Trehalose_synth', 4, NULL),
(10839, NULL, 'IPR011766', NULL, 'Thiamine pyrophosphate enzyme, C-terminal TPP-binding', 'TPP_enzyme-bd_C', 3, NULL),
(10840, NULL, 'IPR012040', NULL, 'Formylmethanofuran dehydrogenase, subunit D', 'Formylmethanofuran_DH_dsu', 4, NULL),
(10841, NULL, 'IPR014229', NULL, 'Sporulation protein YtfJ', 'Spore_YtfJ', 4, NULL),
(10842, NULL, 'IPR010129', NULL, 'Type I secretion membrane fusion protein, HlyD family', 'T1SS_HlyD', 4, NULL),
(10843, NULL, 'IPR010174', NULL, 'Succinyl-diaminopimelate desuccinylase, DapE', 'Succinyl-DAP_deSuclase_DapE', 4, NULL),
(10844, NULL, 'IPR011660', NULL, 'Antitoxin VapB-like', 'VapB-like', 4, NULL),
(10845, NULL, 'IPR010802', NULL, 'Domain of unknown function DUF1400', 'DUF1400', 3, NULL),
(10846, NULL, 'IPR005117', NULL, 'Nitrite/Sulfite reductase ferredoxin-like domain', 'NiRdtase/SiRdtase_haem-b_fer', 3, NULL),
(10847, NULL, 'IPR010803', NULL, 'Citrus tristeza virus P33', 'CTV_P33', 4, NULL),
(10848, NULL, 'IPR015209', NULL, 'Cytochrome C oxidase subunit IIa, transmembrane domain', 'Cyt_c_oxidase_su2a_TM_dom', 3, NULL),
(10849, NULL, 'IPR010125', NULL, 'Poly(R)-hydroxyalkanoic acid synthase, class III, PhaC subunit', 'PHA_synth_III_C', 4, NULL),
(10850, NULL, 'IPR015205', NULL, 'Tower domain', 'Tower_dom', 3, NULL),
(10851, NULL, 'IPR010820', NULL, 'UBA-like domain DUF1421', 'DUF1421', 3, NULL),
(10852, NULL, 'IPR009637', NULL, 'Transmembrane protein GPR107/GPR108-like', 'GPR107/GPR108-like', 4, NULL),
(10853, NULL, 'IPR011184', NULL, 'DNA mismatch repair Msh2-type', 'DNA_mismatch_repair_Msh2', 4, NULL),
(10854, NULL, 'IPR023967', NULL, 'Conserved hypothetical protein CHP03996, oxidoreductase', 'CHP03996_oxidoreductase', 4, NULL),
(10855, NULL, 'IPR014220', NULL, 'Small acid-soluble spore protein, SspJ', 'SASP_SspJ', 4, NULL),
(10856, NULL, 'IPR011083', NULL, 'Phage tail collar domain', 'Phage_tail_collar_dom', 3, NULL),
(10857, NULL, 'IPR010799', NULL, 'Microcystin LR degradation protein MlrC, C-terminal', 'MlrC_C', 3, NULL),
(10858, NULL, 'IPR005108', NULL, 'HELP', 'HELP', 3, NULL),
(10859, NULL, 'IPR011339', NULL, 'ISC system FeS cluster assembly, IscU scaffold', 'ISC_FeS_clus_asmbl_IscU', 4, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(10860, NULL, 'IPR014230', NULL, 'Sporulation protein YhbH', 'Spore_YhbH', 4, NULL),
(10861, NULL, 'IPR007533', NULL, 'Cytochrome c oxidase assembly protein CtaG/Cox11', 'Cyt_c_oxidase_assmbl_CtaG', 4, NULL),
(10862, NULL, 'IPR010144', NULL, 'CRISPR-associated protein, Csd1-type', 'CRISPR-assoc_prot_Csd1-typ', 4, NULL),
(10863, NULL, 'IPR010773', NULL, 'Mycobacterium phage PG1, Gp7', 'Mycophage_PG1_Gp7', 4, NULL),
(10864, NULL, 'IPR012031', NULL, 'MTH0776-like', 'MTH0776-like', 4, NULL),
(10865, NULL, 'IPR014242', NULL, 'Spore cortex biosynthesis protein, YabQ', 'Spore_cortex_biosyn_YabQ', 4, NULL),
(10866, NULL, 'IPR005105', NULL, 'Protein-PII uridylyltransferase, N-terminal', 'GlnD_Uridyltrans_N', 3, NULL),
(10867, NULL, 'IPR011193', NULL, 'Ornithine/lysine/arginine decarboxylase', 'Orn/lys/arg_de-COase', 4, NULL),
(10868, NULL, 'IPR012028', NULL, 'Uncharacterised conserved protein UCP006529, dinucleotide-utilising ThiF/HesA', 'UCP006529_dinclt', 4, NULL),
(10869, NULL, 'IPR014225', NULL, 'Sporulation stage II, protein D firmicutes', 'Spore_II_D_firmicutes', 4, NULL),
(10870, NULL, 'IPR015222', NULL, 'Phosphatidate cytidylyltransferase, mitochondrial', 'Tam41', 4, NULL),
(10871, NULL, 'IPR015202', NULL, 'Galactose oxidase-like, Early set domain', 'GO-like_E_set', 3, NULL),
(10872, NULL, 'IPR009634', NULL, 'Putative excisionase', 'Put_exci', 4, NULL),
(10873, NULL, 'IPR012027', NULL, 'Formylmethanofuran dehydrogenase, subunit A', 'Formylmethanofuran_DH_asu', 4, NULL),
(10874, NULL, 'IPR010127', NULL, 'Phasin, subfamily 1', 'Phasin_subfam-1', 4, NULL),
(10875, NULL, 'IPR014219', NULL, 'Peptidase S55, sporulation stage IV, protein B', 'Pept_S55_SpoIVB', 4, NULL),
(10876, NULL, 'IPR011204', NULL, 'Virulence protein RhuM-like', 'Virulence_RhuM-like', 4, NULL),
(10877, NULL, 'IPR015210', NULL, 'Type II restriction enzyme NaeI', 'NaeI', 3, NULL),
(10878, NULL, 'IPR035907', NULL, '7,8-Dihydro-6-hydroxymethylpterin-pyrophosphokinase HPPK superfamily', 'Hppk_sf', 5, NULL),
(10879, NULL, 'IPR024704', NULL, 'Structural maintenance of chromosomes protein', 'SMC', 4, NULL),
(10880, NULL, 'IPR011631', NULL, 'Protein of unknown function DUF1600', 'DUF1600', 4, NULL),
(10881, NULL, 'IPR011226', NULL, 'ATP-grasp family', 'ATP-grasp_fam', 4, NULL),
(10882, NULL, 'IPR011212', NULL, 'Poxvirus, Protein B14/B22/C16', 'Poxvirus_B14/B22/C16', 4, NULL),
(10883, NULL, 'IPR011659', NULL, 'WD40-like beta propeller', 'PD40', 7, NULL),
(10884, NULL, 'IPR011618', NULL, 'Sorbitol phosphotransferase enzyme II, N-terminal', 'PTS_EIIBC_GUT_N', 3, NULL),
(10885, NULL, 'IPR014238', NULL, 'Sporulation protein YlmC/YmxH', 'Spore_YlmC/YmxH', 4, NULL),
(10886, NULL, 'IPR012664', NULL, 'Conserved hypothetical protein CHP02452', 'CHP02452', 4, NULL),
(10887, NULL, 'IPR015203', NULL, 'Secreted effector protein SptP, N-terminal domain', 'SptP_N', 3, NULL),
(10888, NULL, 'IPR007525', NULL, 'Coenzyme F420 hydrogenase/dehydrogenase beta subunit, C-terminal', 'FrhB_FdhB_C', 3, NULL),
(10889, NULL, 'IPR016101', NULL, 'CO dehydrogenase, alpha-bundle', 'CO_DH_a-bundle', 5, NULL),
(10890, NULL, 'IPR015186', NULL, 'Exotoxin A, middle domain', 'Exotox-A_middle_dom', 3, NULL),
(10891, NULL, 'IPR010796', NULL, 'B9-type C2 domain', 'C2_B9-type_dom', 4, NULL),
(10892, NULL, 'IPR010776', NULL, 'Homologous-pairing protein 2, winged helix domain', 'Hop2_WH_dom', 3, NULL),
(10893, NULL, 'IPR011224', NULL, 'Ribosomal RNA large subunit methyltransferase M', 'rRNA_MeTrfase_M', 4, NULL),
(10894, NULL, 'IPR014224', NULL, 'Spore cortex-lytic enzyme SleB', 'Spore_cortex_SleB', 4, NULL),
(10895, NULL, 'IPR015198', NULL, 'Bacteriophage T4, MotA, transcription regulator N-terminal', 'Phage_T4_MotA_Tscrpt_reg_N', 3, NULL),
(10896, NULL, 'IPR015228', NULL, 'SWA2-like, ubiquitin-associated domain', 'SWA2_UBA', 3, NULL),
(10897, NULL, 'IPR011220', NULL, 'Uncharacterised conserved protein UCP028205', 'UCP028205', 4, NULL),
(10898, NULL, 'IPR005102', NULL, 'Carbohydrate binding  X2 domain', 'Carbo-bd_X2', 3, NULL),
(10899, NULL, 'IPR011671', NULL, 'tRNA (uracil-O(2)-)-methyltransferase', 'tRNA_uracil_MeTrfase', 4, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(10900, NULL, 'IPR011691', NULL, 'Vesicle transport protein SFT2', 'Vesicle_transpt_SFT2', 4, NULL),
(10901, NULL, 'IPR010813', NULL, 'Protein of unknown function DUF1413', 'DUF1413', 4, NULL),
(10902, NULL, 'IPR010121', NULL, 'Pyruvate, phosphate dikinase', 'Pyruvate_phosphate_dikinase', 4, NULL),
(10903, NULL, 'IPR007532', NULL, 'Poxvirus early transcription factor, large subunit', 'Poxvirus_early-TF_lsu', 4, NULL),
(10904, NULL, 'IPR011670', NULL, 'Protein of unknown function DUF1612', 'DUF1612', 4, NULL),
(10905, NULL, 'IPR011669', NULL, 'Uncharacterised conserved protein UCP026760', 'UCP026760', 4, NULL),
(10906, NULL, 'IPR011166', NULL, 'Beta-eliminating lyase family', 'Beta-eliminating_lyase', 4, NULL),
(10907, NULL, 'IPR015215', NULL, 'BmKX domain', 'BmKX_dom', 3, NULL),
(10908, NULL, 'IPR010128', NULL, 'ATPase, type I secretion system, PrtD-like', 'ATPase_T1SS_PrtD-like', 4, NULL),
(10909, NULL, 'IPR015208', NULL, 'T4 recombination endonuclease VII, dimerisation', 'T4_recomb_endonuclease_dimer', 3, NULL),
(10910, NULL, 'IPR010118', NULL, 'Para-aminobenzoate synthase/anthranilate synthase, component I', 'Para-NH2Bz/anthranilate_synth', 4, NULL),
(10911, NULL, 'IPR010142', NULL, 'Nitrogenase vanadium-iron protein, alpha chain', 'Nase_V-Fe_asu', 4, NULL),
(10912, NULL, 'IPR010797', NULL, 'Peroxisome assembly protein 26', 'Pex26', 4, NULL),
(10913, NULL, 'IPR010785', NULL, 'Autographa californica nuclear polyhedrosis virus (AcMNPV), Protein AC18', 'AcMNPV_AC18', 4, NULL),
(10914, NULL, 'IPR010768', NULL, 'Putative glutamine amidotransferase', 'GATase1-like', 3, NULL),
(10915, NULL, 'IPR015216', NULL, 'SANT associated', 'SANTA', 3, NULL),
(10916, NULL, 'IPR011697', NULL, 'Peptidase C26', 'Peptidase_C26', 4, NULL),
(10917, NULL, 'IPR015223', NULL, 'ATPase MipZ', 'MipZ', 4, NULL),
(10918, NULL, 'IPR012008', NULL, 'Serine/threonine-protein phosphatase with EF-hands', 'Ser/Thr-Pase_EF-hand_contain', 4, NULL),
(10919, NULL, 'IPR010814', NULL, 'Protein of unknown function DUF1416', 'DUF1416', 4, NULL),
(10920, NULL, 'IPR010171', NULL, 'CRISPR system endoribonuclease Csx1', 'CRISPR_Csx1', 4, NULL),
(10921, NULL, 'IPR011635', NULL, 'CARDB domain', 'CARDB', 3, NULL),
(10922, NULL, 'IPR015220', NULL, 'Glucodextranase, N-terminal', 'Glucodextranase_N', 3, NULL),
(10923, NULL, 'IPR010810', NULL, 'Flagellin hook, IN motif', 'Flagellin_hook_IN_motif', 2, NULL),
(10924, NULL, 'IPR011231', NULL, 'Bacteriophage VT1-Sakai, H0018', 'Phage_VT1-Sakai_H0018', 4, NULL),
(10925, NULL, 'IPR014221', NULL, 'Stage II sporulation protein E', 'SpoII_E', 4, NULL),
(10926, NULL, 'IPR010790', NULL, 'Repeat of unknown function DUF1388', 'DUF1388', 7, NULL),
(10927, NULL, 'IPR010807', NULL, 'DUF1407/YfgJ-like', 'DUF1407/YfgJ-like', 4, NULL),
(10928, NULL, 'IPR007509', NULL, 'Protein of unknown function DUF515', 'DUF515', 4, NULL),
(10929, NULL, 'IPR011663', NULL, 'UbiC transcription regulator-associated', 'UTRA', 3, NULL),
(10930, NULL, 'IPR007518', NULL, 'MINDY deubiquitinase', 'MINDY', 4, NULL),
(10931, NULL, 'IPR011679', NULL, 'Endoplasmic reticulum resident protein 29, C-terminal', 'ERp29_C', 3, NULL),
(10932, NULL, 'IPR010147', NULL, 'CRISPR-associated protein, CasD', 'CRISPR-assoc_prot_CasD', 4, NULL),
(10933, NULL, 'IPR011652', NULL, 'MORN variant', 'MORN_2', 7, NULL),
(10934, NULL, 'IPR011686', NULL, 'Omega transcriptional repressor', 'Omega_repress', 3, NULL),
(10935, NULL, 'IPR010133', NULL, 'Bacteriocin-type signal sequence', 'Bacteriocin_signal_seq', 2, NULL),
(10936, NULL, 'IPR011699', NULL, 'Mycoplasma MFS transporter', 'MFS_Mycoplasma', 4, NULL),
(10937, NULL, 'IPR012019', NULL, 'FeGP cofactor biosynthesis protein HcgB, guanylyltransferase', 'HcgB', 4, NULL),
(10938, NULL, 'IPR011720', NULL, 'Thr operon leader peptide', 'Thr_lead_pept', 4, NULL),
(10939, NULL, 'IPR010143', NULL, 'Nitrogenase component 1, alpha chain', 'Nase_comp1_asu', 4, NULL),
(10940, NULL, 'IPR005120', NULL, 'UPF3 domain', 'UPF3_dom', 3, NULL),
(10941, NULL, 'IPR010141', NULL, 'Phosphoribosylformylglycinamidine synthase, FGAM', 'FGAM_synthase', 4, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(10942, NULL, 'IPR010160', NULL, 'CRISPR-associated protein, Cmr5', 'CRISPR-assoc_prot_Cmr5', 4, NULL),
(10943, NULL, 'IPR007529', NULL, 'Zinc finger, HIT-type', 'Znf_HIT', 3, NULL),
(10944, NULL, 'IPR010774', NULL, 'Putative nuclease YbcO', 'YbcO', 4, NULL),
(10945, NULL, 'IPR015928', NULL, 'Aconitase/3-isopropylmalate dehydratase, swivel', 'Aconitase/3IPM_dehydase_swvl', 5, NULL),
(10946, NULL, 'IPR011643', NULL, 'High-CO2 inducible periplasmic protein', 'HCR1', 4, NULL),
(10947, NULL, 'IPR005101', NULL, 'Cryptochrome/DNA photolyase, FAD-binding domain', 'Cryptochr/Photolyase_FAD-bd', 3, NULL),
(10948, NULL, 'IPR011674', NULL, 'Domain of unknown function DUF1616', 'DUF1616', 3, NULL),
(10949, NULL, 'IPR005215', NULL, 'Trigger factor', 'Trig_fac', 4, NULL),
(10950, NULL, 'IPR010123', NULL, 'Poly(R)-hydroxyalkanoic acid synthase, class III, PhaE subunit', 'PHA_synth_III_E', 4, NULL),
(10951, NULL, 'IPR007526', NULL, 'SWIRM domain', 'SWIRM', 3, NULL),
(10952, NULL, 'IPR015179', NULL, 'Alpha-amylase/4-alpha-glucanotransferase, C-terminal', 'A-amylase/a-glucTrfase_C', 3, NULL),
(10953, NULL, 'IPR010771', NULL, 'Intracellular growth attenuator IgaA', 'IgaA', 4, NULL),
(10954, NULL, 'IPR011218', NULL, 'Insecticidal delta endotoxin', 'Insecticidal_delta_endotoxin', 4, NULL),
(10955, NULL, 'IPR005107', NULL, 'CO dehydrogenase flavoprotein, C-terminal', 'CO_DH_flav_C', 3, NULL),
(10956, NULL, 'IPR012659', NULL, 'Conserved hypothetical protein CHP02444', 'CHP02444', 4, NULL),
(10957, NULL, 'IPR010149', NULL, 'CRISPR-associated protein, Csm2 Type III-A', 'CRISPR-assoc_prot_Csm2_III-A', 4, NULL),
(10958, NULL, 'IPR014241', NULL, 'Cytochrome c oxidase, subunit I bacterial type', 'Cyt_c_oxidase_su1_bac', 4, NULL),
(10959, NULL, 'IPR011247', NULL, 'Chemotaxis protein-glutamate methylesterase', 'Chemotax_prot-Glu_Me-esterase', 4, NULL),
(10960, NULL, 'IPR011675', NULL, 'Protein of unknown function DUF1617', 'DUF1617', 4, NULL),
(10961, NULL, 'IPR010788', NULL, 'VDE lipocalin domain', 'VDE_dom', 3, NULL),
(10962, NULL, 'IPR005115', NULL, 'Glycine transporter', 'Gly_transporter', 3, NULL),
(10963, NULL, 'IPR011658', NULL, 'PA14 domain', 'PA14_dom', 3, NULL),
(10964, NULL, 'IPR005099', NULL, 'Pneumovirus NS1 protein', 'Pneumo_NS1', 4, NULL),
(10965, NULL, 'IPR011205', NULL, 'Uncharacterised conserved protein UCP015417, vWA', 'UCP015417_vWA', 4, NULL),
(10966, NULL, 'IPR010787', NULL, 'Protein of unknown function DUF1385', 'DUF1385', 4, NULL),
(10967, NULL, 'IPR011181', NULL, 'Protein VP3, rotavirus', 'VP3_Rotav', 4, NULL),
(10968, NULL, 'IPR010781', NULL, 'Protein of unknown function DUF1376', 'DUF1376', 4, NULL),
(10969, NULL, 'IPR015236', NULL, 'Methylated DNA-protein cysteine methyltransferase, ribonuclease H-like domain', 'MGMT_N', 3, NULL),
(10970, NULL, 'IPR015188', NULL, 'BRCA2, OB3', 'BRCA2_OB_3', 3, NULL),
(10971, NULL, 'IPR010784', NULL, 'Merozoite surface protein-type', 'Merozoite_SPAM', 4, NULL),
(10972, NULL, 'IPR009633', NULL, 'Vaccinia virus, B17', 'Vaccinia_virus_B17', 4, NULL),
(10973, NULL, 'IPR012020', NULL, 'AB hydrolase 4 family', 'ABHD4', 4, NULL),
(10974, NULL, 'IPR013498', NULL, 'DNA topoisomerase, type IA, zn finger', 'Topo_IA_Znf', 3, NULL),
(10975, NULL, 'IPR012039', NULL, 'Uncharacterised conserved protein UCP012281', 'UCP012281', 4, NULL),
(10976, NULL, 'IPR015211', NULL, 'Peptidase M1, leukotriene A4 hydrolase/aminopeptidase C-terminal', 'Peptidase_M1_C', 3, NULL),
(10977, NULL, 'IPR015190', NULL, 'Translation elongation factor SelB, winged helix, type 2', 'Elong_fac_SelB-wing-hlx_typ-2', 3, NULL),
(10978, NULL, 'IPR010120', NULL, 'Probable glutamyl-tRNA(Gln) amidotransferase subunit C, archaea', 'Glu-ADT_subunit_C_archaea', 4, NULL),
(10979, NULL, 'IPR010817', NULL, 'HemY, N-terminal', 'HemY_N', 3, NULL),
(10980, NULL, 'IPR011692', NULL, 'Stress up-regulated Nod 19', 'Stress_up-reg_Nod19', 4, NULL),
(10981, NULL, 'IPR012663', NULL, 'Conserved hypothetical protein CHP02450, tryptophan-rich', 'CHP02450_Tryp', 4, NULL),
(10982, NULL, 'IPR011646', NULL, 'KAP family P-loop domain', 'KAP_P-loop', 3, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(10983, NULL, 'IPR009640', NULL, 'Bacteriophage 933W, L0121, tail fibre, C-terminal', 'Phage_933W_L0121_C', 3, NULL),
(10984, NULL, 'IPR010119', NULL, 'Gluconeogenesis factor', 'Gluconeogen_factor', 4, NULL),
(10985, NULL, 'IPR010162', NULL, 'Peptidase M20B, peptidase T-like', 'PepT-like', 4, NULL),
(10986, NULL, 'IPR011242', NULL, 'Acetylglutamate kinase ArgB, GNAT domain-containing', 'ArgB_GNAT', 4, NULL),
(10987, NULL, 'IPR014503', NULL, 'Clavaminate synthase-like', 'Clavaminate_syn-like', 4, NULL),
(10988, NULL, 'IPR005098', NULL, 'Domain of unknown function DUF281', 'DUF281', 3, NULL),
(10989, NULL, 'IPR011655', NULL, 'M penetrans paralogue 26', 'MpPF26', 4, NULL),
(10990, NULL, 'IPR012029', NULL, 'Uncharacterised conserved protein UCP006557', 'UCP006557', 4, NULL),
(10991, NULL, 'IPR014236', NULL, 'RNA polymerase sigma-F type', 'RNA_pol_sigma-F', 4, NULL),
(10992, NULL, 'IPR010152', NULL, 'CRISPR-associated protein Cas2 subtype', 'CRISPR-assoc_prot_Cas2_sub', 4, NULL),
(10993, NULL, 'IPR034600', NULL, '54S ribosomal protein L36, yeast', 'MRPL36_yeast', 4, NULL),
(10994, NULL, 'IPR010140', NULL, 'Histidinol phosphate phosphatase, HisJ', 'Histidinol_P_phosphatase_HisJ', 4, NULL),
(10995, NULL, 'IPR023746', NULL, 'Transcription regulator HTH, YidZ', 'Tscrpt_reg_YidZ', 4, NULL),
(10996, NULL, 'IPR015212', NULL, 'Regulator of G protein signalling-like domain', 'RGS-like_dom', 3, NULL),
(10997, NULL, 'IPR010154', NULL, 'CRISPR-associated protein Cas7/Cst2/DevR', 'CRISPR-assoc_Cas7/Cst2/DevR', 4, NULL),
(10998, NULL, 'IPR034601', NULL, 'Ragulator complex protein LAMTOR4', 'LAMTOR4', 4, NULL),
(10999, NULL, 'IPR015207', NULL, 'Protein of unknown function DUF1931', 'DUF1931', 4, NULL),
(11000, NULL, 'IPR011190', NULL, 'N-acetylglutamate synthase, fungal', 'GlcNAc_Synth_fun', 4, NULL),
(11001, NULL, 'IPR016148', NULL, 'Pili assembly chaperone, C-terminal', 'Pili_assmbl_chaperone_C', 3, NULL),
(11002, NULL, 'IPR014793', NULL, 'Dissimilatory sulphite reductase D', 'DsrD', 3, NULL),
(11003, NULL, 'IPR016014', NULL, 'Clusterin, N-terminal', 'Clusterin_N', 3, NULL),
(11004, NULL, 'IPR015701', NULL, 'Ferredoxin--NADP reductase', 'FNR', 4, NULL),
(11005, NULL, 'IPR013328', NULL, '6-phosphogluconate dehydrogenase, domain 2', '6PGD_dom2', 5, NULL),
(11006, NULL, 'IPR011935', NULL, 'Conserved hypothetical protein CHP02231', 'CHP02231', 4, NULL),
(11007, NULL, 'IPR024274', NULL, 'Anaphase-promoting complex, subunit 9', 'APC9', 4, NULL),
(11008, NULL, 'IPR006124', NULL, 'Metalloenzyme', 'Metalloenzyme', 3, NULL),
(11009, NULL, 'IPR034919', NULL, 'Calcipressin-2, RNA recognition motif', 'RCAN2_RRM', 3, NULL),
(11010, NULL, 'IPR013606', NULL, 'IMD/I-BAR domain', 'I-BAR_dom', 3, NULL),
(11011, NULL, 'IPR013385', NULL, 'Type III secretion system apparatus protein YscQ/HrcQ/SpaO', 'T3SS_SpaO/YscQ/SpaO', 4, NULL),
(11012, NULL, 'IPR034912', NULL, 'Neutrophil cytosol factor 4, PX domain', 'PX_p40phox', 3, NULL),
(11013, NULL, 'IPR005225', NULL, 'Small GTP-binding protein domain', 'Small_GTP-bd_dom', 3, NULL),
(11014, NULL, 'IPR013324', NULL, 'RNA polymerase sigma factor, region 3/4-like', 'RNA_pol_sigma_r3/r4-like', 5, NULL),
(11015, NULL, 'IPR009651', NULL, 'Putative methionine gamma-lyase', 'Met_g_lyase_put', 4, NULL),
(11016, NULL, 'IPR011931', NULL, 'Tyrosine recombinase XerC', 'Recomb_XerC', 4, NULL),
(11017, NULL, 'IPR012045', NULL, 'Peptidase M6, unassigned InhA-related', 'Pept_M6_InhA-rel', 4, NULL),
(11018, NULL, 'IPR011110', NULL, 'Two component regulator propeller', 'Reg_prop', 7, NULL),
(11019, NULL, 'IPR013618', NULL, 'Protein O-mannosyl-transferase TMTC, DUF1736', 'TMTC_DUF1736', 3, NULL),
(11020, NULL, 'IPR011098', NULL, 'G5 domain', 'G5_dom', 3, NULL),
(11021, NULL, 'IPR023976', NULL, 'Conserved hypothetical protein CHP04031, Htur1727', 'CHP04031_Htur1727', 4, NULL),
(11022, NULL, 'IPR014266', NULL, 'PEP-CTERM system TPR-repeat lipoprotein, putative', 'PEP-CTERM_TPR_lipo', 4, NULL),
(11023, NULL, 'IPR013604', NULL, '7TM chemoreceptor', '7TM_chemorcpt', 4, NULL),
(11024, NULL, 'IPR012048', NULL, 'Formylmethanofuran dehydrogenase, fused subunit C/D', 'Formylmethanofuran_DH_csu/dsu', 4, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(11025, NULL, 'IPR023986', NULL, 'Glycosyltransferase, putative, MSMEG0565 family', 'GlycosylTfrase_MSMEG0565', 4, NULL),
(11026, NULL, 'IPR006189', NULL, 'CHASE domain', 'CHASE_dom', 3, NULL),
(11027, NULL, 'IPR011099', NULL, 'Glycosyl hydrolase family 67, C-terminal', 'Glyco_hydro_67_C', 3, NULL),
(11028, NULL, 'IPR006177', NULL, 'Staphylococcal/streptococcal toxin, bacterial', 'Toxin_bac', 4, NULL),
(11029, NULL, 'IPR013390', NULL, 'Type III secretion protein HpaP', 'T3SS_HpaP', 4, NULL),
(11030, NULL, 'IPR023973', NULL, 'Conserved hypothetical protein CHP04061, AZL007950', 'CHP04061_AZL007950', 4, NULL),
(11031, NULL, 'IPR014507', NULL, 'Baseplate assembly protein J, predicted', 'Baseplate_assembly_J_pred', 4, NULL),
(11032, NULL, 'IPR014038', NULL, 'Translation elongation factor EF1B, beta/delta subunit, guanine nucleotide exchange domain', 'EF1B_bsu/dsu_GNE', 3, NULL),
(11033, NULL, 'IPR016009', NULL, 'tRNA methyltransferase TRMD/TRM10-type domain', 'tRNA_MeTrfase_TRMD/TRM10', 3, NULL),
(11034, NULL, 'IPR013399', NULL, 'CRISPR-associated protein Csy3', 'CRISPR-assoc_prot_Csy3', 4, NULL),
(11035, NULL, 'IPR014262', NULL, 'Extracellular HAF', 'Extracellular_HAF', 7, NULL),
(11036, NULL, 'IPR013780', NULL, 'Glycosyl hydrolase, all-beta', 'Glyco_hydro_b', 5, NULL),
(11037, NULL, 'IPR014801', NULL, 'Mediator complex, subunit Med5, fungi', 'Mediator_Med5_fun', 4, NULL),
(11038, NULL, 'IPR013056', NULL, 'Bacteriophage lambda, CIII, regulatory protein', 'Phage_lambda_CIII', 4, NULL),
(11039, NULL, 'IPR012042', NULL, 'Inorganic triphosphatase NeuTTM/CthTTM-like', 'NeuTTM/CthTTM-like', 4, NULL),
(11040, NULL, 'IPR005243', NULL, 'Redox-active disulphide protein 2', 'Redox_disulphide_2', 4, NULL),
(11041, NULL, 'IPR001653', NULL, 'Diaminopimelate epimerase, DapF', 'DAP_epimerase_DapF', 4, NULL),
(11042, NULL, 'IPR014248', NULL, 'Spore coat assembly protein SafA', 'Spore_coat_assembly_SafA', 3, NULL),
(11043, NULL, 'IPR014797', NULL, 'CKK domain', 'CKK_domain', 3, NULL),
(11044, NULL, 'IPR011094', NULL, 'Uncharacterised protein family, LppY/LpqO', 'Uncharacterised_LppY/LpqO', 4, NULL),
(11045, NULL, 'IPR011589', NULL, 'Protein of unknown function UCP004961', 'UCP004961', 4, NULL),
(11046, NULL, 'IPR006148', NULL, 'Glucosamine/galactosamine-6-phosphate isomerase', 'Glc/Gal-6P_isomerase', 3, NULL),
(11047, NULL, 'IPR006206', NULL, 'Mevalonate/galactokinase', 'Mevalonate/galactokinase', 4, NULL),
(11048, NULL, 'IPR011123', NULL, 'Two component regulator three Y', 'Y_Y_Y', 3, NULL),
(11049, NULL, 'IPR006223', NULL, 'Glycine cleavage system T protein', 'GCS_T', 4, NULL),
(11050, NULL, 'IPR011102', NULL, 'Signal transduction histidine kinase, HWE region', 'Sig_transdc_His_kinase_HWE', 3, NULL),
(11051, NULL, 'IPR016123', NULL, 'Mog1/PsbP, alpha/beta/alpha sandwich', 'Mog1/PsbP_a/b/a-sand', 5, NULL),
(11052, NULL, 'IPR011929', NULL, 'NlpC/P60 family, putative phage cell wall peptidase', 'Phage_pept_NlpC/P60', 4, NULL),
(11053, NULL, 'IPR013607', NULL, 'Phospholipase A2-like domain', 'Phospholipase_A2-like', 3, NULL),
(11054, NULL, 'IPR014245', NULL, 'Sporulation stage III, protein AF', 'Spore_III_AF', 4, NULL),
(11055, NULL, 'IPR016107', NULL, 'Adenovirus Pll, hexon, N-terminal', 'Adenovirus_Pll_hexon_N', 3, NULL),
(11056, NULL, 'IPR013396', NULL, 'CRISPR-associated endoribonuclease Cas6/Csy4, subtype I-F/YPEST', 'CRISPR-assoc_prot_Csy4', 4, NULL),
(11057, NULL, 'IPR014261', NULL, 'Sulphite reductase, subunit C', 'Sulphite_reductase_C', 4, NULL),
(11058, NULL, 'IPR016149', NULL, 'Casein kinase II, regulatory subunit, N-terminal', 'Casein_kin_II_reg-sub_N', 5, NULL),
(11059, NULL, 'IPR014259', NULL, 'Sulphite reductase, subunit A', 'Sulphite_reductase_A', 4, NULL),
(11060, NULL, 'IPR013381', NULL, 'CRISPR-associated protein Cse1', 'CRISPR-assoc_prot_Cse1', 4, NULL),
(11061, NULL, 'IPR005246', NULL, 'O-phosphoseryl-tRNA(Cys) ligase', 'O-Pseryl-tRNA(Cys)_ligase', 4, NULL),
(11062, NULL, 'IPR005217', NULL, 'Iron permease FTR1-like', 'FTR1-like', 4, NULL),
(11063, NULL, 'IPR016110', NULL, 'Adenovirus Pll, hexon, subdomain 3', 'Adenovirus_Pll_hexon_sub3', 5, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(11064, NULL, 'IPR006184', NULL, '6-phosphogluconate-binding site', '6PGdom_BS', 1, NULL),
(11065, NULL, 'IPR011970', NULL, 'Lytic murein transglycosylase', 'MltB_2', 3, NULL),
(11066, NULL, 'IPR014252', NULL, 'Sporulation protease LonC', 'Spore_LonC', 4, NULL),
(11067, NULL, 'IPR013776', NULL, 'Alpha-amylase, thermostable', 'A-amylase_thermo', 4, NULL),
(11068, NULL, 'IPR006232', NULL, 'Sucrose-6-phosphate hydrolase', 'Suc6P_hydrolase', 4, NULL),
(11069, NULL, 'IPR011112', NULL, 'Rho termination factor, N-terminal', 'Rho_N', 3, NULL),
(11070, NULL, 'IPR014512', NULL, 'Predicted O-glycosyl hydrolase', 'O_gly_hydro', 4, NULL),
(11071, NULL, 'IPR006230', NULL, 'Protein MutL', 'MutL', 4, NULL),
(11072, NULL, 'IPR006186', NULL, 'Serine/threonine-specific protein phosphatase/bis(5-nucleosyl)-tetraphosphatase', 'Ser/Thr-sp_prot-phosphatase', 3, NULL),
(11073, NULL, 'IPR011924', NULL, 'Lipoprotein releasing system, ATP-binding protein', 'LolD_lipo_ATP-bd', 4, NULL),
(11074, NULL, 'IPR015712', NULL, 'DNA-directed RNA polymerase, subunit 2', 'DNA-dir_RNA_pol_su2', 4, NULL),
(11075, NULL, 'IPR012052', NULL, 'Sporulation transcription factor Spo0A', 'Spore_0_A', 4, NULL),
(11076, NULL, 'IPR011950', NULL, 'HAD-superfamily hydrolase, subfamily IA, CTE7', 'HAD-SF_hydro_IA_CTE7', 4, NULL),
(11077, NULL, 'IPR005237', NULL, 'Uncharacterised protein MJ0570', 'MJ0570', 4, NULL),
(11078, NULL, 'IPR014791', NULL, 'Baseplate structural protein Gp11', 'Baseplate_struct_Gp11', 4, NULL),
(11079, NULL, 'IPR011920', NULL, 'Lipid A biosynthesis lauroyl (or palmitoleoyl) acyltransferase', 'Lipid_A_LpxL_LpxP', 4, NULL),
(11080, NULL, 'IPR011122', NULL, 'WavE lipopolysaccharide synthesis', 'WavE', 4, NULL),
(11081, NULL, 'IPR023987', NULL, 'Conserved hypothetical protein CHP03977, oxidoreductase', 'CHP03977_oxidoreductase', 4, NULL),
(11082, NULL, 'IPR011109', NULL, 'DNA-binding recombinase domain', 'DNA_bind_recombinase_dom', 3, NULL),
(11083, NULL, 'IPR023983', NULL, 'DNA sulphur modification system-associated protein 4', 'DNA_S_mod_dnd_assoc_4', 4, NULL),
(11084, NULL, 'IPR034890', NULL, 'Rrp7A, RNA recognition motif', 'Rrp7A_RRM', 3, NULL),
(11085, NULL, 'IPR014353', NULL, 'Membrane-bound alcohol dehydrogenase, cytochrome c subunit', 'Membr-bd_ADH_cyt_c', 4, NULL),
(11086, NULL, 'IPR011963', NULL, '2,3-dihydroxybenzoate-AMP ligase', 'DHB_AMP_lig', 4, NULL),
(11087, NULL, 'IPR013506', NULL, 'DNA topoisomerase, type IIA, subunit B, domain 2', 'Topo_IIA_bsu_dom2', 3, NULL),
(11088, NULL, 'IPR011095', NULL, 'D-alanine--D-alanine ligase, C-terminal', 'Dala_Dala_lig_C', 3, NULL),
(11089, NULL, 'IPR014250', NULL, 'Quinol oxidase subunit IV', 'QoxD', 4, NULL),
(11090, NULL, 'IPR006178', NULL, 'Major allergen I polypeptide chain 1', 'CH1-like', 4, NULL),
(11091, NULL, 'IPR014251', NULL, 'Sporulation protease LonB', 'Spore_LonB', 4, NULL),
(11092, NULL, 'IPR013374', NULL, 'ATPase, type IV, pilus assembly, PilB', 'ATPase_typ4_pilus-assembl_PilB', 4, NULL),
(11093, NULL, 'IPR016135', NULL, 'Ubiquitin-conjugating enzyme/RWD-like', 'UBQ-conjugating_enzyme/RWD', 5, NULL),
(11094, NULL, 'IPR012043', NULL, 'Pantoate kinase', 'PoK', 4, NULL),
(11095, NULL, 'IPR011941', NULL, 'DNA recombination/repair protein Rad51', 'DNA_recomb/repair_Rad51', 4, NULL),
(11096, NULL, 'IPR006195', NULL, 'Aminoacyl-tRNA synthetase, class II', 'aa-tRNA-synth_II', 3, NULL),
(11097, NULL, 'IPR013605', NULL, 'Spider toxin omega agotoxin/Tx1 family', 'Toxin_34', 4, NULL),
(11098, NULL, 'IPR011120', NULL, 'Neutral trehalase Ca2+ binding', 'Trehalase_Ca-bd', 3, NULL),
(11099, NULL, 'IPR011108', NULL, 'Zn-dependent metallo-hydrolase, RNA specificity domain', 'RMMBL', 3, NULL),
(11100, NULL, 'IPR014800', NULL, 'Apx/Shrm Domain 1', 'ASD1_dom', 3, NULL),
(11101, NULL, 'IPR034610', NULL, 'L-fuconate dehydratase', 'L-fuconate_dehydratase', 4, NULL),
(11102, NULL, 'IPR005248', NULL, 'Nicotinate/nicotinamide nucleotide adenylyltransferase', 'NadD/NMNAT', 4, NULL),
(11103, NULL, 'IPR011602', NULL, 'Type II pantothenate kinase, bacterial', 'Type_II_PanK_bac', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(11104, NULL, 'IPR016136', NULL, 'DNA helicase DnaB, N-terminal/DNA primase DnaG, C-terminal', 'DNA_helicase_N/primase_C', 5, NULL),
(11105, NULL, 'IPR011116', NULL, 'SecA Wing/Scaffold', 'SecA_Wing/Scaffold', 3, NULL),
(11106, NULL, 'IPR014260', NULL, 'Sulphite reductase, subunit B', 'Sulphite_reductase_B', 4, NULL),
(11107, NULL, 'IPR011090', NULL, 'Integrating conjugative element protein, PFL4709', 'Integr_conj_element_PFL4709', 4, NULL),
(11108, NULL, 'IPR013377', NULL, 'Peptidoglycan hydrolase FlgJ', 'FlaJ', 4, NULL),
(11109, NULL, 'IPR006222', NULL, 'Aminomethyltransferase, folate-binding domain', 'GCV_T_N', 3, NULL),
(11110, NULL, 'IPR011559', NULL, 'Initiation factor 2B alpha/beta/delta', 'Initiation_fac_2B_a/b/d', 4, NULL),
(11111, NULL, 'IPR013987', NULL, 'Protein YjdM, N-terminal', 'YjdM_N', 3, NULL),
(11112, NULL, 'IPR011928', NULL, 'Bacteriophage phiJL001, Gp84', 'Phage_phiJL001_Gp84', 4, NULL),
(11113, NULL, 'IPR034789', NULL, 'Bifunctional aldehyde-alcohol dehydrogenase, C-terminal domain', 'AAD_C', 3, NULL),
(11114, NULL, 'IPR014789', NULL, 'Poly(A)-specific ribonuclease, RNA-binding', 'PolyA-riboNase_RNA-binding', 3, NULL),
(11115, NULL, 'IPR013325', NULL, 'RNA polymerase sigma factor, region 2', 'RNA_pol_sigma_r2', 5, NULL),
(11116, NULL, 'IPR014343', NULL, 'Ectoine/hydroxyectoine ABC transporter, ATP-binding protein', 'Ectoine_EhuA', 4, NULL),
(11117, NULL, 'IPR011975', NULL, 'Phenylacetic acid degradation protein PaaN2', 'PaaN_2', 4, NULL),
(11118, NULL, 'IPR011971', NULL, 'Conserved hypothetical protein CHP02284', 'CHP02284', 4, NULL),
(11119, NULL, 'IPR023981', NULL, 'Pre-mycofactocin glycosyltransferase', 'MftF', 4, NULL),
(11120, NULL, 'IPR011954', NULL, 'Benzoyl-CoA reductase, subunit A', 'Benzoyl_CoA_Rdtase_A', 4, NULL),
(11121, NULL, 'IPR014340', NULL, 'Lipopolysaccharide export system protein LptA', 'LptA', 4, NULL),
(11122, NULL, 'IPR023974', NULL, 'His-Xaa-Ser system protein HxsD', 'HxsD', 4, NULL),
(11123, NULL, 'IPR011106', NULL, 'Seven cysteines, N-terminal', 'MANSC_N', 3, NULL),
(11124, NULL, 'IPR011926', NULL, 'Lipoprotein-releasing system transmembrane protein LolE, gammaproteobacteria type', 'LolE_gammaproteobact', 4, NULL),
(11125, NULL, 'IPR011955', NULL, 'Benzoyl-CoA reductase, subunit B', 'Benzoyl_CoA_Rdtase_B', 4, NULL),
(11126, NULL, 'IPR011925', NULL, 'Lipoprotein-releasing system transmembrane protein LolC/E', 'LolCE_TM', 4, NULL),
(11127, NULL, 'IPR014270', NULL, 'PEP-CTERM integral membrane protein', 'PEP-CTERM_IMP', 4, NULL),
(11128, NULL, 'IPR013636', NULL, 'Armadillo-like helical domain-containing protein 3, C-terminal', 'ARMH3_C', 3, NULL),
(11129, NULL, 'IPR006205', NULL, 'Mevalonate kinase', 'Mev_gal_kin', 4, NULL),
(11130, NULL, 'IPR011100', NULL, 'Glycosyl hydrolase family 67, catalytic domain', 'Glyco_hydro_67_cat', 3, NULL),
(11131, NULL, 'IPR006218', NULL, 'DAHP synthetase I/KDSA', 'DAHP1/KDSA', 3, NULL),
(11132, NULL, 'IPR009652', NULL, 'Programmed cell death protein 10', 'PDCD10', 4, NULL),
(11133, NULL, 'IPR009655', NULL, 'Preflagellin peptidase, C-terminal', 'Preflagellin_peptidase_C', 3, NULL),
(11134, NULL, 'IPR009656', NULL, 'PHB de-polymerase, C-terminal', 'PHB_depo_C', 3, NULL),
(11135, NULL, 'IPR013988', NULL, 'Protein YjdM, C-terminal', 'YjdM_C', 3, NULL),
(11136, NULL, 'IPR009650', NULL, 'Fijivirus P9-2', 'Fijivirus_P9-2', 4, NULL),
(11137, NULL, 'IPR013375', NULL, 'O-phosphoseryl-tRNA:Cys-tRNA synthase, archaea', 'Sep_Cys-tRNA_synth_arc', 4, NULL),
(11138, NULL, 'IPR014246', NULL, 'Quinol oxidase subunit III', 'QoxC', 4, NULL),
(11139, NULL, 'IPR013598', NULL, 'Exportin-1/Importin-beta-like', 'Exportin-1/Importin-b-like', 3, NULL),
(11140, NULL, 'IPR023980', NULL, 'Conserved hypothetical protein CHP04013, B12-binding/radical SAM-type', 'CHP04013_B12-bd/rSAM', 4, NULL),
(11141, NULL, 'IPR016102', NULL, 'Succinyl-CoA synthetase-like', 'Succinyl-CoA_synth-like', 5, NULL),
(11142, NULL, 'IPR014257', NULL, 'Cytochrome c oxidase, subunit IV bacillaceae', 'Cyt_c_oxidase_su4_bacillaceae', 4, NULL),
(11143, NULL, 'IPR034786', NULL, 'Maleylacetate reductase', 'MAR', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(11144, NULL, 'IPR016151', NULL, 'DNA mismatch repair protein MutS, N-terminal', 'DNA_mismatch_repair_MutS_N', 5, NULL),
(11145, NULL, 'IPR014514', NULL, 'Uncharacterised conserved protein UCP021940', 'UCP021940', 4, NULL),
(11146, NULL, 'IPR013627', NULL, 'DNA polymerase alpha, subunit B, N-terminal', 'Pol_alpha_B_N', 3, NULL),
(11147, NULL, 'IPR010831', NULL, 'Interleukin-23 alpha', 'IL-23_alpha', 4, NULL),
(11148, NULL, 'IPR013786', NULL, 'Acyl-CoA dehydrogenase/oxidase, N-terminal', 'AcylCoA_DH/ox_N', 3, NULL),
(11149, NULL, 'IPR013373', NULL, 'Flagellin/pilin, N-terminal', 'Flagellin/pilin_N', 3, NULL),
(11150, NULL, 'IPR011119', NULL, 'Uncharacterised domain, helicase/relaxase, putative', 'Unchr_helicase_relaxase_TraI', 3, NULL),
(11151, NULL, 'IPR005218', NULL, 'Diacylglycerol/lipid kinase', 'Diacylglycerol/lipid_kinase', 4, NULL),
(11152, NULL, 'IPR006153', NULL, 'Cation/H+ exchanger', 'Cation/H_exchanger', 3, NULL),
(11153, NULL, 'IPR014258', NULL, 'CAP domain, YkwD-like', 'CAP_domain_YkwD-like', 3, NULL),
(11154, NULL, 'IPR014358', NULL, 'Enoyl-[acyl-carrier-protein] reductase (NADH)', 'Enoyl-ACP_Rdtase_NADH', 4, NULL),
(11155, NULL, 'IPR014256', NULL, 'Sporulation stage VI, protein D', 'Spore_VI_D', 4, NULL),
(11156, NULL, 'IPR034595', NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex assembly factor 8', 'NDUFAF8', 4, NULL),
(11157, NULL, 'IPR013610', NULL, 'N-terminal domain of anti-restriction factor ArdC', 'ArdC_N', 3, NULL),
(11158, NULL, 'IPR011603', NULL, '2-oxoglutarate dehydrogenase E1 component', '2oxoglutarate_DH_E1', 4, NULL),
(11159, NULL, 'IPR012041', NULL, 'CPxCG-like zinc finger protein', 'Znf_CPxCG-like', 4, NULL),
(11160, NULL, 'IPR005220', NULL, 'Bacterial OB-fold', 'BOF', 3, NULL),
(11161, NULL, 'IPR034100', NULL, 'Small nuclear ribonucleoprotein F', 'Sm_F', 4, NULL),
(11162, NULL, 'IPR014513', NULL, 'Uncharacterised conserved protein UCP021525', 'UCP021525', 4, NULL),
(11163, NULL, 'IPR005227', NULL, 'Putative pre-16S rRNA nuclease', 'YqgF', 4, NULL),
(11164, NULL, 'IPR011949', NULL, 'HAD-superfamily hydrolase, subfamily IA, REG-2-like', 'HAD-SF_hydro_IA_REG-2-like', 4, NULL),
(11165, NULL, 'IPR013623', NULL, 'NADPH oxidase Respiratory burst', 'NADPH_Ox', 3, NULL),
(11166, NULL, 'IPR011930', NULL, 'Cell division protein FtsN', 'FtsN', 4, NULL),
(11167, NULL, 'IPR016115', NULL, 'Bacteriophage PRD1, P3, N-terminal', 'Phage_PRD1_P3_N', 5, NULL),
(11168, NULL, 'IPR016132', NULL, 'Phytochrome chromophore attachment domain', 'Phyto_chromo_attachment', 3, NULL),
(11169, NULL, 'IPR006207', NULL, 'Cystine knot, C-terminal', 'Cys_knot_C', 3, NULL),
(11170, NULL, 'IPR013395', NULL, 'Helicase Cas3, CRISPR-associated, Yersinia-type', 'Helicase_Cas3_CRISPR-ass_yers', 4, NULL),
(11171, NULL, 'IPR011919', NULL, 'Cell division protein ZipA', 'Cell_div_ZipA', 4, NULL),
(11172, NULL, 'IPR015951', NULL, 'Chemokine-binding M3, subdomain 2, viral', 'Chemokine-bd_M3_sub2_vir', 5, NULL),
(11173, NULL, 'IPR010827', NULL, 'POTRA domain, BamA/TamA-like', 'BamA/TamA_POTRA', 3, NULL),
(11174, NULL, 'IPR011943', NULL, 'HAD-superfamily hydrolase, subfamily IIID', 'HAD-SF_hydro_IIID', 3, NULL),
(11175, NULL, 'IPR011087', NULL, 'Domain of unknown function DUF1522', 'DUF1522', 3, NULL),
(11176, NULL, 'IPR014249', NULL, 'Sporulation stage V protein B', 'Spore_V_B', 4, NULL),
(11177, NULL, 'IPR006183', NULL, '6-phosphogluconate dehydrogenase', 'Pgluconate_DH', 4, NULL),
(11178, NULL, 'IPR005236', NULL, 'Dihydropteroate synthase-related protein synthase-related protein', 'Dihydropt_synth', 4, NULL),
(11179, NULL, 'IPR013632', NULL, 'DNA recombination and repair protein Rad51-like, C-terminal', 'DNA_recomb/repair_Rad51_C', 3, NULL),
(11180, NULL, 'IPR009660', NULL, 'Bacteriophage A500, Gp15', 'Phage_A500_Gp15', 4, NULL),
(11181, NULL, 'IPR011969', NULL, 'Clan AA aspartic peptidase, C-terminal', 'Clan_AA_Asp_peptidase_C', 3, NULL),
(11182, NULL, 'IPR014786', NULL, 'Anaphase-promoting complex subunit 2, C-terminal', 'APC2_C', 3, NULL),
(11183, NULL, 'IPR014255', NULL, 'Spore coat protein CotS', 'Spore_coat_CotS', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(11184, NULL, 'IPR005250', NULL, 'Ribose-1,5-bisphosphate isomerase, e2b2 family', 'Ribulose_e2b2', 4, NULL),
(11185, NULL, 'IPR013389', NULL, 'CRISPR-associated protein Cas8b', 'CRISPR-assoc_prot_Cas8b', 4, NULL),
(11186, NULL, 'IPR013392', NULL, 'Type III secretion protein HrpB7', 'T3SS_HrpB7', 4, NULL),
(11187, NULL, 'IPR013603', NULL, 'TRASH transcription regulator C-terminal, archaeal', 'TRASH_TR_C_arc', 3, NULL),
(11188, NULL, 'IPR016106', NULL, 'Histidine decarboxylase proenzyme, N-terminal', 'Pyr-dep_his-deCO2ase_N', 5, NULL),
(11189, NULL, 'IPR034914', NULL, 'HuB, RNA recognition motif 3', 'HuB_RRM3', 3, NULL),
(11190, NULL, 'IPR014787', NULL, 'Phosphoserine phosphatase RsbU, N-terminal', 'PSer_Pase_RsbU_N', 3, NULL),
(11191, NULL, 'IPR016112', NULL, 'Group II dsDNA virus coat/capsid protein', 'VP_dsDNA_II', 5, NULL),
(11192, NULL, 'IPR011105', NULL, 'Cell wall hydrolase, SleB', 'Cell_wall_hydrolase_SleB', 3, NULL),
(11193, NULL, 'IPR011952', NULL, 'CD-NTase-associated protein 3', 'CAP3', 4, NULL),
(11194, NULL, 'IPR023975', NULL, 'Six-cysteine peptide SCIFF', 'Six-Cys_pep_SCIFF', 4, NULL),
(11195, NULL, 'IPR009653', NULL, 'Protein kish', 'Ksh1', 4, NULL),
(11196, NULL, 'IPR016117', NULL, 'ArgJ-like domain superfamily', 'ArgJ-like_dom_sf', 5, NULL),
(11197, NULL, 'IPR011118', NULL, 'Tannase/feruloyl esterase', 'Tannase/feruloyl_esterase', 4, NULL),
(11198, NULL, 'IPR012046', NULL, 'LytTR transcriptional regulator with ABC transporter ATP-binding domain', 'LytTR_ABC', 4, NULL),
(11199, NULL, 'IPR006214', NULL, 'Bax inhibitor 1-related', 'Bax_inhibitor_1-related', 4, NULL),
(11200, NULL, 'IPR011957', NULL, 'Benzoate-CoA ligase family', 'Benz_CoA_lig', 4, NULL),
(11201, NULL, 'IPR006212', NULL, 'Furin-like repeat', 'Furin_repeat', 7, NULL),
(11202, NULL, 'IPR014341', NULL, 'Ectoine/hydroxyectoine ABC transporter, permease protein EhuD', 'Ectoine_EhuD', 4, NULL),
(11203, NULL, 'IPR012056', NULL, '[NiFe]-hydrogenase-3-type complex Eha, subunit EhaM', 'NiFe-hyd_3_EhaM', 4, NULL),
(11204, NULL, 'IPR012245', NULL, 'Molybdenum cofactor biosynthesis protein MoaB', 'MoaB', 4, NULL),
(11205, NULL, 'IPR016105', NULL, 'Pyruvoyl-dependent histidine/arginine decarboxylase, 3-layer sandwich domain', 'Pyr-dep_his/arg-deCO2ase_sand', 5, NULL),
(11206, NULL, 'IPR011968', NULL, 'Phenylacetate degradation probable enoyl-CoA hydratase PaaB', 'PaaB1', 4, NULL),
(11207, NULL, 'IPR014359', NULL, 'Ketol-acid reductoisomerase, prokaryotic', 'KARI_prok', 4, NULL),
(11208, NULL, 'IPR011933', NULL, 'Double transmembrane domain', 'Double_TM_dom', 3, NULL),
(11209, NULL, 'IPR011947', NULL, 'FCP1-like phosphatase, phosphatase domain', 'FCP1_euk', 3, NULL),
(11210, NULL, 'IPR016138', NULL, 'Ribosome-inactivating protein, subdomain 1', 'Ribosome_inactivat_prot_sub1', 5, NULL),
(11211, NULL, 'IPR013382', NULL, 'CRISPR-associated protein Cse2', 'CRISPR-assoc_prot_Cse2', 4, NULL),
(11212, NULL, 'IPR005253', NULL, 'Conserved hypothetical protein CHP00529', 'CHP00529', 4, NULL),
(11213, NULL, 'IPR009644', NULL, 'Ribitol-5-phosphate transferase FKTN-related', 'FKTN-related', 4, NULL),
(11214, NULL, 'IPR013401', NULL, 'Type III secretion regulator, YopN/LcrE/InvE/MxiC', 'T3SS_LcrE', 3, NULL),
(11215, NULL, 'IPR023804', NULL, 'Protein of unknown function DUF3792, transmembrane', 'DUF3792_TM', 4, NULL),
(11216, NULL, 'IPR005229', NULL, 'Conserved hypothetical protein CHP00255', 'CHP00255', 4, NULL),
(11217, NULL, 'IPR011946', NULL, 'Integrase, integron-type', 'Integrase_integron-type', 4, NULL),
(11218, NULL, 'IPR006213', NULL, 'Bax inhibitor 1, conserved site', 'Bax_inhbtr1_CS', 2, NULL),
(11219, NULL, 'IPR014770', NULL, 'Munc13 homology 1', 'Munc13_1', 3, NULL),
(11220, NULL, 'IPR035908', NULL, 'ATP synthase, F0 complex, subunit A superfamily', 'F0_ATP_A_sf', 5, NULL),
(11221, NULL, 'IPR013625', NULL, 'Tensin/EPS8 phosphotyrosine-binding domain', 'PTB', 3, NULL),
(11222, NULL, 'IPR009647', NULL, 'Penicillin-binding, C-terminal', 'PBP_C', 3, NULL),
(11223, NULL, 'IPR011125', NULL, 'Zinc finger, HypF-type', 'Znf_HypF', 3, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(11224, NULL, 'IPR023989', NULL, 'Pre-mycofactocin synthase', 'MftD', 4, NULL),
(11225, NULL, 'IPR001597', NULL, 'Aromatic amino acid beta-eliminating lyase/threonine aldolase', 'ArAA_b-elim_lyase/Thr_aldolase', 3, NULL),
(11226, NULL, 'IPR014518', NULL, 'Uncharacterised conserved protein UCP022079', 'UCP022079', 4, NULL),
(11227, NULL, 'IPR013384', NULL, 'Flagellar hook-associated protein 3', 'Flagell_FlgL', 4, NULL),
(11228, NULL, 'IPR013402', NULL, 'Conserved hypothetical protein CHP02569', 'CHP02569', 4, NULL),
(11229, NULL, 'IPR010832', NULL, 'ProSAAS', 'ProSAAS', 4, NULL),
(11230, NULL, 'IPR015707', NULL, 'Beta-2-Microglobulin', 'B2Microglobulin', 4, NULL),
(11231, NULL, 'IPR016108', NULL, 'Adenovirus Pll, hexon, C-terminal', 'Adenovirus_Pll_hexon_C', 3, NULL),
(11232, NULL, 'IPR013621', NULL, 'Ion transport N-terminal', 'Ion_trans_N', 3, NULL),
(11233, NULL, 'IPR023985', NULL, 'Mycofactocin-dependent oxidoreductase', 'SDR_subfam_1', 4, NULL),
(11234, NULL, 'IPR024152', NULL, 'Inhibitor of nuclear factor kappa-B kinase-interacting protein', 'Inh_kappa-B_kinase-int', 4, NULL),
(11235, NULL, 'IPR005219', NULL, 'Intermembrane transport protein PqiA-like, Enterobacteria-type', 'PqiA-like_Ent', 4, NULL),
(11236, NULL, 'IPR005231', NULL, 'Nascent polypeptide-associated complex (NAC), archaeal', 'NAC_arc', 4, NULL),
(11237, NULL, 'IPR014269', NULL, 'Accessory Sec system protein translocase subunit SecY2', 'SecY2', 4, NULL),
(11238, NULL, 'IPR014346', NULL, 'Prenyl protease-related', 'Prenyl_protease-related', 4, NULL),
(11239, NULL, 'IPR016130', NULL, 'Protein-tyrosine phosphatase, active site', 'Tyr_Pase_AS', 0, NULL),
(11240, NULL, 'IPR006145', NULL, 'Pseudouridine synthase, RsuA/RluA-like', 'PsdUridine_synth_RsuA/RluA', 3, NULL),
(11241, NULL, 'IPR014525', NULL, 'Ethylene receptor', 'ETR', 4, NULL),
(11242, NULL, 'IPR011115', NULL, 'SecA DEAD-like, N-terminal', 'SecA_DEAD', 3, NULL),
(11243, NULL, 'IPR013609', NULL, 'Lambda-like tail fibre protein, N-terminal', 'Stf-like_N', 3, NULL),
(11244, NULL, 'IPR013025', NULL, 'Ribosomal protein L25/L23', 'Ribosomal_L25/23', 4, NULL),
(11245, NULL, 'IPR011964', NULL, 'YVTN beta-propeller repeat', 'YVTN_b-propeller_repeat', 7, NULL),
(11246, NULL, 'IPR034098', NULL, 'Small nuclear ribonucleoprotein G', 'Sm_G', 4, NULL),
(11247, NULL, 'IPR011121', NULL, 'Tryptophan-rich domain', 'Trp-rich_dom', 3, NULL),
(11248, NULL, 'IPR014747', NULL, 'Bacterial photosynthetic reaction centre, H-chain, C-terminal', 'Bac_photo_RC_H_C', 5, NULL),
(11249, NULL, 'IPR013784', NULL, 'Carbohydrate-binding-like fold', 'Carb-bd-like_fold', 5, NULL),
(11250, NULL, 'IPR016147', NULL, 'Pili assembly chaperone, N-terminal', 'Pili_assmbl_chaperone_N', 3, NULL),
(11251, NULL, 'IPR013616', NULL, 'Chitin synthase N-terminal', 'Chitin_synth_N', 3, NULL),
(11252, NULL, 'IPR005249', NULL, 'Ap4A hydrolase', 'YqeK', 4, NULL),
(11253, NULL, 'IPR005226', NULL, 'UPF0014 family', 'UPF0014_fam', 4, NULL),
(11254, NULL, 'IPR016119', NULL, 'Bromoperoxidase/chloroperoxidase C-terminal', 'Br/Cl_peroxidase_C', 5, NULL),
(11255, NULL, 'IPR009649', NULL, 'TraU', 'TraU', 4, NULL),
(11256, NULL, 'IPR016103', NULL, 'ProQ/FinO domain', 'ProQ/FinO', 3, NULL),
(11257, NULL, 'IPR011096', NULL, 'FTP domain', 'FTP_domain', 3, NULL),
(11258, NULL, 'IPR013319', NULL, 'Glycoside hydrolase family 11/12', 'GH11/12', 5, NULL),
(11259, NULL, 'IPR014264', NULL, 'Signal transduction response regulator, PEP-CTERM system, putative', 'Sig_transdc_resp-reg_PEP-CTERM', 4, NULL),
(11260, NULL, 'IPR034099', NULL, 'Small nuclear ribonucleoprotein Sm D3', 'SmD3', 4, NULL),
(11261, NULL, 'IPR014509', NULL, 'Uncharacterised conserved protein UCP020606', 'UCP020606', 4, NULL),
(11262, NULL, 'IPR006172', NULL, 'DNA-directed DNA polymerase, family B', 'DNA-dir_DNA_pol_B', 4, NULL),
(11263, NULL, 'IPR016134', NULL, 'Dockerin domain', 'Dockerin_dom', 3, NULL),
(11264, NULL, 'IPR006228', NULL, 'Polycystin cation channel', 'Polycystin_cat', 3, NULL),
(11265, NULL, 'IPR034763', NULL, 'Venom allergen 3, insect', 'P14a_insect', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(11266, NULL, 'IPR014796', NULL, 'Protein of unknown function DUF1780, putative endonuclease', 'DUF1780', 4, NULL),
(11267, NULL, 'IPR005232', NULL, 'Pyridinium-3,5-bisthiocarboxylic acid mononucleotide synthase LarE', 'LarE', 4, NULL),
(11268, NULL, 'IPR006225', NULL, 'Pseudouridine synthase, RluC/RluD', 'PsdUridine_synth_RluC/D', 4, NULL),
(11269, NULL, 'IPR006171', NULL, 'TOPRIM  domain', 'TOPRIM_domain', 3, NULL),
(11270, NULL, 'IPR014522', NULL, 'Archaeosortase A', 'ArtA', 4, NULL),
(11271, NULL, 'IPR014772', NULL, 'Mammalian uncoordinated homology 13, domain 2', 'Munc13_dom-2', 3, NULL),
(11272, NULL, 'IPR006181', NULL, 'D-amino acid oxidase, conserved site', 'D-amino_acid_oxidase_CS', 2, NULL),
(11273, NULL, 'IPR034596', NULL, '39S ribosomal protein L52, mitochondrial', 'MRPL52', 4, NULL),
(11274, NULL, 'IPR011944', NULL, 'Steroid delta5-4-isomerase', 'Steroid_delta5-4_isomerase', 4, NULL),
(11275, NULL, 'IPR013612', NULL, 'Amino acid permease, N-terminal', 'AA_permease_N', 3, NULL),
(11276, NULL, 'IPR034102', NULL, 'Small nuclear ribonucleoprotein D1', 'Sm_D1', 3, NULL),
(11277, NULL, 'IPR013633', NULL, 'siRNA-mediated silencing protein NRDE-2', 'NRDE-2', 4, NULL),
(11278, NULL, 'IPR013403', NULL, 'CRISPR-associated protein GSU0053', 'CRISPR-assoc_prot_GSU0053', 4, NULL),
(11279, NULL, 'IPR006173', NULL, 'Staphylococcal/Streptococcal toxin, OB-fold', 'Staph_tox_OB', 3, NULL),
(11280, NULL, 'IPR013380', NULL, 'Type 3 secretion system ATPase SCTN', 'ATPase_T3SS_SCTN', 4, NULL),
(11281, NULL, 'IPR034913', NULL, 'MRPS27/PTCD2', 'MRPS27/PTCD2', 4, NULL),
(11282, NULL, 'IPR034783', NULL, 'Sorting nexin-4', 'SNX4', 4, NULL),
(11283, NULL, 'IPR014344', NULL, 'PEP-CTERM locus, polysaccharide deactylase', 'PEP-CTERM_polysacc_deacetyl', 4, NULL),
(11284, NULL, 'IPR014517', NULL, 'ArsR transcriptional regulator', 'ArsR_tscrpt_regulator', 4, NULL),
(11285, NULL, 'IPR006180', NULL, '3-hydroxyacyl-CoA dehydrogenase, conserved site', '3-OHacyl-CoA_DH_CS', 2, NULL),
(11286, NULL, 'IPR013378', NULL, 'Listeria/Bacterioides repeat', 'Listeria/Bacterioides_rpt', 7, NULL),
(11287, NULL, 'IPR005228', NULL, 'Conserved hypothetical protein CHP00251', 'CHP00251', 4, NULL),
(11288, NULL, 'IPR011959', NULL, 'Conserved hypothetical protein CHP02270', 'CHP02270', 4, NULL),
(11289, NULL, 'IPR014267', NULL, 'Glycosyltransferase GtfA', 'GtfA', 4, NULL),
(11290, NULL, 'IPR024208', NULL, 'Protein of unknown function DUF3842', 'DUF3842', 4, NULL),
(11291, NULL, 'IPR011093', NULL, 'Putative conjugal transfer nickase/helicase TraI, C-terminal', 'TraI_2_C', 3, NULL),
(11292, NULL, 'IPR011084', NULL, 'DNA repair metallo-beta-lactamase', 'DRMBL', 3, NULL),
(11293, NULL, 'IPR011948', NULL, 'Dullard phosphatase domain, eukaryotic', 'Dullard_phosphatase', 3, NULL),
(11294, NULL, 'IPR013000', NULL, 'Ribosomal protein L4/L1e, eukaryotic/archaeal, conserved site', 'Ribosomal_L4/L1e_euk/arc_CS', 2, NULL),
(11295, NULL, 'IPR011111', NULL, 'RepB plasmid partition', 'Plasmid_RepB', 3, NULL),
(11296, NULL, 'IPR014265', NULL, 'Signal transduction histidine kinase, PEP-CTERM system, putative', 'Sig_transdc_His_kin_PEP-CTERM', 4, NULL),
(11297, NULL, 'IPR011113', NULL, 'Rho termination factor, RNA-binding domain', 'Rho_RNA-bd', 3, NULL),
(11298, NULL, 'IPR014253', NULL, 'Spore coat protein YsxE', 'Spore_coat_YsxE', 4, NULL),
(11299, NULL, 'IPR013397', NULL, 'CRISPR-associated protein Csy1', 'CRISPR-assoc_prot_Csy1', 4, NULL),
(11300, NULL, 'IPR034894', NULL, 'Nrd1/Seb1, RNA recognition motif', 'Nrd1/Seb1_RRM', 3, NULL),
(11301, NULL, 'IPR014506', NULL, 'Uncharacterised conserved protein UCP020479, signal transduction CheW-like', 'UCP020479_CheW', 4, NULL),
(11302, NULL, 'IPR024058', NULL, 'Cytochrome f  transmembrane anchor', 'Cyt-f_TM', 5, NULL),
(11303, NULL, 'IPR024149', NULL, 'Paralemmin-3', 'Paralemmin-3', 4, NULL),
(11304, NULL, 'IPR012047', NULL, 'Aconitase X', 'AcnX', 4, NULL),
(11305, NULL, 'IPR013608', NULL, 'VWA N-terminal', 'VWA_N', 3, NULL),
(11306, NULL, 'IPR013617', NULL, 'DNA-directed DNA polymerase, family B, viral insert domain', 'DNA-dir_DNA_pol_B_vir_insert', 3, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(11307, NULL, 'IPR010826', NULL, 'Phlebovirus glycoprotein G1', 'Phlebovirus_G1', 3, NULL),
(11308, NULL, 'IPR011922', NULL, 'Cell division protein FtsL', 'Cell_div_FtsL', 4, NULL),
(11309, NULL, 'IPR014790', NULL, 'MutL, C-terminal, dimerisation', 'MutL_C', 3, NULL),
(11310, NULL, 'IPR006221', NULL, 'Anthranilate synthase/para-aminobenzoate synthase like domain', 'TrpG/PapA_dom', 3, NULL),
(11311, NULL, 'IPR014788', NULL, 'Acetylcholinesterase, tetramerisation domain', 'AChE_tetra', 3, NULL),
(11312, NULL, 'IPR024701', NULL, 'UPF0187 protein At3g61320-like', 'At3g61320-like', 4, NULL),
(11313, NULL, 'IPR005254', NULL, 'Heme biosynthesis-associated TPR protein', 'Heme_biosyn_assoc_TPR_pro', 4, NULL),
(11314, NULL, 'IPR005245', NULL, 'Conserved hypothetical protein CHP00454', 'CHP00454', 4, NULL),
(11315, NULL, 'IPR035944', NULL, 'YfbM-like super family', 'YfbM-like_sf', 5, NULL),
(11316, NULL, 'IPR014524', NULL, 'Outer membrane protein assembly factor BamC', 'BamC', 4, NULL),
(11317, NULL, 'IPR014794', NULL, 'TATA-box binding', 'DUF1779', 4, NULL),
(11318, NULL, 'IPR011923', NULL, 'Probable peptidoglycan glycosyltransferase RodA/MrdB', 'RodA/MrdB', 4, NULL),
(11319, NULL, 'IPR011264', NULL, 'Betaine aldehyde dehydrogenase', 'BADH', 4, NULL),
(11320, NULL, 'IPR014515', NULL, 'Uncharacterised conserved protein UCP921964', 'UCP921964', 4, NULL),
(11321, NULL, 'IPR034924', NULL, 'TNRC6A, RNA recognition motif', 'TNRC6A_RRM', 3, NULL),
(11322, NULL, 'IPR017867', NULL, 'Protein-tyrosine phosphatase, low molecular weight', 'Tyr_phospatase_low_mol_wt', 4, NULL),
(11323, NULL, 'IPR023982', NULL, 'Conserved hypothetical protein CHP04029, CMD-like', 'CHP04029_CMD-like', 4, NULL),
(11324, NULL, 'IPR013620', NULL, 'Exodeoxyribonuclease I, C-terminal', 'Exonuc_1_C', 3, NULL),
(11325, NULL, 'IPR006200', NULL, 'Transcription regulator LexA', 'LexA', 4, NULL),
(11326, NULL, 'IPR009648', NULL, 'Biotin-dependent malonate decarboxylase, gamma subunit', 'Malonate_gamma', 4, NULL),
(11327, NULL, 'IPR013398', NULL, 'CRISPR-associated protein Csy2', 'CRISPR-assoc_prot_Csy2', 4, NULL),
(11328, NULL, 'IPR005255', NULL, 'PdxA family', 'PdxA_fam', 4, NULL),
(11329, NULL, 'IPR013630', NULL, 'Methyltransferase putative zinc binding domain', 'Methyltransf_Zn-bd_dom_put', 3, NULL),
(11330, NULL, 'IPR013387', NULL, 'Type III secretion system, PrgH/EprH', 'T3SS_PrgH/EprH', 4, NULL),
(11331, NULL, 'IPR034086', NULL, 'Pectinesterase inhibitor, plant', 'PMEI_plant', 4, NULL),
(11332, NULL, 'IPR011107', NULL, 'Type 1 protein phosphatase inhibitor', 'PPI_Ypi1', 4, NULL),
(11333, NULL, 'IPR014508', NULL, 'Uncharacterised conserved protein withTPR-like repeats', 'UCP020555_TPR-like', 4, NULL),
(11334, NULL, 'IPR023988', NULL, 'Mycofactocin precursor peptide', 'MftA', 4, NULL),
(11335, NULL, 'IPR009643', NULL, 'Heat shock factor binding 1', 'HS1-bd', 4, NULL),
(11336, NULL, 'IPR013777', NULL, 'Alpha-amylase-like', 'A-amylase-like', 4, NULL),
(11337, NULL, 'IPR014345', NULL, 'PEP-CTERM locus polysaccharide chain length determinant', 'PEP-CTERM_polysacc_chain', 4, NULL),
(11338, NULL, 'IPR011967', NULL, '3-hydroxyacyl-CoA dehydrogenase PaaC', '3-OHacyl-CoA_DH_PaaC', 4, NULL),
(11339, NULL, 'IPR014792', NULL, 'RsbS co-antagonist protein RsbRA N-terminal domain', 'RsbRA_N', 3, NULL),
(11340, NULL, 'IPR013376', NULL, 'Glutathione peroxidase Gpx7, putative', 'Glut_perox_Gpx7', 4, NULL),
(11341, NULL, 'IPR011584', NULL, 'Green fluorescent protein-related', 'GFP-related', 4, NULL),
(11342, NULL, 'IPR006231', NULL, 'Malate:quinone-oxidoreductase', 'MQO', 4, NULL),
(11343, NULL, 'IPR013635', NULL, 'Protein Ice2', 'Ice2', 4, NULL),
(11344, NULL, 'IPR013613', NULL, 'Baculoviridae p74 N-terminal', 'Baculo_p74_N', 3, NULL),
(11345, NULL, 'IPR013615', NULL, 'CbbQ/NirQ/NorQ, C-terminal', 'CbbQ_C', 3, NULL),
(11346, NULL, 'IPR006219', NULL, 'DAHP synthase, class 1', 'DAHP_synth_1', 4, NULL),
(11347, NULL, 'IPR016140', NULL, 'Bifunctional inhibitor/plant lipid transfer protein/seed storage helical domain', 'Bifunc_inhib/LTP/seed_store', 3, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(11348, NULL, 'IPR013614', NULL, 'Viral polyprotein, Caliciviridae N-terminal', 'Viral_PP_Calicivir_N', 3, NULL),
(11349, NULL, 'IPR013626', NULL, 'Pheophorbide a oxygenase', 'PaO', 3, NULL),
(11350, NULL, 'IPR013391', NULL, 'Type III secretion protein HrpB2', 'T3SS_HrpB2', 4, NULL),
(11351, NULL, 'IPR005251', NULL, 'Methylthioribose-1-phosphate isomerase', 'IF-M1Pi', 4, NULL),
(11352, NULL, 'IPR034101', NULL, 'Sm-like protein Lsm4', 'Lsm4', 3, NULL),
(11353, NULL, 'IPR011937', NULL, '2-carboxy-1,4-naphthoquinone phytyltransferase', 'DHNA_phytyltransferase_MenA', 4, NULL),
(11354, NULL, 'IPR006199', NULL, 'LexA repressor, DNA-binding domain', 'LexA_DNA-bd_dom', 3, NULL),
(11355, NULL, 'IPR014271', NULL, 'Conserved hypothetical protein CHP02922', 'CHP02922', 4, NULL),
(11356, NULL, 'IPR011088', NULL, 'Bacteriophage phiNM3, A0EWY4', 'Phage_phiNM3_A0EWY4', 4, NULL),
(11357, NULL, 'IPR006226', NULL, 'PIN domain toxin', 'Mtu_PIN', 4, NULL),
(11358, NULL, 'IPR013602', NULL, 'Dynein heavy chain, linker', 'Dynein_heavy_linker', 3, NULL),
(11359, NULL, 'IPR005252', NULL, 'Coenzyme A biosynthesis bifunctional protein CoaBC', 'CoaBC', 4, NULL),
(11360, NULL, 'IPR011124', NULL, 'Zinc finger, CW-type', 'Znf_CW', 3, NULL),
(11361, NULL, 'IPR013783', NULL, 'Immunoglobulin-like fold', 'Ig-like_fold', 5, NULL),
(11362, NULL, 'IPR006215', NULL, 'Glycoside hydrolase, melibiase', 'Glyco_hydro_melibiase', 4, NULL),
(11363, NULL, 'IPR005247', NULL, 'YbhB/YbcL', 'YbhB_YbcL', 4, NULL),
(11364, NULL, 'IPR006203', NULL, 'GHMP kinase, ATP-binding, conserved site', 'GHMP_knse_ATP-bd_CS', 2, NULL),
(11365, NULL, 'IPR011590', NULL, 'Transcription elongation factor Spt5, archaeal', 'Spt5_arc', 4, NULL),
(11366, NULL, 'IPR023984', NULL, 'Ribosomal peptide maturation radical SAM protein 1', 'rSAM_ocin_1', 4, NULL),
(11367, NULL, 'IPR006196', NULL, 'RNA-binding domain, S1, IF1 type', 'RNA-binding_domain_S1_IF1', 3, NULL),
(11368, NULL, 'IPR014247', NULL, 'Sporulation lipoprotein YhcN/YlaJ', 'Spore_lipoprot_YhcN/YlaJ', 4, NULL),
(11369, NULL, 'IPR006194', NULL, 'Glycine-tRNA synthetase, heterodimeric', 'Gly-tRNA-synth_heterodimer', 4, NULL),
(11370, NULL, 'IPR005230', NULL, 'TraB, bacterial/archaeal', 'TraB_bac', 4, NULL),
(11371, NULL, 'IPR011938', NULL, 'DNA recombination/repair protein RadA', 'DNA_recomb/repair_RadA', 4, NULL),
(11372, NULL, 'IPR034094', NULL, 'Mak32', 'Mak32', 4, NULL),
(11373, NULL, 'IPR022772', NULL, 'von Hippel-Lindau disease tumour suppressor, beta/alpha domain', 'VHL_tumour_suppress_b/a_dom', 3, NULL),
(11374, NULL, 'IPR011932', NULL, 'Tyrosine recombinase XerD', 'Recomb_XerD', 4, NULL),
(11375, NULL, 'IPR034925', NULL, 'TNRC6B, RNA recognition motif', 'TNRC6B_RRM', 3, NULL),
(11376, NULL, 'IPR006197', NULL, 'Peptidase S24, LexA-like', 'Peptidase_S24_LexA', 4, NULL),
(11377, NULL, 'IPR009645', NULL, 'Uncharacterised conserved protein GguC', 'GguC', 4, NULL),
(11378, NULL, 'IPR015720', NULL, 'Transmembrane emp24 domain-containing protein', 'Emp24-like', 4, NULL),
(11379, NULL, 'IPR011960', NULL, 'Gentisate 1,2-dioxygenase', 'Gentisate_dOase', 4, NULL),
(11380, NULL, 'IPR022773', NULL, 'Siva', 'Siva', 4, NULL),
(11381, NULL, 'IPR014519', NULL, 'Uncharacterised conserved protein UCP024492', 'UCP024492', 4, NULL),
(11382, NULL, 'IPR013619', NULL, 'Domain of unknown function DUF1737', 'DUF1737', 3, NULL),
(11383, NULL, 'IPR005224', NULL, 'Sugar fermentation stimulation protein', 'SfsA', 4, NULL),
(11384, NULL, 'IPR013601', NULL, 'FAE1/Type III polyketide synthase-like protein', 'FAE1_typ3_polyketide_synth', 3, NULL),
(11385, NULL, 'IPR013854', NULL, 'Transcription factor AP-2, C-terminal', 'TF_AP2_C', 3, NULL),
(11386, NULL, 'IPR014362', NULL, 'Glutamate dehydrogenase', 'Glu_DH', 4, NULL),
(11387, NULL, 'IPR006208', NULL, 'Glycoprotein hormone subunit beta', 'Glyco_hormone_CN', 3, NULL),
(11388, NULL, 'IPR006211', NULL, 'Furin-like cysteine-rich domain', 'Furin-like_Cys-rich_dom', 3, NULL),
(11389, NULL, 'IPR022771', NULL, 'Wings apart-like protein, C-terminal', 'WAPL_C', 3, NULL),
(11390, NULL, 'IPR034095', NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex assembly factor 3', 'NDUF3', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(11391, NULL, 'IPR014268', NULL, 'Glycosyltransferase-stabilising protein GtfB', 'GtfB', 4, NULL),
(11392, NULL, 'IPR006176', NULL, '3-hydroxyacyl-CoA dehydrogenase, NAD binding', '3-OHacyl-CoA_DH_NAD-bd', 3, NULL),
(11393, NULL, 'IPR044856', NULL, 'Malate synthase, C-terminal superfamily', 'Malate_synth_C_sf', 5, NULL),
(11394, NULL, 'IPR013611', NULL, 'Transport-associated OB, type 2', 'Transp-assoc_OB_typ2', 3, NULL),
(11395, NULL, 'IPR016137', NULL, 'RGS domain', 'RGS', 3, NULL),
(11396, NULL, 'IPR014511', NULL, 'Protein of unknown function DUF2068, transmembrane, subgroup', 'DUF2068_TM_subgr', 4, NULL),
(11397, NULL, 'IPR006190', NULL, 'Antifreeze-like/N-acetylneuraminic acid synthase C-terminal', 'AFP_Neu5c_C', 3, NULL),
(11398, NULL, 'IPR014244', NULL, 'RNA polymerase sigma-I type', 'RNA_pol_sigma-I', 4, NULL),
(11399, NULL, 'IPR024706', NULL, 'Peroxiredoxin, AhpC-type', 'Peroxiredoxin_AhpC-typ', 4, NULL),
(11400, NULL, 'IPR017868', NULL, 'Filamin/ABP280 repeat-like', 'Filamin/ABP280_repeat-like', 7, NULL),
(11401, NULL, 'IPR011945', NULL, 'Predicted HAD-superfamily phosphatase, subfamily IA/Epoxide hydrolase, N-terminal', 'HAD-SF_ppase_IA/epoxid_hydro_N', 3, NULL),
(11402, NULL, 'IPR034608', NULL, 'Coiled-coil domain-containing protein 125', 'CCDC125', 4, NULL),
(11403, NULL, 'IPR034918', NULL, 'HuD, RNA recognition motif 3', 'HuD_RRM3', 3, NULL),
(11404, NULL, 'IPR016131', NULL, 'Haemerythrin, iron-binding site', 'Haemerythrin_Fe_BS', 1, NULL),
(11405, NULL, 'IPR006202', NULL, 'Neurotransmitter-gated ion-channel ligand-binding domain', 'Neur_chan_lig-bd', 3, NULL),
(11406, NULL, 'IPR023179', NULL, 'GTP-binding protein, orthogonal bundle domain superfamily', 'GTP-bd_ortho_bundle_sf', 5, NULL),
(11407, NULL, 'IPR010825', NULL, 'Stress-inducible humoral factor Turandot', 'Turandot', 4, NULL),
(11408, NULL, 'IPR006175', NULL, 'YjgF/YER057c/UK114 family', 'YjgF/YER057c/UK114', 4, NULL),
(11409, NULL, 'IPR011953', NULL, 'Cobaltochelatase, CobN subunit', 'Cobalto_CobN', 4, NULL),
(11410, NULL, 'IPR013029', NULL, 'YchF, C-terminal domain', 'YchF_C', 3, NULL),
(11411, NULL, 'IPR010828', NULL, 'Alcohol acetyltransferase/N-acetyltransferase', 'Atf2/Sli1-like', 4, NULL),
(11412, NULL, 'IPR005235', NULL, 'Metallophosphoesterase, YmdB-like', 'YmdB-like', 4, NULL),
(11413, NULL, 'IPR016125', NULL, 'Peptidase C15, pyroglutamyl peptidase I-like', 'Peptidase_C15-like', 4, NULL),
(11414, NULL, 'IPR006105', NULL, 'Cereal seed allergen/trypsin and alpha-amylase inhibitor, conserved site', 'Allergen/tryp_amyl_inhib_CS', 2, NULL),
(11415, NULL, 'IPR011921', NULL, 'Lipid A biosynthesis myristoyltransferase', 'Lipid_A_MsbB', 4, NULL),
(11416, NULL, 'IPR011962', NULL, 'dCTP deaminase', 'dCTP_deaminase', 4, NULL),
(11417, NULL, 'IPR011966', NULL, 'Phenylacetic acid degradation protein PaaN', 'PaaN-DH', 4, NULL),
(11418, NULL, 'IPR011965', NULL, 'Phenylacetic acid degradation operon negative regulatory protein PaaX', 'PaaX_trns_reg', 4, NULL),
(11419, NULL, 'IPR005222', NULL, 'Competence protein ComF', 'Competence_ComF', 4, NULL),
(11420, NULL, 'IPR009657', NULL, 'Protein Ac34', 'Protein_Ac34', 4, NULL),
(11421, NULL, 'IPR011958', NULL, 'Benzoyl-CoA reductase, subunit C', 'Benzoyl_CoA_Rdtase_C', 4, NULL),
(11422, NULL, 'IPR011089', NULL, 'Domain of unknown function DUF1524', 'DUF1524', 3, NULL),
(11423, NULL, 'IPR011939', NULL, 'DNA repair and recombination protein RadB', 'DNA_repair_and_recomb_RadB', 4, NULL),
(11424, NULL, 'IPR011972', NULL, 'Conserved hypothetical protein CHP02285', 'CHP02285', 4, NULL),
(11425, NULL, 'IPR016129', NULL, 'Peptidase family C14A, His active site', 'Caspase_his_AS', 0, NULL),
(11426, NULL, 'IPR011951', NULL, 'HAD-superfamily hydrolase, subfamily IA, YjjG/PynA', 'HAD-SF_hydro_IA_YjjG/PynA', 4, NULL),
(11427, NULL, 'IPR014795', NULL, 'Vibrio phage ICP1, Orf50', 'Vibrio_phage_ICP1_Orf50', 4, NULL),
(11428, NULL, 'IPR006182', NULL, 'Flagellar M-ring , N-terminal', 'FliF_N_dom', 3, NULL),
(11429, NULL, 'IPR011942', NULL, 'Poly(3-hydroxyalkanoate) depolymerase', 'PHA_depoly_arom', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(11430, NULL, 'IPR024146', NULL, 'Claspin', 'Claspin', 4, NULL),
(11431, NULL, 'IPR005238', NULL, 'ComB-like', 'ComB-like', 4, NULL),
(11432, NULL, 'IPR013383', NULL, 'CRISPR-associated protein DxTHG, conserved site', 'CRISPR-assoc_prot_DxTHG_CS', 2, NULL),
(11433, NULL, 'IPR011961', NULL, '16S rRNA processing protein RimM', '16S_RimM', 4, NULL),
(11434, NULL, 'IPR011545', NULL, 'DEAD/DEAH box helicase domain', 'DEAD/DEAH_box_helicase_dom', 3, NULL),
(11435, NULL, 'IPR023979', NULL, 'Conserved hypothetical protein CHP04014, B12-binding/radical SAM-type', 'CHP04014_B12-bd/rSAM', 4, NULL),
(11436, NULL, 'IPR006204', NULL, 'GHMP kinase N-terminal domain', 'GHMP_kinase_N_dom', 3, NULL),
(11437, NULL, 'IPR023978', NULL, 'Glucose-methanol-choline oxidoreductase, actinobacteria', 'GMC_oxidoreductase_actinobac', 4, NULL),
(11438, NULL, 'IPR011974', NULL, 'Phenylacetic acid degradation protein PaaY', 'PaaY', 4, NULL),
(11439, NULL, 'IPR011936', NULL, 'Myxococcus cysteine-rich repeat', 'Myxo_disulph_rpt', 7, NULL),
(11440, NULL, 'IPR012049', NULL, 'Menaquinone:cytochrome c reductase, cytochrome b/c subunit', 'MenaQ_cyt_c_Rdtase_cyt_b/c-su', 4, NULL),
(11441, NULL, 'IPR015725', NULL, 'Myosin Light Chain Kinase 1, Kinase domain', 'MLCK1_kinase_dom', 3, NULL),
(11442, NULL, 'IPR011086', NULL, 'Domain of unknown function DUF1521', 'DUF1521', 3, NULL),
(11443, NULL, 'IPR006043', NULL, 'Nucleobase cation symporter 2 family', 'NCS2', 4, NULL),
(11444, NULL, 'IPR023180', NULL, 'Tetrahydrodipicolinate-N-succinyltransferase, chain A, domain 1', 'THP_succinylTrfase_dom1', 3, NULL),
(11445, NULL, 'IPR005234', NULL, 'Chromosome segregation/condensation protein ScpB', 'ScpB_csome_segregation', 4, NULL),
(11446, NULL, 'IPR016133', NULL, 'Insect cysteine-rich antifreeze protein', 'Insect_cyst_antifreeze_prot', 5, NULL),
(11447, NULL, 'IPR035905', NULL, 'Barstar-like superfamily', 'Barstar-like_sf', 5, NULL),
(11448, NULL, 'IPR011927', NULL, 'Stage V sporulation protein D', 'SpoVD_pbp', 4, NULL),
(11449, NULL, 'IPR013394', NULL, 'Type III secretion system, HrpB1/HrpK', 'T3SS_HrpB1/HrpK', 4, NULL),
(11450, NULL, 'IPR034609', NULL, 'Synaptonemal complex central element protein 2', 'Syce2', 4, NULL),
(11451, NULL, 'IPR014799', NULL, 'Apx/Shrm Domain 2', 'ASD2_dom', 3, NULL),
(11452, NULL, 'IPR016139', NULL, 'Ribosome-inactivating protein, subdomain 2', 'Ribosome_inactivat_prot_sub2', 5, NULL),
(11453, NULL, 'IPR011114', NULL, 'Holliday junction DNA helicase RuvA, C-terminal', 'RuvA_C', 3, NULL),
(11454, NULL, 'IPR011605', NULL, 'NusB antitermination factor', 'NusB_fam', 4, NULL),
(11455, NULL, 'IPR023977', NULL, 'Conserved hypothetical protein CHP04052', 'CHP04052', 4, NULL),
(11456, NULL, 'IPR013785', NULL, 'Aldolase-type TIM barrel', 'Aldolase_TIM', 5, NULL),
(11457, NULL, 'IPR013388', NULL, 'Type III secretion apparatus protein OrgA/MxiK', 'T3SS_OrgA/MxiK', 4, NULL),
(11458, NULL, 'IPR013393', NULL, 'Type III secretion protein HrpB4', 'T3SS_HrpB4', 4, NULL),
(11459, NULL, 'IPR006216', NULL, 'Photosystem II cytochrome b559, conserved site', 'PSII_cyt_b559_CS', 2, NULL),
(11460, NULL, 'IPR011101', NULL, 'Protein of unknown function DUF5131', 'DUF5131', 4, NULL),
(11461, NULL, 'IPR013599', NULL, 'TRAM1-like protein', 'TRAM1', 3, NULL),
(11462, NULL, 'IPR014263', NULL, 'Methanolan biosynthesis EpsI', 'Methanolan_biosynth_EpsI', 3, NULL),
(11463, NULL, 'IPR011918', NULL, 'ABC transporter, ATP-binding/permease protein', 'ABC_MsbA_ATP-bd', 4, NULL),
(11464, NULL, 'IPR023972', NULL, 'Conserved hypothetical protein CHP04069, acyl carrier-related', 'CHP04069_acyl_carrier-rel', 4, NULL),
(11465, NULL, 'IPR006224', NULL, 'Pseudouridine synthase, RluA-like, conserved site', 'PsdUridine_synth_RluA-like_CS', 2, NULL),
(11466, NULL, 'IPR013079', NULL, '6-phosphofructo-2-kinase', '6Phosfructo_kin', 3, NULL),
(11467, NULL, 'IPR013321', NULL, 'Arc-type ribbon-helix-helix', 'Arc_rbn_hlx_hlx', 5, NULL),
(11468, NULL, 'IPR013501', NULL, 'Ethanolamine utilization protein, PduT-related', 'Eut_PduT-rel', 4, NULL),
(11469, NULL, 'IPR006179', NULL, '5''-Nucleotidase/apyrase', '5_nucleotidase/apyrase', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(11470, NULL, 'IPR011940', NULL, 'Meiotic recombination protein Dmc1', 'Dmc1', 4, NULL),
(11471, NULL, 'IPR013320', NULL, 'Concanavalin A-like lectin/glucanase domain superfamily', 'ConA-like_dom_sf', 5, NULL),
(11472, NULL, 'IPR009642', NULL, 'Protein of unknown function DUF1236', 'DUF1236', 4, NULL),
(11473, NULL, 'IPR034915', NULL, 'HuC, RNA recognition motif 3', 'HuC_RRM3', 3, NULL),
(11474, NULL, 'IPR005240', NULL, 'Protein of unknown function DUF389', 'DUF389', 4, NULL),
(11475, NULL, 'IPR011104', NULL, 'HPr kinase/phosphorylase, C-terminal', 'Hpr_kin/Pase_C', 3, NULL),
(11476, NULL, 'IPR005239', NULL, 'Conserved hypothetical protein CHP00300', 'CHP00300', 4, NULL),
(11477, NULL, 'IPR016126', NULL, 'Secretoglobin', 'Secretoglobin', 4, NULL),
(11478, NULL, 'IPR009646', NULL, 'Root cap', 'Root_cap', 4, NULL),
(11479, NULL, 'IPR013600', NULL, 'Ly49-like, N-terminal', 'Ly49_N', 3, NULL),
(11480, NULL, 'IPR034096', NULL, 'Mth938 domain-containing protein', 'AAMDC', 4, NULL),
(11481, NULL, 'IPR009658', NULL, 'Domain of unknown function DUF1248', 'DUF1248', 3, NULL),
(11482, NULL, 'IPR014254', NULL, 'Spore coat protein YutH', 'Spore_coat_YutH', 4, NULL),
(11483, NULL, 'IPR006201', NULL, 'Neurotransmitter-gated ion-channel', 'Neur_channel', 4, NULL),
(11484, NULL, 'IPR006217', NULL, 'Photosystem II cytochrome b559, alpha subunit', 'PSII_cyt_b559_asu', 4, NULL),
(11485, NULL, 'IPR011956', NULL, 'Benzoyl-CoA reductase, subunit D', 'Benzoyl_CoA_Rdtase_D', 4, NULL),
(11486, NULL, 'IPR006187', NULL, 'Claudin', 'Claudin', 4, NULL),
(11487, NULL, 'IPR014505', NULL, 'UMP-CMP kinase 2, mitochondrial', 'UMP-CMP_kinase_2', 4, NULL),
(11488, NULL, 'IPR009661', NULL, 'Autographa californica nuclear polyhedrosis virus, Da18', 'AcMNPV_Da18', 4, NULL),
(11489, NULL, 'IPR015727', NULL, 'Protein kinase C mu-related', 'Protein_Kinase_C_mu-related', 4, NULL),
(11490, NULL, 'IPR034611', NULL, 'D-tartrate dehydratase', 'D-tartrate_dehydratase', 4, NULL),
(11491, NULL, 'IPR024163', NULL, 'Aerotolerance regulator, N-terminal', 'Aerotolerance_reg_N', 3, NULL),
(11492, NULL, 'IPR010829', NULL, 'Cerato-platanin', 'Cerato-platanin', 4, NULL),
(11493, NULL, 'IPR016122', NULL, 'Sporulation initiation phosphotransferase B, C-terminal', 'SpoOB_C', 3, NULL),
(11494, NULL, 'IPR014342', NULL, 'Ectoine/hydroxyectoine ABC transporter, permease protein EhuC', 'Ectoine_EhuC', 4, NULL),
(11495, NULL, 'IPR014798', NULL, 'Protein Ocr', 'Ocr', 4, NULL),
(11496, NULL, 'IPR011973', NULL, 'Phenylacetic acid degradation protein PaaD', 'PaaD', 4, NULL),
(11497, NULL, 'IPR013775', NULL, 'Alpha-amylase, plant', 'A-amylase_pln', 4, NULL),
(11498, NULL, 'IPR016104', NULL, 'Pyruvoyl-dependent histidine/arginine decarboxylase', 'Pyr-dep_his/arg-deCO2ase', 5, NULL),
(11499, NULL, 'IPR014510', NULL, 'Tellurite resistance predicted, YeaR', 'Tellurite-R_YeaR', 4, NULL),
(11500, NULL, 'IPR009659', NULL, 'Protein of unknown function DUF1249', 'DUF1249', 4, NULL),
(11501, NULL, 'IPR010838', NULL, 'Protein of unknown unction DUF1444', 'DUF1444', 4, NULL),
(11502, NULL, 'IPR013592', NULL, 'Maf transcription factor, N-terminal', 'Maf_TF_N', 3, NULL),
(11503, NULL, 'IPR014811', NULL, 'Argonaute, linker 1 domain', 'ArgoL1', 3, NULL),
(11504, NULL, 'IPR010835', NULL, 'Protein of unknown function DUF1439', 'DUF1439', 4, NULL),
(11505, NULL, 'IPR035911', NULL, 'MurE/MurF, N-terminal', 'MurE/MurF_N', 5, NULL),
(11506, NULL, 'IPR019998', NULL, 'Membrane insertase YidC', 'Membr_insert_YidC', 4, NULL),
(11507, NULL, 'IPR009682', NULL, 'Protein of unknown function DUF1270', 'DUF1270', 4, NULL),
(11508, NULL, 'IPR012322', NULL, 'Conotoxin, delta-type, conserved site', 'Conotoxin_d-typ_CS', 2, NULL),
(11509, NULL, 'IPR014849', NULL, 'EKC/KEOPS complex, subunit Gon7', 'EKC/KEOPS_Gon7', 4, NULL),
(11510, NULL, 'IPR016158', NULL, 'Cullin homology domain', 'Cullin_homology', 3, NULL),
(11511, NULL, 'IPR023698', NULL, '3-isopropylmalate dehydrogenase, actinobacteria', 'LeuB_actb', 4, NULL),
(11512, NULL, 'IPR016191', NULL, 'Ribonuclease/ribotoxin', 'Ribonuclease/ribotoxin', 5, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(11513, NULL, 'IPR009707', NULL, 'Membrane protein GlpM/YdgC', 'GlpM/YdgC', 4, NULL),
(11514, NULL, 'IPR012726', NULL, 'Thiazole biosynthesis ThiH', 'ThiH', 4, NULL),
(11515, NULL, 'IPR014036', NULL, 'DeoR C-terminal sensor domain', 'DeoR_C', 3, NULL),
(11516, NULL, 'IPR016164', NULL, 'FAD-linked oxidase-like, C-terminal', 'FAD-linked_Oxase-like_C', 5, NULL),
(11517, NULL, 'IPR012730', NULL, 'Molybdopterin synthase sulfurylase MoeB', 'Mopterin_Synthase_Sase_MoeB', 4, NULL),
(11518, NULL, 'IPR008452', NULL, 'Citrus tristeza virus P18', 'CTV_P18', 4, NULL),
(11519, NULL, 'IPR013650', NULL, 'ATP-grasp fold, succinyl-CoA synthetase-type', 'ATP-grasp_succ-CoA_synth-type', 3, NULL),
(11520, NULL, 'IPR012710', NULL, 'Phosphonoacetate hydrolase', 'Phosphonoacetate_hydro', 4, NULL),
(11521, NULL, 'IPR010846', NULL, 'N-acetylmuramoyl-L-alanine amidase-like', 'AmiA-like', 4, NULL),
(11522, NULL, 'IPR016186', NULL, 'C-type lectin-like/link domain superfamily', 'C-type_lectin-like/link_sf', 5, NULL),
(11523, NULL, 'IPR016189', NULL, 'Translation initiation factor IF2/IF5, N-terminal', 'Transl_init_fac_IF2/IF5_N', 5, NULL),
(11524, NULL, 'IPR010879', NULL, 'Domain of unknown function DUF1508', 'DUF1508', 3, NULL),
(11525, NULL, 'IPR012965', NULL, 'Meiotically up-regulated protein Msb1/Mug8 domain', 'Msb1/Mug8_dom', 3, NULL),
(11526, NULL, 'IPR012976', NULL, 'NOSIC', 'NOSIC', 3, NULL),
(11527, NULL, 'IPR016159', NULL, 'Cullin repeat-like-containing domain superfamily', 'Cullin_repeat-like_dom_sf', 5, NULL),
(11528, NULL, 'IPR009664', NULL, 'Pyrimidine/purine nucleoside phosphorylase', 'Ppnp', 4, NULL),
(11529, NULL, 'IPR010848', NULL, 'Protein of unknown function DUF1465', 'DUF1465', 4, NULL),
(11530, NULL, 'IPR013656', NULL, 'PAS fold-4', 'PAS_4', 3, NULL),
(11531, NULL, 'IPR010839', NULL, 'Acyclic terpene utilisation', 'AtuA', 4, NULL),
(11532, NULL, 'IPR024020', NULL, 'Anti sigma-R factor, mycothiol system,RsrA', 'Anit_sigma_mycothiol_RsrA', 4, NULL),
(11533, NULL, 'IPR014768', NULL, 'Rho GTPase-binding/formin homology 3 (GBD/FH3) domain', 'GBD/FH3_dom', 3, NULL),
(11534, NULL, 'IPR012963', NULL, 'Protein of unknown function DUF1700', 'DUF1700', 4, NULL),
(11535, NULL, 'IPR013583', NULL, 'Phosphoribosyltransferase C-terminal', 'PRibTrfase_C', 3, NULL),
(11536, NULL, 'IPR011760', NULL, 'Pseudouridine synthase, TruD, insertion domain', 'PsdUridine_synth_TruD_insert', 3, NULL),
(11537, NULL, 'IPR018023', NULL, 'Ribosome maturation protein SBDS, conserved site', 'Ribosome_mat_SBDS_CS', 2, NULL),
(11538, NULL, 'IPR009681', NULL, 'Phage tail assembly chaperone protein, Siphoviridae', 'Phage_TAC_Siphoviridae', 4, NULL),
(11539, NULL, 'IPR012696', NULL, 'Phosphonate metabolism PhnM', 'PhnM', 4, NULL),
(11540, NULL, 'IPR013019', NULL, 'MAD homology, MH1', 'MAD_homology_MH1', 3, NULL),
(11541, NULL, 'IPR012700', NULL, 'Phosphonate C-P lyase system, PhnK', 'CP_lyase_PhnK', 4, NULL),
(11542, NULL, 'IPR010888', NULL, 'CblD-like pilus biogenesis initiator', 'CblD', 4, NULL),
(11543, NULL, 'IPR012485', NULL, 'Centromere protein I', 'CENP-I', 4, NULL),
(11544, NULL, 'IPR012688', NULL, '4-hydroxyphenylacetate 3-monooxygenase oxygenase component, gammaproteobacteria', 'HpaB_gammaproteobact', 4, NULL),
(11545, NULL, 'IPR014820', NULL, 'Primase, C-terminal 1', 'PriCT_1', 3, NULL),
(11546, NULL, 'IPR024023', NULL, 'His-Xaa-Ser system radical SAM maturase HxsB', 'rSAM_paired_HxsB', 4, NULL),
(11547, NULL, 'IPR016177', NULL, 'DNA-binding domain superfamily', 'DNA-bd_dom_sf', 5, NULL),
(11548, NULL, 'IPR014818', NULL, 'Bacteriophage/plasmid primase, P4, C-terminal', 'Phage/plasmid_primase_P4_C', 3, NULL),
(11549, NULL, 'IPR016153', NULL, 'Heat shock protein Hsp33, N-terminal', 'Heat_shock_Hsp33_N', 5, NULL),
(11550, NULL, 'IPR016179', NULL, 'Insulin-like', 'Insulin-like', 3, NULL),
(11551, NULL, 'IPR012720', NULL, 'T-complex protein 1, eta subunit', 'Chap_CCT_eta', 4, NULL),
(11552, NULL, 'IPR012952', NULL, 'BING4, C-terminal domain', 'BING4_C_dom', 3, NULL),
(11553, NULL, 'IPR020048', NULL, 'NADPH-dependent FMN reductase, SsuE', 'NADPH-dep_FMN_reduc_SsuE', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(11554, NULL, 'IPR012717', NULL, 'T-complex protein 1, delta subunit', 'Chap_CCT_delta', 4, NULL),
(11555, NULL, 'IPR013577', NULL, 'Lethal giant larvae homologue 2', 'LLGL2', 3, NULL),
(11556, NULL, 'IPR010841', NULL, 'Elongation factor G-binding protein, N-terminal', 'EF-G-binding_N', 3, NULL),
(11557, NULL, 'IPR009695', NULL, 'Diacylglycerol glucosyltransferase, N-terminal', 'Diacylglyc_glucosyltr_N', 3, NULL),
(11558, NULL, 'IPR035910', NULL, 'RyR/IP3 receptor binding core, RIH domain superfamily', 'RyR/IP3R_RIH_dom_sf', 5, NULL),
(11559, NULL, 'IPR016182', NULL, 'Copper amine oxidase, N-terminal', 'Cu_amine_oxidase_N-reg', 5, NULL),
(11560, NULL, 'IPR016162', NULL, 'Aldehyde dehydrogenase, N-terminal', 'Ald_DH_N', 5, NULL),
(11561, NULL, 'IPR011615', NULL, 'p53, DNA-binding domain', 'p53_DNA-bd', 3, NULL),
(11562, NULL, 'IPR015753', NULL, 'Leucine-rich repeat-containing protein 37', 'LRRC37', 4, NULL),
(11563, NULL, 'IPR014822', NULL, 'Non-structural protein NSP9, coronavirus', 'NSP9_CoV', 3, NULL),
(11564, NULL, 'IPR012718', NULL, 'T-complex protein 1, epsilon subunit', 'Chap_CCT_epsi', 4, NULL),
(11565, NULL, 'IPR018024', NULL, 'Cobalamin (vitamin B12) transport protein CbiM', 'CbiM', 4, NULL),
(11566, NULL, 'IPR012959', NULL, 'CPL domain', 'CPL_dom', 3, NULL),
(11567, NULL, 'IPR012316', NULL, 'ITAM motif, hantavirus type', 'ITAM_motif_hantavir-typ', 3, NULL),
(11568, NULL, 'IPR023689', NULL, '2,3-diketo-L-gulonate reductase', 'Diketo_gul_Rdtase', 4, NULL),
(11569, NULL, 'IPR014825', NULL, 'DNA alkylation repair enzyme', 'DNA_alkylation', 4, NULL),
(11570, NULL, 'IPR010871', NULL, 'Protein of unknown function DUF1502', 'DUF1502', 7, NULL),
(11571, NULL, 'IPR021133', NULL, 'HEAT, type 2', 'HEAT_type_2', 7, NULL),
(11572, NULL, 'IPR013652', NULL, 'Glycine N-acyltransferase, C-terminal', 'Glycine_N-acyltransferase_C', 3, NULL),
(11573, NULL, 'IPR013653', NULL, 'FR47-like', 'FR47', 3, NULL),
(11574, NULL, 'IPR011750', NULL, 'Myxococcus xanthus double-CXXCG motif', 'Gmx_para_CXXCG', 4, NULL),
(11575, NULL, 'IPR014813', NULL, 'Guanine nucleotide-binding protein-like 3, N-terminal domain', 'Gnl3_N_dom', 3, NULL),
(11576, NULL, 'IPR012712', NULL, 'HTH-type transcriptional regulator HpaR/FarR', 'HpaR/FarR', 4, NULL),
(11577, NULL, 'IPR016156', NULL, 'FAD/NAD-linked reductase, dimerisation domain superfamily', 'FAD/NAD-linked_Rdtase_dimer_sf', 5, NULL),
(11578, NULL, 'IPR012721', NULL, 'T-complex protein 1, theta subunit', 'Chap_CCT_theta', 4, NULL),
(11579, NULL, 'IPR009708', NULL, 'Bacteriophage A118-like, holin/antiholin', 'Phage_A118_holin/antiholin', 4, NULL),
(11580, NULL, 'IPR010867', NULL, 'NPR nonapeptide', 'NPR_nonapeptide', 7, NULL),
(11581, NULL, 'IPR024031', NULL, 'PPOX class F420-dependent enzyme, MSMEG_5819/OxyR family', 'MSMEG_5819/OxyR', 4, NULL),
(11582, NULL, 'IPR019983', NULL, 'Peptidase T1A, proteasome beta-subunit, archaeal', 'Pept_T1A_Psome_bsu_arc', 4, NULL),
(11583, NULL, 'IPR012323', NULL, 'Cyclotide, bracelet, conserved site', 'Cyclotide_bracelet_CS', 2, NULL),
(11584, NULL, 'IPR012689', NULL, '2,4-dihydroxyhept-2-ene-1,7-dioic acid aldolase', 'HpaI', 4, NULL),
(11585, NULL, 'IPR011725', NULL, 'Coenzyme PQQ biosynthesis protein A', 'PQQ_synth_PqqA', 4, NULL),
(11586, NULL, 'IPR012797', NULL, 'Precorrin-6A synthase [deacetylating]', 'CobF', 4, NULL),
(11587, NULL, 'IPR011738', NULL, 'Phage conserved hypothetical protein', 'Phage_CHP', 4, NULL),
(11588, NULL, 'IPR012724', NULL, 'Chaperone DnaJ', 'DnaJ', 4, NULL),
(11589, NULL, 'IPR020043', NULL, 'Deacetylase Atu3266-like', 'Deacetylase_Atu3266-like', 4, NULL),
(11590, NULL, 'IPR035909', NULL, 'Methylesterase CheB, C-terminal', 'CheB_C', 5, NULL),
(11591, NULL, 'IPR012970', NULL, 'Polysaccharide lyase 8, N-terminal alpha-helical', 'Lyase_8_alpha_N', 3, NULL),
(11592, NULL, 'IPR019982', NULL, 'Proteasome alpha subunit, archaeal', 'Proteasome_asu_arc', 4, NULL),
(11593, NULL, 'IPR016157', NULL, 'Cullin, conserved site', 'Cullin_CS', 2, NULL),
(11594, NULL, 'IPR012703', NULL, '2-aminoethylphosphonate--pyruvate transaminase', 'NH2EtPonate_pyrv_transaminase', 4, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(11595, NULL, 'IPR010858', NULL, 'Protein of unknown function DUF1481', 'DUF1481', 4, NULL),
(11596, NULL, 'IPR012731', NULL, 'Thiazole biosynthesis adenylyltransferase ThiF', 'Adenyl_ThiF', 4, NULL),
(11597, NULL, 'IPR014006', NULL, 'Succinate dehydrogenase/fumarate reductase, flavoprotein subunit', 'Succ_Dhase_FrdA_Gneg', 4, NULL),
(11598, NULL, 'IPR034945', NULL, '2-aminobiphenyl-2,3-diol 1,2-dioxygenase, A subunit', 'CarBa', 4, NULL),
(11599, NULL, 'IPR034467', NULL, 'Set1A, RNA recognition motif', 'Set1A_RRM', 3, NULL),
(11600, NULL, 'IPR023854', NULL, 'Poly-beta-1,6-N-acetyl-D-glucosamine N-deacetylase PgaB', 'PGA_deacetylase_PgaB', 4, NULL),
(11601, NULL, 'IPR014807', NULL, 'Cytochrome c oxidase assembly factor 1', 'Coa1', 4, NULL),
(11602, NULL, 'IPR010852', NULL, 'Putative stress-induced transcription regulator', 'ABATE', 4, NULL),
(11603, NULL, 'IPR014851', NULL, 'BCS1, N-terminal', 'BCS1_N', 3, NULL),
(11604, NULL, 'IPR012715', NULL, 'T-complex protein 1, alpha subunit', 'Chap_CCT_alpha', 4, NULL),
(11605, NULL, 'IPR009679', NULL, 'Bacteriophage 186, CII-like', 'Phage_186_CII-like', 4, NULL),
(11606, NULL, 'IPR012958', NULL, 'CHD, N-terminal', 'CHD_N', 3, NULL),
(11607, NULL, 'IPR013584', NULL, 'RAP domain', 'RAP', 3, NULL),
(11608, NULL, 'IPR009675', NULL, 'TPX2', 'TPX2_fam', 4, NULL),
(11609, NULL, 'IPR019902', NULL, 'Violacein biosynthesis enzyme, VioE', 'Violacein_biosynth_enz_VioE', 4, NULL),
(11610, NULL, 'IPR009676', NULL, 'Protein of unknown function DUF1265', 'DUF1265', 4, NULL),
(11611, NULL, 'IPR014845', NULL, 'Protein GYD/TTHA1554', 'GYD/TTHA1554', 4, NULL),
(11612, NULL, 'IPR011763', NULL, 'Acetyl-coenzyme A carboxyltransferase, C-terminal', 'COA_CT_C', 3, NULL),
(11613, NULL, 'IPR010884', NULL, '6-Cysteine (6-Cys) domain', '6_CYS_dom', 3, NULL),
(11614, NULL, 'IPR024017', NULL, 'Petide cyclisation enzyme, radical SAM', 'Pep_cycl_rSAM', 4, NULL),
(11615, NULL, 'IPR019991', NULL, 'GTP-binding protein, ribosome biogenesis', 'GTP-bd_ribosome_bgen', 4, NULL),
(11616, NULL, 'IPR010856', NULL, 'Gig2-like', 'Gig2-like', 4, NULL),
(11617, NULL, 'IPR014819', NULL, 'Primase, C-terminal 2', 'PriCT_2', 3, NULL),
(11618, NULL, 'IPR013595', NULL, 'Peptidase S33 tripeptidyl aminopeptidase-like, C-terminal', 'Pept_S33_TAP-like_C', 3, NULL),
(11619, NULL, 'IPR009699', NULL, 'Mastadenovirus E4/Orf3', 'Mastadenovirus_E4/Orf3', 4, NULL),
(11620, NULL, 'IPR012262', NULL, 'Bifunctional dihydrofolate reductase/thymidylate synthase', 'DHFR-TS', 4, NULL),
(11621, NULL, 'IPR010890', NULL, 'Primosomal replication PriB/PriC', 'Primosomal_replicat_PriB/PriC', 4, NULL),
(11622, NULL, 'IPR011736', NULL, 'Ehrlichia tandem repeat', 'Ehrlichia_tandem_rpt', 7, NULL),
(11623, NULL, 'IPR024048', NULL, 'von Hippel-Lindau disease tumour suppressor, alpha domain', 'VHL_alpha_dom', 3, NULL),
(11624, NULL, 'IPR024047', NULL, 'MM3350-like superfamily', 'MM3350-like_sf', 5, NULL),
(11625, NULL, 'IPR016171', NULL, 'Vanillyl-alcohol oxidase, C-terminal subdomain 2', 'Vanillyl_alc_oxidase_C-sub2', 5, NULL),
(11626, NULL, 'IPR023131', NULL, 'Mth639-like domain superfamily', 'Mth639-like_dom_sf', 5, NULL),
(11627, NULL, 'IPR013585', NULL, 'Protocadherin', 'Protocadherin', 3, NULL),
(11628, NULL, 'IPR023792', NULL, 'Protein-disulfide oxidoreductase DsbI', 'DiS_OxRdtase_Dsbl', 4, NULL),
(11629, NULL, 'IPR009704', NULL, 'EURL protein', 'EURL_prot', 4, NULL),
(11630, NULL, 'IPR016176', NULL, 'Cobalamin (vitamin B12)-dependent enzyme, catalytic', 'Cbl-dep_enz_cat', 5, NULL),
(11631, NULL, 'IPR016185', NULL, 'Pre-ATP-grasp domain superfamily', 'PreATP-grasp_dom_sf', 5, NULL),
(11632, NULL, 'IPR014007', NULL, 'Acetoin reductase', '23BDH', 4, NULL),
(11633, NULL, 'IPR012969', NULL, 'Fibrinogen binding protein', 'Fibrinogen_BP', 4, NULL),
(11634, NULL, 'IPR016166', NULL, 'FAD-binding domain, PCMH-type', 'FAD-bd_PCMH', 3, NULL),
(11635, NULL, 'IPR014839', NULL, 'Ribonucleotide reductase, transcriptional regulator Crt10', 'Crt10', 4, NULL),
(11636, NULL, 'IPR011752', NULL, 'PilZ domain, Myxococcales-type', 'PilV_Myxo-type', 3, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(11637, NULL, 'IPR014843', NULL, 'Protein Him1/Fmp52', 'Him1/Fmp52', 4, NULL),
(11638, NULL, 'IPR012327', NULL, 'D12 class N6 adenine-specific DNA methyltransferase', 'MeTrfase_D12', 4, NULL),
(11639, NULL, 'IPR023700', NULL, 'Divalent cation tolerance protein CutA, Enterobacteria', 'CutA_Enterobact', 4, NULL),
(11640, NULL, 'IPR010854', NULL, 'YdgH/BhsA/McbA-like domain', 'YdgH/BhsA/McbA-like_dom', 3, NULL),
(11641, NULL, 'IPR011748', NULL, 'Uncharacterised protein family, phage tail-like', 'Unchr_phage_tail-like', 3, NULL),
(11642, NULL, 'IPR013081', NULL, 'Photosystem II cytochrome b559, N-terminal', 'PSII_cyt_b559_N', 3, NULL),
(11643, NULL, 'IPR012736', NULL, 'Dihydroxyacetone kinase DhaK, subunit 1', 'DhaK_1', 3, NULL),
(11644, NULL, 'IPR019987', NULL, 'GTP-binding protein, ribosome biogenesis, YsxC', 'GTP-bd_ribosome_bio_YsxC', 4, NULL),
(11645, NULL, 'IPR011746', NULL, 'Trp biosynthesis associated, conserved hypothetical membrane protein', 'Trp_synth-assoc_CHP', 4, NULL),
(11646, NULL, 'IPR024029', NULL, 'Pyridoxamine 5-phosphate oxidase, FMN-dependent', 'Pyridox_Oxase_FMN-dep', 4, NULL),
(11647, NULL, 'IPR019901', NULL, 'Ergot alkaloid biosynthesis protein', 'Ergot_alkaloid_biosynthesis', 4, NULL),
(11648, NULL, 'IPR013500', NULL, 'DNA topoisomerase I, catalytic core, eukaryotic-type', 'TopoI_cat_euk', 3, NULL),
(11649, NULL, 'IPR013845', NULL, 'Ribosomal protein S4e, central region', 'Ribosomal_S4e_central_region', 3, NULL),
(11650, NULL, 'IPR014817', NULL, 'Gag protein p6', 'Gag_p6', 3, NULL),
(11651, NULL, 'IPR023853', NULL, 'Poly-beta-1,6 N-acetyl-D-glucosamine synthase PgaC/IcaA', 'PGA_PgaC/IcaA', 4, NULL),
(11652, NULL, 'IPR019899', NULL, 'Sodium/solute symporter, VC2705 subfamily', 'Na/solute_symporter_VC_2705', 4, NULL),
(11653, NULL, 'IPR012707', NULL, '4-hydroxyphenylacetate permease', 'HPA_permease', 4, NULL),
(11654, NULL, 'IPR012478', NULL, 'GSG1-like', 'GSG-1', 4, NULL),
(11655, NULL, 'IPR010857', NULL, 'Zona-pellucida-binding', 'Sp38-bd', 4, NULL),
(11656, NULL, 'IPR012711', NULL, 'Lacto-N-biose phosphorylase/D-galactosyl-beta-1->4-L-rhamnose phosphorylase', 'Lacto-N-biose_phosphorylase', 4, NULL),
(11657, NULL, 'IPR014842', NULL, 'Iron-regulated transcriptional activator AFT', 'AFT', 4, NULL),
(11658, NULL, 'IPR011765', NULL, 'Peptidase M16, N-terminal', 'Pept_M16_N', 3, NULL),
(11659, NULL, 'IPR013586', NULL, '26S proteasome regulatory subunit, C-terminal', '26S_Psome_reg_C', 3, NULL),
(11660, NULL, 'IPR011728', NULL, 'Polyhydroxyalkanoic acid inclusion protein PhaP', 'PhaP_Bmeg', 4, NULL),
(11661, NULL, 'IPR009671', NULL, 'Regulator of ribonuclease activity B domain', 'RraB_dom', 3, NULL),
(11662, NULL, 'IPR012725', NULL, 'Chaperone DnaK', 'Chaperone_DnaK', 4, NULL),
(11663, NULL, 'IPR024030', NULL, 'AIR synthase-related protein, sll0787 family', 'AIR_synthase-rel_sll0787', 4, NULL),
(11664, NULL, 'IPR012325', NULL, 'Assassin bug toxin-like', 'Assassin_bug_toxin-like', 4, NULL),
(11665, NULL, 'IPR009709', NULL, 'Protein of unknown function DUF1290', 'DUF1290', 4, NULL),
(11666, NULL, 'IPR020023', NULL, 'UDP-2,4-diacetamido-2,4,6-trideoxy-beta-L-altropyranose hydrolase', 'PseG', 4, NULL),
(11667, NULL, 'IPR014837', NULL, 'EF-hand, Ca insensitive', 'EF-hand_Ca_insen', 3, NULL),
(11668, NULL, 'IPR012957', NULL, 'CHD, C-terminal 2', 'CHD_C2', 3, NULL),
(11669, NULL, 'IPR017437', NULL, 'ATP-NAD kinase, PpnK-type, C-terminal', 'ATP-NAD_kinase_PpnK-typ_C', 5, NULL),
(11670, NULL, 'IPR010845', NULL, 'Flagellar FlaF', 'FlaF', 4, NULL),
(11671, NULL, 'IPR009686', NULL, 'Senescence/spartin-associated, C-terminal', 'Senescence/spartin_C', 3, NULL),
(11672, NULL, 'IPR015426', NULL, 'Acetaldehyde dehydrogenase, C-terminal', 'Acetylaldehyde_DH_C', 3, NULL),
(11673, NULL, 'IPR024013', NULL, 'Colanic acid biosynthesis, putative colanic acid polymerase, WcaD', 'Colanic_acid_synth_WcaD', 4, NULL),
(11674, NULL, 'IPR012728', NULL, 'Non-ribosomal peptide synthetase, C-terminal', 'NRPS_C', 3, NULL),
(11675, NULL, 'IPR012714', NULL, 'Thermosome, archaeal', 'Thermosome_arc', 4, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(11676, NULL, 'IPR011739', NULL, 'Gene transfer agent, rcc01693', 'GTA_rcc01693', 4, NULL),
(11677, NULL, 'IPR009677', NULL, 'Protein of unknown function DUF1266', 'DUF1266', 4, NULL),
(11678, NULL, 'IPR009684', NULL, 'Proteinase inhibitor I47, latexin', 'Prot_inh_latexin', 4, NULL),
(11679, NULL, 'IPR023788', NULL, 'D-tagatose-bisphosphate aldolase, class II, subunit KbaY', 'TagBP_ald_KbaY', 4, NULL),
(11680, NULL, 'IPR023693', NULL, 'ABC transporter, vitamin B12, BtuD', 'ABC_transptr_BtuD', 4, NULL),
(11681, NULL, 'IPR020007', NULL, 'N-acetylneuraminate synthase', 'N-AcNeuraminate_synthase', 4, NULL),
(11682, NULL, 'IPR012972', NULL, 'NLE', 'NLE', 3, NULL),
(11683, NULL, 'IPR019980', NULL, 'Ribosomal protein S13, bacterial-type', 'Ribosomal_S13_bac-type', 4, NULL),
(11684, NULL, 'IPR012319', NULL, 'Formamidopyrimidine-DNA glycosylase, catalytic domain', 'FPG_cat', 3, NULL),
(11685, NULL, 'IPR019986', NULL, 'DAK2 domain-containing protein YloV', 'DAK2_dom-cont_prot_YloV', 4, NULL),
(11686, NULL, 'IPR020019', NULL, 'Sialic acid O-acyltransferase NeuD-like', 'Sia_OAcTrfase_NeuD-like', 4, NULL),
(11687, NULL, 'IPR020050', NULL, 'FO synthase, subunit 2', 'FO_synthase_su2', 4, NULL),
(11688, NULL, 'IPR009706', NULL, 'Protein of unknown function DUF1287', 'DUF1287', 4, NULL),
(11689, NULL, 'IPR034939', NULL, 'Gallate dioxygenase, N-terminal', 'Gallate_Doxase_N', 3, NULL),
(11690, NULL, 'IPR014802', NULL, 'Golgi to ER traffic protein 2', 'GET2', 4, NULL),
(11691, NULL, 'IPR012692', NULL, 'ABC transporter, methionine import, ATP-binding protein MetN, proteobacteria', 'ABC_MetN_proteobac', 4, NULL),
(11692, NULL, 'IPR010875', NULL, 'Protein of unknown function DUF1506', 'DUF1506', 4, NULL),
(11693, NULL, 'IPR013651', NULL, 'ATP-grasp fold, RimK-type', 'ATP-grasp_RimK-type', 3, NULL),
(11694, NULL, 'IPR016194', NULL, 'SPOC-like, C-terminal domain superfamily', 'SPOC-like_C_dom_sf', 5, NULL),
(11695, NULL, 'IPR012257', NULL, 'Glycolate oxidase, iron-sulphur subunit', 'Glc_ox_4Fe-4S', 4, NULL),
(11696, NULL, 'IPR016180', NULL, 'Ribosomal protein L10e/L16', 'Ribosomal_L10e/L16', 3, NULL),
(11697, NULL, 'IPR012974', NULL, 'Nucleolar protein 58/56, N-terminal', 'NOP58/56_N', 3, NULL),
(11698, NULL, 'IPR008450', NULL, 'Chorion S16', 'Chorion_S16', 4, NULL),
(11699, NULL, 'IPR009669', NULL, 'Cysteine protease, VirA/EspG', 'Cys_protease_VirA/EspG', 4, NULL),
(11700, NULL, 'IPR010862', NULL, 'Protein of unknown function DUF1493', 'DUF1493', 4, NULL),
(11701, NULL, 'IPR012683', NULL, 'Conserved hypothetical protein CHP02302, transmembrane', 'CHP02302_TM', 4, NULL),
(11702, NULL, 'IPR012687', NULL, '4-HPA 3-monooxygenase large component, Deinococcus-type', 'HpaB_Deino-type', 4, NULL),
(11703, NULL, 'IPR011764', NULL, 'Biotin carboxylation domain', 'Biotin_carboxylation_dom', 3, NULL),
(11704, NULL, 'IPR014844', NULL, 'PalH/RIM21', 'PalH', 4, NULL),
(11705, NULL, 'IPR011762', NULL, 'Acetyl-coenzyme A carboxyltransferase, N-terminal', 'COA_CT_N', 3, NULL),
(11706, NULL, 'IPR010865', NULL, 'Protein of unknown function DUF1499', 'DUF1499', 4, NULL),
(11707, NULL, 'IPR019988', NULL, 'GTP-binding protein, riobosome biogenesis, YqeH', 'GTP-bd_ribosome_bgen_YqeH', 4, NULL),
(11708, NULL, 'IPR009665', NULL, 'Protein of unknown function DUF1256', 'DUF1256', 4, NULL),
(11709, NULL, 'IPR012704', NULL, 'Signal transduction response regulator, propionate catabolism, transcriptional regulator PrpR', 'Sig_transdc_resp-reg_PrpR', 4, NULL),
(11710, NULL, 'IPR024010', NULL, 'Colanic acid biosynthesis, glycosyl transferase,  WcaE', 'Colanic_acid_synth_WcaE', 4, NULL),
(11711, NULL, 'IPR014767', NULL, 'Diaphanous autoregulatory (DAD) domain', 'DAD_dom', 3, NULL),
(11712, NULL, 'IPR024038', NULL, 'MYXO-CTERM domain', 'MYXO-CTERM', 3, NULL),
(11713, NULL, 'IPR016163', NULL, 'Aldehyde dehydrogenase, C-terminal', 'Ald_DH_C', 5, NULL),
(11714, NULL, 'IPR034468', NULL, 'Set1B, RNA recognition motif', 'Set1B_RRM', 3, NULL),
(11715, NULL, 'IPR016188', NULL, 'PurM-like, N-terminal domain', 'PurM-like_N', 3, NULL),
(11716, NULL, 'IPR013645', NULL, 'Glycosyl transferase, family 8, C-terminal', 'Glyco_transf_8N', 3, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(11717, NULL, 'IPR012701', NULL, 'Phosphonate C-P lyase system, PhnL', 'CP_lyase_PhnL', 4, NULL),
(11718, NULL, 'IPR012259', NULL, 'Dihydrofolate reductase', 'DHFR', 4, NULL),
(11719, NULL, 'IPR010889', NULL, 'Protein of unknown function DUF1515', 'DUF1515', 4, NULL),
(11720, NULL, 'IPR020075', NULL, 'Uncharacterised protein family AF2234', 'Uncharacterised_AF2234', 4, NULL),
(11721, NULL, 'IPR019908', NULL, 'Endodeoxyribonuclease toxin RalR', 'Toxin_RalR', 4, NULL),
(11722, NULL, 'IPR014810', NULL, 'Fcf2 pre-rRNA processing, C-terminal', 'Fcf2_C', 3, NULL),
(11723, NULL, 'IPR034946', NULL, 'La-related protein 7, La domain', 'LARP7_La', 3, NULL),
(11724, NULL, 'IPR012961', NULL, 'ATP-dependent RNA helicase Ski2, C-terminal', 'Ski2_C', 3, NULL),
(11725, NULL, 'IPR024011', NULL, 'Natural product biosynthesis luciferase-like monooxygenase domain', 'Biosynth_lucif-like_mOase_dom', 3, NULL),
(11726, NULL, 'IPR019903', NULL, 'Repair of iron centres family', 'RIC_family', 4, NULL),
(11727, NULL, 'IPR009678', NULL, 'Bacteriophage tail completion protein R', 'Phage_tail_completion_R', 4, NULL),
(11728, NULL, 'IPR014835', NULL, 'Rep protein catalytic-like', 'Rep_N', 3, NULL),
(11729, NULL, 'IPR010864', NULL, 'D-lyxose isomerase', 'D-lyxose_isomer', 4, NULL),
(11730, NULL, 'IPR009693', NULL, 'Glucitol operon activator', 'Glucitol_operon_activator', 4, NULL),
(11731, NULL, 'IPR023691', NULL, 'ABC transporter, vitamin B12 import, permease   protein BtuC', 'ABC_transptr_BtuC', 4, NULL),
(11732, NULL, 'IPR012960', NULL, 'Dyskerin-like', 'Dyskerin-like', 3, NULL),
(11733, NULL, 'IPR013341', NULL, 'Mandelate racemase/muconate lactonizing enzyme, N-terminal domain', 'Mandelate_racemase_N_dom', 3, NULL),
(11734, NULL, 'IPR012484', NULL, 'Metallothionein family 7', 'Metalthion_7', 4, NULL),
(11735, NULL, 'IPR012691', NULL, '2,4-dihydroxyhept-2-ene-1,7-dioic acid aldolase variant', 'HpaI_NOT_DapA', 4, NULL),
(11736, NULL, 'IPR020030', NULL, 'Pseudaminic acid biosynthesis, PseI', 'Pseudaminic_synth_PseI', 4, NULL),
(11737, NULL, 'IPR023135', NULL, 'N6 adenine-specific DNA methyltransferase, TaqI class, C-terminal', 'N6_DNA_MeTrfase_TaqI_C', 5, NULL),
(11738, NULL, 'IPR013574', NULL, 'Glucan-binding protein C/Surface antigen I/II, V-domain', 'Glucan-bd_C/Surface_Ag-I/II_V', 3, NULL),
(11739, NULL, 'IPR012486', NULL, 'Far11/STRP, N-terminal', 'Far11/STRP_N', 3, NULL),
(11740, NULL, 'IPR014841', NULL, 'Rad33', 'Rad33', 4, NULL),
(11741, NULL, 'IPR012964', NULL, 'Protein of unknown function DUF1702', 'DUF1702', 4, NULL),
(11742, NULL, 'IPR034958', NULL, 'Testin, LIM domain 1', 'LIM1_Testin', 3, NULL),
(11743, NULL, 'IPR011743', NULL, 'Caa(3)-type oxidase, subunit IV', 'Caa3_sub_IV', 4, NULL),
(11744, NULL, 'IPR012953', NULL, 'BOP1, N-terminal domain', 'BOP1_N_dom', 3, NULL),
(11745, NULL, 'IPR010869', NULL, 'Protein of unknown function DUF1501', 'DUF1501', 4, NULL),
(11746, NULL, 'IPR010883', NULL, 'Marek disease virus, LORF3', 'Marek_disease_virus_LORF3', 4, NULL),
(11747, NULL, 'IPR011747', NULL, 'Conserved hypothetical protein CHP02241', 'CHP02241', 4, NULL),
(11748, NULL, 'IPR012698', NULL, 'Phosphoenolpyruvate phosphomutase, core', 'PEnolPyrv_PMutase_core', 3, NULL),
(11749, NULL, 'IPR024016', NULL, 'Conserved hypothetical protein CHP04064, radical SAM', 'CHP04064_rSAM', 4, NULL),
(11750, NULL, 'IPR034630', NULL, 'MEF-2, RNA recognition motif 1', 'MYEF2_RRM1', 3, NULL),
(11751, NULL, 'IPR018025', NULL, '2-hydroxycarboxylate transporter, Proteobacteria/Firmicutes', '2-OHcarbox_trans_Prot/Firm', 4, NULL),
(11752, NULL, 'IPR010853', NULL, 'DC-EC', 'CagY_M', 7, NULL),
(11753, NULL, 'IPR010837', NULL, 'Conjugal transfer, TrbH', 'Conjugal_tfr_TrbH', 4, NULL),
(11754, NULL, 'IPR020036', NULL, 'UDP-4-amino-4,6-dideoxy-N-acetyl-beta-L-altrosamine N-acetyltransferase', 'PseH', 4, NULL),
(11755, NULL, 'IPR012973', NULL, 'NOG, C-terminal', 'NOG_C', 3, NULL),
(11756, NULL, 'IPR008453', NULL, 'Clavanin', 'Clavanin', 4, NULL),
(11757, NULL, 'IPR012686', NULL, '4-hydroxyphenylacetate degradation bifunctional isomerase/decarboxylase, N-terminal subunit', 'HPA_isomer/decarb_N', 3, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(11758, NULL, 'IPR013581', NULL, 'Plant PDR ABC transporter associated', 'PDR_assoc', 3, NULL),
(11759, NULL, 'IPR011737', NULL, 'Conserved hypothetical protein CHP02206, TP0381', 'CHP02206_TP0381', 4, NULL),
(11760, NULL, 'IPR012256', NULL, 'D-lactate dehydrogenase', 'D_lactate_DH', 4, NULL),
(11761, NULL, 'IPR011761', NULL, 'ATP-grasp fold', 'ATP-grasp', 3, NULL),
(11762, NULL, 'IPR016173', NULL, 'D-lactate dehydrogenase, cap domain, subdomain 2', 'D-lactate_DH_C-sub2', 5, NULL),
(11763, NULL, 'IPR013580', NULL, 'Light-independent protochlorophyllide reductase subunit B-like, C-terminal', 'LI-POR_suB-like_C', 3, NULL),
(11764, NULL, 'IPR014852', NULL, 'Uncharacterised protein YwhD', 'YwhD', 4, NULL),
(11765, NULL, 'IPR012966', NULL, 'Anillin homology domain', 'AHD', 3, NULL),
(11766, NULL, 'IPR016152', NULL, 'Phosphotransferase/anion transporter', 'PTrfase/Anion_transptr', 5, NULL),
(11767, NULL, 'IPR014833', NULL, 'TnsA endonuclease, N-terminal', 'TnsA_N', 3, NULL),
(11768, NULL, 'IPR014847', NULL, 'FERM adjacent (FA)', 'FERM-adjacent', 3, NULL),
(11769, NULL, 'IPR013343', NULL, 'CRISPR-associated protein Cas4', 'CRISPR-assoc_prot_Cas4', 4, NULL),
(11770, NULL, 'IPR012317', NULL, 'Poly(ADP-ribose) polymerase, catalytic domain', 'Poly(ADP-ribose)pol_cat_dom', 3, NULL),
(11771, NULL, 'IPR012978', NULL, 'Uncharacterised domain NUC173', 'Uncharacterised_NUC173', 3, NULL),
(11772, NULL, 'IPR016187', NULL, 'C-type lectin fold', 'CTDL_fold', 5, NULL),
(11773, NULL, 'IPR014832', NULL, 'TnsA endonuclease C-terminal', 'TnsA_C', 3, NULL),
(11774, NULL, 'IPR009672', NULL, 'Pkip-1', 'Pkip-1', 4, NULL),
(11775, NULL, 'IPR016061', NULL, 'Proline-tRNA ligase, class II, C-terminal', 'Pro-tRNA_ligase_II_C', 3, NULL),
(11776, NULL, 'IPR012968', NULL, 'FerIin domain', 'FerIin_dom', 3, NULL),
(11777, NULL, 'IPR009674', NULL, 'DNA-directed RNA polymerase I subunit RPA2, domain 4', 'Rpa2_dom_4', 3, NULL),
(11778, NULL, 'IPR011732', NULL, 'Mycoplasma virulence, signal domain', 'Mycoplasma_virulence_signal', 3, NULL),
(11779, NULL, 'IPR012954', NULL, 'BP28, C-terminal domain', 'BP28_C_dom', 3, NULL),
(11780, NULL, 'IPR024027', NULL, 'Colanic acid biosynthesis, acetyltransferase, WcaB', 'Colanic_acid_synth_WcaB', 4, NULL),
(11781, NULL, 'IPR019909', NULL, 'Haem uptake protein IsdC', 'Haem_uptake_protein_IsdC', 4, NULL),
(11782, NULL, 'IPR013843', NULL, 'Ribosomal protein S4e, N-terminal', 'Ribosomal_S4e_N', 3, NULL),
(11783, NULL, 'IPR012956', NULL, 'CARG-binding factor, N-terminal', 'CARG-binding_factor_N', 3, NULL),
(11784, NULL, 'IPR034178', NULL, 'Isobutyryl-CoA dehydrogenase', 'IBD', 4, NULL),
(11785, NULL, 'IPR015881', NULL, 'Aromatic-ring-hydroxylating dioxygenase, 2Fe-2S-binding site', 'Ring-hydroxy_dOase_2Fe2S_BS', 1, NULL),
(11786, NULL, 'IPR023181', NULL, 'Homospermidine synthase-like, C-terminal', 'Homospermid_syn-like_C', 5, NULL),
(11787, NULL, 'IPR010849', NULL, 'Gonadal family', 'Gonadal', 4, NULL),
(11788, NULL, 'IPR016197', NULL, 'Chromo-like domain superfamily', 'Chromo-like_dom_sf', 5, NULL),
(11789, NULL, 'IPR012318', NULL, 'Crp-type HTH domain', 'HTH_CRP', 3, NULL),
(11790, NULL, 'IPR014834', NULL, 'Gag protein p15', 'Gag_p15', 3, NULL),
(11791, NULL, 'IPR013646', NULL, 'Uncharacterised GTP-binding protein, C-terminal', 'MMR_HSR1_C', 3, NULL),
(11792, NULL, 'IPR012694', NULL, 'Propionate--CoA ligase', 'Propion_PrpE', 4, NULL),
(11793, NULL, 'IPR010868', NULL, 'Tumor suppressor ARF', 'Tumor_suppres_ARF', 4, NULL),
(11794, NULL, 'IPR010874', NULL, 'Telomere-binding protein subunit beta', 'TEBB', 4, NULL),
(11795, NULL, 'IPR012977', NULL, 'Uncharacterised domain NUC130/133, N-terminal', 'Uncharacterised_NUC130/133_N', 3, NULL),
(11796, NULL, 'IPR014803', NULL, 'DNA repair protein Nse5/Nse6', 'DNA_repair_Nse5/Nse6', 4, NULL),
(11797, NULL, 'IPR034928', NULL, 'Matrin-3, RNA recognition motif 1', 'MATR3_RRM1', 3, NULL),
(11798, NULL, 'IPR012690', NULL, '2-oxo-hepta-4-ene-1,7-dioic acid hydratase', 'HpcG', 4, NULL),
(11799, NULL, 'IPR011754', NULL, 'Myxococcus xanthus paralogous protein 2268', 'Mxa_paralog_2268', 4, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(11800, NULL, 'IPR019907', NULL, 'Ribosomal protein L6P, archaea', 'Ribosomal_L6P_arc', 4, NULL),
(11801, NULL, 'IPR010850', NULL, 'Neuroparsin', 'Neuroparsin', 4, NULL),
(11802, NULL, 'IPR009670', NULL, 'Cell surface immobilisation antigen SerH', 'SerH', 4, NULL),
(11803, NULL, 'IPR012693', NULL, 'ABC transporter, phosphonate import, PhnC', 'ABC_transpr_PhnC', 4, NULL),
(11804, NULL, 'IPR011726', NULL, 'K+ transporting P-type ATPase, F subunit', 'KdpF', 4, NULL),
(11805, NULL, 'IPR034470', NULL, 'RBM15, RNA recognition motif 1', 'RBM15_RRM1', 3, NULL),
(11806, NULL, 'IPR012733', NULL, '4-hydroxybenzoate 3-monooxygenase', 'HB_mOase', 4, NULL),
(11807, NULL, 'IPR014848', NULL, 'Reduced growth phenotype protein 1', 'Rgp1', 4, NULL),
(11808, NULL, 'IPR012706', NULL, 'Rib/alpha/Esp surface antigen', 'Rib_alpha_Esp', 7, NULL),
(11809, NULL, 'IPR020039', NULL, 'Pseudaminic acid cytidylyltransferase', 'PseF', 4, NULL),
(11810, NULL, 'IPR009662', NULL, 'Malonate decarboxylase delta subunit', 'Malonate_deCO2ase_dsu', 4, NULL),
(11811, NULL, 'IPR013647', NULL, 'Oligopeptidase F, N-terminal domain', 'OligopepF_N_dom', 3, NULL),
(11812, NULL, 'IPR013654', NULL, 'PAS fold-2', 'PAS_2', 3, NULL),
(11813, NULL, 'IPR012716', NULL, 'T-complex protein 1, beta subunit', 'Chap_CCT_beta', 4, NULL),
(11814, NULL, 'IPR012702', NULL, 'Phosphonate C-P lyase system, transcriptional regulator PhnF', 'CP_lyase_PhnF', 4, NULL),
(11815, NULL, 'IPR019906', NULL, 'Ribosomal protein L6, bacterial-type', 'Ribosomal_L6_bac-type', 4, NULL),
(11816, NULL, 'IPR013588', NULL, 'MAP2/Tau projection', 'MAP2_projctn', 3, NULL),
(11817, NULL, 'IPR009667', NULL, 'Protein of unknown function DUF1258', 'DUF1258', 4, NULL),
(11818, NULL, 'IPR012734', NULL, 'Dihydroxyacetone kinase', 'DhaK_ATP', 4, NULL),
(11819, NULL, 'IPR012481', NULL, 'Kanamycin nucleotidyltransferase, C-terminal', 'KNTase_C', 3, NULL),
(11820, NULL, 'IPR012697', NULL, 'Carboxyvinyl-carboxyphosphonate phosphorylmutase', 'CPEP_Pphonmut', 4, NULL),
(11821, NULL, 'IPR020027', NULL, 'Pseudaminic acid biosynthesis-associated methyltransferase', 'Pseudamin_synth-assoc_MeTrfase', 4, NULL),
(11822, NULL, 'IPR034631', NULL, 'MEF-2, RNA recognition motif 3', 'MYEF2_RRM3', 3, NULL),
(11823, NULL, 'IPR010880', NULL, 'Herpesvirus UL37, HHV-5-related', 'Herpes_UL37_HHV-5-rel', 4, NULL),
(11824, NULL, 'IPR012962', NULL, 'Peptidase M54, archaemetzincin', 'Pept_M54_archaemetzincn', 4, NULL),
(11825, NULL, 'IPR014826', NULL, 'Formaldehyde-activating enzyme', 'HCHO-activating_enzyme', 3, NULL),
(11826, NULL, 'IPR010892', NULL, 'Secreted phosphoprotein 24', 'Spp-24', 4, NULL),
(11827, NULL, 'IPR013575', NULL, 'Initiation factor 2 associated domain, bacterial', 'IF2_assoc_dom_bac', 3, NULL),
(11828, NULL, 'IPR014840', NULL, 'Hpc2-related domain', 'HRD', 3, NULL),
(11829, NULL, 'IPR012321', NULL, 'Conotoxin, omega-type, conserved site', 'Conotoxin_omega-typ_CS', 2, NULL),
(11830, NULL, 'IPR012729', NULL, 'Thiamine biosynthesis protein ThiF', 'ThiF_fam2', 4, NULL),
(11831, NULL, 'IPR020073', NULL, 'Uncharacterised protein family AF1718', 'Uncharacterised_AF1718', 4, NULL),
(11832, NULL, 'IPR024001', NULL, 'Cysteine-rich peptide, radical SAM maturase, CcpM', 'Cys-rich_pep_rSAM_mat_CcpM', 4, NULL),
(11833, NULL, 'IPR011742', NULL, 'CRISPR-associated protein, TM1812', 'CRISPR-assoc_prot_TM1812', 4, NULL),
(11834, NULL, 'IPR016190', NULL, 'Translation initiation factor IF2/IF5, zinc-binding', 'Transl_init_fac_IF2/IF5_Zn-bd', 5, NULL),
(11835, NULL, 'IPR014836', NULL, 'Integrin beta subunit, cytoplasmic domain', 'Integrin_bsu_cyt_dom', 3, NULL),
(11836, NULL, 'IPR009701', NULL, 'Special lobe-specific silk SSP160', 'SSP160', 4, NULL),
(11837, NULL, 'IPR011753', NULL, 'DUSAM domain', 'DUSAM_dom', 3, NULL),
(11838, NULL, 'IPR019978', NULL, 'Ribosomal protein S17, archaeal', 'Ribosomal_S17_archaeal', 4, NULL),
(11839, NULL, 'IPR012971', NULL, 'Nucleolar GTP-binding protein 2, N-terminal domain', 'NOG2_N_dom', 3, NULL),
(11840, NULL, 'IPR010860', NULL, 'CAMP factor', 'CAMP_factor', 4, NULL),
(11841, NULL, 'IPR008451', NULL, 'Chromadorea ALT', 'Chromadorea_ALT', 4, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(11842, NULL, 'IPR010882', NULL, 'Acidic phosphoprotein PCEMA1', 'PCEMA1', 4, NULL),
(11843, NULL, 'IPR009705', NULL, 'Protein of unknown function DUF1286', 'DUF1286', 4, NULL),
(11844, NULL, 'IPR012479', NULL, 'SAP30-binding protein', 'SAP30BP', 4, NULL),
(11845, NULL, 'IPR013789', NULL, 'Phosphotransferase system, mannose family IIA component', 'PTS_EIIA_man', 3, NULL),
(11846, NULL, 'IPR023130', NULL, 'Ta0600-like superfamily', 'Ta0600-like_sf', 5, NULL),
(11847, NULL, 'IPR010872', NULL, 'MDMPI C-terminal', 'MDMPI_C-term_domain', 3, NULL),
(11848, NULL, 'IPR009696', NULL, 'Putative replisome organiser, C-terminal', 'Rep_Org_C', 3, NULL),
(11849, NULL, 'IPR014846', NULL, 'Protein of unknown function DUF1786, putative pyruvate format-lyase activating enzyme', 'DUF1786_pyruvate_format-lyase', 4, NULL),
(11850, NULL, 'IPR020025', NULL, 'UDP-N-acetylglucosamine 4,6-dehydratase (inverting)', 'PseB', 4, NULL),
(11851, NULL, 'IPR012251', NULL, 'N-acetylglucosamine-6-sulfatase', 'GlcNAc_6-SO4ase', 4, NULL),
(11852, NULL, 'IPR016181', NULL, 'Acyl-CoA N-acyltransferase', 'Acyl_CoA_acyltransferase', 5, NULL),
(11853, NULL, 'IPR013578', NULL, 'Peptidase M16C associated', 'Peptidase_M16C_assoc', 3, NULL),
(11854, NULL, 'IPR013658', NULL, 'SMP-30/Gluconolactonase/LRE-like region', 'SGL', 3, NULL),
(11855, NULL, 'IPR013576', NULL, 'Insulin-like growth factor II E-peptide, C-terminal', 'IGF2_C', 3, NULL),
(11856, NULL, 'IPR020020', NULL, 'Luciferase-type oxidoreductase', 'Luciferase-type_oxidoreductase', 4, NULL),
(11857, NULL, 'IPR009666', NULL, 'Uncharacterised protein family Ycf35', 'Uncharacterised_Ycf35', 4, NULL),
(11858, NULL, 'IPR012955', NULL, 'CASP, C-terminal', 'CASP_C', 3, NULL),
(11859, NULL, 'IPR012735', NULL, 'Dihydroxyacetone kinase DhaK, subunit 1b', 'DhaK_1b', 4, NULL),
(11860, NULL, 'IPR011729', NULL, 'Polyhydroxyalkanoic acid synthase, PhaR subunit', 'PhaR_Bmeg_synth', 4, NULL),
(11861, NULL, 'IPR019981', NULL, 'Ribosomal protein S11, bacterial-type', 'Ribosomal_S11_bac-type', 4, NULL),
(11862, NULL, 'IPR012950', NULL, 'Alpha enterocin/lactococcin', 'Alpha_enterocin/lactococcin', 4, NULL),
(11863, NULL, 'IPR023695', NULL, 'Thiosulfate sulfurtransferase, bacterial', 'Thiosulf_sulfurTrfase', 4, NULL),
(11864, NULL, 'IPR013852', NULL, 'Translation elongation factor P/YeiP, conserved site', 'Transl_elong_P/YeiP_CS', 2, NULL),
(11865, NULL, 'IPR010840', NULL, 'Inner membrane protein YqiJ', 'YqiJ', 4, NULL),
(11866, NULL, 'IPR014805', NULL, 'SKG6/TOS2-like', 'SKG6/TOS2-like', 4, NULL),
(11867, NULL, 'IPR009688', NULL, 'Protein FAM210A/B-like domain', 'FAM210A/B-like_dom', 3, NULL),
(11868, NULL, 'IPR013593', NULL, 'Pro-opiomelanocortin N-terminal', 'Melanocortin_N', 3, NULL),
(11869, NULL, 'IPR014815', NULL, 'Phospholipase C-beta, C-terminal domain', 'PLC-beta_C', 3, NULL),
(11870, NULL, 'IPR011751', NULL, 'Myxococcus xanthus paralogous protein 2265', 'Mxa_paralog_2265', 4, NULL),
(11871, NULL, 'IPR014812', NULL, 'Vacuolar protein sorting-associated protein 51', 'Vps51', 4, NULL),
(11872, NULL, 'IPR012684', NULL, '4-hydroxyphenylacetate degradation bifunctional isomerase/decarboxylase, C-terminal subunit', 'HPA_isomer/decarb_C', 3, NULL),
(11873, NULL, 'IPR013589', NULL, 'Bacterial transglutaminase-like, N-terminal', 'Bac_transglu_N', 3, NULL),
(11874, NULL, 'IPR020004', NULL, 'UDP-N-acetylglucosamine 2-epimerase,UDP-hydrolysing', 'UDP-GlcNAc_Epase', 4, NULL),
(11875, NULL, 'IPR012263', NULL, 'Adenine modification methylase, M.EcoRV-type', 'M_m6A_EcoRV', 4, NULL),
(11876, NULL, 'IPR011749', NULL, 'Conserved hypothetical protein CHP02243', 'CHP02243', 4, NULL),
(11877, NULL, 'IPR014764', NULL, 'Defective-in-cullin neddylation protein', 'DCN-prot', 4, NULL),
(11878, NULL, 'IPR010877', NULL, 'Bacteriophage Mu, Baseplate protein gp46', 'Phage_Mu_Gp46', 4, NULL),
(11879, NULL, 'IPR012798', NULL, 'Cobalamin (vitamin B12) biosynthesis CobG-like', 'Cbl_synth_CobG-like', 4, NULL),
(11880, NULL, 'IPR018171', NULL, 'Peptidyl-tRNA hydrolase, conserved site', 'Pept_tRNA_hydro_CS', 2, NULL),
(11881, NULL, 'IPR014816', NULL, 'tRNA (1-methyladenosine) methyltransferase catalytic subunit Gcd14', 'tRNA_MeTrfase_Gcd14', 4, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(11882, NULL, 'IPR014831', NULL, 'Haemagglutinin stalk, influenza C', 'Hemagglutn_stalk_influenz-C', 3, NULL),
(11883, NULL, 'IPR012699', NULL, 'Ribose 1,5-bisphosphate phosphokinase PhnN', 'PhnN', 4, NULL),
(11884, NULL, 'IPR012713', NULL, 'Prefoldin subunit beta', 'PfdB', 4, NULL),
(11885, NULL, 'IPR012255', NULL, 'Electron transfer flavoprotein, beta subunit', 'ETF_b', 4, NULL),
(11886, NULL, 'IPR016170', NULL, 'Cytokinin dehydrogenase, C-terminal domain superfamily', 'Cytok_DH_C_sf', 5, NULL),
(11887, NULL, 'IPR013649', NULL, 'Integrin alpha-2', 'Integrin_alpha-2', 3, NULL),
(11888, NULL, 'IPR016169', NULL, 'FAD-binding, type PCMH, subdomain 2', 'FAD-bd_PCMH_sub2', 5, NULL),
(11889, NULL, 'IPR014824', NULL, 'Scaffold protein Nfu/NifU, N-terminal', 'Nfu/NifU_N', 3, NULL),
(11890, NULL, 'IPR009700', NULL, 'Protein of unknown function DUF1283', 'DUF1283', 4, NULL),
(11891, NULL, 'IPR010836', NULL, 'SapC', 'SapC', 4, NULL),
(11892, NULL, 'IPR016155', NULL, 'Molybdopterin synthase/thiamin biosynthesis sulphur carrier, beta-grasp', 'Mopterin_synth/thiamin_S_b', 5, NULL),
(11893, NULL, 'IPR009694', NULL, 'Protein of unknown function DUF1281', 'DUF1281', 4, NULL),
(11894, NULL, 'IPR017438', NULL, 'Inorganic polyphosphate/ATP-NAD kinase, N-terminal', 'ATP-NAD_kinase_N', 5, NULL),
(11895, NULL, 'IPR010843', NULL, 'Uncharacterised protein family AroM', 'Uncharacterised_AroM', 4, NULL),
(11896, NULL, 'IPR018170', NULL, 'Aldo/keto reductase, conserved site', 'Aldo/ket_reductase_CS', 2, NULL),
(11897, NULL, 'IPR012480', NULL, 'Heparinase II/III-like', 'Hepar_II_III', 4, NULL),
(11898, NULL, 'IPR013767', NULL, 'PAS fold', 'PAS_fold', 3, NULL),
(11899, NULL, 'IPR014821', NULL, 'Inositol 1,4,5-trisphosphate/ryanodine receptor', 'Ins145_P3_rcpt', 3, NULL),
(11900, NULL, 'IPR012709', NULL, '2-methyl-aconitate isomerase PrpF', 'PrpF', 4, NULL),
(11901, NULL, 'IPR013587', NULL, 'Nitrate/nitrite sensing protein', 'Nitrate/nitrite_sensing', 3, NULL),
(11902, NULL, 'IPR019979', NULL, 'Ribosomal protein S17, conserved site', 'Ribosomal_S17_CS', 2, NULL),
(11903, NULL, 'IPR016201', NULL, 'PSI domain', 'PSI', 3, NULL),
(11904, NULL, 'IPR034940', NULL, 'Gallate dioxygenase, C-terminal', 'Gallate_dioxygenase_C', 3, NULL),
(11905, NULL, 'IPR012315', NULL, 'KASH domain', 'KASH', 3, NULL),
(11906, NULL, 'IPR009683', NULL, 'Extensin-like, C-terminal', 'Extensin-like_C', 3, NULL),
(11907, NULL, 'IPR012324', NULL, 'Cyclotide, moebius, conserved site', 'Cyclotide_moebius_CS', 2, NULL),
(11908, NULL, 'IPR024018', NULL, 'Conserved hypothetical protein CHP04083, radical SAM', 'CHP04083_rSAM', 4, NULL),
(11909, NULL, 'IPR011727', NULL, 'Conserved hypothetical protein CHP02117', 'CHP02117', 4, NULL),
(11910, NULL, 'IPR024037', NULL, 'Alternate ATP synthase, F1 complex, subunit epsilon', 'Alt_ATP_synth_F1_esu', 4, NULL),
(11911, NULL, 'IPR011735', NULL, 'HtrL protein', 'HtrL', 4, NULL),
(11912, NULL, 'IPR020026', NULL, 'UDP-4-amino-4,6-dideoxy-N-acetyl-beta-L-altrosamine transaminase', 'PseC', 4, NULL),
(11913, NULL, 'IPR011757', NULL, 'Lytic transglycosylase MltB', 'Lytic_transglycosylase_MltB', 4, NULL),
(11914, NULL, 'IPR012719', NULL, 'T-complex protein 1, gamma subunit', 'Chap_CCT_gamma', 4, NULL),
(11915, NULL, 'IPR012314', NULL, 'Peptidase M12B, GON-ADAMTSs', 'Pept_M12B_GON-ADAMTSs', 3, NULL),
(11916, NULL, 'IPR016195', NULL, 'Polymerase/histidinol phosphatase-like', 'Pol/histidinol_Pase-like', 5, NULL),
(11917, NULL, 'IPR013597', NULL, 'Group II intron, maturase-specific', 'Mat_intron_G2', 3, NULL),
(11918, NULL, 'IPR009703', NULL, 'Selenoprotein S', 'Selenoprotein_S', 4, NULL),
(11919, NULL, 'IPR012705', NULL, '2-methylcitrate dehydratase PrpD', '2Me_IsoCit_deHydtase_PrpD', 4, NULL),
(11920, NULL, 'IPR024046', NULL, 'Flagellar assembly factor FliW domain superfamily', 'Flagellar_assmbl_FliW_dom_sf', 5, NULL),
(11921, NULL, 'IPR015757', NULL, 'Calcineurin B protein', 'Calcineur_B', 4, NULL),
(11922, NULL, 'IPR013655', NULL, 'PAS fold-3', 'PAS_fold_3', 3, NULL),
(11923, NULL, 'IPR016161', NULL, 'Aldehyde/histidinol dehydrogenase', 'Ald_DH/histidinol_DH', 5, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(11924, NULL, 'IPR011744', NULL, 'F0F1-ATPase subunit, putative', 'ATPase_gene1', 4, NULL),
(11925, NULL, 'IPR018026', NULL, 'DNA repair protein Rad4, subgroup', 'DNA_repair_Rad4_subgr', 4, NULL),
(11926, NULL, 'IPR016184', NULL, 'Capsid/spike protein, ssDNA virus', 'Capsid/spike_ssDNA_virus', 5, NULL),
(11927, NULL, 'IPR016183', NULL, 'Leukocidin/Hemolysin toxin', 'Leukocidin/Hemolysin_toxin', 3, NULL),
(11928, NULL, 'IPR010863', NULL, 'Protein of unknown function DUF1495', 'DUF1495', 4, NULL),
(11929, NULL, 'IPR011740', NULL, 'Protein of unknown function DUF2460', 'DUF2460', 4, NULL),
(11930, NULL, 'IPR012732', NULL, 'Hydroxymethylpyrimidine transporter CytX', 'Thia_CytX', 4, NULL),
(11931, NULL, 'IPR023696', NULL, 'Ureohydrolase domain superfamily', 'Ureohydrolase_dom_sf', 5, NULL),
(11932, NULL, 'IPR012320', NULL, 'Stonin homology', 'SHD_dom', 3, NULL),
(11933, NULL, 'IPR012685', NULL, 'Conserved hypothetical protein CHP02304, F390 synthetase-related', 'CHP02304_F390_synth-rel', 4, NULL),
(11934, NULL, 'IPR016172', NULL, 'D-lactate dehydrogenase, cap domain, subdomain 1', 'D-lactate_DH_C-sub1', 5, NULL),
(11935, NULL, 'IPR009689', NULL, 'Protein of unknown function DUF1280', 'DUF1280', 4, NULL),
(11936, NULL, 'IPR010851', NULL, 'Defensin-like protein', 'DEFL', 4, NULL),
(11937, NULL, 'IPR012313', NULL, 'Zinc finger, FCS-type', 'Znf_FCS', 3, NULL),
(11938, NULL, 'IPR024025', NULL, 'SCIFF radical SAM maturase', 'SCIFF_rSAM_maturase', 4, NULL),
(11939, NULL, 'IPR013648', NULL, 'Polyprotein, Potyviridae', 'PP_Potyviridae', 3, NULL),
(11940, NULL, 'IPR009685', NULL, 'Male enhanced antigen 1', 'MEA1', 4, NULL),
(11941, NULL, 'IPR009668', NULL, 'RNA polymerase I associated factor, A49-like', 'RNA_pol-assoc_fac_A49-like', 4, NULL),
(11942, NULL, 'IPR011745', NULL, 'RNA polymerase sigma-70, Myxococcus xanthus', 'RNA_pol_sigma70_MYXXA', 4, NULL),
(11943, NULL, 'IPR014828', NULL, 'Non-structural protein NSP7, coronavirus', 'NSP7_CoV', 3, NULL),
(11944, NULL, 'IPR009663', NULL, 'Pilin accessory predicted', 'PAP_PilO', 4, NULL),
(11945, NULL, 'IPR016154', NULL, 'Heat shock protein Hsp33, C-terminal', 'Heat_shock_Hsp33_C', 5, NULL),
(11946, NULL, 'IPR013591', NULL, 'Brevis radix (BRX) domain', 'Brevis_radix_dom', 3, NULL),
(11947, NULL, 'IPR014808', NULL, 'DNA replication factor Dna2, N-terminal', 'DNA_replication_fac_Dna2_N', 3, NULL),
(11948, NULL, 'IPR034469', NULL, 'Ribosome biogenesis protein 15, RNA recognition motif', 'Nop15_RRM', 3, NULL),
(11949, NULL, 'IPR010876', NULL, 'C1orf43', 'C1orf43', 4, NULL),
(11950, NULL, 'IPR012722', NULL, 'T-complex protein 1, zeta subunit', 'Chap_CCT_zeta', 4, NULL),
(11951, NULL, 'IPR012247', NULL, 'Bifunctional molybdenum cofactor biosynthesis protein MoaC/MogA', 'MoaC_MogA', 4, NULL),
(11952, NULL, 'IPR014806', NULL, 'Ubiquitin-fold modifier-conjugating enzyme 1', 'Ufc1', 4, NULL),
(11953, NULL, 'IPR013657', NULL, 'UAA transporter', 'UAA', 4, NULL),
(11954, NULL, 'IPR010878', NULL, 'Protein of unknown function Gp111', 'Gp111', 4, NULL),
(11955, NULL, 'IPR009692', NULL, 'P13 protein, Citrus tristeza virus', 'P13_Citrus_tristeza_virus', 4, NULL),
(11956, NULL, 'IPR012258', NULL, 'Acyl-CoA oxidase', 'Acyl-CoA_oxidase', 4, NULL),
(11957, NULL, 'IPR010861', NULL, 'Protein of unknown function DUF1492', 'DUF1492', 4, NULL),
(11958, NULL, 'IPR010844', NULL, 'Occludin homology domain', 'Occludin_ELL', 3, NULL),
(11959, NULL, 'IPR016120', NULL, 'Signal transduction histidine kinase, sporulation regulator SpoOB', 'Sig_transdc_His_kin_SpoOB', 5, NULL),
(11960, NULL, 'IPR012695', NULL, '2-methylisocitrate lyase', 'PrpB', 4, NULL),
(11961, NULL, 'IPR013594', NULL, 'Dynein heavy chain, tail', 'Dynein_heavy_tail', 3, NULL),
(11962, NULL, 'IPR012483', NULL, 'Inner membrane mitoribosome receptor Mba1, Saccharomycetales', 'Mba1_Saccharomycetales', 4, NULL),
(11963, NULL, 'IPR010866', NULL, 'Alpha-2,8-polysialyltransferase', 'A-2_8-polyST', 4, NULL),
(11964, NULL, 'IPR016167', NULL, 'FAD-binding, type PCMH, subdomain 1', 'FAD-bd_PCMH_sub1', 5, NULL),
(11965, NULL, 'IPR014830', NULL, 'Glycolipid transfer protein domain', 'Glycolipid_transfer_prot_dom', 3, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(11966, NULL, 'IPR015904', NULL, 'Sulphide quinone-reductase', 'Sulphide_quinone_reductase', 4, NULL),
(11967, NULL, 'IPR014804', NULL, 'Mitochondrial protein Pet20-like', 'Pet20-like', 4, NULL),
(11968, NULL, 'IPR012477', NULL, 'Glycosyltransferase family 52', 'Glyco_transf_52', 4, NULL),
(11969, NULL, 'IPR020066', NULL, 'Cortexin', 'Cortexin', 4, NULL),
(11970, NULL, 'IPR012975', NULL, 'NOPS', 'NOPS', 3, NULL),
(11971, NULL, 'IPR034927', NULL, 'TNRC6C, RNA recognition motif', 'TNRC6C_RRM', 3, NULL),
(11972, NULL, 'IPR014829', NULL, 'Non-structural protein NSP8, coronavirus', 'NSP8_CoV', 3, NULL),
(11973, NULL, 'IPR009690', NULL, 'Bacteriophage T4, Gp30.7', 'Phage_T4_Gp30_7', 4, NULL),
(11974, NULL, 'IPR011758', NULL, 'Alpha-L-glutamate ligase-related protein', 'RimK-rel_E_lig', 4, NULL),
(11975, NULL, 'IPR017441', NULL, 'Protein kinase, ATP binding site', 'Protein_kinase_ATP_BS', 1, NULL),
(11976, NULL, 'IPR012967', NULL, 'Plant methyltransferase dimerisation', 'Plant_MeTrfase_dimerisation', 3, NULL),
(11977, NULL, 'IPR020065', NULL, 'Conjugal transfer protein TrbK', 'Conjugal_tfr_protein_TrbK', 4, NULL),
(11978, NULL, 'IPR011755', NULL, 'Conserved hyptothetical protein CHP02269, MYXXA', 'CHP02269_MYXXA', 4, NULL),
(11979, NULL, 'IPR013579', NULL, 'FAST kinase-like protein, subdomain 2', 'FAST_2', 3, NULL),
(11980, NULL, 'IPR024009', NULL, 'Colanic acid biosynthesis, glycosyl transferase, WcaA', 'Colanic_acid_synth_WcaA', 4, NULL),
(11981, NULL, 'IPR034613', NULL, 'Muconate cycloisomerase (anti)', 'Muconate_cycloisomerase_anti', 4, NULL),
(11982, NULL, 'IPR012799', NULL, 'Fatty oxidation complex, alpha subunit FadB', 'FadB', 4, NULL),
(11983, NULL, 'IPR012951', NULL, 'Berberine/berberine-like', 'BBE', 3, NULL),
(11984, NULL, 'IPR016160', NULL, 'Aldehyde dehydrogenase, cysteine active site', 'Ald_DH_CS_CYS', 2, NULL),
(11985, NULL, 'IPR010855', NULL, 'Cytomegalovirus IE1/IE2', 'Cytomega_IE1/IE2', 4, NULL),
(11986, NULL, 'IPR010893', NULL, '[NiFe]-hydrogenase maturation factor  HyaE', 'NiFe-hyd_mat_HyaE', 4, NULL),
(11987, NULL, 'IPR011741', NULL, 'Phage conserved hypothetical protein, C-terminal', 'Phg_2220_C', 3, NULL),
(11988, NULL, 'IPR024028', NULL, 'Polynucleotide kinase-phosphatase, bacterial', 'PNKP_bac', 4, NULL),
(11989, NULL, 'IPR009702', NULL, 'Protein of unknown function DUF1284', 'DUF1284', 4, NULL),
(11990, NULL, 'IPR010881', NULL, 'Gammaherpesvirus latent membrane protein 2', 'Herpes_LMP2', 4, NULL),
(11991, NULL, 'IPR024229', NULL, 'Protein of unknown function DUF3781', 'DUF3781', 4, NULL),
(11992, NULL, 'IPR010886', NULL, 'Histone H1-like Hc1', 'Hc1', 4, NULL),
(11993, NULL, 'IPR015760', NULL, 'Translation initiation factor IF- 2', 'TIF_IF2', 4, NULL),
(11994, NULL, 'IPR014838', NULL, 'Poliovirus 3A protein-like', 'P3A', 3, NULL),
(11995, NULL, 'IPR012708', NULL, '2-methylisocitrate dehydratase AcnD, Fe/S-dependent', '2Me_IsoCit_deHydtase_FeS-dep', 4, NULL),
(11996, NULL, 'IPR010870', NULL, 'Phosphate-selective porin O/P', 'Porin_O/P', 4, NULL),
(11997, NULL, 'IPR011733', NULL, 'Conserved hypothetical CHP02185, integral membrane', 'CHP02185_IM', 4, NULL),
(11998, NULL, 'IPR012727', NULL, 'Glycine oxidase ThiO', 'Gly_oxidase_ThiO', 4, NULL),
(11999, NULL, 'IPR019977', NULL, 'Ribosomal protein S13, archaeal', 'Ribosomal_S13_archaeal', 4, NULL),
(12000, NULL, 'IPR016202', NULL, 'Deoxyribonuclease I', 'DNase_I', 4, NULL),
(12001, NULL, 'IPR010516', NULL, 'Sin3 associated polypeptide p18', 'SAP18', 4, NULL),
(12002, NULL, 'IPR024086', NULL, 'Phosphoglucosamine mutase, archaeal type', 'GlmM_arc-type', 4, NULL),
(12003, NULL, 'IPR024050', NULL, 'AICAR transformylase, insert domain superfamily', 'AICAR_Tfase_insert_dom_sf', 5, NULL),
(12004, NULL, 'IPR015239', NULL, 'Anthrax toxin lethal factor, central domain', 'Anthrax_LF_cen', 3, NULL),
(12005, NULL, 'IPR015256', NULL, 'Initiation factor eIF2 gamma, C-terminal', 'eIF2g_C', 3, NULL),
(12006, NULL, 'IPR008491', NULL, 'CDK5 regulatory subunit-associated protein 3', 'CDK5RAP3', 4, NULL),
(12007, NULL, 'IPR034475', NULL, 'RBM15B, RNA recognition motif 1', 'RBM15B_RRM1', 3, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(12008, NULL, 'IPR024073', NULL, 'Argininosuccinate synthetase mutimerisation domain, C-terminal tail', 'AS_multimer_C_tail', 5, NULL),
(12009, NULL, 'IPR014737', NULL, 'Transposase, Tn5-like, C-terminal', 'Transposase_Tn5-like_C', 5, NULL),
(12010, NULL, 'IPR008454', NULL, 'Collagen-binding surface protein Cna-like, B-type domain', 'Collagen-bd_Cna-like_B-typ_dom', 3, NULL),
(12011, NULL, 'IPR012853', NULL, 'Chloramphenicol phosphotransferase-like', 'CPT', 4, NULL),
(12012, NULL, 'IPR009739', NULL, 'Lysozyme inhibitor LprI, N-terminal', 'LprI_N', 3, NULL),
(12013, NULL, 'IPR034034', NULL, 'Tumor necrosis factor receptor 21, N-terminal', 'TNFRSF21_N', 3, NULL),
(12014, NULL, 'IPR012078', NULL, 'Methane/phenol monooxygenase, hydroxylase component', 'MP_mOase_hydro', 4, NULL),
(12015, NULL, 'IPR011907', NULL, 'Ribonuclease III', 'RNase_III', 4, NULL),
(12016, NULL, 'IPR012072', NULL, 'LytTR signal transduction protein, putative', 'Sigtransdc_LytTR', 4, NULL),
(12017, NULL, 'IPR008731', NULL, 'Phosphotransferase system, enzyme I  N-terminal', 'PTS_EIN', 3, NULL),
(12018, NULL, 'IPR024238', NULL, 'Initiator binding protein 39kDa, C-terminal', 'IBP39_C', 3, NULL),
(12019, NULL, 'IPR034513', NULL, 'hnRNP A3, RNA recognition motif 1', 'hnRNPA3_RRM1', 3, NULL),
(12020, NULL, 'IPR034516', NULL, 'hnRNP A3, RNA recognition motif 2', 'hnRNPA3_RRM2', 3, NULL),
(12021, NULL, 'IPR011303', NULL, 'Ion-translocating oxidoreductase complex Rnf, subunit D', 'RnfD', 4, NULL),
(12022, NULL, 'IPR009746', NULL, 'Antimicrobial peptide resistance/lipid A acylation PagP', 'Peptid-resist/lipidA_acyl_PagP', 4, NULL),
(12023, NULL, 'IPR008455', NULL, 'HssA/B family related', 'HssA/B-related', 4, NULL),
(12024, NULL, 'IPR024079', NULL, 'Metallopeptidase, catalytic domain superfamily', 'MetalloPept_cat_dom_sf', 5, NULL),
(12025, NULL, 'IPR024698', NULL, 'Capsular polysaccharide biosynthesis protein, Cps23fI-type, predicted', 'Caps_psacc_synth_Cps23fI-typ', 4, NULL),
(12026, NULL, 'IPR011898', NULL, '2-oxoacid:acceptor oxidoreductase, delta subunit, pyruvate/2-ketoisovalerate', 'PorD_KorD', 4, NULL),
(12027, NULL, 'IPR011911', NULL, 'Glutaredoxin-like protein, YruB', 'GlrX_YruB', 4, NULL),
(12028, NULL, 'IPR013219', NULL, 'Ribosomal protein S27/S33, mitochondrial', 'Ribosomal_S27/S33_mit', 4, NULL),
(12029, NULL, 'IPR008501', NULL, 'THO complex subunit 7/Mft1', 'THOC7/Mft1', 4, NULL),
(12030, NULL, 'IPR012859', NULL, 'Archaeal Type IV pilin, N-terminal', 'Pilin_N_archaeal', 3, NULL),
(12031, NULL, 'IPR012674', NULL, 'Calycin', 'Calycin', 5, NULL),
(12032, NULL, 'IPR008761', NULL, 'Peptidase S37, tripeptidyl aminopeptidase', 'Peptidase_S37', 4, NULL),
(12033, NULL, 'IPR009729', NULL, 'Galactose-3-O-sulfotransferase', 'Gal-3-0_sulfotransfrase', 4, NULL),
(12034, NULL, 'IPR014739', NULL, 'Channel forming colicin, N-terminal domain superfamily', 'Channel_colicin_N_sf', 5, NULL),
(12035, NULL, 'IPR012877', NULL, 'Uncharacterised  oxidoreductase Dhs-27', 'Dhs-27', 4, NULL),
(12036, NULL, 'IPR009728', NULL, 'BAALC', 'BAALC', 4, NULL),
(12037, NULL, 'IPR008722', NULL, 'Outer membrane porin F, N-terminal', 'OprF_membrane_N', 3, NULL),
(12038, NULL, 'IPR009755', NULL, 'Regulator of MON1-CCZ1 complex, C-terminal', 'RMC1_C', 3, NULL),
(12039, NULL, 'IPR014529', NULL, 'Uncharacterised conserved protein UCP026631', 'UCP026631', 4, NULL),
(12040, NULL, 'IPR012864', NULL, 'Cysteine oxygenase/2-aminoethanethiol dioxygenase', 'PCO/ADO', 4, NULL),
(12041, NULL, 'IPR012676', NULL, 'TGS-like', 'TGS-like', 5, NULL),
(12042, NULL, 'IPR015288', NULL, 'Protein of unknown function DUF1955', 'DUF1955', 4, NULL),
(12043, NULL, 'IPR008726', NULL, 'Poxvirus F8', 'Poxvirus_F8', 4, NULL),
(12044, NULL, 'IPR009752', NULL, 'Bacteriophage Mu, Gene product J', 'Phage_Mu_GpJ', 4, NULL),
(12045, NULL, 'IPR015241', NULL, 'Transcription regulator MotA, C-terminal', 'MotA_Tscrpt_reg_C', 3, NULL),
(12046, NULL, 'IPR009730', NULL, 'Micro-fibrillar-associated protein 1, C-terminal', 'MFAP1_C', 3, NULL),
(12047, NULL, 'IPR008497', NULL, 'Protein of unknown function DUF779', 'DUF779', 4, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(12048, NULL, 'IPR014774', NULL, 'KaiC-like domain', 'KaiC-like_dom', 3, NULL),
(12049, NULL, 'IPR024279', NULL, 'Paramyxovirinae protein V, zinc-binding domain', 'Paramyx_V_Zn-bd', 3, NULL),
(12050, NULL, 'IPR015242', NULL, 'Mitochondrial resolvase Ydc2, catalytic', 'Ydc2_cat', 3, NULL),
(12051, NULL, 'IPR009737', NULL, 'Thioredoxin-like ferredoxin', 'Aim32/Apd1-like', 4, NULL),
(12052, NULL, 'IPR008744', NULL, 'RNA-directed RNA polymerase, apple chlorotic leaf spot virus', 'RNA-dir_pol_ACLSV', 3, NULL),
(12053, NULL, 'IPR008466', NULL, 'Protein phosphatase inhibitor 1', 'PPP1R1A/B/C', 4, NULL),
(12054, NULL, 'IPR014538', NULL, 'Uncharacterised conserved protein, topoisomerase zinc finger', 'UCP028063_topo_Znf', 4, NULL),
(12055, NULL, 'IPR011917', NULL, 'ABC transporter, lipid A-core flippase, MsbA', 'ABC_transpr_lipidA', 4, NULL),
(12056, NULL, 'IPR008331', NULL, 'Ferritin/DPS protein domain', 'Ferritin_DPS_dom', 3, NULL),
(12057, NULL, 'IPR034637', NULL, 'Negative elongation factor E, RNA recognition motif', 'NELFE_RRM', 3, NULL),
(12058, NULL, 'IPR013225', NULL, 'PaaX-like, C-terminal', 'PaaX_C', 3, NULL),
(12059, NULL, 'IPR012312', NULL, 'Hemerythrin-like', 'Hemerythrin-like', 3, NULL),
(12060, NULL, 'IPR015257', NULL, 'Repressor of RNA polymerase III transcription  Maf1', 'Maf1', 4, NULL),
(12061, NULL, 'IPR011896', NULL, '2-oxoacid:acceptor oxidoreductase, beta subunit', 'OFOB', 4, NULL),
(12062, NULL, 'IPR015281', NULL, 'DNA beta-glucosyltransferase, bacteriophage', 'Phage_Bgt', 4, NULL),
(12063, NULL, 'IPR008472', NULL, 'Domain of unknown function DUF753', 'DUF753', 3, NULL),
(12064, NULL, 'IPR011904', NULL, 'Acetate-CoA ligase', 'Ac_CoA_lig', 4, NULL),
(12065, NULL, 'IPR008463', NULL, 'Transcriptional regulator CtsR', 'CtsR', 4, NULL),
(12066, NULL, 'IPR015267', NULL, 'Protein phosphatase 4 core regulatory subunit R2', 'PPP4R2', 4, NULL),
(12067, NULL, 'IPR015295', NULL, 'Carbohydrate binding module 27', 'Carb-bd_module_27', 3, NULL),
(12068, NULL, 'IPR014388', NULL, '3-oxoacid CoA-transferase', '3-oxoacid_CoA-transferase', 4, NULL),
(12069, NULL, 'IPR014536', NULL, 'Sorting nexin 9 family', 'Snx9_fam', 4, NULL),
(12070, NULL, 'IPR024282', NULL, 'Domain of unknown function DUF3376', 'DUF3376', 3, NULL),
(12071, NULL, 'IPR024119', NULL, 'Transcription factor DEAF-1', 'TF_DEAF-1', 4, NULL),
(12072, NULL, 'IPR008751', NULL, 'Peptidase C53, pestivirus Npro', 'Peptidase_C53', 3, NULL),
(12073, NULL, 'IPR008737', NULL, 'Peptidase aspartic, putative', 'Peptidase_asp_put', 3, NULL),
(12074, NULL, 'IPR014527', NULL, 'Excinuclease GIY-YIG catalytic domain-containing uncharacterised conserved protein', 'UCP026568_excinuclease', 4, NULL),
(12075, NULL, 'IPR024134', NULL, 'Superoxide dismutase (Cu/Zn) / superoxide dismutase copper chaperone', 'SOD_Cu/Zn_/chaperone', 4, NULL),
(12076, NULL, 'IPR012858', NULL, 'Dendritic cell-specific transmembrane protein-like', 'DC_STAMP-like', 3, NULL),
(12077, NULL, 'IPR013222', NULL, 'Glycosyl hydrolase family 98, putative carbohydrate-binding module', 'Glyco_hyd_98_carb-bd', 3, NULL),
(12078, NULL, 'IPR011524', NULL, 'SARAH domain', 'SARAH_dom', 3, NULL),
(12079, NULL, 'IPR023626', NULL, 'Ribosomal protein L39e domain superfamily', 'Ribosomal_L39e_dom_sf', 5, NULL),
(12080, NULL, 'IPR009718', NULL, 'Rex DNA-binding, C-terminal domain', 'Rex_DNA-bd_C_dom', 3, NULL),
(12081, NULL, 'IPR015264', NULL, 'Prolyl-tRNA synthetase, class II, C-terminal, archaeal-type', 'Pro-tRNA_synth_II_arc', 3, NULL),
(12082, NULL, 'IPR008486', NULL, 'Protein of unknown function DUF768', 'DUF768', 4, NULL),
(12083, NULL, 'IPR014762', NULL, 'DNA mismatch repair, conserved site', 'DNA_mismatch_repair_CS', 2, NULL),
(12084, NULL, 'IPR009720', NULL, 'IMP biosynthesis enzyme PurP, C-terminal', 'IMP_biosynth_PurP_C', 3, NULL),
(12085, NULL, 'IPR012061', NULL, 'Glutamate synthase, large subunit domain 3 stand-alone protein', 'Glu_synth_lsu_3', 4, NULL),
(12086, NULL, 'IPR008507', NULL, 'Protein of unknown function DUF789', 'DUF789', 4, NULL),
(12087, NULL, 'IPR015255', NULL, 'Vitellinogen, open beta-sheet', 'Vitellinogen_open_b-sht', 3, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(12088, NULL, 'IPR015294', NULL, 'Penicillin-binding protein 4, C-terminal domain', 'Pen-bd_prot4_C_dom', 3, NULL),
(12089, NULL, 'IPR012869', NULL, 'CopG-like ribbon-helix-helix domain', 'RHH_5', 3, NULL),
(12090, NULL, 'IPR012850', NULL, 'Alpha-amylase, C-terminal beta-sheet', 'A-amylase_bs_C', 3, NULL),
(12091, NULL, 'IPR008502', NULL, 'Prolamin-like domain', 'Prolamin-like', 3, NULL),
(12092, NULL, 'IPR024069', NULL, 'AF2212-like domain superfamily', 'AF2212-like_dom_sf', 5, NULL),
(12093, NULL, 'IPR014745', NULL, 'MHC class II, alpha/beta chain, N-terminal', 'MHC_II_a/b_N', 5, NULL),
(12094, NULL, 'IPR012875', NULL, 'Succinate dehydrogenase assembly factor 4', 'SDHF4', 4, NULL),
(12095, NULL, 'IPR008467', NULL, 'Dynein 1 light intermediate chain', 'Dynein1_light_intermed_chain', 4, NULL),
(12096, NULL, 'IPR012677', NULL, 'Nucleotide-binding alpha-beta plait domain superfamily', 'Nucleotide-bd_a/b_plait_sf', 5, NULL),
(12097, NULL, 'IPR024053', NULL, 'von Hippel-Lindau disease tumour suppressor,  beta domain', 'VHL_beta_dom', 3, NULL),
(12098, NULL, 'IPR015251', NULL, 'X-Prolyl dipeptidyl aminopeptidase PepX, N-terminal domain', 'PepX_N_dom', 3, NULL),
(12099, NULL, 'IPR010524', NULL, 'Signal transduction response regulator, propionate catabolism activator, N-terminal', 'Sig_transdc_resp-reg_PrpR_N', 3, NULL),
(12100, NULL, 'IPR008776', NULL, 'Phytoreovirus Pns9Pns10', 'Phyto_Pns9_10', 4, NULL),
(12101, NULL, 'IPR008495', NULL, 'Protein of unknown function DUF777, Borrelia species', 'DUF777_BOR_spp', 4, NULL),
(12102, NULL, 'IPR014545', NULL, 'Uncharacterised conserved protein UCP028415', 'UCP028415', 4, NULL),
(12103, NULL, 'IPR012851', NULL, 'Spore coat protein CotF-like', 'Spore_coat_CotF-like', 4, NULL),
(12104, NULL, 'IPR008476', NULL, 'Protein PBDC1, metazoa/fungi', 'PBDC1_metazoa/fungi', 4, NULL),
(12105, NULL, 'IPR008499', NULL, 'Leg1', 'Leg1', 4, NULL),
(12106, NULL, 'IPR008746', NULL, 'Peptidase C36, beet necrotic yellow vein furovirus-type papain-like endopeptidase', 'Peptidase_C36', 3, NULL),
(12107, NULL, 'IPR008728', NULL, 'Elongator complex protein 4', 'Elongator_complex_protein_4', 4, NULL),
(12108, NULL, 'IPR024064', NULL, 'FdhE-like superfamily', 'FdhE-like_sf', 5, NULL),
(12109, NULL, 'IPR008489', NULL, 'Protein of unknown function DUF771', 'DUF771', 4, NULL),
(12110, NULL, 'IPR008752', NULL, 'Peptidase M11, gametolysin', 'Peptidase_M11', 3, NULL),
(12111, NULL, 'IPR008754', NULL, 'Peptidase M43, pregnancy-associated plasma-A', 'Peptidase_M43', 3, NULL),
(12112, NULL, 'IPR011903', NULL, 'Glutaredoxin-like, bacteria/archaea', 'Glutaredoxin-like_bact/arc', 4, NULL),
(12113, NULL, 'IPR009741', NULL, 'Protein EARLY FLOWERING 4 domain', 'EARLY_FLOWERING_4_dom', 3, NULL),
(12114, NULL, 'IPR013221', NULL, 'Mur ligase, central', 'Mur_ligase_cen', 3, NULL),
(12115, NULL, 'IPR012863', NULL, 'Protein of unknown function DUF1636', 'DUF1636', 4, NULL),
(12116, NULL, 'IPR008786', NULL, 'Poxvirus A31', 'Poxvirus_A31', 4, NULL),
(12117, NULL, 'IPR010897', NULL, 'Sporulation stage II, protein P', 'Spore_II_P', 4, NULL),
(12118, NULL, 'IPR014383', NULL, 'RNA-directed RNA polymerase, phytoreovirus', 'RNA-dir_poll_phytoreovirus', 4, NULL),
(12119, NULL, 'IPR011916', NULL, 'Lipopolysaccharide heptosyltransferase III, putative', 'LipoPS_heptosylTferase-III', 4, NULL),
(12120, NULL, 'IPR015259', NULL, 'Methylene-tetrahydromethanopterin dehydrogenase, N-terminal', 'Methyl-teptahyd_DH_N', 3, NULL),
(12121, NULL, 'IPR008738', NULL, 'Peptidase C27, rubella virus endopeptidase', 'Peptidase_C27', 3, NULL),
(12122, NULL, 'IPR014556', NULL, 'Uncharacterised conserved protein UCP029407', 'UCP029407', 4, NULL),
(12123, NULL, 'IPR008478', NULL, 'Protein of unknown function DUF759, Borrelia species', 'DUF759_BOR_spp', 4, NULL),
(12124, NULL, 'IPR008764', NULL, 'Peptidase U57, YabG', 'Peptidase_U57', 4, NULL),
(12125, NULL, 'IPR010894', NULL, 'Stage V sporulation AD', 'SpoVAD', 4, NULL),
(12126, NULL, 'IPR012996', NULL, 'Zinc finger, CHHC-type', 'Znf_CHHC', 3, NULL),
(12127, NULL, 'IPR024061', NULL, 'NDT80 DNA-binding domain', 'NDT80_DNA-bd_dom', 3, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(12128, NULL, 'IPR008465', NULL, 'Dystroglycan, C-terminal', 'DAG1_C', 3, NULL),
(12129, NULL, 'IPR024087', NULL, 'Creatininase-like superfamily', 'Creatininase-like_sf', 5, NULL),
(12130, NULL, 'IPR009738', NULL, 'BAT2, N-terminal', 'BAT2_N', 3, NULL),
(12131, NULL, 'IPR014743', NULL, 'Chloride channel, core', 'Cl-channel_core', 5, NULL),
(12132, NULL, 'IPR015292', NULL, 'Transcription regulator YbiH, C-terminal', 'Tscrpt_reg_YbiH_C', 3, NULL),
(12133, NULL, 'IPR010900', NULL, 'Nicotine adenine dinucleotide glycohydrolase', 'NA_dinucl_GlycHdrlase', 4, NULL),
(12134, NULL, 'IPR011998', NULL, 'Flavivirus  glycoprotein central and dimerisation domain', 'Glycoprot_cen/dimer', 3, NULL),
(12135, NULL, 'IPR012675', NULL, 'Beta-grasp domain superfamily', 'Beta-grasp_dom_sf', 5, NULL),
(12136, NULL, 'IPR010896', NULL, 'Nuclease-associated modular DNA-binding 1', 'NUMOD1', 3, NULL),
(12137, NULL, 'IPR014740', NULL, 'Channel forming colicin, central receptor recognition', 'Channel_colicin_cen', 3, NULL),
(12138, NULL, 'IPR008787', NULL, 'Poxvirus G7-like', 'Poxvirus_G7', 4, NULL),
(12139, NULL, 'IPR012987', NULL, 'ROK, N-terminal', 'ROK_N', 3, NULL),
(12140, NULL, 'IPR009743', NULL, 'Hs1pro-1, C-terminal', 'Hs1pro-1_C', 3, NULL),
(12141, NULL, 'IPR014374', NULL, 'Protein kinase, T7-type', 'Protein_kinase_T7-type', 4, NULL),
(12142, NULL, 'IPR008749', NULL, 'Peptidase C42, beet yellows virus-type papain-like endopeptidase C42', 'Peptidase_C42', 3, NULL),
(12143, NULL, 'IPR008769', NULL, 'Poly granule associated', 'PhaF_PhaI', 4, NULL),
(12144, NULL, 'IPR011542', NULL, 'SUF system FeS cluster assembly, SufD', 'SUF_FeS_clus_asmbl_SufD', 4, NULL),
(12145, NULL, 'IPR010517', NULL, 'Phage tail tube protein, Siphoviridae', 'L_lac_phage_MSP', 4, NULL),
(12146, NULL, 'IPR014562', NULL, 'Uncharacterised conserved protein UCP030959, divergent TPR repeat-containing', 'UCP030959_TPR_rpt-cont', 4, NULL),
(12147, NULL, 'IPR008503', NULL, 'Putative ATP-dependent zinc protease', 'Put_Zn_protease', 3, NULL),
(12148, NULL, 'IPR008481', NULL, 'Protein of unknown function DUF762, Coxiella burnetii', 'DUF762_COXBU', 4, NULL),
(12149, NULL, 'IPR011899', NULL, 'Glutaredoxin, eukaryotic/virial', 'Glutaredoxin_euk/vir', 3, NULL),
(12150, NULL, 'IPR011902', NULL, 'Glutaredoxin, GrxA', 'GRXA', 4, NULL),
(12151, NULL, 'IPR013228', NULL, 'PE-PPE, C-terminal', 'PE-PPE_C', 3, NULL),
(12152, NULL, 'IPR008723', NULL, 'RNA-dependent RNA polymerase, orbiviral', 'RNA_pol_orbivir', 4, NULL),
(12153, NULL, 'IPR008767', NULL, 'Bacteriophage SPP1, head-tail adaptor', 'Phage_SPP1_head-tail_adaptor', 4, NULL),
(12154, NULL, 'IPR013218', NULL, 'Kinetochore-associated protein Dsn1/Mis13', 'Dsn1/Mis13', 4, NULL),
(12155, NULL, 'IPR024260', NULL, 'Vacuolar segregation subunit 7', 'Vac7', 4, NULL),
(12156, NULL, 'IPR015247', NULL, 'Vitamin D binding protein, domain III', 'VitD-bind_III', 3, NULL),
(12157, NULL, 'IPR023612', NULL, 'Peptidase M4', 'Peptidase_M4', 4, NULL),
(12158, NULL, 'IPR008506', NULL, 'SRP-independent targeting protein 2/TMEM208', 'SND2/TMEM208', 4, NULL),
(12159, NULL, 'IPR009727', NULL, 'NifT/FixU', 'NifT', 4, NULL),
(12160, NULL, 'IPR012873', NULL, 'Protein of unknown function DUF1672', 'DUF1672', 4, NULL),
(12161, NULL, 'IPR010898', NULL, 'Heptaprenyl diphosphate synthase component I', 'Hpre_diP_synth_I', 4, NULL),
(12162, NULL, 'IPR012852', NULL, 'Calcium binding and coiled-coil domain-like', 'CALCOCO1-like', 3, NULL),
(12163, NULL, 'IPR008740', NULL, 'Peptidase C30, coronavirus', 'Peptidase_C30_CoV', 3, NULL),
(12164, NULL, 'IPR008760', NULL, 'Equine arteritis virus peptidase S32', 'EAV_peptidase_S32', 4, NULL),
(12165, NULL, 'IPR011912', NULL, 'ADP-L-glycero-D-manno-heptose-6-epimerase', 'Heptose_epim', 4, NULL),
(12166, NULL, 'IPR012871', NULL, 'Protein of unknown function DUF1677, Oryza sativa', 'DUF1668_ORYSA', 4, NULL),
(12167, NULL, 'IPR015260', NULL, 'Syntaxin 6, N-terminal', 'Syntaxin-6_N', 3, NULL),
(12168, NULL, 'IPR008479', NULL, 'Protein of unknown function DUF760', 'DUF760', 4, NULL),
(12169, NULL, 'IPR015272', NULL, 'Molybdopterin cofactor biosynthesis MoaD-related, C-terminal', 'Mopterin_CF_MoaD-rel_C', 3, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(12170, NULL, 'IPR008765', NULL, 'Bacteriophage T2, Frd3', 'Phage_T2_Frd3', 4, NULL),
(12171, NULL, 'IPR012265', NULL, 'Protein-tyrosine phosphatase, non-receptor type-1/2', 'Ptpn1/Ptpn2', 4, NULL),
(12172, NULL, 'IPR010901', NULL, 'Merozoite surface 1, C-terminal', 'MSP1_C', 3, NULL),
(12173, NULL, 'IPR008772', NULL, 'Bacterial phosphonate metabolism, PhnH', 'Phosphonate_metab_PhnH', 4, NULL),
(12174, NULL, 'IPR015261', NULL, '4-alpha-glucanotransferase, C-terminal', '4-alpha-glucanotransf_C', 3, NULL),
(12175, NULL, 'IPR015771', NULL, 'Anti-muellerian hormone receptor, type II', 'Anti-muellerian_hrmn_rcpt_II', 4, NULL),
(12176, NULL, 'IPR012981', NULL, 'PIH1, N-terminal', 'PIH1_N', 3, NULL),
(12177, NULL, 'IPR035004', NULL, 'Emerin', 'Emerin', 4, NULL),
(12178, NULL, 'IPR008461', NULL, 'Lycopene cyclase', 'CrtY', 4, NULL),
(12179, NULL, 'IPR015249', NULL, 'Biliverdin reductase, catalytic', 'Biliverdin_Rdtase_cat', 3, NULL),
(12180, NULL, 'IPR008743', NULL, 'Arterivirus Nsp2, peptidase C33', 'Arterivirus_Nsp2_C33', 3, NULL),
(12181, NULL, 'IPR013226', NULL, 'Pal1 cell morphology', 'Pal1', 4, NULL),
(12182, NULL, 'IPR015279', NULL, 'Malto-oligosyltrehalose synthase, C-terminal', 'Trehalose_TreY_C', 3, NULL),
(12183, NULL, 'IPR035006', NULL, 'Ankyrin repeat and LEM domain-containing protein 2, LEM domain', 'LEM_ANKL2', 3, NULL),
(12184, NULL, 'IPR014558', NULL, 'Uncharacterised conserved lipoprotein', 'UCP029720', 4, NULL),
(12185, NULL, 'IPR012865', NULL, 'Protein of unknown function DUF1642', 'DUF1642', 4, NULL),
(12186, NULL, 'IPR013661', NULL, 'Peptidase M9, collagenase, N-terminal domain', 'Peptidase_M9_N_dom', 3, NULL),
(12187, NULL, 'IPR008464', NULL, 'Cypovirus polyhedrin, Cypovirus 1 type', 'Cypo_polyhedrin_Cypovirus1', 4, NULL),
(12188, NULL, 'IPR008741', NULL, 'Arterivirus papain-like cysteine protease alpha (PCPalpha) domain', 'AV_PCPalpha', 3, NULL),
(12189, NULL, 'IPR024707', NULL, 'Ferredoxin-thioredoxin reductase catalytic subunit, cyanobacteria-type', 'FTR_bsu_Cyanobacter', 4, NULL),
(12190, NULL, 'IPR009733', NULL, 'Involucrin 2', 'Involucrin2', 3, NULL),
(12191, NULL, 'IPR023896', NULL, 'D-alanyl-lipoteichoic acid biosynthesis DltD, Firmicutes', 'LTA_DltD', 4, NULL),
(12192, NULL, 'IPR008735', NULL, 'Beta-microseminoprotein', 'PSP94', 4, NULL),
(12193, NULL, 'IPR012070', NULL, 'Arogenate dehydrogenase 2', 'Arogenate_DH_2', 4, NULL),
(12194, NULL, 'IPR008733', NULL, 'Peroxisomal biogenesis factor 11', 'PEX11', 4, NULL),
(12195, NULL, 'IPR024261', NULL, 'RNA binding protein She2', 'RNA-bd_She2', 3, NULL),
(12196, NULL, 'IPR015268', NULL, 'Protein of unknown function DUF1948', 'DUF1948', 4, NULL),
(12197, NULL, 'IPR012861', NULL, 'Protein of unknown function DUF1634', 'DUF1634', 4, NULL),
(12198, NULL, 'IPR014771', NULL, 'Apoptosis, Bim N-terminal', 'Apoptosis_Bim_N', 3, NULL),
(12199, NULL, 'IPR013220', NULL, 'E3 ubiquitin-protein ligase substrate receptor Mms22, budding yeast', 'Mms22_budding_yeast', 4, NULL),
(12200, NULL, 'IPR010520', NULL, 'Esterase FrsA-like', 'FrsA-like', 4, NULL),
(12201, NULL, 'IPR008336', NULL, 'DNA topoisomerase I, DNA binding, eukaryotic-type', 'TopoI_DNA-bd_euk', 3, NULL),
(12202, NULL, 'IPR008333', NULL, 'Flavoprotein pyridine nucleotide cytochrome reductase-like, FAD-binding domain', 'Cbr1-like_FAD-bd_dom', 3, NULL),
(12203, NULL, 'IPR015278', NULL, 'Type-2 restriction enzyme BglII', 'BglII', 4, NULL),
(12204, NULL, 'IPR035945', NULL, 'YhaI-like superfamily', 'YhaI-like_sf', 5, NULL),
(12205, NULL, 'IPR009736', NULL, 'Protein of unknown function DUF1307', 'DUF1307', 4, NULL),
(12206, NULL, 'IPR011995', NULL, 'Orotidine 5''-phosphate decarboxylase, type 2', 'OMPdecase_type-2', 4, NULL),
(12207, NULL, 'IPR008729', NULL, 'Phenolic acid decarboxylase', 'PA_de_COase', 4, NULL),
(12208, NULL, 'IPR035010', NULL, 'Dual specificity protein phosphatase PHS1', 'PHS1', 4, NULL),
(12209, NULL, 'IPR011913', NULL, 'RfaE bifunctional protein, domain I', 'RfaE_dom_I', 3, NULL),
(12210, NULL, 'IPR014381', NULL, 'DNA-directed RNA polymerase subunit Rpo5/Rpb5', 'Arch_Rpo5/euc_Rpb5', 4, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(12211, NULL, 'IPR012071', NULL, 'Chemotaxis glutamate methyltransferase', 'Chemotax_glutamate_MeTrfase', 4, NULL),
(12212, NULL, 'IPR011555', NULL, 'V-ATPase proteolipid subunit C, eukaryotic', 'ATPase_proteolipid_su_C_euk', 4, NULL),
(12213, NULL, 'IPR014548', NULL, 'Predicted acyltransferase', 'Ac_Trasf', 4, NULL),
(12214, NULL, 'IPR010518', NULL, 'Flagellar regulatory FleQ', 'FleQ', 3, NULL),
(12215, NULL, 'IPR014540', NULL, 'Uncharacterised conserved protein UCP028175', 'UCP028175', 4, NULL),
(12216, NULL, 'IPR012985', NULL, 'Peptidase S64, Ssy5', 'Peptidase_S64_Ssy5', 4, NULL),
(12217, NULL, 'IPR012988', NULL, 'Ribosomal protein L30, N-terminal', 'Ribosomal_L30_N', 3, NULL),
(12218, NULL, 'IPR011564', NULL, 'Telomeric single stranded DNA binding POT1/Cdc13', 'Telomer_end-bd_POT1/Cdc13', 3, NULL),
(12219, NULL, 'IPR014379', NULL, '6-phosphofructo-2-kinase Pfk27', 'Pfk27', 4, NULL),
(12220, NULL, 'IPR010899', NULL, 'Protein of unknown function UPF0344', 'UPF0344', 4, NULL),
(12221, NULL, 'IPR012854', NULL, 'Copper amine oxidase-like, N-terminal', 'Cu_amine_oxidase-like_N', 3, NULL),
(12222, NULL, 'IPR008748', NULL, 'Hepatitis E virus, cysteine peptidase', 'Hepatitis-E_Cys-pept', 4, NULL),
(12223, NULL, 'IPR014550', NULL, 'Uncharacterised conserved protein UCP028704, OpgC', 'UCP028704_OpgC', 4, NULL),
(12224, NULL, 'IPR015285', NULL, 'RIO2 kinase winged helix domain, N-terminal', 'RIO2_wHTH_N', 3, NULL),
(12225, NULL, 'IPR009742', NULL, 'Curlin associated', 'Curlin_rpt', 7, NULL),
(12226, NULL, 'IPR008469', NULL, 'DREPP family', 'DREPP', 4, NULL),
(12227, NULL, 'IPR012849', NULL, 'Abl-interactor, homeo-domain homologous domain', 'Abl-interactor_HHR_dom', 3, NULL),
(12228, NULL, 'IPR011900', NULL, 'Glutaredoxin, GrxC', 'GRX_bact', 4, NULL),
(12229, NULL, 'IPR008739', NULL, 'Peptidase C28, foot-and-mouth virus L-proteinase', 'Peptidase_C28', 3, NULL),
(12230, NULL, 'IPR012983', NULL, 'PHR', 'PHR', 3, NULL),
(12231, NULL, 'IPR008757', NULL, 'Peptidase M6-like, domain', 'Peptidase_M6-like_domain', 3, NULL),
(12232, NULL, 'IPR009745', NULL, 'Cysteine-rich, acidic integral membrane', 'CRAM_rpt', 7, NULL),
(12233, NULL, 'IPR024140', NULL, 'Phorbol-12-myristate-13-acetate-induced protein 1', 'Noxa', 4, NULL),
(12234, NULL, 'IPR008780', NULL, 'Plasmodium vivax Vir', 'Plasmodium_Vir', 4, NULL),
(12235, NULL, 'IPR014744', NULL, 'Nuclear receptor coactivator, CREB-bp-like, interlocking', 'Nuc_rcpt_coact_CREBbp', 3, NULL),
(12236, NULL, 'IPR014773', NULL, 'Virulence factor YopE, GAP domain', 'YopE_GAP_dom', 3, NULL),
(12237, NULL, 'IPR024090', NULL, 'Proline dehydrogenase PutA, domain I', 'PRODH_PutA_dom_I', 5, NULL),
(12238, NULL, 'IPR024104', NULL, 'Pseudokinase tribbles family/serine-threonine-protein kinase 40', 'Tribbles/Ser_Thr_kinase_40', 4, NULL),
(12239, NULL, 'IPR014371', NULL, 'Sterol O-acyltransferase, ACAT/DAG/ARE types', 'Oat_ACAT_DAG_ARE', 4, NULL),
(12240, NULL, 'IPR008753', NULL, 'Peptidase M13, N-terminal domain', 'Peptidase_M13_N', 3, NULL),
(12241, NULL, 'IPR012328', NULL, 'Chalcone/stilbene synthase, C-terminal', 'Chalcone/stilbene_synt_C', 3, NULL),
(12242, NULL, 'IPR014735', NULL, 'Transposase, Tn5-like, N-terminal', 'Transposase_Tn5-like_N', 3, NULL),
(12243, NULL, 'IPR012267', NULL, 'Peptidase S1A, acrosin', 'Pept_S1A_acrosin', 4, NULL),
(12244, NULL, 'IPR012872', NULL, 'Protein of unknown function DUF1670', 'DUF1670', 4, NULL),
(12245, NULL, 'IPR010522', NULL, 'Replication protein C, bacterial', 'RepC_bac', 4, NULL),
(12246, NULL, 'IPR024107', NULL, 'Tyrosine-tRNA ligase, bacterial-type, type 1', 'Tyr-tRNA-ligase_bac_1', 4, NULL),
(12247, NULL, 'IPR015246', NULL, 'Formate dehydrogenase, transmembrane', 'Formate_DH_TM', 3, NULL),
(12248, NULL, 'IPR013057', NULL, 'Amino acid transporter, transmembrane domain', 'AA_transpt_TM', 3, NULL),
(12249, NULL, 'IPR008778', NULL, 'Pirin, C-terminal domain', 'Pirin_C_dom', 3, NULL),
(12250, NULL, 'IPR008490', NULL, 'Transposase InsH, N-terminal', 'Transposase_InsH_N', 3, NULL),
(12251, NULL, 'IPR008727', NULL, 'PAAR motif', 'PAAR_motif', 7, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(12252, NULL, 'IPR008509', NULL, 'Molybdate-anion transporter', 'MOT2/MFSD5', 4, NULL),
(12253, NULL, 'IPR013664', NULL, 'Viral methyltransferase, C-terminal domain', 'Virgavirus_MeTrfase_C', 3, NULL),
(12254, NULL, 'IPR012075', NULL, 'Glutamate synthase, large subunit domains 1/3 fusion', 'Glu_synth_lsu_1/3', 4, NULL),
(12255, NULL, 'IPR008773', NULL, 'Phosphonate metabolism protein PhnI', 'PhnI', 4, NULL),
(12256, NULL, 'IPR008770', NULL, 'DNA terminal protein Gp3', 'DNA_terminal_Gp3', 4, NULL),
(12257, NULL, 'IPR011901', NULL, 'Glutaredoxin-2', 'Grx2', 4, NULL),
(12258, NULL, 'IPR008462', NULL, 'CsbD-like domain', 'CsbD', 3, NULL),
(12259, NULL, 'IPR008492', NULL, 'Rv2714-like', 'Rv2714-like', 4, NULL),
(12260, NULL, 'IPR008487', NULL, 'Protein of unknown function DUF769', 'DUF769', 4, NULL),
(12261, NULL, 'IPR012986', NULL, 'Photosystem I PsaX', 'PSI_PsaX', 4, NULL),
(12262, NULL, 'IPR013059', NULL, 'Tryptophan/tyrosine transporter', 'Trp_tyr_transpt', 4, NULL),
(12263, NULL, 'IPR013231', NULL, 'Periviscerokinin', 'Periviscerokinin', 4, NULL),
(12264, NULL, 'IPR013215', NULL, 'Cobalamin-independent methionine synthase MetE, N-terminal', 'Cbl-indep_Met_Synth_N', 3, NULL),
(12265, NULL, 'IPR008766', NULL, 'Replication gene A protein', 'Replication_gene_A', 4, NULL),
(12266, NULL, 'IPR024080', NULL, 'Neurolysin/Thimet oligopeptidase, N-terminal', 'Neurolysin/TOP_N', 5, NULL),
(12267, NULL, 'IPR008458', NULL, 'Accessory protein 5b, avian coronavirus', 'Acc_prot_5b_avian_CoV', 4, NULL),
(12268, NULL, 'IPR012990', NULL, 'Sec23/Sec24 beta-sandwich', 'Sec23_24_beta_S', 3, NULL),
(12269, NULL, 'IPR012066', NULL, 'Uroporphyrin-III C-methyltransferase, fungi', 'Met1_fungi', 4, NULL),
(12270, NULL, 'IPR008470', NULL, 'Uncharacterised protein family Ycf33', 'Uncharacterised_Ycf33', 4, NULL),
(12271, NULL, 'IPR023897', NULL, 'Spore photoproduct lyase', 'Spore_PP_lysase', 4, NULL),
(12272, NULL, 'IPR015240', NULL, 'tRNA pseudouridine synthase II, TruB, subfamily 1, C-terminal', 'tRNA_sdUridine_synth_fam1_C', 3, NULL),
(12273, NULL, 'IPR015273', NULL, 'Cysteinyl-tRNA synthetase, class Ia, DALR', 'Cys-tRNA-synt_Ia_DALR', 3, NULL),
(12274, NULL, 'IPR009724', NULL, 'TMEM70 family', 'TMEM70', 4, NULL),
(12275, NULL, 'IPR009721', NULL, 'O-acyltransferase WSD1, C-terminal', 'O-acyltransferase_WSD1_C', 3, NULL),
(12276, NULL, 'IPR008468', NULL, 'DNA methyltransferase 1-associated 1', 'DMAP1', 3, NULL),
(12277, NULL, 'IPR008734', NULL, 'Phosphorylase kinase alpha/beta subunit', 'PHK_A/B_su', 4, NULL),
(12278, NULL, 'IPR012989', NULL, 'SEP domain', 'SEP_domain', 3, NULL),
(12279, NULL, 'IPR015243', NULL, 'FimH, mannose-binding domain', 'FimH_man-bd', 3, NULL),
(12280, NULL, 'IPR008725', NULL, 'Orthopoxvirus F7', 'Orthopox_F7', 4, NULL),
(12281, NULL, 'IPR013216', NULL, 'Methyltransferase type 11', 'Methyltransf_11', 3, NULL),
(12282, NULL, 'IPR009761', NULL, 'Cytoplasmic repetitive antigen-like', 'CRA_rpt', 7, NULL),
(12283, NULL, 'IPR008779', NULL, 'Plasmodium histidine-rich', 'Plasmodium_HRP', 4, NULL),
(12284, NULL, 'IPR015293', NULL, '1,4-alpha-glucan branching enzyme, C-terminal', 'BE_C', 3, NULL),
(12285, NULL, 'IPR008758', NULL, 'Peptidase S28', 'Peptidase_S28', 4, NULL),
(12286, NULL, 'IPR011910', NULL, 'ADP-heptose--LPS heptosyltransferase 2', 'RfaF', 4, NULL),
(12287, NULL, 'IPR009711', NULL, 'Uncharacterised protein family UPF0473', 'UPF0473', 4, NULL),
(12288, NULL, 'IPR014758', NULL, 'Methionyl-tRNA synthetase', 'Met-tRNA_synth', 4, NULL),
(12289, NULL, 'IPR008496', NULL, 'TMEM222/RTE1', 'TMEM222/RTE1', 4, NULL),
(12290, NULL, 'IPR011914', NULL, 'RfaE bifunctional protein, domain II', 'RfaE_dom_II', 3, NULL),
(12291, NULL, 'IPR024056', NULL, 'Apical membrane antigen 1 domain superfamily', 'Apmem_Ag1_dom_sf', 5, NULL),
(12292, NULL, 'IPR014760', NULL, 'Serum albumin, N-terminal', 'Serum_albumin_N', 3, NULL),
(12293, NULL, 'IPR010519', NULL, 'Female-specific protein transformer', 'Tra', 4, NULL),
(12294, NULL, 'IPR012874', NULL, 'Protein of unknown function DUF1673, Methanosarcina species', 'DUF1673_METspp', 4, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(12295, NULL, 'IPR008480', NULL, 'Protein of unknown function DUF761, plant', 'DUF761_pln', 4, NULL),
(12296, NULL, 'IPR012862', NULL, 'Protein of unknown function DUF1635', 'DUF1635', 4, NULL),
(12297, NULL, 'IPR012867', NULL, 'Domain of unknown function DUF1648', 'DUF1648', 3, NULL),
(12298, NULL, 'IPR008485', NULL, 'JNK1/MAPK8-associated membrane protein', 'JAMP', 4, NULL),
(12299, NULL, 'IPR034511', NULL, 'SRSF6, RNA recognition motif  1', 'SRSF6_RRM1', 3, NULL),
(12300, NULL, 'IPR014547', NULL, 'Uncharacterised conserved protein UCP028477', 'UCP028477', 4, NULL),
(12301, NULL, 'IPR008471', NULL, 'MnmC-like methyltransferase', 'MnmC-like_methylTransf', 3, NULL),
(12302, NULL, 'IPR008335', NULL, 'Eukaryotic molybdopterin oxidoreductase', 'Mopterin_OxRdtase_euk', 4, NULL),
(12303, NULL, 'IPR014537', NULL, 'Uncharacterised conserved protein UCP027893', 'UCP027893', 4, NULL),
(12304, NULL, 'IPR023624', NULL, 'Antenna complex, beta domain superfamily', 'Antenna_beta_dom_sf', 5, NULL),
(12305, NULL, 'IPR013230', NULL, 'Peptidase M15A, C-terminal', 'Peptidase_M15A_C', 3, NULL),
(12306, NULL, 'IPR009042', NULL, 'RNA polymerase sigma-70 region 1.2', 'RNA_pol_sigma70_r1_2', 3, NULL),
(12307, NULL, 'IPR008456', NULL, 'Collagen binding domain', 'Collagen-bd_dom', 3, NULL),
(12308, NULL, 'IPR009757', NULL, 'Circovirus 2, anti-apoptotic ORF4', 'Circovirus2_Orf4', 4, NULL),
(12309, NULL, 'IPR008763', NULL, 'Peptidase S55, SpoIVB', 'Peptidase_S55', 3, NULL),
(12310, NULL, 'IPR009753', NULL, 'Protein of unknown function DUF1322', 'DUF1322', 4, NULL),
(12311, NULL, 'IPR008732', NULL, 'Protein Pet122', 'Pet122', 4, NULL),
(12312, NULL, 'IPR024084', NULL, 'Isopropylmalate dehydrogenase-like domain', 'IsoPropMal-DH-like_dom', 3, NULL),
(12313, NULL, 'IPR034472', NULL, 'RBM15, RNA recognition motif 2', 'RBM15_RRM2', 3, NULL),
(12314, NULL, 'IPR010514', NULL, 'COX aromatic rich motif', 'COX_ARM', 3, NULL),
(12315, NULL, 'IPR023228', NULL, 'S-adenosyl-l-methionine hydroxide adenosyltransferase, N-terminal domain superfamily', 'SAM_OH_AdoTrfase_N_sf', 5, NULL),
(12316, NULL, 'IPR012678', NULL, 'Ribosomal protein L23/L15e core domain superfamily', 'Ribosomal_L23/L15e_core_dom_sf', 5, NULL),
(12317, NULL, 'IPR014544', NULL, 'Uncharacterised conserved protein UCP028408', 'UCP028408', 4, NULL),
(12318, NULL, 'IPR008474', NULL, 'Protein of unknown function DUF755', 'DUF755', 4, NULL),
(12319, NULL, 'IPR010523', NULL, 'Activator of aromatic catabolism', 'XylR_N', 3, NULL),
(12320, NULL, 'IPR014368', NULL, 'Cytochrome c oxidase, subunit VIIa, fungal', 'Cyt_c_oxidase_su7a_fun', 4, NULL),
(12321, NULL, 'IPR023623', NULL, 'Antenna complex, beta subunit, conserved site', 'Antenna_beta_CS', 2, NULL),
(12322, NULL, 'IPR015282', NULL, 'Staphylococcal superantigen-like OB-fold domain', 'SSL_OB', 3, NULL),
(12323, NULL, 'IPR008730', NULL, 'Pheromone biosynthesis activating neuropeptide', 'PBAN', 4, NULL),
(12324, NULL, 'IPR014375', NULL, 'Protein kinase C, alpha/beta/gamma types', 'Protein_kinase_C_a/b/g', 4, NULL),
(12325, NULL, 'IPR013662', NULL, 'RyR/IP3R Homology associated domain', 'RIH_assoc-dom', 3, NULL),
(12326, NULL, 'IPR008781', NULL, 'Pneumovirinae attachment membrane glycoprotein G', 'Pneumo_att_G', 4, NULL),
(12327, NULL, 'IPR014535', NULL, 'Predicted heptaprenyl diphosphate synthase, component I', 'Hpre_diP_synt_I', 4, NULL),
(12328, NULL, 'IPR013234', NULL, 'PIGA, GPI anchor biosynthesis', 'PIGA_GPI_anchor_biosynthesis', 3, NULL),
(12329, NULL, 'IPR012062', NULL, 'D-tagatose-1,6-bisphosphate aldolase subunit  GatZ/KbaZ-like', 'GatZ/KbaZ-like', 4, NULL),
(12330, NULL, 'IPR011909', NULL, 'Glutaredoxin-like protein NrdH', 'GlrX_NrdH', 4, NULL),
(12331, NULL, 'IPR015258', NULL, 'Vitellinogen, beta-sheet shell', 'Vitellinogen_b-sht_shell', 3, NULL),
(12332, NULL, 'IPR015280', NULL, 'Rap1, DNA-binding domain', 'Rap1_DNA-bd', 3, NULL),
(12333, NULL, 'IPR015250', NULL, 'MPT63-like', 'MPT63-like', 3, NULL),
(12334, NULL, 'IPR012270', NULL, 'CCR4-NOT complex, subunit 3/ 5', 'CCR4-NOT_su3/5', 4, NULL),
(12335, NULL, 'IPR024060', NULL, 'Ureidoglycolate lyase domain superfamily', 'Ureidoglycolate_lyase_dom_sf', 5, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(12336, NULL, 'IPR014385', NULL, 'RNA-directed RNA polymerase, phlebovirus', 'RNA-dir_pol_phlebovirus', 4, NULL),
(12337, NULL, 'IPR008482', NULL, 'Protein of unknown function DUF763', 'DUF763', 4, NULL),
(12338, NULL, 'IPR008719', NULL, 'Nitrous oxide reductase accessory protein NosL', 'N2O_reductase_NosL', 4, NULL),
(12339, NULL, 'IPR010527', NULL, 'Photosystem II PsbU, oxygen evolving complex', 'PSII_PsbU', 4, NULL),
(12340, NULL, 'IPR014384', NULL, 'RNA-directed RNA polymerase, orthobunyavirus', 'RNA-dir_pol_orthobunyavirus', 4, NULL),
(12341, NULL, 'IPR009725', NULL, 'Predicted 3-demethylubiquinone-9 3-methyltransferase', '3_dmu_93_MTrfase', 4, NULL),
(12342, NULL, 'IPR011614', NULL, 'Catalase core domain', 'Catalase_core', 3, NULL),
(12343, NULL, 'IPR024055', NULL, 'Translation initiation factor 2, alpha subunit, C-terminal', 'TIF2_asu_C', 5, NULL),
(12344, NULL, 'IPR015269', NULL, 'Uncharacterised domain UPF0029, Impact, C-terminal', 'UPF0029_Impact_C', 3, NULL),
(12345, NULL, 'IPR012856', NULL, 'D-aminopeptidase, domain B', 'DAP_B_dom', 3, NULL),
(12346, NULL, 'IPR015283', NULL, 'Monellin', 'Monellin', 4, NULL),
(12347, NULL, 'IPR012266', NULL, 'Protein-tyrosine phosphatase, non-receptor type-12', 'Ptpn_12', 4, NULL),
(12348, NULL, 'IPR014549', NULL, 'Flagellar protein FlgO', 'FlgO', 4, NULL),
(12349, NULL, 'IPR009716', NULL, 'Ferroportin-1', 'Ferroportin-1', 4, NULL),
(12350, NULL, 'IPR013659', NULL, 'Adenosine/AMP deaminase N-terminal', 'A_deaminase_N', 3, NULL),
(12351, NULL, 'IPR009758', NULL, 'Protein of unknown function DUF1326', 'DUF1326', 4, NULL),
(12352, NULL, 'IPR014553', NULL, 'Predicted aminopeptidase', 'Aminopept', 4, NULL),
(12353, NULL, 'IPR015238', NULL, 'Protein of unknown function DUF1940', 'DUF1940', 4, NULL),
(12354, NULL, 'IPR009731', NULL, 'Replication P', 'Phage_lambda_P', 4, NULL),
(12355, NULL, 'IPR014382', NULL, 'DNA-directed DNA polymerase, family B, adenovirus', 'DNA-dir_DNA_pol_B_adenovir', 4, NULL),
(12356, NULL, 'IPR008332', NULL, 'Methylguanine DNA methyltransferase, ribonuclease-like domain', 'MethylG_MeTrfase_N', 3, NULL),
(12357, NULL, 'IPR015254', NULL, 'N-glycosylase/DNA lyase-like', 'AGOG-like', 4, NULL),
(12358, NULL, 'IPR015275', NULL, 'Actin-fragmin kinase, catalytic domain', 'Actin-fragmin_kin_cat_dom', 3, NULL),
(12359, NULL, 'IPR024057', NULL, 'Nucleoplasmin core domain', 'Nucleoplasmin_core_dom', 3, NULL),
(12360, NULL, 'IPR010525', NULL, 'Auxin response factor domain', 'ARF_dom', 3, NULL),
(12361, NULL, 'IPR011895', NULL, 'Pyruvate-flavodoxin oxidoreductase', 'Pyrv_flavodox_OxRed', 4, NULL),
(12362, NULL, 'IPR009719', NULL, 'GBF-interacting protein 1, N-terminal', 'GIP1_N', 3, NULL),
(12363, NULL, 'IPR015284', NULL, 'Signal recognition particle (SRP) receptor alpha subunit, N-terminal', 'SRX_dom', 3, NULL),
(12364, NULL, 'IPR018020', NULL, 'Oxo-4-hydroxy-4-carboxy-5-ureidoimidazoline decarboxylase', 'OHCU_decarboxylase', 3, NULL),
(12365, NULL, 'IPR008771', NULL, 'Phi-29-like late genes activator', 'Phi-29_GP4', 4, NULL),
(12366, NULL, 'IPR015291', NULL, 'Restriction endonuclease, type II, MspI', 'Restrct_endonuc_II_MspI', 4, NULL),
(12367, NULL, 'IPR011527', NULL, 'ABC transporter type 1, transmembrane domain', 'ABC1_TM_dom', 3, NULL),
(12368, NULL, 'IPR009760', NULL, 'Protein of unknown function DUF1328', 'DUF1328', 4, NULL),
(12369, NULL, 'IPR009744', NULL, 'VirC1', 'VirC1', 4, NULL),
(12370, NULL, 'IPR024074', NULL, 'Argininosuccinate synthetase, catalytic/multimerisation domain body', 'AS_cat/multimer_dom_body', 5, NULL),
(12371, NULL, 'IPR012073', NULL, 'LytTR MHYT transcriptional regulator', 'LytTR_MHYT', 4, NULL),
(12372, NULL, 'IPR013217', NULL, 'Methyltransferase type 12', 'Methyltransf_12', 3, NULL),
(12373, NULL, 'IPR017993', NULL, 'Atrophin-1', 'Atrophin-1', 4, NULL),
(12374, NULL, 'IPR011915', NULL, 'Glutaredoxin-like protein, actinobacteria', 'GlrX_actino', 4, NULL),
(12375, NULL, 'IPR012993', NULL, 'UME domain', 'UME', 3, NULL),
(12376, NULL, 'IPR012866', NULL, 'Protein of unknown function DUF1644', 'DUF1644', 4, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(12377, NULL, 'IPR008777', NULL, 'Phytoreovirus Pns1011', 'Phytoreo_Pns', 4, NULL),
(12378, NULL, 'IPR009723', NULL, 'Pop1, N-terminal', 'Pop1_N', 3, NULL),
(12379, NULL, 'IPR013233', NULL, 'Glycosylphosphatidylinositol-mannosyltransferase I, PIG-X/PBN1', 'PIG-X/PBN1', 4, NULL),
(12380, NULL, 'IPR009748', NULL, 'Orthopoxvirus C10L', 'Orthopox_C10L', 4, NULL),
(12381, NULL, 'IPR012980', NULL, 'Uncharacterised domain NUC202', 'Uncharacterised_NUC202', 3, NULL),
(12382, NULL, 'IPR024071', NULL, 'Protein of unknown function DUF917, C-terminal', 'DUF917_C', 5, NULL),
(12383, NULL, 'IPR014560', NULL, 'Uncharacterised conserved protein UCP030333, DNA/RNA-binding Alba-related', 'UCP030333_Alba', 4, NULL),
(12384, NULL, 'IPR008768', NULL, 'Capsid assembly scaffolding protein-like', 'Gp9-like', 4, NULL),
(12385, NULL, 'IPR009751', NULL, 'CryBP1', 'CryBP1', 4, NULL),
(12386, NULL, 'IPR014528', NULL, 'Cyclic-di-AMP phosphodiesterase GdpP/PdeA', 'GdpP/PdeA', 4, NULL),
(12387, NULL, 'IPR010903', NULL, 'Protein of unknown function DUF1517', 'DUF1517', 4, NULL),
(12388, NULL, 'IPR024054', NULL, 'Translation initiation factor 2, alpha subunit, middle domain superfamily', 'TIF2_asu_middle_sf', 5, NULL),
(12389, NULL, 'IPR023676', NULL, 'Ribosomal protein S14, type Z, archaeal', 'Ribosomal_S14_type-Z_arc', 4, NULL),
(12390, NULL, 'IPR009750', NULL, 'Protein of unknown function DUF1317', 'DUF1317', 4, NULL),
(12391, NULL, 'IPR015245', NULL, 'Nuclear RNA export factor Tap, RNA-binding domain', 'Tap_RNA-bd', 3, NULL),
(12392, NULL, 'IPR009722', NULL, 'SdiA-regulated', 'SdiA-regulated', 4, NULL),
(12393, NULL, 'IPR014853', NULL, 'Uncharacterised domain, cysteine-rich', 'Unchr_dom_Cys-rich', 3, NULL),
(12394, NULL, 'IPR014541', NULL, 'Predicted amidinotransferase, FN0238 type', 'Amdntrnsf_FN0238', 4, NULL),
(12395, NULL, 'IPR008334', NULL, '5''-Nucleotidase, C-terminal', '5''-Nucleotdase_C', 3, NULL),
(12396, NULL, 'IPR008494', NULL, 'Protein of unknown function DUF776', 'DUF776', 4, NULL),
(12397, NULL, 'IPR012074', NULL, 'GAF-ANTAR transcription anti-termination regulator, putative', 'GAF_ANTAR', 4, NULL),
(12398, NULL, 'IPR015276', NULL, 'Cholecystokinin A receptor, N-terminal', 'CholecystokininA_recpt_N', 3, NULL),
(12399, NULL, 'IPR012984', NULL, 'PROCT domain', 'PROCT', 3, NULL),
(12400, NULL, 'IPR014367', NULL, 'Cytochrome c oxidase subunit VII, budding yeast', 'Cox7_yeast', 4, NULL),
(12401, NULL, 'IPR008785', NULL, 'Poxvirus A14, virion envelope', 'Poxvirus_A14', 4, NULL),
(12402, NULL, 'IPR009714', NULL, 'Resistin-like molecule  hormone family', 'RELM', 4, NULL),
(12403, NULL, 'IPR011541', NULL, 'Nickel/cobalt transporter, high-affinity', 'Ni/Co_transpt_high_affinity', 4, NULL),
(12404, NULL, 'IPR024259', NULL, 'Alkylmercury lyase, helix-turn-helix domain', 'MerB_HTH_dom', 3, NULL),
(12405, NULL, 'IPR012860', NULL, 'Arf3-interacting protein 1, N-terminal domain', 'Afi1_N', 3, NULL),
(12406, NULL, 'IPR015289', NULL, 'Alpha-L-arabinofuranosidase B, catalytic', 'A-L-arabinofuranosidase_B_cat', 3, NULL),
(12407, NULL, 'IPR009717', NULL, 'Mo-dependent nitrogenase, C-terminal', 'Mo-dep_Nase_C', 3, NULL),
(12408, NULL, 'IPR024077', NULL, 'Neurolysin/Thimet oligopeptidase, domain 2', 'Neurolysin/TOP_dom2', 5, NULL),
(12409, NULL, 'IPR015262', NULL, 'tRNA(Ile)-lysidine synthase , substrate-binding domain', 'tRNA_Ile_lys_synt_subst-bd', 3, NULL),
(12410, NULL, 'IPR015270', NULL, 'Protein RDM1, plant', 'RDM1_plant', 4, NULL),
(12411, NULL, 'IPR009715', NULL, 'Regulator of RNA terminal phosphate cyclase', 'RtcR', 3, NULL),
(12412, NULL, 'IPR011908', NULL, 'Lipopolysaccharide heptosyltransferase I', 'LipoPS_heptosylTferase-I', 4, NULL),
(12413, NULL, 'IPR009044', NULL, 'ssDNA-binding transcriptional regulator', 'ssDNA-bd_transcriptional_reg', 5, NULL),
(12414, NULL, 'IPR024278', NULL, 'DUF3823, N-terminal', 'DUF3823_N', 3, NULL),
(12415, NULL, 'IPR011897', NULL, 'Translation elongation factor P-like, YeiP', 'Transl_elong_p-like_YeiP', 4, NULL),
(12416, NULL, 'IPR008484', NULL, 'Circovirus Orf6', 'Circovirus_Orf6', 4, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(12417, NULL, 'IPR015252', NULL, 'Breast cancer type 2 susceptibility protein, helical domain', 'BRCA2_hlx', 3, NULL),
(12418, NULL, 'IPR009734', NULL, 'Myoviridae, GpU', 'Myoviridae_GpU', 4, NULL),
(12419, NULL, 'IPR014387', NULL, 'CDP-diacylglycerol-inositol 3-phosphatidyltransferase, eukaryote', 'CDP_diag_ino_3_P_euk', 4, NULL),
(12420, NULL, 'IPR013229', NULL, 'PEGA', 'PEGA', 3, NULL),
(12421, NULL, 'IPR013232', NULL, 'Bacteriophage T7, Gp1.1', 'Phage_T7_Gp1.1', 4, NULL),
(12422, NULL, 'IPR012848', NULL, 'Aspartic peptidase, N-terminal', 'Aspartic_peptidase_N', 3, NULL),
(12423, NULL, 'IPR015248', NULL, 'Ubiquinol-cytochrome c reductase 8kDa, N-terminal', 'Ubiqinol_cyt_c_Rdtase_N', 3, NULL),
(12424, NULL, 'IPR010521', NULL, 'Fijivirus, VP7-1-like', 'Fijivirus_VP7-1-like', 4, NULL),
(12425, NULL, 'IPR008473', NULL, 'Putative 3TM holin, Phage holin 3', 'Phage_holin_3_7', 4, NULL),
(12426, NULL, 'IPR009712', NULL, 'Vibrio phage Vf33, Vpf117', 'Vibrio_phage_Vf33_Vpf117', 4, NULL),
(12427, NULL, 'IPR014551', NULL, 'Beta-glucosidase GBA2-type', 'B_Glucosidase_GBA2-typ', 4, NULL),
(12428, NULL, 'IPR015290', NULL, 'Yeast killer toxin', 'Yeast-kill-tox', 4, NULL),
(12429, NULL, 'IPR008721', NULL, 'Origin recognition complex, subunit 6', 'ORC6', 4, NULL),
(12430, NULL, 'IPR015266', NULL, 'Domain of unknown function DUF1947', 'DUF1947', 3, NULL),
(12431, NULL, 'IPR008255', NULL, 'Pyridine nucleotide-disulphide oxidoreductase, class-II, active site', 'Pyr_nucl-diS_OxRdtase_2_AS', 0, NULL),
(12432, NULL, 'IPR015296', NULL, 'Chemokine-binding M3, viral', 'Chemokine-bd_M3_vir', 4, NULL),
(12433, NULL, 'IPR012992', NULL, 'Tetracycline resistance leader peptide, TetM', 'Tet-R_leader_TetM', 4, NULL),
(12434, NULL, 'IPR008500', NULL, 'Circovirus Orf3', 'Circovirus_Orf3', 4, NULL),
(12435, NULL, 'IPR008504', NULL, 'ER membrane protein complex subunit 6', 'Emc6', 4, NULL),
(12436, NULL, 'IPR015274', NULL, 'CD4, extracellular', 'CD4-extracel', 3, NULL),
(12437, NULL, 'IPR012069', NULL, 'Uncharacterised protein family, CYTH/CHAD/HD-like domain-containing', 'UPF_CYTH/CHAD/HD-like', 4, NULL),
(12438, NULL, 'IPR009754', NULL, 'Orthopoxvirus B11R', 'Orthopox_B11R', 4, NULL),
(12439, NULL, 'IPR008505', NULL, 'Protein of unknown function DUF787', 'DUF787', 4, NULL),
(12440, NULL, 'IPR015237', NULL, 'Alpha-amylase C-terminal, prokaryotic', 'Alpha-amylase_C_pro', 3, NULL),
(12441, NULL, 'IPR010515', NULL, 'Collagenase NC10/endostatin', 'Collagenase_NC10/endostatin', 3, NULL),
(12442, NULL, 'IPR014555', NULL, 'RecF-like', 'RecF-like', 4, NULL),
(12443, NULL, 'IPR011905', NULL, 'Glutaredoxin-like, plant II', 'GlrX-like_pln_2', 4, NULL),
(12444, NULL, 'IPR008756', NULL, 'Peptidase M56', 'Peptidase_M56', 3, NULL),
(12445, NULL, 'IPR012982', NULL, 'PADR1 domain', 'PADR1', 3, NULL),
(12446, NULL, 'IPR013660', NULL, 'DNA polymerase B exonuclease, N-terminal', 'DNApol_B_exo_N', 3, NULL),
(12447, NULL, 'IPR014543', NULL, 'Uncharacterised conserved protein UCP028291', 'UCP028291', 4, NULL),
(12448, NULL, 'IPR015253', NULL, 'Stn1, C-terminal', 'CST_STN1_C', 3, NULL),
(12449, NULL, 'IPR024743', NULL, 'Dynein heavy chain, coiled coil stalk', 'Dynein_HC_stalk', 3, NULL),
(12450, NULL, 'IPR010902', NULL, 'NUMOD4', 'NUMOD4', 3, NULL),
(12451, NULL, 'IPR012995', NULL, 'CIII regulator', 'CIII_regul', 4, NULL),
(12452, NULL, 'IPR011906', NULL, 'Glutaredoxin domain', 'Glutaredoxin_dom', 3, NULL),
(12453, NULL, 'IPR008498', NULL, 'Protein of unknown function DUF780, Caenorhabditis species', 'DUF780_CAE_spp', 4, NULL),
(12454, NULL, 'IPR034473', NULL, 'RBM15, RNA recognition motif 3', 'RBM15_RRM3', 3, NULL),
(12455, NULL, 'IPR014557', NULL, 'Uncharacterised conserved protein UCP029548, STAS-type', 'UCP029548_STAS-type', 4, NULL),
(12456, NULL, 'IPR008720', NULL, 'Viral hemorrhagic septicemia virus non-virion', 'Novirhabdo_Nv', 4, NULL),
(12457, NULL, 'IPR013663', NULL, 'Helicase, SWF/SNF/SWI type, bacterial', 'Helicase_SWF/SNF/SWI_bac', 3, NULL),
(12458, NULL, 'IPR024052', NULL, 'Phosphopentomutase DeoB cap domain superfamily', 'Phosphopentomutase_DeoB_cap_sf', 5, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(12459, NULL, 'IPR008477', NULL, 'Tumor necrosis factor alpha-induced protein 8-like', 'TNFAIP8-like', 4, NULL),
(12460, NULL, 'IPR010895', NULL, 'CHRD', 'CHRD', 3, NULL),
(12461, NULL, 'IPR009732', NULL, 'Protein of unknown function DUF1304', 'DUF1304', 4, NULL),
(12462, NULL, 'IPR014546', NULL, 'Uncharacterised conserved protein, lipid A biosynthesis', 'UCP028440_lipidA_biosyn', 4, NULL),
(12463, NULL, 'IPR008724', NULL, 'Orthopoxvirus, Protein C1', 'Orthopox_C1', 4, NULL),
(12464, NULL, 'IPR015277', NULL, 'Restriction endonuclease, type II, AvaI/BsoBI', 'Restrct_endonuc_II_AvaI/BsoBI', 4, NULL),
(12465, NULL, 'IPR013223', NULL, 'Ribonuclease B, N-terminal OB domain', 'RNase_B_OB_dom', 3, NULL),
(12466, NULL, 'IPR034633', NULL, 'Ribonucleoprotein PTB-binding 1, RNA recognition motif 1', 'RAVER1_RRM1', 3, NULL),
(12467, NULL, 'IPR014369', NULL, 'Glycine/Sarcosine N-methyltransferase', 'Gly/Sar_N_MeTrfase', 4, NULL),
(12468, NULL, 'IPR008508', NULL, 'Protein of unknown function DUF790, endonuclease-like', 'DUF790', 4, NULL),
(12469, NULL, 'IPR012994', NULL, 'Membrane bound YbgT-like', 'YbgT_YccB', 4, NULL),
(12470, NULL, 'IPR014775', NULL, 'L27 domain, C-terminal', 'L27_C', 3, NULL),
(12471, NULL, 'IPR015287', NULL, 'Colicin D immunity protein domain', 'Colicin_D_immunity_dom', 3, NULL),
(12472, NULL, 'IPR034959', NULL, 'Testin, LIM domain 2', 'LIM2_Testin', 3, NULL),
(12473, NULL, 'IPR008457', NULL, 'Copper resistance protein D', 'Cu-R_CopD', 3, NULL),
(12474, NULL, 'IPR014390', NULL, 'Acid phosphatase, Aspergillus type', 'Acid_Pase_Asper', 4, NULL),
(12475, NULL, 'IPR010526', NULL, 'Sodium ion transport-associated', 'Na_trans_assoc', 3, NULL),
(12476, NULL, 'IPR008475', NULL, 'Bacterial phospholipase C, C-terminal domain', 'PLipase_C_C', 3, NULL),
(12477, NULL, 'IPR012870', NULL, 'Protein of unknown function DUF1666', 'DUF1666', 4, NULL),
(12478, NULL, 'IPR008775', NULL, 'Phytanoyl-CoA dioxygenase', 'Phytyl_CoA_dOase', 4, NULL),
(12479, NULL, 'IPR008784', NULL, 'Podovirus DNA packaging protein', 'Podovirus_Gp16', 4, NULL),
(12480, NULL, 'IPR008493', NULL, 'Hikeshi-like domain', 'Hikeshi-like_dom', 3, NULL),
(12481, NULL, 'IPR015286', NULL, 'Porin family, mycobacterial-type', 'Porin_fam_mycobact-type', 4, NULL),
(12482, NULL, 'IPR034018', NULL, 'Tumour necrosis factor receptor 18, N-terminal', 'TNFRSF18_N', 3, NULL),
(12483, NULL, 'IPR008750', NULL, 'Staphopain peptidase C47', 'Peptidase_C47', 4, NULL),
(12484, NULL, 'IPR012876', NULL, 'Protein of unknown function DUF1677, plant', 'DUF1677_pln', 4, NULL),
(12485, NULL, 'IPR011553', NULL, 'Translocation protein Sec62, ascomycota', 'Sec62_asco', 4, NULL),
(12486, NULL, 'IPR009048', NULL, 'Alpha-macroglobulin, receptor-binding', 'A-macroglobulin_rcpt-bd', 3, NULL),
(12487, NULL, 'IPR008483', NULL, 'Protein of unknown function DUF764, Borrelia species', 'DUF764_BOR_spp', 4, NULL),
(12488, NULL, 'IPR014757', NULL, 'Transcription regulator IclR, C-terminal', 'Tscrpt_reg_IclR_C', 3, NULL),
(12489, NULL, 'IPR015265', NULL, 'Bacterial purine repressor, N-terminal', 'PuR_N', 3, NULL),
(12490, NULL, 'IPR011528', NULL, 'Nuclease-related domain, NERD', 'NERD', 3, NULL),
(12491, NULL, 'IPR014376', NULL, 'Protein kinase C, delta/epsilon/eta/theta types', 'Prot_kin_PKC_delta', 4, NULL),
(12492, NULL, 'IPR009749', NULL, 'Protein of unknown function DUF1315', 'DUF1315', 4, NULL),
(12493, NULL, 'IPR008745', NULL, 'Domain of unknown function DUF1717', 'DUF1717', 3, NULL),
(12494, NULL, 'IPR012878', NULL, 'Beta-L-arabinofuranosidase, GH127', 'Glyco_hydro_127', 4, NULL),
(12495, NULL, 'IPR024051', NULL, 'AICAR transformylase, duplicated domain superfamily', 'AICAR_Tfase_dup_dom_sf', 5, NULL),
(12496, NULL, 'IPR009759', NULL, 'Bacteriophage ES18, Gp24', 'Phage_ES18_Gp24', 4, NULL),
(12497, NULL, 'IPR034517', NULL, 'PARP-14, RNA recognition motif 2', 'PAR14_RRM2', 3, NULL),
(12498, NULL, 'IPR008736', NULL, 'Papillomavirus E5A, alphapapillomavirus', 'Papilloma_E5A_alpha', 4, NULL),
(12499, NULL, 'IPR009713', NULL, 'Uncharacterised protein family PsiA', 'Uncharacterised_PsiA', 4, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(12500, NULL, 'IPR015271', NULL, 'Protein of unknown function DUF1951', 'DUF1951', 4, NULL),
(12501, NULL, 'IPR013638', NULL, 'Fork-head N-terminal', 'Fork-head_N', 3, NULL),
(12502, NULL, 'IPR012808', NULL, 'Conserved hypothetical protein CHP02453', 'CHP02453', 4, NULL),
(12503, NULL, 'IPR017918', NULL, 'Nitrogen regulatory protein PII, conserved site', 'N-reg_PII_CS', 2, NULL),
(12504, NULL, 'IPR012105', NULL, 'Sperm surface protein Sp17', 'Sp17', 4, NULL),
(12505, NULL, 'IPR012669', NULL, 'Pectic acid lyase', 'Pectate_lyase', 4, NULL),
(12506, NULL, 'IPR012184', NULL, 'Bifunctional molybdopterin binding protein /nucleotidyl transferase, putative', 'Bifunc_Mopterin-bd', 4, NULL),
(12507, NULL, 'IPR013568', NULL, 'SEFIR domain', 'SEFIR_dom', 3, NULL),
(12508, NULL, 'IPR011516', NULL, 'Shugoshin, N-terminal coiled-coil domain', 'Shugoshin_N', 3, NULL),
(12509, NULL, 'IPR008649', NULL, 'Herpesvirus UL82/UL83', 'Herpes_UL82/UL83', 4, NULL),
(12510, NULL, 'IPR011513', NULL, 'Non-structural maintenance of chromosomes element 1', 'Nse1', 4, NULL),
(12511, NULL, 'IPR012839', NULL, 'Organic radical enzyme activase', 'Organic_radical_activase', 4, NULL),
(12512, NULL, 'IPR020122', NULL, 'Alphabaculovirus, Y056', 'Alphabaculovirus_Y056', 4, NULL),
(12513, NULL, 'IPR008518', NULL, 'Mff/Tango-11', 'Mff/Tango-11', 4, NULL),
(12514, NULL, 'IPR011486', NULL, 'Putative beta-barrel porin-2, OmpL-like. bbp2', 'BBP2', 4, NULL),
(12515, NULL, 'IPR019745', NULL, 'Amyloidogenic glycoprotein, intracellular domain, conserved site', 'Amyloid_glyco_intracell_CS', 2, NULL),
(12516, NULL, 'IPR012523', NULL, 'Ant antimicrobial peptide', 'Antimicrobial_4', 4, NULL),
(12517, NULL, 'IPR012815', NULL, 'Mannosyl-3-phosphoglycerate phosphatase', 'MPG_Pase', 4, NULL),
(12518, NULL, 'IPR013788', NULL, 'Hemocyanin/hexamerin', 'Hemocyanin/hexamerin', 4, NULL),
(12519, NULL, 'IPR012807', NULL, 'Anti-sigma factor ChrR, putative', 'Anti-sigma_ChrR', 4, NULL),
(12520, NULL, 'IPR012358', NULL, 'Endopolyphosphatase, Ppn1p-related', 'EndopolyPtase_N1', 4, NULL),
(12521, NULL, 'IPR015297', NULL, 'Bacteriophage PRD1, P2, absorption protein', 'Phage_PRD1_P2', 4, NULL),
(12522, NULL, 'IPR011496', NULL, 'Beta-N-acetylglucosaminidase', 'Beta-N-acetylglucosaminidase', 4, NULL),
(12523, NULL, 'IPR008655', NULL, 'Helicobacter pylori IceA2', 'IceA2', 4, NULL),
(12524, NULL, 'IPR013809', NULL, 'ENTH  domain', 'ENTH', 3, NULL),
(12525, NULL, 'IPR012108', NULL, 'ADP-ribosylarginine hydrolase', 'ADP-ribosylarg_hydro', 4, NULL),
(12526, NULL, 'IPR011161', NULL, 'MHC class I-like antigen recognition-like', 'MHC_I-like_Ag-recog', 3, NULL),
(12527, NULL, 'IPR015299', NULL, 'Gamete antigen, Plasmodium species', 'Gamete_antigen_PLAspp', 4, NULL),
(12528, NULL, 'IPR011506', NULL, 'Planctomycete extracellular', 'Planctomycete_extracellular', 3, NULL),
(12529, NULL, 'IPR012098', NULL, 'SRP-independent targeting protein 3', 'SND3_fun', 4, NULL),
(12530, NULL, 'IPR013532', NULL, 'Opiodes neuropeptide', 'Opioid_neuropept', 3, NULL),
(12531, NULL, 'IPR012520', NULL, 'Frog antimicrobial peptide, brevinin-1 type', 'Antimicrobial_frog_1', 3, NULL),
(12532, NULL, 'IPR020112', NULL, 'Protein of unknown function DUF2883', 'DUF2883', 4, NULL),
(12533, NULL, 'IPR017870', NULL, 'FeS cluster insertion, C-terminal, conserved site', 'FeS_cluster_insertion_CS', 2, NULL),
(12534, NULL, 'IPR034639', NULL, 'Pub1, RNA recognition motif 3', 'PUB1_RRM3', 3, NULL),
(12535, NULL, 'IPR009767', NULL, 'DNA helicase, TraI type', 'DNA_helicase_TraI', 3, NULL),
(12536, NULL, 'IPR012834', NULL, 'Flagellar basal-body rod FlgG', 'FlgG_G_neg', 4, NULL),
(12537, NULL, 'IPR011492', NULL, 'DEAD box, Flavivirus', 'DEAD_Flavivir', 3, NULL),
(12538, NULL, 'IPR017889', NULL, 'Avidin-like, conserved site', 'Avidin-like_CS', 2, NULL),
(12539, NULL, 'IPR017967', NULL, 'HMG box A DNA-binding domain, conserved site', 'HMG_boxA_CS', 2, NULL),
(12540, NULL, 'IPR015792', NULL, 'Kinesin light chain repeat', 'Kinesin_light_repeat', 7, NULL),
(12541, NULL, 'IPR023805', NULL, 'Uncharacterised protein family, spore photo-product lyase-related', 'Uncharacterised_Spl-rel', 4, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(12542, NULL, 'IPR024145', NULL, 'Histone deacetylase complex subunit SAP30/SAP30-like', 'His_deAcase_SAP30/SAP30L', 4, NULL),
(12543, NULL, 'IPR011498', NULL, 'Kelch repeat type 2', 'Kelch_2', 7, NULL),
(12544, NULL, 'IPR034287', NULL, 'Ephrin type-A receptor 8, ligand binding domain', 'EphA8_rcpt_lig-bd', 3, NULL),
(12545, NULL, 'IPR012534', NULL, 'Bombolitin', 'Bombolitin', 4, NULL),
(12546, NULL, 'IPR012809', NULL, 'Cobalt ECF transporter T component CbiQ', 'ECF_CbiQ', 4, NULL),
(12547, NULL, 'IPR012505', NULL, 'YbbR-like', 'YbbR', 4, NULL),
(12548, NULL, 'IPR011986', NULL, 'Extradiol ring-cleavage dioxygenase LigAB, LigA subunit', 'Xdiol_dOase_LigA', 3, NULL),
(12549, NULL, 'IPR012081', NULL, 'Alkyl hydroperoxide reductase subunit F', 'Alkyl_hydroperoxide_Rdtase_suF', 4, NULL),
(12550, NULL, 'IPR013241', NULL, 'RNase P, subunit Pop3', 'RNase_P_Pop3', 4, NULL),
(12551, NULL, 'IPR008516', NULL, 'Na,K-Atpase Interacting protein', 'Na/K-Atpase_Interacting', 4, NULL),
(12552, NULL, 'IPR012835', NULL, 'Flagellar hook FlgE', 'FlgE_epsilon', 4, NULL),
(12553, NULL, 'IPR013644', NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase, C-terminal', 'DXP_reductoisomerase_C', 3, NULL),
(12554, NULL, 'IPR012519', NULL, 'Lantibiotic, type A, Pep5-type', 'Lantibiotic_typ-A_Pep5', 4, NULL),
(12555, NULL, 'IPR009234', NULL, 'Adenomatous polyposis coli protein basic domain', 'APC_basic_dom', 3, NULL),
(12556, NULL, 'IPR013502', NULL, 'Uncharacterised domain AF0941', 'Uncharacterised_AF0941', 3, NULL),
(12557, NULL, 'IPR023806', NULL, 'Conserved hypothetical protein CHP03905', 'CHP03905', 4, NULL),
(12558, NULL, 'IPR013570', NULL, 'Transcription regulator YsiA, C-terminal', 'Tscrpt_reg_YsiA_C', 3, NULL),
(12559, NULL, 'IPR019743', NULL, 'Involucrin, conserved site', 'Involucrin_CS', 2, NULL),
(12560, NULL, 'IPR009225', NULL, 'Bacteriophage head completion protein GpL', 'Phage_head_completion_GpL', 4, NULL),
(12561, NULL, 'IPR013527', NULL, 'YicC-like, N-terminal', 'YicC-like_N', 3, NULL),
(12562, NULL, 'IPR012494', NULL, 'Reovirus minor core protein, Mu-2', 'Reovirus_Mu2', 4, NULL),
(12563, NULL, 'IPR015812', NULL, 'Integrin beta subunit', 'Integrin_bsu', 4, NULL),
(12564, NULL, 'IPR013998', NULL, 'Nebulin-like', 'Nebulin-like', 4, NULL),
(12565, NULL, 'IPR009775', NULL, 'Envelope small membrane protein', 'GP2b', 4, NULL),
(12566, NULL, 'IPR012308', NULL, 'DNA ligase, ATP-dependent, N-terminal', 'DNA_ligase_ATP-dep_N', 3, NULL),
(12567, NULL, 'IPR017896', NULL, '4Fe-4S ferredoxin-type, iron-sulphur binding domain', '4Fe4S_Fe-S-bd', 3, NULL),
(12568, NULL, 'IPR023991', NULL, 'Bacteriocin, class IIb, lactobin A/cerein 7B family', 'Bacteriocin_IIb_lactobn/cerein', 4, NULL),
(12569, NULL, 'IPR009223', NULL, 'Adenomatous polyposis coli protein repeat', 'APC_rpt', 7, NULL),
(12570, NULL, 'IPR011162', NULL, 'MHC classes I/II-like antigen recognition protein', 'MHC_I/II-like_Ag-recog', 5, NULL),
(12571, NULL, 'IPR013538', NULL, 'Activator of Hsp90 ATPase homologue 1-like', 'Activator_of_Hsp90_ATPase', 4, NULL),
(12572, NULL, 'IPR013531', NULL, 'Pro-opiomelanocortin/corticotropin, ACTH, central region', 'Mcrtin_ACTH_cent', 3, NULL),
(12573, NULL, 'IPR012814', NULL, 'Pyranose 2-oxidase', 'P2OX', 4, NULL),
(12574, NULL, 'IPR012836', NULL, 'Flagellar basal-body rod FlgF', 'FlgF', 4, NULL),
(12575, NULL, 'IPR012672', NULL, 'Type III secretion system YscX', 'T3SS_YscX', 4, NULL),
(12576, NULL, 'IPR012353', NULL, 'Uncharacterised conserved protein UCP01524, polysaccharide biosynthesis aminopeptidase-like', 'UCP015244', 4, NULL),
(12577, NULL, 'IPR023990', NULL, 'Butyryl-CoA:acetate CoA-transferase', 'Butryl-CoA_acetate_CoA_Tfrase', 4, NULL),
(12578, NULL, 'IPR009232', NULL, 'EB-1 binding', 'EB1-bd', 3, NULL),
(12579, NULL, 'IPR034068', NULL, 'Sperm-associated antigen 7, R3H domain', 'R3H_sperm-antigen', 3, NULL),
(12580, NULL, 'IPR012821', NULL, 'Sucrose phosphate synthase, sucrose phosphatase-like domain', 'Sucrose_P_synth_Pase-like_dom', 3, NULL),
(12581, NULL, 'IPR012085', NULL, 'Globin, nematode', 'Globin_nematode', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(12582, NULL, 'IPR012490', NULL, 'PaRep2a', 'PaRep2a', 4, NULL),
(12583, NULL, 'IPR024710', NULL, 'Tyramine--L-glutamate ligase', 'MfnD', 4, NULL),
(12584, NULL, 'IPR008661', NULL, 'L6 membrane', 'L6_membrane', 4, NULL),
(12585, NULL, 'IPR011266', NULL, 'Fibrinogen-binding domain 2', 'Adhesin_Fg-bd_dom_2', 3, NULL),
(12586, NULL, 'IPR019738', NULL, 'Myelin P0 protein, conserved site', 'Myelin_P0_CS', 2, NULL),
(12587, NULL, 'IPR009764', NULL, 'Ovarian carcinoma immunoreactive antigen domain', 'OCIA_dom', 3, NULL),
(12588, NULL, 'IPR012536', NULL, 'Cytomegalovirus US glycoprotein', 'CMV_US', 4, NULL),
(12589, NULL, 'IPR012116', NULL, 'Glycine/sarcosine/betaine reductase complex, protein C, alpha subunit', 'Gly_reductase_pC_asu', 4, NULL),
(12590, NULL, 'IPR023808', NULL, 'Nitrile hydratase accessory protein, putative', 'Nitrile_Hydratase_acc_put', 4, NULL),
(12591, NULL, 'IPR009771', NULL, 'Ribosome control protein 1', 'Ribosome_control_1', 3, NULL),
(12592, NULL, 'IPR013637', NULL, 'Lysine-specific demethylase-like domain', 'Lys_sp_deMease-like_dom', 3, NULL),
(12593, NULL, 'IPR013536', NULL, 'WLM domain', 'WLM_dom', 3, NULL),
(12594, NULL, 'IPR015865', NULL, 'Riboflavin kinase domain, bacterial/eukaryotic', 'Riboflavin_kinase_bac/euk', 3, NULL),
(12595, NULL, 'IPR012803', NULL, 'Fatty acid oxidation complex, alpha subunit, mitochondrial', 'Fa_ox_alpha_mit', 4, NULL),
(12596, NULL, 'IPR020076', NULL, 'Protein of unknown function DUF2768', 'DUF2768', 4, NULL),
(12597, NULL, 'IPR013239', NULL, 'RNA polymerase I, subunit Rpa14, fungi', 'RNA_polI_Rpa14', 4, NULL),
(12598, NULL, 'IPR024713', NULL, 'Fructosamine deglycase FrlB', 'Fructosamine_deglycase_FrlB', 4, NULL),
(12599, NULL, 'IPR012359', NULL, 'NTP pyrophosphohydrolase MazG-related, YpjD', 'MazG-related_YpjD', 4, NULL),
(12600, NULL, 'IPR015931', NULL, 'Aconitase/3-isopropylmalate dehydratase large subunit, alpha/beta/alpha, subdomain 1/3', 'Acnase/IPM_dHydase_lsu_aba_1/3', 5, NULL),
(12601, NULL, 'IPR013566', NULL, 'Mitochondrial Rho GTPase 1/3, EF hand associated, type-1', 'EF_hand_assoc_1', 3, NULL),
(12602, NULL, 'IPR008677', NULL, 'MRVI1', 'MRVI1', 4, NULL),
(12603, NULL, 'IPR031317', NULL, 'Tom37, C-terminal domain', 'Tom37_C', 3, NULL),
(12604, NULL, 'IPR008680', NULL, 'Mastadenovirus early E4 13kDa', 'M_adenovirusE4', 4, NULL),
(12605, NULL, 'IPR019744', NULL, 'Amyloidogenic glycoprotein,  copper-binding domain conserved site', 'APP_CUBD_CS', 2, NULL),
(12606, NULL, 'IPR012496', NULL, 'TMC domain', 'TMC_dom', 3, NULL),
(12607, NULL, 'IPR008648', NULL, 'Herpesvirus ICP27-like', 'ICP27-like', 4, NULL),
(12608, NULL, 'IPR016040', NULL, 'NAD(P)-binding domain', 'NAD(P)-bd_dom', 3, NULL),
(12609, NULL, 'IPR012368', NULL, 'Oxidoreductase molybdopterin-binding subunit, IorB-related', 'OxRdtase_Mopterin-bd_su_IorB', 4, NULL),
(12610, NULL, 'IPR012811', NULL, 'Trehalose synthase/probable maltokinase, C-terminal domain', 'TreS_maltokin_C_dom', 3, NULL),
(12611, NULL, 'IPR011515', NULL, 'Shugoshin, C-terminal', 'Shugoshin_C', 3, NULL),
(12612, NULL, 'IPR012367', NULL, 'Uncharacterised conserved protein thioesterase', 'UCP_Testerase', 4, NULL),
(12613, NULL, 'IPR016035', NULL, 'Acyl transferase/acyl hydrolase/lysophospholipase', 'Acyl_Trfase/lysoPLipase', 5, NULL),
(12614, NULL, 'IPR012507', NULL, 'YibE/F-like', 'YibE_F', 4, NULL),
(12615, NULL, 'IPR023880', NULL, 'Benzylsuccinate synthase activating enzyme', 'Benzylsucc_Synthase_activating', 4, NULL),
(12616, NULL, 'IPR013131', NULL, 'Mannitol dehydrogenase, N-terminal', 'Mannitol_DH_N', 3, NULL),
(12617, NULL, 'IPR012530', NULL, 'B melanoma antigen-like', 'BAGE-like', 4, NULL),
(12618, NULL, 'IPR008669', NULL, 'LSM-interacting domain', 'LSM_interact', 3, NULL),
(12619, NULL, 'IPR012840', NULL, 'Anaerobic ribonucleoside-triphosphate reductase activating protein', 'NrdG2', 4, NULL),
(12620, NULL, 'IPR011488', NULL, 'Translation initiation factor 2, alpha subunit', 'TIF_2_asu', 4, NULL),
(12621, NULL, 'IPR017975', NULL, 'Tubulin, conserved site', 'Tubulin_CS', 2, NULL),
(12622, NULL, 'IPR017905', NULL, 'ERV/ALR sulfhydryl oxidase domain', 'ERV/ALR_sulphydryl_oxidase', 3, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(12623, NULL, 'IPR018006', NULL, 'Flagellar FliJ, proteobacteria', 'Flag_FliJ_proteobac', 4, NULL),
(12624, NULL, 'IPR013984', NULL, 'Aldehyde ferredoxin oxidoreductase, domain 2', 'Ald_Fedxn_OxRdtase_dom2', 5, NULL),
(12625, NULL, 'IPR008659', NULL, 'Yeast cell wall synthesis Kre9/Knh1, C-terminal', 'Kre9/Knh1_C', 3, NULL),
(12626, NULL, 'IPR013562', NULL, 'tRNA(Met) cytidine acetyltransferase TmcA, N-terminal', 'TmcA_N', 3, NULL),
(12627, NULL, 'IPR012091', NULL, 'Peptidase M54, archaemetzincin, archaeal/bacterial', 'Pept_M54_archaemetzncn_arc/bac', 4, NULL),
(12628, NULL, 'IPR013033', NULL, 'Septum formation inhibitor MinC', 'MinC', 4, NULL),
(12629, NULL, 'IPR012510', NULL, 'Actin-binding, Xin repeat', 'Actin-binding_Xin_repeat', 7, NULL),
(12630, NULL, 'IPR012671', NULL, 'Type III secretion system,  secretion protein E', 'T3SS_scE', 4, NULL),
(12631, NULL, 'IPR016039', NULL, 'Thiolase-like', 'Thiolase-like', 5, NULL),
(12632, NULL, 'IPR024169', NULL, 'Serine-pyruvate aminotransferase/2-aminoethylphosphonate-pyruvate transaminase', 'SP_NH2Trfase/AEP_transaminase', 4, NULL),
(12633, NULL, 'IPR019736', NULL, 'Synapsin, phosphorylation site', 'Synapsin_P_site', 6, NULL),
(12634, NULL, 'IPR013534', NULL, 'Starch synthase, catalytic domain', 'Starch_synth_cat_dom', 3, NULL),
(12635, NULL, 'IPR011520', NULL, 'Vestigial family', 'Vg_fam', 4, NULL),
(12636, NULL, 'IPR011517', NULL, 'RNA polymerase sigma-70 ECF-like', 'RNA_pol_sigma70_ECF-like', 4, NULL),
(12637, NULL, 'IPR018000', NULL, 'Neurotransmitter-gated ion-channel, conserved site', 'Neurotransmitter_ion_chnl_CS', 2, NULL),
(12638, NULL, 'IPR008651', NULL, 'Uncharacterised protein family HicB', 'Uncharacterised_HicB', 4, NULL),
(12639, NULL, 'IPR011504', NULL, 'PSRT', 'PSRT', 3, NULL),
(12640, NULL, 'IPR009766', NULL, 'White spot syndrome virus (WSSV), Orf116/126, C-terminal', 'WSSV_Orf116/126_C', 3, NULL),
(12641, NULL, 'IPR011489', NULL, 'EMI domain', 'EMI_domain', 3, NULL),
(12642, NULL, 'IPR013561', NULL, 'Methanogenesis regulatory protein FilR1, middle domain', 'FilR1_middle_dom', 3, NULL),
(12643, NULL, 'IPR012497', NULL, 'Neurotoxin B-IV-like', 'Neurotoxin_B-IV', 4, NULL),
(12644, NULL, 'IPR012514', NULL, 'Formaecin', 'Formaecin', 4, NULL),
(12645, NULL, 'IPR013550', NULL, 'RTX, C-terminal', 'RTX_C', 3, NULL),
(12646, NULL, 'IPR012355', NULL, 'NAD kinase 2, mitochondrial', 'NADK2_mit', 4, NULL),
(12647, NULL, 'IPR009230', NULL, 'ATP synthase protein 8, fungal type', 'ATP_synth_su8_fun', 4, NULL),
(12648, NULL, 'IPR019958', NULL, 'Ribosomal protein S9, archaeal', 'Ribosomal_S9_archaeal', 4, NULL),
(12649, NULL, 'IPR008672', NULL, 'Spindle assembly checkpoint component Mad1', 'Mad1', 4, NULL),
(12650, NULL, 'IPR008517', NULL, 'Putative lipoprotein GNA1162-like', 'GNA1162-like', 4, NULL),
(12651, NULL, 'IPR011502', NULL, 'Nucleoporin Nup85-like', 'Nucleoporin_Nup85', 4, NULL),
(12652, NULL, 'IPR011493', NULL, 'GLUG', 'GLUG', 3, NULL),
(12653, NULL, 'IPR024083', NULL, 'Fumarase/histidase, N-terminal', 'Fumarase/histidase_N', 5, NULL),
(12654, NULL, 'IPR017897', NULL, 'Thrombospondin, type 3 repeat', 'Thrombospondin_3_rpt', 7, NULL),
(12655, NULL, 'IPR014034', NULL, 'Ferritin, conserved site', 'Ferritin_CS', 2, NULL),
(12656, NULL, 'IPR009240', NULL, 'Adenomatous polyposis coli protein, 15 residue repeat', 'APC_15aa_rpt', 7, NULL),
(12657, NULL, 'IPR013564', NULL, 'Lipid II isoglutaminyl synthase (glutamine-hydrolyzing) subunit MurT, C-terminal', 'MurT_C', 3, NULL),
(12658, NULL, 'IPR012524', NULL, 'Abaecin, antimicrobial peptide', 'Abaecin_antimicrobial_peptide', 4, NULL),
(12659, NULL, 'IPR017974', NULL, 'Claudin, conserved site', 'Claudin_CS', 2, NULL),
(12660, NULL, 'IPR013555', NULL, 'Transient receptor ion channel domain', 'TRP_dom', 3, NULL),
(12661, NULL, 'IPR012083', NULL, 'Arylsulfatase', 'Arylsulfatase', 4, NULL),
(12662, NULL, 'IPR013020', NULL, 'ATP-dependent helicase Rad3/Chl1-like', 'Rad3/Chl1-like', 4, NULL),
(12663, NULL, 'IPR013551', NULL, 'Domain of unknown function DUF1732', 'DUF1732', 3, NULL),
(12664, NULL, 'IPR009238', NULL, 'Chordopoxvirus A33R', 'Chordopox_A33R', 4, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(12665, NULL, 'IPR012532', NULL, 'BDHCT', 'BDHCT', 3, NULL),
(12666, NULL, 'IPR012364', NULL, 'Oligosaccharide lyase', 'Oligosacch_lyase', 4, NULL),
(12667, NULL, 'IPR012493', NULL, 'Renin receptor-like', 'Renin_rcpt', 4, NULL),
(12668, NULL, 'IPR018037', NULL, 'Nitrogen fixation protein FixH, Proteobacterial', 'FixH_proteobacterial', 4, NULL),
(12669, NULL, 'IPR015298', NULL, 'Bacteriophage T4, Gp8', 'Phage_T4_Gp8', 3, NULL),
(12670, NULL, 'IPR034667', NULL, 'Novel protein kinase C delta, catalytic domain', 'nPKC_delta', 3, NULL),
(12671, NULL, 'IPR009776', NULL, 'Sporulation stage 0, protein M', 'Spore_0_M', 4, NULL),
(12672, NULL, 'IPR012528', NULL, 'Ponericin L', 'Antimicrobial_9', 4, NULL),
(12673, NULL, 'IPR005918', NULL, 'Conantokin, conserved site', 'Conantokin_CS', 2, NULL),
(12674, NULL, 'IPR017878', NULL, 'TB domain', 'TB_dom', 3, NULL),
(12675, NULL, 'IPR013546', NULL, 'PII-uridylyltransferase/Glutamine-synthetase adenylyltransferase', 'PII_UdlTrfase/GS_AdlTrfase', 3, NULL),
(12676, NULL, 'IPR034878', NULL, 'Plant La-related protein, RNA recognition motif', 'La-rel_plant_RRM', 3, NULL),
(12677, NULL, 'IPR012801', NULL, 'Catechol 1,2-dioxygenase, proteobacteria', 'Cchol_dOase_prob', 4, NULL),
(12678, NULL, 'IPR013244', NULL, 'Sec39 domain', 'Sec39_domain', 3, NULL),
(12679, NULL, 'IPR012495', NULL, 'TadE-like', 'TadE', 4, NULL),
(12680, NULL, 'IPR031312', NULL, 'Sodium/sulphate symporter, conserved site', 'Na/sul_symport_CS', 2, NULL),
(12681, NULL, 'IPR011494', NULL, 'TUP1-like enhancer of split', 'Hira', 3, NULL),
(12682, NULL, 'IPR011509', NULL, 'RtxA toxin', 'RtxA_toxin', 7, NULL),
(12683, NULL, 'IPR012183', NULL, 'FAD synthetase with the MoaB/Mog domain', 'FAD_synth_MoaB/Mog-bd', 4, NULL),
(12684, NULL, 'IPR012817', NULL, 'Chlorocatechol 1,2-dioxygenase', 'Chlorcchol_dOase', 4, NULL),
(12685, NULL, 'IPR009224', NULL, 'SAMP', 'SAMP', 7, NULL),
(12686, NULL, 'IPR008686', NULL, 'RNA-dependent RNA polymerase, mitoviral', 'RNA_pol_mitovir', 4, NULL),
(12687, NULL, 'IPR020100', NULL, 'Glucose-repressible protein Grg1', 'Glc-repressible_Grg1', 4, NULL),
(12688, NULL, 'IPR011508', NULL, 'RSD-2, N-terminal', 'RSD-2_N', 3, NULL),
(12689, NULL, 'IPR013558', NULL, 'CTNNB1 binding, N-teminal', 'CTNNB1-bd_N', 3, NULL),
(12690, NULL, 'IPR012512', NULL, 'Albumin I', 'Albumin_I', 4, NULL),
(12691, NULL, 'IPR017852', NULL, 'GPI ethanolamine phosphate transferase 1, C-terminal', 'GPI_EtnP_transferase_1_C', 3, NULL),
(12692, NULL, 'IPR012112', NULL, 'DNA repair protein Rev1', 'REV1', 4, NULL),
(12693, NULL, 'IPR011991', NULL, 'ArsR-like helix-turn-helix domain', 'ArsR-like_HTH', 3, NULL),
(12694, NULL, 'IPR011521', NULL, 'YTV', 'YTV', 7, NULL),
(12695, NULL, 'IPR020102', NULL, 'Uncharacterised protein YqgC-like', 'YqgC-like', 4, NULL),
(12696, NULL, 'IPR012093', NULL, 'Pirin', 'Pirin', 4, NULL),
(12697, NULL, 'IPR012818', NULL, 'Precorrin-6Y methyltransferase', 'CbiE', 3, NULL),
(12698, NULL, 'IPR013552', NULL, 'Thioester domain', 'Thioester_dom', 3, NULL),
(12699, NULL, 'IPR013548', NULL, 'Plexin, cytoplasmic RasGAP domain', 'Plexin_cytoplasmic_RasGAP_dom', 3, NULL),
(12700, NULL, 'IPR013839', NULL, 'NAD-dependent DNA ligase, adenylation', 'DNAligase_adenylation', 3, NULL),
(12701, NULL, 'IPR009231', NULL, 'Chloride channel CLIC-like', 'Chloride_chnl_CLIC-like', 4, NULL),
(12702, NULL, 'IPR015810', NULL, 'Photosynthetic reaction centre, H subunit, N-terminal', 'Photo_RC_H_N', 3, NULL),
(12703, NULL, 'IPR012816', NULL, 'NADAR', 'NADAR', 3, NULL),
(12704, NULL, 'IPR012100', NULL, 'DNA-damage-repair/toleration protein, DRT102', 'DRT102', 4, NULL),
(12705, NULL, 'IPR012499', NULL, 'Janus-atracotoxin', 'Toxin_16', 4, NULL),
(12706, NULL, 'IPR019961', NULL, 'Ribosomal protein S11, archaeal', 'Ribosomal_S11_archaeal', 4, NULL),
(12707, NULL, 'IPR017845', NULL, 'Chlorosome envelope protein H, CsmH', 'Chlorosome_envelope_CsmH', 7, NULL),
(12708, NULL, 'IPR031318', NULL, 'OPI10 family', 'OPI10', 4, NULL),
(12709, NULL, 'IPR020104', NULL, 'Protein of unknown function DUF5438', 'DUF5438', 4, NULL),
(12710, NULL, 'IPR034418', NULL, 'Probable RNA-binding protein 19, RNA recognition motif 1', 'RMB19_RRM1', 3, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(12711, NULL, 'IPR012522', NULL, 'Spider antimicrobial peptide', 'Antimicrobial_3', 4, NULL),
(12712, NULL, 'IPR017989', NULL, 'Ribosome-inactivating protein type 1/2', 'Ribosome_inactivat_1/2', 4, NULL),
(12713, NULL, 'IPR012110', NULL, 'Thiamine pyrophosphate (TPP)-dependent enzyme', 'TPP_enzyme', 4, NULL),
(12714, NULL, 'IPR012827', NULL, 'Hemerythrin, metal-binding domain', 'Hemerythrin_metal-bd', 3, NULL),
(12715, NULL, 'IPR035916', NULL, 'Egg-lysin superfamily', 'Egg_lysin_sf', 5, NULL),
(12716, NULL, 'IPR008514', NULL, 'Type VI secretion system effector Hcp', 'T6SS_Hcp', 4, NULL),
(12717, NULL, 'IPR012830', NULL, 'Citrate utilization protein B', 'Citrate_utilization_prot_B', 4, NULL),
(12718, NULL, 'IPR009227', NULL, 'Zea mays MURB-like', 'Zea_mays_MuDR', 4, NULL),
(12719, NULL, 'IPR020101', NULL, 'Cytochrome b-c1 complex subunit 8, plants', 'Cyt_b-c1_8-plants', 4, NULL),
(12720, NULL, 'IPR008675', NULL, 'Mating factor alpha precursor, N-terminal', 'Mating_factor_alpha_N', 3, NULL),
(12721, NULL, 'IPR009774', NULL, 'Streptococcus phage 7201, Orf18', 'Phage_7201_Orf18', 4, NULL),
(12722, NULL, 'IPR013983', NULL, 'Aldehyde ferredoxin oxidoreductase, N-terminal', 'Ald_Fedxn_OxRdtase_N', 3, NULL),
(12723, NULL, 'IPR017988', NULL, 'Ribosome-inactivating protein conserved site', 'Ribosome_inactivat_prot_CS', 2, NULL),
(12724, NULL, 'IPR012804', NULL, 'Cobaltochelatase subunit, putative', 'Cob_chelat_sub_put', 4, NULL),
(12725, NULL, 'IPR012800', NULL, 'Catechol 1,2-dioxygenase, actinobacteria', 'Cchol_dOase_actb', 4, NULL),
(12726, NULL, 'IPR020109', NULL, 'Holin, r1t-type', 'Holin_r1t', 4, NULL),
(12727, NULL, 'IPR017977', NULL, 'Zona pellucida domain, conserved site', 'ZP_dom_CS', 2, NULL),
(12728, NULL, 'IPR020108', NULL, 'Spore coat protein CotD', 'Spore_coat_CotD', 4, NULL),
(12729, NULL, 'IPR014347', NULL, 'Tautomerase/MIF superfamily', 'Tautomerase/MIF_sf', 5, NULL),
(12730, NULL, 'IPR019783', NULL, 'Ribosome maturation protein SDO1/SBDS, N-terminal', 'SDO1/SBDS_N', 3, NULL),
(12731, NULL, 'IPR008668', NULL, 'Virion infectivity factor, Lentivirus', 'Vir_infectivity_fact_Lentivir', 4, NULL),
(12732, NULL, 'IPR012492', NULL, 'Protein RED, C-terminal', 'RED_C', 3, NULL),
(12733, NULL, 'IPR009229', NULL, 'Staphylococcal AgrD', 'AgrD', 4, NULL),
(12734, NULL, 'IPR008664', NULL, 'LISCH7', 'LISCH7', 3, NULL),
(12735, NULL, 'IPR019737', NULL, 'Homeobox engrailed-type, conserved site', 'Homoebox-engrailed_CS', 2, NULL),
(12736, NULL, 'IPR012511', NULL, 'S-adenosyl-l-methionine decarboxylase leader peptide', 'AdoMetDC_leader', 4, NULL),
(12737, NULL, 'IPR008670', NULL, 'Long-chain-fatty-acyl-CoA reductase, LuxC', 'CoA_reduct_LuxC', 4, NULL),
(12738, NULL, 'IPR020099', NULL, 'Protein of unknown function DUF5445', 'DUF5445', 4, NULL),
(12739, NULL, 'IPR012509', NULL, 'Neurotoxin 3, Anemonia', 'Neurotoxin_3_Anemonia', 3, NULL),
(12740, NULL, 'IPR008650', NULL, 'Herpesvirus, helicase-primase complex component', 'Helicase-primas_cplx_Herpesvir', 3, NULL),
(12741, NULL, 'IPR015849', NULL, 'Amyloidogenic glycoprotein, heparin-binding', 'Amyloid_glyco_heparin-bd', 3, NULL),
(12742, NULL, 'IPR013238', NULL, 'RNA polymerase III, subunit Rpc25', 'RNA_pol_III_Rbc25', 3, NULL),
(12743, NULL, 'IPR012805', NULL, 'Acetyl-CoA C-acyltransferase FadA', 'FadA', 4, NULL),
(12744, NULL, 'IPR012828', NULL, 'ATP-dependent 6-phosphofructokinase, prokaryotic', 'PFKA_ATP_prok', 4, NULL),
(12745, NULL, 'IPR012106', NULL, 'Protease, Mu phage/prophage I type', 'Phage_Mu_Gp1', 4, NULL),
(12746, NULL, 'IPR012673', NULL, 'Type III secretion system chaperone SycN', 'T3SS_SynN', 4, NULL),
(12747, NULL, 'IPR008515', NULL, 'Prokaryotic ubiquitin-like protein Pup', 'Ubiquitin-like_Pup', 4, NULL),
(12748, NULL, 'IPR012079', NULL, 'Bifunctional aldehyde-alcohol dehydrogenase', 'Bifunc_Ald-ADH', 4, NULL),
(12749, NULL, 'IPR011023', NULL, 'Nop2p', 'Nop2p', 3, NULL),
(12750, NULL, 'IPR009237', NULL, 'Herpesvirus US2/US3', 'Herpes_US2/US3', 4, NULL),
(12751, NULL, 'IPR012111', NULL, 'Hemolectin/hemocytin', 'Hml', 4, NULL),
(12752, NULL, 'IPR012487', NULL, 'Nairovirus M polyprotein-like', 'Nairovirus_M', 4, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(12753, NULL, 'IPR013544', NULL, 'Domain of unknown function DUF1725', 'DUF1725', 3, NULL),
(12754, NULL, 'IPR012502', NULL, 'WAPL domain', 'WAPL_dom', 3, NULL),
(12755, NULL, 'IPR020121', NULL, 'Bacteriophage T7-like gene 6.5', 'Phage_T7-like_6.5', 4, NULL),
(12756, NULL, 'IPR013838', NULL, 'Beta tubulin, autoregulation binding site', 'Beta-tubulin_BS', 1, NULL),
(12757, NULL, 'IPR035013', NULL, 'YabN, N-terminal', 'YabN_N', 3, NULL),
(12758, NULL, 'IPR024173', NULL, 'Phosphoesterase, MJ0037', 'Pesterase_MJ0037', 4, NULL),
(12759, NULL, 'IPR012838', NULL, 'Pyruvate formate-lyase 1 activating enzyme', 'PFL1_activating', 4, NULL),
(12760, NULL, 'IPR014030', NULL, 'Beta-ketoacyl synthase, N-terminal', 'Ketoacyl_synth_N', 3, NULL),
(12761, NULL, 'IPR013243', NULL, 'SCA7 domain', 'SCA7_dom', 3, NULL),
(12762, NULL, 'IPR013535', NULL, 'PUL domain', 'PUL_dom', 3, NULL),
(12763, NULL, 'IPR009762', NULL, 'Circovirus 2, Orf10', 'Circovirus2_Orf10', 4, NULL),
(12764, NULL, 'IPR012503', NULL, 'WisP, N-terminal', 'WisP_N', 3, NULL),
(12765, NULL, 'IPR012670', NULL, 'Type III secretion system, YscI/HrpB', 'T3SS_YscI/HrpB', 4, NULL),
(12766, NULL, 'IPR011606', NULL, 'Branched-chain amino acid transport, permease', 'Brnchd-chn_aa_trnsp_permease', 4, NULL),
(12767, NULL, 'IPR017895', NULL, 'Helix-turn-helix, IS408/IS1162 transposase-type', 'HTH_IS408/IS1162_type', 3, NULL),
(12768, NULL, 'IPR017911', NULL, 'MacB, ATP-binding domain', 'MacB_ATP-bd', 3, NULL),
(12769, NULL, 'IPR012361', NULL, 'Galactose-1-phosphate uridylyltransferase, short form, putative', 'GalT_short', 4, NULL),
(12770, NULL, 'IPR012089', NULL, 'tRNA-cytidine(32) 2-sulfurtransferase', 'tRNA_Cyd_32_2_STrfase', 4, NULL),
(12771, NULL, 'IPR011142', NULL, 'Spider toxin CSTX, Knottin scaffold conserved site', 'Spider_toxin_CSTX_Knottin_CS', 2, NULL),
(12772, NULL, 'IPR008513', NULL, 'tRNA(Met) cytidine acetate ligase', 'tRNA(Met)_cyd_acetate_ligase', 4, NULL),
(12773, NULL, 'IPR015807', NULL, 'Histidine-tRNA ligase', 'His-tRNA-ligase', 4, NULL),
(12774, NULL, 'IPR031313', NULL, 'SAPK-interacting protein 1, Pleckstrin-homology domain', 'Sin1_PH_dom', 3, NULL),
(12775, NULL, 'IPR013985', NULL, 'Aldehyde ferredoxin oxidoreductase, domain 3', 'Ald_Fedxn_OxRdtase_dom3', 5, NULL),
(12776, NULL, 'IPR012504', NULL, 'Spore protein YabP', 'Spore_YabP', 4, NULL),
(12777, NULL, 'IPR024167', NULL, 'Cytochrome c4-like', 'Cytochrome_c4-like', 4, NULL),
(12778, NULL, 'IPR024164', NULL, 'KinB-signalling pathway activation protein', 'KinB-signalling_activ', 4, NULL),
(12779, NULL, 'IPR023809', NULL, 'Thiopeptide-type bacteriocin biosynthesis domain', 'Thiopep_bacteriocin_synth_dom', 3, NULL),
(12780, NULL, 'IPR013567', NULL, 'EF hand associated, type-2', 'EF_hand_assoc_2', 3, NULL),
(12781, NULL, 'IPR012500', NULL, 'Clostridium neurotoxin, translocation', 'Toxin_trans', 3, NULL),
(12782, NULL, 'IPR012820', NULL, 'Sucrose synthase, plant/cyanobacteria', 'Sucrose_synthase_pln/cyn', 4, NULL),
(12783, NULL, 'IPR012498', NULL, 'Alpha-A conotoxin PIVA-like', 'Toxin_14', 4, NULL),
(12784, NULL, 'IPR009778', NULL, 'Modulator of Rho-dependent transcription termination', 'ROF', 4, NULL),
(12785, NULL, 'IPR008663', NULL, 'Leukocyte cell-derived chemotaxin 2', 'LECT2', 4, NULL),
(12786, NULL, 'IPR017871', NULL, 'ABC transporter-like, conserved site', 'ABC_transporter-like_CS', 2, NULL),
(12787, NULL, 'IPR024165', NULL, 'Aminoglycoside 3-phosphotransferase', 'Kan/Strep_kinase', 4, NULL),
(12788, NULL, 'IPR015803', NULL, 'Cysteine-tRNA ligase', 'Cys-tRNA-ligase', 4, NULL),
(12789, NULL, 'IPR024093', NULL, 'Uncharacterised protein family MTH865', 'Uncharacterised_MTH865', 4, NULL),
(12790, NULL, 'IPR013543', NULL, 'Calcium/calmodulin-dependent protein kinase II, association-domain', 'Ca/CaM-dep_prot_kinase-assoc', 3, NULL),
(12791, NULL, 'IPR013542', NULL, 'Epoxyqueuosine reductase QueG, DUF1730', 'QueG_DUF1730', 3, NULL),
(12792, NULL, 'IPR008656', NULL, 'Inositol-tetrakisphosphate 1-kinase', 'Inositol_tetrakis-P_1-kinase', 4, NULL),
(12793, NULL, 'IPR008653', NULL, 'Immediate early response', 'IER', 4, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(12794, NULL, 'IPR012812', NULL, 'Mannosyl-3-phosphoglycerate synthase', 'Osmo_MPG_synth', 4, NULL),
(12795, NULL, 'IPR012357', NULL, 'Uncharacterised conserved protein UCP024484', 'UCP024484', 4, NULL),
(12796, NULL, 'IPR017985', NULL, 'DNA methylase, N-4 cytosine-specific, conserved site', 'MeTrfase_CN4_CS', 2, NULL),
(12797, NULL, 'IPR013640', NULL, 'VPS4-associated protein 1', 'Vfa1', 4, NULL),
(12798, NULL, 'IPR012354', NULL, 'Esterase/lipase', 'Esterase_lipase', 4, NULL),
(12799, NULL, 'IPR013549', NULL, 'Domain of unknown function DUF1731', 'DUF1731', 3, NULL),
(12800, NULL, 'IPR009773', NULL, 'Lactococcus phage 712, M3', 'Lactococcus_phage_712_M3', 4, NULL),
(12801, NULL, 'IPR017968', NULL, 'Acylphosphatase, conserved site', 'Acylphosphatase_CS', 2, NULL),
(12802, NULL, 'IPR009772', NULL, 'Cell division cycle protein 123', 'CDC123', 4, NULL),
(12803, NULL, 'IPR012842', NULL, 'Type 3 secretion system stator protein SctL/SctL2', 'T3SS_SctL/SctL2', 4, NULL),
(12804, NULL, 'IPR012310', NULL, 'DNA ligase, ATP-dependent, central', 'DNA_ligase_ATP-dep_cent', 3, NULL),
(12805, NULL, 'IPR018002', NULL, 'Herpesvirus UL45', 'Herpes_UL45', 4, NULL),
(12806, NULL, 'IPR017980', NULL, 'Metallothionein, family 4, echinoidea/annelida', 'Metalthion_4_echinoid/annelid', 4, NULL),
(12807, NULL, 'IPR009233', NULL, 'Competence pheromone ComX, Bacillus-type', 'Competence_ComX_Bacillus', 4, NULL),
(12808, NULL, 'IPR011519', NULL, 'ASPIC/UnbV', 'UnbV_ASPIC', 3, NULL),
(12809, NULL, 'IPR008652', NULL, 'Adenovirus type 2, E3A glycoprotein', 'Adenovirus_Type-2_E3A', 4, NULL),
(12810, NULL, 'IPR012491', NULL, 'Protein Red1/Rec10', 'Red1/Rec10', 4, NULL),
(12811, NULL, 'IPR019742', NULL, 'Alpha-2-macroglobulin, conserved site', 'MacrogloblnA2_CS', 2, NULL),
(12812, NULL, 'IPR011487', NULL, 'Protein of unknown function DUF1598', 'DUF1598', 4, NULL),
(12813, NULL, 'IPR011988', NULL, 'MHC class II-associated invariant chain, trimerisation', 'MHC_II-assoc_invariant_trimer', 3, NULL),
(12814, NULL, 'IPR012356', NULL, 'Uncharacterised conserved protein UCP018781, methanogenesis', 'UCP018781_methan', 4, NULL),
(12815, NULL, 'IPR009779', NULL, 'Translocon-associated protein subunit gamma', 'SSR3', 4, NULL),
(12816, NULL, 'IPR009770', NULL, 'Domain of unknown function DUF1338', 'DUF1338', 3, NULL),
(12817, NULL, 'IPR023553', NULL, 'Uncharacterised methyltransferase, YrrT', 'Uncharacterised_MeTfrase_YrrT', 4, NULL),
(12818, NULL, 'IPR020087', NULL, 'Protein of unknown function DUF5487', 'DUF5487', 4, NULL),
(12819, NULL, 'IPR013147', NULL, 'CD47-like, transmembrane', 'CD47-like_TM', 3, NULL),
(12820, NULL, 'IPR013560', NULL, 'Domain of unknown function DUF1722', 'DUF1722', 3, NULL),
(12821, NULL, 'IPR012187', NULL, 'Disulphide bond formation protein  BdbC', 'Disulphide_bond_form_BdbC', 4, NULL),
(12822, NULL, 'IPR012819', NULL, 'Sucrose-phosphate synthase, plant', 'SPS_pln', 4, NULL),
(12823, NULL, 'IPR017854', NULL, 'Metallothionein domain superfamily', 'Metalthion_dom_sf', 5, NULL),
(12824, NULL, 'IPR020120', NULL, 'Plasmid pGKL2, Orf8', 'Plasmid_pGKL2_Orf8', 4, NULL),
(12825, NULL, 'IPR012188', NULL, 'NAD(P)-dependent malic enzyme', 'ME_PTA', 4, NULL),
(12826, NULL, 'IPR009226', NULL, 'Penaeidin', 'Penaeidin', 4, NULL),
(12827, NULL, 'IPR008674', NULL, 'Chromosomal protein MC1', 'MC1', 3, NULL),
(12828, NULL, 'IPR012198', NULL, 'cAMP-dependent protein kinase regulatory subunit', 'cAMP_dep_PK_reg_su', 4, NULL),
(12829, NULL, 'IPR012363', NULL, 'Propanediol utilisation/coumermycin biosynthesis, PduX-related', 'PduX', 4, NULL),
(12830, NULL, 'IPR012369', NULL, 'Galactokinase, glycosyltransferase', 'Galk_glycosyltransferase', 4, NULL),
(12831, NULL, 'IPR011062', NULL, 'Contryphan, conserved site', 'Contryphan_CS', 2, NULL),
(12832, NULL, 'IPR035012', NULL, 'Tensin-like, SH2 domain', 'Tensin-like_SH2', 3, NULL),
(12833, NULL, 'IPR008660', NULL, 'Fibroin light chain', 'L-fibroin', 4, NULL),
(12834, NULL, 'IPR010906', NULL, 'Bacteriophage lambda, Nu1, terminase small subunit', 'Phage_lambda_Nu1_terminase-ssu', 4, NULL),
(12835, NULL, 'IPR019739', NULL, 'CTF transcription factor/nuclear factor 1, conserved site', 'CTF/NFI_DNA-bd_CS', 2, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(12836, NULL, 'IPR012527', NULL, 'Uperin', 'Antimicrobial_8', 4, NULL),
(12837, NULL, 'IPR004448', NULL, 'Nitrate reductas, NapE, periplasmic', 'Nitrate_reductase_NapE', 4, NULL),
(12838, NULL, 'IPR011514', NULL, 'Secretin, N-terminal', 'Secretin_N_2', 3, NULL),
(12839, NULL, 'IPR013246', NULL, 'SAGA complex, Sgf11 subunit', 'SAGA_su_Sgf11', 4, NULL),
(12840, NULL, 'IPR023555', NULL, 'Thiol-disulphide oxidoreductase ResA', 'Thiol-dS_OxRdtase_ResA', 4, NULL),
(12841, NULL, 'IPR012516', NULL, 'Halocidin', 'Antimicrobial13', 4, NULL),
(12842, NULL, 'IPR011518', NULL, 'Transposase, Rhodopirellula-type', 'Transposase_36', 4, NULL),
(12843, NULL, 'IPR013790', NULL, 'Dwarfin', 'Dwarfin', 4, NULL),
(12844, NULL, 'IPR012365', NULL, 'Phosphoesterase, lmo2642-related', 'Pesteras_lmo2642', 4, NULL),
(12845, NULL, 'IPR008673', NULL, 'Microfibril-associated glycoprotein', 'MAGP', 4, NULL),
(12846, NULL, 'IPR015796', NULL, 'Impact family, bacterial/archaeal', 'Impact_bac/arc', 4, NULL),
(12847, NULL, 'IPR020085', NULL, 'DNA delivery protein, P32/P34', 'DNA_delivery_prot_P32/34', 4, NULL),
(12848, NULL, 'IPR024174', NULL, 'Hepatocyte growth factor/Macrophage stimulatory protein', 'HGF/MST1', 4, NULL),
(12849, NULL, 'IPR008658', NULL, 'Kinesin-associated protein 3', 'KAP3', 4, NULL),
(12850, NULL, 'IPR012182', NULL, 'Bifunctional molybdenum cofactor biosynthesis MobB/MoeA', 'MobB_MoeA', 4, NULL),
(12851, NULL, 'IPR011505', NULL, 'Peptidase M26, C-terminal domain', 'Peptidase_M26_C_dom', 3, NULL),
(12852, NULL, 'IPR015819', NULL, 'Lipid transport protein, beta-sheet shell', 'Lipid_transp_b-sht_shell', 5, NULL),
(12853, NULL, 'IPR013556', NULL, 'Flagellar M-ring C-terminal', 'Flag_M-ring_C', 3, NULL),
(12854, NULL, 'IPR013571', NULL, 'Transcription regulator QacR, C-terminal', 'Tscrpt_reg_QacR_C', 3, NULL),
(12855, NULL, 'IPR013240', NULL, 'DNA-directed RNA polymerase I, subunit RPA34.5', 'DNA-dir_RNA_pol1_su_RPA34', 4, NULL),
(12856, NULL, 'IPR015802', NULL, 'Copper amine oxidase, N3-terminal', 'Cu_amine_oxidase_N3', 3, NULL),
(12857, NULL, 'IPR009768', NULL, 'Microtubule-associated protein 70', 'MAP70', 4, NULL),
(12858, NULL, 'IPR012825', NULL, '5,6-dimethylbenzimidazole synthase BluB', 'BluB', 4, NULL),
(12859, NULL, 'IPR013539', NULL, 'Adenylosuccinate lyase PurB, C-terminal', 'PurB_C', 3, NULL),
(12860, NULL, 'IPR008676', NULL, 'MRG', 'MRG', 4, NULL),
(12861, NULL, 'IPR012533', NULL, 'YcnI-like', 'YcnI-like', 3, NULL),
(12862, NULL, 'IPR017846', NULL, 'Nicotinate-nucleotide-dimethylbenzimidazole phosphoribosyltransferase, bacterial type', 'Nict_dMeBzImd_PRibTrfase_bact', 4, NULL),
(12863, NULL, 'IPR017901', NULL, 'C-CAP/cofactor C-like domain', 'C-CAP_CF_C-like', 3, NULL),
(12864, NULL, 'IPR013036', NULL, 'Domain of unknown function DUF1587', 'DUF1587', 3, NULL),
(12865, NULL, 'IPR013565', NULL, 'Fatty acid synthase beta subunit AflB /Fas1-like, central domain', 'Fas1/AflB-like_central', 3, NULL),
(12866, NULL, 'IPR012837', NULL, 'Ribonucleoside-triphosphate reductase activating, anaerobic', 'NrdG', 4, NULL),
(12867, NULL, 'IPR013840', NULL, 'NAD-dependent DNA ligase, N-terminal', 'DNAligase_N', 3, NULL),
(12868, NULL, 'IPR012103', NULL, 'Peptidase S8A, bacillopeptidase F', 'Pept_S8A_Bpr', 4, NULL),
(12869, NULL, 'IPR015798', NULL, 'Copper amine oxidase, catalytic domain', 'Cu_amine_oxidase_C', 3, NULL),
(12870, NULL, 'IPR017972', NULL, 'Cytochrome P450, conserved site', 'Cyt_P450_CS', 2, NULL),
(12871, NULL, 'IPR023807', NULL, 'Peptide modification radical SAM enzyme', 'Peptide_mod_rSAM', 4, NULL),
(12872, NULL, 'IPR011500', NULL, 'GPCR, family 3, nine cysteines domain', 'GPCR_3_9-Cys_dom', 3, NULL),
(12873, NULL, 'IPR011499', NULL, 'Lipid A biosynthesis, N-terminal', 'Lipid_A_biosynth_N', 3, NULL),
(12874, NULL, 'IPR014720', NULL, 'Double-stranded RNA-binding domain', 'dsRBD_dom', 3, NULL),
(12875, NULL, 'IPR017879', NULL, 'PotA, ATP-binding domain', 'PotA_ATP-bd', 3, NULL),
(12876, NULL, 'IPR012186', NULL, 'Adenine modification methylase, M.StsI-type', 'Ade-mod_methylase_MStsI', 4, NULL),
(12877, NULL, 'IPR018011', NULL, 'Carbohydrate sulfotransferase 8-10', 'Carb_sulfotrans_8-10', 4, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(12878, NULL, 'IPR013572', NULL, 'Transcription regulator MAATS, C-terminal', 'Tscrpt_reg_MAATS_C', 3, NULL),
(12879, NULL, 'IPR012094', NULL, 'tRNA(Ile)-lysidine synthase', 'tRNA_Ile_lys_synt', 4, NULL),
(12880, NULL, 'IPR012489', NULL, 'Nuclease A inhibitor-like', 'NucleaseA_inhib-like', 4, NULL),
(12881, NULL, 'IPR013545', NULL, 'Type II secretion system protein GspG, C-terminal', 'T2SS_protein-GspG_C', 3, NULL),
(12882, NULL, 'IPR012802', NULL, 'Fatty oxidation complex, alpha subunit FadJ', 'FadJ', 4, NULL),
(12883, NULL, 'IPR011989', NULL, 'Armadillo-like helical', 'ARM-like', 5, NULL),
(12884, NULL, 'IPR019741', NULL, 'Galactokinase, conserved site', 'Galactokinase_CS', 2, NULL),
(12885, NULL, 'IPR009228', NULL, 'Capsid scaffolding protein GpO', 'Capsid_scaffold_GpO', 4, NULL),
(12886, NULL, 'IPR034069', NULL, 'R3H domain, Cip2-type', 'R3H_Cip2', 3, NULL),
(12887, NULL, 'IPR011491', NULL, 'Flagellar hook protein FlgE', 'Falgellar_hook_FlgE', 3, NULL),
(12888, NULL, 'IPR012518', NULL, 'Ocellatin', 'Antimicrobial15', 3, NULL),
(12889, NULL, 'IPR010907', NULL, 'Calcium-mediated lectin', 'Ca-mediated_lectin', 3, NULL),
(12890, NULL, 'IPR013559', NULL, 'YheO-like', 'YheO', 3, NULL),
(12891, NULL, 'IPR018129', NULL, 'Phosphoenolpyruvate carboxylase, Lys active site', 'PEP_COase_Lys_AS', 0, NULL),
(12892, NULL, 'IPR012806', NULL, 'Acetyl-CoA C-acyltransferase FadI', 'Ac-CoA_C-AcTrfase_FadI', 4, NULL),
(12893, NULL, 'IPR012831', NULL, 'Precorrin 3B synthase CobZ', 'CobZ', 4, NULL),
(12894, NULL, 'IPR012092', NULL, '8-oxoguanine DNA glycosylase/AP lyase Ogg', 'DNA_glyclase/AP_lyase_Ogg', 4, NULL),
(12895, NULL, 'IPR017847', NULL, 'Type VI secretion system, RhsGE-associated Vgr  family subset', 'T6SS_RhsGE_Vgr_subset', 4, NULL),
(12896, NULL, 'IPR013537', NULL, 'Acetyl-CoA carboxylase, central domain', 'AcCoA_COase_cen', 3, NULL),
(12897, NULL, 'IPR009235', NULL, 'Autographa californica nuclear polyhedrosis virus (AcMNPV), Orf146', 'AcMNPV_Orf146', 4, NULL),
(12898, NULL, 'IPR008681', NULL, 'Negative regulator of genetic competence, MecA', 'Neg-reg_MecA', 4, NULL),
(12899, NULL, 'IPR013540', NULL, 'Chitinase A N-terminal', 'ChitinaseA_N', 3, NULL),
(12900, NULL, 'IPR008511', NULL, 'Protein ROH1-like', 'ROH1-like', 4, NULL),
(12901, NULL, 'IPR013237', NULL, 'Bacteriophage T7, Gp4, DNA primase/helicase, N-terminal', 'Phage_T7_Gp4_N', 3, NULL),
(12902, NULL, 'IPR013557', NULL, 'AntA/AntB antirepressor', 'AntA/B_antirep', 3, NULL),
(12903, NULL, 'IPR013236', NULL, 'M protein trans-acting positive regulator (MGA), PRD domain', 'Mga_PRD_dom', 3, NULL),
(12904, NULL, 'IPR012521', NULL, 'Frog antimicrobial peptide, brevinin-2/esculentin type', 'Antimicrobial_frog_2', 3, NULL),
(12905, NULL, 'IPR005853', NULL, 'Omega-agatoxin type II/III, conserved site', 'Omega-agatoxin_II/III_CS', 2, NULL),
(12906, NULL, 'IPR009769', NULL, 'Protein ENHANCED DISEASE RESISTANCE 2, C-terminal', 'EDR2_C', 3, NULL),
(12907, NULL, 'IPR013547', NULL, 'Prolyl 4-hydroxylase alpha-subunit, N-terminal', 'Pro_4_hyd_alph_N', 3, NULL),
(12908, NULL, 'IPR020113', NULL, 'Protein of unknown function DUF5439', 'DUF5439', 4, NULL),
(12909, NULL, 'IPR015800', NULL, 'Copper amine oxidase, N2-terminal', 'Cu_amine_oxidase_N2', 3, NULL),
(12910, NULL, 'IPR012833', NULL, 'Ribonucleoside-triphosphate reductase, anaerobic', 'NrdD', 4, NULL),
(12911, NULL, 'IPR011987', NULL, 'ATPase, V1 complex, subunit H, C-terminal', 'ATPase_V1-cplx_hsu_C', 3, NULL),
(12912, NULL, 'IPR016036', NULL, 'Malonyl-CoA ACP transacylase, ACP-binding', 'Malonyl_transacylase_ACP-bd', 5, NULL),
(12913, NULL, 'IPR012832', NULL, 'Reductive dehalogenase', 'RDH', 4, NULL),
(12914, NULL, 'IPR012810', NULL, 'Trehalose synthase/alpha-amylase, N-terminal', 'TreS/a-amylase_N', 3, NULL),
(12915, NULL, 'IPR009239', NULL, 'Bacillus PapR', 'Bacillus_PapR', 4, NULL),
(12916, NULL, 'IPR012501', NULL, 'Vacuolar protein sorting-associated protein 54, C-terminal', 'Vps54_C', 3, NULL),
(12917, NULL, 'IPR004432', NULL, 'Polyketide-type polyunsaturated fatty acid synthase, PfaA', 'Omega_3_polyunsat_FA_synth', 4, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(12918, NULL, 'IPR013235', NULL, 'PPP domain', 'PPP_dom', 3, NULL),
(12919, NULL, 'IPR013642', NULL, 'Calcium-activated chloride channel, N-terminal', 'CLCA_N', 3, NULL),
(12920, NULL, 'IPR024176', NULL, 'Citrate synthase, bacterial-type', 'Citrate_synthase_bac-typ', 4, NULL),
(12921, NULL, 'IPR015817', NULL, 'Vitellinogen, open beta-sheet, subdomain 1', 'Vitellinogen_open_b-sht_sub1', 5, NULL),
(12922, NULL, 'IPR012115', NULL, 'Bifunctional ribulose 5-phosphate reductase/CDP-ribitol pyrophosphorylase', 'CDP-ribitol_syn', 4, NULL),
(12923, NULL, 'IPR011990', NULL, 'Tetratricopeptide-like helical domain superfamily', 'TPR-like_helical_dom_sf', 5, NULL),
(12924, NULL, 'IPR011483', NULL, 'Cellulose-binding Sde182, nucleoside hydrolase-like domain', 'Sde182_NH-like', 3, NULL),
(12925, NULL, 'IPR010905', NULL, 'Glycosyl hydrolase, family 88', 'Glyco_hydro_88', 4, NULL),
(12926, NULL, 'IPR024168', NULL, 'Catalase, SrpA-type, predicted', 'Catalase_SrpA-type_pred', 4, NULL),
(12927, NULL, 'IPR012667', NULL, 'Cobalt transporter subunit CbtB, putative', 'CbtB_put', 4, NULL),
(12928, NULL, 'IPR008685', NULL, 'Centromere protein Mis12', 'Centromere_Mis12', 4, NULL),
(12929, NULL, 'IPR012843', NULL, 'Type III secretion system YscD/HrpQ', 'T3SS_YscD/HrpQ', 4, NULL),
(12930, NULL, 'IPR012097', NULL, 'Opacity-associated protein B', 'OapB', 4, NULL),
(12931, NULL, 'IPR013337', NULL, 'CRISPR-associated protein Cas5, Tneap type', 'CRISPR-assoc_prot_Cas5_Tneap', 4, NULL),
(12932, NULL, 'IPR012529', NULL, 'Attractin', 'Attractin', 4, NULL),
(12933, NULL, 'IPR013643', NULL, 'Calicivirus coat protein C-terminal', 'Calicivirus_coat_C', 3, NULL),
(12934, NULL, 'IPR008662', NULL, 'Torsin-1A-interacting protein 1/2', 'TOIP1/2', 4, NULL),
(12935, NULL, 'IPR015816', NULL, 'Vitellinogen, beta-sheet N-terminal', 'Vitellinogen_b-sht_N', 5, NULL),
(12936, NULL, 'IPR024171', NULL, 'S-receptor-like serine/threonine-protein kinase', 'SRK-like_kinase', 4, NULL),
(12937, NULL, 'IPR018038', NULL, 'Ribosomal protein L30, conserved site', 'Ribosomal_L30_CS', 2, NULL),
(12938, NULL, 'IPR012080', NULL, 'Aspartate-semialdehyde dehydrogenase', 'Asp_semialdehyde_DH', 4, NULL),
(12939, NULL, 'IPR013023', NULL, 'Ketol-acid reductoisomerase', 'KARI', 4, NULL),
(12940, NULL, 'IPR008657', NULL, 'Jumping translocation breakpoint', 'JTB', 4, NULL),
(12941, NULL, 'IPR012102', NULL, 'Protoglobin', 'Protoglobin', 4, NULL),
(12942, NULL, 'IPR009777', NULL, 'Cell division protein ZapD', 'ZapD', 4, NULL),
(12943, NULL, 'IPR015300', NULL, 'DNA-binding pseudobarrel domain superfamily', 'DNA-bd_pseudobarrel_sf', 5, NULL),
(12944, NULL, 'IPR012826', NULL, 'Flagellar motor switch FliN', 'FliN', 4, NULL),
(12945, NULL, 'IPR012517', NULL, 'Lactocin 705', 'Antimicrobial14', 4, NULL),
(12946, NULL, 'IPR019740', NULL, 'Pyridoxamine 5''-phosphate oxidase, conserved site', 'Pyridox_Oxase_CS', 2, NULL),
(12947, NULL, 'IPR020115', NULL, 'Anti-sigma-F factor Fin', 'Fin', 4, NULL),
(12948, NULL, 'IPR024170', NULL, 'Aminoglycoside N6-acetyltransferase', 'Aminoglycoside_N6-AcTrfrase', 4, NULL),
(12949, NULL, 'IPR012822', NULL, 'Sucrose-phosphate synthase, glycosyltransferase domain', 'SucroseP_synth_GlycoTrfase_dom', 3, NULL),
(12950, NULL, 'IPR016045', NULL, 'Tyrosine-protein kinase, non-receptor, TYK2, N-terminal', 'Tyr_kinase_non-rcpt_TYK2_N', 3, NULL),
(12951, NULL, 'IPR012829', NULL, 'Phosphofructokinase, mixed-substrate PFK group III', 'Phosphofructokinase_III', 4, NULL),
(12952, NULL, 'IPR009236', NULL, 'Chordopoxvirus A13L', 'Chordopox_A13L', 4, NULL),
(12953, NULL, 'IPR020077', NULL, 'Protein of unknown function DUF5436', 'DUF5436', 4, NULL),
(12954, NULL, 'IPR012535', NULL, 'Cell division protein Cdc14', 'Cell_div_Cdc14', 4, NULL),
(12955, NULL, 'IPR024709', NULL, 'Putative O-fucosyltransferase, plant', 'FucosylTrfase_pln', 4, NULL),
(12956, NULL, 'IPR024175', NULL, 'Peptidase S1A, complement C1r/C1S/mannan-binding', 'Pept_S1A_C1r/C1S/mannan-bd', 4, NULL),
(12957, NULL, 'IPR013563', NULL, 'Oligopeptide/dipeptide ABC transporter, C-terminal', 'Oligopep_ABC_C', 3, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(12958, NULL, 'IPR012362', NULL, 'LytTR transmembrane transcriptional regulator, putative', 'LytTR_TM', 4, NULL),
(12959, NULL, 'IPR012506', NULL, 'Lysoplasmalogenase-like', 'TMEM86B-like', 4, NULL),
(12960, NULL, 'IPR012101', NULL, 'Biotinidase-like, eukaryotic', 'Biotinidase-like_euk', 4, NULL),
(12961, NULL, 'IPR012513', NULL, 'Metchnikowin', 'Mtk', 4, NULL),
(12962, NULL, 'IPR012824', NULL, 'Zinc chaperone CobW', 'CobW', 4, NULL),
(12963, NULL, 'IPR013641', NULL, 'Protein KTI12/L-seryl-tRNA(Sec) kinase', 'KTI12/PSTK', 4, NULL),
(12964, NULL, 'IPR015797', NULL, 'NUDIX hydrolase-like domain superfamily', 'NUDIX_hydrolase-like_dom_sf', 5, NULL),
(12965, NULL, 'IPR020117', NULL, 'Uncharacterised protein family YncJ', 'Uncharacterised_YncJ', 4, NULL),
(12966, NULL, 'IPR013554', NULL, 'Ribonucleotide reductase N-terminal', 'RNR_N', 3, NULL),
(12967, NULL, 'IPR013569', NULL, 'Carlavirus coat', 'Carlavirus_coat_N', 3, NULL),
(12968, NULL, 'IPR012526', NULL, 'Scorpion antimicrobial peptide', 'Antimicrobial_7', 4, NULL),
(12969, NULL, 'IPR008665', NULL, 'LRV FeS4 cluster', 'LRV_FeS', 3, NULL),
(12970, NULL, 'IPR012104', NULL, 'PHO85 cyclin 1/2/9', 'PHO85_cyclin_1/2/9', 4, NULL),
(12971, NULL, 'IPR014031', NULL, 'Beta-ketoacyl synthase, C-terminal', 'Ketoacyl_synth_C', 3, NULL),
(12972, NULL, 'IPR024166', NULL, 'Ribosomal RNA assembly KRR1', 'rRNA_assembly_KRR1', 4, NULL),
(12973, NULL, 'IPR012309', NULL, 'DNA ligase, ATP-dependent, C-terminal', 'DNA_ligase_ATP-dep_C', 3, NULL),
(12974, NULL, 'IPR034071', NULL, 'NF-kappaB-repression factor, R3H domain', 'R3H_NRF', 3, NULL),
(12975, NULL, 'IPR012190', NULL, 'Uncharacterised conserved protein UCP036698, YpmA', 'UCP036698', 4, NULL),
(12976, NULL, 'IPR009765', NULL, 'Pericardin-like repeat', 'Pericardin-like_rpt', 7, NULL),
(12977, NULL, 'IPR012488', NULL, 'Nodule-specific GRP-repeat', 'Nod_GRP', 7, NULL),
(12978, NULL, 'IPR031315', NULL, 'LNS2/PITP', 'LNS2/PITP', 3, NULL),
(12979, NULL, 'IPR011522', NULL, 'Thiamin/hydroxymethyl pyrimidine-binding YkoF, putative', 'Thiamin/HMP-bd_put_YkoF', 3, NULL),
(12980, NULL, 'IPR034417', NULL, 'Probable RNA-binding protein 19, RNA recognition motif 2', 'RMB19_RRM2', 3, NULL),
(12981, NULL, 'IPR012823', NULL, 'Flagellar export FliJ', 'Flagell_FliJ', 4, NULL),
(12982, NULL, 'IPR012090', NULL, 'Chromosome partition protein MukB', 'MukB', 4, NULL),
(12983, NULL, 'IPR019735', NULL, 'Synapsin, conserved site', 'Synapsin_CS', 2, NULL),
(12984, NULL, 'IPR011992', NULL, 'EF-hand domain pair', 'EF-hand-dom_pair', 5, NULL),
(12985, NULL, 'IPR009241', NULL, 'Toxin HigB-like', 'HigB-like', 4, NULL),
(12986, NULL, 'IPR012508', NULL, 'ATPase, A1 complex, epsilon subunit, archaeal', 'ATPase_A1-cplx_e-su', 4, NULL),
(12987, NULL, 'IPR017853', NULL, 'Glycoside hydrolase superfamily', 'Glycoside_hydrolase_SF', 5, NULL),
(12988, NULL, 'IPR035014', NULL, 'cGMP-dependent protein kinase, catalytic domain', 'STKc_cGK', 3, NULL),
(12989, NULL, 'IPR012099', NULL, 'Midasin', 'Midasin', 4, NULL),
(12990, NULL, 'IPR012515', NULL, 'Pleurocidin', 'Antimicrobial12', 4, NULL),
(12991, NULL, 'IPR017900', NULL, '4Fe-4S ferredoxin, iron-sulphur binding, conserved site', '4Fe4S_Fe_S_CS', 2, NULL),
(12992, NULL, 'IPR012096', NULL, 'ATPase, PP-loop, MJ1638-related', 'ATPase_PP-loop_MJ1638', 4, NULL),
(12993, NULL, 'IPR017855', NULL, 'SMAD-like domain superfamily', 'SMAD-like_dom_sf', 5, NULL),
(12994, NULL, 'IPR012189', NULL, 'Peptidase M28E, aminopeptidase AP1', 'Pept_M28E_Ap1', 4, NULL),
(12995, NULL, 'IPR020119', NULL, 'Pseudouridine synthase TruD, conserved site', 'PsdUridine_synth_TruD_CS', 2, NULL),
(12996, NULL, 'IPR012668', NULL, 'Conserved hypothetical protein CHP02466', 'CHP02466', 4, NULL),
(12997, NULL, 'IPR024172', NULL, 'Adenylyltransferase AadA/Aad9', 'AadA/Aad9', 4, NULL),
(12998, NULL, 'IPR008510', NULL, 'Protein of unknown function DUF792, Borrelia species', 'DUF792_BOR_spp', 4, NULL),
(12999, NULL, 'IPR011501', NULL, 'Nucleolar complex-associated protein 3, N-terminal', 'Noc3_N', 3, NULL),
(13000, NULL, 'IPR011495', NULL, 'Signal transduction histidine kinase, subgroup 2, dimerisation and phosphoacceptor domain', 'Sig_transdc_His_kin_sub2_dim/P', 3, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(13001, NULL, 'IPR008560', NULL, 'Protein of unknown function DUF842, eukaryotic', 'DUF842_euk', 4, NULL),
(13002, NULL, 'IPR012385', NULL, 'Prephenate dehydrogenase, fungal', 'Prephenate_DH_fun', 4, NULL),
(13003, NULL, 'IPR008520', NULL, 'Domain of unknown function DUF802', 'DUF802', 3, NULL),
(13004, NULL, 'IPR012373', NULL, 'Fe(2+)-dicitrate sensor, transmembrane component', 'Ferrdict_sens_TM', 4, NULL),
(13005, NULL, 'IPR015853', NULL, 'ABC transporter, ferric cation import, FbpC', 'ABC_transpr_FbpC', 3, NULL),
(13006, NULL, 'IPR014063', NULL, 'Arsenate resistance ArsH', 'Arsenate-R_ArsH', 4, NULL),
(13007, NULL, 'IPR015855', NULL, 'ABC transporter, maltose/maltodextrin import, MalK-like', 'ABC_transpr_MalK-like', 3, NULL),
(13008, NULL, 'IPR008569', NULL, 'Protein of unknown function DUF851', 'DUF851', 4, NULL),
(13009, NULL, 'IPR009816', NULL, 'Protein of unknown function DUF1387', 'DUF1387', 4, NULL),
(13010, NULL, 'IPR008550', NULL, 'Herpesvirus tegument protein BRRF2-like', 'Herpesvirus_BRRF2-like', 4, NULL),
(13011, NULL, 'IPR015312', NULL, 'Inner layer core protein VP3, Phytoreovirus', 'Innr_layr_core_VP3_Phytoreovir', 4, NULL),
(13012, NULL, 'IPR008700', NULL, 'RIN4, pathogenic type III effector avirulence factor Avr cleavage site', 'TypeIII_avirulence_cleave', 3, NULL),
(13013, NULL, 'IPR014729', NULL, 'Rossmann-like alpha/beta/alpha sandwich fold', 'Rossmann-like_a/b/a_fold', 5, NULL),
(13014, NULL, 'IPR009819', NULL, 'Pes-10', 'Pes-10', 4, NULL),
(13015, NULL, 'IPR011797', NULL, 'Mercuric resistence transcriptional repressor protein MerD', 'MerD', 4, NULL),
(13016, NULL, 'IPR011981', NULL, '3,4-dihydroxyphenylacetate 2,3-dioxygenase, Mn/Fe-type', 'DHPA_dOase_Mn/Fe', 4, NULL),
(13017, NULL, 'IPR014920', NULL, 'Nuclear receptor coactivator, Ncoa-type, interlocking', 'Nuc_rcpt_coact_Ncoa-typ', 3, NULL),
(13018, NULL, 'IPR012386', NULL, '2'',3''-cyclic-nucleotide 3''-phosphodiesterase', 'Cyclic-nucl_3Pdiesterase', 4, NULL),
(13019, NULL, 'IPR024254', NULL, 'MJ0366-like', 'MJ0366-like', 4, NULL),
(13020, NULL, 'IPR008566', NULL, 'Gammaherpesvirus protein of unknown function DUF848', 'DUF848', 4, NULL),
(13021, NULL, 'IPR013270', NULL, 'CD47 immunoglobulin-like', 'CD47_Vset', 3, NULL),
(13022, NULL, 'IPR014879', NULL, 'Sporulation initiation factor Spo0A, C-terminal', 'Spo0A_C', 3, NULL),
(13023, NULL, 'IPR014918', NULL, 'Phage tail tube protein 3', 'Phage_tail_3', 4, NULL),
(13024, NULL, 'IPR012914', NULL, 'Purine catabolism PurC-like domain', 'PucR_dom', 3, NULL),
(13025, NULL, 'IPR008718', NULL, 'NolX', 'NolX', 4, NULL),
(13026, NULL, 'IPR014914', NULL, 'RES domain', 'RES_dom', 3, NULL),
(13027, NULL, 'IPR012302', NULL, 'Malic enzyme, NAD-binding', 'Malic_NAD-bd', 3, NULL),
(13028, NULL, 'IPR014895', NULL, 'Alginate lyase 2', 'Alginate_lyase_2', 3, NULL),
(13029, NULL, 'IPR012393', NULL, 'Tricorn protease', 'Tricorn_protease', 4, NULL),
(13030, NULL, 'IPR011803', NULL, 'Adenylylsulphate reductase, alpha subunit', 'AprA', 4, NULL),
(13031, NULL, 'IPR008692', NULL, 'Haemagglutinin, Mycoplasma', 'Hemogglutn_Mycoplasma', 3, NULL),
(13032, NULL, 'IPR008535', NULL, 'Protein of unknown function DUF817', 'DUF817', 4, NULL),
(13033, NULL, 'IPR008702', NULL, 'Nucleopolyhedrovirus P10', 'NPV_P10', 4, NULL),
(13034, NULL, 'IPR008542', NULL, 'Bacterial Immunoglobulin-like 21', 'BIg21', 3, NULL),
(13035, NULL, 'IPR034425', NULL, 'GRSF-1, RNA recognition motif 1', 'GRSF1_RRM1', 3, NULL),
(13036, NULL, 'IPR015306', NULL, 'Restriction endonuclease, type II, PvuII', 'Restrct_endonuc_II_PvuII', 4, NULL),
(13037, NULL, 'IPR012410', NULL, 'Nucleoside-diphosphate kinase-like NDK-H5', 'NDK_H5', 4, NULL),
(13038, NULL, 'IPR014871', NULL, 'dUTPase/dCTP pyrophosphatase', 'dUTPase/dCTP_pyrophosphatase', 4, NULL),
(13039, NULL, 'IPR009842', NULL, 'Protein of unknown function DUF1402', 'DUF1402', 4, NULL),
(13040, NULL, 'IPR034427', NULL, 'ESRP1, RNA recognition motif 1', 'ESRP1_RRM1', 3, NULL),
(13041, NULL, 'IPR014855', NULL, 'Plant transcription factor NOZZLE', 'NOZZLE', 4, NULL),
(13042, NULL, 'IPR015304', NULL, 'ZinT domain', 'ZinT_dom', 3, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(13043, NULL, 'IPR008527', NULL, 'Protein of unknown function DUF809', 'DUF809', 4, NULL),
(13044, NULL, 'IPR012905', NULL, 'PA-IL-like', 'PA-IL', 4, NULL),
(13045, NULL, 'IPR008689', NULL, 'ATP synthase, F0 complex, subunit D, mitochondrial', 'ATP_synth_F0_dsu_mt', 4, NULL),
(13046, NULL, 'IPR012904', NULL, '8-oxoguanine DNA glycosylase, N-terminal', 'OGG_N', 3, NULL),
(13047, NULL, 'IPR009801', NULL, 'Transmembrane protein 126', 'TMEM126', 4, NULL),
(13048, NULL, 'IPR008540', NULL, 'BES1/BZR1 plant transcription factor, N-terminal', 'BES1_N', 3, NULL),
(13049, NULL, 'IPR009795', NULL, 'Protein of unknown function DUF1363', 'DUF1363', 4, NULL),
(13050, NULL, 'IPR009829', NULL, 'Spindle and kinetochore-associated protein 1', 'SKA1', 4, NULL),
(13051, NULL, 'IPR011320', NULL, 'Ribonuclease H1, N-terminal', 'RNase_H1_N', 3, NULL),
(13052, NULL, 'IPR015310', NULL, 'Activator of Hsp90 ATPase, N-terminal', 'AHSA1_N', 3, NULL),
(13053, NULL, 'IPR024252', NULL, 'Protein of unknown function DUF2528', 'DUF2528', 4, NULL),
(13054, NULL, 'IPR014911', NULL, 'Type 4 secretion system, PilS, N-terminal', 'PilS_N', 3, NULL),
(13055, NULL, 'IPR014056', NULL, 'Addiction module killer protein, predicted', 'Addiction_killer_pred', 4, NULL),
(13056, NULL, 'IPR014074', NULL, 'Carboxysome shell carbonic anhydrase', 'Carboxysome_shell_carb_anhy', 4, NULL),
(13057, NULL, 'IPR012911', NULL, 'Protein serine/threonine phosphatase 2C, C-terminal', 'PP2C_C', 3, NULL),
(13058, NULL, 'IPR012906', NULL, 'PaaX-like, N-terminal', 'PaaX-like_N', 3, NULL),
(13059, NULL, 'IPR014060', NULL, 'Alkaline phosphatase-like protein PglZ', 'PglZ', 4, NULL),
(13060, NULL, 'IPR008703', NULL, 'Na(+)-translocating NADH-quinone reductase subunit A', 'NqrA', 4, NULL),
(13061, NULL, 'IPR024290', NULL, 'Schizont-infected cell agglutination, extracellular alpha domain', 'SICA_extracell_a', 3, NULL),
(13062, NULL, 'IPR014858', NULL, 'BREX protein BrxB', 'BrxB', 4, NULL),
(13063, NULL, 'IPR013793', NULL, 'Porin, Gram-negative type, conserved site', 'Porin_Gram-ve_CS', 2, NULL),
(13064, NULL, 'IPR009792', NULL, 'Transmembrane protein 242', 'TMEM242', 4, NULL),
(13065, NULL, 'IPR013268', NULL, 'U3 snoRNA associated', 'U3_snoRNA_assoc', 4, NULL),
(13066, NULL, 'IPR012888', NULL, 'L-fucose isomerase, N-terminal-1', 'Fucose_iso_N1', 3, NULL),
(13067, NULL, 'IPR009805', NULL, 'Variable length PCR target', 'Variable_length_PCR_target', 7, NULL),
(13068, NULL, 'IPR034420', NULL, 'Probable RNA-binding protein 19, RNA recognition motif 4', 'RBM19_RRM4', 3, NULL),
(13069, NULL, 'IPR011249', NULL, 'Metalloenzyme, LuxS/M16 peptidase-like', 'Metalloenz_LuxS/M16', 5, NULL),
(13070, NULL, 'IPR015316', NULL, 'Ste50, sterile alpha motif', 'SAM_Ste50', 3, NULL),
(13071, NULL, 'IPR014873', NULL, 'Voltage-dependent calcium channel, alpha-1 subunit, IQ domain', 'VDCC_a1su_IQ', 3, NULL),
(13072, NULL, 'IPR009827', NULL, 'Dicarboxylate carrier MatC N-terminal', 'MatC_N', 3, NULL),
(13073, NULL, 'IPR015305', NULL, 'Protein of unknown function DUF1961', 'DUF1961', 4, NULL),
(13074, NULL, 'IPR011979', NULL, 'Antitoxin Xre', 'Antitox_Xre', 4, NULL),
(13075, NULL, 'IPR011983', NULL, '4-hydroxyphenylacetate catabolism regulatory protein HpaA', 'HpaA_TReg', 4, NULL),
(13076, NULL, 'IPR034014', NULL, 'Pol III subunit C11, C-terminal zinc ribbon', 'Zn_ribbon_RPC11_C', 3, NULL),
(13077, NULL, 'IPR012301', NULL, 'Malic enzyme, N-terminal domain', 'Malic_N_dom', 3, NULL),
(13078, NULL, 'IPR011807', NULL, 'Exosome complex component Rrp41', 'Rrp41', 4, NULL),
(13079, NULL, 'IPR015320', NULL, 'DNA topoisomerase VI, subunit B, transducer', 'TopoVI_B_transducer', 3, NULL),
(13080, NULL, 'IPR011786', NULL, 'Sulphite reductase (NADPH) hemoprotein, beta subunit', 'CysI', 4, NULL),
(13081, NULL, 'IPR012415', NULL, 'Restriction endonuclease, type II, Cfr10I/Bse634I', 'Restrct_endonuc_II_Cfr10I', 4, NULL),
(13082, NULL, 'IPR015356', NULL, 'Pertussis toxin, subunit S5', 'Pertussis_toxin_subS5', 4, NULL),
(13083, NULL, 'IPR009796', NULL, 'Protein of unknown function DUF1366', 'DUF1366', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(13084, NULL, 'IPR012389', NULL, 'Cyclin P/U', 'Cyclin_P/U', 4, NULL),
(13085, NULL, 'IPR011800', NULL, 'Phosphoadenosine phosphosulphate reductase CysH', 'PAPS_reductase_CysH', 4, NULL),
(13086, NULL, 'IPR011808', NULL, 'Sulphite reductase, dissimilatory-type beta subunit', 'DsrB', 4, NULL),
(13087, NULL, 'IPR014730', NULL, 'Electron transfer flavoprotein, alpha/beta-subunit, N-terminal', 'ETF_a/b_N', 3, NULL),
(13088, NULL, 'IPR013256', NULL, 'Chromatin SPT2', 'Chromatin_SPT2', 4, NULL),
(13089, NULL, 'IPR015345', NULL, 'Cytokinin dehydrogenase 1, FAD/cytokinin binding domain', 'Cytokinin_DH_FAD/cytokin-bd', 3, NULL),
(13090, NULL, 'IPR012374', NULL, 'Co/Fe-chelatase, CbiX-related', 'CbiX-rel', 4, NULL),
(13091, NULL, 'IPR008565', NULL, 'TtsA-like, Glycoside hydrolase family 108 domain', 'TtsA-like_GH18_dom', 3, NULL),
(13092, NULL, 'IPR014908', NULL, 'Nucleoporin, Nup133/Nup155-like, N-terminal', 'Nucleoporin_Nup133/Nup155_N', 3, NULL),
(13093, NULL, 'IPR008567', NULL, '3-keto-5-aminohexanoate cleavage enzyme', 'KCE_family', 4, NULL),
(13094, NULL, 'IPR015351', NULL, 'RBP-J/Cbf11/Cbf12, DNA binding', 'RBP-J/Cbf11/Cbf12_DNA-bd', 3, NULL),
(13095, NULL, 'IPR012395', NULL, 'IGFBP-related, CNN', 'IGFBP_CNN', 4, NULL),
(13096, NULL, 'IPR012399', NULL, 'Cyclin Y', 'Cyclin_Y', 4, NULL),
(13097, NULL, 'IPR014078', NULL, 'Nucleoside triphosphatase YtkD', 'Nudix_YtkD', 4, NULL),
(13098, NULL, 'IPR012896', NULL, 'Integrin beta subunit, tail', 'Integrin_bsu_tail', 3, NULL),
(13099, NULL, 'IPR011774', NULL, 'Geranylgeranyl reductase, plant/cyanobacteria', 'Geranylgeranyl_Rdtase_pln/cyn', 4, NULL),
(13100, NULL, 'IPR014058', NULL, 'Pteridine reductase', 'Pteridine_reductase', 4, NULL),
(13101, NULL, 'IPR014903', NULL, 'Protein of unknown function DUF1796', 'DUF1796', 4, NULL),
(13102, NULL, 'IPR011783', NULL, 'Peptidase S1C, DegS', 'Pept_S1C_DegS', 4, NULL),
(13103, NULL, 'IPR013255', NULL, 'Chromosome segregation protein Spc25, C-terminal', 'Spc25_C', 3, NULL),
(13104, NULL, 'IPR015334', NULL, 'FokI,  cleavage domain', 'FokI_cleavage_dom', 3, NULL),
(13105, NULL, 'IPR015355', NULL, 'Pertussis toxin, subunit S4', 'Pertussis_toxin_subS4', 4, NULL),
(13106, NULL, 'IPR011805', NULL, 'Ribonuclease R', 'RNase_R', 4, NULL),
(13107, NULL, 'IPR012432', NULL, 'Protein of unknown function DUF1627', 'DUF1627', 4, NULL),
(13108, NULL, 'IPR014877', NULL, 'Exportin-1, C-terminal', 'XPO1_C_dom', 3, NULL),
(13109, NULL, 'IPR008524', NULL, 'Protein of unknown function DUF806', 'DUF806', 4, NULL),
(13110, NULL, 'IPR011799', NULL, 'Chlorophyll synthase, ChlG', 'ChlG', 4, NULL),
(13111, NULL, 'IPR008557', NULL, 'Alkaline phosphatase PhoX', 'PhoX', 4, NULL),
(13112, NULL, 'IPR014904', NULL, 'YkuJ-like', 'YkuJ-like', 4, NULL),
(13113, NULL, 'IPR009808', NULL, 'Protein of unknown function, DUF1378', 'DUF1378', 4, NULL),
(13114, NULL, 'IPR015311', NULL, 'DNA fragmentation factor 40, C-terminal', 'DFF40_C', 3, NULL),
(13115, NULL, 'IPR013264', NULL, 'DNA primase, catalytic core, N-terminal', 'DNA_primase_core_N', 3, NULL),
(13116, NULL, 'IPR012381', NULL, 'Ethanolamine/propanediol utilisation protein, EutP/PduV', 'EutP_PduV', 4, NULL),
(13117, NULL, 'IPR008711', NULL, 'Recombinase NinB', 'Recombinase_NinB', 4, NULL),
(13118, NULL, 'IPR011976', NULL, 'Peptidase M3B, oligoendopeptidase-related', 'Pept_M3B_oligopep-rel', 4, NULL),
(13119, NULL, 'IPR014062', NULL, 'Arsenate reductase, glutathione/glutaredoxin type', 'Arsenate_reductase_gluta', 4, NULL),
(13120, NULL, 'IPR015337', NULL, 'BCMA, TALL-1 binding', 'BCMA_Tall-1-bd', 3, NULL),
(13121, NULL, 'IPR009791', NULL, 'Protein of unknown function DUF1357', 'DUF1357', 4, NULL),
(13122, NULL, 'IPR009812', NULL, 'Protein of unknown function DUF1381', 'DUF1381', 4, NULL),
(13123, NULL, 'IPR014072', NULL, 'Archaeoflavoprotein AfpA', 'Archaeoflavo_AfpA', 4, NULL),
(13124, NULL, 'IPR011978', NULL, 'YgfB-like', 'YgfB-like', 4, NULL),
(13125, NULL, 'IPR009784', NULL, 'Protein of unknown function DUF1349', 'DUF1349', 4, NULL),
(13126, NULL, 'IPR015354', NULL, 'DNA partition complex, ParG', 'DNA_partition_ParG', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(13127, NULL, 'IPR009824', NULL, 'Protein of unknown function DUF1392', 'DUF1392', 4, NULL),
(13128, NULL, 'IPR024108', NULL, 'Tyrosine-tRNA ligase, bacterial-type, type 2', 'Tyr-tRNA-ligase_bac_2', 4, NULL),
(13129, NULL, 'IPR015866', NULL, 'Serine-tRNA synthetase, type1, N-terminal', 'Ser-tRNA-synth_1_N', 3, NULL),
(13130, NULL, 'IPR009799', NULL, 'EthD domain', 'EthD_dom', 3, NULL),
(13131, NULL, 'IPR024227', NULL, 'Protein of unknown function DUF3795', 'DUF3795', 4, NULL),
(13132, NULL, 'IPR014067', NULL, 'Arsenite oxidase subunit AioB/Iodate reductase subunit IdrB, small subunit', 'AioB/IdrB_ssu', 4, NULL),
(13133, NULL, 'IPR014876', NULL, 'DEK, C-terminal', 'DEK_C', 3, NULL),
(13134, NULL, 'IPR011775', NULL, 'Magnesium chelatase, ATPase subunit I', 'Mg_chelatase_ATPase-isu', 4, NULL),
(13135, NULL, 'IPR011812', NULL, 'Biosynthetic peptidoglycan transglycosylase', 'Pep_trsgly', 4, NULL),
(13136, NULL, 'IPR014875', NULL, 'Mor transcription activator', 'Mor_transcription_activator', 3, NULL),
(13137, NULL, 'IPR011789', NULL, 'Cu(I)-responsive transcriptional regulator', 'CueR', 4, NULL),
(13138, NULL, 'IPR012404', NULL, 'Nucleotide-sugar transporter-related', 'UCP036436', 4, NULL),
(13139, NULL, 'IPR024182', NULL, 'Vaccinia virus A55R', 'Vaccinia_A55R', 4, NULL),
(13140, NULL, 'IPR012882', NULL, 'Putative redox protein Fmp46', 'Fmp46', 4, NULL),
(13141, NULL, 'IPR011791', NULL, 'Cd(II)/Pb(II)-responsive transcriptional regulator', 'CadR-PbrR', 4, NULL),
(13142, NULL, 'IPR011806', NULL, 'Sulphite reductase, dissimilatory-type alpha subunit', 'DsrA', 4, NULL),
(13143, NULL, 'IPR011817', NULL, 'Uridylate kinase', 'Uridylate_kinase', 4, NULL),
(13144, NULL, 'IPR011977', NULL, 'Peptidase M3B, oligoendopeptidase-related clade 3', 'Pept_M3B_clade3', 4, NULL),
(13145, NULL, 'IPR014069', NULL, 'Guanosine pentaphosphate synthetase I/polyribonucleotide nucleotidyltransferase', 'GPSI/PNP', 4, NULL),
(13146, NULL, 'IPR009834', NULL, 'Ureide permease', 'Ureide_permease', 4, NULL),
(13147, NULL, 'IPR034424', NULL, 'GRSF-1, RNA recognition motif 2', 'GRSF-1_RRM2', 3, NULL),
(13148, NULL, 'IPR008536', NULL, 'Protein of unknown function DUF818', 'DUF818', 4, NULL),
(13149, NULL, 'IPR014883', NULL, 'VRR-NUC domain', 'VRR_NUC', 3, NULL),
(13150, NULL, 'IPR008552', NULL, 'Domain of unknown function DUF834', 'DUF834', 3, NULL),
(13151, NULL, 'IPR015323', NULL, 'Flavocytochrome c sulphide dehydrogenase, flavin-binding', 'FlavoCytC_S_DH_flav-bd', 3, NULL),
(13152, NULL, 'IPR014896', NULL, 'NHR2-like', 'NHR2', 3, NULL),
(13153, NULL, 'IPR014910', NULL, 'Putative monooxygenase YdhR', 'YdhR', 4, NULL),
(13154, NULL, 'IPR012890', NULL, 'Intron Large complex component GCFC2-like', 'GCFC2-like', 4, NULL),
(13155, NULL, 'IPR014068', NULL, 'Azurin', 'Azurin', 4, NULL),
(13156, NULL, 'IPR015314', NULL, 'Restriction endonuclease, type II, EcoRV', 'Restrct_endonuc_II_EcoRV', 4, NULL),
(13157, NULL, 'IPR034423', NULL, 'Probable RNA-binding protein 19, RNA recognition motif 5', 'RBM19_RRM5', 3, NULL),
(13158, NULL, 'IPR014915', NULL, 'Bacteriophage TLS, TfmB', 'Phage_TLS_TfmB', 4, NULL),
(13159, NULL, 'IPR043704', NULL, 'Tail assembly protein GT', 'Tail_assembly_GT', 4, NULL),
(13160, NULL, 'IPR015341', NULL, 'Glycoside hydrolase family 38, central domain', 'Glyco_hydro_38_cen', 3, NULL),
(13161, NULL, 'IPR008523', NULL, 'Protein of unknown function DUF805', 'DUF805', 4, NULL),
(13162, NULL, 'IPR014900', NULL, 'Viral late gene transcription factor 3 , zinc ribbon', 'VLTF-3_Zn_ribbon', 3, NULL),
(13163, NULL, 'IPR012286', NULL, 'Tetrahaem cytochrome domain', 'Tetrahaem_cytochrome', 3, NULL),
(13164, NULL, 'IPR008534', NULL, 'Baculovirus protein of unknown function DUF816', 'DUF816', 4, NULL),
(13165, NULL, 'IPR014070', NULL, 'Wolbachia palindromic element (WPE)', 'WPE_wolbac', 3, NULL),
(13166, NULL, 'IPR015326', NULL, 'Mycoplasma arthritidis-derived mitogen', 'M_arthritidis-der_mitogen', 4, NULL),
(13167, NULL, 'IPR012429', NULL, 'Heparan-alpha-glucosaminide N-acetyltransferase, catalytic domain', 'HGSNAT_cat', 3, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(13168, NULL, 'IPR014872', NULL, 'Dicistrovirus, capsid-polyprotein, C-terminal', 'Dicistrovirus_capsid-polyPr_C', 3, NULL),
(13169, NULL, 'IPR014868', NULL, 'Cadherin prodomain', 'Cadherin_pro_dom', 3, NULL),
(13170, NULL, 'IPR014880', NULL, 'Sulphur oxidation protein SoxZ', 'SoxZ_dom', 3, NULL),
(13171, NULL, 'IPR011792', NULL, 'Glutamate--cysteine ligase, putative', 'GshA_cyano', 4, NULL),
(13172, NULL, 'IPR014867', NULL, 'Spore coat protein CotH/Invasin CotH2/3/7', 'Spore_coat_CotH_CotH2/3/7', 4, NULL),
(13173, NULL, 'IPR008543', NULL, 'Uncharacterised protein family Ycf2', 'Uncharacterised_Ycf2', 4, NULL),
(13174, NULL, 'IPR012427', NULL, 'Protein of unknown function DUF1622', 'DUF1622', 4, NULL),
(13175, NULL, 'IPR013253', NULL, 'Spc7 kinetochore protein domain', 'Spc7_domain', 3, NULL),
(13176, NULL, 'IPR012405', NULL, 'LytTR stand-alone protein', 'LyTR_stand-alone', 4, NULL),
(13177, NULL, 'IPR009810', NULL, 'Late nodulin', 'Nodulin_late', 4, NULL),
(13178, NULL, 'IPR009811', NULL, 'Protein of unknown function DUF1380', 'DUF1380', 4, NULL),
(13179, NULL, 'IPR014065', NULL, 'tRNA adenylyltransferase', 'tRNA_adenylyltransferase', 4, NULL),
(13180, NULL, 'IPR011809', NULL, 'Histidinol-phosphate phosphatase, putative, inositol monophosphatase', 'His_9_proposed', 4, NULL),
(13181, NULL, 'IPR008709', NULL, 'Neurochondrin', 'Neurochondrin', 4, NULL),
(13182, NULL, 'IPR008712', NULL, 'NinF', 'NinF', 4, NULL),
(13183, NULL, 'IPR008559', NULL, 'Calcium load-activated calcium channel', 'TMCO1', 4, NULL),
(13184, NULL, 'IPR012400', NULL, 'Long-chain-alcohol oxidase', 'Long_Oxdase', 4, NULL),
(13185, NULL, 'IPR011778', NULL, 'Hydantoinase/dihydropyrimidinase', 'Hydantoinase/dihydroPyrase', 4, NULL),
(13186, NULL, 'IPR014856', NULL, 'RNA-free ribonuclease P', 'RNA_free_RNase_P', 4, NULL),
(13187, NULL, 'IPR011813', NULL, 'Penicillin-binding protein 1B', 'PBP_1b', 4, NULL),
(13188, NULL, 'IPR011252', NULL, 'Fibrogen-binding domain 1', 'Fibrogen-bd_dom1', 5, NULL),
(13189, NULL, 'IPR012430', NULL, 'Transmembrane protein 43 family', 'TMEM43_fam', 4, NULL),
(13190, NULL, 'IPR009815', NULL, 'Baculovirus protein AC11', 'AcMNPV_AC11', 4, NULL),
(13191, NULL, 'IPR008561', NULL, 'Protein Ac76, baculovirus', 'Ac76_baculovir', 4, NULL),
(13192, NULL, 'IPR014913', NULL, 'YppE-like', 'YppE-like', 4, NULL),
(13193, NULL, 'IPR013261', NULL, 'Mitochondrial import inner membrane translocase subunit Tim21', 'Tim21', 4, NULL),
(13194, NULL, 'IPR013787', NULL, 'S100/CaBP-9k-type, calcium binding, subdomain', 'S100_Ca-bd_sub', 3, NULL),
(13195, NULL, 'IPR012425', NULL, 'DmpG-like communication', 'DmpG_comm', 3, NULL),
(13196, NULL, 'IPR009814', NULL, 'Bacteriophage lambda, Xis (Q38267)', 'Phage_lambda_Xis_Q38267', 4, NULL),
(13197, NULL, 'IPR009809', NULL, 'Cell division protein ZapC', 'ZapC', 4, NULL),
(13198, NULL, 'IPR015343', NULL, 'Peroxisome biogenesis factor 1, N-terminal, alpha/beta', 'PEX-N_a/b', 3, NULL),
(13199, NULL, 'IPR011804', NULL, 'Ribonuclease II', 'RNase_II', 4, NULL),
(13200, NULL, 'IPR024699', NULL, 'Acetoin utilization protein AcuA', 'AcuA', 4, NULL),
(13201, NULL, 'IPR008706', NULL, 'Nanovirus component 8', 'Nanovirus_C8', 4, NULL),
(13202, NULL, 'IPR013317', NULL, 'Chromosomal replication initiator protein DnaA', 'DnaA', 3, NULL),
(13203, NULL, 'IPR015325', NULL, 'Sucrose phosphorylase, C-terminal', 'Suc_Porlyase_C', 3, NULL),
(13204, NULL, 'IPR015329', NULL, 'tRNA nucleotidyltransferase, substrate binding', 'tRNA_NucTransf2', 3, NULL),
(13205, NULL, 'IPR012909', NULL, 'PHA accumulation regulator DNA-binding, N-terminal', 'PHA_DNA-bd_N', 3, NULL),
(13206, NULL, 'IPR012893', NULL, 'HipA-like, C-terminal', 'HipA-like_C', 3, NULL),
(13207, NULL, 'IPR015332', NULL, 'Major allergen I polypeptide chain 2-like', 'CH2-like', 4, NULL),
(13208, NULL, 'IPR008554', NULL, 'Glutaredoxin-like', 'Glutaredoxin-like', 4, NULL),
(13209, NULL, 'IPR012387', NULL, 'tRNA ligase Trl1, fungi', 'Trl1_fun', 4, NULL),
(13210, NULL, 'IPR009806', NULL, 'Photosystem II PsbW, class 2', 'PSII_PsbW_class2', 4, NULL),
(13211, NULL, 'IPR009846', NULL, 'Splicing factor 3B subunit 5/RDS3 complex subunit 10', 'SF3b5/RDS3-10', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(13212, NULL, 'IPR014061', NULL, 'Lon-like protease BrxL-like', 'BrxL-like', 4, NULL),
(13213, NULL, 'IPR024228', NULL, 'Regulatory protein NPR, central domain', 'NPR_central_dom', 3, NULL),
(13214, NULL, 'IPR008707', NULL, 'PilC beta-propeller domain', 'PilC_beta_prop_dom', 3, NULL),
(13215, NULL, 'IPR012409', NULL, 'Sirohaem synthase', 'Sirohaem_synth', 4, NULL),
(13216, NULL, 'IPR014890', NULL, 'c-SKI SMAD4-binding domain', 'c-SKI_SMAD4-bd_dom', 3, NULL),
(13217, NULL, 'IPR012408', NULL, 'Acetaldehyde/propionaldehyde dehydrogenase, EutE/PduP-related', 'Acetald_propionald_DH-rel', 4, NULL),
(13218, NULL, 'IPR009821', NULL, 'Protein of unknown function DUF1391', 'DUF1391', 4, NULL),
(13219, NULL, 'IPR034421', NULL, 'Probable RNA-binding protein 19, RNA recognition motif 6', 'RBM19_RRM6', 3, NULL),
(13220, NULL, 'IPR009823', NULL, 'Herpesvirus SORF3', 'Herpes_SORF3', 4, NULL),
(13221, NULL, 'IPR014024', NULL, 'Auxin efflux carrier, plant type', 'Auxin_eff_plant', 4, NULL),
(13222, NULL, 'IPR013258', NULL, 'Striatin, N-terminal', 'Striatin_N', 3, NULL),
(13223, NULL, 'IPR014854', NULL, 'Non-structural maintenance of chromosome element 4, C-terminal', 'Nse4_C', 3, NULL),
(13224, NULL, 'IPR014912', NULL, 'Selenoprotein F/M domain', 'Sep15_SelM_dom', 3, NULL),
(13225, NULL, 'IPR011780', NULL, 'D-serine ammonia-lyase', 'D_Ser_am_lyase', 4, NULL),
(13226, NULL, 'IPR014859', NULL, 'Phage tail assembly chaperone', 'Phage_TAC_4', 4, NULL),
(13227, NULL, 'IPR014077', NULL, 'Carboxysome shell vertex protein CsoS4B', 'CsoS4B', 4, NULL),
(13228, NULL, 'IPR013263', NULL, 'DNA topoisomerase I, zinc ribbon-like, bacterial-type', 'TopoI_Znr_bac', 3, NULL),
(13229, NULL, 'IPR014906', NULL, 'Pre-mRNA processing factor 4 (PRP4)-like', 'PRP4-like', 3, NULL),
(13230, NULL, 'IPR008551', NULL, 'Transport and Golgi organisation protein 2', 'TANGO2', 4, NULL),
(13231, NULL, 'IPR011993', NULL, 'PH-like domain superfamily', 'PH-like_dom_sf', 5, NULL),
(13232, NULL, 'IPR009828', NULL, 'CYRIA/CYRIB, Rac1 binding domain', 'CYRIA/CYRIB_Rac1-bd', 3, NULL),
(13233, NULL, 'IPR013573', NULL, 'Transcription regulator YcdC, C-terminal', 'Tscrpt_reg_YcdC_C', 3, NULL),
(13234, NULL, 'IPR015317', NULL, 'Alpha-haemoglobin stabilising protein', 'A_Hb_stabilising_prot', 4, NULL),
(13235, NULL, 'IPR012892', NULL, 'Gp58-like', 'Gp58', 3, NULL),
(13236, NULL, 'IPR008519', NULL, 'Tandem-repeating region of mucin, epiglycanin-like', 'Tandem-repeating_mucin', 3, NULL),
(13237, NULL, 'IPR015302', NULL, 'Major coat protein, L-A virus', 'Major_coat_LA-virus', 3, NULL),
(13238, NULL, 'IPR012390', NULL, 'Phosphoesterase SP1827', 'Pesterase_SP1827', 4, NULL),
(13239, NULL, 'IPR011802', NULL, 'Adenylylsulphate reductase, beta subunit', 'AprB', 4, NULL),
(13240, NULL, 'IPR014882', NULL, 'Cathepsin C exclusion', 'CathepsinC_exc', 3, NULL),
(13241, NULL, 'IPR009818', NULL, 'Ataxin-2, C-terminal', 'Ataxin-2_C', 3, NULL),
(13242, NULL, 'IPR014874', NULL, 'Staphylocoagulase, N-terminal, subdomain 1', 'Staphylocoagulase_N', 3, NULL),
(13243, NULL, 'IPR009837', NULL, 'Matrix extracellular phosphoglycoprotein', 'MEPE', 4, NULL),
(13244, NULL, 'IPR034426', NULL, 'GRSF-1, RNA recognition motif 3', 'GRSF1_RRM3', 3, NULL),
(13245, NULL, 'IPR011250', NULL, 'Outer membrane protein/outer membrane enzyme PagP,  beta-barrel', 'OMP/PagP_b-brl', 5, NULL),
(13246, NULL, 'IPR015315', NULL, 'Protein of unknown function DUF1963', 'DUF1963', 4, NULL),
(13247, NULL, 'IPR009787', NULL, 'Protein jagunal', 'Jagunal', 4, NULL),
(13248, NULL, 'IPR015324', NULL, 'Ribosomal protein Rsm22-like', 'Ribosomal_Rsm22-like', 4, NULL),
(13249, NULL, 'IPR015353', NULL, 'Rubisco LSMT, substrate-binding domain', 'Rubisco_LSMT_subst-bd', 3, NULL),
(13250, NULL, 'IPR009786', NULL, 'Spot 14 family', 'Spot_14', 4, NULL),
(13251, NULL, 'IPR012899', NULL, 'LTXXQ motif family protein', 'LTXXQ', 4, NULL),
(13252, NULL, 'IPR011818', NULL, 'Uridylate kinase, archaeal/spirochete, putative', 'Uridylate_kinase_arch/spir', 4, NULL),
(13253, NULL, 'IPR014916', NULL, 'Kinase associated protein B', 'KapB', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(13254, NULL, 'IPR008528', NULL, 'Protein unc-13 homologue', 'unc-13_homologue', 4, NULL),
(13255, NULL, 'IPR008521', NULL, 'Magnesium transporter NIPA', 'Mg_trans_NIPA', 4, NULL),
(13256, NULL, 'IPR012290', NULL, 'Fibrinogen, alpha/beta/gamma chain, coiled coil domain', 'Fibrinogen_a/b/g_coil_dom', 3, NULL),
(13257, NULL, 'IPR008537', NULL, 'Protein of unknown function DUF819', 'DUF819', 4, NULL),
(13258, NULL, 'IPR009844', NULL, 'Protein of unknown function DUF1404', 'DUF1404', 4, NULL),
(13259, NULL, 'IPR008704', NULL, 'Zinc-binding loop region of homing endonuclease', 'Endonuclease_Zinc-binding_loop', 3, NULL),
(13260, NULL, 'IPR015303', NULL, 'Fimbrial adhesin F17-AG, lectin domain', 'Fimbrial_adhesin_lectin_dom', 3, NULL),
(13261, NULL, 'IPR034030', NULL, 'Salivary gland reprolysin domain', 'ZnMc_salivary_gland_MPs', 3, NULL),
(13262, NULL, 'IPR015348', NULL, 'Clathrin, heavy chain, linker, core motif', 'Clathrin_H-chain_linker_core', 3, NULL),
(13263, NULL, 'IPR009832', NULL, 'Protein of unknown function DUF1397', 'DUF1397', 4, NULL),
(13264, NULL, 'IPR012433', NULL, 'Protein of unknown function DUF1629', 'DUF1629', 4, NULL),
(13265, NULL, 'IPR014905', NULL, 'HIRAN domain', 'HIRAN', 3, NULL),
(13266, NULL, 'IPR014071', NULL, 'Copper transport repressor CopY/TcrY', 'Cu_transp_CopY/TcrY', 4, NULL),
(13267, NULL, 'IPR012422', NULL, 'Cytochrome c oxidase, subunit IV, bacterial aa3 type', 'Cyt_c_oxidase_su4_bac-aa3', 3, NULL),
(13268, NULL, 'IPR009839', NULL, 'SseB protein N-terminal domain', 'SseB_N', 3, NULL),
(13269, NULL, 'IPR011776', NULL, 'Magnesium chelatase, ATPase subunit D', 'Mg_chelatase_ATPase-dsu', 4, NULL),
(13270, NULL, 'IPR013265', NULL, 'TRI9, Fusarium species', 'TRI9_FUSspp', 4, NULL),
(13271, NULL, 'IPR012391', NULL, 'Serine/threonine protein phosphatase, BSU1', 'Ser/Thr_prot_Pase_BSU1', 4, NULL),
(13272, NULL, 'IPR012884', NULL, 'Excisionase-like', 'Excisionase-like', 3, NULL),
(13273, NULL, 'IPR015350', NULL, 'Beta-trefoil DNA-binding domain', 'Beta-trefoil_DNA-bd_dom', 3, NULL),
(13274, NULL, 'IPR012423', NULL, 'Chromatin modification-related protein Eaf7/MRGBP', 'Eaf7/MRGBP', 4, NULL),
(13275, NULL, 'IPR008555', NULL, 'SIKE family', 'SIKE', 4, NULL),
(13276, NULL, 'IPR008716', NULL, 'Nodulation protein Z', 'NodZ', 4, NULL),
(13277, NULL, 'IPR008710', NULL, 'Nicastrin', 'Nicastrin', 4, NULL),
(13278, NULL, 'IPR011814', NULL, 'Malonyl-[acyl-carrier protein] O-methyltransferase BioC', 'BioC', 4, NULL),
(13279, NULL, 'IPR008570', NULL, 'ESCRT-II complex, Vps25 subunit', 'ESCRT-II_cplx_Vps25-sub', 4, NULL),
(13280, NULL, 'IPR012901', NULL, 'Carnosine N-methyltransferase', 'CARME', 4, NULL),
(13281, NULL, 'IPR011784', NULL, 'Sulphate adenylyltransferase, small subunit', 'SO4_adenylTrfase_ssu', 4, NULL),
(13282, NULL, 'IPR014055', NULL, 'CRISPR-associated protein, Csx11', 'CRISPR-assoc_prot_Csx11', 4, NULL),
(13283, NULL, 'IPR011815', NULL, 'Penicillin-binding protein 1C', 'PBP_1c', 4, NULL),
(13284, NULL, 'IPR016015', NULL, 'Clusterin, C-terminal', 'Clusterin_C', 3, NULL),
(13285, NULL, 'IPR009793', NULL, 'Protein of unknown function DUF1361', 'DUF1361', 4, NULL),
(13286, NULL, 'IPR012913', NULL, 'Protein OS9-like domain', 'OS9-like_dom', 3, NULL),
(13287, NULL, 'IPR014864', NULL, 'Transcription factor, NikR, nickel binding C-terminal', 'TF_NikR_Ni-bd_C', 3, NULL),
(13288, NULL, 'IPR012372', NULL, 'Uncharacterised conserved protein UCP014405, metallopeptidase Zn-binding site', 'UCP014405_Zn-bd', 4, NULL),
(13289, NULL, 'IPR034032', NULL, 'Bacterial MMP-like domain', 'Zn_MMP-like_bac', 3, NULL),
(13290, NULL, 'IPR024184', NULL, 'Uncharacterised conserved protein UCP005637', 'UCP005637', 4, NULL),
(13291, NULL, 'IPR009783', NULL, 'Protein of unknown function DUF1348', 'DUF1348', 4, NULL),
(13292, NULL, 'IPR015336', NULL, 'Tumour necrosis factor receptor 13C, TALL-1 binding domain', 'TNFR_13C_TALL-1-bd', 3, NULL),
(13293, NULL, 'IPR012431', NULL, 'PD-(D/E)XK nuclease', 'PDDEXK_10', 4, NULL),
(13294, NULL, 'IPR014076', NULL, 'Carboxysome shell vertex protein CsoS4A', 'CsoS4A', 4, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(13295, NULL, 'IPR015342', NULL, 'Peroxisome biogenesis factor 1, N-terminal, psi beta-barrel fold', 'PEX-N_psi_beta-barrel', 3, NULL),
(13296, NULL, 'IPR014057', NULL, 'Uncharacterized protein HI1420', 'HI1420', 4, NULL),
(13297, NULL, 'IPR009797', NULL, 'Protein of unknown function DUF1367', 'DUF1367', 4, NULL),
(13298, NULL, 'IPR024255', NULL, 'Spore germination GerPB', 'GerPB', 4, NULL),
(13299, NULL, 'IPR013267', NULL, 'Hepatitis TT virus, Orf2a', 'Hepatitis_TTV_Orf2a', 4, NULL),
(13300, NULL, 'IPR009820', NULL, 'Protein of unknown function DUF1390', 'DUF1390', 4, NULL),
(13301, NULL, 'IPR014862', NULL, 'TrwC relaxase', 'TrwC', 3, NULL),
(13302, NULL, 'IPR015327', NULL, 'Smaug, PHAT analogous topology', 'PHAT_dom', 3, NULL),
(13303, NULL, 'IPR024289', NULL, 'Domain of unknown function DUF3828', 'DUF3828', 3, NULL),
(13304, NULL, 'IPR011795', NULL, 'Mercuric transport protein periplasmic component', 'MerP', 4, NULL),
(13305, NULL, 'IPR012397', NULL, 'Pullulan 6-glucanohydrolase', 'Pullulanase', 4, NULL),
(13306, NULL, 'IPR013768', NULL, 'Intercellular adhesion molecule, N-terminal', 'ICAM_N', 3, NULL),
(13307, NULL, 'IPR015347', NULL, 'STAT transcription factor homologue, coiled coil', 'STAT_TF_homologue_coiled-coil', 3, NULL),
(13308, NULL, 'IPR011788', NULL, 'Zn(II)-responsive transcriptional regulator', 'ZntR', 4, NULL),
(13309, NULL, 'IPR013259', NULL, 'Sulfakinin', 'Sulfakinin', 4, NULL),
(13310, NULL, 'IPR012382', NULL, 'Precorrin-2 C(20)-methyltransferase', 'CobI/CbiL', 4, NULL),
(13311, NULL, 'IPR014889', NULL, 'Transcription factor DP, C-terminal', 'Transc_factor_DP_C', 3, NULL),
(13312, NULL, 'IPR015328', NULL, 'Domain of unknown function DUF1965', 'DUF1965', 3, NULL),
(13313, NULL, 'IPR008532', NULL, 'NFACT, RNA-binding domain', 'NFACT_RNA-bd', 3, NULL),
(13314, NULL, 'IPR013248', NULL, 'Secretory component protein Psh3/Shr3', 'Psh3/Shr3', 4, NULL),
(13315, NULL, 'IPR012406', NULL, 'Urease accessory protein UreE', 'UreE', 4, NULL),
(13316, NULL, 'IPR008530', NULL, 'Coiled-coil domain-containing protein 22', 'CCDC22', 4, NULL),
(13317, NULL, 'IPR015313', NULL, 'Protein Her-1', 'Her-1', 4, NULL),
(13318, NULL, 'IPR014869', NULL, 'Glycosyltransferase GT-D fold', 'GT-D', 3, NULL),
(13319, NULL, 'IPR008693', NULL, 'Transport accessory protein  MmpS', 'MmpS', 4, NULL),
(13320, NULL, 'IPR011779', NULL, 'Sulphate adenylyltransferase, large subunit', 'SO4_adenylTrfase_lsu', 4, NULL),
(13321, NULL, 'IPR009807', NULL, 'Phytoreovirus outer capsid P8', 'Phytoreo_P8', 4, NULL),
(13322, NULL, 'IPR015335', NULL, 'F1 capsule antigen', 'Caf1', 4, NULL),
(13323, NULL, 'IPR013252', NULL, 'Kinetochore-Ndc80 subunit Spc24', 'Ndc80_Spc24', 4, NULL),
(13324, NULL, 'IPR015339', NULL, 'Immunomodulatory protein FIP-Fve, fungal', 'Immunomodulatory_FIP-Fve_fun', 4, NULL),
(13325, NULL, 'IPR009838', NULL, 'Type IV conjugative transfer system, protein TraL', 'T4SS_TraL', 4, NULL),
(13326, NULL, 'IPR012903', NULL, 'Nif11 domain', 'Nif11', 3, NULL),
(13327, NULL, 'IPR011984', NULL, '3,4-dihydroxyphenylacetate 2,3-dioxygenase', 'HPCD', 4, NULL),
(13328, NULL, 'IPR012910', NULL, 'TonB-dependent receptor, plug domain', 'Plug_dom', 3, NULL),
(13329, NULL, 'IPR012428', NULL, 'Autographa californica nuclear polyhedrosis virus (AcMNPV), Orf117', 'AcMNPV_Orf117', 4, NULL),
(13330, NULL, 'IPR014870', NULL, 'Domain of unknown function DUF1793', 'DUF1793', 3, NULL),
(13331, NULL, 'IPR009798', NULL, 'Wound-induced protein Wun1-like', 'Wun1-like', 4, NULL),
(13332, NULL, 'IPR014054', NULL, 'Bacteriophage regulatory protein, Rha family', 'Phage_regulatory_Rha', 4, NULL),
(13333, NULL, 'IPR008533', NULL, 'Domain of unknown function DUF815', 'DUF815', 3, NULL),
(13334, NULL, 'IPR009780', NULL, 'Protein of unknown function DUF1344', 'DUF1344', 4, NULL),
(13335, NULL, 'IPR008690', NULL, 'Tetrahydromethanopterin S-methyltransferase subunit B', 'MtrB_MeTrfase', 4, NULL),
(13336, NULL, 'IPR012883', NULL, 'ERp29, N-terminal', 'ERp29_N', 3, NULL),
(13337, NULL, 'IPR014066', NULL, 'Arsenite oxidase subunit AioA/Iodate reductase subunit IdrA, large subunit', 'AioA/IdrA_lsu', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(13338, NULL, 'IPR014075', NULL, 'SUF system FeS cluster assembly, SufR regulator, cyanobacteria', 'SUF_FeS_clus_asmb_SufR_cyano', 4, NULL),
(13339, NULL, 'IPR011782', NULL, 'Peptidase S1C, Do', 'Pept_S1C_Do', 4, NULL),
(13340, NULL, 'IPR013257', NULL, 'Set2 Rpb1 interacting domain', 'SRI', 3, NULL),
(13341, NULL, 'IPR015856', NULL, 'ABC transporter, CbiO/EcfA subunit', 'ABC_transpr_CbiO/EcfA_su', 3, NULL),
(13342, NULL, 'IPR012902', NULL, 'Prokaryotic N-terminal methylation site', 'N_methyl_site', 6, NULL),
(13343, NULL, 'IPR014025', NULL, 'Glutaredoxin subgroup', 'Glutaredoxin_subgr', 3, NULL),
(13344, NULL, 'IPR024177', NULL, 'Biotin synthase', 'Biotin_synthase', 4, NULL),
(13345, NULL, 'IPR009804', NULL, 'Sulfolobus islandicus filamentous virus, Orf14', 'SIFV_Orf14', 4, NULL),
(13346, NULL, 'IPR008713', NULL, 'Bacteriophage lambda NinG', 'Phage_lambda_NinG', 4, NULL),
(13347, NULL, 'IPR011787', NULL, 'Sulphite reductase, ferredoxin dependent', 'SiR_ferredoxin-dep', 4, NULL),
(13348, NULL, 'IPR015322', NULL, 'Cyclin domain, herpesvirus', 'Cyclin_dom_herpesvir', 3, NULL),
(13349, NULL, 'IPR008553', NULL, 'Domain of unknown function DUF835', 'DUF835', 3, NULL),
(13350, NULL, 'IPR011793', NULL, 'Putative glutamate--cysteine ligase YbdK', 'YbdK', 4, NULL),
(13351, NULL, 'IPR012424', NULL, 'Conjugative transposon, TraJ, C-terminal', 'Conjugative_transposon_TraJ_C', 3, NULL),
(13352, NULL, 'IPR012392', NULL, 'Very-long-chain 3-ketoacyl-CoA synthase', '3-ktacl-CoA_syn', 4, NULL),
(13353, NULL, 'IPR014901', NULL, '2-cysteine adaptor', '2-cysteine_adaptor', 3, NULL),
(13354, NULL, 'IPR015349', NULL, 'GTP-binding protein OBG, C-terminal', 'OCT_dom', 3, NULL),
(13355, NULL, 'IPR012907', NULL, 'Peptidase S11, D-Ala-D-Ala carboxypeptidase A, C-terminal', 'Peptidase_S11_C', 3, NULL),
(13356, NULL, 'IPR008558', NULL, 'Lagovirus RHDV, Vp2', 'Lagovirus_RHDV_Vp2', 4, NULL),
(13357, NULL, 'IPR014881', NULL, 'Nin one binding (NOB1) Zn-ribbon-like', 'NOB1_Zn-bd', 3, NULL),
(13358, NULL, 'IPR015864', NULL, 'FAD synthetase', 'FAD_synthase', 3, NULL),
(13359, NULL, 'IPR012908', NULL, 'GPI inositol-deacylase PGAP1-like', 'PGAP1-like', 4, NULL),
(13360, NULL, 'IPR014888', NULL, 'Structural accessory protein ORF7a, SARS-CoV-like', 'ORF7a_SARS-CoV-like', 4, NULL),
(13361, NULL, 'IPR011794', NULL, 'Hg(II)-responsive transcriptional regulator', 'MerR', 4, NULL),
(13362, NULL, 'IPR011773', NULL, 'DNA-directed RNA polymerase, alpha subunit', 'DNA-dir_RpoA', 4, NULL),
(13363, NULL, 'IPR014894', NULL, 'Inner membrane lipoprotein DcrB/EagT6', 'DcrB/EagT6', 4, NULL),
(13364, NULL, 'IPR014866', NULL, 'YfkB-like domain', 'YfkB', 3, NULL),
(13365, NULL, 'IPR014907', NULL, 'Virulence-protein E, N-terminal', 'VirE_N', 3, NULL),
(13366, NULL, 'IPR014059', NULL, 'Conjugative relaxase, N-terminal', 'Conjug_relaxase_N', 3, NULL),
(13367, NULL, 'IPR008546', NULL, 'VAN3-binding protein-like, auxin canalisation domain', 'VAN3-bd-like_auxin_canal', 3, NULL),
(13368, NULL, 'IPR012426', NULL, 'Cell division protein SepF, archaea', 'SepF_arc', 4, NULL),
(13369, NULL, 'IPR014898', NULL, 'Zinc finger, C2H2, LYAR-type', 'Znf_C2H2_LYAR', 3, NULL),
(13370, NULL, 'IPR015344', NULL, 'Vibrio cholerae neuraminidase, lectin-like domain', 'VCNA_lectin-like_dom', 3, NULL),
(13371, NULL, 'IPR012421', NULL, 'WisP, C-terminal', 'WisP_C', 3, NULL),
(13372, NULL, 'IPR012879', NULL, 'PAT complex subunit CCDC47', 'CCDC47', 4, NULL),
(13373, NULL, 'IPR014885', NULL, 'VASP tetramerisation', 'VASP_tetra', 3, NULL),
(13374, NULL, 'IPR011985', NULL, '5-carboxymethyl-2-hydroxymuconate semialdehyde dehydrogenase', 'DH_HpaE', 4, NULL),
(13375, NULL, 'IPR008544', NULL, 'Protein of unknown function DUF826', 'DUF826', 4, NULL),
(13376, NULL, 'IPR011980', NULL, 'Nickel ABC transporter, substrate-binding protein NikA', 'NikA_ABC_Ni-bd', 4, NULL),
(13377, NULL, 'IPR011801', NULL, 'Cyanobacterial long protein repeat', 'Swm_rep_I_cyn', 7, NULL),
(13378, NULL, 'IPR011771', NULL, 'Magnesium-chelatase, subunit H', 'BchH', 4, NULL),
(13379, NULL, 'IPR012891', NULL, 'GCK domain', 'GCK_dom', 3, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(13380, NULL, 'IPR008564', NULL, 'Golgi apparatus membrane protein TVP23-like', 'TVP23-like', 4, NULL),
(13381, NULL, 'IPR015321', NULL, 'Type I cytokine receptor, cytokine-binding domain', 'TypeI_recpt_CBD', 3, NULL),
(13382, NULL, 'IPR008687', NULL, 'Bacterial mobilisation', 'MobC', 3, NULL),
(13383, NULL, 'IPR012394', NULL, 'Aldehyde dehydrogenase NAD(P)-dependent', 'Aldehyde_DH_NAD(P)', 4, NULL),
(13384, NULL, 'IPR008691', NULL, '19kDa lipoprotein antigen', 'LpqH', 4, NULL),
(13385, NULL, 'IPR014919', NULL, 'XisH protein', 'XisH', 4, NULL),
(13386, NULL, 'IPR009835', NULL, 'Sortase B family', 'SrtB', 4, NULL),
(13387, NULL, 'IPR012379', NULL, 'LytTR MHYE transcriptional regulator, putative', 'LytTR_MHYE', 4, NULL),
(13388, NULL, 'IPR012401', NULL, 'DNA-binding protein MutS2, archaea', 'DNA-bd_MutS2_arc', 4, NULL),
(13389, NULL, 'IPR014887', NULL, 'HIF-1 alpha, transactivation domain, C-terminal', 'HIF-1_TAD_C', 3, NULL),
(13390, NULL, 'IPR015860', NULL, 'ABC transporter, teichoic acids export TagH-like', 'ABC_transpr_TagH-like', 3, NULL),
(13391, NULL, 'IPR012388', NULL, 'CDK5 and ABL1 enzyme substrate 1/2', 'CABLES1/2', 4, NULL),
(13392, NULL, 'IPR011982', NULL, '4-hydroxyphenylacetate 3-monooxygenase, reductase component', 'HPA_mOase_red', 4, NULL),
(13393, NULL, 'IPR015308', NULL, 'Bubble protein', 'Bubble', 4, NULL),
(13394, NULL, 'IPR008538', NULL, 'Putative restriction endonuclease', 'Uma2', 3, NULL),
(13395, NULL, 'IPR015338', NULL, 'Glycosyl transferase 64 domain', 'GT64', 3, NULL),
(13396, NULL, 'IPR013266', NULL, 'Tryptophyllin skin active peptide', 'Tryptophillin', 4, NULL),
(13397, NULL, 'IPR015318', NULL, 'Zinc finger, GAGA-binding factor', 'Znf_GAGA-bd_fac', 3, NULL),
(13398, NULL, 'IPR014886', NULL, 'La protein, xRRM domain', 'La_xRRM', 3, NULL),
(13399, NULL, 'IPR034033', NULL, 'Serralysin-like metallopeptidase domain', 'Serralysin-like', 3, NULL),
(13400, NULL, 'IPR013269', NULL, 'Herpesvirus UL2', 'Herpes_UL2', 4, NULL),
(13401, NULL, 'IPR009782', NULL, 'UAP56-interacting factor', 'FYTTD1', 4, NULL),
(13402, NULL, 'IPR013249', NULL, 'RNA polymerase sigma factor 70, region 4 type 2', 'RNA_pol_sigma70_r4_t2', 3, NULL),
(13403, NULL, 'IPR034419', NULL, 'Probable RNA-binding protein 19, RNA recognition motif 3', 'RBM19_RRM3', 3, NULL),
(13404, NULL, 'IPR009813', NULL, 'Uncharacterised protein family YebG', 'Uncharacterised_YebG', 4, NULL),
(13405, NULL, 'IPR011178', NULL, 'Amyloidogenic glycoprotein, copper-binding', 'Amyloid_glyco_Cu-bd', 3, NULL),
(13406, NULL, 'IPR012371', NULL, 'Condensin-2 complex subunit D3', 'NCAPD3', 4, NULL),
(13407, NULL, 'IPR012887', NULL, 'L-fucokinase', 'Fucokinase', 3, NULL),
(13408, NULL, 'IPR012419', NULL, 'Cas1p 10 TM acyl transferase domain', 'Cas1_AcylTrans_dom', 3, NULL),
(13409, NULL, 'IPR009843', NULL, 'Protein of unknown function DUF1403', 'DUF1403', 4, NULL),
(13410, NULL, 'IPR009841', NULL, 'VirC2', 'VirC2', 4, NULL),
(13411, NULL, 'IPR009826', NULL, 'DNA circulation, N-terminal', 'DNA_circ_N', 3, NULL),
(13412, NULL, 'IPR009788', NULL, 'GvpD, P-loop domain', 'GvpD_P-loop', 3, NULL),
(13413, NULL, 'IPR009803', NULL, 'Protein of unknown function DUF1373', 'DUF1373', 4, NULL),
(13414, NULL, 'IPR012383', NULL, 'Uroporphyrin-III C-methyltransferase, plant', 'Uropor_MeTrfase_pln', 4, NULL),
(13415, NULL, 'IPR009800', NULL, 'Coiled-coil alpha-helical rod protein 1', 'HCR', 4, NULL),
(13416, NULL, 'IPR009822', NULL, 'YaeQ', 'YaeQ', 4, NULL),
(13417, NULL, 'IPR015346', NULL, 'DNA topoisomerase I, N-terminal, viral', 'TopoI_N_vir', 3, NULL),
(13418, NULL, 'IPR015307', NULL, 'Restriction endonuclease, type II, HincII', 'Restrct_endonuc_II_HincII', 4, NULL),
(13419, NULL, 'IPR008708', NULL, 'TspB virulence factor', 'Neisseria_TspB', 4, NULL),
(13420, NULL, 'IPR012886', NULL, 'Formiminotransferase, N-terminal subdomain', 'Formiminotransferase_N', 3, NULL),
(13421, NULL, 'IPR012289', NULL, 'Lytic transglycosylase, superhelical linker', 'Lytic_TGlycosylase_superhlx_L', 3, NULL),
(13422, NULL, 'IPR012900', NULL, 'G-box binding protein, multifunctional mosaic region', 'MFMR', 3, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(13423, NULL, 'IPR014064', NULL, 'Arsenate reductase ArsC', 'Arsenate_reductase_ArsC', 4, NULL),
(13424, NULL, 'IPR008698', NULL, 'NADH dehydrogenase [ubiquinone] 1 beta subcomplex subunit 7, NDUB7', 'NDUB7', 4, NULL),
(13425, NULL, 'IPR012417', NULL, 'Calmodulin-binding domain, plant', 'CaM-bd_dom_pln', 3, NULL),
(13426, NULL, 'IPR009790', NULL, 'Transmembrane protein 106', 'TMEM106', 4, NULL),
(13427, NULL, 'IPR008525', NULL, 'Protein of unknown function DUF807, Coxiella burnetii', 'DUF807_COXBU', 4, NULL),
(13428, NULL, 'IPR011790', NULL, 'ADP-specific phosphofructokinase, archaeal', 'ADP_PFK_arc', 4, NULL),
(13429, NULL, 'IPR012418', NULL, 'CAP160', 'CAP160', 7, NULL),
(13430, NULL, 'IPR009785', NULL, 'Lactobacillus prophage Lj928, Orf309', 'Prophage_Lj928_Orf309', 4, NULL),
(13431, NULL, 'IPR015309', NULL, 'Transcriptional repressor TraM', 'Tscrpt_rep_TraM', 4, NULL),
(13432, NULL, 'IPR015319', NULL, 'Interleukin-4 receptor alpha, N-terminal', 'IL-4_rcpt-alpha_N', 3, NULL),
(13433, NULL, 'IPR009794', NULL, 'Anabaena sensory rhodopsin transducer', 'ASRT', 4, NULL),
(13434, NULL, 'IPR014731', NULL, 'Electron transfer flavoprotein, alpha subunit, C-terminal', 'ETF_asu_C', 3, NULL),
(13435, NULL, 'IPR014861', NULL, 'Uncharacterised domain CNP1', 'Uncharacterised_CNP1', 3, NULL),
(13436, NULL, 'IPR009845', NULL, 'Protein of unknown function DUF1405', 'DUF1405', 4, NULL),
(13437, NULL, 'IPR008547', NULL, 'Protein of unknown function DUF829, TMEM53', 'DUF829_TMEM53', 4, NULL),
(13438, NULL, 'IPR012889', NULL, 'L-fucose isomerase, N-terminal-2', 'Fucose_isomerase_N2', 3, NULL),
(13439, NULL, 'IPR009836', NULL, 'Glycine-rich domain-containing protein-like', 'GRDP-like', 4, NULL),
(13440, NULL, 'IPR008701', NULL, 'Necrosis inducing protein', 'NPP1', 4, NULL),
(13441, NULL, 'IPR008688', NULL, 'ATP synthase, F0 complex, subunit B/MI25', 'ATP_synth_Bsub_B/MI25', 4, NULL),
(13442, NULL, 'IPR015333', NULL, 'Pollen allergen ole e 6', 'Pollen_allergen_ole-e-6', 4, NULL),
(13443, NULL, 'IPR008545', NULL, 'WEB family', 'Web', 4, NULL),
(13444, NULL, 'IPR014023', NULL, 'Mononegavirales RNA-directed RNA polymerase catalytic domain', 'Mononeg_RNA_pol_cat', 3, NULL),
(13445, NULL, 'IPR013260', NULL, 'mRNA splicing factor SYF2', 'mRNA_splic_SYF2', 4, NULL),
(13446, NULL, 'IPR015352', NULL, 'Hepsin, SRCR domain', 'Hepsin-SRCR_dom', 3, NULL),
(13447, NULL, 'IPR012915', NULL, 'Reovirus RNA-dependent RNA polymerase lambda 3', 'RdRP_5', 4, NULL),
(13448, NULL, 'IPR011777', NULL, 'Geranylgeranyl reductase family', 'Geranylgeranyl_Rdtase_fam', 4, NULL),
(13449, NULL, 'IPR014897', NULL, 'PBCV-specific basic adaptor domain', 'PBCV_basic_adap', 3, NULL),
(13450, NULL, 'IPR014902', NULL, 'Factor H binding protein, C-terminal', 'FHBP_C', 3, NULL),
(13451, NULL, 'IPR014878', NULL, 'THAP4-like, heme-binding beta-barrel domain', 'THAP4-like_heme-bd', 3, NULL),
(13452, NULL, 'IPR012912', NULL, 'Plasmid pRiA4b, Orf3', 'Plasmid_pRiA4b_Orf3', 4, NULL),
(13453, NULL, 'IPR008717', NULL, 'Noggin', 'Noggin', 4, NULL),
(13454, NULL, 'IPR009781', NULL, 'Protein of unknown function DUF1345', 'DUF1345', 4, NULL),
(13455, NULL, 'IPR014891', NULL, 'DWNN domain', 'DWNN_domain', 3, NULL),
(13456, NULL, 'IPR012880', NULL, 'Gryzun, putative trafficking through Golgi', 'Gryzun', 3, NULL),
(13457, NULL, 'IPR009830', NULL, 'LppX/LprAFG lipoprotein family', 'LppX/LprAFG', 4, NULL),
(13458, NULL, 'IPR024183', NULL, 'RING finger protein Z, arenaviridae', 'RING_finger_Z_arenaviridae', 4, NULL),
(13459, NULL, 'IPR014884', NULL, 'ParB protein family, C-terminal', 'ParB_fam_C', 3, NULL),
(13460, NULL, 'IPR011811', NULL, 'Peptidase S51, cyanophycinase', 'Peptidase_S51_cyanophycinase', 4, NULL),
(13461, NULL, 'IPR008563', NULL, 'Protein AC81, baculovirus', 'AcMNPV_AC81', 4, NULL),
(13462, NULL, 'IPR008541', NULL, 'InvasinE, Adhesion domain', 'InvE_AD', 3, NULL),
(13463, NULL, 'IPR013262', NULL, 'Outer membrane protein, MIM1/TOM13, mitochondrial', 'OMP_MIM1/TOM13_mt', 4, NULL),
(13464, NULL, 'IPR015340', NULL, 'Alpha-amylase, domain C', 'A_amylase_C_dom', 3, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(13465, NULL, 'IPR024178', NULL, 'Estrogen receptor/oestrogen-related receptor', 'Est_rcpt/est-rel_rcp', 4, NULL),
(13466, NULL, 'IPR008715', NULL, 'SAM-dependent methyltransferase, NodS-like', 'SAM-MeTfrase_NodS-like', 4, NULL),
(13467, NULL, 'IPR024181', NULL, 'Chemotaxis response regulator CheV', 'Chemotax_regulator_CheV', 4, NULL),
(13468, NULL, 'IPR013254', NULL, 'Sperm-activating peptide', 'Sperm_act_pept', 4, NULL),
(13469, NULL, 'IPR011798', NULL, 'Adenosine 5''-phosphosulphate reductase', 'APS_reductase', 4, NULL),
(13470, NULL, 'IPR008705', NULL, 'Nanos/Xcat2', 'Nanos/Xcar2', 4, NULL),
(13471, NULL, 'IPR012881', NULL, 'Protein of unknown function DUF1685', 'DUF1685', 4, NULL),
(13472, NULL, 'IPR011785', NULL, 'Transcription regulator PpsR', 'Tscrpt_reg_PpsR-CrtJ', 4, NULL),
(13473, NULL, 'IPR034169', NULL, 'NifX-like domain', 'NifX-like', 3, NULL),
(13474, NULL, 'IPR014917', NULL, 'Protein of unknown function DUF1800', 'DUF1800', 4, NULL),
(13475, NULL, 'IPR008568', NULL, 'ER membrane protein complex subunit 3', 'EMC3', 4, NULL),
(13476, NULL, 'IPR012885', NULL, 'F-box associated domain, type 2', 'F-box-assoc_dom_typ2', 3, NULL),
(13477, NULL, 'IPR012414', NULL, 'BDS potassium channel toxin', 'BDS_K_chnl_tox', 4, NULL),
(13478, NULL, 'IPR014893', NULL, 'Ku, C-terminal', 'Ku_PK_bind', 3, NULL),
(13479, NULL, 'IPR008699', NULL, 'NADH dehydrogenase [ubiquinone] 1 beta subcomplex subunit 8', 'NDUFB8', 4, NULL),
(13480, NULL, 'IPR008562', NULL, 'Autographa californica nuclear polyhedrosis virus (AcMNPV), C42', 'AcMNPV_C42', 4, NULL),
(13481, NULL, 'IPR015331', NULL, 'P22 tailspike C-terminal domain', 'P22_tailspike_C', 3, NULL),
(13482, NULL, 'IPR008526', NULL, 'Inner membrane protein YedI', 'YedI', 4, NULL),
(13483, NULL, 'IPR012416', NULL, 'CALMODULIN-BINDING PROTEIN60', 'CBP60', 4, NULL),
(13484, NULL, 'IPR012398', NULL, 'PRIB5', 'PRIB5', 4, NULL),
(13485, NULL, 'IPR014073', NULL, 'Archaeal dihydromethanopterin reductase', 'DmrX', 4, NULL),
(13486, NULL, 'IPR011810', NULL, 'Cyanophycin synthetase', 'Cya_phycin_syn', 4, NULL),
(13487, NULL, 'IPR012413', NULL, 'BA14k family', 'BA14K', 4, NULL),
(13488, NULL, 'IPR014857', NULL, 'Zinc finger, RING-like', 'Znf_RING-like', 3, NULL),
(13489, NULL, 'IPR012375', NULL, 'Glutamate synthase large subunit domain 1 stand-alone protein', 'Glu_synth_lsu_1', 4, NULL),
(13490, NULL, 'IPR013272', NULL, 'Vps72/YL1, C-terminal', 'Vps72/YL1_C', 3, NULL),
(13491, NULL, 'IPR024180', NULL, 'Bifunctional tetrapyrrole methylase/MazG NTP pyrophosphohydrolase, predicted', 'Tetrapyrrole_Mease/MazG_pred', 4, NULL),
(13492, NULL, 'IPR009825', NULL, 'ECF transporter, substrate-specific component-like', 'ECF_substrate-spec-like', 4, NULL),
(13493, NULL, 'IPR014892', NULL, 'Replication protein A, C-terminal', 'RPA_C', 3, NULL),
(13494, NULL, 'IPR011781', NULL, 'D-serine deaminase transcriptional activator', 'DsdC', 4, NULL),
(13495, NULL, 'IPR023226', NULL, 'Glycoside hydrolase, family 49, N-terminal domain', 'Glyco_hydro_49_N_dom', 3, NULL),
(13496, NULL, 'IPR012897', NULL, 'Potassium channel, voltage dependent, Kv1.4, tandem inactivation domain', 'K_chnl_volt-dep_Kv1.4_TID', 3, NULL),
(13497, NULL, 'IPR012420', NULL, 'Cbp4', 'Cbp4', 4, NULL),
(13498, NULL, 'IPR013251', NULL, 'DASH complex subunit Spc19', 'DASH_Spc19', 4, NULL),
(13499, NULL, 'IPR009833', NULL, 'Uncharacterised protein DUF1398', 'DUF1398', 4, NULL),
(13500, NULL, 'IPR015330', NULL, 'DNA primase/polymerase, bifunctional, N-terminal', 'DNA_primase/pol_bifunc_N', 3, NULL),
(13501, NULL, 'IPR011432', NULL, 'Heme-binding protein Shr-like, Hb-interacting domain', 'Shr-like_HID', 3, NULL),
(13502, NULL, 'IPR013685', NULL, 'POTRA domain, FtsQ-type', 'POTRA_FtsQ_type', 3, NULL),
(13503, NULL, 'IPR013332', NULL, 'Ketopantoate reductase, N-terminal domain', 'KPR_N', 3, NULL),
(13504, NULL, 'IPR018077', NULL, 'Glycoside hydrolase, family 25 subgroup', 'Glyco_hydro_fam25_subgr', 4, NULL),
(13505, NULL, 'IPR018101', NULL, 'Translation elongation factor Ts, conserved site', 'Transl_elong_Ts_CS', 2, NULL),
(13506, NULL, 'IPR012128', NULL, 'Phycobilisome, alpha/beta subunit', 'Phycobilisome_asu/bsu', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(13507, NULL, 'IPR020130', NULL, 'Spanin, outer lipoprotein subunit, T7likevirus', 'O-spanin_T7likevirus', 4, NULL),
(13508, NULL, 'IPR011604', NULL, 'PD-(D/E)XK endonuclease-like domain superfamily', 'PDDEXK-like_dom_sf', 5, NULL),
(13509, NULL, 'IPR016093', NULL, 'MIR motif', 'MIR_motif', 3, NULL),
(13510, NULL, 'IPR018076', NULL, 'Type II secretion system protein GspF domain', 'T2SS_GspF_dom', 3, NULL),
(13511, NULL, 'IPR011464', NULL, 'Domain of unknown function DUF1570', 'DUF1570', 3, NULL),
(13512, NULL, 'IPR014126', NULL, 'Type-F conjugative transfer system secretin TraK', 'TraK_Ftype', 4, NULL),
(13513, NULL, 'IPR008860', NULL, 'Taeniidae antigen', 'Taeniidae_ag', 4, NULL),
(13514, NULL, 'IPR020155', NULL, 'Uncharacterised protein family YeiS', 'Uncharacterised_YeiS', 4, NULL),
(13515, NULL, 'IPR009266', NULL, 'Adenovirus E3', 'Adeno_E3', 4, NULL),
(13516, NULL, 'IPR024731', NULL, 'EGF domain', 'EGF_dom', 3, NULL),
(13517, NULL, 'IPR008823', NULL, 'RuvB C-terminal winged helix domain', 'RuvB_C', 3, NULL),
(13518, NULL, 'IPR018089', NULL, 'Orotidine 5''-phosphate decarboxylase, active site', 'OMPdecase_AS', 0, NULL),
(13519, NULL, 'IPR008854', NULL, 'TPMT family', 'TPMT', 4, NULL),
(13520, NULL, 'IPR009300', NULL, 'Transcription activator RinB', 'Transcription_activator_RinB', 4, NULL),
(13521, NULL, 'IPR011843', NULL, 'Coenzyme PQQ biosynthesis protein E, bacteria', 'PQQ_synth_PqqE_bac', 4, NULL),
(13522, NULL, 'IPR012129', NULL, 'Phytochrome A/B/C/D/E', 'Phytochrome_A-E', 4, NULL),
(13523, NULL, 'IPR009267', NULL, 'Putative nucleotidyltransferase', 'NTP_transf_6', 4, NULL),
(13524, NULL, 'IPR014127', NULL, 'Conserved hypothetical protein CHP02757', 'CHP02757', 4, NULL),
(13525, NULL, 'IPR008807', NULL, 'ROS/MUCR transcriptional regulator', 'ROS_MUCR', 4, NULL),
(13526, NULL, 'IPR011446', NULL, 'Putative beta barrel porin-7', 'BBP7', 4, NULL),
(13527, NULL, 'IPR011478', NULL, 'Domain of unknown function DUF1585', 'DUF1585', 3, NULL),
(13528, NULL, 'IPR015867', NULL, 'Nitrogen regulatory protein PII/ATP phosphoribosyltransferase, C-terminal', 'N-reg_PII/ATP_PRibTrfase_C', 5, NULL),
(13529, NULL, 'IPR020180', NULL, 'Uncharacterised protein family RP853', 'Uncharacterised_RP853', 4, NULL),
(13530, NULL, 'IPR013678', NULL, 'Ribonucleotide reductase class II vitamin B12-dependent, N-terminal domain', 'RNR_2_N', 3, NULL),
(13531, NULL, 'IPR012227', NULL, 'TNF receptor-associated factor TRAF, metazoa', 'TNF_rcpt-assoc_TRAF_met', 4, NULL),
(13532, NULL, 'IPR020159', NULL, 'Phage Tail fiber assembly helper gene product 57', 'Phage_Gp57', 4, NULL),
(13533, NULL, 'IPR011824', NULL, 'Hydrolyase LeuD/DmdB, bacterial', 'LeuD/DmdB_bac', 4, NULL),
(13534, NULL, 'IPR018097', NULL, 'EGF-like calcium-binding, conserved site', 'EGF_Ca-bd_CS', 2, NULL),
(13535, NULL, 'IPR011835', NULL, 'Bacterial/plant glycogen synthase', 'GS/SS', 4, NULL),
(13536, NULL, 'IPR013710', NULL, '2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-acetyltransferase, N-terminal', 'DapH_N', 3, NULL),
(13537, NULL, 'IPR008836', NULL, 'Semenogelin', 'Semenogelin', 4, NULL),
(13538, NULL, 'IPR011422', NULL, 'BRCA1-associated 2', 'BRAP2', 3, NULL),
(13539, NULL, 'IPR011323', NULL, 'Mss4/translationally controlled tumour-associated TCTP', 'Mss4/transl-control_tumour', 5, NULL),
(13540, NULL, 'IPR012120', NULL, 'Fucose-1-phosphate guanylyltransferase', 'Fucose-1-phosphate_GuaTrfase', 4, NULL),
(13541, NULL, 'IPR020144', NULL, 'Stage V sporulation protein AB', 'SpoVAB', 4, NULL),
(13542, NULL, 'IPR008831', NULL, 'Mediator complex, subunit Med31', 'Mediator_Med31', 4, NULL),
(13543, NULL, 'IPR011465', NULL, 'Protein of unknown function DUF1571', 'DUF1571', 4, NULL),
(13544, NULL, 'IPR035901', NULL, 'GIY-YIG endonuclease superfamily', 'GIY-YIG_endonuc_sf', 5, NULL),
(13545, NULL, 'IPR008790', NULL, 'Poxvirus serine/threonine kinase', 'Poxvirus_ser/thr_kinase', 4, NULL),
(13546, NULL, 'IPR008797', NULL, 'Oxygen-evolving enhancer protein 3', 'PSII_PsbQ', 4, NULL),
(13547, NULL, 'IPR008792', NULL, 'Coenzyme PQQ synthesis protein D', 'PQQD', 4, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(13548, NULL, 'IPR008808', NULL, 'Powdery mildew resistance protein, RPW8 domain', 'Powdery_mildew-R_dom', 3, NULL),
(13549, NULL, 'IPR011858', NULL, 'His6-like, eukaryotic-type', 'His6-like_euk', 4, NULL),
(13550, NULL, 'IPR008795', NULL, 'Prominin', 'Prominin', 4, NULL),
(13551, NULL, 'IPR018155', NULL, 'Hyaluronidase', 'Hyaluronidase', 4, NULL),
(13552, NULL, 'IPR013680', NULL, 'Voltage-dependent calcium channel, alpha-2/delta subunit, conserved region', 'VDCC_a2/dsu', 3, NULL),
(13553, NULL, 'IPR023274', NULL, 'Aquaporin 1', 'Aquaporin_1', 4, NULL),
(13554, NULL, 'IPR008820', NULL, 'Rubella membrane glycoprotein E1', 'Rubella_E1', 4, NULL),
(13555, NULL, 'IPR009263', NULL, 'SERTA domain', 'SERTA_dom', 3, NULL),
(13556, NULL, 'IPR012210', NULL, 'Insulin-like growth factor binding protein 2', 'IGFBP-2', 4, NULL),
(13557, NULL, 'IPR011830', NULL, 'Isopropylmalate/citramalate/homocitrate synthase', 'LEU1_arch', 3, NULL),
(13558, NULL, 'IPR024640', NULL, 'Toxin-antitoxin type 1 system, toxin component', 'Toxin-antitoxin_type_1_toxin', 4, NULL),
(13559, NULL, 'IPR013691', NULL, 'C-methyltransferase', 'MeTrfase_14', 3, NULL),
(13560, NULL, 'IPR009253', NULL, 'Protein of unknown function DUF905', 'DUF905', 4, NULL),
(13561, NULL, 'IPR034434', NULL, 'Probable RNA-binding protein 46, RNA recognition motif 1', 'RBM46_RRM1', 3, NULL),
(13562, NULL, 'IPR011855', NULL, 'Phage major tail protein TP901-1', 'Phgtail_TP901_1', 4, NULL),
(13563, NULL, 'IPR009297', NULL, 'Protein of unknown function DUF952', 'DUF952', 4, NULL),
(13564, NULL, 'IPR013692', NULL, 'UDP-glucose 4-epimerase CapD, C-terminal domain', 'CapD_C', 3, NULL),
(13565, NULL, 'IPR014117', NULL, 'Type-IV secretion system protein TraC', 'TraC-F-type', 4, NULL),
(13566, NULL, 'IPR014121', NULL, 'Type-F conjugative transfer system mating-pair stabilisation protein TraN', 'TraN_Ftype', 4, NULL),
(13567, NULL, 'IPR011828', NULL, 'Isopropylmalate/isohomocitrate dehydrogenase', 'LEU3_arc', 4, NULL),
(13568, NULL, 'IPR011833', NULL, 'Glycogen/starch/alpha-glucan phosphorylase', 'Glycg_phsphrylas', 4, NULL),
(13569, NULL, 'IPR009288', NULL, 'Gamma-glutamylcyclotransferase, AIG2-like domain', 'AIG2-like_dom', 3, NULL),
(13570, NULL, 'IPR008840', NULL, 'Siphovirus Gp157', 'Sipho_Gp157', 4, NULL),
(13571, NULL, 'IPR011335', NULL, 'Restriction endonuclease  type II-like', 'Restrct_endonuc-II-like', 5, NULL),
(13572, NULL, 'IPR009272', NULL, 'Protein of unknown function DUF929', 'DUF929', 4, NULL),
(13573, NULL, 'IPR012132', NULL, 'Glucose-methanol-choline oxidoreductase', 'GMC_OxRdtase', 4, NULL),
(13574, NULL, 'IPR011476', NULL, 'Protein of unknown function DUF1582', 'DUF1582', 4, NULL),
(13575, NULL, 'IPR012206', NULL, 'Ferredoxin-like, FixX', 'Fd_FixX', 4, NULL),
(13576, NULL, 'IPR018088', NULL, 'Chalcone/stilbene synthase, active site', 'Chalcone/stilbene_synthase_AS', 0, NULL),
(13577, NULL, 'IPR008841', NULL, 'Siphovirus-type tail component', 'Siphovirus-type_tail', 4, NULL),
(13578, NULL, 'IPR011470', NULL, 'Protein of unknown function DUF1576', 'DUF1576', 4, NULL),
(13579, NULL, 'IPR011457', NULL, 'Protein of unknown function DUF1563', 'DUF1563', 4, NULL),
(13580, NULL, 'IPR011448', NULL, 'Domain of unknown function DUF1554', 'DUF1554', 3, NULL),
(13581, NULL, 'IPR009847', NULL, 'SNURF family', 'SNURF', 4, NULL),
(13582, NULL, 'IPR011859', NULL, 'Dihydrodipicolinate reductase, plant-type', 'Dihydrodipicolinate_Rdtase_pln', 4, NULL),
(13583, NULL, 'IPR013671', NULL, 'Geminivirus AC4/5, conserved domain', 'Gemini_AC4/5_cons-dom', 3, NULL),
(13584, NULL, 'IPR012122', NULL, 'ATPase, PP-loop, MJ1016-related', 'ATPase_PP-loop_MJ1016', 4, NULL),
(13585, NULL, 'IPR014119', NULL, 'Heptaprenyl diphosphate synthase component II', 'GerC3_HepT', 4, NULL),
(13586, NULL, 'IPR013688', NULL, 'GBS Bsp-like', 'GBS_Bsp-like', 7, NULL),
(13587, NULL, 'IPR009289', NULL, 'Baculoviridae 8.2kDa', 'Baculo_8kDa', 4, NULL),
(13588, NULL, 'IPR014116', NULL, 'Cytochrome c oxidase cbb3 type, accessory protein FixG', 'Cyt_c_oxidase_cbb3_FixG', 4, NULL),
(13589, NULL, 'IPR009275', NULL, 'SepZ', 'SepZ', 4, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(13590, NULL, 'IPR009293', NULL, 'Uncharacterised protein family UPF0478', 'UPF0478', 4, NULL),
(13591, NULL, 'IPR011853', NULL, 'TRAP C4-dicarboxylate transport system permease, fused DctM-DctQ', 'TRAP_DctM-Dct_fused', 4, NULL),
(13592, NULL, 'IPR012127', NULL, 'Cytochrome c prime', 'Cyt_c_prime', 4, NULL),
(13593, NULL, 'IPR018121', NULL, 'Seven-in-absentia protein, TRAF-like domain', '7-in-absentia-prot_TRAF-dom', 3, NULL),
(13594, NULL, 'IPR009280', NULL, 'Orthopoxvirus F14', 'Orthopox_F14', 4, NULL),
(13595, NULL, 'IPR011543', NULL, 'Restriction endonuclease, type II, BglI', 'Restrct_endonuc_II_BglI', 3, NULL),
(13596, NULL, 'IPR011826', NULL, 'Homoaconitase/3-isopropylmalate dehydratase, large subunit, prokaryotic', 'HAcnase/IPMdehydase_lsu_prok', 4, NULL),
(13597, NULL, 'IPR011437', NULL, 'Domain of unknown function DUF1540', 'DUF1540', 3, NULL),
(13598, NULL, 'IPR011820', NULL, 'L-threonine dehydratase biosynthetic IlvA', 'IlvA', 4, NULL),
(13599, NULL, 'IPR013677', NULL, 'Nontoxic nonhaemagglutinin C-terminal', 'Nontoxic_nonhemagglutn_C', 3, NULL),
(13600, NULL, 'IPR008794', NULL, 'Proline racemase family', 'Pro_racemase_fam', 4, NULL),
(13601, NULL, 'IPR011860', NULL, 'Ribose 5-phosphate isomerase B, Actinobacteria-type', 'Rib-5-P_Isoase_Actino', 4, NULL),
(13602, NULL, 'IPR008574', NULL, 'Interactor of ZYG-11, nematodes', 'Nematodes_ZYG-11_interact', 4, NULL),
(13603, NULL, 'IPR024190', NULL, 'Methenyltetrahydromethanopterin dehydrogenase, Hmd-type', 'METHMP_Hmd', 4, NULL),
(13604, NULL, 'IPR009246', NULL, 'Ethanolamine ammonia-lyase small subunit', 'EutC', 4, NULL),
(13605, NULL, 'IPR009247', NULL, 'Chordopoxvirus A35R', 'Chordopox_A35R', 4, NULL),
(13606, NULL, 'IPR011463', NULL, 'Protein of unknown function DUF1569', 'DUF1569', 4, NULL),
(13607, NULL, 'IPR008862', NULL, 'T-complex 11', 'Tcp11', 4, NULL),
(13608, NULL, 'IPR017851', NULL, 'Photosystem II PsbV, cytochrome c-550 precursor', 'PSII_PsbV_cyt_c550', 4, NULL),
(13609, NULL, 'IPR011861', NULL, 'Transaldolase, Staphylococcus-type', 'Transald_staph-type', 4, NULL),
(13610, NULL, 'IPR024200', NULL, 'Chondroitin sulfate ABC endolyase', 'Chondroitinase_ABC_I', 4, NULL),
(13611, NULL, 'IPR013706', NULL, '3''5''-cyclic nucleotide phosphodiesterase N-terminal', 'PDEase_N', 3, NULL),
(13612, NULL, 'IPR018080', NULL, 'Band 7/stomatin-like, conserved site', 'Band_7/stomatin-like_CS', 2, NULL),
(13613, NULL, 'IPR008798', NULL, 'Avirulence B/C', 'Avirulence_B/C', 4, NULL),
(13614, NULL, 'IPR013682', NULL, 'Baculovirus Vp91, capsid protein, N-terminal', 'BaculoV_Vp91_N', 3, NULL),
(13615, NULL, 'IPR024952', NULL, 'Lipoprotein LPP20-like', 'Lipo_LPP20-like', 4, NULL),
(13616, NULL, 'IPR011832', NULL, 'Glucose-1-phosphate adenylyltransferase, GlgD subunit', 'GlgDAde_trans', 4, NULL),
(13617, NULL, 'IPR013686', NULL, 'Polypeptide-transport-associated, ShlB-type', 'Polypept-transport_assoc_ShlB', 3, NULL),
(13618, NULL, 'IPR015361', NULL, 'Taq polymerase, thermostable, exonuclease region', 'Taq_pol_thermo_exonuc', 3, NULL),
(13619, NULL, 'IPR012291', NULL, 'CBM2, carbohydrate-binding domain superfamily', 'CBM2_carb-bd_dom_sf', 5, NULL),
(13620, NULL, 'IPR020132', NULL, 'Mycobacteriophage tail assembly protein 24/25', 'Gp24/Gp25', 4, NULL),
(13621, NULL, 'IPR014122', NULL, 'Demethylmenaquinone methyltransferase', 'MenG_heptapren', 4, NULL),
(13622, NULL, 'IPR012296', NULL, 'Nuclease, putative, TT1808', 'Nuclease_put_TT1808', 5, NULL),
(13623, NULL, 'IPR011863', NULL, 'Phosphoserine phosphatase/homoserine phosphotransferase bifunctional protein', 'HSK-PSP', 4, NULL),
(13624, NULL, 'IPR024194', NULL, 'Alginate O-acetyltransferase AlgI/D-alanyl transfer protein DltB', 'Ac/AlaTfrase_AlgI/DltB', 4, NULL),
(13625, NULL, 'IPR009294', NULL, 'Gamma-secretase subunit Aph-1', 'Aph-1', 4, NULL),
(13626, NULL, 'IPR020162', NULL, 'Cell cycle exit/neuronal differentiation protein 1', 'Cend1', 4, NULL),
(13627, NULL, 'IPR013669', NULL, 'Coat protein, C-terminal, Carmoviral', 'Coat_prot_C_Carmovir', 3, NULL),
(13628, NULL, 'IPR008813', NULL, 'Plasmid replication protein, RepL', 'Plasmid_replication_RepL', 3, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(13629, NULL, 'IPR024186', NULL, 'Signal transduction response regulator, heterocyst pattern formation, PatA', 'Sig_transdc_resp-reg_PatA', 4, NULL),
(13630, NULL, 'IPR024193', NULL, 'Ku80', 'Ku80', 4, NULL),
(13631, NULL, 'IPR034415', NULL, 'CsdA, RNA recognition motif', 'CsdA_RRM', 3, NULL),
(13632, NULL, 'IPR008832', NULL, 'Signal recognition particle, SRP9 subunit', 'Signal_recog_particle_SRP9', 4, NULL),
(13633, NULL, 'IPR015358', NULL, 'Transcription regulator MerR, DNA binding', 'Tscrpt_reg_MerR_DNA-bd', 3, NULL),
(13634, NULL, 'IPR011838', NULL, 'Pullulanase, extracellular', 'Pullulan_Gpos', 3, NULL),
(13635, NULL, 'IPR015359', NULL, 'Phosphoinositide-specific phospholipase C, EF-hand-like domain', 'PLC_EF-hand-like', 3, NULL),
(13636, NULL, 'IPR008850', NULL, 'TEP1, N-terminal', 'TEP1_N', 7, NULL),
(13637, NULL, 'IPR011429', NULL, 'Cytochrome C, Planctomycete-type', 'Cyt_c_Planctomycete-type', 3, NULL),
(13638, NULL, 'IPR009299', NULL, 'Gammaherpesvirus capsid', 'Herpes_capsid', 4, NULL),
(13639, NULL, 'IPR011468', NULL, 'Protein of unknown function DUF1574', 'DUF1574', 4, NULL),
(13640, NULL, 'IPR011430', NULL, 'U3 small nucleolar RNA-associated protein 20, N-terminal', 'UTP20_N', 3, NULL),
(13641, NULL, 'IPR008851', NULL, 'Transcription initiation factor IIF, alpha subunit', 'TFIIF-alpha', 4, NULL),
(13642, NULL, 'IPR009282', NULL, 'Protein of unknown function DUF937', 'DUF937', 4, NULL),
(13643, NULL, 'IPR018107', NULL, 'Sodium:dicarboxylate symporter, conserved site', 'Na-dicarboxylate_symporter_CS', 2, NULL),
(13644, NULL, 'IPR012295', NULL, 'TBP domain superfamily', 'TBP_dom_sf', 5, NULL),
(13645, NULL, 'IPR009279', NULL, 'Protein of unknown function DUF935', 'DUF935', 4, NULL),
(13646, NULL, 'IPR011337', NULL, 'DNA mismatch repair MutH/Type II restriction enzyme Sau3AI', 'DNA_rep_MutH/RE_typeII_Sau3AI', 3, NULL),
(13647, NULL, 'IPR024253', NULL, 'Phosducin, thioredoxin-like domain', 'Phosducin_thioredoxin-like_dom', 3, NULL),
(13648, NULL, 'IPR018060', NULL, 'DNA binding HTH domain, AraC-type', 'HTH_AraC', 3, NULL),
(13649, NULL, 'IPR014123', NULL, 'Superoxide dismutase, Nickel-type', 'Superoxide_dismutase_Ni-type', 4, NULL),
(13650, NULL, 'IPR008848', NULL, 'Plasmid regulator, Sulfolobaceae', 'Plasmid_regulator_arc', 4, NULL),
(13651, NULL, 'IPR009278', NULL, 'Herpesvirus US9', 'Herpes_US9', 4, NULL),
(13652, NULL, 'IPR013700', NULL, 'Aflatoxin regulatory protein', 'AflR', 3, NULL),
(13653, NULL, 'IPR018082', NULL, 'AmbAllergen', 'AmbAllergen', 4, NULL),
(13654, NULL, 'IPR012137', NULL, 'Nitrate reductase NADH dependent', 'Nitr_rd_NADH', 4, NULL),
(13655, NULL, 'IPR008834', NULL, 'Salmonella plasmid virulence SpvD', 'Sal_SpvD', 4, NULL),
(13656, NULL, 'IPR011420', NULL, 'Nitrogen regulatory AreA, N-terminal', 'AreA_N', 3, NULL),
(13657, NULL, 'IPR011435', NULL, 'Na(+), Li(+), K(+)/H(+) antiporter subunit A/B', 'UmpAB', 4, NULL),
(13658, NULL, 'IPR024195', NULL, 'NUDIX hydrolase, YfcD, predicted', 'NUDIX_hydrolase_YfcD_pred', 4, NULL),
(13659, NULL, 'IPR008861', NULL, 'Phage Tail Protein X-like', 'GpX-like', 4, NULL),
(13660, NULL, 'IPR009260', NULL, 'CRISPR-associated exonuclease Csa1', 'CRISPR-ass_Csa1', 4, NULL),
(13661, NULL, 'IPR011846', NULL, 'Cyd operon protein YbgE', 'Cyd_oper_YbgE', 4, NULL),
(13662, NULL, 'IPR009849', NULL, 'Domain of unknown function DUF1410', 'DUF1410', 3, NULL),
(13663, NULL, 'IPR009305', NULL, '2-hydroxy-palmitic acid dioxygenase Mpo1-like', 'Mpo1-like', 4, NULL),
(13664, NULL, 'IPR008826', NULL, 'Selenium-binding protein', 'Se-bd', 4, NULL),
(13665, NULL, 'IPR012223', NULL, 'Thioesterase type II, NRPS/PKS/S-FAS', 'TEII', 4, NULL),
(13666, NULL, 'IPR011840', NULL, 'Pullulanase, type I', 'PulA_typeI', 3, NULL),
(13667, NULL, 'IPR008581', NULL, 'Protein of unknown function DUF863, plant', 'DUF863_pln', 4, NULL),
(13668, NULL, 'IPR009262', NULL, 'Solute carrier family 35 member SLC35F1/F2/F6', 'SLC35_F1/F2/F6', 4, NULL),
(13669, NULL, 'IPR009268', NULL, 'Reovirus P9-like', 'Reo_P9', 4, NULL),
(13670, NULL, 'IPR009302', NULL, 'Tail length tape measure', 'Tail_length_tape_measure', 3, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(13671, NULL, 'IPR011450', NULL, 'Protein of unknown function DUF1556', 'DUF1556', 4, NULL),
(13672, NULL, 'IPR013698', NULL, 'Squalene epoxidase', 'Squalene_epoxidase', 3, NULL),
(13673, NULL, 'IPR024198', NULL, 'Uncharacterised conserved protein, UCP033642', 'UCP033642', 4, NULL),
(13674, NULL, 'IPR015868', NULL, 'Glutaminase', 'Glutaminase', 4, NULL),
(13675, NULL, 'IPR018108', NULL, 'Mitochondrial substrate/solute carrier', 'Mitochondrial_sb/sol_carrier', 7, NULL),
(13676, NULL, 'IPR009306', NULL, 'Protein of unknown function DUF963', 'DUF963', 7, NULL),
(13677, NULL, 'IPR011440', NULL, 'Domain of unknown function DUF1543', 'DUF1543', 3, NULL),
(13678, NULL, 'IPR008847', NULL, 'Suppressor of forked', 'Suf', 3, NULL),
(13679, NULL, 'IPR034838', NULL, 'Starch-binding domain-containing protein 1, CBM20 domain', 'CBM20_genethonin_1', 3, NULL),
(13680, NULL, 'IPR023271', NULL, 'Aquaporin-like', 'Aquaporin-like', 5, NULL),
(13681, NULL, 'IPR018110', NULL, 'Mandelate racemase/muconate lactonizing enzyme, conserved site', 'Mandel_Rmase/mucon_lact_enz_CS', 2, NULL),
(13682, NULL, 'IPR024633', NULL, 'DnaA N-terminal domain', 'DnaA_N_dom', 3, NULL),
(13683, NULL, 'IPR011823', NULL, '3-isopropylmalate dehydratase, large subunit, bacteria', 'IsopropMal_deHydtase_lsu_bac', 4, NULL),
(13684, NULL, 'IPR008806', NULL, 'RNA polymerase III Rpc82, C -terminal', 'RNA_pol_III_Rpc82_C', 3, NULL),
(13685, NULL, 'IPR013701', NULL, 'DEAD/H associated', 'DEAD/DEAH_assoc', 3, NULL),
(13686, NULL, 'IPR024291', NULL, 'Protein of unknown function DUF3829', 'DUF3829', 4, NULL),
(13687, NULL, 'IPR011867', NULL, 'Molybdate ABC transporter, permease protein', 'ModB_ABC', 4, NULL),
(13688, NULL, 'IPR024294', NULL, 'Protein of unknown function DUF3810', 'DUF3810', 4, NULL),
(13689, NULL, 'IPR018078', NULL, 'DNA-binding, RecF, conserved site', 'DNA-binding_RecF_CS', 2, NULL),
(13690, NULL, 'IPR018098', NULL, 'Ribosomal S24e conserved site', 'Ribosomal_S24e_CS', 2, NULL),
(13691, NULL, 'IPR013670', NULL, 'EcoEI R protein C-terminal domain', 'EcoEI_R_C_dom', 3, NULL),
(13692, NULL, 'IPR011427', NULL, 'Chlamydia polymorphic membrane, middle domain', 'Polymorphic_membr_middle', 3, NULL),
(13693, NULL, 'IPR012130', NULL, 'Photoactive yellow-protein', 'PYP', 4, NULL),
(13694, NULL, 'IPR015364', NULL, 'Rhamnogalacturonase B, N-terminal', 'RhgB_N', 3, NULL),
(13695, NULL, 'IPR023142', NULL, 'Microtubule-associated serine/threonine-protein kinase, pre-PK domain superfamily', 'MAST_pre-PK_dom_sf', 5, NULL),
(13696, NULL, 'IPR014111', NULL, 'Type IV conjugative transfer system protein TraF-like', 'T4SS_TraF-like', 4, NULL),
(13697, NULL, 'IPR013705', NULL, 'Sterol methyltransferase C-terminal', 'Sterol_MeTrfase_C', 3, NULL),
(13698, NULL, 'IPR011324', NULL, 'Cytotoxic necrotizing factor-like, catalytic', 'Cytotoxic_necrot_fac-like_cat', 5, NULL),
(13699, NULL, 'IPR015360', NULL, 'XPC-binding domain', 'XPC-bd', 3, NULL),
(13700, NULL, 'IPR013820', NULL, 'ATP phosphoribosyltransferase, catalytic domain', 'ATP_PRibTrfase_cat', 3, NULL),
(13701, NULL, 'IPR035935', NULL, 'TFB5-like superfamily', 'TFB5-like_sf', 5, NULL),
(13702, NULL, 'IPR020135', NULL, 'Uncharacterised protein family RP854', 'Uncharacterised_RP854', 4, NULL),
(13703, NULL, 'IPR024204', NULL, 'Cytochrome P450, cholesterol 7-alpha-monooxygenase-type', 'Cyt_P450_CYP7A1-type', 4, NULL),
(13704, NULL, 'IPR011453', NULL, 'Protein of unknown function DUF1559', 'DUF1559', 4, NULL),
(13705, NULL, 'IPR013704', NULL, 'Uncharacterised protein family UPF0313, N-terminal', 'UPF0313_N', 3, NULL),
(13706, NULL, 'IPR011834', NULL, 'Alpha-glucan phosphorylase', 'Agluc_phsphrylas', 4, NULL),
(13707, NULL, 'IPR020157', NULL, 'Uncharacterised protein family YqkC', 'Uncharacterised_YqkC', 4, NULL),
(13708, NULL, 'IPR013689', NULL, 'ATP-dependent RNA helicase HrpB, C-terminal', 'RNA_helicase_ATP-dep_HrpB_C', 3, NULL),
(13709, NULL, 'IPR009850', NULL, 'Domain of unknown function DUF1411', 'DUF1411', 3, NULL),
(13710, NULL, 'IPR011460', NULL, 'Protein of unknown function DUF1566', 'DUF1566', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(13711, NULL, 'IPR015362', NULL, 'WIBG, Mago-binding', 'WIBG_mago-bd', 3, NULL),
(13712, NULL, 'IPR011854', NULL, 'Carbamoyl dehydratase HypE', 'HypE', 4, NULL),
(13713, NULL, 'IPR020158', NULL, 'Protein of unknown function DUF2756', 'DUF2756', 4, NULL),
(13714, NULL, 'IPR008800', NULL, 'PufQ cytochrome subunit', 'PufQ_cyt-su', 4, NULL),
(13715, NULL, 'IPR020182', NULL, 'Protein of unknown function DUF5460', 'DUF5460', 4, NULL),
(13716, NULL, 'IPR008805', NULL, 'RIB43A', 'RIB43A', 4, NULL),
(13717, NULL, 'IPR011847', NULL, 'Phosphopantothenoylcysteine decarboxylase', 'CoaC_strep', 4, NULL),
(13718, NULL, 'IPR011865', NULL, 'Sulphate ABC transporter, permease protein CysT', 'CysT_permease', 4, NULL),
(13719, NULL, 'IPR020168', NULL, 'Uncharacterised protein family RP364', 'Uncharacterised_RP364', 4, NULL),
(13720, NULL, 'IPR011836', NULL, 'Conserved hypothetical protein CHP02099', 'CHP02099', 4, NULL),
(13721, NULL, 'IPR016092', NULL, 'FeS cluster insertion protein', 'FeS_cluster_insertion', 4, NULL),
(13722, NULL, 'IPR009269', NULL, 'NF-kappa-B-activating protein, C-terminal', 'NKAP_C', 3, NULL),
(13723, NULL, 'IPR011844', NULL, 'Coenzyme PQQ biosynthesis protein PqqF', 'PQQ_synth_PqqF', 4, NULL),
(13724, NULL, 'IPR024192', NULL, 'Fosfomycin resistance kinase, FomA-type', 'Fosfomycin_R_FomA-type', 4, NULL),
(13725, NULL, 'IPR008801', NULL, 'Rapid ALkalinization Factor', 'RALF', 4, NULL),
(13726, NULL, 'IPR008863', NULL, 'Toxic anion resistance', 'Toxic_anion-R_TelA', 4, NULL),
(13727, NULL, 'IPR011425', NULL, 'Mediator of RNA polymerase II transcription subunit 9', 'Med9', 4, NULL),
(13728, NULL, 'IPR011852', NULL, 'TRAP transporter solute receptor, TAXI family', 'TRAP_TAXI', 4, NULL),
(13729, NULL, 'IPR011447', NULL, 'Protein of unknown function DUF1552', 'DUF1552', 4, NULL),
(13730, NULL, 'IPR015357', NULL, 'Erythronolide synthase, docking', 'Erythronolide_synth_docking', 3, NULL),
(13731, NULL, 'IPR009286', NULL, 'Inositol-pentakisphosphate 2-kinase', 'Ins_P5_2-kin', 4, NULL),
(13732, NULL, 'IPR018105', NULL, 'Translationally controlled tumour protein', 'Translational_control_tumour_p', 4, NULL),
(13733, NULL, 'IPR008579', NULL, '(S)-ureidoglycine aminohydrolase, cupin domain', 'UGlyAH_Cupin_dom', 3, NULL),
(13734, NULL, 'IPR011825', NULL, '23S rRNA (uracil(747)-C(5))-methyltransferase RlmC', '23SrRNA_MeTrfase_RlmC', 4, NULL),
(13735, NULL, 'IPR024197', NULL, 'Trehalose phosphatase-like', 'TPP-like', 4, NULL),
(13736, NULL, 'IPR008796', NULL, 'Photosystem I reaction centre subunit N, chloroplastic', 'PSAN', 4, NULL),
(13737, NULL, 'IPR011842', NULL, 'Coenzyme PQQ biosynthesis protein B', 'PQQ_synth_PqqB', 4, NULL),
(13738, NULL, 'IPR011466', NULL, 'Protein of unknown function DUF1572', 'DUF1572', 4, NULL),
(13739, NULL, 'IPR014118', NULL, 'Type IV conjugative transfer system protein TraV', 'T4SS_TraV', 4, NULL),
(13740, NULL, 'IPR014129', NULL, 'Conjugative transfer relaxase protein TraI', 'Conjug_relaxase_TraI', 4, NULL),
(13741, NULL, 'IPR009285', NULL, 'Orthopoxvirus A26L/A30L', 'Orthopox_A30L/A26L', 4, NULL),
(13742, NULL, 'IPR012220', NULL, 'Glutamate synthase, eukaryotic', 'Glu_synth_euk', 4, NULL),
(13743, NULL, 'IPR013681', NULL, 'Myelin transcription factor 1', 'Myelin_TF', 3, NULL),
(13744, NULL, 'IPR009251', NULL, 'Alpha-2,3-sialyltransferase', 'A-2_3-sialyltransferase', 4, NULL),
(13745, NULL, 'IPR008838', NULL, 'Variable surface protein, Brachyspira', 'Variable_surface_protein_TREHY', 4, NULL),
(13746, NULL, 'IPR020181', NULL, 'Ant venom allergen, Sol i 2', 'Ant_venom_allergen_Sol_i_2', 4, NULL),
(13747, NULL, 'IPR024189', NULL, 'ANTAR transcription anti-termination regulator', 'ANTAR_transcrpt_antiterm_reg', 4, NULL),
(13748, NULL, 'IPR011862', NULL, 'Phosphate binding protein', 'Phos-bd', 4, NULL),
(13749, NULL, 'IPR034414', NULL, 'Dead end protein 1, RNA recognition motif 1', 'DND1_RRM1', 3, NULL),
(13750, NULL, 'IPR011467', NULL, 'Protein of unknown function DUF1573', 'DUF1573', 4, NULL),
(13751, NULL, 'IPR013695', NULL, 'Wall-associated receptor kinase', 'WAK', 3, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(13752, NULL, 'IPR013702', NULL, 'FIST domain, N-terminal', 'FIST_domain_N', 3, NULL),
(13753, NULL, 'IPR009249', NULL, 'Ferredoxin-dependent bilin reductase', 'Ferredoxin-dep_bilin_Rdtase', 4, NULL),
(13754, NULL, 'IPR009303', NULL, 'Protein of unknown function DUF960', 'DUF960', 4, NULL),
(13755, NULL, 'IPR034012', NULL, 'Pol II subunit B9, C-terminal zinc ribbon', 'Zn_ribbon_RPB9_C', 3, NULL),
(13756, NULL, 'IPR024199', NULL, 'Uncharacterised conserved protein, DsbB-like', 'Uncharacterised_DsbB', 4, NULL),
(13757, NULL, 'IPR008573', NULL, 'Baculovirus U-box/Ring-like', 'Baculovirus_U-box/Ring-like', 4, NULL),
(13758, NULL, 'IPR012133', NULL, 'Alpha-hydroxy acid dehydrogenase, FMN-dependent', 'Alpha-hydoxy_acid_DH_FMN', 4, NULL),
(13759, NULL, 'IPR014115', NULL, 'Type-F conjugative transfer system protein TrbI', 'TrbI_Ftype', 4, NULL),
(13760, NULL, 'IPR008845', NULL, 'Sporozoite P67 surface antigen', 'Sporozoite_P67', 4, NULL),
(13761, NULL, 'IPR024631', NULL, 'Transcription factor p53, C-terminal, Drosophila', 'p53_C_Drosophila', 3, NULL),
(13762, NULL, 'IPR011333', NULL, 'SKP1/BTB/POZ domain superfamily', 'SKP1/BTB/POZ_sf', 5, NULL),
(13763, NULL, 'IPR014113', NULL, 'Type-F conjugative transfer system pilin assembly protein TrbC, subgroup', 'T4SS_TrbC_subgr', 4, NULL),
(13764, NULL, 'IPR011331', NULL, 'Ribosomal protein L37ae/L37e', 'Ribosomal_L37ae/L37e', 5, NULL),
(13765, NULL, 'IPR008791', NULL, 'Orthopoxvirus interleukin 18 binding', 'Orthopox_IL18-bd', 4, NULL),
(13766, NULL, 'IPR020169', NULL, 'Intrinsic membrane protein family, PufX', 'Intrinsic_membrane_PufX', 4, NULL),
(13767, NULL, 'IPR013687', NULL, 'Disaggregatase-related', 'Disaggr-rel', 3, NULL),
(13768, NULL, 'IPR017995', NULL, 'Homeobox protein, antennapedia type', 'Homeobox_antennapedia', 4, NULL),
(13769, NULL, 'IPR011439', NULL, 'Domain of unknown function DUF1542', 'DUF1542', 3, NULL),
(13770, NULL, 'IPR034053', NULL, 'Tumor necrosis factor receptor 5, N-terminal, teleost', 'TNFRSF5_N_teleost', 3, NULL),
(13771, NULL, 'IPR013679', NULL, 'Sucrose-phosphatase, C-terminal', 'SPP_C', 3, NULL),
(13772, NULL, 'IPR009258', NULL, 'Bacteriophage T4, Gp30.8', 'Phage_T4_Gp30.8', 4, NULL),
(13773, NULL, 'IPR013694', NULL, 'VIT domain', 'VIT', 3, NULL),
(13774, NULL, 'IPR013711', NULL, 'Runx, C-terminal  domain', 'RunxI_C_dom', 3, NULL),
(13775, NULL, 'IPR011334', NULL, 'UDP-3-O-acyl N-acetylglucosamine deacetylase, C-terminal', 'UDP-acyl_GlcNac_deAcase_C', 5, NULL),
(13776, NULL, 'IPR013703', NULL, 'Peptidase S49, N-terminal proteobacteria', 'Peptidase_S49_N_proteobac', 3, NULL),
(13777, NULL, 'IPR008835', NULL, 'Sclerostin/Sclerostin domain-containing protein 1', 'Sclerostin/SOSTDC1', 4, NULL),
(13778, NULL, 'IPR008859', NULL, 'Thrombospondin, C-terminal', 'Thrombospondin_C', 3, NULL),
(13779, NULL, 'IPR008814', NULL, 'Dolichyl-diphosphooligosaccharide--protein glycosyltransferase subunit Swp1', 'Swp1', 4, NULL),
(13780, NULL, 'IPR009273', NULL, 'Protein of unknown function DUF930', 'DUF930', 4, NULL),
(13781, NULL, 'IPR024187', NULL, 'Signal transduction response regulator, citrate/malate metabolism', 'Sig_transdc_resp-reg_cit/mal', 4, NULL),
(13782, NULL, 'IPR012134', NULL, 'Glutamate-5-semialdehyde dehydrogenase', 'Glu-5-SA_DH', 4, NULL),
(13783, NULL, 'IPR020175', NULL, 'Herpesvirus glycoprotein L, rhadinovirus-type', 'Herpes_gL_rhadinovirus', 4, NULL),
(13784, NULL, 'IPR024188', NULL, 'Glutamate synthase large subunit-like protein', 'GltB', 4, NULL),
(13785, NULL, 'IPR018062', NULL, 'HTH domain AraC-type, conserved site', 'HTH_AraC-typ_CS', 2, NULL),
(13786, NULL, 'IPR011330', NULL, 'Glycoside hydrolase/deacetylase, beta/alpha-barrel', 'Glyco_hydro/deAcase_b/a-brl', 5, NULL),
(13787, NULL, 'IPR011869', NULL, 'tRNA/tmRNA (uracil-C(5))-methyltransferase, TrmA', 'TrmA_MeTrfase', 4, NULL),
(13788, NULL, 'IPR020170', NULL, 'Herpesvirus UL11, muromegalovirus/roseolovirus-type', 'Herpes_UL11_megaloV/roseoloV', 4, NULL),
(13789, NULL, 'IPR020201', NULL, 'Autographa californica nuclear polyhedrosis virus (AcMNPV), Orf52', 'AcMNPV_Orf52', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(13790, NULL, 'IPR011322', NULL, 'Nitrogen regulatory PII-like, alpha/beta', 'N-reg_PII-like_a/b', 5, NULL),
(13791, NULL, 'IPR013707', NULL, 'Tombusvirus p33', 'Tombusvirus_p33', 3, NULL),
(13792, NULL, 'IPR024203', NULL, '5-deoxy-glucuronate isomerase, IolB', 'Deoxy-glucuronate_isom_IolB', 4, NULL),
(13793, NULL, 'IPR012136', NULL, 'NADP transhydrogenase, beta subunit', 'NADH_DH_b', 4, NULL),
(13794, NULL, 'IPR009264', NULL, 'Autographa californica nuclear polyhedrosis virus (AcMNPV), Orf57', 'AcMNPV_Orf57', 4, NULL),
(13795, NULL, 'IPR020171', NULL, 'Uncharacterised protein family RC0039', 'Uncharacterised_RC0039', 4, NULL),
(13796, NULL, 'IPR013517', NULL, 'FG-GAP repeat', 'FG-GAP', 7, NULL),
(13797, NULL, 'IPR015820', NULL, 'Ty transposon capsid protein', 'TYA', 4, NULL),
(13798, NULL, 'IPR008856', NULL, 'Translocon-associated protein subunit beta', 'TRAP_beta', 4, NULL),
(13799, NULL, 'IPR024637', NULL, 'CTD kinase subunit gamma Ctk3, C-terminal', 'Ctk3_C', 3, NULL),
(13800, NULL, 'IPR018079', NULL, 'Ribosomal protein S4, conserved site', 'Ribosomal_S4_CS', 2, NULL),
(13801, NULL, 'IPR013697', NULL, 'DNA polymerase epsilon, catalytic subunit A, C-terminal', 'DNA_pol_e_suA_C', 3, NULL),
(13802, NULL, 'IPR011332', NULL, 'Zinc-binding ribosomal protein', 'Ribosomal_zn-bd', 5, NULL),
(13803, NULL, 'IPR013333', NULL, 'Ryanodine receptor', 'Ryan_recept', 4, NULL),
(13804, NULL, 'IPR018123', NULL, 'WWE domain, subgroup', 'WWE-dom_subgr', 3, NULL),
(13805, NULL, 'IPR011475', NULL, 'Domain of unknown function DUF1583', 'DUF1583', 3, NULL),
(13806, NULL, 'IPR017994', NULL, 'P-type trefoil, chordata', 'P_trefoil_chordata', 4, NULL),
(13807, NULL, 'IPR008855', NULL, 'Translocon-associated', 'TRAP-delta', 4, NULL),
(13808, NULL, 'IPR008577', NULL, 'Putative viral structural protein (DUF859)', 'DUF859', 4, NULL),
(13809, NULL, 'IPR013709', NULL, '2-isopropylmalate synthase LeuA, allosteric (dimerisation) domain', '2-isopropylmalate_synth_dimer', 3, NULL),
(13810, NULL, 'IPR011821', NULL, 'O-succinylhomoserine (thiol)-lyase', 'O_succ_thio_ly', 4, NULL),
(13811, NULL, 'IPR014124', NULL, 'Peptidase S26A, superoxide dismutase maturation protease, nickel-type', 'Pept_S26A_Sod_Ni_maturase', 4, NULL),
(13812, NULL, 'IPR015365', NULL, 'Elongation factor P, C-terminal', 'Elong-fact-P_C', 3, NULL),
(13813, NULL, 'IPR018096', NULL, 'Interleukin-4/interleukin-13, conserved site', 'IL-4/IL-13_CS', 2, NULL),
(13814, NULL, 'IPR008580', NULL, 'PPPDE peptidase domain', 'PPPDE_dom', 3, NULL),
(13815, NULL, 'IPR035906', NULL, 'MetI-like superfamily', 'MetI-like_sf', 5, NULL),
(13816, NULL, 'IPR009296', NULL, 'Protein of unknown function DUF951', 'DUF951', 4, NULL),
(13817, NULL, 'IPR013665', NULL, 'Sfi1 spindle body', 'Sfi1_dom', 3, NULL),
(13818, NULL, 'IPR011417', NULL, 'AP180 N-terminal homology (ANTH) domain', 'ANTH_dom', 3, NULL),
(13819, NULL, 'IPR009270', NULL, 'Domain of unknown function DUF927', 'DUF927', 3, NULL),
(13820, NULL, 'IPR009257', NULL, 'Chordopoxvirus A30L', 'Chordopox_A30L', 4, NULL),
(13821, NULL, 'IPR034290', NULL, 'Ephrin type-B receptor 4, ligand binding domain', 'EphB4_rcpt_lig-bd', 3, NULL),
(13822, NULL, 'IPR009287', NULL, 'Transcription initiation Spt4', 'Spt4', 4, NULL),
(13823, NULL, 'IPR014042', NULL, 'Glutathione synthase, alpha-helical', 'Glutathione_synthase_a-hlx', 5, NULL),
(13824, NULL, 'IPR024240', NULL, 'Alpha-N-acetylglucosaminidase, N-terminal', 'NAGLU_N', 3, NULL),
(13825, NULL, 'IPR008822', NULL, 'Holliday junction resolvase RusA-like', 'Endonuclease_RusA-like', 4, NULL),
(13826, NULL, 'IPR023183', NULL, 'Serine protease, chymotrypsin-like serine protease, C-terminal', 'Chymotrypsin-like_C', 5, NULL),
(13827, NULL, 'IPR011436', NULL, 'Domain of unknown function DUF1539', 'DUF1539', 3, NULL),
(13828, NULL, 'IPR024191', NULL, 'Peptidase M61', 'Peptidase_M61', 4, NULL),
(13829, NULL, 'IPR035934', NULL, 'Phage tail protein-like superfamily', 'Phage_tail_protein-like_sf', 5, NULL),
(13830, NULL, 'IPR008843', NULL, 'Entomopoxvirus spheroidin', 'Spheroidin', 4, NULL),
(13831, NULL, 'IPR009304', NULL, 'Herpesvirus Latent membrane 2', 'Herpes_LAMP2', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(13832, NULL, 'IPR012218', NULL, 'Cytochrome c, Bacillus subtilis c550-related', 'Cyt_c_BACSU-c550-rel', 4, NULL),
(13833, NULL, 'IPR018109', NULL, 'Folylpolyglutamate synthetase, conserved site', 'Folylpolyglutamate_synth_CS', 2, NULL),
(13834, NULL, 'IPR011851', NULL, 'Sodium/proline symporter', 'Na/Pro_symporter', 4, NULL),
(13835, NULL, 'IPR020183', NULL, 'Uncharacterised protein family RC0048', 'Uncharacterised_RC0048', 4, NULL),
(13836, NULL, 'IPR013693', NULL, 'Sporulation stage II protein D, amidase enhancer LytB N-terminal', 'SpoIID/LytB_N', 3, NULL),
(13837, NULL, 'IPR018040', NULL, 'Pectinesterase, Tyr active site', 'Pectinesterase_Tyr_AS', 0, NULL),
(13838, NULL, 'IPR008844', NULL, 'Spore germination GerAC-like', 'Spore_GerAC-like', 4, NULL),
(13839, NULL, 'IPR013696', NULL, 'Domain of unknown function DUF1743', 'DUF1743', 3, NULL),
(13840, NULL, 'IPR008853', NULL, 'TMEM9/TMEM9B', 'TMEM9/TMEM9B', 4, NULL),
(13841, NULL, 'IPR009248', NULL, 'SbmA/BacA-like', 'SbmA_BacA', 4, NULL),
(13842, NULL, 'IPR012233', NULL, 'Protein kinase C', 'PKC', 4, NULL),
(13843, NULL, 'IPR008811', NULL, 'Glycosyl hydrolases 36', 'Glycosyl_hydrolases_36', 4, NULL),
(13844, NULL, 'IPR013712', NULL, 'Mitochondrial Myo2 receptor-related protein 1', 'MMR1', 4, NULL),
(13845, NULL, 'IPR013683', NULL, 'Vaccinia virus D10,  N-terminal', 'Vaccinia_D10_N', 3, NULL),
(13846, NULL, 'IPR024638', NULL, 'CTD kinase subunit gamma Ctk3, N-terminal', 'Ctk3_N', 3, NULL),
(13847, NULL, 'IPR009292', NULL, 'rRNA biogenesis protein RRP36', 'RRP36', 4, NULL),
(13848, NULL, 'IPR008821', NULL, 'Rubella membrane glycoprotein E2', 'Rubella_E2', 3, NULL),
(13849, NULL, 'IPR008827', NULL, 'Synaptonemal complex protein 1', 'SYCP1', 4, NULL),
(13850, NULL, 'IPR008849', NULL, 'Synaphin', 'Synaphin', 4, NULL),
(13851, NULL, 'IPR011443', NULL, 'Domain of unknown function DUF1547', 'DUF1547', 3, NULL),
(13852, NULL, 'IPR009295', NULL, 'S. aureus uracil DNA glycosylase inhibitor', 'SAUGI', 4, NULL),
(13853, NULL, 'IPR009259', NULL, 'Drosophila roughex', 'Roughex', 4, NULL),
(13854, NULL, 'IPR034435', NULL, 'Probable RNA-binding protein 46, RNA recognition motif 2', 'RBM46_RRM2', 3, NULL),
(13855, NULL, 'IPR008858', NULL, 'TROVE domain', 'TROVE_dom', 3, NULL),
(13856, NULL, 'IPR020156', NULL, 'Protein of unknown function DUF5490', 'DUF5490', 4, NULL),
(13857, NULL, 'IPR011839', NULL, 'Alpha-1,6-glucosidases, pullulanase-type', 'Pullul_strch', 3, NULL),
(13858, NULL, 'IPR012235', NULL, '3-isopropylmalate dehydratase, fused small/large subunit', '3-IsopropMal_deHydtase_ssu/lsu', 4, NULL),
(13859, NULL, 'IPR034047', NULL, 'Tumor necrosis factor receptor 19, N-terminal', 'TNFRSF19_N', 3, NULL),
(13860, NULL, 'IPR013666', NULL, 'Pleckstrin-like, plant', 'PH_pln', 3, NULL),
(13861, NULL, 'IPR012234', NULL, 'Tyrosine-protein kinase, non-receptor SYK/ZAP-70', 'Tyr_kinase_non-rcpt_SYK/ZAP70', 4, NULL),
(13862, NULL, 'IPR008825', NULL, 'S-antigen', 'S-antigen', 3, NULL),
(13863, NULL, 'IPR018099', NULL, 'Purine phosphorylase, family 2, conserved site', 'Purine_phosphorylase-2_CS', 2, NULL),
(13864, NULL, 'IPR018119', NULL, 'Strictosidine synthase, conserved region', 'Strictosidine_synth_cons-reg', 3, NULL),
(13865, NULL, 'IPR012211', NULL, 'Insulin-like growth factor binding protein 3', 'IGFBP-3', 4, NULL),
(13866, NULL, 'IPR024629', NULL, 'Mitochondrial homologous recombination protein 1', 'Mhr1', 4, NULL),
(13867, NULL, 'IPR018044', NULL, 'Peptidase S11, D-alanyl-D-alanine carboxypeptidase A', 'Peptidase_S11', 4, NULL),
(13868, NULL, 'IPR018086', NULL, 'NADH:ubiquinone oxidoreductase, subunit 1, conserved site', 'NADH_UbQ_OxRdtase_su1_CS', 2, NULL),
(13869, NULL, 'IPR034839', NULL, 'Glycerophosphocholine phosphodiesterase GPCPD1, CBM20 domain', 'CBM20_GPCPD1', 3, NULL),
(13870, NULL, 'IPR008828', NULL, 'TORC2 component Sin1/Avo1', 'Sin1/Avo1', 4, NULL),
(13871, NULL, 'IPR008818', NULL, 'Rotavirus major outer capsid VP7', 'Rotavirus_VP7', 4, NULL),
(13872, NULL, 'IPR011474', NULL, 'Protein of unknown function DUF1580', 'DUF1580', 4, NULL),
(13873, NULL, 'IPR008810', NULL, 'Rhodococcus equi virulence-associated protein', 'R_equi_Vir', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(13874, NULL, 'IPR013708', NULL, 'Shikimate dehydrogenase substrate binding, N-terminal', 'Shikimate_DH-bd_N', 3, NULL),
(13875, NULL, 'IPR011473', NULL, 'Protein of unknown function DUF1579', 'DUF1579', 4, NULL),
(13876, NULL, 'IPR034156', NULL, 'HRP1, RNA recognition motif 1', 'Hrp1_RRM1', 3, NULL),
(13877, NULL, 'IPR018103', NULL, 'Translationally controlled tumour protein, conserved site', 'Translation_control_tumour_CS', 2, NULL),
(13878, NULL, 'IPR009307', NULL, 'Bacterial microcompartment shell protein EutS/PduU/CutR', 'EutS/PduU/CutR', 4, NULL),
(13879, NULL, 'IPR011327', NULL, 'Killer toxin, SMK, beta subunit', 'Killer_tox_SMK_b', 3, NULL),
(13880, NULL, 'IPR011421', NULL, 'BCNT-C domain', 'BCNT-C', 3, NULL),
(13881, NULL, 'IPR034155', NULL, 'HRP1, RNA recognition motif 2', 'Hrp1_RRM2', 3, NULL),
(13882, NULL, 'IPR012224', NULL, 'Peptidase S1A, coagulation factor VII/IX/X/C/Z', 'Pept_S1A_FX', 4, NULL),
(13883, NULL, 'IPR008576', NULL, 'Alpha-N-methyltransferase NTM1', 'MeTrfase_NTM1', 4, NULL),
(13884, NULL, 'IPR024636', NULL, 'Histone lysine methyltransferase SET associated', 'SET_assoc', 3, NULL),
(13885, NULL, 'IPR009283', NULL, 'Apyrase', 'Apyrase', 4, NULL),
(13886, NULL, 'IPR011850', NULL, 'Type II secretion system protein  GspF', 'T2SS_GspF', 4, NULL),
(13887, NULL, 'IPR008802', NULL, 'Rubber elongation factor', 'REF', 4, NULL),
(13888, NULL, 'IPR018087', NULL, 'Glycoside hydrolase, family 5, conserved site', 'Glyco_hydro_5_CS', 2, NULL),
(13889, NULL, 'IPR008833', NULL, 'Surfeit locus protein 2', 'Surf2', 4, NULL),
(13890, NULL, 'IPR011831', NULL, 'Glucose-1-phosphate adenylyltransferase', 'ADP-Glc_PPase', 4, NULL),
(13891, NULL, 'IPR020134', NULL, 'Bacteriophage T7-like, protein 6.7', 'Phage_T7-like_6.7', 4, NULL),
(13892, NULL, 'IPR014112', NULL, 'Type-F conjugative transfer system pilin chaperone TraQ, proteobacteria', 'TraQ_proteobacteria', 4, NULL),
(13893, NULL, 'IPR012131', NULL, 'Histidinol dehydrogenase', 'Hstdl_DH', 4, NULL),
(13894, NULL, 'IPR009281', NULL, 'Transmembrane protein 176A/B', 'TMEM176A/TMEM176B', 4, NULL),
(13895, NULL, 'IPR012300', NULL, 'Peptidase M6, InhA', 'Pept_M6_InhA', 4, NULL),
(13896, NULL, 'IPR011849', NULL, 'Sodium/pantothenate symporter', 'Na/pantothenate_symporter', 4, NULL),
(13897, NULL, 'IPR009254', NULL, 'Laminin alpha, domain I', 'Laminin_aI', 3, NULL),
(13898, NULL, 'IPR009256', NULL, 'YqgQ-like', 'YqgQ-like', 4, NULL),
(13899, NULL, 'IPR020133', NULL, 'Decidual protein, progesterone induced', 'DEPP', 4, NULL),
(13900, NULL, 'IPR008819', NULL, 'Rubella capsid', 'Rubella_Capsid', 4, NULL),
(13901, NULL, 'IPR011848', NULL, 'Phosphopantothenate--cysteine ligase', 'CoaB_strep', 4, NULL),
(13902, NULL, 'IPR011442', NULL, 'TAF6, C-terminal HEAT repeat domain', 'TAF6_C', 3, NULL),
(13903, NULL, 'IPR009291', NULL, 'Vacuolar protein sorting-associated protein 62', 'Vps62', 4, NULL),
(13904, NULL, 'IPR020123', NULL, 'Protein of unknown function DUF5475', 'DUF5475', 4, NULL),
(13905, NULL, 'IPR023141', NULL, 'Ammonia/methane monooxygenase, subunit B, hairpin domain superfamily', 'NH3_CH4_mOase_suB_hlx_hairpin', 5, NULL),
(13906, NULL, 'IPR018083', NULL, 'Sterol reductase, conserved site', 'Sterol_reductase_CS', 2, NULL),
(13907, NULL, 'IPR009261', NULL, 'Autographa californica nuclear polyhedrosis virus (AcMNPV), Protein AC78', 'AcMNPV_AC78', 4, NULL),
(13908, NULL, 'IPR018114', NULL, 'Serine proteases, trypsin family, histidine active site', 'TRYPSIN_HIS', 0, NULL),
(13909, NULL, 'IPR011866', NULL, 'Sulphate ABC transporter, permease protein CysW', 'CysW_permease', 4, NULL),
(13910, NULL, 'IPR013087', NULL, 'Zinc finger C2H2-type', 'Znf_C2H2_type', 3, NULL),
(13911, NULL, 'IPR014128', NULL, 'Type IV conjugative transfer system, coupling protein TraD', 'T4SS_TraD', 4, NULL),
(13912, NULL, 'IPR011428', NULL, 'Spore coat protein X/V', 'Spore_coat_X/V', 3, NULL),
(13913, NULL, 'IPR012138', NULL, 'Hydroxylamine oxidase', 'HAO', 4, NULL),
(13914, NULL, 'IPR011829', NULL, 'Tartrate dehydrogenase', 'TTC_DH', 4, NULL),
(13915, NULL, 'IPR018056', NULL, 'Kringle, conserved site', 'Kringle_CS', 2, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(13916, NULL, 'IPR011329', NULL, 'Killer toxin Kp4/SMK', 'Killer_tox_Kp4/SMK', 5, NULL),
(13917, NULL, 'IPR011458', NULL, 'Protein of unknown function DUF1564', 'DUF1564', 4, NULL),
(13918, NULL, 'IPR013699', NULL, 'Signal recognition particle, SRP72 subunit, RNA-binding', 'Signal_recog_part_SRP72_RNA-bd', 3, NULL),
(13919, NULL, 'IPR011438', NULL, 'Domain of unknown function DUF1541', 'DUF1541', 3, NULL),
(13920, NULL, 'IPR011471', NULL, 'Protein of unknown function DUF1577', 'DUF1577', 4, NULL),
(13921, NULL, 'IPR011444', NULL, 'Domain of unknown function DUF1549', 'DUF1549', 3, NULL),
(13922, NULL, 'IPR023186', NULL, 'Inosine/uridine-preferring nucleoside hydrolase', 'IUNH', 4, NULL),
(13923, NULL, 'IPR009274', NULL, 'Host-nuclease inhibitor Gam', 'Gam', 4, NULL),
(13924, NULL, 'IPR009308', NULL, 'Rhamnose isomerase', 'Rhamnose_isomerase', 4, NULL),
(13925, NULL, 'IPR011845', NULL, 'Coenzyme PQQ biosynthesis protein C', 'PqqC', 4, NULL),
(13926, NULL, 'IPR011459', NULL, 'Domain of unknown function DUF1565', 'DUF1565', 3, NULL),
(13927, NULL, 'IPR011856', NULL, 'tRNA endonuclease-like domain superfamily', 'tRNA_endonuc-like_dom_sf', 5, NULL),
(13928, NULL, 'IPR024483', NULL, 'Protein of unknown function DUF2700', 'DUF2700', 4, NULL),
(13929, NULL, 'IPR014110', NULL, 'Type-F conjugative transfer system pilin assembly protein TraF', 'TraF', 4, NULL),
(13930, NULL, 'IPR020164', NULL, 'Cytochrome c oxidase assembly protein COX16', 'Cyt_c_Oxase_assmbl_COX16', 4, NULL),
(13931, NULL, 'IPR013673', NULL, 'Potassium channel, inwardly rectifying, Kir, N-terminal', 'K_chnl_inward-rec_Kir_N', 3, NULL),
(13932, NULL, 'IPR018142', NULL, 'Somatostatin/Cortistatin, C-terminal', 'Somatostatin/Cortistatin_C', 3, NULL),
(13933, NULL, 'IPR009265', NULL, 'Autographa californica nuclear polyhedrosis virus (AcMNPV), Orf29', 'AcMNPV_Orf29', 4, NULL),
(13934, NULL, 'IPR011431', NULL, 'Protein trafficking Pga2', 'Trafficking_Pga2', 4, NULL),
(13935, NULL, 'IPR024642', NULL, 'SUZ-C domain', 'SUZ-C', 3, NULL),
(13936, NULL, 'IPR008812', NULL, 'GTP-binding nuclear protein Ran-related', 'Ran_GTP-bd-rel', 4, NULL),
(13937, NULL, 'IPR011822', NULL, 'Cobalamin-dependent methionine synthase', 'MetH', 4, NULL),
(13938, NULL, 'IPR016128', NULL, 'Pyosin/cloacin translocation domain', 'Pyosin/cloacin_T_dom', 3, NULL),
(13939, NULL, 'IPR008857', NULL, 'Thyrotropin-releasing hormone', 'TRH', 4, NULL),
(13940, NULL, 'IPR011336', NULL, 'Restriction endonuclease, type II, EcoRI/MunI', 'Restrct_endonuc_II_EcoRI/MunI', 5, NULL),
(13941, NULL, 'IPR018154', NULL, 'TLV/ENV coat polyprotein', 'TLV/ENV_coat_polyprotein', 4, NULL),
(13942, NULL, 'IPR012226', NULL, 'Diguanylate cyclase/phosphodiesterase', 'Diguanyl_cyclase/Pdiesterase', 4, NULL),
(13943, NULL, 'IPR018143', NULL, 'Folate receptor-like', 'Folate_rcpt-like', 3, NULL),
(13944, NULL, 'IPR018159', NULL, 'Spectrin/alpha-actinin', 'Spectrin/alpha-actinin', 7, NULL),
(13945, NULL, 'IPR020127', NULL, 'Colicin-E5 immunity protein', 'Colicin-E5_imm', 4, NULL),
(13946, NULL, 'IPR011455', NULL, 'Protein of unknown function DUF1561', 'DUF1561', 4, NULL),
(13947, NULL, 'IPR012292', NULL, 'Globin/Protoglobin', 'Globin/Proto', 5, NULL),
(13948, NULL, 'IPR011819', NULL, 'Pyrococcus aspartate kinase subunit, putative', 'AspKin_pair', 4, NULL),
(13949, NULL, 'IPR008839', NULL, 'Mitochondrial distribution and morphology family 33, fungi', 'MDM33_fungi', 4, NULL),
(13950, NULL, 'IPR024196', NULL, '[NiFe]-hydrogenase-3-type complex Eha, EhaR', 'NiFe_hyd_3_EhaR', 4, NULL),
(13951, NULL, 'IPR011864', NULL, 'Phosphate ABC transporter, permease protein PstC', 'Phosphate_PstC', 4, NULL),
(13952, NULL, 'IPR009252', NULL, 'Cell division protein ZapB', 'Cell_div_ZapB', 4, NULL),
(13953, NULL, 'IPR009284', NULL, 'Cytomegalovirus TRL10', 'Cytomega_TRL10', 4, NULL),
(13954, NULL, 'IPR011328', NULL, 'Salt-mediated killer toxin, alpha subunit', 'SMK_a', 5, NULL),
(13955, NULL, 'IPR008846', NULL, 'Phenol-soluble modulin beta protein', 'PSMbeta', 4, NULL),
(13956, NULL, 'IPR009848', NULL, 'Protein of unknown function DUF1408', 'DUF1408', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(13957, NULL, 'IPR011434', NULL, 'Putative host cell surface-exposed lipoprotein Ltp-like, HTH region', 'Ltp-like_HTH', 3, NULL),
(13958, NULL, 'IPR009271', NULL, 'Coagulation factor V, LSPD', 'Coagulation_factor_V_LSPD', 7, NULL),
(13959, NULL, 'IPR012142', NULL, 'Tryptophan 2-monooxygenase', 'Trp_2-mOase', 4, NULL),
(13960, NULL, 'IPR008816', NULL, 'Glycine zipper 2TM domain', 'Gly_zipper_2TM_dom', 3, NULL),
(13961, NULL, 'IPR012135', NULL, 'Dihydroorotate dehydrogenase, class 1/ 2', 'Dihydroorotate_DH_1_2', 4, NULL),
(13962, NULL, 'IPR008803', NULL, 'RHD3/Sey1', 'RHD3/Sey1', 4, NULL),
(13963, NULL, 'IPR014114', NULL, 'Type-F conjugative transfer system protein TraW', 'TraW', 4, NULL),
(13964, NULL, 'IPR014125', NULL, 'Type-F conjugative transfer system pilin acetylase TraX', 'TraX_Ftype', 4, NULL),
(13965, NULL, 'IPR024630', NULL, 'Stc1 domain', 'Stc1', 3, NULL),
(13966, NULL, 'IPR009245', NULL, 'Herpesvirus UL22A', 'Cytomegalo_UL22A', 4, NULL),
(13967, NULL, 'IPR013672', NULL, 'Herpesvirus thymidine kinase, C-terminal', 'Herpes_TK_C', 3, NULL),
(13968, NULL, 'IPR012121', NULL, 'ATPase, PP-loop, MJ1599-related', 'ATPase_PP-loop_MJ1599', 4, NULL),
(13969, NULL, 'IPR011827', NULL, 'Hydrolyase LeuD/HacB/DmdB', 'LeuD_type2/HacB/DmdB', 4, NULL),
(13970, NULL, 'IPR024201', NULL, 'Calcineurin-like phosphoesterase', 'Calcineurin-like_Pesterase', 4, NULL),
(13971, NULL, 'IPR034253', NULL, 'Carboxypeptidase B, carboxypeptidase domain', 'CPB_M14_CPD', 3, NULL),
(13972, NULL, 'IPR020202', NULL, 'Atracotoxin', 'Atracotoxin', 4, NULL),
(13973, NULL, 'IPR013024', NULL, 'Gamma-glutamyl cyclotransferase-like', 'GGCT-like', 3, NULL),
(13974, NULL, 'IPR018085', NULL, 'Uracil-DNA glycosylase, active site', 'Ura-DNA_Glyclase_AS', 0, NULL),
(13975, NULL, 'IPR018104', NULL, 'Translation initiation factor 1A (eIF-1A), conserved site', 'TIF_eIF-1A_CS', 2, NULL),
(13976, NULL, 'IPR009290', NULL, 'Radial spoke 3', 'Radial_spoke_3', 4, NULL),
(13977, NULL, 'IPR011338', NULL, 'Restriction endonuclease, type II, BamHI/BglIII/BstY', 'BamHI/BglII/BstY', 5, NULL),
(13978, NULL, 'IPR009242', NULL, 'Protein of unknown function DUF896', 'DUF896', 4, NULL),
(13979, NULL, 'IPR018102', NULL, 'Ribosomal S11, conserved site', 'Ribosomal_S11_CS', 2, NULL),
(13980, NULL, 'IPR011868', NULL, 'Molybdate ABC transporter, ATP-binding protein', 'ModC_ABC_ATP-bd', 4, NULL),
(13981, NULL, 'IPR018106', NULL, 'CAP, conserved site, N-terminal', 'CAP_CS_N', 2, NULL),
(13982, NULL, 'IPR011419', NULL, 'ATP12, ATP synthase F1-assembly protein', 'ATP12_ATP_synth-F1-assembly', 4, NULL),
(13983, NULL, 'IPR013676', NULL, 'Nucleoside triphosphatase I, C-terminal', 'NPHI_C', 3, NULL),
(13984, NULL, 'IPR008829', NULL, 'SepSecS/SepCysS family', 'SepSecS/SepCysS', 4, NULL),
(13985, NULL, 'IPR008789', NULL, 'Poxvirus intermediate transcription factor', 'Poxvirus_intermed-TF', 4, NULL),
(13986, NULL, 'IPR013668', NULL, 'Ribonuclease R winged-helix domain', 'RNase_R_HTH_12', 3, NULL),
(13987, NULL, 'IPR012213', NULL, 'Insulin-like growth factor binding protein 5', 'IGFBP-5', 4, NULL),
(13988, NULL, 'IPR034171', NULL, 'Peroxisomal acyl-coenzyme A oxidase', 'ACO', 4, NULL),
(13989, NULL, 'IPR013674', NULL, 'Luteovirus RNA polymerase P1-P2/replicase', 'Luteo_Rpol_P1-P2', 3, NULL),
(13990, NULL, 'IPR011837', NULL, 'Glycogen debranching enzyme, GlgX type', 'Glycogen_debranch_GlgX', 4, NULL),
(13991, NULL, 'IPR011426', NULL, 'CamS sex pheromone cAM373', 'CamS', 4, NULL),
(13992, NULL, 'IPR013675', NULL, 'Methyltransferase small, N-terminal', 'Mtase_sm_N', 3, NULL),
(13993, NULL, 'IPR035027', NULL, 'CSK-like, SH2 domain', 'Csk-like_SH2', 3, NULL),
(13994, NULL, 'IPR008799', NULL, 'Pseudomonas avirulence D', 'Pseudomon_AvrD', 4, NULL),
(13995, NULL, 'IPR011841', NULL, 'Type III secretion system, needle protein', 'T3SS_needle_YscF', 4, NULL),
(13996, NULL, 'IPR008837', NULL, 'Serendipity locus alpha', 'Serendipity_A', 4, NULL),
(13997, NULL, 'IPR008824', NULL, 'RuvB-like P-loop domain', 'RuvB-like_N', 3, NULL),
(13998, NULL, 'IPR009244', NULL, 'Mediator complex, subunit Med7', 'Mediatior_Med7', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(13999, NULL, 'IPR015870', NULL, 'UDP-3-O-acyl N-acetylglucosamine deacetylase, N-terminal', 'UDP-acyl_N-AcGlcN_deAcase_N', 5, NULL),
(14000, NULL, 'IPR012297', NULL, 'Restriction endonuclease EcoO109IR, catalytic domain superfamily', 'EcoO109IR_cat_dom_sf', 5, NULL),
(14001, NULL, 'IPR014140', NULL, 'DNA helicase subunit AddB', 'DNA_helicase_suAddB', 4, NULL),
(14002, NULL, 'IPR015383', NULL, 'Cortexillin, coiled coil', 'Cortexillin-I_coiled-coil', 3, NULL),
(14003, NULL, 'IPR008604', NULL, 'Microtubule-associated protein 7 family', 'MAP7_fam', 4, NULL),
(14004, NULL, 'IPR014081', NULL, 'Branched-chain phosphotransacylase', 'Brnchd-chn_Ptransacetylase', 4, NULL),
(14005, NULL, 'IPR014934', NULL, 'Protein of unknown function DUF1806', 'DUF1806', 4, NULL),
(14006, NULL, 'IPR008606', NULL, 'Eukaryotic translation initiation factor 4E binding', 'EIF4EBP', 4, NULL),
(14007, NULL, 'IPR015395', NULL, 'C-myb, C-terminal', 'C-myb_C', 3, NULL),
(14008, NULL, 'IPR013037', NULL, 'Clathrin adaptor, beta-adaptin, appendage, Ig-like subdomain', 'Clathrin_b-adaptin_app_Ig-like', 5, NULL),
(14009, NULL, 'IPR012332', NULL, 'Autotransporter, pectate lyase C-like domain superfamily', 'Autotransporter_pectin_lyase_C', 5, NULL),
(14010, NULL, 'IPR008638', NULL, 'Filamentous haemagglutinin FhaB/tRNA nuclease CdiA-like, TPS domain', 'FhaB/CdiA-like_TPS', 3, NULL),
(14011, NULL, 'IPR009313', NULL, 'Baculovirus 11kDa', 'Baculo_11_kDa', 4, NULL),
(14012, NULL, 'IPR034274', NULL, 'ENP1, carboxypeptidase domain', 'ENP1_M14_CPD', 3, NULL),
(14013, NULL, 'IPR010538', NULL, 'Di-haem oxidoreductase, putative peroxidase', 'DHOR', 4, NULL),
(14014, NULL, 'IPR012448', NULL, 'Protein of unknown function DUF1652', 'DUF1652', 4, NULL),
(14015, NULL, 'IPR009879', NULL, 'Phlebovirus nonstructural NS-M', 'Phlebovirus_NSM', 3, NULL),
(14016, NULL, 'IPR014947', NULL, 'Protein of unknown function DUF1818', 'DUF1818', 4, NULL),
(14017, NULL, 'IPR009858', NULL, 'Protein of unknown function DUF1415', 'DUF1415', 4, NULL),
(14018, NULL, 'IPR008584', NULL, 'CXXC motif containing zinc binding protein, eukaryotic', 'CXXC_Zn-binding_euk', 4, NULL),
(14019, NULL, 'IPR015410', NULL, 'Domain of unknown function DUF1985', 'DUF1985', 3, NULL),
(14020, NULL, 'IPR034269', NULL, 'At5g42320-like, carboxypeptidase domain', 'At5g42320_M14_CPD', 3, NULL),
(14021, NULL, 'IPR009330', NULL, 'Lipopolysaccharide core heptose(II) kinase', 'LipoPS_heptP_kinase', 4, NULL),
(14022, NULL, 'IPR013929', NULL, 'RNA polymerase II-associated protein 1, C-terminal', 'RNA_pol_II_AP1_C', 3, NULL),
(14023, NULL, 'IPR009347', NULL, 'Rice tungro bacilliform virus P46', 'RTBV_P46', 4, NULL),
(14024, NULL, 'IPR009875', NULL, 'PilZ domain', 'PilZ_domain', 3, NULL),
(14025, NULL, 'IPR009323', NULL, 'Protein of unknown function DUF979', 'DUF979', 4, NULL),
(14026, NULL, 'IPR009889', NULL, 'Dentin matrix 1', 'DMP1', 4, NULL),
(14027, NULL, 'IPR015389', NULL, 'POU, class 2, associating factor 1', 'PD-C2-AF1', 4, NULL),
(14028, NULL, 'IPR014969', NULL, 'DNA sulphur modification protein DndE', 'DNA_S_DndE', 4, NULL),
(14029, NULL, 'IPR010533', NULL, 'Vertebrate interleukin-3 regulated transcription factor', 'Vert_IL3-reg_TF', 3, NULL),
(14030, NULL, 'IPR008621', NULL, 'Cbb3-type cytochrome oxidase component', 'Cbb3-typ_cyt_oxidase_comp', 4, NULL),
(14031, NULL, 'IPR014108', NULL, 'Cytochrome c oxidase caa3 type assembly factor CtaG', 'Caa3-assmbl_CtaG', 4, NULL),
(14032, NULL, 'IPR013939', NULL, 'Regulatory subunit Dfp1/Him1, central region', 'Regulatory_Dfp1/Him1', 3, NULL),
(14033, NULL, 'IPR008631', NULL, 'Glycogen synthase', 'Glycogen_synth', 4, NULL),
(14034, NULL, 'IPR009361', NULL, 'RZZ complex, subunit Zw10', 'RZZ-complex_Zw10', 4, NULL),
(14035, NULL, 'IPR014966', NULL, 'FRG domain', 'FRG-dom', 3, NULL),
(14036, NULL, 'IPR014963', NULL, 'Uncharacterised domain UPF0302, N-terminal', 'UPF0302_N', 3, NULL),
(14037, NULL, 'IPR013940', NULL, 'Meiosis specific protein Spo22/ZIP4/TEX11', 'Spo22/ZIP4/TEX11', 4, NULL),
(14038, NULL, 'IPR008636', NULL, 'Hook, C-terminal', 'Hook_C', 3, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(14039, NULL, 'IPR008632', NULL, 'Nematode fatty acid retinoid binding', 'Gp-FAR-1', 4, NULL),
(14040, NULL, 'IPR013035', NULL, 'Phosphoenolpyruvate carboxykinase, C-terminal', 'PEP_carboxykinase_C', 5, NULL),
(14041, NULL, 'IPR012438', NULL, 'Protein of unknown function DUF1639', 'DUF1639', 4, NULL),
(14042, NULL, 'IPR009345', NULL, 'BMP and activin membrane-bound inhibitor', 'BAMBI', 4, NULL),
(14043, NULL, 'IPR014143', NULL, 'DNA ligase D', 'NHEJ_ligase_prk', 3, NULL),
(14044, NULL, 'IPR015405', NULL, 'NADH-quinone oxidoreductase, chain G, C-terminal', 'NuoG_C', 3, NULL),
(14045, NULL, 'IPR015379', NULL, 'Tectiviridae, minor capsid', 'Tecti-min-caps', 4, NULL),
(14046, NULL, 'IPR012331', NULL, 'Clathrin, heavy chain, linker', 'Clathrin_H-chain_linker', 5, NULL),
(14047, NULL, 'IPR012334', NULL, 'Pectin lyase fold', 'Pectin_lyas_fold', 5, NULL),
(14048, NULL, 'IPR009321', NULL, 'Protein of unknown function DUF973', 'DUF973', 4, NULL),
(14049, NULL, 'IPR013928', NULL, 'Alkali metal cation/H+ antiporter Nha1, C-terminal', 'Cation/H_antiporter_C', 3, NULL),
(14050, NULL, 'IPR009346', NULL, 'GRIM-19', 'GRIM-19', 4, NULL),
(14051, NULL, 'IPR014959', NULL, 'Protein of unknown function DUF1827', 'DUF1827', 4, NULL),
(14052, NULL, 'IPR014090', NULL, 'Siderophore transporter, RhtX/FptX family', 'Siderophore_transpt_RhtX/FptX', 4, NULL),
(14053, NULL, 'IPR012471', NULL, 'Protein of unknown function DUF1690', 'DUF1690', 4, NULL),
(14054, NULL, 'IPR014096', NULL, 'Phenylphosphate carboxylase, beta subunit', 'Phenyl_P_COase_b', 4, NULL),
(14055, NULL, 'IPR023267', NULL, 'RNA (C5-cytosine) methyltransferase', 'RCMT', 4, NULL),
(14056, NULL, 'IPR012460', NULL, 'Protein of unknown function DUF1667', 'DUF1667', 4, NULL),
(14057, NULL, 'IPR009342', NULL, 'Putative carbohydrate binding domain', 'Carb-bd_put_dom', 3, NULL),
(14058, NULL, 'IPR014088', NULL, 'C-20 methyltransferase CrtF-related', 'C20_MeTrfase_CrtF', 4, NULL),
(14059, NULL, 'IPR008611', NULL, 'Protein EaeB', 'EaeB', 4, NULL),
(14060, NULL, 'IPR009914', NULL, 'Dolichol phosphate-mannose biosynthesis regulatory', 'DPM2', 4, NULL),
(14061, NULL, 'IPR012436', NULL, 'Protein of unknown function DUF1633', 'DUF1633', 4, NULL),
(14062, NULL, 'IPR015406', NULL, 'Domain of unknown function DUF1983', 'DUF1983', 3, NULL),
(14063, NULL, 'IPR012472', NULL, 'Mitochondrial adapter protein MCP1, transmembrane domain', 'MCP1_TM', 3, NULL),
(14064, NULL, 'IPR014927', NULL, 'Putative peptidoglycan binding', 'PG-bd_2', 3, NULL),
(14065, NULL, 'IPR008618', NULL, 'Protein S10', 'S10', 4, NULL),
(14066, NULL, 'IPR009899', NULL, 'Antirestriction', 'ArdA', 4, NULL),
(14067, NULL, 'IPR012465', NULL, 'Protein of unknown function DUF1678', 'DUF1678', 4, NULL),
(14068, NULL, 'IPR014159', NULL, 'Protocatechuate 4,5-dioxygenase, alpha subunit', 'PCA_LigA', 4, NULL),
(14069, NULL, 'IPR014926', NULL, 'Bacteriophage D3112, Orf24', 'Phage_D3112_Orf24', 4, NULL),
(14070, NULL, 'IPR009861', NULL, 'Hematopoietic cell signal transducer', 'HCST', 4, NULL),
(14071, NULL, 'IPR013930', NULL, 'RNA polymerase II-associated protein 1, N-terminal', 'RNA_pol_II_AP1_N', 3, NULL),
(14072, NULL, 'IPR015872', NULL, 'Transcription initiation factor IIA, gamma subunit, N-terminal', 'TFIIA_gsu_N', 3, NULL),
(14073, NULL, 'IPR012450', NULL, 'Bacteriophage bIL310, Orf15', 'Phage_bIL310_Orf15', 4, NULL),
(14074, NULL, 'IPR008629', NULL, 'GUN4-like', 'GUN4-like', 3, NULL),
(14075, NULL, 'IPR015402', NULL, 'Protein of unknown function DUF1980', 'DUF1980', 4, NULL),
(14076, NULL, 'IPR009897', NULL, 'Orthoreovirus P17', 'Orthoreo_P17', 4, NULL),
(14077, NULL, 'IPR015408', NULL, 'Zinc finger, Mcm10/DnaG-type', 'Znf_Mcm10/DnaG', 3, NULL),
(14078, NULL, 'IPR009859', NULL, 'Protein of unknown function, Gam-like', 'Gam-like', 4, NULL),
(14079, NULL, 'IPR014973', NULL, 'Protein of unknown function DUF1835', 'DUF1835', 4, NULL),
(14080, NULL, 'IPR014098', NULL, 'Phenylphosphate carboxylase, delta subunit', 'Phenyl_P_COase_d', 4, NULL),
(14081, NULL, 'IPR024129', NULL, 'Sphingomyelin phosphodiesterase 4', 'Sphingomy_SMPD4', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(14082, NULL, 'IPR009854', NULL, 'Orthoreovirus membrane fusion p10', 'Orthoreo_P10', 4, NULL),
(14083, NULL, 'IPR011874', NULL, 'Fibro-slime', 'Fibro_Slime', 3, NULL),
(14084, NULL, 'IPR014133', NULL, 'Cryptochrome DASH', 'Cry_DASH', 4, NULL),
(14085, NULL, 'IPR014137', NULL, 'Nickel import ATP-binding protein NikE', 'Nickel_NikE', 4, NULL),
(14086, NULL, 'IPR012470', NULL, 'PDR1 up-regulated protein 1-like', 'Pup1-like', 4, NULL),
(14087, NULL, 'IPR008597', NULL, 'Invertebrate-type lysozyme', 'Invert_lysozyme', 4, NULL),
(14088, NULL, 'IPR014092', NULL, 'Pyruvate oxidase', 'Pyruvate_oxidase', 4, NULL),
(14089, NULL, 'IPR035938', NULL, 'Hemerythrin-like superfamily', 'Hemerythrin-like_sf', 5, NULL),
(14090, NULL, 'IPR015407', NULL, 'Phytochelatin synthase, C-terminal', 'Phytochelatin_synthase_C', 3, NULL),
(14091, NULL, 'IPR009353', NULL, 'Orthopoxvirus, Protein N1', 'Orthopox_N1', 4, NULL),
(14092, NULL, 'IPR008596', NULL, 'Accessory protein p30II', 'P30II', 4, NULL),
(14093, NULL, 'IPR014944', NULL, 'Toxin SymE-like', 'Toxin_SymE-like', 3, NULL),
(14094, NULL, 'IPR009351', NULL, 'DNA glycosylase AlkZ-like', 'AlkZ-like', 4, NULL),
(14095, NULL, 'IPR013931', NULL, 'Svf1-like, N-terminal', 'Svf1-like_N', 3, NULL),
(14096, NULL, 'IPR014983', NULL, 'GAD-related', 'GAD-rel', 3, NULL),
(14097, NULL, 'IPR009868', NULL, 'VirE2', 'VirE2', 4, NULL),
(14098, NULL, 'IPR010539', NULL, 'Bax inhibitor 1 like', 'BaxI_1-like', 4, NULL),
(14099, NULL, 'IPR014958', NULL, 'DGC', 'DGC', 4, NULL),
(14100, NULL, 'IPR014982', NULL, 'GSCFA', 'GSCFA', 3, NULL),
(14101, NULL, 'IPR013719', NULL, 'Histone chaperone RTT106/FACT complex subunit SPT16-like, middle domain', 'RTT106/SPT16-like_middle_dom', 3, NULL),
(14102, NULL, 'IPR034159', NULL, 'SF3B4, RNA recognition motif 2', 'SF3B4_RRM2', 3, NULL),
(14103, NULL, 'IPR035937', NULL, 'MutM-like, N-terminal', 'MutM-like_N-ter', 5, NULL),
(14104, NULL, 'IPR035075', NULL, 'PRMT5 arginine-N-methyltransferase', 'PRMT5', 3, NULL),
(14105, NULL, 'IPR014742', NULL, 'Adaptor protein Cbl, SH2-like domain', 'Adaptor_Cbl_SH2-like', 3, NULL),
(14106, NULL, 'IPR014089', NULL, 'Acetate-CoA ligase [ADP-forming], alpha domain', 'AcCoA-synth-alpha', 3, NULL),
(14107, NULL, 'IPR012455', NULL, 'Protein of unknown function DUF1660', 'DUF1660', 4, NULL),
(14108, NULL, 'IPR009873', NULL, 'Phytoreovirus S7', 'Phytoreo_S7', 4, NULL),
(14109, NULL, 'IPR015409', NULL, 'D-lactate dehydrogenase, membrane binding, C-terminal', 'Lactate_DH_C', 3, NULL),
(14110, NULL, 'IPR014752', NULL, 'Arrestin-like, C-terminal', 'Arrestin-like_C', 5, NULL),
(14111, NULL, 'IPR012443', NULL, 'Protein of unknown function DUF1646', 'DUF1646', 4, NULL),
(14112, NULL, 'IPR009885', NULL, 'Protein of unknown function DUF1435', 'DUF1435', 4, NULL),
(14113, NULL, 'IPR035073', NULL, 'At2g17340, three-helix bundle domain', 'At2g17340_3_helix_bundle', 5, NULL),
(14114, NULL, 'IPR014930', NULL, 'Myotonic dystrophy protein kinase, coiled coil', 'Myotonic_dystrophy_kinase_coil', 3, NULL),
(14115, NULL, 'IPR035936', NULL, 'BB2672 superfamily', 'BB2672', 5, NULL),
(14116, NULL, 'IPR013924', NULL, 'Ribonuclease H2, subunit C', 'RNase_H2_suC', 4, NULL),
(14117, NULL, 'IPR014146', NULL, 'DNA ligase D, ligase domain', 'LigD_ligase_dom', 3, NULL),
(14118, NULL, 'IPR014741', NULL, 'Adaptor protein Cbl, EF hand-like', 'Adaptor_Cbl_EF_hand-like', 3, NULL),
(14119, NULL, 'IPR009324', NULL, 'Protein of unknown function DUF981', 'DUF981', 4, NULL),
(14120, NULL, 'IPR016016', NULL, 'Clusterin', 'Clusterin', 4, NULL),
(14121, NULL, 'IPR011876', NULL, 'Isopentenyl-diphosphate delta-isomerase, type 1', 'IsopentenylPP_isomerase_typ1', 4, NULL),
(14122, NULL, 'IPR014083', NULL, 'Cation/acetate symporter ActP', 'Cation/Ac_symporter_ActP', 4, NULL),
(14123, NULL, 'IPR014738', NULL, 'Citrate transporter', 'Citrate_transporter', 4, NULL),
(14124, NULL, 'IPR009891', NULL, 'Tapetum specific TAP35/TAP44', 'TAP35_44', 4, NULL),
(14125, NULL, 'IPR013713', NULL, 'Exportin-2, central domain', 'XPO2_central', 3, NULL),
(14126, NULL, 'IPR013717', NULL, 'PIG-P', 'PIG-P', 3, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(14127, NULL, 'IPR010540', NULL, 'Putative ABC-transporter type IV CmpB/TMEM229', 'CmpB_TMEM229', 4, NULL),
(14128, NULL, 'IPR015396', NULL, 'Acyl-CoA dehydrogenase, C-terminal, bacterial type', 'FadE_C', 3, NULL),
(14129, NULL, 'IPR014954', NULL, 'Protein of unknown function DUF1825', 'DUF1825', 4, NULL),
(14130, NULL, 'IPR012447', NULL, 'Protein of unknown function DUF1651', 'DUF1651', 4, NULL),
(14131, NULL, 'IPR009318', NULL, 'Gustatory receptor', 'Gustatory_rcpt', 4, NULL),
(14132, NULL, 'IPR015388', NULL, 'FCP1-like phosphatase, C-terminal', 'FCP1_C', 3, NULL),
(14133, NULL, 'IPR008609', NULL, 'Ebola nucleoprotein', 'Ebola_NP', 4, NULL),
(14134, NULL, 'IPR023268', NULL, 'RNA (C5-cytosine) methyltransferase, putative Rsm-related, plant', 'RCMT_RsmB-rel_pln', 4, NULL),
(14135, NULL, 'IPR012462', NULL, 'Peptidase C78, ubiquitin fold modifier-specific peptidase 1/ 2', 'Peptidase_C78_UfSP1/2', 4, NULL),
(14136, NULL, 'IPR014974', NULL, 'Domain of unknown function DUF1833', 'DUF1833', 4, NULL),
(14137, NULL, 'IPR014921', NULL, 'EsaB', 'EsaB', 4, NULL),
(14138, NULL, 'IPR013030', NULL, 'DNA topoisomerase I, DNA binding, N-terminal domain 2', 'DNA_topo_DNA_db_N_dom2', 5, NULL),
(14139, NULL, 'IPR014933', NULL, 'Alpha C protein, N-terminal', 'AlphaC_N', 3, NULL),
(14140, NULL, 'IPR014097', NULL, 'Phenylphosphate carboxylase, gamma subunit', 'Phenyl_P_COase_g', 4, NULL),
(14141, NULL, 'IPR014148', NULL, 'P-type conjugative transfer protein VirB9', 'VirB9', 4, NULL),
(14142, NULL, 'IPR010531', NULL, 'Zinc finger protein NOA36', 'NOA36', 4, NULL),
(14143, NULL, 'IPR013927', NULL, 'Transcription factor Opi1', 'TF_Opi1', 4, NULL),
(14144, NULL, 'IPR010530', NULL, 'NADH-ubiquinone reductase complex 1 MLRQ subunit', 'B12D', 4, NULL),
(14145, NULL, 'IPR014135', NULL, 'Conjugal transfer protein TraG-like', 'Ti-typ_conjug_TS_TraG-like', 4, NULL),
(14146, NULL, 'IPR014935', NULL, 'Nuclear receptor coactivator, receptor-binding domain', 'SRC/p160_LXXLL', 3, NULL),
(14147, NULL, 'IPR015373', NULL, 'Interferon/interleukin receptor domain', 'Interferon/interleukin_rcp_dom', 3, NULL),
(14148, NULL, 'IPR014084', NULL, 'Urea carboxylase', 'Urea_COase', 4, NULL),
(14149, NULL, 'IPR015404', NULL, 'Sorting nexin Vps5-like, C-terminal', 'Vps5_C', 3, NULL),
(14150, NULL, 'IPR009869', NULL, 'Nematode resistance protein-like HSPRO1, N-terminal', 'HSPRO1_N', 3, NULL),
(14151, NULL, 'IPR008640', NULL, 'Trimeric autotransporter adhesin YadA-like, head domain', 'Adhesin_Head_dom', 3, NULL),
(14152, NULL, 'IPR009908', NULL, 'Methylamine utilisation protein, MauE', 'Methylamine_util_MauE', 3, NULL),
(14153, NULL, 'IPR012464', NULL, 'Protein of unknown function DUF1676', 'DUF1676', 4, NULL),
(14154, NULL, 'IPR013021', NULL, 'Myo-inositol-1-phosphate synthase, GAPDH-like', 'Myo-inos-1-P_Synthase_GAPDH', 3, NULL),
(14155, NULL, 'IPR009329', NULL, 'Protein of unknown function DUF987', 'DUF987', 4, NULL),
(14156, NULL, 'IPR011875', NULL, 'Alpha-maltose-1-phosphate synthase', 'M1P_synthase', 4, NULL),
(14157, NULL, 'IPR014079', NULL, 'Phosphate butyryltransferase', 'Phosphate_butyryltransferase', 4, NULL),
(14158, NULL, 'IPR009870', NULL, 'Putative replication protein DUF1424', 'DUF1424', 4, NULL),
(14159, NULL, 'IPR014156', NULL, 'Nickel ABC transporter, permease subunit NikB', 'Nickel_NikB', 4, NULL),
(14160, NULL, 'IPR009890', NULL, 'Etoposide-induced 2.4', 'EI24', 4, NULL),
(14161, NULL, 'IPR009348', NULL, 'Nitrogen permease regulator 2', 'NPR2', 4, NULL),
(14162, NULL, 'IPR015366', NULL, 'Peptidase S53, activation domain', 'S53_propep', 3, NULL),
(14163, NULL, 'IPR012442', NULL, 'Protein of unknown function DUF1645, plant', 'DUF1645_plant', 4, NULL),
(14164, NULL, 'IPR008619', NULL, 'Filamentous haemagglutinin repeat', 'Filamentous_hemagglutn_rpt', 7, NULL),
(14165, NULL, 'IPR014136', NULL, 'Ti-type conjugative transfer relaxase TraA', 'TraA_Ti', 4, NULL),
(14166, NULL, 'IPR013934', NULL, 'U3 small nucleolar RNA-associated protein 13, C-terminal', 'Utp13_C', 3, NULL),
(14167, NULL, 'IPR014972', NULL, 'Bacteriophage Mu, Gp37', 'Phage_Mu_Gp37', 4, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(14168, NULL, 'IPR022307', NULL, 'DEAD/DEAH-box helicase, putative, actinobacteria', 'Helicase_put_actinobac', 4, NULL),
(14169, NULL, 'IPR009335', NULL, 'Type III secretion system HrpE /V-type ATP synthase subunit E', 'T3SS_HrpE/ATPase_suE', 4, NULL),
(14170, NULL, 'IPR014956', NULL, 'Putative ParB-like nuclease', 'ParBc_2', 4, NULL),
(14171, NULL, 'IPR012444', NULL, 'Protein of unknown function DUF1647', 'DUF1647', 4, NULL),
(14172, NULL, 'IPR014165', NULL, '4-carboxy-4-hydroxy-2-oxoadipate aldolase/oxaloacetate decarboxylase', 'LigK_PcmE', 4, NULL),
(14173, NULL, 'IPR008588', NULL, 'Protein of unknown function DUF870, Caenorhabditis species', 'DUF870_CAE_spp', 4, NULL),
(14174, NULL, 'IPR013932', NULL, 'TATA-binding protein interacting (TIP20)', 'TATA-bd_TIP120', 3, NULL),
(14175, NULL, 'IPR014939', NULL, 'CDT1 Geminin-binding domain-like', 'CDT1_Gemini-bd-like', 3, NULL),
(14176, NULL, 'IPR009368', NULL, 'Protein of unknown function DUF1024', 'DUF1024', 4, NULL),
(14177, NULL, 'IPR010548', NULL, 'BNIP3', 'BNIP3', 4, NULL),
(14178, NULL, 'IPR009356', NULL, 'NADH dehydrogenase subunit 4L', 'NAD_DH_su4L', 4, NULL),
(14179, NULL, 'IPR014082', NULL, 'CRISPR-associated protein, Cas02710', 'CRISPR-assoc_prot_Cas02710', 4, NULL),
(14180, NULL, 'IPR014142', NULL, 'P-type conjugative transfer protein TrbG', 'TrbG_Ti', 4, NULL),
(14181, NULL, 'IPR009917', NULL, 'SRA1/Sec31', 'SRA1/Sec31', 3, NULL),
(14182, NULL, 'IPR010546', NULL, 'Protein of unknown function DUF1120', 'DUF1120', 4, NULL),
(14183, NULL, 'IPR014099', NULL, 'Spore coat protein GerQ', 'Spore_coat_GerQ', 4, NULL),
(14184, NULL, 'IPR009362', NULL, 'YhcG PDDEXK nuclease domain', 'YhcG_C', 3, NULL),
(14185, NULL, 'IPR008626', NULL, 'Mediator complex, subunit Med15, fungi', 'Mediator_Med15_fun', 4, NULL),
(14186, NULL, 'IPR012451', NULL, 'Protein of unknown function DUF1656', 'DUF1656', 4, NULL),
(14187, NULL, 'IPR009876', NULL, 'Outer membrane adhesin OpcA', 'OM_adhesin_OpcA', 4, NULL),
(14188, NULL, 'IPR009881', NULL, 'Protein of unknown function DUF1433', 'DUF1433', 4, NULL),
(14189, NULL, 'IPR009896', NULL, 'Cytadhesin P30/P32', 'Cytadhesin_P30/P32', 4, NULL),
(14190, NULL, 'IPR015371', NULL, 'Endonuclease VIII-like 1, DNA binding', 'Endonuclease-VIII_DNA-bd', 3, NULL),
(14191, NULL, 'IPR014962', NULL, 'YolD-like protein', 'YolD', 4, NULL),
(14192, NULL, 'IPR014924', NULL, 'Protein of unknown function DUF1803', 'DUF1803', 4, NULL),
(14193, NULL, 'IPR012434', NULL, 'Protein of unknown function DUF1631', 'DUF1631', 4, NULL),
(14194, NULL, 'IPR010536', NULL, 'Repulsive guidance molecule, N-terminal', 'RGM_N', 3, NULL),
(14195, NULL, 'IPR008587', NULL, 'Filament-like plant protein', 'FPP_plant', 4, NULL),
(14196, NULL, 'IPR014085', NULL, 'Allophanate hydrolase', 'Allophanate_hydrolase', 3, NULL),
(14197, NULL, 'IPR008630', NULL, 'Glycosyltransferase 34', 'Glyco_trans_34', 4, NULL),
(14198, NULL, 'IPR015875', NULL, 'IMP dehydrogenase / GMP reductase, conserved site', 'IMP_DH/GMP_Rdtase_CS', 2, NULL),
(14199, NULL, 'IPR012468', NULL, 'Protein of unknown function DUF1686', 'DUF1686', 4, NULL),
(14200, NULL, 'IPR014978', NULL, 'Glutamine-Leucine-Glutamine, QLQ', 'Gln-Leu-Gln_QLQ', 3, NULL),
(14201, NULL, 'IPR009866', NULL, 'NADH:ubiquinone oxidoreductase, subunit NDUFB4', 'NADH_UbQ_OxRdtase_NDUFB4_su', 4, NULL),
(14202, NULL, 'IPR014753', NULL, 'Arrestin, N-terminal', 'Arrestin_N', 5, NULL),
(14203, NULL, 'IPR013936', NULL, 'Chloroquine-resistance transporter-like', 'CRT-like', 4, NULL),
(14204, NULL, 'IPR014139', NULL, 'Peptidase S26C, conjugative transfer signal peptidase TraF', 'Peptidase_S26C_TraF', 4, NULL),
(14205, NULL, 'IPR008593', NULL, 'DNA N-6-adenine-methyltransferase', 'Dam_MeTrfase', 4, NULL),
(14206, NULL, 'IPR008591', NULL, 'GINS complex subunit Sld5', 'GINS_Sld5', 4, NULL),
(14207, NULL, 'IPR015392', NULL, 'Domain of unknown function DUF1971', 'DUF1971', 3, NULL),
(14208, NULL, 'IPR009367', NULL, 'Mitochondrial fission protein ELM1-like', 'Elm1-like', 4, NULL),
(14209, NULL, 'IPR022305', NULL, 'Sortase system response regulator', 'Response_regulator', 4, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(14210, NULL, 'IPR009309', NULL, 'IreB regulatory phosphoprotein', 'IreB', 4, NULL),
(14211, NULL, 'IPR009097', NULL, 'Cyclic phosphodiesterase', 'Cyclic_Pdiesterase', 5, NULL),
(14212, NULL, 'IPR014162', NULL, 'Cell division coordinator CpoB, C-terminal', 'CpoB_C', 3, NULL),
(14213, NULL, 'IPR023269', NULL, 'RNA (C5-cytosine) methyltransferase, subfamily 9', 'RCMT_subfamily_9', 4, NULL),
(14214, NULL, 'IPR014957', NULL, 'IDEAL domain', 'IDEAL_dom', 3, NULL),
(14215, NULL, 'IPR014106', NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase, Vibrio-type', 'SAICAR_synthase_Vibrio-typ', 4, NULL),
(14216, NULL, 'IPR014161', NULL, 'Tol-Pal system, TolA', 'Tol-Pal_TolA', 4, NULL),
(14217, NULL, 'IPR010534', NULL, 'Bacteriophage 933W, GpQ', 'Phage_933W_GpQ', 4, NULL),
(14218, NULL, 'IPR009874', NULL, 'Protein of unknown function DUF1428', 'DUF1428', 4, NULL),
(14219, NULL, 'IPR009314', NULL, 'Coronavirus nonstructural NS1', 'Corona_NS1', 4, NULL),
(14220, NULL, 'IPR014951', NULL, 'Protein of unknown function DUF1822', 'DUF1822', 4, NULL),
(14221, NULL, 'IPR034165', NULL, 'FeMo cofactor biosynthesis protein NifB, C-terminal', 'NifB_C', 3, NULL),
(14222, NULL, 'IPR009332', NULL, 'Mediator of RNA polymerase II transcription subunit 22', 'Med22', 4, NULL),
(14223, NULL, 'IPR014152', NULL, 'DNA helicase subunit AddA', 'DNA_helicase_suAddA', 4, NULL),
(14224, NULL, 'IPR009349', NULL, 'Zinc finger, C2HC5-type', 'Znf_C2HC5', 3, NULL),
(14225, NULL, 'IPR015400', NULL, 'Domain of unknown function DUF1978, IncA', 'DUF1978_IncA', 3, NULL),
(14226, NULL, 'IPR015399', NULL, 'Domain of unknown function DUF1977, DnaJ-like', 'DUF1977_DnaJ-like', 3, NULL),
(14227, NULL, 'IPR013926', NULL, 'CGI121/TPRKB', 'CGI121/TPRKB', 4, NULL),
(14228, NULL, 'IPR011872', NULL, 'Homocitrate synthase, fungi/archaea', 'Homocitrate_synth_fun/arc', 4, NULL),
(14229, NULL, 'IPR009365', NULL, 'Nucleopolyhedrovirus LEF-12', 'Nucleo_LEF-12', 4, NULL),
(14230, NULL, 'IPR015386', NULL, 'MHC class II-associated invariant chain/CLIP, MHC II-interacting', 'MHC_II-assoc_invar/CLIP_MHC-bd', 3, NULL),
(14231, NULL, 'IPR009372', NULL, 'Poxvirus virion membrane protein A14.5', 'Poxvirus_A14.5', 4, NULL),
(14232, NULL, 'IPR009855', NULL, 'Baculovirus late expression factor 10', 'Baculo_LEF-10', 4, NULL),
(14233, NULL, 'IPR014936', NULL, 'Axin beta-catenin binding', 'Axin_b-cat-bd', 3, NULL),
(14234, NULL, 'IPR008615', NULL, 'FNIP', 'FNIP', 7, NULL),
(14235, NULL, 'IPR014961', NULL, 'Domain of unknown function DUF1829', 'DUF1829', 3, NULL),
(14236, NULL, 'IPR009862', NULL, 'Protein of unknown function DUF1419', 'DUF1419', 4, NULL),
(14237, NULL, 'IPR009912', NULL, 'Zinc-ribbon containing domain', 'DUF1451', 4, NULL),
(14238, NULL, 'IPR040441', NULL, 'Cilia- and flagella-associated protein 20/CFAP20DC', 'CFA20/CFAP20DC', 4, NULL),
(14239, NULL, 'IPR013726', NULL, 'Protein of unknown function DUF1748, fungi', 'DUF1748_fun', 4, NULL),
(14240, NULL, 'IPR008625', NULL, 'GAGE family', 'GAGE_fam', 4, NULL),
(14241, NULL, 'IPR012459', NULL, 'Ribosomal RNA-processing protein 15', 'Rrp15', 4, NULL),
(14242, NULL, 'IPR009357', NULL, 'Solute carrier family 52, riboflavin transporter', 'Riboflavin_transptr', 4, NULL),
(14243, NULL, 'IPR015403', NULL, 'Mon2/Sec7/BIG1-like, HDS', 'Mon2/Sec7/BIG1-like_HDS', 3, NULL),
(14244, NULL, 'IPR012441', NULL, 'Protein of unknown function DUF1643', 'DUF1643', 4, NULL),
(14245, NULL, 'IPR009326', NULL, 'Protein of unknown function DUF984', 'DUF984', 4, NULL),
(14246, NULL, 'IPR014981', NULL, 'Flagellin D3', 'Flagellin_D3', 3, NULL),
(14247, NULL, 'IPR009364', NULL, 'Bacterial toxin YdaT', 'YdaT_toxin', 3, NULL),
(14248, NULL, 'IPR014093', NULL, 'Thiamine kinase', 'Thiamine_kinase', 4, NULL),
(14249, NULL, 'IPR008595', NULL, 'Sensor DegS', 'DegS', 3, NULL),
(14250, NULL, 'IPR013040', NULL, 'Coatomer, gamma subunit, appendage, Ig-like subdomain', 'Coatomer_gsu_app_Ig-like_dom', 3, NULL),
(14251, NULL, 'IPR009913', NULL, 'TraP', 'TraP', 4, NULL),
(14252, NULL, 'IPR009907', NULL, 'RNA polymerase epsilon subunit', 'RpoY', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(14253, NULL, 'IPR009333', NULL, 'Protein of unknown function DUF992', 'DUF992', 4, NULL),
(14254, NULL, 'IPR013714', NULL, 'Golgi apparatus membrane protein TVP15', 'Golgi_TVP15', 4, NULL),
(14255, NULL, 'IPR009319', NULL, 'Lactococcus phage , Structural protein', 'Phage_A118_VSP1', 4, NULL),
(14256, NULL, 'IPR015382', NULL, 'KCNMB2, ball/chain domain', 'KCNMB2_ball_chain_dom', 3, NULL),
(14257, NULL, 'IPR008603', NULL, 'Dynactin subunit 4', 'DCTN4', 4, NULL),
(14258, NULL, 'IPR009857', NULL, 'Uncharacterised protein family UPF0352', 'UPF0352', 4, NULL),
(14259, NULL, 'IPR014132', NULL, 'Sporulation polysaccharide deacetylase PdaB-like', 'PdaB-like', 4, NULL),
(14260, NULL, 'IPR014103', NULL, 'Zeta-carotene desaturase', 'Zeta_caro_desat', 4, NULL),
(14261, NULL, 'IPR009872', NULL, 'Protein of unknown function DUF1427', 'DUF1427', 4, NULL),
(14262, NULL, 'IPR008589', NULL, '6-phospho-N-acetylmuramidase', 'MupG', 4, NULL),
(14263, NULL, 'IPR010532', NULL, 'Sulfocyanin', 'SoxE', 4, NULL),
(14264, NULL, 'IPR012475', NULL, 'Fucose-specific lectin', 'Fungal_lectin', 4, NULL),
(14265, NULL, 'IPR008620', NULL, 'Nitrogen fixation protein FixH', 'FixH', 4, NULL),
(14266, NULL, 'IPR014925', NULL, 'CGGC domain', 'CGGC_dom', 3, NULL),
(14267, NULL, 'IPR010541', NULL, 'Small nuclear ribonucleoprotein Prp3, C-terminal domain', 'Prp3_C', 3, NULL),
(14268, NULL, 'IPR010549', NULL, 'African swine fever virus, IAP-like p27, C-terminal', 'ASFV_p27_C', 3, NULL),
(14269, NULL, 'IPR015370', NULL, 'T-cell receptor alpha chain, constant domain', 'TCR_alpha_C', 3, NULL),
(14270, NULL, 'IPR009373', NULL, 'Circovirus 2, Orf5', 'Circovirus2_Orf5', 4, NULL),
(14271, NULL, 'IPR008614', NULL, 'Acidic fibroblast growth factor intracellular-binding protein', 'FIBP', 4, NULL),
(14272, NULL, 'IPR014953', NULL, 'Protein of unknown function DUF1824', 'DUF1824', 4, NULL),
(14273, NULL, 'IPR014940', NULL, 'BAAT/Acyl-CoA thioester hydrolase C-terminal', 'BAAT_C', 3, NULL),
(14274, NULL, 'IPR014086', NULL, 'Cyanuric acid hydrolase/Barbiturase', 'AtzD/Barbiturase', 4, NULL),
(14275, NULL, 'IPR009363', NULL, 'Bacteriophage Mu, Gp16', 'Phage_Mu_Gp16', 4, NULL),
(14276, NULL, 'IPR034158', NULL, 'SF3B4, RNA recognition motif 1', 'SF3B4_RRM1', 3, NULL),
(14277, NULL, 'IPR008608', NULL, 'Ectropic viral integration site 2A protein', 'Ectropic_vir_integratn_site_2A', 4, NULL),
(14278, NULL, 'IPR009902', NULL, 'Protein of unknown function DUF1442', 'DUF1442', 4, NULL),
(14279, NULL, 'IPR009910', NULL, 'Protein of unknown function DUF1450', 'DUF1450', 4, NULL),
(14280, NULL, 'IPR012449', NULL, 'Bacteriophage F116, Orf28', 'Phage_F116_Orf28', 4, NULL),
(14281, NULL, 'IPR013342', NULL, 'Mandelate racemase/muconate lactonizing enzyme, C-terminal', 'Mandelate_racemase_C', 3, NULL),
(14282, NULL, 'IPR012469', NULL, 'Protein of unknown function DUF1688', 'DUF1688', 4, NULL),
(14283, NULL, 'IPR011873', NULL, 'Conserved hypothetical protein CHP02147', 'CHP02147', 4, NULL),
(14284, NULL, 'IPR013938', NULL, '3''5''-cyclic nucleotide phosphodiesterase PDE8', 'PDEase_PDE8', 3, NULL),
(14285, NULL, 'IPR009860', NULL, 'Hyaluronidase, bacterial', 'Hyaluronidase_bac', 4, NULL),
(14286, NULL, 'IPR009905', NULL, '2-vinyl bacteriochlorophyllide hydratase', 'BCHF', 4, NULL),
(14287, NULL, 'IPR015375', NULL, 'NADH pyrophosphatase-like, N-terminal', 'NADH_PPase-like_N', 3, NULL),
(14288, NULL, 'IPR009350', NULL, 'Minor tail T', 'Phage_tail_T', 3, NULL),
(14289, NULL, 'IPR014945', NULL, 'Protein of unknown function DUF1816', 'DUF1816', 4, NULL),
(14290, NULL, 'IPR009340', NULL, 'Protein of unknown function DUF999', 'DUF999', 4, NULL),
(14291, NULL, 'IPR008645', NULL, 'Roseolovirus glycoprotein U47', 'Roseolovirus_U47', 4, NULL),
(14292, NULL, 'IPR008605', NULL, 'Extracellular matrix protein 1', 'ECM1', 4, NULL),
(14293, NULL, 'IPR014977', NULL, 'WRC domain', 'WRC_dom', 3, NULL),
(14294, NULL, 'IPR014968', NULL, 'XisI protein', 'XisI', 4, NULL),
(14295, NULL, 'IPR008612', NULL, 'Mating pheromone, Euplotes octocarinatus', 'Mating_pheromone_EUPOC', 4, NULL),
(14296, NULL, 'IPR014153', NULL, 'Double-strand break repair protein AddB', 'Ds_break_AddB', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(14297, NULL, 'IPR014164', NULL, 'TonB-system energizer ExbB type-1', 'TonB_ExbB_1', 4, NULL),
(14298, NULL, 'IPR009903', NULL, 'Per os infectivity factor AC110', 'AcMNPV_AC110', 4, NULL),
(14299, NULL, 'IPR012456', NULL, 'Protein of unknown function DUF1661', 'DUF1661', 4, NULL),
(14300, NULL, 'IPR009311', NULL, 'Interferon alpha-inducible protein IFI6/IFI27-like', 'IFI6/IFI27-like', 4, NULL),
(14301, NULL, 'IPR013034', NULL, 'DNA topoisomerase I, DNA binding, N-terminal domain 1', 'DNA_topo_DNA_db_N_dom1', 5, NULL),
(14302, NULL, 'IPR015377', NULL, 'Fumarylacetoacetase, N-terminal', 'Fumarylacetoacetase_N', 3, NULL),
(14303, NULL, 'IPR009880', NULL, 'Glyoxal oxidase, N-terminal', 'Glyoxal_oxidase_N', 3, NULL),
(14304, NULL, 'IPR010545', NULL, 'Signal-peptide peptidase, presenilin aspartyl protease', 'SPP', 4, NULL),
(14305, NULL, 'IPR034055', NULL, 'Tumor necrosis factor receptor 6, N-terminal, teleost', 'TNFRSF6_N_teleost', 3, NULL),
(14306, NULL, 'IPR015376', NULL, 'Zinc ribbon, NADH pyrophosphatase', 'Znr_NADH_PPase', 3, NULL),
(14307, NULL, 'IPR012440', NULL, 'Protein of unknown function DUF1641', 'DUF1641', 4, NULL),
(14308, NULL, 'IPR008647', NULL, 'Envelope glycoprotein N domain', 'GN_domain', 3, NULL),
(14309, NULL, 'IPR009867', NULL, 'Protein of unknown function DUF1422', 'DUF1422', 4, NULL),
(14310, NULL, 'IPR009878', NULL, 'Phlebovirus glycoprotein G2, fusion domain', 'Phlebovirus_G2_fusion', 3, NULL),
(14311, NULL, 'IPR008594', NULL, 'Scavenger mRNA decapping enzyme DcpS/DCS2', 'DcpS/DCS2', 4, NULL),
(14312, NULL, 'IPR009312', NULL, 'Minor tail protein U-like', 'Phage_lambda_GpU-like', 4, NULL),
(14313, NULL, 'IPR011870', NULL, 'Lysine biosynthesis enzyme LysX', 'LysX_arch', 4, NULL),
(14314, NULL, 'IPR014149', NULL, 'Conjugative transfer, TrbB', 'Conjug-transfer_TrbB', 4, NULL),
(14315, NULL, 'IPR009851', NULL, 'Modifier of rudimentary, Modr', 'Mod_r', 3, NULL),
(14316, NULL, 'IPR009325', NULL, 'Protein of unknown function DUF983', 'DUF983', 4, NULL),
(14317, NULL, 'IPR013921', NULL, 'Mediator complex, subunit Med20', 'Mediator_Med20', 4, NULL),
(14318, NULL, 'IPR013937', NULL, 'Sorting nexin, C-terminal', 'Sorting_nexin_C', 3, NULL),
(14319, NULL, 'IPR009369', NULL, 'Actinobacillus actinomycetemcomitans leukotoxin activator LktC', 'LktC', 4, NULL),
(14320, NULL, 'IPR014976', NULL, 'Anti-bacteriophage protein A/HamA, C-terminal domain', 'AbpA_HamA_C', 3, NULL),
(14321, NULL, 'IPR012473', NULL, 'Fibritin C-terminal', 'Fibritin_C', 3, NULL),
(14322, NULL, 'IPR014971', NULL, 'KGK', 'KGK', 4, NULL),
(14323, NULL, 'IPR008639', NULL, 'Gas vesicle protein GvpC, halobacteria', 'Gas-vesicle_GvpC_halobac', 4, NULL),
(14324, NULL, 'IPR008599', NULL, 'Putative sugar diacid recognition', 'Diacid_rec', 3, NULL),
(14325, NULL, 'IPR008613', NULL, 'Excalibur calcium-binding domain', 'Excalibur_Ca-bd_domain', 3, NULL),
(14326, NULL, 'IPR013917', NULL, 'tRNA wybutosine-synthesis', 'tRNA_wybutosine-synth', 3, NULL),
(14327, NULL, 'IPR010535', NULL, 'Protein of unknown function DUF1110', 'DUF1110', 4, NULL),
(14328, NULL, 'IPR009317', NULL, 'ChaB', 'ChaB', 4, NULL),
(14329, NULL, 'IPR009360', NULL, 'Pre-mRNA-splicing factor Isy1', 'Isy1', 4, NULL),
(14330, NULL, 'IPR009315', NULL, 'Phosphate-starvation-induced PsiE', 'P_starv_induced_PsiE', 4, NULL),
(14331, NULL, 'IPR009343', NULL, 'Protein of unknown function DUF1002', 'DUF1002', 4, NULL),
(14332, NULL, 'IPR019841', NULL, 'Osteopontin, conserved site', 'Osteopontin_CS', 2, NULL),
(14333, NULL, 'IPR013718', NULL, 'COQ9', 'COQ9', 3, NULL),
(14334, NULL, 'IPR015384', NULL, 'TACI, cysteine-rich domain', 'TACI_Cys-rich-dom', 3, NULL),
(14335, NULL, 'IPR008633', NULL, 'Protein GvpH', 'GvpH', 4, NULL),
(14336, NULL, 'IPR015378', NULL, 'Transposase-like, Mu, C-terminal', 'Transposase-like_Mu_C', 3, NULL),
(14337, NULL, 'IPR009884', NULL, 'Benyvirus 14kDa', 'Benyvirus_14kDa', 4, NULL),
(14338, NULL, 'IPR010537', NULL, 'Avian adenovirus fibre, N-terminal', 'Avian_adenovirus_fibre_N', 3, NULL),
(14339, NULL, 'IPR008644', NULL, 'Human herpesvirus U15', 'Herpes_U15', 4, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(14340, NULL, 'IPR008627', NULL, 'GETHR pentapeptide repeat', 'GETHR_repeat', 7, NULL),
(14341, NULL, 'IPR009906', NULL, 'D-glutamate cyclase', 'D-Glu_cyclase', 4, NULL),
(14342, NULL, 'IPR009328', NULL, 'Protein of unknown function DUF986', 'DUF986', 4, NULL),
(14343, NULL, 'IPR013041', NULL, 'Clathrin adaptor, appendage, Ig-like subdomain superfamily', 'Clathrin_app_Ig-like_sf', 5, NULL),
(14344, NULL, 'IPR014984', NULL, 'HopJ type III effector protein', 'HopJ', 4, NULL),
(14345, NULL, 'IPR008634', NULL, 'Gas vesicle protein GvpO', 'Gas-vesicle_GvpO', 4, NULL),
(14346, NULL, 'IPR014946', NULL, 'Protein chlororespiratory reduction 6', 'CRR6', 4, NULL),
(14347, NULL, 'IPR013724', NULL, 'GIT, Spa2 homology (SHD) domain', 'GIT_SHD', 3, NULL),
(14348, NULL, 'IPR012454', NULL, 'Protein of unknown function DUF1659', 'DUF1659', 4, NULL),
(14349, NULL, 'IPR009871', NULL, 'Movement and RNA silencing protein', 'MP', 4, NULL),
(14350, NULL, 'IPR014965', NULL, 'Putative amino acid metabolism', 'Amino_acid_metab_prot_put', 4, NULL),
(14351, NULL, 'IPR012458', NULL, 'Domain of unknown function DUF1664', 'DUF1664', 3, NULL),
(14352, NULL, 'IPR011877', NULL, 'Ribokinase', 'D_ribokin', 4, NULL),
(14353, NULL, 'IPR014938', NULL, 'YfhH-like', 'YfhH-like', 4, NULL),
(14354, NULL, 'IPR008635', NULL, 'Trimeric autotransporter adhesin YadA-like, stalk domain', 'Coiled_stalk_dom', 3, NULL),
(14355, NULL, 'IPR013721', NULL, 'STAG', 'STAG', 3, NULL),
(14356, NULL, 'IPR009887', NULL, 'Progressive ankylosis', 'ANKH', 4, NULL),
(14357, NULL, 'IPR014942', NULL, 'Nucleotidyl transferase AbiEii toxin, Type IV TA system', 'AbiEii', 4, NULL),
(14358, NULL, 'IPR009883', NULL, 'Inner membrane protein YgfX', 'YgfX', 4, NULL),
(14359, NULL, 'IPR014091', NULL, 'Transcriptional repressor poly-beta-hydroxybutyrate-responsive', 'Tscrpt_rep_PHB_PhaQ', 4, NULL),
(14360, NULL, 'IPR014941', NULL, 'Fimbrium subunit FimB/Mfa2/Mfa3', 'FimB/Mfa2/Mfa3', 4, NULL),
(14361, NULL, 'IPR014134', NULL, 'Cryptochrome, plant', 'Cryptochrome_pln', 4, NULL),
(14362, NULL, 'IPR009909', NULL, 'Nmi/IFP 35 domain', 'Nmi/IFP35_dom', 3, NULL),
(14363, NULL, 'IPR034382', NULL, '3,6-anhydro-alpha-L-galactonate cycloisomerase', 'AHGA_cycloisomerase', 4, NULL),
(14364, NULL, 'IPR013922', NULL, 'Cyclin PHO80-like', 'Cyclin_PHO80-like', 4, NULL),
(14365, NULL, 'IPR013918', NULL, 'Nucleotide exchange factor Fes1', 'Nucleotide_exch_fac_Fes1', 3, NULL),
(14366, NULL, 'IPR012476', NULL, 'mRNA export factor GLE1-like', 'GLE1', 4, NULL),
(14367, NULL, 'IPR014158', NULL, 'Type IV secretion system, VirB5', 'T4SS_VirB5', 4, NULL),
(14368, NULL, 'IPR008637', NULL, 'HR-like lesion-inducer', 'HR_lesion', 4, NULL),
(14369, NULL, 'IPR014109', NULL, 'Type-F conjugative transfer system pilin assembly thiol-disulphide isomerase TrbB', 'Thiol-disulphide_isomerase_rbB', 4, NULL),
(14370, NULL, 'IPR015385', NULL, 'Bacteriophage P22, Gp8, scaffold', 'Phage_P22_Gp8_scaffold', 4, NULL),
(14371, NULL, 'IPR014157', NULL, 'Nickel ABC transporter, permease subunit NikC', 'Nickel_NikC', 4, NULL),
(14372, NULL, 'IPR009853', NULL, 'Protein of unknown function DUF1412', 'DUF1412', 4, NULL),
(14373, NULL, 'IPR008585', NULL, 'Poly-gamma-glutamate hydrolase', 'Gamma_PGA_hydro', 4, NULL),
(14374, NULL, 'IPR008590', NULL, 'Transmembrane protein 230/134', 'TMEM_230/134', 4, NULL),
(14375, NULL, 'IPR012461', NULL, 'FAM83, N-terminal', 'FAM83_N', 3, NULL),
(14376, NULL, 'IPR015397', NULL, 'Glycosyl transferase 1, domain A', 'Glyco_trans_A_1', 3, NULL),
(14377, NULL, 'IPR009327', NULL, 'Cupin domain of unknown function DUF985', 'Cupin_DUF985', 3, NULL),
(14378, NULL, 'IPR008592', NULL, 'Protein of unknown function DUF874', 'DUF874', 4, NULL),
(14379, NULL, 'IPR014150', NULL, 'Conjugal transfer, TrbL', 'Conjugal_tfr_TrbL', 4, NULL),
(14380, NULL, 'IPR015391', NULL, 'SurA N-terminal', 'SurA_N', 3, NULL),
(14381, NULL, 'IPR013941', NULL, 'Protein Zds1, C-terminal', 'ZDS1_C', 3, NULL),
(14382, NULL, 'IPR008601', NULL, 'Cell-cell adhesion', 'Dicty_CAD', 4, NULL),
(14383, NULL, 'IPR014138', NULL, 'Nickel import ATP-binding protein NikD', 'Nickel_NikD', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(14384, NULL, 'IPR009893', NULL, 'Nucleopolyhedrovirus capsid P80/P87', 'Nucleo_P80/P87', 4, NULL),
(14385, NULL, 'IPR012435', NULL, 'TMEM144', 'TMEM144', 4, NULL),
(14386, NULL, 'IPR009366', NULL, 'Protein Veg', 'Protein_Veg', 4, NULL),
(14387, NULL, 'IPR009865', NULL, 'Proacrosin binding sp32', 'Proacrosin-bd', 4, NULL),
(14388, NULL, 'IPR015368', NULL, 'Ubiquitin-conjugating enzyme, C-terminal fungi', 'UBA_C_fun', 3, NULL),
(14389, NULL, 'IPR014104', NULL, 'Myxoxanthophyll biosynthesis, C-3'',4'' desaturase CrtD', 'Myxoxanthophyll_desat_CrtD', 4, NULL),
(14390, NULL, 'IPR009310', NULL, 'BphX-like', 'BphX', 4, NULL),
(14391, NULL, 'IPR014980', NULL, 'Dopa 4,5-dioxygenase', 'DOPA_dioxygen', 4, NULL),
(14392, NULL, 'IPR010542', NULL, 'Vertebrate heat shock transcription factor, C-terminal domain', 'Vert_HSTF_C', 3, NULL),
(14393, NULL, 'IPR009898', NULL, 'Protein of unknown function DUF1440', 'DUF1440', 4, NULL),
(14394, NULL, 'IPR014141', NULL, 'DNA helicase subunit RexB', 'DNA_helicase_suRexB', 4, NULL),
(14395, NULL, 'IPR015791', NULL, 'Antimicrobial/protein inhibitor, gamma-crystallin-like', 'Antimic/Inh_G_crystallin-like', 5, NULL),
(14396, NULL, 'IPR015374', NULL, 'Chs5p-Arf1p binding', 'ChAPs', 4, NULL),
(14397, NULL, 'IPR013919', NULL, 'Peroxisome membrane protein, Pex16', 'Pex16', 4, NULL),
(14398, NULL, 'IPR014949', NULL, 'Protein of unknown function DUF1820', 'DUF1820', 4, NULL),
(14399, NULL, 'IPR009911', NULL, 'Fibroin P25', 'Fibroin_P25', 4, NULL),
(14400, NULL, 'IPR009888', NULL, 'Immunity protein CdiI, Proteobacteria type', 'CdiI_Proteobact', 4, NULL),
(14401, NULL, 'IPR014967', NULL, 'Uncharacterised protein family, YugN-like', 'Uncharacterised_YugN-like', 4, NULL),
(14402, NULL, 'IPR012467', NULL, 'Protein of unknown function DUF1684', 'DUF1684', 4, NULL),
(14403, NULL, 'IPR013716', NULL, 'Adenylate cyclase G-alpha binding', 'Adenylate_cyclase_G-a-bd', 3, NULL),
(14404, NULL, 'IPR009316', NULL, 'COG complex component, COG2', 'COG2', 4, NULL),
(14405, NULL, 'IPR013725', NULL, 'DNA replication factor RFC1, C-terminal', 'DNA_replication_fac_RFC1_C', 3, NULL),
(14406, NULL, 'IPR013920', NULL, 'Protein of unknown function DUF1774, fungi', 'DUF1774_fun', 4, NULL),
(14407, NULL, 'IPR014952', NULL, 'Protein of unknown function DUF1823', 'DUF1823', 4, NULL),
(14408, NULL, 'IPR014948', NULL, 'BrxA', 'BrxA', 4, NULL),
(14409, NULL, 'IPR009338', NULL, 'Protein of unknown function  Orf51', 'Orf51', 4, NULL),
(14410, NULL, 'IPR008622', NULL, 'Flagellar protein FliT', 'FliT', 4, NULL),
(14411, NULL, 'IPR014101', NULL, 'Prolycopene isomerase', 'CrtISO', 4, NULL),
(14412, NULL, 'IPR014928', NULL, 'Serine rich protein interaction domain', 'Serine_rich_dom', 3, NULL),
(14413, NULL, 'IPR009900', NULL, 'Apopolysialoglycoprotein', 'PSGP', 7, NULL),
(14414, NULL, 'IPR014094', NULL, 'Penicillin-binding protein activator LpoB', 'LpoB', 4, NULL),
(14415, NULL, 'IPR013923', NULL, 'Autophagy-related protein 16 domain', 'Autophagy-rel_prot_16_dom', 3, NULL),
(14416, NULL, 'IPR014151', NULL, 'DNA helicase, AddA type', 'DNA_helicase_AddA', 4, NULL),
(14417, NULL, 'IPR009344', NULL, 'Borna disease virus G', 'BDV_G', 4, NULL),
(14418, NULL, 'IPR008586', NULL, 'Protein of unknown function DUF868, plant', 'DUF868_pln', 4, NULL),
(14419, NULL, 'IPR014131', NULL, 'Chlamydia phage, Vp3, scaffold', 'Chlamydia_phage_Vp3', 4, NULL),
(14420, NULL, 'IPR015369', NULL, 'Follistatin/Osteonectin EGF domain', 'Follistatin/Osteonectin_EGF', 3, NULL),
(14421, NULL, 'IPR015381', NULL, 'XLF, N-terminal', 'XLF_N', 3, NULL),
(14422, NULL, 'IPR014107', NULL, 'Cytochrome c oxidase cbb3-type, CcoQ', 'Cyt_c_oxidase_cbb3_CcoQ', 4, NULL),
(14423, NULL, 'IPR009901', NULL, 'Bacteriophage VT1-Sakai, H0025', 'Phage_VT1-Sakai_H0025', 4, NULL),
(14424, NULL, 'IPR009337', NULL, 'Protein of unknown function DUF995', 'DUF995', 4, NULL),
(14425, NULL, 'IPR009856', NULL, 'Light regulated Lir1', 'Lir1', 4, NULL),
(14426, NULL, 'IPR014087', NULL, '1-carboxybiuret hydrolase, AtzE subunit', 'Carboxybiuret_hydro_AtzE', 4, NULL),
(14427, NULL, 'IPR014147', NULL, 'Type IV conjugative transfer protein TrbJ', 'T4SS_TrbJ', 4, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(14428, NULL, 'IPR009334', NULL, 'Protein of unknown function DUF993', 'DUF993', 4, NULL),
(14429, NULL, 'IPR014160', NULL, 'Nickel-responsive transcriptional regulator NikR, proteobacteria', 'Nickel_NikR_proteobac', 4, NULL),
(14430, NULL, 'IPR009339', NULL, 'Protein of unknown function DUF998', 'DUF998', 4, NULL),
(14431, NULL, 'IPR013715', NULL, 'Domain of unknown function DUF1746', 'DUF1746', 3, NULL),
(14432, NULL, 'IPR013933', NULL, 'Chromatin-remodelling complex, RSC SWI/SNF subunit Rsc7/Swp82', 'CRC_Rsc7/Swp82', 4, NULL),
(14433, NULL, 'IPR012446', NULL, 'Calcium release-activated calcium channel protein', 'CRAC_channel', 4, NULL),
(14434, NULL, 'IPR014100', NULL, 'GTP-binding protein Obg/CgtA', 'GTP-bd_Obg/CgtA', 4, NULL),
(14435, NULL, 'IPR014922', NULL, 'Domain of unknown function DUF1801', 'DUF1801', 3, NULL),
(14436, NULL, 'IPR014964', NULL, 'Protein of unknown function DUF1830', 'DUF1830', 4, NULL),
(14437, NULL, 'IPR010547', NULL, 'Plant specific mitochondrial import receptor subunit TOM20', 'TOM20_imprt_rcpt', 4, NULL),
(14438, NULL, 'IPR009331', NULL, 'Oligogalacturonate-specific porin', 'Oligogalacturonate-sp_porin', 4, NULL),
(14439, NULL, 'IPR014144', NULL, 'DNA ligase D, 3''-phosphoesterase domain', 'LigD_PE_domain', 3, NULL),
(14440, NULL, 'IPR009354', NULL, 'Usg-like', 'Usg', 4, NULL),
(14441, NULL, 'IPR008610', NULL, 'Eukaryotic rRNA processing', 'Ebp2', 4, NULL),
(14442, NULL, 'IPR012452', NULL, 'Protein of unknown function DUF1657', 'DUF1657', 4, NULL),
(14443, NULL, 'IPR023270', NULL, 'tRNA (C5-cytosine) methyltransferase, NCL1', 'RCMT_NCL1', 4, NULL),
(14444, NULL, 'IPR014960', NULL, 'Domain of unknown function DUF1828', 'DUF1828', 3, NULL),
(14445, NULL, 'IPR014986', NULL, 'Phage-like element PBSX protein XkdN-like', 'XkdN-like', 4, NULL),
(14446, NULL, 'IPR015390', NULL, 'Rabaptin, GTPase-Rab5 binding domain', 'Rabaptin_Rab5-bd_dom', 3, NULL),
(14447, NULL, 'IPR012457', NULL, 'Domain of unknown function DUF1663', 'DUF1663', 3, NULL),
(14448, NULL, 'IPR014923', NULL, 'Protein of unknown function DUF1802', 'DUF1802', 4, NULL),
(14449, NULL, 'IPR014102', NULL, 'Phytoene desaturase', 'Phytoene_desaturase', 4, NULL),
(14450, NULL, 'IPR014105', NULL, 'Carotenoid/retinoid oxidoreductase', 'Carotenoid/retinoid_OxRdtase', 4, NULL),
(14451, NULL, 'IPR009376', NULL, 'Protein of unknown function DUF1031', 'DUF1031', 4, NULL),
(14452, NULL, 'IPR008602', NULL, 'Duffy-antigen binding', 'Duffy-antigen-binding', 4, NULL),
(14453, NULL, 'IPR015871', NULL, 'Transcription initiation factor IIA, gamma subunit, C-terminal', 'TFIIA_gsu_C', 3, NULL),
(14454, NULL, 'IPR035902', NULL, 'Nucleoside phosphorylase/phosphoribosyltransferase catalytic domain superfamily', 'Nuc_phospho_transferase', 5, NULL),
(14455, NULL, 'IPR014985', NULL, 'WbqC-like protein family', 'WbqC', 4, NULL),
(14456, NULL, 'IPR008617', NULL, 'Uncharacterised protein family, YcgJ', 'Uncharacterised_YcgJ', 4, NULL),
(14457, NULL, 'IPR014095', NULL, 'Phenylphosphate carboxylase, alpha subunit', 'Phenyl_P_COase_a', 4, NULL),
(14458, NULL, 'IPR015387', NULL, 'LuxQ, periplasmic domain', 'LuxQ-periplasm_dom', 3, NULL),
(14459, NULL, 'IPR014154', NULL, 'GTP-sensing transcriptional pleiotropic repressor CodY', 'CodY', 4, NULL),
(14460, NULL, 'IPR014163', NULL, 'Tol-Pal system, TolQ', 'Tol-Pal_TolQ', 4, NULL),
(14461, NULL, 'IPR008642', NULL, 'Herpesvirus BLRF2', 'Herpes_BLRF2', 4, NULL),
(14462, NULL, 'IPR014929', NULL, 'E2 binding', 'E2-binding', 3, NULL),
(14463, NULL, 'IPR012437', NULL, 'Domain of unknown function DUF1638', 'DUF1638', 3, NULL),
(14464, NULL, 'IPR012463', NULL, 'Ethylene-responsive binding factor-associated repression', 'Ninja_motif', 3, NULL),
(14465, NULL, 'IPR023253', NULL, 'FPRL1/chemotaxis inhibitory protein', 'FLIPR/CHIPS', 4, NULL),
(14466, NULL, 'IPR008598', NULL, 'Drought induced 19 protein type, zinc-binding domain', 'Di19_Zn-bd', 3, NULL),
(14467, NULL, 'IPR009863', NULL, 'Type III secretion protein, LcrG', 'T3SS_LcrG_PcrG', 4, NULL),
(14468, NULL, 'IPR014937', NULL, 'Protein of unknown function DUF1810', 'DUF1810', 4, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(14469, NULL, 'IPR012445', NULL, 'Autophagy-related protein 101', 'ATG101', 4, NULL),
(14470, NULL, 'IPR014931', NULL, 'Protein of unknown function DUF1805', 'DUF1805', 4, NULL),
(14471, NULL, 'IPR014975', NULL, 'Protein of unknown function DUF1836', 'DUF1836', 4, NULL),
(14472, NULL, 'IPR015393', NULL, 'Domain of unknown function DUF1972', 'DUF1972', 3, NULL),
(14473, NULL, 'IPR009882', NULL, 'Gypsy', 'Gypsy', 4, NULL),
(14474, NULL, 'IPR016017', NULL, 'GDNF/GAS1', 'GDNF/GAS1', 3, NULL),
(14475, NULL, 'IPR009864', NULL, 'Rhoptry-associated protein 1, plasmodium', 'RAP1_Plasmodium', 4, NULL),
(14476, NULL, 'IPR009370', NULL, 'YutD-like', 'YutD-like', 4, NULL),
(14477, NULL, 'IPR008628', NULL, 'Golgi phosphoprotein 3-like', 'GPP34-like', 4, NULL),
(14478, NULL, 'IPR014080', NULL, 'L-lactate oxidase', 'L_lactate_ox', 4, NULL),
(14479, NULL, 'IPR009894', NULL, 'Exported', 'EppA_BapA', 4, NULL),
(14480, NULL, 'IPR015411', NULL, 'Replication factor Mcm10, C-terminal', 'Rep_factor_Mcm10_C', 3, NULL),
(14481, NULL, 'IPR011871', NULL, 'Fibrobacter succinogenes major paralogous domain', 'Fib_succ_major', 3, NULL),
(14482, NULL, 'IPR012466', NULL, 'NECAP, PHear domain', 'NECAP_PHear', 3, NULL),
(14483, NULL, 'IPR009359', NULL, 'Phenylacetic acid degradation B', 'PaaB', 4, NULL),
(14484, NULL, 'IPR015401', NULL, 'Transposase, MuDR, N-terminal', 'Transposase_MuDR_N', 3, NULL),
(14485, NULL, 'IPR014932', NULL, 'Doublesex dimerisation', 'DSX_dimer', 3, NULL),
(14486, NULL, 'IPR009371', NULL, 'Type III secretion protein HrpF', 'T3SS_HrpF', 4, NULL),
(14487, NULL, 'IPR014145', NULL, 'DNA ligase D, polymerase domain', 'LigD_pol_dom', 3, NULL),
(14488, NULL, 'IPR013935', NULL, 'TRAPP II complex, Trs120', 'TRAPP_II_complex_Trs120', 4, NULL),
(14489, NULL, 'IPR009374', NULL, 'Eukaryotic translation initiation factor 3 subunit K', 'eIF3k', 4, NULL),
(14490, NULL, 'IPR012474', NULL, 'Frigida-like', 'Frigida', 4, NULL),
(14491, NULL, 'IPR015367', NULL, 'Transcription factor CEP-1, DNA-binding domain', 'Trans_fact_CEP1_DNA-bd', 3, NULL),
(14492, NULL, 'IPR009895', NULL, 'Protein of unknown function DUF1438', 'DUF1438', 4, NULL),
(14493, NULL, 'IPR010543', NULL, 'Domain of unknown function DUF1117', 'DUF1117', 3, NULL),
(14494, NULL, 'IPR009355', NULL, 'Toluene-4-monooxygenase system B', 'Toluene_mOase_B', 4, NULL),
(14495, NULL, 'IPR014155', NULL, 'Type IV secretion system protein VirB11', 'VirB11', 4, NULL),
(14496, NULL, 'IPR014943', NULL, 'Protein of unknown function DUF1815', 'DUF1815', 4, NULL),
(14497, NULL, 'IPR009320', NULL, 'Antitoxin CbeA', 'Antitoxin_CbeA', 4, NULL),
(14498, NULL, 'IPR009852', NULL, 'T-complex protein 10, C-terminal domain', 'Tcp10_C_dom', 3, NULL),
(14499, NULL, 'IPR009915', NULL, 'NnrU domain', 'NnrU_dom', 3, NULL),
(14500, NULL, 'IPR014955', NULL, 'Protein of unknown function DUF1826', 'DUF1826', 4, NULL),
(14501, NULL, 'IPR020910', NULL, 'Uncharacterised protein family UPF0370', 'UPF0370', 4, NULL),
(14502, NULL, 'IPR034964', NULL, 'Lumazine synthase', 'LS', 4, NULL),
(14503, NULL, 'IPR020937', NULL, 'SecA conserved site', 'SecA_CS', 2, NULL),
(14504, NULL, 'IPR018959', NULL, 'Domain of unknown function DUF1989', 'DUF1989', 3, NULL),
(14505, NULL, 'IPR020919', NULL, 'Ribosomal protein S8e, archaeal', 'Ribosomal_protein_S8e_arc', 4, NULL),
(14506, NULL, 'IPR017528', NULL, 'Conserved hypothetical protein CHP03097, O-antigen ligase-related', 'CHP03097O-antigen_lig-rel', 4, NULL),
(14507, NULL, 'IPR019315', NULL, 'Multiple myeloma tumor-associated protein 2-like, N-terminal', 'MMTA2_N', 3, NULL),
(14508, NULL, 'IPR020915', NULL, 'Uncharacterised protein family UPF0311', 'UPF0311', 4, NULL),
(14509, NULL, 'IPR022977', NULL, 'Pyrimidine-specific ribonucleoside hydrolase RihB', 'Pyrim_hydro_RihB', 4, NULL),
(14510, NULL, 'IPR017199', NULL, 'Uncharacterised conserved protein UCP037409, membrane transporter, MTH672', 'UCP037409_transporter', 4, NULL),
(14511, NULL, 'IPR020908', NULL, 'Uncharacterised protein family UPF0738', 'UPF0738', 4, NULL),
(14512, NULL, 'IPR022692', NULL, 'Geminivirus AL1 replication-associated protein, central domain', 'Gemini_AL1_REP_central', 3, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(14513, NULL, 'IPR020988', NULL, 'Peptidase U32, collagenase', 'Pept_U32_collagenase', 3, NULL),
(14514, NULL, 'IPR020554', NULL, 'Uncharacterised protein family UPF0021, conserved site', 'UPF0021_CS', 2, NULL),
(14515, NULL, 'IPR020954', NULL, 'Rickettsia surface antigen, 120kDa', 'Rickettsia_antigen_120kDa', 4, NULL),
(14516, NULL, 'IPR018501', NULL, 'DDT domain', 'DDT_dom', 3, NULL),
(14517, NULL, 'IPR022946', NULL, 'Uncharacterised protein family UPF0313', 'UPF0313', 4, NULL),
(14518, NULL, 'IPR022887', NULL, 'Cell division suppressor protein, YneA', 'Cell_div_suppressor_YneA', 4, NULL),
(14519, NULL, 'IPR022842', NULL, 'DNA-directed RNA polymerase subunit Rpo3/Rpb3/RPAC1', 'RNAP_Rpo3/Rpb3/RPAC1', 4, NULL),
(14520, NULL, 'IPR035462', NULL, 'Eps8, SH3 domain', 'Eps8_SH3', 3, NULL),
(14521, NULL, 'IPR020541', NULL, 'Chorismate synthase, conserved site', 'Chorismate_synthase_CS', 2, NULL),
(14522, NULL, 'IPR018491', NULL, 'SLC12A transporter, C-terminal', 'SLC12_C', 3, NULL),
(14523, NULL, 'IPR018504', NULL, 'RTX, pore-forming domain', 'RTX_pore_form', 3, NULL),
(14524, NULL, 'IPR035115', NULL, 'Protein of unknown function DUF5514', 'DUF5514', 4, NULL),
(14525, NULL, 'IPR017549', NULL, 'Acanthamoeba polyphaga mimivirus, L690', 'APMV_L690', 3, NULL),
(14526, NULL, 'IPR024911', NULL, 'DNA gyrase inhibitor GyrI', 'DNA_gyrase_inhibitor_GyrI', 4, NULL),
(14527, NULL, 'IPR022832', NULL, 'Probable 4-amino-4-deoxy-L-arabinose-phosphoundecaprenol flippase subunit ArnF', 'Flippase_ArnF', 4, NULL),
(14528, NULL, 'IPR034995', NULL, 'SRSF9, RNA recognition motif 2', 'SRSF9_RRM2', 3, NULL),
(14529, NULL, 'IPR018047', NULL, 'Ammonium transporter, conserved site', 'Ammonium_transpt_CS', 2, NULL),
(14530, NULL, 'IPR017535', NULL, 'Asparagine synthase family amidotransferase', 'Asparagine_synth', 4, NULL),
(14531, NULL, 'IPR018976', NULL, 'Imelysin-like domain', 'Imelysin-like', 3, NULL),
(14532, NULL, 'IPR022916', NULL, 'Protein of unknown function UPF0349', 'UPF0349', 4, NULL),
(14533, NULL, 'IPR017529', NULL, 'Acyl-CoA ligase (AMP-forming), exosortase system type 1 associated', 'AcylCoA_ligase_PEP_1', 4, NULL),
(14534, NULL, 'IPR020972', NULL, 'Dermonecrotic/RTX toxin, membrane localization domain', 'Dermonecrotic/RTX_toxin_MLD', 3, NULL),
(14535, NULL, 'IPR018915', NULL, 'Bacteriophage A118, Gp45', 'Phage_A118_Gp45', 4, NULL),
(14536, NULL, 'IPR020843', NULL, 'Polyketide synthase, enoylreductase domain', 'PKS_ER', 3, NULL),
(14537, NULL, 'IPR022605', NULL, 'Protein of unknown function DUF2920', 'DUF2920', 4, NULL),
(14538, NULL, 'IPR017526', NULL, 'Small acid-soluble spore protein, SspL', 'SASP_SspL', 4, NULL),
(14539, NULL, 'IPR018961', NULL, 'DnaJ homologue, subfamily C, member 28, conserved domain', 'DnaJ_homolog_subfam-C_membr-28', 3, NULL),
(14540, NULL, 'IPR020811', NULL, 'Enolase, N-terminal', 'Enolase_N', 3, NULL),
(14541, NULL, 'IPR020924', NULL, 'Ribosomal protein S6e, archaeal', 'Ribosomal_S6e_arc', 4, NULL),
(14542, NULL, 'IPR022930', NULL, 'Protein of unknown function UPF0316', 'UPF0316', 4, NULL),
(14543, NULL, 'IPR011365', NULL, 'Cytokine IL-3/IL-5/GM-CSF receptor common beta chain', 'IL3_rcpt_beta', 4, NULL),
(14544, NULL, 'IPR020981', NULL, 'Monopolin complex subunit Csm1/Pcs1, C-terminal', '-Csm1/Pcs1_C', 3, NULL),
(14545, NULL, 'IPR022376', NULL, 'PQQ-dependent catabolism-associated CXXCW motif', 'PQQ_CXXCW', 4, NULL),
(14546, NULL, 'IPR017542', NULL, 'Putative glycosyltransferase, exosortase G-associated', 'Glycosyltfrase_exosort_G_assoc', 4, NULL),
(14547, NULL, 'IPR011387', NULL, 'Translation initiation factor 2A', 'TIF2A', 4, NULL),
(14548, NULL, 'IPR020909', NULL, 'UPF0736', 'UPF0736', 4, NULL),
(14549, NULL, 'IPR018913', NULL, 'BppU, N-terminal', 'BppU_N', 3, NULL),
(14550, NULL, 'IPR022932', NULL, 'Putative phosphoesterase YjcG', 'YjcG', 4, NULL),
(14551, NULL, 'IPR018960', NULL, 'Domain of unknown function DUF1990', 'DUF1990', 3, NULL),
(14552, NULL, 'IPR022786', NULL, 'Geminin/Multicilin', 'Geminin/Multicilin', 4, NULL),
(14553, NULL, 'IPR020925', NULL, 'Ribosomal protein L15e, conserved site', 'Ribosomal_L15e_CS', 2, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(14554, NULL, 'IPR022925', NULL, 'NAD-capped RNA hydrolase NudC', 'RNA_Hydrolase_NudC', 4, NULL),
(14555, NULL, 'IPR022783', NULL, 'GCF, C-terminal', 'GCFC_dom', 3, NULL),
(14556, NULL, 'IPR035113', NULL, 'Protein 14, SARS-like', 'Protein_14_SARS-like', 4, NULL),
(14557, NULL, 'IPR022554', NULL, 'Respiratory growth induced protein 1', 'RGI1', 4, NULL),
(14558, NULL, 'IPR023678', NULL, 'Tyrosine-tRNA ligase, type 4', 'Tyr-tRNA-ligase_4', 4, NULL),
(14559, NULL, 'IPR020561', NULL, 'Phosphoribosylglycinamide synthetase, ATP-grasp (A) domain', 'PRibGlycinamid_synth_ATP-grasp', 3, NULL),
(14560, NULL, 'IPR022529', NULL, 'Protein of unknown function DUF3530', 'DUF3530', 4, NULL),
(14561, NULL, 'IPR023118', NULL, 'YqaI domain superfamily', 'YqaI_dom_sf', 5, NULL),
(14562, NULL, 'IPR017525', NULL, 'Small, acid-soluble spore protein I', 'SspI', 4, NULL),
(14563, NULL, 'IPR034291', NULL, 'Thiamine phosphate synthase', 'TMP_synthase', 4, NULL),
(14564, NULL, 'IPR018968', NULL, 'Phasin', 'Phasin', 3, NULL),
(14565, NULL, 'IPR023812', NULL, 'Conserved hypothetical protein CHP04002', 'CHP04002', 4, NULL),
(14566, NULL, 'IPR017956', NULL, 'AT hook, DNA-binding motif', 'AT_hook_DNA-bd_motif', 2, NULL),
(14567, NULL, 'IPR021001', NULL, 'Spidroin, C-terminal', 'Spidroin_C', 3, NULL),
(14568, NULL, 'IPR020818', NULL, 'GroES chaperonin family', 'Chaperonin_GroES', 4, NULL),
(14569, NULL, 'IPR024271', NULL, 'Protein of unknown function DUF3782', 'DUF3782', 4, NULL),
(14570, NULL, 'IPR019309', NULL, 'WASH complex subunit 3', 'WASHC3', 4, NULL),
(14571, NULL, 'IPR019334', NULL, 'Transmembrane protein 170', 'Transmembrane_pr_170', 4, NULL),
(14572, NULL, 'IPR020941', NULL, 'Suppressor of fused-like domain', 'SUFU-like_domain', 3, NULL),
(14573, NULL, 'IPR019317', NULL, 'Brain protein I3', 'Brain_I3', 4, NULL),
(14574, NULL, 'IPR022813', NULL, 'Protein-export membrane protein SecD/SecF, archaeal and bacterial', 'SecD/SecF_arch_bac', 4, NULL),
(14575, NULL, 'IPR017551', NULL, 'Triphosphoribosyl-dephospho-CoA synthase CitG', 'TriPribosyl-deP-CoA_syn_CitG', 4, NULL),
(14576, NULL, 'IPR018541', NULL, 'FtsK gamma domain', 'Ftsk_gamma', 3, NULL),
(14577, NULL, 'IPR020958', NULL, 'Domain of unknown function DUF3686', 'DUF3686', 3, NULL),
(14578, NULL, 'IPR018978', NULL, 'Ribosome maturation protein SDO1/SBDS, central domain', 'SDO1/SBDS_central', 3, NULL),
(14579, NULL, 'IPR017554', NULL, 'Malonate decarboxylase, McdH subunit', 'Malonate_deCOase_MdcHsu', 4, NULL),
(14580, NULL, 'IPR019305', NULL, 'Uncharacterised protein family Smp', 'Uncharacterised_Smp', 4, NULL),
(14581, NULL, 'IPR017560', NULL, 'Cytochrome c-type biogenesis protein CcmI', 'Cyt_c_biogenesis_CcmI', 3, NULL),
(14582, NULL, 'IPR034153', NULL, 'RBM44, RNA recognition motif', 'RBM44_RRM', 3, NULL),
(14583, NULL, 'IPR020966', NULL, 'Aluminum-activated malate transporter', 'ALMT', 4, NULL),
(14584, NULL, 'IPR018972', NULL, 'Sas10 C-terminal domain', 'Sas10_C_dom', 3, NULL),
(14585, NULL, 'IPR020559', NULL, 'Phosphoribosylglycinamide synthetase, conserved site', 'PRibGlycinamide_synth_CS', 2, NULL),
(14586, NULL, 'IPR022790', NULL, 'Glycosyl hydrolase family 26 domain', 'GH26_dom', 3, NULL),
(14587, NULL, 'IPR024763', NULL, 'Vacuolar protein sorting protein 11, C-terminal', 'VPS11_C', 3, NULL),
(14588, NULL, 'IPR018534', NULL, 'Tetracycline regulation of excision, RteC', 'Tet_reg_excision_RteC', 4, NULL),
(14589, NULL, 'IPR019921', NULL, 'Luciferase-like, F420-dependent oxidoreductase, Rv2161c, predicted', 'Lucif-like_OxRdtase_Rv2161c', 3, NULL),
(14590, NULL, 'IPR017518', NULL, 'Conserved hypothetical protein CHP03084', 'CHP03084', 4, NULL),
(14591, NULL, 'IPR011364', NULL, 'Breast cancer type 1 susceptibility protein (BRCA1)', 'BRCA1', 4, NULL),
(14592, NULL, 'IPR022951', NULL, 'Uncharacterised protein family UPF0309', 'UPF0309', 4, NULL),
(14593, NULL, 'IPR020992', NULL, 'Tail specific protease, C-terminal', 'Tail_Prtase_C', 3, NULL),
(14594, NULL, 'IPR035361', NULL, 'Honey bee toxin', 'Bee_toxin', 4, NULL),
(14595, NULL, 'IPR017532', NULL, 'Hydrolase, ortholog 2, exosortase system type 1 associated', 'Hydrolase-2_PEP', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(14596, NULL, 'IPR022559', NULL, 'Protein SUP-1-like', 'SUP-1-like', 4, NULL),
(14597, NULL, 'IPR024909', NULL, 'Cysteinyl-tRNA synthetase/mycothiol ligase', 'Cys-tRNA/MSH_ligase', 4, NULL),
(14598, NULL, 'IPR022535', NULL, 'Golgi pH regulator, conserved domain', 'Golgi_pH-regulator_cons_dom', 3, NULL),
(14599, NULL, 'IPR018914', NULL, 'Protein of unknown function DUF2480', 'DUF2480', 4, NULL),
(14600, NULL, 'IPR034999', NULL, 'HuB, RNA recognition motif 2', 'HuB_RRM2', 3, NULL),
(14601, NULL, 'IPR011383', NULL, 'N-lysine methyltransferase SETD6', 'N-lys_methylase_SETD6', 4, NULL),
(14602, NULL, 'IPR018919', NULL, 'Protein of unknown function DUF2484', 'DUF2484', 4, NULL),
(14603, NULL, 'IPR020562', NULL, 'Phosphoribosylglycinamide synthetase, N-terminal', 'PRibGlycinamide_synth_N', 3, NULL),
(14604, NULL, 'IPR023584', NULL, 'Ribosome recycling factor domain', 'Ribosome_recyc_fac_dom', 3, NULL),
(14605, NULL, 'IPR017201', NULL, 'Uncharacterised conserved protein UCP037429', 'UCP037429', 4, NULL),
(14606, NULL, 'IPR018931', NULL, 'Domain of unknown function DUF2520', 'DUF2520', 3, NULL),
(14607, NULL, 'IPR011379', NULL, 'NTP Pyrophosphohydrolase MazG-related, GP37', 'MazG-related_GP37', 4, NULL),
(14608, NULL, 'IPR024875', NULL, 'Protein Lines', 'Protein_Lines', 4, NULL),
(14609, NULL, 'IPR017541', NULL, 'Exosortase family protein XrtG', 'Exosort-XrtG', 4, NULL),
(14610, NULL, 'IPR017555', NULL, 'Triphosphoribosyl-dephospho-CoA synthase', 'TriPribosyl-deP-CoA_syn', 4, NULL),
(14611, NULL, 'IPR022735', NULL, 'bMERB domain', 'bMERB_dom', 3, NULL),
(14612, NULL, 'IPR019332', NULL, 'Organic solute carrier protein 1', 'OSCP1', 4, NULL),
(14613, NULL, 'IPR019890', NULL, 'Bacteriocin, heterocycloanthracin/sonorensin family', 'Bacteriocin/sonorensin', 4, NULL),
(14614, NULL, 'IPR018050', NULL, 'Phosphomannose isomerase, type I, conserved site', 'Pmannose_isomerase-type1_CS', 2, NULL),
(14615, NULL, 'IPR022927', NULL, 'RNA pyrophosphohydrolase RppH', 'RppH', 4, NULL),
(14616, NULL, 'IPR018918', NULL, 'Protein of unknown function DUF2483', 'DUF2483', 4, NULL),
(14617, NULL, 'IPR018912', NULL, 'Protein of unknown function DUF2478', 'DUF2478', 4, NULL),
(14618, NULL, 'IPR018957', NULL, 'Zinc finger, C3HC4 RING-type', 'Znf_C3HC4_RING-type', 3, NULL),
(14619, NULL, 'IPR024759', NULL, 'UvrB, YAD/RRR-motif-containing domain', 'UvrB_YAD/RRR_dom', 3, NULL),
(14620, NULL, 'IPR034027', NULL, 'Reprolysin domain, adamalysin-type', 'Reprolysin_adamalysin', 3, NULL),
(14621, NULL, 'IPR020538', NULL, 'Hydrogenase nickel incorporation protein HypA/HybF, conserved site', 'Hydgase_Ni_incorp_HypA/HybF_CS', 2, NULL),
(14622, NULL, 'IPR019306', NULL, 'Transmembrane protein 231', 'TMEM231', 4, NULL),
(14623, NULL, 'IPR020961', NULL, 'Domain of unknown function DUF3642, lipoprotein', 'DUF3642_lipo', 3, NULL),
(14624, NULL, 'IPR019855', NULL, 'CRISPR-associated protein Cas1, NMENI subtype', 'CRISPR-assoc_Cas1_NMENI', 4, NULL),
(14625, NULL, 'IPR021005', NULL, 'Zinc finger, CGNR', 'Znf_CGNR', 3, NULL),
(14626, NULL, 'IPR018542', NULL, 'Protein 9b, Betacoronavirus', 'Protein_9b_Betacoronavirus', 4, NULL),
(14627, NULL, 'IPR035460', NULL, 'FCHSD, SH3 domain 1', 'FCHSD_SH3_1', 3, NULL),
(14628, NULL, 'IPR035386', NULL, 'Arm, DNA-binding domain', 'Arm-DNA-bind_5', 3, NULL),
(14629, NULL, 'IPR019920', NULL, 'F420-binding domain, putative', 'F420-binding_dom_put', 3, NULL),
(14630, NULL, 'IPR019318', NULL, 'Guanine nucleotide exchange factor, Ric8', 'Gua_nucleotide_exch_fac_Ric8', 4, NULL),
(14631, NULL, 'IPR019786', NULL, 'Zinc finger, PHD-type, conserved site', 'Zinc_finger_PHD-type_CS', 2, NULL),
(14632, NULL, 'IPR022929', NULL, 'Putative manganese efflux pump MntP', 'Put_MntP', 4, NULL),
(14633, NULL, 'IPR018540', NULL, 'Aspartyl-phosphate phosphatase Spo0E-like', 'Spo0E-like', 4, NULL),
(14634, NULL, 'IPR020557', NULL, 'Fumarate lyase, conserved site', 'Fumarate_lyase_CS', 2, NULL),
(14635, NULL, 'IPR035114', NULL, 'Gene product 67', 'GP67', 4, NULL),
(14636, NULL, 'IPR019330', NULL, 'LRP chaperone MESD', 'MESD', 4, NULL),
(14637, NULL, 'IPR020350', NULL, 'Chemokine-like protein TAFA', 'Chemokine-like_TAFA', 4, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(14638, NULL, 'IPR035465', NULL, 'Rho GTPase-activating protein 9, SH3 domain', 'ARHGAP9_SH3', 3, NULL),
(14639, NULL, 'IPR020922', NULL, 'dITP/XTP pyrophosphatase', 'dITP/XTP_pyrophosphatase', 4, NULL),
(14640, NULL, 'IPR022934', NULL, 'Manganese-dependent inorganic pyrophosphatase, probable', 'Mn-dep_inorganic_PyrPase', 4, NULL),
(14641, NULL, 'IPR035459', NULL, 'Bzz1, SH3 domain 1', 'Bzz1_SH3_1', 3, NULL),
(14642, NULL, 'IPR035398', NULL, 'Alpha-L-rhamnosidase C-terminal domain', 'Bac_rhamnosid_C', 3, NULL),
(14643, NULL, 'IPR019888', NULL, 'Transcription regulator AsnC-like', 'Tscrpt_reg_AsnC-like', 4, NULL),
(14644, NULL, 'IPR019918', NULL, 'Pyrimidine permease RutG, predicted', 'Pyrimidine_permease_RutG_pred', 4, NULL),
(14645, NULL, 'IPR023298', NULL, 'P-type ATPase, transmembrane domain superfamily', 'ATPase_P-typ_TM_dom_sf', 5, NULL),
(14646, NULL, 'IPR022555', NULL, 'Protein of unknown function, DUF2577', 'DUF2577', 4, NULL),
(14647, NULL, 'IPR011356', NULL, 'Peptidase M17, leucine aminopeptidase/peptidase B', 'Leucine_aapep/pepB', 4, NULL),
(14648, NULL, 'IPR022452', NULL, 'Antitoxin MqsA', 'MqsA', 4, NULL),
(14649, NULL, 'IPR019329', NULL, 'NADH:ubiquinone oxidoreductase, ESSS subunit', 'NADH_UbQ_OxRdtase_ESSS_su', 4, NULL),
(14650, NULL, 'IPR020969', NULL, 'Ankyrin-G binding site', 'Ankyrin-G_BS', 1, NULL),
(14651, NULL, 'IPR011346', NULL, 'High-molecular-weight cytochrome c', 'Cyt_cc3', 4, NULL),
(14652, NULL, 'IPR022969', NULL, 'Chloride channel YfeO', 'Chloride_channel_YfeO', 4, NULL),
(14653, NULL, 'IPR017548', NULL, 'CRISPR-associated DEAD/DEAH-box helicase Csf4', 'CRISPR-assoc_helicase_Csf4', 4, NULL),
(14654, NULL, 'IPR024918', NULL, '3''-5'' ssDNA/RNA exonuclease TatD', 'Exonuc_TatD', 4, NULL),
(14655, NULL, 'IPR022804', NULL, 'Ribosomal protein L5, archaeal', 'Ribosomal_L5_arc', 4, NULL),
(14656, NULL, 'IPR018916', NULL, 'Protein of unknown function DUF2481', 'DUF2481', 4, NULL),
(14657, NULL, 'IPR020976', NULL, 'LCI fold', 'Antimicrobial_lci', 3, NULL),
(14658, NULL, 'IPR022914', NULL, 'Protein of unknown function UPF0397', 'UPF0397', 4, NULL),
(14659, NULL, 'IPR022606', NULL, 'Domain of unknown function DUF2914', 'DUF2914', 3, NULL),
(14660, NULL, 'IPR022944', NULL, 'ATPase, V1 complex, subunit F, bacterial/archaeal', 'ATPase_V1-cplx_fsu_bac/arc', 4, NULL),
(14661, NULL, 'IPR019320', NULL, 'BLOC-1-related complex subunit 8', 'BORCS8', 4, NULL),
(14662, NULL, 'IPR022787', NULL, 'D-proline reductase (dithiol), PrdB protein', 'D_pro_red_PrdB', 4, NULL),
(14663, NULL, 'IPR018932', NULL, 'Salivary thrombin inhibitor anophelin, mosquito', 'Thrombin_inhibitor_anophelin', 4, NULL),
(14664, NULL, 'IPR020912', NULL, 'Uncharacterised protein family UPF0295', 'UPF0295', 4, NULL),
(14665, NULL, 'IPR018962', NULL, 'Domain of unknown function DUF1995', 'DUF1995', 3, NULL),
(14666, NULL, 'IPR020929', NULL, 'Ribosomal protein L5, conserved site', 'Ribosomal_L5_CS', 2, NULL),
(14667, NULL, 'IPR017517', NULL, 'Conserved hypothetical protein CHP03083, actinobacterial-type', 'CHP03083_actinobac', 4, NULL),
(14668, NULL, 'IPR018973', NULL, 'MrfA-like Zn-binding domain', 'MZB', 3, NULL),
(14669, NULL, 'IPR022923', NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase, archaeal and bacterial', 'TRM1_arc_bac', 4, NULL),
(14670, NULL, 'IPR022686', NULL, 'Replication-associated protein G2P, N-terminal', 'G2P_N', 3, NULL),
(14671, NULL, 'IPR019335', NULL, 'Conserved oligomeric Golgi complex subunit 7', 'COG7', 4, NULL),
(14672, NULL, 'IPR019915', NULL, 'Transcription regulator, pyrimidine utilisation, RutR', 'Tscrpt_reg_pyr_util_RutR', 4, NULL),
(14673, NULL, 'IPR022968', NULL, '16S/18S rRNA aminocarboxypropyltransferase Tsr3', 'Tsr3-like', 4, NULL),
(14674, NULL, 'IPR011367', NULL, 'Haemoglobin, polymeric', 'Haemoglobin_polymeric', 4, NULL),
(14675, NULL, 'IPR020914', NULL, 'Probable succinate transporter subunit YjjB', 'YjjB', 4, NULL),
(14676, NULL, 'IPR020979', NULL, 'Uncharacterised protein family A0KLC6', 'Uncharacterised_A0KLC6', 4, NULL),
(14677, NULL, 'IPR019897', NULL, 'RidA, conserved site', 'RidA_CS', 2, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(14678, NULL, 'IPR017536', NULL, 'Glutamine synthetase, type III', 'Glutamine_synthetase_typeIII', 4, NULL),
(14679, NULL, 'IPR022972', NULL, 'Uncharacterised protein family UPF0292', 'UPF0292', 4, NULL),
(14680, NULL, 'IPR019787', NULL, 'Zinc finger, PHD-finger', 'Znf_PHD-finger', 3, NULL),
(14681, NULL, 'IPR017204', NULL, 'Signal transduction histidine kinase, STH3221, predicted', 'Sig_transdc_His_kin_STH3221', 4, NULL),
(14682, NULL, 'IPR020921', NULL, 'Erythronate-4-phosphate dehydrogenase', 'Erythronate-4-P_DHase', 4, NULL),
(14683, NULL, 'IPR019836', NULL, 'Verru/Chthon cassette protein D', 'Verru/Chthon_D', 4, NULL),
(14684, NULL, 'IPR018537', NULL, 'Peptidoglycan binding domain', 'Peptidoglycan-bd_3', 3, NULL),
(14685, NULL, 'IPR018046', NULL, 'Pili assembly chaperone, conserved site', 'Pili_assmbl_chaperone_CS', 2, NULL),
(14686, NULL, 'IPR019328', NULL, 'GPI-GlcNAc transferase complex, PIG-H component, conserved domain', 'GPI-GlcNAc_Trfase_PIG-H_dom', 3, NULL),
(14687, NULL, 'IPR022792', NULL, 'Type II secretion system protein GspN', 'T2SS_protein-GspN', 4, NULL),
(14688, NULL, 'IPR019314', NULL, 'BLOC-1-related complex subunit 6', 'BORCS6', 4, NULL),
(14689, NULL, 'IPR018911', NULL, 'Bacterial spore germination, immunoglobulin-like domain', 'Gmad2_Ig-like_dom', 3, NULL),
(14690, NULL, 'IPR018971', NULL, 'Protein of unknown function DUF1997', 'DUF1997', 4, NULL),
(14691, NULL, 'IPR011385', NULL, 'Putative site-specific recombinase Gcr', 'Site-sp_rcmbase', 4, NULL),
(14692, NULL, 'IPR020983', NULL, 'Basic leucine-zipper, C-terminal', 'Basic_leucine-zipper_C', 3, NULL),
(14693, NULL, 'IPR018928', NULL, 'Generative cell specific-1/HAP2 domain', 'HAP2/GCS1_dom', 3, NULL),
(14694, NULL, 'IPR022737', NULL, 'RNA polymerase recycling, bacterial, C-terminal', 'RapA_C', 3, NULL),
(14695, NULL, 'IPR022975', NULL, 'Pyrimidine-specific ribonucleoside hydrolase RihA', 'Pyrim_hydro_RihA', 4, NULL),
(14696, NULL, 'IPR020993', NULL, 'Centromere protein Cenp-K', 'Centromere_CenpK', 4, NULL),
(14697, NULL, 'IPR019313', NULL, 'Mediator complex, subunit Med17', 'Mediator_Med17', 4, NULL),
(14698, NULL, 'IPR023810', NULL, 'Conserved hypothetical protein CHP03894', 'CHP03894', 4, NULL),
(14699, NULL, 'IPR034485', NULL, 'Anaerobic Cys-type sulfatase-maturating enzyme', 'Anaerobic_Cys-type_sulfatase-m', 4, NULL),
(14700, NULL, 'IPR035387', NULL, 'Protein of unknown function DUF5406', 'DUF5406', 4, NULL),
(14701, NULL, 'IPR019308', NULL, 'Transmembrane protein 214', 'TMEM214', 4, NULL),
(14702, NULL, 'IPR017522', NULL, 'Sugar transferase, PEP-CTERM, Stp2', 'Sugar_tfrase_PEP-CTERM_Stp2', 4, NULL),
(14703, NULL, 'IPR017523', NULL, 'Conserved hypothetical protein CHP03089', 'CHP03089', 4, NULL),
(14704, NULL, 'IPR022921', NULL, 'Methionine synthase MetE, archaeal', 'MetE_arc', 4, NULL),
(14705, NULL, 'IPR018948', NULL, 'GTP-binding protein TrmE, N-terminal', 'GTP-bd_TrmE_N', 3, NULL),
(14706, NULL, 'IPR022933', NULL, 'Uncharacterised protein family UPF0353', 'UPF0353', 4, NULL),
(14707, NULL, 'IPR018533', NULL, 'Forkhead box protein, C-terminal', 'Forkhead_box_C', 3, NULL),
(14708, NULL, 'IPR018950', NULL, 'Disulphide bond isomerase, DsbC/G, N-terminal', 'DiS-bond_isomerase_DsbC/G_N', 3, NULL),
(14709, NULL, 'IPR019847', NULL, 'Gliding motility associated protein GldN', 'Gliding_motility_assoc_GldN', 4, NULL),
(14710, NULL, 'IPR019780', NULL, 'Germin, manganese binding site', 'Germin_Mn-BS', 1, NULL),
(14711, NULL, 'IPR019858', NULL, 'CRISPR-associated protein Cas1, HMARI/TNEAP subtype', 'CRISPR-assoc_Cas1_HMARI/TNEAP', 4, NULL),
(14712, NULL, 'IPR017203', NULL, 'Signal transduction histidine kinase, NreB', 'Sig_transdc_His_kinase_NreB', 4, NULL),
(14713, NULL, 'IPR017557', NULL, 'Phosphoribosyl-dephospho-CoA transferase', 'Holo-ACP_synthase', 4, NULL),
(14714, NULL, 'IPR020930', NULL, 'Ribosomal protein L5, bacterial-type', 'Ribosomal_L5_bac-type', 4, NULL),
(14715, NULL, 'IPR022876', NULL, 'Redox-sensing transcriptional repressor Rex', 'Tscrpt_rep_Rex', 4, NULL),
(14716, NULL, 'IPR024914', NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', 'tRNA_acetyltr_TmcA', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(14717, NULL, 'IPR020810', NULL, 'Enolase, C-terminal TIM barrel domain', 'Enolase_C', 3, NULL),
(14718, NULL, 'IPR019893', NULL, 'PQQ-dependent dehydrogenase, s-GDH family', 'PQQ-dependent_DH_s-GDH', 4, NULL),
(14719, NULL, 'IPR022976', NULL, 'Non-specific ribonucleoside hydrolase RihC', 'Nucleosid_hydro_RihC_nonspecif', 4, NULL),
(14720, NULL, 'IPR018053', NULL, 'Glycoside hydrolase, family 32, active site', 'Glyco_hydro_32_AS', 0, NULL),
(14721, NULL, 'IPR017559', NULL, 'Alkyl hydroperoxide reductase subunit C', 'AhpC', 4, NULL),
(14722, NULL, 'IPR020936', NULL, 'tRNA uridine(34) hydroxylase', 'TrhO', 4, NULL),
(14723, NULL, 'IPR018963', NULL, 'Mycobacteriophage D29, Gp19', 'Mycophage_D29_Gp19', 4, NULL),
(14724, NULL, 'IPR022724', NULL, 'RNA methyltransferase, SpoU/TrmH type, C-terminal', 'rRNA_MeTrfase_SpoU_C', 3, NULL),
(14725, NULL, 'IPR019916', NULL, 'Ureidoacrylate amidohydrolase RutB', 'RutB', 4, NULL),
(14726, NULL, 'IPR018924', NULL, 'Protein of unknown function DUF2486', 'DUF2486', 4, NULL),
(14727, NULL, 'IPR018515', NULL, 'Tuberin-type domain', 'Tuberin-type_domain', 3, NULL),
(14728, NULL, 'IPR017546', NULL, 'CRISPR type IV/AFERR-associated protein Csf2', 'CRISPR-assoc_prot_Csf2', 4, NULL),
(14729, NULL, 'IPR018536', NULL, 'Chromophore lyase CpcS/CpeS', 'CpcS/CpeS', 4, NULL),
(14730, NULL, 'IPR024917', NULL, 'Propionate kinase', 'Propionate_kinase', 4, NULL),
(14731, NULL, 'IPR023739', NULL, '3-phenylpropionate/cinnamic acid dioxygenase, ferredoxin subunit', 'HcaC', 4, NULL),
(14732, NULL, 'IPR019324', NULL, 'M-phase phosphoprotein 6', 'MPP6', 4, NULL),
(14733, NULL, 'IPR021003', NULL, 'Cytomegalovirus glycoprotein N, N-terminal', 'Cytomegalovirus_glycopN_N', 3, NULL),
(14734, NULL, 'IPR018927', NULL, 'Toxin co-regulated pilus biosynthesis protein Q, C-terminal', 'Pilus_synth_Q_C', 3, NULL),
(14735, NULL, 'IPR022952', NULL, 'Archease, archaea', 'Archease_arc', 4, NULL),
(14736, NULL, 'IPR020751', NULL, 'Aminoacyl-tRNA synthetase, class I, anticodon-binding domain, subdomain 2', 'aa-tRNA-synth_I_codon-bd_sub2', 5, NULL),
(14737, NULL, 'IPR022893', NULL, 'Shikimate dehydrogenase family', 'Shikimate_DH_fam', 4, NULL),
(14738, NULL, 'IPR018511', NULL, 'Hemolysin-type calcium-binding conserved site', 'Hemolysin-typ_Ca-bd_CS', 2, NULL),
(14739, NULL, 'IPR020608', NULL, 'RNA polymerase, subunit H/Rpb5, conserved site', 'RNA_pol_subH/Rpb5_CS', 2, NULL),
(14740, NULL, 'IPR019323', NULL, 'Active zone protein ELKS', 'ELKS/CAST', 4, NULL),
(14741, NULL, 'IPR011388', NULL, 'Sphingolipid delta4-desaturase', 'DES1/DES2', 4, NULL),
(14742, NULL, 'IPR019319', NULL, 'Plasminogen receptor (KT)', 'Plg-R(KT)', 4, NULL),
(14743, NULL, 'IPR020560', NULL, 'Phosphoribosylglycinamide synthetase, C-domain', 'PRibGlycinamide_synth_C-dom', 3, NULL),
(14744, NULL, 'IPR017539', NULL, 'Exosortase 1 system-associated amidotransferase 1', 'Exosortase-1_amidotfase', 4, NULL),
(14745, NULL, 'IPR020967', NULL, 'Borrelia attachment ligand, p66', 'Borrelia_attachment_p66', 4, NULL),
(14746, NULL, 'IPR022956', NULL, 'Beta-hexosaminidase, bacterial', 'Beta_hexosaminidase_bac', 4, NULL),
(14747, NULL, 'IPR019322', NULL, 'Mitochondrial import inner membrane translocase subunit Tim29', 'TIMM29', 4, NULL),
(14748, NULL, 'IPR020978', NULL, 'Cryptochrome C-terminal', 'Cryptochrome_C', 3, NULL),
(14749, NULL, 'IPR018969', NULL, 'Xylulose 5-phosphate/Fructose 6-phosphate phosphoketolase, C-terminal', 'Xul5P/Fru6P_PKetolase_C', 3, NULL),
(14750, NULL, 'IPR020944', NULL, 'Nodulation protein S, NodS', 'NodS', 4, NULL),
(14751, NULL, 'IPR022958', NULL, 'Uncharacterised protein family UPF0294', 'UPF0294', 4, NULL),
(14752, NULL, 'IPR022726', NULL, 'CXC chemokine receptor 4 N-terminal domain', 'Chemokine_CXCR4_N_dom', 3, NULL),
(14753, NULL, 'IPR022939', NULL, 'Nitrobindin, bacteria/plant', 'Nb(III)_bact/plant', 4, NULL),
(14754, NULL, 'IPR023813', NULL, 'Conserved hypothetical protein CHP03987', 'CHP03987', 4, NULL),
(14755, NULL, 'IPR023814', NULL, 'Conserved hypothetical protein CHP03982', 'CHP03982', 4, NULL),
(14756, NULL, 'IPR035388', NULL, 'Swarming motility protein SwrA', 'SwrA', 4, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(14757, NULL, 'IPR017519', NULL, 'Conserved hypothetical protein CHP03085', 'CHP03085', 4, NULL),
(14758, NULL, 'IPR020948', NULL, 'Phosphate-starvation-induced PsiE-like', 'P_starv_induced_PsiE-like', 4, NULL),
(14759, NULL, 'IPR018194', NULL, 'Nickel-dependent hydrogenase, large subunit, nickel binding site', 'Ni-dep_hyd_lsu_Ni_BS', 1, NULL),
(14760, NULL, 'IPR018200', NULL, 'Ubiquitin specific protease, conserved site', 'USP_CS', 2, NULL),
(14761, NULL, 'IPR022845', NULL, 'Ribosomal protein S27ae', 'Ribosomal_S27ae', 4, NULL),
(14762, NULL, 'IPR023688', NULL, 'Cell division protein ZapA, firmicutes', 'Cell_div_ZapA_firmicutes', 4, NULL),
(14763, NULL, 'IPR019310', NULL, 'rRNA-processing protein Efg1', 'Efg1', 4, NULL),
(14764, NULL, 'IPR018048', NULL, 'CXC chemokine, conserved site', 'Chemokine_CXC_CS', 2, NULL),
(14765, NULL, 'IPR009377', NULL, 'Ethanolamine ammonia-lyase reactivase EutA', 'EutA', 4, NULL),
(14766, NULL, 'IPR023684', NULL, 'Tyrosine-tRNA ligase, type 3', 'Tyr-tRNA-ligase_3', 4, NULL),
(14767, NULL, 'IPR022897', NULL, 'HTH-type transcription regulator MntR', 'HTH_tscrpt_reg_MntR', 4, NULL),
(14768, NULL, 'IPR034992', NULL, 'RNA-binding protein 10, RNA recognition motif 2', 'RBM10_RRM2', 3, NULL),
(14769, NULL, 'IPR023762', NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase, bacterial', 'PGP_synthase_bac', 4, NULL),
(14770, NULL, 'IPR017558', NULL, 'Malonate decarboxylase, carboxybiotin decarboxylase subunit, Na+ transporting', 'Malonate_biotin', 4, NULL),
(14771, NULL, 'IPR022931', NULL, 'Sulfur carrier protein TusA', 'Sulphur_carrier_TusA', 4, NULL),
(14772, NULL, 'IPR017538', NULL, 'Peptidase M42, glutamyl aminopeptidase', 'Pept_M42_glutamyl_aminopept', 4, NULL),
(14773, NULL, 'IPR017545', NULL, 'CRISPR-associated protein, Csf1 family', 'CRISPR-assoc_prot_Csf1', 4, NULL),
(14774, NULL, 'IPR022971', NULL, '5''-deoxynucleotidase YfbR', 'YfbR', 4, NULL),
(14775, NULL, 'IPR019325', NULL, 'NEDD4/Bsd2', 'NEDD4/Bsd2', 4, NULL),
(14776, NULL, 'IPR022701', NULL, 'Glycosyltransferase family 1, N-terminal', 'GlycosylTrfase_1_N', 3, NULL),
(14777, NULL, 'IPR020905', NULL, 'NAD(P)H-quinone oxidoreductase subunit O', 'NdhO', 4, NULL),
(14778, NULL, 'IPR018538', NULL, 'Helicase HerA, barrel domain', 'HerA_barrel_dom', 3, NULL),
(14779, NULL, 'IPR020989', NULL, 'Histone-arginine methyltransferase CARM1, N-terminal', 'Histone-Arg_MeTrfase_N', 3, NULL),
(14780, NULL, 'IPR022978', NULL, 'Monofunctional glycosyl transferase', 'Monofunct_glyco_trans', 4, NULL),
(14781, NULL, 'IPR017543', NULL, '6-pyruvoyl tetrahydropterin synthase, predicted, bacteria', '6-PTP_synth_prd_bac', 4, NULL),
(14782, NULL, 'IPR019887', NULL, 'Transcription regulator AsnC/Lrp, ligand binding domain', 'Tscrpt_reg_AsnC/Lrp_C', 3, NULL),
(14783, NULL, 'IPR022690', NULL, 'Geminivirus AL1 replication-associated protein, catalytic domain', 'Gemini_AL1_REP_cat-dom', 3, NULL),
(14784, NULL, 'IPR024919', NULL, 'ECF transporter transmembrane protein EcfT', 'EcfT', 4, NULL),
(14785, NULL, 'IPR020975', NULL, 'UvsW.1 domain', 'UvsW.1_dom', 3, NULL),
(14786, NULL, 'IPR018531', NULL, 'Protein of unknown function DUF1993', 'DUF1993', 4, NULL),
(14787, NULL, 'IPR019312', NULL, 'CCR4-NOT transcription complex subunit 11', 'CNOT11', 4, NULL),
(14788, NULL, 'IPR019898', NULL, '3-aminoacrylate deaminase RutC', 'RutC', 4, NULL),
(14789, NULL, 'IPR022604', NULL, 'Protein of unknown function DUF2955', 'DUF2955', 4, NULL),
(14790, NULL, 'IPR018490', NULL, 'Cyclic nucleotide-binding domain superfamily', 'cNMP-bd_dom_sf', 5, NULL),
(14791, NULL, 'IPR019894', NULL, 'Patatin-related protein', 'Patatin-related_protein', 3, NULL),
(14792, NULL, 'IPR020841', NULL, 'Polyketide synthase, beta-ketoacyl synthase domain', 'PKS_Beta-ketoAc_synthase_dom', 3, NULL),
(14793, NULL, 'IPR018189', NULL, 'Phosphoglucose isomerase, conserved site', 'Phosphoglucose_isomerase_CS', 2, NULL),
(14794, NULL, 'IPR020984', NULL, 'Cell cycle regulatory protein Speedy', 'Speedy', 4, NULL),
(14795, NULL, 'IPR023701', NULL, '4-hydroxy-2-oxo-heptane-1,7-dioate aldolase, Enterobacteriales', 'HKHD_aldolase_ent', 4, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(14796, NULL, 'IPR019895', NULL, 'Putative bacteriocin export ABC transporter,  lactococcin 972 group', 'L_ocin_972_ABC', 4, NULL),
(14797, NULL, 'IPR023295', NULL, 'Hyaluronate lyase, beta-sheet domain superfamily', 'Hyaluronate_lyase_beta_dom_sf', 5, NULL),
(14798, NULL, 'IPR022533', NULL, 'Cox20', 'Cox20', 4, NULL),
(14799, NULL, 'IPR017200', NULL, 'Coenzyme PQQ synthesis protein E-like', 'PqqE-like', 4, NULL),
(14800, NULL, 'IPR017550', NULL, 'Formylmethanofuran dehydrogenase subunit C', 'Formylmethanofuran_DH_suC', 3, NULL),
(14801, NULL, 'IPR018920', NULL, 'ESAT-6 secretion machinery protein EssA/YueC', 'EssA/YueC', 4, NULL),
(14802, NULL, 'IPR022801', NULL, 'Ribosomal protein S4/S9', 'Ribosomal_S4/S9', 4, NULL),
(14803, NULL, 'IPR022947', NULL, 'Ribosomal protein L18e, archaea', 'Ribosomal_L18e_arc', 4, NULL),
(14804, NULL, 'IPR017540', NULL, 'Exosortase 1', 'Exosortase-1', 4, NULL),
(14805, NULL, 'IPR024000', NULL, 'Conserved hypothetical protein CHP04046, FMN-dependent', 'CHP04046_FMN-dependent', 4, NULL),
(14806, NULL, 'IPR018979', NULL, 'FERM, N-terminal', 'FERM_N', 3, NULL),
(14807, NULL, 'IPR023744', NULL, '3-phenylpropionate/cinnamic acid dioxygenase, ferredoxin--NAD(+) reductase subunit', 'HcaD', 4, NULL),
(14808, NULL, 'IPR019891', NULL, 'Bacteriocin, streptolysin S, precursor', 'Bacteriocin_streptolysin_S_pre', 4, NULL),
(14809, NULL, 'IPR018535', NULL, 'Domain of unknown function DUF1996', 'DUF1996', 3, NULL),
(14810, NULL, 'IPR020942', NULL, 'Class III cytochrome C', 'Cyt_c_III_dom', 3, NULL),
(14811, NULL, 'IPR020931', NULL, 'Decarboxylase MfnA, archaea', 'MfnA', 4, NULL),
(14812, NULL, 'IPR022895', NULL, 'Flap endonuclease Xni', 'Xni', 4, NULL),
(14813, NULL, 'IPR018188', NULL, 'Ribonuclease T2, His active site 1', 'RNase_T2_His_AS_1', 0, NULL),
(14814, NULL, 'IPR023811', NULL, 'Conserved hypothetical protein CHP04076', 'CHP04076', 4, NULL),
(14815, NULL, 'IPR024826', NULL, 'DNA polymerase delta/II small subunit family', 'DNA_pol_delta/II_ssu', 4, NULL),
(14816, NULL, 'IPR018929', NULL, 'Domain of unknown function DUF2510', 'DUF2510', 3, NULL),
(14817, NULL, 'IPR020752', NULL, 'Glutamate-tRNA synthetase, class I, anticodon-binding domain, subdomain 1', 'Glu-tRNA-synth_I_codon-bd_sub1', 5, NULL),
(14818, NULL, 'IPR011390', NULL, 'Insulin-like growth factor binding protein-related protein (IGFBP-rP), MAC25', 'IGFBP_rP_mac25', 4, NULL),
(14819, NULL, 'IPR035463', NULL, 'Peroxin 13', 'Pex13', 4, NULL),
(14820, NULL, 'IPR018970', NULL, 'Xylulose 5-phosphate/Fructose 6-phosphate phosphoketolase, N-terminal', 'Xul5P/Fru6P_PKetolase_N', 3, NULL),
(14821, NULL, 'IPR022815', NULL, 'Protease inhibitor', 'Inh', 4, NULL),
(14822, NULL, 'IPR020998', NULL, 'Mediator of RNA polymerase II transcription subunit 3', 'Med3', 4, NULL),
(14823, NULL, 'IPR035400', NULL, 'Urocanase, N-terminal domain', 'Urocanase_N', 3, NULL),
(14824, NULL, 'IPR024920', NULL, 'Dihydroorotate dehydrogenase, class 1', 'Dihydroorotate_DH_1', 4, NULL),
(14825, NULL, 'IPR020923', NULL, 'DNA ligase B', 'DNA_ligase_B', 4, NULL),
(14826, NULL, 'IPR022607', NULL, 'Baseplate wedge protein gp53, bacteriophage T4', 'Phage_T4_Gp53_baseplate_wedge', 4, NULL),
(14827, NULL, 'IPR022954', NULL, 'Uncharacterised protein family UPF0148', 'UPF0148', 4, NULL),
(14828, NULL, 'IPR035394', NULL, 'Glycosyl hydrolase family 59, central domain', 'Glyco_hydro_59_dom', 3, NULL),
(14829, NULL, 'IPR022973', NULL, 'Ribosomal protein L10', 'Ribosomal_L10', 4, NULL),
(14830, NULL, 'IPR023628', NULL, 'Recombination protein RecR, C4-type zinc finger', 'Rcmb_RecR_C4-type_Zn', 3, NULL),
(14831, NULL, 'IPR018922', NULL, 'NAD(P)H-quinone oxidoreductase subunit M', 'NdhM', 4, NULL),
(14832, NULL, 'IPR022453', NULL, 'Zinc finger, MqsA-type', 'Znf_MqsA-type', 3, NULL),
(14833, NULL, 'IPR022698', NULL, 'Orsellinic acid/F9775 biosynthesis cluster protein D', 'OrsD', 4, NULL),
(14834, NULL, 'IPR020558', NULL, 'Dihydroxy-acid/6-phosphogluconate dehydratase, conserved site', 'DiOHA_6PGluconate_deHydtase_CS', 2, NULL),
(14835, NULL, 'IPR022700', NULL, 'Proteinase, regulatory CLIP domain', 'CLIP', 3, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(14836, NULL, 'IPR019896', NULL, 'Polysaccharide pyruvyl transferase, CsaB', 'Polysacch_pyruvyl_Trfase_CsaB', 4, NULL),
(14837, NULL, 'IPR020918', NULL, 'Peptide chain release factor aRF1', 'Peptide_chain-rel_aRF1', 4, NULL),
(14838, NULL, 'IPR022699', NULL, 'Stonin-2, N-terminal', 'Stonin2_N', 3, NULL),
(14839, NULL, 'IPR018513', NULL, 'Cellulose synthase BcsB, bacterial', 'Cell_synthase_bac', 4, NULL),
(14840, NULL, 'IPR017531', NULL, 'Hydrolase, ortholog 1, exosortase system type 1 associated', 'Hydrolase-1_PEP', 4, NULL),
(14841, NULL, 'IPR020813', NULL, 'Fibrillarin, conserved site', 'Fibrillarin_CS', 2, NULL),
(14842, NULL, 'IPR011348', NULL, '17beta-dehydrogenase', '17beta_DH', 4, NULL),
(14843, NULL, 'IPR018964', NULL, 'Bacteriophage phiJL001, Gp84, C-terminal', 'Phage_phiJL001_Gp84_C', 3, NULL),
(14844, NULL, 'IPR022941', NULL, 'Signal recognition particle, SRP54 subunit', 'SRP54', 4, NULL),
(14845, NULL, 'IPR020789', NULL, 'RNA polymerases, subunit N, zinc binding site', 'RNA_pol_suN_Zn-BS', 1, NULL),
(14846, NULL, 'IPR019851', NULL, 'CRISPR-associated protein Cas1, ECOLI subtype', 'CRISPR-assoc_Cas1_ECOLI', 4, NULL),
(14847, NULL, 'IPR019857', NULL, 'CRISPR-associated protein Cas1, YPEST subtype', 'CRISPR-assoc_Cas1_YPEST-subtyp', 4, NULL),
(14848, NULL, 'IPR020991', NULL, 'Head-to-tail connector protein, podovirus-type', 'Connector_podovirus', 4, NULL),
(14849, NULL, 'IPR023815', NULL, 'CRISPR-associated protein A791736', 'CRISPR-assoc_A791736', 4, NULL),
(14850, NULL, 'IPR020539', NULL, 'Ribonuclease P, conserved site', 'RNase_P_CS', 2, NULL),
(14851, NULL, 'IPR021002', NULL, 'Replication protein 1a, necrotic phentoype-determining domain', '1a_necrotic_phenotyp-det_dom', 3, NULL),
(14852, NULL, 'IPR020351', NULL, 'Phage tail assemb.y chaperone protein, TAC', 'Phage_TAC_9', 4, NULL),
(14853, NULL, 'IPR022885', NULL, 'NAD(P)H-quinone oxidoreductase subunit D/H', 'NDH1_su_D/H', 4, NULL),
(14854, NULL, 'IPR019333', NULL, 'Integrator complex subunit 3, N-terminal', 'INTS3_N', 3, NULL),
(14855, NULL, 'IPR011363', NULL, 'Dorsal-related immunity factor Dif', 'Dif', 4, NULL),
(14856, NULL, 'IPR018543', NULL, 'Adhesion protein FadA', 'Adhesion_FadA', 4, NULL),
(14857, NULL, 'IPR021004', NULL, 'Dispersed gene family protein 1, domain 4', 'Dispersed_gene_fam_prot1_dom4', 3, NULL),
(14858, NULL, 'IPR023753', NULL, 'FAD/NAD(P)-binding domain', 'FAD/NAD-binding_dom', 3, NULL),
(14859, NULL, 'IPR022926', NULL, 'NH(3)-dependent NAD(+) synthetase', 'NH(3)-dep_NAD(+)_synth', 4, NULL),
(14860, NULL, 'IPR020971', NULL, 'ATP synthase, F1 beta subunit', 'ATP_synth_F1_beta_su', 3, NULL),
(14861, NULL, 'IPR022802', NULL, 'Ribosomal protein S4, archaeal', 'Ribosomal_S4_arc', 4, NULL),
(14862, NULL, 'IPR024913', NULL, 'tRNA(Ile2) 2-agmatinylcytidine synthetase TiaS', 'tRNA_Ile2__agm2C_synt', 4, NULL),
(14863, NULL, 'IPR020604', NULL, 'CTF transcription factor/nuclear factor 1, DNA-binding domain', 'CTF/NFI_DNA-bd-dom', 3, NULL),
(14864, NULL, 'IPR023627', NULL, 'Recombination protein RecR', 'Rcmb_RecR', 5, NULL),
(14865, NULL, 'IPR022928', NULL, 'RNA 2''-phosphotransferase KptA, putative', 'RNA_2''-PTrans_KptA', 4, NULL),
(14866, NULL, 'IPR020239', NULL, 'Protein of unknown function DUF5511', 'DUF5511', 4, NULL),
(14867, NULL, 'IPR020809', NULL, 'Enolase, conserved site', 'Enolase_CS', 2, NULL),
(14868, NULL, 'IPR018943', NULL, 'Oligosaccaryltransferase', 'Oligosaccaryltransferase', 4, NULL),
(14869, NULL, 'IPR034993', NULL, 'RNA-binding protein 5, RNA recognition motif 2', 'RBM5_RRM2', 3, NULL),
(14870, NULL, 'IPR019321', NULL, 'Nucleoporin Nup88', 'Nucleoporin_Nup88', 4, NULL),
(14871, NULL, 'IPR018977', NULL, 'NurA domain', 'NurA_domain', 3, NULL),
(14872, NULL, 'IPR020906', NULL, 'Double-stranded DNA-binding Cren7', 'dsDNA-bd_Cren7', 4, NULL),
(14873, NULL, 'IPR034028', NULL, 'Fungal reprolysin domain', 'ZnMc_ADAM_fungal', 3, NULL),
(14874, NULL, 'IPR020974', NULL, 'CGT/MARTX, cysteine protease (CPD) domain', 'CPD_dom', 3, NULL),
(14875, NULL, 'IPR022558', NULL, 'Protein of unknown function DUF2654', 'DUF2654', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(14876, NULL, 'IPR035391', NULL, 'Arylsulfotransferase, N-terminal domain', 'Arylsulfotran_N', 3, NULL),
(14877, NULL, 'IPR019919', NULL, 'Luciferase-like, F420-dependent oxidoreductase, MSMEG2256, predicted', 'Lucif-like_OxRdtase_MSMEG_2256', 4, NULL),
(14878, NULL, 'IPR017520', NULL, 'Conserved hypothetical protein CHP03086', 'CHP03086', 4, NULL),
(14879, NULL, 'IPR020962', NULL, 'Bacteriophage phiX174, GpK', 'Phage_phiX174_GpK', 4, NULL),
(14880, NULL, 'IPR020939', NULL, 'Ribosomal protein L34, conserved site', 'Ribosomal_L34_CS', 2, NULL),
(14881, NULL, 'IPR022553', NULL, 'Protein of unknown function DUF2645', 'DUF2645', 4, NULL),
(14882, NULL, 'IPR018195', NULL, 'Transferrin family, iron binding site', 'Transferrin_Fe_BS', 1, NULL),
(14883, NULL, 'IPR018187', NULL, 'Asp/Glu racemase, active site 1', 'Asp/Glu_racemase_AS_1', 0, NULL),
(14884, NULL, 'IPR011360', NULL, 'Complement B/C2', 'Compl_C2_B', 4, NULL),
(14885, NULL, 'IPR020840', NULL, 'Extracellular matrix-binding protein ebh, GA module', 'Extracell_matrix-bd_GA', 3, NULL),
(14886, NULL, 'IPR023775', NULL, 'Bifunctional protein Aas', 'Aas', 4, NULL),
(14887, NULL, 'IPR024824', NULL, 'Growth arrest and DNA damage-inducible protein GADD45', 'GADD45', 4, NULL),
(14888, NULL, 'IPR023704', NULL, 'Glucan biosynthesis protein G', 'MdoG_OpgG', 4, NULL),
(14889, NULL, 'IPR019301', NULL, 'Flagellar protein FlgJ, N-terminal', 'Flagellar_prot_FlgJ_N', 3, NULL),
(14890, NULL, 'IPR022556', NULL, 'Autographa californica nuclear polyhedrosis virus (AcMNPV), Orf5', 'AcMNPV_Orf5', 4, NULL),
(14891, NULL, 'IPR020956', NULL, 'Transcription factor Aft1, osmotic stress domain', 'TF_Aft1_OSM', 3, NULL),
(14892, NULL, 'IPR017527', NULL, 'Nitrosocyanin', 'Nitrosocyanin', 4, NULL),
(14893, NULL, 'IPR022948', NULL, 'Chitooligosaccharide deacetylase ChbG-like, bacteria', 'COD_ChbG_bac', 4, NULL),
(14894, NULL, 'IPR019913', NULL, 'Pyrimidine utilisation protein RutD', 'Pyrimidine_utilisation_RutD', 4, NULL),
(14895, NULL, 'IPR018514', NULL, 'Rabaptin coiled-coil domain', 'Rabaptin_coiled-coil', 3, NULL),
(14896, NULL, 'IPR018530', NULL, 'SiaC family regulatory phosphoprotein', 'SiaC', 3, NULL),
(14897, NULL, 'IPR017552', NULL, '3-hexulose-6-phosphate isomerase', 'PHI/rmpB', 4, NULL),
(14898, NULL, 'IPR018186', NULL, 'Transcription factor, T-box, conserved site', 'TF_T-box_CS', 2, NULL),
(14899, NULL, 'IPR022955', NULL, 'GMP synthase', 'GMP_synthase', 4, NULL),
(14900, NULL, 'IPR019889', NULL, 'DNA helicase, DnaB-like, phage', 'DNA_helicase_DnaB-like_phg', 4, NULL),
(14901, NULL, 'IPR017544', NULL, 'Exosortase 2', 'Exosortase-2', 4, NULL),
(14902, NULL, 'IPR019331', NULL, 'FAM192A/Fyv6, N-terminal', 'FAM192A/Fyv6_N', 3, NULL),
(14903, NULL, 'IPR018958', NULL, 'Knr4/Smi1-like domain', 'Knr4/Smi1-like_dom', 3, NULL),
(14904, NULL, 'IPR023299', NULL, 'P-type ATPase, cytoplasmic domain N', 'ATPase_P-typ_cyto_dom_N', 5, NULL),
(14905, NULL, 'IPR020926', NULL, 'Ribosomal protein L15e, archaeal', 'Ribosomal_L15e_arc', 4, NULL),
(14906, NULL, 'IPR017547', NULL, 'CRISPR type IV/AFERR-associated protein Csf3', 'CRISPR-assoc_prot_Csf3', 4, NULL),
(14907, NULL, 'IPR023961', NULL, 'Nitric oxide reductase FlRd-NAD(+) reductase', 'NO_rdtase_NorW', 4, NULL),
(14908, NULL, 'IPR019302', NULL, 'CD-NTase-associated protein 12/Pycsar effector protein, TIR domain', 'CAP12/PCTIR_TIR_dom', 3, NULL),
(14909, NULL, 'IPR022957', NULL, 'Uncharacterised protein family UPF0299', 'Uncharacterised_UPF0299', 4, NULL),
(14910, NULL, 'IPR020907', NULL, 'PhoP/PhoQ regulator MgrB', 'MgrB', 4, NULL),
(14911, NULL, 'IPR019922', NULL, 'Luciferase-like, F420-dependent oxidoreductase, MSMEG4141, predicted', 'Lucif-like_OxRdatse_MSMEG_4141', 4, NULL),
(14912, NULL, 'IPR017524', NULL, 'Small acid-soluble spore protein, thioredoxin-like', 'SASP_thioredoxin-like', 4, NULL),
(14913, NULL, 'IPR018930', NULL, 'Late embryogenesis abundant protein, LEA-18', 'LEA-18', 4, NULL),
(14914, NULL, 'IPR023707', NULL, 'Outer membrane protein assembly factor BamA', 'OM_assembly_BamA', 4, NULL),
(14915, NULL, 'IPR022938', NULL, 'Signal recognition particle, SRP19 subunit, archaeal-type', 'SRP19_arc-type', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(14916, NULL, 'IPR017534', NULL, 'GNAT-acetyltransferase', 'GNAT-acetyltransferase', 4, NULL),
(14917, NULL, 'IPR020957', NULL, 'Tachystatin B', 'Tachystatin_B', 4, NULL),
(14918, NULL, 'IPR019326', NULL, 'Protein NDNF', 'NDNF', 4, NULL),
(14919, NULL, 'IPR017516', NULL, 'AbrB duplication', 'AbrB_dup', 3, NULL),
(14920, NULL, 'IPR017537', NULL, 'Peptidase M42, hydrolase', 'Peptidase_M42_hydrolase', 4, NULL),
(14921, NULL, 'IPR023117', NULL, 'PA1123-like domain', 'PA1123-like_domain', 3, NULL),
(14922, NULL, 'IPR018944', NULL, 'DNA polymerase lambda, fingers domain', 'DNA_pol_lambd_fingers_domain', 3, NULL),
(14923, NULL, 'IPR017533', NULL, 'Halocyanin,  copper-binding domain', 'Halocyanin', 3, NULL),
(14924, NULL, 'IPR022950', NULL, 'Homogentisate 1,2-dioxygenase, bacterial', 'Homogentis_dOase_bac', 4, NULL),
(14925, NULL, 'IPR018967', NULL, 'Iron-binding zinc finger, CDGSH type', 'FeS-contain_CDGSH-typ', 3, NULL),
(14926, NULL, 'IPR017521', NULL, 'Sugar transferase, PEP-CTERM, Stp1', 'Sugar_tfrase_PEP-CTERM_Stp1', 4, NULL),
(14927, NULL, 'IPR018544', NULL, 'KICSTOR subunit 2', 'KICS_2', 4, NULL),
(14928, NULL, 'IPR035360', NULL, 'Protein of unknown function DUF5420', 'DUF5420', 4, NULL),
(14929, NULL, 'IPR020990', NULL, 'Carboxysome assembly protein', 'CSOS2', 4, NULL),
(14930, NULL, 'IPR018051', NULL, 'Surfactant-associated polypeptide, palmitoylation site', 'SP-C_palmitoylation_site', 6, NULL),
(14931, NULL, 'IPR020920', NULL, 'L-lactate dehydrogenase, bacterial', 'LldD', 4, NULL),
(14932, NULL, 'IPR022722', NULL, 'Non-structural protein ORF8, betacoronavirus', 'ORF8_betacoronavirus', 4, NULL),
(14933, NULL, 'IPR035389', NULL, 'Protein of unknown function DUF5411', 'DUF5411', 4, NULL),
(14934, NULL, 'IPR018966', NULL, 'VTC domain', 'VTC_domain', 3, NULL),
(14935, NULL, 'IPR020607', NULL, 'DNA primase DnaG, archaea', 'Primase_DnaG_arc', 4, NULL),
(14936, NULL, 'IPR024934', NULL, 'Rubredoxin-like domain', 'Rubredoxin-like_dom', 3, NULL),
(14937, NULL, 'IPR011480', NULL, 'Protein of unknown function DUF1589', 'DUF1589', 4, NULL),
(14938, NULL, 'IPR022781', NULL, 'Flagellar biosynthesis protein, FliO', 'Flagellar_biosynth_FliO', 4, NULL),
(14939, NULL, 'IPR034991', NULL, 'RNA-binding protein 5, RNA recognition motif 1', 'RBM5_RRM1', 3, NULL),
(14940, NULL, 'IPR022953', NULL, 'ATP-dependent 6-phosphofructokinase', 'ATP_PFK', 4, NULL),
(14941, NULL, 'IPR020940', NULL, 'Thymidylate synthase, active site', 'Thymidylate_synthase_AS', 0, NULL),
(14942, NULL, 'IPR022936', NULL, 'Uncharacterised protein family UPF0194, membrane protein YbhG', 'UPF0194_membrane_YbhG', 4, NULL),
(14943, NULL, 'IPR018925', NULL, 'Phage terminase small subunit', 'Phage_terminase_ssu', 4, NULL),
(14944, NULL, 'IPR022970', NULL, 'Nucleoside triphosphate hydrolase-related', 'NTP_hydrolase-rel', 4, NULL),
(14945, NULL, 'IPR022963', NULL, 'Galactokinase, bacterial', 'Galactokinase_bac', 4, NULL),
(14946, NULL, 'IPR019914', NULL, 'Pyrimidine monooxygenase RutA', 'Pyrimidine_monooxygenase_RutA', 4, NULL),
(14947, NULL, 'IPR020913', NULL, 'Uncharacterised protein family UPF0323', 'UPF0323', 4, NULL),
(14948, NULL, 'IPR022937', NULL, 'Mevalonate kinase, archaeal', 'Mevalonate_kinase_arc', 4, NULL),
(14949, NULL, 'IPR019885', NULL, 'Transcription regulator HTH, AsnC-type, conserved site', 'Tscrpt_reg_HTH_AsnC-type_CS', 2, NULL),
(14950, NULL, 'IPR019311', NULL, 'Protein of unknown function DUF2362', 'DUF2362', 4, NULL),
(14951, NULL, 'IPR011391', NULL, 'Acetoin catabolism kinase AcoX', 'AcoX_kinase', 4, NULL),
(14952, NULL, 'IPR019316', NULL, 'G8 domain', 'G8_domain', 3, NULL),
(14953, NULL, 'IPR018937', NULL, 'Membrane magnesium transporter', 'MMgT', 4, NULL),
(14954, NULL, 'IPR018975', NULL, 'Pseudomurein-binding repeat', 'Pseudomurein-binding_repeat', 7, NULL),
(14955, NULL, 'IPR018923', NULL, 'Phage tail assembly chaperone protein Gp14', 'Phage_TAC_8', 4, NULL),
(14956, NULL, 'IPR023686', NULL, 'GMP synthase (glutamine-hydrolyzing) subunit A', 'GMP_synthase_A', 4, NULL),
(14957, NULL, 'IPR024905', NULL, 'Sec-independent protein translocase protein TatE', 'TatE', 4, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(14958, NULL, 'IPR022803', NULL, 'Ribosomal protein L5 domain superfamily', 'Ribosomal_L5_dom_sf', 5, NULL),
(14959, NULL, 'IPR022967', NULL, 'RNA-binding domain, S1', 'S1_dom', 3, NULL),
(14960, NULL, 'IPR018926', NULL, 'Gp23', 'Gp23', 4, NULL),
(14961, NULL, 'IPR022728', NULL, 'Period circadian-like, C-terminal', 'Period_circadian-like_C', 3, NULL),
(14962, NULL, 'IPR022847', NULL, 'Translation elongation factor IF5A, archaeal', 'Transl_elong_IF5A_arc', 4, NULL),
(14963, NULL, 'IPR011375', NULL, 'MfnE family', 'MfnE', 4, NULL),
(14964, NULL, 'IPR035106', NULL, 'Spastin, chordate', 'Spastin_chordate', 4, NULL),
(14965, NULL, 'IPR018974', NULL, 'Tex-like protein, N-terminal', 'Tex-like_N', 3, NULL),
(14966, NULL, 'IPR035900', NULL, 'Colicin E immunity protein superfamily', 'Colicin_E_sf', 5, NULL),
(14967, NULL, 'IPR035946', NULL, 'YML108W-like superfamily', 'YML108W-like_sf', 5, NULL),
(14968, NULL, 'IPR034152', NULL, 'SLIRP, RNA recognition motif', 'SLIRP_RRM', 3, NULL),
(14969, NULL, 'IPR019327', NULL, 'WKF domain', 'WKF', 3, NULL),
(14970, NULL, 'IPR011381', NULL, 'Histone H3-K9 methyltransferase', 'Histone_H3-K9_MeTrfase', 4, NULL),
(14971, NULL, 'IPR035993', NULL, 'Notch-like domain superfamily', 'Notch-like_dom_sf', 5, NULL),
(14972, NULL, 'IPR020949', NULL, 'Prion, copper binding octapeptide repeat', 'Prion_copper_b_octapeptide', 7, NULL),
(14973, NULL, 'IPR034996', NULL, 'HuR, RNA recognition motif 2', 'HuR_RRM2', 3, NULL),
(14974, NULL, 'IPR017202', NULL, 'Sensor histidine kinase LiaS/VraS', 'LiaS/VraS', 4, NULL),
(14975, NULL, 'IPR022398', NULL, 'Peptidase S8, subtilisin, His-active site', 'Peptidase_S8_His-AS', 0, NULL),
(14976, NULL, 'IPR018910', NULL, 'Lipoprotein LpqB, beta-propeller domain, C-terminal', 'Lipoprotein_LpqB_C', 3, NULL),
(14977, NULL, 'IPR018980', NULL, 'FERM, C-terminal PH-like domain', 'FERM_PH-like_C', 3, NULL),
(14978, NULL, 'IPR020935', NULL, 'Phosphodiesterase YfcE, conserved site', 'PdiEstase_YfcE_CS', 2, NULL),
(14979, NULL, 'IPR019307', NULL, 'RNA-binding protein AU-1/Ribonuclease E/G', 'RNA-bd_AU-1/RNase_E/G', 4, NULL),
(14980, NULL, 'IPR019303', NULL, 'vWA found in TerF C terminus', 'vWA_TerF_C', 3, NULL),
(14981, NULL, 'IPR019892', NULL, 'Thiazole/oxazole-forming peptide maturase, SagC family component', 'Cyclo_dehy_ocin', 4, NULL),
(14982, NULL, 'IPR022688', NULL, 'Replication-associated protein G2P, C-terminal', 'G2P_C', 3, NULL),
(14983, NULL, 'IPR017553', NULL, '3-hexulose-6-phosphate synthase', '3-hexulose-6-phosphate_synth', 3, NULL),
(14984, NULL, 'IPR017530', NULL, 'Pyridoxal-dependent decarboxylase, exosortase system type 1 associated', 'DCO2ase_PEP1', 4, NULL),
(14985, NULL, 'IPR019300', NULL, 'CO dehydrogenase accessory protein CooT', 'CooT', 4, NULL),
(14986, NULL, 'IPR019856', NULL, 'CRISPR-associated protein Cas1, DVULG subtype', 'CRISPR-assoc_Cas1_DVULG', 4, NULL),
(14987, NULL, 'IPR023763', NULL, 'DNA integrity scanning protein, DisA', 'DNA_integrity_scanning_protein', 4, NULL),
(14988, NULL, 'IPR011386', NULL, 'Putative ATP-NAD kinase', 'Put_ATP-NAD_kin', 4, NULL),
(14989, NULL, 'IPR018049', NULL, 'Interleukin-7/Interleukin-9, conserved site', 'IL-7/IL-9_CS', 2, NULL),
(14990, NULL, 'IPR035396', NULL, 'Alpha-L-rhamnosidase, six-hairpin glycosidase domain', 'Bac_rhamnosid6H', 3, NULL),
(14991, NULL, 'IPR018917', NULL, 'Protein of unknown function DUF2482', 'DUF2482', 4, NULL),
(14992, NULL, 'IPR017556', NULL, 'Biotin-independent malonate decarboxylase, beta subunit', 'Malonate_beta', 4, NULL),
(14993, NULL, 'IPR018965', NULL, 'Ubiquitin-activating enzyme E1, C-terminal', 'Ub-activating_enz_E1_C', 3, NULL),
(14994, NULL, 'IPR020911', NULL, 'Uncharacterised protein family UPF0325', 'UPF0325', 4, NULL),
(14995, NULL, 'IPR022451', NULL, 'Conserved hypothetical protein CHP03829, YokU', 'CHP03829_YokU', 4, NULL),
(14996, NULL, 'IPR022962', NULL, 'Soluble pyridine nucleotide transhydrogenase', 'STH', 4, NULL),
(14997, NULL, 'IPR022935', NULL, 'ATP-dependent Clp protease adaptor protein ClpS', 'ClpS', 4, NULL),
(14998, NULL, 'IPR022694', NULL, '3-hydroxyacyl-CoA dehydrogenase', '3-OHacyl-CoA_DH', 4, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(14999, NULL, 'IPR020964', NULL, 'Acyl-CoA dehydrogenase, C-terminal', 'Acyl-CoA_dehydrogenase_C', 3, NULL),
(15000, NULL, 'IPR022831', NULL, 'Multidrug resistance protein MdtB', 'Multidrug-R_MdtB', 4, NULL),
(15001, NULL, 'IPR022891', NULL, 'Triosephosphate isomerase, archaeal', 'Triosephosphate_isomerase_arc', 4, NULL),
(15002, NULL, 'IPR016823', NULL, 'Sulfur oxidation c-type cytochrome SoxX, type II', 'Thiosulf_SoxX_II', 4, NULL),
(15003, NULL, 'IPR023023', NULL, 'dNTP triphosphohydrolase, type 2', 'dNTPase_2', 4, NULL),
(15004, NULL, 'IPR022275', NULL, 'NHPM bacteriocin system secretion protein, HylD', 'NHPM_bacteriocin_SS_HylD', 4, NULL),
(15005, NULL, 'IPR017211', NULL, 'Uncharacterised conserved protein UCP037465, zinc finger protein, AF1427', 'UCP037465_Znf', 4, NULL),
(15006, NULL, 'IPR017243', NULL, 'Biogenesis of lysosome-related organelles complex 1 subunit 5', 'Bloc1s5', 4, NULL),
(15007, NULL, 'IPR021170', NULL, 'DnaJ homologue subfamily C member 10', 'ERdj5', 4, NULL),
(15008, NULL, 'IPR023036', NULL, 'Ribosomal protein S14, bacterial/plastid', 'Ribosomal_S14_bac/plastid', 4, NULL),
(15009, NULL, 'IPR021036', NULL, 'Ribosomal protein S35, mitochondrial', 'Ribosomal_S35_mit', 4, NULL),
(15010, NULL, 'IPR022984', NULL, 'M18 family aminopeptidase 2, putative', 'M18_aminopeptidase_2', 4, NULL),
(15011, NULL, 'IPR021015', NULL, 'Duffy-antigen binding, C-terminal', 'Duffy-antigen-binding_C', 3, NULL),
(15012, NULL, 'IPR018547', NULL, 'AbiEi antitoxin C-terminal domain', 'AbiEi_C', 3, NULL),
(15013, NULL, 'IPR035224', NULL, 'TcfC, Usher-like barrel domain', 'Usher_TcfC', 3, NULL),
(15014, NULL, 'IPR017218', NULL, 'BLOC-2 complex, Hps6 subunit', 'BLOC-2_complex_Hps6_subunit', 4, NULL),
(15015, NULL, 'IPR017229', NULL, 'Multidomain scavenger receptor-like protein PxSR', 'Scavenger_rcpt_PxSR', 4, NULL),
(15016, NULL, 'IPR023045', NULL, 'Molybdenum cofactor biosynthesis C', 'Mo_CF_biosynth-C', 4, NULL),
(15017, NULL, 'IPR016819', NULL, 'Ribonuclease P/MRP protein subunit Pop5', 'RNase_P/MRP_POP5', 4, NULL),
(15018, NULL, 'IPR017567', NULL, 'Cytochrome c nitrite reductase, Fe-S protein', 'Cyt_c_NO2Rdtase_NrfC', 4, NULL),
(15019, NULL, 'IPR023076', NULL, 'Hydroxymethylglutaryl-CoA reductase, class I/II, conserved site', 'HMG_CoA_Rdtase_CS', 2, NULL),
(15020, NULL, 'IPR016799', NULL, 'Uncharacterised conserved protein UCP022062', 'UCP022062', 4, NULL),
(15021, NULL, 'IPR021134', NULL, 'Bestrophin/UPF0187', 'Bestrophin/UPF0187', 4, NULL),
(15022, NULL, 'IPR023003', NULL, 'Glycerol-1-phosphate dehydrogenase, bacteria', 'G1P_dehydrogenase_bac', 4, NULL),
(15023, NULL, 'IPR023069', NULL, 'Chaperone TorD', 'Chaperone_TorD', 4, NULL),
(15024, NULL, 'IPR021194', NULL, 'Uncharacterised protein family, dehydrogenase DR0790 type, predicted', 'Uncharacterised_DHase_DR0790', 4, NULL),
(15025, NULL, 'IPR021010', NULL, 'Cytosolic motility protein', 'Cytosolic_motility_protein', 4, NULL),
(15026, NULL, 'IPR035470', NULL, 'Amphiphysin I, SH3 domain', 'Amphiphysin_I_SH3', 3, NULL),
(15027, NULL, 'IPR022996', NULL, 'Uncharacterised protein family UPF0310', 'UPF0310', 4, NULL),
(15028, NULL, 'IPR016794', NULL, 'Uncharacterised conserved protein UCP21603, acetyltransferase-like', 'UCP21603_acetyltransf', 4, NULL),
(15029, NULL, 'IPR021014', NULL, 'SidE, PDE domain', 'SidE_PDE', 3, NULL),
(15030, NULL, 'IPR023055', NULL, 'Putative competence-damage inducible protein, Archaea', 'CinA_Arc', 4, NULL),
(15031, NULL, 'IPR021035', NULL, 'Glycoprotein 60, Cryptosporidium spp', 'Glycop-60_Cryptosporidium', 3, NULL),
(15032, NULL, 'IPR016821', NULL, 'G0/G1 switch protein 2', 'G0S2', 4, NULL),
(15033, NULL, 'IPR016803', NULL, 'RGS1-HXK1-interacting protein 1', 'RHIP1', 4, NULL),
(15034, NULL, 'IPR022293', NULL, 'Integrating conjugative element protein, PFL4693', 'Integrating-conj_element', 4, NULL),
(15035, NULL, 'IPR021053', NULL, 'Dispersed gene family protein 1, C-terminal', 'Dispersed_gene_fam_prot1_C', 3, NULL),
(15036, NULL, 'IPR021009', NULL, 'Motility repressor MogR, DNA-binding domain', 'MogR_DNA-bd', 3, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(15037, NULL, 'IPR023058', NULL, 'Peptidyl-prolyl cis-trans isomerase, PpiC-type, conserved site', 'PPIase_PpiC_CS', 2, NULL),
(15038, NULL, 'IPR016434', NULL, 'Ribonuclease P protein subunit Rnp2, archaea', 'Rnp2_archaea', 4, NULL),
(15039, NULL, 'IPR016466', NULL, 'Uncharacterised protein family UPF0288, methanogenesis', 'UPF0288_methan', 4, NULL),
(15040, NULL, 'IPR017564', NULL, 'Cytochrome c nitrite reductase, pentahaem subunit', 'Cyt_c_NO2Rdtase_pentahaem-su', 4, NULL),
(15041, NULL, 'IPR017221', NULL, 'DUF34/NIF3, bacteria', 'DUF34/NIF3_bac', 4, NULL),
(15042, NULL, 'IPR021153', NULL, 'Heat-inducible transcription repressor HrcA, C-terminal', 'HrcA_C', 3, NULL),
(15043, NULL, 'IPR019928', NULL, 'Ribosomal protein L3, archaeal', 'Ribosomal_L3_arc', 4, NULL),
(15044, NULL, 'IPR022310', NULL, 'NAD/GMP synthase', 'NAD/GMP_synthase', 3, NULL),
(15045, NULL, 'IPR021168', NULL, 'Bifunctional polymyxin resistance protein, ArnA', 'Bifun_polymyxin_resist_ArnA', 4, NULL),
(15046, NULL, 'IPR022899', NULL, 'Deoxyhypusine synthase, putative, archaeal', 'Deoxyhypus_synthase_arc', 4, NULL),
(15047, NULL, 'IPR035231', NULL, 'Protein of unknown function DUF5346', 'DUF5346', 4, NULL),
(15048, NULL, 'IPR022271', NULL, 'Lipocalin, ApoD type', 'Lipocalin_ApoD', 4, NULL),
(15049, NULL, 'IPR018579', NULL, 'Restriction endonuclease, type II, LlaJI', 'Restrct_endonuc_II_LlaJI', 4, NULL),
(15050, NULL, 'IPR016488', NULL, 'NADH dehydrogenase [ubiquinone] (complex I), alpha subcomplex, subunit 6', 'NADH_Ub_cplx-1_asu_su-6', 4, NULL),
(15051, NULL, 'IPR021059', NULL, 'DnaJ-related protein, N-terminal', 'DnaJ-related_N', 3, NULL),
(15052, NULL, 'IPR022985', NULL, 'Sulfate transporter CysZ', 'Sulfate_CysZ', 4, NULL),
(15053, NULL, 'IPR023000', NULL, 'Shikimate kinase, conserved site', 'Shikimate_kinase_CS', 2, NULL),
(15054, NULL, 'IPR016462', NULL, 'Molybdate-dependent transcriptional regulator ModE', 'ModE', 4, NULL),
(15055, NULL, 'IPR021167', NULL, 'Uncharacterised conserved protein, UCP027887, phosphatidlglycerophosphatase-related', 'UCP027887_Ptd-glyceroPase-rel', 4, NULL),
(15056, NULL, 'IPR021124', NULL, 'CRISPR-associated protein, Cas5', 'CRISPR-assoc_prot_Cas5', 4, NULL),
(15057, NULL, 'IPR021100', NULL, 'N-glycosylation protein EOS1', 'N-glycosylation_EOS1', 4, NULL),
(15058, NULL, 'IPR016464', NULL, 'NADH dehydrogenase [ubiquinone] (complex I), alpha subcomplex, subunit 2', 'NADH_Ub_cplx-1_asu_su-2', 4, NULL),
(15059, NULL, 'IPR018561', NULL, 'Domain of unknown function DUF2017', 'DUF2017', 3, NULL),
(15060, NULL, 'IPR017213', NULL, 'Peptidase S54, rhomboid, metazoan', 'Peptidase_S54_rhomboid_met', 4, NULL),
(15061, NULL, 'IPR023042', NULL, 'Peptidase M17, leucine aminopeptidase', 'Peptidase_M17_leu_NH2_pept', 4, NULL),
(15062, NULL, 'IPR016480', NULL, 'Glucose translocase, bactoprenol-linked', 'Glc_translocase_bactprenl-link', 4, NULL),
(15063, NULL, 'IPR035473', NULL, 'CASK, SH3 domain', 'CASK_SH3', 3, NULL),
(15064, NULL, 'IPR016811', NULL, 'Origin recognition complex, subunit 6, fungi', 'ORC6_fun', 4, NULL),
(15065, NULL, 'IPR021112', NULL, 'Lantibiotic streptin immunity protein, C-terminal domain', 'Lantibiotic_streptin_immun_C', 3, NULL),
(15066, NULL, 'IPR019992', NULL, 'Mycoides cluster lipoprotein, LppA/p72', 'Mycoides_lipoprot_LppA/p72', 4, NULL),
(15067, NULL, 'IPR017206', NULL, 'Signal transduction histidine kinase, hybrid-type, BC3207, predicted', 'Sig_transdc_His_kin_hyb_BC3207', 4, NULL),
(15068, NULL, 'IPR019923', NULL, 'Luciferase-like, F420-dependent oxidoreductase, MSMEG2516, predicted', 'Lucif-like_OxRdtase_MSMEG_2516', 4, NULL),
(15069, NULL, 'IPR021057', NULL, 'Trypanosome invariant surface glycoprotein', 'Trypano_invariant_glycop', 4, NULL),
(15070, NULL, 'IPR034655', NULL, 'Alginate biosynthesis protein AlgX, N-terminal', 'AlgX_N', 3, NULL),
(15071, NULL, 'IPR023009', NULL, 'Tyrosine recombinase XerC/XerD', 'Tyrosine_recombinase_XerC/XerD', 4, NULL),
(15072, NULL, 'IPR016450', NULL, 'Uncharacterised conserved protein UCP005522', 'UCP005522', 4, NULL),
(15073, NULL, 'IPR022295', NULL, 'Ribosomal protein L12, archaea', 'Ribosomal_L12_arc', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(15074, NULL, 'IPR021067', NULL, 'Glycosyltransferase, GlcNAc', 'Glycosyltransferase', 4, NULL),
(15075, NULL, 'IPR024019', NULL, 'Conserved hypothetical protein CHP04096', 'CHP04096', 4, NULL),
(15076, NULL, 'IPR023005', NULL, 'Nucleoside diphosphate kinase, active site', 'Nucleoside_diP_kinase_AS', 0, NULL),
(15077, NULL, 'IPR023151', NULL, 'PEP-utilising enzyme, conserved site', 'PEP_util_CS', 2, NULL),
(15078, NULL, 'IPR022284', NULL, 'Glycerol-3-phosphate O-acyltransferase/Dihydroxyacetone phosphate acyltransferase', 'GPAT/DHAPAT', 4, NULL),
(15079, NULL, 'IPR021192', NULL, 'Uncharacterised conserved protein UCP031578, VanZ/RDD-type', 'UCP031578_Vanz/RDD', 4, NULL),
(15080, NULL, 'IPR035219', NULL, 'Protein of unknown function DUF5452', 'DUF5452', 4, NULL),
(15081, NULL, 'IPR021065', NULL, 'Fertility inhibition protein FinO, N-terminal', 'Fertility_inhibition_FinO_N', 3, NULL),
(15082, NULL, 'IPR024021', NULL, '[FeFe]-hydrogenase maturation HydE, radical SAM', 'FeFe-hyd_HydE_rSAM', 4, NULL),
(15083, NULL, 'IPR018570', NULL, 'Phytotoxin, PcF', 'Phytotoxin_PcF', 3, NULL),
(15084, NULL, 'IPR016806', NULL, 'COP9 signalosome complex, subunit 9, fungi', 'Csn9_fungi', 4, NULL),
(15085, NULL, 'IPR035475', NULL, 'MPP1, SH3 domain', 'MPP1_SH3', 3, NULL),
(15086, NULL, 'IPR019927', NULL, 'Ribosomal protein L3, bacterial/organelle-type', 'Ribosomal_L3_bac/org-type', 4, NULL),
(15087, NULL, 'IPR018545', NULL, 'Btz domain', 'Btz_dom', 3, NULL),
(15088, NULL, 'IPR034002', NULL, 'Tumour necrosis factor receptor 8, N-terminal', 'TNFRSF8_N', 3, NULL),
(15089, NULL, 'IPR023018', NULL, 'Transport protein YidE, putative', 'Transpt_YidE_put', 4, NULL),
(15090, NULL, 'IPR023029', NULL, 'Ribosomal protein S15P', 'Ribosomal_S15P', 4, NULL),
(15091, NULL, 'IPR035221', NULL, 'Protein of unknown function DUF5451', 'DUF5451', 4, NULL),
(15092, NULL, 'IPR023071', NULL, 'Transcriptional regulator, SlyA', 'Tscrpt_reg_SlyA', 4, NULL),
(15093, NULL, 'IPR018575', NULL, 'Restriction endonuclease, type II, Eco29kI', 'Restrct_endonuc_II_Eco29kI', 4, NULL),
(15094, NULL, 'IPR017561', NULL, 'Alkyl hydroperoxide reductase F subunit homogue, putative', 'AhpF_homologue_put', 4, NULL),
(15095, NULL, 'IPR021086', NULL, 'Accessory protein p12I', 'p12I', 4, NULL),
(15096, NULL, 'IPR023011', NULL, 'ATP synthase, F0 complex, subunit A, active site', 'ATP_synth_F0_asu_AS', 0, NULL),
(15097, NULL, 'IPR016437', NULL, 'MCT-1/Tma20', 'MCT-1/Tma20', 4, NULL),
(15098, NULL, 'IPR021056', NULL, 'Mitochondrial import inner membrane translocase subunit Tim54', 'Mt_import_IM_translocase_Tim54', 4, NULL),
(15099, NULL, 'IPR021077', NULL, 'Bacteriophage phi-Lf, Orf112', 'Phage_phi-Lf_Orf112', 4, NULL),
(15100, NULL, 'IPR023049', NULL, 'Glucose-1-phosphate adenylyltransferase GlgC, bacterial', 'GlgC_bac', 4, NULL),
(15101, NULL, 'IPR021101', NULL, 'Optomotor-blind protein, N-terminal', 'Optomoror-blind_N', 3, NULL),
(15102, NULL, 'IPR018568', NULL, 'Domain of unknown function DUF2019', 'DUF2019', 3, NULL),
(15103, NULL, 'IPR034404', NULL, 'MSSP-1, RNA recognition motif 1', 'MSSP1_RRM1', 3, NULL),
(15104, NULL, 'IPR022274', NULL, 'Peptidase aspartic, AF0612', 'Peptidase_asp_AF0612', 4, NULL),
(15105, NULL, 'IPR021096', NULL, 'Vibrio phage VSK, Orf152', 'Vibrio_phage_VSK_Orf152', 4, NULL),
(15106, NULL, 'IPR021017', NULL, 'Mediator complex, subunit Med2, fungi', 'Mediator_Med2_fun', 4, NULL),
(15107, NULL, 'IPR021016', NULL, 'Beta-1,3-xylanase', 'Beta-xylanase', 4, NULL),
(15108, NULL, 'IPR017219', NULL, 'Peptidoglycan GlcNAc deacetylase', 'Peptidoglycan_deacetylase', 4, NULL),
(15109, NULL, 'IPR022981', NULL, 'Ribosomal protein L10e, archaea', 'Ribosomal_L10e_arc', 4, NULL),
(15110, NULL, 'IPR017568', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 2', '3-oxoacyl-ACP_synth-2', 4, NULL),
(15111, NULL, 'IPR017565', NULL, 'Formate-dependent nitrite reductase complex, subunit NrfF', 'For-dep_Cytc_NO2Rdtase_NrfF', 3, NULL),
(15112, NULL, 'IPR016460', NULL, 'Coatomer beta subunit (COPB1)', 'COPB1', 4, NULL),
(15113, NULL, 'IPR016787', NULL, 'Uncharacterised conserved protein UCP021328', 'UCP021328', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(15114, NULL, 'IPR023057', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 'GlnE', 4, NULL),
(15115, NULL, 'IPR019925', NULL, 'DNA repair protein, predicted', 'DNA_repair_protein_predicted', 4, NULL),
(15116, NULL, 'IPR021084', NULL, 'Het-s prion-forming domain', 'Het-s_prion_dom', 3, NULL),
(15117, NULL, 'IPR017238', NULL, 'Squamosa promoter-binding protein', 'SBP_fam', 4, NULL),
(15118, NULL, 'IPR016471', NULL, 'Nicotinamide phosphoribosyl transferase', 'Nicotinamide_PRibTrfase', 4, NULL),
(15119, NULL, 'IPR022980', NULL, 'Photosystem I, reaction centre subunit XI', 'PSI_suXI', 4, NULL),
(15120, NULL, 'IPR017212', NULL, 'Clathrin heavy chain linker domain-containing protein 1', 'CLHC1', 4, NULL),
(15121, NULL, 'IPR017207', NULL, 'Mitochondrial translation factor Atp22', 'Atp22', 4, NULL),
(15122, NULL, 'IPR022299', NULL, 'Transcription regulator, NtcA', 'Tscrpt_reg_NtcA', 4, NULL),
(15123, NULL, 'IPR018563', NULL, 'Protein of unknown function DUF2018', 'DUF2018', 4, NULL),
(15124, NULL, 'IPR021060', NULL, 'Merozoite surface antigen', 'Merozoite_surface_antigen', 4, NULL),
(15125, NULL, 'IPR016789', NULL, 'Uncharacterised conserved protein UCP021389', 'UCP021389', 4, NULL),
(15126, NULL, 'IPR016452', NULL, 'Fatty acid synthase beta subunit AflB /Fas1-like, fungi', 'Fas1/AflB-like', 4, NULL),
(15127, NULL, 'IPR021140', NULL, 'Alkaline proteinase inhibitor/ Outer membrane lipoprotein Omp19', 'Inh/Omp19', 3, NULL),
(15128, NULL, 'IPR016468', NULL, 'CCAAT/enhancer-binding protein, chordates', 'C/EBP_chordates', 4, NULL),
(15129, NULL, 'IPR021051', NULL, 'Herpes simplex virus, Tegument protein VP16, C-terminal', 'HSV_VP16_C', 3, NULL),
(15130, NULL, 'IPR016442', NULL, 'tRNA-splicing endonuclease, archaeal short subfamily', 'tRNA_splic_arch_short', 4, NULL),
(15131, NULL, 'IPR021157', NULL, 'Cytochrome c1, transmembrane anchor, C-terminal', 'Cyt_c1_TM_anchor_C', 5, NULL),
(15132, NULL, 'IPR023054', NULL, 'Sporulation regulator WhiA, C-terminal', 'Sporulation_regulator_WhiA_C', 3, NULL),
(15133, NULL, 'IPR022281', NULL, 'ATP-dependent protease, HslV subunit', 'ATP-dep_Prtase_HsIV_su', 4, NULL),
(15134, NULL, 'IPR017236', NULL, 'Glycine/sarcosine/betaine reductase, component C, beta', 'Gly/sarc/bet/_Rdtase_C_bsu', 4, NULL),
(15135, NULL, 'IPR022272', NULL, 'Lipocalin family conserved site', 'Lipocalin_CS', 2, NULL),
(15136, NULL, 'IPR035215', NULL, 'Protein of of unknown function DUF5454', 'DUF5454', 4, NULL),
(15137, NULL, 'IPR021095', NULL, 'Domain of unknown function DUF3734', 'DUF3734', 3, NULL),
(15138, NULL, 'IPR016783', NULL, 'Biofilm formation YmcA', 'Biofilm_formation_YmcA', 4, NULL),
(15139, NULL, 'IPR020934', NULL, 'Ribosomal protein S15/S19, conserved site', 'Ribosomal_S15/S19_CS', 2, NULL),
(15140, NULL, 'IPR022289', NULL, 'ParB-related, ThiF-related cassette, protein C', 'PRTRC_protein-C', 3, NULL),
(15141, NULL, 'IPR017223', NULL, 'Predicted hydrolase of the HAD superfamily, SPs0319-type', 'HAD_SPs0319-typ', 4, NULL),
(15142, NULL, 'IPR022671', NULL, 'Ribosomal protein L2, conserved site', 'Ribosomal_L2_CS', 2, NULL),
(15143, NULL, 'IPR022268', NULL, 'Conserved hypothetical protein CHP03809', 'CHP03809', 4, NULL),
(15144, NULL, 'IPR017222', NULL, 'DUF34/NIF3, animal', 'DUF34/NIF3_animal', 4, NULL),
(15145, NULL, 'IPR021146', NULL, 'Phage gp6-like head-tail connector protein', 'Phafe_gp6_head-tail', 4, NULL),
(15146, NULL, 'IPR021070', NULL, 'Killing trait, RebB', 'Killing_trait_RebB', 4, NULL),
(15147, NULL, 'IPR021087', NULL, 'Uncharacterised protein family PixA/AidA', 'Uncharacterised_PixA/AidA', 4, NULL),
(15148, NULL, 'IPR022983', NULL, 'M18 family aminopeptidase 1, putative', 'M18_aminopeptidase_1', 4, NULL),
(15149, NULL, 'IPR022998', NULL, 'Thiamine phosphate synthase/TenI', 'ThiamineP_synth_TenI', 3, NULL),
(15150, NULL, 'IPR034406', NULL, 'RBMS3, RNA recognition motif  2', 'RBMS3_RRM2', 3, NULL),
(15151, NULL, 'IPR023064', NULL, 'D-ribose pyranase', 'D-ribose_pyranase', 4, NULL),
(15152, NULL, 'IPR021180', NULL, 'Protein lysine methyltranseferase, predicted', 'Protein_Lys_MeTrfase_predicted', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(15153, NULL, 'IPR021102', NULL, 'Peptide-N4-(N-acetyl-beta-glucosaminyl)asparagine amidase A', 'PNGase_A', 4, NULL),
(15154, NULL, 'IPR023024', NULL, 'dNTP triphosphohydrolase, type 3', 'dNTPase_3', 4, NULL),
(15155, NULL, 'IPR016463', NULL, 'Electron transport complex, RnfB/RsxB, Proteobacteria', 'RnfB/RsxB_Proteobac', 4, NULL),
(15156, NULL, 'IPR022273', NULL, 'ParB-related, ThiF-related cassette, protein E', 'PRTRC_protein-E', 3, NULL),
(15157, NULL, 'IPR022347', NULL, 'G protein-coupled receptor 153/162', 'GCR_153/162', 4, NULL),
(15158, NULL, 'IPR016798', NULL, 'Uncharacterised conserved protein UCP021980, OB-fold', 'UCP021980_OB-fold', 4, NULL),
(15159, NULL, 'IPR023060', NULL, 'Membrane insertase YidC/YidC1/YidC2, Firmicutes', 'YidC/YidC1/YidC2_Firmicutes', 4, NULL),
(15160, NULL, 'IPR021050', NULL, 'Cytochrome c oxidase subunit IV, actinobacteria', 'Cyt_c_oxidase_su4_actinobac', 4, NULL),
(15161, NULL, 'IPR021063', NULL, 'NF-kappa-B essential modulator NEMO, N-terminal', 'NEMO_N', 3, NULL),
(15162, NULL, 'IPR023035', NULL, 'Ribosomal protein S9, bacterial/plastid', 'Ribosomal_S9_bac/plastid', 4, NULL),
(15163, NULL, 'IPR021190', NULL, 'Peptidase M10A', 'Pept_M10A', 4, NULL),
(15164, NULL, 'IPR019989', NULL, 'CRISPR-associated protein Cas8a1/Csx13, Myxan subtype, N-terminal', 'CRISPR-assoc_Csx13_N', 3, NULL),
(15165, NULL, 'IPR016482', NULL, 'Protein transport protein SecG/Sec61-beta/Sbh', 'SecG/Sec61-beta/Sbh', 4, NULL),
(15166, NULL, 'IPR016824', NULL, 'Tfp pilus assembly protein FimT', 'Tfp-pilus_assembly_FimT', 4, NULL),
(15167, NULL, 'IPR021163', NULL, 'Ferredoxin-NADP+ reductase, adrenodoxin-type', 'Ferredox_Rdtase_adrenod', 4, NULL),
(15168, NULL, 'IPR022258', NULL, 'Flagellar operon protein YvyF', 'Flagellar_operon_YvyF', 4, NULL),
(15169, NULL, 'IPR021008', NULL, 'Protein of unknown function DUF3687', 'DUF3687', 4, NULL),
(15170, NULL, 'IPR016451', NULL, 'Intermediate filament, ifa/ifb', 'Intermed_filament_ifa/ifb', 4, NULL),
(15171, NULL, 'IPR022270', NULL, 'Beta-carotene 15,15''-monooxygenase, Brp/Blh family', 'Blh_monoox', 4, NULL),
(15172, NULL, 'IPR016772', NULL, 'Uncharacterised conserved protein UCP020408', 'UCP020408', 4, NULL),
(15173, NULL, 'IPR023016', NULL, 'HisA/PriA, bacterial-type', 'Isoase_HisA-like_bact', 4, NULL),
(15174, NULL, 'IPR018576', NULL, 'Restriction endonuclease, type II, Pab1', 'Restrct_endonuc_II_Pab1', 3, NULL),
(15175, NULL, 'IPR018554', NULL, 'Frequency clock protein', 'FRQ', 4, NULL),
(15176, NULL, 'IPR017563', NULL, 'Cytochrome c nitrate reductase biogenesis protein NrfE', 'CytC_NO3Rdtase_biogenesis_NrfE', 4, NULL),
(15177, NULL, 'IPR016785', NULL, 'ComG operon protein 4', 'ComGD', 4, NULL),
(15178, NULL, 'IPR023012', NULL, 'Probable glycine dehydrogenase (decarboxylating) subunit 2', 'GcvPB', 4, NULL),
(15179, NULL, 'IPR016777', NULL, 'Uncharacterised conserved protein UCP020772', 'UCP020772', 4, NULL),
(15180, NULL, 'IPR017230', NULL, 'Rab geranylgeranyltransferase complex component A', 'Mrs6', 4, NULL),
(15181, NULL, 'IPR021149', NULL, 'Oligosaccharyl transferase complex, subunit OST3/OST6', 'OligosaccharylTrfase_OST3/OST6', 4, NULL),
(15182, NULL, 'IPR021126', NULL, 'Interferon gamma receptor, D2 domain, poxvirus/mammal', 'IFN_gamma_rc_D2_pox/mammal', 3, NULL),
(15183, NULL, 'IPR016818', NULL, 'Nitric oxide synthase-interacting protein', 'NOSIP', 4, NULL),
(15184, NULL, 'IPR021093', NULL, 'NADH-quinone oxidoreductase, subunit15', 'NADH_quinone_OxRdtase_su15', 4, NULL),
(15185, NULL, 'IPR018582', NULL, 'Envelope glycoprotein, lentivirus', 'Envelope_glycop_lentivirus', 4, NULL),
(15186, NULL, 'IPR023030', NULL, 'Bifunctional protein HldE', 'Bifunc_HldE', 4, NULL),
(15187, NULL, 'IPR018565', NULL, 'Kinetochore subunit Nkp2/Cnl2', 'Nkp2/Cnl2', 4, NULL),
(15188, NULL, 'IPR016486', NULL, 'Uncharacterised conserved protein UCP006591,  MJ1004 type', 'UCP006591_CBS', 4, NULL),
(15189, NULL, 'IPR023053', NULL, 'Ribosomal protein S14, type Z', 'Ribosomal_S14_Z', 4, NULL),
(15190, NULL, 'IPR021181', NULL, 'Mitochondrial Rho GTPase', 'Miro', 4, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(15191, NULL, 'IPR021188', NULL, 'N6 adenine-specific DNA methyltransferase, TaqI class', 'N6_DNA_MeTrfase_TaqI', 4, NULL),
(15192, NULL, 'IPR016436', NULL, 'Uncharacterised conserved protein UCP005063, CBS-type', 'UCP005063_CBS', 4, NULL),
(15193, NULL, 'IPR023067', NULL, 'DNA protection during starvation protein, gammaproteobacteria', 'Dps_gammaproteobac', 4, NULL),
(15194, NULL, 'IPR017225', NULL, 'Cell shape-determining protein MreD, predicted', 'Cell_shape_determin_MreD_prd', 4, NULL),
(15195, NULL, 'IPR021033', NULL, 'Extracellular fibrinogen binding protein, C-terminal', 'Extracellular_fibrinogen-bd_C', 3, NULL),
(15196, NULL, 'IPR021049', NULL, 'Bacteriophage T4, Gp40, head assembly', 'Phage_T4_Gp40', 4, NULL),
(15197, NULL, 'IPR023074', NULL, 'Hydroxymethylglutaryl-CoA reductase, class I/II, catalytic domain superfamily', 'HMG_CoA_Rdtase_cat_sf', 5, NULL),
(15198, NULL, 'IPR016784', NULL, 'Uncharacterised protein UCP021288 with ACT domain', 'UCP021288_ACT', 4, NULL),
(15199, NULL, 'IPR021038', NULL, 'Herpesvirus UL130, cytomegalovirus', 'Herpes_UL130_cytomegalovirus', 4, NULL),
(15200, NULL, 'IPR021018', NULL, 'Mediator complex, subunit Med29, metazoa', 'Mediator_Med29_met', 4, NULL),
(15201, NULL, 'IPR017214', NULL, 'Cytochrome b561 and DOMON domain-containing protein', 'UCP037471', 4, NULL),
(15202, NULL, 'IPR024014', NULL, 'FMNH(2)-dependent dimethylsulfone monooxygenase SfnG', 'DMSO2_SphG', 4, NULL),
(15203, NULL, 'IPR023026', NULL, 'Tryptophan synthase beta chain/beta chain-like', 'Trp_synth_beta/beta-like', 4, NULL),
(15204, NULL, 'IPR021169', NULL, 'Histone H3-K79 methyltransferase, metazoa', 'DOT1L/grappa', 4, NULL),
(15205, NULL, 'IPR017242', NULL, 'BLOC-1 complex, pallidin subunit', 'BLOC-1_pallidin', 4, NULL),
(15206, NULL, 'IPR021054', NULL, 'Cell wall mannoprotein 1', 'Cell_wall_mannoprotein_1', 4, NULL),
(15207, NULL, 'IPR016447', NULL, 'Translocation associated membrane protein', 'Translocation_assoc_membrane', 4, NULL),
(15208, NULL, 'IPR021045', NULL, 'Influenza A proapoptotic protein PB1-F2', 'Flu_proapoptotic_PB1-F2', 4, NULL),
(15209, NULL, 'IPR021047', NULL, 'Mannosyltransferase 1, CMT1', 'Mannosyltransferase_CMT1', 4, NULL),
(15210, NULL, 'IPR023081', NULL, 'Cell division protein FtsB', 'Cell_div_FtsB', 4, NULL),
(15211, NULL, 'IPR022987', NULL, 'Uncharacterised protein family UPF0227', 'UPF0227', 4, NULL),
(15212, NULL, 'IPR022260', NULL, 'Integrating conjugative element protein PilL, PFGI-1', 'Integr_conj_element_PilL', 3, NULL),
(15213, NULL, 'IPR016814', NULL, 'Profilin, apicomplexa', 'Profilin_apicomplexa', 4, NULL),
(15214, NULL, 'IPR018569', NULL, 'Saf-pilin pilus formation protein', 'Saf-pilin_pilus_formation', 3, NULL),
(15215, NULL, 'IPR016456', NULL, 'Predicted cobalamin-independent methionine synthase, catalytic subunit', 'Met_Synthase_cat', 4, NULL),
(15216, NULL, 'IPR021143', NULL, 'Pyrimidine dimer DNA glycosylase, endonuclease V type', 'Pyr-dimer_DNAGlyclase_EndonucV', 4, NULL),
(15217, NULL, 'IPR024940', NULL, 'Transcription factor TCF/LEF', 'TCF/LEF', 4, NULL),
(15218, NULL, 'IPR022348', NULL, 'G protein-coupled receptor 162', 'GPR162', 4, NULL),
(15219, NULL, 'IPR021006', NULL, 'HDA1 complex subunit 2/3', 'Hda2/3', 4, NULL),
(15220, NULL, 'IPR021058', NULL, 'Porin OmpL1', 'Porin_OmpL1', 4, NULL),
(15221, NULL, 'IPR016790', NULL, 'Thiol ester hydratase, Rv0216, predicted', 'Thiol_ester_hydratase_Rv0216', 4, NULL),
(15222, NULL, 'IPR018546', NULL, 'Protein of unknown function DUF2004', 'DUF2004', 4, NULL),
(15223, NULL, 'IPR022294', NULL, 'Lantibiotic protection ABC transporter permease subunit, MutG family', 'ABC-transptr_permeasesu', 4, NULL),
(15224, NULL, 'IPR023072', NULL, 'Acetyltransferase, YpeA', 'Acetyltransferase_YpeA', 4, NULL),
(15225, NULL, 'IPR016478', NULL, 'GTPase, MTG1', 'GTPase_MTG1', 4, NULL),
(15226, NULL, 'IPR016786', NULL, 'Uncharacterised protein YdeI, bacterial', 'YdeI_bac', 4, NULL),
(15227, NULL, 'IPR018577', NULL, 'Restriction endonuclease, type II, Bpu10I', 'Restrct_endonuc_II_Bpu10I', 4, NULL),
(15228, NULL, 'IPR021139', NULL, 'NYN domain, MARF1-type', 'NYN_MARF1', 3, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(15229, NULL, 'IPR016825', NULL, 'Flagella-related protein F', 'Flagellin-rel_FlaF', 4, NULL),
(15230, NULL, 'IPR023025', NULL, 'Serine/threonine transporter SstT', 'Ser_Thr_transp_SstT', 4, NULL),
(15231, NULL, 'IPR022283', NULL, 'ParB-related, ThiF-related cassette, protein F', 'PRTRC_protein-F', 4, NULL),
(15232, NULL, 'IPR018555', NULL, 'Protein of unknown function DUF2011', 'DUF2011', 4, NULL),
(15233, NULL, 'IPR017235', NULL, 'RNA-directed RNA polymerase L, filovirus', 'RNA-dir_pol_L_filovirus', 4, NULL),
(15234, NULL, 'IPR021029', NULL, 'DNA polymerase III, tau subunit, domain V', 'DNA_pol_III_tau_dom-5', 3, NULL),
(15235, NULL, 'IPR018560', NULL, 'Domain of unknown function DUF2016', 'DUF2016', 3, NULL),
(15236, NULL, 'IPR016775', NULL, 'Nodulation, NolB', 'Nodulation_NolB', 4, NULL),
(15237, NULL, 'IPR016780', NULL, 'Uncharacterised conserved protein UCP020893', 'UCP020893', 4, NULL),
(15238, NULL, 'IPR016440', NULL, 'Rubredoxin-oxygen oxidoreductase', 'Rubredoxin-O_OxRdtase', 4, NULL),
(15239, NULL, 'IPR016788', NULL, 'Membrane protein YqfB', 'YqfB', 4, NULL),
(15240, NULL, 'IPR018580', NULL, 'Uncharacterised protein family YfhO', 'Uncharacterised_YfhO', 4, NULL),
(15241, NULL, 'IPR023007', NULL, 'Uncharacterised protein family UPF0232, actinobacteria', 'UPF0232_actinobac', 4, NULL),
(15242, NULL, 'IPR019954', NULL, 'Ubiquitin conserved site', 'Ubiquitin_CS', 2, NULL),
(15243, NULL, 'IPR035471', NULL, 'Amphiphysin 2, SH3 domain', 'Amphiphysin-2_SH3', 3, NULL),
(15244, NULL, 'IPR021072', NULL, 'Melanoma associated antigen, N-terminal', 'MAGE_N', 3, NULL),
(15245, NULL, 'IPR023048', NULL, 'NADH:quinone oxidoreductase, FMN-dependent', 'NADH:quinone_OxRdtase_FMN_depd', 4, NULL),
(15246, NULL, 'IPR016457', NULL, 'Formylmethanofuran dehydrogenase, subunit B', 'Formylmethanofuran_DH_bsu', 4, NULL),
(15247, NULL, 'IPR021148', NULL, 'Polysaccharide biosynthesis domain', 'Polysacc_synth_dom', 3, NULL),
(15248, NULL, 'IPR034734', NULL, 'Zinc finger C2HC RNF-type', 'ZF_C2HC_RNF', 3, NULL),
(15249, NULL, 'IPR021164', NULL, 'Tyrosine hydroxylase, conserved site', 'Tyrosine_hydroxylase_CS', 2, NULL),
(15250, NULL, 'IPR021156', NULL, 'Transcription elongation factor A-like/Brain expressed X-linked', 'TF_A-like/BEX', 4, NULL),
(15251, NULL, 'IPR021094', NULL, 'NPR1/NIM1-like, C-terminal', 'NPR1/NIM1-like_C', 3, NULL),
(15252, NULL, 'IPR023002', NULL, 'Glycerol-1-phosphate dehydrogenase, archaea', 'G1P_dehydrogenase_arc', 4, NULL),
(15253, NULL, 'IPR017216', NULL, 'Hermansky-Pudlak syndrome 3 protein', 'HPS3', 4, NULL),
(15254, NULL, 'IPR018550', NULL, 'Lipid A 3-O-deacylase-related', 'Lipid-A_deacylase-rel', 4, NULL),
(15255, NULL, 'IPR023051', NULL, 'Potassium uptake protein, low affinity, Kup', 'K+_uptake_low_affin', 4, NULL),
(15256, NULL, 'IPR016793', NULL, 'Uncharacterised conserved protein UCP021591', 'UCP021591', 4, NULL),
(15257, NULL, 'IPR016445', NULL, 'Lipase Rog1', 'Rog1_fam', 4, NULL),
(15258, NULL, 'IPR021091', NULL, 'Mercury ion transport, MerF', 'Mercury_ion_transport_MerF', 4, NULL),
(15259, NULL, 'IPR016469', NULL, 'Carbohydrate sulfotransferase', 'Carbohydrate_sulfotransferase', 4, NULL),
(15260, NULL, 'IPR017566', NULL, 'NrfD', 'NrfD', 4, NULL),
(15261, NULL, 'IPR022278', NULL, 'Phosphoserine aminotransferase', 'Pser_aminoTfrase', 4, NULL),
(15262, NULL, 'IPR023027', NULL, 'Mannitol dehydrogenase, conserved site', 'Mannitol_DH_CS', 2, NULL),
(15263, NULL, 'IPR021007', NULL, 'Complementary sex determiner, C-terminal', 'Sex_determ_C', 3, NULL),
(15264, NULL, 'IPR021135', NULL, 'Phosphoenolpyruvate carboxylase', 'PEP_COase', 4, NULL),
(15265, NULL, 'IPR023063', NULL, 'FeS cluster insertion protein ErpA', 'FeS_cluster_insertion_RrpA', 4, NULL),
(15266, NULL, 'IPR023157', NULL, 'AGR-C-984p-like superfamily', 'AGR-C-984p-like_sf', 5, NULL),
(15267, NULL, 'IPR021048', NULL, 'Intracellular growth locus C protein', 'Intracellular_growth_locus_C', 4, NULL),
(15268, NULL, 'IPR022372', NULL, 'Accessory secretory system protein Asp1', 'Accessory_SS_Asp1', 4, NULL),
(15269, NULL, 'IPR021147', NULL, 'Protein of unknown function DUF697', 'DUF697', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(15270, NULL, 'IPR021052', NULL, 'Holliday junction recognition protein, HJURP, central domain', 'HJURP_central_dom', 3, NULL),
(15271, NULL, 'IPR021145', NULL, 'Portal protein', 'Portal_protein', 4, NULL),
(15272, NULL, 'IPR023050', NULL, 'Bifunctional protein PyrR', 'PyrR', 4, NULL),
(15273, NULL, 'IPR017224', NULL, 'Opine oxidase, subunit A/hydrogen cyanide synthase, subunit B', 'Opine_Oxase_asu/HCN_bsu', 4, NULL),
(15274, NULL, 'IPR024935', NULL, 'Rubredoxin domain', 'Rubredoxin_dom', 3, NULL),
(15275, NULL, 'IPR022997', NULL, 'NADH-quinone oxidoreductase chain 4', 'NADH_Q_OxRdtase_chain4', 4, NULL),
(15276, NULL, 'IPR018552', NULL, 'Centromere protein X', 'CENP-X', 4, NULL),
(15277, NULL, 'IPR035468', NULL, 'SH3D21, SH3 domain', 'SH3D21_SH3', 3, NULL),
(15278, NULL, 'IPR018559', NULL, 'Protein of unknown function DUF2015', 'DUF2015', 4, NULL),
(15279, NULL, 'IPR016472', NULL, 'Transcription regulator, MJ0621, predicted', 'Tscrpt_reg_MJ0621_prd', 4, NULL),
(15280, NULL, 'IPR035217', NULL, 'Protein of unknown function DUF5453', 'DUF5453', 4, NULL),
(15281, NULL, 'IPR021090', NULL, 'SAM/SH3 domain-containing', 'rSAM/SH3_domain-containing', 4, NULL),
(15282, NULL, 'IPR016791', NULL, 'Rubromycin-type polyketide biosynthesis protein, GrhN/RubW, predicted', 'Polyketide_synth_GrhN/RubW_prd', 4, NULL),
(15283, NULL, 'IPR021013', NULL, 'ATPase, vacuolar ER assembly factor, Vma12', 'ATPase_Vma12', 4, NULL),
(15284, NULL, 'IPR022982', NULL, 'DNA double-strand break repair Rad50 ATPase, archaeal type', 'Rad50_ATPase_archaeal', 4, NULL),
(15285, NULL, 'IPR023010', NULL, 'Probable glycine dehydrogenase (decarboxylating) subunit 1', 'GcvPA', 4, NULL),
(15286, NULL, 'IPR023061', NULL, 'Selenophosphate synthetase, class I', 'SelD_I', 4, NULL),
(15287, NULL, 'IPR021152', NULL, 'Herpesvirus UL31', 'Herpes_UL31', 4, NULL),
(15288, NULL, 'IPR035212', NULL, 'Matrix/matrix long, N-terminal', 'Mx/ML_C', 3, NULL),
(15289, NULL, 'IPR019950', NULL, 'M protein-type anchor domain', 'M_anchor', 3, NULL),
(15290, NULL, 'IPR016453', NULL, 'Coatomer beta'' subunit (COPB2)', 'COPB2', 4, NULL),
(15291, NULL, 'IPR017215', NULL, '5-methyltetrahydrofolate-homocysteine S-methyltransferase, bacterial', 'MetH_bac', 4, NULL),
(15292, NULL, 'IPR017232', NULL, 'Nitrogen regulation protein NtrY', 'NtrY', 4, NULL),
(15293, NULL, 'IPR016782', NULL, 'Uncharacterised conserved protein UCP022271', 'UCP022271', 4, NULL),
(15294, NULL, 'IPR021089', NULL, 'Bacteriocin, lactococcin-G', 'Bacteriocin_lactococcin-G', 4, NULL),
(15295, NULL, 'IPR021062', NULL, 'Putative aromatic acid exporter, C-terminal', 'ArAE_1_C', 3, NULL),
(15296, NULL, 'IPR023043', NULL, 'NAD(P)H-quinone oxidoreductase subunit 3, bacterial/plastid', 'NAD(P)H_OxRDtase_bac/plastid', 4, NULL),
(15297, NULL, 'IPR018548', NULL, 'Spike (S) protein S1 subunit, receptor-binding domain, betacoronavirus', 'Spike_S1_RBD_bCoV', 3, NULL),
(15298, NULL, 'IPR017239', NULL, 'Mitogen-activated protein (MAP) kinase kinase kinase Ste11, Cryptococcus', 'Ste11_Cryptococcus', 4, NULL),
(15299, NULL, 'IPR021098', NULL, 'Bacteriophage P22, Gp10, DNA-stabilising', 'Phage_P22_Gp10', 4, NULL),
(15300, NULL, 'IPR016828', NULL, 'Alpha-L-arabinofuranosidase', 'Alpha-L-arabinofuranosidase', 4, NULL),
(15301, NULL, 'IPR020995', NULL, 'Chlorosome envelope protein C', 'Chlorosome_envelope_CsmC', 4, NULL),
(15302, NULL, 'IPR017233', NULL, 'WD repeat protein 35', 'WDR35', 4, NULL),
(15303, NULL, 'IPR021125', NULL, 'Protein of unknown function DUF2127', 'DUF2127', 4, NULL),
(15304, NULL, 'IPR016489', NULL, 'Uncharacterised conserved protein UCP006685', 'UCP006685', 4, NULL),
(15305, NULL, 'IPR022816', NULL, 'Condensin complex subunit 2/barren', 'Condensin_barren_su2', 4, NULL),
(15306, NULL, 'IPR021011', NULL, 'DNA replication regulator, HobA', 'HobA', 4, NULL),
(15307, NULL, 'IPR016435', NULL, 'Diphthamide synthesis DPH1/DPH2', 'DPH1/DPH2', 4, NULL),
(15308, NULL, 'IPR017562', NULL, 'Cytochrome c-type biogenesis protein CcsA', 'Cyt_c_biogenesis_CcsA', 4, NULL),
(15309, NULL, 'IPR021074', NULL, 'Formate dehydrogenase, delta subunit', 'Formate_DH_dsu', 4, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(15310, NULL, 'IPR021066', NULL, 'Fungal protease inhibitor-1', 'FPI1', 4, NULL),
(15311, NULL, 'IPR016444', NULL, 'Synaptobrevin/Vesicle-associated membrane protein', 'Synaptobrevin/VAMP', 4, NULL),
(15312, NULL, 'IPR021088', NULL, 'Osteocrin', 'Osteocrin', 4, NULL),
(15313, NULL, 'IPR021131', NULL, 'Ribosomal protein L18e/L15P', 'Ribosomal_L18e/L15P', 3, NULL),
(15314, NULL, 'IPR023028', NULL, 'Mannitol-1-phosphate 5-dehydrogenase', 'Mannitol_1_phos_5_DH', 4, NULL),
(15315, NULL, 'IPR021044', NULL, 'Herpesvirus Glycoprotein B, antigenic domain, N-terminal', 'Glycoprot_B_antigenic_N', 3, NULL),
(15316, NULL, 'IPR022988', NULL, 'Nickel-responsive transcriptional regulator NikR', 'Ni_resp_reg_NikR', 4, NULL),
(15317, NULL, 'IPR016487', NULL, 'Sm-like protein Lsm6/SmF', 'Lsm6/sSmF', 4, NULL),
(15318, NULL, 'IPR022290', NULL, 'Conserved hypothetical protein CHP03858, luciferase-like monooxygenase, putative', 'CHP03858_lucif-like_mOase_put', 4, NULL),
(15319, NULL, 'IPR021064', NULL, 'Estrogen receptor beta-like, N-terminal', 'ER-beta-like_N', 3, NULL),
(15320, NULL, 'IPR023031', NULL, 'Orotate phosphoribosyltransferase', 'OPRT', 4, NULL),
(15321, NULL, 'IPR021061', NULL, 'Mitochondrial division protein 1', 'Mt_division_protein_1', 4, NULL),
(15322, NULL, 'IPR021069', NULL, 'ImpA, C-terminal', 'ImpA_C', 3, NULL),
(15323, NULL, 'IPR023073', NULL, 'DNA polymerase, error-prone', 'DNA_pol_error_prone', 4, NULL),
(15324, NULL, 'IPR023017', NULL, 'Transport protein YbjL, putative', 'Transp_YbjL_put', 4, NULL),
(15325, NULL, 'IPR016778', NULL, 'Competence protein ComB', 'Competence_ComB', 4, NULL),
(15326, NULL, 'IPR017226', NULL, 'Betaine-homocysteine S-methyltransferase, BHMT', 'Betaine-hCys_S-MeTrfase_BHMT', 4, NULL),
(15327, NULL, 'IPR021040', NULL, 'LRRC8, pannexin-like TM region', 'LRRC8_Pannexin-like', 3, NULL),
(15328, NULL, 'IPR021043', NULL, 'MKI67 FHA domain-interacting nucleolar phosphoprotein, FHA Ki67 binding', 'NIFK_FHA_Ki67-binding', 3, NULL),
(15329, NULL, 'IPR017241', NULL, 'Toll-like receptor', 'Toll-like_receptor', 4, NULL),
(15330, NULL, 'IPR021037', NULL, 'Stomoxyn', 'Stomoxyn', 4, NULL),
(15331, NULL, 'IPR016796', NULL, 'Uncharacterised conserved protein UCP021774', 'UCP021774', 4, NULL),
(15332, NULL, 'IPR022288', NULL, 'VPDSG-CTERM protein sorting domain', 'VPDSG_CTERM', 3, NULL),
(15333, NULL, 'IPR023059', NULL, 'Foldase protein PrsA', 'Foldase_PrsA', 4, NULL),
(15334, NULL, 'IPR021165', NULL, 'Saposin, chordata', 'Saposin_chordata', 4, NULL),
(15335, NULL, 'IPR017569', NULL, 'Enoyl-(acyl-carrier-protein) reductase II, putative', 'Enoyl_ACP_red-II_put', 4, NULL),
(15336, NULL, 'IPR022276', NULL, 'Conjugative transposon, TraK', 'Conjug_transposon_TraK', 4, NULL),
(15337, NULL, 'IPR021172', NULL, 'Uncharacterised conserved protein, RNA methylase-related', 'UCP006607_RNA_methylase-rel', 4, NULL),
(15338, NULL, 'IPR023159', NULL, 'SO1590-like superfamily', 'SO1590-like_sf', 5, NULL),
(15339, NULL, 'IPR021097', NULL, 'CPH domain', 'CPH_domain', 3, NULL),
(15340, NULL, 'IPR021207', NULL, 'Integrating conjugative element protein, PFL4705', 'Integr_conj_element_PFL4705', 4, NULL),
(15341, NULL, 'IPR018564', NULL, 'DNA replication checkpoint mediator, MRC1 domain', 'Repl_chkpnt_MRC1_dom', 3, NULL),
(15342, NULL, 'IPR017209', NULL, 'Alpha/beta hydrolase, predicted', 'Abhydr', 4, NULL),
(15343, NULL, 'IPR018551', NULL, 'Domain of unknown function DUF2007', 'DUF2007', 3, NULL),
(15344, NULL, 'IPR022992', NULL, 'Uncharacterised protein family UPF0213, GIY-YIG endonuclease', 'UPF0213_GIY-YIG_endonuc', 4, NULL),
(15345, NULL, 'IPR016481', NULL, 'Transcription factor TFE, archaea', 'TF_E_archaea', 4, NULL),
(15346, NULL, 'IPR018573', NULL, 'Restriction endonuclease, type II, AlwI', 'Restrct_endonuc_II_AlwI', 4, NULL),
(15347, NULL, 'IPR021068', NULL, 'HTH DNA binding domain', 'HTH_DNA-bd', 3, NULL),
(15348, NULL, 'IPR018567', NULL, 'Domain of unknown function DUF2020', 'DUF2020', 3, NULL),
(15349, NULL, 'IPR016473', NULL, 'Deoxycytidylate deaminase', 'dCMP_deaminase', 4, NULL),
(15350, NULL, 'IPR016438', NULL, 'ATP-dependent RNA helicase Ski2-like', 'Ski2-like', 4, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(15351, NULL, 'IPR022896', NULL, 'Triosephosphate isomerase, bacterial/eukaryotic', 'TrioseP_Isoase_bac/euk', 4, NULL),
(15352, NULL, 'IPR017210', NULL, 'Actin patch protein 1', 'APP1', 4, NULL),
(15353, NULL, 'IPR021193', NULL, 'BPI fold-containing family B member 1', 'Bpifb1', 4, NULL),
(15354, NULL, 'IPR021191', NULL, 'Restriction endonuclease, type II, DpnII', 'Restrct_endonuc_II_DpnII', 4, NULL),
(15355, NULL, 'IPR023065', NULL, 'Uncharacterised protein family ApaG', 'Uncharacterised_ApaG', 4, NULL),
(15356, NULL, 'IPR021099', NULL, 'Plant organelle RNA recognition domain', 'PORR_domain', 3, NULL),
(15357, NULL, 'IPR016827', NULL, 'Transcriptional adaptor 2', 'Ada2/TADA2', 4, NULL),
(15358, NULL, 'IPR018578', NULL, 'Restriction endonuclease, type II, BstXI', 'Restrct_endonuc_II_BstXI', 4, NULL),
(15359, NULL, 'IPR024766', NULL, 'Zinc finger, RING-H2-type', 'Znf_RING_H2', 3, NULL),
(15360, NULL, 'IPR035477', NULL, 'SH3PXD2B, SH3 domain 1', 'SH3PXD2B_SH3_1', 3, NULL),
(15361, NULL, 'IPR035467', NULL, 'Putative ATP-dependent RNA helicase YLR419W-like, UBA domain', 'YLR419W-like_UBA', 3, NULL),
(15362, NULL, 'IPR022585', NULL, 'TraD coupling protein, N-terminal', 'TraD_N', 3, NULL),
(15363, NULL, 'IPR021046', NULL, 'Cold-shock protein, DEAD box A, C-terminal', 'Cold-shock_DEAD_Abox_C', 3, NULL),
(15364, NULL, 'IPR016812', NULL, 'Protein phosphatase methylesterase, eukaryotic', 'PPase_methylesterase_euk', 4, NULL),
(15365, NULL, 'IPR016810', NULL, 'DNA repair protein Rad59', 'Rad59', 4, NULL),
(15366, NULL, 'IPR016773', NULL, 'Ferric uptake regulator, CjrA, predicted', 'Fe3_uptake_reg_CjrA_prd', 4, NULL),
(15367, NULL, 'IPR023070', NULL, 'DnaA initiator-associating protein', 'DiaA', 4, NULL),
(15368, NULL, 'IPR021039', NULL, 'Iron-sulphur binding protein LdpA, C-terminal', 'Fe-S-bd_prot_LdpA_C', 3, NULL),
(15369, NULL, 'IPR035228', NULL, 'Protein of unknown function DUF5340', 'DUF5340', 4, NULL),
(15370, NULL, 'IPR017237', NULL, 'rRNA (guanine-N2-)-methyltransferase, RsmD', 'rRNA_m2G-MeTrfase_RsmD', 4, NULL),
(15371, NULL, 'IPR016815', NULL, 'Rhoptry protein, Rop2-like', 'Rhoptry_Rop2-like', 4, NULL),
(15372, NULL, 'IPR018572', NULL, 'Protein of unknown function YopT', 'YopT', 3, NULL),
(15373, NULL, 'IPR016792', NULL, 'Uncharacterised conserved protein UCP021573', 'UCP021573', 4, NULL),
(15374, NULL, 'IPR018571', NULL, 'Membrane anchor Opy2, N-terminal', 'Membrane_anchor_Opy2_N', 3, NULL),
(15375, NULL, 'IPR016479', NULL, 'tRNA/rRNA methyltransferase, YfiF, predicted', 'YfiF_prd', 4, NULL),
(15376, NULL, 'IPR023008', NULL, 'Uncharacterized MFS-type transporter YhhS-like', 'MFS_YhhS-like', 4, NULL),
(15377, NULL, 'IPR021055', NULL, 'Type-IV b secretion system, inner-membrane complex component', 'T4BSS_IcmL/DotI', 4, NULL),
(15378, NULL, 'IPR019956', NULL, 'Ubiquitin domain', 'Ubiquitin_dom', 3, NULL),
(15379, NULL, 'IPR034409', NULL, 'U1 small nuclear ribonucleoprotein A, RNA recognition motif  2', 'U1A_RRM2', 3, NULL),
(15380, NULL, 'IPR016797', NULL, 'Uncharacterised conserved protein UCP021898', 'UCP021898', 4, NULL),
(15381, NULL, 'IPR021034', NULL, 'Domain of unknown function DUF3672', 'DUF3672', 3, NULL),
(15382, NULL, 'IPR021109', NULL, 'Aspartic peptidase domain superfamily', 'Peptidase_aspartic_dom_sf', 5, NULL),
(15383, NULL, 'IPR018562', NULL, 'ARS binding protein 2', 'ARS-binding_2', 4, NULL),
(15384, NULL, 'IPR022280', NULL, 'ParB-related, ThiF-related cassette, protein B', 'PRTRC_protein-B', 4, NULL),
(15385, NULL, 'IPR016808', NULL, 'Mitochondrial morphogenesis protein Sld7', 'Sld7', 4, NULL),
(15386, NULL, 'IPR017231', NULL, 'Small GTPase Tem1/Spg1', 'Small_GTPase_Tem1/Spg1', 4, NULL),
(15387, NULL, 'IPR022990', NULL, 'Uncharacterised protein family UPF0115', 'UPF0115', 4, NULL),
(15388, NULL, 'IPR016820', NULL, 'Mediator complex, subunit Med6, metazoa/plant', 'Mediator_Med6_met/pln', 4, NULL),
(15389, NULL, 'IPR022999', NULL, 'Transaldolase type 3B, putative', 'Transaldolase_3B', 4, NULL),
(15390, NULL, 'IPR021012', NULL, 'Down syndrome cell adhesion molecule, C-terminal', 'Dscam_C', 3, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(15391, NULL, 'IPR021108', NULL, 'Restriction endonuclease, type II, BpuJI, N-terminal', 'Restrct_endonuc_II_BpuJI_N', 3, NULL),
(15392, NULL, 'IPR016781', NULL, 'Anti-sigma regulatory factor, PmgA, predicted', 'Anti-sigma_regulat_PmgA_prd', 4, NULL),
(15393, NULL, 'IPR016801', NULL, 'Uncharacterised conserved protein UCP022207', 'UCP022207', 4, NULL),
(15394, NULL, 'IPR023052', NULL, 'Cell division protein SepF', 'Cell_div_SepF', 4, NULL),
(15395, NULL, 'IPR021136', NULL, 'Flagellar hook-length control protein-like, C-terminal', 'Flagellar_hook_control-like_C', 3, NULL),
(15396, NULL, 'IPR023006', NULL, 'Uncharacterised protein family UPF0225', 'UPF0225', 4, NULL),
(15397, NULL, 'IPR016446', NULL, 'Flavin oxidoreductase Frp family', 'Flavin_OxRdtase_Frp', 4, NULL),
(15398, NULL, 'IPR021210', NULL, 'Exosporium BclB, C-terminal', 'Exosporium_BclB', 3, NULL),
(15399, NULL, 'IPR022296', NULL, 'Proteasome, alpha subunit, bacterial', 'Proteasome_asu_bac', 4, NULL),
(15400, NULL, 'IPR016795', NULL, 'Uncharacterised conserved protein UCP021697, membrane', 'UCP021697', 4, NULL),
(15401, NULL, 'IPR017240', NULL, 'Mitogen-activated protein (MAP) kinase kinase kinase Ssk2/Ssk22', 'MAPKKK_Ssk2/Ssk22', 4, NULL),
(15402, NULL, 'IPR022371', NULL, 'Exopolyphosphatase', 'Exopolyphosphatase', 3, NULL),
(15403, NULL, 'IPR022291', NULL, 'Bacteriocin biosynthesis, cyclodehydratase domain', 'Bacteriocin_synth_cyclodeHase', 3, NULL),
(15404, NULL, 'IPR017234', NULL, 'RNA-directed RNA polymerase, rhabdovirus', 'RNA-dir_pol_rhabdovirus', 4, NULL),
(15405, NULL, 'IPR023033', NULL, 'Alanine-tRNA ligase, eukaryota/bacteria', 'Ala_tRNA_ligase_euk/bac', 4, NULL),
(15406, NULL, 'IPR019960', NULL, 'Type I secretion C-terminal target domain, VC_A0849 subclass', 'T1SS_VCA0849', 3, NULL),
(15407, NULL, 'IPR016805', NULL, 'Intermembrane space protein MIX23, fungal', 'MIX23_fungal', 4, NULL),
(15408, NULL, 'IPR021119', NULL, 'Poxvirus F1/C10', 'Poxvirus_F1/C10', 4, NULL),
(15409, NULL, 'IPR021151', NULL, 'GINS subunit, domain A', 'GINS_A', 3, NULL),
(15410, NULL, 'IPR021138', NULL, '60S ribosomal protein L18a/ L20, eukaryotes', 'Ribosomal_L18a/L20_eukaryotes', 4, NULL),
(15411, NULL, 'IPR018557', NULL, 'THO complex subunit Thp2', 'THO_cplx_su_Thp2', 4, NULL),
(15412, NULL, 'IPR021130', NULL, 'Phosphoribosyl-ATP pyrophosphohydrolase-like', 'PRib-ATP_PPHydrolase-like', 4, NULL),
(15413, NULL, 'IPR016455', NULL, 'Xyloglucan endotransglucosylase/hydrolase', 'XTH', 4, NULL),
(15414, NULL, 'IPR023013', NULL, 'N-acetyl-gamma-glutamyl-phosphate reductase, active site', 'AGPR_AS', 0, NULL),
(15415, NULL, 'IPR016443', NULL, 'RNA 3''-terminal phosphate cyclase type 2', 'RNA3''_term_phos_cyc_type_2', 4, NULL),
(15416, NULL, 'IPR021073', NULL, 'Murid herpesvirus 1, M157', 'MuHV-1_M157', 4, NULL),
(15417, NULL, 'IPR021195', NULL, 'Ubiquinol cytochrome c reductase, cytochrome c1 subunit, predicted', 'Ubol_Cyt_c_Rdtase_Cyt_c_su_prd', 4, NULL),
(15418, NULL, 'IPR021030', NULL, 'Protein of unknown function DUF3731', 'DUF3731', 4, NULL),
(15419, NULL, 'IPR017208', NULL, 'Uncharacterised conserved protein UCP037442, alpha/beta hydrolase, RSp0795', 'UCP037442_abhydr', 4, NULL),
(15420, NULL, 'IPR019924', NULL, 'ABC transporter, urea permease protein UrtB, archaeal', 'ABC_UrtB_arc', 4, NULL),
(15421, NULL, 'IPR016449', NULL, 'Potassium channel, inwardly rectifying, Kir', 'K_chnl_inward-rec_Kir', 4, NULL),
(15422, NULL, 'IPR021137', NULL, 'Ribosomal protein L35', 'Ribosomal_L35', 4, NULL),
(15423, NULL, 'IPR016776', NULL, '3-hydroxylacyl-(acyl carrier protein) dehydratase, predicted', 'Hydroxyacyl-ACP_deHydtase_prd', 4, NULL),
(15424, NULL, 'IPR034657', NULL, 'Alginate O-acetyltranferase AlgJ', 'AlgJ', 3, NULL),
(15425, NULL, 'IPR035222', NULL, 'Non-structural protein NS3', 'NS3', 4, NULL),
(15426, NULL, 'IPR022277', NULL, 'Conserved hypothetical protein CHP02171, Fibrobacter succinogenes', 'CHP02171_FIBSS', 4, NULL),
(15427, NULL, 'IPR021032', NULL, 'Duffy-antigen binding, N-terminal', 'Duffy-antigen-binding_N', 3, NULL),
(15428, NULL, 'IPR021041', NULL, 'Major surface glycoprotein 2, C-terminal', 'Maj_surf_glycoprot_2_C', 3, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(15429, NULL, 'IPR016816', NULL, 'Surface antigen p22', 'SAG2', 4, NULL),
(15430, NULL, 'IPR016477', NULL, 'Fructosamine/Ketosamine-3-kinase', 'Fructo-/Ketosamine-3-kinase', 4, NULL),
(15431, NULL, 'IPR022374', NULL, 'Energy-dependent translational throttle protein EttA', 'EttA', 4, NULL),
(15432, NULL, 'IPR018581', NULL, 'Type III secretion system, pilus formation, HrpA', 'T3SS_pilus_HrpA', 4, NULL),
(15433, NULL, 'IPR019959', NULL, 'T1SS-143 repeat-containing domain', 'T1SS-143_rpt-cont_dom', 3, NULL),
(15434, NULL, 'IPR023082', NULL, 'Homeo-prospero domain', 'Homeo_prospero_dom', 3, NULL),
(15435, NULL, 'IPR016484', NULL, 'GTP-binding protein EngA', 'GTP-bd_EngA', 4, NULL),
(15436, NULL, 'IPR021162', NULL, 'Histone H3-K79 methyltransferase, fungi', 'Dot1', 4, NULL),
(15437, NULL, 'IPR016441', NULL, 'TEL2-interacting protein 1', 'Tti1', 4, NULL),
(15438, NULL, 'IPR021110', NULL, 'DNA replication/checkpoint protein', 'DNA_rep_checkpnt_protein', 4, NULL),
(15439, NULL, 'IPR021076', NULL, 'Parvovirus non-structural protein 1, N-terminal', 'Parvovirus_NS1_N', 3, NULL),
(15440, NULL, 'IPR016461', NULL, 'O-methyltransferase COMT-type', 'COMT-like', 4, NULL),
(15441, NULL, 'IPR021111', NULL, 'Hexameric tyrosine-coordinated heme protein (HTHP)', 'Hexamer_Tyr-coord_heme_pr_HTHP', 4, NULL),
(15442, NULL, 'IPR018566', NULL, '4-Methylmuconolactone methyl-isomerase', 'MeMu_Me-Isoase', 3, NULL),
(15443, NULL, 'IPR022890', NULL, 'Ferredoxin--NADP reductase, type 2', 'Fd--NADP_Rdtase_type_2', 4, NULL),
(15444, NULL, 'IPR017205', NULL, 'Signal transduction histidine kinase, ChrS', 'Sig_transdc_His_kinase_ChrS', 4, NULL),
(15445, NULL, 'IPR018553', NULL, 'Protein of unknown function DUF2009', 'DUF2009', 4, NULL),
(15446, NULL, 'IPR016439', NULL, 'Sphingosine N-acyltransferase Lag1/Lac1-like', 'Lag1/Lac1-like', 4, NULL),
(15447, NULL, 'IPR021132', NULL, 'Ribosomal protein L18/L18-A/B/e, conserved site', 'Ribosomal_L18/L18-A/B/e_CS', 2, NULL),
(15448, NULL, 'IPR016467', NULL, 'DNA recombination and repair protein, RecA-like', 'DNA_recomb/repair_RecA-like', 4, NULL),
(15449, NULL, 'IPR023154', NULL, 'Jann4075-like superfamily', 'Jann4075-like_sf', 5, NULL),
(15450, NULL, 'IPR023034', NULL, 'Peptidyl-prolyl isomerase SurA', 'PPIase_SurA', 4, NULL),
(15451, NULL, 'IPR017227', NULL, 'Nucleoside-triphosphatase, alveolata', 'NTPase_alveloata', 4, NULL),
(15452, NULL, 'IPR016458', NULL, 'Uncharacterised conserved protein UCP005648, calcium-binding', 'UCP005648_Ca-bd', 4, NULL),
(15453, NULL, 'IPR023032', NULL, 'tRNA 5-methylaminomethyl-2-thiouridine biosynthesis bifunctional protein MnmC', 'tRNA_MAMT_biosynth_bifunc_MnmC', 4, NULL),
(15454, NULL, 'IPR016813', NULL, 'NADH dehydrogenase [ubiquinone] (complex I), 21kDa subunit, fungi', 'NADH_Ub_cplx-1_21kDa_fun', 4, NULL),
(15455, NULL, 'IPR016817', NULL, 'Mannose-P-dolichol utilization defect 1 protein', 'MannP-dilichol_defect-1', 4, NULL),
(15456, NULL, 'IPR023068', NULL, 'CCA-adding enzyme, firmicutes', 'CCA-adding_enz_firmicutes', 4, NULL),
(15457, NULL, 'IPR020997', NULL, 'Ataxin-1, N-terminal', 'Ataxin-1_N', 3, NULL),
(15458, NULL, 'IPR023001', NULL, 'Fructose-6-phosphate aldolase', 'F6P_aldolase', 4, NULL),
(15459, NULL, 'IPR019926', NULL, 'Ribosomal protein L3, conserved site', 'Ribosomal_L3_CS', 2, NULL),
(15460, NULL, 'IPR021019', NULL, 'Mediator complex, subunit Med30, metazoa', 'Mediator_Med30_met', 4, NULL),
(15461, NULL, 'IPR023080', NULL, 'D-amino acid dehydrogenase DadA', 'DadA', 4, NULL),
(15462, NULL, 'IPR024771', NULL, 'SUZ domain', 'SUZ', 3, NULL),
(15463, NULL, 'IPR022986', NULL, 'Uncharacterised protein family UPF0237, ACT-type', 'UPF0237_ACT', 4, NULL),
(15464, NULL, 'IPR016804', NULL, 'Uncharacterised protein family UPF0114, plant', 'UPF0114_pln', 4, NULL),
(15465, NULL, 'IPR022991', NULL, 'Ribosomal protein L30e, conserved site', 'Ribosomal_L30e_CS', 2, NULL),
(15466, NULL, 'IPR016476', NULL, 'SH3 domain protein', 'SH3_dom_pro', 4, NULL),
(15467, NULL, 'IPR021144', NULL, 'Uncharacterised protein family UPF0597', 'UPF0597', 4, NULL),
(15468, NULL, 'IPR034403', NULL, 'Srp1, RNA recognition motif', 'Srp1p_RRM', 3, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(15469, NULL, 'IPR021023', NULL, 'Envelope glycoprotein UL132', 'UL132', 4, NULL),
(15470, NULL, 'IPR016470', NULL, 'Phycobilisome linker protein', 'Phycobilisome', 4, NULL),
(15471, NULL, 'IPR021022', NULL, 'Human herpes virus-8, Protein K1, cytoplasmic domain', 'HHSV-8_K1_cytoplasmic_dom', 3, NULL),
(15472, NULL, 'IPR023014', NULL, 'Fructose-bisphosphate aldolase class I, Gram-positive bacteria-type', 'FBA_I_Gram+-type', 4, NULL),
(15473, NULL, 'IPR016802', NULL, 'Uncharacterised conserved protein UCP022260', 'UCP022260', 4, NULL),
(15474, NULL, 'IPR023066', NULL, 'Quinolinate synthase A, type 2', 'Quinolinate_synth_type2', 4, NULL),
(15475, NULL, 'IPR016807', NULL, 'Anaphase-promoting complex subunit Mnd2', 'Mnd2', 4, NULL),
(15476, NULL, 'IPR021075', NULL, 'Bocavirus non-capsid protein, NP1', 'Bocavirus_NP1', 4, NULL),
(15477, NULL, 'IPR023047', NULL, 'Probable cyclic pyranopterin monophosphate synthase accessory protein, archaea', 'Mo_CF_biosynth-C_arc', 4, NULL),
(15478, NULL, 'IPR018574', NULL, 'Structure-specific endonuclease subunit Slx4', 'Structure-sp_endonuc_su_Slx4', 4, NULL),
(15479, NULL, 'IPR034407', NULL, 'U1 small nuclear ribonucleoprotein A, RNA recognition motif  1', 'U1A_RRM1', 3, NULL),
(15480, NULL, 'IPR017220', NULL, 'Sulphite reductase, assimilatory', 'Sulphite_reductase_assimil', 4, NULL),
(15481, NULL, 'IPR023019', NULL, 'Histidine biosynthesis bifunctional protein HisIE', 'His_synth_HisIE', 4, NULL),
(15482, NULL, 'IPR019957', NULL, 'ABC transporter, high-affinity heme uptake system protein IsdE', 'ABC_transptr_haem-bd_IsdE', 4, NULL),
(15483, NULL, 'IPR021042', NULL, 'Herpesvirus UL139, cytomegalovirus', 'Herpes_UL139_cytomegalovirus', 4, NULL),
(15484, NULL, 'IPR021171', NULL, 'Core histone macro-H2A', 'Core_histone_macro-H2A', 4, NULL),
(15485, NULL, 'IPR016800', NULL, 'Uncharacterised conserved protein UCP022080', 'UCP022080', 4, NULL),
(15486, NULL, 'IPR016483', NULL, 'Uncharacterised conserved protein UCP006404, peptidase M50/CBS', 'UCP006404_Pept_M50_CBS', 4, NULL),
(15487, NULL, 'IPR021021', NULL, 'Fibronectin-binding repeat, SSURE', 'Fibronectin-binding_SSURE', 7, NULL),
(15488, NULL, 'IPR021150', NULL, 'Ubiquinol-cytochrome c chaperone', 'Ubiq_cyt_c_chap', 3, NULL),
(15489, NULL, 'IPR023062', NULL, 'NADH dehydrogenase, subunit CD', 'NADH_DH_suCD', 4, NULL),
(15490, NULL, 'IPR021071', NULL, 'Low molecular weight S layer protein, N-terminal', 'Low_molc_weight_S-layer_N', 3, NULL),
(15491, NULL, 'IPR018556', NULL, 'SPIN90/Ldb17, leucine-rich domain', 'SPIN90/Ldb17_LRD', 3, NULL),
(15492, NULL, 'IPR016475', NULL, 'Phosphate acetyltransferase, bacteria', 'P-Actrans_bac', 4, NULL),
(15493, NULL, 'IPR022263', NULL, 'KxYKxGKxW signal peptide', 'KxYKxGKxW', 2, NULL),
(15494, NULL, 'IPR022292', NULL, 'Conserved hypothetical protein CHP03843', 'CHP03843', 4, NULL),
(15495, NULL, 'IPR023079', NULL, 'Sedoheptulose-1,7-bisphosphatase', 'SBPase', 4, NULL),
(15496, NULL, 'IPR022626', NULL, 'Protein of unknown function DUF2740', 'DUF2740', 4, NULL),
(15497, NULL, 'IPR022279', NULL, 'Pup--protein ligase', 'Pup_ligase', 4, NULL),
(15498, NULL, 'IPR016454', NULL, 'Cysteine desulfurase', 'Cysteine_dSase', 4, NULL),
(15499, NULL, 'IPR035225', NULL, 'Protein of unknown function DUF5338', 'DUF5338', 4, NULL),
(15500, NULL, 'IPR016779', NULL, 'Radical SAM enzyme, MSMEG0568', 'rSAM_MSMEG0568', 4, NULL),
(15501, NULL, 'IPR022264', NULL, 'Microcyclamide/patellamide bacteriocin family, leader peptide', 'Microcy/ptell_bactrcn_lead_pep', 3, NULL),
(15502, NULL, 'IPR018584', NULL, 'Glycosyltransferase family 87', 'GT87', 4, NULL),
(15503, NULL, 'IPR020977', NULL, 'Beta-casein-like', 'Beta-casein-like', 4, NULL),
(15504, NULL, 'IPR018989', NULL, 'Phage tail tube protein', 'DUF2001', 4, NULL),
(15505, NULL, 'IPR017575', NULL, 'CRISPR-associated helicase, CYANO-type', 'CRISPR-assoc_helicase_CYANO', 4, NULL),
(15506, NULL, 'IPR020046', NULL, '5''-3'' exonuclease, alpha-helical arch, N-terminal', '5-3_exonucl_a-hlix_arch_N', 3, NULL),
(15507, NULL, 'IPR023248', NULL, 'Cattle cerebrum and skeletal muscle-specific protein 1', 'CCSMST1', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(15508, NULL, 'IPR034673', NULL, 'Maternal embryonic leucine zipper kinase, catalytic domain', 'MELK', 3, NULL),
(15509, NULL, 'IPR019357', NULL, 'Short coiled-coil protein', 'SCOC', 4, NULL),
(15510, NULL, 'IPR018992', NULL, 'Thrombin light chain', 'Thrombin_light_chain', 3, NULL),
(15511, NULL, 'IPR023145', NULL, 'YfbU, helix-hairpin domain superfamily', 'YfbU_helix-hairpin_sf', 5, NULL),
(15512, NULL, 'IPR017593', NULL, 'Allantoinase', 'Allantoinase', 4, NULL),
(15513, NULL, 'IPR020982', NULL, 'Bacteriophage T4, GpT, holin', 'Phage_T4_GpT_holin', 4, NULL),
(15514, NULL, 'IPR022399', NULL, 'Helicase/secretion neighbourhood ATPase', 'HlxAse/secretion_ATPase', 4, NULL),
(15515, NULL, 'IPR018597', NULL, 'Bacteriophage Tuc2009, YjcQ', 'Phage_Tuc2009_YjcQ', 4, NULL),
(15516, NULL, 'IPR022336', NULL, 'Neurogenic locus notch homolog protein 2', 'Notch_2', 4, NULL),
(15517, NULL, 'IPR023235', NULL, 'FAM105', 'FAM105', 4, NULL),
(15518, NULL, 'IPR019366', NULL, 'Clusterin-associated protein-1', 'Clusterin-associated_protein-1', 4, NULL),
(15519, NULL, 'IPR017592', NULL, 'Pilus assembly, Flp-type CpaB', 'Pilus_assmbl_Flp-typ_CpaB', 4, NULL),
(15520, NULL, 'IPR023341', NULL, 'MABP domain', 'MABP', 3, NULL),
(15521, NULL, 'IPR022370', NULL, 'Phosphosulpholactate synthase', 'Arch_ComA', 4, NULL),
(15522, NULL, 'IPR018019', NULL, 'Luteovirus Orf2 putative replicase 1', 'Luteovirus_Orf2', 4, NULL),
(15523, NULL, 'IPR022361', NULL, 'Tumour necrosis factor receptor 11A', 'TNFR_11A', 4, NULL),
(15524, NULL, 'IPR022340', NULL, 'G protein-coupled receptor GCR1 putative', 'GPCR_GCR1_put', 4, NULL),
(15525, NULL, 'IPR023367', NULL, 'Peptidase M42, domain 2', 'Peptidase_M42_dom2', 5, NULL),
(15526, NULL, 'IPR019820', NULL, 'Sec-independent periplasmic protein translocase, conserved site', 'Sec-indep_translocase_CS', 2, NULL),
(15527, NULL, 'IPR022435', NULL, 'Surface-anchored repeat, actinobacteria', 'Surface-anchored_actinobac', 7, NULL),
(15528, NULL, 'IPR022410', NULL, 'ABC transporter, permease F420-0', 'ABC_transptr_permease_F420-0', 4, NULL),
(15529, NULL, 'IPR019372', NULL, 'Lipoma HMGIC fusion partner-like protein', 'LHFPL', 4, NULL),
(15530, NULL, 'IPR019003', NULL, 'APC membrane recruitment protein', 'AMER', 4, NULL),
(15531, NULL, 'IPR023184', NULL, 'Ubiquinol-cytochrome C reductase hinge domain', 'Ubol_cytC_Rdtase_hinge_dom', 3, NULL),
(15532, NULL, 'IPR020973', NULL, 'Packaging enzyme P4', 'Packaging_enz_P4', 4, NULL),
(15533, NULL, 'IPR019338', NULL, 'Ribosomal protein L35, mitochondrial', 'Ribosomal-L35_mit', 4, NULL),
(15534, NULL, 'IPR024303', NULL, 'Natural killer cell receptor 2B4, immunoglobulin domain', 'NK_rcpt_2B4_Ig_dom', 3, NULL),
(15535, NULL, 'IPR017576', NULL, 'CRISPR-associated protein Csc1', 'CRISPR-assoc_prot_Csc1', 4, NULL),
(15536, NULL, 'IPR017257', NULL, 'Spore germination protein GerPD, predicted', 'Spore_germination_GerPD_prd', 4, NULL),
(15537, NULL, 'IPR023331', NULL, 'Rhabdovirus nucleocapsid, C-terminal', 'Rhabdovirus_ncapsid_C', 5, NULL),
(15538, NULL, 'IPR017245', NULL, 'BLOC-1 complex, subunit 3', 'BLOC-1_complex_su-3', 4, NULL),
(15539, NULL, 'IPR022357', NULL, 'Major intrinsic protein, conserved site', 'MIP_CS', 2, NULL),
(15540, NULL, 'IPR019347', NULL, 'Axonemal dynein light chain', 'Axonemal_dynein_light_chain', 4, NULL),
(15541, NULL, 'IPR020953', NULL, 'Acyl-CoA dehydrogenase, N-terminal, bacteria', 'Acyl-CoA_DH_N_bac', 3, NULL),
(15542, NULL, 'IPR022373', NULL, 'KaiC domain-containing protein', 'KaiC_containing', 4, NULL),
(15543, NULL, 'IPR022466', NULL, 'Enriched in aromatic and glycine residues box', 'EAGR_box', 3, NULL),
(15544, NULL, 'IPR022422', NULL, 'Protein import receptor MAS20, metazoan', 'MAS20_rcpt_metazoan', 4, NULL),
(15545, NULL, 'IPR022459', NULL, 'Lysine-2,3-aminomutase', 'Lysine_aminomutase', 4, NULL),
(15546, NULL, 'IPR019038', NULL, 'DNA polymerase delta subunit 3', 'POLD3', 4, NULL),
(15547, NULL, 'IPR018457', NULL, 'LacY/RafB permease family, conserved site', 'LacY/RafB_perm_fam_CS', 2, NULL),
(15548, NULL, 'IPR017256', NULL, 'Methane monooxygenase component D', 'MmoD', 4, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(15549, NULL, 'IPR019014', NULL, 'Multivesicular body sorting factor 12', 'Mvb12', 3, NULL),
(15550, NULL, 'IPR022329', NULL, 'Tumour necrosis factor receptor 25', 'TNFR_25', 4, NULL),
(15551, NULL, 'IPR019005', NULL, 'Vacuolar R-SNARE Nyv1, longin domain', 'Vacuolar_R-SNAR_Nyv1_longi_dom', 3, NULL),
(15552, NULL, 'IPR022442', NULL, 'Parallel beta-helix repeat-containing domain', 'B-helix_rpt-cont_dom', 3, NULL),
(15553, NULL, 'IPR022323', NULL, 'Tumour necrosis factor receptor 11', 'TNFR_11', 4, NULL),
(15554, NULL, 'IPR019975', NULL, 'Transcription termination factor CPSF1, archaea', 'aCPSF1', 4, NULL),
(15555, NULL, 'IPR022426', NULL, 'Flagellum-specific ATP synthase FliI, clade 3', 'FliI_clade3', 4, NULL),
(15556, NULL, 'IPR023384', NULL, 'Bacteriocin, class IIa, conserved site', 'Bacteriocin_IIa_CS', 2, NULL),
(15557, NULL, 'IPR019963', NULL, 'Futalosine hydrolase', 'FL_hydrolase_MqnB', 4, NULL),
(15558, NULL, 'IPR023291', NULL, 'Af2093, N-terminal', 'Af2093-N', 5, NULL),
(15559, NULL, 'IPR019966', NULL, 'F420-dependent enzyme, PPOX class, family Rv3369, probable', 'F420-dep_enz_PPOX_Rv3369', 4, NULL),
(15560, NULL, 'IPR023338', NULL, 'Arterivirus NSP4 peptidase domain', 'Arterivirus_NSP4_peptidase', 3, NULL),
(15561, NULL, 'IPR017571', NULL, 'Cytochrome c nitrite reductase, small subunit', 'NrfH', 4, NULL),
(15562, NULL, 'IPR022304', NULL, 'Integrating conjugative element, PFGI-1, ParB', 'ICE_PFGI_1_ParB', 3, NULL),
(15563, NULL, 'IPR023336', NULL, 'RAG nonamer-binding domain', 'RAG_nonamer-bd_dom', 3, NULL),
(15564, NULL, 'IPR024012', NULL, 'DNA phosphorothioation system restriction enzyme, putative', 'Dnd_restrict_put', 4, NULL),
(15565, NULL, 'IPR023152', NULL, 'Ras GTPase-activating protein, conserved site', 'RasGAP_CS', 2, NULL),
(15566, NULL, 'IPR018589', NULL, 'Pheromone response, PrgU-like domain', 'Pheromone_resp_PrgU-like', 3, NULL),
(15567, NULL, 'IPR023340', NULL, 'UMA domain', 'UMA', 3, NULL),
(15568, NULL, 'IPR017578', NULL, 'Alpha-ribazole phosphatase, CobC', 'Ribazole_CobC', 4, NULL),
(15569, NULL, 'IPR022262', NULL, 'Lipoprotein, putative', 'Lipoprot_put', 4, NULL),
(15570, NULL, 'IPR023247', NULL, 'Dynein-f, intermediate chain IC97/Dnai7-like', 'IC97/Dnai7-like', 4, NULL),
(15571, NULL, 'IPR019375', NULL, 'Ribosomal protein S28, mitochondrial', 'Ribosomal_S28_mit', 4, NULL),
(15572, NULL, 'IPR019362', NULL, 'Methylmalonic aciduria and homocystinuria type D protein', 'MMADHC', 4, NULL),
(15573, NULL, 'IPR019017', NULL, 'Signal transduction histidine kinase RcsC, alpha-beta loop, C-terminal', 'Sig_transdc_His_kin_a/b-loop_C', 3, NULL),
(15574, NULL, 'IPR023099', NULL, 'Glycoside hydrolase, family 46, N-terminal', 'Glyco_hydro_46_N', 5, NULL),
(15575, NULL, 'IPR022462', NULL, 'Lysine-2,3-aminomutase-like', 'EpmB', 4, NULL),
(15576, NULL, 'IPR019015', NULL, 'HIRA B motif', 'HIRA_B_motif', 2, NULL),
(15577, NULL, 'IPR019036', NULL, 'Restriction endonuclease, type II, ApaLI', 'Restrct_endonuc_II_ApaLI', 4, NULL),
(15578, NULL, 'IPR023334', NULL, 'REKLES domain', 'REKLES_domain', 3, NULL),
(15579, NULL, 'IPR019344', NULL, 'Mitochondrial F1-F0 ATP synthase subunit F, predicted', 'F1F0-ATPsyn_F_prd', 4, NULL),
(15580, NULL, 'IPR022425', NULL, 'Flagellar export ATPase FliI, clade 2', 'FliI_clade2', 4, NULL),
(15581, NULL, 'IPR023249', NULL, 'FAM153', 'FAM153', 4, NULL),
(15582, NULL, 'IPR020952', NULL, 'Antitermination protein N, arginine-rich motif', 'Antiterm_prot_N_Arg-rich', 4, NULL),
(15583, NULL, 'IPR022342', NULL, 'Tumour necrosis factor receptor 19', 'TNFR_19', 4, NULL),
(15584, NULL, 'IPR019027', NULL, 'Pilus biogenesis CpaD-related', 'Pilus_biogenesis_CpaD-related', 4, NULL),
(15585, NULL, 'IPR020980', NULL, 'Menbrane protein HflK, N-terminal', 'Membrane_HflK_N', 3, NULL),
(15586, NULL, 'IPR023324', NULL, 'BH2638-like superfamily', 'BH2638-like_sf', 5, NULL),
(15587, NULL, 'IPR020053', NULL, 'Ribosome-binding factor A, conserved site', 'Ribosome-bd_factorA_CS', 2, NULL),
(15588, NULL, 'IPR020960', NULL, 'Aleutian mink disease parvovirus non-structural protein 1-3', 'ADV_NS1-3', 3, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(15589, NULL, 'IPR018601', NULL, 'Sulfolobus spindle-shape virus 1 F-112 protein-like', 'SSV1_F112-like', 4, NULL),
(15590, NULL, 'IPR019339', NULL, 'CBF1-interacting co-repressor CIR, N-terminal domain', 'CIR_N_dom', 3, NULL),
(15591, NULL, 'IPR023198', NULL, 'Phosphoglycolate phosphatase-like, domain 2', 'PGP-like_dom2', 5, NULL),
(15592, NULL, 'IPR022343', NULL, 'GCR1-cAMP receptor', 'GCR1-cAMP_receptor', 4, NULL),
(15593, NULL, 'IPR022848', NULL, 'Small heat shock protein IbpB', 'HSP20_IbpB', 4, NULL),
(15594, NULL, 'IPR019964', NULL, 'KH domain protein, archaea', 'KH_domain_protein_archaea', 4, NULL),
(15595, NULL, 'IPR022430', NULL, 'Conserved hypothetical protein CHP03684', 'CHP03684', 4, NULL),
(15596, NULL, 'IPR023093', NULL, 'ScpA-like, C-terminal', 'ScpA-like_C', 5, NULL),
(15597, NULL, 'IPR035346', NULL, 'Protein of unknown function NinD', 'NinD', 4, NULL),
(15598, NULL, 'IPR019021', NULL, 'E3 ubiquitin-protein ligase substrate receptor Mms22', 'Mms22', 4, NULL),
(15599, NULL, 'IPR022354', NULL, 'Pheromone-binding protein Gp-9', 'Pheromone-bd_protein_Gp-9', 4, NULL),
(15600, NULL, 'IPR023240', NULL, 'FAM175 family, BRISC complex, Abro1 subunit', 'FAM175_BRISC_cplx_Abro1_su', 4, NULL),
(15601, NULL, 'IPR019969', NULL, 'DNA-directed RNA polymerase subunit Rpo2', 'RNAP_Rpo2', 4, NULL),
(15602, NULL, 'IPR018984', NULL, 'Histidine kinase, N-terminal', 'Histidine_kinase_N', 3, NULL),
(15603, NULL, 'IPR022418', NULL, 'Porphobilinogen deaminase, C-terminal', 'Porphobilinogen_deaminase_C', 3, NULL),
(15604, NULL, 'IPR023342', NULL, 'APO domain', 'APO_dom', 3, NULL),
(15605, NULL, 'IPR019013', NULL, 'Vacuolar ATPase assembly integral membrane protein Vma21', 'Vma21', 4, NULL),
(15606, NULL, 'IPR019384', NULL, 'FHF complex subunit HOOK interacting protein', 'FHIP', 4, NULL),
(15607, NULL, 'IPR021025', NULL, 'Fanconi Anaemia group E protein, C-terminal', 'Fanconi_anaemia_gr_E_prot_C', 3, NULL),
(15608, NULL, 'IPR022338', NULL, 'Tumour necrosis factor receptor 13C', 'TNFR_13C', 4, NULL),
(15609, NULL, 'IPR023245', NULL, 'FAM138', 'FAM138', 4, NULL),
(15610, NULL, 'IPR019974', NULL, 'XPG conserved site', 'XPG_CS', 2, NULL),
(15611, NULL, 'IPR018592', NULL, 'Protein of unknown function DUF2024', 'DUF2024', 4, NULL),
(15612, NULL, 'IPR019378', NULL, 'GDP-fucose protein O-fucosyltransferase', 'GDP-Fuc_O-FucTrfase', 4, NULL),
(15613, NULL, 'IPR022265', NULL, 'Conserved hypothetical protein CHP03790', 'CHP03790', 4, NULL),
(15614, NULL, 'IPR023091', NULL, 'Metalloprotease catalytic domain superfamily, predicted', 'MetalPrtase_cat_dom_sf_prd', 5, NULL),
(15615, NULL, 'IPR019839', NULL, 'Verru/Chthon cassette protein C', 'Verru/Chthon_C', 4, NULL),
(15616, NULL, 'IPR023343', NULL, 'Penicillin amidase type, domain 1', 'Penicillin_amidase_dom1', 5, NULL),
(15617, NULL, 'IPR019028', NULL, 'Carbohydrate binding domain CBM49', 'CBM_49', 3, NULL),
(15618, NULL, 'IPR022328', NULL, 'Tumour necrosis factor receptor 7', 'TNFR_7', 4, NULL),
(15619, NULL, 'IPR017572', NULL, 'Cytochrome b558/566, subunit A', 'Cyt_b558/566_suA', 4, NULL),
(15620, NULL, 'IPR017582', NULL, 'tRNA 2-selenouridine synthase', 'SelU', 4, NULL),
(15621, NULL, 'IPR034021', NULL, 'Tumour necrosis factor receptor 5, N-terminal', 'TNFRSF5_N', 3, NULL),
(15622, NULL, 'IPR017600', NULL, 'Alpha-ketoglutarate dehydrogenase', 'Alpha-ketoglut_DH', 4, NULL),
(15623, NULL, 'IPR022420', NULL, 'Circadian clock protein, KaiC, archaea', 'Circ_KaiC_arc', 4, NULL),
(15624, NULL, 'IPR017586', NULL, 'Rieske iron-sulphur protein SoxL2', 'Rieske_Fe-S_SoxL2', 4, NULL),
(15625, NULL, 'IPR023144', NULL, 'Phenylalanine ammonia-lyase, shielding domain superfamily', 'Phe_NH3-lyase_shielding_dom_sf', 5, NULL),
(15626, NULL, 'IPR020045', NULL, 'DNA polymerase I-like, H3TH domain', 'DNA_polI_H3TH', 3, NULL),
(15627, NULL, 'IPR018982', NULL, 'RQC domain', 'RQC_domain', 3, NULL),
(15628, NULL, 'IPR019371', NULL, 'Uncharacterised domain KxDL', 'Uncharacterised_KxDL', 3, NULL),
(15629, NULL, 'IPR019368', NULL, 'Ribosomal protein S23/S29, mitochondrial', 'Ribosomal_S23/S29_mit', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(15630, NULL, 'IPR017577', NULL, 'Alpha-ribazole phosphatase, CobZ', 'Ribazole_CobZ', 4, NULL),
(15631, NULL, 'IPR022377', NULL, 'Small hydrophilic plant seed protein, conserved site', 'Sm_Hydphi_plant_seed_CS', 2, NULL),
(15632, NULL, 'IPR022384', NULL, 'Formiminotransferase catalytic domain superfamily', 'FormiminoTrfase_cat_dom_sf', 5, NULL),
(15633, NULL, 'IPR023100', NULL, 'D-aminoacylase, insert domain superfamily', 'D-aminoacylase_insert_dom_sf', 5, NULL),
(15634, NULL, 'IPR018593', NULL, 'tRNA-splicing endonuclease subunit Sen15', 'tRNA-endonuc_su_Sen15', 3, NULL),
(15635, NULL, 'IPR023232', NULL, 'Glycoside hydrolase, family 2, active site', 'Glyco_hydro_2_AS', 0, NULL),
(15636, NULL, 'IPR022397', NULL, 'Tyrosine decarboxylase, bacteria', 'Tyrosine_deCO2ase_bac', 4, NULL),
(15637, NULL, 'IPR022326', NULL, 'Insulin-like growth factor-binding protein 6', 'IGFBP-6', 4, NULL),
(15638, NULL, 'IPR023294', NULL, 'Tachylectin 2', 'Tachylectin2', 3, NULL),
(15639, NULL, 'IPR022312', NULL, 'DNA polymerase family X', 'DNA_pol_X', 4, NULL),
(15640, NULL, 'IPR019336', NULL, 'Intimal thickness related receptor, IRP', 'Intimal_thickness-rel_rcpt', 3, NULL),
(15641, NULL, 'IPR022350', NULL, 'Insulin-like growth factor', 'Insulin-like_growth_factor', 4, NULL),
(15642, NULL, 'IPR022966', NULL, 'Ribonuclease II/R, conserved site', 'RNase_II/R_CS', 2, NULL),
(15643, NULL, 'IPR023083', NULL, 'Glycerol-3-phosphate O-acyltransferase, alpha helical bundle, N-terminal', 'G3P_O-acylTrfase_N', 3, NULL),
(15644, NULL, 'IPR023333', NULL, 'Proteasome B-type subunit', 'Proteasome_suB-type', 4, NULL),
(15645, NULL, 'IPR017604', NULL, 'Benzoyl-CoA reductase, bzd-type, O subunit', 'Benzoyl-CoA_Rdtase_bzd_osu', 4, NULL),
(15646, NULL, 'IPR022441', NULL, 'Parallel beta-helix repeat-2', 'Para_beta_helix_rpt-2', 7, NULL),
(15647, NULL, 'IPR017597', NULL, 'Pyruvate dehydrogenase (acetyl-transferring) E1 component, alpha subunit, subgroup y', 'Pyrv_DH_E1_asu_subgrp-y', 4, NULL),
(15648, NULL, 'IPR022434', NULL, 'ABC transporter, LPXTG-anchor lipoprotein, actinobacteria', 'ABC_LPXTG_lipo_actinobac', 4, NULL),
(15649, NULL, 'IPR022465', NULL, 'Terminal organelle assembly protein TopJ', 'Termin_org_TopJ', 4, NULL),
(15650, NULL, 'IPR019004', NULL, 'Uncharacterised protein YqeY/Aim41', 'YqeY/Aim41', 4, NULL),
(15651, NULL, 'IPR019012', NULL, 'RNA cap guanine-N2 methyltransferase', 'RNA_cap_Gua-N2-MeTrfase', 4, NULL),
(15652, NULL, 'IPR022337', NULL, 'Inositol monophosphatase SuhB-like', 'Inositol_monophosphatase_SuhB', 4, NULL),
(15653, NULL, 'IPR017596', NULL, 'Pyruvate dehydrogenase E1 component subunit alpha/BCKADH E1-alpha', 'PdhA/BkdA', 4, NULL),
(15654, NULL, 'IPR023153', NULL, 'PSPTO4464-like domain superfamily', 'PSPTO4464-like_dom_sf', 5, NULL),
(15655, NULL, 'IPR019363', NULL, 'Lipid droplet-associated hydrolase', 'LDAH', 4, NULL),
(15656, NULL, 'IPR022474', NULL, 'Thiopurine S-methyltransferase, Se/Te detoxification', 'Thiopur_S-MeTfrase_Se/Te_detox', 4, NULL),
(15657, NULL, 'IPR019967', NULL, 'F420-dependent enzyme, PPOX class, family Rv0121, probable', 'F420-dep_enz_PPOX_Rv0121', 4, NULL),
(15658, NULL, 'IPR020985', NULL, 'Cell surface protein Shp, haem-binding domain', 'Cell_surface_Shp_haem-bd', 3, NULL),
(15659, NULL, 'IPR023332', NULL, 'Proteasome alpha-type subunit', 'Proteasome_alpha-type', 4, NULL),
(15660, NULL, 'IPR019365', NULL, 'TVP18/Calcium channel flower', 'TVP18/Ca-channel_flower', 4, NULL),
(15661, NULL, 'IPR023374', NULL, 'AttH-like domain superfamily', 'AttH-like_dom_sf', 5, NULL),
(15662, NULL, 'IPR022344', NULL, 'Gene transfer agent, major tail protein', 'GTA_major-tail', 4, NULL),
(15663, NULL, 'IPR022322', NULL, 'Insulin-like growth factor-binding protein 1', 'IGFBP1', 4, NULL),
(15664, NULL, 'IPR019389', NULL, 'Selenoprotein T', 'Selenoprotein_T', 4, NULL),
(15665, NULL, 'IPR023146', NULL, 'YfbU, alpha-helical bundle domain superfamily', 'YfbU_alpha-helical_sf', 5, NULL),
(15666, NULL, 'IPR035313', NULL, 'Transferrin-binding protein B, N-lobe handle', 'TbpB_N-lobe', 3, NULL),
(15667, NULL, 'IPR022438', NULL, 'Rickettsia palindromic element RPE5', 'RPE5', 3, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(15668, NULL, 'IPR019848', NULL, 'CRISPR-associated protein, Csx14', 'CRISPR-assoc_prot_Csx14', 4, NULL),
(15669, NULL, 'IPR019380', NULL, 'Casein kinase substrate, phosphoprotein PP28', 'Casein_kinase_sb_PP28', 3, NULL),
(15670, NULL, 'IPR022427', NULL, 'Uncharacterised protein MJ0570, ATP-binding', 'MJ0570_ATP-bd', 4, NULL),
(15671, NULL, 'IPR022421', NULL, 'Relaxin', 'Relaxin', 4, NULL),
(15672, NULL, 'IPR018599', NULL, 'Protein of unknown function DUF2026', 'DUF2026', 4, NULL),
(15673, NULL, 'IPR022417', NULL, 'Porphobilinogen deaminase, N-terminal', 'Porphobilin_deaminase_N', 3, NULL),
(15674, NULL, 'IPR023088', NULL, '3''5''-cyclic nucleotide phosphodiesterase', 'PDEase', 4, NULL),
(15675, NULL, 'IPR022436', NULL, 'Rickettsia palindromic element RPE2', 'RPE2', 3, NULL),
(15676, NULL, 'IPR023368', NULL, 'Uncharacterised protein family UPF0066, conserved site', 'UPF0066_cons_site', 2, NULL),
(15677, NULL, 'IPR019037', NULL, 'Restriction endonuclease, type II, Bsp6I', 'Restrct_endonuc_II_Bsp6I', 4, NULL),
(15678, NULL, 'IPR019349', NULL, 'Ribosomal protein S24/S35, mitochondrial, conserved domain', 'Ribosomal_S24/S35_mit', 3, NULL),
(15679, NULL, 'IPR022389', NULL, 'ParB-related, ThiF-related cassette, protein D', 'PRTRC_protein-D', 4, NULL),
(15680, NULL, 'IPR024006', NULL, 'Conserved hypothetical protein CHP04089', 'CHP04089', 4, NULL),
(15681, NULL, 'IPR021028', NULL, 'Homotrimeric ring hydroxylase, catalytic domain', 'Homotrim_ring_OHase_catalytic', 3, NULL),
(15682, NULL, 'IPR022850', NULL, 'UDP-4-amino-4-deoxy-L-arabinose-oxoglutarate aminotransferase, ArnB', 'ArnB_NH2Trfase', 4, NULL),
(15683, NULL, 'IPR022393', NULL, 'Conjugative transposon, TraJ', 'Conjugative_transposon_TraJ', 4, NULL),
(15684, NULL, 'IPR022402', NULL, 'F420-dependent oxidoreductase-predicted, MSMEG3544', 'F420_OxRdatse_MSMEG3544_pred', 4, NULL),
(15685, NULL, 'IPR019361', NULL, 'Histone PARylation factor 1', 'HPF1', 4, NULL),
(15686, NULL, 'IPR017599', NULL, 'DNA sulphur modification protein DndD', 'DNA_S_DndD', 4, NULL),
(15687, NULL, 'IPR022259', NULL, 'Accessory Sec system protein Asp3', 'Acessory_Sec_prot_Asp3', 4, NULL),
(15688, NULL, 'IPR023236', NULL, 'Inactive ubiquitin thioesterase OTULINL', 'OTULINL', 4, NULL),
(15689, NULL, 'IPR017591', NULL, 'Allantoate amidohydrolase', 'Allantoate_amidohydrolase', 4, NULL),
(15690, NULL, 'IPR019341', NULL, 'Alpha/gamma-adaptin-binding protein p34', 'Alpha/Gamma-adaptin-bd_p34', 4, NULL),
(15691, NULL, 'IPR019379', NULL, 'Gamma-secretase aspartyl protease complex, presenilin enhancer-2 subunit', 'Gamma_Secretase_Asp_P_PEN2', 4, NULL),
(15692, NULL, 'IPR017590', NULL, 'Ureidoglycolate dehydrogenase', 'Ureidoglycolate_dehydrogenase', 4, NULL),
(15693, NULL, 'IPR022362', NULL, 'Neurogenic locus notch homolog protein 1', 'Notch_1', 4, NULL),
(15694, NULL, 'IPR018588', NULL, 'Dihaem cytochrome c', 'Dihaem_cytochrome-c', 4, NULL),
(15695, NULL, 'IPR018999', NULL, 'RNA helicase UPF1, Cys/His rich zinc-binding domain', 'UPF1_CH/ZBD', 3, NULL),
(15696, NULL, 'IPR023197', NULL, 'Bacteriophage T4, Gp59, helicase assembly protein domain superfamily', 'Phage_T4_Gp59_dom_sf', 5, NULL),
(15697, NULL, 'IPR017570', NULL, 'Formate-dependent cytochrome c nitrite reductase, c552 subunit', 'Cyt_c_NO2Rdtase_formate-dep', 4, NULL),
(15698, NULL, 'IPR019009', NULL, 'Signal recognition particle receptor, beta subunit', 'SRP_receptor_beta_su', 4, NULL),
(15699, NULL, 'IPR022339', NULL, 'MHC class II-associated invariant chain', 'MHC_II-assoc_invar_chain', 4, NULL),
(15700, NULL, 'IPR022390', NULL, '4-hydroxybenzoate decarboxylase subunit C', 'HBDC', 4, NULL),
(15701, NULL, 'IPR023293', NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase, central domain superfamily', 'dGTP_triP_hydro_central_sf', 5, NULL),
(15702, NULL, 'IPR022301', NULL, 'Integral membrane protein YjbE', 'Integral_membrane_YjbE', 4, NULL),
(15703, NULL, 'IPR018981', NULL, 'Outer membrane porin G', 'Outer_membrane_porin_G', 4, NULL),
(15704, NULL, 'IPR018598', NULL, 'Domain of unknown function DUF2027', 'DUF2027', 3, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(15705, NULL, 'IPR022315', NULL, 'F420-dependent oxidoreductase-predicted, CPS4043', 'F420_OxRdatse_CPS4043_pred', 4, NULL),
(15706, NULL, 'IPR022324', NULL, 'Bacilysin exporter BacE, putative', 'Bacilysin_exporter_BacE_put', 4, NULL),
(15707, NULL, 'IPR019020', NULL, 'Cytochrome c-552/DMSO reductase-like, haem-binding domain', 'Cyt-c552/DMSO_Rdtase_haem-bd', 3, NULL),
(15708, NULL, 'IPR022424', NULL, 'Translation initiation factor 2, gamma subunit', 'TIF2_gsu', 4, NULL),
(15709, NULL, 'IPR022429', NULL, 'Alanine-tRNA ligase, archaea', 'Ala-tRNA_lgiase_arc', 4, NULL),
(15710, NULL, 'IPR024022', NULL, 'Transcription regulator HTH, surface antigen', 'Tscrpt_reg_HTH_surface_antigen', 4, NULL),
(15711, NULL, 'IPR019382', NULL, 'Translation initiation factor 3 complex subunit L', 'eIF3l', 4, NULL),
(15712, NULL, 'IPR023388', NULL, 'Bacteriocin class IIa domain superfamily', 'Bacteriocin_IIa_dom_sf', 5, NULL),
(15713, NULL, 'IPR017581', NULL, 'N-ATPase, AtpR subunit-like', 'AtpR-like', 4, NULL),
(15714, NULL, 'IPR023205', NULL, 'Thiol:disulphide interchange protein DsbA/DsbL', 'DsbA/DsbL', 4, NULL),
(15715, NULL, 'IPR023246', NULL, 'Autism susceptibility gene 2 protein', 'AUTS2', 4, NULL),
(15716, NULL, 'IPR022401', NULL, 'Cysteate synthase', 'Cysteate_synthase', 4, NULL),
(15717, NULL, 'IPR022433', NULL, 'Lipid kinase YegS', 'Lip_kinase_YegS', 4, NULL),
(15718, NULL, 'IPR022472', NULL, 'VPLPA-CTERM protein sorting domain', 'VPLPA-CTERM', 3, NULL),
(15719, NULL, 'IPR018988', NULL, 'Protein of unknown function DUF2000', 'DUF2000', 4, NULL),
(15720, NULL, 'IPR020955', NULL, 'Uncharacterised protein family Atu4866', 'Uncharacterised_Atu4866', 4, NULL),
(15721, NULL, 'IPR022395', NULL, 'Conserved hypothetical protein CHP03773, ABC transporter-like', 'CHP03773_ABC_transptr-like', 4, NULL),
(15722, NULL, 'IPR035311', NULL, 'Cystine knot toxin', 'Cys_Knot_tox', 4, NULL),
(15723, NULL, 'IPR022316', NULL, 'Tumour necrosis factor receptor 12', 'TNFR_12', 4, NULL),
(15724, NULL, 'IPR018292', NULL, 'A-kinase anchor 110kDa, C-terminal', 'AKAP_110_C', 3, NULL),
(15725, NULL, 'IPR019972', NULL, 'Ribosomal protein L14P,  conserved site', 'Ribosomal_L14P_CS', 2, NULL),
(15726, NULL, 'IPR022464', NULL, 'Streptococcal pilin isopeptide linker', 'Strep_pil_isopept_link', 3, NULL),
(15727, NULL, 'IPR017250', NULL, 'Histone deacetylase complex subunit SAP18', 'Hist_deAcase_cplx_SAP18', 4, NULL),
(15728, NULL, 'IPR020963', NULL, 'Arabinofuranosyltransferase AftA, N-terminal', 'ArabinofuranosylTrfase_AftA_N', 3, NULL),
(15729, NULL, 'IPR022456', NULL, 'PQQ-dependent catabolism-associated beta-propeller protein', 'PQQ_b_propeller', 4, NULL),
(15730, NULL, 'IPR019356', NULL, 'Menorin', 'Memorin', 4, NULL),
(15731, NULL, 'IPR022332', NULL, 'Tumour necrosis factor receptor 14', 'TNFR_14', 4, NULL),
(15732, NULL, 'IPR023278', NULL, 'Ethylene insensitive 3-like protein, DNA-binding domain superfamily', 'Ethylene_insens-like_DNA-bd', 5, NULL),
(15733, NULL, 'IPR018990', NULL, 'Proteinase inhibitor I42, chagasin', 'Prot_inh_I42_chagasin', 3, NULL),
(15734, NULL, 'IPR022355', NULL, 'Neurogenic locus Notch 4', 'Notch_4', 4, NULL),
(15735, NULL, 'IPR022596', NULL, 'G protein-coupled receptor GPR1, C-terminal', 'GPR1_C', 3, NULL),
(15736, NULL, 'IPR019010', NULL, 'Eukaryotic translation initiation factor 3 subunit E, N-terminal', 'eIF3e_N', 3, NULL),
(15737, NULL, 'IPR019024', NULL, 'Ribonuclease H2 subunit B, wHTH domain', 'RNase_H2_suB_wHTH', 3, NULL),
(15738, NULL, 'IPR019352', NULL, 'SREBP regulating gene protein', 'SPRING1', 4, NULL),
(15739, NULL, 'IPR019029', NULL, 'Type III secretion system, PrgH/EprH-like', 'T3SS_PrgH/EprH-like', 4, NULL),
(15740, NULL, 'IPR022400', NULL, 'Adhesin P1', 'Adhesin_P1', 4, NULL),
(15741, NULL, 'IPR022476', NULL, 'Spore protein YabP/YqfC', 'Spore_YabP/YqfC', 4, NULL),
(15742, NULL, 'IPR017253', NULL, 'Transcription factor SRY', 'SRY', 4, NULL),
(15743, NULL, 'IPR023162', NULL, 'Apc36109-like domain superfamily', 'Apc36109-like_dom_sf', 5, NULL),
(15744, NULL, 'IPR021203', NULL, 'Muellerian-inhibiting factor', 'Muellerian-inhibiting_factor', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(15745, NULL, 'IPR019377', NULL, 'NADH-ubiquinone oxidoreductase, subunit 10', 'NADH_UbQ_OxRdtase_su10', 4, NULL),
(15746, NULL, 'IPR035347', NULL, 'Chemokine-like protein U83', 'Putative_chemo_U83', 4, NULL),
(15747, NULL, 'IPR018994', NULL, 'Protein of unknown function DUF2002', 'DUF2002', 4, NULL),
(15748, NULL, 'IPR018594', NULL, 'Domain of unknown function DUF2023', 'DUF2023', 3, NULL),
(15749, NULL, 'IPR023210', NULL, 'NADP-dependent oxidoreductase domain', 'NADP_OxRdtase_dom', 3, NULL),
(15750, NULL, 'IPR019355', NULL, 'Cell cycle regulator Mat89Bb', 'Cell_cycle_regulator_Mat89Bb', 4, NULL),
(15751, NULL, 'IPR022463', NULL, 'Fructose 1-phosphate kinase', '1-PFruKinase', 4, NULL),
(15752, NULL, 'IPR022458', NULL, 'Conjugative coupling factor TraG/TraD', 'Conjugative_coupling_TraG/TraD', 4, NULL),
(15753, NULL, 'IPR023173', NULL, 'NADPH-cytochrome p450 reductase, FAD-binding, alpha-helical domain superfamily', 'NADPH_Cyt_P450_Rdtase_alpha', 5, NULL),
(15754, NULL, 'IPR022388', NULL, 'Conserved hypothetical protein CHP03808', 'CHP03808', 4, NULL),
(15755, NULL, 'IPR023101', NULL, 'AF1862-like domain superfamily', 'AF1862-like_dom_sf', 5, NULL),
(15756, NULL, 'IPR017595', NULL, '2-oxo-4-hydroxy-4-carboxy-5-ureidoimidazoline decarboxylase, type 2', 'OHCU_decarboxylase-2', 3, NULL),
(15757, NULL, 'IPR022411', NULL, 'C-type cytochrome, methanol metabolism-related', 'C-typ_cyt_methanol_metab-rel', 4, NULL),
(15758, NULL, 'IPR019374', NULL, 'Ribosomal protein S22, mitochondrial', 'Ribosomal_S22_mit', 4, NULL),
(15759, NULL, 'IPR022964', NULL, 'Translation initiation factor 2, alpha subunit, archaeal', 'TIF2_asu_arc', 4, NULL),
(15760, NULL, 'IPR023090', NULL, 'UPF0702, alpha/beta domain superfamily', 'UPF0702_alpha/beta_dom_sf', 5, NULL),
(15761, NULL, 'IPR023378', NULL, 'YheA/YmcA-like domain superfamily', 'YheA/YmcA-like_dom_sf', 5, NULL),
(15762, NULL, 'IPR022473', NULL, 'ABC transporter, Choline, ATP-binding subunit', 'ABC_trnsptr_Choline_ATP-bd', 4, NULL),
(15763, NULL, 'IPR023282', NULL, 'Hydroxymethylglutaryl-CoA reductase, N-terminal', 'HMG_CoA_Rdtase_N', 5, NULL),
(15764, NULL, 'IPR022334', NULL, 'Insulin-like growth factor II', 'IGF2', 4, NULL),
(15765, NULL, 'IPR018587', NULL, 'White spot syndrome virus (WSSV), Orf116/126, N-terminal', 'WSSV_Orf116/126_N', 3, NULL),
(15766, NULL, 'IPR019002', NULL, 'Ribosome biogenesis protein Nop16', 'Ribosome_biogenesis_Nop16', 4, NULL),
(15767, NULL, 'IPR019367', NULL, 'PDZ-binding protein, CRIPT', 'PDZ-binding_CRIPT', 4, NULL),
(15768, NULL, 'IPR022378', NULL, 'F420-dependent oxidoreductase-predicted, MSMEG2249', 'F420_OxRdatse_MSMEG2249_pred', 4, NULL),
(15769, NULL, 'IPR022415', NULL, 'ATP:guanido phosphotransferase active site', 'ATP-guanido_PTrfase_AS', 0, NULL),
(15770, NULL, 'IPR022471', NULL, 'Cysteine desulphurase, catalytic subunit, CsdA', 'Cys_desulphurase_CdsA', 4, NULL),
(15771, NULL, 'IPR017258', NULL, 'Chloroquine resistance transporter', 'Transprt_Chloroquine', 4, NULL),
(15772, NULL, 'IPR023288', NULL, 'Pa2218-like domain superfamily', 'Pa2218-like_dom_sf', 5, NULL),
(15773, NULL, 'IPR022396', NULL, 'ParB-related, ThiF-related cassette, ParB', 'PRTRC_ParB', 4, NULL),
(15774, NULL, 'IPR020986', NULL, 'Chemotaxis inhibitory protein', 'CHIPS', 4, NULL),
(15775, NULL, 'IPR022431', NULL, 'Cyclic dehypoxanthine futalosine synthase', 'Cyclic_DHFL_synthase_mqnC', 4, NULL),
(15776, NULL, 'IPR019364', NULL, 'Mediator complex, subunit Med8, fungi/metazoa', 'Mediatior_Med8_fun/met', 4, NULL),
(15777, NULL, 'IPR017255', NULL, 'Acetyltransferase, GNAT, predicted', 'AcTrfase_GNAT_prd', 4, NULL),
(15778, NULL, 'IPR023381', NULL, 'YP001051499.1-like domain superfamily', 'YP001051499.1-like_dom_sf', 5, NULL),
(15779, NULL, 'IPR020965', NULL, 'Aromatic prenyltransferase, CloQ-type', 'Prenyltransferase_CloQ', 4, NULL),
(15780, NULL, 'IPR019354', NULL, 'Nonsense-mediated mRNA decay factor SMG8/SMG9', 'SMG8/SMG9', 4, NULL),
(15781, NULL, 'IPR023373', NULL, 'YmcC-like superfamily', 'YmcC_sf', 5, NULL),
(15782, NULL, 'IPR020052', NULL, 'Ribosomal protein L31e, conserved site', 'Ribosomal_L31e_CS', 2, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(15783, NULL, 'IPR017246', NULL, 'Snapin', 'Snapin', 4, NULL),
(15784, NULL, 'IPR035303', NULL, 'Protein of unknown function DUF5364', 'DUF5364', 4, NULL),
(15785, NULL, 'IPR022383', NULL, 'Lactate/malate dehydrogenase, C-terminal', 'Lactate/malate_DH_C', 3, NULL),
(15786, NULL, 'IPR022266', NULL, 'Integrating conjugative element protein, PFL4697-type', 'Integr_conj_elem_PFL4697-type', 4, NULL),
(15787, NULL, 'IPR019035', NULL, 'Mediator complex, subunit Med12', 'Mediator_Med12', 3, NULL),
(15788, NULL, 'IPR020968', NULL, 'Bacteriocin class II, aureocin-like', 'Bacteriocin_II_aureocin-like', 4, NULL),
(15789, NULL, 'IPR022300', NULL, 'Polyphosphate:nucleotide phosphotransferase, PPK2', 'PPK2-rel_1', 4, NULL),
(15790, NULL, 'IPR022432', NULL, 'Aminodeoxyfutalosine synthase', 'MqnE', 4, NULL),
(15791, NULL, 'IPR023330', NULL, 'Rhabdovirus nucleocapsid, N-terminal', 'Rhabdovirus_ncapsid_N', 5, NULL),
(15792, NULL, 'IPR019840', NULL, 'Verru/Chthon cassette protein A', 'Verru/Chthon_A', 4, NULL),
(15793, NULL, 'IPR019965', NULL, 'PPOX class F420-dependent enzyme, family Rv2061, putative', 'PPOX_F420-dep_Rv2061_put', 4, NULL),
(15794, NULL, 'IPR020970', NULL, 'Bacteriocin class IIc', 'Bacteriocin_IIc', 4, NULL),
(15795, NULL, 'IPR019025', NULL, 'Cordon-bleu, ubiquitin-like domain', 'Cordon-bleu_ubiquitin_domain', 3, NULL),
(15796, NULL, 'IPR022454', NULL, 'Conserved hypothetical protein CHP03883, F420 biosynthesis associated', 'CHP03883_F420-assoc', 4, NULL),
(15797, NULL, 'IPR023084', NULL, 'Proteinase inhibitor I11, ecotin, gammaproteobacteria', 'Prot_inh_ecotin_gammaproteobac', 4, NULL),
(15798, NULL, 'IPR019348', NULL, 'Uncharacterised domain KLRAQ/TTKRSYEDQ, C-terminal', 'KLRAQ/TTKRSYEDQ_C', 3, NULL),
(15799, NULL, 'IPR022414', NULL, 'ATP:guanido phosphotransferase, catalytic domain', 'ATP-guanido_PTrfase_cat', 3, NULL),
(15800, NULL, 'IPR023370', NULL, 'TrmO-like, N-terminal domain', 'TrmO-like_N', 3, NULL),
(15801, NULL, 'IPR023339', NULL, 'CVC domain', 'CVC', 3, NULL),
(15802, NULL, 'IPR022394', NULL, 'Methylamine utilisation protein, MauG', 'Methylamine_utilis_MauG', 4, NULL),
(15803, NULL, 'IPR017254', NULL, 'Lipoprotein, LppL', 'Lipoprotein_LppL', 4, NULL),
(15804, NULL, 'IPR023208', NULL, 'NADPH-cytochrome P450 reductase', 'P450R', 4, NULL),
(15805, NULL, 'IPR022455', NULL, 'Methanol oxidation system protein MoxJ', 'Methanol_oxidation_MoxJ', 4, NULL),
(15806, NULL, 'IPR018600', NULL, 'Bacillus phage SPbeta, YonK', 'Phage_SP-beta_YonK', 3, NULL),
(15807, NULL, 'IPR022392', NULL, 'Anchored repeat-type ABC transporter, permease subunit', 'Anch_rpt-typ_ABC_trnsprt_perm', 4, NULL),
(15808, NULL, 'IPR019971', NULL, 'Ribosomal protein L14P, archaeal', 'Ribosomal_L14P_arc', 4, NULL),
(15809, NULL, 'IPR017589', NULL, 'CRISPR associated protein Csc3', 'CRISPR-assoc_prot_Csc3', 4, NULL),
(15810, NULL, 'IPR022303', NULL, 'Conjugative transfer ATPase', 'Conjug_Trfer_ATPase', 4, NULL),
(15811, NULL, 'IPR022413', NULL, 'ATP:guanido phosphotransferase, N-terminal', 'ATP-guanido_PTrfase_N', 3, NULL),
(15812, NULL, 'IPR023167', NULL, 'Yap1 redox domain superfamily', 'Yap1_redox_dom_sf', 5, NULL),
(15813, NULL, 'IPR018987', NULL, 'Protein of unknown function DUF1999', 'DUF1999', 4, NULL),
(15814, NULL, 'IPR018583', NULL, 'Cotton leaf-curl disease, DNA-betaC1', 'CLCuD_DNA-betaC1', 3, NULL),
(15815, NULL, 'IPR023175', NULL, 'Vta1/Callose synthase, N-terminal domain superfamily', 'Vta1/CALS_N_sf', 5, NULL),
(15816, NULL, 'IPR018996', NULL, 'Man1/Src1, C-terminal', 'MSC', 3, NULL),
(15817, NULL, 'IPR023380', NULL, 'DsbB-like superfamily', 'DsbB-like_sf', 5, NULL),
(15818, NULL, 'IPR017573', NULL, 'Cytochrome b558/566, subunit B', 'Cyt_b558/566_suB', 4, NULL),
(15819, NULL, 'IPR022416', NULL, 'Prion/Doppel protein, beta-ribbon domain', 'Prion/Doppel_prot_b-ribbon_dom', 3, NULL),
(15820, NULL, 'IPR019838', NULL, 'Verru/Chthon cassette protein B', 'Verru/Chthon_B', 4, NULL),
(15821, NULL, 'IPR019837', NULL, 'Conserved hypothetical protein CHP02597', 'CHP02597', 4, NULL),
(15822, NULL, 'IPR023243', NULL, 'FAM25', 'FAM25', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(15823, NULL, 'IPR019381', NULL, 'Phosphofurin acidic cluster sorting protein 1', 'Phosphofurin_acidic_CS-1', 4, NULL),
(15824, NULL, 'IPR035401', NULL, 'Urocanase, C-terminal domain', 'Urocanase_C', 3, NULL),
(15825, NULL, 'IPR019034', NULL, 'Uncharacterised protein family UPF0390', 'UPF0390', 4, NULL),
(15826, NULL, 'IPR022333', NULL, 'Tumour necrosis factor receptor 19-like', 'TNFR_19-like', 4, NULL),
(15827, NULL, 'IPR022457', NULL, 'Aspartate-alanine antiporter', 'Asp_Ala_antiprt', 4, NULL),
(15828, NULL, 'IPR017588', NULL, 'Uric acid permease UacT-like', 'UacT-like', 4, NULL),
(15829, NULL, 'IPR021027', NULL, 'Transposase, putative, helix-turn-helix domain', 'Transposase_put_HTH', 3, NULL),
(15830, NULL, 'IPR022419', NULL, 'Porphobilinogen deaminase, dipyrromethane cofactor binding site', 'Porphobilin_deaminase_cofac_BS', 1, NULL),
(15831, NULL, 'IPR019011', NULL, 'Cryptic/Cripto, CFC domain', 'Cryptic/Cripto_CFC-dom', 3, NULL),
(15832, NULL, 'IPR021026', NULL, 'Filamentous haemagglutinin family outer membrane protein, domain of unknown function DUF3739', 'Filamn_hemagglutn_DUF3739', 3, NULL),
(15833, NULL, 'IPR017249', NULL, 'Activator of apoptosis harakiri', 'Apoptosis_activator_harakiri', 4, NULL),
(15834, NULL, 'IPR019373', NULL, 'Ribosomal protein L51, mitochondrial', 'Ribosomal_L51_mit', 4, NULL),
(15835, NULL, 'IPR017251', NULL, 'Apoptotic protease-activating factor 1', 'Apaf-1', 4, NULL),
(15836, NULL, 'IPR018602', NULL, 'Gp37/putative cytoplasmic protein STM4215', 'Gp37/STM4215', 4, NULL),
(15837, NULL, 'IPR019026', NULL, 'Peptidase M64, IgA', 'Peptidase_M64_IgA', 4, NULL),
(15838, NULL, 'IPR023323', NULL, 'Tex-like domain superfamily', 'Tex-like_dom_sf', 5, NULL),
(15839, NULL, 'IPR023206', NULL, 'Bifunctional cytochrome P450/NADPH--cytochrome P450 reductase', 'Bifunctional_P450_P450_red', 4, NULL),
(15840, NULL, 'IPR023337', NULL, 'c-Kit-binding domain', 'KBD', 3, NULL),
(15841, NULL, 'IPR017574', NULL, 'CRISPR-associated protein Csc2', 'CRISPR-assoc_prot_Csc2', 4, NULL),
(15842, NULL, 'IPR022461', NULL, 'Arginine/ornithine antiporter', 'Arg/Orn_antiprt_ArcD', 4, NULL),
(15843, NULL, 'IPR018998', NULL, 'EndoU ribonuclease, C-terminal', 'EndoU_C', 3, NULL),
(15844, NULL, 'IPR022403', NULL, 'Alcohol ABC transporter, permease protein', 'Alc_ABC_transptr_permease', 4, NULL),
(15845, NULL, 'IPR017252', NULL, 'Dynein regulator LIS1', 'Dynein_regulator_LIS1', 4, NULL),
(15846, NULL, 'IPR019962', NULL, 'Conserved hypothetical protein CHP03663', 'CHP03663', 4, NULL),
(15847, NULL, 'IPR022391', NULL, 'Integrating conjugative element relaxase, PFGI-1 class', 'ICE_relaxase_PFGI-1', 3, NULL),
(15848, NULL, 'IPR021020', NULL, 'Adhesin, Dr family, signal peptide', 'Adhesin_Dr_signal_peptide', 6, NULL),
(15849, NULL, 'IPR022318', NULL, 'Tumour necrosis factor receptor 18', 'TNFR_18', 4, NULL),
(15850, NULL, 'IPR022302', NULL, 'Phosphoesterase, putative', 'Phosphoesterase_putative', 4, NULL),
(15851, NULL, 'IPR023238', NULL, 'FAM175 family', 'FAM175', 4, NULL),
(15852, NULL, 'IPR022313', NULL, 'Phenylalanine/histidine ammonia-lyases, active site', 'Phe/His_NH3-lyase_AS', 0, NULL),
(15853, NULL, 'IPR023302', NULL, 'Peptidase S9A, N-terminal domain', 'Pept_S9A_N', 3, NULL),
(15854, NULL, 'IPR023372', NULL, 'Restriction endonuclease, type II, EcoRII, N-terminal', 'Rest_endonuc_II_EcoRII_N', 3, NULL),
(15855, NULL, 'IPR022387', NULL, 'Carbohydrate ABC transporter substrate-binding, CPR0540', 'Bind_CPR0540', 4, NULL),
(15856, NULL, 'IPR024835', NULL, 'Synaptonemal complex protein 2-like', 'SYCP2-like', 4, NULL),
(15857, NULL, 'IPR022851', NULL, 'Translation factor SUI1 homolog, archaea', 'SUI1_arc', 4, NULL),
(15858, NULL, 'IPR023166', NULL, 'HI0933-like insert domain superfamily', 'HI0933-like_dom_sf', 5, NULL),
(15859, NULL, 'IPR023376', NULL, 'YqcC-like domain', 'YqcC-like_dom', 3, NULL),
(15860, NULL, 'IPR019006', NULL, 'Sterol regulatory element-binding protein 1, C-terminal', 'Sre1_C', 3, NULL),
(15861, NULL, 'IPR019016', NULL, 'CRISPR system endoribonuclease Csx1-like', 'Csx1-like', 4, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(15862, NULL, 'IPR022382', NULL, 'Mycoplasma peptidase DUF31', 'Mycoplasma_peptidase_DUF31', 3, NULL),
(15863, NULL, 'IPR023286', NULL, 'ABATE domain superfamily', 'ABATE_dom_sf', 5, NULL),
(15864, NULL, 'IPR018604', NULL, 'Regulatory protein YycH-like', 'YycI-like', 3, NULL),
(15865, NULL, 'IPR024007', NULL, '[FeFe]-hydrogenase maturation HydG, radical SAM', 'FeFe-hyd_mat_HydG', 4, NULL),
(15866, NULL, 'IPR022359', NULL, 'Aminoglycoside phosphotransferase, bacteria', 'Aminoglycoside_PTrfase_bact', 3, NULL),
(15867, NULL, 'IPR018983', NULL, 'U3 small nucleolar RNA-associated protein 15, C-terminal', 'U3_snoRNA-assocProt_15_C', 3, NULL),
(15868, NULL, 'IPR019023', NULL, 'Lamin-B receptor of TUDOR domain', 'Lamin-B_rcpt_of_tudor', 3, NULL),
(15869, NULL, 'IPR022320', NULL, 'Tumour necrosis factor receptor 17', 'TNFR_17', 4, NULL),
(15870, NULL, 'IPR023237', NULL, 'Ubiquitin thioesterase otulin', 'Otulin', 4, NULL),
(15871, NULL, 'IPR023375', NULL, 'Acetoacetate decarboxylase domain superfamily', 'ADC_dom_sf', 5, NULL),
(15872, NULL, 'IPR035307', NULL, 'Beta-defensin 136/42', 'DEFB136/42', 4, NULL),
(15873, NULL, 'IPR022331', NULL, 'Neurogenic locus Notch 3', 'Notch_3', 4, NULL),
(15874, NULL, 'IPR024008', NULL, 'Conserved hypothetical protein CHP04090', 'CHP04090', 4, NULL),
(15875, NULL, 'IPR023155', NULL, 'Cytochrome c-552/4', 'Cyt_c-552/4', 3, NULL),
(15876, NULL, 'IPR018997', NULL, 'PUB domain', 'PUB_domain', 3, NULL),
(15877, NULL, 'IPR018995', NULL, 'RNA synthesis protein NSP10, coronavirus', 'RNA_synth_NSP10_CoV', 3, NULL),
(15878, NULL, 'IPR019351', NULL, 'Protein of unknown function DUF2039', 'DUF2039', 4, NULL),
(15879, NULL, 'IPR019041', NULL, 'SSXRD motif', 'SSXRD_motif', 2, NULL),
(15880, NULL, 'IPR019343', NULL, 'Uncharacterised domain KLRAQ/TTKRSYEDQ, N-terminal', 'Unchr_KLRAQ/TTKRSYEDQ_N', 3, NULL),
(15881, NULL, 'IPR022267', NULL, 'Accessory Sec system protein Asp2', 'Asp2', 4, NULL),
(15882, NULL, 'IPR022345', NULL, 'Bacteriophage 69, Orf23, major tail protein', 'Phage_69_Orf23_MTP', 4, NULL),
(15883, NULL, 'IPR022428', NULL, 'Diphthamide synthesis Dph2, archaea', 'Dph2_arc', 4, NULL),
(15884, NULL, 'IPR034812', NULL, 'Psi-factor producing oxygenase, N-terminal heme peroxidase domain', 'Ppo_N', 3, NULL),
(15885, NULL, 'IPR035269', NULL, '26S Proteasome non-ATPase regulatory subunit 9', 'PSMD9', 4, NULL),
(15886, NULL, 'IPR017584', NULL, 'Pyridine nucleotide-disulphide oxidoreductase family protein, N-terminal', 'Pyridine_nucleo_diS_OxRdtase_N', 3, NULL),
(15887, NULL, 'IPR035234', NULL, 'IgGFc-binding protein, N-terminal', 'IgGFc-bd_N', 3, NULL),
(15888, NULL, 'IPR017580', NULL, '2-oxo-4-hydroxy-4-carboxy-5-ureidoimidazoline decarboxylase, type 1', 'OHCU_decarboxylase-1', 3, NULL),
(15889, NULL, 'IPR023392', NULL, 'Mitochondrial outer membrane translocase complex, Tom20 domain superfamily', 'Tom20_dom_sf', 5, NULL),
(15890, NULL, 'IPR017583', NULL, 'Tagatose/fructose phosphokinase', 'Tagatose/fructose_Pkinase', 4, NULL),
(15891, NULL, 'IPR019039', NULL, 'T4 RNA ligase 1-like, N-terminal', 'T4-Rnl1-like_N', 3, NULL),
(15892, NULL, 'IPR035312', NULL, 'Satellite RNA 48kDa protein', 'SatRNA_48', 4, NULL),
(15893, NULL, 'IPR019376', NULL, 'Myeloid leukemia factor', 'Myeloid_leukemia_factor', 4, NULL),
(15894, NULL, 'IPR019392', NULL, 'Mitoguardin', 'Miga', 4, NULL),
(15895, NULL, 'IPR017244', NULL, 'Ribosomal RNA large subunit methyltransferase K/L', '23SrRNA_methyltr_KL', 4, NULL),
(15896, NULL, 'IPR022317', NULL, 'Tumour necrosis factor receptor 13B', 'TNFR_13B', 4, NULL),
(15897, NULL, 'IPR022439', NULL, 'Rickettsia palindromic element RPE4', 'RPE4', 3, NULL),
(15898, NULL, 'IPR017603', NULL, 'Benzoyl-CoA reductase, bzd-type, N subunit', 'Benzoyl-CoA_Rdtase_bzd_nsu', 4, NULL),
(15899, NULL, 'IPR022321', NULL, 'Insulin-like growth factor-binding protein family 1-6, chordata', 'IGFBP_1-6_chordata', 4, NULL),
(15900, NULL, 'IPR017585', NULL, 'Flagella basal body P-ring formation protein FlgA, C-terminal', 'Flag_basal_body_FlgA_C', 3, NULL),
(15901, NULL, 'IPR019968', NULL, 'Urea ABC transporter, substrate-binding protein', 'Urea_ABC_transptr_substrate-bd', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(15902, NULL, 'IPR019358', NULL, 'NEMP family', 'NEMP_fam', 4, NULL),
(15903, NULL, 'IPR022477', NULL, 'Sporulation protein YqfC', 'Spore_YqfC', 4, NULL),
(15904, NULL, 'IPR019345', NULL, 'ARMET, C-terminal', 'ARMET_C', 3, NULL),
(15905, NULL, 'IPR023244', NULL, 'Brefeldin A-sensitivity protein 4', 'Brefeldin_A-sensitivity_4', 4, NULL),
(15906, NULL, 'IPR022386', NULL, 'Carbohydrate ABC transporter, N-acetylglucosamine/diacetylchitobiose-binding protein', 'Chitin_NgcE', 4, NULL),
(15907, NULL, 'IPR022325', NULL, 'Tumour necrosis factor receptor 16', 'TNFR_16', 4, NULL),
(15908, NULL, 'IPR019008', NULL, 'ER membrane protein complex subunit 7, beta-sandwich domain', 'EMC7_beta_sandwich', 3, NULL),
(15909, NULL, 'IPR022335', NULL, 'G protein-coupled receptor 153', 'GPR153', 4, NULL),
(15910, NULL, 'IPR023165', NULL, 'rRNA adenine dimethylase-like, C-terminal', 'rRNA_Ade_diMease-like_C', 5, NULL),
(15911, NULL, 'IPR019369', NULL, 'Protein-lysine N-methyltransferase Efm5/EEF1AKMT1', 'Efm5/EEF1AKMT1', 4, NULL),
(15912, NULL, 'IPR022818', NULL, 'Photosystem I Ycf3, assembly', 'PSI_Ycf3_assembly', 4, NULL),
(15913, NULL, 'IPR018605', NULL, 'Sororin protein', 'Sororin', 4, NULL),
(15914, NULL, 'IPR034736', NULL, 'Zinc finger C2H2 AKAP95-type', 'ZF_C2H2_AKAP95', 3, NULL),
(15915, NULL, 'IPR022470', NULL, '6-pyruvoyl tetrahydropterin synthase, cysteine active site', 'PTPS_Cys_AS', 0, NULL),
(15916, NULL, 'IPR019350', NULL, 'RNA polymerase I-specific transcription initiation factor RRN6-like', 'RNA_pol_I-sp_TIF_RRN6-like', 4, NULL),
(15917, NULL, 'IPR023230', NULL, 'Glycoside hydrolase, family 2, conserved site', 'Glyco_hydro_2_CS', 2, NULL),
(15918, NULL, 'IPR019370', NULL, 'E2F-associated phosphoprotein', 'E2F-assoc_phosphoprotein', 4, NULL),
(15919, NULL, 'IPR019346', NULL, '39S ribosomal protein L42, mitochondrial', 'MRPL42', 4, NULL),
(15920, NULL, 'IPR017248', NULL, 'HS1-associating protein X-1', 'HAX-1', 4, NULL),
(15921, NULL, 'IPR022440', NULL, 'Conserved hypothetical protein CHP03788', 'CHP03788', 4, NULL),
(15922, NULL, 'IPR022469', NULL, '6-pyruvoyl tetrahydropterin synthase, histidine active site', 'PTPS_His_AS', 0, NULL),
(15923, NULL, 'IPR022261', NULL, 'Ribosomal natural product, two-chain TOMM family', 'RNP_Burkhold', 4, NULL),
(15924, NULL, 'IPR022448', NULL, 'Quinoprotein dehydrogenase-associated', 'Quinoprotein_dehydrogenase', 4, NULL),
(15925, NULL, 'IPR022385', NULL, 'Rhs repeat-associated core', 'Rhs_assc_core', 3, NULL),
(15926, NULL, 'IPR018591', NULL, 'YorP protein', 'YorP', 4, NULL),
(15927, NULL, 'IPR019388', NULL, 'Fat storage-inducing transmembrane protein', 'FIT', 4, NULL),
(15928, NULL, 'IPR023085', NULL, 'UDP-N-acetyl-D-mannosaminuronic acid transferase', 'UDP-ManNAcA_Trfase_WecG', 4, NULL),
(15929, NULL, 'IPR019359', NULL, 'CCDC85 family', 'CCDC85', 4, NULL),
(15930, NULL, 'IPR034735', NULL, 'NEMO, Zinc finger', 'NEMO_ZF', 3, NULL),
(15931, NULL, 'IPR023087', NULL, 'Flagellar motor switch protein FliG, C-terminal', 'Flg_Motor_Flig_C', 3, NULL),
(15932, NULL, 'IPR022330', NULL, 'Tumour necrosis factor receptor 21', 'TNFR_21', 4, NULL),
(15933, NULL, 'IPR023379', NULL, 'BART domain', 'BART_dom', 3, NULL),
(15934, NULL, 'IPR022269', NULL, 'Conserved hypothetical protein CHP03806, HNE0200 family', 'CHP03806_HNE0200', 3, NULL),
(15935, NULL, 'IPR023390', NULL, 'Bacteriophage M13, G8P, capsid domain superfamily', 'Phage_M13_G8P_capsid_dom_sf', 5, NULL),
(15936, NULL, 'IPR019391', NULL, 'Storkhead-box protein, winged-helix domain', 'Storkhead-box_winged-helix', 3, NULL),
(15937, NULL, 'IPR024003', NULL, 'Putative luciferase-like monooxygenase, KPN01858', 'Luciferase-like_KPN01858', 4, NULL),
(15938, NULL, 'IPR024005', NULL, 'Colanic acid biosynthesis, acetyltransferase, WcaF', 'Colanic_acid_synth_WcaF', 4, NULL),
(15939, NULL, 'IPR023143', NULL, 'Mycolic acid cyclopropane synthase-like domain superfamily', 'Cyclopro_synthase-like_dom_sf', 5, NULL),
(15940, NULL, 'IPR019819', NULL, 'Carboxylesterase type B, conserved site', 'Carboxylesterase_B_CS', 2, NULL),
(15941, NULL, 'IPR017602', NULL, 'Cyclohexa-1,5-dienecarbonyl-CoA hydratase', 'Dienoyl_CoA_hydratase', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(15942, NULL, 'IPR019340', NULL, 'Histone acetyltransferases subunit 3', 'Histone_AcTrfase_su3', 4, NULL),
(15943, NULL, 'IPR022467', NULL, 'ABC transporter, ATP-binding subunit, PQQ-dependent alcohol dehydrogenase system', 'ABC_transprt_ATP-bd_su_PQQ', 4, NULL),
(15944, NULL, 'IPR035094', NULL, 'Histidine N-alpha-methyltransferase', 'EgtD', 4, NULL),
(15945, NULL, 'IPR019342', NULL, 'NADH:ubiquinone oxidoreductase, iron-sulphur subunit 5', 'NADH_UbQ_OxRdtase_FeS-su5', 4, NULL),
(15946, NULL, 'IPR022327', NULL, 'Insulin-like growth factor-binding protein 4', 'IGFBP-4', 4, NULL),
(15947, NULL, 'IPR022468', NULL, 'Phosphonatase-like hydrolase', 'PhnX-like', 4, NULL),
(15948, NULL, 'IPR019834', NULL, 'Glycoside hydrolase, family 8, conserved site', 'Glyco_hydro_8_CS', 2, NULL),
(15949, NULL, 'IPR023209', NULL, 'D-amino-acid oxidase', 'DAO', 4, NULL),
(15950, NULL, 'IPR034953', NULL, 'Regulator of G-protein signalling 4, RGS domain', 'RGS_RGS4', 3, NULL),
(15951, NULL, 'IPR022443', NULL, 'KaiC-related', 'KaiC-rel', 4, NULL),
(15952, NULL, 'IPR017587', NULL, 'Putative selenium-dependent hydroxylase accessory protein YqeC', 'YqeC', 4, NULL),
(15953, NULL, 'IPR020951', NULL, 'Mitochondrial import receptor subunit Tom22, fungi', 'Tom22_fungi', 4, NULL),
(15954, NULL, 'IPR023296', NULL, 'Glycosyl hydrolase, five-bladed beta-propellor domain superfamily', 'Glyco_hydro_beta-prop_sf', 5, NULL),
(15955, NULL, 'IPR035105', NULL, 'Deoxycytidylate deaminase domain', 'Deoxycytidylate_deaminase_dom', 3, NULL),
(15956, NULL, 'IPR019970', NULL, 'Ribosomal protein L4, archaea', 'Ribosomall_L4-archaea', 4, NULL),
(15957, NULL, 'IPR022341', NULL, 'Insulin-like growth factor I', 'IGF-I', 4, NULL),
(15958, NULL, 'IPR019007', NULL, 'WW domain binding protein 11', 'WW_dom-bd_prot_11', 4, NULL),
(15959, NULL, 'IPR022460', NULL, 'Conserved hyptotheical flavoprotein, PP4765', 'Flavoprotein_PP4765', 4, NULL),
(15960, NULL, 'IPR018993', NULL, 'FGFR1 oncogene partner (FOP), N-terminal dimerisation domain', 'FOP_dimerisation-dom_N', 3, NULL),
(15961, NULL, 'IPR020959', NULL, 'Arabinofuranosyltransferase AftA, C-terminal', 'ArabinofuranosylTrfase_AftA_C', 3, NULL),
(15962, NULL, 'IPR019337', NULL, 'Telomere length regulation protein, conserved domain', 'Telomere_length_regulation_dom', 3, NULL),
(15963, NULL, 'IPR017598', NULL, 'Sulphur transferase DndC, putative', 'SulphurTrfase_DndC_put', 4, NULL),
(15964, NULL, 'IPR034737', NULL, 'Translationally controlled tumour protein (TCTP) domain', 'TCTP', 3, NULL),
(15965, NULL, 'IPR023086', NULL, 'Phosphoglycerate mutase, GpmB, probable', 'Phosphoglycerate_mutase_GpmB', 4, NULL),
(15966, NULL, 'IPR022379', NULL, '11-S seed storage protein, conserved site', '11S_seedstore_CS', 2, NULL),
(15967, NULL, 'IPR017247', NULL, 'UBX domain-containing protein 8', 'UBXN8', 4, NULL),
(15968, NULL, 'IPR023089', NULL, 'YozE SAM-like domain', 'YozE_SAM-like', 3, NULL),
(15969, NULL, 'IPR022380', NULL, 'Glutamyl-Q tRNA(Asp) synthetase', 'Glu-Q_tRNA(Asp)_Synthase', 4, NULL),
(15970, NULL, 'IPR022475', NULL, 'Uncharacterised protein family UPF0273, KaiC-like', 'UPF0273_KaiC-like', 4, NULL),
(15971, NULL, 'IPR035316', NULL, 'Transferrin-binding protein B, C-lobe handle domain', 'TbpB_C-lobe', 3, NULL),
(15972, NULL, 'IPR018586', NULL, 'Brinker DNA-binding domain', 'Brinker_DNA-bd', 3, NULL),
(15973, NULL, 'IPR022308', NULL, 'Synaptic vesicle protein SV2', 'SV2', 4, NULL),
(15974, NULL, 'IPR019385', NULL, 'Phosphorylated adapter RNA export protein, RNA-binding domain', 'PHAX_RNA-binding_domain', 3, NULL),
(15975, NULL, 'IPR035345', NULL, 'Viral Protein E7', 'E7R', 3, NULL),
(15976, NULL, 'IPR034892', NULL, 'NADPH oxidase regulator NoxR, PB1 domain', 'PB1_NoxR', 3, NULL),
(15977, NULL, 'IPR021031', NULL, 'Hyphally-regulated cell wall protein, N-terminal', 'Hyphal-reg_cell_wall_N', 3, NULL),
(15978, NULL, 'IPR022319', NULL, 'Tumour necrosis factor receptor 27', 'TNFR_27', 4, NULL),
(15979, NULL, 'IPR035304', NULL, 'Acyl homoserine lactone synthase', 'AHL_synthase', 4, NULL),
(15980, NULL, 'IPR019387', NULL, 'Uncharacterised domain SAYSvFN', 'Uncharacterised_SAYSvFN', 3, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(15981, NULL, 'IPR022437', NULL, 'Rickettsia palindromic element RPE3', 'RPE3', 3, NULL),
(15982, NULL, 'IPR019018', NULL, 'Rab-binding domain FIP-RBD', 'Rab-bd_FIP-RBD', 3, NULL),
(15983, NULL, 'IPR034802', NULL, 'NADPH-dependent butanol dehydrogenase', 'NADPH_BDH', 4, NULL),
(15984, NULL, 'IPR035232', NULL, 'Protein of unknown function DUF5347', 'DUF5347', 4, NULL),
(15985, NULL, 'IPR017459', NULL, 'Glycosyl transferase family 3, N-terminal domain', 'Glycosyl_Trfase_fam3_N_dom', 3, NULL),
(15986, NULL, 'IPR023383', NULL, 'Ferredoxin, chloroplast transit peptide', 'Ferredoxin_transit_pept', 3, NULL),
(15987, NULL, 'IPR018590', NULL, 'Uncharacterised domain YvfG', 'Uncharacterised_YvfG', 3, NULL),
(15988, NULL, 'IPR019019', NULL, 'H-type lectin domain', 'H-type_lectin_domain', 3, NULL),
(15989, NULL, 'IPR022314', NULL, 'Tyrosine 2,3-aminomutase, putative', 'Tyr_aminomutase', 4, NULL),
(15990, NULL, 'IPR019973', NULL, 'Flap structure-specific endonuclease, archaea', 'Flap_structure-sp_endonuc_arc', 4, NULL),
(15991, NULL, 'IPR023391', NULL, 'Protein translocase SecE domain superfamily', 'Prot_translocase_SecE_dom_sf', 5, NULL),
(15992, NULL, 'IPR018585', NULL, 'Metaviral G glycoprotein', 'Metaviral_G_glycop', 3, NULL),
(15993, NULL, 'IPR017601', NULL, 'DGQHR-containing domain', 'DGQHR-contain_dom', 3, NULL),
(15994, NULL, 'IPR023241', NULL, 'FAM175 family, plant', 'FAM175_plant', 4, NULL),
(15995, NULL, 'IPR019383', NULL, 'Golgin subfamily A member 7/ERF4', 'Golgin_A_7/ERF4', 3, NULL),
(15996, NULL, 'IPR024015', NULL, 'Pyridoxamine 5''-phosphate oxidase, probable FMN-dependent, Alr4036 family', 'Pyridox_Oxase_FMN-dep_Alr4036', 4, NULL),
(15997, NULL, 'IPR035236', NULL, 'RNA chaperone ProQ, C-terminal', 'ProQ_C', 3, NULL),
(15998, NULL, 'IPR023239', NULL, 'FAM175 family, BRCA1-A complex, Abraxas 1 subunit', 'FAM175_Abraxas1', 4, NULL),
(15999, NULL, 'IPR022311', NULL, 'DNA polymerase/3''-5'' exonuclease PolX-like', 'PolX-like', 4, NULL),
(16000, NULL, 'IPR017259', NULL, 'Uncharacterised conserved protein UCP037672', 'UCP037672', 4, NULL),
(16001, NULL, 'IPR023424', NULL, 'Oxaloacetate decarboxylase, gamma chain', 'OadG', 4, NULL),
(16002, NULL, 'IPR023596', NULL, 'Peptidase PrsW, archaeal/bacterial', 'Peptidase_PrsW_arch/bac', 4, NULL),
(16003, NULL, 'IPR022568', NULL, 'Protein of unknown function DUF2824', 'DUF2824', 4, NULL),
(16004, NULL, 'IPR023507', NULL, 'Serine/threonine protein kinase PknD', 'Ser/Thr_kinase_PknD', 4, NULL),
(16005, NULL, 'IPR022543', NULL, 'Protein of unknown function DUF2572', 'DUF2572', 4, NULL),
(16006, NULL, 'IPR020082', NULL, 'S-adenosyl-L-homocysteine hydrolase, conserved site', 'S-Ado-L-homoCys_hydrolase_CS', 2, NULL),
(16007, NULL, 'IPR023403', NULL, 'Uncharacterised protein MG237, N-terminal', 'Uncharacterised_MG237_N', 5, NULL),
(16008, NULL, 'IPR023513', NULL, 'Quinolinate synthase A, type 1', 'Quinolinate_synth_A_type1', 4, NULL),
(16009, NULL, 'IPR034430', NULL, 'Protein PSY', 'PSY', 4, NULL),
(16010, NULL, 'IPR023431', NULL, 'Photosystem II PsbX, type 1 subfamily', 'PSII_PsbX_type_1_subfam', 4, NULL),
(16011, NULL, 'IPR022518', NULL, 'Aspartate 4-decarboxylase', 'Aspartate_4-decarboxylase', 4, NULL),
(16012, NULL, 'IPR023096', NULL, 'Phosphoglucose isomerase, C-terminal', 'G6P_Isomerase_C', 5, NULL),
(16013, NULL, 'IPR023405', NULL, 'DNA topoisomerase, type IA, core domain', 'Topo_IA_core_domain', 5, NULL),
(16014, NULL, 'IPR023400', NULL, 'DNA recombination and repair protein RecA, C-terminal', 'RecA_C', 5, NULL),
(16015, NULL, 'IPR016832', NULL, 'Uncharacterised conserved protein UCP025926, globin-related', 'UCP025926_globin-rel', 4, NULL),
(16016, NULL, 'IPR023406', NULL, 'DNA topoisomerase, type IA, active site', 'Topo_IA_AS', 0, NULL),
(16017, NULL, 'IPR018627', NULL, 'Elongator complex protein 6', 'ELP6', 4, NULL),
(16018, NULL, 'IPR022519', NULL, 'Gloeobacter/Verrucomicrobia repeat', 'Gloeo/Verruco_rpt', 7, NULL),
(16019, NULL, 'IPR022504', NULL, 'Exosortase, archaea', 'Exosortase_arc', 4, NULL),
(16020, NULL, 'IPR018630', NULL, 'RZZ complex, subunit Zwilch', 'Zwilch', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(16021, NULL, 'IPR035241', NULL, 'Protein of unknown function DUF5442', 'DUF5442', 4, NULL),
(16022, NULL, 'IPR017613', NULL, '6-oxocyclohex-1-ene-1-carbonyl-CoA hydrolase', 'Dearomat_hydrolase', 4, NULL),
(16023, NULL, 'IPR023473', NULL, 'AMMECR1', 'AMMECR1', 4, NULL),
(16024, NULL, 'IPR018622', NULL, 'DNA damage checkpoint protein, Lcd1', 'DNA_damage_chkpnt_Lcd1', 4, NULL),
(16025, NULL, 'IPR035478', NULL, 'SH3PXD2B, SH3 domain 2', 'SH3PXD2B_SH3_2', 3, NULL),
(16026, NULL, 'IPR021199', NULL, 'Cytadherence high molecular weight protein 1 N-terminal', 'Cytadherence_HMW-1_N', 3, NULL),
(16027, NULL, 'IPR016495', NULL, 'p53 negative regulator Mdm2/Mdm4', 'p53_neg-reg_MDM_2/4', 4, NULL),
(16028, NULL, 'IPR016494', NULL, '5''-3'' exoribonuclease 1', '5_3_exoribonuclease_1', 4, NULL),
(16029, NULL, 'IPR023490', NULL, 'HTH-type transcriptional regulator ArgP, Gammaproteobacteria', 'ArgP_Gammaproteobact', 4, NULL),
(16030, NULL, 'IPR020081', NULL, 'SsrA-binding protein, conserved site', 'SsrA-bd_prot_CS', 2, NULL),
(16031, NULL, 'IPR016518', NULL, 'Alpha-L-fucosidase', 'Alpha-L-fucosidase', 4, NULL),
(16032, NULL, 'IPR022486', NULL, 'Polyphosphate kinase 2, PA0141', 'PPK2_PA0141', 4, NULL),
(16033, NULL, 'IPR022567', NULL, 'Glycosyl hydrolase, C-terminal (DUF3459)', 'DUF3459', 3, NULL),
(16034, NULL, 'IPR022573', NULL, 'Protein of unknown function DUF2887', 'DUF2887', 4, NULL),
(16035, NULL, 'IPR023464', NULL, 'DNA-directed RNA polymerase subunit Rpo12', 'Rpo12', 4, NULL),
(16036, NULL, 'IPR016874', NULL, 'Methyltransferase TcmP-like', 'TcmP-like', 4, NULL),
(16037, NULL, 'IPR021200', NULL, 'Conserved hypothetical integral membrane protein', 'CHIM_prot', 4, NULL),
(16038, NULL, 'IPR016844', NULL, 'Uncharacterised conserved protein UCP026610', 'UCP026610', 4, NULL),
(16039, NULL, 'IPR017265', NULL, 'rRNA-processing protein Fyv7, fungi', 'Fyv7_fungi', 4, NULL),
(16040, NULL, 'IPR022498', NULL, 'Tungstate ABC transporter, substrate-binding protein WtpA', 'ABC_trnspt_W-bd_WtpA', 4, NULL),
(16041, NULL, 'IPR023642', NULL, 'DNA primase large subunit PriL', 'DNA_primase_lsu_PriL', 4, NULL),
(16042, NULL, 'IPR022489', NULL, 'Polyphosphate:AMP phosphotransferase', 'PolyP_AMP_Tfrase', 4, NULL),
(16043, NULL, 'IPR020079', NULL, 'Peptidase A26, omptin, conserved site', 'Peptidase_A26_CS', 2, NULL),
(16044, NULL, 'IPR022508', NULL, 'ABC transporter, anchored repeat-type, ATP-binding subunit', 'ABC_trspt_anch-rpt_ATP-bd', 4, NULL),
(16045, NULL, 'IPR023474', NULL, 'Exosome complex component Rrp4', 'Rrp4', 4, NULL),
(16046, NULL, 'IPR016501', NULL, 'Uncharacterised conserved protein UCP007004', 'UCP007004', 4, NULL),
(16047, NULL, 'IPR022572', NULL, 'DNA replication/recombination mediator RecO, N-terminal', 'DNA_rep/recomb_RecO_N', 3, NULL),
(16048, NULL, 'IPR023608', NULL, 'Protein-glutamine gamma-glutamyltransferase, animal', 'Transglutaminase_animal', 4, NULL),
(16049, NULL, 'IPR016860', NULL, 'Cerberus', 'Cerberus', 4, NULL),
(16050, NULL, 'IPR023493', NULL, 'N-methyl-L-tryptophan oxidase MTOX', 'Me_Trp_Oxase_MTOX', 4, NULL),
(16051, NULL, 'IPR023500', NULL, 'Zinc transporter ZitB', 'Zn_transptr_ZitB', 4, NULL),
(16052, NULL, 'IPR023599', NULL, 'Membrane-associated protein TcaA', 'Mem_prot_TcaA', 4, NULL),
(16053, NULL, 'IPR016527', NULL, 'Origin recognition complex subunit 4', 'ORC4', 4, NULL),
(16054, NULL, 'IPR017611', NULL, 'Xanthine dehydrogenase E subunit', 'Xanthine_dehydrogenase_esu', 4, NULL),
(16055, NULL, 'IPR016509', NULL, 'Factor-induced gene 1 protein', 'Fig1', 4, NULL),
(16056, NULL, 'IPR017266', NULL, 'Cyclin-dependent kinase 2-associated protein 1/2', 'DOC_1/2', 4, NULL),
(16057, NULL, 'IPR024024', NULL, 'D-alanyl transfer protein DltB', 'DltB', 4, NULL),
(16058, NULL, 'IPR022581', NULL, 'Spt5 transcription elongation factor, N-terminal', 'Spt5_N', 3, NULL),
(16059, NULL, 'IPR018616', NULL, 'Protein GUCD1', 'GUCD1', 4, NULL),
(16060, NULL, 'IPR016873', NULL, 'Capsular polysaccharide biosynthesis protein, BcbE, predicted', 'Caps_polysacc_synth_BcbE_prd', 4, NULL),
(16061, NULL, 'IPR017277', NULL, 'Putative antitoxin VapB45-like', 'VapB45-like', 4, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(16062, NULL, 'IPR022488', NULL, 'Polyphosphate kinase-2-related', 'PPK2-related', 3, NULL),
(16063, NULL, 'IPR023435', NULL, 'D-tagatose-bisphosphate aldolase, class II, non-catalytic subunit KbaZ', 'TagBP_ald_KbaZ', 4, NULL),
(16064, NULL, 'IPR023471', NULL, 'Cytochrome c oxidase assembly protein CtaG/Cox11, domain superfamily', 'CtaG/Cox11_dom_sf', 5, NULL),
(16065, NULL, 'IPR023506', NULL, 'Trans-aconitate 2-methyltransferase', 'Trans-aconitate_MeTrfase', 4, NULL),
(16066, NULL, 'IPR023703', NULL, 'Membrane-bound lytic murein transglycosylase F', 'MltF', 4, NULL),
(16067, NULL, 'IPR023501', NULL, 'Proteasome-activating nucleotidase PAN', 'Nucleotidase_PAN', 4, NULL),
(16068, NULL, 'IPR023420', NULL, 'Tyrosine-protein kinase SYK/ZAP-70, inter-SH2 domain superfamily', 'Kinase_SYK/ZAP-70_inter-SH2_sf', 5, NULL),
(16069, NULL, 'IPR023610', NULL, 'Phosphatidylinositol-4-phosphate 5-kinase', 'PInositol-4-P-5-kinase', 4, NULL),
(16070, NULL, 'IPR022578', NULL, 'Flagellin, D2 domain', 'Flagellin_D2_dom', 3, NULL),
(16071, NULL, 'IPR018635', NULL, 'Uncharacterised protein family UPF0319', 'UPF0319', 4, NULL),
(16072, NULL, 'IPR017282', NULL, 'Histone deposition protein Asf1', 'Hist_deposition_Asf1', 4, NULL),
(16073, NULL, 'IPR022523', NULL, 'Flagellar regulator, FliZ', 'Flagellar_regulator_FliZ', 4, NULL),
(16074, NULL, 'IPR016511', NULL, 'Uncharacterised conserved protein UCP007248', 'UCP007248', 4, NULL),
(16075, NULL, 'IPR022549', NULL, 'Domain of unknown function DUF3627', 'DUF3627', 3, NULL),
(16076, NULL, 'IPR022537', NULL, 'TRSP domain', 'TRSP_dom', 3, NULL),
(16077, NULL, 'IPR016834', NULL, 'Uncharacterised conserved protein UCP026306', 'UCP026306', 4, NULL),
(16078, NULL, 'IPR018607', NULL, 'Chromosome transmission fidelity protein 8', 'Ctf8', 4, NULL),
(16079, NULL, 'IPR022509', NULL, 'Conjugation system ATPase, TraG', 'Conjugation_ATPase_TraG', 4, NULL),
(16080, NULL, 'IPR016842', NULL, 'Protein of unknown function UCP026546, HtH-CBS', 'UCP026546_HTH-CBS', 4, NULL),
(16081, NULL, 'IPR021079', NULL, 'Methanol-cobalamin methyltransferase, B subunit', 'MeOH-cob_MeTrfase_bsu', 4, NULL),
(16082, NULL, 'IPR016859', NULL, 'Uncharacterised conserved protein UCP207779', 'UCP207779', 4, NULL),
(16083, NULL, 'IPR017620', NULL, 'Cyclohexanecarboxyl-CoA dehydrogenase', 'Cyc-hxne_CoA_dehydrogenase', 4, NULL),
(16084, NULL, 'IPR035409', NULL, 'Seminal vesicle secretory protein 4/5/6', 'Svs4/5/6', 4, NULL),
(16085, NULL, 'IPR023486', NULL, 'Transcription factor TFIIB, conserved site', 'TFIIB_CS', 2, NULL),
(16086, NULL, 'IPR023499', NULL, 'L-ribulose-5-phosphate 4-epimerase UlaF', 'UlaF', 4, NULL),
(16087, NULL, 'IPR016541', NULL, 'Uncharacterised conserved protein UCP008505', 'UCP008505', 4, NULL),
(16088, NULL, 'IPR023540', NULL, 'Phosphopantetheine adenylyltransferase, archaea', 'PPAT_arch', 4, NULL),
(16089, NULL, 'IPR022501', NULL, 'Gallidermin ABC transporter, ATP-binding subunit', 'ABC_Gallidermin_ATP-bd', 4, NULL),
(16090, NULL, 'IPR022525', NULL, 'Beta-lysine N-acetyltransferase', 'GNAT_AblB', 4, NULL),
(16091, NULL, 'IPR023520', NULL, 'UV-endonuclease UvdE, bacterial', 'UvdE_bac', 4, NULL),
(16092, NULL, 'IPR020094', NULL, 'Pseudouridine synthase TruA/RsuA/RluB/E/F, N-terminal', 'TruA/RsuA/RluB/E/F_N', 5, NULL),
(16093, NULL, 'IPR022493', NULL, 'Integral membrane YkoY', 'CHP03716_TM_YkoY', 4, NULL),
(16094, NULL, 'IPR023576', NULL, 'UbiE/COQ5 methyltransferase, conserved site', 'UbiE/COQ5_MeTrFase_CS', 2, NULL),
(16095, NULL, 'IPR023472', NULL, 'Uncharacterised protein family MJ0810', 'Uncharacterised_MJ0810', 4, NULL),
(16096, NULL, 'IPR023395', NULL, 'Mitochondrial carrier domain superfamily', 'Mt_carrier_dom_sf', 5, NULL),
(16097, NULL, 'IPR017269', NULL, 'Biopolymer transport ExbB-like protein 1', 'Biopolymer_transpt_ExbB-like_1', 4, NULL),
(16098, NULL, 'IPR022499', NULL, 'ParB-related, ThiF-related cassette, protein A', 'PRTRC_protein-A', 4, NULL),
(16099, NULL, 'IPR023611', NULL, 'Ribosomal protein S23/S25, mitochondrial', 'Ribosomal_S23/S25_mit', 3, NULL),
(16100, NULL, 'IPR023437', NULL, 'Argininosuccinate synthase, type 2 subfamily', 'Arg_succ_synth_type2_subfam', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(16101, NULL, 'IPR016867', NULL, 'Glycine cleavage system transcriptional repressor', 'GcvR', 4, NULL),
(16102, NULL, 'IPR023609', NULL, 'Transcription regulator HTH, RhaS', 'Tscrpt_reg_HTH_RhaS', 4, NULL),
(16103, NULL, 'IPR018629', NULL, 'XK-related protein', 'XK-rel', 4, NULL),
(16104, NULL, 'IPR016843', NULL, 'S-adenosyl-L-methionine dependent adenine methyltransferase, bacteria, predicted', 'S-AdoMet-dep_Ade-MeTrfase_prd', 4, NULL),
(16105, NULL, 'IPR023525', NULL, 'Ureidoglycolate lyase, bacterial', 'Ureidogly_lyase_bac', 4, NULL),
(16106, NULL, 'IPR023616', NULL, 'Cytochrome c oxidase-like, subunit I domain', 'Cyt_c_oxase-like_su1_dom', 3, NULL),
(16107, NULL, 'IPR023607', NULL, 'Exodeoxyribonuclease I', 'Exodeoxyribonuclease_I', 4, NULL),
(16108, NULL, 'IPR016857', NULL, 'Uncharacterised conserved protein UCP027682, CUB, vWA', 'UCP027682_CUB_vWA', 4, NULL),
(16109, NULL, 'IPR016869', NULL, 'Uncharacterised conserved protein UCP028135, HipA-like', 'UCP028135_HipA-like', 4, NULL),
(16110, NULL, 'IPR022522', NULL, 'Flagellar motor stator, MotA', 'Flagellar_motor_stator_MotA', 4, NULL),
(16111, NULL, 'IPR023631', NULL, 'Amidase signature domain', 'Amidase_dom', 3, NULL),
(16112, NULL, 'IPR022521', NULL, 'Conserved hypothetical protein CHP03815, CpaE-like', 'CHP03815_CpaE-like', 4, NULL),
(16113, NULL, 'IPR023527', NULL, 'Adaptive-response sensory-kinase SasA', 'Kinase_SasA', 4, NULL),
(16114, NULL, 'IPR023514', NULL, 'Glyoxylate/hydroxypyruvate reductase A, Enterobacterales', 'GhrA_Enterobacterales', 4, NULL),
(16115, NULL, 'IPR018615', NULL, 'Ribosomal protein L55, mitochondrial', 'Ribosomal_L55_mit', 4, NULL),
(16116, NULL, 'IPR021197', NULL, 'Cross-wall-targeting lipoprotein motif', 'Cross-wall-target_lipo_motif', 2, NULL),
(16117, NULL, 'IPR023552', NULL, 'Hut operon regulatory protein HutP, bacillales', 'Regulatory_HutP_bacillales', 4, NULL),
(16118, NULL, 'IPR022481', NULL, 'Ribosomal protein L7Ae, archaea', 'Ribosomal_L7Ae_arc', 4, NULL),
(16119, NULL, 'IPR023432', NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit beta, archaeal', 'CO_DH/Ac-CoA_synth_bsu_arc', 4, NULL),
(16120, NULL, 'IPR021205', NULL, 'Lantibiotic ABC transporter permease subunit, SpaE/MutE', 'Lantibiotic_perm_SpaE/MutE', 4, NULL),
(16121, NULL, 'IPR023398', NULL, 'Translation Initiation factor eIF- 4e-like', 'TIF_eIF4e-like', 5, NULL),
(16122, NULL, 'IPR034250', NULL, 'Ssp2, RNA recognition motif', 'Ssp2_RRM', 3, NULL),
(16123, NULL, 'IPR023497', NULL, 'Acid shock protein', 'Acid_shock', 4, NULL),
(16124, NULL, 'IPR017274', NULL, 'Putative N-acetyltransferase YlbP', 'YlbP', 4, NULL),
(16125, NULL, 'IPR035407', NULL, 'Protein of unknown function DUF5399', 'DUF5399', 4, NULL),
(16126, NULL, 'IPR023677', NULL, 'UbiD decarboxylyase, bacteria', 'UbiD_bacteria', 4, NULL),
(16127, NULL, 'IPR017618', NULL, 'Dicarboxylate-CoA ligase PimA', 'Dicarboxylate-CoA_ligase_PimA', 4, NULL),
(16128, NULL, 'IPR016853', NULL, 'S-adenosyl-L-methionine binding protein, YMR209C, predicted', 'S-AdoMet-bd_YMR209C_prd', 4, NULL),
(16129, NULL, 'IPR022565', NULL, 'Protein of unknown function DUF2608', 'DUF2608', 4, NULL),
(16130, NULL, 'IPR018633', NULL, 'Domain of unknown function DUF2357', 'DUF2357', 3, NULL),
(16131, NULL, 'IPR016540', NULL, 'Uncharacterised conserved protein UCP008459', 'UCP008459', 4, NULL),
(16132, NULL, 'IPR022496', NULL, 'tRNA threonylcarbamoyl adenosine modification protein TsaB', 'T6A_TsaB', 4, NULL),
(16133, NULL, 'IPR022560', NULL, 'Domain of unknown function DUF3473', 'DUF3473', 3, NULL),
(16134, NULL, 'IPR020054', NULL, 'Proteinase inhibitor I16, Streptomyces subtilisin-type inhibitor, conserved site', 'Prot_inh_SSI_I16_CS', 2, NULL),
(16135, NULL, 'IPR020057', NULL, 'Ribosomal protein L25, beta domain', 'Ribosomal_L25_b-dom', 3, NULL),
(16136, NULL, 'IPR021196', NULL, 'PdxT/SNO family, conserved site', 'PdxT/SNO_CS', 2, NULL),
(16137, NULL, 'IPR023504', NULL, 'Bacteriohemerythrin-like protein', 'Bacteriohemerythrin-like', 4, NULL),
(16138, NULL, 'IPR018613', NULL, 'Ccdc97-like', 'Ccdc97-like', 4, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(16139, NULL, 'IPR022480', NULL, 'F420-dependent oxidoreductase, MSMEG2906', 'F420_MSMEG2906', 4, NULL),
(16140, NULL, 'IPR016872', NULL, 'Uncharacterised conserved protein UCP028160', 'UCP028160', 4, NULL),
(16141, NULL, 'IPR017606', NULL, '4-hydroxybenzoyl-CoA reductase, gamma subunit', '4hydrxbenzoyl-CoA_Rdtase_gsu', 4, NULL),
(16142, NULL, 'IPR023404', NULL, 'Radical SAM, alpha/beta horseshoe', 'rSAM_horseshoe', 5, NULL),
(16143, NULL, 'IPR035479', NULL, 'SH3PXD2B, SH3 domain 3', 'SH3PXD2B_SH3_3', 3, NULL),
(16144, NULL, 'IPR017614', NULL, '6-hydroxycyclohex-1-ene-1-carbonyl-CoA dehydrogenase', 'Dearomat_deydrogenase', 4, NULL),
(16145, NULL, 'IPR016858', NULL, 'Class V SAM-dependent methyltransferases', 'Hist_H4-K20_MeTrfase', 4, NULL),
(16146, NULL, 'IPR022528', NULL, '6-phosphogluconolactonase, YbhE-type', '6-phosphogluconolactonase_YbhE', 4, NULL),
(16147, NULL, 'IPR016871', NULL, 'MSHA biogenesis protein, MshI', 'MSHA_biogenesis_MshI', 4, NULL),
(16148, NULL, 'IPR023509', NULL, 'D-aminoacyl-tRNA deacylase-like superfamily', 'DTD-like_sf', 5, NULL),
(16149, NULL, 'IPR023479', NULL, 'Pyridoxine/pyridoxal/pyridoxamine kinase', 'PdxK', 4, NULL),
(16150, NULL, 'IPR035060', NULL, 'Serine/threonine kinase 25, catalytic domain', 'STK_STK25', 3, NULL),
(16151, NULL, 'IPR023537', NULL, 'Deoxyuridine triphosphate nucleotidohydrolase, archaeal', 'dUTPase_archaeal', 4, NULL),
(16152, NULL, 'IPR017273', NULL, 'Probable cell wall amidase LytH', 'LytH', 4, NULL),
(16153, NULL, 'IPR022492', NULL, 'Phosphomutase MSMEG4193, putative', 'Phosphomutase_MSMEG4193_put', 4, NULL),
(16154, NULL, 'IPR023604', NULL, 'Uncharacterised protein family SanA', 'Uncharacterised_SanA', 4, NULL),
(16155, NULL, 'IPR023503', NULL, 'Ribosome biogenesis methyltransferase NEP1, archaea', 'Ribosome_NEP1_arc', 4, NULL),
(16156, NULL, 'IPR035404', NULL, 'Domain of unknown function DUF5405', 'DUF5405', 3, NULL),
(16157, NULL, 'IPR020080', NULL, 'Outer membrane adhesin/peptidase omptin', 'OM_adhesin/peptidase_omptin', 5, NULL),
(16158, NULL, 'IPR022536', NULL, 'ESX-1 secretion-associated protein EspC', 'EspC', 4, NULL),
(16159, NULL, 'IPR016848', NULL, 'Ribonuclease P/MRP subunit Rpp29', 'RNase_P/MRP_Rpp29-subunit', 4, NULL),
(16160, NULL, 'IPR023458', NULL, 'Methionine-tRNA ligase, type 1', 'Met-tRNA_ligase_1', 4, NULL),
(16161, NULL, 'IPR017609', NULL, 'Xanthine dehydrogenase D subunit', 'Xanthine_dehydrogenase_dsu', 4, NULL),
(16162, NULL, 'IPR022513', NULL, 'NHLP leader peptide domain', 'TOMM_pelo', 3, NULL),
(16163, NULL, 'IPR022534', NULL, 'Protein of unknown function DUF2563', 'DUF2563', 4, NULL),
(16164, NULL, 'IPR016513', NULL, 'Uncharacterised conserved protein UCP007319', 'UCP007319', 4, NULL),
(16165, NULL, 'IPR022487', NULL, 'L-aspartate dehydrogenase, archaeal', 'Asp_DH_arc', 4, NULL),
(16166, NULL, 'IPR016517', NULL, 'Peptidase M11, autolysin', 'Peptidase_M11_autolysin', 4, NULL),
(16167, NULL, 'IPR023470', NULL, 'Riboflavin kinase, archaeal', 'Riboflavin_kinase_archaeal', 4, NULL),
(16168, NULL, 'IPR016528', NULL, 'Vacuolar protein sorting-associated protein 11', 'VPS11', 4, NULL),
(16169, NULL, 'IPR016841', NULL, 'Transcription regulator DksA-related, predicted', 'Tscrpt_reg_DksA-rel_prd', 4, NULL),
(16170, NULL, 'IPR022575', NULL, 'Neurogenic differentiation factor, domain of unknown function', 'NeuroD_DUF', 3, NULL),
(16171, NULL, 'IPR016837', NULL, 'Uncharacterised protein family Ycf55, cyanobacteria', 'Uncharacterised_Ycf55_cyanobac', 4, NULL),
(16172, NULL, 'IPR023594', NULL, 'Haloalkane dehalogenase, subfamily 2', 'Haloalkane_dehalogenase_2', 4, NULL),
(16173, NULL, 'IPR016537', NULL, 'Uncharacterised conserved protein UCP008159,', 'UCP008159_ABC', 4, NULL),
(16174, NULL, 'IPR023428', NULL, 'Photosystem II PsbX, type 2 subfamily', 'PSII_PsbX_type_2_subfam', 4, NULL),
(16175, NULL, 'IPR022563', NULL, 'Domain of unknown function DUF3463', 'DUF3463', 3, NULL),
(16176, NULL, 'IPR017615', NULL, 'Xanthine dehydrogenase, accessory protein PucB', 'Xanthine_dehydrogenase_PucB', 4, NULL),
(16177, NULL, 'IPR016839', NULL, 'Signal transduction diguanylate cyclase, CHASE2 sensor domain-containing, predicted', 'Sig_transdc_diG_cyclase_prd', 4, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(16178, NULL, 'IPR016524', NULL, 'Ubiquitin-like-conjugating enzyme Atg10', 'Atg10', 4, NULL),
(16179, NULL, 'IPR016856', NULL, 'NADPH-dependent 7-cyano-7-deazaguanine reductase, QueF type 1', 'QueF_type1', 4, NULL),
(16180, NULL, 'IPR016863', NULL, 'dTDP-4-amino-4,6-dideoxy-D-glucose ammonia-lyase', 'DesII', 4, NULL),
(16181, NULL, 'IPR018609', NULL, 'Bud13', 'Bud13', 4, NULL),
(16182, NULL, 'IPR023492', NULL, 'L-ribulose-5-phosphate 3-epimerase, Enterobacteriaceae', 'L-Ru-5P_3-Epase_Enterobacteria', 4, NULL),
(16183, NULL, 'IPR022516', NULL, 'Nif11-like leader peptide', 'CHP03798_Ocin', 3, NULL),
(16184, NULL, 'IPR023668', NULL, 'Altronate oxidoreductase', 'Altronate_OxRdtase', 4, NULL),
(16185, NULL, 'IPR022547', NULL, 'ATPase, RavA, C-terminal', 'ATPase_RavA_C', 3, NULL),
(16186, NULL, 'IPR023652', NULL, 'Sirohydrochlorin cobaltochelatase', 'SiroHydchlorin_Cochelatase', 4, NULL),
(16187, NULL, 'IPR034186', NULL, 'Pin4-like, RNA recognition motif', 'PIN4-like_RRM', 3, NULL),
(16188, NULL, 'IPR016846', NULL, 'Predicted ion channel, cNMP-binding', 'cNMP-bd_ion_channel', 4, NULL),
(16189, NULL, 'IPR021202', NULL, 'Apoptosis inhibitor Rv3654c-like', 'Rv3654c-like', 4, NULL),
(16190, NULL, 'IPR035239', NULL, 'Cypovirus polyhedrin', 'CPV_Polyhedrin', 4, NULL),
(16191, NULL, 'IPR022503', NULL, 'Conjugative coupling factor TraG/TraD, PFGI-1', 'Conj_coupling_TraG/TraD_PFGI-1', 4, NULL),
(16192, NULL, 'IPR022574', NULL, 'Protein of unknown function DUF2623', 'DUF2623', 4, NULL),
(16193, NULL, 'IPR016850', NULL, 'Transcription initiation factor Rrn11, budding yeast', 'TIF_Rrn11_budding_yeast', 4, NULL),
(16194, NULL, 'IPR017619', NULL, '2-hydroxycyclohexanecarboxyl-CoA dehydrogenase', 'OH-benzo_CoA_DH_BadH', 4, NULL),
(16195, NULL, 'IPR020056', NULL, 'Ribosomal protein L25/Gln-tRNA synthetase, N-terminal', 'Rbsml_L25/Gln-tRNA_synth_N', 5, NULL),
(16196, NULL, 'IPR023401', NULL, 'Ornithine cyclodeaminase, N-terminal', 'ODC_N', 5, NULL),
(16197, NULL, 'IPR022515', NULL, 'NHPM bacteriocin system ABC transporter, ATP-binding protein', 'NHPM_micro_ABC2', 4, NULL),
(16198, NULL, 'IPR017278', NULL, 'TIR domain-containing adapter molecule 1', 'TICAM1', 4, NULL),
(16199, NULL, 'IPR020095', NULL, 'Pseudouridine synthase I, TruA, C-terminal', 'PsdUridine_synth_TruA_C', 5, NULL),
(16200, NULL, 'IPR017292', NULL, 'Peptidase S8A, Vpr', 'Peptidase_S8A_Vpr', 4, NULL),
(16201, NULL, 'IPR016516', NULL, 'Uncharacterised conserved protein UCP07580', 'UCP07580', 4, NULL),
(16202, NULL, 'IPR023415', NULL, 'Low-density lipoprotein (LDL) receptor class A, conserved site', 'LDLR_class-A_CS', 2, NULL),
(16203, NULL, 'IPR023705', NULL, 'Nucleoid occlusion protein', 'Nucleoid_occlusion_protein', 4, NULL),
(16204, NULL, 'IPR034347', NULL, 'Glutathione S-transferases Phi, C-terminal', 'GST_Phi_C', 3, NULL),
(16205, NULL, 'IPR018620', NULL, 'Ubiquitin 3 binding protein But2, C-terminal', 'Ubiquitin3-bd_protein_But2_C', 3, NULL),
(16206, NULL, 'IPR017605', NULL, 'Benzoyl-CoA reductase, bzd-type, Q subunit', 'Benzoyl-CoA_Rdtase_bzd_qsu', 4, NULL),
(16207, NULL, 'IPR016876', NULL, 'Uncharacterised conserved protein UCP028234', 'UCP028234', 4, NULL),
(16208, NULL, 'IPR020059', NULL, 'Glutamyl/glutaminyl-tRNA synthetase, class Ib, anti-codon binding domain', 'Glu/Gln-tRNA-synth_Ib_codon-bd', 3, NULL),
(16209, NULL, 'IPR016497', NULL, 'Herpesvirus UL5', 'Herpes_UL5', 4, NULL),
(16210, NULL, 'IPR017267', NULL, 'Cytochrome c oxidase subunit VIIa-related, mitochondrial', 'Cyt_c_oxidase_su7a-rel_mt', 4, NULL),
(16211, NULL, 'IPR023505', NULL, 'N-acetyl-D-glucosamine kinase', 'N-acetyl-D-glucosamine_kinase', 4, NULL),
(16212, NULL, 'IPR023426', NULL, 'Flap endonuclease 1', 'Flap_endonuc', 4, NULL),
(16213, NULL, 'IPR023430', NULL, 'Peptidase HybD-like domain superfamily', 'Pept_HybD-like_dom_sf', 5, NULL),
(16214, NULL, 'IPR024779', NULL, '2OGFeDO JBP1/TET, oxygenase domain', '2OGFeDO_JBP1/TET_oxygenase_dom', 3, NULL),
(16215, NULL, 'IPR024936', NULL, 'Cyclophilin-type peptidyl-prolyl cis-trans isomerase', 'Cyclophilin-type_PPIase', 4, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(16216, NULL, 'IPR023690', NULL, 'Cytoskeleton protein RodZ', 'RodZ', 4, NULL),
(16217, NULL, 'IPR016847', NULL, 'Mannose-6-phosphate isomerase, Firmicutes, long form, predicted', 'Man6P_Isoase_Firm_lng_prd', 4, NULL),
(16218, NULL, 'IPR016491', NULL, 'Septin', 'Septin', 4, NULL),
(16219, NULL, 'IPR016544', NULL, 'N-glycosylase/DNA lyase', 'AGOG', 4, NULL),
(16220, NULL, 'IPR023605', NULL, 'Lipoprotein NlpI', 'Lipoprotein_NlpI', 4, NULL),
(16221, NULL, 'IPR022564', NULL, 'Protein of unknown function DUF2678', 'DUF2678', 4, NULL),
(16222, NULL, 'IPR023444', NULL, 'L-rhamnonate dehydratase', 'L-Rhamnon_dehydrat', 4, NULL),
(16223, NULL, 'IPR022545', NULL, 'Human herpesvirus, UL121', 'HHV_UL121', 4, NULL),
(16224, NULL, 'IPR017262', NULL, 'Salivary gland allergen Aed3', 'Salivary_gland_allergen_Aed3', 4, NULL),
(16225, NULL, 'IPR017283', NULL, 'Protein/nucleic acid deglycase HchA', 'HchA', 4, NULL),
(16226, NULL, 'IPR020092', NULL, 'Pleiotrophin/Midkine heparin-binding growth factor, conserved site', 'PTN_MK_heparin-bd_GF_CS', 2, NULL),
(16227, NULL, 'IPR017622', NULL, 'Transcription regulator, P21/BotR , Clostridium toxin-associated', 'Tscrpt_reg_p21/BotR', 4, NULL),
(16228, NULL, 'IPR017279', NULL, 'Toll-interleukin 1 receptor domain-containing adaptor protein, Tirap', 'Tol-interleuk_rcpt_adapt_Tirap', 4, NULL),
(16229, NULL, 'IPR016534', NULL, 'Vacuolar protein sorting-associated protein 16', 'VPS16', 4, NULL),
(16230, NULL, 'IPR023663', NULL, 'NADPH dehydrogenase, bacteria', 'NADPH_DH_bac', 4, NULL),
(16231, NULL, 'IPR022538', NULL, 'Protein of unknown function DUF2570', 'DUF2570', 4, NULL),
(16232, NULL, 'IPR023461', NULL, 'Electron transfer flavoprotein FixB subunit', 'FixB', 4, NULL),
(16233, NULL, 'IPR018624', NULL, 'Translocation protein Sec66', 'Sec66', 4, NULL),
(16234, NULL, 'IPR023418', NULL, 'Transthyretin, thyroxine binding site', 'Thyroxine_BS', 1, NULL),
(16235, NULL, 'IPR021206', NULL, 'MprA protease C-terminal rhombosortase-interaction domain', 'MprA_tail', 3, NULL),
(16236, NULL, 'IPR017284', NULL, 'Tautomerase PptA', 'Tautomerase_PptA', 4, NULL),
(16237, NULL, 'IPR023489', NULL, 'Haloalkane dehalogenase, subfamily 1', 'Haloalkane_dehalogenase_1', 4, NULL),
(16238, NULL, 'IPR023467', NULL, 'Tetrahydromethanopterin S-methyltransferase, subunit H/Methyltransferase Mtx, subunit H', 'MeTrfase_MtrH/MtxH', 4, NULL),
(16239, NULL, 'IPR018612', NULL, 'Nuclear speckle splicing regulatory protein 1, N-terminal', 'NSRP1_N', 3, NULL),
(16240, NULL, 'IPR016865', NULL, 'Inner membrane protein RclC', 'RclC', 4, NULL),
(16241, NULL, 'IPR023646', NULL, 'Primosomal replication protein PriB', 'Prisomal_replication_PriB', 4, NULL),
(16242, NULL, 'IPR016546', NULL, 'Maltodextrose utilization protein MalA', 'Maltodextrose_util_MalA', 4, NULL),
(16243, NULL, 'IPR016510', NULL, 'Cysteine protease S273R', 'VPRT', 4, NULL),
(16244, NULL, 'IPR034432', NULL, 'Nucleoporin nup60', 'Nup60', 4, NULL),
(16245, NULL, 'IPR022582', NULL, 'T-box transcription factor 2/3, transcription activation domain', 'TBX2/3_TAD', 3, NULL),
(16246, NULL, 'IPR017268', NULL, 'Tax1-binding protein 3', 'Tax1-binding_p3', 4, NULL),
(16247, NULL, 'IPR022478', NULL, 'ABC transporter, substrate-binding protein, PQQ-dependent alcohol dehydrogenase system', 'ABC_transptr_sub-bd_PQQ', 4, NULL),
(16248, NULL, 'IPR016508', NULL, 'Uncharacterised conserved protein UCP007103', 'UCP007103', 4, NULL),
(16249, NULL, 'IPR023452', NULL, 'L-carnitine CoA-transferase CaiB', 'CoA-Trfase_CaiB', 4, NULL),
(16250, NULL, 'IPR016522', NULL, 'Ribosomal protein S22, mitochondrial, budding yeast', 'Ribosome_S22_mit_bud', 4, NULL),
(16251, NULL, 'IPR017271', NULL, 'Transcription regulator HTH, MJ1545, predicted', 'Tscrpt_reg_HTH_MJ1545_prd', 4, NULL),
(16252, NULL, 'IPR023597', NULL, 'Flagellar regulator Flk', 'Flagellar_regulator_Flk', 4, NULL),
(16253, NULL, 'IPR016535', NULL, 'RFamide neuropeptide, ACEP-1', 'RFamide_neuropeptide_ACEP-1', 4, NULL),
(16254, NULL, 'IPR016530', NULL, 'Mediator of RNA polymerase II transcription subunit 22, Saccharomycetes', 'Med22_Saccharomyce', 4, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(16255, NULL, 'IPR034694', NULL, 'Ribosome hibernation promoting factor, long/plastid', 'HPF_long/plastid', 4, NULL),
(16256, NULL, 'IPR022482', NULL, 'Proteasome ATPase', 'Proteasome_ATPase', 4, NULL),
(16257, NULL, 'IPR023402', NULL, 'Uncharacterised protein MG237, central domain', 'Uncharacterised_MG237_central', 5, NULL),
(16258, NULL, 'IPR023438', NULL, 'Ribosomal protein L24e', 'Ribosomal_L24e', 4, NULL),
(16259, NULL, 'IPR023416', NULL, 'Transthyretin/hydroxyisourate hydrolase domain', 'Transthyretin/HIU_hydrolase_d', 3, NULL),
(16260, NULL, 'IPR022517', NULL, 'Aspartate 1-decarboxylase, pyridoxal-dependent', 'Asp_decarboxylase_pyridox', 4, NULL),
(16261, NULL, 'IPR022479', NULL, 'Coenzyme PQQ synthesis D, bacteria', 'PqqD_bac', 4, NULL),
(16262, NULL, 'IPR023394', NULL, 'Sec7, C-terminal domain superfamily', 'Sec7_C_sf', 5, NULL),
(16263, NULL, 'IPR022539', NULL, 'Protein of unknown function DUF3724, picornavirus', 'DUF3724', 2, NULL),
(16264, NULL, 'IPR022544', NULL, 'Bacteriophage P22, Orf80', 'Phage_P22_Orf80', 4, NULL),
(16265, NULL, 'IPR022580', NULL, 'Protein of unknown function DUF2639', 'DUF2639', 4, NULL),
(16266, NULL, 'IPR022548', NULL, 'Domain of unknown function DUF2846', 'DUF2846', 3, NULL),
(16267, NULL, 'IPR017270', NULL, 'Putative MotA/TolQ/ExbB family protein', 'MotA/TolQ/ExbB-rel', 4, NULL),
(16268, NULL, 'IPR016523', NULL, 'Calcipressin-like protein', 'Rcn1_fungi', 4, NULL),
(16269, NULL, 'IPR016539', NULL, 'Uncharacterised conserved protein UCP008315', 'UCP008315', 4, NULL),
(16270, NULL, 'IPR023456', NULL, 'Crotonobetaine/carnitine-CoA ligase CaiC', 'CaiC', 4, NULL),
(16271, NULL, 'IPR023457', NULL, 'Methionine-tRNA synthetase, type 2', 'Met-tRNA_synth_2', 4, NULL),
(16272, NULL, 'IPR022527', NULL, 'Sucrose phosphorylase', 'Sucrose_phospho', 4, NULL),
(16273, NULL, 'IPR016506', NULL, 'Competence protein D, Pasteurellaceae', 'ComD_Pasteurellaceae', 4, NULL),
(16274, NULL, 'IPR022500', NULL, 'ParB-related, ThiF-related cassette, ThiF', 'PRTRC_ThiF', 4, NULL),
(16275, NULL, 'IPR020091', NULL, 'Pleiotrophin/Midkine disulphide-rich domain superfamily', 'PTN/MK_diS_sf', 5, NULL),
(16276, NULL, 'IPR023603', NULL, 'Low specificity L-threonine aldolase', 'Low_specificity_L-TA', 4, NULL),
(16277, NULL, 'IPR022484', NULL, 'PEP-CTERM/exosortase system-associated acyltransferase, predicted', 'PEP-CTERM/exosrtase_acylTfrase', 4, NULL),
(16278, NULL, 'IPR018634', NULL, 'ChrB, C-terminal domain', 'ChrB_C', 3, NULL),
(16279, NULL, 'IPR020090', NULL, 'Pleiotrophin/Midkine, C-terminal domain', 'PTN/MK_C_dom', 3, NULL),
(16280, NULL, 'IPR021204', NULL, 'Integrating conjugative element protein, PFL4711', 'Integr_conj_element_PFL4711', 4, NULL),
(16281, NULL, 'IPR016855', NULL, 'Endoplasmic reticulum resident protein 29', 'ERp29', 4, NULL),
(16282, NULL, 'IPR023454', NULL, 'Ribosomal protein S2, archaeal', 'Ribosomal_S2_arc', 4, NULL),
(16283, NULL, 'IPR016533', NULL, 'Wound-induced protein 1/12, subgroup', 'Wound-induced_1/12_sub', 4, NULL),
(16284, NULL, 'IPR023601', NULL, 'Golgi SNAP receptor complex, subunit 1', 'Golgi_SNAP_su1', 4, NULL),
(16285, NULL, 'IPR023488', NULL, 'HTH-type transcriptional regulator Hpr', 'HTH_tscrpt_reg_Hpr', 4, NULL),
(16286, NULL, 'IPR018606', NULL, 'Argonaute-binding protein 1', 'Arb1', 4, NULL),
(16287, NULL, 'IPR021201', NULL, 'Leader peptide, exosporium', 'Leader_pep_exosporium', 3, NULL),
(16288, NULL, 'IPR017616', NULL, 'Pimeloyl-CoA dehydrogenase, small subunit', 'Pimeloyl_CoA_dehydrogenase_ssu', 4, NULL),
(16289, NULL, 'IPR016879', NULL, 'Uncharacterised conserved protein UCP028299', 'UCP028299', 4, NULL),
(16290, NULL, 'IPR018610', NULL, 'UV-stimulated scaffold protein A', 'UVSSA', 4, NULL),
(16291, NULL, 'IPR022552', NULL, 'Uncharacterised protein family Ycf55', 'UPF_Ycf55', 4, NULL),
(16292, NULL, 'IPR023657', NULL, 'Ribosomal protein L40e, archaeal', 'Ribosomal_L40e_arc', 4, NULL),
(16293, NULL, 'IPR016490', NULL, 'Transcriptional regulator, HTH, AF0396-type', 'Tscrpt_reg_HTH_AF0396-typ3', 4, NULL),
(16294, NULL, 'IPR020055', NULL, 'Ribosomal protein L25, short-form', 'Ribosomal_L25_short', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(16295, NULL, 'IPR023319', NULL, 'Tex-like protein, HTH domain superfamily', 'Tex-like_HTH_dom_sf', 5, NULL),
(16296, NULL, 'IPR016512', NULL, 'Uncharacterised protein family, inner membrane YidI', 'Uncharacterised_IM_YidI', 4, NULL),
(16297, NULL, 'IPR024843', NULL, 'Dapper', 'Dapper', 4, NULL),
(16298, NULL, 'IPR023453', NULL, 'Methionine repressor MetJ domain superfamily', 'Met_repressor_MetJ_dom_sf', 5, NULL),
(16299, NULL, 'IPR023685', NULL, 'Pyridoxal kinase PdxY', 'Pyridoxal_kinase_PdxY', 4, NULL),
(16300, NULL, 'IPR023476', NULL, 'Peptidyl-tRNA hydrolase II domain superfamily', 'Pep_tRNA_hydro_II_dom_sf', 5, NULL),
(16301, NULL, 'IPR016836', NULL, 'Long-chain acyl-[acyl-carrier-protein] reductase', 'AAR', 4, NULL),
(16302, NULL, 'IPR022569', NULL, 'Ferredoxin, C-terminal', 'Fd_C', 3, NULL),
(16303, NULL, 'IPR016854', NULL, 'Apoptosis regulator, Ced-4', 'Apop_reg_Ced-4', 4, NULL),
(16304, NULL, 'IPR016532', NULL, 'Mediator of RNA polymerase II transcription subunit 20', 'Med20', 4, NULL),
(16305, NULL, 'IPR022505', NULL, 'Exosortase, cyanobacteria', 'Exosortase_cyanobac', 4, NULL),
(16306, NULL, 'IPR023651', NULL, 'Ribosomal protein L14e', 'Ribosomal_L14e', 4, NULL),
(16307, NULL, 'IPR035995', NULL, 'Bowman-Birk type proteinase inhibitor', 'Bowman-Birk_prot_inh', 5, NULL),
(16308, NULL, 'IPR023425', NULL, 'Galactose-1-phosphate uridyl transferase, class II, conserved site', 'GalP_uridyl_Trfase_II_CS', 2, NULL),
(16309, NULL, 'IPR016531', NULL, 'RNA polymerase I-specific transcription initiation factor Rrn6', 'Rrn6', 4, NULL),
(16310, NULL, 'IPR020945', NULL, 'DMSO/Nitrate reductase chaperone', 'DMSO/NO3_reduct_chaperone', 4, NULL),
(16311, NULL, 'IPR023639', NULL, 'DNA primase small subunit PriS', 'DNA_primase_ssu_PriS', 4, NULL),
(16312, NULL, 'IPR020089', NULL, 'Pleiotrophin/Midkine, N-terminal domain', 'PTN/MK_N_dom', 3, NULL),
(16313, NULL, 'IPR017281', NULL, 'Myeloid differentiation primary response protein MyD88', 'Myelin_different_resp_MyD88', 4, NULL),
(16314, NULL, 'IPR016845', NULL, 'Uncharacterised conserved protein UCP026633, TfuA-like, mycobacteria', 'UCP026633_TfuA-like', 4, NULL),
(16315, NULL, 'IPR022507', NULL, 'Metallophosphoesterase, RPA4764', 'Metallophosphoesterase_RPA4764', 4, NULL),
(16316, NULL, 'IPR023600', NULL, 'Folylpolyglutamate synthase, eukaryota', 'Folylpolyglutamate_synth_euk', 4, NULL),
(16317, NULL, 'IPR022495', NULL, 'Serine/threonine-protein kinase Bud32', 'Bud32', 4, NULL),
(16318, NULL, 'IPR017289', NULL, 'SH2 protein 1A', 'SH2_prot_1A', 4, NULL),
(16319, NULL, 'IPR016829', NULL, 'Spodoptera frugiperda nuclear polyhedrosis virus (SfNPV), sf27', 'SfNPV_sf27', 4, NULL),
(16320, NULL, 'IPR016498', NULL, 'Protein YzcX', 'YzcX', 4, NULL),
(16321, NULL, 'IPR035994', NULL, 'Nucleoside phosphorylase superfamily', 'Nucleoside_phosphorylase_sf', 5, NULL),
(16322, NULL, 'IPR023508', NULL, 'Acetyl esterase', 'Acetyl_esterase', 4, NULL),
(16323, NULL, 'IPR023638', NULL, 'Ribosomal protein L19/L19e conserved site', 'Ribosomal_L19/L19e_CS', 2, NULL),
(16324, NULL, 'IPR020061', NULL, 'Glutamine-tRNA ligase, alpha-bundle domain superfamily', 'Glu_tRNA_lig_a-bdl', 5, NULL),
(16325, NULL, 'IPR035062', NULL, 'Kic1p-like serine/threonine kinase, catalytic domain', 'STK_Kic1p-like', 3, NULL),
(16326, NULL, 'IPR023399', NULL, 'Baseplate-like, two-layer sandwich fold', 'Baseplate-like_2-layer_sand', 5, NULL),
(16327, NULL, 'IPR016870', NULL, 'Uncharacterised conserved protein UCP028137, membrane', 'UCP028137', 4, NULL),
(16328, NULL, 'IPR018628', NULL, 'Cytochrome c oxidase assembly factor 3, mitochondrial, coiled-coil domain', 'Coa3_cc', 3, NULL),
(16329, NULL, 'IPR016502', NULL, 'Type II secretion system (T2SS) pilotin, S protein', 'T2SSS_2', 4, NULL),
(16330, NULL, 'IPR023593', NULL, '2-keto-3-deoxy-L-rhamnonate aldolase', 'KDR_aldolase', 4, NULL),
(16331, NULL, 'IPR016849', NULL, 'Histone acetyltransferase Rtt109', 'Rtt109', 4, NULL),
(16332, NULL, 'IPR016500', NULL, 'Uncharacterised conserved protein UCP006993', 'UCP006993', 4, NULL),
(16333, NULL, 'IPR023419', NULL, 'Transthyretin, conserved site', 'Transthyretin_CS', 2, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(16334, NULL, 'IPR017621', NULL, 'Cyclohexanecarboxylate-CoA ligase', 'Cyclohxane-COOH-CoA_Ligase', 4, NULL),
(16335, NULL, 'IPR017291', NULL, 'Sulfofructosephosphate aldolase, YihT', 'SFP_aldolase_YihT', 4, NULL),
(16336, NULL, 'IPR023671', NULL, 'ATPase RavA', 'ATPase_RavA', 4, NULL),
(16337, NULL, 'IPR023644', NULL, 'Nitrous-oxide reductase', 'NO_Rdtase', 4, NULL),
(16338, NULL, 'IPR022490', NULL, 'Protein translocase subunit SecA2', 'SecA2', 4, NULL),
(16339, NULL, 'IPR023408', NULL, 'Mechanosensitive ion channel MscS, beta-domain superfamily', 'MscS_beta-dom_sf', 5, NULL),
(16340, NULL, 'IPR020083', NULL, 'Ribosomal protein L39e, conserved site', 'Ribosomal_L39_CS', 2, NULL),
(16341, NULL, 'IPR035249', NULL, 'Protein of unknown function DUF5441', 'DUF5441', 4, NULL),
(16342, NULL, 'IPR022566', NULL, 'Protein of unknown function DUF2613', 'DUF2613', 4, NULL),
(16343, NULL, 'IPR023445', NULL, 'Arginine exporter protein ArgO, enterobacteria', 'Arg_export_ArgO_enterobac', 4, NULL),
(16344, NULL, 'IPR023515', NULL, 'Quinolinate synthase A, type 3', 'Quinolinate_synth_A_type3', 4, NULL),
(16345, NULL, 'IPR022497', NULL, 'ABC transporter, urea permease, UrtC', 'ABC_trnspt_urea_permease_UrtC', 4, NULL),
(16346, NULL, 'IPR022576', NULL, 'Protein YfgG', 'YfgG', 4, NULL),
(16347, NULL, 'IPR022633', NULL, 'Translocated intimin receptor, N-terminal', 'Transloc_intimin_rcpt_N', 3, NULL),
(16348, NULL, 'IPR022502', NULL, 'Sulfopyruvate decarboxylase, alpha subunit', 'Sulfopyruvate_deCO2ase_alpha', 3, NULL),
(16349, NULL, 'IPR016830', NULL, 'Ubiquinone biosynthesis accessory factor UbiT', 'UbiT', 4, NULL),
(16350, NULL, 'IPR023421', NULL, 'Axin interactor, dorsalization-associated protein, N-terminal', 'AIDA_N', 3, NULL),
(16351, NULL, 'IPR034249', NULL, 'MyD88, death domain', 'MyD88_Death', 3, NULL),
(16352, NULL, 'IPR020084', NULL, 'NUDIX hydrolase, conserved site', 'NUDIX_hydrolase_CS', 2, NULL),
(16353, NULL, 'IPR016505', NULL, 'Protein YopQ', 'YopQ', 4, NULL),
(16354, NULL, 'IPR017610', NULL, 'tRNA U-34 5-methylaminomethyl-2-thiouridine biosynthesis protein MnmC, C-terminal', 'tRNA_S-uridine_synth_MnmC_C', 3, NULL),
(16355, NULL, 'IPR018632', NULL, 'C-terminal AAA-associated domain', 'AAA-associated_dom_C', 4, NULL),
(16356, NULL, 'IPR023409', NULL, '14-3-3 protein, conserved site', '14-3-3_CS', 2, NULL),
(16357, NULL, 'IPR016499', NULL, 'Nucleic acid binding protein, Rv2694c, predicted', 'NucleicA-bd_Rv2694c_prd', 4, NULL),
(16358, NULL, 'IPR022557', NULL, 'Domain of unknown function DUF3480', 'DUF3480', 3, NULL),
(16359, NULL, 'IPR023664', NULL, 'Murein transglycosylase-C', 'Murein_transglycosylaseC', 4, NULL),
(16360, NULL, 'IPR022510', NULL, 'Sortase system, histidine kinase', 'Sortase_His-kinase', 4, NULL),
(16361, NULL, 'IPR022571', NULL, 'Magnesium chelatase, subunit H, N-terminal', 'Mg_chelatase_H_N', 3, NULL),
(16362, NULL, 'IPR023649', NULL, 'Deoxyribose-phosphate aldolase type II', 'DeoC_typeII', 4, NULL),
(16363, NULL, 'IPR022520', NULL, 'Putative glutamate/gamma-aminobutyrate antiporter', 'Glu/GABA_antiporter_put', 4, NULL),
(16364, NULL, 'IPR020058', NULL, 'Glutamyl/glutaminyl-tRNA synthetase, class Ib, catalytic domain', 'Glu/Gln-tRNA-synth_Ib_cat-dom', 3, NULL),
(16365, NULL, 'IPR016838', NULL, 'Uncharacterised conserved protein UCP026449', 'UCP026449', 4, NULL),
(16366, NULL, 'IPR017608', NULL, '4-hydroxybenzoyl-CoA reductase, beta subunit', '4hydrxbenzoyl-CoA_Rdtase_bsu', 4, NULL),
(16367, NULL, 'IPR022532', NULL, 'Domain of unknown function DUF3696, C-terminal', 'DUF3696', 3, NULL),
(16368, NULL, 'IPR017293', NULL, 'N-acetylmuramoyl-L-alanine amidase, YrvJ, predicted', 'N-acetylmuramoyl-L-ala_amidase', 4, NULL),
(16369, NULL, 'IPR022562', NULL, 'Protein of unknown function DUF3466', 'DUF3466', 4, NULL),
(16370, NULL, 'IPR023614', NULL, 'Porin domain superfamily', 'Porin_dom_sf', 5, NULL),
(16371, NULL, 'IPR023655', NULL, 'Cytochrome c6', 'Cyt_C6', 4, NULL),
(16372, NULL, 'IPR022506', NULL, 'Metallophosphoesterase, PPA1498', 'Metallophosphoesterase_PPA1498', 4, NULL),
(16373, NULL, 'IPR023502', NULL, 'G/U mismatch-specific DNA glycosylase MUG, bacterial', 'MUG_bact', 4, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(16374, NULL, 'IPR022512', NULL, 'Conserved hypothetical protein CHP03792', 'CHP03792', 4, NULL),
(16375, NULL, 'IPR018619', NULL, 'Hyccin', 'Hyccin', 4, NULL),
(16376, NULL, 'IPR023411', NULL, 'Ribonuclease A, active site', 'RNaseA_AS', 0, NULL),
(16377, NULL, 'IPR016521', NULL, 'RNA-processing, Lsm12', 'RNA-processing_Lsm12', 4, NULL),
(16378, NULL, 'IPR016833', NULL, 'Putative sodium bile acid cotransporter', 'Put_Na-Bile_cotransptr', 4, NULL),
(16379, NULL, 'IPR023468', NULL, 'Riboflavin kinase', 'Riboflavin_kinase', 4, NULL),
(16380, NULL, 'IPR023318', NULL, 'Ubiquitin activating enzyme, alpha domain superfamily', 'Ub_act_enz_dom_a_sf', 5, NULL),
(16381, NULL, 'IPR018621', NULL, 'Autophagy-related protein 31', 'Atg31', 4, NULL),
(16382, NULL, 'IPR023498', NULL, 'Zinc transporter ZupT', 'Zn_transptr_ZupT', 4, NULL),
(16383, NULL, 'IPR016862', NULL, 'Uncharacterised conserved protein UCP027936', 'UCP027936', 4, NULL),
(16384, NULL, 'IPR018626', NULL, 'Protein LCHN/Anr2', 'LCHN/Anr2', 4, NULL),
(16385, NULL, 'IPR023495', NULL, 'Sugar efflux transporter, putative', 'Sugar_effux_transptr_put', 4, NULL),
(16386, NULL, 'IPR023450', NULL, 'Crotonobetainyl-CoA reductase CaiA', 'CaiA', 4, NULL),
(16387, NULL, 'IPR022511', NULL, 'Proteobacterial sortase system peptidoglycan-associated protein', 'PdsO', 4, NULL),
(16388, NULL, 'IPR034411', NULL, 'Heterogeneous nuclear ribonucleoprotein R, RNA recognition motif 2', 'hnRNPR_RRM2', 3, NULL),
(16389, NULL, 'IPR023459', NULL, 'Transcription elongation factor GreA/GreB family', 'Tscrpt_elong_fac_GreA/B_fam', 4, NULL),
(16390, NULL, 'IPR023412', NULL, 'Ribonuclease A-domain', 'RNaseA_domain', 3, NULL),
(16391, NULL, 'IPR016515', NULL, 'Uncharacterised conserved protein UCP007407, Abi protease-like', 'UCP007407_Abi-like', 4, NULL),
(16392, NULL, 'IPR023463', NULL, 'Electron transfer flavoprotein, FixA subunit', 'FixA', 4, NULL),
(16393, NULL, 'IPR023550', NULL, 'PKHD-type hydroxylase', 'PKHD_hydroxylase', 4, NULL),
(16394, NULL, 'IPR035402', NULL, 'Domain of unknown function DUF1611-N, Rossmann-like domain', 'DUF1611-N', 3, NULL),
(16395, NULL, 'IPR023449', NULL, 'L-carnitine/gamma-butyrobetaine antiporter CaiT', 'BCCT_transptr_CaiT', 4, NULL),
(16396, NULL, 'IPR023434', NULL, 'Argininosuccinate synthase, type 1 subfamily', 'Arginosuc_synth_type_1_subfam', 4, NULL),
(16397, NULL, 'IPR023455', NULL, 'Dihydroorotate dehydrogenase electron transfer subunit', 'Dihydroorotate_DHASE_ETsu', 4, NULL),
(16398, NULL, 'IPR016831', NULL, 'PPi-dependent kinase', 'PPi-dep_kinase', 4, NULL),
(16399, NULL, 'IPR018611', NULL, 'E3 UFM1-protein ligase 1', 'Ufl1', 4, NULL),
(16400, NULL, 'IPR023658', NULL, '15,16-dihydrobiliverdin:ferredoxin oxidoreductase', 'DiHydbiliverdin_OxRdtase', 4, NULL),
(16401, NULL, 'IPR023397', NULL, 'S-adenosyl-L-methionine-dependent methyltransferase, MraW, recognition domain superfamily', 'SAM-dep_MeTrfase_MraW_recog', 5, NULL),
(16402, NULL, 'IPR016542', NULL, 'Phosphatidylinositol N-acetylglucosaminyltransferase, GPI19/PIG-P subunit', 'PIG-P_GPI19', 4, NULL),
(16403, NULL, 'IPR022526', NULL, 'F420-dependent oxidoreductase, Rv3093c', 'F420_Rv3093c', 4, NULL),
(16404, NULL, 'IPR016866', NULL, 'Uncharacterised conserved protein UCP028069', 'UCP028069', 4, NULL),
(16405, NULL, 'IPR022570', NULL, 'Betacoronavirus, lineage A, NSP1', 'B-CoV_A_NSP1', 4, NULL),
(16406, NULL, 'IPR023523', NULL, 'Histidine decarboxylase, bacteria', 'Hist_deCOase_bac', 4, NULL),
(16407, NULL, 'IPR034346', NULL, 'Gtt2-like, C-terminal', 'Gtt2-like_C', 3, NULL),
(16408, NULL, 'IPR017263', NULL, 'Uncharacterised conserved protein UCP037692', 'UCP037692', 4, NULL),
(16409, NULL, 'IPR023447', NULL, 'Formylmethanofuran: tetrahydromethanopterin formyltransferase Ftr, ferredoxin-like superfamily', 'ForMFR_H4MPT_ForTrfase_fd-like', 5, NULL),
(16410, NULL, 'IPR023410', NULL, '14-3-3 domain', '14-3-3_domain', 3, NULL),
(16411, NULL, 'IPR023439', NULL, 'Malonate decarboxylase/citrate lyase acyl carrier protein', 'Mal_deCO2ase/Cit_lyase_ACP', 4, NULL),
(16412, NULL, 'IPR023427', NULL, 'Acetyl-CoA decarbonylase/synthase complex, gamma subunit, archaea', 'AcylCoA_decarb/synth_gsu_arc', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(16413, NULL, 'IPR023460', NULL, 'Ribosomal protein L7Ae, putative', 'Ribosomal_L7Ae_putative', 4, NULL),
(16414, NULL, 'IPR023465', NULL, 'Riboflavin kinase domain superfamily', 'Riboflavin_kinase_dom_sf', 5, NULL),
(16415, NULL, 'IPR016868', NULL, 'Bacteriophage B3, Orf5', 'Phage_B3_Orf5', 4, NULL),
(16416, NULL, 'IPR016851', NULL, 'Kinetochore-associated protein Nnf1', 'Nnf1', 4, NULL),
(16417, NULL, 'IPR018608', NULL, 'Gti1/Pac2 family', 'Gti1/Pac2', 4, NULL),
(16418, NULL, 'IPR016543', NULL, 'Mitochondria fission 1 protein', 'Fis1', 4, NULL),
(16419, NULL, 'IPR016835', NULL, 'Uncharacterised conserved protein UCP026317, WGR', 'UCP026317_WGR', 4, NULL),
(16420, NULL, 'IPR017276', NULL, 'Synthesis of cytochrome c oxidase, Sco1/Sco2', 'Synth_of_cyt-c-oxidase_Sco1/2', 4, NULL),
(16421, NULL, 'IPR023572', NULL, 'Archease domain', 'Archease_dom', 3, NULL),
(16422, NULL, 'IPR023592', NULL, 'D-galactonate dehydratase', 'Galactonate_deHydtase', 4, NULL),
(16423, NULL, 'IPR017287', NULL, 'Retinal rod rhodopsin-sensitive cGMP 3'', 5''-cyclic phosphodiesterase, delta subunit', 'Rhodop-sen_GMP-Pdiesterase_dsu', 4, NULL),
(16424, NULL, 'IPR016878', NULL, 'Uncharacterised conserved protein UCP028288', 'UCP028288', 4, NULL),
(16425, NULL, 'IPR024928', NULL, 'E3 ubiquitin-protein ligase, SMURF1 type', 'E3_ub_ligase_SMURF1', 4, NULL),
(16426, NULL, 'IPR023475', NULL, 'Probable cobalt-precorrin-6B C(15)-methyltransferase (decarboxylating) CbiT', 'CbiT', 4, NULL),
(16427, NULL, 'IPR016875', NULL, 'Uncharacterised conserved protein UCP028200', 'UCP028200', 4, NULL),
(16428, NULL, 'IPR023511', NULL, 'Plastocyanin, cyanobacteria', 'Plastocyanin_cyanobac', 4, NULL),
(16429, NULL, 'IPR023393', NULL, 'START-like domain superfamily', 'START-like_dom_sf', 5, NULL),
(16430, NULL, 'IPR023585', NULL, 'Isoleucine-tRNA ligase, type 1', 'Ile-tRNA-ligase_type1', 4, NULL),
(16431, NULL, 'IPR016545', NULL, 'Uncharacterised conserved protein UCP009120, proteasome-type protease, Sll0069', 'UCP009120_prtse', 4, NULL),
(16432, NULL, 'IPR018631', NULL, 'AAA-ATPase-like domain', 'AAA-ATPase-like_dom', 3, NULL),
(16433, NULL, 'IPR022540', NULL, 'Protein of unknown function DUF2556', 'DUF2556', 4, NULL),
(16434, NULL, 'IPR022583', NULL, 'Microcystin synthetase, domain of unknown function', 'Microcystin_synth_DUF', 3, NULL),
(16435, NULL, 'IPR016520', NULL, 'Uncharacterised conserved protein UCP007778', 'UCP007778', 4, NULL),
(16436, NULL, 'IPR022965', NULL, 'ATP-dependent DNA helicase Hel308', 'Helicase_Hel308', 4, NULL),
(16437, NULL, 'IPR023660', NULL, 'Protein arginine kinase', 'Arg_Kinase', 4, NULL),
(16438, NULL, 'IPR023451', NULL, 'Thymidylate synthase/dCMP hydroxymethylase domain', 'Thymidate_synth/dCMP_Mease_dom', 3, NULL),
(16439, NULL, 'IPR022494', NULL, 'Sulfopyruvate decarboxylase, beta subunit', 'Sulfopyruvate_deCO2ase_bsu', 3, NULL),
(16440, NULL, 'IPR024927', NULL, 'Purple acid phosphatase', 'Acid_PPase', 4, NULL),
(16441, NULL, 'IPR016507', NULL, 'Uncharacterised conserved protein UCP007061', 'UCP007061', 4, NULL),
(16442, NULL, 'IPR023561', NULL, 'Carbonic anhydrase, alpha-class', 'Carbonic_anhydrase_a-class', 4, NULL),
(16443, NULL, 'IPR034693', NULL, 'Diadenylate cyclase CdaS', 'CdaS', 4, NULL),
(16444, NULL, 'IPR022483', NULL, 'Proteasome subunit beta, actinobacteria', 'PSB_actinobac', 4, NULL),
(16445, NULL, 'IPR023667', NULL, 'NAD-dependent malic enzyme, proteobacteria', 'NAD_malic_enz_proteobac', 4, NULL),
(16446, NULL, 'IPR023407', NULL, 'Ribosomal protein S27, zinc-binding domain superfamily', 'Ribosomal_S27_Zn-bd_dom_sf', 5, NULL),
(16447, NULL, 'IPR022550', NULL, 'Nucleotidyltransferase 8', 'NTP_transf_8', 4, NULL),
(16448, NULL, 'IPR022589', NULL, 'Protein of unknown function DUF2660', 'DUF2660', 4, NULL),
(16449, NULL, 'IPR017607', NULL, '4-hydroxybenzoyl-CoA reductase, alpha subunit', '4hydrxbenzoyl-CoA_Rdtase_asu', 4, NULL),
(16450, NULL, 'IPR018614', NULL, 'Keratinocyte-associated protein 2', 'KRTCAP2', 4, NULL),
(16451, NULL, 'IPR023484', NULL, 'Transcription initiation factor TFIIB, archaea', 'TFIIB_arc', 4, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(16452, NULL, 'IPR022546', NULL, 'Uncharacterised protein family Ycf68', 'Uncharacterised_Ycf68', 4, NULL),
(16453, NULL, 'IPR034345', NULL, 'Gtt2-like, N-terminal', 'Gtt2-like_N', 3, NULL),
(16454, NULL, 'IPR022514', NULL, 'NHPM bacteriocin system ABC transporter, peptidase/ATP-binding protein', 'NHPM_micro_ABC1', 4, NULL),
(16455, NULL, 'IPR017275', NULL, 'Transcription factor FapR', 'Transcription_factor_FapR', 4, NULL),
(16456, NULL, 'IPR022524', NULL, 'Flagellar assembly FliH, Bacilli', 'FliH_Bacilli', 4, NULL),
(16457, NULL, 'IPR023446', NULL, 'Carnitine operon protein CaiE', 'CaiE', 4, NULL),
(16458, NULL, 'IPR017264', NULL, 'Ribosomal protein MRP10, mitochondrial', 'Ribosomal_MRP10_mt', 4, NULL),
(16459, NULL, 'IPR023436', NULL, 'D-tagatose-bisphosphate aldolase, class II, non-catalytic subunit GatZ', 'TagBP_ald_GatZ', 4, NULL),
(16460, NULL, 'IPR017260', NULL, 'Uncharacterised conserved protein UCP037673', 'UCP037673', 4, NULL),
(16461, NULL, 'IPR022588', NULL, 'Protein of unknown function DUF2659', 'DUF2659', 4, NULL),
(16462, NULL, 'IPR023643', NULL, '3-phenylpropionate-dihydrodiol/cinnamic acid-dihydrodiol dehydrogenase HcaB', 'Dihydrodiol_DH_HcaB', 4, NULL),
(16463, NULL, 'IPR022586', NULL, 'Swinepox virus, C51', 'Swinepox_virus_C51', 4, NULL),
(16464, NULL, 'IPR016840', NULL, 'Glycoside hydrolase, family 43, endo-1, 5-alpha-L-arabinosidase', 'Glyco_hydro_43_endo_a_Ara-ase', 4, NULL),
(16465, NULL, 'IPR016877', NULL, 'Uncharacterised conserved protein UCP028235', 'UCP028235', 4, NULL),
(16466, NULL, 'IPR016880', NULL, 'ABC-type oligopeptide transport system, solute-binding component, Mycoplasmataceae, predicted', 'ABC_oligopep_solut-bd_myco_prd', 4, NULL),
(16467, NULL, 'IPR017288', NULL, 'Bcl-2-like protein 11', 'Bcl-2-like_11', 4, NULL),
(16468, NULL, 'IPR023163', NULL, 'SMc04008-like domain', 'SMc04008-like_domain', 3, NULL),
(16469, NULL, 'IPR018617', NULL, 'Ima1, N-terminal domain', 'Ima1_N', 3, NULL),
(16470, NULL, 'IPR018625', NULL, 'Protein Pet100', 'Pet100', 4, NULL),
(16471, NULL, 'IPR016504', NULL, 'Outer membrane protein YaiO', 'YaiO', 4, NULL),
(16472, NULL, 'IPR018618', NULL, 'Vacuolar import/degradation protein Vid24', 'Vacuolar_import/degrad_Vid24', 4, NULL),
(16473, NULL, 'IPR016538', NULL, 'Uncharacterised conserved protein UCP008292', 'UCP008292', 4, NULL),
(16474, NULL, 'IPR017261', NULL, 'DNA mismatch repair protein MutS/MSH', 'DNA_mismatch_repair_MutS/MSH', 4, NULL),
(16475, NULL, 'IPR024896', NULL, 'Propionate kinase PduW', 'Propionate_kinase_PduW', 4, NULL),
(16476, NULL, 'IPR017290', NULL, 'Ribonuclease H, Bacteroides-type', 'RNase_H_bac', 4, NULL),
(16477, NULL, 'IPR023491', NULL, 'Acyl carrier protein phosphodiesterase, gammaproteobacteria', 'ACP_phosphodiesterase_gpbac', 4, NULL),
(16478, NULL, 'IPR016496', NULL, 'GTPase HflX', 'GTPase_HflX', 4, NULL),
(16479, NULL, 'IPR022579', NULL, 'Neuropilin, C-terminal', 'Neuropilin_C', 3, NULL),
(16480, NULL, 'IPR023477', NULL, 'Adenylate kinase AdkA', 'Adenylate_kinase_AdkA', 4, NULL),
(16481, NULL, 'IPR023530', NULL, 'Cytochrome b6, PetB', 'Cyt_B6_PetB', 4, NULL),
(16482, NULL, 'IPR022551', NULL, 'BrxC', 'BrxC', 4, NULL),
(16483, NULL, 'IPR023442', NULL, 'Ribosomal protein L24e, conserved site', 'Ribosomal_L24e_CS', 2, NULL),
(16484, NULL, 'IPR022531', NULL, 'RNA-directed RNA polymerase L, PA-C-like domain', 'L_PA-C-like', 3, NULL),
(16485, NULL, 'IPR016864', NULL, 'Uncharacterised conserved protein UCP028035', 'UCP028035', 4, NULL),
(16486, NULL, 'IPR017617', NULL, 'Pimeloyl-CoA dehydrogenase, large subunit', 'Pimeloyl_CoA_dehydrogenase_lsu', 4, NULL),
(16487, NULL, 'IPR018636', NULL, 'Protein of unknown function DUF2058', 'DUF2058', 4, NULL),
(16488, NULL, 'IPR016514', NULL, 'Fimbrial protein EcpA', 'EcpA', 4, NULL),
(16489, NULL, 'IPR022853', NULL, 'Flotillin-like protein FloA', 'FloA', 4, NULL),
(16490, NULL, 'IPR022541', NULL, 'FicA antitoxin homologue YhfG', 'YhfG', 4, NULL),
(16491, NULL, 'IPR022584', NULL, 'Protein of unknown function DUF2937', 'DUF2937', 4, NULL),
(16492, NULL, 'IPR022542', NULL, 'Focadhesin/RST, DUF3730', 'FOCAD/RST1_DUF3730', 3, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(16493, NULL, 'IPR022638', NULL, 'Translocated intimin receptor', 'Transloc_intimin_rcpt', 4, NULL),
(16494, NULL, 'IPR022639', NULL, 'Translocated intimin receptor, C-terminal', 'Transloc_intimin_rcpt_C', 3, NULL),
(16495, NULL, 'IPR016493', NULL, 'Spore coat protein CotF', 'Spore_coat_CotF', 4, NULL),
(16496, NULL, 'IPR022485', NULL, '2-succinyl-6-hydroxy-2,4-cyclohexadiene-1-carboxylate synthase', 'SHCHC_synthase_MenH', 4, NULL),
(16497, NULL, 'IPR022577', NULL, 'Tubulin-specific chaperone D, C-terminal', 'Tubulin_specific_chaperoneD_C', 3, NULL),
(16498, NULL, 'IPR017285', NULL, 'Cyclin, herpesvirus', 'Cyclin_herpesvir', 4, NULL),
(16499, NULL, 'IPR017612', NULL, 'Xanthine dehydrogenase C subunit', 'Xanthine_dehydrogenase_csu', 4, NULL),
(16500, NULL, 'IPR016852', NULL, 'SET domain methyltransferase', 'SET_MeTrfase', 4, NULL),
(16501, NULL, 'IPR019419', NULL, 'Altered inheritance of mitochondria protein 19', 'AIM19', 4, NULL),
(16502, NULL, 'IPR022590', NULL, 'Peroxisome proliferator-activated receptor gamma, N-terminal', 'PPARgamma_N', 3, NULL),
(16503, NULL, 'IPR022736', NULL, 'Non-structural protein NS6, betacoronavirus', 'NS6_bCoV', 4, NULL),
(16504, NULL, 'IPR017318', NULL, 'Peptidase S8A, subtilisin-related, campylobacter', 'Pept_S8A_subtilisin_campylobac', 4, NULL),
(16505, NULL, 'IPR017627', NULL, '(S)-ureidoglycine aminohydrolase', 'UGHY', 4, NULL),
(16506, NULL, 'IPR018637', NULL, 'Domain of unknown function DUF2059', 'DUF2059', 3, NULL),
(16507, NULL, 'IPR022660', NULL, 'Domain of unknown function DUF1581', 'DUF1581', 3, NULL),
(16508, NULL, 'IPR023748', NULL, 'Replication factor C small subunit, archaeal', 'Rep_factor-C_ssu_arc', 4, NULL),
(16509, NULL, 'IPR017646', NULL, 'DNA phosphorothioation-dependent restriction protein DptH', 'Dnd_assoc_2', 4, NULL),
(16510, NULL, 'IPR019048', NULL, 'Immunodominant surface protein, Ehrlichia tandem repeat-containing', 'Immunodom_prot_Ehrlichia_rpt', 4, NULL),
(16511, NULL, 'IPR017626', NULL, '2,3-dihydroxybiphenyl 1,2-dioxygenase', 'DiOHbiphenyl_dOase', 4, NULL),
(16512, NULL, 'IPR023783', NULL, 'Cation efflux pump FieF', 'Cation_efflux_FieF', 4, NULL),
(16513, NULL, 'IPR022691', NULL, 'Transcription elongation factor, GreA/GreB, N-terminal', 'Tscrpt_elong_fac_GreA/B_N', 3, NULL),
(16514, NULL, 'IPR023529', NULL, 'RNA chaperone ProQ', 'ProQ', 4, NULL),
(16515, NULL, 'IPR019393', NULL, 'WASH complex, subunit strumpellin', 'WASH_strumpellin', 4, NULL),
(16516, NULL, 'IPR023122', NULL, 'NE1680-like superfamily', 'NE1680-like_sf', 5, NULL),
(16517, NULL, 'IPR023767', NULL, 'Transcriptional regulator SgrR', 'Tscrpt_reg_SgrR', 4, NULL),
(16518, NULL, 'IPR019863', NULL, 'Gliding-associated putative ABC transporter substrate-binding GldG', 'Motility-assoc_ABC-rel_GldG', 4, NULL),
(16519, NULL, 'IPR016889', NULL, 'Uncharacterised conserved protein UCP028503', 'UCP028503', 4, NULL),
(16520, NULL, 'IPR017311', NULL, 'Peptidase S8A, subtilisin-related, Sama-2696-type', 'Sama-2696', 4, NULL),
(16521, NULL, 'IPR018303', NULL, 'P-type ATPase, phosphorylation site', 'ATPase_P-typ_P_site', 6, NULL),
(16522, NULL, 'IPR023777', NULL, 'Amino acid/peptide transporter family, dipeptide permease D', 'AA/pep_transptr_DtpD', 4, NULL),
(16523, NULL, 'IPR022618', NULL, 'Defensin-like protein 20-28', 'Defensin-like_20-28', 4, NULL),
(16524, NULL, 'IPR022739', NULL, 'Polyphenol oxidase, central domain', 'Polyphenol_oxidase_cen', 3, NULL),
(16525, NULL, 'IPR019860', NULL, 'Gliding motility-associated ABC transporter permease protein GldF', 'Motility-assoc_ABC_perm_GldF', 4, NULL),
(16526, NULL, 'IPR023839', NULL, 'Firmicutes EssC, C-terminal', 'Firmicutes_EssC_C', 3, NULL),
(16527, NULL, 'IPR023875', NULL, 'DNA metabolism protein, putative', 'DNA_metab_put', 4, NULL),
(16528, NULL, 'IPR035489', NULL, 'MYO15B, SH3 domain', 'MYO15B_SH3', 3, NULL),
(16529, NULL, 'IPR022709', NULL, 'Protein SCAI', 'SCAI', 4, NULL),
(16530, NULL, 'IPR018667', NULL, 'Domain of unknown function DUF2126', 'DUF2126', 3, NULL),
(16531, NULL, 'IPR016881', NULL, 'Uncharacterised conserved protein UCP028340', 'UCP028340', 4, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(16532, NULL, 'IPR023894', NULL, 'Sporulation delaying protein SdpB', 'Sporulation_SdpB', 4, NULL),
(16533, NULL, 'IPR022651', NULL, 'S-layer protein, C-terminal', 'S_layer_C', 3, NULL),
(16534, NULL, 'IPR017304', NULL, 'Cytoplasmic protein NCK', 'NCK', 4, NULL),
(16535, NULL, 'IPR020147', NULL, 'Inhibitor of dGTPase, bacteriophage T7-like', 'Phage_T7-like_1.2', 4, NULL),
(16536, NULL, 'IPR022710', NULL, 'Metallothionein domain, yeast', 'Metalthion_dom_yeast', 3, NULL),
(16537, NULL, 'IPR022678', NULL, 'Glycylpeptide N-tetradecanoyltransferase, conserved site', 'NMT_CS', 2, NULL),
(16538, NULL, 'IPR023535', NULL, 'Threonylcarbamoyl-AMP synthase', 'TC-AMP_synthase', 4, NULL),
(16539, NULL, 'IPR022647', NULL, 'Recombinase Flp protein, N-terminal', 'Recombinase_Flp_N', 3, NULL),
(16540, NULL, 'IPR019395', NULL, 'Transmembrane protein 161A/B', 'Transmembrane_161A/B', 4, NULL),
(16541, NULL, 'IPR019862', NULL, 'Gliding motility-associated protein GldE', 'Motility-assoc_prot_GldE', 4, NULL),
(16542, NULL, 'IPR022641', NULL, 'Chemotaxis receptor methyltransferase CheR, N-terminal', 'CheR_N', 3, NULL),
(16543, NULL, 'IPR023322', NULL, 'Outer surface lipoprotein domain superfamily', 'OM_lipoprot_dom_sf', 5, NULL),
(16544, NULL, 'IPR023541', NULL, 'rRNA small subunit methyltransferase B, enterobacteriaceae', 'rRNA_ssu_MeTfrase_B_ent', 4, NULL),
(16545, NULL, 'IPR016895', NULL, 'Uncharacterised conserved protein UCP028680', 'UCP028680', 4, NULL),
(16546, NULL, 'IPR018655', NULL, 'Protein of unknown function DUF2086', 'DUF2086', 4, NULL),
(16547, NULL, 'IPR035492', NULL, 'FNBP1, SH3 domain', 'FNBP1_SH3', 3, NULL),
(16548, NULL, 'IPR019060', NULL, 'Domain of unknown function DUF2382', 'DUF2382', 3, NULL),
(16549, NULL, 'IPR017623', NULL, '2-ketocyclohexanecarboxyl-CoA hydrolase', 'Keto-benzo_CoA_Hydrolase', 4, NULL),
(16550, NULL, 'IPR023577', NULL, 'CYTH domain', 'CYTH_domain', 3, NULL),
(16551, NULL, 'IPR022680', NULL, 'Methyl-coenzyme M reductase, beta subunit, N-terminal', 'Me_CoM_Rdtase_bsu_N', 3, NULL),
(16552, NULL, 'IPR023749', NULL, 'Co-chaperone DjlA', 'DjlA', 4, NULL),
(16553, NULL, 'IPR019864', NULL, 'Gliding motility-associated ABC transporter ATP-binding subunit GldA', 'Motility-assoc_ABC_GldA', 4, NULL),
(16554, NULL, 'IPR018955', NULL, 'Branched-chain alpha-ketoacid dehydrogenase kinase/Pyruvate dehydrogenase kinase, N-terminal', 'BCDHK/PDK_N', 3, NULL),
(16555, NULL, 'IPR023793', NULL, '2-keto-4-pentenoate hydratase', 'Keto_pentenoate-hydratase', 4, NULL),
(16556, NULL, 'IPR023632', NULL, 'ATP synthase, F1 complex, gamma subunit conserved site', 'ATP_synth_F1_gsu_CS', 2, NULL),
(16557, NULL, 'IPR035494', NULL, 'FNBP1L, F-BAR domain', 'FNBP1L_F-BAR', 3, NULL),
(16558, NULL, 'IPR022656', NULL, 'XPA, C-terminal', 'XPA_C', 3, NULL),
(16559, NULL, 'IPR022703', NULL, 'Domain of unknown function DUF3533', 'DUF3533', 3, NULL),
(16560, NULL, 'IPR022612', NULL, 'Long-chain fatty aldehyde decarbonylase', 'Ald_deCOase', 4, NULL),
(16561, NULL, 'IPR018299', NULL, 'Alkaline phosphatase, active site', 'Alkaline_phosphatase_AS', 0, NULL),
(16562, NULL, 'IPR035498', NULL, 'Caskin1/2, SAM repeat 2', 'Caskin1/2_SAM_2', 3, NULL),
(16563, NULL, 'IPR019063', NULL, 'Restriction endonuclease, type II, LlaMI', 'Restrct_endonuc_II_LlaMI', 4, NULL),
(16564, NULL, 'IPR018650', NULL, 'Sulfolobus virus STSV1, Orf64', 'STSV1_Orf64', 4, NULL),
(16565, NULL, 'IPR022711', NULL, 'Ribonuclease Y, N-terminal', 'RNase_Y_N', 3, NULL),
(16566, NULL, 'IPR023382', NULL, 'tRNA-specific 2-thiouridylase MnmA-like, central domain superfamily', 'MnmA-like_central_sf', 5, NULL),
(16567, NULL, 'IPR017303', NULL, 'Mitochondrial import inner membrane translocase subunit Tim44', 'Tim44', 4, NULL),
(16568, NULL, 'IPR018027', NULL, 'Asn/Gln amidotransferase', 'Asn/Gln_amidotransferase', 3, NULL),
(16569, NULL, 'IPR018643', NULL, 'Protein of unknown function DUF2069, membrane', 'DUF2069_membrane', 4, NULL),
(16570, NULL, 'IPR023845', NULL, 'Domain of unknown function DUF3817, transmembrane', 'DUF3817_TM', 3, NULL),
(16571, NULL, 'IPR023533', NULL, 'Ribosomal protein S6--L-glutamate ligase RimK', 'RimK', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(16572, NULL, 'IPR016887', NULL, 'Uncharacterised conserved protein UCP028470, steroid isomerase-related', 'UCP028470_steroid_isom-rel', 4, NULL),
(16573, NULL, 'IPR023758', NULL, 'tRNA-modifying protein YgfZ', 'tRNA-modifying_YgfZ', 4, NULL),
(16574, NULL, 'IPR017634', NULL, 'Benzoyl-CoA oxygenase/reductase, BoxA protein', 'Benzoyl_CoA_Oase_BoxA', 4, NULL),
(16575, NULL, 'IPR022704', NULL, 'Protein of unknown function DUF2746', 'DUF2746', 4, NULL),
(16576, NULL, 'IPR022631', NULL, 'S-adenosylmethionine synthetase, conserved site', 'ADOMET_SYNTHASE_CS', 2, NULL),
(16577, NULL, 'IPR017642', NULL, 'DNA sulphur modification protein DndB', 'DNA_S_mod_DndB', 4, NULL),
(16578, NULL, 'IPR022707', NULL, 'Mot1, central domain', 'Mot1_central_dom', 3, NULL),
(16579, NULL, 'IPR023679', NULL, 'Uncharacterised protein family UPF0761, bacterial', 'UPF0761_bac', 4, NULL),
(16580, NULL, 'IPR019877', NULL, 'Succinyldiaminopimelate transaminase, DapC', 'DapC', 4, NULL),
(16581, NULL, 'IPR023842', NULL, 'Bacillithiol biosynthesis deacetylase, BshB1', 'Bacillithiol_biosynth_BshB1', 4, NULL),
(16582, NULL, 'IPR022672', NULL, 'Hexokinase, N-terminal', 'Hexokinase_N', 3, NULL),
(16583, NULL, 'IPR035480', NULL, 'SH3PXD2B, SH3 domain 4', 'SH3PXD2B_SH3_4', 3, NULL),
(16584, NULL, 'IPR019406', NULL, 'Aprataxin and PNK-like factor, PBZ domain', 'APLF_PBZ', 3, NULL),
(16585, NULL, 'IPR023591', NULL, 'Ribosomal protein S2, flavodoxin-like domain superfamily', 'Ribosomal_S2_flav_dom_sf', 5, NULL),
(16586, NULL, 'IPR022613', NULL, 'Calmodulin-regulated spectrin-associated protein-like, Calponin-homology domain', 'CAMSAP-like_CH_dom', 3, NULL),
(16587, NULL, 'IPR019397', NULL, 'Uncharacterised protein family TMEM39', 'Uncharacterised_TMEM39', 4, NULL),
(16588, NULL, 'IPR023602', NULL, 'Riboflavin kinase domain, CTP-dependent', 'Riboflavin_kinase_CTP-dep', 3, NULL),
(16589, NULL, 'IPR016888', NULL, 'Uncharacterised conserved protein UCP028498', 'UCP028498', 4, NULL),
(16590, NULL, 'IPR018297', NULL, 'Adenylyl cyclase class-4/guanylyl cyclase, conserved site', 'A/G_cyclase_CS', 2, NULL),
(16591, NULL, 'IPR022595', NULL, 'Enterobacter phage Enc34, ssDNA-binding protein', 'Enc34_ssDNA-bd', 4, NULL),
(16592, NULL, 'IPR022664', NULL, 'Dihydrodipicolinate reductase, conserved site', 'DapB_N_CS', 2, NULL),
(16593, NULL, 'IPR022667', NULL, 'Formylmethanofuran: tetrahydromethanopterin formyltransferase Ftr, N-terminal', 'ForMFR_H4MPT_ForTrfase_N', 3, NULL),
(16594, NULL, 'IPR019874', NULL, 'Protein-(glutamine-N5) methyltransferase, release factor-specific', 'Release_fac_Glu-N5_MeTfrase', 4, NULL),
(16595, NULL, 'IPR019420', NULL, '7TM GPCR, serpentine receptor class bc (Srbc)', '7TM_GPCR_serpentine_rcpt_Srbc', 4, NULL),
(16596, NULL, 'IPR023547', NULL, 'Digeranylgeranylglyceryl phosphate synthase', 'DGGGP_synth', 4, NULL),
(16597, NULL, 'IPR019881', NULL, 'Diaminopimelate aminotransferase, DapL, Desulfovibrio-type', 'DAP-NH2Trfase_DapL_Desulfo', 4, NULL),
(16598, NULL, 'IPR019867', NULL, 'Gliding motility-associated lipoprotein GldK, short form', 'Glid_motil-assoc_GldK_short', 4, NULL),
(16599, NULL, 'IPR019089', NULL, 'CRISPR-associated protein, GSU0054', 'Cas_GSU0054', 4, NULL),
(16600, NULL, 'IPR022695', NULL, 'Histidinol dehydrogenase, monofunctional', 'Histidinol_DH_monofunct', 4, NULL),
(16601, NULL, 'IPR019067', NULL, 'Restriction endonuclease, type II, MamI', 'Restrct_endonuc_II_MamI', 4, NULL),
(16602, NULL, 'IPR019865', NULL, 'Gliding motility-associated lipoprotein GldJ', 'Glid_motil-assoc_lipo_GldJ', 4, NULL),
(16603, NULL, 'IPR022684', NULL, 'Peptidase C2, calpain family', 'Calpain_cysteine_protease', 4, NULL),
(16604, NULL, 'IPR019399', NULL, 'Parkin co-regulated protein', 'Parkin_co-regulated_protein', 4, NULL),
(16605, NULL, 'IPR023482', NULL, 'Uncharacterised protein family Ves', 'Uncharacterised_Ves', 4, NULL),
(16606, NULL, 'IPR023791', NULL, '2-hydroxy-6-oxononadienedioate/2-hydroxy-6-oxononatrienedioate hydrolase', 'MhpC_alpha/beta_hydrolase', 4, NULL),
(16607, NULL, 'IPR023776', NULL, 'Anti-adapter protein, IraD', 'Anti-adapt_IraD', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(16608, NULL, 'IPR019044', NULL, 'Restriction endonuclease, type II, HindVP', 'Restrct_endonuc_II_HindVP', 4, NULL),
(16609, NULL, 'IPR022594', NULL, 'Autographa californica nuclear polyhedrosis virus (AcMNPV), 30.6kDa', 'AcMNPV_30.6kDa', 4, NULL),
(16610, NULL, 'IPR019859', NULL, 'Gliding motility-associated protein GldM', 'Motility-assoc_prot_GldM', 4, NULL),
(16611, NULL, 'IPR035493', NULL, 'FNBP1L, SH3 domain', 'FNBP1L_SH3', 3, NULL),
(16612, NULL, 'IPR019064', NULL, 'Type-2 restriction enzyme NlaIV', 'Restrct_endonuc_II_NlaIV', 4, NULL),
(16613, NULL, 'IPR035495', NULL, 'Caskin-1, SH3 domain', 'Caskin1_SH3', 3, NULL),
(16614, NULL, 'IPR023510', NULL, 'Methylmalonate-semialdehyde dehydrogenase, Gram-positive bacteria', 'MSDH_GmP_bac', 4, NULL),
(16615, NULL, 'IPR023780', NULL, 'Chromo domain', 'Chromo_domain', 3, NULL),
(16616, NULL, 'IPR022611', NULL, 'Protein suppressor of silencing, bacteriophage T7', 'Phage_T7_5.5', 4, NULL),
(16617, NULL, 'IPR022630', NULL, 'S-adenosylmethionine synthetase, C-terminal', 'S-AdoMet_synt_C', 3, NULL),
(16618, NULL, 'IPR021158', NULL, 'Peptidase M10A, cysteine switch, zinc binding site', 'Pept_M10A_Zn_BS', 1, NULL),
(16619, NULL, 'IPR022732', NULL, 'Peptidase S54, GlpG peptidase, N-terminal', 'Peptidase_S54_GlpG_N', 3, NULL),
(16620, NULL, 'IPR023545', NULL, 'rRNA small subunit methyltransferase F', 'rRNA_ssu_MeTfrase_F', 4, NULL),
(16621, NULL, 'IPR023606', NULL, 'CoA-transferase family III domain 1 superfamily', 'CoA-Trfase_III_dom_1_sf', 5, NULL),
(16622, NULL, 'IPR022603', NULL, 'Domain of unknown function DUF3152', 'DUF3152', 3, NULL),
(16623, NULL, 'IPR023789', NULL, '2,3-dihydroxyphenylpropionate/2,3-dihydroxicinnamic acid 1,2-dioxygenase', 'DHPP/DHXA_dioxygenase', 4, NULL),
(16624, NULL, 'IPR023838', NULL, 'Type VII secretion system EsaA', 'T7SS_EsaA', 3, NULL),
(16625, NULL, 'IPR023784', NULL, '2-oxoglutarate dehydrogenase E1 component, bacterial', '2oxoglutarate_DH_E1_bac', 4, NULL),
(16626, NULL, 'IPR019994', NULL, 'Conserved hypothetical protein CHP03492', 'CHP03492', 4, NULL),
(16627, NULL, 'IPR035491', NULL, 'ARHGAP12, SH3 domain', 'ARHGAP12_SH3', 3, NULL),
(16628, NULL, 'IPR023387', NULL, 'DUF1653-like domain', 'DUF1653-like_dom', 3, NULL),
(16629, NULL, 'IPR019051', NULL, 'Trp biosynthesis associated, transmembrane protein, Oprn/Chp', 'Trp_biosyn_TM_oprn/chp', 4, NULL),
(16630, NULL, 'IPR019425', NULL, '7TM GPCR, serpentine receptor class t (Srt)', '7TM_GPCR_serpentine_rcpt_Srt', 4, NULL),
(16631, NULL, 'IPR018317', NULL, 'Queuosine biosynthesis protein QueC', 'QueC', 4, NULL),
(16632, NULL, 'IPR019870', NULL, 'Selenium metabolism protein YedF', 'Se_metab_YedF', 4, NULL),
(16633, NULL, 'IPR019404', NULL, 'Mediator complex, subunit Med11', 'Mediator_Med11', 4, NULL),
(16634, NULL, 'IPR023542', NULL, 'rRNA large subunit methyltransferase I', 'rRNA_lsu_MeTfrase_I', 4, NULL),
(16635, NULL, 'IPR019424', NULL, 'Serpentine type 7TM GPCR chemoreceptor Srsx', '7TM_GPCR_Srsx', 4, NULL),
(16636, NULL, 'IPR022859', NULL, 'Alginate lyase', 'Alginate_lyase', 4, NULL),
(16637, NULL, 'IPR016884', NULL, 'Uncharacterised conserved protein UCP028438', 'UCP028438', 4, NULL),
(16638, NULL, 'IPR023531', NULL, 'Preprotein translocase subunit SecG', 'Preprot_translocase_SecG', 4, NULL),
(16639, NULL, 'IPR023158', NULL, 'YerB-like superfamily', 'YerB-like_sf', 5, NULL),
(16640, NULL, 'IPR023351', NULL, 'YppE-like superfamily', 'YppE-like_sf', 5, NULL),
(16641, NULL, 'IPR023729', NULL, 'K(+)/H(+) antiporter NhaP2', 'NhaP2', 4, NULL),
(16642, NULL, 'IPR023779', NULL, 'Chromo domain, conserved site', 'Chromodomain_CS', 2, NULL),
(16643, NULL, 'IPR022706', NULL, 'Antifungal protein', 'Antifungal_prot', 4, NULL),
(16644, NULL, 'IPR022677', NULL, 'Glycylpeptide N-tetradecanoyltransferase, C-terminal', 'NMT_C', 3, NULL),
(16645, NULL, 'IPR023521', NULL, 'Translation release factor  pelota, archaea', 'Pelota_arc', 4, NULL),
(16646, NULL, 'IPR019402', NULL, 'Frag1/DRAM/Sfk1', 'Frag1/DRAM/Sfk1', 4, NULL),
(16647, NULL, 'IPR023551', NULL, 'Iron-sulfur cluster repair protein ScdA', 'ScdA', 4, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(16648, NULL, 'IPR033999', NULL, 'Fas receptor, N-terminal', 'TNFRSF6_N', 3, NULL),
(16649, NULL, 'IPR017317', NULL, 'Peptidase S8A, subtilisin-related, bacteroidetes-2', 'Pept_S8_subtilisin_bacteroid-2', 4, NULL),
(16650, NULL, 'IPR023713', NULL, 'Endonuclease VIII', 'Endonuclease-VIII', 4, NULL),
(16651, NULL, 'IPR022625', NULL, 'Type I restriction enzyme R protein, C-terminal', 'TypeI_RM_Rsu_C', 3, NULL),
(16652, NULL, 'IPR023836', NULL, 'EccCa-like, Actinobacteria', 'EccCa-like_Actinobacteria', 4, NULL),
(16653, NULL, 'IPR020006', NULL, 'Flagellar biosynthesis protein FlhF', 'FlhF', 4, NULL),
(16654, NULL, 'IPR022673', NULL, 'Hexokinase, C-terminal', 'Hexokinase_C', 3, NULL),
(16655, NULL, 'IPR023787', NULL, 'Type III secretion system flagellar brake protein YcgR', 'T3SS_YcgR', 4, NULL),
(16656, NULL, 'IPR019087', NULL, 'Mediator of RNA polymerase II transcription subunit 15', 'Med15', 4, NULL),
(16657, NULL, 'IPR023831', NULL, 'C-terminal-processing peptidase S41A, putative', 'Pept_41A_put', 4, NULL),
(16658, NULL, 'IPR023834', NULL, 'Type VII secretion system peptidase S8A, mycosin', 'T7SS_pept_S8A_mycosin', 4, NULL),
(16659, NULL, 'IPR022742', NULL, 'Serine aminopeptidase, S33', 'Hydrolase_4', 3, NULL),
(16660, NULL, 'IPR023480', NULL, 'Uncharacterised protein family UPF0312/YceI', 'UPF0312/YceI', 4, NULL),
(16661, NULL, 'IPR023869', NULL, 'tRNA adenosine deaminase-associated protein, putative', 'tRNA_Adeno_NH3ase_assoc_put', 4, NULL),
(16662, NULL, 'IPR020011', NULL, 'Motility protein FimV, C-terminal', 'Motility_prot_FimV_C', 3, NULL),
(16663, NULL, 'IPR017635', NULL, 'Benzoyl-CoA oxygenase, B subunit', 'Benzoyl_CoA_Oase_BoxB_bsu', 4, NULL),
(16664, NULL, 'IPR023483', NULL, 'Uncharacterised protein family SprT', 'Uncharacterised_SprT', 4, NULL),
(16665, NULL, 'IPR019056', NULL, 'Phage tail assembly chaperone protein, TAC6', 'Phage_TAC_6', 4, NULL),
(16666, NULL, 'IPR035412', NULL, 'Phage terminase large subunit, N-terminal', 'Terminase_L_N', 3, NULL),
(16667, NULL, 'IPR023548', NULL, 'Probable Brix domain-containing ribosomal biogenesis protein', 'Brix_dom_Rbsml_bgen_prot', 4, NULL),
(16668, NULL, 'IPR023852', NULL, 'Metalloproteinase lipoprotein, BF0631', 'Metalloproteinase_lipop_BF0631', 4, NULL),
(16669, NULL, 'IPR023712', NULL, '3-phenylpropionate/cinnamic acid dioxygenase, beta subunit', 'HcaF', 4, NULL),
(16670, NULL, 'IPR023733', NULL, 'Pyrophosphatase PpaX', 'Pyrophosphatase_Ppax', 4, NULL),
(16671, NULL, 'IPR022655', NULL, 'Domain of unknown function DUF1553', 'DUF1553', 3, NULL),
(16672, NULL, 'IPR022738', NULL, 'Adenylylsulphate reductase, beta subunit, C-terminal', 'AprB_C', 3, NULL),
(16673, NULL, 'IPR022627', NULL, 'Domain of unknown function DUF3502', 'DUF3502', 3, NULL),
(16674, NULL, 'IPR016893', NULL, 'Protein of unknown function UCP028589', 'UCP028589', 4, NULL),
(16675, NULL, 'IPR022676', NULL, 'Glycylpeptide N-tetradecanoyltransferase, N-terminal', 'NMT_N', 3, NULL),
(16676, NULL, 'IPR019999', NULL, 'Anthranilate synthase component I-like', 'Anth_synth_I-like', 4, NULL),
(16677, NULL, 'IPR022665', NULL, 'Methylaspartate ammonia-lyase, N-terminal', 'MeAsp_NH4-lyase_N', 3, NULL),
(16678, NULL, 'IPR017300', NULL, 'Na(+)/H(+) exchange regulatory cofactor NHERF-1/2', 'NHERF-1/NHERF-2', 4, NULL),
(16679, NULL, 'IPR021183', NULL, 'N-terminal acetyltransferase A, auxiliary subunit', 'NatA_aux_su', 4, NULL),
(16680, NULL, 'IPR018649', NULL, 'SHOCT domain', 'SHOCT', 3, NULL),
(16681, NULL, 'IPR019059', NULL, 'Restriction endonuclease, type II, HaeIII', 'Restrct_endonuc_II_HaeIII', 4, NULL),
(16682, NULL, 'IPR022622', NULL, 'Domain of unknown function DUF3492', 'DUF3492', 3, NULL),
(16683, NULL, 'IPR019052', NULL, 'Domain of unknown function DUF2383', 'DUF2383', 3, NULL),
(16684, NULL, 'IPR019043', NULL, 'Restriction endonuclease, type II, HindIII', 'Restrct_endonuc_II_HindIII', 4, NULL),
(16685, NULL, 'IPR018658', NULL, 'Protein of unknown function DUF2089', 'DUF2089', 4, NULL),
(16686, NULL, 'IPR018648', NULL, 'Protein of unknown function DUF2076', 'DUF2076', 4, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(16687, NULL, 'IPR019412', NULL, 'Inclusion body clearance protein Iml2/Tetratricopeptide repeat protein 39', 'Iml2/TPR_39', 4, NULL),
(16688, NULL, 'IPR018652', NULL, 'Protein of unknown function DUF2082, nucleic-acid-binding, Zn-ribbon', 'DUF2082_NA-bd_Znr', 4, NULL),
(16689, NULL, 'IPR018300', NULL, 'Aminotransferase, class IV, conserved site', 'Aminotrans_IV_CS', 2, NULL),
(16690, NULL, 'IPR023123', NULL, 'Tubulin, C-terminal', 'Tubulin_C', 5, NULL),
(16691, NULL, 'IPR023781', NULL, 'Nucleoside triphosphatase NudI', 'Nucleoside_triphosphatase_NudI', 4, NULL),
(16692, NULL, 'IPR023538', NULL, 'Ribonuclease P protein subunit RNP1', 'RNP1', 4, NULL),
(16693, NULL, 'IPR022877', NULL, 'Protein of unknown funcion UPF0173', 'UPF0173', 4, NULL),
(16694, NULL, 'IPR023539', NULL, 'Ribonuclease P, protein component 3, archaeal', 'RNase_P_comp-3_arc', 4, NULL),
(16695, NULL, 'IPR017309', NULL, 'Peptidase S8A, subtilisin-related, proteobacteria', 'Pept_S8A_subtilisin_proteobac', 4, NULL),
(16696, NULL, 'IPR018642', NULL, 'Protein of unknown function DUF2066', 'DUF2066', 4, NULL),
(16697, NULL, 'IPR017313', NULL, 'Peptidase S8A, subtilisin-related, Moth-2364-type', 'Moth2364', 4, NULL),
(16698, NULL, 'IPR022623', NULL, 'Glycosyl transferase family 4 domain', 'Glyco_trans_4_3', 3, NULL),
(16699, NULL, 'IPR023768', NULL, 'Transcriptional regulator HTH-type, MalT', 'Tscrpt_reg_HTH_MalT', 4, NULL),
(16700, NULL, 'IPR018036', NULL, 'Protein of unknown function DUF429, subgroup', 'DUF429_subgr', 4, NULL),
(16701, NULL, 'IPR017308', NULL, 'Peptidase S8A, subtilisin-related, bacteroidetes', 'Pept_S8_subtilisin_bacteroid', 4, NULL),
(16702, NULL, 'IPR018022', NULL, 'IPP transferase', 'IPT', 4, NULL),
(16703, NULL, 'IPR023778', NULL, 'Amino acid/peptide transporter family, dipeptide/tripeptide permease B', 'AA/pep_transptr_DtpB', 4, NULL),
(16704, NULL, 'IPR020008', NULL, 'GlyGly-CTERM domain', 'GlyGly_CTERM', 3, NULL),
(16705, NULL, 'IPR023517', NULL, 'Amino acid/peptide transporter family, dipeptide and tripeptide permease A', 'AA/pep_transptr_DtpA', 4, NULL),
(16706, NULL, 'IPR022593', NULL, '2-oxoisovalerate dehydrogenase, E1 alpha subunit, N-terminal domain', 'Oxoisoval_DH_suAlpha_N_dom', 3, NULL),
(16707, NULL, 'IPR018296', NULL, 'Acid phosphatase, class A, bacterial, conserved site', 'Acid_Pase_classA_bac_CS', 2, NULL),
(16708, NULL, 'IPR022727', NULL, 'Pupal cuticle protein C1', 'Cuticle_C1', 4, NULL),
(16709, NULL, 'IPR023843', NULL, 'CRISPR-associated protein Cas1, cyanobacteria-type', 'CRISPR-assoc_Cas1_cyanobact', 4, NULL),
(16710, NULL, 'IPR019068', NULL, 'Restriction endonuclease, type II, MjaI', 'Restrct_endonuc_II_MjaI', 4, NULL),
(16711, NULL, 'IPR019076', NULL, 'Sporulation lipoprotein YhcN/YlaJ-like', 'Spore_lipoprot_YhcN/YlaJ-like', 4, NULL),
(16712, NULL, 'IPR023543', NULL, 'rRNA small subunit methyltransferase C', 'rRNA_ssu_MeTfrase_C', 4, NULL),
(16713, NULL, 'IPR019050', NULL, 'FDF domain', 'FDF_dom', 3, NULL),
(16714, NULL, 'IPR022687', NULL, 'DTXR-type HTH domain', 'HTH_DTXR', 3, NULL),
(16715, NULL, 'IPR017297', NULL, 'Peptidase S8A, DPH-A', 'Peptidase_S8A_DPH-A', 4, NULL),
(16716, NULL, 'IPR022713', NULL, 'Proteinase inhibitor I67, bromein', 'Prot_inhib_I67_bromein', 3, NULL),
(16717, NULL, 'IPR022697', NULL, 'Homoserine dehydrogenase lacking ACT domain', 'HDH_short', 4, NULL),
(16718, NULL, 'IPR022721', NULL, 'Protein of unknown function DUF3561', 'DUF3561', 4, NULL),
(16719, NULL, 'IPR023730', NULL, 'HTH-type transcriptional repressor NanR', 'Tscrpt_reg_NanR', 4, NULL),
(16720, NULL, 'IPR018446', NULL, 'Corticotropin-releasing factor conserved site', 'Corticotropin-releasing_fac_CS', 2, NULL),
(16721, NULL, 'IPR019861', NULL, 'Type IX secretion system membrane protein, PorP/SprF family', 'PorP/SprF_Bacteroidetes', 4, NULL),
(16722, NULL, 'IPR023494', NULL, 'Cytochrome c biogenesis protein Ccs1/CcsB/ResB', 'Cyt_c_bgen_Ccs1/CcsB/ResB', 4, NULL),
(16723, NULL, 'IPR019875', NULL, '2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-succinyltransferase, actinobacteria', 'DapD_actinobacteria', 4, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(16724, NULL, 'IPR022659', NULL, 'Proliferating cell nuclear antigen, PCNA, conserved site', 'Pr_cel_nuc_antig_CS', 2, NULL),
(16725, NULL, 'IPR023586', NULL, 'Isoleucine-tRNA ligase, type 2', 'Ile-tRNA-ligase_type2', 4, NULL),
(16726, NULL, 'IPR018301', NULL, 'Aromatic amino acid hydroxylase, iron/copper binding site', 'ArAA_hydroxylase_Fe/CU_BS', 1, NULL),
(16727, NULL, 'IPR023532', NULL, 'H/ACA ribonucleoprotein complex subunit Nop10 , archaeal-type', 'Nop10_arc-typ', 4, NULL),
(16728, NULL, 'IPR023546', NULL, 'Methylated-DNA--protein-cysteine methyltransferase', 'MGMT', 4, NULL),
(16729, NULL, 'IPR017643', NULL, 'Hydroxypyruvate isomerase', 'Hydroxypyruvate_isomerase', 4, NULL),
(16730, NULL, 'IPR023496', NULL, 'Deoxyhypusine synthase-like', 'Deoxyhypusine_synthase-like', 4, NULL),
(16731, NULL, 'IPR017632', NULL, '2-oxopent-4-enoate hydratase', '2-oxopent-4-enoate_hydratase', 4, NULL),
(16732, NULL, 'IPR017645', NULL, 'DNA phosphorothioation-dependent restriction protein DptG', 'Dnd_assoc_1', 4, NULL),
(16733, NULL, 'IPR016882', NULL, 'Uncharacterised protein family UPF0374', 'UPF0374', 4, NULL),
(16734, NULL, 'IPR023136', NULL, 'Api92-like domain superfamily', 'Api92-like_dom_sf', 5, NULL),
(16735, NULL, 'IPR022714', NULL, 'Protein of unknown function DUF2670', 'DUF2670', 4, NULL),
(16736, NULL, 'IPR019422', NULL, '7TM GPCR, serpentine receptor class h (Srh)', '7TM_GPCR_serpentine_rcpt_Srh', 4, NULL),
(16737, NULL, 'IPR018653', NULL, 'Short-chain fatty acyl coenzyme A regulators, C-terminal', 'ScfR_C', 3, NULL),
(16738, NULL, 'IPR019411', NULL, 'MMM1 domain', 'MMM1_dom', 3, NULL),
(16739, NULL, 'IPR022642', NULL, 'MCP methyltransferase, CheR-type, SAM-binding domain, C-terminal', 'CheR_C', 3, NULL),
(16740, NULL, 'IPR022740', NULL, 'Polyphenol oxidase, C-terminal', 'Polyphenol_oxidase_C', 3, NULL),
(16741, NULL, 'IPR017310', NULL, 'Peptidase S8A, subtilisin-related, clostridia', 'Pept_S8A_subtilisin_clostridia', 4, NULL),
(16742, NULL, 'IPR019876', NULL, '2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-succinyltransferase, gammaproteobacteria', 'DapD_gammaproteobac', 4, NULL),
(16743, NULL, 'IPR023795', NULL, 'Serpin, conserved site', 'Serpin_CS', 2, NULL),
(16744, NULL, 'IPR019413', NULL, 'DSC E3 ubiquitin ligase complex subunit 3, ubiquitin-like domain', 'Dsc3_ub-like_dom', 3, NULL),
(16745, NULL, 'IPR023528', NULL, 'Major facilitator superfamily transporter, TsgA', 'MFS_TsgA', 4, NULL),
(16746, NULL, 'IPR022629', NULL, 'S-adenosylmethionine synthetase, central domain', 'S-AdoMet_synt_central', 3, NULL),
(16747, NULL, 'IPR019046', NULL, 'Restriction endonuclease, type II, NgoPII', 'Restrct_endonuc_II_NgoPII', 4, NULL),
(16748, NULL, 'IPR018298', NULL, 'Adrenodoxin, iron-sulphur binding site', 'Adrenodoxin_Fe-S_BS', 1, NULL),
(16749, NULL, 'IPR021185', NULL, 'Tumour necrosis factor family protein, CD30 ligand type', 'TNF_CD30_ligand_type', 4, NULL),
(16750, NULL, 'IPR019407', NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', 'CTU2', 4, NULL),
(16751, NULL, 'IPR017628', NULL, '2-hydroxymuconic semialdehyde dehydrogenase', 'OHmuconic_semiald_DH', 4, NULL),
(16752, NULL, 'IPR019069', NULL, 'Restriction endonuclease, type II, ScaI', 'Restrct_endonuc_II_ScaI', 4, NULL),
(16753, NULL, 'IPR021081', NULL, 'Nepovirus subgroup A, RNA2 polyprotein, Protein 2A', 'Nepovirus_subgr_A_2A', 3, NULL),
(16754, NULL, 'IPR019058', NULL, 'Restriction endonuclease, type II, HaeII', 'Restrct_endonuc_II_HaeII', 4, NULL),
(16755, NULL, 'IPR023481', NULL, 'Uncharacterised protein family ViaA', 'Uncharacterised_ViaA', 4, NULL),
(16756, NULL, 'IPR021083', NULL, 'Nuclear abundant poly(A) RNA-binding protein Nab2, N-terminal', 'Nab2_N', 3, NULL),
(16757, NULL, 'IPR018654', NULL, 'Putative toxin of bacterial toxin-antitoxin pair', 'YjhX_toxin', 4, NULL),
(16758, NULL, 'IPR023385', NULL, 'YopX-like, C-terminal', 'YopX-like_C', 5, NULL),
(16759, NULL, 'IPR023653', NULL, 'Acetoacetate decarboxylase, bacterial', 'Acetoacetate_decarboxylase_bac', 4, NULL),
(16760, NULL, 'IPR017319', NULL, 'Subtilisin-like serine protease TK1689-type', 'Subtilisin_TK1689', 4, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(16761, NULL, 'IPR023761', NULL, 'Transcriptional repressor HTH, NsrR', 'Tscrpt_rep_HTH_NsrR', 4, NULL),
(16762, NULL, 'IPR017644', NULL, 'Cysteine desulfurase DndA', 'Cysteine_desulfurase_DndA', 4, NULL),
(16763, NULL, 'IPR023216', NULL, 'Transcription regulator SKI/SnoN', 'Tscrpt_reg_SKI_SnoN', 4, NULL),
(16764, NULL, 'IPR017629', NULL, '4-hydroxy-2-oxovalerate aldolase', '4OH_2_O-val_aldolase', 4, NULL),
(16765, NULL, 'IPR022616', NULL, 'Glycosyl hydrolase, family 4, C-terminal', 'Glyco_hydro_4_C', 3, NULL),
(16766, NULL, 'IPR019866', NULL, 'Gliding motility-associated lipoprotein GldK', 'Glid_motil-assoc_lipo_GldK', 4, NULL),
(16767, NULL, 'IPR022601', NULL, 'Protein of unknown function DUF3160', 'DUF3160', 4, NULL),
(16768, NULL, 'IPR023840', NULL, 'Type VII secretion system Rv3446c', 'T7SS_Rv3446c', 4, NULL),
(16769, NULL, 'IPR018660', NULL, 'C-type lysozyme inhibitor', 'MliC', 3, NULL),
(16770, NULL, 'IPR022650', NULL, 'S-layer protein, N-terminal', 'S_layer_N', 3, NULL),
(16771, NULL, 'IPR021182', NULL, 'Protein SOSEKI, magnoliopsida', 'SOK_magnoliopsida', 4, NULL),
(16772, NULL, 'IPR019084', NULL, 'Stm1-like, N-terminal', 'Stm1-like_N', 3, NULL),
(16773, NULL, 'IPR023715', NULL, 'Trehalase, cytoplasmic', 'Cyt_trehalase', 4, NULL),
(16774, NULL, 'IPR018293', NULL, '43kDa postsynaptic, conserved site', 'Postsynaptic_CS', 2, NULL),
(16775, NULL, 'IPR017633', NULL, 'Benzoyl-CoA-dihydrodiol lyase', 'Benz-CoA_dihydrodiol_lyase', 4, NULL),
(16776, NULL, 'IPR023389', NULL, 'DOPA-like superfamily', 'DOPA-like_sf', 5, NULL),
(16777, NULL, 'IPR019868', NULL, 'Gliding motility-associated lipoprotein GldJ-short', 'Glid_motil-assoc_GldJ-short', 4, NULL),
(16778, NULL, 'IPR023549', NULL, 'Subtilisin inhibitor', 'Subtilisin_inhibitor', 3, NULL),
(16779, NULL, 'IPR019995', NULL, 'Cellulose biosynthesis, BcsF/YhjT', 'Cellulose_BcsF/YhjT', 4, NULL),
(16780, NULL, 'IPR019408', NULL, '7TM GPCR, serpentine receptor class ab (Srab)', '7TM_GPCR_serpentine_rcpt_Srab', 4, NULL),
(16781, NULL, 'IPR023738', NULL, 'Maltoporin', 'Maltoporin', 4, NULL),
(16782, NULL, 'IPR020010', NULL, 'Conserved hypothetical protein CHP03503', 'CHP03503', 4, NULL),
(16783, NULL, 'IPR023519', NULL, 'Glyoxylate reductase GyaR', 'Glyoxylate_reductase_GyaR', 4, NULL),
(16784, NULL, 'IPR021078', NULL, 'Membrane-integrating protein Mistic', 'Membrane-integrating_Mistic', 4, NULL),
(16785, NULL, 'IPR022669', NULL, 'Ribosomal protein L2, C-terminal', 'Ribosomal_L2_C', 3, NULL),
(16786, NULL, 'IPR019088', NULL, 'Conserved hypothetical protein CHP02186-related, transmembrane', 'CHP02186-rel_TM', 4, NULL),
(16787, NULL, 'IPR023723', NULL, 'Glucan biosynthesis protein C', 'Glucans_biosynth_C', 4, NULL),
(16788, NULL, 'IPR016897', NULL, 'S-phase kinase-associated protein 1', 'SKP1', 4, NULL),
(16789, NULL, 'IPR018665', NULL, 'Protein of unknown function DUF2122, RecB-family nuclease-related', 'DUF2122_RecB-nuclease-rel', 4, NULL),
(16790, NULL, 'IPR022682', NULL, 'Peptidase C2, calpain, large subunit, domain III', 'Calpain_domain_III', 3, NULL),
(16791, NULL, 'IPR022657', NULL, 'Orn/DAP/Arg decarboxylase 2, conserved site', 'De-COase2_CS', 2, NULL),
(16792, NULL, 'IPR019074', NULL, 'Spore cortex biosynthesis protein, YabQ-like', 'YabQ-like', 4, NULL),
(16793, NULL, 'IPR023121', NULL, 'ApoC-II domain superfamily', 'ApoC-II_dom_sf', 5, NULL),
(16794, NULL, 'IPR017306', NULL, 'Peptidase S8A, fervidolysin-like', 'Peptidase_S8A_fervidolysi-like', 4, NULL),
(16795, NULL, 'IPR023536', NULL, 'Coenzyme A disulphide reductase, staphyolococci', 'CoA_disulphide_reductase_staph', 4, NULL),
(16796, NULL, 'IPR022666', NULL, 'Ribosomal Proteins L2, RNA binding domain', 'Rbsml_prot_L2_RNA-bd_dom', 3, NULL),
(16797, NULL, 'IPR020003', NULL, 'ATPase, alpha/beta subunit, nucleotide-binding domain, active site', 'ATPase_a/bsu_AS', 0, NULL),
(16798, NULL, 'IPR018448', NULL, 'Sec-independent protein translocase protein TatB', 'TatB', 4, NULL),
(16799, NULL, 'IPR023847', NULL, 'Conserved hypothetical protein CHP04044, MSMEG0572', 'CHP04044_MSMEG0572', 4, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(16800, NULL, 'IPR019410', NULL, 'Lysine methyltransferase', 'Methyltransf_16', 4, NULL),
(16801, NULL, 'IPR017625', NULL, 'PuuE allantoinase/chitin deacetylase 1', 'PuuE/SpCDA1', 3, NULL),
(16802, NULL, 'IPR016894', NULL, 'Uncharacterised conserved protein UCP028609', 'UCP028609', 4, NULL),
(16803, NULL, 'IPR022675', NULL, 'Glucose-6-phosphate dehydrogenase, C-terminal', 'G6P_DH_C', 3, NULL),
(16804, NULL, 'IPR019054', NULL, 'Restriction endonuclease, type II, AccI', 'Restrct_endonuc_II_AccI', 4, NULL),
(16805, NULL, 'IPR022674', NULL, 'Glucose-6-phosphate dehydrogenase, NAD-binding', 'G6P_DH_NAD-bd', 3, NULL),
(16806, NULL, 'IPR019049', NULL, 'Nucleoporin protein Ndc1-Nup', 'Nucleoporin_prot_Ndc1/Nup', 4, NULL),
(16807, NULL, 'IPR022658', NULL, 'XPA, conserved site', 'XPA_CS', 2, NULL),
(16808, NULL, 'IPR022652', NULL, 'Zinc finger, XPA-type, conserved site', 'Znf_XPA_CS', 2, NULL),
(16809, NULL, 'IPR019423', NULL, '7TM GPCR, serpentine receptor class j (Srj)', '7TM_GPCR_serpentine_rcpt_Srj', 4, NULL),
(16810, NULL, 'IPR019396', NULL, 'Transmembrane Fragile-X-F-associated protein', 'TM_Fragile-X-F-assoc', 4, NULL),
(16811, NULL, 'IPR018647', NULL, 'Schlafen group 3-like, DNA/RNA helicase domain', 'SLFN_3-like_DNA/RNA_helicase', 3, NULL),
(16812, NULL, 'IPR016892', NULL, 'Uncharacterised conserved protein UCP028583', 'UCP028583', 4, NULL),
(16813, NULL, 'IPR020149', NULL, 'Uncharacterised protein family C02F5.10', 'Uncharacterised_C02F5.10', 4, NULL),
(16814, NULL, 'IPR017298', NULL, 'Transcriptional regulator Ure2', 'Ure2', 4, NULL),
(16815, NULL, 'IPR023720', NULL, 'Trehalase, periplasmic', 'Trehalase_periplasmic', 4, NULL),
(16816, NULL, 'IPR019057', NULL, 'Restriction endonuclease, type II, Eco47II', 'Restrct_endonuc_II_Eco47II', 4, NULL),
(16817, NULL, 'IPR018659', NULL, 'Protein of unknown function DUF2090', 'DUF2090', 3, NULL),
(16818, NULL, 'IPR018644', NULL, 'Protein of unknown function DUF2071', 'DUF2071', 4, NULL),
(16819, NULL, 'IPR022717', NULL, 'Antimicrobial peptide tachystatin A', 'Antimicrobial_tachystatin_A', 4, NULL),
(16820, NULL, 'IPR023702', NULL, 'D-cysteine desulphhydrase, bacterial', 'D_Cys_desulphydr_bac', 4, NULL),
(16821, NULL, 'IPR017638', NULL, 'Anthranilate 1,2-dioxygenase, large subunit', 'Anthranilate_1-2-diOase_lsu', 4, NULL),
(16822, NULL, 'IPR035958', NULL, 'SecB-like superfamily', 'SecB-like_sf', 5, NULL),
(16823, NULL, 'IPR016885', NULL, 'Uncharacterised conserved protein UCP028445', 'UCP028445', 4, NULL),
(16824, NULL, 'IPR016891', NULL, 'Protein of unknown function DUF2321', 'DUF2321', 4, NULL),
(16825, NULL, 'IPR022719', NULL, 'Gliding motility-associated protein GldM, C-terminal', 'Motility-assoc_prot_GldM_C', 3, NULL),
(16826, NULL, 'IPR022636', NULL, 'S-adenosylmethionine synthetase superfamily', 'S-AdoMet_synthetase_sfam', 5, NULL),
(16827, NULL, 'IPR022731', NULL, 'Dermaseptin', 'Dermaseptin', 3, NULL),
(16828, NULL, 'IPR023851', NULL, 'Transcriptional regulator, TetR-type', 'Tscrpt_reg_TetR-type', 4, NULL),
(16829, NULL, 'IPR017637', NULL, 'Putative 2-aminoethylphosphonate binding protein, ABC transporter', 'AminoethylPonate_ABC-bd', 4, NULL),
(16830, NULL, 'IPR023526', NULL, 'Sulphur relay, TusB', 'Sulphur_relay_TusB', 4, NULL),
(16831, NULL, 'IPR022591', NULL, 'Transcription initiation factor TFIID subunit 1, histone acetyltransferase domain', 'TAF1_HAT_dom', 3, NULL),
(16832, NULL, 'IPR016890', NULL, 'Uncharacterised conserved protein UCP028520', 'UCP028520', 4, NULL),
(16833, NULL, 'IPR023850', NULL, 'Peptide chaperone MftB', 'MftB', 4, NULL),
(16834, NULL, 'IPR023124', NULL, 'DUF3239 domain superfamily', 'DUF3239_dom_sf', 5, NULL),
(16835, NULL, 'IPR023833', NULL, 'Signal peptide, camelysin', 'Signal_peptide_camelysin', 3, NULL),
(16836, NULL, 'IPR017641', NULL, 'Benzoate 1,2-dioxygenase, small subunit', 'Benzo_1-2-diOase_ssu', 4, NULL),
(16837, NULL, 'IPR019871', NULL, 'Diaminopropionate ammonia-lyase, subgroup', 'DiNH2propionate_NH3-lyase_sub', 4, NULL),
(16838, NULL, 'IPR016898', NULL, 'Polyphosphate phosphotransferase', 'Polyphosphate_phosphotransfera', 4, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(16839, NULL, 'IPR018666', NULL, 'Protein of unknown function DUF2125', 'DUF2125', 4, NULL),
(16840, NULL, 'IPR018662', NULL, 'Protein of unknown function DUF2095', 'DUF2095', 4, NULL),
(16841, NULL, 'IPR023769', NULL, 'Nucleoid occlusion factor SlmA', 'NO_SlmA', 4, NULL),
(16842, NULL, 'IPR023524', NULL, 'Uncharacterised protein family SprT-like', 'Uncharacterised_SprT-like', 4, NULL),
(16843, NULL, 'IPR023844', NULL, 'CRISPR-associated protein Cas1, MYXAN subtype', 'CRISPR-assoc_Cas1_MYXAN', 4, NULL),
(16844, NULL, 'IPR022614', NULL, 'Herpesvirus UL96 family', 'Herpesvirus_UL96', 4, NULL),
(16845, NULL, 'IPR035971', NULL, 'Cellulose-binding domain superfamily', 'CBD_sf', 5, NULL),
(16846, NULL, 'IPR023743', NULL, 'Aquaporin Z', 'Aquaporin_Z', 4, NULL),
(16847, NULL, 'IPR018663', NULL, 'Protein of unknown function DUF2101, membrane', 'DUF2101_membrane', 4, NULL),
(16848, NULL, 'IPR019416', NULL, 'Nuclear cap-binding protein subunit 3', 'NCBP3', 4, NULL),
(16849, NULL, 'IPR018016', NULL, 'Nucleoside phosphorylase, conserved site', 'Nucleoside_phosphorylase_CS', 2, NULL),
(16850, NULL, 'IPR019872', NULL, 'O-phosphoseryl-tRNA(Sec) selenium transferase', 'Sec-tRNA_Se_transferase', 4, NULL),
(16851, NULL, 'IPR035497', NULL, 'Caskin1/2, SAM repeat 1', 'Caskin1/2_SAM_1', 3, NULL),
(16852, NULL, 'IPR023841', NULL, 'Bacillithiol biosynthesis deacetylase BshB2', 'BshB2', 4, NULL),
(16853, NULL, 'IPR017315', NULL, 'Peptidase S8A, subtilisin-related, proteobacteria-2', 'Pep_S8A_subtilisin_pbac-2', 4, NULL),
(16854, NULL, 'IPR019421', NULL, '7TM GPCR, serpentine receptor class d (Srd)', '7TM_GPCR_serpentine_rcpt_Srd', 4, NULL),
(16855, NULL, 'IPR019414', NULL, 'RNA polymerase II assembly factor Rtp1, C-terminal domain 2', 'Rtp1_C2', 3, NULL),
(16856, NULL, 'IPR018641', NULL, 'Transferase 1, rSAM/selenodomain-associated', 'Trfase_1_rSAM/selenodom_assoc', 4, NULL),
(16857, NULL, 'IPR019409', NULL, 'FMP27, domain of unknown function DUF2405', 'FMP27_DUF2405', 3, NULL),
(16858, NULL, 'IPR034877', NULL, 'Protein kinase C, PB1 domain', 'PB1_aPKC', 3, NULL),
(16859, NULL, 'IPR023846', NULL, 'Conserved hypothetical protein CHP04042, MSMEG0570', 'CHP04042_MSMEG0570', 4, NULL),
(16860, NULL, 'IPR017648', NULL, '5-keto-4-deoxy-D-glucarate aldolase', 'GarL', 4, NULL),
(16861, NULL, 'IPR022646', NULL, 'Protein-export membrane protein SecD/SecF/SecDF, conserved site', 'SecD/SecF_CS', 2, NULL),
(16862, NULL, 'IPR022725', NULL, 'Type II restriction enzyme MunI', 'Restrct_endonuc_II_MunI', 4, NULL),
(16863, NULL, 'IPR023796', NULL, 'Serpin domain', 'Serpin_dom', 3, NULL),
(16864, NULL, 'IPR022723', NULL, 'RDM domain, Ret finger protein-like', 'RDM_domain_RFPL', 3, NULL),
(16865, NULL, 'IPR019042', NULL, 'Restriction endonuclease, type II, CfrBI', 'Restrct_endonuc_II_CfrBI', 4, NULL),
(16866, NULL, 'IPR020150', NULL, 'Type IV conjugative transfer system protein TrbE', 'T4SS_TrbE', 4, NULL),
(16867, NULL, 'IPR022600', NULL, 'Frog virus 3, Orf82R', 'Frog_virus-3_Orf82R', 4, NULL),
(16868, NULL, 'IPR023837', NULL, 'EccCb-like, Actinobacteria', 'EccCb-like_Actinobacteria', 4, NULL),
(16869, NULL, 'IPR019996', NULL, 'Salicylate synthase', 'Salicylate_synthase', 4, NULL),
(16870, NULL, 'IPR017295', NULL, 'Peptidase S8A, subtilisin-related, cyanobacteria-1', 'Pept_S8A_subtilisin_cyanobac-1', 4, NULL),
(16871, NULL, 'IPR022645', NULL, 'Protein-export membrane protein SecD/SecF, bacterial', 'SecD/SecF_bac', 4, NULL),
(16872, NULL, 'IPR023745', NULL, 'MSF-type transporter, YcaD', 'MFS_YcaD', 4, NULL),
(16873, NULL, 'IPR035413', NULL, 'Phage terminase large subunit, C-terminal', 'Terminase_L_C', 3, NULL),
(16874, NULL, 'IPR022663', NULL, 'Dihydrodipicolinate reductase, C-terminal', 'DapB_C', 3, NULL),
(16875, NULL, 'IPR017631', NULL, 'Salicylate 1-monooxygenase', 'Salicylate_mOase', 4, NULL),
(16876, NULL, 'IPR035499', NULL, 'Caskin2, SH3 domain', 'Caskin2_SH3', 3, NULL),
(16877, NULL, 'IPR034879', NULL, 'Mitogen-activated protein kinase kinase kinase 2/3, PB1 domain', 'PB1_MEKK2/3', 3, NULL),
(16878, NULL, 'IPR022741', NULL, 'Bacteriophage B103, Gp8,  head fibre', 'Phage_B103_Gp8', 4, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(16879, NULL, 'IPR022733', NULL, 'DPUP/SUD, C-terminal, betacoronavirus', 'DPUP_SUD_C_bCoV', 3, NULL),
(16880, NULL, 'IPR023849', NULL, 'Uncharacterised domain CHP03934, TQXA', 'CHP03934_TQXA', 3, NULL),
(16881, NULL, 'IPR019045', NULL, 'Restriction endonuclease, type II, TdeIII', 'Restrct_endonuc_II_TdeIII', 4, NULL),
(16882, NULL, 'IPR018954', NULL, 'Beta-galactosidase, domain 2', 'Betagal_dom2', 3, NULL),
(16883, NULL, 'IPR022602', NULL, 'Protein of unknown function DUF2813', 'DUF2813', 4, NULL),
(16884, NULL, 'IPR018035', NULL, 'Flagellar assembly protein FliH/Type III secretion system HrpE', 'Flagellar_FliH/T3SS_HrpE', 3, NULL),
(16885, NULL, 'IPR019062', NULL, 'Restriction endonuclease, type II, HpaII', 'Restrct_endonuc_II_HpaII', 4, NULL),
(16886, NULL, 'IPR019079', NULL, 'Capsule synthesis protein, CapA', 'Capsule_synth_CapA', 3, NULL),
(16887, NULL, 'IPR021184', NULL, 'Tumour necrosis factor, conserved site', 'TNF_CS', 2, NULL),
(16888, NULL, 'IPR019071', NULL, 'Restriction endonuclease, type II, XcyI', 'Restrct_endonuc_II_XcyI', 4, NULL),
(16889, NULL, 'IPR019065', NULL, 'Restriction endonuclease, type II, NgoFVII', 'Res_endonuc_III_NgoFVII', 4, NULL),
(16890, NULL, 'IPR019417', NULL, 'Domain of unknown function DUF2415', 'DUF2415', 3, NULL),
(16891, NULL, 'IPR020009', NULL, 'Extracellular lipase, Pla-1/cef family', 'Extracell_lipase_Pla-1/cef_e', 4, NULL),
(16892, NULL, 'IPR017316', NULL, 'Peptidase S8A, subtilisin-related, cyanobacteria-2', 'Pept_S8A_subtilisin_cyanobac-2', 4, NULL),
(16893, NULL, 'IPR023512', NULL, 'Deaminase MtaD/DadD', 'Deaminase_MtaD/DadD', 4, NULL),
(16894, NULL, 'IPR019880', NULL, '4-dedimethylamino-4-oxo-anhydrotetracycline transaminase OxyQ', 'OxyQ', 4, NULL),
(16895, NULL, 'IPR022718', NULL, 'Protein of unknown function DUF2672', 'DUF2672', 4, NULL),
(16896, NULL, 'IPR023867', NULL, 'Anaerobic sulphatase maturase, radical SAM', 'Sulphatase_maturase_rSAM', 4, NULL),
(16897, NULL, 'IPR023764', NULL, 'Transcriptional repressor HTH, FabR', 'Tscrpt_reg_HTH_FabR', 4, NULL),
(16898, NULL, 'IPR021080', NULL, 'Minor capsid protein', 'Minor_capsid_protein', 4, NULL),
(16899, NULL, 'IPR023544', NULL, 'ABC transporter, vitamin B12-binding protein', 'ABC_transptr_vit_B12-bd', 4, NULL),
(16900, NULL, 'IPR023522', NULL, 'Chromosome-anchoring protein RacA', 'Chrosome_anchoring_RacA', 4, NULL),
(16901, NULL, 'IPR018295', NULL, 'FLAP/GST2/LTC4S, conserved site', 'FLAP/GST2/LTC4S_CS', 2, NULL),
(16902, NULL, 'IPR022599', NULL, 'Lysis protein, bacteriophage MS2', 'Phage_MS2_lysis', 4, NULL),
(16903, NULL, 'IPR019403', NULL, 'Mediator complex, subunit Med19, metazoa', 'Mediator_Med19_met', 4, NULL),
(16904, NULL, 'IPR022662', NULL, 'Methylaspartate ammonia-lyase, C-terminal', 'MeAsp_NH4-lyase_C', 3, NULL),
(16905, NULL, 'IPR017305', NULL, 'Leupaxin/Paxillin/TGFB1I1', 'Tgfb1i1/Leupaxin/TGFB1I1', 4, NULL),
(16906, NULL, 'IPR023848', NULL, 'TasA anchoring/assembly protein', 'TasA', 4, NULL),
(16907, NULL, 'IPR020005', NULL, 'Flagellar export ATPase FliI, clade 1', 'FliI_clade1', 4, NULL),
(16908, NULL, 'IPR017647', NULL, 'DNA phosphorothioation-dependent restriction protein DptF', 'Dnd_assoc_3', 4, NULL),
(16909, NULL, 'IPR023725', NULL, 'Glucan biosynthesis glucosyltransferase H', 'Glucans_biosynth_gluTrFase_H', 4, NULL),
(16910, NULL, 'IPR022628', NULL, 'S-adenosylmethionine synthetase, N-terminal', 'S-AdoMet_synt_N', 3, NULL),
(16911, NULL, 'IPR017314', NULL, 'Peptidase S8A, subtilisin-like peptidase 1, plasmodium', 'Pept_S8A_PfSUB_1', 4, NULL),
(16912, NULL, 'IPR018953', NULL, 'AMP nucleoside phosphorylase, N-terminal', 'AMP_nucleoside_Pase_N', 3, NULL),
(16913, NULL, 'IPR019405', NULL, 'Lactonase, 7-bladed beta propeller', 'Lactonase_7-beta_prop', 4, NULL),
(16914, NULL, 'IPR023835', NULL, 'Type VII secretion system AAA-ATPase, EccA', 'T7SS_EccA', 4, NULL),
(16915, NULL, 'IPR019080', NULL, 'YqaJ viral recombinase', 'YqaJ_viral_recombinase', 3, NULL),
(16916, NULL, 'IPR023873', NULL, '[FeFe]-hydrogenase H-cluster maturation GTPase HydF', 'FeFe-hyd_GTPase_HydF', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(16917, NULL, 'IPR023785', NULL, 'Regulator of RNA polymerase sigma(70) subunit, Rsd', 'Sigma70_reg_Rsd', 4, NULL),
(16918, NULL, 'IPR022730', NULL, 'DAZ associated protein 2', 'DAZ_assoc-2', 4, NULL),
(16919, NULL, 'IPR023872', NULL, 'Poly-beta-1,6-N-acetyl-D-glucosamine N-deacetylase', 'PNAG_deacetylase', 4, NULL),
(16920, NULL, 'IPR018028', NULL, 'Catalase, mono-functional, haem-containing', 'Catalase', 4, NULL),
(16921, NULL, 'IPR019878', NULL, 'Succinyldiaminopimelate transaminase, DapC, beta/gammaproteobacteria', 'DapC_beta/gammaproteobac', 4, NULL),
(16922, NULL, 'IPR019083', NULL, 'IGR protein motif', 'IGR_protein_motif', 3, NULL),
(16923, NULL, 'IPR017624', NULL, 'Catechol 2,3 dioxygenase', 'Catechol_2-3_dOase', 4, NULL),
(16924, NULL, 'IPR022863', NULL, 'Ribosomal protein S12, archaea', 'Ribosomal_S12_arc', 4, NULL),
(16925, NULL, 'IPR017640', NULL, 'Anthranilate 1,2-dioxygenase, small subunit', 'Anthranilate_1-2-diOase_ssu', 4, NULL),
(16926, NULL, 'IPR031330', NULL, 'Glycoside hydrolase 35, catalytic domain', 'Gly_Hdrlase_35_cat', 3, NULL),
(16927, NULL, 'IPR022715', NULL, 'Protein of unknown function DUF2671', 'DUF2671', 4, NULL),
(16928, NULL, 'IPR023747', NULL, 'Xanthine-guanine phosphoribosyltransferase', 'Xanthine_Guanine_PRibTrfase', 4, NULL),
(16929, NULL, 'IPR020148', NULL, 'Protein of unknown function DUF5477', 'DUF5477', 4, NULL),
(16930, NULL, 'IPR019082', NULL, 'Neurogenic mastermind-like, N-terminal', 'Mastermind-like_N', 3, NULL),
(16931, NULL, 'IPR023797', NULL, 'RNA 3''-terminal phosphate cyclase domain', 'RNA3''_phos_cyclase_dom', 3, NULL),
(16932, NULL, 'IPR021085', NULL, 'AvrE-family Type-III effector protein', 'AvrE_T3Es', 4, NULL),
(16933, NULL, 'IPR019869', NULL, 'Gliding motility-associated, peptidyl-prolyl isomerase, GldI', 'Motility-assoc_PPIase_GldI', 4, NULL),
(16934, NULL, 'IPR018316', NULL, 'Tubulin/FtsZ, 2-layer sandwich domain', 'Tubulin/FtsZ_2-layer-sand-dom', 3, NULL),
(16935, NULL, 'IPR017294', NULL, 'Peptidase S8A, subtilisin-related protease, kinetoplastidia', 'Subtilisin-like_kinetoplast', 4, NULL),
(16936, NULL, 'IPR022716', NULL, 'Gcn1, N-terminal', 'Gcn1_N', 3, NULL),
(16937, NULL, 'IPR023724', NULL, 'Glucan biosynthesis, MdoD', 'Glucan_biosyn_MdoD', 4, NULL),
(16938, NULL, 'IPR023874', NULL, 'DNA modification/repair radical SAM protein, putative', 'DNA_rSAM_put', 4, NULL),
(16939, NULL, 'IPR017302', NULL, 'Neuronal migration protein doublecortin, chordata', 'Doublecortin_chordata', 4, NULL),
(16940, NULL, 'IPR022702', NULL, 'DNA (cytosine-5)-methyltransferase 1, replication foci domain', 'Cytosine_MeTrfase1_RFD', 3, NULL),
(16941, NULL, 'IPR022597', NULL, 'Endoribonuclease antitoxin GhoS', 'GhoS', 4, NULL),
(16942, NULL, 'IPR022620', NULL, 'Domain of unknown function DUF2666', 'DUF2666', 3, NULL),
(16943, NULL, 'IPR019394', NULL, 'Testis-specific protein TEX28/transmembrane and coiled-coil domains protein', 'TEX28/TMCC', 4, NULL),
(16944, NULL, 'IPR018656', NULL, 'Domain of unknown function DUF2087', 'DUF2087', 3, NULL),
(16945, NULL, 'IPR022615', NULL, 'Na(+)-translocating NADH-quinone reductase subunit A, C-terminal domain', 'NqrA_C_domain', 3, NULL),
(16946, NULL, 'IPR018645', NULL, 'Zn-ribbon containing protein', 'DUF2072', 4, NULL),
(16947, NULL, 'IPR018638', NULL, 'Domain of unknown function DUF2061, membrane', 'DUF2061_membrane', 3, NULL),
(16948, NULL, 'IPR018640', NULL, 'Putative DNA-binding domain, bacteria', 'DUF2063', 3, NULL),
(16949, NULL, 'IPR019070', NULL, 'Type II restriction endonuclease SinI', 'Restrct_endonuc_II_SinI', 4, NULL),
(16950, NULL, 'IPR023765', NULL, 'Solute-binding protein family 5, conserved site', 'SBP_5_CS', 2, NULL),
(16951, NULL, 'IPR018951', NULL, 'Fumarase C, C-terminal', 'Fumarase_C_C', 3, NULL),
(16952, NULL, 'IPR019072', NULL, 'Restriction endonuclease, type II, XamI', 'Restrct_endonuc_II_XamI', 4, NULL),
(16953, NULL, 'IPR023830', NULL, 'Peptidase S8A, PatG', 'Peptidase_S8A_PatG', 4, NULL),
(16954, NULL, 'IPR016896', NULL, 'Protein of unknown function DUF2860', 'DUF2860', 4, NULL),
(16955, NULL, 'IPR021198', NULL, 'Pyridoxamine 5''-phosphate oxidase, plant', 'Pyridox_Oxase_pln', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(16956, NULL, 'IPR018052', NULL, 'Aldose 1-epimerase, conserved site', 'Ald1_epimerase_CS', 2, NULL),
(16957, NULL, 'IPR018639', NULL, 'Domain of unknown function DUF2062', 'DUF2062', 3, NULL),
(16958, NULL, 'IPR016883', NULL, 'Uncharacterised conserved protein UCP028431', 'UCP028431', 4, NULL),
(16959, NULL, 'IPR019398', NULL, 'Pre-rRNA-processing protein TSR2', 'Pre-rRNA_process_TSR2', 4, NULL),
(16960, NULL, 'IPR017296', NULL, 'Peptidase S8A, SAM-P45', 'Peptidase_S8A_SAM-P45', 4, NULL),
(16961, NULL, 'IPR022592', NULL, 'Nucleolar protein 19', 'Nucleolar_19', 4, NULL),
(16962, NULL, 'IPR022598', NULL, 'Long-chain fatty acyl-CoA thioesterase FcoT-like', 'FcoT_ThioEstase', 4, NULL),
(16963, NULL, 'IPR020000', NULL, 'Bacteriophage P2, LysB', 'Phage_P2_LysB', 4, NULL),
(16964, NULL, 'IPR019081', NULL, 'Uncharacterised protein family UPF0328', 'UPF0328', 4, NULL),
(16965, NULL, 'IPR022621', NULL, 'Autographa californica nuclear polyhedrosis virus (AcMNPV), Orf72', 'AcMNPV_Orf72', 4, NULL),
(16966, NULL, 'IPR022683', NULL, 'Peptidase C2, calpain, domain III', 'Calpain_III', 3, NULL),
(16967, NULL, 'IPR023485', NULL, 'Phosphotyrosine protein phosphatase I', 'Ptyr_pPase', 3, NULL),
(16968, NULL, 'IPR022679', NULL, 'Methyl-coenzyme M reductase, beta subunit, C-terminal', 'Me_CoM_Rdtase_bsu_C', 3, NULL),
(16969, NULL, 'IPR018661', NULL, 'Protein of unknown function DUF2093', 'DUF2093', 4, NULL),
(16970, NULL, 'IPR022653', NULL, 'Orn/DAP/Arg decarboxylase 2, pyridoxal-phosphate binding site', 'De-COase2_pyr-phos_BS', 1, NULL),
(16971, NULL, 'IPR022734', NULL, 'Apolipoprotein M', 'ApoM', 4, NULL),
(16972, NULL, 'IPR019401', NULL, 'Zinc finger, CHCC-type', 'Znf_CHCC', 3, NULL),
(16973, NULL, 'IPR022712', NULL, 'Beta-Casp domain', 'Beta_Casp', 3, NULL),
(16974, NULL, 'IPR019400', NULL, 'Peptidase C65, otubain', 'Peptidase_C65_otubain', 4, NULL),
(16975, NULL, 'IPR023634', NULL, 'Reovirus, outer capsid sigma-3 domain superfamily', 'Reovirus_capsid_sigma-3_dom_sf', 5, NULL),
(16976, NULL, 'IPR018646', NULL, 'Membrane protein of 12 TMs', '12TM_1', 4, NULL),
(16977, NULL, 'IPR022708', NULL, 'Serine/threonine-protein kinase Atg1-like, tMIT domain', 'Atg1-like_tMIT', 3, NULL),
(16978, NULL, 'IPR017299', NULL, 'DNA fragmentation factor 45', 'DFF45', 4, NULL),
(16979, NULL, 'IPR018952', NULL, '2''-5''-oligoadenylate synthetase 1, domain 2/C-terminal', '2-5-oligoAdlate_synth_1_dom2/C', 3, NULL),
(16980, NULL, 'IPR022617', NULL, 'Rad60/SUMO-like domain', 'Rad60/SUMO-like_dom', 3, NULL),
(16981, NULL, 'IPR018657', NULL, 'LarA-like, N-terminal', 'LarA-like_N', 3, NULL),
(16982, NULL, 'IPR019073', NULL, 'Restriction endonuclease, type II, TaqI', 'Restrct_endonuc_II_TaqI', 4, NULL),
(16983, NULL, 'IPR023771', NULL, 'Cell division protein ZapA, eubacteria', 'Cell_div_ZapA_eubact', 4, NULL),
(16984, NULL, 'IPR018664', NULL, 'Protein of unknown function DUF2103, metal-binding', 'DUF2103_metal-binding', 4, NULL),
(16985, NULL, 'IPR022689', NULL, 'Iron dependent repressor', 'Iron_dep_repressor', 4, NULL),
(16986, NULL, 'IPR017630', NULL, '4-oxalocrotonate decarboxylase', '4-oxalocrotonate_decarboxylase', 4, NULL),
(16987, NULL, 'IPR019066', NULL, 'Restriction endonuclease, type II, SacI', 'Restrct_endonuc_II_SacI', 4, NULL),
(16988, NULL, 'IPR023516', NULL, 'tRNA-splicing endonuclease, archaeal long subfamily', 'tRNA_splic_arch_long', 4, NULL),
(16989, NULL, 'IPR018294', NULL, '4-diphosphocytidyl-2C-methyl-D-erythritol synthase, conserved site', 'ISPD_synthase_CS', 2, NULL),
(16990, NULL, 'IPR017639', NULL, 'Benzoate 1,2-dioxygenase, large subunit', 'Benzo_1-2-diOase_lsu', 4, NULL),
(16991, NULL, 'IPR023794', NULL, 'Inositol 2-dehydrogenase/D-chiro-inositol 3-dehydrogenase', 'MI/DCI_dehydrogenase', 4, NULL),
(16992, NULL, 'IPR023534', NULL, 'Rof/RNase P-like', 'Rof/RNase_P-like', 5, NULL),
(16993, NULL, 'IPR017636', NULL, '2-aminoethylphosphonate ABC transporter system, permease protein PhnU', 'AminoethylPonate_ABC_perm-PhnU', 4, NULL),
(16994, NULL, 'IPR017312', NULL, 'Peptidase S8A, subtilisin-related, Alteromonadales', 'Subtilisin_Alteromonadales', 4, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(16995, NULL, 'IPR023870', NULL, 'Poly-beta-1,6 N-acetyl-D-glucosamine export porin PgaA', 'PGA_export_porin_PgaA', 4, NULL),
(16996, NULL, 'IPR022720', NULL, 'Gliding motility-associated protein GldM, N-terminal', 'Motility-assoc_prot_GldM_N', 3, NULL),
(16997, NULL, 'IPR019873', NULL, '2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-acetyltransferase, DapH', 'DapH', 4, NULL),
(16998, NULL, 'IPR022878', NULL, 'V-type ATP synthase catalytic alpha chain', 'V-ATPase_asu', 4, NULL),
(16999, NULL, 'IPR016886', NULL, 'Predicted glycerophosphotransferase UCP028458', 'UCP028458_glyceroPtfrase', 4, NULL),
(17000, NULL, 'IPR019415', NULL, 'FMP27, SW domain', 'FMP27_SW_dom', 3, NULL),
(17001, NULL, 'IPR022872', NULL, 'Quinate/Shikimate dehydrogenase', 'Quinate/Shikimate_DH', 4, NULL),
(17002, NULL, 'IPR018707', NULL, 'Lipid A deacylase LpxR', 'LpxR', 4, NULL),
(17003, NULL, 'IPR018683', NULL, 'Domain of unknown function DUF2169', 'DUF2169', 3, NULL),
(17004, NULL, 'IPR022819', NULL, 'Poxvirus Bcl-2-like', 'Poxvirus_Bcl-2-like', 4, NULL),
(17005, NULL, 'IPR017352', NULL, 'Methyl-CpG-binding domain protein 4', 'MBD4', 4, NULL),
(17006, NULL, 'IPR022640', NULL, 'Cysteine and tyrosine-rich protein 1', 'CYYR1', 4, NULL),
(17007, NULL, 'IPR013191', NULL, 'Glycosyl hydrolase family 98, central domain', 'GH98_central', 3, NULL),
(17008, NULL, 'IPR017660', NULL, 'Oxalyl-CoA decarboxylase', 'Oxalyl-CoA_decarboxylase', 4, NULL),
(17009, NULL, 'IPR022784', NULL, 'Ribosome biogenesis protein Alb1', 'Ribosome_bgen_Alb1', 4, NULL),
(17010, NULL, 'IPR013174', NULL, 'Dolichol-phosphate mannosyltransferase subunit 3', 'DPM3', 4, NULL),
(17011, NULL, 'IPR019807', NULL, 'Hexokinase, binding site', 'Hexokinase_BS', 1, NULL),
(17012, NULL, 'IPR019810', NULL, 'Citrate synthase active site', 'Citrate_synthase_AS', 0, NULL),
(17013, NULL, 'IPR018689', NULL, 'Domain of unknown function DUF2185', 'DUF2185', 3, NULL),
(17014, NULL, 'IPR013194', NULL, 'Histone deacetylase interacting domain', 'HDAC_interact_dom', 3, NULL),
(17015, NULL, 'IPR019446', NULL, '25S rRNA (uridine-N(3))-methyltransferase BMT5-like', 'BMT5-like', 3, NULL),
(17016, NULL, 'IPR017658', NULL, 'Conserved hypothetical protein CHP03252, HhH-GPD', 'CHP03252_HhH-GPD', 4, NULL),
(17017, NULL, 'IPR019454', NULL, 'Putative cell-wall binding lipoprotein YkyA-like', 'Lipoprot_YkyA-like', 4, NULL),
(17018, NULL, 'IPR019442', NULL, 'THADA/TRM732, DUF2428', 'THADA/TRM732_DUF2428', 3, NULL),
(17019, NULL, 'IPR022797', NULL, 'Type III secretion system regulator LcrR/Chaperone CesD2', 'LcrR/CesD2', 4, NULL),
(17020, NULL, 'IPR023589', NULL, 'Processive diacylglycerol beta-glucosyltransferase', 'Pro_diacylglycrl_glcsylTrfase', 4, NULL),
(17021, NULL, 'IPR013196', NULL, 'Helix-turn-helix, type 11', 'HTH_11', 3, NULL),
(17022, NULL, 'IPR035092', NULL, 'EV matrix protein, C-terminal', 'EV_matrix_protein_C', 5, NULL),
(17023, NULL, 'IPR013180', NULL, 'Beta-catenin-like protein 1, N-terminal', 'CTNNBL1_N', 3, NULL),
(17024, NULL, 'IPR018690', NULL, 'Protein of unknown function DUF2187', 'DUF2187', 4, NULL),
(17025, NULL, 'IPR022855', NULL, 'Multidrug resistance protein MdtH', 'Multidrug-R_MdtH', 4, NULL),
(17026, NULL, 'IPR018717', NULL, 'Domain of unknown function DUF2241', 'DUF2241', 3, NULL),
(17027, NULL, 'IPR020012', NULL, 'Motility protein FimV, N-terminal', 'Motility_prot_FimV_N', 3, NULL),
(17028, NULL, 'IPR018503', NULL, 'Tetraspanin, conserved site', 'Tetraspanin_CS', 2, NULL),
(17029, NULL, 'IPR016256', NULL, 'Serine/threonine-protein kinase Rad53', 'Ser/Thr_kinase_Rad53', 4, NULL),
(17030, NULL, 'IPR016217', NULL, 'Nitrogen fixation, NifU', 'N_fixation_NifU', 4, NULL),
(17031, NULL, 'IPR027266', NULL, 'GTP-binding protein TrmE/Aminomethyltransferase GcvT, domain 1', 'TrmE/GcvT_dom1', 5, NULL),
(17032, NULL, 'IPR022363', NULL, 'Bacteriophage TP901-1, major tail protein', 'Phage_TP901-1_major-tail', 4, NULL),
(17033, NULL, 'IPR022915', NULL, 'Peroxiredoxin, TDXH subfamily', 'Peroxiredoxin_TDXH', 4, NULL),
(17034, NULL, 'IPR020013', NULL, 'Flagellar hook-basal body protein, FlgE/F/G', 'Flagellar_FlgE/F/G', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(17035, NULL, 'IPR016927', NULL, 'Lectin, sugar-binding', 'Lectin_sugar-bd', 4, NULL),
(17036, NULL, 'IPR019796', NULL, 'Glucose-6-phosphate dehydrogenase, active site', 'G6P_DH_AS', 0, NULL),
(17037, NULL, 'IPR017351', NULL, 'LIM and senescent cell antigen-like-containing domain protein 1-like', 'PINCH_1-like', 4, NULL),
(17038, NULL, 'IPR013202', NULL, 'Kinin peptide', 'Kinin_peptide', 4, NULL),
(17039, NULL, 'IPR017336', NULL, 'Snurportin-1', 'Snurportin-1', 4, NULL),
(17040, NULL, 'IPR016252', NULL, 'Serine/threonine-protein kinase SpkB', 'Ser/Thr_kinase_SpkB', 4, NULL),
(17041, NULL, 'IPR019433', NULL, 'GPI-Mannosyltransferase II co-activator, Pga1', 'GPI_ManTrfase_II_coact_Pga1', 4, NULL),
(17042, NULL, 'IPR019809', NULL, 'Histone H4, conserved site', 'Histone_H4_CS', 2, NULL),
(17043, NULL, 'IPR016239', NULL, 'Ribosomal protein S6 kinase II', 'Ribosomal_S6_kinase_II', 4, NULL),
(17044, NULL, 'IPR017325', NULL, 'RNA binding protein Fox-1', 'RNA-bd_Fox-1', 4, NULL),
(17045, NULL, 'IPR017651', NULL, 'Arginine/ornithine succinyltransferase, alpha subunit', 'Arg/Orn_succinylTfrase_asu', 4, NULL),
(17046, NULL, 'IPR017654', NULL, 'Galactarate dehydratase GarD-like', 'GarD-like', 4, NULL),
(17047, NULL, 'IPR019462', NULL, 'DNA-directed RNA polymerase, beta subunit, external 1 domain', 'DNA-dir_RNA_pol_bsu_external_1', 3, NULL),
(17048, NULL, 'IPR016933', NULL, 'Pentapeptide repeat-containing uncharacterised conserved protein UCP029688', 'UCP029688_pentapep', 4, NULL),
(17049, NULL, 'IPR017653', NULL, 'Glucarate dehydratase', 'Glucarate_dehydratase', 4, NULL),
(17050, NULL, 'IPR013178', NULL, 'Histone acetyltransferase Rtt109/CBP', 'Histone_AcTrfase_Rtt109/CBP', 4, NULL),
(17051, NULL, 'IPR022791', NULL, 'Lysylphosphatidylglycerol synthetase/glycosyltransferase AglD', 'L-PG_synthase/AglD', 4, NULL),
(17052, NULL, 'IPR017335', NULL, 'E3 ubiquitin-protein ligase RNF8', 'RNF8', 4, NULL),
(17053, NULL, 'IPR013190', NULL, 'Glycosyl hydrolase family 98, C-terminal', 'GH98_C', 3, NULL),
(17054, NULL, 'IPR018719', NULL, 'Protein of unknown function DUF2243, membrane', 'DUF2243_membrane', 4, NULL),
(17055, NULL, 'IPR035124', NULL, 'Protein of unknown function DUF5508', 'DUF5508', 4, NULL),
(17056, NULL, 'IPR023936', NULL, 'Probable malonic semialdehyde reductase RutE-like', 'RutE-like', 4, NULL),
(17057, NULL, 'IPR018712', NULL, 'Domain of unknown function DUF2235', 'DUF2235', 3, NULL),
(17058, NULL, 'IPR023311', NULL, 'Methuselah ectodomain, domain 2', 'Methusela_ecto_dom_2', 5, NULL),
(17059, NULL, 'IPR024627', NULL, 'V(D)J recombination-activating protein 1', 'RAG1', 4, NULL),
(17060, NULL, 'IPR023200', NULL, 'Ribosome modulation factor domain superfamily', 'RMF_sf', 5, NULL),
(17061, NULL, 'IPR013184', NULL, 'Lactococcus phage c2, E2', 'Lactococcus_phage_c2_E2', 4, NULL),
(17062, NULL, 'IPR016244', NULL, 'Tyrosine-protein kinase, HGF/MSP receptor', 'Tyr_kinase_HGF/MSP_rcpt', 4, NULL),
(17063, NULL, 'IPR019774', NULL, 'Aromatic amino acid hydroxylase, C-terminal', 'Aromatic-AA_hydroxylase_C', 3, NULL),
(17064, NULL, 'IPR034040', NULL, 'Tumor necrosis factor receptor 11A, N-terminal', 'TNFRSF11A_N', 3, NULL),
(17065, NULL, 'IPR019793', NULL, 'Peroxidases heam-ligand binding site', 'Peroxidases_heam-ligand_BS', 1, NULL),
(17066, NULL, 'IPR013187', NULL, 'F-box associated domain, type 3', 'F-box-assoc_dom_typ3', 3, NULL),
(17067, NULL, 'IPR019829', NULL, 'Macrophage migration inhibitory factor, conserved site', 'Macrophage_inhib_fac_CS', 2, NULL),
(17068, NULL, 'IPR022846', NULL, 'Xaa-Pro dipeptidase', 'X_Pro_dipept', 4, NULL),
(17069, NULL, 'IPR022883', NULL, '4-amino-4-deoxy-L-arabinose-phosphoundecaprenol flippase, subunit ArnE', 'Flippase_ArnE', 4, NULL),
(17070, NULL, 'IPR019826', NULL, 'Carboxylesterase type B, active site', 'Carboxylesterase_B_AS', 0, NULL),
(17071, NULL, 'IPR018455', NULL, 'Phosphotransferase system, sorbose subfamily IIB component, subgroup', 'PTS_IIB_sorbose-sp_subgr', 4, NULL),
(17072, NULL, 'IPR035120', NULL, 'Protein of unknown function DUF5509', 'DUF5509', 4, NULL),
(17073, NULL, 'IPR016930', NULL, 'Uncharacterised conserved protein UCP029644, LysM, PA4035', 'UCP029644', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(17074, NULL, 'IPR017323', NULL, 'Lysyl endopeptidase', 'Lysyl_endo-pept', 4, NULL),
(17075, NULL, 'IPR018687', NULL, 'Protein of unknown function DUF2177, membrane', 'DUF2177_membr', 4, NULL),
(17076, NULL, 'IPR019824', NULL, 'Leghaemoglobin, iron-binding site', 'Leghaemoglobin_Fe_BS', 1, NULL),
(17077, NULL, 'IPR019466', NULL, 'Matrilin, coiled-coil trimerisation domain', 'Matrilin_coiled-coil_trimer', 3, NULL),
(17078, NULL, 'IPR021116', NULL, 'Calcitonin/adrenomedullin', 'Calcitonin/adrenomedullin', 4, NULL),
(17079, NULL, 'IPR019806', NULL, 'Heat-stable enterotoxin, conserved site', 'Heat-stable_enterotox_CS', 2, NULL),
(17080, NULL, 'IPR022793', NULL, 'RNA polymerase I-specific transcription initiation factor Rrn10', 'Rrn10', 4, NULL),
(17081, NULL, 'IPR016247', NULL, 'Tyrosine-protein kinase, receptor ROR', 'Tyr_kinase_rcpt_ROR', 4, NULL),
(17082, NULL, 'IPR018673', NULL, 'Protein of unknown function DUF2141', 'DUF2141', 4, NULL),
(17083, NULL, 'IPR019437', NULL, 'Shelterin complex subunit TPP1/Est3', 'TPP1/Est3', 3, NULL),
(17084, NULL, 'IPR019812', NULL, 'Hydrogenase assembly chaperone, conserved site', 'Hydgase_assmbl_chp_CS', 2, NULL),
(17085, NULL, 'IPR019799', NULL, 'Glycoside hydrolase family 22 domain', 'Glyco_hydro_22_CS', 3, NULL),
(17086, NULL, 'IPR019438', NULL, 'Queuosine salvage protein family', 'Q_salvage', 4, NULL),
(17087, NULL, 'IPR018686', NULL, 'Protein of unknown function DUF2175', 'DUF2175', 4, NULL),
(17088, NULL, 'IPR019445', NULL, 'Uncharacterised protein family UPF0321', 'UPF0321', 4, NULL),
(17089, NULL, 'IPR022745', NULL, 'Eukaryotic translation initiation factor 4G1, eIF4E-binding domain', 'eIF4G1_eIF4E-bd', 3, NULL),
(17090, NULL, 'IPR017662', NULL, '2-aminoethylphosphonate ABC transport system, ATP-binding component PhnT', 'AminoethylPonate_ABC_PhnT', 4, NULL),
(17091, NULL, 'IPR018697', NULL, 'Protein of unknown function DUF2199', 'DUF2199', 4, NULL),
(17092, NULL, 'IPR022889', NULL, 'DNA-binding protein, archaeal', 'DNA_bind_arc', 4, NULL),
(17093, NULL, 'IPR022751', NULL, 'Alpha-mannosyltransferase', 'Alpha_mannosyltransferase', 4, NULL),
(17094, NULL, 'IPR017340', NULL, 'U1 small nuclear ribonucleoprotein C', 'U1_snRNP-C', 4, NULL),
(17095, NULL, 'IPR019426', NULL, '7TM GPCR, serpentine receptor class v (Srv)', '7TM_GPCR_serpentine_rcpt_Srv', 4, NULL),
(17096, NULL, 'IPR019464', NULL, 'RNA polymerase II elongation factor ELL, N-terminal', 'ELL_N', 3, NULL),
(17097, NULL, 'IPR022866', NULL, 'Heat shock protein HspQ', 'HspQ', 4, NULL),
(17098, NULL, 'IPR018718', NULL, 'Protein of unknown function DUF2242', 'DUF2242', 4, NULL),
(17099, NULL, 'IPR019436', NULL, 'Steryl acetyl hydrolase 1-like', 'Say1-like', 4, NULL),
(17100, NULL, 'IPR022865', NULL, 'DNA ligase, ATP-dependent, bacterial/archaeal', 'DNA_ligae_ATP-dep_bac/arc', 4, NULL),
(17101, NULL, 'IPR016915', NULL, 'Uncharacterised conserved protein UCP029342', 'UCP029342', 4, NULL),
(17102, NULL, 'IPR019453', NULL, 'Vacuolar sorting protein 39/Transforming growth factor beta receptor-associated domain 2', 'VPS39/TGF_beta_rcpt-assoc_2', 3, NULL),
(17103, NULL, 'IPR017354', NULL, 'Vasodilator-stimulated phosphoprotein/ENA/VASP-like', 'VASP/EVL', 4, NULL),
(17104, NULL, 'IPR017353', NULL, 'Methyl-CpG binding protein MeCP2', 'Me_CpG-bd_MeCP2', 4, NULL),
(17105, NULL, 'IPR022826', NULL, '3-deoxy-D-manno-octulosonic acid kinase', 'KDO_kinase', 4, NULL),
(17106, NULL, 'IPR019993', NULL, 'RecB family nuclease, TM0106, putative', 'RecB_nuclease_TM0106_put', 4, NULL),
(17107, NULL, 'IPR018449', NULL, 'NIL domain', 'NIL_domain', 3, NULL),
(17108, NULL, 'IPR034900', NULL, 'LARP5, RNA recognition motif', 'LARP5_RRM', 3, NULL),
(17109, NULL, 'IPR022750', NULL, 'Interferon regulatory factor 2-binding protein 1 & 2, zinc finger', 'Interferon_reg_fac2-bd1_2_Znf', 3, NULL),
(17110, NULL, 'IPR018492', NULL, 'Ribosomal protein L7Ae/L8/Nhp2 family', 'Ribosomal_L7Ae/L8/Nhp2', 4, NULL),
(17111, NULL, 'IPR024209', NULL, 'Protein of unknown function DUF3787', 'DUF3787', 4, NULL),
(17112, NULL, 'IPR018724', NULL, '2OG-Fe dioxygenase', '2OG-Fe_dioxygenase', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(17113, NULL, 'IPR016224', NULL, 'Ecdysteroid UDP-glucosyltransferase', 'Ecdysteroid_UDP-Glc_Trfase', 4, NULL),
(17114, NULL, 'IPR017339', NULL, 'Trans-activator protein BZLF1, human herpesvirus 4', 'Trans-activator_BZLF1_HHV-4', 4, NULL),
(17115, NULL, 'IPR016918', NULL, 'Uncharacterised conserved protein UCP029394', 'UCP029394', 4, NULL),
(17116, NULL, 'IPR019430', NULL, '7TM GPCR, serpentine receptor class x  (Srx)', '7TM_GPCR_serpentine_rcpt_Srx', 3, NULL),
(17117, NULL, 'IPR016209', NULL, 'Protochlorophyllide reductase, ChlB, light independent', 'Protochlorophyllide_Rdtase', 4, NULL),
(17118, NULL, 'IPR019434', NULL, 'Domain of unknown function DUF2423', 'DUF2423', 3, NULL),
(17119, NULL, 'IPR034906', NULL, 'Calcipressin-1, RNA recognition motif', 'RCAN1_RRM', 3, NULL),
(17120, NULL, 'IPR022880', NULL, 'DNA polymerase IV', 'DNApol_IV', 4, NULL),
(17121, NULL, 'IPR018451', NULL, 'NAF/FISL domain', 'NAF/FISL_domain', 3, NULL),
(17122, NULL, 'IPR035058', NULL, 'SH2B2, SH2 domain', 'SH2B2_SH2', 3, NULL),
(17123, NULL, 'IPR019465', NULL, 'Conserved oligomeric Golgi complex subunit 5', 'Cog5', 4, NULL),
(17124, NULL, 'IPR017656', NULL, 'Putative phosphonoacetaldehyde dehydrogenase', 'Put_phosphonoacetaldehyde_DH', 4, NULL),
(17125, NULL, 'IPR013195', NULL, 'Hepatitis B virus, capsid N-terminal', 'Hepatitis_B_virus_capsid_N', 3, NULL),
(17126, NULL, 'IPR019775', NULL, 'WD40 repeat, conserved site', 'WD40_repeat_CS', 2, NULL),
(17127, NULL, 'IPR019815', NULL, 'Translation initiation factor 3, C-terminal', 'Translation_initiation_fac_3_C', 3, NULL),
(17128, NULL, 'IPR018725', NULL, 'Protein of unknown function DUF2259, secreted', 'DUF2259_secreted', 4, NULL),
(17129, NULL, 'IPR018691', NULL, 'Protein of unknown function DUF2188', 'DUF2188', 4, NULL),
(17130, NULL, 'IPR016917', NULL, 'Uncharacterised conserved protein UCP029393', 'UCP029393', 4, NULL),
(17131, NULL, 'IPR018709', NULL, 'CoA enzyme activase, domain of unknown function DUF2229', 'CoA_activase_DUF2229', 3, NULL),
(17132, NULL, 'IPR018219', NULL, 'Thiol peroxidase conserved site', 'Tpx_CS', 2, NULL),
(17133, NULL, 'IPR018705', NULL, 'Domain of unknown function DUF2134, membrane', 'DUF2134_membrane', 3, NULL),
(17134, NULL, 'IPR022635', NULL, 'DNA polymerase III, beta sliding clamp, C-terminal', 'DNA_polIII_beta_C', 3, NULL),
(17135, NULL, 'IPR016922', NULL, 'Uncharacterised conserved protein UCP029505', 'UCP029505', 4, NULL),
(17136, NULL, 'IPR017671', NULL, 'Putative methanogenesis marker domain 9', 'Methan_mark_9', 3, NULL),
(17137, NULL, 'IPR016913', NULL, 'Uncharacterised conserved protein UCP029215', 'UCP029215', 4, NULL),
(17138, NULL, 'IPR022857', NULL, 'Undecaprenyl-phosphate 4-deoxy-4-formamido-L-arabinose transferase', 'ArnC_tfrase', 4, NULL),
(17139, NULL, 'IPR013192', NULL, 'Hepatitis C virus, Non-structural 5a protein, domain 1a', 'HCV_NS5A_1a', 3, NULL),
(17140, NULL, 'IPR016207', NULL, 'Ketol-acid reductoisomerase, fungi', 'KetolA_reductoisomerase_fun', 4, NULL),
(17141, NULL, 'IPR016206', NULL, 'Ketol-acid reductoisomerase, plant', 'KetolA_reductoisomerase_plant', 4, NULL),
(17142, NULL, 'IPR019813', NULL, 'Translation initiation factor 3, conserved site', 'Translation_initiation_fac3_CS', 2, NULL),
(17143, NULL, 'IPR016249', NULL, 'Tyrosine-protein kinase, Ret receptor', 'Tyr_kinase_Ret_rcpt', 4, NULL),
(17144, NULL, 'IPR019814', NULL, 'Translation initiation factor 3, N-terminal', 'Translation_initiation_fac_3_N', 3, NULL),
(17145, NULL, 'IPR022902', NULL, 'N-acetyltransferase Eis', 'NAcTrfase_Eis', 4, NULL),
(17146, NULL, 'IPR018702', NULL, 'Protein of unknown function DUF2207, membrane', 'DUF2207_membrane', 4, NULL),
(17147, NULL, 'IPR015618', NULL, 'Transforming growth factor beta-3', 'TGFB3', 4, NULL),
(17148, NULL, 'IPR034671', NULL, 'Hormonally up-regulated neu tumour-associated kinase, catalytic domain', 'Hunk', 3, NULL),
(17149, NULL, 'IPR022830', NULL, 'Indigoidine synthase A-like', 'Indigdn_synthA-like', 5, NULL),
(17150, NULL, 'IPR019457', NULL, 'Uncharacterised domain YojJ, N-terminal', 'Uncharacterised_YojJ_N', 3, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(17151, NULL, 'IPR019443', NULL, 'FMP27,  C-terminal', 'FMP27_C', 3, NULL),
(17152, NULL, 'IPR017657', NULL, 'L-lysine 6-transaminase', 'L-lysine_6-transaminase', 4, NULL),
(17153, NULL, 'IPR034509', NULL, 'Pub1, RNA recognition motif 1', 'PUB1_RRM1', 3, NULL),
(17154, NULL, 'IPR023140', NULL, 'Domain of unknown function DUF357', 'DUF357', 3, NULL),
(17155, NULL, 'IPR019477', NULL, 'Rhodopsin, N-terminal', 'Rhodopsin_N', 3, NULL),
(17156, NULL, 'IPR018669', NULL, 'Toxin-antitoxin system,  mRNA interferase HigB', 'Toxin_HigB', 4, NULL),
(17157, NULL, 'IPR018218', NULL, 'Scorpion long chain toxin', 'Scorpion_toxinL', 4, NULL),
(17158, NULL, 'IPR018701', NULL, 'Protein of unknown function DUF2206, membrane', 'DUF2206_membrane', 4, NULL),
(17159, NULL, 'IPR016235', NULL, 'Tyrosine/threonine-protein kinase, Cdc2 inhibitor', 'Tyr/Thr_kinase_Cdc2_inhib', 4, NULL),
(17160, NULL, 'IPR017672', NULL, 'Radical SAM methyltransferase MA_4551-like', 'MA_4551-like', 4, NULL),
(17161, NULL, 'IPR017322', NULL, 'Receptor-interacting serine/threonine-protein kinase 2', 'Rcpt-int_Ser/Thr_kinase-2', 4, NULL),
(17162, NULL, 'IPR022918', NULL, 'Phenylalanine-tRNA ligase beta chain 2, archaeal type', 'Phe_tRNA_ligase_beta2_arc', 4, NULL),
(17163, NULL, 'IPR017328', NULL, 'Sirtuin, class I', 'Sirtuin_class_I', 4, NULL),
(17164, NULL, 'IPR019439', NULL, 'FMP27, N-terminal', 'FMP27_N', 3, NULL),
(17165, NULL, 'IPR017320', NULL, 'Histone deacetylase class II, eukaryotic-type', 'Histone_deAcase_II_euk', 4, NULL),
(17166, NULL, 'IPR022864', NULL, 'DnaA regulatory inactivator Hda, Enterobacteriaceae', 'Hda_Enterobact', 4, NULL),
(17167, NULL, 'IPR019830', NULL, 'Malate synthase, conserved site', 'Malate_synthase_CS', 2, NULL),
(17168, NULL, 'IPR016931', NULL, 'Uncharacterised conserved protein UCP029658, TPR', 'UCP029658_TPR', 4, NULL),
(17169, NULL, 'IPR018693', NULL, 'Protein of unknown function DUF2192', 'DUF2192', 4, NULL),
(17170, NULL, 'IPR019823', NULL, 'Large-conductance mechanosensitive channel, conserved site', 'Mechanosensitive_channel_CS', 2, NULL),
(17171, NULL, 'IPR022917', NULL, 'Phenylalanine-tRNA ligase alpha subunit,  bacterial/archaeal', 'Phe_tRNA_ligase_alpha_bac/arc', 4, NULL),
(17172, NULL, 'IPR019802', NULL, 'Glycoside hydrolase, family 4, conserved site', 'GlycHydrolase_4_CS', 2, NULL),
(17173, NULL, 'IPR023275', NULL, 'Aquaporin 3', 'Aquaporin_3', 4, NULL),
(17174, NULL, 'IPR019794', NULL, 'Peroxidase, active site', 'Peroxidases_AS', 0, NULL),
(17175, NULL, 'IPR013185', NULL, 'Translation elongation factor, KOW-like', 'Transl_elong_KOW-like', 3, NULL),
(17176, NULL, 'IPR020015', NULL, 'Decaheme cytochrome, c-type, DmsE', 'Decahaem_cyt-c_DmsE', 4, NULL),
(17177, NULL, 'IPR013198', NULL, 'GTP-sensing helix-turn-helix, CodY, C-terminal', 'GTP_sensing_HTH_CodY_C', 3, NULL),
(17178, NULL, 'IPR019467', NULL, 'Histone acetyl transferase HAT1 N-terminal', 'Hat1_N', 3, NULL),
(17179, NULL, 'IPR019828', NULL, 'Lysyl oxidase, conserved site', 'Lysyl_oxidase_CS', 2, NULL),
(17180, NULL, 'IPR017326', NULL, 'Peptidase S1A, polyserase-2', 'Pept_S1A_polyserase-2', 4, NULL),
(17181, NULL, 'IPR022756', NULL, 'Signal transducer and activation of transcription 2, C-terminal', 'STAT2_C', 3, NULL),
(17182, NULL, 'IPR022798', NULL, 'Cellulose synthase operon protein D, bacterial', 'BcsD_bac', 4, NULL),
(17183, NULL, 'IPR017356', NULL, 'Chimaerin', 'CHN1/CHN2', 4, NULL),
(17184, NULL, 'IPR016909', NULL, 'Ribosomal RNA large subunit methyltransferase F', 'rRNA_lsu_MeTfrase_F', 4, NULL),
(17185, NULL, 'IPR034197', NULL, 'Cucumisin-like catalytic domain', 'Peptidases_S8_3', 3, NULL),
(17186, NULL, 'IPR016919', NULL, 'Uncharacterised conserved protein UCP029416, tyrosine-protein phosphatase, Mlr4629', 'UCP029416_PTP', 4, NULL),
(17187, NULL, 'IPR023202', NULL, 'YejL-like superfamily', 'YejL_sf', 5, NULL),
(17188, NULL, 'IPR017329', NULL, 'Peptidase S1A, HAT/DESC1', 'Pept_S1A_HAT/DESC1', 4, NULL),
(17189, NULL, 'IPR023309', NULL, 'Endoglucanase F, domain 2', 'Endo-1-4-beta-glucanase_dom2', 5, NULL),
(17190, NULL, 'IPR019772', NULL, 'Ferrochelatase, active site', 'Ferrochelatase_AS', 0, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(17191, NULL, 'IPR013183', NULL, 'DASH complex subunit Hsk3-like', 'Hsk3-like', 4, NULL),
(17192, NULL, 'IPR016908', NULL, 'Uncharacterised conserved protein UCP029037', 'UCP029037', 4, NULL),
(17193, NULL, 'IPR019468', NULL, 'Adenylosuccinate lyase C-terminal', 'AdenyloSucc_lyase_C', 3, NULL),
(17194, NULL, 'IPR035057', NULL, 'SH2B1, SH2 domain', 'SH2B1_SH2', 3, NULL),
(17195, NULL, 'IPR022749', NULL, 'N6 adenine-specific DNA methyltransferase, N-terminal domain', 'D12N6_MeTrfase_N', 3, NULL),
(17196, NULL, 'IPR019429', NULL, '7TM GPCR, serpentine chemoreceptor class i (Sri)', '7TM_GPCR_serpentine_rcpt_Sri', 4, NULL),
(17197, NULL, 'IPR019474', NULL, 'Ubiquitin conjugation factor E4, core', 'Ub_conjug_fac_E4_core', 3, NULL),
(17198, NULL, 'IPR019817', NULL, 'Interferon regulatory factor, conserved site', 'Interferon_reg_fac_CS', 2, NULL),
(17199, NULL, 'IPR022746', NULL, 'Cathelicidin, antimicrobial peptide, C-terminal', 'Cathlecidin_C', 3, NULL),
(17200, NULL, 'IPR035277', NULL, 'MalF, N-terminal', 'MalF_N', 5, NULL),
(17201, NULL, 'IPR018695', NULL, 'Protein of unknown function DUF2194', 'DUF2194', 4, NULL),
(17202, NULL, 'IPR022820', NULL, 'Uncharacterised protein family UPF0758, YicR subfamily', 'UPF0758_YicR', 4, NULL),
(17203, NULL, 'IPR016926', NULL, 'Uncharacterised conserved protein UCP029594', 'UCP029594', 4, NULL),
(17204, NULL, 'IPR034507', NULL, 'RBM14, RNA recognition motif 2', 'RBM14_RRM2', 3, NULL),
(17205, NULL, 'IPR019455', NULL, 'Acetolactate synthase, small subunit, C-terminal', 'Acetolactate_synth_ssu_C', 3, NULL),
(17206, NULL, 'IPR013189', NULL, 'Glycosyl hydrolase family 32, C-terminal', 'Glyco_hydro_32_C', 3, NULL),
(17207, NULL, 'IPR016925', NULL, 'Uncharacterised conserved protein UCP029570', 'UCP029570', 4, NULL),
(17208, NULL, 'IPR013203', NULL, 'Leader peptide, Arg-2/CPA1', 'Leader_Arg2_CPA1', 4, NULL),
(17209, NULL, 'IPR018716', NULL, 'Protein of unknown function DUF2240', 'DUF2240', 4, NULL),
(17210, NULL, 'IPR016241', NULL, 'Nitrogen network kinase 1', 'Nnk1', 4, NULL),
(17211, NULL, 'IPR018700', NULL, 'Protein of unknown function DUF2204', 'DUF2204', 4, NULL),
(17212, NULL, 'IPR016212', NULL, 'Methyl coenzyme M reductase, alpha subunit', 'Me_CoM_Rdtase_asu', 4, NULL),
(17213, NULL, 'IPR022839', NULL, 'Undecaprenyl phosphate-alpha-4-amino-4-deoxy-L-arabinose arabinosyl transferase', 'ArnT_tfrase', 4, NULL),
(17214, NULL, 'IPR022871', NULL, 'Para-hydroxybenzoic acid efflux pump, subunit AaeA', 'PHBA_efflux_pump_AaeA', 4, NULL),
(17215, NULL, 'IPR022752', NULL, 'Signal transducer and activation of transcription 1, TAZ2 binding domain, C-terminal', 'STAT1_TAZ2-bd_C', 3, NULL),
(17216, NULL, 'IPR018708', NULL, 'Protein of unknown function DUF2225', 'DUF2225', 4, NULL),
(17217, NULL, 'IPR018684', NULL, 'Protein of unknown function DUF2171', 'DUF2171', 4, NULL),
(17218, NULL, 'IPR018711', NULL, 'Phosphodiester glycosidase', 'NAGPA', 3, NULL),
(17219, NULL, 'IPR018715', NULL, 'Protein of unknown function DUF2239', 'DUF2239', 4, NULL),
(17220, NULL, 'IPR018723', NULL, 'Protein of unknown function DUF2254, membrane', 'DUF2254_membrane', 4, NULL),
(17221, NULL, 'IPR016929', NULL, 'Imm52 family, TsiT-like', 'TsiT-like', 4, NULL),
(17222, NULL, 'IPR022867', NULL, 'Protein-methionine-sulfoxide reductase subunit MsrP', 'MsrP', 4, NULL),
(17223, NULL, 'IPR022827', NULL, 'Phycoerythrobilin:ferredoxin oxidoreductase', 'Phycoerythrobilin_Fdx_Rdtase', 4, NULL),
(17224, NULL, 'IPR022913', NULL, 'Multidrug resistance protein MdtK', 'Multidrug-R_MdtK', 4, NULL),
(17225, NULL, 'IPR022812', NULL, 'Dynamin', 'Dynamin', 4, NULL),
(17226, NULL, 'IPR013207', NULL, 'LGFP', 'LGFP', 7, NULL),
(17227, NULL, 'IPR017349', NULL, 'Tumour necrosis factor receptor 3', 'TNFR_3_LTBR', 4, NULL),
(17228, NULL, 'IPR017344', NULL, 'Uncharacterised conserved protein UCP037988,TerD, trypsin', 'UCP037988', 4, NULL),
(17229, NULL, 'IPR020014', NULL, 'Decahaem cytochrome, c-type, OmcA/MtrC', 'Decahaem_cyt-c_OmcA/MtrC', 4, NULL),
(17230, NULL, 'IPR019771', NULL, 'F-actin capping protein, beta subunit, conserved site', 'F-actin_capping_bsu_CS', 2, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(17231, NULL, 'IPR018721', NULL, 'Protein of unknown function DUF2252', 'DUF2252', 4, NULL),
(17232, NULL, 'IPR035122', NULL, 'Uncharacterized protein B277', 'B277', 4, NULL),
(17233, NULL, 'IPR016219', NULL, 'Phosphatidylethanolamine N-methyltransferase, fungi', 'Phosphatid-EA_MeTrfase_fun', 4, NULL),
(17234, NULL, 'IPR022644', NULL, 'Orn/DAP/Arg decarboxylase 2, N-terminal', 'De-COase2_N', 3, NULL),
(17235, NULL, 'IPR018680', NULL, 'Protein of unknown function DUF2164', 'DUF2164', 4, NULL),
(17236, NULL, 'IPR016215', NULL, 'Nitrilotriacetate monooxygenase component A/pristinamycin IIA synthase subunit A', 'NTA_MOA', 4, NULL),
(17237, NULL, 'IPR018285', NULL, 'Methionyl-tRNA synthetase, N-terminal heteromerisation domain', 'Met-tRNA-synth_N', 3, NULL),
(17238, NULL, 'IPR018677', NULL, 'Domain of unknown function DUF2157', 'DUF2157', 3, NULL),
(17239, NULL, 'IPR022775', NULL, 'AP complex, mu/sigma subunit', 'AP_mu_sigma_su', 3, NULL),
(17240, NULL, 'IPR022909', NULL, '50S ribosomal protein L10, archaea', '50S_L10_arch', 4, NULL),
(17241, NULL, 'IPR017334', NULL, 'Eukaryotic translation initiation factor 3 subunit G', 'eIF3_g', 4, NULL),
(17242, NULL, 'IPR016223', NULL, 'DNA alpha-glucosyltransferase', 'DNA_alpha-glucosyltransferase', 4, NULL),
(17243, NULL, 'IPR019808', NULL, 'Histidine triad, conserved site', 'Histidine_triad_CS', 2, NULL),
(17244, NULL, 'IPR018692', NULL, 'Predicted integral membrane protein DUF2189', 'DUF2189', 4, NULL),
(17245, NULL, 'IPR035061', NULL, 'Shark-like, N-terminal SH2 domain', 'Shark-like_SH2_N', 3, NULL),
(17246, NULL, 'IPR023137', NULL, 'BrxA superfamily', 'BrxA_sf', 5, NULL),
(17247, NULL, 'IPR017348', NULL, 'Serine/threonine-protein kinase pim-1/2/3', 'PIM1/2/3', 4, NULL),
(17248, NULL, 'IPR019795', NULL, 'Globin, bacterial-like, conserved site', 'Globin_bac-like_CS', 2, NULL),
(17249, NULL, 'IPR018710', NULL, 'Protein of unknown function DUF2232', 'DUF2232', 4, NULL),
(17250, NULL, 'IPR019480', NULL, 'Dihydroorotate dehydrogenase, electron transfer subunit, iron-sulphur cluster binding domain', 'Dihydroorotate_DH_Fe-S-bd', 3, NULL),
(17251, NULL, 'IPR035481', NULL, 'GRAF, SH3 domain', 'GRAF_SH3', 3, NULL),
(17252, NULL, 'IPR019804', NULL, 'Ras guanine-nucleotide exchange factor, conserved site', 'Ras_G-nucl-exch_fac_CS', 2, NULL),
(17253, NULL, 'IPR022757', NULL, 'Glucose signalling factor 2', 'Gsf2', 4, NULL),
(17254, NULL, 'IPR022782', NULL, 'Actin interacting protein 3-like, C-terminal', 'AIP3-like_C', 3, NULL),
(17255, NULL, 'IPR022901', NULL, 'snRNP Sm-like, putative, archaea', 'snRNP_Sm-like_arc', 4, NULL),
(17256, NULL, 'IPR019432', NULL, 'Acyltransferase MbtK/IucB-like, conserved domain', 'Acyltransferase_MbtK/IucB-like', 3, NULL),
(17257, NULL, 'IPR022805', NULL, 'Phosphoenolpyruvate carboxylase, bacterial/plant-type', 'PEP_COase_bac/pln-type', 4, NULL),
(17258, NULL, 'IPR021118', NULL, 'Calcitonin', 'Calcitonin', 4, NULL),
(17259, NULL, 'IPR022822', NULL, 'Lactate utilization protein A', 'LutA', 4, NULL),
(17260, NULL, 'IPR019789', NULL, 'Xylulose 5-phosphate/Fructose 6-phosphate phosphoketolase, thiamine diphosphate binding site', 'Xul5P/Fru6P_PKetolase_ThDP_BS', 1, NULL),
(17261, NULL, 'IPR013188', NULL, 'Influenza matrix M1, C-terminal', 'Flu_matrix_M1_C', 3, NULL),
(17262, NULL, 'IPR019449', NULL, 'FMP27, WPPW  domain', 'FMP27_WPPW_dom', 3, NULL),
(17263, NULL, 'IPR016225', NULL, 'NAD--protein ADP-ribosyltransferase Alt-like', 'Phage_T4_Alt-like', 4, NULL),
(17264, NULL, 'IPR022924', NULL, 'Cardiolipin synthase', 'Cardiolipin_synthase', 4, NULL),
(17265, NULL, 'IPR022905', NULL, 'DNA-directed RNA polymerase subunit Rpo11', 'Rpo11', 4, NULL),
(17266, NULL, 'IPR023138', NULL, 'NMB0513-like superfamily', 'NMB0513-like_sf', 5, NULL),
(17267, NULL, 'IPR016213', NULL, 'Polyphenol oxidase', 'Polyphenol_oxidase', 4, NULL),
(17268, NULL, 'IPR022920', NULL, 'Disulphide bond formation protein DsbB', 'Disulphide_bond_form_DsbB', 4, NULL),
(17269, NULL, 'IPR013199', NULL, 'M protein trans-acting positive regulator (MGA) HTH domain', 'HTH_Mga_DNA-bd_dom', 3, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(17270, NULL, 'IPR018674', NULL, 'Protein of unknown function DUF2142, membrane', 'DUF2142_membrane', 4, NULL),
(17271, NULL, 'IPR022828', NULL, 'Thiazole biosynthetic enzyme, prokaryotic', 'Thi4_prok', 4, NULL),
(17272, NULL, 'IPR019791', NULL, 'Haem peroxidase, animal-type', 'Haem_peroxidase_animal', 4, NULL),
(17273, NULL, 'IPR016920', NULL, 'Uncharacterised conserved protein UCP029477', 'UCP029477', 4, NULL),
(17274, NULL, 'IPR016899', NULL, 'mRNA cap guanine-N7 methyltransferase, eukaryotes', 'mRNA_G-N7_MeTrfase_euk', 4, NULL),
(17275, NULL, 'IPR016214', NULL, 'NAD-reducing hydrogenase, HoxS gamma subunit', 'NAD-red_Hydgase_HoxS_gsu', 4, NULL),
(17276, NULL, 'IPR023276', NULL, 'Aquaporin 5', 'Aquaporin_5', 4, NULL),
(17277, NULL, 'IPR022825', NULL, 'Lactate utilization protein B', 'LutB', 4, NULL),
(17278, NULL, 'IPR016245', NULL, 'Tyrosine protein kinase, EGF/ERB/XmrK receptor', 'Tyr_kinase_EGF/ERB/XmrK_rcpt', 4, NULL),
(17279, NULL, 'IPR013209', NULL, 'Lipin/Ned1/Smp2 (LNS2)', 'LNS2', 3, NULL),
(17280, NULL, 'IPR022843', NULL, 'Formamidase', 'Formamidase', 4, NULL),
(17281, NULL, 'IPR013175', NULL, 'INO80 complex, subunit Ies4', 'INO80_su_Ies4', 4, NULL),
(17282, NULL, 'IPR017343', NULL, 'Uncharacterised conserved protein UCP037987', 'UCP037987', 4, NULL),
(17283, NULL, 'IPR017346', NULL, 'UBX domain-containing protein 2/7', 'UBX_7/2', 4, NULL),
(17284, NULL, 'IPR022852', NULL, 'Carnitinyl-CoA dehydratase', 'Carnitinyl_CoA_dehydratase', 4, NULL),
(17285, NULL, 'IPR022882', NULL, 'tRNA1(Val) (adenine(37)-N6)-methyltransferase', 'tRNA_adenine-N6_MeTrfase', 4, NULL),
(17286, NULL, 'IPR022906', NULL, 'Uncharacterised protein family UPF0127', 'UPF0127', 4, NULL),
(17287, NULL, 'IPR019827', NULL, 'Leukemia inhibitory factor /oncostatin, conserved site', 'Leukemia_IF/oncostatin_CS', 2, NULL),
(17288, NULL, 'IPR017667', NULL, 'Putative methanogenesis marker protein 1', 'Methan_mark_1', 4, NULL),
(17289, NULL, 'IPR027267', NULL, 'AH/BAR domain superfamily', 'AH/BAR_dom_sf', 5, NULL),
(17290, NULL, 'IPR019427', NULL, '7TM GPCR, serpentine receptor class w (Srw)', '7TM_GPCR_serpentine_rcpt_Srw', 4, NULL),
(17291, NULL, 'IPR019984', NULL, '30S ribosomal protein S17', 'Ribosomal_S17', 4, NULL),
(17292, NULL, 'IPR022755', NULL, 'Zinc finger, double-stranded RNA binding', 'Znf_C2H2_jaz', 3, NULL),
(17293, NULL, 'IPR017652', NULL, 'Acetyl/Succinylornithine transaminase family, bacteria', 'Ac/SucOrn_transaminase_bac', 4, NULL),
(17294, NULL, 'IPR016238', NULL, 'Ribosomal protein S6 kinase', 'Ribosomal_S6_kinase', 4, NULL),
(17295, NULL, 'IPR022844', NULL, 'Glycogen debranching enzyme, bacterial', 'Glycogen_debranch_bac', 4, NULL),
(17296, NULL, 'IPR016914', NULL, 'tRNA (cytidine/uridine-2''-O-)-methyltransferase', 'tRNA_cyt/urid_MeTfrase', 4, NULL),
(17297, NULL, 'IPR013182', NULL, 'Domain of unknown function DUF1720', 'DUF1720', 3, NULL),
(17298, NULL, 'IPR019448', NULL, 'NT-type C2 domain', 'NT-C2', 3, NULL),
(17299, NULL, 'IPR019805', NULL, 'Heat shock protein Hsp90, conserved site', 'Heat_shock_protein_90_CS', 2, NULL),
(17300, NULL, 'IPR022841', NULL, '5-dehydro-2-deoxygluconokinase, Firmicutes', 'DKG_kinase_firmi', 4, NULL),
(17301, NULL, 'IPR016216', NULL, 'Monophenol monooxygenase, fungi', 'Monophenol_mOase_fun', 4, NULL),
(17302, NULL, 'IPR019797', NULL, 'Glutamate 5-kinase, conserved site', 'Glutamate_5-kinase_CS', 2, NULL),
(17303, NULL, 'IPR016916', NULL, 'Uncharacterised conserved protein UCP029389, subtilisin-related', 'UCP029389_subtilisin-related', 4, NULL),
(17304, NULL, 'IPR019469', NULL, 'Protein of unknown function DUF2443', 'DUF2443', 4, NULL),
(17305, NULL, 'IPR022780', NULL, 'Dynein family light intermediate chain', 'Dynein_light_int_chain', 4, NULL),
(17306, NULL, 'IPR022858', NULL, 'Metallothiol transferase FosB', 'Metallothiol_Trafse_FosB', 4, NULL),
(17307, NULL, 'IPR019801', NULL, 'Glycoside hydrolase, family 35, conserved site', 'Glyco_hydro_35_CS', 2, NULL),
(17308, NULL, 'IPR016222', NULL, 'Glycerol-3-phosphate O-acyltransferase, chloroplast', 'G3P_O-acylTrfase_chlp', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(17309, NULL, 'IPR023201', NULL, 'SecY domain superfamily', 'SecY_dom_sf', 5, NULL),
(17310, NULL, 'IPR017327', NULL, 'Peptidase S1A, TMPRSS13', 'Peptidase_S1A_TMPRSS13', 4, NULL),
(17311, NULL, 'IPR022794', NULL, 'Bul1, C-terminal', 'Bul1_C', 3, NULL),
(17312, NULL, 'IPR019473', NULL, 'Transcription factor TFIID, subunit 8, C-terminal', 'TFIID_su8_C', 3, NULL),
(17313, NULL, 'IPR023277', NULL, 'Aquaporin 8', 'Aquaporin_8', 4, NULL),
(17314, NULL, 'IPR016902', NULL, 'Vacuolar protein sorting-associated protein 41', 'VPS41', 4, NULL),
(17315, NULL, 'IPR022637', NULL, 'DNA polymerase III, beta sliding clamp, central', 'DNA_polIII_beta_cen', 3, NULL),
(17316, NULL, 'IPR019803', NULL, 'Glypican, conserved site', 'Glypican_CS', 2, NULL),
(17317, NULL, 'IPR017659', NULL, 'Formyl-CoA:oxalate CoA-transferase', 'Formyl_CoA_transfer', 4, NULL),
(17318, NULL, 'IPR016250', NULL, 'Tyrosine-protein kinase, Fes/Fps type', 'Tyr-prot_kinase_Fes/Fps', 4, NULL),
(17319, NULL, 'IPR019792', NULL, 'Gonadoliberin', 'Gonadoliberin', 4, NULL),
(17320, NULL, 'IPR024210', NULL, 'Protein of unknown function DUF3785', 'DUF3785', 4, NULL),
(17321, NULL, 'IPR022778', NULL, 'CDKN3 domain', 'CDKN3', 3, NULL),
(17322, NULL, 'IPR018668', NULL, 'DNA-binding protein VF530-like', 'DNA-binding_VF530-like', 4, NULL),
(17323, NULL, 'IPR016248', NULL, 'Fibroblast growth factor receptor family', 'FGF_rcpt_fam', 4, NULL),
(17324, NULL, 'IPR018713', NULL, 'ER-bound oxygenase mpaB/mpaB''/Rubber oxygenase, catalytic domain', 'MPAB/Lcp_cat_dom', 3, NULL),
(17325, NULL, 'IPR018696', NULL, 'Protein of unknown function DUF2195', 'DUF2195', 4, NULL),
(17326, NULL, 'IPR013197', NULL, 'RNA polymerase III subunit RPC82-related, helix-turn-helix', 'RNA_pol_III_RPC82-rel_HTH', 3, NULL),
(17327, NULL, 'IPR013206', NULL, 'Leucophaea maderae tachykinin-related peptide', 'Lem_TRP', 4, NULL),
(17328, NULL, 'IPR022744', NULL, 'Methyltransferase domain, putative', 'MeTrfase_dom_put', 3, NULL),
(17329, NULL, 'IPR016907', NULL, 'Uncharacterised conserved protein UCP029033, periplasmic protein', 'UCP029033', 4, NULL),
(17330, NULL, 'IPR023164', NULL, 'YqgQ-like superfamily', 'YqgQ-like_sf', 5, NULL),
(17331, NULL, 'IPR018676', NULL, 'Protein of unknown function DUF2149', 'DUF2149', 4, NULL),
(17332, NULL, 'IPR021117', NULL, 'Calcitonin-like', 'Calcitonin-like', 4, NULL),
(17333, NULL, 'IPR019452', NULL, 'Vacuolar sorting protein 39/Transforming growth factor beta receptor-associated domain 1', 'VPS39/TGF_beta_rcpt-assoc_1', 3, NULL),
(17334, NULL, 'IPR022643', NULL, 'Orn/DAP/Arg decarboxylase 2, C-terminal', 'De-COase2_C', 3, NULL),
(17335, NULL, 'IPR016233', NULL, 'Homeobox protein Pitx/unc30', 'Homeobox_Pitx/unc30', 4, NULL),
(17336, NULL, 'IPR019821', NULL, 'Kinesin motor domain, conserved site', 'Kinesin_motor_CS', 2, NULL),
(17337, NULL, 'IPR022369', NULL, 'Integral membrane protein TerC, riboswitch-linked', 'Integral_membrane_TerC_rswitch', 4, NULL),
(17338, NULL, 'IPR019451', NULL, 'RNA polymerase II assembly factor Rtp1, C-terminal', 'Rtp1_C1', 3, NULL),
(17339, NULL, 'IPR016251', NULL, 'Tyrosine-protein kinase, non-receptor Jak/Tyk2', 'Tyr_kinase_non-rcpt_Jak/Tyk2', 4, NULL),
(17340, NULL, 'IPR018704', NULL, 'Tetratricopeptide repeat-like domain', 'TPR_21', 3, NULL),
(17341, NULL, 'IPR016211', NULL, 'Glutamate/phenylalanine/leucine/valine dehydrogenase, bacterial/archaeal', 'Glu/Phe/Leu/Val_DH_bac/arc', 4, NULL),
(17342, NULL, 'IPR017669', NULL, 'Methyl coenzyme M reductase system, component A2', 'Me_Coenz_M_Rdtase_A2', 4, NULL),
(17343, NULL, 'IPR017666', NULL, '2-aminoethylphosphonate ABC transport system, ATP-binding component PhnT2', 'AminoethylPonate_ABC_PhnT2', 4, NULL),
(17344, NULL, 'IPR017661', NULL, '2-aminoethylphosphonate ABC transport system, membrane component PhnV', 'AminoethylPonate_ABC_PhnV', 4, NULL),
(17345, NULL, 'IPR022800', NULL, 'Spt4/RpoE2 zinc finger', 'Spt4/RpoE2_Znf', 3, NULL),
(17346, NULL, 'IPR018672', NULL, 'Protein of unknown function DUF2140', 'DUF2140', 4, NULL),
(17347, NULL, 'IPR019431', NULL, 'Protein of unknown function DUF2417', 'DUF2417', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(17348, NULL, 'IPR022821', NULL, 'Transcription regulator HTH, MurR', 'Tscrpt_reg_HTH_MurR', 4, NULL),
(17349, NULL, 'IPR019478', NULL, 'Sirohaem synthase, dimerisation domain', 'Sirohaem_synthase_dimer_dom', 3, NULL),
(17350, NULL, 'IPR016234', NULL, 'Serine/threonine-protein kinase, Sbk1', 'Ser/Thr_kinase_Sbk1', 4, NULL),
(17351, NULL, 'IPR017337', NULL, 'Zinc finger Ran-binding domain-containing protein 2', 'ZRANB2', 4, NULL),
(17352, NULL, 'IPR019470', NULL, 'Ubiquitinol-cytochrome C reductase, Fe-S subunit, TAT signal', 'Ubiq_cytC_Rdtase_Fe-S_su_TAT', 3, NULL),
(17353, NULL, 'IPR022903', NULL, 'Glycine cleavage system T protein, bacteria', 'GCS_T_bac', 4, NULL),
(17354, NULL, 'IPR022919', NULL, 'Peptidase M48, protease HtpX, putative', 'Pept_M48_protease_HtpX', 4, NULL),
(17355, NULL, 'IPR016900', NULL, 'Alpha-2-glucosyltransferase Alg10', 'Alg10', 4, NULL),
(17356, NULL, 'IPR022861', NULL, 'Glutamine-tRNA ligase, bacterial', 'Gln_tRNA_ligase_bac', 4, NULL),
(17357, NULL, 'IPR016242', NULL, 'Serine/threonine-protein kinase Mps1', 'Mps1', 4, NULL),
(17358, NULL, 'IPR022758', NULL, 'ATP-dependent helicase Sgs1', 'Helicase_Sgs1', 3, NULL),
(17359, NULL, 'IPR022898', NULL, 'Ribonuclease HII', 'RNase_HII', 4, NULL),
(17360, NULL, 'IPR016903', NULL, 'Nucleolar complex-associated protein 3', 'Nucleolar_cplx-assoc_3', 4, NULL),
(17361, NULL, 'IPR019479', NULL, 'Peroxiredoxin, C-terminal', 'Peroxiredoxin_C', 3, NULL),
(17362, NULL, 'IPR016901', NULL, 'Anaphase-promoting complex subunit APC10/Doc1', 'APC10/Doc1', 4, NULL),
(17363, NULL, 'IPR022776', NULL, 'TRM13/UPF0224 family, U11-48K-like CHHC zinc finger domain', 'TRM13/UPF0224_CHHC_Znf_dom', 3, NULL),
(17364, NULL, 'IPR018679', NULL, 'Putative PD-(D/E)XK phosphodiesterase (DUF2161)', 'DUF2161', 4, NULL),
(17365, NULL, 'IPR034677', NULL, 'Protein Kinase B beta, catalytic domain', 'Akt2', 3, NULL),
(17366, NULL, 'IPR023139', NULL, 'PBDC1-like domain superfamily', 'PBDC1-like_dom_sf', 5, NULL),
(17367, NULL, 'IPR019447', NULL, 'DNA/RNA-binding protein Kin17, WH-like domain', 'DNA/RNA-bd_Kin17_WH-like_dom', 3, NULL),
(17368, NULL, 'IPR017649', NULL, 'Succinylglutamate-semialdehyde dehydrogenase', 'SuccinylGlu_semiald_DH_AstD', 4, NULL),
(17369, NULL, 'IPR022648', NULL, 'Proliferating cell nuclear antigen, PCNA, N-terminal', 'Pr_cel_nuc_antig_N', 3, NULL),
(17370, NULL, 'IPR017341', NULL, 'Membrane cofactor protein CD46', 'CD46', 4, NULL),
(17371, NULL, 'IPR019818', NULL, 'Isocitrate/isopropylmalate dehydrogenase, conserved site', 'IsoCit/isopropylmalate_DH_CS', 2, NULL),
(17372, NULL, 'IPR019811', NULL, 'Homoserine dehydrogenase, conserved site', 'HDH_CS', 2, NULL),
(17373, NULL, 'IPR016921', NULL, 'Uncharacterised conserved protein UCP029502', 'UCP029502', 4, NULL),
(17374, NULL, 'IPR022587', NULL, 'Myotubularin-related 12-like C-terminal domain', 'MTMR12-like_C', 3, NULL),
(17375, NULL, 'IPR013193', NULL, 'Hepatitis C virus non-structural 5a, 1B domain', 'HCV_NS5a_1B_dom', 3, NULL),
(17376, NULL, 'IPR019773', NULL, 'Tyrosine 3-monooxygenase-like', 'Tyrosine_3-monooxygenase-like', 4, NULL),
(17377, NULL, 'IPR018699', NULL, 'Protein of unknown function DUF2203', 'DUF2203', 4, NULL),
(17378, NULL, 'IPR022856', NULL, 'Ribosomal protein L21e, archaeal', 'Ribosomal_L21e_arc', 4, NULL),
(17379, NULL, 'IPR016905', NULL, 'Glycyl radical enzyme YjjI-like', 'Glycyl_radical_YjjI-like', 4, NULL),
(17380, NULL, 'IPR019440', NULL, 'Chromatid cohesion factor MAU2', 'MAU2', 4, NULL),
(17381, NULL, 'IPR022879', NULL, 'V-type ATP synthase regulatory subunit B/beta', 'V-ATPase_su_B/beta', 4, NULL),
(17382, NULL, 'IPR013181', NULL, 'Protein of unknown function DUF1719', 'DUF1719', 4, NULL),
(17383, NULL, 'IPR017670', NULL, 'Phosphonate degradation operon associated HDIG domain protein', 'Phosphonate_degrad_HDIG', 4, NULL),
(17384, NULL, 'IPR019456', NULL, 'Pyruvate-flavodoxin oxidoreductase, EKR domain', 'Pyrv-flavodox_OxRtase_EKR', 3, NULL),
(17385, NULL, 'IPR016923', NULL, 'Uncharacterised conserved protein UCP029509, membrane', 'UCP029509', 4, NULL),
(17386, NULL, 'IPR022894', NULL, 'Oligoribonuclease', 'Oligoribonuclease', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(17387, NULL, 'IPR016932', NULL, 'Uncharacterised conserved protein UCP029669', 'UCP029669', 4, NULL),
(17388, NULL, 'IPR018685', NULL, 'Protein of unknown function DUF2173', 'DUF2173', 4, NULL),
(17389, NULL, 'IPR017321', NULL, 'Histone deacetylase class II, yeast', 'Hist_deAcase_II_yeast', 4, NULL),
(17390, NULL, 'IPR022759', NULL, 'Antirestriction protein Ral', 'Antirestriction_protein_Ral', 4, NULL),
(17391, NULL, 'IPR013177', NULL, 'Mitochondrial mRNA-processing protein COX24, C-terminal', 'COX24_C', 3, NULL),
(17392, NULL, 'IPR017331', NULL, 'Peptidoglycan recognition protein, PGRP-S', 'Peptidoglycan_recognition', 4, NULL),
(17393, NULL, 'IPR034903', NULL, 'LARP4, RNA recognition motif', 'LARP4_RRM', 3, NULL),
(17394, NULL, 'IPR016208', NULL, 'Aldehyde oxidase/xanthine dehydrogenase', 'Ald_Oxase/xanthine_DH', 4, NULL),
(17395, NULL, 'IPR022908', NULL, 'tRNA(Phe) 7-((3-amino-3-carboxypropyl)-4-demethylwyosine(37)-N(4))-methyltransferase', 'Taw3', 4, NULL),
(17396, NULL, 'IPR022910', NULL, 'Thiol:disulphide interchange protein DsbD', 'Thiol_diS_interchange_DbsD', 4, NULL),
(17397, NULL, 'IPR019471', NULL, 'Interferon regulatory factor-3', 'Interferon_reg_factor-3', 3, NULL),
(17398, NULL, 'IPR018714', NULL, 'Protein of unknown function DUF2237', 'DUF2237', 4, NULL),
(17399, NULL, 'IPR017324', NULL, 'Transmembrane protease serine 9', 'Tmprss9', 4, NULL),
(17400, NULL, 'IPR017655', NULL, '5-dehydro-4-deoxyglucarate dehydratase', 'Dehydro-deoxyglucarate_dehyd', 4, NULL),
(17401, NULL, 'IPR016240', NULL, 'Serine/threonine-protein kinase YKL116C, predicted', 'Ser/Thr_kin_YKL116c_prd', 4, NULL),
(17402, NULL, 'IPR016934', NULL, 'Uncharacterised conserved protein UCP029691', 'UCP029691', 4, NULL),
(17403, NULL, 'IPR013204', NULL, 'Leader peptide, Erm', 'Leader_Erm', 4, NULL),
(17404, NULL, 'IPR019435', NULL, 'Velum formation protein 1-like', 'Vel1-like', 4, NULL),
(17405, NULL, 'IPR017355', NULL, 'Tumour necrosis factor ligand 10/11', 'TNF_ligand_10/11', 4, NULL),
(17406, NULL, 'IPR022634', NULL, 'DNA polymerase III, beta sliding clamp, N-terminal', 'DNA_polIII_beta_N', 3, NULL),
(17407, NULL, 'IPR022649', NULL, 'Proliferating cell nuclear antigen, PCNA, C-terminal', 'Pr_cel_nuc_antig_C', 3, NULL),
(17408, NULL, 'IPR022367', NULL, '2-oxoacid:acceptor oxidoreductase, alpha subunit', '2-oxoacid/accept_OxRdtase_asu', 4, NULL),
(17409, NULL, 'IPR017668', NULL, 'Putative methanogenesis marker protein 2', 'Methan_mark_2', 4, NULL),
(17410, NULL, 'IPR016924', NULL, 'Uncharacterised conserved protein UCP029543', 'UCP029543', 4, NULL),
(17411, NULL, 'IPR018698', NULL, 'VWA-like domain', 'VWA-like_dom', 3, NULL),
(17412, NULL, 'IPR022881', NULL, 'Ribosomal RNA large subunit methyltransferase, Cfr', 'rRNA_lsu_MeTfrase_Cfr', 4, NULL),
(17413, NULL, 'IPR019790', NULL, 'Xylulose 5-phosphate/Fructose 6-phosphate phosphoketolase, conserved site', 'Xul5P/Fru6P_PKetolase_CS', 2, NULL),
(17414, NULL, 'IPR022854', NULL, 'PyrE-like', 'PyrE-like', 4, NULL),
(17415, NULL, 'IPR022748', NULL, 'NADH dehydrogenase subunit 2, N-terminal', 'NADH_DH_su2_N', 3, NULL),
(17416, NULL, 'IPR013201', NULL, 'Cathepsin propeptide inhibitor domain (I29)', 'Prot_inhib_I29', 3, NULL),
(17417, NULL, 'IPR016910', NULL, 'Uncharacterised conserved protein UCP029195, PTS-EIIA 2', 'UCP029195_PTS_EIIA2', 4, NULL),
(17418, NULL, 'IPR019825', NULL, 'Legume lectin, beta chain, Mn/Ca-binding site', 'Lectin_legB_Mn/Ca_BS', 1, NULL),
(17419, NULL, 'IPR016254', NULL, 'Serine/threonine-protein kinase, asfivirus', 'Ser/Thr_kinase_asfivir', 4, NULL),
(17420, NULL, 'IPR035121', NULL, 'Uncharacterized protein US30', 'US30', 4, NULL),
(17421, NULL, 'IPR022753', NULL, 'Type IV pilus biogenesis PilP', 'T4SS_pilus_biogen_PilP', 4, NULL),
(17422, NULL, 'IPR016229', NULL, 'Thiamine-phosphate synthase, cyanobacterial/bacterial', 'TMP_synthase_cyanobac_bac', 4, NULL),
(17423, NULL, 'IPR013176', NULL, 'Vacuolar fusion protein Ccz1', 'Ccz1', 4, NULL),
(17424, NULL, 'IPR017664', NULL, '2-aminoethylphosphonate ABC transport system, permease protein, putative', 'AminoethylPonate_ABC_perm-1', 4, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(17425, NULL, 'IPR016218', NULL, 'Acetyl-CoA decarbonylase/synthase complex, gamma subunit', 'AcylCoA_decarb/synth_gsu', 4, NULL),
(17426, NULL, 'IPR023193', NULL, '3-phosphoshikimate 1-carboxyvinyltransferase, conserved site', 'EPSP_synthase_CS', 2, NULL),
(17427, NULL, 'IPR016220', NULL, 'Methylphosphotriester-DNA alkyltransferase, AdaA', 'Me-P-triester_DNA_alkyl-Trfase', 4, NULL),
(17428, NULL, 'IPR016236', NULL, 'Serine/threonine-protein kinase PknK, predicted', 'Ser/Thr_kinase_PknK_prd', 4, NULL),
(17429, NULL, 'IPR017333', NULL, 'Uncharacterised conserved protein UCP037948, zinc finger MYND-type', 'UCP037948_Znf-MYND', 4, NULL),
(17430, NULL, 'IPR024744', NULL, 'Putative cyclic diguanylate phosphodiesterase, CSS motif-containing domain', 'CSS-motif_dom', 3, NULL),
(17431, NULL, 'IPR022747', NULL, 'Salmonella outer protein D', 'SopD', 4, NULL),
(17432, NULL, 'IPR018678', NULL, 'Protein of unknown function DUF2160, transmembrane', 'DUF2160_TM', 4, NULL),
(17433, NULL, 'IPR035483', NULL, 'GRAF, BAR domain', 'GRAF_BAR', 3, NULL),
(17434, NULL, 'IPR022823', NULL, 'Lactate utilization protein C', 'LutC', 4, NULL),
(17435, NULL, 'IPR018671', NULL, 'Protein of unknown function DUF2138', 'DUF2138', 4, NULL),
(17436, NULL, 'IPR016912', NULL, 'Bacteriophage P2, GpU', 'Phage_P2_GpU', 4, NULL),
(17437, NULL, 'IPR016231', NULL, 'Mitogen-activated protein (MAP) kinase kinase kinase, MLK1-4', 'MLK1-4', 4, NULL),
(17438, NULL, 'IPR017665', NULL, 'Guanylate kinase', 'Guanylate_kinase', 4, NULL),
(17439, NULL, 'IPR023938', NULL, 'HMP-PP phosphatase', 'HMP-PP_phosphatase', 4, NULL),
(17440, NULL, 'IPR018706', NULL, 'Protein of unknown function DUF2214, membrane', 'DUF2214_membrane', 4, NULL),
(17441, NULL, 'IPR022754', NULL, 'DNA polymerase III, gamma subunit, domain III', 'DNA_pol_III_gamma-3', 3, NULL),
(17442, NULL, 'IPR017857', NULL, 'Coagulation factor-like, Gla domain superfamily', 'Coagulation_fac-like_Gla_dom', 5, NULL),
(17443, NULL, 'IPR015615', NULL, 'Transforming growth factor-beta-related', 'TGF-beta-rel', 4, NULL),
(17444, NULL, 'IPR016246', NULL, 'Tyrosine-protein kinase, insulin-like receptor', 'Tyr_kinase_insulin-like_rcpt', 4, NULL),
(17445, NULL, 'IPR023939', NULL, 'Cysteine desulfuration protein SufE', 'Cysteine_desulfuration_SufE', 4, NULL),
(17446, NULL, 'IPR022849', NULL, 'Peptidase S12, YfeW/YbbE-like', 'Pept_S12_YfeW/YbbE-like', 4, NULL),
(17447, NULL, 'IPR015621', NULL, 'Interleukin-1 receptor family', 'IL-1_rcpt_fam', 4, NULL),
(17448, NULL, 'IPR019460', NULL, 'Autophagy-related protein 11, C-terminal', 'Atg11_C', 3, NULL),
(17449, NULL, 'IPR022870', NULL, 'Phycocyanobilin:ferredoxin oxidoreductase', 'Ferredoxin_bilin_OxRdtase', 4, NULL),
(17450, NULL, 'IPR019481', NULL, 'Transcription factor TFIIIC, triple barrel domain', 'TFIIIC_triple_barrel', 3, NULL),
(17451, NULL, 'IPR023098', NULL, 'L-serine kinase SerK/SbnI, C-terminal', 'SerK/SbnI_C', 5, NULL),
(17452, NULL, 'IPR016230', NULL, 'Serine-protein kinase, PrkA', 'Ser_kinase_PrkA', 4, NULL),
(17453, NULL, 'IPR013210', NULL, 'Leucine-rich repeat-containing N-terminal, plant-type', 'LRR_N_plant-typ', 3, NULL),
(17454, NULL, 'IPR022829', NULL, '1,4-dihydroxy-2-naphthoyl-CoA hydrolase', 'DHNA_CoA_hydrolase', 4, NULL),
(17455, NULL, 'IPR035059', NULL, 'SH2B3, SH2 domain', 'SH2B3_SH2', 3, NULL),
(17456, NULL, 'IPR016255', NULL, 'eIF-2-alpha kinase Gcn2', 'Gcn2', 4, NULL),
(17457, NULL, 'IPR022770', NULL, 'Aerobactin siderophore biosynthesis IucA/IucC-like, C-terminal', 'IucA/IucC-like_C', 3, NULL),
(17458, NULL, 'IPR018720', NULL, 'Domain of unknown function DUF2249', 'DUF2249', 3, NULL),
(17459, NULL, 'IPR016037', NULL, '3-dehydroquinate synthase AroB', 'DHQ_synth_AroB', 3, NULL),
(17460, NULL, 'IPR035252', NULL, 'Gene product 44', 'Gp44', 4, NULL),
(17461, NULL, 'IPR019831', NULL, 'Manganese/iron superoxide dismutase, N-terminal', 'Mn/Fe_SOD_N', 3, NULL),
(17462, NULL, 'IPR017650', NULL, 'Arginine N-succinyltransferase', 'Arginine_N-succinylTrfase', 4, NULL),
(17463, NULL, 'IPR017330', NULL, 'Sperm-associated antigen 7', 'SPAG7', 4, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(17464, NULL, 'IPR018694', NULL, 'Protein of unknown function DUF2193', 'DUF2193', 4, NULL),
(17465, NULL, 'IPR019798', NULL, 'Serine hydroxymethyltransferase, pyridoxal phosphate binding site', 'Ser_HO-MeTrfase_PLP_BS', 1, NULL),
(17466, NULL, 'IPR034510', NULL, 'SECp43, RNA recognition motif 2', 'SECp43_RRM2', 3, NULL),
(17467, NULL, 'IPR022911', NULL, 'Phenylalanine-tRNA ligase alpha chain 1, bacterial', 'Phe_tRNA_ligase_alpha1_bac', 4, NULL),
(17468, NULL, 'IPR018681', NULL, 'Protein of unknown function DUF2165, transmembrane', 'DUF2165_transmembrane', 4, NULL),
(17469, NULL, 'IPR013205', NULL, 'Leader peptide, tryptophan-operon', 'Leader_Trp_op', 4, NULL),
(17470, NULL, 'IPR022796', NULL, 'Chlorophyll A-B binding protein', 'Chloroa_b-bind', 4, NULL),
(17471, NULL, 'IPR018688', NULL, 'Protein of unknown function DUF2182, transmembrane, metal-binding', 'DUF2182_TM_metal-bd', 4, NULL),
(17472, NULL, 'IPR017347', NULL, 'Heterogeneous nuclear ribonucleoprotein C', 'hnRNP_C', 4, NULL),
(17473, NULL, 'IPR024626', NULL, 'Kri1-like, C-terminal', 'Kri1-like_C', 3, NULL),
(17474, NULL, 'IPR017345', NULL, 'Peptidase S1A, Tysnd1', 'Pept_S1A_Tysnd1', 4, NULL),
(17475, NULL, 'IPR019458', NULL, 'Telomerase activating protein Est1-like, N-terminal', 'Est1-like_N', 3, NULL),
(17476, NULL, 'IPR019441', NULL, 'FMP27, GFWDK domain', 'FMP27_GFWDK_dom', 3, NULL),
(17477, NULL, 'IPR035250', NULL, 'Metapneumovirus small hydrophobic protein', 'Metap_SH', 4, NULL),
(17478, NULL, 'IPR022892', NULL, 'Ribonuclease HI', 'RNaseHI', 4, NULL),
(17479, NULL, 'IPR016928', NULL, 'Uncharacterised conserved protein UCP029611', 'UCP029611', 4, NULL),
(17480, NULL, 'IPR022840', NULL, 'GTP cyclohydrolase MptA', 'GTP_cyclohydrolase_MptA', 4, NULL),
(17481, NULL, 'IPR016227', NULL, 'Dihydropteroate synthase, predicted', 'Dihydropteroate_synthase_prd', 4, NULL),
(17482, NULL, 'IPR035123', NULL, 'Viral unique long protein 16', 'UL16', 4, NULL),
(17483, NULL, 'IPR016204', NULL, 'Homoserine dehydrogenase', 'HDH', 4, NULL),
(17484, NULL, 'IPR016221', NULL, 'Bifunctional regulatory protein Ada', 'Bifunct_regulatory_prot_Ada', 4, NULL),
(17485, NULL, 'IPR022907', NULL, 'VapC family', 'VapC_family', 4, NULL),
(17486, NULL, 'IPR016257', NULL, 'Ephrin receptor type-A /type-B', 'Tyr_kinase_ephrin_rcpt', 4, NULL),
(17487, NULL, 'IPR019475', NULL, 'DNA primase, DnaB-helicase binding domain', 'DNA_primase_DnaB-bd', 3, NULL),
(17488, NULL, 'IPR035485', NULL, 'GRAF2, SH3 domain', 'GRAF2_SH3', 3, NULL),
(17489, NULL, 'IPR016205', NULL, 'Glycerol dehydrogenase', 'Glycerol_DH', 4, NULL),
(17490, NULL, 'IPR019476', NULL, 'Type IV secretion system coupling protein TraD, DNA-binding domain', 'T4SS_TraD_DNA-bd', 3, NULL),
(17491, NULL, 'IPR017342', NULL, 'S-adenosyl-L-methionine dependent methionine synthase, predicted', 'S-AdoMet-dep_Met_synth_prd', 4, NULL),
(17492, NULL, 'IPR016210', NULL, 'NAD-dependent glutamate dehydrogenase, eukaryotes', 'NAD-GDH_euk', 4, NULL),
(17493, NULL, 'IPR019800', NULL, 'Glycoside hydrolase, family 3, active site', 'Glyco_hydro_3_AS', 0, NULL),
(17494, NULL, 'IPR018682', NULL, 'Protein of unknown function DUF2167, membrane', 'DUF2167_membr', 4, NULL),
(17495, NULL, 'IPR016237', NULL, 'Serine/threonine-protein kinase, Ulk1/Ulk2', 'Ser/Thr_kin_STPK_Ulk-1/2', 4, NULL),
(17496, NULL, 'IPR013186', NULL, 'Early nodulin 40', 'ENOD40', 4, NULL),
(17497, NULL, 'IPR019459', NULL, 'GRIP-related Arf-binding domain', 'GRAB', 3, NULL),
(17498, NULL, 'IPR019985', NULL, 'Ribosomal protein L23', 'Ribosomal_L23', 4, NULL),
(17499, NULL, 'IPR017663', NULL, 'ABC transport system, 1-aminoethylphosphonate-binding protein, putative', 'ABC_PhnS2_put', 4, NULL),
(17500, NULL, 'IPR019428', NULL, '7TM GPCR, serpentine receptor class r (Str)', '7TM_GPCR_serpentine_rcpt_Str', 4, NULL),
(17501, NULL, 'IPR016595', NULL, 'Surface-adhesin protein E, Pasteurellaceae', 'Adhesin_E_Pasteurellaceae', 4, NULL),
(17502, NULL, 'IPR013913', NULL, 'Nucleoporin Nup153, N-terminal', 'Nup153_N', 3, NULL),
(17503, NULL, 'IPR016959', NULL, 'Uncharacterised conserved protein UCP030811', 'UCP030811', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(17504, NULL, 'IPR019093', NULL, 'YpkA, Rac1-binding domain', 'Rac1-binding_domain', 3, NULL),
(17505, NULL, 'IPR035507', NULL, 'Unconventional myosin-Ie/If, SH3 domain', 'Ie/If_SH3', 3, NULL),
(17506, NULL, 'IPR018327', NULL, 'Rad4 beta-hairpin domain 2', 'BHD_2', 3, NULL),
(17507, NULL, 'IPR021280', NULL, 'Protein of unknown function DUF2723', 'DUF2723', 4, NULL),
(17508, NULL, 'IPR016960', NULL, 'Protein kinase YegI-like', 'YegI-like', 4, NULL),
(17509, NULL, 'IPR019129', NULL, 'Folate-sensitive fragile site protein Fra10Ac1', 'Folate-sensitive_fs_Fra10Ac1', 4, NULL),
(17510, NULL, 'IPR021275', NULL, 'Protein of unknown function DUF2854', 'DUF2854', 4, NULL),
(17511, NULL, 'IPR019103', NULL, 'Aspartic peptidase, DDI1-type', 'Peptidase_aspartic_DDI1-type', 3, NULL),
(17512, NULL, 'IPR021298', NULL, 'Cilia- and flagella-associated protein 298', 'CFAP298', 4, NULL),
(17513, NULL, 'IPR017679', NULL, 'Coenzyme F420 hydrogenase subunit beta, archaea', 'FrhB_archaea', 4, NULL),
(17514, NULL, 'IPR016602', NULL, 'Uncharacterised conserved protein UCP012666', 'UCP012666', 4, NULL),
(17515, NULL, 'IPR021320', NULL, 'Protein of unknown function DUF2905', 'DUF2905', 4, NULL),
(17516, NULL, 'IPR018323', NULL, 'Outer membrane lipoprotein carrier protein LolA, Proteobacteria', 'OM_lipoprot_carrier_LolA_Pbac', 4, NULL),
(17517, NULL, 'IPR019110', NULL, 'Uncharacterised protein family, RAQPRD', 'Uncharacterised_RAQPRD', 4, NULL),
(17518, NULL, 'IPR021321', NULL, 'Protein of unknown function DUF2922', 'DUF2922', 4, NULL),
(17519, NULL, 'IPR021278', NULL, 'ATP synthase subunit K', 'ATP19', 4, NULL),
(17520, NULL, 'IPR017375', NULL, 'Peroxisome assembly protein 12', 'PEX12', 4, NULL),
(17521, NULL, 'IPR021247', NULL, 'Protein of unknown function DUF2785', 'DUF2785', 4, NULL),
(17522, NULL, 'IPR019135', NULL, 'Polycomb protein, VEFS-Box', 'Polycomb_protein_VEFS-Box', 3, NULL),
(17523, NULL, 'IPR017361', NULL, 'Bifunctional phosphatidylinositol trisphosphate phosphatase/dual specificity phosphatase PTEN', 'Bifunc_PIno_P3_Pase/Pase_PTEN', 4, NULL),
(17524, NULL, 'IPR021292', NULL, 'Protein of unknown function DUF2863', 'DUF2863', 4, NULL),
(17525, NULL, 'IPR021249', NULL, 'Protein of unknown function DUF2788', 'DUF2788', 4, NULL),
(17526, NULL, 'IPR016968', NULL, 'Uncharacterised conserved protein UCP031074', 'UCP031074', 4, NULL),
(17527, NULL, 'IPR024715', NULL, 'Coagulation factor 5/8-like', 'Factor_5/8-like', 4, NULL),
(17528, NULL, 'IPR034545', NULL, 'Meiosis-specific kinetochore protein', 'Meikin', 4, NULL),
(17529, NULL, 'IPR021263', NULL, 'Protein of unknown function DUF2840', 'DUF2840', 4, NULL),
(17530, NULL, 'IPR021241', NULL, 'Peptidoglycan-binding protein, CsiV', 'CsiV', 4, NULL),
(17531, NULL, 'IPR021231', NULL, 'Protein of unknown function DUF2811', 'DUF2811', 4, NULL),
(17532, NULL, 'IPR016953', NULL, 'Uncharacterised conserved protein UCP030365', 'UCP030365', 4, NULL),
(17533, NULL, 'IPR013907', NULL, 'Sds3-like', 'Sds3', 4, NULL),
(17534, NULL, 'IPR017680', NULL, 'CoB--CoM heterodisulphide reductase, subunit C', 'CoB/CoM_hetero-S_Rdtase_csu', 4, NULL),
(17535, NULL, 'IPR020021', NULL, 'Glycosyl amidation-associated protein, WbuZ', 'Glycosyl_amidation-assoc_WbuZ', 4, NULL),
(17536, NULL, 'IPR016975', NULL, 'Cell wall-active antibiotic response protein', 'Cell_wall-act_antibiotic_resp', 4, NULL),
(17537, NULL, 'IPR023863', NULL, 'Archaeal radical SAM protein, PTO1314 family', 'rSAM_PTO1314', 4, NULL),
(17538, NULL, 'IPR016940', NULL, 'ComG operon protein C', 'ComGC', 4, NULL),
(17539, NULL, 'IPR023862', NULL, 'Conserved hypothetical protein CHP03960, radical SAM', 'CHP03960_rSAM', 4, NULL),
(17540, NULL, 'IPR013888', NULL, 'Ribonuclease P, Rpm2, mitochondrial', 'RNase_P_Rpm2_mt', 4, NULL),
(17541, NULL, 'IPR017372', NULL, 'Glial cell line-derived neurotrophic factor receptor, alpha 1/2', 'Glial_neurotroph_fac_rcpt_a1/2', 4, NULL),
(17542, NULL, 'IPR013895', NULL, 'Chromatin structure-remodeling complex protein Rsc14', 'Rsc14', 4, NULL),
(17543, NULL, 'IPR016550', NULL, 'Guanidinoacetate N-methyltransferase', 'GuanidinoAc_N-MeTrfase', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(17544, NULL, 'IPR013905', NULL, 'Lethal giant larvae (Lgl)-like, C-terminal domain', 'Lgl_C_dom', 3, NULL),
(17545, NULL, 'IPR021261', NULL, 'Glycerophosphocholine acyltransferase 1', 'GPCAT', 4, NULL),
(17546, NULL, 'IPR016565', NULL, 'Proteasome assembly chaperone 1', 'Proteasome_assmbl_chp_1', 4, NULL),
(17547, NULL, 'IPR017721', NULL, 'Indolepyruvate oxidoreductase subunit IorA', 'IorA', 4, NULL),
(17548, NULL, 'IPR016560', NULL, 'T-cell leukemia translocation-altered gene protein', 'TCTA', 4, NULL),
(17549, NULL, 'IPR019121', NULL, 'CRISPR-associated protein, CXXC-CXXC domain', 'CRISPR-assoc_CXXC-CXXC_dom', 3, NULL),
(17550, NULL, 'IPR017443', NULL, 'Ribulose bisphosphate carboxylase, large subunit, ferrodoxin-like N-terminal', 'RuBisCO_lsu_fd_N', 3, NULL),
(17551, NULL, 'IPR017675', NULL, 'Ni-sirohydrochlorin a,c-diamide reductive cyclase complex, component CfbD', 'CfbD', 4, NULL),
(17552, NULL, 'IPR021266', NULL, 'Kdo hydroxylase', 'Kdo_hydroxlase', 4, NULL),
(17553, NULL, 'IPR015664', NULL, 'P53-induced protein', 'P53_induced', 4, NULL),
(17554, NULL, 'IPR021333', NULL, 'Protein of unknown function DUF2946', 'DUF2946', 4, NULL),
(17555, NULL, 'IPR017717', NULL, '2,3-diketo-5-methylthiopentyl-1-phosphate enolase', 'Diketo-Methiopentyl-P_enolase', 4, NULL),
(17556, NULL, 'IPR016581', NULL, 'CRISPR-associated protein Cas7, subtype I-B/Tneap, bacterial', 'Cas7/Cst2/DevR_bac', 4, NULL),
(17557, NULL, 'IPR017673', NULL, 'Putative radical SAM enzyme, CHP03279 family', 'CHP03279_fam', 4, NULL),
(17558, NULL, 'IPR021282', NULL, 'Dispersed gene family protein 1, domain 5', 'Dispersed_gene_fam_prot1_dom5', 3, NULL),
(17559, NULL, 'IPR016601', NULL, 'Uncharacterised conserved protein UCP012637', 'UCP012637', 4, NULL),
(17560, NULL, 'IPR016589', NULL, 'tRNA-splicing endonuclease, SEN2 subunit', 'tRNA_splic_SEN2', 4, NULL),
(17561, NULL, 'IPR035962', NULL, 'Rop-like superfamily', 'Rop-like_sf', 5, NULL),
(17562, NULL, 'IPR013896', NULL, 'Carbon catabolite-derepressing protein kinase, ubiquitin-associated domain', 'SNF1_UBA', 3, NULL),
(17563, NULL, 'IPR013903', NULL, 'Meiotic expression up-regulated protein', 'Meiotic_expression', 4, NULL),
(17564, NULL, 'IPR013881', NULL, 'Pre-mRNA-splicing factor 3', 'Pre-mRNA_splic_Prp3', 3, NULL),
(17565, NULL, 'IPR017357', NULL, 'Telomeric repeat-binding factor 1/2', 'TERF1/2', 4, NULL),
(17566, NULL, 'IPR016954', NULL, 'Uncharacterised protein family, Vng0742h', 'Uncharacterised_Vng0742h', 4, NULL),
(17567, NULL, 'IPR016579', NULL, 'Synaptogyrin', 'Synaptogyrin', 4, NULL),
(17568, NULL, 'IPR014008', NULL, 'Cobalamin biosynthesis, precorrin-6Y methyltransferase, CbiT subunit', 'Cbl_synth_MTase_CbiT', 4, NULL),
(17569, NULL, 'IPR021271', NULL, 'Protein of unknown function DUF2850', 'DUF2850', 4, NULL),
(17570, NULL, 'IPR017716', NULL, 'S-adenosylmethionine decarboxylase proenzyme', 'S-AdoMet_deCOase_pro-enz', 4, NULL),
(17571, NULL, 'IPR016591', NULL, 'Suppressor of fused, eukaryotic', 'Suppressor_of_fused_euk', 4, NULL),
(17572, NULL, 'IPR016566', NULL, 'Uncharacterised conserved protein UCP010219', 'UCP010219', 4, NULL),
(17573, NULL, 'IPR017358', NULL, 'Ras-related small G protein, RGK family', 'RGK', 4, NULL),
(17574, NULL, 'IPR034628', NULL, 'Maltose excess protein 1', 'MEX1/MEX1-like', 4, NULL),
(17575, NULL, 'IPR013904', NULL, 'Transcriptional regulatory protein RXT2, N-terminal', 'RXT2_N', 3, NULL),
(17576, NULL, 'IPR021211', NULL, 'Sorting assembly machinery 35kDa subunit', 'SAM35', 4, NULL),
(17577, NULL, 'IPR013828', NULL, 'Haemagglutinin, HA1 chain, alpha/beta domain superfamily', 'Hemagglutn_HA1_a/b_dom_sf', 5, NULL),
(17578, NULL, 'IPR035502', NULL, 'BR140-related, PWWD domain', 'BR140-rel_PWWD', 3, NULL),
(17579, NULL, 'IPR016555', NULL, 'Phospholipase D, eukaryotic type', 'PLipase_D_euk', 4, NULL),
(17580, NULL, 'IPR023800', NULL, 'Cucumovirus coat protein, chain A', 'Cucumovirus_coat_A', 3, NULL),
(17581, NULL, 'IPR020042', NULL, 'Protein of unknown function DUF4311', 'DUF4311', 4, NULL),
(17582, NULL, 'IPR020029', NULL, 'CRISPR-associated protein Csp2', 'CRISPR-assoc_Csp2', 4, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(17583, NULL, 'IPR017364', NULL, 'Gem-associated protein 2', 'GEMIN2', 4, NULL),
(17584, NULL, 'IPR021217', NULL, 'Spiroplasma phage 1-C74, Orf10', 'Phage_1-C74_Orf10', 4, NULL),
(17585, NULL, 'IPR015655', NULL, 'Protein phosphatase 2C family', 'PP2C', 4, NULL),
(17586, NULL, 'IPR016588', NULL, 'Replication factor A protein 3, Saccharomycetes', 'Rfp3_Saccharomycetes', 4, NULL),
(17587, NULL, 'IPR017706', NULL, 'Peptidase M20/DapE, YgeY', 'Peptidase_M20/DapE_YgeY', 4, NULL),
(17588, NULL, 'IPR020018', NULL, 'Gliding motility-associated lipoprotein, GldH', 'Motility-assoc_lipoprot_GldH', 4, NULL),
(17589, NULL, 'IPR016551', NULL, 'NADH dehydrogenase [ubiquinone] 1 beta subcomplex subunit 8, metazoa', 'Ndufb8_metazoa', 4, NULL),
(17590, NULL, 'IPR021225', NULL, 'Tlde1 domain', 'Tlde1_dom', 3, NULL),
(17591, NULL, 'IPR016583', NULL, 'Uncharacterised conserved protein UCP011452, HNH endonuclease domain-type', 'UCP011452_HNH_endonucl', 4, NULL),
(17592, NULL, 'IPR021294', NULL, 'Protein of unknown function DUF2866', 'DUF2866', 4, NULL),
(17593, NULL, 'IPR013826', NULL, 'DNA topoisomerase, type IA, central region, subdomain 3', 'Topo_IA_cen_sub3', 5, NULL),
(17594, NULL, 'IPR016582', NULL, 'D-(-)-3-hydroxybutyrate oligomer hydrolase, putative', 'OHBut_olig_hydro_put', 4, NULL),
(17595, NULL, 'IPR021286', NULL, 'Baculovirus, protein E26', 'Baculovirus_E26', 4, NULL),
(17596, NULL, 'IPR020184', NULL, 'Keratin-associated protein 7', 'KRTAP7', 4, NULL),
(17597, NULL, 'IPR016941', NULL, 'Uncharacterised conserved protein UCP029962', 'UCP029962', 4, NULL),
(17598, NULL, 'IPR015672', NULL, 'The Golgi pH regulator/GPCR-type G protein', 'GPHR/GTG', 4, NULL),
(17599, NULL, 'IPR020033', NULL, 'Pyridoxal phosphate-dependent transferase, archaea', 'PyrdxlP-dep_transferase_arc', 4, NULL),
(17600, NULL, 'IPR016978', NULL, 'Putative competence-induced protein Ccs4', 'Competence-induced_Ccs4', 4, NULL),
(17601, NULL, 'IPR016584', NULL, 'Methyltransferase VrtF-like', 'MeTrfase_VrtF', 4, NULL),
(17602, NULL, 'IPR021220', NULL, 'Protein of unknown function DUF2686', 'DUF2686', 4, NULL),
(17603, NULL, 'IPR021218', NULL, 'Protein of unknown function DUF2784', 'DUF2784', 4, NULL),
(17604, NULL, 'IPR013883', NULL, 'Transcription factor Iwr1 domain', 'TF_Iwr1_dom', 3, NULL),
(17605, NULL, 'IPR021246', NULL, 'Protein of unknown function DUF2797', 'DUF2797', 4, NULL),
(17606, NULL, 'IPR016587', NULL, 'DNA damage checkpoint control protein Rad17', 'Rad17', 4, NULL),
(17607, NULL, 'IPR017677', NULL, 'Putative methanogenesis marker 16 metalloprotein', 'Methan_mark_16', 4, NULL),
(17608, NULL, 'IPR021311', NULL, 'Rev protein of equine infectious anaemia virus', 'EIAV_Rev', 4, NULL),
(17609, NULL, 'IPR024893', NULL, 'ATP phosphoribosyltransferase HisG, short form', 'ATP_PRibTrfase_HisG_short', 4, NULL),
(17610, NULL, 'IPR025994', NULL, 'BRCA1, serine-rich domain', 'BRCA1_serine_dom', 3, NULL),
(17611, NULL, 'IPR016945', NULL, 'Uncharacterised conserved protein UCP030092', 'UCP030092', 4, NULL),
(17612, NULL, 'IPR020028', NULL, 'L-seryl-tRNA(Sec)kinase, eukaryote', 'L-seryl-tRNA_Sec_kinase_euk', 4, NULL),
(17613, NULL, 'IPR021216', NULL, 'Protein of unknown function DUF2722', 'DUF2722', 4, NULL),
(17614, NULL, 'IPR021308', NULL, 'Group 4 capsule polysaccharide formation lipoprotein GfcB', 'GfcB', 4, NULL),
(17615, NULL, 'IPR020032', NULL, 'CRISPR-associated protein Csp1', 'CRISPR-assoc_Csp1', 4, NULL),
(17616, NULL, 'IPR017377', NULL, 'Herpesvirus US8A', 'Herpes_US8A', 4, NULL),
(17617, NULL, 'IPR025995', NULL, 'RNA binding activity-knot of a chromodomain', 'Tudor-knot', 3, NULL),
(17618, NULL, 'IPR021295', NULL, 'Protein of unknown function DUF2867', 'DUF2867', 4, NULL),
(17619, NULL, 'IPR023860', NULL, '[FeFe]-hydrogenase system regulator TM1266', 'FeFe-hyd_TM1266', 4, NULL),
(17620, NULL, 'IPR016971', NULL, 'Uncharacterised conserved protein UCP031277', 'UCP031277', 4, NULL),
(17621, NULL, 'IPR016988', NULL, 'Uncharacterised conserved protein UCP032086', 'UCP032086', 4, NULL),
(17622, NULL, 'IPR016574', NULL, 'Nicalin', 'Nicalin', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(17623, NULL, 'IPR020151', NULL, 'Protein of unknown function DUF5478', 'DUF5478', 4, NULL),
(17624, NULL, 'IPR017359', NULL, 'Uncharacterised conserved protein UCP038021, RWD', 'UCP038021_RWD', 4, NULL),
(17625, NULL, 'IPR013915', NULL, 'Pre-mRNA-splicing factor 19', 'Pre-mRNA_splic_Prp19', 3, NULL),
(17626, NULL, 'IPR034122', NULL, 'Retropepsin-like domain, bacterial', 'Retropepsin-like_bacterial', 3, NULL),
(17627, NULL, 'IPR021326', NULL, 'Protein of unknown function DUF2931', 'DUF2931', 4, NULL),
(17628, NULL, 'IPR016592', NULL, 'Nibrin', 'Nibrin_met', 4, NULL),
(17629, NULL, 'IPR017674', NULL, 'Putative methanogenesis marker protein 11', 'Methan_mark_11', 4, NULL),
(17630, NULL, 'IPR020063', NULL, 'Bordetella pertussis toxin B, subunit 2/3, C-terminal', 'ToxinB_su2/3_C_BORPE', 3, NULL),
(17631, NULL, 'IPR019109', NULL, 'Protein of unknown function DUF4870', 'DUF4870', 4, NULL),
(17632, NULL, 'IPR024717', NULL, 'Denitrification system component NapC/NirT/NrfH', 'NapC/NirT/NrfH', 4, NULL),
(17633, NULL, 'IPR017702', NULL, 'Putative carbamoyltransferase YgeW', 'Carbamoyltransferase_YgeW', 4, NULL),
(17634, NULL, 'IPR019114', NULL, 'Chaperone lipoprotein, PulS/OutS-like', 'Chap_lipoprot_PulS/OutS-like', 4, NULL),
(17635, NULL, 'IPR016949', NULL, 'Damage-control phosphatase At2g17340', 'At2g17340', 4, NULL),
(17636, NULL, 'IPR016984', NULL, 'Uncharacterised conserved protein UCP031853', 'UCP031853', 4, NULL),
(17637, NULL, 'IPR018729', NULL, 'Protein of unknown function DUF2269, transmembrane', 'DUF2269_transmembrane', 4, NULL),
(17638, NULL, 'IPR016956', NULL, 'Inner membrane protein YdjM', 'YdjM', 4, NULL),
(17639, NULL, 'IPR019098', NULL, 'Histone chaperone domain CHZ', 'Histone_chaperone_domain_CHZ', 3, NULL),
(17640, NULL, 'IPR021279', NULL, 'Protein of unknown function DUF2721', 'DUF2721', 4, NULL),
(17641, NULL, 'IPR013909', NULL, 'Nuclear-interacting partner of ALK/Rsm1-like, C-terminal', 'NIPA/Rsm1_C', 3, NULL),
(17642, NULL, 'IPR034629', NULL, 'Pentatricopeptide repeat-containing protein 2, mitochondrial', 'PTCD2', 4, NULL),
(17643, NULL, 'IPR021276', NULL, 'Protein of unknown function DUF2855', 'DUF2855', 4, NULL),
(17644, NULL, 'IPR013834', NULL, 'Bacteriophage, G3P, N2-domain superfamily', 'Phage_G3P_N2_sf', 5, NULL),
(17645, NULL, 'IPR016979', NULL, 'Protein of unknown function DUF2129', 'DUF2129', 4, NULL),
(17646, NULL, 'IPR016958', NULL, 'Uncharacterised conserved protein UCP030798', 'UCP030798', 4, NULL),
(17647, NULL, 'IPR019137', NULL, 'Nck-associated protein 1', 'Nck-associated_protein-1', 4, NULL),
(17648, NULL, 'IPR017371', NULL, 'Tumour necrosis factor receptor 11B', 'TNFR_11B', 4, NULL),
(17649, NULL, 'IPR017691', NULL, 'ATP synthase subunit beta, bacterial and archaeal', 'Alt_ATPase_F1_bsu', 4, NULL),
(17650, NULL, 'IPR015667', NULL, 'Telethonin', 'Telethonin', 4, NULL),
(17651, NULL, 'IPR021284', NULL, 'Protein of unknown function DUF2750', 'DUF2750', 4, NULL),
(17652, NULL, 'IPR021325', NULL, 'Cofactor assembly of complex C subunit B, CCB2/CCB4', 'CCB2/CCB4', 4, NULL),
(17653, NULL, 'IPR013908', NULL, 'Nibrin, C-terminal', 'Nibrin_C', 3, NULL),
(17654, NULL, 'IPR021235', NULL, 'Protein of unknown function DUF2637', 'DUF2637', 4, NULL),
(17655, NULL, 'IPR020022', NULL, 'N-acetyl sugar amidotransferase', 'N-acetyl_sugar_amidoTrfase', 4, NULL),
(17656, NULL, 'IPR017367', NULL, 'Peptidase M12A, nematode astacin 7/8,  Caenorhabditis', 'Caenorhab_nas-7/8', 4, NULL),
(17657, NULL, 'IPR013886', NULL, 'PI31 proteasome regulator, C-terminal', 'PI31_Prot_C', 3, NULL),
(17658, NULL, 'IPR021312', NULL, 'Protein of unknown function DUF2889', 'DUF2889', 4, NULL),
(17659, NULL, 'IPR016986', NULL, 'Uncharacterised conserved protein UCP031982, alpha/beta hydrolase, XabL', 'UCP031982_abhydr', 4, NULL),
(17660, NULL, 'IPR016553', NULL, 'Protein tyrosine phosphatase receptor type C-associated protein', 'PTPRCAP', 4, NULL),
(17661, NULL, 'IPR021213', NULL, 'Protein of unknown function DUF2567', 'DUF2567', 4, NULL),
(17662, NULL, 'IPR021228', NULL, 'BREX system ATP-binding protein BrxD', 'BrxD', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(17663, NULL, 'IPR023928', NULL, 'Conserved hypothetical protein CHP03979', 'CHP03979', 4, NULL),
(17664, NULL, 'IPR019117', NULL, 'CRISPR-associated protein, Cmr3', 'CRISPR-assoc_protein_Cmr3', 4, NULL),
(17665, NULL, 'IPR017682', NULL, 'Coenzyme F420 hydrogenase, subunit alpha', 'Coenz_F420_hydrogenase_asu', 4, NULL),
(17666, NULL, 'IPR017715', NULL, 'Putative aminophosphonate oxidoreductase', 'NH2-phosphonate_OxRdtase', 4, NULL),
(17667, NULL, 'IPR013833', NULL, 'Cytochrome c oxidase, subunit III, 4-helical bundle', 'Cyt_c_oxidase_su3_a-hlx', 5, NULL),
(17668, NULL, 'IPR020049', NULL, 'Protein of unknown function DUF2184', 'DUF2184', 4, NULL),
(17669, NULL, 'IPR021313', NULL, 'Protein of unknown function DUF2909', 'DUF2909', 4, NULL),
(17670, NULL, 'IPR018326', NULL, 'Rad4 beta-hairpin domain 1', 'Rad4_beta-hairpin_dom1', 3, NULL),
(17671, NULL, 'IPR013213', NULL, 'Mastoparan', 'Mastoparan', 4, NULL),
(17672, NULL, 'IPR020037', NULL, 'Protein of unknown function DUF4312', 'DUF4312', 4, NULL),
(17673, NULL, 'IPR021252', NULL, 'Protein of unknown function DUF2794', 'DUF2794', 4, NULL),
(17674, NULL, 'IPR021289', NULL, 'Recombination, repair and ssDNA binding protein UvsY', 'UvsY', 4, NULL),
(17675, NULL, 'IPR020044', NULL, 'PRD domain protein, EF0829/AHA3910', 'PRD_EF0829/AHA3910', 4, NULL),
(17676, NULL, 'IPR021254', NULL, 'Protein of unknown function DUF2806', 'DUF2806', 4, NULL),
(17677, NULL, 'IPR016948', NULL, 'Uncharacterised conserved protein UCP030175', 'UCP030175', 4, NULL),
(17678, NULL, 'IPR021248', NULL, 'Protein of unknown function DUF2787', 'DUF2787', 4, NULL),
(17679, NULL, 'IPR020186', NULL, 'Meiosis-expressed gene 1 protein', 'Meiosis-expressed_gene_1', 4, NULL),
(17680, NULL, 'IPR021223', NULL, 'Abortive phage resistance protein AbiGi', 'AbiGi', 4, NULL),
(17681, NULL, 'IPR017363', NULL, 'Cdc42 effector protein 2', 'Cdc42_effector_prot_2', 4, NULL),
(17682, NULL, 'IPR013910', NULL, 'Transcription factor PAP1', 'TF_PAP1', 3, NULL),
(17683, NULL, 'IPR015669', NULL, 'Endothelial protein C receptor', 'Endothetial_C_recpt', 4, NULL),
(17684, NULL, 'IPR015668', NULL, 'B Cell Lymphoma 9', 'Bcl-9/Bcl-9l', 4, NULL),
(17685, NULL, 'IPR017709', NULL, 'Alternate ATP synthase, F1 complex, subunit gamma', 'Alt_ATP_synth_F1_gsu', 4, NULL),
(17686, NULL, 'IPR016567', NULL, 'Cysteine-rich protein, furovirus', 'Cys-rich_furovirus', 4, NULL),
(17687, NULL, 'IPR020204', NULL, 'Uncharacterised protein family, YxaJ', 'Uncharacterised_YxaJ', 4, NULL),
(17688, NULL, 'IPR017370', NULL, 'Hatching enzyme, Uvs2-like', 'Hatching_enzyme_Uvs2-like', 4, NULL),
(17689, NULL, 'IPR021236', NULL, 'Uncharacterised protein family YfdX', 'Uncharacterised_YfdX', 4, NULL),
(17690, NULL, 'IPR019131', NULL, 'Cortactin-binding protein-2, N-terminal', 'Cortactin-binding_p2_N', 3, NULL),
(17691, NULL, 'IPR013824', NULL, 'DNA topoisomerase, type IA, central region, subdomain 1', 'Topo_IA_cen_sub1', 5, NULL),
(17692, NULL, 'IPR016586', NULL, 'Mitochondrial transcription factor Mtf1', 'Mtf1', 4, NULL),
(17693, NULL, 'IPR015648', NULL, 'Transcription factor DP', 'Transcrpt_fac_DP', 4, NULL),
(17694, NULL, 'IPR021244', NULL, 'Protein of unknown function DUF2802', 'DUF2802', 4, NULL),
(17695, NULL, 'IPR021288', NULL, 'Sporulated oocyst TA4 antigen', 'Surface_antigen', 4, NULL),
(17696, NULL, 'IPR021300', NULL, 'Integrating conjugative element protein, PFL4695', 'Integr_conj_element_PFL4695', 4, NULL),
(17697, NULL, 'IPR017720', NULL, 'Coenzyme F390 synthetase', 'Coenzyme_F390_Synthase', 4, NULL),
(17698, NULL, 'IPR021314', NULL, 'Protein of unknown function DUF2911', 'DUF2911', 4, NULL),
(17699, NULL, 'IPR017360', NULL, 'Anthrax toxin receptor', 'Anthrax_toxin_rcpt', 4, NULL),
(17700, NULL, 'IPR017369', NULL, 'SPAN protein/blastula protease 10', 'SPAN/blastula_protease_10', 4, NULL),
(17701, NULL, 'IPR021287', NULL, 'Trans-sialidase, conserved site', 'Trans-sialidase_CS', 2, NULL),
(17702, NULL, 'IPR013878', NULL, 'Mo25-like', 'Mo25', 4, NULL),
(17703, NULL, 'IPR016939', NULL, 'Mitochondrial ribosomal protein S25', 'Mt__Rbsml_prot_S25', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(17704, NULL, 'IPR013799', NULL, 'STAT transcription factor, protein interaction', 'STAT_TF_prot_interaction', 3, NULL),
(17705, NULL, 'IPR021293', NULL, 'Protein of unknown function DUF2865', 'DUF2865', 4, NULL),
(17706, NULL, 'IPR013879', NULL, 'Protein of unknown function DUF1761', 'DUF1761', 4, NULL),
(17707, NULL, 'IPR016957', NULL, 'Uncharacterised conserved protein UCP030791', 'UCP030791', 4, NULL),
(17708, NULL, 'IPR019099', NULL, 'Uncharacterised protein family PGPGW, transmembrane', 'Uncharacterised_PGPGW_TM', 4, NULL),
(17709, NULL, 'IPR021297', NULL, 'YlqD protein', 'YlqD', 4, NULL),
(17710, NULL, 'IPR020034', NULL, 'Conserved hypothetical protein CHP03577, EF0830/AHA3911', 'CHP03577_EF0830/AHA3911', 4, NULL),
(17711, NULL, 'IPR016559', NULL, 'Uncharacterised conserved protein UCP009597', 'UCP009597', 4, NULL),
(17712, NULL, 'IPR017365', NULL, 'Protein lin-7', 'LIN7', 4, NULL),
(17713, NULL, 'IPR021324', NULL, 'Protein of unknown function DUF2929', 'DUF2929', 4, NULL),
(17714, NULL, 'IPR019106', NULL, 'Type-F conjugative transfer system pilin assembly protein TrbC', 'T4SS_TrbC', 4, NULL),
(17715, NULL, 'IPR021234', NULL, 'Protein of unknown function DUF2827', 'DUF2827', 4, NULL),
(17716, NULL, 'IPR016564', NULL, 'Uncharacterised conserved protein UCP010056', 'UCP010056', 4, NULL),
(17717, NULL, 'IPR019102', NULL, 'HMG box transcription factor BBX, domain of unknown function DUF2028', 'TF_HMG_box_BBX_DUF2028', 3, NULL),
(17718, NULL, 'IPR016569', NULL, 'Methyltransferase, trithorax', 'MeTrfase_trithorax', 4, NULL),
(17719, NULL, 'IPR035414', NULL, 'Peptidase M1, alanyl aminopeptidase, Ig-like fold', 'Peptidase_M1_pepN_Ig-like', 3, NULL),
(17720, NULL, 'IPR016577', NULL, 'Adenylate cyclase, type 10', 'Adenylate_cyclase_typ10', 4, NULL),
(17721, NULL, 'IPR035501', NULL, 'NP60, PWWP domain', 'NP60_PWWP', 3, NULL),
(17722, NULL, 'IPR016571', NULL, 'Spore coat assembly protein CotJB', 'Spore_coat_assembly_CotJB', 4, NULL),
(17723, NULL, 'IPR017713', NULL, 'AMP phosphorylase', 'AMP_phosphorylase', 4, NULL),
(17724, NULL, 'IPR018324', NULL, 'Checkpoint protein Rad17/Rad24, fungi/metazoa', 'Rad17/Rad24_fun/met', 4, NULL),
(17725, NULL, 'IPR013211', NULL, 'LVIVD', 'LVIVD', 7, NULL),
(17726, NULL, 'IPR018325', NULL, 'Rad4/PNGase transglutaminase-like fold', 'Rad4/PNGase_transGLS-fold', 3, NULL),
(17727, NULL, 'IPR019140', NULL, 'Mini-chromosome maintenance complex-binding protein', 'MCM_complex-bd', 4, NULL),
(17728, NULL, 'IPR034764', NULL, 'Nucleoside transporter ENT1/ENT2', 'ENT1/ENT2', 4, NULL),
(17729, NULL, 'IPR021242', NULL, 'Protein of unknown function DUF2799', 'DUF2799', 4, NULL),
(17730, NULL, 'IPR021273', NULL, 'Protein of unknown function DUF2852', 'DUF2852', 4, NULL),
(17731, NULL, 'IPR021309', NULL, 'Inner membrane protein YgaP-like, transmembrane domain', 'YgaP-like_TM', 3, NULL),
(17732, NULL, 'IPR016965', NULL, 'Phosphatase PHOSPHO-type', 'Pase_PHOSPHO-typ', 4, NULL),
(17733, NULL, 'IPR017704', NULL, 'Putative selenium-binding protein YdfZ', 'Se-bd_putative_YdfZ', 4, NULL),
(17734, NULL, 'IPR017710', NULL, 'Alternate ATP synthase, F1 complex, subunit alpha', 'Alt_ATP_synth_F1_asu', 4, NULL),
(17735, NULL, 'IPR013830', NULL, 'SGNH hydrolase-type esterase domain', 'SGNH_hydro', 3, NULL),
(17736, NULL, 'IPR020195', NULL, 'SWR1 chromatin-remodelling complex, subunit Swc7', 'SWR1_Swc7', 4, NULL),
(17737, NULL, 'IPR017695', NULL, 'Selenium-dependent molybdenum hydroxylase system protein, YqeB family', 'Se-dep_Mo_hydrolase_YqeB', 3, NULL),
(17738, NULL, 'IPR023798', NULL, 'Ribosomal protein S7 domain', 'Ribosomal_S7_dom', 3, NULL),
(17739, NULL, 'IPR021230', NULL, 'Protein of unknown function DUF2810', 'DUF2810', 4, NULL),
(17740, NULL, 'IPR016983', NULL, 'Uncharacterised conserved protein UCP031804', 'UCP031804', 4, NULL),
(17741, NULL, 'IPR016561', NULL, 'Dynein light chain roadblock-type 1/2', 'DYNLRB1/2', 4, NULL),
(17742, NULL, 'IPR020189', NULL, 'Translation elongation factor, IF5A C-terminal', 'Transl_elong_IF5A_C', 3, NULL),
(17743, NULL, 'IPR017698', NULL, 'Probable selenate reductase, FAD-binding subunit', 'Se_Rdtase_FAD-bd_su', 4, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(17744, NULL, 'IPR023317', NULL, 'Peptidase S1A, plasmin', 'Pept_S1A_plasmin', 4, NULL),
(17745, NULL, 'IPR019094', NULL, 'Bacteriophage SP-beta, YorD', 'Phage_SP-beta_YorD', 3, NULL),
(17746, NULL, 'IPR016573', NULL, 'Meiosis-specific protein Hop1', 'Hop1', 4, NULL),
(17747, NULL, 'IPR015654', NULL, 'Mandelate racemase', 'Mandelate_racemase', 4, NULL),
(17748, NULL, 'IPR021257', NULL, 'Protein of unknown function DUF2809', 'DUF2809', 4, NULL),
(17749, NULL, 'IPR021328', NULL, 'Protein of unknown function DUF2935', 'DUF2935', 4, NULL),
(17750, NULL, 'IPR015649', NULL, 'Schwannomin interacting protein 1, C-terminal', 'SCHIP_1_C', 3, NULL),
(17751, NULL, 'IPR019095', NULL, 'Mediator complex, subunit Med18', 'Mediator_Med18', 4, NULL),
(17752, NULL, 'IPR023829', NULL, 'Poly-beta-1,6-N-acetyl-D-glucosamine biosynthesis protein PgaD', 'PGA_PgaD', 4, NULL),
(17753, NULL, 'IPR013911', NULL, 'Mitochondrial inner membrane i-AAA protease complex subunit Mgr1', 'i-AAA_Mgr1', 4, NULL),
(17754, NULL, 'IPR017687', NULL, 'Outer membrane protein assembly factor BamB', 'BamB', 4, NULL),
(17755, NULL, 'IPR023888', NULL, 'Antimicrobial peptide, SdpC family', 'Antimicrobial_SdpC', 4, NULL),
(17756, NULL, 'IPR021212', NULL, 'Domain of unknown function DUF2760', 'DUF2760', 3, NULL),
(17757, NULL, 'IPR021317', NULL, 'Protein of unknown function DUF2917', 'DUF2917', 4, NULL),
(17758, NULL, 'IPR019127', NULL, 'Exosortase', 'Exosortase', 4, NULL),
(17759, NULL, 'IPR023858', NULL, '5,10-methenyltetrahydromethanopterin hydrogenase cofactor biosynthesis protein HmdB', 'RSAM_HmdB', 4, NULL),
(17760, NULL, 'IPR021238', NULL, 'Protein of unknown function DUF2620', 'DUF2620', 4, NULL),
(17761, NULL, 'IPR016594', NULL, 'Bacteriophage T4, inh', 'Phage_T4_inh', 4, NULL),
(17762, NULL, 'IPR013885', NULL, 'Protein of unknown function DUF1764, eukaryotic', 'DUF1764_euk', 4, NULL),
(17763, NULL, 'IPR016547', NULL, 'Uncharacterised conserved protein UCP009158', 'UCP009158', 4, NULL),
(17764, NULL, 'IPR035503', NULL, 'IOC4-like, PWWP domain', 'IOC4-like_PWWP', 3, NULL),
(17765, NULL, 'IPR021251', NULL, 'Protein of unknown function DUF2793', 'DUF2793', 4, NULL),
(17766, NULL, 'IPR021299', NULL, 'Protein of unknown function DUF2871', 'DUF2871', 4, NULL),
(17767, NULL, 'IPR020040', NULL, 'Ribosomal protein L6, alpha-beta domain', 'Ribosomal_L6_a/b-dom', 3, NULL),
(17768, NULL, 'IPR016982', NULL, 'Probable magnetosome protein Mms48', 'Mms48', 4, NULL),
(17769, NULL, 'IPR019139', NULL, 'Leucine-rich repeat flightless-interacting protein 1/2', 'LRRFIP1/2', 4, NULL),
(17770, NULL, 'IPR034543', NULL, 'Long chronological lifespan protein 2', 'LCL2', 4, NULL),
(17771, NULL, 'IPR016972', NULL, 'Uncharacterised conserved protein UCP031279', 'UCP031279', 4, NULL),
(17772, NULL, 'IPR016585', NULL, 'Glycine/sarcosine/betaine reductase, component B, fused alpha/beta', 'Gly/sarc/bet_Rdtase_B_asu/bsu', 4, NULL),
(17773, NULL, 'IPR021304', NULL, 'Adenovirus L4-33K/L4-22K', 'Adeno_L4-33K/L4-22K', 4, NULL),
(17774, NULL, 'IPR021269', NULL, 'Protein of unknown function DUF2848', 'DUF2848', 4, NULL),
(17775, NULL, 'IPR021224', NULL, 'Protein of unknown function DUF2690', 'DUF2690', 4, NULL),
(17776, NULL, 'IPR017689', NULL, 'Outer membrane protein assembly factor BamD', 'BamD', 4, NULL),
(17777, NULL, 'IPR013889', NULL, 'Karyogamy protein, KAR9', 'Karyogamy_KAR9', 4, NULL),
(17778, NULL, 'IPR034549', NULL, 'Sperm acrosome membrane-associated protein 6', 'SPACA6', 4, NULL),
(17779, NULL, 'IPR013212', NULL, 'Mad3/Bub1 homology region 1', 'Mad3/Bub1_I', 3, NULL),
(17780, NULL, 'IPR016596', NULL, 'Protein of unknown function UCP012335', 'UCP012335', 4, NULL),
(17781, NULL, 'IPR021253', NULL, 'Protein of unknown function DUF2796', 'DUF2796', 4, NULL),
(17782, NULL, 'IPR017681', NULL, 'Coenzyme F420 hydrogenase, subunit gamma', 'Coenz_F420_hydrogenase_gsu', 4, NULL),
(17783, NULL, 'IPR017684', NULL, 'Phosphonopyruvate decarboxylase', 'Phosphono-pyrv_decarboxylase', 4, NULL),
(17784, NULL, 'IPR021268', NULL, 'Protein of unknown function DUF2845', 'DUF2845', 4, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(17785, NULL, 'IPR023883', NULL, 'Conserved hypothetical protein CHP03980,  redox-disulphide', 'CHP03980_redox-disulphide', 4, NULL),
(17786, NULL, 'IPR021214', NULL, 'Protein of unknown function DUF2568', 'DUF2568', 4, NULL),
(17787, NULL, 'IPR017368', NULL, 'Peptidase M12A, nematode astacin 9/10/11', 'Peptidase_M12A_astacin-9/10/11', 4, NULL),
(17788, NULL, 'IPR017690', NULL, 'Outer membrane insertion C-terminal signal, omp85 target', 'OM_insertion_C_omp85_target', 2, NULL),
(17789, NULL, 'IPR021232', NULL, 'Protein of unknown function DUF2735', 'DUF2735', 4, NULL),
(17790, NULL, 'IPR022961', NULL, 'Glycine-tRNA ligase, bacterial', 'Gly_tRNA_ligase_bac', 4, NULL),
(17791, NULL, 'IPR016981', NULL, 'Transcription regulator, AraC, predicted', 'Tscrpt_reg_031684_prd', 4, NULL),
(17792, NULL, 'IPR023832', NULL, 'Histidine triad protein', 'His_triad_protein', 4, NULL),
(17793, NULL, 'IPR021315', NULL, 'Glycolipid exporter Gap/Sap', 'Gap/Sap', 4, NULL),
(17794, NULL, 'IPR019134', NULL, 'Cactin, C-terminal', 'Cactin_C', 3, NULL),
(17795, NULL, 'IPR023885', NULL, '4Fe4S-binding SPASM domain', '4Fe4S-binding_SPASM_dom', 3, NULL),
(17796, NULL, 'IPR016980', NULL, 'S-adenosyl-L-methionine dependent methyltransferase, Alr7345, predicted', 'S-AdoMet-dep_MeTrfase_Alr7345', 4, NULL),
(17797, NULL, 'IPR017719', NULL, 'Indolepyruvate ferredoxin oxidoreductase, beta subunit', 'Indolepyruvate_Fd_OxRdtase_bsu', 4, NULL),
(17798, NULL, 'IPR016952', NULL, 'Small heat shock protein, predicted, plant', 'Small_heat_shock_prot_prd_pln', 4, NULL),
(17799, NULL, 'IPR024232', NULL, 'Stage III sporulation protein AH-like', 'SpoIIIAH', 4, NULL),
(17800, NULL, 'IPR023803', NULL, 'Ribosomal protein S16 domain superfamily', 'Ribosomal_S16_dom_sf', 5, NULL),
(17801, NULL, 'IPR016562', NULL, 'Proteasome assembly chaperone 2, eukaryotic', 'Proteasome_assmbl_chp_2_euk', 4, NULL),
(17802, NULL, 'IPR016558', NULL, 'DNA primase, large subunit, eukaryotic', 'DNA_primase_lsu_euk', 4, NULL),
(17803, NULL, 'IPR017366', NULL, 'Lysine-specific histone demethylase', 'Hist_Lys-spec_deMease', 4, NULL),
(17804, NULL, 'IPR020038', NULL, 'Circular bacteriocin', 'Circ_bacteriocin', 4, NULL),
(17805, NULL, 'IPR017708', NULL, 'Alternate ATP synthase, F0 complex, subunit C, bacterial/archaeal', 'Alt_ATP_synth_F0_Csu', 4, NULL),
(17806, NULL, 'IPR016942', NULL, 'Uncharacterised conserved protein UCP030042', 'UCP030042', 4, NULL),
(17807, NULL, 'IPR016570', NULL, 'Uncharacterised conserved protein UCP010361, membrane', 'UCP010361', 4, NULL),
(17808, NULL, 'IPR021305', NULL, 'Protein of unknown function DUF2880', 'DUF2880', 4, NULL),
(17809, NULL, 'IPR021329', NULL, 'Protein of unknown function DUF2938', 'DUF2938', 4, NULL),
(17810, NULL, 'IPR013892', NULL, 'Cytochrome c oxidase biogenesis protein Cmc1-like', 'Cyt_c_biogenesis_Cmc1-like', 4, NULL),
(17811, NULL, 'IPR021296', NULL, 'Protein of unknown function DUF2868', 'DUF2868', 4, NULL),
(17812, NULL, 'IPR017685', NULL, 'HTH-type transcriptional regulator ArgP', 'ArgP', 4, NULL),
(17813, NULL, 'IPR016974', NULL, 'Uncharacterised phage-associated protein', 'Uncharacterised_phage-assoc', 4, NULL),
(17814, NULL, 'IPR021262', NULL, 'Protein of unknown function DUF2839', 'DUF2839', 4, NULL),
(17815, NULL, 'IPR021302', NULL, 'Protein of unknown function DUF2780, VcgC/VcgE', 'DUF2780_VcgC/VcgE', 4, NULL),
(17816, NULL, 'IPR016961', NULL, 'Diacylglycerol kinase, plant', 'Diacylglycerol_kinase_pln', 4, NULL),
(17817, NULL, 'IPR020190', NULL, 'Procorazonin', 'Procorazonin', 4, NULL),
(17818, NULL, 'IPR016563', NULL, 'Nuclear protein localization protein 4', 'Npl4', 4, NULL),
(17819, NULL, 'IPR021265', NULL, 'Protein of unknown function DUF2842', 'DUF2842', 4, NULL),
(17820, NULL, 'IPR013897', NULL, 'Protein of unknown function DUF1769', 'DUF1769', 4, NULL),
(17821, NULL, 'IPR017714', NULL, 'Methylthioribulose-1-phosphate dehydratase', 'MethylthioRu-1-P_deHdtase_MtnB', 4, NULL),
(17822, NULL, 'IPR021221', NULL, 'Protein fil', 'Fil', 4, NULL),
(17823, NULL, 'IPR021270', NULL, 'Protein of unknown function DUF2849', 'DUF2849', 4, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(17824, NULL, 'IPR021310', NULL, 'Plant viral coat protein nucleocapsid', 'Nucleocap_ssRNA', 4, NULL),
(17825, NULL, 'IPR019141', NULL, 'Protein of unknown function DUF2045', 'DUF2045', 4, NULL),
(17826, NULL, 'IPR023877', NULL, 'Pyrrolysyl-tRNA ligase, C-terminal', 'Pyrrolysyl-tRNA_ligase_C', 3, NULL),
(17827, NULL, 'IPR016977', NULL, 'Competence operon G, ComGF', 'Competence_ComGF', 4, NULL),
(17828, NULL, 'IPR016951', NULL, 'Haem oxygenase (decyclizing), plant', 'Haem_Oase_decyc_pln', 4, NULL),
(17829, NULL, 'IPR017699', NULL, 'Molybdenum-binding protein YgfN/XdhD', 'Mo-bd_YgfN/XdhD', 4, NULL),
(17830, NULL, 'IPR016969', NULL, 'Uncharacterised conserved protein UCP031088, alpha/beta hydrolase, At1g15070', 'UCP031088_abhydr', 4, NULL),
(17831, NULL, 'IPR021285', NULL, 'Transcription regulator, HycA', 'Tscrpt_reg_HycA', 4, NULL),
(17832, NULL, 'IPR019108', NULL, 'Cytochrome c oxidase caa3-type, assembly factor CtaG-related', 'Caa3_assmbl_CtaG-rel', 4, NULL),
(17833, NULL, 'IPR023878', NULL, 'Pyrrolysyl-tRNA ligase, N-terminal', 'Pyrrolysyl-tRNA_ligase_N', 3, NULL),
(17834, NULL, 'IPR023801', NULL, 'Histone deacetylase domain', 'His_deacetylse_dom', 3, NULL),
(17835, NULL, 'IPR013890', NULL, 'Transcriptional repressor Tup1, N-terminal', 'Tscrpt_rep_Tup1_N', 3, NULL),
(17836, NULL, 'IPR021239', NULL, 'Protein of unknown function DUF2625', 'DUF2625', 4, NULL),
(17837, NULL, 'IPR017703', NULL, 'YgfZ/GcvT conserved site', 'YgfZ/GcvT_CS', 2, NULL),
(17838, NULL, 'IPR016593', NULL, 'Adenovirus 41, E3-31.6kDa', 'Adenovirus-41_E3-31.6kDa', 4, NULL),
(17839, NULL, 'IPR015633', NULL, 'E2F Family', 'E2F', 4, NULL),
(17840, NULL, 'IPR017692', NULL, 'Alternate ATP synthase, F0complex, subunit A', 'Alt_ATP_synth_F0_Asu', 4, NULL),
(17841, NULL, 'IPR021258', NULL, 'Epiplasmin protein', 'Epiplasmin', 4, NULL),
(17842, NULL, 'IPR021322', NULL, 'Protein of unknown function DUF2924', 'DUF2924', 4, NULL),
(17843, NULL, 'IPR016985', NULL, 'Uncharacterised conserved protein UCP031890, Tim44-related', 'UCP031890_Tim44-rel', 4, NULL),
(17844, NULL, 'IPR013901', NULL, 'Anthrone oxygenase', 'Anthrone_oxy', 4, NULL),
(17845, NULL, 'IPR013825', NULL, 'DNA topoisomerase, type IA, central region, subdomain 2', 'Topo_IA_cen_sub2', 5, NULL),
(17846, NULL, 'IPR017362', NULL, 'DNA-binding, RFXANK', 'DNA-bd_RFXANK', 4, NULL),
(17847, NULL, 'IPR017374', NULL, 'Fringe', 'Fringe', 4, NULL),
(17848, NULL, 'IPR017705', NULL, 'Ribonuclease Y', 'Ribonuclease_Y', 4, NULL),
(17849, NULL, 'IPR024890', NULL, '(R)-citramalate synthase CimA', 'Citramalate_synthase_CimA', 4, NULL),
(17850, NULL, 'IPR013877', NULL, 'YAP-binding/ALF4/Glomulin', 'YAP-bd/ALF4/Glomulin', 4, NULL),
(17851, NULL, 'IPR013894', NULL, 'RecQ mediated genome instability protein 1, N-terminal', 'RMI1_N', 3, NULL),
(17852, NULL, 'IPR016575', NULL, 'Bardet-Biedl syndrome 7 protein', 'Bardet-Biedl_syndrome_7_prot', 4, NULL),
(17853, NULL, 'IPR019092', NULL, 'CRISPR-assoc protein, NE0113/Csx13', 'CRISPR-assoc_prot_NE0113/Csx12', 4, NULL),
(17854, NULL, 'IPR016598', NULL, 'Uncharacterised conserved protein UCP012467', 'UCP012467', 4, NULL),
(17855, NULL, 'IPR016950', NULL, 'Mannosyltransferase, MA4085, predicted', 'Manno-Trfase_MA4085_prd', 4, NULL),
(17856, NULL, 'IPR013893', NULL, 'Ribonuclease P protein subunit Rpp40', 'RNase_P_Rpp40', 4, NULL),
(17857, NULL, 'IPR016572', NULL, 'Uncharacterised conserved protein UCP010611', 'UCP010611', 4, NULL),
(17858, NULL, 'IPR023887', NULL, 'Quinohemoprotein amine dehydrogenase, alpha subunit', 'QH-AmDH_asu', 4, NULL),
(17859, NULL, 'IPR013836', NULL, 'CD34/Podocalyxin', 'CD34/Podocalyxin', 4, NULL),
(17860, NULL, 'IPR017693', NULL, 'Phosphonate metabolism protein PhnP', 'Phosphonate_metab_PhnP', 4, NULL),
(17861, NULL, 'IPR019096', NULL, 'YopX protein', 'YopX_protein', 3, NULL),
(17862, NULL, 'IPR017678', NULL, 'CoB--CoM heterodisulphide reductase, subunit B', 'CoB/CoM_hetero-S_Rdtase_bsu', 4, NULL),
(17863, NULL, 'IPR021226', NULL, 'Protein of unknown function DUF2744', 'DUF2744', 4, NULL),
(17864, NULL, 'IPR017718', NULL, '2-hydroxy-3-keto-5-methylthiopentenyl-1-phosphate phosphatase', 'HAD-SF_hydro_IB_MtnX', 4, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(17865, NULL, 'IPR020024', NULL, 'L-seryl-tRNA(Sec) kinase, archaea', 'L-seryl-tRNA_Sec_kinase_arc', 4, NULL),
(17866, NULL, 'IPR021264', NULL, 'Protein of unknown function DUF2841', 'DUF2841', 4, NULL),
(17867, NULL, 'IPR016557', NULL, 'Cyclic 2, 3-diphospoglycerate synthetase', 'Cyc_diphosphoglycerate_synth', 4, NULL),
(17868, NULL, 'IPR013906', NULL, 'Eukaryotic translation initiation factor 3 subunit J', 'eIF3j', 4, NULL),
(17869, NULL, 'IPR019128', NULL, 'Sister chromatid cohesion protein Dcc1', 'Dcc1', 4, NULL),
(17870, NULL, 'IPR016935', NULL, 'Opine metallophore dehydrogenase', 'Opine_metallophore_DH', 4, NULL),
(17871, NULL, 'IPR013900', NULL, 'Ribonucleotide reductase inhibitor', 'RNR_inhibitor', 4, NULL),
(17872, NULL, 'IPR021290', NULL, 'Protein of unknown function DUF2861', 'DUF2861', 4, NULL),
(17873, NULL, 'IPR021332', NULL, 'Protein of unknown function DUF2944', 'DUF2944', 4, NULL),
(17874, NULL, 'IPR016964', NULL, 'Sigma intracellular receptor 2', 'Sigma2_recept', 4, NULL),
(17875, NULL, 'IPR018727', NULL, 'Protein of unknown function DUF2267', 'DUF2267', 4, NULL),
(17876, NULL, 'IPR016963', NULL, 'Glycoporin RafY', 'Glycoporin_RafY', 4, NULL),
(17877, NULL, 'IPR032476', NULL, 'Carnitine O-palmitoyltransferase, N-terminal', 'CPT_N', 3, NULL),
(17878, NULL, 'IPR021219', NULL, 'Protein of unknown function DUF2703', 'DUF2703', 4, NULL),
(17879, NULL, 'IPR021259', NULL, 'Protein of unknown function DUF2817', 'DUF2817', 4, NULL),
(17880, NULL, 'IPR016548', NULL, 'Uncharacterised conserved protein UCP009180', 'UCP009180', 4, NULL),
(17881, NULL, 'IPR035504', NULL, 'MUM1-like, PWWP domain', 'MUM1-like_PWWP', 3, NULL),
(17882, NULL, 'IPR016938', NULL, 'Uncharacterised protein family UPF0317', 'UPF0317', 4, NULL),
(17883, NULL, 'IPR016578', NULL, 'SODIUM POTASSIUM ROOT DEFECTIVE 2/3', 'NAKR2/3', 4, NULL),
(17884, NULL, 'IPR034626', NULL, 'Outer envelope pore protein 24', 'OEP24', 4, NULL),
(17885, NULL, 'IPR021277', NULL, 'Protein of unknown function DUF2610', 'DUF2610', 4, NULL),
(17886, NULL, 'IPR017700', NULL, 'Putative aminohydrolase SsnA', 'Aminohydrolase_SsnA', 4, NULL),
(17887, NULL, 'IPR021233', NULL, 'Protein of unknown function DUF2783', 'DUF2783', 4, NULL),
(17888, NULL, 'IPR021303', NULL, 'Uncharacterised protein family, inner membrane, YbhQ', 'Uncharacterised_YbhQ', 4, NULL),
(17889, NULL, 'IPR013842', NULL, 'GTP-binding protein LepA, C-terminal', 'LepA_CTD', 3, NULL),
(17890, NULL, 'IPR016580', NULL, 'Cell cycle checkpoint, Hus1', 'Cell_cycle_HUS1', 4, NULL),
(17891, NULL, 'IPR016976', NULL, 'Uncharacterised conserved protein UCP031601', 'UCP031601', 4, NULL),
(17892, NULL, 'IPR016947', NULL, 'Uncharacterised phage-associated protein UCP030140', 'UCP030140', 4, NULL),
(17893, NULL, 'IPR034546', NULL, 'Protein PAIR1', 'PAIR1', 4, NULL),
(17894, NULL, 'IPR024740', NULL, 'Hen1, N-terminal', 'Hen1_N', 3, NULL),
(17895, NULL, 'IPR020185', NULL, 'Spore morphogenesis/germination protein YwcE', 'Spore_morphogenesis_YwcE', 4, NULL),
(17896, NULL, 'IPR021319', NULL, 'Protein of unknown function DUF2921', 'DUF2921', 4, NULL),
(17897, NULL, 'IPR015659', NULL, 'Proline oxidase family', 'Proline_oxidase', 4, NULL),
(17898, NULL, 'IPR021281', NULL, 'Small nuclear RNA activating complex subunit 2', 'SNAPC2', 4, NULL),
(17899, NULL, 'IPR013851', NULL, 'Transcription factor Otx, C-terminal', 'Otx_TF_C', 3, NULL),
(17900, NULL, 'IPR016590', NULL, 'Rhamnogalacturonase B', 'Rhamnogalacturonase_B', 4, NULL),
(17901, NULL, 'IPR035511', NULL, 'SH3YL1, SH3 domain', 'SH3YL1_SH3', 3, NULL),
(17902, NULL, 'IPR021316', NULL, 'Protein of unknown function DUF2913', 'DUF2913', 4, NULL),
(17903, NULL, 'IPR016970', NULL, 'Uncharacterised conserved protein UCP031143', 'UCP031143', 4, NULL),
(17904, NULL, 'IPR017697', NULL, 'Selenium-dependent xanthine dehydrogenase', 'Xdh', 4, NULL),
(17905, NULL, 'IPR021301', NULL, 'Domain of unknown functionDUF2779', 'DUF2779', 3, NULL),
(17906, NULL, 'IPR016946', NULL, 'Uncharacterised conserved protein UCP030125', 'UCP030125', 4, NULL),
(17907, NULL, 'IPR013214', NULL, 'Mastoparan peptide', 'Mastoparan_peptide', 4, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(17908, NULL, 'IPR017376', NULL, 'Herpesvirus UL49A', 'Herpes_UL49A', 4, NULL),
(17909, NULL, 'IPR019130', NULL, 'Macoilin', 'Macoilin', 4, NULL),
(17910, NULL, 'IPR020017', NULL, 'XapX domain', 'XapX_domain', 3, NULL),
(17911, NULL, 'IPR024892', NULL, 'Putative phenylalanine aminotransferase', 'Pat', 4, NULL),
(17912, NULL, 'IPR013882', NULL, 'DNA endonuclease activator Ctp1, C-terminal', 'Ctp1_C', 3, NULL),
(17913, NULL, 'IPR017707', NULL, 'Alternate ATP synthase, F0 complex, subunit b', 'Alt_ATP_synth_F0_bsu', 4, NULL),
(17914, NULL, 'IPR017694', NULL, 'Phosphonate metabolism protein, transferase hexapeptide repeat family', 'Phosphonate_tfrase_rpt', 4, NULL),
(17915, NULL, 'IPR017711', NULL, 'Cis-2,3-dihydrobiphenyl-2,3-diol dehydrogenase', 'BphB_TodD', 4, NULL),
(17916, NULL, 'IPR021307', NULL, 'Protein of unknown function DUF2884', 'DUF2884', 4, NULL),
(17917, NULL, 'IPR021237', NULL, 'Leader peptide SpeFL', 'SpeFL', 4, NULL),
(17918, NULL, 'IPR019133', NULL, 'Mitochondrial inner membrane protein Mitofilin', 'Mt-IM_prot_Mitofilin', 4, NULL),
(17919, NULL, 'IPR021267', NULL, 'Protein of unknown function DUF2844', 'DUF2844', 4, NULL),
(17920, NULL, 'IPR017712', NULL, 'Ribulose bisphosphate carboxylase, type III', 'RuBisCO_III', 4, NULL),
(17921, NULL, 'IPR015660', NULL, 'Achaete-scute transcription factor-related', 'MASH1/Ascl1a-like', 4, NULL),
(17922, NULL, 'IPR020031', NULL, 'CRISPR-associated protein Cas5p', 'CRISPR-assoc_Cas5p', 4, NULL),
(17923, NULL, 'IPR015632', NULL, 'T-cell surface antigen CD2', 'CD2', 4, NULL),
(17924, NULL, 'IPR014710', NULL, 'RmlC-like jelly roll fold', 'RmlC-like_jellyroll', 5, NULL),
(17925, NULL, 'IPR022960', NULL, 'Glycine-tRNA ligase, archaeal', 'Gly_tRNA_ligase_arc', 4, NULL),
(17926, NULL, 'IPR020016', NULL, 'Decahaem-associated outer membrane protein, MtrB/PioB', 'Decahaem-assoc_OM_MtrB/PioB', 4, NULL),
(17927, NULL, 'IPR016554', NULL, 'Runt-related transcription factor RUNX', 'TF_Runt-rel_RUNX', 4, NULL),
(17928, NULL, 'IPR016936', NULL, 'Uncharacterised conserved protein UCP029693', 'UCP029693', 4, NULL),
(17929, NULL, 'IPR013902', NULL, 'Domain of unknown function DUF1773', 'DUF1773', 3, NULL),
(17930, NULL, 'IPR021243', NULL, 'Protein of unknown function DUF2804', 'DUF2804', 4, NULL),
(17931, NULL, 'IPR021250', NULL, 'Protein of unknown function DUF2789', 'DUF2789', 4, NULL),
(17932, NULL, 'IPR021274', NULL, 'Protein of unknown function DUF2853', 'DUF2853', 4, NULL),
(17933, NULL, 'IPR021318', NULL, 'Protein of unknown function DUF2919', 'DUF2919', 4, NULL),
(17934, NULL, 'IPR024891', NULL, 'Antiholin-like protein LrgB', 'Antiholin-like_LrgB', 4, NULL),
(17935, NULL, 'IPR016944', NULL, 'Uncharacterised conserved protein UCP030066', 'UCP030066', 4, NULL),
(17936, NULL, 'IPR032465', NULL, '2-amino-3-carboxymuconate-6-semialdehyde decarboxylase', 'ACMSD', 4, NULL),
(17937, NULL, 'IPR015662', NULL, 'Promotilin', 'Promotilin', 4, NULL),
(17938, NULL, 'IPR018162', NULL, 'Alanine-tRNA ligase, class IIc, anti-codon-binding domain superfamily', 'Ala-tRNA-ligase_IIc_anticod-bd', 5, NULL),
(17939, NULL, 'IPR021327', NULL, 'Protein of unknown function DUF2934', 'DUF2934', 4, NULL),
(17940, NULL, 'IPR034627', NULL, 'Increased recombination centres protein 6', 'Irc6', 4, NULL),
(17941, NULL, 'IPR020062', NULL, 'Nuclear transition protein 1, conserved site', 'Nuclear_transition_prot1_CS', 2, NULL),
(17942, NULL, 'IPR017701', NULL, 'Putative selenate reductase YgfK', 'Se_rdtase_YgfK', 4, NULL),
(17943, NULL, 'IPR021222', NULL, 'Protein of unknown function DUF2714', 'DUF2714', 4, NULL),
(17944, NULL, 'IPR016029', NULL, 'Inner layer core protein VP3, Reovirus', 'Inner_layer_core_VP3_Reovir', 5, NULL),
(17945, NULL, 'IPR021256', NULL, 'Protein of unknown function DUF2808', 'DUF2808', 4, NULL),
(17946, NULL, 'IPR015671', NULL, 'GLTSCR protein, conserved region', 'GSCR1_dom', 3, NULL),
(17947, NULL, 'IPR020203', NULL, 'Membrane protein YneK', 'YneK', 4, NULL),
(17948, NULL, 'IPR016549', NULL, 'Uncharacterised conserved protein UCP009193', 'UCP009193', 4, NULL),
(17949, NULL, 'IPR016962', NULL, 'Dehydrase, ECs4332, predicted', 'Dehydrase_ECs4332_prd', 4, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(17950, NULL, 'IPR013914', NULL, 'Rad9-like Rad53-binding domain, fungi', 'Rad9_Rad53-bd_dom_fun', 3, NULL),
(17951, NULL, 'IPR016597', NULL, 'Uncharacterised conserved protein UCP012359', 'UCP012359', 4, NULL),
(17952, NULL, 'IPR013887', NULL, 'Uncharacterised protein family UPF0592', 'UPF0592', 4, NULL),
(17953, NULL, 'IPR020205', NULL, 'Uncharacterised protein family, YwnF, transmembrane', 'Uncharacterised_YwnF_TM', 4, NULL),
(17954, NULL, 'IPR013898', NULL, 'Mitophagy receptor Atg43', 'Atg43', 4, NULL),
(17955, NULL, 'IPR021272', NULL, 'Protein of unknown function DUF2851', 'DUF2851', 4, NULL),
(17956, NULL, 'IPR021215', NULL, 'Protein of unknown function DUF2752', 'DUF2752', 4, NULL),
(17957, NULL, 'IPR021330', NULL, 'Protein of unknown function DUF2939', 'DUF2939', 4, NULL),
(17958, NULL, 'IPR017373', NULL, 'Sodium-dependent phosphate transport protein 4 , predicted', 'Na-dep_P-transpt_4_prd', 4, NULL),
(17959, NULL, 'IPR021291', NULL, 'Cytochrome b6f, subunit Tsr0524-like', 'Tsr0524-like', 4, NULL),
(17960, NULL, 'IPR016600', NULL, 'Uncharacterised conserved protein UCP012611', 'UCP012611', 4, NULL),
(17961, NULL, 'IPR019138', NULL, 'De-etiolated protein 1, Det1', 'De-etiolated_protein_1_Det1', 4, NULL),
(17962, NULL, 'IPR021255', NULL, 'Putative auto-transporter adhesin, head GIN domain', 'DUF2807', 3, NULL),
(17963, NULL, 'IPR013912', NULL, 'Adenylate cyclase-associated CAP, C-terminal', 'Adenylate_cyclase-assoc_CAP_C', 3, NULL),
(17964, NULL, 'IPR019097', NULL, 'Mg296 protein', 'Mg296_protein', 3, NULL),
(17965, NULL, 'IPR019136', NULL, 'Transcription factor IIIC subunit 5, HTH domain', 'TF_IIIC_su-5_HTH', 3, NULL),
(17966, NULL, 'IPR021245', NULL, 'Protein of unknown function DUF2790', 'DUF2790', 4, NULL),
(17967, NULL, 'IPR021229', NULL, 'Protein of unknown function DUF2800', 'DUF2800', 4, NULL),
(17968, NULL, 'IPR013880', NULL, 'Yos1-like', 'Yos1', 4, NULL),
(17969, NULL, 'IPR032477', NULL, 'Beta-1,3-glucanase, N-terminal', 'Glyco_hydro_64_N', 3, NULL),
(17970, NULL, 'IPR021283', NULL, 'Protein of unknown function DUF2612', 'DUF2612', 4, NULL),
(17971, NULL, 'IPR016568', NULL, 'Sulphur oxidation, SoxY', 'Sulphur_oxidation_SoxY', 4, NULL),
(17972, NULL, 'IPR016599', NULL, 'Uncharacterised conserved protein UCP012569', 'UCP012569', 4, NULL),
(17973, NULL, 'IPR017676', NULL, 'Putative methanogenesis marker protein 15', 'Methan_mark_15', 4, NULL),
(17974, NULL, 'IPR016937', NULL, 'Uncharacterised conserved protein UCP029727', 'UCP029727', 4, NULL),
(17975, NULL, 'IPR015661', NULL, 'Mitotic spindle checkpoint protein Bub1/Mad3', 'Bub1/Mad3', 4, NULL),
(17976, NULL, 'IPR015666', NULL, 'Sarcoplasmic reticulum histidine-rich calcium-binding protein', 'HRC', 4, NULL),
(17977, NULL, 'IPR020051', NULL, 'SagB-type dehydrogenase domain', 'SagB-type_dehydrogenase', 3, NULL),
(17978, NULL, 'IPR017696', NULL, 'Molybdenum cofactor cytidylyltransferase', 'Mo_hydrolase_YgfJ', 4, NULL),
(17979, NULL, 'IPR021331', NULL, 'Hypervirulence associated protein, TUDOR domain', 'Hva1_TUDOR', 3, NULL),
(17980, NULL, 'IPR021323', NULL, 'Protein of unknown function DUF2927', 'DUF2927', 4, NULL),
(17981, NULL, 'IPR023799', NULL, 'Ribosome-binding factor A domain superfamily', 'RbfA_dom_sf', 5, NULL),
(17982, NULL, 'IPR021306', NULL, 'Protein of unknown function DUF2878', 'DUF2878', 4, NULL),
(17983, NULL, 'IPR016966', NULL, 'Thiamin pyrophosphokinase, eukaryotic', 'Thiamin_pyrophosphokinase_euk', 4, NULL),
(17984, NULL, 'IPR016987', NULL, 'Uncharacterised conserved protein UCP023238', 'UCP023238', 4, NULL),
(17985, NULL, 'IPR017686', NULL, 'Phage/plasmid-like protein', 'Phg/plasmid-like_prot', 4, NULL),
(17986, NULL, 'IPR016973', NULL, 'Integral membrane protein SYS1', 'Integral_membrane_SYS1', 4, NULL),
(17987, NULL, 'IPR016955', NULL, 'Autotransporter, YhjY, predicted', 'Autotranspt_YhjY_prd', 4, NULL),
(17988, NULL, 'IPR035509', NULL, 'Stac2, SH3 domain', 'Stac2_SH3', 3, NULL),
(17989, NULL, 'IPR021240', NULL, 'Protein of unknown function DUF2776', 'DUF2776', 4, NULL),
(17990, NULL, 'IPR015657', NULL, 'Aminobutyraldehyde dehydrogenase', 'Aminobutyraldehyde_DH', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(17991, NULL, 'IPR019111', NULL, 'Plasmodium RESA, N-terminal', 'PRESA_N', 3, NULL),
(17992, NULL, 'IPR021334', NULL, 'Protein of unknown function DUF2947', 'DUF2947', 4, NULL),
(17993, NULL, 'IPR013899', NULL, 'Domain of unknown function DUF1771', 'DUF1771', 3, NULL),
(17994, NULL, 'IPR020196', NULL, 'Uncharacterised protein family YqgB', 'Uncharacterised_YqgB', 4, NULL),
(17995, NULL, 'IPR018728', NULL, 'Domain of unknown function DUF2268', 'DUF2268', 3, NULL),
(17996, NULL, 'IPR021260', NULL, 'Lipid II flippase Amj', 'Amj', 4, NULL),
(17997, NULL, 'IPR035972', NULL, 'Gamma-carboxyglutamic acid-rich (GLA) domain superfamily', 'GLA-like_dom_SF', 5, NULL),
(17998, NULL, 'IPR016943', NULL, 'Uncharacterised conserved protein UCP030050, HTH transcriptional regulator, BH1869', 'UCP030050_HTH', 4, NULL),
(17999, NULL, 'IPR015637', NULL, 'Uracil DNA glycosylase family 2', 'MUG/TDG', 4, NULL),
(18000, NULL, 'IPR016576', NULL, 'Ribosomal protein 63, mitochondrial', 'Ribosomal_MRP63_mit', 4, NULL),
(18001, NULL, 'IPR021389', NULL, 'Protein of unknown function DUF3022', 'DUF3022', 4, NULL),
(18002, NULL, 'IPR018748', NULL, 'Domain of unknown function DUF2300, secreted', 'DUF2300_secreted', 3, NULL),
(18003, NULL, 'IPR021474', NULL, 'Protein of unknown function DUF3127', 'DUF3127', 4, NULL),
(18004, NULL, 'IPR021429', NULL, 'Mediator complex, subunit Med24,', 'Mediator_Med24', 4, NULL),
(18005, NULL, 'IPR011234', NULL, 'Fumarylacetoacetase-like, C-terminal', 'Fumarylacetoacetase-like_C', 3, NULL),
(18006, NULL, 'IPR017406', NULL, 'Serine/threonine-protein kinase Rio3', 'Ser/Thr_kinase_Rio3', 4, NULL),
(18007, NULL, 'IPR023886', NULL, 'Quinohemoprotein amine dehydrogenase, gamma subunit maturation protein', 'QH-AmDH_gsu_maturation', 4, NULL),
(18008, NULL, 'IPR023921', NULL, 'Alcohol dehydrogenase, zinc-type, actinomycetes', 'ADH_Zn_actinomycetes', 4, NULL),
(18009, NULL, 'IPR015685', NULL, 'Aquaporin 9', 'Aquaporin_9', 4, NULL),
(18010, NULL, 'IPR019163', NULL, 'THO complex, subunit 5', 'THO_Thoc5', 4, NULL),
(18011, NULL, 'IPR034227', NULL, 'Ubiquinol oxidase subunit 2, cupredoxin domain', 'CuRO_UO_II', 3, NULL),
(18012, NULL, 'IPR021443', NULL, 'Protein of unknown function DUF3093', 'DUF3093', 4, NULL),
(18013, NULL, 'IPR015679', NULL, 'Phospholipase D family', 'PLipase_D_fam', 4, NULL),
(18014, NULL, 'IPR019507', NULL, 'Protease A inhibitor IA3', 'Pai3', 4, NULL),
(18015, NULL, 'IPR023906', NULL, 'Radical SAM target protein, putative', 'rSAM_target_put', 4, NULL),
(18016, NULL, 'IPR021482', NULL, 'Protein of unknown function DUF3135', 'DUF3135', 4, NULL),
(18017, NULL, 'IPR019173', NULL, 'NADH:ubiquinone oxidoreductase, NDUFB5/SGDH subunit', 'NADH_UbQ_OxRdtase_B5_su', 4, NULL),
(18018, NULL, 'IPR017914', NULL, 'Colipase, C-terminal', 'Colipase_C', 3, NULL),
(18019, NULL, 'IPR019912', NULL, 'FMN reductase, MsuE-like', 'FMN_Rdtase_MsuE-like', 4, NULL),
(18020, NULL, 'IPR023910', NULL, 'Colanic acid biosynthesis, glycosyl transferase, WcaI', 'Colanic_acid_synth_WcaI', 4, NULL),
(18021, NULL, 'IPR023913', NULL, 'Mycofactocin maturase MftC', 'MftC', 4, NULL),
(18022, NULL, 'IPR019143', NULL, 'JNK/Rab-associated protein-1, N-terminal', 'JNK/Rab-associated_protein-1_N', 3, NULL),
(18023, NULL, 'IPR018774', NULL, 'Bacteriophage Mu, GpT', 'Phage_Mu_GpT', 3, NULL),
(18024, NULL, 'IPR017739', NULL, 'Type VI secretion system-associated, VCA0119', 'T6SS-assoc_VCA0119', 4, NULL),
(18025, NULL, 'IPR017741', NULL, 'FAD-dependent oxidoreductase, HpnW', 'FAD-dependent_OxRdtase_HpnW', 4, NULL),
(18026, NULL, 'IPR021082', NULL, 'Protein GAPT', 'Protein_GAPT', 4, NULL),
(18027, NULL, 'IPR017873', NULL, 'Cysteine-rich Golgi apparatus protein 1 repeat, eukaryote', 'Cys-rich_GLG1_repeat_euk', 7, NULL),
(18028, NULL, 'IPR019142', NULL, 'Dymeclin', 'Dymeclin', 4, NULL),
(18029, NULL, 'IPR021427', NULL, 'Protein of unknown function DUF3077', 'DUF3077', 4, NULL),
(18030, NULL, 'IPR018737', NULL, 'Protein LIN52', 'DREAM_LIN52', 4, NULL),
(18031, NULL, 'IPR021370', NULL, 'Protein of unknown function DUF2987', 'DUF2987', 4, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(18032, NULL, 'IPR019496', NULL, 'FMR1-interacting protein 1, conserved domain', 'NUFIP1_cons_dom', 3, NULL),
(18033, NULL, 'IPR019943', NULL, 'Coenzyme F420 biosynthesis protein FbiB, C-terminal', 'F420_FbiB_C', 3, NULL),
(18034, NULL, 'IPR019500', NULL, 'Peptidase S46', 'Pep_S46', 4, NULL),
(18035, NULL, 'IPR019149', NULL, 'Alpha/beta hydrolase domain-containing protein 18', 'ABHD18', 4, NULL),
(18036, NULL, 'IPR035426', NULL, 'Gemin2/Brr1', 'Gemin2/Brr1', 4, NULL),
(18037, NULL, 'IPR021393', NULL, 'Protein of unknown function DUF3034', 'DUF3034', 4, NULL),
(18038, NULL, 'IPR015675', NULL, 'Secretin precursor', 'Prosecretin', 4, NULL),
(18039, NULL, 'IPR017425', NULL, 'Mitogen-activated protein (MAP) kinase kinase kinase 14', 'MAPKKK14', 4, NULL),
(18040, NULL, 'IPR021457', NULL, 'Protein of unknown function DUF3108', 'DUF3108', 4, NULL),
(18041, NULL, 'IPR032480', NULL, 'Domain of unknown function DUF5057', 'DUF5057', 3, NULL),
(18042, NULL, 'IPR035418', NULL, 'Transcription regulator HTH, AraC- type, ligand binding domain-like', 'AraC-bd_2', 3, NULL),
(18043, NULL, 'IPR023905', NULL, 'Acetyldiaminopimelate deacetylase', 'AcetylDAP_deacetylase', 4, NULL),
(18044, NULL, 'IPR021397', NULL, 'Mediator complex, subunit Med25, synapsin 1', 'Mediator_Med25_SD1', 3, NULL),
(18045, NULL, 'IPR021469', NULL, 'Protein of unknown function DUF3122', 'DUF3122', 4, NULL),
(18046, NULL, 'IPR018741', NULL, 'Protein of unknown function DUF2288', 'DUF2288', 4, NULL),
(18047, NULL, 'IPR021441', NULL, 'Protein of unknown function DUF3090', 'DUF3090', 4, NULL),
(18048, NULL, 'IPR017413', NULL, 'Transcription factor  GTE1', 'GTE1', 4, NULL),
(18049, NULL, 'IPR021357', NULL, 'Protein of unknown function DUF2782', 'DUF2782', 4, NULL),
(18050, NULL, 'IPR017431', NULL, 'Interferon regulatory factor-1/2', 'IRF1/IRF2', 4, NULL),
(18051, NULL, 'IPR023901', NULL, 'Thiocyanate hydrolase, gamma subunit', 'Thiocyan_Hydrolase_gsu', 4, NULL),
(18052, NULL, 'IPR019843', NULL, 'DNA polymerase family X, binding site', 'DNA_pol-X_BS', 1, NULL),
(18053, NULL, 'IPR019152', NULL, 'Protein of unknown function DUF2046', 'DUF2046', 4, NULL),
(18054, NULL, 'IPR019176', NULL, 'Cytochrome B561-related', 'Cytochrome_B561-rel', 4, NULL),
(18055, NULL, 'IPR032678', NULL, 'tRNA synthetases class I, catalytic domain', 'tRNA-synt_1_cat_dom', 3, NULL),
(18056, NULL, 'IPR019930', NULL, 'Iron-regulated surface determinant protein H', 'IsdH', 4, NULL),
(18057, NULL, 'IPR021464', NULL, 'Protein of unknown function DUF3116', 'DUF3116', 4, NULL),
(18058, NULL, 'IPR021467', NULL, 'Protein of unknown function DUF3119', 'DUF3119', 4, NULL),
(18059, NULL, 'IPR018732', NULL, 'Dpy-19/Dpy-19-like', 'Dpy-19/Dpy-19-like', 4, NULL),
(18060, NULL, 'IPR016192', NULL, 'APOBEC/CMP deaminase, zinc-binding', 'APOBEC/CMP_deaminase_Zn-bd', 1, NULL),
(18061, NULL, 'IPR018773', NULL, 'Methyltransferase regulatory domain, predicted', 'MeTrfase_reg_dom_prd', 3, NULL),
(18062, NULL, 'IPR018759', NULL, 'Putative beta-barrel porin 2', 'BBP2_2', 4, NULL),
(18063, NULL, 'IPR023904', NULL, 'Peptide radical SAM maturase , YydG', 'Pep_rSAM_mat_YydG', 4, NULL),
(18064, NULL, 'IPR018767', NULL, 'Brl1/Brr6 domain', 'Brl1/Brr6_dom', 3, NULL),
(18065, NULL, 'IPR017407', NULL, 'Serine/threonine-protein kinase Rio1', 'Ser/Thr_kinase_Rio1', 4, NULL),
(18066, NULL, 'IPR023912', NULL, 'Putative glycyl-radical enzyme activating enzyme YjjW', 'YjjW_bact', 4, NULL),
(18067, NULL, 'IPR017910', NULL, 'Zinc finger, large T-antigen D1-type', 'Znf_lg_T-Ag_D1-typ', 3, NULL),
(18068, NULL, 'IPR017736', NULL, 'Glycoside hydrolase, family 1, beta-glucosidase', 'Glyco_hydro_1_beta-glucosidase', 4, NULL),
(18069, NULL, 'IPR021486', NULL, 'Protein of unknown function DUF3139', 'DUF3139', 4, NULL),
(18070, NULL, 'IPR021367', NULL, 'Protein of unknown function DUF2982', 'DUF2982', 4, NULL),
(18071, NULL, 'IPR018013', NULL, 'Nucleoside-specific channel-forming protein, Tsx-like', 'Channel_Tsx-like', 4, NULL),
(18072, NULL, 'IPR021413', NULL, 'Protein of unknown function DUF3053', 'DUF3053', 4, NULL),
(18073, NULL, 'IPR017420', NULL, '6,7-dimethyl-8-ribityllumazine synthase, chloroplast', 'DMRL_synthase_chloroplast', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(18074, NULL, 'IPR021400', NULL, 'Protein of unknown function DUF3039', 'DUF3039', 4, NULL),
(18075, NULL, 'IPR017729', NULL, 'AAA+ ATPase ClpV1', 'ATPase_T6SS_ClpV1', 4, NULL),
(18076, NULL, 'IPR017725', NULL, 'Phosphonate utilization associated transmembrane protein, putative', 'Phosphonate_util-assoc_TM_put', 4, NULL),
(18077, NULL, 'IPR021436', NULL, 'Protein of unknown function DUF3085', 'DUF3085', 4, NULL),
(18078, NULL, 'IPR021406', NULL, 'Mediator complex, subunit Med25, NR box', 'Mediator_Med25_NR-box', 3, NULL),
(18079, NULL, 'IPR017405', NULL, 'Citron Rho-interacting kinase', 'Citron_Rho-interacting_kinase', 4, NULL),
(18080, NULL, 'IPR019175', NULL, 'Prp31 C-terminal', 'Prp31_C', 3, NULL),
(18081, NULL, 'IPR021336', NULL, 'Protein of unknown function DUF2949', 'DUF2949', 4, NULL),
(18082, NULL, 'IPR019516', NULL, 'Glomulin/ALF4', 'Glomulin/ALF4', 4, NULL),
(18083, NULL, 'IPR019911', NULL, 'Alkanesulphonate monooxygenase, FMN-dependent', 'Alkanesulphonate_mOase_FMN-dep', 4, NULL),
(18084, NULL, 'IPR021412', NULL, 'Protein of unknown function DUF3052', 'DUF3052', 4, NULL),
(18085, NULL, 'IPR016059', NULL, 'DNA ligase, ATP-dependent, conserved site', 'DNA_ligase_ATP-dep_CS', 2, NULL),
(18086, NULL, 'IPR021155', NULL, 'Poxvirus E2/O1', 'Poxvirus_E2/O1', 4, NULL),
(18087, NULL, 'IPR021342', NULL, 'Protein of unknown function DUF2959', 'DUF2959', 4, NULL),
(18088, NULL, 'IPR021103', NULL, 'Argonaute PAZ domain, archaea', 'PAZ_arc', 3, NULL),
(18089, NULL, 'IPR019186', NULL, 'Nucleolar protein 12', 'Nucleolar_protein_12', 4, NULL),
(18090, NULL, 'IPR018744', NULL, 'Domain of unknown function DUF2293', 'DUF2293', 3, NULL),
(18091, NULL, 'IPR032483', NULL, 'Protein of unknown function DUF5053', 'DUF5053', 4, NULL),
(18092, NULL, 'IPR017410', NULL, 'Mitochondrial outer membrane transport complex protein Metaxin 1/3', 'Metaxin1/3', 4, NULL),
(18093, NULL, 'IPR017424', NULL, 'Mitogen-activated protein (MAP) kinase kinase kinase 8', 'MAPKKK8', 4, NULL),
(18094, NULL, 'IPR021480', NULL, 'Probable zinc-ribbon domain, plant', 'Zinc_ribbon_12', 3, NULL),
(18095, NULL, 'IPR018757', NULL, 'Protein of unknown function DUF2316', 'DUF2316', 4, NULL),
(18096, NULL, 'IPR018756', NULL, 'Domain of unknown function DUF2314', 'DUF2314', 3, NULL),
(18097, NULL, 'IPR017740', NULL, 'Type VI secretion system protein TssA-like', 'TssA-like', 4, NULL),
(18098, NULL, 'IPR021354', NULL, 'Protein of unknown function DUF2975', 'DUF2975', 4, NULL),
(18099, NULL, 'IPR019154', NULL, 'Arb2 domain', 'Arb2_domain', 3, NULL),
(18100, NULL, 'IPR019502', NULL, 'Peptidase S68, pidd', 'Peptidase_S68_pidd', 4, NULL),
(18101, NULL, 'IPR017874', NULL, 'CRIC domain', 'CRIC_domain', 3, NULL),
(18102, NULL, 'IPR017439', NULL, 'Amidohydrolase', 'Amidohydrolase', 4, NULL),
(18103, NULL, 'IPR017395', NULL, 'Chlorophyllase', 'Chlorophyllase', 4, NULL),
(18104, NULL, 'IPR021359', NULL, 'Protein of unknown function DUF2812', 'DUF2812', 4, NULL),
(18105, NULL, 'IPR021447', NULL, 'Protein of unknown function DUF3097', 'DUF3097', 4, NULL),
(18106, NULL, 'IPR021470', NULL, 'Protein of unknown function DUF3123', 'DUF3123', 4, NULL),
(18107, NULL, 'IPR019498', NULL, 'MENTAL domain', 'MENTAL', 3, NULL),
(18108, NULL, 'IPR019162', NULL, 'Fanconi anemia complex, subunit FancL, WD-repeat containing domain', 'FancL_WD-rpt_cont_dom', 3, NULL),
(18109, NULL, 'IPR023996', NULL, 'TonB-dependent outer membrane protein, SusC/RagA', 'TonB-dep_OMP_SusC/RagA', 4, NULL),
(18110, NULL, 'IPR017381', NULL, 'Leukocyte cell-derived chemotaxin 2, chordata', 'LECT2_chordata', 4, NULL),
(18111, NULL, 'IPR023998', NULL, 'Siderophore ferric iron reductase, AHA1954 family', 'Sidero_Fe_redtase_AHA1954', 4, NULL),
(18112, NULL, 'IPR021430', NULL, 'Protein of unknown function DUF3079', 'DUF3079', 4, NULL),
(18113, NULL, 'IPR019492', NULL, 'Cyclo-malto-dextrinase, C-terminal', 'Cyclo-malto-dextrinase_C', 3, NULL),
(18114, NULL, 'IPR019486', NULL, 'Argonaute hook domain', 'Argonaute_hook_dom', 3, NULL),
(18115, NULL, 'IPR018770', NULL, '5-bromo-4-chloroindolyl phosphate hydrolysis protein', 'ChloroindolylP_hydrolase', 4, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(18116, NULL, 'IPR021428', NULL, 'Protein of unknown function DUF3078', 'DUF3078', 4, NULL),
(18117, NULL, 'IPR018731', NULL, 'Autophagy-related protein 13, N-terminal', 'Atg13_N', 3, NULL),
(18118, NULL, 'IPR019160', NULL, 'Exocyst complex component Sec3, C-terminal', 'Sec3_C', 3, NULL),
(18119, NULL, 'IPR019165', NULL, 'Peptidase M76, ATP23', 'Peptidase_M76_ATP23', 4, NULL),
(18120, NULL, 'IPR032677', NULL, 'GTP cyclohydrolase II', 'GTP_cyclohydro_II', 3, NULL),
(18121, NULL, 'IPR018762', NULL, 'Histidine phosphotransferase ChpT, C-terminal', 'ChpT_C', 3, NULL),
(18122, NULL, 'IPR021353', NULL, 'Protein of unknown function DUF2972', 'DUF2972', 4, NULL),
(18123, NULL, 'IPR019525', NULL, 'Nuclear respiratory factor 1, NLS/DNA-binding, dimerisation domain', 'Nrf1_NLS/DNA-bd_dimer', 3, NULL),
(18124, NULL, 'IPR021388', NULL, 'Bacteriophage 933W, L0084', 'Phage_933W_L0084', 4, NULL),
(18125, NULL, 'IPR021337', NULL, 'Protein of unknown function DUF2951', 'DUF2951', 4, NULL),
(18126, NULL, 'IPR021378', NULL, 'Protein of unknown function DUF3010', 'DUF3010', 4, NULL),
(18127, NULL, 'IPR021402', NULL, 'Protein of unknown function DUF3042', 'DUF3042', 4, NULL),
(18128, NULL, 'IPR034201', NULL, 'RNPS1, RNA recognition motif', 'RNPS1_RRM', 3, NULL),
(18129, NULL, 'IPR019508', NULL, 'Proteinase inhibitor I48, clitocypin', 'Prot_inh_I48_clitocypin', 4, NULL),
(18130, NULL, 'IPR021444', NULL, 'Protein of unknown function DUF3094', 'DUF3094', 4, NULL),
(18131, NULL, 'IPR021473', NULL, 'Protein of unknown function DUF3126', 'DUF3126', 4, NULL),
(18132, NULL, 'IPR017396', NULL, 'WRKY transcription factor, group IIc', 'TF_WRKY_IIc', 4, NULL),
(18133, NULL, 'IPR021104', NULL, 'KfrA, N-terminal DNA-binding domain', 'KfrA_DNA-bd_N', 3, NULL),
(18134, NULL, 'IPR019185', NULL, 'Integral membrane protein SYS1-related', 'Integral_membrane_SYS1-rel', 4, NULL),
(18135, NULL, 'IPR021451', NULL, 'Protein of unknown function DUF3102', 'DUF3102', 4, NULL),
(18136, NULL, 'IPR021432', NULL, 'Protein of unknown function DUF3081', 'DUF3081', 4, NULL),
(18137, NULL, 'IPR023192', NULL, 'TGS-like domain superfamily', 'TGS-like_dom_sf', 5, NULL),
(18138, NULL, 'IPR032485', NULL, 'Domain of unknown function DUF5050', 'DUF5050', 3, NULL),
(18139, NULL, 'IPR021461', NULL, 'Protein of unknown function DUF3113', 'DUF3113', 4, NULL),
(18140, NULL, 'IPR019515', NULL, 'Vacuolar protein sorting-associated protein 54, N-terminal', 'VPS54_N', 3, NULL),
(18141, NULL, 'IPR016193', NULL, 'Cytidine deaminase-like', 'Cytidine_deaminase-like', 5, NULL),
(18142, NULL, 'IPR017411', NULL, 'Mitochondrial outer membrane translocase complex, subunit Tom22, plant', 'Tom22_pln', 4, NULL),
(18143, NULL, 'IPR032674', NULL, 'LRR-containing bacterial E3 ligase, N-terminal', 'LRR_E3_ligase_N', 3, NULL),
(18144, NULL, 'IPR021424', NULL, 'Porin PorA', 'PorA', 4, NULL),
(18145, NULL, 'IPR017732', NULL, 'Type IV / VI secretion system, DotU', 'T4/T6SS_DotU', 3, NULL),
(18146, NULL, 'IPR023903', NULL, 'Cyclised secreted peptide', 'Cyclised_pep', 4, NULL),
(18147, NULL, 'IPR021394', NULL, 'Mediator complex, subunit Med25, PTOV domain', 'Med25_PTOV', 3, NULL),
(18148, NULL, 'IPR019167', NULL, 'mRNA decay factor PAT1 domain', 'PAT1_dom', 3, NULL),
(18149, NULL, 'IPR019522', NULL, 'Phosphoinositide 3-kinase regulatory subunit 5/6', 'PIK3R5/6', 4, NULL),
(18150, NULL, 'IPR019939', NULL, 'CofG family', 'CofG_family', 4, NULL),
(18151, NULL, 'IPR019942', NULL, 'LL-diaminopimelate aminotransferase/aminotransferase ALD1', 'DapL/ALD1', 4, NULL),
(18152, NULL, 'IPR021391', NULL, 'Protein of unknown function DUF3027', 'DUF3027', 4, NULL),
(18153, NULL, 'IPR017724', NULL, 'Aminoethylphosphonate utilisation-associated transcription regulator, LysR-type', 'Tscrpt_reg_LysR', 4, NULL),
(18154, NULL, 'IPR021471', NULL, 'Protein of unknown function DUF3124', 'DUF3124', 4, NULL),
(18155, NULL, 'IPR021446', NULL, 'Protein of unknown function DUF3096', 'DUF3096', 4, NULL),
(18156, NULL, 'IPR018754', NULL, 'Domain of unknown function DUF2285', 'DUF2285', 3, NULL),
(18157, NULL, 'IPR019482', NULL, 'Interleukin-12 beta, central domain', 'IL-12_beta_cen-dom', 3, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(18158, NULL, 'IPR018753', NULL, 'GapR-like', 'GapR-like', 4, NULL),
(18159, NULL, 'IPR017415', NULL, 'Putative RNA polymerase II transcriptional coactivator KELP', 'KELP', 4, NULL),
(18160, NULL, 'IPR017726', NULL, 'Fe/S biogenesis protein NfuA', 'Fe/S_biogenesis_protein_NfuA', 4, NULL),
(18161, NULL, 'IPR019853', NULL, 'Gliding motility-associated lipoprotein, GldB', 'Motility-assoc_lipoprot_GldB', 4, NULL),
(18162, NULL, 'IPR018734', NULL, 'Domain of unknown function DUF2275', 'DUF2275', 3, NULL),
(18163, NULL, 'IPR021395', NULL, 'Protein of unknown function DUF3035', 'DUF3035', 4, NULL),
(18164, NULL, 'IPR035422', NULL, 'Alginate O-acetyl transferase AlgF', 'AlgF', 4, NULL),
(18165, NULL, 'IPR019193', NULL, 'Ubiquitin-conjugating enzyme E2-binding protein', 'UBQ-conj_enz_E2-bd_prot', 4, NULL),
(18166, NULL, 'IPR017387', NULL, 'Testis-specific TEX28', 'Testis-specific_TEX28', 4, NULL),
(18167, NULL, 'IPR019190', NULL, 'Exonuclease V', 'EXOV', 4, NULL),
(18168, NULL, 'IPR023566', NULL, 'Peptidyl-prolyl cis-trans isomerase Fpr3/Fpr4-like', 'PPIase_Fpr3/Fpr4-like', 4, NULL),
(18169, NULL, 'IPR021439', NULL, 'Protein of unknown function DUF3088', 'DUF3088', 4, NULL),
(18170, NULL, 'IPR023194', NULL, 'Eukaryotic translation initiation factor 3-like domain superfamily', 'eIF3-like_dom_sf', 5, NULL),
(18171, NULL, 'IPR021483', NULL, 'Protein of unknown function DUF3136', 'DUF3136', 4, NULL),
(18172, NULL, 'IPR019929', NULL, 'Iron-regulated surface determinant protein IsdB', 'Iron-reg_IsdB', 4, NULL),
(18173, NULL, 'IPR032675', NULL, 'Leucine-rich repeat domain superfamily', 'LRR_dom_sf', 5, NULL),
(18174, NULL, 'IPR019147', NULL, 'Suppressor of white apricot, N-terminal domain', 'SWAP_N_domain', 3, NULL),
(18175, NULL, 'IPR023900', NULL, 'Nitrile hydratase alpha subunit /Thiocyanate hydrolase gamma subunit', 'CN_Hdrtase_asu/SCN_Hdrlase_gsu', 4, NULL),
(18176, NULL, 'IPR021384', NULL, 'Mediator complex, subunit Med21', 'Mediator_Med21', 4, NULL),
(18177, NULL, 'IPR017379', NULL, 'PDZ domain-containing protein GIPC1/2/3', 'GIPC1/2/3', 4, NULL),
(18178, NULL, 'IPR018772', NULL, 'Transcription activator HlyU', 'Transcription_activator_HlyU', 4, NULL),
(18179, NULL, 'IPR035974', NULL, 'Rap/Ran-GAP superfamily', 'Rap/Ran-GAP_sf', 5, NULL),
(18180, NULL, 'IPR017730', NULL, 'Chaperonin ClpB', 'Chaperonin_ClpB', 4, NULL),
(18181, NULL, 'IPR019192', NULL, 'Ribosomal protein L28/L40, mitochondrial', 'Ribosomal_L28/L40_mit', 4, NULL),
(18182, NULL, 'IPR019497', NULL, 'Sorting nexin protein, WASP-binding domain', 'Sorting_nexin_WASP-bd-dom', 3, NULL),
(18183, NULL, 'IPR021485', NULL, 'Protein of unknown function DUF3138', 'DUF3138', 4, NULL),
(18184, NULL, 'IPR021425', NULL, 'Protein of unknown function DUF3072', 'DUF3072', 4, NULL),
(18185, NULL, 'IPR019191', NULL, 'Essential protein Yae1, N-terminal', 'Essential_protein_Yae1_N', 3, NULL),
(18186, NULL, 'IPR021375', NULL, 'Protein of unknown function DUF2997', 'DUF2997', 4, NULL),
(18187, NULL, 'IPR021398', NULL, 'Protein of unknown function DUF3037', 'DUF3037', 4, NULL),
(18188, NULL, 'IPR021392', NULL, 'Focadhesin', 'Focadhesin', 4, NULL),
(18189, NULL, 'IPR023995', NULL, 'Oxygen-independent coproporphyrinogen-III oxidase-like protein HemZ', 'HemZ', 4, NULL),
(18190, NULL, 'IPR017384', NULL, 'NADH dehydrogenase [ubiquinone] (complex I), alpha subcomplex subunit 1', 'NADH_Ub_cplx-1_asu_su-1', 4, NULL),
(18191, NULL, 'IPR023909', NULL, 'F420-dependent oxidoreductase, NP1902A', 'F420_NP1902A', 4, NULL),
(18192, NULL, 'IPR021434', NULL, 'Protein of unknown function DUF3082', 'DUF3082', 4, NULL),
(18193, NULL, 'IPR017409', NULL, 'Pyruvate Pi dikinase regulator, chloroplast', 'Pyrv_Pi_dikinase_reg_chlpt', 4, NULL),
(18194, NULL, 'IPR021358', NULL, 'Protein of unknown function DUF2977', 'DUF2977', 4, NULL),
(18195, NULL, 'IPR017731', NULL, 'Type VI secretion system  protein TssM1-like', 'TssM1-like', 4, NULL),
(18196, NULL, 'IPR021340', NULL, 'Protein of unknown function DUF2957', 'DUF2957', 4, NULL),
(18197, NULL, 'IPR021407', NULL, 'Protein of unknown function DUF2544', 'DUF2544', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(18198, NULL, 'IPR021365', NULL, 'Protein of unknown function DUF2891', 'DUF2891', 4, NULL),
(18199, NULL, 'IPR034981', NULL, 'EfeO/Algp7, imelysin-like domain', 'Imelysin-like_EfeO/Algp7', 3, NULL),
(18200, NULL, 'IPR019854', NULL, 'Gliding motility-associated protein, GldC', 'Motility-assoc_prot_GldC', 4, NULL),
(18201, NULL, 'IPR018766', NULL, 'Zinicin-like metallopeptidase type 2', 'Zinicin_2', 4, NULL),
(18202, NULL, 'IPR032481', NULL, 'Protein of unknown function DUF5055', 'DUF5055', 4, NULL),
(18203, NULL, 'IPR018769', NULL, 'Type VI secretion system spike protein VgrG2, C-terminal domain of unknown function DUF2345', 'VgrG2_C_DUF2345', 3, NULL),
(18204, NULL, 'IPR035421', NULL, 'Terminase, large subunit gp17-like, C-terminal', 'Terminase_6C', 3, NULL),
(18205, NULL, 'IPR019937', NULL, 'Cyclically-permuted mutarotase family', 'Cycl-permuted_mutarotase', 4, NULL),
(18206, NULL, 'IPR019520', NULL, 'Ribosomal protein S23, mitochondrial', 'Ribosomal_S23', 4, NULL),
(18207, NULL, 'IPR021409', NULL, 'Protein of unknown function DUF3047', 'DUF3047', 4, NULL),
(18208, NULL, 'IPR019852', NULL, 'Gliding motility-associated protein, GldL', 'Motility-assoc_prot_GldL', 4, NULL),
(18209, NULL, 'IPR019938', NULL, 'YcaO domain protein', 'YcaO_dom_prot', 4, NULL),
(18210, NULL, 'IPR021437', NULL, 'Protein of unknown function DUF3086', 'DUF3086', 4, NULL),
(18211, NULL, 'IPR019485', NULL, 'V(D)J recombination-activating protein 1, Zinc finger', 'RAG1_Znf', 3, NULL),
(18212, NULL, 'IPR019164', NULL, 'Transmembrane protein 147', 'TMEM147', 4, NULL),
(18213, NULL, 'IPR017383', NULL, 'Actin-related protein 2/3 complex subunit 1', 'ARPC1', 4, NULL),
(18214, NULL, 'IPR019168', NULL, 'Nuclear envelope phosphatase-regulatory subunit 1', 'NEP1-R1', 4, NULL),
(18215, NULL, 'IPR019947', NULL, 'DNA photolyase class 1, 8-HDF type', 'Photolyase_8HDF', 4, NULL),
(18216, NULL, 'IPR019512', NULL, 'Protein phosphatase 1, regulatory subunit 15B, N-terminal', 'Prot_Pase1_reg-su15B_N', 3, NULL),
(18217, NULL, 'IPR023923', NULL, 'Alkylhydroperoxidase domain-containing  protein, Avi7169', 'AhpD_Avi7169', 4, NULL),
(18218, NULL, 'IPR021348', NULL, 'Domiain of unknown function DUF2963', 'DUF2963', 3, NULL),
(18219, NULL, 'IPR023920', NULL, 'ABC transporter, substrate-binding protein, KPN01854', 'ABC_transptr_sub-bd_KPN01854', 4, NULL),
(18220, NULL, 'IPR019195', NULL, 'ABC transporter, ATPase, putative', 'ABC_ATPase_put', 4, NULL),
(18221, NULL, 'IPR021454', NULL, 'Protein of unknown function DUF3105', 'DUF3105', 4, NULL),
(18222, NULL, 'IPR019499', NULL, 'Valyl-tRNA synthetase,  tRNA-binding arm', 'Val-tRNA_synth_tRNA-bd', 3, NULL),
(18223, NULL, 'IPR017386', NULL, 'Transcription factor SOX-12/11/4', 'SOX-12/11/4', 4, NULL),
(18224, NULL, 'IPR019144', NULL, 'Membralin', 'Membralin', 4, NULL),
(18225, NULL, 'IPR021377', NULL, 'Protein of unknown function DUF3006', 'DUF3006', 4, NULL),
(18226, NULL, 'IPR034200', NULL, 'RDM1, RNA recognition motif', 'RDM1_RRM', 3, NULL),
(18227, NULL, 'IPR035420', NULL, 'Spt6, SH2 domain', 'Spt6_SH2', 3, NULL),
(18228, NULL, 'IPR017393', NULL, 'Chromatin-remodeling complex component Sfh1/SNF5', 'Sfh1/SNF5', 4, NULL),
(18229, NULL, 'IPR019179', NULL, 'Coiled-coil domain-containing protein 149-A', 'Coiled-coil_dom-contain_pr_149', 4, NULL),
(18230, NULL, 'IPR019171', NULL, 'Intermembrane space protein MIX23', 'MIX23', 4, NULL),
(18231, NULL, 'IPR017453', NULL, 'Glycine cleavage system H-protein, subgroup', 'GCV_H_sub', 4, NULL),
(18232, NULL, 'IPR019151', NULL, 'Proteasome assembly chaperone 2', 'Proteasome_assmbl_chaperone_2', 4, NULL),
(18233, NULL, 'IPR017394', NULL, 'LOB domain-containing protein 18/20', 'LOB_18/20', 4, NULL),
(18234, NULL, 'IPR019917', NULL, 'FMN reductase (NADH) RutF', 'RutF', 4, NULL),
(18235, NULL, 'IPR034569', NULL, 'Photosynthetic NDH subunit of subcomplex B 5, chloroplastic', 'PNSB5', 4, NULL),
(18236, NULL, 'IPR021411', NULL, 'Sugarcane yellow leaf virus (SCYLV), Orf0', 'SCYLV_Orf0', 4, NULL),
(18237, NULL, 'IPR019884', NULL, 'YtoQ family protein', 'YtoQ_family_protein', 4, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(18238, NULL, 'IPR021449', NULL, 'Protein of unknown function DUF3099', 'DUF3099', 4, NULL),
(18239, NULL, 'IPR019523', NULL, 'Protein phosphatase 1, regulatory subunit 15A/B, C-terminal', 'Prot_Pase1_reg-su15A/B_C', 3, NULL),
(18240, NULL, 'IPR021415', NULL, 'SAV0927-like', 'SAV0927-like', 4, NULL),
(18241, NULL, 'IPR017426', NULL, 'Nuclear receptor coactivator', 'Nuclear_rcpt_coactivator', 4, NULL),
(18242, NULL, 'IPR017402', NULL, 'Proteorhodopsin', 'Proteorhodopsin', 4, NULL),
(18243, NULL, 'IPR015673', NULL, 'Enamelin', 'Enamelin', 4, NULL),
(18244, NULL, 'IPR021356', NULL, 'Integrating conjugative element protein PFL4702', 'Integr_conj_element_PFL4702', 4, NULL),
(18245, NULL, 'IPR017400', NULL, 'Eukaryotic elongation factor 2 kinase', 'eEF-2K', 4, NULL),
(18246, NULL, 'IPR021347', NULL, 'Protein of unknown function DUF2964', 'DUF2964', 4, NULL),
(18247, NULL, 'IPR023908', NULL, 'xxxLxxG heptad repeat', 'xxxLxxG_rpt', 7, NULL),
(18248, NULL, 'IPR019150', NULL, 'Vesicle transport protein, Use1', 'Vesicle_transport_protein_Use1', 4, NULL),
(18249, NULL, 'IPR021463', NULL, 'Putative SAM-dependent methyltransferase', 'Methyltransf_34', 4, NULL),
(18250, NULL, 'IPR019519', NULL, 'Elongator complex protein 5', 'Elp5', 4, NULL),
(18251, NULL, 'IPR021426', NULL, 'Protein of unknown function DUF3073', 'DUF3073', 4, NULL),
(18252, NULL, 'IPR011222', NULL, 'Double-stranded DNA virus, group I, capsid', 'dsDNA_vir_gr_I_capsid', 5, NULL),
(18253, NULL, 'IPR019183', NULL, 'N-acetyltransferase B complex, non-catalytic subunit', 'N-acetylTrfase_B_cplx_non-cat', 4, NULL),
(18254, NULL, 'IPR019148', NULL, 'Nuclear protein DGCR14/ESS-2', 'Nuclear_protein_DGCR14_ESS-2', 4, NULL),
(18255, NULL, 'IPR021462', NULL, 'Protein of unknown function DUF3114', 'DUF3114', 4, NULL),
(18256, NULL, 'IPR019184', NULL, 'Uncharacterised protein family, transmembrane-17', 'Uncharacterised_TM-17', 4, NULL),
(18257, NULL, 'IPR021368', NULL, 'Type VII secretion system protein EccE', 'T7SS_EccE', 4, NULL),
(18258, NULL, 'IPR019833', NULL, 'Manganese/iron superoxide dismutase, binding site', 'Mn/Fe_SOD_BS', 1, NULL),
(18259, NULL, 'IPR021339', NULL, 'Protein of unknown function DUF2956', 'DUF2956', 4, NULL),
(18260, NULL, 'IPR024657', NULL, 'COMPASS complex Set1 subunit, N-SET domain', 'COMPASS_Set1_N-SET', 3, NULL),
(18261, NULL, 'IPR017880', NULL, 'KilA, N-terminal', 'KilA_N', 3, NULL),
(18262, NULL, 'IPR021431', NULL, 'Protein of unknown function DUF3080', 'DUF3080', 4, NULL),
(18263, NULL, 'IPR023997', NULL, 'TonB-dependent outer membrane protein SusC/RagA, conserved site', 'TonB-dep_OMP_SusC/RagA_CS', 2, NULL),
(18264, NULL, 'IPR019197', NULL, 'Biotin-protein ligase, N-terminal', 'Biotin-prot_ligase_N', 3, NULL),
(18265, NULL, 'IPR021440', NULL, 'Protein of unknown function DUF3089', 'DUF3089', 4, NULL),
(18266, NULL, 'IPR018746', NULL, 'Protein of unknown function DUF2298', 'DUF2298', 4, NULL),
(18267, NULL, 'IPR021352', NULL, 'Protein of unknown function DUF2971', 'DUF2971', 4, NULL),
(18268, NULL, 'IPR021452', NULL, 'Protein of unknown function DUF3103', 'DUF3103', 4, NULL),
(18269, NULL, 'IPR019850', NULL, 'Gliding motility-associated lipoprotein, GldD', 'Motility-assoc_lipoprot_GldD', 4, NULL),
(18270, NULL, 'IPR017408', NULL, 'Arginine N-methyltransferase 2', 'Arginine_N-MeTrfase_2', 4, NULL),
(18271, NULL, 'IPR018743', NULL, 'Protein of unknown function DUF2292', 'DUF2292', 4, NULL),
(18272, NULL, 'IPR023945', NULL, 'N-acetylmannosamine kinase, bacterial', 'ManNAc_kinase_bac', 4, NULL),
(18273, NULL, 'IPR021445', NULL, 'Protein of unknown function DUF3095', 'DUF3095', 4, NULL),
(18274, NULL, 'IPR019949', NULL, 'Luciferase family oxidoreductase, group 1', 'Luciferase_OxRdatse_group-1', 4, NULL),
(18275, NULL, 'IPR019196', NULL, 'ABC-type uncharacterised transport system', 'ABC_transp_unknown', 3, NULL),
(18276, NULL, 'IPR019494', NULL, 'FIST, C-domain', 'FIST_C', 3, NULL),
(18277, NULL, 'IPR018755', NULL, 'Bacteriophage Mu-like, Gp48', 'Phage_Mu_Gp48', 4, NULL),
(18278, NULL, 'IPR021349', NULL, 'Protein of unknown function DUF2967', 'DUF2967', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(18279, NULL, 'IPR021405', NULL, 'Bacteriophage T4, Gp30.1', 'Phage_T4_Gp30.1', 4, NULL),
(18280, NULL, 'IPR019931', NULL, 'LPXTG cell wall anchor domain', 'LPXTG_anchor', 3, NULL),
(18281, NULL, 'IPR019177', NULL, 'Golgin subfamily A member 5', 'Golgin_subfamily_A_member_5', 4, NULL),
(18282, NULL, 'IPR017380', NULL, 'Histone acetyltransferase type B, catalytic subunit', 'Hist_AcTrfase_B-typ_cat-su', 4, NULL),
(18283, NULL, 'IPR019180', NULL, 'Oxidoreductase-like, N-terminal', 'Oxidoreductase-like_N', 3, NULL),
(18284, NULL, 'IPR019845', NULL, 'Squalene/phytoene synthase, conserved site', 'Squalene/phytoene_synthase_CS', 2, NULL),
(18285, NULL, 'IPR017433', NULL, 'Dystrophin-related protein 2', 'Dystrophin-related_2', 4, NULL),
(18286, NULL, 'IPR019951', NULL, 'F420-dependent oxidoreductase-predicted, Rv3520c', 'F420_OxRdatse_Rv3520c_pred', 4, NULL),
(18287, NULL, 'IPR023355', NULL, 'Myotoxin/Anemone neurotoxin domain superfamily', 'Myo_ane_neurotoxin_sf', 5, NULL),
(18288, NULL, 'IPR034239', NULL, 'Metallocarboxypeptidase Z, carboxypeptidase domain', 'M14_CPZ_CPD', 3, NULL),
(18289, NULL, 'IPR021345', NULL, 'Protein of unknown function DUF2961', 'DUF2961', 4, NULL),
(18290, NULL, 'IPR019178', NULL, 'Phosphatidylinositol 4,5-bisphosphate 4-phosphatase', 'PtdIns-P2-Ptase', 4, NULL),
(18291, NULL, 'IPR021410', NULL, 'The fantastic four family', 'FAF', 4, NULL),
(18292, NULL, 'IPR021335', NULL, 'Protein of unknown function DUF2948', 'DUF2948', 4, NULL),
(18293, NULL, 'IPR021351', NULL, 'Protein of unknown function DUF2969', 'DUF2969', 4, NULL),
(18294, NULL, 'IPR021364', NULL, 'Protein of unknown function DUF2857', 'DUF2857', 4, NULL),
(18295, NULL, 'IPR018738', NULL, 'Protein of unknown function DUF2280', 'DUF2280', 4, NULL),
(18296, NULL, 'IPR018758', NULL, 'Membrane iron-sulfur containing protein FtrD-like', 'FtrD-like', 3, NULL),
(18297, NULL, 'IPR018735', NULL, 'Protein of unknown function DUF2277', 'DUF2277', 4, NULL),
(18298, NULL, 'IPR019941', NULL, 'Transcription regulator LuxR, chaperone HchA-associated', 'Tscrpt_reg_LuxR_HchA-assoc', 4, NULL),
(18299, NULL, 'IPR019174', NULL, 'NADH dehydrogenase 1, beta subcomplex, subunit 6', 'NADH_DH_b-subcmplx_su6', 4, NULL),
(18300, NULL, 'IPR021450', NULL, 'Protein of unknown function DUF3100', 'DUF3100', 4, NULL),
(18301, NULL, 'IPR023902', NULL, 'Sporulation delaying protein SdpA', 'Sporulation_SdpA', 4, NULL),
(18302, NULL, 'IPR015676', NULL, 'Tob1/2', 'Tob1/2', 4, NULL),
(18303, NULL, 'IPR019936', NULL, 'Mutatrotase, YjhT-like', 'Mutatrotase_YjhT-like', 4, NULL),
(18304, NULL, 'IPR018730', NULL, 'Protein of unknown function DUF2273', 'DUF2273', 4, NULL),
(18305, NULL, 'IPR021338', NULL, 'Protein of unknown function DUF2953', 'DUF2953', 4, NULL),
(18306, NULL, 'IPR021366', NULL, 'Protein of unknown function DUF2981', 'DUF2981', 4, NULL),
(18307, NULL, 'IPR018765', NULL, 'Domain of unknown function DUF2341', 'DUF2341', 3, NULL),
(18308, NULL, 'IPR019188', NULL, 'snRNA-activating protein complex subunit 1', 'SNAPC1', 4, NULL),
(18309, NULL, 'IPR017423', NULL, 'tRNA (adenine(58)-N(1))-methyltransferase non-catalytic subunit TRM6', 'TRM6', 4, NULL),
(18310, NULL, 'IPR014717', NULL, 'Translation elongation factor EF1B/ribosomal protein S6', 'Transl_elong_EF1B/ribosomal_S6', 5, NULL),
(18311, NULL, 'IPR021414', NULL, 'Protein of unknown function DUF3054', 'DUF3054', 4, NULL),
(18312, NULL, 'IPR021107', NULL, 'Restriction endonuclease, type II, HinP1I', 'Restrct_endonuc_II_HinP1I', 4, NULL),
(18313, NULL, 'IPR019835', NULL, 'SWIB domain', 'SWIB_domain', 3, NULL),
(18314, NULL, 'IPR019182', NULL, 'Cytochrome b-c1 complex subunit 10, fungi', 'Cytochrome_b-c1_su10_fun', 4, NULL),
(18315, NULL, 'IPR021386', NULL, 'SPP41, DUF3020', 'SPP41_DUF3020', 3, NULL),
(18316, NULL, 'IPR017734', NULL, 'Type VI secretion system, lipoprotein SciN', 'T6SS_SciN', 4, NULL),
(18317, NULL, 'IPR021382', NULL, 'Protein of unknown function DUF3014', 'DUF3014', 4, NULL),
(18318, NULL, 'IPR021419', NULL, 'Mediator of RNA polymerase II transcription subunit 25, von Willebrand factor type A domain', 'Mediator_Med25_VWA', 3, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(18319, NULL, 'IPR035213', NULL, 'Protein of unknown function DUF5321', 'DUF5321', 4, NULL),
(18320, NULL, 'IPR017737', NULL, 'Type VI secretion system protein TssE1-like', 'TssE1-like', 4, NULL),
(18321, NULL, 'IPR023895', NULL, 'Thiazolylpeptide-type bacteriocin precursor', 'Thiopep_bacteriocin_prcur', 4, NULL),
(18322, NULL, 'IPR021456', NULL, 'Protein of unknown function DUF3107', 'DUF3107', 4, NULL),
(18323, NULL, 'IPR021468', NULL, 'Protein of unknown function DUF3120', 'DUF3120', 4, NULL),
(18324, NULL, 'IPR018750', NULL, 'Protein of unknown function DUF2306, membrane', 'DUF2306_membrane', 4, NULL),
(18325, NULL, 'IPR021477', NULL, 'Type VII secretion effector, SACOL2603 family', 'TVIIS_effector_SACOL2603_fam', 4, NULL),
(18326, NULL, 'IPR018775', NULL, 'RNA repair pathway DNA polymerase beta', 'RlaP', 4, NULL),
(18327, NULL, 'IPR021381', NULL, 'Protein of unknown function DUF3011', 'DUF3011', 4, NULL),
(18328, NULL, 'IPR021363', NULL, 'Protein of unknown function DUF2835', 'DUF2835', 4, NULL),
(18329, NULL, 'IPR017419', NULL, 'Mitogen-activated protein kinase kinase kinase 12/13', 'MAP3K12_MAP3K13', 4, NULL),
(18330, NULL, 'IPR021343', NULL, 'Protein of unknown function DUF2960', 'DUF2960', 4, NULL),
(18331, NULL, 'IPR021374', NULL, 'Protein of unknown function DUF2996', 'DUF2996', 4, NULL),
(18332, NULL, 'IPR017733', NULL, 'Type VI secretion system peptidoglycan-associated domain', 'OmpA/MotB_dom', 3, NULL),
(18333, NULL, 'IPR019933', NULL, 'DivIVA domain', 'DivIVA_domain', 3, NULL),
(18334, NULL, 'IPR035211', NULL, 'Protein of unknown function DUF5325', 'DUF5325', 4, NULL),
(18335, NULL, 'IPR019952', NULL, 'F420-dependent oxidoreductase-predicted, Rv1855c', 'F420_OxRdatse_Rv1855c_pred', 4, NULL),
(18336, NULL, 'IPR014716', NULL, 'Fibrinogen, alpha/beta/gamma chain, C-terminal globular, subdomain 1', 'Fibrinogen_a/b/g_C_1', 5, NULL),
(18337, NULL, 'IPR018733', NULL, 'Protein of unknown function DUF2274', 'DUF2274', 4, NULL),
(18338, NULL, 'IPR017416', NULL, 'Chaperonin Cpn20', 'Cpn20', 4, NULL),
(18339, NULL, 'IPR019935', NULL, 'Conserved hypothetical protein CHP03546', 'CHP03546', 4, NULL),
(18340, NULL, 'IPR017727', NULL, '2-hydroxy-6-oxo-6-phenylhexa-2,4-dienoate hydrolase, BphD', 'HOPD_hydrolase_BphD', 4, NULL),
(18341, NULL, 'IPR019181', NULL, 'LSM12, anticodon-binding domain', 'LSM12_ABD', 3, NULL),
(18342, NULL, 'IPR019945', NULL, 'F420-dependent glucose-6-phosphate dehydrogenase-related', 'F420_G6P_DH-rel', 4, NULL),
(18343, NULL, 'IPR019946', NULL, '5,10-methylenetetrahydromethanopterin reductase', 'MeH4methanopterin_reductase', 4, NULL),
(18344, NULL, 'IPR019953', NULL, 'Organic hydroperoxide resistance protein famiy', 'OHR', 4, NULL),
(18345, NULL, 'IPR021417', NULL, 'Protein of unknown function DUF3060', 'DUF3060', 4, NULL),
(18346, NULL, 'IPR019511', NULL, 'A-kinase anchor protein 7, RI-RII subunit-binding domain', 'AKAP7_RI-RII-bd_dom', 3, NULL),
(18347, NULL, 'IPR021466', NULL, 'Putative rhamnosyl transferase', 'Put_rhamnosyl_transferase', 4, NULL),
(18348, NULL, 'IPR032676', NULL, 'Putative L,D-transpeptidase tautomerase', 'YkuD_2', 4, NULL),
(18349, NULL, 'IPR017378', NULL, 'Torsin 1/2', 'Torsin_1/2', 4, NULL),
(18350, NULL, 'IPR017429', NULL, 'Suppressor of fused, bacterial', 'Suppressor_of_fused_bac', 4, NULL),
(18351, NULL, 'IPR019944', NULL, 'F420-dependent glucose-6-phosphate dehydrogenase', 'F420-dep_G6P_DH', 4, NULL),
(18352, NULL, 'IPR019832', NULL, 'Manganese/iron superoxide dismutase, C-terminal', 'Mn/Fe_SOD_C', 3, NULL),
(18353, NULL, 'IPR019509', NULL, 'Carboxypeptidase inhibitor I68', 'Carboxypeptidase_inhibitor_I68', 4, NULL),
(18354, NULL, 'IPR018771', NULL, 'PocR domain', 'PocR_dom', 3, NULL),
(18355, NULL, 'IPR032484', NULL, 'Protein of unknown function DUF5052', 'DUF5052', 4, NULL),
(18356, NULL, 'IPR017432', NULL, 'Distrobrevin', 'Distrobrevin', 4, NULL),
(18357, NULL, 'IPR021435', NULL, 'Protein of unknown function DUF3084', 'DUF3084', 4, NULL),
(18358, NULL, 'IPR021350', NULL, 'Protein of unknown function DUF2968', 'DUF2968', 4, NULL),
(18359, NULL, 'IPR021479', NULL, '30K viral movement protein, C-terminal', '30K_MP_C', 3, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(18360, NULL, 'IPR023915', NULL, 'UDP-GlcNAc diphosphorylase/GlcNAc-1-P N-acetyltransferase, GlmU, archaeal-type', 'Bifunctiontional_GlmU_arc-type', 4, NULL),
(18361, NULL, 'IPR023889', NULL, 'TOMM system kinase/cyclase fusion protein', 'TOMM_kin_cyc', 4, NULL),
(18362, NULL, 'IPR019905', NULL, 'Peroxiredoxin OsmC-like protein, Firmicutes', 'OsmC-like_firmicutes', 4, NULL),
(18363, NULL, 'IPR019489', NULL, 'Clp ATPase, C-terminal', 'Clp_ATPase_C', 3, NULL),
(18364, NULL, 'IPR023191', NULL, 'Deoxynucleotide monophosphate kinase, N-terminal', 'DNMP_kinase_N', 5, NULL),
(18365, NULL, 'IPR019491', NULL, 'Lipoate protein ligase, C-terminal', 'Lipoate_protein_ligase_C', 3, NULL),
(18366, NULL, 'IPR017915', NULL, 'Colipase, conserved site', 'Colipase_CS', 2, NULL),
(18367, NULL, 'IPR017385', NULL, 'ATPase, V0 complex, subunit e1/e2, metazoa', 'ATPase_V0-cplx_e1/e2_su_met', 4, NULL),
(18368, NULL, 'IPR021442', NULL, 'Protein of unknown function DUF3091', 'DUF3091', 4, NULL),
(18369, NULL, 'IPR019194', NULL, 'Transcription elongation factor  Eaf, N-terminal', 'Tscrpt_elong_fac_Eaf_N', 3, NULL),
(18370, NULL, 'IPR017399', NULL, 'WD repeat protein DCAF11/LEC14B', 'DCAF11/LEC14B', 4, NULL),
(18371, NULL, 'IPR021379', NULL, 'Protein of unknown function DUF3012', 'DUF3012', 4, NULL),
(18372, NULL, 'IPR019886', NULL, 'Sodium symporter small subunit, predicted', 'Na_symporter_ssu_prd', 3, NULL),
(18373, NULL, 'IPR021401', NULL, 'Protein of unknown function DUF3040', 'DUF3040', 4, NULL),
(18374, NULL, 'IPR018760', NULL, 'Protein of unknown function DUF2326', 'DUF2326', 3, NULL),
(18375, NULL, 'IPR019882', NULL, 'Conserved hypothetical protein CHP03643', 'CHP03643', 4, NULL),
(18376, NULL, 'IPR017913', NULL, 'Colipase, N-terminal', 'Colipase_N', 3, NULL),
(18377, NULL, 'IPR018752', NULL, 'Probable inorganic carbon transporter subunit DabA', 'DabA', 4, NULL),
(18378, NULL, 'IPR018763', NULL, 'Protein of unknown function DUF2334', 'DUF2334', 4, NULL),
(18379, NULL, 'IPR019490', NULL, 'Bifunctional glucose-6-phosphate/mannose-6-phosphate isomerase, C-terminal', 'Glu6P/Mann6P_isomerase_C', 3, NULL),
(18380, NULL, 'IPR017390', NULL, 'Ubiquitinyl hydrolase, UCH37 type', 'Ubiquitinyl_hydrolase_UCH37', 4, NULL),
(18381, NULL, 'IPR018745', NULL, 'Na+-translocating membrane potential-generating system MpsC', 'MpsC', 3, NULL),
(18382, NULL, 'IPR034571', NULL, 'Protein APEM9', 'APEM9', 4, NULL),
(18383, NULL, 'IPR023871', NULL, 'Mycofactocin precursor peptide peptidase', 'MftE', 4, NULL),
(18384, NULL, 'IPR017937', NULL, 'Thioredoxin, conserved site', 'Thioredoxin_CS', 2, NULL),
(18385, NULL, 'IPR019932', NULL, 'Conserved hypothetical protein CHP03543', 'CHP03543', 4, NULL),
(18386, NULL, 'IPR019170', NULL, 'Meckelin', 'Meckelin', 4, NULL),
(18387, NULL, 'IPR017881', NULL, 'Nitrite reductase (NADH) small subunit', 'NirD', 4, NULL),
(18388, NULL, 'IPR019518', NULL, 'DNA endonuclease Ctp1, N-terminal', 'CtIP_N', 3, NULL),
(18389, NULL, 'IPR019495', NULL, 'Exosome complex component CSL4, C-terminal', 'EXOSC1_C', 3, NULL),
(18390, NULL, 'IPR023868', NULL, '7-carboxy-7-deazaguanine synthase, Clostridial form', '7-CO-7-deazaGua_synth_put_Clo', 4, NULL),
(18391, NULL, 'IPR033985', NULL, 'SusD-like, N-terminal', 'SusD-like_N', 3, NULL),
(18392, NULL, 'IPR019514', NULL, 'Syndetin, C-terminal', 'Syndetin_C', 3, NULL),
(18393, NULL, 'IPR034570', NULL, 'Photosynthetic NDH subunit of subcomplex B 4, chloroplastic', 'PNSB4', 4, NULL),
(18394, NULL, 'IPR019879', NULL, 'Ammonium transporter, marine subtype', 'Ammonium_transptr_marine', 4, NULL),
(18395, NULL, 'IPR019517', NULL, 'Integrin binding protein, ICAP-1', 'Integrin-bd_ICAP-1', 4, NULL),
(18396, NULL, 'IPR021380', NULL, 'Protein of unknown function DUF3013', 'DUF3013', 4, NULL),
(18397, NULL, 'IPR019940', NULL, 'CofH family', 'CofH_family', 4, NULL),
(18398, NULL, 'IPR017404', NULL, 'Ladinin 1', 'Ladinin_1', 4, NULL),
(18399, NULL, 'IPR023993', NULL, 'S-adenosyl-L-methionine-dependent tRNA 4-demethylwyosine synthase,  archaea', 'TYW1_archaea', 4, NULL),
(18400, NULL, 'IPR019156', NULL, 'Ataxin-10 domain', 'Ataxin-10_domain', 3, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(18401, NULL, 'IPR017414', NULL, 'LOB domain-containing protein', 'LOBD', 4, NULL),
(18402, NULL, 'IPR021385', NULL, 'Protein of unknown function DUF3017', 'DUF3017', 4, NULL),
(18403, NULL, 'IPR021373', NULL, 'Protein of unknown function DUF2993', 'DUF2993', 4, NULL),
(18404, NULL, 'IPR021453', NULL, 'Protein of unknown function DUF3104', 'DUF3104', 4, NULL),
(18405, NULL, 'IPR019910', NULL, 'Luciferase-like, F420-dependent oxidoreductase, MSMEG4879, predicted', 'Lucif-like_OxRdtase_MSMEG_4879', 4, NULL),
(18406, NULL, 'IPR017738', NULL, 'Type VI secretion system-associated, VCA0118', 'T6SS-assoc_VCA0118', 4, NULL),
(18407, NULL, 'IPR021481', NULL, 'Protein of unknown function DUF3134', 'DUF3134', 4, NULL),
(18408, NULL, 'IPR018747', NULL, 'Protein of unknown function DUF2299', 'DUF2299', 4, NULL),
(18409, NULL, 'IPR021475', NULL, 'Protein of unknown function DUF3128', 'DUF3128', 4, NULL),
(18410, NULL, 'IPR019934', NULL, 'Conserved hypothetical protein CHP03545', 'CHP03545', 4, NULL),
(18411, NULL, 'IPR019506', NULL, 'Peptidase inhibitor, PinA', 'Pept-inhibitor_PinA', 4, NULL),
(18412, NULL, 'IPR019169', NULL, 'Transmembrane protein 26', 'Transmembrane_26', 4, NULL),
(18413, NULL, 'IPR023992', NULL, 'Pre-heme d1 synthase NirJ', 'HemeD1_Synth_NirJ', 4, NULL),
(18414, NULL, 'IPR017401', NULL, 'Protein phosphatase 1 regulatory subunit 12A/B/C', 'MYPT1/MYPT2/Mbs85', 4, NULL),
(18415, NULL, 'IPR019504', NULL, 'Peptidase U49, Lit peptidase', 'Peptidase_U49_Lit_pept', 4, NULL),
(18416, NULL, 'IPR021106', NULL, 'Protein Ste5, Fus3-binding domain', 'Ste5_Fus3-bd_dom', 3, NULL),
(18417, NULL, 'IPR019883', NULL, 'Lactoylglutathione lyase', 'Lactoylglutathione_lyase', 4, NULL),
(18418, NULL, 'IPR019153', NULL, 'DDRGK domain containing protein', 'DDRGK_dom-contain', 4, NULL),
(18419, NULL, 'IPR021416', NULL, 'Protein of unknown function DUF3048, N-terminal', 'DUF3048_N', 3, NULL),
(18420, NULL, 'IPR021459', NULL, 'Glycosyl hydrolases related to GH101 family, GHL1-GHL3', 'GH101-related', 4, NULL),
(18421, NULL, 'IPR023321', NULL, 'PINIT domain', 'PINIT', 3, NULL),
(18422, NULL, 'IPR021376', NULL, 'Protein of unknown function DUF2999', 'DUF2999', 4, NULL),
(18423, NULL, 'IPR019172', NULL, 'Osteopetrosis-associated transmembrane protein 1 precursor', 'Osteopetrosis-assoc_TM_1', 4, NULL),
(18424, NULL, 'IPR017392', NULL, 'AP2/ERF transcription factor ERF/PTI6', 'AP2/ERF-transcript_factor', 4, NULL),
(18425, NULL, 'IPR017417', NULL, 'Protein phosphatase 1, regulatory subunit 16A/B', 'Pase-1_reg_su_16AB', 4, NULL),
(18426, NULL, 'IPR019189', NULL, 'Ribosomal protein L27/L41, mitochondrial', 'Ribosomal_L27/L41_mit', 4, NULL),
(18427, NULL, 'IPR017722', NULL, 'Phosphonate utilization transcriptional regulator PhnR', 'Tscrpt_reg_PhnR', 4, NULL),
(18428, NULL, 'IPR019501', NULL, 'Peptidase M30, hyicolysin', 'Peptidase_M30_hyicolysin', 4, NULL),
(18429, NULL, 'IPR021422', NULL, 'Protein of unknown function DUF3069', 'DUF3069', 4, NULL),
(18430, NULL, 'IPR021476', NULL, 'Egh16-like virulence factor', 'Egh16-like', 4, NULL),
(18431, NULL, 'IPR018740', NULL, 'Protein of unknown function DUF2282, integral membrane', 'DUF2282_membr', 4, NULL),
(18432, NULL, 'IPR015890', NULL, 'Chorismate-utilising enzyme, C-terminal', 'Chorismate_C', 3, NULL),
(18433, NULL, 'IPR021404', NULL, 'Bacteriophage T4, Gp24.3', 'Phage_T4_Gp24.3', 4, NULL),
(18434, NULL, 'IPR021455', NULL, 'Protein of unknown function DUF3106', 'DUF3106', 4, NULL),
(18435, NULL, 'IPR019159', NULL, 'CCDC93, coiled-coil domain', 'CCDC93_CC', 3, NULL),
(18436, NULL, 'IPR018739', NULL, 'Domain of unknown function DUF2281', 'DUF2281', 3, NULL),
(18437, NULL, 'IPR019166', NULL, 'MICOS complex subunit MIC26/MIC27', 'MIC26/MIC27', 4, NULL),
(18438, NULL, 'IPR019844', NULL, 'Cold-shock (CSD) domain', 'CSD_1', 3, NULL),
(18439, NULL, 'IPR032479', NULL, 'Protein of unknown function DUF5058', 'DUF5058', 4, NULL),
(18440, NULL, 'IPR019487', NULL, 'RAM signalling pathway, SOG2', 'RAM_signalling_pathway_SOG2', 4, NULL),
(18441, NULL, 'IPR021448', NULL, 'Protein of unknown function DUF3098', 'DUF3098', 4, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(18442, NULL, 'IPR019503', NULL, 'Peptidase M66 domain', 'Peptidase_M66_dom', 3, NULL),
(18443, NULL, 'IPR032482', NULL, 'Protein of unknown function DUF5054', 'DUF5054', 4, NULL),
(18444, NULL, 'IPR021372', NULL, 'Protein of unknown function DUF2989', 'DUF2989', 4, NULL),
(18445, NULL, 'IPR018736', NULL, 'Protein of unknown function DUF2279, periplasmic lipoprotein', 'DUF2279_periplasmic_lipo', 4, NULL),
(18446, NULL, 'IPR017389', NULL, 'Nucleoporin, NUP53', 'Nucleoporin_NUP53', 4, NULL),
(18447, NULL, 'IPR017428', NULL, 'Interleukin-1 receptor-associated kinase 4', 'IRAK4', 4, NULL),
(18448, NULL, 'IPR021387', NULL, 'Protein of unknown function DUF3023', 'DUF3023', 4, NULL),
(18449, NULL, 'IPR021390', NULL, 'Protein of unknown function DUF3025', 'DUF3025', 4, NULL),
(18450, NULL, 'IPR019513', NULL, 'Centromere protein Cenp-F, leucine-rich repeat-containing domain', 'Centromere_CenpF_leu-rich_rpt', 3, NULL),
(18451, NULL, 'IPR021408', NULL, 'Protein of unknown function DUF3046', 'DUF3046', 4, NULL),
(18452, NULL, 'IPR021420', NULL, 'Protein of unknown function DUF3067', 'DUF3067', 4, NULL),
(18453, NULL, 'IPR021355', NULL, 'Bacteriophage Syn9, Gp224', 'Phage_Syn9_Gp224', 4, NULL),
(18454, NULL, 'IPR021418', NULL, 'THO complex, subunitTHOC2, C-terminal', 'THO_THOC2_C', 3, NULL),
(18455, NULL, 'IPR023203', NULL, 'TTHA0068-like superfamily', 'TTHA0068_sf', 5, NULL),
(18456, NULL, 'IPR021362', NULL, 'Protein of unknown function DUF2834', 'DUF2834', 4, NULL),
(18457, NULL, 'IPR019198', NULL, 'Beta propeller domain-containing family', 'Beta_propeller_containing', 4, NULL),
(18458, NULL, 'IPR021433', NULL, 'Protein of unknown function DUF3083', 'DUF3083', 4, NULL),
(18459, NULL, 'IPR021478', NULL, 'Protein of unknown function DUF3131', 'DUF3131', 4, NULL),
(18460, NULL, 'IPR021344', NULL, 'Protein of unknown function DUF2970', 'DUF2970', 4, NULL),
(18461, NULL, 'IPR021438', NULL, 'Protein of unknown function DUF3087', 'DUF3087', 4, NULL),
(18462, NULL, 'IPR017422', NULL, 'WD repeat protein 55', 'WDR55', 4, NULL),
(18463, NULL, 'IPR035424', NULL, 'Antitoxin of toxin-antitoxin, RelE/RelB, TA system', 'Antitoxin_RelB', 4, NULL),
(18464, NULL, 'IPR021341', NULL, 'Protein of unknown function DUF2958', 'DUF2958', 4, NULL),
(18465, NULL, 'IPR023916', NULL, 'Colanic acid biosynthesis, glycosyl transferase, WcaC', 'Colanic_acid_synth_WcaC', 4, NULL),
(18466, NULL, 'IPR019505', NULL, 'Peptidase U40', 'Peptidase_U40', 4, NULL),
(18467, NULL, 'IPR019904', NULL, 'Peroxiredoxin OsmC', 'Peroxiredoxin_OsmC', 4, NULL),
(18468, NULL, 'IPR023994', NULL, '[NiFe]-hydrogenase assembly, chaperone, HybE', 'NiFe-hyd_HybE', 4, NULL),
(18469, NULL, 'IPR018742', NULL, 'Protein of unknown function DUF2290', 'DUF2290', 4, NULL),
(18470, NULL, 'IPR017403', NULL, 'Podocalyxin', 'PODXL', 4, NULL),
(18471, NULL, 'IPR021369', NULL, 'Protein of unknown function DUF2985', 'DUF2985', 4, NULL),
(18472, NULL, 'IPR023917', NULL, 'UDP-GlcNAc diphosphorylase/GlcNAc-1-P N-acetyltransferase, GlmU, bacterial-type', 'Bifunctiontional_GlmU_bac-type', 4, NULL),
(18473, NULL, 'IPR018764', NULL, 'Anti-sigma K factor RskA', 'Anti-sigma_K_RskA', 4, NULL),
(18474, NULL, 'IPR034203', NULL, 'RBM45, RNA recognition motif 1', 'RBM45_RRM1', 3, NULL),
(18475, NULL, 'IPR021460', NULL, 'Protein of unknown function DUF3112', 'DUF3112', 4, NULL),
(18476, NULL, 'IPR021465', NULL, 'Protein of unknown function DUF3117', 'DUF3117', 4, NULL),
(18477, NULL, 'IPR035973', NULL, 'Cytochrome c oxidase subunit III-like superfamily', 'Cyt_c_oxidase_su3-like_sf', 5, NULL),
(18478, NULL, 'IPR032478', NULL, 'Staufen, C-terminal', 'Staufen_C', 3, NULL),
(18479, NULL, 'IPR018768', NULL, 'Domain of unknown function DUF2344', 'DUF2344', 3, NULL),
(18480, NULL, 'IPR017735', NULL, 'Type VI secretion system, FHA domain-containing protein', 'T6SS_FHA', 4, NULL),
(18481, NULL, 'IPR019510', NULL, 'Protein kinase A anchor protein, nuclear localisation signal domain', 'Kinase-A_anchor_nucl_local_sig', 3, NULL),
(18482, NULL, 'IPR023356', NULL, 'Leucyl-tRNA synthetase, domain 3', 'Leu-tRNA-synth_dom3', 3, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(18483, NULL, 'IPR017723', NULL, 'Transcription regulator, 2-aminoethylphosphonate utilisation-associated', 'Tscrpt_reg_AEP_util-assoc', 4, NULL),
(18484, NULL, 'IPR017742', NULL, '7-carboxy-7-deazaguanine synthase', 'Deazaguanine_synth', 4, NULL),
(18485, NULL, 'IPR019488', NULL, 'Nuclear pore RNA shuttling protein Mtr2', 'Nucl_pore_RNA_shuttling_Mtr2', 4, NULL),
(18486, NULL, 'IPR017421', NULL, 'Mitogen-activated protein (MAP) kinase kinase kinase 7', 'MAPKKK7', 4, NULL),
(18487, NULL, 'IPR021346', NULL, 'Translation machinery-associated protein 16', 'Tma16', 4, NULL),
(18488, NULL, 'IPR021403', NULL, 'Protein of unknown function DUF3043', 'DUF3043', 4, NULL),
(18489, NULL, 'IPR021458', NULL, 'Protein of unknown function DUF3109', 'DUF3109', 4, NULL),
(18490, NULL, 'IPR021421', NULL, 'Protein of unknown function DUF3071', 'DUF3071', 4, NULL),
(18491, NULL, 'IPR021361', NULL, 'Protein of unknown function DUF2829', 'DUF2829', 4, NULL),
(18492, NULL, 'IPR019493', NULL, 'Bacteriocin, class IIb, lactacin-related', 'Bacteriocin_IIb_lactacin-rel', 4, NULL),
(18493, NULL, 'IPR019145', NULL, 'Mediator complex, subunit Med10', 'Mediator_Med10', 4, NULL),
(18494, NULL, 'IPR021383', NULL, 'Protein of unknown function DUF3015', 'DUF3015', 4, NULL),
(18495, NULL, 'IPR023892', NULL, 'Cyclic nucleotide-binding domain protein', 'cNMP-bd', 4, NULL),
(18496, NULL, 'IPR021484', NULL, 'Protein of unknown function DUF3137', 'DUF3137', 4, NULL),
(18497, NULL, 'IPR021399', NULL, 'Protein of unknown function DUF3038', 'DUF3038', 4, NULL),
(18498, NULL, 'IPR019155', NULL, 'CLEC16A/TT9, N-terminal', 'CLEC16A/TT9_N', 3, NULL),
(18499, NULL, 'IPR023907', NULL, 'Non-F420 flavinoid oxidoreductase', 'Non-F420_Flavin_OxRdtase', 4, NULL),
(18500, NULL, 'IPR021105', NULL, 'Potassium channel, voltage dependent, Kv3, inactivation domain', 'K_chnl_volt-dep_Kv3_ID', 3, NULL),
(18501, NULL, 'IPR017448', NULL, 'SRCR-like domain', 'SRCR-like_dom', 3, NULL),
(18502, NULL, 'IPR021636', NULL, 'Protein of unknown function DUF3242', 'DUF3242', 4, NULL),
(18503, NULL, 'IPR017864', NULL, 'Arrestin, conserved site', 'Arrestin_CS', 2, NULL),
(18504, NULL, 'IPR013106', NULL, 'Immunoglobulin V-set domain', 'Ig_V-set', 3, NULL),
(18505, NULL, 'IPR023574', NULL, 'Ribosomal protein L4 domain superfamily', 'Ribosomal_L4_dom_sf', 5, NULL),
(18506, NULL, 'IPR021539', NULL, 'Bacteriocin subtilosin A', 'Subtilosin_A', 4, NULL),
(18507, NULL, 'IPR020462', NULL, 'Interleukin-11B, fish', 'IL-11B_fish', 4, NULL),
(18508, NULL, 'IPR034990', NULL, 'hnRNPM, RNA recognition motif 3', 'hnRNPM_RRM3', 3, NULL),
(18509, NULL, 'IPR021640', NULL, 'Mediator complex, subunit Med28', 'Mediator_Med28', 4, NULL),
(18510, NULL, 'IPR021525', NULL, 'Protein of unknown function DUF3189', 'DUF3189', 4, NULL),
(18511, NULL, 'IPR017927', NULL, 'FAD-binding domain, ferredoxin reductase-type', 'FAD-bd_FR_type', 3, NULL),
(18512, NULL, 'IPR021547', NULL, 'Protein of unknown function DUF2826', 'DUF2826', 4, NULL),
(18513, NULL, 'IPR017862', NULL, 'SKI-interacting protein, SKIP', 'SKI-int_prot_SKIP', 4, NULL),
(18514, NULL, 'IPR021558', NULL, 'Antitoxin MazE-like', 'MazE-like', 4, NULL),
(18515, NULL, 'IPR013105', NULL, 'Tetratricopeptide repeat 2', 'TPR_2', 7, NULL),
(18516, NULL, 'IPR013121', NULL, 'Ferric reductase, NAD binding domain', 'Fe_red_NAD-bd_6', 3, NULL),
(18517, NULL, 'IPR017456', NULL, 'CTP synthase, N-terminal', 'CTP_synthase_N', 3, NULL),
(18518, NULL, 'IPR024078', NULL, 'Putative deacetylase LmbE-like domain superfamily', 'LmbE-like_dom_sf', 5, NULL),
(18519, NULL, 'IPR017760', NULL, 'L-ascorbate oxidase, plants', 'L-ascorbate_oxidase_pln', 4, NULL),
(18520, NULL, 'IPR021608', NULL, 'Melampsora lini avirulence protein AvrL567', 'AvrL567', 4, NULL),
(18521, NULL, 'IPR013353', NULL, 'Type III secretion system chaperone YscB', 'T3SS_YscB', 4, NULL),
(18522, NULL, 'IPR034983', NULL, 'hnRPLL, RNA recognition motif 3', 'hnRPLL_RRM3', 3, NULL),
(18523, NULL, 'IPR021598', NULL, 'Protein of unknown function DUF3221', 'DUF3221', 4, NULL),
(18524, NULL, 'IPR034987', NULL, 'hnRPLL, RNA recognition motif 4', 'hnRPLL_RRM4', 3, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(18525, NULL, 'IPR017016', NULL, 'Uncharacterised conserved protein UCP033595', 'UCP033595', 4, NULL),
(18526, NULL, 'IPR017002', NULL, 'Glycoside hydrolase, family 57, Saci1162, predicted', 'Glyco_hydro_57_Saci1162_prd', 4, NULL),
(18527, NULL, 'IPR034985', NULL, 'hnRPLL, RNA recognition motif 1', 'hnRPLL_RRM1', 3, NULL),
(18528, NULL, 'IPR035915', NULL, 'Plakin repeat superfamily', 'Plakin_repeat_sf', 5, NULL),
(18529, NULL, 'IPR021628', NULL, 'Protein of unknown function DUF3234', 'DUF3234', 4, NULL),
(18530, NULL, 'IPR024862', NULL, 'Transient receptor potential cation channel subfamily V', 'TRPV', 4, NULL),
(18531, NULL, 'IPR021536', NULL, 'DNA ligase IV domain', 'DNA_ligase_IV_dom', 3, NULL),
(18532, NULL, 'IPR021613', NULL, 'Protein-tyrosine phosphatase receptor IA-2 ectodomain', 'Receptor_IA-2_dom', 3, NULL),
(18533, NULL, 'IPR021578', NULL, 'Protein of unknown function DUF3211', 'DUF3211', 4, NULL),
(18534, NULL, 'IPR020829', NULL, 'Glyceraldehyde 3-phosphate dehydrogenase, catalytic domain', 'GlycerAld_3-P_DH_cat', 3, NULL),
(18535, NULL, 'IPR013358', NULL, 'Pilus biogenesis, MshL', 'Pilus_biogenesis_MshL', 4, NULL),
(18536, NULL, 'IPR021649', NULL, 'Protein of unknown function DUF3247', 'DUF3247', 4, NULL),
(18537, NULL, 'IPR021653', NULL, 'CCR4-associated factor 4', 'Caf4', 4, NULL),
(18538, NULL, 'IPR021607', NULL, 'Protein of unknown function DUF3224', 'DUF3224', 4, NULL),
(18539, NULL, 'IPR017028', NULL, 'Uncharacterised conserved protein UCP034456', 'UCP034456', 4, NULL),
(18540, NULL, 'IPR021562', NULL, 'Protein of unknown function DUF3007', 'DUF3007', 4, NULL),
(18541, NULL, 'IPR021543', NULL, 'Programmed cell death activator EGL-1', 'EGL-1', 4, NULL),
(18542, NULL, 'IPR017749', NULL, 'Gamma-aminobutyraldehyde dehydrogenase', 'PatD', 4, NULL),
(18543, NULL, 'IPR016994', NULL, 'Uncharacterised conserved protein UCP032370, VraC', 'UCP032370_VraC', 4, NULL),
(18544, NULL, 'IPR021627', NULL, 'Mediator complex, subunit Med27', 'Mediator_Med27', 4, NULL),
(18545, NULL, 'IPR020069', NULL, 'Ribosomal protein L9, C-terminal', 'Ribosomal_L9_C', 3, NULL),
(18546, NULL, 'IPR017919', NULL, 'Transcription factor TFE/TFIIEalpha HTH domain', 'TFIIE/TFIIEa_HTH', 3, NULL),
(18547, NULL, 'IPR013350', NULL, 'Ribonucleotide reductase alpha chain', 'RNR_alpha', 4, NULL),
(18548, NULL, 'IPR017040', NULL, 'Uncharacterised conserved protein UCP035918 , rubrerythrin/DUF125-related', 'UCP035918_rubreryth/DUF125', 4, NULL),
(18549, NULL, 'IPR016991', NULL, 'Protein of unknown function UCP032178', 'UCP032178', 4, NULL),
(18550, NULL, 'IPR021534', NULL, 'Protein of unknown function DUF3192', 'DUF3192', 4, NULL),
(18551, NULL, 'IPR017014', NULL, 'Fimbrial-like protein YadC', 'Fimbrial-like_YadC', 4, NULL),
(18552, NULL, 'IPR023573', NULL, 'Ribosomal protein 50S-L18Ae/60S-L20/60S-L18A', 'Ribosomal_L18a//L18Ae/LX', 3, NULL),
(18553, NULL, 'IPR024854', NULL, 'Kinectin', 'Kinectin', 4, NULL),
(18554, NULL, 'IPR013359', NULL, 'Pilus formation type IVB, outer membrane PilN', 'Pilus_4B_PilN', 4, NULL),
(18555, NULL, 'IPR021521', NULL, 'Protein of unknown function DUF3185', 'DUF3185', 4, NULL),
(18556, NULL, 'IPR020408', NULL, 'Nerve growth factor-like', 'Nerve_growth_factor-like', 4, NULL),
(18557, NULL, 'IPR014721', NULL, 'Ribosomal protein S5 domain 2-type fold, subgroup', 'Ribosomal_S5_D2-typ_fold_subgr', 5, NULL),
(18558, NULL, 'IPR017452', NULL, 'GPCR, rhodopsin-like, 7TM', 'GPCR_Rhodpsn_7TM', 3, NULL),
(18559, NULL, 'IPR017865', NULL, 'F-actin capping protein, alpha subunit, conserved site', 'F-actin_cap_asu_CS', 2, NULL),
(18560, NULL, 'IPR021492', NULL, 'Protein of unknown function DUF3146', 'DUF3146', 4, NULL),
(18561, NULL, 'IPR021494', NULL, 'Protein of unknown function DUF3149', 'DUF3149', 4, NULL),
(18562, NULL, 'IPR017771', NULL, 'Cyanamide hydratase', 'Cyanamide_hydratase_HD', 4, NULL),
(18563, NULL, 'IPR021570', NULL, 'LamB-type porin N-terminal domain', 'LamB-type_porin_N_dom', 3, NULL),
(18564, NULL, 'IPR017031', NULL, 'Predicted S-adenosyl-L-methionine dependent methyltransferase, YjhP-type', 'Pre_MeTrfase_YjhP', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(18565, NULL, 'IPR013010', NULL, 'Zinc finger, SIAH-type', 'Znf_SIAH', 3, NULL),
(18566, NULL, 'IPR021655', NULL, 'Putative metal-binding motif', 'Put_metal-bd', 7, NULL),
(18567, NULL, 'IPR021629', NULL, 'Mediator complex, subunit Med23', 'Mediator_Med23', 4, NULL),
(18568, NULL, 'IPR017764', NULL, 'Indole-3-pyruvate decarboxylase, Enterobacteriaceae', 'IPDC_Enterobacteriaceae', 4, NULL),
(18569, NULL, 'IPR021663', NULL, 'T-cell surface glycoprotein CD3 zeta subunit/High affinity IgE receptor gamma subunit', 'CD3_zeta/IgE_Fc_rcpt_gamma', 4, NULL),
(18570, NULL, 'IPR021495', NULL, 'Protein CHLORORESPIRATORY REDUCTION 42-like', 'CRR42-like', 4, NULL),
(18571, NULL, 'IPR021503', NULL, 'Protein of unknown function DUF3110', 'DUF3110', 4, NULL),
(18572, NULL, 'IPR021537', NULL, 'Hypoxia-inducible factor, alpha subunit-like', 'HIF_alpha-like', 3, NULL),
(18573, NULL, 'IPR021605', NULL, 'Subunit of cleavage factor IA Pcf11, C-terminal', 'CFIA_Pcf11_C', 3, NULL),
(18574, NULL, 'IPR013118', NULL, 'Mannitol dehydrogenase, C-terminal', 'Mannitol_DH_C', 3, NULL),
(18575, NULL, 'IPR020421', NULL, 'Interleukin-19', 'IL-19', 4, NULL),
(18576, NULL, 'IPR017747', NULL, 'Putrescine aminotransferase', 'Putrescine_aminotransferase', 4, NULL),
(18577, NULL, 'IPR034721', NULL, 'Bacterial renalase', 'Bac_renal', 4, NULL),
(18578, NULL, 'IPR021656', NULL, 'RPGR-interacting protein 1, first C2 domain', 'C2-C2_1', 3, NULL),
(18579, NULL, 'IPR013115', NULL, 'Histidine biosynthesis HisG, C-terminal', 'HisG_C', 3, NULL),
(18580, NULL, 'IPR034646', NULL, 'ADCK3-like domain', 'ADCK3_dom', 3, NULL),
(18581, NULL, 'IPR024045', NULL, 'NusG, domain 2', 'NusG_dom2', 3, NULL),
(18582, NULL, 'IPR013360', NULL, 'Pilus biogenesis/stability type IV, PilW', 'Pilus_4_PilW', 4, NULL),
(18583, NULL, 'IPR021518', NULL, 'Protein of unknown function DUF3181', 'DUF3181', 4, NULL),
(18584, NULL, 'IPR020103', NULL, 'Pseudouridine synthase, catalytic domain superfamily', 'PsdUridine_synth_cat_dom_sf', 5, NULL),
(18585, NULL, 'IPR024075', NULL, 'DNA-directed RNA polymerase, helix hairpin domain superfamily', 'DNA-dir_RNA_pol_helix_hairp_sf', 5, NULL),
(18586, NULL, 'IPR021589', NULL, 'Spindle pole body-associated protein cut12', 'Cut12', 3, NULL),
(18587, NULL, 'IPR021677', NULL, 'Protein of unknown function DUF2986', 'DUF2986', 4, NULL),
(18588, NULL, 'IPR017009', NULL, 'Uncharacterised conserved protein UCP032840', 'UCP032840', 4, NULL),
(18589, NULL, 'IPR021499', NULL, 'Protein of unknown function DUF3153', 'DUF3153', 4, NULL),
(18590, NULL, 'IPR020827', NULL, 'Asparaginase/glutaminase, active site 1', 'Asparaginase/glutaminase_AS1', 0, NULL),
(18591, NULL, 'IPR013366', NULL, 'Ethanolamine utilisation EutJ', 'EutJ', 4, NULL),
(18592, NULL, 'IPR021498', NULL, 'Protein of unknown function DUF3155', 'DUF3155', 4, NULL),
(18593, NULL, 'IPR020422', NULL, 'Dual specificity protein phosphatase domain', 'TYR_PHOSPHATASE_DUAL_dom', 3, NULL),
(18594, NULL, 'IPR020142', NULL, 'Protein of unknown function DUF5489', 'DUF5489', 4, NULL),
(18595, NULL, 'IPR020212', NULL, 'ESX secretion system protein YueC', 'YueC', 4, NULL),
(18596, NULL, 'IPR017755', NULL, 'N-carbamoylputrescine amidase', 'N-carbamoylputrescine_amidase', 4, NULL),
(18597, NULL, 'IPR021632', NULL, 'Protein of unknown function DUF3239', 'DUF3239', 4, NULL),
(18598, NULL, 'IPR021583', NULL, 'Protein of unknown function DUF3213', 'DUF3213', 4, NULL),
(18599, NULL, 'IPR013346', NULL, 'Ribonucleotide reductase, class I , alpha subunit', 'NrdE_NrdA', 3, NULL),
(18600, NULL, 'IPR035166', NULL, 'Protein of unknown function DUF5336', 'DUF5336', 4, NULL),
(18601, NULL, 'IPR021540', NULL, 'Protein of unknown function DUF3195', 'DUF3195', 4, NULL),
(18602, NULL, 'IPR013335', NULL, 'Trp repressor, bacterial', 'Trp_repress_bac', 4, NULL),
(18603, NULL, 'IPR017017', NULL, 'Uncharacterised conserved protein UCP033622, transglutaminase-like, CPE1922', 'UCP033622_transglutaminase', 4, NULL),
(18604, NULL, 'IPR020565', NULL, 'Imidazoleglycerol-phosphate dehydratase, conserved site', 'ImidazoleglycerP_deHydtase_CS', 2, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(18605, NULL, 'IPR017038', NULL, 'Uncharacterised conserved protein UCP035609, HNH endonuclease-type', 'UCP035609_HNH_endonucl', 4, NULL),
(18606, NULL, 'IPR017768', NULL, 'Acid phosphatase, AcpA', 'AcpA', 4, NULL),
(18607, NULL, 'IPR020405', NULL, 'Atypical dual specificity phosphatase, subfamily A', 'Atypical_DUSP_subfamA', 4, NULL),
(18608, NULL, 'IPR020411', NULL, 'Tumour necrosis factor receptor 1B', 'TNFR_1B', 4, NULL),
(18609, NULL, 'IPR021551', NULL, 'Protein of unknown function DUF3005', 'DUF3005', 4, NULL),
(18610, NULL, 'IPR021576', NULL, 'Protein of unknown function DUF3208', 'DUF3208', 4, NULL),
(18611, NULL, 'IPR021522', NULL, 'Copper transporter MctB', 'MctB', 4, NULL),
(18612, NULL, 'IPR013810', NULL, 'Ribosomal protein S5, N-terminal', 'Ribosomal_S5_N', 3, NULL),
(18613, NULL, 'IPR035169', NULL, 'Protein of unknown function DUF5318', 'DUF5318', 4, NULL),
(18614, NULL, 'IPR021549', NULL, 'Protein of unknown function DUF2894', 'DUF2894', 4, NULL),
(18615, NULL, 'IPR035342', NULL, 'Phage gene product 45.2', 'Gp45.2', 4, NULL),
(18616, NULL, 'IPR017006', NULL, 'Uncharacterised conserved protein UCP032756', 'UCP032756', 4, NULL),
(18617, NULL, 'IPR013111', NULL, 'EGF-like domain, extracellular', 'EGF_extracell', 3, NULL),
(18618, NULL, 'IPR021573', NULL, 'Leader peptide, picornavirus', 'Leader_pept_picornaV', 4, NULL),
(18619, NULL, 'IPR021612', NULL, 'Staphylococcal complement inhibitor SCIN', 'SCIN', 4, NULL),
(18620, NULL, 'IPR014722', NULL, 'Ribosomal protein L2, domain 2', 'Rib_L2_dom2', 5, NULL),
(18621, NULL, 'IPR017000', NULL, 'Membrane-anchored ubiquitin-fold protein', 'MUB', 4, NULL),
(18622, NULL, 'IPR017025', NULL, 'Cancer-associated antigen RCAS1', 'Cancer-assoc_antigen_RCAS1', 4, NULL),
(18623, NULL, 'IPR021596', NULL, 'Protein of unknown function DUF3219', 'DUF3219', 4, NULL),
(18624, NULL, 'IPR021597', NULL, 'Protein of unknown function DUF3220', 'DUF3220', 4, NULL),
(18625, NULL, 'IPR017021', NULL, 'Uncharacterised conserved protein UCP033763', 'UCP033763', 4, NULL),
(18626, NULL, 'IPR021618', NULL, 'Protein of unknown function DUF3232', 'DUF3232', 4, NULL),
(18627, NULL, 'IPR018124', NULL, 'Calreticulin/calnexin, conserved site', 'Calret/calnex_CS', 2, NULL),
(18628, NULL, 'IPR017756', NULL, 'Transmembrane Gly-Cys-Arg, conserved site', 'TM_Gly-Cys-Arg_CS', 2, NULL),
(18629, NULL, 'IPR017004', NULL, 'Uncharacterised conserved protein UCP032676, PqqC', 'UCP032676_PqqC', 4, NULL),
(18630, NULL, 'IPR020420', NULL, 'Atypical dual specificity phosphatase, subfamily B', 'Atypical_DUSP_subfamB', 4, NULL),
(18631, NULL, 'IPR013370', NULL, 'Muconate/chloromuconate cycloisomerase', 'Chloromuconate_cycloisomerase', 4, NULL),
(18632, NULL, 'IPR021635', NULL, 'Proteinaceous host-selective toxin ToxA', 'Toxin_ToxA', 4, NULL),
(18633, NULL, 'IPR018151', NULL, 'Transcription elongation factor, GreA/GreB, conserved site', 'TF_GreA/GreB_CS', 2, NULL),
(18634, NULL, 'IPR017451', NULL, 'F-box associated interaction domain', 'F-box-assoc_interact_dom', 3, NULL),
(18635, NULL, 'IPR017866', NULL, 'Succinyl-CoA synthetase, beta subunit, conserved site', 'Succ-CoA_synthase_bsu_CS', 2, NULL),
(18636, NULL, 'IPR021552', NULL, 'Putative, 10TM heavy-metal exporter', 'ArsP_2', 4, NULL),
(18637, NULL, 'IPR024097', NULL, 'Basic helix-loop-helix leucine zipper transcription factor', 'bHLH_ZIP_TF', 4, NULL),
(18638, NULL, 'IPR013116', NULL, 'Ketol-acid reductoisomerase, N-terminal', 'KARI_N', 3, NULL),
(18639, NULL, 'IPR014053', NULL, 'Formylmethanofuran: tetrahydromethanopterin formyltransferase Ftr', 'ForMFR_H4MPT_ForTrfase', 4, NULL),
(18640, NULL, 'IPR013094', NULL, 'Alpha/beta hydrolase fold-3', 'AB_hydrolase_3', 3, NULL),
(18641, NULL, 'IPR021579', NULL, 'Protein of unknown function DUF3212', 'DUF3212', 4, NULL),
(18642, NULL, 'IPR021622', NULL, 'Afadin/alpha-actinin-binding', 'Afadin/alpha-actinin-bd', 4, NULL),
(18643, NULL, 'IPR021674', NULL, 'Bacteriophage T4, Gp14, neck protein', 'Phage_T4_Gp14_neck-protein', 4, NULL),
(18644, NULL, 'IPR021560', NULL, 'Protein of unknown function DUF3021', 'DUF3021', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(18645, NULL, 'IPR013362', NULL, 'Pilus modification type IV, PilV', 'Pilus_4_PilV', 4, NULL),
(18646, NULL, 'IPR021658', NULL, 'Domain of unknown function DUF3251', 'DUF3251', 3, NULL),
(18647, NULL, 'IPR021524', NULL, 'Protein of unknown function DUF3188', 'DUF3188', 4, NULL),
(18648, NULL, 'IPR020575', NULL, 'Heat shock protein Hsp90, N-terminal', 'Hsp90_N', 3, NULL),
(18649, NULL, 'IPR020563', NULL, 'Crossover junction endodeoxyribonuclease RuvC, magnesium-binding site', 'X-over_junc_endoDNase_Mg_BS', 1, NULL),
(18650, NULL, 'IPR020125', NULL, 'Protein of unknown function DUF5488', 'DUF5488', 4, NULL),
(18651, NULL, 'IPR013103', NULL, 'Reverse transcriptase, RNA-dependent DNA polymerase', 'RVT_2', 3, NULL),
(18652, NULL, 'IPR013013', NULL, 'Phosphotransferase system, EIIC component, type 1', 'PTS_EIIC_1', 3, NULL),
(18653, NULL, 'IPR034675', NULL, 'Protein kinase B gamma, catalytic domain', 'Akt3', 3, NULL),
(18654, NULL, 'IPR020128', NULL, 'Secapin', 'Secapin', 4, NULL),
(18655, NULL, 'IPR021666', NULL, 'Troponin I residues 1-32', 'Troponin-I_N', 4, NULL),
(18656, NULL, 'IPR021545', NULL, 'Type III secretion system filament chaperone CesA', 'CesA', 4, NULL),
(18657, NULL, 'IPR021508', NULL, 'Tail completion protein', 'Gp17-like', 4, NULL),
(18658, NULL, 'IPR016996', NULL, 'Uncharacterised conserved protein UCP032441', 'UCP032441', 4, NULL),
(18659, NULL, 'IPR021624', NULL, 'Single-strand annealing weakened protein 1', 'Saw1', 4, NULL),
(18660, NULL, 'IPR035344', NULL, 'Phage gene product 52', 'Gp52', 4, NULL),
(18661, NULL, 'IPR017003', NULL, 'Uncharacterised conserved protein UCP032675', 'UCP032675', 4, NULL),
(18662, NULL, 'IPR017746', NULL, 'Cellulose synthase operon protein BcsQ', 'Cellulose_synthase_operon_BcsQ', 4, NULL),
(18663, NULL, 'IPR017748', NULL, 'T6S-associated protein TagF', 'TagF', 4, NULL),
(18664, NULL, 'IPR021672', NULL, 'Protein of unknown function DUF3258', 'DUF3258', 4, NULL),
(18665, NULL, 'IPR024072', NULL, 'Dihydrofolate reductase-like domain superfamily', 'DHFR-like_dom_sf', 5, NULL),
(18666, NULL, 'IPR021654', NULL, 'Histone-lysine N-methyltransferase EZH1/EZH2', 'EZH1/EZH2', 4, NULL),
(18667, NULL, 'IPR017022', NULL, 'Uncharacterised conserved protein UCP033860', 'UCP033860', 4, NULL),
(18668, NULL, 'IPR016995', NULL, 'Dimeric dUTPase Dut-like', 'Dimeric_Dut-like', 4, NULL),
(18669, NULL, 'IPR021582', NULL, 'Altered inheritance of mitochondria protein 21', 'Aim21', 4, NULL),
(18670, NULL, 'IPR021497', NULL, 'Holin of 3TMs, for gene-transfer release', 'GTA_holin_3TM', 4, NULL),
(18671, NULL, 'IPR017035', NULL, 'Uncharacterised conserved protein UCP035009, HsdR, All3000-type', 'UCP035009_HsdR_All3000-type', 4, NULL),
(18672, NULL, 'IPR013112', NULL, 'FAD-binding 8', 'FAD-bd_8', 3, NULL),
(18673, NULL, 'IPR035168', NULL, 'Protein of unknown function DUF5317', 'DUF5317', 4, NULL),
(18674, NULL, 'IPR017015', NULL, 'Uncharacterised conserved protein UCP033367, VanZ, Bll3170', 'UCP033367_VanZ', 4, NULL),
(18675, NULL, 'IPR020126', NULL, 'Protein of unknown function DUF2732', 'DUF2732', 4, NULL),
(18676, NULL, 'IPR020139', NULL, 'Protein of unknown function DUF2642', 'DUF2642', 4, NULL),
(18677, NULL, 'IPR020213', NULL, 'Toxin coregulated pilus biosynthesis protein TcpS', 'Toxin-coreg_pilus_synth_TcpS', 4, NULL),
(18678, NULL, 'IPR017001', NULL, 'Peptidase S53, physarolisin II, archaeal-type', 'Pept_S53_physarolisin-II_arc', 4, NULL),
(18679, NULL, 'IPR021664', NULL, 'Protein of unknown function DUF3255', 'DUF3255', 4, NULL),
(18680, NULL, 'IPR017019', NULL, 'Predicted DNA replication protein, bacterial', 'DNA_replication_prd_bac', 4, NULL),
(18681, NULL, 'IPR021610', NULL, 'Protein of unknown function DUF3228', 'DUF3228', 4, NULL),
(18682, NULL, 'IPR020567', NULL, 'Nodulation protein A, NodA, conserved site', 'Nodulation_prot_NodA_CS', 2, NULL),
(18683, NULL, 'IPR035214', NULL, 'Protein of unknown function DUF5324', 'DUF5324', 4, NULL),
(18684, NULL, 'IPR013006', NULL, 'Antimicrobial peptide, C6 type, conserved site', 'Antimicrobial_C6_CS', 2, NULL),
(18685, NULL, 'IPR021671', NULL, 'PD(D/E)XK endonuclease', 'PD(D/E)XK_Endonuc', 3, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(18686, NULL, 'IPR013364', NULL, 'ATPase, plasmid transfer, TraJ', 'ATPase_plasmid-transfer_TraJ', 4, NULL),
(18687, NULL, 'IPR013012', NULL, 'Phosphotransferase system, EIIB component, type 3', 'PTS_EIIB_3', 3, NULL),
(18688, NULL, 'IPR017773', NULL, 'Cysteine desulfurase NifS, proteobacteria', 'Cys_deSase_NifS_proteobacteria', 4, NULL),
(18689, NULL, 'IPR021609', NULL, 'Nitrosopumilus output domain 5', 'NitrOD5', 3, NULL),
(18690, NULL, 'IPR021533', NULL, 'Putative beta-lactamase-inhibitor-like, PepSY-like', 'PepSY-like', 3, NULL),
(18691, NULL, 'IPR013096', NULL, 'Cupin 2, conserved barrel', 'Cupin_2', 3, NULL),
(18692, NULL, 'IPR013351', NULL, 'Type III secretion system effector delivery regulator TyeA-related', 'T3SS_TyeA-rel', 3, NULL),
(18693, NULL, 'IPR020566', NULL, 'Histidine biosynthesis bifunctional protein HisB', 'His_synth_bifunc_HisB', 4, NULL),
(18694, NULL, 'IPR021567', NULL, 'Lens epithelium-derived growth factor, integrase-binding domain', 'LEDGF_IBD', 3, NULL),
(18695, NULL, 'IPR017449', NULL, 'Prolyl-tRNA synthetase, class II', 'Pro-tRNA_synth_II', 5, NULL),
(18696, NULL, 'IPR021587', NULL, 'Transcription activator LAG-3', 'Transcription_activator_LAG-3', 4, NULL),
(18697, NULL, 'IPR020070', NULL, 'Ribosomal protein L9, N-terminal', 'Ribosomal_L9_N', 3, NULL),
(18698, NULL, 'IPR023258', NULL, 'Placentin', 'Placentin', 4, NULL),
(18699, NULL, 'IPR017750', NULL, 'ATPase, type I secretion system', 'ATPase_T1SS', 4, NULL),
(18700, NULL, 'IPR021575', NULL, 'RNA silencing suppressor P21, C-terminal', 'Suppressor_P21_C', 3, NULL),
(18701, NULL, 'IPR013099', NULL, 'Potassium channel domain', 'K_chnl_dom', 3, NULL),
(18702, NULL, 'IPR021611', NULL, 'Spindle pole body component Spc42', 'Spc42', 4, NULL),
(18703, NULL, 'IPR021662', NULL, 'Heterogeneous nuclear ribonucleoprotein A1/A2, C-terminal', 'HnRNPA1/A2_C', 3, NULL),
(18704, NULL, 'IPR020140', NULL, 'Uncharacterised protein family YusG', 'Uncharacterised_YusG', 4, NULL),
(18705, NULL, 'IPR021670', NULL, 'Protein of unknown function DUF3256', 'DUF3256', 4, NULL),
(18706, NULL, 'IPR013124', NULL, 'Gap junction alpha-1 protein (Cx43), C-terminal', 'Connexin43_C', 3, NULL),
(18707, NULL, 'IPR017743', NULL, 'Alcohol dehydrogenase, phosphonate catabolism-associated, putative', 'ADH_phosphonate_catab-assoc', 4, NULL),
(18708, NULL, 'IPR021561', NULL, 'Transcriptional regulator, AbiEi 3 antitoxin, Type IV TA system', 'AbiEi_3', 4, NULL),
(18709, NULL, 'IPR017020', NULL, 'Uncharacterised conserved protein UCP033725', 'UCP033725', 4, NULL),
(18710, NULL, 'IPR021515', NULL, 'Protein of unknown function DUF3177', 'DUF3177', 4, NULL),
(18711, NULL, 'IPR020206', NULL, 'Uncharacterised protein family, VP2110', 'Uncharacterised_VP2110', 4, NULL),
(18712, NULL, 'IPR017772', NULL, 'Cysteine desulfurase NifS, bacterial/archaeal', 'Cys_deSase_NifS_bac/arc', 4, NULL),
(18713, NULL, 'IPR021648', NULL, 'Vacuolar protein sorting protein 36, GLUE domain', 'GLUE_dom', 3, NULL),
(18714, NULL, 'IPR017762', NULL, 'Multicopper oxidase, fungi', 'Multicopper_oxidase_fun', 4, NULL),
(18715, NULL, 'IPR017440', NULL, 'ATP-citrate lyase/succinyl-CoA ligase, active site', 'Cit_synth/succinyl-CoA_lig_AS', 0, NULL),
(18716, NULL, 'IPR020828', NULL, 'Glyceraldehyde 3-phosphate dehydrogenase, NAD(P) binding domain', 'GlycerAld_3-P_DH_NAD(P)-bd', 3, NULL),
(18717, NULL, 'IPR017753', NULL, 'Glycerol-3-phosphate dehydrogenase, GlpC subunit', 'G3P_DH_GlpC_su', 4, NULL),
(18718, NULL, 'IPR021542', NULL, 'Tn7 transposition regulator TnsC', 'Tn7_TnsC', 4, NULL),
(18719, NULL, 'IPR020536', NULL, 'Thil, AANH domain', 'ThiI_AANH', 3, NULL),
(18720, NULL, 'IPR017765', NULL, 'Indole-3-pyruvate decarboxylase', 'IPDC', 4, NULL),
(18721, NULL, 'IPR016998', NULL, 'HTH-type transcriptional regulator Rot', 'Rot', 4, NULL),
(18722, NULL, 'IPR021599', NULL, 'Protein of unknown function DUF3222', 'DUF3222', 4, NULL),
(18723, NULL, 'IPR013372', NULL, 'Ethanolamine utilization, putative', 'Eut_put', 4, NULL),
(18724, NULL, 'IPR020208', NULL, 'Protein of unknown function DUF2712', 'DUF2712', 4, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(18725, NULL, 'IPR035912', NULL, 'Enhancer of rudimentary superfamily', 'EHR_sf', 5, NULL),
(18726, NULL, 'IPR014718', NULL, 'Glycoside hydrolase-type carbohydrate-binding', 'GH-type_carb-bd', 5, NULL),
(18727, NULL, 'IPR035104', NULL, 'Ribosomal protein S1-like', 'Ribosomal_protein_S1-like', 4, NULL),
(18728, NULL, 'IPR013113', NULL, 'FAD-binding 9, siderophore-interacting', 'FAD-bd_9_SIP', 3, NULL),
(18729, NULL, 'IPR021496', NULL, 'Protein of unknown function DUF3150', 'DUF3150', 4, NULL),
(18730, NULL, 'IPR017036', NULL, 'Uncharacterised conserved protein UCP035040, CBS-type', 'UCP035040_CBS', 4, NULL),
(18731, NULL, 'IPR021676', NULL, 'Protein of unknown function DUF3262', 'DUF3262', 4, NULL),
(18732, NULL, 'IPR013120', NULL, 'Fatty acyl-coenzyme A reductase, NAD-binding domain', 'Far_NAD-bd', 3, NULL),
(18733, NULL, 'IPR013979', NULL, 'Translation initiation factor, beta propellor-like domain', 'TIF_beta_prop-like', 3, NULL),
(18734, NULL, 'IPR021593', NULL, 'Protein of unknown function DUF3218', 'DUF3218', 4, NULL),
(18735, NULL, 'IPR021650', NULL, 'Protein of unknown function DUF3248', 'DUF3248', 4, NULL),
(18736, NULL, 'IPR035331', NULL, 'Clostridial binary toxin B/anthrax toxin PA, domain 3', 'Binary_toxB_3', 3, NULL),
(18737, NULL, 'IPR017011', NULL, 'Uncharacterised conserved protein UCP032888', 'UCP032888', 4, NULL),
(18738, NULL, 'IPR021489', NULL, 'Protein of unknown function DUF3143', 'DUF3143', 4, NULL),
(18739, NULL, 'IPR020830', NULL, 'Glyceraldehyde 3-phosphate dehydrogenase, active site', 'GlycerAld_3-P_DH_AS', 0, NULL),
(18740, NULL, 'IPR021667', NULL, 'REDY-like protein HapK', 'HapK', 4, NULL),
(18741, NULL, 'IPR021527', NULL, 'Protein of unknown function DUF2795', 'DUF2795', 4, NULL),
(18742, NULL, 'IPR024082', NULL, 'Proline dehydrogenase PutA, domain II', 'PRODH_PutA_dom_II', 3, NULL),
(18743, NULL, 'IPR013126', NULL, 'Heat shock protein 70 family', 'Hsp_70_fam', 4, NULL),
(18744, NULL, 'IPR021621', NULL, 'Solitary outer membrane autotransporter beta-barrel domain', 'Omp_AT', 3, NULL),
(18745, NULL, 'IPR020442', NULL, 'Interleukin-20', 'IL-20', 4, NULL),
(18746, NULL, 'IPR021630', NULL, 'Resuscitation-promoting factor Rpf1, C-terminal', 'Rpf1_C', 3, NULL),
(18747, NULL, 'IPR017926', NULL, 'Glutamine amidotransferase', 'GATASE', 3, NULL),
(18748, NULL, 'IPR017013', NULL, 'Archaeal Cdc45', 'Arc_Cdc45', 4, NULL),
(18749, NULL, 'IPR017766', NULL, 'Sphingomyelinase C/phospholipase C', 'Sphingomyelinase/PLipase_C', 4, NULL),
(18750, NULL, 'IPR021642', NULL, 'Protein of unknown function DUF3246', 'DUF3246', 4, NULL),
(18751, NULL, 'IPR021633', NULL, 'Antagonist of EGFR signalling, Argos', 'Argos', 4, NULL),
(18752, NULL, 'IPR021548', NULL, 'Protein of unknown function DUF2895', 'DUF2895', 4, NULL),
(18753, NULL, 'IPR024745', NULL, 'Glycoside hydrolase, family 44', 'Glyco_hydro_44', 3, NULL),
(18754, NULL, 'IPR017763', NULL, 'Cysteine desulfurase, sulphur acceptor subunit CsdE', 'Cysteine_desulfurase_CsdE', 4, NULL),
(18755, NULL, 'IPR021523', NULL, 'Protein of unknown function DUF3187', 'DUF3187', 4, NULL),
(18756, NULL, 'IPR021660', NULL, 'Protein of unknown function DUF3253', 'DUF3253', 4, NULL),
(18757, NULL, 'IPR013123', NULL, 'RNA 2-O ribose methyltransferase, substrate binding', 'SpoU_subst-bd', 3, NULL),
(18758, NULL, 'IPR021620', NULL, 'Erythrocyte binding antigen 175, C-terminal', 'EBA-175_C', 3, NULL),
(18759, NULL, 'IPR021625', NULL, 'PI31 proteasome regulator,  N-terminal', 'PI31_Prot_N', 3, NULL),
(18760, NULL, 'IPR021657', NULL, 'Immunoglobulin-binding protein Sbi, domain IV', 'IgG-binding_Sbi_dom_IV', 3, NULL),
(18761, NULL, 'IPR016992', NULL, 'Uncharacterised conserved protein UCP032209', 'UCP032209', 4, NULL),
(18762, NULL, 'IPR013363', NULL, 'Dot/Icm secretion system ATPase DotB', 'Dot_Icm_DotB', 4, NULL),
(18763, NULL, 'IPR020461', NULL, 'High affinity nerve growth factor receptor NTRK1', 'NTRK1', 4, NULL),
(18764, NULL, 'IPR021626', NULL, 'Plasmodium falciparum UIS3 membrane protein', 'PfUIS3', 4, NULL),
(18765, NULL, 'IPR034666', NULL, 'Arp2/3 complex subunit 2/4', 'ARPC2/4', 5, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(18766, NULL, 'IPR017436', NULL, 'Cripto-related protein 3', 'Cripto-rel_3', 4, NULL),
(18767, NULL, 'IPR017005', NULL, 'Uncharacterised conserved protein UCP032748', 'UCP032748', 4, NULL),
(18768, NULL, 'IPR021634', NULL, 'Protein of unknown function DUF3240', 'DUF3240', 4, NULL),
(18769, NULL, 'IPR021659', NULL, 'NADH dehydrogenase-like complex, subunit S', 'NdhS', 4, NULL),
(18770, NULL, 'IPR021512', NULL, 'Protein of unknown function DUF3173', 'DUF3173', 4, NULL),
(18771, NULL, 'IPR021529', NULL, 'Protein of unknown function DUF2798', 'DUF2798', 4, NULL),
(18772, NULL, 'IPR021535', NULL, 'Tetrabrachion', 'Tetrabrachion', 4, NULL),
(18773, NULL, 'IPR035077', NULL, 'Phosphoenolpyruvate carboxykinase, C-terminal P-loop domain', 'PEP_carboxykinase_GTP_C', 3, NULL),
(18774, NULL, 'IPR021490', NULL, 'Protein of unknown function DUF3144', 'DUF3144', 4, NULL),
(18775, NULL, 'IPR021530', NULL, 'Protein of unknown function DUF2877', 'DUF2877', 4, NULL),
(18776, NULL, 'IPR013855', NULL, 'Cdc37, N-terminal domain', 'Cdc37_N_dom', 3, NULL),
(18777, NULL, 'IPR021590', NULL, 'NSP1, globular domain, betacoronavirus', 'NSP1_glob_bCoV', 3, NULL),
(18778, NULL, 'IPR020221', NULL, 'Protein of unknown function DUF5505', 'DUF5505', 4, NULL),
(18779, NULL, 'IPR021531', NULL, 'Protein of unknown function DUF2875', 'DUF2875', 4, NULL),
(18780, NULL, 'IPR020574', NULL, 'Ribosomal protein S9, conserved site', 'Ribosomal_S9_CS', 2, NULL),
(18781, NULL, 'IPR023259', NULL, 'Dexamethasone-induced protein', 'Dexamethasone-induced', 4, NULL),
(18782, NULL, 'IPR020097', NULL, 'Pseudouridine synthase I, TruA, alpha/beta domain', 'PsdUridine_synth_TruA_a/b_dom', 3, NULL),
(18783, NULL, 'IPR021568', NULL, 'Ribonuclease III,  archaeal', 'Ribonuclease_III_archaeal', 4, NULL),
(18784, NULL, 'IPR023257', NULL, 'Liver X receptor', 'Liver_X_rcpt', 4, NULL),
(18785, NULL, 'IPR021501', NULL, 'Protein of unknown function DUF3157', 'DUF3157', 4, NULL),
(18786, NULL, 'IPR013354', NULL, 'Type III secretion system needle length determinant, C-terminal domain', 'T3SS_YscP_C', 3, NULL),
(18787, NULL, 'IPR021617', NULL, 'Protein of unknown function DUF3231', 'DUF3231', 4, NULL),
(18788, NULL, 'IPR021520', NULL, 'Stealth protein CR2, conserved region 2', 'Stealth_CR2', 3, NULL),
(18789, NULL, 'IPR024042', NULL, 'TM1646-like domain superfamily', 'TM1646-like_dom_sf', 5, NULL),
(18790, NULL, 'IPR013355', NULL, 'Type IV pilus secretin PilQ', 'Pilus_4_PilQ', 4, NULL),
(18791, NULL, 'IPR013365', NULL, 'Dot/Icm secretion system IcmQ', 'Dot_Icm_IcmQ', 4, NULL),
(18792, NULL, 'IPR013095', NULL, 'Type III secretion system chaperone', 'T3SS_chaperone', 4, NULL),
(18793, NULL, 'IPR034683', NULL, 'Cytidylyltransferase IspD/TarI', 'IspD/TarI', 4, NULL),
(18794, NULL, 'IPR017012', NULL, 'Uncharacterised conserved protein UCP032899, lipoprotein', 'UCP032899', 4, NULL),
(18795, NULL, 'IPR013102', NULL, 'Pyrimidine nucleoside phosphorylase, C-terminal', 'PYNP_C', 3, NULL),
(18796, NULL, 'IPR034689', NULL, 'Endolysin T7 type', 'Endolysin_T7_type', 4, NULL),
(18797, NULL, 'IPR017454', NULL, 'Neuromodulin (GAP-43), C-terminal', 'Neuromodulin_C', 3, NULL),
(18798, NULL, 'IPR017455', NULL, 'Zinc finger, FYVE-related', 'Znf_FYVE-rel', 3, NULL),
(18799, NULL, 'IPR017023', NULL, 'Uncharacterised conserved protein UCP034039', 'UCP034039', 4, NULL),
(18800, NULL, 'IPR021528', NULL, 'Phagosome trafficking protein DotA', 'DotA', 4, NULL),
(18801, NULL, 'IPR021563', NULL, 'Rab interacting lysosomal protein, dimerization domain', 'RILP_dimer', 3, NULL),
(18802, NULL, 'IPR013345', NULL, 'Ribonucleoside-triphosphate reductase, adenosylcobalamin-dependent', 'RTP_Rdtase_AdoCbl-dep', 4, NULL),
(18803, NULL, 'IPR021571', NULL, 'Protein of unknown function DUF3206', 'DUF3206', 4, NULL),
(18804, NULL, 'IPR020067', NULL, 'Frizzled domain', 'Frizzled_dom', 3, NULL),
(18805, NULL, 'IPR020569', NULL, 'Uncharacterised protein family UPF0029, Impact, conserved site', 'UPF0029_Impact_CS', 2, NULL),
(18806, NULL, 'IPR021514', NULL, 'Protein of unknown function DUF3176', 'DUF3176', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(18807, NULL, 'IPR021513', NULL, 'Ralstonia phage RSL1, Orf186', 'Phage_RSL1_Orf186', 4, NULL),
(18808, NULL, 'IPR021646', NULL, 'Sir1, ORC-binding domain', 'Sir1_ORC-binding', 3, NULL),
(18809, NULL, 'IPR024041', NULL, 'Ammonium transporter AmtB-like domain', 'NH4_transpt_AmtB-like_dom', 3, NULL),
(18810, NULL, 'IPR021619', NULL, 'Mig-6 domain', 'Mig-6', 3, NULL),
(18811, NULL, 'IPR021550', NULL, 'Protein of unknown function DUF2897', 'DUF2897', 4, NULL),
(18812, NULL, 'IPR016999', NULL, 'L-serine kinase SbnI-like', 'SbnI-like', 4, NULL),
(18813, NULL, 'IPR013347', NULL, 'Tetrahydromethanopterin S-methyltransferase, F subunit', 'MeTrfase_F_su', 3, NULL),
(18814, NULL, 'IPR024067', NULL, 'Methylmalonyl-CoA mutase small subunit, N-terminal', 'Me-malonyl-CoA_mutase_sm_su_N', 5, NULL),
(18815, NULL, 'IPR024857', NULL, 'Cappuccino', 'Cappuccino', 4, NULL),
(18816, NULL, 'IPR020458', NULL, 'Zinc finger, DksA/TraR C4-type conserved site', 'Znf_DskA_TraR_CS', 2, NULL),
(18817, NULL, 'IPR021603', NULL, 'Selenium-binding protein, archaea', 'SeBP_arc', 4, NULL),
(18818, NULL, 'IPR024076', NULL, 'Rotavirus NSP2, C-terminal', 'Rotavirus_NSP2_C', 5, NULL),
(18819, NULL, 'IPR016993', NULL, 'Predicted glycerophosphotransferase, SA2157 type', 'SA2157_glycerophostrnsf', 4, NULL),
(18820, NULL, 'IPR024033', NULL, 'Uncharacterised domain superfamily, YlbE', 'Uncharacterised_dom_sf_YlbE', 5, NULL),
(18821, NULL, 'IPR035056', NULL, 'MST4, kinase domain', 'STK_MST4', 3, NULL),
(18822, NULL, 'IPR017029', NULL, 'Putative phage head morphogenesis protein', 'Phage_head_put', 4, NULL),
(18823, NULL, 'IPR018126', NULL, 'Small acid-soluble spore protein, alpha/beta-type, conserved site', 'SASP_alpha/beta-type_CS', 2, NULL),
(18824, NULL, 'IPR017751', NULL, 'Glycerol-3-phosphate dehydrogenase, NAD-dependent, eukaryotic', 'G3P_DH_NAD-dep_euk', 4, NULL),
(18825, NULL, 'IPR021586', NULL, 'Transcription regulator TrmB, C-terminal', 'Tscrpt_reg_TrmB_C', 3, NULL),
(18826, NULL, 'IPR017039', NULL, 'Virulence factor BrkB', 'Virul_fac_BrkB', 4, NULL),
(18827, NULL, 'IPR017752', NULL, 'Glycerol-3-phosphate dehydrogenase, GlpA subunit', 'G3P_DH_GlpA_su', 4, NULL),
(18828, NULL, 'IPR021584', NULL, 'Thylakoid soluble phosphoprotein TSP9', 'TSP9', 4, NULL),
(18829, NULL, 'IPR021526', NULL, 'Vitelline envelope, lysin receptor', 'Vitelline_env_lysin-recpt', 4, NULL),
(18830, NULL, 'IPR021553', NULL, 'Protein of unknwon function DUF3008', 'DUF3008', 4, NULL),
(18831, NULL, 'IPR021564', NULL, 'Protein of unknown function DUF3203', 'DUF3203', 4, NULL),
(18832, NULL, 'IPR018116', NULL, 'Somatotropin hormone, conserved site', 'Somatotropin_CS', 2, NULL),
(18833, NULL, 'IPR021519', NULL, 'Protein of unknown function DUF3182', 'DUF3182', 4, NULL),
(18834, NULL, 'IPR021661', NULL, 'TRF2-interacting telomeric protein/Rap1, C-terminal', 'Rap1_C', 3, NULL),
(18835, NULL, 'IPR021643', NULL, 'Mediator complex, subunit Med13, N-terminal', 'Mediator_Med13_N', 3, NULL),
(18836, NULL, 'IPR021638', NULL, 'Protein of unknown function DUF3244', 'DUF3244', 4, NULL),
(18837, NULL, 'IPR021532', NULL, 'Structural accessory protein ORF7b, betacoronavirus', 'NS7B_bCoV', 4, NULL),
(18838, NULL, 'IPR020141', NULL, 'Herpesvirus UL41A', 'Herpesvirus_UL41A', 4, NULL),
(18839, NULL, 'IPR013100', NULL, 'Limonene-1,2-epoxide hydrolase', 'LEH', 3, NULL),
(18840, NULL, 'IPR017848', NULL, 'RNA polymerase sigma factor, RpoD-like, cyanobacteria', 'RNA_pol_sigma_RpoD_cyanobac', 4, NULL),
(18841, NULL, 'IPR013098', NULL, 'Immunoglobulin I-set', 'Ig_I-set', 3, NULL),
(18842, NULL, 'IPR021615', NULL, 'Outer membrane protein Omp28', 'Omp28', 4, NULL),
(18843, NULL, 'IPR017745', NULL, 'Cellulose biosynthesis protein BcsE', 'BcsE', 4, NULL),
(18844, NULL, 'IPR021669', NULL, 'Glycosylphosphatidylinositol-anchored merozoite surface protein', 'Antigen_Bd37', 4, NULL),
(18845, NULL, 'IPR024034', NULL, 'ATPase, F1/V1 complex, beta/alpha subunit, C-terminal', 'ATPase_F1/V1_b/a_C', 5, NULL),
(18846, NULL, 'IPR021591', NULL, 'YNR034W-A/EGO2', 'YNR034W-A/EGO2', 4, NULL),
(18847, NULL, 'IPR024066', NULL, 'RGS, subdomain 1/3', 'RGS_subdom1/3', 5, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(18848, NULL, 'IPR017754', NULL, 'Agmatine deiminase', 'Agmatine_deiminase', 4, NULL),
(18849, NULL, 'IPR035330', NULL, 'Rotavirus VP4, membrane interaction domain', 'Rota_VP4_MID', 3, NULL),
(18850, NULL, 'IPR021493', NULL, 'Protein of unknown function DUF3147', 'DUF3147', 4, NULL),
(18851, NULL, 'IPR017744', NULL, 'Cellulose biosynthesis protein BcsG', 'BcsG', 4, NULL),
(18852, NULL, 'IPR013368', NULL, 'TrpR homologue YerC/YecD', 'YecD_YerC', 4, NULL),
(18853, NULL, 'IPR021487', NULL, 'Protein of unknown function DUF3140', 'DUF3140', 4, NULL),
(18854, NULL, 'IPR017932', NULL, 'Glutamine amidotransferase type 2 domain', 'GATase_2_dom', 3, NULL),
(18855, NULL, 'IPR035223', NULL, 'Protein of unknown function DUF5335', 'DUF5335', 4, NULL),
(18856, NULL, 'IPR020432', NULL, 'Neurotrophin-4', 'Neurotrophin-4', 4, NULL),
(18857, NULL, 'IPR012948', NULL, 'AARP2CN', 'AARP2CN', 3, NULL),
(18858, NULL, 'IPR018117', NULL, 'DNA methylase, C-5 cytosine-specific, active site', 'C5_DNA_meth_AS', 0, NULL),
(18859, NULL, 'IPR017861', NULL, 'Kae1/TsaD family', 'KAE1/TsaD', 4, NULL),
(18860, NULL, 'IPR021502', NULL, 'Protein of unknown function DUF3158', 'DUF3158', 4, NULL),
(18861, NULL, 'IPR021566', NULL, 'Prion-like protein Doppel', 'Doppel', 4, NULL),
(18862, NULL, 'IPR020555', NULL, '2-C-methyl-D-erythritol 2,4-cyclodiphosphate synthase, conserved site', 'MECDP_synthase_CS', 2, NULL),
(18863, NULL, 'IPR021668', NULL, 'Telomere-length maintenance and DNA damage repair', 'TAN', 3, NULL),
(18864, NULL, 'IPR013101', NULL, 'Leucine-rich repeat 2', 'Leu-rich_rpt_2', 7, NULL),
(18865, NULL, 'IPR017007', NULL, 'Uncharacterised conserved protein UCP032762', 'UCP032762', 4, NULL),
(18866, NULL, 'IPR020423', NULL, 'Interleukin-10, conserved site', 'IL-10_CS', 2, NULL),
(18867, NULL, 'IPR021546', NULL, 'Pilot protein MxiM', 'MxiM', 4, NULL),
(18868, NULL, 'IPR034784', NULL, 'PDIP3, RNA recognition motif', 'PDIP3_RRM', 3, NULL),
(18869, NULL, 'IPR013005', NULL, '50S ribosomal protein uL4', 'Ribosomal_uL4/L1e', 4, NULL),
(18870, NULL, 'IPR021569', NULL, 'TUG ubiquitin-like domain', 'TUG-UBL1', 3, NULL),
(18871, NULL, 'IPR013107', NULL, 'Acyl-CoA dehydrogenase, C-terminal domain', 'Acyl-CoA_DH_C', 3, NULL),
(18872, NULL, 'IPR021559', NULL, 'Protein of unknown function DUF3019', 'DUF3019', 4, NULL),
(18873, NULL, 'IPR017435', NULL, 'ESCRT-1 complex, Vps37, fungi', 'ESCRT-1_cplx_Vps37_fungi', 4, NULL),
(18874, NULL, 'IPR017027', NULL, 'STM3548-like', 'STM3548-like', 4, NULL),
(18875, NULL, 'IPR034714', NULL, 'N-acetylglucosaminyldiphosphoundecaprenol N-acetyl-beta-D-mannosaminyltransferase', 'TagA_TarA', 4, NULL),
(18876, NULL, 'IPR021491', NULL, 'Protein of unknown function DUF3145', 'DUF3145', 4, NULL),
(18877, NULL, 'IPR035163', NULL, 'Protochlamydia outer membrane protein', 'Pom', 3, NULL),
(18878, NULL, 'IPR021675', NULL, 'Protein of unknown function DUF3261', 'DUF3261', 4, NULL),
(18879, NULL, 'IPR024035', NULL, 'GNAT N-acetyltransferase, putative', 'GNAT_putative', 4, NULL),
(18880, NULL, 'IPR021651', NULL, 'Scaffold protein Ste5, Fus3-binding domain', 'Ste5_Fus-binding', 3, NULL),
(18881, NULL, 'IPR024036', NULL, 'tRNA-dihydrouridine synthase, putative, C-terminal', 'tRNA-dHydroUridine_Synthase_C', 5, NULL),
(18882, NULL, 'IPR016990', NULL, 'Uncharacterised conserved protein UCP032162, transmembrane', 'UCP032162_TM', 4, NULL),
(18883, NULL, 'IPR021639', NULL, 'DNA polymerase catalytic subunit Pol, C-terminal', 'DNAPolymera_Pol_C', 3, NULL),
(18884, NULL, 'IPR013349', NULL, 'Type III secretion system effector YopR', 'T3SS_YopR', 4, NULL),
(18885, NULL, 'IPR017757', NULL, 'Transcriptional repressor BetI', 'Tscrpt_rep_BetI', 4, NULL),
(18886, NULL, 'IPR021647', NULL, 'Copper binding periplasmic protein CusF', 'CusF_Ec', 4, NULL),
(18887, NULL, 'IPR019846', NULL, 'Nerve growth factor conserved site', 'Nerve_growth_factor_CS', 2, NULL),
(18888, NULL, 'IPR020138', NULL, 'Uncharacterised protein family YqzF', 'Uncharacterised_YqzF', 4, NULL),
(18889, NULL, 'IPR013348', NULL, 'Type III secretion system YscG', 'T3SS_YscG', 4, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(18890, NULL, 'IPR021580', NULL, 'Type II restriction enzyme SfiI', 'Restrct_endonuc_II_SfiI', 4, NULL),
(18891, NULL, 'IPR020413', NULL, 'Tumour necrosis factor receptor 9', 'TNFR_9', 4, NULL),
(18892, NULL, 'IPR020215', NULL, 'EbsA-like', 'EbsA-like', 4, NULL),
(18893, NULL, 'IPR017769', NULL, 'Phospholipase C accessory protein PlcR', 'PLipase_C_acessory_PlcR', 4, NULL),
(18894, NULL, 'IPR020210', NULL, 'Uncharacterised protein family, YpbF, transmembrane', 'Uncharacterised_YpbF_TM', 4, NULL),
(18895, NULL, 'IPR021120', NULL, 'KduI/IolB isomerase', 'KduI/IolB_isomerase', 4, NULL),
(18896, NULL, 'IPR013015', NULL, 'Laminin IV type B', 'Laminin_IV_B', 3, NULL),
(18897, NULL, 'IPR021641', NULL, 'Protein of unknown function DUF3245', 'DUF3245', 4, NULL),
(18898, NULL, 'IPR021538', NULL, 'Syntaxin-5, N-terminal, Sly1p-binding domain', 'Syntaxin-5_N', 3, NULL),
(18899, NULL, 'IPR013114', NULL, 'Beta-hydroxydecanoyl thiol ester dehydrase, FabA/FabZ', 'FabA_FabZ', 4, NULL),
(18900, NULL, 'IPR023315', NULL, 'SynGAP C2 domain, N-terminal', 'SynGAP_C2_N', 5, NULL),
(18901, NULL, 'IPR021614', NULL, 'Protein transport protein SEC31', 'Sec31', 4, NULL),
(18902, NULL, 'IPR021506', NULL, 'Protein of unknown function DUF3165', 'DUF3165', 4, NULL),
(18903, NULL, 'IPR018131', NULL, 'Restriction endonuclease, type II, EcoRI, Proteobacteria', 'Restrct_endonuc_II_EcoRI_Pbac', 4, NULL),
(18904, NULL, 'IPR021488', NULL, 'Protein of unknown function DUF3142', 'DUF3142', 4, NULL),
(18905, NULL, 'IPR017037', NULL, 'Uncharacterised conserved protein UCP035261', 'UCP035261', 4, NULL),
(18906, NULL, 'IPR020556', NULL, 'Amidase, conserved site', 'Amidase_CS', 2, NULL),
(18907, NULL, 'IPR016989', NULL, 'ATP synthase protein I, alphaproteobacterial', 'Atp1_alphaprobac', 4, NULL),
(18908, NULL, 'IPR017030', NULL, 'Virulence effector, SrfC', 'Vir_effector_SfrC', 4, NULL),
(18909, NULL, 'IPR034986', NULL, 'hnRPLL, RNA recognition motif 2', 'hnRPLL_RRM2', 3, NULL),
(18910, NULL, 'IPR021517', NULL, 'Protein of unknown function DUF3180', 'DUF3180', 4, NULL),
(18911, NULL, 'IPR017032', NULL, 'Vi polysaccharide biosynthesis protein TviA', 'TviA', 4, NULL),
(18912, NULL, 'IPR021631', NULL, 'Protein of unknown function DUF3238', 'DUF3238', 4, NULL),
(18913, NULL, 'IPR034988', NULL, 'DAZ/BOULE, RNA recognition motif', 'DAZ_BOULE_RRM', 3, NULL),
(18914, NULL, 'IPR021556', NULL, 'Protein of unknown function DUF2950', 'DUF2950', 4, NULL),
(18915, NULL, 'IPR035165', NULL, 'Protein of unknown function DUF5319', 'DUF5319', 4, NULL),
(18916, NULL, 'IPR018122', NULL, 'Fork head domain conserved site1', 'TF_fork_head_CS_1', 2, NULL),
(18917, NULL, 'IPR017010', NULL, 'Uncharacterised conserved protein UCP032862, iron-sulphur-binding domain-type, SSO0018', 'UCP032862_Fe-S-type', 4, NULL),
(18918, NULL, 'IPR017024', NULL, 'Uncharacterised conserved protein UCP034217', 'UCP034217', 4, NULL),
(18919, NULL, 'IPR021637', NULL, 'Protein of unknown function DUF3243', 'DUF3243', 4, NULL),
(18920, NULL, 'IPR013122', NULL, 'Polycystin cation channel, PKD1/PKD2', 'PKD1_2_channel', 3, NULL),
(18921, NULL, 'IPR017758', NULL, 'Coenzyme A disulphide reductase', 'CoA_disulphide_reductase', 4, NULL),
(18922, NULL, 'IPR021623', NULL, 'Lamina-associated polypeptide 2 alpha, C-terminal', 'LAP2alpha_C', 3, NULL),
(18923, NULL, 'IPR017761', NULL, 'Laccase', 'Laccase', 4, NULL),
(18924, NULL, 'IPR021505', NULL, 'Bacteriophage B3, Orf6', 'Phage_B3_Orf6', 4, NULL),
(18925, NULL, 'IPR020443', NULL, 'Interleukin-10/19/20/22/24/26 family', 'IL-10/19/20/22/24/26_fam', 4, NULL),
(18926, NULL, 'IPR020437', NULL, 'Nerve growth factor, beta subunit, mammalian', 'Nerve_growth_factor_bsu_mml', 4, NULL),
(18927, NULL, 'IPR020209', NULL, 'Cas6b, C-terminal domain', 'Cas6b_C', 3, NULL),
(18928, NULL, 'IPR013356', NULL, 'Type II secretion system protein GspD', 'T2SS_GspD', 4, NULL),
(18929, NULL, 'IPR021600', NULL, 'Transcription factor TFIIE alpha subunit, C-terminal', 'TFIIE_asu_C', 3, NULL),
(18930, NULL, 'IPR021601', NULL, 'Phosphatidylinositol 4-kinase, Pik1, fungi', 'Phosphatidylino_kinase_fungi', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(18931, NULL, 'IPR018120', NULL, 'Glycoside hydrolase family 1, active site', 'Glyco_hydro_1_AS', 0, NULL),
(18932, NULL, 'IPR020465', NULL, 'Tumour necrosis factor receptor 10', 'TNFR_10', 4, NULL),
(18933, NULL, 'IPR023999', NULL, 'Formate transporter FocA', 'Formate_transptr_FocA', 4, NULL),
(18934, NULL, 'IPR017770', NULL, 'RNA 3''-terminal phosphate cyclase type 1', 'RNA3''_term_phos_cyc_type_1', 4, NULL),
(18935, NULL, 'IPR021574', NULL, 'Sialyltransferase PMO188', 'PM0188', 4, NULL),
(18936, NULL, 'IPR020867', NULL, 'Tetrahydrofolate dehydrogenase/cyclohydrolase, conserved site', 'THF_DH/CycHdrlase_CS', 2, NULL),
(18937, NULL, 'IPR035340', NULL, 'Protein of unknown function DUF5425', 'DUF5425', 4, NULL),
(18938, NULL, 'IPR020216', NULL, 'Uncharacterised protein family, YncE', 'Uncharacterised_YncE', 4, NULL),
(18939, NULL, 'IPR021500', NULL, 'Protein of unknown function DUF3156', 'DUF3156', 4, NULL),
(18940, NULL, 'IPR035341', NULL, 'Gene product 63', 'Gp63', 4, NULL),
(18941, NULL, 'IPR034664', NULL, 'Classical protein kinase C beta, catalytic domain', 'cPKC-beta', 3, NULL),
(18942, NULL, 'IPR021577', NULL, 'Protein of unknown function DUF3209', 'DUF3209', 4, NULL),
(18943, NULL, 'IPR013369', NULL, 'Type II secretion system protein GspE', 'T2SS_GspE', 4, NULL),
(18944, NULL, 'IPR013352', NULL, 'Iron hydrogenase, subset', 'Fe_hydrogenase_subset', 3, NULL),
(18945, NULL, 'IPR017026', NULL, 'Inducible mutagenesis protein A', 'ImuA', 4, NULL),
(18946, NULL, 'IPR017008', NULL, 'Uncharacterised conserved protein UCP032817', 'UCP032817', 4, NULL),
(18947, NULL, 'IPR020207', NULL, 'Metastasis-suppressor KiSS-1', 'Metastasis-suppressor_KiSS-1', 4, NULL),
(18948, NULL, 'IPR013097', NULL, 'Stress responsive alpha-beta barrel', 'Dabb', 3, NULL),
(18949, NULL, 'IPR013016', NULL, 'Peptidase C16, coronavirus', 'Peptidase_C16_CoV', 3, NULL),
(18950, NULL, 'IPR035220', NULL, 'Protein of unknown function DUF5330', 'DUF5330', 4, NULL),
(18951, NULL, 'IPR024068', NULL, 'Rotavirus NSP2, N-terminal', 'Rotavirus_NSP2_N', 5, NULL),
(18952, NULL, 'IPR017860', NULL, 'Peptidase M22, conserved site', 'Peptidase_M22_CS', 2, NULL),
(18953, NULL, 'IPR021665', NULL, 'Mediator complex, subunit Med16', 'Mediator_Med16', 4, NULL),
(18954, NULL, 'IPR021595', NULL, 'Thermoplasma acidophilum protein TA0956', 'TA0956', 4, NULL),
(18955, NULL, 'IPR013367', NULL, 'Flagellar, putative', 'Flagellar_put', 4, NULL),
(18956, NULL, 'IPR017434', NULL, 'Protein phosphatase 1 regulatory subunit 3B/C/D, metazoa', 'Pase-1_reg-su_3B/C/D_met', 4, NULL),
(18957, NULL, 'IPR021565', NULL, 'Rabenosyn, Rab binding domain', 'Rbsn_Rab-bd', 3, NULL),
(18958, NULL, 'IPR017767', NULL, 'Bacterial phospholipase C, phosphocholine-specific', 'Bact_PC-PLC', 4, NULL),
(18959, NULL, 'IPR020464', NULL, 'LanC-like protein, eukaryotic', 'LanC-like_prot_euk', 4, NULL),
(18960, NULL, 'IPR023256', NULL, 'FPRL1 inhibitory protein', 'FLIPR', 4, NULL),
(18961, NULL, 'IPR013011', NULL, 'Phosphotransferase system, EIIB component, type 2', 'PTS_EIIB_2', 3, NULL),
(18962, NULL, 'IPR035218', NULL, 'Protein of unknown function DUF5327', 'DUF5327', 4, NULL),
(18963, NULL, 'IPR021604', NULL, 'Copper resistance protein K', 'CopK', 4, NULL),
(18964, NULL, 'IPR024044', NULL, 'NifT/FixU barrel-like domain superfamily', 'NifT/FixU_barrel-like_dom_sf', 5, NULL),
(18965, NULL, 'IPR021544', NULL, 'Vanadium-binding protein 2', 'Vanabin-2', 4, NULL),
(18966, NULL, 'IPR023314', NULL, '5-Dehydro-2-deoxygluconokinase-like superfamily', 'Myo_inos_IolC-like_sf', 5, NULL),
(18967, NULL, 'IPR021516', NULL, 'Protein of unknown function DUF3179', 'DUF3179', 4, NULL),
(18968, NULL, 'IPR013361', NULL, 'Pilus biogenesis CpaD', 'Pilus_CpaD', 4, NULL),
(18969, NULL, 'IPR035975', NULL, 'E2/EBNA1, C-terminal', 'E2/EBNA1_C_sf', 5, NULL),
(18970, NULL, 'IPR017034', NULL, 'Abortive infection system protein AbiD/AbiF', 'Abi_system_AbiD/AbiF', 4, NULL),
(18971, NULL, 'IPR021557', NULL, 'Protein of unknown function DUF3016', 'DUF3016', 4, NULL),
(18972, NULL, 'IPR016997', NULL, 'Uncharacterised conserved protein UCP032442', 'UCP032442', 4, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(18973, NULL, 'IPR013357', NULL, 'Acetaldehyde dehydrogenase, acetylating', 'Acetaldehyde_DH_acetylating', 4, NULL),
(18974, NULL, 'IPR034248', NULL, 'Carboxypeptidase A, carboxypeptidase domain', 'CPA_M14_CPD', 3, NULL),
(18975, NULL, 'IPR021555', NULL, 'Protein of unknown function DUF3000', 'DUF3000', 4, NULL),
(18976, NULL, 'IPR035167', NULL, 'Protein of unknown function DUF5316', 'DUF5316', 4, NULL),
(18977, NULL, 'IPR014719', NULL, 'Ribosomal protein L7/L12, C-terminal/adaptor protein ClpS-like', 'Ribosomal_L7/12_C/ClpS-like', 5, NULL),
(18978, NULL, 'IPR021645', NULL, 'Shal-type voltage-gated potassium channels, N-terminal', 'Shal-type_N', 3, NULL),
(18979, NULL, 'IPR014029', NULL, 'NADH:ubiquinone oxidoreductase, 49kDa subunit, conserved site', 'NADH_UbQ_OxRdtase_49kDa_CS', 2, NULL),
(18980, NULL, 'IPR034982', NULL, 'Iron-regulated protein A, imelysin-like domain', 'Imelysin-like_IrpA', 3, NULL),
(18981, NULL, 'IPR034968', NULL, 'Reelin', 'Reelin', 4, NULL),
(18982, NULL, 'IPR013108', NULL, 'Amidohydrolase 3', 'Amidohydro_3', 3, NULL),
(18983, NULL, 'IPR013014', NULL, 'Phosphotransferase system, EIIC component, type 2', 'PTS_EIIC_2', 3, NULL),
(18984, NULL, 'IPR034688', NULL, 'Lysis inhibition accessory protein rIII', 'Linr3', 4, NULL),
(18985, NULL, 'IPR021511', NULL, 'Protein of unknown function DUF3172', 'DUF3172', 4, NULL),
(18986, NULL, 'IPR020214', NULL, 'Cytomegalovirus UL124', 'Cytomega_UL124', 4, NULL),
(18987, NULL, 'IPR020568', NULL, 'Ribosomal protein S5 domain 2-type fold', 'Ribosomal_S5_D2-typ_fold', 5, NULL),
(18988, NULL, 'IPR017033', NULL, 'Type III secretion system apparatus protein SsaM', 'T3SS_SsaM', 4, NULL),
(18989, NULL, 'IPR013104', NULL, 'Clostridium neurotoxin, receptor-binding C-terminal', 'Toxin_rcpt-bd_C', 3, NULL),
(18990, NULL, 'IPR017018', NULL, 'Uncharacterised conserved protein UCP033634', 'UCP033634', 4, NULL),
(18991, NULL, 'IPR034672', NULL, 'Salt-Inducible kinase, catalytic domain', 'SIK', 3, NULL),
(18992, NULL, 'IPR021509', NULL, 'Protein of unknown function DUF3169', 'DUF3169', 4, NULL),
(18993, NULL, 'IPR021673', NULL, 'RIG-I-like receptor, C-terminal regulatory domain', 'RLR_CTR', 3, NULL),
(18994, NULL, 'IPR013117', NULL, 'Intimin, C-terminal', 'Intimin_C', 3, NULL),
(18995, NULL, 'IPR013344', NULL, 'Ribonucleotide reductase, adenosylcobalamin-dependent', 'RNR_NrdJ/NrdZ', 4, NULL),
(18996, NULL, 'IPR035339', NULL, 'Protein of unknown function DUF5426', 'DUF5426', 4, NULL),
(18997, NULL, 'IPR024096', NULL, 'NO signalling/Golgi transport ligand-binding domain superfamily', 'NO_sig/Golgi_transp_ligand-bd', 5, NULL),
(18998, NULL, 'IPR021585', NULL, 'Ta0938', 'Ta0938', 4, NULL),
(18999, NULL, 'IPR020439', NULL, 'Interleukin-15', 'IL-15', 4, NULL),
(19000, NULL, 'IPR035343', NULL, 'Phage protein Gp68', 'Gp68', 4, NULL),
(19001, NULL, 'IPR018508', NULL, '3-dehydroquinate dehydratase, active site', '3-dehydroquinate_DH_AS', 0, NULL),
(19002, NULL, 'IPR020260', NULL, 'Uncharacterised protein family YueH', 'Uncharacterised_YueH', 4, NULL),
(19003, NULL, 'IPR023359', NULL, 'Dihydroorotate dehydrogenase A, chain A, domain 2', 'Dihydro_DH_chainA_dom2', 5, NULL),
(19004, NULL, 'IPR024747', NULL, 'Pyridoxamine 5''-phosphate oxidase-related', 'Pyridox_Oxase-rel', 4, NULL),
(19005, NULL, 'IPR020272', NULL, 'Uncharacterized protein C-84-like', 'C-84-like', 4, NULL),
(19006, NULL, 'IPR017811', NULL, 'Mycothiol S-conjugate amidase Mca', 'Mca', 4, NULL),
(19007, NULL, 'IPR018054', NULL, 'Chromogranin, conserved site', 'Chromogranin_CS', 2, NULL),
(19008, NULL, 'IPR021175', NULL, 'Bifunctional inorganic polyphosphate/ATP-NAD kinase, predicted', 'Bifunctional_PpnK_predicted', 4, NULL),
(19009, NULL, 'IPR017984', NULL, 'Chromo domain subgroup', 'Chromo_dom_subgr', 3, NULL),
(19010, NULL, 'IPR021695', NULL, 'Structural protein ORF10, bacteriophage KPP10', 'Phage_KPP10_Orf10', 4, NULL),
(19011, NULL, 'IPR019219', NULL, 'Protein of unknown function DUF2130', 'DUF2130', 4, NULL),
(19012, NULL, 'IPR024761', NULL, 'Transcription factor IIIC, 90kDa subunit, N-terminal', 'TFIIIC_delta_N', 3, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(19013, NULL, 'IPR021691', NULL, 'Protein of unknown function DUF3273', 'DUF3273', 4, NULL),
(19014, NULL, 'IPR018801', NULL, 'E3 ubiquitin-protein ligase TM129', 'TM129', 4, NULL),
(19015, NULL, 'IPR018783', NULL, 'Transcription factor, enhancer of yellow 2', 'TF_ENY2', 4, NULL),
(19016, NULL, 'IPR019527', NULL, 'RZZ complex, subunit KNTC1/ROD, C-terminal', 'RZZ-complex_KNTC1/ROD_C', 3, NULL),
(19017, NULL, 'IPR017997', NULL, 'Vinculin', 'Vinculin', 4, NULL),
(19018, NULL, 'IPR018074', NULL, 'Ubiquitin-activating enzyme E1, conserved site', 'UBQ-activ_enz_E1_CS', 2, NULL),
(19019, NULL, 'IPR021700', NULL, 'Protein of unknown function DUF3283', 'DUF3283', 4, NULL),
(19020, NULL, 'IPR019543', NULL, 'Beta-amyloid precursor protein C-terminal', 'APP_amyloid_C', 3, NULL),
(19021, NULL, 'IPR017815', NULL, 'Myo-inositol 1-phosphate synthase, actinobacteria', 'Myo-inos-1-P_Synthase_actino', 4, NULL),
(19022, NULL, 'IPR021725', NULL, 'Pathogenicity locus', 'Cdd1', 4, NULL),
(19023, NULL, 'IPR021796', NULL, 'Tll0287-like', 'Tll0287-like', 4, NULL),
(19024, NULL, 'IPR019207', NULL, 'Protein of unknown function DUF2092, periplasmic', 'DUF2092', 4, NULL),
(19025, NULL, 'IPR020427', NULL, 'Interleukin-11A, fish', 'IL-11A_fish', 4, NULL),
(19026, NULL, 'IPR020516', NULL, 'Uncharacterised protein family YxcD', 'Uncharacterised_YxcD', 4, NULL),
(19027, NULL, 'IPR019200', NULL, 'ATP adenylyltransferase, C-terminal', 'ATP_adenylylTrfase_C', 3, NULL),
(19028, NULL, 'IPR018506', NULL, 'Cytochrome b5, heme-binding site', 'Cyt_B5_heme-BS', 1, NULL),
(19029, NULL, 'IPR024753', NULL, 'Regulatory protein AriR', 'AriR', 4, NULL),
(19030, NULL, 'IPR017798', NULL, 'D-xylonate dehydratase YjhG/YagF', 'Dehydratase_YjhG/YagF', 4, NULL),
(19031, NULL, 'IPR035990', NULL, 'Triosephosphate isomerase superfamily', 'TIM_sf', 5, NULL),
(19032, NULL, 'IPR021808', NULL, 'Protein of unknown function DUF3383', 'DUF3383', 4, NULL),
(19033, NULL, 'IPR020313', NULL, 'Double-stranded DNA-binding protein', 'Double-stranded_DNA-bd', 4, NULL),
(19034, NULL, 'IPR017789', NULL, 'Frataxin', 'Frataxin', 4, NULL),
(19035, NULL, 'IPR017803', NULL, 'Conserved hypothetical protein CHP03437, C-terminal, Solibacter usitatus', 'CHP03437_C_SOLUE', 3, NULL),
(19036, NULL, 'IPR034788', NULL, 'Protein couch potato, RNA recognition motif', 'Cpo_RRM', 3, NULL),
(19037, NULL, 'IPR018785', NULL, 'Cysteine-rich domain, DPF-motif', 'Cys-rich_DPF', 3, NULL),
(19038, NULL, 'IPR035430', NULL, 'Phosphoprotein P region PNT disordered', 'Paramyxo_PNT', 3, NULL),
(19039, NULL, 'IPR021728', NULL, 'Protein of unknown function DUF3300', 'DUF3300', 4, NULL),
(19040, NULL, 'IPR023366', NULL, 'ATP synthase subunit alpha, N-terminal domain-like superfamily', 'ATP_synth_asu-like_sf', 5, NULL),
(19041, NULL, 'IPR021810', NULL, 'Type I restriction enzyme HindI endonuclease subunit-like, C-terminal', 'T1RH-like_C', 3, NULL),
(19042, NULL, 'IPR018794', NULL, 'Uncharacterised protein family UPF0538', 'UPF0538', 4, NULL),
(19043, NULL, 'IPR024749', NULL, 'Putative collagen-binding domain', 'Collagen-bd_put', 3, NULL),
(19044, NULL, 'IPR021173', NULL, 'Bifunctional dolichyl pyrophosphate glc1man9glcnac2 alpha-1,3-glucosyltransferase/endonuclease V', 'C08H9.3-like', 4, NULL),
(19045, NULL, 'IPR020605', NULL, 'Octanoyltransferase, conserved site', 'Octanoyltransferase_CS', 2, NULL),
(19046, NULL, 'IPR034724', NULL, 'Chromodomain-helicase-DNA-binding protein 8', 'CHD8', 4, NULL),
(19047, NULL, 'IPR016615', NULL, 'Ubiquitin thioesterase Otubain', 'Otubain', 4, NULL),
(19048, NULL, 'IPR021735', NULL, 'Protein of unknown function DUF3306', 'DUF3306', 4, NULL),
(19049, NULL, 'IPR016643', NULL, '26S proteasome regulatory complex, non-ATPase subcomplex, Rpn1 subunit', '26S_Psome_Rpn1', 4, NULL),
(19050, NULL, 'IPR021791', NULL, 'Phage tail tube protein, GTA-gp10', 'Phage_TAC_11', 4, NULL),
(19051, NULL, 'IPR020615', NULL, 'Thiolase, acyl-enzyme intermediate active site', 'Thiolase_acyl_enz_int_AS', 0, NULL),
(19052, NULL, 'IPR017807', NULL, 'Urea transporter, bacteria', 'Urea_transporter_bac', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(19053, NULL, 'IPR019217', NULL, 'Protein of unknown function DUF2118', 'DUF2118', 4, NULL),
(19054, NULL, 'IPR018800', NULL, 'Proline-rich protein PRCC', 'PRCC', 4, NULL),
(19055, NULL, 'IPR023352', NULL, 'Membrane associated eicosanoid/glutathione metabolism-like domain superfamily', 'MAPEG-like_dom_sf', 5, NULL),
(19056, NULL, 'IPR018790', NULL, 'Protein of unknown function DUF2358', 'DUF2358', 4, NULL),
(19057, NULL, 'IPR020581', NULL, 'Glycine cleavage system P protein', 'GDC_P', 4, NULL),
(19058, NULL, 'IPR019528', NULL, 'Pericentrin/AKAP-450 centrosomal targeting domain', 'PACT_domain', 3, NULL),
(19059, NULL, 'IPR017781', NULL, 'ABC transporter, urea, ATP-binding protein, UrtD', 'ABC_transptr_urea_ATP-bd_UrtD', 4, NULL),
(19060, NULL, 'IPR021756', NULL, 'Transcription factor Aft1, HRR domain', 'TF_Aft1_HRR', 3, NULL),
(19061, NULL, 'IPR023361', NULL, 'DUF1285, beta-roll domain superfamily', 'DUF1285_beta_roll_sf', 5, NULL),
(19062, NULL, 'IPR016259', NULL, 'Hygromycin-B kinase', 'Hygromycin-B_Kinase', 4, NULL),
(19063, NULL, 'IPR021176', NULL, 'Competence-induced protein CoiA', 'Competence-induced_CoiA', 4, NULL),
(19064, NULL, 'IPR020902', NULL, 'Actin/actin-like conserved site', 'Actin/actin-like_CS', 2, NULL),
(19065, NULL, 'IPR017779', NULL, 'ABC transporter, urea permease protein UrtB, bacterial-type', 'ABC_UrtB_bac', 4, NULL),
(19066, NULL, 'IPR020271', NULL, 'Uncharacterised protein family, MJ1172', 'Uncharacterised_MJ1172', 4, NULL),
(19067, NULL, 'IPR019205', NULL, 'Protein of unknown function DUF2080, transposon-encoded', 'DUF2080_transposon-encoded', 4, NULL),
(19068, NULL, 'IPR017817', NULL, 'Mycothione reductase', 'Mycothione_reductase', 4, NULL),
(19069, NULL, 'IPR021686', NULL, 'Protein of unkown function DUF3268', 'DUF3268', 4, NULL),
(19070, NULL, 'IPR020251', NULL, 'Uncharacterised protein family, YmjA', 'Uncharacterised_YmjA', 4, NULL),
(19071, NULL, 'IPR021737', NULL, 'Bacteriophage phiKZ, Orf197', 'Phage_phiKZ_Orf197', 4, NULL),
(19072, NULL, 'IPR018033', NULL, 'D-aminoacyl-tRNA deacylase, archaea', 'Deacylase_DtdA_archaea', 4, NULL),
(19073, NULL, 'IPR021788', NULL, 'Protein CHAPERONE-LIKE PROTEIN OF POR1-like', 'CPP1-like', 4, NULL),
(19074, NULL, 'IPR021740', NULL, 'Velvet factor', 'Velvet', 4, NULL),
(19075, NULL, 'IPR034910', NULL, 'LARP7, RNA recognition motif 2', 'LARP7_RRM2', 3, NULL),
(19076, NULL, 'IPR016639', NULL, 'Glutathione S-transferase Omega/GSH', 'GST_Omega/GSH', 4, NULL),
(19077, NULL, 'IPR020493', NULL, 'Uncharacterised protein family HI0310', 'Uncharacterised_HI0310', 4, NULL),
(19078, NULL, 'IPR021779', NULL, 'Protein of unknown function DUF3344', 'DUF3344', 4, NULL),
(19079, NULL, 'IPR021813', NULL, 'Protein of unknown function DUF3392', 'DUF3392', 4, NULL),
(19080, NULL, 'IPR017978', NULL, 'GPCR family 3, C-terminal', 'GPCR_3_C', 3, NULL),
(19081, NULL, 'IPR019532', NULL, 'Nuclear RNA-splicing-associated protein, SR-25', 'Nucl_RNA-splicing_assoc_SR-25', 4, NULL),
(19082, NULL, 'IPR021759', NULL, 'Domain of unknown function DUF3324, C-terminal', 'DUF3324_C', 3, NULL),
(19083, NULL, 'IPR019239', NULL, 'Bacterial antitoxin of type II TA system, VapB', 'VapB_antitoxin', 4, NULL),
(19084, NULL, 'IPR034036', NULL, 'Tolloid/BMP1 peptidase domain', 'ZnMP_TLD/BMP1', 3, NULL),
(19085, NULL, 'IPR021707', NULL, 'Protein of unknown function DUF3290', 'DUF3290', 4, NULL),
(19086, NULL, 'IPR018003', NULL, 'Insecticidal toxin complex/plasmid virulence protein', 'Insecticidal_toxin/plasmid_vir', 4, NULL),
(19087, NULL, 'IPR021721', NULL, 'Zinc finger, CCCH-type, TRM13', 'Znf_CCCH-type_TRM13', 3, NULL),
(19088, NULL, 'IPR021785', NULL, 'Domain of unknown function DUF3350', 'DUF3350', 3, NULL),
(19089, NULL, 'IPR016631', NULL, 'Regulatory, RpfE', 'Regulatory_RpfE', 4, NULL),
(19090, NULL, 'IPR018778', NULL, 'Type VII secretion system EssB', 'T7SS_EssB', 4, NULL),
(19091, NULL, 'IPR017778', NULL, 'ABC transporter, urea, permease protein, UrtC', 'ABC_transptr_urea_perm_UrtC', 4, NULL),
(19092, NULL, 'IPR021787', NULL, 'Protein of unknown function DUF3352', 'DUF3352', 4, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(19093, NULL, 'IPR020258', NULL, 'Uncharacterised protein family YbeF', 'Uncharacterised_YbeF', 4, NULL),
(19094, NULL, 'IPR021763', NULL, 'Protein of unknown function DUF3326', 'DUF3326', 4, NULL),
(19095, NULL, 'IPR019548', NULL, 'CTF transcription factor/nuclear factor 1, N-terminal', 'CTF/NFI_DNA-bd_N', 3, NULL),
(19096, NULL, 'IPR018073', NULL, 'Proteinase inhibitor I25, cystatin, conserved site', 'Prot_inh_cystat_CS', 2, NULL),
(19097, NULL, 'IPR018804', NULL, 'Luciferase catalytic domain', 'Luciferase_cat', 3, NULL),
(19098, NULL, 'IPR016258', NULL, 'Multiphosphoryl transfer protein FruB', 'FruB', 4, NULL),
(19099, NULL, 'IPR020277', NULL, 'Protein of unknown function DUF2624', 'DUF2624', 4, NULL),
(19100, NULL, 'IPR017797', NULL, 'Phosphonate ABC transporter, substrate-binding protein', 'Phosphnate-bd', 4, NULL),
(19101, NULL, 'IPR016636', NULL, '3-oxo-5-alpha-steroid 4-dehydrogenase', '3-oxo-5-alpha-steroid_4-DH', 4, NULL),
(19102, NULL, 'IPR020244', NULL, 'Rotavirus B, non-structural protein 5', 'Rotavirus_B_NSP5', 4, NULL),
(19103, NULL, 'IPR016642', NULL, '26S proteasome regulatory complex, non-ATPase subcomplex, Rpn2/Psmd1 subunit', '26S_Psome_Rpn2', 4, NULL),
(19104, NULL, 'IPR019212', NULL, 'Protein of unknown function DUF2105, membrane', 'DUF2105_membrane', 4, NULL),
(19105, NULL, 'IPR021773', NULL, 'Trafficking protein particle complex subunit 11', 'TPC11', 3, NULL),
(19106, NULL, 'IPR020613', NULL, 'Thiolase, conserved site', 'Thiolase_CS', 2, NULL),
(19107, NULL, 'IPR018064', NULL, 'Metallothionein, vertebrate, metal binding site', 'Metalthion_vert_metal_BS', 1, NULL),
(19108, NULL, 'IPR019226', NULL, 'Protein of unknown function DUF2158', 'DUF2158', 4, NULL),
(19109, NULL, 'IPR017809', NULL, 'Glutamate--cysteine ligase EgtA, Actinobacteria', 'EgtA_Actinobacteria', 4, NULL),
(19110, NULL, 'IPR021768', NULL, 'Protein of unknown function DUF3332', 'DUF3332', 4, NULL),
(19111, NULL, 'IPR016619', NULL, 'Uncharacterised conserved protein UCP014439, ACT', 'UCP014439_ACT', 4, NULL),
(19112, NULL, 'IPR018788', NULL, 'Proteasome assembly chaperone 3', 'Proteasome_assmbl_chp_3', 4, NULL),
(19113, NULL, 'IPR021709', NULL, 'Protein of unknown function DUF3292', 'DUF3292', 4, NULL),
(19114, NULL, 'IPR020448', NULL, 'Maltose fermentation regulatory protein, DNA-binding domain', 'Maltose_ferment_reg_DNA-bd', 3, NULL),
(19115, NULL, 'IPR017990', NULL, 'Connexin, conserved site', 'Connexin_CS', 2, NULL),
(19116, NULL, 'IPR034909', NULL, 'Neutrophil cytosol factor 1, PX domain', 'PX_p47phox', 3, NULL),
(19117, NULL, 'IPR018509', NULL, 'Dehydroquinase, class II, conserved site', 'DHquinase_II_CS', 2, NULL),
(19118, NULL, 'IPR019220', NULL, 'Domain of unknown function DUF2135', 'DUF2135', 3, NULL),
(19119, NULL, 'IPR034787', NULL, 'RBPMS2, RNA recognition motif', 'RBPMS2_RRM', 3, NULL),
(19120, NULL, 'IPR021682', NULL, 'Protein of unknown function DUF2933', 'DUF2933', 4, NULL),
(19121, NULL, 'IPR017806', NULL, 'Ergothioneine biosynthesis protein EgtB', 'EgtB', 4, NULL),
(19122, NULL, 'IPR018141', NULL, 'Nitrile hydratase, alpha subunit', 'Nitrile_hydratase_asu', 4, NULL),
(19123, NULL, 'IPR034857', NULL, 'TFG, PB1 domain', 'PB1_TFG', 3, NULL),
(19124, NULL, 'IPR021729', NULL, 'Domain of unknown function DUF3298', 'DUF3298', 3, NULL),
(19125, NULL, 'IPR016630', NULL, 'Uncharacterised conserved protein UCP015278', 'UCP015278', 4, NULL),
(19126, NULL, 'IPR023353', NULL, 'LemA-like domain superfamily', 'LemA-like_dom_sf', 5, NULL),
(19127, NULL, 'IPR021774', NULL, 'Cytohesin Ubiquitin Protein Inducing Domain', 'CUPID', 3, NULL),
(19128, NULL, 'IPR021678', NULL, 'Protein of unknown function DUF3263', 'DUF3263', 4, NULL),
(19129, NULL, 'IPR016635', NULL, 'Adaptor protein complex, sigma subunit', 'AP_complex_ssu', 4, NULL),
(19130, NULL, 'IPR017774', NULL, 'Bicupin, oxalate decarboxylase/oxidase', 'Bicupin_oxalate_deCO2ase/Oxase', 4, NULL),
(19131, NULL, 'IPR035913', NULL, 'RPB5-like RNA polymerase subunit superfamily', 'RPB5-like_sf', 5, NULL),
(19132, NULL, 'IPR020249', NULL, 'Protein of unknown function DUF5492', 'DUF5492', 4, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(19133, NULL, 'IPR018152', NULL, 'Superoxide dismutase, copper/zinc, binding site', 'SOD_Cu/Zn_BS', 1, NULL),
(19134, NULL, 'IPR020255', NULL, 'Minor curli fiber component A', 'CsgA', 4, NULL),
(19135, NULL, 'IPR020323', NULL, 'Protein of unknown function DUF2716', 'DUF2716', 4, NULL),
(19136, NULL, 'IPR019241', NULL, 'Protein of unknown function DUF2197', 'DUF2197', 4, NULL),
(19137, NULL, 'IPR021747', NULL, 'Protein of unknown function DUF3313', 'DUF3313', 4, NULL),
(19138, NULL, 'IPR024760', NULL, 'Helix-turn-helix, conjugative transposon-like', 'HTH_dom_conjug_TS-like', 3, NULL),
(19139, NULL, 'IPR017784', NULL, 'ABC transporter, choline, permease protein', 'ABC_transptr_choline_permease', 4, NULL),
(19140, NULL, 'IPR021792', NULL, 'Beta-fructofuranosidase, N-terminal domain', 'Beta-fructofuranosidase_N', 3, NULL),
(19141, NULL, 'IPR019554', NULL, 'Soluble ligand binding domain', 'Soluble_ligand-bd', 3, NULL),
(19142, NULL, 'IPR018043', NULL, 'Sodium:galactoside symporter, conserved site', 'Na/Gal_symport_CS', 2, NULL),
(19143, NULL, 'IPR021696', NULL, 'Protein of unknown function DUF3279', 'DUF3279', 4, NULL),
(19144, NULL, 'IPR017982', NULL, 'Defensin, insect', 'Defensin_insect', 4, NULL),
(19145, NULL, 'IPR021179', NULL, 'Mercury(II) reductase', 'Mercury_reductase_MerA', 4, NULL),
(19146, NULL, 'IPR021726', NULL, 'THO complex, subunitTHOC2, N-terminal', 'THO_THOC2_N', 3, NULL),
(19147, NULL, 'IPR020731', NULL, 'Apoptosis regulator, Bcl-2, BH4 motif, conserved site', 'Bcl2_BH4_motif_CS', 2, NULL),
(19148, NULL, 'IPR017786', NULL, 'Transcription factor, choline sulphate-utilisation, putative', 'TF_choline_sulphate-util_put', 4, NULL),
(19149, NULL, 'IPR034703', NULL, 'Proton/glutamate-aspartate symporter GltP', 'GltP', 4, NULL),
(19150, NULL, 'IPR018799', NULL, 'TRAF3-interacting protein 1', 'TRAF3IP1', 4, NULL),
(19151, NULL, 'IPR021793', NULL, 'Major outer membrane lipoprotein Oprl', 'Oprl', 4, NULL),
(19152, NULL, 'IPR016613', NULL, 'Increased recombination centres protein 19', 'Irc19', 4, NULL),
(19153, NULL, 'IPR017795', NULL, 'Aromatic prenyltransferase, DMATS-type', 'Aro_prenylTrfase_DMATS', 4, NULL),
(19154, NULL, 'IPR017805', NULL, 'SAM-dependent methyltransferase, EasF-type, putative', 'SAM_MeTrfase_EasF-type_put', 3, NULL),
(19155, NULL, 'IPR019563', NULL, 'Glycosyl-hydrolase 97, catalytic domain', 'GH97_catalytic', 3, NULL),
(19156, NULL, 'IPR024756', NULL, 'Protocatechuate 3,4-dioxygenase beta subunit, N-terminal', 'PCDO_beta_N', 3, NULL),
(19157, NULL, 'IPR020617', NULL, 'Thiolase, C-terminal', 'Thiolase_C', 3, NULL),
(19158, NULL, 'IPR021811', NULL, 'Protein of unknown function DUF3389', 'DUF3389', 4, NULL),
(19159, NULL, 'IPR020901', NULL, 'Proteinase inhibitor I2, Kunitz, conserved site', 'Prtase_inh_Kunz-CS', 2, NULL),
(19160, NULL, 'IPR018807', NULL, 'Cell wall protein YJL171C/Tos1, N-terminal', 'YJL171C/Tos1_N', 3, NULL),
(19161, NULL, 'IPR019544', NULL, 'Tetratricopeptide, SHNi-TPR domain', 'Tetratricopeptide_SHNi-TPR_dom', 3, NULL),
(19162, NULL, 'IPR017821', NULL, 'Succinate CoA transferase', 'Succinate_CoA_transferase', 4, NULL),
(19163, NULL, 'IPR018787', NULL, 'Protein of unknown function DUF2371, TMEM200', 'DUF2371_TMEM200', 4, NULL),
(19164, NULL, 'IPR021784', NULL, 'Protein of unknown function DUF3349', 'DUF3349', 4, NULL),
(19165, NULL, 'IPR021795', NULL, 'Protein of unknown function DUF3363', 'DUF3363', 4, NULL),
(19166, NULL, 'IPR018802', NULL, 'Latarcin precursor', 'Latarcin_precursor', 4, NULL),
(19167, NULL, 'IPR018781', NULL, 'Transmembrane protein TPRA1/CAND2/CAND8', 'TPRA1/CAND2/CAND8', 4, NULL),
(19168, NULL, 'IPR017793', NULL, 'ABC transporter, urea utilisation-associated, substrate-binding protein', 'ABC_transptr_urea-assoc_sub-bd', 4, NULL),
(19169, NULL, 'IPR021687', NULL, 'Protein of unknown function DUF3269', 'DUF3269', 4, NULL),
(19170, NULL, 'IPR021688', NULL, 'Protein of unknown function DUF3270', 'DUF3270', 4, NULL),
(19171, NULL, 'IPR018039', NULL, 'Intermediate filament protein, conserved site', 'IF_conserved', 2, NULL),
(19172, NULL, 'IPR019547', NULL, 'Lipid desaturase domain', 'Lipid_desat', 3, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(19173, NULL, 'IPR017970', NULL, 'Homeobox, conserved site', 'Homeobox_CS', 2, NULL),
(19174, NULL, 'IPR019201', NULL, 'Protein of unknown function DUF2065', 'DUF2065', 4, NULL),
(19175, NULL, 'IPR021710', NULL, 'Protein of unknown function DUF3293', 'DUF3293', 4, NULL),
(19176, NULL, 'IPR019215', NULL, 'Protein of unknown function DUF2115', 'DUF2115', 4, NULL),
(19177, NULL, 'IPR021717', NULL, 'Nucleoporin Nup120/160', 'Nucleoporin_Nup160', 4, NULL),
(19178, NULL, 'IPR021174', NULL, 'Uncharacterised conserved protein UCP037139', 'UCP037139', 4, NULL),
(19179, NULL, 'IPR021815', NULL, 'Protein of unknown function DUF3396', 'DUF3396', 4, NULL),
(19180, NULL, 'IPR021694', NULL, 'Protein of unknown function DUF3276', 'DUF3276', 4, NULL),
(19181, NULL, 'IPR018042', NULL, 'Aspartate kinase, conserved site', 'Aspartate_kinase_CS', 2, NULL),
(19182, NULL, 'IPR017813', NULL, 'Mycothiol acetyltransferase', 'Mycothiol_AcTrfase', 4, NULL),
(19183, NULL, 'IPR019535', NULL, 'Little elongation complex subunit 2 , C-terminal', 'ICE2_C', 3, NULL),
(19184, NULL, 'IPR021738', NULL, 'Protein of unknown function DUF3309', 'DUF3309', 4, NULL),
(19185, NULL, 'IPR021807', NULL, 'High-affinity branched-chain amino acid transport system permease, LivHM, N-terminal', 'LivHM_N', 3, NULL),
(19186, NULL, 'IPR021743', NULL, 'Keratin-associated protein, type6/8/16/19/20/21', 'KRTAP_type6/8/16/19/20/21', 4, NULL),
(19187, NULL, 'IPR020248', NULL, 'Protein of unknown function Y03I', 'Y03I', 4, NULL),
(19188, NULL, 'IPR020252', NULL, 'Protein of unknown function DUF5446', 'DUF5446', 4, NULL),
(19189, NULL, 'IPR021745', NULL, 'Cobalamin biosynthesis central region', 'CbiG_mid', 3, NULL),
(19190, NULL, 'IPR019570', NULL, 'Gap junction protein, cysteine-rich domain', 'Connexin_CCC', 3, NULL),
(19191, NULL, 'IPR035959', NULL, 'RutC-like superfamily', 'RutC-like_sf', 5, NULL),
(19192, NULL, 'IPR021798', NULL, 'Alpha-(1->3)-arabinofuranosyltransferase', 'AftD', 4, NULL),
(19193, NULL, 'IPR035428', NULL, 'Fanconi anemia group F protein', 'FANCF', 4, NULL),
(19194, NULL, 'IPR020231', NULL, 'Uncharacterised protein family, YfgI', 'Uncharacterised_YfgI', 4, NULL),
(19195, NULL, 'IPR020226', NULL, 'Avian adenovirus Orf17', 'Avian_adenovirus_Orf17', 4, NULL),
(19196, NULL, 'IPR020262', NULL, 'Uncharacterised protein family YecJ', 'Uncharacterised_YecJ', 4, NULL),
(19197, NULL, 'IPR018779', NULL, 'Single-stranded-DNA-specific exonuclease RecJ, C-terminal', 'RecJ_C', 3, NULL),
(19198, NULL, 'IPR017818', NULL, 'Plasmid partitioning protein, RepA', 'Plasmid_partition_RepA', 4, NULL),
(19199, NULL, 'IPR021752', NULL, 'Transcription initiation factor Rrn7, Zinc-finger', 'TF_Rrn7_Zf', 3, NULL),
(19200, NULL, 'IPR016637', NULL, 'Neurogenic differentiation factor NeuroD', 'TF_bHLH_NeuroD', 4, NULL),
(19201, NULL, 'IPR019536', NULL, 'Harmonin-binding protein USHBP1, PDZ-binding domain', 'USHBP1_PDZ-bd', 3, NULL),
(19202, NULL, 'IPR016620', NULL, 'CRISPR system ring nuclease SSO1393', 'SSO1393', 4, NULL),
(19203, NULL, 'IPR018796', NULL, 'Cytochrome c oxidase assembly factor 8', 'COA8', 4, NULL),
(19204, NULL, 'IPR024746', NULL, 'Glycosyl hydrolase family 100', 'Glyco_hydro_100', 4, NULL),
(19205, NULL, 'IPR020312', NULL, 'Protein of unknown function DUF5497', 'DUF5497', 4, NULL),
(19206, NULL, 'IPR018777', NULL, 'Replication initiator protein A', 'Replication_initiator_prot_A', 4, NULL),
(19207, NULL, 'IPR017942', NULL, 'Lipid-binding serum glycoprotein, N-terminal', 'Lipid-bd_serum_glycop_N', 3, NULL),
(19208, NULL, 'IPR035429', NULL, 'Nitrile-specifier protein 1/2/3', 'NSP1/2/3', 4, NULL),
(19209, NULL, 'IPR021780', NULL, 'Nuclear/hormone receptor activator site AF-1', 'Nuc_recep-AF1', 3, NULL),
(19210, NULL, 'IPR035914', NULL, 'Spermadhesin, CUB domain superfamily', 'Sperma_CUB_dom_sf', 5, NULL),
(19211, NULL, 'IPR017800', NULL, 'Acidobacterial duplicated orphan permease', 'ADOP', 4, NULL),
(19212, NULL, 'IPR019571', NULL, 'Involucrin, N-terminal', 'Involucrin_N', 3, NULL),
(19213, NULL, 'IPR017799', NULL, 'Transcription regulator PadR, acidobacterial-type', 'Tscrpt_reg_PadR_acidobac-type', 4, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(19214, NULL, 'IPR021746', NULL, 'DIPSY domain', 'DIPSY', 3, NULL),
(19215, NULL, 'IPR035427', NULL, 'Tim10-like domain superfamily', 'Tim10-like_dom_sf', 5, NULL),
(19216, NULL, 'IPR019199', NULL, 'Virulence-associated protein D / CRISPR associated protein Cas2', 'Virulence_VapD/CRISPR_Cas2', 4, NULL),
(19217, NULL, 'IPR020526', NULL, 'Ribosomal protein L6, chloroplast', 'Ribosomal_L6_chp', 4, NULL),
(19218, NULL, 'IPR018290', NULL, 'MULE transposase, N-terminal all-beta domain', 'MULE_transposase_N', 3, NULL),
(19219, NULL, 'IPR021760', NULL, 'Replication protein-C C-terminal', 'RP-C_C', 3, NULL),
(19220, NULL, 'IPR021764', NULL, 'Enterochelin esterase, N-terminal', 'Enterochelin_esterase_N', 3, NULL),
(19221, NULL, 'IPR035976', NULL, 'Sushi/SCR/CCP superfamily', 'Sushi/SCR/CCP_sf', 5, NULL),
(19222, NULL, 'IPR021804', NULL, 'Protein of unknown function DUF3375', 'DUF3375', 4, NULL),
(19223, NULL, 'IPR017820', NULL, 'Sulphoacetaldehyde acetyltransferase', 'Sulphoacetald_Actrfrase', 4, NULL),
(19224, NULL, 'IPR019230', NULL, 'tRNA (guanine-N(1)-)-methyltransferase, C-terminal', 'RNA_MeTrfase_C_dom', 3, NULL),
(19225, NULL, 'IPR017776', NULL, 'FeS assembly SUF system protein SufT, putative', 'FeS_assembly_SufT_put', 4, NULL),
(19226, NULL, 'IPR016622', NULL, 'Bacteriophage SP-beta, YorJ', 'Phage_SP-beta_YorJ', 4, NULL),
(19227, NULL, 'IPR016262', NULL, 'RNA polymerase sigma factor, SigB/C/D/F, plastid', 'RNA_pol_sigma_SigB/C/D/F', 4, NULL),
(19228, NULL, 'IPR020457', NULL, 'Zinc finger, B-box, chordata', 'Znf_B-box_chordata', 3, NULL),
(19229, NULL, 'IPR023335', NULL, 'ATP12 orthogonal Bundle domain superfamily', 'ATP12_ortho_dom_sf', 5, NULL),
(19230, NULL, 'IPR020230', NULL, 'Transcription regulator MotB', 'Tscrpt_reg_MotB', 4, NULL),
(19231, NULL, 'IPR021771', NULL, 'Triacylglycerol lipase, N-terminal', 'Triacylglycerol_lipase_N', 3, NULL),
(19232, NULL, 'IPR020475', NULL, 'Endothelin', 'Endothelin', 4, NULL),
(19233, NULL, 'IPR018067', NULL, 'Protein phosphatase 2A regulatory subunit PR55, conserved site', 'PP2A_PR55_CS', 2, NULL),
(19234, NULL, 'IPR020513', NULL, 'Uncharacterised protein family, inner membrane YaiY', 'Uncharacterised_IM_YaiY', 4, NULL),
(19235, NULL, 'IPR019553', NULL, 'Spider toxin CSTX, Knottin scaffold', 'Spider_toxin_CSTX_knottin', 4, NULL),
(19236, NULL, 'IPR020387', NULL, 'Autographa californica nuclear polyhedrosis virus (AcMNPV), Orf112', 'AcMNPV_Orf112', 4, NULL),
(19237, NULL, 'IPR021730', NULL, 'Dicarboxylate transport', 'DctA-YdbH', 3, NULL),
(19238, NULL, 'IPR021797', NULL, 'Virulence factor membrane-bound polymerase, C-terminal', 'Wzy_C_2', 3, NULL),
(19239, NULL, 'IPR021708', NULL, 'Domain of unknown function DUF3291', 'DUF3291', 3, NULL),
(19240, NULL, 'IPR021757', NULL, 'Ribosomal protein L46, N-terminal', 'Ribosomal_L46_N', 3, NULL),
(19241, NULL, 'IPR016612', NULL, 'Mediator complex, subunit Med6, fungi', 'Mediator_Med6_fun', 4, NULL),
(19242, NULL, 'IPR019208', NULL, 'Protein of unknown function DUF2097', 'DUF2097', 4, NULL),
(19243, NULL, 'IPR017783', NULL, 'Choline ABC transporter, substrate-binding protein', 'ABC_choline_sub-bd', 4, NULL),
(19244, NULL, 'IPR017792', NULL, 'Urea carboxylase-associated protein 2', 'Urea_carboxylase-assoc_2', 4, NULL),
(19245, NULL, 'IPR019537', NULL, 'Transmembrane protein 65', 'TMEM65', 4, NULL),
(19246, NULL, 'IPR018030', NULL, 'Fimbrial membrane usher, conserved site', 'Fimbrial_membr_usher_CS', 2, NULL),
(19247, NULL, 'IPR021778', NULL, 'Putative Se/S carrier protein-like', 'Se/S_carrier-like', 3, NULL),
(19248, NULL, 'IPR017816', NULL, 'S-(hydroxymethyl)mycothiol dehydrogenase', 'MycoS_dep_FDH', 4, NULL),
(19249, NULL, 'IPR016609', NULL, 'Uncharacterised  protein Opy1', 'Opy1', 4, NULL),
(19250, NULL, 'IPR020278', NULL, 'Uncharacterized protein YqaH-like', 'YqaH-like', 4, NULL),
(19251, NULL, 'IPR021715', NULL, 'Pre-mRNA-splicing factor SLU7 domain', 'Slu7_dom', 3, NULL),
(19252, NULL, 'IPR019561', NULL, 'Translocon Sec61/SecY, plug domain', 'Translocon_Sec61/SecY_plug_dom', 3, NULL),
(19253, NULL, 'IPR018191', NULL, '4-oxalocrotonate tautomerase, Pseudomonas-type', 'Tautomerase_Pseudo-typ', 4, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(19254, NULL, 'IPR019566', NULL, 'Myelin protein P0, C-terminal', 'MYP0_C', 3, NULL),
(19255, NULL, 'IPR017461', NULL, 'Conserved hypothetical domain CHP03009, planctomycetes', 'CHP03009_planctomycetes', 3, NULL),
(19256, NULL, 'IPR020717', NULL, 'Apoptosis regulator, Bcl-2, BH1 motif, conserved site', 'Bcl2_BH1_motif_CS', 2, NULL),
(19257, NULL, 'IPR021803', NULL, 'Protein of unknown function DUF3373', 'DUF3373', 4, NULL),
(19258, NULL, 'IPR021806', NULL, 'Protein of unknown function DUF3379', 'DUF3379', 4, NULL),
(19259, NULL, 'IPR021753', NULL, 'Protein of unknown function DUF3319', 'DUF3319', 4, NULL),
(19260, NULL, 'IPR018075', NULL, 'Ubiquitin-activating enzyme E1', 'UBQ-activ_enz_E1', 4, NULL),
(19261, NULL, 'IPR021814', NULL, 'Protein of unknown function DUF3394', 'DUF3394', 4, NULL),
(19262, NULL, 'IPR021765', NULL, 'Mycotoxin biosynthesis protein UstYa-like', 'UstYa-like', 4, NULL),
(19263, NULL, 'IPR019560', NULL, 'Mitochondrial 18kDa protein', 'Mitochondrial_18_kDa_protein_', 4, NULL),
(19264, NULL, 'IPR016632', NULL, 'Conserved oligomeric Golgi complex subunit 8, Metazoal and Viridiplantae', 'COG8_Metazoal_Plant', 4, NULL),
(19265, NULL, 'IPR017810', NULL, 'Mycothiol biosynthesis protein, MshB', 'Mycothiol_biosynthesis_MshB', 4, NULL),
(19266, NULL, 'IPR017998', NULL, 'Chaperone tailless complex polypeptide 1 (TCP-1)', 'Chaperone_TCP-1', 4, NULL),
(19267, NULL, 'IPR021777', NULL, 'SANT and BTB domain regulator of CSR, BTB domain', 'SANBR_BTB', 3, NULL),
(19268, NULL, 'IPR017787', NULL, 'NIF system FeS cluster assembly, NifU-like', 'NIF_FeS_clus_asmbl_NifU-like', 4, NULL),
(19269, NULL, 'IPR020807', NULL, 'Polyketide synthase, dehydratase domain', 'PKS_DH', 3, NULL),
(19270, NULL, 'IPR020476', NULL, 'NUDIX hydrolase', 'Nudix_hydrolase', 3, NULL),
(19271, NULL, 'IPR021748', NULL, 'Protein of unknown function DUF3314', 'DUF3314', 4, NULL),
(19272, NULL, 'IPR021679', NULL, 'Toxin endonuclease, YhaV', 'Toxin_endonuclease_YhaV', 4, NULL),
(19273, NULL, 'IPR016633', NULL, 'Protein-arginine rhamnosyltransferase EarP', 'EarP', 4, NULL),
(19274, NULL, 'IPR019216', NULL, 'Protein of unknown function DUF2116, Zn-ribbon', 'DUF2116_Zn-ribbon', 4, NULL),
(19275, NULL, 'IPR021733', NULL, 'Protein of unknown function DUF3304', 'DUF3304', 4, NULL),
(19276, NULL, 'IPR018793', NULL, 'Cytochrome c oxidase assembly protein PET191', 'Cyt_c_oxidase_assmbl_Pet191', 4, NULL),
(19277, NULL, 'IPR020280', NULL, 'Microcin V bacteriocin', 'MccV', 4, NULL),
(19278, NULL, 'IPR018786', NULL, 'Mitochondrial K+-H+ exchange-related', 'Mit_KHE1', 4, NULL),
(19279, NULL, 'IPR021802', NULL, 'MiT/TFE transcription factors, C-terminal', 'MiT/TFE_C', 3, NULL),
(19280, NULL, 'IPR019240', NULL, 'Protein of unknown function DUF2196', 'DUF2196', 4, NULL),
(19281, NULL, 'IPR017777', NULL, 'Urea ABC transporter, substrate-binding protein UrtA-like', 'ABC_urea-bd_UrtA', 4, NULL),
(19282, NULL, 'IPR016629', NULL, 'TATA box-binding protein-associated factor RNA polymerase I subunit A, chordata', 'RNA_pol_I_TAF1A/TAFI48_chr', 4, NULL),
(19283, NULL, 'IPR034035', NULL, 'Astacin-like metallopeptidase domain', 'Astacin-like_dom', 3, NULL),
(19284, NULL, 'IPR021722', NULL, 'Uncharacterised domain YvbH-like, oligomerisation domain', 'UPF_YvbH_oligomer_dom', 3, NULL),
(19285, NULL, 'IPR016604', NULL, 'Uncharacterised conserved protein UCP012886', 'UCP012886', 4, NULL),
(19286, NULL, 'IPR020891', NULL, 'Uncharacterised protein family UPF0758, conserved site', 'UPF0758_CS', 2, NULL),
(19287, NULL, 'IPR017460', NULL, 'Conserved hypothetical domain CHP03000, planctomycetes', 'CHP03000_planctomycetes', 3, NULL),
(19288, NULL, 'IPR021731', NULL, 'AMIN domain', 'AMIN_dom', 3, NULL),
(19289, NULL, 'IPR017801', NULL, 'Soil-associated protein DUF3738', 'DUF3738', 4, NULL),
(19290, NULL, 'IPR020227', NULL, 'Protein of unknown function DUF5507', 'DUF5507', 4, NULL),
(19291, NULL, 'IPR035960', NULL, 'Secretoglobin superfamily', 'Secretoglobin_sf', 5, NULL),
(19292, NULL, 'IPR021742', NULL, 'Suppressor of RNA silencing P21-like, N-terminal', 'RSS_P20_N', 3, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(19293, NULL, 'IPR019568', NULL, 'Rapsyn, myristoylation/linker region, N-terminal', 'Rapsyn_myristoylation/link_N', 3, NULL),
(19294, NULL, 'IPR017969', NULL, 'Heavy-metal-associated, conserved site', 'Heavy-metal-associated_CS', 2, NULL),
(19295, NULL, 'IPR021698', NULL, 'Protein of unknown function DUF2380', 'DUF3280', 4, NULL),
(19296, NULL, 'IPR021720', NULL, 'Malectin domain', 'Malectin_dom', 3, NULL),
(19297, NULL, 'IPR019228', NULL, 'Bacteriophage phiJL001, Gp84, N-terminal', 'Phage_phiJL001_Gp84_N', 3, NULL),
(19298, NULL, 'IPR018792', NULL, 'Nuclear protein 1-like', 'NUPR1-like', 4, NULL),
(19299, NULL, 'IPR020527', NULL, 'Cytomegalovirus uncharacterized protein UL17', 'Cytomegalovir_UL17', 4, NULL),
(19300, NULL, 'IPR023312', NULL, 'Putative nitroreductase, C-terminal, bacterial', 'Put_nitroreductase_C_bac', 5, NULL),
(19301, NULL, 'IPR018045', NULL, 'Sulphate anion transporter, conserved site', 'S04_transporter_CS', 2, NULL),
(19302, NULL, 'IPR019545', NULL, 'DM13 domain', 'DM13_domain', 3, NULL),
(19303, NULL, 'IPR020726', NULL, 'Apoptosis regulator, Bcl-2, BH2 motif, conserved site', 'Bcl2_BH2_motif_CS', 2, NULL),
(19304, NULL, 'IPR021699', NULL, 'Protein of unknown function DUF3281', 'DUF3281', 4, NULL),
(19305, NULL, 'IPR019552', NULL, 'Histidine-rich calcium-binding', 'Hist_rich_Ca-bd', 7, NULL),
(19306, NULL, 'IPR018805', NULL, 'Cell wall protein YJL171C/Tos1, C-terminal', 'YJL171C/Tos1_C', 3, NULL),
(19307, NULL, 'IPR019533', NULL, 'Peptidase S26', 'Peptidase_S26', 3, NULL),
(19308, NULL, 'IPR020404', NULL, 'Protein of unknown function DUF2713', 'DUF2713', 3, NULL),
(19309, NULL, 'IPR019559', NULL, 'Cullin protein, neddylation domain', 'Cullin_neddylation_domain', 3, NULL),
(19310, NULL, 'IPR020261', NULL, 'Protein of unknown function DUF5493', 'DUF5493', 4, NULL),
(19311, NULL, 'IPR023358', NULL, 'Peptidase M18, domain 2', 'Peptidase_M18_dom2', 5, NULL),
(19312, NULL, 'IPR017983', NULL, 'GPCR, family 2, secretin-like, conserved site', 'GPCR_2_secretin-like_CS', 2, NULL),
(19313, NULL, 'IPR019542', NULL, 'Enhancer of polycomb-like, N-terminal', 'Enhancer_polycomb-like_N', 3, NULL),
(19314, NULL, 'IPR021801', NULL, 'Protein of unknown function DUF3370', 'DUF3370', 4, NULL),
(19315, NULL, 'IPR018061', NULL, 'Retropepsins', 'Retropepsins', 3, NULL),
(19316, NULL, 'IPR021705', NULL, 'Protein of unknown function DUF3288', 'DUF3288', 4, NULL),
(19317, NULL, 'IPR017938', NULL, 'Riboflavin synthase-like beta-barrel', 'Riboflavin_synthase-like_b-brl', 5, NULL),
(19318, NULL, 'IPR018507', NULL, 'Cytochrome c oxidase, subunit VIa, conserved site', 'Cyt_c_oxidase_su6a_CS', 2, NULL),
(19319, NULL, 'IPR020806', NULL, 'Polyketide synthase, phosphopantetheine-binding domain', 'PKS_PP-bd', 3, NULL),
(19320, NULL, 'IPR017796', NULL, 'Tryptophan dimethylallyltransferase', 'Trp_dimethylallylTrfase', 4, NULL),
(19321, NULL, 'IPR017788', NULL, 'DnaA regulatory inactivator Hda', 'Hda', 4, NULL),
(19322, NULL, 'IPR021685', NULL, 'Major surface protein 1a (MSP1a)', 'MSP1a', 4, NULL),
(19323, NULL, 'IPR020831', NULL, 'Glyceraldehyde/Erythrose phosphate dehydrogenase family', 'GlycerAld/Erythrose_P_DH', 4, NULL),
(19324, NULL, 'IPR020518', NULL, 'Transcription regulator PrtN', 'Tscrpt_reg_PrtN', 4, NULL),
(19325, NULL, 'IPR021714', NULL, 'Nucleolar pre-ribosomal-associated protein 1, N-terminal', 'Npa1_N', 3, NULL),
(19326, NULL, 'IPR017996', NULL, 'Major royal jelly protein/protein yellow', 'Royal_jelly/protein_yellow', 4, NULL),
(19327, NULL, 'IPR021744', NULL, 'Cobalamin synthesis G, N-terminal', 'CbiG_N', 3, NULL),
(19328, NULL, 'IPR016627', NULL, 'Uncharacterised conserved protein UCP015013', 'UCP015013', 4, NULL),
(19329, NULL, 'IPR020362', NULL, 'Tail accessory factor GP4', 'Tail_accessory_Gp4', 4, NULL),
(19330, NULL, 'IPR018797', NULL, 'FAM98', 'FAM98', 4, NULL),
(19331, NULL, 'IPR020317', NULL, 'Uncharacterised protein family YjbD', 'Uncharacterised_YjbD', 4, NULL),
(19332, NULL, 'IPR021718', NULL, 'Pre-mRNA 3''-end-processing endonuclease polyadenylation factor C-term', 'CPSF73-100_C', 3, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(19333, NULL, 'IPR018798', NULL, 'Multivesicular body subunit 12', 'MVB12A/B', 4, NULL),
(19334, NULL, 'IPR020401', NULL, 'mRNA transport factor GFD1', 'mRNA_transport_factor_GFD1', 4, NULL),
(19335, NULL, 'IPR021177', NULL, 'Serum albumin/Alpha-fetoprotein/Afamin', 'Serum_albumin/AFP/Afamin', 4, NULL),
(19336, NULL, 'IPR021800', NULL, 'Domain of unknown function DUF3369', 'DUF3369', 3, NULL),
(19337, NULL, 'IPR021762', NULL, 'Protein of unknown function DUF3325', 'DUF3325', 4, NULL),
(19338, NULL, 'IPR021782', NULL, 'Protein of unknown function DUF3347', 'DUF3347', 3, NULL),
(19339, NULL, 'IPR024966', NULL, 'Primase helical domain', 'Primase_helical_domain', 3, NULL),
(19340, NULL, 'IPR020311', NULL, 'Uncharacterised protein family, Rv0898c', 'Uncharacterised_Rv0898c', 4, NULL),
(19341, NULL, 'IPR020578', NULL, 'Aminotransferase class-V, pyridoxal-phosphate binding site', 'Aminotrans_V_PyrdxlP_BS', 1, NULL),
(19342, NULL, 'IPR019531', NULL, 'Peroxisomal membrane protein 4', 'Pmp4', 4, NULL),
(19343, NULL, 'IPR021751', NULL, 'Protein of unknown function DUF3318', 'DUF3318', 4, NULL),
(19344, NULL, 'IPR018780', NULL, 'BLOC-1-related complex subunit 5', 'TBORCS5', 4, NULL),
(19345, NULL, 'IPR021693', NULL, 'Protein of unknown function DUF3275', 'DUF3275', 4, NULL),
(19346, NULL, 'IPR021727', NULL, 'Protein of unknown function DUF3299', 'DUF3299', 4, NULL),
(19347, NULL, 'IPR016605', NULL, 'High-affinity nitrate transporter', 'Transptr_NO3_Nar2', 4, NULL),
(19348, NULL, 'IPR020579', NULL, 'Exonuclease VII, large subunit, C-terminal', 'Exonuc_VII_lsu_C', 3, NULL),
(19349, NULL, 'IPR021702', NULL, 'Protein of unknown function DUF3285', 'DUF3285', 4, NULL),
(19350, NULL, 'IPR019204', NULL, 'Domain of unknown function DUF2070, membrane', 'DUF2070_membrane', 3, NULL),
(19351, NULL, 'IPR019538', NULL, '26S proteasome non-ATPase regulatory subunit 5', 'PSMD5', 4, NULL),
(19352, NULL, 'IPR020394', NULL, 'Uncharacterised protein family, FAM23-like, transmembrane', 'Uncharacterised_FAM23-like_TM', 4, NULL),
(19353, NULL, 'IPR017823', NULL, 'Bisanhydrobacterioruberin hydratase CruF', 'CruF', 4, NULL),
(19354, NULL, 'IPR020274', NULL, 'Uncharacterised protein family HI1496', 'Uncharacterised_HI1496', 4, NULL),
(19355, NULL, 'IPR017814', NULL, 'Mycothiol biosynthesis protein, MshA', 'Mycothiol_biosynthesis_MshA', 4, NULL),
(19356, NULL, 'IPR017780', NULL, 'ABC transporter, urea, ATP-binding protein, UrtE', 'ABC_transptr_urea_ATP-bd_UrtE', 4, NULL),
(19357, NULL, 'IPR021769', NULL, 'Protein of unknown function DUF3331', 'DUF3331', 4, NULL),
(19358, NULL, 'IPR016624', NULL, 'Uncharacterised conserved protein UCP014753', 'UCP014753', 4, NULL),
(19359, NULL, 'IPR020616', NULL, 'Thiolase, N-terminal', 'Thiolase_N', 3, NULL),
(19360, NULL, 'IPR020728', NULL, 'Apoptosis regulator, Bcl-2, BH3 motif, conserved site', 'Bcl2_BH3_motif_CS', 2, NULL),
(19361, NULL, 'IPR021719', NULL, 'Proteinase inhibitor I78', 'Prot_inh_I78', 4, NULL),
(19362, NULL, 'IPR021775', NULL, 'Protein of unknown function DUF3339', 'DUF3339', 4, NULL),
(19363, NULL, 'IPR018004', NULL, 'KilA, N-terminal/APSES-type HTH, DNA-binding', 'KilA_N/APSES_HTH', 3, NULL),
(19364, NULL, 'IPR021770', NULL, 'Protein of unknown function DUF3335', 'DUF3335', 4, NULL),
(19365, NULL, 'IPR019224', NULL, 'Protein of unknown function DUF2148', 'DUF2148', 3, NULL),
(19366, NULL, 'IPR021701', NULL, 'Protein of unknown function DUF3284', 'DUF3284', 4, NULL),
(19367, NULL, 'IPR020367', NULL, 'Host transcription inhibitor Alc', 'Host_transcript_inhib_Alc', 4, NULL),
(19368, NULL, 'IPR021692', NULL, 'Protein of unknown function DUF3274', 'DUF3274', 4, NULL),
(19369, NULL, 'IPR017782', NULL, 'Hydroxyacylglutathione hydrolase', 'Hydroxyacylglutathione_Hdrlase', 4, NULL),
(19370, NULL, 'IPR019236', NULL, 'Phosphatidate phosphatase APP1, catalytic domain', 'APP1_cat', 3, NULL),
(19371, NULL, 'IPR021736', NULL, 'Protein of unknown function DUF3305', 'DUF3305', 4, NULL),
(19372, NULL, 'IPR017775', NULL, 'Alcohol dehydrogenase, iron-type,  phosphonate metabolism-associated', 'ADH_Fe_phosphonate-assoc', 4, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(19373, NULL, 'IPR018782', NULL, 'Essential MCU regulator, mitochondrial', 'MCU_reg', 4, NULL),
(19374, NULL, 'IPR021794', NULL, 'Protein of unknown function DUF3360', 'DUF3360', 4, NULL),
(19375, NULL, 'IPR021683', NULL, 'Putative zincin peptidase', 'DUF3267', 4, NULL),
(19376, NULL, 'IPR021786', NULL, 'Pre-mRNA splicing factor component Cdc5p/Cef1, C-terminal', 'Cdc5p/Cef1_C', 3, NULL),
(19377, NULL, 'IPR016621', NULL, 'Uncharacterised conserved protein UCP014543', 'UCP014543', 4, NULL),
(19378, NULL, 'IPR021684', NULL, 'WW domain-binding protein 1-like', 'WBP1-like', 4, NULL),
(19379, NULL, 'IPR021697', NULL, 'Protein of unknown function DUF3278', 'DUF3278', 4, NULL),
(19380, NULL, 'IPR018291', NULL, '5 transmembrane protein, Schizosaccharomyces pombe', '5TM-prot_SCHPO', 4, NULL),
(19381, NULL, 'IPR019530', NULL, 'Intra-flagellar transport protein 57', 'Intra-flagellar_transport_57', 4, NULL),
(19382, NULL, 'IPR017790', NULL, 'Penicillin-binding protein 2', 'Penicillin-binding_protein_2', 4, NULL),
(19383, NULL, 'IPR021732', NULL, 'Protein of unknown function DUF3301', 'DUF3301', 4, NULL),
(19384, NULL, 'IPR018789', NULL, 'Flocculin 11 domain', 'Flo11', 3, NULL),
(19385, NULL, 'IPR019549', NULL, 'Homeobox engrailed, C-terminal', 'Homeobox-engrailed_C-terminal', 3, NULL),
(19386, NULL, 'IPR019218', NULL, 'Protein of unknown function DUF2119', 'DUF2119', 4, NULL),
(19387, NULL, 'IPR019572', NULL, 'Ubiquitin-activating enzyme, SCCH domain', 'UBA_E1_SCCH', 3, NULL),
(19388, NULL, 'IPR021767', NULL, 'Transposon Tn21 modulator protein', 'TnpM', 4, NULL),
(19389, NULL, 'IPR016626', NULL, 'Uncharacterised conserved protein UCP014897, archaea', 'UCP014897_arc', 4, NULL),
(19390, NULL, 'IPR019564', NULL, 'Mitochondrial outer membrane transport complex Sam37/metaxin, N-terminal domain', 'Sam37/metaxin_N', 3, NULL),
(19391, NULL, 'IPR018795', NULL, 'Uncharacterized protein KIAA2013-like', 'K2013-like', 4, NULL),
(19392, NULL, 'IPR016611', NULL, 'Mitochondrial intermembrane space cysteine motif-containing protein Mix14', 'Mix14', 4, NULL),
(19393, NULL, 'IPR018289', NULL, 'MULE transposase domain', 'MULE_transposase_dom', 3, NULL),
(19394, NULL, 'IPR019529', NULL, 'SNARE-complex protein Syntaxin-18, N-terminal', 'Syntaxin-18_N', 3, NULL),
(19395, NULL, 'IPR021690', NULL, 'Protein of unknown function DUF3272', 'DUF3272', 4, NULL),
(19396, NULL, 'IPR021766', NULL, 'Phosphate regulon sensor protein PhoR', 'PhoR', 4, NULL),
(19397, NULL, 'IPR019539', NULL, 'Galactokinase, N-terminal  domain', 'GalKase_N', 3, NULL),
(19398, NULL, 'IPR021776', NULL, 'Alternative complex III, ActD subunit', 'ActD', 4, NULL),
(19399, NULL, 'IPR017794', NULL, 'Urea carboxylase-associated, permease', 'Urea_CO2ase-assoc_permease', 4, NULL),
(19400, NULL, 'IPR016614', NULL, 'Mitochondrial holo-[acyl-carrier-protein] synthase Ppt2', 'PPTase_2', 4, NULL),
(19401, NULL, 'IPR016644', NULL, 'T-DNA border endonuclease virD2', 'VirD2', 4, NULL),
(19402, NULL, 'IPR021739', NULL, 'SaV-like', 'SaV-like', 4, NULL),
(19403, NULL, 'IPR019557', NULL, 'Aminotransferase-like, plant mobile domain', 'AminoTfrase-like_pln_mobile', 3, NULL),
(19404, NULL, 'IPR019562', NULL, 'Micronemal adhesive repeat, sialic-acid binding', 'Micronemal-adhesive-rpt_sia-bd', 7, NULL),
(19405, NULL, 'IPR020479', NULL, 'Homeobox domain, metazoa', 'Homeobox_metazoa', 3, NULL),
(19406, NULL, 'IPR020253', NULL, 'Torovirus, nucleocapsid protein', 'Torovirus_nucleocapsid', 4, NULL),
(19407, NULL, 'IPR034885', NULL, 'Neutrophil cytosol factor 2, PB1 domain', 'PB1_P67', 3, NULL),
(19408, NULL, 'IPR016628', NULL, 'ATPase, SAG2001, predicted', 'ATPase_SAG2001_prd', 4, NULL),
(19409, NULL, 'IPR021790', NULL, 'PTBP1-like, RNA recognition motif 2', 'PTBP1-like_RRM2', 3, NULL),
(19410, NULL, 'IPR021755', NULL, 'Transcription factor Aft1, HRA domain', 'TF_Aft1_HRA', 3, NULL),
(19411, NULL, 'IPR021805', NULL, 'Peptidase M10A, matrix metallopeptidase, C-terminal', 'Pept_M10A_metallopeptidase_C', 3, NULL),
(19412, NULL, 'IPR021681', NULL, 'Protein of unknown function DUF3265', 'DUF3265', 4, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(19413, NULL, 'IPR021754', NULL, 'Domain of unknown function DUF3320', 'DUF3320', 3, NULL),
(19414, NULL, 'IPR018527', NULL, 'Rubredoxin, iron-binding site', 'Rubredoxin_Fe_BS', 1, NULL),
(19415, NULL, 'IPR021781', NULL, 'Replication initiator protein RctB, central region', 'RctB_central_dom', 3, NULL),
(19416, NULL, 'IPR024660', NULL, 'UNC-45/Cro1/She4, central domain', 'UCS_central_dom', 3, NULL),
(19417, NULL, 'IPR020254', NULL, 'Protein of unknown function DUF2626', 'DUF2626', 4, NULL),
(19418, NULL, 'IPR016606', NULL, 'Uncharacterised conserved protein UCP012943', 'UCP012943', 4, NULL),
(19419, NULL, 'IPR024965', NULL, 'Putative integrase', 'Putative_integrase', 4, NULL),
(19420, NULL, 'IPR020787', NULL, 'Ribonuclease HII, archaea', 'RNase_HII_arc', 4, NULL),
(19421, NULL, 'IPR020314', NULL, 'Uncharacterised protein family YpzA', 'Uncharacterised_YpzA', 4, NULL),
(19422, NULL, 'IPR023362', NULL, 'PH-BEACH domain', 'PH-BEACH_dom', 3, NULL),
(19423, NULL, 'IPR016616', NULL, 'Bardet-Biedl syndrome 2 protein', 'Bardet-Biedl_syndrome_2_prot', 4, NULL),
(19424, NULL, 'IPR019202', NULL, 'Protein of unknown function DUF2067', 'DUF2067', 4, NULL),
(19425, NULL, 'IPR016641', NULL, 'Nascent polypeptide-associated complex subunit alpha', 'EGD2/NACA', 4, NULL),
(19426, NULL, 'IPR017785', NULL, 'Choline-sulfatase', 'Choline-sulfatase', 4, NULL),
(19427, NULL, 'IPR019209', NULL, 'Protein of unknown function DUF2098', 'DUF2098', 4, NULL),
(19428, NULL, 'IPR017812', NULL, 'Mycothiol ligase MshC', 'Mycothiol_ligase_MshC', 4, NULL),
(19429, NULL, 'IPR019235', NULL, 'Protein of unknown function DUF2178, transmembrane', 'DUF2178_TM', 4, NULL),
(19430, NULL, 'IPR018526', NULL, 'Glycoside hydrolase, family 29, conserved site', 'Glyco_hydro_29_CS', 2, NULL),
(19431, NULL, 'IPR016618', NULL, 'Uncharacterised conserved protein UCP014422', 'UCP014422', 4, NULL),
(19432, NULL, 'IPR021716', NULL, 'Thrombin inhibitor Madanin', 'Inhibitor_I53', 3, NULL),
(19433, NULL, 'IPR019214', NULL, 'Protein of unknown function DUF2109, membrane', 'DUF2109_membrane', 4, NULL),
(19434, NULL, 'IPR017822', NULL, 'Carotene biosynthesis-associated membrane protein, type-1', 'Carotene_biosyn-assoc_mem-1', 4, NULL),
(19435, NULL, 'IPR019231', NULL, 'Protein of unknown function DUF2170', 'DUF2170', 4, NULL),
(19436, NULL, 'IPR021758', NULL, 'Baculoviridae late expression factor 5, C-terminal', 'Baculo_LEF5_C', 3, NULL),
(19437, NULL, 'IPR016607', NULL, 'Protein SCAI, metazoan/viridiplantae', 'SCAI_metazoan/Viridiplantae', 4, NULL),
(19438, NULL, 'IPR017791', NULL, 'Urea carboxylase-associated protein 1', 'Urea_carboxylase-assoc_1', 4, NULL),
(19439, NULL, 'IPR017824', NULL, 'Aminodeoxychorismate lyase, class IV', 'Aminodeoxychorismate_lyase_IV', 4, NULL),
(19440, NULL, 'IPR016634', NULL, 'WYL domain protein, s026 type', 'WYL_dom_s026', 4, NULL),
(19441, NULL, 'IPR021772', NULL, 'WDR48/Bun107', 'WDR48/Bun107', 4, NULL),
(19442, NULL, 'IPR021789', NULL, 'KHA domain', 'KHA_dom', 3, NULL),
(19443, NULL, 'IPR019213', NULL, 'Protein of unknown function DUF2108, membrane', 'DUF2108_membrane', 4, NULL),
(19444, NULL, 'IPR018510', NULL, 'Diaminopimelate epimerase, active site', 'DAP_epimerase_AS', 0, NULL),
(19445, NULL, 'IPR017802', NULL, 'VWFA-related, acidobacterial-type', 'VWFA-rel_acidobac-type', 4, NULL),
(19446, NULL, 'IPR020233', NULL, 'GSE/EGO complex subunit Slm4', 'Slm4', 4, NULL),
(19447, NULL, 'IPR018523', NULL, 'Isocitrate lyase/phosphorylmutase, conserved site', 'Isocitrate_lyase_ph_CS', 2, NULL),
(19448, NULL, 'IPR019225', NULL, 'Protein of unknown function DUF2155', 'DUF2155', 4, NULL),
(19449, NULL, 'IPR017819', NULL, 'Plasmid partitioning protein, RepB', 'Plasmid_partition_RepB', 4, NULL),
(19450, NULL, 'IPR018808', NULL, 'Muniscin C-terminal', 'Muniscin_C', 3, NULL),
(19451, NULL, 'IPR019546', NULL, 'Twin-arginine translocation pathway, signal sequence, bacterial/archaeal', 'TAT_signal_bac_arc', 2, NULL),
(19452, NULL, 'IPR021750', NULL, 'Septation initiation Sid4-like', 'Sid4-like', 4, NULL),
(19453, NULL, 'IPR021799', NULL, 'Protein of unknown function DUF3368', 'DUF3368', 4, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(19454, NULL, 'IPR024758', NULL, 'Inheritance of peroxisomes protein 1', 'Inp1', 4, NULL),
(19455, NULL, 'IPR021749', NULL, 'Competence system putative prepilin ComGE', 'ComGE', 4, NULL),
(19456, NULL, 'IPR021706', NULL, 'Protein of unknown function DUF2990', 'DUF2990', 4, NULL),
(19457, NULL, 'IPR019238', NULL, 'Transcriptional regulator, AbiEi 2 antitoxin, Type IV TA system', 'AbiEi_2', 4, NULL),
(19458, NULL, 'IPR019540', NULL, 'Phosphatidylinositol-glycan biosynthesis class S protein', 'PtdIno-glycan_biosynth_class_S', 4, NULL),
(19459, NULL, 'IPR020256', NULL, 'Spore coat protein CotJA', 'Spore_coat_CotJA', 4, NULL),
(19460, NULL, 'IPR017804', NULL, 'Methyltransferase EgtD-like', 'MeTrfase_EgtD-like', 4, NULL),
(19461, NULL, 'IPR021783', NULL, 'Protein of unknown function DUF3348', 'DUF3348', 4, NULL),
(19462, NULL, 'IPR019541', NULL, 'Trappin protein transglutaminase-binding repeat', 'Trappin_transglut-bd_rpt', 7, NULL),
(19463, NULL, 'IPR034790', NULL, 'RBM20, RNA recognition motif', 'RBM20_RRM', 3, NULL),
(19464, NULL, 'IPR017808', NULL, 'Ergothioneine biosynthesis protein EgtC', 'EgtC', 4, NULL),
(19465, NULL, 'IPR034733', NULL, 'Acetyl-CoA carboxylase', 'AcCoA_carboxyl', 3, NULL),
(19466, NULL, 'IPR021689', NULL, 'Protein of unknown function DUF3271', 'DUF3271', 4, NULL),
(19467, NULL, 'IPR021761', NULL, 'UDP-glucuronate decarboxylase N-terminal', 'UXS1_N', 3, NULL),
(19468, NULL, 'IPR021122', NULL, 'RNA ligase domain, REL/Rln2', 'RNA_ligase_dom_REL/Rnl2', 3, NULL),
(19469, NULL, 'IPR018803', NULL, 'Ish1/Msc1-like', 'Ish1/Msc1-like', 7, NULL),
(19470, NULL, 'IPR019211', NULL, 'Energy-converting hydrogenase subunit EhaL', 'EhaL', 4, NULL),
(19471, NULL, 'IPR018066', NULL, 'Tubby, C-terminal, conserved site', 'Tubby_C_CS', 2, NULL),
(19472, NULL, 'IPR021809', NULL, 'Protein of unknown function DUF3386', 'DUF3386', 4, NULL),
(19473, NULL, 'IPR016617', NULL, 'Armadillo repeat-containing protein 1', 'ARMC1', 4, NULL),
(19474, NULL, 'IPR018791', NULL, 'UV radiation resistance protein/autophagy-related protein 14', 'UV_resistance/autophagy_Atg14', 4, NULL),
(19475, NULL, 'IPR019534', NULL, 'Protein of unknown function DUF2452', 'DUF2452', 4, NULL),
(19476, NULL, 'IPR016625', NULL, 'Uncharacterised conserved protein UCP014872, subtilisin-related', 'UCP014872_subtilisin-rel', 4, NULL),
(19477, NULL, 'IPR019206', NULL, 'Protein of unknown function DUF2085, transmembrane', 'DUF2085_TM', 4, NULL),
(19478, NULL, 'IPR016610', NULL, 'Exonuclease V, Saccharomyces', 'Exo5', 4, NULL),
(19479, NULL, 'IPR017946', NULL, 'PLC-like phosphodiesterase, TIM beta/alpha-barrel domain superfamily', 'PLC-like_Pdiesterase_TIM-brl', 5, NULL),
(19480, NULL, 'IPR020460', NULL, 'Zinc finger, DksA/TraR C4-type, bacteria', 'Znf_C4-type_bac', 3, NULL),
(19481, NULL, 'IPR016608', NULL, 'PR domain zinc finger protein 1', 'PRDM1', 4, NULL),
(19482, NULL, 'IPR018784', NULL, 'Learning associated protein 18-like', 'LAPS18-like', 4, NULL),
(19483, NULL, 'IPR019223', NULL, 'Domain of unknown function DUF2147', 'DUF2147', 3, NULL),
(19484, NULL, 'IPR024764', NULL, 'Transcription factor IIIC, putative zinc-finger', 'TFIIIC_Znf', 3, NULL),
(19485, NULL, 'IPR024659', NULL, 'Major capsid protein Gp5', 'Phage_coat_Gp5', 4, NULL),
(19486, NULL, 'IPR021711', NULL, 'Protein of unknown function DUF3295', 'DUF3295', 4, NULL),
(19487, NULL, 'IPR021713', NULL, 'Folliculin', 'Folliculin', 4, NULL),
(19488, NULL, 'IPR021741', NULL, 'Protein of unknown function DUF3311', 'DUF3311', 4, NULL),
(19489, NULL, 'IPR018776', NULL, 'Membrane protein, 6-pyruvoyl-tetrahydropterin synthase-related domain', 'Membrane_prot_PTPS-rel_domain', 3, NULL),
(19490, NULL, 'IPR034706', NULL, 'Cell division coordinator CpoB', 'CpoB', 4, NULL),
(19491, NULL, 'IPR018034', NULL, 'KRR1 interacting protein 1', 'Kri1', 4, NULL),
(19492, NULL, 'IPR021712', NULL, 'Uncharacterised domain UPF0506', 'UPF0506', 3, NULL),
(19493, NULL, 'IPR024765', NULL, 'TOBE-like domain', 'TOBE-like', 3, NULL),
(19494, NULL, 'IPR021704', NULL, 'Protein of unknown function DUF3287', 'DUF3287', 4, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(19495, NULL, 'IPR017979', NULL, 'GPCR, family 3, conserved site', 'GPCR_3_CS', 2, NULL),
(19496, NULL, 'IPR016638', NULL, 'Uncharacterised protein family UPF0376', 'UPF0376', 4, NULL),
(19497, NULL, 'IPR021734', NULL, 'Protein of unknown function DUF3303', 'DUF3303', 4, NULL),
(19498, NULL, 'IPR021724', NULL, 'Protein of unknown function DUF3297', 'DUF3297', 4, NULL),
(19499, NULL, 'IPR021812', NULL, 'Protein of unknown function DUF3391', 'DUF3391', 3, NULL),
(19500, NULL, 'IPR016261', NULL, 'Folic acid synthesis protein FOL1', 'Folic_acid_synth', 4, NULL),
(19501, NULL, 'IPR018332', NULL, 'Antenna complex, alpha subunit', 'Antenna_alpha', 4, NULL),
(19502, NULL, 'IPR018257', NULL, 'Ribosomal protein L19, conserved site', 'Ribosomal_L19_CS', 2, NULL),
(19503, NULL, 'IPR021115', NULL, 'Pyridoxal-phosphate binding site', 'Pyridoxal-P_BS', 1, NULL),
(19504, NULL, 'IPR020469', NULL, 'Cytochrome P450, CYP2 family', 'Cyt_P450_CYP2_fam', 4, NULL),
(19505, NULL, 'IPR021846', NULL, 'NFACT protein, C-terminal', 'NFACT-C', 3, NULL),
(19506, NULL, 'IPR017053', NULL, 'Response regulator  B-type, plant', 'Response_reg_B-typ_pln', 4, NULL),
(19507, NULL, 'IPR020379', NULL, 'Protein of unknown function DUF5448', 'DUF5448', 4, NULL),
(19508, NULL, 'IPR019257', NULL, 'Histidine-specific methyltransferase, SAM-dependent', 'MeTrfase_dom', 3, NULL),
(19509, NULL, 'IPR034194', NULL, 'Mrn1, RNA recognition motif 2', 'Mrn1_RRM2', 3, NULL),
(19510, NULL, 'IPR020346', NULL, 'Uncharacterised protein family 15.3kDa', 'Uncharacterised_15.3kDa', 4, NULL),
(19511, NULL, 'IPR020355', NULL, 'Uncharacterised protein family YhcU', 'Uncharacterised_YhcU', 4, NULL),
(19512, NULL, 'IPR020348', NULL, 'Uncharacterised protein family YvaD', 'Uncharacterised_YvaD', 4, NULL),
(19513, NULL, 'IPR021827', NULL, 'Nucleoporin Nup186/Nup192/Nup205', 'Nup186/Nup192/Nup205', 4, NULL),
(19514, NULL, 'IPR017828', NULL, 'Squalene synthase HpnD-like', 'SQ_synth_HpnD-like', 4, NULL),
(19515, NULL, 'IPR021879', NULL, 'Ribosomal S4P (gammaproteobacterial)', 'Ribosomal_S4Pg', 4, NULL),
(19516, NULL, 'IPR023264', NULL, 'ABC transporter, acetoin utilisation, predicted permease Ytrc/YtrD', 'ABC_transptr_acetoin_YtrC/YtrD', 4, NULL),
(19517, NULL, 'IPR034115', NULL, 'Peptidyl-Lys metallopeptidase catalytic domain', 'M35_peptidyl-Lys', 3, NULL),
(19518, NULL, 'IPR018204', NULL, 'Tryptophan synthase, alpha chain, active site', 'Trp_synthase_alpha_AS', 0, NULL),
(19519, NULL, 'IPR017069', NULL, 'Maltodextrin glucosidase', 'MalZ', 4, NULL),
(19520, NULL, 'IPR016284', NULL, 'Bacteriophage PRD1, P15, lysozyme', 'Phage_PRD1_P15_lysozyme', 4, NULL),
(19521, NULL, 'IPR017834', NULL, 'Hopanoid biosynthesis associated radical SAM protein HpnJ', 'Hopanoid_synth-assoc_rSAM_HpnJ', 4, NULL),
(19522, NULL, 'IPR018063', NULL, 'SAM-dependent methyltransferase RsmI, conserved site', 'SAM_MeTrfase_RsmI_CS', 2, NULL),
(19523, NULL, 'IPR021892', NULL, 'RNA helicase NPH-II', 'NPH-II', 4, NULL),
(19524, NULL, 'IPR017073', NULL, 'Hepatocyte growth factor-regulated tyrosine kinase substrate/VPS27', 'HGS/VPS27', 4, NULL),
(19525, NULL, 'IPR018525', NULL, 'Mini-chromosome maintenance, conserved site', 'MCM_CS', 2, NULL),
(19526, NULL, 'IPR016648', NULL, 'Uncharacterised conserved protein UCP016175, prenyltransferase beta-subunit-related', 'UCP016175_prenyltrans-rel', 4, NULL),
(19527, NULL, 'IPR019250', NULL, 'Protein of unknown function DUF2227, metal-binding', 'DUF2227_metal-bd', 4, NULL),
(19528, NULL, 'IPR021859', NULL, 'XRN2-binding (XTBD) domain', 'XTBD', 3, NULL),
(19529, NULL, 'IPR016270', NULL, 'CDP-alcohol phosphatidyltransferase class-II family', 'PGS1', 4, NULL),
(19530, NULL, 'IPR021841', NULL, 'Vacuolar protein 14, C-terminal Fig4-binding domain', 'VAC14_Fig4p-bd', 3, NULL),
(19531, NULL, 'IPR021862', NULL, 'Protein of unknown function DUF3472', 'DUF3472', 4, NULL),
(19532, NULL, 'IPR018812', NULL, 'Swiss Army Knife RNA repair protein, HAD domain', 'SAK_HAD', 3, NULL),
(19533, NULL, 'IPR018252', NULL, 'Annexin repeat, conserved site', 'Annexin_repeat_CS', 2, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(19534, NULL, 'IPR019260', NULL, 'Domain of unknown function DUF2262', 'DUF2262', 3, NULL),
(19535, NULL, 'IPR017051', NULL, 'Peptidase S1A, matripase', 'Peptidase_S1A_matripase', 4, NULL),
(19536, NULL, 'IPR021880', NULL, 'Protein of unknown function DUF3489', 'DUF3489', 4, NULL),
(19537, NULL, 'IPR019676', NULL, 'Domain of unknown function (DUF2529)', 'DUF2529', 3, NULL),
(19538, NULL, 'IPR020895', NULL, 'Frataxin conserved site', 'Frataxin_CS', 2, NULL),
(19539, NULL, 'IPR019265', NULL, 'RNA transcription, translation and transport factor protein', 'RTRAF', 4, NULL),
(19540, NULL, 'IPR016278', NULL, 'Dual specificity protein phosphatase 12', 'DUSP12', 4, NULL),
(19541, NULL, 'IPR017085', NULL, 'RNA editing complex, structural subunit MP81', 'RNA_edit_cplx_Nase-su_MP81', 4, NULL),
(19542, NULL, 'IPR020347', NULL, 'Ribonucleases P/MRP protein subunit Pop8', 'Pop8', 4, NULL),
(19543, NULL, 'IPR018304', NULL, 'Transcription regulator protein Rtt102', 'Rtt102', 4, NULL),
(19544, NULL, 'IPR019778', NULL, 'Hydrophobin, conserved site', 'Hydrophobin_CS', 2, NULL),
(19545, NULL, 'IPR035433', NULL, 'NFU1-like', 'NFU1-like', 4, NULL),
(19546, NULL, 'IPR018279', NULL, 'Ribosomal protein S21e, conserved site', 'Ribosomal_S21e_CS', 2, NULL),
(19547, NULL, 'IPR021922', NULL, 'Par3/HAL, N-terminal', 'Par3/HAL_N', 3, NULL),
(19548, NULL, 'IPR021866', NULL, 'SpoIIAA-like', 'SpoIIAA-like', 4, NULL),
(19549, NULL, 'IPR018267', NULL, 'Ribosomal protein L37e, conserved site', 'Ribosomal_L37e_CS', 2, NULL),
(19550, NULL, 'IPR016650', NULL, 'Eukaryotic translation initiation factor 3 subunit E', 'eIF3e', 4, NULL),
(19551, NULL, 'IPR016273', NULL, 'Erythromycin esterase, proteobacteria', 'Emycin_Estase_proteobac', 4, NULL),
(19552, NULL, 'IPR020903', NULL, 'Epithelial sodium channel, conserved site', 'ENaC_CS', 2, NULL),
(19553, NULL, 'IPR016314', NULL, 'Cell division protein Cdc6/18', 'Cdc6/18', 4, NULL),
(19554, NULL, 'IPR020877', NULL, 'Interleukin-1 conserved site', 'IL-1_CS', 2, NULL),
(19555, NULL, 'IPR023115', NULL, 'Translation initiation factor IF- 2, domain 3', 'TIF_IF2_dom3', 3, NULL),
(19556, NULL, 'IPR017043', NULL, 'Type I restriction-modification system, specificity subunit, predicted', 'HsdS_prd', 4, NULL),
(19557, NULL, 'IPR017049', NULL, 'Low density lipoprotein receptor-related protein 5/6', 'LRP5/6', 4, NULL),
(19558, NULL, 'IPR019287', NULL, 'Holliday junction resolvase-related domain', 'Hday_junct_resolvase-rel_dom', 3, NULL),
(19559, NULL, 'IPR016657', NULL, 'Phosphoacetylglucosamine mutase', 'PAGM', 4, NULL),
(19560, NULL, 'IPR017052', NULL, 'Atrial natriuretic peptide-converting enzyme corin', 'Corin', 4, NULL),
(19561, NULL, 'IPR017071', NULL, 'Transcription elongation factor Spt5, eukaryote', 'TF_Spt5_eukaryote', 4, NULL),
(19562, NULL, 'IPR021833', NULL, 'Protein of unknown function DUF3425', 'DUF3425', 4, NULL),
(19563, NULL, 'IPR021838', NULL, 'Protein of unknown function DUF3431', 'DUF3431', 4, NULL),
(19564, NULL, 'IPR020370', NULL, 'Protein of unknown function DUF5504', 'DUF5504', 4, NULL),
(19565, NULL, 'IPR023951', NULL, 'L-ascorbate-6-phosphate lactonase UlaG', 'L-ascorbate_6P_UlaG', 4, NULL),
(19566, NULL, 'IPR018820', NULL, 'Brefeldin A sensitivity protein-related, domain of unknown function DUF2421', 'BRE4-related_DUF2421', 3, NULL),
(19567, NULL, 'IPR016654', NULL, 'U6 snRNA-associated Sm-like protein LSm2', 'U6_snRNA_Lsm2', 4, NULL),
(19568, NULL, 'IPR020359', NULL, 'Biofilm regulator BssR', 'Biofilm_regulator_BssR', 4, NULL),
(19569, NULL, 'IPR020529', NULL, 'Origin recognition complex, subunit 6, metazoa/plant', 'ORC6_met/pln', 4, NULL),
(19570, NULL, 'IPR017840', NULL, 'DMSO reductase family, type II, molybdopterin subunit', 'DMSO_Rdtase_II_Mopterin_su', 4, NULL),
(19571, NULL, 'IPR020875', NULL, '3-phenylpropionate/cinnamic acid dioxygenase, alpha subunit', 'HcaE', 4, NULL),
(19572, NULL, 'IPR021869', NULL, 'Ribonuclease Zc3h12a-like, NYN domain', 'RNase_Zc3h12_NYN', 3, NULL),
(19573, NULL, 'IPR018271', NULL, 'Ribosomal protein S14, conserved site', 'Ribosomal_S14_CS', 2, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(19574, NULL, 'IPR035155', NULL, 'Protein of unknown function DUF5393', 'DUF5393', 4, NULL),
(19575, NULL, 'IPR019243', NULL, 'Domain of unknown function DUF2202', 'DUF2202', 3, NULL),
(19576, NULL, 'IPR016302', NULL, 'Anthranilate synthase component 2', 'Anthranilate_synth_II', 4, NULL),
(19577, NULL, 'IPR020369', NULL, 'Mobilisation protein B', 'Mobilisation_protein_B', 4, NULL),
(19578, NULL, 'IPR016305', NULL, 'Mannose-6-phosphate isomerase', 'Mannose-6-P_Isomerase', 4, NULL),
(19579, NULL, 'IPR021854', NULL, 'WASH1, WAHD domain', 'WASH1_WAHD', 3, NULL),
(19580, NULL, 'IPR019264', NULL, 'Domain of unknown function DUF2179', 'DUF2179', 3, NULL),
(19581, NULL, 'IPR018091', NULL, 'Phosphoenolpyruvate carboxykinase, GTP-utilising, conserved site', 'PEP_carboxykin_GTP_CS', 2, NULL),
(19582, NULL, 'IPR018821', NULL, 'Domain of unknown function DUF294, putative nucleotidyltransferase substrate-binding', 'DUF294_put_nucleoTrafse_sb-bd', 3, NULL),
(19583, NULL, 'IPR016281', NULL, 'Crossover junction endodeoxyribonuclease, RusA', 'Endonuclease_RusA', 4, NULL),
(19584, NULL, 'IPR017047', NULL, 'Teratocarcinoma-derived growth factor Cripto', 'Cripto_growth_factor', 4, NULL),
(19585, NULL, 'IPR018810', NULL, 'Uncharacterised protein family UPF0662', 'UPF0662', 4, NULL),
(19586, NULL, 'IPR017832', NULL, 'Glycosyl transferase, family 2, hopene-associated, HpnB', 'Glyco_trans_2_hopen-assoc_HpnB', 4, NULL),
(19587, NULL, 'IPR020386', NULL, 'Uncharacterised protein family YehE', 'Uncharacterised_YehE', 4, NULL),
(19588, NULL, 'IPR019242', NULL, 'Protein of unknown function DUF2198', 'DUF2198', 4, NULL),
(19589, NULL, 'IPR019273', NULL, 'Lunapark domain', 'Lunapark_dom', 3, NULL),
(19590, NULL, 'IPR019283', NULL, 'Protein of unknown function DUF2330', 'DUF2330', 4, NULL),
(19591, NULL, 'IPR018262', NULL, 'Ribosomal protein L27e, conserved site', 'Ribosomal_L27e_CS', 2, NULL),
(19592, NULL, 'IPR020354', NULL, 'Competence, DNA-entry nuclease inhibitor, ComJ', 'Competence_nuclease_inhibitor', 4, NULL),
(19593, NULL, 'IPR021868', NULL, 'Alpha-2-macroglobulin MG3 domain', 'Alpha_2_Macroglob_MG3', 3, NULL),
(19594, NULL, 'IPR021908', NULL, 'Protein of unknown function DUF3520', 'DUF3520', 4, NULL),
(19595, NULL, 'IPR017837', NULL, 'Plasmid replication initiator, RepA, IncFII type', 'Plasmid_rep_init_RepA_IncFII', 4, NULL),
(19596, NULL, 'IPR020400', NULL, 'Cecropin, insect', 'Cecropin_insect', 4, NULL),
(19597, NULL, 'IPR017070', NULL, 'Uncharacterised conserved protein UCP036920, phosphoglycerate mutase, plant X4/Y4', 'UCP036920_PGAM-like_plant', 4, NULL),
(19598, NULL, 'IPR016266', NULL, 'DNA polymerase epsilon, subunit B', 'POLE2', 4, NULL),
(19599, NULL, 'IPR021867', NULL, 'S-adenosylmethionine-dependent methyltransferase Bmt2-like', 'Bmt2/SAMTOR', 4, NULL),
(19600, NULL, 'IPR034984', NULL, 'IPPA , imelysin-like domain', 'Imelysin-like_IPPA', 3, NULL),
(19601, NULL, 'IPR021877', NULL, 'Protein of unknown function DUF3487', 'DUF3487', 4, NULL),
(19602, NULL, 'IPR021872', NULL, 'Protein of unknown function DUF3483', 'DUF3483', 4, NULL),
(19603, NULL, 'IPR019253', NULL, 'Protein of unknown function DUF2244, transmembrane', 'DUF2244_TM', 4, NULL),
(19604, NULL, 'IPR017843', NULL, 'DMSO reductase family, type II, chaperone', 'DMSO_Rdtase_II_chaperone', 4, NULL),
(19605, NULL, 'IPR018070', NULL, 'Neuromedin U, amidation site', 'Neuromedin-U_amidation-site', 6, NULL),
(19606, NULL, 'IPR017045', NULL, 'Maltose phosphorylase/glycosyl hydrolase/vacuolar acid trehalase', 'Malt_Pase/Glycosyl_Hdrlase', 4, NULL),
(19607, NULL, 'IPR017092', NULL, 'Peptidase S54, rhomboid-like, Rom4/Rom5, apicomplexa', 'Pept_S54_Rhomboid-like_Rom4/5', 4, NULL),
(19608, NULL, 'IPR020376', NULL, 'Uncharacterised protein family F46C5.1', 'Uncharacterised_F46C5.1', 4, NULL),
(19609, NULL, 'IPR016659', NULL, 'Transcription factor II-I', 'TF_II-I', 4, NULL),
(19610, NULL, 'IPR017072', NULL, 'Transcription elongation factor Spt6', 'TF_Spt6', 4, NULL),
(19611, NULL, 'IPR020466', NULL, 'Interleukin-15, mammal', 'IL-15_mml', 4, NULL),
(19612, NULL, 'IPR018256', NULL, 'Ribosomal protein L13e, conserved site', 'Ribosomal_L13e_CS', 2, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(19613, NULL, 'IPR018130', NULL, 'Ribosomal protein S2, conserved site', 'Ribosomal_S2_CS', 2, NULL),
(19614, NULL, 'IPR017088', NULL, 'Wax synthase, Magnoliopsida', 'Wax_synthase_Magnoliopsida', 4, NULL),
(19615, NULL, 'IPR020471', NULL, 'Aldo-keto reductase', 'AKR', 4, NULL),
(19616, NULL, 'IPR021917', NULL, 'Uncharacterised protein family, zinc metallopeptidase-like', 'Unchr_Zn-peptidase-like', 4, NULL),
(19617, NULL, 'IPR020373', NULL, 'Alpha-ketoglutarate dehydrogenase component 4/YMR-31', 'Kgd4/YMR-31', 4, NULL),
(19618, NULL, 'IPR021891', NULL, 'Telomerase ribonucleoprotein complex - RNA-binding domain', 'Telomerase_RBD', 3, NULL),
(19619, NULL, 'IPR020368', NULL, 'Uncharacterised protein family YbjM', 'Uncharacterised_YbjM', 4, NULL),
(19620, NULL, 'IPR021931', NULL, 'Protein kinase C-binding protein 1', 'ZMYND8', 4, NULL),
(19621, NULL, 'IPR018277', NULL, 'Ribosomal protein S19e, conserved site', 'Ribosomal_S19e_CS', 2, NULL),
(19622, NULL, 'IPR016286', NULL, 'Alpha-L-fucosidase, metazoa-type', 'FUC_metazoa-typ', 4, NULL),
(19623, NULL, 'IPR019678', NULL, 'Protein of unknown function DUF2555', 'DUF2555', 4, NULL),
(19624, NULL, 'IPR016285', NULL, 'Haemagglutinin-neuraminidase', 'Hemagglutn-neuramid', 4, NULL),
(19625, NULL, 'IPR021925', NULL, 'Large proline-rich protein BAG6', 'BAG6', 3, NULL),
(19626, NULL, 'IPR017055', NULL, 'Signal transduction histidine kinase, DctB (C4-dicarboxylate transport system regulator)', 'Sig_transdc_His_kinase_DctB', 4, NULL),
(19627, NULL, 'IPR021911', NULL, 'ATPase family AAA domain-containing protein 3, N-terminal', 'ATAD3_N', 3, NULL),
(19628, NULL, 'IPR016287', NULL, 'Beta-agarase', 'Beta_agarase', 4, NULL),
(19629, NULL, 'IPR021930', NULL, 'Heparan sulphate-N-deacetylase', 'Heparan_SO4_deacetylase', 3, NULL),
(19630, NULL, 'IPR021816', NULL, 'Dedicator of cytokinesis C/D, N-terminal', 'DOCK_C/D_N', 3, NULL),
(19631, NULL, 'IPR018823', NULL, 'Putative ER transporter, 6TM, N-terminal', 'ArAE_2_N', 3, NULL),
(19632, NULL, 'IPR020894', NULL, 'Cadherin conserved site', 'Cadherin_CS', 2, NULL),
(19633, NULL, 'IPR034242', NULL, 'Methylamine utilization protein MauL', 'MauL', 3, NULL),
(19634, NULL, 'IPR021914', NULL, 'Transcriptional factor DELLA, N-terminal', 'TF_DELLA_N', 3, NULL),
(19635, NULL, 'IPR019278', NULL, 'DICT domain', 'DICT_dom', 3, NULL),
(19636, NULL, 'IPR020363', NULL, 'Uncharacterised protein family YbgS', 'Uncharacterised_YbgS', 4, NULL),
(19637, NULL, 'IPR017056', NULL, 'Phosphoesterase, HI0762, predicted', 'P-Estase_HI0762_prd', 4, NULL),
(19638, NULL, 'IPR017075', NULL, 'mRNA capping enzyme, alpha subunit', 'mRNA_cap_enzyme_alpha', 4, NULL),
(19639, NULL, 'IPR023254', NULL, 'Aquaporin 6', 'Aquaporin_6', 4, NULL),
(19640, NULL, 'IPR021876', NULL, 'Retrograde transport protein Dsl1, C-terminal domain', 'Dsl1_C', 3, NULL),
(19641, NULL, 'IPR016300', NULL, 'Arsenical pump ATPase, ArsA/GET3', 'ATPase_ArsA/GET3', 4, NULL),
(19642, NULL, 'IPR016656', NULL, 'Transcription initiation factor TFIIE, beta subunit', 'TFIIE-bsu', 4, NULL),
(19643, NULL, 'IPR020270', NULL, 'Uncharacterised protein family, plasmid pXO2-34', 'Plasmid_pXO2-34', 4, NULL),
(19644, NULL, 'IPR035991', NULL, 'Casein kinase II subunit beta-like', 'Casein_kinase_II_beta-like', 5, NULL),
(19645, NULL, 'IPR020325', NULL, 'Uncharacterised protein family 16.1kDa', 'Uncharacterised_16.1kDa', 4, NULL),
(19646, NULL, 'IPR035161', NULL, 'Protein of unknown function DUF5332', 'DUF5332', 4, NULL),
(19647, NULL, 'IPR021863', NULL, 'Fatty acid desaturase, N-terminal', 'FAS_N', 3, NULL),
(19648, NULL, 'IPR018136', NULL, 'Aconitase family, 4Fe-4S cluster binding site', 'Aconitase_4Fe-4S_BS', 1, NULL),
(19649, NULL, 'IPR016292', NULL, 'Epoxide hydrolase', 'Epoxide_hydrolase', 4, NULL),
(19650, NULL, 'IPR020275', NULL, 'Family of unknown function DUF5592', 'DUF5592', 4, NULL),
(19651, NULL, 'IPR016272', NULL, 'Lipase, LIPH-type', 'Lipase_LIPH', 4, NULL),
(19652, NULL, 'IPR019266', NULL, '28S ribosomal protein S27, mitochondrial', 'MRPS27', 4, NULL),
(19653, NULL, 'IPR018287', NULL, 'Hap4 transcription factor, heteromerisation domain', 'Hap4_TF_heteromerisation', 3, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(19654, NULL, 'IPR016652', NULL, 'Ubiquitinyl hydrolase', 'Ubiquitinyl_hydrolase', 4, NULL),
(19655, NULL, 'IPR019282', NULL, 'Glycoamylase-like, conserved domain', 'Glycoamylase-like_cons_dom', 3, NULL),
(19656, NULL, 'IPR035445', NULL, 'GYF-like domain superfamily', 'GYF-like_dom_sf', 5, NULL),
(19657, NULL, 'IPR018814', NULL, 'Protein of unknown function DUF5427', 'DUF5427', 4, NULL),
(19658, NULL, 'IPR021113', NULL, 'Acyl-ACP-thioesterase, N-terminal', 'Acyl-ACP-thioesterase_N', 3, NULL),
(19659, NULL, 'IPR020390', NULL, 'Uncharacterised protein family YqhV', 'Uncharacterised_YqhV', 4, NULL),
(19660, NULL, 'IPR017829', NULL, 'Hopanoid-associated sugar epimerase', 'Hopanoid-assoc_sugar_epimerase', 4, NULL),
(19661, NULL, 'IPR018811', NULL, 'MIOREX complex component 11', 'Mrx11', 4, NULL),
(19662, NULL, 'IPR021934', NULL, 'Sox, C-terminal', 'Sox_C', 3, NULL),
(19663, NULL, 'IPR021849', NULL, 'Early growth response, N-terminal', 'EGR_N', 3, NULL),
(19664, NULL, 'IPR021845', NULL, 'Protein of unknown function DUF3440', 'DUF3440', 4, NULL),
(19665, NULL, 'IPR035015', NULL, 'Methylene tetrahydromethanopterin dehydrogenase, NADP-binding domain', 'NAD-bd_H4MPT_DH', 3, NULL),
(19666, NULL, 'IPR018251', NULL, 'Crustacean neurohormone, conserved site', 'Crust_neurhormone_CS', 2, NULL),
(19667, NULL, 'IPR020393', NULL, 'Uncharacterised protein family YusU', 'Uncharacterised_YusU', 4, NULL),
(19668, NULL, 'IPR020282', NULL, 'Arginine vasopressin-induced protein 1/transcriptional and immune response regulator', 'Avpi1/C8orf4_dom', 3, NULL),
(19669, NULL, 'IPR019674', NULL, 'Lipoprotein LpqN/LpqT-like', 'Lipoprotein_LpqN/LpqT-like', 4, NULL),
(19670, NULL, 'IPR035446', NULL, 'S-locus-specific glycoprotein/EP1', 'SLSG/EP1', 4, NULL),
(19671, NULL, 'IPR019284', NULL, 'Uncharacterized protein RP532', 'RP532', 4, NULL),
(19672, NULL, 'IPR017046', NULL, 'Prenylcysteine oxidase', 'Prenylcysteine_Oxase', 4, NULL),
(19673, NULL, 'IPR019675', NULL, 'Protein of unknown function DUF2550', 'DUF2550', 4, NULL),
(19674, NULL, 'IPR020366', NULL, 'INO80 complex subunit Ies5', 'Ies5', 4, NULL),
(19675, NULL, 'IPR018273', NULL, 'Ribosomal protein S17e, conserved site', 'Ribosomal_S17e_CS', 2, NULL),
(19676, NULL, 'IPR021825', NULL, 'Protein RETICULATA-related', 'RETICULATA-related', 4, NULL),
(19677, NULL, 'IPR021904', NULL, 'Protein of unknown function DUF3516', 'DUF3516', 4, NULL),
(19678, NULL, 'IPR016288', NULL, '1, 4-beta cellobiohydrolase', 'Beta_cellobiohydrolase', 4, NULL),
(19679, NULL, 'IPR034196', NULL, 'CELF1/2, RNA recognition motif 1', 'CELF1/2_RRM1', 3, NULL),
(19680, NULL, 'IPR021923', NULL, 'Protein of unknown function DUF3536', 'DUF3536', 4, NULL),
(19681, NULL, 'IPR020872', NULL, '2-phosphoglycerate kinase', '2PKG', 4, NULL),
(19682, NULL, 'IPR020453', NULL, 'Interleukin-22', 'IL-22', 4, NULL),
(19683, NULL, 'IPR021819', NULL, 'Far11/STRP, C-terminal', 'Far11/STRP_C', 3, NULL),
(19684, NULL, 'IPR020349', NULL, 'Uncharacterised protein family 14.7kDa', 'Uncharacterised_14.7kDa', 4, NULL),
(19685, NULL, 'IPR019672', NULL, 'Protein of unknown function DUF2627', 'DUF2527', 4, NULL),
(19686, NULL, 'IPR016304', NULL, 'Peptidyl-prolyl cis-trans isomerase E', 'PPIE', 4, NULL),
(19687, NULL, 'IPR020890', NULL, 'Transcription regulator HTH, HdfR', 'Tscrpt_reg_HTH_HdfR', 4, NULL),
(19688, NULL, 'IPR021889', NULL, 'Protein of unknown function DUF3500', 'DUF3500', 4, NULL),
(19689, NULL, 'IPR018825', NULL, 'Domain of unknown function DUF2427', 'DUF2427', 3, NULL),
(19690, NULL, 'IPR017089', NULL, 'Splicing factor 3B, subunit 5', 'Splicing_factor_3B_subunit_5', 4, NULL),
(19691, NULL, 'IPR020470', NULL, 'Interleukin-13', 'IL-13', 4, NULL),
(19692, NULL, 'IPR021828', NULL, 'Alpha-1,4-glucan:maltose-1-phosphate maltosyltransferase, domain N/S', 'GlgE_dom_N/S', 3, NULL),
(19693, NULL, 'IPR021818', NULL, 'Signal-induced proliferation-associated 1-like protein, C-terminal', 'SIPA1L_C', 3, NULL),
(19694, NULL, 'IPR018827', NULL, 'Uncharacterised domain YCR061W, C-terminal', 'Uncharacterised_YCR061W_C', 3, NULL),
(19695, NULL, 'IPR016289', NULL, 'Endo-beta-N-acetylglucosaminidase', 'Endo-Fsp', 4, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(19696, NULL, 'IPR021834', NULL, 'Protein of unknown function DUF3426', 'DUF3426', 4, NULL),
(19697, NULL, 'IPR023262', NULL, 'Active regulator of SIRT1', 'AROS', 4, NULL),
(19698, NULL, 'IPR016271', NULL, 'CDP-diacylglycerol--serine O-phosphatidyltransferase, fungal', 'CDP-diaglyc--ser_O-PTrfase_fun', 4, NULL),
(19699, NULL, 'IPR021893', NULL, 'Protein of unknown function DUF3504', 'DUF3504', 3, NULL),
(19700, NULL, 'IPR023615', NULL, 'Cytochrome c oxidase, subunit I, copper-binding site', 'Cyt_c_Oxase_su1_BS', 1, NULL),
(19701, NULL, 'IPR021916', NULL, 'Protein of unknown function DUF3527', 'DUF3527', 4, NULL),
(19702, NULL, 'IPR020372', NULL, 'Competence operon G protein 7, ComGG', 'Competence_ComGG', 4, NULL),
(19703, NULL, 'IPR017825', NULL, 'Lycopene cyclase domain', 'Lycopene_cyclase_dom', 3, NULL),
(19704, NULL, 'IPR018822', NULL, 'Uncharacterised protein family UPF0646', 'UPF0646', 4, NULL),
(19705, NULL, 'IPR016651', NULL, 'Leucine carboxyl methyltransferase 1', 'PPM1', 4, NULL),
(19706, NULL, 'IPR016311', NULL, 'Transforming protein C-ets', 'Transform_prot_C-ets', 4, NULL),
(19707, NULL, 'IPR020849', NULL, 'Small GTPase, Ras-type', 'Small_GTPase_Ras-type', 4, NULL),
(19708, NULL, 'IPR034246', NULL, 'Sulfocyanin, C-terminal', 'Sulfocyanin_C', 3, NULL),
(19709, NULL, 'IPR017079', NULL, 'Zeaxanthin epoxidase', 'Zeaxanthin_epoxidase', 4, NULL),
(19710, NULL, 'IPR017844', NULL, 'Cell division protein FtsZ, C-terminal extension', 'Cell_div_FtsZ_C', 3, NULL),
(19711, NULL, 'IPR017041', NULL, 'Uncharacterised conserved protein UCP036054', 'UCP036054', 4, NULL),
(19712, NULL, 'IPR018258', NULL, 'Ribosomal protein L21, conserved site', 'Ribosomal_L21_CS', 2, NULL),
(19713, NULL, 'IPR016276', NULL, 'Non-receptor tyrosine-protein phosphatase 22', 'PTPN22', 4, NULL),
(19714, NULL, 'IPR021919', NULL, 'Cofactor assembly of complex C subunit B, CCB1', 'CCB1', 4, NULL),
(19715, NULL, 'IPR019247', NULL, 'Histidine kinase BarA, N-terminal', 'Histidine_kinase_BarA_N', 3, NULL),
(19716, NULL, 'IPR016310', NULL, 'Transcription factor GAMYB-like', 'GAMYB-like', 4, NULL),
(19717, NULL, 'IPR019268', NULL, 'Protein of unknown function DUF2278', 'DUF2278', 4, NULL),
(19718, NULL, 'IPR035158', NULL, 'Protein of unknown function DUF5396', 'DUF5396', 4, NULL),
(19719, NULL, 'IPR023260', NULL, 'Cysteine/serine-rich nuclear protein family', 'Cys/Ser-rich_nuc_prot', 4, NULL),
(19720, NULL, 'IPR018522', NULL, 'DNA topoisomerase, type IIA, conserved site', 'TopoIIA_CS', 2, NULL),
(19721, NULL, 'IPR021878', NULL, 'Protein-glutamine gamma-glutamyltransferase TgpA, N-terminal', 'TgpA_N', 3, NULL),
(19722, NULL, 'IPR021817', NULL, 'Protein of unknown function DUF3400', 'DUF3400', 4, NULL),
(19723, NULL, 'IPR016306', NULL, 'DNA ligase, bacteriophage T7-type', 'DNA_ligase_T7', 4, NULL),
(19724, NULL, 'IPR017080', NULL, 'Uncharacterised conserved protein UCP036990, CBS, BON', 'UCP036990_CBS_BON', 4, NULL),
(19725, NULL, 'IPR021933', NULL, 'SERRATE/Ars2, N-terminal', 'SERRATE/Ars2_N', 3, NULL),
(19726, NULL, 'IPR018818', NULL, 'Sin3 binding protein', 'Stb3', 4, NULL),
(19727, NULL, 'IPR017093', NULL, 'Molecular chaperone regulator BAG-1', 'BAG-1', 4, NULL),
(19728, NULL, 'IPR019254', NULL, 'Protein of unknown function DUF2250', 'DUF2250', 4, NULL),
(19729, NULL, 'IPR019262', NULL, 'Domain of unknown function DUF2272', 'DUF2272', 3, NULL),
(19730, NULL, 'IPR017066', NULL, 'E3 ubiquitin-protein ligase BOI-like', 'E3ligase_BOI-like', 4, NULL),
(19731, NULL, 'IPR021823', NULL, 'Protein of unknown function DUF3408', 'DUF3408', 4, NULL),
(19732, NULL, 'IPR020377', NULL, 'Uncharacterised protein family LpqV', 'Uncharacterised_LpqV', 4, NULL),
(19733, NULL, 'IPR020595', NULL, 'MnmG-related, conserved site', 'MnmG-rel_CS', 2, NULL),
(19734, NULL, 'IPR019261', NULL, 'Microbial-type PARG, catalytic domain', 'PARG_cat_microbial', 3, NULL),
(19735, NULL, 'IPR018809', NULL, 'Protein of unknown function DUF2406', 'DUF2406', 4, NULL),
(19736, NULL, 'IPR021873', NULL, 'Cell division protein FtsA, C-terminal', 'FtsA_C', 3, NULL),
(19737, NULL, 'IPR018163', NULL, 'Threonyl/alanyl tRNA synthetase, class II-like, putative editing domain superfamily', 'Thr/Ala-tRNA-synth_IIc_edit', 5, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(19738, NULL, 'IPR035009', NULL, 'SR140, RNA recognition motif', 'SR140_RRM', 3, NULL),
(19739, NULL, 'IPR021910', NULL, 'NGX6/PGAP6/MYMK', 'NGX6/PGAP6/MYMK', 4, NULL),
(19740, NULL, 'IPR019673', NULL, 'Spore germination protein GerPC', 'Spore_germination_GerPC', 4, NULL),
(19741, NULL, 'IPR019249', NULL, 'Protein of unknown function DUF2226', 'DUF2226', 4, NULL),
(19742, NULL, 'IPR018275', NULL, 'Ribosomal protein S18, conserved site', 'Ribosomal_S18_CS', 2, NULL),
(19743, NULL, 'IPR021856', NULL, 'Protein of unknown function DUF3465', 'DUF3465', 4, NULL),
(19744, NULL, 'IPR018269', NULL, 'Ribosomal protein S13, conserved site', 'Ribosomal_S13_CS', 2, NULL),
(19745, NULL, 'IPR018302', NULL, 'Kinetochore protein Cenp-F/LEK1, Rb protein-binding domain', 'CenpF/LEK1_Rb-prot-bd', 3, NULL),
(19746, NULL, 'IPR019270', NULL, 'Protein of unknown function DUF2283', 'DUF2283', 4, NULL),
(19747, NULL, 'IPR021882', NULL, 'Protein of unknown function DUF3491', 'DUF3491', 4, NULL),
(19748, NULL, 'IPR017835', NULL, 'Hopanoid biosynthesis associated glycosyltransferase, HpnI', 'Hopen-assoc_HpnI', 4, NULL),
(19749, NULL, 'IPR018263', NULL, 'Ribosomal protein L32e, conserved site', 'Ribosomal_L32e_CS', 2, NULL),
(19750, NULL, 'IPR020472', NULL, 'G-protein beta WD-40 repeat', 'G-protein_beta_WD-40_rep', 7, NULL),
(19751, NULL, 'IPR020392', NULL, 'Pancreatic hormone-like, conserved site', 'Pancreatic_hormone-like_CS', 2, NULL),
(19752, NULL, 'IPR019289', NULL, 'Bacteriophage tail protein Gp41, putative', 'Phage_tail_Gp41_put', 4, NULL),
(19753, NULL, 'IPR021887', NULL, 'Disabled homolog 2-interacting protein, C-terminal domain', 'DAB2P_C', 3, NULL),
(19754, NULL, 'IPR021890', NULL, 'Protein of unknown function DUF3501', 'DUF3501', 4, NULL),
(19755, NULL, 'IPR019275', NULL, 'Protein of unknown function DUF2301', 'DUF2301', 4, NULL),
(19756, NULL, 'IPR018391', NULL, 'Pyrrolo-quinoline quinone beta-propeller repeat', 'PQQ_beta_propeller_repeat', 7, NULL),
(19757, NULL, 'IPR017077', NULL, 'Uncharacterised protein family Ycf55, algae', 'Uncharacterised_Ycf55_algae', 4, NULL),
(19758, NULL, 'IPR018268', NULL, 'Ribosomal protein S10, conserved site', 'Ribosomal_S10_CS', 2, NULL),
(19759, NULL, 'IPR021929', NULL, 'Late blight resistance protein R1', 'Late_blight_resistance_R1', 4, NULL),
(19760, NULL, 'IPR018255', NULL, 'Ribosomal protein L10e, conserved site', 'Ribosomal_L10e_CS', 2, NULL),
(19761, NULL, 'IPR017981', NULL, 'GPCR, family 2-like', 'GPCR_2-like', 3, NULL),
(19762, NULL, 'IPR034195', NULL, 'Mrn1, RNA recognition motif 1', 'Mrn1_RRM1', 3, NULL),
(19763, NULL, 'IPR016298', NULL, 'Histidine biosynthesis trifunctional-protein', 'Histidine_synth_trifunct', 4, NULL),
(19764, NULL, 'IPR021927', NULL, 'Protein of unknown function DUF3540', 'DUF3540', 4, NULL),
(19765, NULL, 'IPR017841', NULL, 'Hopanoid biosynthesis associated RND transporter-like protein HpnN', 'Hopanoid_biosynth_HpnN', 4, NULL),
(19766, NULL, 'IPR016312', NULL, 'Transcription factor, GA-binding, alpha subunit', 'TF_GA-bd_asu', 4, NULL),
(19767, NULL, 'IPR021822', NULL, 'Protein of unknown function DUF3405', 'DUF3405', 4, NULL),
(19768, NULL, 'IPR021831', NULL, 'ParD-like antitoxin of type II bacterial toxin-antitoxin system', 'ParD-like', 4, NULL),
(19769, NULL, 'IPR021913', NULL, 'Protein of unknown function DUF3526', 'DUF3526', 4, NULL),
(19770, NULL, 'IPR023196', NULL, 'Phosducin, N-terminal domain superfamily', 'Phosducin_N_dom_sf', 5, NULL),
(19771, NULL, 'IPR021937', NULL, 'Protein of unknown function DUF3551', 'DUF3551', 4, NULL),
(19772, NULL, 'IPR021848', NULL, 'Haem-dependent oxidative N-demethylase, alpha subunit-like', 'HODM_asu-like', 4, NULL),
(19773, NULL, 'IPR021932', NULL, 'Protein of unknown function DUF3545', 'DUF3545', 4, NULL),
(19774, NULL, 'IPR019277', NULL, 'Protein of unknown function DUF2304', 'DUF2304', 4, NULL),
(19775, NULL, 'IPR017054', NULL, 'Cobalamin reductase PduS', 'PduS', 4, NULL),
(19776, NULL, 'IPR018815', NULL, 'Increased loss of mitochondrial DNA protein 1', 'Incr_loss_mito_DNA_1', 4, NULL),
(19777, NULL, 'IPR020519', NULL, 'Divergent protein kinase domain 2A/B', 'DIPK2A/B', 4, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(19778, NULL, 'IPR035139', NULL, 'Bacillus competence protein S', 'ComS', 4, NULL),
(19779, NULL, 'IPR021881', NULL, 'NPK1-activating kinesin-like protein, C-terminal', 'NACK_C', 3, NULL),
(19780, NULL, 'IPR016655', NULL, 'Prefoldin subunit 3', 'PFD3', 4, NULL),
(19781, NULL, 'IPR021905', NULL, 'Domain of unknown function DUF3517', 'DUF3517', 3, NULL),
(19782, NULL, 'IPR017087', NULL, 'Uncharacterised conserved protein UCP037004', 'UCP037004', 4, NULL),
(19783, NULL, 'IPR020339', NULL, 'Uncharacterised protein family C20orf85', 'Uncharacterised_C20orf85', 4, NULL),
(19784, NULL, 'IPR034023', NULL, 'Tumor necrosis factor receptor 6B, N-terminal', 'TNFRSF6B_N', 3, NULL),
(19785, NULL, 'IPR018166', NULL, 'S-adenosylmethionine decarboxylase, conserved site', 'S-AdoMet_deCO2ase_CS', 2, NULL),
(19786, NULL, 'IPR021832', NULL, 'Ankyrin repeat domain-containing protein 13', 'ANKRD13', 4, NULL),
(19787, NULL, 'IPR021936', NULL, 'Protein of unknown function DUF3549', 'DUF3549', 4, NULL),
(19788, NULL, 'IPR021847', NULL, 'Protein of unknown function DUF3443', 'DUF3443', 4, NULL),
(19789, NULL, 'IPR020403', NULL, 'Equine arteritis virus envelope glycoprotein 5', 'EAV_Gp5', 4, NULL),
(19790, NULL, 'IPR017836', NULL, 'Hopanoid biosynthesis associated protein HpnK', 'Hopanoid_biosynth-assoc_HpnK', 4, NULL),
(19791, NULL, 'IPR016275', NULL, 'Glucose-6-phosphatase', 'Glucose-6-phosphatase', 4, NULL),
(19792, NULL, 'IPR021853', NULL, 'Protein of unknown function DUF3460', 'DUF3460', 4, NULL),
(19793, NULL, 'IPR021920', NULL, 'Protein of unknown function DUF3531', 'DUF3531', 4, NULL),
(19794, NULL, 'IPR035431', NULL, 'BLOC-2 complex member HPS5', 'HPS5', 4, NULL),
(19795, NULL, 'IPR017057', NULL, 'Ent-kaurene synthase, fungal', 'Ent-kaurene_synthase_fun', 4, NULL),
(19796, NULL, 'IPR017059', NULL, '[NiFe]-hydrogenase-3-type complex Eha, membrane protein EhaH, predicted', 'NiFe-hyd_3_EhaH_prd', 4, NULL),
(19797, NULL, 'IPR021829', NULL, 'Protein of unknown function DUF3419', 'DUF3419', 4, NULL),
(19798, NULL, 'IPR023204', NULL, 'SP1917 domain superfamily', 'SP1917_dom_sf', 5, NULL),
(19799, NULL, 'IPR020892', NULL, 'Cyclophilin-type peptidyl-prolyl cis-trans isomerase, conserved site', 'Cyclophilin-type_PPIase_CS', 2, NULL),
(19800, NULL, 'IPR020850', NULL, 'GTPase effector domain', 'GED_dom', 3, NULL),
(19801, NULL, 'IPR023950', NULL, 'Flavohemoprotein', 'Hmp', 4, NULL),
(19802, NULL, 'IPR017078', NULL, 'Uncharacterised conserved protein UCP036978, histidinol phosphatase-related hydrolase, SCO0789', 'UCP036978_PHPhdr', 4, NULL),
(19803, NULL, 'IPR017831', NULL, 'Hopanoid-associated phosphorylase HpnG', 'Hopanoid-assoc_phosphoryl_HpnG', 4, NULL),
(19804, NULL, 'IPR017048', NULL, 'Fibulin-1', 'Fibulin-1', 4, NULL),
(19805, NULL, 'IPR020342', NULL, 'Bacteriophage T4, Gp16, DNA-packaging', 'Phage_T4_Gp16_DNA-pack', 4, NULL),
(19806, NULL, 'IPR017042', NULL, 'Uncharacterised conserved protein UCP036055', 'UCP036055', 4, NULL),
(19807, NULL, 'IPR018266', NULL, 'Ribosomal protein L35Ae, conserved site', 'Ribosomal_L35Ae_CS', 2, NULL),
(19808, NULL, 'IPR018065', NULL, 'Ribosomal protein L34e, conserved site', 'Ribosomal_L34e_CS', 2, NULL),
(19809, NULL, 'IPR016290', NULL, 'S-Adenosylmethionine lyase', 'S-AdoMet_lyase', 4, NULL),
(19810, NULL, 'IPR017842', NULL, 'Hopanoid biosynthesis-associated membrane protein HpnM', 'Hopanoid_biosyn-assoc_HpnM', 4, NULL),
(19811, NULL, 'IPR020621', NULL, 'ATP phosphoribosyltransferase HisG, long form', 'ATP_PRibTrfase_HisG_long', 4, NULL),
(19812, NULL, 'IPR018057', NULL, 'Deoxyribonuclease I, active site', 'Deoxyribonuclease-1_AS', 0, NULL),
(19813, NULL, 'IPR034059', NULL, 'Tumor necrosis factor receptor, N-terminal, viral', 'TNFRSF_N_viral', 3, NULL),
(19814, NULL, 'IPR018253', NULL, 'DnaJ domain, conserved site', 'DnaJ_domain_CS', 2, NULL),
(19815, NULL, 'IPR017083', NULL, 'RNA editing complex, nuclease subunit MP42', 'RNA_edit_cplx_Nase-su_MP42', 4, NULL),
(19816, NULL, 'IPR018282', NULL, 'Ribosomal protein S6/S6e/A/B/2, conserved site', 'Ribosomal_S6e_CS', 2, NULL),
(19817, NULL, 'IPR021836', NULL, 'Protein of unknown function DUF3429', 'DUF3429', 4, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(19818, NULL, 'IPR019293', NULL, 'Thiamine-phosphate synthase ThiN', 'ThiN', 4, NULL),
(19819, NULL, 'IPR020627', NULL, 'RNA-binding protein KhpA', 'KhpA', 4, NULL),
(19820, NULL, 'IPR023195', NULL, 'Nicotinate-nucleotide-dimethylbenzimidazole phosphoribosyltransferase, N-terminal', 'Nict_dMeBzImd_PRibTrfase_N', 5, NULL),
(19821, NULL, 'IPR021915', NULL, 'Tubuliform egg casing silk strands structural domain', 'RP1-2', 3, NULL),
(19822, NULL, 'IPR021903', NULL, 'Protein of unknown function DUF3515', 'DUF3515', 4, NULL),
(19823, NULL, 'IPR016315', NULL, 'Protohaem IX farnesyltransferase, mitochondria', 'Protohaem_IX_farnesylTrfase_mt', 4, NULL),
(19824, NULL, 'IPR019258', NULL, 'Mediator complex, subunit Med4', 'Mediator_Med4', 4, NULL),
(19825, NULL, 'IPR020320', NULL, 'Swinepox virus, C2', 'Swinepox_virus_C2', 4, NULL),
(19826, NULL, 'IPR020357', NULL, 'Transcription regulator CaiF/GrlA', 'Tscrpt_reg_CaiF/GrlA', 4, NULL),
(19827, NULL, 'IPR020629', NULL, 'Formamidopyrimidine-DNA glycosylase', 'Formamido-pyr_DNA_Glyclase', 4, NULL),
(19828, NULL, 'IPR019267', NULL, 'CRISPR-associated protein Cas6, C-terminal', 'CRISPR-assoc_Cas6_C', 3, NULL),
(19829, NULL, 'IPR019248', NULL, 'Glucodextranase-like, C-terminal', 'Glucodextran_C', 3, NULL),
(19830, NULL, 'IPR020606', NULL, 'Ribosomal protein S7, conserved site', 'Ribosomal_S7_CS', 2, NULL),
(19831, NULL, 'IPR021899', NULL, 'Protein of unknown function DUF3511', 'DUF3511', 4, NULL),
(19832, NULL, 'IPR021824', NULL, 'Capsid protein C, pestivirus', 'Capsid-C_pestivirus', 3, NULL),
(19833, NULL, 'IPR018828', NULL, 'Protein of unknown function DUF2034', 'DUF2034', 4, NULL),
(19834, NULL, 'IPR018203', NULL, 'GDP dissociation inhibitor', 'GDP_dissociation_inhibitor', 4, NULL),
(19835, NULL, 'IPR016301', NULL, 'Phosphoribosylaminoimidazole carboxylase, fungi/plant', 'Ade2_fungi/plant', 4, NULL),
(19836, NULL, 'IPR023261', NULL, 'Autophagy-related protein 14', 'Autophagy-related_protein_14', 4, NULL),
(19837, NULL, 'IPR021902', NULL, 'Protein of unknown function DUF3514', 'DUF3514', 4, NULL),
(19838, NULL, 'IPR019290', NULL, 'Glycosyltransferase 2-like, prokaryotic type', 'GlycosylTrfase-like_prok', 3, NULL),
(19839, NULL, 'IPR021874', NULL, 'Bacteriophage Mu, Gp27', 'Phage_Mu_Gp27', 4, NULL),
(19840, NULL, 'IPR018816', NULL, 'Cactin, central domain', 'Cactin_central', 3, NULL),
(19841, NULL, 'IPR021864', NULL, 'Domain of unknown function DUF3475', 'DUF3475', 3, NULL),
(19842, NULL, 'IPR020356', NULL, 'Poxvirus T3C', 'Poxvirus_T3C', 4, NULL),
(19843, NULL, 'IPR034333', NULL, 'Glutathione S-transferases, class Zeta , N-terminal', 'GST_Zeta_N', 3, NULL),
(19844, NULL, 'IPR018278', NULL, 'Ribosomal protein S21, conserved site', 'Ribosomal_S21_CS', 2, NULL),
(19845, NULL, 'IPR017068', NULL, 'Protein disulphide-isomerase A4', 'Protein_diS-isomerase_A4', 4, NULL),
(19846, NULL, 'IPR019271', NULL, 'Protein of unknown function DUF2284, metal-binding', 'DUF2284_metal-binding', 4, NULL),
(19847, NULL, 'IPR016307', NULL, 'Protease inhibitor with pacifastin repeats', 'Prtase-inh_pacifastin', 4, NULL),
(19848, NULL, 'IPR018521', NULL, 'DNA topoisomerase I, active site', 'TopoI_AS', 0, NULL),
(19849, NULL, 'IPR017826', NULL, '2,3-oxidosqualene cyclase', '2-3-oxidosqualene_cyclase', 4, NULL),
(19850, NULL, 'IPR016268', NULL, 'RNA-directed RNA polymerase, hantavirus', 'RNA-dir_pol_hantavirus', 4, NULL),
(19851, NULL, 'IPR017044', NULL, 'Uncharacterised conserved protein UCP036238', 'UCP036238', 4, NULL),
(19852, NULL, 'IPR017064', NULL, 'Acid sphingomyelinase-like phosphodiesterase, predicted', 'ASM-like_Pdiesterase_prd', 4, NULL),
(19853, NULL, 'IPR018281', NULL, 'Ribosomal protein S3Ae, conserved site', 'Ribosomal_S3Ae_CS', 2, NULL),
(19854, NULL, 'IPR018193', NULL, 'Glycerate kinase, flavodoxin-like fold', 'Glyc_kinase_flavodox-like_fold', 5, NULL),
(19855, NULL, 'IPR020380', NULL, 'Uncharacterised protein family MJ1658', 'Uncharacterised_MJ1658', 4, NULL),
(19856, NULL, 'IPR021843', NULL, 'Proteasome activator complex subunit 4 C-terminal domain', 'PSME4_C', 3, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(19857, NULL, 'IPR021897', NULL, 'Cilia- and flagella-associated protein 206', 'FAP206', 4, NULL),
(19858, NULL, 'IPR020396', NULL, 'NADH:ubiquinone oxidoreductase, 30kDa subunit, conserved site', 'NADH_UbQ_OxRdtase_CS', 2, NULL),
(19859, NULL, 'IPR017086', NULL, 'RNA editing complex, structural subunit MP63', 'RNA_edit_cplx_Nase-su_MP63', 4, NULL),
(19860, NULL, 'IPR016280', NULL, 'Phosphatidylinositol-4, 5-bisphosphate phosphodiesterase beta', 'PLC-beta', 4, NULL),
(19861, NULL, 'IPR021884', NULL, 'Ice-binding protein', 'Ice-bd_prot', 4, NULL),
(19862, NULL, 'IPR018305', NULL, 'Ribosomal protein L50, mitochondria', 'Ribosomal_L50_mt', 4, NULL),
(19863, NULL, 'IPR019286', NULL, 'Protein of unknown function DUF2339, transmembrane', 'DUF2339_TM', 4, NULL),
(19864, NULL, 'IPR021907', NULL, 'Protein of unknown function DUF3519', 'DUF3519', 4, NULL),
(19865, NULL, 'IPR021898', NULL, 'Protein of unknown function DUF3509', 'DUF3509', 4, NULL),
(19866, NULL, 'IPR018520', NULL, 'Di-trans-poly-cis-decaprenylcistransferase-like, conserved site', 'UPP_synth-like_CS', 2, NULL),
(19867, NULL, 'IPR021860', NULL, 'Peptidase S12, Pab87-related, C-terminal', 'Peptidase_S12_Pab87-rel_C', 3, NULL),
(19868, NULL, 'IPR021821', NULL, 'Protein of unknown function DUF3404', 'DUF3404', 4, NULL),
(19869, NULL, 'IPR019294', NULL, 'Translational regulator Com', 'Translation_reg_Com', 4, NULL),
(19870, NULL, 'IPR021885', NULL, 'Domain of unknown function DUF3496', 'DUF3496', 3, NULL),
(19871, NULL, 'IPR018260', NULL, 'Ribosomal protein L22/L17, conserved site', 'Ribosomal_L22/L17_CS', 2, NULL),
(19872, NULL, 'IPR017081', NULL, 'Ribosomal protein S24, mitochondrial', 'Ribosomal_S24_mit', 4, NULL),
(19873, NULL, 'IPR034762', NULL, 'Bacterial/eukaryotic lysine-tRNA ligase, class II', 'Lys-tRNA-ligase_II_bac/euk', 4, NULL),
(19874, NULL, 'IPR024751', NULL, 'Variant erythrocyte surface antigen-1', 'VESA1', 4, NULL),
(19875, NULL, 'IPR018149', NULL, 'Lysyl-tRNA synthetase, class II, C-terminal', 'Lys-tRNA-synth_II_C', 3, NULL),
(19876, NULL, 'IPR021840', NULL, 'Protein of unknown function DUF3433', 'DUF3433', 4, NULL),
(19877, NULL, 'IPR016294', NULL, 'Peptidase M10B', 'Pept_M10B', 4, NULL),
(19878, NULL, 'IPR021886', NULL, 'MgsA AAA+ ATPase C-terminal', 'MgsA_C', 3, NULL),
(19879, NULL, 'IPR021928', NULL, 'Protein of unknown function DUF3541', 'DUF3541', 4, NULL),
(19880, NULL, 'IPR017838', NULL, 'DMSO reductase family, type II, haem b-binding subunit', 'DMSO_Rdtase_II_haem_b-bd_su', 4, NULL),
(19881, NULL, 'IPR018207', NULL, 'Haem oxygenase conserved site', 'Haem_oxygenase_CS', 2, NULL),
(19882, NULL, 'IPR018819', NULL, 'Nur1/Mug154', 'Nur1/Mug154', 4, NULL),
(19883, NULL, 'IPR019292', NULL, 'Type IV methyl-directed restriction enzyme EcoKMcrBC', 'McrC', 4, NULL),
(19884, NULL, 'IPR017090', NULL, 'Serine/threonine-protein kinase, SIK1/2', 'Ser/Thr_kinase_SIK1/2', 4, NULL),
(19885, NULL, 'IPR016291', NULL, 'Isochorismatase', 'Isochorismatase', 4, NULL),
(19886, NULL, 'IPR019681', NULL, 'Protein of unknown function DUF2530', 'DUF2530', 4, NULL),
(19887, NULL, 'IPR018328', NULL, 'Rad4 beta-hairpin domain 3', 'Rad4_beta-hairpin_dom3', 3, NULL),
(19888, NULL, 'IPR017830', NULL, 'Hydroxysqualene dehydroxylase HpnE', 'SQase_HpnE', 4, NULL),
(19889, NULL, 'IPR019777', NULL, 'Formate C-acetyltransferase glycine radical, conserved site', 'Form_AcTrfase_GR_CS', 2, NULL),
(19890, NULL, 'IPR016308', NULL, 'Proteinase inhibitor A/B', 'Prot_inh_API-A/B', 4, NULL),
(19891, NULL, 'IPR020881', NULL, 'Phosphoglycerol transferase I', 'OpgB', 4, NULL),
(19892, NULL, 'IPR020343', NULL, 'Viral CC chemokine-like protein FPV060', 'Chemokine_CC_FPV060', 4, NULL),
(19893, NULL, 'IPR021875', NULL, 'Retrograde transport protein Dsl1 N-terminal domain', 'Dsl1_N_dom', 3, NULL),
(19894, NULL, 'IPR021888', NULL, 'Protein of unknown function DUF3499', 'DUF3499', 4, NULL),
(19895, NULL, 'IPR016658', NULL, 'DNA primase LEF1', 'DNA_primase_LEF1', 4, NULL),
(19896, NULL, 'IPR020880', NULL, 'Protein of unknown function UPF0741', 'UPF0741', 4, NULL),
(19897, NULL, 'IPR016649', NULL, 'Glial cell line-derived neurotrophic factor', 'GDNF', 4, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(19898, NULL, 'IPR021852', NULL, 'Domain of unknown function DUF3456', 'DUF3456', 3, NULL),
(19899, NULL, 'IPR020378', NULL, 'Protein of unknown function DUF4186', 'DUF4186', 4, NULL),
(19900, NULL, 'IPR021912', NULL, 'Protein of unknown function DUF3525', 'DUF3525', 4, NULL),
(19901, NULL, 'IPR035979', NULL, 'RNA-binding domain superfamily', 'RBD_domain_sf', 5, NULL),
(19902, NULL, 'IPR020353', NULL, 'mRNA interferase toxin YafO', 'Toxin_YafO', 4, NULL),
(19903, NULL, 'IPR017050', NULL, 'Metallopeptidase, nematode', 'Metallopeptidase_nem', 4, NULL),
(19904, NULL, 'IPR021114', NULL, 'Porin PorB/PorC', 'Porin_PorB/PorC', 4, NULL),
(19905, NULL, 'IPR019679', NULL, 'Regulatory phage protein Cox', 'Phage_P2_Cox', 4, NULL),
(19906, NULL, 'IPR016279', NULL, 'Phosphatidylinositol-4, 5-bisphosphate phosphodiesterase gamma', 'PLC-gamma', 4, NULL),
(19907, NULL, 'IPR018280', NULL, 'Ribosomal protein S3, conserved site', 'Ribosomal_S3_CS', 2, NULL),
(19908, NULL, 'IPR021842', NULL, 'Protein of unknown function DUF3435', 'DUF3435', 4, NULL),
(19909, NULL, 'IPR019291', NULL, 'Host attachment protein', 'Host_attachment_protein', 4, NULL),
(19910, NULL, 'IPR021844', NULL, 'Integrating conjugative element protein, PFL4704', 'Integr_conj_element_PFL4704', 4, NULL),
(19911, NULL, 'IPR021918', NULL, 'Domain of unknown function DUF3528, homeobox protein, eukaryotic', 'DUF3528', 3, NULL),
(19912, NULL, 'IPR021858', NULL, 'Fungal transcription factor', 'Fun_TF', 4, NULL),
(19913, NULL, 'IPR021901', NULL, 'CAS family, C-terminal', 'CAS_C', 3, NULL),
(19914, NULL, 'IPR016313', NULL, 'Disks large 1-like', 'DLG1-like', 4, NULL),
(19915, NULL, 'IPR019285', NULL, 'Protein of unknown function DUF2336', 'DUF2336', 4, NULL),
(19916, NULL, 'IPR019680', NULL, 'Mediator complex, subunit Med1', 'Mediator_Med1', 3, NULL),
(19917, NULL, 'IPR018259', NULL, 'Ribosomal protein L21e, conserved site', 'Ribosomal_L21e_CS', 2, NULL),
(19918, NULL, 'IPR016283', NULL, 'Glycoside hydrolase, family 19', 'Glyco_hydro_19', 4, NULL),
(19919, NULL, 'IPR018261', NULL, 'Ribosomal protein L27, conserved site', 'Ribosomal_L27_CS', 2, NULL),
(19920, NULL, 'IPR016646', NULL, 'Alpha-(1, 3)-fucosyltransferase/alpha-(1, 4)-fucosyltransferase, Helicobacter', 'Alpha-1_3/4-FUT_helico', 4, NULL),
(19921, NULL, 'IPR018264', NULL, 'Ribosomal protein L33, conserved site', 'Ribosomal_L33_CS', 2, NULL),
(19922, NULL, 'IPR020573', NULL, 'UDP-3-O-[3-hydroxymyristoyl] glucosamine N-acyltransferase, non-repeat region', 'UDP_GlcNAc_AcTrfase_non-rep', 3, NULL),
(19923, NULL, 'IPR021896', NULL, 'Transposase protein', 'Transposase_37', 4, NULL),
(19924, NULL, 'IPR017074', NULL, 'mRNA capping enzyme, bifunctional', 'mRNA_cap_enz_bifunc', 4, NULL),
(19925, NULL, 'IPR016267', NULL, 'UTP--glucose-1-phosphate uridylyltransferase', 'UDPGP_trans', 4, NULL),
(19926, NULL, 'IPR035160', NULL, 'Protein of unknown function DUF5334', 'DUF5334', 4, NULL),
(19927, NULL, 'IPR035008', NULL, 'hnRNP-L, RNA recognition motif 2', 'hnRNPL_RRM2', 3, NULL),
(19928, NULL, 'IPR017058', NULL, 'Major membrane immunogen, tpp15, predicted', 'Major_M_immunogen_Tpp15_prd', 4, NULL),
(19929, NULL, 'IPR020360', NULL, 'Uncharacterised protein family alr2393', 'Uncharacterised_alr2393', 4, NULL),
(19930, NULL, 'IPR035157', NULL, 'Protein of unknown function DUF5395', 'DUF5395', 4, NULL),
(19931, NULL, 'IPR020455', NULL, 'BDNF/NT-3 growth factors receptor NTRK2', 'NTRK2', 4, NULL),
(19932, NULL, 'IPR021871', NULL, 'Protein of unknown function DUF3482', 'DUF3482', 4, NULL),
(19933, NULL, 'IPR020468', NULL, 'Nisin biosynthesis protein, NisC', 'Nisin_biosynthesis_NisC', 4, NULL),
(19934, NULL, 'IPR021857', NULL, 'Protein of unknown function DUF3467', 'DUF3467', 4, NULL),
(19935, NULL, 'IPR020633', NULL, 'Thymidine kinase, conserved site', 'Thymidine_kinase_CS', 2, NULL),
(19936, NULL, 'IPR019776', NULL, 'Flagellar basal body rod protein, conserved site', 'Flagellar_basal_body_rod_CS', 2, NULL),
(19937, NULL, 'IPR016645', NULL, 'Uncharacterised conserved protein UCP016134', 'UCP016134', 4, NULL),
(19938, NULL, 'IPR016282', NULL, 'Glycoside hydrolase, family 5, endoglucanase B', 'Glyco_hydro_5_endoGlcnase_B', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(19939, NULL, 'IPR020884', NULL, 'Glutathione-regulated potassium-efflux system protein KefB', 'K_H_efflux_KefB', 4, NULL),
(19940, NULL, 'IPR021870', NULL, 'Major vault protein, shoulder domain', 'MVP_shoulder', 3, NULL),
(19941, NULL, 'IPR018254', NULL, 'Ribosomal protein L29, conserved site', 'Ribosomal_L29_CS', 2, NULL),
(19942, NULL, 'IPR017084', NULL, 'RNA editing complex, subunit MP18', 'RNA_edit_cplx_su_MP18', 4, NULL),
(19943, NULL, 'IPR021839', NULL, 'Early growth response protein 1, C-terminal', 'EGR1_C', 7, NULL),
(19944, NULL, 'IPR021906', NULL, 'SWI/SNF-like complex subunit BAF250/Osa', 'BAF250/Osa', 4, NULL),
(19945, NULL, 'IPR017833', NULL, 'Hopanoid biosynthesis associated radical SAM protein HpnH', 'Hopanoid_synth-assoc_rSAM_HpnH', 4, NULL),
(19946, NULL, 'IPR021935', NULL, 'Small G protein signalling modulator 1/2, Rab-binding domain', 'SGSM1/2_RBD', 3, NULL),
(19947, NULL, 'IPR016274', NULL, 'Histidine acid phosphatase, eukaryotic', 'Histidine_acid_Pase_euk', 4, NULL),
(19948, NULL, 'IPR023263', NULL, 'Activity-regulated cytoskeleton-associated protein', 'Arc', 4, NULL),
(19949, NULL, 'IPR018071', NULL, 'Omega-atracotoxin, conserved site', 'Omega-atracotox_CS', 2, NULL),
(19950, NULL, 'IPR017839', NULL, 'DMSO reductase family, type II, iron-sulphur subunit', 'DMSO_Rdtase_II_Fe-S_su', 4, NULL),
(19951, NULL, 'IPR018395', NULL, '2-keto-3-deoxygluconate permease, subgroup', '2keto-3dGluconate_permease_sub', 4, NULL),
(19952, NULL, 'IPR017095', NULL, 'Saimiri transformation-associated protein', 'StpC', 4, NULL),
(19953, NULL, 'IPR016653', NULL, 'tRNA (guanine(9)-N(1))-methyltransferase TRM10/TRM10A', 'TRM10/TRM10A', 4, NULL),
(19954, NULL, 'IPR019779', NULL, 'Galactose-1-phosphate uridyl transferase, class I His-active site', 'GalP_UDPtransf1_His-AS', 0, NULL),
(19955, NULL, 'IPR018524', NULL, 'DNA/RNA non-specific endonuclease, active site', 'DNA/RNA_endonuclease_AS', 0, NULL),
(19956, NULL, 'IPR024750', NULL, 'Calcium-transporting P-type ATPase, N-terminal autoinhibitory domain', 'Ca_ATPase_N_dom', 3, NULL),
(19957, NULL, 'IPR016277', NULL, 'Tyrosine-protein phosphatase 1', 'Ptp1', 4, NULL),
(19958, NULL, 'IPR017094', NULL, 'Biliverdin reductase A', 'Biliverdin_Rdtase_A', 4, NULL),
(19959, NULL, 'IPR016299', NULL, 'Riboflavin biosynthesis protein RibBA', 'Riboflavin_synth_RibBA', 4, NULL),
(19960, NULL, 'IPR017067', NULL, 'Ribonuclease H1, eukaryote', 'RNase_H1_euk', 4, NULL),
(19961, NULL, 'IPR021865', NULL, 'Peptidase G2, IMC autoproteolytic cleavage domain', 'Peptidase_G2', 3, NULL),
(19962, NULL, 'IPR021926', NULL, 'PII-interacting protein X, cyanobacteria', 'PipX', 4, NULL),
(19963, NULL, 'IPR019251', NULL, 'Domain of unknown function DUF2231, transmembrane', 'DUF2231_TM', 3, NULL),
(19964, NULL, 'IPR021924', NULL, 'Protein of unknown function DUF3537', 'DUF3537', 4, NULL),
(19965, NULL, 'IPR016647', NULL, 'Probable ribonuclease VapC, Thermococci', 'VapV_Thermo', 4, NULL),
(19966, NULL, 'IPR021851', NULL, 'Protein of unknown function DUF3455', 'DUF3455', 4, NULL),
(19967, NULL, 'IPR035016', NULL, 'Protein kinase PknD, NHL repeat domain', 'NHL_PKND', 3, NULL),
(19968, NULL, 'IPR020383', NULL, 'Potassium channel accessory subunit protein 4, MinK-related', 'K_chnl_acc_su_p4_MinK-rel', 4, NULL),
(19969, NULL, 'IPR021883', NULL, 'Protein LOW PSII ACCUMULATION 1-like', 'LPA1-like', 4, NULL),
(19970, NULL, 'IPR021835', NULL, 'Protein of unknown function DUF3427', 'DUF3427', 4, NULL),
(19971, NULL, 'IPR018072', NULL, 'Conotoxin, alpha-type, conserved site', 'Conotoxin_a-typ_CS', 2, NULL),
(19972, NULL, 'IPR018265', NULL, 'Ribosomal protein L35, conserved site', 'Ribosomal_L35_CS', 2, NULL),
(19973, NULL, 'IPR018283', NULL, 'Ribosomal protein S8e, conserved site', 'Ribosomal_S8e_CS', 2, NULL),
(19974, NULL, 'IPR018517', NULL, 'tRNA-dihydrouridine synthase, conserved site', 'tRNA_hU_synthase_CS', 2, NULL),
(19975, NULL, 'IPR018817', NULL, '7TM GPCR, serpentine receptor class z (Srz)', '7TM_GPCR_serpentine_rcpt_Srz', 4, NULL),
(19976, NULL, 'IPR019276', NULL, 'Protein of unkown function DUF2303', 'DUF2303', 4, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(19977, NULL, 'IPR016269', NULL, 'RNA-directed RNA polymerase, paramyxovirus', 'RNA-dir_pol_paramyxovirus', 4, NULL),
(19978, NULL, 'IPR021855', NULL, 'PAM68-like', 'PAM68-like', 4, NULL),
(19979, NULL, 'IPR019288', NULL, 'Predicted 3''-5'' exonuclease, PolB-like', '3''-5''_exonuclease_PolB-like', 3, NULL),
(19980, NULL, 'IPR021837', NULL, 'Counting factor-associated protein A/B/C', 'CfaA/B/C', 4, NULL),
(19981, NULL, 'IPR018396', NULL, 'Lysosomal-associated transmembrane protein, 4A/5', 'LAPTM_4A/5', 4, NULL),
(19982, NULL, 'IPR021820', NULL, 'S-locus receptor kinase, C-terminal', 'S-locus_recpt_kinase_C', 3, NULL),
(19983, NULL, 'IPR017827', NULL, 'Hydroxysqualene synthase HpnC', 'HSQ_synthase_HpnC', 4, NULL),
(19984, NULL, 'IPR020878', NULL, 'Ribulose bisphosphate carboxylase, large chain, active site', 'RuBisCo_large_chain_AS', 0, NULL),
(19985, NULL, 'IPR021830', NULL, 'Protein of unknown function DUF3422', 'DUF3422', 4, NULL),
(19986, NULL, 'IPR021826', NULL, 'Pyrimidine/purine nucleotide 5''-monophosphate nucleosidase, C-terminal domain', 'PpnN_C', 3, NULL),
(19987, NULL, 'IPR016295', NULL, 'Proteasome subunit beta 4', 'Proteasome_beta4', 4, NULL),
(19988, NULL, 'IPR017076', NULL, 'Kremen', 'Kremen', 4, NULL),
(19989, NULL, 'IPR021895', NULL, 'Bud3, N-terminal', 'Bud3_N', 3, NULL),
(19990, NULL, 'IPR020269', NULL, 'Bacteriophage Mu, Gp25', 'Phage_Mu_Gp25', 4, NULL),
(19991, NULL, 'IPR019269', NULL, 'Biogenesis of lysosome-related organelles complex-1, subunit 2', 'BLOC1_su2', 4, NULL),
(19992, NULL, 'IPR018250', NULL, 'Neuregulin-1', 'NRG1', 4, NULL),
(19993, NULL, 'IPR019296', NULL, 'Uncharacterised protein family, nitrogen regulatory protein PII-related', 'Unchr_N-regulatory-PII-rel', 4, NULL),
(19994, NULL, 'IPR024026', NULL, '3''-RNA ribose 2''-O-methyltransferase, Hen1, bacterial', '3''-RNA_MeTfrase_Hen1_bac', 4, NULL),
(19995, NULL, 'IPR020338', NULL, 'SMN complex, gem-associated protein 7', 'SMN_gemin7', 4, NULL),
(19996, NULL, 'IPR017082', NULL, 'Ribosomal protein S23, mitochondrial, fungi', 'Ribosomal_S23_mit_fun', 4, NULL),
(19997, NULL, 'IPR021861', NULL, 'THO complex, subunit THOC1', 'THO_THOC1', 4, NULL),
(19998, NULL, 'IPR018824', NULL, 'Conidiation-specific protein 6', 'Conidiation-specific_6', 4, NULL),
(19999, NULL, 'IPR020511', NULL, 'Uncharacterised protein family HI0941', 'Uncharacterised_HI0941', 4, NULL),
(20000, NULL, 'IPR021900', NULL, 'Protein of unknown function DUF3512', 'DUF3512', 4, NULL),
(20001, NULL, 'IPR018199', NULL, 'Ribosomal protein S4e, N-terminal, conserved site', 'Ribosomal_S4e_N_CS', 2, NULL),
(20002, NULL, 'IPR035194', NULL, 'Protein of unknown function DUF5461', 'DUF5461', 4, NULL),
(20003, NULL, 'IPR018357', NULL, 'Hexapeptide transferase, conserved site', 'Hexapep_transf_CS', 2, NULL),
(20004, NULL, 'IPR018382', NULL, 'DNA polymerase III, psi subunit, subgroup', 'DNA_pol_III_psi_subgr', 4, NULL),
(20005, NULL, 'IPR023578', NULL, 'Ras guanine nucleotide exchange factor domain superfamily', 'Ras_GEF_dom_sf', 5, NULL),
(20006, NULL, 'IPR024257', NULL, 'Protein of unknown function DUF3796', 'DUF3796', 4, NULL),
(20007, NULL, 'IPR022044', NULL, 'Insecticide toxin TcdB middle/C-terminal', 'TcdB_toxin_mid/C', 3, NULL),
(20008, NULL, 'IPR022051', NULL, 'Protein of unknown function DUF3611', 'DUF3611', 4, NULL),
(20009, NULL, 'IPR016341', NULL, 'Clathrin, heavy chain', 'Clathrin_heavy_chain', 4, NULL),
(20010, NULL, 'IPR016681', NULL, 'Succinylglutamate desuccinylase', 'SuccinylGlu_desuccinylase', 4, NULL),
(20011, NULL, 'IPR021981', NULL, 'Domain of unknown function DUF3586', 'DUF3586', 3, NULL),
(20012, NULL, 'IPR019687', NULL, 'Protein of unknown function DUF2535', 'DUF2535', 4, NULL),
(20013, NULL, 'IPR020618', NULL, 'Adenylate kinase isoenzyme 6', 'Adenyl_kinase_AK6', 4, NULL),
(20014, NULL, 'IPR016665', NULL, 'SAS complex subunit SAS5/transcription initiation factor TFIID subunit 14', 'Sas5/TAF14', 4, NULL),
(20015, NULL, 'IPR035176', NULL, 'Elicitor peptide', 'PEP', 4, NULL),
(20016, NULL, 'IPR020416', NULL, 'Tumour necrosis factor receptor 8', 'TNFR_8', 4, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(20017, NULL, 'IPR021944', NULL, 'Protein of unknown function DUF3560', 'DUF3560', 4, NULL),
(20018, NULL, 'IPR017110', NULL, 'Stonin', 'Stonin', 4, NULL),
(20019, NULL, 'IPR017117', NULL, 'Ribonuclease Nob1, eukaryote', 'Nob1_euk', 4, NULL),
(20020, NULL, 'IPR021958', NULL, 'Protein of unknown function DUF3575', 'DUF3575', 4, NULL),
(20021, NULL, 'IPR034326', NULL, 'ROD1, RNA recognition motif 1', 'ROD1_RRM1', 3, NULL),
(20022, NULL, 'IPR021965', NULL, 'Plasminogen ligand, VEK-30', 'Plasminogen_ligand_VEK-30', 3, NULL),
(20023, NULL, 'IPR016691', NULL, 'tRNA guanosine-2''-O-methyltransferase, TRM11', 'tRNA_mtfrase_TRM11', 4, NULL),
(20024, NULL, 'IPR016363', NULL, 'Legume lectin', 'L-lectin', 4, NULL),
(20025, NULL, 'IPR035185', NULL, 'Protein of unknown function DUF5305', 'DUF5305', 4, NULL),
(20026, NULL, 'IPR018829', NULL, 'Domain of unknown function DUF2433', 'DUF2433', 3, NULL),
(20027, NULL, 'IPR016371', NULL, 'RNA polymerase sigma-H factor', 'RNA_pol_sigma-H_factor', 4, NULL),
(20028, NULL, 'IPR022048', NULL, 'Envelope fusion protein-like', 'Envelope_fusion-like', 4, NULL),
(20029, NULL, 'IPR022020', NULL, 'Domain of unknown function DUF3601', 'DUF3601', 3, NULL),
(20030, NULL, 'IPR022033', NULL, 'RAVE complex protein Rav1 C-terminal', 'Rav1p_C', 3, NULL),
(20031, NULL, 'IPR024894', NULL, 'Bifunctional pantoate ligase/cytidylate kinase', 'Pantoate_ligase/cytidylate_kin', 4, NULL),
(20032, NULL, 'IPR018365', NULL, 'Cell cycle, FtsW / RodA / SpoVE, conserved site', 'Cell_cycle_FtsW-rel_CS', 2, NULL),
(20033, NULL, 'IPR021954', NULL, 'Protein CHLORORESPIRATORY REDUCTION 7', 'CRR7', 4, NULL),
(20034, NULL, 'IPR016713', NULL, 'Poly(A) polymerase complex subunit Air1/2, budding yeast', 'Air1/2_Saccharomycetales', 4, NULL),
(20035, NULL, 'IPR034334', NULL, 'Prostaglandin E synthase 2', 'PGES2', 4, NULL),
(20036, NULL, 'IPR035451', NULL, 'Ada-like domain superfamily', 'Ada-like_dom_sf', 5, NULL),
(20037, NULL, 'IPR018378', NULL, 'C-type lectin, conserved site', 'C-type_lectin_CS', 2, NULL),
(20038, NULL, 'IPR024236', NULL, 'Serine/threonine-protein kinase 40', 'Ser/Thr_kinase_40', 4, NULL),
(20039, NULL, 'IPR021946', NULL, 'Protein of unknown function DUF3563', 'DUF3563', 4, NULL),
(20040, NULL, 'IPR021949', NULL, 'Domain of unknown function DUF3566. transmembrane', 'DUF3566_TM', 3, NULL),
(20041, NULL, 'IPR017099', NULL, 'Uncharacterised conserved protein UCP037053', 'UCP037053', 4, NULL),
(20042, NULL, 'IPR019700', NULL, 'Anti-sigma-G factor Gin', 'Sigma-G_inhibitor_Gin', 4, NULL),
(20043, NULL, 'IPR018840', NULL, 'Protein of unknown function DUF2441', 'DUF2441', 4, NULL),
(20044, NULL, 'IPR021967', NULL, 'Nuclear pore complex protein NUP96, C-terminal domain', 'Nup98_C', 3, NULL),
(20045, NULL, 'IPR020508', NULL, 'SecA translation cis-regulator SecM, small type', 'SecM_small', 4, NULL),
(20046, NULL, 'IPR022039', NULL, 'Post-transcriptional regulator MKT1, C-terminal', 'MKT1_C', 3, NULL),
(20047, NULL, 'IPR024292', NULL, 'Nodavirus capsid', 'Nodavirus_capsid', 4, NULL),
(20048, NULL, 'IPR022041', NULL, 'Farnesoic acid O-methyl transferase', 'Methyltransf_FA', 3, NULL),
(20049, NULL, 'IPR022055', NULL, 'Protein of unknown function DUF3612', 'DUF3612', 4, NULL),
(20050, NULL, 'IPR016677', NULL, 'Uncharacterised conserved protein UCP016817, ATP-dependent carboligase', 'UCP016817_carboligase', 4, NULL),
(20051, NULL, 'IPR020502', NULL, 'Late transcription unit B', 'LtuB', 4, NULL),
(20052, NULL, 'IPR016334', NULL, 'Protein-tyrosine phosphatase, receptor type R/non-receptor type 5', 'Tyr_Pase_rcpt_R/non-rcpt_5', 4, NULL),
(20053, NULL, 'IPR017106', NULL, 'Coatomer gamma subunit', 'Coatomer_gsu', 4, NULL),
(20054, NULL, 'IPR021989', NULL, 'Mediator complex, subunit Med12, catenin-binding', 'Mediator_Med12_catenin-bd', 3, NULL),
(20055, NULL, 'IPR020507', NULL, 'Protein of unknown function DUF5517', 'DUF5517', 4, NULL),
(20056, NULL, 'IPR020797', NULL, 'Cytidine deaminase, bacteria', 'Cytidine_deaminase_bacteria', 4, NULL),
(20057, NULL, 'IPR017116', NULL, 'Signal transduction histidine kinase, PgtB', 'Sig_transdc_His_kinase_PgtB', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(20058, NULL, 'IPR016351', NULL, 'Plasminogen-related', 'Plasminogen-rel', 4, NULL),
(20059, NULL, 'IPR016330', NULL, 'Neurotoxin 3, Actiniidae', 'Neurotoxin_3_Actiniidae', 4, NULL),
(20060, NULL, 'IPR023957', NULL, 'Anaerobic nitric oxide reductase flavorubredoxin', 'Anaer_NO_rdtase_flvorubredoxin', 4, NULL),
(20061, NULL, 'IPR034676', NULL, 'Protein kinase B alpha, catalytic domain', 'Akt1', 3, NULL),
(20062, NULL, 'IPR016700', NULL, '3-hydroxyanthranilate 3, 4-dioxygenase, metazoan', '3hydroanth_dOase_met', 4, NULL),
(20063, NULL, 'IPR020835', NULL, 'Catalase superfamily', 'Catalase_sf', 5, NULL),
(20064, NULL, 'IPR022018', NULL, 'ARF GTPase-activating protein GIT1, C-terminal', 'GIT1_C', 3, NULL),
(20065, NULL, 'IPR018201', NULL, 'Beta-ketoacyl synthase, active site', 'Ketoacyl_synth_AS', 0, NULL),
(20066, NULL, 'IPR019688', NULL, 'Protein of unknown function DUF2533', 'DUF2533', 4, NULL),
(20067, NULL, 'IPR018837', NULL, 'Transcription factor CRF1/IFH1', 'TF_CRF1/IFH1', 4, NULL),
(20068, NULL, 'IPR016709', NULL, 'Dehydratase subunit HadA-like', 'HadA-like', 4, NULL),
(20069, NULL, 'IPR019612', NULL, 'Minor capsid protein, putative', 'Minor_capsid_put', 4, NULL),
(20070, NULL, 'IPR021950', NULL, 'Transcription factor Spt20', 'Spt20', 4, NULL),
(20071, NULL, 'IPR021984', NULL, 'Plasmodium repeat', 'Plasmodium_rpt', 7, NULL),
(20072, NULL, 'IPR035453', NULL, 'SH3PXD2A, SH3 domain 4', 'SH3PXD2A_SH3_4', 3, NULL),
(20073, NULL, 'IPR021938', NULL, 'Protein of unknown function DUF3553', 'DUF3553', 4, NULL),
(20074, NULL, 'IPR017100', NULL, 'Insulin-like peptide 6', 'Insulin-like_pep_6', 4, NULL),
(20075, NULL, 'IPR035898', NULL, 'TAZ domain superfamily', 'TAZ_dom_sf', 5, NULL),
(20076, NULL, 'IPR022003', NULL, 'RST domain', 'RST', 3, NULL),
(20077, NULL, 'IPR020303', NULL, 'Protein of unknown function DUF5495', 'DUF5495', 4, NULL),
(20078, NULL, 'IPR023866', NULL, '2,3-diaminopropionate biosynthesis protein SbnB', 'SbnB', 4, NULL),
(20079, NULL, 'IPR016669', NULL, 'Interferon alpha/beta receptor 1', 'Interferon_alpha/beta_rcpt-1', 4, NULL),
(20080, NULL, 'IPR017105', NULL, 'Adaptor protein complex AP-3, delta subunit', 'AP3_complex_dsu', 4, NULL),
(20081, NULL, 'IPR022040', NULL, 'Post-transcriptional regulator MKT1, N-terminal', 'MKT1_N', 3, NULL),
(20082, NULL, 'IPR016368', NULL, 'Endoribonuclease VapD', 'VapD', 4, NULL),
(20083, NULL, 'IPR020445', NULL, 'Tumour necrosis factor receptor 4', 'TNFR_4', 4, NULL),
(20084, NULL, 'IPR018356', NULL, 'Transcription regulator, HTH DeoR-type, conserved site', 'Tscrpt_reg_HTH_DeoR_CS', 2, NULL),
(20085, NULL, 'IPR019576', NULL, 'Pyridoxine 5''-phosphate oxidase, dimerisation, C-terminal', 'Pyridoxamine_oxidase_dimer_C', 3, NULL),
(20086, NULL, 'IPR018383', NULL, 'Uncharacterised protein family UPF0324, prokaryote', 'UPF0324_pro', 4, NULL),
(20087, NULL, 'IPR022031', NULL, 'Telomere-associated protein Rif1, N-terminal', 'Rif1_N', 3, NULL),
(20088, NULL, 'IPR016682', NULL, 'Flagella accessory protein D, predicted, archaeal', 'FlaD_prd_arc', 4, NULL),
(20089, NULL, 'IPR018854', NULL, 'Proteasome chaperone 3/4', 'Psome_chaperone_3/4', 4, NULL),
(20090, NULL, 'IPR024239', NULL, 'Exopolysaccharide production repressor', 'SyrA', 4, NULL),
(20091, NULL, 'IPR016339', NULL, 'Truncated hemoglobin, group 1', 'Hemoglobin_trunc_I', 4, NULL),
(20092, NULL, 'IPR035179', NULL, 'Protein of unknown function DUF5314', 'DUF5314', 4, NULL),
(20093, NULL, 'IPR024249', NULL, 'Protein of unknown function DUF2761', 'DUF2761', 4, NULL),
(20094, NULL, 'IPR019605', NULL, 'Misato Segment II tubulin-like domain', 'Misato_II_tubulin-like', 3, NULL),
(20095, NULL, 'IPR017109', NULL, 'Adaptor protein complex AP-4, epsilon subunit', 'AP4_complex_esu', 4, NULL),
(20096, NULL, 'IPR016336', NULL, 'Receptor tyrosine-protein phosphatase, alpha/epsilon-type', 'Tyr_Pase_rcpt_a/e-type', 4, NULL),
(20097, NULL, 'IPR019621', NULL, 'Protein of unknown function DUF2491', 'DUF2491', 4, NULL),
(20098, NULL, 'IPR020622', NULL, 'Alanine racemase, pyridoxal-phosphate attachment site', 'Ala_racemase_pyridoxalP-BS', 1, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(20099, NULL, 'IPR019585', NULL, '26S proteasome regulatory subunit Rpn7/COP9 signalosome complex subunit 1', 'Rpn7/CSN1', 4, NULL),
(20100, NULL, 'IPR016680', NULL, 'NADH dehydrogenase [ubiquinone] (complex I), alpha subcomplex, subunit 8', 'NDUFA8', 4, NULL),
(20101, NULL, 'IPR021969', NULL, 'Protein of unknown function DUF3579', 'DUF3579', 4, NULL),
(20102, NULL, 'IPR023365', NULL, 'Sortase domain superfamily', 'Sortase_dom-sf', 5, NULL),
(20103, NULL, 'IPR020436', NULL, 'Somatomedin B domain, chordata', 'SMB_chordata', 3, NULL),
(20104, NULL, 'IPR035186', NULL, 'Protein of unknown function DUF5308', 'DUF5308', 4, NULL),
(20105, NULL, 'IPR022027', NULL, 'Turkey astrovirus capsid protein', 'Astro_capsid_p', 4, NULL),
(20106, NULL, 'IPR016338', NULL, 'Phospholipase A2 inhibitor, alpha/gamma type', 'PLipase_A2-inh_a/b-type', 4, NULL),
(20107, NULL, 'IPR020406', NULL, 'Epidermin biosynthesis protein EpiC', 'Epidermin_biosynth_EpiC', 4, NULL),
(20108, NULL, 'IPR035195', NULL, 'ERMES regulator 1', 'Emr1', 4, NULL),
(20109, NULL, 'IPR035193', NULL, 'Beta defensin 50', 'Defb50', 4, NULL),
(20110, NULL, 'IPR016345', NULL, 'Casein, beta', 'Casein_beta', 4, NULL),
(20111, NULL, 'IPR024266', NULL, 'Domain of unknown function DUF3806', 'DUF3806', 3, NULL),
(20112, NULL, 'IPR016672', NULL, 'Polyketide biosynthesis protein CurC, predicted', 'Polyketide_Synth_CurC_prd', 4, NULL),
(20113, NULL, 'IPR016660', NULL, 'Kinase associated protein phosphatase', 'Kinase_assoc_Pase', 4, NULL),
(20114, NULL, 'IPR021990', NULL, 'Mediator complex, subunit Med12, LCEWAV-domain', 'Mediator_Med12_LCEWAV', 3, NULL),
(20115, NULL, 'IPR018847', NULL, 'Monopolin complex, subunit Mam1', 'Monopolin_cplx_su_Mam1', 4, NULL),
(20116, NULL, 'IPR024237', NULL, 'VirE1', 'VirE1', 4, NULL),
(20117, NULL, 'IPR017115', NULL, 'Tellurite resistance, TerA', 'Tellurite_resistance_TerA', 4, NULL),
(20118, NULL, 'IPR016356', NULL, 'Seminal plasma protein, PDC-109-like', 'Seminal_plasma_PDC-109-like', 4, NULL),
(20119, NULL, 'IPR020798', NULL, 'Ribosomal protein L16, conserved site', 'Ribosomal_L16_CS', 2, NULL),
(20120, NULL, 'IPR022042', NULL, 'snRNA-activating protein complex, subunit 3', 'snRNA-activating_su3', 4, NULL),
(20121, NULL, 'IPR034181', NULL, 'Pre-mRNA-splicing factor Cwc2, RNA recognition motif', 'Cwc2_RRM', 3, NULL),
(20122, NULL, 'IPR019592', NULL, 'Protein of unknown function DUF2469', 'DUF2469', 4, NULL),
(20123, NULL, 'IPR016662', NULL, 'Acyl-CoA thioesterase, long chain', 'Acyl-CoA_thioEstase_long-chain', 4, NULL),
(20124, NULL, 'IPR022030', NULL, 'Splicing factor 3A subunit 1, conserved domain', 'SF3A1_dom', 3, NULL),
(20125, NULL, 'IPR018831', NULL, 'Uncharacterised protein family NKWYS', 'Uncharacterised_NKWYS', 4, NULL),
(20126, NULL, 'IPR020509', NULL, 'Uncharacterised protein family YnzE', 'Uncharacterised_YnzE', 4, NULL),
(20127, NULL, 'IPR019608', NULL, 'Photosystem I P840 reaction centre protein PscD', 'PSI_P840_PscD', 4, NULL),
(20128, NULL, 'IPR020425', NULL, 'Nerve growth factor, beta subunit', 'Nerve_growth_factor_bsu', 4, NULL),
(20129, NULL, 'IPR024247', NULL, 'Protein of unknown function DUF2673', 'DUF2673', 4, NULL),
(20130, NULL, 'IPR016325', NULL, 'Mating-type protein ALPHA1, Saccharomycetales', 'ALPHA1_Saccharomycetales', 4, NULL),
(20131, NULL, 'IPR017107', NULL, 'Adaptor protein complex AP-1, gamma subunit', 'AP1_complex_gsu', 4, NULL),
(20132, NULL, 'IPR022006', NULL, 'Chromosome passenger complex (CPC) protein INCENP N-terminal', 'INCENP_N', 3, NULL),
(20133, NULL, 'IPR019698', NULL, 'Protein of unknown function DUF2583', 'DUF2583', 4, NULL),
(20134, NULL, 'IPR022009', NULL, 'Restriction endonuclease, type II, NotI', 'Resctriction_endonuc_II_NotI', 3, NULL),
(20135, NULL, 'IPR019690', NULL, 'Protein of unknown function DUF2569', 'DUF2569', 4, NULL),
(20136, NULL, 'IPR021976', NULL, 'N-acetylmuramoyl-l-alanine amidase, C-terminal domain', 'Amidase_C', 3, NULL),
(20137, NULL, 'IPR017098', NULL, 'Uncharacterised conserved protein UCP037052', 'UCP037052', 4, NULL),
(20138, NULL, 'IPR019620', NULL, 'Putative metal-binding protein', 'Metal-bd_prot_put', 4, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(20139, NULL, 'IPR020510', NULL, 'Poly-beta-1,6-N-acetyl-D-glucosamine synthesis protein IcaD', 'IcaD', 4, NULL),
(20140, NULL, 'IPR024269', NULL, 'Protein of unknown function DUF3791', 'DUF3791', 4, NULL),
(20141, NULL, 'IPR023266', NULL, 'Aquaporin 11', 'Aquaporin_11', 4, NULL),
(20142, NULL, 'IPR019695', NULL, 'Bacterial proteasome activator', 'Proteasome_act', 4, NULL),
(20143, NULL, 'IPR016362', NULL, 'POU-domain transcription factor, class 3', 'TF_POU_3', 4, NULL),
(20144, NULL, 'IPR018192', NULL, 'Ribosomal protein S5, N-terminal, conserved site', 'Ribosomal_S5_N_CS', 2, NULL),
(20145, NULL, 'IPR016322', NULL, 'Frog skin active peptide family', 'FSAP', 4, NULL),
(20146, NULL, 'IPR019617', NULL, 'Domain of unknown function DUF2489', 'DUF2489', 3, NULL),
(20147, NULL, 'IPR016702', NULL, 'Mitochondrial ATP synthase subunit g, animal', 'ATP_synth_su_G_mt_met', 4, NULL),
(20148, NULL, 'IPR021964', NULL, 'Colicin E5 ribonuclease domain', 'Colicin_E5_C', 3, NULL),
(20149, NULL, 'IPR022017', NULL, 'Domain of unknown function DUF3598, Biogenesis factor required for ATP synthase 1-like', 'DUF3598_BFA1-like', 3, NULL),
(20150, NULL, 'IPR018370', NULL, 'Chaperonin Cpn60, conserved site', 'Chaperonin_Cpn60_CS', 2, NULL),
(20151, NULL, 'IPR018852', NULL, 'Protein of unknown function DUF2456', 'DUF2456', 4, NULL),
(20152, NULL, 'IPR035172', NULL, 'Protein of unknown function DUF5302', 'DUF5302', 4, NULL),
(20153, NULL, 'IPR016369', NULL, 'Flagellar filament outer layer protein FlaA, Spirochaetes', 'FlaA_Spirochaetes', 4, NULL),
(20154, NULL, 'IPR020431', NULL, 'Neurotrophin-6', 'Neurotrophin-6', 4, NULL),
(20155, NULL, 'IPR018849', NULL, 'Nucleolar 27S pre-rRNA processing, Urb2/Npa2, C-terminal', 'Urb2/Npa2_C', 3, NULL),
(20156, NULL, 'IPR022014', NULL, 'Sulfolobus virus, coat protein, C-terminal', 'Sulfobus_virus_coat_C', 3, NULL),
(20157, NULL, 'IPR016328', NULL, 'Beta/delta-agatoxin family', 'Beta/delta-agatoxin_fam', 4, NULL),
(20158, NULL, 'IPR021966', NULL, 'Splicing factor SF3a60 binding domain', 'SF3a60_bindingd', 3, NULL),
(20159, NULL, 'IPR016663', NULL, 'Myelin-oligodendrocyte glycoprotein', 'Myelin-oligodendrocyte_glycop', 4, NULL),
(20160, NULL, 'IPR019684', NULL, 'HofP protein', 'HofP', 4, NULL),
(20161, NULL, 'IPR018359', NULL, 'Bromodomain, conserved site', 'Bromodomain_CS', 2, NULL),
(20162, NULL, 'IPR021997', NULL, 'Stage V sporulation protein AA', 'SporV_AA', 3, NULL),
(20163, NULL, 'IPR022000', NULL, 'Min27-like integrase, DNA-binding domain', 'Min27-like_integrase_DNA_bind', 3, NULL),
(20164, NULL, 'IPR016710', NULL, 'Emp46/Emp47', 'Emp46/Emp47', 4, NULL),
(20165, NULL, 'IPR016708', NULL, 'Aspartoacylase', 'Aspartoacylase', 4, NULL),
(20166, NULL, 'IPR019614', NULL, 'S-adenosylmethionine-dependent methyltransferase', 'SAM-dep_methyl-trfase', 3, NULL),
(20167, NULL, 'IPR035447', NULL, 'DNA topoisomerase I, N-terminal', 'DNA_topo_I_N', 5, NULL),
(20168, NULL, 'IPR021953', NULL, 'Protein of unknown function DUF3570', 'DUF3570', 4, NULL),
(20169, NULL, 'IPR022054', NULL, 'Protein of unknown function DUF3614', 'DUF3614', 4, NULL),
(20170, NULL, 'IPR019574', NULL, 'NADH:ubiquinone oxidoreductase, subunit G, iron-sulphur binding', 'NADH_UbQ_OxRdtase_Gsu_4Fe4S-bd', 3, NULL),
(20171, NULL, 'IPR018839', NULL, 'Cryptic loci regulator 2, C-terminal', 'Tscrpt-silencing_Clr2_C', 3, NULL),
(20172, NULL, 'IPR016319', NULL, 'Transforming growth factor-beta', 'TGF-beta', 4, NULL),
(20173, NULL, 'IPR021995', NULL, 'Protein of unknown function DUF3593', 'DUF3593', 4, NULL),
(20174, NULL, 'IPR021955', NULL, 'Protein of unknown function DUF3572', 'DUF3572', 4, NULL),
(20175, NULL, 'IPR019582', NULL, 'RNA recognition motif, spliceosomal PrP8', 'RRM_spliceosomal_PrP8', 3, NULL),
(20176, NULL, 'IPR022764', NULL, 'Peptidase S54, rhomboid domain', 'Peptidase_S54_rhomboid_dom', 3, NULL),
(20177, NULL, 'IPR019580', NULL, 'Pre-mRNA-processing-splicing factor 8, U6-snRNA-binding', 'Prp8_U6-snRNA-bd', 3, NULL),
(20178, NULL, 'IPR018366', NULL, 'Carbohydrate-binding type-2, conserved site', 'CBM2_CS', 2, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(20179, NULL, 'IPR035183', NULL, 'Protein of unknown function DUF5304', 'DUF5304', 4, NULL),
(20180, NULL, 'IPR021978', NULL, 'Protein of unknown function DUF3583', 'DUF3583', 4, NULL),
(20181, NULL, 'IPR018376', NULL, 'Enoyl-CoA hydratase/isomerase, conserved site', 'Enoyl-CoA_hyd/isom_CS', 2, NULL),
(20182, NULL, 'IPR019616', NULL, 'Ycf54 protein', 'Ycf54', 4, NULL),
(20183, NULL, 'IPR019618', NULL, 'Spore germination protein GerPA/GerPF', 'Spore_germination_GerPA', 4, NULL),
(20184, NULL, 'IPR022026', NULL, 'Methylene-tetrahydrofolate reductase C-terminal', 'MTHFR_C', 3, NULL),
(20185, NULL, 'IPR021971', NULL, 'Salivary protein 15', 'Salp15', 4, NULL),
(20186, NULL, 'IPR016695', NULL, 'Purine 5''-nucleotidase', 'Pur_nucleotidase', 4, NULL),
(20187, NULL, 'IPR016375', NULL, 'Transcription factor GATA-4/5/6', 'TF_GATA_4/5/6', 4, NULL),
(20188, NULL, 'IPR024263', NULL, 'Stn1, C-terminal, fungi', 'Stn1_C_fungi', 3, NULL),
(20189, NULL, 'IPR035189', NULL, 'Std1/Mth1', 'Std1/Mth1', 4, NULL),
(20190, NULL, 'IPR016675', NULL, 'Uncharacterised conserved protein UCP016666', 'UCP016666', 4, NULL),
(20191, NULL, 'IPR021968', NULL, 'Polyribonucleotide phosphorylase C-terminal', 'PNPase_C', 3, NULL),
(20192, NULL, 'IPR016364', NULL, 'Surface antigen, Rickettsia type', 'Surface_antigen_Rickettsia', 4, NULL),
(20193, NULL, 'IPR019603', NULL, 'Mitochondrial outer membrane translocase complex, subunit Tom5', 'Tom5', 4, NULL),
(20194, NULL, 'IPR022001', NULL, 'DNA polymerase III subunit tau, DnaB-binding domain IV', 'DNA_pol3_tau_IV', 3, NULL),
(20195, NULL, 'IPR018333', NULL, 'Squalene cyclase', 'Squalene_cyclase', 4, NULL),
(20196, NULL, 'IPR034943', NULL, '2-aminophenol 1,6-dioxygenase, beta subunit', '2A5CPDO_B', 4, NULL),
(20197, NULL, 'IPR022028', NULL, 'Protein of unknown function DUF3604', 'DUF3604', 4, NULL),
(20198, NULL, 'IPR019685', NULL, 'Protein of unknown function DUF2534', 'DUF2534', 4, NULL),
(20199, NULL, 'IPR035454', NULL, 'SH3PXD2A, SH3 domain 5', 'SH3PXD2A_SH3_5', 3, NULL),
(20200, NULL, 'IPR017097', NULL, 'Bombyxin', 'Bombyxin', 4, NULL),
(20201, NULL, 'IPR021996', NULL, 'Fibrinogen alpha C domain', 'Fibrinogen_aC', 3, NULL),
(20202, NULL, 'IPR020631', NULL, 'Tetrahydrofolate dehydrogenase/cyclohydrolase, NAD(P)-binding domain', 'THF_DH/CycHdrlase_NAD-bd_dom', 3, NULL),
(20203, NULL, 'IPR022012', NULL, 'D212, catalytic domain', 'D212_cat_dom', 3, NULL),
(20204, NULL, 'IPR034944', NULL, '2-aminobiphenyl-2,3-diol-1,2-dioxygenase, beta subunit', 'CarBb', 4, NULL),
(20205, NULL, 'IPR018371', NULL, 'Chitin-binding, type 1, conserved site', 'Chitin-binding_1_CS', 2, NULL),
(20206, NULL, 'IPR021991', NULL, 'UHRF1, tandem tudor domain', 'TTD_dom', 3, NULL),
(20207, NULL, 'IPR021986', NULL, 'Spherulation-specific family 4', 'Spherulin4', 4, NULL),
(20208, NULL, 'IPR019595', NULL, 'Domain of unknown function DUF2470', 'DUF2470', 3, NULL),
(20209, NULL, 'IPR020496', NULL, 'Sigma-M inhibitor YhdK', 'YhdK', 4, NULL),
(20210, NULL, 'IPR021973', NULL, 'SprA-related family', 'SprA-related', 4, NULL),
(20211, NULL, 'IPR019702', NULL, 'Multidrug efflux pump accessory protein AcrZ', 'AcrZ', 4, NULL),
(20212, NULL, 'IPR019694', NULL, 'Bacteriophage HP1, Orf23', 'Phage_HP1_Orf23', 4, NULL),
(20213, NULL, 'IPR034471', NULL, 'GDGT/MA synthase', 'GDGT/MA_synthase', 4, NULL),
(20214, NULL, 'IPR020586', NULL, 'Photosystem I PsaA/PsaB, conserved site', 'PSI_PsaA/B_CS', 2, NULL),
(20215, NULL, 'IPR018362', NULL, 'CCAAT-binding factor, conserved site', 'CCAAT-binding_factor_CS', 2, NULL),
(20216, NULL, 'IPR024251', NULL, 'Membrane protein, Torovirus', 'M_Torovirus', 4, NULL),
(20217, NULL, 'IPR024264', NULL, 'Domain of unknown function DUF3786', 'DUF3786', 3, NULL),
(20218, NULL, 'IPR016353', NULL, 'Chordin', 'Chordin', 4, NULL),
(20219, NULL, 'IPR020611', NULL, 'Copper type II, ascorbate-dependent monooxygenase, histidine-cluster-1 conserved site', 'Cu2_ascorb_mOase_CS-1', 2, NULL),
(20220, NULL, 'IPR022019', NULL, 'Domain of unknown function DUF3600', 'DUF3600', 3, NULL),
(20221, NULL, 'IPR018368', NULL, 'ClpA/B, conserved site 1', 'ClpA/B_CS1', 2, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(20222, NULL, 'IPR019590', NULL, 'Disks large homologue 1, N-terminal PEST domain', 'DLG1_PEST_dom', 3, NULL),
(20223, NULL, 'IPR021942', NULL, 'Protein of unknown function DUF3557', 'DUF3557', 4, NULL),
(20224, NULL, 'IPR016685', NULL, 'RNA-induced silencing complex, nuclease component Tudor-SN', 'Silence_cplx_Nase-comp_TudorSN', 4, NULL),
(20225, NULL, 'IPR018363', NULL, 'CD59 antigen, conserved site', 'CD59_antigen_CS', 2, NULL),
(20226, NULL, 'IPR022036', NULL, 'Protein of unknown function DUF3605', 'DUF3605', 4, NULL),
(20227, NULL, 'IPR024265', NULL, 'Protein of unknown function DUF3788', 'DUF3788', 4, NULL),
(20228, NULL, 'IPR016329', NULL, 'Neurotoxin, TxP-I', 'Neurotoxin_TxP-I', 4, NULL),
(20229, NULL, 'IPR024244', NULL, 'Protein of unknown function DUF2537', 'DUF2537', 4, NULL),
(20230, NULL, 'IPR020635', NULL, 'Tyrosine-protein kinase, catalytic domain', 'Tyr_kinase_cat_dom', 3, NULL),
(20231, NULL, 'IPR019610', NULL, 'Iron sulphur domain-containing, mitoNEET, N-terminal', 'FeS-contain_mitoNEET_N', 3, NULL),
(20232, NULL, 'IPR019691', NULL, 'Protein of unknown function DUF2585', 'DUF2585', 4, NULL),
(20233, NULL, 'IPR016688', NULL, 'Mechanosensitive ion channel MscS-like, plants/fungi', 'MscS-like_plants/fungi', 4, NULL),
(20234, NULL, 'IPR016694', NULL, 'Protein of unknown function UCP017292, zinc finger, CHY-type', 'UCP017292', 4, NULL),
(20235, NULL, 'IPR016342', NULL, 'AP-1/2/4 complex subunit beta', 'AP_complex_bsu_1_2_4', 4, NULL),
(20236, NULL, 'IPR016668', NULL, 'NADH dehydrogenase [ubiquinone] iron-sulfur protein 6, mitochondrial', 'NDUFS6', 4, NULL),
(20237, NULL, 'IPR024767', NULL, 'Pre-mRNA-splicing factor 38, C-terminal', 'PRP38_C', 3, NULL),
(20238, NULL, 'IPR016326', NULL, 'Mating factor alpha', 'Mating_factor_a', 4, NULL),
(20239, NULL, 'IPR016703', NULL, 'Conjugal transfer, TraD, beta/gamma-type', 'Conjugal_tfr_TraD_b/g-type', 4, NULL),
(20240, NULL, 'IPR016348', NULL, 'L-selectin', 'L-selectin', 4, NULL),
(20241, NULL, 'IPR019593', NULL, 'Spore coat protein Z/Y', 'Spore_coat_protein_Z/Y', 4, NULL),
(20242, NULL, 'IPR019604', NULL, 'Photosystem P840 reaction-centre, cytochrome c-551', 'Cytochrome-c551', 4, NULL),
(20243, NULL, 'IPR017101', NULL, 'P-loop ATP/GTP binding protein, All4644, predicted', 'P-loop_ATP/GTP-bd_All4644_prd', 4, NULL),
(20244, NULL, 'IPR035197', NULL, 'Protein of unknown function DUF5313', 'DUF5313', 4, NULL),
(20245, NULL, 'IPR018360', NULL, 'Calcitonin, conserved site', 'Calcitonin_CS', 2, NULL),
(20246, NULL, 'IPR016343', NULL, 'Spectrin, beta subunit', 'Spectrin_bsu', 4, NULL),
(20247, NULL, 'IPR024297', NULL, 'Inorganic phosphate transporter chaperone Pho86', 'Pho86', 4, NULL),
(20248, NULL, 'IPR018848', NULL, 'WIYLD domain', 'WIYLD_domain', 3, NULL),
(20249, NULL, 'IPR020761', NULL, 'Uncharacterised protein family UPF0114, bacteria', 'UPF0114_bac', 4, NULL),
(20250, NULL, 'IPR021951', NULL, 'Protein of unknown function DUF3567', 'DUF3567', 4, NULL),
(20251, NULL, 'IPR018369', NULL, 'Chaperonin GroES, conserved site', 'Chaprnonin_Cpn10_CS', 2, NULL),
(20252, NULL, 'IPR021988', NULL, 'Beta-mannosyltransferase', 'BMT1', 4, NULL),
(20253, NULL, 'IPR022029', NULL, 'Putative peptidoglycan binding domain', 'PG-bd_4', 3, NULL),
(20254, NULL, 'IPR020308', NULL, 'Uncharacterised protein family, Ynq1', 'Uncharacterised_Ynq1', 4, NULL),
(20255, NULL, 'IPR018851', NULL, 'Borealin, N-terminal', 'Borealin_N', 3, NULL),
(20256, NULL, 'IPR020503', NULL, 'Uncharacterised protein family Rv2561', 'Uncharacterised_Rv2561', 4, NULL),
(20257, NULL, 'IPR018375', NULL, 'Coproporphyrinogen III oxidase, conserved site', 'Coprogen_oxidase_CS', 2, NULL),
(20258, NULL, 'IPR022004', NULL, 'White spot syndrome virus structural envelope protein Vp28', 'WSSV_Vp28', 3, NULL),
(20259, NULL, 'IPR016358', NULL, 'Hemopexin', 'Hemopexin', 4, NULL),
(20260, NULL, 'IPR022049', NULL, 'FAM69, protein-kinase domain', 'FAM69_kinase_dom', 3, NULL),
(20261, NULL, 'IPR016377', NULL, 'Sucrose/Glucosylglycerate phosphorylase-related', 'Sucrose_GGa_phosphorylase-rel', 4, NULL),
(20262, NULL, 'IPR018853', NULL, 'Protein of unknown function DUF2457', 'DUF2457', 4, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(20263, NULL, 'IPR020821', NULL, 'Extracellular Endonuclease, subunit A', 'Extracellular_endonuc_su_A', 3, NULL),
(20264, NULL, 'IPR016367', NULL, 'Major outer membrane lipoprotein Lpp', 'MOM_Lpp', 4, NULL),
(20265, NULL, 'IPR020504', NULL, 'Protein of unknown function DUF5500', 'DUF5500', 4, NULL),
(20266, NULL, 'IPR021956', NULL, 'Protein of unknown function DUF3573', 'DUF3573', 4, NULL),
(20267, NULL, 'IPR018830', NULL, 'Protein of unknown function DUF2434', 'DUF2434', 4, NULL),
(20268, NULL, 'IPR019581', NULL, 'Pre-mRNA-processing-splicing factor 8, U5-snRNA-binding', 'Prp8_U5-snRNA-bd', 3, NULL),
(20269, NULL, 'IPR019686', NULL, 'Protein of unknown function DUF2536', 'DUF2536', 4, NULL),
(20270, NULL, 'IPR019697', NULL, 'Bacteriophage HP1, Orf28', 'Phage_HP1_Orf28', 4, NULL),
(20271, NULL, 'IPR019601', NULL, 'Oxoglutarate/iron-dependent oxygenase, C-terminal degradation domain', 'Oxoglutarate/Fe-dep_Oase_C', 3, NULL),
(20272, NULL, 'IPR016692', NULL, 'Sulfiredoxin', 'Sulfiredoxin', 4, NULL),
(20273, NULL, 'IPR017103', NULL, 'Ionotropic glutamate receptor, plant', 'Iontropic_Glu_rcpt_pln', 4, NULL),
(20274, NULL, 'IPR020501', NULL, 'Uncharacterised protein family AF1218', 'Uncharacterised_AF1218', 4, NULL),
(20275, NULL, 'IPR022005', NULL, 'Prohormone convertase enzyme', 'Proho_convert', 3, NULL),
(20276, NULL, 'IPR017118', NULL, 'Peptidase S1A, matriptase-2', 'Pept_S1A_matriptase-2', 4, NULL),
(20277, NULL, 'IPR020415', NULL, 'Interleukin-34', 'IL-34', 4, NULL),
(20278, NULL, 'IPR016679', NULL, 'Transcription factor, GATA, plant', 'TF_GATA_pln', 4, NULL),
(20279, NULL, 'IPR019600', NULL, 'Hemin uptake protein HemP', 'Hemin_uptake_protein_HemP', 4, NULL),
(20280, NULL, 'IPR017113', NULL, 'Antirestriction, ArdC', 'Antirestriction_ArdC', 4, NULL),
(20281, NULL, 'IPR016324', NULL, 'Thyroglobulin', 'Thyroglobulin', 4, NULL),
(20282, NULL, 'IPR021998', NULL, 'Alfin, N-terminal', 'Alfin_N', 3, NULL),
(20283, NULL, 'IPR019689', NULL, 'Toxin GhoT/OrtT', 'Toxin_GhoT/OrtT', 4, NULL),
(20284, NULL, 'IPR016372', NULL, 'K88 fimbrial protein A', 'K88_fimbrial_pA', 4, NULL),
(20285, NULL, 'IPR018358', NULL, 'Disintegrin, conserved site', 'Disintegrin_CS', 2, NULL),
(20286, NULL, 'IPR022024', NULL, 'Protein of unknown function DUF3602', 'DUF3602', 4, NULL),
(20287, NULL, 'IPR019587', NULL, 'Polyketide cyclase/dehydrase', 'Polyketide_cyclase/dehydratase', 4, NULL),
(20288, NULL, 'IPR024276', NULL, 'Crustacean cardioactive peptide', 'CCAP', 4, NULL),
(20289, NULL, 'IPR034727', NULL, 'Kintoun', 'Kintoun', 4, NULL),
(20290, NULL, 'IPR022023', NULL, 'U1 small nuclear ribonucleoprotein of 70kDa N-terminal', 'U1snRNP70_N', 3, NULL),
(20291, NULL, 'IPR022032', NULL, 'Myogenic determination factor 5', 'Myf5', 3, NULL),
(20292, NULL, 'IPR020302', NULL, 'Uncharacterized YnfE-like', 'YnfE-like', 4, NULL),
(20293, NULL, 'IPR035456', NULL, 'SH3BP4, SH3 domain', 'SH3BP4_SH3', 3, NULL),
(20294, NULL, 'IPR020447', NULL, 'Interleukin-9', 'IL-9', 4, NULL),
(20295, NULL, 'IPR019615', NULL, 'Protein of unknown function DUF2487', 'DUF2487', 4, NULL),
(20296, NULL, 'IPR022007', NULL, 'I-kappa-kinase-beta NEMO binding domain', 'IKKbetaNEMObind', 3, NULL),
(20297, NULL, 'IPR019693', NULL, 'Biofilm formation regulator YbaJ', 'Biofilm_formation_reg_YbaJ', 4, NULL),
(20298, NULL, 'IPR021980', NULL, 'PHTF1/2, N-terminal', 'PHTF1/2_N', 3, NULL),
(20299, NULL, 'IPR016355', NULL, 'Nuclear hormone receptor family 5', 'NR5_fam', 4, NULL),
(20300, NULL, 'IPR021941', NULL, 'Protein of unknown function DUF3556, transmembrane', 'DUF3556_TM', 4, NULL),
(20301, NULL, 'IPR020904', NULL, 'Short-chain dehydrogenase/reductase, conserved site', 'Sc_DH/Rdtase_CS', 2, NULL),
(20302, NULL, 'IPR021940', NULL, 'Uncharacterised domain Wax2, C-terminal', 'Uncharacterised_Wax2_C', 3, NULL),
(20303, NULL, 'IPR024298', NULL, 'Ancestral coatomer element 1, Sec16/Sec31', 'ACE1_Sec16_Sec31', 3, NULL),
(20304, NULL, 'IPR021948', NULL, 'Protein of unknown function DUF3565', 'DUF3565', 4, NULL),
(20305, NULL, 'IPR019591', NULL, 'Mrp/NBP35 ATP-binding protein', 'Mrp/NBP35_ATP-bd', 4, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(20306, NULL, 'IPR035131', NULL, 'Protein of unknown function DUF5502', 'DUF5502', 4, NULL),
(20307, NULL, 'IPR019606', NULL, 'GerMN domain', 'GerMN', 3, NULL),
(20308, NULL, 'IPR018846', NULL, 'Cleavage/polyadenylation specificity factor, A subunit, N-terminal', 'Cleavage/polyA-sp_fac_asu_N', 3, NULL),
(20309, NULL, 'IPR019699', NULL, 'Protein of unknown function DUF2584', 'DUF2584', 4, NULL),
(20310, NULL, 'IPR018385', NULL, 'C4-dicarboxylate anaerobic carrier-like', 'C4_dicarb_anaerob_car-like', 4, NULL),
(20311, NULL, 'IPR018834', NULL, 'DNA/RNA-binding domain, Est1-type', 'DNA/RNA-bd_Est1-type', 3, NULL),
(20312, NULL, 'IPR019692', NULL, 'Domain of unknown function DUF2581', 'DUF2581', 3, NULL),
(20313, NULL, 'IPR020625', NULL, 'Schiff base-forming aldolase, active site', 'Schiff_base-form_aldolases_AS', 0, NULL),
(20314, NULL, 'IPR021992', NULL, 'Mannan-binding protein', 'MVL', 3, NULL),
(20315, NULL, 'IPR018389', NULL, 'TRAP transporter solute receptor DctP', 'DctP_fam', 4, NULL),
(20316, NULL, 'IPR016347', NULL, 'Acyl-CoA-binding domain-containing protein 5', 'ACBD5', 4, NULL),
(20317, NULL, 'IPR016705', NULL, 'Photosynthesis system II assembly factor Ycf48/Hcf136', 'Ycf48/Hcf136', 4, NULL),
(20318, NULL, 'IPR019683', NULL, 'Sporulation inhibitor of replication protein SirA', 'SirA', 4, NULL),
(20319, NULL, 'IPR017119', NULL, 'SET domain containing methyltransferase Efm1/Rkm1', 'Efm1/Rkm1', 4, NULL),
(20320, NULL, 'IPR016335', NULL, 'Receptor-type tyrosine-protein phosphatase C', 'Ptprc', 4, NULL),
(20321, NULL, 'IPR024246', NULL, 'Protein of unknown function DUF2674', 'DUF2674', 4, NULL),
(20322, NULL, 'IPR022008', NULL, 'TSG101 and ALIX binding domain of CEP55', 'EABR', 3, NULL),
(20323, NULL, 'IPR016707', NULL, 'Conjugal transfer, TraB, rhizobiales', 'Conjugal_tfr_TraB_rhizob', 4, NULL),
(20324, NULL, 'IPR020306', NULL, 'Mite allergen, group 5/21', 'Mite_allergen_group-5/21', 4, NULL),
(20325, NULL, 'IPR020266', NULL, 'Mitochondrial import receptor subunit Tom6', 'Tom6', 4, NULL),
(20326, NULL, 'IPR022013', NULL, 'Fungal calcium binding protein', 'CBP', 3, NULL),
(20327, NULL, 'IPR016712', NULL, 'Mitochondrial ribosomal protein MRP51, fungi', 'Mt_Rbsml_MRP51_fun', 4, NULL),
(20328, NULL, 'IPR016332', NULL, 'Alpha-1B-glycoprotein/leukocyte immunoglobulin-like receptor', 'A1B_glyco/leuk_Ig-like_rcpt', 4, NULL),
(20329, NULL, 'IPR018844', NULL, 'Nucleolar protein Dnt1-like, N-terminal', 'Dnt1-like_N', 3, NULL),
(20330, NULL, 'IPR020410', NULL, 'Interleukin-15, fish', 'IL-15_fish', 4, NULL),
(20331, NULL, 'IPR019607', NULL, 'Putative zinc-finger domain', 'Putative_zinc-finger_domain', 3, NULL),
(20332, NULL, 'IPR024258', NULL, 'Protein of unknown function DUF3798', 'DUF3798', 4, NULL),
(20333, NULL, 'IPR017122', NULL, 'Uncharacterised conserved protein UCP037158', 'UCP037158', 4, NULL),
(20334, NULL, 'IPR023575', NULL, 'Ribosomal protein S19/S15, superfamily', 'Ribosomal_S19_S15_SF', 5, NULL),
(20335, NULL, 'IPR019613', NULL, 'Protein of unknown function DUF4198', 'DUF4198', 4, NULL),
(20336, NULL, 'IPR016676', NULL, 'Phospholipid/glycerol acyltransferase, predicted', 'P_lipid/glycerol_AcTrfase_prd', 4, NULL),
(20337, NULL, 'IPR020987', NULL, 'Centromere protein Cenp-M', 'Centromere_Cenp-M', 4, NULL),
(20338, NULL, 'IPR021972', NULL, 'Parvovirus non-structural protein 1, C-terminal', 'Parvovirus_NS1_C', 3, NULL),
(20339, NULL, 'IPR021985', NULL, 'RNA polymerase Rpo13 subunit HTH domain', 'RNA_pol_Rpo13', 3, NULL),
(20340, NULL, 'IPR023953', NULL, 'Heme oxygenase IsdG', 'IsdG', 4, NULL),
(20341, NULL, 'IPR024242', NULL, 'Non-classical export protein 1', 'NCE101', 4, NULL),
(20342, NULL, 'IPR022038', NULL, 'Ig-like domain, bacterial type', 'Ig-like_bact', 3, NULL),
(20343, NULL, 'IPR016690', NULL, 'tRNA-splicing endonuclease, SEN34 subunit', 'tRNA_splic_SEN34', 4, NULL),
(20344, NULL, 'IPR022025', NULL, 'Putative amidoligase enzyme', 'Amidoligase_2', 4, NULL),
(20345, NULL, 'IPR035449', NULL, 'SH3PXD2A, SH3 domain 3', 'SH3PXD2A_SH3_3', 3, NULL),
(20346, NULL, 'IPR022011', NULL, 'Nup358/RanBP2 E3 ligase domain', 'IR1-M', 3, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(20347, NULL, 'IPR021945', NULL, 'Protein of unknown function DUF3562', 'DUF3562', 4, NULL),
(20348, NULL, 'IPR019577', NULL, 'SPARC/Testican, calcium-binding domain', 'SPARC/Testican_Ca-bd-dom', 3, NULL),
(20349, NULL, 'IPR035192', NULL, 'Nuclear pore complex protein NUP160', 'NUP160', 3, NULL),
(20350, NULL, 'IPR023364', NULL, 'Trans-sialidase, domain 3', 'Trans_sialidase_dom3', 5, NULL),
(20351, NULL, 'IPR035191', NULL, 'K88 minor fimbrial subunit FaeF', 'FaeF', 4, NULL),
(20352, NULL, 'IPR020630', NULL, 'Tetrahydrofolate dehydrogenase/cyclohydrolase, catalytic domain', 'THF_DH/CycHdrlase_cat_dom', 3, NULL),
(20353, NULL, 'IPR019619', NULL, 'Protein of unknown function DUF2490', 'DUF2490', 4, NULL),
(20354, NULL, 'IPR021975', NULL, 'Rifampin ADP-ribosyltransferase', 'Rifampin_Arr', 3, NULL),
(20355, NULL, 'IPR016674', NULL, 'Sphingomyelinase D/Phospholipase D', 'SMase_D/PLipase_D', 4, NULL),
(20356, NULL, 'IPR034335', NULL, 'Prostaglandin E synthase 2, C-terminal', 'PGES2_C', 3, NULL),
(20357, NULL, 'IPR017102', NULL, 'Uncharacterised conserved protein UCP037087', 'UCP037087', 4, NULL),
(20358, NULL, 'IPR020946', NULL, 'Flavin monooxygenase-like', 'Flavin_mOase-like', 4, NULL),
(20359, NULL, 'IPR035452', NULL, 'SH3PXD2A, SH3 domain 2', 'SH3PXD2A_SH3_2', 3, NULL),
(20360, NULL, 'IPR017111', NULL, 'Histone-lysine N-methyltransferase Set1, fungi', 'Set1_fungi', 4, NULL),
(20361, NULL, 'IPR024234', NULL, 'Protein of unknown function DUF3801', 'DUF3801', 4, NULL),
(20362, NULL, 'IPR018372', NULL, 'Chloramphenicol acetyltransferase, active site', 'Chloramphenicol_AcTrfase_AS', 0, NULL),
(20363, NULL, 'IPR016696', NULL, 'TRAPP I complex, subunit 5', 'TRAPP-I_su5', 4, NULL),
(20364, NULL, 'IPR018843', NULL, 'U3 small nucleolar RNA-associated protein 8', 'Utp8', 4, NULL),
(20365, NULL, 'IPR020626', NULL, 'L-aspartate dehydrogenase, prokaryotic', 'Asp_DH_prok', 4, NULL),
(20366, NULL, 'IPR022047', NULL, 'Microcephalin-like', 'Microcephalin-like', 4, NULL),
(20367, NULL, 'IPR022022', NULL, 'Immune evasion protein', 'M04gp34-like', 4, NULL),
(20368, NULL, 'IPR019701', NULL, 'NinX, bacteriophage P22', 'Phage_P22_NinX', 4, NULL),
(20369, NULL, 'IPR022015', NULL, 'Tuberculin-active protein', 'Tuberculin', 3, NULL),
(20370, NULL, 'IPR016661', NULL, 'Prefoldin, subunit 4', 'PFDN4', 4, NULL),
(20371, NULL, 'IPR022053', NULL, 'Protein of unknown function DUF3613', 'DUF3613', 4, NULL),
(20372, NULL, 'IPR019598', NULL, 'Universal stress protein B', 'Universal_stress_protein_B', 4, NULL),
(20373, NULL, 'IPR020612', NULL, 'Methylthiotransferase, conserved site', 'Methylthiotransferase_CS', 2, NULL),
(20374, NULL, 'IPR022034', NULL, 'Fragile X messenger ribonucleoprotein 1, C-terminal core', 'FMR1_C_core', 3, NULL),
(20375, NULL, 'IPR035170', NULL, 'Metastasis-associated protein MTA1, R1 domain', 'MTA1_R1', 3, NULL),
(20376, NULL, 'IPR024299', NULL, 'NigD-like N-terminal OB domain', 'NigD-like_OB_dom', 3, NULL),
(20377, NULL, 'IPR021939', NULL, 'Kank N-terminal motif', 'KN_motif', 2, NULL),
(20378, NULL, 'IPR016667', NULL, 'Capsular polysaccharide synthesis, CpsB/CapC', 'Caps_polysacc_synth_CpsB/CapC', 4, NULL),
(20379, NULL, 'IPR020610', NULL, 'Thiolase, active site', 'Thiolase_AS', 0, NULL),
(20380, NULL, 'IPR020534', NULL, 'Uncharacterised protein family YqxA', 'Uncharacterised_YqxA', 4, NULL),
(20381, NULL, 'IPR016317', NULL, 'Pro-epidermal growth factor', 'Pro-epidermal_GF', 4, NULL),
(20382, NULL, 'IPR024267', NULL, 'Domain of unknown function (DUF4878)', 'DUF4878', 3, NULL),
(20383, NULL, 'IPR017114', NULL, 'C2H2-type Zinc finger protein,  YY1-like', 'YY1-like', 4, NULL),
(20384, NULL, 'IPR016671', NULL, 'Acyl-protein synthetase, LuxE, bacterial', 'LuxE_bac', 4, NULL),
(20385, NULL, 'IPR034341', NULL, 'Stringent starvation protein A, N-terminal', 'SspA_N', 3, NULL),
(20386, NULL, 'IPR016683', NULL, 'Glycosyl transferase, family 28, RedA, predicted', 'Glyco_trans_28_RedA_prd', 4, NULL),
(20387, NULL, 'IPR016361', NULL, 'Transcriptional enhancer factor, metazoa', 'TEF_metazoa', 4, NULL),
(20388, NULL, 'IPR020412', NULL, 'Interleukin-11, mammalian', 'IL-11_mml', 4, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(20389, NULL, 'IPR035175', NULL, 'Serine/threonine-protein kinase SMG1, N-terminal', 'SMG1_N', 3, NULL),
(20390, NULL, 'IPR016331', NULL, 'Shiga-like toxin, subunit A', 'Shiga-like_toxin_subunit_A', 4, NULL),
(20391, NULL, 'IPR016318', NULL, 'Transforming protein, StpA/StpB', 'Transforming_StpA/StpB', 4, NULL),
(20392, NULL, 'IPR022002', NULL, 'Domain of unknown function DUF35, rubredoxin-like zinc ribbon domain, N-terminal', 'DUF35_Znr_N', 3, NULL),
(20393, NULL, 'IPR016370', NULL, 'Photosystem I reaction center subunit V/PsaK, plant', 'PSI_PsaG/PsaK_pln', 4, NULL),
(20394, NULL, 'IPR018384', NULL, 'DNA-binding protein Tfx, euryarchaeota', 'Tfx_DNA-bd_euryarc', 4, NULL),
(20395, NULL, 'IPR021962', NULL, 'Surface lipoprotein of Spirochaetales order', 'Lipl32', 3, NULL),
(20396, NULL, 'IPR016678', NULL, 'Mono-ADP-ribosyltransferase C3/Edin', 'Mono-ADP_RibTrfase_C3/Edin', 4, NULL),
(20397, NULL, 'IPR020497', NULL, 'Protein of unknown function DUF5440', 'DUF5440', 4, NULL),
(20398, NULL, 'IPR021993', NULL, 'Putative metal-binding domain of cation transport ATPase', 'ATPase-cat-bd', 3, NULL),
(20399, NULL, 'IPR022037', NULL, 'Protein of unknown function DUF3606', 'DUF3606', 4, NULL),
(20400, NULL, 'IPR035188', NULL, 'Histone-like protein p6', 'Histone-like_p6', 4, NULL),
(20401, NULL, 'IPR023265', NULL, 'Aquaporin 12', 'Aquaporin_12', 4, NULL),
(20402, NULL, 'IPR021963', NULL, 'T cell CD4 receptor C-terminal region', 'Tcell_CD4_Cterm', 3, NULL),
(20403, NULL, 'IPR035450', NULL, 'SH3PXD2A, SH3 domain 1', 'SH3PXD2A_SH3_1', 3, NULL),
(20404, NULL, 'IPR019588', NULL, 'Metabotropic glutamate receptor, Homer-binding domain', 'Metabotropic_Glu_rcpt_Homer-bd', 3, NULL),
(20405, NULL, 'IPR024250', NULL, 'Protein of unknown function DUF2711', 'DUF2711', 4, NULL),
(20406, NULL, 'IPR021961', NULL, 'Type IV methyl-directed restriction enzyme EcoKMcrB subunit, DNA-binding domain', 'McrB_DNA-bd', 3, NULL),
(20407, NULL, 'IPR018835', NULL, 'RNA-binding domain, putative', 'RNA-binding_domain_put', 3, NULL),
(20408, NULL, 'IPR024256', NULL, 'Domain of unknown function DUF3797', 'DUF3797', 3, NULL),
(20409, NULL, 'IPR022035', NULL, 'PCIF1, WW domain', 'PCIF1_WW', 3, NULL),
(20410, NULL, 'IPR021957', NULL, 'Protein of unknown function DUF3574', 'DUF3574', 4, NULL),
(20411, NULL, 'IPR018841', NULL, 'Protein of unknown function DUF2442', 'DUF2442', 4, NULL),
(20412, NULL, 'IPR016352', NULL, 'Small leucine-rich proteoglycan, class I, decorin/asporin/byglycan', 'SLRP_I_decor/aspor/byglycan', 4, NULL),
(20413, NULL, 'IPR016698', NULL, 'Numb/numb-like', 'Numb/numb-like', 4, NULL),
(20414, NULL, 'IPR017121', NULL, 'Nitrite reductase [NAD(P)H], large subunit', 'Nitrite_Rdtase_lsu', 4, NULL),
(20415, NULL, 'IPR035173', NULL, 'Sulphur globule protein', 'SGP', 4, NULL),
(20416, NULL, 'IPR022050', NULL, 'Thermostable hemolysin', 'T_hemolysin', 4, NULL),
(20417, NULL, 'IPR024768', NULL, 'Meiosis regulator and mRNA stability factor 1', 'Marf1', 4, NULL),
(20418, NULL, 'IPR024245', NULL, 'Cell wall synthesis protein CwsA', 'CwsA', 4, NULL),
(20419, NULL, 'IPR017120', NULL, 'Bifunctional 3-hexulose-6-phosphate synthase/demethylmenaquinone methyltransferase, predicted', 'Bifunct_HPS/DMK_prd', 4, NULL),
(20420, NULL, 'IPR024248', NULL, 'Protein of unknown function DUF2695', 'DUF2695', 4, NULL),
(20421, NULL, 'IPR016699', NULL, 'Acid ceramidase-like', 'Acid_ceramidase-like', 4, NULL),
(20422, NULL, 'IPR019609', NULL, 'Trypanosome variant surface glycoprotein, C-terminal', 'Variant_surf_glycoprt_trypan_C', 3, NULL),
(20423, NULL, 'IPR035196', NULL, 'Protein of unknown function DUF5312', 'DUF5312', 4, NULL),
(20424, NULL, 'IPR035457', NULL, 'CRK, N-terminal SH3 domain', 'CRK_SH3_N', 3, NULL),
(20425, NULL, 'IPR021977', NULL, 'D domain of beta-TrCP', 'Beta-TrCP_D', 3, NULL),
(20426, NULL, 'IPR021987', NULL, 'SLED domain', 'SLED', 3, NULL),
(20427, NULL, 'IPR016697', NULL, 'Aquaporin 11/12', 'Aquaporin_11/12', 4, NULL),
(20428, NULL, 'IPR016376', NULL, 'Histone acetyltransferase GCN5/PCAF', 'GCN5/PCAF', 4, NULL),
(20429, NULL, 'IPR022043', NULL, 'Chromatin assembly factor 1 subunit A', 'CAF1A', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(20430, NULL, 'IPR016673', NULL, 'Histamine N-methyltransferase-like', 'HHMT-like', 4, NULL),
(20431, NULL, 'IPR035187', NULL, 'Mitochondrial peculiar membrane protein 1', 'Mpm1', 4, NULL),
(20432, NULL, 'IPR020428', NULL, 'Atypical dual-specificity phosphatase Siw14-like, plant and fungi', 'PFA-DSPs', 4, NULL),
(20433, NULL, 'IPR018833', NULL, 'Rv2993c-like, N-terminal', 'Rv2993c-like_N', 3, NULL),
(20434, NULL, 'IPR018842', NULL, 'YkuI, C-terminal', 'YkuI_C', 3, NULL),
(20435, NULL, 'IPR019682', NULL, 'Bacteriophage T7, Gp17.5, holin', 'Phage_T7_Gp17.5_holin', 4, NULL),
(20436, NULL, 'IPR019594', NULL, 'Ionotropic glutamate receptor, L-glutamate and glycine-binding domain', 'Glu/Gly-bd', 3, NULL),
(20437, NULL, 'IPR020781', NULL, 'ATPase, OSCP/delta subunit, conserved site', 'ATPase_OSCP/d_CS', 2, NULL),
(20438, NULL, 'IPR016689', NULL, 'ESCRT-2 complex, Snf8', 'ESCRT-2_cplx_Snf8', 4, NULL),
(20439, NULL, 'IPR016714', NULL, 'Mannan endo-1,4-beta-mannosidase B/E', 'MANB/E', 4, NULL),
(20440, NULL, 'IPR016704', NULL, 'Conjugal transfer, TrbD', 'Conjugal_tfr_TrbD', 4, NULL),
(20441, NULL, 'IPR016684', NULL, 'Type III secretion system chaperone, YscY', 'T3SS_YscY', 4, NULL),
(20442, NULL, 'IPR019579', NULL, 'Protein FAM161A/B', 'FAM161A/B', 4, NULL),
(20443, NULL, 'IPR018379', NULL, 'BEN domain', 'BEN_domain', 3, NULL),
(20444, NULL, 'IPR024286', NULL, 'Domain of unknown function DUF3700', 'DUF3700', 3, NULL),
(20445, NULL, 'IPR018845', NULL, 'Initiator binding domain', 'Initiator-bd', 3, NULL),
(20446, NULL, 'IPR034466', NULL, 'Methyltransferase, class B', 'Methyltransferase_Class_B', 4, NULL),
(20447, NULL, 'IPR016327', NULL, 'Alpha-defensin', 'Alpha-defensin', 4, NULL),
(20448, NULL, 'IPR019602', NULL, 'mRNA capping enzyme, large subunit, ATPase/guanylyltransferase, virus', 'mRNA_cap_ATPase/GuylTrfase_vir', 3, NULL),
(20449, NULL, 'IPR021994', NULL, 'Protein of unknown function DUF3592', 'DUF3592', 4, NULL),
(20450, NULL, 'IPR021982', NULL, 'Repeat element protein, Ichnovirus', 'REEP_Ichnovirus', 4, NULL),
(20451, NULL, 'IPR018838', NULL, 'Domain of unknown function DUF2439', 'DUF2439', 3, NULL),
(20452, NULL, 'IPR016346', NULL, 'Guanine nucleotide-binding protein, beta subunit', 'Guanine_nucleotide-bd_bsu', 4, NULL),
(20453, NULL, 'IPR019597', NULL, 'Energy-converting hydrogenase B, subunit P', 'Energy-convert_hydgase-B_suP', 4, NULL),
(20454, NULL, 'IPR020450', NULL, 'Interleukin-16', 'IL-16', 4, NULL),
(20455, NULL, 'IPR035448', NULL, 'Phosphoinositide 3-kinase, catalytic domain', 'PI3Kc', 3, NULL),
(20456, NULL, 'IPR018361', NULL, 'Caveolin, conserved site', 'Caveolin_CS', 2, NULL),
(20457, NULL, 'IPR021952', NULL, 'Lipoprotein Flpp3-like', 'Flpp3-like', 4, NULL),
(20458, NULL, 'IPR034474', NULL, 'Methyltransferase, class D', 'Methyltransferase_Class_D', 4, NULL),
(20459, NULL, 'IPR018836', NULL, 'Necrogenic protein Nec1', 'Necrogenic_Nec1', 4, NULL),
(20460, NULL, 'IPR020628', NULL, 'Formate-tetrahydrofolate ligase, FTHFS, conserved site', 'Formate_THF_ligase_CS', 2, NULL),
(20461, NULL, 'IPR022765', NULL, 'Dna2/Cas4, domain of unknown function DUF83', 'Dna2/Cas4_DUF83', 3, NULL),
(20462, NULL, 'IPR016711', NULL, 'Sds23', 'Ssd23', 4, NULL),
(20463, NULL, 'IPR022052', NULL, 'Histone-binding protein RBBP4, N-terminal', 'Histone-bd_RBBP4_N', 3, NULL),
(20464, NULL, 'IPR016686', NULL, 'Ribosome biogenesis factor, NIP7', 'Ribosomal_synth_fac_NIP7', 4, NULL),
(20465, NULL, 'IPR022768', NULL, 'Fascin domain', 'Fascin-domain', 3, NULL),
(20466, NULL, 'IPR018832', NULL, 'Peptidase C25, gingipain, C-terminal', 'Pept_C25_gingipain_C', 3, NULL),
(20467, NULL, 'IPR016670', NULL, 'DNA damage-inducible transcript 3', 'DNA_damage_induc_transcript_3', 4, NULL),
(20468, NULL, 'IPR019575', NULL, 'NADH-ubiquinone oxidoreductase 51kDa subunit, iron-sulphur binding domain', 'Nuop51_4Fe4S-bd', 3, NULL),
(20469, NULL, 'IPR016359', NULL, 'SPARC-like protein 1', 'SPARC-like_p1', 4, NULL),
(20470, NULL, 'IPR020419', NULL, 'Tumour necrosis factor receptor 1A', 'TNFR_1A', 4, NULL),
(20471, NULL, 'IPR019596', NULL, 'Bacteriophage Mu, GpM, tail tube', 'Phage_Mu_GpM_tail_tub', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(20472, NULL, 'IPR016357', NULL, 'Transferrin', 'Transferrin', 4, NULL),
(20473, NULL, 'IPR021979', NULL, 'Protein of unknown function DUF3584', 'DUF3584', 4, NULL),
(20474, NULL, 'IPR016706', NULL, 'Cleavage/polyadenylation specificity factor subunit 5', 'Cleav_polyA_spec_factor_su5', 4, NULL),
(20475, NULL, 'IPR018336', NULL, 'Ribonuclease PH, conserved site', 'RNase_PH_CS', 2, NULL),
(20476, NULL, 'IPR021947', NULL, 'Protein of unknown function DUF3564', 'DUF3564', 4, NULL),
(20477, NULL, 'IPR035458', NULL, 'CRK, C-terminal SH3 domain', 'CRK_SH3_C', 3, NULL),
(20478, NULL, 'IPR018850', NULL, 'Mitochondrial escape protein 2, C-terminal', 'Mt_escape_2_C', 3, NULL),
(20479, NULL, 'IPR021959', NULL, 'Protein of unknown function DUF3576', 'DUF3576', 4, NULL),
(20480, NULL, 'IPR018337', NULL, 'Cell wall/choline-binding repeat', 'Cell_wall/Cho-bd_repeat', 7, NULL),
(20481, NULL, 'IPR016365', NULL, 'Actobindin', 'Actobindin', 4, NULL),
(20482, NULL, 'IPR016337', NULL, 'Monocyte differentiation antigen CD14', 'Monocyte_diff_Ag_CD14', 4, NULL),
(20483, NULL, 'IPR020624', NULL, 'Schiff base-forming aldolase, conserved site', 'Schiff_base-form_aldolases_CS', 2, NULL),
(20484, NULL, 'IPR022016', NULL, 'Domain of unknown function DUF3597', 'DUF3597', 3, NULL),
(20485, NULL, 'IPR022045', NULL, 'Insecticide toxin TcdB middle/N-terminal', 'TcdB_toxin_mid/N', 3, NULL),
(20486, NULL, 'IPR035132', NULL, 'Protein of unknown function DUF5501', 'DUF5501', 4, NULL),
(20487, NULL, 'IPR021960', NULL, 'Protein of unknown function DUF3577', 'DUF3577', 4, NULL),
(20488, NULL, 'IPR017096', NULL, 'BTB-kelch protein', 'BTB-kelch_protein', 4, NULL),
(20489, NULL, 'IPR017112', NULL, 'Homeobox protein HXA9/HXB9/HXC9', 'HXA9/HXB9/HXC9', 4, NULL),
(20490, NULL, 'IPR017104', NULL, 'Adaptor protein complex AP-2, alpha subunit', 'AP2_complex_asu', 4, NULL),
(20491, NULL, 'IPR020500', NULL, 'Anti-RecBCD protein 2, bacteriophage P22', 'Phage_P22_anti-RecBCD_p2', 4, NULL),
(20492, NULL, 'IPR016374', NULL, 'Transcription factor, GATA-2/3', 'TF_GATA-2/3', 4, NULL),
(20493, NULL, 'IPR021970', NULL, 'Sequence-variable mosaic (SVM), signal sequence', 'SVM_signal', 3, NULL),
(20494, NULL, 'IPR016373', NULL, 'Opacity', 'Opacity', 4, NULL),
(20495, NULL, 'IPR021983', NULL, 'PRP8 domain IV core', 'PRP8_domainIV', 3, NULL),
(20496, NULL, 'IPR016666', NULL, 'TGF beta-induced protein/periostin', 'TGFBI/POSTN', 4, NULL),
(20497, NULL, 'IPR016340', NULL, 'Ribosomal protein L31, mitochondrial', 'Ribosomal_L31_mit', 4, NULL),
(20498, NULL, 'IPR021974', NULL, 'Protein of unknown function DUF3581', 'DUF3581', 4, NULL),
(20499, NULL, 'IPR019583', NULL, 'PDZ-associated domain of NMDA receptors', 'PDZ_assoc', 3, NULL),
(20500, NULL, 'IPR018198', NULL, 'ATP phosphoribosyltransferase, conserved site', 'ATP_PRibTrfase_CS', 2, NULL),
(20501, NULL, 'IPR020596', NULL, 'Ribosomal RNA adenine methylase transferase, conserved site', 'rRNA_Ade_Mease_Trfase_CS', 2, NULL),
(20502, NULL, 'IPR018885', NULL, 'mRNA-binding domain', 'mRNA-bd_dom', 3, NULL),
(20503, NULL, 'IPR023104', NULL, 'ITPase-like domain superfamily', 'ITPase-like_dom_sf', 5, NULL),
(20504, NULL, 'IPR018134', NULL, 'Lysosome-associated membrane glycoprotein, conserved site', 'LAMP_CS', 2, NULL),
(20505, NULL, 'IPR019648', NULL, 'Protein YebY', 'YebY', 4, NULL),
(20506, NULL, 'IPR017138', NULL, 'Aspartate/glutamate leucyltransferase', 'Asp_Glu_LeuTrfase', 4, NULL),
(20507, NULL, 'IPR022144', NULL, 'Domain of unknown function DUF3676', 'DUF3676', 3, NULL),
(20508, NULL, 'IPR019646', NULL, 'Aminoglycoside-2''''-adenylyltransferase', 'Aminoglyc_AdlTrfase', 4, NULL),
(20509, NULL, 'IPR022056', NULL, 'CpG binding protein, C-terminal', 'CpG-bd_C', 3, NULL),
(20510, NULL, 'IPR018891', NULL, 'Abortive bacteriophage infection, resistance', 'Abortive_phage_infection', 4, NULL),
(20511, NULL, 'IPR022168', NULL, 'Golgi associated RAB2 interactor protein-like, Rab2B-binding domain', 'GARIL-like_Rab2B-bd', 3, NULL),
(20512, NULL, 'IPR017143', NULL, 'Uncharacterised conserved protein UCP037225', 'UCP037225', 4, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(20513, NULL, 'IPR022136', NULL, 'Domain of unknown function DUF3668', 'DUF3668', 3, NULL),
(20514, NULL, 'IPR020667', NULL, 'DNA mismatch repair protein, MutL', 'DNA_mismatch_repair_MutL', 4, NULL),
(20515, NULL, 'IPR034342', NULL, 'Stringent starvation protein A, C-terminal', 'SspA_C', 3, NULL),
(20516, NULL, 'IPR024220', NULL, 'Protein of unknown function DUF3780', 'DUF3780', 4, NULL),
(20517, NULL, 'IPR022069', NULL, 'Protein of unknown function DUF3622', 'DUF3622', 4, NULL),
(20518, NULL, 'IPR018873', NULL, 'KilA-N, DNA-binding domain', 'KilA-N_DNA-bd_domain', 3, NULL),
(20519, NULL, 'IPR020592', NULL, 'Ribosomal protein S16, conserved site', 'Ribosomal_S16_CS', 2, NULL),
(20520, NULL, 'IPR019727', NULL, 'ATP synthase, F0 complex, subunit F, mitochondria, fungi', 'ATP_synth_F0_fsu_mt_fun', 4, NULL),
(20521, NULL, 'IPR017485', NULL, 'Tryptophan 2,3-dioxygenase, bacterial', 'Trp_2-3-dOase_bac', 4, NULL),
(20522, NULL, 'IPR017469', NULL, 'PEP-CTERM system-associated, FemAB-related', 'PEP-CTERM_FemAB-rel', 4, NULL),
(20523, NULL, 'IPR017499', NULL, 'Protein Thf1', 'Thf1', 4, NULL),
(20524, NULL, 'IPR019758', NULL, 'Peptidase S26A, signal peptidase I, conserved site', 'Pept_S26A_signal_pept_1_CS', 2, NULL),
(20525, NULL, 'IPR022062', NULL, 'Protein of unknown function DUF3618', 'DUF3618', 4, NULL),
(20526, NULL, 'IPR017492', NULL, 'Photosystem I reaction center subunit PsaK', 'PSI_PsaK', 4, NULL),
(20527, NULL, 'IPR020845', NULL, 'AMP-binding, conserved site', 'AMP-binding_CS', 2, NULL),
(20528, NULL, 'IPR022106', NULL, 'Paired box protein 7, C-terminal', 'Pax7_C', 3, NULL),
(20529, NULL, 'IPR017467', NULL, 'Conserved hypothetical protein CHP03016, PEP-CTERM', 'CHP03016_PEP-CTERM', 4, NULL),
(20530, NULL, 'IPR018893', NULL, 'Type VIII secretion system, CsgF', 'T8SS_CsgF', 4, NULL),
(20531, NULL, 'IPR017481', NULL, 'Conserved hypothetical protein CHP03032', 'CHP03032', 3, NULL),
(20532, NULL, 'IPR018905', NULL, 'Alpha-galactosidase, NEW3 domain', 'A-galactase_NEW3', 3, NULL),
(20533, NULL, 'IPR019633', NULL, 'Protein of unknown function DUF2498', 'DUF2498', 4, NULL),
(20534, NULL, 'IPR022066', NULL, 'Histidine kinase PdtaS, GAF domain', 'PdtaS_GAF', 3, NULL),
(20535, NULL, 'IPR022072', NULL, 'Protein of unknown function DUF3624', 'DUF3624', 4, NULL),
(20536, NULL, 'IPR018863', NULL, 'Fragile site-associated protein, C-terminal', 'Fragile_site-assoc_C', 3, NULL),
(20537, NULL, 'IPR018876', NULL, 'Bacteriophage P22, antirepressor protein, C-terminal', 'Phage_P22_antirepressor_C', 3, NULL),
(20538, NULL, 'IPR017476', NULL, 'UDP-glucose/GDP-mannose dehydrogenase', 'UDP-Glc/GDP-Man', 4, NULL),
(20539, NULL, 'IPR019631', NULL, 'Myticin preproprotein', 'Myticin_preproprotein', 4, NULL),
(20540, NULL, 'IPR017136', NULL, 'Uncharacterised conserved protein UCP037205', 'UCP037205', 4, NULL),
(20541, NULL, 'IPR024305', NULL, 'Single-stranded DNA binding protein DdrB-like', 'ssDNA-bd_DdrB-like', 4, NULL),
(20542, NULL, 'IPR019723', NULL, 'Uncharacterised protein, YfmQ', 'Uncharacterised_YfmQ', 4, NULL),
(20543, NULL, 'IPR020795', NULL, 'Origin recognition complex, subunit 3', 'ORC3', 4, NULL),
(20544, NULL, 'IPR019767', NULL, 'Erythropoietin/thrombopoeitin, conserved site', 'EPO/TPO_CS', 2, NULL),
(20545, NULL, 'IPR017135', NULL, 'D-glutamate cyclase, mitochondrial', 'D-Glu_cyclase_mito', 4, NULL),
(20546, NULL, 'IPR017856', NULL, 'Integrase-like, N-terminal', 'Integrase-like_N', 5, NULL),
(20547, NULL, 'IPR017463', NULL, 'Sulphur relay, TusD/DsrE', 'Sulphur_relay_TusD/DsrE', 4, NULL),
(20548, NULL, 'IPR018094', NULL, 'Thymidylate kinase', 'Thymidylate_kinase', 4, NULL),
(20549, NULL, 'IPR019666', NULL, 'Cell division activator CedA', 'Cell_div_activator_CedA', 4, NULL),
(20550, NULL, 'IPR024221', NULL, 'Beta-lactamase-inhibitor protein BLIP domain superfamily', 'BLIP_dom_sf', 5, NULL),
(20551, NULL, 'IPR019722', NULL, 'Glucose-6-phosphate 1-dehydrogenase, bacterial', 'G6PD_bac', 4, NULL),
(20552, NULL, 'IPR019756', NULL, 'Peptidase S26A, signal peptidase I, serine active site', 'Pept_S26A_signal_pept_1_Ser-AS', 0, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(20553, NULL, 'IPR022068', NULL, 'Mamastrovirus p20 protein', 'Mamastrovirus_p20', 4, NULL),
(20554, NULL, 'IPR022164', NULL, 'Kinesin-like', 'Kinesin-like', 3, NULL),
(20555, NULL, 'IPR024225', NULL, 'Cyclic-AMP phosphodiesterase class-II, conserved site', 'cAMP-PdiesteraseII_CS', 2, NULL),
(20556, NULL, 'IPR017123', NULL, 'Uncharacterised conserved protein UCP037159', 'UCP037159', 4, NULL),
(20557, NULL, 'IPR018145', NULL, 'CagE, TrbE, VirB component of type IV transporter system, central domain', 'CagE_TrbE_VirB_cntrl_dom', 3, NULL),
(20558, NULL, 'IPR020794', NULL, 'Aconitase X subunit 2, archaeal, putative', 'AcnX_sub2_archaea_put', 4, NULL),
(20559, NULL, 'IPR034130', NULL, 'RNA-binding protein Musashi homologue, RNA recognition motif 1', 'MSI_RRM1', 3, NULL),
(20560, NULL, 'IPR019755', NULL, 'Restriction endonuclease, type II, EcoRV, Proteobacteria', 'Restrct_endonuc_II_EcoRV_Pbac', 4, NULL),
(20561, NULL, 'IPR018862', NULL, 'Eukaryotic translation initiation factor 4E binding protein', 'eIF4E-T', 4, NULL),
(20562, NULL, 'IPR023313', NULL, 'Ubiquitin-conjugating enzyme, active site', 'UBQ-conjugating_AS', 0, NULL),
(20563, NULL, 'IPR022152', NULL, 'Protein of unknown function DUF3682', 'DUF3682', 4, NULL),
(20564, NULL, 'IPR024300', NULL, 'SipL, SPOCS domain', 'SipL_SPOCS_dom', 3, NULL),
(20565, NULL, 'IPR020916', NULL, 'Protein-glutamine gamma-glutamyltransferase, bacteria', 'Gln_gamma-glutamylTfrase_bac', 4, NULL),
(20566, NULL, 'IPR020898', NULL, 'Synapsin, ATP-binding domain', 'Synapsin_ATP-bd_dom', 3, NULL),
(20567, NULL, 'IPR017943', NULL, 'Bactericidal permeability-increasing protein, alpha/beta domain superfamily', 'Bactericidal_perm-incr_a/b_dom', 5, NULL),
(20568, NULL, 'IPR022156', NULL, 'Uncharacterised protein YfbK, N-terminal', 'Uncharacterised_YfbK_N', 3, NULL),
(20569, NULL, 'IPR024830', NULL, 'Glucocorticoid modulatory element-binding protein 1/2', 'GMEB1/2', 4, NULL),
(20570, NULL, 'IPR019626', NULL, 'Stress-induced protein, KGG, repeat', 'Stress-induced_KGG_rpt', 7, NULL),
(20571, NULL, 'IPR023588', NULL, 'Transcription regulator HTH, PurR', 'Tscrpt_reg_HTH_PurR', 4, NULL),
(20572, NULL, 'IPR022089', NULL, 'Tryptophan/threonine-rich plasmodium antigen, C-terminal', 'Plasmodium-antigen_C', 3, NULL),
(20573, NULL, 'IPR034134', NULL, 'DAZ-associated protein 1, RNA recognition motif 1', 'DAZAP1_RRM1', 3, NULL),
(20574, NULL, 'IPR020897', NULL, 'Synapsin, pre-ATP-grasp domain', 'Synapsin_pre-ATP-grasp_dom', 3, NULL),
(20575, NULL, 'IPR023346', NULL, 'Lysozyme-like domain superfamily', 'Lysozyme-like_dom_sf', 5, NULL),
(20576, NULL, 'IPR024217', NULL, 'Protein of unknown function DUF3813', 'DUF3813', 4, NULL),
(20577, NULL, 'IPR019757', NULL, 'Peptidase S26A, signal peptidase I, lysine active site', 'Pept_S26A_signal_pept_1_Lys-AS', 0, NULL),
(20578, NULL, 'IPR018866', NULL, 'Zinc-finger domain of monoamine-oxidase A repressor R1', 'Znf-4CXXC_R1', 3, NULL),
(20579, NULL, 'IPR017125', NULL, 'PR-domain zinc finger protein PRDM5-like', 'Znf_PRDM5-like', 4, NULL),
(20580, NULL, 'IPR022108', NULL, 'Protein of unknown function DUF3648', 'DUF3648', 4, NULL),
(20581, NULL, 'IPR020603', NULL, 'MraZ domain', 'MraZ_dom', 3, NULL),
(20582, NULL, 'IPR023105', NULL, 'YkvR-like superfamily', 'YkvR-like_sf', 5, NULL),
(20583, NULL, 'IPR019718', NULL, 'Protein of unknown function DUF2602', 'DUF2602', 4, NULL),
(20584, NULL, 'IPR020917', NULL, 'Primosomal protein 1', 'DnaT', 4, NULL),
(20585, NULL, 'IPR019732', NULL, 'Sigma-S stabilisation anti-adaptor protein', 'SigmaS_Anti-adapt_IraP', 4, NULL),
(20586, NULL, 'IPR022154', NULL, 'Trafficking kinesin-binding protein, C-terminal', 'TRAK1/2_C', 3, NULL),
(20587, NULL, 'IPR017475', NULL, 'Exopolysaccharide biosynthesis polyprenyl glycosylphosphotransferase', 'EPS_sugar_tfrase', 4, NULL),
(20588, NULL, 'IPR020889', NULL, 'LPS-assembly protein LptD', 'LipoPS_assembly_LptD', 4, NULL),
(20589, NULL, 'IPR017146', NULL, 'Type 2 lantibiotic biosynthesis protein LanM', 'Lanti_2_LanM', 4, NULL),
(20590, NULL, 'IPR018857', NULL, 'TORC1 complex, subunit TCO89', 'TORC1_cplx_su_TCO89', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(20591, NULL, 'IPR019717', NULL, 'Dextransucrase DSRB', 'Dextransucrase_DSRB', 4, NULL),
(20592, NULL, 'IPR017491', NULL, 'Photosystem I protein PsaC', 'PSI_PsaC', 4, NULL),
(20593, NULL, 'IPR017144', NULL, 'Xaa-Arg dipeptidase', 'Xaa-Arg_dipeptidase', 4, NULL),
(20594, NULL, 'IPR018903', NULL, 'Proline-rich protein 23', 'PRR23', 4, NULL),
(20595, NULL, 'IPR023347', NULL, 'Lysozyme domain superfamily', 'Lysozyme_dom_sf', 5, NULL),
(20596, NULL, 'IPR020459', NULL, 'AMP-binding', 'AMP-binding', 3, NULL),
(20597, NULL, 'IPR020863', NULL, 'Membrane attack complex component/perforin domain, conserved site', 'MACPF_CS', 2, NULL),
(20598, NULL, 'IPR018887', NULL, 'Myeloid-derived growth factor', 'MYDGF', 4, NULL),
(20599, NULL, 'IPR019664', NULL, 'Uncharacterised protein family Ycf51', 'Uncharacterised_Ycf51', 4, NULL),
(20600, NULL, 'IPR022161', NULL, 'DNA helicase IV, N-terminal domain', 'Helicase_IV_N', 3, NULL),
(20601, NULL, 'IPR017126', NULL, 'PR-domain zinc finger protein PRDM12', 'Znf_PRDM12', 4, NULL),
(20602, NULL, 'IPR035989', NULL, 'DBP-like superfamily', 'DBP_sf', 5, NULL),
(20603, NULL, 'IPR020777', NULL, 'Growth factor receptor NTRK', 'NTRK', 4, NULL),
(20604, NULL, 'IPR020454', NULL, 'Diacylglycerol/phorbol-ester binding', 'DAG/PE-bd', 3, NULL),
(20605, NULL, 'IPR020588', NULL, 'DNA recombination and repair protein RecA-like, ATP-binding domain', 'RecA_ATP-bd', 3, NULL),
(20606, NULL, 'IPR017129', NULL, 'Bifunctional hydroxyisourate hydrolase/2-oxo-4-hydroxy-4-carboxy-5-ureidoimidazoline decarboxylase', 'HIU_hydrol/OHCU_decarb', 4, NULL),
(20607, NULL, 'IPR017462', NULL, 'Sulphur relay, TusC/DsrF', 'Sulphur_relay_TusC/DsrF', 4, NULL),
(20608, NULL, 'IPR019637', NULL, 'Protein of unknown function DUF2501', 'DUF2501', 4, NULL),
(20609, NULL, 'IPR020852', NULL, 'Ribonucleotide reductase, class Ib, NrdI, bacterial', 'RNR_Ib_NrdI_bac', 4, NULL),
(20610, NULL, 'IPR019634', NULL, 'Uncharacterised protein family Ycf49', 'Uncharacterised_Ycf49', 4, NULL),
(20611, NULL, 'IPR022153', NULL, 'Protein of unknown function DUF3683', 'DUF3683', 4, NULL),
(20612, NULL, 'IPR022057', NULL, 'Chitin synthase export chaperone', 'Chs7', 4, NULL),
(20613, NULL, 'IPR018410', NULL, 'Na+/H+ exchanger, isoforms 3/5', 'Na/H_exchanger_3/5', 4, NULL),
(20614, NULL, 'IPR018882', NULL, 'Calmodulin-binding domain C0, NMDA receptor, NR1 subunit', 'CaM-bd_C0_NMDA_rcpt_NR1', 3, NULL),
(20615, NULL, 'IPR020591', NULL, 'Chromosomal replication control, initiator DnaA-like', 'Chromosome_initiator_DnaA-like', 4, NULL),
(20616, NULL, 'IPR022088', NULL, 'Intraflagellar transport complex B protein 46', 'Intraflagellar_transp_cmplxB', 4, NULL),
(20617, NULL, 'IPR022101', NULL, 'GB virus C, polyprotein N-terminal', 'GB_virus-C_polyprotein_N', 3, NULL),
(20618, NULL, 'IPR024216', NULL, 'Protein of unknown function DUF3851', 'DUF3851', 4, NULL),
(20619, NULL, 'IPR020587', NULL, 'DNA recombination and repair protein RecA, monomer-monomer interface', 'RecA_monomer-monomer_interface', 3, NULL),
(20620, NULL, 'IPR022148', NULL, 'CopG antitoxin', 'CopG_antitoxin', 4, NULL),
(20621, NULL, 'IPR017470', NULL, 'Transcription regulator EpsA', 'Tscrpt_reg_EpsA', 4, NULL),
(20622, NULL, 'IPR018880', NULL, 'Bacteriophage P4, Ash protein', 'Phage_P4_Ash', 4, NULL),
(20623, NULL, 'IPR034179', NULL, 'Long-chain specific acyl-CoA dehydrogenase', 'LCAD', 4, NULL),
(20624, NULL, 'IPR022084', NULL, 'Transcription factor Elf, N-terminal', 'TF_Elf_N', 3, NULL),
(20625, NULL, 'IPR022142', NULL, 'Protein of unknown function DUF3673', 'DUF3673', 4, NULL),
(20626, NULL, 'IPR020382', NULL, 'Androgenic gland hormone', 'AGH', 4, NULL),
(20627, NULL, 'IPR022160', NULL, 'Spiroplasma phage 1-C74, Orf1', 'Phage_1-C74_Orf1', 4, NULL),
(20628, NULL, 'IPR018897', NULL, 'Plasmid conjugative transfer protein PilI', 'Plasmid_conjug_transfer_PilI', 4, NULL),
(20629, NULL, 'IPR022067', NULL, 'Homeobox protein Hox1A3 N-terminal', 'HoxA13_N', 3, NULL),
(20630, NULL, 'IPR017941', NULL, 'Rieske [2Fe-2S] iron-sulphur domain', 'Rieske_2Fe-2S', 3, NULL),
(20631, NULL, 'IPR022165', NULL, 'Polo kinase kinase', 'PKK', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(20632, NULL, 'IPR022073', NULL, 'Putative outer membrane core complex of type IVb secretion', 'T4BSS_DotH_IcmK', 4, NULL),
(20633, NULL, 'IPR019728', NULL, 'Protein of unknown function DUF2605', 'DUF2605', 4, NULL),
(20634, NULL, 'IPR017148', NULL, 'Vacuolar protein sorting-associated protein 13, fungi', 'VPS13_fungi', 4, NULL),
(20635, NULL, 'IPR022126', NULL, 'S-locus, receptor kinase', 'S-locus_recpt_kinase', 3, NULL),
(20636, NULL, 'IPR020433', NULL, 'Venom nerve growth factor', 'Venom_nerve_growth_factor', 4, NULL),
(20637, NULL, 'IPR018093', NULL, 'BCCT transporter, conserved site', 'BCCT_CS', 2, NULL),
(20638, NULL, 'IPR020859', NULL, 'Roc domain', 'ROC_dom', 3, NULL),
(20639, NULL, 'IPR018081', NULL, 'Anaphylatoxin, complement system', 'Anaphylatoxin_comp_syst', 5, NULL),
(20640, NULL, 'IPR019623', NULL, 'Protein Rot1', 'Rot1', 4, NULL),
(20641, NULL, 'IPR020290', NULL, 'Gene product 88', 'Gp88', 4, NULL),
(20642, NULL, 'IPR024218', NULL, 'Protein of unknown function DUF3867', 'DUF3867', 4, NULL),
(20643, NULL, 'IPR034263', NULL, 'Ephrin type-A receptor 2, ligand binding domain', 'EphA2_rcpt_lig-bd', 3, NULL),
(20644, NULL, 'IPR019624', NULL, 'Herpesvirus UL40', 'Herpes_UL40', 4, NULL),
(20645, NULL, 'IPR020994', NULL, 'Uncharacterised protein family, calcium binding protein, CcbP', 'Uncharacterised_Ca-bd_CcbP', 4, NULL),
(20646, NULL, 'IPR018868', NULL, 'Bcl2-associated agonist of cell death', 'BAD', 4, NULL),
(20647, NULL, 'IPR022115', NULL, 'Protein of unknown function DUF3654', 'DUF3654', 4, NULL),
(20648, NULL, 'IPR020602', NULL, 'GTP cyclohydrolase I domain', 'GTP_CycHdrlase_I_dom', 3, NULL),
(20649, NULL, 'IPR019714', NULL, '2-haloacid dehalogenase, DehI', '2-haloacid_dehalogenase_DehI', 4, NULL),
(20650, NULL, 'IPR022125', NULL, 'U3 small nucleolar RNA-associated protein 10, N-terminal', 'U3snoRNP10_N', 3, NULL),
(20651, NULL, 'IPR034504', NULL, 'RALYL, RNA recognition motif', 'RALYL_RRM', 3, NULL),
(20652, NULL, 'IPR018906', NULL, 'DNA integrity scanning, DisA, linker region', 'DNA_integrity_scan_DisA_link', 3, NULL),
(20653, NULL, 'IPR017497', NULL, 'Putative magnesium chelatase accessory protein', 'Mg-chelatase_BchO', 4, NULL),
(20654, NULL, 'IPR018907', NULL, 'Spindle body associated protein, C-terminal domain', 'Spindle_body_associated_C_dom', 3, NULL),
(20655, NULL, 'IPR020846', NULL, 'Major facilitator superfamily domain', 'MFS_dom', 3, NULL),
(20656, NULL, 'IPR020823', NULL, 'Cell division protein FtsA', 'Cell_div_FtsA', 4, NULL),
(20657, NULL, 'IPR024791', NULL, 'Cytochrome c oxidase subunit III', 'Cyt_c/ubiquinol_Oxase_su3', 4, NULL),
(20658, NULL, 'IPR022102', NULL, 'Holliday junction regulator protein family C-terminal', 'HJURP_C', 3, NULL),
(20659, NULL, 'IPR022078', NULL, 'CD99 antigen-like protein 2', 'CD99L2', 4, NULL),
(20660, NULL, 'IPR019762', NULL, 'Dynamin, GTPase region, conserved site', 'Dynamin_GTPase_CS', 2, NULL),
(20661, NULL, 'IPR018892', NULL, 'Retro-transposon transporting motif', 'Retro-transposon_transp_CS', 2, NULL),
(20662, NULL, 'IPR020719', NULL, 'RNA 3''-terminal phosphate cyclase-like, conserved site', 'RNA3''_term_phos_cycl-like_CS', 2, NULL),
(20663, NULL, 'IPR018889', NULL, 'Arpin', 'Arpin', 4, NULL),
(20664, NULL, 'IPR020886', NULL, 'Putative HTH-type transcriptional regulator, archaea', 'Arc_TR_HTH', 4, NULL),
(20665, NULL, 'IPR022381', NULL, 'Uncharacterised protein family MG067', 'Uncharacterised_MG067', 4, NULL),
(20666, NULL, 'IPR023108', NULL, 'Domain of unknown function, DUF3216', 'DUF3216', 3, NULL),
(20667, NULL, 'IPR019630', NULL, 'Protein of unknown function DUF2496, YbaM-related', 'DUF2496_YbaM-rel', 4, NULL),
(20668, NULL, 'IPR020584', NULL, 'DNA recombination/repair protein RecA, conserved site', 'DNA_recomb/repair_RecA_CS', 2, NULL),
(20669, NULL, 'IPR022087', NULL, 'Protein DA1-like domain', 'DA1-like_dom', 3, NULL),
(20670, NULL, 'IPR022070', NULL, 'Cytoplasmic activation/proliferation-associated protein-1 C term', 'Caprin-1_C', 3, NULL),
(20671, NULL, 'IPR019629', NULL, 'Uncharacterised protein family HI1736/YgjV', 'Uncharacterised_HI1736/YgjV', 4, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(20672, NULL, 'IPR020869', NULL, 'Exosome complex component Rrp42, archaea', 'Rrp42_archaea', 4, NULL),
(20673, NULL, 'IPR020775', NULL, 'Tyrosine-protein kinase, non-receptor Jak3', 'Tyr_kinase_non-rcpt_Jak3', 4, NULL),
(20674, NULL, 'IPR022138', NULL, 'Helicase SWF/SNF-related', 'Helicase_SWF/SNF-rel', 4, NULL),
(20675, NULL, 'IPR019635', NULL, 'Protein of unknown function DUF2500', 'DUF2500', 4, NULL),
(20676, NULL, 'IPR023349', NULL, 'Ammonia monooxygenase/particulate methane monooxygenase, subunit C domain superfamily', 'NH3_CH4_mOase_C_sf', 5, NULL),
(20677, NULL, 'IPR024215', NULL, 'Protein of unknown function DUF3847', 'DUF3847', 4, NULL),
(20678, NULL, 'IPR022092', NULL, 'TATA element modulatory factor 1 DNA binding', 'TMF_DNA-bd', 4, NULL),
(20679, NULL, 'IPR024831', NULL, 'Uroplakin-3', 'Uroplakin-3', 4, NULL),
(20680, NULL, 'IPR022079', NULL, 'Protein of unknown function DUF3629', 'DUF3629', 4, NULL),
(20681, NULL, 'IPR018874', NULL, 'Bacteriophage Mx8, p63, C-terminal', 'Phage_Mx8_p63_C', 3, NULL),
(20682, NULL, 'IPR024205', NULL, 'Mst1 SARAH domain', 'Mst1_SARAH_domain', 3, NULL),
(20683, NULL, 'IPR018886', NULL, 'Uncharacterised domain UPF0547', 'UPF0547', 3, NULL),
(20684, NULL, 'IPR020861', NULL, 'Triosephosphate isomerase, active site', 'Triosephosphate_isomerase_AS', 0, NULL),
(20685, NULL, 'IPR022064', NULL, 'Protein of unknown function DUF3619', 'DUF3619', 4, NULL),
(20686, NULL, 'IPR018872', NULL, 'Zn-cluster domain', 'Zn-cluster-dom', 3, NULL),
(20687, NULL, 'IPR022107', NULL, 'DNA polymerase III, subunit gamma/ tau, C-terminal', 'DNA_pol_III_gamma/tau_C', 3, NULL),
(20688, NULL, 'IPR020594', NULL, 'Ribosomal protein L9, bacteria/chloroplast', 'Ribosomal_L9_bac/chp', 4, NULL),
(20689, NULL, 'IPR017486', NULL, 'Photosystem II CP47 reaction centre protein', 'PSII_PsbB', 4, NULL),
(20690, NULL, 'IPR020796', NULL, 'Origin recognition complex, subunit 5', 'ORC5', 4, NULL),
(20691, NULL, 'IPR019705', NULL, 'Protein of unknown function DUF2594', 'DUF2594', 4, NULL),
(20692, NULL, 'IPR024219', NULL, 'Protein of unknown function DUF3809', 'DUF3809', 4, NULL),
(20693, NULL, 'IPR022118', NULL, 'Peptidase C70, AvrRpt2', 'Peptidase_C70_AvrRpt2', 4, NULL),
(20694, NULL, 'IPR018865', NULL, 'Serine-threonine protein kinase 19', 'Ser/Thr_kinase_19', 4, NULL),
(20695, NULL, 'IPR017128', NULL, 'Catechol O-methyltransferase, eukaryotic', 'Catechol_O-MeTrfase_euk', 4, NULL),
(20696, NULL, 'IPR022127', NULL, 'Store-operated calcium entry regulator STIMATE/YPL162C', 'STIMATE/YPL162C', 4, NULL),
(20697, NULL, 'IPR019724', NULL, 'Uncharacterised protein family UPF0763', 'UPF0763', 4, NULL),
(20698, NULL, 'IPR019638', NULL, 'Protein of unknown function DUF2502', 'DUF2502', 4, NULL),
(20699, NULL, 'IPR020838', NULL, 'DBINO domain', 'DBINO', 3, NULL),
(20700, NULL, 'IPR020599', NULL, 'Translation elongation factor P/YeiP', 'Transl_elong_fac_P/YeiP', 4, NULL),
(20701, NULL, 'IPR018403', NULL, 'Silicon transporter, Cylindrotheca fusiformis', 'Silicon_transpt_CYLFU', 4, NULL),
(20702, NULL, 'IPR020885', NULL, 'Uncharacterised protein family UPF0367', 'UPF0367', 4, NULL),
(20703, NULL, 'IPR020298', NULL, 'Kil protein, bacteriophage P22-type', 'Kil_phage_P22-type', 4, NULL),
(20704, NULL, 'IPR022103', NULL, 'Baculoviral IAP repeat-containing protein 6', 'BIRC6', 4, NULL),
(20705, NULL, 'IPR022163', NULL, 'GTP cyclohydrolase N-terminal', 'GTP_CH_N', 3, NULL),
(20706, NULL, 'IPR017140', NULL, 'ThermoDBP-related, archaea', 'ThermoDBP-RPs_arc', 4, NULL),
(20707, NULL, 'IPR020779', NULL, 'dNTP triphosphohydrolase, type 1', 'dNTPase_1', 4, NULL),
(20708, NULL, 'IPR020684', NULL, 'Rho-associated protein kinase 1/2', 'ROCK1/ROCK2', 4, NULL),
(20709, NULL, 'IPR022137', NULL, 'Zinc finger protein, DUF3669 domain', 'Znf_prot_DUF3669', 3, NULL),
(20710, NULL, 'IPR019667', NULL, 'Uncharacterised protein family YbaK', 'Uncharacterised_YbaK', 4, NULL),
(20711, NULL, 'IPR019729', NULL, 'Gloverin-like protein', 'Gloverin-like_protein', 4, NULL),
(20712, NULL, 'IPR017134', NULL, 'Ubiquitin-protein ligase E3A', 'UBE3A', 4, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(20713, NULL, 'IPR017150', NULL, 'Peptidase M20, glutamate carboxypeptidase', 'Pept_M20_glutamate_carboxypep', 4, NULL),
(20714, NULL, 'IPR020864', NULL, 'Membrane attack complex component/perforin (MACPF) domain', 'MACPF', 3, NULL),
(20715, NULL, 'IPR019715', NULL, 'Haemolysin XhlA', 'Haemolysin_XhlA', 4, NULL),
(20716, NULL, 'IPR017465', NULL, 'Exopolysaccharide biosynthesis operon, EpsL, proteobacteria', 'EpsL_proteobac', 4, NULL),
(20717, NULL, 'IPR017142', NULL, 'Nitric oxide synthase, oxygenase subunit', 'Nitric_oxide_synthase_Oase-su', 4, NULL),
(20718, NULL, 'IPR034710', NULL, 'Ribulose-5-phosphate reductase', 'TarJ', 4, NULL),
(20719, NULL, 'IPR020451', NULL, 'Interleukin-15, avian', 'IL-15_avian', 4, NULL),
(20720, NULL, 'IPR022130', NULL, 'Paired-box protein 2 C-terminal', 'Pax2_C', 3, NULL),
(20721, NULL, 'IPR019654', NULL, 'NAD(P)H-quinone oxidoreductase subunit L', 'NADH-quinone_OxRdatse_su_L', 4, NULL),
(20722, NULL, 'IPR019731', NULL, 'Protein of unknown function DUF2607', 'DUF2607', 4, NULL),
(20723, NULL, 'IPR019658', NULL, 'Protein of unknown function DUF2515', 'DUF2515', 4, NULL),
(20724, NULL, 'IPR020449', NULL, 'Transcription regulator HTH, AraC- type', 'Tscrpt_reg_HTH_AraC-type', 4, NULL),
(20725, NULL, 'IPR018878', NULL, 'ORF6C domain', 'ORF6C_dom', 3, NULL),
(20726, NULL, 'IPR018902', NULL, 'Uncharacterised protein FAM166/UPF0605', 'FAM166/UPF0605', 4, NULL),
(20727, NULL, 'IPR022132', NULL, 'Homeobox protein', 'Abdominal-A', 4, NULL),
(20728, NULL, 'IPR022082', NULL, 'Noelin domain', 'Noelin_dom', 3, NULL),
(20729, NULL, 'IPR017496', NULL, 'Photosynthetic complex assembly protein 2, putative', 'Photo_alph_chp2', 4, NULL),
(20730, NULL, 'IPR017127', NULL, 'Ribosomal protein L3-specific, glutamine-N5-methyltransferase', 'Ribosome_L3_Gln-N5_MeTrfase', 4, NULL),
(20731, NULL, 'IPR017147', NULL, 'Tricalbin', 'Tricalbin', 4, NULL),
(20732, NULL, 'IPR022104', NULL, 'Domain of unknown function DUF3644', 'DUF3644', 3, NULL),
(20733, NULL, 'IPR019763', NULL, 'Dynein light chain, type 1/2, conserved site', 'Dynein_light_1/2_CS', 2, NULL),
(20734, NULL, 'IPR019765', NULL, 'Ephrin, conserved site', 'Ephrin_CS', 2, NULL),
(20735, NULL, 'IPR022157', NULL, 'Dynein associated protein', 'Dynactin', 3, NULL),
(20736, NULL, 'IPR017464', NULL, 'Sugar transferase, PEP-CTERM system associated', 'Sugar_tfrase_EpsB_2', 4, NULL),
(20737, NULL, 'IPR019645', NULL, 'Uncharacterised protein family Ycf15', 'Uncharacterised_Ycf15', 4, NULL),
(20738, NULL, 'IPR020598', NULL, 'Ribosomal RNA adenine methylase transferase, N-terminal', 'rRNA_Ade_methylase_Trfase_N', 3, NULL),
(20739, NULL, 'IPR020792', NULL, 'Sulphate adenylyltransferase, prokaryotic-type', 'SO4_adenylyltransferase_pro', 4, NULL),
(20740, NULL, 'IPR019656', NULL, 'Uncharacterised protein family Ycf34', 'Uncharacterised_Ycf34', 4, NULL),
(20741, NULL, 'IPR018898', NULL, 'Plasmid conjugative transfer entry exclusion protein TraS', 'Eex_TraS', 4, NULL),
(20742, NULL, 'IPR017468', NULL, 'Chain length determinant protein EpsF', 'Chain_len_reg_EpsF', 4, NULL),
(20743, NULL, 'IPR018867', NULL, 'Cell division protein borealin', 'Cell_div_borealin', 4, NULL),
(20744, NULL, 'IPR020435', NULL, 'Tumour necrosis factor receptor 5', 'TNFR_5', 4, NULL),
(20745, NULL, 'IPR018894', NULL, 'Protein of unknown function DUF2471', 'DUF2471', 4, NULL),
(20746, NULL, 'IPR022086', NULL, 'Inner membrane complex protein', 'IMCp', 4, NULL),
(20747, NULL, 'IPR022170', NULL, 'E3 Ubiquitin ligase MUL1-like', 'MUL1-like', 3, NULL),
(20748, NULL, 'IPR019760', NULL, 'DNA-directed DNA polymerase, family A, conserved site', 'DNA-dir_DNA_pol_A_CS', 2, NULL),
(20749, NULL, 'IPR019655', NULL, 'Baculovirus occlusion-derived virus envelope, E18', 'Baculo_ODV-E18', 4, NULL),
(20750, NULL, 'IPR018877', NULL, 'Bacteriophage P22, Orf201, C-terminal', 'Phage_P22_Orf201_C', 3, NULL),
(20751, NULL, 'IPR022141', NULL, 'Plasma membrane calcium transporting P-type ATPase, C-terminal', 'ATP_Ca_trans_C', 3, NULL),
(20752, NULL, 'IPR020446', NULL, 'NT-3 growth factor receptor NTRK3', 'NTRK3', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(20753, NULL, 'IPR019627', NULL, 'YspA, cpYpsA-related SLOG family', 'YAcAr', 4, NULL),
(20754, NULL, 'IPR017495', NULL, 'Putative photosynthetic complex assembly protein', 'Photo_alph_chp1', 4, NULL),
(20755, NULL, 'IPR020549', NULL, 'Endoribonuclease YbeY, conserved site', 'YbeY_CS', 2, NULL),
(20756, NULL, 'IPR022162', NULL, 'Short transient receptor potential channel 4-associated protein', 'TRPC4AP', 4, NULL),
(20757, NULL, 'IPR017490', NULL, 'Photosystem II PsbV2, cytochrome', 'PSII_cyt_PsbV2', 4, NULL),
(20758, NULL, 'IPR023581', NULL, 'Platelet-derived growth factor, conserved site', 'PD_growth_factor_CS', 2, NULL),
(20759, NULL, 'IPR023580', NULL, 'RNA polymerase subunit RPB10', 'RNA_pol_su_RPB10', 5, NULL),
(20760, NULL, 'IPR022134', NULL, 'Protein of unknown function DUF3667', 'DUF3667', 4, NULL),
(20761, NULL, 'IPR020545', NULL, 'Aspartate carbamoyltransferase regulatory subunit, N-terminal', 'Asp_carbamoyltransf_reg_N', 3, NULL),
(20762, NULL, 'IPR017477', NULL, 'PEP-CTERM, putative polysaccharide export protein', 'PEP-CTERM_polysacc_export', 4, NULL),
(20763, NULL, 'IPR020887', NULL, 'Uncharacterised protein family UPF0509', 'UPF0509', 4, NULL),
(20764, NULL, 'IPR022151', NULL, 'Sox developmental protein N-terminal', 'Sox_N', 3, NULL),
(20765, NULL, 'IPR022060', NULL, 'Protein of unknown function DUF3616', 'DUF3616', 4, NULL),
(20766, NULL, 'IPR035001', NULL, 'PTBP1, RNA recognition motif 3', 'PTBP1_RRM3', 3, NULL),
(20767, NULL, 'IPR020672', NULL, 'Ribose-5-phosphate isomerase, type A, subgroup', 'Ribose5P_isomerase_typA_subgr', 4, NULL),
(20768, NULL, 'IPR019665', NULL, 'Putative oxidoreductase/dehydrogenase, Rossmann-like domain', 'OxRdtase/DH_put_Rossmann_dom', 3, NULL),
(20769, NULL, 'IPR022135', NULL, 'Distal-less-like homeobox protein, N-terminal domain', 'Distal-less_N', 3, NULL),
(20770, NULL, 'IPR017483', NULL, 'Conserved hypothetical protein CHP03034', 'CHP03034', 4, NULL),
(20771, NULL, 'IPR019730', NULL, 'Protein of unknown function DUF2606', 'DUF2606', 4, NULL),
(20772, NULL, 'IPR034207', NULL, 'RBM45, RNA recognition motif 3', 'RBM45_RRM3', 3, NULL),
(20773, NULL, 'IPR020900', NULL, 'Arginine repressor, DNA-binding domain', 'Arg_repress_DNA-bd', 3, NULL),
(20774, NULL, 'IPR023110', NULL, 'PH1570-like domain', 'PH1570-like_domain', 3, NULL),
(20775, NULL, 'IPR022085', NULL, 'Protein of unknown function DUF3632', 'DUF3632', 4, NULL),
(20776, NULL, 'IPR020590', NULL, 'Guanylate kinase, conserved site', 'Guanylate_kinase_CS', 2, NULL),
(20777, NULL, 'IPR020847', NULL, 'AP endonuclease 1, binding site', 'AP_endonuclease_F1_BS', 1, NULL),
(20778, NULL, 'IPR019716', NULL, 'Ribosomal protein L53, mitochondrial', 'Ribosomal_L53_mit', 4, NULL),
(20779, NULL, 'IPR019761', NULL, 'DNA-directed RNA polymerase M, 15kDa subunit, conserved site', 'DNA-dir_RNA_pol-M_15_CS', 2, NULL),
(20780, NULL, 'IPR020293', NULL, 'Accessory recombination function protein', 'Arf', 4, NULL),
(20781, NULL, 'IPR018860', NULL, 'Anaphase-promoting complex, subunit CDC26', 'APC_suCDC26', 4, NULL),
(20782, NULL, 'IPR020288', NULL, 'Protein of unknown function DUF2634', 'DUF2634', 4, NULL),
(20783, NULL, 'IPR017488', NULL, 'Photosystem II Psb27, cyanobacteria', 'PSII_Psb27_cyano_bac', 4, NULL),
(20784, NULL, 'IPR020883', NULL, 'Type I toxin-antitoxin system, SymE toxin', 'TypeI_TA_SymE', 4, NULL),
(20785, NULL, 'IPR017487', NULL, 'Photosystem II PsbQ, cyanobacteria', 'PSII_PsbQ_cyanobac', 4, NULL),
(20786, NULL, 'IPR035019', NULL, 'Spt6, SH2 domain, N terminus', 'Spt6_SH2_N', 3, NULL),
(20787, NULL, 'IPR022123', NULL, 'Protein of unknown function DUF3658', 'DUF3658', 4, NULL),
(20788, NULL, 'IPR022065', NULL, 'Uncharacterised protein family, TMEM59', 'Uncharacterised_TMEM59', 4, NULL),
(20789, NULL, 'IPR018084', NULL, 'Hok/gef cell toxic protein, conserved site', 'Hok/gef_toxin_CS', 2, NULL),
(20790, NULL, 'IPR017482', NULL, 'Putative phage-type endonuclease', 'Phage_endonuclease_put', 3, NULL),
(20791, NULL, 'IPR024861', NULL, 'Donson', 'Donson', 4, NULL),
(20792, NULL, 'IPR020430', NULL, 'Brain-derived neurotrophic factor', 'Brain-der_neurotrophic_factor', 4, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(20793, NULL, 'IPR020593', NULL, 'Gamma-glutamyl phosphate reductase GPR, conserved site', 'G-glutamylP_reductase_CS', 2, NULL),
(20794, NULL, 'IPR020296', NULL, 'Sporulation protein Cse60', 'Spore_Cse60', 4, NULL),
(20795, NULL, 'IPR017130', NULL, 'Cholesteryl ester transfer', 'Cholesteryl_ester_transfer', 4, NULL),
(20796, NULL, 'IPR018875', NULL, 'Antirepressor protein ant, N-terminal', 'Antirepressor_Ant_N', 3, NULL),
(20797, NULL, 'IPR019657', NULL, 'Late competence development protein ComFB', 'ComFB', 4, NULL),
(20798, NULL, 'IPR019661', NULL, 'Replication regulatory protein RepA2', 'RepA2', 4, NULL),
(20799, NULL, 'IPR017498', NULL, 'Photosystem I PsaO', 'PSI_PsaO', 4, NULL),
(20800, NULL, 'IPR018148', NULL, 'Methylglyoxal synthase, active site', 'Methylglyoxal_synth_AS', 0, NULL),
(20801, NULL, 'IPR020287', NULL, 'Tail sheath protein, C-terminal domain', 'Tail_sheath_C', 3, NULL),
(20802, NULL, 'IPR017478', NULL, 'Polysaccharide export EpsE', 'Polysacc_export_EpsE', 4, NULL),
(20803, NULL, 'IPR022097', NULL, 'Transcription factor SOX', 'SOX_fam', 4, NULL),
(20804, NULL, 'IPR020776', NULL, 'Tyrosine-protein kinase, non-receptor Jak1', 'Tyr_kinase_non-rcpt_Jak1', 4, NULL),
(20805, NULL, 'IPR019748', NULL, 'FERM central domain', 'FERM_central', 3, NULL),
(20806, NULL, 'IPR017133', NULL, 'L-tyrosine isonitrile synthase', 'PvcA', 4, NULL),
(20807, NULL, 'IPR022113', NULL, 'Transmembrane protein 131-like,  N-terminal', 'TMEM131-like_N', 3, NULL),
(20808, NULL, 'IPR017132', NULL, 'Sm-like protein Lsm7', 'Lsm7', 4, NULL),
(20809, NULL, 'IPR024222', NULL, 'CST complex subunit Ten1, fungal', 'Ten1_fungal', 4, NULL),
(20810, NULL, 'IPR019708', NULL, 'Bacteriophage HP1, Orf24', 'Phage_HP1_Orf24', 4, NULL),
(20811, NULL, 'IPR020537', NULL, 'ATP synthase, F0 complex, subunit C, DCCD-binding site', 'ATP_synth_F0_csu_DDCD_BS', 1, NULL),
(20812, NULL, 'IPR019647', NULL, 'PhoP regulatory network protein YrbL', 'PhoP_reg_network_YrbL', 4, NULL),
(20813, NULL, 'IPR019652', NULL, 'Protein of unknown function DUF2509', 'DUF2509', 4, NULL),
(20814, NULL, 'IPR018888', NULL, 'Uncharacterised protein family UPF0561', 'UPF0561', 4, NULL),
(20815, NULL, 'IPR018909', NULL, 'Endo-1,3(4)-beta-glucanase 1, carbohydrate binding', 'Eng1_septum', 3, NULL),
(20816, NULL, 'IPR018095', NULL, 'Thymidylate kinase, conserved site', 'Thymidylate_kin_CS', 2, NULL),
(20817, NULL, 'IPR022074', NULL, 'Protein of unknown function DUF3626', 'DUF3626', 4, NULL),
(20818, NULL, 'IPR022091', NULL, 'TATA element modulatory factor 1, TATA binding', 'TMF_TATA-bd', 3, NULL),
(20819, NULL, 'IPR018402', NULL, 'Malonate/sodium symporter MadM subunit, N-terminal', 'Mal/Na_symporter_MadM_N', 3, NULL),
(20820, NULL, 'IPR024302', NULL, 'SusD-like', 'SusD-like', 4, NULL),
(20821, NULL, 'IPR035899', NULL, 'Dbl homology (DH) domain superfamily', 'DBL_dom_sf', 5, NULL),
(20822, NULL, 'IPR020438', NULL, 'Interleukin-11', 'IL-11', 4, NULL),
(20823, NULL, 'IPR022096', NULL, 'SBF1/SBF2 domain', 'SBF1/SBF2', 3, NULL),
(20824, NULL, 'IPR022059', NULL, 'Protein of unknown function DUF3615', 'DUF3615', 4, NULL),
(20825, NULL, 'IPR024769', NULL, 'TcdA/TcdB toxin, pore forming domain', 'TcdA/TcdB_pore_forming', 3, NULL),
(20826, NULL, 'IPR018901', NULL, 'Spore coat protein CotE', 'Spore_coat_CotE', 4, NULL),
(20827, NULL, 'IPR018899', NULL, 'Conjugative transposon, TraO', 'Conjug_transposon_Tra0', 4, NULL),
(20828, NULL, 'IPR018884', NULL, 'Glutamate [NMDA] receptor, epsilon subunit, C-terminal', 'NMDAR2_C', 3, NULL),
(20829, NULL, 'IPR035000', NULL, 'PTBP1,  RNA recognition motif 1', 'PTBP1_RRM1', 3, NULL),
(20830, NULL, 'IPR019644', NULL, 'Protein of unknown function DUF2508', 'DUF2508', 4, NULL),
(20831, NULL, 'IPR022147', NULL, 'Glutamine synthetase type III N-terminal', 'GSIII_N', 3, NULL),
(20832, NULL, 'IPR020335', NULL, 'Probable scaffold protein Gp13, bacteriophage T7', 'Phage_T7_Gp13', 4, NULL),
(20833, NULL, 'IPR019726', NULL, 'Protein of unknown function DUF2604', 'DUF2604', 4, NULL),
(20834, NULL, 'IPR018859', NULL, 'BAR domain-containing family', 'BAR_dom-cont', 4, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(20835, NULL, 'IPR020295', NULL, 'Protein of unknown function DUF2737', 'DUF2737', 4, NULL),
(20836, NULL, 'IPR020440', NULL, 'Interleukin-17, chordata', 'IL-17_chr', 4, NULL),
(20837, NULL, 'IPR020999', NULL, 'Chitin synthesis regulation, Congo red resistance, RCR protein', 'Chitin_synth_reg_RCR', 4, NULL),
(20838, NULL, 'IPR019713', NULL, 'Inner membrane protein YlaC', 'Memb_YlaC', 4, NULL),
(20839, NULL, 'IPR035022', NULL, 'PI3K p85 subunit, N-terminal SH2 domain', 'PI3kinase_P85_nSH2', 3, NULL),
(20840, NULL, 'IPR019703', NULL, 'Inner membrane protein YbjO, dehydrogenase-like', 'YbjO_DH-like', 4, NULL),
(20841, NULL, 'IPR020452', NULL, 'Subtilin biosynthesis protein SpaC', 'Subtilin_biosynthesis_SpaC', 4, NULL),
(20842, NULL, 'IPR020837', NULL, 'Fibrinogen, conserved site', 'Fibrinogen_CS', 2, NULL),
(20843, NULL, 'IPR017930', NULL, 'Myb domain', 'Myb_dom', 3, NULL),
(20844, NULL, 'IPR020860', NULL, 'MIRO domain', 'MIRO_dom', 3, NULL),
(20845, NULL, 'IPR022133', NULL, 'Ribose-5-phosphate isomerase, C-terminal', 'Ribose_5_isomerase_C', 3, NULL),
(20846, NULL, 'IPR017149', NULL, 'Glutathione degradosome, Dug2', 'GSH_degradosome_Dug2', 4, NULL),
(20847, NULL, 'IPR018881', NULL, 'Mitochondrial protein C2orf69', 'C2orf69_mit', 4, NULL),
(20848, NULL, 'IPR022158', NULL, 'Inositol phosphatase', 'Inositol_phosphatase', 3, NULL),
(20849, NULL, 'IPR017131', NULL, 'Small ribonucleoprotein associated, SmB/SmN', 'snRNP-assoc_SmB/SmN', 4, NULL),
(20850, NULL, 'IPR020600', NULL, 'Inosine monophosphate cyclohydrolase-like', 'IMP_cyclohydrolase-like', 3, NULL),
(20851, NULL, 'IPR019650', NULL, 'Protein of unknown function DUF2513', 'DUF2513', 4, NULL),
(20852, NULL, 'IPR017466', NULL, 'ATPase, secretion system, PEP-CTERM, predicted', 'ATPase_secr-sys_PEP-CTERM_pred', 4, NULL),
(20853, NULL, 'IPR022098', NULL, 'Protein of unknown function DUF3637', 'DUF3637', 4, NULL),
(20854, NULL, 'IPR019649', NULL, 'Protein of unknown function DUF2512', 'DUF2512', 4, NULL),
(20855, NULL, 'IPR017494', NULL, 'Photosystem I reaction center subunit V', 'PSI_PsaG', 4, NULL),
(20856, NULL, 'IPR022140', NULL, 'Kinesin-like KIF1-type', 'Kinesin-like_KIF1-typ', 3, NULL),
(20857, NULL, 'IPR018864', NULL, 'Nucleoporin Nup188, N-terminal', 'Nucleoporin_Nup188_N', 3, NULL),
(20858, NULL, 'IPR019651', NULL, 'Glutamate dehydrogenase, NAD-specific', 'Glutamate_DH_NAD-spec', 4, NULL),
(20859, NULL, 'IPR034479', NULL, 'Alternative heme biosynthesis C (AhbC-like)', 'AhbC-like', 4, NULL),
(20860, NULL, 'IPR022119', NULL, 'Peptidase C71, pseudomurein endo-isopeptidase Pei', 'Peptidase_C71', 4, NULL),
(20861, NULL, 'IPR023107', NULL, 'Atu2299-like domain superfamily', 'Atu2299-like_dom_sf', 5, NULL),
(20862, NULL, 'IPR022080', NULL, 'Protein of unknown function DUF3630', 'DUF3630', 4, NULL),
(20863, NULL, 'IPR019707', NULL, 'Winged helix-turn-helix domain (DUF2582)', 'DUF2582', 4, NULL),
(20864, NULL, 'IPR035023', NULL, 'PLC-gamma, C-terminal SH2 domain', 'PLC-gamma_C-SH2', 3, NULL),
(20865, NULL, 'IPR035002', NULL, 'PTBP2, RNA recognition motif 1', 'PTBP2_RRM1', 3, NULL),
(20866, NULL, 'IPR020285', NULL, 'Superinfection exclusion gene product 17', 'Gp17', 4, NULL),
(20867, NULL, 'IPR035102', NULL, 'Phosphomevalonate kinase', 'Phosphomevalonate_kinase', 4, NULL),
(20868, NULL, 'IPR022083', NULL, 'KIF-1 binding protein', 'KBP', 4, NULL),
(20869, NULL, 'IPR022110', NULL, 'CASC1, C-terminal', 'CASC1_C', 3, NULL),
(20870, NULL, 'IPR018883', NULL, 'Delta carbonic anhydrase', 'Delta_CA', 4, NULL),
(20871, NULL, 'IPR019747', NULL, 'FERM conserved site', 'FERM_CS', 2, NULL),
(20872, NULL, 'IPR020542', NULL, 'Aspartate carbamoyltransferase regulatory subunit, C-terminal', 'Asp_carbamoyltrfase_reg_C', 3, NULL),
(20873, NULL, 'IPR017479', NULL, 'Tyrosine-protein kinase, chain length determinant protein EpsG', 'Tyr_kinase_chain_length_EpsG', 4, NULL),
(20874, NULL, 'IPR019663', NULL, 'Uncharacterised protein YbfA', 'YbfA', 4, NULL),
(20875, NULL, 'IPR035018', NULL, 'Spt6, SH2 domain, C terminus', 'Spt6_SH2_C', 3, NULL),
(20876, NULL, 'IPR022075', NULL, 'Symplekin  C-terminal', 'Symplekin_C', 3, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(20877, NULL, 'IPR034206', NULL, 'RBM45, RNA recognition motif 2', 'RBM45_RRM2', 3, NULL),
(20878, NULL, 'IPR022114', NULL, 'Doublesex- and mab-3-related transcription factor  1-like', 'DMRT1-like', 4, NULL),
(20879, NULL, 'IPR022139', NULL, 'Protein of unknown function DUF3671', 'DUF3671', 4, NULL),
(20880, NULL, 'IPR022146', NULL, 'Protein of unknown function DUF3678', 'DUF3678', 4, NULL),
(20881, NULL, 'IPR022063', NULL, 'Complementary sex determination, N-terminal', 'Sex_determin_N', 3, NULL),
(20882, NULL, 'IPR019622', NULL, 'Rrn9 domain', 'Rrn9_dom', 3, NULL),
(20883, NULL, 'IPR022093', NULL, 'Rad26-like, helical repeats', 'Rad26-like_helical', 3, NULL),
(20884, NULL, 'IPR022150', NULL, 'AKNA domain', 'AKNA_dom', 3, NULL),
(20885, NULL, 'IPR017500', NULL, 'Phage infection protein, YhgE, N-terminal', 'Phage_infect_YhgE_N', 3, NULL),
(20886, NULL, 'IPR022145', NULL, 'Domain of unknown function DUF3677', 'DUF3677', 3, NULL),
(20887, NULL, 'IPR019632', NULL, 'Protein of unknown function DUF2497', 'DUF2497', 4, NULL),
(20888, NULL, 'IPR019704', NULL, 'Flagellar assembly regulator FliX, class II', 'Flagellar_assmbl_FliX_class2', 4, NULL),
(20889, NULL, 'IPR020467', NULL, 'Potassium channel, voltage dependent, Kv1.4', 'K_chnl_volt-dep_Kv1.4', 4, NULL),
(20890, NULL, 'IPR022122', NULL, 'Protein FAM135', 'DUF3657', 4, NULL),
(20891, NULL, 'IPR020683', NULL, 'Domain of unknown function DUF3447', 'DUF3447', 3, NULL),
(20892, NULL, 'IPR019764', NULL, 'Endothelin-like toxin, conserved site', 'Endothelin_toxin_CS', 2, NULL),
(20893, NULL, 'IPR034208', NULL, 'RBM45, RNA recognition motif 4', 'RBM45_RRM4', 3, NULL),
(20894, NULL, 'IPR017137', NULL, 'Arginine-tRNA-protein transferase 1, eukaryotic', 'Arg-tRNA-P_Trfase_1_euk', 4, NULL),
(20895, NULL, 'IPR022061', NULL, 'Protein of unknown function DUF3617', 'DUF3617', 4, NULL),
(20896, NULL, 'IPR019769', NULL, 'Translation elongation factor, IF5A, hypusine site', 'Trans_elong_IF5A_hypusine_site', 6, NULL),
(20897, NULL, 'IPR017484', NULL, 'Kynurenine formamidase, bacteria', 'Kynurenine_formamidase_bac', 4, NULL),
(20898, NULL, 'IPR022121', NULL, 'Peptidase M73, camelysin', 'Peptidase_M73_camelysin', 4, NULL),
(20899, NULL, 'IPR024301', NULL, 'Putative amidase domain', 'Amidase_6', 3, NULL),
(20900, NULL, 'IPR020399', NULL, 'T-cell receptor-associated transmembrane adapter 1', 'T-cell_rcpt-assoc_TM_adapter-1', 4, NULL),
(20901, NULL, 'IPR018879', NULL, 'MSV199 domain', 'MSV199_dom', 3, NULL),
(20902, NULL, 'IPR034348', NULL, 'RLI, domain 1', 'RLI_dom_1', 3, NULL),
(20903, NULL, 'IPR019653', NULL, 'T4 endoribonuclease RegB', 'T4_endoribonuclease_RegB', 4, NULL),
(20904, NULL, 'IPR017141', NULL, 'Peptidase M20, carboxypeptidase S', 'Pept_M20_carboxypep', 4, NULL),
(20905, NULL, 'IPR034709', NULL, 'Ribitol-5-phosphate cytidylyltransferase', 'TarI', 4, NULL),
(20906, NULL, 'IPR022076', NULL, 'Limbin', 'Limbin', 4, NULL),
(20907, NULL, 'IPR019710', NULL, 'Protein of unknown function DUF4226', 'DUF4226', 4, NULL),
(20908, NULL, 'IPR022095', NULL, 'Rickettsia outer membrane protein B', 'rOmpB', 4, NULL),
(20909, NULL, 'IPR019721', NULL, 'NADH-ubiquinone oxidoreductase, 21kDa subunit, N-terminal', 'NADH-UbQ_OxRdtase_su21_N', 3, NULL),
(20910, NULL, 'IPR022071', NULL, 'Rotavirus VP1 RNA-directed RNA polymerase, C-terminal', 'Rotavirus_VP1_C', 3, NULL),
(20911, NULL, 'IPR020601', NULL, '1-aminocyclopropane-1-carboxylate deaminase, bacterial', 'ACP_carboxylate_deaminase_bac', 4, NULL),
(20912, NULL, 'IPR019642', NULL, 'Protein of unknown function DUF2507', 'DUF2507', 4, NULL),
(20913, NULL, 'IPR022105', NULL, 'Domain of unknown function DUF3645', 'DUF3645', 3, NULL),
(20914, NULL, 'IPR022166', NULL, 'UBAP2/protein lingerer', 'UBAP2/Lig', 4, NULL),
(20915, NULL, 'IPR017151', NULL, '5''-3'' exoribonuclease type 2', 'Xrn2/3/4', 4, NULL),
(20916, NULL, 'IPR022169', NULL, 'Protein of unknown function DUF3701', 'DUF3701', 4, NULL),
(20917, NULL, 'IPR020848', NULL, 'AP endonuclease 1, conserved site', 'AP_endonuclease_F1_CS', 2, NULL),
(20918, NULL, 'IPR018895', NULL, 'Protein of unknown function DUF2474', 'DUF2474', 4, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(20919, NULL, 'IPR017145', NULL, 'Aminobenzoyl-glutamate utilization protein B', 'Aminobenzoyl-glu_utiliz_pB', 4, NULL),
(20920, NULL, 'IPR020444', NULL, 'Interleukin-24', 'IL-24', 4, NULL),
(20921, NULL, 'IPR034480', NULL, 'Heme carboxy lyase-like', 'Heme_carboxy_lyase-like', 4, NULL),
(20922, NULL, 'IPR022111', NULL, 'Rhodanase, C-terminal', 'Rhodanese_C', 3, NULL),
(20923, NULL, 'IPR019766', NULL, 'Signal peptidase I, all-beta subdomain', 'Sign_pep_all-beta_subdom', 5, NULL),
(20924, NULL, 'IPR018856', NULL, 'CST complex subunit Stn1, N-terminal', 'Stn1_N', 3, NULL),
(20925, NULL, 'IPR018870', NULL, 'Tti2 family', 'Tti2', 4, NULL),
(20926, NULL, 'IPR019711', NULL, 'ATP synthase, F0 complex, subunit H', 'ATP_synth_F0_suH', 4, NULL),
(20927, NULL, 'IPR019662', NULL, 'Protein of unknown function DUF2516', 'DUF2516', 4, NULL),
(20928, NULL, 'IPR022159', NULL, 'Tuftelin interacting protein, N-terminal domain', 'STIP/TFIP11_N', 3, NULL),
(20929, NULL, 'IPR023199', NULL, 'Copper chaperone GriE/MELC1 superfamily', 'GriE/MELC1_sf', 5, NULL),
(20930, NULL, 'IPR022120', NULL, 'Pestivirus nonstructural protein 2', 'NS2', 4, NULL),
(20931, NULL, 'IPR022109', NULL, 'Protein of unknown function DUF3649', 'DUF3649', 4, NULL),
(20932, NULL, 'IPR017124', NULL, 'PR-domain zinc finger protein PRDM4', 'PRDM4', 4, NULL),
(20933, NULL, 'IPR034131', NULL, 'DAZ-associated protein 1, RNA recognition motif 2', 'DAZAP1_RRM2', 3, NULL),
(20934, NULL, 'IPR022081', NULL, 'Domain of unknown function DUF3631', 'DUF3631', 3, NULL),
(20935, NULL, 'IPR022155', NULL, 'Protein of unknown function DUF3684', 'DUF3684', 4, NULL),
(20936, NULL, 'IPR019734', NULL, 'Tetratricopeptide repeat', 'TPR_repeat', 7, NULL),
(20937, NULL, 'IPR018904', NULL, 'Uncharacterised protein family UPF0574', 'UPF0574', 4, NULL),
(20938, NULL, 'IPR034180', NULL, 'Medium-chain specific acyl-CoA dehydrogenase', 'MCAD', 4, NULL),
(20939, NULL, 'IPR017472', NULL, 'Undecaprenyl-phosphate galactose phosphotransferase, WbaP', 'Undecaprenyl-P_galact_Ptfrase', 4, NULL),
(20940, NULL, 'IPR020839', NULL, 'Stromalin conservative domain', 'SCD', 3, NULL),
(20941, NULL, 'IPR024214', NULL, 'Protein of unknown function DUF3843', 'DUF3843', 4, NULL),
(20942, NULL, 'IPR017850', NULL, 'Alkaline-phosphatase-like, core domain superfamily', 'Alkaline_phosphatase_core_sf', 5, NULL),
(20943, NULL, 'IPR017473', NULL, 'Undecaprenyl-phosphate glucose phosphotransferase, WcaJ', 'Undecaprenyl-P_gluc_Ptfrase', 4, NULL),
(20944, NULL, 'IPR022128', NULL, 'FhaA, N-terminal domain', 'FhaA_N', 3, NULL),
(20945, NULL, 'IPR022099', NULL, 'Domain of unknown function DUF3638', 'DUF3638', 3, NULL),
(20946, NULL, 'IPR019625', NULL, 'Biofilm-dependent modulation protein Bdm, putative', 'Biofilm-dep_modulation_Bdm_put', 4, NULL),
(20947, NULL, 'IPR022116', NULL, 'Adhesin P1, N-terminal', 'P1_N', 3, NULL),
(20948, NULL, 'IPR034503', NULL, 'SRSF9, RNA recognition motif  1', 'SRSF9_RRM1', 3, NULL),
(20949, NULL, 'IPR017474', NULL, 'PEF-CTERM protein sorting domain', 'PEF_CTERM_arc', 3, NULL),
(20950, NULL, 'IPR022117', NULL, 'Severe acute respiratory syndrome coronavirus 3b protein', 'SARS_3b', 4, NULL),
(20951, NULL, 'IPR019712', NULL, 'Tetraprenyl-beta-curcumene synthase YtpB-like', 'YtpB-like', 4, NULL),
(20952, NULL, 'IPR022171', NULL, 'PPE family, C-terminal', 'PPE_C', 3, NULL),
(20953, NULL, 'IPR035005', NULL, 'hnRNP-L, RNA recognition motif 1', 'hnRNPL_RRM1', 3, NULL),
(20954, NULL, 'IPR034506', NULL, 'RBM14, RNA recognition motif 1', 'RBM14_RRM1', 3, NULL),
(20955, NULL, 'IPR020844', NULL, 'Circadian clock protein KaiA, N-terminal', 'Circadian_clock_KaiA_N', 3, NULL),
(20956, NULL, 'IPR035020', NULL, 'PI3K p85 subunit, C-terminal SH2 domain', 'PI3kinase_P85_cSH2', 3, NULL),
(20957, NULL, 'IPR018871', NULL, 'GLEYA adhesin domain', 'GLEYA_adhesin_domain', 3, NULL),
(20958, NULL, 'IPR020888', NULL, 'Ribulose bisphosphate carboxylase large subunit, type I', 'RuBisCO_lsuI', 4, NULL),
(20959, NULL, 'IPR019725', NULL, 'Bacteriophage T4, P15K, RNA polymerase binding', 'Phage_T4_P15K_Rpol-bd', 4, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(20960, NULL, 'IPR035024', NULL, 'PLC-gamma, N-terminal SH2 domain', 'PLC-gamma_N-SH2', 3, NULL),
(20961, NULL, 'IPR020834', NULL, 'Lipoxygenase, conserved site', 'LipOase_CS', 2, NULL),
(20962, NULL, 'IPR020653', NULL, 'Tryptophan-tRNA ligase, archaea', 'Tryptophan-tRNA-ligase_arc', 4, NULL),
(20963, NULL, 'IPR019720', NULL, 'Plasmid stability protein, StbB', 'Plasmid_stability_protein_StbB', 4, NULL),
(20964, NULL, 'IPR019660', NULL, 'Putative sensory transduction regulator YbjN', 'Put_sensory_transdc_reg_YbjN', 4, NULL),
(20965, NULL, 'IPR018855', NULL, 'Proteasome chaperone 1, fungi', 'Psome_chaperone_1_fun', 4, NULL),
(20966, NULL, 'IPR020791', NULL, 'Leucine-tRNA ligase, archaeal', 'Leu-tRNA-lgase_arc', 4, NULL),
(20967, NULL, 'IPR022090', NULL, 'Protein of unknown function DUF3634', 'DUF3634', 4, NULL),
(20968, NULL, 'IPR018908', NULL, 'Putative transmembrane family 234', 'TMEM234', 4, NULL),
(20969, NULL, 'IPR019719', NULL, 'Protein of unknown function DUF2599', 'DUF2599', 4, NULL),
(20970, NULL, 'IPR018861', NULL, 'Transmembrane protein 201, C-terminal', 'TMEM201_C', 3, NULL),
(20971, NULL, 'IPR017493', NULL, 'Photosystem I reaction center subunit psaK, plant', 'PSI_PsaK_pln', 4, NULL),
(20972, NULL, 'IPR020899', NULL, 'Arginine repressor, C-terminal', 'Arg_repress_C', 3, NULL),
(20973, NULL, 'IPR022149', NULL, 'Protein of unknown function DUF3681', 'DUF3681', 4, NULL),
(20974, NULL, 'IPR022143', NULL, 'Protein of unknown function DUF3675', 'DUF3675', 4, NULL),
(20975, NULL, 'IPR020583', NULL, 'Inositol monophosphatase, metal-binding site', 'Inositol_monoP_metal-BS', 1, NULL),
(20976, NULL, 'IPR020708', NULL, 'DNA-directed RNA polymerase, 14-18kDa subunit, conserved site', 'DNA-dir_RNA_polK_14-18kDa_CS', 2, NULL),
(20977, NULL, 'IPR022167', NULL, 'Protein of unknown function DUF3698', 'DUF3698', 4, NULL),
(20978, NULL, 'IPR020868', NULL, 'Bifunctional enzyme Fae/Hps', 'Fae/Hps', 4, NULL),
(20979, NULL, 'IPR020833', NULL, 'Lipoxygenase, iron binding site', 'LipOase_Fe_BS', 1, NULL),
(20980, NULL, 'IPR020879', NULL, 'N-acetylglucosamine-binding protein A', 'GlcNAc-bd_A', 4, NULL),
(20981, NULL, 'IPR018890', NULL, 'FAM171', 'FAM171', 4, NULL),
(20982, NULL, 'IPR020456', NULL, 'Acylphosphatase', 'Acylphosphatase', 4, NULL),
(20983, NULL, 'IPR019639', NULL, 'Protein of unknown function DUF2505', 'DUF2505', 4, NULL),
(20984, NULL, 'IPR022077', NULL, 'ATP-dependent RNA helicase RhlB', 'RhlB', 4, NULL),
(20985, NULL, 'IPR022129', NULL, 'Transcriptional repressor NocA-like', 'Tscrpt_rep_NocA-like', 4, NULL),
(20986, NULL, 'IPR020996', NULL, 'Type III secretion system, AvrPto', 'T3SS_AvrPto', 4, NULL),
(20987, NULL, 'IPR018900', NULL, 'Curli assembly protein CsgE', 'Curli_CsgE', 4, NULL),
(20988, NULL, 'IPR022131', NULL, 'Protein of unknown function DUF3664, surface protein', 'DUF3664', 4, NULL),
(20989, NULL, 'IPR017139', NULL, 'Uncharacterised conserved protein UCP037213', 'UCP037213', 4, NULL),
(20990, NULL, 'IPR022124', NULL, 'Protein of unknown function DUF3659', 'DUF3659', 4, NULL),
(20991, NULL, 'IPR018090', NULL, 'Pyrimidine-nucleoside phosphorylase, bacterial/eukaryotic', 'Pyrmidine_PPas_bac/euk', 4, NULL),
(20992, NULL, 'IPR022100', NULL, 'Minichromosome loss protein Mcl1, middle region', 'Mcl1_mid', 3, NULL),
(20993, NULL, 'IPR018146', NULL, 'Glyoxalase I, conserved site', 'Glyoxalase_1_CS', 2, NULL),
(20994, NULL, 'IPR019733', NULL, 'Uncharacterised protein family YhfT', 'Uncharacterised_YhfT', 4, NULL),
(20995, NULL, 'IPR018858', NULL, 'Protein of unknown function DUF2458', 'DUF2458', 4, NULL),
(20996, NULL, 'IPR019659', NULL, 'Protein of unknown function DUF2514', 'DUF2514', 4, NULL),
(20997, NULL, 'IPR023587', NULL, 'Metallothionein domain superfamily, vertebrate', 'Metalthion_dom_sf_vert', 5, NULL),
(20998, NULL, 'IPR017924', NULL, 'RNA-binding protein YhbY', 'RNA-binding_YhbY', 4, NULL),
(20999, NULL, 'IPR023292', NULL, 'NTP pyrophosphohydrolase-like domain superfamily', 'NTP_PyroPHydrolase-like_dom_sf', 5, NULL),
(21000, NULL, 'IPR019749', NULL, 'Band 4.1 domain', 'Band_41_domain', 3, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(21001, NULL, 'IPR016746', NULL, 'Uncharacterised conserved protein UCP019078', 'UCP019078', 4, NULL),
(21002, NULL, 'IPR016738', NULL, 'DNA double-strand break repair nuclease NurA-like', 'NurA-like', 4, NULL),
(21003, NULL, 'IPR022178', NULL, 'Protein of unknown function DUF3709', 'DUF3709', 4, NULL),
(21004, NULL, 'IPR026432', NULL, 'Archaeosortase D', 'Archaeo_ArtD', 4, NULL),
(21005, NULL, 'IPR017510', NULL, 'Release factor H-coupled RctB family protein', 'Release_fac_RtcB', 4, NULL),
(21006, NULL, 'IPR016730', NULL, 'RNA-binding FAU-1', 'RNA-bd_FAU-1', 4, NULL),
(21007, NULL, 'IPR029285', NULL, 'CagY type 1 repeat', 'CagY_I', 7, NULL),
(21008, NULL, 'IPR031807', NULL, 'HicB-like antitoxin of toxin-antitoxin system', 'HicB-like', 3, NULL),
(21009, NULL, 'IPR022187', NULL, 'Conjugative transposon, TraM', 'Conjug_transposon_TraM', 4, NULL),
(21010, NULL, 'IPR022195', NULL, 'Protein of unknown function DUF3720', 'DUF3720', 4, NULL),
(21011, NULL, 'IPR016404', NULL, 'M polyprotein precursor, phlebovirus', 'M_polyprot_prcur_phlebovir', 4, NULL),
(21012, NULL, 'IPR026400', NULL, 'Bunyavirus nonstructural protein NSm', 'Bunya_nonstruc_pro_NSm', 3, NULL),
(21013, NULL, 'IPR016753', NULL, 'Phage portal protein PBSX family, Firmicutes', 'PBSX_Firmicutes', 4, NULL),
(21014, NULL, 'IPR016423', NULL, 'Resolvase, Rsv', 'Resolvase_Rsv', 4, NULL),
(21015, NULL, 'IPR026385', NULL, 'Aminotransferase, LLPSF_NHT_00031 family', 'AminoTrfase_NHT_00031', 4, NULL),
(21016, NULL, 'IPR016715', NULL, 'Platelet-activating factor acetylhydrolase, eucaryote', 'PAF_acetylhydro_eucaryote', 4, NULL),
(21017, NULL, 'IPR026394', NULL, 'Streptococcal surface-anchored protein repeat, S. criceti family', 'RPT_S_cricet', 7, NULL),
(21018, NULL, 'IPR022222', NULL, 'Protein of unknown function DUF3747', 'DUF3747', 4, NULL),
(21019, NULL, 'IPR017173', NULL, 'Nuclear mRNA export protein Sac3', 'Sac3', 4, NULL),
(21020, NULL, 'IPR029273', NULL, 'Cdc42 effector', 'Cdc42_effect', 4, NULL),
(21021, NULL, 'IPR022206', NULL, 'Firmicutes EssC, N-terminal', 'Firmicutes_EssC_N', 3, NULL),
(21022, NULL, 'IPR019668', NULL, 'Uncharacterised protein family YtzC', 'Uncharacterised_YtzC', 4, NULL),
(21023, NULL, 'IPR022176', NULL, 'Apolipoprotein B100 C-terminal', 'ApoB100_C', 3, NULL),
(21024, NULL, 'IPR022226', NULL, 'Domain of unknown function DUF3752', 'DUF3752', 3, NULL),
(21025, NULL, 'IPR020491', NULL, 'Biogenesis of lysosome-related organelles complex 1 subunit BLI1', 'BLI1', 4, NULL),
(21026, NULL, 'IPR026424', NULL, 'Modification target Cys-rich peptide, AC3_0185 family', 'Cxxx_AC3_0185', 4, NULL),
(21027, NULL, 'IPR022180', NULL, 'Vegetative insecticide protein 3', 'Vip3', 4, NULL),
(21028, NULL, 'IPR016770', NULL, 'Nonstructural, NS2', 'Non-structural_NS2', 4, NULL),
(21029, NULL, 'IPR016416', NULL, 'Bacteriophage T4, Gp31, chaperonin-GroEL', 'Phage_T4_Gp31_GroEL', 4, NULL),
(21030, NULL, 'IPR017503', NULL, 'Sortase B signal domain, QVPTGV class', 'Sortase_SrtB_sig_QVPTGV', 3, NULL),
(21031, NULL, 'IPR034116', NULL, 'AGE domain', 'AGE_dom', 3, NULL),
(21032, NULL, 'IPR020857', NULL, 'Serum albumin, conserved site', 'Serum_albumin_CS', 2, NULL),
(21033, NULL, 'IPR034110', NULL, 'LSM domain containing 1', 'LSMD1', 3, NULL),
(21034, NULL, 'IPR017162', NULL, 'Uncharacterised conserved protein UCP037266', 'UCP037266', 4, NULL),
(21035, NULL, 'IPR018474', NULL, 'Uncharacterised protein family YqaI', 'Uncharacterised_Yqai', 4, NULL),
(21036, NULL, 'IPR016402', NULL, 'Envelope glycoprotein precursor, Hantavirus', 'Envelope_glycoprot_Hantavirus', 4, NULL),
(21037, NULL, 'IPR026413', NULL, 'CXXX repeat peptide modification system protein', 'CXXX_rpt_assoc', 4, NULL),
(21038, NULL, 'IPR029281', NULL, 'FAM194, C-terminal', 'FAM194_C', 3, NULL),
(21039, NULL, 'IPR022409', NULL, 'PKD/Chitinase domain', 'PKD/Chitinase_dom', 3, NULL),
(21040, NULL, 'IPR034284', NULL, 'Copper resistance protein, first cupredoxin domain', 'CuRO_1_CopA', 3, NULL),
(21041, NULL, 'IPR024664', NULL, 'L-arabinose isomerase, C-terminal', 'Ara_Isoase_C', 3, NULL),
(21042, NULL, 'IPR024679', NULL, 'Pre-rRNA-processing protein Ipi1, N-terminal', 'Ipi1_N', 3, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(21043, NULL, 'IPR020234', NULL, 'Mite allergen, group-7', 'Mite_allergen_group-7', 4, NULL),
(21044, NULL, 'IPR022238', NULL, '18S rRNA (guanine(1575)-N(7))-methyltransferase Bud23, C-terminal', 'Bud23_C', 3, NULL),
(21045, NULL, 'IPR016426', NULL, 'L-aspartate semialdehyde sulfurtransferase MA1821-like', 'MA1821-like', 4, NULL),
(21046, NULL, 'IPR016388', NULL, 'Putative partitioning protein SopC', 'Put_partitioning_SopC', 4, NULL),
(21047, NULL, 'IPR016394', NULL, 'Human herpesvirus 5, HKLF1', 'HHV5_HKLF1', 4, NULL),
(21048, NULL, 'IPR016432', NULL, 'Ribonuclease P subunit RNP4', 'RNP4', 4, NULL),
(21049, NULL, 'IPR020785', NULL, 'Ribosomal protein L11, conserved site', 'Ribosomal_L11_CS', 2, NULL),
(21050, NULL, 'IPR024677', NULL, '4-HPA 3-monooxygenase large component/Pyoverdin chromophore biosynthetic protein', 'HpaB/PvcC', 4, NULL),
(21051, NULL, 'IPR026407', NULL, 'Radical SAM peptide maturase, GG-Bacteroidales family', 'SAM_GG-Bacter', 4, NULL),
(21052, NULL, 'IPR017160', NULL, 'Uncharacterised conserved protein UCP037256', 'UCP037256', 4, NULL),
(21053, NULL, 'IPR017172', NULL, 'Lipopolysaccharide core heptose(I) kinase RfaP', 'Lsacc_core_hep_kinase_RfaP', 4, NULL),
(21054, NULL, 'IPR022365', NULL, 'Clathrin, heavy chain, propeller repeat', 'Clathrin_H-chain_propeller_rpt', 7, NULL),
(21055, NULL, 'IPR026423', NULL, 'Peptide-modifying radical SAM enzyme CbpB', 'rSAM_cobopep', 4, NULL),
(21056, NULL, 'IPR022220', NULL, 'Hemolytic toxin, N-terminal', 'Hemolysin_N', 3, NULL),
(21057, NULL, 'IPR022188', NULL, 'TASOR, DUF3715', 'TASOR_DUF3715', 3, NULL),
(21058, NULL, 'IPR035282', NULL, 'Protein of unknown function DUF5429', 'DUF5429', 4, NULL),
(21059, NULL, 'IPR016760', NULL, 'Methenyltetrahydromethanopterin hydrogenase cofactor biosynthesis protein HmdC', 'MonoFe_hyd_HmdC', 4, NULL),
(21060, NULL, 'IPR017176', NULL, 'Alpha-(1, 3)-fucosyltransferase, metazoan', 'Alpha-1_3-FUT_met', 4, NULL),
(21061, NULL, 'IPR022184', NULL, 'Cucumber mosaic virus 1a protein C-terminal', 'CMV_1a_C', 3, NULL),
(21062, NULL, 'IPR016757', NULL, 'Uncharacterised conserved protein UCP019322', 'UCP019322', 4, NULL),
(21063, NULL, 'IPR016744', NULL, 'Uncharacterised conserved protein UCP019072', 'UCP019072', 4, NULL),
(21064, NULL, 'IPR023111', NULL, 'Titin-like domain superfamily', 'Titin-like_dom_sf', 5, NULL),
(21065, NULL, 'IPR022189', NULL, 'Smoothelin', 'SMTN', 3, NULL),
(21066, NULL, 'IPR020803', NULL, 'Polyketide synthase, methyltransferase domain', 'PKS_MeTfrase', 3, NULL),
(21067, NULL, 'IPR025170', NULL, 'Protein of unknown function DUF3928', 'DUF3928', 4, NULL),
(21068, NULL, 'IPR026405', NULL, 'Chlamydiae/Verrucomicrobia/Planctomycetes  small basic protein', 'Chlam/Ver/Plancto_rRNA', 4, NULL),
(21069, NULL, 'IPR022250', NULL, 'Type IVb secretion, IcmS, effector-recruitment', 'T4bSS_IcmS', 4, NULL),
(21070, NULL, 'IPR026533', NULL, 'Non-canonical purine NTP phosphatase/PRRC1', 'NTPase/PRRC1', 3, NULL),
(21071, NULL, 'IPR022207', NULL, 'Genetic suppressor element-like', 'GSE-like', 3, NULL),
(21072, NULL, 'IPR022234', NULL, 'Protein of unknown function DUF3759', 'DUF3759', 4, NULL),
(21073, NULL, 'IPR024671', NULL, 'Autophagy-related protein 22-like', 'Atg22-like', 4, NULL),
(21074, NULL, 'IPR016767', NULL, 'Uncharacterised conserved protein UCP019853', 'UCP019853', 4, NULL),
(21075, NULL, 'IPR025172', NULL, 'Protein of unknown function DUF3930', 'DUF3930', 4, NULL),
(21076, NULL, 'IPR022211', NULL, 'Poly-beta-hydroxybutyrate polymerase N-terminal', 'PHBC_N', 3, NULL),
(21077, NULL, 'IPR020532', NULL, 'Cycloeucalenol cycloisomerase', 'Cycloeucalenol_cycloisomerase', 4, NULL),
(21078, NULL, 'IPR020815', NULL, 'Ribosomal protein S6, conserved site', 'Ribosomal_S6_CS', 2, NULL),
(21079, NULL, 'IPR035358', NULL, 'Protein of unknown function DUF5422', 'DUF5422', 4, NULL),
(21080, NULL, 'IPR016379', NULL, 'Type III secretion system, low calcium response, chaperone LcrH/SycD, subgroup', 'T3SS_Ca_resp_chp_LcrH/SycD_sub', 4, NULL),
(21081, NULL, 'IPR020799', NULL, 'A-kinase anchor 110kDa', 'AKAP_110', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(21082, NULL, 'IPR023582', NULL, 'Impact family', 'Impact', 4, NULL),
(21083, NULL, 'IPR020485', NULL, 'Stationary phase protein 4', 'Spg4', 4, NULL),
(21084, NULL, 'IPR025167', NULL, 'Fusion glycoprotein F0, Isavirus', 'Fusion_F0_Isavirus', 4, NULL),
(21085, NULL, 'IPR022240', NULL, 'Protein of unknown function DUF3764', 'DUF3764', 4, NULL),
(21086, NULL, 'IPR026534', NULL, 'Protein PRRC1', 'PRRC1', 4, NULL),
(21087, NULL, 'IPR022368', NULL, 'Putative thiazole-containing bacteriocin maturation protein', 'Thiazole_bacteriocin_mat_put', 4, NULL),
(21088, NULL, 'IPR016726', NULL, 'Repressor protein C1', 'Repressor_C1', 4, NULL),
(21089, NULL, 'IPR016413', NULL, 'Bacteriophage T4, DenA, endonuclease II', 'Phage_T4_DenA_endoDNaseII', 4, NULL),
(21090, NULL, 'IPR022256', NULL, 'Domain of unknown function DUF3778', 'DUF3778', 3, NULL),
(21091, NULL, 'IPR018469', NULL, 'Dual oxidase maturation factor', 'Dual_oxidase_maturation_fac', 4, NULL),
(21092, NULL, 'IPR017168', NULL, 'Glycoside hydrolase, family 16, CRH1, predicted', 'Glyco_hydro_16_CRH1_prd', 4, NULL),
(21093, NULL, 'IPR017183', NULL, 'Sigma54-dependent transcriptional activator, RtcR', 'Sigma54_dep_tscrpt_act_RtcR', 4, NULL),
(21094, NULL, 'IPR022285', NULL, 'Conserved hypothetical protein CHP03879, regulatory domain, putative', 'CHP03879_regulat_dom_put', 3, NULL),
(21095, NULL, 'IPR022193', NULL, 'Protein of unknown function DUF3718', 'DUF3718', 4, NULL),
(21096, NULL, 'IPR016735', NULL, 'Uncharacterised protein family UPF0285, methanogenesis', 'UPF0285_methan', 4, NULL),
(21097, NULL, 'IPR017514', NULL, 'Glycine cleavage system protein H-related, Chlamydia', 'GcvH_Chlamydia', 4, NULL),
(21098, NULL, 'IPR022221', NULL, 'Type III restriction/modification enzyme methylation subunit', 'TypeIII_RM_meth', 3, NULL),
(21099, NULL, 'IPR016766', NULL, 'Trichothecene biosynthesis transcription regulator TRI6', 'Tscrpt_reg_Tri6', 4, NULL),
(21100, NULL, 'IPR016737', NULL, 'Uncharacterised conserved protein UCP018868', 'UCP018868', 4, NULL),
(21101, NULL, 'IPR016741', NULL, 'Uncharacterised conserved protein UCP018953', 'UCP018953', 4, NULL),
(21102, NULL, 'IPR026433', NULL, 'EPS-associated transcriptional regulator, MarR family', 'MarR_EPS', 4, NULL),
(21103, NULL, 'IPR024668', NULL, 'GA-binding protein alpha subunit, N-terminal', 'GABP_asu_N', 3, NULL),
(21104, NULL, 'IPR018445', NULL, 'Putative phosphate transport regulator', 'Put_Phosphate_transp_reg', 4, NULL),
(21105, NULL, 'IPR018476', NULL, 'Glycerophosphoryl diester phosphodiesterase, membrane domain', 'GlyceroP-diester-Pdiesterase_M', 3, NULL),
(21106, NULL, 'IPR034112', NULL, 'Intraflagellar transport protein 27 homologue, eukaryotes', 'RabL4_euk', 4, NULL),
(21107, NULL, 'IPR016428', NULL, 'NADPH-dependent 7-cyano-7-deazaguanine reductase, QueF type 2', 'QueF_type2', 4, NULL),
(21108, NULL, 'IPR020552', NULL, 'Inositol monophosphatase, lithium-sensitive', 'Inositol_monoPase_Li-sen', 4, NULL),
(21109, NULL, 'IPR026420', NULL, 'Exosortase E/protease, VPEID-CTERM system', 'Exo_VPEID', 4, NULL),
(21110, NULL, 'IPR026183', NULL, 'Taxilin family', 'Taxilin_fam', 4, NULL),
(21111, NULL, 'IPR016407', NULL, 'C-protein', 'C-protein', 4, NULL),
(21112, NULL, 'IPR029287', NULL, 'Retinoic acid early-inducible protein 1', 'RAE-1', 3, NULL),
(21113, NULL, 'IPR019669', NULL, 'Uncharacterised bacterial stress protein YodD', 'Uncharacterised_YodD', 4, NULL),
(21114, NULL, 'IPR016393', NULL, 'Replication protein E1, papillomavirus', 'Rep_E1_papillomaV', 4, NULL),
(21115, NULL, 'IPR017187', NULL, 'Ethylene-insensitive protein 2', 'EIN2', 4, NULL),
(21116, NULL, 'IPR016405', NULL, 'Coat protein, Ilarvirus, predicted', 'Coat_Ilarvirus_prd', 4, NULL),
(21117, NULL, 'IPR022239', NULL, 'Protein of unknown function DUF3762', 'DUF3762', 4, NULL),
(21118, NULL, 'IPR016745', NULL, 'Archaeal GINS complex, Gins51 subunit', 'Gins51', 4, NULL),
(21119, NULL, 'IPR020481', NULL, 'Intracellular proteinase inhibitor BsuPI', 'Intracell_prot_inh_BsuPI', 3, NULL),
(21120, NULL, 'IPR017515', NULL, 'Methylmalonyl-CoA epimerase', 'MeMalonyl-CoA_epimerase', 4, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(21121, NULL, 'IPR016747', NULL, 'Phosphotransbutyrylase', 'Phosphotransbutyrylase', 4, NULL),
(21122, NULL, 'IPR016395', NULL, 'Cytoplasmic envelopment protein 3, Simplexvirus', 'UL11_simplexvirus', 4, NULL),
(21123, NULL, 'IPR016384', NULL, 'Plasmid transfer regulator TraJ, R1 plasmid', 'TraJ_R1', 4, NULL),
(21124, NULL, 'IPR016429', NULL, 'NAD biosynthesis/regulator protein NadR', 'NAD_NadR', 4, NULL),
(21125, NULL, 'IPR018484', NULL, 'Carbohydrate kinase, FGGY, N-terminal', 'Carb_kinase_FGGY_N', 3, NULL),
(21126, NULL, 'IPR016731', NULL, 'Uncharacterised conserved protein UCP018649', 'UCP018649', 4, NULL),
(21127, NULL, 'IPR022209', NULL, 'Pre-mRNA splicing factor', 'CWC25', 4, NULL),
(21128, NULL, 'IPR016380', NULL, 'Signal transduction histidine kinase, nitrate/nitrite-sensing', 'Sig_transdc_His_kin_NarX/NarQ', 4, NULL),
(21129, NULL, 'IPR022245', NULL, 'Rubivirus non-structural protein, C-terminal', 'Rubi_NSP_C', 3, NULL),
(21130, NULL, 'IPR016742', NULL, 'tRNA methyltransferase, archaea', 'tRNA_m1G_mtfrase_arc', 4, NULL),
(21131, NULL, 'IPR024757', NULL, 'Cell division protein FtsZ, C-terminal', 'FtsZ_C', 3, NULL),
(21132, NULL, 'IPR022216', NULL, 'Putative ABC cobalt transporter', 'ABC_Co_transporter', 4, NULL),
(21133, NULL, 'IPR018485', NULL, 'Carbohydrate kinase, FGGY, C-terminal', 'Carb_kinase_FGGY_C', 3, NULL),
(21134, NULL, 'IPR016768', NULL, 'Uncharacterised conserved protein UCP019883, membrane', 'UCP019883', 4, NULL),
(21135, NULL, 'IPR022251', NULL, 'Protein of unknown function wound-induced', 'DUF3774_wound-induced', 4, NULL),
(21136, NULL, 'IPR022215', NULL, 'SteA-like C-terminal', 'SteA-like_C', 3, NULL),
(21137, NULL, 'IPR018475', NULL, 'Luciferase, helical bundle domain', 'Luciferase_hlx-bundle_domain', 3, NULL),
(21138, NULL, 'IPR022252', NULL, 'SOCS4/SOCS5 domain', 'SOCS4/SOCS5_dom', 3, NULL),
(21139, NULL, 'IPR026403', NULL, 'Putative lipoprotein, rSAM/lipoprotein system', 'Lipo_with_rSAM', 4, NULL),
(21140, NULL, 'IPR022297', NULL, 'CRISPR-associated protein, CsaX', 'CRISPR-assoc_prot_CsaX', 4, NULL),
(21141, NULL, 'IPR035270', NULL, 'Protein of unknown function DUF5433', 'DUF5433', 4, NULL),
(21142, NULL, 'IPR022404', NULL, 'Diphtheria toxin, receptor-binding domain', 'Diphtheria_toxin_rcpt-bd_dom', 3, NULL),
(21143, NULL, 'IPR023112', NULL, 'Antifungal protein domain superfamily', 'Antifungal-protein_dom_sf', 5, NULL),
(21144, NULL, 'IPR016421', NULL, 'Transposition, TnsE', 'Transposition_TnsE', 4, NULL),
(21145, NULL, 'IPR022447', NULL, 'Lysine-2,3-aminomutase-related', 'Lys_aminomutase-rel', 4, NULL),
(21146, NULL, 'IPR022241', NULL, 'Inactive rhomboid protein 1/2', 'iRhom1/2', 4, NULL),
(21147, NULL, 'IPR016382', NULL, 'Pilus assembly, TraL', 'Pilus_assmbly_TraL', 4, NULL),
(21148, NULL, 'IPR020240', NULL, 'Uncharacterised protein family UPF0412, YaaI', 'UPF0412_YaaI', 4, NULL),
(21149, NULL, 'IPR017196', NULL, 'ECF transporter, predicted substrate-specific component UCP037395', 'ECF_substrate-spec_UCP037395', 4, NULL),
(21150, NULL, 'IPR022219', NULL, 'Poxvirus I6, C-terminal', 'Poxvirus_I6_C', 3, NULL),
(21151, NULL, 'IPR017186', NULL, 'Lipase, autotransporter EstA', 'Lipase_autotranspt_EstA', 4, NULL),
(21152, NULL, 'IPR035285', NULL, 'Ctenitoxin', 'CNTX', 4, NULL),
(21153, NULL, 'IPR016732', NULL, 'Uncharacterised conserved protein UCP018688', 'UCP018688', 4, NULL),
(21154, NULL, 'IPR022232', NULL, 'Tripeptidyl peptidase II, C-terminal domain, arthropoda', 'TPPII_C_art', 3, NULL),
(21155, NULL, 'IPR020814', NULL, 'Ribosomal protein S6, plastid/chloroplast', 'Ribosomal_S6_plastid/chlpt', 4, NULL),
(21156, NULL, 'IPR016725', NULL, 'Ogawa serotype, WbeT', 'Ogawa_serotype_WbeT', 4, NULL),
(21157, NULL, 'IPR022356', NULL, 'Interleukin-11, fish', 'IL-11_fish', 4, NULL),
(21158, NULL, 'IPR034212', NULL, 'PUF60, RNA recognition motif 3', 'PUF60_RRM3', 3, NULL),
(21159, NULL, 'IPR016758', NULL, 'Glucose-6-phosphate isomerase, archaea/bacteria', 'G6P_isomerase_archaea/bacteria', 4, NULL),
(21160, NULL, 'IPR016412', NULL, 'RNA polymerase inhibitor', 'RNA_pol_inhibitor', 4, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(21161, NULL, 'IPR017185', NULL, 'Uncharacterised conserved protein UCP037373, transcriptional regulator, AF0674', 'UCP037373_trxn_reg', 4, NULL),
(21162, NULL, 'IPR026382', NULL, 'RNA endonuclease, cap-snatching', 'CapSnatchArena', 3, NULL),
(21163, NULL, 'IPR018486', NULL, 'Hemopexin, conserved site', 'Hemopexin_CS', 2, NULL),
(21164, NULL, 'IPR017509', NULL, 'Putative peptide chain release factor H', 'Release_fac_PrfH', 4, NULL),
(21165, NULL, 'IPR016755', NULL, 'Uncharacterised conserved protein UCP019302', 'UCP019302', 4, NULL),
(21166, NULL, 'IPR017190', NULL, 'Bifunctional CTP:phosphocholine cytidylyltransferase/choline kinase', 'Bifunc_CCT/choline_kinase', 4, NULL),
(21167, NULL, 'IPR025189', NULL, 'Protein of unknown function DUF4121', 'DUF4121', 4, NULL),
(21168, NULL, 'IPR017167', NULL, 'Uncharacterised conserved protein UCP037291, glutaredoxin-related', 'UCP037291_glutaredoxin-rel', 4, NULL),
(21169, NULL, 'IPR018466', NULL, 'Yeast cell wall synthesis Kre9/Knh1-like, N-terminal', 'Kre9/Knh1-like_N', 3, NULL),
(21170, NULL, 'IPR020871', NULL, 'Ribulose bisphosphate carboxylase large subunit, type II', 'RuBisCO_lsuII', 4, NULL),
(21171, NULL, 'IPR017179', NULL, 'Spastin', 'Spastin', 4, NULL),
(21172, NULL, 'IPR035276', NULL, 'Feline immunodeficiency virus OrfA protein', 'FIV_OrfA', 4, NULL),
(21173, NULL, 'IPR016406', NULL, 'Cystovirus, RNA-directed RNA polymerase', 'Cystovir_RNA-dir_pol', 4, NULL),
(21174, NULL, 'IPR016425', NULL, '4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase, bacterial', 'IspG_bac', 4, NULL),
(21175, NULL, 'IPR017175', NULL, 'Inhibin, alpha subunit', 'Inhibin_asu', 4, NULL),
(21176, NULL, 'IPR024752', NULL, 'Myb/SANT-like domain', 'Myb/SANT-like_dom', 3, NULL),
(21177, NULL, 'IPR034221', NULL, 'RBM34, RNA recognition motif 2', 'RBM34_RRM2', 3, NULL),
(21178, NULL, 'IPR018487', NULL, 'Hemopexin-like repeats', 'Hemopexin-like_repeat', 7, NULL),
(21179, NULL, 'IPR034107', NULL, 'Lsm16, N-terminal', 'Lsm16_N', 3, NULL),
(21180, NULL, 'IPR025175', NULL, 'Protein of unknown function DUF3934', 'DUF3934', 4, NULL),
(21181, NULL, 'IPR030910', NULL, 'SLAP domain, Bacillus-type', 'SLAP_dom_Bacil', 3, NULL),
(21182, NULL, 'IPR016717', NULL, 'Gip2/Pig2', 'Gip2/Pig2', 4, NULL),
(21183, NULL, 'IPR030912', NULL, 'Arg-Lys translocation region protein phosphatase', 'RK_trnsloc_Pase', 4, NULL),
(21184, NULL, 'IPR022229', NULL, 'Tripeptidyl peptidase II, Ig-like domain', 'TPPII_Ig-like', 3, NULL),
(21185, NULL, 'IPR026417', NULL, 'Geranylgeranylglyceryl phosphate synthase, Halobacteria', 'GGGPS_Halobacteria', 4, NULL),
(21186, NULL, 'IPR023590', NULL, 'Digeranylgeranylglycerophospholipid reductase', 'DGGGPL_reductase', 4, NULL),
(21187, NULL, 'IPR018477', NULL, 'Bicaudal-D protein', 'BICD', 4, NULL),
(21188, NULL, 'IPR024673', NULL, 'Octaheme c-type cytochrome', 'Octahem_Cyt_c', 4, NULL),
(21189, NULL, 'IPR016391', NULL, 'Coatomer subunit alpha', 'Coatomer_asu', 4, NULL),
(21190, NULL, 'IPR025186', NULL, 'Protein of unknown function DUF4119', 'DUF4119', 4, NULL),
(21191, NULL, 'IPR017155', NULL, 'Histone-lysine N-methyltransferase, SET', 'Hist-Lys_N-MeTrfase_SET', 4, NULL),
(21192, NULL, 'IPR020550', NULL, 'Inositol monophosphatase, conserved site', 'Inositol_monophosphatase_CS', 2, NULL),
(21193, NULL, 'IPR034209', NULL, 'PUF60, RNA recognition motif 1', 'PUF60_RRM1', 3, NULL),
(21194, NULL, 'IPR016409', NULL, 'Bacteriophage T4, Gp55.2', 'Phage_T4_Gp55.2', 4, NULL),
(21195, NULL, 'IPR022412', NULL, 'Quinolinate phosphoribosyl transferase, N-terminal', 'Quinolinate_PRibosylTrfase_N', 3, NULL),
(21196, NULL, 'IPR025168', NULL, 'Protein of unknown function DUF3925', 'DUF3925', 4, NULL),
(21197, NULL, 'IPR022243', NULL, 'Protein of unknown function DUF3768', 'DUF3768', 4, NULL),
(21198, NULL, 'IPR016719', NULL, 'Guided entry of tail-anchored proteins factor CAMLG', 'CAMLG', 4, NULL),
(21199, NULL, 'IPR016761', NULL, 'Uncharacterised conserved protein UCP019454, CBS', 'UCP019454_CBS', 4, NULL),
(21200, NULL, 'IPR022228', NULL, 'Protein of unknown function DUF3755', 'DUF3755', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(21201, NULL, 'IPR026414', NULL, 'Exosortase F-associated protein', 'ExosoTase_F-assoc_pro', 4, NULL),
(21202, NULL, 'IPR018473', NULL, 'Hermes trasposase, DNA-binding domain', 'Hermes_transposase_DNA-db', 3, NULL),
(21203, NULL, 'IPR022202', NULL, 'Hepatitis E virus, hinge domain', 'Hepatitis-E_hinge', 3, NULL),
(21204, NULL, 'IPR016389', NULL, 'Exclusion-determining protein', 'Exclusion-determining_protein', 4, NULL),
(21205, NULL, 'IPR025190', NULL, 'Protein of unknown function DUF4122', 'DUF4122', 4, NULL),
(21206, NULL, 'IPR020876', NULL, 'Tyrosine recombinase XerD-like', 'Tyrosine_recombinase_XerD-like', 4, NULL),
(21207, NULL, 'IPR017506', NULL, 'Photosystem II S4', 'PSII_S4', 4, NULL),
(21208, NULL, 'IPR016751', NULL, 'Uncharacterised conserved protein UCP019236', 'UCP019236', 4, NULL),
(21209, NULL, 'IPR017182', NULL, 'Methyltransferase METTL16/PsiM', 'METTL16/PsiM', 4, NULL),
(21210, NULL, 'IPR020784', NULL, 'Ribosomal protein L11, N-terminal', 'Ribosomal_L11_N', 3, NULL),
(21211, NULL, 'IPR017174', NULL, 'Transcription factor TFIIIB component B'''', fungi', 'Bdp1_fungi', 4, NULL),
(21212, NULL, 'IPR035198', NULL, 'Protein of unknown function DUF5309', 'DUF5309', 4, NULL),
(21213, NULL, 'IPR034114', NULL, 'Ras-related protein Rab-23', 'Rab23', 4, NULL),
(21214, NULL, 'IPR022185', NULL, 'Protein of unknown function DUF3712', 'DUF3712', 4, NULL),
(21215, NULL, 'IPR016410', NULL, 'Bacteriophage-associated immunity protein', 'Phage_imm', 4, NULL),
(21216, NULL, 'IPR022200', NULL, 'Herpesvirus glycoprotein L, C-terminal', 'Herpes_gL_C', 3, NULL),
(21217, NULL, 'IPR024094', NULL, 'Cytochrome f large domain', 'Cyt_f_lg_dom', 3, NULL),
(21218, NULL, 'IPR016748', NULL, 'Transcription regulator, CopG/Arc/MetJ DNA-binding domain-containing, predicted', 'Tscrpt_reg_CopG_prd', 4, NULL),
(21219, NULL, 'IPR024661', NULL, 'DNA-directed RNA polymerase III, subunit Rpc31', 'RNA_pol_III_Rpc31', 4, NULL),
(21220, NULL, 'IPR035171', NULL, 'Aphid megourin', 'Megourin', 4, NULL),
(21221, NULL, 'IPR020802', NULL, 'Polyketide synthase, thioesterase domain', 'PKS_thioesterase', 3, NULL),
(21222, NULL, 'IPR022257', NULL, '10TM putative phosphate transporter, extracellular tail', 'PHM7_ext', 3, NULL),
(21223, NULL, 'IPR020546', NULL, 'ATP synthase, F1 complex, delta/epsilon subunit, N-terminal', 'ATP_synth_F1_dsu/esu_N', 3, NULL),
(21224, NULL, 'IPR022353', NULL, 'Insulin, conserved site', 'Insulin_CS', 2, NULL),
(21225, NULL, 'IPR026246', NULL, 'Fibrous sheath-interacting protein 1', 'Fsip1', 4, NULL),
(21226, NULL, 'IPR020236', NULL, 'Uncharacterised protein family YebF', 'Uncharacterised_YebF', 4, NULL),
(21227, NULL, 'IPR017511', NULL, 'PQQ-dependent membrane bound dehydrogenase', 'PQQ_mDH', 4, NULL),
(21228, NULL, 'IPR031304', NULL, 'Transglycosylase SLT domain 2', 'SLT_2', 3, NULL),
(21229, NULL, 'IPR022231', NULL, 'Protein of unknown function DUF3757', 'DUF3757', 4, NULL),
(21230, NULL, 'IPR022191', NULL, 'Protein of unknown function DUF3717', 'DUF3717', 4, NULL),
(21231, NULL, 'IPR016424', NULL, 'Cytochrome B pre-mRNA-processing protein 2', 'Cbp2', 4, NULL),
(21232, NULL, 'IPR020547', NULL, 'ATP synthase epsilon subunit, C-terminal domain', 'ATP_synth_F1_esu_C', 3, NULL),
(21233, NULL, 'IPR018465', NULL, 'Centromere protein Scm3/HJURP', 'Scm3/HJURP', 4, NULL),
(21234, NULL, 'IPR017171', NULL, 'Signal transduction histidine kinase, MctS', 'Sig_transdc_His_kinase_MctS', 4, NULL),
(21235, NULL, 'IPR016718', NULL, 'rRNA (guanine-N1-)-methyltransferase A, predicted', 'rRNA_m1G-MeTrfase_A_prd', 4, NULL),
(21236, NULL, 'IPR017507', NULL, 'Transcription regulator, HipB-like', 'Tscrpt_reg_HipB-like', 4, NULL),
(21237, NULL, 'IPR022247', NULL, 'Casein kinase 1 gamma C-terminal', 'Casein_kinase-1_gamma_C', 3, NULL),
(21238, NULL, 'IPR017508', NULL, 'HipA, N-terminal subdomain 1', 'HipA_N1', 3, NULL),
(21239, NULL, 'IPR017169', NULL, 'Anaphase-promoting complex subunit 4, metazoa', 'APC4_metazoa', 4, NULL),
(21240, NULL, 'IPR017181', NULL, 'Signal transduction histidine kinase, CHASE2 sensor domain-containing, predicted', 'Sig_transdc_His_kin_CHASE2', 4, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(21241, NULL, 'IPR018459', NULL, 'RII binding domain', 'RII-bd_1', 3, NULL),
(21242, NULL, 'IPR026416', NULL, 'Putative folate metabolism gamma-glutamate ligase', 'Fol_metab_g-glu_lig', 4, NULL),
(21243, NULL, 'IPR022446', NULL, 'Conserved hypothetical protein CHP03704, protein-(glutamine-N5) methyltransferase', 'CHP03704_MeTrfrase', 4, NULL),
(21244, NULL, 'IPR016759', NULL, 'HTH-type transcriptional repressor RghR', 'RghR', 4, NULL),
(21245, NULL, 'IPR026410', NULL, 'Oligosaccharyl transferase, archaeal', 'OlisacTrfase_arch', 4, NULL),
(21246, NULL, 'IPR035284', NULL, 'Protein of unknown function DUF5428', 'DUF5428', 4, NULL),
(21247, NULL, 'IPR020533', NULL, 'Developmental regulator, ULTRAPETALA', 'Developmental_reg_ULTRAPETALA', 4, NULL),
(21248, NULL, 'IPR020490', NULL, 'Uncharacterised protein family YaiZ', 'Uncharacterised_YaiZ', 4, NULL),
(21249, NULL, 'IPR022194', NULL, 'Protein of unknown function DUF3719', 'DUF3719', 3, NULL),
(21250, NULL, 'IPR016383', NULL, 'Plasmid transfer regulator TraJ', 'TraJ', 4, NULL),
(21251, NULL, 'IPR019670', NULL, 'Protein of unkown function DUF2523', 'DUF2523', 4, NULL),
(21252, NULL, 'IPR026249', NULL, 'CASTOR family', 'CASTOR_fam', 4, NULL),
(21253, NULL, 'IPR017191', NULL, 'Junctophilin', 'Junctophilin', 4, NULL),
(21254, NULL, 'IPR016743', NULL, 'Nuclear factor interleukin-3-regulated protein', 'NFIL3/E4BP4', 4, NULL),
(21255, NULL, 'IPR018478', NULL, 'Sporulation  transcription regulator WhiA, N-terminal domain', 'Sporu_reg_WhiA_N_dom', 3, NULL),
(21256, NULL, 'IPR020489', NULL, 'Uncharacterised protein family YejG', 'Uncharacterised_YejG', 4, NULL),
(21257, NULL, 'IPR018460', NULL, 'Batten''s disease protein Cln3, subgroup', 'Battenin_disease_Cln3_subgr', 4, NULL),
(21258, NULL, 'IPR019671', NULL, 'Protein of unknown function DUF2526', 'DUF2526', 4, NULL),
(21259, NULL, 'IPR020242', NULL, 'Conotoxin I2-superfamily', 'Conotoxin_I2-superfamily', 4, NULL),
(21260, NULL, 'IPR027145', NULL, 'Periodic tryptophan protein 2', 'PWP2', 4, NULL),
(21261, NULL, 'IPR022201', NULL, 'Protein of unknown function DUF3726', 'DUF3726', 4, NULL),
(21262, NULL, 'IPR022199', NULL, 'Protein of unknown function DUF3725', 'DUF3725', 4, NULL),
(21263, NULL, 'IPR026387', NULL, 'Outer membrane protein', 'OMP_w_GlyGly', 4, NULL),
(21264, NULL, 'IPR022181', NULL, 'Bcl2-/adenovirus E1B 19kDa-interacting protein 2', 'Bcl2-/adenovirus-E1B', 4, NULL),
(21265, NULL, 'IPR022186', NULL, 'Protein of unknown function DUF3713', 'DUF3713', 4, NULL),
(21266, NULL, 'IPR028896', NULL, 'Aminomethyltransferase-like', 'GCST/YgfZ/DmdA', 4, NULL),
(21267, NULL, 'IPR024211', NULL, 'Protein of unknown function DUF3841', 'DUF3841', 4, NULL),
(21268, NULL, 'IPR031805', NULL, 'Piezo domain', 'Piezo_dom', 3, NULL),
(21269, NULL, 'IPR022174', NULL, 'Nuclear coactivator', 'ARA70', 3, NULL),
(21270, NULL, 'IPR016729', NULL, 'FADD', 'FADD', 4, NULL),
(21271, NULL, 'IPR016378', NULL, 'Transcription factor cyclic AMP-dependent, CRE-BP1-type', 'TF_CRE-BP1-typ', 4, NULL),
(21272, NULL, 'IPR031806', NULL, 'Protein of unknown function DUF4744', 'DUF4744', 4, NULL),
(21273, NULL, 'IPR016722', NULL, 'DNA polymerase alpha, subunit B', 'DNA_pol_alpha_bsu', 4, NULL),
(21274, NULL, 'IPR017153', NULL, 'Cytosolic nonspecific dipeptidase/DUG1', 'CNDP/DUG1', 4, NULL),
(21275, NULL, 'IPR034150', NULL, 'SF3B6, RNA recognition motif', 'SF3B6_RRM', 3, NULL),
(21276, NULL, 'IPR026402', NULL, 'Chitooligosaccharide deacetylase NodB', 'Nodulat_NodB', 4, NULL),
(21277, NULL, 'IPR020870', NULL, 'Uncharacterised protein family UPF0387, membrane', 'UPF0387_membrane', 4, NULL),
(21278, NULL, 'IPR026392', NULL, 'Exosortase/Archaeosortase domain', 'Exo/Archaeosortase_dom', 3, NULL),
(21279, NULL, 'IPR022210', NULL, 'Transcription activator GCR1-like domain', 'TF_GCR1-like', 3, NULL),
(21280, NULL, 'IPR026412', NULL, 'Radical SAM peptide maturase, CXXX-repeat target', 'rSAM_Cxxx_rpt', 4, NULL),
(21281, NULL, 'IPR026408', NULL, 'Natural product precursor, GG-Bacteroidales', 'GG_sam_targ_CFB', 3, NULL),
(21282, NULL, 'IPR025173', NULL, 'Protein of unknown function DUF3932', 'DUF3932', 4, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(21283, NULL, 'IPR026422', NULL, 'VPEID-CTERM protein sorting domain', 'VPEID-CTERM', 3, NULL),
(21284, NULL, 'IPR026390', NULL, 'NAD dependent epimerase/dehydratase, LLPSF_EDH_00030 family', 'EDH_00030', 4, NULL),
(21285, NULL, 'IPR022213', NULL, 'Protein of unknown function DUF3742', 'DUF3742', 4, NULL),
(21286, NULL, 'IPR022445', NULL, 'Sortase, proteobacterial type', 'Sortase_proteobact_type', 4, NULL),
(21287, NULL, 'IPR035273', NULL, 'Protein of unknown function DUF5431', 'DUF5431', 4, NULL),
(21288, NULL, 'IPR020301', NULL, 'MIOREX complex component 7', 'Mrx7', 4, NULL),
(21289, NULL, 'IPR022352', NULL, 'Insulin family', 'Insulin_family', 4, NULL),
(21290, NULL, 'IPR024680', NULL, 'Ribulose-1,5-bisphosphate carboxylase small subunit, N-terminal', 'RuBisCO_ssu_N', 3, NULL),
(21291, NULL, 'IPR022407', NULL, 'Oxidoreductase, molybdopterin binding site', 'OxRdtase_Mopterin_BS', 1, NULL),
(21292, NULL, 'IPR026427', NULL, 'Putative peptidyl-prolyl cis-trans isomerase, LIC12922 family', 'Put_pepPro_cis-trans_isomerase', 4, NULL),
(21293, NULL, 'IPR016397', NULL, 'Serpin, predicted, poxvirus', 'Serpin_prd_poxvir', 4, NULL),
(21294, NULL, 'IPR024678', NULL, 'Serine/threonine-protein kinase OSR1/WNK, CCT domain', 'Kinase_OSR1/WNK_CCT', 3, NULL),
(21295, NULL, 'IPR020825', NULL, 'Phenylalanyl-tRNA synthetase-like, B3/B4', 'Phe-tRNA_synthase-like_B3/B4', 5, NULL),
(21296, NULL, 'IPR026395', NULL, 'CshA domain', 'CshA_fibril', 3, NULL),
(21297, NULL, 'IPR020816', NULL, 'Histone-like DNA-binding protein, conserved site', 'Histone-like_DNA-bd_CS', 2, NULL),
(21298, NULL, 'IPR022235', NULL, 'Protein of unknown function DUF3760', 'DUF3760', 4, NULL),
(21299, NULL, 'IPR022173', NULL, 'Protein of unknown function DUF3704', 'DUF3704', 4, NULL),
(21300, NULL, 'IPR016392', NULL, 'Large T antigen, polyomaviridae', 'Lg_T_Ag_polyomavir', 4, NULL),
(21301, NULL, 'IPR017195', NULL, 'ABC-type thiamin-related transport system, permease component 1, predicted', 'ABC_thiamin-permease_prd', 4, NULL),
(21302, NULL, 'IPR016765', NULL, 'Metal-dependent membrane protease, predicted', 'M_metal-dep_Prtase_arc_prd', 4, NULL),
(21303, NULL, 'IPR022204', NULL, 'Prepilin peptidase dependent protein C-like, C-terminal domain', 'PpdC-like_C', 3, NULL),
(21304, NULL, 'IPR024912', NULL, 'Protein translocase subunit SecD, archaeal', 'SecD_arc', 4, NULL),
(21305, NULL, 'IPR026426', NULL, 'Radical SAM peptide maturase, FibroRumin system', 'rSAM_FibroRumin', 4, NULL),
(21306, NULL, 'IPR016433', NULL, 'Small GTPase superfamily, Uncharacterized protein MJ1339', 'Small_GTPase_MJ1339', 4, NULL),
(21307, NULL, 'IPR022212', NULL, 'Domain of unknown function DUF3741', 'DUF3741', 3, NULL),
(21308, NULL, 'IPR017154', NULL, 'PC4-like', 'PC4-like', 4, NULL),
(21309, NULL, 'IPR018467', NULL, 'CO/COL/TOC1, conserved site', 'CCT_CS', 2, NULL),
(21310, NULL, 'IPR022183', NULL, 'Protein of unknown function DUF3710', 'DUF3710', 4, NULL),
(21311, NULL, 'IPR024672', NULL, 'Agglutinin-like protein, N-terminal', 'Agglutinin-like_N', 3, NULL),
(21312, NULL, 'IPR034217', NULL, 'SART3, RNA recognition motif 1', 'SART3_RRM1', 3, NULL),
(21313, NULL, 'IPR018488', NULL, 'Cyclic nucleotide-binding, conserved site', 'cNMP-bd_CS', 2, NULL),
(21314, NULL, 'IPR017189', NULL, 'CTP:phosphocholine cytidylyltransferase', 'CTP-phospocholine_CTT', 4, NULL),
(21315, NULL, 'IPR026377', NULL, 'Cell surface SprA', 'Cell_surface_SprA', 4, NULL),
(21316, NULL, 'IPR024004', NULL, 'Glycosyltransferase family 1, Daro2409 family', 'GlycosylTrfase_Daro2409', 4, NULL),
(21317, NULL, 'IPR017502', NULL, 'Sortase B cell surface sorting signal', 'Sortase_SrtB_target', 3, NULL),
(21318, NULL, 'IPR016387', NULL, 'Mobilization, MobA', 'Mobilization_MobA', 4, NULL),
(21319, NULL, 'IPR016381', NULL, 'Signal transduction histidine kinase, DegS', 'Sig_transdc_His_kinase_DegS', 4, NULL),
(21320, NULL, 'IPR017163', NULL, 'Phosphatidylinositol-4-phosphate 5-kinase, plant', 'PIno-4-P-5_kinase_pln', 4, NULL),
(21321, NULL, 'IPR016386', NULL, 'Plasmid mobilisation, TrbF', 'Plasmid_mob_TrbF', 4, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(21322, NULL, 'IPR022450', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase, TsaD', 'TsaD', 4, NULL),
(21323, NULL, 'IPR022444', NULL, 'Cofactor-binding repeat, putative', 'Cofactor-bd_rpt', 7, NULL),
(21324, NULL, 'IPR016420', NULL, 'Uncharacterised conserved protein UCP004546', 'UCP004546', 4, NULL),
(21325, NULL, 'IPR025177', NULL, 'Cell division inhibitor MciZ', 'MciZ', 4, NULL),
(21326, NULL, 'IPR018479', NULL, 'Monopolin complex subunit Lrs4/Mde4', 'Lrs4/Mde4', 4, NULL),
(21327, NULL, 'IPR025185', NULL, 'Protein of unknown function DUF4120', 'DUF4120', 4, NULL),
(21328, NULL, 'IPR016724', NULL, 'Insulin-related peptide', 'Insulin-rel_pep', 4, NULL),
(21329, NULL, 'IPR022227', NULL, 'Protein of unknown function DUF3754', 'DUF3754', 4, NULL),
(21330, NULL, 'IPR035162', NULL, 'Protein of unknown function DUF5470', 'DUF5470', 4, NULL),
(21331, NULL, 'IPR026389', NULL, 'Protein translocase subunit SecA, Actinobacteria-type', 'SecA_Actinobact_type', 4, NULL),
(21332, NULL, 'IPR020250', NULL, 'Uncharacterised protein family, plasmid pXO2-72', 'Plasmid_pXO2-72', 4, NULL),
(21333, NULL, 'IPR022248', NULL, 'TNF receptor family, RELT', 'TNF_rcpt_RELT', 4, NULL),
(21334, NULL, 'IPR016763', NULL, 'Vesicle-associated membrane-protein-associated protein', 'VAP', 4, NULL),
(21335, NULL, 'IPR018470', NULL, 'Periplasmic metal-binding protein Tp34-type', 'Metal-bd_Tp34-typ', 4, NULL),
(21336, NULL, 'IPR026411', NULL, 'Cyanosortase A-associated protein', 'Cyanosort_A_assoc', 4, NULL),
(21337, NULL, 'IPR028202', NULL, 'Reductase, C-terminal', 'Reductase_C', 3, NULL),
(21338, NULL, 'IPR017184', NULL, 'Serine/threonine-protein kinase Unc-51', 'Ser/Thr_kinase_Unc51', 4, NULL),
(21339, NULL, 'IPR034148', NULL, 'NCBP2, RNA recognition motif', 'NCBP2_RRM', 3, NULL),
(21340, NULL, 'IPR016430', NULL, 'Cytadherence high molecular weight protein 2', 'Cytadherence_Hmw2', 4, NULL),
(21341, NULL, 'IPR032021', NULL, 'Frog antimicrobial peptide, caerin-type, Litoria', 'Frog_Litoria', 4, NULL),
(21342, NULL, 'IPR022203', NULL, 'Protein of unknown function DUF3727', 'DUF3727', 4, NULL),
(21343, NULL, 'IPR022217', NULL, 'Protease inhibitor I10, marinostatin', 'Prot_inh_I10_marinostatin', 4, NULL),
(21344, NULL, 'IPR020300', NULL, 'Protein of unknown function DUF2644', 'DUF2644', 4, NULL),
(21345, NULL, 'IPR016716', NULL, 'Regulator of ribonuclease activity B', 'RraB', 4, NULL),
(21346, NULL, 'IPR034219', NULL, 'ZCRB1, RNA recognition motif', 'ZCRB1_RRM', 3, NULL),
(21347, NULL, 'IPR017178', NULL, '4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase, atypical', 'IspG_atypical', 4, NULL),
(21348, NULL, 'IPR017180', NULL, 'Phosphotransferase system component IIBC, sugar-specific, predicted', 'PTS_IIBC_sugar_specific', 4, NULL),
(21349, NULL, 'IPR020858', NULL, 'Serum albumin-like', 'Serum_albumin-like', 5, NULL),
(21350, NULL, 'IPR018472', NULL, 'Growth arrest/ DNA-damage-inducible protein-interacting protein 1', 'Damage-induce-interacting_prot', 4, NULL),
(21351, NULL, 'IPR022225', NULL, 'Phage tail fibre protein', 'Phage_tail_fibre', 4, NULL),
(21352, NULL, 'IPR017166', NULL, 'Uncharacterised conserved protein UCP037290', 'UCP037290', 4, NULL),
(21353, NULL, 'IPR026415', NULL, 'UDP-N-acetylglucosamine 4,6-dehydratase/5-epimerase', 'FnlA', 4, NULL),
(21354, NULL, 'IPR020484', NULL, 'Protein of unknown function DUF5503', 'DUF5503', 4, NULL),
(21355, NULL, 'IPR025176', NULL, 'Protein of unknown function DUF3935', 'DUF3935', 4, NULL),
(21356, NULL, 'IPR022405', NULL, 'Diphtheria toxin, translocation domain', 'Diphtheria_toxin_translocation', 3, NULL),
(21357, NULL, 'IPR024674', NULL, 'HpaB/PvcC/4-BUDH N-terminal', 'HpaB/PvcC/4-BUDH_N', 3, NULL),
(21358, NULL, 'IPR016385', NULL, 'Conjugal transfer repressor TrbA', 'Conjugal_tfr_repressor_TrbA', 4, NULL),
(21359, NULL, 'IPR026428', NULL, 'VPXXXP-CTERM protein sorting domain', 'VPxxxP_CTERM', 3, NULL),
(21360, NULL, 'IPR034220', NULL, 'RBM34, RNA recognition motif 1', 'RBM34_RRM1', 3, NULL),
(21361, NULL, 'IPR016418', NULL, 'Uncharacterised conserved protein UCP004509, Rem', 'UCP004509_Rem', 4, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(21362, NULL, 'IPR022255', NULL, 'PHD finger protein 20, AT hook', 'PHF20_AT-hook', 3, NULL),
(21363, NULL, 'IPR031804', NULL, 'Domain of unknown function DUF4743', 'DUF4743', 3, NULL),
(21364, NULL, 'IPR022298', NULL, 'Conjugative transposon, TraN', 'Conjug_transposon_TraN', 4, NULL),
(21365, NULL, 'IPR026404', NULL, 'Radical SAM enzyme, rSAM/lipoprotein system', 'rSAM_w_lipo', 4, NULL),
(21366, NULL, 'IPR026406', NULL, 'Verrucomicrobia /Planctomycetes-restricted protein', 'Ver/Plancto_CHP', 4, NULL),
(21367, NULL, 'IPR022346', NULL, 'General secretion pathway, GspH', 'T2SS_GspH', 3, NULL),
(21368, NULL, 'IPR025171', NULL, 'Protein of unknown function DUF3929', 'DUF3929', 4, NULL),
(21369, NULL, 'IPR035359', NULL, 'Protein of unknown function DUF5421', 'DUF5421', 4, NULL),
(21370, NULL, 'IPR034147', NULL, 'RBM40, RNA recognition motif 1', 'RBM40_RRM1', 3, NULL),
(21371, NULL, 'IPR022408', NULL, 'Acyl-CoA-binding protein, ACBP, conserved site', 'Acyl-CoA-binding_prot_CS', 2, NULL),
(21372, NULL, 'IPR026431', NULL, 'Methanobactin biosynthesis cassette protein MbnB', 'Methbact_MbnB', 4, NULL),
(21373, NULL, 'IPR022196', NULL, 'Protein of unknown function DUF3721', 'DUF3721', 4, NULL),
(21374, NULL, 'IPR017501', NULL, 'Phage infection protein, YhgE, C-terminal', 'Phage_infect_YhgE_C', 3, NULL),
(21375, NULL, 'IPR016411', NULL, 'Single-stranded DNA-binding protein, bacteriophage T7', 'SSB_T7', 4, NULL),
(21376, NULL, 'IPR026419', NULL, 'Glycosyltransferase, GG-Bacteroidales peptide system', 'Glyco_rSAM_CFB', 4, NULL),
(21377, NULL, 'IPR034285', NULL, 'Laccase, second cupredoxin domain', 'CuRO_2_LCC', 3, NULL),
(21378, NULL, 'IPR021159', NULL, 'Glycerate/sugar phosphate transporter, conserved site', 'Sugar-P_transporter_CS', 2, NULL),
(21379, NULL, 'IPR022208', NULL, 'Protein of unknown function DUF3737', 'DUF3737', 4, NULL),
(21380, NULL, 'IPR020874', NULL, 'NAD(P)H-quinone oxidoreductase, subunit N', 'NAD(P)H-quinone_OxRdtase_su_N', 4, NULL),
(21381, NULL, 'IPR016750', NULL, 'Acetophenone carboxylase beta subunit/Acetone carboxylase gamma subunit', 'Aceto_COase_bsu/gsu', 4, NULL),
(21382, NULL, 'IPR027287', NULL, 'Flavivirus glycoprotein E, immunoglobulin-like domain', 'Flavi_E_Ig-like', 3, NULL),
(21383, NULL, 'IPR016762', NULL, 'Uncharacterised conserved protein UCP019464, methanogenesis', 'UCP019464_methan', 4, NULL),
(21384, NULL, 'IPR022423', NULL, 'Neurohypophysial hormone, conserved site', 'Neurohypophysial_hormone_CS', 2, NULL),
(21385, NULL, 'IPR016431', NULL, 'Pyruvate-formate lyase-activating enzyme, predicted', 'Pyrv-formate_lyase-activ_prd', 4, NULL),
(21386, NULL, 'IPR022190', NULL, 'Protein of unknown function DUF3716', 'DUF3716', 4, NULL),
(21387, NULL, 'IPR016419', NULL, 'Prepilin peptidase-dependent protein B, predicted', 'Prepilin_Pept-dep_B_prd', 4, NULL),
(21388, NULL, 'IPR024910', NULL, 'Trans-2-enoyl-CoA reductase catalytic domain, putative', 'Enoyl-CoA_Rdtase_cat_dom', 3, NULL),
(21389, NULL, 'IPR025169', NULL, 'Protein of unknown function DUF3927', 'DUF3927', 4, NULL),
(21390, NULL, 'IPR022223', NULL, 'Protein of unknown function DUF3748', 'DUF3748', 4, NULL),
(21391, NULL, 'IPR016417', NULL, 'Spanin, inner membrane subunit, T7likevirus-type', 'I-spanin_T7likevirus', 4, NULL),
(21392, NULL, 'IPR026429', NULL, '3-methyl-2-indolic acid synthase', 'MIA_synthase', 4, NULL),
(21393, NULL, 'IPR018468', NULL, 'SFR1/Mei5 family', 'SFR1/Mei5', 4, NULL),
(21394, NULL, 'IPR020808', NULL, 'Bacterial microcompartments protein, conserved site', 'Bact_microcomp_CS', 2, NULL),
(21395, NULL, 'IPR035164', NULL, 'Cupiennin', 'Cupiennin', 4, NULL),
(21396, NULL, 'IPR022218', NULL, 'ToxR activated gene A lipoprotein domain', 'TagA_dom', 3, NULL),
(21397, NULL, 'IPR022449', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase Kae1, archaea', 'Kae1_arc', 4, NULL),
(21398, NULL, 'IPR016756', NULL, 'Metal-dependent hydrolase, membrane-bound predicted', 'Metal-dep_Ohase_Mem-prd', 4, NULL),
(21399, NULL, 'IPR017156', NULL, 'Carboxysome assembly protein CcmM', 'CcmM', 4, NULL),
(21400, NULL, 'IPR022286', NULL, 'ABC transporter, F420-0 import, ATP-binding protein, predicted', 'ABC_trnsptr_F420-0_ATP-bd_pred', 4, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(21401, NULL, 'IPR018422', NULL, 'Cation/H+ exchanger, CPA1 family', 'Cation/H_exchanger_CPA1', 4, NULL),
(21402, NULL, 'IPR020856', NULL, 'Circadian clock protein KaiA, C-terminal', 'Circadian_clock_protein_KaiA_C', 3, NULL),
(21403, NULL, 'IPR016769', NULL, 'Bacteriophage SP01, Orf1', 'Phage_SP01_Orf1', 4, NULL),
(21404, NULL, 'IPR020783', NULL, 'Ribosomal protein L11, C-terminal', 'Ribosomal_L11_C', 3, NULL),
(21405, NULL, 'IPR026532', NULL, 'Ribosome biogenesis protein BRX1', 'BRX1', 4, NULL),
(21406, NULL, 'IPR022249', NULL, 'Domain of unknown function DUF3772', 'DUF3772', 3, NULL),
(21407, NULL, 'IPR020693', NULL, 'Tyrosine-protein kinase, non-receptor Jak2', 'Tyr_kinase_non-rcpt_Jak2', 4, NULL),
(21408, NULL, 'IPR022254', NULL, 'Protein of unknown function DUF3775', 'DUF3775', 4, NULL),
(21409, NULL, 'IPR017512', NULL, 'PQQ-dependent dehydrogenase, methanol/ethanol family', 'PQQ_MeOH/EtOH_DH', 4, NULL),
(21410, NULL, 'IPR022242', NULL, '87kDa Transposase', '87kDa_transposase', 4, NULL),
(21411, NULL, 'IPR016422', NULL, 'Replication-associated protein RepA4', 'Rep_assoc_RepA4', 4, NULL),
(21412, NULL, 'IPR020855', NULL, 'Ureohydrolase, manganese-binding site', 'Ureohydrolase_Mn_BS', 1, NULL),
(21413, NULL, 'IPR020241', NULL, 'Ribonuclease P/MRP subunit Pop7, fungi', 'RNase_P/MRP_Pop7_fungi', 4, NULL),
(21414, NULL, 'IPR016720', NULL, 'Phosphatidate cytidylyltransferase, eukaryota', 'PC_Trfase_euk', 4, NULL),
(21415, NULL, 'IPR022198', NULL, 'Protein of unknown function DUF3723', 'DUF3723', 4, NULL),
(21416, NULL, 'IPR022287', NULL, 'ABC transporter, F420-0 import, periplasmic substrate-binding protein, predicted', 'ABC_trnsptr_F420-0_sub-bd_pred', 4, NULL),
(21417, NULL, 'IPR026409', NULL, 'Firmicu-CTERM domain', 'Firmicu_CTERM', 3, NULL),
(21418, NULL, 'IPR016723', NULL, 'Transcription regulator, ArsR, predicted', 'Tscrpt_reg_ArsR_prd', 4, NULL),
(21419, NULL, 'IPR017513', NULL, 'Conserved hypothetical protein CHP03076, glycine cleavage', 'CHP03076_Gly-cleavage', 4, NULL),
(21420, NULL, 'IPR034215', NULL, 'RBM42, RNA recognition motif', 'RBM42_RRM', 3, NULL),
(21421, NULL, 'IPR023113', NULL, 'Telomere-binding protein, beta subunit domain superfamily', 'TEBP_beta_dom_sf', 5, NULL),
(21422, NULL, 'IPR022237', NULL, 'L-tryptophan decarboxylase PsiD-like', 'PsiD-like', 3, NULL),
(21423, NULL, 'IPR017164', NULL, 'Wee1-like protein kinase', 'Wee1-like_protein_kinase', 4, NULL),
(21424, NULL, 'IPR034218', NULL, 'SART3, RNA recognition motif 2', 'SART3_RRM2', 3, NULL),
(21425, NULL, 'IPR020483', NULL, 'Uncharacterised protein family YgbA', 'Uncharacterised_YgbA', 4, NULL),
(21426, NULL, 'IPR024213', NULL, 'Protein of unknown function DUF3822', 'DUF3822', 4, NULL),
(21427, NULL, 'IPR022366', NULL, 'Pup deamidase', 'Pup_deamidase', 4, NULL),
(21428, NULL, 'IPR020826', NULL, 'Transketolase binding site', 'Transketolase_BS', 1, NULL),
(21429, NULL, 'IPR020548', NULL, 'Fructose-1,6-bisphosphatase, active site', 'Fructose_bisphosphatase_AS', 0, NULL),
(21430, NULL, 'IPR022309', NULL, 'Ribosomal protein S8e/ribosomal biogenesis NSA2', 'Ribosomal_S8e/biogenesis_NSA2', 4, NULL),
(21431, NULL, 'IPR017157', NULL, 'Arylacetamide deacetylase', 'Arylacetamide_deacetylase', 4, NULL),
(21432, NULL, 'IPR016398', NULL, 'E3 ubiquitin-protein ligase p28', 'E3_ubiquitin-prot_ligase_p28', 4, NULL),
(21433, NULL, 'IPR024212', NULL, 'Domain of unknown function DUF3837', 'DUF3837', 3, NULL),
(21434, NULL, 'IPR016764', NULL, 'Methyltransferase Mtx, subunit X', 'MeTrfase_MtxX_xsu', 4, NULL),
(21435, NULL, 'IPR017170', NULL, 'Lhr-like ATP-dependent RNA helicase, predicted', 'Lhr-like_ATP-dep_RNA_helic_prd', 4, NULL),
(21436, NULL, 'IPR022244', NULL, 'Protein of unknown function DUF3769', 'DUF3769', 4, NULL),
(21437, NULL, 'IPR026421', NULL, 'Modified peptide precursor CbpA', 'Mod_peptide_prec_CbpA', 4, NULL),
(21438, NULL, 'IPR020805', NULL, 'Cell division protein FtsZ, conserved site', 'Cell_div_FtsZ_CS', 2, NULL),
(21439, NULL, 'IPR016415', NULL, 'Bacteriophage T4, Prohead assembly protein gp68', 'Phage_T4_Gp68', 4, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(21440, NULL, 'IPR017192', NULL, 'Thiosulphate:quinone oxidoreductase, fused subunit DoxA/ DoxD', 'ThioSO4-Q_OxRdtase_DoxA/D', 4, NULL),
(21441, NULL, 'IPR022236', NULL, 'Protein of unknown function DUF3761', 'DUF3761', 4, NULL),
(21442, NULL, 'IPR026191', NULL, 'Ligand-dependent nuclear receptor-interacting factor 1', 'LRIF1', 4, NULL),
(21443, NULL, 'IPR022233', NULL, 'TRAPP II complex TRAPPC10, C-terminal', 'TRAPP_II_complex_TRAPPC10_C', 3, NULL),
(21444, NULL, 'IPR026425', NULL, 'Cys-rich radical SAM target, FibroRumin family', 'FibroRuminTarg', 4, NULL),
(21445, NULL, 'IPR022224', NULL, 'Protein of unknown function DUF3750', 'DUF3750', 4, NULL),
(21446, NULL, 'IPR022230', NULL, 'Protein of unknown function DUF3756', 'DUF3756', 4, NULL),
(21447, NULL, 'IPR034109', NULL, 'Sm-like protein Lsm11, middle domain', 'Lsm11_M', 3, NULL),
(21448, NULL, 'IPR017505', NULL, 'Sortase B signal domain, NPQTN class', 'Sortase_SrtB_sig_NPQTN', 3, NULL),
(21449, NULL, 'IPR026245', NULL, 'Protein FRG2', 'FRG2', 4, NULL),
(21450, NULL, 'IPR022214', NULL, 'Mitotic-spindle organizing protein 1', 'MZT1', 4, NULL),
(21451, NULL, 'IPR025174', NULL, 'Protein of unknown function DUF3933', 'DUF3933', 4, NULL),
(21452, NULL, 'IPR022205', NULL, 'Protein of unknown function DUF3732', 'DUF3732', 4, NULL),
(21453, NULL, 'IPR016728', NULL, 'Neuroblastoma suppressor of tumourigenicity 1', 'Neuroblast_suppress_tumour_1', 4, NULL),
(21454, NULL, 'IPR017197', NULL, 'Bone morphogenetic protein 3/3B', 'BMP3/BMP3B', 4, NULL),
(21455, NULL, 'IPR016771', NULL, 'Fe-S oxidoreductase, radical SAM domain-containing, TM0948, predicted', 'Fe-S_OxRdtase_rSAM_TM0948_prd', 4, NULL),
(21456, NULL, 'IPR024002', NULL, 'Formate/nitrite transporter, conserved site', 'For/NO2_transpt_CS', 2, NULL),
(21457, NULL, 'IPR016740', NULL, 'Uncharacterised conserved protein UCP018938', 'UCP018938', 4, NULL),
(21458, NULL, 'IPR035992', NULL, 'Ricin B-like lectins', 'Ricin_B-like_lectins', 5, NULL),
(21459, NULL, 'IPR017198', NULL, 'DNA (cytosine-5)-methyltransferase 1-like', 'DNMT1-like', 4, NULL),
(21460, NULL, 'IPR022406', NULL, 'Diphtheria toxin, catalytic domain', 'Diphtheria_toxin_catalytic_dom', 3, NULL),
(21461, NULL, 'IPR022175', NULL, 'BCAS3 domain', 'BCAS3', 3, NULL),
(21462, NULL, 'IPR022192', NULL, 'Mitochondrial degradasome RNA helicase subunit, C-terminal domain', 'SUV3_C', 3, NULL),
(21463, NULL, 'IPR016721', NULL, 'Bet3 family', 'Bet3', 4, NULL),
(21464, NULL, 'IPR030911', NULL, 'Accessory Sec system S-layer assembly protein', 'Sec_acc_SLAP', 4, NULL),
(21465, NULL, 'IPR020309', NULL, 'Uncharacterised protein family, CD034/YQF4', 'Uncharacterised_CD034/YQF4', 4, NULL),
(21466, NULL, 'IPR022182', NULL, 'ABC transporter phosphate permease PstC, N-terminal domain', 'PstC_N', 3, NULL),
(21467, NULL, 'IPR017177', NULL, 'Alpha-(1, 3)-fucosyltransferase/alpha-(1, 4)-fucosyltransferase, plant', 'Alpha-1_3/4-FUT_pln', 4, NULL),
(21468, NULL, 'IPR022179', NULL, 'Cilia- and flagella-associated protein 276', 'CFAP276', 4, NULL),
(21469, NULL, 'IPR016752', NULL, 'Uncharacterised conserved protein UCP019240, SpoVT/AbrB-related', 'UCP019240_SpoVT/AbrB-related', 4, NULL),
(21470, NULL, 'IPR016733', NULL, 'Uncharacterised conserved protein UCP018747', 'UCP018747', 4, NULL),
(21471, NULL, 'IPR016739', NULL, 'Uncharacterised conserved protein UCP018933', 'UCP018933', 4, NULL),
(21472, NULL, 'IPR026418', NULL, 'Pseudo-rSAM protein, GG-Bacteroidales system', 'Pseudo_rSAM', 4, NULL),
(21473, NULL, 'IPR026181', NULL, 'Transmembrane protein 40', 'TMEM40', 4, NULL),
(21474, NULL, 'IPR016400', NULL, 'Rev protein, Ovine/caprine lentivirus', 'Rev_lentivir', 4, NULL),
(21475, NULL, 'IPR020246', NULL, 'Uncharacterised protein family SCO3924', 'Uncharacterised_SCO3924', 4, NULL),
(21476, NULL, 'IPR022246', NULL, 'Bacteriophage T7, Gp17, C-terminal', 'Phage_T7_Gp17_C', 3, NULL),
(21477, NULL, 'IPR017504', NULL, 'Conserved hypothetical protein CHP03067, planctomycetes', 'CHP03067_Planctomycetes', 3, NULL),
(21478, NULL, 'IPR017158', NULL, 'Transcription regulator, CBS domain-containing, predicted', 'Tscrpt-reg_CBS-contain_prd', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(21479, NULL, 'IPR016754', NULL, 'Uncharacterised conserved protein UCP019262', 'UCP019262', 4, NULL),
(21480, NULL, 'IPR016427', NULL, 'Uncharacterised conserved protein UCP004699, CBS/ParB-like', 'UCP004699_CBS/ParB', 4, NULL),
(21481, NULL, 'IPR020257', NULL, 'Protein of unknown function DUF5512', 'DUF5512', 4, NULL),
(21482, NULL, 'IPR016736', NULL, 'Uncharacterised protein MJ1481, archaea', 'MJ1481_archaea', 4, NULL),
(21483, NULL, 'IPR017194', NULL, 'Transforming growth factor-beta receptor, type II', 'Transform_growth_fac-b_typ-2', 4, NULL),
(21484, NULL, 'IPR022253', NULL, 'Ribosome recycling factor. bacterial', 'Ribosome_recyc_fac_bac', 4, NULL),
(21485, NULL, 'IPR029283', NULL, 'Calcium-dependent cell adhesion molecule 1, membrane-binding domain', 'Membrane-bd', 3, NULL),
(21486, NULL, 'IPR018483', NULL, 'Carbohydrate kinase, FGGY, conserved site', 'Carb_kinase_FGGY_CS', 2, NULL),
(21487, NULL, 'IPR028238', NULL, 'Bacterial toxin 46', 'Ntox46', 3, NULL),
(21488, NULL, 'IPR022172', NULL, 'Protein of unknown function DUF3703', 'DUF3703', 4, NULL),
(21489, NULL, 'IPR024812', NULL, 'Tetratricopeptide repeat protein 24', 'TPR_24', 4, NULL),
(21490, NULL, 'IPR034211', NULL, 'PUF60, RNA recognition motif 2', 'PUF60_RRM2', 3, NULL),
(21491, NULL, 'IPR024665', NULL, 'Thrombospondin/cartilage oligomeric matrix protein, coiled-coil domain', 'Thbs/COMP_coiled-coil', 3, NULL),
(21492, NULL, 'IPR016408', NULL, 'Bacteriophage phi-29, Gp1', 'Phage_phi-29_Gp1', 4, NULL),
(21493, NULL, 'IPR026430', NULL, 'Archaeosortase B', 'Archaeosortase_B', 4, NULL),
(21494, NULL, 'IPR016399', NULL, 'Apoptosis regulator, M-T4, endoplasmic reticulum', 'Apoptosis_reg_M-T4_ER', 4, NULL),
(21495, NULL, 'IPR017159', NULL, 'Gremlin-1/2', 'Gremlin-1/2', 4, NULL),
(21496, NULL, 'IPR020265', NULL, 'Protein of unknown function DUF5513', 'DUF5513', 4, NULL),
(21497, NULL, 'IPR016727', NULL, 'ATPase, V0 complex, subunit d', 'ATPase_V0-cplx_dsu', 4, NULL),
(21498, NULL, 'IPR020873', NULL, '3''-5'' exoribonuclease YhaM', '3''-5''_exoribonuclease_YhaM', 4, NULL),
(21499, NULL, 'IPR035271', NULL, 'Protein of unknown function DUF5432', 'DUF5432', 4, NULL),
(21500, NULL, 'IPR034266', NULL, 'Ephrin type-A receptor 3, ligand binding domain', 'EphA3_rcpt_lig-bd', 3, NULL),
(21501, NULL, 'IPR025374', NULL, 'Protein of unknown function DUF4364', 'DUF4364', 4, NULL),
(21502, NULL, 'IPR029329', NULL, 'Domain of unknown function DUF4472', 'DUF4472', 3, NULL),
(21503, NULL, 'IPR032473', NULL, 'Protein argonaute, Mid domain', 'Argonaute_Mid_dom', 3, NULL),
(21504, NULL, 'IPR031321', NULL, 'Uncharacterised conserved protein UCP012641, putative zinc-binding metallo-peptidase', 'UCP012641', 4, NULL),
(21505, NULL, 'IPR025898', NULL, 'Tc3 transposase, DNA binding domain', 'Tc3_transposase_DNA-bd_dom', 3, NULL),
(21506, NULL, 'IPR032559', NULL, 'Protein of unknown function DUF4933', 'DUF4933', 4, NULL),
(21507, NULL, 'IPR030841', NULL, 'Endonuclease III-like protein 1', 'NTH1', 4, NULL),
(21508, NULL, 'IPR026298', NULL, 'Bcl-2 family', 'Bcl-2_fam', 4, NULL),
(21509, NULL, 'IPR032569', NULL, 'Nucleophosmin, C-terminal', 'NPM1_C', 3, NULL),
(21510, NULL, 'IPR027414', NULL, 'Glycosyl hydrolase family 95, N-terminal domain', 'GH95_N_dom', 3, NULL),
(21511, NULL, 'IPR032582', NULL, 'Protein of unknown function DUF4916', 'DUF4916', 4, NULL),
(21512, NULL, 'IPR032744', NULL, 'Insulin growth factor-like family', 'IGFL', 4, NULL),
(21513, NULL, 'IPR029264', NULL, 'ARF7 effector protein, C-terminal', 'ARF7EP_C', 3, NULL),
(21514, NULL, 'IPR028878', NULL, 'Ribonuclease E', 'RNase_E', 4, NULL),
(21515, NULL, 'IPR032634', NULL, 'Gef2/Nod1 domain', 'Gef2/Nod1_dom', 3, NULL),
(21516, NULL, 'IPR030848', NULL, 'Elongation factor G, chloroplastic', 'EF_G_plantC', 4, NULL),
(21517, NULL, 'IPR031962', NULL, 'Domain of unknown function DUF4781', 'DUF4781', 3, NULL),
(21518, NULL, 'IPR025399', NULL, 'Domain of unknown function DUF4372', 'DUF4372', 3, NULL),
(21519, NULL, 'IPR028127', NULL, 'Ripply family', 'Ripply_fam', 4, NULL),
(21520, NULL, 'IPR032640', NULL, 'AMP-activated protein kinase, glycogen-binding domain', 'AMPK1_CBM', 3, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(21521, NULL, 'IPR029414', NULL, 'Tricorn protease, PDZ domain', 'Tricorn_PDZ', 3, NULL),
(21522, NULL, 'IPR026718', NULL, 'Leucine zipper protein 2', 'Luzp2', 4, NULL),
(21523, NULL, 'IPR028244', NULL, 'Putative type VI secretion system, Rhs element associated Vgr domain', 'T6SS_Rhs_Vgr_dom', 3, NULL),
(21524, NULL, 'IPR032557', NULL, 'PIN domain (DUF4935)', 'DUF4935', 3, NULL),
(21525, NULL, 'IPR027728', NULL, 'Topless family', 'Topless_fam', 4, NULL),
(21526, NULL, 'IPR028877', NULL, '50S ribosomal protein L18Ae/60S ribosomal protein L20 and L18a', '50S_L18Ae/Ribosomal_L18a/L20', 4, NULL),
(21527, NULL, 'IPR029251', NULL, 'Fanconi anemia-associated protein of 100kDa', 'Faap100', 4, NULL),
(21528, NULL, 'IPR028038', NULL, 'TM140 protein family', 'TM140', 4, NULL),
(21529, NULL, 'IPR032826', NULL, 'Flagellin, H7-serospecific domain', 'FliC_H7', 3, NULL),
(21530, NULL, 'IPR030851', NULL, 'Ribosome-releasing factor 2, mitochondrial', 'EFG2', 4, NULL),
(21531, NULL, 'IPR032637', NULL, 'Putative phage holin-like', 'Phage_holin-like', 4, NULL),
(21532, NULL, 'IPR025200', NULL, 'Polyphosphate kinase C-terminal domain 2', 'PPK_C_dom2', 3, NULL),
(21533, NULL, 'IPR028344', NULL, 'Toxin-antitoxin system, toxin component ParE1/4', 'ParE1/4', 4, NULL),
(21534, NULL, 'IPR032399', NULL, 'RelB leucine zipper', 'RelB_leu_zip', 3, NULL),
(21535, NULL, 'IPR024568', NULL, 'Ribonuclease HIII, N-terminal', 'RNase_HIII_N', 3, NULL),
(21536, NULL, 'IPR032579', NULL, 'DNA glycosylase Phe SMUG2-like', 'Phe_SMUG2-like', 4, NULL),
(21537, NULL, 'IPR031248', NULL, 'E3 ubiquitin-protein ligase RNF213', 'RNF213', 4, NULL),
(21538, NULL, 'IPR031368', NULL, 'Spermatid maturation protein 1, N-terminal', 'SPEM1_N', 3, NULL),
(21539, NULL, 'IPR024556', NULL, 'Protein of unknown function DUF3599', 'DUF3599', 4, NULL),
(21540, NULL, 'IPR029195', NULL, 'Host cell factor C1 regulator 1', 'HCFC1R1', 4, NULL),
(21541, NULL, 'IPR032743', NULL, 'FAM47 family', 'FAM47', 4, NULL),
(21542, NULL, 'IPR032815', NULL, 'Peptidase S8, pro-domain', 'S8_pro-domain', 3, NULL),
(21543, NULL, 'IPR029164', NULL, 'Phosphatidylinositol N-acetylglucosaminyltransferase subunit Y', 'PIG-Y', 4, NULL),
(21544, NULL, 'IPR032565', NULL, 'Nuclear receptor coactivator 2/3,  DUF4927', 'NCOA2/3_DUF4927', 3, NULL),
(21545, NULL, 'IPR032570', NULL, 'Splicing factor 1, helix-hairpin domain', 'SF1-HH', 3, NULL),
(21546, NULL, 'IPR032571', NULL, 'KHDRBS, Qua1 domain', 'Qua1_dom', 3, NULL),
(21547, NULL, 'IPR029250', NULL, 'Protein of unknown function DUF4571', 'DUF4571', 4, NULL),
(21548, NULL, 'IPR032566', NULL, 'Aprataxin, C2HE/C2H2/C2HC zinc finger', 'Znf-C2HE', 3, NULL),
(21549, NULL, 'IPR029014', NULL, '[NiFe]-hydrogenase, large subunit', 'NiFe-Hase_large', 5, NULL),
(21550, NULL, 'IPR025377', NULL, 'Domain of unknown function DUF4367', 'DUF4367', 3, NULL),
(21551, NULL, 'IPR032585', NULL, 'Protein of unknown function DUF4912', 'DUF4912', 4, NULL),
(21552, NULL, 'IPR032583', NULL, 'Protein of unknown function DUF4914', 'DUF4914', 4, NULL),
(21553, NULL, 'IPR028149', NULL, 'Tantalus-like', 'Tantalus-like', 3, NULL),
(21554, NULL, 'IPR024567', NULL, 'Ribonuclease HII/HIII domain', 'RNase_HII/HIII_dom', 3, NULL),
(21555, NULL, 'IPR030993', NULL, 'Violacein biosynthesis protein  VioB', 'VioB', 4, NULL),
(21556, NULL, 'IPR031108', NULL, 'FeS assembly protein IscA, plant/cyanobacteria type', 'ISCA_plant_cyanobact', 4, NULL),
(21557, NULL, 'IPR034067', NULL, 'Serine protease KerA-like, domain', 'Serine_protease_KerA-like_dom', 3, NULL),
(21558, NULL, 'IPR030807', NULL, 'Putative sugar O-methyltransferase', 'Methyltran_NanM', 4, NULL),
(21559, NULL, 'IPR028765', NULL, 'IQ calmodulin-binding motif-containing protein 1', 'IQCB1', 4, NULL),
(21560, NULL, 'IPR027362', NULL, 'DNA topoisomerase I, C-terminal', 'TopoI_C', 5, NULL),
(21561, NULL, 'IPR027395', NULL, 'Winged helix DNA-binding domain', 'WH_DNA-bd_dom', 3, NULL),
(21562, NULL, 'IPR031366', NULL, 'Protein of unknown function DUF4663', 'DUF4663', 4, NULL),
(21563, NULL, 'IPR029252', NULL, 'Regulator of cell cycle RGCC', 'RGCC', 4, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(21564, NULL, 'IPR032817', NULL, 'Mon2, C-terminal', 'Mon2_C', 3, NULL),
(21565, NULL, 'IPR027411', NULL, 'Baseplate structural protein Gp9/Gp10 middle domain superfamily', 'Gp9/Gp10_mid_dom_sf', 5, NULL),
(21566, NULL, 'IPR030394', NULL, 'HflX-type guanine nucleotide-binding (G) domain', 'G_HFLX_dom', 3, NULL),
(21567, NULL, 'IPR032793', NULL, 'Type II restriction endonuclease EcoO109IR', 'RE_EcoO109IR', 3, NULL),
(21568, NULL, 'IPR032636', NULL, 'Pilus assembly protein, E-set like domain', 'Pilus_assem_E-set-like_dom', 3, NULL),
(21569, NULL, 'IPR030843', NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', 'PAN2', 4, NULL),
(21570, NULL, 'IPR024573', NULL, 'Domain of unknown function DUF3333', 'DUF3333', 3, NULL),
(21571, NULL, 'IPR031162', NULL, 'CBP/p300-type histone acetyltransferase domain', 'CBP_P300_HAT', 3, NULL),
(21572, NULL, 'IPR029192', NULL, 'Spermatogenesis-associated protein 25', 'SPATA25', 4, NULL),
(21573, NULL, 'IPR025882', NULL, 'Toxin Fst', 'Toxin_Fst', 4, NULL),
(21574, NULL, 'IPR026570', NULL, 'Coiled-coil domain-containing protein 86', 'CCDC86', 4, NULL),
(21575, NULL, 'IPR032690', NULL, 'CDP-archaeol synthase', 'CarS', 4, NULL),
(21576, NULL, 'IPR024456', NULL, 'Integrase catalytic domain, putative', 'Integrase_catalytic_putative', 3, NULL),
(21577, NULL, 'IPR029263', NULL, 'Respiratory nitrate reductase beta, C-terminal', 'Nitr_red_bet_C', 3, NULL),
(21578, NULL, 'IPR029253', NULL, 'Cytokine-like protein 1', 'CYTL1', 4, NULL),
(21579, NULL, 'IPR025208', NULL, 'NFkB-p65-degrading zinc protease', 'Peptidase_M85', 4, NULL),
(21580, NULL, 'IPR032471', NULL, 'GAIN domain, N-terminal', 'GAIN_dom_N', 3, NULL),
(21581, NULL, 'IPR026074', NULL, 'Microtubule associated protein 1', 'MAP1', 4, NULL),
(21582, NULL, 'IPR024467', NULL, 'Antitoxin Xre/MbcA/ParS-like, toxin-binding domain', 'Xre/MbcA/ParS-like_toxin-bd', 3, NULL),
(21583, NULL, 'IPR028435', NULL, 'Plakophilin/Delta catenin', 'Plakophilin/d_Catenin', 4, NULL),
(21584, NULL, 'IPR028588', NULL, 'Thiol:disulfide interchange protein DsbL', 'DsbL', 4, NULL),
(21585, NULL, 'IPR024466', NULL, 'Conserved hypothetical protein CHP02679, N terminus', 'CHP02679_N', 3, NULL),
(21586, NULL, 'IPR029235', NULL, 'Protein of unknown function DUF4619', 'DUF4619', 4, NULL),
(21587, NULL, 'IPR027822', NULL, 'Protein of unknown function DUF4641', 'DUF4641', 4, NULL),
(21588, NULL, 'IPR027407', NULL, 'Manganese catalase, C-terminal', 'Mn_catalase_C', 5, NULL),
(21589, NULL, 'IPR027231', NULL, 'Semaphorin', 'Semaphorin', 4, NULL),
(21590, NULL, 'IPR032561', NULL, 'Protein of unknown function DUF4930', 'DUF4930', 4, NULL),
(21591, NULL, 'IPR026715', NULL, 'Speriolin', 'SPATC1', 4, NULL),
(21592, NULL, 'IPR032740', NULL, 'SGNH hydrolase-type esterase, N-terminal', 'GxDLY', 3, NULL),
(21593, NULL, 'IPR024576', NULL, 'Ribosomal RNA methyltransferase Spb1, domain of unknown function DUF3381', 'rRNA_MeTfrase_Spb1_DUF3381', 3, NULL),
(21594, NULL, 'IPR025191', NULL, 'Protein of unknown function DUF4125', 'DUF4125', 4, NULL),
(21595, NULL, 'IPR031367', NULL, 'Coiled-coil domain-containing protein 24', 'CCDC24', 4, NULL),
(21596, NULL, 'IPR032707', NULL, 'MYCBP-associated protein', 'MYCBPAP', 4, NULL),
(21597, NULL, 'IPR032472', NULL, 'Argonaute linker 2 domain', 'ArgoL2', 3, NULL),
(21598, NULL, 'IPR030475', NULL, 'Ribonucleotide reductase small subunit, acitve site', 'RNR_small_AS', 0, NULL),
(21599, NULL, 'IPR028147', NULL, 'Neuropeptide-like protein', 'Neuropep-like', 4, NULL),
(21600, NULL, 'IPR025376', NULL, 'Domain of unknown function DUF4366', 'DUF4366', 3, NULL),
(21601, NULL, 'IPR032491', NULL, 'Domain of unknown function DUF5046', 'DUF5046', 3, NULL),
(21602, NULL, 'IPR024898', NULL, 'Octanoyltransferase LipM', 'LipM', 4, NULL),
(21603, NULL, 'IPR032560', NULL, 'Protein of unknown function DUF4932', 'DUF4932', 4, NULL),
(21604, NULL, 'IPR028181', NULL, 'SLP adapter and CSK-interacting membrane protein', 'SCIMP', 4, NULL),
(21605, NULL, 'IPR029255', NULL, 'Ceroid-lipofuscinosis neuronal protein 6', 'CLN6', 4, NULL),
(21606, NULL, 'IPR024571', NULL, 'ERAP1-like C-terminal domain', 'ERAP1-like_C_dom', 3, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(21607, NULL, 'IPR034768', NULL, 'WhiB-like  iron-sulfur binding domain', '4FE4S_WBL', 3, NULL),
(21608, NULL, 'IPR031322', NULL, 'Shikimate kinase/gluconokinase', 'Shikimate/glucono_kinase', 4, NULL),
(21609, NULL, 'IPR030382', NULL, 'SAM-dependent methyltransferase TRM5/TYW2-type', 'MeTrfase_TRM5/TYW2', 3, NULL),
(21610, NULL, 'IPR032630', NULL, 'P-type ATPase, C-terminal', 'P_typ_ATPase_c', 3, NULL),
(21611, NULL, 'IPR029411', NULL, 'Rhamnogalacturonan lyase, domain III', 'RG-lyase_III', 3, NULL),
(21612, NULL, 'IPR030189', NULL, 'Ureide permease, plant', 'UPS_plant', 4, NULL),
(21613, NULL, 'IPR032551', NULL, 'HTH-type transcriptional repressor, C-terminal', 'BscR_C', 3, NULL),
(21614, NULL, 'IPR028130', NULL, 'Dermcidin', 'Dermcidin', 4, NULL),
(21615, NULL, 'IPR028460', NULL, 'Tyramine beta-hydroxylase/Dopamine beta-hydroxylase', 'Tbh/DBH', 4, NULL),
(21616, NULL, 'IPR024555', NULL, 'PX-associated domain', 'PX-associated', 3, NULL),
(21617, NULL, 'IPR027820', NULL, 'Pyrimidine/purine nucleotide 5''-monophosphate nucleosidase, N-terminal', 'PpnN_N', 3, NULL),
(21618, NULL, 'IPR029027', NULL, 'Single alpha-helix domain superfamily', 'Single_a-helix_sf', 5, NULL),
(21619, NULL, 'IPR027371', NULL, 'Mg296-like, C-terminal', 'Mg296-like_C', 5, NULL),
(21620, NULL, 'IPR024460', NULL, 'Protamine-like', 'Protamine-like', 4, NULL),
(21621, NULL, 'IPR029020', NULL, 'Ammonium/urea transporter', 'Ammonium/urea_transptr', 5, NULL),
(21622, NULL, 'IPR026077', NULL, 'Protamine-P3', 'PRMP3', 4, NULL),
(21623, NULL, 'IPR025925', NULL, 'PPC89 centrosome localisation domain', 'PPC89_CLD', 3, NULL),
(21624, NULL, 'IPR032781', NULL, 'ABC-transporter extension domain', 'ABC_tran_Xtn', 3, NULL),
(21625, NULL, 'IPR026071', NULL, 'Glycosyl hydrolase family 99', 'Glyco_Hydrolase_99', 4, NULL),
(21626, NULL, 'IPR026081', NULL, 'Disrupted in schizophrenia 1', 'DISC1', 4, NULL),
(21627, NULL, 'IPR027824', NULL, 'Domain of unknown function DUF4469 with IG-like fold', 'DUF4469', 3, NULL),
(21628, NULL, 'IPR026574', NULL, 'Modulator protein MzrA', 'Modulator_MzrA', 4, NULL),
(21629, NULL, 'IPR032819', NULL, 'tRNA pseudouridylate synthase B, C-terminal', 'TruB_C', 3, NULL),
(21630, NULL, 'IPR030398', NULL, 'DG-type SEA domain', 'SEA_DG_dom', 3, NULL),
(21631, NULL, 'IPR025773', NULL, 'Arterivirus papain-like cysteine protease beta (PCPbeta) domain', 'AV_PCPbeta', 3, NULL),
(21632, NULL, 'IPR027816', NULL, 'Membrane-anchored junction protein', 'MAJIN', 4, NULL),
(21633, NULL, 'IPR024557', NULL, 'CCR4-NOT transcription complex subunit 1, domain 4', 'CNOT1_dom_4', 3, NULL),
(21634, NULL, 'IPR032558', NULL, 'Domain of unknown function DUF4934', 'DUF4934', 3, NULL),
(21635, NULL, 'IPR024903', NULL, 'Putrescine carbamoyltransferase PtcA', 'PtcA', 4, NULL),
(21636, NULL, 'IPR031645', NULL, 'Vacuolar protein sorting-associated protein 13, DH-like domain', 'VPS13_DH-like', 3, NULL),
(21637, NULL, 'IPR025210', NULL, 'ATP25 mRNA stabilisation domain', 'ATP25_mRNA_stabil_dom', 3, NULL),
(21638, NULL, 'IPR031700', NULL, 'Loricrin', 'Loricrin', 4, NULL),
(21639, NULL, 'IPR026737', NULL, 'Golgin subfamily A member 6-like', 'GOLGA6L', 4, NULL),
(21640, NULL, 'IPR028029', NULL, 'Signal transducer CD24', 'CD24', 4, NULL),
(21641, NULL, 'IPR032704', NULL, 'Protein Cms1', 'Cms1', 4, NULL),
(21642, NULL, 'IPR032397', NULL, 'Rel homology dimerisation domain', 'RHD_dimer', 3, NULL),
(21643, NULL, 'IPR025398', NULL, 'Domain of unknown function DUF4371', 'DUF4371', 3, NULL),
(21644, NULL, 'IPR029165', NULL, 'Spermatogenesis-associated serine-rich protein 1', 'SASRP1', 4, NULL),
(21645, NULL, 'IPR028025', NULL, 'FAM229 protein', 'FAM229', 4, NULL),
(21646, NULL, 'IPR032789', NULL, 'Pilus formation protein, N-terminal', 'T2SS-T3SS_pil_N', 3, NULL),
(21647, NULL, 'IPR024554', NULL, 'Domain of unknown function DUF3818, PX-associated', 'DUF3818_PX-associated', 3, NULL),
(21648, NULL, 'IPR029413', NULL, 'Rhamnogalacturonan lyase, domain II', 'RG-lyase_II', 3, NULL),
(21649, NULL, 'IPR028991', NULL, 'D-lysine 5,6-aminomutase beta subunit KamE, N-terminal', 'KamE_N', 3, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(21650, NULL, 'IPR024457', NULL, 'Putative integrase, N-terminal', 'Putative_integrase_N', 3, NULL),
(21651, NULL, 'IPR024897', NULL, 'Octanoyltransferase LipL', 'LipL', 4, NULL),
(21652, NULL, 'IPR030992', NULL, 'Bacterial microcompartment assembly protein PduM', 'PduM', 4, NULL),
(21653, NULL, 'IPR029242', NULL, 'Protein melan-A', 'MLANA', 4, NULL),
(21654, NULL, 'IPR027492', NULL, 'Dual-specificity RNA methyltransferase RlmN', 'RNA_MTrfase_RlmN', 4, NULL),
(21655, NULL, 'IPR030809', NULL, 'EgtB-related enzyme signature domain', 'EgtB_signatur', 3, NULL),
(21656, NULL, 'IPR024560', NULL, 'Uncharacterised protein family UPF0313, C-terminal', 'UPF0313_C', 3, NULL),
(21657, NULL, 'IPR024972', NULL, 'HNS-dependent expression A', 'HdeA', 4, NULL),
(21658, NULL, 'IPR025953', NULL, 'Putative coat protein YlbD', 'YlbD_coat', 4, NULL),
(21659, NULL, 'IPR028143', NULL, 'GET complex subunit Get2/sif1', 'Get2/sif1', 4, NULL),
(21660, NULL, 'IPR032632', NULL, 'Peptidase M16, middle/third domain', 'Peptidase_M16_M', 3, NULL),
(21661, NULL, 'IPR032701', NULL, 'Prokaryotic E2 family B domain', 'Prok-E2_B_dom', 3, NULL),
(21662, NULL, 'IPR032394', NULL, 'Anoctamin, dimerisation domain', 'Anoct_dimer', 3, NULL),
(21663, NULL, 'IPR029431', NULL, 'Tumour protein p53-inducible nuclear protein', 'TP53INP', 4, NULL),
(21664, NULL, 'IPR025899', NULL, 'Phosphatase RapC/F inhibitor, PhrC/F', 'PhrC_PhrF', 4, NULL),
(21665, NULL, 'IPR031331', NULL, 'Neutral/alkaline non-lysosomal ceramidase, C-terminal', 'NEUT/ALK_ceramidase_C', 3, NULL),
(21666, NULL, 'IPR024453', NULL, 'Permuted papain-like amidase enzyme, YaeF/YiiX, C92 family', 'Peptidase_C92', 4, NULL),
(21667, NULL, 'IPR032573', NULL, 'Protein of unknown function DUF4925', 'DUF4925', 4, NULL),
(21668, NULL, 'IPR029270', NULL, 'Limb expression 1', 'LIX1', 4, NULL),
(21669, NULL, 'IPR025885', NULL, 'PapC, N-terminal domain', 'PapC_N', 3, NULL),
(21670, NULL, 'IPR029256', NULL, 'Helicase-associated putative binding domain', 'Heliccase-ass-bd', 3, NULL),
(21671, NULL, 'IPR032553', NULL, 'UCP032676, C2H2 type zinc-finger domain', 'UCP032676_Znf-C2H2', 3, NULL),
(21672, NULL, 'IPR034775', NULL, 'Splicing factor ELAV/Hu, RNA recognition motif 1', 'ELAV/Hu_RRM1', 3, NULL),
(21673, NULL, 'IPR026572', NULL, 'Transmembrane protein 267', 'TMEM267', 4, NULL),
(21674, NULL, 'IPR026709', NULL, 'Myb/SANT-like DNA-binding domain-containing protein 3', 'Msantd3', 4, NULL),
(21675, NULL, 'IPR029234', NULL, 'Testis-expressed protein 33', 'TEX33', 4, NULL),
(21676, NULL, 'IPR028566', NULL, 'Telomere-associated protein  Rif1', 'Rif1', 4, NULL),
(21677, NULL, 'IPR026079', NULL, 'Cerebellar degeneration-related protein 2', 'CDR2', 4, NULL),
(21678, NULL, 'IPR030987', NULL, 'Abortive infection protein, AbiV family', 'AbiV', 4, NULL),
(21679, NULL, 'IPR030989', NULL, 'Radical SAM/SPASM domain peptide maturase, XyeB family', 'rSAM_XyeB', 4, NULL),
(21680, NULL, 'IPR025401', NULL, 'Protein of unknown function DUF4374', 'DUF4374', 4, NULL),
(21681, NULL, 'IPR029024', NULL, 'TerB-like', 'TerB-like', 5, NULL),
(21682, NULL, 'IPR028126', NULL, 'Spexin', 'Spexin', 4, NULL),
(21683, NULL, 'IPR025195', NULL, 'GTA TIM-barrel-like domain', 'GTA_TIM_dom', 3, NULL),
(21684, NULL, 'IPR027814', NULL, 'Protein of unknown function DUF4562', 'DUF4562', 4, NULL),
(21685, NULL, 'IPR032567', NULL, 'LDOC1-related', 'LDOC1-rel', 4, NULL),
(21686, NULL, 'IPR026708', NULL, 'Centrosome and spindle pole associated protein 1', 'CSPP1', 4, NULL),
(21687, NULL, 'IPR024969', NULL, 'Rpn11/EIF3F, C-terminal', 'Rpn11/EIF3F_C', 3, NULL),
(21688, NULL, 'IPR025897', NULL, 'Antitoxin SpoIISB', 'Antitoxin_SpoIISB', 4, NULL),
(21689, NULL, 'IPR029186', NULL, 'Peroxisomal testis-specific protein 1', 'PXT1', 4, NULL),
(21690, NULL, 'IPR030373', NULL, 'Polyamine biosynthesis domain, conserved site', 'PABS_CS', 2, NULL),
(21691, NULL, 'IPR030808', NULL, 'Putative glycosyltransferase CHP04372', 'Glycosyl_04372', 3, NULL),
(21692, NULL, 'IPR027831', NULL, 'Domain of unknown function DUF4485', 'DUF4485', 3, NULL),
(21693, NULL, 'IPR032787', NULL, 'Prokaryotic E2 family D', 'Prok-E2_D', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(21694, NULL, 'IPR031784', NULL, 'Krueppel-like factor 1, transactivation domain 2', 'EKLF_TAD2', 3, NULL),
(21695, NULL, 'IPR031333', NULL, 'Daxx, N-terminal Rassf1C-interacting domain', 'Daxx_N', 3, NULL),
(21696, NULL, 'IPR027252', NULL, 'Iodothyronine deiodinase I/III', 'Iodothyronine_deiodinase_I/III', 4, NULL),
(21697, NULL, 'IPR028245', NULL, 'Eisosome component PIL1/LSP1', 'PIL1/LSP1', 4, NULL),
(21698, NULL, 'IPR026728', NULL, 'UHRF1-binding protein 1-like', 'UHRF1BP1-like', 4, NULL),
(21699, NULL, 'IPR024930', NULL, 'Skp domain superfamily', 'Skp_dom_sf', 5, NULL),
(21700, NULL, 'IPR032511', NULL, 'Protein of unknown function DUF4971', 'DUF4971', 4, NULL),
(21701, NULL, 'IPR027094', NULL, 'Mitofusin family', 'Mitofusin_fam', 4, NULL),
(21702, NULL, 'IPR027359', NULL, 'Voltage-dependent channel domain superfamily', 'Volt_channel_dom_sf', 5, NULL),
(21703, NULL, 'IPR024901', NULL, 'FAPy deformylase', 'FAPy_deformylase', 4, NULL),
(21704, NULL, 'IPR032797', NULL, 'Gamma-tubulin complex subunit Mod21', 'Mod21', 4, NULL),
(21705, NULL, 'IPR028985', NULL, 'Bacillus phage protein-like', 'Bacillus_phage_prot-like', 5, NULL),
(21706, NULL, 'IPR027363', NULL, 'Methylthioribose-1-phosphate isomerase, N-terminal', 'M1Pi_N', 5, NULL),
(21707, NULL, 'IPR030845', NULL, 'Regulator of telomere elongation helicase 1', 'RTEL1', 4, NULL),
(21708, NULL, 'IPR024459', NULL, 'Anti-CBASS protein Acb1-like', 'Acb1-like', 4, NULL),
(21709, NULL, 'IPR031099', NULL, 'BRCA1-associated', 'BRCA1-associated', 4, NULL),
(21710, NULL, 'IPR031339', NULL, 'Domain of unknown function DUF4942', 'DUF4942', 3, NULL),
(21711, NULL, 'IPR032702', NULL, 'CppA, N-terminal', 'CppA_N', 3, NULL),
(21712, NULL, 'IPR029345', NULL, 'Maltose transport system permease protein MalF, P2 domain', 'MalF_P2', 3, NULL),
(21713, NULL, 'IPR026720', NULL, 'Cilia- and flagella-associated protein 91', 'CFAP91', 4, NULL),
(21714, NULL, 'IPR030810', NULL, 'Hercynine metabolism small protein', 'Small_EgtBD', 4, NULL),
(21715, NULL, 'IPR025954', NULL, 'DBC1/CARP1 catalytically inactive NUDIX hydrolase domain', 'DBC1/CARP1_inactive_NUDIX_dom', 3, NULL),
(21716, NULL, 'IPR030998', NULL, 'Thiosulfohydrolase SoxB', 'Thiosulf_SoxB', 4, NULL),
(21717, NULL, 'IPR029429', NULL, 'Ciliary BBSome complex subunit 2, middle region', 'BBS2_Mid', 3, NULL),
(21718, NULL, 'IPR028990', NULL, 'GK1464-like', 'GK1464-like', 5, NULL),
(21719, NULL, 'IPR030934', NULL, 'Intein C-terminal splicing region', 'Intein_C', 3, NULL),
(21720, NULL, 'IPR032526', NULL, 'Domain of unknown function DUF4960', 'DUF4960', 3, NULL),
(21721, NULL, 'IPR032563', NULL, 'DAMP1, SANT/Myb-like domain', 'DAMP1_SANT-like', 3, NULL),
(21722, NULL, 'IPR032706', NULL, 'Transcription elongation factor Spt6, helix-hairpin-helix motif', 'Spt6_HHH', 3, NULL),
(21723, NULL, 'IPR030986', NULL, 'Abortive infection protein, AbiA family', 'AbiA', 4, NULL),
(21724, NULL, 'IPR025378', NULL, 'Domain of unknown function DUF4368', 'DUF4368', 3, NULL),
(21725, NULL, 'IPR032807', NULL, 'Tyrosine kinase, G-rich domain', 'GNVR', 3, NULL),
(21726, NULL, 'IPR029185', NULL, 'CMT1A duplicated region transcript 4 protein', 'CDRT4', 4, NULL),
(21727, NULL, 'IPR026716', NULL, 'PABIR1/2/3', 'PBIR1/2/3', 4, NULL),
(21728, NULL, 'IPR025203', NULL, 'Putative quorum-sensing-regulated virulence factor, QSregVF', 'QSregVF', 4, NULL),
(21729, NULL, 'IPR027828', NULL, 'Protein of unknown function DUF4465', 'DUF4465', 4, NULL),
(21730, NULL, 'IPR028183', NULL, 'Small integral membrane protein 4-like', 'Smim4-like', 4, NULL),
(21731, NULL, 'IPR029239', NULL, 'Cilia- and flagella-associated protein 418', 'CFAP418', 4, NULL),
(21732, NULL, 'IPR032811', NULL, 'Putative conjugal transfer protein TraF-related', 'Put_conjugal_transfer', 4, NULL),
(21733, NULL, 'IPR032836', NULL, 'DsrE2-like family', 'DsrE2-like', 4, NULL),
(21734, NULL, 'IPR026569', NULL, 'Ribosomal protein L28/L24', 'Ribo_L28/L24', 4, NULL),
(21735, NULL, 'IPR028333', NULL, 'Ribosomal protein S17, archaeal/eukaryotic', 'Ribosomal_S17_arc-typ', 4, NULL),
(21736, NULL, 'IPR024552', NULL, 'Domain of Unknown Function DUF3856', 'DUF3856', 3, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(21737, NULL, 'IPR028992', NULL, 'Hedgehog/Intein (Hint) domain', 'Hedgehog/Intein_dom', 3, NULL),
(21738, NULL, 'IPR032783', NULL, 'AraC-type transcription regulator, ligand-binding domain', 'AraC_lig', 3, NULL),
(21739, NULL, 'IPR032375', NULL, 'Cerebral cavernous malformations 2, harmonin-homology domain', 'CCM2_C', 3, NULL),
(21740, NULL, 'IPR025952', NULL, 'R3H-associated N-terminal domain', 'R3H-assoc_dom', 3, NULL),
(21741, NULL, 'IPR031963', NULL, 'Histone deacetylase complex subunit SAP130, C-terminal domain', 'SAP130_C', 3, NULL),
(21742, NULL, 'IPR024559', NULL, 'Protein of unknown function DUF3846', 'DUF3846', 4, NULL),
(21743, NULL, 'IPR028010', NULL, 'Gamma-secretase-activating protein, C-terminal domain', 'GSAP_C_dom', 3, NULL),
(21744, NULL, 'IPR032631', NULL, 'P-type ATPase, N-terminal', 'P-type_ATPase_N', 3, NULL),
(21745, NULL, 'IPR032673', NULL, 'DNA photolyase class 2, conserved site', 'DNA_photolyase_2_CS', 2, NULL),
(21746, NULL, 'IPR032506', NULL, 'N-sulphoglucosamine sulphohydrolase, C-terminal', 'SGSH_C', 3, NULL),
(21747, NULL, 'IPR024464', NULL, 'Protein of unknown function DUF2391', 'DUF2391', 4, NULL),
(21748, NULL, 'IPR032587', NULL, 'Protein of unknown function DUF4911', 'DUF4911', 4, NULL),
(21749, NULL, 'IPR032556', NULL, 'Protein of unknown function DUF4936', 'DUF4936', 4, NULL),
(21750, NULL, 'IPR029427', NULL, 'Altered inheritance of mitochondria protein 23, mitochondrial', 'AIM23', 4, NULL),
(21751, NULL, 'IPR025371', NULL, 'Domain of unknown function DUF4361', 'DUF4361', 3, NULL),
(21752, NULL, 'IPR026046', NULL, 'UbiA prenyltransferase domain containing protein 1', 'UBIAD1', 4, NULL),
(21753, NULL, 'IPR032554', NULL, 'Protein of unknown function DUF4938', 'DUF4938', 4, NULL),
(21754, NULL, 'IPR031890', NULL, 'F-box only protein 30/40', 'Fbxo30/Fbxo40', 4, NULL),
(21755, NULL, 'IPR025397', NULL, 'Succinate dehydrogenase subunit 5, mitochondrial', 'SDH5', 4, NULL),
(21756, NULL, 'IPR026714', NULL, 'Small acidic protein', 'SMAP', 4, NULL),
(21757, NULL, 'IPR032572', NULL, 'Nuclear migration protein nudC', 'NuDC', 3, NULL),
(21758, NULL, 'IPR032831', NULL, 'Prokaryotic lipoprotein-attachment site', 'LPAM_2', 2, NULL),
(21759, NULL, 'IPR031959', NULL, 'Protein of unknown function DUF4779', 'DUF4779', 4, NULL),
(21760, NULL, 'IPR024561', NULL, 'Alpha-1,6-glucosidases, pullulanase-type, C-terminal', 'Pullul_strch_C', 3, NULL),
(21761, NULL, 'IPR025204', NULL, 'Centromere subunit  L', 'CENP-L', 4, NULL),
(21762, NULL, 'IPR029260', NULL, 'Dual specificity/tyrosine protein phosphatase, N-terminal', 'DSPn', 3, NULL),
(21763, NULL, 'IPR025207', NULL, 'Kinetochore Sim4 complex subunit  Fta4', 'Sim4_Fta4', 4, NULL),
(21764, NULL, 'IPR026072', NULL, 'Lck-interacting transmembrane adapter 1', 'Lime1', 4, NULL),
(21765, NULL, 'IPR029177', NULL, 'Interferon lambda', 'INF_lambda', 4, NULL),
(21766, NULL, 'IPR030995', NULL, 'Thiosulfate oxidation carrier complex protein SoxZ', 'SoxZ', 4, NULL),
(21767, NULL, 'IPR025205', NULL, 'PilX/PilW C-terminal domain', 'PilX/PilW_C', 3, NULL),
(21768, NULL, 'IPR028623', NULL, 'HNS-dependent expression B', 'HdeB', 4, NULL),
(21769, NULL, 'IPR028989', NULL, 'Ribosome maturation factor RimP, N-terminal', 'RimP_N', 3, NULL),
(21770, NULL, 'IPR028246', NULL, 'Cation channel sperm-associated auxiliary subunit gamma', 'CATSPERG', 4, NULL),
(21771, NULL, 'IPR032562', NULL, 'Protein of unknown function DUF4929', 'DUF4929', 4, NULL),
(21772, NULL, 'IPR026082', NULL, 'ABC transporter A', 'ABCA', 4, NULL),
(21773, NULL, 'IPR024933', NULL, 'Septin and tuftelin interacting protein', 'TFP11', 4, NULL),
(21774, NULL, 'IPR026721', NULL, 'Transmembrane protein 18', 'TMEM18', 4, NULL),
(21775, NULL, 'IPR027818', NULL, 'Sperm acrosome-associated protein 9', 'SPACA9', 4, NULL),
(21776, NULL, 'IPR029430', NULL, 'Ciliary BBSome complex subunit 2, N-terminal', 'BBS2_N', 3, NULL),
(21777, NULL, 'IPR032400', NULL, 'RelB transactivation domain', 'RelB_transact', 3, NULL),
(21778, NULL, 'IPR032821', NULL, 'Polyketide synthase, C-terminal extension', 'PKS_assoc', 3, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(21779, NULL, 'IPR032705', NULL, 'Origin recognition complex subunit 4, C-terminal', 'ORC4_C', 3, NULL),
(21780, NULL, 'IPR032828', NULL, 'tRNA nucleotidyltransferase/poly(A) polymerase, RNA and SrmB- binding domain', 'PolyA_RNA-bd', 3, NULL),
(21781, NULL, 'IPR030192', NULL, 'Miniconductance mechanosensitive channel YbdG', 'YbdG', 4, NULL),
(21782, NULL, 'IPR031365', NULL, 'Protein of unknown function with motif GDWWSH', 'GDWWSH', 4, NULL),
(21783, NULL, 'IPR035929', NULL, 'CoaB-like superfamily', 'CoaB-like_sf', 5, NULL),
(21784, NULL, 'IPR026565', NULL, 'Putative pyruvate, phosphate dikinase regulatory protein', 'PPDK_reg', 4, NULL),
(21785, NULL, 'IPR029856', NULL, 'Protein AMBP', 'AMBP', 4, NULL),
(21786, NULL, 'IPR029978', NULL, 'LIM domain only protein 7', 'LMO-7', 4, NULL),
(21787, NULL, 'IPR025375', NULL, 'Domain of unknown function DUF4365', 'DUF4365', 3, NULL),
(21788, NULL, 'IPR029193', NULL, 'Testis-expressed sequence 12 protein', 'TEX12', 4, NULL),
(21789, NULL, 'IPR028015', NULL, 'CCDC84-like', 'CCDC84-like', 4, NULL),
(21790, NULL, 'IPR026736', NULL, 'Protein virilizer', 'Virilizer', 4, NULL),
(21791, NULL, 'IPR025951', NULL, 'GXWXG domain', 'GXWXG_dom', 3, NULL),
(21792, NULL, 'IPR030491', NULL, 'TATA-box binding protein, conserved site', 'TBP_CS', 2, NULL),
(21793, NULL, 'IPR032568', NULL, 'Protein of unknown function DUF4926', 'DUF4926', 4, NULL),
(21794, NULL, 'IPR031708', NULL, 'Protein of unknown function DUF4722', 'DUF4722', 4, NULL),
(21795, NULL, 'IPR030847', NULL, 'Mitochondrial glycine transporter Hem25/SLC25A38', 'Hem25/SLC25A38', 4, NULL),
(21796, NULL, 'IPR029238', NULL, 'Shadow of prion protein', 'Shadoo', 4, NULL),
(21797, NULL, 'IPR032810', NULL, 'CCA-adding enzyme, C-terminal', 'CCA-adding_enz_C', 3, NULL),
(21798, NULL, 'IPR026076', NULL, 'Late cornified envelope-like proline-rich protein 1', 'Lelp1', 4, NULL),
(21799, NULL, 'IPR032795', NULL, 'DUF3741-associated sequence motif', 'DUF3741-assoc', 3, NULL),
(21800, NULL, 'IPR029170', NULL, 'FAM180 family', 'FAM180', 4, NULL),
(21801, NULL, 'IPR028146', NULL, 'Glucosidase II beta subunit, N-terminal', 'PRKCSH_N', 3, NULL),
(21802, NULL, 'IPR024564', NULL, 'Nitrogenase molybdenum-iron protein beta chain, N-terminal', 'Nase_Mo-Fe_CF_bsu_N', 3, NULL),
(21803, NULL, 'IPR032402', NULL, 'Putative adherens-junction anchoring domain', 'AbLIM_anchor', 3, NULL),
(21804, NULL, 'IPR029325', NULL, 'ITPR-interacting domain', 'ITPR-bd', 3, NULL),
(21805, NULL, 'IPR032742', NULL, 'INO80 complex subunit 3', 'Iec3', 4, NULL),
(21806, NULL, 'IPR029166', NULL, 'Williams-Beuren syndrome chromosomal region 28 protein homologue', 'WBS28', 4, NULL),
(21807, NULL, 'IPR030812', NULL, 'Hercynine metabolism protein', 'Cyano_EgtBD', 4, NULL),
(21808, NULL, 'IPR032510', NULL, 'Protein of unknown function DUF4972', 'DUF4972', 4, NULL),
(21809, NULL, 'IPR032509', NULL, 'Domain of unknown function DUF4973', 'DUF4973', 3, NULL),
(21810, NULL, 'IPR032584', NULL, 'Protein of unknown function DUF4913', 'DUF4913', 4, NULL),
(21811, NULL, 'IPR030492', NULL, 'Rel homology domain, conserved site', 'RHD_CS', 2, NULL),
(21812, NULL, 'IPR029333', NULL, 'Ciliary BBSome complex subunit 2, C-terminal domain', 'BBS2_C', 3, NULL),
(21813, NULL, 'IPR027098', NULL, 'Sodium channel subunit beta-1/beta-3', 'Na_channel_b1/b3', 4, NULL),
(21814, NULL, 'IPR029259', NULL, 'Rapamycin-insensitive companion of mTOR, phosphorylation-site', 'RICTOR_phospho', 6, NULL),
(21815, NULL, 'IPR026064', NULL, 'Terminal deoxynucleotidyltransferase-interacting factor 1', 'TdIF1', 4, NULL),
(21816, NULL, 'IPR024899', NULL, 'Nitrogen fixation-sustaining protein CowN', 'CowN', 4, NULL),
(21817, NULL, 'IPR031706', NULL, 'Odontogenesis associated phosphoprotein', 'ODAPH', 4, NULL),
(21818, NULL, 'IPR024902', NULL, 'FAD synthase RibL', 'FAD_synth_RibL', 4, NULL),
(21819, NULL, 'IPR028191', NULL, 'WASH complex subunit 4, N-terminal', 'WASH-4_N', 3, NULL),
(21820, NULL, 'IPR028019', NULL, 'Protein of unknown function DUF4508', 'DUF4508', 4, NULL),
(21821, NULL, 'IPR030675', NULL, 'Lipid binding protein BPI/LBP', 'BPI/LBP', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(21822, NULL, 'IPR032796', NULL, 'Polysulfide reductase', 'NrfD_2', 4, NULL),
(21823, NULL, 'IPR026045', NULL, 'Ferric binding protein', 'Ferric-bd', 4, NULL),
(21824, NULL, 'IPR028417', NULL, 'CAP, conserved site, C-terminal', 'CAP_CS_C', 2, NULL),
(21825, NULL, 'IPR030997', NULL, 'SoxY-related AACIE arm protein', 'SoxY_para_1', 4, NULL),
(21826, NULL, 'IPR032474', NULL, 'Protein argonaute, N-terminal', 'Argonaute_N', 3, NULL),
(21827, NULL, 'IPR030994', NULL, 'Diol dehydratase reactivase ATPase-like domain', 'DDR_dom', 3, NULL),
(21828, NULL, 'IPR028014', NULL, 'Transmembrane protein 255', 'TMEM255', 4, NULL),
(21829, NULL, 'IPR027813', NULL, 'Protein of unknown function DUF4642', 'DUF4642', 4, NULL),
(21830, NULL, 'IPR029176', NULL, 'Spermatogenesis-associated protein 24', 'SPATA24', 4, NULL),
(21831, NULL, 'IPR025211', NULL, 'Toxin TisB, type I toxin-antitoxin system', 'TisB_toxin', 4, NULL),
(21832, NULL, 'IPR026711', NULL, 'Protein male-specific lethal-1', 'Msl-1', 4, NULL),
(21833, NULL, 'IPR024572', NULL, 'Nickel/cobalt homeostasis protein RcnB', 'RcnB', 4, NULL),
(21834, NULL, 'IPR027998', NULL, 'Respiration factor 1', 'Rsf1_fungi', 4, NULL),
(21835, NULL, 'IPR029236', NULL, 'Protein of unknown function DUF4618', 'DUF4618', 4, NULL),
(21836, NULL, 'IPR032741', NULL, 'Protein Sls1', 'Sls1', 4, NULL),
(21837, NULL, 'IPR025196', NULL, 'Domain of unknown function DUF4126', 'DUF4126', 3, NULL),
(21838, NULL, 'IPR032492', NULL, 'Domain of unknown function DUF5045', 'DUF5045', 3, NULL),
(21839, NULL, 'IPR030127', NULL, 'I-BAR domain containing protein MTSS1/MTSS2', 'MTSS1/MTSS2', 4, NULL),
(21840, NULL, 'IPR032830', NULL, 'Helicase XPB/Ssl2, N-terminal domain', 'XPB/Ssl2_N', 3, NULL),
(21841, NULL, 'IPR027829', NULL, 'Protein of unknown function DUF4625', 'DUF4625', 4, NULL),
(21842, NULL, 'IPR028140', NULL, 'Protein TraM', 'TraM', 4, NULL),
(21843, NULL, 'IPR029013', NULL, 'HP0062-like domain superfamily', 'HP0062-like_sf', 5, NULL),
(21844, NULL, 'IPR029189', NULL, 'Thymic stromal lymphopoietin', 'TSLP', 4, NULL),
(21845, NULL, 'IPR024574', NULL, 'ELMO, armadillo-like helical domain', 'ELMO_ARM', 3, NULL),
(21846, NULL, 'IPR028190', NULL, 'Novel toxin 21', 'Ntox21', 3, NULL),
(21847, NULL, 'IPR028131', NULL, 'Tubulinyl-Tyr carboxypeptidase', 'VASH1', 4, NULL),
(21848, NULL, 'IPR025663', NULL, 'A-kinase anchor protein 28kDa', 'AKAP_28', 4, NULL),
(21849, NULL, 'IPR025372', NULL, 'Protein of unknown function DUF4362', 'DUF4362', 4, NULL),
(21850, NULL, 'IPR032555', NULL, 'Domain of unknown function DUF4937', 'DUF4937', 3, NULL),
(21851, NULL, 'IPR026717', NULL, 'Spermatogenesis-associated protein 3', 'SPATA3', 4, NULL),
(21852, NULL, 'IPR024925', NULL, 'Malonyl CoA-acyl carrier protein transacylase', 'Malonyl_CoA-ACP_transAc', 4, NULL),
(21853, NULL, 'IPR032552', NULL, 'Acin1, RNSP1-SAP18 binding (RSB) motif', 'RSB_motif', 2, NULL),
(21854, NULL, 'IPR026719', NULL, 'Glutamate-rich protein 1', 'ERICH1', 4, NULL),
(21855, NULL, 'IPR024932', NULL, 'Flavin transferase ApbE', 'ApbE', 4, NULL),
(21856, NULL, 'IPR032629', NULL, 'Mon2/Sec7/BIG1-like, dimerisation and cyclophilin-binding domain', 'DCB_dom', 3, NULL),
(21857, NULL, 'IPR031652', NULL, 'Phosphoribosylformylglycinamidine subunit PurL, C-terminal', 'PurL_C', 3, NULL),
(21858, NULL, 'IPR032633', NULL, 'ThiJ/PfpI family-like', 'ThiJ-like', 4, NULL),
(21859, NULL, 'IPR032739', NULL, 'MRN complex-interacting protein', 'MRNIP', 4, NULL),
(21860, NULL, 'IPR032378', NULL, 'ZC3H15/TMA46 family, C-terminal', 'ZC3H15/TMA46_C', 3, NULL),
(21861, NULL, 'IPR025202', NULL, 'Phospholipase D-like domain', 'PLD-like_dom', 3, NULL),
(21862, NULL, 'IPR030384', NULL, 'SAM-dependent methyltransferase SMT-type', 'MeTrfase_SMT', 3, NULL),
(21863, NULL, 'IPR029187', NULL, 'Follicular dendritic cell secreted peptide', 'FDC-SP', 4, NULL),
(21864, NULL, 'IPR026073', NULL, 'Gametogenetin-binding protein 2', 'GGNBP2', 4, NULL),
(21865, NULL, 'IPR026265', NULL, 'Lipopolysaccharide export system protein LptC', 'LptC', 4, NULL),
(21866, NULL, 'IPR024570', NULL, 'Murein transglycosylase-C, N-terminal', 'Murein_transglycosylaseC_N', 3, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(21867, NULL, 'IPR032745', NULL, 'G protein-regulated inducer of neurite outgrowth, C-terminal', 'GRIN_C', 3, NULL),
(21868, NULL, 'IPR030849', NULL, 'Ubiquitin carboxyl-terminal hydrolase 16', 'UBP16', 4, NULL),
(21869, NULL, 'IPR024967', NULL, 'DNA-binding domain, IS481-type', 'DNA-bd_IS481-type', 3, NULL),
(21870, NULL, 'IPR030996', NULL, 'Exosortase O', 'Exosort_XrtO', 4, NULL),
(21871, NULL, 'IPR030840', NULL, 'Cardiolipin synthase A', 'CL_synthase_A', 4, NULL),
(21872, NULL, 'IPR028195', NULL, 'Spermatid-specific manchette-related protein 1', 'SMRP1', 4, NULL),
(21873, NULL, 'IPR025206', NULL, 'Protein of unknown function DUF4152', 'DUF4152', 3, NULL),
(21874, NULL, 'IPR029194', NULL, 'Lens epithelial cell protein LEP503', 'LEP503', 4, NULL),
(21875, NULL, 'IPR029327', NULL, 'HAUS augmin-like complex subunit 4', 'HAUS4', 4, NULL),
(21876, NULL, 'IPR028128', NULL, 'Vasculin family', 'Vasculin_fam', 4, NULL),
(21877, NULL, 'IPR028129', NULL, 'Consortin, C-terminal domain', 'Consortin_C', 3, NULL),
(21878, NULL, 'IPR032575', NULL, 'Lipocalin-like domain (DUF4923)', 'DUF4923', 3, NULL),
(21879, NULL, 'IPR027812', NULL, 'Protein of unknown function DUF4653', 'DUF4653', 4, NULL),
(21880, NULL, 'IPR032703', NULL, 'CppA, C-terminal', 'CppA_C', 3, NULL),
(21881, NULL, 'IPR032586', NULL, 'Tagaturonate/fructuronate epimerase', 'UxaE', 4, NULL),
(21882, NULL, 'IPR030395', NULL, 'Glycerophosphodiester phosphodiesterase domain', 'GP_PDE_dom', 3, NULL),
(21883, NULL, 'IPR025943', NULL, 'Sigma-54 interaction domain, ATP-binding site 2', 'Sigma_54_int_dom_ATP-bd_2', 1, NULL),
(21884, NULL, 'IPR028182', NULL, 'BMP-2-inducible protein kinase, C-terminal', 'BMP2K_C', 3, NULL),
(21885, NULL, 'IPR028119', NULL, 'Snapin/Pallidin/Snn1', 'Snapin/Pallidin/Snn1', 4, NULL),
(21886, NULL, 'IPR030990', NULL, 'Putative rSAM-modified RiPP, XyeA family', 'RiPP_XyeA', 4, NULL),
(21887, NULL, 'IPR031961', NULL, 'Domain of unknown function DUF4780', 'DUF4780', 3, NULL),
(21888, NULL, 'IPR028124', NULL, 'Small acidic protein-like domain', 'SMAP_dom', 3, NULL),
(21889, NULL, 'IPR028241', NULL, 'RAVE subunit 2/Rogdi', 'RAVE2/Rogdi', 4, NULL),
(21890, NULL, 'IPR029262', NULL, 'DNA-directed RNA polymerase, N-terminal', 'RPOL_N', 3, NULL),
(21891, NULL, 'IPR025400', NULL, 'Uncharacterized phage-related protein Lin1244/Lin1753-like, N-terminal', 'Lin1244/Lin1753-like_N', 3, NULL),
(21892, NULL, 'IPR029261', NULL, 'Transposase IS204/IS1001/IS1096/IS1165, zinc-finger', 'Transposase_Znf', 3, NULL),
(21893, NULL, 'IPR029703', NULL, 'DNA polymerase epsilon catalytic subunit', 'POL2', 4, NULL),
(21894, NULL, 'IPR029257', NULL, 'Rab3GAP regulatory subunit, C-terminal', 'RAB3GAP2_C', 3, NULL),
(21895, NULL, 'IPR032806', NULL, 'H repeat-associated protein, N-terminal', 'YbfD_N', 3, NULL),
(21896, NULL, 'IPR029054', NULL, 'dUTPase-like', 'dUTPase-like', 3, NULL),
(21897, NULL, 'IPR031649', NULL, 'Voltage-dependent L-type calcium channel, IQ-associated domain', 'GPHH_dom', 3, NULL),
(21898, NULL, 'IPR026263', NULL, 'Alkaline phosphatase, prokaryotic', 'Alkaline_phosphatase_prok', 4, NULL),
(21899, NULL, 'IPR024455', NULL, 'Phage capsid', 'Phage_capsid', 4, NULL),
(21900, NULL, 'IPR028186', NULL, 'Transmembrane protein 191B/C', 'TMEM191B/C', 4, NULL),
(21901, NULL, 'IPR026091', NULL, 'BLOC-3 complex member HPS4', 'HPS4', 4, NULL),
(21902, NULL, 'IPR032628', NULL, 'Adenylate cyclase, N-terminal', 'AC_N', 3, NULL),
(21903, NULL, 'IPR028039', NULL, 'Coiled-coil domain containing protein 32', 'CCDC32', 4, NULL),
(21904, NULL, 'IPR025373', NULL, 'Protein of unknown function DUF4363', 'DUF4363', 4, NULL),
(21905, NULL, 'IPR028243', NULL, 'Paramyxovirus structural protein P/V, N-terminal domain', 'Paramyxo_P/V_N', 3, NULL),
(21906, NULL, 'IPR025900', NULL, 'Nuclear receptor repeat', 'Nuclear_receptor_repeat', 7, NULL),
(21907, NULL, 'IPR027412', NULL, 'Baseplate structural protein Gp9 C-terminal domain superfamily', 'Gp9_C_dom_sf', 5, NULL),
(21908, NULL, 'IPR030673', NULL, 'Pyrophosphatase, GppA/Ppx-type', 'PyroPPase_GppA_Ppx', 4, NULL),
(21909, NULL, 'IPR028174', NULL, 'Fibroblast growth factor receptor 1, catalytic domain', 'FGF_rcpt_1', 3, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(21910, NULL, 'IPR031957', NULL, 'Domain of unknown function DUF4777', 'DUF4777', 3, NULL),
(21911, NULL, 'IPR028144', NULL, 'Cysteine-rich transmembrane CYSTM domain', 'CYSTM_dom', 3, NULL),
(21912, NULL, 'IPR027392', NULL, 'Transcription factor zinc-finger', 'TF_Znf', 3, NULL),
(21913, NULL, 'IPR032798', NULL, 'Endoglucanase Z, cellulose-binding domain', 'CBM_5_12_2', 3, NULL),
(21914, NULL, 'IPR028881', NULL, 'PAN2, UCH domain', 'PAN2_UCH_dom', 3, NULL),
(21915, NULL, 'IPR032574', NULL, 'Protein of unknown function DUF4924', 'DUF4924', 4, NULL),
(21916, NULL, 'IPR031958', NULL, 'Protein of unknown function DUF4778', 'DUF4778', 4, NULL),
(21917, NULL, 'IPR029180', NULL, 'Myc target protein 1', 'Myc_target_1', 4, NULL),
(21918, NULL, 'IPR029982', NULL, 'Kaptin', 'Kptn', 4, NULL),
(21919, NULL, 'IPR029168', NULL, 'Meiotic recombination protein REC114-like', 'REC114L', 4, NULL),
(21920, NULL, 'IPR029179', NULL, 'Mitochondrial import receptor subunit TOM5, metazoa', 'TOMM5_metazoa', 4, NULL),
(21921, NULL, 'IPR024569', NULL, 'Lactate utilization protein B, C-terminal', 'LutB_C', 3, NULL),
(21922, NULL, 'IPR029241', NULL, 'Testis-specific gene 13 protein', 'TSGA13', 4, NULL),
(21923, NULL, 'IPR024465', NULL, 'Domain of unknown function DUF2399', 'DUF2399', 3, NULL),
(21924, NULL, 'IPR032813', NULL, 'Putative Na+/H+ antiporter, N-terminal', 'Na_H_antiport_N', 3, NULL),
(21925, NULL, 'IPR025402', NULL, 'Domain of unknown function DUF4375', 'DUF4375', 3, NULL),
(21926, NULL, 'IPR032800', NULL, 'ML-like domain', 'TRP_N', 3, NULL),
(21927, NULL, 'IPR024931', NULL, 'Importin subunit alpha', 'Importin_alpha', 4, NULL),
(21928, NULL, 'IPR032508', NULL, 'Protein FecR, C-terminal', 'FecR_C', 3, NULL),
(21929, NULL, 'IPR029326', NULL, 'Sperm-specific antigen 2, C-terminal', 'SSFA2_C', 3, NULL),
(21930, NULL, 'IPR032577', NULL, 'Protein of unknown function DUF4920', 'DUF4920', 4, NULL),
(21931, NULL, 'IPR028184', NULL, 'Transcription cofactor vestigial-like protein 4', 'VGLL4', 4, NULL),
(21932, NULL, 'IPR032639', NULL, 'Tex protein, YqgF-like domain', 'Tex_YqgF', 3, NULL),
(21933, NULL, 'IPR026669', NULL, 'Arsenite methyltransferase-like', 'Arsenite_MeTrfase-like', 4, NULL),
(21934, NULL, 'IPR031646', NULL, 'Vacuolar protein sorting-associated protein 13, second N-terminal domain', 'VPS13_N2', 3, NULL),
(21935, NULL, 'IPR031783', NULL, 'Chromosome segregation in meiosis protein 2', 'Csm2', 4, NULL),
(21936, NULL, 'IPR028301', NULL, 'Serine proteases, V8 family, histidine active site', 'V8_his_AS', 0, NULL),
(21937, NULL, 'IPR028346', NULL, 'HAUS augmin-like complex subunit 2', 'HAUS2', 4, NULL),
(21938, NULL, 'IPR025886', NULL, 'Phloem protein 2-like', 'PP2-like', 4, NULL),
(21939, NULL, 'IPR030838', NULL, '30S ribosomal protein S3Ae', '30S_S3Ae', 4, NULL),
(21940, NULL, 'IPR027811', NULL, 'CRISPR-associated protein  Cas8a1/Csx13, Myxan subtype, C-terminal', 'CRISPR-assoc_Csx13_C', 3, NULL),
(21941, NULL, 'IPR025209', NULL, 'Domain of unknown function DUF4209', 'DUF4209', 3, NULL),
(21942, NULL, 'IPR032809', NULL, 'Putative HupE/UreJ protein', 'Put_HupE_UreJ', 4, NULL),
(21943, NULL, 'IPR028150', NULL, 'Lustrin, cysteine-rich repeated', 'Lustrin_cystein', 7, NULL),
(21944, NULL, 'IPR032475', NULL, 'Protealysin, N-terminal propeptide', 'Protealysin_N_PP', 3, NULL),
(21945, NULL, 'IPR029342', NULL, 'ECSIT, C-terminal domain', 'ECIST_C', 3, NULL),
(21946, NULL, 'IPR025198', NULL, 'Polyphosphate kinase N-terminal domain', 'PPK_N_dom', 3, NULL),
(21947, NULL, 'IPR028988', NULL, 'Hemolytic lectin CEL-III, C-terminal domain superfamily', 'CEL-III_C_sf', 5, NULL),
(21948, NULL, 'IPR025922', NULL, 'Minor type IV pilin, PilX-like', 'Pilin_PilX-like', 4, NULL),
(21949, NULL, 'IPR032805', NULL, 'Wax synthase domain', 'Wax_synthase_dom', 3, NULL),
(21950, NULL, 'IPR028145', NULL, 'Synaptonemal complex central element protein 3', 'Synaptonemal_3', 4, NULL),
(21951, NULL, 'IPR029324', NULL, 'Mitochondrial apoptosis-inducing factor, C-terminal domain', 'AIF_C', 3, NULL),
(21952, NULL, 'IPR029419', NULL, 'Argininosuccinate lyase, C-terminal', 'Arg_succ_lyase_C', 3, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(21953, NULL, 'IPR032580', NULL, 'SatD family', 'SatD', 4, NULL),
(21954, NULL, 'IPR031710', NULL, 'Protein of unknown function DUF4723', 'DUF4723', 4, NULL),
(21955, NULL, 'IPR028422', NULL, 'GREB1', 'GREB1', 4, NULL),
(21956, NULL, 'IPR029415', NULL, 'Protein Lines, C-terminal', 'Lines_C', 3, NULL),
(21957, NULL, 'IPR032638', NULL, 'Putative bacterial porin', 'Porin_5', 4, NULL),
(21958, NULL, 'IPR028187', NULL, 'STAT6, C-terminal', 'STAT6_C', 3, NULL),
(21959, NULL, 'IPR030191', NULL, 'Cytosine permease', 'CodB', 4, NULL),
(21960, NULL, 'IPR032507', NULL, 'GH32, BT1760-like, C-terminal domain', 'BT1760-like_C', 3, NULL),
(21961, NULL, 'IPR028986', NULL, 'AF2331-like domain', 'AF2331-like_dom', 3, NULL),
(21962, NULL, 'IPR027823', NULL, 'Domain of unknown function DUF4468 with TBP-like fold', 'DUF4468', 3, NULL),
(21963, NULL, 'IPR030991', NULL, 'Cytochrome c-550 PedF', 'c550_PedF', 4, NULL),
(21964, NULL, 'IPR027826', NULL, 'Domain of unknown function DUF4431', 'DUF4431', 3, NULL),
(21965, NULL, 'IPR024461', NULL, 'Coiled-coil domain-containing protein 90-like', 'CCDC90-like', 4, NULL),
(21966, NULL, 'IPR028189', NULL, 'Nitrate reductase, alpha subunit, N-terminal', 'Nitr_red_alph_N', 3, NULL),
(21967, NULL, 'IPR028148', NULL, 'Immunity protein 74', 'Imm74', 4, NULL),
(21968, NULL, 'IPR028248', NULL, 'Transmembrane protein 190', 'TMEM190', 4, NULL),
(21969, NULL, 'IPR028366', NULL, 'Phosphate transport system protein PhoU', 'P_transport_PhoU', 4, NULL),
(21970, NULL, 'IPR029172', NULL, 'Putative testis-specific prion protein', 'PRNT', 4, NULL),
(21971, NULL, 'IPR027179', NULL, 'Mature-T-Cell Proliferation I type', 'MTCP1', 4, NULL),
(21972, NULL, 'IPR032564', NULL, 'Protein of unknown function DUF4928', 'DUF4928', 4, NULL),
(21973, NULL, 'IPR032576', NULL, 'Domain of unknown function DUF4921', 'DUF4921', 3, NULL),
(21974, NULL, 'IPR030999', NULL, 'Sulfur oxidation c-type cytochrome SoxX', 'Thiosulf_SoxX', 4, NULL),
(21975, NULL, 'IPR027368', NULL, 'tRNA modification GTPase MnmE domain 2', 'MnmE_dom2', 5, NULL),
(21976, NULL, 'IPR031443', NULL, 'Mitochondrial biogenesis regulation protein 1', 'Mbr1', 4, NULL),
(21977, NULL, 'IPR029182', NULL, 'Mitochondrial import receptor subunit TOM6 homologue', 'TOMM6', 4, NULL),
(21978, NULL, 'IPR028118', NULL, 'Chibby family', 'Chibby_fam', 4, NULL),
(21979, NULL, 'IPR026571', NULL, 'Transmembrane protein 186', 'Tmem186', 4, NULL),
(21980, NULL, 'IPR030988', NULL, 'Putative ATP-grasp target RiPP, Rhodococcus', 'GRASP_targ_2_Rhodococcus', 4, NULL),
(21981, NULL, 'IPR025700', NULL, 'L-lysine 6-monooxygenase/L-ornithine 5-monooxygenase', 'Lys/Orn_oxygenase', 4, NULL),
(21982, NULL, 'IPR026713', NULL, 'CRACD-like', 'CRACD-like', 4, NULL),
(21983, NULL, 'IPR030844', NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', 'PAN3', 4, NULL),
(21984, NULL, 'IPR029245', NULL, 'Protein of unknown function DUF4528', 'DUF4528', 4, NULL),
(21985, NULL, 'IPR028185', NULL, 'Immunity protein 70', 'Imm70', 4, NULL),
(21986, NULL, 'IPR032837', NULL, 'Glycerol-1-phosphate dehydrogenase', 'G1PDH', 4, NULL),
(21987, NULL, 'IPR032377', NULL, 'STAR protein, homodimerisation region', 'STAR_dimer', 3, NULL),
(21988, NULL, 'IPR029231', NULL, 'Fimbrillin-like', 'Mfa-like_2', 4, NULL),
(21989, NULL, 'IPR026088', NULL, 'Niban-like', 'Niban-like', 4, NULL),
(21990, NULL, 'IPR032581', NULL, 'Protein of unknown function DUF4917', 'DUF4917', 4, NULL),
(21991, NULL, 'IPR025380', NULL, 'Domain of unknown function DUF4369', 'DUF4369', 3, NULL),
(21992, NULL, 'IPR029183', NULL, 'C-X-C motif chemokine 17', 'CXCL17', 4, NULL),
(21993, NULL, 'IPR026722', NULL, 'Neuronal tyrosine-phosphorylated phosphoinositide-3-kinase adapter 1/2', 'NYAP1/NYAP2', 4, NULL),
(21994, NULL, 'IPR029254', NULL, 'MORF4 family-associated protein 1', 'MRFAP1', 4, NULL),
(21995, NULL, 'IPR032834', NULL, 'Sensor histidine kinase NatK, C-terminal domain', 'NatK_C', 3, NULL),
(21996, NULL, 'IPR029269', NULL, 'Putative treble-clef, zinc-finger domain', 'Zf-tcix', 3, NULL),
(21997, NULL, 'IPR025944', NULL, 'Sigma-54 interaction domain, conserved site', 'Sigma_54_int_dom_CS', 2, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(21998, NULL, 'IPR032791', NULL, 'Uncharacterised protein YhfZ, C-terminal domain', 'YhfZ_C', 3, NULL),
(21999, NULL, 'IPR032578', NULL, 'Protein of unknown function DUF4919', 'DUF4919', 4, NULL),
(22000, NULL, 'IPR028141', NULL, 'Transcriptional regulator', 'Transcriptional_reg_dom', 3, NULL),
(22001, NULL, 'IPR025342', NULL, 'Protein of unknown function DUF4248', 'DUF4248', 4, NULL),
(22002, NULL, 'IPR032756', NULL, 'Domain of unknown function DUF4685', 'DUF4685', 3, NULL),
(22003, NULL, 'IPR025329', NULL, 'Protein of unknown function DUF4235', 'DUF4235', 4, NULL),
(22004, NULL, 'IPR027835', NULL, 'Transmembrane protein 174', 'TMEM174', 4, NULL),
(22005, NULL, 'IPR024342', NULL, 'Bacteriophage baseplate structural protein Gp28', 'Phage_T4_Gp28', 4, NULL),
(22006, NULL, 'IPR024362', NULL, 'Protein of unknown function DUF2685', 'DUF2685', 4, NULL),
(22007, NULL, 'IPR031909', NULL, 'Alginate biosynthesis sensor protein KinB, sensor domain', 'KinB_sensor_dom', 3, NULL),
(22008, NULL, 'IPR024978', NULL, 'Homeodomain, phBC6A51-type', 'Homeodomain_phBC6A51-type', 3, NULL),
(22009, NULL, 'IPR027834', NULL, 'Pre-T-cell antigen receptor', 'PTCRA', 4, NULL),
(22010, NULL, 'IPR031838', NULL, 'Fe-S cluster assembly protein Dre2, N-terminal', 'Dre2_N', 3, NULL),
(22011, NULL, 'IPR025910', NULL, 'Plant viral polyprotein P1, serine peptidase domain', 'P1_Ser_Pept_dom', 3, NULL),
(22012, NULL, 'IPR031863', NULL, 'Protein of unknown function DUF4755', 'DUF4755', 4, NULL),
(22013, NULL, 'IPR024975', NULL, 'Protein NO VEIN, C-terminal', 'NOV_C', 3, NULL),
(22014, NULL, 'IPR025383', NULL, 'MrpA C-terminal/MbhD', 'MrpA_C/MbhD', 3, NULL),
(22015, NULL, 'IPR032803', NULL, 'PLD-like domain', 'PLDc_3', 3, NULL),
(22016, NULL, 'IPR026794', NULL, 'Uncharacterised protein family UPF0687', 'UPF0687', 4, NULL),
(22017, NULL, 'IPR026296', NULL, 'CXC chemokine 16', 'CXCL16', 4, NULL),
(22018, NULL, 'IPR032140', NULL, 'Intersectin-1, AP2 binding region', 'INTAP', 3, NULL),
(22019, NULL, 'IPR024377', NULL, 'RNA-binding protein, B2', 'RNA-bd_B2', 4, NULL),
(22020, NULL, 'IPR026617', NULL, 'Transmembrane and coiled-coil domain-containing protein 2/5', 'SMCO2/5', 4, NULL),
(22021, NULL, 'IPR031911', NULL, 'Pesticin immunity protein', 'Pim', 4, NULL),
(22022, NULL, 'IPR032801', NULL, 'Peroxiredoxin-like 2A/B/C', 'PXL2A/B/C', 4, NULL),
(22023, NULL, 'IPR025907', NULL, 'Phostensin/Taperin PP1-binding domain', 'Phostensin/Taperin_PP1-bd_dom', 3, NULL),
(22024, NULL, 'IPR029520', NULL, 'Nucleoredoxin-like protein 1', 'RdCVF', 4, NULL),
(22025, NULL, 'IPR026297', NULL, 'FMRFamide-related peptide/Growth hormone-releasing peptide', 'FMRFamide-related/fGRP', 4, NULL),
(22026, NULL, 'IPR031823', NULL, 'TRAP transporter T-component', 'TatT', 4, NULL),
(22027, NULL, 'IPR031839', NULL, 'Protein of unknown function DUF5070', 'DUF5070', 4, NULL),
(22028, NULL, 'IPR031908', NULL, 'Germinal-centre associated nuclear protein, nucleoporin homology domain', 'NupH_GANP', 3, NULL),
(22029, NULL, 'IPR024981', NULL, 'Domain of unknown function DUF3887', 'DUF3887', 3, NULL),
(22030, NULL, 'IPR027585', NULL, 'Pantocin A family RiPP precursor', 'Pantocin_A_RiPP_pre', 4, NULL),
(22031, NULL, 'IPR028879', NULL, 'NADPH-dependent diflavin oxidoreductase 1', 'NDOR1', 4, NULL),
(22032, NULL, 'IPR032771', NULL, 'Protein of unknown function DUF4527', 'DUF4527', 4, NULL),
(22033, NULL, 'IPR032493', NULL, 'Phage tail tube protein family', 'Phage_TTP_13', 4, NULL),
(22034, NULL, 'IPR025113', NULL, 'TRL-like protein family', 'TRL-like', 4, NULL),
(22035, NULL, 'IPR025755', NULL, '60S ribosomal protein L4, C-terminal domain', 'Ribos_L4_C_dom', 3, NULL),
(22036, NULL, 'IPR024401', NULL, 'WYL domain containing protein', 'WYL_prot', 4, NULL),
(22037, NULL, 'IPR031811', NULL, 'AlgX/AlgJ, SGNH hydrolase-like domain', 'ALGX/ALGJ_SGNH-like', 3, NULL),
(22038, NULL, 'IPR024350', NULL, 'Hepatitus C virus, Non-structural 5a protein, C-terminal', 'HCV_NS5a_C', 3, NULL),
(22039, NULL, 'IPR031817', NULL, 'DotD protein', 'DotD', 4, NULL),
(22040, NULL, 'IPR030885', NULL, 'Putative large structural protein', 'Lepto_longest', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(22041, NULL, 'IPR030895', NULL, 'T5SS/PEP-CTERM-associated repeat', 'T5SS_PEPC_rpt', 7, NULL),
(22042, NULL, 'IPR024810', NULL, 'Mab-21-like', 'Mab-21-like', 4, NULL),
(22043, NULL, 'IPR024842', NULL, 'Triple repetitive-sequence of QXXK/R protein', 'TRIQK', 4, NULL),
(22044, NULL, 'IPR026806', NULL, 'Protein CDV3', 'CDV3', 4, NULL),
(22045, NULL, 'IPR025748', NULL, 'PrcB C-terminal domain', 'PrcB_C_dom', 3, NULL),
(22046, NULL, 'IPR025458', NULL, 'Protein of unknown function DUF4278', 'DUF4278', 4, NULL),
(22047, NULL, 'IPR032757', NULL, 'Domain of unknown function DUF4683', 'DUF4683', 3, NULL),
(22048, NULL, 'IPR024608', NULL, 'Smad anchor for receptor activation, Smad-binding domain', 'SARA_Smad-bd', 3, NULL),
(22049, NULL, 'IPR024688', NULL, 'Maltose/galactoside acetyltransferase', 'Mac_dom', 3, NULL),
(22050, NULL, 'IPR031537', NULL, 'Protein of unknown function DUF5092', 'DUF5092', 4, NULL),
(22051, NULL, 'IPR027024', NULL, 'ABC-type uncharacterised transport system, substrate-binding component, TM0202 type', 'UCP027386_ABC_sbc_TM0202', 4, NULL),
(22052, NULL, 'IPR032763', NULL, 'Resistance to inhibitors of cholinesterase protein 3, N-terminal', 'RIC3_N', 3, NULL),
(22053, NULL, 'IPR024349', NULL, 'Human herpesvirus 5 RL5A/RL6', 'HHV5_RL5A/RL6', 4, NULL),
(22054, NULL, 'IPR031865', NULL, 'Domain of unknown function DUF4757', 'DUF4757', 3, NULL),
(22055, NULL, 'IPR025457', NULL, 'Domain of unknown function DUF4277', 'DUF4277', 3, NULL),
(22056, NULL, 'IPR030113', NULL, 'Actin-filament associated protein', 'AFAP', 4, NULL),
(22057, NULL, 'IPR025438', NULL, 'Domain of unknown function DUF4180', 'DUF4180', 3, NULL),
(22058, NULL, 'IPR024399', NULL, 'Protein of unknown function DUF2628', 'DUF2628', 4, NULL),
(22059, NULL, 'IPR031820', NULL, 'CRISPR-associated protein Csn2 subfamily St', 'Cas_St_Csn2', 4, NULL),
(22060, NULL, 'IPR027499', NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit F, mitochondrial', 'GatF', 4, NULL),
(22061, NULL, 'IPR031585', NULL, 'Putative OmpA-OmpF-like porin family', 'OmpA_OmpF-like', 4, NULL),
(22062, NULL, 'IPR032486', NULL, 'JNK-interacting protein, leucine zipper II', 'JIP_LZII', 3, NULL),
(22063, NULL, 'IPR032786', NULL, 'Nsp2, transmembrane domain', 'NSP2_TM_arteriviridae', 3, NULL),
(22064, NULL, 'IPR024405', NULL, 'Prophage protein BhlA/UviB', 'Phage_BhlA/UviB', 4, NULL),
(22065, NULL, 'IPR025974', NULL, 'Mif2/CENP-C cupin domain', 'Mif2/CENP-C_cupin', 3, NULL),
(22066, NULL, 'IPR026085', NULL, 'Activating transcription factor 7-interacting protein', 'ATF7-int', 4, NULL),
(22067, NULL, 'IPR025405', NULL, 'Domain of unknown function DUF4131', 'DUF4131', 3, NULL),
(22068, NULL, 'IPR025445', NULL, 'Protein of unknown function DUF4191', 'DUF4191', 4, NULL),
(22069, NULL, 'IPR025394', NULL, 'Protein of unknown function DUF4127', 'DUF4127', 4, NULL),
(22070, NULL, 'IPR024402', NULL, 'Domain of unknown function DUF2726', 'DUF2726', 3, NULL),
(22071, NULL, 'IPR026621', NULL, 'Immortalization up-regulated protein', 'IMUP', 4, NULL),
(22072, NULL, 'IPR032504', NULL, 'Domain of unknown function DUF4978', 'DUF4978', 3, NULL),
(22073, NULL, 'IPR031837', NULL, 'Domain of unknown function DUF5071', 'DUF5071', 3, NULL),
(22074, NULL, 'IPR031328', NULL, 'Ephrin', 'Ephrin', 4, NULL),
(22075, NULL, 'IPR024374', NULL, 'Bacteriophage phi-29 scaffolding protein Gp7', 'Phage_phi-29_Gp7', 4, NULL),
(22076, NULL, 'IPR031159', NULL, 'Helper-component proteinase (HC-Pro) cysteine protease (CPD) domain', 'HC_PRO_CPD_dom', 3, NULL),
(22077, NULL, 'IPR025326', NULL, 'Protein of unknown function DUF4232', 'DUF4232', 4, NULL),
(22078, NULL, 'IPR025403', NULL, 'Domain of unknown function DUF4129', 'DUF4129', 3, NULL),
(22079, NULL, 'IPR024687', NULL, 'MMS19, C-terminal', 'MMS19_C', 3, NULL),
(22080, NULL, 'IPR033991', NULL, 'Selectin, C-type lectin-like domain', 'Selectin_CTLD', 3, NULL),
(22081, NULL, 'IPR024398', NULL, 'Poxvirus poly(A) polymerase, catalytic subunit, N-terminal', 'Poxvirus_polyA_pol_cat_N', 3, NULL),
(22082, NULL, 'IPR025425', NULL, 'Tox-PAAR-like domain', 'Tox_PAAR-like', 3, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(22083, NULL, 'IPR028923', NULL, 'SAICAR synthetase/ADE2, N-terminal', 'SAICAR_synt/ADE2_N', 3, NULL),
(22084, NULL, 'IPR032840', NULL, 'CFAP91 domain', 'CFAP91_dom', 3, NULL),
(22085, NULL, 'IPR032512', NULL, 'Domain of unknown function DUF4969', 'DUF4969', 3, NULL),
(22086, NULL, 'IPR032248', NULL, 'Protein of unknown function DUF4823', 'DUF4823', 4, NULL),
(22087, NULL, 'IPR030887', NULL, 'YaiO family, OMP domain', 'OMP_YaiO_dom', 3, NULL),
(22088, NULL, 'IPR025313', NULL, 'Domain of unknown function DUF4217', 'DUF4217', 3, NULL),
(22089, NULL, 'IPR025331', NULL, 'Tuberculosis necrotizing toxin', 'TNT', 3, NULL),
(22090, NULL, 'IPR026797', NULL, 'HAUS augmin-like complex subunit 6', 'HAUS_6', 4, NULL),
(22091, NULL, 'IPR025454', NULL, 'Protein of unknown function DUF4275', 'DUF4275', 4, NULL),
(22092, NULL, 'IPR026623', NULL, 'Mucin-like protein 3', 'MUCL3', 4, NULL),
(22093, NULL, 'IPR024358', NULL, 'Non-structural protein NSP3, N-terminal, betacoronavirus', 'NSP3_N_bCoV', 3, NULL),
(22094, NULL, 'IPR025345', NULL, 'Protein of unknown function DUF4249', 'DUF4249', 4, NULL),
(22095, NULL, 'IPR025459', NULL, 'Protein of unknown function DUF4279', 'DUF4279', 4, NULL),
(22096, NULL, 'IPR024351', NULL, 'Tegument protein UL11, Herpesvirus', 'Tegument_UL11_Herpesvir', 4, NULL),
(22097, NULL, 'IPR031596', NULL, 'Putative methionine and alanine importer, small subunit', 'MaAIMP_sms', 4, NULL),
(22098, NULL, 'IPR030697', NULL, 'Ras-related protein Rab29/Rab38/Rab32', 'Rab29/Rab38/Rab32', 4, NULL),
(22099, NULL, 'IPR031580', NULL, 'Pilus assembly protein TadZ, N-terminal', 'TadZ_N', 3, NULL),
(22100, NULL, 'IPR032772', NULL, 'Poly-beta-1,6-N-acetyl-D-glucosamine N-deacetylase PgaB, C-terminal', 'PGA_deacetylase_PgaB_C', 3, NULL),
(22101, NULL, 'IPR032779', NULL, 'Flagellar motor switch protein FliG, middle domain', 'FliG_M', 3, NULL),
(22102, NULL, 'IPR028214', NULL, 'Testis-specific serine kinase substrate', 'TSKS', 4, NULL),
(22103, NULL, 'IPR031539', NULL, 'Protein of unknown function DUF5090', 'DUF5090', 4, NULL),
(22104, NULL, 'IPR028342', NULL, 'Tetrahydromethanopterin S-methyltransferase subunit H', 'MtrH', 4, NULL),
(22105, NULL, 'IPR031836', NULL, 'Late transcription coactivator', 'Trans_coact', 4, NULL),
(22106, NULL, 'IPR027579', NULL, 'Surface protein repeat SSSPR-51', 'SSSPR51_Rpt', 7, NULL),
(22107, NULL, 'IPR031866', NULL, 'Domain of unknown function DUF4758', 'DUF4758', 3, NULL),
(22108, NULL, 'IPR025909', NULL, 'Phosphoprotein P soyouz module', 'Soyouz_module', 3, NULL),
(22109, NULL, 'IPR028207', NULL, 'DNA polymerase beta, palm domain', 'DNA_pol_B_palm_palm', 3, NULL),
(22110, NULL, 'IPR024409', NULL, 'Protein of unknown function DUF3833', 'DUF3833', 4, NULL),
(22111, NULL, 'IPR024845', NULL, 'Actin remodeling regulator NHS', 'NHS_fam', 4, NULL),
(22112, NULL, 'IPR024864', NULL, 'Nucleoporin Nup54/Nup57/Nup44', 'Nup54/Nup57/Nup44', 4, NULL),
(22113, NULL, 'IPR024422', NULL, 'Protein of unknown function, OB-fold-containing', 'Protein_unknown_function_OB', 4, NULL),
(22114, NULL, 'IPR026618', NULL, 'M-phase-specific PLK1-interacting protein-like,  vertebrate', 'MPLKIP-like_vertebrate', 4, NULL),
(22115, NULL, 'IPR031590', NULL, 'Pre-mRNA-splicing factor Prp9, N-terminal', 'PRP9_N', 3, NULL),
(22116, NULL, 'IPR025977', NULL, 'Nuclear condensin complex subunit 3, C-terminal domain', 'Cnd3_C', 3, NULL),
(22117, NULL, 'IPR025133', NULL, 'Poxvirus B22R protein N-terminal domain', 'Poxvirus_B22R_N_dom', 3, NULL),
(22118, NULL, 'IPR025318', NULL, 'Protein of unknown function DUF4223', 'DUF4223', 4, NULL),
(22119, NULL, 'IPR031818', NULL, 'Protein Hri1', 'Hri1', 4, NULL),
(22120, NULL, 'IPR025436', NULL, 'Domain of unknown function DUF4179', 'DUF4179', 3, NULL),
(22121, NULL, 'IPR024992', NULL, 'Protein of unknown function DUF3891', 'DUF3891', 4, NULL),
(22122, NULL, 'IPR028192', NULL, 'Bcl-2-modifying factor', 'BMF', 4, NULL),
(22123, NULL, 'IPR025429', NULL, 'Domain of unknown function DUF4165', 'DUF4165', 3, NULL),
(22124, NULL, 'IPR031912', NULL, 'Sharpin, PH domain', 'Sharpin_PH', 3, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(22125, NULL, 'IPR032838', NULL, 'VWA-Hint protein, Vwaint domain', 'Vwaint_dom', 3, NULL),
(22126, NULL, 'IPR025314', NULL, 'Domain of unknown function DUF4219', 'DUF4219', 3, NULL),
(22127, NULL, 'IPR026838', NULL, 'Endospore coat-associated protein YheC/D', 'YheC/D', 4, NULL),
(22128, NULL, 'IPR024376', NULL, 'Phlebovirus, non structural protein', 'RVFV_non-structural', 4, NULL),
(22129, NULL, 'IPR024836', NULL, 'Janus kinase and microtubule-interacting protein', 'JAKMIP', 4, NULL),
(22130, NULL, 'IPR028651', NULL, 'ING family', 'ING_fam', 4, NULL),
(22131, NULL, 'IPR025105', NULL, 'Domain of unknown function DUF4010', 'DUF4010', 3, NULL),
(22132, NULL, 'IPR026610', NULL, '3''-RNA ribose 2''-O-methyltransferase, Hen1', 'Hen1', 4, NULL),
(22133, NULL, 'IPR025753', NULL, 'AAA-type ATPase, N-terminal domain', 'AAA_N_dom', 3, NULL),
(22134, NULL, 'IPR024406', NULL, 'Phage tail assembly chaperone TAC-10', 'TAC-10', 4, NULL),
(22135, NULL, 'IPR026820', NULL, 'Iminophenyl-pyruvate dimer synthase', 'VioB/RebD_dom', 3, NULL),
(22136, NULL, 'IPR024833', NULL, 'Regulated endocrine-specific protein 18', 'RESP18', 4, NULL),
(22137, NULL, 'IPR032751', NULL, 'Protein fuseless', 'Fuseless', 4, NULL),
(22138, NULL, 'IPR031789', NULL, 'NBD94 domain', 'NBD94', 3, NULL),
(22139, NULL, 'IPR025341', NULL, 'Protein of unknown function DUF4247', 'DUF4247', 4, NULL),
(22140, NULL, 'IPR024596', NULL, 'DNA-directed RNA polymerase subunit beta/EpuA', 'RNApol_su_b/EpuA', 4, NULL),
(22141, NULL, 'IPR024394', NULL, 'RNA polymerase, 30kDa subunit, chordopox-type, N-terminal', 'RNA_pol_30_chordopoxvir-type_N', 3, NULL),
(22142, NULL, 'IPR032758', NULL, 'Antitoxin MqsA/HigA-2', 'MqsA/HigA-2', 4, NULL),
(22143, NULL, 'IPR031788', NULL, 'CS6 fimbrial subunit A/B', 'CssA/B', 4, NULL),
(22144, NULL, 'IPR032426', NULL, 'SUMO-activating enzyme subunit 2, C-terminal domain', 'UBA2_C', 3, NULL),
(22145, NULL, 'IPR026841', NULL, 'Inositolphosphotransferase Aur1/Ipt1', 'Aur1/Ipt1', 3, NULL),
(22146, NULL, 'IPR024418', NULL, 'Protein of unknown function DUF3862', 'DUF3862', 4, NULL),
(22147, NULL, 'IPR032762', NULL, 'Putative polysaccharide deacetylase', 'Polysacc_deac_3', 4, NULL),
(22148, NULL, 'IPR031844', NULL, 'Voltage-gated hydrogen channel 1, C-terminal membrane-localisation domain', 'VGPC1_C', 3, NULL),
(22149, NULL, 'IPR031792', NULL, 'Surface antigen, GAG-binding domain', 'GAG_BD', 3, NULL),
(22150, NULL, 'IPR025334', NULL, 'Domain of unknown function (DUF4240)', 'DUF4240', 3, NULL),
(22151, NULL, 'IPR031971', NULL, 'Unconventional myosin-X, coiled coil domain', 'MYO10_CC', 3, NULL),
(22152, NULL, 'IPR032494', NULL, 'Lambda phage tail tube protein', 'Phage_TTP_12', 4, NULL),
(22153, NULL, 'IPR025041', NULL, 'Protein of unknown function DUF3983', 'DUF3983', 4, NULL),
(22154, NULL, 'IPR028880', NULL, 'ATP-dependent DNA helicase Rrm3', 'Rrm3', 4, NULL),
(22155, NULL, 'IPR026825', NULL, 'Vacuole morphology and inheritance protein 14', 'Vac14', 4, NULL),
(22156, NULL, 'IPR024868', NULL, 'Four-jointed box protein 1/four-jointed protein', 'FJX1/FJ', 4, NULL),
(22157, NULL, 'IPR031829', NULL, 'Effector protein NleF', 'NleF', 4, NULL),
(22158, NULL, 'IPR032252', NULL, 'Protein of unknown function DUF4827', 'DUF4827', 4, NULL),
(22159, NULL, 'IPR032782', NULL, 'RNA-binding protein KhpB, N-terminal', 'KhpB_N', 3, NULL),
(22160, NULL, 'IPR025449', NULL, 'Wadjet protein JetB', 'JetB', 4, NULL),
(22161, NULL, 'IPR032497', NULL, 'Uncharacterised protein YmgD', 'YmgD', 4, NULL),
(22162, NULL, 'IPR025069', NULL, 'Cleavage and polyadenylation specificity factor 2, C-terminal', 'Cpsf2_C', 3, NULL),
(22163, NULL, 'IPR025136', NULL, 'MAP3K, TRAFs-binding domain', 'MAP3K_TRAF-bd', 3, NULL),
(22164, NULL, 'IPR031786', NULL, 'Krueppel-like factor 1, transactivation domain 1', 'EKLF_TAD1', 3, NULL),
(22165, NULL, 'IPR032755', NULL, 'Translin-associated factor X-interacting protein 1, N-terminal', 'TSNAXIP1_N', 3, NULL),
(22166, NULL, 'IPR032767', NULL, 'Ascaris metallocarboxypeptidase inhibitor', 'ACI44', 4, NULL),
(22167, NULL, 'IPR024390', NULL, 'RNA polymerase, 132kDa subunit, poxvirus-type', 'RNA_pol_132_poxvirus', 4, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(22168, NULL, 'IPR026616', NULL, 'Testis-expressed sequence 15 protein', 'TEX15', 4, NULL),
(22169, NULL, 'IPR032816', NULL, 'SNARE associated Golgi protein', 'SNARE_assoc', 4, NULL),
(22170, NULL, 'IPR025101', NULL, 'Protein of unknown function DUF4012', 'DUF4012', 4, NULL),
(22171, NULL, 'IPR025137', NULL, 'Bacteriophage N4 adsorption protein A, C-terminal', 'NfrA_C', 3, NULL),
(22172, NULL, 'IPR024347', NULL, 'GB virus, envelope protein', 'GB_virus_envelope', 3, NULL),
(22173, NULL, 'IPR032499', NULL, 'Bacteriophage CI repressor, C-terminal', 'Phage_CI_C', 3, NULL),
(22174, NULL, 'IPR025316', NULL, 'Protein of unknown function DUF4221', 'DUF4221', 4, NULL),
(22175, NULL, 'IPR024378', NULL, 'RNA-directed RNA polymerase, hantavirus, N-terminal', 'RNA-dir_pol_N_hantavirus', 3, NULL),
(22176, NULL, 'IPR031581', NULL, 'Mannosyl phosphorylinositol ceramide synthase regulatory protein Csg2', 'Csg2', 4, NULL),
(22177, NULL, 'IPR024413', NULL, 'Bacteriophage phiKZ, Orf92, internal head', 'Phage_phiKZ_Orf92_int-head', 4, NULL),
(22178, NULL, 'IPR025225', NULL, 'Protein of unknown function DUF3956', 'DUF3956', 4, NULL),
(22179, NULL, 'IPR029614', NULL, 'Chromatin remodeling regulator CECR2', 'CECR2', 4, NULL),
(22180, NULL, 'IPR025427', NULL, 'Protein of unknown function DUF4160', 'DUF4160', 4, NULL),
(22181, NULL, 'IPR024987', NULL, 'Protein of unknown function DUF3889', 'DUF3889', 4, NULL),
(22182, NULL, 'IPR025096', NULL, 'Protein of unknown function DUF4014', 'DUF4014', 4, NULL),
(22183, NULL, 'IPR032790', NULL, 'Glycogen debranching enzyme, C-terminal', 'GDE_C', 3, NULL),
(22184, NULL, 'IPR028216', NULL, 'DDB1- and CUL4-associated factor 16', 'DCAF16', 4, NULL),
(22185, NULL, 'IPR032841', NULL, 'Arterivirus polyprotein, nsp2, non-essential region', 'NSP2_assoc', 3, NULL),
(22186, NULL, 'IPR025315', NULL, 'Domain of unknown function DUF4220', 'DUF4220', 3, NULL),
(22187, NULL, 'IPR026622', NULL, 'Matrix-remodeling-associated protein 7', 'Mxra7', 4, NULL),
(22188, NULL, 'IPR024412', NULL, 'Lsr2', 'Lsr2', 4, NULL),
(22189, NULL, 'IPR024977', NULL, 'Anaphase-promoting complex subunit 4, WD40 domain', 'Apc4_WD40_dom', 3, NULL),
(22190, NULL, 'IPR027502', NULL, 'Inosine triphosphate pyrophosphatase', 'ITPase', 4, NULL),
(22191, NULL, 'IPR031815', NULL, 'Protein of unknown function DUF5074', 'DUF5074', 4, NULL),
(22192, NULL, 'IPR031283', NULL, 'Amphoterin-induced protein', 'AMIGO', 4, NULL),
(22193, NULL, 'IPR028208', NULL, 'Effector protein NleD-like', 'Effector_pro_NleD-like', 4, NULL),
(22194, NULL, 'IPR030850', NULL, 'Exosome complex component Csl4, archaea', 'Exosome_Csl4_arc', 4, NULL),
(22195, NULL, 'IPR024346', NULL, 'Tegument protein, herpes virus, N-terminal domain', 'Tegument_herpes_virus_N', 3, NULL),
(22196, NULL, 'IPR024345', NULL, 'DNA maturase, bacteriophage T7-like', 'DNA_matur_Phage_T7-like', 4, NULL),
(22197, NULL, 'IPR032776', NULL, 'CECR6/TMEM121 family', 'CECR6/TMEM121', 4, NULL),
(22198, NULL, 'IPR031579', NULL, 'Rough colony protein B', 'RcpB', 4, NULL),
(22199, NULL, 'IPR025110', NULL, 'AMP-binding enzyme, C-terminal domain', 'AMP-bd_C', 3, NULL),
(22200, NULL, 'IPR030456', NULL, 'Fork head domain conserved site 2', 'TF_fork_head_CS_2', 2, NULL),
(22201, NULL, 'IPR025407', NULL, 'Protein of unknown function DUF4133', 'DUF4133', 4, NULL),
(22202, NULL, 'IPR024849', NULL, 'Shootin-1', 'Shootin-1', 4, NULL),
(22203, NULL, 'IPR024976', NULL, 'Domain of unknown function DUF3885', 'DUF3885', 3, NULL),
(22204, NULL, 'IPR024421', NULL, 'Bacteriophage P22, Mnt', 'Phage_P22_Mnt', 4, NULL),
(22205, NULL, 'IPR025138', NULL, 'Domain of unknown function DUF4072', 'DUF4072', 3, NULL),
(22206, NULL, 'IPR031578', NULL, 'Na+ channel auxiliary subunit TipE', 'TipE', 4, NULL),
(22207, NULL, 'IPR025046', NULL, 'Domain of unknown function DUF3960', 'DUF3960', 3, NULL),
(22208, NULL, 'IPR025444', NULL, 'Monooxygenase af470-like', 'Monooxy_af470', 4, NULL),
(22209, NULL, 'IPR024855', NULL, 'UNC79', 'UNC79', 4, NULL),
(22210, NULL, 'IPR032769', NULL, 'Nck-associated protein 5, C-terminal', 'NCKAP5_C', 3, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(22211, NULL, 'IPR027290', NULL, 'Platelet-derived growth factor receptor alpha', 'PDGFRA', 4, NULL),
(22212, NULL, 'IPR031586', NULL, 'Haemoglobin-haptoglobin utilisation, porphyrin transporter', 'HpuA', 4, NULL),
(22213, NULL, 'IPR025325', NULL, 'Protein of unknown function DUF4231', 'DUF4231', 4, NULL),
(22214, NULL, 'IPR032159', NULL, 'Domain of unknown function DUF4995', 'DUF4995', 3, NULL),
(22215, NULL, 'IPR025330', NULL, 'Domain of unknown function DUF4236', 'DUF4236', 3, NULL),
(22216, NULL, 'IPR024980', NULL, 'Protein of unknown function DUF3886', 'DUF3886', 4, NULL),
(22217, NULL, 'IPR031902', NULL, 'Telomeric repeat-binding factor 2, Rap1-binding domain', 'TERF2_RBM', 3, NULL),
(22218, NULL, 'IPR029866', NULL, 'Steroidogenic acute regulatory protein', 'StAR', 4, NULL),
(22219, NULL, 'IPR032778', NULL, 'Growth factor receptor domain 4', 'GF_recep_IV', 3, NULL),
(22220, NULL, 'IPR025452', NULL, 'Domain of unknown function DUF4218', 'DUF4218', 3, NULL),
(22221, NULL, 'IPR032794', NULL, 'Protein Lines, N-terminal', 'LINES_N', 3, NULL),
(22222, NULL, 'IPR025742', NULL, 'Cleavage stimulation factor subunit 2, hinge domain', 'CSTF2_hinge', 3, NULL),
(22223, NULL, 'IPR025406', NULL, 'Domain of unknown function DUF4132', 'DUF4132', 3, NULL),
(22224, NULL, 'IPR025217', NULL, 'Domain of unknown function DUF3944', 'DUF3944', 3, NULL),
(22225, NULL, 'IPR032747', NULL, 'FMR1-interacting protein 2', 'NUFIP2', 4, NULL),
(22226, NULL, 'IPR024389', NULL, 'Baseplate tail-tube protein gp48, T4-like virus', 'Gp48_T4-like', 4, NULL),
(22227, NULL, 'IPR024397', NULL, 'Poxvirus poly(A) polymerase, catalytic subunit, C-terminal', 'Poxvirus_polyA_pol_cat_C', 3, NULL),
(22228, NULL, 'IPR025343', NULL, 'Protein of unknown function DUF4099', 'DUF4099', 4, NULL),
(22229, NULL, 'IPR026295', NULL, 'Coiled-coil domain-containing protein 81', 'Coiled-coil_dom_cont_p_81', 4, NULL),
(22230, NULL, 'IPR031327', NULL, 'Mini-chromosome maintenance protein', 'MCM', 4, NULL),
(22231, NULL, 'IPR025746', NULL, 'Type 4 fimbrial biogenesis protein PilX, N-terminal domain', 'PilX_N_dom', 3, NULL),
(22232, NULL, 'IPR025222', NULL, 'Protein of unknown function DUF3945', 'DUF3945', 3, NULL),
(22233, NULL, 'IPR025128', NULL, 'Poxvirus B22R protein C-terminal domain', 'Poxvirus_B22R_C_dom', 3, NULL),
(22234, NULL, 'IPR024829', NULL, 'Radiation-inducible immediate-early gene IEX-1', 'IEX-1', 4, NULL),
(22235, NULL, 'IPR026832', NULL, 'Asteroid', 'Asteroid', 4, NULL),
(22236, NULL, 'IPR025098', NULL, 'Protein of unknown function DUF4013', 'DUF4013', 4, NULL),
(22237, NULL, 'IPR025390', NULL, 'DSC E3 ubiquitin ligase complex subunit 3, C-terminal', 'Dsc3_C', 3, NULL),
(22238, NULL, 'IPR032160', NULL, 'Domain of unknown function DUF4996', 'DUF4996', 3, NULL),
(22239, NULL, 'IPR029790', NULL, 'EFG1/Phd1/StuA family', 'EFG1/Phd1/StuA', 4, NULL),
(22240, NULL, 'IPR024957', NULL, 'Cep57 centrosome microtubule-binding domain', 'Cep57_MT-bd_dom', 3, NULL),
(22241, NULL, 'IPR024872', NULL, 'HEXIM', 'HEXIM', 4, NULL),
(22242, NULL, 'IPR026801', NULL, 'Transmembrane protein 160', 'TMEM160', 4, NULL),
(22243, NULL, 'IPR024822', NULL, 'Coilin', 'Coilin', 4, NULL),
(22244, NULL, 'IPR032749', NULL, 'Frog antimicrobial peptide Nigrocin', 'Nigrocin', 4, NULL),
(22245, NULL, 'IPR029867', NULL, 'StAR-related lipid transfer protein 3, C-terminal', 'STARD3_MLN64_C', 3, NULL),
(22246, NULL, 'IPR025092', NULL, 'Glycosyl hydrolase family 66', 'Glyco_hydro_66', 4, NULL),
(22247, NULL, 'IPR031790', NULL, 'Nitric oxide synthase-interacting protein, zinc-finger', 'Znf-NOSIP', 3, NULL),
(22248, NULL, 'IPR028213', NULL, 'PTIP-associated protein 1', 'PA1', 4, NULL),
(22249, NULL, 'IPR031867', NULL, 'MiT/TFE transcription factors, N-terminal', 'MiT/TFE_N', 3, NULL),
(22250, NULL, 'IPR034003', NULL, 'ATP-binding cassette transporter, PDR-like subfamily G, domain 2', 'ABCG_PDR_2', 3, NULL),
(22251, NULL, 'IPR024424', NULL, 'Replicative helicase inhibitor G39P, N-terminal', 'G39P_N', 3, NULL),
(22252, NULL, 'IPR025816', NULL, 'RrmJ-type ribose 2-O-methyltransferase domain', 'RrmJ-type_MeTrfase', 3, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(22253, NULL, 'IPR030891', NULL, 'HaoA-associated protein HaoB', 'HaoB_nitrify', 4, NULL),
(22254, NULL, 'IPR025743', NULL, 'IcmF-related, N-terminal domain', 'IcmF-related_N_dom', 3, NULL),
(22255, NULL, 'IPR024979', NULL, 'Protein of unknown function DUF3884', 'DUF3884', 4, NULL),
(22256, NULL, 'IPR029704', NULL, 'STEEP-like', 'STEEP-like', 4, NULL),
(22257, NULL, 'IPR032843', NULL, 'Cleavage inducing molecular chaperone, Jiv', 'Jiv', 3, NULL),
(22258, NULL, 'IPR028341', NULL, 'Complement factor B', 'Complement_B', 4, NULL),
(22259, NULL, 'IPR030671', NULL, 'Protein transport Sec61-beta/Sbh', 'Sec61-beta/Sbh', 4, NULL),
(22260, NULL, 'IPR025121', NULL, 'GTPase HflX, N-terminal', 'GTPase_HflX_N', 3, NULL),
(22261, NULL, 'IPR026624', NULL, 'Cat eye syndrome critical region protein 6', 'CECR6', 4, NULL),
(22262, NULL, 'IPR031540', NULL, 'Protein of unknown function DUF5088', 'DUF5088', 4, NULL),
(22263, NULL, 'IPR031160', NULL, 'F-BAR domain', 'F_BAR', 3, NULL),
(22264, NULL, 'IPR034074', NULL, 'Y4bN, peptidase domain', 'Y4bN_pept_dom', 3, NULL),
(22265, NULL, 'IPR025067', NULL, 'Protein of unknown function DUF4079', 'DUF4079', 4, NULL),
(22266, NULL, 'IPR031835', NULL, 'Antiactivator protein ExsD', 'ExsD', 4, NULL),
(22267, NULL, 'IPR030802', NULL, 'ABC transporter permease MalE', 'Permease_MalE', 4, NULL),
(22268, NULL, 'IPR025213', NULL, 'Kinetochore Sim4 complex subunit Fta2', 'Sim4_Fta2', 4, NULL),
(22269, NULL, 'IPR028196', NULL, 'Keratinocyte differentiation-associated protein', 'KRTDAP', 4, NULL),
(22270, NULL, 'IPR025756', NULL, 'MYB-CC type transcription factor, LHEQLE-containing domain', 'Myb_CC_LHEQLE', 3, NULL),
(22271, NULL, 'IPR028215', NULL, 'Refilin family', 'Refilin', 4, NULL),
(22272, NULL, 'IPR024352', NULL, 'RNA-dependent RNA polymerase L methyltransferase domain, paramyxovirus', 'L_methyltrans_paramyxo', 3, NULL),
(22273, NULL, 'IPR025430', NULL, 'Domain of unknown function DUF4167', 'DUF4167', 3, NULL),
(22274, NULL, 'IPR032199', NULL, 'RecQ-mediated genome instability protein 1, C-terminal OB-fold domain', 'RMI1_C', 3, NULL),
(22275, NULL, 'IPR028203', NULL, 'Photosynthesis system II assembly factor Ycf48/Hcf136-like domain', 'PSII_CF48-like_dom', 3, NULL),
(22276, NULL, 'IPR029494', NULL, 'ssDNA thymidine ADP-ribosyltransferase, DarT', 'DarT', 3, NULL),
(22277, NULL, 'IPR025757', NULL, 'Ternary complex factor MIP1, leucine-zipper', 'MIP1_Leuzipper', 3, NULL),
(22278, NULL, 'IPR032251', NULL, 'Protein of unknown function DUF4826', 'DUF4826', 4, NULL),
(22279, NULL, 'IPR028626', NULL, 'Ribosomal protein S28e conserved site', 'Ribosomal_S28e_CS', 2, NULL),
(22280, NULL, 'IPR032503', NULL, 'FAD dependent oxidoreductase, central domain', 'FAO_M', 3, NULL),
(22281, NULL, 'IPR028194', NULL, 'Coiled-coil domain-containing protein 167', 'CCDC-167', 4, NULL),
(22282, NULL, 'IPR025317', NULL, 'Protein of unknown function DUF4222', 'DUF4222', 4, NULL),
(22283, NULL, 'IPR025455', NULL, 'Protein of unknown function DUF4276', 'DUF4276', 4, NULL),
(22284, NULL, 'IPR034073', NULL, 'Subtilisin DY-like, domain', 'Subtilisin_DY-like_dom', 3, NULL),
(22285, NULL, 'IPR027833', NULL, 'Domain of unknown function DUF4525', 'DUF4525', 4, NULL),
(22286, NULL, 'IPR024689', NULL, 'Proteasome beta subunit, C-terminal', 'Proteasome_bsu_C', 3, NULL),
(22287, NULL, 'IPR028927', NULL, 'Mannose-6-phosphate receptor', 'Man-6-P_rcpt', 4, NULL),
(22288, NULL, 'IPR025451', NULL, 'Domain of unknown function DUF4211', 'DUF4211', 3, NULL),
(22289, NULL, 'IPR032773', NULL, 'Protein MGARP, N-terminal', 'MGARP_N', 3, NULL),
(22290, NULL, 'IPR025392', NULL, 'Domain of unknown function DUF4124', 'DUF4124', 3, NULL),
(22291, NULL, 'IPR032149', NULL, 'Domain of unknown function DUF4988', 'DUF4988', 3, NULL),
(22292, NULL, 'IPR031583', NULL, 'PelD, GGDEF domain', 'PelD_GGDEF', 3, NULL),
(22293, NULL, 'IPR025066', NULL, 'Coiled-coil domain-containing protein 174-like', 'CCDC174-like', 4, NULL),
(22294, NULL, 'IPR028343', NULL, 'Fructose-1,6-bisphosphatase', 'FBPtase', 4, NULL),
(22295, NULL, 'IPR025045', NULL, 'Protein of unknown function DUF3979', 'DUF3979', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(22296, NULL, 'IPR032784', NULL, '2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-succinyltransferase, middle domain', 'THDPS_M', 3, NULL),
(22297, NULL, 'IPR026619', NULL, 'Centrosomal protein of 95kDa', 'CEP95', 4, NULL),
(22298, NULL, 'IPR027841', NULL, 'Interleukin-17 receptor C/E, N-terminal', 'IL-17_rcpt_C/E_N', 3, NULL),
(22299, NULL, 'IPR024387', NULL, 'Peptidase C3G, Picornavirus', 'Pept_C3G_Picornavir', 3, NULL),
(22300, NULL, 'IPR026614', NULL, 'Angiopoietin-like protein 8', 'ANGPTL8', 4, NULL),
(22301, NULL, 'IPR024354', NULL, 'Hepatitis A virus, protein VP1-2A', 'Hepatitis_A_VP1-2A', 4, NULL),
(22302, NULL, 'IPR024344', NULL, 'Mycothiol-dependent maleylpyruvate isomerase, metal-binding domain', 'MDMPI_metal-binding', 3, NULL),
(22303, NULL, 'IPR025751', NULL, 'RsbT co-antagonist protein RsbRD, N-terminal domain', 'RsbRD_N_dom', 3, NULL),
(22304, NULL, 'IPR025408', NULL, 'Protein of unknown function DUF4134', 'DUF4134', 3, NULL),
(22305, NULL, 'IPR031840', NULL, 'Protein male-specific lethal-1, dimerisation domain', 'MSL1_dimer', 3, NULL),
(22306, NULL, 'IPR032250', NULL, 'Domain of unknown function DUF4825', 'DUF4825', 3, NULL),
(22307, NULL, 'IPR027827', NULL, 'Protein of unknown function DUF4523', 'DUF4523', 4, NULL),
(22308, NULL, 'IPR026823', NULL, 'Complement Clr-like EGF domain', 'cEGF', 3, NULL),
(22309, NULL, 'IPR031907', NULL, 'Germinal-centre associated nuclear protein, MCM3AP domain', 'MCM3AP_GANP', 3, NULL),
(22310, NULL, 'IPR031825', NULL, 'RXLR phytopathogen effector protein', 'RXLR', 4, NULL),
(22311, NULL, 'IPR032792', NULL, 'Glycogen debranching enzyme, glucanotransferase domain', 'AGL_glucanoTrfase', 3, NULL),
(22312, NULL, 'IPR025039', NULL, 'Protein of unknown function DUF3947', 'DUF3947', 4, NULL),
(22313, NULL, 'IPR025335', NULL, 'Protein of unknown function DUF4241', 'DUF4241', 4, NULL),
(22314, NULL, 'IPR025461', NULL, 'ABA DEFICIENT 4-like', 'ABA4-like', 4, NULL),
(22315, NULL, 'IPR025044', NULL, 'Domain of unknown function DUF3980', 'DUF3980', 3, NULL),
(22316, NULL, 'IPR028364', NULL, 'Ribosomal protein L1/ribosomal biogenesis protein', 'Ribosomal_L1/biogenesis', 4, NULL),
(22317, NULL, 'IPR032498', NULL, 'PI3K regulatory subunit p85-related , inter-SH2 domain', 'PI3K_P85_iSH2', 3, NULL),
(22318, NULL, 'IPR027830', NULL, 'Domain of unknown function DUF4524', 'DUF4524', 3, NULL),
(22319, NULL, 'IPR032488', NULL, 'Protein of unknown function DUF5049', 'DUF5049', 4, NULL),
(22320, NULL, 'IPR032495', NULL, 'Phage tail tube protein, lambda-like', 'Phage_TTP_11', 4, NULL),
(22321, NULL, 'IPR027836', NULL, 'Protein of unknown function DUF4529', 'DUF4529', 4, NULL),
(22322, NULL, 'IPR031906', NULL, 'Regulator of Ty1 transposition protein 107, BRCT domain', 'RTT107_BRCT_6', 3, NULL),
(22323, NULL, 'IPR025332', NULL, 'Protein of unknown function DUF4238', 'DUF4238', 4, NULL),
(22324, NULL, 'IPR024411', NULL, 'Minor capsid protein, bacteriophage', 'Minor_capsid_phage', 4, NULL),
(22325, NULL, 'IPR031816', NULL, 'Protein of unknown function DUF5073', 'DUF5073', 4, NULL),
(22326, NULL, 'IPR024343', NULL, 'Capsid protein VP4, dicistrovirus', 'VP4_dicistrovir', 3, NULL),
(22327, NULL, 'IPR029617', NULL, 'Lid2 complex component Snt2', 'Snt2', 4, NULL),
(22328, NULL, 'IPR025322', NULL, 'PADRE domain', 'PADRE_dom', 4, NULL),
(22329, NULL, 'IPR032196', NULL, 'Fragile X messenger ribonucleoprotein 1, C-terminal region 2', 'FMR1_C2', 3, NULL),
(22330, NULL, 'IPR032777', NULL, 'Domain of unknown function DUF4515', 'DUF4515', 3, NULL),
(22331, NULL, 'IPR032163', NULL, 'Domain of unknown function DUF4999', 'DUF4999', 3, NULL),
(22332, NULL, 'IPR032249', NULL, 'Protein of unknown function DUF4824', 'DUF4824', 4, NULL),
(22333, NULL, 'IPR024379', NULL, 'Waikavirus, capsid protein 1', 'Waikavirus_capsid-1', 4, NULL),
(22334, NULL, 'IPR028919', NULL, 'Viral movement protein', 'Viral_movement', 4, NULL),
(22335, NULL, 'IPR027815', NULL, 'CSC1/OSCA1-like, cytosolic domain', 'CSC1/OSCA1-like_cyt', 3, NULL),
(22336, NULL, 'IPR032799', NULL, 'Xylanase inhibitor, C-terminal', 'TAXi_C', 3, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(22337, NULL, 'IPR025310', NULL, 'Protein of unknown function DUF4164', 'DUF4164', 4, NULL),
(22338, NULL, 'IPR024364', NULL, 'Baseplate hub assembly protein, bacteriophage T4-like', 'Baseplate_phage_T4-like', 4, NULL),
(22339, NULL, 'IPR027825', NULL, 'Protein of unknown function DUF4522', 'DUF4522', 4, NULL),
(22340, NULL, 'IPR025971', NULL, 'LppP/LprE lipoprotein', 'LppP/LprE', 4, NULL),
(22341, NULL, 'IPR032768', NULL, 'G2 and S phase-expressed protein 1, N-terminal', 'GTSE1_N', 3, NULL),
(22342, NULL, 'IPR032780', NULL, 'DNA polymerase III subunit delta, C-terminal', 'DNA_pol3_delt_C', 3, NULL),
(22343, NULL, 'IPR027819', NULL, 'Guanine nucleotide exchange factor C9orf72', 'C9orf72', 4, NULL),
(22344, NULL, 'IPR025319', NULL, 'Domain of unknown function DUF4224', 'DUF4224', 3, NULL),
(22345, NULL, 'IPR025339', NULL, 'Protein of unknown function DUF4245', 'DUF4245', 4, NULL),
(22346, NULL, 'IPR025975', NULL, 'Polysaccharide lyase', 'Polysacc_lyase', 4, NULL),
(22347, NULL, 'IPR031594', NULL, 'Putative iron/lead transporter', 'OFeT_1', 4, NULL),
(22348, NULL, 'IPR026254', NULL, 'E3 ubiquitin-protein ligase RNF31-like', 'RNF31-like', 4, NULL),
(22349, NULL, 'IPR025212', NULL, 'Centromere protein Q', 'CAD_CENP-Q', 4, NULL),
(22350, NULL, 'IPR024408', NULL, 'N-acetylmuramidase', 'Muramidase', 3, NULL),
(22351, NULL, 'IPR025337', NULL, 'Questin oxidase-like', 'Questin_oxidase-like', 4, NULL),
(22352, NULL, 'IPR031822', NULL, 'Fiber protein 1, C-terminal', 'AdHead_fibreRBD', 3, NULL),
(22353, NULL, 'IPR025040', NULL, 'Protein of unknown function DUF3984', 'DUF3984', 4, NULL),
(22354, NULL, 'IPR025433', NULL, 'Domain of unknown function DUF4168', 'DUF4168', 3, NULL),
(22355, NULL, 'IPR025321', NULL, 'Protein of unknown function DUF4227', 'DUF4227', 4, NULL),
(22356, NULL, 'IPR032500', NULL, 'Spike glycoprotein S1, N-terminal domain, betacoronavirus-like', 'bCoV_S1_N', 3, NULL),
(22357, NULL, 'IPR025340', NULL, 'Protein of unknown function DUF4246', 'DUF4246', 4, NULL),
(22358, NULL, 'IPR025333', NULL, 'Protein of unknown function DUF4239', 'DUF4239', 4, NULL),
(22359, NULL, 'IPR025338', NULL, 'Protein of unknown function DUF4244', 'DUF4244', 4, NULL),
(22360, NULL, 'IPR031791', NULL, 'Avirulence protein ATR13', 'ATR13', 4, NULL),
(22361, NULL, 'IPR024360', NULL, 'Cytoplasmic envelopment protein 3, herpesvirus', 'Herpesvirus_CEP3', 4, NULL),
(22362, NULL, 'IPR025404', NULL, 'Domain of unknown function DUF4130', 'DUF4130', 3, NULL),
(22363, NULL, 'IPR030888', NULL, 'Putative ccm operon protein', 'Put_ccm', 4, NULL),
(22364, NULL, 'IPR026802', NULL, 'Odontogenic ameloblast-associated protein', 'Odam', 4, NULL),
(22365, NULL, 'IPR034075', NULL, 'Glr3161-like, domain', 'Glr3161-like_dom', 3, NULL),
(22366, NULL, 'IPR024900', NULL, 'O-acetyl-ADP-ribose deacetylase', 'O-Ac-ADP-ribose_deAcase', 4, NULL),
(22367, NULL, 'IPR025749', NULL, 'Sphingomyelin synthase-like domain', 'Sphingomyelin_synth-like_dom', 3, NULL),
(22368, NULL, 'IPR025327', NULL, 'Protein of unknown function DUF4233', 'DUF4233', 4, NULL),
(22369, NULL, 'IPR032514', NULL, 'Domain of unknown function DUF4965', 'DUF4965', 3, NULL),
(22370, NULL, 'IPR024988', NULL, 'Domain of unknown function DUF3890', 'DUF3890', 3, NULL),
(22371, NULL, 'IPR032136', NULL, 'Neutrophil cytosol factor 1, PBR/AIR', 'NCF1_PBR/AIR', 3, NULL),
(22372, NULL, 'IPR032761', NULL, 'Plasmodium falciparum erythrocyte membrane protein 1, N-terminal', 'PfEMP1_N', 3, NULL),
(22373, NULL, 'IPR025395', NULL, 'Protein of unknown function DUF4128', 'DUF4128', 4, NULL),
(22374, NULL, 'IPR028198', NULL, 'Surfactant-associated protein 2', 'SFTA2', 4, NULL),
(22375, NULL, 'IPR025411', NULL, 'Domain of unknown function DUF4136', 'DUF4136', 3, NULL),
(22376, NULL, 'IPR032748', NULL, 'Phosphoprotein associated with glycosphingolipid-enriched microdomains 1', 'PAG', 4, NULL),
(22377, NULL, 'IPR025441', NULL, 'Protein of unknown function DUF4181', 'DUF4181', 4, NULL),
(22378, NULL, 'IPR032505', NULL, 'Non-structural protein NSP4, C-terminal, coronavirus', 'CoV_NSP4_C', 3, NULL),
(22379, NULL, 'IPR027437', NULL, '30s ribosomal protein S13, C-terminal', '30s_Rbsml_prot_S13_C', 5, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(22380, NULL, 'IPR024375', NULL, 'Non-structural protein NSP3, SUD-M domain, betacoronavirus', 'NSP3_bCoV', 3, NULL),
(22381, NULL, 'IPR030045', NULL, 'Alpha-catulin 1', 'CTNNAL1', 4, NULL),
(22382, NULL, 'IPR024414', NULL, 'Uncharacterised protein family PrgI', 'Uncharacterised_PrgI', 4, NULL),
(22383, NULL, 'IPR025103', NULL, 'Uncharacterized ATP-dependent helicase MG140', 'DUF4011', 4, NULL),
(22384, NULL, 'IPR025388', NULL, 'Alginate export domain', 'Alginate_export_dom', 3, NULL),
(22385, NULL, 'IPR026822', NULL, 'Spp2/MOS2, G-patch domain', 'Spp2/MOS2_G-patch', 3, NULL),
(22386, NULL, 'IPR032760', NULL, 'Bacterial toxin 6', 'Ntox6', 4, NULL),
(22387, NULL, 'IPR027197', NULL, 'Equilibrative nucleobase transporter 1', 'SLC43A3', 4, NULL),
(22388, NULL, 'IPR027578', NULL, 'Proline-rich tail region repeat', 'ProTail_Rpt', 7, NULL),
(22389, NULL, 'IPR032785', NULL, 'Replicase polyprotein 1ab, peptidase C33-associated domain', 'Pdase_C33_assoc', 3, NULL),
(22390, NULL, 'IPR026834', NULL, 'LHH', 'LHH', 3, NULL),
(22391, NULL, 'IPR024373', NULL, 'Bacteriophage T4, IpI', 'Phage_T4_IpI', 4, NULL),
(22392, NULL, 'IPR025820', NULL, 'Methyltransferase NNMT/PNMT/TEMT, conserved site', 'NNMT/PNMT/TEMT_CS', 2, NULL),
(22393, NULL, 'IPR031812', NULL, 'Protein C', 'C_Hendra', 4, NULL),
(22394, NULL, 'IPR032746', NULL, 'Treslin, N-terminal', 'Treslin_N', 3, NULL),
(22395, NULL, 'IPR025391', NULL, 'Domain of unknown function DUF4123', 'DUF4123', 3, NULL),
(22396, NULL, 'IPR032812', NULL, 'SbsA, Ig-like domain', 'SbsA_Ig', 3, NULL),
(22397, NULL, 'IPR024811', NULL, 'Polycomb protein ASX/ASX-like', 'ASX/ASX-like', 4, NULL),
(22398, NULL, 'IPR027837', NULL, 'Kinocilin protein', 'Kinocilin', 4, NULL),
(22399, NULL, 'IPR024410', NULL, 'Phage tail assembly chaperone protein, TAC', 'Phage_TAC_12', 4, NULL),
(22400, NULL, 'IPR025460', NULL, 'Protein of unknown function DUF4280', 'DUF4280', 4, NULL),
(22401, NULL, 'IPR031582', NULL, 'Putative tight adherence pilin protein F', 'TadF', 4, NULL),
(22402, NULL, 'IPR025420', NULL, 'Domain of unknown function DUF4143', 'DUF4143', 3, NULL),
(22403, NULL, 'IPR032487', NULL, 'Polyprotein allergen, nematode', 'ABA-1_nematode', 3, NULL),
(22404, NULL, 'IPR031910', NULL, 'Germinal-centre associated nuclear protein, CID domain', 'GANP_CID_dom', 3, NULL),
(22405, NULL, 'IPR025423', NULL, 'Domain of unknown function DUF4149', 'DUF4149', 3, NULL),
(22406, NULL, 'IPR032750', NULL, 'Transposon Tn7 transposition protein TnsD, C-termianl', 'TnsD_C', 3, NULL),
(22407, NULL, 'IPR024407', NULL, 'Protein 3a, betacoronavirus', 'Protein_3a_bCoV', 4, NULL),
(22408, NULL, 'IPR027586', NULL, 'Putative radical SAM/SPASM metalloenzyme maturase', 'rSAM_metal_mat', 4, NULL),
(22409, NULL, 'IPR024984', NULL, 'Protein of unknown function DUF3888', 'DUF3888', 4, NULL),
(22410, NULL, 'IPR031841', NULL, 'DL-endopeptidase inhibitor IseA', 'Endopep_inhib', 4, NULL),
(22411, NULL, 'IPR029510', NULL, 'Aldehyde dehydrogenase, glutamic acid active site', 'Ald_DH_CS_GLU', 2, NULL),
(22412, NULL, 'IPR025903', NULL, 'Phostensin/Taperin N-terminal domain', 'Phostensin/Taperin_N_dom', 3, NULL),
(22413, NULL, 'IPR028193', NULL, 'Testis-expressed sequence 13 protein family', 'TEX13', 4, NULL),
(22414, NULL, 'IPR032754', NULL, 'Leucine-rich repeat-containing protein 37, N-terminal', 'LRRC37_N', 3, NULL),
(22415, NULL, 'IPR031864', NULL, 'Protein of unknown function DUF4756', 'DUF4756', 4, NULL),
(22416, NULL, 'IPR031588', NULL, 'Collectrin domain', 'Collectrin_dom', 3, NULL),
(22417, NULL, 'IPR025786', NULL, 'Mononegavirus L protein 2-O-ribose methyltransferase', 'Mononega_L_MeTrfase', 3, NULL),
(22418, NULL, 'IPR025047', NULL, 'Protein of unknown function DUF3986', 'DUF3986', 4, NULL),
(22419, NULL, 'IPR025972', NULL, 'Beta-galactosidase, domain 3', 'BetaGal_dom3', 3, NULL),
(22420, NULL, 'IPR025336', NULL, 'SCO4226-like', 'SCO4226-like', 4, NULL),
(22421, NULL, 'IPR032501', NULL, 'Proteasomal ATPase OB C-terminal domain', 'Prot_ATP_ID_OB_C', 3, NULL),
(22422, NULL, 'IPR026795', NULL, 'Shiftless antiviral inhibitor of ribosomal frameshifting', 'SHFL', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(22423, NULL, 'IPR027124', NULL, 'SWR1-complex protein 5/Craniofacial development protein 1/2', 'Swc5/CFDP1/2', 4, NULL),
(22424, NULL, 'IPR025214', NULL, 'Centromere protein U', 'CENP-U', 4, NULL),
(22425, NULL, 'IPR025447', NULL, 'Protein of unknown function DUF4192', 'DUF4192', 4, NULL),
(22426, NULL, 'IPR025344', NULL, 'ARC6, IMS domain', 'ARC6-like_IMS', 3, NULL),
(22427, NULL, 'IPR025768', NULL, 'TFG box', 'TFG_box', 3, NULL),
(22428, NULL, 'IPR032152', NULL, 'Domain of unknown function DUF4989', 'DUF4989', 3, NULL),
(22429, NULL, 'IPR024874', NULL, 'Transcription factor Maf family', 'Transcription_factor_Maf_fam', 4, NULL),
(22430, NULL, 'IPR025312', NULL, 'Domain of unknown function DUF4216', 'DUF4216', 3, NULL),
(22431, NULL, 'IPR032155', NULL, 'Domain of unknown function DUF4992', 'DUF4992', 3, NULL),
(22432, NULL, 'IPR025805', NULL, 'Histone-lysine N-methyltransferase Smyd3', 'Hist-Lys_N-MeTrfase_Smyd3', 4, NULL),
(22433, NULL, 'IPR030886', NULL, 'Lipoprotein, tandem type', 'Lepto_lipo', 4, NULL),
(22434, NULL, 'IPR029515', NULL, 'LAR-interacting protein, Liprin', 'Liprin', 4, NULL),
(22435, NULL, 'IPR029495', NULL, 'NACHT-associated domain', 'NACHT-assoc', 3, NULL),
(22436, NULL, 'IPR025042', NULL, 'Protein of unknown function DUF3982', 'DUF3982', 4, NULL),
(22437, NULL, 'IPR032766', NULL, 'Fission yeast  Sec3, C-terminal', 'Sec3_C_2', 3, NULL),
(22438, NULL, 'IPR032765', NULL, 'Testis expressed sequence 15 domain', 'TEX15_dom', 3, NULL),
(22439, NULL, 'IPR025815', NULL, 'Cytochrome c lysine N-methyltransferase 1', 'Ctm1', 4, NULL),
(22440, NULL, 'IPR032788', NULL, 'Glycogen debranching enzyme, central domain', 'AGL_central', 3, NULL),
(22441, NULL, 'IPR026609', NULL, 'Opalin', 'Opalin', 4, NULL),
(22442, NULL, 'IPR024400', NULL, 'Protein of unknown function DUF2635', 'DUF2635', 4, NULL),
(22443, NULL, 'IPR026835', NULL, 'Toxin YqcG, C-terminal', 'YqcG_C', 3, NULL),
(22444, NULL, 'IPR032759', NULL, 'Bacterial toxin 5', 'Ntox5', 4, NULL),
(22445, NULL, 'IPR032839', NULL, 'Rab3-GAP regulatory subunit, N-terminal', 'RAB3GAP_N', 3, NULL),
(22446, NULL, 'IPR025142', NULL, 'Domain of unknown function DUF4073', 'DUF4073', 3, NULL),
(22447, NULL, 'IPR024610', NULL, 'Inhibitor of growth protein, N-terminal histone-binding', 'ING_N_histone-binding', 3, NULL),
(22448, NULL, 'IPR032764', NULL, 'Tankyrase 1-binding protein, C-terminal', 'Tankyrase-bd_C', 3, NULL),
(22449, NULL, 'IPR025323', NULL, 'Protein of unknown function DUF4229', 'DUF4229', 4, NULL),
(22450, NULL, 'IPR025419', NULL, 'Domain of unknown function DUF4142', 'DUF4142', 3, NULL),
(22451, NULL, 'IPR028212', NULL, 'Hypothetical glycosyl hydrolase 6', 'GHL6', 4, NULL),
(22452, NULL, 'IPR025415', NULL, 'Protein of unknown function DUF4141', 'DUF4141', 4, NULL),
(22453, NULL, 'IPR029519', NULL, 'Nucleoredoxin-like protein 2', 'RdCVF2', 4, NULL),
(22454, NULL, 'IPR031831', NULL, 'cGMP-dependent protein kinase, N-terminal coiled-coil domain', 'PKcGMP_CC', 3, NULL),
(22455, NULL, 'IPR025320', NULL, 'Protein of unknown function DUF4225', 'DUF4225', 4, NULL),
(22456, NULL, 'IPR025324', NULL, 'Protein of unknown function DUF4230', 'DUF4230', 4, NULL),
(22457, NULL, 'IPR025309', NULL, 'KTSC domain', 'KTSC_dom', 3, NULL),
(22458, NULL, 'IPR025311', NULL, 'Domain of unknown function DUF4166', 'DUF4166', 3, NULL),
(22459, NULL, 'IPR031593', NULL, 'Putative general bacterial porin', 'Porin_7', 4, NULL),
(22460, NULL, 'IPR032496', NULL, 'Hemolysin, beta-prism lectin', 'Hemolysin_beta-prism_lec', 3, NULL),
(22461, NULL, 'IPR032153', NULL, 'Domain of unknown function DUF4990', 'DUF4990', 3, NULL),
(22462, NULL, 'IPR032774', NULL, 'WG containing repeat', 'WG_beta_rep', 7, NULL),
(22463, NULL, 'IPR025735', NULL, 'RHIM domain', 'RHIM_dom', 3, NULL),
(22464, NULL, 'IPR031819', NULL, 'Read-through domain', 'Read-through_dom', 3, NULL),
(22465, NULL, 'IPR027131', NULL, 'Structural maintenance of chromosomes protein 5', 'SMC5', 4, NULL),
(22466, NULL, 'IPR025043', NULL, 'Domain of unknown function DUF3981', 'DUF3981', 3, NULL),
(22467, NULL, 'IPR027436', NULL, 'Protein kinase C, delta', 'PKC_delta', 4, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(22468, NULL, 'IPR032752', NULL, 'DC-UbP/UBTD2, N-terminal domain', 'DC-UbP/UBTD2_N', 3, NULL),
(22469, NULL, 'IPR025385', NULL, 'Domain of unknown function DUF4092', 'DUF4092', 3, NULL),
(22470, NULL, 'IPR028630', NULL, 'RNA polymerase sigma factor RpoD', 'Sigma70_RpoD', 4, NULL),
(22471, NULL, 'IPR026597', NULL, 'Hypoxanthine/guanine phosphoribosyltransferase-like', 'HGPRTase-like', 4, NULL),
(22472, NULL, 'IPR026620', NULL, 'Transmembrane protein 177', 'TMEM177', 4, NULL),
(22473, NULL, 'IPR027582', NULL, 'Amanitin/phalloidin toxin', 'Amanitin/phalloidin', 4, NULL),
(22474, NULL, 'IPR024348', NULL, 'Peptidase C62, gill-associated virus', 'Pept_C62_gill-assoc_virus', 4, NULL),
(22475, NULL, 'IPR025410', NULL, 'Lantibiotic biosynthesis protein, dehydration domain', 'Lant_dehyd', 3, NULL),
(22476, NULL, 'IPR025775', NULL, 'Birnavirus VP4 protease domain', 'Birna_VP4_Prtase_dom', 3, NULL),
(22477, NULL, 'IPR032154', NULL, 'Coatomer subunit gamma, C-terminal', 'Coatomer_g_Cpla', 3, NULL),
(22478, NULL, 'IPR026113', NULL, 'tRNA N(3)-methylcytidine methyltransferase METTL2/6/8-like', 'METTL2/6/8-like', 4, NULL),
(22479, NULL, 'IPR027438', NULL, 'Ecotin, C-terminal', 'Ecotin_C', 5, NULL),
(22480, NULL, 'IPR025745', NULL, 'Restriction system protein Mrr-like N-terminal domain', 'Mrr-like_N_dom', 3, NULL),
(22481, NULL, 'IPR024858', NULL, 'Golgin subfamily A', 'Golgin_A', 4, NULL),
(22482, NULL, 'IPR025796', NULL, 'Histone-lysine N-methyltransferase SETDB1', 'Hist-Lys_N-MeTrfase_SETDB1', 4, NULL),
(22483, NULL, 'IPR024419', NULL, 'Protein of unknown function YvrJ', 'YvrJ', 4, NULL),
(22484, NULL, 'IPR024867', NULL, 'Nuclear factor related to kappa-B-binding protein', 'NFRKB', 4, NULL),
(22485, NULL, 'IPR024869', NULL, 'FAM20', 'FAM20', 4, NULL),
(22486, NULL, 'IPR025112', NULL, 'Putative carbohydrate metabolism domain', 'PCMD', 3, NULL),
(22487, NULL, 'IPR025442', NULL, 'Domain of unknown function DUF4185', 'DUF4185', 3, NULL),
(22488, NULL, 'IPR032502', NULL, 'Protein of unknown function DUF4979', 'DUF4979', 4, NULL),
(22489, NULL, 'IPR028882', NULL, 'Succinate dehydrogenase assembly factor 2, mitochondrial', 'SDHAF2', 4, NULL),
(22490, NULL, 'IPR025328', NULL, 'Domain of unknown function DUF4234', 'DUF4234', 3, NULL),
(22491, NULL, 'IPR025421', NULL, 'Protein of unknown function DUF4148', 'DUF4148', 4, NULL),
(22492, NULL, 'IPR030457', NULL, 'ELO family, conserved site', 'ELO_CS', 2, NULL),
(22493, NULL, 'IPR027821', NULL, 'Shieldin complex subunit 1', 'SHLD1', 4, NULL),
(22494, NULL, 'IPR027817', NULL, 'Costars domain', 'Costars_dom', 3, NULL),
(22495, NULL, 'IPR032770', NULL, 'Domain of unknown function DUF4537', 'DUF4537', 3, NULL),
(22496, NULL, 'IPR031595', NULL, 'Protein-only RNase P, C-terminal', 'PRORP_C', 3, NULL),
(22497, NULL, 'IPR031584', NULL, 'Putative ABC exporter', 'Put_ABC_export', 4, NULL),
(22498, NULL, 'IPR026118', NULL, 'Calcium-binding and spermatid-specific protein 1', 'Ca-bd_spermatid', 4, NULL),
(22499, NULL, 'IPR032513', NULL, 'Alpha-glucosidase, N-terminal', 'AGL_N', 3, NULL),
(22500, NULL, 'IPR030846', NULL, 'DNA primase DnaG, bacteria', 'DnaG_bac', 4, NULL),
(22501, NULL, 'IPR025117', NULL, 'Domain of unknown function DUF4037', 'DUF4037', 3, NULL),
(22502, NULL, 'IPR024998', NULL, 'Protein of unknown function DUF3906', 'DUF3906', 4, NULL),
(22503, NULL, 'IPR031482', NULL, 'Cellulose biosynthesis protein BcsN', 'CBP_BcsN', 4, NULL),
(22504, NULL, 'IPR032118', NULL, 'Bacteriophage holin HP1 family', 'Phage_holin_HP1', 4, NULL),
(22505, NULL, 'IPR026010', NULL, 'Nucleoporin NSP1/NUP62', 'NSP1/NUP62', 4, NULL),
(22506, NULL, 'IPR030445', NULL, 'Histone H3-K79 methyltransferase', 'H3-K79_meTrfase', 4, NULL),
(22507, NULL, 'IPR027796', NULL, 'OTT_1508-like deaminase', 'OTT_1508_deam-like', 4, NULL),
(22508, NULL, 'IPR028233', NULL, 'Cilia BBSome complex subunit 10', 'BBIP10', 4, NULL),
(22509, NULL, 'IPR031519', NULL, 'Domain of unknown function DUF5094', 'DUF5094', 3, NULL),
(22510, NULL, 'IPR025029', NULL, 'Protein of unknown function DUF3918', 'DUF3918', 4, NULL),
(22511, NULL, 'IPR034157', NULL, 'DNA topoisomerase 2, TOPRIM domain', 'TOPRIM_TopoII', 3, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(22512, NULL, 'IPR027336', NULL, 'Mas-related G protein-coupled receptor G', 'MRGPCRG', 4, NULL),
(22513, NULL, 'IPR025774', NULL, 'SAM-dependent methyltransferase gTMT-type', 'MTs_g-TMT', 4, NULL),
(22514, NULL, 'IPR026380', NULL, 'Seadornavirus VP8 protein', 'Seadorna_VP8', 4, NULL),
(22515, NULL, 'IPR024443', NULL, 'Domain of unknown function DUF3197', 'DUF3197', 4, NULL),
(22516, NULL, 'IPR025079', NULL, 'Domain of unknown function DUF3943', 'DUF3943', 3, NULL),
(22517, NULL, 'IPR025109', NULL, 'Domain of unknown function DUF4031', 'DUF4031', 3, NULL),
(22518, NULL, 'IPR034164', NULL, 'Pepsin-like domain', 'Pepsin-like_dom', 3, NULL),
(22519, NULL, 'IPR031965', NULL, 'Starch-binding module 26', 'CBM26', 3, NULL),
(22520, NULL, 'IPR031682', NULL, 'Type VII secretion system protein EsaE', 'EsaE', 4, NULL),
(22521, NULL, 'IPR032852', NULL, 'DNA oxidative demethylase ALKBH2', 'ALKBH2', 4, NULL),
(22522, NULL, 'IPR032329', NULL, 'Protein of unknown function DUF4855', 'DUF4855', 4, NULL),
(22523, NULL, 'IPR025085', NULL, 'pPIWI_RE module, N-terminal domain', 'pPIWI_RE_X', 3, NULL),
(22524, NULL, 'IPR026147', NULL, 'Rab3GAP catalytic subunit, conserved domain', 'Rab3GAP1_conserved', 3, NULL),
(22525, NULL, 'IPR024995', NULL, 'Protein of unknown function DUF3895', 'DUF3895', 4, NULL),
(22526, NULL, 'IPR025134', NULL, 'Protein of unknown function DUF4059', 'DUF4059', 4, NULL),
(22527, NULL, 'IPR025063', NULL, 'Protein of unknown function DUF4004', 'DUF4004', 4, NULL),
(22528, NULL, 'IPR024368', NULL, 'Zinc binding protein Ecl1/2/3', 'Ecl1/2/3', 4, NULL),
(22529, NULL, 'IPR028728', NULL, 'Sperm-associated antigen 5', 'Astrin', 4, NULL),
(22530, NULL, 'IPR031522', NULL, 'Putative Mad3/Bub1 like region 1 protein', 'Mad3_Bub1_I_2', 4, NULL),
(22531, NULL, 'IPR028584', NULL, 'Cellobiose 2-epimerase', 'Cellobiose_2_epim', 4, NULL),
(22532, NULL, 'IPR031479', NULL, 'Protein SLX4IP', 'SLX4IP', 4, NULL),
(22533, NULL, 'IPR024477', NULL, 'Protein of unknown function DUF3865, CADD-like', 'DUF3865_CADD-like', 4, NULL),
(22534, NULL, 'IPR025586', NULL, 'PcfJ-like protein', 'PcfJ', 4, NULL),
(22535, NULL, 'IPR025007', NULL, 'Domain of unknown function DUF3899', 'DUF3899', 3, NULL),
(22536, NULL, 'IPR024366', NULL, 'Alpha-ketoglutarate-dependent dioxygenase FTO, C-terminal', 'FTO_C', 3, NULL),
(22537, NULL, 'IPR025145', NULL, 'Protein of unknown function DUF4087', 'DUF4087', 4, NULL),
(22538, NULL, 'IPR025353', NULL, 'Protein of unknown function DUF4257)', 'DUF4257', 4, NULL),
(22539, NULL, 'IPR026275', NULL, 'Glyoxalase/dioxygenase/EhpR', 'Glyoxalase/dOase/EhpR', 4, NULL),
(22540, NULL, 'IPR025022', NULL, 'Protein of unknown function DUF3911', 'DUF3911', 4, NULL),
(22541, NULL, 'IPR031394', NULL, 'Musculoskeletal embryonic nuclear protein 1', 'MUSTN1', 4, NULL),
(22542, NULL, 'IPR025025', NULL, 'Protein of unknown function DUF3914', 'DUF3914', 4, NULL),
(22543, NULL, 'IPR025059', NULL, 'Protein of unknown function DUF3997', 'DUF3997', 4, NULL),
(22544, NULL, 'IPR025090', NULL, 'Protein of unknown function DUF4017', 'DUF4017', 4, NULL),
(22545, NULL, 'IPR032177', NULL, 'Fragile X-related 1 protein, C-terminal region 3', 'FXR_C3', 3, NULL),
(22546, NULL, 'IPR026388', NULL, 'Seadornavirus double-stranded RNA-binding protein', 'Seadorna_dsRNA-bnd', 4, NULL),
(22547, NULL, 'IPR025107', NULL, 'Protein of unknown function DUF4029', 'DUF4029', 4, NULL),
(22548, NULL, 'IPR027629', NULL, 'Putative protein phosphatase DevT-like', 'DevT-like', 4, NULL),
(22549, NULL, 'IPR031813', NULL, 'Domain of unknown function DUF4745', 'DUF4745', 3, NULL),
(22550, NULL, 'IPR031992', NULL, 'Domain of unknown function DUF4788', 'DUF4788', 3, NULL),
(22551, NULL, 'IPR025139', NULL, 'Domain of unknown function DUF4062', 'DUF4062', 3, NULL),
(22552, NULL, 'IPR032333', NULL, 'Protein of unknown function DUF4857', 'DUF4857', 4, NULL),
(22553, NULL, 'IPR024463', NULL, 'Transposase TnpC, homeodomain', 'Transposase_TnpC_homeodom', 3, NULL),
(22554, NULL, 'IPR031503', NULL, 'Protein of unknown function DUF5099', 'DUF5099', 4, NULL),
(22555, NULL, 'IPR031988', NULL, 'DNA primase DnaG, C-terminal helicase-binding domain', 'DnaG_HBD', 3, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(22556, NULL, 'IPR032327', NULL, 'Protein of unknown function DUF4854', 'DUF4854', 4, NULL),
(22557, NULL, 'IPR025078', NULL, 'Protein of unknown function DUF3931', 'DUF3931', 4, NULL),
(22558, NULL, 'IPR034091', NULL, 'BTBD9, BACK-like domain', 'BTBD9_BACK-like_dom', 3, NULL),
(22559, NULL, 'IPR025077', NULL, 'Protein of unknown function DUF3941', 'DUF3941', 4, NULL),
(22560, NULL, 'IPR031523', NULL, 'Putative acetyl-transferase', 'Acetyltransf_15', 4, NULL),
(22561, NULL, 'IPR034117', NULL, 'Cysteine-rich secretory protein, SCP domain', 'SCP_CRISP', 3, NULL),
(22562, NULL, 'IPR031918', NULL, 'Herpesvirus membrane glycoprotein UL141', 'UL141', 4, NULL),
(22563, NULL, 'IPR024996', NULL, 'pPIWI_RE, RNaseH domain', 'RNaseH_pPIWI_RE', 3, NULL),
(22564, NULL, 'IPR031663', NULL, 'Phosphogluconate dehydrogenase (decarboxylating) , C-terminal', 'PGDH_C', 3, NULL),
(22565, NULL, 'IPR031450', NULL, 'Orthopoxvirus B3 protein', 'B3R', 4, NULL),
(22566, NULL, 'IPR031739', NULL, 'Condensin-2 complex subunit H2', 'Ncaph2', 4, NULL),
(22567, NULL, 'IPR031533', NULL, 'Protein of unknown function DUF5093', 'DUF5093', 4, NULL),
(22568, NULL, 'IPR032322', NULL, 'Protein of unknown function DUF4850', 'DUF4850', 4, NULL),
(22569, NULL, 'IPR024444', NULL, 'Protein of unknown function DUF2706', 'DUF2706', 4, NULL),
(22570, NULL, 'IPR032459', NULL, 'Putative oxidoreductase, C-terminal', 'Oxidoreduct_C', 3, NULL),
(22571, NULL, 'IPR025075', NULL, 'Protein of unknown function DUF3916', 'DUF3916', 4, NULL),
(22572, NULL, 'IPR027256', NULL, 'P-type ATPase, subfamily IB', 'P-typ_ATPase_IB', 4, NULL),
(22573, NULL, 'IPR032323', NULL, 'Protein of unknown function DUF4851', 'DUF4851', 4, NULL),
(22574, NULL, 'IPR025148', NULL, '1-carboxybiuret hydrolase subunit AtzG-like', 'AtzG-like', 4, NULL),
(22575, NULL, 'IPR031488', NULL, 'WD repeat protein mio, zinc-ribbon like domain', 'Zn_ribbon_mio', 3, NULL),
(22576, NULL, 'IPR028730', NULL, 'Zinc finger FYVE domain-containing protein 26', 'ZFYVE26', 4, NULL),
(22577, NULL, 'IPR025201', NULL, 'Sensor protein KdpD, transmembrane domain', 'KdpD_TM', 3, NULL),
(22578, NULL, 'IPR031989', NULL, 'Domain of unknown function DUF5067', 'DUF5067', 3, NULL),
(22579, NULL, 'IPR031475', NULL, 'Four-carbon acid sugar kinase, nucleotide binding domain', 'NBD_C', 3, NULL),
(22580, NULL, 'IPR026378', NULL, 'Seadornavirus VP11 protein', 'Seadorna_VP11', 4, NULL),
(22581, NULL, 'IPR034170', NULL, 'Retropepsin-like catalytic domain', 'Retropepsin-like_cat_dom', 3, NULL),
(22582, NULL, 'IPR032091', NULL, 'Maltogenic Amylase, C-terminal', 'Malt_amylase_C', 3, NULL),
(22583, NULL, 'IPR031974', NULL, 'Programmed cell death protein 7', 'PDCD7', 4, NULL),
(22584, NULL, 'IPR031920', NULL, 'Partner and localiser of BRCA2, WD40 domain', 'PALB2_WD40', 3, NULL),
(22585, NULL, 'IPR025036', NULL, 'Protein of unknown function DUF3921', 'DUF3921', 4, NULL),
(22586, NULL, 'IPR025730', NULL, 'Biofilm regulator BssS', 'Biofilm_BssS', 4, NULL),
(22587, NULL, 'IPR025115', NULL, 'Domain of unknown function DUF4034', 'DUF4034', 3, NULL),
(22588, NULL, 'IPR025055', NULL, 'Endospore appendages core', 'Ena_core', 3, NULL),
(22589, NULL, 'IPR031745', NULL, 'Vps53, C-terminal', 'Vps53_C', 3, NULL),
(22590, NULL, 'IPR031676', NULL, 'Protein of unknown function DUF5083', 'DUF5083', 4, NULL),
(22591, NULL, 'IPR032128', NULL, 'Pyocin R2, holin', 'Pyocin_R2_holin', 4, NULL),
(22592, NULL, 'IPR025352', NULL, 'Protein of unknown function DUF4256', 'DUF4256', 4, NULL),
(22593, NULL, 'IPR025053', NULL, 'Protein of unknown function DUF3985', 'DUF3985', 4, NULL),
(22594, NULL, 'IPR025004', NULL, 'Transcriptional regulatory protein SenN/SenS', 'SenN/SenS', 4, NULL),
(22595, NULL, 'IPR032359', NULL, 'Kiwa protein KwaB-like', 'KwaB-like', 4, NULL),
(22596, NULL, 'IPR031916', NULL, 'DNA ligase 3, BRCT domain', 'LIG3_BRCT', 3, NULL),
(22597, NULL, 'IPR034092', NULL, 'PHO1, SPX domain', 'PHO1_SPX', 3, NULL),
(22598, NULL, 'IPR027264', NULL, 'Protein kinase C, theta', 'PKC_theta', 4, NULL),
(22599, NULL, 'IPR028581', NULL, 'Deoxyribose-phosphate aldolase type I', 'DeoC_typeI', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(22600, NULL, 'IPR025199', NULL, 'DNA translocase FtsK, 4TM region', 'FtsK_4TM', 3, NULL),
(22601, NULL, 'IPR025116', NULL, 'Protein of unknown function DUF4035', 'DUF4035', 4, NULL),
(22602, NULL, 'IPR032890', NULL, 'Hercynine oxygenase, Actinobacteria', 'EgtB_Actinobacteria', 4, NULL),
(22603, NULL, 'IPR025733', NULL, 'Iron/zinc purple acid phosphatase-like C-terminal domain', 'Purple_acid_PPase_C_dom', 3, NULL),
(22604, NULL, 'IPR026955', NULL, 'Biorientation of chromosomes in cell division protein 1-like', 'Bod1-like', 4, NULL),
(22605, NULL, 'IPR025792', NULL, 'tRNA (guanine(37)-N(1))-methyltransferase, eukaryotic', 'tRNA_Gua_MeTrfase_euk', 4, NULL),
(22606, NULL, 'IPR027798', NULL, 'Ubiquitin Mut7-C domain', 'Ub_Mut7C', 3, NULL),
(22607, NULL, 'IPR025197', NULL, 'Domain of unknown function DUF4116', 'DUF4116', 3, NULL),
(22608, NULL, 'IPR027110', NULL, 'Pyruvate dehydrogenase E1 component subunit beta', 'PDHB', 4, NULL),
(22609, NULL, 'IPR031494', NULL, 'Putative beta-lactamase-like family', 'Beta_lactamase3', 4, NULL),
(22610, NULL, 'IPR032055', NULL, 'Transmembrane protein 72', 'TMEM72', 4, NULL),
(22611, NULL, 'IPR025596', NULL, 'YedD-like protein', 'YedD', 4, NULL),
(22612, NULL, 'IPR028226', NULL, 'Protein LIN37', 'LIN37', 4, NULL),
(22613, NULL, 'IPR034182', NULL, 'Kexin/furin catalytic domain', 'Kexin/furin', 3, NULL),
(22614, NULL, 'IPR032103', NULL, 'Sodium/hydrogen exchanger, regulatory region', 'NHE_CaM-bd', 3, NULL),
(22615, NULL, 'IPR025697', NULL, 'CLU domain', 'CLU_dom', 3, NULL),
(22616, NULL, 'IPR025099', NULL, 'Protein of unknown function DUF4024', 'DUF4024', 4, NULL),
(22617, NULL, 'IPR032362', NULL, 'Ferlin, C-terminal domain', 'Ferlin_C', 3, NULL),
(22618, NULL, 'IPR030159', NULL, 'Autoinducer 2 ABC transporter, substrate-binding protein LsrB', 'LsrB', 4, NULL),
(22619, NULL, 'IPR026138', NULL, 'Ceroid-lipofuscinosis neuronal protein 5', 'CLN5', 4, NULL),
(22620, NULL, 'IPR026282', NULL, 'DNA-binding protein, MJ1563 type', 'MJ1563', 4, NULL),
(22621, NULL, 'IPR031507', NULL, 'Polar tube protein 2', 'PTP2', 4, NULL),
(22622, NULL, 'IPR030869', NULL, '1,4-dihydroxy-6-naphtoate synthase', 'MqnD', 4, NULL),
(22623, NULL, 'IPR030804', NULL, 'Bardet-Biedl syndrome 5 protein/sex-determination protein fem-3', 'BBS5/fem-3', 4, NULL),
(22624, NULL, 'IPR031476', NULL, 'Protein of unknown function DUF4686', 'DUF4686', 4, NULL),
(22625, NULL, 'IPR025144', NULL, 'Protein of unknown function DUF4085', 'DUF4085', 4, NULL),
(22626, NULL, 'IPR025052', NULL, 'Domain of unknown function DUF3967', 'DUF3967', 3, NULL),
(22627, NULL, 'IPR028661', NULL, 'Vacuolar protein sorting-associated protein 29', 'Vps29', 4, NULL),
(22628, NULL, 'IPR032456', NULL, 'CAAX prenyl protease 1, N-terminal', 'Peptidase_M48_N', 3, NULL),
(22629, NULL, 'IPR024989', NULL, 'Major facilitator superfamily associated domain', 'MFS_assoc_dom', 3, NULL),
(22630, NULL, 'IPR031740', NULL, 'Cell division control protein 4, dimerisation domain', 'Cdc4_D', 3, NULL),
(22631, NULL, 'IPR025111', NULL, 'Domain of unknown function DUF4032', 'DUF4032', 3, NULL),
(22632, NULL, 'IPR026284', NULL, 'Alpha-2-macroglobulin, bacteria', 'A2-macglob_dom_prot_bac', 4, NULL),
(22633, NULL, 'IPR026288', NULL, 'Submaxillary gland androgen-regulated protein like', 'SMR-like', 4, NULL),
(22634, NULL, 'IPR025368', NULL, 'Protein of unknown function DUF4272', 'DUF4272', 4, NULL),
(22635, NULL, 'IPR026805', NULL, 'GW182, middle domain', 'GW182_M_dom', 3, NULL),
(22636, NULL, 'IPR025068', NULL, 'Protein of unknown function DUF3937', 'DUF3937', 4, NULL),
(22637, NULL, 'IPR027797', NULL, 'Pre-toxin TG domain', 'PT-TG_dom', 3, NULL),
(22638, NULL, 'IPR026152', NULL, 'Specifically androgen-regulated gene protein', 'SARG', 4, NULL),
(22639, NULL, 'IPR026266', NULL, 'L-arabinose-binding periplasmic protein', 'AraF', 4, NULL),
(22640, NULL, 'IPR031061', NULL, 'High mobility group protein HMGB, plant', 'HMGB_plant', 4, NULL),
(22641, NULL, 'IPR025035', NULL, 'Protein of unknown function DUF3922', 'DUF3922', 4, NULL),
(22642, NULL, 'IPR025097', NULL, 'Protein of unknown function DUF4023', 'DUF4023', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(22643, NULL, 'IPR025788', NULL, 'Histone-lysine N-methyltransferase, Set2, fungi', 'Set2_fungi', 4, NULL),
(22644, NULL, 'IPR026791', NULL, 'Dedicator of cytokinesis', 'DOCK', 4, NULL),
(22645, NULL, 'IPR032808', NULL, 'DoxX family', 'DoxX', 4, NULL),
(22646, NULL, 'IPR026270', NULL, 'Signal recognition particle, SRP72 subunit', 'SRP72', 4, NULL),
(22647, NULL, 'IPR026281', NULL, 'HTH-type transcriptional regulator RamB', 'HTH_RamB', 4, NULL),
(22648, NULL, 'IPR026662', NULL, 'NADH-quinone oxidoreductase subunit CD', 'NDH-1_subunit_CD', 4, NULL),
(22649, NULL, 'IPR025124', NULL, 'Domain of unknown function DUF4050', 'DUF4050', 3, NULL),
(22650, NULL, 'IPR025347', NULL, 'Protein of unknown function DUF4251', 'DUF4251', 4, NULL),
(22651, NULL, 'IPR025102', NULL, 'Protein of unknown function DUF4026', 'DUF4026', 4, NULL),
(22652, NULL, 'IPR025129', NULL, 'Domain of unknown function DUF4055', 'DUF4055', 3, NULL),
(22653, NULL, 'IPR025006', NULL, 'Protein of unknown function DUF3900', 'DUF3900', 4, NULL),
(22654, NULL, 'IPR031994', NULL, 'Janus kinase and microtubule-interacting protein, C-terminal domain', 'JAKMIP_C', 3, NULL),
(22655, NULL, 'IPR024476', NULL, 'Protein of unknown function DUF3861', 'DUF3861', 4, NULL),
(22656, NULL, 'IPR028237', NULL, 'Proline-rich protein 15', 'PRR15', 4, NULL),
(22657, NULL, 'IPR025594', NULL, 'YebO-like protein', 'YebO', 4, NULL),
(22658, NULL, 'IPR031527', NULL, 'Protein of unknown function DUF5091', 'DUF5091', 4, NULL),
(22659, NULL, 'IPR028662', NULL, 'Sorting nexin-8/Mvp1', 'SNX8/Mvp1', 4, NULL),
(22660, NULL, 'IPR026939', NULL, 'ZNF706/At2g23090 superfamily', 'ZNF706/At2g23090_sf', 5, NULL),
(22661, NULL, 'IPR025365', NULL, 'Protein of unknown function DUF4269', 'DUF4269', 4, NULL),
(22662, NULL, 'IPR025789', NULL, 'Histone-lysine N-methyltransferase DOT1 domain', 'DOT1_dom', 3, NULL),
(22663, NULL, 'IPR031743', NULL, 'Small outer capsid protein', 'Soc', 4, NULL),
(22664, NULL, 'IPR024990', NULL, 'Anaphase-promoting complex subunit 1', 'Apc1', 4, NULL),
(22665, NULL, 'IPR031474', NULL, 'Protein phosphatase 1 regulatory subunit 26, N-terminal domain', 'PPP1R26_N', 3, NULL),
(22666, NULL, 'IPR025081', NULL, 'Domain of unknown function DUF3961', 'DUF3961', 3, NULL),
(22667, NULL, 'IPR025731', NULL, 'YecR-like lipoprotein', 'YecR-like', 4, NULL),
(22668, NULL, 'IPR025366', NULL, 'Protein of unknown function DUF4270', 'DUF4270', 4, NULL),
(22669, NULL, 'IPR025364', NULL, 'Domain of unknown function DUF4268', 'DUF4268', 3, NULL),
(22670, NULL, 'IPR026811', NULL, 'Cip1-interacting zinc finger protein', 'CIZ1', 4, NULL),
(22671, NULL, 'IPR026951', NULL, 'Peptidyl-prolyl cis-trans isomerase like 2, U-box domain', 'PPIL2_U-box_dom', 3, NULL),
(22672, NULL, 'IPR025095', NULL, 'Protein of unknown function DUF4022', 'DUF4022', 4, NULL),
(22673, NULL, 'IPR031481', NULL, 'Fucosyltransferase, N-terminal', 'Glyco_tran_10_N', 3, NULL),
(22674, NULL, 'IPR031680', NULL, 'Heparin-sulfate lyase, N-terminal', 'Hepar_II_III_N', 3, NULL),
(22675, NULL, 'IPR026937', NULL, 'Strawberry notch, helicase C domain', 'SBNO_Helicase_C_dom', 3, NULL),
(22676, NULL, 'IPR025600', NULL, 'YccJ-like protein', 'YccJ', 4, NULL),
(22677, NULL, 'IPR025193', NULL, 'Domain of unknown function DUF4114', 'DUF4114', 3, NULL),
(22678, NULL, 'IPR032357', NULL, 'Protein of unknown function DUF4866', 'DUF4866', 4, NULL),
(22679, NULL, 'IPR025355', NULL, 'Protein of unknown function DUF4259', 'DUF4259', 4, NULL),
(22680, NULL, 'IPR031666', NULL, 'Protein of unknown function DUF5084', 'DUF5084', 4, NULL),
(22681, NULL, 'IPR025356', NULL, 'Protein of unknown function DUF4260', 'DUF4260', 4, NULL),
(22682, NULL, 'IPR025603', NULL, 'YebF/Colicin-M immunity protein', 'YebF/ColM_immunity', 4, NULL),
(22683, NULL, 'IPR031967', NULL, 'PhoR, single Cache-like domain', 'PhoR_single_Cache-like_dom', 3, NULL),
(22684, NULL, 'IPR025728', NULL, 'YsaB-like lipoprotein', 'YsaB-like', 4, NULL),
(22685, NULL, 'IPR030048', NULL, 'Survival protein SurE', 'SurE', 4, NULL),
(22686, NULL, 'IPR032050', NULL, 'Domain of unknown function DUF4797', 'DUF4797', 3, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(22687, NULL, 'IPR031511', NULL, 'Domain of unknown function DUF5097', 'DUF5097', 3, NULL),
(22688, NULL, 'IPR025038', NULL, 'Protein of unknown function DUF3924', 'DUF3924', 4, NULL),
(22689, NULL, 'IPR028224', NULL, 'Otospiralin', 'Otospiralin', 4, NULL),
(22690, NULL, 'IPR026268', NULL, 'Protein RseC', 'RseC', 4, NULL),
(22691, NULL, 'IPR028227', NULL, 'Uncharacterised protein family UPF0449', 'UPF0449', 4, NULL),
(22692, NULL, 'IPR025033', NULL, 'Protein of unknown function DUF3920', 'DUF3920', 4, NULL),
(22693, NULL, 'IPR031485', NULL, 'Cellulose biosynthesis protein BcsS', 'CBP_BcsS', 4, NULL),
(22694, NULL, 'IPR032848', NULL, 'Sex-determining transformer protein 2', 'Ce-Tra-2', 4, NULL),
(22695, NULL, 'IPR025724', NULL, 'GAG-pre-integrase domain', 'GAG-pre-integrase_dom', 3, NULL),
(22696, NULL, 'IPR025958', NULL, 'SID1 transmembrane family', 'SID1_TM_fam', 4, NULL),
(22697, NULL, 'IPR025084', NULL, 'Protein of unknown function DUF3966', 'DUF3966', 4, NULL),
(22698, NULL, 'IPR031493', NULL, 'Zinc-ribbon 15', 'Zinc_ribbon_15', 3, NULL),
(22699, NULL, 'IPR031673', NULL, 'Chitin biosynthesis protein Chs5, N-terminal', 'Chs5_N', 3, NULL),
(22700, NULL, 'IPR031504', NULL, 'Putative DMAP1-like', 'DMAP1-like', 4, NULL),
(22701, NULL, 'IPR024479', NULL, 'Protein of unknown function DUF3866', 'DUF3866', 4, NULL),
(22702, NULL, 'IPR032880', NULL, 'CSC1/OSCA1-like, N-terminal transmembrane domain', 'Csc1/OSCA1-like_N', 3, NULL),
(22703, NULL, 'IPR024474', NULL, 'Transposase IS66, zinc-finger binding domain of', 'Znf_dom_IS66', 3, NULL),
(22704, NULL, 'IPR034232', NULL, 'Carboxypeptidase E, carboxypeptidase domain', 'M14_CPE_CPD', 3, NULL),
(22705, NULL, 'IPR025020', NULL, 'Protein of unknown function DUF3908', 'DUF3908', 4, NULL),
(22706, NULL, 'IPR025100', NULL, 'Protein of unknown function DUF4025', 'DUF4025', 4, NULL),
(22707, NULL, 'IPR031599', NULL, 'Putative ATP-binding cassette', 'ABC_tran_2', 4, NULL),
(22708, NULL, 'IPR026160', NULL, 'Resistance to inhibitors of cholinesterase protein 3', 'Ric3', 4, NULL),
(22709, NULL, 'IPR026283', NULL, 'Beta-galactosidase 1-like', 'B-gal_1-like', 4, NULL),
(22710, NULL, 'IPR031681', NULL, 'Domain of unknown function DUF5082', 'DUF5082', 3, NULL),
(22711, NULL, 'IPR031814', NULL, 'ALG11 mannosyltransferase, N-terminal', 'ALG11_N', 3, NULL),
(22712, NULL, 'IPR025054', NULL, 'Domain of unknown function DUF3991', 'DUF3991', 3, NULL),
(22713, NULL, 'IPR025072', NULL, 'Fur-regulated basic protein A', 'Fur_reg_FbpA', 4, NULL),
(22714, NULL, 'IPR025001', NULL, 'Protein of unknown function DUF3902', 'DUF3902', 4, NULL),
(22715, NULL, 'IPR031951', NULL, 'Interleukin 17 receptor D, N-terminal', 'IL17R_D_N', 3, NULL),
(22716, NULL, 'IPR031914', NULL, 'XACb0070, ribbon-helix-helix domain', 'XACb0070_RHH_dom', 3, NULL),
(22717, NULL, 'IPR031973', NULL, 'Deltamethrin resistance protein prag01', 'Deltameth_res_prag01', 3, NULL),
(22718, NULL, 'IPR025123', NULL, 'Domain of unknown function DUF4049', 'DUF4049', 3, NULL),
(22719, NULL, 'IPR027795', NULL, 'CASTOR,  ACT domain', 'CASTOR_ACT_dom', 3, NULL),
(22720, NULL, 'IPR025026', NULL, 'Protein of unknown function DUF3915', 'DUF3915', 4, NULL),
(22721, NULL, 'IPR031514', NULL, 'Aberrant zinc-finger domain', 'Zf-C2H2_aberr', 3, NULL),
(22722, NULL, 'IPR027113', NULL, 'Transcription factor NFYB/HAP3', 'Transc_fact_NFYB/HAP3', 4, NULL),
(22723, NULL, 'IPR024365', NULL, 'Protein of unknown function DUF3839', 'DUF3839', 4, NULL),
(22724, NULL, 'IPR024448', NULL, 'Xylosyltransferase, C-terminal', 'XylT_C', 3, NULL),
(22725, NULL, 'IPR025021', NULL, 'Protein of unknown function DUF3910', 'DUF3910', 4, NULL),
(22726, NULL, 'IPR026393', NULL, 'Modification target Cys-rich repeat', 'tSAM_targ_Cxxx_rpt', 7, NULL),
(22727, NULL, 'IPR025114', NULL, 'Beta-carotene isomerase D27-like, C-terminal', 'D27-like_C', 3, NULL),
(22728, NULL, 'IPR026271', NULL, 'PRAME family', 'PRAME_family', 4, NULL),
(22729, NULL, 'IPR027104', NULL, 'U4/U6 small nuclear ribonucleoprotein Prp3', 'Prp3', 4, NULL),
(22730, NULL, 'IPR025091', NULL, 'Protein of unknown function DUF4019', 'DUF4019', 4, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(22731, NULL, 'IPR025146', NULL, 'Protein of unknown function DUF4088', 'DUF4088', 4, NULL),
(22732, NULL, 'IPR027105', NULL, 'U4/U6 small nuclear ribonucleoprotein Prp31', 'Prp31', 4, NULL),
(22733, NULL, 'IPR031655', NULL, 'FokI, D3 domain', 'FokI_D3', 3, NULL),
(22734, NULL, 'IPR032441', NULL, 'Putative virion membrane protein', 'SP24', 4, NULL),
(22735, NULL, 'IPR025732', NULL, 'MarB protein', 'MarB', 4, NULL),
(22736, NULL, 'IPR028229', NULL, 'Integrase repeat unit', 'Integrase_rpt', 7, NULL),
(22737, NULL, 'IPR025729', NULL, 'MsyB protein', 'MsyB', 4, NULL),
(22738, NULL, 'IPR031939', NULL, 'Surface-adhesin protein E-like', 'Adhesin_E-like', 4, NULL),
(22739, NULL, 'IPR025734', NULL, 'EspG family', 'EspG', 4, NULL),
(22740, NULL, 'IPR032056', NULL, 'Protein of unknown function DUF4798', 'DUF4798', 4, NULL),
(22741, NULL, 'IPR031502', NULL, 'Putative zinc-finger ribonucleoprotein', 'Zf_ribonucleo', 4, NULL),
(22742, NULL, 'IPR031821', NULL, 'SOSS complex subunit C', 'SOSSC', 4, NULL),
(22743, NULL, 'IPR026146', NULL, '28S ribosomal protein S24, mitochondrial', 'MRPS24', 4, NULL),
(22744, NULL, 'IPR025350', NULL, 'Protein of unknown function DUF4254', 'DUF4254', 4, NULL),
(22745, NULL, 'IPR024482', NULL, 'Domain of unknown function DUF3855', 'DUF3855', 3, NULL),
(22746, NULL, 'IPR031664', NULL, 'Protein of unknown function DUF5085', 'DUF5085', 4, NULL),
(22747, NULL, 'IPR025964', NULL, 'GGGtGRT protein', 'GGGtGRT', 4, NULL),
(22748, NULL, 'IPR031489', NULL, 'D,L-carboxypeptidase, peptidase domain', 'Peptidase_M99', 3, NULL),
(22749, NULL, 'IPR032095', NULL, 'Saccharopine dehydrogenase-like, C-terminal', 'Sacchrp_dh-like_C', 3, NULL),
(22750, NULL, 'IPR027432', NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase, C-terminal', 'dGTP_triphosphohydrolase_C', 5, NULL),
(22751, NULL, 'IPR027624', NULL, 'Thiazole/oxazole-forming peptide maturase, SagD family component', 'TOMM_cyclo_SagD', 4, NULL),
(22752, NULL, 'IPR027799', NULL, 'Replication termination factor 2, RING-finger', 'Rtf2_RING-finger', 3, NULL),
(22753, NULL, 'IPR024926', NULL, 'Nucleolar GTP-binding protein 1', 'NOG1', 4, NULL),
(22754, NULL, 'IPR026153', NULL, 'Treslin', 'Treslin', 4, NULL),
(22755, NULL, 'IPR024994', NULL, 'Protein of unknown function DUF3896', 'DUF3896', 4, NULL),
(22756, NULL, 'IPR025588', NULL, 'YcxB-like protein', 'YcxB', 3, NULL),
(22757, NULL, 'IPR024999', NULL, 'Protein of unknown function DUF3905', 'DUF3905', 4, NULL),
(22758, NULL, 'IPR025135', NULL, 'Protein of unknown function DUF4060', 'DUF4060', 4, NULL),
(22759, NULL, 'IPR032361', NULL, 'von Willebrand factor, VWA N-terminal domain', 'VWA_N2', 3, NULL),
(22760, NULL, 'IPR025088', NULL, 'Protein of unknown function DUF3970', 'DUF3970', 4, NULL),
(22761, NULL, 'IPR025070', NULL, 'Protein of unknown function DUF3938', 'DUF3938', 4, NULL),
(22762, NULL, 'IPR025104', NULL, 'Protein of unknown function DUF4027', 'DUF4027', 4, NULL),
(22763, NULL, 'IPR035939', NULL, 'FGD1, N-terminal PH domain', 'FGD1_PH1', 3, NULL),
(22764, NULL, 'IPR025119', NULL, 'Domain of unknown function DUF4046', 'DUF4046', 3, NULL),
(22765, NULL, 'IPR025122', NULL, 'Domain of unknown function DUF4048', 'DUF4048', 3, NULL),
(22766, NULL, 'IPR028230', NULL, 'Trimeric autotransporter adhesin, tryptophan-ring motif', 'TAA-Trp-ring', 3, NULL),
(22767, NULL, 'IPR032360', NULL, 'Protein of unknown function DUF4869', 'DUF4869', 4, NULL),
(22768, NULL, 'IPR025182', NULL, 'RNA polymerase-binding protein RbpA', 'RNApol-bd_RbpA', 4, NULL),
(22769, NULL, 'IPR025179', NULL, 'Protein of unknown function DUF4106', 'DUF4106', 4, NULL),
(22770, NULL, 'IPR027296', NULL, 'DNA fragmentation factor 45kDa, C-terminal', 'DFF-C', 5, NULL),
(22771, NULL, 'IPR026163', NULL, 'Nck-associated protein 5-like', 'Nckap5l', 4, NULL),
(22772, NULL, 'IPR030268', NULL, 'Nesprin-4', 'SYNE4', 4, NULL),
(22773, NULL, 'IPR031970', NULL, 'Anillin, N-terminal domain', 'Anillin_N', 3, NULL),
(22774, NULL, 'IPR031515', NULL, 'Protein of unknown function DUF5095', 'DUF5095', 4, NULL),
(22775, NULL, 'IPR031919', NULL, 'Alpha-L-fucosidase, C-terminal', 'Fucosidase_C', 3, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(22776, NULL, 'IPR024481', NULL, 'Helicase Sen1, N-terminal', 'Helicase_Sen1_N', 3, NULL),
(22777, NULL, 'IPR031675', NULL, 'Serine-threonine protein phosphatase, N-terminal', 'STPPase_N', 3, NULL),
(22778, NULL, 'IPR034176', NULL, 'Peptidase MprA-like catalytic domain', 'Peptidases_S8_13', 3, NULL),
(22779, NULL, 'IPR026157', NULL, 'Leucine zipper transcription factor-like protein 1', 'LZTFL1', 4, NULL),
(22780, NULL, 'IPR027948', NULL, 'Protein of unknown function (DUF4436)', 'DUF4436', 4, NULL),
(22781, NULL, 'IPR031760', NULL, 'Centromere DNA-binding protein complex CBF3 subunit B, C-terminal', 'Cep3_C', 3, NULL),
(22782, NULL, 'IPR026379', NULL, 'Seadornavirus VP3 protein', 'Seadorna_VP3', 4, NULL),
(22783, NULL, 'IPR025178', NULL, 'Domain of unknown function DUF4105', 'DUF4105', 3, NULL),
(22784, NULL, 'IPR031968', NULL, 'VASt domain', 'VASt', 3, NULL),
(22785, NULL, 'IPR032019', NULL, 'Frog antimicrobial peptide, ranacyclin-type, Ranidae', 'Frog_antimicrobial_Ranidae', 4, NULL),
(22786, NULL, 'IPR031763', NULL, 'Dinitrogenase iron-molybdenum cofactor, N-terminal', 'NafY_N', 3, NULL),
(22787, NULL, 'IPR032101', NULL, 'Axin-1/2, tankyrase-binding domain', 'Axin_TNKS-bd', 3, NULL),
(22788, NULL, 'IPR028235', NULL, 'Dynein assembly factor 3, C-terminal domain', 'DNAAF3_C', 3, NULL),
(22789, NULL, 'IPR025012', NULL, 'Domain of unknown function DUF3898', 'DUF3898', 3, NULL),
(22790, NULL, 'IPR025126', NULL, 'Protein of unknown function DUF4052', 'DUF4052', 4, NULL),
(22791, NULL, 'IPR032326', NULL, 'Protein of unknown function DUF4853', 'DUF4853', 4, NULL),
(22792, NULL, 'IPR024333', NULL, 'Mating-type protein A-alpha/beta 1, N-terminal', 'Mating-type_A-alpha/beta_1_N', 3, NULL),
(22793, NULL, 'IPR033997', NULL, 'Tumour necrosis factor receptor 3, N-terminal', 'TNFRSF3_N', 3, NULL),
(22794, NULL, 'IPR026660', NULL, 'Phosphoribosyl-AMP cyclohydrolase', 'PRA-CH', 4, NULL),
(22795, NULL, 'IPR025065', NULL, 'Protein of unknown function DUF4006', 'DUF4006', 4, NULL),
(22796, NULL, 'IPR027626', NULL, 'Pseudo-rSAM protein/SPASM domain protein', 'Pseudo_SAM_Halo', 4, NULL),
(22797, NULL, 'IPR031749', NULL, 'Cell division control protein 13, N-terminal', 'Cdc13_N', 3, NULL),
(22798, NULL, 'IPR032458', NULL, 'Histone H2A conserved site', 'Histone_H2A_CS', 2, NULL),
(22799, NULL, 'IPR025790', NULL, 'Suv4-20 family, animal', 'Suv4-20_animal', 4, NULL),
(22800, NULL, 'IPR025599', NULL, 'YjcZ-like protein', 'YjcZ', 4, NULL),
(22801, NULL, 'IPR030921', NULL, 'LPS export ABC transporter, ATP-binding protein LptB', 'LPS_export_LptB', 4, NULL),
(22802, NULL, 'IPR031915', NULL, 'Cryptic loci regulator 2, N-terminal', 'Clr2_N', 3, NULL),
(22803, NULL, 'IPR025082', NULL, 'Protein of unknown function DUF3964', 'DUF3964', 4, NULL),
(22804, NULL, 'IPR024367', NULL, 'Alpha-ketoglutarate-dependent dioxygenase FTO, catalytic domain', 'FTO_cat_dom', 3, NULL),
(22805, NULL, 'IPR031656', NULL, 'Alpha-glycerophosphate oxidase, C-terminal', 'DAO_C', 3, NULL),
(22806, NULL, 'IPR031759', NULL, 'Effector protein HopAB, BAK1-binding domain', 'HopAB_BAK-bd', 3, NULL),
(22807, NULL, 'IPR034132', NULL, 'Retropepsin Saci-like domain', 'RP_Saci-like', 3, NULL),
(22808, NULL, 'IPR031660', NULL, 'C-terminal associated domain of TOPRIM', 'TOPRIM_C', 3, NULL),
(22809, NULL, 'IPR025120', NULL, 'Domain of unknown function DUF4047', 'DUF4047', 3, NULL),
(22810, NULL, 'IPR031495', NULL, 'Protein of unknown function DUF5100', 'DUF5100', 4, NULL),
(22811, NULL, 'IPR025024', NULL, 'Protein of unknown function DUF3913', 'DUF3913', 4, NULL),
(22812, NULL, 'IPR025064', NULL, 'Domain of unknown function DUF4005', 'DUF4005', 3, NULL),
(22813, NULL, 'IPR034093', NULL, 'Ketohexokinase', 'KHK', 4, NULL),
(22814, NULL, 'IPR025180', NULL, 'Protein of unknown function DUF4107', 'DUF4107', 4, NULL),
(22815, NULL, 'IPR025093', NULL, 'Domain of unknown function DUF4020', 'DUF4020', 3, NULL),
(22816, NULL, 'IPR025061', NULL, 'Diedel', 'Diedel', 4, NULL),
(22817, NULL, 'IPR028288', NULL, 'SCAR/WAVE family', 'SCAR/WAVE_fam', 4, NULL),
(22818, NULL, 'IPR024312', NULL, 'TACC protein, fungi', 'TACC_fungi', 4, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(22819, NULL, 'IPR025058', NULL, 'Protein of unknown function DUF3995', 'DUF3995', 4, NULL),
(22820, NULL, 'IPR027109', NULL, 'SWR1-complex protein 4/DNA methyltransferase 1-associated protein 1', 'Swc4/Dmap1', 4, NULL),
(22821, NULL, 'IPR031966', NULL, 'PHD finger protein 12, MRG binding domain', 'PHF12_MRG-bd', 3, NULL),
(22822, NULL, 'IPR031737', NULL, 'Condensin-2 complex subunit H2, C-terminal', 'CNDH2_C', 3, NULL),
(22823, NULL, 'IPR031757', NULL, 'Glycosyltransferase family 88', 'Glyco_transf_88', 4, NULL),
(22824, NULL, 'IPR025108', NULL, 'Protein of unknown function DUF4030', 'DUF4030', 4, NULL),
(22825, NULL, 'IPR025591', NULL, 'RloB-like protein', 'RloB', 4, NULL),
(22826, NULL, 'IPR031758', NULL, 'Putative substrate of the Dot/Icm secretion system', 'SoDot-IcmSS', 4, NULL),
(22827, NULL, 'IPR025794', NULL, 'Histone H3-K9 methyltransferase, plant', 'H3-K9-MeTrfase_plant', 4, NULL),
(22828, NULL, 'IPR025143', NULL, 'Protein of unknown function DUF4083', 'DUF4083', 4, NULL),
(22829, NULL, 'IPR026816', NULL, 'Flavodoxin domain', 'Flavodoxin_dom', 3, NULL),
(22830, NULL, 'IPR032094', NULL, 'Meso-diaminopimelate D-dehydrogenase, C-terminal', 'Meso-DAP_DH_C', 3, NULL),
(22831, NULL, 'IPR025057', NULL, 'Domain of unknown function DUF3994', 'DUF3994', 3, NULL),
(22832, NULL, 'IPR032124', NULL, 'Bacteriophage F116-like holin', 'Phage_F116_holin', 4, NULL),
(22833, NULL, 'IPR025359', NULL, 'Shedu protein SduA, C-terminal', 'SduA_C', 3, NULL),
(22834, NULL, 'IPR032868', NULL, 'Alpha-ketoglutarate-dependent dioxygenase FTO', 'FTO', 4, NULL),
(22835, NULL, 'IPR025080', NULL, 'Protein of unknown function DUF3959', 'DUF3959', 4, NULL),
(22836, NULL, 'IPR026383', NULL, 'Seadornavirus VP4 protein', 'Seadorna_VP4', 4, NULL),
(22837, NULL, 'IPR032017', NULL, 'FAM76 protein', 'FAM76', 4, NULL),
(22838, NULL, 'IPR025140', NULL, 'Putative 2/3 transmembrane domain holin', 'Holin_2-3', 4, NULL),
(22839, NULL, 'IPR028231', NULL, 'Transcription elongation factor Spt6, YqgF domain', 'Spt6_YqgF', 3, NULL),
(22840, NULL, 'IPR025023', NULL, 'Protein of unknown function DUF3912', 'DUF3912', 4, NULL),
(22841, NULL, 'IPR030865', NULL, 'Lipopolysaccharide assembly protein B', 'LapB', 4, NULL),
(22842, NULL, 'IPR026279', NULL, 'Sigma-E factor negative regulatory protein RseA', 'RseA', 4, NULL),
(22843, NULL, 'IPR034129', NULL, 'Cathepsin D-like catalytic domain', 'Cathepsin_D-like', 3, NULL),
(22844, NULL, 'IPR032879', NULL, 'FixG, C-terminal immunoglobulin-like domain', 'FixG_C', 3, NULL),
(22845, NULL, 'IPR031953', NULL, 'mRNA-decapping enzyme, C-terminal', 'mRNA_decap_C', 3, NULL),
(22846, NULL, 'IPR032889', NULL, 'Gamma-glutamyl-hercynylcysteine sulfoxide hydrolase, Actinobacteria', 'EgtC_Actinobacteria', 4, NULL),
(22847, NULL, 'IPR025184', NULL, 'Adenylyltransferase AadA, C-terminal domain', 'AadA_C', 3, NULL),
(22848, NULL, 'IPR030657', NULL, 'Telomeric repeat-binding factor 2', 'TERF2', 4, NULL),
(22849, NULL, 'IPR025727', NULL, 'YbfN-like lipoprotein', 'YbfN-like', 4, NULL),
(22850, NULL, 'IPR031824', NULL, 'E3 ubiquitin-protein ligase RNF220, middle domain', 'RNF220_mid', 3, NULL),
(22851, NULL, 'IPR027618', NULL, 'Beta propeller repeat, Msarc-type', 'Beta_prop_Msarc', 7, NULL),
(22852, NULL, 'IPR025699', NULL, 'ABC-2 membrane transporter-like', 'ABC2_memb-like', 4, NULL),
(22853, NULL, 'IPR026381', NULL, 'RNA-directed RNA polymerase', 'Seadorna_RNAP', 4, NULL),
(22854, NULL, 'IPR024983', NULL, 'CHAT domain', 'CHAT_dom', 3, NULL),
(22855, NULL, 'IPR032121', NULL, 'Mycobacterial phage holin', 'Myco_phage_holin', 4, NULL),
(22856, NULL, 'IPR031948', NULL, 'Periplasmic lysozyme inhibitor, I-type', 'PliI', 4, NULL),
(22857, NULL, 'IPR030862', NULL, 'L-2-hydroxyglutarate dehydrogenase', 'L2HG_DH', 4, NULL),
(22858, NULL, 'IPR025349', NULL, 'Domain of unknown function DUF4253', 'DUF4253', 3, NULL),
(22859, NULL, 'IPR026586', NULL, 'Type 2 tetrahydrodipicolinate N-succinyltransferase family', 'Type2_DapD', 4, NULL),
(22860, NULL, 'IPR034133', NULL, 'Chemokine CC, DCCL motif-cointaining domain', 'Chemokine_CC_DCCL', 3, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(22861, NULL, 'IPR025698', NULL, '2TM domain', '2TM_dom', 3, NULL),
(22862, NULL, 'IPR024997', NULL, 'Protein of unknown function DUF3892', 'DUF3892', 4, NULL),
(22863, NULL, 'IPR024435', NULL, 'Histidyl tRNA synthetase-related domain', 'HisRS-related_dom', 3, NULL),
(22864, NULL, 'IPR032320', NULL, 'Glycoside hydrolase family 18, BT1044-like', 'GH18_BT1044-like', 4, NULL),
(22865, NULL, 'IPR025358', NULL, 'Protein of unknown function DUF4262', 'DUF4262', 4, NULL),
(22866, NULL, 'IPR028157', NULL, 'PELOTA RNA-binding domain', 'PELOTA_dom', 3, NULL),
(22867, NULL, 'IPR031986', NULL, 'Serine protease gd, N-terminal domain', 'GD_N', 3, NULL),
(22868, NULL, 'IPR031987', NULL, 'Trypanosoma glutamic acid/alanine-rich protein', 'GARP', 3, NULL),
(22869, NULL, 'IPR032108', NULL, 'CLIP1, zinc knuckle', 'CLIP1_ZNF', 3, NULL),
(22870, NULL, 'IPR031498', NULL, 'Bromodomain associated protein-like', 'Bromo_TP-like', 4, NULL),
(22871, NULL, 'IPR032455', NULL, 'Cadherin, cytoplasmic C-terminal domain', 'Cadherin_C', 3, NULL),
(22872, NULL, 'IPR025346', NULL, 'Protein of unknown function DUF4250', 'DUF4250', 4, NULL),
(22873, NULL, 'IPR025094', NULL, 'Protein of unknown function DUF4021', 'DUF4021', 4, NULL),
(22874, NULL, 'IPR031513', NULL, 'Spore wall protein', 'MICSWaP', 4, NULL),
(22875, NULL, 'IPR032847', NULL, 'Pre-mRNA-processing factor 17', 'PRPF17', 4, NULL),
(22876, NULL, 'IPR032127', NULL, 'LydA-holin antagonist LydB', 'LydB', 4, NULL),
(22877, NULL, 'IPR025183', NULL, 'Domain of unknown function DUF4110', 'DUF4110', 3, NULL),
(22878, NULL, 'IPR027794', NULL, 'tRNase Z endonuclease', 'tRNase_Z_dom', 3, NULL),
(22879, NULL, 'IPR028290', NULL, 'WASH1', 'WASH1', 4, NULL),
(22880, NULL, 'IPR025141', NULL, 'Domain of unknown function DUF4082', 'DUF4082', 3, NULL),
(22881, NULL, 'IPR025127', NULL, 'Protein of unknown function DUF4054', 'DUF4054', 4, NULL),
(22882, NULL, 'IPR025049', NULL, 'Fimbrillin-like 1', 'Mfa-like_1', 4, NULL),
(22883, NULL, 'IPR025031', NULL, 'Protein of unknown function DUF3919', 'DUF3919', 4, NULL),
(22884, NULL, 'IPR025118', NULL, 'Domain of unknown function DUF4045', 'DUF4045', 3, NULL),
(22885, NULL, 'IPR024307', NULL, 'YmaF', 'YmaF', 4, NULL),
(22886, NULL, 'IPR024473', NULL, 'Transposase, IS4, N-terminal', 'Transposases_IS4_N', 3, NULL),
(22887, NULL, 'IPR031686', NULL, 'ATPsynthase alpha/beta subunit, N-terminal extension', 'ATP-synth_a_Xtn', 3, NULL),
(22888, NULL, 'IPR025130', NULL, 'Protein of unknown function DUF4056', 'DUF4056', 4, NULL),
(22889, NULL, 'IPR031913', NULL, 'Spidroin, N-terminal', 'Spidroin_N', 3, NULL),
(22890, NULL, 'IPR028583', NULL, '4-O-beta-D-mannosyl-D-glucose phosphorylase', 'Man_Glc_phosphorylase', 4, NULL),
(22891, NULL, 'IPR028236', NULL, 'Ciliogenesis and planar polarity effector 1', 'CPLANE1', 4, NULL),
(22892, NULL, 'IPR026273', NULL, 'Low specificity L-threonine aldolase, bacteria', 'Low_specificity_L-TA_bact', 4, NULL),
(22893, NULL, 'IPR031452', NULL, 'Protein Kre1', 'Kre1', 4, NULL),
(22894, NULL, 'IPR031662', NULL, 'GTP binding protein, second domain', 'GTP-binding_2', 3, NULL),
(22895, NULL, 'IPR025062', NULL, 'Protein of unknown function DUF4003', 'DUF4003', 4, NULL),
(22896, NULL, 'IPR032331', NULL, 'Protein of unknown function DUF4856', 'DUF4856', 4, NULL),
(22897, NULL, 'IPR025357', NULL, 'Domain of unknown function DUF4261', 'DUF4261', 3, NULL),
(22898, NULL, 'IPR031753', NULL, 'Stomagen', 'Stomagen', 4, NULL),
(22899, NULL, 'IPR034163', NULL, 'Aspergillopepsin-like catalytic domain', 'Aspergillopepsin-like_cat_dom', 3, NULL),
(22900, NULL, 'IPR031752', NULL, 'Herpes viral adaptor, REF-binding domain', 'HHV-1_REF-bd', 3, NULL),
(22901, NULL, 'IPR031480', NULL, 'Cellulose-complementing protein', 'CcpAX', 4, NULL),
(22902, NULL, 'IPR031944', NULL, 'Ribosome biogenesis GTPase RsgA, N-terminal', 'RsgA_N', 3, NULL),
(22903, NULL, 'IPR025051', NULL, 'Protein of unknown function DUF3990', 'DUF3990', 4, NULL),
(22904, NULL, 'IPR031991', NULL, 'DNA repair protein Rev1, C-terminal', 'Rev1_C', 3, NULL),
(22905, NULL, 'IPR031509', NULL, 'Putative double-strand recombination repair protein-like', 'Mei5-like', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(22906, NULL, 'IPR025787', NULL, 'Histone-lysine N-methyltransferase, SET2, plant', 'Hist-Lys_N-MeTrfase_SET2_plant', 4, NULL),
(22907, NULL, 'IPR025071', NULL, 'Protein of unknown function DUF3939', 'DUF3939', 4, NULL),
(22908, NULL, 'IPR027631', NULL, '[FeFe] hydrogenase, group B1/B3', 'FeFe_hydrog_B1', 4, NULL),
(22909, NULL, 'IPR026259', NULL, 'Di-c-type haem protein, MauG/cytochrome c peroxidase', 'MauG/Cytc_peroxidase', 4, NULL),
(22910, NULL, 'IPR024440', NULL, 'Colicin D, C-terminal', 'ColicinD_C', 3, NULL),
(22911, NULL, 'IPR025132', NULL, 'Protein of unknown function DUF4058', 'DUF4058', 4, NULL),
(22912, NULL, 'IPR027949', NULL, 'Petal formation-expressed', 'Chloroplast_duf', 4, NULL),
(22913, NULL, 'IPR031139', NULL, 'RPGRIP1 family', 'RPGRIP1_fam', 4, NULL),
(22914, NULL, 'IPR024548', NULL, 'Copper type II ascorbate-dependent monooxygenase, C-terminal', 'Cu2_monoox_C', 3, NULL),
(22915, NULL, 'IPR025073', NULL, 'Protein of unknown function DUF3909', 'DUF3909', 4, NULL),
(22916, NULL, 'IPR025181', NULL, 'Protein of unknown function DUF4108', 'DUF4108', 4, NULL),
(22917, NULL, 'IPR025362', NULL, 'Domain of unknown function DUF4266', 'DUF4266', 3, NULL),
(22918, NULL, 'IPR025060', NULL, 'Protein of unknown function DUF3999', 'DUF3999', 4, NULL),
(22919, NULL, 'IPR025726', NULL, 'E3 ubiquitin ligase SopA-like central domain', 'SopA-like_central', 3, NULL),
(22920, NULL, 'IPR025131', NULL, 'Domain of unknown function DUF4057', 'DUF4057', 3, NULL),
(22921, NULL, 'IPR032057', NULL, 'Protein of unknown function DUF4799', 'DUF4799', 4, NULL),
(22922, NULL, 'IPR032053', NULL, 'Mitochondrial 28S ribosomal protein S34', 'MRP-S34', 4, NULL),
(22923, NULL, 'IPR030868', NULL, 'Chorismate dehydratase', 'MqnA', 4, NULL),
(22924, NULL, 'IPR024311', NULL, 'Lipocalin-like domain', 'Lipocalin-like', 3, NULL),
(22925, NULL, 'IPR025369', NULL, 'Domain of unknown function DUF4274', 'DUF4274', 3, NULL),
(22926, NULL, 'IPR026162', NULL, 'Myb/SANT-like DNA-binding domain-containing protein 4', 'MSANTD4', 4, NULL),
(22927, NULL, 'IPR025027', NULL, 'Protein of unknown function DUF3917', 'DUF3917', 4, NULL),
(22928, NULL, 'IPR025725', NULL, 'E3 ubiquitin-protein ligase SopA-like, catalytic domain', 'SopA-like_cat', 3, NULL),
(22929, NULL, 'IPR025799', NULL, 'Protein arginine N-methyltransferase', 'Arg_MeTrfase', 4, NULL),
(22930, NULL, 'IPR025188', NULL, 'Domain of unknown function DUF4113', 'DUF4113', 3, NULL),
(22931, NULL, 'IPR032881', NULL, 'Oberon, PHD finger domain', 'Oberon_PHD', 3, NULL),
(22932, NULL, 'IPR025187', NULL, 'Protein of unknown function DUF4112', 'DUF4112', 4, NULL),
(22933, NULL, 'IPR027950', NULL, 'Protein of unknown function DUF4576', 'DUF4576', 4, NULL),
(22934, NULL, 'IPR025037', NULL, 'Protein of unknown function DUF3923', 'DUF3923', 4, NULL),
(22935, NULL, 'IPR025363', NULL, 'Protein of unknown function DUF4267', 'DUF4267', 4, NULL),
(22936, NULL, 'IPR031755', NULL, 'Peptidase inhibitor I66', 'Inhibitor_I66', 4, NULL),
(22937, NULL, 'IPR028720', NULL, 'Protein HEG', 'HEG', 4, NULL),
(22938, NULL, 'IPR025048', NULL, 'Protein of unknown function DUF3987)', 'DUF3987', 4, NULL),
(22939, NULL, 'IPR025106', NULL, 'Protein of unknown function DUF4028', 'DUF4028', 4, NULL),
(22940, NULL, 'IPR032109', NULL, 'Bacterial Ig-like domain (group 3)', 'Big_3_5', 3, NULL),
(22941, NULL, 'IPR031497', NULL, 'Microsporidial 8TM transmembrane domain', '8TM_micro', 3, NULL),
(22942, NULL, 'IPR031990', NULL, 'Protein of unknown function DUF5066', 'DUF5066', 4, NULL),
(22943, NULL, 'IPR032126', NULL, 'LydA-like holin', 'LydA_holin', 4, NULL),
(22944, NULL, 'IPR031938', NULL, 'Protein inscuteable homologue, LGN-binding domain', 'INSC_LBD', 3, NULL),
(22945, NULL, 'IPR031477', NULL, 'E domain', 'SasG_E', 3, NULL),
(22946, NULL, 'IPR026817', NULL, 'Guanine nucleotide exchange factor Ect2', 'Ect2', 4, NULL),
(22947, NULL, 'IPR031512', NULL, 'Domain of unknown function DUF5096', 'DUF5096', 3, NULL),
(22948, NULL, 'IPR025348', NULL, 'Protein of unknown function DUF4252', 'DUF4252', 4, NULL),
(22949, NULL, 'IPR025361', NULL, 'Protein of unknown function DUF4265', 'DUF4265', 4, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(22950, NULL, 'IPR026145', NULL, 'Interleukin-33', 'IL-33', 4, NULL),
(22951, NULL, 'IPR025354', NULL, 'Protein of unknown function DUF4258', 'DUF4258', 4, NULL),
(22952, NULL, 'IPR030920', NULL, 'Sporulation killing factor system integral membrane protein SkfF', 'SkfF', 4, NULL),
(22953, NULL, 'IPR031484', NULL, 'Cellulose biosynthesis protein BcsO', 'CBP_BcsO', 4, NULL),
(22954, NULL, 'IPR032358', NULL, 'Protein of unknown function DUF4867', 'DUF4867', 4, NULL),
(22955, NULL, 'IPR026401', NULL, 'CXXX repeat peptide maturase', 'CXXX_matur', 3, NULL),
(22956, NULL, 'IPR025074', NULL, 'Protein of unknown function DUF3942', 'DUF3942', 4, NULL),
(22957, NULL, 'IPR031658', NULL, 'Cyclin, C-terminal domain 2', 'Cyclin_C_2', 3, NULL),
(22958, NULL, 'IPR031946', NULL, 'KIAA1045, RING finger', 'KIAA1045_Zf_RING', 3, NULL),
(22959, NULL, 'IPR026327', NULL, 'Methyl-coenzyme M reductase, protein C-like', 'Me_CoM_Rdtase_prot-C-like', 4, NULL),
(22960, NULL, 'IPR025050', NULL, 'Conjugative transposon protein TraL', 'TraL_transposon', 4, NULL),
(22961, NULL, 'IPR026376', NULL, 'Putative radical SAM-modified peptide', 'rSAM_modified_put', 4, NULL),
(22962, NULL, 'IPR025083', NULL, 'Protein of unknown function DUF3969', 'DUF3969', 4, NULL),
(22963, NULL, 'IPR025696', NULL, 'rRNA-processing arch domain', 'rRNA_proc-arch_dom', 3, NULL),
(22964, NULL, 'IPR025076', NULL, 'Protein of unknown function DUF3926', 'DUF3926', 4, NULL),
(22965, NULL, 'IPR031492', NULL, 'Protein of unknown function DUF5101', 'DUF5101', 4, NULL),
(22966, NULL, 'IPR024993', NULL, 'Protein of unknown function DUF3894', 'DUF3894', 4, NULL),
(22967, NULL, 'IPR025056', NULL, 'Protein of unknown function DUF3993', 'DUF3993', 4, NULL),
(22968, NULL, 'IPR024986', NULL, 'Sister chromatid cohesion C-terminal domain', 'Nipped-B_C', 3, NULL),
(22969, NULL, 'IPR025000', NULL, 'Protein of unknown function DUF3903', 'DUF3903', 4, NULL),
(22970, NULL, 'IPR026300', NULL, 'CWF11 family', 'CWF11_fam', 4, NULL),
(22971, NULL, 'IPR032325', NULL, 'Protein of unknown function DUF4852', 'DUF4852', 4, NULL),
(22972, NULL, 'IPR028228', NULL, 'Immunity protein 53', 'Imm53', 4, NULL),
(22973, NULL, 'IPR026384', NULL, 'Seadornavirus VP2 protein', 'Seadorna_VP2', 4, NULL),
(22974, NULL, 'IPR031964', NULL, 'Caspase recruitment domain', 'CARD_dom', 3, NULL),
(22975, NULL, 'IPR026156', NULL, 'Folliculin-interacting protein family', 'FNIP_fam', 4, NULL),
(22976, NULL, 'IPR025089', NULL, 'Protein of unknown function DUF4018', 'DUF4018', 4, NULL),
(22977, NULL, 'IPR031657', NULL, 'Replication protein A, OB domain', 'REPA_OB_2', 3, NULL),
(22978, NULL, 'IPR031505', NULL, 'Protein of unknown function DUF5098', 'DUF5098', 4, NULL),
(22979, NULL, 'IPR034187', NULL, 'PoSI-like peptidase domain', 'Peptidases_S8_5', 3, NULL),
(22980, NULL, 'IPR025087', NULL, 'Domain of unknown function DUF3965', 'DUF3965', 3, NULL),
(22981, NULL, 'IPR031478', NULL, 'Spermatogenesis-associated protein 1, C-terminal domain', 'SPATA1_C', 3, NULL),
(22982, NULL, 'IPR026142', NULL, 'Protein phosphatase 1 regulatory subunit 36', 'Pro_pase_1_reg_su_36', 4, NULL),
(22983, NULL, 'IPR025194', NULL, 'Domain of unknown function DUF4115', 'DUF4115', 3, NULL),
(22984, NULL, 'IPR026935', NULL, 'Butirosin biosynthesis protein H, N-terminal', 'BtrH_N', 3, NULL),
(22985, NULL, 'IPR031669', NULL, 'Fibronectin type III domain, fungi', 'Fn3_2', 3, NULL),
(22986, NULL, 'IPR024480', NULL, 'Domain of unknown function DUF3868', 'DUF3868', 3, NULL),
(22987, NULL, 'IPR031972', NULL, 'Cysteine/serine-rich nuclear protein, N-terminal domain', 'CSRNP_N', 3, NULL),
(22988, NULL, 'IPR026159', NULL, 'Cerebral cavernous malformations 2', 'Malcavernin', 4, NULL),
(22989, NULL, 'IPR025351', NULL, 'Pvc16, N-terminal', 'Pvc16_N', 3, NULL),
(22990, NULL, 'IPR026391', NULL, 'CRISPR-associated protein GSU0052/csb3, Dpsyc system', 'Cas_GSU0052', 4, NULL),
(22991, NULL, 'IPR025367', NULL, 'Protein of unknown function DUF4271', 'DUF4271', 4, NULL),
(22992, NULL, 'IPR024991', NULL, 'Anaphase-promoting complex subunit 11, RING-H2 finger', 'RING-H2_APC11', 3, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(22993, NULL, 'IPR026140', NULL, '28S ribosomal protein S26', 'MRPS26', 4, NULL),
(22994, NULL, 'IPR025013', NULL, 'Protein of unknown function DUF3907', 'DUF3907', 4, NULL),
(22995, NULL, 'IPR031654', NULL, 'Major capsid protein, N-terminal', 'Capsid_N', 3, NULL),
(22996, NULL, 'IPR034185', NULL, 'Site-1 peptidase catalytic domain', 'Site-1_peptidase_cat_dom', 3, NULL),
(22997, NULL, 'IPR032093', NULL, 'Phospholipase D, N-terminal', 'PhoD_N', 3, NULL),
(22998, NULL, 'IPR027615', NULL, 'Putative TOMM peptide', 'TOMM_nitrile_2', 4, NULL),
(22999, NULL, 'IPR031993', NULL, 'Domain of unknown function DUF4789', 'DUF4789', 3, NULL),
(23000, NULL, 'IPR031483', NULL, 'AP-1 complex-associated regulatory protein', 'AP1AR', 4, NULL),
(23001, NULL, 'IPR024534', NULL, 'Wadjet protein JetD, C-terminal', 'JetD_C', 3, NULL),
(23002, NULL, 'IPR027905', NULL, 'Cilia- and flagella-associated protein 95', 'CFAP95', 4, NULL),
(23003, NULL, 'IPR029487', NULL, 'Novel E3 ligase domain', 'NEL_dom', 3, NULL),
(23004, NULL, 'IPR025245', NULL, 'Protein of unknown function DUF4197', 'DUF4197', 4, NULL),
(23005, NULL, 'IPR025848', NULL, 'N6-adenosine-methyltransferase MT-A70-like', 'MT-A70', 4, NULL),
(23006, NULL, 'IPR032855', NULL, 'Arterivirus polyprotein, nsp2, immunogenic region', 'NSP2-B_epitope', 3, NULL),
(23007, NULL, 'IPR032419', NULL, 'NF-kappa-B essential modulator NEMO, CC2-LZ domain', 'CC2-LZ_dom', 3, NULL),
(23008, NULL, 'IPR025226', NULL, 'Protein of unknown function DUF4170', 'DUF4170', 4, NULL),
(23009, NULL, 'IPR026502', NULL, 'Histone RNA stem-loop-binding protein SLBP1/SLBP2', 'SLBP1/SLBP2', 4, NULL),
(23010, NULL, 'IPR025235', NULL, 'Domain of unknown function DUF4178', 'DUF4178', 3, NULL),
(23011, NULL, 'IPR029498', NULL, 'Prion-inhibition and propagation, HeLo domain', 'HeLo_dom', 3, NULL),
(23012, NULL, 'IPR025779', NULL, 'Methionine S-methyltransferase', 'Met_S-MeTrfase', 4, NULL),
(23013, NULL, 'IPR025261', NULL, 'Domain of unknown function DUF4210', 'DUF4210', 3, NULL),
(23014, NULL, 'IPR025293', NULL, 'YfiR/HmsC-like', 'YfiR/HmsC-like', 4, NULL),
(23015, NULL, 'IPR028080', NULL, 'Domain of unknown function DUF4454', 'DUF4454', 3, NULL),
(23016, NULL, 'IPR025241', NULL, 'Domain of unknown function DUF4190', 'DUF4190', 3, NULL),
(23017, NULL, 'IPR026351', NULL, 'Radical SAM/Cys-rich domain protein', 'rSAM_SeCys', 4, NULL),
(23018, NULL, 'IPR026590', NULL, 'Sirtuin family, catalytic core domain', 'Ssirtuin_cat_dom', 3, NULL),
(23019, NULL, 'IPR025778', NULL, 'Histone-lysine N-methyltransferase, plant', 'Hist-Lys_N-MeTrfase_plant', 4, NULL),
(23020, NULL, 'IPR025560', NULL, 'Immunity protein 22', 'Imm22', 4, NULL),
(23021, NULL, 'IPR025904', NULL, 'Tubulin-like', 'Tubulin-like', 4, NULL),
(23022, NULL, 'IPR026492', NULL, 'Cyanoexosortase B', 'Cyanoexo_CrtB', 4, NULL),
(23023, NULL, 'IPR025236', NULL, 'SR1 protein', 'SR1P', 4, NULL),
(23024, NULL, 'IPR028084', NULL, 'Folliculin-interacting protein, N-terminal domain', 'FNIP_N_dom', 3, NULL),
(23025, NULL, 'IPR025295', NULL, 'Domain of unknown function DUF4157', 'DUF4157', 3, NULL),
(23026, NULL, 'IPR025265', NULL, 'WPP domain', 'WPP_dom', 3, NULL),
(23027, NULL, 'IPR025916', NULL, 'Cold-inducible protein YdjO', 'YdjO', 4, NULL),
(23028, NULL, 'IPR032246', NULL, 'ACTH-associated domain', 'ACTH_assoc', 3, NULL),
(23029, NULL, 'IPR025604', NULL, 'Actin cytoskeleton-regulatory complex protein End3', 'End3', 4, NULL),
(23030, NULL, 'IPR024792', NULL, 'Rho GDP-dissociation inhibitor domain superfamily', 'RhoGDI_dom_sf', 5, NULL),
(23031, NULL, 'IPR029393', NULL, 'Tumour suppressor candidate 2', 'FUS1', 4, NULL),
(23032, NULL, 'IPR025237', NULL, 'Domain of unknown function DUF4183', 'DUF4183', 3, NULL),
(23033, NULL, 'IPR025286', NULL, 'MOFRL-associated domain', 'MOFRL_assoc_dom', 3, NULL),
(23034, NULL, 'IPR028257', NULL, 'Centrosomal protein of 126kDa', 'CEP126', 4, NULL),
(23035, NULL, 'IPR025256', NULL, 'Domain of unknown function DUF4203', 'DUF4203', 3, NULL),
(23036, NULL, 'IPR027915', NULL, 'Protein of unknown function DUF4452', 'DUF4452', 4, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(23037, NULL, 'IPR027292', NULL, 'DNA nucleotidylexotransferase (TdT)', 'TdT', 4, NULL),
(23038, NULL, 'IPR026523', NULL, 'Paraneoplastic antigen Ma', 'PNMA', 4, NULL),
(23039, NULL, 'IPR029396', NULL, 'Tuberoinfundibular peptide of 39 residues', 'TIP39', 4, NULL),
(23040, NULL, 'IPR025924', NULL, 'YHYH domain', 'YHYH_dom', 3, NULL),
(23041, NULL, 'IPR027424', NULL, 'Glucose Oxidase, domain 2', 'Glucose_Oxidase_domain_2', 5, NULL),
(23042, NULL, 'IPR029462', NULL, 'Regulator of nucleoside diphosphate kinase, N-terminal domain', 'Rnk_N', 3, NULL),
(23043, NULL, 'IPR025918', NULL, 'YIEGIA protein', 'YIEGIA', 4, NULL),
(23044, NULL, 'IPR032025', NULL, 'Protein of unknown function DUF5063', 'DUF5063', 4, NULL),
(23045, NULL, 'IPR026506', NULL, 'GDP-L-galactose/GDP-D-glucose phosphorylase', 'GDPGP', 4, NULL),
(23046, NULL, 'IPR025284', NULL, 'Protein of unknown function DUF4144', 'DUF4144', 4, NULL),
(23047, NULL, 'IPR028078', NULL, 'AP2-coincident, C-terminal domain', 'ACDC', 3, NULL),
(23048, NULL, 'IPR032036', NULL, 'Protein of unknown function DUF5062', 'DUF5062', 4, NULL),
(23049, NULL, 'IPR028751', NULL, 'Cation channel sperm-associated auxiliary subunit delta/epsilon', 'CATSPERD/E', 4, NULL),
(23050, NULL, 'IPR027569', NULL, 'GeoRSP system PqqD family protein', 'Geo_PqqD_fam', 4, NULL),
(23051, NULL, 'IPR024754', NULL, 'DNA polymerase III PolC-like, N-terminal domain II', 'DNA_PolC-like_N_II', 3, NULL),
(23052, NULL, 'IPR029225', NULL, 'Nse4/EID protein, Nse3/MAGE-binding domain', 'Nse4_Nse3-bd', 3, NULL),
(23053, NULL, 'IPR032035', NULL, 'Folliculin, DENN domain', 'Folliculin_DENN', 3, NULL),
(23054, NULL, 'IPR032415', NULL, 'TRPM, tetramerisation domain', 'TRPM_tetra', 3, NULL),
(23055, NULL, 'IPR027514', NULL, 'Methylthioribulose-1-phosphate dehydratase, eukaryotes', 'Salvage_MtnB_euk', 4, NULL),
(23056, NULL, 'IPR028085', NULL, 'Folliculin-interacting protein, middle domain', 'FNIP_mid_dom', 3, NULL),
(23057, NULL, 'IPR027433', NULL, 'Lipoxygenase, domain 3', 'Lipoxygenase_dom_3', 5, NULL),
(23058, NULL, 'IPR031325', NULL, 'RHS repeat', 'RHS_repeat', 7, NULL),
(23059, NULL, 'IPR027587', NULL, 'Conjugative transfer region protein TrbK', 'TrbK', 4, NULL),
(23060, NULL, 'IPR025558', NULL, 'Domain of unknown function DUF4283', 'DUF4283', 3, NULL),
(23061, NULL, 'IPR026455', NULL, 'ATP-GRASP peptide maturase, grasp-with-spasm system', 'GRASP_w_spasm', 4, NULL),
(23062, NULL, 'IPR028263', NULL, 'Flagellar motor switch protein FliG, N-terminal domain', 'FliG_N', 3, NULL),
(23063, NULL, 'IPR025149', NULL, 'Protein of unknown function DUF4090', 'DUF4090', 4, NULL),
(23064, NULL, 'IPR029405', NULL, 'APCDD1 domain', 'APCDD1_dom', 3, NULL),
(23065, NULL, 'IPR029463', NULL, 'Lysine-specific metallo-endopeptidase', 'Lys_MEP', 3, NULL),
(23066, NULL, 'IPR027505', NULL, 'Probable bifunctional methylthioribulose-1-phosphate dehydratase/enolase-phosphatase E1', 'MtnB_viridiplantae', 4, NULL),
(23067, NULL, 'IPR026161', NULL, 'FAM178 family', 'FAM178', 4, NULL),
(23068, NULL, 'IPR029019', NULL, 'Beta-hexosaminidase, eukaryotic type, N-terminal', 'HEX_eukaryotic_N', 3, NULL),
(23069, NULL, 'IPR026032', NULL, 'Probable 3-phenylpropionic acid transporter', 'HcaT', 4, NULL),
(23070, NULL, 'IPR032247', NULL, 'Domain of unknown function DUF4822', 'DUF4822', 3, NULL),
(23071, NULL, 'IPR026494', NULL, 'Ribonucleoside-diphosphate reductase subunit beta', 'RNR_NrdF-like', 4, NULL),
(23072, NULL, 'IPR025902', NULL, 'LssY-like C-terminal domain', 'LssY-like-C_dom', 3, NULL),
(23073, NULL, 'IPR028258', NULL, 'Exocyst complex component Sec3, PIP2-binding N-terminal domain', 'Sec3-PIP2_bind', 3, NULL),
(23074, NULL, 'IPR030511', NULL, 'Tetratricopeptide repeat protein 26', 'TTC26', 4, NULL),
(23075, NULL, 'IPR026489', NULL, 'CXC domain', 'CXC_dom', 3, NULL),
(23076, NULL, 'IPR026369', NULL, 'CxxC-20-CxxC protein', 'CxxC_20_CxxC', 4, NULL),
(23077, NULL, 'IPR026507', NULL, 'Piercer of microtubule wall 1/2', 'PIRC1/2', 4, NULL),
(23078, NULL, 'IPR024739', NULL, 'Protein tyrosine phosphatase, receptor type, N-terminal', 'PTP_recept_N', 3, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(23079, NULL, 'IPR032295', NULL, 'Domain of unknown function DUF4842', 'DUF4842', 3, NULL),
(23080, NULL, 'IPR026155', NULL, 'Apelin', 'Apelin', 4, NULL),
(23081, NULL, 'IPR026000', NULL, 'Anaphase-promoting complex subunit 5 domain', 'Apc5_dom', 3, NULL),
(23082, NULL, 'IPR032297', NULL, 'Torus domain', 'Torus', 3, NULL),
(23083, NULL, 'IPR029490', NULL, 'Cytochrome c-550 domain', 'Cytochrom_C550', 3, NULL),
(23084, NULL, 'IPR025937', NULL, 'PDGLE domain', 'PDGLE_dom', 3, NULL),
(23085, NULL, 'IPR025275', NULL, 'Putative glycosyl hydrolase domain DUF4015', 'DUF4015', 3, NULL),
(23086, NULL, 'IPR027568', NULL, 'Ornithine decarboxylase SpeF', 'ODC_inducible', 4, NULL),
(23087, NULL, 'IPR026521', NULL, 'THAP domain-containing protein 2', 'THAP2', 4, NULL),
(23088, NULL, 'IPR025934', NULL, 'NudC N-terminal domain', 'NudC_N_dom', 3, NULL),
(23089, NULL, 'IPR026002', NULL, 'L-2-amino-thiazoline-4-carboxylic acid hydrolase', 'ATC_hydrolase', 4, NULL),
(23090, NULL, 'IPR026341', NULL, 'Gliding motility-associated, C-terminal domain', 'Bac_Flav_CTERM', 3, NULL),
(23091, NULL, 'IPR028071', NULL, 'Macro-like domain', 'Macro-like_dom', 3, NULL),
(23092, NULL, 'IPR027911', NULL, 'Domain of unknown function DUF4604', 'DUF4604', 3, NULL),
(23093, NULL, 'IPR027612', NULL, 'Putative methyltransferase, LIC12133 family', 'Put_MTase_LIC12133', 4, NULL),
(23094, NULL, 'IPR027594', NULL, 'Methanogenesis multiheme c-type cytochrome', 'Methanoheme_cyt', 4, NULL),
(23095, NULL, 'IPR026443', NULL, 'Rhombotail lipoprotein', 'Rhombo_lipo', 4, NULL),
(23096, NULL, 'IPR026484', NULL, 'Cys-Xaa-Xaa-Xaa repeat radical SAM target protein', 'Syntroph_Cxxx', 4, NULL),
(23097, NULL, 'IPR025246', NULL, 'Transposase IS30-like HTH domain', 'IS30-like_HTH', 3, NULL),
(23098, NULL, 'IPR032031', NULL, 'Zinc finger FYVE domain-containing protein 21, C-terminal', 'ZFYVE21_C', 3, NULL),
(23099, NULL, 'IPR026368', NULL, 'SWIM/SEC-C metal-binding motif protein, PBPRA1643 family', 'SWIM_PBPRA1643', 4, NULL),
(23100, NULL, 'IPR028261', NULL, 'Dihydroprymidine dehydrogenase domain II', 'DPD_II', 3, NULL),
(23101, NULL, 'IPR026034', NULL, 'Cell shape-determining protein MreD, proteobacterial type', 'MreD_proteobac', 4, NULL),
(23102, NULL, 'IPR025720', NULL, 'ECF transporter, Riboflavin transporter RibU', 'RibU', 4, NULL),
(23103, NULL, 'IPR025807', NULL, 'Adrift-type ribose 2-O-methyltransferase domain', 'Adrift-typ_MeTrfase', 3, NULL),
(23104, NULL, 'IPR029403', NULL, 'RESP18 domain', 'RESP18_dom', 3, NULL),
(23105, NULL, 'IPR025758', NULL, 'Fic/DOC N-terminal', 'Fic/DOC_N', 3, NULL),
(23106, NULL, 'IPR032029', NULL, 'ADAM17, membrane-proximal domain', 'ADAM17_MPD', 3, NULL),
(23107, NULL, 'IPR025761', NULL, 'FFD box', 'FFD_box', 3, NULL),
(23108, NULL, 'IPR029491', NULL, 'Helicase Helix-turn-helix domain', 'Helicase_HTH', 3, NULL),
(23109, NULL, 'IPR028083', NULL, 'Spt6 acidic, N-terminal domain', 'Spt6_acidic_N_dom', 3, NULL),
(23110, NULL, 'IPR026441', NULL, 'Exosortase H, IPTLxxWG-CTERM-specific', 'Exosort_XrtH', 4, NULL),
(23111, NULL, 'IPR026332', NULL, 'Anaerobilin synthase HutW', 'HutW', 4, NULL),
(23112, NULL, 'IPR027573', NULL, 'Methyltransferase, FxLD system', 'Methyltran_FxLD', 4, NULL),
(23113, NULL, 'IPR027517', NULL, 'Deoxyhypusine hydroxylase', 'Deoxyhypusine_hydroxylase', 4, NULL),
(23114, NULL, 'IPR028111', NULL, 'Melanocortin-2 receptor accessory protein family', 'MRAP', 4, NULL),
(23115, NULL, 'IPR025883', NULL, 'Cadherin-like beta sandwich domain', 'Cadherin-like_b_sandwich', 3, NULL),
(23116, NULL, 'IPR027912', NULL, 'Cilia- and flagella-associated protein 54', 'CFAP54', 4, NULL),
(23117, NULL, 'IPR032023', NULL, 'GCC2, Rab binding domain', 'GCC2_Rab_bind', 3, NULL),
(23118, NULL, 'IPR025800', NULL, 'Calmodulin-lysine N-methyltransferase', 'CaM-Lys-N-MeTrfase', 4, NULL),
(23119, NULL, 'IPR028307', NULL, 'Lin-54 family', 'Lin-54_fam', 4, NULL),
(23120, NULL, 'IPR028088', NULL, 'Helix-turn-helix DNA-binding domain of Spt6', 'Spt6_HTH_DNA-bd_dom', 3, NULL),
(23121, NULL, 'IPR026439', NULL, 'ATP-grasp ribosomal peptide maturase, MvdD family', 'ATP_grasp_rbs_pep_matu_MvdD', 4, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(23122, NULL, 'IPR032412', NULL, 'Myosin VI, cargo binding domain', 'Myosin-VI_CBD', 3, NULL),
(23123, NULL, 'IPR028744', NULL, 'Cation channel sperm-associated protein 4', 'CatSper4', 4, NULL),
(23124, NULL, 'IPR025920', NULL, 'Bacterial virulence factor lipase, N-terminal domain', 'Lipase_bact_N', 3, NULL),
(23125, NULL, 'IPR025302', NULL, 'Domain of unknown function DUF4162', 'DUF4162', 3, NULL),
(23126, NULL, 'IPR025251', NULL, 'Domain of unknown function DUF4213', 'DUF4213', 3, NULL),
(23127, NULL, 'IPR028107', NULL, 'Spatacsin, C-terminal domain', 'Spatacsin_C_dom', 3, NULL),
(23128, NULL, 'IPR025605', NULL, 'OST-HTH/LOTUS domain', 'OST-HTH/LOTUS_dom', 3, NULL),
(23129, NULL, 'IPR026985', NULL, 'Fanconi anemia-associated protein of 24kDa', 'FAAP24', 4, NULL),
(23130, NULL, 'IPR025227', NULL, 'Protein of unknown function DUF4169', 'DUF4169', 4, NULL),
(23131, NULL, 'IPR026170', NULL, 'N-lysine methyltransferase FAM173A/B', 'FAM173A/B', 4, NULL),
(23132, NULL, 'IPR025776', NULL, 'Histone-lysine N-methyltransferase SUVR4/SUVR1/SUVR2', 'SUVR4/1/2', 4, NULL),
(23133, NULL, 'IPR032862', NULL, 'Alpha-ketoglutarate-dependent dioxygenase alkB homologue 6', 'ALKBH6', 4, NULL),
(23134, NULL, 'IPR025277', NULL, 'Putative glycohydrolase domain DUF4038', 'DUF4038', 3, NULL),
(23135, NULL, 'IPR027589', NULL, 'Choice-of-anchor B domain', 'Choice_anch_B', 3, NULL),
(23136, NULL, 'IPR027633', NULL, 'Putative heme D1 biosynthesis radical SAM protein NirJ2', 'rSAM_NirJ2', 4, NULL),
(23137, NULL, 'IPR025723', NULL, 'Anion-transporting ATPase-like domain', 'Anion-transp_ATPase-like_dom', 3, NULL),
(23138, NULL, 'IPR031999', NULL, 'Pathogenicity island protein gp6, Staphylococcus', 'SAPIS-gp6', 4, NULL),
(23139, NULL, 'IPR028103', NULL, 'Spatacsin', 'Spatacsin', 4, NULL),
(23140, NULL, 'IPR025258', NULL, 'Rubicon Homology Domain', 'RH_dom', 3, NULL),
(23141, NULL, 'IPR026448', NULL, 'Methyltransferase, ATP-grasp peptide maturase system', 'Methyltr_grasp', 4, NULL),
(23142, NULL, 'IPR025901', NULL, 'Kinesin-associated microtubule-binding domain', 'Kinesin-assoc_MT-bd_dom', 3, NULL),
(23143, NULL, 'IPR029017', NULL, 'Enolase-like, N-terminal', 'Enolase-like_N', 5, NULL),
(23144, NULL, 'IPR029002', NULL, 'Phospholipase C/D', 'PLPC/GPLD1', 3, NULL),
(23145, NULL, 'IPR025935', NULL, 'Bacteriophage abortive infection AbiH', 'AbiH', 4, NULL),
(23146, NULL, 'IPR024388', NULL, 'Ribosomal protein L20, mitochondrial', 'Ribosomal_L20_mt', 4, NULL),
(23147, NULL, 'IPR029353', NULL, 'Neuronal tyrosine-phosphorylated phosphoinositide-3-kinase adapter, C-terminal domain', 'NYAP_C', 3, NULL),
(23148, NULL, 'IPR024796', NULL, 'T4 endonuclease V', 'T4_endonuc_V', 5, NULL),
(23149, NULL, 'IPR025566', NULL, 'Protein of unknown function DUF4331', 'DUF4331', 4, NULL),
(23150, NULL, 'IPR025784', NULL, 'Protein N-terminal and lysine N-methyltransferase EFM7', 'EFM7', 4, NULL),
(23151, NULL, 'IPR027597', NULL, 'HprK-related kinase B', 'HprK-rel_B', 4, NULL),
(23152, NULL, 'IPR024566', NULL, 'Colicin, receptor domain', 'Colicin_R_dom', 3, NULL),
(23153, NULL, 'IPR028009', NULL, 'N-acetyltransferase ESCO, acetyl-transferase domain', 'ESCO_Acetyltransf_dom', 3, NULL),
(23154, NULL, 'IPR031995', NULL, 'Inositol polyphosphate 5-phosphatase, clathrin binding domain', 'OCRL_clath-bd', 3, NULL),
(23155, NULL, 'IPR028072', NULL, 'Domain of unknown function DUF4466', 'DUF4466', 3, NULL),
(23156, NULL, 'IPR026456', NULL, 'Glycosyltransferase AglJ', 'GCTrfase_AglJ', 4, NULL),
(23157, NULL, 'IPR026504', NULL, 'Meiosis-specific nuclear structural protein 1', 'MNS1', 4, NULL),
(23158, NULL, 'IPR025296', NULL, 'Domain of unknown function DUF4158', 'DUF4158', 3, NULL),
(23159, NULL, 'IPR027921', NULL, 'NOP protein chaperone 1', 'NOPCHAP1', 4, NULL),
(23160, NULL, 'IPR029391', NULL, 'COP9 signalosome complex, subunit 9, metazoa', 'CSN9_metazoa', 4, NULL),
(23161, NULL, 'IPR024372', NULL, 'Proteasome component Ecm29', 'Ecm29', 4, NULL),
(23162, NULL, 'IPR025969', NULL, 'Abscisic acid G-protein coupled receptor-like domain', 'ABA_GPCR_dom', 3, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(23163, NULL, 'IPR029460', NULL, 'DNA polymerase, helix-hairpin-helix motif', 'DNAPol_HHH', 3, NULL),
(23164, NULL, 'IPR025991', NULL, 'Chemoreceptor zinc-binding domain', 'Chemoreceptor_zinc-bind_dom', 3, NULL),
(23165, NULL, 'IPR026482', NULL, 'Nif11-class peptide radical SAM maturase 3', 'rSAM_nif11_3', 4, NULL),
(23166, NULL, 'IPR026596', NULL, 'Bifunctional enzyme IspD/IspF', 'IspD/F', 4, NULL),
(23167, NULL, 'IPR025760', NULL, 'Fetuin-A-type cystatin domain', 'Cystatin_Fetuin_A', 3, NULL),
(23168, NULL, 'IPR027571', NULL, 'GeoRSP system SPASM domain protein', 'GeoRSP_SPASM', 4, NULL),
(23169, NULL, 'IPR026033', NULL, 'Azaguanine-like transporters, bacteria and archaea type', 'Azg-like_bact_archaea', 4, NULL),
(23170, NULL, 'IPR027570', NULL, 'GeoRSP system radical SAM/SPASM protein', 'GeoRSP_rSAM', 4, NULL),
(23171, NULL, 'IPR032387', NULL, 'Acetyl-coenzyme A synthetase, N-terminal domain', 'ACAS_N', 3, NULL),
(23172, NULL, 'IPR032858', NULL, 'Cbb3-type cytochrome c oxidase subunit CcoP, N-terminal', 'CcoP_N', 3, NULL),
(23173, NULL, 'IPR025279', NULL, 'Stress response protein NST1', 'NST1', 4, NULL),
(23174, NULL, 'IPR026487', NULL, 'Sporadically distributed protein CHP04141', 'CHP04141', 4, NULL),
(23175, NULL, 'IPR026052', NULL, 'DNA-binding protein inhibitor', 'DNA-bd_prot-inh', 4, NULL),
(23176, NULL, 'IPR027622', NULL, 'Radical SAM/SPASM domain-containing Clo7bot peptide maturase', 'rSAM_Clo7bot', 4, NULL),
(23177, NULL, 'IPR026004', NULL, 'Septum formation-related domain', 'Septum_form', 3, NULL),
(23178, NULL, 'IPR028746', NULL, 'Cation channel sperm-associated protein 1', 'CatSper1', 4, NULL),
(23179, NULL, 'IPR026003', NULL, 'HEAT repeat associated with sister chromatid cohesion protein', 'Cohesin_HEAT', 7, NULL),
(23180, NULL, 'IPR032059', NULL, 'Mucin-like domain', 'Mucin-like', 3, NULL),
(23181, NULL, 'IPR026054', NULL, 'Nuclear pore complex protein', 'Nucleoporin', 4, NULL),
(23182, NULL, 'IPR025938', NULL, 'RRXRR domain', 'RRXRR_dom', 3, NULL),
(23183, NULL, 'IPR025570', NULL, 'Protein of unknown function DUF4337', 'DUF4337', 4, NULL),
(23184, NULL, 'IPR032425', NULL, 'Talin, N-terminal F0 domain', 'FERM_f0', 3, NULL),
(23185, NULL, 'IPR026501', NULL, 'Limbin/EvC complex member EVC', 'Limbin/EVC', 4, NULL),
(23186, NULL, 'IPR030479', NULL, 'Syndecan, conserved site', 'Syndecan_CS', 2, NULL),
(23187, NULL, 'IPR030816', NULL, 'Conserved hypothetical protein CHP04376', 'CHP04376', 4, NULL),
(23188, NULL, 'IPR024579', NULL, 'Bcl-2-interacting killer', 'Bcl2-int_killer', 4, NULL),
(23189, NULL, 'IPR024793', NULL, 'Thrombin inhibitor hirudin', 'Hirudin', 5, NULL),
(23190, NULL, 'IPR027616', NULL, 'CRISPR-associated protein Cas4, PREFRAN subtype', 'Cas4_PREFRAN', 4, NULL),
(23191, NULL, 'IPR025766', NULL, 'ADD domain', 'ADD', 3, NULL),
(23192, NULL, 'IPR026144', NULL, 'Neuritin family', 'Neuritin_fam', 4, NULL),
(23193, NULL, 'IPR025911', NULL, 'ToxN/AbiQ toxin', 'ToxN/AbiQ_toxin', 4, NULL),
(23194, NULL, 'IPR027500', NULL, '40S ribosomal protein S1/3, eukaryotes', 'Ribosomal_S1/3_euk', 4, NULL),
(23195, NULL, 'IPR027593', NULL, 'Aromatic cluster surface protein', 'Aro_clust', 4, NULL),
(23196, NULL, 'IPR026454', NULL, 'Rhombotarget A', 'Rhombotarget_A', 4, NULL),
(23197, NULL, 'IPR027908', NULL, 'Protein of unknown function DUF4640', 'DUF4640', 4, NULL),
(23198, NULL, 'IPR032856', NULL, 'Putative glycogen debranching enzyme, N-terminal', 'GDE_N_bis', 3, NULL),
(23199, NULL, 'IPR026374', NULL, 'PEP-CTERM protein sorting domain, cyanobacterial subclass', 'Cyano_PEP', 3, NULL),
(23200, NULL, 'IPR024353', NULL, 'Protein of unknown function DUF3871', 'DUF3871', 4, NULL),
(23201, NULL, 'IPR025238', NULL, 'Protein of unknown function DUF4184', 'DUF4184', 4, NULL),
(23202, NULL, 'IPR025294', NULL, 'Protein of unknown function DUF4156', 'DUF4156', 4, NULL),
(23203, NULL, 'IPR032414', NULL, 'Matrix protein, Bornaviridae', 'BDV_M', 4, NULL),
(23204, NULL, 'IPR027625', NULL, 'Putative 4-mercaptohistidine N1-methyltranferase, OvoA C-terminal domain', 'OvoA_Cterm', 3, NULL),
(23205, NULL, 'IPR032024', NULL, 'Protein of unknown function DUF5064', 'DUF5064', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(23206, NULL, 'IPR029467', NULL, 'Cytochrome c7-like', 'Cyt_c7-like', 3, NULL),
(23207, NULL, 'IPR028074', NULL, 'PTHB1, C-terminal domain', 'PHTB1_C_dom', 3, NULL),
(23208, NULL, 'IPR027914', NULL, 'Domain of unknown function DUF4456', 'DUF4456', 3, NULL),
(23209, NULL, 'IPR026371', NULL, 'PGF-CTERM archaeal protein-sorting signal', 'PGF_CTERM', 3, NULL),
(23210, NULL, 'IPR030480', NULL, 'Natriuretic peptide, conserved site', 'Natr_peptide_CS', 2, NULL),
(23211, NULL, 'IPR029352', NULL, 'Photoreceptor cilium actin regulator', 'PCARE', 4, NULL),
(23212, NULL, 'IPR026036', NULL, 'PucC protein', 'PucC', 4, NULL),
(23213, NULL, 'IPR026158', NULL, 'Apolipoprotein B receptor', 'ApolipoprotB_rcpt', 4, NULL),
(23214, NULL, 'IPR026172', NULL, 'Gamma-secretase-activating protein family', 'GSAP_fam', 4, NULL),
(23215, NULL, 'IPR032859', NULL, 'GTPase Der, C-terminal KH-domain-like', 'KH_dom-like', 3, NULL),
(23216, NULL, 'IPR032027', NULL, 'Synphilin-1, alpha-Synuclein-binding domain', 'SNCAIP_SNCA-bd', 3, NULL),
(23217, NULL, 'IPR026269', NULL, 'Tat proofreading chaperone DmsD-type', 'DmsD-type', 4, NULL),
(23218, NULL, 'IPR027567', NULL, 'Exosortase XrtM', 'Exosort_XrtM', 4, NULL),
(23219, NULL, 'IPR028748', NULL, 'Cation channel sperm-associated auxiliary subunit beta', 'CATSPERB', 4, NULL),
(23220, NULL, 'IPR027614', NULL, 'Predicted outer membrane protein, Leptospiraceae', 'OMP_Lepto', 4, NULL),
(23221, NULL, 'IPR028073', NULL, 'PTHB1, N-terminal domain', 'PHTB1_N_dom', 3, NULL),
(23222, NULL, 'IPR027913', NULL, 'Protein of unknown function DUF4473', 'DUF4473', 4, NULL),
(23223, NULL, 'IPR026452', NULL, 'Surface glycoprotein signal peptide', 'Surf_glycop_sig_pep', 3, NULL),
(23224, NULL, 'IPR026442', NULL, 'IPTL-CTERM protein sorting domain', 'IPTL_CTERM', 3, NULL),
(23225, NULL, 'IPR035941', NULL, 'FGD1-4, C-terminal PH domain', 'FGD1-4_PH2', 3, NULL),
(23226, NULL, 'IPR027902', NULL, 'Protein of unknown function DUF4487', 'DUF4487', 4, NULL),
(23227, NULL, 'IPR026333', NULL, 'ATP-dependent DNA ligase, PP_1105 family', 'ATP_dep_DNA_lig_pp_1105_fam', 4, NULL),
(23228, NULL, 'IPR027501', NULL, 'Lon protease homologue 2, peroxisomal', 'Lonp2_euk', 4, NULL),
(23229, NULL, 'IPR026164', NULL, 'Integrator complex subunit 10', 'Int_cplx_su10', 4, NULL),
(23230, NULL, 'IPR027464', NULL, 'Ornithine decarboxylase, N-terminal', 'Ornithine_deCO2ase_N', 5, NULL),
(23231, NULL, 'IPR027575', NULL, 'FxLD family lantipeptide', 'LD_lanti_pre', 4, NULL),
(23232, NULL, 'IPR027511', NULL, 'Enolase-phosphatase E1, eukaryotes', 'ENOPH1_eukaryotes', 4, NULL),
(23233, NULL, 'IPR032003', NULL, 'Ribosome-associated complex head domain', 'RAC_head', 3, NULL),
(23234, NULL, 'IPR026488', NULL, 'Exosortase C, VPDSG-CTERM-specific', 'Exosort_VPDSG', 4, NULL),
(23235, NULL, 'IPR026362', NULL, 'DEXH box helicase, DNA ligase-associated', 'DEXH_lig_assoc', 4, NULL),
(23236, NULL, 'IPR029481', NULL, 'ABC-transporter, N-terminal domain', 'ABC_trans_N', 3, NULL),
(23237, NULL, 'IPR029865', NULL, 'Dyslexia-associated protein KIAA0319-like', 'KIAA0319-like', 4, NULL),
(23238, NULL, 'IPR028440', NULL, 'Transcription factor TRPS1', 'TRPS1', 4, NULL),
(23239, NULL, 'IPR025856', NULL, 'HeH/LEM domain', 'HeH/LEM_domain', 3, NULL),
(23240, NULL, 'IPR027503', NULL, 'Lon protease homologue, chloroplastic/mitochondrial', 'Lonm_euk', 4, NULL),
(23241, NULL, 'IPR032245', NULL, 'RecQ-mediated genome instability protein 2', 'RMI2', 4, NULL),
(23242, NULL, 'IPR025606', NULL, 'NLPC/P60, N-terminal domain', 'NLPC/P60_N_dom', 3, NULL),
(23243, NULL, 'IPR025563', NULL, 'Protein of unknown function DUF4286', 'DUF4286', 4, NULL),
(23244, NULL, 'IPR025262', NULL, 'Quorum-sensing regulator protein G', 'QseG', 4, NULL),
(23245, NULL, 'IPR026627', NULL, 'NADH dehydrogenase [ubiquinone] 1 beta subcomplex subunit 2, animal type', 'NDUFB2_animal', 4, NULL),
(23246, NULL, 'IPR029240', NULL, 'MMS19, N-terminal', 'MMS19_N', 3, NULL),
(23247, NULL, 'IPR025252', NULL, 'Domain of unknown function DUF4200', 'DUF4200', 3, NULL),
(23248, NULL, 'IPR025930', NULL, 'NETI protein', 'NETI', 4, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(23249, NULL, 'IPR025259', NULL, 'Coiled-coil domain-containing protein 34/181', 'CCDC34/181', 3, NULL),
(23250, NULL, 'IPR026446', NULL, 'ATP-grasp ribosomal peptide maturase, MvdC family', 'ATP_grasp_MvdC', 4, NULL),
(23251, NULL, 'IPR026493', NULL, 'Cys-rich peptide', 'Cys-rich_pep', 4, NULL),
(23252, NULL, 'IPR025269', NULL, 'Phage integrase SAM-like domain', 'SAM-like_dom', 3, NULL),
(23253, NULL, 'IPR029246', NULL, 'Protein TALPID3', 'TALPID3', 4, NULL),
(23254, NULL, 'IPR025283', NULL, 'Domain of unknown function DUF4042', 'DUF4042', 3, NULL),
(23255, NULL, 'IPR027520', NULL, 'Structure-specific endonuclease subunit Slx1', 'Slx1', 4, NULL),
(23256, NULL, 'IPR024383', NULL, 'Domain of unknown function DUF3849', 'DUF3849', 3, NULL),
(23257, NULL, 'IPR028079', NULL, 'Zc3h12a-like Ribonuclease NYN domain', 'RNase_Zc3h12a_2', 3, NULL),
(23258, NULL, 'IPR026485', NULL, 'Archaeosortase family protein ArtE', 'Archaeo_ArtE', 4, NULL),
(23259, NULL, 'IPR025240', NULL, 'Domain of unknown function DUF4189', 'DUF4189', 3, NULL),
(23260, NULL, 'IPR025255', NULL, 'Protein of unknown function DUF4202', 'DUF4202', 4, NULL),
(23261, NULL, 'IPR025297', NULL, 'Domain of unknown function DUF4159', 'DUF4159', 3, NULL),
(23262, NULL, 'IPR030465', NULL, 'Centrosomal protein of 131kDa', 'CEP131', 4, NULL),
(23263, NULL, 'IPR032020', NULL, 'CAG pathogenicity island protein 13', 'CagS', 4, NULL),
(23264, NULL, 'IPR025299', NULL, 'CstA, C-terminal domain', 'CstA_C', 3, NULL),
(23265, NULL, 'IPR025568', NULL, 'Domain of unknown function DUF4334', 'DUF4334', 3, NULL),
(23266, NULL, 'IPR026499', NULL, 'Peptide S-glycosyltransferase, SunS family', 'S_glycosyl_SunS', 4, NULL),
(23267, NULL, 'IPR024575', NULL, 'Cloacin colicin family', 'Cloacin_colicin_fam', 4, NULL),
(23268, NULL, 'IPR028997', NULL, 'PA2201-like, N-terminal', 'PA2201-like_N', 5, NULL),
(23269, NULL, 'IPR026505', NULL, 'Solute carrier family 35 member F3/F4', 'Solute_c_fam_35_mem_F3/F4', 4, NULL),
(23270, NULL, 'IPR024385', NULL, 'Domain of unknown function DUF3854', 'DUF3854', 3, NULL),
(23271, NULL, 'IPR024371', NULL, 'Acetyl-coenzyme A transporter 1-like', 'AcetylCoA_trans_1-like', 4, NULL),
(23272, NULL, 'IPR026001', NULL, 'Abortive infection protein-like, C-terminal domain', 'Abi-like_C', 3, NULL),
(23273, NULL, 'IPR028021', NULL, 'Katanin p80 subunit, C-terminal', 'Katanin_C-terminal', 3, NULL),
(23274, NULL, 'IPR034251', NULL, 'Ephrin type-A receptor 1, ligand binding domain', 'EphA1_rcpt_lig-bd', 3, NULL),
(23275, NULL, 'IPR024380', NULL, 'Domain of unknown function DUF3848', 'DUF3848', 3, NULL),
(23276, NULL, 'IPR025253', NULL, 'Type I toxin-antitoxin system, toxin Ldr', 'Toxin_Ldr', 4, NULL),
(23277, NULL, 'IPR025254', NULL, 'Domain of unknown function DUF4201', 'DUF4201', 3, NULL),
(23278, NULL, 'IPR025615', NULL, 'TILa domain', 'TILa_dom', 3, NULL),
(23279, NULL, 'IPR032299', NULL, 'Protein of unknown function DUF4843', 'DUF4843', 4, NULL),
(23280, NULL, 'IPR028077', NULL, 'Ubiquitin/SUMO-activating enzyme ubiquitin-like domain', 'UAE_UbL_dom', 3, NULL),
(23281, NULL, 'IPR025562', NULL, 'Type VI secretion system (T6SS), amidase effector protein 4', 'Tae4', 4, NULL),
(23282, NULL, 'IPR028075', NULL, 'Domain of unknown function with cystatin-like fold DUF4467', 'DUF4467', 3, NULL),
(23283, NULL, 'IPR032417', NULL, 'T3SS negative regulator GrlR', 'GrlR', 4, NULL),
(23284, NULL, 'IPR025291', NULL, 'Protein of unknown function DUF4153', 'DUF4153', 4, NULL),
(23285, NULL, 'IPR025569', NULL, 'Protein of unknown function DUF4335', 'DUF4335', 4, NULL),
(23286, NULL, 'IPR026440', NULL, 'DNA phosphorothioation-associated DGQHR protein 1', 'DNA_PRithio_assoc_DGOHR_pro_1', 4, NULL),
(23287, NULL, 'IPR027467', NULL, 'Molybdopterin oxidoreductase, molybdopterin cofactor binding site', 'MopterinOxRdtase_cofactor_BS', 1, NULL),
(23288, NULL, 'IPR027904', NULL, 'Domain of unknown function DUF4587', 'DUF4587', 3, NULL),
(23289, NULL, 'IPR025260', NULL, 'Chromodomain-helicase-DNA-binding protein 1-like, C-terminal domain', 'CHD1-like_C', 3, NULL),
(23290, NULL, 'IPR026345', NULL, 'Adhesin isopeptide-forming adherence domain', 'Adh_isopep-form_adh_dom', 3, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(23291, NULL, 'IPR026530', NULL, 'Phosphoenolpyruvate synthase regulatory protein', 'PSRP', 4, NULL),
(23292, NULL, 'IPR027910', NULL, 'YdiL domain superfamily', 'YdiL_sf', 5, NULL),
(23293, NULL, 'IPR026486', NULL, 'Uncharacterised protein AF_0576', 'CHP_AF_0576', 4, NULL),
(23294, NULL, 'IPR026587', NULL, 'Sirtuin, class II', 'Sirtuin_class_II', 4, NULL),
(23295, NULL, 'IPR025228', NULL, 'Domain of unknown function DUF4171', 'DUF4171', 3, NULL),
(23296, NULL, 'IPR025557', NULL, 'Protein of unknown function DUF4282', 'DUF4282', 4, NULL),
(23297, NULL, 'IPR027600', NULL, 'HprK-related kinase A', 'HprK-rel_A', 4, NULL),
(23298, NULL, 'IPR029016', NULL, 'GAF-like domain superfamily', 'GAF-like_dom_sf', 5, NULL),
(23299, NULL, 'IPR032385', NULL, 'T-box transcription factor-associated', 'T-box_assoc', 3, NULL),
(23300, NULL, 'IPR025985', NULL, 'YnbE-like lipoprotein', 'YnbE-like', 4, NULL),
(23301, NULL, 'IPR026481', NULL, 'CCGSCS motif protein', 'CCGSCS', 4, NULL),
(23302, NULL, 'IPR027903', NULL, 'Protein of unknown function DUF4566', 'DUF4566', 4, NULL),
(23303, NULL, 'IPR030312', NULL, 'Interleukin-1 receptor-associated kinase 1-binding protein 1', 'IRAK1BP1', 4, NULL),
(23304, NULL, 'IPR027604', NULL, 'Tungsten cofactor oxidoreducase radical SAM maturase', 'W_rSAM_matur', 4, NULL),
(23305, NULL, 'IPR024794', NULL, 'Ribosomal protein L15e core domain superfamily', 'Rbsml_L15e_core_dom_sf', 5, NULL),
(23306, NULL, 'IPR027636', NULL, 'Glucan-binding repeat', 'Glucan-bd_rpt', 7, NULL),
(23307, NULL, 'IPR032000', NULL, 'Albumin I chain a', 'Albumin_I_a', 3, NULL),
(23308, NULL, 'IPR027907', NULL, 'BTB/POZ domain-containing protein 8, C-terminal', 'BTBD8_C', 3, NULL),
(23309, NULL, 'IPR026457', NULL, 'CSLREA domain', 'CSLREA_Nterm', 3, NULL),
(23310, NULL, 'IPR027564', NULL, 'Hopanoid C-3 methylase HpnR', 'HpnR_B12_rSAM', 4, NULL),
(23311, NULL, 'IPR026520', NULL, 'THAP domain-containing protein 3', 'THAP3', 4, NULL),
(23312, NULL, 'IPR027584', NULL, 'Entry exclusion lipoprotein TrbK', 'TrbK_RP4', 4, NULL),
(23313, NULL, 'IPR025285', NULL, 'Domain of unknown function DUF4145', 'DUF4145', 3, NULL),
(23314, NULL, 'IPR025804', NULL, 'Poxvirus/kinetoplastid-type cap-specific nucleoside 2-O-methyltransferase', 'Pox/kineto_cap_MeTfrase', 4, NULL),
(23315, NULL, 'IPR026445', NULL, 'Alkylhydroperoxidase/carboxymuconolactone decarboxylase family', 'AlkhydPrxdase/COmuclacdeCOase', 4, NULL),
(23316, NULL, 'IPR025915', NULL, 'Phage protein (N4 Gp49/phage Sf6 gene 66) family', 'Phage_gp49_66', 4, NULL),
(23317, NULL, 'IPR026496', NULL, 'Putative ATP-grasp target RiPP', 'GRASP_targ', 3, NULL),
(23318, NULL, 'IPR032422', NULL, 'Huntingtin-interacting protein 1, clathrin-binding domain', 'HIP1_clath-bd', 3, NULL),
(23319, NULL, 'IPR026526', NULL, 'Coiled-coil domain-containing protein 8', 'Coiled-coil_p8', 4, NULL),
(23320, NULL, 'IPR026652', NULL, 'Centrosomal protein of 128kDa', 'CEP128', 4, NULL),
(23321, NULL, 'IPR025564', NULL, 'Cyanobacterial aminoacyl-tRNA synthetase, CAAD domain', 'CAAD_dom', 3, NULL),
(23322, NULL, 'IPR035924', NULL, 'FlaG-like superfamily', 'FlaG-like_sf', 5, NULL),
(23323, NULL, 'IPR029400', NULL, 'TERF1-interacting nuclear factor 2, N-terminal domain', 'TINF2_N', 3, NULL),
(23324, NULL, 'IPR032302', NULL, 'THO complex subunit 2, N-terminal domain', 'THOC2_N', 3, NULL),
(23325, NULL, 'IPR026500', NULL, 'Dendrin', 'Dendrin', 4, NULL),
(23326, NULL, 'IPR025234', NULL, 'Protein of unknown function DUF4177', 'DUF4177', 4, NULL),
(23327, NULL, 'IPR024356', NULL, 'Protein of unknown function DUF3873', 'DUF3873', 4, NULL),
(23328, NULL, 'IPR028037', NULL, 'Antitoxin Rv0909/MT0933', 'Antitoxin_Rv0909/MT0933', 4, NULL),
(23329, NULL, 'IPR028089', NULL, 'Domain of unknown function DUF4455', 'DUF4455', 3, NULL),
(23330, NULL, 'IPR026031', NULL, 'Cytochrome c-type biogenesis protein CcmB, bacteria', 'Cyt_c_CcmB_bac', 4, NULL),
(23331, NULL, 'IPR026516', NULL, 'THAP domain-containing protein 1/10', 'THAP1/10', 4, NULL),
(23332, NULL, 'IPR025554', NULL, 'Domain of unknown function DUF4140', 'DUF4140', 3, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(23333, NULL, 'IPR026336', NULL, 'Metallophosphoesterase, DNA ligase-associated', 'P_estr_lig_assc', 4, NULL),
(23334, NULL, 'IPR032028', NULL, 'Cleavage stimulation factor subunit 1, dimerisation domain', 'CSTF1_dimer', 3, NULL),
(23335, NULL, 'IPR026999', NULL, 'Alpha-s1 casein', 'Alpha-s1_casein', 4, NULL),
(23336, NULL, 'IPR028002', NULL, 'Myb/SANT-like DNA-binding domain 5', 'Myb_DNA-bind_5', 3, NULL),
(23337, NULL, 'IPR027920', NULL, 'Domain of unknown function DUF4453', 'DUF4453', 3, NULL),
(23338, NULL, 'IPR029355', NULL, 'Proline-rich protein 19', 'Pro-rich_19', 4, NULL),
(23339, NULL, 'IPR027901', NULL, 'Protein of unknown function DUF4541', 'DUF4541', 4, NULL),
(23340, NULL, 'IPR025762', NULL, 'DFDF domain', 'DFDF', 3, NULL),
(23341, NULL, 'IPR032022', NULL, 'KRIT, N-terminal NPxY motif-rich region', 'NUDIX', 3, NULL),
(23342, NULL, 'IPR032037', NULL, 'Methylmalonic aciduria and homocystinuria type C family', 'MMACHC', 4, NULL),
(23343, NULL, 'IPR025777', NULL, 'GMP synthetase ATP pyrophosphatase domain', 'GMPS_ATP_PPase_dom', 3, NULL),
(23344, NULL, 'IPR029392', NULL, 'AP-5 complex subunit sigma-1', 'AP-5_subunit_s1', 4, NULL),
(23345, NULL, 'IPR025280', NULL, 'Domain of unknown function DUF4041', 'DUF4041', 3, NULL),
(23346, NULL, 'IPR029395', NULL, 'Protein of unknown function DUF4514', 'DUF4514', 4, NULL),
(23347, NULL, 'IPR031998', NULL, 'Protein of unknown function DUF5065', 'DUF5065', 4, NULL),
(23348, NULL, 'IPR024382', NULL, 'Domain of unknown function DUF3844', 'DUF3844', 3, NULL),
(23349, NULL, 'IPR032301', NULL, 'Protein of unknown function DUF4844', 'DUF4844', 4, NULL),
(23350, NULL, 'IPR025764', NULL, 'Fetuin-B-type cystatin domain', 'Cystatin_Fetuin_B', 3, NULL),
(23351, NULL, 'IPR026638', NULL, 'Nuclear receptor coactivator 6', 'NCOA6', 4, NULL),
(23352, NULL, 'IPR026449', NULL, 'ATP-grasp ribosomal peptide maturase, SAV-5884 family', 'GRASP_SAV_5884', 4, NULL),
(23353, NULL, 'IPR026459', NULL, 'Ribonucleotide reductase, class 1b, subunit NrdE', 'RNR_1b_NrdE', 4, NULL),
(23354, NULL, 'IPR032383', NULL, 'Protein of unknown function DUF4875', 'DUF4875', 4, NULL),
(23355, NULL, 'IPR026450', NULL, 'MAST domain', 'MAST_dom', 3, NULL),
(23356, NULL, 'IPR027592', NULL, 'ATP-grasp enzyme, GAK system', 'ATP-grasp_GAK', 4, NULL),
(23357, NULL, 'IPR026626', NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 3', 'NDUFA3', 4, NULL),
(23358, NULL, 'IPR025304', NULL, 'ALIX V-shaped domain', 'ALIX_V_dom', 3, NULL),
(23359, NULL, 'IPR025987', NULL, 'GW domain', 'GW_dom', 3, NULL),
(23360, NULL, 'IPR025608', NULL, 'TcpE family', 'TcpE', 4, NULL),
(23361, NULL, 'IPR026491', NULL, 'Exosortase D, VPLPA-CTERM-specific', 'ExosortD_VPLPA', 4, NULL),
(23362, NULL, 'IPR027588', NULL, 'XXXCH domain family', 'XXXCH_dom_fam', 4, NULL),
(23363, NULL, 'IPR034161', NULL, 'Pepsin-like domain, plant', 'Pepsin-like_plant', 3, NULL),
(23364, NULL, 'IPR026983', NULL, 'Dynein heavy chain', 'DHC_fam', 4, NULL),
(23365, NULL, 'IPR028005', NULL, 'N-acetyltransferase ESCO, zinc-finger', 'AcTrfase_ESCO_Znf_dom', 3, NULL),
(23366, NULL, 'IPR028995', NULL, 'Glycoside hydrolase families 57/38, central domain superfamily', 'Glyco_hydro_57/38_cen_sf', 5, NULL),
(23367, NULL, 'IPR025282', NULL, 'Domain of unknown function DUF4214', 'DUF4214', 3, NULL),
(23368, NULL, 'IPR026438', NULL, 'Geranylgeranylglyceryl phosphate synthase, archaea', 'GGGP_synthase_archaea', 4, NULL),
(23369, NULL, 'IPR026591', NULL, 'Sirtuin, catalytic core small domain superfamily', 'Sirtuin_cat_small_dom_sf', 5, NULL),
(23370, NULL, 'IPR025243', NULL, 'Domain of unknown function DUF4195', 'DUF4195', 3, NULL),
(23371, NULL, 'IPR027521', NULL, 'U6 snRNA phosphodiesterase 1', 'Usb1', 4, NULL),
(23372, NULL, 'IPR025806', NULL, 'Probable methyltransferase TARBP1', 'Prob_MeTrfase_TARBP1', 4, NULL),
(23373, NULL, 'IPR025609', NULL, 'Lsm14-like, N-terminal', 'Lsm14-like_N', 3, NULL),
(23374, NULL, 'IPR025565', NULL, 'Domain of unknown function DUF4328', 'DUF4328', 3, NULL),
(23375, NULL, 'IPR026365', NULL, 'Phage-associated protein, BcepMu gp16 family', 'BcepMu_gp16', 4, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(23376, NULL, 'IPR029497', NULL, 'Type 4 fimbrial biogenesis protein PilY2', 'Fimbrial_PilY2', 4, NULL),
(23377, NULL, 'IPR029483', NULL, 'Glycosyl-hydrolase 97, C-terminal oligomerisation domain', 'GH97_C', 3, NULL),
(23378, NULL, 'IPR026509', NULL, 'Transmembrane protein 183', 'TMEM183', 4, NULL),
(23379, NULL, 'IPR025257', NULL, 'Deubiquitinating enzyme MINDY-3/4, conserved domain', 'MINDY-3/4_CD', 3, NULL),
(23380, NULL, 'IPR032002', NULL, 'Immunity factor for SPN', 'IFS', 4, NULL),
(23381, NULL, 'IPR026353', NULL, 'Hypoxanthine-DNA glycosylase', 'Hypoxan-DNA_Glyclase', 4, NULL),
(23382, NULL, 'IPR025150', NULL, 'Glycoside hydrolase 123, C-terminal', 'GH123_C', 3, NULL),
(23383, NULL, 'IPR026483', NULL, 'CRISPR-associated protein Csx17, subtype Dpsyc', 'Cas_Csx17', 4, NULL),
(23384, NULL, 'IPR028264', NULL, 'Immunity protein 15', 'Imm15', 4, NULL),
(23385, NULL, 'IPR024393', NULL, 'Mechanosensitive ion channel MscS, porin domain', 'MscS_porin', 3, NULL),
(23386, NULL, 'IPR034085', NULL, 'TOG domain', 'TOG', 3, NULL),
(23387, NULL, 'IPR027599', NULL, 'PqqD family protein, HPr-rel-A system', 'PqqD-rel_X', 4, NULL),
(23388, NULL, 'IPR026495', NULL, 'PIP-CTERM protein sorting domain', 'PIP_CTERM', 3, NULL),
(23389, NULL, 'IPR026256', NULL, 'Transcriptional regulator, TfoX/Sxy-type', 'TfoX_Sxy', 4, NULL),
(23390, NULL, 'IPR029351', NULL, 'GAD domain', 'GAD_dom', 3, NULL),
(23391, NULL, 'IPR032005', NULL, 'Tyrosyl-tRNA synthetase, C-terminal', 'TyrRSs_C', 3, NULL),
(23392, NULL, 'IPR027031', NULL, 'Glycyl-tRNA synthetase/DNA polymerase subunit gamma-2', 'Gly-tRNA_synthase/POLG2', 4, NULL),
(23393, NULL, 'IPR025906', NULL, 'Putative motility protein', 'YjfB_motility', 4, NULL),
(23394, NULL, 'IPR025232', NULL, 'Domain of unknown function DUF4174', 'DUF4174', 3, NULL),
(23395, NULL, 'IPR025905', NULL, 'NVEALA protein', 'NVEALA', 4, NULL),
(23396, NULL, 'IPR031996', NULL, 'NVL2, nucleolin binding domain', 'NVL2_nucleolin-bd', 3, NULL),
(23397, NULL, 'IPR027617', NULL, 'CRISPR-associated endonuclease Cas1, PREFRAN subtype', 'Cas1_PREFRAN', 4, NULL),
(23398, NULL, 'IPR032034', NULL, 'Yop protein translocation protein D, periplasmic domain', 'YscD_ppl', 3, NULL),
(23399, NULL, 'IPR026519', NULL, 'THAP domain-containing protein 7', 'THAP7', 4, NULL),
(23400, NULL, 'IPR025835', NULL, 'Thiopurine S-methyltransferase', 'Thiopurine_S-MeTrfase', 4, NULL),
(23401, NULL, 'IPR025303', NULL, 'Deacetylase PdaC', 'PdaC', 3, NULL),
(23402, NULL, 'IPR028091', NULL, 'FAM91, N-terminal domain', 'FAM91_N_dom', 3, NULL),
(23403, NULL, 'IPR029018', NULL, 'Beta-hexosaminidase-like, domain 2', 'Hex-like_dom2', 5, NULL),
(23404, NULL, 'IPR025567', NULL, 'Domain of unknown function DUF4332', 'DUF4332', 3, NULL),
(23405, NULL, 'IPR027565', NULL, 'Cupin fold metalloprotein, WbuC family', 'Cupin_WbuC', 4, NULL),
(23406, NULL, 'IPR026511', NULL, 'Parathyroid hormone-responsive B1', 'PTHB1', 4, NULL),
(23407, NULL, 'IPR032030', NULL, 'YscD, cytoplasmic domain', 'YscD_cytoplasmic_dom', 3, NULL),
(23408, NULL, 'IPR026497', NULL, 'SPASM domain peptide maturase, GRASP-with-SPASM system', 'GRASP-with-SPASM', 4, NULL),
(23409, NULL, 'IPR025912', NULL, 'Regulatory protein YrvL', 'YrvL', 4, NULL),
(23410, NULL, 'IPR032635', NULL, 'Surface antigen domain', 'Anti_2', 3, NULL),
(23411, NULL, 'IPR026998', NULL, 'Calpastatin', 'Calpastatin', 4, NULL),
(23412, NULL, 'IPR026139', NULL, 'GOLM1/CASC4 family', 'GOLM1/CASC4', 4, NULL),
(23413, NULL, 'IPR025857', NULL, 'MacB-like periplasmic core domain', 'MacB_PCD', 3, NULL),
(23414, NULL, 'IPR025927', NULL, 'Potential DNA-binding domain', 'Potential_DNA-bd', 3, NULL),
(23415, NULL, 'IPR025928', NULL, 'Flocculin type 3 repeat', 'Flocculin_t3_rpt', 7, NULL),
(23416, NULL, 'IPR025917', NULL, 'Putative membrane protein YuiB', 'YuiB', 4, NULL),
(23417, NULL, 'IPR024355', NULL, 'Conjugative transposon protein TraQ, bacteroidetes', 'TraQ_bacteroidetes', 4, NULL),
(23418, NULL, 'IPR025242', NULL, 'Protein of unknown function DUF4193', 'DUF4193', 4, NULL),
(23419, NULL, 'IPR028076', NULL, 'Staphopain proregion', 'Staphopain_pro', 3, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(23420, NULL, 'IPR026788', NULL, 'Transmembrane protein 141', 'Tmem141', 4, NULL),
(23421, NULL, 'IPR025229', NULL, 'YniB-like protein', 'YniB-like', 4, NULL),
(23422, NULL, 'IPR032033', NULL, 'Cytochrome P460', 'Cytochrome_P460', 3, NULL),
(23423, NULL, 'IPR027906', NULL, 'Protein of unknown function DUF4567', 'DUF4567', 4, NULL),
(23424, NULL, 'IPR028020', NULL, 'ASX, DEUBAD domain', 'ASX_DEUBAD_dom', 3, NULL),
(23425, NULL, 'IPR029492', NULL, 'Domain of unknown function DUF4435', 'DUF4435', 3, NULL),
(23426, NULL, 'IPR026498', NULL, 'Grasp-with-spasm leader A domain', 'Grasp_w_spasm_A', 3, NULL),
(23427, NULL, 'IPR025230', NULL, 'Domain of unknown function DUF4172', 'DUF4172', 3, NULL),
(23428, NULL, 'IPR026515', NULL, 'ARL14 effector protein', 'ARL14EP', 4, NULL),
(23429, NULL, 'IPR026057', NULL, 'PC-Esterase', 'PC-Esterase', 4, NULL),
(23430, NULL, 'IPR027613', NULL, 'Surface carbohydrate biosynthesis protein, LIC13510 family', 'O_ant_LIC13510', 4, NULL),
(23431, NULL, 'IPR024531', NULL, 'Erythronate-4-phosphate dehydrogenase, dimerisation domain', 'Erythronate-4-P_DHase_dimer', 3, NULL),
(23432, NULL, 'IPR025908', NULL, 'Sensor N-terminal transmembrane domain', 'Sensor_TM1', 3, NULL),
(23433, NULL, 'IPR025239', NULL, 'Domain of unknown function DUF4187', 'DUF4187', 3, NULL),
(23434, NULL, 'IPR025913', NULL, 'Cep57 centrosome localisation domain', 'Cep57_CLD', 3, NULL),
(23435, NULL, 'IPR025803', NULL, 'Putrescine N-methyltransferase', 'Putrescine_N-MeTfrase', 4, NULL),
(23436, NULL, 'IPR028097', NULL, 'FAM91, C-terminal domain', 'FAM91_C_dom', 3, NULL),
(23437, NULL, 'IPR028309', NULL, 'Retinoblastoma protein family', 'RB_fam', 4, NULL),
(23438, NULL, 'IPR029461', NULL, 'Metallophosphoesterase, TT1561-like', 'TT1561-like', 3, NULL),
(23439, NULL, 'IPR029477', NULL, 'Diacylglycerol kinase type I, N-terminal', 'DAG_kinase_typeI_N', 3, NULL),
(23440, NULL, 'IPR028086', NULL, 'Folliculin-interacting protein, C-terminal domain', 'FNIP_C_dom', 3, NULL),
(23441, NULL, 'IPR028139', NULL, 'Humanin family', 'Humanin', 4, NULL),
(23442, NULL, 'IPR025884', NULL, 'Methyl-CpG binding protein 2/3, C-terminal domain', 'MeCpG-bd_2/3_C_dom', 3, NULL),
(23443, NULL, 'IPR032026', NULL, 'Adenylate cyclase regulatory domain', 'Ad_Cy_reg', 3, NULL),
(23444, NULL, 'IPR028747', NULL, 'Cation channel sperm-associated protein 2', 'CatSper2', 4, NULL),
(23445, NULL, 'IPR027523', NULL, 'CLU domain containing protein', 'CLU_prot', 4, NULL),
(23446, NULL, 'IPR026165', NULL, 'Cytoskeleton-associated protein 2 family', 'CKAP2_fam', 4, NULL),
(23447, NULL, 'IPR027509', NULL, 'Adenylosuccinate synthetase isozyme 1, chordates', 'AdSS_1_vert', 4, NULL),
(23448, NULL, 'IPR027919', NULL, 'Protein of unknown function DUF4568', 'DUF4568', 4, NULL),
(23449, NULL, 'IPR027566', NULL, 'Putrescine transporter PotE', 'Symport/antiport_PotE', 4, NULL),
(23450, NULL, 'IPR026360', NULL, 'Putative exonuclease, DNA ligase-associated', 'Xnuc_lig_assoc', 4, NULL),
(23451, NULL, 'IPR027519', NULL, 'Kynurenine formamidase, vertebrates/fungi-type', 'KFase_ver/fungi-typ', 4, NULL),
(23452, NULL, 'IPR028267', NULL, 'Rapamycin-insensitive companion of mTOR, N-terminal domain', 'Pianissimo_N', 3, NULL),
(23453, NULL, 'IPR025926', NULL, 'PDZ-like domain', 'PDZ-like_dom', 3, NULL),
(23454, NULL, 'IPR026510', NULL, 'Peroxisomal membrane protein 11C, metazoa', 'PEX11C_met', 4, NULL),
(23455, NULL, 'IPR027909', NULL, 'Protein of unknown function DUF4447', 'DUF4447', 4, NULL),
(23456, NULL, 'IPR026437', NULL, 'Putative peptide modification target', 'CxxCx5CxxC_targ', 4, NULL),
(23457, NULL, 'IPR028993', NULL, 'RecG, N-terminal antiparallel four helix bundle', 'RecG_N', 3, NULL),
(23458, NULL, 'IPR031997', NULL, 'Myoviridae tail sheath stabiliser', 'T4-gp15_tss', 4, NULL),
(23459, NULL, 'IPR025152', NULL, 'Domain of unknown function DUF4084', 'DUF4084', 3, NULL),
(23460, NULL, 'IPR025970', NULL, 'SusE outer membrane protein', 'SusE', 3, NULL),
(23461, NULL, 'IPR025795', NULL, 'tRNA (uracil-5-)-methyltransferase', 'tRNA_(uracil-5-)_MeTrfase', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(23462, NULL, 'IPR025914', NULL, 'Stage V sporulation protein AE', 'SpoVAE', 4, NULL),
(23463, NULL, 'IPR024580', NULL, 'Dishevelled C-terminal', 'Dishevelled_C-dom', 3, NULL),
(23464, NULL, 'IPR026453', NULL, 'PGF-pre-PGF domain', 'PGF_pre_PGF', 3, NULL),
(23465, NULL, 'IPR026458', NULL, 'Major cell surface glycoprotein', 'Major_cell_surface_glycoprot', 4, NULL),
(23466, NULL, 'IPR025233', NULL, 'Protein of unknown function DUF4176', 'DUF4176', 4, NULL),
(23467, NULL, 'IPR032424', NULL, 'Putative NADH-ubiquinone oxidoreductase chain E', 'NADH-UOR_E', 4, NULL),
(23468, NULL, 'IPR028268', NULL, 'Pianissimo family', 'Pianissimo_fam', 4, NULL),
(23469, NULL, 'IPR027574', NULL, 'Thiaminase II', 'Thiaminase_II', 4, NULL),
(23470, NULL, 'IPR026151', NULL, 'Maspardin', 'Maspardin', 4, NULL),
(23471, NULL, 'IPR032032', NULL, 'Type VI secretion system (T6SS), amidase immunity protein', 'Tai4', 4, NULL),
(23472, NULL, 'IPR029479', NULL, 'Nitroreductase', 'Nitroreductase', 3, NULL),
(23473, NULL, 'IPR025250', NULL, 'Protein of unknown function DUF4199', 'DUF4199', 4, NULL),
(23474, NULL, 'IPR025244', NULL, 'Coiled-coil domain-containing protein 82', 'CCDC82', 3, NULL),
(23475, NULL, 'IPR029459', NULL, 'Elongation factor Tu-type domain', 'EFTU-type', 3, NULL),
(23476, NULL, 'IPR027572', NULL, 'Putative folate metabolism protein, CADD family', 'Fol-rel_CADD', 4, NULL),
(23477, NULL, 'IPR034051', NULL, 'Tripeptidyl-peptidase II domain', 'TPP_II_domain', 3, NULL),
(23478, NULL, 'IPR032001', NULL, 'SAWADEE domain', 'SAWADEE_dom', 3, NULL),
(23479, NULL, 'IPR030125', NULL, 'SPIN90/Ldb17', 'SPIN90/Ldb17', 4, NULL),
(23480, NULL, 'IPR028265', NULL, 'TTDN1/Protein SICKLE', 'TTDN1/SICKLE', 4, NULL),
(23481, NULL, 'IPR025287', NULL, 'Wall-associated receptor kinase, galacturonan-binding domain', 'WAK_GUB', 3, NULL),
(23482, NULL, 'IPR026451', NULL, 'Class III signal peptide protein, archaeosortase D/PIP-CTERM system', 'ClassIII_w_PIP', 4, NULL),
(23483, NULL, 'IPR027576', NULL, 'Choice-of-anchor C domain', 'Choice_anch_C_dom', 3, NULL),
(23484, NULL, 'IPR027591', NULL, 'CofD-related protein, GAK system', 'CofD-rel_GAK', 4, NULL),
(23485, NULL, 'IPR029478', NULL, 'Putative nitroreductase TM1586', 'TM1586_NiRdase', 3, NULL),
(23486, NULL, 'IPR029474', NULL, 'Haem-oxygenase-associated, N-terminal helices', 'HOASN', 3, NULL),
(23487, NULL, 'IPR030817', NULL, '3,5/4-Trihydroxycyclohexa-1,2-dione hydrolase', 'Myo_inos_IolD', 4, NULL),
(23488, NULL, 'IPR027620', NULL, 'CRISPR-associated endonuclease Cas12a', 'Cas12a', 4, NULL),
(23489, NULL, 'IPR029486', NULL, 'Glycosyl-hydrolase 97, N-terminal domain', 'GH97_N', 3, NULL),
(23490, NULL, 'IPR026508', NULL, 'Transmembrane protein 164', 'TMEM164', 4, NULL),
(23491, NULL, 'IPR027917', NULL, 'Small integral membrane protein 20', 'SMIM20', 4, NULL),
(23492, NULL, 'IPR027623', NULL, 'AmmeMemoRadiSam system protein A', 'AmmeMemoSam_A', 4, NULL),
(23493, NULL, 'IPR026447', NULL, 'B12-binding domain/radical SAM domain protein, Ta0216 family', 'B12_SAM_Ta0216', 4, NULL),
(23494, NULL, 'IPR026646', NULL, 'G protein-regulated inducer of neurite outgrowth', 'GPRIN2-like/GPRIN3', 4, NULL),
(23495, NULL, 'IPR027598', NULL, 'Amphi-Trp domain', 'Amphi-Trp_dom', 3, NULL),
(23496, NULL, 'IPR026444', NULL, 'Secretion system C-terminal sorting domain', 'Secre_tail', 3, NULL),
(23497, NULL, 'IPR026595', NULL, 'Domain of unknown function, CHP04279', 'CHP04279', 3, NULL),
(23498, NULL, 'IPR025919', NULL, 'Stimulus-sensing domain', 'Stimulus_sens_dom', 3, NULL),
(23499, NULL, 'IPR026366', NULL, 'Putative selenium metabolism protein, YedE family', 'Seleno_YedE', 4, NULL),
(23500, NULL, 'IPR028998', NULL, 'Ribosome maturation factor RimP, C-terminal', 'RimP_C', 3, NULL),
(23501, NULL, 'IPR027958', NULL, 'Domain of unknown function DUF4657', 'DUF4657', 3, NULL),
(23502, NULL, 'IPR024581', NULL, 'Tbk1/Ikki binding domain', 'TBD', 3, NULL),
(23503, NULL, 'IPR029417', NULL, 'FAM227 Protein', 'FAM227', 4, NULL),
(23504, NULL, 'IPR032135', NULL, 'Helix-turn-helix domain (DUF4817)', 'DUF4817', 3, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(23505, NULL, 'IPR024778', NULL, 'Putative cellulase', 'Put_cellulase', 4, NULL),
(23506, NULL, 'IPR031572', NULL, 'Domain of unknown function DUF4705', 'DUF4705', 3, NULL),
(23507, NULL, 'IPR030858', NULL, 'Mid-cell-anchored protein Z', 'MapZ', 4, NULL),
(23508, NULL, 'IPR028153', NULL, 'Transmembrane protein C12orf23, UPF0444', 'UPF0444', 4, NULL),
(23509, NULL, 'IPR031648', NULL, 'Transmembrane protein 82', 'TMEM82', 4, NULL),
(23510, NULL, 'IPR027536', NULL, 'Mitochondrial distribution and morphology protein 34', 'Mdm34', 4, NULL),
(23511, NULL, 'IPR029512', NULL, 'Coiled-coil domain-containing protein 154', 'CCDC154', 4, NULL),
(23512, NULL, 'IPR024425', NULL, 'Cell wall-active antibiotics response 4TMS YvqF', 'DUF2154', 3, NULL),
(23513, NULL, 'IPR030856', NULL, 'Sensor histidine kinase RcsC', 'RcsC', 4, NULL),
(23514, NULL, 'IPR031650', NULL, 'Coiled-coil domain-containing protein 73', 'CCDC73', 4, NULL),
(23515, NULL, 'IPR032186', NULL, 'Domain of unknown function DUF5018', 'DUF5018', 3, NULL),
(23516, NULL, 'IPR031747', NULL, 'Transmembrane protein 232', 'TMEM232', 4, NULL),
(23517, NULL, 'IPR029034', NULL, 'Cystine-knot cytokine', 'Cystine-knot_cytokine', 5, NULL),
(23518, NULL, 'IPR032300', NULL, 'Cell surface antigen, C-terminal', 'Antigen_C', 3, NULL),
(23519, NULL, 'IPR024404', NULL, 'Lipid-binding, putative', 'Lipid-bd_put', 4, NULL),
(23520, NULL, 'IPR027020', NULL, 'Protein YnjB', 'YnjB', 4, NULL),
(23521, NULL, 'IPR029340', NULL, 'Protein FAM222', 'FAM222', 4, NULL),
(23522, NULL, 'IPR027628', NULL, 'Conjugal transfer/type IV secretion protein DotA/TraY', 'DotA_TraY', 4, NULL),
(23523, NULL, 'IPR028008', NULL, 'Protein of unknown function DUF4441', 'DUF4441', 4, NULL),
(23524, NULL, 'IPR025704', NULL, 'E3 ubiquitin ligase UBR4, C-terminal', 'E3_Ub_ligase_UBR4_C', 3, NULL),
(23525, NULL, 'IPR028564', NULL, 'tRNA methyltransferase TRM10-type domain', 'MT_TRM10-typ', 3, NULL),
(23526, NULL, 'IPR031597', NULL, 'KELK-motif containing domain', 'KELK', 3, NULL),
(23527, NULL, 'IPR032061', NULL, 'Domain of unknown function DUF4802', 'DUF4802', 3, NULL),
(23528, NULL, 'IPR032254', NULL, 'Protein of unknown function DUF4828', 'DUF4828', 4, NULL),
(23529, NULL, 'IPR034267', NULL, 'Ascorbate oxidase, third cupredoxin domain', 'CuRO_3_AAO', 3, NULL),
(23530, NULL, 'IPR030918', NULL, 'Polyketide product template domain', 'PT_fungal_PKS', 3, NULL),
(23531, NULL, 'IPR029118', NULL, 'Novel toxin 16', 'Ntox16', 3, NULL),
(23532, NULL, 'IPR024772', NULL, 'TcdA/TcdB toxin, N-terminal helical domain', 'TcdA/TcdB_N', 3, NULL),
(23533, NULL, 'IPR030642', NULL, 'Nephrocystin-1, SH3 domain', 'NPHP1_SH3', 3, NULL),
(23534, NULL, 'IPR027988', NULL, 'Transcription factor  BREVIS RADIX, N-terminal domain', 'BRX_N', 3, NULL),
(23535, NULL, 'IPR024915', NULL, '23S rRNA (guanosine-2-O-)-methyltransferase RlmB', '23S_rRNA_MeTrfase_RlmB', 4, NULL),
(23536, NULL, 'IPR027805', NULL, 'Transposase, Helix-turn-helix domain', 'Transposase_HTH_dom', 3, NULL),
(23537, NULL, 'IPR025532', NULL, 'Glucose-6-phosphate 1-epimerase', 'G6P_1-epimerase', 4, NULL),
(23538, NULL, 'IPR025559', NULL, 'Enhanced intracellular survival protein domain', 'Eis_dom', 3, NULL),
(23539, NULL, 'IPR029328', NULL, 'Spindle pole component Bbp1, N-terminal', 'Bbp1_N', 3, NULL),
(23540, NULL, 'IPR030224', NULL, 'Sla2 family', 'Sla2_fam', 4, NULL),
(23541, NULL, 'IPR030854', NULL, 'Ribonuclease J, bacteria', 'RNase_J_bac', 4, NULL),
(23542, NULL, 'IPR024787', NULL, 'EcsC protein', 'EcsC', 4, NULL),
(23543, NULL, 'IPR030830', NULL, '5-Dehydro-2-deoxygluconokinase', 'Myo_inos_IolC', 4, NULL),
(23544, NULL, 'IPR029037', NULL, 'DUF1407/YfgJ-like superfamily', 'DUF1407/YfgJ-like_sf', 5, NULL),
(23545, NULL, 'IPR031557', NULL, 'N-CoR, GPS2-interacting domain', 'N-CoR_GPS2_interact', 3, NULL),
(23546, NULL, 'IPR029112', NULL, 'Bacterial toxin 27', 'Ntox27', 3, NULL),
(23547, NULL, 'IPR029108', NULL, 'Bacterial toxin 37', 'Ntox37', 3, NULL),
(23548, NULL, 'IPR032106', NULL, '2-oxoglutarate dehydrogenase E1 component, N-terminal domain', '2-oxogl_dehyd_N', 3, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(23549, NULL, 'IPR028040', NULL, 'Type 2 DNA topoisomerase 6 subunit B-like', 'TopoVIB-like', 4, NULL),
(23550, NULL, 'IPR029416', NULL, 'Cilia- and flagella-associated protein 300', 'CFAP300', 4, NULL),
(23551, NULL, 'IPR032062', NULL, 'Protein of unknown function DUF4803', 'DUF4803', 4, NULL),
(23552, NULL, 'IPR029338', NULL, 'Tumour suppressing sub-chromosomal transferable candidate 4', 'TSSC4', 4, NULL),
(23553, NULL, 'IPR025192', NULL, 'Succinate dehydogenase/fumarate reductase N-terminal', 'Succ_DH/fum_Rdtase_N', 3, NULL),
(23554, NULL, 'IPR031444', NULL, 'PCNA-associated factor, histone-like domain', 'PCNA-AF_dom', 3, NULL),
(23555, NULL, 'IPR029450', NULL, 'Apoptosis regulator M11', 'Apo_reg_M11', 4, NULL),
(23556, NULL, 'IPR030870', NULL, 'Cell division protein ZapE', 'ZapE', 4, NULL),
(23557, NULL, 'IPR030819', NULL, 'Outer membrane exchange protein TraA, N-terminal domain', 'Myxo_TraA_N', 3, NULL),
(23558, NULL, 'IPR032194', NULL, 'CCR4-NOT transcription complex subunit 1, HEAT repeat', 'CNOT1_HEAT', 3, NULL),
(23559, NULL, 'IPR029106', NULL, 'Bacterial toxin 43', 'Ntox43', 3, NULL),
(23560, NULL, 'IPR024403', NULL, 'Dihydroorotase-like, bacterial', 'DHOase-like_bac', 4, NULL),
(23561, NULL, 'IPR032940', NULL, 'Calmodulin-regulated spectrin-associated protein', 'CAMSAP', 4, NULL),
(23562, NULL, 'IPR027008', NULL, 'Teashirt family', 'Teashirt_fam', 4, NULL),
(23563, NULL, 'IPR029110', NULL, 'Bacterial toxin 33', 'Ntox33', 3, NULL),
(23564, NULL, 'IPR032172', NULL, 'Fragile X-related protein 1, C-terminal region 1', 'FXR1_C1', 3, NULL),
(23565, NULL, 'IPR027527', NULL, 'Lipoyl synthase, mitochondrial', 'Lipoyl_synth_mt', 4, NULL),
(23566, NULL, 'IPR029332', NULL, 'PEHE domain', 'PEHE_dom', 3, NULL),
(23567, NULL, 'IPR029709', NULL, 'Lipid droplet assembly factor 1', 'LDAF1', 4, NULL),
(23568, NULL, 'IPR028168', NULL, 'KASH5-like coiled-coil domain', 'KASH5_coiled-coil', 3, NULL),
(23569, NULL, 'IPR027510', NULL, '6-hydroxymethyl-7,8-dihydropterin pyrophosphokinase, MptE', 'HMPDK_MptE', 4, NULL),
(23570, NULL, 'IPR032296', NULL, 'Cytoplasmic polyadenylation element-binding protein, ZZ domain', 'CEBP_ZZ', 3, NULL),
(23571, NULL, 'IPR030815', NULL, 'Selenouridine synthase, SelU C-terminal-like subunit', 'Arch_SelU_Cterm', 4, NULL),
(23572, NULL, 'IPR027867', NULL, 'Spermatogenesis-associated protein 48', 'SPATA48', 4, NULL),
(23573, NULL, 'IPR028159', NULL, 'RPA-interacting protein, C-terminal domain', 'RPA_interact_C_dom', 3, NULL),
(23574, NULL, 'IPR024370', NULL, 'PBP domain', 'PBP_domain', 3, NULL),
(23575, NULL, 'IPR025544', NULL, 'YhzD-like protein', 'YhzD', 4, NULL),
(23576, NULL, 'IPR029347', NULL, 'Raptor, N-terminal CASPase-like domain', 'Raptor_N', 3, NULL),
(23577, NULL, 'IPR031361', NULL, 'Spindle pole body component Kre28', 'Kre28', 4, NULL),
(23578, NULL, 'IPR029335', NULL, 'Phage-encoded virulence factor', 'PAGK', 4, NULL),
(23579, NULL, 'IPR025499', NULL, 'Pectin degradation protein KdgF', 'KdgF', 4, NULL),
(23580, NULL, 'IPR032292', NULL, 'Cytoplasmic polyadenylation element-binding protein 1, N-terminal', 'CEBP1_N', 3, NULL),
(23581, NULL, 'IPR032594', NULL, 'Protein of unknown function DUF4906', 'DUF4906', 4, NULL),
(23582, NULL, 'IPR029619', NULL, 'Protein FAM81', 'FAM81', 4, NULL),
(23583, NULL, 'IPR032191', NULL, 'CCR4-NOT transcription complex subunit 1, CAF1-binding domain', 'CNOT1_CAF1_bind', 3, NULL),
(23584, NULL, 'IPR026049', NULL, 'Uncharacterised protein C2orf42', 'C2orf42', 4, NULL),
(23585, NULL, 'IPR027452', NULL, 'Hypoxia-inducible factor 1-alpha inhibitor, domain II', 'FIH-1_dom_II', 5, NULL),
(23586, NULL, 'IPR025771', NULL, 'Phosphoethanolamine N-methyltransferase', 'Phosphoethanolamine_N-MeTrfase', 4, NULL),
(23587, NULL, 'IPR032589', NULL, 'Domain of unknown function DUF4910', 'DUF4910', 3, NULL),
(23588, NULL, 'IPR027468', NULL, 'Alpha-dystroglycan domain 2', 'Alpha-dystroglycan_domain_2', 5, NULL),
(23589, NULL, 'IPR031167', NULL, 'OBG-type guanine nucleotide-binding (G) domain', 'G_OBG', 3, NULL),
(23590, NULL, 'IPR029841', NULL, 'Cyclin-dependent kinase inhibitor 1', 'CDKN1A', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(23591, NULL, 'IPR027806', NULL, 'Harbinger transposase-derived nuclease domain', 'HARBI1_dom', 3, NULL),
(23592, NULL, 'IPR032259', NULL, 'Enoyl-CoA hydratase/isomerase,  HIBYL-CoA-H type', 'HIBYL-CoA-H', 4, NULL),
(23593, NULL, 'IPR029343', NULL, 'Coiled-coil domain-containing protein 14', 'CCDC14', 4, NULL),
(23594, NULL, 'IPR028022', NULL, 'Protein of unknown function DUF4600', 'DUF4600', 4, NULL),
(23595, NULL, 'IPR028164', NULL, 'TMEM61 protein family', 'TMEM61', 4, NULL),
(23596, NULL, 'IPR029124', NULL, 'RNA-directed RNA polymerase L, N-terminal', 'L_protein_N', 3, NULL),
(23597, NULL, 'IPR032193', NULL, 'CCR4-NOT transcription complex subunit 1, TTP binding domain', 'CNOT1_TTP_bind', 3, NULL),
(23598, NULL, 'IPR032178', NULL, 'Domain of unknown function DUF5010', 'DUF5010', 3, NULL),
(23599, NULL, 'IPR027995', NULL, 'Galactosyltransferase, N-terminal', 'Galactosyl_T_N', 3, NULL),
(23600, NULL, 'IPR029123', NULL, 'Splicing factor RBM39, linker', 'RBM39_linker', 3, NULL),
(23601, NULL, 'IPR030842', NULL, 'Transcription termination/antitermination protein NusA, bacterial', 'NusA_bac', 4, NULL),
(23602, NULL, 'IPR031900', NULL, 'Lactococcus phage single-stranded DNA binding protein', 'Phage_SSB', 4, NULL),
(23603, NULL, 'IPR029127', NULL, 'MvaI/BcnI restriction endonuclease', 'MvaI_BcnI', 3, NULL),
(23604, NULL, 'IPR031644', NULL, 'E3 ubiquitin-protein ligase makorin 1, C-terminal', 'MKRN1_C', 3, NULL),
(23605, NULL, 'IPR032857', NULL, 'Alpha-ketoglutarate-dependent dioxygenase alkB homologue 4', 'ALKBH4', 4, NULL),
(23606, NULL, 'IPR026512', NULL, 'RGS7BP/RGS9BP family', 'RGS7BP/RGS9BP', 4, NULL),
(23607, NULL, 'IPR024381', NULL, 'Protein of unknown function DUF2561', 'DUF2561', 4, NULL),
(23608, NULL, 'IPR029420', NULL, 'MDM2-binding protein, central domain', 'MTBP_central', 3, NULL),
(23609, NULL, 'IPR030824', NULL, 'Uncharacterised protein family CHP04562', 'CHP04562', 4, NULL),
(23610, NULL, 'IPR032173', NULL, 'Protein of unknown function DUF5007', 'DUF5007', 4, NULL),
(23611, NULL, 'IPR032063', NULL, 'Protein of unknown function DUF4804', 'DUF4804', 4, NULL),
(23612, NULL, 'IPR029145', NULL, 'Neuroblastoma-amplified sequence, N-terminal', 'NBAS_N', 3, NULL),
(23613, NULL, 'IPR032449', NULL, 'Keratin type II cytoskeletal 1, tail', 'Keratin_2_1_tail', 3, NULL),
(23614, NULL, 'IPR027889', NULL, 'Coiled-coil domain-containing glutamate-rich protein family 1', 'CCER1', 4, NULL),
(23615, NULL, 'IPR032187', NULL, 'Outer membrane protein SusF/SusE', 'SusF/SusE', 4, NULL),
(23616, NULL, 'IPR027546', NULL, 'Sirtuin, class III', 'Sirtuin_class_III', 4, NULL),
(23617, NULL, 'IPR031764', NULL, 'Domain of unknown function DUF4739', 'DUF4739', 3, NULL),
(23618, NULL, 'IPR032179', NULL, 'Pesticidal crystal protein Cry22Aa, Ig-like domain', 'Cry22Aa_Ig-like', 3, NULL),
(23619, NULL, 'IPR032854', NULL, 'Alkylated DNA repair protein alkB homologue 3', 'ALKBH3', 4, NULL),
(23620, NULL, 'IPR029625', NULL, 'Protein FAM169', 'FAM169', 4, NULL),
(23621, NULL, 'IPR029136', NULL, 'Nuclear protein MDM1', 'MDM1', 4, NULL),
(23622, NULL, 'IPR024783', NULL, 'Transducer of regulated CREB activity, N-terminal', 'TORC_N', 3, NULL),
(23623, NULL, 'IPR027992', NULL, 'Possible tRNA binding domain', 'tRNA_bind_dom', 3, NULL),
(23624, NULL, 'IPR028162', NULL, 'Siroheme biosynthesis protein Met8, C-terminal', 'Met8_C', 3, NULL),
(23625, NULL, 'IPR031398', NULL, 'SWI5-dependent HO expression protein 3', 'She3', 4, NULL),
(23626, NULL, 'IPR029775', NULL, 'Nephrocystin-4', 'NPHP4', 4, NULL),
(23627, NULL, 'IPR032190', NULL, 'Niemann-Pick C1, N-terminal', 'NPC1_N', 3, NULL),
(23628, NULL, 'IPR032192', NULL, 'GUN4, N-terminal ARM-like repeat domain', 'GUN4_N', 3, NULL),
(23629, NULL, 'IPR024416', NULL, 'Protein of unknown function DUF2738', 'DUF2738', 4, NULL),
(23630, NULL, 'IPR027548', NULL, 'Ribosomal protein S19e, archaeal', 'Ribosomal_S19e_archaeal', 4, NULL),
(23631, NULL, 'IPR029526', NULL, 'PiggyBac transposable element-derived protein', 'PGBD', 3, NULL),
(23632, NULL, 'IPR031403', NULL, 'Sbe2/Sbe22', 'Sbe2/Sbe22', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(23633, NULL, 'IPR031577', NULL, 'Doublesex- and mab-3-related transcription factor C1/C2, C-terminal', 'DMRT-C1/C2_C', 3, NULL),
(23634, NULL, 'IPR031896', NULL, 'INPP5B, PH domain', 'INPP5B_PH_dom', 3, NULL),
(23635, NULL, 'IPR027512', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 'EIF3A', 4, NULL),
(23636, NULL, 'IPR032591', NULL, 'Protein of unknown function DUF4908', 'DUF4908', 4, NULL),
(23637, NULL, 'IPR029336', NULL, 'Protein of unknown function DUF4594', 'DUF4594', 4, NULL),
(23638, NULL, 'IPR029337', NULL, 'Inhibitory synaptic factor 2', 'INSYN2', 4, NULL),
(23639, NULL, 'IPR029708', NULL, 'SERTA domain-containing protein 4', 'SERTAD4', 4, NULL),
(23640, NULL, 'IPR026645', NULL, 'Dermatopontin family', 'Dermatopontin_fam', 4, NULL),
(23641, NULL, 'IPR031316', NULL, 'Anti-sigma-28 factor FlgM, C-terminal', 'FlgM_C', 3, NULL),
(23642, NULL, 'IPR024623', NULL, 'Uncharacterised protein family YtxH', 'YtxH', 4, NULL),
(23643, NULL, 'IPR032894', NULL, 'dTDP-4-amino-4,6-dideoxygalactose transaminase WecE', 'WecE', 4, NULL),
(23644, NULL, 'IPR024426', NULL, 'Protein of unknown function DUF2694', 'DUF2694', 4, NULL),
(23645, NULL, 'IPR032454', NULL, 'Histone H2A, C-terminal domain', 'Histone_H2A_C', 3, NULL),
(23646, NULL, 'IPR029418', NULL, 'MDN2-binding protein, C-terminal domain', 'MTBP_C', 3, NULL),
(23647, NULL, 'IPR031413', NULL, 'Outer capsid protein VP7', 'Capsid_VP7', 4, NULL),
(23648, NULL, 'IPR028219', NULL, 'Spermatogenesis-associated protein 19, mitochondrial', 'SPATA19', 4, NULL),
(23649, NULL, 'IPR030876', NULL, '3-sulfolactaldehyde reductase', 'SLA_reductase', 4, NULL),
(23650, NULL, 'IPR031898', NULL, 'Lytic exoenzyme, target recognition domain', 'ZoocinA_TRD', 3, NULL),
(23651, NULL, 'IPR029341', NULL, 'FAM21/CAPZIP domain', 'FAM21/CAPZIP', 3, NULL),
(23652, NULL, 'IPR027417', NULL, 'P-loop containing nucleoside triphosphate hydrolase', 'P-loop_NTPase', 5, NULL),
(23653, NULL, 'IPR028589', NULL, 'AdoMet-dependent rRNA methyltransferase SPB1-like', 'SPB1-like', 4, NULL),
(23654, NULL, 'IPR031395', NULL, 'Protein Sop4', 'Sop4', 4, NULL),
(23655, NULL, 'IPR031396', NULL, 'Multidrug resistance efflux pump SepA', 'SepA', 4, NULL),
(23656, NULL, 'IPR028217', NULL, 'Ribosome-assembly protein 3, C-terminal', 'Rsa3_C', 3, NULL),
(23657, NULL, 'IPR024357', NULL, 'Argonaut, glycine-rich domain', 'Argonaut_Gly-rich', 3, NULL),
(23658, NULL, 'IPR025574', NULL, 'Nucleoporin FG repeat', 'Nucleoporin_FG_rpt', 7, NULL),
(23659, NULL, 'IPR032180', NULL, 'Domain of unknown function DUF5012', 'DUF5012', 3, NULL),
(23660, NULL, 'IPR026642', NULL, 'Glucocorticoid-induced transcript 1/FAM117', 'Glcci1/FAM117', 4, NULL),
(23661, NULL, 'IPR030872', NULL, 'Cardiolipin synthase B', 'Cardiolipin_synth_ClsB', 4, NULL),
(23662, NULL, 'IPR029109', NULL, 'Bacterial toxin 35', 'Ntox35', 3, NULL),
(23663, NULL, 'IPR032185', NULL, 'Domain of unknown function DUF5017', 'DUF5017', 3, NULL),
(23664, NULL, 'IPR029122', NULL, 'Novel toxin 10', 'Ntox10', 3, NULL),
(23665, NULL, 'IPR029146', NULL, 'CST complex subunit Ten1, animal and plant type', 'Ten1_animal_plant', 4, NULL),
(23666, NULL, 'IPR026649', NULL, 'Nuclear receptor-interacting protein 1', 'NRIP1', 4, NULL),
(23667, NULL, 'IPR029451', NULL, 'Rapamycin-insensitive companion of mTOR, middle domain', 'RICTOR_M', 3, NULL),
(23668, NULL, 'IPR028592', NULL, 'Queuine tRNA-ribosyltransferase accessory subunit QTRTD1', 'QTRTD1', 4, NULL),
(23669, NULL, 'IPR028158', NULL, 'RPA-interacting protein, N-terminal domain', 'RPA_interact_N_dom', 3, NULL),
(23670, NULL, 'IPR029331', NULL, 'Muscular LMNA-interacting protein', 'MLIP', 4, NULL),
(23671, NULL, 'IPR028032', NULL, 'Domain of unknown function DUF4503', 'DUF4503', 3, NULL),
(23672, NULL, 'IPR029348', NULL, 'Nucleotidyltransferase-like domain', 'NTF-like', 3, NULL),
(23673, NULL, 'IPR024945', NULL, 'Spt5 C-terminal domain', 'Spt5_C_dom', 3, NULL),
(23674, NULL, 'IPR032444', NULL, 'Keratin type II head', 'Keratin_2_head', 3, NULL),
(23675, NULL, 'IPR027535', NULL, 'Sulfate adenylyltransferase', 'Sulf_adenylyltr_euk', 4, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(23676, NULL, 'IPR031742', NULL, 'Protein of unknown function DUF4730', 'DUF4730', 4, NULL),
(23677, NULL, 'IPR030917', NULL, 'Cyanoexosortase B-associated protein', 'Cyanoexo_CrtB_assoc', 4, NULL),
(23678, NULL, 'IPR029038', NULL, 'Methionyl-tRNA synthetase, Zn-domain', 'MetRS_Zn', 5, NULL),
(23679, NULL, 'IPR032896', NULL, 'Lipid III flippase WzxE, Proteobacteria', 'WzxE_Proteobacteria', 4, NULL),
(23680, NULL, 'IPR025490', NULL, 'RNA-binding protein, HP1423 type', 'RNAbp_HP1423', 4, NULL),
(23681, NULL, 'IPR030482', NULL, 'p53 and DNA damage-regulated protein 1', 'PDRG1', 4, NULL),
(23682, NULL, 'IPR028033', NULL, 'Domain of unknown function DUF4462', 'DUF4462', 3, NULL),
(23683, NULL, 'IPR028934', NULL, 'Vacuolar protein sorting protein 26 related', 'Vps26-related', 4, NULL),
(23684, NULL, 'IPR027544', NULL, 'Shikimate kinase 2', 'Shikimate_kinase_2', 4, NULL),
(23685, NULL, 'IPR027877', NULL, 'Small integral membrane protein 15', 'Smim15', 4, NULL),
(23686, NULL, 'IPR032060', NULL, 'MGA, conserved domain', 'MGA_dom', 3, NULL),
(23687, NULL, 'IPR031899', NULL, 'Baseplate protein Gp15-like', 'Baseplate_Gp15-like', 4, NULL),
(23688, NULL, 'IPR030814', NULL, 'Small integral membrane protein', 'Mollicut_2TM', 4, NULL),
(23689, NULL, 'IPR031741', NULL, 'Serine-rich and transmembrane domain-containing protein', 'SERTM', 4, NULL),
(23690, NULL, 'IPR029334', NULL, 'Protein phosphatase 1 binding domain', 'PP1-bd', 3, NULL),
(23691, NULL, 'IPR029143', NULL, 'Protein of unknown function, YrpD', 'YrpD', 4, NULL),
(23692, NULL, 'IPR027632', NULL, 'Type 2 lantibiotic, SP_1948 family', 'Lant_SP_1948', 4, NULL),
(23693, NULL, 'IPR031415', NULL, 'Required for respiratory growth protein 8, mitochondrial', 'Rrg8', 4, NULL),
(23694, NULL, 'IPR024384', NULL, 'Protein of unknown function DUF2742', 'DUF2742', 4, NULL),
(23695, NULL, 'IPR024788', NULL, 'Malectin-like domain', 'Malectin-like_Carb-bd_dom', 3, NULL),
(23696, NULL, 'IPR032871', NULL, 'AHH domain-containing protein', 'AHH_dom_containing', 4, NULL),
(23697, NULL, 'IPR027791', NULL, 'Galactosyltransferase, C-terminal', 'Galactosyl_T_C', 3, NULL),
(23698, NULL, 'IPR028888', NULL, 'Molybdopterin synthase catalytic subunit, eukaryotes', 'MOCS2B_euk', 4, NULL),
(23699, NULL, 'IPR028850', NULL, 'Mucin-16', 'MUC16', 4, NULL),
(23700, NULL, 'IPR027891', NULL, 'Protein of unknown function DUF4645', 'DUF4645', 4, NULL),
(23701, NULL, 'IPR032182', NULL, 'Domain of unknown function DUF5014', 'DUF5014', 3, NULL),
(23702, NULL, 'IPR032183', NULL, 'PKD-like family', 'PKD-like', 4, NULL),
(23703, NULL, 'IPR027635', NULL, 'Type 2 lantibiotic, leader peptide domain', 'Lantibiotic2_lead_pep_dom', 3, NULL),
(23704, NULL, 'IPR029344', NULL, 'Histone RNA hairpin-binding protein, RNA-binding domain', 'SLBP_RNA_bind', 3, NULL),
(23705, NULL, 'IPR027273', NULL, 'Neocarzinostatin-like', 'Neocarzinostatin-like', 5, NULL),
(23706, NULL, 'IPR027802', NULL, 'Multi-ubiquitin domain', 'Multi-ubiquitin_dom', 3, NULL),
(23707, NULL, 'IPR028299', NULL, 'ClpA/B, conserved site 2', 'ClpA/B_CS2', 2, NULL),
(23708, NULL, 'IPR024781', NULL, 'Merozoite surface protein, C-terminal', 'MSP_C', 3, NULL),
(23709, NULL, 'IPR027994', NULL, 'WxL domain', 'WxL_dom', 3, NULL),
(23710, NULL, 'IPR028801', NULL, 'Two pore channel protein 1', 'TPC1_animal', 4, NULL),
(23711, NULL, 'IPR028156', NULL, 'RPA-interacting protein', 'RIP', 4, NULL),
(23712, NULL, 'IPR029330', NULL, 'Spindle pole body component Bbp1, C-terminal', 'Bbp1_C', 3, NULL),
(23713, NULL, 'IPR032189', NULL, 'DNA mismatch repair protein Mlh1, C-terminal', 'Mlh1_C', 3, NULL),
(23714, NULL, 'IPR031445', NULL, 'Protein of unknown function DUF4672', 'DUF4672', 4, NULL),
(23715, NULL, 'IPR028591', NULL, 'DIS3-like exonuclease 2', 'DIS3L2', 4, NULL),
(23716, NULL, 'IPR028013', NULL, 'Protein of unknown function DUF4437', 'DUF4437', 4, NULL),
(23717, NULL, 'IPR029130', NULL, 'Acid ceramidase, N-terminal', 'Acid_ceramidase_N', 3, NULL),
(23718, NULL, 'IPR031984', NULL, 'Solute carrier family 3 member 2, N-terminal domain', 'SLC3A2_N', 3, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(23719, NULL, 'IPR029525', NULL, 'INO80 complex, subunit Ies6', 'INO80C/Ies6', 4, NULL),
(23720, NULL, 'IPR029767', NULL, 'UDP-N-acetylglucosamine 2-epimerase WecB-like', 'WecB-like', 4, NULL),
(23721, NULL, 'IPR032870', NULL, 'Alpha-ketoglutarate-dependent dioxygenase alkB homologue 7', 'ALKBH7', 4, NULL),
(23722, NULL, 'IPR029423', NULL, 'LRRC37A/B like protein 1, C-terminal', 'LRRC37AB_C', 3, NULL),
(23723, NULL, 'IPR027885', NULL, 'Uncharacterised protein family UPF0728', 'UPF0728', 4, NULL),
(23724, NULL, 'IPR026583', NULL, 'Glucose 1-dehydrogenase, archaea', 'Glc_1-DH_arc', 4, NULL),
(23725, NULL, 'IPR029115', NULL, 'Bacterial toxin 23', 'Ntox23', 3, NULL),
(23726, NULL, 'IPR030459', NULL, 'Glycosyl hydrolases family 31, conserved site', 'Glyco_hydro_31_CS', 2, NULL),
(23727, NULL, 'IPR031979', NULL, 'Protein of unknown function DUF4785', 'DUF4785', 4, NULL),
(23728, NULL, 'IPR032291', NULL, 'Extracellular endo-alpha-(1->5)-L-arabinanase, C-terminal', 'Abn2_C', 3, NULL),
(23729, NULL, 'IPR029113', NULL, 'Bacterial toxin 25', 'Ntox25', 3, NULL),
(23730, NULL, 'IPR029117', NULL, 'Novel toxin 17', 'Ntox17', 3, NULL),
(23731, NULL, 'IPR027801', NULL, 'Centromere protein P', 'CENP-P', 4, NULL),
(23732, NULL, 'IPR029523', NULL, 'INO80 complex, subunit Ies2', 'INO80B/Ies2', 4, NULL),
(23733, NULL, 'IPR030183', NULL, 'S-type anion channel', 'SLAC/SLAH', 4, NULL),
(23734, NULL, 'IPR032256', NULL, 'Domain of unknown function DUF4829', 'DUF4829', 3, NULL),
(23735, NULL, 'IPR031566', NULL, 'Putative citrate transporter', 'CitMHS_2', 4, NULL),
(23736, NULL, 'IPR024415', NULL, 'Fungus-induced protein', 'Fungus-induced', 4, NULL),
(23737, NULL, 'IPR028894', NULL, 'Reductive dehalogenase domain', 'RDH_dom', 3, NULL),
(23738, NULL, 'IPR028160', NULL, 'Ribosome biogenesis protein Slx9-like', 'Slx9-like', 4, NULL),
(23739, NULL, 'IPR025759', NULL, 'tRNA guanosine-2''-O-methyltransferase, Trm3', 'Trm3', 4, NULL),
(23740, NULL, 'IPR032257', NULL, 'Domain of unknown function DUF4830', 'DUF4830', 3, NULL),
(23741, NULL, 'IPR030867', NULL, 'tRNA(Phe) (4-demethylwyosine(37)-C(7)) aminocarboxypropyltransferase', 'TYW2_archaea', 4, NULL),
(23742, NULL, 'IPR029452', NULL, 'Rapamycin-insensitive companion of mTOR, domain 5', 'RICTOR_V', 3, NULL),
(23743, NULL, 'IPR029134', NULL, 'Protein of unknown function DUF4647', 'DUF4647', 4, NULL),
(23744, NULL, 'IPR028011', NULL, 'Domain of unknown function DUF4476', 'DUF4476', 3, NULL),
(23745, NULL, 'IPR028221', NULL, 'Junctional cadherin 5-associated protein', 'JCAD', 4, NULL),
(23746, NULL, 'IPR031589', NULL, 'Protein FAM35A, C-terminal domain', 'FAM35A_C', 3, NULL),
(23747, NULL, 'IPR024363', NULL, 'Protein of unknown function DUF3853', 'DUF3853', 4, NULL),
(23748, NULL, 'IPR031559', NULL, 'Serine/threonine-protein kinase SMG1', 'SMG1', 4, NULL),
(23749, NULL, 'IPR028170', NULL, 'Protein KASH5', 'KASH5', 4, NULL),
(23750, NULL, 'IPR028163', NULL, 'HAUS augmin-like complex subunit 6, N-terminal', 'HAUS_6_N', 3, NULL),
(23751, NULL, 'IPR029670', NULL, 'UPF0524 family', 'UPF0524_fam', 4, NULL),
(23752, NULL, 'IPR027883', NULL, 'Protein of unknown function DUF4552', 'DUF4552', 4, NULL),
(23753, NULL, 'IPR029137', NULL, 'Putative RNase-like toxin, toxin1', 'Ntox1', 3, NULL),
(23754, NULL, 'IPR025945', NULL, 'DHHW protein', 'DHHW', 4, NULL),
(23755, NULL, 'IPR032443', NULL, 'RAWUL domain', 'RAWUL', 3, NULL),
(23756, NULL, 'IPR032175', NULL, 'Domain of unknown function DUF5008', 'DUF5008', 3, NULL),
(23757, NULL, 'IPR025657', NULL, 'RadC-like JAB domain', 'RadC_JAB', 3, NULL),
(23758, NULL, 'IPR029618', NULL, 'Coiled-coil domain-containing protein 172', 'CCDC172', 4, NULL),
(23759, NULL, 'IPR029421', NULL, 'MDM2-binding protein, N-terminal domain', 'MTBP_N', 3, NULL),
(23760, NULL, 'IPR030458', NULL, 'Glycosyl hydrolases family 31, active site', 'Glyco_hydro_31_AS', 0, NULL),
(23761, NULL, 'IPR028027', NULL, 'Protein of unknown function DUF4542', 'DUF4542', 4, NULL),
(23762, NULL, 'IPR024392', NULL, 'Protein of unknown function DUF2688', 'DUF2688', 4, NULL),
(23763, NULL, 'IPR028851', NULL, 'Periphilin-1', 'Pphln1', 4, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(23764, NULL, 'IPR027621', NULL, 'Putative 7-cyano-7-deazaguanosine (preQ0) biosynthesis protein QueE', 'rSAM_QueE_gams', 4, NULL),
(23765, NULL, 'IPR032174', NULL, 'Intron-binding protein aquarius, N-terminal', 'Aquarius_N', 3, NULL),
(23766, NULL, 'IPR029705', NULL, 'VPS35 endosomal protein sorting factor-like', 'VPS35L', 4, NULL),
(23767, NULL, 'IPR030659', NULL, 'SecY conserved site', 'SecY_CS', 2, NULL),
(23768, NULL, 'IPR032064', NULL, 'Protein of unknown function DUF4805', 'DUF4805', 4, NULL),
(23769, NULL, 'IPR030656', NULL, 'Delta-aminolevulinic acid dehydratase, active site', 'ALAD_AS', 0, NULL),
(23770, NULL, 'IPR027540', NULL, 'Ubiquinone biosynthesis protein Coq4, eukaryotic', 'Coq4_euk', 4, NULL),
(23771, NULL, 'IPR028166', NULL, 'Bifunctional transglycosylase second domain', 'UB2H', 3, NULL),
(23772, NULL, 'IPR024583', NULL, 'Voltage-gated Na+ ion channel, cytoplasmic domain', 'Na_trans_cytopl', 3, NULL),
(23773, NULL, 'IPR029125', NULL, 'TBP-interacting protein, N-terminal', 'TIP_N', 3, NULL),
(23774, NULL, 'IPR029129', NULL, 'Chromatin assembly factor 1 subunit B, C-terminal domain', 'CAF1_p60_C', 3, NULL),
(23775, NULL, 'IPR027886', NULL, 'Protein of unknown function DUF4555', 'DUF4555', 4, NULL),
(23776, NULL, 'IPR031401', NULL, 'She1', 'She1', 4, NULL),
(23777, NULL, 'IPR032895', NULL, 'ECA polysaccharide chain length modulation protein WzzE', 'WzzE', 4, NULL),
(23778, NULL, 'IPR029107', NULL, 'Bacterial toxin 3', 'Ntox3', 3, NULL),
(23779, NULL, 'IPR031643', NULL, 'Domain of unknown function DUF4708', 'DUF4708', 3, NULL),
(23780, NULL, 'IPR029141', NULL, 'Major fimbrial subunit protein, N-terminal', 'FimA_N', 3, NULL),
(23781, NULL, 'IPR029120', NULL, 'Novel toxin 14', 'Ntox14', 3, NULL),
(23782, NULL, 'IPR032892', NULL, 'UDP-N-acetylglucosamine 2-epimerase WecB', 'WecB', 4, NULL),
(23783, NULL, 'IPR028004', NULL, 'Protein of unknown function DUF4643', 'DUF4643', 4, NULL),
(23784, NULL, 'IPR025949', NULL, 'PapC-like, C-terminal domain', 'PapC-like_C', 3, NULL),
(23785, NULL, 'IPR028028', NULL, 'Protein of unknown function DUF4450', 'DUF4450', 4, NULL),
(23786, NULL, 'IPR030686', NULL, 'Cytochrome P450 8B1', 'Cytochrome_CYP8B1', 4, NULL),
(23787, NULL, 'IPR031446', NULL, 'Pericentriolar material 1 protein, C-terminal', 'PCM1_C', 3, NULL),
(23788, NULL, 'IPR027876', NULL, 'Domain of unknown function DUF4550', 'DUF4550', 3, NULL),
(23789, NULL, 'IPR028001', NULL, 'Protein of unknown function DUF4601', 'DUF4601', 4, NULL),
(23790, NULL, 'IPR029135', NULL, 'Protein phosphatase 1 regulatory subunit 35, C-terminal', 'PPP1R35_C', 3, NULL),
(23791, NULL, 'IPR028197', NULL, 'Syntaphilin/Syntabulin', 'Syntaphilin/Syntabulin', 4, NULL),
(23792, NULL, 'IPR028994', NULL, 'Integrin alpha, N-terminal', 'Integrin_alpha_N', 5, NULL),
(23793, NULL, 'IPR031409', NULL, 'Darcynin', 'Darcynin', 4, NULL),
(23794, NULL, 'IPR027961', NULL, 'Protein of unknown function DUF4442', 'DUF4442', 4, NULL),
(23795, NULL, 'IPR031565', NULL, 'T-superfamily conotoxin', 'T-conotoxin', 4, NULL),
(23796, NULL, 'IPR028218', NULL, 'JAB-like toxin 1', 'Toxin-JAB1', 4, NULL),
(23797, NULL, 'IPR028012', NULL, 'Transcription regulator Rua1, C-terminal', 'Rua1_C', 3, NULL),
(23798, NULL, 'IPR028222', NULL, 'AP-5 complex subunit zeta-1', 'AP5Z1', 4, NULL),
(23799, NULL, 'IPR028585', NULL, 'Adenylate kinase 4, mitochondrial', 'AK4_mitochondrial', 4, NULL),
(23800, NULL, 'IPR027619', NULL, 'Putative C-S lyase', 'C_S_lyase_PatB', 4, NULL),
(23801, NULL, 'IPR027952', NULL, 'Domain of unknown function DUF4632', 'DUF4632', 3, NULL),
(23802, NULL, 'IPR031891', NULL, 'DNA-mimic protein DMP12', 'DMP12', 4, NULL),
(23803, NULL, 'IPR032088', NULL, 'Starter unit:ACP transacylase', 'SAT', 3, NULL),
(23804, NULL, 'IPR031983', NULL, 'Protein of unknown function DUF4786', 'DUF4786', 4, NULL),
(23805, NULL, 'IPR026664', NULL, 'Stereocilin-related', 'Stereocilin-rel', 4, NULL),
(23806, NULL, 'IPR030383', NULL, 'Very large inducible GTPASE (VLIG)-type guanine nucleotide-binding (G) domain', 'G_VLIG_dom', 3, NULL),
(23807, NULL, 'IPR025658', NULL, 'Cyclophilin TM1367-like domain', 'Cyclophilin_TM1367', 3, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(23808, NULL, 'IPR034015', NULL, 'Aminopeptidase, leukotriene A4 hydrolase-like', 'M1_LTA4H', 4, NULL),
(23809, NULL, 'IPR031404', NULL, 'Regulator of rDNA transcription 14', 'Rrt14', 4, NULL),
(23810, NULL, 'IPR032595', NULL, 'Protein of unknown function DUF4905', 'DUF4905', 4, NULL),
(23811, NULL, 'IPR026022', NULL, 'PhoU domain', 'PhoU_dom', 3, NULL),
(23812, NULL, 'IPR032195', NULL, 'CCR4-NOT transcription complex subunit 1, HEAT repeat 1', 'CNOT1_HEAT_N', 3, NULL),
(23813, NULL, 'IPR031977', NULL, 'Protein of unknown function DUF4783', 'DUF4783', 4, NULL),
(23814, NULL, 'IPR025702', NULL, 'Aliphatic aldoxime/phenylacetaldoxime dehydratase', 'OXD', 4, NULL),
(23815, NULL, 'IPR031738', NULL, 'JMY/WHAMM, middle domain', 'JMY/WHAMM', 3, NULL),
(23816, NULL, 'IPR025561', NULL, 'Kinase suppressor of RAS, SAM-like domain', 'KSR_SAM-like_dom', 3, NULL),
(23817, NULL, 'IPR024386', NULL, 'Protein of unknown function DUF2532', 'DUF2532', 4, NULL),
(23818, NULL, 'IPR029138', NULL, 'snRNA-activating protein complex subunit 5', 'SNAPC5', 4, NULL),
(23819, NULL, 'IPR030375', NULL, 'Poxvirus cap-specific nucleoside 2-O-methyltransferase', 'Poxvir_cap_MeTfrase', 4, NULL),
(23820, NULL, 'IPR030829', NULL, 'Quinoprotein relay system zinc metallohydrolase 2', 'SoxH-rel_PQQ_2', 3, NULL),
(23821, NULL, 'IPR027537', NULL, 'Maintenance of mitochondrial morphology protein 1', 'Mmm1', 4, NULL),
(23822, NULL, 'IPR030818', NULL, 'Selenouridine synthase, SelU N-terminal-like subunit', 'Arch_SelU_Nterm', 4, NULL),
(23823, NULL, 'IPR031746', NULL, 'Protein of unknown function DUF4732', 'DUF4732', 4, NULL),
(23824, NULL, 'IPR028034', NULL, 'CCDC81, HU domain 1', 'HU-CCDC81', 3, NULL),
(23825, NULL, 'IPR028026', NULL, 'Domain of unknown function DUF4502', 'DUF4502', 3, NULL),
(23826, NULL, 'IPR028886', NULL, 'Molybdenum cofactor sulfurase', 'MoCo_sulfurase', 4, NULL),
(23827, NULL, 'IPR030825', NULL, 'Integral membrane protein', 'Integral_membrane', 4, NULL),
(23828, NULL, 'IPR030182', NULL, 'Purine permease, plant', 'PUP_plant', 4, NULL),
(23829, NULL, 'IPR032111', NULL, 'Clostridium phage holin', 'Clostridium_phage_holin', 4, NULL),
(23830, NULL, 'IPR029503', NULL, 'Phosphotransferase system EIIB component, mannitol-specific', 'PTS_EIIB_mannitol', 3, NULL),
(23831, NULL, 'IPR032902', NULL, 'Phenolic acid decarboxylase subunit C', 'BsdC', 4, NULL),
(23832, NULL, 'IPR031591', NULL, 'Coiled-coil domain-containing protein 106', 'CCDC106', 4, NULL),
(23833, NULL, 'IPR027007', NULL, 'C2 DOCK-type domain', 'C2_DOCK-type_domain', 3, NULL),
(23834, NULL, 'IPR024784', NULL, 'Transducer of regulated CREB activity, middle domain', 'TORC_M', 3, NULL),
(23835, NULL, 'IPR029111', NULL, 'Bacterial toxin 30', 'Ntox30', 3, NULL),
(23836, NULL, 'IPR031978', NULL, 'Protein of unknown function DUF4784', 'DUF4784', 4, NULL),
(23837, NULL, 'IPR029346', NULL, 'Ubiquitin carboxyl-terminal hydrolase, C-terminal', 'USP_C', 3, NULL),
(23838, NULL, 'IPR030634', NULL, 'Synemin', 'SYNM', 4, NULL),
(23839, NULL, 'IPR024359', NULL, 'Peroxisome assembly protein 22', 'Peroxin-22', 4, NULL),
(23840, NULL, 'IPR027803', NULL, 'Toxin/Nuclease, N-terminal', 'Toxin/Nuc_N', 3, NULL),
(23841, NULL, 'IPR028007', NULL, 'Domain of unknown function DUF4459', 'DUF4459', 3, NULL),
(23842, NULL, 'IPR027095', NULL, 'Golgin-45', 'Golgin-45', 4, NULL),
(23843, NULL, 'IPR027526', NULL, 'Lipoyl synthase, chloroplastic', 'Lipoyl_synth_chlpt', 4, NULL),
(23844, NULL, 'IPR031573', NULL, 'GPI-anchored cell wall protein repeat', 'Cell_wall_rpt', 7, NULL),
(23845, NULL, 'IPR024423', NULL, 'Protein of unknown function DUF3050', 'DUF3050', 4, NULL),
(23846, NULL, 'IPR028593', NULL, 'Protein Spindly, chordates', 'SPDLY_chordates', 4, NULL),
(23847, NULL, 'IPR024770', NULL, 'TcdA/TcdB toxin, catalytic glycosyltransferase domain', 'TcdA/TcdB_cat', 3, NULL),
(23848, NULL, 'IPR030922', NULL, 'LPS export ABC transporter permease LptF', 'LptF', 4, NULL),
(23849, NULL, 'IPR031724', NULL, 'Extended EGL-27 and MTA1 homology domain', 'EELM2', 3, NULL),
(23850, NULL, 'IPR030935', NULL, 'Phage portal protein PBSX family, Proteobacteria', 'PBSX_Proteobac', 4, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(23851, NULL, 'IPR030874', NULL, 'Cardiolipin synthase, Firmicutes-type', 'Cardiolipin_synth_Firmi', 4, NULL),
(23852, NULL, 'IPR031564', NULL, 'Putative Flagellin, Flp1-like domain', 'Flp1-like', 3, NULL),
(23853, NULL, 'IPR032893', NULL, 'Galactarate dehydratase (L-threo-forming) GarD, Enterobacteriaceae', 'GarD_Enterobacteriaceae', 4, NULL),
(23854, NULL, 'IPR031165', NULL, 'Yjdj-type Gcn5-related N-acetyltransferase', 'GNAT_YJDJ', 3, NULL),
(23855, NULL, 'IPR024786', NULL, 'CREB-regulated transcription coactivator', 'TORC', 4, NULL),
(23856, NULL, 'IPR029126', NULL, 'Restriction endonuclease BpuSI, N-terminal domain', 'BpuSI_N', 3, NULL),
(23857, NULL, 'IPR030821', NULL, 'Synergist-CTERM protein sorting domain', 'Synergist_CTERM', 3, NULL),
(23858, NULL, 'IPR028165', NULL, 'TMEM125 protein family', 'TMEM125', 4, NULL),
(23859, NULL, 'IPR027627', NULL, 'Putative glycosyltransferase', 'Glycosyltransferase_put', 4, NULL),
(23860, NULL, 'IPR029627', NULL, 'Serine-rich coiled-coil domain-containing protein', 'CCSER', 4, NULL),
(23861, NULL, 'IPR029133', NULL, 'Overexpressed in colon carcinoma 1', 'OCC1', 4, NULL),
(23862, NULL, 'IPR029453', NULL, 'Rapamycin-insensitive companion of mTOR, domain 4', 'Rictor_IV', 3, NULL),
(23863, NULL, 'IPR030836', NULL, 'Putative ABC transporter periplasmic binding protein PhnD-like', 'ABC_peri_PhnD-like', 4, NULL),
(23864, NULL, 'IPR031127', NULL, 'E3 ubiquitin ligase RBR family', 'E3_UB_ligase_RBR', 4, NULL),
(23865, NULL, 'IPR031299', NULL, 'ADP-dependent glucose/glucosamine kinase, archaeal', 'GlkA', 4, NULL),
(23866, NULL, 'IPR030676', NULL, 'Citrate carrier CitT-related', 'CitT-rel', 4, NULL),
(23867, NULL, 'IPR025546', NULL, 'YqzH-like protein', 'YqzH', 4, NULL),
(23868, NULL, 'IPR031575', NULL, 'E1A-binding protein p400, N-terminal', 'EP400_N', 3, NULL),
(23869, NULL, 'IPR028024', NULL, 'Transmembrane protein 251', 'TMEM251', 4, NULL),
(23870, NULL, 'IPR028586', NULL, 'Adenylate kinase 3/4, mitochondrial', 'AK3/Ak4_mitochondrial', 4, NULL),
(23871, NULL, 'IPR027516', NULL, 'Eukaryotic translation initiation factor 3 subunit C', 'EIF3C', 4, NULL),
(23872, NULL, 'IPR028018', NULL, 'Protein of unknown function DUF4646', 'DUF4646', 4, NULL),
(23873, NULL, 'IPR027878', NULL, 'Protein of unknown function DUF4551', 'DUF4551', 4, NULL),
(23874, NULL, 'IPR030857', NULL, 'Lipid A biosynthesis palmitoleoyltransferase, LpxP', 'Lipid_A_LpxP', 4, NULL),
(23875, NULL, 'IPR031767', NULL, 'Inhibitor of glucose uptake transporter SgrT', 'SgrT', 4, NULL),
(23876, NULL, 'IPR031587', NULL, 'Lung adenoma susceptibility protein 2', 'LAS2', 4, NULL),
(23877, NULL, 'IPR031744', NULL, 'Small integral membrane protein 1', 'SMIM1', 4, NULL),
(23878, NULL, 'IPR032588', NULL, 'Putative GDSL-like Lipase/Acylhydrolase', 'Lipase_GDSL_lke', 4, NULL),
(23879, NULL, 'IPR032593', NULL, 'Protein of unknown function DUF4907', 'DUF4907', 4, NULL),
(23880, NULL, 'IPR024775', NULL, 'DinB-like domain', 'DinB-like', 3, NULL),
(23881, NULL, 'IPR025939', NULL, 'Axin interactor dorsalization-associated protein, C-terminal', 'Aida_C', 3, NULL),
(23882, NULL, 'IPR028887', NULL, 'Molybdopterin synthase sulfur carrier subunit, eukaryote', 'MOCS2A_euk', 4, NULL),
(23883, NULL, 'IPR030381', NULL, 'Dynamin-type guanine nucleotide-binding (G) domain', 'G_DYNAMIN_dom', 3, NULL),
(23884, NULL, 'IPR032263', NULL, 'ATP-citrate synthase, citrate-binding domain', 'Citrate-bd', 3, NULL),
(23885, NULL, 'IPR028155', NULL, 'RPA-interacting protein, central domain', 'RPA_interact_central', 3, NULL),
(23886, NULL, 'IPR030834', NULL, 'Polyketide synthase-associated domain', 'PKS_assoc_dom', 3, NULL),
(23887, NULL, 'IPR030185', NULL, 'Malic acid transport protein', 'Mae1', 4, NULL),
(23888, NULL, 'IPR030225', NULL, 'Sterol regulatory element-binding protein cleavage-activating protein', 'SCAP', 4, NULL),
(23889, NULL, 'IPR028031', NULL, 'Domain of unknown function DUF4460', 'DUF4460', 3, NULL),
(23890, NULL, 'IPR027939', NULL, 'NMT1/THI5 family', 'NMT1/THI5', 4, NULL),
(23891, NULL, 'IPR024578', NULL, 'Homez, homeobox domain', 'Homez_homeobox_dom', 3, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(23892, NULL, 'IPR030700', NULL, 'N-end rule aminoacyl transferase', 'N-end_Aminoacyl_Trfase', 4, NULL),
(23893, NULL, 'IPR029140', NULL, 'Fimbrial subunit protein, C-terminal', 'FimA_C', 3, NULL),
(23894, NULL, 'IPR031981', NULL, 'Mitochondria-eating protein, C-terminal domain', 'MIEAP_C', 3, NULL),
(23895, NULL, 'IPR027529', NULL, 'Adenylosuccinate synthetase isozyme 2, chordates', 'AdSS_2_vert', 4, NULL),
(23896, NULL, 'IPR032590', NULL, 'Protein of unknown function DUF4909', 'DUF4909', 4, NULL),
(23897, NULL, 'IPR032515', NULL, 'Domain of unknown function DUF4964', 'DUF4964', 3, NULL),
(23898, NULL, 'IPR032524', NULL, 'ABC transporter Uup, C-terminal', 'ABC_tran_C', 3, NULL),
(23899, NULL, 'IPR032176', NULL, 'Domain of unknown function DUF5009', 'DUF5009', 3, NULL),
(23900, NULL, 'IPR032592', NULL, 'Non-structural protein NSP3, nucleic acid-binding domain, betacoronavirus', 'NSP3_NAB_bCoV', 3, NULL),
(23901, NULL, 'IPR027093', NULL, 'EAF family', 'EAF_fam', 4, NULL),
(23902, NULL, 'IPR028030', NULL, 'Domain of unknown function DUF4592', 'DUF4592', 3, NULL),
(23903, NULL, 'IPR031761', NULL, 'Folded gastrulation, N-terminal domain', 'FOG_N', 3, NULL),
(23904, NULL, 'IPR030832', NULL, 'Processed acidic surface protein', 'Acidic_LPXTA', 4, NULL),
(23905, NULL, 'IPR031762', NULL, 'Protein of unknown function DUF4738', 'DUF4738', 4, NULL),
(23906, NULL, 'IPR024417', NULL, 'Neuronal protein 3.1', 'Neuronal_3.1', 4, NULL),
(23907, NULL, 'IPR026326', NULL, 'Probable tRNA pseudouridine synthase B, archaeal', 'TruB_arch', 4, NULL),
(23908, NULL, 'IPR027018', NULL, 'Hemolysin E', 'Hemolysin_E', 4, NULL),
(23909, NULL, 'IPR028587', NULL, 'Adenylate kinase 2', 'AK2', 4, NULL),
(23910, NULL, 'IPR030685', NULL, 'Serotransferrin, mammalian', 'Serotransferrin_mammal', 4, NULL),
(23911, NULL, 'IPR029121', NULL, 'Novel toxin 11', 'Ntox11', 3, NULL),
(23912, NULL, 'IPR031552', NULL, 'Type II bacterial toxin-antitoxin system, ParE-like toxin', 'ParE-like_toxin', 4, NULL),
(23913, NULL, 'IPR027193', NULL, 'Nucleolar complex protein 4', 'Noc4', 4, NULL),
(23914, NULL, 'IPR029412', NULL, 'Centrosomal protein of 19kDa', 'CEP19', 4, NULL),
(23915, NULL, 'IPR024361', NULL, 'Bacteroidetes-Associated Carbohydrate-binding Often N-terminal', 'BACON', 3, NULL),
(23916, NULL, 'IPR027539', NULL, 'Mitochondrial distribution and morphology protein 10', 'Mdm10', 4, NULL),
(23917, NULL, 'IPR029422', NULL, 'Coiled coil protein 74, C-terminal', 'CCDC74_C', 3, NULL),
(23918, NULL, 'IPR029128', NULL, 'Restriction endonuclease ThaI', 'ThaI', 4, NULL),
(23919, NULL, 'IPR031570', NULL, 'Neurobeachin/BDCP, DUF4704', 'NBEA/BDCP_DUF4704', 3, NULL),
(23920, NULL, 'IPR031412', NULL, 'Torovirinae spike protein', 'S_torovirinae', 4, NULL),
(23921, NULL, 'IPR035947', NULL, 'MG354-like superfamily', 'MG354-like_sf', 5, NULL),
(23922, NULL, 'IPR030871', NULL, 'Cardiolipin synthase C', 'Cardiolipin_synth_ClsC', 4, NULL),
(23923, NULL, 'IPR031895', NULL, 'RHH transcriptional regulator CopG', 'RHH_CopG', 4, NULL),
(23924, NULL, 'IPR028325', NULL, 'Voltage-gated potassium channel', 'VG_K_chnl', 4, NULL),
(23925, NULL, 'IPR025770', NULL, 'Protein-S-isoprenylcysteine O-methyltransferase', 'PPMT_MeTrfase', 4, NULL),
(23926, NULL, 'IPR029132', NULL, 'Choloylglycine hydrolase/NAAA C-terminal', 'CBAH/NAAA_C', 3, NULL),
(23927, NULL, 'IPR032090', NULL, 'Peptide chain release factor 3, C-terminal', 'RF3_C', 3, NULL),
(23928, NULL, 'IPR030470', NULL, 'UbiA prenyltransferase conserved site', 'UbiA_prenylTrfase_CS', 2, NULL),
(23929, NULL, 'IPR025547', NULL, 'YtzH-like protein', 'YtzH', 4, NULL),
(23930, NULL, 'IPR024774', NULL, 'Pleckstrin homology domain, Mcp5-type', 'PH_dom-Mcp5-type', 3, NULL),
(23931, NULL, 'IPR027454', NULL, 'Histone-like protein H-NS, N-terminal', 'Histone_HNS_N', 5, NULL),
(23932, NULL, 'IPR028006', NULL, 'Protein of unknown function DUF4570', 'DUF4570', 4, NULL),
(23933, NULL, 'IPR028036', NULL, 'Domain of unknown function DUF4536', 'DUF4536', 3, NULL),
(23934, NULL, 'IPR029032', NULL, 'AhpD-like', 'AhpD-like', 5, NULL),
(23935, NULL, 'IPR025659', NULL, 'Tubby-like, C-terminal', 'Tubby-like_C', 5, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(23936, NULL, 'IPR029116', NULL, 'Bacterial toxin 22', 'Ntox22', 3, NULL),
(23937, NULL, 'IPR027756', NULL, 'Ovo-like', 'Ovo-like', 4, NULL),
(23938, NULL, 'IPR030826', NULL, '30S ribosomal protein', 'Ribo_THX', 4, NULL),
(23939, NULL, 'IPR032872', NULL, 'Wall-associated receptor kinase, C-terminal', 'WAK_assoc_C', 3, NULL),
(23940, NULL, 'IPR028188', NULL, 'Type IV pilin PilA', 'Pilin_PilA', 4, NULL),
(23941, NULL, 'IPR024785', NULL, 'Transducer of regulated CREB activity, C-terminal', 'TORC_C', 3, NULL),
(23942, NULL, 'IPR031893', NULL, 'Phage tail assembly chaperone protein', 'Phage_tail_APC', 4, NULL),
(23943, NULL, 'IPR029349', NULL, 'Domain of unknown function DUF4443', 'DUF4443', 3, NULL),
(23944, NULL, 'IPR027955', NULL, 'Protein of unknown function DUF4636', 'DUF4636', 4, NULL),
(23945, NULL, 'IPR031166', NULL, 'EngA-type guanine nucleotide-binding (G) domain', 'G_ENGA', 3, NULL),
(23946, NULL, 'IPR028167', NULL, 'BLOC-2 complex member HPS3, central region', 'HPS3_central_dom', 3, NULL),
(23947, NULL, 'IPR031554', NULL, 'Fibrous sheath-interacting protein 2, C-terminal', 'FSIP2_C', 3, NULL),
(23948, NULL, 'IPR031568', NULL, 'Protein Pet117, mitochondrial', 'Pet117', 4, NULL),
(23949, NULL, 'IPR028594', NULL, 'Katanin p60 subunit A-like 1, chordates', 'Katnal1_chordates', 4, NULL),
(23950, NULL, 'IPR032184', NULL, 'Protein of unknown function DUF5016', 'DUF5016', 4, NULL),
(23951, NULL, 'IPR030916', NULL, 'ELWxxDGT repeat', 'ELWxxDGT_rpt', 7, NULL),
(23952, NULL, 'IPR027508', NULL, '7,8-dihydroneopterin aldolase, MptD', 'DHN_aldolase_MptD', 4, NULL),
(23953, NULL, 'IPR027870', NULL, 'Protein of unknown function DUF4543', 'DUF4543', 4, NULL),
(23954, NULL, 'IPR031563', NULL, 'Molybdate transporter 1/2', 'MOT1/MOT2', 4, NULL),
(23955, NULL, 'IPR027875', NULL, 'Protein of unknown function DUF4547', 'DUF4547', 4, NULL),
(23956, NULL, 'IPR025545', NULL, 'YozD-like protein', 'YozD', 4, NULL),
(23957, NULL, 'IPR024396', NULL, 'Conjugal transfer protein TrbD, putative', 'Conjug_TrbD_put', 4, NULL),
(23958, NULL, 'IPR024961', NULL, 'Type II secretion system protein GspC, N-terminal', 'T2SS_GspC_N', 3, NULL),
(23959, NULL, 'IPR025948', NULL, 'HTH-like domain', 'HTH-like_dom', 3, NULL),
(23960, NULL, 'IPR028003', NULL, 'Keratinocyte differentiation factor 1', 'KDF1', 4, NULL),
(23961, NULL, 'IPR024960', NULL, 'Phosphatidyl-N-methylethanolamine/Phosphatidylethanolamine N-methyltransferase', 'PEMT/MFAP', 4, NULL),
(23962, NULL, 'IPR025541', NULL, 'Propanediol/glycerol dehydratase, medium subunit', 'Ppandiol/glycerol_DHydtase_msu', 4, NULL),
(23963, NULL, 'IPR032181', NULL, 'Domain of unknown function DUF5013', 'DUF5013', 3, NULL),
(23964, NULL, 'IPR024624', NULL, 'Pyridoxamine 5''-phosphate oxidase, Alr4036 family, FMN-binding domain', 'Pyridox_Oxase_Alr4036_FMN-bd', 3, NULL),
(23965, NULL, 'IPR031411', NULL, 'Two-component-system connector protein SafA', 'SafA', 4, NULL),
(23966, NULL, 'IPR029672', NULL, 'FAM199X family', 'FAM199X_fam', 4, NULL),
(23967, NULL, 'IPR032171', NULL, 'C-terminal of Roc (COR) domain', 'COR', 3, NULL),
(23968, NULL, 'IPR024958', NULL, 'GRASP-type PDZ domain', 'GRASP_PDZ', 3, NULL),
(23969, NULL, 'IPR027725', NULL, 'Heat shock transcription factor family', 'HSF_fam', 4, NULL),
(23970, NULL, 'IPR026325', NULL, 'Protein of unknown function DUF932', 'DUF932', 4, NULL),
(23971, NULL, 'IPR030820', NULL, 'Outer membrane beta-barrel protein, Proteobacteria', 'OMP_myx_plus_Proteobacteria', 3, NULL),
(23972, NULL, 'IPR032610', NULL, 'Domain of unknown function DUF2172', 'DUF2172', 3, NULL),
(23973, NULL, 'IPR028996', NULL, 'Ganglioside GM2 activator', 'GM2-AP', 4, NULL),
(23974, NULL, 'IPR026643', NULL, 'CAMPATH-1 antigen  (CD52)', 'CAMPATH-1', 4, NULL),
(23975, NULL, 'IPR029339', NULL, 'Protein FAM219', 'FAM219', 4, NULL),
(23976, NULL, 'IPR031726', NULL, 'Protein glycosylation ligase domain', 'PglL_A', 3, NULL),
(23977, NULL, 'IPR026051', NULL, 'Chitobiosyldiphosphodolichol beta-mannosyltransferase ALG1-like', 'ALG1-like', 4, NULL),
(23978, NULL, 'IPR032134', NULL, 'Protein of unknown function DUF4816', 'DUF4816', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(23979, NULL, 'IPR027865', NULL, 'Domain of unknown function DUF4520', 'DUF4520', 3, NULL),
(23980, NULL, 'IPR028154', NULL, 'AMP-dependent ligase, C-terminal', 'AMP-dep_Lig_C', 3, NULL),
(23981, NULL, 'IPR032901', NULL, 'Probable UbiX-like flavin prenyltransferase', 'UbiX_pad_YclB', 4, NULL),
(23982, NULL, 'IPR032298', NULL, 'EutK-Ctail domain', 'EutK_C', 3, NULL),
(23983, NULL, 'IPR029774', NULL, 'Centriole, cilia and spindle-associated protein', 'CSAP', 4, NULL),
(23984, NULL, 'IPR030822', NULL, 'MXAN_4361/MXAN_4362 family small protein', 'MXAN_4361/MXAN_4362', 4, NULL),
(23985, NULL, 'IPR031414', NULL, '30S ribosomal protein Thx', 'Thx', 4, NULL),
(23986, NULL, 'IPR030831', NULL, 'Quinoprotein dehydrogenase-associated SoxYZ-like carrier', 'Fuse-rel_SoxYZ', 4, NULL),
(23987, NULL, 'IPR031748', NULL, 'Protein of unknown function DUF4733', 'DUF4733', 4, NULL),
(23988, NULL, 'IPR032891', NULL, 'UDP-N-acetyl-D-mannosamine dehydrogenase WecC', 'WecC', 4, NULL),
(23989, NULL, 'IPR025946', NULL, 'CABIT domain', 'CABIT_dom', 3, NULL),
(23990, NULL, 'IPR028161', NULL, 'Siroheme biosynthesis protein Met8', 'Met8', 4, NULL),
(23991, NULL, 'IPR028590', NULL, 'tRNA (cytidine(32)/guanosine(34)-2-O)-methyltransferase TRM7', 'RNA_methyltr_E_TRM7', 4, NULL),
(23992, NULL, 'IPR031397', NULL, 'Male-specific protein scotti', 'Soti', 4, NULL),
(23993, NULL, 'IPR030184', NULL, 'WAT1-related protein', 'WAT1-related', 4, NULL),
(23994, NULL, 'IPR028582', NULL, 'Adenylate kinase isoenzyme 1', 'AK1', 4, NULL),
(23995, NULL, 'IPR027874', NULL, 'Testis-expressed sequence 35 protein', 'Tex35', 4, NULL),
(23996, NULL, 'IPR028000', NULL, 'Pma1 stabilization in the Golgi protein 1', 'Pma1', 4, NULL),
(23997, NULL, 'IPR025763', NULL, 'tRNA (guanine-N-7) methyltransferase catalytic subunit Trm8, eukaryote', 'Trm8_euk', 4, NULL),
(23998, NULL, 'IPR030835', NULL, 'Sulfite dehydrogenase SoxC', 'Sulfite_DH_SoxC', 4, NULL),
(23999, NULL, 'IPR028939', NULL, 'Pyrroline-5-carboxylate reductase, catalytic, N-terminal', 'P5C_Rdtase_cat_N', 3, NULL),
(24000, NULL, 'IPR029114', NULL, 'Bacterial toxin 24', 'Ntox24', 3, NULL),
(24001, NULL, 'IPR029684', NULL, 'Schlafen family', 'Schlafen', 4, NULL),
(24002, NULL, 'IPR031857', NULL, 'Integrase SSV1, C-terminal', 'Integrase_SSV1_C', 3, NULL),
(24003, NULL, 'IPR025575', NULL, 'DpnD/PcfM-like protein', 'DpnD/PcfM', 4, NULL),
(24004, NULL, 'IPR030977', NULL, '7-carboxy-7-deazaguanine synthase, Cx14CxxC-type', 'QueE_Cx14CxxC', 4, NULL),
(24005, NULL, 'IPR031308', NULL, 'Uncharacterised conserved protein UCP028777', 'UCP028777', 4, NULL),
(24006, NULL, 'IPR032874', NULL, 'DDE domain', 'DDE_dom', 3, NULL),
(24007, NULL, 'IPR033980', NULL, 'Mannosyl-3-phosphoglycerate phosphatase, thermophiles', 'MPG_Pase_thermophiles', 4, NULL),
(24008, NULL, 'IPR029044', NULL, 'Nucleotide-diphospho-sugar transferases', 'Nucleotide-diphossugar_trans', 5, NULL),
(24009, NULL, 'IPR031567', NULL, 'Sin1, middle CRIM domain', 'CRIM_dom', 3, NULL),
(24010, NULL, 'IPR025840', NULL, '7 transmembrane helices usually fused to an inactive transglutaminase', '7TM_transglut', 3, NULL),
(24011, NULL, 'IPR032898', NULL, 'Cell division protein DedD', 'DedD', 4, NULL),
(24012, NULL, 'IPR027377', NULL, 'Zinc-binding domain', 'Znf-3CxxC', 3, NULL),
(24013, NULL, 'IPR025845', NULL, 'Thg1 C-terminal domain', 'Thg1_C_dom', 3, NULL),
(24014, NULL, 'IPR032071', NULL, 'Domain of unknown function DUF4806', 'DUF4806', 3, NULL),
(24015, NULL, 'IPR026770', NULL, 'Ribonuclease kappa', 'RNase_K', 4, NULL),
(24016, NULL, 'IPR032598', NULL, 'Transcriptional regulator RsaM-like', 'RsaM-like', 4, NULL),
(24017, NULL, 'IPR026754', NULL, 'Pancreatic progenitor cell differentiation and proliferation factor', 'PPDPF', 4, NULL),
(24018, NULL, 'IPR030980', NULL, 'Phosphate ABC transporter substrate-binding protein', 'PtsS_plasma', 4, NULL),
(24019, NULL, 'IPR032200', NULL, 'Transcription factor COE, DNA-binding domain', 'COE_DBD', 3, NULL),
(24020, NULL, 'IPR031314', NULL, 'Deoxynucleoside kinase domain', 'DNK_dom', 3, NULL),
(24021, NULL, 'IPR027928', NULL, 'Vascular endothelial growth factor, heparin-binding domain', 'VEGF_C', 3, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(24022, NULL, 'IPR025625', NULL, 'YuzL-like protein', 'YuzL', 4, NULL),
(24023, NULL, 'IPR025571', NULL, 'YqfQ-like protein', 'YqfQ', 4, NULL),
(24024, NULL, 'IPR032211', NULL, 'Protein of unknown function DUF5030', 'DUF5030', 4, NULL),
(24025, NULL, 'IPR024504', NULL, 'Uncharacterised membrane protein Ta0354, soluble domain', 'Unchr_Ta0354_soluble_domain', 3, NULL),
(24026, NULL, 'IPR030924', NULL, 'Type II secretion system-associated lipoprotein', 'Spiro_T2SS_lipo', 4, NULL),
(24027, NULL, 'IPR032096', NULL, 'Domain of unknown function DUF4815', 'DUF4815', 3, NULL),
(24028, NULL, 'IPR034294', NULL, 'Aquaporin transporter', 'Aquaporin_transptr', 4, NULL),
(24029, NULL, 'IPR027969', NULL, 'Small membrane A-kinase anchor protein', 'Small_membr_AKAP', 4, NULL),
(24030, NULL, 'IPR024486', NULL, 'Protein of unknown function DUF2617', 'DUF2617', 4, NULL),
(24031, NULL, 'IPR025627', NULL, 'YfzA-like protein', 'YfzA', 4, NULL),
(24032, NULL, 'IPR027954', NULL, 'Domain of unknown function DUF4430', 'DUF4430', 3, NULL),
(24033, NULL, 'IPR027977', NULL, 'Protein of unknown function DUF4621', 'DUF4621', 4, NULL),
(24034, NULL, 'IPR024484', NULL, 'Protein of unknown function DUF2709', 'DUF2709', 4, NULL),
(24035, NULL, 'IPR029675', NULL, 'GPI-GalNAc transferase PGAP4', 'PGAP4', 4, NULL),
(24036, NULL, 'IPR027477', NULL, 'Succinate dehydrogenase/fumarate reductase flavoprotein, catalytic domain superfamily', 'Succ_DH/fumarate_Rdtase_cat_sf', 5, NULL),
(24037, NULL, 'IPR024505', NULL, 'Protein of unknown function DUF3201', 'DUF3201', 4, NULL),
(24038, NULL, 'IPR032083', NULL, 'Protein of unknown function DUF4811', 'DUF4811', 4, NULL),
(24039, NULL, 'IPR032260', NULL, 'Domain of unknown function DUF5060', 'DUF5060', 3, NULL),
(24040, NULL, 'IPR031435', NULL, 'Transmembrane protein TMEM132, N-terminal', 'TMEM132_N', 3, NULL),
(24041, NULL, 'IPR031975', NULL, 'Type IV pilin-like putative secretion pathway protein G/H', 'Pilin_GH', 4, NULL),
(24042, NULL, 'IPR032072', NULL, 'Protein of unknown function DUF4807', 'DUF4807', 4, NULL),
(24043, NULL, 'IPR024446', NULL, 'PXPV repeat', 'PXPV', 7, NULL),
(24044, NULL, 'IPR027312', NULL, 'Sda1', 'Sda1', 4, NULL),
(24045, NULL, 'IPR032349', NULL, 'Protein of unknown function DUF4865', 'DUF4865', 4, NULL),
(24046, NULL, 'IPR032605', NULL, 'Domain of unknown function DUF4896', 'DUF4896', 3, NULL),
(24047, NULL, 'IPR024489', NULL, 'Organ specific protein', 'Organ_specific_prot', 4, NULL),
(24048, NULL, 'IPR032207', NULL, 'Protein of unknown function DUF5026', 'DUF5026', 4, NULL),
(24049, NULL, 'IPR031370', NULL, 'Altered inheritance of mitochondria protein 3', 'Aim3', 4, NULL),
(24050, NULL, 'IPR029010', NULL, 'ThuA-like domain', 'ThuA-like', 3, NULL),
(24051, NULL, 'IPR032343', NULL, 'Methyl-CpG-binding domain protein 2/3, p55-binding region', 'MBD2/MBD3_p55-bd', 3, NULL),
(24052, NULL, 'IPR024452', NULL, 'Protein of unknown function DUF3876', 'DUF3876', 4, NULL),
(24053, NULL, 'IPR025626', NULL, 'YyzF-like protein', 'YyzF', 4, NULL),
(24054, NULL, 'IPR029760', NULL, 'Glutathione peroxidase conserved site', 'GPX_CS', 2, NULL),
(24055, NULL, 'IPR030983', NULL, 'Bacterial microcompartment shell protein EutL', 'EutL', 4, NULL),
(24056, NULL, 'IPR024487', NULL, 'Protein YhjR', 'YhjR', 4, NULL),
(24057, NULL, 'IPR026771', NULL, 'Transmembrane protein 218', 'Tmem218', 4, NULL),
(24058, NULL, 'IPR032197', NULL, 'Ubiquitin-like modifier-activating enzyme Atg7, N-terminal', 'Atg7_N', 3, NULL),
(24059, NULL, 'IPR027899', NULL, 'Domain of unknown function DUF4458', 'DUF4458', 3, NULL),
(24060, NULL, 'IPR026699', NULL, 'Exosome complex RNA-binding protein 1/RRP40/RRP4', 'Exosome_RNA_bind1/RRP40/RRP4', 4, NULL),
(24061, NULL, 'IPR031334', NULL, 'Piezo non-specific cation channel, R-Ras-binding domain', 'Piezo_RRas-bd_dom', 3, NULL),
(24062, NULL, 'IPR029036', NULL, 'Pyrroline-5-carboxylate reductase, dimerisation domain', 'P5CR_dimer', 3, NULL),
(24063, NULL, 'IPR025829', NULL, 'Zinc knuckle CX2CX3GHX4C', 'Zn_knuckle_CX2CX3GHX4C', 3, NULL),
(24064, NULL, 'IPR025553', NULL, 'YppF-like protein', 'YppF', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(24065, NULL, 'IPR030984', NULL, 'Bacterial microcompartment shell protein PduB', 'PduB', 4, NULL),
(24066, NULL, 'IPR032215', NULL, 'Protein of unknown function DUF5034', 'DUF5034', 4, NULL),
(24067, NULL, 'IPR032448', NULL, 'SMARCC, SWIRM-associated domain', 'SWIRM-assoc', 3, NULL),
(24068, NULL, 'IPR029030', NULL, 'Caspase-like domain superfamily', 'Caspase-like_dom_sf', 5, NULL),
(24069, NULL, 'IPR025961', NULL, 'Heavy-metal resistance protein', 'Metal_resist', 4, NULL),
(24070, NULL, 'IPR027953', NULL, 'Domain of unknown function DUF4605', 'DUF4605', 3, NULL),
(24071, NULL, 'IPR025844', NULL, 'Ribosomally synthesized peptide in Herpetosiphon', 'Herpeto_peptide', 4, NULL),
(24072, NULL, 'IPR032888', NULL, 'Histidine N-alpha-methyltransferase, Actinobacteria-type', 'EgtD_Actinobacteria', 4, NULL),
(24073, NULL, 'IPR032347', NULL, 'Protein of unknown function DUF4864', 'DUF4864', 4, NULL),
(24074, NULL, 'IPR031766', NULL, 'Occluded RNA-recognition motif', 'RRM_occluded', 3, NULL),
(24075, NULL, 'IPR032222', NULL, 'Protein of unknown function DUF5041', 'DUF5041', 4, NULL),
(24076, NULL, 'IPR031547', NULL, 'Protein of unknown function DUF5089', 'DUF5089', 4, NULL),
(24077, NULL, 'IPR032390', NULL, 'Polynucleotide kinase-phosphatase, C-terminal', 'PNKP_C', 3, NULL),
(24078, NULL, 'IPR025542', NULL, 'YacH protein', 'YacH', 4, NULL),
(24079, NULL, 'IPR025664', NULL, 'Stage III sporulation protein AC/AD family', 'Spore_III_AC/AD', 4, NULL),
(24080, NULL, 'IPR032253', NULL, 'Exocrine gland-secreted peptide Esp1/Esp22', 'Esp1/Esp22', 4, NULL),
(24081, NULL, 'IPR027465', NULL, 'Proteinase inhibitor I35b (TIMP), C-terminal', 'TIMP_C', 5, NULL),
(24082, NULL, 'IPR025823', NULL, 'tRNA (uracil-5-)-methyltransferase homolog B, chordates', 'TRM2B_chor', 4, NULL),
(24083, NULL, 'IPR029006', NULL, 'ADF-H/Gelsolin-like domain superfamily', 'ADF-H/Gelsolin-like_dom_sf', 5, NULL),
(24084, NULL, 'IPR032393', NULL, 'Stromal interaction molecule, Orai1-activating region', 'SOAR', 3, NULL),
(24085, NULL, 'IPR032600', NULL, 'Sm-like domain', 'Sm-like_dom', 3, NULL),
(24086, NULL, 'IPR025887', NULL, 'Glycoside hydrolase family 31, N-terminal domain', 'Glyco_hydro_31_N_dom', 3, NULL),
(24087, NULL, 'IPR025962', NULL, 'SdpI/YhfL protein family', 'SdpI/YhfL', 4, NULL),
(24088, NULL, 'IPR031725', NULL, 'Acetylserotonin O-methyltransferase, dimerisation domain', 'ASMT_dimerisation', 3, NULL),
(24089, NULL, 'IPR025830', NULL, 'DNA-binding domain, ovate family-like', 'DNA_bnd_dom_ovate', 3, NULL),
(24090, NULL, 'IPR024501', NULL, 'Protein of unknown function DUF3141', 'DUF3141', 4, NULL),
(24091, NULL, 'IPR027012', NULL, 'Enkurin domain', 'Enkurin_dom', 3, NULL),
(24092, NULL, 'IPR031556', NULL, 'Sir4, SID domain', 'SIR4_SID', 3, NULL),
(24093, NULL, 'IPR026769', NULL, 'MICOS complex subunit Mic13', 'Mic13', 4, NULL),
(24094, NULL, 'IPR032908', NULL, 'Lipid A 1-diphosphate synthase', 'LpxT', 4, NULL),
(24095, NULL, 'IPR025548', NULL, 'YfkD-like protein', 'YfkD', 4, NULL),
(24096, NULL, 'IPR025672', NULL, 'Sigma factor regulator C-terminal domain', 'Sigma_reg_C_dom', 3, NULL),
(24097, NULL, 'IPR032341', NULL, 'MITD1, C-terminal phospholipase D-like domain', 'MITD1_C', 3, NULL),
(24098, NULL, 'IPR027373', NULL, 'Ribbon-helix-helix domain', 'RHH_dom', 3, NULL),
(24099, NULL, 'IPR030978', NULL, 'Adenosyl-fluoride synthase', 'Fluorinase', 4, NULL),
(24100, NULL, 'IPR024508', NULL, 'Protein of unknown function DUF3226', 'DUF3226', 4, NULL),
(24101, NULL, 'IPR032876', NULL, 'Tip attachment protein J', 'J_dom', 3, NULL),
(24102, NULL, 'IPR025539', NULL, 'YdgH protein', 'YdgH', 4, NULL),
(24103, NULL, 'IPR025543', NULL, 'Dodecin-like', 'Dodecin-like', 5, NULL),
(24104, NULL, 'IPR032203', NULL, 'Protein of unknown function (DUF5022)', 'DUF5022', 4, NULL),
(24105, NULL, 'IPR029009', NULL, 'Allosteric substrate binding domain superfamily', 'ASB_dom_sf', 5, NULL),
(24106, NULL, 'IPR026697', NULL, 'Dynein axonemal assembly factor 6', 'DNAAF6', 4, NULL),
(24107, NULL, 'IPR027972', NULL, 'Protein of unknown function DUF4489', 'DUF4489', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(24108, NULL, 'IPR026702', NULL, 'Coiled-coil domain-containing protein 83', 'CCDC83', 4, NULL),
(24109, NULL, 'IPR035918', NULL, 'Delta-endotoxin CytB-like superfamily', 'CytB_endotoxin-like_sf', 5, NULL),
(24110, NULL, 'IPR025673', NULL, 'Protein of unknown function with PCYCGC motif', 'PCYCGC', 4, NULL),
(24111, NULL, 'IPR030417', NULL, 'Membrane-spanning 4-domains subfamily A', 'MS4A', 4, NULL),
(24112, NULL, 'IPR031769', NULL, 'Actin-like protein 7A, N-terminal', 'ACTL7A_N', 3, NULL),
(24113, NULL, 'IPR028978', NULL, 'Chorismate pyruvate-lyase/UbiC transcription regulator-associated domain superfamily', 'Chorismate_lyase_/UTRA_dom_sf', 5, NULL),
(24114, NULL, 'IPR031544', NULL, 'WD40-like domain containing protein', 'WD40-like', 4, NULL),
(24115, NULL, 'IPR025783', NULL, 'Histone-lysine N-methyltransferase Set9, fungi', 'Set9_fungi', 4, NULL),
(24116, NULL, 'IPR026762', NULL, 'Spindle and kinetochore-associated protein 2', 'Ska2', 4, NULL),
(24117, NULL, 'IPR028890', NULL, 'Ubiquitin-specific peptidase-like, SUMO isopeptidase', 'Peptidase_C98', 3, NULL),
(24118, NULL, 'IPR029052', NULL, 'Metallo-dependent phosphatase-like', 'Metallo-depent_PP-like', 5, NULL),
(24119, NULL, 'IPR031546', NULL, 'Putative actin-like family', 'Actin_micro', 4, NULL),
(24120, NULL, 'IPR029288', NULL, 'Protein of unknown function DUF4607', 'DUF4607', 4, NULL),
(24121, NULL, 'IPR032451', NULL, 'SMARCC, C-terminal', 'SMARCC_C', 3, NULL),
(24122, NULL, 'IPR025549', NULL, 'YjzC-like protein', 'YjzC', 4, NULL),
(24123, NULL, 'IPR032092', NULL, 'Type IV Pilus-assembly protein W', 'PilW', 4, NULL),
(24124, NULL, 'IPR031638', NULL, 'Melanoregulin', 'Melanoregulin', 4, NULL),
(24125, NULL, 'IPR027481', NULL, 'HIV-1 Nef protein, core domain superfamily', 'HIV-1_Nef_core_sf', 5, NULL),
(24126, NULL, 'IPR031723', NULL, 'Dimethlysulfonioproprionate lyase', 'DMSP_lyase', 4, NULL),
(24127, NULL, 'IPR028979', NULL, 'HPr(Ser) kinase/phosphorylase-like, N-terminal domain superfamily', 'Ser_kin/Pase_Hpr-like_N_sf', 5, NULL),
(24128, NULL, 'IPR025622', NULL, 'YqzE-like protein', 'YqzE', 4, NULL),
(24129, NULL, 'IPR032391', NULL, 'Invasin IpaB, N-terminal', 'SipB_N', 3, NULL),
(24130, NULL, 'IPR024956', NULL, 'tRNAHis guanylyltransferase catalytic domain', 'tRNAHis_GuaTrfase_cat', 3, NULL),
(24131, NULL, 'IPR025827', NULL, 'Recombinase zinc beta ribbon domain', 'Zn_ribbon_recom_dom', 3, NULL),
(24132, NULL, 'IPR029070', NULL, 'Chitinase insertion domain superfamily', 'Chitinase_insertion_sf', 5, NULL),
(24133, NULL, 'IPR031734', NULL, 'Transcription activator MBF2', 'MBF2', 4, NULL),
(24134, NULL, 'IPR026436', NULL, 'Conserved hypothetical protein CHP04206', 'CHP04206', 4, NULL),
(24135, NULL, 'IPR031148', NULL, 'Plexin family', 'Plexin', 4, NULL),
(24136, NULL, 'IPR025837', NULL, 'CFTR regulator domain', 'CFTR_reg_dom', 3, NULL),
(24137, NULL, 'IPR025842', NULL, 'Ribosomally synthesized peptide in Bacteroidetes', 'Bacteroid_pep', 4, NULL),
(24138, NULL, 'IPR032219', NULL, 'Protein of unknown function DUF5038', 'DUF5038', 4, NULL),
(24139, NULL, 'IPR025824', NULL, 'OB-fold nucleic acid binding domain', 'OB-fold_nuc-bd_dom', 3, NULL),
(24140, NULL, 'IPR024488', NULL, 'Protein of unknown function DUF2777', 'DUF2777', 4, NULL),
(24141, NULL, 'IPR025540', NULL, 'Fluoroacetyl-CoA thioesterase', 'FlK', 4, NULL),
(24142, NULL, 'IPR026777', NULL, 'Plasma membrane fusion protein PRM1', 'PRM1', 4, NULL),
(24143, NULL, 'IPR031329', NULL, 'Neutral/alkaline non-lysosomal ceramidase, N-terminal', 'NEUT/ALK_ceramidase_N', 3, NULL),
(24144, NULL, 'IPR035956', NULL, 'RimP, N-terminal domain superfamily', 'RimP_N_sf', 5, NULL),
(24145, NULL, 'IPR031550', NULL, 'Rad61, Wapl domain', 'Rad61_Wapl', 3, NULL),
(24146, NULL, 'IPR030397', NULL, 'SEPARIN core domain', 'SEPARIN_core_dom', 3, NULL),
(24147, NULL, 'IPR027923', NULL, 'Hydrophobic seed protein domain', 'Hydrophob_seed_dom', 3, NULL),
(24148, NULL, 'IPR031709', NULL, 'Putative phage abortive infection protein', 'PutAbiC', 4, NULL),
(24149, NULL, 'IPR032389', NULL, 'Type II secretion system protein GspB', 'GspB', 4, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(24150, NULL, 'IPR031382', NULL, 'Uncharacterised protein YjbT', 'YjbT', 4, NULL),
(24151, NULL, 'IPR026058', NULL, 'LIPIN family', 'LIPIN', 4, NULL),
(24152, NULL, 'IPR024449', NULL, 'Anti-sigma factor RsgI, N-terminal', 'Anti-sigma_RsgI_N', 3, NULL),
(24153, NULL, 'IPR027435', NULL, 'Stannin superfamily', 'Stannin_sf', 5, NULL),
(24154, NULL, 'IPR025623', NULL, 'YusW-like protein', 'YusW', 4, NULL),
(24155, NULL, 'IPR027965', NULL, 'Protein of unknown function DUF4513', 'DUF4513', 4, NULL),
(24156, NULL, 'IPR031768', NULL, 'Carbohydrate binding module, xylan-binding domain', 'CBM60_xylan-bd', 3, NULL),
(24157, NULL, 'IPR027944', NULL, 'Sieve element occlusion, C-terminal', 'SEO_C', 3, NULL),
(24158, NULL, 'IPR025963', NULL, 'FlgD Tudor-like domain', 'FLgD_Tudor', 3, NULL),
(24159, NULL, 'IPR030877', NULL, 'Sulfofructose kinase', 'SF_kinase', 4, NULL),
(24160, NULL, 'IPR031558', NULL, 'Vacuolar protein-sorting-associated protein 36, NZF-N zinc-finger domain', 'Vps36-NZF-N', 3, NULL),
(24161, NULL, 'IPR025960', NULL, 'Reverse transcriptase, N-terminal domain', 'RVT_N', 3, NULL),
(24162, NULL, 'IPR031770', NULL, 'Antibacterial factor-related peptide', 'Abf-1/2', 4, NULL),
(24163, NULL, 'IPR030985', NULL, 'Putative peptide maturation system protein', 'PpiC-rel_mature', 4, NULL),
(24164, NULL, 'IPR025669', NULL, 'AAA domain', 'AAA_dom', 3, NULL),
(24165, NULL, 'IPR032198', NULL, 'E2F transcription factor, CC-MB domain', 'E2F_CC-MB', 3, NULL),
(24166, NULL, 'IPR032098', NULL, 'Acyltransferase, C-terminal domain', 'Acyltransf_C', 3, NULL),
(24167, NULL, 'IPR031372', NULL, 'CAMSAP, spectrin and Ca2+/calmodulin-binding region', 'CAMSAP_CC1', 2, NULL),
(24168, NULL, 'IPR026775', NULL, 'Zygote arrest protein 1', 'Zar1', 4, NULL),
(24169, NULL, 'IPR027966', NULL, 'FANCD2 opposite strand protein', 'FANCD2OS', 4, NULL),
(24170, NULL, 'IPR024447', NULL, 'YXWGXW repeat', 'YXWGXW_rpt', 7, NULL),
(24171, NULL, 'IPR032350', NULL, 'Next to BRCA1, central domain', 'N_BRCA1_central', 3, NULL),
(24172, NULL, 'IPR029668', NULL, 'Transmembrane protein 98', 'TMEM98', 4, NULL),
(24173, NULL, 'IPR032212', NULL, 'Protein of unknown function DUF5031', 'DUF5031', 4, NULL),
(24174, NULL, 'IPR026018', NULL, 'Ribosomal protein S7, archaeal', 'Ribosomal_S7_arc', 4, NULL),
(24175, NULL, 'IPR027962', NULL, 'Glutamate-rich protein 3', 'ERICH3', 4, NULL),
(24176, NULL, 'IPR027980', NULL, 'RACo, C-terminal', 'RACo_C', 3, NULL),
(24177, NULL, 'IPR032214', NULL, 'Protein of unknown function DUF5033', 'DUF5033', 4, NULL),
(24178, NULL, 'IPR024445', NULL, 'ISXO2-like transposase domain', 'Tnp_ISXO2-like', 3, NULL),
(24179, NULL, 'IPR027027', NULL, 'GOSR2/Membrin/Bos1', 'GOSR2/Membrin/Bos1', 4, NULL),
(24180, NULL, 'IPR032604', NULL, 'Protein of unknown function DUF4897', 'DUF4897', 4, NULL),
(24181, NULL, 'IPR032897', NULL, 'Dissimilatory sulfite reductase', 'Sulfite_reductase', 4, NULL),
(24182, NULL, 'IPR024495', NULL, 'Protein of unknown function DUF2771', 'DUF2771', 4, NULL),
(24183, NULL, 'IPR035949', NULL, 'SopE-like, GEF domain superfamily', 'SopE-like_GEF_dom_sf', 5, NULL),
(24184, NULL, 'IPR024490', NULL, 'Protein of unknown function DUF2759', 'DUF2759', 4, NULL),
(24185, NULL, 'IPR026766', NULL, 'Protein FAM133', 'Fam133', 4, NULL),
(24186, NULL, 'IPR025550', NULL, 'YycC-like protein', 'YycC', 4, NULL),
(24187, NULL, 'IPR032601', NULL, 'Protein of unknown function DUF4900', 'DUF4900', 4, NULL),
(24188, NULL, 'IPR032354', NULL, 'FOXP, coiled-coil domain', 'FOXP-CC', 3, NULL),
(24189, NULL, 'IPR024451', NULL, 'TraG, N-terminal, Bacteroidetes', 'TraG_N_Bacteroidetes', 3, NULL),
(24190, NULL, 'IPR027956', NULL, 'Protein of unknown function DUF4556', 'DUF4556', 4, NULL),
(24191, NULL, 'IPR032442', NULL, 'Cytoplasmic tRNA 2-thiolation protein 1, C-terminal', 'CTU1_C', 3, NULL),
(24192, NULL, 'IPR031705', NULL, 'Glycosyl hydrolase family 36, C-terminal', 'Glyco_hydro_36_C', 3, NULL),
(24193, NULL, 'IPR029003', NULL, 'CENP-S/Mhf1', 'CENP-S/Mhf1', 4, NULL),
(24194, NULL, 'IPR025942', NULL, 'Stage VI sporulation protein F', 'SpoVIF', 4, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(24195, NULL, 'IPR026779', NULL, 'Calcium/calmodulin-dependent protein kinase II inhibitor', 'Camk2n', 4, NULL),
(24196, NULL, 'IPR031849', NULL, 'Domain of unknown function DUF5069', 'DUF5069', 3, NULL),
(24197, NULL, 'IPR031388', NULL, 'Topoisomerase I damage affected protein 11', 'Tda11', 4, NULL),
(24198, NULL, 'IPR027924', NULL, 'Phage-like element PBSX protein, XkdF', 'XkdF', 3, NULL),
(24199, NULL, 'IPR028610', NULL, 'Arylsulfate sulfotransferase AssT, Enterobacteria', 'AssT_Enterobac', 4, NULL),
(24200, NULL, 'IPR027945', NULL, 'SseB protein, C-terminal', 'SseB_C', 3, NULL),
(24201, NULL, 'IPR032255', NULL, 'Helical bimodular sensor domain', 'HBM', 3, NULL),
(24202, NULL, 'IPR027354', NULL, 'YcgL domain', 'YcgL_dom', 3, NULL),
(24203, NULL, 'IPR027960', NULL, 'Protein of unknown function DUF4519', 'DUF4519', 4, NULL),
(24204, NULL, 'IPR031689', NULL, 'Protein of unknown function DUF5080', 'DUF5080', 4, NULL),
(24205, NULL, 'IPR032220', NULL, 'Protein of unknown function DUF5039', 'DUF5039', 4, NULL),
(24206, NULL, 'IPR032366', NULL, 'Protein of unknown function DUF4871', 'DUF4871', 4, NULL),
(24207, NULL, 'IPR032217', NULL, 'Protein of unknown function DUF5036', 'DUF5036', 4, NULL),
(24208, NULL, 'IPR034270', NULL, 'Ephrin type-A receptor 4, ligand binding domain', 'EphA4_rcpt_lig-bd', 3, NULL),
(24209, NULL, 'IPR032453', NULL, 'Homeobox protein PKNOX/Meis, N-terminal', 'PKNOX/Meis_N', 3, NULL),
(24210, NULL, 'IPR031793', NULL, 'Integrin-alpha FG-GAP repeat-containing protein 2', 'KICSTOR_ITFG2', 4, NULL),
(24211, NULL, 'IPR032396', NULL, 'Spindle assembly abnormal protein 6, N-terminal', 'SAS-6_N', 3, NULL),
(24212, NULL, 'IPR032906', NULL, 'Lipopolysaccharide assembly protein A', 'LapA', 4, NULL),
(24213, NULL, 'IPR025888', NULL, 'Meiosis-specific protein MEI4', 'MEI4', 4, NULL),
(24214, NULL, 'IPR032080', NULL, 'Protein of unknown function DUF4809', 'DUF4809', 4, NULL),
(24215, NULL, 'IPR027970', NULL, 'Domain of unknown function DUF4599', 'DUF4599', 3, NULL),
(24216, NULL, 'IPR027358', NULL, 'Kininogen-type cystatin domain', 'Kininogen-type_cystatin_dom', 3, NULL),
(24217, NULL, 'IPR025832', NULL, 'GxGYxYP putative glycoside hydrolase, C-terminal', 'GxGYxYP_C', 3, NULL),
(24218, NULL, 'IPR029045', NULL, 'ClpP/crotonase-like domain superfamily', 'ClpP/crotonase-like_dom_sf', 5, NULL),
(24219, NULL, 'IPR025843', NULL, 'Ribosomally synthesized peptide in Actinomycetes', 'Actino_peptide', 4, NULL),
(24220, NULL, 'IPR032264', NULL, 'Menaquinone biosynthesis protein MenD, middle domain', 'MenD_middle', 3, NULL),
(24221, NULL, 'IPR032887', NULL, 'tRNA-dihydrouridine synthase B', 'DusB', 4, NULL),
(24222, NULL, 'IPR027352', NULL, 'Nonstructural protein 13, zinc-binding domain, coronavirus-like', 'NSP13_ZBD_CoV-like', 3, NULL),
(24223, NULL, 'IPR026763', NULL, 'Transmembrane protein 182', 'TMEM182', 4, NULL),
(24224, NULL, 'IPR025555', NULL, 'YppG-like protein', 'YppG', 4, NULL),
(24225, NULL, 'IPR032877', NULL, 'Transposase IS204/IS1001/IS1096/IS1165, helix-turn-helix domain', 'Transposase_HTH', 3, NULL),
(24226, NULL, 'IPR032905', NULL, 'O-acetyltransferase WecH', 'WecH', 4, NULL),
(24227, NULL, 'IPR026767', NULL, 'Transmembrane protein 151', 'Tmem151', 4, NULL),
(24228, NULL, 'IPR027375', NULL, 'DKNYY family', 'DKNYY', 4, NULL),
(24229, NULL, 'IPR027971', NULL, 'Elongin BC and Polycomb repressive complex 2-associated protein EPOP', 'EPOP', 4, NULL),
(24230, NULL, 'IPR027356', NULL, 'NPH3 domain', 'NPH3_dom', 3, NULL),
(24231, NULL, 'IPR029031', NULL, 'Gingipain, N-terminal superfamily', 'Gingipain_N_sf', 5, NULL),
(24232, NULL, 'IPR029759', NULL, 'Glutathione peroxidase active site', 'GPX_AS', 0, NULL),
(24233, NULL, 'IPR030702', NULL, 'Ras-related protein Rab14', 'Rab14', 4, NULL),
(24234, NULL, 'IPR031447', NULL, 'Protein moonraker', 'MNR', 4, NULL),
(24235, NULL, 'IPR025668', NULL, 'Transposase DDE domain', 'Tnp_DDE_dom', 3, NULL),
(24236, NULL, 'IPR032371', NULL, 'Domain of unknown function DUF4873', 'DUF4873', 3, NULL),
(24237, NULL, 'IPR027360', NULL, 'AbrB-like transcriptional regulator', 'AbrB-like', 4, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(24238, NULL, 'IPR030873', NULL, 'Beta-barrel assembly-enhancing protease', 'Protease_BepA', 4, NULL),
(24239, NULL, 'IPR029686', NULL, 'Enhancer of split M4 family', 'Malpha/m4/m2', 4, NULL),
(24240, NULL, 'IPR032903', NULL, 'UbiD-like decarboxylase/ferulic acid decarboxylase 1', 'UbiD/Fdc1', 4, NULL),
(24241, NULL, 'IPR024502', NULL, 'Protein of unknown function DUF3194', 'DUF3194', 4, NULL),
(24242, NULL, 'IPR024420', NULL, 'TRAPP III complex, Trs85', 'TRAPP_III_complex_Trs85', 4, NULL),
(24243, NULL, 'IPR025839', NULL, 'RimK-like ATPgrasp N-terminal domain', 'RLAN_dom', 3, NULL),
(24244, NULL, 'IPR024485', NULL, 'Protein of unknown function DUF2680', 'DUF2680', 4, NULL),
(24245, NULL, 'IPR025573', NULL, 'YwpF-like protein', 'YwpF', 4, NULL),
(24246, NULL, 'IPR025505', NULL, 'FHIPEP conserved site', 'FHIPEP_CS', 2, NULL),
(24247, NULL, 'IPR026698', NULL, 'Uncharacterised protein C3orf38 (DUF4518)', 'UPF_C3orf38', 4, NULL),
(24248, NULL, 'IPR027372', NULL, 'Phytase-like domain', 'Phytase-like_dom', 3, NULL),
(24249, NULL, 'IPR032446', NULL, 'S phase cyclin A-associated protein in the endoplasmic reticulum, N-terminal', 'SCAPER_N', 3, NULL),
(24250, NULL, 'IPR031561', NULL, 'Protein of unknown function DUF5086', 'DUF5086', 4, NULL),
(24251, NULL, 'IPR027974', NULL, 'Domain of unknown function DUF4470', 'DUF4470', 3, NULL),
(24252, NULL, 'IPR027419', NULL, 'CRISPR-associated protein Csx1, C-terminal', 'CRISPR-assoc_Csx1_C', 5, NULL),
(24253, NULL, 'IPR027926', NULL, 'Uncharacterised protein YqbF domain', 'YqbF', 3, NULL),
(24254, NULL, 'IPR031794', NULL, 'Hyaluronan-mediated motility receptor, C-terminal', 'HMMR_C', 3, NULL),
(24255, NULL, 'IPR027032', NULL, 'Twinkle-like protein', 'Twinkle-like', 4, NULL),
(24256, NULL, 'IPR032086', NULL, 'Protein of unknown function DUF4813', 'DUF4813', 4, NULL),
(24257, NULL, 'IPR032907', NULL, 'Tubulin-like protein CetZ', 'CetZ', 4, NULL),
(24258, NULL, 'IPR031765', NULL, 'Mdy2, Get4 binding domain', 'Mdy2_get4-bd', 3, NULL),
(24259, NULL, 'IPR027959', NULL, 'Domain of unknown function DUF4627', 'DUF4627', 3, NULL),
(24260, NULL, 'IPR025671', NULL, 'Protein of unknown function with HXXEE motif', 'HXXEE', 4, NULL),
(24261, NULL, 'IPR025712', NULL, 'Nucleoporin Nup54, alpha-helical domain', 'Nup54_alpha-helical_dom', 3, NULL),
(24262, NULL, 'IPR026750', NULL, 'Protein N-terminal asparagine amidohydrolase', 'NTAN1', 4, NULL),
(24263, NULL, 'IPR034087', NULL, 'Cell wall/vacuolar inhibitor of fructosidase', 'C/VIF1', 4, NULL),
(24264, NULL, 'IPR025501', NULL, 'ATP binding protein MinD/FleN', 'MinD_FleN', 4, NULL),
(24265, NULL, 'IPR026753', NULL, 'Nuclear apoptosis-inducing factor 1', 'NAIF1', 4, NULL),
(24266, NULL, 'IPR025667', NULL, 'SprB repeat', 'SprB_repeat', 7, NULL),
(24267, NULL, 'IPR025852', NULL, 'Ataxin 2, SM domain', 'SM_dom_ATX', 3, NULL),
(24268, NULL, 'IPR030777', NULL, 'PSTPIP1, SH3 domain', 'PSTPIP1_SH3', 3, NULL),
(24269, NULL, 'IPR027482', NULL, 'Sec1-like, domain 2', 'Sec1-like_dom2', 5, NULL),
(24270, NULL, 'IPR024507', NULL, 'AtzH-like', 'AtzH-like', 4, NULL),
(24271, NULL, 'IPR032104', NULL, 'Spaetzle', 'Spaetzle', 3, NULL),
(24272, NULL, 'IPR029043', NULL, 'Glycine cleavage T-protein/YgfZ, C-terminal', 'GcvT/YgfZ_C', 5, NULL),
(24273, NULL, 'IPR029673', NULL, 'Transmembrane protein 179', 'TMEM179', 4, NULL),
(24274, NULL, 'IPR025572', NULL, 'YgaB-like protein', 'YgaB', 4, NULL),
(24275, NULL, 'IPR031449', NULL, 'Annexin-2 receptor', 'ANXA2R', 4, NULL),
(24276, NULL, 'IPR031801', NULL, 'Virilizer, N-terminal', 'VIR_N', 3, NULL),
(24277, NULL, 'IPR027897', NULL, 'Protein of unknown function DUF4559', 'DUF4559', 4, NULL),
(24278, NULL, 'IPR031729', NULL, 'Fanconi anaemia group A protein, N-terminal domain', 'Fanconi_A_N', 3, NULL),
(24279, NULL, 'IPR025966', NULL, 'Oligopeptide transport permease C-like, N-terminal domain', 'OppC_N', 3, NULL),
(24280, NULL, 'IPR024506', NULL, 'Protein of unknown function DUF3217', 'DUF3217', 4, NULL),
(24281, NULL, 'IPR026066', NULL, 'Headcase protein', 'Headcase', 4, NULL),
(24282, NULL, 'IPR031545', NULL, 'Putative TPR-like repeat', 'SRP_TPR-like', 7, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(24283, NULL, 'IPR027365', NULL, 'GNAT acetyltransferase YdfB-like', 'GNAT_acetyltra_YdfB-like', 4, NULL),
(24284, NULL, 'IPR026704', NULL, 'Katanin-interacting protein', 'KATNIP', 4, NULL),
(24285, NULL, 'IPR032599', NULL, 'Protein of unknown function DUF4901', 'DUF4901', 4, NULL),
(24286, NULL, 'IPR032205', NULL, 'Protein of unknown function DUF5024', 'DUF5024', 4, NULL),
(24287, NULL, 'IPR025483', NULL, 'Lipase, eukaryotic', 'Lipase_euk', 4, NULL),
(24288, NULL, 'IPR027925', NULL, 'MCM N-terminal domain', 'MCM_N', 3, NULL),
(24289, NULL, 'IPR032672', NULL, 'TmcA/NAT10/Kre33', 'TmcA/NAT10/Kre33', 4, NULL),
(24290, NULL, 'IPR028797', NULL, 'PRKAA1, UBA-like autoinhibitory domain', 'PRKAA1_UBA', 3, NULL),
(24291, NULL, 'IPR032904', NULL, '2-phytyl-1,4-naphtoquinone methyltransferase MenG', 'MenG', 4, NULL),
(24292, NULL, 'IPR032221', NULL, 'Protein of unknown function DUF5040', 'DUF5040', 4, NULL),
(24293, NULL, 'IPR031436', NULL, 'Transmembrane protein TMEM132, C-terminal', 'TMEM132_C', 3, NULL),
(24294, NULL, 'IPR024550', NULL, 'TFIIEalpha/SarR/Rpc3 HTH domain', 'TFIIEa/SarR/Rpc3_HTH_dom', 3, NULL),
(24295, NULL, 'IPR032445', NULL, 'Domain of unknown function DUF5059', 'DUF5059', 3, NULL),
(24296, NULL, 'IPR025973', NULL, 'Cysteine-rich VLP domain', 'Cys_rich_VLP_dom', 3, NULL),
(24297, NULL, 'IPR025670', NULL, 'Fox-1 C-terminal domain', 'Fox-1_C_dom', 3, NULL),
(24298, NULL, 'IPR025624', NULL, 'PcfK-like protein', 'PcfK', 4, NULL),
(24299, NULL, 'IPR029758', NULL, 'Sulphite reductase [NADPH] flavoprotein, alpha chain, Proteobacteria', 'CysJ_Proteobact', 4, NULL),
(24300, NULL, 'IPR025957', NULL, 'Cysteine-rich KTR', 'Cys_rich_KTR', 4, NULL),
(24301, NULL, 'IPR028889', NULL, 'Ubiquitin specific protease domain', 'USP_dom', 3, NULL),
(24302, NULL, 'IPR026564', NULL, 'Transcriptional regulator TACO1-like, domain 3', 'Transcrip_reg_TACO1-like_dom3', 5, NULL),
(24303, NULL, 'IPR032073', NULL, 'Fibronectin type III domain-containing protein 5, C-terminal domain', 'FNDC5_C', 3, NULL),
(24304, NULL, 'IPR026562', NULL, 'Probable transcriptional regulatory protein YeeN', 'Transcrip_reg_TACO1_YeeN', 4, NULL),
(24305, NULL, 'IPR029008', NULL, 'ER membrane protein complex subunit 6-like', 'EMC6-like', 4, NULL),
(24306, NULL, 'IPR032258', NULL, '17kDa common-antigen outer membrane protein', 'DUF5061', 4, NULL),
(24307, NULL, 'IPR031377', NULL, 'Inovirus G7P protein', 'Tail_VII', 4, NULL),
(24308, NULL, 'IPR025833', NULL, 'GDYXXLXY protein', 'GDYXXLXY', 4, NULL),
(24309, NULL, 'IPR032208', NULL, 'Protein of unknown function DUF5027', 'DUF5027', 4, NULL),
(24310, NULL, 'IPR026772', NULL, 'Fin bud initiation factor', 'Fibin', 4, NULL),
(24311, NULL, 'IPR025551', NULL, 'Immunity protein WapI-like', 'WapI-like', 4, NULL),
(24312, NULL, 'IPR025716', NULL, 'Post-transcriptional regulator', 'Post-transcriptional_regulator', 4, NULL),
(24313, NULL, 'IPR029154', NULL, '3-hydroxyisobutyrate dehydrogenase-like, NAD-binding domain', 'HIBADH-like_NADP-bd', 3, NULL),
(24314, NULL, 'IPR032009', NULL, 'Stomatal closure-related actin-binding protein, coiled-coil domain', 'SCAB_CC', 3, NULL),
(24315, NULL, 'IPR027957', NULL, 'Protein of unknown function DUF4634', 'DUF4634', 4, NULL),
(24316, NULL, 'IPR025968', NULL, 'YwqJ-like deaminase', 'YwqJ_deaminase', 4, NULL),
(24317, NULL, 'IPR029012', NULL, 'Helix hairpin bin domain superfamily', 'Helix_hairpin_bin_sf', 5, NULL),
(24318, NULL, 'IPR026700', NULL, 'Coiled-coil domain-containing protein 142', 'CCDC142', 4, NULL),
(24319, NULL, 'IPR025836', NULL, 'Zinc knuckle CX2CX4HX4C', 'Zn_knuckle_CX2CX4HX4C', 3, NULL),
(24320, NULL, 'IPR032209', NULL, 'Protein of unknown function DUF5028', 'DUF5028', 4, NULL),
(24321, NULL, 'IPR024492', NULL, 'Protein of unknown function DUF2764', 'DUF2764', 4, NULL),
(24322, NULL, 'IPR031704', NULL, 'Glycosyl hydrolase family 36, N-terminal', 'Glyco_hydro_36_N', 3, NULL),
(24323, NULL, 'IPR031982', NULL, 'Type IV pilus non-core minor pilin PilE-like', 'PilE-like', 4, NULL),
(24324, NULL, 'IPR029056', NULL, 'Ribokinase-like', 'Ribokinase-like', 5, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(24325, NULL, 'IPR026059', NULL, 'Rab3GAP regulatory subunit', 'Rab3GAP2', 4, NULL),
(24326, NULL, 'IPR031850', NULL, 'Fungal kinase associated-1 domain', 'Fungal_KA1_dom', 3, NULL),
(24327, NULL, 'IPR031719', NULL, 'Condensin II complex subunit H2, middle domain', 'H2_M', 3, NULL),
(24328, NULL, 'IPR032216', NULL, 'Protein of unknown function DUF5035', 'DUF5035', 4, NULL),
(24329, NULL, 'IPR030923', NULL, 'LPS export ABC transporter permease LptG', 'LptG', 4, NULL),
(24330, NULL, 'IPR031437', NULL, 'Transmembrane protein family 132, middle domain', 'TMEM132_M', 3, NULL),
(24331, NULL, 'IPR031307', NULL, 'Ninja family', 'Ninja_fam', 4, NULL),
(24332, NULL, 'IPR025502', NULL, 'TldD', 'TldD', 4, NULL),
(24333, NULL, 'IPR029001', NULL, 'Inosine triphosphate pyrophosphatase-like', 'ITPase-like_fam', 5, NULL),
(24334, NULL, 'IPR031402', NULL, 'Protein LYRIC', 'LYRIC', 4, NULL),
(24335, NULL, 'IPR031692', NULL, 'EH domain-containing protein, N-terminal', 'EHD_N', 3, NULL),
(24336, NULL, 'IPR029040', NULL, 'RNA polymerase subunit RPABC4/transcription elongation factor Spt4', 'RPABC4/Spt4', 5, NULL),
(24337, NULL, 'IPR025576', NULL, 'YwiC-like protein', 'YwiC', 4, NULL),
(24338, NULL, 'IPR025850', NULL, 'SUKH-3 immunity protein', 'SUKH-3', 4, NULL),
(24339, NULL, 'IPR027963', NULL, 'Meiosis-specific coiled-coil domain-containing protein MEIOC', 'MEIOC', 4, NULL),
(24340, NULL, 'IPR026768', NULL, 'Protein FAM72', 'FAM72', 4, NULL),
(24341, NULL, 'IPR025959', NULL, 'Winged helix-turn helix domain', 'Winged_HTH_dom', 3, NULL),
(24342, NULL, 'IPR028796', NULL, 'Tetratricopeptide repeat protein 8', 'BBS8', 4, NULL),
(24343, NULL, 'IPR035953', NULL, 'Dextranase, N-terminal', 'Dextranase_N-ter', 5, NULL),
(24344, NULL, 'IPR027942', NULL, 'Sieve element occlusion, N-terminal', 'SEO_N', 3, NULL),
(24345, NULL, 'IPR025665', NULL, 'Outer membrane protein beta-barrel domain 2', 'OMP_b-brl_2', 3, NULL),
(24346, NULL, 'IPR026435', NULL, 'Cys-rich repeat, Myxococcales-type', 'Myxo_Cys_rpt', 7, NULL),
(24347, NULL, 'IPR027350', NULL, 'Glycosyltransferase family 23 (GT23) domain', 'GT23_dom', 3, NULL),
(24348, NULL, 'IPR025853', NULL, 'Bd3614-like deaminase', 'NH3ase_Bd3614-like', 4, NULL),
(24349, NULL, 'IPR024499', NULL, 'Mbeg1-like', 'Mbeg1-like', 4, NULL),
(24350, NULL, 'IPR028975', NULL, 'Diol dehydratase-reactivating factor,  alpha subunit, swiveling domain superfamily', 'DDRA_swiveling_dom_sf', 5, NULL),
(24351, NULL, 'IPR031392', NULL, 'Spindle pole component 29', 'Spc29', 4, NULL),
(24352, NULL, 'IPR029035', NULL, 'DHS-like NAD/FAD-binding domain superfamily', 'DHS-like_NAD/FAD-binding_dom', 5, NULL),
(24353, NULL, 'IPR026759', NULL, 'Putative monooxygenase p33MONOX', 'P33MONOX', 4, NULL),
(24354, NULL, 'IPR025854', NULL, 'Bd3614-like deaminase, N-terminal', 'NH3ase_Bd3614-like_N_dom', 3, NULL),
(24355, NULL, 'IPR031211', NULL, 'Nestin', 'Nestin', 4, NULL),
(24356, NULL, 'IPR026695', NULL, 'Coiled-coil domain-containing protein 71/71L', 'Ccdc71/71L', 4, NULL),
(24357, NULL, 'IPR030875', NULL, 'Sulfoquinovose isomerase', 'SQ_isomerase', 4, NULL),
(24358, NULL, 'IPR031375', NULL, 'Penicillin-binding protein, N-terminal', 'PBP_N', 3, NULL),
(24359, NULL, 'IPR032602', NULL, 'Protein of unknown function DUF4899', 'DUF4899', 4, NULL),
(24360, NULL, 'IPR032875', NULL, 'Succinyl-CoA synthetase-like, flavodoxin domain', 'Succ_CoA_lig_flav_dom', 3, NULL),
(24361, NULL, 'IPR027370', NULL, 'Zinc finger, RING-type, eukaryotic', 'Znf-RING_euk', 3, NULL),
(24362, NULL, 'IPR032210', NULL, 'Protein of unknown function DUF5029', 'DUF5029', 4, NULL),
(24363, NULL, 'IPR032018', NULL, 'Putative lipoprotein, pathogenic bacteria', 'LppA/LppB/LprP', 4, NULL),
(24364, NULL, 'IPR025846', NULL, 'Trichome birefringence-like, N-terminal domain', 'TBL_N', 3, NULL),
(24365, NULL, 'IPR031693', NULL, 'Sin3, C-terminal', 'Sin3_C', 3, NULL),
(24366, NULL, 'IPR025655', NULL, 'Peroxisomal membrane protein 14', 'PEX14', 4, NULL),
(24367, NULL, 'IPR031553', NULL, 'Lysyl-tRNA synthetase, N-terminal transmembrane region', 'tRNA-synt_2_TM', 3, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(24368, NULL, 'IPR031381', NULL, 'YtcA family', 'YtcA', 4, NULL),
(24369, NULL, 'IPR031852', NULL, 'Spindle pole body-associated protein Vik1/Cik1, microtubule binding domain', 'Vik1/Cik1_MT-bd', 3, NULL),
(24370, NULL, 'IPR025855', NULL, 'Plasmid replication-relaxation', 'Replic_Relax', 4, NULL),
(24371, NULL, 'IPR031717', NULL, 'Multifunctional 2-oxoglutarate metabolism enzyme, C-terminal', 'KGD_C', 3, NULL),
(24372, NULL, 'IPR026749', NULL, 'Transmembrane protein 135', 'Tmem135', 4, NULL),
(24373, NULL, 'IPR031703', NULL, 'Lipin, middle domain', 'Lipin_mid', 3, NULL),
(24374, NULL, 'IPR027967', NULL, 'Protein of unknown function DUF4612', 'DUF4612', 4, NULL),
(24375, NULL, 'IPR024498', NULL, 'Domain of unknown function DUF2786', 'DUF2786', 3, NULL),
(24376, NULL, 'IPR024497', NULL, 'Protein of unknown function DUF2773', 'DUF2773', 4, NULL),
(24377, NULL, 'IPR031543', NULL, 'Protein of unknown function DUF5087', 'DUF5087', 4, NULL),
(24378, NULL, 'IPR030976', NULL, 'Putative modified peptide', 'Mod_pep_NH_fam', 4, NULL),
(24379, NULL, 'IPR025847', NULL, 'MEDS domain', 'MEDS_domain', 3, NULL),
(24380, NULL, 'IPR031732', NULL, 'Protein of unknown function DUF4729', 'DUF4729', 4, NULL),
(24381, NULL, 'IPR024790', NULL, 'Anaphase-promoting complex subunit 4 long domain', 'APC4_long_dom', 3, NULL),
(24382, NULL, 'IPR031690', NULL, 'Protein of unknown function DUF5079', 'DUF5079', 4, NULL),
(24383, NULL, 'IPR024391', NULL, 'LDB19, N-terminal', 'LDB19_N', 3, NULL),
(24384, NULL, 'IPR027480', NULL, 'HIV-1 Nef protein, anchor domain superfamily', 'HIV-1_Nef_anchor_sf', 5, NULL),
(24385, NULL, 'IPR031374', NULL, 'Uncharacterised protein family UPF0715', 'UPF0715', 4, NULL),
(24386, NULL, 'IPR025965', NULL, 'FlgD Ig-like domain', 'FlgD_Ig', 3, NULL),
(24387, NULL, 'IPR026765', NULL, 'Transmembrane protein 163', 'Tmem163', 4, NULL),
(24388, NULL, 'IPR030979', NULL, 'Fluorothreonine transaldolase', 'F_threo_transal', 4, NULL),
(24389, NULL, 'IPR030925', NULL, 'Type II secretion system protein GspN, Leptospira-type', 'T2SS_GspN_Lepto', 4, NULL),
(24390, NULL, 'IPR032603', NULL, 'Protein of unknown function DUF4898', 'DUF4898', 4, NULL),
(24391, NULL, 'IPR032204', NULL, 'Protein of unknown function DUF5023', 'DUF5023', 4, NULL),
(24392, NULL, 'IPR031712', NULL, 'Domain of unknown function DUF5077', 'DUF5077', 3, NULL),
(24393, NULL, 'IPR029710', NULL, 'DNA ligase 4', 'LIG4', 4, NULL),
(24394, NULL, 'IPR031691', NULL, 'Lipoyl synthase, N-terminal', 'LIAS_N', 3, NULL),
(24395, NULL, 'IPR026755', NULL, 'Protein FAM221A/B', 'Fam221a/b', 4, NULL),
(24396, NULL, 'IPR027916', NULL, 'Protein kinase-like domain, Apicomplexa', 'Kinase-like_dom_Apicomplexa', 3, NULL),
(24397, NULL, 'IPR031701', NULL, 'Homeobox protein SIX1, N-terminal SD domain', 'SIX1_SD', 3, NULL),
(24398, NULL, 'IPR027367', NULL, 'YMGG-like Gly-zipper', 'Gly-zipper_YMGG', 3, NULL),
(24399, NULL, 'IPR027310', NULL, 'Profilin conserved site', 'Profilin_CS', 2, NULL),
(24400, NULL, 'IPR028823', NULL, 'Sodium leak channel NALCN', 'NALCN', 4, NULL),
(24401, NULL, 'IPR034041', NULL, 'STABLE peptidase domain', 'STABLE_peptidase', 3, NULL),
(24402, NULL, 'IPR024500', NULL, 'Domain of unknown function DUF3074', 'DUF3074', 3, NULL),
(24403, NULL, 'IPR031555', NULL, 'DNA-directed RNA polymerase subunit Rpo8', 'RNA_pol_Rpo8', 4, NULL),
(24404, NULL, 'IPR032452', NULL, 'Sodium/calcium exchanger domain, C-terminal extension', 'Na_Ca_Ex_C-exten', 3, NULL),
(24405, NULL, 'IPR031733', NULL, 'Dynein attachment factor, N-terminal', 'Dynein_attach_N', 3, NULL),
(24406, NULL, 'IPR025851', NULL, 'SUKH-4 immunity protein', 'SUKH-4', 4, NULL),
(24407, NULL, 'IPR026060', NULL, 'Associate of Myc 1', 'AMY1', 4, NULL),
(24408, NULL, 'IPR025526', NULL, 'DsrC-like domain superfamily', 'DsrC-like_dom_sf', 5, NULL),
(24409, NULL, 'IPR027935', NULL, 'Protein dehydration-induced 19, C-terminal', 'Di19_C', 3, NULL),
(24410, NULL, 'IPR024503', NULL, 'Protein of unknown function DUF3196', 'DUF3196', 4, NULL),
(24411, NULL, 'IPR027936', NULL, 'Ephrin receptor, transmembrane domain', 'Eph_TM', 3, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(24412, NULL, 'IPR028045', NULL, 'Homologous recombination OB-fold protein', 'HROB', 4, NULL),
(24413, NULL, 'IPR026044', NULL, 'Membrane-bound lytic murein transglycosylase A', 'MltA', 4, NULL),
(24414, NULL, 'IPR031702', NULL, 'Protein of unknown function DUF5078', 'DUF5078', 4, NULL),
(24415, NULL, 'IPR025849', NULL, 'AF2226-like SPOUT RNA methylase fused to THUMP', 'SPOUT_MTase_fused_to_THUMP', 4, NULL),
(24416, NULL, 'IPR025826', NULL, 'Cob(I)alamin adenosyltransferase N-terminal domain', 'Co_AT_N_dom', 3, NULL),
(24417, NULL, 'IPR025940', NULL, 'Toxin SpoIISA, type II toxin-antitoxin system', 'SpoIISA_toxin', 4, NULL),
(24418, NULL, 'IPR024496', NULL, 'Spore germination protein GerPE', 'Spore_germ_GerPE', 4, NULL),
(24419, NULL, 'IPR032012', NULL, 'Stomatal closure-related actin-binding protein, actin-binding domain', 'SCAB-ABD', 3, NULL),
(24420, NULL, 'IPR032900', NULL, 'PanD regulatory factor PanZ', 'PanZ', 4, NULL),
(24421, NULL, 'IPR032392', NULL, 'SATB, ubiquitin-like oligomerisation domain', 'ULD', 3, NULL),
(24422, NULL, 'IPR027946', NULL, 'Oligogalacturonate lyase domain', 'Ogl_dom', 3, NULL),
(24423, NULL, 'IPR031432', NULL, 'MALE GAMETOPHYTE DEFECTIVE 1', 'MGP1', 4, NULL),
(24424, NULL, 'IPR026703', NULL, 'Glutamate-rich protein 2', 'ERICH2', 4, NULL),
(24425, NULL, 'IPR031707', NULL, 'Putative abortive phage resistance protein AbiGii toxin', 'AbiGii_2', 4, NULL),
(24426, NULL, 'IPR031385', NULL, 'Small capsid protein, Herpesviridae', 'HV_small_capsid', 4, NULL),
(24427, NULL, 'IPR028976', NULL, 'CheC-like superfamily', 'CheC-like_sf', 5, NULL),
(24428, NULL, 'IPR027968', NULL, 'Jhy protein', 'JHY', 4, NULL),
(24429, NULL, 'IPR028044', NULL, 'Domain of unknown function DUF4444', 'DUF4444', 3, NULL),
(24430, NULL, 'IPR027304', NULL, 'Trigger factor/SurA domain superfamily', 'Trigger_fact/SurA_dom_sf', 5, NULL),
(24431, NULL, 'IPR025552', NULL, 'YkyB-like protein', 'YkyB', 4, NULL),
(24432, NULL, 'IPR032447', NULL, 'Cyclin-A, N-terminal APC/C binding region', 'Cyclin-A_N', 3, NULL),
(24433, NULL, 'IPR031560', NULL, 'Heavy-metal resistance protein CzcE', 'CzcE', 4, NULL),
(24434, NULL, 'IPR024789', NULL, 'Anaphase-promoting complex subunit 4', 'APC4', 4, NULL),
(24435, NULL, 'IPR031386', NULL, 'Unique cartilage matrix-associated protein', 'UCMA', 4, NULL),
(24436, NULL, 'IPR031803', NULL, 'Bacterioopsin transcriptional activator, GAF and HTH associated domain', 'BAT_GAF/HTH-assoc', 3, NULL),
(24437, NULL, 'IPR025834', NULL, 'Topoisomerase I C-terminal domain', 'TopoI_C_dom', 3, NULL),
(24438, NULL, 'IPR027033', NULL, 'Cytidine monophosphate-N-acetylneuraminic acid hydroxylase', 'Cnh', 4, NULL),
(24439, NULL, 'IPR030982', NULL, 'Electron transfer flavoprotein, mycofactocin-associated', 'Mft_EtfB', 4, NULL),
(24440, NULL, 'IPR032450', NULL, 'SMARCC, N-terminal', 'SMARCC_N', 3, NULL),
(24441, NULL, 'IPR032899', NULL, 'Cell division protein DamX', 'DamX', 4, NULL),
(24442, NULL, 'IPR027951', NULL, 'Nucleolus and neural progenitor protein-like, N-terminal domain', 'Nepro_N', 3, NULL),
(24443, NULL, 'IPR025828', NULL, 'Putative sensor domain', 'Put_sensor_dom', 3, NULL),
(24444, NULL, 'IPR026705', NULL, 'Hid-1/Ecm30', 'Hid-1/Ecm30', 4, NULL),
(24445, NULL, 'IPR028043', NULL, 'ATPase PAAT-like', 'PAAT-like', 4, NULL),
(24446, NULL, 'IPR029055', NULL, 'Nucleophile aminohydrolases, N-terminal', 'Ntn_hydrolases_N', 5, NULL),
(24447, NULL, 'IPR027900', NULL, 'Vexin domain', 'Vexin_dom', 3, NULL),
(24448, NULL, 'IPR032084', NULL, 'Domain of unknown function DUF4812', 'DUF4812', 3, NULL),
(24449, NULL, 'IPR025785', NULL, 'Actin-histidine N-methyltransferase SETD3', 'SETD3', 4, NULL),
(24450, NULL, 'IPR035948', NULL, 'YwqG-like superfamily', 'YwqG-like_sf', 5, NULL),
(24451, NULL, 'IPR032395', NULL, 'Sf6-type phage tail needle knob', 'Phage_tail_NK', 3, NULL),
(24452, NULL, 'IPR027898', NULL, 'Domain of unknown function DUF4629', 'DUF4629', 3, NULL),
(24453, NULL, 'IPR024442', NULL, 'Transposase, zinc-ribbon', 'Transposase_Zn_ribbon', 3, NULL),
(24454, NULL, 'IPR029033', NULL, 'Histidine phosphatase superfamily', 'His_PPase_superfam', 5, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(24455, NULL, 'IPR031391', NULL, 'Nucleolar protein Swm2', 'Swm2', 4, NULL),
(24456, NULL, 'IPR032596', NULL, 'Domain of unknown function DUF4904', 'DUF4904', 3, NULL),
(24457, NULL, 'IPR025889', NULL, 'General stress protein 17M-like domain', 'GSP17M-like_dom', 3, NULL),
(24458, NULL, 'IPR024493', NULL, 'Fumarase D', 'FumD', 4, NULL),
(24459, NULL, 'IPR032226', NULL, 'TNRC6, PABC binding domain', 'TNRC6_PABC-bd', 3, NULL),
(24460, NULL, 'IPR029289', NULL, 'Coordinator of PRMT5 and differentiation stimulator', 'COPR5', 4, NULL),
(24461, NULL, 'IPR032201', NULL, 'Transcription factor COE, helix-loop-helix domain', 'COE_HLH', 3, NULL),
(24462, NULL, 'IPR025780', NULL, 'Histone-lysine N-methyltransferase ATX', 'Hist-Lys_N-MeTrfase_ATX', 4, NULL),
(24463, NULL, 'IPR026069', NULL, 'Fuzzy protein', 'Fuzzy', 4, NULL),
(24464, NULL, 'IPR024494', NULL, 'Protein of unknown function DUF2770', 'DUF2770', 4, NULL),
(24465, NULL, 'IPR027351', NULL, '(+) RNA virus helicase core domain', '(+)RNA_virus_helicase_core_dom', 3, NULL),
(24466, NULL, 'IPR031376', NULL, 'Penicillin-binding protein, OB-like domain', 'PCB_OB', 3, NULL),
(24467, NULL, 'IPR031802', NULL, 'FAM193, C-terminal', 'FAM193_C', 3, NULL),
(24468, NULL, 'IPR034016', NULL, 'Aminopeptidase N-type', 'M1_APN-typ', 4, NULL),
(24469, NULL, 'IPR031551', NULL, 'Accessory secretory protein Asp4', 'Asp4', 4, NULL),
(24470, NULL, 'IPR032206', NULL, 'Protein of unknown function DUF5025', 'DUF5025', 4, NULL),
(24471, NULL, 'IPR024395', NULL, 'CLASP N-terminal domain', 'CLASP_N_dom', 3, NULL),
(24472, NULL, 'IPR031799', NULL, 'C2H2-type zinc ribbon', 'Znf-C2H2_ribbon', 3, NULL),
(24473, NULL, 'IPR027979', NULL, 'Protein of unknown function DUF4655', 'DUF4655', 4, NULL),
(24474, NULL, 'IPR030811', NULL, 'Quinoprotein relay system zinc metallohydrolase 1', 'SoxH-rel_PQQ_1', 4, NULL),
(24475, NULL, 'IPR032014', NULL, 'Vibrio phage CTXphi pIII, N-terminal N1 domain', 'CTXphi_pIII-N1', 3, NULL),
(24476, NULL, 'IPR032213', NULL, 'Protein of unknown function DUF5032', 'DUF5032', 4, NULL),
(24477, NULL, 'IPR032218', NULL, 'Protein of unknown function DUF5037', 'DUF5037', 4, NULL),
(24478, NULL, 'IPR031976', NULL, 'Rhomboid protease, N-terminal', 'NRho', 3, NULL),
(24479, NULL, 'IPR032262', NULL, 'Zinc-regulated secreted antivirulence protein, C-terminal', 'ZirS_C', 3, NULL),
(24480, NULL, 'IPR024450', NULL, 'Domain of unknown function DUF3874', 'DUF3874', 3, NULL),
(24481, NULL, 'IPR032369', NULL, 'Domain of unknown function DUF4872', 'DUF4872', 3, NULL),
(24482, NULL, 'IPR029765', NULL, 'Diphosphomevalonate decarboxylase', 'Mev_diP_decarb', 4, NULL),
(24483, NULL, 'IPR031383', NULL, 'Uncharacterised protein ycf90', 'Ycf90', 4, NULL),
(24484, NULL, 'IPR025841', NULL, 'Circularly permuted ATP-grasp type 2', 'CP_ATPgrasp_2', 4, NULL),
(24485, NULL, 'IPR025577', NULL, 'FlxA-like protein', 'FlxA', 4, NULL),
(24486, NULL, 'IPR031384', NULL, 'Herpesvirus US34A protein family', 'HHV-5_US34A', 4, NULL),
(24487, NULL, 'IPR026756', NULL, 'Nucleolar and spindle-associated protein 1', 'NuSAP', 4, NULL),
(24488, NULL, 'IPR024441', NULL, 'Mating-type protein, C-terminal domain', 'Homeodomain1_C', 3, NULL),
(24489, NULL, 'IPR030981', NULL, 'SDR family mycofactocin-dependent oxidoreductase', 'SDR_subfam_2', 4, NULL),
(24490, NULL, 'IPR031541', NULL, 'HTH-like domain-containing protein, Microsporidia', 'HTH_micro', 4, NULL),
(24491, NULL, 'IPR025831', NULL, 'ATP-dependent DNA helicase RecG, C-terminal domain', 'RecG_C', 3, NULL),
(24492, NULL, 'IPR032597', NULL, 'Protein of unknown function DUF4903', 'DUF4903', 4, NULL),
(24493, NULL, 'IPR025838', NULL, 'Inactive transglutaminase fused to 7 transmembrane helices', 'Transglut_i_TM', 3, NULL),
(24494, NULL, 'IPR027934', NULL, 'Cellulose synthase, RING-type zinc finger', 'CES_Znf_RING', 3, NULL),
(24495, NULL, 'IPR026065', NULL, 'SIN3-HDAC complex-associated factor', 'FAM60A', 4, NULL),
(24496, NULL, 'IPR031548', NULL, 'Accessory secretory protein Asp5', 'Asp5', 4, NULL),
(24497, NULL, 'IPR032202', NULL, 'Family of unknown function DUF5021', 'DUF5021', 4, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(24498, NULL, 'IPR024491', NULL, 'Selenoprotein SelK/SelG', 'Se_SelK/SelG', 4, NULL),
(24499, NULL, 'IPR034777', NULL, 'Nop12, RNA recognition motif 1', 'Nop12_RRM1', 3, NULL),
(24500, NULL, 'IPR031846', NULL, 'Voltage-gated hydrogen channel 1', 'Hvcn1', 4, NULL),
(24501, NULL, 'IPR029713', NULL, 'Transmembrane protein 168', 'TMEM168', 4, NULL),
(24502, NULL, 'IPR025694', NULL, 'Mitochondrial splicing apparatus component MNE1', 'MNE1', 4, NULL),
(24503, NULL, 'IPR028946', NULL, 'Bacterial toxin 44', 'Ntox44', 3, NULL),
(24504, NULL, 'IPR026358', NULL, 'Substrate-binding orphan protein, GRRM family', 'Orph_peri_GRRM', 4, NULL),
(24505, NULL, 'IPR025921', NULL, 'HmuY protein', 'HmuY', 4, NULL),
(24506, NULL, 'IPR028904', NULL, 'Tox-REase-5 domain', 'Tox-REase-5_dom', 3, NULL),
(24507, NULL, 'IPR024339', NULL, 'Protein of unknown function DUF3836', 'DUF3836', 4, NULL),
(24508, NULL, 'IPR028098', NULL, 'Glycosyltransferase subfamily 4-like, N-terminal domain', 'Glyco_trans_4-like_N', 3, NULL),
(24509, NULL, 'IPR027991', NULL, 'Domain of unknown function DUF4488', 'DUF4488', 3, NULL),
(24510, NULL, 'IPR027381', NULL, 'LytR/CpsA/Psr regulator, C-terminal domain', 'LytR/CpsA/Psr_C', 3, NULL),
(24511, NULL, 'IPR028172', NULL, 'Intraflagellar transport protein 20', 'FT20', 4, NULL),
(24512, NULL, 'IPR025701', NULL, 'Ubiquitin-conjugating enzyme, E2, family E', 'UBQ-conjugat_E2_E', 4, NULL),
(24513, NULL, 'IPR024336', NULL, 'tRNA-splicing endonuclease, subunit Sen54, N-terminal', 'tRNA_splic_suSen54_N', 3, NULL),
(24514, NULL, 'IPR031410', NULL, 'Protein phosphatase 1 regulatory subunit 32', 'PPP1R32', 4, NULL),
(24515, NULL, 'IPR032519', NULL, 'YbgF, trimerisation domain', 'YbgF_tri', 3, NULL),
(24516, NULL, 'IPR024332', NULL, 'MOZART2 family', 'MOZART2', 4, NULL),
(24517, NULL, 'IPR026242', NULL, 'HAUS augmin-like complex subunit 2, metazoa', 'HAUS2_metazoa', 4, NULL),
(24518, NULL, 'IPR025715', NULL, 'Chromatin target of PRMT1 protein, C-terminal', 'FoP_C', 3, NULL),
(24519, NULL, 'IPR024685', NULL, 'Adenylate cyclase class-I, N-terminal domain', 'Adenylate_cyclase_1_N', 3, NULL),
(24520, NULL, 'IPR027330', NULL, 'TPX2 central domain', 'TPX2_central_dom', 3, NULL),
(24521, NULL, 'IPR024656', NULL, 'Ammonia monooxygenase, subunit A, archaeal', 'AmoA_arc', 4, NULL),
(24522, NULL, 'IPR027403', NULL, 'Delta antigen, N-terminal', 'Delta_antigen_N', 5, NULL),
(24523, NULL, 'IPR024521', NULL, 'Domain of unknown function DUF3641', 'DUF3641', 3, NULL),
(24524, NULL, 'IPR025583', NULL, 'HMG-CoA reductase, N-terminal domain', 'HMG-CoA_N_dom', 3, NULL),
(24525, NULL, 'IPR026243', NULL, 'HAUS augmin-like complex subunit 1', 'HAUS1', 4, NULL),
(24526, NULL, 'IPR029095', NULL, 'NarX-like, N-terminal', 'NarX-like_N', 3, NULL),
(24527, NULL, 'IPR026541', NULL, 'MRG domain', 'MRG_dom', 3, NULL),
(24528, NULL, 'IPR026334', NULL, 'FXSXX-COOH protein', 'FxSxx-COOH', 4, NULL),
(24529, NULL, 'IPR024514', NULL, 'Domain of unknown function DUF3388', 'DUF3388', 3, NULL),
(24530, NULL, 'IPR029409', NULL, 'Transmembrane protein 237', 'TMEM237', 4, NULL),
(24531, NULL, 'IPR031937', NULL, 'PNN-interacting serine/arginine-rich protein', 'PNISR', 4, NULL),
(24532, NULL, 'IPR028948', NULL, 'Bacterial toxin 28', 'Ntox28', 3, NULL),
(24533, NULL, 'IPR027107', NULL, 'Tuberin/Ral GTPase-activating protein subunit alpha', 'Tuberin/Ral-act_asu', 4, NULL),
(24534, NULL, 'IPR027746', NULL, 'Probable tubulin-tyrosine ligase', 'TTL', 4, NULL),
(24535, NULL, 'IPR024519', NULL, 'Inverse autotransporter, beta-domain', 'IAT_beta', 3, NULL),
(24536, NULL, 'IPR024532', NULL, 'Protein of unknown function DUF3830', 'DUF3830', 4, NULL),
(24537, NULL, 'IPR026338', NULL, 'NDMA-dependent methanol dehydrogenase', 'NDMA_methanol_DH', 4, NULL),
(24538, NULL, 'IPR026363', NULL, 'CxxC-x17-CxxC domain', 'CxxC-x17-CxxC_dom', 3, NULL),
(24539, NULL, 'IPR027249', NULL, 'DNA-directed DNA/RNA polymerase mu', 'DNA/RNApol_mu', 4, NULL),
(24540, NULL, 'IPR029099', NULL, 'Ribose-phosphate pyrophosphokinase, N-terminal domain', 'Pribosyltran_N', 3, NULL),
(24541, NULL, 'IPR028113', NULL, 'Protein of unknown function DUF4624', 'DUF4624', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(24542, NULL, 'IPR025956', NULL, 'Cytoplasmic dynein 1 intermediate chain 1/2', 'DYNC1I1/DYNC1I2', 4, NULL),
(24543, NULL, 'IPR024538', NULL, 'Protein of unknown function DUF3878', 'DUF3878', 4, NULL),
(24544, NULL, 'IPR028913', NULL, 'Tox-MPTase3 domain', 'Tox-MPTase3_dom', 3, NULL),
(24545, NULL, 'IPR025933', NULL, 'Beta-defensin', 'Beta_defensin', 3, NULL),
(24546, NULL, 'IPR031934', NULL, 'Protein of unknown function DUF4769', 'DUF4769', 4, NULL),
(24547, NULL, 'IPR031936', NULL, 'Domain of unknown function DUF4771', 'DUF4771', 3, NULL),
(24548, NULL, 'IPR030661', NULL, 'SUMO-activating enzyme subunit Uba2', 'Uba2', 4, NULL),
(24549, NULL, 'IPR035920', NULL, 'YhbY-like superfamily', 'YhbY-like_sf', 5, NULL),
(24550, NULL, 'IPR028966', NULL, 'Immunity protein 72', 'Imm72', 3, NULL),
(24551, NULL, 'IPR027522', NULL, 'Probable alanine--tRNA ligase, plants', 'Ala_tRNA_synth_plant', 4, NULL),
(24552, NULL, 'IPR025693', NULL, 'Glycine-zipper-containing OmpA-like membrane domain', 'Gly-zipper_OmpA-like_dom', 3, NULL),
(24553, NULL, 'IPR025931', NULL, 'TaqI-like C-terminal specificity domain', 'TaqI_C', 3, NULL),
(24554, NULL, 'IPR025679', NULL, 'Immunity protein Imm2', 'Imm2', 4, NULL),
(24555, NULL, 'IPR025923', NULL, 'YodL-like', 'YodL-like', 4, NULL),
(24556, NULL, 'IPR026276', NULL, 'Baseplate protein GpP', 'Baseplate_GpP', 4, NULL),
(24557, NULL, 'IPR026367', NULL, 'FxsC C-terminal domain', 'FxsC_C_dom', 3, NULL),
(24558, NULL, 'IPR024319', NULL, 'ATPase expression protein 2, mitochondrial', 'ATPase_expression_mit', 4, NULL),
(24559, NULL, 'IPR029104', NULL, 'Retro-transcribing virus envelope glycoprotein', 'HERV-K_env', 3, NULL),
(24560, NULL, 'IPR026038', NULL, 'Putative phosphatidylglycerophosphatase', 'Put_PGPase', 4, NULL),
(24561, NULL, 'IPR024684', NULL, 'Transcriptional activator PerC/bacteriophage SfV Orf40', 'Tscrpt_act_PerC/SfV_Orf40', 4, NULL),
(24562, NULL, 'IPR029646', NULL, 'Calretinin', 'CALB2', 4, NULL),
(24563, NULL, 'IPR026250', NULL, 'Inositol 1,4,5-trisphosphate receptor-interacting protein family', 'ITPRIP_fam', 4, NULL),
(24564, NULL, 'IPR027165', NULL, 'Condensin complex subunit 3', 'CND3', 4, NULL),
(24565, NULL, 'IPR025718', NULL, 'Histone deacetylase complex subunit SAP30, Sin3 binding domain', 'SAP30_Sin3-bd', 3, NULL),
(24566, NULL, 'IPR027389', NULL, 'Beta-1,4-mannosyltransferase Bre-3/Egh', 'B_mannosylTrfase_Bre-3/Egh', 4, NULL),
(24567, NULL, 'IPR030662', NULL, 'Diphthine--ammonia ligase/Uncharacterised protein MJ0570', 'DPH6/MJ0570', 4, NULL),
(24568, NULL, 'IPR024340', NULL, 'Sec16, central conserved domain', 'Sec16_CCD', 3, NULL),
(24569, NULL, 'IPR025932', NULL, 'Trypanosome variant surface glycoprotein, B-type, N-terminal domain', 'Trypano_VSG_B_N_dom', 3, NULL),
(24570, NULL, 'IPR031854', NULL, 'Putative membrane protein FidL-like', 'FidL-like', 4, NULL),
(24571, NULL, 'IPR025634', NULL, 'Protein of unknown function DUF4292', 'DUF4292', 4, NULL),
(24572, NULL, 'IPR024527', NULL, 'Eisosome protein 1', 'Eisosome1', 4, NULL),
(24573, NULL, 'IPR026203', NULL, 'Intracellular hyaluronic acid binding protein', 'IHABP', 4, NULL),
(24574, NULL, 'IPR027471', NULL, 'YbeD-like domain superfamily', 'YbeD-like_sf', 5, NULL),
(24575, NULL, 'IPR029299', NULL, 'ALMS motif', 'ALMS_motif', 3, NULL),
(24576, NULL, 'IPR029067', NULL, 'CDC48 domain 2-like superfamily', 'CDC48_domain_2-like_sf', 5, NULL),
(24577, NULL, 'IPR025706', NULL, 'Endo-alpha-N-acetylgalactosaminidase', 'Endoa_GalNAc', 3, NULL),
(24578, NULL, 'IPR029306', NULL, 'E3 ubiquitin-protein ligase Arkadia, N-terminal', 'RNF111_N', 3, NULL),
(24579, NULL, 'IPR026087', NULL, 'Corneodesmosin', 'Corneodesmosin', 4, NULL),
(24580, NULL, 'IPR026021', NULL, 'Putative NAD(P)H nitroreductase YdjA-like', 'YdjA-like', 4, NULL),
(24581, NULL, 'IPR028898', NULL, 'Tox-WTIP domain', 'Tox-WTIP_dom', 3, NULL),
(24582, NULL, 'IPR025635', NULL, 'Protein of unknown function DUF4293', 'DUF4293', 4, NULL),
(24583, NULL, 'IPR028909', NULL, 'Ribosomal protein L21-like', 'L21p-like', 4, NULL),
(24584, NULL, 'IPR026349', NULL, 'Conserved hypothetical protein CHP04255', 'CHP04255', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(24585, NULL, 'IPR029068', NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 'Glyas_Bleomycin-R_OHBP_Dase', 5, NULL),
(24586, NULL, 'IPR028960', NULL, 'Immunity protein 27', 'Imm27', 4, NULL),
(24587, NULL, 'IPR026040', NULL, 'Hydroxypyruvate isomerase-like', 'HyI-like', 4, NULL),
(24588, NULL, 'IPR024509', NULL, 'Anti-lipopolysaccharide factor/Scygonadin', 'Anti-LPS_factor/Scygonadin', 4, NULL),
(24589, NULL, 'IPR027398', NULL, 'SecD export protein N-terminal TM domain', 'SecD-TM', 3, NULL),
(24590, NULL, 'IPR027442', NULL, 'MAP kinase activated protein kinase, C-terminal', 'MAPKAPK_C', 5, NULL),
(24591, NULL, 'IPR024529', NULL, 'ECF transporter, substrate-specific component', 'ECF_trnsprt_substrate-spec', 4, NULL),
(24592, NULL, 'IPR030660', NULL, 'High-affinity branched-chain amino acid transport ATP-binding protein', 'ABC_branched_ATPase_LivF/BraG', 4, NULL),
(24593, NULL, 'IPR029424', NULL, 'MMS22-like, C-terminal', 'MMS22L_C', 3, NULL),
(24594, NULL, 'IPR028954', NULL, 'Immunity protein 59', 'Imm59', 4, NULL),
(24595, NULL, 'IPR026041', NULL, 'Glyoxalase ElbB', 'ElbB', 4, NULL),
(24596, NULL, 'IPR024528', NULL, 'Threonine/Serine exporter, ThrE', 'ThrE_2', 3, NULL),
(24597, NULL, 'IPR025982', NULL, 'Superinfection exclusion protein B', 'SieB', 4, NULL),
(24598, NULL, 'IPR030523', NULL, 'SH2B adapter protein', 'SH2B', 4, NULL),
(24599, NULL, 'IPR024326', NULL, 'Ribosomal RNA-processing protein 7, C-terminal domain', 'RRP7_C', 3, NULL),
(24600, NULL, 'IPR027259', NULL, 'Predicted 3-demethylubiquinone-9 3-methyltransferase, bacterial', 'MTase_demethylubiq_bac', 4, NULL),
(24601, NULL, 'IPR026340', NULL, 'Thiazole biosynthesis domain', 'Thiazole_biosynth_dom', 3, NULL),
(24602, NULL, 'IPR031510', NULL, 'Leukemia-associated protein 7', 'DLEU7', 4, NULL),
(24603, NULL, 'IPR025736', NULL, 'PucR C-terminal helix-turn-helix domain', 'PucR_C-HTH_dom', 3, NULL),
(24604, NULL, 'IPR026361', NULL, 'Extracellular matrix-binding protein Ebh domain', 'Ebh_dom', 3, NULL),
(24605, NULL, 'IPR028967', NULL, 'Immunity protein 65', 'Imm65', 4, NULL),
(24606, NULL, 'IPR027268', NULL, 'Peptidase M4/M1, CTD superfamily', 'Peptidase_M4/M1_CTD_sf', 5, NULL),
(24607, NULL, 'IPR024511', NULL, 'WD repeat-containing and planar cell polarity effector protein Fritz', 'Frtz', 4, NULL),
(24608, NULL, 'IPR027387', NULL, 'Cytochrome b/b6-like domain superfamily', 'Cytb/b6-like_sf', 5, NULL),
(24609, NULL, 'IPR029428', NULL, 'Mapk-regulated corepressor-interacting protein', 'MCRIP', 4, NULL),
(24610, NULL, 'IPR026352', NULL, 'C(7)-type cytochrome triheme domain', 'Nanowire_3heme', 3, NULL),
(24611, NULL, 'IPR025691', NULL, 'GspL periplasmic domain', 'GspL_pp_dom', 3, NULL),
(24612, NULL, 'IPR027408', NULL, 'PNPase/RNase PH domain superfamily', 'PNPase/RNase_PH_dom_sf', 5, NULL),
(24613, NULL, 'IPR026086', NULL, 'Proline-rich protein', 'Pro-rich', 4, NULL),
(24614, NULL, 'IPR025647', NULL, 'Putative component of ''biosynthetic module''', 'YceG_bac', 3, NULL),
(24615, NULL, 'IPR031935', NULL, 'Domain of unknown function DUF4770', 'DUF4770', 3, NULL),
(24616, NULL, 'IPR027065', NULL, 'Lon protease', 'Lon_Prtase', 4, NULL),
(24617, NULL, 'IPR024524', NULL, 'Protein of unknown function DUF3800', 'DUF3800', 4, NULL),
(24618, NULL, 'IPR026343', NULL, 'SynChlorMet cassette protein ScmC', 'SCM_chp_ScmC', 4, NULL),
(24619, NULL, 'IPR029072', NULL, 'YebC-like', 'YebC-like', 5, NULL),
(24620, NULL, 'IPR029390', NULL, 'AP-3 complex subunit beta, C-terminal domain', 'AP3B_C', 3, NULL),
(24621, NULL, 'IPR025695', NULL, 'DoxX-like family', 'DoxX-like', 4, NULL),
(24622, NULL, 'IPR025713', NULL, 'Motility protein B-like, N-terminal domain', 'MotB-like_N_dom', 3, NULL),
(24623, NULL, 'IPR026344', NULL, 'SynChlorMet cassette radical SAM/SPASM protein ScmE', 'SCM_rSAM_ScmE', 4, NULL),
(24624, NULL, 'IPR024475', NULL, 'Type IV conjugative transfer protein TrbJ/K, C-terminal', 'TrbJ/K_C', 3, NULL),
(24625, NULL, 'IPR026850', NULL, 'FANCL C-terminal domain', 'FANCL_C', 3, NULL),
(24626, NULL, 'IPR027328', NULL, 'Microtubule-associated protein RP/EB', 'MAPRE', 4, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(24627, NULL, 'IPR026848', NULL, 'E3 ubiquitin-protein ligase FANCL', 'Fancl', 4, NULL),
(24628, NULL, 'IPR035917', NULL, 'YjbQ-like superfamily', 'YjbQ-like_sf', 5, NULL),
(24629, NULL, 'IPR028963', NULL, 'Immunity protein 9', 'Imm9', 4, NULL),
(24630, NULL, 'IPR032518', NULL, 'Heparinase II, N-terminal', 'HepII_N', 3, NULL),
(24631, NULL, 'IPR029098', NULL, 'UDP N-acetylglucosamine O-acyltransferase, C-terminal', 'Acetyltransf_C', 3, NULL),
(24632, NULL, 'IPR028962', NULL, 'Immunity protein 10', 'Imm10', 4, NULL),
(24633, NULL, 'IPR027396', NULL, 'DsrEFH-like', 'DsrEFH-like', 5, NULL),
(24634, NULL, 'IPR029602', NULL, 'Intraflagellar transport protein 74', 'IFT74', 4, NULL),
(24635, NULL, 'IPR028320', NULL, 'RelA-associated inhibitor', 'iASPP', 4, NULL),
(24636, NULL, 'IPR034288', NULL, 'Laccase, first cupredoxin domain', 'CuRO_1_LCC', 3, NULL),
(24637, NULL, 'IPR025649', NULL, 'Protein of unknown function DUF4360', 'DUF4360', 4, NULL),
(24638, NULL, 'IPR029101', NULL, 'Sigma factor regulator, N-terminal', 'Sigma_reg_N', 3, NULL),
(24639, NULL, 'IPR029407', NULL, 'Kidney-associated antigen 1', 'KAAG1', 4, NULL),
(24640, NULL, 'IPR028950', NULL, 'Immunity protein 71', 'Imm71', 3, NULL),
(24641, NULL, 'IPR025646', NULL, 'Domain of unknown function DUF4350', 'DUF4350', 3, NULL),
(24642, NULL, 'IPR028042', NULL, 'Protein of unknown function DUF4639', 'DUF4639', 4, NULL),
(24643, NULL, 'IPR027260', NULL, 'Hyaluronidase-3', 'Hyaluronidase-3', 4, NULL),
(24644, NULL, 'IPR028905', NULL, 'Tox-REase-3 domain', 'Tox-REase-3_dom', 3, NULL),
(24645, NULL, 'IPR029296', NULL, 'Putative Bcl-2 like protein of testis', 'Bcl-2-like_put', 4, NULL),
(24646, NULL, 'IPR027478', NULL, 'Murein tetrapeptide carboxypeptidase, N-terminal', 'LdcA_N', 5, NULL),
(24647, NULL, 'IPR029394', NULL, 'AP-3 complex subunit beta 1, serine-rich domain', 'AP3B1_Ser', 3, NULL),
(24648, NULL, 'IPR024653', NULL, 'Peptidase, metallopeptidase M10/M27/M57', 'Peptidase_M10/M27/M57', 4, NULL),
(24649, NULL, 'IPR025719', NULL, 'Myelin gene regulatory factor C-terminal domain 2', 'MYRF_C2', 3, NULL),
(24650, NULL, 'IPR025709', NULL, 'Leucyl-tRNA synthetase, editing domain', 'Leu_tRNA-synth_edit', 3, NULL),
(24651, NULL, 'IPR027379', NULL, 'Cardiolipin synthase N-terminal', 'CLS_N', 3, NULL),
(24652, NULL, 'IPR026359', NULL, 'SasC/Mrp/FmtB intercellular aggregation domain', 'SasC_Mrp_aggreg_dom', 3, NULL),
(24653, NULL, 'IPR029903', NULL, 'RmlD-like substrate binding domain', 'RmlD-like-bd', 3, NULL),
(24654, NULL, 'IPR029406', NULL, 'Ewing''s tumour-associated antigen 1', 'ETAA1', 4, NULL),
(24655, NULL, 'IPR026831', NULL, 'Adenomatous polyposis coli protein', 'APC_dom', 5, NULL),
(24656, NULL, 'IPR028375', NULL, 'KA1 domain/Ssp2, C-terminal', 'KA1/Ssp2_C', 5, NULL),
(24657, NULL, 'IPR025645', NULL, 'Domain of unknown function DUF4349', 'DUF4349', 4, NULL),
(24658, NULL, 'IPR025714', NULL, 'Methyltransferase domain', 'Methyltranfer_dom', 3, NULL),
(24659, NULL, 'IPR028102', NULL, 'Protein of unknown function DUF4652', 'DUF4652', 4, NULL),
(24660, NULL, 'IPR028959', NULL, 'Immunity protein 41', 'Imm41', 4, NULL),
(24661, NULL, 'IPR029317', NULL, 'KRBA1 family repeat', 'KRBA1_rpt', 7, NULL),
(24662, NULL, 'IPR028104', NULL, 'Protein of unknown function DUF4553', 'DUF4553', 4, NULL),
(24663, NULL, 'IPR028965', NULL, 'Immunity protein 7', 'Imm7', 4, NULL),
(24664, NULL, 'IPR025644', NULL, 'Putative metallopeptidase', 'DUF4344', 4, NULL),
(24665, NULL, 'IPR028956', NULL, 'Immunity protein 51', 'Imm51', 4, NULL),
(24666, NULL, 'IPR027470', NULL, 'Cation efflux protein, cytoplasmic domain', 'Cation_efflux_CTD', 3, NULL),
(24667, NULL, 'IPR030473', NULL, 'Interleukin-6/GCSF/MGF, conserved site', 'IL6/GCSF/MGF_CS', 2, NULL),
(24668, NULL, 'IPR025650', NULL, 'Alkyldihydroxyacetonephosphate synthase', 'Alkyl-DHAP_Synthase', 4, NULL),
(24669, NULL, 'IPR027929', NULL, 'D-amino acid oxidase activator', 'DAOA', 4, NULL),
(24670, NULL, 'IPR025983', NULL, 'Cysteine-rich CPCC domain', 'Cys_rich_CPCC', 3, NULL),
(24671, NULL, 'IPR029993', NULL, 'Plant galacturonosyltransferase GAUT', 'GAUT', 4, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(24672, NULL, 'IPR030963', NULL, '3-dehydroquinate synthase family', 'DHQ_synth_fam', 4, NULL),
(24673, NULL, 'IPR028969', NULL, 'Immunity protein 52', 'Imm52', 3, NULL),
(24674, NULL, 'IPR025687', NULL, 'C4-type zinc-finger of DNA polymerase delta', 'Znf-C4pol', 3, NULL),
(24675, NULL, 'IPR028942', NULL, 'WHIM1 domain', 'WHIM1_dom', 3, NULL),
(24676, NULL, 'IPR025675', NULL, 'Immunity protein Imm5', 'Imm5', 4, NULL),
(24677, NULL, 'IPR030616', NULL, 'Aurora kinase', 'Aur', 4, NULL),
(24678, NULL, 'IPR026206', NULL, 'HAUS augmin-like complex subunit 3', 'HAUS3', 4, NULL),
(24679, NULL, 'IPR024309', NULL, 'Nuclear Testis  protein, N-terminal', 'NUT_N', 3, NULL),
(24680, NULL, 'IPR026135', NULL, 'Uncharacterised protein C6orf15', 'C6orf15', 4, NULL),
(24681, NULL, 'IPR024515', NULL, 'Protein of unknown function DUF3397', 'DUF3397', 4, NULL),
(24682, NULL, 'IPR029293', NULL, 'Rad9, Rad1, Hus1-interacting nuclear orphan protein 1', 'RHNO1', 4, NULL),
(24683, NULL, 'IPR030954', NULL, 'Putative PLP-dependent aminotransferase', 'PLP_IMCC1989', 4, NULL),
(24684, NULL, 'IPR024470', NULL, 'Protein of unknown function DUF2545', 'DUF2545', 4, NULL),
(24685, NULL, 'IPR027272', NULL, 'Piezo family', 'Piezo', 4, NULL),
(24686, NULL, 'IPR027513', NULL, 'RNA-splicing ligase RtcB homologue, eukaryotic', 'RtcB_euk', 4, NULL),
(24687, NULL, 'IPR025648', NULL, 'Protein of unknown function DUF4358', 'DUF4358', 4, NULL),
(24688, NULL, 'IPR028099', NULL, 'Protein of unknown function DUF4577', 'DUF4577', 4, NULL),
(24689, NULL, 'IPR027474', NULL, 'L-asparaginase, N-terminal', 'L-asparaginase_N', 3, NULL),
(24690, NULL, 'IPR026847', NULL, 'Vacuolar protein sorting-associated protein 13', 'VPS13', 4, NULL),
(24691, NULL, 'IPR027790', NULL, 'S-adenosylmethionine synthase', 'AdoMet_synthase_2_family', 4, NULL),
(24692, NULL, 'IPR028096', NULL, 'EfeO-type cupredoxin-like domain', 'EfeO_Cupredoxin', 3, NULL),
(24693, NULL, 'IPR027251', NULL, 'Diacylglycerol O-acyltransferase 1', 'Diacylglycerol_acylTrfase1', 4, NULL),
(24694, NULL, 'IPR026274', NULL, 'tRNA wybutosine synthesizing protein 2', 'tRNA_wybutosine_synth_prot_2', 4, NULL),
(24695, NULL, 'IPR027986', NULL, 'T-cell activation inhibitor, mitochondrial', 'TCAIM', 4, NULL),
(24696, NULL, 'IPR027984', NULL, 'TMEM95 family', 'TMEM95', 4, NULL),
(24697, NULL, 'IPR025643', NULL, 'ATP-grasp domain, R2K clade family 3', 'R2K_3', 3, NULL),
(24698, NULL, 'IPR030514', NULL, 'Stathmin, conserved site', 'Stathmin_CS', 2, NULL),
(24699, NULL, 'IPR026015', NULL, 'F1F0 ATP synthase OSCP/delta subunit, N-terminal domain superfamily', 'ATP_synth_OSCP/delta_N_sf', 5, NULL),
(24700, NULL, 'IPR026373', NULL, 'Seadornavirus VP5/VP6 protein', 'VP5/VP6', 4, NULL),
(24701, NULL, 'IPR025601', NULL, 'ATP-binding sugar transporter-like protein', 'ATP-bd_sugar_transptr-like', 4, NULL),
(24702, NULL, 'IPR024526', NULL, 'Protein of unknown function DUF3807', 'DUF3807', 4, NULL),
(24703, NULL, 'IPR028899', NULL, 'Tox-URI2 domain', 'Tox-URI2_dom', 3, NULL),
(24704, NULL, 'IPR026247', NULL, 'Endothelial cell-specific chemotaxis regulator', 'ECSCR', 4, NULL),
(24705, NULL, 'IPR028108', NULL, 'Protein of unknown function DUF4505', 'DUF4505', 4, NULL),
(24706, NULL, 'IPR024654', NULL, 'Calcineurin-like phosphoesterase domain, lpxH-type', 'Calcineurin-like_PHP_lpxH', 3, NULL),
(24707, NULL, 'IPR026025', NULL, 'Fatty acid synthase alpha subunit, yeast', 'FAS_alpha_yeast', 4, NULL),
(24708, NULL, 'IPR030957', NULL, 'Putative sugar phosphate phospholyase (cyclising)', 'Put_AroB', 4, NULL),
(24709, NULL, 'IPR026348', NULL, 'Putative globular PEP-CTERM protein', 'Glob_PEP-CTERM', 4, NULL),
(24710, NULL, 'IPR024517', NULL, 'Glycogen phosphorylase, domain of unknown function DUF3417', 'Glycogen_phosphorylase_DUF3417', 3, NULL),
(24711, NULL, 'IPR029062', NULL, 'Class I glutamine amidotransferase-like', 'Class_I_gatase-like', 5, NULL),
(24712, NULL, 'IPR028900', NULL, 'Tox-SHH domain', 'Tox-SHH_dom', 3, NULL),
(24713, NULL, 'IPR032522', NULL, 'Protein of unknown function DUF4961', 'DUF4961', 4, NULL),
(24714, NULL, 'IPR030952', NULL, 'FemAB family protein', 'FemAB', 4, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(24715, NULL, 'IPR033986', NULL, 'Clusterin, conserved site', 'Clusterin_CS', 2, NULL),
(24716, NULL, 'IPR026859', NULL, 'Myosin-binding domain', 'Myosin-bd', 3, NULL),
(24717, NULL, 'IPR025676', NULL, 'Clr5 domain', 'Clr5_dom', 3, NULL),
(24718, NULL, 'IPR025589', NULL, 'Topoisomerase C-terminal repeat', 'Toprim_C_rpt', 7, NULL),
(24719, NULL, 'IPR027409', NULL, 'GroEL-like apical domain superfamily', 'GroEL-like_apical_dom_sf', 5, NULL),
(24720, NULL, 'IPR026357', NULL, 'Radical SAM/SPASM domain protein, GRRM system', 'rSAM/SPASM_prot_GRRM_system', 4, NULL),
(24721, NULL, 'IPR025683', NULL, 'Protein beta', 'Protein_beta', 4, NULL),
(24722, NULL, 'IPR026205', NULL, 'Progesterone-induced-blocking factor 1', 'PIBF1', 4, NULL),
(24723, NULL, 'IPR025593', NULL, 'Growth arrest-specific protein 8 domain', 'GAS8_dom', 3, NULL),
(24724, NULL, 'IPR029039', NULL, 'Flavoprotein-like superfamily', 'Flavoprotein-like_sf', 5, NULL),
(24725, NULL, 'IPR026337', NULL, 'HEXXH motif domain', 'Mod_HExxH', 3, NULL),
(24726, NULL, 'IPR029060', NULL, 'PIN-like domain superfamily', 'PIN-like_dom_sf', 5, NULL),
(24727, NULL, 'IPR026346', NULL, 'SynChlorMet cassette radical SAM/SPASM protein ScmF', 'SCM_rSAM_ScmF', 4, NULL),
(24728, NULL, 'IPR027383', NULL, 'Putative zinc-finger', 'Znf_put', 3, NULL),
(24729, NULL, 'IPR029711', NULL, 'HAUS augmin-like complex subunit 7-like', 'Haus7-like', 4, NULL),
(24730, NULL, 'IPR026846', NULL, 'E3 SUMO-protein ligase Nse2 (Mms21)', 'Nse2(Mms21)', 4, NULL),
(24731, NULL, 'IPR026255', NULL, 'NAD(P) transhydrogenase, alpha subunit', 'NADP_transhyd_a', 4, NULL),
(24732, NULL, 'IPR028041', NULL, 'WD repeat and coiled-coil-containing protein family', 'WDCP', 4, NULL),
(24733, NULL, 'IPR029057', NULL, 'Phosphoribosyltransferase-like', 'PRTase-like', 5, NULL),
(24734, NULL, 'IPR027413', NULL, 'GroEL-like equatorial domain superfamily', 'GROEL-like_equatorial_sf', 5, NULL),
(24735, NULL, 'IPR029762', NULL, 'Pyroglutamyl peptidase I, bacterial-type', 'PGP-I_bact-type', 4, NULL),
(24736, NULL, 'IPR025632', NULL, 'Protein of unknown function DUF4290', 'DUF4290', 4, NULL),
(24737, NULL, 'IPR029402', NULL, 'tRNA-guanine transglycosylase, patch-forming domain C2', 'TGT_C2', 3, NULL),
(24738, NULL, 'IPR030389', NULL, 'FeoB-type guanine nucleotide-binding (G) domain', 'G_FEOB_dom', 3, NULL),
(24739, NULL, 'IPR029058', NULL, 'Alpha/Beta hydrolase fold', 'AB_hydrolase', 5, NULL),
(24740, NULL, 'IPR029309', NULL, 'Calcium-responsive transcription factor', 'CaRF', 4, NULL),
(24741, NULL, 'IPR027475', NULL, 'Asparaginase/glutaminase, active site 2', 'Asparaginase/glutaminase_AS2', 0, NULL),
(24742, NULL, 'IPR031506', NULL, 'Histidine-rich carboxyl terminus protein 1', 'HRCT1', 4, NULL),
(24743, NULL, 'IPR031856', NULL, 'Bacterial antitoxin YdaS', 'YdaS_toxin', 4, NULL),
(24744, NULL, 'IPR024520', NULL, 'Protein of unknown function DUF3558', 'DUF3558', 4, NULL),
(24745, NULL, 'IPR029065', NULL, 'Enolase C-terminal domain-like', 'Enolase_C-like', 3, NULL),
(24746, NULL, 'IPR027922', NULL, 'Proline-rich acidic protein 1', 'PRAP', 4, NULL),
(24747, NULL, 'IPR029751', NULL, 'Ribosomal protein L25', 'Ribosomal_L25', 4, NULL),
(24748, NULL, 'IPR024324', NULL, 'Condensin complex subunit 1, N-terminal', 'Condensin_cplx_su1_N', 3, NULL),
(24749, NULL, 'IPR027752', NULL, 'Protein polyglycylase TTLL10', 'TTLL10', 4, NULL),
(24750, NULL, 'IPR026350', NULL, 'GxxExxY protein', 'GxxExxY', 4, NULL),
(24751, NULL, 'IPR027300', NULL, 'Agouti domain', 'Agouti_dom', 3, NULL),
(24752, NULL, 'IPR028374', NULL, 'FadR, C-terminal domain', 'FadR_C', 3, NULL),
(24753, NULL, 'IPR027118', NULL, 'Matrix Gla protein', 'MGP', 4, NULL),
(24754, NULL, 'IPR026356', NULL, 'rSAM-associated Gly-rich repeat protein', 'Cyano_gly_rpt_prot', 4, NULL),
(24755, NULL, 'IPR024510', NULL, 'Protein of unknown function DUF2589', 'DUF2589', 4, NULL),
(24756, NULL, 'IPR027051', NULL, 'XdhC Rossmann domain', 'XdhC_Rossmann_dom', 3, NULL),
(24757, NULL, 'IPR025677', NULL, 'OST-HTH associated domain', 'OST-HTH-assoc_dom', 3, NULL),
(24758, NULL, 'IPR027473', NULL, 'L-asparaginase, C-terminal', 'L-asparaginase_C', 5, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(24759, NULL, 'IPR026370', NULL, 'Squalene-tetrahymanol cyclase THC1', 'Tetrahymanol_synth_THC1', 4, NULL),
(24760, NULL, 'IPR028169', NULL, 'Raftlin family', 'Raftlin', 4, NULL),
(24761, NULL, 'IPR025686', NULL, 'Glucosyl transferase II', 'Glucos_trans_II', 4, NULL),
(24762, NULL, 'IPR027749', NULL, 'Tubulin--tyrosine ligase-like protein 12', 'TTLL12', 4, NULL),
(24763, NULL, 'IPR027444', NULL, 'Histone-like protein H-NS, C-terminal domain', 'H-NS_C_dom', 3, NULL),
(24764, NULL, 'IPR030682', NULL, 'Protein phosphatase 1 regulatory subunit 3B', 'PP1_3B', 4, NULL),
(24765, NULL, 'IPR030474', NULL, 'Interleukin-6/GCSF/MGF', 'IL-6/GCSF/MGF', 4, NULL),
(24766, NULL, 'IPR029426', NULL, 'FAM86, N-terminal', 'FAM86_N', 3, NULL),
(24767, NULL, 'IPR031499', NULL, 'Protein of unknown function DUF4689', 'DUF4689', 4, NULL),
(24768, NULL, 'IPR025717', NULL, 'Histone deacetylase complex subunit SAP30 zinc-finger', 'SAP30_zn-finger', 3, NULL),
(24769, NULL, 'IPR028897', NULL, 'Tox-HDC domain', 'Tox-HDC_dom', 4, NULL),
(24770, NULL, 'IPR030399', NULL, 'Pestivirus NS2, peptidase C74', 'NS2_C74', 3, NULL),
(24771, NULL, 'IPR025981', NULL, 'Ribosomal RNA aminoglycoside-resistance methyltransferase', 'rRNA_MeTrfase', 4, NULL),
(24772, NULL, 'IPR029378', NULL, 'Type III secreted effector HopW1-1/HolPsyAE', 'T3SS_HopW1-1/HolPsyAE', 4, NULL),
(24773, NULL, 'IPR028115', NULL, 'Domain of unknown function DUF4484', 'DUF4484', 3, NULL),
(24774, NULL, 'IPR025585', NULL, 'Photosystem II Pbs27', 'PSII_Pbs27', 4, NULL),
(24775, NULL, 'IPR025602', NULL, 'BCP1 family', 'BCP1_family', 4, NULL),
(24776, NULL, 'IPR026130', NULL, 'Protein phosphatase 1 regulatory subunit 26', 'PPP1R26', 4, NULL),
(24777, NULL, 'IPR031853', NULL, 'Putative antitoxin YmcE', 'YmcE_antitoxin', 4, NULL),
(24778, NULL, 'IPR026849', NULL, 'Autophagy-related protein 2', 'ATG2', 4, NULL),
(24779, NULL, 'IPR024338', NULL, 'Stretch-activated cation channel Mid1/Calcium influx-promoting protein Ehs1', 'Mid1/Ehs1', 4, NULL),
(24780, NULL, 'IPR028105', NULL, 'Protein of unknown function DUF4651', 'DUF4651', 4, NULL),
(24781, NULL, 'IPR024541', NULL, 'Protein of unknown function DUF3881', 'DUF3881', 4, NULL),
(24782, NULL, 'IPR025703', NULL, 'Bifunctional protein PutA', 'Bifunct_PutA', 4, NULL),
(24783, NULL, 'IPR025630', NULL, 'Protein of unknown function DUF4288', 'DUF4288', 4, NULL),
(24784, NULL, 'IPR027461', NULL, 'LD-carboxypeptidase A, C-terminal domain superfamily', 'Carboxypeptidase_A_C_sf', 5, NULL),
(24785, NULL, 'IPR032520', NULL, 'MukB, hinge domain', 'MukB_hinge', 3, NULL),
(24786, NULL, 'IPR026364', NULL, 'Ax21 family', 'Ax21', 4, NULL),
(24787, NULL, 'IPR027996', NULL, 'Tubulin epsilon and delta complex protein 1 domain', 'TEDC1_dom', 3, NULL),
(24788, NULL, 'IPR028901', NULL, 'Tox-SGS domain', 'Tox-SGS_dom', 3, NULL),
(24789, NULL, 'IPR029061', NULL, 'Thiamin diphosphate-binding fold', 'THDP-binding', 5, NULL),
(24790, NULL, 'IPR026126', NULL, 'BRISC and BRCA1-A complex member 1', 'BABAM1', 4, NULL),
(24791, NULL, 'IPR026026', NULL, 'Histidine triad hydrolase, Hint-type', 'HIT_Hint', 4, NULL),
(24792, NULL, 'IPR025636', NULL, 'Protein of unknown function DUF4294', 'DUF4294', 4, NULL),
(24793, NULL, 'IPR024681', NULL, 'Ribulose bisphosphate carboxylase, small subunit', 'RuBisCO_ssu', 4, NULL),
(24794, NULL, 'IPR027990', NULL, 'Protein of unknown function DUF4633', 'DUF4633', 4, NULL),
(24795, NULL, 'IPR028082', NULL, 'Periplasmic binding protein-like I', 'Peripla_BP_I', 5, NULL),
(24796, NULL, 'IPR027938', NULL, 'Adipogenin', 'Adipogenin', 4, NULL),
(24797, NULL, 'IPR025681', NULL, 'Phage phiEco32-like COOH-NH2 ligase-type 2', 'COOH-NH2_lig', 4, NULL),
(24798, NULL, 'IPR030559', NULL, 'DNA polymerase zeta catalytic subunit', 'PolZ_Rev3', 4, NULL),
(24799, NULL, 'IPR026136', NULL, 'RIPOR family member 3', 'RIPOR3', 4, NULL),
(24800, NULL, 'IPR027446', NULL, 'Variant surface glycoprotein C-terminal domain superfamily', 'VSG_C_dom_sf', 5, NULL),
(24801, NULL, 'IPR029307', NULL, 'INTS6/SAGE1/DDX26B/CT45, C-terminal', 'INT_SG_DDX_CT_C', 3, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(24802, NULL, 'IPR029301', NULL, 'Sperm acrosome-associated protein 7', 'SPACA7', 4, NULL),
(24803, NULL, 'IPR028110', NULL, 'Transmembrane protein 254', 'TMEM254', 4, NULL),
(24804, NULL, 'IPR028101', NULL, 'Protein of unknown function DUF4616', 'DUF4616', 4, NULL),
(24805, NULL, 'IPR024512', NULL, 'Small subunit of serine palmitoyltransferase-like', 'Ser_palmitoyltrfase_ssu-like', 4, NULL),
(24806, NULL, 'IPR029318', NULL, 'Beclin-1, BH3 domain', 'BH3_dom', 3, NULL),
(24807, NULL, 'IPR026858', NULL, 'Vezatin', 'Vezatin', 4, NULL),
(24808, NULL, 'IPR029063', NULL, 'S-adenosyl-L-methionine-dependent methyltransferase superfamily', 'SAM-dependent_MTases_sf', 5, NULL),
(24809, NULL, 'IPR025682', NULL, 'CpXC domain', 'CpXC_dom', 3, NULL),
(24810, NULL, 'IPR028941', NULL, 'WHIM2 domain', 'WHIM2_dom', 3, NULL),
(24811, NULL, 'IPR027255', NULL, 'Transcriptional enhancer factor TEF-3 (TEAD4)', 'TEF-3', 4, NULL),
(24812, NULL, 'IPR025711', NULL, 'PepSY domain', 'PepSY', 3, NULL),
(24813, NULL, 'IPR025637', NULL, 'Domain of unknown function DUF4333', 'DUF4333', 3, NULL),
(24814, NULL, 'IPR024513', NULL, 'Protein of unknown function DUF3334', 'DUF3334', 4, NULL),
(24815, NULL, 'IPR024337', NULL, 'tRNA-splicing endonuclease, subunit Sen54', 'tRNA_splic_suSen54', 4, NULL),
(24816, NULL, 'IPR029600', NULL, 'Intraflagellar transport protein 81', 'IFT81', 4, NULL),
(24817, NULL, 'IPR024533', NULL, 'Protein of unknown function DUF3834', 'DUF3834', 4, NULL),
(24818, NULL, 'IPR031688', NULL, 'Voltage-gated calcium channel subunit alpha, C-terminal', 'CAC1F_C', 3, NULL),
(24819, NULL, 'IPR026204', NULL, 'GRIP1-associated protein 1', 'GRIPAP1', 4, NULL),
(24820, NULL, 'IPR025639', NULL, 'Druantia protein DruA', 'DruA', 4, NULL),
(24821, NULL, 'IPR025642', NULL, 'Domain of unknown function DUF4342', 'DUF4342', 3, NULL),
(24822, NULL, 'IPR028961', NULL, 'Immunity protein 21', 'Imm21', 4, NULL),
(24823, NULL, 'IPR025955', NULL, 'Type-IV secretion system protein TraC/Conjugative transfer ATPase', 'TraC/Conjuga_ATPase', 4, NULL),
(24824, NULL, 'IPR026039', NULL, 'Ancillary SecYEG translocon subunit YfgM', 'YfgM', 4, NULL),
(24825, NULL, 'IPR030951', NULL, 'Sec region non-globular protein', 'Sec_Non_Glob', 4, NULL),
(24826, NULL, 'IPR027989', NULL, 'Domain of unknown function DUF4461', 'DUF4461', 3, NULL),
(24827, NULL, 'IPR027937', NULL, 'Photoreceptor disk component PRCD', 'PRCD', 4, NULL),
(24828, NULL, 'IPR030955', NULL, 'CRISPR type III-associated protein, CHP04423 family', 'CHP04423', 4, NULL),
(24829, NULL, 'IPR028953', NULL, 'Immunity protein IFT-like', 'Imm_IFT-like', 4, NULL),
(24830, NULL, 'IPR031508', NULL, 'Transmembrane protein 108', 'TMEM108', 4, NULL),
(24831, NULL, 'IPR029410', NULL, 'CAP-associated domain', 'CAP_assoc', 3, NULL),
(24832, NULL, 'IPR027410', NULL, 'TCP-1-like chaperonin intermediate domain superfamily', 'TCP-1-like_intermed_sf', 5, NULL),
(24833, NULL, 'IPR026207', NULL, 'Interleukin-27 alpha', 'IL-27_alpha', 4, NULL),
(24834, NULL, 'IPR025689', NULL, 'Sporulation protein YtrH', 'Spore_YtrH', 4, NULL),
(24835, NULL, 'IPR026037', NULL, 'Phosphatidylglycerophosphatase A', 'PgpA', 4, NULL),
(24836, NULL, 'IPR027250', NULL, 'Phosphoglycerate kinase, euglenozoa', 'Pgk_euglenozoa', 4, NULL),
(24837, NULL, 'IPR027518', NULL, 'Translation factor GUF1 homologue, organellar chromatophore', 'GUFP', 4, NULL),
(24838, NULL, 'IPR025582', NULL, 'YARHG domain', 'YARHG_dom', 3, NULL),
(24839, NULL, 'IPR026092', NULL, 'Retinoic acid-induced protein 2/sine oculis-binding protein homologue', 'RAI2/SOBP', 4, NULL),
(24840, NULL, 'IPR026845', NULL, 'Neurexophilin/NXPE', 'NXPH/NXPE', 4, NULL),
(24841, NULL, 'IPR025684', NULL, 'Gliding motility protein SprA N-terminal domain', 'SprA_N_dom', 3, NULL),
(24842, NULL, 'IPR026854', NULL, 'Vacuolar protein sorting-associated protein 13-like, N-terminal domain', 'VPS13-like_N', 3, NULL),
(24843, NULL, 'IPR028173', NULL, 'Augurin', 'Augurin', 4, NULL),
(24844, NULL, 'IPR030513', NULL, 'Dehydrin, conserved site', 'Dehydrin_CS', 2, NULL),
(24845, NULL, 'IPR025685', NULL, 'YoaP-like domain', 'YoaP-like_dom', 3, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(24846, NULL, 'IPR025929', NULL, 'Insulin-induced protein family', 'INSIG_fam', 4, NULL),
(24847, NULL, 'IPR026653', NULL, 'Variably charged protein VCX/VCY1', 'VCX/VCY1', 4, NULL),
(24848, NULL, 'IPR024949', NULL, 'Bet v I type allergen', 'Bet_v_I_allergen', 4, NULL),
(24849, NULL, 'IPR027943', NULL, 'FAM209 family', 'FAM209', 4, NULL),
(24850, NULL, 'IPR026238', NULL, 'Protein INCA1', 'INCA1', 4, NULL),
(24851, NULL, 'IPR025678', NULL, 'Immunity protein Imm3', 'Imm3', 4, NULL),
(24852, NULL, 'IPR026285', NULL, 'TenA_E protein', 'TenA_E', 4, NULL),
(24853, NULL, 'IPR028949', NULL, 'Novel toxin 15', 'Ntox15', 3, NULL),
(24854, NULL, 'IPR027549', NULL, 'Arginine decarboxylase proenzyme', 'ArgDC', 4, NULL),
(24855, NULL, 'IPR024682', NULL, 'Nuclear pore localisation protein Npl4, ubiquitin-like domain', 'Npl4_Ub-like_dom', 3, NULL),
(24856, NULL, 'IPR028906', NULL, 'Tox-REase-2 domain', 'Tox-REase-2_dom', 3, NULL),
(24857, NULL, 'IPR027941', NULL, 'Placenta-specific protein 9', 'PLAC9', 4, NULL),
(24858, NULL, 'IPR027469', NULL, 'Cation efflux transmembrane domain superfamily', 'Cation_efflux_TMD_sf', 5, NULL),
(24859, NULL, 'IPR025680', NULL, 'Double-stranded DNA deaminase immunity protein DddI', 'DddI', 4, NULL),
(24860, NULL, 'IPR024535', NULL, 'Pectate lyase superfamily protein', 'Pectate_lyase_SF_prot', 3, NULL),
(24861, NULL, 'IPR029715', NULL, 'Shieldin complex subunit 2', 'FAM35A', 4, NULL),
(24862, NULL, 'IPR030472', NULL, 'Tissue factor, conserved site', 'Tissue_Factor_CS', 2, NULL),
(24863, NULL, 'IPR027016', NULL, 'Uncharacterised protein with YceI domain', 'UCP029811', 4, NULL),
(24864, NULL, 'IPR024537', NULL, 'Domain of unknown function DUF3322', 'DUF3322', 3, NULL),
(24865, NULL, 'IPR027640', NULL, 'Kinesin-like protein', 'Kinesin-like_fam', 4, NULL),
(24866, NULL, 'IPR024686', NULL, 'Adenylate cyclase class-I, conserved site', 'Adenylate_cyclase_1_CS', 2, NULL),
(24867, NULL, 'IPR029399', NULL, 'TMEM192 family', 'TMEM192', 4, NULL),
(24868, NULL, 'IPR029300', NULL, 'CEP170, C-terminal', 'CEP170_C', 3, NULL),
(24869, NULL, 'IPR028902', NULL, 'Tox-REase-9 domain', 'Tox-REase-9_dom', 3, NULL),
(24870, NULL, 'IPR035919', NULL, 'EAL domain superfamily', 'EAL_sf', 5, NULL),
(24871, NULL, 'IPR024471', NULL, 'Protein of unknown function DUF2715', 'DUF2715', 4, NULL),
(24872, NULL, 'IPR027993', NULL, 'Protein of unknown function DUF4495', 'DUF4495', 4, NULL),
(24873, NULL, 'IPR025941', NULL, 'Vacuolar protein sorting-associated protein 8, central domain', 'Vps8_central_dom', 3, NULL),
(24874, NULL, 'IPR028171', NULL, 'Codanin-1, C-terminal domain', 'Codanin-1_C', 3, NULL),
(24875, NULL, 'IPR028903', NULL, 'Tox-REase-7 domain', 'Tox-REase-7_dom', 3, NULL),
(24876, NULL, 'IPR024522', NULL, 'Protein of unknown function DUF3789', 'DUF3789', 4, NULL),
(24877, NULL, 'IPR027476', NULL, 'D-aminopeptidase, N-terminal', 'DppA_N', 5, NULL),
(24878, NULL, 'IPR028544', NULL, 'Protein CASC3', 'CASC3', 4, NULL),
(24879, NULL, 'IPR025631', NULL, 'Putative porin-10', 'Porin_10', 4, NULL),
(24880, NULL, 'IPR028943', NULL, 'Zorya protein ZorC, EH signature domain', 'ZorC_EH_Signature_dom', 3, NULL),
(24881, NULL, 'IPR028944', NULL, 'PRTase ComF-like', 'PRTase_ComF-like', 4, NULL),
(24882, NULL, 'IPR028911', NULL, 'Tox-MPTase5 domain', 'Tox-MPTase5_dom', 3, NULL),
(24883, NULL, 'IPR027253', NULL, 'Transcriptional enhancer factor TEF-5 (TEAD3)', 'TEF-5', 4, NULL),
(24884, NULL, 'IPR026354', NULL, 'Four helix bundle suffix domain', '4helix_suffix_dom', 3, NULL),
(24885, NULL, 'IPR027399', NULL, 'Alcohol dehydrogenase GroES-associated', 'ADH_N_assoc', 3, NULL),
(24886, NULL, 'IPR027059', NULL, 'Coatomer delta subunit', 'Coatomer_dsu', 4, NULL),
(24887, NULL, 'IPR027271', NULL, 'Acetolactate synthase/Transcription factor NikR, C-terminal', 'Acetolactate_synth/TF_NikR_C', 5, NULL),
(24888, NULL, 'IPR028955', NULL, 'Immunity protein 57', 'Imm57', 4, NULL),
(24889, NULL, 'IPR029605', NULL, 'FAM184 family', 'FAM184', 4, NULL),
(24890, NULL, 'IPR024329', NULL, 'Amyloidogenic glycoprotein, E2 domain', 'Amyloid_glyco_E2_domain', 3, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(24891, NULL, 'IPR027385', NULL, 'Outer membrane protein beta-barrel domain', 'OMP_b-brl', 3, NULL),
(24892, NULL, 'IPR029064', NULL, '50S ribosomal protein L30e-like', 'L30e-like', 5, NULL),
(24893, NULL, 'IPR026289', NULL, 'Solute binding protein, TakP-like', 'SBP_TakP-like', 4, NULL),
(24894, NULL, 'IPR027639', NULL, 'ComB, archaeal', 'ComB_archaeal', 4, NULL),
(24895, NULL, 'IPR029069', NULL, 'HotDog domain superfamily', 'HotDog_dom_sf', 5, NULL),
(24896, NULL, 'IPR026028', NULL, 'ATPase, V0 complex, subunit 116kDa, eukaryotic', 'V-type_ATPase_116kDa_su_euka', 4, NULL),
(24897, NULL, 'IPR028106', NULL, 'Protein of unknown function DUF4578', 'DUF4578', 4, NULL),
(24898, NULL, 'IPR027057', NULL, 'CAAX prenyl protease 1', 'CAXX_Prtase_1', 4, NULL),
(24899, NULL, 'IPR031500', NULL, 'Protein SNORC', 'SNORC', 4, NULL),
(24900, NULL, 'IPR027918', NULL, 'Centriolar and ciliogenesis-associated protein HYLS1, C-terminal domain', 'HYLS1_C_dom', 3, NULL),
(24901, NULL, 'IPR029297', NULL, 'Spermatogenesis-associated protein 32', 'SPATA32', 4, NULL),
(24902, NULL, 'IPR025674', NULL, 'Immunity protein Imm6', 'Imm6', 4, NULL),
(24903, NULL, 'IPR031855', NULL, 'Protein of unknown function DUF4751', 'DUF4751', 4, NULL),
(24904, NULL, 'IPR025640', NULL, 'GYF domain 2', 'GYF_2', 3, NULL),
(24905, NULL, 'IPR024469', NULL, 'Protein of unknown function DUF2538', 'DUF2538', 4, NULL),
(24906, NULL, 'IPR027329', NULL, 'TPX2, C-terminal', 'TPX2_C', 3, NULL),
(24907, NULL, 'IPR024525', NULL, 'Protein of unknown function DUF3804', 'DUF3804', 4, NULL),
(24908, NULL, 'IPR028250', NULL, 'Thiol:disulfide interchange protein DsbD, N-terminal domain', 'DsbDN', 3, NULL),
(24909, NULL, 'IPR027056', NULL, 'Gluconate 2-dehydrogenase subunit 3', 'Gluconate_2DH_su3', 4, NULL),
(24910, NULL, 'IPR030960', NULL, '3-dehydroquinate synthase domain', 'DHQS/DOIS', 3, NULL),
(24911, NULL, 'IPR028968', NULL, 'Immunity protein 58', 'Imm58', 4, NULL),
(24912, NULL, 'IPR027448', NULL, 'Short tail fibre protein, C-terminal', 'Short_tail_fibre_C', 3, NULL),
(24913, NULL, 'IPR034289', NULL, 'Laccase, third cupredoxin domain', 'CuRO_3_LCC', 3, NULL),
(24914, NULL, 'IPR027261', NULL, 'Retinoic acid receptor responder protein 1', 'TIG1', 4, NULL),
(24915, NULL, 'IPR025652', NULL, 'Acyl-CoA thioesterase II domain', 'Acyl_CoA_thio_II_dom', 3, NULL),
(24916, NULL, 'IPR031933', NULL, 'UPF0767 family', 'UPF0767', 4, NULL),
(24917, NULL, 'IPR024937', NULL, 'Domain X', 'Domain_X', 3, NULL),
(24918, NULL, 'IPR029059', NULL, 'Alpha/beta hydrolase fold-5', 'AB_hydrolase_5', 3, NULL),
(24919, NULL, 'IPR025629', NULL, 'Protein of unknown function DUF4287', 'DUF4287', 4, NULL),
(24920, NULL, 'IPR026124', NULL, 'Sperm-associated antigen 8', 'Sperm-assoc_Ag8', 4, NULL),
(24921, NULL, 'IPR029425', NULL, 'Protein MMS22-like, N-terminal', 'MMS22L_N', 3, NULL),
(24922, NULL, 'IPR029290', NULL, 'TP53-target gene 5 protein', 'TP53TG5', 4, NULL),
(24923, NULL, 'IPR024655', NULL, 'Uncharacterised protein family, glycosyl hydrolase catalytic domain', 'Unchr_glyco_hydro_catalytic', 3, NULL),
(24924, NULL, 'IPR026828', NULL, 'Suppressor APC domain-containing protein 1/2', 'Suppressor_APCD_1/2', 4, NULL),
(24925, NULL, 'IPR025641', NULL, 'Domain of unknown function DUF4340', 'DUF4340', 3, NULL),
(24926, NULL, 'IPR029304', NULL, 'A-kinase anchor protein 2, C-terminal domain', 'AKAP2_C', 3, NULL),
(24927, NULL, 'IPR029717', NULL, 'FAM193 family', 'FAM193', 4, NULL),
(24928, NULL, 'IPR029401', NULL, 'Nudix hydrolase, N-terminal', 'Nudix_N', 3, NULL),
(24929, NULL, 'IPR028114', NULL, 'Protein of unknown function DUF4658', 'DUF4658', 4, NULL),
(24930, NULL, 'IPR026027', NULL, 'Phosphatidylcholine synthase Pcs', 'PcS', 4, NULL),
(24931, NULL, 'IPR027997', NULL, 'Protein Largen/Inhibitory synaptic factor 1', 'Largen/INSYN1', 4, NULL),
(24932, NULL, 'IPR029302', NULL, 'Intraflagellar transport protein 43', 'IFT43', 4, NULL),
(24933, NULL, 'IPR029404', NULL, 'CDAN1-interacting nuclease 1', 'CDIN1', 4, NULL),
(24934, NULL, 'IPR025692', NULL, 'Mechanosensitive ion channel inner membrane domain 1', 'MscS_IM_dom1', 3, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(24935, NULL, 'IPR025738', NULL, 'Aerotolerance-related protein BatD', 'BatD', 4, NULL),
(24936, NULL, 'IPR025690', NULL, 'Methyltransferase, putative', 'Methyltransf_put', 4, NULL),
(24937, NULL, 'IPR024523', NULL, 'Protein of unknown function DUF3793', 'DUF3793', 4, NULL),
(24938, NULL, 'IPR024542', NULL, 'Domain of unknown function DUF3880', 'DUF3880', 3, NULL),
(24939, NULL, 'IPR024540', NULL, 'Protein of unknown function DUF3879', 'DUF3879', 4, NULL),
(24940, NULL, 'IPR028957', NULL, 'Immunity protein 50', 'Imm50', 4, NULL),
(24941, NULL, 'IPR028958', NULL, 'Immunity protein 42', 'Imm42', 4, NULL),
(24942, NULL, 'IPR028912', NULL, 'Tox-MPTase4 domain', 'Tox-MPTase4_dom', 3, NULL),
(24943, NULL, 'IPR024923', NULL, 'Peptidoglycan biosynthesis protein, SpoVB-type', 'PG_synth_SpoVB', 4, NULL),
(24944, NULL, 'IPR024530', NULL, 'Putative quorum-sensing-regulated virulence factor', 'QSregVF_b', 4, NULL),
(24945, NULL, 'IPR028947', NULL, 'Bacterial toxin 34', 'Ntox34', 3, NULL),
(24946, NULL, 'IPR029397', NULL, 'Tube, Death domain', 'Tube_Death', 3, NULL),
(24947, NULL, 'IPR026024', NULL, 'Chemotaxis protein methyltransferase CheR', 'Chemotaxis_MeTrfase_CheR', 4, NULL),
(24948, NULL, 'IPR027940', NULL, 'Kita-kyushu lung cancer antigen 1', 'KKLCAg1', 4, NULL),
(24949, NULL, 'IPR029066', NULL, 'PLP-binding barrel', 'PLP-binding_barrel', 5, NULL),
(24950, NULL, 'IPR029311', NULL, 'Coiled-coil domain-containing protein 50,  N-terminal', 'CCDC50_N', 3, NULL),
(24951, NULL, 'IPR025638', NULL, 'Protein of unknown function DUF4336', 'DUF4336', 4, NULL),
(24952, NULL, 'IPR027391', NULL, 'rRNA small subunit methyltransferase F, RNA-binding PUA-like domain', 'Nol1_Nop2_Fmu_2', 3, NULL),
(24953, NULL, 'IPR034271', NULL, 'Ascorbate oxidase homologue, second cupredoxin domain', 'CuRO_2_AO-like', 3, NULL),
(24954, NULL, 'IPR029388', NULL, 'Domain of unknown function DUF4650', 'DUF4650', 3, NULL),
(24955, NULL, 'IPR034286', NULL, 'Cytosolic carboxypeptidase-like protein 5 catalytic domain', 'M14_AGBL5-like', 3, NULL),
(24956, NULL, 'IPR027947', NULL, 'TMEM240 family', 'TMEM240', 4, NULL),
(24957, NULL, 'IPR030666', NULL, 'tRNA isopentenyltransferase, eukaryotes', 'IPP_transferase_euk', 4, NULL),
(24958, NULL, 'IPR024310', NULL, 'NUT family', 'NUT', 4, NULL),
(24959, NULL, 'IPR024539', NULL, 'Protein of unknown function DUF3877', 'DUF3877', 4, NULL),
(24960, NULL, 'IPR026355', NULL, 'Oxalate/formate antiporter', 'Oxa/Form_antiport', 4, NULL),
(24961, NULL, 'IPR025754', NULL, 'TRC8-like,  N-terminal domain', 'TRC8_N_dom', 3, NULL),
(24962, NULL, 'IPR029723', NULL, 'Integral membrane protein GPR137', 'GPR137', 4, NULL),
(24963, NULL, 'IPR031501', NULL, 'Amelotin', 'Amelotin', 4, NULL),
(24964, NULL, 'IPR032521', NULL, 'Pestivirus envelope glycoprotein E2', 'Pestivirus_E2', 3, NULL),
(24965, NULL, 'IPR025752', NULL, 'High pH protein family', 'HPH_family', 4, NULL),
(24966, NULL, 'IPR028951', NULL, 'Immunity protein 64', 'Imm64', 4, NULL),
(24967, NULL, 'IPR024516', NULL, 'Mammalian cell entry, C-terminal', 'Mce_C', 3, NULL),
(24968, NULL, 'IPR025747', NULL, 'ThiC-associated domain', 'ThiC-associated_dom', 3, NULL),
(24969, NULL, 'IPR030665', NULL, 'Circadian clock protein kinase KaiC', 'KaiC', 4, NULL),
(24970, NULL, 'IPR026240', NULL, 'Immunogenic miracidial antigen 8I''', 'Miracidia_Ag_8I''', 4, NULL),
(24971, NULL, 'IPR028970', NULL, 'Protein of unknown function DUF4662', 'DUF4662', 4, NULL),
(24972, NULL, 'IPR025633', NULL, 'Protein of unknown function DUF4291', 'DUF4291', 4, NULL),
(24973, NULL, 'IPR025737', NULL, 'MetA-pathway of phenol degradation, putative', 'Phenol_MetA_deg_put', 4, NULL),
(24974, NULL, 'IPR028952', NULL, 'Immunity protein 63', 'Imm63', 3, NULL),
(24975, NULL, 'IPR028081', NULL, 'Leucine-binding protein domain', 'Leu-bd', 3, NULL),
(24976, NULL, 'IPR027324', NULL, 'Microtubule associated protein MAP2/MAP4/Tau', 'MAP2/MAP4/Tau', 4, NULL),
(24977, NULL, 'IPR028910', NULL, 'Tox-PL-2 domain', 'Tox-PL-2_dom', 3, NULL),
(24978, NULL, 'IPR026236', NULL, 'Integrator complex subunit 2, metazoa', 'Int2_metazoa', 4, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(24979, NULL, 'IPR025688', NULL, 'PGDYG protein', 'PGDYG_prot', 4, NULL),
(24980, NULL, 'IPR029292', NULL, 'Methylated in normal thymocytes protein', 'MENT', 4, NULL),
(24981, NULL, 'IPR026286', NULL, 'Maleate isomerase/Arylmalonate decarboxylase', 'MaiA/AMDase', 4, NULL),
(24982, NULL, 'IPR026272', NULL, 'Immunity protein SdpI', 'SdpI', 4, NULL),
(24983, NULL, 'IPR028908', NULL, 'Tox-PL domain', 'Tox-PL_dom', 3, NULL),
(24984, NULL, 'IPR031858', NULL, 'Protein of unknown function DUF4752', 'DUF4752', 4, NULL),
(24985, NULL, 'IPR028907', NULL, 'Tox-PLDMTX domain', 'Tox-PLDMTX_dom', 3, NULL),
(24986, NULL, 'IPR028116', NULL, 'Tautomerase, cis-CaaD-like', 'Cis-CaaD-like', 3, NULL),
(24987, NULL, 'IPR027434', NULL, 'Homing endonuclease', 'Homing_endonucl', 5, NULL),
(24988, NULL, 'IPR026818', NULL, 'Adenomatous polyposis coli (APC)  family', 'Apc_fam', 4, NULL),
(24989, NULL, 'IPR030956', NULL, 'Microcin B17-processing protein McbB', 'McbB', 4, NULL),
(24990, NULL, 'IPR029316', NULL, 'Regulatory factor X-associated protein, RFXANK-binding domain', 'RFXAP_RFXANK-bd', 3, NULL),
(24991, NULL, 'IPR026856', NULL, 'Sialidase family', 'Sialidase_fam', 4, NULL),
(24992, NULL, 'IPR026342', NULL, 'SynChlorMet cassette protein ScmD', 'SCM_PqqD-rel', 4, NULL),
(24993, NULL, 'IPR026339', NULL, 'Methylamine methyltransferase corrinoid protein reductive activase', 'Rama_corrin_act', 4, NULL),
(24994, NULL, 'IPR026278', NULL, 'Potassium/proton antiporter subunit KhtT', 'K(+)/H(+)_antiporter_KhtT', 4, NULL),
(24995, NULL, 'IPR029398', NULL, 'DNA polymerase beta, thumb domain', 'PolB_thumb', 3, NULL),
(24996, NULL, 'IPR028964', NULL, 'Immunity protein 8', 'Imm8', 4, NULL),
(24997, NULL, 'IPR026347', NULL, 'Mesaconyl-CoA isomerase', 'Mesacon_CoA_Isoase', 4, NULL),
(24998, NULL, 'IPR026335', NULL, 'Radical SAM/SPASM domain, FxsB family', 'SAM_SPASM_FxsB', 4, NULL),
(24999, NULL, 'IPR027073', NULL, '5''-3'' exoribonuclease', '5_3_exoribonuclease', 4, NULL),
(25000, NULL, 'IPR027378', NULL, 'Cyclic nucleotide-regulated ion channel, N-terminal', 'Nucleotide_channel_N', 5, NULL),
(25001, NULL, 'IPR026189', NULL, 'Cylicin', 'CYLC', 4, NULL),
(25002, NULL, 'IPR026479', NULL, 'Glycopeptide, sublancin family', 'Glycopep_SunS', 4, NULL),
(25003, NULL, 'IPR028847', NULL, 'Centromere protein W', 'CENP-W', 4, NULL),
(25004, NULL, 'IPR030962', NULL, 'STREFT protein', 'Mycopla_NOT_gsn', 4, NULL),
(25005, NULL, 'IPR038720', NULL, 'YprB, ribonuclease H-like domain', 'YprB_RNase_H-like_dom', 3, NULL),
(25006, NULL, 'IPR030390', NULL, 'RNA methyltransferase TrmA, active site', 'MeTrfase_TrmA_AS', 0, NULL),
(25007, NULL, 'IPR032293', NULL, 'Protein of unknown function DUF4840', 'DUF4840', 4, NULL),
(25008, NULL, 'IPR029086', NULL, 'Immunity protein 19', 'Imm19', 4, NULL),
(25009, NULL, 'IPR031616', NULL, 'Small toxic protein BsrE-like', 'BsrE-like', 4, NULL),
(25010, NULL, 'IPR031530', NULL, 'UPF0688 family', 'UPF0688', 4, NULL),
(25011, NULL, 'IPR031005', NULL, 'XrtN system VIT domain protein', 'Sorted_by_XrtN', 4, NULL),
(25012, NULL, 'IPR032380', NULL, 'Polynucleotide kinase-phosphatase, ligase domain', 'PNKP_ligase_dom', 3, NULL),
(25013, NULL, 'IPR031001', NULL, 'Proline reductase-associated electron transfer protein PrdC', 'PR_assoc_PrdC', 4, NULL),
(25014, NULL, 'IPR032284', NULL, 'ATP-dependent DNA helicase RecQ, zinc-binding domain', 'RecQ_Zn-bd', 3, NULL),
(25015, NULL, 'IPR029676', NULL, 'Primary ciliary dyskinesia protein 1', 'Gm101', 4, NULL),
(25016, NULL, 'IPR031634', NULL, 'Protein kinase G, rubredoxin domain', 'PknG_rubred', 3, NULL),
(25017, NULL, 'IPR029084', NULL, 'Immunity protein 30', 'Imm30', 3, NULL),
(25018, NULL, 'IPR028914', NULL, 'Tox-MPTase2 domain', 'Tox-MPTase2_dom', 3, NULL),
(25019, NULL, 'IPR032054', NULL, 'DNA replication factor Cdt1, C-terminal', 'Cdt1_C', 3, NULL),
(25020, NULL, 'IPR028915', NULL, 'Tox-HNH-HHH domain', 'Tox-HNH-HHH_dom', 3, NULL),
(25021, NULL, 'IPR026555', NULL, 'KAT8 regulatory NSL complex subunit 3/Testis-expressed sequence 30 protein', 'NSL3/Tex30', 4, NULL),
(25022, NULL, 'IPR028615', NULL, 'Maleate isomerase', 'Maleate_isomerase', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(25023, NULL, 'IPR032885', NULL, 'DNA double-strand break repair protein Mre11, archaea-type', 'Mre11_archaea-type', 4, NULL),
(25024, NULL, 'IPR028614', NULL, 'GDP-L-fucose synthase/GDP-L-colitose synthase', 'GDP_fucose/colitose_synth', 4, NULL),
(25025, NULL, 'IPR026194', NULL, 'Prolactin-releasing peptide', 'PrRP', 4, NULL),
(25026, NULL, 'IPR028921', NULL, 'NTF2 fold domain', 'NTF2_fold_dom', 3, NULL),
(25027, NULL, 'IPR032429', NULL, 'Nibrin, second BRCT domain', 'Nibrin_BRCT2', 3, NULL),
(25028, NULL, 'IPR031453', NULL, 'Transmembrane protein 119', 'TMEM119', 4, NULL),
(25029, NULL, 'IPR034151', NULL, 'Bacterial DnaG primase, TOPRIM domain', 'TOPRIM_DnaG_bac', 3, NULL),
(25030, NULL, 'IPR030896', NULL, 'AdoMet-dependent heme synthase AhbD', 'rSAM_AhbD_hemeb', 4, NULL),
(25031, NULL, 'IPR025744', NULL, 'Ribosomally synthesised peptide in Streptomyces', 'Rbsml_synth_pep_Strp', 4, NULL),
(25032, NULL, 'IPR026186', NULL, 'Protein POF1B', 'POF1B', 4, NULL),
(25033, NULL, 'IPR026241', NULL, 'GLC7-interacting protein 4', 'GIP4', 4, NULL),
(25034, NULL, 'IPR031442', NULL, 'Protein NPAT, C-terminal domain', 'NPAT_C', 3, NULL),
(25035, NULL, 'IPR030828', NULL, 'TyrR family, helix-turn-helix domain', 'HTH_TypR', 3, NULL),
(25036, NULL, 'IPR026657', NULL, 'Proline/serine-rich coiled-coil protein 1/G2 and S phase-expressed protein 1', 'DDA3/GTSE-1', 4, NULL),
(25037, NULL, 'IPR032317', NULL, 'RND efflux pump, membrane fusion protein, barrel-sandwich domain', 'HlyD_D23', 3, NULL),
(25038, NULL, 'IPR030670', NULL, '60S acidic ribosomal protein P0', 'L10E_eukaryotes', 4, NULL),
(25039, NULL, 'IPR025876', NULL, 'Trafficking protein particle complex subunit 11, C-terminal', 'TRAPPC11_C', 3, NULL),
(25040, NULL, 'IPR025739', NULL, 'Centrosome-associated, FAM110, N-terminal domain', 'FAM110_N', 3, NULL),
(25041, NULL, 'IPR029088', NULL, 'Immunity protein 12', 'Imm12', 3, NULL),
(25042, NULL, 'IPR031614', NULL, 'Putative holin', 'Holin_9', 4, NULL),
(25043, NULL, 'IPR028916', NULL, 'Tox-GHH domain', 'Tox-GHH_dom', 3, NULL),
(25044, NULL, 'IPR026577', NULL, 'Replication modulator SeqA, C-terminal DNA-binding domain', 'SeqA_DNA-bd_C', 3, NULL),
(25045, NULL, 'IPR030961', NULL, 'VPAMP-CTERM protein sorting domain', 'VPAMP_C', 4, NULL),
(25046, NULL, 'IPR025722', NULL, 'Bacterial transcriptional repressor TetR', 'TetR', 4, NULL),
(25047, NULL, 'IPR029432', NULL, 'Siphovirus Gp37-like protein', 'Sipho_Gp37', 4, NULL),
(25048, NULL, 'IPR031633', NULL, 'DNA replication complex GINS protein SLD5, C-terminal', 'SLD5_C', 3, NULL),
(25049, NULL, 'IPR026094', NULL, 'G protein pathway suppressor 2', 'GPS2', 4, NULL),
(25050, NULL, 'IPR028057', NULL, 'DrrA phosphatidylinositol 4-phosphate binding domain', 'DrrA_P4M', 3, NULL),
(25051, NULL, 'IPR029681', NULL, 'Coiled-coil domain-containing protein 157', 'CCDC157', 4, NULL),
(25052, NULL, 'IPR028613', NULL, 'GDP-mannose mannosyl hydrolase, Enterobacteria', 'GDPMH_Gmm', 4, NULL),
(25053, NULL, 'IPR027976', NULL, 'TATA box-binding protein-associated factor 1D', 'TAF1D', 4, NULL),
(25054, NULL, 'IPR032047', NULL, 'Telomere resolvase ResT', 'Telomere_res', 4, NULL),
(25055, NULL, 'IPR032324', NULL, 'Clp1, N-terminal beta-sandwich domain', 'Clp1_N', 3, NULL),
(25056, NULL, 'IPR032883', NULL, '6-phosphogluconate dehydrogenase, archaea', '6PGDH_archaea', 4, NULL),
(25057, NULL, 'IPR035950', NULL, 'XkdW-like superfamily', 'XkdW-like_sf', 5, NULL),
(25058, NULL, 'IPR032382', NULL, 'Alternaria alternata allergen 1', 'AltA1', 3, NULL),
(25059, NULL, 'IPR032914', NULL, 'Vam6/VPS39/TRAP1 family', 'Vam6/VPS39/TRAP1', 4, NULL),
(25060, NULL, 'IPR026110', NULL, 'Lymphocyte antigen 6 complex locus protein G5c', 'LY6G5C', 4, NULL),
(25061, NULL, 'IPR027985', NULL, 'Rab15 effector', 'Rab15_effector', 4, NULL),
(25062, NULL, 'IPR030855', NULL, 'Bifunctional ligase/repressor BirA', 'Bifunct_BirA', 4, NULL),
(25063, NULL, 'IPR030898', NULL, 'Beta-methylarginine biosynthesis bifunctional aminotransferase', '3metArgNH2trans', 4, NULL),
(25064, NULL, 'IPR027496', NULL, 'Acireductone dioxygenase, eukaryotes', 'ARD_euk', 4, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(25065, NULL, 'IPR032861', NULL, 'Xylanase inhibitor, N-terminal', 'TAXi_N', 3, NULL),
(25066, NULL, 'IPR026469', NULL, 'Putative ABC transporter PGF-CTERM-modified substrate-binding protein', 'Peripla_PGF_1', 4, NULL),
(25067, NULL, 'IPR032408', NULL, 'Sensor histidine kinase RisS, periplasmic domain', 'RisS_PPD', 3, NULL),
(25068, NULL, 'IPR030823', NULL, 'IolE/MocC family', 'IolE/MocC', 4, NULL),
(25069, NULL, 'IPR029083', NULL, 'Immunity protein 32', 'Imm32', 4, NULL),
(25070, NULL, 'IPR027054', NULL, 'Mannosyltransferase ALG2', 'ALG2', 4, NULL),
(25071, NULL, 'IPR026478', NULL, 'Exosortase J', 'Exosortase_J', 4, NULL),
(25072, NULL, 'IPR026106', NULL, 'Microtubule-associated protein 9', 'MAP9', 4, NULL),
(25073, NULL, 'IPR032048', NULL, 'Transglutaminase elicitor', 'TGase_elicitor', 4, NULL),
(25074, NULL, 'IPR030950', NULL, 'Radical SAM family RiPP maturation amino acid epimerase', 'rSAM_PoyD', 4, NULL),
(25075, NULL, 'IPR030429', NULL, 'Sarcospan', 'Sarcospan', 4, NULL),
(25076, NULL, 'IPR026100', NULL, 'Transmembrane protein 223', 'Tmem223', 4, NULL),
(25077, NULL, 'IPR030972', NULL, 'UrcA family protein', 'UrcA_uranyl', 4, NULL),
(25078, NULL, 'IPR029752', NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase, NAD-binding domain conserved site 1', 'D-isomer_DH_CS1', 2, NULL),
(25079, NULL, 'IPR028612', NULL, 'DNA topoisomerase I, type IA', 'Topoisom_1_IA', 4, NULL),
(25080, NULL, 'IPR030669', NULL, 'Molybdenum storage protein subunit alpha/beta', 'MoSto_subunit_alpha/beta', 4, NULL),
(25081, NULL, 'IPR032860', NULL, 'RNA demethylase ALKBH5', 'ALKBH5', 4, NULL),
(25082, NULL, 'IPR034083', NULL, 'DExH-box ATP-dependent RNA helicase, R3H domain', 'R3H_DEXH_helicase', 3, NULL),
(25083, NULL, 'IPR029899', NULL, 'Kinase non-catalytic C-lobe domain-containing protein 1', 'KNDC1', 4, NULL),
(25084, NULL, 'IPR025881', NULL, 'Toxin Ibs', 'Toxin_Ibs', 4, NULL),
(25085, NULL, 'IPR032430', NULL, 'Proteasome activator Blm10, mid region', 'Blm10_mid', 3, NULL),
(25086, NULL, 'IPR027606', NULL, 'Surface protein repeat Ser-Ala-175', 'SerAla_Lrha_rpt', 7, NULL),
(25087, NULL, 'IPR032420', NULL, 'Ubiquitin-activating enzyme E1, four-helix bundle', 'E1_4HB', 3, NULL),
(25088, NULL, 'IPR030948', NULL, 'MoCo/4Fe-4S cofactor protein extended Tat translocation domain', 'MoCo_extend_TAT_dom', 3, NULL),
(25089, NULL, 'IPR029081', NULL, 'Immunity protein 39', 'Imm39', 4, NULL),
(25090, NULL, 'IPR027702', NULL, 'Syncoilin', 'Syncoilin', 4, NULL),
(25091, NULL, 'IPR026580', NULL, 'Cell division protein DivIB', 'DivIB', 4, NULL),
(25092, NULL, 'IPR031631', NULL, 'Glycosyl hydrolase family 63, N-terminal', 'Glyco_hydro_63N', 3, NULL),
(25093, NULL, 'IPR032428', NULL, 'TrfB transcriptional repressor protein', 'TrfB', 3, NULL),
(25094, NULL, 'IPR026178', NULL, 'Junctional sarcoplasmic reticulum protein 1', 'JSRP1', 4, NULL),
(25095, NULL, 'IPR031155', NULL, 'Urea active transporter', 'DUR', 4, NULL),
(25096, NULL, 'IPR029768', NULL, 'Fructose-bisphosphate aldolase class-I active site', 'Aldolase_I_AS', 2, NULL),
(25097, NULL, 'IPR026175', NULL, 'Mirror-image polydactyly gene 1 protein', 'MIPOL1', 4, NULL),
(25098, NULL, 'IPR026182', NULL, 'Anaphase-promoting complex subunit 15', 'ANAPC15', 4, NULL),
(25099, NULL, 'IPR031389', NULL, 'Ribosomal biogenesis factor', 'RBIS', 4, NULL),
(25100, NULL, 'IPR027608', NULL, 'Spirochetes SPASM protein', 'Spiro_SPASM', 4, NULL),
(25101, NULL, 'IPR026237', NULL, 'Probable serine/threonine-protein kinase GDT family', 'STKINASEGDT', 4, NULL),
(25102, NULL, 'IPR032386', NULL, 'Flagellar assembly protein T, middle domain', 'FlgT_M', 3, NULL),
(25103, NULL, 'IPR026971', NULL, 'Condensin subunit 1/Condensin-2 complex subunit D3', 'CND1/NCAPD3', 4, NULL),
(25104, NULL, 'IPR032433', NULL, 'Putative virion glycoprotein, N-terminal', 'DiSB-ORF2_chro', 3, NULL),
(25105, NULL, 'IPR030946', NULL, 'Energy-coupling factor transporter ATP-binding protein EcfA2', 'EcfA2', 4, NULL),
(25106, NULL, 'IPR031373', NULL, 'Circadian-associated transcriptional repressor', 'Ciart', 4, NULL),
(25107, NULL, 'IPR026995', NULL, 'Astrotactin', 'Astrotactin', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(25108, NULL, 'IPR029078', NULL, 'Immunity protein 44', 'Imm44', 4, NULL),
(25109, NULL, 'IPR027307', NULL, 'WASH complex subunit 7', 'WASH7', 4, NULL),
(25110, NULL, 'IPR031101', NULL, 'RNA polymerase-associated protein Ctr9', 'Ctr9', 4, NULL),
(25111, NULL, 'IPR031158', NULL, 'Glycosyl hydrolases family 10, active site', 'GH10_AS', 0, NULL),
(25112, NULL, 'IPR031636', NULL, 'Protein kinase G, tetratricopeptide repeat containing domain', 'PknG_TPR', 3, NULL),
(25113, NULL, 'IPR026464', NULL, 'Nitrous oxide reductase family maturation protein NosD', 'NosD_copper_fam', 4, NULL),
(25114, NULL, 'IPR026173', NULL, 'Sperm-associated antigen 17', 'SPAG17', 4, NULL),
(25115, NULL, 'IPR026180', NULL, 'KAT8 regulatory NSL complex subunit 1', 'NSL1', 4, NULL),
(25116, NULL, 'IPR031490', NULL, 'FAAP20, zinc finger UBZ2-type', 'UBZ2_FAAP20', 3, NULL),
(25117, NULL, 'IPR026490', NULL, 'mRNA cap 0/1 methyltransferase', 'mRNA_cap_0/1_MeTrfase', 3, NULL),
(25118, NULL, 'IPR030658', NULL, 'Macrophage colony-stimulating factor 1 receptor', 'CSF-1_receptor', 4, NULL),
(25119, NULL, 'IPR026042', NULL, 'Stress response protein YjbJ', 'YjbJ', 4, NULL),
(25120, NULL, 'IPR031525', NULL, 'Coiled-coil domain-containing protein 190', 'CC190', 4, NULL),
(25121, NULL, 'IPR026323', NULL, 'Exosortase-related protein XrtF', 'Exosortase-related_prot_XrtF', 4, NULL),
(25122, NULL, 'IPR030611', NULL, 'Aurora kinase A', 'AURKA', 3, NULL),
(25123, NULL, 'IPR032311', NULL, 'Domain of unknown function DUF4982', 'DUF4982', 3, NULL),
(25124, NULL, 'IPR029097', NULL, 'Bacterial toxin 8', 'Ntox8', 3, NULL),
(25125, NULL, 'IPR029093', NULL, 'Testis-expressed protein 19', 'TEX19', 4, NULL),
(25126, NULL, 'IPR030973', NULL, 'Conserved hypothetical protein CHP04434', 'CHP04434', 4, NULL),
(25127, NULL, 'IPR032307', NULL, 'Putative PepSY TM-like protein', 'PepSY_TM-like_2', 4, NULL),
(25128, NULL, 'IPR027291', NULL, 'Glycoside hydrolase 38, N-terminal domain superfamily', 'Glyco_hydro_38_N_sf', 5, NULL),
(25129, NULL, 'IPR032304', NULL, 'Subtilase, N-terminal', 'Peptidase_S8_N', 3, NULL),
(25130, NULL, 'IPR029962', NULL, 'Trichome birefringence-like family', 'TBL', 4, NULL),
(25131, NULL, 'IPR028920', NULL, 'Tox-ART-HYD1 domain', 'Tox-ART-HYD1_dom', 3, NULL),
(25132, NULL, 'IPR027528', NULL, 'Eukaryotic translation initiation factor 3 subunit M', 'eIF3m', 4, NULL),
(25133, NULL, 'IPR032313', NULL, 'Domain of unknown function DUF4980', 'DUF4980', 3, NULL),
(25134, NULL, 'IPR032423', NULL, 'AAA C-terminal domain', 'AAA_assoc_2', 3, NULL),
(25135, NULL, 'IPR026097', NULL, 'S100P-binding protein', 'S100PBP', 4, NULL),
(25136, NULL, 'IPR026470', NULL, 'Flavivirus envelope glycoprotein E, Stem/Anchor domain', 'Flavi_E_Stem/Anchor_dom', 3, NULL),
(25137, NULL, 'IPR031161', NULL, 'Peptidase family M60 domain', 'Peptidase_M60_dom', 3, NULL),
(25138, NULL, 'IPR026184', NULL, 'Placenta-expressed transcript 1', 'PLET1', 4, NULL),
(25139, NULL, 'IPR030400', NULL, 'Sedolisin domain', 'Sedolisin_dom', 3, NULL),
(25140, NULL, 'IPR032523', NULL, 'Cytochrome c-type biogenesis protein CcmF, C-terminal', 'CcmF_C', 3, NULL),
(25141, NULL, 'IPR027430', NULL, 'Visual pigments (opsins) retinal binding site', 'Retinal_BS', 1, NULL),
(25142, NULL, 'IPR031311', NULL, 'Chitin-binding type R&R consensus', 'CHIT_BIND_RR_consensus', 2, NULL),
(25143, NULL, 'IPR032530', NULL, 'Domain of unknown function DUF4957', 'DUF4957', 3, NULL),
(25144, NULL, 'IPR030966', NULL, 'Putative peptide modification system cyclase', 'Mod_pep_cyc', 4, NULL),
(25145, NULL, 'IPR026635', NULL, 'Protein-lysine N-methyltransferase Efm4/METTL10', 'Efm4/METTL10', 4, NULL),
(25146, NULL, 'IPR030030', NULL, 'Scaffold protein salvador', 'Sav', 4, NULL),
(25147, NULL, 'IPR029103', NULL, 'Bacterial toxin 47', 'Ntox47', 3, NULL),
(25148, NULL, 'IPR030683', NULL, 'Protein phosphatase 1 regulatory subunit 3C', 'PP1_3C', 4, NULL),
(25149, NULL, 'IPR028931', NULL, 'CENP-C, middle DNMT3B-binding domain', 'CENP-C_mid', 3, NULL),
(25150, NULL, 'IPR026179', NULL, 'SLAIN motif-containing protein', 'Slain', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(25151, NULL, 'IPR026201', NULL, 'Centrosomal protein of 290kDa', 'Cep290', 4, NULL),
(25152, NULL, 'IPR030603', NULL, 'Kelch-like protein 18, BTB/POZ domain', 'KLHL18_BTB/POZ', 3, NULL),
(25153, NULL, 'IPR031000', NULL, 'Proline reductase cluster protein PrdD', 'D_pro_red_PrdD', 4, NULL),
(25154, NULL, 'IPR025741', NULL, 'Centrosome-associated, FAM110, C-terminal domain', 'FAM110_C', 3, NULL),
(25155, NULL, 'IPR032527', NULL, 'Domain of unknown function DUF4959', 'DUF4959', 3, NULL),
(25156, NULL, 'IPR029079', NULL, 'Immunity protein 43', 'Imm43', 3, NULL),
(25157, NULL, 'IPR031451', NULL, 'mRNA interferase toxin MqsR', 'MqsR_toxin', 4, NULL),
(25158, NULL, 'IPR031640', NULL, 'Glucose dehydrogenase, C-terminal', 'Glu_dehyd_C', 3, NULL),
(25159, NULL, 'IPR032440', NULL, '40S ribosomal protein S11, N-terminal', 'Ribosomal_S11_N', 3, NULL),
(25160, NULL, 'IPR028917', NULL, 'Tox-GHH2 domain', 'Tox-GHH2_domain', 3, NULL),
(25161, NULL, 'IPR026630', NULL, 'EPM2A-interacting protein 1/ZBED8-like', 'EPM2A-int_1/ZBED8-like', 4, NULL),
(25162, NULL, 'IPR027681', NULL, 'I-BAR domain containing protein IRSp53/IRTKS/Pinkbar', 'IRSp53/IRTKS/Pinkbar', 4, NULL),
(25163, NULL, 'IPR032330', NULL, 'Elongation factor G-binding protein, C-terminal treble-clef zinc-finger', 'EF-G-binding_C', 3, NULL),
(25164, NULL, 'IPR032434', NULL, 'Emaravirus P4 movement protein', 'Emaravirus_P4', 4, NULL),
(25165, NULL, 'IPR028618', NULL, 'ATP-dependent RNA helicase DeaD', 'DEAD_helicase_DeaD', 4, NULL),
(25166, NULL, 'IPR026474', NULL, 'Plantazolicin', 'Plantazolicin', 4, NULL),
(25167, NULL, 'IPR026096', NULL, 'Receptor-transporting protein', 'R-trans_p', 4, NULL),
(25168, NULL, 'IPR026192', NULL, 'NADH-ubiquinone oxidoreductase 1 subunit C1', 'NDUFC1', 4, NULL),
(25169, NULL, 'IPR030884', NULL, 'Uncharacterised protein family CHP04551', 'CHP04551', 4, NULL),
(25170, NULL, 'IPR029076', NULL, 'Immunity protein 47', 'Imm47', 4, NULL),
(25171, NULL, 'IPR026598', NULL, 'GMP synthase subunit B', 'GMP_synthase_B', 4, NULL),
(25172, NULL, 'IPR027531', NULL, 'Eukaryotic translation initiation factor 3 subunit F', 'eIF3f', 4, NULL),
(25173, NULL, 'IPR026843', NULL, 'Nuclease SbcCD subunit D, C-terminal domain', 'SbcD_C', 3, NULL),
(25174, NULL, 'IPR031619', NULL, 'DNA transfer protein', 'Inj_translocase', 4, NULL),
(25175, NULL, 'IPR032290', NULL, 'Protein of unknown function DUF4839', 'DUF4839', 4, NULL),
(25176, NULL, 'IPR032410', NULL, 'Mitochondrial ABC-transporter, N-terminal five TM domain', 'MTABC_N', 3, NULL),
(25177, NULL, 'IPR028060', NULL, 'Big defensin domain', 'Defensin_big_dom', 3, NULL),
(25178, NULL, 'IPR031635', NULL, 'Growth factor receptor NTRK, leucine rich repeat C-terminal', 'NTRK_LRRCT', 3, NULL),
(25179, NULL, 'IPR031526', NULL, 'Protein of unknown function DUF4698', 'DUF4698', 4, NULL),
(25180, NULL, 'IPR031306', NULL, 'CcdC protein', 'CcdC', 4, NULL),
(25181, NULL, 'IPR032403', NULL, 'Exocyst component Exo84, C-terminal', 'Exo84_C', 3, NULL),
(25182, NULL, 'IPR028135', NULL, 'Ubiquitin-like domain, USP-type', 'Ub_USP-typ', 3, NULL),
(25183, NULL, 'IPR027309', NULL, 'P2X purinoreceptor extracellular domain superfamily', 'P2X_extracellular_dom_sf', 5, NULL),
(25184, NULL, 'IPR032835', NULL, 'Rho GTPase-activating protein, FF domain', 'RhoGAP-FF1', 3, NULL),
(25185, NULL, 'IPR031602', NULL, 'Clock-interacting pacemaker', 'CIPC', 4, NULL),
(25186, NULL, 'IPR031621', NULL, 'Histidine kinase, N-terminal 7TM region', 'HisKA_7TM', 3, NULL),
(25187, NULL, 'IPR025750', NULL, 'DPF1-3, N-terminal domain', 'DPF1-3_N', 3, NULL),
(25188, NULL, 'IPR030900', NULL, 'GMC family mycofactocin-associated oxidreductase', 'GMC_mycofac_OxRdtase', 4, NULL),
(25189, NULL, 'IPR030907', NULL, 'Ferritin-like protein', 'Ferrit_encaps', 4, NULL),
(25190, NULL, 'IPR027685', NULL, 'Shroom family', 'Shroom_fam', 4, NULL),
(25191, NULL, 'IPR024719', NULL, 'HpaB/PvcC/4-BUDH C-terminal', 'HpaB/PvcC/4-BUDH_C', 3, NULL),
(25192, NULL, 'IPR030547', NULL, 'DNA repair protein XRCC2', 'XRCC2', 4, NULL),
(25193, NULL, 'IPR030893', NULL, 'MOLPALP family lipoprotein', 'Mollicu_LP', 4, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(25194, NULL, 'IPR031440', NULL, 'Protein of unknown function DUF4670', 'DUF4670', 4, NULL),
(25195, NULL, 'IPR027659', NULL, 'Beta-sarcoglycan', 'Sgcb', 4, NULL),
(25196, NULL, 'IPR029087', NULL, 'Immunity protein 17', 'Imm17', 4, NULL),
(25197, NULL, 'IPR031100', NULL, 'LOG family', 'LOG_fam', 4, NULL),
(25198, NULL, 'IPR026461', NULL, 'Transferase 2, rSAM/selenodomain-associated', 'Trfase_2_rSAM/seldom_assoc', 4, NULL),
(25199, NULL, 'IPR025740', NULL, 'FAM110', 'FAM110', 4, NULL),
(25200, NULL, 'IPR032418', NULL, 'Ubiquitin-activating enzyme E1, FCCH domain', 'E1_FCCH', 3, NULL),
(25201, NULL, 'IPR028056', NULL, 'Colicin M', 'Colicin_M', 4, NULL),
(25202, NULL, 'IPR026195', NULL, 'P-selectin glycoprotein ligand 1', 'PSGL-1', 4, NULL),
(25203, NULL, 'IPR030899', NULL, '2-ketoarginine methyltransferase', 'MrsA', 4, NULL),
(25204, NULL, 'IPR032867', NULL, 'DYW domain', 'DYW_dom', 3, NULL),
(25205, NULL, 'IPR026053', NULL, 'BLOC-3 complex member HPS1', 'HPS1', 4, NULL),
(25206, NULL, 'IPR032820', NULL, 'Putative F0F1-ATPase subunit, Ca2+/Mg2+ transporter', 'ATPase_put', 4, NULL),
(25207, NULL, 'IPR030894', NULL, 'Fe-coproporphyrin III synthase AhbC, Proteobacteria type', 'Ahb_Proteobacteria', 4, NULL),
(25208, NULL, 'IPR026468', NULL, 'Nitrous-oxide reductase, Sec-dependent', 'Nitrous_oxide_Rdtase_Sec-dep', 4, NULL),
(25209, NULL, 'IPR032287', NULL, 'Protein of unknown function DUF4838', 'DUF4838', 4, NULL),
(25210, NULL, 'IPR031613', NULL, 'Pathogenicity locus protein HrpK', 'HrpK', 4, NULL),
(25211, NULL, 'IPR031046', NULL, 'Carnosine synthase 1', 'CARNS1', 4, NULL),
(25212, NULL, 'IPR031639', NULL, 'Annelid erythrocruorin linker subunit, C-terminal', 'Eryth_link_C', 3, NULL),
(25213, NULL, 'IPR026322', NULL, 'Geopeptide radical SAM maturase, putative', 'Geopep_mat_rSAM', 4, NULL),
(25214, NULL, 'IPR031007', NULL, 'Phenylalanine aminomutase (D-beta-phenylalanine forming)', 'Phe_D_beta_mut', 4, NULL),
(25215, NULL, 'IPR030959', NULL, 'GWxTD domain', 'GWxTD_dom', 3, NULL),
(25216, NULL, 'IPR031390', NULL, 'Orofacial cleft 1 candidate gene 1 protein', 'OFCC1', 4, NULL),
(25217, NULL, 'IPR030939', NULL, 'Acido-empty-quinoprotein group A', 'Acido_non_PQQ', 4, NULL),
(25218, NULL, 'IPR032865', NULL, 'Prokaryotic E2 family A', 'Prok-E2_A', 4, NULL),
(25219, NULL, 'IPR032334', NULL, 'Gram-positive pilin backbone subunit 2, Cna-B-like domain', 'GramPos_pilinBB', 3, NULL),
(25220, NULL, 'IPR026968', NULL, '3-oxoadipate enol-lactonase 1/2', 'PcaD/CatD', 4, NULL),
(25221, NULL, 'IPR024755', NULL, 'Circularly permutated YpsA SLOG', 'cpYpsA', 4, NULL),
(25222, NULL, 'IPR028930', NULL, 'Cancer/testis antigen 47', 'CT47', 4, NULL),
(25223, NULL, 'IPR026200', NULL, 'TYRO protein tyrosine kinase-binding protein', 'Tyrobp', 4, NULL),
(25224, NULL, 'IPR027787', NULL, 'Alpha/beta-hydrolase, catalytic domain', 'Alpha/beta-hydrolase_catalytic', 3, NULL),
(25225, NULL, 'IPR031004', NULL, 'Radical SAM/CxCxxxxC motif protein YfkAB', 'rSAM_YfkAB', 4, NULL),
(25226, NULL, 'IPR030947', NULL, 'Energy-coupling factor transporter ATP-binding protein EcfA1', 'EcfA_1', 4, NULL),
(25227, NULL, 'IPR028928', NULL, 'CC2D2A, N-terminal, C2 domain', 'CC2D2AN-C2', 3, NULL),
(25228, NULL, 'IPR031618', NULL, 'Putative type IV secretory system protein', 'T4SS_TraI', 4, NULL),
(25229, NULL, 'IPR032421', NULL, 'Protein O-mannosyl-transferase, C-terminal four TM domain', 'PMT_4TMC', 3, NULL),
(25230, NULL, 'IPR025872', NULL, 'RING finger family 2, prokaryotic', 'RING_finger_2_prok', 4, NULL),
(25231, NULL, 'IPR026465', NULL, 'Serine-rich repeat adhesion glycoprotein', 'Ser_adhes_glycop', 3, NULL),
(25232, NULL, 'IPR031066', NULL, 'Basic helix-loop-helix (bHLH) transcription factors ALC-like, plant', 'bHLH_ALC-like_plant', 4, NULL),
(25233, NULL, 'IPR026460', NULL, 'Aldehyde dehydrogenase, Rv0768 family', 'Aldehyde_dehydrogenase_Rv0768', 4, NULL),
(25234, NULL, 'IPR029074', NULL, 'Immunity protein 49', 'Imm49', 4, NULL),
(25235, NULL, 'IPR029731', NULL, 'OKL38 family', 'OKL38_fam', 4, NULL),
(25236, NULL, 'IPR029077', NULL, 'Immunity protein 45', 'Imm45', 3, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(25237, NULL, 'IPR030909', NULL, 'IMEF cargo protein', 'IMEF_cargo', 4, NULL),
(25238, NULL, 'IPR032319', NULL, 'Polyribonucleotide 5''-hydroxyl-kinase Clp1, P-loop domain', 'CLP1_P', 3, NULL),
(25239, NULL, 'IPR031003', NULL, 'Radical SAM P-methyltransferase, PhpK family', 'BcpD_PhpK_rSAM', 4, NULL),
(25240, NULL, 'IPR032866', NULL, 'Prokaryotic Ubiquitin', 'Prok_Ub', 4, NULL),
(25241, NULL, 'IPR029691', NULL, 'Prostate and testis expressed protein 2', 'PATE2', 4, NULL),
(25242, NULL, 'IPR032884', NULL, 'NAD-dependent glucose-6-phosphate dehydrogenase, archaea', 'Glc6PDH_archaea', 4, NULL),
(25243, NULL, 'IPR031529', NULL, 'Interactor of HORMAD1 protein 1', 'IHO1', 4, NULL),
(25244, NULL, 'IPR030890', NULL, 'Substrate import-associated zinc metallohydrolase lipoprotein', 'LP_HExxH_w_TonB', 4, NULL),
(25245, NULL, 'IPR031310', NULL, 'Ribosomal protein L5, N-terminal', 'Ribosomal_L5_N', 3, NULL),
(25246, NULL, 'IPR031438', NULL, 'Mitochondrial coiled-coil domain protein 1', 'MCCD1', 4, NULL),
(25247, NULL, 'IPR029080', NULL, 'Immunity protein 40', 'Imm40', 3, NULL),
(25248, NULL, 'IPR031860', NULL, 'Protein of unknown function DUF4754', 'DUF4754', 4, NULL),
(25249, NULL, 'IPR026463', NULL, 'Chitooligosaccharide synthase NodC', 'Chitooligosach_Synthase_NodC', 4, NULL),
(25250, NULL, 'IPR031164', NULL, 'SAM-binding methyltransferase MPBQ/MBSQ', 'SAM_MPBQ_MSBQ_MT', 3, NULL),
(25251, NULL, 'IPR028918', NULL, 'Tox-ART-HYE1 domain', 'Tox-ART-HYE1_dom', 3, NULL),
(25252, NULL, 'IPR029094', NULL, 'Draxin', 'Draxin', 4, NULL),
(25253, NULL, 'IPR024904', NULL, 'Ornithine carbamoyltransferase', 'OTCase_ArgI', 4, NULL),
(25254, NULL, 'IPR026017', NULL, 'Lumazine-binding domain', 'Lumazine-bd_dom', 3, NULL),
(25255, NULL, 'IPR032882', NULL, 'SrkA/RdoA protein kinase', 'SrkA/RdoA', 4, NULL),
(25256, NULL, 'IPR029102', NULL, 'Bacterial toxin 4', 'Ntox4', 3, NULL),
(25257, NULL, 'IPR031369', NULL, 'Proline-rich protein 18', 'PRR18', 4, NULL),
(25258, NULL, 'IPR028885', NULL, 'Adenylyltransferase and sulfurtransferase MOCS3/Uba4', 'MOCS3/Uba4', 4, NULL),
(25259, NULL, 'IPR028925', NULL, 'Demeter, RRM-fold domain', 'RRM_DME', 3, NULL),
(25260, NULL, 'IPR032398', NULL, 'Infectious hypodermal and haematopoietic necrosis virus, capsid protein', 'IHHNV_capsid', 4, NULL),
(25261, NULL, 'IPR030852', NULL, 'Outer membrane lipoprotein RcsF', 'RcsF', 4, NULL),
(25262, NULL, 'IPR028938', NULL, 'Remodeling and spacing factor 1-like', 'Rsf1-like', 4, NULL),
(25263, NULL, 'IPR031487', NULL, 'Protein of unknown function DUF4687', 'DUF4687', 4, NULL),
(25264, NULL, 'IPR030805', NULL, 'Oxidoreductase-SelD-related fusion protein', 'Oxidorec-SedlD_fusion', 4, NULL),
(25265, NULL, 'IPR030476', NULL, 'Pentaxin, conserved site', 'Pentaxin_CS', 2, NULL),
(25266, NULL, 'IPR030958', NULL, 'P450-derived glycosyltranferase activator', 'P450-rel_GT_act', 4, NULL),
(25267, NULL, 'IPR032312', NULL, 'Beta-galactosidase, domain 4', 'LacZ_4', 3, NULL),
(25268, NULL, 'IPR030687', NULL, 'Sterol O-acyltransferase, metazoa', 'Sterol_acyltranf_meta', 4, NULL),
(25269, NULL, 'IPR029100', NULL, 'Bacterial toxin 50', 'Ntox50', 3, NULL),
(25270, NULL, 'IPR030944', NULL, 'Helix-rich protein', 'Mplasa_alph_rch', 4, NULL),
(25271, NULL, 'IPR028138', NULL, 'Neuropeptide S', 'Neuropeptide_S', 4, NULL),
(25272, NULL, 'IPR028926', NULL, 'CEP76, C2 domain', 'CEP76-C2', 3, NULL),
(25273, NULL, 'IPR031098', NULL, 'Crustacean CHH/MIH/GIH neurohormone family', 'Crust_neurohorm', 4, NULL),
(25274, NULL, 'IPR026472', NULL, 'E3 CR1-alpha-1', 'E3_CR1-alpha-1', 3, NULL),
(25275, NULL, 'IPR031303', NULL, 'DNA methylase, C-5 cytosine-specific,  conserved site', 'C5_meth_CS', 2, NULL),
(25276, NULL, 'IPR029090', NULL, 'Protein of unknown function DUF4659', 'DUF4659', 4, NULL),
(25277, NULL, 'IPR029901', NULL, 'Protein Spire', 'Spire', 4, NULL),
(25278, NULL, 'IPR030827', NULL, 'Inositol 2-dehydrogenase', 'Myo_inos_IolG', 4, NULL),
(25279, NULL, 'IPR026043', NULL, 'Transcription repressor NadR', 'NadR', 4, NULL),
(25280, NULL, 'IPR027611', NULL, 'Sporadic carbohydrate cluster 2-oxoglutarate-Fe(II) oxygenase', 'SpoChClust_oxygenase', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(25281, NULL, 'IPR026324', NULL, 'Haem oxygenase, HugZ', 'Haem_oxygenase_HugZ', 4, NULL),
(25282, NULL, 'IPR027274', NULL, 'Protein kinase C, epsilon', 'PKC_epsilon', 4, NULL),
(25283, NULL, 'IPR027973', NULL, 'Protein of unknown function DUF4602', 'DUF4602', 4, NULL),
(25284, NULL, 'IPR028846', NULL, 'Recoverin family', 'Recoverin', 4, NULL),
(25285, NULL, 'IPR030940', NULL, 'Uncharacterised protein MG279/MG280', 'MG279/MG280', 4, NULL),
(25286, NULL, 'IPR028049', NULL, 'NTF2 fold immunity protein', 'Imm-NTF2', 3, NULL),
(25287, NULL, 'IPR026171', NULL, 'Fanconi anemia group I protein', 'FANCI', 4, NULL),
(25288, NULL, 'IPR032529', NULL, 'BT4661-like', 'BT4661-like', 4, NULL),
(25289, NULL, 'IPR032974', NULL, 'Polyprenol kinase family', 'Polypren_kinase', 4, NULL),
(25290, NULL, 'IPR028579', NULL, 'Putative thymidine phosphorylase', 'Thym_Pase_Put', 4, NULL),
(25291, NULL, 'IPR031486', NULL, 'Transmembrane protein 215', 'TMEM215', 4, NULL),
(25292, NULL, 'IPR028050', NULL, 'Toxin in Odyssella and Amoebophilus', 'Tox-ODYAM1', 4, NULL),
(25293, NULL, 'IPR030965', NULL, 'Putative peptide maturation dehydrogenase', 'SagB-rel_DH_2', 4, NULL),
(25294, NULL, 'IPR030837', NULL, 'Putative variant cofactor biosynthesis B12-binding domain/radical SAM domain protein 1', 'B12_rSAM_cofa1', 4, NULL),
(25295, NULL, 'IPR030892', NULL, 'DnaD family protein', 'DnaD_Mollicutes', 4, NULL),
(25296, NULL, 'IPR032516', NULL, 'Na+/H+ antiporter, budding yeast', 'Nha1', 4, NULL),
(25297, NULL, 'IPR027932', NULL, 'Protein of unknown function DUF4606', 'DUF4606', 4, NULL),
(25298, NULL, 'IPR031006', NULL, 'Exosortase N', 'Exosort_XrtN', 4, NULL),
(25299, NULL, 'IPR032294', NULL, 'Domain of unknown function DUF4841', 'DUF4841', 3, NULL),
(25300, NULL, 'IPR027495', NULL, 'Thiamine thiazole synthase', 'Sti35', 4, NULL),
(25301, NULL, 'IPR028624', NULL, 'Transcription elongation factor GreA/GreB', 'Tscrpt_elong_fac_GreA/B', 4, NULL),
(25302, NULL, 'IPR032531', NULL, 'Protein of unknown function DUF4956', 'DUF4956', 4, NULL),
(25303, NULL, 'IPR030564', NULL, 'Myotubularin family', 'Myotubularin_fam', 4, NULL),
(25304, NULL, 'IPR031137', NULL, 'Growth-regulating factor', 'GRF', 4, NULL),
(25305, NULL, 'IPR032946', NULL, 'BPI fold-containing family A member 3', 'Bpifa3', 4, NULL),
(25306, NULL, 'IPR028619', NULL, 'ATP-dependent RNA helicase DbpA', 'DEAD_helicase_DbpA', 4, NULL),
(25307, NULL, 'IPR027533', NULL, 'Very-long-chain 3-oxoacyl-CoA reductase, fungal', '3_ketoreductase_fungal', 4, NULL),
(25308, NULL, 'IPR026477', NULL, 'XrtJ-associated TM-motif-TM protein', 'Targ_of_XrtJ', 4, NULL),
(25309, NULL, 'IPR026109', NULL, 'G kinase-anchoring protein 1', 'GKAP1', 4, NULL),
(25310, NULL, 'IPR026693', NULL, 'Zinc finger CCCH-type antiviral protein 1-like', 'Zc3hav1-like', 4, NULL),
(25311, NULL, 'IPR028052', NULL, 'Kinetochore assembly subunit CENP-C, N-terminal domain', 'CENP-C_N_dom', 3, NULL),
(25312, NULL, 'IPR028046', NULL, 'Immunity protein 75', 'Imm75', 4, NULL),
(25313, NULL, 'IPR032886', NULL, 'tRNA-dihydrouridine(16) synthase', 'DusC', 4, NULL),
(25314, NULL, 'IPR028616', NULL, 'Regulator of RpoS', 'RssB', 4, NULL),
(25315, NULL, 'IPR030791', NULL, 'Rotatin', 'Rotatin', 4, NULL),
(25316, NULL, 'IPR027707', NULL, 'Troponin T', 'TNNT', 4, NULL),
(25317, NULL, 'IPR027525', NULL, 'Eukaryotic translation initiation factor 3 subunit I', 'eIF3i', 4, NULL),
(25318, NULL, 'IPR030889', NULL, 'Three transmembrane helix protein', '3TM_Mycoplasma', 4, NULL),
(25319, NULL, 'IPR032303', NULL, 'YaiA protein', 'YaiA', 4, NULL),
(25320, NULL, 'IPR032305', NULL, 'GTP-binding protein, middle domain', 'GTP-bd_M', 3, NULL),
(25321, NULL, 'IPR028609', NULL, 'Alanine dehydrogenase, archaeal-type', 'AlaDH_arch-typ', 4, NULL),
(25322, NULL, 'IPR031140', NULL, 'Protein indeterminate-domain 1-16', 'IDD1-16', 4, NULL),
(25323, NULL, 'IPR028883', NULL, 'tRNA-specific adenosine deaminase', 'tRNA_aden_deaminase', 4, NULL),
(25324, NULL, 'IPR031528', NULL, 'Protein of unknown function DUF4699', 'DUF4699', 4, NULL),
(25325, NULL, 'IPR027975', NULL, 'TMEM71 protein family', 'TMEM71', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(25326, NULL, 'IPR027276', NULL, 'Transforming protein C-ets-2', 'Transform_prot_C-ets-2', 4, NULL),
(25327, NULL, 'IPR030904', NULL, 'Cytochrome P450, CypX', 'CypX', 4, NULL),
(25328, NULL, 'IPR032942', NULL, 'BPI/LBP/Plunc family', 'BPI/LBP/Plunc', 4, NULL),
(25329, NULL, 'IPR031629', NULL, 'Dipicolinate synthase subunit A, N-terminal', 'DpaA_N', 3, NULL),
(25330, NULL, 'IPR026585', NULL, 'Alpha-1,4-glucan:maltose-1-phosphate maltosyltransferase', 'GlgE', 4, NULL),
(25331, NULL, 'IPR032404', NULL, 'Two-component sensor protein CpxA, periplasmic domain', 'CpxA_peri', 3, NULL),
(25332, NULL, 'IPR026475', NULL, 'Archaetidylserine synthase', 'Archaetidylserine_synthase', 4, NULL),
(25333, NULL, 'IPR031641', NULL, 'Phthiocerol/phthiodiolone dimycocerosyl transferase, C-terminal', 'PapA_C', 3, NULL),
(25334, NULL, 'IPR029089', NULL, 'Protein of unknown function DUF4660', 'DUF4660', 4, NULL),
(25335, NULL, 'IPR030908', NULL, 'Protein translocase subunit SecA 2, Bacillus anthracis-type', 'SecA2_Bac_anthr', 4, NULL),
(25336, NULL, 'IPR026252', NULL, 'Aquaporin 10', 'Aquaporin_10', 4, NULL),
(25337, NULL, 'IPR030975', NULL, 'Putative 2OG-Fe(II) oxygenase', 'SpoChoClust_3', 4, NULL),
(25338, NULL, 'IPR032336', NULL, 'Pathogenicity island component CagD', 'CagD', 4, NULL),
(25339, NULL, 'IPR030974', NULL, 'Restriction system-associated AAA family ATPase', 'Restrict_AAA', 4, NULL),
(25340, NULL, 'IPR028929', NULL, 'Mif2, N-terminal', 'Mif2_N', 3, NULL),
(25341, NULL, 'IPR029091', NULL, 'Chromatin assembly factor 1 subunit p150, N-terminal', 'CAF1_p150_N', 3, NULL),
(25342, NULL, 'IPR026190', NULL, 'Hypoxia-inducible lipid droplet-associated protein', 'Hipoxia_HILPDA', 4, NULL),
(25343, NULL, 'IPR030684', NULL, 'Lactotransferrin', 'Lactotransferrin', 4, NULL),
(25344, NULL, 'IPR031538', NULL, 'Tryptophan RNA-binding attenuator protein inhibitory protein', 'Anti-TRAP', 4, NULL),
(25345, NULL, 'IPR031309', NULL, 'Ribosomal protein L5, C-terminal', 'Ribosomal_L5_C', 3, NULL),
(25346, NULL, 'IPR029546', NULL, 'Astrocytic phosphoprotein PEA-15, death effector domain', 'PEA15_DED', 3, NULL),
(25347, NULL, 'IPR031371', NULL, 'Cell-membrane associated Mucin-15', 'Mucin-15', 4, NULL),
(25348, NULL, 'IPR028924', NULL, 'Permuted single zf-CXXC unit', 'Perm-CXXC', 3, NULL),
(25349, NULL, 'IPR031400', NULL, 'Gametogenetin', 'GGN', 4, NULL),
(25350, NULL, 'IPR031496', NULL, 'Protein of unknown function DUF4688', 'DUF4688', 4, NULL),
(25351, NULL, 'IPR028137', NULL, 'Syncollin', 'Syncollin', 4, NULL),
(25352, NULL, 'IPR032401', NULL, 'Enhancer of mRNA-decapping protein 4, WD40 repeat region', 'EDC4_WD40', 3, NULL),
(25353, NULL, 'IPR026095', NULL, 'Myb/SANT-like DNA-binding domain-containing protein', 'Myb/SANT-like_DNA-bd_dom_prot', 4, NULL),
(25354, NULL, 'IPR031105', NULL, 'Telomere repeat-binding protein, plant', 'TRP_plant', 4, NULL),
(25355, NULL, 'IPR027605', NULL, 'Putative ornithine decarboxylase, Lactobacillus', 'Lacto_ODC_put', 4, NULL),
(25356, NULL, 'IPR032335', NULL, 'Sam68, tyrosine-rich domain', 'Sam68-YY', 3, NULL),
(25357, NULL, 'IPR032405', NULL, 'Kinesin-associated', 'Kinesin_assoc', 3, NULL),
(25358, NULL, 'IPR032052', NULL, 'CD3 gamma/delta subunit, Ig-like domain', 'Ig_4', 3, NULL),
(25359, NULL, 'IPR032979', NULL, 'Cytosolic endo-beta-N-acetylglucosaminidase', 'ENGase', 4, NULL),
(25360, NULL, 'IPR028468', NULL, 'Smc1, ATP-binding cassette domain', 'Smc1_ABC', 3, NULL),
(25361, NULL, 'IPR030941', NULL, 'Putative immunoglobulin-blocking virulence protein', 'Predic_Ig_block', 4, NULL),
(25362, NULL, 'IPR026471', NULL, 'Zinc metalloproteinase 18-residue repeat', 'Zmp_18_rpt', 7, NULL),
(25363, NULL, 'IPR034300', NULL, 'NADP transhydrogenase beta-like domain', 'PNTB-like', 3, NULL),
(25364, NULL, 'IPR030606', NULL, 'Kelch-like protein 5, BTB/POZ domain', 'KLHL5_BTB/POZ', 3, NULL),
(25365, NULL, 'IPR029085', NULL, 'Immunity protein 25', 'Imm25', 3, NULL),
(25366, NULL, 'IPR028617', NULL, 'RNA polymerase sigma factor FliA', 'Sigma70_FliA', 4, NULL),
(25367, NULL, 'IPR028621', NULL, 'ATP-dependent RNA helicase SrmB', 'DEAD_helicase_SrmB', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(25368, NULL, 'IPR026185', NULL, 'Epithelial-stromal interaction protein 1', 'EPSTI1', 4, NULL),
(25369, NULL, 'IPR028884', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit', 'Trm82', 4, NULL),
(25370, NULL, 'IPR032384', NULL, 'Kinesin-like protein Kif23, Arf6-interacting domain', 'Kif23_Arf-bd', 3, NULL),
(25371, NULL, 'IPR029092', NULL, 'ZW10 interactor', 'Zwint-1', 4, NULL),
(25372, NULL, 'IPR032409', NULL, 'Rho guanine nucleotide exchange factor 6/7, coiled-coil domain', 'GEF6/7_CC', 3, NULL),
(25373, NULL, 'IPR028622', NULL, 'ATP-dependent RNA helicase RhlE', 'DEAD_helicase_RhlE', 4, NULL),
(25374, NULL, 'IPR030542', NULL, 'Tandem C2 domains nuclear protein', 'Tac2-N', 4, NULL),
(25375, NULL, 'IPR032416', NULL, 'Peptidase M24, C-terminal domain', 'Peptidase_M24_C', 3, NULL),
(25376, NULL, 'IPR030477', NULL, 'Interleukin-2, conserved site', 'IL-2_CS', 2, NULL),
(25377, NULL, 'IPR031600', NULL, 'Domain of unknown function DUF4706', 'DUF4706', 3, NULL),
(25378, NULL, 'IPR026634', NULL, 'Protein-tyrosine sulfotransferase', 'TPST', 4, NULL),
(25379, NULL, 'IPR032281', NULL, '40S ribosomal protein SA, C-terminal domain', '40S_SA_C', 3, NULL),
(25380, NULL, 'IPR030897', NULL, 'Choline trimethylamine-lyase', 'Choline_CutC', 4, NULL),
(25381, NULL, 'IPR029073', NULL, 'Protein of unknown function DUF4661', 'DUF4661', 4, NULL),
(25382, NULL, 'IPR026188', NULL, 'Lebercilin-like', 'Lebercilin-like', 4, NULL),
(25383, NULL, 'IPR031163', NULL, 'Filoviruses VP35 interferon inhibitory domain', 'VP35_IID', 3, NULL),
(25384, NULL, 'IPR030949', NULL, 'ECF transporter S component, folate family', 'ECF_S_folate_fam', 4, NULL),
(25385, NULL, 'IPR030943', NULL, 'IgG-blocking protein M', 'M_MG281', 4, NULL),
(25386, NULL, 'IPR026576', NULL, 'Proofreading thioesterase EntH', 'Thioesterase_EntH', 4, NULL),
(25387, NULL, 'IPR032321', NULL, 'Centrosomal protein of 290kDa, coiled-coil region', 'Cep209_CC5', 3, NULL),
(25388, NULL, 'IPR030903', NULL, 'Cyclodipeptide synthase', 'CDPS', 4, NULL),
(25389, NULL, 'IPR031399', NULL, 'Testis development-related protein', 'TDRP', 4, NULL),
(25390, NULL, 'IPR032337', NULL, 'Regulation of nuclear pre-mRNA domain-containing protein 1A/B', 'RPR1A/B', 3, NULL),
(25391, NULL, 'IPR031617', NULL, 'Putative exopolysaccharide exporter', 'PelG', 4, NULL),
(25392, NULL, 'IPR026187', NULL, 'Cell death regulator Aven', 'Aven', 4, NULL),
(25393, NULL, 'IPR035951', NULL, 'TM1622-like superfamily', 'TM1622-like_sf', 5, NULL),
(25394, NULL, 'IPR029504', NULL, 'Microcephalin, mammal', 'Microcephalin_mammal', 4, NULL),
(25395, NULL, 'IPR032978', NULL, 'Zinc finger MYND domain-containing protein 19', 'ZMYND19', 4, NULL),
(25396, NULL, 'IPR028048', NULL, 'HNH/Endo VII superfamily nuclease toxins', 'Tox-HNH-EHHH', 3, NULL),
(25397, NULL, 'IPR027931', NULL, 'Domain of unknown function DUF4595 with porin-like fold', 'DUF4595', 3, NULL),
(25398, NULL, 'IPR028062', NULL, 'Kidney androgen-regulated protein', 'KAR_prot', 4, NULL),
(25399, NULL, 'IPR025879', NULL, 'Pab87 octamerisation domain', 'Pab87_oct', 3, NULL),
(25400, NULL, 'IPR026473', NULL, 'Cyanobactin biosynthesis protein, PatB/AcyB/McaB family', 'PatB_AcyB_McaB', 4, NULL),
(25401, NULL, 'IPR025880', NULL, 'Glycosyl hydrolase family 80, chitosanase', 'Glyco_hydro_80_chitosanase', 4, NULL),
(25402, NULL, 'IPR031157', NULL, 'Tr-type G domain, conserved site', 'G_TR_CS', 2, NULL),
(25403, NULL, 'IPR026739', NULL, 'AP complex subunit beta', 'AP_beta', 4, NULL),
(25404, NULL, 'IPR026467', NULL, 'Ser/Gly rich, Cys  interspersed, C-terminal domain', 'Ser/Gly_Cys_C_dom', 3, NULL),
(25405, NULL, 'IPR031439', NULL, 'Proline-rich protein family 20', 'PRR20', 4, NULL),
(25406, NULL, 'IPR026055', NULL, 'Fatty acyl-CoA reductase', 'FAR', 4, NULL),
(25407, NULL, 'IPR027978', NULL, 'Protein of unknown function DUF4644', 'DUF4644', 4, NULL),
(25408, NULL, 'IPR026671', NULL, 'Phostensin/Taperin', 'PPP1R18/Tprn', 4, NULL),
(25409, NULL, 'IPR026248', NULL, 'Protein Fyv8', 'Fyv8', 4, NULL),
(25410, NULL, 'IPR026197', NULL, 'Secretogranin III', 'SCG3', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(25411, NULL, 'IPR031008', NULL, 'Phenylalanine aminomutase (L-beta-phenylalanine forming)', 'Taxol_Phe_23mut', 4, NULL),
(25412, NULL, 'IPR032963', NULL, 'Glutamate--cysteine ligase regulatory subunit', 'Gclm', 4, NULL),
(25413, NULL, 'IPR032427', NULL, 'Phage P22-like portal protein', 'P22_portal', 4, NULL),
(25414, NULL, 'IPR029082', NULL, 'Immunity protein 35', 'Imm35', 3, NULL),
(25415, NULL, 'IPR029105', NULL, 'Chromatin assembly factor 1 subunit p150, C-terminal', 'CAF1-p150_C2', 3, NULL),
(25416, NULL, 'IPR030031', NULL, 'PDZ domain-containing protein MAGIX', 'MAGIX', 4, NULL),
(25417, NULL, 'IPR032306', NULL, 'Phosphotransferase RcsD, RcsD-ABL domain', 'RcsD_ABL', 3, NULL),
(25418, NULL, 'IPR030942', NULL, 'IgG-blocking virulence domain', 'Mycoplas_M_dom', 3, NULL),
(25419, NULL, 'IPR032528', NULL, 'Sigma 54 modulation/S30EA ribosomal protein, C-terminal', 'Ribosom_S30AE_C', 3, NULL),
(25420, NULL, 'IPR030905', NULL, 'Choline TMA-lyase-activating enzyme', 'CutC_activ_rSAM', 4, NULL),
(25421, NULL, 'IPR030667', NULL, 'NEDD8-activating enzyme E1 regulatory subunit APP-BP1', 'APP-BP1', 4, NULL),
(25422, NULL, 'IPR032328', NULL, 'Cation efflux system protein CusB, long alpha hairpin domain', 'HlyD_D4', 3, NULL),
(25423, NULL, 'IPR029075', NULL, 'Immunity protein 48', 'Imm48', 4, NULL),
(25424, NULL, 'IPR031441', NULL, 'Break repair meiotic recombinase recruitment factor 1', 'Brme1', 4, NULL),
(25425, NULL, 'IPR026476', NULL, 'Sarcinarray family protein', 'Sarcinarray_fam', 4, NULL),
(25426, NULL, 'IPR032049', NULL, 'E3 ubiquitin-protein ligase Msl2, CXC domain', 'Msl2-CXC', 3, NULL),
(25427, NULL, 'IPR030431', NULL, 'Endosomal transmembrane epsin interactor 1-3', 'ENTTREP1-3', 4, NULL),
(25428, NULL, 'IPR030798', NULL, 'Arfaptin family', 'Arfaptin_fam', 4, NULL),
(25429, NULL, 'IPR030936', NULL, 'Putative nonproteinogenic amino acid hydroxylase', 'Nonproteo_OH', 4, NULL),
(25430, NULL, 'IPR030902', NULL, 'Conserved hypothetical protein', 'CLB_0814_fam', 4, NULL),
(25431, NULL, 'IPR027610', NULL, 'Sporadic carbohydrate cluster protein, LIC12192 family', 'SpoChClust', 4, NULL),
(25432, NULL, 'IPR026575', NULL, 'Cyclic nucleotide phosphodiesterase GpdQ/CpdA-like', 'GpdQ/CpdA-like', 4, NULL),
(25433, NULL, 'IPR026579', NULL, 'Cell division protein FtsQ', 'FtsQ', 4, NULL),
(25434, NULL, 'IPR026169', NULL, 'Mitochondria-eating protein', 'MIEAP', 4, NULL),
(25435, NULL, 'IPR026202', NULL, 'Golgin subfamily B member 1', 'GOLGB1', 4, NULL),
(25436, NULL, 'IPR028047', NULL, 'Latrotoxin, C-terminal domain', 'Latrotoxin_C_dom', 3, NULL),
(25437, NULL, 'IPR026740', NULL, 'AP-3 complex subunit beta', 'AP3_beta', 4, NULL),
(25438, NULL, 'IPR026193', NULL, 'NADH-ubiquinone oxidoreductase flavoprotein 3', 'NDUFV3', 4, NULL),
(25439, NULL, 'IPR032309', NULL, 'Domain of unknown function DUF4983', 'DUF4983', 3, NULL),
(25440, NULL, 'IPR029562', NULL, 'Retinoic acid receptor responder protein 2', 'Chemerin', 4, NULL),
(25441, NULL, 'IPR032332', NULL, 'Gram-positive pilin backbone subunit 3, Cna-B-like domain', 'GramPos_pilinD3', 3, NULL),
(25442, NULL, 'IPR028063', NULL, 'Scrapie-responsive protein 1', 'SCRG1', 4, NULL),
(25443, NULL, 'IPR032823', NULL, 'Branched-chain amino acid ATP-binding cassette transporter, C-terminal', 'BCA_ABC_TP_C', 3, NULL),
(25444, NULL, 'IPR025873', NULL, 'Metal binding domain, predicted', 'Metal-bd_dom_prd', 3, NULL),
(25445, NULL, 'IPR031387', NULL, 'Spindle and centriole-associated protein 1', 'SPICE1', 4, NULL),
(25446, NULL, 'IPR028611', NULL, 'Tat proofreading chaperone DmsD', 'DmsD_chaperone', 4, NULL),
(25447, NULL, 'IPR031601', NULL, 'Coiled-coil domain-containing protein 48', 'CCD48', 4, NULL),
(25448, NULL, 'IPR028933', NULL, 'Lebercilin domain', 'Lebercilin_dom', 3, NULL),
(25449, NULL, 'IPR030945', NULL, 'Putative energy coupling factor transporter S component', 'EcfS_MSC_0063', 4, NULL),
(25450, NULL, 'IPR027120', NULL, 'Smc2, ATP-binding cassette domain', 'Smc2_ABC', 3, NULL),
(25451, NULL, 'IPR027607', NULL, 'SEC10/PgrA surface exclusion domain', 'Surf_Exclu_SEC10/PgrA', 3, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(25452, NULL, 'IPR030396', NULL, 'Peptidase family S6 domain', 'Peptidase_S6_dom', 3, NULL),
(25453, NULL, 'IPR028133', NULL, 'Dynamitin', 'Dynamitin', 4, NULL),
(25454, NULL, 'IPR030882', NULL, 'Putative DNA helicase Rad25, archaea', 'Helicase_Rad25_arc', 4, NULL),
(25455, NULL, 'IPR027788', NULL, 'Alpha/beta-hydrolase, N-terminal domain', 'Alpha/beta-hydrolase_N_dom', 3, NULL),
(25456, NULL, 'IPR028932', NULL, 'TerB-C domain', 'TerB-C', 3, NULL),
(25457, NULL, 'IPR028067', NULL, 'Interleukin-32', 'IL-32', 4, NULL),
(25458, NULL, 'IPR031152', NULL, 'Plexin domain-containing protein', 'PLXDC', 4, NULL),
(25459, NULL, 'IPR030608', NULL, 'Kelch-like protein 10, BTB/POZ domain', 'KLHL10_BTB/POZ', 3, NULL),
(25460, NULL, 'IPR030906', NULL, 'Surface carbohydrate biosynthesis protein', 'Surf_polysacc', 3, NULL),
(25461, NULL, 'IPR032406', NULL, 'Cyclic nucleotide-gated channel, C-terminal leucine zipper domain', 'CLZ_dom', 3, NULL),
(25462, NULL, 'IPR030380', NULL, 'SAM-dependent methyltransferase DRM', 'SAM_MeTfrase_DRM', 3, NULL),
(25463, NULL, 'IPR030953', NULL, 'Glycosyltransferase, activator-dependent family', 'Glycosyl_450act', 4, NULL),
(25464, NULL, 'IPR026466', NULL, 'Fimbrial isopeptide formation D2 domain', 'Fim_isopep_form_D2_dom', 3, NULL),
(25465, NULL, 'IPR027532', NULL, 'Mitochondrial distribution and morphology protein 12', 'Mdm12', 4, NULL),
(25466, NULL, 'IPR027987', NULL, 'Interleukin-31', 'IL-31', 4, NULL),
(25467, NULL, 'IPR026636', NULL, 'M-phase phosphoprotein 9', 'MPHOSPH9', 4, NULL),
(25468, NULL, 'IPR030853', NULL, '3-5 exoribonuclease, actinobacteria', '3_5_Exoribonuc_actinobac', 4, NULL),
(25469, NULL, 'IPR031491', NULL, 'FAAP20, FANCA interaction domain', 'FANCA_interact', 3, NULL),
(25470, NULL, 'IPR032286', NULL, 'Protein of unknown function DUF4837', 'DUF4837', 4, NULL),
(25471, NULL, 'IPR027684', NULL, 'Tubulin-specific chaperone C', 'TBCC', 4, NULL),
(25472, NULL, 'IPR026694', NULL, 'Protein CUSTOS', 'CUSTOS', 4, NULL),
(25473, NULL, 'IPR030901', NULL, 'Thiaminase-1', 'Thiaminase_BcmE', 4, NULL),
(25474, NULL, 'IPR027777', NULL, 'Dynactin subunit 6', 'DCTN6', 4, NULL),
(25475, NULL, 'IPR029695', NULL, 'Transmembrane protein 74-like', 'TMEM74-like', 4, NULL),
(25476, NULL, 'IPR029096', NULL, 'Developmental pluripotency-associated protein 3', 'Dppa3', 4, NULL),
(25477, NULL, 'IPR032411', NULL, 'Flagellar FLiS export co-chaperone, HP1076', 'FliS_cochap', 4, NULL),
(25478, NULL, 'IPR031393', NULL, 'Lymphocyte transmembrane adapter 1', 'LAX', 4, NULL),
(25479, NULL, 'IPR030937', NULL, 'Hemophore Rv0203', 'Hemophore_Rv0203', 4, NULL),
(25480, NULL, 'IPR034149', NULL, 'DNA topoisomerase 1, TOPRIM domain', 'TOPRIM_TopoI', 3, NULL),
(25481, NULL, 'IPR027930', NULL, 'Protein of unknown function DUF4609', 'DUF4609', 4, NULL),
(25482, NULL, 'IPR027705', NULL, 'Flotillin family', 'Flotillin_fam', 4, NULL),
(25483, NULL, 'IPR027609', NULL, 'Putative 7-carboxy-7-deazaguanine synthase QueE, Proteobacteria', 'rSAM_QueE_Proteobac', 4, NULL),
(25484, NULL, 'IPR032976', NULL, 'YjeF N-terminal domain-containing protein NAXE-like', 'YJEFN_prot_NAXE-like', 4, NULL),
(25485, NULL, 'IPR026480', NULL, 'Arginine N-methyltransferase 2-like domain', 'RMT2_dom', 3, NULL),
(25486, NULL, 'IPR027421', NULL, 'DNA polymerase lambda lyase domain superfamily', 'DNA_pol_lamdba_lyase_dom_sf', 5, NULL),
(25487, NULL, 'IPR031623', NULL, 'Archaeal histidine kinase, 4TM domain', 'HisKA_4TM', 3, NULL),
(25488, NULL, 'IPR032869', NULL, 'WHH domain-containing protein', 'WHH_dom_containing', 4, NULL),
(25489, NULL, 'IPR029656', NULL, 'Arginine/serine-rich protein 1', 'RSRP1', 4, NULL),
(25490, NULL, 'IPR026104', NULL, 'Zinc finger C2HC domain-containing protein 1C', 'ZNF_C2HC_dom_1C', 4, NULL),
(25491, NULL, 'IPR027524', NULL, 'Eukaryotic translation initiation factor 3 subunit H', 'eIF3h', 4, NULL),
(25492, NULL, 'IPR029688', NULL, 'Interactor of constitutive active ROPs', 'ICR', 4, NULL),
(25493, NULL, 'IPR032282', NULL, 'Hydroxyacylglutathione hydrolase, C-terminal domain', 'HAGH_C', 3, NULL),
(25494, NULL, 'IPR032413', NULL, 'Atypical Arm repeat', 'Arm_3', 7, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(25495, NULL, 'IPR032388', NULL, 'Flagellar assembly protein T, C-terminal', 'FlgT_C', 3, NULL),
(25496, NULL, 'IPR029753', NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase, NAD-binding domain conserved site', 'D-isomer_DH_CS', 2, NULL),
(25497, NULL, 'IPR032864', NULL, 'Prokaryotic E2 family C', 'Prok-E2_C', 4, NULL),
(25498, NULL, 'IPR032407', NULL, 'Haemophore, haem-binding', 'MHB', 3, NULL),
(25499, NULL, 'IPR032818', NULL, 'DedA family', 'DedA', 4, NULL),
(25500, NULL, 'IPR031002', NULL, 'D-proline reductase, PrdA proprotein', 'D_pro_red_PrdA', 4, NULL),
(25501, NULL, 'IPR027863', NULL, 'Protein of unknown function DUF4623', 'DUF4623', 4, NULL),
(25502, NULL, 'IPR031679', NULL, 'TSSK6-activating co-chaperone protein', 'SSTK-IP', 4, NULL),
(25503, NULL, 'IPR027472', NULL, 'Pput2613-like deaminase', 'Pput2613-NH3ase', 4, NULL),
(25504, NULL, 'IPR030664', NULL, 'FAD-dependent oxidoreductase SdhA/FrdA/AprA', 'SdhA/FrdA/AprA', 4, NULL),
(25505, NULL, 'IPR031023', NULL, '4-nitrotryptophan synthase', 'CYP450_TxtE', 4, NULL),
(25506, NULL, 'IPR025890', NULL, 'Abhydrolase, bacterial', 'Abhydrolase_bac', 4, NULL),
(25507, NULL, 'IPR029787', NULL, 'Nucleotide cyclase', 'Nucleotide_cyclase', 5, NULL),
(25508, NULL, 'IPR027286', NULL, 'Prostacyclin synthase', 'PTGIS', 4, NULL),
(25509, NULL, 'IPR027873', NULL, 'Protein PAXX', 'PAXX', 4, NULL),
(25510, NULL, 'IPR032550', NULL, 'PBP-dependent ABC transporters TM subunit, N-terminal', 'TM_PBP2_N', 3, NULL),
(25511, NULL, 'IPR032546', NULL, 'Protein of unknown function DUF4943', 'DUF4943', 4, NULL),
(25512, NULL, 'IPR031336', NULL, 'Cell division control protein 73, C-terminal', 'CDC73_C', 3, NULL),
(25513, NULL, 'IPR025276', NULL, 'Protein of unknown function DUF4075', 'DUF4075', 4, NULL),
(25514, NULL, 'IPR026128', NULL, 'Neurosecretory protein VGF', 'VGF', 4, NULL),
(25515, NULL, 'IPR027486', NULL, 'Ribosomal protein S10 domain', 'Ribosomal_S10_dom', 3, NULL),
(25516, NULL, 'IPR031931', NULL, 'Protein of unknown function DUF4768', 'DUF4768', 4, NULL),
(25517, NULL, 'IPR029046', NULL, 'Lipoprotein localisation LolA/LolB/LppX', 'LolA/LolB/LppX', 5, NULL),
(25518, NULL, 'IPR031014', NULL, 'Cytosylglucuronate decarboxylase', 'rSAM_BlsE', 4, NULL),
(25519, NULL, 'IPR024727', NULL, 'Bacterial NAD-glutamate dehydrogenase, N-terminal', 'NAD_Glu_DH_bac_N', 3, NULL),
(25520, NULL, 'IPR032544', NULL, 'Protein of unknown function DUF4945', 'DUF4945', 4, NULL),
(25521, NULL, 'IPR027887', NULL, 'Protein of unknown function DUF4464', 'DUF4464', 4, NULL),
(25522, NULL, 'IPR031923', NULL, 'Helicobacter TNF-alpha-inducing protein', 'Tipalpha', 4, NULL),
(25523, NULL, 'IPR026780', NULL, 'Proline-rich nuclear receptor coactivator 1/2', 'PNRC1/2', 4, NULL),
(25524, NULL, 'IPR029448', NULL, 'Fanconi anaemia protein FANCD2', 'FANCD2', 4, NULL),
(25525, NULL, 'IPR031416', NULL, 'Mediator complex subunit 26, C-terminal domain', 'Med26_C', 3, NULL),
(25526, NULL, 'IPR028427', NULL, 'Peptide methionine sulfoxide reductase MsrB', 'Met_Sox_Rdtase_MsrB', 4, NULL),
(25527, NULL, 'IPR025289', NULL, 'Domain of unknown function DUF4081', 'DUF4081', 3, NULL),
(25528, NULL, 'IPR031721', NULL, 'Partial cleavage stimulation factor domain', 'Partial_CstF', 3, NULL),
(25529, NULL, 'IPR031773', NULL, 'Protein of unknown function DUF4741', 'DUF4741', 4, NULL),
(25530, NULL, 'IPR028426', NULL, 'Huntingtin family', 'Huntingtin_fam', 4, NULL),
(25531, NULL, 'IPR026776', NULL, 'Uncharacterised protein family UPF0729', 'UPF0729', 4, NULL),
(25532, NULL, 'IPR031830', NULL, 'Uncharacterised protein YdiH', 'YdiH', 4, NULL),
(25533, NULL, 'IPR027303', NULL, 'Glutamine synthetase, glycine-rich site', 'Gln_synth_gly_rich_site', 2, NULL),
(25534, NULL, 'IPR031674', NULL, 'Protein of unknown function DUF4714', 'DUF4714', 4, NULL),
(25535, NULL, 'IPR031685', NULL, 'Testis-expressed sequence 29 protein', 'TEX29', 4, NULL),
(25536, NULL, 'IPR031611', NULL, 'Putative porin', 'Porin_6', 4, NULL),
(25537, NULL, 'IPR027893', NULL, 'EKC/KEOPS complex subunit GON7, metazoa', 'GON7_meta', 4, NULL),
(25538, NULL, 'IPR031713', NULL, 'G-protein coupled receptor ligand 15', 'GPR15L', 4, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(25539, NULL, 'IPR025032', NULL, 'Protein of unknown function DUF3949', 'DUF3949', 4, NULL),
(25540, NULL, 'IPR027384', NULL, 'Runx, central domain superfamily', 'Runx_central_dom_sf', 5, NULL),
(25541, NULL, 'IPR024924', NULL, '7-carboxy-7-deazaguanine synthase-like', '7-CO-7-deazaguanine_synth-like', 4, NULL),
(25542, NULL, 'IPR028802', NULL, 'Nonsense-mediated mRNA decay factor SMG8', 'SMG8', 4, NULL),
(25543, NULL, 'IPR026319', NULL, 'Zinc finger C2HC domain-containing protein', 'ZC2HC1', 4, NULL),
(25544, NULL, 'IPR028120', NULL, 'Apolipoprotein C-IV', 'APOC4', 4, NULL),
(25545, NULL, 'IPR028458', NULL, 'Twinfilin', 'Twinfilin', 4, NULL),
(25546, NULL, 'IPR028798', NULL, 'Two pore channel protein 2', 'TPC2', 4, NULL),
(25547, NULL, 'IPR026316', NULL, 'KAT8 regulatory NSL complex subunit 2', 'NSL2', 4, NULL),
(25548, NULL, 'IPR027894', NULL, 'Protein of unknown function DUF4620', 'DUF4620', 4, NULL),
(25549, NULL, 'IPR025865', NULL, 'Cobaltochelatase subunit CobS N-terminal domain', 'CobS_N_dom', 3, NULL),
(25550, NULL, 'IPR032540', NULL, 'Protein of unknown function DUF4949', 'DUF4949', 4, NULL),
(25551, NULL, 'IPR033983', NULL, 'Thiazole synthase ThiG', 'Thiazole_synthase_ThiG', 3, NULL),
(25552, NULL, 'IPR031018', NULL, 'LipL41-expression chaperone Lep', 'Chaper_lep', 4, NULL),
(25553, NULL, 'IPR031845', NULL, 'Bacterial toxin, RNase RnlA/LsoA, N-terminal repeated domain', 'RnlA_toxin_NRD', 3, NULL),
(25554, NULL, 'IPR026960', NULL, 'Reverse transcriptase zinc-binding domain', 'RVT-Znf', 3, NULL),
(25555, NULL, 'IPR031677', NULL, 'Testis-expressed sequence 38 protein', 'TEX38', 4, NULL),
(25556, NULL, 'IPR031606', NULL, 'Potassium transporter Kch', 'Kch1/2', 4, NULL),
(25557, NULL, 'IPR025893', NULL, 'Tocopherol cyclase', 'Tocopherol_cyclase', 4, NULL),
(25558, NULL, 'IPR027895', NULL, 'Protein of unknown function DUF4533', 'DUF4533', 4, NULL),
(25559, NULL, 'IPR025028', NULL, 'Protein of unknown function DUF3951', 'DUF3951', 4, NULL),
(25560, NULL, 'IPR030915', NULL, 'Sporulation killing factor system, radical SAM maturase SkfB', 'rSAM_SkfB', 4, NULL),
(25561, NULL, 'IPR030217', NULL, 'Nuclear RNA export factor', 'NXF_fam', 4, NULL),
(25562, NULL, 'IPR028051', NULL, 'Chemotaxis phosphatase CheX-like domain', 'CheX-like_dom', 3, NULL),
(25563, NULL, 'IPR032008', NULL, 'E3 ubiquitin-protein ligase APD1-4, N-terminal', 'APD1-4_N', 3, NULL),
(25564, NULL, 'IPR031630', NULL, 'Coiled-coil domain-containing protein 117', 'CCDC117', 4, NULL),
(25565, NULL, 'IPR030971', NULL, 'Aminoglycoside N(6'')-acetyltransferase, AacA4 type', 'N6_acetyl_AAC6', 4, NULL),
(25566, NULL, 'IPR035952', NULL, 'Rhomboid-like superfamily', 'Rhomboid-like_sf', 5, NULL),
(25567, NULL, 'IPR031364', NULL, 'Germinal centre-associated lymphoma protein', 'GC_assoc_lym', 4, NULL),
(25568, NULL, 'IPR031378', NULL, 'Small vasohibin-binding protein', 'SVBP', 4, NULL),
(25569, NULL, 'IPR027079', NULL, 'TFIIH subunit Tfb1/GTF2H1', 'Tfb1/GTF2H1', 4, NULL),
(25570, NULL, 'IPR031678', NULL, 'Protein of unknown function DUF4715', 'DUF4715', 4, NULL),
(25571, NULL, 'IPR025218', NULL, 'Domain of unknown function DUF4426', 'DUF4426', 3, NULL),
(25572, NULL, 'IPR027388', NULL, 'Ku70, bridge and pillars domain superfamily', 'Ku70_bridge/pillars_dom_sf', 5, NULL),
(25573, NULL, 'IPR028627', NULL, 'Acylphosphatase, bacteria', 'Acylphosphatase_bac', 4, NULL),
(25574, NULL, 'IPR031020', NULL, 'Enduracididine biosynthesis enzyme MppP', 'Endura_MppP', 4, NULL),
(25575, NULL, 'IPR029757', NULL, 'DNA-directed RNA polymerase subunit delta', 'RpoE', 4, NULL),
(25576, NULL, 'IPR025223', NULL, 'S1-like RNA binding domain', 'S1-like_RNA-bd_dom', 3, NULL),
(25577, NULL, 'IPR032004', NULL, 'Protein of unknown function DUF4790', 'DUF4790', 4, NULL),
(25578, NULL, 'IPR026673', NULL, 'SPEC3/Stum', 'SPEC3/Stum', 4, NULL),
(25579, NULL, 'IPR029142', NULL, 'Small proline-rich protein 2', 'SPRR2', 4, NULL),
(25580, NULL, 'IPR026224', NULL, 'Protein DPCD', 'DPCD', 4, NULL),
(25581, NULL, 'IPR029147', NULL, 'Cilia- and flagella-associated protein 77', 'CFAP77', 4, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(25582, NULL, 'IPR025273', NULL, 'Domain of unknown function DUF4064', 'DUF4064', 3, NULL),
(25583, NULL, 'IPR025607', NULL, 'Ribosomal protein L5 eukaryotic, C-terminal', 'Rbsml_L5e_C', 3, NULL),
(25584, NULL, 'IPR028121', NULL, 'TMEM213 family', 'TMEM213', 4, NULL),
(25585, NULL, 'IPR025281', NULL, 'Domain of unknown function DUF4074', 'DUF4074', 3, NULL),
(25586, NULL, 'IPR031800', NULL, 'Cyclic di-GMP receptor, atypical PilZ domain', 'PilZ_atypical', 3, NULL),
(25587, NULL, 'IPR028625', NULL, 'Regulator of nucleoside diphosphate kinase', 'Rnk', 4, NULL),
(25588, NULL, 'IPR025860', NULL, 'Major prion protein N-terminal domain', 'Prion_N_dom', 3, NULL),
(25589, NULL, 'IPR031851', NULL, 'Protein of unknown function DUF4750', 'DUF4750', 4, NULL),
(25590, NULL, 'IPR031941', NULL, 'Domain of unknown function DUF4773', 'DUF4773', 3, NULL),
(25591, NULL, 'IPR030680', NULL, 'Bombyxin A', 'Bombyxin_A', 4, NULL),
(25592, NULL, 'IPR031421', NULL, 'Protein of unknown function DUF4666', 'DUF4666', 4, NULL),
(25593, NULL, 'IPR026137', NULL, 'Leucine-rich repeat-containing  41', 'Leu_rpt_41', 4, NULL),
(25594, NULL, 'IPR030681', NULL, 'Cholesterol 7-alpha-monooxygenase', 'Cholesterol_7a_monooxygenase', 4, NULL),
(25595, NULL, 'IPR031943', NULL, 'CARMIL, C-terminal domain', 'CARMIL_C', 3, NULL),
(25596, NULL, 'IPR025986', NULL, 'RNA-polymerase II-associated protein 3-like, C-terminal domain', 'RPAP3-like_C', 3, NULL),
(25597, NULL, 'IPR025247', NULL, 'Type II methyltransferase M.EcoRI-like', 'EcoRI-like_methylase', 4, NULL),
(25598, NULL, 'IPR025877', NULL, 'MobA-like NTP transferase', 'MobA-like_NTP_Trfase', 3, NULL),
(25599, NULL, 'IPR025220', NULL, 'NFRKB winged helix-like domain', 'NFRKB_winged_dom', 3, NULL),
(25600, NULL, 'IPR025019', NULL, 'Domain of unknown function DUF3952', 'DUF3952', 3, NULL),
(25601, NULL, 'IPR027888', NULL, 'Protein of unknown function DUF4501', 'DUF4501', 4, NULL),
(25602, NULL, 'IPR031809', NULL, 'Coiled-coil domain-containing protein 158', 'CCDC158', 4, NULL),
(25603, NULL, 'IPR032534', NULL, 'EcxA, zinc-binding', 'EcxA_zinc-bd', 3, NULL),
(25604, NULL, 'IPR026299', NULL, 'Mitochondrial 28S ribosomal protein S31', 'MRP-S31', 4, NULL),
(25605, NULL, 'IPR025219', NULL, 'PLAT/LH2 and C2-like Ca2+-binding lipoprotein', 'PLCC', 4, NULL),
(25606, NULL, 'IPR029861', NULL, 'V-set and immunoglobulin domain-containing protein 1', 'VSIG1', 4, NULL),
(25607, NULL, 'IPR032539', NULL, 'Protein of unknown function DUF4950', 'DUF4950', 4, NULL),
(25608, NULL, 'IPR025278', NULL, 'Domain of unknown function DUF4077', 'DUF4077', 3, NULL),
(25609, NULL, 'IPR025030', NULL, 'Domain of unknown function DUF3950', 'DUF3950', 3, NULL),
(25610, NULL, 'IPR027074', NULL, 'Integrator complex subunit 9', 'Integrator_9su', 4, NULL),
(25611, NULL, 'IPR026229', NULL, 'Vesicular, overexpressed in cancer, prosurvival protein 1', 'VOPP1', 4, NULL),
(25612, NULL, 'IPR031017', NULL, 'TAT-translocated F420-dependent dehydrogenase, FGD2 family', 'F420_FGD2', 4, NULL),
(25613, NULL, 'IPR031925', NULL, 'Tubulin-specific chaperone C, N-terminal', 'TBCC_N', 3, NULL),
(25614, NULL, 'IPR026988', NULL, 'YaaC-like protein', 'YaaC-like', 4, NULL),
(25615, NULL, 'IPR032542', NULL, 'Protein of unknown function DUF4947', 'DUF4947', 4, NULL),
(25616, NULL, 'IPR031778', NULL, 'Sortilin, N-terminal', 'Sortilin_N', 3, NULL),
(25617, NULL, 'IPR031942', NULL, 'Domain of unknown function DUF4774', 'DUF4774', 3, NULL),
(25618, NULL, 'IPR026112', NULL, 'Amnionless', 'AMN', 4, NULL),
(25619, NULL, 'IPR026678', NULL, 'INO80 complex subunit E', 'INO80E', 4, NULL),
(25620, NULL, 'IPR027981', NULL, 'Protein of unknown function DUF4446', 'DUF4446', 4, NULL),
(25621, NULL, 'IPR026782', NULL, 'Protein FAM131', 'FAM131', 4, NULL),
(25622, NULL, 'IPR028605', NULL, 'RISC-loading complex subunit TRBP2', 'TRBP2', 4, NULL),
(25623, NULL, 'IPR030970', NULL, 'Probable phospholipid ABC transporter-binding protein MlaD', 'ABC_MlaD', 4, NULL),
(25624, NULL, 'IPR025003', NULL, 'Domain of unknown function DUF3973', 'DUF3973', 3, NULL),
(25625, NULL, 'IPR027443', NULL, 'Isopenicillin N synthase-like superfamily', 'IPNS-like_sf', 5, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(25626, NULL, 'IPR025875', NULL, 'Leucine rich repeat 4', 'Leu-rich_rpt_4', 7, NULL),
(25627, NULL, 'IPR026992', NULL, 'Non-haem dioxygenase N-terminal domain', 'DIOX_N', 3, NULL),
(25628, NULL, 'IPR031380', NULL, 'Six6 opposite strand transcript 1', 'SIX6OS1', 4, NULL),
(25629, NULL, 'IPR029155', NULL, 'SIPAR domain', 'SIPAR', 3, NULL),
(25630, NULL, 'IPR031905', NULL, 'Flotillin, C-terminal domain', 'Flotillin_C', 3, NULL),
(25631, NULL, 'IPR032609', NULL, 'Protein of unknown function DUF4893', 'DUF4893', 4, NULL),
(25632, NULL, 'IPR025894', NULL, 'Polycomb-like MTF2 factor 2, C-terminal domain', 'Mtf2_C_dom', 3, NULL),
(25633, NULL, 'IPR031417', NULL, 'Mediator complex subunit 26, middle domain', 'Med26_Mid', 3, NULL),
(25634, NULL, 'IPR026116', NULL, 'Glycosyltransferase family 18', 'GlyclTrfase_18', 4, NULL),
(25635, NULL, 'IPR025988', NULL, 'YWFCY domain', 'YWFCY_dom', 3, NULL),
(25636, NULL, 'IPR031024', NULL, 'Lipoprotein LenA', 'Lipo_LenA_lepto', 4, NULL),
(25637, NULL, 'IPR031848', NULL, 'PrlF antitoxin', 'PrlF_antitoxin', 4, NULL),
(25638, NULL, 'IPR025858', NULL, 'Exopolysaccharide production protein YjbE', 'YjbE', 4, NULL),
(25639, NULL, 'IPR024922', NULL, 'Rubredoxin', 'Rubredoxin', 4, NULL),
(25640, NULL, 'IPR027441', NULL, 'Protective antigen domain 4', 'PA_dom4', 5, NULL),
(25641, NULL, 'IPR027855', NULL, 'Domain of unknown function DUF4479', 'DUF4479', 3, NULL),
(25642, NULL, 'IPR025221', NULL, 'E1 N-terminal domain', 'E1-N_dom', 3, NULL),
(25643, NULL, 'IPR027851', NULL, 'Protein of unknown function DUF4628', 'DUF4628', 4, NULL),
(25644, NULL, 'IPR032606', NULL, 'Protein of unknown function DUF4895', 'DUF4895', 4, NULL),
(25645, NULL, 'IPR027892', NULL, 'Maturin', 'Maturin', 4, NULL),
(25646, NULL, 'IPR025864', NULL, 'Type-F conjugative transfer system protein TraW N-terminal domain', 'TraW_N_dom', 3, NULL),
(25647, NULL, 'IPR031947', NULL, 'Headcase, middle domain', 'Headcase_mid', 3, NULL),
(25648, NULL, 'IPR026225', NULL, 'Daughter-specific expression protein 2', 'DSE2', 4, NULL),
(25649, NULL, 'IPR025017', NULL, 'Protein of unknown function DUF3954', 'DUF3954', 4, NULL),
(25650, NULL, 'IPR025306', NULL, 'Probable zinc-binding domain', 'Zn-bnd_dom_prob', 3, NULL),
(25651, NULL, 'IPR027394', NULL, 'Cytochrome-c3 hydrogenase, C-terminal', 'Cytochrome-c3_hydrogenase_C', 3, NULL),
(25652, NULL, 'IPR025267', NULL, 'Protein of unknown function DUF4043', 'DUF4043', 4, NULL),
(25653, NULL, 'IPR028628', NULL, 'Sirtuin, class U', 'Sirtuin_class_U', 4, NULL),
(25654, NULL, 'IPR031011', NULL, 'MarR family transcriptional regulator', 'Reg_MarR', 4, NULL),
(25655, NULL, 'IPR025264', NULL, 'Cag pathogenicity island protein Cag12', 'Cag12', 4, NULL),
(25656, NULL, 'IPR025862', NULL, 'L-seryl-tRNA selenium transferase N-terminal domain', 'SelA_trans_N_dom', 3, NULL),
(25657, NULL, 'IPR031604', NULL, '4Fe-4S ferredoxin iron-sulfur binding domain-containing protein, N-terminal', 'Ferredoxin_N', 3, NULL),
(25658, NULL, 'IPR025989', NULL, 'Virulence factor domain', 'Virulence_F_dom', 3, NULL),
(25659, NULL, 'IPR029053', NULL, 'Viral coat protein subunit', 'Viral_coat', 5, NULL),
(25660, NULL, 'IPR032611', NULL, 'Protein of unknown function DUF4891', 'DUF4891', 4, NULL),
(25661, NULL, 'IPR026133', NULL, 'Tastin', 'Tastin', 4, NULL),
(25662, NULL, 'IPR026741', NULL, 'Protein strawberry notch', 'SNO', 4, NULL),
(25663, NULL, 'IPR025298', NULL, 'Domain of unknown function DUF4094', 'DUF4094', 3, NULL),
(25664, NULL, 'IPR031711', NULL, 'Domain of unknown function DUF4724', 'DUF4724', 3, NULL),
(25665, NULL, 'IPR028457', NULL, 'ABI family', 'ABI', 4, NULL),
(25666, NULL, 'IPR031466', NULL, 'Migration and invasion-inhibitory protein', 'MIIP', 4, NULL),
(25667, NULL, 'IPR027078', NULL, 'Small nuclear ribonucleoprotein E', 'snRNP-E', 4, NULL),
(25668, NULL, 'IPR025266', NULL, 'TerB, N-terminal', 'TerB_N', 3, NULL),
(25669, NULL, 'IPR031335', NULL, 'Glycosyl hydrolase family 63, C-terminal', 'Glyco_hydro_63_C', 3, NULL),
(25670, NULL, 'IPR026757', NULL, 'Endosome-associated-trafficking regulator 1', 'ENTR1', 4, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(25671, NULL, 'IPR027390', NULL, 'Endoglucanase F, domain 3', 'Endoglucanase_F_dom3', 5, NULL),
(25672, NULL, 'IPR032536', NULL, 'Transmembrane protein 100', 'TMEM100', 4, NULL),
(25673, NULL, 'IPR031728', NULL, 'Beta-glucuronidase, C-terminal', 'GlcAase_C', 3, NULL),
(25674, NULL, 'IPR032538', NULL, 'Protein of unknown function DUF4951', 'DUF4951', 4, NULL),
(25675, NULL, 'IPR025990', NULL, 'Cysteine-rich CPXCG protein', 'Cys_rich_CPXCG', 4, NULL),
(25676, NULL, 'IPR032608', NULL, 'Protein of unknown function DUF4892', 'DUF4892', 4, NULL),
(25677, NULL, 'IPR026987', NULL, 'WD repeat-containing protein 18, C-terminal domain', 'Wdr18_C_dom', 3, NULL),
(25678, NULL, 'IPR028123', NULL, 'TMEM210 family', 'TMEM210', 4, NULL),
(25679, NULL, 'IPR027864', NULL, 'Protein of unknown function DUF4597', 'DUF4597', 4, NULL),
(25680, NULL, 'IPR031337', NULL, 'KDPG/KHG aldolase, active site 1', 'KDPG/KHG_AS_1', 0, NULL),
(25681, NULL, 'IPR026131', NULL, 'Mastermind-like domain-containing protein 1', 'MAMLD1', 4, NULL),
(25682, NULL, 'IPR025305', NULL, 'UCH repeated domain', 'UCH_repeat_domain', 3, NULL),
(25683, NULL, 'IPR026748', NULL, 'Clarin', 'Clarin', 4, NULL),
(25684, NULL, 'IPR027439', NULL, 'Protective antigen, heptamerisation domain', 'PA_heptamer_dom', 3, NULL),
(25685, NULL, 'IPR029119', NULL, 'MutY, C-terminal', 'MutY_C', 3, NULL),
(25686, NULL, 'IPR026120', NULL, 'Transmembrane protein 11', 'TMEM11', 4, NULL),
(25687, NULL, 'IPR032039', NULL, 'Alphacoronavirus nsp1', 'A-CoV_nsp1', 3, NULL),
(25688, NULL, 'IPR031940', NULL, 'Domain of unknown function DUF4772', 'DUF4772', 3, NULL),
(25689, NULL, 'IPR028816', NULL, 'Caprin', 'Caprin', 4, NULL),
(25690, NULL, 'IPR032547', NULL, 'Protein of unknown function DUF4941', 'DUF4941', 4, NULL),
(25691, NULL, 'IPR027859', NULL, 'KATNIP domain', 'KATNIP_dom', 3, NULL),
(25692, NULL, 'IPR029636', NULL, 'Protein Csf1', 'Csf1', 4, NULL),
(25693, NULL, 'IPR026209', NULL, 'Wolframin family', 'Wolframin_fam', 4, NULL),
(25694, NULL, 'IPR025997', NULL, 'Periplasmic binding protein', 'SBP_2_dom', 3, NULL),
(25695, NULL, 'IPR031653', NULL, 'MAPK-interacting and spindle-stabilising protein', 'MISS', 4, NULL),
(25696, NULL, 'IPR029153', NULL, 'Chondroitin proteoglycan 4', 'CPG4', 3, NULL),
(25697, NULL, 'IPR026682', NULL, 'Proline-rich AKT1 substrate 1 protein', 'AKT1S1', 4, NULL),
(25698, NULL, 'IPR027159', NULL, 'Nuclear cap-binding protein subunit 1', 'CBP80', 4, NULL),
(25699, NULL, 'IPR034183', NULL, 'Isovaleryl-CoA dehydrogenase', 'IVD', 4, NULL),
(25700, NULL, 'IPR028055', NULL, 'Membrane insertase YidC/Oxa1, C-terminal', 'Membr_insert_YidC/Oxa1_C', 3, NULL),
(25701, NULL, 'IPR025891', NULL, 'Developmental pluripotency-associated protein 2/4, C-terminal domain', 'Dppa2/4_C_dom', 3, NULL),
(25702, NULL, 'IPR025292', NULL, 'Type III secretion system protein', 'T3SS_LEE_assoc', 4, NULL),
(25703, NULL, 'IPR027871', NULL, 'Protein of unknown function DUF4603', 'DUF4603', 4, NULL),
(25704, NULL, 'IPR031720', NULL, 'Protein of unknown function DUF4728', 'DUF4728', 4, NULL),
(25705, NULL, 'IPR034154', NULL, 'Archaeal primase DnaG/twinkle-like, TOPRIM domain', 'TOPRIM_DnaG/twinkle', 3, NULL),
(25706, NULL, 'IPR029050', NULL, 'Immunoprotective extracellular, immunoglobulin-like domain superfamily', 'Immunoprotect_excell_Ig-like', 5, NULL),
(25707, NULL, 'IPR030968', NULL, 'Phr family, secreted RapG/RapK phosphatase inhibitor', 'Phr_RapG/K_inhib', 4, NULL),
(25708, NULL, 'IPR026954', NULL, 'PknH-like extracellular domain', 'PknH-like_Extracell', 3, NULL),
(25709, NULL, 'IPR026784', NULL, 'Constitutive coactivator of PPAR-gamma', 'Coact_PPARg', 4, NULL),
(25710, NULL, 'IPR024721', NULL, 'Snurportin-1, N-terminal', 'Snurportin-1_N', 3, NULL),
(25711, NULL, 'IPR029149', NULL, 'Creatinase/Aminopeptidase P/Spt16, N-terminal', 'Creatin/AminoP/Spt16_NTD', 5, NULL),
(25712, NULL, 'IPR027849', NULL, 'Protein of unknown function DUF4434', 'DUF4434', 4, NULL),
(25713, NULL, 'IPR025034', NULL, 'Protein of unknown function DUF3948', 'DUF3948', 4, NULL),
(25714, NULL, 'IPR026686', NULL, 'UPF0708 protein C6orf162', 'UPF0708', 4, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(25715, NULL, 'IPR026226', NULL, 'Chromatin modification-related protein EAF5', 'EAF5', 4, NULL),
(25716, NULL, 'IPR028606', NULL, 'Polyribonucleotide 5-hydroxyl-kinase Clp1', 'Clp1', 4, NULL),
(25717, NULL, 'IPR026315', NULL, 'Out at first protein', 'Oaf', 4, NULL),
(25718, NULL, 'IPR027479', NULL, 'Protein of unknown function DUF917, N-terminal', 'DUF917_N', 5, NULL),
(25719, NULL, 'IPR027080', NULL, 'Protein Unc-13', 'Unc-13', 4, NULL),
(25720, NULL, 'IPR026117', NULL, 'Prostate apoptosis response 4', 'Par-4', 4, NULL),
(25721, NULL, 'IPR025307', NULL, 'FIIND domain', 'FIIND_dom', 3, NULL),
(25722, NULL, 'IPR029442', NULL, 'GyrI-like small molecule binding domain', 'GyrI-like', 3, NULL),
(25723, NULL, 'IPR025288', NULL, 'Domain of unknown function DUF4080', 'DUF4080', 3, NULL),
(25724, NULL, 'IPR031929', NULL, 'Bacterial collagen-like protein, middle domain', 'CLP_mid', 3, NULL),
(25725, NULL, 'IPR031826', NULL, 'IC97/Casc1, N-terminal', 'IC97/Casc1_N', 3, NULL),
(25726, NULL, 'IPR025015', NULL, 'Protein of unknown function DUF3975', 'DUF3975', 4, NULL),
(25727, NULL, 'IPR026099', NULL, 'Outer dense fibre protein 2-related', 'Odf2-rel', 4, NULL),
(25728, NULL, 'IPR026742', NULL, 'Centrosomal protein kizuna', 'Centrosomal_kizuma', 4, NULL),
(25729, NULL, 'IPR031714', NULL, 'Protein of unknown function DUF4726', 'DUF4726', 4, NULL),
(25730, NULL, 'IPR032545', NULL, 'Protein of unknown function DUF4944', 'DUF4944', 4, NULL),
(25731, NULL, 'IPR026212', NULL, 'Centrosomal protein of 78kDa', 'Cep78', 4, NULL),
(25732, NULL, 'IPR031687', NULL, 'ADP-ribosylation factor-like protein 17, C-terminal', 'ARL17_C', 3, NULL),
(25733, NULL, 'IPR032535', NULL, 'Oberon, coiled-coil region', 'Oberon_cc', 3, NULL),
(25734, NULL, 'IPR026778', NULL, 'MLLT11 family', 'MLLT11_fam', 4, NULL),
(25735, NULL, 'IPR028053', NULL, 'Membrane insertase YidC, N-terminal', 'Membr_insert_YidC_N', 3, NULL),
(25736, NULL, 'IPR025011', NULL, 'Protein of unknown function DUF3963', 'DUF3963', 4, NULL),
(25737, NULL, 'IPR025270', NULL, 'Protein of unknown function DUF4044', 'DUF4044', 4, NULL),
(25738, NULL, 'IPR027386', NULL, 'Ribosomal L15/L27a, N-terminal', 'Rbsml_prot_L15/27a_N', 5, NULL),
(25739, NULL, 'IPR031473', NULL, 'Protein of unknown function DUF4684', 'DUF4684', 4, NULL),
(25740, NULL, 'IPR031379', NULL, 'CLLAC-motif containing domain', 'CLLAC', 3, NULL),
(25741, NULL, 'IPR031843', NULL, 'Yuri gagarin', 'Yuri_gagarin', 4, NULL),
(25742, NULL, 'IPR031777', NULL, 'Sortilin, C-terminal', 'Sortilin_C', 3, NULL),
(25743, NULL, 'IPR025216', NULL, 'Domain of unknown function DUF4427', 'DUF4427', 3, NULL),
(25744, NULL, 'IPR029047', NULL, 'Heat shock protein 70kD, peptide-binding domain superfamily', 'HSP70_peptide-bd_sf', 5, NULL),
(25745, NULL, 'IPR028326', NULL, 'Tumor necrosis factor ligand superfamily member 6', 'FASL', 4, NULL),
(25746, NULL, 'IPR025271', NULL, 'Coiled-coil domain-containing protein 28', 'CCDC28', 4, NULL),
(25747, NULL, 'IPR032042', NULL, 'Protection of telomeres protein 1, ssDNA-binding domain', 'POT1PC', 3, NULL),
(25748, NULL, 'IPR031319', NULL, 'Alpha-amylase, C-terminal domain', 'A-amylase_C', 3, NULL),
(25749, NULL, 'IPR031904', NULL, 'Cadherin, C-terminal catenin-binding domain', 'Cadherin_CBD', 3, NULL),
(25750, NULL, 'IPR029569', NULL, 'Calcium homeostasis modulator family', 'CALHM', 4, NULL),
(25751, NULL, 'IPR029754', NULL, 'Urease nickel binding site', 'Urease_Ni-bd', 1, NULL),
(25752, NULL, 'IPR031273', NULL, 'Protein mono-ADP-ribosyltransferase PARP4', 'PARP4', 4, NULL),
(25753, NULL, 'IPR027284', NULL, 'Hepatocyte growth factor', 'Hepatocyte_GF', 4, NULL),
(25754, NULL, 'IPR031798', NULL, 'Alginate biosynthesis protein AlgX, C-terminal carbohydrate-binding module', 'AlgX_C', 3, NULL),
(25755, NULL, 'IPR027848', NULL, 'Protein of unknown function DUF4494', 'DUF4494', 4, NULL),
(25756, NULL, 'IPR031808', NULL, 'JMY/WHAMM, N-terminal', 'JMY/WHAMM_N', 3, NULL),
(25757, NULL, 'IPR031531', NULL, 'Dynein axonemal assembly factor 8', 'DNAAF8', 4, NULL),
(25758, NULL, 'IPR025996', NULL, 'Tetracyclin repressor-like, C-terminal domain (WHG)', 'TetR_C_WHG', 3, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(25759, NULL, 'IPR031730', NULL, 'Carbamoyltransferase, C-terminal', 'Carbam_trans_C', 3, NULL),
(25760, NULL, 'IPR031142', NULL, 'SPX domain-containing protein', 'SPX_prot', 4, NULL),
(25761, NULL, 'IPR027075', NULL, 'Cleavage and polyadenylation specificity factor subunit 2', 'CPSF2', 4, NULL),
(25762, NULL, 'IPR031628', NULL, 'BCL-6 corepressor, non-ankyrin-repeat domain', 'BCOR', 3, NULL),
(25763, NULL, 'IPR031780', NULL, 'FAM65, N-terminal', 'FAM65_N', 3, NULL),
(25764, NULL, 'IPR031465', NULL, 'Protein of unknown function DUF4681', 'DUF4681', 4, NULL),
(25765, NULL, 'IPR026222', NULL, 'Apolipoprotein D, vertebrates', 'ApoD_vertbrte', 4, NULL),
(25766, NULL, 'IPR025859', NULL, 'P-aminobenzoate N-oxygenase AurF', 'AurF', 4, NULL),
(25767, NULL, 'IPR026111', NULL, 'Actin-binding Rho-activating protein', 'Abra', 4, NULL),
(25768, NULL, 'IPR031722', NULL, 'Coilin, N-terminal domain', 'Coilin_N', 3, NULL),
(25769, NULL, 'IPR025274', NULL, 'Domain of unknown function DUF4070', 'DUF4070', 3, NULL),
(25770, NULL, 'IPR029441', NULL, 'Integron-associated effector binding protein', 'Cass2', 3, NULL),
(25771, NULL, 'IPR031832', NULL, 'Protein of unknown function DUF4747', 'DUF4747', 4, NULL),
(25772, NULL, 'IPR029051', NULL, 'Domain of unknown function DUF4352', 'DUF4352', 3, NULL),
(25773, NULL, 'IPR026320', NULL, 'Proline-rich protein 14', 'PRR14', 4, NULL),
(25774, NULL, 'IPR027393', NULL, 'Virus scaffolding protein, C-terminal', 'Virus_scaffolding_prot_C', 5, NULL),
(25775, NULL, 'IPR026989', NULL, 'Transposon-encoded protein TnpV', 'TnpV', 4, NULL),
(25776, NULL, 'IPR029000', NULL, 'Cyclophilin-like domain superfamily', 'Cyclophilin-like_dom_sf', 5, NULL),
(25777, NULL, 'IPR027487', NULL, 'Mitochondrial ribosomal protein L48', 'Ribosomal_L48', 4, NULL),
(25778, NULL, 'IPR027890', NULL, 'Protein of unknown function DUF4491', 'DUF4491', 4, NULL),
(25779, NULL, 'IPR031917', NULL, 'Pilus assembly protein, C-terminal domain', 'Pilus_assem_C', 3, NULL),
(25780, NULL, 'IPR026962', NULL, 'Katanin p80 WD40 repeat-containing subunit B1', 'KTNB1', 4, NULL),
(25781, NULL, 'IPR032011', NULL, 'Domain of unknown function DUF4794', 'DUF4794', 3, NULL),
(25782, NULL, 'IPR026677', NULL, 'Uncharacterised protein C9orf131', 'UPF_C9orf131', 4, NULL),
(25783, NULL, 'IPR030773', NULL, 'Histatin/statherin family', 'Histatin/statherin', 4, NULL),
(25784, NULL, 'IPR025892', NULL, 'Developmental pluripotency-associated protein 2/4, central domain', 'Dppa2/4_central_dom', 3, NULL),
(25785, NULL, 'IPR031731', NULL, 'IMS import disulfide relay-system, CHCH-CHCH-like Cx9C', 'CX9C', 3, NULL),
(25786, NULL, 'IPR032543', NULL, 'Protein of unknown function DUF4946', 'DUF4946', 4, NULL),
(25787, NULL, 'IPR025248', NULL, 'Domain of unknown function DUF4007', 'DUF4007', 3, NULL),
(25788, NULL, 'IPR026321', NULL, 'Coiled-coil domain-containing protein 134', 'Coiled-coil_dom_con_pro_134', 4, NULL),
(25789, NULL, 'IPR026990', NULL, 'Transposon-encoded protein TnpW', 'TnpW', 4, NULL),
(25790, NULL, 'IPR025870', NULL, 'Glyoxalase-like domain', 'Glyoxalase-like_dom', 3, NULL),
(25791, NULL, 'IPR027862', NULL, 'Protein of unknown function DUF4534', 'DUF4534', 4, NULL),
(25792, NULL, 'IPR025010', NULL, 'Protein of unknown function DUF3978', 'DUF3978', 4, NULL),
(25793, NULL, 'IPR031009', NULL, 'Three-Cys-motif partner protein', 'Tcm_partner', 4, NULL),
(25794, NULL, 'IPR031012', NULL, 'Radical SAM mobile pair protein B', 'rSAM_mob_pairB', 4, NULL),
(25795, NULL, 'IPR031926', NULL, 'Transmembrane protein 135, N-terminal domain', 'TMEM135_N', 3, NULL),
(25796, NULL, 'IPR026208', NULL, 'Wolframin', 'Wolframin', 4, NULL),
(25797, NULL, 'IPR031651', NULL, 'Domain of unknown function DUF4709', 'DUF4709', 3, NULL),
(25798, NULL, 'IPR031683', NULL, 'Domain of unknown function DUF4716', 'DUF4716', 3, NULL),
(25799, NULL, 'IPR031847', NULL, 'Domain of unknown function DUF4749', 'DUF4749', 3, NULL),
(25800, NULL, 'IPR026674', NULL, 'Flagellum-associated coiled-coil domain-containing protein 1', 'FLACC1', 4, NULL),
(25801, NULL, 'IPR024723', NULL, 'Termicin', 'Termicin', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(25802, NULL, 'IPR031665', NULL, 'UPF0730 family', 'UPF0730', 4, NULL),
(25803, NULL, 'IPR026307', NULL, 'Transmembrane protein 132', 'TMEM132', 4, NULL),
(25804, NULL, 'IPR032040', NULL, 'ELYS, beta-propeller domain', 'ELYS-bb', 3, NULL),
(25805, NULL, 'IPR031168', NULL, 'TrmE-type guanine nucleotide-binding domain', 'G_TrmE', 3, NULL),
(25806, NULL, 'IPR025871', NULL, 'Growth hormone-binding protein', 'GHBP', 3, NULL),
(25807, NULL, 'IPR026687', NULL, 'Coiled-coil domain-containing protein 181', 'CCDC181', 4, NULL),
(25808, NULL, 'IPR025249', NULL, 'KH domain, NusA-like', 'KH_dom_NusA-like', 3, NULL),
(25809, NULL, 'IPR031021', NULL, 'Enduracididine biosynthesis enzyme MppQ', 'Endura_MppQ', 4, NULL),
(25810, NULL, 'IPR029641', NULL, 'Anaphase-promoting complex subunit 16', 'APC16', 4, NULL),
(25811, NULL, 'IPR027858', NULL, 'Protein BRAWNIN', 'BRAWNIN', 4, NULL),
(25812, NULL, 'IPR032548', NULL, 'Protein of unknown function DUF4940', 'DUF4940', 4, NULL),
(25813, NULL, 'IPR031010', NULL, 'Radical SAM mobile pair protein A', 'rSAM_mob_pairA', 4, NULL),
(25814, NULL, 'IPR029139', NULL, 'NADPH-dependent 7-cyano-7-deazaguanine reductase, N-terminal', 'QueF_N', 3, NULL),
(25815, NULL, 'IPR029156', NULL, 'CST complex subunit CTC1', 'CTC1', 4, NULL),
(25816, NULL, 'IPR027288', NULL, 'Platelet-derived growth factor receptor beta', 'PGFRB', 4, NULL),
(25817, NULL, 'IPR031176', NULL, 'ELL/occludin family', 'ELL/occludin', 4, NULL),
(25818, NULL, 'IPR029144', NULL, 'Threonine synthase, N-terminal', 'Thr_synth_N', 3, NULL),
(25819, NULL, 'IPR032010', NULL, 'E3 ubiquitin-protein ligase APD1-4, middle domain', 'APD1-4_M', 3, NULL),
(25820, NULL, 'IPR026306', NULL, 'RSBN1/Dpy-21', 'RSBN1/Dpy-21', 4, NULL),
(25821, NULL, 'IPR030679', NULL, 'ABC-type amino acid transport system, ATPase component, HisP-type', 'ABC_ATPase_HisP-typ', 4, NULL),
(25822, NULL, 'IPR026956', NULL, 'D-serine dehydratase-like domain', 'D-ser_dehydrat-like_dom', 3, NULL),
(25823, NULL, 'IPR027868', NULL, 'Protein of unknown function DUF4630', 'DUF4630', 4, NULL),
(25824, NULL, 'IPR026952', NULL, 'WVELL protein', 'WVELL', 4, NULL),
(25825, NULL, 'IPR026217', NULL, 'Ddc1', 'Ddc1', 4, NULL),
(25826, NULL, 'IPR030914', NULL, 'Mobilome CxxCx(11)CxxC protein', 'Mob_CxxC_CxxC', 4, NULL),
(25827, NULL, 'IPR031756', NULL, 'Beta-1,3-glucan-binding protein, N-terminal', 'BGBP_N', 3, NULL),
(25828, NULL, 'IPR025614', NULL, 'Cell morphogenesis protein N-terminal', 'Cell_morpho_N', 3, NULL),
(25829, NULL, 'IPR031605', NULL, 'Putative OMPG-porin 1 family', 'Porin_OmpG_1_2', 4, NULL),
(25830, NULL, 'IPR031025', NULL, 'LruC domain', 'LruC_dom', 3, NULL),
(25831, NULL, 'IPR025861', NULL, 'Cobalamin biosynthesis protein CobT VWA domain', 'CobT_VWA_dom', 3, NULL),
(25832, NULL, 'IPR027397', NULL, 'Catenin binding domain superfamily', 'Catenin-bd_sf', 5, NULL),
(25833, NULL, 'IPR025878', NULL, 'Acetyl-CoA dehydrogenase-like C-terminal domain', 'Acyl-CoA_dh-like_C_dom', 3, NULL),
(25834, NULL, 'IPR027860', NULL, 'Domain of unknown function DUF4429', 'DUF4429', 3, NULL),
(25835, NULL, 'IPR027884', NULL, 'Domain of unknown function DUF4614', 'DUF4614', 3, NULL),
(25836, NULL, 'IPR026219', NULL, 'Jagged/Serrate protein', 'Jagged/Serrate', 4, NULL),
(25837, NULL, 'IPR032006', NULL, 'Transmembrane inner ear expressed protein', 'TMIE', 4, NULL),
(25838, NULL, 'IPR031259', NULL, 'Intracellular lipid binding protein', 'ILBP', 4, NULL),
(25839, NULL, 'IPR028804', NULL, 'SSX family', 'SSX', 4, NULL),
(25840, NULL, 'IPR025014', NULL, 'Protein of unknown function DUF3958', 'DUF3958', 4, NULL),
(25841, NULL, 'IPR032541', NULL, 'Protein of unknown function DUF4948', 'DUF4948', 4, NULL),
(25842, NULL, 'IPR027493', NULL, 'Ribosomal protein L31 type B', 'Ribosomal_L31_B', 4, NULL),
(25843, NULL, 'IPR032041', NULL, 'Paf1 complex subunit Cdc73, N-terminal domain', 'Cdc73_N', 3, NULL),
(25844, NULL, 'IPR025008', NULL, 'Domain of unknown function DUF3976', 'DUF3976', 3, NULL),
(25845, NULL, 'IPR027498', NULL, 'Ribosomal protein S2, eukaryotic', 'Ribosomal_S2_euk', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(25846, NULL, 'IPR031797', NULL, 'IGP family C-type lectin domain', 'DUF5075', 4, NULL),
(25847, NULL, 'IPR031013', NULL, 'CGA synthase-related protein', 'CGA_synth-rel', 4, NULL),
(25848, NULL, 'IPR031015', NULL, 'Arginine 2,3-aminomutase', 'Arg_2_3_am_muta', 4, NULL),
(25849, NULL, 'IPR025863', NULL, 'Choline sulfatase enzyme C-terminal domain', 'Choline_sulf_C_dom', 3, NULL),
(25850, NULL, 'IPR031901', NULL, 'Unpaired protein', 'Unpaired', 4, NULL),
(25851, NULL, 'IPR031775', NULL, 'cGMP-dependent protein kinase, interacting domain', 'PRKG1_interact', 3, NULL),
(25852, NULL, 'IPR033979', NULL, 'MINDY deubiquitinase domain', 'MINDY_domain', 3, NULL),
(25853, NULL, 'IPR029131', NULL, 'HAUS augmin-like complex subunit 5', 'HAUS5', 4, NULL),
(25854, NULL, 'IPR028540', NULL, 'A-kinase anchor protein 12', 'AKAP12', 4, NULL),
(25855, NULL, 'IPR025895', NULL, 'Lysine-2,3-aminomutase, C-terminal domain', 'LAM_C_dom', 3, NULL),
(25856, NULL, 'IPR028629', NULL, 'CRISPR-associated endonuclease Cas9', 'Cas9', 4, NULL),
(25857, NULL, 'IPR031609', NULL, 'Cyclodextrin porin CymA', 'CymA', 4, NULL),
(25858, NULL, 'IPR028058', NULL, 'Fis1, N-terminal tetratricopeptide repeat', 'Fis1_TPR_N', 7, NULL),
(25859, NULL, 'IPR032533', NULL, 'Protein of unknown function DUF4954', 'DUF4954', 4, NULL),
(25860, NULL, 'IPR025009', NULL, 'Protein of unknown function DUF3977', 'DUF3977', 4, NULL),
(25861, NULL, 'IPR032016', NULL, 'Protein of unknown function DUF4796', 'DUF4796', 4, NULL),
(25862, NULL, 'IPR031532', NULL, 'Protein of unknown function DUF4702', 'DUF4702', 4, NULL),
(25863, NULL, 'IPR029148', NULL, 'FACT complex subunit Spt16, N-terminal lobe domain', 'FACT-Spt16_Nlobe', 3, NULL),
(25864, NULL, 'IPR029439', NULL, 'Wzt, C-terminal', 'Wzt_C', 3, NULL),
(25865, NULL, 'IPR031627', NULL, 'PDZK1-interacting protein 1/SMIM24', 'PDZK1IP1/SMIM24', 4, NULL),
(25866, NULL, 'IPR027023', NULL, 'Putative lipopolysaccharide kinase InaA', 'Put_LipoPS_kinase_InaA', 4, NULL),
(25867, NULL, 'IPR025224', NULL, 'Cell cycle and apoptosis regulator protein', 'CCAR1/CCAR2', 4, NULL),
(25868, NULL, 'IPR025867', NULL, 'MnmE, helical domain', 'MnmE_helical', 3, NULL),
(25869, NULL, 'IPR027488', NULL, 'Ribosomal protein S3, archaeal', 'Ribosomal_S3_arc', 4, NULL),
(25870, NULL, 'IPR024921', NULL, 'Protein-export membrane protein SecF, archaeal', 'SecF_arc', 4, NULL),
(25871, NULL, 'IPR032532', NULL, 'Domain of unknown function DUF4955', 'DUF4955', 3, NULL),
(25872, NULL, 'IPR026114', NULL, 'Apolipoprotein F', 'APOF', 4, NULL),
(25873, NULL, 'IPR031927', NULL, 'Domain of unknown function DUF4767', 'DUF4767', 3, NULL),
(25874, NULL, 'IPR031016', NULL, 'Hydroxymethylcytosylglucuronate/cytosylglucuronate synthase', 'CGA_synthase', 4, NULL),
(25875, NULL, 'IPR027869', NULL, 'TASL protein', 'TASL', 4, NULL),
(25876, NULL, 'IPR026676', NULL, 'Synaptonemal complex central element protein 1', 'SYCE1', 4, NULL),
(25877, NULL, 'IPR028607', NULL, '2-deoxynucleoside 5-phosphate N-hydrolase 1, DNPH1', 'DNPH1', 4, NULL),
(25878, NULL, 'IPR026679', NULL, 'Microtubule-associated protein 10, C-terminal', 'MAP10_C-term', 3, NULL),
(25879, NULL, 'IPR032607', NULL, 'Protein of unknown function DUF4894', 'DUF4894', 4, NULL),
(25880, NULL, 'IPR027861', NULL, 'Cation channel sperm-associated auxiliary subunit TMEM249', 'TMEM249', 4, NULL),
(25881, NULL, 'IPR026314', NULL, 'YLP motif-containing protein 1', 'YLP_motif_con_p1', 4, NULL),
(25882, NULL, 'IPR030967', NULL, 'dTDP-4-dehydro-6-deoxyglucose aminotransferase', 'PLP_DesI', 4, NULL),
(25883, NULL, 'IPR032117', NULL, 'Caskin, C-terminal', 'Caskin_C', 3, NULL),
(25884, NULL, 'IPR032537', NULL, 'Protein of unknown function DUF4952', 'DUF4952', 4, NULL),
(25885, NULL, 'IPR029152', NULL, 'Protein LKAAEAR1', 'LKAAEAR1', 4, NULL),
(25886, NULL, 'IPR026302', NULL, 'NEDD4-binding protein 2', 'NEDD4_b_p2', 4, NULL),
(25887, NULL, 'IPR027853', NULL, 'Protein of unknown function DUF4492', 'DUF4492', 4, NULL),
(25888, NULL, 'IPR027081', NULL, 'CyclinH/Ccl1', 'CyclinH/Ccl1', 4, NULL),
(25889, NULL, 'IPR026123', NULL, 'SCL-interrupting locus protein', 'Sil', 4, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(25890, NULL, 'IPR031833', NULL, 'Protein of unknown function DUF4748', 'DUF4748', 4, NULL),
(25891, NULL, 'IPR031464', NULL, 'Protein of unknown function DUF4680', 'DUF4680', 4, NULL),
(25892, NULL, 'IPR025272', NULL, 'Antitoxin SocA-like, Panacea domain', 'SocA_Panacea', 3, NULL),
(25893, NULL, 'IPR032549', NULL, 'Domain of unknown function DUF4939', 'DUF4939', 3, NULL),
(25894, NULL, 'IPR031828', NULL, 'Myofilin', 'Myofilin', 4, NULL),
(25895, NULL, 'IPR029151', NULL, 'Periplasmic sensor-like domain superfamily', 'Sensor-like_sf', 5, NULL),
(25896, NULL, 'IPR027854', NULL, 'Short transmembrane mitochondrial protein 1', 'STMP1', 4, NULL),
(25897, NULL, 'IPR025002', NULL, 'Domain of unknown function DUF3972', 'DUF3972', 3, NULL),
(25898, NULL, 'IPR032043', NULL, 'E3 ubiquitin-protein ligase Msl2, zinc RING finger', 'Msl2_Znf-RING', 3, NULL),
(25899, NULL, 'IPR031924', NULL, 'Glycosyl hydrolase family 115', 'GH115', 4, NULL),
(25900, NULL, 'IPR031897', NULL, 'DolP-mannose mannosyltransferase AglS', 'AglS', 4, NULL),
(25901, NULL, 'IPR027857', NULL, 'Protein SPO16 homolog', 'SCRE', 4, NULL),
(25902, NULL, 'IPR031751', NULL, 'Protein of unknown function DUF4735', 'DUF4735', 4, NULL),
(25903, NULL, 'IPR031716', NULL, 'Late cornified envelope protein 6A', 'LCE6A', 4, NULL),
(25904, NULL, 'IPR032038', NULL, 'Adenomatous polyposis coli, N-terminal dimerisation domain', 'APC_N', 3, NULL),
(25905, NULL, 'IPR027285', NULL, 'Bombyxin B', 'Bombyxin_B', 4, NULL),
(25906, NULL, 'IPR031727', NULL, 'Galactose mutarotase, N-terminal barrel', 'Gal_mutarotase_N', 3, NULL),
(25907, NULL, 'IPR031632', NULL, 'Small VCP/p97-interacting protein', 'SVIP', 4, NULL),
(25908, NULL, 'IPR027850', NULL, 'Protein of unknown function DUF4504', 'DUF4504', 4, NULL),
(25909, NULL, 'IPR027302', NULL, 'Glutamine synthetase, N-terminal conserved site', 'Gln_synth_N_conserv_site', 2, NULL),
(25910, NULL, 'IPR025016', NULL, 'Protein of unknown function DUF3955', 'DUF3955', 4, NULL),
(25911, NULL, 'IPR031754', NULL, 'Protein of unknown function DUF4736', 'DUF4736', 4, NULL),
(25912, NULL, 'IPR027852', NULL, 'Steroid receptor-associated and regulated protein', 'C1ORF64', 4, NULL),
(25913, NULL, 'IPR031305', NULL, 'Casein alpha/beta, conserved site', 'Casein_CS', 2, NULL),
(25914, NULL, 'IPR027141', NULL, 'Like-Sm (LSM) domain containing protein, LSm4/SmD1/SmD3', 'LSm4/Sm_D1/D3', 4, NULL),
(25915, NULL, 'IPR030913', NULL, 'Twin-arginine translocation signal, Cys-rich four helix bundle protein', 'TAT_Cys_rich', 4, NULL),
(25916, NULL, 'IPR027263', NULL, 'Mast/stem cell growth factor receptor', 'SCGF_receptor', 4, NULL),
(25917, NULL, 'IPR031612', NULL, 'Putative phage holin', 'Phage_holin_Dp1', 4, NULL),
(25918, NULL, 'IPR028472', NULL, 'Eyes absent family', 'EYA_fam', 4, NULL),
(25919, NULL, 'IPR031715', NULL, 'Protein of unknown function DUF4727', 'DUF4727', 4, NULL),
(25920, NULL, 'IPR031750', NULL, 'Domain of unknown function DUF4734', 'DUF4734', 3, NULL),
(25921, NULL, 'IPR031534', NULL, 'Sperm acrosome developmental regulator', 'SPACDR', 4, NULL),
(25922, NULL, 'IPR025874', NULL, 'Double zinc ribbon', 'DZR', 3, NULL),
(25923, NULL, 'IPR031782', NULL, 'LKB1 serine/threonine kinase interacting protein 1, N-terminal', 'LIP1_N', 3, NULL),
(25924, NULL, 'IPR026966', NULL, 'Neurofascin/L1/NrCAM, C-terminal domain', 'Neurofascin/L1/NrCAM_C', 3, NULL),
(25925, NULL, 'IPR029454', NULL, 'ODR-4-like', 'ODR-4-like', 4, NULL),
(25926, NULL, 'IPR026103', NULL, 'Harbinger transposase-derived nuclease, animal', 'HARBI1_animal', 4, NULL),
(25927, NULL, 'IPR027882', NULL, 'Domain of unknown function DUF4482', 'DUF4482', 3, NULL),
(25928, NULL, 'IPR027880', NULL, 'Protein of unknown function DUF4635', 'DUF4635', 4, NULL),
(25929, NULL, 'IPR031607', NULL, 'Cag pathogenicity island, type IV secretory system', 'T4SS_CagC', 4, NULL),
(25930, NULL, 'IPR027879', NULL, 'Protein of unknown function DUF4649', 'DUF4649', 4, NULL),
(25931, NULL, 'IPR031810', NULL, 'YjeJ-like', 'YjeJ-like', 4, NULL),
(25932, NULL, 'IPR027866', NULL, 'Retroelement silencing factor 1', 'RESF1', 4, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(25933, NULL, 'IPR026115', NULL, 'Novel Amplified in Breast Cancer-1', 'NABC1', 4, NULL),
(25934, NULL, 'IPR029048', NULL, 'Heat shock protein 70kD, C-terminal domain superfamily', 'HSP70_C_sf', 5, NULL),
(25935, NULL, 'IPR028608', NULL, 'Probable cytosolic iron-sulfur protein assembly protein, CIAO1/Cia1', 'CIAO1/Cia1', 4, NULL),
(25936, NULL, 'IPR026743', NULL, 'Sperm equatorial segment protein 1', 'Equatorial_segment', 4, NULL),
(25937, NULL, 'IPR031771', NULL, 'CAAX box protein 1', 'CAAX_1', 4, NULL),
(25938, NULL, 'IPR029827', NULL, 'J domain-containing protein 1-like', 'JDP1-like', 4, NULL),
(25939, NULL, 'IPR029455', NULL, 'Hypothetical glycosyl hydrolase family 15', 'GHL15', 4, NULL),
(25940, NULL, 'IPR025896', NULL, 'Spi protease inhibitor', 'Spi_Prtas-inh', 3, NULL),
(25941, NULL, 'IPR035925', NULL, 'BSD domain superfamily', 'BSD_dom_sf', 5, NULL),
(25942, NULL, 'IPR027504', NULL, '40S ribosomal protein SA', '40S_ribosomal_SA', 4, NULL),
(25943, NULL, 'IPR025300', NULL, 'Beta-galactosidase jelly roll domain', 'BetaGal_jelly_roll_dom', 3, NULL),
(25944, NULL, 'IPR025005', NULL, 'Domain of unknown function DUF3974', 'DUF3974', 3, NULL),
(25945, NULL, 'IPR028061', NULL, 'Fis1, C-terminal tetratricopeptide repeat', 'Fis1_TPR_C', 7, NULL),
(25946, NULL, 'IPR028122', NULL, 'FAM24 family', 'FAM24', 4, NULL),
(25947, NULL, 'IPR029456', NULL, 'Sialidase, N-terminal', 'Sialidase_N', 3, NULL),
(25948, NULL, 'IPR027497', NULL, 'Katanin p60 ATPase-containing subunit A-like 2', 'Katanin_p60_AL2', 4, NULL),
(25949, NULL, 'IPR032013', NULL, 'Protein of unknown function DUF4795', 'DUF4795', 4, NULL),
(25950, NULL, 'IPR025984', NULL, 'dCTP pyrophosphatase 1', 'DCTPP', 4, NULL),
(25951, NULL, 'IPR029150', NULL, 'Double Cache domain 3', 'dCache_3', 3, NULL),
(25952, NULL, 'IPR029458', NULL, 'Ras-binding domain of Byr2', 'Ras-bd_By2', 3, NULL),
(25953, NULL, 'IPR031736', NULL, 'Elongin A binding-protein 1', 'EloA-BP1', 3, NULL),
(25954, NULL, 'IPR031834', NULL, 'Antitoxin RnlB/LsoB', 'RnlB/LsoB_antitoxin', 4, NULL),
(25955, NULL, 'IPR025993', NULL, 'Ceramide glucosyltransferase', 'Ceramide_glucosylTrfase', 4, NULL),
(25956, NULL, 'IPR029457', NULL, 'Hypothetical glycoside hydrolase 5', 'GHL5', 4, NULL),
(25957, NULL, 'IPR025610', NULL, 'Transcription factor MYC/MYB N-terminal', 'MYC/MYB_N', 3, NULL),
(25958, NULL, 'IPR028352', NULL, 'Protozoan surface antigen, SAG1 family', 'Surface_antig_SAG1', 4, NULL),
(25959, NULL, 'IPR025868', NULL, 'Putative zinc ribbon domain', 'Zn_ribbon_dom_put', 3, NULL),
(25960, NULL, 'IPR025999', NULL, 'Microspherule protein, N-terminal domain', 'MCRS_N', 3, NULL),
(25961, NULL, 'IPR027896', NULL, 'Ubiquinol-cytochrome-c reductase complex assembly factor 3', 'UQCC3', 4, NULL),
(25962, NULL, 'IPR031608', NULL, 'Putative cyclic bacteriocin', 'CclA_1', 4, NULL),
(25963, NULL, 'IPR025263', NULL, 'Domain of unknown function DUF3971', 'DUF3971', 3, NULL),
(25964, NULL, 'IPR031945', NULL, 'Protein of unknown function DUF4775', 'DUF4775', 4, NULL),
(25965, NULL, 'IPR031892', NULL, 'Abi component, membrane-anchored ion channel RexB', 'RexB', 4, NULL),
(25966, NULL, 'IPR024906', NULL, 'Enoyl reductase FAD binding domain', 'Eno_Rdtase_FAD-bd_dom', 3, NULL),
(25967, NULL, 'IPR031827', NULL, 'Domain of unknown function DUF4746', 'DUF4746', 3, NULL),
(25968, NULL, 'IPR031796', NULL, 'Protein of unknown function DUF5076', 'DUF5076', 4, NULL),
(25969, NULL, 'IPR027491', NULL, 'Ribosomal protein L31 type A', 'Ribosomal_L31_A', 4, NULL),
(25970, NULL, 'IPR032007', NULL, 'Protein of unknown function DUF4791', 'DUF4791', 4, NULL),
(25971, NULL, 'IPR026752', NULL, 'Cavin family', 'Cavin_fam', 4, NULL),
(25972, NULL, 'IPR031903', NULL, 'Domain of unknown function DUF4766', 'DUF4766', 3, NULL),
(25973, NULL, 'IPR025866', NULL, 'Polymerase A arginine-rich C-terminal domain', 'PolyA_pol_arg_C_dom', 3, NULL),
(25974, NULL, 'IPR031610', NULL, 'Protein TIC110, chloroplastic', 'TIC110', 4, NULL),
(25975, NULL, 'IPR031019', NULL, 'Radical SAM/SPASM domain protein maturase', 'rSAM_vs_C_rich', 4, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(25976, NULL, 'IPR027856', NULL, 'Protein of unknown function DUF4573', 'DUF4573', 4, NULL),
(25977, NULL, 'IPR031022', NULL, 'Enduracididine biosynthesis enzyme MppR', 'Endura_MppR', 4, NULL),
(25978, NULL, 'IPR031894', NULL, 'Abi component, intracellular sensor of Lambda phage RexA', 'RexA', 4, NULL),
(25979, NULL, 'IPR025992', NULL, 'Haem-binding domain', 'Haem-bd', 3, NULL),
(25980, NULL, 'IPR031338', NULL, 'KDPG/KHG aldolase, active site 2', 'KDPG/KHG_AS_2', 0, NULL),
(25981, NULL, 'IPR027282', NULL, 'Two partner secretion pathway transporter', 'TPS', 4, NULL),
(25982, NULL, 'IPR030072', NULL, 'Xin actin-binding repeat-containing protein 1/2', 'XIRP1/XIRP2', 4, NULL),
(25983, NULL, 'IPR029638', NULL, 'Protein FAM78', 'FAM78', 4, NULL),
(25984, NULL, 'IPR027872', NULL, 'Domain of unknown function DUF4428', 'DUF4428', 3, NULL),
(25985, NULL, 'IPR031684', NULL, 'Sperm-egg fusion protein LLCFC1', 'LLCFC1', 4, NULL),
(25986, NULL, 'IPR026134', NULL, 'MyoD family inhibitor/MyoD family inhibitor domain-containing protein', 'MDFI/MDFIC', 4, NULL),
(25987, NULL, 'IPR026317', NULL, 'Protein C10', 'P_C10', 4, NULL),
(25988, NULL, 'IPR027283', NULL, 'Glutamate synthase large subunit-like protein, bacteria', 'YerD', 4, NULL),
(25989, NULL, 'IPR026961', NULL, 'PGG domain', 'PGG_dom', 3, NULL),
(25990, NULL, 'IPR031795', NULL, 'Putative zinc-finger containing protein', 'Zf-HC3', 4, NULL),
(25991, NULL, 'IPR031535', NULL, 'Proline-rich protein 22', 'PRR22', 4, NULL),
(25992, NULL, 'IPR031922', NULL, 'Pesticin, C-terminal', 'Pesticin_C', 3, NULL),
(25993, NULL, 'IPR030969', NULL, 'Tryptophan 2-C-methyltransferase', 'B12_rSAM_trp_MT', 4, NULL),
(25994, NULL, 'IPR025018', NULL, 'Protein of unknown function DUF3953', 'DUF3953', 4, NULL),
(25995, NULL, 'IPR026680', NULL, 'Coiled-coil domain-containing protein 137', 'CCDC137', 4, NULL),
(25996, NULL, 'IPR031419', NULL, 'RAD51 interacting motif', 'RAD51_interact', 3, NULL),
(25997, NULL, 'IPR027881', NULL, 'Protein SOGA', 'SOGA', 4, NULL),
(25998, NULL, 'IPR031718', NULL, 'Deleted in esophageal cancer 1', 'DEC1', 4, NULL),
(25999, NULL, 'IPR029447', NULL, 'Domain of unknown function DUF4439', 'DUF4439', 3, NULL),
(26000, NULL, 'IPR030919', NULL, 'Sporulation killing factor SkfA', 'RiPP_SkfA', 4, NULL),
(26001, NULL, 'IPR029372', NULL, 'Voltage-dependent calcium channel gamma-like subunit', 'Tmem37', 4, NULL),
(26002, NULL, 'IPR029284', NULL, 'p53-regulated apoptosis-inducing protein 1', 'TP53AIP1', 4, NULL),
(26003, NULL, 'IPR031430', NULL, 'Outer spore wall protein 5', 'Osw5', 4, NULL),
(26004, NULL, 'IPR031433', NULL, 'Monopolar spindle protein 2', 'Mps2', 4, NULL),
(26005, NULL, 'IPR025528', NULL, 'BrnA antitoxin of type II toxin-antitoxin system', 'BrnA_antitoxin', 4, NULL),
(26006, NULL, 'IPR024732', NULL, 'Alpha-N-acetylglucosaminidase, C-terminal', 'NAGLU_C', 3, NULL),
(26007, NULL, 'IPR032732', NULL, 'Spermatogenesis-associated protein 6, N-terminal', 'SPATA6_N', 3, NULL),
(26008, NULL, 'IPR032680', NULL, 'SUN domain-containing protein 1, N-terminal', 'SUN1_N', 3, NULL),
(26009, NULL, 'IPR025464', NULL, 'Protein of unknown function DUF4315', 'DUF4315', 4, NULL),
(26010, NULL, 'IPR025529', NULL, 'Protein of unknown function DUF4416', 'DUF4416', 4, NULL),
(26011, NULL, 'IPR025708', NULL, 'Heat shock protein 15', 'HSP15', 4, NULL),
(26012, NULL, 'IPR032147', NULL, 'Domain of unknown function DUF4819', 'DUF4819', 3, NULL),
(26013, NULL, 'IPR032285', NULL, 'Calcineurin-like phosphoesterase, N-terminal', 'Metallophos_N', 3, NULL),
(26014, NULL, 'IPR032314', NULL, 'Protein of unknown function DUF4845', 'DUF4845', 4, NULL),
(26015, NULL, 'IPR025161', NULL, 'Putative transposase IS4/IS5 family', 'Put_IS4/IS5', 4, NULL),
(26016, NULL, 'IPR031027', NULL, 'Probable lipoprotein, LA_1396/MXAN_6521 family', 'Lipo_MXAN_6521', 4, NULL),
(26017, NULL, 'IPR032614', NULL, 'Protein of unknown function DUF4888', 'DUF4888', 4, NULL),
(26018, NULL, 'IPR025379', NULL, 'Protein of unknown function DUF4295', 'DUF4295', 4, NULL),
(26019, NULL, 'IPR031405', NULL, 'Nuclear receptor-interacting protein 1, repression domain 1', 'NRIP1_RD1', 3, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(26020, NULL, 'IPR025520', NULL, 'Domain of unknown function DUF4408', 'DUF4408', 3, NULL),
(26021, NULL, 'IPR025516', NULL, 'Protein of unknown function DUF4404', 'DUF4404', 4, NULL),
(26022, NULL, 'IPR029267', NULL, 'FAM212 domain', 'FAM212', 3, NULL),
(26023, NULL, 'IPR025486', NULL, 'Domain of unknown function DUF4378', 'DUF4378', 3, NULL),
(26024, NULL, 'IPR028596', NULL, 'Katanin p60 subunit A1', 'KATNA1', 4, NULL),
(26025, NULL, 'IPR032691', NULL, 'Mon2/Sec7/BIG1-like, HUS domain', 'Mon2/Sec7/BIG1-like_HUS', 3, NULL),
(26026, NULL, 'IPR025508', NULL, 'Domain of unknown function DUF4395', 'DUF4395', 3, NULL),
(26027, NULL, 'IPR025463', NULL, 'Domain of unknown function DUF4314', 'DUF4314', 3, NULL),
(26028, NULL, 'IPR025164', NULL, 'Putative adhesin', 'DUF4097', 3, NULL),
(26029, NULL, 'IPR025396', NULL, 'Protein of unknown function DUF4302', 'DUF4302', 4, NULL),
(26030, NULL, 'IPR031461', NULL, 'Protein of unknown function DUF4679', 'DUF4679', 4, NULL),
(26031, NULL, 'IPR032733', NULL, 'HAUS augmin-like complex subunit 3, N-terminal', 'HAUS3_N', 3, NULL),
(26032, NULL, 'IPR032435', NULL, 'Band 7, C-terminal extension', 'Band_7_C', 3, NULL),
(26033, NULL, 'IPR025707', NULL, 'Predicted DNA-binding protein with PD1-like DNA-binding motif', 'DNA_bp_PD1', 4, NULL),
(26034, NULL, 'IPR026214', NULL, 'HAUS augmin-like complex subunit 4, metazoa', 'HAUS4_met', 4, NULL),
(26035, NULL, 'IPR031343', NULL, 'Domain of unknown function DUF5105', 'DUF5105', 3, NULL),
(26036, NULL, 'IPR029272', NULL, 'Coiled-coil domain-containing protein 7', 'CCDC7', 4, NULL),
(26037, NULL, 'IPR030929', NULL, 'Glycosyltransferase Aah/TibC', 'Aah/TibC', 4, NULL),
(26038, NULL, 'IPR025535', NULL, 'Protein of unknown function DUF4421', 'DUF4421', 4, NULL),
(26039, NULL, 'IPR027451', NULL, 'Arabinofuranosyltransferase, domain 1', 'EmbABC_dom1', 5, NULL),
(26040, NULL, 'IPR031034', NULL, 'Creatinine amidohydrolase', 'Creatininase', 4, NULL),
(26041, NULL, 'IPR025595', NULL, 'Domain of unknown function DUF4346', 'DUF4346', 3, NULL),
(26042, NULL, 'IPR025487', NULL, 'Probable Zinc-ribbon domain', 'DUF4379', 3, NULL),
(26043, NULL, 'IPR027784', NULL, 'Structure-specific endonuclease subunit Slx4, ascomycetes', 'Slx4_ascomycetes', 4, NULL),
(26044, NULL, 'IPR032723', NULL, 'Deaminase, LmjF36.5940-like', 'Deaminase_LmjF365940', 4, NULL),
(26045, NULL, 'IPR032679', NULL, 'Sin1, N-terminal', 'Sin1_N', 3, NULL),
(26046, NULL, 'IPR024970', NULL, 'Maelstrom domain', 'Maelstrom', 3, NULL),
(26047, NULL, 'IPR025521', NULL, 'Neprosin activation peptide', 'Neprosin_propep', 3, NULL),
(26048, NULL, 'IPR031462', NULL, 'Cation channel sperm-associated targeting subunit tau', 'CTSRT', 4, NULL),
(26049, NULL, 'IPR024322', NULL, 'Protein of unknown function DUF2682', 'DUF2682', 4, NULL),
(26050, NULL, 'IPR031347', NULL, 'Protein AmpE', 'AmpE', 4, NULL),
(26051, NULL, 'IPR030677', NULL, 'Bifunctional NAD(P)H-hydrate repair enzyme Nnr', 'Nnr', 4, NULL),
(26052, NULL, 'IPR027005', NULL, 'Glycosyltransferase 39-like', 'GlyclTrfase_39-like', 4, NULL),
(26053, NULL, 'IPR028601', NULL, 'Cytosolic Fe-S cluster assembly factor NUBP1/Nbp35', 'NUBP1/Nbp35', 4, NULL),
(26054, NULL, 'IPR029379', NULL, 'FAM163', 'FAM163', 4, NULL),
(26055, NULL, 'IPR025479', NULL, 'Domain of unknown function DUF4329', 'DUF4329', 3, NULL),
(26056, NULL, 'IPR025475', NULL, 'Protein of unknown function DUF4326)', 'DUF4326', 4, NULL),
(26057, NULL, 'IPR026216', NULL, 'HDA1 complex subunit 3', 'HDA3', 4, NULL),
(26058, NULL, 'IPR025590', NULL, 'Protein of unknown function DUF4348', 'DUF4348', 4, NULL),
(26059, NULL, 'IPR032164', NULL, 'Domain of unknown function DUF5000', 'DUF5000', 3, NULL),
(26060, NULL, 'IPR025443', NULL, 'Protein of unknown function DUF4307', 'DUF4307', 4, NULL),
(26061, NULL, 'IPR029276', NULL, 'Plasminogen-binding protein  PgbA, N-terminal', 'PgbA_N', 3, NULL),
(26062, NULL, 'IPR027235', NULL, 'Prefoldin subunit 2', 'PFD2', 4, NULL),
(26063, NULL, 'IPR027843', NULL, 'Domain of unknown function DUF4440', 'DUF4440', 3, NULL),
(26064, NULL, 'IPR028095', NULL, 'Mso1, N-terminal domain', 'Mso1_N_dom', 3, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(26065, NULL, 'IPR025525', NULL, 'hAT-like transposase, RNase-H fold', 'hAT-like_transposase_RNase-H', 3, NULL),
(26066, NULL, 'IPR025581', NULL, 'Protein of unknown function DUF4354', 'DUF4354', 4, NULL),
(26067, NULL, 'IPR032271', NULL, 'Domain of unknown function DUF4987', 'DUF4987', 3, NULL),
(26068, NULL, 'IPR031342', NULL, 'Meiotically up-regulated gene 163 protein-like', 'Mug163-like', 4, NULL),
(26069, NULL, 'IPR032266', NULL, 'Putative cytidyltransferase-related, C-terminal region', 'HIGH_NTase1_ass', 3, NULL),
(26070, NULL, 'IPR026260', NULL, 'Threonine synthase, bacterial/archaeal', 'Thr_Synthase_bac/arc', 4, NULL),
(26071, NULL, 'IPR025413', NULL, 'YpzG-like protein', 'YpzG-like', 4, NULL),
(26072, NULL, 'IPR031344', NULL, 'Protein of unknown function DUF5104', 'DUF5104', 4, NULL),
(26073, NULL, 'IPR031028', NULL, 'Small lipoprotein, LB_250 family', 'Lepto_4Cys', 4, NULL),
(26074, NULL, 'IPR025409', NULL, 'Protein of unknown function DUF4303', 'DUF4303', 4, NULL),
(26075, NULL, 'IPR029369', NULL, 'Domain of unknown function with conserved HDNR motif', 'HDNR', 3, NULL),
(26076, NULL, 'IPR028300', NULL, 'Holliday junction resolvase-related', 'Holliday_junct_resolvase-rel', 4, NULL),
(26077, NULL, 'IPR025616', NULL, 'YpjP-like protein', 'YpjP', 4, NULL),
(26078, NULL, 'IPR032066', NULL, 'DNA-packaging protein gp3', 'GP3_package', 4, NULL),
(26079, NULL, 'IPR032070', NULL, 'TNF receptor-associated factor, BIRC3 binding domain', 'TRAF_BIRC3-bd', 3, NULL),
(26080, NULL, 'IPR025453', NULL, 'Protein of unknown function DUF4309', 'DUF4309', 4, NULL),
(26081, NULL, 'IPR030602', NULL, 'Ephrin type-A receptor 4, SAM domain', 'EphA4_SAM', 3, NULL),
(26082, NULL, 'IPR025496', NULL, 'Protein of unknown function DUF4387', 'DUF4387', 4, NULL),
(26083, NULL, 'IPR025510', NULL, 'Domain of unknown function DUF4397', 'DUF4397', 3, NULL),
(26084, NULL, 'IPR025381', NULL, 'Domain of unknown function DUF4296', 'DUF4296', 3, NULL),
(26085, NULL, 'IPR025158', NULL, 'Mg chelatase-related protein, C-terminal domain', 'Mg_chelat-rel_C', 3, NULL),
(26086, NULL, 'IPR031457', NULL, 'Renal cancer differentiation gene 1 protein', 'RCDG1', 4, NULL),
(26087, NULL, 'IPR026210', NULL, 'Toxin Pg family', 'Toxin_Pg', 4, NULL),
(26088, NULL, 'IPR032267', NULL, 'Domain of unknown function DUF4832', 'DUF4832', 3, NULL),
(26089, NULL, 'IPR030654', NULL, 'Sugar 1,4-lactone oxidase', 'Sugar_lactone_oxidase', 4, NULL),
(26090, NULL, 'IPR028598', NULL, 'WD repeat BOP1/Erb1', 'BOP1/Erb1', 4, NULL),
(26091, NULL, 'IPR028355', NULL, 'Estrogen receptor beta/gamma', 'ER-beta/gamma', 4, NULL),
(26092, NULL, 'IPR030866', NULL, 'Transcriptional regulatory protein RcsA', 'RcsA', 4, NULL),
(26093, NULL, 'IPR027450', NULL, 'Alpha-ketoglutarate-dependent dioxygenase AlkB-like', 'AlkB-like', 3, NULL),
(26094, NULL, 'IPR032700', NULL, 'Izumo sperm-egg fusion protein 1', 'IZUMO1', 4, NULL),
(26095, NULL, 'IPR025471', NULL, 'Domain of unknown function DUF4322', 'DUF4322', 3, NULL),
(26096, NULL, 'IPR025662', NULL, 'Sigma-54 interaction domain, ATP-binding site 1', 'Sigma_54_int_dom_ATP-bd_1', 1, NULL),
(26097, NULL, 'IPR025153', NULL, 'Ead/Ea22-like protein', 'Ead_Ea22', 4, NULL),
(26098, NULL, 'IPR031698', NULL, 'Cysteine-rich C-terminal protein 1', 'NICE-1', 4, NULL),
(26099, NULL, 'IPR032439', NULL, 'RecQ-like DNA helicase BLM, BDHCT-box associated domain', 'BDHCT_assoc', 3, NULL),
(26100, NULL, 'IPR034137', NULL, 'RecR, TOPRIM domain', 'TOPRIM_RecR', 3, NULL),
(26101, NULL, 'IPR028871', NULL, 'Blue (type 1) copper protein, binding site', 'BlueCu_1_BS', 1, NULL),
(26102, NULL, 'IPR030668', NULL, 'Spermidine/spermine synthase, eukaryotes', 'Spermi_synthase_euk', 4, NULL),
(26103, NULL, 'IPR025424', NULL, 'YrhK domain', 'YrhK_domain', 3, NULL),
(26104, NULL, 'IPR028199', NULL, 'Mucin, catalytic, TM and cytoplasmic tail domain', 'Mucin_dom', 3, NULL),
(26105, NULL, 'IPR032731', NULL, 'Arabinosyltransferase, C-terminal', 'Arabino_trans_C', 3, NULL),
(26106, NULL, 'IPR032622', NULL, 'UCP01524, winged helix-turn-helix domain', 'UCP01524_HTH', 3, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(26107, NULL, 'IPR029356', NULL, 'Family of FAM53', 'FAM53', 4, NULL),
(26108, NULL, 'IPR025418', NULL, 'YrhC-like protein', 'YrhC-like', 4, NULL),
(26109, NULL, 'IPR032364', NULL, 'Gram-positive pilin subunit D1, N-terminal', 'GramPos_pilinD1_N', 3, NULL),
(26110, NULL, 'IPR032618', NULL, 'Protein of unknown function DUF4884', 'DUF4884', 4, NULL),
(26111, NULL, 'IPR027844', NULL, 'Integrator complex subunit 15', 'INTS15', 4, NULL),
(26112, NULL, 'IPR034076', NULL, 'Transcriptional repressor NF-X1, R3H domain', 'R3H_NF-X1', 3, NULL),
(26113, NULL, 'IPR031699', NULL, 'Protein of unknown function DUF4720', 'DUF4720', 4, NULL),
(26114, NULL, 'IPR026213', NULL, 'DNA-directed RNA polymerase II subunit GRINL1', 'GRINL1', 4, NULL),
(26115, NULL, 'IPR032734', NULL, 'DDB1- and CUL4-associated factor 15, WD40 repeat-containing domain', 'DCAF15_WD40', 3, NULL),
(26116, NULL, 'IPR025489', NULL, 'Protein of unknown function (DUF4381', 'DUF4381', 4, NULL),
(26117, NULL, 'IPR028595', NULL, 'Methionine aminopeptidase, archaeal', 'MetAP_archaeal', 4, NULL),
(26118, NULL, 'IPR027353', NULL, 'NET domain', 'NET_dom', 3, NULL),
(26119, NULL, 'IPR032627', NULL, 'Protein of unknown function DUF4876', 'DUF4876', 4, NULL),
(26120, NULL, 'IPR031774', NULL, 'SF3A3 domain', 'SF3A3_dom', 3, NULL),
(26121, NULL, 'IPR025477', NULL, 'Protein of unknown function DUF4327', 'DUF4327', 4, NULL),
(26122, NULL, 'IPR025382', NULL, 'CD-NTase associated protein 4-like, DNA endonuclease domain', 'Cap4-like_endonuclease_dom', 3, NULL),
(26123, NULL, 'IPR031779', NULL, 'Shu complex, component Psy3', 'Psy3', 4, NULL),
(26124, NULL, 'IPR029358', NULL, 'Protein of unknown function DUF4586', 'DUF4586', 4, NULL),
(26125, NULL, 'IPR027783', NULL, 'Bacterial Pleckstrin homology domain-related', 'Bacterial_PH-related', 3, NULL),
(26126, NULL, 'IPR025432', NULL, 'YhfH-like protein', 'YhfH-like', 4, NULL),
(26127, NULL, 'IPR025617', NULL, 'YqzL-like protein', 'YqzL', 4, NULL),
(26128, NULL, 'IPR032621', NULL, 'Protein of unknown function DUF4881', 'DUF4881', 4, NULL),
(26129, NULL, 'IPR025416', NULL, 'YqzM-like protein', 'YqzM', 4, NULL),
(26130, NULL, 'IPR025504', NULL, 'D-glutamate cyclase-like, C-terminal', 'GLUCM_C', 3, NULL),
(26131, NULL, 'IPR032612', NULL, 'Protein of unknown function DUF4890', 'DUF4890', 4, NULL),
(26132, NULL, 'IPR032151', NULL, 'Cilia- and flagella-associated protein 61, N-terminal domain', 'CFAP61_N', 3, NULL),
(26133, NULL, 'IPR025519', NULL, 'Protein of unknown function DUF4407', 'DUF4407', 4, NULL),
(26134, NULL, 'IPR025537', NULL, 'Domain of unknown function DUF4423', 'DUF4423', 3, NULL),
(26135, NULL, 'IPR032276', NULL, 'Protein of unknown function DUF4836', 'DUF4836', 4, NULL),
(26136, NULL, 'IPR031874', NULL, 'Adult cuticle protein 1', 'Cuticle_Acp1', 4, NULL),
(26137, NULL, 'IPR031341', NULL, 'Ribosomal RNA small subunit methyltransferase F, N-terminal', 'Methyltr_RsmF_N', 3, NULL),
(26138, NULL, 'IPR032280', NULL, 'Domain of unknown function DUF4985', 'DUF4985', 3, NULL),
(26139, NULL, 'IPR031424', NULL, 'Protein quiver', 'QVR', 4, NULL),
(26140, NULL, 'IPR025579', NULL, 'Domain of unknown function DUF4357', 'DUF4357', 3, NULL),
(26141, NULL, 'IPR025507', NULL, 'Domain of unknown function DUF4394', 'DUF4394', 3, NULL),
(26142, NULL, 'IPR029377', NULL, 'TMEM220 protein', 'TMEM220', 4, NULL),
(26143, NULL, 'IPR025492', NULL, 'Protein of unknown function DUF4383', 'DUF4383', 4, NULL),
(26144, NULL, 'IPR032616', NULL, 'Domain of unknown function DUF4886', 'DUF4886', 3, NULL),
(26145, NULL, 'IPR028112', NULL, 'DNA polymerase III PolC-type, N-terminal domain I', 'DNA_PolC-type_N_I', 3, NULL),
(26146, NULL, 'IPR029385', NULL, 'Speriolin, N-terminal', 'Speriolin_N', 3, NULL),
(26147, NULL, 'IPR029360', NULL, 'Serine/arginine repetitive matrix protein, C-terminal', 'SRRM_C', 3, NULL),
(26148, NULL, 'IPR032275', NULL, 'Domain of unknown function DUF4986', 'DUF4986', 3, NULL),
(26149, NULL, 'IPR031044', NULL, 'Small Trp-rich protein', 'Small_Trp_rich', 4, NULL),
(26150, NULL, 'IPR031042', NULL, 'Glycosyltransferase domain', 'Glyco_TIGR04440', 3, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(26151, NULL, 'IPR026264', NULL, 'Type IV secretion system protein VirB8/PtlE', 'VirB8/PtlE', 4, NULL),
(26152, NULL, 'IPR025503', NULL, 'Protein of unknown function DUF4391', 'DUF4391', 4, NULL),
(26153, NULL, 'IPR026258', NULL, 'Signal recognition particle subunit SRP68', 'SRP68', 4, NULL),
(26154, NULL, 'IPR032730', NULL, 'Transglycosylase PBP1b, N-terminal transmembrane domain', 'PBP1b_TM', 3, NULL),
(26155, NULL, 'IPR029357', NULL, 'Spermatogenesis-associated protein 7', 'SPATA7', 4, NULL),
(26156, NULL, 'IPR029278', NULL, 'Immunity protein 26', 'Imm26', 4, NULL),
(26157, NULL, 'IPR029493', NULL, 'RecD helicase-like helix-hairpin-helix domain', 'RecD-like_HHH', 3, NULL),
(26158, NULL, 'IPR025468', NULL, 'Putative transposon-transfer assisting protein', 'TTRAP', 4, NULL),
(26159, NULL, 'IPR032623', NULL, 'FecR, N-terminal', 'FecR_N', 3, NULL),
(26160, NULL, 'IPR032727', NULL, 'Flagellar C1a complex subunit C1a-32', 'CLAMP', 4, NULL),
(26161, NULL, 'IPR031052', NULL, 'FHY3/FAR1 family', 'FHY3/FAR1', 4, NULL),
(26162, NULL, 'IPR032735', NULL, 'Protein broad-minded', 'BROMI', 4, NULL),
(26163, NULL, 'IPR030674', NULL, 'Nudix hydrolase, AtNUDT22-type', 'Nudix_hydrolase_AtNUDT22', 4, NULL),
(26164, NULL, 'IPR025491', NULL, 'Domain of unknown function DUF4382', 'DUF4382', 3, NULL),
(26165, NULL, 'IPR025611', NULL, 'YobH-like protein', 'YobH', 4, NULL),
(26166, NULL, 'IPR027431', NULL, 'Protein kinase C, eta', 'PKC_eta', 4, NULL),
(26167, NULL, 'IPR025437', NULL, 'YfhE-like protein', 'YfhE-like', 4, NULL),
(26168, NULL, 'IPR032438', NULL, 'ERCC3/RAD25/XPB helicase, C-terminal domain', 'ERCC3_RAD25_C', 3, NULL),
(26169, NULL, 'IPR025493', NULL, 'Domain of unknown function DUF4384', 'DUF4384', 3, NULL),
(26170, NULL, 'IPR031406', NULL, 'Nuclear receptor-interacting protein 1, repression domain 2', 'NRIP1_RD2', 3, NULL),
(26171, NULL, 'IPR025165', NULL, 'Protein of unknown function DUF4100', 'DUF4100', 4, NULL),
(26172, NULL, 'IPR031030', NULL, 'Small lipoprotein, LA_3946 family', 'Lepto_Lipo_YY_C', 4, NULL),
(26173, NULL, 'IPR031120', NULL, 'WD repeat HIR1', 'HIR1', 4, NULL),
(26174, NULL, 'IPR032737', NULL, 'Plasminogen-binding protein PgbA, C-terminal', 'PGBA_C', 3, NULL),
(26175, NULL, 'IPR032432', NULL, 'Radical SAM, C-terminal extension', 'Radical_SAM_C', 3, NULL),
(26176, NULL, 'IPR030393', NULL, 'EngB-type guanine nucleotide-binding (G) domain', 'G_ENGB_dom', 3, NULL),
(26177, NULL, 'IPR031781', NULL, 'SF3A2 domain', 'SF3A2_dom', 3, NULL),
(26178, NULL, 'IPR032170', NULL, 'Domain of unknown function DUF5006', 'DUF5006', 3, NULL),
(26179, NULL, 'IPR025524', NULL, 'Domain of unknown function DUF4412', 'DUF4412', 3, NULL),
(26180, NULL, 'IPR026223', NULL, 'Hydroxyacyl-thioester dehydratase type 2', 'Htd2', 4, NULL),
(26181, NULL, 'IPR025440', NULL, 'Protein of unknown function DUF4306', 'DUF4306', 4, NULL),
(26182, NULL, 'IPR028481', NULL, 'Protein S100-B', 'S100-B', 4, NULL),
(26183, NULL, 'IPR025578', NULL, 'Protein of unknown function DUF4359', 'DUF4359', 4, NULL),
(26184, NULL, 'IPR031695', NULL, 'Protein of unknown function DUF4718', 'DUF4718', 4, NULL),
(26185, NULL, 'IPR026218', NULL, 'Heme transporter HRG', 'HRG', 4, NULL),
(26186, NULL, 'IPR032076', NULL, 'Tetratricopeptide repeat protein 5, OB fold domain', 'TTC5_OB', 3, NULL),
(26187, NULL, 'IPR028604', NULL, 'Protein argonaute-4', 'AGO4', 4, NULL),
(26188, NULL, 'IPR025536', NULL, 'Domain of unknown function DUF4422', 'DUF4422', 3, NULL),
(26189, NULL, 'IPR032272', NULL, 'Protein of unknown function DUF4834', 'DUF4834', 4, NULL),
(26190, NULL, 'IPR034038', NULL, 'Meprin peptidase domain', 'ZnMP_meprin', 3, NULL),
(26191, NULL, 'IPR032355', NULL, 'SATB, CUT1-like DNA-binding domain', 'CUTL', 3, NULL),
(26192, NULL, 'IPR032729', NULL, 'tRNA-guanine(15) transglycosylase, C1 domain', 'TGT_C1', 3, NULL),
(26193, NULL, 'IPR027846', NULL, 'Cytochrome b-245 chaperone 1', 'Cybc1', 4, NULL),
(26194, NULL, 'IPR031626', NULL, 'Trafficking protein particle complex subunit 14', 'TRAPPC14', 4, NULL),
(26195, NULL, 'IPR025494', NULL, 'Protein of unknown function DUF4385', 'DUF4385', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(26196, NULL, 'IPR031615', NULL, 'MYND-like zinc finger', 'Zfn-C6H2', 3, NULL),
(26197, NULL, 'IPR031625', NULL, 'Sodium channel modifier 1, acidic C-terminal domain', 'SCNM1_acidic', 3, NULL),
(26198, NULL, 'IPR032278', NULL, 'Protein-glutamine deamidase Cif', 'Cif', 4, NULL),
(26199, NULL, 'IPR028490', NULL, 'Protein S100-Z', 'S100Z', 4, NULL),
(26200, NULL, 'IPR025417', NULL, 'YrzO-like protein', 'YrzO-like', 4, NULL),
(26201, NULL, 'IPR025456', NULL, 'Protein of unknown function DUF4310', 'DUF4310', 4, NULL),
(26202, NULL, 'IPR024943', NULL, 'Enhancer of polycomb protein', 'Enhancer_polycomb', 4, NULL),
(26203, NULL, 'IPR029359', NULL, 'FAM181', 'FAM181', 4, NULL),
(26204, NULL, 'IPR025426', NULL, 'Protein of unknown function DUF4305', 'DUF4305', 4, NULL),
(26205, NULL, 'IPR025481', NULL, 'Cell morphogenesis protein C-terminal', 'Cell_Morphogen_C', 3, NULL),
(26206, NULL, 'IPR031671', NULL, 'Protein of unknown function DUF4713', 'DUF4713', 4, NULL),
(26207, NULL, 'IPR031668', NULL, 'Protein of unknown function DUF4711', 'DUF4711', 4, NULL),
(26208, NULL, 'IPR025160', NULL, 'AATF leucine zipper-containing domain', 'AATF', 3, NULL),
(26209, NULL, 'IPR029756', NULL, 'MTH1187/YkoF-like', 'MTH1187/YkoF-like', 5, NULL),
(26210, NULL, 'IPR024544', NULL, 'Domain of unknown function DUF3858', 'DUF3858', 3, NULL),
(26211, NULL, 'IPR031624', NULL, 'Coiled-coil domain-containing protein 168, N-terminal', 'CCDC168_N', 3, NULL),
(26212, NULL, 'IPR029376', NULL, 'Domain of unknown function DUF4549', 'DUF4549', 3, NULL),
(26213, NULL, 'IPR028087', NULL, 'Putative Flp pilus-assembly TadG-like, N-terminal', 'Tad_N', 3, NULL),
(26214, NULL, 'IPR025484', NULL, 'Domain of unknown function DUF4376', 'DUF4376', 3, NULL),
(26215, NULL, 'IPR032346', NULL, 'Transcriptional repressor p66, coiled-coil MBD2-interaction domain', 'P66_CC', 3, NULL),
(26216, NULL, 'IPR029373', NULL, 'FAM216', 'FAM216', 4, NULL),
(26217, NULL, 'IPR028092', NULL, 'Retinal degeneration protein 3', 'RD3', 4, NULL),
(26218, NULL, 'IPR030800', NULL, 'Lipid A Kdo2 1-phosphate O-methyltransferase', 'LmtA_Leptospira', 4, NULL),
(26219, NULL, 'IPR025597', NULL, 'Protein of unknown function DUF4345', 'DUF4345', 4, NULL),
(26220, NULL, 'IPR032168', NULL, 'Protein of unknown function DUF5004', 'DUF5004', 4, NULL),
(26221, NULL, 'IPR027845', NULL, 'Protein of unknown function DUF4548', 'DUF4548', 4, NULL),
(26222, NULL, 'IPR025435', NULL, 'YfhD-like protein', 'YfhD-like', 4, NULL),
(26223, NULL, 'IPR032077', NULL, 'Adhesin JlpA, Campylobacter', 'JLPA', 4, NULL),
(26224, NULL, 'IPR031026', NULL, '3-deoxy-D-manno-oct-2-ulosonate III transferase WaaZ', 'WaaZ_KDO_III', 4, NULL),
(26225, NULL, 'IPR031053', NULL, 'Chromodomain-helicase-DNA-binding protein 1-like', 'ALC1', 4, NULL),
(26226, NULL, 'IPR032165', NULL, 'Ig-like domain', 'DUF5001', 3, NULL),
(26227, NULL, 'IPR029381', NULL, 'Cancer-associated gene protein 1', 'CAGE1', 4, NULL),
(26228, NULL, 'IPR026584', NULL, 'Rad9', 'Rad9', 4, NULL),
(26229, NULL, 'IPR029279', NULL, 'FLYWCH-type zinc finger-containing protein, N-terminal', 'FLYWCH_N', 3, NULL),
(26230, NULL, 'IPR025531', NULL, 'Protein of unknown function DUF4418', 'DUF4418', 4, NULL),
(26231, NULL, 'IPR024543', NULL, 'Autophagy protein Atg19/Atg34, C-terminal', 'Atg19/Atg34_C', 3, NULL),
(26232, NULL, 'IPR032274', NULL, 'Protein of unknown function DUF4835', 'DUF4835', 4, NULL),
(26233, NULL, 'IPR032352', NULL, 'Arf GTPase-activating protein GIT1/2, coiled-coil domain', 'GIT1/2_CC', 3, NULL),
(26234, NULL, 'IPR031041', NULL, 'Surface carbohydrate biosynthesis protein, Leptospira', 'Lept_O_ant_chp1', 4, NULL),
(26235, NULL, 'IPR032150', NULL, 'Protein of unknown function DUF4820', 'DUF4820', 4, NULL),
(26236, NULL, 'IPR032624', NULL, 'Protein of unknown function DUF4879', 'DUF4879', 4, NULL),
(26237, NULL, 'IPR025439', NULL, 'Spore coat protein CotO', 'Spore_coat_CotO', 4, NULL),
(26238, NULL, 'IPR027238', NULL, 'RuvB-like', 'RuvB-like', 4, NULL),
(26239, NULL, 'IPR031420', NULL, 'UPF0669 protein C6orf120', 'UPF0669', 4, NULL),
(26240, NULL, 'IPR032069', NULL, 'Ubiquitin carboxyl-terminal hydrolase 37, pleckstrin homology-like domain', 'USP37-like_PH', 3, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(26241, NULL, 'IPR029362', NULL, 'Fusion protein IQCJ-SCHIP1, N-terminal', 'IQCJ-SCHIP1_N', 3, NULL),
(26242, NULL, 'IPR032615', NULL, 'Protein of unknown function DUF4887', 'DUF4887', 4, NULL),
(26243, NULL, 'IPR029374', NULL, 'TMEM156 protein', 'TMEM156', 4, NULL),
(26244, NULL, 'IPR025370', NULL, 'Transcriptional regulator SgrR, N-terminal HTH domain', 'SgrR_HTH_N', 3, NULL),
(26245, NULL, 'IPR032067', NULL, 'FOXO protein, transactivation domain', 'FOXO-TAD', 3, NULL),
(26246, NULL, 'IPR025428', NULL, 'Sporulation protein YhaL', 'Spore_YhaL', 4, NULL),
(26247, NULL, 'IPR032283', NULL, 'Domain of unknown function DUF4984', 'DUF4984', 3, NULL),
(26248, NULL, 'IPR025467', NULL, 'Protein of unknown function DUF4318', 'DUF4318', 4, NULL),
(26249, NULL, 'IPR031032', NULL, 'Putative immunity protein/bacteriocin', 'Gpos_C8-like', 4, NULL),
(26250, NULL, 'IPR032728', NULL, 'Bardet-Biedl syndrome 1, N-terminal', 'BBS1_N', 3, NULL),
(26251, NULL, 'IPR035926', NULL, 'NusB-like superfamily', 'NusB-like_sf', 5, NULL),
(26252, NULL, 'IPR032129', NULL, 'Protein of unknown function DUF5056', 'DUF5056', 4, NULL),
(26253, NULL, 'IPR025661', NULL, 'Cysteine peptidase, asparagine active site', 'Pept_asp_AS', 0, NULL),
(26254, NULL, 'IPR031458', NULL, 'Protein of unknown function DUF4677', 'DUF4677', 4, NULL),
(26255, NULL, 'IPR025147', NULL, 'DNA packaging protein FI', 'Packaging_FI', 4, NULL),
(26256, NULL, 'IPR031620', NULL, 'DDB1- and CUL4-associated factor 17', 'DCAF17', 4, NULL),
(26257, NULL, 'IPR029382', NULL, 'Lysosomal transcription factor, NCU-G1', 'NCU-G1', 4, NULL),
(26258, NULL, 'IPR030678', NULL, 'Peptide/nickel binding protein, MppA-type', 'Peptide/Ni-bd', 4, NULL),
(26259, NULL, 'IPR026331', NULL, 'Integrating conjugative element protein PFL_4710', 'PFL_4710', 4, NULL),
(26260, NULL, 'IPR025470', NULL, 'Protein of unknown function DUF4321', 'DUF4321', 4, NULL),
(26261, NULL, 'IPR031043', NULL, 'Putative histamine N-monooxygenase', 'Histamin_N_OH', 4, NULL),
(26262, NULL, 'IPR032699', NULL, 'Izumo protein, immunoglobulin domain', 'Izumo-Ig', 3, NULL),
(26263, NULL, 'IPR032268', NULL, 'Capsid polyprotein VP90, C-terminal', 'VP90_C', 3, NULL),
(26264, NULL, 'IPR025389', NULL, 'Protein of unknown function DUF4300', 'DUF4300', 4, NULL),
(26265, NULL, 'IPR032613', NULL, 'Protein of unknown function DUF4889', 'DUF4889', 4, NULL),
(26266, NULL, 'IPR031418', NULL, 'RBPJ-interacting and tubulin-associated protein 1', 'RITA1', 4, NULL),
(26267, NULL, 'IPR026215', NULL, 'HAUS complex subunit 5, metazoa', 'HAUS5_metazoa', 4, NULL),
(26268, NULL, 'IPR032145', NULL, 'Protein of unknown function DUF4818', 'DUF4818', 4, NULL),
(26269, NULL, 'IPR029364', NULL, 'ALK and LTK ligand 1/2', 'ALKL1/2', 4, NULL),
(26270, NULL, 'IPR025155', NULL, 'WxxW domain', 'WxxW_domain', 3, NULL),
(26271, NULL, 'IPR031036', NULL, 'Prenylated cyclic peptide, anacyclamide/piricyclamide family', 'Pren_cyc_PirE', 4, NULL),
(26272, NULL, 'IPR025422', NULL, 'Transcription factor TGA like domain', 'TGA_domain', 3, NULL),
(26273, NULL, 'IPR029375', NULL, 'Cilia- and flagella-associated protein 141', 'CFAP141', 4, NULL),
(26274, NULL, 'IPR032620', NULL, 'Protein of unknown function DUF4882', 'DUF4882', 4, NULL),
(26275, NULL, 'IPR029363', NULL, 'Protein of unknown function DUF4575', 'DUF4575', 4, NULL),
(26276, NULL, 'IPR029386', NULL, 'TMEM169 protein', 'TMEM169', 4, NULL),
(26277, NULL, 'IPR031434', NULL, 'MgtA leader peptide', 'MGTL', 4, NULL),
(26278, NULL, 'IPR027847', NULL, 'Protein of unknown function DUF4545', 'DUF4545', 4, NULL),
(26279, NULL, 'IPR025462', NULL, 'Protein of unknown function DUF4313', 'DUF4313', 4, NULL),
(26280, NULL, 'IPR031348', NULL, 'Fungal N-terminal domain of STAND protein', 'Helo-like_N', 3, NULL),
(26281, NULL, 'IPR027275', NULL, 'PRC-barrel domain', 'PRC-brl_dom', 3, NULL),
(26282, NULL, 'IPR025522', NULL, 'Protein of unknown function DUF4410', 'DUF4410', 4, NULL),
(26283, NULL, 'IPR025511', NULL, 'Domain of unknown function DUF4398', 'DUF4398', 3, NULL),
(26284, NULL, 'IPR025154', NULL, 'Putative metallopeptidase domain', 'Put_metallopeptidase_dom', 3, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(26285, NULL, 'IPR030801', NULL, 'Glutamate 2,3-aminomutase', 'Glu_2_3_NH3_mut', 4, NULL),
(26286, NULL, 'IPR031425', NULL, 'NPR1/NH1-interacting protein', 'NPR1/NH1-interacting', 4, NULL),
(26287, NULL, 'IPR025162', NULL, 'Recombination activating protein 2, PHD domain', 'RAG2_PHD', 3, NULL),
(26288, NULL, 'IPR029275', NULL, 'Trimeric autotransporter adhesin, putative GIN domain', 'HiaBD2_put_GIN_domain', 3, NULL),
(26289, NULL, 'IPR031038', NULL, 'Chorismatase, FkbO/Hyg5 family', 'Chori_FkbO_Hyg5', 4, NULL),
(26290, NULL, 'IPR025412', NULL, 'Protein of unknown function DUF4304', 'DUF4304', 4, NULL),
(26291, NULL, 'IPR029274', NULL, 'Protein of unknown function DUF4615', 'DUF4615', 4, NULL),
(26292, NULL, 'IPR032625', NULL, 'Peptidase M64, N-terminal', 'M64_N', 3, NULL),
(26293, NULL, 'IPR031928', NULL, 'Anti-sigma-D factor RsdA, sigma factor binding region', 'RsdA_SigD-bd', 3, NULL),
(26294, NULL, 'IPR030930', NULL, 'Adhesin of bacterial autotransporter system', 'AIDA', 7, NULL),
(26295, NULL, 'IPR028597', NULL, 'Leucine zipper putative tumour suppressor 2', 'LZTS2', 4, NULL),
(26296, NULL, 'IPR025587', NULL, 'Domain of unknown function DUF4351', 'DUF4351', 3, NULL),
(26297, NULL, 'IPR032157', NULL, 'Proteasome assembly chaperone 4', 'PAC4', 4, NULL),
(26298, NULL, 'IPR032310', NULL, 'Putative nuclear localisation signal', 'NINJA_B', 3, NULL),
(26299, NULL, 'IPR024545', NULL, 'Mto2p-binding domain', 'Mto2p-binding', 3, NULL),
(26300, NULL, 'IPR034024', NULL, 'Tumor necrosis factor receptor 10, N-terminal', 'TNFRSF10_N', 3, NULL),
(26301, NULL, 'IPR027652', NULL, 'Pre-mRNA-processing-splicing factor 8', 'PRP8', 4, NULL),
(26302, NULL, 'IPR031697', NULL, 'Transmembrane and coiled-coil domain-containing protein 2', 'TMCCDC2', 4, NULL),
(26303, NULL, 'IPR032617', NULL, 'Protein of unknown function DUF4885', 'DUF4885', 4, NULL),
(26304, NULL, 'IPR027244', NULL, 'Vacuolar membrane-associated protein Iml1', 'IML1', 4, NULL),
(26305, NULL, 'IPR028354', NULL, 'Glycerol-3-phosphate acyltransferase, PlsB', 'GPAT_PlsB', 4, NULL),
(26306, NULL, 'IPR031040', NULL, 'Conserved hypothetical protein CHP04442', 'CHP04442', 4, NULL),
(26307, NULL, 'IPR031694', NULL, 'Transmembrane protein 239', 'TMEM239', 4, NULL),
(26308, NULL, 'IPR032270', NULL, 'AMPK, C-terminal adenylate sensor domain', 'AMPK_C', 3, NULL),
(26309, NULL, 'IPR032344', NULL, 'Protein of unknown function DUF4862', 'DUF4862', 4, NULL),
(26310, NULL, 'IPR025517', NULL, 'Domain of unknown function DUF4405', 'DUF4405', 3, NULL),
(26311, NULL, 'IPR030484', NULL, 'Serine/threonine-protein kinase Rio2', 'Rio2', 3, NULL),
(26312, NULL, 'IPR025166', NULL, 'Integrase, DNA-binding domain', 'Integrase_DNA_bind_dom', 3, NULL),
(26313, NULL, 'IPR026267', NULL, 'Inner membrane protein YgjV', 'YgjV', 4, NULL),
(26314, NULL, 'IPR029361', NULL, 'Testis-expressed sequence 37 protein', 'TEX37', 4, NULL),
(26315, NULL, 'IPR032356', NULL, 'Interleukin-17 receptor, fibronectin-III-like domain 1', 'IL17R_fnIII_D1', 3, NULL),
(26316, NULL, 'IPR030488', NULL, 'DNA (cytosine-5)-methyltransferase 3B, ADD domain', 'DNMT3B_ADD', 3, NULL),
(26317, NULL, 'IPR025465', NULL, 'Domain of unknown function DUF4316', 'DUF4316', 3, NULL),
(26318, NULL, 'IPR032316', NULL, 'Protein of unknown function DUF4847', 'DUF4847', 4, NULL),
(26319, NULL, 'IPR029280', NULL, 'Leukemia NUP98 fusion partner 1', 'LNP1', 4, NULL),
(26320, NULL, 'IPR031345', NULL, 'Protein of unknown function DUF5103', 'DUF5103', 4, NULL),
(26321, NULL, 'IPR027281', NULL, 'Saccharopine dehydrogenase [NAD(+), L-lysine-forming]', 'Lys1', 4, NULL),
(26322, NULL, 'IPR025518', NULL, 'Protein of unknown function DUF4406', 'DUF4406', 4, NULL),
(26323, NULL, 'IPR027789', NULL, 'Syndecan/Neurexin domain', 'Syndecan/Neurexin_dom', 3, NULL),
(26324, NULL, 'IPR025584', NULL, 'Carbohydrate-binding domain-containing protein Cthe_2159', 'Cthe_2159', 4, NULL),
(26325, NULL, 'IPR031672', NULL, 'FAM27D/FAM27E', 'FAM27D/FAM27E', 4, NULL),
(26326, NULL, 'IPR031667', NULL, 'Protein of unknown function DUF4710', 'DUF4710', 4, NULL),
(26327, NULL, 'IPR025159', NULL, 'Transcriptional regulator, AbiEi antitoxin', 'AbiEi_4', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(26328, NULL, 'IPR025469', NULL, 'Protein of unknown function DUF4320', 'DUF4320', 4, NULL),
(26329, NULL, 'IPR025466', NULL, 'Protein of unknown function DUF4317', 'DUF4317', 4, NULL),
(26330, NULL, 'IPR031320', NULL, 'GAGE', 'GAGE', 3, NULL),
(26331, NULL, 'IPR025431', NULL, 'YhdB-like protein', 'YhdB-like', 4, NULL),
(26332, NULL, 'IPR032373', NULL, 'Centromere kinetochore component CENP-T, N-terminal domain', 'CENP-T_N', 3, NULL),
(26333, NULL, 'IPR025580', NULL, 'Protein of unknown function DUF4355', 'DUF4355', 4, NULL),
(26334, NULL, 'IPR028356', NULL, 'UDP-glucose 6-dehydrogenase, eukaryotic type', 'UDPglc_DH_euk', 4, NULL),
(26335, NULL, 'IPR026227', NULL, 'Centriolar and ciliogenesis-associated protein HYLS1', 'HYLS1', 4, NULL),
(26336, NULL, 'IPR031346', NULL, 'Uncharacterised protein DUF2154, N-terminal', 'DUF2154_N', 3, NULL),
(26337, NULL, 'IPR028789', NULL, 'Baculoviral IAP repeat-containing protein 1', 'Naip', 4, NULL),
(26338, NULL, 'IPR032381', NULL, 'Intracellular hyaluronan-binding protein 4, N-terminal domain', 'IHABP4_N', 3, NULL),
(26339, NULL, 'IPR025156', NULL, 'Ribonuclease M5, C-terminal domain', 'RNase_M5_C', 3, NULL),
(26340, NULL, 'IPR032724', NULL, 'Double-stranded DNA deaminase toxin A', 'DddA-like', 4, NULL),
(26341, NULL, 'IPR027839', NULL, 'Protein of unknown function DUF4432', 'DUF4432', 4, NULL),
(26342, NULL, 'IPR032075', NULL, 'Phosphoinositide phospholipase C, Ca2+-dependent', 'PI-PLC-C1', 4, NULL),
(26343, NULL, 'IPR032308', NULL, 'Tify domain binding domain', 'TDBD', 3, NULL),
(26344, NULL, 'IPR031772', NULL, 'Distal tube protein, N-terminal', 'Caud_tail_N', 3, NULL),
(26345, NULL, 'IPR028358', NULL, 'GDP-mannose 6-dehydrogenase', 'GDPman_DH', 4, NULL),
(26346, NULL, 'IPR025705', NULL, 'Beta-hexosaminidase', 'Beta_hexosaminidase_sua/sub', 4, NULL),
(26347, NULL, 'IPR031622', NULL, 'Sodium channel modifier 1, zinc-finger', 'Znf-SCNM1', 3, NULL),
(26348, NULL, 'IPR025448', NULL, 'YmzC-like protein', 'YmzC-like', 4, NULL),
(26349, NULL, 'IPR031549', NULL, 'Abnormal spindle-like microcephaly-associated protein, ASH domain', 'ASH', 3, NULL),
(26350, NULL, 'IPR031985', NULL, 'Protein of unknown function DUF4787', 'DUF4787', 4, NULL),
(26351, NULL, 'IPR032339', NULL, 'Domain of unknown function DUF4859', 'DUF4859', 3, NULL),
(26352, NULL, 'IPR032167', NULL, 'Protein of unknown function DUF5003', 'DUF5003', 4, NULL),
(26353, NULL, 'IPR025488', NULL, 'Protein of unknown function DUF4380', 'DUF4380', 4, NULL),
(26354, NULL, 'IPR031029', NULL, 'Cys-rich protein, LA_1312 family', 'Lepto_8Cys', 4, NULL),
(26355, NULL, 'IPR031039', NULL, 'Coenzyme gamma-F420-2:alpha-L-glutamate ligase', 'F420_CofF', 4, NULL),
(26356, NULL, 'IPR029266', NULL, 'FAM217 family', 'FAM217', 4, NULL),
(26357, NULL, 'IPR032379', NULL, 'Domain of unknown function DUF4874', 'DUF4874', 3, NULL),
(26358, NULL, 'IPR032065', NULL, 'E3 ubiquitin-protein ligase RNF31, UBA-like domain', 'RNF31-UBA', 3, NULL),
(26359, NULL, 'IPR025157', NULL, 'Hemagglutinin repeat', 'Hemagglutinin_rpt', 7, NULL),
(26360, NULL, 'IPR025495', NULL, 'Protein of unknown function DUF4386', 'DUF4386', 4, NULL),
(26361, NULL, 'IPR026231', NULL, 'Protein IBD2', 'IBD2', 4, NULL),
(26362, NULL, 'IPR032078', NULL, 'Multiple PDZ domain protein', 'MPDZ', 4, NULL),
(26363, NULL, 'IPR024974', NULL, 'Sde2, N-terminal ubiquitin domain', 'Sde2_N', 3, NULL),
(26364, NULL, 'IPR032619', NULL, 'Protein of unknown function DUF4883', 'DUF4883', 4, NULL),
(26365, NULL, 'IPR032376', NULL, 'Dedicator of cytokinesis, N-terminal domain', 'DOCK_N', 3, NULL),
(26366, NULL, 'IPR025513', NULL, 'Domain of unknown function DUF4401', 'DUF4401', 3, NULL),
(26367, NULL, 'IPR032342', NULL, 'Protein of unknown function DUF4861', 'DUF4861', 4, NULL),
(26368, NULL, 'IPR025509', NULL, 'Domain of unknown function DUF4396', 'DUF4396', 3, NULL),
(26369, NULL, 'IPR028565', NULL, 'Mu homology domain', 'MHD', 3, NULL),
(26370, NULL, 'IPR025514', NULL, 'Protein of unknown function DUF4402', 'DUF4402', 4, NULL),
(26371, NULL, 'IPR032315', NULL, 'Protein of unknown function DUF4846', 'DUF4846', 4, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(26372, NULL, 'IPR031033', NULL, 'Halocin C8-like bacteriocin domain', 'Halocin_C8_dom', 3, NULL),
(26373, NULL, 'IPR028357', NULL, 'UDP-glucose 6-dehydrogenase, bacterial type', 'UDPglc_DH_bac', 4, NULL),
(26374, NULL, 'IPR025618', NULL, 'YtpI-like protein', 'YtpI', 4, NULL),
(26375, NULL, 'IPR026262', NULL, 'Antitoxin DinJ', 'DinJ', 4, NULL),
(26376, NULL, 'IPR028353', NULL, 'Dihydroxyacetone phosphate acyltransferase', 'DHAPAT', 4, NULL),
(26377, NULL, 'IPR028603', NULL, 'Protein argonaute-3', 'AGO3', 4, NULL),
(26378, NULL, 'IPR032068', NULL, 'FOXO protein, KIX-binding domain', 'FOXO_KIX-bd', 3, NULL),
(26379, NULL, 'IPR028340', NULL, 'E3 ubiquitin-protein ligase Mdm2', 'Mdm2', 4, NULL),
(26380, NULL, 'IPR029389', NULL, 'Izumo sperm-egg fusion protein', 'IZUMO', 4, NULL),
(26381, NULL, 'IPR025533', NULL, 'Protein of unknown function DUF4419', 'DUF4419', 4, NULL),
(26382, NULL, 'IPR024973', NULL, 'ESPR domain', 'ESPR', 3, NULL),
(26383, NULL, 'IPR031876', NULL, 'Protein of unknown function DUF4760', 'DUF4760', 4, NULL),
(26384, NULL, 'IPR025500', NULL, 'Protein of unknown function DUF4390', 'DUF4390', 4, NULL),
(26385, NULL, 'IPR025527', NULL, 'HUWE1/Rev1, ubiquitin binding region', 'HUWE1/Rev1_UBM', 7, NULL),
(26386, NULL, 'IPR032318', NULL, 'Protein of unknown function DUF4848', 'DUF4848', 4, NULL),
(26387, NULL, 'IPR025619', NULL, 'YlzJ-like protein', 'YlzJ', 4, NULL),
(26388, NULL, 'IPR025446', NULL, 'Antirepressor AbbA', 'Antirep_AbbA', 4, NULL),
(26389, NULL, 'IPR031035', NULL, 'Cyanobactin cluster PatC/TenC/TruC protein', 'PatC_TenC_TruC', 3, NULL),
(26390, NULL, 'IPR031031', NULL, 'Lantipeptide, SCO0268 family', 'Lanti_SCO0268', 4, NULL),
(26391, NULL, 'IPR025414', NULL, 'YpzI-like protein', 'YpzI-like', 4, NULL),
(26392, NULL, 'IPR025387', NULL, 'Protein of unknown function DUF4299', 'DUF4299', 4, NULL),
(26393, NULL, 'IPR032345', NULL, 'Protein of unknown function DUF4863', 'DUF4863', 4, NULL),
(26394, NULL, 'IPR027842', NULL, 'Domain of unknown function DUF4449', 'DUF4449', 3, NULL),
(26395, NULL, 'IPR028602', NULL, 'Protein argonaute-2', 'AGO2', 4, NULL),
(26396, NULL, 'IPR026093', NULL, 'Protein MGARP', 'MGARP', 4, NULL),
(26397, NULL, 'IPR031930', NULL, 'Two-component histidine kinase, sensor domain', 'HK_sensor', 3, NULL),
(26398, NULL, 'IPR031542', NULL, 'Cation channel complex component UNC80, N-terminal', 'UNC80_N', 3, NULL),
(26399, NULL, 'IPR031429', NULL, 'Phenol-soluble modulin alpha peptide', 'PSM_alpha', 4, NULL),
(26400, NULL, 'IPR024880', NULL, 'COPII coat assembly protein, Sec16', 'Sec16', 4, NULL),
(26401, NULL, 'IPR025620', NULL, 'YlaH-like protein', 'YlaH', 4, NULL),
(26402, NULL, 'IPR031878', NULL, 'Commissureless', 'Commissureless', 4, NULL),
(26403, NULL, 'IPR031932', NULL, 'Arterivirus nonstructural protein 7 alpha', 'Arteri_nsp7a', 4, NULL),
(26404, NULL, 'IPR026019', NULL, 'Ribulose-phosphate 3-epimerase', 'Ribul_P_3_epim', 4, NULL),
(26405, NULL, 'IPR030672', NULL, 'Adenylate cyclase', 'Adcy', 4, NULL),
(26406, NULL, 'IPR029282', NULL, 'Equatorin', 'Eqtn/Afaf', 4, NULL),
(26407, NULL, 'IPR032288', NULL, 'Calcineurin-like phosphoesterase, C-terminal', 'Metallophos_C', 3, NULL),
(26408, NULL, 'IPR028486', NULL, 'Protein S100-A1', 'S100-A1', 4, NULL),
(26409, NULL, 'IPR025660', NULL, 'Cysteine peptidase, histidine active site', 'Pept_his_AS', 0, NULL),
(26410, NULL, 'IPR025512', NULL, 'Domain of unknown function DUF4399', 'DUF4399', 3, NULL),
(26411, NULL, 'IPR032338', NULL, 'Protein of unknown function DUF4858', 'DUF4858', 4, NULL),
(26412, NULL, 'IPR025515', NULL, 'Protein of unknown function DUF4403', 'DUF4403', 4, NULL),
(26413, NULL, 'IPR026235', NULL, 'Inheritance of peroxisomes protein 2', 'INP2', 4, NULL),
(26414, NULL, 'IPR032269', NULL, 'Domain of unknown function DUF4833', 'DUF4833', 3, NULL),
(26415, NULL, 'IPR025621', NULL, 'YoqO-like protein', 'YoqO', 4, NULL),
(26416, NULL, 'IPR030927', NULL, 'Type II secretion system protein GspM, XcpZ', 'T2SS_GspM_XcpZ', 4, NULL),
(26417, NULL, 'IPR029368', NULL, 'Small integral membrane protein 19', 'SMIM19', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(26418, NULL, 'IPR029354', NULL, 'Cylicin, N-terminal', 'Cylicin_N', 3, NULL),
(26419, NULL, 'IPR032143', NULL, 'BLOC-1-related complex subunit 7', 'BORCS7', 4, NULL),
(26420, NULL, 'IPR032626', NULL, 'GxGYxYP putative glycoside hydrolase, N-terminal', 'GxGYxYP_N', 3, NULL),
(26421, NULL, 'IPR025434', NULL, 'YesK-like protein', 'YesK-like', 4, NULL),
(26422, NULL, 'IPR025480', NULL, 'Protein of unknown function DUF4330', 'DUF4330', 4, NULL),
(26423, NULL, 'IPR025538', NULL, 'Domain of unknown function DUF4424', 'DUF4424', 3, NULL),
(26424, NULL, 'IPR025592', NULL, 'Domain of unknown function DUF4347', 'DUF4347', 3, NULL),
(26425, NULL, 'IPR035921', NULL, 'F/V-ATP synthase subunit C superfamily', 'F/V-ATP_Csub_sf', 5, NULL),
(26426, NULL, 'IPR032277', NULL, '40S ribosomal protein S4, C-terminal domain', '40S_S4_C', 3, NULL),
(26427, NULL, 'IPR032348', NULL, 'E3 ubiquitin-protein ligase HECW1/2, N-terminal', 'HECW_N', 3, NULL),
(26428, NULL, 'IPR025721', NULL, 'Exosome complex component, N-terminal domain', 'Exosome_cplx_N_dom', 3, NULL),
(26429, NULL, 'IPR028386', NULL, 'Centromere protein C/Mif2/cnp3', 'CENP-C/Mif2/cnp3', 4, NULL),
(26430, NULL, 'IPR032525', NULL, 'Peptidase family U32, C-terminal', 'Peptidase_U32_C', 3, NULL),
(26431, NULL, 'IPR032736', NULL, 'Protein hinderin', 'Hinderin', 4, NULL),
(26432, NULL, 'IPR029277', NULL, 'Single domain Von Willebrand factor type C domain', 'SVWC_dom', 3, NULL),
(26433, NULL, 'IPR027449', NULL, '5-keto-4-deoxyuronate isomerase, N-terminal', 'KduI_N', 5, NULL),
(26434, NULL, 'IPR027838', NULL, 'Domain of unknown function DUF4585', 'DUF4585', 3, NULL),
(26435, NULL, 'IPR029366', NULL, 'TMEM206 protein', 'TMEM206', 4, NULL),
(26436, NULL, 'IPR025612', NULL, 'YqjK-like protein', 'YqjK', 4, NULL),
(26437, NULL, 'IPR028090', NULL, 'JAB domain, prokaryotic', 'JAB_dom_prok', 3, NULL),
(26438, NULL, 'IPR032265', NULL, 'Protein of unknown function DUF4831', 'DUF4831', 4, NULL),
(26439, NULL, 'IPR031332', NULL, 'Coproheme decarboxylase', 'CHDC', 4, NULL),
(26440, NULL, 'IPR032726', NULL, 'ThiS-like ubiquitin domain', 'ThiS-like_dom', 3, NULL),
(26441, NULL, 'IPR032273', NULL, 'Fragilysin, N-terminal', 'Fragilysin_N', 3, NULL),
(26442, NULL, 'IPR025506', NULL, 'Abortive infection alpha', 'Abi_alpha', 4, NULL),
(26443, NULL, 'IPR031423', NULL, 'Phosphatase SCO2771', 'Phosphatase_SCO2771', 4, NULL),
(26444, NULL, 'IPR024733', NULL, 'Alpha-N-acetylglucosaminidase, tim-barrel domain', 'NAGLU_tim-barrel', 3, NULL),
(26445, NULL, 'IPR031408', NULL, 'Nuclear receptor-interacting protein 1, repression domain 4', 'NRIP1_RD4', 3, NULL),
(26446, NULL, 'IPR031670', NULL, 'Protein of unknown function DUF4712', 'DUF4712', 4, NULL),
(26447, NULL, 'IPR032436', NULL, 'Nucleolar pre-ribosomal-associated protein 1, C-terminal domain', 'NopRA1_C', 3, NULL),
(26448, NULL, 'IPR032437', NULL, 'RecQ-like DNA helicase BLM, N-terminal domain', 'BLM_N', 3, NULL),
(26449, NULL, 'IPR027289', NULL, 'Oestrogen-related receptor', 'Oest-rel_rcp', 4, NULL),
(26450, NULL, 'IPR025530', NULL, 'Protein of unknown function DUF4417', 'DUF4417', 4, NULL),
(26451, NULL, 'IPR025474', NULL, 'Domain of unknown function DUF4325', 'DUF4325', 3, NULL),
(26452, NULL, 'IPR028476', NULL, 'Protein S100-A10', 'S100-A10', 4, NULL),
(26453, NULL, 'IPR029271', NULL, 'Psoriasis susceptibility 1 candidate gene 2 protein', 'SPR1', 4, NULL),
(26454, NULL, 'IPR032340', NULL, 'Protein of unknown function DUF4860', 'DUF4860', 4, NULL),
(26455, NULL, 'IPR027277', NULL, 'Nicotinate-nucleotide pyrophosphorylase/Putative pyrophosphorylase ModD', 'NadC/ModD', 4, NULL),
(26456, NULL, 'IPR032169', NULL, 'Protein of unknown function DUF5005', 'DUF5005', 4, NULL),
(26457, NULL, 'IPR029383', NULL, 'ADP-ribosylation factor-like protein 6-interacting protein 6', 'ARL6IP6', 4, NULL),
(26458, NULL, 'IPR024968', NULL, 'Surface layer protein A domain', 'SlpA_dom', 3, NULL),
(26459, NULL, 'IPR031431', NULL, 'Prostate androgen-regulated mucin-like protein 1', 'PARM1', 4, NULL),
(26460, NULL, 'IPR029367', NULL, 'Small integral membrane protein 10', 'SMIM10', 4, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(26461, NULL, 'IPR025498', NULL, 'Protein of unknown function DUF4389', 'DUF4389', 4, NULL),
(26462, NULL, 'IPR025497', NULL, 'Domain of unknown function DUF4388', 'DUF4388', 3, NULL),
(26463, NULL, 'IPR027534', NULL, 'Ribosomal protein L12/P1/P2 family', 'Ribosomal_L12/P1/P2', 4, NULL),
(26464, NULL, 'IPR024549', NULL, 'NADH-ubiquinone oxidoreductase, 21kDa subunit, C-terminal, fungi', 'NADH-UbQ_OxRdtase_su21_C_fun', 3, NULL),
(26465, NULL, 'IPR025485', NULL, 'Domain of unknown function DUF4377', 'DUF4377', 3, NULL),
(26466, NULL, 'IPR025534', NULL, 'Putative PD-(D/E)XK family member (DUF4420)', 'DUF4420', 4, NULL),
(26467, NULL, 'IPR032351', NULL, 'Putative mobile pathogenicity island', 'SAPI', 4, NULL),
(26468, NULL, 'IPR025710', NULL, 'L-cysteine S-thiosulfotransferase subunit SoxA', 'SoxA', 4, NULL),
(26469, NULL, 'IPR025613', NULL, 'YlbE-like protein', 'YlbE', 4, NULL),
(26470, NULL, 'IPR025476', NULL, 'Helitron helicase-like domain', 'Helitron_helicase-like', 3, NULL),
(26471, NULL, 'IPR028600', NULL, 'Cytosolic Fe-S cluster assembly factor NUBP2/Cfd1, eukaryotes', 'NUBP2/Cfd1_eukaryotes', 4, NULL),
(26472, NULL, 'IPR028094', NULL, 'Restriction of telomere capping protein 4, C-terminal', 'RTC4_C', 3, NULL),
(26473, NULL, 'IPR029371', NULL, 'TMEM101 protein', 'TMEM101', 4, NULL),
(26474, NULL, 'IPR025151', NULL, 'ELYS-like domain', 'ELYS_dom', 3, NULL),
(26475, NULL, 'IPR032353', NULL, 'Ubiquitin-protein ligase E3A, N-terminal zinc-binding domain', 'AZUL', 3, NULL),
(26476, NULL, 'IPR029265', NULL, 'Transmembrane protein 51', 'TMEM51', 4, NULL),
(26477, NULL, 'IPR031407', NULL, 'Nuclear receptor-interacting protein 1, repression domain 3', 'NRIP1_RD3', 4, NULL),
(26478, NULL, 'IPR027278', NULL, '1-aminocyclopropane-1-carboxylate deaminase/D-cysteine desulfhydrase', 'ACCD_DCysDesulf', 4, NULL),
(26479, NULL, 'IPR025450', NULL, 'YndJ-like protein', 'YndJ-like', 4, NULL),
(26480, NULL, 'IPR029384', NULL, 'Speriolin, C-terminal', 'Speriolin_C', 3, NULL),
(26481, NULL, 'IPR026211', NULL, 'GIGANTEA', 'GIGANTEA', 4, NULL),
(26482, NULL, 'IPR025393', NULL, 'Domain of unknown function DUF4301', 'DUF4301', 3, NULL),
(26483, NULL, 'IPR024964', NULL, 'CTLH/CRA C-terminal to LisH motif domain', 'CTLH/CRA', 3, NULL),
(26484, NULL, 'IPR025478', NULL, 'Circadian oscillating protein COP23', 'COP23', 4, NULL),
(26485, NULL, 'IPR025384', NULL, 'Protein of unknown function DUF4298', 'DUF4298', 4, NULL),
(26486, NULL, 'IPR031460', NULL, 'Protein of unknown function DUF4678', 'DUF4678', 4, NULL),
(26487, NULL, 'IPR029380', NULL, 'FAM124', 'FAM124', 4, NULL),
(26488, NULL, 'IPR031340', NULL, 'Ribosomal RNA small subunit methyltransferase F, first C-terminal domain', 'RsmF_methylt_CI', 3, NULL),
(26489, NULL, 'IPR029370', NULL, 'TMEM117 protein', 'TMEM117', 4, NULL),
(26490, NULL, 'IPR029387', NULL, 'Organic solute transporter subunit beta', 'OSTbeta', 4, NULL),
(26491, NULL, 'IPR030928', NULL, 'CRISPR type MYXAN-associated protein Cmx8', 'MYXAN_cmx8', 4, NULL),
(26492, NULL, 'IPR031121', NULL, 'KH domain containing protein RIK/BLOM7', 'RIK/BLOM7', 4, NULL),
(26493, NULL, 'IPR032074', NULL, 'Actin cross-linking domain', 'ACD_dom', 3, NULL),
(26494, NULL, 'IPR029268', NULL, 'Small muscular protein Chisel', 'Chisel', 4, NULL),
(26495, NULL, 'IPR027840', NULL, 'Protein of unknown function DUF4493', 'DUF4493', 4, NULL),
(26496, NULL, 'IPR028599', NULL, 'WD repeat WDR12/Ytm1', 'WDR12/Ytm1', 4, NULL),
(26497, NULL, 'IPR029286', NULL, 'Aurora kinase A and ninein interacting protein', 'AUNIP', 4, NULL),
(26498, NULL, 'IPR031037', NULL, 'Peptide O-prenyltransferase, LynF/TruF/PatF family', 'Preny_LynF_TruF', 4, NULL),
(26499, NULL, 'IPR029365', NULL, 'TMEM238 protein', 'TMEM238', 4, NULL),
(26500, NULL, 'IPR031696', NULL, 'Protein of unknown function DUF4719', 'DUF4719', 4, NULL),
(26501, NULL, 'IPR026524', NULL, 'Lymphocyte antigen 6 complex locus protein G6d/G6f', 'LY6G6d/LY6G6f', 4, NULL),
(26502, NULL, 'IPR026030', NULL, 'Purine-cytosine permease Fcy2/21/22', 'Pur-cyt_permease_Fcy2/21/22', 4, NULL),
(26503, NULL, 'IPR024551', NULL, 'Aspartate aminotransferase Ic', 'AspAT_Ic', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(26504, NULL, 'IPR029219', NULL, 'UNC119-binding protein', 'UNC119-bd', 4, NULL),
(26505, NULL, 'IPR026592', NULL, 'Outer membrane protein assembly factor BamE', 'BamE', 4, NULL),
(26506, NULL, 'IPR031886', NULL, 'Domain of unknown function DUF4765', 'DUF4765', 3, NULL),
(26507, NULL, 'IPR029181', NULL, 'Barttin', 'Barttin', 4, NULL),
(26508, NULL, 'IPR029471', NULL, 'HNH endonuclease 5', 'HNH_5', 3, NULL),
(26509, NULL, 'IPR029465', NULL, 'TupA-like ATPgrasp protein', 'ATPgrasp_TupA', 4, NULL),
(26510, NULL, 'IPR026029', NULL, 'Muconolactone isomerase domain', 'MLI_dom', 3, NULL),
(26511, NULL, 'IPR029473', NULL, 'Cell morphogenesis central region', 'MOR2-PAG1_mid', 3, NULL),
(26512, NULL, 'IPR031467', NULL, 'ATPase expression protein 1', 'Aep1', 4, NULL),
(26513, NULL, 'IPR027706', NULL, 'PGP phosphatase, mitochondrial/chloroplastic', 'PGP_Pase', 4, NULL),
(26514, NULL, 'IPR032720', NULL, 'Cysteine-rich CWC', 'Cys_rich_CWC', 4, NULL),
(26515, NULL, 'IPR028788', NULL, 'Cyclin-dependent kinase 6', 'CDK6', 4, NULL),
(26516, NULL, 'IPR028262', NULL, 'CST complex subunit CTC1, plant', 'CTC1_plant', 4, NULL),
(26517, NULL, 'IPR029247', NULL, 'FAM168A/MANI', 'FAM168A/MANI', 4, NULL),
(26518, NULL, 'IPR029227', NULL, 'Plant antimicrobial peptide', 'Plant_Antimicrobial', 3, NULL),
(26519, NULL, 'IPR031516', NULL, 'Protein of unknown function DUF4691', 'DUF4691', 4, NULL),
(26520, NULL, 'IPR032718', NULL, 'PiggyBac transposable element-derived protein 4, C-terminal zinc-ribbon', 'PGBD4_C_Znf-ribbon', 3, NULL),
(26521, NULL, 'IPR028266', NULL, 'Tumor protein p53-inducible protein 11', 'TP53I11', 4, NULL),
(26522, NULL, 'IPR029308', NULL, 'FANCI solenoid 1 domain', 'FANCI_S1', 3, NULL),
(26523, NULL, 'IPR029199', NULL, 'THRAP3/BCLAF1 family', 'THRAP3_BCLAF1', 4, NULL),
(26524, NULL, 'IPR027157', NULL, 'Nuclear cap-binding protein subunit 2', 'NCBP2', 4, NULL),
(26525, NULL, 'IPR031869', NULL, 'YscO-like protein', 'YscO-like', 4, NULL),
(26526, NULL, 'IPR029472', NULL, 'Retrotransposon Copia-like, N-terminal', 'Copia-like_N', 3, NULL),
(26527, NULL, 'IPR026869', NULL, 'Gamma-glutamyl-hercynylcysteine sulfoxide hydrolase EgtC-like', 'EgtC-like', 4, NULL),
(26528, NULL, 'IPR029437', NULL, 'BLOC-2 complex member HPS3, N-terminal domain', 'HPS3_N', 3, NULL),
(26529, NULL, 'IPR024428', NULL, 'Endosialidase, beta propeller domain', 'Endosialidase_beta_prop', 3, NULL),
(26530, NULL, 'IPR029159', NULL, 'Ribosome biogenesis protein C1orf109-like', 'CA109-like', 4, NULL),
(26531, NULL, 'IPR031872', NULL, 'Ndc10, domain 2', 'NDC10_II', 3, NULL),
(26532, NULL, 'IPR024951', NULL, 'Sulphate adenylyltransferase catalytic domain', 'Sulfurylase_cat_dom', 3, NULL),
(26533, NULL, 'IPR035923', NULL, 'TT1751-like domain superfamily', 'TT1751-like_sf', 5, NULL),
(26534, NULL, 'IPR029226', NULL, 'Ecp2 effector protein', 'Ecp2', 3, NULL),
(26535, NULL, 'IPR029206', NULL, 'Protein of unknown function DUF4532', 'DUF4532', 4, NULL),
(26536, NULL, 'IPR027355', NULL, 'Nonstructural protein 10, zinc-binding domain, arterivirus', 'NSP10_Av_ZBD', 3, NULL),
(26537, NULL, 'IPR024558', NULL, 'ComZ', 'ComZ', 4, NULL),
(26538, NULL, 'IPR029468', NULL, 'O-antigen polysaccharide polymerase Wzy', 'O-ag_pol_Wzy', 4, NULL),
(26539, NULL, 'IPR032710', NULL, 'NTF2-like domain superfamily', 'NTF2-like_dom_sf', 5, NULL),
(26540, NULL, 'IPR024325', NULL, 'Domain of unknown function DUF3835', 'DUF3835', 3, NULL),
(26541, NULL, 'IPR029779', NULL, 'Protein of unknown function DUF4674', 'DUF4674', 4, NULL),
(26542, NULL, 'IPR028351', NULL, 'Cyclolysin transport protein CyaE', 'CyaE', 4, NULL),
(26543, NULL, 'IPR032365', NULL, 'BCL-6 corepressor, PCGF1 binding domain', 'PUFD', 3, NULL),
(26544, NULL, 'IPR028359', NULL, 'UDP-N-acetyl-D-mannosamine/glucosamine dehydrogenase', 'UDP_ManNAc/GlcNAc_DH', 4, NULL),
(26545, NULL, 'IPR030932', NULL, 'Polysaccharide biosynthesis PFTS motif protein', 'PFTS_polysacc', 4, NULL),
(26546, NULL, 'IPR024605', NULL, 'NAD(P) transhydrogenase, alpha subunit, C-terminal', 'NADP_transhyd_a_C', 3, NULL),
(26547, NULL, 'IPR029502', NULL, 'Ribosomally synthesized peptide', 'Ribosomal_synth', 4, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(26548, NULL, 'IPR026287', NULL, 'Protein adenylyltransferase SoFic-like', 'SoFic-like', 4, NULL),
(26549, NULL, 'IPR029208', NULL, 'Cytochrome c oxidase assembly protein COX14', 'COX14', 4, NULL),
(26550, NULL, 'IPR024607', NULL, 'Sulfatase, conserved site', 'Sulfatase_CS', 2, NULL),
(26551, NULL, 'IPR028999', NULL, 'Haemocyanin beta-sandwich  domain', 'Haemocyanin_beta-sandwich', 3, NULL),
(26552, NULL, 'IPR029475', NULL, 'Protein of unknown function DUF6807', 'DUF6807', 4, NULL),
(26553, NULL, 'IPR027580', NULL, 'EXLDI protein', 'EXLDI', 4, NULL),
(26554, NULL, 'IPR029221', NULL, 'Penicillin-binding protein Tp47 domain A', 'PBP-Tp47_A', 3, NULL),
(26555, NULL, 'IPR027462', NULL, 'Z ring-associated protein D, C-terminal', 'ZapD_C', 5, NULL),
(26556, NULL, 'IPR028275', NULL, 'Clustered mitochondria protein, N-terminal', 'CLU_N', 3, NULL),
(26557, NULL, 'IPR029160', NULL, 'CCSMST1 family', 'CCSMST1_fam', 4, NULL),
(26558, NULL, 'IPR031882', NULL, 'Protein of unknown function DUF4762', 'DUF4762', 4, NULL),
(26559, NULL, 'IPR026330', NULL, 'Succinylornithine transaminase', 'SOAT', 4, NULL),
(26560, NULL, 'IPR027279', NULL, 'D-aminopeptidase/lipoprotein domain superfamily', 'D_amino_pept/lipop_sf', 5, NULL),
(26561, NULL, 'IPR024478', NULL, 'Chemotaxis methyl-accepting receptor HlyB-like, 4HB MCP domain', 'HlyB_4HB_MCP', 3, NULL),
(26562, NULL, 'IPR028983', NULL, 'PA2201-like, C-terminal', 'PA2201-like_C', 5, NULL),
(26563, NULL, 'IPR027557', NULL, 'Archaeosortase ArtF', 'Archaeo_ArtF', 4, NULL),
(26564, NULL, 'IPR027541', NULL, 'Arsenical pump-driving ATPase', 'Ars_ATPase', 4, NULL),
(26565, NULL, 'IPR028059', NULL, 'Putative flagellar system-associated repeat', 'SWM_rpt', 7, NULL),
(26566, NULL, 'IPR031884', NULL, 'Nucleotide exchange factor Sil1, fungi', 'Sil1_fungi', 4, NULL),
(26567, NULL, 'IPR026895', NULL, 'ER membrane protein complex subunit 1', 'EMC1', 4, NULL),
(26568, NULL, 'IPR031576', NULL, 'Flagellar motor switch protein FliN, N-terminal', 'FliN_N', 3, NULL),
(26569, NULL, 'IPR028973', NULL, 'PhnB-like', 'PhnB-like', 3, NULL),
(26570, NULL, 'IPR029163', NULL, 'Histone deacetylase complex subunit SAP25', 'SAP25', 4, NULL),
(26571, NULL, 'IPR030490', NULL, 'Tissue inhibitor of metalloproteinase, conserved site', 'TIMP_CS', 2, NULL),
(26572, NULL, 'IPR028745', NULL, 'A-kinase anchor protein 9/Pericentrin', 'AKAP9/Pericentrin', 4, NULL),
(26573, NULL, 'IPR027559', NULL, 'B12-binding domain/radical SAM domain protein, rhizo-twelve system', 'B12_rSAM_oligo', 4, NULL),
(26574, NULL, 'IPR027155', NULL, 'AP-3 complex subunit sigma', 'APS3', 4, NULL),
(26575, NULL, 'IPR035589', NULL, 'Janus kinase 2, catalytic domain', 'PTKc_Jak2_rpt2', 3, NULL),
(26576, NULL, 'IPR024603', NULL, 'COG complex component, COG2, C-terminal', 'COG_complex_COG2_C', 3, NULL),
(26577, NULL, 'IPR028070', NULL, 'G6B family', 'G6B', 4, NULL),
(26578, NULL, 'IPR028349', NULL, 'Protein PafC', 'PafC', 4, NULL),
(26579, NULL, 'IPR024887', NULL, 'Ashwin', 'Ashwin', 4, NULL),
(26580, NULL, 'IPR029488', NULL, 'Hemingway/CFA97', 'Hmw/CFAP97', 4, NULL),
(26581, NULL, 'IPR027463', NULL, 'Multidrug efflux transporter AcrB TolC docking domain, DN/DC subdomains', 'AcrB_DN_DC_subdom', 5, NULL),
(26582, NULL, 'IPR028260', NULL, 'FAM177 family', 'FAM177', 4, NULL),
(26583, NULL, 'IPR026899', NULL, '1,3-beta-glucan synthase subunit FKS1-like, domain-1', 'FKS1-like_dom1', 3, NULL),
(26584, NULL, 'IPR030933', NULL, 'HemN-related non-iron pseudo-SAM protein PsgB', 'Non_iron_rSAM', 4, NULL),
(26585, NULL, 'IPR026866', NULL, 'Protein CR006, P-loop domain', 'CR006_AAA', 3, NULL),
(26586, NULL, 'IPR028987', NULL, 'F-type ATP synthase subunit B-like, membrane domain superfamily', 'ATP_synth_B-like_membr_sf', 5, NULL),
(26587, NULL, 'IPR027562', NULL, 'Histidine-histamine antiporter', 'His_histam_anti', 4, NULL),
(26588, NULL, 'IPR024615', NULL, 'CRISPR-associated protein Cmr2, N-terminal', 'CRISPR-assoc_Cmr2_N', 3, NULL),
(26589, NULL, 'IPR027595', NULL, 'Conserved hypothetical protein CHP04338', 'CHP04338', 4, NULL),
(26590, NULL, 'IPR029211', NULL, 'Plasmodium falciparum erythrocyte membrane protein 1, acidic terminal segment', 'PfEMP1_ATS', 3, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(26591, NULL, 'IPR029500', NULL, 'NADPH-dependent 7-cyano-7-deazaguanine reductase QueF', 'QueF', 4, NULL),
(26592, NULL, 'IPR027262', NULL, 'Receptor tyrosine-protein phosphatase alpha', 'Tyr_Pase_rcpt_alpha', 4, NULL),
(26593, NULL, 'IPR029041', NULL, 'FAD-linked oxidoreductase-like', 'FAD-linked_oxidoreductase-like', 5, NULL),
(26594, NULL, 'IPR024334', NULL, 'Domain of unknown function DUF3863', 'DUF3863', 3, NULL),
(26595, NULL, 'IPR026578', NULL, 'L-carnitine dehydrogenase', 'L-carnitine_dehydrogenase', 4, NULL),
(26596, NULL, 'IPR035927', NULL, 'DUSP-like superfamily', 'DUSP-like_sf', 5, NULL),
(26597, NULL, 'IPR029466', NULL, 'No apical meristem-associated, C-terminal domain', 'NAM-associated_C', 3, NULL),
(26598, NULL, 'IPR029004', NULL, 'Ribosomal L28e/Mak16', 'L28e/Mak16', 3, NULL),
(26599, NULL, 'IPR032721', NULL, 'Deaminases, BURPS668_1122 family', 'Toxin-deaminase', 4, NULL),
(26600, NULL, 'IPR029174', NULL, 'Domain of unknown function DUF4637', 'DUF4637', 3, NULL),
(26601, NULL, 'IPR024616', NULL, 'Pherophorin', 'Pherophorin', 3, NULL),
(26602, NULL, 'IPR024429', NULL, 'Endosialidase, N-terminal extension domain', 'Endosialidase_N-extension', 3, NULL),
(26603, NULL, 'IPR031470', NULL, 'Centrosomal protein Cep63/Deup1, N-terminal', 'Cep63/Deup1_N', 3, NULL),
(26604, NULL, 'IPR032243', NULL, 'Protein of unknown function DUF5044', 'DUF5044', 4, NULL),
(26605, NULL, 'IPR026950', NULL, 'Capsule assembly protein Wzi', 'Caps_assemb_Wzi', 4, NULL),
(26606, NULL, 'IPR032711', NULL, 'Ig-like SoxY domain', 'SoxY', 3, NULL),
(26607, NULL, 'IPR029217', NULL, 'Sporulation-specific protein 71, N-terminal domain', 'Spo7_2_N', 3, NULL),
(26608, NULL, 'IPR028784', NULL, 'Bardet-Biedl syndrome 1 protein', 'BBS1', 4, NULL),
(26609, NULL, 'IPR032714', NULL, 'Cilium assembly protein DZIP1, N-terminal', 'DZIP1_N', 3, NULL),
(26610, NULL, 'IPR031427', NULL, 'Protein of unknown function DUF4668', 'DUF4668', 4, NULL),
(26611, NULL, 'IPR028339', NULL, 'Reduced folate transporter SLC19A1', 'SLC19A1', 4, NULL),
(26612, NULL, 'IPR026947', NULL, 'Ubinuclein middle domain', 'UBN_middle_dom', 3, NULL),
(26613, NULL, 'IPR028068', NULL, 'Phosphoinositide-interacting protein', 'PIRT', 4, NULL),
(26614, NULL, 'IPR026864', NULL, 'SH3b2-type SH3 domain', 'SH3b2-type_SH3', 3, NULL),
(26615, NULL, 'IPR024315', NULL, 'Domain of unknown function DUF3805', 'DUF3805', 3, NULL),
(26616, NULL, 'IPR027552', NULL, 'CGP-CTERM domain', 'CGP_CTERM', 3, NULL),
(26617, NULL, 'IPR024438', NULL, 'Staygreen protein', 'Staygreen', 3, NULL),
(26618, NULL, 'IPR026876', NULL, 'Fn3 associated repeat', 'Fn3_assoc_repeat', 7, NULL),
(26619, NULL, 'IPR028278', NULL, 'Modulator of retrovirus infection', 'MRI', 4, NULL),
(26620, NULL, 'IPR031659', NULL, 'Spermatogenesis-associated protein 9', 'SPATA9', 4, NULL),
(26621, NULL, 'IPR029303', NULL, 'Polysaccharide biosynthesis protein, C-terminal domain', 'Polysacc_synt_C', 3, NULL),
(26622, NULL, 'IPR024341', NULL, 'Protein of unknown function DUF2631', 'DUF2631', 4, NULL),
(26623, NULL, 'IPR028750', NULL, 'Centrosome-associated protein 350', 'CEP350', 4, NULL),
(26624, NULL, 'IPR027590', NULL, 'PQQ system protein', 'PQQ_MSMEG_3727', 4, NULL),
(26625, NULL, 'IPR026881', NULL, 'WYL domain', 'WYL_dom', 3, NULL),
(26626, NULL, 'IPR036186', NULL, 'Serpin superfamily', 'Serpin_sf', 5, NULL),
(26627, NULL, 'IPR028361', NULL, 'GPI-anchor transamidase', 'GPI_transamidase', 4, NULL),
(26628, NULL, 'IPR036184', NULL, 'IBP39, C-terminal domain superfamily', 'IBP39-like_C_sf', 5, NULL),
(26629, NULL, 'IPR026910', NULL, 'Shisa family', 'Shisa', 4, NULL),
(26630, NULL, 'IPR029230', NULL, 'Macin', 'Macin', 4, NULL),
(26631, NULL, 'IPR028641', NULL, 'Protein RCC2', 'RCC2', 4, NULL),
(26632, NULL, 'IPR029203', NULL, 'Tektin bundle interacting protein 1', 'TKTI1', 4, NULL),
(26633, NULL, 'IPR024584', NULL, 'Tuberin, N-terminal', 'Tuberin_N', 3, NULL),
(26634, NULL, 'IPR033926', NULL, 'NFkappaB IPT domain', 'IPT_NFkappaB', 3, NULL),
(26635, NULL, 'IPR029216', NULL, 'Phytoplasma antigenic membrane protein', 'Phyto-Amp', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(26636, NULL, 'IPR029480', NULL, 'Transposase-associated domain', 'Transpos_assoc', 3, NULL),
(26637, NULL, 'IPR029319', NULL, 'DNA ligase, OB-like domain', 'DNA_ligase_OB', 3, NULL),
(26638, NULL, 'IPR024590', NULL, 'RNA helicase HrpA, C-terminal', 'HrpA_C', 3, NULL),
(26639, NULL, 'IPR026928', NULL, 'FAX/IsoI-like', 'FAX/IsoI-like', 4, NULL),
(26640, NULL, 'IPR027563', NULL, 'Pyridoxal-phosphate-dependent protein EgtE', 'EgtE', 4, NULL),
(26641, NULL, 'IPR024600', NULL, 'Notch, C-terminal', 'Notch_C', 3, NULL),
(26642, NULL, 'IPR024437', NULL, 'Domain of unknown function DUF3825', 'DUF3825', 3, NULL),
(26643, NULL, 'IPR034082', NULL, 'Protein SQS1, R3H domain', 'R3H_G-patch', 3, NULL),
(26644, NULL, 'IPR031870', NULL, 'ATF7-interacting protein , protein binding domain', 'ATF7IP_BD', 3, NULL),
(26645, NULL, 'IPR030386', NULL, 'GB1/RHD3-type guanine nucleotide-binding (G) domain', 'G_GB1_RHD3_dom', 3, NULL),
(26646, NULL, 'IPR030883', NULL, 'D-allose kinase', 'AlsK', 4, NULL),
(26647, NULL, 'IPR029191', NULL, 'Up-regulated during septation protein 1', 'Uds1', 3, NULL),
(26648, NULL, 'IPR024598', NULL, 'Splicing factor SF3a60 /Prp9 subunit,  C-terminal', 'SF3a60/Prp9_C', 3, NULL),
(26649, NULL, 'IPR028064', NULL, 'Transmembrane protein 154', 'TMEM154', 4, NULL),
(26650, NULL, 'IPR033924', NULL, 'Alkanal monooxygenase', 'Alkanal_monooxygenase', 4, NULL),
(26651, NULL, 'IPR032239', NULL, 'CRISPR-associated endonuclease Cas9, bridge helix', 'Cas9-BH', 3, NULL),
(26652, NULL, 'IPR028790', NULL, 'Molecular chaperone MKKS', 'MKKS', 4, NULL),
(26653, NULL, 'IPR024609', NULL, 'Extracellular sulfatase, C-terminal', 'Extracellular_sulfatase_C', 3, NULL),
(26654, NULL, 'IPR028200', NULL, 'Immunity protein 31', 'Imm31', 4, NULL),
(26655, NULL, 'IPR024884', NULL, 'N-acyl-phosphatidylethanolamine-hydrolysing phospholipase D', 'NAPE-PLD', 4, NULL),
(26656, NULL, 'IPR034079', NULL, 'RNA-binding protein KhpB, R3H domain', 'R3H_KhpB', 3, NULL),
(26657, NULL, 'IPR029440', NULL, 'Dynein regulatory complex protein 1, C-terminal', 'DRC1_C', 3, NULL),
(26658, NULL, 'IPR032686', NULL, 'Pyruvate ferredoxin oxidoreductase beta subunit, C-terminal', 'PFO_beta_C', 3, NULL),
(26659, NULL, 'IPR026230', NULL, 'Mas-related G protein-coupled receptor E', 'MRGPCRE', 4, NULL),
(26660, NULL, 'IPR029435', NULL, 'Protein TOPAZ1 domain', 'TOPAZ1_dom', 3, NULL),
(26661, NULL, 'IPR032232', NULL, 'Caskin-1, CASK-interaction domain', 'Caskin1-CID', 3, NULL),
(26662, NULL, 'IPR029205', NULL, 'Aftiphilin, clathrin-binding box', 'Clathrin-bd', 3, NULL),
(26663, NULL, 'IPR028280', NULL, 'Protein Njmu-R1', 'Njmu-R1', 4, NULL),
(26664, NULL, 'IPR026234', NULL, 'Mas-related G protein-coupled receptor family', 'MRGPCRFAMILY', 4, NULL),
(26665, NULL, 'IPR026902', NULL, 'RnfC Barrel sandwich hybrid domain', 'RnfC_N', 3, NULL),
(26666, NULL, 'IPR029198', NULL, 'AJAP1/PANP, C-terminal', 'AJAP1_PANP_C', 3, NULL),
(26667, NULL, 'IPR026328', NULL, 'Formylmethanofuran dehydrogenase, subunit E', 'FmdE', 4, NULL),
(26668, NULL, 'IPR026873', NULL, 'Geranylgeranyl transferase type-2 subunit beta', 'Ptb1', 4, NULL),
(26669, NULL, 'IPR028362', NULL, 'Alginate O-acetyltransferase AlgI', 'AlgI', 4, NULL),
(26670, NULL, 'IPR027458', NULL, 'Pheromone alpha factor receptor, double transmembrane domain superfamily', 'STE2_TM1-TM2_sf', 5, NULL),
(26671, NULL, 'IPR036047', NULL, 'F-box-like domain superfamily', 'F-box-like_dom_sf', 5, NULL),
(26672, NULL, 'IPR025979', NULL, 'ChrR-like cupin domain', 'ChrR-like_cupin_dom', 3, NULL),
(26673, NULL, 'IPR028971', NULL, 'NAD-glutamate dehydrogenase', 'NAD-GDH', 4, NULL),
(26674, NULL, 'IPR026593', NULL, 'Protein translocase subunit SecY', 'SecY', 4, NULL),
(26675, NULL, 'IPR031468', NULL, 'Synaptotagmin-like mitochondrial-lipid-binding domain', 'SMP_LBD', 3, NULL),
(26676, NULL, 'IPR024432', NULL, 'Putative exodeoxyribonuclease 8, PDDEXK-like domain', 'Put_RecE_PDDEXK-like_dom', 3, NULL),
(26677, NULL, 'IPR029438', NULL, 'BLOC-2 complex member HPS3, C-terminal domain', 'HPS3_C', 3, NULL),
(26678, NULL, 'IPR029157', NULL, 'Centrosomal CEP44 domain', 'CEP44_CC', 3, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(26679, NULL, 'IPR029314', NULL, 'FANCI solenoid 4 domain', 'FANCI_S4', 3, NULL),
(26680, NULL, 'IPR024586', NULL, 'DnaJ-like protein C11, C-terminal', 'DnaJ-like_C11_C', 3, NULL),
(26681, NULL, 'IPR029434', NULL, 'Putative transcriptional regulator', 'Put_trans_reg', 4, NULL),
(26682, NULL, 'IPR027601', NULL, 'Cys-rich peptide, Clo7bot family', 'Clo7Bot_mod_Cys', 4, NULL),
(26683, NULL, 'IPR030931', NULL, 'Group II intron reverse transcriptase/maturase', 'Group_II_RT_mat', 4, NULL),
(26684, NULL, 'IPR029315', NULL, 'FANCI solenoid 2 domain', 'FANCI_S2', 3, NULL),
(26685, NULL, 'IPR031469', NULL, 'Fungal death-pathway protein, SesB domain', 'SesB_dom', 4, NULL),
(26686, NULL, 'IPR024316', NULL, 'Nuclear pore assembly and biogenesis protein, APQ12', 'APQ12', 4, NULL),
(26687, NULL, 'IPR029021', NULL, 'Protein-tyrosine phosphatase-like', 'Prot-tyrosine_phosphatase-like', 5, NULL),
(26688, NULL, 'IPR024431', NULL, 'Insertion element IS1 protein InsA, helix-turn-helix domain', 'InsA_HTH_dom', 3, NULL),
(26689, NULL, 'IPR029305', NULL, 'FANCI solenoid 1 cap', 'FANCI_S1-cap', 3, NULL),
(26690, NULL, 'IPR024883', NULL, 'Neurensin', 'Neurensin', 4, NULL),
(26691, NULL, 'IPR024331', NULL, 'Domain of unknown function DUF3859', 'DUF3859', 3, NULL),
(26692, NULL, 'IPR024335', NULL, 'Domain of unknown function DUF3864', 'DUF3864', 3, NULL),
(26693, NULL, 'IPR026890', NULL, 'Mononegavirales mRNA-capping domain V', 'Mononeg_mRNAcap', 3, NULL),
(26694, NULL, 'IPR031861', NULL, 'Phage tail base-plate attachment protein ORF16', 'Caudo_ORF16', 4, NULL),
(26695, NULL, 'IPR024320', NULL, 'Phosphatidylglycerol lysyltransferase, C-terminal', 'LPG_synthase_C', 3, NULL),
(26696, NULL, 'IPR026932', NULL, 'Myelin gene regulatory factor, ICA domain', 'MYRF_ICA', 3, NULL),
(26697, NULL, 'IPR028283', NULL, 'WASH complex subunit 7, C-terminal', 'WASH-7_C', 3, NULL),
(26698, NULL, 'IPR026889', NULL, 'Transposase zinc-binding domain', 'Zn_Tnp', 3, NULL),
(26699, NULL, 'IPR030688', NULL, 'Methyltransferase MtrA/MtxA', 'MeTrfase_MtrA/MtxA', 4, NULL),
(26700, NULL, 'IPR027550', NULL, 'MSEP-CTERM protein', 'MSEP-CTERM', 4, NULL),
(26701, NULL, 'IPR029776', NULL, 'Transmembrane protein 179B', 'TMEM179B', 4, NULL),
(26702, NULL, 'IPR029071', NULL, 'Ubiquitin-like domain superfamily', 'Ubiquitin-like_domsf', 5, NULL),
(26703, NULL, 'IPR030392', NULL, 'Intramolecular chaperone auto-processing domain', 'S74_ICA', 3, NULL),
(26704, NULL, 'IPR029470', NULL, 'PD-(D/E)XK nuclease superfamily  4', 'PDDEXK_4', 4, NULL),
(26705, NULL, 'IPR031952', NULL, 'KH-like RNA-binding domain', 'MOEP19_KH-like', 3, NULL),
(26706, NULL, 'IPR028631', NULL, 'Adrenocortical dysplasia protein', 'ACD', 4, NULL),
(26707, NULL, 'IPR029322', NULL, 'Domain of unknown function DUF4474', 'DUF4474', 3, NULL),
(26708, NULL, 'IPR024589', NULL, 'Fungal ligninase, C-terminal', 'Ligninase_C', 3, NULL),
(26709, NULL, 'IPR024468', NULL, 'Sec16, N-terminal', 'Sec16_N', 3, NULL),
(26710, NULL, 'IPR029321', NULL, 'Integrator complex subunit 2', 'INTS2', 4, NULL),
(26711, NULL, 'IPR026877', NULL, 'DXP reductoisomerase C-terminal domain', 'DXPR_C', 3, NULL),
(26712, NULL, 'IPR031642', NULL, 'VPS13, repeated region', 'VPS13_mid_rpt', 3, NULL),
(26713, NULL, 'IPR030385', NULL, 'IRG-type guanine nucleotide-binding (G) domain', 'G_IRG_dom', 3, NULL),
(26714, NULL, 'IPR031518', NULL, 'Protein of unknown function DUF4693', 'DUF4693', 4, NULL),
(26715, NULL, 'IPR030391', NULL, 'RNA methyltransferase TrmA, conserved site', 'MeTrfase_TrmA_CS', 2, NULL),
(26716, NULL, 'IPR030378', NULL, 'Circularly permuted (CP)-type guanine nucleotide-binding (G) domain', 'G_CP_dom', 3, NULL),
(26717, NULL, 'IPR027603', NULL, 'Putative transferase, LIC12162 family', 'LIC12162', 4, NULL),
(26718, NULL, 'IPR029023', NULL, 'Tensin-type phosphatase domain', 'Tensin_phosphatase', 3, NULL),
(26719, NULL, 'IPR032692', NULL, 'Integral membrane protein YccS, N-terminal', 'YccS_N', 3, NULL),
(26720, NULL, 'IPR024601', NULL, 'Peptidase M1, alanyl aminopeptidase, C-terminal', 'Peptidase_M1_pepN_C', 3, NULL),
(26721, NULL, 'IPR028276', NULL, 'Immunity protein 68', 'Imm68', 4, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(26722, NULL, 'IPR032372', NULL, 'Proteasome activator Blm10, N-terminal', 'Blm10_N', 3, NULL),
(26723, NULL, 'IPR029249', NULL, 'Rotatin, N-terminal', 'Rotatin_N', 3, NULL),
(26724, NULL, 'IPR028282', NULL, 'WASH complex subunit 7, central domain', 'WASH-7_central', 3, NULL),
(26725, NULL, 'IPR029162', NULL, 'TRP-interacting helix, InaF motif', 'InaF-motif', 2, NULL),
(26726, NULL, 'IPR031463', NULL, 'MICOS complex subunit Mic12', 'Mic12', 4, NULL),
(26727, NULL, 'IPR032687', NULL, 'HTH-type transcriptional regulator AraC-type, N-terminal', 'AraC-type_N', 3, NULL),
(26728, NULL, 'IPR026906', NULL, 'BspA type Leucine rich repeat region', 'LRR_5', 7, NULL),
(26729, NULL, 'IPR029501', NULL, 'Bacterial EndoU nuclease', 'EndoU_bac', 3, NULL),
(26730, NULL, 'IPR029175', NULL, 'Exocyst complex component EXOC2/Sec5', 'EXOC2/Sec5', 4, NULL),
(26731, NULL, 'IPR027583', NULL, 'Radical SAM/SPASM domain protein, ACGX system', 'rSAM_ACGX', 4, NULL),
(26732, NULL, 'IPR029445', NULL, 'Integrator complex subunit 5, N-terminal', 'INTS5_N', 3, NULL),
(26733, NULL, 'IPR029294', NULL, 'Helically-extended SH3 domain', 'hSH3', 3, NULL),
(26734, NULL, 'IPR028206', NULL, 'Psoriasis susceptibility 1 candidate 1', 'SEEK1', 4, NULL),
(26735, NULL, 'IPR031862', NULL, 'Gap junction alpha-5 protein (Cx40), C-terminal', 'Cx40_C', 3, NULL),
(26736, NULL, 'IPR028389', NULL, 'Protection of telomeres protein 1', 'POT1', 4, NULL),
(26737, NULL, 'IPR032683', NULL, 'Malate dehydrogenase enzyme, N-terminal', 'Malate_DH', 3, NULL),
(26738, NULL, 'IPR032716', NULL, 'Biotin-dependent acetyl-/propionyl-coenzyme A carboxylase epsilon subunit', 'ACC_epsilon', 4, NULL),
(26739, NULL, 'IPR029312', NULL, 'FANCI helical domain 2', 'FANCI_HD2', 3, NULL),
(26740, NULL, 'IPR031887', NULL, 'Serologically defined colon cancer antigen 8', 'SDCCAG8', 4, NULL),
(26741, NULL, 'IPR026280', NULL, 'Tissue plasminogen activator', 'Tissue_plasm_act', 4, NULL),
(26742, NULL, 'IPR032240', NULL, 'CRISPR-associated endonuclease Cas9, REC lobe', 'Cas9_REC', 3, NULL),
(26743, NULL, 'IPR024882', NULL, 'Nucleoporin p58/p45', 'Nucleoporin_p58/p45', 4, NULL),
(26744, NULL, 'IPR027785', NULL, 'UvrD-like helicase C-terminal domain', 'UvrD-like_helicase_C', 3, NULL),
(26745, NULL, 'IPR027596', NULL, 'AmmeMemoRadiSam system radical SAM enzyme', 'AmmeMemoSam_rS', 4, NULL),
(26746, NULL, 'IPR031879', NULL, 'Fanconi anemia group M protein,  MHF binding domain', 'FANCM-MHF-bd', 3, NULL),
(26747, NULL, 'IPR026870', NULL, 'Zinc-ribbon domain', 'Zinc_ribbon_dom', 3, NULL),
(26748, NULL, 'IPR032238', NULL, 'Putative ATP-synthase-associated protein', 'ATP-synth_Z', 4, NULL),
(26749, NULL, 'IPR034052', NULL, 'Tumor necrosis factor receptor EDAR, N-terminal', 'EDAR_N', 3, NULL),
(26750, NULL, 'IPR028892', NULL, 'Adenine deaminase type 2', 'ADE', 4, NULL),
(26751, NULL, 'IPR032237', NULL, 'CRISPR-associated endonuclease Cas9, PAM-interacting domain', 'Cas9_PI', 3, NULL),
(26752, NULL, 'IPR027246', NULL, 'Eukaryotic porin/Tom40', 'Porin_Euk/Tom40', 4, NULL),
(26753, NULL, 'IPR024318', NULL, 'Negative regulator of Ofd1/Enhancer of translation termination 1', 'Nro1/ETT1', 4, NULL),
(26754, NULL, 'IPR026913', NULL, 'Probable methyltransferase-like protein 24', 'METTL24', 4, NULL),
(26755, NULL, 'IPR032715', NULL, 'Nuclear receptor coactivator 6, TRADD-N domain', 'NCOA6_TRADD-N', 3, NULL),
(26756, NULL, 'IPR029323', NULL, 'Equine arteritis virus, non-structural protein 1', 'EAV_nsp1', 3, NULL),
(26757, NULL, 'IPR024588', NULL, 'Inner membrane protein YejM, N-terminal', 'YejM_N', 3, NULL),
(26758, NULL, 'IPR029291', NULL, 'DNA binding protein Tfx, C-terminal', 'Tfx_C', 3, NULL),
(26759, NULL, 'IPR035588', NULL, 'Janus kinase 2, pseudokinase domain', 'PTK_Jak2_rpt1', 3, NULL),
(26760, NULL, 'IPR033923', NULL, 'p21 activated kinase binding domain', 'PAK_BD', 3, NULL),
(26761, NULL, 'IPR028350', NULL, 'DNA replication protein DnaC/insertion sequence putative ATP-binding protein', 'DNAC/ATP-binding', 4, NULL),
(26762, NULL, 'IPR031569', NULL, 'Apextrin, C-terminal domain', 'ApeC', 3, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(26763, NULL, 'IPR029171', NULL, 'Protein of unknown function DUF4638', 'DUF4638', 4, NULL),
(26764, NULL, 'IPR024606', NULL, 'Protein of unknown function DUF3827', 'DUF3827', 4, NULL),
(26765, NULL, 'IPR027786', NULL, 'Nse4/EID family', 'Nse4/EID', 4, NULL),
(26766, NULL, 'IPR031459', NULL, 'Cytochrome c oxidase assembly factor 2', 'Coa2', 4, NULL),
(26767, NULL, 'IPR031868', NULL, 'Sliding-clamp-loader small subunit gp62', 'Phage_clamp_gp62', 4, NULL),
(26768, NULL, 'IPR024604', NULL, 'Serine/threonine-protein kinase haspin, C-terminal', 'GSG2_C', 3, NULL),
(26769, NULL, 'IPR027543', NULL, 'Lon protease, bacterial', 'Lon_bac', 4, NULL),
(26770, NULL, 'IPR026885', NULL, 'Autophagy-related protein 2, CAD motif', 'ATG2_CAD_motif', 3, NULL),
(26771, NULL, 'IPR032370', NULL, 'Flagellar assembly protein T, N-terminal', 'FlgT_N', 3, NULL),
(26772, NULL, 'IPR030374', NULL, 'Polyamine biosynthesis  domain', 'PABS', 3, NULL),
(26773, NULL, 'IPR026891', NULL, 'Fibronectin type III-like domain', 'Fn3-like', 3, NULL),
(26774, NULL, 'IPR031471', NULL, 'Protein BptA', 'BptA', 4, NULL),
(26775, NULL, 'IPR034043', NULL, 'Tumor necrosis factor receptor 11B, N-terminal, teleost', 'TNFRSF11B_N_teleost', 3, NULL),
(26776, NULL, 'IPR027357', NULL, 'DOCKER domain', 'DOCKER_dom', 3, NULL),
(26777, NULL, 'IPR034039', NULL, 'Hatching enzyme, peptidase domain', 'ZnMP_hatching_enz', 3, NULL),
(26778, NULL, 'IPR027156', NULL, 'AP-2 complex subunit sigma', 'APS2', 4, NULL),
(26779, NULL, 'IPR032374', NULL, 'SGTA, homodimerisation domain', 'SGTA_dimer', 3, NULL),
(26780, NULL, 'IPR028066', NULL, 'Transmembrane protein 187', 'TMEM187', 4, NULL),
(26781, NULL, 'IPR028893', NULL, 'Adenosine deaminase', 'A_deaminase', 4, NULL),
(26782, NULL, 'IPR026907', NULL, 'Cyclin-D1-binding protein 1', 'CCNDBP1', 4, NULL),
(26783, NULL, 'IPR028281', NULL, 'Siroheme synthase, central domain', 'Sirohaem_synthase_central', 3, NULL),
(26784, NULL, 'IPR024592', NULL, 'Variable lymphocyte receptor, C-terminal', 'Variable_lymphocyte_rcpt_C', 3, NULL),
(26785, NULL, 'IPR028433', NULL, 'Parvin', 'Parvin', 4, NULL),
(26786, NULL, 'IPR029158', NULL, 'Stimulator of interferon genes protein', 'STING', 4, NULL),
(26787, NULL, 'IPR027460', NULL, 'Aerobic respiration control sensor protein ArcB, transmembrane domain superfamily', 'ArcB_TM_sf', 5, NULL),
(26788, NULL, 'IPR032713', NULL, 'Putative multidrug resistance efflux transporter', 'EmrE', 4, NULL),
(26789, NULL, 'IPR031521', NULL, 'Protein of unknown function DUF4695', 'DUF4695', 4, NULL),
(26790, NULL, 'IPR029229', NULL, 'Alkyl sulfatase, C-terminal', 'Alkyl_sulf_C', 3, NULL),
(26791, NULL, 'IPR024328', NULL, 'Protein of unknown function DUF3845', 'DUF3845', 4, NULL),
(26792, NULL, 'IPR026898', NULL, 'Intramembrane metalloprotease PrsW', 'PrsW', 4, NULL),
(26793, NULL, 'IPR027577', NULL, '5-histidylcysteine sulfoxide synthase', 'OvoA_Nterm', 4, NULL),
(26794, NULL, 'IPR029220', NULL, 'Penicillin-binding protein Tp47, domain D', 'BP-Tp47_dom_D', 5, NULL),
(26795, NULL, 'IPR032722', NULL, 'Deaminase, Xanthomonas XOO_2897-like', 'Deaminase_XOO_2897', 4, NULL),
(26796, NULL, 'IPR024942', NULL, 'Maturase MatK, N-terminal domain', 'Maturase_MatK_N', 3, NULL),
(26797, NULL, 'IPR029201', NULL, 'Jiraiya', 'Jiraiya', 4, NULL),
(26798, NULL, 'IPR028069', NULL, 'Transmembrane protein 89', 'TMEM89', 4, NULL),
(26799, NULL, 'IPR027542', NULL, 'Arsenical pump ATPase, ArsA/GET3, eukaryotic', 'ATPase_ArsA/GET3_euk', 4, NULL),
(26800, NULL, 'IPR026588', NULL, 'Choice-of-anchor A domain', 'Choice_anch_A', 3, NULL),
(26801, NULL, 'IPR032717', NULL, 'Mitochondrial splicing suppressor 51, zinc-finger', 'Mss51_Znf', 3, NULL),
(26802, NULL, 'IPR033875', NULL, 'Flagellum site-determining protein FlhG', 'FlhG', 3, NULL),
(26803, NULL, 'IPR024619', NULL, 'Protein of unknown function DUF3860', 'DUF3860', 4, NULL),
(26804, NULL, 'IPR032242', NULL, 'Protein of unknown function DUF5043', 'DUF5043', 4, NULL),
(26805, NULL, 'IPR028274', NULL, 'TerY-C metal binding domain', 'TerY-C', 3, NULL),
(26806, NULL, 'IPR024885', NULL, 'Neuronatin', 'Neuronatin', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(26807, NULL, 'IPR031571', NULL, 'Flp pilus assembly protein RcpC/CpaB domain', 'RcpC_dom', 3, NULL),
(26808, NULL, 'IPR026894', NULL, 'DNAJ-containing protein, X-domain', 'DnaJ_X', 3, NULL),
(26809, NULL, 'IPR027560', NULL, 'PEFG-CTERM domain', 'PEFG-CTERM', 3, NULL),
(26810, NULL, 'IPR029196', NULL, 'HUWE1-associated protein modifying stress responses-like', 'HAPSTR1-like', 4, NULL),
(26811, NULL, 'IPR032697', NULL, 'Squalene cyclase, N-terminal', 'SQ_cyclase_N', 3, NULL),
(26812, NULL, 'IPR034081', NULL, 'AAA domain-containing protein, R3H domain', 'R3H_AAA', 3, NULL),
(26813, NULL, 'IPR029188', NULL, 'Ribosomal RNA-processing protein 14, N-terminal', 'Rrp14_N', 3, NULL),
(26814, NULL, 'IPR027561', NULL, 'Thaumarchaeosortase', 'Thauma_sortase', 4, NULL),
(26815, NULL, 'IPR032460', NULL, 'Symplekin/Pta1, N-terminal', 'Symplekin/Pta1_N', 3, NULL),
(26816, NULL, 'IPR026896', NULL, 'Transcription termination and cleavage factor, C-terminal domain', 'CSTF_C', 3, NULL),
(26817, NULL, 'IPR029433', NULL, 'Protein of unknown function DUF4438', 'DUF4438', 4, NULL),
(26818, NULL, 'IPR029178', NULL, 'Extracellular mutant protein 11, C-terminal', 'Ecm11_C', 3, NULL),
(26819, NULL, 'IPR032708', NULL, 'Microcin J25-processing protein McjB, C-terminal', 'McjB_C', 3, NULL),
(26820, NULL, 'IPR024462', NULL, 'Glycosyl-hydrolase family 116, N-terminal', 'GH116_N', 3, NULL),
(26821, NULL, 'IPR029499', NULL, 'Corrinoid adenosyltransferase, PduO-type', 'PduO-typ', 4, NULL),
(26822, NULL, 'IPR027405', NULL, 'YidB-like', 'YidB-like', 5, NULL),
(26823, NULL, 'IPR029482', NULL, 'Putative peptidase domain, HRXXH', 'HRXXH', 3, NULL),
(26824, NULL, 'IPR029320', NULL, 'Acyl-coenzyme A oxidase, N-terminal', 'Acyl-CoA_ox_N', 3, NULL),
(26825, NULL, 'IPR028259', NULL, 'AP2-like integrase, N-terminal domain', 'AP2-like_int_N', 3, NULL),
(26826, NULL, 'IPR029222', NULL, 'Protein FAM104', 'FAM104', 4, NULL),
(26827, NULL, 'IPR029215', NULL, 'High mobility group box domain 5', 'HMG_box_5', 3, NULL),
(26828, NULL, 'IPR024886', NULL, 'Bone marrow stromal antigen 2', 'BST2', 4, NULL),
(26829, NULL, 'IPR031877', NULL, 'Metal-binding protein SmbP', 'SmbP', 4, NULL),
(26830, NULL, 'IPR024434', NULL, 'TSCPD domain', 'TSCPD_dom', 3, NULL),
(26831, NULL, 'IPR032712', NULL, 'AsmA-like, C-terminal', 'AsmA_C', 3, NULL),
(26832, NULL, 'IPR035970', NULL, 'Ribosomal protein L19/L19e superfamily', '60S_ribosomal_L19/L19e_sf', 5, NULL),
(26833, NULL, 'IPR029214', NULL, 'FAM183 family', 'FAM183', 4, NULL),
(26834, NULL, 'IPR032681', NULL, 'HlyD family secretion protein', 'HlyD_2', 4, NULL),
(26835, NULL, 'IPR027558', NULL, 'Prepilin-type processing-associated H-X9-DG domain', 'Pre_pil_HX9DG', 3, NULL),
(26836, NULL, 'IPR027554', NULL, 'Methyltransferase, Rta_06860 family', 'Meth_Rta_06860', 4, NULL),
(26837, NULL, 'IPR028271', NULL, 'RNA guanine-N7 methyltransferase activating subunit', 'RAMAC', 4, NULL),
(26838, NULL, 'IPR027545', NULL, 'Kynurenine 3-monooxygenase', 'Kynurenine_monooxygenase', 4, NULL),
(26839, NULL, 'IPR029436', NULL, 'Eukaryotic glycogen debranching enzyme, N-terminal domain', 'AGL_euk_N', 3, NULL),
(26840, NULL, 'IPR028337', NULL, 'Thiamine transporter 2', 'ThTr-2', 4, NULL),
(26841, NULL, 'IPR027602', NULL, 'Poly-gamma-glutamate system protein', 'PGA_system', 4, NULL),
(26842, NULL, 'IPR031428', NULL, 'Linker for activation of T-cells family member 2', 'LAT2', 4, NULL),
(26843, NULL, 'IPR032695', NULL, 'Integrin domain superfamily', 'Integrin_dom_sf', 5, NULL),
(26844, NULL, 'IPR028974', NULL, 'TSP type-3 repeat', 'TSP_type-3_rpt', 5, NULL),
(26845, NULL, 'IPR027214', NULL, 'Cystatin', 'Cystatin', 4, NULL),
(26846, NULL, 'IPR033925', NULL, 'Rad51/DMC1/RadA', 'Rad51_DMC1_RadA', 3, NULL),
(26847, NULL, 'IPR029446', NULL, 'Coatomer beta subunit, appendage platform domain', 'COPB1_appendage_platform_dom', 3, NULL),
(26848, NULL, 'IPR029295', NULL, 'Snf2, ATP coupling domain', 'SnAC', 3, NULL),
(26849, NULL, 'IPR024881', NULL, 'T-cell immunomodulatory protein', 'Tip', 4, NULL),
(26850, NULL, 'IPR026232', NULL, 'Mas-related G protein-coupled receptor D', 'MRGPCRD', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(26851, NULL, 'IPR028065', NULL, 'Telomere repeats-binding bouquet formation protein 2', 'TERB2', 4, NULL),
(26852, NULL, 'IPR032693', NULL, 'YtkA-like domain', 'YtkA-like_dom', 3, NULL),
(26853, NULL, 'IPR026233', NULL, 'Mas-related G protein-coupled receptor A', 'MRGPCRA', 4, NULL),
(26854, NULL, 'IPR029218', NULL, 'Penicillin-binding protein Tp47, domain C', 'PBP-Tp47_dom_C', 3, NULL),
(26855, NULL, 'IPR027248', NULL, 'Small nuclear ribonucleoprotein Sm D2', 'Sm_D2', 4, NULL),
(26856, NULL, 'IPR032367', NULL, 'Protein quaking, putative nuclear localisation signal', 'Quaking_NLS', 3, NULL),
(26857, NULL, 'IPR029028', NULL, 'Alpha/beta knot methyltransferases', 'Alpha/beta_knot_MTases', 5, NULL),
(26858, NULL, 'IPR031883', NULL, 'Protein of unknown function DUF4763', 'DUF4763', 4, NULL),
(26859, NULL, 'IPR024321', NULL, 'Protease  inhibitor, falstatin', 'Prot_Inh_falstatin', 4, NULL),
(26860, NULL, 'IPR024439', NULL, 'RNHCP domain', 'RNHCP', 3, NULL),
(26861, NULL, 'IPR026893', NULL, 'Tyrosine/serine-protein phosphatase IphP-type', 'Tyr/Ser_Pase_IphP-type', 4, NULL),
(26862, NULL, 'IPR032738', NULL, 'TBC1 domain family member 30, C-terminal', 'Tbc1d30_C', 3, NULL),
(26863, NULL, 'IPR033280', NULL, 'Membrane protein MLC1', 'Membrane_MLC1', 4, NULL),
(26864, NULL, 'IPR026875', NULL, 'Phosphohydrolase-associated domain', 'PHydrolase_assoc_dom', 3, NULL),
(26865, NULL, 'IPR028277', NULL, 'Lsm, C-terminal', 'Lsm_C', 3, NULL),
(26866, NULL, 'IPR029213', NULL, 'Cell-cell fusogen EFF/AFF', 'Fusogen_EFF/AFF', 4, NULL),
(26867, NULL, 'IPR031456', NULL, 'Cap-associated protein Caf20', 'Caf20', 4, NULL),
(26868, NULL, 'IPR031889', NULL, 'AIMP2, lysyl-tRNA synthetase binding domain', 'AIMP2_LysRS-bd', 3, NULL),
(26869, NULL, 'IPR024562', NULL, 'Uncharacterised protein family YqhG', 'YqhG', 4, NULL),
(26870, NULL, 'IPR027485', NULL, 'AMMECR1, N-terminal', 'AMMECR1_N', 5, NULL),
(26871, NULL, 'IPR029210', NULL, 'Plasmodium falciparum erythrocyte membrane protein-1, N-terminal segment', 'PfEMP1_NTS', 3, NULL),
(26872, NULL, 'IPR033821', NULL, 'Nuclear receptor-interacting protein, peptidase domain', 'NRIP_C', 3, NULL),
(26873, NULL, 'IPR026914', NULL, 'Calsyntenin', 'Calsyntenin', 4, NULL),
(26874, NULL, 'IPR030379', NULL, 'Septin-type guanine nucleotide-binding (G) domain', 'G_SEPTIN_dom', 3, NULL),
(26875, NULL, 'IPR029202', NULL, 'Protein of unknown function DUF4530', 'DUF4530', 4, NULL),
(26876, NULL, 'IPR029200', NULL, 'Transmembrane protein 247', 'TMEM247', 4, NULL),
(26877, NULL, 'IPR027551', NULL, 'Exosortase K', 'Exosort_XrtK', 4, NULL),
(26878, NULL, 'IPR032682', NULL, 'Condensin complex subunit 1, C-terminal', 'Cnd1_C', 3, NULL),
(26879, NULL, 'IPR026872', NULL, 'Protein farnesyltransferase subunit beta', 'FTB', 4, NULL),
(26880, NULL, 'IPR024330', NULL, 'Protein of unknown function DUF3852', 'DUF3852', 4, NULL),
(26881, NULL, 'IPR029025', NULL, 'Type III secretion system substrate exporter, C-terminal', 'T3SS_substrate_exporter_C', 5, NULL),
(26882, NULL, 'IPR027555', NULL, 'tRNA (Mo5U34)-methyltransferase-like', 'Mo5U34_MeTrfas-like', 4, NULL),
(26883, NULL, 'IPR029489', NULL, 'O-GlcNAc transferase, C-terminal', 'OGT/SEC/SPY_C', 3, NULL),
(26884, NULL, 'IPR029464', NULL, 'Type I restriction enzyme R protein, N-terminal domain', 'HSDR_N', 3, NULL),
(26885, NULL, 'IPR036072', NULL, 'Class I myosin, motor domain', 'MYSc_Myo1', 3, NULL),
(26886, NULL, 'IPR024317', NULL, 'Dynein heavy chain, AAA module D4', 'Dynein_heavy_chain_D4_dom', 3, NULL),
(26887, NULL, 'IPR035954', NULL, 'MTH677-like superfamily', 'MTH677-like_sf', 5, NULL),
(26888, NULL, 'IPR035969', NULL, 'Rab-GTPase-TBC domain superfamily', 'Rab-GTPase_TBC_sf', 5, NULL),
(26889, NULL, 'IPR031661', NULL, 'Bcl-2-binding component 3', 'Bbc3', 4, NULL),
(26890, NULL, 'IPR024427', NULL, 'Endosialidase, beta barrel domain', 'Endosialidase_beta_barrel', 3, NULL),
(26891, NULL, 'IPR029237', NULL, 'Long chain scorpion toxin family', 'Long_scorpion_toxin', 4, NULL),
(26892, NULL, 'IPR031885', NULL, 'Domain of unknown function DUF4764', 'DUF4764', 3, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(26893, NULL, 'IPR027553', NULL, 'Eight-cysteine-cluster domain', 'Heavy_Cys', 3, NULL),
(26894, NULL, 'IPR028209', NULL, 'LAMTOR1/MEH1', 'LAMTOR1/MEH1', 4, NULL),
(26895, NULL, 'IPR027017', NULL, 'Uncharacterised peptidase with NlpC/P60 domain, YkfC type', 'P60_peptidase_YkfC', 4, NULL),
(26896, NULL, 'IPR031454', NULL, 'Viral matrix protein M', 'Viral_M', 4, NULL),
(26897, NULL, 'IPR024430', NULL, 'Endosialidase, C-terminal domain', 'Endosialidase_C_dom', 3, NULL),
(26898, NULL, 'IPR034162', NULL, 'Pepsin catalytic domain', 'Pepsin_A', 3, NULL),
(26899, NULL, 'IPR030548', NULL, 'DNA repair protein RAD51 homologue 2', 'RAD51B', 4, NULL),
(26900, NULL, 'IPR027581', NULL, 'ACGX-repeat peptide', 'Target_ACGX', 4, NULL),
(26901, NULL, 'IPR032688', NULL, 'ABC-2 family transporter protein', 'ABC2_membrane_2', 4, NULL),
(26902, NULL, 'IPR026905', NULL, 'Protein ASX-like, PHD domain', 'ASX-like_PHD', 3, NULL),
(26903, NULL, 'IPR028204', NULL, 'Tricorn protease C1 domain', 'Tricorn_C1', 3, NULL),
(26904, NULL, 'IPR027021', NULL, 'Cyclic di-GMP binding protein, PA4608 type', 'C-di-GMP_BP_PA4608', 4, NULL),
(26905, NULL, 'IPR024593', NULL, 'Domain of unknown function DUF3444', 'DUF3444', 3, NULL),
(26906, NULL, 'IPR028783', NULL, 'PRKAA2, UBA-like autoinhibitory domain', 'PRKAA2', 3, NULL),
(26907, NULL, 'IPR031517', NULL, 'RHEX-like', 'RHEX-like', 4, NULL),
(26908, NULL, 'IPR025980', NULL, 'ATP-sulfurylase PUA-like domain', 'ATP-Sase_PUA-like_dom', 3, NULL),
(26909, NULL, 'IPR029298', NULL, 'RFX5, C-terminal', 'RFX5_C', 3, NULL),
(26910, NULL, 'IPR031426', NULL, 'Protein of unknown function DUF4667', 'DUF4667', 4, NULL),
(26911, NULL, 'IPR028338', NULL, 'Thiamine transporter 1', 'ThTr-1', 4, NULL),
(26912, NULL, 'IPR026581', NULL, 'T-complex protein 10 family', 'TCP10_fam', 4, NULL),
(26913, NULL, 'IPR029444', NULL, 'Integrator complex subunit 5, C-terminal', 'INTS5_C', 3, NULL),
(26914, NULL, 'IPR026228', NULL, 'Mas-related G protein-coupled receptor F', 'MRGPCRF', 4, NULL),
(26915, NULL, 'IPR031950', NULL, '116kDa U5 small nuclear ribonucleoprotein component, N-terminal', 'EFTUD2_N', 3, NULL),
(26916, NULL, 'IPR029310', NULL, 'FANCI helical domain 1', 'FANCI_HD1', 3, NULL),
(26917, NULL, 'IPR024954', NULL, 'SSRP1, dimerization domain', 'SSRP1_DD', 3, NULL),
(26918, NULL, 'IPR028945', NULL, 'Get1 family', 'Get1', 4, NULL),
(26919, NULL, 'IPR030489', NULL, 'Transcription regulator Rrf2-type, conserved site', 'TR_Rrf2-type_CS', 2, NULL),
(26920, NULL, 'IPR030879', NULL, 'Ribonuclease J, archaea', 'RNase_J_arc', 4, NULL),
(26921, NULL, 'IPR032368', NULL, 'RPN13, DEUBAD domain', 'RPN13_DEUBAD', 3, NULL),
(26922, NULL, 'IPR030689', NULL, 'Cytochrome b', 'Cytochrome_b', 4, NULL),
(26923, NULL, 'IPR029243', NULL, 'Lantibiotic alpha component', 'Lantibiotic_alpha', 4, NULL),
(26924, NULL, 'IPR030655', NULL, 'NifH/chlL conserved site', 'NifH/chlL_CS', 2, NULL),
(26925, NULL, 'IPR032244', NULL, 'LapD/MoxY,  periplasmic domain', 'LapD_MoxY_N', 3, NULL),
(26926, NULL, 'IPR029485', NULL, 'Cationic amino acid transporter, C-terminal', 'CAT_C', 3, NULL),
(26927, NULL, 'IPR028269', NULL, 'AP-4 complex subunit epsilon-1, C-terminal', 'AP4E1_C', 3, NULL),
(26928, NULL, 'IPR031455', NULL, 'Genetic interactor of prohibitin 5', 'Gep5', 4, NULL),
(26929, NULL, 'IPR024613', NULL, 'Huntingtin, middle-repeat', 'Huntingtin_middle-repeat', 7, NULL),
(26930, NULL, 'IPR034128', NULL, 'K02A2.6-like peptidase catalytic domain', 'K02A2.6-like', 3, NULL),
(26931, NULL, 'IPR026904', NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG, C-terminal', 'MnmG_C', 3, NULL),
(26932, NULL, 'IPR030387', NULL, 'Bms1/Tsr1-type G domain', 'G_Bms1/Tsr1_dom', 3, NULL),
(26933, NULL, 'IPR034160', NULL, 'DNA gyrase subunit B, TOPRIM domain', 'TOPRIM_GyrB', 3, NULL),
(26934, NULL, 'IPR032719', NULL, 'Glycosyltransferase WbsX', 'WbsX', 4, NULL),
(26935, NULL, 'IPR027022', NULL, 'ABC transporter permease protein, BceB-type', 'ABC_permease_BceB-typ', 4, NULL),
(26936, NULL, 'IPR031875', NULL, 'Recombination enhancement, RecA-dependent nuclease', 'RecA_dep_nuc', 4, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(26937, NULL, 'IPR026912', NULL, 'Adenine deaminase C-terminal domain', 'Adenine_deam_C', 3, NULL),
(26938, NULL, 'IPR028054', NULL, 'Protein of unknown function DUF4481', 'DUF4481', 4, NULL),
(26939, NULL, 'IPR034042', NULL, 'PARN, R3H domain', 'PARN_R3H', 3, NULL),
(26940, NULL, 'IPR029209', NULL, 'DML1/Misato, tubulin domain', 'DML1/Misato_tubulin', 3, NULL),
(26941, NULL, 'IPR029248', NULL, 'Transmembrane protein 107', 'TMEM107', 4, NULL),
(26942, NULL, 'IPR028345', NULL, 'Aminoglycoside 3-N-acetyltransferase-like', 'Antibiotic_NAT-like', 5, NULL),
(26943, NULL, 'IPR028363', NULL, 'DNA-directed RNA polymerase, subunit  RPB6', 'RPB6', 4, NULL),
(26944, NULL, 'IPR024618', NULL, 'Domain of unknown function DUF3857', 'DUF3857', 3, NULL),
(26945, NULL, 'IPR026220', NULL, 'HTLV-1 basic zipper factor', 'HTLV1ZIPPER', 4, NULL),
(26946, NULL, 'IPR029212', NULL, 'Rho guanine nucleotide exchange factor 5/35, N-terminal', 'ARHGEF5/35_N', 3, NULL),
(26947, NULL, 'IPR031949', NULL, 'Domain of unknown function DUF4776', 'DUF4776', 3, NULL),
(26948, NULL, 'IPR027484', NULL, 'Phosphatidylinositol-4-phosphate 5-kinase, N-terminal', 'PInositol-4-P-5-kinase_N', 5, NULL),
(26949, NULL, 'IPR032694', NULL, 'Copper transport protein C/D', 'CopC/D', 4, NULL),
(26950, NULL, 'IPR029204', NULL, 'CB1 cannabinoid receptor-interacting protein 1', 'CNRIP1', 4, NULL),
(26951, NULL, 'IPR030880', NULL, 'DEAD-box ATP-dependent RNA helicase CshA', 'DEAD_helicase_CshA', 4, NULL),
(26952, NULL, 'IPR024314', NULL, 'Suppressor of fused C-terminal', 'SUFU_C', 3, NULL),
(26953, NULL, 'IPR031472', NULL, 'MAT1-1-2/MatA-2/Smr1', 'MAT1-1-2/MatA-2/Smr1', 4, NULL),
(26954, NULL, 'IPR032698', NULL, 'Protein SirB1, N-terminal', 'SirB1_N', 3, NULL),
(26955, NULL, 'IPR027643', NULL, 'Formin-like family, plant', 'Formin-like_plant', 4, NULL),
(26956, NULL, 'IPR024585', NULL, 'Domain of unknown function DUF3385,  target of rapamycin protein', 'DUF3385_TOR', 3, NULL),
(26957, NULL, 'IPR030388', NULL, 'Era-type guanine nucleotide-binding (G) domain', 'G_ERA_dom', 3, NULL),
(26958, NULL, 'IPR026888', NULL, 'Acetyl-CoA hydrolase/transferase C-terminal domain', 'AcetylCoA_hyd_C', 3, NULL),
(26959, NULL, 'IPR031888', NULL, 'Protein of unknown function DUF5068', 'DUF5068', 4, NULL),
(26960, NULL, 'IPR026919', NULL, 'Adhesion G-protein coupled receptor V1', 'ADGRV1', 4, NULL),
(26961, NULL, 'IPR024602', NULL, 'Conserved oligomeric Golgi complex, subunit 2, N-terminal', 'COG_su2_N', 3, NULL),
(26962, NULL, 'IPR029161', NULL, 'Spermatogenesis-associated protein 16', 'SPATA16', 4, NULL),
(26963, NULL, 'IPR024563', NULL, 'Uncharacterised protein family YqhR', 'YqhR', 4, NULL),
(26964, NULL, 'IPR036046', NULL, 'Acylphosphatase-like domain superfamily', 'Acylphosphatase-like_dom_sf', 5, NULL),
(26965, NULL, 'IPR027455', NULL, 'Spermine/spermidine acetyltransferase, N-terminal', 'Sper_AcTfrase_N', 5, NULL),
(26966, NULL, 'IPR029169', NULL, 'PEST proteolytic signal-containing nuclear protein', 'PCNP', 4, NULL),
(26967, NULL, 'IPR029190', NULL, 'Ribosomal RNA-processing protein 14/surfeit locus protein 6, C-terminal domain', 'Rrp14/SURF6_C', 3, NULL),
(26968, NULL, 'IPR029207', NULL, 'FAM198 family', 'FAM198', 4, NULL),
(26969, NULL, 'IPR028255', NULL, 'Centromere protein T', 'CENP-T', 4, NULL),
(26970, NULL, 'IPR031520', NULL, 'Protein of unknown function DUF4694', 'DUF4694', 4, NULL),
(26971, NULL, 'IPR029167', NULL, 'Meiotically up-regulated gene 117 protein', 'Mug117', 4, NULL),
(26972, NULL, 'IPR024599', NULL, 'Retinoblastoma-associated protein, N-terminal', 'RB_N', 3, NULL),
(26973, NULL, 'IPR029026', NULL, 'tRNA (guanine-N1-)-methyltransferase, N-terminal', 'tRNA_m1G_MTases_N', 5, NULL),
(26974, NULL, 'IPR029228', NULL, 'Alkyl sulfatase dimerisation domain', 'Alkyl_sulf_dimr', 3, NULL),
(26975, NULL, 'IPR029224', NULL, 'Pilus-assembly complex, chaperone PapJ', 'PapJ', 4, NULL),
(26976, NULL, 'IPR024953', NULL, 'Polyphosphate kinase middle domain', 'PP_kinase_middle', 3, NULL),
(26977, NULL, 'IPR032696', NULL, 'Squalene cyclase, C-terminal', 'SQ_cyclase_C', 3, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(26978, NULL, 'IPR029197', NULL, 'Cytoskeleton-associated protein 2, C-terminal', 'CKAP2_C', 3, NULL),
(26979, NULL, 'IPR024436', NULL, 'Domain of unknown function DUF3824', 'DUF3824', 3, NULL),
(26980, NULL, 'IPR026589', NULL, 'Cell division protein FtsP', 'FtsP', 4, NULL),
(26981, NULL, 'IPR035922', NULL, '3H domain superfamily', '3H_dom_sf', 5, NULL),
(26982, NULL, 'IPR027556', NULL, 'Heavy-Cys/GCP-CTERM domain protein', 'Heavy_Cys_GCP', 4, NULL),
(26983, NULL, 'IPR031524', NULL, 'Armadillo-like helical domain-containing protein 4', 'ARMH4', 4, NULL),
(26984, NULL, 'IPR026221', NULL, 'Mas-related G protein-coupled receptor H', 'MRGPCRH', 4, NULL),
(26985, NULL, 'IPR028347', NULL, 'START domain-containing protein', 'START_dom_prot', 4, NULL),
(26986, NULL, 'IPR024565', NULL, 'Orexigenic neuropeptide QRFP/P518', 'P518', 4, NULL),
(26987, NULL, 'IPR028205', NULL, 'Late cornified envelope protein', 'LCE', 4, NULL),
(26988, NULL, 'IPR029476', NULL, 'Deoxyribonuclease NucA/NucB', 'DNase_NucA_NucB', 4, NULL),
(26989, NULL, 'IPR029005', NULL, 'LIM-domain binding protein/SEUSS', 'LIM-bd/SEUSS', 4, NULL),
(26990, NULL, 'IPR029173', NULL, 'Transmembrane protein family 171', 'TMEM171', 4, NULL),
(26991, NULL, 'IPR026607', NULL, 'DMRT family', 'DMRT', 4, NULL),
(26992, NULL, 'IPR031881', NULL, 'Protein of unknown function DUF4761', 'DUF4761', 4, NULL),
(26993, NULL, 'IPR029244', NULL, 'FAM69, N-terminal', 'FAM69_N', 3, NULL),
(26994, NULL, 'IPR029184', NULL, 'Something about silencing protein 4 domain', 'Sas4_dom', 3, NULL),
(26995, NULL, 'IPR032689', NULL, 'TraD/TraG, TraM recognition site', 'TraG-D_C', 3, NULL),
(26996, NULL, 'IPR032241', NULL, 'Protein of unknown function DUF5042', 'DUF5042', 4, NULL),
(26997, NULL, 'IPR024587', NULL, 'Potassium channel, voltage dependent, Kv4, C-terminal', 'K_chnl_volt-dep_Kv4_C', 3, NULL),
(26998, NULL, 'IPR027538', NULL, 'Get 1, fungi', 'Get1_fungi', 4, NULL),
(26999, NULL, 'IPR029313', NULL, 'FANCI solenoid 3 domain', 'FANCI_S3', 3, NULL),
(27000, NULL, 'IPR030881', NULL, 'DEAD-box ATP-dependent RNA helicase CshB', 'CshB', 4, NULL),
(27001, NULL, 'IPR035397', NULL, 'CT_584-like', 'CT_584-like', 4, NULL),
(27002, NULL, 'IPR040079', NULL, 'Glutathione transferase family', 'Glutathione_S-Trfase', 4, NULL),
(27003, NULL, 'IPR035390', NULL, 'Thiol-activated cytolysin C-terminal', 'Thiol_cytolys_C', 3, NULL),
(27004, NULL, 'IPR036640', NULL, 'ABC transporter type 1, transmembrane domain superfamily', 'ABC1_TM_sf', 5, NULL),
(27005, NULL, 'IPR037465', NULL, 'YlxR', 'YlxR', 4, NULL),
(27006, NULL, 'IPR039891', NULL, 'von Willebrand factor A domain-containing protein 8', 'VWA8', 4, NULL),
(27007, NULL, 'IPR039298', NULL, 'Acyl-coenzyme A thioesterase 13', 'ACOT13', 4, NULL),
(27008, NULL, 'IPR039633', NULL, 'Plastid-lipid-associated protein', 'PAP', 4, NULL),
(27009, NULL, 'IPR040131', NULL, 'MnmG, N-terminal domain', 'MnmG_N', 3, NULL),
(27010, NULL, 'IPR034969', NULL, 'hnRNPH3, RNA recognition motif 3', 'hnRNPH3_RRM3', 3, NULL),
(27011, NULL, 'IPR039309', NULL, 'Biopterin transporter family', 'BT1', 4, NULL),
(27012, NULL, 'IPR039923', NULL, 'Protodermal factor 1', 'Protodermal_1', 4, NULL),
(27013, NULL, 'IPR038516', NULL, 'AAR2, N-terminal domain superfamily', 'AAR2_N_sf', 5, NULL),
(27014, NULL, 'IPR038254', NULL, 'DNA/RNA-binding protein KIN17, WH-like domain superfamily', 'KIN17_WH-like_sf', 5, NULL),
(27015, NULL, 'IPR037025', NULL, 'Photosystem II cytochrome b559, alpha subunit superfamily', 'PSII_cyt_b559_asu_sf', 5, NULL),
(27016, NULL, 'IPR040555', NULL, 'Cas9, PI domain', 'Cas9_PI2', 3, NULL),
(27017, NULL, 'IPR040562', NULL, 'Prim-pol 4', 'PPL4', 4, NULL),
(27018, NULL, 'IPR040547', NULL, 'Immunity protein CdiI', 'CdiI', 4, NULL),
(27019, NULL, 'IPR040271', NULL, 'Uncharacterized protein T19C3.2-like', 'T19C3.2-like', 4, NULL),
(27020, NULL, 'IPR040023', NULL, 'WW domain-binding protein 4', 'WBP4', 4, NULL),
(27021, NULL, 'IPR038929', NULL, 'Coiled-coil domain-containing protein 13', 'CCDC13', 4, NULL),
(27022, NULL, 'IPR039887', NULL, 'IQ domain-containing protein F', 'IQCF', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(27023, NULL, 'IPR039561', NULL, 'Peptidase M15C', 'Peptidase_M15C', 3, NULL),
(27024, NULL, 'IPR033473', NULL, 'Protein FAM214, C-terminal', 'FAM214_C', 3, NULL),
(27025, NULL, 'IPR039640', NULL, 'Stomatal closure-related actin-binding protein', 'SCAB', 4, NULL),
(27026, NULL, 'IPR040205', NULL, 'HIN-200 family', 'HIN-200', 4, NULL),
(27027, NULL, 'IPR040134', NULL, '26S Proteasome non-ATPase regulatory subunit 12/COP9 signalosome complex subunit 4', 'PSMD12/CSN4', 4, NULL),
(27028, NULL, 'IPR039631', NULL, 'Leucine-rich repeat-containing protein 42', 'LRRC42', 4, NULL),
(27029, NULL, 'IPR034231', NULL, 'Ephrin type-B receptor 1, ligand binding domain', 'EphB1_rcpt_lig-bd', 3, NULL),
(27030, NULL, 'IPR039253', NULL, 'Aprataxin and PNK-like factor', 'APLF', 4, NULL),
(27031, NULL, 'IPR038259', NULL, 'Tmem141 superfamily', 'Tmem141_sf', 5, NULL),
(27032, NULL, 'IPR035836', NULL, 'ASAP1-like, SH3 domain', 'ASAP1-like_SH3', 3, NULL),
(27033, NULL, 'IPR036092', NULL, 'Small/middle T-antigen superfamily', 'Papo_T_antigensf', 5, NULL),
(27034, NULL, 'IPR033391', NULL, 'Fructose-1-6-bisphosphatase class I, N-terminal', 'FBPase_N', 3, NULL),
(27035, NULL, 'IPR037863', NULL, 'Rho GTPase-activating protein 6/36', 'RHOGAP6/36', 4, NULL),
(27036, NULL, 'IPR040015', NULL, 'UBL3-like', 'UBL3-like', 4, NULL),
(27037, NULL, 'IPR040050', NULL, 'Zinc finger protein 830-like', 'ZNF830-like', 4, NULL),
(27038, NULL, 'IPR036191', NULL, 'RRF superfamily', 'RRF_sf', 5, NULL),
(27039, NULL, 'IPR037026', NULL, 'Vgr protein, OB-fold domain superfamily', 'Vgr_OB-fold_dom_sf', 5, NULL),
(27040, NULL, 'IPR037544', NULL, 'Cyanide hydratase', 'CN_hydrolase', 4, NULL),
(27041, NULL, 'IPR037734', NULL, 'Thylakoid lumenal 17.9kDa protein', 'Thylakoid_lumenal_17.9', 4, NULL),
(27042, NULL, 'IPR038253', NULL, 'SRP68, N-terminal domain superfamily', 'SRP68_N_sf', 5, NULL),
(27043, NULL, 'IPR036096', NULL, 'Ataxin, AXH domain superfamily', 'Ataxin_AXH_dom_sf', 5, NULL),
(27044, NULL, 'IPR040032', NULL, 'DENN domain-containing protein 1A/1B/1C', 'DENND1A/B/C', 4, NULL),
(27045, NULL, 'IPR038914', NULL, 'DDB1- and CUL4-associated factor 15', 'DCAF15', 4, NULL),
(27046, NULL, 'IPR036100', NULL, 'S-adenosylmethionine:tRNA ribosyltransferase-isomerase,  QueA superfamily', 'QueA_sf', 5, NULL),
(27047, NULL, 'IPR038916', NULL, 'Protein FAM118', 'FAM118', 4, NULL),
(27048, NULL, 'IPR037738', NULL, 'Protein Ecm13-like', 'Ecm13-like', 4, NULL),
(27049, NULL, 'IPR038396', NULL, 'SpoIIAA-like superfamily', 'SpoIIAA-like_sf', 5, NULL),
(27050, NULL, 'IPR039662', NULL, 'Cohesin subunit Scc3/SA', 'Cohesin_Scc3/SA', 4, NULL),
(27051, NULL, 'IPR039777', NULL, 'Interferon-related developmental regulator', 'IFRD', 4, NULL),
(27052, NULL, 'IPR039729', NULL, 'DNA fragmentation factor 40', 'DFF40', 4, NULL),
(27053, NULL, 'IPR038385', NULL, 'Threonylcarbamoyl-AMP synthase, C-terminal domain superfamily', 'Sua5/YwlC_C', 5, NULL),
(27054, NULL, 'IPR038255', NULL, 'Phycobilisome linker domain superfamily', 'PBS_linker_sf', 5, NULL),
(27055, NULL, 'IPR036627', NULL, 'CobW-like, C-terminal domain superfamily', 'CobW-likC_sf', 5, NULL),
(27056, NULL, 'IPR038649', NULL, 'Exonuclease I, SH3-like domain superfamily', 'EXOI_SH3_sf', 5, NULL),
(27057, NULL, 'IPR040546', NULL, 'Rege-1, UBA-like domain', 'Rege-1_UBA-like', 3, NULL),
(27058, NULL, 'IPR039076', NULL, 'Cell division protein DivIC', 'DivIC', 4, NULL),
(27059, NULL, 'IPR038262', NULL, 'Nitrate reductase beta, C-terminal domain superfamily', 'Nitr_red_bet_C_sf', 5, NULL),
(27060, NULL, 'IPR039843', NULL, 'KxDL motif-containing protein 1-like', 'KXD1-like', 4, NULL),
(27061, NULL, 'IPR037089', NULL, 'Methylene-tetrahydromethanopterin dehydrogenase, N-terminal domain superfamily', 'Methyl-teptahyd_DH_N_sf', 5, NULL),
(27062, NULL, 'IPR040251', NULL, 'Protein transport protein SEC31-like', 'SEC31-like', 4, NULL),
(27063, NULL, 'IPR039543', NULL, 'Lipid-binding protein POX18/UbiT/NSL-TP1', 'POX18/UbiT/NSL-TP1', 4, NULL),
(27064, NULL, 'IPR040110', NULL, 'PINK1, protein kinase domain', 'PINK1_STKc', 3, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(27065, NULL, 'IPR040111', NULL, 'Outer dynein arm-docking complex subunit 4', 'ODAD4', 4, NULL),
(27066, NULL, 'IPR033247', NULL, 'Transketolase family', 'Transketolase_fam', 4, NULL),
(27067, NULL, 'IPR037524', NULL, 'PA14/GLEYA domain', 'PA14/GLEYA', 3, NULL),
(27068, NULL, 'IPR037483', NULL, 'YjjU-like', 'YjjU-like', 4, NULL),
(27069, NULL, 'IPR036034', NULL, 'PDZ superfamily', 'PDZ_sf', 5, NULL),
(27070, NULL, 'IPR037232', NULL, 'NADH:ubiquinone oxidoreductase, 30kDa subunit superfamily', 'NADH_quin_OxRdtase_su_C/D-like', 5, NULL),
(27071, NULL, 'IPR037435', NULL, '14-3-3 protein sigma', '14-3-3_sigma', 4, NULL),
(27072, NULL, 'IPR039847', NULL, 'RING finger protein 37', 'Ubox5', 4, NULL),
(27073, NULL, 'IPR036634', NULL, 'PRD domain superfamily', 'PRD_sf', 5, NULL),
(27074, NULL, 'IPR037525', NULL, 'Velvet domain', 'Velvet_dom', 3, NULL),
(27075, NULL, 'IPR037481', NULL, 'Protein LacX', 'LacX', 4, NULL),
(27076, NULL, 'IPR036070', NULL, 'Nop domain superfamily', 'Nop_dom_sf', 5, NULL),
(27077, NULL, 'IPR037878', NULL, 'Sperm acrosome membrane-associated protein 1', 'SPACA1', 4, NULL),
(27078, NULL, 'IPR037977', NULL, 'Afadin, cargo binding domain', 'CBD_Afadin', 3, NULL),
(27079, NULL, 'IPR040020', NULL, 'Uncharacterized protein C13orf46-like', 'C13orf46-like', 4, NULL),
(27080, NULL, 'IPR036038', NULL, 'Aminotransferase-like, PLP-dependent enzymes', 'Aminotransferase-like', 5, NULL),
(27081, NULL, 'IPR039251', NULL, 'Oxidoreductase-like domain-containing protein 1', 'OXLD1', 4, NULL),
(27082, NULL, 'IPR039089', NULL, 'Immunoglobulin superfamily member 6', 'IGSF6', 4, NULL),
(27083, NULL, 'IPR039905', NULL, 'CD2 antigen cytoplasmic tail-binding protein 2/Lin1', 'CD2BP2/Lin1', 4, NULL),
(27084, NULL, 'IPR039926', NULL, 'Protein egg apparatus-1', 'Egg_app_1', 4, NULL),
(27085, NULL, 'IPR040115', NULL, 'Lunapark family', 'Lnp', 4, NULL),
(27086, NULL, 'IPR038260', NULL, 'Vps53, C-terminal domain superfamily', 'Vps53_C_sf', 5, NULL),
(27087, NULL, 'IPR037029', NULL, 'Alliinase, N-terminal domain superfamily', 'Alliinase_N_sf', 5, NULL),
(27088, NULL, 'IPR039095', NULL, 'Transcription factor 19, PHD finger', 'TCF19_PHD', 3, NULL),
(27089, NULL, 'IPR040004', NULL, 'Single-pass membrane and coiled-coil domain-containing protein 3', 'SMCO3', 4, NULL),
(27090, NULL, 'IPR040002', NULL, 'U6 snRNA-associated Sm-like protein Lsm3', 'Sm-like_LSM3', 4, NULL),
(27091, NULL, 'IPR039249', NULL, 'G patch domain-containing protein 11', 'GPATCH11', 4, NULL),
(27092, NULL, 'IPR040155', NULL, 'CEBPZ/Mak21-like', 'CEBPZ/Mak21-like', 4, NULL),
(27093, NULL, 'IPR040165', NULL, 'Delta(24)-sterol reductase', 'Diminuto-like', 4, NULL),
(27094, NULL, 'IPR034966', NULL, 'CCR4-NOT transcription complex subunit 6', 'Cnot6', 3, NULL),
(27095, NULL, 'IPR038925', NULL, 'UV-B-induced protein At3g17800-like', 'At3g17800-like', 4, NULL),
(27096, NULL, 'IPR039524', NULL, 'GPI ethanolamine phosphate transferase 3', 'PIGO/GPI13', 4, NULL),
(27097, NULL, 'IPR039324', NULL, 'Protein SHORT HYPOCOTYL IN WHITE LIGHT 1', 'SHW1', 4, NULL),
(27098, NULL, 'IPR040175', NULL, 'Methylcytosine dioxygenase TET1/2/3', 'TET1/2/3', 4, NULL),
(27099, NULL, 'IPR034970', NULL, 'hnRNPH3, RNA recognition motif 2', 'hnRNPH3_RRM2', 3, NULL),
(27100, NULL, 'IPR040550', NULL, 'Prim-pol family 5', 'PPL5', 4, NULL),
(27101, NULL, 'IPR040346', NULL, 'GEX1/Brambleberry', 'GEX1/Brambleberry', 4, NULL),
(27102, NULL, 'IPR037893', NULL, 'Calcyclin-binding Protein, CS domain', 'CS_CacyBP', 3, NULL),
(27103, NULL, 'IPR035835', NULL, 'SH3 domain-containing protein 19, SH3 domain 3', 'Eve1_SH3_3', 3, NULL),
(27104, NULL, 'IPR040259', NULL, 'Mesogenin/MesP', 'Mesogenin/MesP', 4, NULL),
(27105, NULL, 'IPR039889', NULL, 'Coiled-coil domain-containing protein 33', 'CCD33', 4, NULL),
(27106, NULL, 'IPR039769', NULL, '18S rRNA (guanine(1575)-N(7))-methyltransferase Bud23-like', 'Bud23-like', 4, NULL),
(27107, NULL, 'IPR039573', NULL, 'NS2A-like', 'NS2A-like', 3, NULL),
(27108, NULL, 'IPR039060', NULL, 'Antitoxin HigA', 'Antitox_HigA', 4, NULL),
(27109, NULL, 'IPR037907', NULL, 'Vps17, PX domain', 'Vps17_PX', 3, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(27110, NULL, 'IPR039308', NULL, 'Growth arrest-specific protein 8', 'GAS8', 4, NULL),
(27111, NULL, 'IPR039680', NULL, 'Pleckstrin homology domain-containing family B member 1/2', 'PLEKHB1/2', 4, NULL),
(27112, NULL, 'IPR039063', NULL, 'Riboflavin kinase, CTP-dependent', 'RibK_CTP-dep', 4, NULL),
(27113, NULL, 'IPR037595', NULL, 'Reversibly glycosylated polypeptide family', 'RGP_fam', 4, NULL),
(27114, NULL, 'IPR038024', NULL, 'SPy1572-like superfamily', 'SPy1572-like_sf', 5, NULL),
(27115, NULL, 'IPR039630', NULL, 'Protein FAM149', 'FAM149', 4, NULL),
(27116, NULL, 'IPR038630', NULL, 'Ribosomal protein L24e/L24 superfamily', 'L24e/L24_sf', 5, NULL),
(27117, NULL, 'IPR039913', NULL, 'RNA polymerase II-associated protein RPAP1/Rba50', 'RPAP1/Rba50', 4, NULL),
(27118, NULL, 'IPR039641', NULL, 'Low-molecular-weight cysteine-rich protein', 'LCR', 4, NULL),
(27119, NULL, 'IPR038224', NULL, 'SATB, ULD domain superfamily', 'SATB_ULD_sf', 5, NULL),
(27120, NULL, 'IPR036071', NULL, 'AMMECR1 domain superfamily', 'AMMECR1_dom_sf', 5, NULL),
(27121, NULL, 'IPR039390', NULL, 'Hydroxyquinol/catechol  1,2-dioxygenase', '1_2-HQD/HQD', 4, NULL),
(27122, NULL, 'IPR039015', NULL, 'Endonuclease domain-containing 1 protein', 'ENDOD1', 4, NULL),
(27123, NULL, 'IPR040154', NULL, 'Biotinidase/VNN family', 'Biotinidase/VNN', 4, NULL),
(27124, NULL, 'IPR040128', NULL, 'Uncharacterized protein T25E4.2-like', 'T25E4.2-like', 4, NULL),
(27125, NULL, 'IPR036026', NULL, 'Seven-hairpin glycosidases', 'Seven-hairpin_glycosidases', 5, NULL),
(27126, NULL, 'IPR033393', NULL, 'Nuclear receptor-binding factor 2, MIT domain', 'NRBF2_MIT', 3, NULL),
(27127, NULL, 'IPR040343', NULL, 'RNA 5''-triphosphatase Cet1/Ctl1', 'Cet1/Ctl1', 4, NULL),
(27128, NULL, 'IPR037031', NULL, 'Succinylarginine dihydrolase superfamily', 'AstB_sf', 5, NULL),
(27129, NULL, 'IPR039311', NULL, 'FAM187A/B', 'FAM187A/B', 4, NULL),
(27130, NULL, 'IPR036276', NULL, 'T4 RNase H, C-terminal', 'T4_RNaseH_C', 3, NULL),
(27131, NULL, 'IPR038221', NULL, 'YidC, periplasmic domain superfamily', 'YidC_periplasmic_sf', 5, NULL),
(27132, NULL, 'IPR036102', NULL, 'OsmC/Ohr superfamily', 'OsmC/Ohrsf', 5, NULL),
(27133, NULL, 'IPR039570', NULL, 'AmiC, periplasmic binding domain', 'AmiC_PBP1', 3, NULL),
(27134, NULL, 'IPR034238', NULL, 'Ephrin type-B receptor 2, ligand binding domain', 'EphB2_rcpt_lig-bd', 3, NULL),
(27135, NULL, 'IPR036028', NULL, 'SH3-like domain superfamily', 'SH3-like_dom_sf', 5, NULL),
(27136, NULL, 'IPR039620', NULL, 'BKI1/Probable membrane-associated kinase regulator 1/3/4', 'BKI1/MAKR1/3/4', 4, NULL),
(27137, NULL, 'IPR039842', NULL, 'TBC1 domain family member 7', 'TBC1D7', 4, NULL),
(27138, NULL, 'IPR039845', NULL, 'PSME3-interacting protein', 'FAM192A', 4, NULL),
(27139, NULL, 'IPR037865', NULL, 'Active breakpoint cluster region-related protein, PH domain', 'ABR_PH', 3, NULL),
(27140, NULL, 'IPR037471', NULL, 'Protein TIC56', 'TIC56', 4, NULL),
(27141, NULL, 'IPR039566', NULL, 'Conserved virulence factor B, S1 domain', 'CvfB_S1', 3, NULL),
(27142, NULL, 'IPR038393', NULL, 'L-fucose isomerase, domain 3 superfamily', 'Fuc_iso_dom3_sf', 5, NULL),
(27143, NULL, 'IPR039663', NULL, 'AIP/AIPL1/TTC9', 'AIP/AIPL1/TTC9', 4, NULL),
(27144, NULL, 'IPR040211', NULL, 'Small EDRK-rich factor 1/2', 'SERF1/2', 4, NULL),
(27145, NULL, 'IPR038919', NULL, 'Stb2/Stb6', 'Stb2/Stb6', 4, NULL),
(27146, NULL, 'IPR039302', NULL, 'Microtubule associated protein 10', 'MAP10', 4, NULL),
(27147, NULL, 'IPR033873', NULL, 'CND41-like', 'CND41-like', 3, NULL),
(27148, NULL, 'IPR039637', NULL, 'CCR4-NOT transcription complex subunit 7/8/Pop2', 'CNOT7/CNOT8/Pop2', 4, NULL),
(27149, NULL, 'IPR040049', NULL, '28S ribosomal protein S25, mitochondrial', 'MRPS25', 4, NULL),
(27150, NULL, 'IPR037533', NULL, 'Matrix protein 1', 'INFV_M1', 4, NULL),
(27151, NULL, 'IPR039958', NULL, 'RING1 and YY1-binding protein/YY1-associated factor 2', 'RYBP/YAF2', 4, NULL),
(27152, NULL, 'IPR037386', NULL, 'Coiled-coil domain-containing protein 40', 'CCDC40', 4, NULL),
(27153, NULL, 'IPR038014', NULL, 'Ino80 subunit 1', 'Ies1', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(27154, NULL, 'IPR039607', NULL, 'VQ motif-containing protein 8/17/18/20/21/25', 'VQ_8/17/18/20/21/25', 4, NULL),
(27155, NULL, 'IPR040553', NULL, 'Toxoflavin-degrading enzyme', 'TxDE', 3, NULL),
(27156, NULL, 'IPR039655', NULL, 'HMG box-containing protein 1', 'HBP1', 4, NULL),
(27157, NULL, 'IPR039667', NULL, 'Dolichyldiphosphatase, PAP2 domain', 'Dolichyldiphosphatase_PAP2', 3, NULL),
(27158, NULL, 'IPR040290', NULL, 'Protein E6-like', 'Prot_E6-like', 4, NULL),
(27159, NULL, 'IPR039321', NULL, 'Increased DNA methylation 2/3-like', 'IDM2/3-like', 4, NULL),
(27160, NULL, 'IPR039307', NULL, 'GPI-anchored protein LORELEI-like', 'LORELEI-like', 4, NULL),
(27161, NULL, 'IPR039363', NULL, 'Zinc finger protein 750', 'ZNF750', 4, NULL),
(27162, NULL, 'IPR036774', NULL, 'ERV/ALR sulfhydryl oxidase domain superfamily', 'ERV/ALR_sulphydryl_oxid_sf', 5, NULL),
(27163, NULL, 'IPR039669', NULL, 'TRAF family member-associated NF-kappa-B activator', 'TANK', 4, NULL),
(27164, NULL, 'IPR039799', NULL, 'Sulfhydryl oxidase ALR/ERV', 'ALR/ERV', 4, NULL),
(27165, NULL, 'IPR037496', NULL, 'BEN domain-containing protein 6-like', 'BEND6-like', 4, NULL),
(27166, NULL, 'IPR038926', NULL, 'Centrosomal protein of 55kDa', 'CEP55', 4, NULL),
(27167, NULL, 'IPR040019', NULL, 'Uncharacterized protein C27D6.3-like', 'C27D6.3-like', 4, NULL),
(27168, NULL, 'IPR039610', NULL, 'VQ motif-containing protein 29', 'VQ29', 4, NULL),
(27169, NULL, 'IPR039646', NULL, 'Zinc finger HIT domain-containing protein 2', 'ZNHIT2', 4, NULL),
(27170, NULL, 'IPR037455', NULL, 'Aerobactin siderophore biosynthesis, IucA/IucC-like', 'LucA/IucC-like', 4, NULL),
(27171, NULL, 'IPR037739', NULL, 'Uncharacterized protein C6orf141', 'C6orf141', 4, NULL),
(27172, NULL, 'IPR035652', NULL, 'RasGAP, SH3 domain', 'RasGAP_SH3', 3, NULL),
(27173, NULL, 'IPR037174', NULL, 'Trimeric adhesin', 'Trimeric_adhesin', 5, NULL),
(27174, NULL, 'IPR039664', NULL, 'GRB/APBB1IP', 'GRB/APBB1IP', 4, NULL),
(27175, NULL, 'IPR040132', NULL, 'TREX component Tex1/THOC3', 'Tex1/THOC3', 4, NULL),
(27176, NULL, 'IPR039415', NULL, 'Ubiquitin-like protein FUBI', 'FUBI', 3, NULL),
(27177, NULL, 'IPR037531', NULL, 'Protein P', 'HBV_DPOL', 4, NULL),
(27178, NULL, 'IPR039963', NULL, 'Uncharacterized 22kDa protein in aldolase locus', 'Unchar_22kDa', 4, NULL),
(27179, NULL, 'IPR035539', NULL, 'Protein of unknown function DUF5387', 'DUF5387', 4, NULL),
(27180, NULL, 'IPR040307', NULL, '50S ribosomal protein 5, chloroplastic', '50S_RP', 4, NULL),
(27181, NULL, 'IPR040045', NULL, 'Cytoplasmic dynein 2 light intermediate chain 1', 'DYNC2LI1', 4, NULL),
(27182, NULL, 'IPR040261', NULL, 'Protein FAM240', 'FAM240', 4, NULL),
(27183, NULL, 'IPR039608', NULL, 'VQ motif-containing protein 1/10', 'VQ_1/10', 4, NULL),
(27184, NULL, 'IPR039621', NULL, 'Protein BIG GRAIN 1-like', 'BG1-like', 4, NULL),
(27185, NULL, 'IPR033031', NULL, 'Scc2/Nipped-B family', 'Scc2/Nipped-B', 4, NULL),
(27186, NULL, 'IPR036101', NULL, 'CarD-like/TRCF, RNAP-interacting domain superfamily', 'CarD-like/TRCF_RID_sf', 5, NULL),
(27187, NULL, 'IPR039387', NULL, 'Protocatechuate 3,4-dioxygenase', '3_4-PCD', 4, NULL),
(27188, NULL, 'IPR039635', NULL, 'Endoplasmic reticulum membrane-associated RNA degradation protein', 'ERMARD', 4, NULL),
(27189, NULL, 'IPR038640', NULL, 'Benzylsuccinate synthase gamma subunit superfamily', 'BssC_sf', 5, NULL),
(27190, NULL, 'IPR040467', NULL, 'CCDC66 domain', 'CCDC66_dom', 3, NULL),
(27191, NULL, 'IPR033899', NULL, 'CXC Chemokine domain', 'CXC_Chemokine_domain', 3, NULL),
(27192, NULL, 'IPR039602', NULL, 'Transcriptional regulatory protein Rxt2', 'Rxt2', 4, NULL),
(27193, NULL, 'IPR037874', NULL, 'Cdc42', 'Cdc42', 4, NULL),
(27194, NULL, 'IPR035834', NULL, 'SH3 domain-containing protein 19, SH3 domain 1', 'Eve1_SH3_1', 3, NULL),
(27195, NULL, 'IPR038392', NULL, 'L-fucose isomerase, domain 2 superfamily', 'Fucose_isomerase_dom2_sf', 5, NULL),
(27196, NULL, 'IPR039299', NULL, 'Protein SIEVE ELEMENT OCCLUSION', 'SEOA', 4, NULL),
(27197, NULL, 'IPR039846', NULL, 'Zinc finger CCHC domain-containing protein 4', 'ZCCHC4', 4, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(27198, NULL, 'IPR033394', NULL, 'Svf1-like, C-terminal', 'Svf1-like_C', 3, NULL),
(27199, NULL, 'IPR039615', NULL, 'Protein PHYTOCHROME KINASE SUBSTRATE', 'PKS', 4, NULL),
(27200, NULL, 'IPR040164', NULL, 'High mobility group nucleosome-binding domain-containing protein 5', 'HMGN5', 4, NULL),
(27201, NULL, 'IPR038402', NULL, 'Restriction endonuclease, type II, PvuII superfamily', 'PvuII_sf', 5, NULL),
(27202, NULL, 'IPR040065', NULL, 'Protein LZIC', 'LZIC', 4, NULL),
(27203, NULL, 'IPR038982', NULL, 'NrpR repressor', 'NrpR', 4, NULL),
(27204, NULL, 'IPR037892', NULL, 'SNX14, RGS domain', 'SNX14_RGS', 3, NULL),
(27205, NULL, 'IPR039306', NULL, 'Myosin-binding protein', 'MYOB', 4, NULL),
(27206, NULL, 'IPR039770', NULL, 'Ribosome biogenesis protein Rpf2', 'Rpf2', 4, NULL),
(27207, NULL, 'IPR039612', NULL, 'VQ motif-containing protein 5/9/14', 'VQ_5/9/14', 4, NULL),
(27208, NULL, 'IPR033734', NULL, 'Jacalin-like lectin domain, plant', 'Jacalin-like_lectin_dom_plant', 3, NULL),
(27209, NULL, 'IPR039634', NULL, 'Bul1-like', 'Bul1-like', 4, NULL),
(27210, NULL, 'IPR036095', NULL, 'PTS system IIB component-like superfamily', 'PTS_EIIB-like_sf', 5, NULL),
(27211, NULL, 'IPR039772', NULL, 'RNA methyltransferase Bin3-like', 'Bin3-like', 4, NULL),
(27212, NULL, 'IPR039861', NULL, 'Interphotoreceptor matrix proteoglycan', 'IMPG', 4, NULL),
(27213, NULL, 'IPR038915', NULL, 'Proline-rich protein 29-like', 'PRR29-like', 4, NULL),
(27214, NULL, 'IPR036025', NULL, 'tRNA-splicing ligase RtcB-like superfamily', 'RtcB-like_sf', 5, NULL),
(27215, NULL, 'IPR039606', NULL, 'Phytol/farnesol kinase', 'Phytol/farnesol_kinase', 4, NULL),
(27216, NULL, 'IPR038398', NULL, 'NAB co-repressor domain 2 superfamily', 'NCD2_sf', 5, NULL),
(27217, NULL, 'IPR039885', NULL, 'BTBD10/KCTD20, BTB/POZ domain', 'BTBD10/KCTD20_BTB/POZ', 3, NULL),
(27218, NULL, 'IPR038920', NULL, 'BTB/POZ domain-containing protein', 'BTB/POZ_dom_prot', 4, NULL),
(27219, NULL, 'IPR040035', NULL, 'Transmembrane protein 180', 'TMEM180', 4, NULL),
(27220, NULL, 'IPR039661', NULL, 'ELP3/YhcC', 'ELP3', 4, NULL),
(27221, NULL, 'IPR036190', NULL, 'Urocanase superfamily', 'Urocanase_sf', 5, NULL),
(27222, NULL, 'IPR040156', NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase', 'ETF-QO', 4, NULL),
(27223, NULL, 'IPR039391', NULL, 'Phytocyanin', 'Phytocyanin', 4, NULL),
(27224, NULL, 'IPR039759', NULL, 'Eukaryotic translation initiation factor 2D, SUI1 domain', 'eIF2D_SUI1', 3, NULL),
(27225, NULL, 'IPR039310', NULL, 'UBA-like domain-containing protein 1/2', 'UBALD1/2', 4, NULL),
(27226, NULL, 'IPR040444', NULL, 'PCNA-associated factor', 'PCNA-AF', 4, NULL),
(27227, NULL, 'IPR039087', NULL, 'Deubiquitinating protein VCPIP1', 'VCPIP1', 4, NULL),
(27228, NULL, 'IPR039763', NULL, 'Damage-control phosphatase ARMT1', 'ARMT1', 4, NULL),
(27229, NULL, 'IPR037872', NULL, 'Rab3', 'Rab3', 4, NULL),
(27230, NULL, 'IPR040559', NULL, 'tRNA nuclease CdiA, C-terminal', 'CdiA_C', 3, NULL),
(27231, NULL, 'IPR040022', NULL, 'Uncharacterized protein C9orf153-like', 'C9orf153-like', 4, NULL),
(27232, NULL, 'IPR039313', NULL, 'Protein HEAT INTOLERANT 4', 'HIT4', 4, NULL),
(27233, NULL, 'IPR039580', NULL, 'Transcriptional and immune response regulator', 'Tcim', 4, NULL),
(27234, NULL, 'IPR038025', NULL, 'Antitoxin CbeA superfamily', 'CbeA_sf', 5, NULL),
(27235, NULL, 'IPR039300', NULL, 'Protein JASON', 'JASON', 4, NULL),
(27236, NULL, 'IPR039316', NULL, 'CLAVATA3/ESR (CLE)-related protein 25/26', 'CLE25/26', 4, NULL),
(27237, NULL, 'IPR040181', NULL, 'Pleckstrin homology domain-containing family G member 5/7', 'PKHG5/7', 4, NULL),
(27238, NULL, 'IPR036093', NULL, 'NAC domain superfamily', 'NAC_dom_sf', 5, NULL),
(27239, NULL, 'IPR038520', NULL, 'Matrix protein superfamily', 'BDV_M_sf', 5, NULL),
(27240, NULL, 'IPR039962', NULL, 'Uncharacterized protein ZC21.8', 'ZC21.8', 4, NULL),
(27241, NULL, 'IPR039629', NULL, 'R3H domain-containing protein 4', 'R3HDM4', 4, NULL),
(27242, NULL, 'IPR039093', NULL, 'Protein XRP2', 'XRP2', 4, NULL),
(27243, NULL, 'IPR039798', NULL, 'Sulfhydryl oxidase', 'Sulfhydryl_oxidase', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(27244, NULL, 'IPR037024', NULL, '[NiFe]-hydrogenase, small subunit, N-terminal domain superfamily', 'NiFe_Hase_small_N_sf', 5, NULL),
(27245, NULL, 'IPR039626', NULL, 'Nucleolar protein 7', 'NOL7', 4, NULL),
(27246, NULL, 'IPR039884', NULL, 'Coiled-coil domain-containing protein R3HC1/R3HCL', 'R3HC1/R3HCL', 4, NULL),
(27247, NULL, 'IPR040283', NULL, 'Transmembrane protein DDB_G0292058-like', 'DDB_G0292058-like', 4, NULL),
(27248, NULL, 'IPR040348', NULL, 'Protein POLAR-like', 'POLAR-like', 4, NULL),
(27249, NULL, 'IPR039840', NULL, 'N-alpha-acetyltransferase 80', 'NAA80', 4, NULL),
(27250, NULL, 'IPR040266', NULL, 'TMF-regulated nuclear protein 1', 'TRNP1', 4, NULL),
(27251, NULL, 'IPR039539', NULL, 'Ras GTPase-activating protein-binding protein', 'Ras_GTPase_bind_prot', 4, NULL),
(27252, NULL, 'IPR039618', NULL, 'CLAVATA3/ESR (CLE)-related protein 9/10/11/12/13', 'CLE9/10/11/12/13', 4, NULL),
(27253, NULL, 'IPR039648', NULL, 'Pyridine nucleotide-disulphide oxidoreductase, N-terminal', 'DHPH_N', 3, NULL),
(27254, NULL, 'IPR039322', NULL, 'MOM1', 'MOM1', 4, NULL),
(27255, NULL, 'IPR040127', NULL, 'Uncharacterized protein C16orf45-like', 'C16orf45-like', 4, NULL),
(27256, NULL, 'IPR039928', NULL, 'LNK family', 'LNK', 4, NULL),
(27257, NULL, 'IPR036036', NULL, 'SOCS box-like domain superfamily', 'SOCS_box-like_dom_sf', 5, NULL),
(27258, NULL, 'IPR039614', NULL, 'Protein PLASTID MOVEMENT IMPAIRED 1-like', 'PMI1-like', 4, NULL),
(27259, NULL, 'IPR039801', NULL, 'Epidermal growth factor receptor kinase substrate 8-like', 'EPS8-like', 4, NULL),
(27260, NULL, 'IPR040270', NULL, 'Microtubule-associated protein, Trypanosoma', 'Microtub-assoc_Trypanosoma', 4, NULL),
(27261, NULL, 'IPR039624', NULL, 'Late embryogenesis abundant protein 1/2/D7', 'LEA1/2/D7', 4, NULL),
(27262, NULL, 'IPR039914', NULL, 'Signal recognition particle SRP9', 'SRP9', 4, NULL),
(27263, NULL, 'IPR040344', NULL, 'Uncharacterized protein At3g17950-like', 'At3g17950-like', 4, NULL),
(27264, NULL, 'IPR036024', NULL, 'Somatomedin B-like domain superfamily', 'Somatomedin_B-like_dom_sf', 5, NULL),
(27265, NULL, 'IPR033392', NULL, 'Sox 7/17/18, central domain', 'Sox7/17/18_central', 3, NULL),
(27266, NULL, 'IPR037240', NULL, 'ORC1-binding domain', 'ORC1-binding_dom', 5, NULL),
(27267, NULL, 'IPR037737', NULL, 'Regulator of phospholipase D Srf1', 'Srf1', 4, NULL),
(27268, NULL, 'IPR039883', NULL, 'Fcf2/DNTTIP2', 'Fcf2/DNTTIP2', 4, NULL),
(27269, NULL, 'IPR039920', NULL, 'DNA repair/transcription protein MET18/MMS19', 'MET18/MMS19', 4, NULL),
(27270, NULL, 'IPR037894', NULL, 'Dynein axonemal assembly factor 4, CS domain', 'CS_DYX1C1', 3, NULL),
(27271, NULL, 'IPR037522', NULL, 'HD-GYP domain', 'HD_GYP_dom', 3, NULL),
(27272, NULL, 'IPR039911', NULL, 'JNK-interacting protein 3/4', 'JIP3/JIP4', 4, NULL),
(27273, NULL, 'IPR039653', NULL, 'Prenyltransferase', 'Prenyltransferase', 4, NULL),
(27274, NULL, 'IPR036638', NULL, 'Helix-loop-helix DNA-binding domain superfamily', 'HLH_DNA-bd_sf', 5, NULL),
(27275, NULL, 'IPR039312', NULL, 'Protein LITTLE ZIPPER', 'ZPR', 4, NULL),
(27276, NULL, 'IPR033010', NULL, 'The WD repeat Cdc20/Fizzy family', 'Cdc20/Fizzy', 4, NULL),
(27277, NULL, 'IPR033463', NULL, 'Single cache domain 3', 'sCache_3', 3, NULL),
(27278, NULL, 'IPR040273', NULL, 'PAMP-induced secreted peptide 1', 'PIP1', 4, NULL),
(27279, NULL, 'IPR039611', NULL, 'VQ motif-containing protein 4/11/13/19/31/33', 'VQ_4/11/13/19/31/33', 4, NULL),
(27280, NULL, 'IPR037983', NULL, 'Rasip1/Radil, cargo-binding domain', 'CBD_Rasip1/Radil', 3, NULL),
(27281, NULL, 'IPR036097', NULL, 'Signal transduction histidine kinase, dimerisation/phosphoacceptor domain superfamily', 'HisK_dim/P_sf', 5, NULL),
(27282, NULL, 'IPR039393', NULL, 'Rhizopine-oxygenase-like', 'Rhizopine-oxygenase-like', 4, NULL),
(27283, NULL, 'IPR033876', NULL, 'Secreted aspartic endopeptidase', 'SAP-like', 3, NULL),
(27284, NULL, 'IPR033874', NULL, 'Memapsin-like', 'Memapsin-like', 3, NULL),
(27285, NULL, 'IPR038391', NULL, 'L-fucose isomerase, domain 1 superfamily', 'Fucose_iso_dom1_sf', 5, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(27286, NULL, 'IPR038922', NULL, 'Huntingtin-interacting protein K, UBA-like domain', 'HYPK_UBA', 3, NULL),
(27287, NULL, 'IPR036098', NULL, 'Thymidylate synthase ThyX superfamily', 'Thymidylate_synthase_ThyX_sf', 5, NULL),
(27288, NULL, 'IPR040387', NULL, 'RPM1-interacting protein 4/NOI4', 'RIN4/NOI4', 4, NULL),
(27289, NULL, 'IPR037505', NULL, 'pH-response regulator protein palC', 'pH-resp_palC', 4, NULL),
(27290, NULL, 'IPR039682', NULL, 'Exocyst complex component Sec8/EXOC4', 'Sec8/EXOC4', 4, NULL),
(27291, NULL, 'IPR040029', NULL, 'Uncharacterized protein C14orf28-like', 'C14orf28-like', 4, NULL),
(27292, NULL, 'IPR040545', NULL, 'DICER-like, HTH domain', 'DICER_HTH', 3, NULL),
(27293, NULL, 'IPR038635', NULL, 'CCR4-NOT complex subunit 2/3/5, C-terminal domain superfamily', 'CCR4-NOT_su2/3/5_C_sf', 5, NULL),
(27294, NULL, 'IPR039652', NULL, 'Coatomer subunit zeta', 'Coatomer_zeta', 4, NULL),
(27295, NULL, 'IPR039996', NULL, 'Shieldin complex subunit 3', 'Shieldin_RINN1', 4, NULL),
(27296, NULL, 'IPR038233', NULL, 'Colicin D/E5 nuclease domain superfamily', 'Colicin_D/E5_nuclease', 5, NULL),
(27297, NULL, 'IPR035656', NULL, 'Nostrin, SH3 domain', 'Nostrin_SH3', 3, NULL),
(27298, NULL, 'IPR039577', NULL, 'E3 ubiquitin-protein ligase Rad18', 'Rad18', 4, NULL),
(27299, NULL, 'IPR037482', NULL, 'ST1585, MBL-fold', 'ST1585_MBL-fold', 3, NULL),
(27300, NULL, 'IPR037436', NULL, 'Sorting nexin-14, PX domain', 'SNX14_PX', 3, NULL),
(27301, NULL, 'IPR039952', NULL, 'G-protein coupled receptor Aex-2', 'Aex-2', 4, NULL),
(27302, NULL, 'IPR039090', NULL, 'T-cell antigen CD7', 'CD7', 4, NULL),
(27303, NULL, 'IPR037975', NULL, 'Class XI myosin, cargo binding domain', 'MyosinXI_CBD', 3, NULL),
(27304, NULL, 'IPR034977', NULL, 'CPEB-1, RNA recognition motif 1', 'CPEB1_RRM1', 3, NULL),
(27305, NULL, 'IPR039579', NULL, 'Arginine vasopressin-induced protein 1', 'AVPI1', 4, NULL),
(27306, NULL, 'IPR038389', NULL, 'Proteasome assembly chaperone 2 superfamily', 'PSMG2_sf', 5, NULL),
(27307, NULL, 'IPR040003', NULL, 'Plastoglobular protein 18-like', 'PG18-like', 4, NULL),
(27308, NULL, 'IPR039916', NULL, 'Exophilin-5', 'EXPH5', 4, NULL),
(27309, NULL, 'IPR040548', NULL, 'BepA, intracellular delivery domain', 'BepA_ID', 3, NULL),
(27310, NULL, 'IPR036069', NULL, 'DUF34/NIF3 superfamily', 'DUF34/NIF3_sf', 5, NULL),
(27311, NULL, 'IPR037090', NULL, 'Glycoside hydrolase families 57, central domain', '57_glycoside_trans_central', 5, NULL),
(27312, NULL, 'IPR039665', NULL, 'APBB1IP, PH domain', 'PH_APBB1IP', 3, NULL),
(27313, NULL, 'IPR037543', NULL, 'Prokaryotic ubiquitin-like protein UBact', 'UBact', 4, NULL),
(27314, NULL, 'IPR040027', NULL, 'Uncharacterized protein C11orf91-like', 'C11orf91-like', 4, NULL),
(27315, NULL, 'IPR039804', NULL, 'Listerin, zinc finger, RING-type', 'RING-CH-C4HC3_LTN1', 3, NULL),
(27316, NULL, 'IPR039632', NULL, 'Transmembrane protein 42', 'TMEM42', 4, NULL),
(27317, NULL, 'IPR038631', NULL, 'Herpesvirus Glycoprotein B, PH-like domain 2 superfamily', 'Glycoprot_B_PH2_sf', 5, NULL),
(27318, NULL, 'IPR037523', NULL, 'Vicinal oxygen chelate (VOC) domain', 'VOC', 3, NULL),
(27319, NULL, 'IPR038633', NULL, 'Proteasomal ubiquitin receptor Rpn13/ADRM1, Pru domain superfamily', 'Rpn13/ADRM1_Pru_sf', 5, NULL),
(27320, NULL, 'IPR034139', NULL, 'OLD protein-like, TOPRIM domain', 'TOPRIM_OLD', 3, NULL),
(27321, NULL, 'IPR035392', NULL, 'Protein of unknown function DUF5417', 'DUF5417', 4, NULL),
(27322, NULL, 'IPR039890', NULL, 'Cyclin N-terminal domain-containing protein 1', 'CNTD1', 4, NULL),
(27323, NULL, 'IPR039961', NULL, 'NADH-ubiquinone oxidoreductase 9.5kDa subunit', 'Nuo9.5', 4, NULL),
(27324, NULL, 'IPR039567', NULL, 'Glycine zipper domain', 'Gly-zipper', 3, NULL),
(27325, NULL, 'IPR039619', NULL, 'Membrane-associated kinase regulator 2/5', 'MAKR2/5', 4, NULL),
(27326, NULL, 'IPR039016', NULL, 'Reversion-inducing cysteine-rich protein with Kazal motifs', 'RECK', 4, NULL),
(27327, NULL, 'IPR039304', NULL, 'Dynein assembly factor 3, axonemal', 'DNAAF3', 4, NULL),
(27328, NULL, 'IPR039789', NULL, 'CYFIP-related Rac1 interactor', 'CYRI', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(27329, NULL, 'IPR040409', NULL, 'Phytochelatin synthase', 'PCS-like', 4, NULL),
(27330, NULL, 'IPR039800', NULL, 'Calcium uptake protein 1/2/3', 'MICU1/2/3', 4, NULL),
(27331, NULL, 'IPR036279', NULL, '5''-3'' exonuclease, C-terminal domain superfamily', '5-3_exonuclease_C_sf', 5, NULL),
(27332, NULL, 'IPR037971', NULL, 'Ankyrin-3, death domain', 'Ank3_Death', 3, NULL),
(27333, NULL, 'IPR040552', NULL, 'DNMT3, cysteine rich ADD domain', 'DNMT3_ADD', 3, NULL),
(27334, NULL, 'IPR039886', NULL, 'BTBD10/KCTD20', 'BTBD10/KCTD20', 4, NULL),
(27335, NULL, 'IPR039863', NULL, 'Dickkopf-like protein', 'DKK-like', 4, NULL),
(27336, NULL, 'IPR033593', NULL, 'N-terminal RASSF family', 'N-RASSF', 4, NULL),
(27337, NULL, 'IPR040167', NULL, 'Transcription factor CP2-like', 'TF_CP2-like', 4, NULL),
(27338, NULL, 'IPR039625', NULL, 'Transmembrane protein 178A/B', 'T178A/B', 4, NULL),
(27339, NULL, 'IPR039862', NULL, 'N-terminal EF-hand calcium binding protein 1/2/3', 'NECAB1/2/3', 4, NULL),
(27340, NULL, 'IPR037735', NULL, 'Cadmium-induced protein AS8-like', 'AS8-like', 4, NULL),
(27341, NULL, 'IPR040294', NULL, 'Nodulin-related protein 1/2', 'Nodulin-rel_1/2', 4, NULL),
(27342, NULL, 'IPR039601', NULL, 'RNA polymerase I-specific transcription initiation factor Rrn5', 'Rrn5', 4, NULL),
(27343, NULL, 'IPR040350', NULL, 'Transmembrane protein 272', 'TMEM272', 4, NULL),
(27344, NULL, 'IPR033896', NULL, 'MADS MEF2-like', 'MADS_MEF2-like', 3, NULL),
(27345, NULL, 'IPR033897', NULL, 'MADS SRF-like', 'MADS_SRF-like', 3, NULL),
(27346, NULL, 'IPR040028', NULL, 'Intraflagellar transport-associated protein', 'IFTAP', 4, NULL),
(27347, NULL, 'IPR039568', NULL, 'Peptidase MA-like', 'Peptidase_MA-like', 3, NULL),
(27348, NULL, 'IPR040025', NULL, 'Zinc finger protein 622/Rei1/Reh1', 'Znf622/Rei1/Reh1', 4, NULL),
(27349, NULL, 'IPR039901', NULL, '3-deoxy-D-manno-octulosonic acid transferase', 'Kdotransferase', 4, NULL),
(27350, NULL, 'IPR039385', NULL, 'NGN domain, eukaryotic', 'NGN_Euk', 3, NULL),
(27351, NULL, 'IPR039882', NULL, 'Zinc finger protein 414', 'ZN414', 4, NULL),
(27352, NULL, 'IPR037470', NULL, 'Protein IVY1', 'IVY1', 4, NULL),
(27353, NULL, 'IPR037909', NULL, 'SNX19, PX domain', 'SNX19_PX', 3, NULL),
(27354, NULL, 'IPR039841', NULL, 'Integrator complex subunit 14', 'INTS14', 4, NULL),
(27355, NULL, 'IPR038258', NULL, 'Peptidoglycan hydrolase Gp4 superfamily', 'Gp4_sf', 5, NULL),
(27356, NULL, 'IPR038968', NULL, 'Centriolar satellite-associated tubulin polyglutamylase complex regulator 1', 'CSTPP1', 4, NULL),
(27357, NULL, 'IPR039603', NULL, 'Protein Fyv4', 'Fyv4', 4, NULL),
(27358, NULL, 'IPR037383', NULL, 'Coiled-coil domain-containing protein 87', 'CCDC87', 4, NULL),
(27359, NULL, 'IPR037673', NULL, 'Large-conductance mechanosensitive channel/anditomin synthesis protein L', 'MSC/AndL', 4, NULL),
(27360, NULL, 'IPR040174', NULL, 'Renalase', 'RNLS', 4, NULL),
(27361, NULL, 'IPR039544', NULL, 'Tim44-like', 'Tim44-like', 4, NULL),
(27362, NULL, 'IPR040047', NULL, 'Syndetin', 'VPS50', 4, NULL),
(27363, NULL, 'IPR039562', NULL, 'Membrane fusion protein, biotin-lipoyl like domain', 'MFP_biotin_lipoyl_2', 3, NULL),
(27364, NULL, 'IPR040268', NULL, 'Armadillo-like helical domain-containing protein 2', 'ARMH2', 4, NULL),
(27365, NULL, 'IPR039650', NULL, 'H(2):CoB-CoM heterodisulfide,ferredoxin reductase subunit A-like', 'HdrA-like', 4, NULL),
(27366, NULL, 'IPR039732', NULL, 'Ubiquitin-like modifier Hub1/Ubl5', 'Hub1/Ubl5', 4, NULL),
(27367, NULL, 'IPR039790', NULL, 'CHORD domain containing protein', 'CHORD_protein', 4, NULL),
(27368, NULL, 'IPR039651', NULL, 'Protein FixC-like', 'FixC-like', 4, NULL),
(27369, NULL, 'IPR039681', NULL, 'Interleukin-18-binding protein', 'IL18BP', 4, NULL),
(27370, NULL, 'IPR040077', NULL, 'Glutathione S-transferase Theta, C-terminal', 'GST_C_Theta', 3, NULL),
(27371, NULL, 'IPR039757', NULL, 'Eukaryotic translation initiation factor 2D', 'EIF2D', 4, NULL),
(27372, NULL, 'IPR033900', NULL, 'Porin domain, Gram-negative type', 'Gram_neg_porin_domain', 3, NULL),
(27373, NULL, 'IPR039794', NULL, 'Glucosidase II beta subunit-like', 'Gtb1-like', 4, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(27374, NULL, 'IPR039627', NULL, 'Mitochondrial escape protein 2', 'Yme2_C', 4, NULL),
(27375, NULL, 'IPR040133', NULL, 'Synphilin-1', 'SNCAIP', 4, NULL),
(27376, NULL, 'IPR033464', NULL, 'CSN8/PSMD8/EIF3K', 'CSN8_PSD8_EIF3K', 3, NULL),
(27377, NULL, 'IPR040296', NULL, 'Photosystem II 5kDa protein, chloroplastic', 'PSBT', 4, NULL),
(27378, NULL, 'IPR039813', NULL, 'Stromal cell-derived factor 1', 'CXCL12', 4, NULL),
(27379, NULL, 'IPR039386', NULL, 'Homoaconitase, swivel domain', 'Homoaconitase_swivel', 3, NULL),
(27380, NULL, 'IPR040335', NULL, 'Multivesicular body subunit 12A', 'MVB12A', 4, NULL),
(27381, NULL, 'IPR040470', NULL, 'Vexin', 'Vexin', 4, NULL),
(27382, NULL, 'IPR036099', NULL, 'Cytochrome b6/f complex, subunit 5 superfamily', 'Cyt_6/f_cplx_su5_sf', 5, NULL),
(27383, NULL, 'IPR039879', NULL, 'EF-hand calcium-binding domain-containing protein 10', 'EFC10', 4, NULL),
(27384, NULL, 'IPR039088', NULL, 'C-X-C motif chemokine 14', 'CXCL14', 4, NULL),
(27385, NULL, 'IPR039933', NULL, 'Protein XRI1', 'XRI1', 4, NULL),
(27386, NULL, 'IPR039787', NULL, 'Poly(U)-specific endoribonuclease', 'ENDOU', 4, NULL),
(27387, NULL, 'IPR037088', NULL, 'Vitellinogen, beta-sheet shell domain superfamily', 'Vitellinogen_b-sht_shell_sf', 5, NULL),
(27388, NULL, 'IPR033462', NULL, 'Cache 3/Cache 2 fusion domain', 'Cache_3-Cache_2', 3, NULL),
(27389, NULL, 'IPR039622', NULL, 'Methyl-CpG-binding domain-containing protein 10/11', 'MBD10/11', 4, NULL),
(27390, NULL, 'IPR035683', NULL, 'Smoothened, transmembrane domain', 'SMO_7TM', 3, NULL),
(27391, NULL, 'IPR040159', NULL, 'Suppressor of hairless-like', 'CLS_fam', 4, NULL),
(27392, NULL, 'IPR039727', NULL, 'SERRATE/Ars2', 'SE/Ars2', 4, NULL),
(27393, NULL, 'IPR039613', NULL, 'Protein SPIRAL1-like', 'SPR1/2/3/4/5', 4, NULL),
(27394, NULL, 'IPR035395', NULL, 'Protein of unknown function DUF5415', 'DUF5415', 4, NULL),
(27395, NULL, 'IPR039571', NULL, 'RNF126, RING finger, H2 subclass', 'RNF126_RING-H2', 3, NULL),
(27396, NULL, 'IPR037027', NULL, 'YqgF/RNase H-like domain superfamily', 'YqgF/RNaseH-like_dom_sf', 5, NULL),
(27397, NULL, 'IPR038227', NULL, 'PCGF Ub-like fold discriminator superfamily', 'PUFD_som_sf', 5, NULL),
(27398, NULL, 'IPR039008', NULL, 'Intermediate filament, rod domain', 'IF_rod_dom', 3, NULL),
(27399, NULL, 'IPR038400', NULL, 'Non-structural protein NSP3, SUD-M domain superfamily, betacoronavirus', 'NSP3_SUD-M_sf_bCoV', 5, NULL),
(27400, NULL, 'IPR037030', NULL, 'Retinal cGMP phosphodiesterase, gamma subunit superfamily', 'PDE6_gamma_sf', 5, NULL),
(27401, NULL, 'IPR037497', NULL, 'Protein PROTON GRADIENT REGULATION 5', 'PGR5', 4, NULL),
(27402, NULL, 'IPR033649', NULL, 'LigD polymerase domain, MtLigD-type', 'MtLigD_Pol-like', 3, NULL),
(27403, NULL, 'IPR039935', NULL, 'Uncharacterized protein YML079W-like', 'YML079W-like', 4, NULL),
(27404, NULL, 'IPR039683', NULL, 'Protein Lsm12-like', 'Lsm12-like', 4, NULL),
(27405, NULL, 'IPR039888', NULL, 'Protein melted-like', 'Melted-like', 4, NULL),
(27406, NULL, 'IPR039730', NULL, 'Jlp2/Ccd25', 'Jlp2/Ccd25', 4, NULL),
(27407, NULL, 'IPR034973', NULL, 'Synaptojanin-2, RNA recognition motif', 'SYNJ2_RRM', 3, NULL),
(27408, NULL, 'IPR037395', NULL, 'GSK3B-interacting protein', 'GSKIP', 4, NULL),
(27409, NULL, 'IPR040129', NULL, 'Protein lin-15B-like', 'Lin-15B-like', 4, NULL),
(27410, NULL, 'IPR039305', NULL, 'Protein PIN-LIKES 2/6', 'PILS2/6', 4, NULL),
(27411, NULL, 'IPR040051', NULL, 'Selenocysteine insertion sequence-binding protein 2', 'SECISBP2', 4, NULL),
(27412, NULL, 'IPR038383', NULL, 'CGT/MARTX, cysteine protease (CPD) domain superfamily', 'CPD_dom_sf', 5, NULL),
(27413, NULL, 'IPR039319', NULL, 'Protein EARLY FLOWERING 3-like', 'ELF3-like', 4, NULL),
(27414, NULL, 'IPR039638', NULL, 'Mediator of RNA polymerase II transcription subunit 33A/B', 'MED33A/B', 4, NULL),
(27415, NULL, 'IPR039643', NULL, 'Dihydroxyacetone kinase phosphotransferase subunit DhaM', 'DhaM', 4, NULL),
(27416, NULL, 'IPR038261', NULL, 'Golgi phosphoprotein 3-like domain superfamily', 'GPP34-like_sf', 5, NULL),
(27417, NULL, 'IPR038632', NULL, 'Zinc finger FYVE 21, C-terminal domain superfamily', 'ZFYVE21_C_sf', 5, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(27418, NULL, 'IPR037534', NULL, 'Polymerase acidic protein', 'INFV_PA', 4, NULL),
(27419, NULL, 'IPR039250', NULL, 'CREBL2/REPTOR-BP', 'CREBL2/REPTOR-BP', 4, NULL),
(27420, NULL, 'IPR039844', NULL, 'Nucleolar pre-ribosomal-associated protein 1', 'URB1', 4, NULL),
(27421, NULL, 'IPR037437', NULL, 'Sorting nexin-13, PX domain', 'SNX13_PX', 3, NULL),
(27422, NULL, 'IPR036188', NULL, 'FAD/NAD(P)-binding domain superfamily', 'FAD/NAD-bd_sf', 5, NULL),
(27423, NULL, 'IPR039617', NULL, 'CLAVATA3/ESR (CLE)-related protein', 'CLAVATA3-CLE', 4, NULL),
(27424, NULL, 'IPR039999', NULL, 'Cell growth-regulating nucleolar protein', 'LYAR', 4, NULL),
(27425, NULL, 'IPR036094', NULL, 'Quinolinate synthetase A superfamily', 'NadA_sf', 5, NULL),
(27426, NULL, 'IPR039417', NULL, 'Papain-like cysteine endopeptidase', 'Peptidase_C1A_papain-like', 3, NULL),
(27427, NULL, 'IPR037091', NULL, 'Penicillin-binding protein 4, C-terminal domain superfamily', 'Pen-bd_prot4_C_dom_sf', 5, NULL),
(27428, NULL, 'IPR040000', NULL, 'Nucleolar protein 9', 'NOP9', 4, NULL),
(27429, NULL, 'IPR040007', NULL, 'THO complex subunit 2', 'Tho2', 4, NULL),
(27430, NULL, 'IPR037875', NULL, 'Ribosome biogenesis protein Bms1, N-terminal', 'Bms1_N', 3, NULL),
(27431, NULL, 'IPR039616', NULL, 'CLAVATA3/ESR (CLE)-related protein 1-4', 'CLE1-4', 4, NULL),
(27432, NULL, 'IPR039733', NULL, 'Protein N-terminal glutamine amidohydrolase', 'NTAQ1', 4, NULL),
(27433, NULL, 'IPR039859', NULL, 'Palmitoyltransferase ZDHHC16', 'ZDH16', 4, NULL),
(27434, NULL, 'IPR038917', NULL, 'Malonyl-CoA decarboxylase', 'Malonyl_CoA_deC', 4, NULL),
(27435, NULL, 'IPR040178', NULL, 'E3 ubiquitin-protein ligase RNF220, RING finger', 'RNF220_RING', 3, NULL),
(27436, NULL, 'IPR039628', NULL, 'PILR alpha-associated neural protein', 'PIANP', 4, NULL),
(27437, NULL, 'IPR040187', NULL, 'OCIA domain-containing protein 1/2', 'OCAD1/2', 4, NULL),
(27438, NULL, 'IPR038388', NULL, 'RcsC, C-terminal domain superfamily', 'RcsC_C_sf', 5, NULL),
(27439, NULL, 'IPR038222', NULL, 'DHHA2 domain superfamily', 'DHHA2_dom_sf', 5, NULL),
(27440, NULL, 'IPR035385', NULL, 'Herpesvirus U62/UL91, functional domain', 'U62/UL91', 3, NULL),
(27441, NULL, 'IPR040168', NULL, 'Not2/Not3/Not5', 'Not2/3/5', 4, NULL),
(27442, NULL, 'IPR039878', NULL, 'RNA-binding protein 33', 'RBM33', 4, NULL),
(27443, NULL, 'IPR040549', NULL, 'Domain of unknown function DUF5613', 'DUF5613', 3, NULL),
(27444, NULL, 'IPR035393', NULL, 'Protein of unknown function DUF5416', 'DUF5416', 4, NULL),
(27445, NULL, 'IPR040274', NULL, 'CLAVATA3/ESR (CLE)-related protein 27/43', 'CLE27/CLE43', 4, NULL),
(27446, NULL, 'IPR038634', NULL, 'Alphacoronavirus nsp1 domain superfamily', 'A-CoV_nsp1_sf', 5, NULL),
(27447, NULL, 'IPR039301', NULL, 'Protein Sip5/DA2', 'Sip5/DA2', 4, NULL),
(27448, NULL, 'IPR039788', NULL, 'Nucleolar protein 4 family', 'NOL4/NOL4L', 4, NULL),
(27449, NULL, 'IPR040560', NULL, 'Synaptonemal complex protein 2, Spt16M-like domain', 'SYCP2_SLD', 3, NULL),
(27450, NULL, 'IPR035961', NULL, 'Rhabdovirus nucleoprotein-like', 'Rhabdovirus_nucleoprotein-like', 5, NULL),
(27451, NULL, 'IPR037028', NULL, 'Dr-adhesin superfamily', 'Dr_adhesin_sf', 5, NULL),
(27452, NULL, 'IPR039609', NULL, 'VQ motif-containing protein 15/22', 'VQ_15/22', 4, NULL),
(27453, NULL, 'IPR040014', NULL, 'Corepressor interacting with RBPJ 1', 'CIR1', 4, NULL),
(27454, NULL, 'IPR039509', NULL, 'SPATA31/FAM205', 'SPATA31/FAM205', 3, NULL),
(27455, NULL, 'IPR040048', NULL, 'Zinc finger protein 277', 'ZNF277', 4, NULL),
(27456, NULL, 'IPR039848', NULL, 'Ribosomal protein S24/S35, mitochondrial', 'Ribosomal_S24/S35', 4, NULL),
(27457, NULL, 'IPR037484', NULL, 'AmhX-like', 'AmhX-like', 4, NULL),
(27458, NULL, 'IPR038404', NULL, 'TRAP transporter solute receptor DctP superfamily', 'TRAP_DctP_sf', 5, NULL),
(27459, NULL, 'IPR034965', NULL, 'Nocturnin, deadenylase domain', 'Deadenylase_nocturnin', 3, NULL),
(27460, NULL, 'IPR040117', NULL, 'GCSF/MGF', 'GCSF/MGF', 4, NULL),
(27461, NULL, 'IPR037970', NULL, 'IRAK4, Death domain', 'IRAK4_Death', 3, NULL),
(27462, NULL, 'IPR039009', NULL, 'Capsid Gp10A/Gp10B', 'Capsid_Gp10A/Gp10B', 3, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(27463, NULL, 'IPR034971', NULL, 'Synaptojanin-1, RNA recognition motif', 'SYNJ1_RRM', 3, NULL),
(27464, NULL, 'IPR039569', NULL, 'N-terminal of MaoC-like dehydratase', 'MaoC-like_dehydrat_N', 3, NULL),
(27465, NULL, 'IPR039684', NULL, 'Fanconi anemia group G protein', 'FANCG', 4, NULL),
(27466, NULL, 'IPR040185', NULL, 'Far11/STRP', 'Far11/STRP', 4, NULL),
(27467, NULL, 'IPR039578', NULL, 'Oncostatin-M', 'OSM', 4, NULL),
(27468, NULL, 'IPR038978', NULL, 'Protein MJ0935', 'MJ0935', 4, NULL),
(27469, NULL, 'IPR040557', NULL, 'VIP1, N-terminal', 'VIP1_N', 3, NULL),
(27470, NULL, 'IPR035093', NULL, 'Toxin-antitoxin system, RelE/ParE toxin domain superfamily', 'RelE/ParE_toxin_dom_sf', 5, NULL),
(27471, NULL, 'IPR039919', NULL, 'Rho guanine nucleotide exchange factor 10/17', 'ARHGEF10/ARHGEF17', 4, NULL),
(27472, NULL, 'IPR040006', NULL, 'Tankyrase 1-binding protein-like', 'TNKS1BP1-like', 4, NULL),
(27473, NULL, 'IPR037385', NULL, 'Methyl-CpG-binding domain protein 5/6', 'MBD5/MBD6', 4, NULL),
(27474, NULL, 'IPR039303', NULL, 'Coiled-coil domain-containing protein 50', 'CCDC50', 4, NULL),
(27475, NULL, 'IPR036635', NULL, 'UDP-N-acetylenolpyruvoylglucosamine reductase, C-terminal domain superfamily', 'MurB_C_sf', 5, NULL),
(27476, NULL, 'IPR040170', NULL, 'Cytosolic acyl coenzyme A thioester hydrolase', 'Cytosol_ACT', 4, NULL),
(27477, NULL, 'IPR039314', NULL, 'Calvin cycle protein CP12-like', 'CP12-like', 4, NULL),
(27478, NULL, 'IPR040282', NULL, 'Abnormal cell migration protein 18-like', 'Mig-18-like', 4, NULL),
(27479, NULL, 'IPR040291', NULL, 'Uncharacterized transmembrane protein DDB_G0287341-like', 'DDB_G0287341-like', 4, NULL),
(27480, NULL, 'IPR039880', NULL, 'Uncharacterized protein C17orf64-like', 'C17orf64-like', 4, NULL),
(27481, NULL, 'IPR039731', NULL, 'CAAX prenyl protease 2, eukaryotes', 'Rce1', 4, NULL),
(27482, NULL, 'IPR039639', NULL, 'Protein IDA-like', 'IDA-like', 4, NULL),
(27483, NULL, 'IPR038217', NULL, 'MRG, C-terminal domain superfamily', 'MRG_C_sf', 5, NULL),
(27484, NULL, 'IPR037439', NULL, '1,4-alpha-glucan-branching enzyme', 'Branching_enzy', 4, NULL),
(27485, NULL, 'IPR039805', NULL, 'CUE domain-containing protein 2, CUE domain', 'CUE_CUED2', 3, NULL),
(27486, NULL, 'IPR040561', NULL, 'Large polyvalent protein associated domain 38', 'LPD38', 3, NULL),
(27487, NULL, 'IPR040556', NULL, 'Predicted pPIWI-associating nuclease', 'pP_pnuc_1', 3, NULL),
(27488, NULL, 'IPR037457', NULL, 'M28 Zn-Peptidase Glutaminyl Cyclase', 'M28_QC', 3, NULL),
(27489, NULL, 'IPR040125', NULL, 'Squalene monooxygenase', 'Squalene_monox', 4, NULL),
(27490, NULL, 'IPR037736', NULL, 'Photosystem I assembly factor PSA3', 'PSA3', 4, NULL),
(27491, NULL, 'IPR039760', NULL, 'MOFRL domain-containing protein', 'MOFRL_protein', 4, NULL),
(27492, NULL, 'IPR040289', NULL, 'Microtubule binding protein 2C', 'MBP2C', 4, NULL),
(27493, NULL, 'IPR040262', NULL, 'Uncharacterized protein At4g38062-like', 'At4g38062-like', 4, NULL),
(27494, NULL, 'IPR039656', NULL, 'Synergin gamma', 'SYNRG', 4, NULL),
(27495, NULL, 'IPR039918', NULL, 'Serine/threonine-protein phosphatase 4 regulatory subunit 4', 'PPP4R4', 4, NULL),
(27496, NULL, 'IPR039536', NULL, 'Transcriptional regulator TetR, C-terminal, Proteobacteria type', 'TetR_C_Proteobacteria', 3, NULL),
(27497, NULL, 'IPR040075', NULL, 'Glutathione S-transferase Theta, N-terminal', 'GST_N_Theta', 3, NULL),
(27498, NULL, 'IPR035653', NULL, 'Alpha-(1,6)-fucosyltransferase, SH3 domain', 'Fut8_SH3', 3, NULL),
(27499, NULL, 'IPR040126', NULL, 'Storkhead-box protein 1/2', 'STOX1/2', 4, NULL),
(27500, NULL, 'IPR039881', NULL, 'mRNA (2''-O-methyladenosine-N(6)-)-methyltransferase PCIF1-like', 'PCIF1-like', 4, NULL),
(27501, NULL, 'IPR036013', NULL, 'Band 7/SPFH domain superfamily', 'Band_7/SPFH_dom_sf', 5, NULL),
(27502, NULL, 'IPR033133', NULL, 'Pumilio homology domain', 'PUM-HD', 3, NULL),
(27503, NULL, 'IPR040371', NULL, 'Regulator of MON1-CCZ1 complex', 'RMC1', 4, NULL),
(27504, NULL, 'IPR040479', NULL, 'Protein masquerade, clip-domain', 'CLIP_SPH_mas', 3, NULL),
(27505, NULL, 'IPR040345', NULL, 'Mug56/Spo71', 'Mug56/Spo71', 4, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(27506, NULL, 'IPR040537', NULL, 'Domain of unknown function DUF5612', 'DUF5612', 3, NULL),
(27507, NULL, 'IPR040482', NULL, 'Trimeric autotransporter adhesin, Trp ring domain', 'Trp_ring', 3, NULL),
(27508, NULL, 'IPR040921', NULL, 'LD-carboxypeptidase, C-terminal', 'Peptidase_S66C', 3, NULL),
(27509, NULL, 'IPR035506', NULL, 'Pollen allergen/Uncharacterized protein Os', 'Pollen_allergen/Os', 5, NULL),
(27510, NULL, 'IPR037308', NULL, 'TNF receptor-associated factor 5, MATH domain', 'TRAF5_MATH', 3, NULL),
(27511, NULL, 'IPR040437', NULL, 'Uncharacterized protein F10E9.3-like', 'F10E9.3-like', 4, NULL),
(27512, NULL, 'IPR036352', NULL, 'Sema domain superfamily', 'Semap_dom_sf', 5, NULL),
(27513, NULL, 'IPR038013', NULL, 'ALG11 mannosyltransferase', 'ALG11', 4, NULL),
(27514, NULL, 'IPR038008', NULL, 'Jag, KH domain', 'Jag_KH', 3, NULL),
(27515, NULL, 'IPR040372', NULL, 'YaeB-like', 'YaeB-like', 4, NULL),
(27516, NULL, 'IPR040036', NULL, 'Protein CYCLOPS', 'CYCLOPS', 4, NULL),
(27517, NULL, 'IPR036833', NULL, 'Beta-galactosidase, domain 3 superfamily', 'BetaGal_dom3_sf', 5, NULL),
(27518, NULL, 'IPR038590', NULL, 'YaeQ superfamily', 'YaeQ_sf', 5, NULL),
(27519, NULL, 'IPR038078', NULL, 'PhoU-like domain superfamily', 'PhoU-like_sf', 5, NULL),
(27520, NULL, 'IPR040378', NULL, 'Protein BREAKING OF ASYMMETRY IN THE STOMATAL LINEAGE', 'BASL', 4, NULL),
(27521, NULL, 'IPR040453', NULL, 'Mnd1, HTH domain', 'Mnd1_HTH', 3, NULL),
(27522, NULL, 'IPR037689', NULL, 'BAG family molecular chaperone regulator 2', 'BAG2', 4, NULL),
(27523, NULL, 'IPR036416', NULL, 'Peptidyl-tRNA hydrolase superfamily', 'Pept_tRNA_hydro_sf', 5, NULL),
(27524, NULL, 'IPR040342', NULL, 'Uncharacterized protein C20orf194-like', 'C20orf194-like', 4, NULL),
(27525, NULL, 'IPR035730', NULL, 'VAV1 protein, first SH3 domain', 'VAV1_SH3_1', 3, NULL),
(27526, NULL, 'IPR039411', NULL, 'Ribosomal biogenesis NSA2 family', 'NSA2_fam', 4, NULL),
(27527, NULL, 'IPR039126', NULL, 'Gamma-glutamylaminecyclotransferase', 'GGACT', 4, NULL),
(27528, NULL, 'IPR035566', NULL, 'Ribosomal protein L20, C-terminal', 'Ribosomal_protein_L20_C', 5, NULL),
(27529, NULL, 'IPR033533', NULL, 'Proline-rich protein 27', 'PRR27', 4, NULL),
(27530, NULL, 'IPR040539', NULL, 'WRNIP1, ubiquitin-binding domain', 'Znf-WRNIP1_ubi', 3, NULL),
(27531, NULL, 'IPR040475', NULL, 'Surface glycan-binding protein B, xyloglucan binding domain', 'SGBP_B_XBD', 3, NULL),
(27532, NULL, 'IPR040573', NULL, 'Tail specific protease, N-terminal domain', 'TSP_N', 3, NULL),
(27533, NULL, 'IPR038256', NULL, 'DNA polymerase alpha, zinc finger domain superfamily', 'Pol_alpha_znc_sf', 5, NULL),
(27534, NULL, 'IPR035668', NULL, 'Amicyanin', 'Amicyanin', 4, NULL),
(27535, NULL, 'IPR036387', NULL, 'Neurohypophysial hormone domain superfamily', 'Neurhyp_horm_dom_sf', 5, NULL),
(27536, NULL, 'IPR040460', NULL, 'Gasdermin, pore forming domain', 'Gasdermin_pore', 3, NULL),
(27537, NULL, 'IPR038010', NULL, 'YhfW, C-terminal Rieske domain', 'YhfW_C', 3, NULL),
(27538, NULL, 'IPR040722', NULL, 'Hit1, C-terminal', 'Hit1_C', 3, NULL),
(27539, NULL, 'IPR040572', NULL, 'Thaumarchaeal output domain 1', 'TackOD1', 3, NULL),
(27540, NULL, 'IPR040930', NULL, 'AF-9, ANC1 homology domain', 'AF-9_AHD', 3, NULL),
(27541, NULL, 'IPR040565', NULL, 'Benzylsuccinate synthase beta subunit', 'BssB_TutG', 3, NULL),
(27542, NULL, 'IPR040598', NULL, 'UPF0113, pre-PUA domain', 'UPF0113_N', 3, NULL),
(27543, NULL, 'IPR036816', NULL, 'Ribonuclease A-like domain superfamily', 'RNaseA-like_dom_sf', 5, NULL),
(27544, NULL, 'IPR033369', NULL, 'Protein C19orf12', 'C19orf12', 4, NULL),
(27545, NULL, 'IPR036557', NULL, 'Methanol dehydrogenase, beta subunit superfamily', 'Meth_DH_bsu_sf', 5, NULL),
(27546, NULL, 'IPR040492', NULL, 'Galactofuranosyltransferase GlfT2, N-terminal', 'GlfT2_N', 3, NULL),
(27547, NULL, 'IPR040040', NULL, 'Autophagy-related protein 11', 'ATG11', 4, NULL),
(27548, NULL, 'IPR036819', NULL, 'Subtilisin inhibitor-like superfamily', 'Subtilisin_inhibitor-like_sf', 5, NULL),
(27549, NULL, 'IPR040929', NULL, 'Archaellum regulatory network B, C-terminal', 'ArnB_C', 3, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(27550, NULL, 'IPR037335', NULL, 'DEP domain-containing mTOR-interacting protein, DEP domain 1', 'DEPTOR_DEP_1', 3, NULL),
(27551, NULL, 'IPR036424', NULL, 'Decaprenyl diphosphate synthase-like superfamily', 'UPP_synth-like_sf', 5, NULL),
(27552, NULL, 'IPR037201', NULL, 'Calcyclin-binding protein, N-terminal', 'CacyBP_N', 5, NULL),
(27553, NULL, 'IPR035514', NULL, 'SPIN90, SH3 domain', 'SPIN90_SH3', 3, NULL),
(27554, NULL, 'IPR040496', NULL, 'Prokaryotic pPIWI_RE, MID domain', 'MID_pPIWI_RE', 3, NULL),
(27555, NULL, 'IPR039694', NULL, 'WD repeat-containing protein 11', 'WDR11', 4, NULL),
(27556, NULL, 'IPR037768', NULL, 'Copine, C2B domain', 'C2B_Copine', 3, NULL),
(27557, NULL, 'IPR035729', NULL, 'VAV1 protein, second SH3 domain', 'VAV1_SH3_2', 3, NULL),
(27558, NULL, 'IPR037305', NULL, 'TNF receptor-associated factor 2, MATH domain', 'TRAF2_MATH', 3, NULL),
(27559, NULL, 'IPR034277', NULL, 'Ephrin type-A receptor 5, ligand binding domain', 'EphA5_rcpt_lig-bd', 3, NULL),
(27560, NULL, 'IPR037494', NULL, 'Rubisco accumulation factor 1', 'RAF1', 4, NULL),
(27561, NULL, 'IPR037369', NULL, 'Pleckstrin-2, DEP domain', 'PLEK2_DEP', 3, NULL),
(27562, NULL, 'IPR040922', NULL, 'MRPL25 domain', 'MRPL25_dom', 3, NULL),
(27563, NULL, 'IPR038009', NULL, 'GlmU, C-terminal LbH domain', 'GlmU_C_LbH', 3, NULL),
(27564, NULL, 'IPR037359', NULL, 'Heparan sulfate sulfotransferase', 'NST/OST', 4, NULL),
(27565, NULL, 'IPR040568', NULL, 'Large polyvalent protein-associated domain 16', 'LPD16', 3, NULL),
(27566, NULL, 'IPR037212', NULL, 'Mediator complex, subunit Med7/Med21-like', 'Med7/Med21-like', 5, NULL),
(27567, NULL, 'IPR040487', NULL, 'Peptidase family M23, N-terminal', 'Peptidase_M23_N', 3, NULL),
(27568, NULL, 'IPR037343', NULL, 'SOCS5, SOCS box domain', 'SOCS5_SOCS', 3, NULL),
(27569, NULL, 'IPR040306', NULL, 'Os02g0753200-like', 'Os02g0753200-like', 4, NULL),
(27570, NULL, 'IPR035570', NULL, 'UPF0234, N-terminal', 'UPF0234_N', 5, NULL),
(27571, NULL, 'IPR038539', NULL, 'Anti-lipopolysaccharide factor/Scygonadin superfamily', 'Anti-LPS_factor/Scygonadin_sf', 5, NULL),
(27572, NULL, 'IPR040478', NULL, 'BDBT FKBP like, N-terminal', 'FKBP_N_2', 3, NULL),
(27573, NULL, 'IPR040664', NULL, 'AFL, C-terminal', 'AFL_C', 3, NULL),
(27574, NULL, 'IPR040540', NULL, 'Ribonuclease III, N-terminal domain', 'RNase_3_N', 3, NULL),
(27575, NULL, 'IPR035726', NULL, 'Abl interactor 2, SH3 domain', 'Abi2_SH3', 3, NULL),
(27576, NULL, 'IPR038527', NULL, 'HupH, C-terminal domain superfamily', 'HupH_C_sf', 5, NULL),
(27577, NULL, 'IPR037489', NULL, 'DNA repair RAD52-like protein', 'RAD52-like', 4, NULL),
(27578, NULL, 'IPR037993', NULL, 'NDPK7, second NDPk domain', 'NDPk7B', 3, NULL),
(27579, NULL, 'IPR040716', NULL, 'Outer-membrane lipoprotein Wza, C-terminal domain', 'Wza_C', 3, NULL),
(27580, NULL, 'IPR036835', NULL, 'Replication modulator SeqA, C-terminal DNA-binding domain superfamily', 'SeqA_DNA-bd_C_sf', 5, NULL),
(27581, NULL, 'IPR040577', NULL, 'Glutamine synthetase, C-terminal', 'Gln-synt_C', 3, NULL),
(27582, NULL, 'IPR038249', NULL, 'DNA polymerase III, tau subunit, domain V superfamily', 'PolIII_tau_V_sf', 5, NULL),
(27583, NULL, 'IPR037304', NULL, 'TRAF3, MATH domain', 'TRAF3_MATH', 3, NULL),
(27584, NULL, 'IPR036338', NULL, 'Activator of Hsp90 ATPase, Aha1', 'Aha1', 5, NULL),
(27585, NULL, 'IPR033397', NULL, 'Metallo-carboxypeptidase, C-terminal domain', 'Metallo_peptidase_C', 3, NULL),
(27586, NULL, 'IPR037313', NULL, 'Serine/threonine-protein kinase N, first HR1 domain', 'PKN_HR1_1', 3, NULL),
(27587, NULL, 'IPR040504', NULL, 'TFIIF, beta subunit, N-terminal', 'TFIIF_beta_N', 3, NULL),
(27588, NULL, 'IPR036617', NULL, 'Barrier-to-autointegration factor, BAF superfamily', 'BAF_sf', 5, NULL),
(27589, NULL, 'IPR040591', NULL, 'YlmH, putative RNA-binding domain', 'YlmH_RBD', 3, NULL),
(27590, NULL, 'IPR040966', NULL, 'Metalloprotease StcE, C-terminal', 'StcE_C', 3, NULL),
(27591, NULL, 'IPR036814', NULL, 'YqcC-like superfamily', 'YqcC-like_sf', 5, NULL),
(27592, NULL, 'IPR040438', NULL, 'Protein HIDE1', 'HIDE1', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(27593, NULL, 'IPR040571', NULL, 'Mitochondrial membrane-anchored protein', 'MIX', 3, NULL),
(27594, NULL, 'IPR036823', NULL, 'Ribosomal protein S7 domain superfamily', 'Ribosomal_S7_dom_sf', 5, NULL),
(27595, NULL, 'IPR035805', NULL, 'Tyrosine-protein kinase Frk, SH2 domain', 'SH2_Frk', 3, NULL),
(27596, NULL, 'IPR040328', NULL, 'Uncharacterized protein DDB_G0279899-like', 'DDB_G0279899-like', 4, NULL),
(27597, NULL, 'IPR036321', NULL, 'Hypothetical protein ST1625', 'ST1625', 5, NULL),
(27598, NULL, 'IPR038543', NULL, 'Churchill superfamily', 'Churchill_sf', 5, NULL),
(27599, NULL, 'IPR037353', NULL, 'Histone methyltransferase complex subunit ASH2', 'ASH2', 4, NULL),
(27600, NULL, 'IPR040264', NULL, 'Uncharacterized protein T15H9.4-like', 'T15H9.4-like', 4, NULL),
(27601, NULL, 'IPR040927', NULL, 'Monalysin, beta barrel Pore-forming domain', 'BB_PF', 3, NULL),
(27602, NULL, 'IPR036841', NULL, 'Vascular endothelial growth factor, heparin-binding domain superfamily', 'VEGF_C_sf', 5, NULL),
(27603, NULL, 'IPR035671', NULL, 'DsbD gamma', 'DsbD_gamma', 3, NULL),
(27604, NULL, 'IPR039685', NULL, 'Fanconi anemia group E protein', 'FANCE', 4, NULL),
(27605, NULL, 'IPR040404', NULL, 'Phylloplanin-like', 'Phylloplanin-like', 4, NULL),
(27606, NULL, 'IPR040474', NULL, 'Get5, C-terminal domain', 'Get5_C', 3, NULL),
(27607, NULL, 'IPR040508', NULL, 'AbiJ, N-terminal domain 5', 'AbiJ_NTD5', 3, NULL),
(27608, NULL, 'IPR035725', NULL, 'Abl Interactor 1, SH3 domain', 'Abi1_SH3', 3, NULL),
(27609, NULL, 'IPR035734', NULL, 'VAV3 protein, second SH3 domain', 'VAV3_SH3_2', 3, NULL),
(27610, NULL, 'IPR038540', NULL, 'Pathogenicity island protein gp6 superfamily', 'SAPIS-gp6_sf', 5, NULL),
(27611, NULL, 'IPR040486', NULL, 'Exoribonuclease 1, domain 3', 'Xrn1_D3', 3, NULL),
(27612, NULL, 'IPR037375', NULL, 'Tyrosine-protein kinase BAZ1B, bromodomain', 'BAZ1B_Bromo', 3, NULL),
(27613, NULL, 'IPR040336', NULL, 'Uncharacterized GPI-anchored protein At1g61900-lke', 'At1g61900-like', 4, NULL),
(27614, NULL, 'IPR036746', NULL, 'TT1725-like superfamily', 'TT1725-like_sf', 5, NULL),
(27615, NULL, 'IPR035733', NULL, 'VAV2 protein, first SH3 domain', 'VAV2_SH3_1', 3, NULL),
(27616, NULL, 'IPR040412', NULL, 'Uncharacterized protein At1g65710-like', 'At1g65710-like', 4, NULL),
(27617, NULL, 'IPR040765', NULL, 'RapA, N-terminal Tudor like domain 1', 'Tudor_1_RapA', 3, NULL),
(27618, NULL, 'IPR034283', NULL, 'Ephrin type-A receptor 7, ligand binding domain', 'EphA7_rcpt_lig-bd', 3, NULL),
(27619, NULL, 'IPR038248', NULL, 'Dicer dimerisation domain superfamily', 'Dicer_dimer_sf', 5, NULL),
(27620, NULL, 'IPR040715', NULL, 'Kinetoplastid DICER, KptA ADP-ribosyltransferase domain', 'KptA_kDICER', 3, NULL),
(27621, NULL, 'IPR035732', NULL, 'VAV2 protein, second SH3 domain', 'VAV2_SH3_2', 3, NULL),
(27622, NULL, 'IPR035571', NULL, 'UPF0234-like, C-terminal', 'UPF0234-like_C', 5, NULL),
(27623, NULL, 'IPR033529', NULL, 'Mucin-7', 'MUC7', 4, NULL),
(27624, NULL, 'IPR036745', NULL, 'DNA polymerase III-theta superfamily', 'PolIII_theta_sf', 5, NULL),
(27625, NULL, 'IPR035384', NULL, 'Uncharacterized protein YhdX-like', 'YhdX-like', 4, NULL),
(27626, NULL, 'IPR040629', NULL, 'Phage spike trimer', 'Phage_spike', 3, NULL),
(27627, NULL, 'IPR040701', NULL, 'Bacterial archaeo-eukaryotic release factor family 2', 'Bact_RF_family2', 4, NULL),
(27628, NULL, 'IPR040351', NULL, 'Guanine nucleotide exchange factor RAB3IL/RAB3IP/Sec2', 'RAB3IL/RAB3IP/Sec2', 4, NULL),
(27629, NULL, 'IPR040445', NULL, 'Potassium channel, inwardly rectifying, transmembrane domain', 'Kir_TM', 3, NULL),
(27630, NULL, 'IPR036744', NULL, 'RAP domain superfamily', 'RAP_sf', 5, NULL),
(27631, NULL, 'IPR040354', NULL, 'Tectonic', 'Tectonic', 4, NULL),
(27632, NULL, 'IPR039414', NULL, 'SMG1, PIKK catalytic domain', 'SMG1_PIKKc', 3, NULL),
(27633, NULL, 'IPR040920', NULL, 'Arabinosyltransferas, concanavalin like domain', 'Arabino_trans_N', 3, NULL),
(27634, NULL, 'IPR039704', NULL, 'Myogenic factor', 'Myogenic_factor', 4, NULL),
(27635, NULL, 'IPR040533', NULL, 'Four helical bundle domain', '4HB', 3, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(27636, NULL, 'IPR040399', NULL, 'Transmembrane protein 35A/B', 'TMEM35A/B', 4, NULL),
(27637, NULL, 'IPR033134', NULL, 'Asp/Glu racemase, active site 2', 'Asp/Glu_racemase_AS_2', 0, NULL),
(27638, NULL, 'IPR035591', NULL, 'Phosphatidylinositol 3-kinase regulatory subunit alpha, SH3 domain', 'PI3K_p85alpha_SH3', 3, NULL),
(27639, NULL, 'IPR036420', NULL, 'BRCT domain superfamily', 'BRCT_dom_sf', 5, NULL),
(27640, NULL, 'IPR033744', NULL, 'RBM8, RNA recognition motif', 'RRM_RBM8', 3, NULL),
(27641, NULL, 'IPR037200', NULL, 'Pre-mRNA-splicing factor Isy1 superfamily', 'Isy1_sf', 5, NULL),
(27642, NULL, 'IPR034065', NULL, 'All0781-like, domain', 'All0781-like_dom', 3, NULL),
(27643, NULL, 'IPR040340', NULL, 'Chloroplast enhancing stress tolerance protein', 'CEST/Y3IP1', 4, NULL),
(27644, NULL, 'IPR040601', NULL, 'tRNA methyltransferase 5, N-terminal', 'Trm5_N', 3, NULL),
(27645, NULL, 'IPR037367', NULL, 'PREX2, DEP domain 1', 'Rex2_DEP_1', 3, NULL),
(27646, NULL, 'IPR036323', NULL, 'Chemokine-binding M3 superfamily', 'M3_sf_vir', 5, NULL),
(27647, NULL, 'IPR033130', NULL, 'Ribonuclease T2, His active site 2', 'RNase_T2_His_AS_2', 0, NULL),
(27648, NULL, 'IPR040357', NULL, 'Vma22/CCDC115', 'Vma22/CCDC115', 4, NULL),
(27649, NULL, 'IPR038553', NULL, 'Myoviridae tail sheath stabiliser superfamily', 'T4-gp15_tss_sf', 5, NULL),
(27650, NULL, 'IPR040657', NULL, 'GshAB, ATP-grasp-like domain', 'GshAB_ATP-grasp', 3, NULL),
(27651, NULL, 'IPR033908', NULL, 'R2-like ligand binding oxidase', 'R2LOX', 4, NULL),
(27652, NULL, 'IPR033195', NULL, 'Glycine/inosamine-phosphate amidinotransferase', 'AmidinoTrfase', 4, NULL),
(27653, NULL, 'IPR039376', NULL, 'Ferritin-like, di-iron-binding domain', 'Ferritin_CCC1_N', 3, NULL),
(27654, NULL, 'IPR039134', NULL, 'Single-strand selective monofunctional uracil DNA glycosylase', 'SMUG1', 4, NULL),
(27655, NULL, 'IPR040405', NULL, 'Uncharacterized protein DDB_G0275255-like', 'DDB_G0275255-like', 4, NULL),
(27656, NULL, 'IPR033570', NULL, 'Sodium channel modifier 1', 'SCNM1', 4, NULL),
(27657, NULL, 'IPR040923', NULL, '4-hydroxyphenylacetate decarboxylase small gamma subunit, C-terminal', 'HpdC_C', 3, NULL),
(27658, NULL, 'IPR039127', NULL, 'Multifunctional methyltransferase subunit Trm112', 'Trm112', 4, NULL),
(27659, NULL, 'IPR040042', NULL, '1,4-alpha-glucan branching enzyme MT3115-like', 'Branching_enz_MT3115-like', 4, NULL),
(27660, NULL, 'IPR040505', NULL, 'Family of unknown function DUF5537', 'DUF5537', 4, NULL),
(27661, NULL, 'IPR040965', NULL, 'Protein of unknown function DUF5559', 'DUF5559', 4, NULL),
(27662, NULL, 'IPR040542', NULL, 'HMW1 domain 2', 'HMW1_D2', 3, NULL),
(27663, NULL, 'IPR039130', NULL, 'Inner centromere protein', 'INCENP', 4, NULL),
(27664, NULL, 'IPR040402', NULL, 'DNA-directed RNA polymerase IV/V subunit 1, C-terminal', 'NRPD1_C', 3, NULL),
(27665, NULL, 'IPR040494', NULL, 'DNA topoisomerase VI, subunit B, C-terminal', 'Top6b_C', 3, NULL),
(27666, NULL, 'IPR040483', NULL, 'PatG domain', 'PatG_dom', 3, NULL),
(27667, NULL, 'IPR033646', NULL, 'CLU central domain', 'CLU-central', 3, NULL),
(27668, NULL, 'IPR037368', NULL, 'Integral membrane protein GPR155, DEP domain', 'GPR155_DEP', 3, NULL),
(27669, NULL, 'IPR036419', NULL, 'Ribosomal protein S3, C-terminal domain superfamily', 'Ribosomal_S3_C_sf', 5, NULL),
(27670, NULL, 'IPR039736', NULL, 'RNA-directed RNA polymerase L, C-terminal', 'L_poly_C', 3, NULL),
(27671, NULL, 'IPR038556', NULL, 'Tail assembly chaperone Gp13-like superfamily', 'TAC_Gp13-like_sf', 5, NULL),
(27672, NULL, 'IPR040919', NULL, 'Asparaginase/glutaminase, C-terminal', 'Asparaginase_C', 3, NULL),
(27673, NULL, 'IPR040975', NULL, 'RnaseLS-like HEPN', 'HEPN_RnaseLS', 4, NULL),
(27674, NULL, 'IPR040507', NULL, 'Protein of unknown function DUF5540', 'DUF5540', 4, NULL),
(27675, NULL, 'IPR040914', NULL, 'Repeat of uncharacterized protein PH0542', 'HEAT_UF', 7, NULL),
(27676, NULL, 'IPR037342', NULL, 'SOCS4, SOCS box domain', 'SOCS4_SOCS', 3, NULL),
(27677, NULL, 'IPR036831', NULL, 'HNS-dependent expression A superfamily', 'HdeA_sf', 5, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(27678, NULL, 'IPR040512', NULL, 'Large polyvalent-protein-associated domain 15', 'LPD15', 3, NULL),
(27679, NULL, 'IPR033928', NULL, 'Epidermal growth factor receptor kinase substrate, phosphotyrosine-binding domain', 'EPS8_PTB', 3, NULL),
(27680, NULL, 'IPR036349', NULL, 'Integrin beta tail domain superfamily', 'Integrin_bsu_tail_dom_sf', 5, NULL),
(27681, NULL, 'IPR040665', NULL, 'Tyrosine kinase receptor A, transmembrane domain', 'TrkA_TMD', 3, NULL),
(27682, NULL, 'IPR040400', NULL, 'BAG family molecular chaperone regulator 5/6/7/8', 'BAG5/6/7/8', 4, NULL),
(27683, NULL, 'IPR040493', NULL, 'Protein of unknown function DUF5518', 'DUF5518', 4, NULL),
(27684, NULL, 'IPR040329', NULL, 'Chemokine-like protein TAFA-5', 'TAFA-5', 4, NULL),
(27685, NULL, 'IPR040439', NULL, 'Protein FAM237', 'FAM237A/B', 4, NULL),
(27686, NULL, 'IPR035731', NULL, 'TRIM46, PRY/SPRY domain', 'SPRY/PRY_TRIM46', 3, NULL),
(27687, NULL, 'IPR033571', NULL, 'NEDD4-binding protein 3', 'N4BP3', 4, NULL),
(27688, NULL, 'IPR038530', NULL, '[NiFe]-hydrogenase assembly chaperone, HybE superfamily', 'NiFe-hyd_HybE_sf', 5, NULL),
(27689, NULL, 'IPR036817', NULL, 'Transthyretin/hydroxyisourate hydrolase domain superfamily', 'Transthyretin/HIU_hydrolase_sf', 5, NULL),
(27690, NULL, 'IPR040376', NULL, 'At4g28100-like', 'At4g28100-like', 4, NULL),
(27691, NULL, 'IPR035806', NULL, 'Beta-1,3-glucan recognition protein, C-terminal', 'GH16_GRP_C', 3, NULL),
(27692, NULL, 'IPR033131', NULL, 'Pectinesterase, Asp active site', 'Pectinesterase_Asp_AS', 0, NULL),
(27693, NULL, 'IPR037310', NULL, 'Rho-associated protein kinase 1, HR1', 'ROCK1_HR1', 3, NULL),
(27694, NULL, 'IPR036762', NULL, 'IscX-like superfamily', 'IscX-like_sf', 5, NULL),
(27695, NULL, 'IPR039133', NULL, 'E3 ubiquitin-protein ligase RNF25', 'RNF25', 4, NULL),
(27696, NULL, 'IPR040459', NULL, 'MJ1316 RNA cyclic group end recognition domain', 'MJ1316', 3, NULL),
(27697, NULL, 'IPR040263', NULL, 'PWWP domain-containing DNA repair factor 3A/B', 'PWP3A/B', 4, NULL),
(27698, NULL, 'IPR036827', NULL, 'She2 domain superfamily', 'She2_dom_sf', 5, NULL),
(27699, NULL, 'IPR036837', NULL, 'Cation efflux protein, cytoplasmic domain superfamily', 'Cation_efflux_CTD_sf', 5, NULL),
(27700, NULL, 'IPR039378', NULL, 'Ribonuclease T2, prokaryotic', 'RNase_T2_prok', 4, NULL),
(27701, NULL, 'IPR037307', NULL, 'TNF receptor-associated factor 4, MATH domain', 'TRAF4_MATH', 3, NULL),
(27702, NULL, 'IPR034369', NULL, 'SCAF4, RNA recognition motif', 'SCAF4_RRM', 3, NULL),
(27703, NULL, 'IPR033370', NULL, 'Conserved oligomeric Golgi complex subunit 1', 'COG1', 4, NULL),
(27704, NULL, 'IPR036418', NULL, 'Cytochrome c oxidase, subunit VIa superfamily', 'Cyt_c_oxidase_su6a_sf', 5, NULL),
(27705, NULL, 'IPR040176', NULL, 'RING finger protein RNF121/RNF175', 'RNF121/RNF175', 4, NULL),
(27706, NULL, 'IPR035088', NULL, 'Protective antigen, Ca-binding domain', 'PA_Ca-bd', 3, NULL),
(27707, NULL, 'IPR040269', NULL, 'VAN3-binding protein', 'VAB', 4, NULL),
(27708, NULL, 'IPR037224', NULL, 'PapC, N-terminal domain superfamily', 'PapC_N_sf', 5, NULL),
(27709, NULL, 'IPR040979', NULL, 'Vid27, N-terminal', 'Vid27_N', 3, NULL),
(27710, NULL, 'IPR040567', NULL, 'RctB, helix turn helix domain', 'RctB_HTH', 3, NULL),
(27711, NULL, 'IPR036616', NULL, 'Poly(ADP-ribose) polymerase, regulatory domain superfamily', 'Poly(ADP-ribose)pol_reg_dom_sf', 5, NULL),
(27712, NULL, 'IPR037994', NULL, 'Nucleoside diphosphate kinase 6', 'NDPk6', 4, NULL),
(27713, NULL, 'IPR040392', NULL, 'PKHA4-7, PH domain', 'PKHA4-7_PH', 3, NULL),
(27714, NULL, 'IPR036354', NULL, 'Proteinase inhibitor I13, potato inhibitor I superfamily', 'Prot_inh_pot1_sf', 5, NULL),
(27715, NULL, 'IPR040626', NULL, 'Cytosolic carboxypeptidase, N-terminal', 'Pepdidase_M14_N', 3, NULL),
(27716, NULL, 'IPR040963', NULL, 'Magnetochrome domain', 'MCR', 3, NULL),
(27717, NULL, 'IPR037680', NULL, 'Protein RMD5 homologue A, degenerated RING finger', 'RMD5A_dRING', 3, NULL),
(27718, NULL, 'IPR040480', NULL, 'DnaT, DNA-binding domain', 'DnaT_DNA_bind', 3, NULL),
(27719, NULL, 'IPR033331', NULL, 'Transmembrane protein 127', 'TMEM127', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(27720, NULL, 'IPR040468', NULL, 'TRAF3-interacting protein 1, N-terminal', 'TRAF3IP1_N', 3, NULL),
(27721, NULL, 'IPR040566', NULL, 'Interleukin-13 receptor subunit alpha-1, Ig-like domain', 'Il13Ra_Ig', 3, NULL),
(27722, NULL, 'IPR040333', NULL, 'Catalase, clade 3', 'Catalase_3', 4, NULL),
(27723, NULL, 'IPR037688', NULL, 'Zinc finger B-box domain-containing protein', 'ZBBX', 4, NULL),
(27724, NULL, 'IPR035522', NULL, 'Sho1, SH3 domain', 'Sho1_SH3', 3, NULL),
(27725, NULL, 'IPR039100', NULL, 'Ribosome maturation protein Sdo1/SBDS-like', 'Sdo1/SBDS-like', 4, NULL),
(27726, NULL, 'IPR037345', NULL, 'SOCS6, SOCS box domain', 'SOCS6_SOCS', 3, NULL),
(27727, NULL, 'IPR040766', NULL, 'RapA, N-terminal Tudor-like domain 2', 'Tudor_2_RapA', 3, NULL),
(27728, NULL, 'IPR037374', NULL, 'BAZ2A/BAZ2B, bromodomain', 'BAZ2A/B_Bromo', 3, NULL),
(27729, NULL, 'IPR036760', NULL, 'SspB-like superfamily', 'SspB-like_sf', 5, NULL),
(27730, NULL, 'IPR040720', NULL, 'Glycosyl hydrolase family 81, C-terminal domain', 'GH81_C', 3, NULL),
(27731, NULL, 'IPR040594', NULL, 'Unkempt, zinc finger domain 1', 'Unkempt_Znf', 3, NULL),
(27732, NULL, 'IPR037456', NULL, 'MA1715-like', 'MA1715-like', 4, NULL),
(27733, NULL, 'IPR040451', NULL, 'Glycosyl hydrolase family 81, N-terminal', 'GH81_N', 3, NULL),
(27734, NULL, 'IPR033399', NULL, 'Putative outer membrane lipoprotein-sorting protein', 'Put_LolA-like', 4, NULL),
(27735, NULL, 'IPR037579', NULL, 'Fibrinogen', 'Fibrinogen', 4, NULL),
(27736, NULL, 'IPR037685', NULL, 'RNA polymerase RBP11', 'RBP11', 4, NULL),
(27737, NULL, 'IPR040038', NULL, 'TIPIN/Csm3/Swi3', 'TIPIN/Csm3/Swi3', 4, NULL),
(27738, NULL, 'IPR040457', NULL, 'Gamma tubulin complex component, C-terminal', 'GCP_C', 3, NULL),
(27739, NULL, 'IPR040918', NULL, 'GatD, N-terminal', 'GatD_N', 3, NULL),
(27740, NULL, 'IPR033557', NULL, 'Lymphocyte expansion molecule', 'LEXM', 4, NULL),
(27741, NULL, 'IPR036356', NULL, 'Endoplasmic reticulum resident protein 29, C-terminal domain superfamily', 'ERp29_C_sf', 5, NULL),
(27742, NULL, 'IPR040968', NULL, 'MCSS domain', 'Ezh2_MCSS', 3, NULL),
(27743, NULL, 'IPR034591', NULL, 'RBM12, RNA recognition motif 1', 'RBM12_RRM1', 3, NULL),
(27744, NULL, 'IPR037488', NULL, 'Uncharacterized protein At2g33490-like', 'At2g33490-like', 4, NULL),
(27745, NULL, 'IPR036825', NULL, 'MTH865-like superfamily', 'MTH865-like_sf', 5, NULL),
(27746, NULL, 'IPR040381', NULL, 'Uncharacterized protein At4g14450-like', 'At4g14450-like', 4, NULL),
(27747, NULL, 'IPR036421', NULL, 'Iron dependent repressor, metal binding and dimerisation domain superfamily', 'Fe_dep_repressor_sf', 5, NULL),
(27748, NULL, 'IPR040661', NULL, 'Leucine zipper with capping helix domain', 'LZ3wCH', 3, NULL),
(27749, NULL, 'IPR040917', NULL, 'RalF, C-terminal Sec-7 capping domain', 'RalF_SCD', 3, NULL),
(27750, NULL, 'IPR040498', NULL, 'PriA DNA helicase, Cys-rich region (CRR) domain', 'PriA_CRR', 3, NULL),
(27751, NULL, 'IPR040541', NULL, 'Metanogen output domain 2', 'MetOD2', 3, NULL),
(27752, NULL, 'IPR036020', NULL, 'WW domain superfamily', 'WW_dom_sf', 5, NULL),
(27753, NULL, 'IPR037336', NULL, 'DEP domain-containing mTOR-interacting protein, DEP domain 2', 'DEPTOR_DEP_2', 3, NULL),
(27754, NULL, 'IPR033808', NULL, 'Burkholderia lethal factor 1', 'BPSL1549', 4, NULL),
(27755, NULL, 'IPR039131', NULL, 'Complex I intermediate-associated protein 30, mitochondrial', 'NDUFAF1', 4, NULL),
(27756, NULL, 'IPR040579', NULL, 'Acetyltransferase (GNAT) domain', 'Acetyltransf_19', 3, NULL),
(27757, NULL, 'IPR040401', NULL, 'Coiled-coil domain-containing protein 162', 'CCDC162', 4, NULL),
(27758, NULL, 'IPR040403', NULL, 'DNA-directed RNA polymerase IV/V subunit 1, N-terminal', 'NRPD1_N', 3, NULL),
(27759, NULL, 'IPR036346', NULL, 'GTP-binding protein OBG, C-terminal domain superfamily', 'GTP-bd_prot_GTP1/OBG_C_sf', 5, NULL),
(27760, NULL, 'IPR038007', NULL, 'RBP-Jkappa, IPT domain', 'RBP-Jkappa_IPT', 3, NULL),
(27761, NULL, 'IPR038559', NULL, 'Phage-like element PBSX protein XkdN-like superfamily', 'XkdN-like_sf', 5, NULL),
(27762, NULL, 'IPR040700', NULL, 'ZNRF-3, ectodomain', 'ZNRF-3_ecto', 3, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(27763, NULL, 'IPR040511', NULL, 'Adenylyl/Guanylyl and SMODS, C-terminal sensor domain', 'AGS_C', 3, NULL),
(27764, NULL, 'IPR033869', NULL, 'Phytepsin', 'Phytepsin', 3, NULL),
(27765, NULL, 'IPR033396', NULL, 'Domain of unknown function DUF5107', 'DUF5107', 4, NULL),
(27766, NULL, 'IPR038531', NULL, 'Neuraminyllactose-binding hemagglutinin superfamily', 'NeuraminylLac-bd_hemagglutn_sf', 5, NULL),
(27767, NULL, 'IPR040396', NULL, 'Polyadenylate-binding protein-interacting protein 2-like', 'PAIP2-like', 4, NULL),
(27768, NULL, 'IPR039693', NULL, 'Rtr1/RPAP2', 'Rtr1/RPAP2', 4, NULL),
(27769, NULL, 'IPR033931', NULL, 'PDK1-type, PH domain', 'PDK1-typ_PH', 3, NULL),
(27770, NULL, 'IPR040236', NULL, 'Transmembrane protein 198', 'TMEM198', 4, NULL),
(27771, NULL, 'IPR040398', NULL, 'CCR4-NOT transcription complex subunit 1', 'Not1', 4, NULL),
(27772, NULL, 'IPR033398', NULL, 'Carboxypeptidase M99, beta-barrel domain', 'M99_beta-barrel', 3, NULL),
(27773, NULL, 'IPR037681', NULL, 'Protein RMD5 homologue B, degenerated RING finger', 'RMD5B_dRING', 3, NULL),
(27774, NULL, 'IPR040374', NULL, 'Protein BIC', 'BIC', 4, NULL),
(27775, NULL, 'IPR040662', NULL, 'Transcription factor Tfb2, C-terminal domain', 'Tfb2_C', 3, NULL),
(27776, NULL, 'IPR040698', NULL, 'Hydrazine synthase alpha subunit, middle domain', 'HZS_alpha_mid', 3, NULL),
(27777, NULL, 'IPR036829', NULL, 'Hypothetical protein TM0875', 'TM0875', 5, NULL),
(27778, NULL, 'IPR040502', NULL, 'Endo-alpha-N-acetylgalactosaminidase, domain 6', 'GH101_dom-6', 3, NULL),
(27779, NULL, 'IPR040267', NULL, 'F-box protein EID1-like', 'EID1-like', 4, NULL),
(27780, NULL, 'IPR037675', NULL, 'GPI ethanolamine phosphate transferase 3, N-terminal', 'PIG-O_N', 3, NULL),
(27781, NULL, 'IPR039699', NULL, 'Ribosomal protein L7/L30', 'Ribosomal_L7/L30', 4, NULL),
(27782, NULL, 'IPR038587', NULL, 'Ribosomal protein L40e superfamily', 'L40e_sf', 5, NULL),
(27783, NULL, 'IPR040575', NULL, 'Endo-alpha-N-acetylgalactosaminidase, N-terminal', 'GH101_N', 3, NULL),
(27784, NULL, 'IPR038006', NULL, 'Transcription factor COE, IPT domain', 'COE_IPT', 3, NULL),
(27785, NULL, 'IPR039377', NULL, 'Manganese catalase, ferritin-like di-iron-binding domain', 'Mn_catalase_dom', 3, NULL),
(27786, NULL, 'IPR040764', NULL, 'Conserved virulence factor B-like, winged helix domain', 'CvfB_WH', 3, NULL),
(27787, NULL, 'IPR035728', NULL, 'Rho guanine nucleotide exchange factor 9, SH3 domain', 'ARHGEF9_SH3', 3, NULL),
(27788, NULL, 'IPR033223', NULL, 'TPA-induced transmembrane protein', 'TTMP', 4, NULL),
(27789, NULL, 'IPR036342', NULL, 'Superantigen MAM', 'MAM_sf', 5, NULL),
(27790, NULL, 'IPR040501', NULL, 'TFA2, Winged helix domain 2', 'TFA2_Winged_2', 3, NULL),
(27791, NULL, 'IPR040265', NULL, 'Protein CHUP1-like', 'CHUP1-like', 4, NULL),
(27792, NULL, 'IPR033840', NULL, 'Ubiquitin-specific peptidase 38', 'USP38', 3, NULL),
(27793, NULL, 'IPR040394', NULL, 'F-box only protein 25/32', 'FBX25/32', 4, NULL),
(27794, NULL, 'IPR040514', NULL, 'C4b-binding protein alpha, oligomerization domain', 'C4bp_oligo', 3, NULL),
(27795, NULL, 'IPR040603', NULL, 'Fanconi-associated nuclease 1, SAP domain', 'FAN1_SAP', 3, NULL),
(27796, NULL, 'IPR033841', NULL, 'Ubiquitin-specific peptidase 48', 'USP48', 3, NULL),
(27797, NULL, 'IPR038074', NULL, 'YfmB domain superfamily', 'YfmB_sf', 5, NULL),
(27798, NULL, 'IPR033909', NULL, 'Ribonucleotide reductase small subunit', 'RNR_small', 4, NULL),
(27799, NULL, 'IPR037997', NULL, 'CTP-dependent diacylglycerol kinase 1-like', 'Dgk1-like', 4, NULL),
(27800, NULL, 'IPR035521', NULL, 'Fus1, SH3 domain', 'Fus1_SH3', 3, NULL),
(27801, NULL, 'IPR036842', NULL, 'AF2331-like superfamily', 'AF2331-like_sf', 5, NULL),
(27802, NULL, 'IPR036838', NULL, 'Ribosomal protein S10 domain superfamily', 'Ribosomal_S10_dom_sf', 5, NULL),
(27803, NULL, 'IPR035526', NULL, 'Obscurin, SH3 domain', 'Obscurin_SH3', 3, NULL),
(27804, NULL, 'IPR035087', NULL, 'MatP, N-terminal', 'MatP_N', 3, NULL),
(27805, NULL, 'IPR033868', NULL, 'Xylanase inhibitor I-like', 'Xylanase_inhibitor_I-like', 3, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(27806, NULL, 'IPR038076', NULL, 'MgtE, N-terminal domain superfamily', 'MgtE_N_sf', 5, NULL),
(27807, NULL, 'IPR036836', NULL, 'Agouti domain superfamily', 'Agouti_dom_sf', 5, NULL),
(27808, NULL, 'IPR040721', NULL, 'Protein of unknown function DUF5520', 'DUF5520', 4, NULL),
(27809, NULL, 'IPR033199', NULL, 'Dimethylarginine dimethylaminohydrolase', 'DDAH', 4, NULL),
(27810, NULL, 'IPR040495', NULL, 'CCDC81-like prokaryotic HU domain 1', 'HU-CCDC81_bac_1', 3, NULL),
(27811, NULL, 'IPR038526', NULL, 'Ribosomal protein L22e superfamily', 'Ribosomal_L22e_sf', 5, NULL),
(27812, NULL, 'IPR036840', NULL, 'YqbF domain superfamily', 'YqbF_dom_sf', 5, NULL),
(27813, NULL, 'IPR036832', NULL, 'Polyphosphate kinase N-terminal domain superfamily', 'PPK_N_dom_sf', 5, NULL),
(27814, NULL, 'IPR040570', NULL, 'L-amino acid ligase, C-terminal domain 2', 'LAL_C2', 3, NULL),
(27815, NULL, 'IPR036834', NULL, 'Bcl-2-like superfamily', 'Bcl-2-like_sf', 5, NULL),
(27816, NULL, 'IPR033466', NULL, 'Cornichon, conserved site', 'Cornichon_conserved', 2, NULL),
(27817, NULL, 'IPR033558', NULL, 'Intraflagellar transport protein 25', 'IFT25', 4, NULL),
(27818, NULL, 'IPR033371', NULL, 'Arginine and glutamate-rich protein 1', 'ARGLU1', 4, NULL),
(27819, NULL, 'IPR035727', NULL, 'TRIM36, PRY/SPRY domain', 'SPRY/PRY_TRIM36', 3, NULL),
(27820, NULL, 'IPR035689', NULL, 'Sodium/iodide cotransporter', 'SLC5A5', 4, NULL),
(27821, NULL, 'IPR036351', NULL, 'Ribosomal protein L32e superfamily', 'Ribosomal_L32e_sf', 5, NULL),
(27822, NULL, 'IPR040623', NULL, '26S proteasome regulatory subunit RPN2, C-terminal', 'RPN2_C', 3, NULL),
(27823, NULL, 'IPR040535', NULL, 'NLRC4, helical domain', 'NLRC4_HD', 3, NULL),
(27824, NULL, 'IPR033332', NULL, 'BTG family', 'BTG', 4, NULL),
(27825, NULL, 'IPR038545', NULL, 'DBF-type zinc finger superfamily', 'Znf_DBF_sf', 5, NULL),
(27826, NULL, 'IPR038546', NULL, 'Hen1, N-terminal domain superfamily', 'Hen1_N_sf', 5, NULL),
(27827, NULL, 'IPR037340', NULL, 'SSB2, SOCS box domain', 'SSB2_SOCS', 3, NULL),
(27828, NULL, 'IPR040697', NULL, 'Pullulanase, N1 domain', 'PulA_N1', 3, NULL),
(27829, NULL, 'IPR040327', NULL, 'TLC domain-containing protein At5g14285-like', 'At5g14285-like', 4, NULL),
(27830, NULL, 'IPR038263', NULL, 'Lytic exoenzyme, target recognition domain superfamily', 'Lytic_exo_TRD_sf', 5, NULL),
(27831, NULL, 'IPR039135', NULL, 'N-acetyltransferase 9-like', 'NAT9-like', 4, NULL),
(27832, NULL, 'IPR036425', NULL, 'MoaB/Mog-like domain superfamily', 'MoaB/Mog-like_dom_sf', 5, NULL),
(27833, NULL, 'IPR037346', NULL, 'SOCS7, SOCS box domain', 'SOCS7_SOCS', 3, NULL),
(27834, NULL, 'IPR040476', NULL, 'RNase II/RNase R, cold shock domain', 'CSD2', 3, NULL),
(27835, NULL, 'IPR033929', NULL, 'Tensin, phosphotyrosine-binding domain', 'Tensin_PTB', 3, NULL),
(27836, NULL, 'IPR033888', NULL, 'Dihydroorotate dehydrogenase, class 1B', 'DHOD_1B', 4, NULL),
(27837, NULL, 'IPR040608', NULL, 'Snf8/Vps36 family', 'Snf8/Vps36', 4, NULL),
(27838, NULL, 'IPR036828', NULL, 'TTHA1528-like superfamily', 'TTHA1528-like_sf', 5, NULL),
(27839, NULL, 'IPR040971', NULL, 'Pleurotolysin B, C-terminal', 'PlyB_C', 3, NULL),
(27840, NULL, 'IPR039128', NULL, 'Activating signal cointegrator 1-like', 'TRIP4-like', 4, NULL),
(27841, NULL, 'IPR039697', NULL, 'Iron-type alcohol dehydrogenase-like', 'Alcohol_dehydrogenase_Fe', 4, NULL),
(27842, NULL, 'IPR037578', NULL, 'Von Willebrand factor', 'Von_Willebrand_factor', 4, NULL),
(27843, NULL, 'IPR038252', NULL, 'Ubiquitin-activating enzyme E1, C-terminal domain superfamily', 'UBA_E1_C_sf', 5, NULL),
(27844, NULL, 'IPR040395', NULL, 'Tetratricopeptide repeat protein 19', 'TTC19', 4, NULL),
(27845, NULL, 'IPR034588', NULL, 'RBM12B, RNA recognition motif 2', 'RBM12B_RRM2', 3, NULL),
(27846, NULL, 'IPR033932', NULL, 'YtcJ like', 'YtcJ-like', 4, NULL),
(27847, NULL, 'IPR040297', NULL, 'Multivesicular body subunit 12B', 'MVB12B', 4, NULL),
(27848, NULL, 'IPR040924', NULL, '5-hmdU DNA kinase', 'HMUDK/HMUD1', 4, NULL),
(27849, NULL, 'IPR040216', NULL, 'Cytotoxic T-lymphocyte protein 4/CD28', 'CTLA4/CD28', 4, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(27850, NULL, 'IPR038987', NULL, 'Molybdopterin biosynthesis protein MoeA-like', 'MoeA-like', 4, NULL),
(27851, NULL, 'IPR036818', NULL, 'Axin interactor, dorsalization-associated protein, N-terminal domain superfamily', 'AIDA_N_sf', 5, NULL),
(27852, NULL, 'IPR037309', NULL, 'TNF receptor-associated factor 6, MATH domain', 'TRAF6_MATH', 3, NULL),
(27853, NULL, 'IPR037377', NULL, 'Putative transcription factor GTE, bromodomain', 'GTE_bromo', 3, NULL),
(27854, NULL, 'IPR040177', NULL, 'Zinc transporter 9', 'SLC30A9', 4, NULL),
(27855, NULL, 'IPR040503', NULL, 'tRNA uridine(34) hydroxylase, N-terminal', 'TRHO_N', 3, NULL),
(27856, NULL, 'IPR040625', NULL, 'Restriction endonuclease, SH3 domain', 'SH3_17', 3, NULL),
(27857, NULL, 'IPR034280', NULL, 'Ephrin type-A receptor 6, ligand binding domain', 'EphA6_rcpt_lig-bd', 3, NULL),
(27858, NULL, 'IPR037371', NULL, 'Pleckstrin, DEP domain', 'PLEK_DEP', 3, NULL),
(27859, NULL, 'IPR040452', NULL, 'Sugar fermentation stimulation protein, C-terminal', 'SfsA_C', 3, NULL),
(27860, NULL, 'IPR039960', NULL, 'Mitochondrial adapter protein MCP1', 'MCP1', 4, NULL),
(27861, NULL, 'IPR040582', NULL, 'MalK, OB fold domain', 'OB_MalK', 3, NULL),
(27862, NULL, 'IPR036334', NULL, 'Bubble superfamily', 'Bubble_sf', 5, NULL),
(27863, NULL, 'IPR037677', NULL, 'CD86, IgV domain', 'CD86_IgV', 3, NULL),
(27864, NULL, 'IPR039418', NULL, 'LexA-like', 'LexA-like', 3, NULL),
(27865, NULL, 'IPR035704', NULL, 'SNX8/Mvp1, PX domain', 'SNX8/Mvp1_PX', 3, NULL),
(27866, NULL, 'IPR036815', NULL, '14-3-3 domain superfamily', '14-3-3_dom_sf', 5, NULL),
(27867, NULL, 'IPR040699', NULL, 'Xeroderma pigmentosum group B helicase, damage recognition domain', 'XPB_DRD', 3, NULL),
(27868, NULL, 'IPR038561', NULL, 'Sarcosine oxidase subunit delta superfamily', 'SoxD_sf', 5, NULL),
(27869, NULL, 'IPR039702', NULL, 'Farnesyl pyrophosphate synthase-like', 'FPS1-like', 4, NULL),
(27870, NULL, 'IPR038250', NULL, 'TGT, patch-forming C2 domain superfamily', 'TGT_C2_sf', 5, NULL),
(27871, NULL, 'IPR036423', NULL, 'Superoxide dismutase-like, copper/zinc binding domain superfamily', 'SOD-like_Cu/Zn_dom_sf', 5, NULL),
(27872, NULL, 'IPR036748', NULL, 'MTH938-like superfamily', 'MTH938-like_sf', 5, NULL),
(27873, NULL, 'IPR034594', NULL, 'RBM12, RNA recognition motif 2', 'RBM12_RRM2', 3, NULL),
(27874, NULL, 'IPR036336', NULL, 'Transcriptional repressor TraM superfamily', 'Tscrpt_rep_TraM_sf', 5, NULL),
(27875, NULL, 'IPR040925', NULL, 'Heparinase II, C-terminal', 'HepII_C', 3, NULL),
(27876, NULL, 'IPR040605', NULL, 'Glycoside hydrolase family 2, domain 5', 'Glyco_hydro2_dom5', 3, NULL),
(27877, NULL, 'IPR037674', NULL, 'GPI ethanolamine phosphate transferase 2, N-terminal', 'PIG-G_N', 3, NULL),
(27878, NULL, 'IPR038551', NULL, 'Ribosomal protein S26e superfamily', 'Ribosomal_S26e_sf', 5, NULL),
(27879, NULL, 'IPR039786', NULL, 'Protein EFR3', 'EFR3', 4, NULL),
(27880, NULL, 'IPR040491', NULL, 'Domain of unknown function DUF5626', 'DUF5626', 3, NULL),
(27881, NULL, 'IPR040484', NULL, 'LepB GAP domain, C-terminal subdomain', 'LepB_GAP_C', 3, NULL),
(27882, NULL, 'IPR037311', NULL, 'Rho-associated protein kinase 2, HR1 domain', 'ROCK2_HR1', 3, NULL),
(27883, NULL, 'IPR033132', NULL, 'Glycosyl hydrolases family 1, N-terminal conserved site', 'Glyco_hydro_1_N_CS', 2, NULL),
(27884, NULL, 'IPR040510', NULL, 'Astrotactin-2, C-terminal beta-hairpin domain', 'ASTN_2_hairpin', 3, NULL),
(27885, NULL, 'IPR040926', NULL, 'Cellular tumor antigen p53, transactivation domain 2', 'p53_TAD2', 3, NULL),
(27886, NULL, 'IPR040355', NULL, 'Protein FAM220A', 'FAM220A', 4, NULL),
(27887, NULL, 'IPR040977', NULL, 'HP1451, C-terminal', 'HP1451_C', 3, NULL),
(27888, NULL, 'IPR040485', NULL, 'Exportin-1, repeat 3', 'XPO1_repeat_3', 7, NULL),
(27889, NULL, 'IPR035064', NULL, 'p21-activated kinase 2, catalytic domain', 'STK_PAK2', 3, NULL),
(27890, NULL, 'IPR037306', NULL, 'TNF receptor-associated factor 1, MATH domain', 'TRAF1_MATH', 3, NULL),
(27891, NULL, 'IPR035086', NULL, 'Domain of unknown function DUF1611, P-loop', 'DUF1611_C', 3, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(27892, NULL, 'IPR036344', NULL, 'Fungal immunomodulatory protein FIP-Fve superfamily', 'FIP_sf', 5, NULL),
(27893, NULL, 'IPR038042', NULL, 'Gp37-like domain superfamily', 'Gp37-like', 5, NULL),
(27894, NULL, 'IPR040477', NULL, 'Lysine-specific demethylase 4, Tudor domain', 'KDM4_Tudor_2', 3, NULL),
(27895, NULL, 'IPR040628', NULL, 'Bacterial archaeo-eukaryotic release factor family 6', 'BaeRF_family6', 4, NULL),
(27896, NULL, 'IPR037683', NULL, 'Rmd5, degenerated RING (dRING) finger', 'Rmd5_dRing', 3, NULL),
(27897, NULL, 'IPR033886', NULL, 'Dihydroorotate dehydrogenase, class 1A', 'DHOD_1A', 4, NULL),
(27898, NULL, 'IPR036767', NULL, 'ApaG domain superfamily', 'ApaG_sf', 5, NULL),
(27899, NULL, 'IPR040338', NULL, 'Putative F-box protein At1g67623-like', 'At1g67623-like', 4, NULL),
(27900, NULL, 'IPR040352', NULL, 'Transmembrane and ubiquitin-like domain-containing protein 1/2', 'TMUB1/2', 4, NULL),
(27901, NULL, 'IPR038549', NULL, 'SeBP-like superfamily', 'SeBP-like_sf', 5, NULL),
(27902, NULL, 'IPR040384', NULL, 'Orcokinin peptides type A/B', 'ORCKA/B', 4, NULL),
(27903, NULL, 'IPR038555', NULL, 'Zincin-like metallopeptidase superfamily', 'Zincin_1_sf', 5, NULL),
(27904, NULL, 'IPR036826', NULL, 'Cytochrome f large domain superfamily', 'Cyt_f_lg_dom_sf', 5, NULL),
(27905, NULL, 'IPR040326', NULL, 'HAP2/GCS1', 'HAP2/GCS1', 4, NULL),
(27906, NULL, 'IPR040714', NULL, 'RAP80, N-terminal', 'RAP80_UIM', 3, NULL),
(27907, NULL, 'IPR037495', NULL, 'CLAVATA3/ESR (CLE)-related protein 41/44', 'CLE41/44', 4, NULL),
(27908, NULL, 'IPR036064', NULL, 'Class XVIII myosin, motor domain', 'MYSc_Myo18', 3, NULL),
(27909, NULL, 'IPR033395', NULL, 'Domain of unknown function DUF5106', 'DUF5106', 3, NULL),
(27910, NULL, 'IPR040534', NULL, 'Calcium binding protein SSO6904', 'Ca_bind_SSO6904', 3, NULL),
(27911, NULL, 'IPR040509', NULL, 'CdiI, C-terminal', 'CdiI_C', 3, NULL),
(27912, NULL, 'IPR036822', NULL, 'Copper homeostasis (CutC) domain superfamily', 'CutC_dom_sf', 5, NULL),
(27913, NULL, 'IPR037392', NULL, 'YfmP, Helix-Turn-Helix DNA binding domain', 'YfmP_HTH', 3, NULL),
(27914, NULL, 'IPR036415', NULL, 'Lamin tail domain superfamily', 'Lamin_tail_dom_sf', 5, NULL),
(27915, NULL, 'IPR036008', NULL, 'Aconitase, iron-sulfur domain', 'Aconitase_4Fe-4S_dom', 5, NULL),
(27916, NULL, 'IPR033561', NULL, 'Fas-binding factor 1', 'FBF1', 4, NULL),
(27917, NULL, 'IPR037684', NULL, 'Guanylate-binding protein, C-terminal', 'GBP_C', 3, NULL),
(27918, NULL, 'IPR033866', NULL, 'Plasmepsin 5', 'Plasmepsin_5', 3, NULL),
(27919, NULL, 'IPR036824', NULL, 'Nucleoplasmin core domain superfamily', 'Nucleoplasmin_core_dom_sf', 5, NULL),
(27920, NULL, 'IPR033755', NULL, 'PdxS/SNZ N-terminal domain', 'PdxS/SNZ_N', 3, NULL),
(27921, NULL, 'IPR036327', NULL, 'Bacteriophage T4, Gp8 superfamily', 'Gp8_sf', 5, NULL),
(27922, NULL, 'IPR038532', NULL, 'NADH dehydrogenase ubiquinone Fe-S protein 4-like superfamily', 'NDUFS4-like_sf', 5, NULL),
(27923, NULL, 'IPR040506', NULL, 'RACo linker region', 'RACo_linker', 3, NULL),
(27924, NULL, 'IPR033129', NULL, 'Phosphoenolpyruvate carboxylase, His active site', 'PEPCASE_His_AS', 0, NULL),
(27925, NULL, 'IPR036758', NULL, 'At5g01610-like superfamily', 'At5g01610-like', 5, NULL),
(27926, NULL, 'IPR040596', NULL, 'RNase II-type exonuclease, C-terminal S1 domain', 'RNase_II_C_S1', 3, NULL),
(27927, NULL, 'IPR036332', NULL, 'L-A virus major coat protein superfamily', 'Major_coat_LA-virus_sf', 5, NULL),
(27928, NULL, 'IPR038251', NULL, 'PdxB, dimerisation domain superfamily', 'PdxB_dimer_sf', 5, NULL),
(27929, NULL, 'IPR040497', NULL, 'Glucosyltransferase 24, catalytic domain', 'Glyco_transf_24', 3, NULL),
(27930, NULL, 'IPR040576', NULL, 'Dynamin-like helical domain', 'DLP_helical', 3, NULL),
(27931, NULL, 'IPR040349', NULL, 'Monopolin complex subunit Csm1/Pcs1', 'Csm1/Pcs1', 4, NULL),
(27932, NULL, 'IPR040915', NULL, 'GK1464-like domain', 'GK1464-like_dom', 3, NULL),
(27933, NULL, 'IPR036821', NULL, 'Peptide deformylase superfamily', 'Peptide_deformylase_sf', 5, NULL),
(27934, NULL, 'IPR040393', NULL, 'Three-prime repair exonuclease 1/2', 'TREX1/2', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(27935, NULL, 'IPR037676', NULL, 'CD80, IgC-like domain', 'CD80_IgC', 3, NULL),
(27936, NULL, 'IPR040913', NULL, 'Htr2, transmembrane domain', 'Htr2', 3, NULL),
(27937, NULL, 'IPR037312', NULL, 'Protein kinase C-like, HR1 domain', 'PKC-like_HR1', 3, NULL),
(27938, NULL, 'IPR033034', NULL, 'NADH dehydrogenase [ubiquinone] 1 beta subcomplex subunit 9', 'NDUFB9', 4, NULL),
(27939, NULL, 'IPR035569', NULL, 'Antitoxin epsilon/PezA domain superfamily', 'Antitoxin_epsilon/PezA_dom_sf', 5, NULL),
(27940, NULL, 'IPR040254', NULL, 'Protein Ecm3-like', 'Ecm3-like', 4, NULL),
(27941, NULL, 'IPR040538', NULL, 'Cch, helix turn helix domain', 'Cch_HTH', 3, NULL),
(27942, NULL, 'IPR040973', NULL, 'Inactive serine protease scarface, clip-domain', 'CLIP_SPH_Scar', 3, NULL),
(27943, NULL, 'IPR036417', NULL, 'Tobacco mosaic virus-like, coat protein superfamily', 'TMV-like_coat_sf', 5, NULL),
(27944, NULL, 'IPR040213', NULL, 'GIR2-like', 'GIR2-like', 4, NULL),
(27945, NULL, 'IPR036019', NULL, 'Large-conductance mechanosensitive channel MscL', 'MscL_channel', 5, NULL),
(27946, NULL, 'IPR040569', NULL, 'Reverse gyrase, zinc finger', 'Znf_Rg', 3, NULL),
(27947, NULL, 'IPR035807', NULL, 'Pyruvate dehydrogenase E1 component, N-terminal', 'PDC_E1_N', 3, NULL),
(27948, NULL, 'IPR040473', NULL, 'NusG, additional domain', 'NusG_add', 3, NULL),
(27949, NULL, 'IPR035703', NULL, 'SNX18, PX domain', 'SNX18_PX', 3, NULL),
(27950, NULL, 'IPR040916', NULL, 'DD-reactivating factor swiveling domain', 'DDR_swiveling', 3, NULL),
(27951, NULL, 'IPR033534', NULL, 'Mucin-21', 'MUC21', 4, NULL),
(27952, NULL, 'IPR034063', NULL, 'Fervidolysin domain', 'Fervidolysin_dom', 3, NULL),
(27953, NULL, 'IPR038766', NULL, 'Membrane component of ABC transporter, predicted', 'Membrane_comp_ABC_pdt', 4, NULL),
(27954, NULL, 'IPR039413', NULL, 'RON, Sema domain', 'RON_Sema', 3, NULL),
(27955, NULL, 'IPR035825', NULL, 'Alpha Spectrin, SH3 domain', 'Alpha_Spectrin_SH3', 3, NULL),
(27956, NULL, 'IPR040397', NULL, 'Suppressor of white apricot', 'SWAP', 4, NULL),
(27957, NULL, 'IPR040627', NULL, 'T3SS EscN ATPase, C-terminal', 'T3SS_ATPase_C', 3, NULL),
(27958, NULL, 'IPR036830', NULL, 'Polyphosphate kinase middle domain superfamily', 'PP_kinase_middle_dom_sf', 5, NULL),
(27959, NULL, 'IPR037998', NULL, 'Maternal protein exuperantia', 'Exu', 4, NULL),
(27960, NULL, 'IPR036319', NULL, 'RDM1 superfamily', 'RDM1_sf', 5, NULL),
(27961, NULL, 'IPR040928', NULL, 'Importin repeat', 'Importin_rep_5', 7, NULL),
(27962, NULL, 'IPR040228', NULL, 'Insulin-related peptide, invertebrates', 'Insulin-relat-peptide_inver', 4, NULL),
(27963, NULL, 'IPR040411', NULL, 'Uncharacterized protein At5g23160-like', 'At5g23160-like', 4, NULL),
(27964, NULL, 'IPR036325', NULL, 'Bacteriophage PRD1, P2, absorption protein superfamily', 'P2_sf', 5, NULL),
(27965, NULL, 'IPR033551', NULL, 'Dynein regulatory complex subunit 7', 'DRC7/lobo', 4, NULL),
(27966, NULL, 'IPR040455', NULL, 'Atg6, BARA domain', 'Atg6_BARA', 3, NULL),
(27967, NULL, 'IPR040587', NULL, '5-3 exonuclease XRN1, DCP1-binding motif', 'XRN1_DBM', 3, NULL),
(27968, NULL, 'IPR034061', NULL, 'Autotransporter serine protease peptidase domain', 'Peptidases_S8_Autotransporter', 3, NULL),
(27969, NULL, 'IPR035063', NULL, 'p21-activated kinase 3, catalytic domain', 'STK_PAK3', 3, NULL),
(27970, NULL, 'IPR037679', NULL, 'Anaphase-promoting complex subunit 5', 'Apc5', 4, NULL),
(27971, NULL, 'IPR040305', NULL, 'At1g75730-like', 'At1g75730-like', 4, NULL),
(27972, NULL, 'IPR040663', NULL, 'DNA polymerase delta subunit, OB-fold domain', 'DNA_pol_D_N', 3, NULL),
(27973, NULL, 'IPR040377', NULL, 'Thylakoid membrane protein Ssl2009-like', 'Ssl2009-like', 4, NULL),
(27974, NULL, 'IPR036839', NULL, '7,8-dihydroneopterin aldolase (MptD) superfamily', 'MptD_sf', 5, NULL),
(27975, NULL, 'IPR040059', NULL, 'Pumilio homologue 3', 'PUM3', 4, NULL),
(27976, NULL, 'IPR040712', NULL, 'Phosphofructokinase, N-terminal domain', 'Pfk_N', 3, NULL),
(27977, NULL, 'IPR036010', NULL, '2Fe-2S ferredoxin-like superfamily', '2Fe-2S_ferredoxin-like_sf', 5, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(27978, NULL, 'IPR033930', NULL, 'FAM43A/B, phosphotyrosine-binding domain', 'FAM43A/B_PTB', 3, NULL),
(27979, NULL, 'IPR036741', NULL, 'TAFII-230 TBP-binding domain superfamily', 'TAFII-230_TBP-bd_sf', 5, NULL),
(27980, NULL, 'IPR036341', NULL, 'Her-1 superfamily', 'Her-1_sf', 5, NULL),
(27981, NULL, 'IPR040624', NULL, 'Halobacterial output domain 1', 'HalOD1', 3, NULL),
(27982, NULL, 'IPR037485', NULL, 'Peroxisome biogenesis protein 22', 'PEX22', 4, NULL),
(27983, NULL, 'IPR040981', NULL, 'Fatty acid synthase subunit PfaD, N-terminal', 'PfaD_N', 3, NULL),
(27984, NULL, 'IPR035808', NULL, 'Ribosomal protein L7, eukaryotic/archaeal', 'Ribosomal_L7_euk_arc', 3, NULL),
(27985, NULL, 'IPR035382', NULL, 'Mating factor A1', 'MFA1', 4, NULL),
(27986, NULL, 'IPR033690', NULL, 'Adenylate kinase, conserved site', 'Adenylat_kinase_CS', 2, NULL),
(27987, NULL, 'IPR040347', NULL, 'YAP1-binding protein 1/2', 'YBP1/2', 4, NULL),
(27988, NULL, 'IPR040713', NULL, 'Domain of unknown function DUF5611', 'DUF5611', 3, NULL),
(27989, NULL, 'IPR040339', NULL, 'Uncharacterized membrane protein At1g16860-like', 'At1g16860-like', 4, NULL),
(27990, NULL, 'IPR037378', NULL, 'PIKfyve, DEP domain', 'PIKfyve_DEP', 3, NULL),
(27991, NULL, 'IPR037337', NULL, 'Dip2-like domain', 'Dip2-like_dom', 3, NULL),
(27992, NULL, 'IPR040410', NULL, 'UPF0658 Golgi apparatus membrane protein', 'UPF0658_Golgi', 4, NULL),
(27993, NULL, 'IPR040472', NULL, 'Synaptic functional regulator FMRP, KH0 domain', 'FMRP_KH0', 3, NULL),
(27994, NULL, 'IPR040578', NULL, 'UPF0242, C-terminal PAS-like domain', 'UPF0242_PAS', 3, NULL),
(27995, NULL, 'IPR035658', NULL, 'Conjugal transfer protein TrbF', 'TrbF', 3, NULL),
(27996, NULL, 'IPR040330', NULL, 'LYR motif-containing protein 1', 'LYRM1', 4, NULL),
(27997, NULL, 'IPR038257', NULL, 'CRISPR-associated Cas3-type HD domain superfamily', 'CRISPR-assoc_Cas3_HD_sf', 5, NULL),
(27998, NULL, 'IPR040513', NULL, 'Mutator 2, fork head associated domain', 'MU2_FHA', 3, NULL),
(27999, NULL, 'IPR040341', NULL, 'G patch domain-containing protein 3', 'GPATCH3', 4, NULL),
(28000, NULL, 'IPR036820', NULL, 'Archease domain superfamily', 'Archease_dom_sf', 5, NULL),
(28001, NULL, 'IPR035641', NULL, 'GRB2, N-terminal SH3 domain', 'GRB2_N_SH3', 3, NULL),
(28002, NULL, 'IPR036428', NULL, 'Pterin 4 alpha carbinolamine dehydratase superfamily', 'PCD_sf', 5, NULL),
(28003, NULL, 'IPR036940', NULL, 'Phosphatidylinositol 3-/4-kinase, catalytic domain superfamily', 'PI3/4_kinase_cat_sf', 5, NULL),
(28004, NULL, 'IPR033292', NULL, 'Thy-1 membrane glycoprotein', 'THY1', 4, NULL),
(28005, NULL, 'IPR036012', NULL, 'TBC1D8B, PH-GRAM domain 1', 'TBC1D8B_PH-GRAM1', 3, NULL),
(28006, NULL, 'IPR040647', NULL, 'SPIN-DOC-like, zinc-finger', 'SPIN-DOC_Znf-C2H2', 3, NULL),
(28007, NULL, 'IPR033468', NULL, 'Metaxin, glutathione S-transferase domain', 'Metaxin_GST', 3, NULL),
(28008, NULL, 'IPR040637', NULL, '60S ribosomal protein L10P, insertion domain', 'RL10P_insert', 3, NULL),
(28009, NULL, 'IPR036649', NULL, 'Inorganic pyrophosphatase superfamily', 'Pyrophosphatase_sf', 5, NULL),
(28010, NULL, 'IPR036960', NULL, 'T-box superfamily', 'T-box_sf', 5, NULL),
(28011, NULL, 'IPR039116', NULL, 'Coiled-coil domain-containing protein 93', 'CCDC93', 4, NULL),
(28012, NULL, 'IPR039691', NULL, 'Zinc finger CCCH domain-containing protein A/B', 'ZC3H7A/B', 4, NULL),
(28013, NULL, 'IPR040653', NULL, 'Csd3, N-terminal', 'Csd3_N', 3, NULL),
(28014, NULL, 'IPR035128', NULL, 'Viral unique short region 10', 'US10', 4, NULL),
(28015, NULL, 'IPR037122', NULL, 'Pleiotrophin/Midkine, N-terminal domain superfamily', 'PTN/MK_N_dom_sf', 5, NULL),
(28016, NULL, 'IPR033688', NULL, 'RNA cytidine acetyltransferase NAT10', 'NAT10', 4, NULL),
(28017, NULL, 'IPR040643', NULL, 'Murine leukemia virus integrase, C-terminal', 'MLVIN_C', 3, NULL),
(28018, NULL, 'IPR036999', NULL, 'Diol/glycerol dehydratase, large subunit superfamily', 'Diol/glycerol_deHase_lsu_sf', 5, NULL),
(28019, NULL, 'IPR036347', NULL, 'Erythronolide synthase, docking domain superfamily', 'DEBS_docking_sf', 5, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(28020, NULL, 'IPR041028', NULL, 'Cdc13, OB4 dimerization domain', 'Cdc13_OB4_dimer', 3, NULL),
(28021, NULL, 'IPR036641', NULL, 'HPT domain superfamily', 'HPT_dom_sf', 5, NULL),
(28022, NULL, 'IPR040974', NULL, 'Purple acid phosphatase, Fn3-like domain', 'Fn3_PAP', 3, NULL),
(28023, NULL, 'IPR040679', NULL, 'PTX/LNS-Like (PLL) domain', 'PLL', 3, NULL),
(28024, NULL, 'IPR037103', NULL, 'Tubulin/FtsZ-like, C-terminal domain', 'Tubulin/FtsZ-like_C', 5, NULL),
(28025, NULL, 'IPR036009', NULL, 'TBC1D8, PH-GRAM domain 1', 'TBC1D8_PH-GRAM1', 3, NULL),
(28026, NULL, 'IPR040983', NULL, 'Bacterial archaeo-eukaryotic release factor family 5', 'Bact_RF_family5', 4, NULL),
(28027, NULL, 'IPR036954', NULL, 'Collagen IV, non-collagenous domain superfamily', 'Collagen_IV_NC_sf', 5, NULL),
(28028, NULL, 'IPR040682', NULL, 'HscB, tetracysteine metal binding motif', 'HscB_4_cys', 3, NULL),
(28029, NULL, 'IPR037104', NULL, 'Annexin superfamily', 'Annexin_sf', 5, NULL),
(28030, NULL, 'IPR034453', NULL, 'MEI2-like, RNA recognition motif 1', 'MEI2-like_RRM1', 3, NULL),
(28031, NULL, 'IPR040687', NULL, 'Protein of unknown function DUF5586', 'DUF5586', 4, NULL),
(28032, NULL, 'IPR037136', NULL, 'RNA 3''-terminal phosphate cyclase domain superfamily', 'RNA3''_phos_cyclase_dom_sf', 5, NULL),
(28033, NULL, 'IPR033693', NULL, 'Pyroglutamyl peptidase I, Glu active site', 'PGPEP1_Glu_AS', 0, NULL),
(28034, NULL, 'IPR039808', NULL, 'Cadherin', 'Cadherin', 4, NULL),
(28035, NULL, 'IPR040640', NULL, 'Myosin X, N-terminal SH3 domain', 'MyoX_N_SH3', 3, NULL),
(28036, NULL, 'IPR036874', NULL, 'Carbonic anhydrase superfamily', 'Carbonic_anhydrase_sf', 5, NULL),
(28037, NULL, 'IPR037004', NULL, 'Exonuclease VII, small subunit superfamily', 'Exonuc_VII_ssu_sf', 5, NULL),
(28038, NULL, 'IPR040870', NULL, 'HEN1, double-stranded RNA binding domain 2', 'HEN1_dsRBD2', 3, NULL),
(28039, NULL, 'IPR036878', NULL, 'Glucose permease domain IIB', 'Glu_permease_IIB', 5, NULL),
(28040, NULL, 'IPR037120', NULL, 'Haem peroxidase domain superfamily, animal type', 'Haem_peroxidase_sf_animal', 5, NULL),
(28041, NULL, 'IPR041041', NULL, 'Protein of unknown function DUF5539', 'DUF5539', 4, NULL),
(28042, NULL, 'IPR035640', NULL, 'Endophilin B2, SH3 domain', 'Endophilin_B2_SH3', 3, NULL),
(28043, NULL, 'IPR035227', NULL, 'Protein HdcB', 'HdcB', 4, NULL),
(28044, NULL, 'IPR036645', NULL, 'Elafin-like superfamily', 'Elafin-like_sf', 5, NULL),
(28045, NULL, 'IPR040635', NULL, 'D-ribitol-5-phosphate cytidylyltransferase, C-terminal', 'ISPD_C', 3, NULL),
(28046, NULL, 'IPR035739', NULL, 'Intersectin-2, third SH3 domain', 'Intersectin-2_SH3_3', 3, NULL),
(28047, NULL, 'IPR040649', NULL, 'Bacterial HORMA domain', 'Bact_HORMA', 3, NULL),
(28048, NULL, 'IPR036042', NULL, 'Class XVI myosin, motor domain', 'MYSc_Myo16', 3, NULL),
(28049, NULL, 'IPR040618', NULL, 'Pre-nudix hydrolase domain', 'Pre-Nudix', 3, NULL),
(28050, NULL, 'IPR035126', NULL, 'Secreted clade V protein', 'SCVP', 4, NULL),
(28051, NULL, 'IPR039208', NULL, 'C2 calcium-dependent domain-containing protein 4', 'C2_Ca-dependent_4', 4, NULL),
(28052, NULL, 'IPR037772', NULL, 'Freud, C2 domain', 'C2_Freud', 3, NULL),
(28053, NULL, 'IPR034904', NULL, 'Fe-S cluster assembly domain superfamily', 'FSCA_dom_sf', 5, NULL),
(28054, NULL, 'IPR037742', NULL, 'FGD4, N-terminal PH domain', 'FDG4_N_PH', 3, NULL),
(28055, NULL, 'IPR035741', NULL, 'Intersectin-2, fifth SH3 domain', 'Intersectin-2_SH3_5', 3, NULL),
(28056, NULL, 'IPR040964', NULL, 'OAA-family lectin sugar binding domain', 'SBD', 3, NULL),
(28057, NULL, 'IPR035399', NULL, 'Protein of unknown function DUF5413', 'DUF5413', 4, NULL),
(28058, NULL, 'IPR035127', NULL, 'Uncharacterized strongylid L4 protein', 'SL4P', 4, NULL),
(28059, NULL, 'IPR037779', NULL, 'SynGAP, PH domain', 'SynGAP_PH', 3, NULL),
(28060, NULL, 'IPR039038', NULL, 'Aspartyl/asparaginyl beta-hydroxylase family', 'ASPH', 4, NULL),
(28061, NULL, 'IPR037007', NULL, 'Epstein Barr virus nuclear antigen-1, DNA-binding domain superfamily', 'EBNA1_DNA-bd_sf', 5, NULL),
(28062, NULL, 'IPR036228', NULL, 'ATP synthase, F0 complex, subunit D superfamily, mitochondrial', 'ATP_synth_F0_dsu_sf_mt', 5, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(28063, NULL, 'IPR033351', NULL, 'Centrosomal protein POC5', 'POC5', 4, NULL),
(28064, NULL, 'IPR036959', NULL, 'Peptidase C12, ubiquitin carboxyl-terminal hydrolase superfamily', 'Peptidase_C12_UCH_sf', 5, NULL),
(28065, NULL, 'IPR036964', NULL, 'Ras guanine-nucleotide exchange factor, catalytic domain superfamily', 'RASGEF_cat_dom_sf', 5, NULL),
(28066, NULL, 'IPR037129', NULL, 'XPA domain superfamily', 'XPA_sf', 5, NULL),
(28067, NULL, 'IPR036201', NULL, 'Pacifastin domain superfamily', 'Pacifastin_dom_sf', 5, NULL),
(28068, NULL, 'IPR040972', NULL, 'ALMS repeat', 'ALMS_repeat', 7, NULL),
(28069, NULL, 'IPR036017', NULL, 'TCB1D9/TCB1D9B, PH-GRAM domain 2', 'TCB1D9/TCB1D9B_PH-GRAM2', 3, NULL),
(28070, NULL, 'IPR039112', NULL, 'Phosphotyrosine interaction domain containing 1', 'PID1', 4, NULL),
(28071, NULL, 'IPR036430', NULL, 'Ribonuclease T2-like superfamily', 'RNase_T2-like_sf', 5, NULL),
(28072, NULL, 'IPR040709', NULL, 'Importin 13, repeat 1', 'Importin_rep_1', 7, NULL),
(28073, NULL, 'IPR036106', NULL, 'Class VII myosin, motor domain', 'MYSc_Myo7', 3, NULL),
(28074, NULL, 'IPR035612', NULL, 'SH3RF3, SH3 domain 3', 'SH3RF3_SH3_3', 3, NULL),
(28075, NULL, 'IPR037137', NULL, 'Cucumovirus coat protein, subunit A superfamily', 'Cucumovirus_coat_Asu_sf', 5, NULL),
(28076, NULL, 'IPR037781', NULL, 'SKAP family', 'SKAP_fam', 4, NULL),
(28077, NULL, 'IPR036941', NULL, 'Receptor L-domain superfamily', 'Rcpt_L-dom_sf', 5, NULL),
(28078, NULL, 'IPR037743', NULL, 'FGD6, N-terminal PH domain', 'FGD6_N_PH', 3, NULL),
(28079, NULL, 'IPR040994', NULL, 'SUN coiled coil domain 2', 'Sun_CC2', 3, NULL),
(28080, NULL, 'IPR034451', NULL, 'RNA-binding protein 27, RNA recognition motif', 'RBM27_RRM', 3, NULL),
(28081, NULL, 'IPR040711', NULL, 'Immunomodulating metalloprotease N-terminal domain', 'IMPa_N_2', 3, NULL),
(28082, NULL, 'IPR040970', NULL, 'CadC C-terminal domain 1', 'CadC_C1', 3, NULL),
(28083, NULL, 'IPR037107', NULL, 'Putative outer membrane protein superfamily', 'Put_OMP_sf', 5, NULL),
(28084, NULL, 'IPR033602', NULL, 'Protein pitchfork', 'Pitchfork', 4, NULL),
(28085, NULL, 'IPR041030', NULL, 'SHIRT domain', 'SHIRT', 3, NULL),
(28086, NULL, 'IPR035738', NULL, 'Intersectin-2, second SH3 domain', 'Intersectin-2_SH3_2', 3, NULL),
(28087, NULL, 'IPR036391', NULL, 'Thionin-like superfamily', 'Thionin-like_sf', 5, NULL),
(28088, NULL, 'IPR040978', NULL, 'Hypothetical protein TT1725', 'TT1725', 3, NULL),
(28089, NULL, 'IPR035611', NULL, 'c-Cbl associated protein, SH3 domain 2', 'SORBS1_SH3_2', 3, NULL),
(28090, NULL, 'IPR040651', NULL, 'Large polyvalent protein-associated domain 5', 'LPD5', 3, NULL),
(28091, NULL, 'IPR036348', NULL, 'WIBG, N-terminal domain superfamily', 'WIBG_N_sf', 5, NULL),
(28092, NULL, 'IPR036457', NULL, 'PPM-type phosphatase-like domain superfamily', 'PPM-type-like_dom_sf', 5, NULL),
(28093, NULL, 'IPR040683', NULL, 'Surface adhesin CshA, non-repetitive domain 2', 'CshA_NR2', 3, NULL),
(28094, NULL, 'IPR040634', NULL, 'Arginine decarboxylase, helical bundle domain', 'Arg_decarb_HB', 3, NULL),
(28095, NULL, 'IPR035861', NULL, 'SOCS1, SH2 domain', 'SOCS1_SH2', 3, NULL),
(28096, NULL, 'IPR036390', NULL, 'Winged helix DNA-binding domain superfamily', 'WH_DNA-bd_sf', 5, NULL),
(28097, NULL, 'IPR040872', NULL, 'Fibrillin 1, unique N-terminal domain', 'Fibrillin_U_N', 3, NULL),
(28098, NULL, 'IPR036862', NULL, 'Integrase, C-terminal domain superfamily, retroviral', 'Integrase_C_dom_sf_retrovir', 5, NULL),
(28099, NULL, 'IPR037000', NULL, 'Ski-like, DNA-binding domain superfamily', 'Ski_DNA-bd_sf', 5, NULL),
(28100, NULL, 'IPR040672', NULL, 'Large polyvalent protein associated domain 34', 'LPD34', 3, NULL),
(28101, NULL, 'IPR040708', NULL, 'Domain of of unknown function DUF5636', 'DUF5636', 3, NULL),
(28102, NULL, 'IPR040779', NULL, 'Protein of unknown function DUF5538', 'DUF5538', 4, NULL),
(28103, NULL, 'IPR036997', NULL, 'Proteasome activator PA28, C-terminal domain superfamily', 'PA28_C_sf', 5, NULL),
(28104, NULL, 'IPR039111', NULL, 'Signal-transducing adaptor protein STAP1/STAP2', 'STAP1/STAP2', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(28105, NULL, 'IPR040782', NULL, 'KfrB domain', 'KfrB', 3, NULL),
(28106, NULL, 'IPR036331', NULL, 'Chagasin-like superfamily', 'Chagasin-like_sf', 5, NULL),
(28107, NULL, 'IPR039706', NULL, 'Major intrinsically disordered Notch2-binding receptor 1-like', 'MINAR1-like', 4, NULL),
(28108, NULL, 'IPR036427', NULL, 'Bromodomain-like superfamily', 'Bromodomain-like_sf', 5, NULL),
(28109, NULL, 'IPR033698', NULL, 'Plk4, second cryptic polo-box domain', 'POLO_box_Plk4_2', 3, NULL),
(28110, NULL, 'IPR035226', NULL, 'Protein of unknown function DUF5450', 'DUF5450', 4, NULL),
(28111, NULL, 'IPR040632', NULL, 'Sulfotransferase, S. mansonii-type', 'Sulfotransfer_4', 4, NULL),
(28112, NULL, 'IPR037124', NULL, 'GroES chaperonin superfamily', 'Chaperonin_GroES_sf', 5, NULL),
(28113, NULL, 'IPR039659', NULL, 'Transcription elongation factor SPT5', 'SPT5', 4, NULL),
(28114, NULL, 'IPR036861', NULL, 'Endochitinase-like superfamily', 'Endochitinase-like_sf', 5, NULL),
(28115, NULL, 'IPR039657', NULL, 'Dimethylallyltransferase', 'Dimethylallyltransferase', 4, NULL),
(28116, NULL, 'IPR036240', NULL, 'Gp9-like superfamily', 'Gp9-like_sf', 5, NULL),
(28117, NULL, 'IPR037010', NULL, 'Vitamin B12-dependent methionine synthase, activation domain superfamily', 'VitB12-dep_Met_synth_activ_sf', 5, NULL),
(28118, NULL, 'IPR040729', NULL, 'Kazal-type serine protease inhibitor domain', 'Kazal_3', 3, NULL),
(28119, NULL, 'IPR039744', NULL, '40S ribosomal protein S29/30S ribosomal protein S14 type Z', '40S_S29/30S_S14z', 4, NULL),
(28120, NULL, 'IPR036637', NULL, 'Phosphohistidine domain superfamily', 'Phosphohistidine_dom_sf', 5, NULL),
(28121, NULL, 'IPR035547', NULL, 'Phospholipase B', 'Phospholipase_B', 3, NULL),
(28122, NULL, 'IPR036202', NULL, 'DNA topoisomerase I, DNA binding, eukaryotic-type, N-terminal domain superfamily', 'TopoI_DNA-bd_euk_N_sf', 5, NULL),
(28123, NULL, 'IPR040652', NULL, 'Cry35Ab1 , HTH C-terminal domain', 'Cry35Ab1_HTH', 3, NULL),
(28124, NULL, 'IPR033270', NULL, 'VPRBP/DCAF1 family', 'VPRBP/DCAF1', 4, NULL),
(28125, NULL, 'IPR036320', NULL, 'Glycosyl transferase family 3, N-terminal domain superfamily', 'Glycosyl_Trfase_fam3_N_dom_sf', 5, NULL),
(28126, NULL, 'IPR036607', NULL, 'Glucosidase 2 subunit beta-like', 'PRKCSH', 3, NULL),
(28127, NULL, 'IPR036944', NULL, 'Peptidyl-prolyl cis-trans isomerase, FKBP-type, N-terminal domain superfamily', 'PPIase_FKBP_N_sf', 5, NULL),
(28128, NULL, 'IPR036326', NULL, 'Spike S1 subunit, receptor binding domain superfamily, betacoronavirus', 'Spike_S1_RBD_sf_bCoV', 5, NULL),
(28129, NULL, 'IPR036939', NULL, 'Copper type II, ascorbate-dependent monooxygenase, N-terminal domain superfamily', 'Cu2_ascorb_mOase_N_sf', 5, NULL),
(28130, NULL, 'IPR038020', NULL, 'MbtH-like domain superfamily', 'MbtH-like_sf', 5, NULL),
(28131, NULL, 'IPR033961', NULL, 'Exocyst complex component Exo84', 'Exo84', 4, NULL),
(28132, NULL, 'IPR037857', NULL, 'MTMR1, PH-GRAM', 'MTMR1_PH-GRAM', 3, NULL),
(28133, NULL, 'IPR036200', NULL, 'Attachment protein G3P, N-terminal domain superfamily', 'Attachment_G3P_N_sf', 5, NULL),
(28134, NULL, 'IPR040696', NULL, 'Large polyvalent protein associated domain 23', 'LPD23', 3, NULL),
(28135, NULL, 'IPR033294', NULL, 'Erlin1/2', 'Erlin1/2', 4, NULL),
(28136, NULL, 'IPR036345', NULL, 'Exoribonuclease, PH domain 2 superfamily', 'ExoRNase_PH_dom2_sf', 5, NULL),
(28137, NULL, 'IPR037143', NULL, '4''-phosphopantetheinyl transferase domain superfamily', '4-PPantetheinyl_Trfase_dom_sf', 5, NULL),
(28138, NULL, 'IPR036437', NULL, 'Outer surface protein C-like superfamily', 'OspC-like_sf', 5, NULL),
(28139, NULL, 'IPR040622', NULL, 'Integrin beta, epidermal growth factor-like domain 1', 'I-EGF_1', 3, NULL),
(28140, NULL, 'IPR033696', NULL, 'Plk4, C-terminal polo-box domain', 'POLO_box_Plk4_C', 3, NULL),
(28141, NULL, 'IPR040642', NULL, 'Histidine kinase receptor ArcB, transmembrane domain', 'HKR_ArcB_TM', 3, NULL),
(28142, NULL, 'IPR037745', NULL, 'Small G protein signalling modulator 1/2, PH domain', 'SGSM1/2', 3, NULL),
(28143, NULL, 'IPR039715', NULL, 'Zinc finger CCHC domain-containing protein 10', 'ZCCHC10', 4, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(28144, NULL, 'IPR040650', NULL, 'Cell division control protein 13, OB2 domain', 'Cdc13_OB2', 3, NULL),
(28145, NULL, 'IPR040466', NULL, 'NF-kappa-B-activating protein', 'NKAP', 4, NULL),
(28146, NULL, 'IPR036956', NULL, 'Impact, N-terminal domain superfamily', 'Impact_N_sf', 5, NULL),
(28147, NULL, 'IPR040707', NULL, 'Phosphoribosylformylglycinamidine synthase, N-terminal', 'FGAR-AT_N', 3, NULL),
(28148, NULL, 'IPR036962', NULL, 'Glycoside hydrolase, family 3, N-terminal domain superfamily', 'Glyco_hydro_3_N_sf', 5, NULL),
(28149, NULL, 'IPR036392', NULL, 'PLAT/LH2 domain superfamily', 'PLAT/LH2_dom_sf', 5, NULL),
(28150, NULL, 'IPR035129', NULL, 'Viral unique short region 6', 'US6', 4, NULL),
(28151, NULL, 'IPR033706', NULL, 'Methionine synthase, B12-binding domain', 'Met_synthase_B12-bd', 3, NULL),
(28152, NULL, 'IPR036872', NULL, 'CH domain superfamily', 'CH_dom_sf', 5, NULL),
(28153, NULL, 'IPR033772', NULL, 'UPA domain', 'UPA', 3, NULL),
(28154, NULL, 'IPR040191', NULL, 'U3 small nucleolar RNA-associated protein 10', 'UTP10', 4, NULL),
(28155, NULL, 'IPR036868', NULL, 'TusA-like domain superfamily', 'TusA-like_sf', 5, NULL),
(28156, NULL, 'IPR035748', NULL, 'Tyrosine-protein kinase Lyn, SH3 domain', 'Lyn_SH3', 3, NULL),
(28157, NULL, 'IPR041002', NULL, 'RK-1-like defensin', 'Defensin_RK-1', 3, NULL),
(28158, NULL, 'IPR035537', NULL, 'Disks large homologue 5, SH3 domain', 'DLG5_SH3', 3, NULL),
(28159, NULL, 'IPR037135', NULL, 'DUF1653-like domain superfamily', 'DUF1653-like_dom_sf', 5, NULL),
(28160, NULL, 'IPR037012', NULL, 'NanQ anomerase/TabA/YiaL superfamily', 'NanQ/TabA/YiaL_sf', 5, NULL),
(28161, NULL, 'IPR036458', NULL, 'Sodium:dicarboxylate symporter superfamily', 'Na:dicarbo_symporter_sf', 5, NULL),
(28162, NULL, 'IPR035258', NULL, 'Protein of unknown function DUF5350', 'DUF5350', 4, NULL),
(28163, NULL, 'IPR036441', NULL, 'Dehydroquinase, class II superfamily', 'DHquinase_II_sf', 5, NULL),
(28164, NULL, 'IPR037747', NULL, 'Dok-7, PH domain', 'Dok-7_PH', 3, NULL),
(28165, NULL, 'IPR036936', NULL, 'CRIB domain superfamily', 'CRIB_dom_sf', 5, NULL),
(28166, NULL, 'IPR035740', NULL, 'Intersectin-2, fourth SH3 domain', 'Intersectin-2_SH3_4', 3, NULL),
(28167, NULL, 'IPR036943', NULL, 'Fibronectin type II domain superfamily', 'FN_type2_sf', 5, NULL),
(28168, NULL, 'IPR037957', NULL, 'GAS7, F-BAR domain', 'GAS7_F-BAR', 3, NULL),
(28169, NULL, 'IPR039114', NULL, 'PID1, PTB domain', 'PID1_PTB', 3, NULL),
(28170, NULL, 'IPR035737', NULL, 'Intersectin-2, first SH3 domain', 'Intersectin-2_SH3_1', 3, NULL),
(28171, NULL, 'IPR037113', NULL, 'Histone acetyl transferase 1, N-terminal domain superfamily', 'Hat1_N_sf', 5, NULL),
(28172, NULL, 'IPR040776', NULL, 'ThcOx helix turn helix domain', 'ThcOx_HTH', 3, NULL),
(28173, NULL, 'IPR036343', NULL, 'Glutamyl-tRNA reductase, N-terminal domain superfamily', 'GluRdtase_N_sf', 5, NULL),
(28174, NULL, 'IPR036858', NULL, 'Cyclin-dependent kinase, regulatory subunit superfamily', 'Cyclin-dep_kinase_reg-sub_sf', 5, NULL),
(28175, NULL, 'IPR035747', NULL, 'Embryonal Fyn-associated substrate, SH3 domain', 'EFS_SH3', 3, NULL),
(28176, NULL, 'IPR036436', NULL, 'Disintegrin domain superfamily', 'Disintegrin_dom_sf', 5, NULL),
(28177, NULL, 'IPR035257', NULL, 'Protein of unknown function DUF5349', 'DUF5349', 4, NULL),
(28178, NULL, 'IPR036879', NULL, 'Transcription factor, MADS-box superfamily', 'TF_MADSbox_sf', 5, NULL),
(28179, NULL, 'IPR040706', NULL, 'MYST, zinc finger domain', 'Zf-MYST', 3, NULL),
(28180, NULL, 'IPR039660', NULL, 'Ribosomal protein L14', 'Ribosomal_protein_L14', 4, NULL),
(28181, NULL, 'IPR040638', NULL, 'N-terminal PilZ-like domain', 'PilZN1', 3, NULL),
(28182, NULL, 'IPR036942', NULL, 'TonB-dependent receptor-like, beta-barrel domain superfamily', 'TonB_rcpt_b-brl_sf', 5, NULL),
(28183, NULL, 'IPR036103', NULL, 'Class V myosin, motor domain', 'MYSc_Myo5', 3, NULL),
(28184, NULL, 'IPR037009', NULL, 'mRNA triphosphatase Cet1-like superfamily', 'mRNA_triPase_Cet1_sf', 5, NULL),
(28185, NULL, 'IPR036231', NULL, 'Avirulence B/C superfamily', 'Avirulence_B/C_sf', 5, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(28186, NULL, 'IPR037126', NULL, 'PdaC/RsiV-like superfamily', 'PdaC/RsiV-like_sf', 5, NULL),
(28187, NULL, 'IPR040695', NULL, 'EcpB, C-terminal', 'EcpB_C', 3, NULL),
(28188, NULL, 'IPR040655', NULL, 'TIAM1, CC-Ex domain', 'TIAM1_CC-Ex', 3, NULL),
(28189, NULL, 'IPR037125', NULL, 'Lipoprotein YajI-like superfamily', 'YajI-like_sf', 5, NULL),
(28190, NULL, 'IPR033708', NULL, 'Isoleucyl tRNA synthetase type 1, anticodon-binding domain', 'Anticodon_Ile_BEm', 3, NULL),
(28191, NULL, 'IPR040728', NULL, 'Domain of unknown function DUF5635', 'DUF5635', 3, NULL),
(28192, NULL, 'IPR036867', NULL, 'R3H domain superfamily', 'R3H_dom_sf', 5, NULL),
(28193, NULL, 'IPR034440', NULL, 'Putative RNA-binding protein 47, RNA recognition motif 2', 'RBM47_RRM2', 3, NULL),
(28194, NULL, 'IPR036631', NULL, 'Methylated DNA-protein cysteine methyltransferase domain superfamily', 'MGMT_N_sf', 5, NULL),
(28195, NULL, 'IPR037011', NULL, 'Phycoerythrin-like alpha chain superfamily', 'Phycoerythr-like_a_sf', 5, NULL),
(28196, NULL, 'IPR033773', NULL, 'CBX family C-terminal motif', 'CBX7_C', 2, NULL),
(28197, NULL, 'IPR039117', NULL, 'RING finger protein 17', 'RNF17', 4, NULL),
(28198, NULL, 'IPR036388', NULL, 'Winged helix-like DNA-binding domain superfamily', 'WH-like_DNA-bd_sf', 5, NULL),
(28199, NULL, 'IPR037003', NULL, 'Translocated intimin receptor, central domain superfamily', 'Tir_central_sf', 5, NULL),
(28200, NULL, 'IPR040736', NULL, 'Mex67, RNA recognition motif', 'Mex67_RRM', 3, NULL),
(28201, NULL, 'IPR036610', NULL, 'PEBP-like superfamily', 'PEBP-like_sf', 5, NULL),
(28202, NULL, 'IPR035229', NULL, 'Protein of unknown function DUF5447', 'DUF5447', 4, NULL),
(28203, NULL, 'IPR039711', NULL, 'Protein GDF5OS, mitochondrial', 'GDF5OS', 4, NULL),
(28204, NULL, 'IPR037018', NULL, 'Glycoside hydrolase family 65, N-terminal domain superfamily', 'Glyco_hydro_65_N_sf', 5, NULL),
(28205, NULL, 'IPR037128', NULL, 'Quinolinate phosphoribosyl transferase, N-terminal domain superfamily', 'Quinolinate_PRibosylTase_N_sf', 5, NULL),
(28206, NULL, 'IPR037123', NULL, 'Phosphoribosylglycinamide synthetase, C-domain superfamily', 'PRibGlycinamide_synth_C_sf', 5, NULL),
(28207, NULL, 'IPR039690', NULL, 'U11/U12 small nuclear ribonucleoprotein 25kDa protein', 'SNRNP25', 4, NULL),
(28208, NULL, 'IPR037112', NULL, 'Pyruvate-flavodoxin oxidoreductase, EKR domain superfamily', 'Pyrv-flavodox_OxR_EKR_sf', 5, NULL),
(28209, NULL, 'IPR035034', NULL, 'Grb14, SH2 domain', 'Grb14_SH2', 3, NULL),
(28210, NULL, 'IPR037008', NULL, 'Cytochrome bc1 complex subunit Rieske, transmembrane domain superfamily', 'bc1_Rieske_TM_sf', 5, NULL),
(28211, NULL, 'IPR035031', NULL, 'Vav, SH2 domain, invertebrate', 'Vav_SH2_invertebrate', 3, NULL),
(28212, NULL, 'IPR036938', NULL, 'Phosphatidic acid phosphatase type 2/haloperoxidase superfamily', 'P_Acid_Pase_2/haloperoxi_sf', 5, NULL),
(28213, NULL, 'IPR040731', NULL, 'Metal-independent restriction enzyme BfiI, DNA binding domain', 'BfiI_DBD', 3, NULL),
(28214, NULL, 'IPR040667', NULL, 'Tyrosine-protein kinase receptor Ret, cadherin like domain 3', 'Ret_CLD3', 3, NULL),
(28215, NULL, 'IPR039040', NULL, 'NAB family', 'NAB_fam', 4, NULL),
(28216, NULL, 'IPR040646', NULL, 'Fanconi anemia core complex-associated protein 24, pseudonuclease domain', 'PND', 3, NULL),
(28217, NULL, 'IPR037020', NULL, 'Hemocyanin, C-terminal domain superfamily', 'Hemocyanin_C_sf', 5, NULL),
(28218, NULL, 'IPR036014', NULL, 'TCB1D9/TCB1D9B, PH-GRAM domain 1', 'TCB1D9/TCB1D9B_PH-GRAM1', 3, NULL),
(28219, NULL, 'IPR035607', NULL, 'Vinexin, SH3 domain 3', 'Vinexin_SH3_3', 3, NULL),
(28220, NULL, 'IPR036633', NULL, 'Orn/Lys/Arg decarboxylase, C-terminal domain superfamily', 'Prn/Lys/Arg_de-COase_C_sf', 5, NULL),
(28221, NULL, 'IPR040993', NULL, 'Histone chaperone Rtt106, N-terminal domain', 'Rtt106_N', 3, NULL),
(28222, NULL, 'IPR040689', NULL, 'SUVR5, C2H2-type Zinc finger, 3 repeats', 'SUVR5_Znf-C2H2_3rpt', 7, NULL),
(28223, NULL, 'IPR035243', NULL, 'TamA, POTRA domain 1', 'TamA_POTRA_Dom_1', 3, NULL),
(28224, NULL, 'IPR034445', NULL, 'Putative RNA-binding protein 47, RNA recognition motif 3', 'RBM47_RRM3', 3, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(28225, NULL, 'IPR040786', NULL, 'RXLR phytopathogen effector protein, WY-domain', 'RXLR_WY', 3, NULL),
(28226, NULL, 'IPR040976', NULL, 'Fungal-type protein kinase', 'Pkinase_fungal', 3, NULL),
(28227, NULL, 'IPR039753', NULL, 'mRNA cap guanine-N7 methyltransferase', 'RG7MT1', 4, NULL),
(28228, NULL, 'IPR036955', NULL, 'AP2/ERF domain superfamily', 'AP2/ERF_dom_sf', 5, NULL),
(28229, NULL, 'IPR040741', NULL, 'Amino acid:DNA transferase', 'ADDT', 3, NULL),
(28230, NULL, 'IPR037139', NULL, 'von Hippel-Lindau disease tumour suppressor, alpha domain superfamily', 'VHL_alpha_dom_sf', 5, NULL),
(28231, NULL, 'IPR033749', NULL, 'Polyprenyl synthetase, conserved site', 'Polyprenyl_synt_CS', 2, NULL),
(28232, NULL, 'IPR036870', NULL, 'Ribosomal protein S18 superfamily', 'Ribosomal_S18_sf', 5, NULL),
(28233, NULL, 'IPR037119', NULL, 'Haem oxygenase HugZ-like superfamily', 'Haem_oxidase_HugZ-like_sf', 5, NULL),
(28234, NULL, 'IPR040969', NULL, 'Insulin receptor, trans-membrane domain', 'Insulin_TMD', 3, NULL),
(28235, NULL, 'IPR036328', NULL, 'C-type lysozyme inhibitor superfamily', 'MliC_sf', 5, NULL),
(28236, NULL, 'IPR037130', NULL, 'Copper metallothionein superfamily', 'Cup1_sf', 5, NULL),
(28237, NULL, 'IPR036877', NULL, 'SUI1 domain superfamily', 'SUI1_dom_sf', 5, NULL),
(28238, NULL, 'IPR036373', NULL, 'Ribosomal protein L17 superfamily', 'Ribosomal_L17_sf', 5, NULL),
(28239, NULL, 'IPR036996', NULL, 'Proteasome activator PA28, N-terminal domain superfamily', 'PA28_N_sf', 5, NULL),
(28240, NULL, 'IPR037786', NULL, 'Tandem C2 domains nuclear protein, C2A domain', 'C2A_Tac2-N', 3, NULL),
(28241, NULL, 'IPR040733', NULL, 'Zyg-1, polo box domain 1', 'Zyg-1_PB1', 3, NULL),
(28242, NULL, 'IPR037118', NULL, 'Valyl-tRNA synthetase, tRNA-binding arm superfamily', 'Val-tRNA_synth_C_sf', 5, NULL),
(28243, NULL, 'IPR035238', NULL, 'Protein of unknown function DUF5345', 'DUF5345', 4, NULL),
(28244, NULL, 'IPR037102', NULL, 'Zinc finger, large T-antigen D1 domain superfamily', 'Znf_lg_T-Ag_D1_dom_sf', 5, NULL),
(28245, NULL, 'IPR035534', NULL, 'DBS, PH domain', 'DBS_PH', 3, NULL),
(28246, NULL, 'IPR033702', NULL, 'Polo-like kinase 1, catalytic domain', 'PLK1_cat', 3, NULL),
(28247, NULL, 'IPR035246', NULL, 'Spermidine synthase, tetramerisation domain', 'Spermidine_synt_N', 3, NULL),
(28248, NULL, 'IPR033275', NULL, 'E3 ubiquitin-protein ligase MARCH-like', 'MARCH-like', 4, NULL),
(28249, NULL, 'IPR037503', NULL, 'rRNA-processing protein Fcf1, PIN domain', 'Fcf1_PIN', 3, NULL),
(28250, NULL, 'IPR034659', NULL, 'Atypical protein kinase C, catalytic domain', 'Atypical_PKC', 3, NULL),
(28251, NULL, 'IPR040681', NULL, 'Cilia- and flagella-associated protein HOATZ-like', 'HOATZ-like', 4, NULL),
(28252, NULL, 'IPR035606', NULL, 'c-Cbl associated protein, SH3 domain', 'SORBS1_SH3', 3, NULL),
(28253, NULL, 'IPR036235', NULL, 'Ribosomal protein L7/L12, oligomerisation domain superfamily', 'Ribosomal_L7/L12_oligo_N_sf', 5, NULL),
(28254, NULL, 'IPR035253', NULL, 'Putative lipoprotein, bacteria', 'Lipoprotein_22_bac', 4, NULL),
(28255, NULL, 'IPR033756', NULL, 'Flagellum site-determining protein YlxH/ Fe-S cluster assembling factor NBP35', 'YlxH/NBP35', 4, NULL),
(28256, NULL, 'IPR034464', NULL, 'PARP-10, RNA recognition motif 1 and 2', 'PAR10_RRM1_2', 3, NULL),
(28257, NULL, 'IPR036998', NULL, 'Porin, LamB-type superfamily', 'Porin_LamB_sf', 5, NULL),
(28258, NULL, 'IPR036003', NULL, 'MTMR7, PH-GRAM domain', 'MTMR7_PH-GRAM', 3, NULL),
(28259, NULL, 'IPR037109', NULL, 'AMP nucleoside phosphorylase, N-terminal domain superfamily', 'AMP_N_sf', 5, NULL),
(28260, NULL, 'IPR035565', NULL, 'Nck1, SH3 domain 3', 'Nck1_SH3_3', 3, NULL),
(28261, NULL, 'IPR040999', NULL, 'Maltokinase N-terminal cap domain', 'Mak_N_cap', 3, NULL),
(28262, NULL, 'IPR040192', NULL, 'CUE domain-containing protein 1', 'CUEDC1', 4, NULL),
(28263, NULL, 'IPR036965', NULL, 'Terpene synthase, N-terminal domain superfamily', 'Terpene_synth_N_sf', 5, NULL),
(28264, NULL, 'IPR036995', NULL, 'Methylpurine-DNA glycosylase superfamily', 'MPG_sf', 5, NULL),
(28265, NULL, 'IPR036957', NULL, 'Zinc finger, PARP-type superfamily', 'Znf_PARP_sf', 5, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(28266, NULL, 'IPR039708', NULL, 'Probable membrane protein MT1774/Rv1733c-like', 'MT1774/Rv1733c-like', 4, NULL),
(28267, NULL, 'IPR036329', NULL, 'Aromatic amino acid monoxygenase, C-terminal domain superfamily', 'Aro-AA_hydroxylase_C_sf', 5, NULL),
(28268, NULL, 'IPR036865', NULL, 'CRAL-TRIO lipid binding domain superfamily', 'CRAL-TRIO_dom_sf', 5, NULL),
(28269, NULL, 'IPR035563', NULL, 'Splicing factor 3A subunit 1, ubiquitin domain', 'SF3As1_ubi', 3, NULL),
(28270, NULL, 'IPR033504', NULL, 'Agglutinin-like protein', 'ALS', 4, NULL),
(28271, NULL, 'IPR037744', NULL, 'ARHGEF18, PH domain', 'ARHGEF18_PH', 3, NULL),
(28272, NULL, 'IPR037746', NULL, 'Protein Dok-7', 'Dok-7', 4, NULL),
(28273, NULL, 'IPR035535', NULL, 'Fungal myosin-I, SH3 domain', 'Fungal_myosin-I_SH3', 3, NULL),
(28274, NULL, 'IPR040703', NULL, 'Limiting CO2-inducible protein B/C, beta carbonyic anhydrase domain', 'LCIB/C_CA', 3, NULL),
(28275, NULL, 'IPR039362', NULL, 'Autophagy-related protein 29 superfamily', 'ATG29_sf', 5, NULL),
(28276, NULL, 'IPR040727', NULL, 'Nicotinate phosphoribosyltransferase, N-terminal domain', 'NAPRTase_N', 3, NULL),
(28277, NULL, 'IPR033590', NULL, 'Protein phosphatase 1 regulatory subunit 35', 'PPP1R35', 4, NULL),
(28278, NULL, 'IPR036429', NULL, 'SpoA-like superfamily', 'SpoA-like_sf', 5, NULL),
(28279, NULL, 'IPR036369', NULL, 'High potential iron-sulphur protein superfamily', 'HIPIP_sf', 5, NULL),
(28280, NULL, 'IPR040780', NULL, '6S proteasome subunit Rpn6, C-terminal helix domain', 'Rpn6_C_helix', 3, NULL),
(28281, NULL, 'IPR040195', NULL, 'CUE domain-containing protein 1, CUE domain', 'CUE_CUED1', 3, NULL),
(28282, NULL, 'IPR036044', NULL, 'Class XIV myosin, motor domain', 'MYSc_Myo14', 3, NULL),
(28283, NULL, 'IPR037101', NULL, 'Photosystem I reaction centre subunit PsaK', 'PSI_PsaK_bact', 5, NULL),
(28284, NULL, 'IPR036624', NULL, 'Hcp1-like superfamily', 'Hcp1-lik_sf', 5, NULL),
(28285, NULL, 'IPR035744', NULL, 'Cas scaffolding protein family member 4, SH3 domain', 'CASS4_SH3', 3, NULL),
(28286, NULL, 'IPR036393', NULL, 'Acetylglutamate kinase-like superfamily', 'AceGlu_kinase-like_sf', 5, NULL),
(28287, NULL, 'IPR035998', NULL, 'MTMR6, PH-GRAM domain', 'MTMR6_PH-GRAM', 3, NULL),
(28288, NULL, 'IPR039036', NULL, 'Granulin family', 'Granulin_fam', 4, NULL),
(28289, NULL, 'IPR036935', NULL, 'Ribosomal protein L9, N-terminal domain superfamily', 'Ribosomal_L9_N_sf', 5, NULL),
(28290, NULL, 'IPR036445', NULL, 'GPCR family 2, extracellular hormone receptor domain superfamily', 'GPCR_2_extracell_dom_sf', 5, NULL),
(28291, NULL, 'IPR041006', NULL, 'Morc, S5 domain 2-like', 'Morc_S5', 3, NULL),
(28292, NULL, 'IPR040631', NULL, 'Large polyvalent protein associated domain 30', 'LPD30', 3, NULL),
(28293, NULL, 'IPR039714', NULL, 'Transmembrane protein 134', 'TMEM134', 4, NULL),
(28294, NULL, 'IPR035125', NULL, 'Protein ORF45', 'ORF45', 4, NULL),
(28295, NULL, 'IPR033694', NULL, 'Pyroglutamyl peptidase I, Cys active site', 'PGPEP1_Cys_AS', 0, NULL),
(28296, NULL, 'IPR036238', NULL, 'Transglutaminase, C-terminal domain superfamily', 'Transglutaminase_C_sf', 5, NULL),
(28297, NULL, 'IPR036339', NULL, 'PUB-like domain superfamily', 'PUB-like_dom_sf', 5, NULL),
(28298, NULL, 'IPR040788', NULL, 'MAE_28990/MAE_18760-like HEPN', 'HEPN_MAE_28990', 3, NULL),
(28299, NULL, 'IPR039754', NULL, 'Pre-rRNA-processing protein Esf1', 'Esf1', 4, NULL),
(28300, NULL, 'IPR037133', NULL, 'Tetrahydrodipicolinate-N-succinyltransferase, N-terminal domain superfamily', 'THP_succinylTrfase_N_sf', 5, NULL),
(28301, NULL, 'IPR036629', NULL, 'YjbJ superfamily', 'YjbJ_sf', 5, NULL),
(28302, NULL, 'IPR039809', NULL, 'Chemokine beta/gamma/delta', 'Chemokine_b/g/d', 4, NULL),
(28303, NULL, 'IPR036199', NULL, 'Portal protein Gp10 superfamily', 'Gp10_sf', 5, NULL),
(28304, NULL, 'IPR039709', NULL, 'Putative antitoxin VapB3-like', 'VapB3-like', 4, NULL),
(28305, NULL, 'IPR036452', NULL, 'Ribonucleoside hydrolase-like', 'Ribo_hydro-like', 5, NULL),
(28306, NULL, 'IPR036871', NULL, 'PX domain superfamily', 'PX_dom_sf', 5, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(28307, NULL, 'IPR039041', NULL, 'Nav/unc-53 family', 'Nav/unc-53', 4, NULL),
(28308, NULL, 'IPR040685', NULL, 'Annexin-like domain', 'Annexin-like', 3, NULL),
(28309, NULL, 'IPR040871', NULL, 'HopA1 effector protein', 'HopA1', 4, NULL),
(28310, NULL, 'IPR036337', NULL, 'Matrilin, coiled-coil domain superfamily', 'Matrilin_cc_sf', 5, NULL),
(28311, NULL, 'IPR040742', NULL, 'Peptidoglycan hydrolase LytB, WW-like domain', 'LytB_WW-like', 3, NULL),
(28312, NULL, 'IPR035609', NULL, 'Vinexin, SH3 domain 1', 'Vinexin_SH3_1', 3, NULL),
(28313, NULL, 'IPR038019', NULL, 'Phosphoribosyl-AMP cyclohydrolase domain superfamily', 'PRib_AMP_CycHydrolase_sf', 5, NULL),
(28314, NULL, 'IPR037015', NULL, 'Aerolysin/Pertussis toxin (APT), N-terminal domain superfamily', 'APT_N_sf', 5, NULL),
(28315, NULL, 'IPR036863', NULL, 'Photosystem II reaction centre protein H superfamily', 'PSII_PsbH_sf', 5, NULL),
(28316, NULL, 'IPR034454', NULL, 'MEI2-like, RNA recognition motif 3', 'MEI2-like_RRM3', 3, NULL),
(28317, NULL, 'IPR035735', NULL, 'Shank1, SH3 domain', 'Shank1_SH3', 3, NULL),
(28318, NULL, 'IPR035648', NULL, 'srGAP1/2/3, SH3 domain', 'srGAP1/2/3_SH3', 3, NULL),
(28319, NULL, 'IPR036333', NULL, 'RNA synthesis protein NSP10 superfamily, coronavirus', 'NSP10_sf_CoV', 5, NULL),
(28320, NULL, 'IPR036433', NULL, 'Elongation factor EF1B gamma, C-terminal domain superfamily', 'EF1B_G_C_sf', 5, NULL),
(28321, NULL, 'IPR036004', NULL, 'MTMR10, PH-GRAM domain', 'MTMR10_PH-GRAM', 3, NULL),
(28322, NULL, 'IPR036859', NULL, 'CAP Gly-rich domain superfamily', 'CAP-Gly_dom_sf', 5, NULL),
(28323, NULL, 'IPR041031', NULL, 'RNF31, C-terminal', 'RNF31_C', 3, NULL),
(28324, NULL, 'IPR035255', NULL, 'Domain of unknown function DUF5348', 'DUF5348', 3, NULL),
(28325, NULL, 'IPR040735', NULL, 'Protein of unknown function DUF5583', 'DUF5583', 4, NULL),
(28326, NULL, 'IPR035260', NULL, 'Filaments in between nuclei protein-1', 'Fin1', 4, NULL),
(28327, NULL, 'IPR039254', NULL, 'Protein Rds1', 'Rds1', 4, NULL),
(28328, NULL, 'IPR036324', NULL, 'Manganese/iron superoxide dismutase, N-terminal domain superfamily', 'Mn/Fe_SOD_N_sf', 5, NULL),
(28329, NULL, 'IPR036869', NULL, 'Chaperone J-domain superfamily', 'J_dom_sf', 5, NULL),
(28330, NULL, 'IPR035137', NULL, 'Discriminator of mRNA degradation', 'Dmd', 4, NULL),
(28331, NULL, 'IPR036963', NULL, 'Tat domain superfamily', 'Tat_dom_sf', 5, NULL),
(28332, NULL, 'IPR035235', NULL, 'Protein of unknown function DUF5343', 'DUF5343', 4, NULL),
(28333, NULL, 'IPR041043', NULL, 'Domain of unknown function DUF5622', 'DUF5622', 3, NULL),
(28334, NULL, 'IPR039707', NULL, 'Macrophage-expressed gene 1 protein', 'MPEG1', 4, NULL),
(28335, NULL, 'IPR036618', NULL, 'PtsI, HPr-binding domain superfamily', 'PtsI_HPr-bd_sf', 5, NULL),
(28336, NULL, 'IPR037956', NULL, 'RGS6, RGS domain', 'RGS6_RGS', 3, NULL),
(28337, NULL, 'IPR039110', NULL, 'KNL2-like', 'KNL2-like', 4, NULL),
(28338, NULL, 'IPR037785', NULL, 'C2CD5, C2 domain', 'C2_C2CD5', 3, NULL),
(28339, NULL, 'IPR040654', NULL, 'LasR-specific antiactivator QslA', 'QslA', 3, NULL),
(28340, NULL, 'IPR037117', NULL, 'Dihydroorotate dehydrogenase, electron transfer subunit, Fe-S binding domain superfamily', 'Dihydroorotate_DH_ele_sf', 5, NULL),
(28341, NULL, 'IPR035037', NULL, 'Grb10, SH2', 'Grb10_SH2', 3, NULL),
(28342, NULL, 'IPR037005', NULL, 'S-ribosylhomocysteinase (LuxS) superfamily', 'LuxS_sf', 5, NULL),
(28343, NULL, 'IPR041025', NULL, 'Homing endonuclease associated repeat', 'HNH_repeat', 7, NULL),
(28344, NULL, 'IPR040669', NULL, 'Agarase, CBM-like domain', 'Agarase_CBM', 3, NULL),
(28345, NULL, 'IPR035248', NULL, 'PRMT5, oligomerisation domain', 'PRMT5_C', 3, NULL),
(28346, NULL, 'IPR035604', NULL, 'MPP3, SH3 domain', 'MPP3_SH3', 3, NULL),
(28347, NULL, 'IPR036242', NULL, 'Agglutinin domain superfamily', 'Agglutinin_dom_sf', 5, NULL),
(28348, NULL, 'IPR037002', NULL, 'Microviridae F protein superfamily', 'Microviridae_protein_F_sf', 5, NULL),
(28349, NULL, 'IPR037784', NULL, 'Serine/threonine-protein kinase N, C2 domain', 'C2_PKN', 3, NULL),
(28350, NULL, 'IPR035855', NULL, 'STAT3, SH2 domain', 'STAT3_SH2', 3, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(28351, NULL, 'IPR036961', NULL, 'Kinesin motor domain superfamily', 'Kinesin_motor_dom_sf', 5, NULL),
(28352, NULL, 'IPR035240', NULL, 'SprT-like, zinc ribbon domain', 'SprT_Zn_ribbon', 3, NULL),
(28353, NULL, 'IPR037131', NULL, 'Homeo-prospero domain superfamily', 'Homeo_prospero_dom_sf', 5, NULL),
(28354, NULL, 'IPR039042', NULL, 'UDP-N-acetylglucosamine transferase subunit Alg13-like', 'Alg13-like', 4, NULL),
(28355, NULL, 'IPR036459', NULL, 'Viral capsid core domain supefamily, Hepatitis B virus', 'Viral_capsid_core_dom_sf_HBV', 5, NULL),
(28356, NULL, 'IPR035645', NULL, 'GRAP, N-terminal SH3 domain', 'GRAP_N_SH3', 3, NULL),
(28357, NULL, 'IPR036876', NULL, 'UVR domain superfamily', 'UVR_dom_sf', 5, NULL),
(28358, NULL, 'IPR040666', NULL, 'Atg29, N-terminal', 'Atg29_N', 3, NULL),
(28359, NULL, 'IPR033689', NULL, 'NAD-dependent formate dehydrogenase', 'FDH_NAD-dep', 4, NULL),
(28360, NULL, 'IPR040675', NULL, 'E3 ubiquitin-protein ligase AMFR, Ube2g2-binding region', 'AMFR_Ube2g2-bd', 3, NULL),
(28361, NULL, 'IPR037111', NULL, 'Thrombin light chain domain superfamily', 'Thrombin_light_chain_sf', 5, NULL),
(28362, NULL, 'IPR036937', NULL, 'Fimbrial-type adhesion domain superfamily', 'Adhesion_dom_fimbrial_sf', 5, NULL),
(28363, NULL, 'IPR037013', NULL, 'Glutathione synthase, substrate-binding domain superfamily', 'GSH-S_sub-bd_sf', 5, NULL),
(28364, NULL, 'IPR036614', NULL, 'Holliday junction resolvase RusA-like superfamily', 'RusA-like_sf', 5, NULL),
(28365, NULL, 'IPR035745', NULL, 'BCAR1, SH3 domain', 'BCAR1_SH3', 3, NULL),
(28366, NULL, 'IPR036860', NULL, 'SH2 domain superfamily', 'SH2_dom_sf', 5, NULL),
(28367, NULL, 'IPR039741', NULL, 'UDP-sugar pyrophosphorylase', 'UDP-sugar_pyrophosphorylase', 4, NULL),
(28368, NULL, 'IPR041050', NULL, 'Pilin A4', 'PilA4', 3, NULL),
(28369, NULL, 'IPR040688', NULL, 'SMODS and SLOG-associating 2TM effector domain 2', 'SLATT_2', 3, NULL),
(28370, NULL, 'IPR033927', NULL, 'WASP family, EVH1 domain', 'WASPfam_EVH1', 3, NULL),
(28371, NULL, 'IPR036620', NULL, 'Chromosomal protein MC1 superfamily', 'MC1_sf', 5, NULL),
(28372, NULL, 'IPR037110', NULL, 'Beta-galactosidase, domain 2 superfamily', 'Betagal_dom2_sf', 5, NULL),
(28373, NULL, 'IPR035564', NULL, 'Nck1, SH3 domain 2', 'Nck1_SH3_2', 3, NULL),
(28374, NULL, 'IPR037959', NULL, 'PICK1, BAR domain', 'PICK1_BAR', 3, NULL),
(28375, NULL, 'IPR040777', NULL, 'Domain of unknown function DUF5591', 'DUF5591', 3, NULL),
(28376, NULL, 'IPR039180', NULL, 'Omega-hydroxyceramide transacylase PNPLA1', 'PNPLA1', 4, NULL),
(28377, NULL, 'IPR036994', NULL, 'Methyl-coenzyme M reductase, gamma subunit superfamily', 'Me_CoM_Rdtase_gsu_sf', 5, NULL),
(28378, NULL, 'IPR039252', NULL, 'Protein RALF-like 27', 'RALFL27', 4, NULL),
(28379, NULL, 'IPR037022', NULL, 'Formyl transferase, C-terminal domain superfamily', 'Formyl_trans_C_sf', 5, NULL),
(28380, NULL, 'IPR039717', NULL, 'Protein Hgh1', 'Hgh1', 4, NULL),
(28381, NULL, 'IPR036875', NULL, 'Zinc finger, CCHC-type superfamily', 'Znf_CCHC_sf', 5, NULL),
(28382, NULL, 'IPR037108', NULL, 'TM1727-like, C-terminal domain superfamily', 'TM1727-like_C_sf', 5, NULL),
(28383, NULL, 'IPR040704', NULL, 'HEPN, AbiU2-like', 'HEPN_AbiU2', 3, NULL),
(28384, NULL, 'IPR037138', NULL, 'Histone deacetylase domain superfamily', 'His_deacetylse_dom_sf', 5, NULL),
(28385, NULL, 'IPR035237', NULL, 'Protein of unknown function DUF5341', 'DUF5341', 4, NULL),
(28386, NULL, 'IPR040931', NULL, 'Cadmium carbonic anhydrase repeat', 'CDCA', 7, NULL),
(28387, NULL, 'IPR040739', NULL, 'RlmM ferredoxin-like domain', 'RlmM_FDX', 3, NULL),
(28388, NULL, 'IPR033701', NULL, 'First polo-box domain', 'POLO_box_1', 3, NULL),
(28389, NULL, 'IPR035743', NULL, 'PACSIN1/PACSIN2, SH3 domain', 'PACSIN1/PACSIN2_SH3', 3, NULL),
(28390, NULL, 'IPR035138', NULL, 'Protein of unknown function DUF5485', 'DUF5485', 4, NULL),
(28391, NULL, 'IPR040778', NULL, 'CASTOR1, N-terminal', 'CASTOR1_N', 3, NULL),
(28392, NULL, 'IPR033135', NULL, 'ClpP, histidine active site', 'ClpP_His_AS', 0, NULL),
(28393, NULL, 'IPR040783', NULL, 'Actinobacteria/chloroflexi VLRF1 release factor', 'VLRF1', 3, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(28394, NULL, 'IPR036945', NULL, 'Diacylglycerol kinase (DAGK) superfamily', 'DAGK_sf', 5, NULL),
(28395, NULL, 'IPR036461', NULL, 'Urease, beta subunit superfamily', 'Urease_betasu_sf', 5, NULL),
(28396, NULL, 'IPR036372', NULL, 'BEACH domain superfamily', 'BEACH_dom_sf', 5, NULL),
(28397, NULL, 'IPR036443', NULL, 'Zinc finger, RanBP2-type superfamily', 'Znf_RanBP2_sf', 5, NULL),
(28398, NULL, 'IPR040612', NULL, 'ArsA, HSP20-like domain', 'ArsA_HSP20-like', 3, NULL),
(28399, NULL, 'IPR041037', NULL, 'Pallilysin beta barrel domain', 'Pallilysin', 3, NULL),
(28400, NULL, 'IPR033685', NULL, 'DNA primase', 'HSV_PRIM', 4, NULL),
(28401, NULL, 'IPR035638', NULL, 'JIP1, SH3 domain', 'JIP1_SH3', 3, NULL),
(28402, NULL, 'IPR039213', NULL, 'FAM90', 'FAM90', 4, NULL),
(28403, NULL, 'IPR035854', NULL, 'STAT2, SH2 domain', 'STAT2_SH2', 3, NULL),
(28404, NULL, 'IPR041026', NULL, 'HEPN like, Abia C-terminal domain', 'HEPN_AbiA_CTD', 3, NULL),
(28405, NULL, 'IPR033119', NULL, 'Glycoside hydrolase family 11, active site 2', 'GH11_AS_2', 0, NULL),
(28406, NULL, 'IPR040639', NULL, 'Alpha-2-macroglobulin, MG1 domain', 'A2MG_MG1', 3, NULL),
(28407, NULL, 'IPR040867', NULL, 'Domain of unknown function DUF5603', 'DUF5603', 3, NULL),
(28408, NULL, 'IPR037019', NULL, 'Glycoside hydrolase family 7, catalytic domain superfamily', 'Glyco_hydro_7_sf', 5, NULL),
(28409, NULL, 'IPR040767', NULL, 'Diphteria toxin repressor, SH3 domain', 'DtxR_SH3', 3, NULL),
(28410, NULL, 'IPR036431', NULL, 'ARID DNA-binding domain superfamily', 'ARID_dom_sf', 5, NULL),
(28411, NULL, 'IPR033543', NULL, 'Bcl-2-like protein 15', 'BCL2L15', 4, NULL),
(28412, NULL, 'IPR041039', NULL, 'Yos9, dimerzation domain', 'Yos9_DD', 3, NULL),
(28413, NULL, 'IPR040645', NULL, 'Neurabin-1/2, PDZ domain', 'Neurabin-1/2_PDZ', 3, NULL),
(28414, NULL, 'IPR037140', NULL, 'von Hippel-Lindau disease tumour suppressor,  beta domain superfamily', 'VHL_beta_dom_sf', 5, NULL),
(28415, NULL, 'IPR035636', NULL, 'ARHGEF37, SH3 domain 2', 'ARHGEF37_SH3_2', 3, NULL),
(28416, NULL, 'IPR040869', NULL, 'Cyclic nucleotide phosphodiesterase, C-terminal domain', 'CNP_C', 3, NULL),
(28417, NULL, 'IPR039712', NULL, 'Meiotic expression up-regulated protein 6', 'Meu6', 4, NULL),
(28418, NULL, 'IPR037141', NULL, 'NDT80 DNA-binding domain superfamily', 'NDT80_DNA-bd_dom_sf', 5, NULL),
(28419, NULL, 'IPR036880', NULL, 'Pancreatic trypsin inhibitor Kunitz domain superfamily', 'Kunitz_BPTI_sf', 5, NULL),
(28420, NULL, 'IPR040734', NULL, 'Zyg-1, polo box domain 2', 'Zyg-1_PB2', 3, NULL),
(28421, NULL, 'IPR039688', NULL, 'STAC1/2/3', 'STAC1/2/3', 4, NULL),
(28422, NULL, 'IPR035532', NULL, 'DBS, SH3 domain', 'DBS_SH3', 3, NULL),
(28423, NULL, 'IPR036322', NULL, 'WD40-repeat-containing domain superfamily', 'WD40_repeat_dom_sf', 5, NULL),
(28424, NULL, 'IPR035247', NULL, 'PRMT5, TIM barrel domain', 'PRMT5_TIM', 3, NULL),
(28425, NULL, 'IPR035136', NULL, 'Protein of unknown function DUF5486', 'DUF5486', 4, NULL),
(28426, NULL, 'IPR040630', NULL, 'Ubiquitous surface protein adhesin repeat', 'UspA1_rep', 7, NULL),
(28427, NULL, 'IPR041032', NULL, 'Protein of unknown function DUF5546', 'DUF5546', 4, NULL),
(28428, NULL, 'IPR037114', NULL, 'Rhodopsin, N-terminal domain superfamily', 'Rhodopsin_N_sf', 5, NULL),
(28429, NULL, 'IPR037961', NULL, 'SH3PXD2, PX domain', 'SH3PXD2_PX', 3, NULL),
(28430, NULL, 'IPR036374', NULL, 'Oxidoreductase, molybdopterin-binding domain superfamily', 'OxRdtase_Mopterin-bd_sf', 5, NULL),
(28431, NULL, 'IPR039037', NULL, 'Calcium homeostasis endoplasmic reticulum protein', 'CHERP', 4, NULL),
(28432, NULL, 'IPR035608', NULL, 'Vinexin, SH3 domain 2', 'Vinexin_SH3_2', 3, NULL),
(28433, NULL, 'IPR040641', NULL, 'E3 ubiquitin-protein ligase RNF31, PUB domain', 'RNF31_PUB', 3, NULL),
(28434, NULL, 'IPR040648', NULL, 'HMG domain-containing protein 3, CxC4 like cysteine cluster', 'HMGXB3_CxC4', 3, NULL),
(28435, NULL, 'IPR036856', NULL, 'Aldehyde oxidase/xanthine dehydrogenase, a/b hammerhead superfamily', 'Ald_Oxase/Xan_DH_a/b_sf', 5, NULL),
(28436, NULL, 'IPR036866', NULL, 'Ribonuclease Z/Hydroxyacylglutathione hydrolase-like', 'RibonucZ/Hydroxyglut_hydro', 5, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(28437, NULL, 'IPR038589', NULL, 'Archaeal transcription elongation factor Spt4 superfamily', 'Spt4_dom_sf', 5, NULL),
(28438, NULL, 'IPR036611', NULL, 'Trigger factor ribosome-binding domain superfamily', 'Trigger_fac_ribosome-bd_sf', 5, NULL),
(28439, NULL, 'IPR035997', NULL, 'MTMR4, PH-GRAM domain', 'MTMR4_PH-GRAM', 3, NULL),
(28440, NULL, 'IPR035746', NULL, 'Enhancer of filamentation 1, SH3 domain', 'NEDD9_SH3', 3, NULL),
(28441, NULL, 'IPR037121', NULL, 'Ribosomal protein L25, C-terminal', 'Ribosomal_L25_C', 5, NULL),
(28442, NULL, 'IPR040967', NULL, 'Domain of unknown function DUF5595', 'DUF5595', 3, NULL),
(28443, NULL, 'IPR039039', NULL, 'RAI1-like family', 'RAI1-like_fam', 4, NULL),
(28444, NULL, 'IPR040740', NULL, 'MglB-2, periplasmic binding protein domain', 'MglB-2_Peripla_BP', 3, NULL),
(28445, NULL, 'IPR036016', NULL, 'TBC1D8, PH-GRAM domain 2', 'TBC1D8_PH-GRAM2', 3, NULL),
(28446, NULL, 'IPR035853', NULL, 'Tyrosine-protein kinase Blk, SH2 domain', 'Blk_SH2', 3, NULL),
(28447, NULL, 'IPR036330', NULL, 'Oligosaccharyltransferase subunit ost4p superfamily', 'Ost4p_sf', 5, NULL),
(28448, NULL, 'IPR039713', NULL, 'At2g23090-like', 'At2g23090-like', 4, NULL),
(28449, NULL, 'IPR040868', NULL, 'Histidine kinase DraK, N-terminal domain', 'DraK_HK_N', 3, NULL),
(28450, NULL, 'IPR035637', NULL, 'JIP2, SH3 domain', 'JIP2_SH3', 3, NULL),
(28451, NULL, 'IPR035230', NULL, 'Anti-sigma factor CnrY', 'CnrY', 4, NULL),
(28452, NULL, 'IPR035610', NULL, 'c-Cbl associated protein, SH3 domain 1', 'SORBS1_SH3_1', 3, NULL),
(28453, NULL, 'IPR033349', NULL, 'ATR-interacting protein', 'ATRIP', 4, NULL),
(28454, NULL, 'IPR040723', NULL, 'Cytosolic phospholipases A2, C2-domain', 'cPLA2_C2', 3, NULL),
(28455, NULL, 'IPR035602', NULL, 'MPP2, SH3 domain', 'MPP2_SH3', 3, NULL),
(28456, NULL, 'IPR040691', NULL, 'PexRD2, WYL domain', 'PexRD2_WYL', 3, NULL),
(28457, NULL, 'IPR040198', NULL, 'Fido domain-containing protein', 'Fido_containing', 4, NULL),
(28458, NULL, 'IPR040633', NULL, 'Galactose mutarotase-like fold domain', 'Gal_mutarotas_3', 3, NULL),
(28459, NULL, 'IPR040737', NULL, 'Domain of unknown function DUF5638', 'DUF5638', 3, NULL),
(28460, NULL, 'IPR040644', NULL, 'Hydrogen maturase F, tetramerization domain', 'HydF_tetramer', 3, NULL),
(28461, NULL, 'IPR037132', NULL, 'Protein N-terminal glutamine amidohydrolase, alpha beta roll superfamily', 'N_Gln_amidohydro_ab_roll_sf', 5, NULL),
(28462, NULL, 'IPR040730', NULL, 'Hexapeptide repeat including loop', 'Hexapep_loop', 7, NULL),
(28463, NULL, 'IPR036873', NULL, 'Rhodanese-like domain superfamily', 'Rhodanese-like_dom_sf', 5, NULL),
(28464, NULL, 'IPR035643', NULL, 'GRB2, C-terminal SH3 domain', 'GRB2_C_SH3', 3, NULL),
(28465, NULL, 'IPR037001', NULL, 'Ammonia/particulate methane monooxygenase, subunit A superfamily', 'NH3/CH4_mOase_suA_sf', 5, NULL),
(28466, NULL, 'IPR040674', NULL, 'SET and RING associated domain', 'SRA', 3, NULL),
(28467, NULL, 'IPR035736', NULL, 'Stac3, first SH3 domain', 'Stac3_SH3_1', 3, NULL),
(28468, NULL, 'IPR041035', NULL, 'TbRIF5 SNase domain 1', 'RIF5_SNase_1', 3, NULL),
(28469, NULL, 'IPR040738', NULL, 'Large polyvalent protein associated domain 22', 'LPD22', 3, NULL),
(28470, NULL, 'IPR037115', NULL, 'Sirohaem synthase, dimerisation domain superfamily', 'Sirohaem_synt_dimer_dom_sf', 5, NULL),
(28471, NULL, 'IPR036855', NULL, 'Zinc finger, CCCH-type superfamily', 'Znf_CCCH_sf', 5, NULL),
(28472, NULL, 'IPR036015', NULL, 'TBC1D8B, PH-GRAM domain 2', 'TBC1D8B_PH-GRAM2', 3, NULL),
(28473, NULL, 'IPR036245', NULL, 'Protozoan pheromone superfamily', 'Pheromone_protoz_sf', 5, NULL),
(28474, NULL, 'IPR035562', NULL, 'Nck1, SH3 domain 1', 'Nck1_SH3_1', 3, NULL),
(28475, NULL, 'IPR040636', NULL, 'PatG, C-terminal', 'PatG_C', 3, NULL),
(28476, NULL, 'IPR036857', NULL, 'Thyroglobulin type-1 superfamily', 'Thyroglobulin_1_sf', 5, NULL),
(28477, NULL, 'IPR040781', NULL, 'Rubisco accumulation factor 1, helix turn helix domain', 'Raf1_HTH', 3, NULL),
(28478, NULL, 'IPR035742', NULL, 'Fibronectin type III and SPRY containing 1, PRY/SPRY domain', 'SPRY/PRY_FSD1', 3, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(28479, NULL, 'IPR033390', NULL, '3''-5'' exoribonuclease Rv2179c-like domain', 'Rv2179c-like', 3, NULL),
(28480, NULL, 'IPR034907', NULL, 'Nucleoside diphosphate kinase-like domain', 'NDK-like_dom', 3, NULL),
(28481, NULL, 'IPR035603', NULL, 'MPP6, SH3 domain', 'MPP6_SH3', 3, NULL),
(28482, NULL, 'IPR035242', NULL, 'Protein of unknown function DUF5329', 'DUF5329', 4, NULL),
(28483, NULL, 'IPR036619', NULL, 'NinB superfamily', 'NinB_sf', 5, NULL),
(28484, NULL, 'IPR036353', NULL, 'XPC-binding domain superfamily', 'XPC-bd_sf', 5, NULL),
(28485, NULL, 'IPR039124', NULL, 'Fungal antigen PRA1-like', 'PRA1-like', 4, NULL),
(28486, NULL, 'IPR036426', NULL, 'Bulb-type lectin domain superfamily', 'Bulb-type_lectin_dom_sf', 5, NULL),
(28487, NULL, 'IPR036389', NULL, 'Ribonuclease III, endonuclease domain superfamily', 'RNase_III_sf', 5, NULL),
(28488, NULL, 'IPR039689', NULL, 'B-cell differentiation antigen CD72-like', 'CD72-like', 4, NULL),
(28489, NULL, 'IPR036340', NULL, 'MG296-like superfamily', 'MG296-like_sf', 5, NULL),
(28490, NULL, 'IPR034458', NULL, 'Terminal EAR1-like, RNA recognition motif 3', 'EAR1-like_RRM3', 3, NULL),
(28491, NULL, 'IPR037006', NULL, 'Histidine kinase  CheA-like, homodimeric domain superfamily', 'CheA-like_homodim_sf', 5, NULL),
(28492, NULL, 'IPR040668', NULL, 'TraI, 2B/2B-like domain', 'TraI_2B', 3, NULL),
(28493, NULL, 'IPR037017', NULL, 'Anthrax toxin, edema factor, central domain superfamily', 'Anthrax_toxin_edema_cen_sf', 5, NULL),
(28494, NULL, 'IPR035646', NULL, 'GRAP2, C-terminal SH3 domain', 'GRAP2_C_SH3', 3, NULL),
(28495, NULL, 'IPR036864', NULL, 'Zn(2)-C6 fungal-type DNA-binding domain superfamily', 'Zn2-C6_fun-type_DNA-bd_sf', 5, NULL),
(28496, NULL, 'IPR040673', NULL, 'CCDC81, HU domain 2', 'CCDC81_HU_dom_2', 3, NULL),
(28497, NULL, 'IPR040768', NULL, 'Vid27, PH-like domain', 'Vid27_PH', 3, NULL),
(28498, NULL, 'IPR037021', NULL, 'RnfH superfamily', 'RnfH_sf', 5, NULL),
(28499, NULL, 'IPR033542', NULL, 'Transmembrane protein 225', 'TMEM225', 4, NULL),
(28500, NULL, 'IPR035251', NULL, 'ShlB, POTRA domain', 'ShlB_POTRA', 3, NULL),
(28501, NULL, 'IPR040959', NULL, 'Cellulose-binding protein CttA, N-terminal', 'CttA_N', 3, NULL),
(28502, NULL, 'IPR039970', NULL, 'Transcription factor Grauzone', 'TF_Grauzone', 4, NULL),
(28503, NULL, 'IPR040773', NULL, '26S proteasome regulatory subunit Rpn6, N-terminal', 'Rpn6_N', 3, NULL),
(28504, NULL, 'IPR036969', NULL, 'Citrate synthase superfamily', 'Citrate_synthase_sf', 5, NULL),
(28505, NULL, 'IPR040953', NULL, 'Domain of unknown function DUF5594', 'DUF5594', 3, NULL),
(28506, NULL, 'IPR039495', NULL, 'TATA box-binding protein-associated factor RNA polymerase I subunit A', 'TAF1A', 4, NULL),
(28507, NULL, 'IPR038324', NULL, 'Rpb4/RPC9 superfamily', 'Rpb4/RPC9_sf', 5, NULL),
(28508, NULL, 'IPR041209', NULL, 'Vesicle tethering protein p115, armadillo tether-repeat', 'P115_Arm_rpt', 7, NULL),
(28509, NULL, 'IPR041162', NULL, 'Bacterial HORMA domain 1', 'Bact_HORMA_1', 3, NULL),
(28510, NULL, 'IPR040087', NULL, 'Protein MJ0021-like', 'MJ0021-like', 4, NULL),
(28511, NULL, 'IPR038319', NULL, 'CAS, serine rich four helix bundle domain superfamily', 'Serine_rich_sf', 5, NULL),
(28512, NULL, 'IPR034869', NULL, 'EWS, RNA recognition motif', 'EWS_RRM', 3, NULL),
(28513, NULL, 'IPR036913', NULL, 'YegP-like superfamily', 'YegP-like_sf', 5, NULL),
(28514, NULL, 'IPR037409', NULL, 'HTH-type transcriptional regulator XapR, PBP2 domain', 'XapR_PBP2', 3, NULL),
(28515, NULL, 'IPR038316', NULL, 'DUF5062 superfamily', 'DUF5062_sf', 5, NULL),
(28516, NULL, 'IPR039946', NULL, 'Zinc finger protein 839', 'ZN839', 4, NULL),
(28517, NULL, 'IPR039497', NULL, 'CCDC144C-like, coiled-coil domain', 'CC144C-like_CC_dom', 3, NULL),
(28518, NULL, 'IPR038314', NULL, 'T6SS superfamily', 'T6SS_sf', 5, NULL),
(28519, NULL, 'IPR041116', NULL, 'SMODS and SLOG-associating 2TM effector domain 3', 'SLATT_3', 3, NULL),
(28520, NULL, 'IPR033971', NULL, 'Avilamycin epimerase', 'Avilamycin_epimerase', 4, NULL),
(28521, NULL, 'IPR040904', NULL, 'Protein of unknown function DUF5557', 'DUF5557', 4, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(28522, NULL, 'IPR036915', NULL, 'Cyclin-like superfamily', 'Cyclin-like_sf', 5, NULL),
(28523, NULL, 'IPR041146', NULL, 'IFT81, calponin homology domain', 'IFT81_CH', 3, NULL),
(28524, NULL, 'IPR041206', NULL, 'HEPN/RES N-terminal domain 1', 'HEPN/RES_NTD1', 3, NULL),
(28525, NULL, 'IPR040084', NULL, 'GTPase Obg', 'GTPase_Obg', 4, NULL),
(28526, NULL, 'IPR040658', NULL, 'SipA, vinculin binding site', 'SipA_VBS', 2, NULL),
(28527, NULL, 'IPR040670', NULL, 'Protein of unknown function DUF5556', 'DUF5556', 4, NULL),
(28528, NULL, 'IPR033114', NULL, 'Cas9-type HNH domain', 'HNH_CAS9', 3, NULL),
(28529, NULL, 'IPR035687', NULL, 'TRIM17, PRY/SPRY domain', 'TRIM17_PRY/SPRY', 3, NULL),
(28530, NULL, 'IPR033858', NULL, '26S Proteasome non-ATPase regulatory subunit 7/8', 'MPN_RPN7_8', 4, NULL),
(28531, NULL, 'IPR040574', NULL, 'V-type ATP synthase subunit I, N-terminal', 'V_ATPase_I_N', 3, NULL),
(28532, NULL, 'IPR037896', NULL, 'SNX13, RGS domain', 'SNX13_RGS', 3, NULL),
(28533, NULL, 'IPR040430', NULL, 'Putative transcriptional regulator CudA-like', 'CudA-like', 4, NULL),
(28534, NULL, 'IPR041085', NULL, 'tRNA selenocysteine 1-associated protein 1, C-terminal', 'TSAP1_C', 3, NULL),
(28535, NULL, 'IPR036622', NULL, 'Dioxygenase LigAB, LigA subunit superfamily', 'LigA_sf', 5, NULL),
(28536, NULL, 'IPR037447', NULL, '40S Ribosomal protein S10', 'Rps10', 4, NULL),
(28537, NULL, 'IPR040905', NULL, 'Single-stranded DNA-binding protein, Pseudomonas', 'SS_DBP_Pseudomonas', 4, NULL),
(28538, NULL, 'IPR040694', NULL, 'UGGT, thioredoxin-like domain 2', 'UGGT_TRXL_2', 3, NULL),
(28539, NULL, 'IPR038602', NULL, 'Mite allergen, group-7 superfamily', 'Mite_allergen_7_sf', 5, NULL),
(28540, NULL, 'IPR040434', NULL, 'tRNA selenocysteine 1-associated protein 1', 'TSAP1', 4, NULL),
(28541, NULL, 'IPR040759', NULL, 'Regulator of G-protein signalling, DHEX domain', 'RGS_DHEX', 3, NULL),
(28542, NULL, 'IPR038321', NULL, 'TmcA, C-terminal domain superfamily', 'TmcA_C_sf', 5, NULL),
(28543, NULL, 'IPR040684', NULL, '5-hmdU DNA kinase, helical domain', 'HMUDK_hel', 3, NULL),
(28544, NULL, 'IPR041115', NULL, 'SMODS and SLOG-associating 2TM effector domain 5', 'SLATT_5', 3, NULL),
(28545, NULL, 'IPR041051', NULL, 'Proprotein convertase subtilisin/kexin type 9, C-terminal domain 3', 'PCSK9_C3', 3, NULL),
(28546, NULL, 'IPR036886', NULL, 'Villin headpiece domain superfamily', 'Villin_headpiece_dom_sf', 5, NULL),
(28547, NULL, 'IPR036233', NULL, 'Efb, C-terminal domain superfamily', 'Efb_C_sf', 5, NULL),
(28548, NULL, 'IPR041163', NULL, 'Ret, cadherin like domain 1', 'Ret_CLD1', 3, NULL),
(28549, NULL, 'IPR041056', NULL, 'Protein of unknown function DUF5585', 'DUF5585', 4, NULL),
(28550, NULL, 'IPR041142', NULL, 'Nitrous oxide reductase, propeller repeat 2', 'NOS_propeller_2', 7, NULL),
(28551, NULL, 'IPR040758', NULL, 'Release factor glutamine methyltransferase, N-terminal domain', 'PrmC_N', 3, NULL),
(28552, NULL, 'IPR036966', NULL, 'Carbohydrate-binding module 3 superfamily', 'CBM3_sf', 5, NULL),
(28553, NULL, 'IPR041212', NULL, 'Vta1, C-terminal', 'Vta1_C', 3, NULL),
(28554, NULL, 'IPR040671', NULL, 'Pullulanase, N2 domain', 'Pullulanase_N2', 3, NULL),
(28555, NULL, 'IPR040980', NULL, 'SWI2/SNF2 ATPase', 'SWI2_SNF2', 3, NULL),
(28556, NULL, 'IPR039044', NULL, 'tRNA:m(4)X modification enzyme Trm13', 'Trm13', 4, NULL),
(28557, NULL, 'IPR041108', NULL, 'Polyphosphate kinase, C-terminal domain 1', 'PP_kinase_C_1', 3, NULL),
(28558, NULL, 'IPR040907', NULL, 'IL-3 receptor alpha chain, N-terminal', 'IL3Ra_N', 3, NULL),
(28559, NULL, 'IPR040908', NULL, 'Hydroquinone 1,2-dioxygenase large subunit, N-terminal', 'PnpCD_PnpD_N', 3, NULL),
(28560, NULL, 'IPR037904', NULL, 'Nischarin, PX domain', 'Nischarin_PX', 3, NULL),
(28561, NULL, 'IPR040461', NULL, 'Homologous-pairing protein 2', 'Hop2', 4, NULL),
(28562, NULL, 'IPR035820', NULL, 'Dynamin-binding protein, first C-terminal SH3 domain', 'DNMBP_SH3_C1', 3, NULL),
(28563, NULL, 'IPR040985', NULL, 'Nup54, C-terminal interacting domain', 'Nup54_C', 3, NULL),
(28564, NULL, 'IPR041118', NULL, 'Rx, N-terminal', 'Rx_N', 3, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(28565, NULL, 'IPR036142', NULL, 'ENT domain-like superfamily', 'ENT_dom-like_sf', 5, NULL),
(28566, NULL, 'IPR039981', NULL, 'Activator of 90kDa heat shock protein ATPase-like', 'AHSA-like', 4, NULL),
(28567, NULL, 'IPR041215', NULL, 'FlgO domain', 'FlgO_dom', 3, NULL),
(28568, NULL, 'IPR036144', NULL, 'GTP cyclohydrolase II superfamily', 'RibA-like_sf', 5, NULL),
(28569, NULL, 'IPR036882', NULL, 'Alba-like domain superfamily', 'Alba-like_dom_sf', 5, NULL),
(28570, NULL, 'IPR036683', NULL, 'CO dehydrogenase flavoprotein, C-terminal domain superfamily', 'CO_DH_flav_C_dom_sf', 5, NULL),
(28571, NULL, 'IPR036141', NULL, 'MukF, middle domain superfamily', 'MukF_M_sp', 5, NULL),
(28572, NULL, 'IPR033222', NULL, 'PLAC1 family', 'PLAC1_fam', 4, NULL),
(28573, NULL, 'IPR037691', NULL, 'Uncharacterized protein C11orf98', 'C11orf98', 4, NULL),
(28574, NULL, 'IPR039498', NULL, 'Uncharacterised nucleotidyltransferase', 'NTP_transf_5', 4, NULL),
(28575, NULL, 'IPR037532', NULL, 'Peptidoglycan D,D-transpeptidase FtsI', 'FtsI_transpept', 4, NULL),
(28576, NULL, 'IPR036881', NULL, 'Glycoside hydrolase family 3 C-terminal domain superfamily', 'Glyco_hydro_3_C_sf', 5, NULL),
(28577, NULL, 'IPR041061', NULL, 'Dictyosteliid AID/APOBEC-like deaminase', 'DAAD', 4, NULL),
(28578, NULL, 'IPR036968', NULL, 'Enolpyruvate transferase domain superfamily', 'Enolpyruvate_Tfrase_sf', 5, NULL),
(28579, NULL, 'IPR038738', NULL, 'Nedd8-like ubiquitin', 'Nedd8-like', 3, NULL),
(28580, NULL, 'IPR041079', NULL, 'Neuraminidase-like domain', 'Neuraminidase-like', 3, NULL),
(28581, NULL, 'IPR041082', NULL, 'Suv3, C-terminal domain 1', 'Suv3_C_1', 3, NULL),
(28582, NULL, 'IPR036916', NULL, 'Sporulation inhibitor A superfamily', 'Sda_sf', 5, NULL),
(28583, NULL, 'IPR040984', NULL, 'Domain of unknown function DUF5640', 'DUF5640', 3, NULL),
(28584, NULL, 'IPR039503', NULL, 'BARD1, Zinc finger, RING-type', 'BARD1_Znf-RING', 3, NULL),
(28585, NULL, 'IPR040383', NULL, 'E3 ubiquitin-protein ligase HAKAI/CBLL2', 'HAKAI/CBLL2', 4, NULL),
(28586, NULL, 'IPR041094', NULL, 'Brr2, N-terminal helicase PWI domain', 'Brr2_helicase_PWI', 3, NULL),
(28587, NULL, 'IPR038612', NULL, 'YkfF-like domain superfamily', 'YkfF-like_sf', 5, NULL),
(28588, NULL, 'IPR037451', NULL, 'SLIT-ROBO Rho GTPase-activating protein 1, F-BAR domain', 'srGAP1_F-BAR', 3, NULL),
(28589, NULL, 'IPR041073', NULL, 'MobL relaxases', 'MobL', 4, NULL),
(28590, NULL, 'IPR041174', NULL, 'Krr1, KH1 domain', 'KH_8', 3, NULL),
(28591, NULL, 'IPR039500', NULL, 'EVA1 domain', 'EVA1_dom', 3, NULL),
(28592, NULL, 'IPR040414', NULL, 'PAM2-containing protein CID1/CID2', 'CID1/CID2', 4, NULL),
(28593, NULL, 'IPR041165', NULL, 'Cas6, N-terminal domain, archaea', 'Cas6_N_arch', 3, NULL),
(28594, NULL, 'IPR038310', NULL, 'DUF1104 superfamily', 'DUF1104_sf', 5, NULL),
(28595, NULL, 'IPR035084', NULL, 'Nucleocapsid, C-terminal, Arenaviridae', 'Nucleocapsid_C_arenaviridae', 3, NULL),
(28596, NULL, 'IPR041149', NULL, 'Extracellular cadherin domain', 'EC_dom', 3, NULL),
(28597, NULL, 'IPR035847', NULL, 'SH3BP2, SH2 domain', 'SH3BP2_SH2', 3, NULL),
(28598, NULL, 'IPR041198', NULL, 'N-terminal extension of GAT domain', 'GGA_N-GAT', 3, NULL),
(28599, NULL, 'IPR034870', NULL, 'TAF15/EWS/TLS family', 'TET_fam', 4, NULL),
(28600, NULL, 'IPR040753', NULL, 'Domain of unknown function DUF5620', 'DUF5620', 3, NULL),
(28601, NULL, 'IPR035628', NULL, 'TcpC, C-terminal', 'TcpC_C', 3, NULL),
(28602, NULL, 'IPR041156', NULL, 'Protein of unknown function DUF5533', 'DUF5533', 4, NULL),
(28603, NULL, 'IPR039968', NULL, 'Bacterial ceramide synthase-like', 'BcerS-like', 4, NULL),
(28604, NULL, 'IPR036143', NULL, 'Cytochrome b6-f complex, subunit 8 superfamily', 'Cytochr_b6-f_cplx_su8_sf', 5, NULL),
(28605, NULL, 'IPR041091', NULL, 'RPGRIP1, C-terminal', 'RPGRIP1_C', 3, NULL),
(28606, NULL, 'IPR034118', NULL, 'Protein S100-A6', 'S-100A6', 4, NULL),
(28607, NULL, 'IPR038322', NULL, 'Pex19, C-terminal domain superfamily', 'Pex19_C_sf', 5, NULL),
(28608, NULL, 'IPR040784', NULL, 'Glycogen debranching enzyme, C-terminal domain', 'GlgX_C', 3, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(28609, NULL, 'IPR035822', NULL, 'SH3RF2, third SH3 domain', 'SH3RF2_SH3_3', 3, NULL),
(28610, NULL, 'IPR041100', NULL, 'T-Q ester bond containing domain', 'TQ', 3, NULL),
(28611, NULL, 'IPR040677', NULL, 'Large polyvalent protein-associated domain 7', 'LPD7', 3, NULL),
(28612, NULL, 'IPR040775', NULL, 'Tail spike TSP1/Gp66, N-terminal domain', 'Tail_spike_N', 3, NULL),
(28613, NULL, 'IPR041137', NULL, 'Zinc transporter ZIP4, N-terminal', 'ZIP4_N', 3, NULL),
(28614, NULL, 'IPR041024', NULL, 'Mcm6, C-terminal winged-helix domain', 'Mcm6_C', 3, NULL),
(28615, NULL, 'IPR039496', NULL, 'CCDC92/74, coiled-coil domain', 'CCDC92/74_CC_dom', 3, NULL),
(28616, NULL, 'IPR035476', NULL, 'Phosphoglucose isomerase, SIS domain 1', 'SIS_PGI_1', 3, NULL),
(28617, NULL, 'IPR038317', NULL, 'Pf1176-like superfamily', 'Pf1176-like_sf', 5, NULL),
(28618, NULL, 'IPR041066', NULL, 'C19orf38, Ig domain', 'C19orf38_Ig', 3, NULL),
(28619, NULL, 'IPR040749', NULL, 'BRCC36, C-terminal helical domain', 'BRCC36_C', 3, NULL),
(28620, NULL, 'IPR040718', NULL, 'LnmK, N-terminal', 'LnmK_N_HDF', 3, NULL),
(28621, NULL, 'IPR040564', NULL, 'CxC3 like cysteine cluster', 'CxC3-like', 3, NULL),
(28622, NULL, 'IPR035821', NULL, 'Sla1, third SH3 domain', 'Sla1_SH3_3', 3, NULL),
(28623, NULL, 'IPR041155', NULL, 'FERM F1 lobe ubiquitin-like domain', 'FERM_F1', 3, NULL),
(28624, NULL, 'IPR035832', NULL, 'Jouberin, SH3 domain', 'AHI1_SH3', 3, NULL),
(28625, NULL, 'IPR038330', NULL, 'TspO/MBR-related superfamily', 'TspO/MBR-related_sf', 5, NULL),
(28626, NULL, 'IPR041183', NULL, 'Cyclophilin-like', 'Cyclophilin-like', 3, NULL),
(28627, NULL, 'IPR039967', NULL, 'Uncharacterized protein MJ1020-like', 'MJ1020-like', 4, NULL),
(28628, NULL, 'IPR037805', NULL, 'Leukocyte surface antigen CD47, IgV', 'IgV_CD47', 3, NULL),
(28629, NULL, 'IPR038307', NULL, 'StbB superfamily', 'StbB_sf', 5, NULL),
(28630, NULL, 'IPR040375', NULL, 'Microprocessor complex subunit DGCR8', 'DGCR8', 4, NULL),
(28631, NULL, 'IPR041123', NULL, 'Chromosome region maintenance repeat', 'CRM1_repeat', 7, NULL),
(28632, NULL, 'IPR038313', NULL, 'Herpesvirus glycoprotein L, rhadinovirus-type superfamily', 'Herpes_gL_rhadinovirus_sf', 5, NULL),
(28633, NULL, 'IPR041161', NULL, 'Tenascin, EGF-like domain', 'EGF_Tenascin', 3, NULL),
(28634, NULL, 'IPR041166', NULL, 'LapB,  rubredoxin metal binding domain', 'Rubredoxin_2', 3, NULL),
(28635, NULL, 'IPR036885', NULL, 'SWIB/MDM2 domain superfamily', 'SWIB_MDM2_dom_sf', 5, NULL),
(28636, NULL, 'IPR038717', NULL, 'Tc1-like transposase, DDE domain', 'Tc1-like_DDE_dom', 3, NULL),
(28637, NULL, 'IPR040463', NULL, 'BAP29/BAP31, transmembrane domain', 'BAP29/BAP31_N', 3, NULL),
(28638, NULL, 'IPR038318', NULL, 'KdpD, transmembrane domain superfamily', 'KdpD_sf', 5, NULL),
(28639, NULL, 'IPR036909', NULL, 'Cytochrome c-like domain superfamily', 'Cyt_c-like_dom_sf', 5, NULL),
(28640, NULL, 'IPR039971', NULL, 'Pre-mRNA-splicing factor CWC24-like', 'CWC24-like', 4, NULL),
(28641, NULL, 'IPR039494', NULL, 'Factor VIII intron 22 protein', 'F8A', 4, NULL),
(28642, NULL, 'IPR035817', NULL, 'Dynamin-binding protein, first N-terminal SH3 domain', 'DNMBP_SH3_N1', 3, NULL),
(28643, NULL, 'IPR033975', NULL, 'Carbapenem intermediate methyltransferase, ThnP-like', 'ThnP-like', 4, NULL),
(28644, NULL, 'IPR036145', NULL, 'Septum formation inhibitor MinC, C-terminal domain superfamily', 'MinC_C_sf', 5, NULL),
(28645, NULL, 'IPR035496', NULL, 'HDGF-related, PWWP domain', 'HDGF-rel_PWWP', 3, NULL),
(28646, NULL, 'IPR037999', NULL, 'Alpha-2-macroglobulin RAP, domain 3', 'RAP_D3', 3, NULL),
(28647, NULL, 'IPR039499', NULL, 'Leucine rich adaptor protein 1/25', 'LURA1/LRA25', 4, NULL),
(28648, NULL, 'IPR041195', NULL, 'Rnh202, triple barrel domain', 'Rnh202_N', 3, NULL),
(28649, NULL, 'IPR037529', NULL, '[LysW]-aminoadipate/[LysW]-glutamate kinase', 'LysZ', 4, NULL),
(28650, NULL, 'IPR039944', NULL, 'VSIG4, immunoglobulin variable (IgV)-like domain', 'VSIG4_IgV', 3, NULL),
(28651, NULL, 'IPR035406', NULL, 'Protein of unknown function DUF5412', 'DUF5412', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(28652, NULL, 'IPR039982', NULL, 'Ribosomal protein S30, mitochondrial', 'MRPS30', 4, NULL),
(28653, NULL, 'IPR037901', NULL, 'HCLS1-binding protein 3, PX domain', 'HS1BP3_PX', 3, NULL),
(28654, NULL, 'IPR036395', NULL, 'Copper fist DNA-binding domain superfamily', 'Cu_fist_DNA-bd_dom_sf', 5, NULL),
(28655, NULL, 'IPR033242', NULL, 'Protein phosphatase 1 regulatory subunit 17', 'PPP1R17', 4, NULL),
(28656, NULL, 'IPR035706', NULL, 'Dynein heavy chain, ATP-binding dynein motor region', 'AAA_9', 3, NULL),
(28657, NULL, 'IPR036149', NULL, 'APC, N-terminal coiled-coil domain superfamily', 'APC_N_sf', 5, NULL),
(28658, NULL, 'IPR041147', NULL, 'Glycosyl hydrolases family 38, C-terminal beta sandwich domain', 'GH38_C', 3, NULL),
(28659, NULL, 'IPR040435', NULL, 'Putative G-protein coupled receptor, Chromadorea', 'Put_GPCR_Chromadorea', 4, NULL),
(28660, NULL, 'IPR041180', NULL, 'Nucleotide modification associated domain 2', 'Nmad2', 3, NULL),
(28661, NULL, 'IPR035810', NULL, 'Phosphatidylethanolamine-binding protein, eukaryotic', 'PEBP_euk', 4, NULL),
(28662, NULL, 'IPR040693', NULL, 'UGGT, thioredoxin-like domain 1', 'UGGT_TRXL_1', 3, NULL),
(28663, NULL, 'IPR036652', NULL, 'YjeF N-terminal domain superfamily', 'YjeF_N_dom_sf', 5, NULL),
(28664, NULL, 'IPR040359', NULL, 'Protein glutamine dumper', 'GDU', 4, NULL),
(28665, NULL, 'IPR038329', NULL, 'Thymic stromal lymphopoietin superfamily', 'TSLP_sf', 5, NULL),
(28666, NULL, 'IPR041164', NULL, 'SLOG cluster4', 'LDcluster4', 4, NULL),
(28667, NULL, 'IPR040989', NULL, 'Major vault protein repeat domain 3', 'Vault_3', 3, NULL),
(28668, NULL, 'IPR033759', NULL, 'Systemic RNA interference defective protein 5', 'Sid-5', 4, NULL),
(28669, NULL, 'IPR038308', NULL, 'RFXAP, C-terminal domain superfamily', 'RFXAP_C_sf', 5, NULL),
(28670, NULL, 'IPR037698', NULL, 'Ubiquinol-cytochrome-c reductase complex assembly factor 2', 'UQCC2', 4, NULL),
(28671, NULL, 'IPR037690', NULL, 'Protein FAM204A', 'FAM204A', 4, NULL),
(28672, NULL, 'IPR041135', NULL, 'Nucleotide modification associated domain 3', 'Nmad3', 3, NULL),
(28673, NULL, 'IPR040356', NULL, 'SPEAR family', 'SPEAR', 4, NULL),
(28674, NULL, 'IPR040380', NULL, 'HAKAI-like, RING finger, HC subclass', 'HAKAI-like_RING-HC', 3, NULL),
(28675, NULL, 'IPR041070', NULL, 'Jumonji, helical domain', 'JHD', 3, NULL),
(28676, NULL, 'IPR041111', NULL, 'Pullulanase, Ins domain', 'Pullulanase_Ins', 3, NULL),
(28677, NULL, 'IPR038750', NULL, 'Uncharacterized protein YczE/YyaS-like', 'YczE/YyaS-like', 4, NULL),
(28678, NULL, 'IPR036146', NULL, 'Cyclotide superfamily', 'Cyclotide_sf', 5, NULL),
(28679, NULL, 'IPR037908', NULL, 'Cytochrome b5 reductase 4, p23 domain', 'p23_NCB5OR', 3, NULL),
(28680, NULL, 'IPR040772', NULL, 'C19orf47, SAM domain', 'C19orf47_SAM', 3, NULL),
(28681, NULL, 'IPR037782', NULL, 'Transcriptional activator Spt7', 'Spt7', 4, NULL),
(28682, NULL, 'IPR041117', NULL, 'SoxA, A3 domain', 'SoxA_A3', 3, NULL),
(28683, NULL, 'IPR041210', NULL, 'NLRC5, atypical caspase recruitment domain', 'NLRC5_atypical_Card', 3, NULL),
(28684, NULL, 'IPR037693', NULL, 'Coiled-coil domain-containing protein 15', 'CCDC15', 4, NULL),
(28685, NULL, 'IPR041110', NULL, 'Phage-Barnase-EndoU-ColicinE5/D-RelE like nuclease 2', 'PBECR2', 3, NULL),
(28686, NULL, 'IPR041093', NULL, 'DIS3-like exonuclease 2, C-terminal', 'Dis3l2_C', 3, NULL),
(28687, NULL, 'IPR033746', NULL, 'Glucosylglycerate phosphorylase', 'GGa_phosphorylase', 4, NULL),
(28688, NULL, 'IPR040464', NULL, 'Inositol 1,3,4-trisphosphate 5/6-kinase, ATP-grasp domain', 'InsP(3)kin_ATP-grasp', 3, NULL),
(28689, NULL, 'IPR035403', NULL, 'Uncharacterized protein YmpT-like', 'YmpT-like', 4, NULL),
(28690, NULL, 'IPR036889', NULL, 'Monooxygenase component MmoB/DmpM superfamily', 'mOase_MmoB_DmpM_sf', 5, NULL),
(28691, NULL, 'IPR041057', NULL, 'ZHX, C2H2 finger domain', 'ZHX_Znf_C2H2', 3, NULL),
(28692, NULL, 'IPR036150', NULL, 'Cytochrome b/b6, C-terminal domain superfamily', 'Cyt_b/b6_C_sf', 5, NULL),
(28693, NULL, 'IPR033650', NULL, 'Mitochondrial ribosomal protein L46 NUDIX', 'MRP_L46_NUDIX', 3, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(28694, NULL, 'IPR040960', NULL, 'Homeobox-cysteine loop-homeobox', 'HOCHOB', 3, NULL),
(28695, NULL, 'IPR036891', NULL, 'Signal recognition particle, SRP54 subunit, M-domain superfamily', 'Signal_recog_part_SRP54_M_sf', 5, NULL),
(28696, NULL, 'IPR038749', NULL, 'GINS complex protein Sld5, alpha-helical domain', 'Sld5_GINS_A', 3, NULL),
(28697, NULL, 'IPR040386', NULL, 'Transcriptional repressor p66', 'P66', 4, NULL),
(28698, NULL, 'IPR039045', NULL, 'Schwannomin interacting protein 1', 'SCHIP_1', 4, NULL),
(28699, NULL, 'IPR038320', NULL, 'KinB, N-terminal domain superfamily', 'KinB_N_sf', 5, NULL),
(28700, NULL, 'IPR041131', NULL, 'Phage MuF, C-terminal domain', 'MuF_C', 3, NULL),
(28701, NULL, 'IPR037452', NULL, 'Tyrosine-protein kinase Fer, F-BAR domain', 'Fer_F-BAR', 3, NULL),
(28702, NULL, 'IPR041216', NULL, 'Yeast SAGA-associated factor 11, N-terminal domain', 'Sgf11_N', 3, NULL),
(28703, NULL, 'IPR038029', NULL, 'GbiG N-terminal domain superfamily', 'GbiG_N_sf', 5, NULL),
(28704, NULL, 'IPR039802', NULL, 'Myotubularin-related protein 14', 'MTMR14', 4, NULL),
(28705, NULL, 'IPR040909', NULL, 'E3 ubiquitin-protein ligase CHFR, cysteine rich domain with multizinc binding', 'CHFR_Znf-CRD', 3, NULL),
(28706, NULL, 'IPR035659', NULL, 'Sucrose-phosphate synthase, C-terminal', 'SPS_C', 3, NULL),
(28707, NULL, 'IPR041107', NULL, 'RimK, PreATP-grasp domain', 'Rimk_N', 3, NULL),
(28708, NULL, 'IPR037408', NULL, 'HTH-type transcriptional regulator cbl, PBP2 domain', 'Cbl_PBP2', 3, NULL),
(28709, NULL, 'IPR040431', NULL, 'Cation channel sperm-associated auxiliary subunit TMEM262', 'TM262', 4, NULL),
(28710, NULL, 'IPR040755', NULL, 'Interleukin receptor mimic protein A', 'IrmA', 4, NULL),
(28711, NULL, 'IPR035464', NULL, 'AgaS, SIS domain', 'SIS_AgaS', 3, NULL),
(28712, NULL, 'IPR033674', NULL, 'Thioredoxin/glutathione peroxidase BtuE', 'BtuE', 4, NULL),
(28713, NULL, 'IPR041064', NULL, 'Trehalose-6-phosphate phosphatase, helical bundle domain', 'T6PP_helical', 3, NULL),
(28714, NULL, 'IPR041143', NULL, 'YgxA-like, helix-turn-helix domain', 'YgxA_HTH', 3, NULL),
(28715, NULL, 'IPR037480', NULL, 'YihR-like', 'YihR-like', 4, NULL),
(28716, NULL, 'IPR035474', NULL, 'KpsF-like, SIS domain', 'SIS_Kpsf', 3, NULL),
(28717, NULL, 'IPR036893', NULL, 'SBP domain superfamily', 'SBP_sf', 5, NULL),
(28718, NULL, 'IPR040686', NULL, 'Phosphoribosylaminoimidazole carboxylase, C-terminal domain', 'PurK_C', 3, NULL),
(28719, NULL, 'IPR041211', NULL, 'Protein of unknown function DUF5565', 'DUF5565', 4, NULL),
(28720, NULL, 'IPR040771', NULL, 'Thiolase-like protein type 1, additional C-terminal domain', 'TLP1_add_C', 3, NULL),
(28721, NULL, 'IPR040988', NULL, 'Domain of unknown function DUF5618', 'DUF5618', 3, NULL),
(28722, NULL, 'IPR039479', NULL, 'Single CXXC unit', 'Mono-CXXC', 3, NULL),
(28723, NULL, 'IPR041053', NULL, 'Replicase polyprotein 1ab', 'Rep_1B', 3, NULL),
(28724, NULL, 'IPR033333', NULL, 'Fanconi anemia group B protein', 'FANCB', 4, NULL),
(28725, NULL, 'IPR041208', NULL, 'SMODS-associating 2TM, beta-strand rich effector domain', 'S_2TMBeta', 3, NULL),
(28726, NULL, 'IPR035816', NULL, 'SH3RF1/SH3RF3, fourth SH3 domain', 'SH3RF1/SH3RF3_SH3_4', 3, NULL),
(28727, NULL, 'IPR040586', NULL, 'PheRS DNA binding domain 2', 'PheRS_DBD2', 3, NULL),
(28728, NULL, 'IPR036152', NULL, 'Asparaginase/glutaminase-like superfamily', 'Asp/glu_Ase-like_sf', 5, NULL),
(28729, NULL, 'IPR041172', NULL, 'Esterase, Ig-like N-terminal', 'EstA_Ig-like_N', 3, NULL),
(28730, NULL, 'IPR037692', NULL, 'Centrosomal protein of 70kDa', 'CEP70', 4, NULL),
(28731, NULL, 'IPR036914', NULL, 'Methylglyoxal synthase-like domain superfamily', 'MGS-like_dom_sf', 5, NULL),
(28732, NULL, 'IPR040956', NULL, 'Lower baseplate protein, N-terminal', 'BppL_N', 3, NULL),
(28733, NULL, 'IPR033745', NULL, 'Mitochondria fission protein Fis1, cytosolic domain', 'Fis1_cytosol', 3, NULL),
(28734, NULL, 'IPR036657', NULL, 'DNA-binding protein Tfx superfamily, archaea', 'Tfx_DNA-bd_sf_arc', 5, NULL),
(28735, NULL, 'IPR039743', NULL, 'Endo-beta-1,6-galactanase/Exo-beta-1,6-galactobiohydrolase', '6GAL/EXGAL', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(28736, NULL, 'IPR041076', NULL, 'Domain of unknown function DUF5614', 'DUF5614', 3, NULL),
(28737, NULL, 'IPR039965', NULL, 'Uncharacterized protein C3H7.08c', 'C3H7.08c', 4, NULL),
(28738, NULL, 'IPR041129', NULL, 'CdiI immunity protein', 'CdiI_2', 3, NULL),
(28739, NULL, 'IPR039490', NULL, 'Transmembrane protein 207', 'TMEM207', 4, NULL),
(28740, NULL, 'IPR035845', NULL, 'ShkD/ShkE, SH2 domain', 'ShkD/ShkE_SH2', 3, NULL),
(28741, NULL, 'IPR041175', NULL, 'VLRF1/Vms1', 'VLRF1/Vms1', 3, NULL),
(28742, NULL, 'IPR037515', NULL, 'Ribose-phosphate pyrophosphokinase, bacterial-type', 'Rib-P_diPkinase_bac', 4, NULL),
(28743, NULL, 'IPR036654', NULL, 'DNA polymerase III, psi subunit superfamily', 'DNA_pol_III_psi_sf', 5, NULL),
(28744, NULL, 'IPR041054', NULL, 'Exosome complex exonuclease Rrp40, N-terminal', 'Rrp40_N', 3, NULL),
(28745, NULL, 'IPR041063', NULL, 'Glycoside Hydrolase 20C, C-terminal', 'Glyco_H_20C_C', 3, NULL),
(28746, NULL, 'IPR036887', NULL, 'HTH APSES-type DNA-binding domain superfamily', 'HTH_APSES_sf', 5, NULL),
(28747, NULL, 'IPR036672', NULL, 'TCL1/MTCP1 superfamily', 'TCL1_MTCP1_sf', 5, NULL),
(28748, NULL, 'IPR040954', NULL, 'ZAP, zinc finger', 'Znf-CCCH_8', 3, NULL),
(28749, NULL, 'IPR041150', NULL, 'Chromodomain helicase DNA-binding domain', 'Cdh1_DBD', 3, NULL),
(28750, NULL, 'IPR039137', NULL, '5''-AMP-activated protein kinase alpha 1 catalytic subunit, C-terminal', 'AMPKA1_C', 3, NULL),
(28751, NULL, 'IPR040660', NULL, 'N-formyltransferase dimerization C-terminal domain', 'N_formyltrans_C', 3, NULL),
(28752, NULL, 'IPR040992', NULL, 'Xrn1, D1 domain', 'XRN1_D1', 3, NULL),
(28753, NULL, 'IPR036967', NULL, 'Ribosomal protein S11 superfamily', 'Ribosomal_S11_sf', 5, NULL),
(28754, NULL, 'IPR039979', NULL, 'Pre-mRNA-splicing factor 18', 'PRPF18', 4, NULL),
(28755, NULL, 'IPR040955', NULL, 'Immune mapped protein 2, N-terminal', 'IMP2_N', 3, NULL),
(28756, NULL, 'IPR041144', NULL, 'Stomatal closure-related actin-binding protein, PH domain', 'SCAB-PH', 3, NULL),
(28757, NULL, 'IPR033937', NULL, 'Carbamoyl-phosphate synthase large chain, methylglyoxal synthase-like domain', 'MGS_CPS_CarB', 3, NULL),
(28758, NULL, 'IPR040465', NULL, 'CtsR, N-terminal HTH domain', 'CtsR_N', 3, NULL),
(28759, NULL, 'IPR041122', NULL, 'RecJ, OB domain', 'RecJ_OB', 3, NULL),
(28760, NULL, 'IPR036898', NULL, 'RNA polymerase Rpb7-like, N-terminal domain superfamily', 'RNA_pol_Rpb7-like_N_sf', 5, NULL),
(28761, NULL, 'IPR040910', NULL, 'Closterovirus 1a polyprotein, central region', 'Zemlya', 4, NULL),
(28762, NULL, 'IPR036239', NULL, 'Prenyltransferase-like superfamily', 'PrenylTrfase-like_sf', 5, NULL),
(28763, NULL, 'IPR041154', NULL, 'Archaeal glycosylation protein B, peripheral domain', 'AglB_P1', 3, NULL),
(28764, NULL, 'IPR039964', NULL, 'Uncharacterized protein KIAA0040-like', 'KIAA0040-like', 4, NULL),
(28765, NULL, 'IPR037950', NULL, 'Peptidoglycan deacetylase PgdA-like', 'PgdA-like', 4, NULL),
(28766, NULL, 'IPR038884', NULL, 'Cilia- and flagella-associated protein 61', 'CFAP61', 4, NULL),
(28767, NULL, 'IPR036892', NULL, 'L27 domain superfamily', 'L27_dom_sf', 5, NULL),
(28768, NULL, 'IPR036912', NULL, 'Haem-binding HasA superfamily', 'HasA_haem-bd_sf', 5, NULL),
(28769, NULL, 'IPR038783', NULL, 'Fungal mitogen-activated protein (MAP) kinase Sty1/Hog1', 'MAPK_Sty1/Hog1', 4, NULL),
(28770, NULL, 'IPR036140', NULL, 'Profilin superfamily', 'PFN_sf', 5, NULL),
(28771, NULL, 'IPR036147', NULL, 'Anti sigma-E protein RseA, N-terminal domain superfamily', 'Anti-sigma_E_RseA_N_sf', 5, NULL),
(28772, NULL, 'IPR040787', NULL, 'Cas12a, REC1 domain', 'Cas12a_REC1', 3, NULL),
(28773, NULL, 'IPR041177', NULL, 'Holliday junction resolvase Gen1, C-terminal domain', 'GEN1_C', 3, NULL),
(28774, NULL, 'IPR036662', NULL, 'Phosphotransferase system, mannose-type IIA component superfamily', 'PTS_EIIA_man-typ_sf', 5, NULL),
(28775, NULL, 'IPR041125', NULL, '4-hydroxyphenylacetate decarboxylase small gamma subunit, N-terminal', '4HPAD_g_N', 3, NULL),
(28776, NULL, 'IPR036667', NULL, 'Phosphotransferase system, sorbose subfamily IIB component superfamily', 'PTS_IIB_sorbose-sp_sf', 5, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(28777, NULL, 'IPR037453', NULL, 'PACSIN2, F-BAR domain', 'PACSIN2_F-BAR', 3, NULL),
(28778, NULL, 'IPR036900', NULL, 'Alpha-D-phosphohexomutase, C-terminal domain superfamily', 'A-D-PHexomutase_C_sf', 5, NULL),
(28779, NULL, 'IPR040417', NULL, 'Glycine-rich cell wall structural protein 1/2', 'GRP1/2', 4, NULL),
(28780, NULL, 'IPR034213', NULL, 'Vpr-like peptidase,  catalytic domain', 'S8_Vpr-like', 3, NULL),
(28781, NULL, 'IPR036394', NULL, 'Ribosomal protein L22/L17 superfamily', 'Ribosomal_L22/L17_sf', 5, NULL),
(28782, NULL, 'IPR041140', NULL, 'Defence against restriction A, N-terminal', 'DarA_N', 3, NULL),
(28783, NULL, 'IPR033764', NULL, 'SD-repeat containing protein, B domain', 'Sdr_B', 3, NULL),
(28784, NULL, 'IPR037410', NULL, 'HTH-type transcriptional regulator BudR, PBP2 domain', 'BudR_PBP2', 3, NULL),
(28785, NULL, 'IPR040086', NULL, 'Protein MJ0683-like', 'MJ0683-like', 4, NULL),
(28786, NULL, 'IPR040680', NULL, 'Domain of unknown function DUF5643', 'DUF5643', 3, NULL),
(28787, NULL, 'IPR033304', NULL, 'Deleted in lung and esophageal cancer protein 1', 'DLEC1', 4, NULL),
(28788, NULL, 'IPR041095', NULL, 'Elongation Factor G, domain II', 'EFG_II', 3, NULL),
(28789, NULL, 'IPR036153', NULL, 'Erythrocruorin linker subunit, C-terminal superfamily', 'Eryth_link_C_sf', 5, NULL),
(28790, NULL, 'IPR040358', NULL, 'Uncharacterized protein At4g22758-like', 'At4g22758-like', 4, NULL),
(28791, NULL, 'IPR039492', NULL, 'Transmembrane protein 109', 'TMEM109', 4, NULL),
(28792, NULL, 'IPR038323', NULL, 'Putative aromatic acid exporter, C-terminal domain superfamily', 'ArAE_1_C_sf', 5, NULL),
(28793, NULL, 'IPR041168', NULL, 'L-Lysine epsilon oxidase, N-terminal', 'LodA_N', 3, NULL),
(28794, NULL, 'IPR037801', NULL, 'ARHGEF12, PH domain', 'ARHGEF12_PH', 3, NULL),
(28795, NULL, 'IPR041065', NULL, 'GCN5-related N-acetyltransferase-like domain', 'GNAT-like', 3, NULL),
(28796, NULL, 'IPR041069', NULL, 'FeoB, cytosolic helical domain', 'FeoB_Cyto', 3, NULL),
(28797, NULL, 'IPR040987', NULL, 'TraI, N-terminal subdomain', 'TraI_N', 3, NULL),
(28798, NULL, 'IPR038312', NULL, 'DUF5063 superfamily', 'DUF5063_sf', 5, NULL),
(28799, NULL, 'IPR035684', NULL, 'Arginyl-tRNA synthetase, catalytic core domain', 'ArgRS_core', 3, NULL),
(28800, NULL, 'IPR037778', NULL, 'Protein kinase C-like, C2 domain', 'C2_fungal_PKC', 3, NULL),
(28801, NULL, 'IPR040761', NULL, 'Tle cognate immunity protein 4, N-terminal domain', 'Tli4_N', 3, NULL),
(28802, NULL, 'IPR041185', NULL, 'IKBKB, scaffold dimerization domain', 'IKBKB_SDD', 3, NULL),
(28803, NULL, 'IPR041158', NULL, 'Cue1, Ubc7p-binding domain', 'Cue1_U7BR', 3, NULL),
(28804, NULL, 'IPR036155', NULL, 'Cryptochrome/photolyase, N-terminal domain superfamily', 'Crypto/Photolyase_N_sf', 5, NULL),
(28805, NULL, 'IPR039977', NULL, 'Histone-lysine N-methyltransferase Suv4-20/Set9', 'Suv4-20/Set9', 4, NULL),
(28806, NULL, 'IPR040659', NULL, 'Phenylalanine--tRNA ligase beta subunit, B1 domain', 'PhetRS_B1', 3, NULL),
(28807, NULL, 'IPR038325', NULL, 'Interleukin-7 superfamily', 'IL7_sf', 5, NULL),
(28808, NULL, 'IPR040233', NULL, 'CCD97-like, C-terminal', 'CCD97-like_C', 3, NULL),
(28809, NULL, 'IPR041055', NULL, 'Serine/Threonine/Tyrosine Kinase found in polyvalent protein', 'Kinase-PolyVal', 4, NULL),
(28810, NULL, 'IPR041207', NULL, 'NEDD8 ultimate buster 1, ubiquitin-like domain', 'NUB1_ubiquitin-like_dom', 3, NULL),
(28811, NULL, 'IPR041124', NULL, 'Sensor histidine kinase (AbfS), sensor domain', 'AbfS_sensor', 3, NULL),
(28812, NULL, 'IPR039752', NULL, 'F-box only protein', 'F-box_only', 4, NULL),
(28813, NULL, 'IPR040760', NULL, 'Testis-specific expressed protein 55', 'Tex55', 4, NULL),
(28814, NULL, 'IPR040990', NULL, 'Domain of unknown function DUF5600', 'DUF5600', 3, NULL),
(28815, NULL, 'IPR040234', NULL, 'Glutaminyl-peptide cyclotransferase-like', 'QC/QCL', 4, NULL),
(28816, NULL, 'IPR038326', NULL, 'Interferon lambda superfamily', 'IFN-lambda_sf', 5, NULL),
(28817, NULL, 'IPR035846', NULL, 'PTK6, SH2 domain', 'PTK6_SH2', 3, NULL),
(28818, NULL, 'IPR034004', NULL, 'Pol I subunit A12, C-terminal zinc ribbon', 'Zn_ribbon_RPA12_C', 3, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(28819, NULL, 'IPR041153', NULL, 'Yeast longin domain', 'Longin_2', 3, NULL),
(28820, NULL, 'IPR041060', NULL, 'RNA editing 3'' terminal uridylyl transferase 2 middle domain', 'Ret2_MD', 3, NULL),
(28821, NULL, 'IPR033667', NULL, 'Nucleoside permease NupG', 'NupG', 4, NULL),
(28822, NULL, 'IPR040769', NULL, 'Phosphoinositide phosphatase insertion domain', 'PI_PP_I', 3, NULL),
(28823, NULL, 'IPR039966', NULL, 'Uncharacterized protein C553.12c', 'C553.12c', 4, NULL),
(28824, NULL, 'IPR034216', NULL, 'C5a peptidase-like domain', 'C5a_Peptidase', 3, NULL),
(28825, NULL, 'IPR041128', NULL, 'Arginine decarboxylase, C-terminal helical', 'Arg_decarbox_C', 3, NULL),
(28826, NULL, 'IPR041084', NULL, 'Nicastrin, small lobe', 'Ncstrn_small', 3, NULL),
(28827, NULL, 'IPR035482', NULL, 'Phosphoglucose isomerase, SIS domain 2', 'SIS_PGI_2', 3, NULL),
(28828, NULL, 'IPR035461', NULL, 'GmhA/DiaA', 'GmhA/DiaA', 4, NULL),
(28829, NULL, 'IPR037923', NULL, 'Transcription regulator HTH-like', 'HTH-like', 5, NULL),
(28830, NULL, 'IPR040420', NULL, 'Uncharacterized protein At1g76660-like', 'At1g76660-like', 4, NULL),
(28831, NULL, 'IPR041067', NULL, 'Vanadium chloroperoxidase, N-terminal', 'VCPO_N', 3, NULL),
(28832, NULL, 'IPR041188', NULL, 'ARS-binding protein 1, N-terminal', 'HTH_ABP1_N', 3, NULL),
(28833, NULL, 'IPR041121', NULL, 'SDH, C-terminal', 'SDH_C', 3, NULL),
(28834, NULL, 'IPR041127', NULL, 'Cutinase', 'Cutinase', 4, NULL),
(28835, NULL, 'IPR041170', NULL, 'RING/Ubox-like zinc-binding domain', 'Znf-RING_14', 3, NULL),
(28836, NULL, 'IPR036911', NULL, 'Beta-catenin-interacting ICAT superfamily', 'ICAT_sf', 5, NULL),
(28837, NULL, 'IPR037856', NULL, 'Sdc1/DPY30', 'Sdc1/DPY30', 4, NULL),
(28838, NULL, 'IPR041075', NULL, 'NOD2, winged helix domain', 'NOD2_WH', 3, NULL),
(28839, NULL, 'IPR041213', NULL, 'Nitrosopumilus output domain 1', 'NitrOD1', 3, NULL),
(28840, NULL, 'IPR041189', NULL, 'Transcription factor IIB, C-terminal module 1', 'TFIIB_C_1', 3, NULL),
(28841, NULL, 'IPR039491', NULL, 'Required for excision 1-B domain-containing protein', 'REX1-B', 4, NULL),
(28842, NULL, 'IPR041157', NULL, 'Up-regulated in Daf-2', 'PUD1/2', 3, NULL),
(28843, NULL, 'IPR037948', NULL, 'Chromo domain-containing protein cec-4/Chromobox protein homolog hpl-2', 'Cec-4/hpl-2', 4, NULL),
(28844, NULL, 'IPR036896', NULL, 'Avidin-like superfamily', 'Avidin-like_sf', 5, NULL),
(28845, NULL, 'IPR041160', NULL, 'SLOG cluster2', 'LD_cluster2', 4, NULL),
(28846, NULL, 'IPR040588', NULL, 'Argonaute, N domain', 'AGO_N', 3, NULL),
(28847, NULL, 'IPR037899', NULL, 'SNX25, PX domain', 'SNX25_PX', 3, NULL),
(28848, NULL, 'IPR035651', NULL, 'BipA, domain V', 'BipA_V', 3, NULL),
(28849, NULL, 'IPR033990', NULL, 'Collectin, C-type lectin-like domain', 'Collectin_CTLD', 3, NULL),
(28850, NULL, 'IPR034119', NULL, 'PQQ-dependent type I alcohol dehydrogenase', 'ADHI', 4, NULL),
(28851, NULL, 'IPR036895', NULL, 'Uracil-DNA glycosylase-like domain superfamily', 'Uracil-DNA_glycosylase-like_sf', 5, NULL),
(28852, NULL, 'IPR041052', NULL, 'Proprotein convertase subtilisin/kexin type 9, C-terminal domain 2', 'PCSK9_C2', 3, NULL),
(28853, NULL, 'IPR035650', NULL, 'Tetracycline resistance protein, C-terminal', 'Tet_C', 3, NULL),
(28854, NULL, 'IPR040361', NULL, 'Tapetum determinant 1', 'TPD1', 4, NULL),
(28855, NULL, 'IPR041080', NULL, 'YcaO cyclodehydratase, C-terminal', 'YcaO_C', 3, NULL),
(28856, NULL, 'IPR036139', NULL, 'Virulence-associated V antigen superfamily', 'Vir_assoc_V_ag_sf', 5, NULL),
(28857, NULL, 'IPR040373', NULL, 'Transcription factor castor', 'CASZ1', 4, NULL),
(28858, NULL, 'IPR041214', NULL, 'Dda helicase SH3 domain', 'SH3_14', 3, NULL),
(28859, NULL, 'IPR040958', NULL, 'Secreted Novel AID/APOBEC-like Deaminase 1', 'SNAD1', 4, NULL),
(28860, NULL, 'IPR040690', NULL, 'FtsX, extracellular domain', 'FtsX_ECD', 3, NULL),
(28861, NULL, 'IPR033974', NULL, 'Glycerol dehydratase activase', 'Glycerol_dehydratase_activase', 4, NULL),
(28862, NULL, 'IPR036883', NULL, 'PDCD5-like superfamily', 'PDCD5-like_sf', 5, NULL),
(28863, NULL, 'IPR035484', NULL, 'Bifunctional phosphoglucose/phosphomannose isomerase, SIS domain 1', 'SIS_PGI/PMI_1', 3, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(28864, NULL, 'IPR040418', NULL, 'Protein crowded nuclei', 'CRWN', 4, NULL),
(28865, NULL, 'IPR033467', NULL, 'Tesmin/TSO1-like CXC domain', 'Tesmin/TSO1-like_CXC', 3, NULL),
(28866, NULL, 'IPR040429', NULL, 'Uncharacterized protein C11orf97-like', 'C11orf97-like', 4, NULL),
(28867, NULL, 'IPR036623', NULL, 'Hemimethylated DNA-binding domain superfamily', 'Hemimethylated_DNA-bd_sf', 5, NULL),
(28868, NULL, 'IPR036154', NULL, 'Tp47, N-terminal domain superfamily', 'Tp47_N_sf', 5, NULL),
(28869, NULL, 'IPR036972', NULL, 'Cytochrome c oxidase, subunit Vb superfamily', 'Cyt_c_oxidase_su5b_sf', 5, NULL),
(28870, NULL, 'IPR041176', NULL, 'von Willebrand factor type A, C-terminal domain', 'VWA_3_C', 3, NULL),
(28871, NULL, 'IPR041197', NULL, 'SLOG cluster3 family', 'LD_cluster3', 4, NULL),
(28872, NULL, 'IPR040581', NULL, 'SNTX, thioredoxin-like domain', 'Thioredoxin_11', 3, NULL),
(28873, NULL, 'IPR037696', NULL, 'Coiled-coil domain-containing protein 77', 'CCDC77', 4, NULL),
(28874, NULL, 'IPR035809', NULL, 'Nicotinate phosphoribosyltransferase, archaeal-type', 'NAPRTase_arc-type', 4, NULL),
(28875, NULL, 'IPR040752', NULL, 'DNA mismatch repair protein HSM3, C-terminal domain', 'HSM3_C', 3, NULL),
(28876, NULL, 'IPR040962', NULL, 'Tetratricopeptide-like repeat', 'TPR_22', 7, NULL),
(28877, NULL, 'IPR038315', NULL, 'FLiS export co-chaperone, HP1076 superfamily', 'FliS_cochap_sf', 5, NULL),
(28878, NULL, 'IPR041113', NULL, 'Heliorhodopsin', 'Heliorhodopsin', 4, NULL),
(28879, NULL, 'IPR037803', NULL, 'Rho guanine nucleotide exchange factor 11, PH domain', 'PRG_PH', 3, NULL),
(28880, NULL, 'IPR035408', NULL, 'Phage single-stranded DNA-binding protein', 'Phi29_Phage_SSB', 4, NULL),
(28881, NULL, 'IPR040678', NULL, 'AbrB, C-terminal', 'AbrB_C', 3, NULL),
(28882, NULL, 'IPR036660', NULL, 'Fe-S hydro-lyase, tartrate dehydratase beta-type, catalytic domain superfamily', 'Fe-S_hydroAse_TtdB_cat_sf', 5, NULL),
(28883, NULL, 'IPR035472', NULL, 'RpiR-like, SIS domain', 'RpiR-like_SIS', 3, NULL),
(28884, NULL, 'IPR040362', NULL, 'RAB11-binding protein RELCH', 'RELCH', 4, NULL),
(28885, NULL, 'IPR041081', NULL, 'Protein of unknown function DUF5629', 'DUF5629', 4, NULL),
(28886, NULL, 'IPR039980', NULL, 'MAP kinase-activating death domain protein', 'MADD', 4, NULL),
(28887, NULL, 'IPR041034', NULL, 'Phosphoinositide phosphatase, C-terminal', 'PI_PP_C', 3, NULL),
(28888, NULL, 'IPR039947', NULL, 'Nuclear receptor coactivator 4', 'NCoA-4', 4, NULL),
(28889, NULL, 'IPR040757', NULL, 'Endoribonuclease Regnase 1/ZC3H12, C-terminal domain', 'Regnase_1/ZC3H12_C', 3, NULL),
(28890, NULL, 'IPR033583', NULL, 'BEN domain-containing protein 3', 'BEND3', 4, NULL),
(28891, NULL, 'IPR041078', NULL, 'Plavaka transposase', 'Plavaka', 4, NULL),
(28892, NULL, 'IPR041120', NULL, 'VapC9 PIN-like domain', 'PIN_9', 3, NULL),
(28893, NULL, 'IPR034922', NULL, 'RNA exonuclease 1-like, exonuclease domain', 'REX1-like_exo', 3, NULL),
(28894, NULL, 'IPR040719', NULL, 'Domain of unknown function DUF5597', 'DUF5597', 3, NULL),
(28895, NULL, 'IPR040717', NULL, 'P-loop nucleotide kinase 3', 'Ploop_nt_kinase3', 4, NULL),
(28896, NULL, 'IPR038311', NULL, 'Herpesvirus glycoprotein L, N-terminal domain superfamily', 'Herpes_gL_N_sf', 5, NULL),
(28897, NULL, 'IPR036894', NULL, 'Nucleoid-associated protein YbaB-like domain superfamily', 'YbaB-like_sf', 5, NULL),
(28898, NULL, 'IPR041106', NULL, 'Exoribonuclease Xrn1, D2/D3 domain', 'XRN1_D2_D3', 3, NULL),
(28899, NULL, 'IPR040754', NULL, 'Pre ATP-grasp domain', 'PreAtp-grasp', 3, NULL),
(28900, NULL, 'IPR033305', NULL, 'Hydrocephalus-inducing-like', 'Hydin-like', 4, NULL),
(28901, NULL, 'IPR035811', NULL, 'Netrin-4, NTR domain', 'Netrin-4_NTR', 3, NULL),
(28902, NULL, 'IPR041098', NULL, 'Rv2175c, C-terminal', 'Rv2175c_C', 3, NULL),
(28903, NULL, 'IPR041193', NULL, 'CysA, C-terminal regulatory domain', 'CysA_C', 3, NULL),
(28904, NULL, 'IPR039803', NULL, 'MTMR14, PH-GRAM domain', 'MTMR14_PH-GRAM', 3, NULL),
(28905, NULL, 'IPR036396', NULL, 'Cytochrome P450 superfamily', 'Cyt_P450_sf', 5, NULL),
(28906, NULL, 'IPR037783', NULL, 'Transcription initiation factor TFIID subunit 5', 'Taf5', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(28907, NULL, 'IPR037695', NULL, 'IQ and ubiquitin-like domain-containing protein', 'IQUB', 4, NULL),
(28908, NULL, 'IPR041141', NULL, 'Diiron non-heme beta-hydroxylase, N-terminal domain', 'CmlA_N', 3, NULL),
(28909, NULL, 'IPR038331', NULL, 'DisA, linker domain superfamily', 'DisA_sf', 5, NULL),
(28910, NULL, 'IPR036899', NULL, 'Ribosomal protein L13 superfamily', 'Ribosomal_L13_sf', 5, NULL),
(28911, NULL, 'IPR037250', NULL, 'NEAT domain superfamily', 'NEAT_dom_sf', 5, NULL),
(28912, NULL, 'IPR040906', NULL, 'Protein of unknown function DUF5535', 'DUF5535', 4, NULL),
(28913, NULL, 'IPR037741', NULL, 'Synaptotagmin 7, C2B domain', 'C2B_Synaptotagmin-7', 3, NULL),
(28914, NULL, 'IPR038739', NULL, 'Armadillo-type fold containing protein ARMC8/Vid28', 'ARMC8/Vid28', 4, NULL),
(28915, NULL, 'IPR041196', NULL, 'Large polyvalent protein associated domain 37', 'LPD37', 3, NULL),
(28916, NULL, 'IPR040774', NULL, 'Protein of unknown function DUF5580', 'DUF5580', 4, NULL),
(28917, NULL, 'IPR041068', NULL, 'Methyltransferase, fungal type, helix-turn-helix domain', 'HTH_51', 3, NULL),
(28918, NULL, 'IPR036888', NULL, 'DNA integrity scanning protein, DisA, N-terminal domain superfamily', 'DNA_integrity_DisA_N_sf', 5, NULL),
(28919, NULL, 'IPR041072', NULL, 'Fumarylacetoacetase N-terminal domain', 'FAA_hydro_N', 3, NULL),
(28920, NULL, 'IPR040419', NULL, 'DUF5568 family', 'DUF5568', 4, NULL),
(28921, NULL, 'IPR040415', NULL, 'SET domain-containing protein 9', 'SETD9', 4, NULL),
(28922, NULL, 'IPR036890', NULL, 'Histidine kinase/HSP90-like ATPase superfamily', 'HATPase_C_sf', 5, NULL),
(28923, NULL, 'IPR039750', NULL, 'Dynein regulatory complex protein', 'DRC1/DRC2', 4, NULL),
(28924, NULL, 'IPR039892', NULL, 'Protein Spa2/Sph1', 'Spa2/Sph1', 4, NULL),
(28925, NULL, 'IPR035818', NULL, 'Dynamin-binding protein, second N-terminal SH3 domain', 'DNMBP_SH3_N2', 3, NULL),
(28926, NULL, 'IPR041167', NULL, 'SAVED-fused 2TM effector domain', 'Saf_2TM', 3, NULL),
(28927, NULL, 'IPR040961', NULL, 'Cop9 signalosome subunit 5 C-terminal domain', 'CSN5_C', 3, NULL),
(28928, NULL, 'IPR040982', NULL, 'DNA polymerase III alpha subunit finger domain', 'DNA_pol3_finger', 3, NULL),
(28929, NULL, 'IPR036971', NULL, '3''5''-cyclic nucleotide phosphodiesterase, catalytic domain superfamily', 'PDEase_catalytic_dom_sf', 5, NULL),
(28930, NULL, 'IPR037903', NULL, 'MONaKA, PX domain', 'MONaKA_PX', 3, NULL),
(28931, NULL, 'IPR040416', NULL, 'Transmembrane protein 181', 'TMEM181', 4, NULL),
(28932, NULL, 'IPR035405', NULL, 'Gene product 70', 'GP70', 4, NULL),
(28933, NULL, 'IPR040763', NULL, 'Ribonucleotide reductase, alpha helical domain', 'RNR_alpha_hel', 3, NULL),
(28934, NULL, 'IPR036665', NULL, 'Phosphotransferase system, glucitol/sorbitol-specific IIA component superfamily', 'PTS_IIA_glucitol/sorbitol_sf', 5, NULL),
(28935, NULL, 'IPR037694', NULL, 'Uncharacterized protein C17orf80', 'C17orf80', 4, NULL),
(28936, NULL, 'IPR035085', NULL, 'Urocanase, Rossmann-like domain', 'Urocanase_Rossmann-like', 3, NULL),
(28937, NULL, 'IPR041151', NULL, 'Replication initiator protein A, C-terminal domain', 'Bac_RepA_C', 3, NULL),
(28938, NULL, 'IPR038885', NULL, 'Phospholipase B1, membrane-associated', 'PLB1', 4, NULL),
(28939, NULL, 'IPR036148', NULL, 'MmgE/PrpD superfamily', 'MmgE/PrpD_sf', 5, NULL),
(28940, NULL, 'IPR040751', NULL, 'S-layer protein SbsC, C-terminal domain', 'SbsC_C', 3, NULL),
(28941, NULL, 'IPR033760', NULL, 'Integrin beta N-terminal', 'Integrin_beta_N', 3, NULL),
(28942, NULL, 'IPR041218', NULL, 'Domain of unknown function DUF5606', 'DUF5606', 3, NULL),
(28943, NULL, 'IPR040676', NULL, 'Domain of unknown function DUF5641', 'DUF5641', 3, NULL),
(28944, NULL, 'IPR037992', NULL, 'TRAPP complex, Trs33 subunit', 'TRAPPC6/Trs33', 4, NULL),
(28945, NULL, 'IPR036682', NULL, 'Insect odorant-binding protein A10/Ejaculatory bulb-specific protein 3 superfamily', 'OS_D_A10/PebIII_sf', 5, NULL),
(28946, NULL, 'IPR036371', NULL, 'Thiamin pyrophosphokinase, thiamin-binding domain superfamily', 'TPK_B1-bd_sf', 5, NULL),
(28947, NULL, 'IPR037454', NULL, 'PACSIN1, F-BAR', 'PACSIN1_F-BAR', 3, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(28948, NULL, 'IPR039745', NULL, 'Vacuolar protein sorting-associated protein 54', 'Vps54', 4, NULL),
(28949, NULL, 'IPR041119', NULL, 'SMODS and SLOG-associating 2TM effector domain 6', 'SLATT_6', 3, NULL),
(28950, NULL, 'IPR036897', NULL, 'Carbamoyl-phosphate synthetase, large subunit oligomerisation domain superfamily', 'CarbamoylP_synth_lsu_oligo_sf', 5, NULL),
(28951, NULL, 'IPR040580', NULL, 'Domain of unknown function DUF5627', 'DUF5627', 3, NULL),
(28952, NULL, 'IPR040085', NULL, 'Protein MJ0674-like', 'MJ0674-like', 4, NULL),
(28953, NULL, 'IPR040785', NULL, 'Immune Mapped Protein 1-like, C-terminal domain', 'IMP1-like_C', 3, NULL),
(28954, NULL, 'IPR041058', NULL, 'Alpha-(1,3)-fucosyltransferase FucT, N-terminal', 'FucT_N', 3, NULL),
(28955, NULL, 'IPR040656', NULL, 'Cas9, WED domain', 'Cas9_WED_dom', 3, NULL),
(28956, NULL, 'IPR038306', NULL, 'CagS superfamily', 'CagS_sf', 5, NULL),
(28957, NULL, 'IPR033761', NULL, 'Negative modulator of initiation of replication SeqA, N-terminal', 'SeqA_N', 3, NULL),
(28958, NULL, 'IPR041169', NULL, 'Alpha helical domain', 'Alpha_helical', 3, NULL),
(28959, NULL, 'IPR037900', NULL, 'CISK, PX domain', 'CISK_PX', 3, NULL),
(28960, NULL, 'IPR039480', NULL, 'C-C bond lyase-like', 'C-C_Bond_Lyase-like', 4, NULL),
(28961, NULL, 'IPR040756', NULL, 'Peptidase M61, N-terminal domain', 'Peptidase_M61_N', 3, NULL),
(28962, NULL, 'IPR041074', NULL, 'Endo-beta-N-acetylglucosaminidase LytB, WW domain', 'LytB_WW', 3, NULL),
(28963, NULL, 'IPR037699', NULL, 'Uncharacterized protein At5g65660-like', 'At5g65660-like', 4, NULL),
(28964, NULL, 'IPR036910', NULL, 'High mobility group box domain superfamily', 'HMG_box_dom_sf', 5, NULL),
(28965, NULL, 'IPR039043', NULL, 'Zinc finger protein-like 1', 'ZFPL1', 4, NULL),
(28966, NULL, 'IPR040462', NULL, 'Protein EARLY FLOWERING 4', 'EARLY_FLOWERING_4', 4, NULL),
(28967, NULL, 'IPR041071', NULL, 'DAHP synthase ferredoxin-like domain', 'DAHP_snth_FXD', 3, NULL),
(28968, NULL, 'IPR041171', NULL, 'SDR-like Ig domain', 'SDR_Ig', 3, NULL),
(28969, NULL, 'IPR041126', NULL, 'Chlamydial protease/proteasome-like activity factor, PDZ domain', 'CPAF_PDZ', 3, NULL),
(28970, NULL, 'IPR040433', NULL, 'Spermatid nuclear transition protein', 'Spermatid_TP', 4, NULL),
(28971, NULL, 'IPR041105', NULL, 'TAR DNA-binding protein 43, N-terminal', 'TDP43_N', 3, NULL),
(28972, NULL, 'IPR041102', NULL, 'UvrA, interaction domain', 'UvrA_inter', 3, NULL),
(28973, NULL, 'IPR035819', NULL, 'Dynamin-binding protein, third N-terminal SH3 domain', 'DNMBP_SH3_N3', 3, NULL),
(28974, NULL, 'IPR033116', NULL, 'Serine proteases, trypsin family, serine active site', 'TRYPSIN_SER', 0, NULL),
(28975, NULL, 'IPR040986', NULL, 'Sulfhydryl oxidase, flavin adenine dinucleotide (FAD) binding domain', 'QSOX_FAD-bd_dom', 3, NULL),
(28976, NULL, 'IPR041145', NULL, 'Domain of unknown function DUF5619', 'DUF5619', 3, NULL),
(28977, NULL, 'IPR038328', NULL, 'Interleukin-34 superfamily', 'IL-34_sf', 5, NULL),
(28978, NULL, 'IPR041033', NULL, 'Prealbumin-like fold domain', 'Prealbumin-like', 3, NULL),
(28979, NULL, 'IPR038606', NULL, 'Takeout superfamily', 'To_sf', 5, NULL),
(28980, NULL, 'IPR036917', NULL, 'Orange carotenoid-binding protein, N-terminal domain superfamily', 'Orange_carotenoid-bd_N_sf', 5, NULL),
(28981, NULL, 'IPR040957', NULL, 'Anosmin-1, cysteine rich domain', 'Anosmin-1_Cys_box', 3, NULL),
(28982, NULL, 'IPR041077', NULL, 'MALT1 immunoglobulin-like domain', 'MALT1_Ig', 3, NULL),
(28983, NULL, 'IPR041059', NULL, 'Protein of of unknown function DUF5558', 'DUF5558', 4, NULL),
(28984, NULL, 'IPR038309', NULL, 'Regulator of RNA polymerase sigma(70) subunit, Rsd/AlgQ superfamily', 'Rsd/AlgQ_sf', 5, NULL),
(28985, NULL, 'IPR041173', NULL, 'L-lysine epsilon oxidase, C-terminal', 'LodA_C', 3, NULL),
(28986, NULL, 'IPR040750', NULL, 'eIF3 subunit M, C-terminal helix domain', 'eIF3m_C_helix', 3, NULL),
(28987, NULL, 'IPR036908', NULL, 'RlpA-like domain superfamily', 'RlpA-like_sf', 5, NULL),
(28988, NULL, 'IPR038305', NULL, 'HeLo domain superfamily', 'HeLo_sf', 5, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(28989, NULL, 'IPR041114', NULL, 'Nitrous oxide reductase, propeller repeat 1', 'Nos_propeller', 7, NULL),
(28990, NULL, 'IPR040770', NULL, 'Rtt106, pleckstrin homology domain', 'Rtt106_PH', 3, NULL),
(28991, NULL, 'IPR040692', NULL, 'UGGT, thioredoxin-like domain 3', 'UGGT_TRXL_3', 3, NULL),
(28992, NULL, 'IPR033669', NULL, 'Fused isobutyryl-CoA mutase', 'IcmF', 4, NULL),
(28993, NULL, 'IPR039983', NULL, 'Cholesterol 24-hydroxylase', 'CYP46A1', 4, NULL),
(28994, NULL, 'IPR039493', NULL, 'TMEM248/TMEM219', 'TMEM248/TMEM219', 4, NULL),
(28995, NULL, 'IPR039747', NULL, 'DNA-directed RNA polymerases I, II, and III subunit RPABC4', 'RPABC4', 4, NULL),
(28996, NULL, 'IPR041178', NULL, 'RPA43, OB domain', 'RPA43_OB', 3, NULL),
(28997, NULL, 'IPR041152', NULL, 'Oligosaccharyltransferase, peripheral 2 domain', 'OST_P2', 3, NULL),
(28998, NULL, 'IPR036677', NULL, 'EutN/Ccml superfamily', 'EutN_CcmL_sf', 5, NULL),
(28999, NULL, 'IPR036884', NULL, '[2Fe-2S]-binding domain superfamily', '2Fe-2S-bd_dom_sf', 5, NULL),
(29000, NULL, 'IPR039478', NULL, 'Protein FAM184A/B, N-terminal', 'FAM184A/B_N', 3, NULL),
(29001, NULL, 'IPR040748', NULL, 'HP0268', 'HP0268', 3, NULL),
(29002, NULL, 'IPR041392', NULL, 'Beta-galactosidase, beta-sandwich domain', 'GHD', 3, NULL),
(29003, NULL, 'IPR041230', NULL, 'FbpC, C-terminal regulatory nucleotide binding domain', 'FbpC_C', 3, NULL),
(29004, NULL, 'IPR034007', NULL, 'C-type lectin-like domain, bacterial', 'CTLD_bac', 3, NULL),
(29005, NULL, 'IPR041182', NULL, 'Leptin receptor, immunoglobulin-like domain', 'LEP-R_IGD', 3, NULL),
(29006, NULL, 'IPR041484', NULL, 'TetR transcriptional regulator Rv1219c-like, C-terminal domain', 'TetR_C_25', 3, NULL),
(29007, NULL, 'IPR034932', NULL, 'BRAP2, RNA recognition motif', 'BRAP2_RRM', 3, NULL),
(29008, NULL, 'IPR041353', NULL, 'Flax-rust effector AvrM, N-terminal domain', 'AvrM_N', 3, NULL),
(29009, NULL, 'IPR040802', NULL, 'Peptidoglycan GlcNAc deacetylase, N-terminal', 'PgdA_N', 3, NULL),
(29010, NULL, 'IPR041284', NULL, 'Fungal defensin Copsin', 'Copsin', 3, NULL),
(29011, NULL, 'IPR033265', NULL, 'Gem-associated protein 4', 'GEMIN4', 4, NULL),
(29012, NULL, 'IPR036397', NULL, 'Ribonuclease H superfamily', 'RNaseH_sf', 5, NULL),
(29013, NULL, 'IPR037038', NULL, 'tRNA nuclease HepT-like superfamily', 'HepT-like_sf', 5, NULL),
(29014, NULL, 'IPR034829', NULL, 'DnaD-like domain superfamily', 'DnaD-like_sf', 5, NULL),
(29015, NULL, 'IPR041480', NULL, 'Cysteine-rich interdomain region 1 gamma', 'CIDR1_gamma', 3, NULL),
(29016, NULL, 'IPR041383', NULL, 'RuvC endonuclease subdomain 3', 'RuvC_III', 3, NULL),
(29017, NULL, 'IPR040819', NULL, 'Rolling Circle replication initiation protein, N-terminal', 'Rol_Rep_N', 3, NULL),
(29018, NULL, 'IPR033978', NULL, 'L-talarate/galactarate dehydratase', 'L-talarate_dehydratase', 4, NULL),
(29019, NULL, 'IPR040816', NULL, 'STY4199-like HEPN domain', 'STY4199_HEPN_dom', 3, NULL),
(29020, NULL, 'IPR037228', NULL, 'PhtA domain superfamily', 'PhtA_dom_sf', 5, NULL),
(29021, NULL, 'IPR033803', NULL, 'CBM6/CBM35/CBM36-like 2', 'CBM6/CBM35/CBM36-like_2', 3, NULL),
(29022, NULL, 'IPR041427', NULL, 'AbiJ-NTD3', 'AbiJ-NTD3', 3, NULL),
(29023, NULL, 'IPR037354', NULL, 'COMM domain-containing protein 2', 'Commd2', 4, NULL),
(29024, NULL, 'IPR040948', NULL, 'Protein of unknown function DUF5639', 'DUF5639', 3, NULL),
(29025, NULL, 'IPR035545', NULL, 'Outer membrane lipoprotein virB7', 'VirB7', 4, NULL),
(29026, NULL, 'IPR041367', NULL, 'E3 ligase, CCCH-type zinc finger', 'Znf-CCCH_4', 3, NULL),
(29027, NULL, 'IPR033416', NULL, 'Periplasmic sensor domain CHASE7', 'CHASE7', 3, NULL),
(29028, NULL, 'IPR033469', NULL, 'CYTH-like domain superfamily', 'CYTH-like_dom_sf', 5, NULL),
(29029, NULL, 'IPR040804', NULL, 'Tetracyclin repressor-like, C-terminal domain 18', 'TetR_C_18', 3, NULL),
(29030, NULL, 'IPR040379', NULL, 'WD repeat-containing protein 19/dyf-2', 'WDR19/dyf-2', 4, NULL),
(29031, NULL, 'IPR041404', NULL, 'Protein of unknown function DUF5588', 'DUF5588', 4, NULL),
(29032, NULL, 'IPR036248', NULL, 'Clostridium neurotoxin, translocation domain', 'Clostridium_toxin_transloc', 5, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(29033, NULL, 'IPR040385', NULL, 'Rab-like protein 6', 'RABL6', 4, NULL),
(29034, NULL, 'IPR041200', NULL, 'FKBP3, basic tilted helix bundle domain', 'FKBP3_BTHB', 3, NULL),
(29035, NULL, 'IPR041262', NULL, 'Spore germination GerD, central core domain', 'GerD_central', 3, NULL),
(29036, NULL, 'IPR040232', NULL, 'Protein Kreg-1', 'Kreg-1', 4, NULL),
(29037, NULL, 'IPR041104', NULL, 'DNA processing protein A, sterile alpha motif domain', 'SAM_DrpA', 3, NULL),
(29038, NULL, 'IPR034951', NULL, 'Regulator of G-protein signalling 3, RGS domain', 'RGS_RGS3', 3, NULL),
(29039, NULL, 'IPR038959', NULL, 'Pre-mRNA-processing factor 19', 'Prp19', 4, NULL),
(29040, NULL, 'IPR033867', NULL, 'Ribosome assembly factor Mrt4', 'Mrt4', 4, NULL),
(29041, NULL, 'IPR040822', NULL, 'Swi6, N-terminal', 'Swi6_N', 3, NULL),
(29042, NULL, 'IPR040799', NULL, 'ComR, tetratricopeptide', 'ComR_TPR', 3, NULL),
(29043, NULL, 'IPR033113', NULL, 'Phospholipase A2, histidine active site', 'PLipase_A2_His_AS', 0, NULL),
(29044, NULL, 'IPR041358', NULL, 'Rubisco accumulation factor 1, alpha helical domain', 'Raf1_N', 3, NULL),
(29045, NULL, 'IPR041097', NULL, 'PKHD-type hydroxylase C-terminal domain', 'PKHD_C', 3, NULL),
(29046, NULL, 'IPR033470', NULL, 'Uncharacterised protein, DhaK domain', 'UPF_DhaK', 3, NULL),
(29047, NULL, 'IPR041205', NULL, 'Copper resistance protein ScsC, N-terminal', 'ScsC_N', 3, NULL),
(29048, NULL, 'IPR040808', NULL, 'Protein of unknown function DUF5630', 'DUF5630', 4, NULL),
(29049, NULL, 'IPR041283', NULL, 'Leucine-rich repeat unit', 'LRR_12', 7, NULL),
(29050, NULL, 'IPR041342', NULL, 'Carbohydrate binding module family 35', 'CMB_fam35', 3, NULL),
(29051, NULL, 'IPR041235', NULL, 'Exportin-1, repeat 2', 'Exp1_repeat_2', 7, NULL),
(29052, NULL, 'IPR033555', NULL, 'TCF3 fusion partner', 'TFPT', 4, NULL),
(29053, NULL, 'IPR033738', NULL, 'Asparagine synthase, N-terminal domain', 'AsnB_N', 3, NULL),
(29054, NULL, 'IPR041370', NULL, 'Methyltransferase EEF1AKMT1/ZCCHC4', 'Mlase_EEF1AKMT1/ZCCHC4', 4, NULL),
(29055, NULL, 'IPR040997', NULL, 'IL-7Ralpha, fibronectin type III domain', 'FN3_7', 3, NULL),
(29056, NULL, 'IPR041387', NULL, 'FHOD1, N-terminal GTPase-binding domain', 'FHOD1_GBD_N', 3, NULL),
(29057, NULL, 'IPR037054', NULL, 'Alpha-glucuronidase, C-terminal domain superfamily', 'A-glucoronidase_C_sf', 5, NULL),
(29058, NULL, 'IPR041101', NULL, 'Transport inhibitor response 1 domain', 'Transp_inhibit', 3, NULL),
(29059, NULL, 'IPR041298', NULL, 'DNA polymerase eta, ubiquitin-binding zinc finger', 'UBZ3', 3, NULL),
(29060, NULL, 'IPR035871', NULL, 'Growth hormone-inducible transmembrane protein', 'GHITM', 3, NULL),
(29061, NULL, 'IPR037033', NULL, 'DNA-directed RNA polymerase, subunit 2, hybrid-binding domain superfamily', 'DNA-dir_RNAP_su2_hyb_sf', 5, NULL),
(29062, NULL, 'IPR041359', NULL, 'Metanogen output domain 1', 'MetOD1', 3, NULL),
(29063, NULL, 'IPR041280', NULL, 'Bacterial Ig domain, transpeptidase-associated', 'Big_10', 3, NULL),
(29064, NULL, 'IPR038732', NULL, 'FAD-dependent urate hydroxylase HpyO, FAD/NAD(P)-binding domain', 'HpyO_NAD-binding', 3, NULL),
(29065, NULL, 'IPR037473', NULL, 'Rubber oxygenase Lcp-like', 'Lcp-like', 4, NULL),
(29066, NULL, 'IPR034732', NULL, 'Extended PHD (ePHD) domain', 'EPHD', 3, NULL),
(29067, NULL, 'IPR041482', NULL, 'LSDAT, prokaryote', 'LSDAT_prok', 3, NULL),
(29068, NULL, 'IPR041486', NULL, 'NAD(+) hydrolase ThsA, Sir2/TIR-associating SLOG domain', 'ThsA_STALD', 3, NULL),
(29069, NULL, 'IPR041293', NULL, 'Serine-tRNA ligase type 2, tRNA-binding domain', 'SerS_tRNA-bd', 3, NULL),
(29070, NULL, 'IPR038730', NULL, 'Hydrogenase-4 component E-like', 'HyfE-like', 4, NULL),
(29071, NULL, 'IPR041493', NULL, 'PRDM4, zinc knuckle motif', 'PRDM4_Znf_knuckle', 3, NULL),
(29072, NULL, 'IPR034745', NULL, 'Deoxyuridine 5''-triphosphate nucleotidohydrolase', 'HSV_DUT', 4, NULL),
(29073, NULL, 'IPR037226', NULL, 'CAC2185-like superfamily', 'CAC2185-like_sf', 5, NULL),
(29074, NULL, 'IPR034729', NULL, 'Zinc finger CCHC HIVEP-type', 'ZF_CCHC_HIVEP', 3, NULL),
(29075, NULL, 'IPR036194', NULL, 'Flagellar transcriptional activator FlhD superfamily', 'FlhD_sf', 5, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(29076, NULL, 'IPR041363', NULL, 'LIM interaction domain', 'LID', 3, NULL),
(29077, NULL, 'IPR033665', NULL, 'D-aminoacyl-tRNA deacylase DTD3', 'Deacylase_DTD3', 4, NULL),
(29078, NULL, 'IPR037041', NULL, 'Trigger factor, C-terminal domain superfamily', 'Trigger_fac_C_sf', 5, NULL),
(29079, NULL, 'IPR037230', NULL, 'Non-structural protein NSP8 superfamily, coronavirus', 'NSP8_sf_CoV', 5, NULL),
(29080, NULL, 'IPR037355', NULL, 'COMM domain-containing protein 3', 'COMMD3', 4, NULL),
(29081, NULL, 'IPR041004', NULL, 'Cell-traversal protein for ookinetes and sporozoites', 'CelTOS', 3, NULL),
(29082, NULL, 'IPR037387', NULL, 'Pentatricopeptide repeat domain-containing protein 3', 'PTCD3', 4, NULL),
(29083, NULL, 'IPR036197', NULL, 'NarG-like superfamily', 'NarG-like_sf', 5, NULL),
(29084, NULL, 'IPR041201', NULL, 'PTPRJ, transmembrane domain', 'PTPRJ_TM', 3, NULL),
(29085, NULL, 'IPR041451', NULL, 'RecD-like DNA helicase, SH3 domain', 'RecD-like_SH13', 3, NULL),
(29086, NULL, 'IPR039346', NULL, 'Classical arabinogalactan protein 25/26', 'AGP25/26', 4, NULL),
(29087, NULL, 'IPR041217', NULL, 'Cas9 C-terminal domain', 'Cas9_C', 3, NULL),
(29088, NULL, 'IPR034931', NULL, 'ETP1, RNA recognition motif', 'ETP1_RRM', 3, NULL),
(29089, NULL, 'IPR041223', NULL, 'ApeA, N-terminal domain 1', 'ApeA_NTD1', 3, NULL),
(29090, NULL, 'IPR041315', NULL, 'PlcR,  tetratricopeptide repeat', 'PlcR_TPR', 7, NULL),
(29091, NULL, 'IPR041442', NULL, 'PIH1D1/2/3, CS-like domain', 'PIH1D1/2/3_CS-like', 3, NULL),
(29092, NULL, 'IPR035574', NULL, 'Tyrosine-protein kinase BTK, SH3 domain', 'BTK_SH3', 3, NULL),
(29093, NULL, 'IPR041083', NULL, 'AAA lid domain', 'AAA_lid_10', 3, NULL),
(29094, NULL, 'IPR040941', NULL, 'Exuperantia, SAM-like domain', 'SAM_Exu', 3, NULL),
(29095, NULL, 'IPR036198', NULL, 'Ecotin superfamily', 'Ecotin_sf', 5, NULL),
(29096, NULL, 'IPR033805', NULL, 'CDI inhibitor, Bp1026b-like', 'CdiI_Bp1026b-like', 3, NULL),
(29097, NULL, 'IPR040943', NULL, 'Protein of unknown function DUF5571', 'DUF5571', 4, NULL),
(29098, NULL, 'IPR037035', NULL, 'Glycerate kinase-like, C-terminal domain superfamily', 'GK-like_C_sf', 5, NULL),
(29099, NULL, 'IPR040809', NULL, 'Large polyvalent protein associated domain 28', 'LPD28', 3, NULL),
(29100, NULL, 'IPR041375', NULL, 'VapC45, PIN like domain', 'VapC45_PIN-like', 3, NULL),
(29101, NULL, 'IPR038052', NULL, 'Chaperonin-like RbcX superfamily', 'Chaperonin_RbcX_sf', 5, NULL),
(29102, NULL, 'IPR041234', NULL, 'Domain of unknown function DUF5617', 'DUF5617', 3, NULL),
(29103, NULL, 'IPR039032', NULL, 'Rim-like', 'Rim-like', 4, NULL),
(29104, NULL, 'IPR033112', NULL, 'Phospholipase A2, aspartic acid active site', 'PLipase_A2_Asp_AS', 0, NULL),
(29105, NULL, 'IPR041423', NULL, 'DNA gyrase subunit B insert domain', 'GyrB_insert', 3, NULL),
(29106, NULL, 'IPR041291', NULL, 'Histone methyltransferase, Tudor domain 1', 'TUDOR_5', 3, NULL),
(29107, NULL, 'IPR033811', NULL, 'Proteasome beta 3 subunit', 'Proteasome_beta_3', 4, NULL),
(29108, NULL, 'IPR039144', NULL, 'Aveugle-like, SAM domain', 'Aveugle-like_SAM_dom', 3, NULL),
(29109, NULL, 'IPR041352', NULL, 'Major tropism determinant, N-terminal domain', 'Mtd_N', 3, NULL),
(29110, NULL, 'IPR041389', NULL, 'Importin repeat 6', 'Importin_rep_6', 7, NULL),
(29111, NULL, 'IPR041038', NULL, 'TarS beta-glycosyltransferase C-terminal domain 1', 'TarS_C1', 3, NULL),
(29112, NULL, 'IPR034258', NULL, 'Ascorbate oxidase, second cupredoxin domain', 'CuRO_2_AAO', 3, NULL),
(29113, NULL, 'IPR033412', NULL, 'Pyruvate:ferredoxin oxidoreductase, core domain II', 'PFOR_II', 3, NULL),
(29114, NULL, 'IPR041400', NULL, 'PARP16 N-terminal domain', 'PARP16_N', 3, NULL),
(29115, NULL, 'IPR037227', NULL, 'Endoribonuclease EndoU-like', 'EndoU-like', 5, NULL),
(29116, NULL, 'IPR040998', NULL, 'Barnase-EndoU-ColicinE5/D-RelE like', 'PBECR5', 3, NULL),
(29117, NULL, 'IPR035585', NULL, 'Serine/arginine-rich splicing factor SRSF4-like, RNA recognition motif 1', 'RRM1_SRSF4-like', 3, NULL),
(29118, NULL, 'IPR041300', NULL, 'CxC7-like cysteine cluster associated with KDZ transposases', 'CxC7', 3, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(29119, NULL, 'IPR035091', NULL, 'Gap junction alpha-1 protein (Cx43), alpha helix domain superfamily', 'Alpha_helix_dom_sf', 5, NULL),
(29120, NULL, 'IPR041062', NULL, 'Csm1, subunit domain B', 'Csm1_B', 3, NULL),
(29121, NULL, 'IPR033186', NULL, 'Helicase HerA-like C-terminal', 'HerA_C', 3, NULL),
(29122, NULL, 'IPR040353', NULL, 'FLC EXPRESSOR/FLX-like', 'FLX/FLX-like', 4, NULL),
(29123, NULL, 'IPR040944', NULL, 'Importin 13 repeat 2', 'Importin_rep_2', 7, NULL),
(29124, NULL, 'IPR041513', NULL, 'SAS-6 coiled-coil domain', 'SAS6_CC', 3, NULL),
(29125, NULL, 'IPR040949', NULL, 'HetR, C-terminal Hood domain', 'HetR_C', 3, NULL),
(29126, NULL, 'IPR033264', NULL, 'BZR family', 'BZR', 4, NULL),
(29127, NULL, 'IPR039139', NULL, 'Coiled-coil domain-containing protein 170-like', 'CCDC170-like', 4, NULL),
(29128, NULL, 'IPR041371', NULL, 'Glycosyl hydrolase family 92 N-terminal domain', 'GH92_N', 3, NULL),
(29129, NULL, 'IPR041036', NULL, 'Glycoside hydrolase family 5, C-terminal domain', 'GH5_C', 3, NULL),
(29130, NULL, 'IPR033656', NULL, 'Histidyl-anticodon-binding', 'HisRS_anticodon', 3, NULL),
(29131, NULL, 'IPR034515', NULL, 'Carbapenem intermediate methyltransferase, ThnL-like', 'ThnL-like', 4, NULL),
(29132, NULL, 'IPR034897', NULL, 'RBM4, RNA recognition motif 1', 'RBM4_RRM1', 3, NULL),
(29133, NULL, 'IPR033871', NULL, 'Sm-like protein LSm5', 'LSm5', 3, NULL),
(29134, NULL, 'IPR041254', NULL, 'Proprotein convertase subtilisin/kexin type 9, C-terminal domain 1', 'PCSK9_C1', 3, NULL),
(29135, NULL, 'IPR033885', NULL, 'Alkane/xylene monooxygenase', 'AlkB/XylM', 4, NULL),
(29136, NULL, 'IPR041286', NULL, 'MBG domain, YGX type', 'MBG_2', 3, NULL),
(29137, NULL, 'IPR037389', NULL, 'Outer dense fibre protein 1', 'ODFP', 4, NULL),
(29138, NULL, 'IPR033214', NULL, 'A-kinase-interacting protein 1', 'AKIP1', 4, NULL),
(29139, NULL, 'IPR040935', NULL, 'Subtilisin-like protease 2, prodomain', 'Pro_sub2', 3, NULL),
(29140, NULL, 'IPR041258', NULL, 'Large polyvalent protein-associated domain 18', 'LPD18', 3, NULL),
(29141, NULL, 'IPR039145', NULL, '39S ribosomal protein L40, mitochondrial', 'MRPL40', 4, NULL),
(29142, NULL, 'IPR041267', NULL, 'NACHT, LRR and PYD domains-containing protein, helical domain HD2', 'NLRP_HD2', 3, NULL),
(29143, NULL, 'IPR040940', NULL, 'DNA polymerase nu, pseudo-exo domain', 'DNA_pol_P_Exo', 3, NULL),
(29144, NULL, 'IPR033880', NULL, 'SPFH domain, YdjI-like', 'SPFH_YdjI', 3, NULL),
(29145, NULL, 'IPR041088', NULL, 'Ribbon-helix-helix transcriptional regulator', 'RHH_8', 4, NULL),
(29146, NULL, 'IPR037225', NULL, 'NADH-ubiquinone oxidoreductase 51kDa subunit, FMN-binding domain superfamily', 'Nuo51_FMN-bd_sf', 5, NULL),
(29147, NULL, 'IPR040806', NULL, 'SpuA, C-terminal', 'SpuA_C', 3, NULL),
(29148, NULL, 'IPR038733', NULL, 'Predicted DNA-binding protein, ribbon-helix-helix domain', 'Predicted_DNA_bind_prot_RHH', 3, NULL),
(29149, NULL, 'IPR041495', NULL, 'Mub B2-like domain', 'Mub_B2', 3, NULL),
(29150, NULL, 'IPR041369', NULL, 'TrmO, C-terminal', 'TrmO_C', 3, NULL),
(29151, NULL, 'IPR040814', NULL, 'Activity-regulated cytoskeleton-associated protein, C-terminal domain', 'Arc_C', 3, NULL),
(29152, NULL, 'IPR033804', NULL, 'Lmo2686-like', 'Lmo2686-like', 3, NULL),
(29153, NULL, 'IPR033806', NULL, 'CDI toxin, Bp1026b-like', 'CDI_toxin_Bp1026b-like', 3, NULL),
(29154, NULL, 'IPR037229', NULL, 'Ribosomal protein L35 superfamily', 'Ribosomal_L35_sf', 5, NULL),
(29155, NULL, 'IPR041184', NULL, 'T6 antigen, Ig-like domain', 'T6_Ig-like', 3, NULL),
(29156, NULL, 'IPR035079', NULL, 'Floricaula/Leafy protein, SAM domain', 'LFY_SAM', 3, NULL),
(29157, NULL, 'IPR037223', NULL, 'Protein 9b, SARS-CoV', 'Protein_9b_SARS', 5, NULL),
(29158, NULL, 'IPR040934', NULL, 'Mit1, C-terminal Zn finger 2', 'Znf-CCCH_6', 3, NULL),
(29159, NULL, 'IPR041199', NULL, 'CarS, SH3 domain', 'CarS_SH3', 3, NULL),
(29160, NULL, 'IPR034136', NULL, 'Topoisomerase 6 subunit A/Spo11, TOPRIM domain', 'TOPRIM_Topo6A/Spo11', 3, NULL),
(29161, NULL, 'IPR041402', NULL, 'Dextranase, beta solenoid repeat', 'B_solenoid_dext', 7, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(29162, NULL, 'IPR036059', NULL, 'Metalloprotease TldD/PmbA superfamily', 'TldD/PmbA_sf', 5, NULL),
(29163, NULL, 'IPR041007', NULL, 'Copper(I)-binding protein CorA', 'Cu_bind_CorA', 3, NULL),
(29164, NULL, 'IPR037380', NULL, 'DALR anticodon-binding domain-containing protein 3', 'DALRD3', 4, NULL),
(29165, NULL, 'IPR033447', NULL, 'OSK domain', 'OSK', 3, NULL),
(29166, NULL, 'IPR037046', NULL, 'DNA-3-methyladenine glycosylase AlkA, N-terminal domain superfamily', 'AlkA_N_sf', 5, NULL),
(29167, NULL, 'IPR041203', NULL, 'Bacterial Alpha-2-macroglobulin, MG5 domain', 'Bact_A2M_MG5', 3, NULL),
(29168, NULL, 'IPR033248', NULL, 'Transketolase, C-terminal domain', 'Transketolase_C', 3, NULL),
(29169, NULL, 'IPR041016', NULL, 'Bdellovibrio beta-sandwich', 'BD_b_sandwich', 3, NULL),
(29170, NULL, 'IPR041245', NULL, 'CARMIL, pleckstrin homology domain', 'CARMIL_PH', 3, NULL),
(29171, NULL, 'IPR037039', NULL, 'Chorismate mutase, AroQ class superfamily, eukaryotic', 'CM_AroQ_sf_eucaryotic', 5, NULL),
(29172, NULL, 'IPR034259', NULL, 'Ascorbate oxidase, first cupredoxin domain', 'CuRO_1_AAO', 3, NULL),
(29173, NULL, 'IPR041368', NULL, 'Dam-replacing protein, HTH domain', 'DRP_C', 3, NULL),
(29174, NULL, 'IPR041252', NULL, 'RL domain', 'RL', 3, NULL),
(29175, NULL, 'IPR033250', NULL, 'C-terminally encoded peptide', 'CEP', 4, NULL),
(29176, NULL, 'IPR041344', NULL, '30K viral movement protein, core domain', '30K_MP_core', 3, NULL),
(29177, NULL, 'IPR040817', NULL, 'Leukemia inhibitory factor receptor, D2 domain', 'LIFR_D2', 3, NULL),
(29178, NULL, 'IPR033673', NULL, '3-hydroxy-5-phosphonooxypentane-2,4-dione thiolase', 'LsrF', 4, NULL),
(29179, NULL, 'IPR041225', NULL, 'Cas9, topo homolgy domain', 'Cas9_Topo', 3, NULL),
(29180, NULL, 'IPR041394', NULL, 'Cthe_2314-like HEPN', 'HEPN_Cthe2314', 3, NULL),
(29181, NULL, 'IPR035109', NULL, 'Ancylostoma-associated secreted protein related', 'ASPR', 4, NULL),
(29182, NULL, 'IPR033122', NULL, 'LETM1-like, ribosome-binding domain', 'LETM1-like_RBD', 3, NULL),
(29183, NULL, 'IPR034759', NULL, 'Peptidyl-tRNA hydrolase, archaea', 'Pept_tRNA_hydro_arch', 4, NULL),
(29184, NULL, 'IPR034505', NULL, 'Anaerobic coproporphyrinogen-III oxidase', 'Coproporphyrinogen-III_oxidase', 4, NULL),
(29185, NULL, 'IPR041350', NULL, 'Carbon monoxide dehydrogenase subunit alpha ,N-terminal', 'CODH_A_N', 3, NULL),
(29186, NULL, 'IPR041226', NULL, 'Nitrososphaera output domain 2', 'NitrOD2', 3, NULL),
(29187, NULL, 'IPR033847', NULL, 'ATP-citrate lyase/succinyl-CoA ligase, conserved site', 'Citrt_syn/SCS-alpha_CS', 2, NULL),
(29188, NULL, 'IPR037347', NULL, 'MJ0144, FMN-binding domain', 'MJ0144_FMN', 3, NULL),
(29189, NULL, 'IPR039383', NULL, 'FHIT family', 'FHIT', 4, NULL),
(29190, NULL, 'IPR041181', NULL, 'DR2241 stabilising domain', 'DR2241_middle', 3, NULL),
(29191, NULL, 'IPR040937', NULL, 'Argonaute, N-terminal', 'Ago_N_1', 3, NULL),
(29192, NULL, 'IPR041302', NULL, 'Ribonuclease inhibitor, leucine rich repeat cap', 'LRR_RI_cap', 7, NULL),
(29193, NULL, 'IPR041290', NULL, 'Tle cognate immunity protein 4, C-terminal domain', 'Tli4_C', 3, NULL),
(29194, NULL, 'IPR036255', NULL, 'YgfB-like superfamily', 'YgfB-like_sf', 5, NULL),
(29195, NULL, 'IPR041357', NULL, 'LegC3 N-terminal, Legionellaceae', 'LegC3_N_Legionellaceae', 3, NULL),
(29196, NULL, 'IPR041103', NULL, 'Glutamate--tRNA ligase, N-terminal domain', 'GluRS_N', 3, NULL),
(29197, NULL, 'IPR041219', NULL, 'Phage tail lysozyme', 'Phage_lysozyme2', 3, NULL),
(29198, NULL, 'IPR041384', NULL, 'DNTTIP1, dimerisation domain', 'DNTTIP1_dimer', 3, NULL),
(29199, NULL, 'IPR033809', NULL, 'USP39', 'USP39', 4, NULL),
(29200, NULL, 'IPR041003', NULL, 'EXOG, C-terminal', 'Exog_C', 3, NULL),
(29201, NULL, 'IPR037050', NULL, 'Domain of unknown function DUF1254 superfamily', 'DUF1254_sf', 5, NULL),
(29202, NULL, 'IPR041396', NULL, 'Cysteine-rich protective antigen 6 bladed domain', 'CyRPA', 3, NULL),
(29203, NULL, 'IPR040945', NULL, 'Domain of unknown function DUF5621', 'DUF5621', 3, NULL),
(29204, NULL, 'IPR033644', NULL, 'Ferrochelatase, C-terminal', 'Ferrochelatase_C', 3, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(29205, NULL, 'IPR040813', NULL, 'Small RNA 2''-O-methyltransferase Hen1, La-motif C-terminal domain', 'Hen1_Lam_C', 3, NULL),
(29206, NULL, 'IPR041361', NULL, 'Nidovirus helicase, RING/Ubox like zinc-binding domain', 'Znf-RING_13', 3, NULL),
(29207, NULL, 'IPR037034', NULL, 'RNA polymerase Rpb2, domain 2 superfamily', 'RNA_pol_Rpb2_2_sf', 5, NULL),
(29208, NULL, 'IPR041139', NULL, 'Major vault protein repeat domain', 'MVP_rep_dom', 3, NULL),
(29209, NULL, 'IPR033801', NULL, 'CBM6/CBM35/CBM36-like 1', 'CBM6-CBM35-CBM36-like_1', 3, NULL),
(29210, NULL, 'IPR041393', NULL, 'Sld3, N-terminal', 'Sld3_N', 3, NULL),
(29211, NULL, 'IPR041268', NULL, 'CCDC81-like prokaryotic HU domain 2', 'HU-CCDC81_bac_2', 3, NULL),
(29212, NULL, 'IPR041295', NULL, 'MapZ, extracellular domain 1', 'MapZ_EC1', 3, NULL),
(29213, NULL, 'IPR041001', NULL, 'Phosphoglucose isomerase, N-terminal', 'PG_isomerase_N', 3, NULL),
(29214, NULL, 'IPR040795', NULL, 'Non-structural protein 2, gammacoronavirus', 'NSP2_gammaCoV', 3, NULL),
(29215, NULL, 'IPR041278', NULL, 'Chitinase W immunoglobulin-like domain', 'ChiW_Ig-like', 3, NULL),
(29216, NULL, 'IPR041308', NULL, 'Xer recombinase, N-terminal', 'Xer_N', 3, NULL),
(29217, NULL, 'IPR037052', NULL, 'Chemotaxis protein CheA, P2 response regulator-binding domain superfamily', 'CheA-like_P2_sf', 5, NULL),
(29218, NULL, 'IPR037472', NULL, 'Methyl-CpG-binding domain-containing protein 8', 'MBD8', 4, NULL),
(29219, NULL, 'IPR037357', NULL, 'COMM domain-containing protein 5', 'COMMD5', 4, NULL),
(29220, NULL, 'IPR041327', NULL, 'TIR- and PNP-associating SLOG family', 'TPALS', 4, NULL),
(29221, NULL, 'IPR037222', NULL, 'GatD, N-terminal superfamily', 'GatD_N_sf', 5, NULL),
(29222, NULL, 'IPR041099', NULL, 'Fatty acid synthase subunit beta, N-terminal domain', 'FAS1_N', 3, NULL),
(29223, NULL, 'IPR036061', NULL, 'CheW-like domain superfamily', 'CheW-like_dom_sf', 5, NULL),
(29224, NULL, 'IPR041355', NULL, 'Pre-SET CXC domain', 'Pre-SET_CXC', 3, NULL),
(29225, NULL, 'IPR041086', NULL, 'YAP binding domain', 'YBD', 3, NULL),
(29226, NULL, 'IPR041303', NULL, 'Phage spike trimer 2', 'Phage_spike_2', 7, NULL),
(29227, NULL, 'IPR035572', NULL, 'Tyrosine-protein kinase Tec, SH3 domain', 'Tec_SH3', 3, NULL),
(29228, NULL, 'IPR041040', NULL, '3-hydroxybutyryl-CoA dehydrogenase reduced Rossmann-fold domain', '3HCDH_RFF', 3, NULL),
(29229, NULL, 'IPR036058', NULL, 'Kazal domain superfamily', 'Kazal_dom_sf', 5, NULL),
(29230, NULL, 'IPR041292', NULL, 'Histone methyltransferase, Tudor domain 2', 'Tudor_4', 3, NULL),
(29231, NULL, 'IPR041112', NULL, 'Nuf2, DHR10-like domain', 'Nuf2_DHR10-like', 3, NULL),
(29232, NULL, 'IPR035616', NULL, 'MvaT, DNA-binding domain', 'MvaT_DBD', 3, NULL),
(29233, NULL, 'IPR033263', NULL, 'E3 ubiquitin-protein ligase RNF180', 'RNF180', 4, NULL),
(29234, NULL, 'IPR041294', NULL, 'Ankyrin ubiquitin-binding domain', 'AnkUBD', 3, NULL),
(29235, NULL, 'IPR041000', NULL, 'Gammaproteobacterial serine protease', 'Serine_protease', 4, NULL),
(29236, NULL, 'IPR038731', NULL, 'Glycosyltransferase RgtA/B/C/D-like', 'RgtA/B/C-like', 3, NULL),
(29237, NULL, 'IPR041263', NULL, 'Gasdermin, PUB domain', 'Gasdermin_PUB', 3, NULL),
(29238, NULL, 'IPR035033', NULL, 'TRIM39, PRY/SPRY domain', 'PRY/SPRY_TRIM39', 3, NULL),
(29239, NULL, 'IPR040811', NULL, 'SMODS and SLOG-associating 2TM effector domain', 'SLATT_4', 3, NULL),
(29240, NULL, 'IPR041483', NULL, 'Tetracyclin repressor-like, C-terminal domain 34', 'TetR_C_34', 3, NULL),
(29241, NULL, 'IPR039381', NULL, 'Endopeptidase La, PDZ domain', 'La_PDZ', 3, NULL),
(29242, NULL, 'IPR041320', NULL, 'CxC1-like cysteine cluster associated with KDZ transposases', 'CxC1', 3, NULL),
(29243, NULL, 'IPR036249', NULL, 'Thioredoxin-like superfamily', 'Thioredoxin-like_sf', 5, NULL),
(29244, NULL, 'IPR041221', NULL, 'Anaphase-promoting complex subunit 1, C-terminal', 'APC1_C', 3, NULL),
(29245, NULL, 'IPR041296', NULL, 'ISP3, C-terminal', 'ISP3_C', 3, NULL),
(29246, NULL, 'IPR033200', NULL, 'Trichohyalin', 'TCHH', 4, NULL),
(29247, NULL, 'IPR035617', NULL, 'RBM6, OCRE domain', 'RBM6_OCRE', 3, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(29248, NULL, 'IPR041323', NULL, 'HEPN-like integron domain', 'HEPN-like_int', 3, NULL),
(29249, NULL, 'IPR041240', NULL, 'Protein of unknown function DUF5541', 'DUF5541', 4, NULL),
(29250, NULL, 'IPR041491', NULL, 'TRPM, SLOG domain', 'TRPM_SLOG', 3, NULL),
(29251, NULL, 'IPR041191', NULL, 'pPIWI_RE three-gene island domain Y', 'pPIWI_RE_Y', 3, NULL),
(29252, NULL, 'IPR033943', NULL, 'Ba3-like heme-copper oxidase subunit I', 'Ba3-like_Oxidase_I', 4, NULL),
(29253, NULL, 'IPR041485', NULL, 'QsdR, TetR regulatory C-terminal domain', 'TetR_C_36', 3, NULL),
(29254, NULL, 'IPR034723', NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta, mitochondrial', 'Succ_CoA_betaA_euk', 4, NULL),
(29255, NULL, 'IPR041313', NULL, 'Domain of unknown function DUF5642', 'DUF5642', 3, NULL),
(29256, NULL, 'IPR041403', NULL, 'DUF4458 domain-containing protein, leucine-rich repeat', 'DUF4458_prot_LRR', 7, NULL),
(29257, NULL, 'IPR033996', NULL, 'Tumor necrosis factor receptor 1B, N-terminal', 'TNFRSF1B_N', 3, NULL),
(29258, NULL, 'IPR041301', NULL, 'Phage-Barnase-EndoU-ColicinE5/D-RelE like nuclease 3', 'PBECR3', 3, NULL),
(29259, NULL, 'IPR041374', NULL, 'Bacterial archaeo-eukaryotic release factor family 12', 'BaeRF_family12', 4, NULL),
(29260, NULL, 'IPR041390', NULL, 'Focal adhesion kinase, N-terminal', 'FADK_N', 3, NULL),
(29261, NULL, 'IPR037351', NULL, 'COMM domain-containing protein 1', 'Murr1', 4, NULL),
(29262, NULL, 'IPR037382', NULL, 'Remodelling complex subunit Rsc/polybromo', 'Rsc/polybromo', 4, NULL),
(29263, NULL, 'IPR038971', NULL, 'Cyclin-dependent protein kinase inhibitor SMR11/SMR16', 'SMR11/SMR16', 4, NULL),
(29264, NULL, 'IPR041109', NULL, 'HMW1C N-terminal', 'HMW1C_N', 3, NULL),
(29265, NULL, 'IPR041373', NULL, 'Reverse transcriptase, RNase H-like domain', 'RT_RNaseH', 3, NULL),
(29266, NULL, 'IPR034937', NULL, 'Protocatechuate 4,5-dioxygenase beta chain', 'PCA_45_Dioxygenase_B', 4, NULL),
(29267, NULL, 'IPR041382', NULL, 'Bacterial dipeptidyl-peptidase SH3 domain', 'SH3_16', 3, NULL),
(29268, NULL, 'IPR041380', NULL, 'Eis-like, acetyltransferase domain', 'Acetyltransf_17', 3, NULL),
(29269, NULL, 'IPR033254', NULL, 'Fasciclin-like arabinogalactan protein', 'Plant_FLA', 4, NULL),
(29270, NULL, 'IPR040815', NULL, 'Nas2, N-terminal', 'Nas2_N', 3, NULL),
(29271, NULL, 'IPR041224', NULL, 'Beta-porphyranase A, C-terminal', 'BPA_C', 3, NULL),
(29272, NULL, 'IPR040951', NULL, 'Interleukin-2 receptor subunit beta, N-terminal', 'IL2RB_N1', 3, NULL),
(29273, NULL, 'IPR040933', NULL, 'Photosystem II Psb31 protein', 'PSII_Pbs31', 3, NULL),
(29274, NULL, 'IPR036057', NULL, 'Class XV myosin, motor domain', 'MYSc_Myo15', 3, NULL),
(29275, NULL, 'IPR041395', NULL, 'HAMP N-terminal domain 3', 'HAMP_N3', 3, NULL),
(29276, NULL, 'IPR039143', NULL, 'Glucosamine 6-phosphate N-acetyltransferase', 'GNPNAT1', 4, NULL),
(29277, NULL, 'IPR041537', NULL, 'Protein of of unknown function DUF5547', 'DUF5547', 4, NULL),
(29278, NULL, 'IPR041504', NULL, 'Adaptive response protein AidB, N-terminal', 'AidB_N', 3, NULL),
(29279, NULL, 'IPR039382', NULL, 'M61 glycyl-aminopeptidase, PDZ domain', 'M61_PDZ_dom', 3, NULL),
(29280, NULL, 'IPR040789', NULL, 'Large polyvalent protein-associated domain 11', 'LPD11', 3, NULL),
(29281, NULL, 'IPR040807', NULL, 'Protein of unknown function DUF5522', 'DUF5522', 4, NULL),
(29282, NULL, 'IPR037042', NULL, 'Bacterial toxin YdaT superfamily', 'YdaT_toxin_sf', 5, NULL),
(29283, NULL, 'IPR040812', NULL, 'RNA helicase UPF1, 1B domain', 'UPF1_1B_dom', 3, NULL),
(29284, NULL, 'IPR041282', NULL, 'FYVE-type zinc finger', 'FYVE_2', 3, NULL),
(29285, NULL, 'IPR037348', NULL, 'Trimethylamine dehydrogenase/Dimethylamine dehydrogenase, FMN-binding domain', 'TMADH/HD_FMN-bd', 3, NULL),
(29286, NULL, 'IPR033813', NULL, 'Penicillin G acylase, C-terminal', 'PGA_C', 3, NULL),
(29287, NULL, 'IPR041132', NULL, 'Domain of unknown function DUF5624', 'DUF5624', 3, NULL),
(29288, NULL, 'IPR040942', NULL, 'Minimal CRISPR polymerase domain', 'Minimal_Cpol', 3, NULL),
(29289, NULL, 'IPR041241', NULL, 'Thymine dioxygenase JBP1, DNA-binding domain', 'DB_JBP1', 3, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(29290, NULL, 'IPR033249', NULL, 'CLAVATA3/ESR (CLE)-related protein, plant', 'CLE_plant', 4, NULL),
(29291, NULL, 'IPR037358', NULL, 'COMM domain-containing protein 7', 'COMMD7', 4, NULL),
(29292, NULL, 'IPR041500', NULL, 'RecC, C-terminal', 'RecC_C', 3, NULL),
(29293, NULL, 'IPR033807', NULL, 'Antirepressor CarS', 'CarS_antirepressor', 3, NULL),
(29294, NULL, 'IPR038940', NULL, 'Noncompact myelin-associated protein', 'NCMAP', 4, NULL),
(29295, NULL, 'IPR037824', NULL, 'NdvB, GH94N domain 2', 'GH94N_2_NdvB', 3, NULL),
(29296, NULL, 'IPR040744', NULL, 'Npun R1517', 'Npun_R1517', 3, NULL),
(29297, NULL, 'IPR033415', NULL, 'C-terminal domain of two-partite extracellular sensor domain', 'CHASE6_C', 3, NULL),
(29298, NULL, 'IPR034728', NULL, 'Peptidase A3B domain', 'Peptidase_A3B', 3, NULL),
(29299, NULL, 'IPR039384', NULL, 'HINT family', 'HINT', 4, NULL),
(29300, NULL, 'IPR041042', NULL, 'Hakai, C2H2 zinc finger domain', 'Znf_Hakai', 3, NULL),
(29301, NULL, 'IPR041376', NULL, 'Integron Cassette Protein Hfx_Cass5', 'Hfx_Cass5', 3, NULL),
(29302, NULL, 'IPR041420', NULL, 'Phage-Barnase-EndoU-ColicinE5/D-RelE like nuclease 4', 'PBECR4', 3, NULL),
(29303, NULL, 'IPR041265', NULL, 'Propionyl-coenzyme A carboxylase, BT domain', 'PCC_BT', 3, NULL),
(29304, NULL, 'IPR041349', NULL, 'Proline utilization A proline dehydrogenase N-terminal domain', 'PRODH', 3, NULL),
(29305, NULL, 'IPR041289', NULL, 'Bacterial archaeo-eukaryotic release factor family 3', 'Bact_RF_family3', 4, NULL),
(29306, NULL, 'IPR040810', NULL, 'Calcium-regulated actin-bundling protein, C-terminal', 'F_actin_bund_C', 3, NULL),
(29307, NULL, 'IPR041496', NULL, 'YitH, acetyltransferase (GNAT) domain', 'YitH_GNAT', 3, NULL),
(29308, NULL, 'IPR041274', NULL, 'Isopullulanase beta-solenoid repeat', 'IPU_b_solenoid', 7, NULL),
(29309, NULL, 'IPR037036', NULL, 'GMP phosphodiesterase, delta subunit superfamily', 'PDED_dom_sf', 5, NULL),
(29310, NULL, 'IPR040726', NULL, 'Halobacterial output domain 2', 'HalOD2', 3, NULL),
(29311, NULL, 'IPR033940', NULL, '3-isopropylmalate dehydratase, swivel domain', 'IPMI_Swivel', 3, NULL),
(29312, NULL, 'IPR034000', NULL, 'Tumour necrosis factor receptor 7, N-terminal', 'TNFRSF7_N', 3, NULL),
(29313, NULL, 'IPR037040', NULL, 'Cytotoxic necrotizing factor, Rho-activating domain superfamily', 'CNF_Rho-act_sf', 5, NULL),
(29314, NULL, 'IPR040805', NULL, 'EMP3/KAHRP, N-terminal', 'EMP3/KAHRP_N', 3, NULL),
(29315, NULL, 'IPR033184', NULL, 'Protein PRRC2', 'PRRC2', 4, NULL),
(29316, NULL, 'IPR037388', NULL, 'Kinetochore scaffold 1', 'Blinkin', 4, NULL),
(29317, NULL, 'IPR033976', NULL, 'Gentamicin-like N-methyltransferase', 'GntE-like', 4, NULL),
(29318, NULL, 'IPR033198', NULL, 'Repetin', 'RPTN', 4, NULL),
(29319, NULL, 'IPR038967', NULL, 'DSC E3 ubiquitin ligase complex subunit 4-like', 'Dsc4-like', 4, NULL),
(29320, NULL, 'IPR033879', NULL, 'Undecaprenyl-diphosphatase', 'UPP_Pase', 3, NULL),
(29321, NULL, 'IPR034722', NULL, 'Succinate--CoA ligase [GDP-forming] subunit beta, mitochondrial', 'Succ_CoA_betaG_euk', 4, NULL),
(29322, NULL, 'IPR036314', NULL, 'Manganese/iron superoxide dismutase, C-terminal domain superfamily', 'SOD_C_sf', 5, NULL),
(29323, NULL, 'IPR040725', NULL, 'PheRS, DNA binding domain 3', 'PheRS_DBD3', 3, NULL),
(29324, NULL, 'IPR041511', NULL, 'Putative DNA-binding domain', 'DBD_HTH', 3, NULL),
(29325, NULL, 'IPR036253', NULL, 'Flavivirus glycoprotein, central and dimerisation domain superfamily', 'Glycoprot_cen/dimer_sf', 5, NULL),
(29326, NULL, 'IPR034678', NULL, 'DNA-directed RNA polymerase subunit RpoC1', 'RNApol_RpoC1', 4, NULL),
(29327, NULL, 'IPR034938', NULL, '3-O-Methylgallate 3,4-dioxygenase', '3MGA_Dioxygenase', 4, NULL),
(29328, NULL, 'IPR040797', NULL, 'Zmiz1, N-terminal tetratricopeptide repeat domain', 'Zmiz1_N', 3, NULL),
(29329, NULL, 'IPR041186', NULL, 'Domain of unknown function DUF3823_C', 'DUF3823_C', 3, NULL),
(29330, NULL, 'IPR040932', NULL, 'Csm4, C-terminal', 'Csm4_C', 3, NULL),
(29331, NULL, 'IPR041014', NULL, 'CEL-III, C-terminal', 'CEL_III_C', 3, NULL),
(29332, NULL, 'IPR041422', NULL, 'Protein of unknown function DUF5545', 'DUF5545', 4, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(29333, NULL, 'IPR041299', NULL, 'Chromatin remodeling factor Mit1, C-terminal Zn finger 1', 'Znf-CCCH_7', 3, NULL),
(29334, NULL, 'IPR036196', NULL, 'Phosphotyrosine protein phosphatase I superfamily', 'Ptyr_pPase_sf', 5, NULL),
(29335, NULL, 'IPR041379', NULL, 'Collagenase ColG-like, catalytic helper subdomain', 'ColG_subdomain', 3, NULL),
(29336, NULL, 'IPR041490', NULL, 'HTH-type transcriptional repressor KstR2, C-terminal', 'KstR2_TetR_C', 3, NULL),
(29337, NULL, 'IPR040947', NULL, 'Short myomegalin-like EB1 binding protein, N-terminal', 'SMYLE_N', 3, NULL),
(29338, NULL, 'IPR041324', NULL, 'Antigen I/II, N-terminal', 'AgI/II_N', 3, NULL),
(29339, NULL, 'IPR041306', NULL, 'NSD, Cys-His rich domain', 'C5HCH', 3, NULL),
(29340, NULL, 'IPR041366', NULL, 'Pre-PUA domain', 'Pre-PUA', 3, NULL),
(29341, NULL, 'IPR041192', NULL, 'ZNF451, PIN-like domain', 'PIN_11', 3, NULL),
(29342, NULL, 'IPR035111', NULL, 'Protein of unknown function DUF5516', 'DUF5516', 4, NULL),
(29343, NULL, 'IPR037045', NULL, 'Peptidase S8 propeptide/proteinase inhibitor I9 superfamily', 'S8pro/Inhibitor_I9_sf', 5, NULL),
(29344, NULL, 'IPR041087', NULL, 'TANK binding kinase 1, ubiquitin-like domain', 'TBK1_ULD', 3, NULL),
(29345, NULL, 'IPR041509', NULL, 'Glycosyl hydrolases 38, beta-1 domain', 'GH38_beta-1', 3, NULL),
(29346, NULL, 'IPR036247', NULL, 'Neurotoxin 3 superfamily', 'Neurotoxin_3_sf', 5, NULL),
(29347, NULL, 'IPR033843', NULL, 'Carboxypeptidase A6', 'CPAH', 3, NULL),
(29348, NULL, 'IPR041011', NULL, 'ZBTB21, zinc finger domain', 'Znf_C2H2_6', 3, NULL),
(29349, NULL, 'IPR035587', NULL, 'DUS-like, FMN-binding domain', 'DUS-like_FMN-bd', 3, NULL),
(29350, NULL, 'IPR037043', NULL, 'Moricin domain superfamily', 'Moricin_sf', 5, NULL),
(29351, NULL, 'IPR040382', NULL, 'Nucleolar protein 10/Enp2', 'NOL10/Enp2', 4, NULL),
(29352, NULL, 'IPR034815', NULL, 'Alpha-dioxygenase', 'A_dioxygenase', 4, NULL),
(29353, NULL, 'IPR041354', NULL, '4''-phosphopantetheinyl transferase, N-terminal domain', '4PPT_N', 3, NULL),
(29354, NULL, 'IPR041347', NULL, 'MftR, C-terminal', 'MftR_C', 3, NULL),
(29355, NULL, 'IPR041134', NULL, 'Major vault protein repeat domain 2', 'Vault_2', 3, NULL),
(29356, NULL, 'IPR035110', NULL, 'HCMV protein UL42', 'UL42', 4, NULL),
(29357, NULL, 'IPR041365', NULL, 'Csp protease B, prodomain', 'CspB_prodomain', 3, NULL),
(29358, NULL, 'IPR037049', NULL, 'Domain of unknown function DUF1214, C-terminal domain superfamily', 'DUF1214_C_sf', 5, NULL),
(29359, NULL, 'IPR037221', NULL, 'H-type lectin domain superfamily', 'H-type_lectin_dom_sf', 5, NULL),
(29360, NULL, 'IPR034514', NULL, 'Carbapenem intermediate methyltransferase ThnK-like', 'ThnK-like', 4, NULL),
(29361, NULL, 'IPR040939', NULL, 'Vacuolar protein sorting 38', 'Vps38', 4, NULL),
(29362, NULL, 'IPR041249', NULL, 'DZIP3-like HEPN domain', 'HEPN_DZIP3', 3, NULL),
(29363, NULL, 'IPR035546', NULL, 'Neutrophil cytosol factor 2, SH3 domain 1', 'p67phox_SH3_1', 3, NULL),
(29364, NULL, 'IPR033413', NULL, 'Domain of unknown function DUF5117', 'DUF5117', 3, NULL),
(29365, NULL, 'IPR034757', NULL, 'Ornithine aminotransferase, bacterial type', 'Ornith_aminotrans_bact', 4, NULL),
(29366, NULL, 'IPR033461', NULL, 'Putative WW-binding domain and destruction box', 'WRNPLPNID', 3, NULL),
(29367, NULL, 'IPR035796', NULL, 'Core histone macro-H2A, macro domain', 'Macro_H2A', 3, NULL),
(29368, NULL, 'IPR033444', NULL, 'Membrane-associated sensor MASE5', 'MASE5', 3, NULL),
(29369, NULL, 'IPR033194', NULL, 'Microfibrillar-associated protein 1', 'MFAP1', 4, NULL),
(29370, NULL, 'IPR036060', NULL, 'Zinc finger, C2H2C-type superfamily', 'Znf_C2H2C_sf', 5, NULL),
(29371, NULL, 'IPR041401', NULL, 'Domain of unknown function DUF5590', 'DUF5590', 3, NULL),
(29372, NULL, 'IPR040790', NULL, 'Kindlin-2, N-terminal', 'Kindlin_2_N', 3, NULL),
(29373, NULL, 'IPR041340', NULL, 'PIK3AP1, Toll/interleukin-1 receptor domain', 'PIK3AP1_TIR', 3, NULL),
(29374, NULL, 'IPR037053', NULL, 'Phage tail collar domain superfamily', 'Phage_tail_collar_dom_sf', 5, NULL),
(29375, NULL, 'IPR037379', NULL, 'WDR74/Nsa1', 'WDR74/Nsa1', 4, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(29376, NULL, 'IPR034508', NULL, 'Spectinomycin biosynthesis', 'Spectinomycin_biosynthesis', 4, NULL),
(29377, NULL, 'IPR039142', NULL, 'NRF1/Ewg family', 'NRF1/Ewg', 4, NULL),
(29378, NULL, 'IPR034726', NULL, 'Scavenger receptor class A member 5', 'SCARA5', 4, NULL),
(29379, NULL, 'IPR037047', NULL, 'PITH domain superfamily', 'PITH_dom_sf', 5, NULL),
(29380, NULL, 'IPR039343', NULL, 'Protein NEOXANTHIN-DEFICIENT 1-like', 'NDX1-like', 4, NULL),
(29381, NULL, 'IPR033453', NULL, 'Glycosyl hydrolase family 30, TIM-barrel domain', 'Glyco_hydro_30_TIM-barrel', 3, NULL),
(29382, NULL, 'IPR040122', NULL, 'Importin beta family', 'Importin_beta', 4, NULL),
(29383, NULL, 'IPR041204', NULL, 'RIG-I-like receptor, C-terminal', 'RIG-I-like_C', 3, NULL),
(29384, NULL, 'IPR040724', NULL, 'PheRS, DNA binding domain 1', 'PheRS_DBD1', 3, NULL),
(29385, NULL, 'IPR035579', NULL, 'Tyrosine-protein kinase TXK, SH3 domain', 'TXK_SH3', 3, NULL),
(29386, NULL, 'IPR039379', NULL, 'Protoglobin, globin sensor domain', 'Protoglobin_sensor_dom', 3, NULL),
(29387, NULL, 'IPR035081', NULL, '(5-formylfuran-3-yl)methyl phosphate synthase, archaea', '4HFCP_synth_arc', 4, NULL),
(29388, NULL, 'IPR040793', NULL, 'CDH1/2, SANT-Helical linker 1', 'CDH1_2_SANT_HL1', 3, NULL),
(29389, NULL, 'IPR041013', NULL, 'Allene oxide cyclase barrel-like domain', 'AOC-like', 3, NULL),
(29390, NULL, 'IPR040746', NULL, 'THO1_MOS11, C-terminal domain', 'THO1_MOS11_C', 3, NULL),
(29391, NULL, 'IPR041341', NULL, 'PSA endolysin, cell wall binding domain', 'PSA_CBD', 3, NULL),
(29392, NULL, 'IPR033443', NULL, 'Pentacotripeptide-repeat region of PRORP', 'PPR_long', 3, NULL),
(29393, NULL, 'IPR037037', NULL, 'L-proline 3-hydroxylase, C-terminal domain superfamily', 'Pro_3_hydrox_C_sf', 5, NULL),
(29394, NULL, 'IPR033417', NULL, 'Periplasmic sensor domain CHASE8', 'CHASE8', 3, NULL),
(29395, NULL, 'IPR033810', NULL, 'Carboxypeptidase T', 'Carboxypeptidase_T', 3, NULL),
(29396, NULL, 'IPR041378', NULL, 'SbsC C-terminal domain', 'S-layer_SbsC_C', 3, NULL),
(29397, NULL, 'IPR041018', NULL, 'Tse2 ADP-ribosyltransferase toxin', 'ADPRTs_Tse2', 3, NULL),
(29398, NULL, 'IPR041501', NULL, 'Defence against restriction A, C-terminal', 'DarA_C', 3, NULL),
(29399, NULL, 'IPR033511', NULL, 'Rho guanine nucleotide exchange factor Cdc24/Scd1, PH domain', 'Cdc24/Scd1_PH_dom', 3, NULL),
(29400, NULL, 'IPR041356', NULL, 'PGM1 C-terminal domain', 'PGM1_C', 3, NULL),
(29401, NULL, 'IPR041029', NULL, 'N-acetylglucosamine binding protein A domain 2', 'GbpA_2', 3, NULL),
(29402, NULL, 'IPR041256', NULL, 'CDI immunity protein', 'CdiI_4', 3, NULL),
(29403, NULL, 'IPR033977', NULL, 'Galactarate dehydratase 2', 'Galactarate_dehydratase_2', 4, NULL),
(29404, NULL, 'IPR041202', NULL, 'Bacterial archaeo-eukaryotic release factor family 10', 'BaeRF_family10', 4, NULL),
(29405, NULL, 'IPR041092', NULL, 'Phage-Barnase-EndoU-ColicinE5/D-RelE-like nuclease', 'PBECR1', 3, NULL),
(29406, NULL, 'IPR039345', NULL, 'Protein STPG4', 'STPG4', 4, NULL),
(29407, NULL, 'IPR041179', NULL, 'Centrosomal protein C10orf90, N-terminal', 'C10orf90_N', 3, NULL),
(29408, NULL, 'IPR041345', NULL, 'Reovirus sigma C capsid protein triple beta spiral', 'Reo_sigmaC_M', 3, NULL),
(29409, NULL, 'IPR037048', NULL, 'KorB, C-terminal domain superfamily', 'KorB_C_sf', 5, NULL),
(29410, NULL, 'IPR041220', NULL, 'Large polyvalent protein associated domain 24', 'LPD24', 3, NULL),
(29411, NULL, 'IPR034680', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase Kae1, archaea and eukaryote', 'Kae1_archaea_euk', 4, NULL),
(29412, NULL, 'IPR041351', NULL, 'Exo-beta-D-glucosaminidase, Ig-fold domain', 'Ig_GlcNase', 3, NULL),
(29413, NULL, 'IPR041136', NULL, 'Major vault protein repeat domain 4', 'Vault_4', 3, NULL),
(29414, NULL, 'IPR041453', NULL, 'Suv3, N-terminal', 'Suv3_N', 3, NULL),
(29415, NULL, 'IPR040950', NULL, 'GPCR-Autoproteolysis-INducing (GAIN) subdomain A', 'GAIN_A', 3, NULL),
(29416, NULL, 'IPR033414', NULL, 'Periplasmic sensor domain', 'Sensor_dom', 3, NULL),
(29417, NULL, 'IPR033812', NULL, 'Proteasome subunit alpha5', 'Proteasome_alpha_type_5', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(29418, NULL, 'IPR037474', NULL, 'Sca1 complex scaffold protein ScaA', 'ScaA', 4, NULL),
(29419, NULL, 'IPR041297', NULL, 'DNA repair protein Crb2, Tudor domain', 'Crb2_Tudor', 3, NULL),
(29420, NULL, 'IPR041222', NULL, 'Primosomal protein N'', 3'' DNA-binding domain', 'PriA_3primeBD', 3, NULL),
(29421, NULL, 'IPR033942', NULL, 'Inositol monophosphatase', 'IMPase', 4, NULL),
(29422, NULL, 'IPR039938', NULL, 'Zinc finger protein 781', 'ZNF781', 4, NULL),
(29423, NULL, 'IPR041381', NULL, 'JAK1-3/TYK2, pleckstrin homology-like domain', 'JAK1-3/TYK2_PHL_dom', 3, NULL),
(29424, NULL, 'IPR034930', NULL, 'Matrin-3, RNA recognition motif 2', 'MATR3_RRM2', 3, NULL),
(29425, NULL, 'IPR034720', NULL, 'Viral alkaline exonuclease', 'Viral_alk_exo', 4, NULL),
(29426, NULL, 'IPR033446', NULL, 'Zinc finger domain-containing protein 24, zinc-binding domain', 'Zcchc24_Znf-3CxxC', 3, NULL),
(29427, NULL, 'IPR040798', NULL, 'Rpn9, C-terminal helix', 'Rpn9_C', 3, NULL),
(29428, NULL, 'IPR040747', NULL, 'BILBO1, N-terminal domain', 'BILBO1_N', 3, NULL),
(29429, NULL, 'IPR041264', NULL, 'SidC, N-terminal', 'SidC_N', 3, NULL),
(29430, NULL, 'IPR041388', NULL, 'PNK, FHA domain', 'FHA_2', 3, NULL),
(29431, NULL, 'IPR041346', NULL, 'DR2241, 4Fe-4S iron-sulfur cluster binding domain', 'DR2241_Fer4', 3, NULL),
(29432, NULL, 'IPR040745', NULL, 'Ankyrin, UPA domain', 'Ankyrin_UPA', 3, NULL),
(29433, NULL, 'IPR040938', NULL, 'Legionella ubiquitin-specific protease A domain', 'LupA', 3, NULL),
(29434, NULL, 'IPR033919', NULL, 'Transaldolase/Fructose-6-phosphate aldolase, archaeal/bacterial', 'TSA/FSA_arc/bac', 4, NULL),
(29435, NULL, 'IPR041385', NULL, '5''-3'' exoribonuclease 1, SH3-like domain', 'SH3_12', 3, NULL),
(29436, NULL, 'IPR041391', NULL, 'Protein of unknown function DUF5570', 'DUF5570', 4, NULL),
(29437, NULL, 'IPR034731', NULL, 'Zinc finger CCHC FOG-type', 'ZF_CCHC_FOG', 3, NULL),
(29438, NULL, 'IPR041397', NULL, 'ThiD2', 'ThiD2', 3, NULL),
(29439, NULL, 'IPR041360', NULL, 'ZAP, helix turn helix N-terminal domain', 'ZAP_HTH', 3, NULL),
(29440, NULL, 'IPR040946', NULL, 'Endoglucanase B, carbohydrate binding domain', 'CBM46', 3, NULL),
(29441, NULL, 'IPR041398', NULL, 'DdrB-like domain', 'DdrB_dom', 3, NULL),
(29442, NULL, 'IPR033944', NULL, 'Cytochrome c oxidase subunit I domain', 'Cyt_c_oxase_su1_dom', 3, NULL),
(29443, NULL, 'IPR041027', NULL, 'FtsK alpha domain', 'FtsK_alpha', 3, NULL),
(29444, NULL, 'IPR041441', NULL, 'Pih1, Ascomycota, CS domain', 'Pih1_CS_Ascomycota', 3, NULL),
(29445, NULL, 'IPR041276', NULL, 'Vacuolar ATPase subunit I, N-terminal proximal lobe', 'V_ATPase_prox', 3, NULL),
(29446, NULL, 'IPR035869', NULL, 'Ras and Rab interactor 3, SH2 domain', 'RIN3_SH2', 3, NULL),
(29447, NULL, 'IPR040818', NULL, 'Tsi6', 'Tsi6', 3, NULL),
(29448, NULL, 'IPR041008', NULL, 'Domain of unknown function DUF5625', 'DUF5625', 3, NULL),
(29449, NULL, 'IPR041021', NULL, '5-hmdU DNA kinase 2', 'HMUD2', 4, NULL),
(29450, NULL, 'IPR037381', NULL, 'E3 ubiquitin-protein ligase RFWD3', 'RFWD3', 4, NULL),
(29451, NULL, 'IPR033814', NULL, 'Carboxypeptidase N, N-terminal domain', 'M14_CPN', 3, NULL),
(29452, NULL, 'IPR036402', NULL, 'Elongation factor Ts, dimerisation domain superfamily', 'EF-Ts_dimer_sf', 5, NULL),
(29453, NULL, 'IPR041362', NULL, 'Plexin, TIG domain 2', 'TIG2_plexin', 3, NULL),
(29454, NULL, 'IPR041248', NULL, 'YDG domain', 'YDG', 3, NULL),
(29455, NULL, 'IPR034738', NULL, 'Inner tegument protein', 'HSV_ITP', 4, NULL),
(29456, NULL, 'IPR041089', NULL, 'SUB1 protease prodomain ProdP9', 'SUB1_ProdP9', 3, NULL),
(29457, NULL, 'IPR041231', NULL, 'FlgA, N-terminal', 'FlgA_N', 3, NULL),
(29458, NULL, 'IPR041244', NULL, 'Ribosomal L27 protein, C-terminal', 'Ribosomal_L27_C', 3, NULL),
(29459, NULL, 'IPR041261', NULL, 'ATP-grasp domain, R2K clade family 2', 'R2K_2', 3, NULL),
(29460, NULL, 'IPR041523', NULL, 'Roquin II', 'ROQ_II', 3, NULL),
(29461, NULL, 'IPR033654', NULL, 'Sialidase, Influenza viruses A/B', 'Sialidase_Influenza_A/B', 3, NULL),
(29462, NULL, 'IPR040820', NULL, 'Secreted Novel AID/APOBEC-like Deaminase 3', 'SNAD3', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(29463, NULL, 'IPR040743', NULL, 'DNA methylase N-terminal domain', 'DNA_meth_N', 3, NULL),
(29464, NULL, 'IPR041190', NULL, 'Midasin AAA lid domain 5', 'Midasin_AAA_lid_5', 3, NULL),
(29465, NULL, 'IPR038964', NULL, 'Alpha-L-arabinofuranosidase B', 'ABFB', 4, NULL),
(29466, NULL, 'IPR033676', NULL, 'Autoinducer-2 kinase', 'AI-2_kinase', 4, NULL),
(29467, NULL, 'IPR033545', NULL, 'Centrosomal protein of 89kDa', 'CEP89', 4, NULL),
(29468, NULL, 'IPR036257', NULL, 'Cytochrome C oxidase subunit II, transmembrane domain superfamily', 'Cyt_c_oxidase_su2_TM_sf', 5, NULL),
(29469, NULL, 'IPR040821', NULL, 'Testis-specific protein LINC02914-like', 'LINC02914-like', 4, NULL),
(29470, NULL, 'IPR033941', NULL, '3-Isopropylmalate dehydratase, catalytic domain', 'IPMI_cat', 3, NULL),
(29471, NULL, 'IPR037350', NULL, 'Lactate 2-monooxygenase, FMN-binding domain', 'LMO_FMN', 3, NULL),
(29472, NULL, 'IPR034898', NULL, 'RBM4, RNA recognition motif 2', 'RBM4_RRM2', 3, NULL),
(29473, NULL, 'IPR041364', NULL, 'Rubredoxin binding domain', 'Rbx-bd', 3, NULL),
(29474, NULL, 'IPR037356', NULL, 'COMM domain-containing protein 4', 'Commd4', 4, NULL),
(29475, NULL, 'IPR039034', NULL, 'Inositol 3,4-bisphosphate 4-phosphatase', 'INPP4', 4, NULL),
(29476, NULL, 'IPR041372', NULL, 'Cas3, C-terminal', 'Cas3_C', 3, NULL),
(29477, NULL, 'IPR037051', NULL, 'Four-carbon acid sugar kinase, N-terminal domain superfamily', '4-carb_acid_sugar_kinase_N_sf', 5, NULL),
(29478, NULL, 'IPR041237', NULL, 'Adhesin BspA, variable domain', 'BspA_v', 3, NULL),
(29479, NULL, 'IPR039939', NULL, 'V-set and immunoglobulin domain-containing protein 4', 'VSIG4', 4, NULL),
(29480, NULL, 'IPR039031', NULL, 'Mucolipin', 'Mucolipin', 4, NULL),
(29481, NULL, 'IPR041343', NULL, 'Polycomb repressive complex 2 subunit EZH1/EZH2, tri-helical domain', 'PRC2_HTH_1', 3, NULL),
(29482, NULL, 'IPR041348', NULL, 'VEGFR-2, transmembrane domain', 'VEGFR-2_TMD', 3, NULL),
(29483, NULL, 'IPR035584', NULL, 'Amidophosphoribosyltransferase, N-terminal', 'PurF_N', 3, NULL),
(29484, NULL, 'IPR034008', NULL, 'TC14-like, C-type lectin-like domain', 'TC14-like_CTLD', 3, NULL),
(29485, NULL, 'IPR041253', NULL, 'Carbohydrate binding module 77', 'CBM77', 3, NULL),
(29486, NULL, 'IPR040936', NULL, 'Large polyvalent protein associated domain 26', 'LPD26', 3, NULL),
(29487, NULL, 'IPR035618', NULL, 'RBM10, OCRE domain', 'RBM10_OCRE', 3, NULL),
(29488, NULL, 'IPR041090', NULL, 'Protein of unknown function DUF5578', 'DUF5578', 4, NULL),
(29489, NULL, 'IPR033802', NULL, 'Carbohydrate-binding protein CttA, X module', 'CttA_X', 3, NULL),
(29490, NULL, 'IPR039138', NULL, 'Ubiquitin thioesterase OTU1/2/3', 'OTU1_2_3', 4, NULL),
(29491, NULL, 'IPR033512', NULL, 'Protein TFG', 'TFG', 4, NULL),
(29492, NULL, 'IPR041377', NULL, 'Viral coat protein P2, N-terminal', 'P2_N', 3, NULL),
(29493, NULL, 'IPR033966', NULL, 'RuBisCO', 'RuBisCO', 4, NULL),
(29494, NULL, 'IPR033442', NULL, 'tRNA(Met) cytidine acetyltransferase TmcA, tRNA-binding domain', 'TmcA_tRNA_bind', 3, NULL),
(29495, NULL, 'IPR034519', NULL, 'UDP-N-acetyl-tunicamine-uracil synthase TunB-like', 'TunB-like', 4, NULL),
(29496, NULL, 'IPR041194', NULL, 'GLD-3, KH5 domain', 'GLD-3_KH5', 3, NULL),
(29497, NULL, 'IPR041266', NULL, 'EDS1, EP domain', 'EDS1_EP', 3, NULL),
(29498, NULL, 'IPR033904', NULL, 'Trans-isoprenyl diphosphate synthases, head-to-head', 'Trans_IPPS_HH', 3, NULL),
(29499, NULL, 'IPR041449', NULL, 'Phosphoserine phosphatase, N-terminal', 'SerB_N', 3, NULL),
(29500, NULL, 'IPR041005', NULL, 'DNA polymerase II intein domain IV', 'PI-TkoII_IV', 3, NULL),
(29501, NULL, 'IPR041281', NULL, 'CD180, leucine-rich repeat', 'LRR_11', 7, NULL),
(29502, NULL, 'IPR037155', NULL, 'Staphopain proregion superfamily', 'Staphopain_pro_sf', 5, NULL),
(29503, NULL, 'IPR033616', NULL, 'Protein KIAA1109', 'KIAA1109', 4, NULL),
(29504, NULL, 'IPR034585', NULL, 'Retinitis pigmentosa 9 protein', 'PAP-1', 4, NULL),
(29505, NULL, 'IPR041270', NULL, 'Phage ABA sandwich domain', 'Phage_ABA_S', 3, NULL),
(29506, NULL, 'IPR036680', NULL, 'Sporulation-like domain superfamily', 'SPOR-like_sf', 5, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(29507, NULL, 'IPR041711', NULL, 'Methionyl-tRNA formyltransferase, N-terminal domain', 'Met-tRNA-FMT_N', 3, NULL),
(29508, NULL, 'IPR036646', NULL, 'BPG-independent phosphoglycerate mutase, domain B superfamily', 'PGAM_B_sf', 5, NULL),
(29509, NULL, 'IPR033599', NULL, 'RNA polymerase I transcription initiation factor TAF1B/Rrn7', 'TAF1B/Rrn7', 4, NULL),
(29510, NULL, 'IPR041048', NULL, 'RuvB-like, AAA-lid domain', 'RuvB-like_C', 3, NULL),
(29511, NULL, 'IPR037058', NULL, 'Flagellar hook protein FlgE superfamily', 'Falgellar_hook_FlgE_sf', 5, NULL),
(29512, NULL, 'IPR041285', NULL, 'MID domain of medPIWI', 'MID_MedPIWI', 3, NULL),
(29513, NULL, 'IPR038401', NULL, 'Rev1, C-terminal domain superfamily', 'Rev1_C_sf', 5, NULL),
(29514, NULL, 'IPR038618', NULL, 'CTXphi pIII, N1 domain superfamily', 'CTXphi_pIII_N1_sf', 5, NULL),
(29515, NULL, 'IPR038179', NULL, 'NigD-like, N-terminal domain superfamily', 'NigD-like_N_sf', 5, NULL),
(29516, NULL, 'IPR037944', NULL, 'Peroxiredoxin-5-like', 'PRX5-like', 4, NULL),
(29517, NULL, 'IPR033865', NULL, 'Machado-Joseph disease protein', 'Ataxin-3', 4, NULL),
(29518, NULL, 'IPR041599', NULL, 'Phage protein Gp138 N-terminal domain', 'Gp138_N', 3, NULL),
(29519, NULL, 'IPR037064', NULL, 'Formiminotransferase, N-terminal subdomain superfamily', 'Formiminotransferase_N_sf', 5, NULL),
(29520, NULL, 'IPR038390', NULL, 'Metal-sensitive repressor, helix protomer superfamily', 'Metal_Tscrpt_repr_sf', 5, NULL),
(29521, NULL, 'IPR035840', NULL, 'Chimaerin, SH2 domain', 'Chimaerin_SH2', 3, NULL),
(29522, NULL, 'IPR037085', NULL, 'Cdc42 binding domain-like superfamily', 'Cdc42-bd-like_dom_sf', 5, NULL),
(29523, NULL, 'IPR038403', NULL, 'Plasmodium falciparum UIS3, C-terminal domain superfamily', 'PfUIS3_sf', 5, NULL),
(29524, NULL, 'IPR041725', NULL, 'Type I (cytosolic) L-asparaginase', 'L-asparaginase_I', 4, NULL),
(29525, NULL, 'IPR041531', NULL, 'Baseplate upper protein, immunoglobulin like domain', 'BppU_IgG', 3, NULL),
(29526, NULL, 'IPR037233', NULL, 'CcmK-like superfamily', 'CcmK-like_sf', 5, NULL),
(29527, NULL, 'IPR041722', NULL, 'Alpha-keto acid binding periplasmic protein', 'TakP/all3028', 4, NULL),
(29528, NULL, 'IPR036063', NULL, 'Smr domain superfamily', 'Smr_dom_sf', 5, NULL),
(29529, NULL, 'IPR036578', NULL, 'SMAD MH1 domain superfamily', 'SMAD_MH1_sf', 5, NULL),
(29530, NULL, 'IPR038386', NULL, 'Beta-thymosin superfamily', 'Beta-thymosin_sf', 5, NULL),
(29531, NULL, 'IPR036653', NULL, 'CinA-like, C-terminal', 'CinA-like_C', 5, NULL),
(29532, NULL, 'IPR033338', NULL, 'Spc105/Spc7', 'Spc105/Spc7', 4, NULL),
(29533, NULL, 'IPR041045', NULL, 'Large polyvalent protein associated domain 25', 'LPD25', 3, NULL),
(29534, NULL, 'IPR041497', NULL, 'THUMP-like domain', 'Thump-like', 3, NULL),
(29535, NULL, 'IPR037069', NULL, 'Acyl-CoA dehydrogenase/oxidase, N-terminal domain superfamily', 'AcylCoA_DH/ox_N_sf', 5, NULL),
(29536, NULL, 'IPR039773', NULL, 'Molecular chaperone regulator BAG', 'BAG_chaperone_regulator', 4, NULL),
(29537, NULL, 'IPR037075', NULL, 'Formaldehyde-activating enzyme superfamily', 'HCHO-activating_enzyme_sf', 5, NULL),
(29538, NULL, 'IPR037835', NULL, 'SNX27, RA domain', 'SNX27_RA', 3, NULL),
(29539, NULL, 'IPR041543', NULL, 'Domain of unknown function DUF5644', 'DUF5644', 3, NULL),
(29540, NULL, 'IPR035930', NULL, 'FomD-like superfamily', 'FomD-like_sf', 5, NULL),
(29541, NULL, 'IPR041277', NULL, 'MBG domain, Lactobacillales', 'MBG_Lactobacillales', 3, NULL),
(29542, NULL, 'IPR038099', NULL, 'BldD-like, C-terminal domain superfamily', 'BldD-like_C_sf', 5, NULL),
(29543, NULL, 'IPR035963', NULL, 'FERM superfamily, second domain', 'FERM_2', 5, NULL),
(29544, NULL, 'IPR037148', NULL, '[NiFe]-hydrogenase, small subunit, C-terminal domain superfamily', 'NiFe-Hase_small_C_sf', 5, NULL),
(29545, NULL, 'IPR036696', NULL, 'YdfO-like superfamily', 'YdfO-like_sf', 5, NULL),
(29546, NULL, 'IPR036480', NULL, 'Carbamoyl-phosphate synthase small subunit, N-terminal domain superfamily', 'CarbP_synth_ssu_N_sf', 5, NULL),
(29547, NULL, 'IPR035332', NULL, 'Protein of unknown function DUF5386', 'DUF5386', 4, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(29548, NULL, 'IPR041559', NULL, 'DNA ligase, ATP-dependent, bacteriophage T7-type, C-terminal', 'DNA_ligase_ATP-dep_T7_C', 3, NULL),
(29549, NULL, 'IPR036470', NULL, 'Elicitin superfamily', 'Elicitin_sf', 5, NULL),
(29550, NULL, 'IPR038095', NULL, 'Costars domain superfamily', 'Costars_sf', 5, NULL),
(29551, NULL, 'IPR033375', NULL, 'CGG triplet repeat-binding protein 1', 'Cggbp1', 4, NULL),
(29552, NULL, 'IPR036643', NULL, 'DNA-directed RNA polymerase, insert domain superfamily', 'RNApol_insert_sf', 5, NULL),
(29553, NULL, 'IPR037808', NULL, 'Dedicator of cytokinesis C, C2 domain', 'C2_Dock-C', 3, NULL),
(29554, NULL, 'IPR036608', NULL, 'MTH777-like superfamily', 'MTH777-like_sf', 5, NULL),
(29555, NULL, 'IPR037169', NULL, 'Mitochondrial cytochrome c oxidase subunit VIc/VIIs superfamily', 'Cytochrome_c_oxidase_VIc_sf', 5, NULL),
(29556, NULL, 'IPR033661', NULL, 'Phosphatidylserine decarboxylase, eukaryotic type 1', 'PSD_type1_euk', 4, NULL),
(29557, NULL, 'IPR038934', NULL, 'Uncharacterized protein At5g64816-like', 'At5g64816-like', 4, NULL),
(29558, NULL, 'IPR038178', NULL, 'Kringle superfamily', 'Kringle_sf', 5, NULL),
(29559, NULL, 'IPR035932', NULL, 'HflD-like superfamily', 'HflD-like_sf', 5, NULL),
(29560, NULL, 'IPR038180', NULL, 'FlgT, N-terminal domain superfamily', 'FlgT_N_sf', 5, NULL),
(29561, NULL, 'IPR041532', NULL, 'RlmI, PUA-like domain', 'RlmI_PUA-like', 3, NULL),
(29562, NULL, 'IPR038172', NULL, 'Herpesvirus glycoprotein H, C-terminal domain superfamily', 'Herpes_glycoH_C_sf', 5, NULL),
(29563, NULL, 'IPR038191', NULL, 'YciN superfamily', 'YciN_sf', 5, NULL),
(29564, NULL, 'IPR041576', NULL, 'Virulence factor Evf', 'Evf', 3, NULL),
(29565, NULL, 'IPR038092', NULL, 'Phosphorylated adapter RNA export protein, RNA-binding domain superfamily', 'PHAX_RNA-binding_sf', 5, NULL),
(29566, NULL, 'IPR038164', NULL, 'Pab87 octamerisation domain superfamily', 'Pab87_oct_sf', 5, NULL),
(29567, NULL, 'IPR037065', NULL, 'Potassium channel, voltage dependent, Kv1.4, tandem inactivation domain superfamily', 'K_chnl_volt-dep_Kv1.4_TID_sf', 5, NULL),
(29568, NULL, 'IPR035967', NULL, 'SWAP/Surp superfamily', 'SWAP/Surp_sf', 5, NULL),
(29569, NULL, 'IPR041609', NULL, 'Phosphoribosylformylglycinamidine synthase, linker domain', 'PurL_linker', 3, NULL),
(29570, NULL, 'IPR041623', NULL, 'NOG1, N-terminal helical domain', 'NOG1_N', 3, NULL),
(29571, NULL, 'IPR033336', NULL, 'Stabilizer of axonemal microtubules 1/2', 'SAXO1/2', 4, NULL),
(29572, NULL, 'IPR041044', NULL, 'Nuclear polyadenylated RNA-binding 2 protein, CCCH zinc finger 1', 'Nab2p_Zf1', 3, NULL),
(29573, NULL, 'IPR036236', NULL, 'Zinc finger C2H2 superfamily', 'Znf_C2H2_sf', 5, NULL),
(29574, NULL, 'IPR041639', NULL, 'Large polyvalent protein-associated domain 39', 'LPD39', 3, NULL),
(29575, NULL, 'IPR038106', NULL, 'NFRKB winged helix-like domain superfamily', 'NFRKB_winged_sf', 5, NULL),
(29576, NULL, 'IPR038176', NULL, 'Fragilysin, N-terminal domain superfamily', 'Fragilysin_N_sf', 5, NULL),
(29577, NULL, 'IPR033680', NULL, 'Elongation of very long chain fatty acids protein 2', 'ELOVL2', 4, NULL),
(29578, NULL, 'IPR036674', NULL, 'p53-like tetramerisation domain superfamily', 'p53_tetramer_sf', 5, NULL),
(29579, NULL, 'IPR041465', NULL, 'SfsA, N-terminal OB domain', 'SfsA_N', 3, NULL),
(29580, NULL, 'IPR035692', NULL, 'Integrin-linked protein kinase, pseudokinase domain', 'PK_ILK', 3, NULL),
(29581, NULL, 'IPR037163', NULL, 'Spermidine synthase, tetramerisation domain superfamily', 'Spermidine_synt_N_sf', 5, NULL),
(29582, NULL, 'IPR037238', NULL, 'YbiA-like superfamily', 'YbiA-like_sf', 5, NULL),
(29583, NULL, 'IPR038397', NULL, 'TBCC, N-terminal domain superfamily', 'TBCC_N_sf', 5, NULL),
(29584, NULL, 'IPR033175', NULL, 'Phosphatidylserine decarboxylase, archaeal-type', 'PSD-A', 4, NULL),
(29585, NULL, 'IPR037145', NULL, 'Smad anchor for receptor activation, Smad-binding domain superfamily', 'SARA_Smad-bd_sf', 5, NULL),
(29586, NULL, 'IPR041312', NULL, 'CHIP, N-terminal tetratricopeptide repeat domain', 'CHIP_TPR_N', 3, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(29587, NULL, 'IPR041632', NULL, 'Arsenite oxidase subunit AioA/Iodate reductase subunit IdrA, 3Fe-4S cluster', 'AioA/IdrA_3Fe-4S', 3, NULL),
(29588, NULL, 'IPR033682', NULL, 'Palmitoyltransferase PFA4', 'PFA4', 4, NULL),
(29589, NULL, 'IPR038104', NULL, 'TRF2-interacting telomeric protein/Rap1, C-terminal domain superfamily', 'Rap1_C_sf', 5, NULL),
(29590, NULL, 'IPR041434', NULL, 'Domain of unknown function DUF5637', 'DUF5637', 3, NULL),
(29591, NULL, 'IPR036684', NULL, 'Calcium-mediated lectin superfamily', 'Ca_lectin_sf', 5, NULL),
(29592, NULL, 'IPR036226', NULL, 'Lipoxigenase, C-terminal domain superfamily', 'LipOase_C_sf', 5, NULL),
(29593, NULL, 'IPR038181', NULL, 'Novel toxin 21 superfamily', 'Ntox21_sf', 5, NULL),
(29594, NULL, 'IPR033355', NULL, 'Transmembrane protein 88', 'TMEM88', 4, NULL),
(29595, NULL, 'IPR041512', NULL, 'APOBEC3H', 'APOBEC3H', 4, NULL),
(29596, NULL, 'IPR033334', NULL, 'Protein LONGIFOLIA 1/2', 'LNG1/2', 4, NULL),
(29597, NULL, 'IPR037421', NULL, 'HTH-type transcriptional regulator ClcR, PBP2 domain', 'ClcR_PBP2', 3, NULL),
(29598, NULL, 'IPR038568', NULL, 'Hepatitis C virus NS5A, 1B domain superfamily', 'HCV_NS5A_1B_sf', 5, NULL),
(29599, NULL, 'IPR041470', NULL, 'Gamma tubulin complex component protein, N-terminal', 'GCP_N', 3, NULL),
(29600, NULL, 'IPR033668', NULL, 'Regulatory protein E2', 'Reg_prot_E2', 4, NULL),
(29601, NULL, 'IPR034583', NULL, 'Protein EMBRYONIC FLOWER 1', 'EMF1', 4, NULL),
(29602, NULL, 'IPR034665', NULL, 'Novel protein kinase C eta, catalytic domain', 'nPKC_eta', 3, NULL),
(29603, NULL, 'IPR037057', NULL, 'DNA mismatch repair MutH/Type II restriction endonuclease superfamily', 'DNA_rep_MutH/T2_RE_sf', 5, NULL),
(29604, NULL, 'IPR038580', NULL, 'Monellin, A chain superfamily', 'Monellin_A_sf', 5, NULL),
(29605, NULL, 'IPR041681', NULL, 'Pleckstrin homology domain 9', 'PH_9', 3, NULL),
(29606, NULL, 'IPR038237', NULL, 'Ribosomal protein S4e, central domain superfamily', 'Ribosomal_S4e_central_sf', 5, NULL),
(29607, NULL, 'IPR036465', NULL, 'von Willebrand factor A-like domain superfamily', 'vWFA_dom_sf', 5, NULL),
(29608, NULL, 'IPR041550', NULL, 'Fatty acid synthase type I, helical', 'FASI_helical', 3, NULL),
(29609, NULL, 'IPR037149', NULL, 'Protective antigen, heptamerisation domain superfamily', 'PA_heptamer_dom_sf', 5, NULL),
(29610, NULL, 'IPR037362', NULL, 'CAS family', 'CAS_fam', 4, NULL),
(29611, NULL, 'IPR041334', NULL, 'SAV2148-like HEPN domain', 'HEPN_SAV2148', 3, NULL),
(29612, NULL, 'IPR038097', NULL, 'Ribosomal protein L36e domain superfamily', 'L36e_sf', 5, NULL),
(29613, NULL, 'IPR041498', NULL, 'Bacterial Ig domain', 'Big_6', 3, NULL),
(29614, NULL, 'IPR037235', NULL, 'TRCF-like, C-terminal D7 domain', 'TRCF-like_C_D7', 5, NULL),
(29615, NULL, 'IPR036655', NULL, 'Monomethylamine methyltransferase MtmB superfamily', 'MtmB_sf', 5, NULL),
(29616, NULL, 'IPR037081', NULL, 'Hypothetical protein TM1506', 'Hyp_TM1506', 5, NULL),
(29617, NULL, 'IPR037363', NULL, 'Sec13/Seh1 family', 'Sec13/Seh1_fam', 4, NULL),
(29618, NULL, 'IPR037396', NULL, 'FMN hydroxy acid dehydrogenase domain', 'FMN_HAD', 3, NULL),
(29619, NULL, 'IPR041047', NULL, 'Large polyvalent protein-associated domain 1', 'LPD1', 3, NULL),
(29620, NULL, 'IPR035333', NULL, 'Protein of unknown function DUF5389', 'DUF5389', 4, NULL),
(29621, NULL, 'IPR041530', NULL, 'Oligosaccharyltransferase insert domain', 'OST_IS', 3, NULL),
(29622, NULL, 'IPR038576', NULL, 'Methyltransferase putative zinc binding domain superfamily', 'Methyltransf_Zn-bd_dom_put_sf', 5, NULL),
(29623, NULL, 'IPR037811', NULL, 'Dedicator of cytokinesis B, C2 domain', 'C2_Dock-B', 3, NULL),
(29624, NULL, 'IPR034750', NULL, 'CULT domain', 'CULT', 3, NULL),
(29625, NULL, 'IPR041621', NULL, 'Pyruvate dehydrogenase E1 component, middle domain', 'PDH_E1_M', 3, NULL),
(29626, NULL, 'IPR037066', NULL, 'TonB-dependent receptor, plug domain superfamily', 'Plug_dom_sf', 5, NULL),
(29627, NULL, 'IPR041337', NULL, 'Heterogeneous nuclear ribonucleoprotein Q acidic domain', 'hnRNP_Q_AcD', 3, NULL),
(29628, NULL, 'IPR041468', NULL, 'ParB/Spo0J, HTH domain', 'HTH_ParB/Spo0J', 3, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(29629, NULL, 'IPR041525', NULL, 'Nicotinate/nicotinamide phosphoribosyltransferase', 'N/Namide_PRibTrfase', 3, NULL),
(29630, NULL, 'IPR037156', NULL, 'Like-Sm ribonucleoprotein, C-terminal domain superfamily', 'Lsm_C_sf', 5, NULL),
(29631, NULL, 'IPR041273', NULL, 'N-acyltransferase, N-terminal domain', 'NAT_N', 3, NULL),
(29632, NULL, 'IPR041601', NULL, 'Fluorescence recovery protein', 'FRP', 4, NULL),
(29633, NULL, 'IPR037082', NULL, 'Bacteriophage T4, Gp59, helicase assembly protein, C-terminal domain superfamily', 'Phage_T4_Gp59_C_sf', 5, NULL),
(29634, NULL, 'IPR039774', NULL, 'Transcriptional regulatory protein Sin3-like', 'Sin3-like', 4, NULL),
(29635, NULL, 'IPR038380', NULL, 'Ribosomal protein S21 superfamily', 'S21_sf', 5, NULL),
(29636, NULL, 'IPR039295', NULL, 'Signaling mucin MSB2', 'MSB2', 4, NULL),
(29637, NULL, 'IPR041590', NULL, 'O-phosphoserine--tRNA(Cys) ligase, C-terminal domain', 'SepRS_C', 3, NULL),
(29638, NULL, 'IPR034581', NULL, 'Protein PLASTID TRANSCRIPTIONALLY ACTIVE 12', 'PTAC12', 4, NULL),
(29639, NULL, 'IPR033815', NULL, 'Ubiquitin specific peptidase 1', 'USP1', 3, NULL),
(29640, NULL, 'IPR036585', NULL, 'Attractin superfamily', 'Attractin_sf', 5, NULL),
(29641, NULL, 'IPR037157', NULL, 'UDP-N-acetylglucosamine O-acyltransferase, C-terminal domain superfamily', 'Acetyltransf_C_sf', 5, NULL),
(29642, NULL, 'IPR037168', NULL, 'Virulence factor YopE, GAP domain superfamily', 'YopE_GAP_dom_sf', 5, NULL),
(29643, NULL, 'IPR035337', NULL, 'Uncharacterized protein Ycf70-like', 'Ycf70-like', 4, NULL),
(29644, NULL, 'IPR038166', NULL, 'Polyprotein cleavage domain PL2pro superfamily, betacoronavirus', 'NSP3_PL2pro_sf_bCoV', 5, NULL),
(29645, NULL, 'IPR035968', NULL, 'ATP synthase, F1 complex, gamma subunit superfamily', 'ATP_synth_F1_ATPase_gsu', 5, NULL),
(29646, NULL, 'IPR041460', NULL, 'Molybdopterin oxidoreductase, N-terminal', 'Molybdopterin_N', 3, NULL),
(29647, NULL, 'IPR033679', NULL, 'Elongation of very long chain fatty acids protein 3', 'ELOVL3', 4, NULL),
(29648, NULL, 'IPR037420', NULL, 'HTH-type transcriptional activator AmpR, PBP2', 'AmpR_PBP2', 3, NULL),
(29649, NULL, 'IPR041316', NULL, 'ISP1 C-terminal', 'ISP1_C', 3, NULL),
(29650, NULL, 'IPR041712', NULL, 'Methanocaldococcus jannaschii dihydropteroate synthase-like, MBL-fold metallo hydrolase domain', 'DHPS-like_MBL-fold', 3, NULL),
(29651, NULL, 'IPR041637', NULL, 'Caprin-1 dimerization domain', 'Caprin-1_dimer', 3, NULL),
(29652, NULL, 'IPR035112', NULL, 'Viral unique long protein 21a', 'UL21a', 4, NULL),
(29653, NULL, 'IPR041336', NULL, 'DNA mitochondrial polymerase, exonuclease domain', 'DNApol_Exo', 3, NULL),
(29654, NULL, 'IPR041680', NULL, 'Pleckstrin homology domain 8', 'PH_8', 3, NULL),
(29655, NULL, 'IPR038194', NULL, 'DUF3861 domain superfamily', 'DUF3861_sf', 5, NULL),
(29656, NULL, 'IPR037086', NULL, 'D-Lysine 5,6-aminomutase alpha subunit superfamily', 'Lys-AminoMut_asu_sf', 5, NULL),
(29657, NULL, 'IPR035860', NULL, 'Tyrosine-protein kinase JAK2, SH2 domain', 'JAK2_SH2', 3, NULL),
(29658, NULL, 'IPR035964', NULL, 'I/LWEQ domain superfamily', 'I/LWEQ_dom_sf', 5, NULL),
(29659, NULL, 'IPR036258', NULL, 'Apyrase superfamily', 'Apyrase_sf', 5, NULL),
(29660, NULL, 'IPR038972', NULL, 'Inner membrane protein YiaA-like', 'YiaA-like', 4, NULL),
(29661, NULL, 'IPR038620', NULL, 'YdcP-like superfamily', 'YdcP-like_sf', 5, NULL),
(29662, NULL, 'IPR041538', NULL, 'ATPase RavA-like, AAA lid domain', 'RavA-like_AAA_lid', 3, NULL),
(29663, NULL, 'IPR041503', NULL, 'AIMP2, thioredoxin-like domain', 'AIMP2_thioredoxin', 3, NULL),
(29664, NULL, 'IPR038582', NULL, 'S27a-like superfamily', 'S27a-like_sf', 5, NULL),
(29665, NULL, 'IPR041574', NULL, 'Domain of unknown function DUF5608', 'DUF5608', 3, NULL),
(29666, NULL, 'IPR037151', NULL, 'Alpha-ketoglutarate-dependent dioxygenase AlkB-like superfamily', 'AlkB-like_sf', 5, NULL),
(29667, NULL, 'IPR037162', NULL, 'TRPM, tetramerisation domain superfamily', 'TRPM_tetra_sf', 5, NULL),
(29668, NULL, 'IPR036681', NULL, 'PgpA-like superfamily', 'PgpA-like_sf', 5, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(29669, NULL, 'IPR037239', NULL, 'Oxysterol-binding protein superfamily', 'OSBP_sf', 5, NULL),
(29670, NULL, 'IPR037413', NULL, 'Mucosal addressin cell adhesion molecule 1', 'MADCAM1', 4, NULL),
(29671, NULL, 'IPR041730', NULL, 'MJ0421-like THUMP domain', 'MJ0421-like_THUMP', 3, NULL),
(29672, NULL, 'IPR038114', NULL, 'GPAT, N-terminal domain superfamily', 'GPAT_N_sf', 5, NULL),
(29673, NULL, 'IPR036673', NULL, 'Cyanovirin-N superfamily', 'Cyanovirin-N_sf', 5, NULL),
(29674, NULL, 'IPR036698', NULL, 'TM1070-like superfamily', 'TM1070-like_sf', 5, NULL),
(29675, NULL, 'IPR041536', NULL, 'N-acetylglucosamine-1-phosphotransferase subunit alpha/beta, regulatory domain', 'GNPTAB_reg', 3, NULL),
(29676, NULL, 'IPR037365', NULL, 'Slowmo/Ups family', 'Slowmo/Ups', 4, NULL),
(29677, NULL, 'IPR041255', NULL, 'LpxI N-terminal domain', 'LpxI_N', 3, NULL),
(29678, NULL, 'IPR033276', NULL, 'E3 ubiquitin-protein ligase BIG BROTHER', 'BB', 4, NULL),
(29679, NULL, 'IPR041655', NULL, 'Domain of unknown function DUF5607', 'DUF5607', 3, NULL),
(29680, NULL, 'IPR041469', NULL, 'Subtilisin-like protease, fibronectin type-III domain', 'Subtilisin-like_FN3', 3, NULL),
(29681, NULL, 'IPR041728', NULL, 'GPAT/DHAPAT, acyltransferase domain', 'GPAT/DHAPAT_LPLAT', 3, NULL),
(29682, NULL, 'IPR036243', NULL, 'Photosystem I PsaX superfamily', 'PSI_PsaX_sf', 5, NULL),
(29683, NULL, 'IPR041251', NULL, 'SAGA-associated factor 73, zinc finger domain', 'Znf_C2H2_13', 3, NULL),
(29684, NULL, 'IPR038177', NULL, 'Inverse autotransporter, beta-domain superfamily', 'IAT_beta_sf', 5, NULL),
(29685, NULL, 'IPR036699', NULL, 'YehR-like superfamily', 'YehR-like_sf', 5, NULL),
(29686, NULL, 'IPR038192', NULL, 'Transcription termination and cleavage factor, C-terminal domain superfamily', 'CSTF_C_sf', 5, NULL),
(29687, NULL, 'IPR041517', NULL, 'Protease Do-like, PDZ domain', 'DEGP_PDZ', 3, NULL),
(29688, NULL, 'IPR038384', NULL, 'Formate dehydrogenase, C-terminal domain superfamily', 'Formate_DH_C_sf', 5, NULL),
(29689, NULL, 'IPR041304', NULL, 'AbiTii', 'AbiTii', 3, NULL),
(29690, NULL, 'IPR036678', NULL, 'MutS, connector domain superfamily', 'MutS_con_dom_sf', 5, NULL),
(29691, NULL, 'IPR036685', NULL, 'YehU-like superfamily', 'YehU-like_sf', 5, NULL),
(29692, NULL, 'IPR038199', NULL, 'DGK type I, N-terminal domain superfamily', 'DGK_typeI_N_sf', 5, NULL),
(29693, NULL, 'IPR037078', NULL, 'NEDD8-activating enzyme E1 catalytic subunit, C-terminal', 'NEDD8-ac_enz1_catalyticsu_C', 5, NULL),
(29694, NULL, 'IPR034088', NULL, 'Pla a 1-like', 'Pla_a_1-like', 4, NULL),
(29695, NULL, 'IPR033481', NULL, 'Cell fusion protein Dni1/Fig1', 'Dni1/Fig1', 4, NULL),
(29696, NULL, 'IPR041492', NULL, 'Haloacid dehalogenase-like hydrolase', 'HAD_2', 4, NULL),
(29697, NULL, 'IPR037289', NULL, 'Elongator complex protein 2', 'Elp2', 4, NULL),
(29698, NULL, 'IPR035691', NULL, 'RING finger protein 219, RING finger', 'RNF219_RING-HC', 3, NULL),
(29699, NULL, 'IPR038569', NULL, 'Bacteriophage T4, IpI C-terminal domain superfamily', 'Phage_T4_IpI_C_sf', 5, NULL),
(29700, NULL, 'IPR037167', NULL, 'D-Ala-D-Ala carboxypeptidase, C-terminal domain superfamily', 'Peptidase_S11_C_sf', 5, NULL),
(29701, NULL, 'IPR037939', NULL, 'Death domain-containing protein CRADD', 'CRADD', 4, NULL),
(29702, NULL, 'IPR038387', NULL, 'Bacteriochlorophyll c-binding superfamily', 'Bchl_C-bd_sf', 5, NULL),
(29703, NULL, 'IPR038956', NULL, 'Late embryogenesis abundant protein, LEA_5 subgroup', 'LEA_5', 4, NULL),
(29704, NULL, 'IPR041310', NULL, 'TNF receptor-associated factor 6, zinc finger 2', 'TRAF6_Z2', 3, NULL),
(29705, NULL, 'IPR033337', NULL, 'MT-associated protein TORTIFOLIA1/SPIRAL2-like', 'TORTIFOLIA1/SPIRAL2-like', 4, NULL),
(29706, NULL, 'IPR036651', NULL, 'Glutamine synthetase, N-terminal domain superfamily', 'Gln_synt_N_sf', 5, NULL),
(29707, NULL, 'IPR040363', NULL, 'Homeobox-containing protein 1', 'HMBOX1', 4, NULL),
(29708, NULL, 'IPR037809', NULL, 'Dedicator of cytokinesis D, C2 domain', 'C2_Dock-D', 3, NULL),
(29709, NULL, 'IPR036223', NULL, 'Adenylate cyclase-associated CAP, C-terminal  superfamily', 'CAP_C_sf', 5, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(29710, NULL, 'IPR035411', NULL, 'Putative DNA-Binding protein G5P', 'Putative_G5P', 4, NULL),
(29711, NULL, 'IPR036219', NULL, 'Translation elongation factor eEF-1beta-like superfamily', 'eEF-1beta-like_sf', 5, NULL),
(29712, NULL, 'IPR041386', NULL, 'XIAP-associated factor 1, C-terminal', 'XAF1_C', 3, NULL),
(29713, NULL, 'IPR037152', NULL, 'L-asparaginase, N-terminal domain superfamily', 'L-asparaginase_N_sf', 5, NULL),
(29714, NULL, 'IPR038617', NULL, 'Rhabdovirus matrix protein superfamily', 'Rhabdovirus_M_sf', 5, NULL),
(29715, NULL, 'IPR036656', NULL, 'Cytochrome b-c1 complex subunit 9 superfamily', 'QCR9_sf', 5, NULL),
(29716, NULL, 'IPR038116', NULL, 'TrpR-like superfamily', 'TrpR-like_sf', 5, NULL),
(29717, NULL, 'IPR038376', NULL, 'ATP synthase, alpha subunit, C-terminal domain superfamily', 'ATP_synth_asu_C_sf', 5, NULL),
(29718, NULL, 'IPR041626', NULL, 'Proteasomal ATPase, N-terminal OB domain', 'Prot_ATP_ID_OB_N', 3, NULL),
(29719, NULL, 'IPR037165', NULL, 'Aldehyde oxidase/xanthine dehydrogenase, molybdopterin binding domain superfamily', 'AldOxase/xan_DH_Mopterin-bd_sf', 5, NULL),
(29720, NULL, 'IPR033178', NULL, 'Phosphatidylserine decarboxylase, prokaryotic type 1', 'PSD_type1_pro', 4, NULL),
(29721, NULL, 'IPR037084', NULL, 'Protein-glutamine gamma-glutamyltransferase superfamily', 'Transglut_prok_sf', 5, NULL),
(29722, NULL, 'IPR037161', NULL, 'Semialdehyde dehydrogenase-like, C-terminal', 'Semialdehyde_DH-like_C', 5, NULL),
(29723, NULL, 'IPR041540', NULL, 'Vms1-associating treble clef domain', 'VATC', 3, NULL),
(29724, NULL, 'IPR037364', NULL, 'Protein transport protein Sec23', 'Sec23', 4, NULL),
(29725, NULL, 'IPR041338', NULL, 'OSBS, enolase-like N-terminal domain', 'OSBS_N', 3, NULL),
(29726, NULL, 'IPR037333', NULL, 'Ankyrin repeat and SOCS box protein 9/11, SOCS box domain', 'ASB9/11_SOCS', 3, NULL),
(29727, NULL, 'IPR041271', NULL, 'Alpha-glutamyl/putrescinyl thymine pyrophosphorylase clade 3', 'AGPT-Pplase3', 3, NULL),
(29728, NULL, 'IPR041651', NULL, 'Domain of unknown function DUF5610', 'DUF5610', 3, NULL),
(29729, NULL, 'IPR036214', NULL, 'Baseplate structural protein Gp11 superfamily', 'Gp11_sf', 5, NULL),
(29730, NULL, 'IPR039296', NULL, 'Predicted cytochrome c oxidase subunit VII', 'Predicted_CoxVII', 4, NULL),
(29731, NULL, 'IPR035841', NULL, 'Ras GTPase-activating protein 1, N-terminal SH2 domain', 'RasGAP_N_SH2', 3, NULL),
(29732, NULL, 'IPR035335', NULL, 'Protein of unknown function DUF5397', 'DUF5397', 4, NULL),
(29733, NULL, 'IPR033816', NULL, 'Eosinophil major basic protein, C-type lectin-like domain', 'EMBP_CTLD', 3, NULL),
(29734, NULL, 'IPR041719', NULL, 'Ferritin, prokaryotic-type', 'Ferritin_prok', 4, NULL),
(29735, NULL, 'IPR037063', NULL, 'Bacterial Pleckstrin homology domain superfamily', 'PHb_sf', 5, NULL),
(29736, NULL, 'IPR036241', NULL, 'NSFL1 cofactor p47, SEP domain superfamily', 'NSFL1C_SEP_dom_sf', 5, NULL),
(29737, NULL, 'IPR041309', NULL, 'TANK-binding kinase 1, coiled-coil domain 1', 'TBK1_CCD1', 3, NULL),
(29738, NULL, 'IPR041735', NULL, '4-hydroxyphenylpyruvate dioxygenase, C-terminal', '4OHPhenylPyrv_dOase_C', 3, NULL),
(29739, NULL, 'IPR041335', NULL, 'DNA mismatch repair protein HSM3, N-terminal domain', 'HSM3_N', 3, NULL),
(29740, NULL, 'IPR041596', NULL, 'RNA ligase Pab1020, C-terminal domain', 'Lig_Pab1020_C', 3, NULL),
(29741, NULL, 'IPR037424', NULL, 'Regulatory protein NocR, PBP2 domain', 'NocR_PBP2', 3, NULL),
(29742, NULL, 'IPR036262', NULL, 'Resistin-like superfamily', 'Resistin-like_sf', 5, NULL),
(29743, NULL, 'IPR041514', NULL, 'Proline utilization A, N-terminal', 'PutA_N', 3, NULL),
(29744, NULL, 'IPR041721', NULL, 'Lactate-binding periplasmic protein TTHA0766', 'TTHA0766', 4, NULL),
(29745, NULL, 'IPR037941', NULL, 'Selenoprotein P', 'SeP', 4, NULL),
(29746, NULL, 'IPR036230', NULL, '2-isopropylmalate synthase LeuA, allosteric (dimerisation) domain  superfamily', 'LeuA_allosteric_dom_sf', 5, NULL),
(29747, NULL, 'IPR037291', NULL, 'Domain of unknown function DUF4139', 'DUF4139', 3, NULL),
(29748, NULL, 'IPR041604', NULL, 'STAT, EF-hand fold domain', 'EF-hand_12', 3, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(29749, NULL, 'IPR037083', NULL, 'Type-2 restriction enzyme NgoMIV superfamily', 'NgoMIV_sf', 5, NULL),
(29750, NULL, 'IPR041332', NULL, 'Pan3 pseudokinase domain', 'Pan3_PK', 3, NULL),
(29751, NULL, 'IPR041527', NULL, 'YhcG, N-terminal', 'YhcG_N', 3, NULL),
(29752, NULL, 'IPR041435', NULL, 'Protein of unknown function DUF5552', 'DUF5552', 4, NULL),
(29753, NULL, 'IPR036483', NULL, 'PWI domain superfamily', 'PWI_dom_sf', 5, NULL),
(29754, NULL, 'IPR037334', NULL, 'Ankyrin repeat and SOCS box protein 13, SOCS box domain', 'ASB13_SOCS', 3, NULL),
(29755, NULL, 'IPR035444', NULL, 'Fibroblast growth factor 15/19/21', 'FGF15/19/21', 4, NULL),
(29756, NULL, 'IPR036237', NULL, 'Xylose isomerase-like superfamily', 'Xyl_isomerase-like_sf', 5, NULL),
(29757, NULL, 'IPR034500', NULL, 'RBM7, RNA recognition motif', 'RBM7_RRM', 3, NULL),
(29758, NULL, 'IPR039171', NULL, 'Pre-mRNA-splicing factor Cwc2/Slt11', 'Cwc2/Slt11', 4, NULL),
(29759, NULL, 'IPR038406', NULL, 'DUF3837 superfamily', 'DUF3837_sf', 5, NULL),
(29760, NULL, 'IPR036250', NULL, 'Acyl-CoA dehydrogenase-like, C-terminal', 'AcylCo_DH-like_C', 5, NULL),
(29761, NULL, 'IPR041279', NULL, 'Giardia dicer, N-terminal', 'Dicer_N', 3, NULL),
(29762, NULL, 'IPR041515', NULL, 'PPAF-2-like, Clip domain', 'PPAF-2-like_Clip', 3, NULL),
(29763, NULL, 'IPR036220', NULL, 'UDP-glucose/GDP-mannose dehydrogenase, C-terminal domain superfamily', 'UDP-Glc/GDP-Man_DH_C_sf', 5, NULL),
(29764, NULL, 'IPR035870', NULL, 'Tyrosine-protein kinase TXK, SH2 domain', 'Txk_SH2', 3, NULL),
(29765, NULL, 'IPR041438', NULL, 'Carbohydrate-binding module 64', 'CBM64', 3, NULL),
(29766, NULL, 'IPR037292', NULL, 'Hypothetical protein D-63', 'D-63', 5, NULL),
(29767, NULL, 'IPR033956', NULL, 'Translin', 'Translin', 4, NULL),
(29768, NULL, 'IPR036679', NULL, 'FlgN-like superfamily', 'FlgN-like_sf', 5, NULL),
(29769, NULL, 'IPR034891', NULL, 'Protein NLP, PB1 domain', 'PB1_NLP', 3, NULL),
(29770, NULL, 'IPR038405', NULL, 'Cytochrome oxidase Caa3-type, subunit IV superfamily', 'Caa3-IV_sf', 5, NULL),
(29771, NULL, 'IPR041516', NULL, 'LACTB2, winged helix domain', 'LACTB2_WH', 3, NULL),
(29772, NULL, 'IPR037211', NULL, 'Bacteriophage DNA replication protein Gp16.7 superfamily', 'Phage_DNA_replic_GP16.7_sf', 5, NULL),
(29773, NULL, 'IPR041473', NULL, 'CtsR, C-terminal dimerization domain', 'CtsR_C', 3, NULL),
(29774, NULL, 'IPR041464', NULL, 'TubC, N-terminal docking domain', 'TubC_N', 3, NULL),
(29775, NULL, 'IPR033335', NULL, 'Microtubule-associated protein Jupiter', 'JUPITER', 4, NULL),
(29776, NULL, 'IPR041608', NULL, 'Embryo surrounding factor 1, brassicaceae', 'ESF1_brassicaceae', 3, NULL),
(29777, NULL, 'IPR041678', NULL, 'Tetracyclin repressor-like, C-terminal domain 16', 'TetR_C_16', 3, NULL),
(29778, NULL, 'IPR041649', NULL, 'Anti-sigma factor NepR', 'NepR', 3, NULL),
(29779, NULL, 'IPR037055', NULL, 'MHC class I-like antigen recognition-like superfamily', 'MHC_I-like_Ag-recog_sf', 5, NULL),
(29780, NULL, 'IPR037423', NULL, 'HTH-type transcriptional regulator CysB, PBP2 domain', 'CysB_PBP2', 3, NULL),
(29781, NULL, 'IPR041723', NULL, 'CTP:phosphocholine cytidylyltransferase domain', 'CCT', 3, NULL),
(29782, NULL, 'IPR036234', NULL, 'Glucan-binding protein C/Surface antigen I/II, V-domain superfamily', 'SA_I/II_PAC_V_sf', 5, NULL),
(29783, NULL, 'IPR033177', NULL, 'Phosphatidylserine decarboxylase', 'PSD', 4, NULL),
(29784, NULL, 'IPR041439', NULL, 'Rv3651-like, middle domain', 'Rv3651-like_middle', 3, NULL),
(29785, NULL, 'IPR033699', NULL, 'Plk4, first cryptic polo-box domain', 'POLO_box_Plk4_1', 3, NULL),
(29786, NULL, 'IPR036254', NULL, 'Rab geranylgeranyltransferase, alpha subunit, insert-domain superfamily', 'RabGGT_asu_insert-dom_sf', 5, NULL),
(29787, NULL, 'IPR038175', NULL, 'CBM21 domain superfamily', 'CBM21_dom_sf', 5, NULL),
(29788, NULL, 'IPR041440', NULL, 'HypF, Kae1-like domain', 'HypF_C', 3, NULL),
(29789, NULL, 'IPR036580', NULL, 'Phosphatase 2C, C-terminal domain superfamily', 'PP2C_C_sf', 5, NULL),
(29790, NULL, 'IPR038090', NULL, 'DNA replication factor Cdt1, C-terminal WH domain superfamily', 'Cdt1_C_WH_dom_sf', 5, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(29791, NULL, 'IPR041305', NULL, 'Interleukin-4 inducing immunoglobulin-binding domain', 'IL4_i_Ig', 3, NULL),
(29792, NULL, 'IPR036256', NULL, 'Mu1/VP4 superfamily', 'Mu1/VP4_sf', 5, NULL),
(29793, NULL, 'IPR041458', NULL, 'Rv3651-like, N-terminal', 'Rv3651-like_N', 3, NULL),
(29794, NULL, 'IPR038096', NULL, 'TEA/ATTS domain superfamily', 'TEA/ATTS_sf', 5, NULL),
(29795, NULL, 'IPR038165', NULL, 'FlgT, C-terminal domain superfamily', 'FlgT_C_sf', 5, NULL),
(29796, NULL, 'IPR033017', NULL, 'Palladin, C-terminal immunoglobulin-like domain', 'Palladin_C', 3, NULL),
(29797, NULL, 'IPR041494', NULL, 'PIN-like domain', 'PIN7', 3, NULL),
(29798, NULL, 'IPR038210', NULL, 'Membrane insertase YidC, periplasmic domain', 'YidC_periplasmic', 3, NULL),
(29799, NULL, 'IPR035434', NULL, 'Glutamate--cysteine ligase, bacteria and plant', 'GCL_bact_plant', 4, NULL),
(29800, NULL, 'IPR038195', NULL, 'Apolipoprotein CIII superfamily', 'Apo_CIII_sf', 5, NULL),
(29801, NULL, 'IPR036216', NULL, 'Putative type 4B encapsulin shell protein superfamily', 'ENCP4_sf', 5, NULL),
(29802, NULL, 'IPR041405', NULL, 'Type III R-M EcoP15I, C-terminal', 'T3RM_EcoP15I_C', 3, NULL),
(29803, NULL, 'IPR041541', NULL, 'Glutaminase, EF-hand domain', 'Glutaminase_EF-hand', 3, NULL),
(29804, NULL, 'IPR036676', NULL, 'PurM-like, C-terminal domain superfamily', 'PurM-like_C_sf', 5, NULL),
(29805, NULL, 'IPR035336', NULL, 'Protein of unknown function DUF5398', 'DUF5398', 4, NULL),
(29806, NULL, 'IPR041587', NULL, 'Pesticidal crystal protein Cry, domain V', 'Cry_V', 3, NULL),
(29807, NULL, 'IPR037068', NULL, 'DNA primase, catalytic core, N-terminal domain superfamily', 'DNA_primase_core_N_sf', 5, NULL),
(29808, NULL, 'IPR035074', NULL, 'EspA/CesA-like', 'EspA/CesA-like', 5, NULL),
(29809, NULL, 'IPR034214', NULL, 'Ba3-like heme-copper oxidase subunit II, C-terminal', 'Ba3_CcO_II_C', 3, NULL),
(29810, NULL, 'IPR038193', NULL, 'Mistic superfamily', 'Mistic_sf', 5, NULL),
(29811, NULL, 'IPR036065', NULL, 'BolA-like superfamily', 'BolA-like_sf', 5, NULL),
(29812, NULL, 'IPR038936', NULL, 'Protein maintenance of PSII under high light 1', 'MPH1', 4, NULL),
(29813, NULL, 'IPR037838', NULL, 'JAK2, FERM domain C-lobe', 'JAK2_FERM_C-lobe', 3, NULL),
(29814, NULL, 'IPR041526', NULL, 'DAPG hydrolase, PhiG domain', 'DAPG_hydrolase', 3, NULL),
(29815, NULL, 'IPR038567', NULL, 'Transcription elongation factor 1 superfamily', 'T_Elf1_sf', 5, NULL),
(29816, NULL, 'IPR041046', NULL, 'JAK, FERM F2 lobe domain', 'FERM_F2', 3, NULL),
(29817, NULL, 'IPR036225', NULL, 'SRP/SRP receptor, N-terminal', 'SRP/SRP_N', 5, NULL),
(29818, NULL, 'IPR035966', NULL, 'Phosphofructokinase superfamily', 'PKF_sf', 5, NULL),
(29819, NULL, 'IPR041579', NULL, 'Pelovaterin', 'Pelovaterin', 3, NULL),
(29820, NULL, 'IPR037814', NULL, 'Cellobionic acid phosphorylase, N-terminal', 'GH94N_CBAP', 3, NULL),
(29821, NULL, 'IPR035334', NULL, 'Protein of unknown function DUF5390', 'DUF5390', 4, NULL),
(29822, NULL, 'IPR041502', NULL, 'SMODS/Ubiquitin system-associated 2TM effector domain', 'SUa-2TM', 3, NULL),
(29823, NULL, 'IPR036658', NULL, 'CPI-17 superfamily', 'CPI-17_sf', 5, NULL),
(29824, NULL, 'IPR037144', NULL, 'Peptidase M1, alanyl aminopeptidase, C-terminal domain superfamily', 'Peptidase_M1_pepN_C_sf', 5, NULL),
(29825, NULL, 'IPR037070', NULL, 'Formiminotransferase, C-terminal subdomain superfamily', 'Formiminotransferase_C_sf', 5, NULL),
(29826, NULL, 'IPR041653', NULL, 'Importin repeat 4', 'Importin_rep_4', 7, NULL),
(29827, NULL, 'IPR038198', NULL, 'MukF, C-terminal domain superfamily', 'MukF_C_sf', 5, NULL),
(29828, NULL, 'IPR038394', NULL, 'TA0956 superfamily', 'TA0956_sf', 5, NULL),
(29829, NULL, 'IPR037332', NULL, 'Ankyrin repeat and SOCS box protein 8, SOCS box domain', 'ASB8_SOCS', 3, NULL),
(29830, NULL, 'IPR039297', NULL, 'Cytochrome c oxidase subunit VII', 'COX7a', 4, NULL),
(29831, NULL, 'IPR041522', NULL, 'CdaR, GGDEF-like domain', 'CdaR_GGDEF', 3, NULL),
(29832, NULL, 'IPR037940', NULL, 'MALT1, death domain', 'MALT1_Death', 3, NULL),
(29833, NULL, 'IPR033587', NULL, 'Meiosis 1 arrest protein', 'M1AP', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(29834, NULL, 'IPR041269', NULL, 'Sulfhydryl oxidase, Trx-like domain', 'QSOX_Trx1', 3, NULL),
(29835, NULL, 'IPR037422', NULL, 'HTH-type transcriptional regulator BlaA, PBP2 domain', 'BlaA_PBP2', 3, NULL),
(29836, NULL, 'IPR037150', NULL, 'Histone-like protein H-NS, C-terminal domain superfamily', 'H-NS_C_dom_sf', 5, NULL),
(29837, NULL, 'IPR036260', NULL, 'P40 nucleoprotein superfamily, Borna disease virus', 'P40_nucleoprot_sf_BD-vir', 5, NULL),
(29838, NULL, 'IPR038174', NULL, 'Streptococcal pilin isopeptide linker superfamily', 'Strep_pil_link_sf', 5, NULL),
(29839, NULL, 'IPR037295', NULL, 'Alpha-lytic protease prodomain', 'Alpha-lytic_protease_prodomain', 5, NULL),
(29840, NULL, 'IPR038016', NULL, 'ASAP1, SH3 domain', 'ASAP1_SH3', 3, NULL),
(29841, NULL, 'IPR033615', NULL, 'Protein EOLA1/EOLA2', 'EOLA1/EOLA2', 4, NULL),
(29842, NULL, 'IPR041720', NULL, 'Aldolase FbaB-like, archaeal-type', 'FbaB-like', 4, NULL),
(29843, NULL, 'IPR041729', NULL, 'Formyltetrahydrofolate deformylase, C-terminal hydrolase domain', 'Formyl-FH4-Hydrolase_C', 3, NULL),
(29844, NULL, 'IPR041585', NULL, 'LepB GAP domain, N-terminal subdomain', 'LepB_GAP_N', 3, NULL),
(29845, NULL, 'IPR036215', NULL, 'TM0957-like superfamily', 'TM0957-like_sf', 5, NULL),
(29846, NULL, 'IPR041250', NULL, 'ParA helix turn helix domain', 'HTH_54', 3, NULL),
(29847, NULL, 'IPR038584', NULL, 'Ribosomal protein L33 superfamily', 'L33_sf', 5, NULL),
(29848, NULL, 'IPR034584', NULL, 'Testis, prostate and placenta-expressed protein', 'TEPP', 4, NULL),
(29849, NULL, 'IPR041471', NULL, 'UvrB, interaction domain', 'UvrB_inter', 3, NULL),
(29850, NULL, 'IPR041542', NULL, 'Beta-xylosidase, C-terminal Concanavalin A-like domain', 'GH43_C2', 3, NULL),
(29851, NULL, 'IPR041643', NULL, 'ZIC protein, zinc finger domain', 'Znf_ZIC', 3, NULL),
(29852, NULL, 'IPR041606', NULL, 'Hydrogen maturase F dimerization domain', 'HydF_dimer', 3, NULL),
(29853, NULL, 'IPR041625', NULL, 'Beta-mannosidase, Ig-fold domain', 'Beta-mannosidase_Ig', 3, NULL),
(29854, NULL, 'IPR038619', NULL, 'MraZ superfamily', 'MraZ_sf', 5, NULL),
(29855, NULL, 'IPR041733', NULL, 'PAE1087-like, metallophosphatase domain', 'PAE1087_MPP', 3, NULL),
(29856, NULL, 'IPR041519', NULL, 'RiboL-PSP-HEPN', 'HEPN_RiboL-PSP', 3, NULL),
(29857, NULL, 'IPR041472', NULL, 'BL00235/CARNS1, N-terminal', 'BL00235/CARNS1_N', 3, NULL),
(29858, NULL, 'IPR036068', NULL, 'Nicotinate phosphoribosyltransferase-like, C-terminal', 'Nicotinate_pribotase-like_C', 5, NULL),
(29859, NULL, 'IPR036701', NULL, 'RraB-like superfamily', 'RraB-like_sf', 5, NULL),
(29860, NULL, 'IPR041467', NULL, 'HTH-type transcriptional repressor Sco4008, C-terminal', 'Sco4008_C', 3, NULL),
(29861, NULL, 'IPR041588', NULL, 'Integrase zinc-binding domain', 'Integrase_H2C2', 3, NULL),
(29862, NULL, 'IPR037296', NULL, 'Staphostatin A/B', 'Staphostatin_A/B', 5, NULL),
(29863, NULL, 'IPR033671', NULL, 'tRNA (guanosine(18)-2''-O)-methyltransferase', 'TrmH', 4, NULL),
(29864, NULL, 'IPR035500', NULL, 'Nuclear hormone receptor-like domain superfamily', 'NHR-like_dom_sf', 5, NULL),
(29865, NULL, 'IPR036261', NULL, 'Ectatomin superfamily', 'Ectatomin_sf', 5, NULL),
(29866, NULL, 'IPR038377', NULL, 'Sodium/glucose symporter superfamily', 'Na/Glc_symporter_sf', 5, NULL),
(29867, NULL, 'IPR036477', NULL, 'Formyl transferase, N-terminal domain superfamily', 'Formyl_transf_N_sf', 5, NULL),
(29868, NULL, 'IPR037158', NULL, 'Threonine synthase, N-terminal domain superfamily', 'Thr_synth_N_sf', 5, NULL),
(29869, NULL, 'IPR041049', NULL, 'Domain of unknown function DUF5615', 'DUF5615', 3, NULL),
(29870, NULL, 'IPR037077', NULL, 'Nuclear receptor coactivator, Ncoa-type, interlocking domain superfamily', 'Nuc_rcpt_coact_Ncoa_int_sf', 5, NULL),
(29871, NULL, 'IPR041658', NULL, 'Dynein heavy chain AAA lid domain', 'AAA_lid_11', 3, NULL),
(29872, NULL, 'IPR033681', NULL, 'Elongation of very long chain fatty acids protein 1', 'ELOVL1', 4, NULL),
(29873, NULL, 'IPR035933', NULL, 'Hypothetical protein MTH1880', 'MTH1880', 5, NULL),
(29874, NULL, 'IPR041246', NULL, 'Bacterial alpha-2-macroglobulin MG10 domain', 'Bact_MG10', 3, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(29875, NULL, 'IPR038171', NULL, 'Peptidase M64, N-terminal domain superfamily', 'M64_N_sf', 5, NULL),
(29876, NULL, 'IPR041462', NULL, 'Bacterial Alpha-2-macroglobulin, MG6 domain', 'Bact_A2M_MG6', 3, NULL),
(29877, NULL, 'IPR033684', NULL, 'Protein-lysine N-methyltransferase EFM6', 'EFM6', 4, NULL),
(29878, NULL, 'IPR037188', NULL, 'Ribosome maturation protein Sdo1/SBDS, central domain superfamily', 'Sdo1/SBDS_central_sf', 5, NULL),
(29879, NULL, 'IPR041457', NULL, 'CxC2-like cysteine cluster, KDZ transposase-associated', 'CxC2_KDZ-assoc', 3, NULL),
(29880, NULL, 'IPR037074', NULL, 'Protein of unknown function DUF1780, putative endonuclease superfamily', 'DUF1780_sf', 5, NULL),
(29881, NULL, 'IPR036222', NULL, 'Adenylate cyclase-associated CAP, N-terminal  domain superfamily', 'CAP_N_sf', 5, NULL),
(29882, NULL, 'IPR041533', NULL, 'Bartonella effector protein, BID domain', 'Bep_BID', 3, NULL),
(29883, NULL, 'IPR035680', NULL, 'Hydroxyacylglutathione hydrolase, MBL domain', 'Clx_II_MBL', 3, NULL),
(29884, NULL, 'IPR037080', NULL, 'Capsid protein VP4 superfamily, Picornavirus', 'Capsid_VP4_sf_Picornavirus', 5, NULL),
(29885, NULL, 'IPR041628', NULL, 'ChlI/MoxR, AAA lid domain', 'ChlI/MoxR_AAA_lid', 3, NULL),
(29886, NULL, 'IPR037059', NULL, 'Rel homology domain (RHD), DNA-binding domain superfamily', 'RHD_DNA_bind_dom_sf', 5, NULL),
(29887, NULL, 'IPR040369', NULL, 'LisH domain-containing protein ARMC9', 'ARMC9', 4, NULL),
(29888, NULL, 'IPR036582', NULL, 'Copper amine oxidase-like, N-terminal domain superfamily', 'Mao_N_sf', 5, NULL),
(29889, NULL, 'IPR033678', NULL, 'Elongation of very long chain fatty acids protein 4', 'ELOVL4', 4, NULL),
(29890, NULL, 'IPR036463', NULL, 'Urease, gamma subunit superfamily', 'Urease_gamma_sf', 5, NULL),
(29891, NULL, 'IPR037836', NULL, 'SNX17, atypical FERM-like domain', 'SNX17_FERM-like_dom', 3, NULL),
(29892, NULL, 'IPR036613', NULL, 'MHC class II-associated invariant chain, trimerisation domain superfamily', 'MHCII_invariant_trimer_sf', 5, NULL),
(29893, NULL, 'IPR037071', NULL, 'Amyloidogenic glycoprotein, amyloid-beta peptide superfamily', 'Amyloid_glyco_Abeta_sf', 5, NULL),
(29894, NULL, 'IPR037294', NULL, 'ABC transporter, BtuC-like', 'ABC_BtuC-like', 5, NULL),
(29895, NULL, 'IPR038207', NULL, 'DIX domain superfamily', 'DIX_dom_sf', 5, NULL),
(29896, NULL, 'IPR035338', NULL, 'Protein KleA/KleC', 'KleA/KleC', 4, NULL),
(29897, NULL, 'IPR036583', NULL, '23S rRNA-intervening sequence superfamily', '23S_rRNA_IVS_sf', 5, NULL),
(29898, NULL, 'IPR038109', NULL, 'DNA-binding recombinase domain superfamily', 'DNA_bind_recomb_sf', 5, NULL),
(29899, NULL, 'IPR036022', NULL, 'Plant myosin class VIII, motor domain', 'MYSc_Myo8', 3, NULL),
(29900, NULL, 'IPR041307', NULL, 'Polysaccharide biosynthesis enzyme WcbI', 'WcbI', 3, NULL),
(29901, NULL, 'IPR041287', NULL, 'Protein of unknown function DUF5548', 'DUF5548', 4, NULL),
(29902, NULL, 'IPR041481', NULL, 'COP9 signalosome complex subunit 7, helix I', 'CSN7_helixI', 3, NULL),
(29903, NULL, 'IPR037234', NULL, 'ImmE5 superfamily', 'ImmE5_sf', 5, NULL),
(29904, NULL, 'IPR038209', NULL, 'CKK domain superfamily', 'CKK_dom_sf', 5, NULL),
(29905, NULL, 'IPR041487', NULL, 'HEPN/Toprim N-terminal domain 1', 'HEPN/Toprim-NTD1', 3, NULL),
(29906, NULL, 'IPR041732', NULL, 'Peptide chain release factor 3, GTP-binding domain', 'RF3_GTP-bd', 3, NULL),
(29907, NULL, 'IPR037061', NULL, 'Lytic transglycosylase, superhelical linker domain superfamily', 'Lytic_TGlycoase_superhlx_L_sf', 5, NULL),
(29908, NULL, 'IPR035442', NULL, 'Ferredoxin--NADP reductase, plant and Cyanobacteria type', 'FNR_plant_Cyanobacteria', 4, NULL),
(29909, NULL, 'IPR041726', NULL, 'Acyl-CoA dehydrogenase family member 10/11, N-terminal', 'ACAD10_11_N', 3, NULL),
(29910, NULL, 'IPR035842', NULL, 'Ras GTPase-activating protein 1, C-terminal SH2 domain', 'RasGAP_C_SH2', 3, NULL),
(29911, NULL, 'IPR041247', NULL, 'Rad52 family', 'Rad52_fam', 4, NULL),
(29912, NULL, 'IPR041339', NULL, 'Cell-surface Ig-like, bacterial', 'Ig-like_bac', 3, NULL),
(29913, NULL, 'IPR033677', NULL, 'Elongation of very long chain fatty acids protein 5', 'ELOVL5', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(29914, NULL, 'IPR036692', NULL, 'Shew3726-like superfamily', 'Shew3726-like_sf', 5, NULL),
(29915, NULL, 'IPR041433', NULL, '26S proteasome non-ATPase regulatory subunit RPN1, C-terminal', 'RPN1_C', 3, NULL),
(29916, NULL, 'IPR041551', NULL, 'BsaWI restriction endonuclease type 2', 'RE_BsaWI', 3, NULL),
(29917, NULL, 'IPR036217', NULL, 'Methylated DNA-protein cysteine methyltransferase, DNA binding domain', 'MethylDNA_cys_MeTrfase_DNAb', 5, NULL),
(29918, NULL, 'IPR037160', NULL, 'DNA polymerase, thumb domain superfamily', 'DNA_Pol_thumb_sf', 5, NULL),
(29919, NULL, 'IPR041272', NULL, 'N-acetyl-beta-D-glucosaminidase, N-terminal', 'GcnA_N', 3, NULL),
(29920, NULL, 'IPR038265', NULL, 'PA2222-like domain superfamily', 'PA2222-like_sf', 5, NULL),
(29921, NULL, 'IPR036023', NULL, 'Class IX myosin, motor domain', 'MYSc_Myo9', 3, NULL),
(29922, NULL, 'IPR037153', NULL, 'Pyrimidine/purine nucleotide 5''-monophosphate nucleosidase PpnN-like superfamily', 'PpnN-like_sf', 5, NULL),
(29923, NULL, 'IPR038572', NULL, 'Stomagen, C-terminal domain superfamily', 'Stomagen_C_sf', 5, NULL),
(29924, NULL, 'IPR041407', NULL, 'MazG, C-terminal', 'MazG_C', 3, NULL),
(29925, NULL, 'IPR036467', NULL, 'Lumazine/riboflavin synthase superfamily', 'LS/RS_sf', 5, NULL),
(29926, NULL, 'IPR038120', NULL, 'RNA polymerase Rpb1, funnel domain superfamily', 'Rpb1_funnel_sf', 5, NULL),
(29927, NULL, 'IPR037752', NULL, 'Extended synaptotagmin, C-terminal C2 domain', 'C2C_KIAA1228', 3, NULL),
(29928, NULL, 'IPR034502', NULL, 'Raly, RNA recognition motif', 'RALY_RRM', 3, NULL),
(29929, NULL, 'IPR041459', NULL, 'Polyvalent protein, metallopeptidase domain', 'MPTase-PolyVal', 3, NULL),
(29930, NULL, 'IPR041257', NULL, 'Adenomatous polyposis coli (APC) repeat', 'APC_rep', 7, NULL),
(29931, NULL, 'IPR041437', NULL, 'Gylcosyl hydrolase 115 C-terminal domain', 'GH115_C', 3, NULL),
(29932, NULL, 'IPR037062', NULL, 'Malic enzyme, N-terminal domain superfamily', 'Malic_N_dom_sf', 5, NULL),
(29933, NULL, 'IPR036671', NULL, 'DPH-type metal-binding domain superfamily', 'DPH_MB_sf', 5, NULL),
(29934, NULL, 'IPR041605', NULL, '3''-5'' exonuclease C-terminal domain', 'Exo_C', 3, NULL),
(29935, NULL, 'IPR041474', NULL, 'HTH-type transcriptional repressor NicS, C-terminal', 'NicS_C', 3, NULL),
(29936, NULL, 'IPR036666', NULL, 'HHA superfamily', 'HHA_sf', 5, NULL),
(29937, NULL, 'IPR038163', NULL, 'Drosophila transcription factor p53, C-terminal domain superfamily', 'Dro_p53_C_sf', 5, NULL),
(29938, NULL, 'IPR038173', NULL, 'Transcription factor COE, DNA-binding domain superfamily', 'COE_DBD_sf', 5, NULL),
(29939, NULL, 'IPR033179', NULL, 'Phosphatidylserine decarboxylase, prokaryotic type 2', 'PSD_type2_pro', 4, NULL),
(29940, NULL, 'IPR040364', NULL, 'Tetratricopeptide repeat protein 21A/21B', 'TTC21A/TTC21B', 4, NULL),
(29941, NULL, 'IPR037067', NULL, 'Coatomer, gamma subunit, appendage domain superfamily', 'Coatomer_gsu_app_sf', 5, NULL),
(29942, NULL, 'IPR036668', NULL, 'Insect antifreeze protein superfamily', 'Antifreeze_sf', 5, NULL),
(29943, NULL, 'IPR037331', NULL, 'Ankyrin repeat and SOCS box protein 1, SOCS box domain', 'ASB1_SOCS', 3, NULL),
(29944, NULL, 'IPR041597', NULL, 'L,D-transpeptidase C-terminal domain', 'Ldt_C', 3, NULL),
(29945, NULL, 'IPR034089', NULL, 'SPOP, C-terminal BACK domain', 'SPOP_C', 3, NULL),
(29946, NULL, 'IPR037418', NULL, 'HTH-type transcriptional regulator TrpI, PBP2', 'TrpI_PBP2', 3, NULL),
(29947, NULL, 'IPR037154', NULL, 'YtpR-like superfamily', 'YtpR-like_sf', 5, NULL),
(29948, NULL, 'IPR035931', NULL, 'YlxR-like superfamily', 'YlxR-like_sf', 5, NULL),
(29949, NULL, 'IPR041311', NULL, 'Large polyvalent protein associated domain 29', 'LPD29', 3, NULL),
(29950, NULL, 'IPR038064', NULL, 'Influenza A virus NS1, effector domain-like superfamily', 'NS1A_effect_dom-like_sf', 5, NULL),
(29951, NULL, 'IPR041406', NULL, 'COP9 signalosome complex subunit 4, helix turn helix domain', 'CSN4_HTH', 3, NULL),
(29952, NULL, 'IPR038621', NULL, 'Lactococcus phage SSB superfamily', 'Lacto_phage_SSB_sf', 5, NULL),
(29953, NULL, 'IPR038100', NULL, 'NVL2, N-terminal domain superfamily', 'NLV2_N_sf', 5, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(29954, NULL, 'IPR041275', NULL, 'ESX-1 secretion-associated protein EspB, PE domain', 'EspB_PE', 3, NULL),
(29955, NULL, 'IPR033675', NULL, 'Elongation of very long chain fatty acids protein 6', 'ELOVL6', 4, NULL),
(29956, NULL, 'IPR037820', NULL, 'NdvB, GH94N domain 1', 'GH94N_NdvB', 3, NULL),
(29957, NULL, 'IPR036244', NULL, 'TipA-like multidrug resistance regulator, antibiotic-recognition domain', 'TipA-like_antibiotic-bd', 5, NULL),
(29958, NULL, 'IPR037056', NULL, 'Ribonuclease H1, N-terminal domain superfamily', 'RNase_H1_N_sf', 5, NULL),
(29959, NULL, 'IPR038935', NULL, 'Uncharacterized protein C5orf52', 'C5orf52', 4, NULL),
(29960, NULL, 'IPR037073', NULL, 'Nuclear receptor coactivator, CREB-bp-like, interlocking domain superfamily', 'Nuc_rcpt_coact_CREBbp_sf', 5, NULL),
(29961, NULL, 'IPR037079', NULL, 'AF2212/PG0164-like superfamily', 'AF2212/PG0164-like_sf', 5, NULL),
(29962, NULL, 'IPR038234', NULL, 'Colicin E5 ribonuclease domain superfamily', 'Colicin_E5_C_sf', 5, NULL),
(29963, NULL, 'IPR041644', NULL, 'GNAT-like C-terminal domain', 'GNAT_C', 3, NULL),
(29964, NULL, 'IPR037159', NULL, 'DNA-directed RNA polymerase, N-terminal domain superfamily', 'RNA_POL_N_sf', 5, NULL),
(29965, NULL, 'IPR037164', NULL, 'Satellite virus coat domain superfamily', 'Satellite_virus_coat_sf', 5, NULL),
(29966, NULL, 'IPR037914', NULL, 'SpoVT-AbrB domain superfamily', 'SpoVT-AbrB_sf', 5, NULL),
(29967, NULL, 'IPR041331', NULL, 'Bacterial alpha amylase, C-terminal domain', 'Bac_A_amyl_C', 3, NULL),
(29968, NULL, 'IPR041499', NULL, 'Transcription factor IIIC subunit Tfc1/Sfc1, triple barrel domain', 'Tfc1/Sfc1_N', 3, NULL),
(29969, NULL, 'IPR036062', NULL, 'Photosystem I PsaJ, reaction centre subunit IX superfamily', 'PSI_PsaJ_sf', 5, NULL),
(29970, NULL, 'IPR035812', NULL, 'Methylenetetrahydrofolate dehydrogenase, NAD-binding domain', 'm-THF_DH_NAD-bd', 3, NULL),
(29971, NULL, 'IPR035965', NULL, 'PAS domain superfamily', 'PAS-like_dom_sf', 5, NULL),
(29972, NULL, 'IPR034090', NULL, 'BPM, C-terminal', 'BPM_C', 3, NULL),
(29973, NULL, 'IPR034501', NULL, 'RBM11, RNA recognition motif', 'RBM11_RRM', 3, NULL),
(29974, NULL, 'IPR036694', NULL, 'Dodecin-like superfamily', 'Dodecin-like_sf', 5, NULL),
(29975, NULL, 'IPR041645', NULL, 'ADAMTS, cysteine-rich domain 2', 'ADAMTS_CR_2', 3, NULL),
(29976, NULL, 'IPR038098', NULL, 'PHD finger protein 12, MRG binding domain superfamily', 'PHF12_MRG-bd_sf', 5, NULL),
(29977, NULL, 'IPR037839', NULL, 'PLEKHN1, PH domain', 'PLEKHN1_PH', 3, NULL),
(29978, NULL, 'IPR038565', NULL, 'Proteinase, regulatory CLIP domain superfamily', 'CLIP_sf', 5, NULL),
(29979, NULL, 'IPR041701', NULL, 'Methionine import ATP-binding protein MetN, ATP-binding domain', 'MetN_ABC', 3, NULL),
(29980, NULL, 'IPR035435', NULL, 'Diphthamide synthesis DHP1/DPH2, eukaryotes and archaea', 'DPH1/DPH2_euk_archaea', 4, NULL),
(29981, NULL, 'IPR033889', NULL, 'Type I lantibiotic biosynthesis cyclase', 'LanC', 4, NULL),
(29982, NULL, 'IPR036048', NULL, 'Chemokine interleukin-8-like superfamily', 'Interleukin_8-like_sf', 5, NULL),
(29983, NULL, 'IPR041489', NULL, 'PDZ domain 6', 'PDZ_6', 3, NULL),
(29984, NULL, 'IPR041580', NULL, 'Telomerase reverse transcriptase, thumb DNA-binding domain', 'TERT_thumb', 3, NULL),
(29985, NULL, 'IPR041466', NULL, 'Dynein heavy chain, AAA 5 extension domain', 'Dynein_AAA5_ext', 3, NULL),
(29986, NULL, 'IPR038190', NULL, 'Set2 Rpb1 interacting domain superfamily', 'SRI_sf', 5, NULL),
(29987, NULL, 'IPR035415', NULL, 'Protein of unknown function DUF5382', 'DUF5382', 4, NULL),
(29988, NULL, 'IPR041425', NULL, 'Complement C3/4/5, macroglobulin domain MG1', 'C3/4/5_MG1', 3, NULL),
(29989, NULL, 'IPR038378', NULL, 'Haemophore, haem-binding domain superfamily', 'MHB_sf', 5, NULL),
(29990, NULL, 'IPR037147', NULL, 'Ribosomal protein L28/L24 superfamily', 'Ribo_L28/L24_sf', 5, NULL),
(29991, NULL, 'IPR036252', NULL, 'Proteasome activator superfamily', 'Proteasome_activ_sf', 5, NULL),
(29992, NULL, 'IPR041659', NULL, 'Aquifex aeolicus argonaute, PAZ domain', 'Paz_1', 3, NULL),
(29993, NULL, 'IPR041518', NULL, 'Bacterial Glycosyl hydrolase family 3, C-terminal', 'Bac_GH3_C', 3, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(29994, NULL, 'IPR037146', NULL, 'Colicin/pyocin, DNase domain superfamily', 'Colicin/pyocin_DNase_dom_sf', 5, NULL),
(29995, NULL, 'IPR041529', NULL, 'Nicotinamide phosphoribosyltransferase, N-terminal domain', 'DUF5598', 3, NULL),
(29996, NULL, 'IPR040366', NULL, 'Nuclear polyadenylated RNA-binding protein Nab2/ZC3H14', 'Nab2/ZC3H14', 4, NULL),
(29997, NULL, 'IPR038379', NULL, 'SecE superfamily', 'SecE_sf', 5, NULL),
(29998, NULL, 'IPR036485', NULL, 'Glutamate synthase, alpha subunit, C-terminal domain superfamily', 'Glu_synth_asu_C_sf', 5, NULL),
(29999, NULL, 'IPR041399', NULL, 'Large catalase, C-terminal domain', 'Catalase_large_C', 3, NULL),
(30000, NULL, 'IPR041524', NULL, 'Glycoside hydrolase 131, catalytic N-terminal', 'GH131_N', 3, NULL),
(30001, NULL, 'IPR041879', NULL, 'YvgL-like, substrate binding domain', 'YvgL-like_PBP2', 3, NULL),
(30002, NULL, 'IPR042021', NULL, 'Glycerol kinase-like, proteobacteria', 'GK-like_proteobact', 4, NULL),
(30003, NULL, 'IPR033269', NULL, 'Signaling threshold-regulating transmembrane adapter 1', 'Sit1', 4, NULL),
(30004, NULL, 'IPR041916', NULL, 'Anti-sigma factor, zinc-finger domain superfamily', 'Anti_sigma_zinc_sf', 5, NULL),
(30005, NULL, 'IPR041716', NULL, 'Uncharacterized cupredoxin-like protein, Cyanobacteria-type', 'Cupredoxin-like_Cyanobacteria', 3, NULL),
(30006, NULL, 'IPR041897', NULL, 'Integrator complex subunit 11, MBL-fold', 'INTS11-like_MBL-fold', 3, NULL),
(30007, NULL, 'IPR042041', NULL, 'Protein transport protein Tip20, domain A', 'Tip20p_domA', 5, NULL),
(30008, NULL, 'IPR036163', NULL, 'Heavy metal-associated domain superfamily', 'HMA_dom_sf', 5, NULL),
(30009, NULL, 'IPR036615', NULL, 'Mur ligase, C-terminal domain superfamily', 'Mur_ligase_C_dom_sf', 5, NULL),
(30010, NULL, 'IPR041744', NULL, 'Bifunctional delta 1-pyrroline-5-carboxylate synthetase, glutamate-5-kinase domain', 'G5K_ProBA', 3, NULL),
(30011, NULL, 'IPR041769', NULL, 'Frizzled 3, cysteine-rich domain', 'FZ3_CRD', 3, NULL),
(30012, NULL, 'IPR040389', NULL, 'Cyclin-dependent protein kinase inhibitor SMR', 'SMR', 4, NULL),
(30013, NULL, 'IPR041631', NULL, 'Alpha-dystroglycan N-terminal domain 2', 'Alpha_DG1_N2', 3, NULL),
(30014, NULL, 'IPR041893', NULL, 'Antirestriction protein ArdA, domain 3', 'ArdA_dom3', 5, NULL),
(30015, NULL, 'IPR038107', NULL, '3-deoxy-D-manno-octulosonic-acid transferase, N-terminal domain superfamily', 'Glycos_transf_N_sf', 5, NULL),
(30016, NULL, 'IPR042047', NULL, 'Cell wall hydrolase SleB, domain 1', 'SleB_dom1', 5, NULL),
(30017, NULL, 'IPR041895', NULL, 'Antirestriction protein ArdA, domain 1', 'ArdA_dom1', 5, NULL),
(30018, NULL, 'IPR036167', NULL, 'tRNA intron endonuclease, catalytic domain-like superfamily', 'tRNA_intron_Endo_cat-like_sf', 5, NULL),
(30019, NULL, 'IPR037788', NULL, 'Tandem C2 domains nuclear protein, C2B domain', 'C2B_Tac2-N', 3, NULL),
(30020, NULL, 'IPR036018', NULL, 'Plant myosin, class XI, motor domain', 'MYSc_Myo11', 3, NULL),
(30021, NULL, 'IPR039719', NULL, 'F-box only protein 28', 'FBXO28', 4, NULL),
(30022, NULL, 'IPR041910', NULL, 'Alpha-helical PorB/PorC', 'Alpha_h_PorB/PorC', 5, NULL),
(30023, NULL, 'IPR041578', NULL, 'PIN like domain, group 8', 'PIN_8', 3, NULL),
(30024, NULL, 'IPR036532', NULL, 'AvrPto superfamily', 'AvrPto_sf', 5, NULL),
(30025, NULL, 'IPR037804', NULL, 'SAGA-associated factor 73', 'SGF73', 4, NULL),
(30026, NULL, 'IPR041227', NULL, 'Mu-like prophage FluMu N-terminal domain', 'FluMu_N', 3, NULL),
(30027, NULL, 'IPR041790', NULL, 'MYLIP, FERM domain C-lobe', 'MYLIP_FERM_C', 3, NULL),
(30028, NULL, 'IPR037789', NULL, 'Rab11-family interacting protein class I', 'FIP_classI', 4, NULL),
(30029, NULL, 'IPR041673', NULL, 'Tetracyclin repressor-like, C-terminal domain 23', 'TetR_C_23', 3, NULL),
(30030, NULL, 'IPR036517', NULL, 'FF domain superfamily', 'FF_domain_sf', 5, NULL),
(30031, NULL, 'IPR042038', NULL, 'MukE, N-terminal domain', 'MukE_N', 5, NULL),
(30032, NULL, 'IPR041556', NULL, 'Disulfide isomerase DsbG, N-terminal', 'DsbG_N', 3, NULL),
(30033, NULL, 'IPR042076', NULL, 'Crisp-like domain', 'Crisp-like_dom', 5, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(30034, NULL, 'IPR041505', NULL, 'Dis3-like cold-shock domain 2', 'Dis3_CSD2', 3, NULL),
(30035, NULL, 'IPR041791', NULL, 'Krev interaction trapped protein 1, FERM domain C-lobe', 'KRIT1_FERM_C', 3, NULL),
(30036, NULL, 'IPR041534', NULL, 'PP2A regulatory subunit B'''', EF-hand domain', 'EF-hand_13', 3, NULL),
(30037, NULL, 'IPR041417', NULL, 'Probable aminopeptidase NPEPL1, N-terminal', 'NPEPL1_N', 3, NULL),
(30038, NULL, 'IPR041980', NULL, 'Spt5, KOW domain repeat 6', 'KOW_Spt5_6', 3, NULL),
(30039, NULL, 'IPR040138', NULL, 'Mesoderm induction early response protein/metastasis-associated protein', 'MIER/MTA', 4, NULL),
(30040, NULL, 'IPR036980', NULL, 'Ribonuclease P/MRP subunit  Rpp29 superfamily', 'RNase_P/MRP_Rpp29_sf', 5, NULL),
(30041, NULL, 'IPR041318', NULL, 'pEK499_p136 HEPN domain', 'pEK499_p136', 3, NULL),
(30042, NULL, 'IPR041948', NULL, 'RNA ligase 1/2, C-terminal domain superfamily', 'Rnl1/2_C_sf', 5, NULL),
(30043, NULL, 'IPR034941', NULL, 'PydA-like', 'PydA-like', 4, NULL),
(30044, NULL, 'IPR041646', NULL, 'IcaR, C-terminal', 'IcaR_C', 3, NULL),
(30045, NULL, 'IPR037905', NULL, 'NudC domain-containing protein 3, p23 domain', 'p23_NUDCD3', 3, NULL),
(30046, NULL, 'IPR042046', NULL, 'Lepidopteran low molecular weight lipoprotein, N-terminal domain', 'Lipoprotein_11_N', 5, NULL),
(30047, NULL, 'IPR042088', NULL, 'Oligoendopeptidase F, C-terminal domain', 'OligoPept_F_C', 5, NULL),
(30048, NULL, 'IPR041737', NULL, 'SoxW family', 'SoxW', 4, NULL),
(30049, NULL, 'IPR041882', NULL, 'Ankyrin repeat and SAM domain-containing protein 1, SAM repeat 2', 'SAM_ANKS1_repeat2', 3, NULL),
(30050, NULL, 'IPR035553', NULL, 'Cytokinesis protein 3, SH3 domain', 'Cyk3_SH3', 3, NULL),
(30051, NULL, 'IPR034751', NULL, 'Yippee domain', 'Yippee', 3, NULL),
(30052, NULL, 'IPR041917', NULL, 'Trinucleotide repeat-containing gene 6C protein, UBA domain', 'TNR6C_UBA', 3, NULL),
(30053, NULL, 'IPR040325', NULL, 'RIMS-binding protein 1/2/3', 'RIMBP1/2/3', 4, NULL),
(30054, NULL, 'IPR033857', NULL, 'Bacillopeptidase F, peptidase domain', 'Bacillopeptidase_F', 3, NULL),
(30055, NULL, 'IPR041970', NULL, 'Rup1, UBA domain', 'Rup1_UBA', 3, NULL),
(30056, NULL, 'IPR033139', NULL, 'Peptidase family C14A, cysteine active site', 'Caspase_cys_AS', 0, NULL),
(30057, NULL, 'IPR041903', NULL, 'Tyrosine 3-monooxygenase, catalytic domain', 'Eu_TyrOH_cat', 3, NULL),
(30058, NULL, 'IPR036005', NULL, 'Creatinase/aminopeptidase-like', 'Creatinase/aminopeptidase-like', 5, NULL),
(30059, NULL, 'IPR041904', NULL, 'Tryptophan 5-hydroxylase, catalytic domain', 'TrpOH_cat', 3, NULL),
(30060, NULL, 'IPR042034', NULL, 'Host-nuclease inhibitor Gam superfamily', 'Gam_sf', 5, NULL),
(30061, NULL, 'IPR041742', NULL, 'Sec24-like, trunk domain', 'Sec24-like_trunk_dom', 3, NULL),
(30062, NULL, 'IPR036554', NULL, 'GHMP kinase, C-terminal domain superfamily', 'GHMP_kinase_C_sf', 5, NULL),
(30063, NULL, 'IPR038170', NULL, 'NS5A domain 1a superfamily', 'NS5A_1a_sf', 5, NULL),
(30064, NULL, 'IPR041824', NULL, 'Rab9', 'Rab9', 4, NULL),
(30065, NULL, 'IPR041715', NULL, 'Class II Histidinyl-tRNA synthetase (HisRS)-like catalytic core domain', 'HisRS-like_core', 3, NULL),
(30066, NULL, 'IPR041552', NULL, 'UvrA DNA-binding domain', 'UvrA_DNA-bd', 3, NULL),
(30067, NULL, 'IPR041905', NULL, 'Ribosomal protein S6 kinase alpha-3, C-terminal catalytic domain', 'RPS6KA3_C', 3, NULL),
(30068, NULL, 'IPR042008', NULL, 'BRPF1, PHD domain', 'BRPF1_PHD', 3, NULL),
(30069, NULL, 'IPR036516', NULL, 'Translation repressor RegA superfamily', 'Transl_repress_RegA_sf', 5, NULL),
(30070, NULL, 'IPR041445', NULL, 'RuvB, AAA lid domain', 'AAA_lid_4', 3, NULL),
(30071, NULL, 'IPR039924', NULL, 'Protein ICln/Lot5/Saf5', 'ICln/Lot5/Saf5', 4, NULL),
(30072, NULL, 'IPR041902', NULL, 'CtsR, N-terminal domain superfamily', 'CtsR_N_sf', 5, NULL),
(30073, NULL, 'IPR041907', NULL, 'NAC-alpha domain-containing protein 1, UBA-like domain', 'NACAD_UBA', 3, NULL),
(30074, NULL, 'IPR039997', NULL, 'Transcription factor E', 'TFE', 4, NULL),
(30075, NULL, 'IPR038113', NULL, 'MITD1, C-terminal phospholipase D-like domain superfamily', 'MITD1_C_sf', 5, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(30076, NULL, 'IPR041408', NULL, 'Hemolysin coregulated protein (Hcp) TssD', 'Hcp_Tssd', 4, NULL),
(30077, NULL, 'IPR039949', NULL, 'N-alpha-acetyltransferase 40', 'NAA40', 4, NULL),
(30078, NULL, 'IPR038184', NULL, 'CSTF1, dimerization domain superfamily', 'CSTF1_dimer_sf', 5, NULL),
(30079, NULL, 'IPR033715', NULL, 'GDP-mannose mannosyl hydrolase', 'GDPMH', 4, NULL),
(30080, NULL, 'IPR033799', NULL, 'CDI toxin, EC869-like', 'CDI_EC869-like', 3, NULL),
(30081, NULL, 'IPR039930', NULL, 'Ral GTPase-activating protein subunit beta', 'RALGAPB', 4, NULL),
(30082, NULL, 'IPR039931', NULL, 'Protein FAM102-like', 'FAM102-like', 4, NULL),
(30083, NULL, 'IPR037720', NULL, 'Ferlin, second C2 domain', 'C2B_Ferlin', 3, NULL),
(30084, NULL, 'IPR041694', NULL, 'Oxidoreductase, N-terminal domain', 'ADH_N_2', 3, NULL),
(30085, NULL, 'IPR041958', NULL, 'KMT2A, ePHD domain', 'KMT2A_ePHD', 3, NULL),
(30086, NULL, 'IPR035550', NULL, 'Bem1/Scd2, PX domain', 'Bem1/Scd2_PX', 3, NULL),
(30087, NULL, 'IPR038775', NULL, 'Testis-expressed protein 49', 'TEX49', 4, NULL),
(30088, NULL, 'IPR038776', NULL, 'Uncharacterized protein C2orf80', 'C2orf80', 4, NULL),
(30089, NULL, 'IPR035548', NULL, 'Bem1/Scd2, SH3 domain 1', 'Bem1/Scd2_SH3_1', 3, NULL),
(30090, NULL, 'IPR041243', NULL, 'STI1/HOP, DP domain', 'STI1/HOP_DP', 3, NULL),
(30091, NULL, 'IPR033389', NULL, 'AUX/IAA domain', 'AUX/IAA_dom', 3, NULL),
(30092, NULL, 'IPR036514', NULL, 'SGNH hydrolase superfamily', 'SGNH_hydro_sf', 5, NULL),
(30093, NULL, 'IPR041889', NULL, 'Ecdysone receptor, ligand-binding domain', 'NR_LBD_EcR', 3, NULL),
(30094, NULL, 'IPR041317', NULL, 'RET, cadherin-like domain 4', 'RET_CLD4', 3, NULL),
(30095, NULL, 'IPR039951', NULL, 'Transmembrane protein TMEM114/TMEM235', 'TMEM114/TMEM235', 4, NULL),
(30096, NULL, 'IPR040152', NULL, 'ATPase synthesis protein 25, mitochondrial', 'Atp25', 4, NULL),
(30097, NULL, 'IPR041642', NULL, 'HTH-type transcriptional repressor KstR, C-terminal', 'KstR_C', 3, NULL),
(30098, NULL, 'IPR036509', NULL, 'Peptide methionine sulphoxide reductase MsrA superfamily', 'Met_Sox_Rdtase_MsrA_sf', 5, NULL),
(30099, NULL, 'IPR036609', NULL, 'LCCL domain superfamily', 'LCCL_sf', 5, NULL),
(30100, NULL, 'IPR041640', NULL, 'Tyosinase, C-terminal', 'Tyosinase_C', 3, NULL),
(30101, NULL, 'IPR036039', NULL, 'Influenza virus matrix protein M1', 'Flu_matrix_M1', 5, NULL),
(30102, NULL, 'IPR041911', NULL, 'TAB2/3, CUE domain', 'TAB2/3_CUE', 3, NULL),
(30103, NULL, 'IPR038183', NULL, 'RICH domain superfamily', 'RICH_sf', 5, NULL),
(30104, NULL, 'IPR040323', NULL, 'EARP and GARP complex-interacting protein 1', 'EIPR1', 4, NULL),
(30105, NULL, 'IPR040151', NULL, 'Gfd2/YDR514C-like', 'Gfd2/YDR514C-like', 4, NULL),
(30106, NULL, 'IPR035756', NULL, 'Neutrophil cytosol factor 1, first SH3 domain', 'NCF1_SH3_1', 3, NULL),
(30107, NULL, 'IPR041635', NULL, 'Type ISP restriction-modification enzyme LLaBIII, C-terminal specificity domain', 'Type_ISP_LLaBIII_C', 3, NULL),
(30108, NULL, 'IPR041584', NULL, 'Predicted pPIWI-associating nuclease, group 2', 'Put_pPIWI_pnuc_2', 3, NULL),
(30109, NULL, 'IPR041863', NULL, 'DNA polymerase delta subunit 2, C-terminal domain', 'PolD2_C', 3, NULL),
(30110, NULL, 'IPR041818', NULL, 'Rab39', 'Rab39', 4, NULL),
(30111, NULL, 'IPR037490', NULL, 'WPP domain-associated protein', 'WAP', 4, NULL),
(30112, NULL, 'IPR035759', NULL, 'Disks Large homologue 2, SH3 domain', 'DLG2_SH3', 3, NULL),
(30113, NULL, 'IPR038115', NULL, 'Nucleocapsid, C-terminal superfamily', 'Nucleocapsid_C_sf', 5, NULL),
(30114, NULL, 'IPR036208', NULL, 'VHL superfamily', 'VHL_sf', 5, NULL),
(30115, NULL, 'IPR035749', NULL, 'Lck, SH3 domain', 'Lck_SH3', 3, NULL),
(30116, NULL, 'IPR041891', NULL, 'Carbonic anhydrase, prokaryotic-like', 'Alpha_CA_prokaryot-like', 4, NULL),
(30117, NULL, 'IPR035552', NULL, 'Mti1, SH3 domain', 'Mti1_SH3', 3, NULL),
(30118, NULL, 'IPR038751', NULL, 'Integrator complex subunit 8', 'Int8', 4, NULL),
(30119, NULL, 'IPR041796', NULL, 'Mre11 nuclease, N-terminal metallophosphatase domain', 'Mre11_N', 3, NULL),
(30120, NULL, 'IPR041896', NULL, 'Antirestriction protein ArdA, domain 2', 'ArdA_dom2', 5, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(30121, NULL, 'IPR041591', NULL, 'OCRE domain', 'OCRE', 3, NULL),
(30122, NULL, 'IPR038103', NULL, 'Cell division control protein 73, C-terminal domain superfamily', 'CDC73_C_sf', 5, NULL),
(30123, NULL, 'IPR035753', NULL, 'RIMS-binding protein, second SH3 domain', 'RIM-BP_SH3_2', 3, NULL),
(30124, NULL, 'IPR033823', NULL, 'Nucellin', 'Nucellin', 3, NULL),
(30125, NULL, 'IPR034391', NULL, 'Cmo-like SPASM domain containing protein', 'Cmo-like_SPASM_containing', 4, NULL),
(30126, NULL, 'IPR041630', NULL, 'Epithelial cell adhesion molecule N-terminal domain', 'EpCAM_N', 3, NULL),
(30127, NULL, 'IPR041228', NULL, 'Dynein heavy chain, C-terminal domain', 'Dynein_C', 3, NULL),
(30128, NULL, 'IPR038778', NULL, 'Mitoregulin', 'Mtln', 4, NULL),
(30129, NULL, 'IPR038093', NULL, 'Ubiquitin carboxyl-terminal hydrolase 37, pleckstrin homology-like domain superfamily', 'USP37-like_PH_sf', 5, NULL),
(30130, NULL, 'IPR041699', NULL, 'Lon protease, AAA domain', 'AAA_32', 3, NULL),
(30131, NULL, 'IPR041647', NULL, 'Inward rectifier potassium channel, C-terminal', 'IRK_C', 3, NULL),
(30132, NULL, 'IPR042009', NULL, 'BRPF2, PHD domain', 'BRPF2_PHD', 3, NULL),
(30133, NULL, 'IPR041600', NULL, 'Effector immunity protein Tgi2PP', 'Tgi2PP', 3, NULL),
(30134, NULL, 'IPR041912', NULL, 'Eukaryotic phenylalanine-4-hydroxylase, catalytic domain', 'Euk_PheOH_cat', 3, NULL),
(30135, NULL, 'IPR041748', NULL, 'Aspartokinase catalytic domain, ectoine pathway', 'AK-Ectoine', 3, NULL),
(30136, NULL, 'IPR038197', NULL, 'TbpB, C-lobe handle domain superfamily', 'TbpB_C-lobe_sf', 5, NULL),
(30137, NULL, 'IPR038187', NULL, 'NAC A/B domain superfamily', 'NAC_A/B_dom_sf', 5, NULL),
(30138, NULL, 'IPR041667', NULL, 'Cupin-like domain 8', 'Cupin_8', 3, NULL),
(30139, NULL, 'IPR036531', NULL, 'Rabenosyn, Rab binding domain superfamily', 'Rbsn_Rab-bd_sf', 5, NULL),
(30140, NULL, 'IPR041583', NULL, 'Tetracyclin repressor-like, C-terminal, group 31', 'TetR_C_31', 3, NULL),
(30141, NULL, 'IPR042035', NULL, 'DEAH helicase, winged-helix domain', 'DEAH_win-hel_dom', 5, NULL),
(30142, NULL, 'IPR042087', NULL, 'DNA polymerase family B, thumb domain', 'DNA_pol_B_thumb', 5, NULL),
(30143, NULL, 'IPR041535', NULL, 'Antitoxin VbhA', 'VbhA', 3, NULL),
(30144, NULL, 'IPR041567', NULL, 'COI1, F-box', 'COI1_F-box', 3, NULL),
(30145, NULL, 'IPR036161', NULL, 'RPB6/omega subunit-like superfamily', 'RPB6/omega-like_sf', 5, NULL),
(30146, NULL, 'IPR033797', NULL, 'L-lysine epsilon-oxidase', 'LodA', 4, NULL),
(30147, NULL, 'IPR036518', NULL, 'CobE/GbiG C-terminal domain superfamily', 'CobE/GbiG_C_sf', 5, NULL),
(30148, NULL, 'IPR041826', NULL, 'Rab15', 'Rab15', 4, NULL),
(30149, NULL, 'IPR033901', NULL, 'DNA-directed RNA polymerases I and III subunit AC40', 'RNAPI/III_AC40', 4, NULL),
(30150, NULL, 'IPR041679', NULL, 'DNA2/NAM7 helicase-like, C-terminal', 'DNA2/NAM7-like_C', 3, NULL),
(30151, NULL, 'IPR041982', NULL, 'Ribosomal protein S4, KOW domain', 'KOW_RPS4', 3, NULL),
(30152, NULL, 'IPR041443', NULL, 'ExoP, galactose-binding-like domain', 'Exop_C', 3, NULL),
(30153, NULL, 'IPR041880', NULL, 'Ankyrin repeat and SAM domain-containing protein 1, SAM repeat 1', 'SAM_ANKS1_repeat1', 3, NULL),
(30154, NULL, 'IPR041926', NULL, 'UBAC1, UBA domain 1', 'UBA1_UBAC1', 3, NULL),
(30155, NULL, 'IPR042033', NULL, 'Big defensin, N-terminal domain', 'Defensin_big_N', 5, NULL),
(30156, NULL, 'IPR033253', NULL, 'Cilia- and flagella-associated protein 45', 'CFAP45', 4, NULL),
(30157, NULL, 'IPR042044', NULL, 'EXOC6/PINT-1/Sec15/Tip20, C-terminal, domain 2', 'EXOC6PINT-1/Sec15/Tip20_C_dom2', 5, NULL),
(30158, NULL, 'IPR042051', NULL, 'ParM-like', 'ParM-like', 4, NULL),
(30159, NULL, 'IPR041987', NULL, 'HERC2, zinc finger, ZZ-type', 'ZZ_HERC2', 3, NULL),
(30160, NULL, 'IPR033752', NULL, 'MetA family', 'MetA_family', 4, NULL),
(30161, NULL, 'IPR041641', NULL, 'CALCOCO1/2, zinc finger UBZ1-type', 'CALCOCO1/2_Zn_UBZ1', 3, NULL),
(30162, NULL, 'IPR040391', NULL, 'BEN domain-containing protein 5', 'BEND5', 4, NULL),
(30163, NULL, 'IPR041918', NULL, 'HUWE1, UBA domain', 'UBA_HUWE1', 3, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(30164, NULL, 'IPR041670', NULL, 'Zinc knuckle', 'Znf-CCHC_6', 3, NULL),
(30165, NULL, 'IPR041964', NULL, 'KMT2D, ePHD2 domain', 'KMT2D_ePHD2', 3, NULL),
(30166, NULL, 'IPR041765', NULL, 'Frizzled 4, cysteine-rich domain', 'FZ4_CRD', 3, NULL),
(30167, NULL, 'IPR033796', NULL, 'Putative lipoprotein BA_2398-like', 'BA_2398-like', 4, NULL),
(30168, NULL, 'IPR042068', NULL, 'Semaphorin-1A, sema domain', 'SEM1A_sema_dom', 3, NULL),
(30169, NULL, 'IPR035549', NULL, 'Bem1/Scd2, SH3 domain 2', 'Bem1/Scd2_SH3_2', 3, NULL),
(30170, NULL, 'IPR036166', NULL, 'YxeA-like superfamily', 'YxeA-like_sf', 5, NULL),
(30171, NULL, 'IPR035265', NULL, 'Colicin-K immunity', 'Colicin-K_immunity', 4, NULL),
(30172, NULL, 'IPR041717', NULL, 'FwdD/FmdC, molybdopterin dinucleotide-binding domain', 'FmdC/FwdD_MopB-bd', 3, NULL),
(30173, NULL, 'IPR039992', NULL, 'Selenoprotein F/M', 'Sep15_SelM', 4, NULL),
(30174, NULL, 'IPR038117', NULL, 'Bypass of forespore C, C-terminal domain superfamily', 'BofC_C_sf', 5, NULL),
(30175, NULL, 'IPR039988', NULL, 'Microsomal triglyceride transfer protein large subunit', 'MTTP', 4, NULL),
(30176, NULL, 'IPR041771', NULL, 'Smoothened, cysteine-rich domain', 'SMO_CRD', 3, NULL),
(30177, NULL, 'IPR042012', NULL, 'PHF7/G2E3, PHD domain', 'PHF7/G2E3_PHD', 3, NULL),
(30178, NULL, 'IPR041321', NULL, 'Lpg0393, helical bundle domain', 'Lpg0393_HBD', 3, NULL),
(30179, NULL, 'IPR042031', NULL, 'SKA1 microtubule binding domain', 'SKA1-MBD', 5, NULL),
(30180, NULL, 'IPR041447', NULL, 'Mannosidase Ig/CBM-like domain', 'Mannosidase_ig', 3, NULL),
(30181, NULL, 'IPR041695', NULL, 'Glutathione S-transferase, C-terminal domain', 'GST_C_5', 3, NULL),
(30182, NULL, 'IPR041410', NULL, 'STATa immunoglobulin-like domain', 'STATa_Ig', 3, NULL),
(30183, NULL, 'IPR041751', NULL, 'PP2B, metallophosphatase domain', 'MPP_PP2B', 3, NULL),
(30184, NULL, 'IPR041789', NULL, 'ERM family, FERM domain C-lobe', 'ERM_FERM_C', 3, NULL),
(30185, NULL, 'IPR041677', NULL, 'DNA2/NAM7 helicase, helicase domain', 'DNA2/NAM7_AAA_11', 3, NULL),
(30186, NULL, 'IPR039922', NULL, 'GDP-fucose protein O-fucosyltransferase 1', 'POFUT1', 4, NULL),
(30187, NULL, 'IPR042052', NULL, 'HSPA4, nucleotide-binding domain', 'HSPA4_NBD', 3, NULL),
(30188, NULL, 'IPR036041', NULL, 'Ribosome-inactivating protein superfamily', 'Ribosome-inact_prot_sf', 5, NULL),
(30189, NULL, 'IPR041508', NULL, 'Toxin complex C-like repeat', 'TcC-like_repeat', 7, NULL),
(30190, NULL, 'IPR037869', NULL, 'Spp1/CFP1', 'Spp1/CFP1', 4, NULL),
(30191, NULL, 'IPR041992', NULL, 'SMCT1, solute-binding domain', 'SLC5sbd_SMCT1', 3, NULL),
(30192, NULL, 'IPR036002', NULL, 'Stathmin superfamily', 'Stathmin_sf', 5, NULL),
(30193, NULL, 'IPR041718', NULL, 'IS607-like transposase, catalytic domain', 'IS607_transposase-like', 3, NULL),
(30194, NULL, 'IPR041865', NULL, 'Protein disulfide-isomerase A5, N-terminal TRX-like b domain', 'PDI_b_PDIR_N', 3, NULL),
(30195, NULL, 'IPR041819', NULL, 'Rab4', 'Rab4', 4, NULL),
(30196, NULL, 'IPR042027', NULL, 'Sedoheptulokinase', 'SHK', 4, NULL),
(30197, NULL, 'IPR033725', NULL, 'LIM1 prickle', 'LIM1_prickle', 3, NULL),
(30198, NULL, 'IPR038167', NULL, 'SSRP1 domain superfamily', 'SSRP1_sf', 5, NULL),
(30199, NULL, 'IPR041788', NULL, 'FARP1/FARP2/FRMD7, FERM domain C-lobe', 'FARP1/FARP2/FRMD7_FERM_C', 3, NULL),
(30200, NULL, 'IPR033138', NULL, 'Multicopper oxidases, conserved site', 'Cu_oxidase_CS', 2, NULL),
(30201, NULL, 'IPR041697', NULL, 'Zinc-finger C2H2-type 11', 'Znf-C2H2_11', 3, NULL),
(30202, NULL, 'IPR041793', NULL, 'Myosin VII, FERM domain C-lobe, repeat 1', 'MyoVII_FERM_C1', 3, NULL),
(30203, NULL, 'IPR041763', NULL, 'Corin, cysteine-rich domain 2', 'Corin_CRD_2', 3, NULL),
(30204, NULL, 'IPR033653', NULL, 'NTP pyrophosphohydrolase, DR2231-like', 'NTP-PPase_DR2231-like', 4, NULL),
(30205, NULL, 'IPR038779', NULL, 'Coiled-coil domain-containing protein 107', 'CCDC107', 4, NULL),
(30206, NULL, 'IPR042062', NULL, 'Lipoxygenase, vertebrates, PLAT domain', 'PLAT_LOX_verte', 3, NULL),
(30207, NULL, 'IPR033471', NULL, 'DIRP domain', 'DIRP', 3, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(30208, NULL, 'IPR036511', NULL, 'Queuine tRNA-ribosyltransferase-like', 'TGT-like_sf', 5, NULL),
(30209, NULL, 'IPR037867', NULL, 'COMPASS component Swd2/WDR82', 'Swd2/WDR82', 4, NULL),
(30210, NULL, 'IPR033777', NULL, 'Viral cysteine endopeptidase C107', 'Peptidase_C107', 4, NULL),
(30211, NULL, 'IPR041627', NULL, 'CbbX, AAA lid domain', 'AAA_lid_6', 3, NULL),
(30212, NULL, 'IPR035755', NULL, 'RIMS-binding protein, third SH3 domain', 'RIM-BP_SH3_3', 3, NULL),
(30213, NULL, 'IPR033367', NULL, 'BRI3-binding protein', 'BRI3BP', 4, NULL),
(30214, NULL, 'IPR041414', NULL, 'RACo, middle region', 'Raco_middle', 3, NULL),
(30215, NULL, 'IPR036515', NULL, 'Transposase IS200-like superfamily', 'Transposase_17_sf', 5, NULL),
(30216, NULL, 'IPR041413', NULL, 'MmyB-like transcription regulator ligand binding', 'MLTR_LBD', 3, NULL),
(30217, NULL, 'IPR041454', NULL, 'BsuBI/PstI restriction endonuclease, HTH domain', 'BsuBI/PstI_N', 3, NULL),
(30218, NULL, 'IPR041233', NULL, 'Alpha galactosidase, C-terminal beta sandwich domain', 'Melibiase_C', 3, NULL),
(30219, NULL, 'IPR041971', NULL, 'Gawky, UBA domain', 'Gawky_UBA', 3, NULL),
(30220, NULL, 'IPR041562', NULL, 'MCM, AAA-lid domain', 'MCM_lid', 3, NULL),
(30221, NULL, 'IPR041785', NULL, 'FRMD4A/B, FERM domain C-lobe', 'FRMD4A/B_FERM_C', 3, NULL),
(30222, NULL, 'IPR038108', NULL, 'RPN13, DEUBAD domain superfamily', 'RPN13_DEUBAD_sf', 5, NULL),
(30223, NULL, 'IPR033652', NULL, 'LigD polymerase domain, type 3', 'LigD_Pol-like_3', 3, NULL),
(30224, NULL, 'IPR036000', NULL, 'Class II myosin, Myh3, motor domain', 'MYSc_Myh3', 3, NULL),
(30225, NULL, 'IPR042065', NULL, 'E3 ubiquitin-protein ligase ELL-like', 'E3_ELL-like', 5, NULL),
(30226, NULL, 'IPR041972', NULL, 'Transcription factor 20, ePHD domain', 'TCF-20_ePHD', 3, NULL),
(30227, NULL, 'IPR033651', NULL, 'LigD polymerase domain, PaeLigD-type', 'PaeLigD_Pol-like', 3, NULL),
(30228, NULL, 'IPR042011', NULL, 'ATX3/4/5, PHD domain', 'ATX3/4/5_PHD', 3, NULL),
(30229, NULL, 'IPR042049', NULL, 'Heat shock 70kDa protein 14, nucleotide-binding domain', 'HSPA14_NBD', 3, NULL),
(30230, NULL, 'IPR036976', NULL, 'RimM, N-terminal domain superfamily', 'RimM_N_sf', 5, NULL),
(30231, NULL, 'IPR033890', NULL, 'GDP-mannose 3,5-epimerase', 'GDP-Man_epi', 3, NULL),
(30232, NULL, 'IPR034942', NULL, 'PhnC-like', 'PhnC-like', 4, NULL),
(30233, NULL, 'IPR041985', NULL, 'Ribosomal protein L14, KOW motif', 'RPL14_KOW', 3, NULL),
(30234, NULL, 'IPR041650', NULL, 'Swt1-like HEPN', 'HEPN_Swt1', 3, NULL),
(30235, NULL, 'IPR038088', NULL, 'DELLA, N-terminal domain superfamily', 'DELLA_N_sf', 5, NULL),
(30236, NULL, 'IPR038091', NULL, 'UPF0302, N-terminal domain superfamily', 'UPF0302_N_sf', 5, NULL),
(30237, NULL, 'IPR041928', NULL, 'UBAC2, UBA domain', 'UBA_UBAC2', 3, NULL),
(30238, NULL, 'IPR041988', NULL, 'Ribosomal protein L26/L24, KOW domain', 'KOW_RPL26/RPL24', 3, NULL),
(30239, NULL, 'IPR042048', NULL, 'Heat shock 70kDa protein 13', 'HSPA13', 4, NULL),
(30240, NULL, 'IPR033640', NULL, 'Fatty acyl-CoA reductase, C-terminal', 'FAR_C', 3, NULL),
(30241, NULL, 'IPR033403', NULL, 'Domain of unknown function DUF5110', 'DUF5110', 3, NULL),
(30242, NULL, 'IPR041319', NULL, 'Protein of unknown function DUF5543', 'DUF5543', 4, NULL),
(30243, NULL, 'IPR041761', NULL, 'SFRP5, cysteine-rich domain', 'SFRP5_CRD', 3, NULL),
(30244, NULL, 'IPR041669', NULL, 'Tetracyclin repressor SlmA-like, C-terminal domain', 'TetR_C_15', 3, NULL),
(30245, NULL, 'IPR041450', NULL, 'ToxB-like N-terminal, ascomycota', 'ToxB-like_N_ascomy', 3, NULL),
(30246, NULL, 'IPR041814', NULL, 'Type III secretion system virulence factor YopR, core domain', 'YopR_core', 5, NULL),
(30247, NULL, 'IPR042018', NULL, 'Glycerol kinase, metazoa', 'GK1-3_metazoa', 4, NULL),
(30248, NULL, 'IPR033845', NULL, 'p-Aminobenzoyl-glutamate hydrolase subunit A', 'AbgA', 4, NULL),
(30249, NULL, 'IPR036975', NULL, 'Importin-alpha, importin-beta-binding domain superfamily', 'Importin-a_IBB_sf', 5, NULL),
(30250, NULL, 'IPR041561', NULL, 'PglD, N-terminal', 'PglD_N', 3, NULL),
(30251, NULL, 'IPR042004', NULL, 'BRPF2, ePHD domain', 'BRPF2_ePHD', 3, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(30252, NULL, 'IPR036979', NULL, 'Chorismate mutase domain superfamily', 'CM_dom_sf', 5, NULL),
(30253, NULL, 'IPR036162', NULL, 'Resolvase-like, N-terminal catalytic domain superfamily', 'Resolvase-like_N_sf', 5, NULL),
(30254, NULL, 'IPR039927', NULL, '39S ribosomal protein L43/54S ribosomal protein L51', 'MRPL43/MRPL51', 4, NULL),
(30255, NULL, 'IPR041638', NULL, 'Bacterial archaeo-eukaryotic release factor family 11', 'BaeRF_family11', 4, NULL),
(30256, NULL, 'IPR041921', NULL, 'NADH-quinone oxidoreductase subunit E, N-terminal', 'NuoE_N', 5, NULL),
(30257, NULL, 'IPR033272', NULL, 'Hemogen', 'Hemogen', 4, NULL),
(30258, NULL, 'IPR042053', NULL, 'HSPH1, nucleotide-binding domain', 'HSPH1_NBD', 3, NULL),
(30259, NULL, 'IPR039907', NULL, 'RNA-binding protein NOB1', 'NOB1', 4, NULL),
(30260, NULL, 'IPR036977', NULL, 'DNA Primase, CHC2-type zinc finger', 'DNA_primase_Znf_CHC2', 5, NULL),
(30261, NULL, 'IPR038186', NULL, 'CHAD domain superfamily', 'CHAD_dom_sf', 5, NULL),
(30262, NULL, 'IPR033118', NULL, 'EXPERA domain', 'EXPERA', 3, NULL),
(30263, NULL, 'IPR040145', NULL, 'Integral membrane protein 2', 'ITM2', 4, NULL),
(30264, NULL, 'IPR041654', NULL, 'Styrene monooxygenase StyA, putative substrate binding domain', 'StyA_sbd', 3, NULL),
(30265, NULL, 'IPR040390', NULL, 'TIFY/JAZ family', 'TIFY/JAZ', 4, NULL),
(30266, NULL, 'IPR041236', NULL, 'Primosomal protein N, C-terminal domain', 'PriA_C', 3, NULL),
(30267, NULL, 'IPR042082', NULL, 'CST complex subunit Stn1, wHTH1 motif superfamily', 'CST_Stn1_wHTH1_sf', 5, NULL),
(30268, NULL, 'IPR041411', NULL, 'Linalool dehydratase/isomerase', 'Ldi', 3, NULL),
(30269, NULL, 'IPR039932', NULL, 'Serine protease inhibitor Kazal-type 4-like', 'Spink4-like', 4, NULL),
(30270, NULL, 'IPR041685', NULL, 'AAA domain, group 15', 'AAA_15', 3, NULL),
(30271, NULL, 'IPR041747', NULL, 'Aspartokinase HOM3, catalytic domain', 'AK-Hom3', 3, NULL),
(30272, NULL, 'IPR036546', NULL, 'Mediator complex subunit 15, KIX domain', 'MED15_KIX', 3, NULL),
(30273, NULL, 'IPR041475', NULL, 'His-Me finger endonuclease, beta4-alpha2 domain', 'His_Me_b4a2', 3, NULL),
(30274, NULL, 'IPR041969', NULL, 'Intermembrane lipid transfer protein VPS13D, UBA domain', 'VP13D_UBA', 3, NULL),
(30275, NULL, 'IPR041564', NULL, 'Sld7, N-terminal', 'Sld7_N', 3, NULL),
(30276, NULL, 'IPR041656', NULL, 'Tetratrico peptide repeat, group 5', 'TPR_5', 3, NULL),
(30277, NULL, 'IPR041565', NULL, 'Parkin, RING/Ubox like zinc-binding domain', 'Parkin_Znf-RING', 3, NULL),
(30278, NULL, 'IPR041923', NULL, 'UBXN1, UBA domain', 'UBA_UBXN1', 3, NULL),
(30279, NULL, 'IPR041991', NULL, 'Eukaryotic Ribosomal Protein L27, KOW domain', 'KOW_RPL27', 3, NULL),
(30280, NULL, 'IPR033402', NULL, 'Domain of unknown function DUF5109', 'DUF5109', 3, NULL),
(30281, NULL, 'IPR041764', NULL, 'SFRP2, cysteine-rich domain', 'SFRP2_CRD', 3, NULL),
(30282, NULL, 'IPR039948', NULL, 'Elongin-C', 'ELC1', 4, NULL),
(30283, NULL, 'IPR041866', NULL, 'Protein disulfide-isomerase A4, TRX-like domain b', 'PDIA4_PDI_b', 3, NULL),
(30284, NULL, 'IPR041478', NULL, 'Tetracyclin repressor-like, C-terminal domain 27', 'TetR_C_27', 3, NULL),
(30285, NULL, 'IPR041558', NULL, 'Mucin binding domain', 'MucBP_2', 3, NULL),
(30286, NULL, 'IPR041622', NULL, 'SMODS and SLOG-associating 2TM effector domain, fungi', 'SLATT_fungi', 3, NULL),
(30287, NULL, 'IPR040162', NULL, 'Microsomal glutathione S-transferase 1-like', 'MGST1-like', 4, NULL),
(30288, NULL, 'IPR041229', NULL, 'Apea-like HEPN', 'HEPN_Apea', 3, NULL),
(30289, NULL, 'IPR042043', NULL, 'Protein transport protein Tip20, domain C', 'Tip20p_domC', 5, NULL),
(30290, NULL, 'IPR033716', NULL, 'Nudix motif 17 domain', 'Nudt17_dom', 3, NULL),
(30291, NULL, 'IPR038961', NULL, 'Protein PEP-related development arrested 1', 'PRDA1', 4, NULL),
(30292, NULL, 'IPR042054', NULL, 'YegD-like', 'YegD-like', 4, NULL),
(30293, NULL, 'IPR041746', NULL, 'Lysine-sensitive aspartokinase catalytic domain', 'AK-LysC-like', 3, NULL),
(30294, NULL, 'IPR040322', NULL, 'RNA-binding protein RO60', 'TROVE2', 4, NULL),
(30295, NULL, 'IPR038030', NULL, 'NSP1 globular domain superfamily, betacoronavirus', 'NSP1_glob_sf_bCoV', 5, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(30296, NULL, 'IPR035076', NULL, 'Snake toxin/toxin-like', 'Toxin/TOLIP', 3, NULL),
(30297, NULL, 'IPR041477', NULL, 'Domain of unknown function DUF5577', 'DUF5577', 3, NULL),
(30298, NULL, 'IPR042067', NULL, 'Sip3, PH domain', 'Sip3_PH', 3, NULL),
(30299, NULL, 'IPR033140', NULL, 'Lipase, GDXG, putative serine active site', 'Lipase_GDXG_put_SER_AS', 0, NULL),
(30300, NULL, 'IPR041586', NULL, 'PsrA, tetracyclin repressor-like, C-terminal domain', 'PsrA_TetR_C', 3, NULL),
(30301, NULL, 'IPR033648', NULL, 'AAR2, C-terminal', 'AAR2_C', 3, NULL),
(30302, NULL, 'IPR038169', NULL, 'DC-UbP/UBTD2, N-terminal domain superfamily', 'DC-UbP/UBTD2_N_sf', 5, NULL),
(30303, NULL, 'IPR042045', NULL, 'Exocyst complex component EXOC6/Sec15, C-terminal, domain 1', 'EXOC6/Sec15_C_dom1', 5, NULL),
(30304, NULL, 'IPR041919', NULL, 'Plasmid replication protein, C-terminal domain superfamily', 'Plasmid_rep_C_sf', 5, NULL),
(30305, NULL, 'IPR041674', NULL, 'Tetracyclin repressor SCO1712-like, C-terminal domain', 'TetR_C_22', 3, NULL),
(30306, NULL, 'IPR042066', NULL, 'Spt6, Death-like domain', 'Spt6_death-like', 5, NULL),
(30307, NULL, 'IPR033776', NULL, 'COMMD1 N-terminal domain', 'COMMD1_N', 3, NULL),
(30308, NULL, 'IPR040388', NULL, 'CXXC-type zinc finger protein CXXC4/CXXC5', 'CXXC4/CXXC5', 4, NULL),
(30309, NULL, 'IPR041913', NULL, 'DNA polymerase delta subunit 3 superfamily', 'POLD3_sf', 5, NULL),
(30310, NULL, 'IPR038102', NULL, 'EYA domain superfamily', 'EYA_dom_sf', 5, NULL),
(30311, NULL, 'IPR033902', NULL, 'Patatin-like phospholipase domain-containing protein 4', 'PNPLA4', 4, NULL),
(30312, NULL, 'IPR042057', NULL, 'Plant lipoxygenase, PLAT/LH2 domain', 'Lipoxy_PLAT/LH2', 3, NULL),
(30313, NULL, 'IPR041993', NULL, 'G-patch domain and KOW motifs-containing protein, KOW 1', 'GPKOW_KOW1', 3, NULL),
(30314, NULL, 'IPR041633', NULL, 'Polymerase beta, nucleotidyltransferase', 'Polbeta', 3, NULL),
(30315, NULL, 'IPR041675', NULL, 'Pleckstrin homology domain 5', 'PH_5', 3, NULL),
(30316, NULL, 'IPR041974', NULL, 'Ubiquitin carrier protein 27, UBA domain', 'UBC27_UBA', 3, NULL),
(30317, NULL, 'IPR041657', NULL, 'Helix-turn-helix domain, group 17', 'HTH_17', 3, NULL),
(30318, NULL, 'IPR039934', NULL, 'C2 domain-containing protein 2-like', 'C2CD2/C2CD2L', 4, NULL),
(30319, NULL, 'IPR041648', NULL, 'Rank, cysteine-rich repeat domain 2', 'RANK_CRD_2', 3, NULL),
(30320, NULL, 'IPR038483', NULL, 'YcfL-like superfamily', 'YcfL-like_sf', 5, NULL),
(30321, NULL, 'IPR041692', NULL, 'HHH domain 9', 'HHH_9', 3, NULL),
(30322, NULL, 'IPR041956', NULL, 'ATX1/2, ePHD domain', 'ATX1/2_ePHD', 3, NULL),
(30323, NULL, 'IPR038185', NULL, 'MyTH4 domain superfamily', 'MyTH4_dom_sf', 5, NULL),
(30324, NULL, 'IPR041629', NULL, 'Bacterial SCP orthologue', 'SCP_3', 3, NULL),
(30325, NULL, 'IPR041714', NULL, 'Vitamin K epoxide reductase, Actinobacteria-type', 'VKOR_Actinobacteria', 3, NULL),
(30326, NULL, 'IPR041784', NULL, 'FAK1/PYK2, FERM domain C-lobe', 'FAK1/PYK2_FERM_C', 3, NULL),
(30327, NULL, 'IPR041553', NULL, 'Nuclear pore complex protein Nup214, phenylalanine-glycine (FG) domain', 'Nup214_FG', 3, NULL),
(30328, NULL, 'IPR038970', NULL, 'Polysaccharide lyase 8', 'Lyase_8', 4, NULL),
(30329, NULL, 'IPR041577', NULL, 'Reverse transcriptase/retrotransposon-derived protein, RNase H-like domain', 'RT_RNaseH_2', 3, NULL),
(30330, NULL, 'IPR041624', NULL, 'Rhamnogalacturonan I lyase beta-sheet domain', 'RGI_lyase', 3, NULL),
(30331, NULL, 'IPR041555', NULL, 'Macroglobulin domain MG3', 'MG3', 3, NULL),
(30332, NULL, 'IPR041507', NULL, 'Peptidase C12, C-terminal domain', 'UCH_C', 3, NULL),
(30333, NULL, 'IPR041955', NULL, 'ATX3/4/5, ePHD domain', 'ATX3/4/5_ePHD', 3, NULL),
(30334, NULL, 'IPR041927', NULL, 'UBAC1, UBA domain 2', 'UBA2_UBAC1', 3, NULL),
(30335, NULL, 'IPR036206', NULL, 'Thiamin phosphate synthase superfamily', 'ThiamineP_synth_sf', 5, NULL),
(30336, NULL, 'IPR037459', NULL, 'Rhamnogalacturonan acetylesterase RhgT-like', 'RhgT-like', 4, NULL),
(30337, NULL, 'IPR041476', NULL, 'TRAF3-interacting protein 1, C-terminal domain', 'TRAF3IP1_C', 3, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(30338, NULL, 'IPR041582', NULL, 'RimO, TRAM domain', 'RimO_TRAM', 3, NULL),
(30339, NULL, 'IPR041668', NULL, 'Rh5 coiled-coil domain', 'Rh5_CC', 3, NULL),
(30340, NULL, 'IPR041822', NULL, 'Rab33A/B', 'Rab33A/B', 4, NULL),
(30341, NULL, 'IPR041995', NULL, 'Kin17, KOW domain', 'KOW_KIN17', 3, NULL),
(30342, NULL, 'IPR041691', NULL, 'Atg6/beclin, coiled-coil domain', 'Atg6/beclin_CC', 3, NULL),
(30343, NULL, 'IPR042040', NULL, 'Protein transport protein Tip20, domain E', 'Tip20p_domE', 5, NULL),
(30344, NULL, 'IPR041415', NULL, 'BclA, C-terminal domain', 'BclA_C', 3, NULL),
(30345, NULL, 'IPR039721', NULL, 'D-glucuronyl C5-epimerase', 'C5-epimerase', 4, NULL),
(30346, NULL, 'IPR041888', NULL, 'ZN598/Hel2, RING finger', 'RING-HC_ZNF598/Hel2', 3, NULL),
(30347, NULL, 'IPR038110', NULL, 'Threonine dehydratase, ACT-like domain superfamily', 'TD_ACT-like_sf', 5, NULL),
(30348, NULL, 'IPR041959', NULL, 'KMT2B, ePHD domain', 'KMT2B_ePHD', 3, NULL),
(30349, NULL, 'IPR042013', NULL, 'PHF7/G2E3, ePHD domain', 'PHF7/G2E3_ePHD', 3, NULL),
(30350, NULL, 'IPR041242', NULL, 'Putative HNHc nuclease', 'HNHc_6', 4, NULL),
(30351, NULL, 'IPR041539', NULL, 'CxC5 like cysteine cluster associated with KDZ', 'CxC5', 3, NULL),
(30352, NULL, 'IPR033782', NULL, 'Domain of unknown function DUF5301', 'DUF5301', 4, NULL),
(30353, NULL, 'IPR039720', NULL, 'Transmembrane protein 94', 'TMEM94', 4, NULL),
(30354, NULL, 'IPR041890', NULL, 'Carbonic anhydrase VII', 'Alpha_CA_VII', 4, NULL),
(30355, NULL, 'IPR038963', NULL, 'Uncharacterized protein C17orf107', 'C17orf107', 4, NULL),
(30356, NULL, 'IPR042075', NULL, 'KorB DNA-binding domain', 'KorB_DNA-db', 5, NULL),
(30357, NULL, 'IPR038780', NULL, 'Uncharacterized protein C4orf3', 'C4orf3', 4, NULL),
(30358, NULL, 'IPR037902', NULL, 'NudC domain-containing protein 2, p23 domain', 'p23_NUDCD2', 3, NULL),
(30359, NULL, 'IPR042085', NULL, 'Alkaline phosphatase, crown domain', 'Ap_crown', 5, NULL),
(30360, NULL, 'IPR033775', NULL, 'Protein of unknown function (DUF5137)', 'DUF5137', 4, NULL),
(30361, NULL, 'IPR042091', NULL, 'Ska2, N-terminal', 'Ska2_N', 3, NULL),
(30362, NULL, 'IPR033724', NULL, 'PET testin', 'PET_testin', 3, NULL),
(30363, NULL, 'IPR039994', NULL, 'JmjC domain-containing', 'JmjC_protein', 4, NULL),
(30364, NULL, 'IPR040153', NULL, 'Respiratory supercomplex factor 2, mitochondrial', 'Rcf2', 4, NULL),
(30365, NULL, 'IPR034752', NULL, 'Mis18 domain', 'Mis18', 3, NULL),
(30366, NULL, 'IPR041260', NULL, 'Sld7 C-terminal domain', 'Sld7_C', 3, NULL),
(30367, NULL, 'IPR041986', NULL, 'ZZEF1, zinc finger, ZZ-type', 'ZZEF1_ZZ', 3, NULL),
(30368, NULL, 'IPR036512', NULL, 'Photosystem II PsbZ superfamily', 'PSII_PsbZ_sf', 5, NULL),
(30369, NULL, 'IPR038196', NULL, 'Mediator complex subunit 25, PTOV domain superfamily', 'Med25_PTOV_sf', 5, NULL),
(30370, NULL, 'IPR041510', NULL, 'Domain of unknown function DUF5523', 'DUF5523', 3, NULL),
(30371, NULL, 'IPR040144', NULL, 'Rap1 GTPase-GDP dissociation stimulator 1', 'RAP1GDS1', 4, NULL),
(30372, NULL, 'IPR038105', NULL, 'Kinesin-like protein Kif23, Arf6-interacting domain superfamily', 'Kif23_Arf-bd_sf', 5, NULL),
(30373, NULL, 'IPR041997', NULL, 'Ribosomal Protein L6, KOW domain', 'KOW_RPL6', 3, NULL),
(30374, NULL, 'IPR033795', NULL, 'Uncharacterised protein Clospo_01618-like', 'Clospo_01618-like', 3, NULL),
(30375, NULL, 'IPR038777', NULL, 'Uncharacterized protein At4g18490-like', 'At4g18490-like', 4, NULL),
(30376, NULL, 'IPR033401', NULL, 'Domain of unknown function DUF5108', 'DUF5108', 3, NULL),
(30377, NULL, 'IPR036505', NULL, 'N-acetylmuramoyl-L-alanine amidase/PGRP domain superfamily', 'Amidase/PGRP_sf', 5, NULL),
(30378, NULL, 'IPR041828', NULL, 'Rab24', 'Rab24', 4, NULL),
(30379, NULL, 'IPR041766', NULL, 'PA3087-like', 'PA3087-like', 4, NULL),
(30380, NULL, 'IPR041418', NULL, 'SAM domain', 'SAM_3', 3, NULL),
(30381, NULL, 'IPR041575', NULL, 'NADH-rubredoxin oxidoreductase, C-terminal', 'Rubredoxin_C', 3, NULL),
(30382, NULL, 'IPR038200', NULL, 'GW domain superfamily', 'GW_dom_sf', 5, NULL),
(30383, NULL, 'IPR041915', NULL, 'Tudor domain-containing protein 3, UBA domain', 'UBA_TDRD3', 3, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(30384, NULL, 'IPR041652', NULL, 'Domain of unknown function DUF5616', 'DUF5616', 3, NULL),
(30385, NULL, 'IPR041412', NULL, 'Xrn1, helical domain', 'Xrn1_helical', 3, NULL),
(30386, NULL, 'IPR042036', NULL, 'Ribosomal RNA-processing protein 8, N-terminal domain', 'RRP8_N', 5, NULL),
(30387, NULL, 'IPR036165', NULL, 'YefM-like superfamily', 'YefM-like_sf', 5, NULL),
(30388, NULL, 'IPR033828', NULL, 'CTP synthase GATase domain', 'GATase1_CTP_Synthase', 3, NULL),
(30389, NULL, 'IPR041937', NULL, 'SPRE, EVH1 domain', 'SPRE_EVH1', 3, NULL),
(30390, NULL, 'IPR036510', NULL, 'Ribosomal protein S20 superfamily', 'Ribosomal_S20_sf', 5, NULL),
(30391, NULL, 'IPR035551', NULL, 'Boi1/2, SH3 domain', 'Boi1/2_SH3', 3, NULL),
(30392, NULL, 'IPR040141', NULL, 'ZPR1 family', 'ZPR1', 4, NULL),
(30393, NULL, 'IPR041409', NULL, 'Restriction endonuclease AspBHI, N-terminal', 'RE_AspBHI_N', 3, NULL),
(30394, NULL, 'IPR035996', NULL, 'Tetrapyrrole methylase superfamily', '4pyrrol_Methylase_sf', 5, NULL),
(30395, NULL, 'IPR033779', NULL, 'Domain of unknown function (DUF5300)', 'DUF5300', 4, NULL),
(30396, NULL, 'IPR037898', NULL, 'NudC family', 'NudC_fam', 4, NULL),
(30397, NULL, 'IPR041448', NULL, 'Tumor necrosis factor receptor member 16, transmembrane domain', 'TNFR16_TM', 3, NULL),
(30398, NULL, 'IPR041672', NULL, 'Bap31/Bap29 cytoplasmic coiled-coil domain', 'Bap31/Bap29_C', 3, NULL),
(30399, NULL, 'IPR033713', NULL, 'Phosphatase NudJ', 'NudJ', 4, NULL),
(30400, NULL, 'IPR041693', NULL, 'Glycosyl-transferase family 4_5', 'Glyco_trans_4_5', 4, NULL),
(30401, NULL, 'IPR041750', NULL, 'Bifunctional NMN adenylyltransferase/Nudix hydrolase, N-terminal NMNAT domain', 'NMNAT_Nudix', 3, NULL),
(30402, NULL, 'IPR041961', NULL, 'KMT2D, ePHD1 domain', 'KMT2D_ePHD1', 3, NULL),
(30403, NULL, 'IPR042016', NULL, 'Apulose kinase', 'Apulose_kinase', 4, NULL),
(30404, NULL, 'IPR042060', NULL, 'Polycystin-1 like, PLAT/LH2 domain', 'PLAT_polycystin1', 3, NULL),
(30405, NULL, 'IPR041619', NULL, 'Nicotinate phosphoribosyltransferase C-terminal domain', 'NAPRTase_C', 3, NULL),
(30406, NULL, 'IPR041589', NULL, 'Dynein heavy chain 3, AAA+ lid domain', 'DNAH3_AAA_lid_1', 3, NULL),
(30407, NULL, 'IPR041820', NULL, 'Rab30', 'Rab30', 4, NULL),
(30408, NULL, 'IPR042042', NULL, 'Protein transport protein Tip20, domain B', 'Tip20p_domB', 5, NULL),
(30409, NULL, 'IPR040324', NULL, 'WD repeat-containing protein WDR44/Dgr2', 'WDR44/Dgr2', 4, NULL),
(30410, NULL, 'IPR033404', NULL, 'Domain of unknown function DUF5111', 'DUF5111', 3, NULL),
(30411, NULL, 'IPR041770', NULL, 'Frizzled 6, cysteine-rich domain', 'FZ6_CRD', 3, NULL),
(30412, NULL, 'IPR041698', NULL, 'Methyltransferase domain 25', 'Methyltransf_25', 3, NULL),
(30413, NULL, 'IPR041736', NULL, '4-hydroxyphenylpyruvate dioxygenase, N-terminal', '4OHPhenylPyrv_dOase_N', 3, NULL),
(30414, NULL, 'IPR036612', NULL, 'K Homology domain, type 1 superfamily', 'KH_dom_type_1_sf', 5, NULL),
(30415, NULL, 'IPR041461', NULL, 'CdvA-like coiled-coil domain', 'CdvA_CC', 3, NULL),
(30416, NULL, 'IPR041749', NULL, 'NadR, nicotinamide/nicotinate mononucleotide adenylyltransferase domain', 'NMNAT_NadR', 3, NULL),
(30417, NULL, 'IPR035758', NULL, 'NADPH oxidase organiser 1, second SH3 domain', 'NoxO1_SH3_2', 3, NULL),
(30418, NULL, 'IPR036001', NULL, 'Photosystem antenna protein-like superfamily', 'PS_II_antenna-like_sf', 5, NULL),
(30419, NULL, 'IPR036982', NULL, 'Deoxyhypusine synthase superfamily', 'Deoxyhypusine_synthase_sf', 5, NULL),
(30420, NULL, 'IPR042092', NULL, 'Pseudouridine synthase, RsuA/RluB/E/F, catalytic domain', 'PsdUridine_s_RsuA/RluB/E/F_cat', 5, NULL),
(30421, NULL, 'IPR033819', NULL, 'Saccharopepsin', 'Saccharopepsin', 3, NULL),
(30422, NULL, 'IPR038966', NULL, 'Translation machinery-associated protein 17', 'TMA17', 4, NULL),
(30423, NULL, 'IPR041232', NULL, 'Nucleoplasmin-like domain', 'NPL', 3, NULL),
(30424, NULL, 'IPR036973', NULL, 'Major capsid L1 (late) superfamily, Papillomavirus', 'Capsid_L1_sf_Papillomavir', 5, NULL),
(30425, NULL, 'IPR041463', NULL, 'LidA long coiled-coil domain', 'LidA_long_CC', 3, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(30426, NULL, 'IPR033647', NULL, 'AAR2, N-terminal', 'Aar2_N', 3, NULL),
(30427, NULL, 'IPR041920', NULL, 'ROS/MUCR transcriptional regulator superfamily', 'ROS/MUCR_sf', 5, NULL),
(30428, NULL, 'IPR041238', NULL, 'Rap1a immunity protein', 'Rap1a', 3, NULL),
(30429, NULL, 'IPR042032', NULL, 'Viral RNA-directed RNA polymerase, 4-helical domain', 'RNA-dir_pol_4-hel_dom', 5, NULL),
(30430, NULL, 'IPR035750', NULL, 'Fyn/Yrk, SH3 domain', 'Fyn/Yrk_SH3', 3, NULL),
(30431, NULL, 'IPR041416', NULL, 'IL-1Ra-like, immunoglobulin domain', 'IL-1RAcP-like_ig', 3, NULL),
(30432, NULL, 'IPR039910', NULL, 'Surface antigen D15-like', 'D15-like', 4, NULL),
(30433, NULL, 'IPR041671', NULL, 'Csm1 N-terminal domain', 'Csm1_N', 3, NULL),
(30434, NULL, 'IPR033723', NULL, 'PET prickle', 'PET_prickle', 3, NULL),
(30435, NULL, 'IPR041452', NULL, 'APAF-1 helical domain', 'APAF1_C', 3, NULL),
(30436, NULL, 'IPR041886', NULL, 'Protein C-ets-1, pointed domain', 'SAM_PNT-ETS-1', 3, NULL),
(30437, NULL, 'IPR041322', NULL, 'Synaptonemal complex protein 2, armadillo-repeat-like domain', 'SYCP2_ARLD', 3, NULL),
(30438, NULL, 'IPR041762', NULL, 'Corin, cysteine-rich domain 1', 'Corin_CRD_1', 3, NULL),
(30439, NULL, 'IPR041506', NULL, 'Domain of unknown function DUF5645', 'DUF5645', 3, NULL),
(30440, NULL, 'IPR033704', NULL, 'dUTPase, trimeric', 'dUTPase_trimeric', 3, NULL),
(30441, NULL, 'IPR038484', NULL, 'MucB/RseB, C-terminal domain superfamily', 'MucB/RseB_C_sf', 5, NULL),
(30442, NULL, 'IPR041994', NULL, 'G-patch domain and KOW motifs-containing protein, KOW 2', 'GPKOW_KOW2', 3, NULL),
(30443, NULL, 'IPR041581', NULL, 'Glyoxalase-like domain, group 6', 'Glyoxalase_6', 3, NULL),
(30444, NULL, 'IPR041690', NULL, 'Cadherin-like domain', 'Cadherin_5', 3, NULL),
(30445, NULL, 'IPR035757', NULL, 'Neutrophil cytosol factor 1, second SH3 domain', 'NCF1_SH3_2', 3, NULL),
(30446, NULL, 'IPR041326', NULL, 'Tk-SP N-propeptide domain', 'Tk-SP_N-pro', 3, NULL),
(30447, NULL, 'IPR041634', NULL, 'Nuclear pore protein Nup188, C-terminal', 'Nup188_C', 3, NULL),
(30448, NULL, 'IPR035760', NULL, 'Voltage-dependent L-type calcium channel subunit beta-3, SH3 domain', 'CACNB3_SH3', 3, NULL),
(30449, NULL, 'IPR036974', NULL, 'PUA domain superfamily', 'PUA_sf', 5, NULL),
(30450, NULL, 'IPR038168', NULL, 'Transcription factor DP, C-terminal domain superfamily', 'TF_DP_C_sf', 5, NULL),
(30451, NULL, 'IPR042086', NULL, 'Methyltransferase, alpha-helical capping domain', 'MeTrfase_capping', 5, NULL),
(30452, NULL, 'IPR041772', NULL, 'Sizzled, cysteine-rich domain', 'Sizzled_CRD', 3, NULL),
(30453, NULL, 'IPR041989', NULL, 'TOPK, catalytic domain', 'PKc_TOPK', 3, NULL),
(30454, NULL, 'IPR036513', NULL, 'STAS domain superfamily', 'STAS_dom_sf', 5, NULL),
(30455, NULL, 'IPR041689', NULL, 'Gamma-aminobutyric acid type B receptor subunit 2, coiled-coil domain', 'GBR2_CC', 3, NULL),
(30456, NULL, 'IPR041636', NULL, 'Ribonuclease J, C-terminal', 'RNase_J_C', 3, NULL),
(30457, NULL, 'IPR040150', NULL, 'RNA polymerase II nuclear localization protein Iwr1', 'Iwr1', 4, NULL),
(30458, NULL, 'IPR042005', NULL, 'BRPF3, ePHD domain', 'BRPF3_ePHD', 3, NULL),
(30459, NULL, 'IPR033798', NULL, 'Uncharacterised protein, LodA-like', 'LodA-like', 3, NULL),
(30460, NULL, 'IPR038118', NULL, 'Bypass-of-forespore C, N-terminal domain superfamily', 'BOFC_N_sf', 5, NULL),
(30461, NULL, 'IPR041894', NULL, 'ProX-like, substrate-binding domain', 'PBP2_ProX-like', 3, NULL),
(30462, NULL, 'IPR041618', NULL, 'Polyketide synthase dimerisation element domain', 'PKS_DE', 3, NULL),
(30463, NULL, 'IPR033388', NULL, 'SWI/SNF-like complex subunit BAF250, C-terminal', 'BAF250_C', 3, NULL),
(30464, NULL, 'IPR038958', NULL, 'Protein plastid transcriptionally active 7', 'PTAC7', 4, NULL),
(30465, NULL, 'IPR041743', NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase, N-terminal catalytic domain', 'AK-HSDH_N', 3, NULL),
(30466, NULL, 'IPR033898', NULL, 'DNA-directed RNA polymerases I and III subunit AC19', 'RNAP_AC19', 4, NULL),
(30467, NULL, 'IPR037393', NULL, 'Bud22/Serum response factor-binding protein 1', 'Bud22/SRFB1', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(30468, NULL, 'IPR037721', NULL, 'Ferlin  family', 'Ferlin', 4, NULL),
(30469, NULL, 'IPR041573', NULL, 'Desmoplakin, spectrin-like domain', 'Desmoplakin_Spectrin-like', 3, NULL),
(30470, NULL, 'IPR041572', NULL, 'Laterosporulin defensin-like peptide', 'Laterosporulin', 4, NULL),
(30471, NULL, 'IPR038094', NULL, 'Desulfoferrodoxin, N-terminal domain superfamily', 'Desulfoferrodoxin_N_sf', 5, NULL),
(30472, NULL, 'IPR041830', NULL, 'Rab12', 'Rab12', 4, NULL),
(30473, NULL, 'IPR041325', NULL, 'Protein glutaminase', 'Gln_deamidase_2', 3, NULL),
(30474, NULL, 'IPR035751', NULL, 'Tyrosine-protein kinase Yes, SH3 domain', 'Yes_SH3', 3, NULL),
(30475, NULL, 'IPR042010', NULL, 'ATX1/2, PHD domain', 'ATX1/2_PHD', 3, NULL),
(30476, NULL, 'IPR041745', NULL, 'Lysine-sensitive aspartokinase 3, N-terminal catalytic domain', 'AKiii-LysC-EC', 3, NULL),
(30477, NULL, 'IPR041239', NULL, 'Domain of unknown function DUF5605', 'DUF5605', 3, NULL),
(30478, NULL, 'IPR036535', NULL, 'STAT transcription factor, N-terminal domain superfamily', 'STAT_N_sf', 5, NULL),
(30479, NULL, 'IPR041569', NULL, 'AAA ATPase, AAA+ lid domain', 'AAA_lid_3', 3, NULL),
(30480, NULL, 'IPR038485', NULL, 'Protein Z, RING-type zinc finger superfamily', 'Z_RING-type_Znf_sf', 5, NULL),
(30481, NULL, 'IPR034123', NULL, 'RBM6, RNA recognition motif 1', 'RBM6_RRM1', 3, NULL),
(30482, NULL, 'IPR041713', NULL, 'PTS system lactose-specific EIICB component, IIB domain', 'PTS_IIB', 3, NULL),
(30483, NULL, 'IPR039993', NULL, 'NADH dehydrogenase [ubiquinone] 1 beta subcomplex subunit 10', 'NDUFB10', 4, NULL),
(30484, NULL, 'IPR041906', NULL, 'Ribosomal S6 kinase, N-terminal catalytic domain', 'RSK_N', 3, NULL),
(30485, NULL, 'IPR041696', NULL, 'Bacteroidetes PKD-like domain', 'PKD_3', 3, NULL),
(30486, NULL, 'IPR041760', NULL, 'SFRP1, cysteine-rich domain', 'SFRP1_CRD', 3, NULL),
(30487, NULL, 'IPR041682', NULL, 'AAA domain, group 14', 'AAA_14', 3, NULL),
(30488, NULL, 'IPR036553', NULL, 'RNA 3''-terminal phosphate cyclase, insert domain superfamily', 'RPTC_insert', 5, NULL),
(30489, NULL, 'IPR042050', NULL, 'Endoplasmic reticulum chaperone BIP, nucleotide-binding domain', 'BIP_NBD', 3, NULL),
(30490, NULL, 'IPR035999', NULL, 'Sec7 domain superfamily', 'Sec7_dom_sf', 5, NULL),
(30491, NULL, 'IPR037802', NULL, 'SAGA-associated factor 29', 'SGF29', 4, NULL),
(30492, NULL, 'IPR039989', NULL, 'ADP-ribose pyrophosphatase, mitochondrial', 'NUDT9', 4, NULL),
(30493, NULL, 'IPR036508', NULL, 'Chitin binding domain superfamily', 'Chitin-bd_dom_sf', 5, NULL),
(30494, NULL, 'IPR042037', NULL, 'MukE, C-terminal domain', 'MukE_C', 5, NULL),
(30495, NULL, 'IPR041571', NULL, 'Protein of unknown function DUF5576', 'DUF5576', 4, NULL),
(30496, NULL, 'IPR033778', NULL, 'Cuticle protein CPCFC', 'CPCFC', 3, NULL),
(30497, NULL, 'IPR041933', NULL, 'BIRC2/BIRC3, UBA domain', 'BIRC2/BIRC3_UBA', 3, NULL),
(30498, NULL, 'IPR038112', NULL, 'Protein-tyrosine phosphatase receptor IA-2,  ectodomain superfamily', 'Receptor_IA-2_ectodomain_sf', 5, NULL),
(30499, NULL, 'IPR038962', NULL, 'Transmembrane protein 158', 'TMEM158', 4, NULL),
(30500, NULL, 'IPR041444', NULL, 'YhfZ, helix-turn-helix domain', 'HTH_41', 3, NULL),
(30501, NULL, 'IPR037612', NULL, 'Tumour protein p73, SAM domain', 'Tumour-p73_SAM', 3, NULL),
(30502, NULL, 'IPR042023', NULL, 'KMT2A, PHD domain 1', 'KMT2A_PHD1', 3, NULL),
(30503, NULL, 'IPR041430', NULL, 'ATRX, ADD domain', 'ADD_ATRX', 3, NULL),
(30504, NULL, 'IPR039441', NULL, 'AsmA-like C-terminal region', 'AsmA-like_C', 3, NULL),
(30505, NULL, 'IPR034457', NULL, 'Organic radical-activating enzymes', 'Organic_radical-activating', 4, NULL),
(30506, NULL, 'IPR041753', NULL, 'PP5, C-terminal metallophosphatase domain', 'PP5_C', 3, NULL),
(30507, NULL, 'IPR033839', NULL, 'Lacticin 481 processing peptidase', 'Lacticin_481_peptidase', 3, NULL),
(30508, NULL, 'IPR035761', NULL, 'Ryanodine receptor, SPRY domain 1', 'SPRY1_RyR', 3, NULL),
(30509, NULL, 'IPR042100', NULL, 'Bordetella uptake gene, domain 1', 'Bug_dom1', 5, NULL),
(30510, NULL, 'IPR038706', NULL, 'Type VI secretion protein SciN-like superfamily', 'Type_VI_SciN-like_sf', 5, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(30511, NULL, 'IPR038566', NULL, 'Mediator complex, subunit Med6 superfamily', 'Mediator_Med6_sf', 5, NULL),
(30512, NULL, 'IPR041710', NULL, 'HPS/KGPDC domain', 'HPS/KGPDC', 3, NULL),
(30513, NULL, 'IPR037844', NULL, 'ASAP, PH domain', 'PH_ASAP', 3, NULL),
(30514, NULL, 'IPR033887', NULL, 'PTS system mannose/sorbose specific IIA subunit', 'PTS_IIA_man', 3, NULL),
(30515, NULL, 'IPR038991', NULL, 'Caspase activity and apoptosis inhibitor 1', 'CAAP1', 4, NULL),
(30516, NULL, 'IPR038060', NULL, 'KICSTOR complex protein C12orf66-like, central domain superfamily', 'C12orf66-like_central_sf', 5, NULL),
(30517, NULL, 'IPR040163', NULL, 'RP1/RP1L1/DCX', 'RP1/RP1L1/DCX', 4, NULL),
(30518, NULL, 'IPR042015', NULL, 'MTF2, PHD domain 2', 'MTF2_PHD2', 3, NULL),
(30519, NULL, 'IPR033121', NULL, 'Peptidase family A1 domain', 'PEPTIDASE_A1', 3, NULL),
(30520, NULL, 'IPR041603', NULL, 'YvdT, C-terminal', 'YvdT_C', 3, NULL),
(30521, NULL, 'IPR036948', NULL, 'Ribosomal protein L21 superfamily', 'Ribosomal_L21_sf', 5, NULL),
(30522, NULL, 'IPR041779', NULL, 'FERM and PDZ domain-containing protein 1/3/4, FERM domain C-lobe', 'FRMPD1/3/4_FERM_C', 3, NULL),
(30523, NULL, 'IPR036632', NULL, 'Scaffold protein D superfamily', 'Scaffold_D_sf', 5, NULL),
(30524, NULL, 'IPR041602', NULL, 'Quercetin 2,3-dioxygenase, C-terminal cupin domain', 'Quercetinase_C', 3, NULL),
(30525, NULL, 'IPR038160', NULL, '6-Cysteine (6-Cys) domain superfamily', '6_CYS_dom_sf', 5, NULL),
(30526, NULL, 'IPR035356', NULL, 'Lacto-N-biose phosphorylase, C-terminal domain', 'LBP_C', 3, NULL),
(30527, NULL, 'IPR035678', NULL, 'srGAP4, SH3 domain', 'srGAP4_SH3', 3, NULL),
(30528, NULL, 'IPR041951', NULL, 'STARD10, START domain', 'STARD10_START', 3, NULL),
(30529, NULL, 'IPR037614', NULL, 'Kazrin', 'Kazrin', 4, NULL),
(30530, NULL, 'IPR041773', NULL, 'Crescent, cysteine-rich domain', 'Crescent_CRD', 3, NULL),
(30531, NULL, 'IPR038823', NULL, 'Mediator-associated protein 2, plant', 'MED2_plant', 4, NULL),
(30532, NULL, 'IPR041330', NULL, 'KN17, SH3-like C-terminal domain', 'KN17_SH3', 3, NULL),
(30533, NULL, 'IPR035350', NULL, 'Protein of unknown function DUF5400', 'DUF5400', 4, NULL),
(30534, NULL, 'IPR038824', NULL, 'Protein shortage in chiasmata 1-like', 'SHOC1-like', 4, NULL),
(30535, NULL, 'IPR037830', NULL, 'ZZ-type zinc finger-containing protein 3', 'ZZZ3', 4, NULL),
(30536, NULL, 'IPR033872', NULL, 'Non-specific lipid-transfer protein type 2', 'nsLTP2', 3, NULL),
(30537, NULL, 'IPR038952', NULL, 'Protein TOPAZ1', 'TOPAZ1', 4, NULL),
(30538, NULL, 'IPR036650', NULL, 'CAT RNA-binding domain superfamily', 'CAT_RNA-bd_dom_sf', 5, NULL),
(30539, NULL, 'IPR038709', NULL, 'RNA polymerase sigma-54 factor, core-binding domain superfamily', 'RpoN_core-bd_sf', 5, NULL),
(30540, NULL, 'IPR041846', NULL, 'Early nodulin-like protein domain', 'ENL_dom', 3, NULL),
(30541, NULL, 'IPR041813', NULL, 'Alpha-2-macroglobulin, TED domain', 'A2M_TED', 3, NULL),
(30542, NULL, 'IPR038830', NULL, 'Coiled-coil domain-containing protein 186', 'CCDC186', 4, NULL),
(30543, NULL, 'IPR037607', NULL, 'Diacylglycerol kinase', 'DGK', 4, NULL),
(30544, NULL, 'IPR041883', NULL, 'PilM protein, N-terminal domain', 'PilM_N-ter', 5, NULL),
(30545, NULL, 'IPR036648', NULL, 'Nitrile hydratase alpha /Thiocyanate hydrolase gamma superfamily', 'CN_Hdrase_a/SCN_Hdrase_g_sf', 5, NULL),
(30546, NULL, 'IPR041887', NULL, 'Receptor-type tyrosine-protein phosphatase, carbonic anhydrase domain', 'Alpha_CARP_receptor-type', 3, NULL),
(30547, NULL, 'IPR038573', NULL, 'Ribonuclease toxin BrnT superfamily', 'BrnT_sf', 5, NULL),
(30548, NULL, 'IPR033740', NULL, 'Aminopeptidase P', 'Pept_M24B', 3, NULL),
(30549, NULL, 'IPR041806', NULL, 'Polyadenylate-binding protein-interacting protein 5/6/7, CUE domain', 'CID5/6/7_CUE', 3, NULL),
(30550, NULL, 'IPR041568', NULL, 'TcA receptor binding domain', 'TcA_RBD', 3, NULL),
(30551, NULL, 'IPR041877', NULL, 'Carbonic anhydrase-related protein VIII', 'CARP_VIII', 4, NULL),
(30552, NULL, 'IPR038839', NULL, 'AT hook-containing protein attf-4-like', 'Attf-4-like', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(30553, NULL, 'IPR041934', NULL, 'NAD glycohydrolase, helical linker domain', 'NAD_glyco_helical_dom', 5, NULL),
(30554, NULL, 'IPR036639', NULL, 'Cytochrome c oxidase subunit IV superfamily', 'Cyt_c_oxidase_su4_sf', 5, NULL),
(30555, NULL, 'IPR041929', NULL, 'Tetrathionate reductase subunit A, N-terminal', 'Tetrathionate-R_A_N', 3, NULL),
(30556, NULL, 'IPR038990', NULL, 'LBH domain', 'LBH_dom', 3, NULL),
(30557, NULL, 'IPR041833', NULL, 'Rab21', 'Rab21', 4, NULL),
(30558, NULL, 'IPR041549', NULL, 'Immunomodulating metalloprotease helical domain', 'IMPa_helical', 3, NULL),
(30559, NULL, 'IPR034405', NULL, 'F420, menaquinone cofactor biosynthesis', 'F420', 4, NULL),
(30560, NULL, 'IPR036642', NULL, 'Cytochrome b-c1 complex subunit 8 superfamily', 'Cyt_bc1_su8_sf', 5, NULL),
(30561, NULL, 'IPR041776', NULL, 'Frizzled 8, cysteine-rich domain', 'FZ8_CRD', 3, NULL),
(30562, NULL, 'IPR038817', NULL, 'Coiled-coil domain-containing protein 192', 'CCDC192', 4, NULL),
(30563, NULL, 'IPR037883', NULL, 'Knr4/Smi1-like domain superfamily', 'Knr4/Smi1-like_sf', 5, NULL),
(30564, NULL, 'IPR041885', NULL, 'MAN1, winged-helix domain', 'MAN1_winged_helix_dom', 5, NULL),
(30565, NULL, 'IPR041797', NULL, 'Myosin X, FERM domain C-lobe', 'MyoX_FERM_C', 3, NULL),
(30566, NULL, 'IPR042090', NULL, 'tRNA nucleotidyltransferase, domain 2', 'CCA_tRNA_nucleotrans_2', 5, NULL),
(30567, NULL, 'IPR039325', NULL, 'Nodulin homeobox protein', 'NDX', 4, NULL),
(30568, NULL, 'IPR036628', NULL, 'Clp, N-terminal domain superfamily', 'Clp_N_dom_sf', 5, NULL),
(30569, NULL, 'IPR034653', NULL, 'SPF45, RNA recognition motif', 'SPF45_RRM', 3, NULL),
(30570, NULL, 'IPR037284', NULL, 'SUF system FeS cluster assembly, SufBD superfamily', 'SUF_FeS_clus_asmbl_SufBD_sf', 5, NULL),
(30571, NULL, 'IPR036950', NULL, 'Penicillin binding protein transglycosylase domain', 'PBP_transglycosylase', 5, NULL),
(30572, NULL, 'IPR038243', NULL, 'Spidroin, N-terminal domain superfamily', 'Spidroin_N_sf', 5, NULL),
(30573, NULL, 'IPR041560', NULL, 'FMR1, tudor domain', 'Tudor_FRM1', 3, NULL),
(30574, NULL, 'IPR042020', NULL, 'ING3, PHD domain', 'ING3_PHD', 3, NULL),
(30575, NULL, 'IPR041613', NULL, 'Peptidase S41, N-terminal', 'Pept_S41_N', 3, NULL),
(30576, NULL, 'IPR041547', NULL, 'C->U-editing enzyme APOBEC-1', 'APOBEC1', 4, NULL),
(30577, NULL, 'IPR042017', NULL, 'PHF19, PHD domain 2', 'PHF19_PHD2', 3, NULL),
(30578, NULL, 'IPR041968', NULL, 'KMT2C, ePHD2', 'KMT2C_ePHD2', 3, NULL),
(30579, NULL, 'IPR041946', NULL, 'GPR156, 7TM domain', 'GPR156_7TM', 3, NULL),
(30580, NULL, 'IPR038876', NULL, 'Ecto-NOX disulfide-thiol exchanger', 'ENOX', 4, NULL),
(30581, NULL, 'IPR037771', NULL, 'WWC, C2 domain', 'C2_WWC', 3, NULL),
(30582, NULL, 'IPR041611', NULL, 'SKICH domain', 'SKICH', 3, NULL),
(30583, NULL, 'IPR041821', NULL, 'CG11883-like, N-terminal metallophosphatase domain', 'CG11883_N', 3, NULL),
(30584, NULL, 'IPR041709', NULL, 'Elongation factor Tu (EF-Tu), GTP-binding domain', 'EF-Tu_GTP-bd', 3, NULL),
(30585, NULL, 'IPR041419', NULL, 'TnsE, C-terminal', 'TnsE_C', 3, NULL),
(30586, NULL, 'IPR034462', NULL, 'Benzylsuccinate synthase activase', 'Benzylsuc_synthase_activase', 4, NULL),
(30587, NULL, 'IPR036156', NULL, 'Beta-Galactosidase/glucuronidase domain superfamily', 'Beta-gal/glucu_dom_sf', 5, NULL),
(30588, NULL, 'IPR033825', NULL, 'FACT complex subunit Spt16, peptidase M24-like domain', 'Spt16_M24', 3, NULL),
(30589, NULL, 'IPR041783', NULL, 'PTPN3/4, FERM domain C-lobe', 'PTPN3/4_FERM_C', 3, NULL),
(30590, NULL, 'IPR041795', NULL, 'Myosin-XV, FERM domain C-lobe', 'MyoXV_FERM_C', 3, NULL),
(30591, NULL, 'IPR041908', NULL, 'CtsR, C-terminal domain superfamily', 'CtsR_C_sf', 5, NULL),
(30592, NULL, 'IPR035362', NULL, 'Protein KleE', 'KleE', 4, NULL),
(30593, NULL, 'IPR038932', NULL, 'PCNA-interacting partner', 'PARPBP', 4, NULL),
(30594, NULL, 'IPR038977', NULL, 'Zinc finger protein 428', 'ZNF428', 4, NULL),
(30595, NULL, 'IPR038851', NULL, 'Ras-related protein Rap1', 'Rap1', 4, NULL),
(30596, NULL, 'IPR033863', NULL, 'Scytalidoglutamic peptidase', 'Scytalidoglutamic_peptidase', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(30597, NULL, 'IPR042024', NULL, 'D-xylulose kinase', 'D-XK_euk', 4, NULL),
(30598, NULL, 'IPR039004', NULL, 'Carnitine monooxygenase oxygenase subunit', 'Carnitine_monoox_A', 4, NULL),
(30599, NULL, 'IPR038143', NULL, 'NigD-like, C-terminal domain superfamily', 'NigD-like_C_dom_sf', 5, NULL),
(30600, NULL, 'IPR035676', NULL, 'SH2 adaptor protein C, SH2 domain', 'SHC_SH2', 3, NULL),
(30601, NULL, 'IPR041949', NULL, 'STARD7, START domain', 'START_STARD7', 3, NULL),
(30602, NULL, 'IPR033419', NULL, 'Gammaproteobacterial periplasmic sensor domain GAPES3', 'GAPES3', 3, NULL),
(30603, NULL, 'IPR041855', NULL, 'Lysin B, C-terminal linker domain', 'Lysin_B_C_ter', 5, NULL),
(30604, NULL, 'IPR038840', NULL, 'RWD domain-containing protein 3', 'RWDD3', 4, NULL),
(30605, NULL, 'IPR041664', NULL, 'Orc1-like, AAA ATPase domain', 'AAA_16', 3, NULL),
(30606, NULL, 'IPR036626', NULL, 'Head-to-tail joining protein W superfamily', 'GpW_sf', 5, NULL),
(30607, NULL, 'IPR041329', NULL, 'YubB, ferredoxin-like domain', 'YubB_C', 3, NULL),
(30608, NULL, 'IPR041996', NULL, 'FAM83H, N-terminal phospholipase D-like domain', 'PLDc_FAM83H_N', 3, NULL),
(30609, NULL, 'IPR038140', NULL, 'DotD superfamily', 'DotD_sf', 5, NULL),
(30610, NULL, 'IPR036952', NULL, 'Parvovirus coat protein VP1/VP2', 'VP1/VP2', 5, NULL),
(30611, NULL, 'IPR037609', NULL, 'Stromal interaction molecule 1, SAM domain', 'STIM1_SAM', 3, NULL),
(30612, NULL, 'IPR038071', NULL, 'UROD/MetE-like superfamily', 'UROD/MetE-like_sf', 5, NULL),
(30613, NULL, 'IPR038954', NULL, 'Casein kinase II subunit alpha''-interacting protein', 'CSNKA2IP', 4, NULL),
(30614, NULL, 'IPR039277', NULL, 'Transcription factor VOZ1/VOZ2', 'VOZ1/VOZ2', 4, NULL),
(30615, NULL, 'IPR041546', NULL, 'ClpA/ClpB, AAA lid domain', 'ClpA/ClpB_AAA_lid', 3, NULL),
(30616, NULL, 'IPR038951', NULL, 'Outer envelope pore protein 37-like', 'OEP37-like', 4, NULL),
(30617, NULL, 'IPR042003', NULL, 'Sortase E', 'Sortase_E', 4, NULL),
(30618, NULL, 'IPR037800', NULL, 'Histone acetyltransferase GCN5', 'GCN5', 4, NULL),
(30619, NULL, 'IPR041479', NULL, 'TetR transcriptional regulator CgmR-like, C-terminal domain', 'TetR_CgmR_C', 3, NULL),
(30620, NULL, 'IPR038988', NULL, 'Something about silencing protein 4', 'Sas4', 4, NULL),
(30621, NULL, 'IPR041808', NULL, 'CUE domain-containing protein 3, CUE domain', 'Cue3_CUE', 3, NULL),
(30622, NULL, 'IPR041754', NULL, 'PP7, metallophosphatase domain', 'MPP_PP7', 3, NULL),
(30623, NULL, 'IPR039276', NULL, 'Protein SAWADEE HOMEODOMAIN HOMOLOG 1/2', 'SHH1/2', 4, NULL),
(30624, NULL, 'IPR038757', NULL, 'Bombesin receptor-activated protein', 'BRAP', 4, NULL),
(30625, NULL, 'IPR037700', NULL, 'Nucleoporin NUP88/NUP82', 'NUP88/NUP82', 4, NULL),
(30626, NULL, 'IPR033362', NULL, 'SSNA1 family', 'SSNA1_fam', 4, NULL),
(30627, NULL, 'IPR038877', NULL, 'Thrombospondin type-1 domain-containing protein 1', 'THSD1', 4, NULL),
(30628, NULL, 'IPR035349', NULL, 'Meiotic recombination protein Rec104', 'Rec104', 4, NULL),
(30629, NULL, 'IPR039368', NULL, 'Acetolactate synthase large subunit, TPP binding domain', 'AHAS_TPP', 3, NULL),
(30630, NULL, 'IPR041930', NULL, 'Acetylene hydratase', 'Acetylene_hydratase', 3, NULL),
(30631, NULL, 'IPR038903', NULL, 'Allergen Asp f 4', 'Allergen_Asp_f_4', 4, NULL),
(30632, NULL, 'IPR039274', NULL, 'Flowering-promoting factor 1', 'FPF1', 4, NULL),
(30633, NULL, 'IPR038985', NULL, 'OPENER-like', 'OPRN-like', 4, NULL),
(30634, NULL, 'IPR038969', NULL, 'Flap endonuclease', 'FEN', 4, NULL),
(30635, NULL, 'IPR035143', NULL, 'Protein of unknown function DUF5483', 'DUF5483', 4, NULL),
(30636, NULL, 'IPR036263', NULL, 'Chorismate mutase type II superfamily', 'Chorismate_II_sf', 5, NULL),
(30637, NULL, 'IPR041952', NULL, 'STARD11, START domain', 'STARD11_START', 3, NULL),
(30638, NULL, 'IPR038716', NULL, 'Ribosomal protein P1/P2, N-terminal domain', 'P1/P2_N_sf', 5, NULL),
(30639, NULL, 'IPR041936', NULL, 'HetR, N-terminal DNA-binding domain', 'HetR_DNA-bd_N', 5, NULL),
(30640, NULL, 'IPR038879', NULL, 'Golgi-associated PDZ and coiled-coil motif-containing protein', 'GOPC', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(30641, NULL, 'IPR038953', NULL, 'Putative C->U-editing enzyme APOBEC-4', 'APOBEC4', 4, NULL),
(30642, NULL, 'IPR042039', NULL, 'HscA chaperone, nucleotide-binding domain', 'HscA_NBD', 3, NULL),
(30643, NULL, 'IPR041976', NULL, 'Spt5, KOW domain repeat 3', 'KOW_Spt5_3', 3, NULL),
(30644, NULL, 'IPR041706', NULL, 'YchF, N-terminal', 'YchF_N', 3, NULL),
(30645, NULL, 'IPR041739', NULL, 'Glutamate-5-kinase domain', 'G5K_ProB', 3, NULL),
(30646, NULL, 'IPR036168', NULL, 'AP-2 complex subunit mu, C-terminal superfamily', 'AP2_Mu_C_sf', 5, NULL),
(30647, NULL, 'IPR039265', NULL, 'Putative lipid-transfer protein DIR1-like', 'DIR1-like', 4, NULL),
(30648, NULL, 'IPR038976', NULL, 'Protein snakeskin', 'Ssk', 4, NULL),
(30649, NULL, 'IPR038753', NULL, 'NF-kappa-B inhibitor-like protein 1', 'NFKBIL1', 4, NULL),
(30650, NULL, 'IPR041802', NULL, 'YfcE-like, metallophosphatase domain', 'MPP_YfcE', 3, NULL),
(30651, NULL, 'IPR041881', NULL, 'Coenzyme PQQ synthesis protein D superfamily', 'PqqD_sf', 5, NULL),
(30652, NULL, 'IPR033641', NULL, 'CRISPR-associated protein Cas1, type I-E', 'Cas1_I-E', 4, NULL),
(30653, NULL, 'IPR034371', NULL, 'UHMK1, RNA recognition motif', 'UHMK1_RRM', 3, NULL),
(30654, NULL, 'IPR041935', NULL, 'HetR, flap domain', 'HetR_flap', 5, NULL),
(30655, NULL, 'IPR036157', NULL, 'dUTPase-like superfamily', 'dUTPase-like_sf', 5, NULL),
(30656, NULL, 'IPR038201', NULL, 'PrgU-like superfamily', 'PrgU-like_sf', 5, NULL),
(30657, NULL, 'IPR037450', NULL, 'Sulphur relay, TusC', 'Sulphur_relay_TusC', 4, NULL),
(30658, NULL, 'IPR033420', NULL, 'Gammaproteobacterial periplasmic sensor domain GAPES1', 'GAPES1', 3, NULL),
(30659, NULL, 'IPR041780', NULL, 'PrpE-like, metallophosphatase domain', 'MPP_PrpE-like', 3, NULL),
(30660, NULL, 'IPR036647', NULL, 'GTF2I-like repeat superfamily', 'GTF2I-like_rpt_sf', 5, NULL),
(30661, NULL, 'IPR035142', NULL, 'Cytomegalovirus UL20', 'UL20', 4, NULL),
(30662, NULL, 'IPR041973', NULL, 'Spt5, KOW domain repeat 1', 'KOW_Spt5_1', 3, NULL),
(30663, NULL, 'IPR041950', NULL, 'STARD2, START domain', 'STARD2_START', 3, NULL),
(30664, NULL, 'IPR041428', NULL, 'Syntrophin, split Pleckstrin homology (PH) domain', 'PHsplit_syntrophin', 3, NULL),
(30665, NULL, 'IPR038161', NULL, 'VirB9/CagX/TrbG, C-terminal domain superfamily', 'VirB9/CagX/TrbG_C_sf', 5, NULL),
(30666, NULL, 'IPR041978', NULL, 'Spt5, KOW domain repeat 5', 'KOW_Spt5_5', 3, NULL),
(30667, NULL, 'IPR041832', NULL, 'Synechococcus PhoA, N-terminal metallophosphatase domain', 'PhoA_N', 3, NULL),
(30668, NULL, 'IPR037616', NULL, 'Kazrin, SAM domain repeat 3', 'Kazrin_SAM_rpt_3', 3, NULL),
(30669, NULL, 'IPR041867', NULL, 'CPPED1, metallophosphatase domain', 'MPP_CSTP1', 3, NULL),
(30670, NULL, 'IPR041844', NULL, 'Plantacyanin', 'Plantacyanin', 4, NULL),
(30671, NULL, 'IPR041702', NULL, 'Magnesium-chelatase BchD/ChlD, VWA domain', 'BchD/ChlD_VWA', 3, NULL),
(30672, NULL, 'IPR034237', NULL, 'FOX1, RNA recognition motif', 'FOX1_RRM', 3, NULL),
(30673, NULL, 'IPR040160', NULL, 'Eukaryotic translation initiation factor 4E-binding protein Mextli', 'Mxt', 4, NULL),
(30674, NULL, 'IPR039447', NULL, 'Urease accessory protein UreH-like, transmembrane domain', 'UreH-like_TM_dom', 3, NULL),
(30675, NULL, 'IPR035754', NULL, 'SPRY domain-containing SOCS box protein 3, SPRY domain', 'SPRY_SPSB3', 3, NULL),
(30676, NULL, 'IPR041426', NULL, 'Mos1 transposase, HTH domain', 'Mos1_HTH', 3, NULL),
(30677, NULL, 'IPR041932', NULL, 'Phenylacetyl-CoA:acceptor oxidoreductase, N-terminal', 'Phenylacetyl-CoA-OR_N', 3, NULL),
(30678, NULL, 'IPR041740', NULL, 'Aspartokinase catalytic domain', 'AKii-LysC-BS', 3, NULL),
(30679, NULL, 'IPR041938', NULL, 'Histone-lysine N-methyltransferase, N-terminal domain', 'Hist-Lys_N-MTase_N', 5, NULL),
(30680, NULL, 'IPR042104', NULL, 'Polyketide synthase, dehydratase domain superfamily', 'PKS_dehydratase_sf', 5, NULL),
(30681, NULL, 'IPR033878', NULL, 'Oxygen-insensitive NAD(P)H nitroreductase NfsB-like', 'NfsB-like', 3, NULL),
(30682, NULL, 'IPR041983', NULL, 'ADA2-like, zinc finger, ZZ-type', 'ADA2-like_ZZ', 3, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(30683, NULL, 'IPR042019', NULL, 'ING2, PHD domain', 'ING2_PHD', 3, NULL),
(30684, NULL, 'IPR041901', NULL, 'Rpa43, N-terminal ribonucleoprotein (RNP) domain', 'RNAP_I_Rpa43_N', 3, NULL),
(30685, NULL, 'IPR041738', NULL, 'Structural maintenance of chromosomes 4, ABC domain, eukaryotic', 'SMC4_ABC_euk', 3, NULL),
(30686, NULL, 'IPR035145', NULL, 'Protein of unknown function DUF5482', 'DUF5482', 4, NULL),
(30687, NULL, 'IPR038792', NULL, 'CFAP97 domain-containing protein 1/2', 'CFAP97D1/2', 4, NULL),
(30688, NULL, 'IPR037701', NULL, 'Nucleoporin Pom152', 'Pom152', 4, NULL),
(30689, NULL, 'IPR037417', NULL, 'HTH-type transcriptional regulator SyrM, PBP2 domain', 'SyrM_PBP2', 3, NULL),
(30690, NULL, 'IPR036946', NULL, 'Gamma-retroviral matrix domain superfamily', 'G_retro_matrix_sf', 5, NULL),
(30691, NULL, 'IPR042029', NULL, 'L-ribulokinase-like', 'L-RBK-like', 4, NULL),
(30692, NULL, 'IPR037895', NULL, 'NudC domain-containing protein 1', 'NUDCD1', 4, NULL),
(30693, NULL, 'IPR041872', NULL, 'Methionyl-tRNA synthetase, anticodon-binding domain', 'Anticodon_Met', 3, NULL),
(30694, NULL, 'IPR041834', NULL, 'Cdc1-like, metallophosphatase domain', 'MPP_Cdc1', 3, NULL),
(30695, NULL, 'IPR036251', NULL, 'Arginine repressor, C-terminal domain superfamily', 'Arg_repress_C_sf', 5, NULL),
(30696, NULL, 'IPR041803', NULL, 'RNA polymerase II degradation factor 1, CUE domain', 'DEF1_CUE', 3, NULL),
(30697, NULL, 'IPR039341', NULL, 'Cilia- and flagella-associated protein 99', 'CFAP99', 4, NULL),
(30698, NULL, 'IPR041741', NULL, 'Structural maintenance of chromosomes 3, ABC domain, eukaryotic', 'SMC3_ABC_euk', 3, NULL),
(30699, NULL, 'IPR038833', NULL, 'Testis-expressed protein 50', 'TEX50', 4, NULL),
(30700, NULL, 'IPR034234', NULL, 'Nucleolin, RNA recognition motif 3', 'Nucleolin_RRM3', 3, NULL),
(30701, NULL, 'IPR041954', NULL, 'Trimethylamine-N-oxide reductase-like, molybdopterin-binding domain', 'CT_DMSOR/BSOR/TMAOR', 3, NULL),
(30702, NULL, 'IPR034748', NULL, 'Exonuclease I, C-terminal alpha-helical domain', 'EXOI_C', 3, NULL),
(30703, NULL, 'IPR041563', NULL, 'STT3 subunit PglB, C-terminal beta-barrel domain', 'STT3_PglB_C', 3, NULL),
(30704, NULL, 'IPR035677', NULL, 'ASAP2, SH3 domain', 'ASAP2_SH3', 3, NULL),
(30705, NULL, 'IPR034372', NULL, 'Serine/threonine-protein kinase Kist', 'UHMK1', 4, NULL),
(30706, NULL, 'IPR034228', NULL, 'Nop6, RNA recognition motif', 'Nop6_RRM', 3, NULL),
(30707, NULL, 'IPR041686', NULL, 'Zinc-finger CCCH domain', 'Znf-CCCH_3', 3, NULL),
(30708, NULL, 'IPR038703', NULL, 'YebF/Cmi superfamily', 'YebF/Cmi_sf', 5, NULL),
(30709, NULL, 'IPR035368', NULL, 'Nrap protein, domain 3', 'Nrap_D3', 3, NULL),
(30710, NULL, 'IPR041931', NULL, 'Bacterial DNA polymerase III alpha subunit, thumb domain', 'DNA_pol3_alpha_thumb_dom', 5, NULL),
(30711, NULL, 'IPR033183', NULL, 'Neurofilament heavy polypeptide', 'NF-H', 4, NULL),
(30712, NULL, 'IPR033664', NULL, 'tRNA 5-carboxymethoxyuridine methyltransferase', 'Cmo5U_methylTrfase', 4, NULL),
(30713, NULL, 'IPR037411', NULL, 'HTH-type transcriptional regulator AlsR, PBP2 domain', 'AlsR_PBP2', 3, NULL),
(30714, NULL, 'IPR041804', NULL, 'Vacuolar protein sorting-associated protein 9, CUE domain', 'Vps9_CUE', 3, NULL),
(30715, NULL, 'IPR035715', NULL, 'Metallothionein-like protein Crs5', 'Crs5', 4, NULL),
(30716, NULL, 'IPR039371', NULL, 'LeuA, N-terminal catalytic TIM barrel domain', 'LeuA_N_DRE-TIM', 3, NULL),
(30717, NULL, 'IPR035366', NULL, 'Protein of unknown function DUF5408', 'DUF5408', 4, NULL),
(30718, NULL, 'IPR041615', NULL, 'Desmoplakin, SH3 domain', 'Desmoplakin_SH3', 3, NULL),
(30719, NULL, 'IPR041688', NULL, 'Orotate phosphoribosyltransferase-like', 'PRTase_2', 3, NULL),
(30720, NULL, 'IPR041899', NULL, 'MAGE homology domain, winged helix WH2 motif', 'MAGE_WH2', 5, NULL),
(30721, NULL, 'IPR035348', NULL, 'MoaF, C-terminal domain', 'MoaF_C', 3, NULL),
(30722, NULL, 'IPR033192', NULL, 'Outer dynein arm-docking complex subunit 3', 'ODAD3', 4, NULL),
(30723, NULL, 'IPR041734', NULL, 'N-Acetyl-L-glutamate kinase, fungal-type', 'NAGK-fArgBP', 3, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(30724, NULL, 'IPR037843', NULL, 'Kindlin/fermitin', 'Kindlin/fermitin', 4, NULL),
(30725, NULL, 'IPR039006', NULL, 'Rho GTPase-activating protein, pG2 domain', 'RhoGAP_pG2', 3, NULL),
(30726, NULL, 'IPR035752', NULL, 'TRIM1, PRY/SPRY domain', 'SPRY/PRY_TRIM1', 3, NULL),
(30727, NULL, 'IPR042001', NULL, 'Sortase F', 'Sortase_F', 4, NULL),
(30728, NULL, 'IPR039369', NULL, 'Galactoside O-acetyltransferase LacA-like', 'LacA-like', 4, NULL),
(30729, NULL, 'IPR041781', NULL, 'FERM domain-containing protein 6, FERM domain C-lobe', 'FRMD6-FERM_C', 3, NULL),
(30730, NULL, 'IPR041774', NULL, 'LIN-17, cysteine-rich domain', 'LIN-17_CRD', 3, NULL),
(30731, NULL, 'IPR042097', NULL, 'Aminopeptidase N-like , N-terminal domain superfamliy', 'Aminopeptidase_N-like_N_sf', 5, NULL),
(30732, NULL, 'IPR041429', NULL, 'Inositol-tetrakisphosphate 1-kinase, N-terminal', 'ITPK1_N', 3, NULL),
(30733, NULL, 'IPR039442', NULL, 'Mrr-like domain', 'Mrr-like_dom', 3, NULL),
(30734, NULL, 'IPR042103', NULL, 'Serine-tRNA synthetase, type1, N-terminal domain superfamily', 'SerRS_1_N_sf', 5, NULL),
(30735, NULL, 'IPR038754', NULL, 'Testis-expressed basic protein 1', 'TSBP1', 4, NULL),
(30736, NULL, 'IPR041869', NULL, 'Manganese-dependent ADP-ribose/CDP-alcohol diphosphatase', 'MPP_ADPRM', 3, NULL),
(30737, NULL, 'IPR042063', NULL, 'Ubiquitin-activating enzyme E1, SCCH domain', 'Ubi_acti_E1_SCCH', 5, NULL),
(30738, NULL, 'IPR034747', NULL, 'Exonuclease I, SH3-like domain', 'EXOI_SH3', 3, NULL),
(30739, NULL, 'IPR042089', NULL, 'Peptidase M13, domain 2', 'Peptidase_M13_dom_2', 5, NULL),
(30740, NULL, 'IPR041914', NULL, 'ATP-dependent 6-phosphofructokinase, vertebrate-type', 'PFK_vert-type', 4, NULL),
(30741, NULL, 'IPR034225', NULL, 'Nop13/Rnp24, RNA recognition motif 1', 'Nop13/Rnp24_RRM1', 3, NULL),
(30742, NULL, 'IPR036630', NULL, 'Head decoration protein D superfamily', 'Head_decoration_D_sf', 5, NULL),
(30743, NULL, 'IPR040148', NULL, 'Fragile X messenger ribonucleoprotein 1', 'FMR1', 4, NULL),
(30744, NULL, 'IPR038075', NULL, 'RalF, C-terminal domain superfamily', 'RalF_C_sf', 5, NULL),
(30745, NULL, 'IPR041859', NULL, 'Calsequestrin, N-terminal TRX-fold domain', 'Calsequestrin_N', 3, NULL),
(30746, NULL, 'IPR041705', NULL, 'VapC-like Sll0205 protein, PIN domain', 'PIN_Sll0205', 3, NULL),
(30747, NULL, 'IPR038240', NULL, 'Stn1, C-terminal domain superfamily', 'Stn1_C_sf', 5, NULL),
(30748, NULL, 'IPR041545', NULL, 'RABX5, catalytic core helical domain', 'DUF5601', 3, NULL),
(30749, NULL, 'IPR038975', NULL, 'Thionin-like protein', 'THNL', 4, NULL),
(30750, NULL, 'IPR041607', NULL, 'HU domain fused to wHTH, Ig, or Glycine-rich motif', 'HU-HIG', 3, NULL),
(30751, NULL, 'IPR039218', NULL, 'REM family', 'REM_fam', 4, NULL),
(30752, NULL, 'IPR041857', NULL, 'Rab effector Noc2, FYVE domain', 'Noc2_FYVE', 3, NULL),
(30753, NULL, 'IPR041925', NULL, 'Formate dehydrogenase H, molybdopterin-binding domain', 'CT_Formate-Dh_H', 3, NULL),
(30754, NULL, 'IPR033854', NULL, 'Signal peptide peptidase A', 'S49_SppA_1', 3, NULL),
(30755, NULL, 'IPR038986', NULL, 'Cryptic loci regulator 2', 'Clr2', 4, NULL),
(30756, NULL, 'IPR038831', NULL, 'Small integral membrane protein 26', 'SMIM26', 4, NULL),
(30757, NULL, 'IPR036259', NULL, 'MFS transporter superfamily', 'MFS_trans_sf', 5, NULL),
(30758, NULL, 'IPR041838', NULL, 'ADP-ribosylation factor 6', 'Arf6', 4, NULL),
(30759, NULL, 'IPR037328', NULL, 'Ankyrin repeat and SOCS box protein 5, SOCS box domain', 'ASB5_SOCS', 3, NULL),
(30760, NULL, 'IPR041827', NULL, 'CpdB, N-terminal metallophosphatase domain', 'CpdB_N', 3, NULL),
(30761, NULL, 'IPR034330', NULL, 'Glutathione S-transferases, class Zeta , C-terminal', 'GST_Zeta_C', 3, NULL),
(30762, NULL, 'IPR033935', NULL, 'Ribosomal protein L19, eukaryotic', 'Ribosomal_L19_euka', 3, NULL),
(30763, NULL, 'IPR041848', NULL, 'Guanine nucleotide-binding protein subunit gamma, fungal', 'Ste18_fungal', 4, NULL),
(30764, NULL, 'IPR035352', NULL, 'TSX', 'TSX', 4, NULL),
(30765, NULL, 'IPR037412', NULL, 'HTH-type transcriptional regulator IlvR, PBP2 domain', 'IlvR_PBP2', 3, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(30766, NULL, 'IPR041566', NULL, 'Alpha-mannosidase 2, C-terminal sub-domain', 'AManII_C', 3, NULL),
(30767, NULL, 'IPR041862', NULL, 'Endoplasmic reticulum resident protein 44, TRX-like domain b''', 'ERp44_PDI_b''', 3, NULL),
(30768, NULL, 'IPR041662', NULL, 'SusD-like 2', 'SusD-like_2', 4, NULL),
(30769, NULL, 'IPR037327', NULL, 'Ankyrin repeat and SOCS box protein 6, SOCS box domain', 'ASB6_SOCS', 3, NULL),
(30770, NULL, 'IPR034370', NULL, 'SCAF8, RNA recognition motif', 'SCAF8_RRM', 3, NULL),
(30771, NULL, 'IPR041731', NULL, 'N-Acetyl-L-glutamate kinase, noncyclic', 'NAGK-NC', 4, NULL),
(30772, NULL, 'IPR041801', NULL, 'NEDD4-binding protein 2, CUE domain', 'N4BP2_CUE', 3, NULL),
(30773, NULL, 'IPR038142', NULL, 'Cytochrome P460 superfamily', 'Cytochrome_P460_sp', 5, NULL),
(30774, NULL, 'IPR041661', NULL, 'ZN622/Rei1/Reh1, zinc finger C2H2-type', 'ZN622/Rei1/Reh1_Znf-C2H2', 3, NULL),
(30775, NULL, 'IPR041812', NULL, 'Ubiquitin carboxyl-terminal hydrolase 5, UBA1 domain', 'UBP5_UBA1', 3, NULL),
(30776, NULL, 'IPR041975', NULL, 'Spt5, KOW domain repeat 2', 'KOW_Spt5_2', 3, NULL),
(30777, NULL, 'IPR039000', NULL, 'ATP-dependent DNA helicase DinG', 'DinG_proteobact', 4, NULL),
(30778, NULL, 'IPR041874', NULL, 'Carbonic anhydrase, CA4/CA15', 'CA4/CA15', 4, NULL),
(30779, NULL, 'IPR035541', NULL, 'Neutrophil cytosol factor P40, SH3 domain', 'p40phox_SH3', 3, NULL),
(30780, NULL, 'IPR037431', NULL, 'RNA exonuclease 4, DEDDh 3''-5'' exonuclease domain', 'REX4_DEDDh_dom', 3, NULL),
(30781, NULL, 'IPR033855', NULL, 'Bacteriophage protein C', 'Protein_C', 3, NULL),
(30782, NULL, 'IPR034226', NULL, 'Nop13/Rnp24, RNA recognition motif 2', 'Nop13/Rnp24_RRM2', 3, NULL),
(30783, NULL, 'IPR041823', NULL, 'YHR202W-like, N-terminal metallophosphatase domain', 'YHR202W_N', 3, NULL),
(30784, NULL, 'IPR034772', NULL, 'CPSF6/7 family', 'CPSF6/7', 4, NULL),
(30785, NULL, 'IPR037432', NULL, 'Exonuclease Mut-7, DEDDy 3''-5'' exonuclease domain', 'Mut-7_DEDDy_dom', 3, NULL),
(30786, NULL, 'IPR037615', NULL, 'Kazrin, SAM domain repeat 2', 'Kazrin_SAM_rpt_2', 3, NULL),
(30787, NULL, 'IPR041858', NULL, 'Calsequestrin, middle TRX-fold domain', 'Calsequestrin_middle_dom', 3, NULL),
(30788, NULL, 'IPR042102', NULL, 'RNA polymerase Rpb1, domain 3 superfamily', 'RNA_pol_Rpb1_3_sf', 5, NULL),
(30789, NULL, 'IPR041684', NULL, 'PHD/FYVE-zinc-finger like domain', 'Znf-PHD-like', 3, NULL),
(30790, NULL, 'IPR037415', NULL, 'Octopine catabolism/uptake operon regulatory protein OccR, PBP2 domain', 'OccR_PBP2', 3, NULL),
(30791, NULL, 'IPR037329', NULL, 'Ankyrin repeat and SOCS box protein 3, SOCS box domain', 'ASB3_SOCS', 3, NULL),
(30792, NULL, 'IPR041998', NULL, 'Histamine H3 receptor, 7TM', '7tmA_HRH3', 3, NULL),
(30793, NULL, 'IPR037606', NULL, 'Diacylglycerol kinase delta, SAM domain', 'DGK-delta_SAM', 3, NULL),
(30794, NULL, 'IPR034719', NULL, 'Inhibitor of hydrogen peroxide resistance', 'IprA', 4, NULL),
(30795, NULL, 'IPR038157', NULL, 'Ferrous iron transporter, core domain', 'FeoA_core_dom', 5, NULL),
(30796, NULL, 'IPR033934', NULL, 'Bacterial and archaeal 5-aminoimidazole-4-(N-succinylcarboxamide) ribonucleotide synthase', 'SAICAR_synt_PurC', 4, NULL),
(30797, NULL, 'IPR041752', NULL, 'Cytochrome c oxidase assembly factor 3, mitochondrial', 'Coa3', 4, NULL),
(30798, NULL, 'IPR041794', NULL, 'Myosin VII, FERM domain C-lobe, repeat 2', 'MyoVII_FERM_C2', 3, NULL),
(30799, NULL, 'IPR038881', NULL, 'Yae1-like', 'Yae1-like', 4, NULL),
(30800, NULL, 'IPR037608', NULL, 'Stromal interaction molecule', 'STIM', 4, NULL),
(30801, NULL, 'IPR041845', NULL, 'Mavicyanin', 'Mavicyanin', 4, NULL),
(30802, NULL, 'IPR038820', NULL, 'Coiled-coil domain-containing protein 171', 'CCDC171', 4, NULL),
(30803, NULL, 'IPR035141', NULL, 'Protein of unknown function DUF5484', 'DUF5484', 4, NULL),
(30804, NULL, 'IPR038070', NULL, 'Rv2632c-like superfamily', 'Rv2632c-like_sf', 5, NULL),
(30805, NULL, 'IPR034773', NULL, 'CPSF7, RNA recognition motif', 'CPSF7_RRM', 3, NULL),
(30806, NULL, 'IPR041868', NULL, 'Protein disulfide-isomerase A3, first redox inactive TRX-like domain b', 'PDIA3_PDI_b', 3, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(30807, NULL, 'IPR041884', NULL, 'PilM protein, C-terminal domain', 'PilM_C-ter', 5, NULL),
(30808, NULL, 'IPR038974', NULL, 'Protein Casparian strip integrity factor 1/2', 'CIF1/2', 4, NULL),
(30809, NULL, 'IPR041687', NULL, 'IprA, winged helix-turn-helix domain', 'HTH_46', 3, NULL),
(30810, NULL, 'IPR037285', NULL, 'TM0693-like superfamily', 'TM0693-like_sf', 5, NULL),
(30811, NULL, 'IPR041831', NULL, 'Endonuclease YhcR, metallophosphatase domain', 'YhcR_MPP', 3, NULL),
(30812, NULL, 'IPR038144', NULL, 'Intracellular proteinase inhibitor', 'IPI', 5, NULL),
(30813, NULL, 'IPR041850', NULL, 'Nectin-1, second immunoglobulin (Ig) domain', 'Nectin-1_Ig2', 3, NULL),
(30814, NULL, 'IPR041840', NULL, 'Ras-related protein Rap2', 'Rap2', 4, NULL),
(30815, NULL, 'IPR039452', NULL, 'Protein of unknown function DUF5403', 'DUF5403', 4, NULL),
(30816, NULL, 'IPR033418', NULL, 'Periplasmic sensor domain, extracellular', 'CHASE9', 3, NULL),
(30817, NULL, 'IPR038992', NULL, 'Transmembrane protein 204', 'TMEM204', 4, NULL),
(30818, NULL, 'IPR041612', NULL, 'YfiR, C-terminal', 'YfiR_C', 3, NULL),
(30819, NULL, 'IPR041825', NULL, 'SA0022-like, N-terminal metallophosphatase domain', 'SA0022_N', 3, NULL),
(30820, NULL, 'IPR041957', NULL, 'Nitrate reductase NapA-like, molybdopterin-binding domain', 'CT_Nitrate-R-NapA-like', 3, NULL),
(30821, NULL, 'IPR037613', NULL, 'Kazrin, SAM domain repeat 1', 'Kazrin_SAM_rpt_1', 3, NULL),
(30822, NULL, 'IPR041616', NULL, 'Phenylalanyl tRNA synthetase beta chain, core domain', 'PheRS_beta_core', 3, NULL),
(30823, NULL, 'IPR041852', NULL, 'ARHGAP6/36, RhoGAP domain', 'ARHGAP6_RhoGAP', 3, NULL),
(30824, NULL, 'IPR036947', NULL, 'POLO box domain superfamily', 'POLO_box_dom_sf', 5, NULL),
(30825, NULL, 'IPR041598', NULL, 'Methionine--tRNA ligase, N-terminal', 'MARS_N', 3, NULL),
(30826, NULL, 'IPR041707', NULL, 'Pseudouridine synthase Pus3-like', 'Pus3-like', 4, NULL),
(30827, NULL, 'IPR039271', NULL, 'Kiwellin-like', 'Kiwellin-like', 4, NULL),
(30828, NULL, 'IPR033120', NULL, 'Hotdog acyl-CoA thioesterase (ACOT)-type domain', 'HOTDOG_ACOT', 3, NULL),
(30829, NULL, 'IPR033853', NULL, 'Archaeal protein PH0471, N-terminal', 'PH1510-N', 3, NULL),
(30830, NULL, 'IPR036636', NULL, 'Cytochrome c oxidase subunit VIIc superfamily', 'COX7C/Cox8_sf', 5, NULL),
(30831, NULL, 'IPR036164', NULL, 'L21-like superfamily', 'L21-like_sf', 5, NULL),
(30832, NULL, 'IPR041953', NULL, 'YdeP, molybdopterin-binding oxidoreductase-like domain', 'YdeP_MopB', 3, NULL),
(30833, NULL, 'IPR038826', NULL, 'Coiled-coil domain-containing protein 178', 'CCDC178', 4, NULL),
(30834, NULL, 'IPR041810', NULL, 'Ubiquitin-binding protein Cue2, CUE domain 2', 'Cue2_CUE2', 3, NULL),
(30835, NULL, 'IPR033747', NULL, 'Class I PurE', 'PurE_ClassI', 3, NULL),
(30836, NULL, 'IPR041807', NULL, 'Cue5/Don1, CUE domain', 'Cue5/Don1_CUE', 3, NULL),
(30837, NULL, 'IPR038980', NULL, 'Serine/threonine-protein kinase ATM, plant', 'ATM_plant', 4, NULL),
(30838, NULL, 'IPR041860', NULL, 'Calsequestrin, C-terminal TRX-fold domain', 'Calsequestrin_C', 3, NULL),
(30839, NULL, 'IPR034725', NULL, 'E3 ubiquitin-protein ligase RNF168', 'RNF168', 4, NULL),
(30840, NULL, 'IPR041945', NULL, 'Putative dimethyl sulfoxide reductase catalytic subunit A, C-terminal', 'DmsA_C', 3, NULL),
(30841, NULL, 'IPR041962', NULL, 'BsuBI/PstI restriction endonuclease, N-terminal domain superfamily', 'BsuBI/PstI_N_sf', 5, NULL),
(30842, NULL, 'IPR041875', NULL, 'Syntaxin-8, SNARE domain', 'Syntaxin-8_SNARE', 3, NULL),
(30843, NULL, 'IPR035369', NULL, 'Nrap protein, domain 4', 'Nrap_D4', 3, NULL),
(30844, NULL, 'IPR041703', NULL, 'Transcription termination factor Rho, ATP binding domain', 'Rho_factor_ATP-bd', 3, NULL),
(30845, NULL, 'IPR041861', NULL, 'Nucleoredoxin, redox inactive TRX-like domain b''', 'NRX_PDI_b''', 3, NULL),
(30846, NULL, 'IPR041843', NULL, 'Rho-related GTP-binding protein RhoE', 'RhoE', 4, NULL),
(30847, NULL, 'IPR041610', NULL, 'ArlS, sensor domain', 'ArlS_N', 3, NULL),
(30848, NULL, 'IPR034233', NULL, 'Nucleolin, RNA recognition motif 2', 'Nucleolin_RRM2', 3, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(30849, NULL, 'IPR039342', NULL, 'Protein TRIGALACTOSYLDIACYLGLYCEROL 2-like', 'TGD2-like', 4, NULL),
(30850, NULL, 'IPR041758', NULL, 'Phosphatase BSL, C-terminal metallophosphatase domain', 'MPP_BSL_C', 3, NULL),
(30851, NULL, 'IPR034701', NULL, 'Diadenylate cyclase CdaA', 'CdaA', 4, NULL),
(30852, NULL, 'IPR041436', NULL, 'Bacterial CdiA-CT RNAse A domain', 'RNAse_A_bac', 3, NULL),
(30853, NULL, 'IPR037326', NULL, 'Ankyrin repeat and SOCS box protein 7, SOCS box domain', 'ASB7_SOCS', 3, NULL),
(30854, NULL, 'IPR037953', NULL, 'SbnI-like, N-terminal', 'SbnI-like_N', 3, NULL),
(30855, NULL, 'IPR037682', NULL, 'TonB, C-terminal', 'TonB_C', 3, NULL),
(30856, NULL, 'IPR035675', NULL, 'STAM2, SH3 domain', 'STAM2_SH3', 3, NULL),
(30857, NULL, 'IPR039444', NULL, 'SIR2-like domain', 'SIR2-like', 3, NULL),
(30858, NULL, 'IPR041842', NULL, 'Rho-related GTP-binding protein RhoN', 'RhoN', 4, NULL),
(30859, NULL, 'IPR041421', NULL, 'Ubl4, C-terminal TUGS domain', 'Ubl4_C_TUGS', 3, NULL),
(30860, NULL, 'IPR038983', NULL, 'C2 domain-containing protein 5', 'C2CD5', 4, NULL),
(30861, NULL, 'IPR034949', NULL, 'Regulator of G-protein signalling 8, RGS domain', 'RGS_RGS8', 3, NULL),
(30862, NULL, 'IPR039453', NULL, 'Mitochondrial outer membrane protein OM14, C-terminal', 'OM14_C', 3, NULL),
(30863, NULL, 'IPR033577', NULL, 'Aminopeptidase O', 'AOPep', 4, NULL),
(30864, NULL, 'IPR033936', NULL, 'Ribosomal protein L19e, archaeal', 'Ribosomal_L19e_A', 3, NULL),
(30865, NULL, 'IPR041431', NULL, 'Mvd1, C-terminal', 'Mvd1_C', 3, NULL),
(30866, NULL, 'IPR034229', NULL, 'eIF4H, RNA recognition motif', 'eIF4H_RRM', 3, NULL),
(30867, NULL, 'IPR042028', NULL, 'CD63, extracellular domain', 'CD63_LEL', 3, NULL),
(30868, NULL, 'IPR034718', NULL, 'Endolytic peptidoglycan transglycosylase RlpA', 'RlpA', 4, NULL),
(30869, NULL, 'IPR038139', NULL, 'NlpE, C-terminal domain superfamily', 'NlpE_C_sf', 5, NULL),
(30870, NULL, 'IPR041967', NULL, 'KMT2C, ePHD1', 'KMT2C_ePHD1', 3, NULL),
(30871, NULL, 'IPR035149', NULL, 'Protein of unknown function DUF5479', 'DUF5479', 4, NULL),
(30872, NULL, 'IPR041871', NULL, 'TMEM62, metallophosphatase domain', 'MPP_TMEM62', 3, NULL),
(30873, NULL, 'IPR041853', NULL, 'Plexin-C1, Sema domain', 'Plexin-C1_Sema', 3, NULL),
(30874, NULL, 'IPR040161', NULL, 'F-box A protein FB155/FB224', 'FB155/FB224', 4, NULL),
(30875, NULL, 'IPR037610', NULL, 'Stromal interaction molecule 2, SAM domain', 'STIM2_SAM', 3, NULL),
(30876, NULL, 'IPR038245', NULL, 'MogR, DNA-binding domain superfamily', 'MogR_DNA-bd_sf', 5, NULL),
(30877, NULL, 'IPR041432', NULL, 'Ubiquitinyl hydrolase, variant UBP zinc finger', 'UBP13_Znf-UBP_var', 3, NULL),
(30878, NULL, 'IPR042026', NULL, 'Peripherin, extracellular domain', 'Peripherin_LEL', 3, NULL),
(30879, NULL, 'IPR037611', NULL, 'Tumour protein p63, SAM domain', 'Tumor-p63_SAM', 3, NULL),
(30880, NULL, 'IPR041620', NULL, 'CdiA, C-terminal tRNase domain', 'CdiA_C_tRNase', 3, NULL),
(30881, NULL, 'IPR033877', NULL, 'Nitroreductase Frm2/Hbn1-like', 'Frm2/Hbn1', 4, NULL),
(30882, NULL, 'IPR041854', NULL, 'BFD-like [2Fe-2S]-binding domain superfamily', 'BFD-like_2Fe2S-bd_dom_sf', 5, NULL),
(30883, NULL, 'IPR037433', NULL, 'ISG20, DEDDh 3''-5'' exonuclease domain', 'ISG20_DEDDh', 3, NULL),
(30884, NULL, 'IPR042094', NULL, 'Type II secretion system GspF domain superfamily', 'T2SS_GspF_sf', 5, NULL),
(30885, NULL, 'IPR041800', NULL, 'Activating signal cointegrator 1 complex subunit 2, CUE domain', 'ASCC2_CUE', 3, NULL),
(30886, NULL, 'IPR037414', NULL, 'Transcriptional activator protein LysR, PBP2 domain', 'LysR_PBP2', 3, NULL),
(30887, NULL, 'IPR033741', NULL, 'Sequestosome-1, UBA domain', 'SQSTM_UBA', 3, NULL),
(30888, NULL, 'IPR041424', NULL, 'CinA, KH domain', 'CinA_KH', 3, NULL),
(30889, NULL, 'IPR039455', NULL, 'EPIDERMAL PATTERNING FACTOR-like protein', 'EPFL', 4, NULL),
(30890, NULL, 'IPR042014', NULL, 'MTF2, PHD domain 1', 'MTF2_PHD1', 3, NULL),
(30891, NULL, 'IPR041782', NULL, 'PTPN14/21, FERM domain C-lobe', 'PTPN14/21_FERM_C', 3, NULL),
(30892, NULL, 'IPR041809', NULL, 'Ubiquitin-binding protein Cue2, CUE domain 1', 'Cue2_CUE1', 3, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(30893, NULL, 'IPR035089', NULL, 'Tail sheath protein, subtilisin-like domain', 'Phage_sheath_subtilisin', 3, NULL),
(30894, NULL, 'IPR038979', NULL, 'Pesticidal crystal protein', 'Pest_crys', 4, NULL),
(30895, NULL, 'IPR038162', NULL, 'Ig-like SoxY domain superfamily', 'SoxY_sf', 5, NULL),
(30896, NULL, 'IPR039005', NULL, 'CSPG repeat', 'CSPG_rpt', 7, NULL),
(30897, NULL, 'IPR041798', NULL, 'Otoconin-90, phospholipase A2-like domain', 'Otoconin-90', 3, NULL),
(30898, NULL, 'IPR039327', NULL, 'C2H2 finger domain transcription factor CON7-like', 'CON7-like', 4, NULL),
(30899, NULL, 'IPR041528', NULL, 'Cas6b N-terminal', 'Cas6b_N', 3, NULL),
(30900, NULL, 'IPR041829', NULL, 'SoxB, N-terminal metallophosphatase domain', 'SoxB_N', 3, NULL),
(30901, NULL, 'IPR041898', NULL, 'MAGE homology domain, winged helix WH1 motif', 'MAGE_WH1', 5, NULL),
(30902, NULL, 'IPR038973', NULL, 'DNA mismatch repair protein MutL/Mlh/Pms', 'MutL/Mlh/Pms', 4, NULL),
(30903, NULL, 'IPR041870', NULL, 'Endoplasmic reticulum resident protein 44, TRX-like domain b', 'ERp44_PDI_b', 3, NULL),
(30904, NULL, 'IPR037952', NULL, 'Sensor histidine kinase TorS, sensor domain', 'Sensor_TorS', 3, NULL),
(30905, NULL, 'IPR041966', NULL, 'LOTUS-like domain', 'LOTUS-like', 5, NULL),
(30906, NULL, 'IPR033862', NULL, 'Putative metalloprotease, Jacalin-like lectin domain', 'Jacalin-like_metallopeptidase', 3, NULL),
(30907, NULL, 'IPR041333', NULL, 'Peptidase M60, C-terminal', 'M60_C', 3, NULL),
(30908, NULL, 'IPR041792', NULL, 'Purple acid phosphatase, metallophosphatase domain', 'MPP_PAP', 3, NULL),
(30909, NULL, 'IPR036621', NULL, 'Anticodon-binding domain superfamily', 'Anticodon-bd_dom_sf', 5, NULL),
(30910, NULL, 'IPR037416', NULL, 'Nodulation protein D, PBP2', 'NodD_PBP2', 3, NULL),
(30911, NULL, 'IPR039446', NULL, 'Transcriptional regulator DauR-like', 'DauR-like', 4, NULL),
(30912, NULL, 'IPR041839', NULL, 'ADP-ribosylation factor-like protein 6', 'Arl6', 4, NULL),
(30913, NULL, 'IPR038818', NULL, 'Mast cell-expressed membrane protein 1', 'MCEMP1', 4, NULL),
(30914, NULL, 'IPR041815', NULL, 'Rab35', 'Rab35', 4, NULL),
(30915, NULL, 'IPR038141', NULL, 'YutD-like superfamily', 'YutD-like_sf', 5, NULL),
(30916, NULL, 'IPR039454', NULL, 'Mitochondrial outer membrane protein OM14', 'OM14', 4, NULL),
(30917, NULL, 'IPR035363', NULL, 'Lacto-N-biose phosphorylase, central domain', 'LBP_M', 3, NULL),
(30918, NULL, 'IPR041799', NULL, 'Toll-interacting protein, CUE domain', 'TOLIP_CUE', 3, NULL),
(30919, NULL, 'IPR041617', NULL, 'MalT-like TPR region', 'TPR_MalT', 3, NULL),
(30920, NULL, 'IPR041900', NULL, 'Collagen alpha-3(VI) chain, vWA domain', 'vWA_collagen_alpha3-VI-like', 3, NULL),
(30921, NULL, 'IPR033655', NULL, 'RelA/SpoT, TGS domain', 'TGS_RelA/SpoT', 3, NULL),
(30922, NULL, 'IPR039003', NULL, 'Carnitine monooxygenase reductase subunit', 'Carnitine_monoox_B', 4, NULL),
(30923, NULL, 'IPR033739', NULL, 'Peptidase M10A, catalytic domain', 'M10A_MMP', 3, NULL),
(30924, NULL, 'IPR041778', NULL, 'Frizzled 2, cysteine-rich domain', 'FZ2_CRD', 3, NULL),
(30925, NULL, 'IPR039001', NULL, 'Peptidoglycan-associated lipoprotein', 'Pal', 4, NULL),
(30926, NULL, 'IPR041981', NULL, 'ZZZ3, zinc finger, ZZ-type', 'ZZZ3_ZZ', 3, NULL),
(30927, NULL, 'IPR041811', NULL, 'RAD23A/RAD23B, UBA1 domain', 'RAD23A/B_UBA1', 3, NULL),
(30928, NULL, 'IPR042095', NULL, 'Sulfatase-modifying factor enzyme superfamily', 'SUMF_sf', 5, NULL),
(30929, NULL, 'IPR034668', NULL, 'Novel protein kinase C theta, catalytic domain', 'nPKC_theta', 3, NULL),
(30930, NULL, 'IPR041544', NULL, 'MotY N-terminal domain', 'MotY_N', 3, NULL),
(30931, NULL, 'IPR038752', NULL, 'IQ domain-containing protein H', 'IQCH', 4, NULL),
(30932, NULL, 'IPR035148', NULL, 'Protein of unknown function DUF5480', 'DUF5480', 4, NULL),
(30933, NULL, 'IPR041984', NULL, 'Rsc8/Ssr1/Ssr2, zinc finger, ZZ-type', 'Rsc8/Ssr1/Ssr2_ZZ', 3, NULL),
(30934, NULL, 'IPR038835', NULL, 'Giardin subunit beta-like', 'Giardin_beta-like', 4, NULL),
(30935, NULL, 'IPR041873', NULL, 'PARMER_03128-like, N-terminal', 'PARMER_03128_N', 3, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(30936, NULL, 'IPR038713', NULL, 'Terminase small subunit, N-terminal DNA-binding domain, HTH motif superfamily', 'Terminase_Gp1_N_sf', 5, NULL),
(30937, NULL, 'IPR033703', NULL, 'Picornavirus/Calicivirus coat protein', 'Rhv-like', 3, NULL),
(30938, NULL, 'IPR041614', NULL, 'DprA, winged helix domain', 'DprA_WH', 3, NULL),
(30939, NULL, 'IPR037330', NULL, 'Ankyrin repeat and SOCS box protein 2, SOCS box domain', 'ASB2_SOCS', 3, NULL),
(30940, NULL, 'IPR038981', NULL, 'Polyadenylate-binding protein-interacting protein 5/6', 'CID5/CID6', 4, NULL),
(30941, NULL, 'IPR041328', NULL, 'ResE, histidine kinase sensor domain', 'HisK_sensor', 3, NULL),
(30942, NULL, 'IPR041768', NULL, 'Tyrosine-protein phosphatase', 'RLPH', 4, NULL),
(30943, NULL, 'IPR039266', NULL, 'Autonomous transposable element EN-1 mosaic protein', 'EN-1/SPM', 4, NULL),
(30944, NULL, 'IPR042002', NULL, 'Sortase C', 'Sortase_C', 4, NULL),
(30945, NULL, 'IPR041924', NULL, 'Formate dehydrogenase H, N-terminal', 'Formate_Dh-H_N', 3, NULL),
(30946, NULL, 'IPR038784', NULL, 'Mitogen-activated protein kinase 14', 'p38alpha', 4, NULL),
(30947, NULL, 'IPR041878', NULL, 'Carbonic anhydrase-related protein X/XI', 'Alpha_CARP_X/XI', 4, NULL),
(30948, NULL, 'IPR041708', NULL, 'Pseudouridine synthase PUS1/ PUS2-like', 'PUS1/PUS2-like', 4, NULL),
(30949, NULL, 'IPR042096', NULL, 'Dihydroxy-acid dehydratase, C-terminal', 'Dihydro-acid_dehy_C', 5, NULL),
(30950, NULL, 'IPR034235', NULL, 'Nucleolin, RNA recognition motif 4', 'Nucleolin_RRM4', 3, NULL),
(30951, NULL, 'IPR041841', NULL, 'Ras-related protein Rsr1', 'Rsr1', 4, NULL),
(30952, NULL, 'IPR034651', NULL, 'SRSF7, RNA recognition motif', 'SRSF7_RRM', 3, NULL),
(30953, NULL, 'IPR035540', NULL, 'FYB, helically extended SH3 domain', 'FYB_hSH3', 3, NULL),
(30954, NULL, 'IPR041965', NULL, 'Putative transposon-transfer assisting superfamily', 'TTRAP_sf', 5, NULL),
(30955, NULL, 'IPR033053', NULL, 'Histone transcription regulator 3/CABIN1', 'Hir3/CABIN1', 4, NULL),
(30956, NULL, 'IPR042098', NULL, 'Taurine dioxygenase TauD-like superfamily', 'TauD-like_sf', 5, NULL),
(30957, NULL, 'IPR034465', NULL, 'Pyruvate formate-lyase activase', 'Pyruvate_for-lyase_activase', 4, NULL),
(30958, NULL, 'IPR037434', NULL, 'Fosfomycin resistance protein FosX', 'FosX', 4, NULL),
(30959, NULL, 'IPR039279', NULL, 'Polygalacturonase QRT3-like', 'QRT3-like', 4, NULL),
(30960, NULL, 'IPR038815', NULL, 'IgA-inducing protein', 'IGIP', 4, NULL),
(30961, NULL, 'IPR042099', NULL, 'ANL, N-terminal domain', 'ANL_N_sf', 5, NULL),
(30962, NULL, 'IPR042025', NULL, 'KMT2A, PHD domain 2', 'KMT2A_PHD2', 3, NULL),
(30963, NULL, 'IPR041700', NULL, 'Outer membrane protein beta-barrel domain 3', 'OMP_b-brl_3', 3, NULL),
(30964, NULL, 'IPR035365', NULL, 'Protein of unknown function DUF5407', 'DUF5407', 4, NULL),
(30965, NULL, 'IPR041864', NULL, 'Metallophosphatase TT1561', 'MPP_Tt1561', 3, NULL),
(30966, NULL, 'IPR041775', NULL, 'Ror-like, cysteine-rich domain', 'Ror-like_CRD', 3, NULL),
(30967, NULL, 'IPR041777', NULL, 'Frizzled 9, cysteine-rich domain', 'FZ9_CRD', 3, NULL),
(30968, NULL, 'IPR037954', NULL, 'Butyrophilin subfamily 3, PRY/SPRY domain', 'SPRY_PRY_BTN3', 3, NULL),
(30969, NULL, 'IPR038073', NULL, 'YkuJ-like superfamily', 'YkuJ-like_sf', 5, NULL),
(30970, NULL, 'IPR038821', NULL, 'CLE-related protein 45-like', 'CLE45-like', 4, NULL),
(30971, NULL, 'IPR036625', NULL, 'E3-binding domain superfamily', 'E3-bd_dom_sf', 5, NULL),
(30972, NULL, 'IPR042030', NULL, 'Chaperone protein HscC, nucleotide-binding domain', 'HscC_NBD', 3, NULL),
(30973, NULL, 'IPR039002', NULL, 'Hydrogenase maturation factor HybF', 'HybF', 4, NULL),
(30974, NULL, 'IPR041663', NULL, 'DisA/LigA, helix-hairpin-helix motif', 'DisA/LigA_HHH', 3, NULL),
(30975, NULL, 'IPR036951', NULL, 'Aromatic amino acid hydroxylase superfamily', 'ArAA_hydroxylase_sf', 5, NULL),
(30976, NULL, 'IPR041947', NULL, 'PHF13, PHD finger', 'PHD_PHF13', 3, NULL),
(30977, NULL, 'IPR041595', NULL, 'Inorganic pyrophosphatase domain', 'Inorganic_Pase', 3, NULL),
(30978, NULL, 'IPR041847', NULL, 'Cytosolic phospholipase A2, C2 domain', 'C2_cPLA2', 3, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(30979, NULL, 'IPR041849', NULL, 'Nectin-1, first immunoglobulin (Ig) domain', 'Nectin-1_Ig1', 3, NULL),
(30980, NULL, 'IPR033494', NULL, 'NUDE family', 'NUDE', 4, NULL),
(30981, NULL, 'IPR034230', NULL, 'Nucleolin, RNA recognition motif 1', 'Nucleolin_RRM1', 3, NULL),
(30982, NULL, 'IPR035146', NULL, 'Protein of unknown function DUF5481', 'DUF5481', 4, NULL),
(30983, NULL, 'IPR041704', NULL, 'CFLE, GH18 catalytic domain', 'CFLE_GH18', 3, NULL),
(30984, NULL, 'IPR038989', NULL, 'Ubiquinone biosynthesis accessory factor UbiJ', 'UbiJ', 4, NULL),
(30985, NULL, 'IPR039445', NULL, 'Transcriptional regulator DauR-like, HTH domain', 'DauR-like_HTH', 3, NULL),
(30986, NULL, 'IPR042007', NULL, 'Sortase A', 'Sortase_A', 4, NULL),
(30987, NULL, 'IPR038933', NULL, 'Ovate protein family', 'Ovate', 4, NULL),
(30988, NULL, 'IPR041977', NULL, 'Spt5, KOW domain repeat 4', 'KOW_Spt5_4', 3, NULL),
(30989, NULL, 'IPR041909', NULL, 'Sbi, C3 binding domain IV', 'Sbi_C3_db_domIV', 5, NULL),
(30990, NULL, 'IPR041727', NULL, 'N-Acetyl-L-glutamate kinase, cyclic', 'NAGK-C', 4, NULL),
(30991, NULL, 'IPR041805', NULL, 'Acid sphingomyelinase/endopolyphosphatase, metallophosphatase domain', 'ASMase/PPN1_MPP', 3, NULL),
(30992, NULL, 'IPR035367', NULL, 'Nrap protein, domain 2', 'Nrap_D2', 3, NULL),
(30993, NULL, 'IPR041960', NULL, 'Geranylgeranyl transferase type-1 subunit beta', 'GGTase_I_beta', 4, NULL),
(30994, NULL, 'IPR039440', NULL, 'Domain of unknown function DUF3850', 'DUF3850', 3, NULL),
(30995, NULL, 'IPR035147', NULL, 'ECORI-T site protein ETM', 'ETM', 4, NULL),
(30996, NULL, 'IPR035714', NULL, 'RAG1 importin-binding', 'RAG1_imp-bd', 3, NULL),
(30997, NULL, 'IPR038999', NULL, 'Capsid vertex protein', 'CAPSP', 4, NULL),
(30998, NULL, 'IPR041787', NULL, 'Shewanella-like phosphatase, metallophosphatase domain', 'MPP_Shelphs', 3, NULL),
(30999, NULL, 'IPR036644', NULL, 'Ferredoxin thioredoxin reductase catalytic beta subunit superfamily', 'FTR_bsu_sf', 5, NULL),
(31000, NULL, 'IPR042101', NULL, 'Signal recognition particle SRP54, N-terminal domain superfamily', 'SRP54_N_sf', 5, NULL),
(31001, NULL, 'IPR033472', NULL, 'RecQ mediated genome instability protein 1-like, N-terminal helical domain', 'RMI1-like_N_hel', 3, NULL),
(31002, NULL, 'IPR040055', NULL, '28S ribosomal protein S10, mitochondrial', 'MRPS10', 4, NULL),
(31003, NULL, 'IPR039904', NULL, 'TPR and ankyrin repeat-containing protein 1', 'TRANK1', 4, NULL),
(31004, NULL, 'IPR040203', NULL, 'DNA replication regulator Sld2', 'Sld2', 4, NULL),
(31005, NULL, 'IPR040053', NULL, 'Josephin-1/2', 'JOSD1/2', 4, NULL),
(31006, NULL, 'IPR039696', NULL, 'Microfibril-associated glycoprotein 3-like', 'MFAP3-like', 4, NULL),
(31007, NULL, 'IPR038707', NULL, 'Conjugal transfer protein TraQ superfamily', 'TraQ_sf', 5, NULL),
(31008, NULL, 'IPR034902', NULL, 'Sorting nexin 4, PX domain', 'PX_SNX4', 3, NULL),
(31009, NULL, 'IPR038297', NULL, 'CcmH/CycL/Ccl2/NrfF domain superfamily', 'CcmH/CycL/NrfF/Ccl2_sf', 5, NULL),
(31010, NULL, 'IPR037796', NULL, 'Transcription initiation factor TFIID subunit 6', 'TAF6', 4, NULL),
(31011, NULL, 'IPR042058', NULL, 'UNC5D, Death domain', 'UNC5D_Death', 3, NULL),
(31012, NULL, 'IPR041009', NULL, 'Protein of unknown function DUF5550', 'DUF5550', 4, NULL),
(31013, NULL, 'IPR036688', NULL, 'MoeA, C-terminal, domain IV superfamily', 'MoeA_C_domain_IV_sf', 5, NULL),
(31014, NULL, 'IPR033603', NULL, 'Centrosomal protein of 44kDa', 'CEP44', 4, NULL),
(31015, NULL, 'IPR040235', NULL, 'Nicolin-1', 'Nicolin-1', 4, NULL),
(31016, NULL, 'IPR039856', NULL, 'ER membrane protein complex subunit 2-like', 'EMC2-like', 4, NULL),
(31017, NULL, 'IPR039723', NULL, 'Vps71/ZNHIT1', 'Vps71/ZNHIT1', 4, NULL),
(31018, NULL, 'IPR035423', NULL, 'M60-like domain, N-terminal', 'M60-like_N', 3, NULL),
(31019, NULL, 'IPR036479', NULL, 'Heat-stable enterotoxin B superfamily', 'STb_sf', 5, NULL),
(31020, NULL, 'IPR039463', NULL, 'Sip3/Lam1, BAR domain', 'Sip3/Lam1_BAR', 3, NULL),
(31021, NULL, 'IPR039698', NULL, 'Polyprenol reductase', 'Dfg10/SRD5A3', 4, NULL),
(31022, NULL, 'IPR040219', NULL, 'Uncharacterized protein KIAA1143-like', 'KIAA1143-like', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(31023, NULL, 'IPR036507', NULL, 'Telomere repeat-binding factor, dimerisation domain superfamily', 'Telomere_rpt-bd_fac_dimer_sf', 5, NULL),
(31024, NULL, 'IPR038425', NULL, 'GAT domain superfamily', 'GAT_sf', 5, NULL),
(31025, NULL, 'IPR036579', NULL, 'Photosystem I, reaction centre subunit PsaD superfamily', 'PsaD_sf', 5, NULL),
(31026, NULL, 'IPR033457', NULL, 'Protein of unknown function DUF5133', 'DUF5133', 4, NULL),
(31027, NULL, 'IPR040030', NULL, '54S ribosomal protein L15, mitochondrial', 'MRPL15', 4, NULL),
(31028, NULL, 'IPR034979', NULL, 'UPF3B, RNA recognition motif-like domain', 'UPF3B_RRM-like', 3, NULL),
(31029, NULL, 'IPR039457', NULL, 'Ly6/PLAUR domain-containing protein 6-like', 'LYPD6-like', 4, NULL),
(31030, NULL, 'IPR038448', NULL, 'Effector protein HopAB, E3 ubiquitin ligase domain superfamily', 'HopAB_E3_ubiquit_lig_sf', 5, NULL),
(31031, NULL, 'IPR039109', NULL, 'Ribosomal protein L30/L30e', 'L30/L30e', 4, NULL),
(31032, NULL, 'IPR038786', NULL, 'Mitogen-activated protein kinase 12', 'p38gamma', 4, NULL),
(31033, NULL, 'IPR040024', NULL, 'Protein phosphatase 1 regulatory subunit 21', 'PPP1R21', 4, NULL),
(31034, NULL, 'IPR036298', NULL, 'Chalcone isomerase superfamily', 'Chalcone_isomerase_sf', 5, NULL),
(31035, NULL, 'IPR039725', NULL, 'Coiled-coil and C2 domain-containing protein 1', 'CC2D1A/B', 4, NULL),
(31036, NULL, 'IPR036318', NULL, 'FAD-binding, type PCMH-like superfamily', 'FAD-bd_PCMH-like_sf', 5, NULL),
(31037, NULL, 'IPR035425', NULL, 'CENP-T/Histone H4, histone fold', 'CENP-T/H4_C', 3, NULL),
(31038, NULL, 'IPR038544', NULL, 'ACP, N-terminal domain superfamily', 'ACP_N_sf', 5, NULL),
(31039, NULL, 'IPR038147', NULL, 'Cox superfamily', 'Cox_sf', 5, NULL),
(31040, NULL, 'IPR041963', NULL, 'BsuBI/PstI restriction endonuclease, C-terminal domain superfamily', 'BsuBI/PstI_C_sf', 5, NULL),
(31041, NULL, 'IPR038430', NULL, 'NADH:ubiquinone oxidoreductase, subunit 3 superfamily', 'NDAH_ubi_oxred_su3_sf', 5, NULL),
(31042, NULL, 'IPR039462', NULL, 'Nucleoporin Nup159/Nup146, N-terminal', 'Nup159/Nup146_N', 3, NULL),
(31043, NULL, 'IPR038627', NULL, 'YebG-like superfamily', 'YebG-like_sf', 5, NULL),
(31044, NULL, 'IPR038644', NULL, 'CopK superfamily', 'CopK_sf', 5, NULL),
(31045, NULL, 'IPR035764', NULL, 'Ryanodine receptor, SPRY domain 2', 'SPRY2_RyR', 3, NULL),
(31046, NULL, 'IPR035798', NULL, 'Secretagogin, EF-hand domain', 'EFh_SCGN', 3, NULL),
(31047, NULL, 'IPR040308', NULL, 'HUWE1-associated protein modifying stress responses', 'HAPR1', 4, NULL),
(31048, NULL, 'IPR040314', NULL, 'Protein dopey', 'DOP1', 4, NULL),
(31049, NULL, 'IPR033422', NULL, 'Gammaproteobacterial periplasmic sensor domain GAPES2', 'GAPES2', 3, NULL),
(31050, NULL, 'IPR038671', NULL, 'Human cytomegalovirus, UL16 ectodomain', 'HCMV_UL16_sf', 5, NULL),
(31051, NULL, 'IPR040194', NULL, 'Cwf19-like protein', 'Cwf19-like', 4, NULL),
(31052, NULL, 'IPR036572', NULL, 'Doublecortin domain superfamily', 'Doublecortin_dom_sf', 5, NULL),
(31053, NULL, 'IPR041019', NULL, 'Plexin, TIG domain 1', 'TIG1_plexin', 3, NULL),
(31054, NULL, 'IPR038205', NULL, 'Protein inscuteable homologue, LGN-binding domain superfamily', 'INSC_LBD_sf', 5, NULL),
(31055, NULL, 'IPR040218', NULL, 'Probable RNA polymerase II nuclear localization protein SLC7A6OS', 'SLC7A6OS', 4, NULL),
(31056, NULL, 'IPR033043', NULL, 'FAS-associated factor 1-like, UBX domain', 'FAF1-like_UBX', 3, NULL),
(31057, NULL, 'IPR038455', NULL, 'Mite allergen, group 5/21 superfamily', 'Mite_allergen_group-5/21_sf', 5, NULL),
(31058, NULL, 'IPR040078', NULL, 'CTD small RNA polymerase II polypeptide A phosphatase-like', 'RNA_Pol_CTD_Phosphatase', 4, NULL),
(31059, NULL, 'IPR037714', NULL, 'MSK2, N-terminal catalytic domain', 'MSK2_N_dom', 3, NULL),
(31060, NULL, 'IPR038712', NULL, 'PixA-like superfamily', 'PixA-like_sf', 5, NULL),
(31061, NULL, 'IPR038300', NULL, 'SASP, alpha/beta-type superfamily', 'SASP_sf_alpha/beta', 5, NULL),
(31062, NULL, 'IPR035873', NULL, 'Phosphonoacetaldehyde reductase', 'PhpC', 4, NULL),
(31063, NULL, 'IPR038906', NULL, 'Tetratricopeptide repeat protein 36', 'TTC36', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(31064, NULL, 'IPR038435', NULL, 'Probable DNA packing protein, C-terminal domain superfamily', 'DNA_pack_C_sf', 5, NULL),
(31065, NULL, 'IPR036478', NULL, 'Exotoxin A, middle domain superfamily', 'Exotox-A_middle_dom_sf', 5, NULL),
(31066, NULL, 'IPR041755', NULL, 'Archaeal Hef helicase/nuclease, insert domain', 'Hef_ID', 3, NULL),
(31067, NULL, 'IPR033965', NULL, 'Tryptophan prenyltransferase ComQ', 'ComQ', 4, NULL),
(31068, NULL, 'IPR037650', NULL, '60S ribosomal subunit assembly/export protein Loc1', 'Loc1', 4, NULL),
(31069, NULL, 'IPR038428', NULL, 'Two-component histidine kinase, sensor domain superfamily', 'HK_sensor_dom_sf', 5, NULL),
(31070, NULL, 'IPR035693', NULL, 'Tyrosine-protein kinase Fgr, SH2 domain', 'Fgr_SH2', 3, NULL),
(31071, NULL, 'IPR037911', NULL, 'SNX16, PX domain', 'SNX16_PX', 3, NULL),
(31072, NULL, 'IPR038415', NULL, 'Minor type IV pilin, PilX-like superfamily', 'Pilin_PilX-like_sf', 5, NULL),
(31073, NULL, 'IPR039900', NULL, 'Pat1-like', 'Pat1-like', 4, NULL),
(31074, NULL, 'IPR041756', NULL, 'Peptidase M28, SGAP-like', 'M28_SGAP-like', 4, NULL),
(31075, NULL, 'IPR038453', NULL, 'DUF3220 superfamily', 'DUF3220_sf', 5, NULL),
(31076, NULL, 'IPR040225', NULL, 'Protein gravitropic in the light 1-like', 'GIL1-like', 4, NULL),
(31077, NULL, 'IPR040026', NULL, 'Flagellar hook-associated protein 2', 'FliD', 4, NULL),
(31078, NULL, 'IPR037702', NULL, 'PI3Kbeta, catalytic domain', 'PI3Kbeta_dom', 3, NULL),
(31079, NULL, 'IPR039954', NULL, 'Protein of unknown function DUF5527', 'DUF5527', 4, NULL),
(31080, NULL, 'IPR035827', NULL, 'TRIM22, PRY/SPRY domain', 'PRY/SPRY_TRIM22', 3, NULL),
(31081, NULL, 'IPR038424', NULL, 'Histidine kinase PdtaS, GAF domain superfamily', 'H_kinase_PdtaS_GAF_sf', 5, NULL),
(31082, NULL, 'IPR038089', NULL, 'Mediator of RNA polymerase II, subunit Med31 superfamily', 'Med31_sf', 5, NULL),
(31083, NULL, 'IPR039722', NULL, 'Nonsense-mediated mRNA decay protein 3', 'Upf3', 4, NULL),
(31084, NULL, 'IPR039908', NULL, 'Protein sepa-1', 'Sepa-1', 4, NULL),
(31085, NULL, 'IPR036083', NULL, 'Class III myosin, motor domain', 'MYSc_Myo3', 3, NULL),
(31086, NULL, 'IPR041010', NULL, 'Acetyl-coA carboxylase zinc finger domain', 'Znf-ACC', 3, NULL),
(31087, NULL, 'IPR038283', NULL, 'Channel forming colicin, C-terminal domain superfamily', 'Channel_colicin_C_sf', 5, NULL),
(31088, NULL, 'IPR038708', NULL, 'Gp34-like superfamily', 'Gp34-like_sf', 5, NULL),
(31089, NULL, 'IPR036286', NULL, 'LexA/Signal peptidase-like superfamily', 'LexA/Signal_pep-like_sf', 5, NULL),
(31090, NULL, 'IPR036488', NULL, 'DUF1883-like superfamily', 'DUF1883-like_sf', 5, NULL),
(31091, NULL, 'IPR037653', NULL, 'Cytochrome B pre-mRNA-processing protein 6', 'Cbp6', 4, NULL),
(31092, NULL, 'IPR038431', NULL, 'Killer toxin SMK, beta subunit superfamily', 'Killer_tox_SMK_b_sf', 5, NULL),
(31093, NULL, 'IPR033425', NULL, 'Membrane-associated sensor domain MASE3', 'MASE3', 3, NULL),
(31094, NULL, 'IPR038447', NULL, 'PSRP-3/Ycf65 superfamily', 'PSRP-3/Ycf65_sf', 5, NULL),
(31095, NULL, 'IPR039508', NULL, 'Protein KASH5, EF-hand-like domain', 'KASH5_EF-hand-like_dom', 3, NULL),
(31096, NULL, 'IPR041816', NULL, 'Lariat debranching enzyme, N-terminal metallophosphatase domain', 'Dbr1_N', 3, NULL),
(31097, NULL, 'IPR037647', NULL, 'HIRA-interacting protein 3', 'HIRIP3', 4, NULL),
(31098, NULL, 'IPR036474', NULL, 'Transcription regulator MotA, C-terminal domain superfamily', 'MotA_Tscrpt_reg_C_sf', 5, NULL),
(31099, NULL, 'IPR033663', NULL, 'Tripartite terminase subunit 3', 'HSV_TRM3', 4, NULL),
(31100, NULL, 'IPR038698', NULL, 'Tp47, domain C superfamily', 'PBP_Tp47_domC_sf', 5, NULL),
(31101, NULL, 'IPR038286', NULL, 'Inositol polyphosphate kinase superfamily', 'IPK_sf', 5, NULL),
(31102, NULL, 'IPR038296', NULL, 'Antitoxin ParD superfamily', 'ParD_sf', 5, NULL),
(31103, NULL, 'IPR038085', NULL, 'RNase P subunit Pop5/Rpp14/Rnp2-like domain superfamily', 'Rnp2-like_sf', 5, NULL),
(31104, NULL, 'IPR040057', NULL, 'Spermatogenesis-defective protein 39', 'Spe-39', 4, NULL),
(31105, NULL, 'IPR038082', NULL, 'YopT domain superfamily', 'YopT_sf', 5, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(31106, NULL, 'IPR040066', NULL, 'WD repeat-containing protein 31', 'WDR31', 4, NULL),
(31107, NULL, 'IPR033907', NULL, 'Endolysin/autolysin', 'Endolysin_autolysin', 3, NULL),
(31108, NULL, 'IPR037643', NULL, 'HERV-H LTR-associating protein 1', 'HHLA1', 4, NULL),
(31109, NULL, 'IPR033137', NULL, 'Neuromodulin, phosphorylation site', 'Neuromodulin_P_site', 6, NULL),
(31110, NULL, 'IPR037646', NULL, 'Proline and serine-rich protein 3', 'PROSER3', 4, NULL),
(31111, NULL, 'IPR033882', NULL, 'DNA damage inducible protein 1 ubiquitin-like domain', 'DDI1_N', 3, NULL),
(31112, NULL, 'IPR039528', NULL, 'DPM1-like', 'DPM1-like', 4, NULL),
(31113, NULL, 'IPR035154', NULL, 'Protein of unknown function DUF5472', 'DUF5472', 4, NULL),
(31114, NULL, 'IPR038275', NULL, 'Nuf2, N-terminal domain superfamily', 'Nuf2_N_sf', 5, NULL),
(31115, NULL, 'IPR040067', NULL, 'WD repeat-containing protein 47', 'WDR47', 4, NULL),
(31116, NULL, 'IPR039700', NULL, 'Lymphocyte antigen 6G6e', 'Ly6g6e', 4, NULL),
(31117, NULL, 'IPR037706', NULL, 'DNA-dependent protein kinase catalytic subunit, catalytic domain', 'DNA-PK_dom', 3, NULL),
(31118, NULL, 'IPR036122', NULL, 'SK, calmodulin-binding domain superfamily', 'CaM-bd_dom_sf', 5, NULL),
(31119, NULL, 'IPR038280', NULL, 'Telomere resolvase ResT superfamily', 'ResT_sf', 5, NULL),
(31120, NULL, 'IPR040321', NULL, 'Coiled-coil domain-containing protein SCD2-like', 'SCD2-like', 4, NULL),
(31121, NULL, 'IPR035716', NULL, 'Cortactin, SH3 domain', 'Cortactin_SH3', 3, NULL),
(31122, NULL, 'IPR037708', NULL, 'Citron Rho-interacting kinase, catalytic domain', 'CRIK_dom', 3, NULL),
(31123, NULL, 'IPR033426', NULL, 'Domain of unknown function DUF5124', 'DUF5124', 3, NULL),
(31124, NULL, 'IPR036577', NULL, 'Photosystem I PsaF, reaction centre subunit III superfamily', 'PSI_PsaF_sf', 5, NULL),
(31125, NULL, 'IPR037513', NULL, 'NAD(P)H dehydrogenase (quinone), prokaryotic', 'NQO', 4, NULL),
(31126, NULL, 'IPR035661', NULL, 'EMP46/EMP47, N-terminal lectin domain', 'EMP46/EMP47_N', 3, NULL),
(31127, NULL, 'IPR037507', NULL, '54S ribosomal protein L25', 'MrpL25', 4, NULL),
(31128, NULL, 'IPR038785', NULL, 'Mitogen-activated protein kinase 13', 'p38delta', 4, NULL),
(31129, NULL, 'IPR036462', NULL, 'Fumarylacetoacetase, N-terminal domain superfamily', 'Fumarylacetoacetase_N_sf', 5, NULL),
(31130, NULL, 'IPR041759', NULL, 'SFRP3, cysteine-rich domain', 'SFRP3_CRD', 3, NULL),
(31131, NULL, 'IPR040217', NULL, 'ACT domain-containing protein ACR1-12', 'ACR1-12', 4, NULL),
(31132, NULL, 'IPR039902', NULL, 'Coiled-coil domain-containing protein CCDC148/CCDC112', 'CCDC148/CCDC112', 4, NULL),
(31133, NULL, 'IPR033883', NULL, 'Calpain subdomain III', 'C2_III', 3, NULL),
(31134, NULL, 'IPR040088', NULL, 'Protein MJ0103-like', 'MJ0103-like', 4, NULL),
(31135, NULL, 'IPR035290', NULL, 'Beta/Mu-diguetoxin-1', 'Beta/Mu-DGTX-Dc1', 4, NULL),
(31136, NULL, 'IPR038276', NULL, 'Floricaula/leafy, C-terminal domain superfamily', 'Floricaula/leafy_C_sf', 5, NULL),
(31137, NULL, 'IPR036305', NULL, 'RGS domain superfamily', 'RGS_sf', 5, NULL),
(31138, NULL, 'IPR039749', NULL, 'NEDD8 ultimate buster 1', 'NUB1', 4, NULL),
(31139, NULL, 'IPR039764', NULL, 'RNA binding protein HABP4/SERBP1', 'HABP4/SERBP1', 4, NULL),
(31140, NULL, 'IPR038450', NULL, 'Photosystem II Pbs27 superfamily', 'PSII_Pbs27_sf', 5, NULL),
(31141, NULL, 'IPR036503', NULL, 'Aldehyde ferredoxin oxidoreductase, N-terminal domain superfamily', 'Ald_Fedxn_OxRdtase_N_sf', 5, NULL),
(31142, NULL, 'IPR037366', NULL, 'BOULE/DAZ family', 'BOULE/DAZ', 4, NULL),
(31143, NULL, 'IPR039169', NULL, 'Protein Abitram', 'Abitram', 4, NULL),
(31144, NULL, 'IPR040017', NULL, 'Exportin-T', 'XPOT', 4, NULL),
(31145, NULL, 'IPR036487', NULL, 'Quinohemoprotein amine dehydrogenase, gamma subunit structural domain superfamily', 'QH-AmDH_gsu_sf', 5, NULL),
(31146, NULL, 'IPR038287', NULL, 'Cse2 superfamily', 'Cse2_sf', 5, NULL),
(31147, NULL, 'IPR038083', NULL, 'Non-structural protein NSP3A domain-like superfamily', 'NSP3A-like', 5, NULL),
(31148, NULL, 'IPR037849', NULL, 'ADAP, PH domain 1', 'PH1_ADAP', 3, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(31149, NULL, 'IPR040313', NULL, 'Keratin-associated protein 6', 'KAP6', 4, NULL),
(31150, NULL, 'IPR033524', NULL, 'Leu/Phe/Val dehydrogenases active site', 'Glu/Leu/Phe/Val_DH_AS', 0, NULL),
(31151, NULL, 'IPR039796', NULL, 'MIP18 family', 'MIP18', 4, NULL),
(31152, NULL, 'IPR040206', NULL, 'Protein Zds1/2', 'Zds1/2', 4, NULL),
(31153, NULL, 'IPR038905', NULL, 'Armadillo repeat-containing protein 2', 'ARMC2', 4, NULL),
(31154, NULL, 'IPR036281', NULL, 'SinR repressor/SinI anti-repressor, dimerisation domain superfamily', 'SinR/SinI_dimer_dom_sf', 5, NULL),
(31155, NULL, 'IPR040201', NULL, 'Protein Mrg3-like', 'Mrg3-like', 4, NULL),
(31156, NULL, 'IPR033884', NULL, 'Calpain C2 domain', 'C2_Calpain', 3, NULL),
(31157, NULL, 'IPR040072', NULL, 'Methyltransferase (Class A)', 'Methyltransferase_A', 4, NULL),
(31158, NULL, 'IPR040200', NULL, 'FAS1 domain-containing protein Mug57-like', 'Mug57-like', 4, NULL),
(31159, NULL, 'IPR033720', NULL, 'Elongation factor Tu, domain 2', 'EFTU_2', 3, NULL),
(31160, NULL, 'IPR039464', NULL, 'Gag-Pol polyprotein, Zinc-finger like domain', 'Gag-pol_Znf-H3C2', 3, NULL),
(31161, NULL, 'IPR036581', NULL, 'Cyanate lyase, C-terminal domain superfamily', 'Cyanate_lyase_C_sf', 5, NULL),
(31162, NULL, 'IPR033721', NULL, 'Prolyl-tRNA synthetase, catalytic domain', 'ProRS_core_arch_euk', 3, NULL),
(31163, NULL, 'IPR038711', NULL, 'Leucine Rich repeat protein, N-terminal domain superfamily', 'LRR_N_sf', 5, NULL),
(31164, NULL, 'IPR034980', NULL, 'RNA-binding protein fusilli, RNA recognition motif 2', 'Fusilli_RRM2', 3, NULL),
(31165, NULL, 'IPR037851', NULL, 'ADAP, PH domain 2', 'PH2_ADAP', 3, NULL),
(31166, NULL, 'IPR038145', NULL, 'EAGR domain superfamily', 'EAGR_sf', 5, NULL),
(31167, NULL, 'IPR039546', NULL, 'Jade-1, PHD finger', 'Jade-1_PHD', 3, NULL),
(31168, NULL, 'IPR038418', NULL, '6-pyruvoyl tetrahydropterin synthase/QueD superfamily', '6-PTP_synth/QueD_sf', 5, NULL),
(31169, NULL, 'IPR034901', NULL, 'Sorting Nexin 1, PX domain', 'PX_SNX1', 3, NULL),
(31170, NULL, 'IPR039505', NULL, 'Dynein regulatory complex protein 1/2, N-terminal', 'DRC1/2_N', 3, NULL),
(31171, NULL, 'IPR040210', NULL, 'Cep85/Cep85L', 'Cep85/Cep85L', 4, NULL),
(31172, NULL, 'IPR038293', NULL, 'ATPase inhibitor subunit zeta superfamily', 'ATPase_inh_sub_z_sf', 5, NULL),
(31173, NULL, 'IPR038486', NULL, 'Fiber protein, C-terminal domain superfamily', 'Fiber_prot_C_sf', 5, NULL),
(31174, NULL, 'IPR037508', NULL, 'Meiotically up-regulated protein Msb1/Mug8', 'Msb1/Mug8', 4, NULL),
(31175, NULL, 'IPR039866', NULL, 'Carboxypeptidase Q', 'CPQ', 4, NULL),
(31176, NULL, 'IPR037709', NULL, 'Serine/threonine-protein kinase Sgk3, catalytic domain', 'SGK3_dom', 3, NULL),
(31177, NULL, 'IPR039906', NULL, 'Nuclear anchorage protein 1-like', 'Anc-1-like', 4, NULL),
(31178, NULL, 'IPR040039', NULL, 'Phosphatidylinositol-glycan biosynthesis class X protein', 'PIGX', 4, NULL),
(31179, NULL, 'IPR036574', NULL, 'Knottin, scorpion toxin-like superfamily', 'Scorpion_toxin-like_sf', 5, NULL),
(31180, NULL, 'IPR042000', NULL, 'Sortase D, type 2', 'Sortase_D_2', 4, NULL),
(31181, NULL, 'IPR039104', NULL, '6-Phosphogluconolactonase', 'PGLS', 4, NULL),
(31182, NULL, 'IPR041757', NULL, 'Sulfate adenylyltransferase subunit CysN, GTP-binding domain', 'CysN_GTP-bd', 3, NULL),
(31183, NULL, 'IPR037649', NULL, 'Uncharacterized protein C10orf62', 'C10orf62', 4, NULL),
(31184, NULL, 'IPR038822', NULL, 'Vertnin-like', 'Vertnin-like', 4, NULL),
(31185, NULL, 'IPR036501', NULL, 'Inhibitor of vertebrate lysozyme superfamily', 'Inhibitor_vert_lysozyme_sf', 5, NULL),
(31186, NULL, 'IPR038303', NULL, 'HNS-dependent expression A/B superfamily', 'HdeA/HdeB_sf', 5, NULL),
(31187, NULL, 'IPR033373', NULL, 'Small kinetochore-associated protein', 'SKAP', 4, NULL),
(31188, NULL, 'IPR040081', NULL, 'Chondrochloren A methyltransferase (CndI-like)', 'CndI-like', 4, NULL),
(31189, NULL, 'IPR037645', NULL, 'Keratinocyte-associated transmembrane protein 2', 'KCT2', 4, NULL),
(31190, NULL, 'IPR035697', NULL, 'DNA-directed RNA polymerase III subunit RPC1, N-terminal', 'RNAP_III_RPC1_N', 3, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(31191, NULL, 'IPR037967', NULL, 'RACK7, Bromo domain', 'RACK7_Bromo_dom', 3, NULL),
(31192, NULL, 'IPR036504', NULL, 'CGI121/TPRKB superfamily', 'CGI121/TPRKB_sf', 5, NULL),
(31193, NULL, 'IPR034871', NULL, 'Allene oxide cyclase superfamily', 'Allene_oxi_cyc_sf', 5, NULL),
(31194, NULL, 'IPR036567', NULL, 'Ribosome hibernation promotion factor-like', 'RHF-like', 5, NULL),
(31195, NULL, 'IPR035300', NULL, 'L1 transposable element, dsRBD-like domain', 'L1_dsRBD', 3, NULL),
(31196, NULL, 'IPR038705', NULL, 'YabP superfamily', 'YabP_sf', 5, NULL),
(31197, NULL, 'IPR038548', NULL, 'Stage V sporulation protein AA, N-terminal domain superfamily', 'SporV_AA_N_sf', 5, NULL),
(31198, NULL, 'IPR039459', NULL, 'RepB-like DNA primase domain', 'RepB-like_DNA_primase_dom', 3, NULL),
(31199, NULL, 'IPR038647', NULL, 'Cren7 superfamily', 'Cren7_sf', 5, NULL),
(31200, NULL, 'IPR038901', NULL, 'Hexosaminidase D-like', 'HEXDC-like', 4, NULL),
(31201, NULL, 'IPR037640', NULL, 'SMOC-2, extracellular calcium-binding domain', 'SMOC2_EC', 3, NULL),
(31202, NULL, 'IPR038409', NULL, 'Ycf54-like superfamily', 'Ycf54-like_sf', 5, NULL),
(31203, NULL, 'IPR033826', NULL, 'Isoaspartyl-dipeptidase', 'Isoaspartyl-dipeptidase', 4, NULL),
(31204, NULL, 'IPR037917', NULL, 'Ypt35, PX domain', 'Ypt35_PX', 3, NULL),
(31205, NULL, 'IPR041856', NULL, 'Glutamine-dependent NAD+ synthetase, C-terminal', 'NAD+_synth_C', 5, NULL),
(31206, NULL, 'IPR037966', NULL, 'Brd8, Bromo domain', 'Brd8_Bromo_dom', 3, NULL),
(31207, NULL, 'IPR036571', NULL, '2-C-methyl-D-erythritol 2,4-cyclodiphosphate synthase superfamily', 'MECDP_synthase_sf', 5, NULL),
(31208, NULL, 'IPR037960', NULL, 'Ret finger protein-like, SPRY/PRY domain', 'SPRY/PRY_RFPL', 3, NULL),
(31209, NULL, 'IPR037705', NULL, 'PI3K-C2-alpha, catalytic domain', 'PI3K-C2-alpha_dom', 3, NULL),
(31210, NULL, 'IPR038432', NULL, 'PulS/OutS-like superfamily', 'PulS/OutS-like_sf', 5, NULL),
(31211, NULL, 'IPR038188', NULL, 'TorS, sensor domain superfamily', 'TorS_sensor_sf', 5, NULL),
(31212, NULL, 'IPR033423', NULL, 'Gammaproteobacterial periplasmic sensor domain GAPES4', 'GAPES4', 3, NULL),
(31213, NULL, 'IPR039742', NULL, 'Protein Shq1', 'Shq1', 4, NULL),
(31214, NULL, 'IPR039695', NULL, 'B-cell antigen receptor complex-associated protein alpha/beta chain', 'CD79a/CD79b', 4, NULL),
(31215, NULL, 'IPR039748', NULL, 'DNA-directed RNA polymerase III subunit RPC3', 'RPC3', 4, NULL),
(31216, NULL, 'IPR036475', NULL, 'Mitogen Ypm superfamily', 'Mitogen_Ypm_sf', 5, NULL),
(31217, NULL, 'IPR036469', NULL, 'Gametocyte protein Pfg27 superfamily', 'Pfg27_sf', 5, NULL),
(31218, NULL, 'IPR040426', NULL, 'Uncharacterized protein C05B5.4-like', 'C05B5.4-like', 4, NULL),
(31219, NULL, 'IPR035156', NULL, 'Protein of unknown function DUF5471', 'DUF5471', 4, NULL),
(31220, NULL, 'IPR039903', NULL, 'E3 ubiquitin-protein ligase Zswim2', 'Zswim2', 4, NULL),
(31221, NULL, 'IPR038910', NULL, 'Proline-rich protein Hua1-like', 'Hua1-like', 4, NULL),
(31222, NULL, 'IPR033905', NULL, 'Secretory peroxidase', 'Secretory_peroxidase', 3, NULL),
(31223, NULL, 'IPR038208', NULL, 'Sigma factor-binding protein Crl superfamily', 'Tscrpt_reg_Crl_sf', 5, NULL),
(31224, NULL, 'IPR036492', NULL, 'Hypothetical protein YojF superfamily', 'YojF_sf', 5, NULL),
(31225, NULL, 'IPR033921', NULL, 'DPS-like protein, ferritin-like diiron-binding domain', 'DPSL_diiron-bd_dom', 3, NULL),
(31226, NULL, 'IPR038304', NULL, 'YmgD domain superfamily', 'YmgD_sf', 5, NULL),
(31227, NULL, 'IPR038298', NULL, 'Daxx, N-terminal domain superfamily', 'Daxx_N_sf', 5, NULL),
(31228, NULL, 'IPR037545', NULL, 'Tripartite DENN domain, FNIP1/2-type', 'DENN_FNIP1/2', 3, NULL),
(31229, NULL, 'IPR038955', NULL, 'Protein PriA', 'PriA_fungi', 4, NULL),
(31230, NULL, 'IPR040221', NULL, 'CDCA7/CDA7L', 'CDCA7/CDA7L', 4, NULL),
(31231, NULL, 'IPR039718', NULL, 'Ribonucleoside-diphosphate reductase large subunit', 'Rrm1', 4, NULL),
(31232, NULL, 'IPR039456', NULL, 'WDR59, modified RING finger, H2 subclass (C3H3C2-type)', 'WDR59_mRING-H2-C3H3C2', 3, NULL),
(31233, NULL, 'IPR033719', NULL, 'N-acetylglutamate synthase, kinase-like domain', 'NAGS_kin', 3, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(31234, NULL, 'IPR036207', NULL, 'B-form DNA mimic Ocr', 'B-form_Ocr', 5, NULL),
(31235, NULL, 'IPR040312', NULL, 'FLYWCH-type zinc finger-containing protein 1/2', 'FWCH1/FWCH2', 4, NULL),
(31236, NULL, 'IPR038928', NULL, 'Protein LAZY1', 'LAZY1', 4, NULL),
(31237, NULL, 'IPR040230', NULL, 'Protease TIKI1/2-like', 'TIKI1/2-like', 4, NULL),
(31238, NULL, 'IPR040193', NULL, 'EF-hand domain-containing protein EFHC1/EFHC2/EFHB', 'EFHC1/EFHC2/EFHB', 4, NULL),
(31239, NULL, 'IPR038419', NULL, 'Poxvirus poly(A) polymerase, nucleotidyltransferase domain superfamily', 'Pox_polyA_pol_nucTrfase_sf', 5, NULL),
(31240, NULL, 'IPR038414', NULL, 'Cbb3-type cytochrome c oxidase subunit CcoP, N-terminal domain superfamily', 'CcoP_N_sf', 5, NULL),
(31241, NULL, 'IPR037644', NULL, 'Transcriptional activator MN1', 'MN1', 4, NULL),
(31242, NULL, 'IPR035828', NULL, 'TRIM6, PRY/SPRY domain', 'PRY/SPRY_TRIM6', 3, NULL),
(31243, NULL, 'IPR038291', NULL, 'SAP30, C-terminal domain superfamily', 'SAP30_C_sf', 5, NULL),
(31244, NULL, 'IPR037652', NULL, 'Mim2', 'Mim2', 4, NULL),
(31245, NULL, 'IPR039458', NULL, 'FimA-like', 'FimA-like', 4, NULL),
(31246, NULL, 'IPR040031', NULL, 'Codanin-1', 'Codanin-1', 4, NULL),
(31247, NULL, 'IPR036296', NULL, 'SKP1-like, dimerisation domain superfamily', 'SKP1-like_dim_sf', 5, NULL),
(31248, NULL, 'IPR038421', NULL, 'Sensor histidine kinase RisS, periplasmic domain superfamily', 'RisS_PPD_sf', 5, NULL),
(31249, NULL, 'IPR038434', NULL, 'YARHG domain superfamily', 'YARHG_sf', 5, NULL),
(31250, NULL, 'IPR038628', NULL, 'XkdM-like superfamily', 'XkdM-like_sf', 5, NULL),
(31251, NULL, 'IPR040224', NULL, 'RAD52 motif-containing protein 1', 'RDM1', 4, NULL),
(31252, NULL, 'IPR033428', NULL, 'Domain of unknown function DUF5118', 'DUF5118', 3, NULL),
(31253, NULL, 'IPR033239', NULL, 'Protein EVI2B', 'EVI2B', 4, NULL),
(31254, NULL, 'IPR035719', NULL, 'Fungal actin-binding protein 1, first SH3 domain', 'Abp1_fungi_SH3_C1', 3, NULL),
(31255, NULL, 'IPR040319', NULL, 'LSD1-like', 'LSD1-like', 4, NULL),
(31256, NULL, 'IPR036569', NULL, 'Sugar-phosphate isomerase, RpiB/LacA/LacB superfamily', 'RpiB_LacA_LacB_sf', 5, NULL),
(31257, NULL, 'IPR037916', NULL, 'SNX29, PX domain', 'SNX29_PX', 3, NULL),
(31258, NULL, 'IPR038626', NULL, 'Rof-like superfamily', 'Rof-like_sf', 5, NULL),
(31259, NULL, 'IPR040240', NULL, 'Transcription initiation factor TFIID subunit 1', 'TAF1', 4, NULL),
(31260, NULL, 'IPR038714', NULL, 'YfeY-like superfamily', 'YfeY-like_sf', 5, NULL),
(31261, NULL, 'IPR035723', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma-2, SH3 domain', 'PLCgamma2_SH3', 3, NULL),
(31262, NULL, 'IPR040119', NULL, 'Uncharacterized protein C10orf67-like', 'C10orf67-like', 4, NULL),
(31263, NULL, 'IPR035718', NULL, 'Fungal actin-binding protein 1, second SH3 domain', 'Abp1_fungi_SH3_C2', 3, NULL),
(31264, NULL, 'IPR039955', NULL, 'Signal peptidase complex-like protein DTM1', 'DTM1', 4, NULL),
(31265, NULL, 'IPR033910', NULL, 'Glutamyl-tRNA synthetase', 'GluRS_core', 3, NULL),
(31266, NULL, 'IPR038700', NULL, 'Thiol-activated cytolysin, C-terminal domain superfamily', 'Thiol_cytolys_C_sf', 5, NULL),
(31267, NULL, 'IPR036482', NULL, 'Hut operon regulatory protein HutP superfamily', 'Regulatory_HutP_sf', 5, NULL),
(31268, NULL, 'IPR039167', NULL, 'Mitochondrial transcription rescue factor 1', 'MTRES1', 4, NULL),
(31269, NULL, 'IPR038080', NULL, 'Kinase associated protein B superfamily', 'KapB_sf', 5, NULL),
(31270, NULL, 'IPR037707', NULL, 'PI3K-C2-gamma, catalytic domain', 'PI3K-C2-gamma_dom', 3, NULL),
(31271, NULL, 'IPR036209', NULL, 'YwmB-like superfamily', 'YwmB-like_sf', 5, NULL),
(31272, NULL, 'IPR035874', NULL, 'Iduronate-2-sulfatase', 'IDS', 4, NULL),
(31273, NULL, 'IPR040229', NULL, 'Uncharacterized membrane protein At3g27390-like', 'At3g27390-like', 4, NULL),
(31274, NULL, 'IPR038646', NULL, 'Atu4866-like superfamily', 'Atu4866-like_sf', 5, NULL),
(31275, NULL, 'IPR040370', NULL, 'Coiled-coil domain-containing protein 74A/74B/92', 'CCDC74A/CCDC74B/CCDC92', 4, NULL),
(31276, NULL, 'IPR036464', NULL, 'Rubisco LSMT, substrate-binding domain superfamily', 'Rubisco_LSMT_subst-bd_sf', 5, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(31277, NULL, 'IPR038710', NULL, 'Adenovirus Gp19K superfamily', 'Adenovirus_Gp19K_sf', 5, NULL),
(31278, NULL, 'IPR039504', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase delta-3, EF hand domain', 'PLC-delta3_EF-hand', 3, NULL),
(31279, NULL, 'IPR040443', NULL, 'PH_15 domain', 'PH_15', 3, NULL),
(31280, NULL, 'IPR041012', NULL, 'Flap endonuclease GEN, chromatin organization modifier domain', 'GEN_chromo', 3, NULL),
(31281, NULL, 'IPR041020', NULL, 'ARHGEF1-like, PH domain', 'PH_16', 3, NULL),
(31282, NULL, 'IPR033922', NULL, 'NAD(P) binding domain of glutamate dehydrogenase', 'NAD_bind_Glu_DH', 3, NULL),
(31283, NULL, 'IPR037711', NULL, 'Microtubule-associated serine/threonine-protein kinase, catalytic domain', 'MAST', 3, NULL),
(31284, NULL, 'IPR038148', NULL, 'Transposon Tn1545/Tn916, excisionase', 'Tn1545/Tn916_Xis', 5, NULL),
(31285, NULL, 'IPR038429', NULL, 'PhoQ Sensor superfamily', 'PhoQ_Sensor_sf', 5, NULL),
(31286, NULL, 'IPR035826', NULL, 'TRIM34, PRY/SPRY domain', 'TRIM34_PRY/SPRY', 3, NULL),
(31287, NULL, 'IPR038625', NULL, 'Rhodococcus equi virulence-associated superfamily', 'R_equi_Vir_sf', 5, NULL),
(31288, NULL, 'IPR038650', NULL, 'PADR1 domain superfamily', 'PADR1_dom_sf', 5, NULL),
(31289, NULL, 'IPR039959', NULL, 'Fimbrin/Plastin', 'Fimbrin/Plastin', 4, NULL),
(31290, NULL, 'IPR038440', NULL, 'FimV, C-terminal domain superfamily', 'FimV_C_sf', 5, NULL),
(31291, NULL, 'IPR037770', NULL, 'Cyclin-dependent kinase 7', 'CDK7', 4, NULL),
(31292, NULL, 'IPR036576', NULL, 'WRKY domain superfamily', 'WRKY_dom_sf', 5, NULL),
(31293, NULL, 'IPR040315', NULL, 'WD repeat-containing protein WDR46/Utp7', 'WDR46/Utp7', 4, NULL),
(31294, NULL, 'IPR039853', NULL, 'Pinin', 'Pinin', 4, NULL),
(31295, NULL, 'IPR038146', NULL, 'Bacteriophage 933W-like, putative excisionase superfamily', '933W_put_Xis_sf', 5, NULL),
(31296, NULL, 'IPR039791', NULL, 'Chorion-specific transcription factor GCM', 'GCM', 4, NULL),
(31297, NULL, 'IPR040320', NULL, 'Uncharacterized protein At4g37920-like', 'At4g37920-like', 4, NULL),
(31298, NULL, 'IPR033793', NULL, 'Cytochrome oxidase Caa3-type, subunit IV', 'Caa3-IV', 3, NULL),
(31299, NULL, 'IPR036575', NULL, 'Transcription elongation factor S-II, central domain superfamily', 'TFIIS_cen_dom_sf', 5, NULL),
(31300, NULL, 'IPR036502', NULL, 'Nickel-containing superoxide dismutase superfamily', 'NiSOD_sf', 5, NULL),
(31301, NULL, 'IPR038413', NULL, 'FTO, C-terminal domain superfamily', 'FTO_C_sf', 5, NULL),
(31302, NULL, 'IPR038674', NULL, 'CzcE superfamily', 'CzcE_sf', 5, NULL),
(31303, NULL, 'IPR038295', NULL, 'STAT1, C-terminal domain superfamily', 'STAT1_C_sf', 5, NULL),
(31304, NULL, 'IPR036499', NULL, 'Non-structural protein NSP9 superfamily, coronavirus', 'NSP9_sf_CoV', 5, NULL),
(31305, NULL, 'IPR038422', NULL, 'Cut8/Sts1 superfamily', 'Cut8/Sts1_sf', 5, NULL),
(31306, NULL, 'IPR038289', NULL, 'DVA-1 superfamily', 'DVA-1_sf', 5, NULL),
(31307, NULL, 'IPR038068', NULL, 'YcgL-like superfamily', 'YcgL-like_sf', 5, NULL),
(31308, NULL, 'IPR036494', NULL, 'Ku, C-terminal domain superfamily', 'Ku_C_sf', 5, NULL),
(31309, NULL, 'IPR038426', NULL, 'Vacuolar R-SNARE Nyv1, longin domain superfamily', 'Nyv1_longin_sf', 5, NULL),
(31310, NULL, 'IPR039507', NULL, 'Phosphatidylinositol N-acetylglucosaminyltransferase  subunit PIG-A/GPI3', 'PIG-A/GPI3', 4, NULL),
(31311, NULL, 'IPR036471', NULL, 'Colicin D superfamily', 'Colicin_D_sf', 5, NULL),
(31312, NULL, 'IPR036493', NULL, 'Hypothetical protein YunC superfamily', 'YunC_sf', 5, NULL),
(31313, NULL, 'IPR038454', NULL, 'DnaA, N-terminal domain superfamily', 'DnaA_N_sf', 5, NULL),
(31314, NULL, 'IPR035698', NULL, 'DNA-directed RNA polymerase III subunit RPC1, C-terminal', 'RNAP_III_Rpc1_C', 3, NULL),
(31315, NULL, 'IPR038444', NULL, 'DUF465 superfamily', 'DUF465_sf', 5, NULL),
(31316, NULL, 'IPR038638', NULL, 'RbpA superfamily', 'RbpA_sf', 5, NULL),
(31317, NULL, 'IPR038825', NULL, 'Apical junction component', 'Apical_junction', 4, NULL),
(31318, NULL, 'IPR041017', NULL, 'DipZ, thioredoxin-like C-terminal domain', 'Thioredoxin_10', 3, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(31319, NULL, 'IPR039795', NULL, 'E3 ubiquitin-protein ligase listerin', 'LTN1/Rkr1', 4, NULL),
(31320, NULL, 'IPR035799', NULL, 'Calbindin-32, EF-hand domain', 'EFh_CBN', 3, NULL),
(31321, NULL, 'IPR039527', NULL, 'GPI ethanolamine phosphate transferase 2', 'PIGG/GPI7', 4, NULL),
(31322, NULL, 'IPR037968', NULL, 'Protein polybromo-1, Bromodomain 5', 'PBRM1_BD5', 3, NULL),
(31323, NULL, 'IPR037704', NULL, 'PI3Kalpha, catalytic domain', 'PI3Kalpha_dom', 3, NULL),
(31324, NULL, 'IPR036302', NULL, 'Pyosin/cloacin translocation domain superfamily', 'Pyosin/cloacin_T_dom_sf', 5, NULL),
(31325, NULL, 'IPR040226', NULL, 'THH1/TOM1/TOM3', 'THH1/TOM1/TOM3', 4, NULL),
(31326, NULL, 'IPR033456', NULL, 'Protein of unknown function DUF5132', 'DUF5132', 4, NULL),
(31327, NULL, 'IPR038446', NULL, 'CEBP, ZZ domain superfamily', 'CEBP_ZZ_sf', 5, NULL),
(31328, NULL, 'IPR036573', NULL, 'Carbohydrate-binding module superfamily 5/12', 'CBM_sf_5/12', 5, NULL),
(31329, NULL, 'IPR038900', NULL, 'Transmembrane channel-like protein', 'TMC', 4, NULL),
(31330, NULL, 'IPR035720', NULL, 'SAM and SH3 domain-containing protein 1, SH3 domain', 'SASH1_SH3', 3, NULL),
(31331, NULL, 'IPR038441', NULL, 'THAP-type zinc finger superfamily', 'THAP_Znf_sf', 5, NULL),
(31332, NULL, 'IPR036490', NULL, 'Thoeris protein ThsB, TIR-like domain superfamily', 'ThsB_TIR-like_sf', 5, NULL),
(31333, NULL, 'IPR036476', NULL, 'Talin, central domain superfamily', 'Talin_cent_sf', 5, NULL),
(31334, NULL, 'IPR039739', NULL, 'RING-finger protein Mag2/Rnf10', 'Mag2/Rnf10', 4, NULL),
(31335, NULL, 'IPR033614', NULL, 'Ras association domain-containing protein 1-6', 'RASSF1-6', 4, NULL),
(31336, NULL, 'IPR039549', NULL, 'JADE2, ePHD domain', 'JADE2_ePHD', 3, NULL),
(31337, NULL, 'IPR040016', NULL, 'Exportin-6', 'XPO6', 4, NULL),
(31338, NULL, 'IPR038281', NULL, 'RTP801-like, C-terminal domain superfamily', 'RTP801-like_C_sf', 5, NULL),
(31339, NULL, 'IPR037651', NULL, 'SWR1-complex protein 3', 'Swc3', 4, NULL),
(31340, NULL, 'IPR036312', NULL, 'Bifunctional inhibitor/plant lipid transfer protein/seed storage helical domain superfamily', 'Bifun_inhib/LTP/seed_sf', 5, NULL),
(31341, NULL, 'IPR039740', NULL, 'CCR4-NOT transcription complex subunit 10', 'CNOT10', 4, NULL),
(31342, NULL, 'IPR039746', NULL, 'FOG family', 'FOG', 4, NULL),
(31343, NULL, 'IPR040220', NULL, 'Protein down-regulated in DIF1 11', 'DD11', 4, NULL),
(31344, NULL, 'IPR036300', NULL, 'Mir domain superfamily', 'MIR_dom_sf', 5, NULL),
(31345, NULL, 'IPR035686', NULL, 'Carbamoyl-phosphate synthase small subunit, GATase1 domain', 'CPSase_GATase1', 3, NULL),
(31346, NULL, 'IPR035724', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma-1, SH3 domain', 'PLCgamma1_SH3', 3, NULL),
(31347, NULL, 'IPR039703', NULL, 'Protein N-terminal amidase', 'Nta1', 4, NULL),
(31348, NULL, 'IPR036203', NULL, 'Poliovirus core protein 3a, soluble domain', 'P3A_soluble_dom', 5, NULL),
(31349, NULL, 'IPR037703', NULL, 'PI3Kdelta, catalytic domain', 'PI3Kdelta_dom', 3, NULL),
(31350, NULL, 'IPR040082', NULL, 'Gentamicin C-6'' methyltransferase (GenK-like)', 'GenK-like', 4, NULL),
(31351, NULL, 'IPR040190', NULL, 'N-acetylmuramic acid 6-phosphate etherase/glucokinase regulatory protein', 'MURQ/GCKR', 4, NULL),
(31352, NULL, 'IPR042055', NULL, 'CD9, extracellular domain', 'CD9_LEL', 3, NULL),
(31353, NULL, 'IPR036275', NULL, 'YdgH-like superfamily', 'YdgH-like_sf', 5, NULL),
(31354, NULL, 'IPR038292', NULL, 'YmfJ/YflH superfamily', 'YmfJ/YflH_sf', 5, NULL),
(31355, NULL, 'IPR040009', NULL, 'Protein Mtf2/C5D6.12-like', 'Mtf2/C5D6.12-like', 4, NULL),
(31356, NULL, 'IPR040043', NULL, 'UPF0692 protein', 'UPF0692', 4, NULL),
(31357, NULL, 'IPR039852', NULL, 'Cullin-associated NEDD8-dissociated protein 1/2', 'CAND1/CAND2', 4, NULL),
(31358, NULL, 'IPR033645', NULL, 'VirB9/CagX/TrbG, C-terminal', 'VirB9/CagX/TrbG_C', 3, NULL),
(31359, NULL, 'IPR038636', NULL, 'Capsule assembly protein Wzi superfamily', 'Wzi_sf', 5, NULL),
(31360, NULL, 'IPR038084', NULL, 'Corrinoid adenosyltransferase PduO/GlcC-like superfamily', 'PduO/GlcC-like_sf', 5, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(31361, NULL, 'IPR033906', NULL, 'Lipase, N-terminal', 'Lipase_N', 3, NULL),
(31362, NULL, 'IPR040442', NULL, 'Pyruvate kinase-like domain superfamily', 'Pyrv_Kinase-like_dom_sf', 5, NULL),
(31363, NULL, 'IPR033237', NULL, 'BMP/retinoic acid-inducible neural-specific protein', 'BRINP', 4, NULL),
(31364, NULL, 'IPR036288', NULL, 'Aconitase B, HEAT-like domain superfamily', 'Aconitase_B_HEAT-like_dom_sf', 5, NULL),
(31365, NULL, 'IPR036481', NULL, 'Bcr-Abl oncoprotein oligomerisation domain superfamily', 'Bcr-Abl_oncoprot_oligo_sf', 5, NULL),
(31366, NULL, 'IPR036486', NULL, 'Anti-Sigma Factor A superfamily', 'AsiA_sf', 5, NULL),
(31367, NULL, 'IPR039797', NULL, 'Protein Pecanex', 'Pecanex', 4, NULL),
(31368, NULL, 'IPR036472', NULL, 'Cholecystokinin A receptor, N-terminal domain superfamily', 'CholecystokininA_recpt_N_sf', 5, NULL),
(31369, NULL, 'IPR033790', NULL, 'Lectin Bc2l-C, N-terminal', 'Bc2l-C_N', 3, NULL),
(31370, NULL, 'IPR038701', NULL, 'ToxA superfamily', 'ToxA_sf', 5, NULL),
(31371, NULL, 'IPR039548', NULL, 'JADE2, PHD domain', 'JADE2_PHD', 3, NULL),
(31372, NULL, 'IPR038302', NULL, 'Envelope glycoprotein M superfamily, flavivirus', 'Env_glycoprot_M_sf_flavivir', 5, NULL),
(31373, NULL, 'IPR034967', NULL, 'CCR4-NOT transcription complex subunit 6-like', 'Deadenylase_CCR4b', 3, NULL),
(31374, NULL, 'IPR037654', NULL, 'Protein Big1', 'Big1', 4, NULL),
(31375, NULL, 'IPR035762', NULL, 'Ryanodine receptor, SPRY domain 3', 'SPRY3_RyR', 3, NULL),
(31376, NULL, 'IPR040041', NULL, 'Transmembrane protein 201', 'TMEM201', 4, NULL),
(31377, NULL, 'IPR036495', NULL, 'ORF7a superfamily, coronavirus', 'ORF7a_sf_CoV', 5, NULL),
(31378, NULL, 'IPR033753', NULL, 'Glycine cleavage system H-protein/Simiate', 'GCV_H/Fam206', 4, NULL),
(31379, NULL, 'IPR035153', NULL, 'Protein of unknown function DUF5473', 'DUF5473', 4, NULL),
(31380, NULL, 'IPR038189', NULL, 'Cdc37, Hsp90-binding domain superfamily', 'Cdc37_Hsp90-bd_sf', 5, NULL),
(31381, NULL, 'IPR033341', NULL, 'Spindle and kinetochore-associated protein 3', 'SKA3', 4, NULL),
(31382, NULL, 'IPR033792', NULL, 'Cellophane-induced protein 1', 'Cin1', 3, NULL),
(31383, NULL, 'IPR036473', NULL, 'Molybdopterin cofactor biosynthesis MoaD-related, C-terminal domain superfamily', 'Mopterin_CF_MoaD-rel_C_sf', 5, NULL),
(31384, NULL, 'IPR038411', NULL, 'PurL, C-terminal domain superfamily', 'PurL_C_sf', 5, NULL),
(31385, NULL, 'IPR040309', NULL, 'H/ACA ribonucleoprotein complex non-core subunit Naf1', 'Naf1', 4, NULL),
(31386, NULL, 'IPR036422', NULL, 'RuBisCO large subunit, N-terminal domain superfamily', 'RuBisCO_lsu_N_sf', 5, NULL),
(31387, NULL, 'IPR036277', NULL, 'SMCs flexible hinge superfamily', 'SMC_hinge_sf', 5, NULL),
(31388, NULL, 'IPR038829', NULL, 'Leukosialin', 'Leukosialin', 4, NULL),
(31389, NULL, 'IPR038449', NULL, 'SirA superfamily', 'SirA_sf', 5, NULL),
(31390, NULL, 'IPR040052', NULL, 'Splicing factor 45', 'RBM17', 4, NULL),
(31391, NULL, 'IPR040222', NULL, 'ALOG  family', 'ALOG', 4, NULL),
(31392, NULL, 'IPR041835', NULL, 'Rab-like protein 2', 'RabL2', 4, NULL),
(31393, NULL, 'IPR036570', NULL, 'HORMA domain superfamily', 'HORMA_dom_sf', 5, NULL),
(31394, NULL, 'IPR035681', NULL, 'ComA-like, MBL domain', 'ComA-like_MBL', 3, NULL),
(31395, NULL, 'IPR040365', NULL, 'EF-hand domain-containing protein D1/2', 'EFHD1/2', 4, NULL),
(31396, NULL, 'IPR038202', NULL, 'Regulatory protein cro superfamily', 'Cro_sf', 5, NULL),
(31397, NULL, 'IPR038451', NULL, 'Arterivirus nsp7 alpha superfamily', 'Arteri_nsp7a_sf', 5, NULL),
(31398, NULL, 'IPR038204', NULL, 'Antibacterial factor-related peptide superfamily', 'Abf-1/2_sf', 5, NULL),
(31399, NULL, 'IPR033620', NULL, 'Coiled-coil-helix-coiled-coil-helix domain-containing protein 1', 'CHCHD1', 4, NULL),
(31400, NULL, 'IPR040214', NULL, 'Uncharacterized protein KIAA2026', 'KIAA2026', 4, NULL),
(31401, NULL, 'IPR036466', NULL, 'Pollen allergen ole e 6 superfamily', 'Pollen_allergen_ole-e-6_sf', 5, NULL),
(31402, NULL, 'IPR034804', NULL, 'Fumarate reductase/succinate dehydrogenase, transmembrane subunit', 'SQR/QFR_C/D', 5, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(31403, NULL, 'IPR035682', NULL, 'Phosphonate metabolism protein, MBL domain', 'PhnP_MBL', 3, NULL),
(31404, NULL, 'IPR037918', NULL, 'SNX2, PX domain', 'SNX2_PX', 3, NULL),
(31405, NULL, 'IPR038408', NULL, 'Gnk2-homologous domain superfamily', 'GNK2_sf', 5, NULL),
(31406, NULL, 'IPR040070', NULL, 'Immunity-related GTPase family Q protein', 'IRGQ', 4, NULL),
(31407, NULL, 'IPR036489', NULL, 'YoaG superfamily', 'YoaG_sf', 5, NULL),
(31408, NULL, 'IPR033774', NULL, 'Yaf2/RYBP C-terminal binding motif', 'YAF2_RYBP', 2, NULL),
(31409, NULL, 'IPR038456', NULL, 'Macin superfamily', 'Macin_sf', 5, NULL),
(31410, NULL, 'IPR040034', NULL, 'Centromere protein H', 'CENP-H', 4, NULL),
(31411, NULL, 'IPR039701', NULL, 'HCLS1-binding protein 3', 'HS1BP3', 4, NULL),
(31412, NULL, 'IPR041851', NULL, 'RecBCD enzyme subunit RecD, N-terminal domain', 'RecD_N', 5, NULL),
(31413, NULL, 'IPR038301', NULL, 'AraC-like superfamily', 'AraC-like_sf', 5, NULL),
(31414, NULL, 'IPR040044', NULL, 'SRR1-like protein', 'SRR1L', 4, NULL),
(31415, NULL, 'IPR039857', NULL, 'Intraflagellar transport protein 122 homolog', 'Ift122', 4, NULL),
(31416, NULL, 'IPR041015', NULL, 'Toll-like receptor 3 trans-membrane domain', 'TLR3_TMD', 3, NULL),
(31417, NULL, 'IPR033427', NULL, 'Domain of unknown function DUF5123', 'DUF5123', 3, NULL),
(31418, NULL, 'IPR040425', NULL, 'Uncharacterized protein C20orf141-like', 'C20orf141-like', 4, NULL),
(31419, NULL, 'IPR033532', NULL, 'Arabinose metabolism transcriptional repressor, ligand-binding domain', 'AraR_ligand_bind_dom', 3, NULL),
(31420, NULL, 'IPR035417', NULL, 'FACT complex subunit SSRP1/POB3, N-terminal PH domain', 'SSRP1/POB3_N', 3, NULL),
(31421, NULL, 'IPR038277', NULL, 'UreF domain superfamily', 'UreF_sf', 5, NULL),
(31422, NULL, 'IPR035516', NULL, 'DNA gyrase/topoisomerase IV, subunit A, C-terminal', 'Gyrase/topoIV_suA_C', 5, NULL),
(31423, NULL, 'IPR040311', NULL, 'Coiled-coil domain-containing protein 3', 'CCDC3', 4, NULL),
(31424, NULL, 'IPR035813', NULL, 'Secreted frizzled-related protein 3, NTR domain', 'NTR_Sfrp3', 3, NULL),
(31425, NULL, 'IPR036317', NULL, 'Cullin homology domain superfamily', 'Cullin_homology_sf', 5, NULL),
(31426, NULL, 'IPR036468', NULL, 'AHSP superfamily', 'AHSP_sf', 5, NULL),
(31427, NULL, 'IPR039793', NULL, 'Uroporphyrinogen-III synthase', 'UROS/Hem4', 4, NULL),
(31428, NULL, 'IPR034031', NULL, 'Tumor necrosis factor receptor 14/UL144, N-terminal', 'TNFRSF14/UL144_N', 3, NULL),
(31429, NULL, 'IPR040250', NULL, 'Nucleobindin', 'Nucleobindin', 4, NULL),
(31430, NULL, 'IPR041836', NULL, 'Rab20', 'Rab20', 4, NULL),
(31431, NULL, 'IPR035766', NULL, 'SPRY domain-containing protein 7', 'SPRYD7', 4, NULL),
(31432, NULL, 'IPR038436', NULL, 'Effector protein NleG superfamily', 'Effector_NleG_sf', 5, NULL),
(31433, NULL, 'IPR039506', NULL, 'SpoOB, alpha-helical domain', 'SPOB_a', 3, NULL),
(31434, NULL, 'IPR033437', NULL, 'Protein of unknown function DUF5130', 'DUF5130', 4, NULL),
(31435, NULL, 'IPR036691', NULL, 'Endonuclease/exonuclease/phosphatase superfamily', 'Endo/exonu/phosph_ase_sf', 5, NULL),
(31436, NULL, 'IPR038279', NULL, 'Ndc10, domain 2 superfamily', 'Ndc10_dom2_sf', 5, NULL),
(31437, NULL, 'IPR040046', NULL, 'Protein FAM228', 'FAM228', 4, NULL),
(31438, NULL, 'IPR037913', NULL, 'Small heat shock protein IbpA/IbpB, ACD domain', 'ACD_IbpA/B', 3, NULL),
(31439, NULL, 'IPR038282', NULL, 'Uncharacterized conserved protein DUF2267 superfamily', 'DUF2267_sf', 5, NULL),
(31440, NULL, 'IPR040118', NULL, 'Coiled-coil domain-containing protein 144A/B/C', 'C144A/B/C', 4, NULL),
(31441, NULL, 'IPR038407', NULL, 'Vesicle transport v-SNARE, N-terminal domain superfamily', 'v-SNARE_N_sf', 5, NULL),
(31442, NULL, 'IPR033424', NULL, 'Membrane-associated sensor domain', 'MASE4', 3, NULL),
(31443, NULL, 'IPR037794', NULL, 'Transcription initiation factor TFIID subunit 12', 'TAF12', 4, NULL),
(31444, NULL, 'IPR040054', NULL, '28S ribosomal protein S18b, mitochondrial', 'MRPS18B', 4, NULL),
(31445, NULL, 'IPR038203', NULL, 'Diapausin superfamily', 'Diapausin_sf', 5, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(31446, NULL, 'IPR038416', NULL, 'Sigma 54 modulation/S30EA ribosomal protein, C-terminal domain superfamily', 'Ribosom_S30AE_C_sf', 5, NULL),
(31447, NULL, 'IPR038442', NULL, 'Dsl1, N-terminal domain superfamily', 'Dsl1_N_sf', 5, NULL),
(31448, NULL, 'IPR039724', NULL, 'WD repeat-containing protein 91', 'WDR91', 4, NULL),
(31449, NULL, 'IPR040423', NULL, 'Phosphoethanolamine transferase', 'PEA_transferase', 4, NULL),
(31450, NULL, 'IPR037962', NULL, 'Neuralized', 'Neuralized', 4, NULL),
(31451, NULL, 'IPR038927', NULL, 'Uncharacterized protein C6orf163', 'C6orf163', 4, NULL),
(31452, NULL, 'IPR040316', NULL, 'Integrator complex subunit 5', 'INTS5', 4, NULL),
(31453, NULL, 'IPR038066', NULL, 'Spc24, Fungi, globular domain superfamily', 'Spc24_Fungi_globular_sf', 5, NULL),
(31454, NULL, 'IPR035416', NULL, 'Protein of unknown function DUF5376', 'DUF5376', 4, NULL),
(31455, NULL, 'IPR038704', NULL, 'YEATS superfamily', 'YEAST_sf', 5, NULL),
(31456, NULL, 'IPR040074', NULL, 'BssD/PflA/YjjW', 'BssD/PflA/YjjW', 4, NULL),
(31457, NULL, 'IPR038437', NULL, 'GINS complex, subunit Psf3 superfamily', 'GINS_Psf3_sf', 5, NULL),
(31458, NULL, 'IPR038274', NULL, 'Atg6/Beclin C-terminal domain superfamily', 'Atg6/Beclin_C_sf', 5, NULL),
(31459, NULL, 'IPR033791', NULL, 'Pesticin,  translocation and receptor binding domain', 'Pesticin_N_RB', 3, NULL),
(31460, NULL, 'IPR033881', NULL, 'von Willebrand factor domain BatA-type', 'vWA_BatA_type', 3, NULL),
(31461, NULL, 'IPR039550', NULL, 'JADE3, PHD domain', 'JADE3_PHD', 3, NULL),
(31462, NULL, 'IPR033438', NULL, 'Modulator of levamisole receptor-1', 'MOLO1', 4, NULL),
(31463, NULL, 'IPR033238', NULL, 'B-cell lymphoma/leukemia 10/E10', 'BCL10/E10', 4, NULL),
(31464, NULL, 'IPR041999', NULL, 'Sortase D, type 1', 'Sortase_D_1', 4, NULL),
(31465, NULL, 'IPR040310', NULL, 'Uncharacterized protein DDB_G0292248-like', 'DDB_G0292248-like', 4, NULL),
(31466, NULL, 'IPR038904', NULL, 'BRCA1-associated ATM activator 1', 'BRAT1', 4, NULL),
(31467, NULL, 'IPR039751', NULL, 'Homocysteine-responsive endoplasmic reticulum-resident ubiquitin-like domain member 1 /2', 'HERPUD1/2', 4, NULL),
(31468, NULL, 'IPR035872', NULL, '2-epi-5-epi-valiolone synthase-like', 'EEVS-like', 4, NULL),
(31469, NULL, 'IPR038299', NULL, 'Alpha-glycerophosphate oxidase, C-terminal domain superfamily', 'DAO_C_sf', 5, NULL),
(31470, NULL, 'IPR034386', NULL, '2-Deoxy-scyllo-inosamine dehydrogenase (BtrN-like)', 'BtrN-like', 4, NULL),
(31471, NULL, 'IPR036291', NULL, 'NAD(P)-binding domain superfamily', 'NAD(P)-bd_dom_sf', 5, NULL),
(31472, NULL, 'IPR036491', NULL, 'YugN-like superfamily', 'YugN-like_sf', 5, NULL),
(31473, NULL, 'IPR036690', NULL, 'Ferrodoxin-fold anticodon-binding domain superfamily', 'Fdx_antiC-bd_sf', 5, NULL),
(31474, NULL, 'IPR040005', NULL, 'Uncharacterized protein ZNRD1-AS1', 'ZNRD1-AS1', 4, NULL),
(31475, NULL, 'IPR033621', NULL, 'TRAF-interacting protein with FHA domain-containing protein', 'TIFA', 4, NULL),
(31476, NULL, 'IPR036316', NULL, 'Pili assembly chaperone, C-terminal domain superfamily', 'Pili_assmbl_chap_C_dom_sf', 5, NULL),
(31477, NULL, 'IPR036497', NULL, 'Glycolipid transfer protein superfamily', 'GLTP_sf', 5, NULL),
(31478, NULL, 'IPR036123', NULL, 'Methane monooxygenase, gamma chain superfamily', 'Me_mOase_sf_g', 5, NULL),
(31479, NULL, 'IPR035717', NULL, 'Drebrin-like protein, SH3 domain', 'Drebrin-like_SH3', 3, NULL),
(31480, NULL, 'IPR036498', NULL, 'Scaffold protein Nfu/NifU, N-terminal domain superfamily', 'Nfu/NifU_N_sf', 5, NULL),
(31481, NULL, 'IPR039476', NULL, 'Pyridinium-3,5-biscarboxylic acid mononucleotide synthase', 'P2CMN_synthase_LarB', 4, NULL),
(31482, NULL, 'IPR038288', NULL, 'Peptidoglycan hydrolase Gp5 superfamily', 'Gp5_sf', 5, NULL),
(31483, NULL, 'IPR038902', NULL, 'Integrator complex subunit 1', 'INTS1', 4, NULL),
(31484, NULL, 'IPR041837', NULL, 'Rab27a/b', 'Rab27a/b', 4, NULL),
(31485, NULL, 'IPR036496', NULL, 'Cathepsin C, exclusion domain superfamily', 'CathepsinC_exc_dom_sf', 5, NULL),
(31486, NULL, 'IPR040120', NULL, 'Uncharacterized protein C19orf44-like', 'C19orf44-like', 4, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(31487, NULL, 'IPR033136', NULL, 'NAD-dependent DNA ligase, conserved site', 'DNA_ligase_CS', 2, NULL),
(31488, NULL, 'IPR038452', NULL, 'Channel forming colicin, central receptor recognition domain superfamily', 'Channel_colicin_cen_sf', 5, NULL),
(31489, NULL, 'IPR039865', NULL, 'Serine/threonine-protein phosphatase 2A regulatory subunit B'''' subunit gamma', 'PPP2R3C', 4, NULL),
(31490, NULL, 'IPR038827', NULL, 'Coiled-coil domain-containing protein 152', 'CCDC152', 4, NULL),
(31491, NULL, 'IPR033458', NULL, 'Protein of unknown function DUF5134', 'DUF5134', 4, NULL),
(31492, NULL, 'IPR036484', NULL, 'Protein-tyrosine phosphatase, YopH, N-terminal domain superfamily', 'ProtTyrPase_YopH_N_sf', 5, NULL),
(31493, NULL, 'IPR036284', NULL, 'G-protein gamma-like domain superfamily', 'GGL_sf', 5, NULL),
(31494, NULL, 'IPR033435', NULL, 'Domain of unknown function DUF5129', 'DUF5129', 3, NULL),
(31495, NULL, 'IPR042056', NULL, 'E3 ubiquitin-protein ligase MIB1/2, zinc finger, ZZ-type', 'MIB1/2_ZZ', 3, NULL),
(31496, NULL, 'IPR035721', NULL, 'SAM and SH3 domain-containing protein 3, SH3 domain', 'SASH3_SH3', 3, NULL),
(31497, NULL, 'IPR040202', NULL, 'Nucleus export protein  Brl1/Brr6', 'Brl1/Brr6', 4, NULL),
(31498, NULL, 'IPR033626', NULL, 'Class II PurE', 'PurE_classII', 3, NULL),
(31499, NULL, 'IPR039190', NULL, 'Tetratricopeptide repeat protein 14', 'TTC14', 4, NULL),
(31500, NULL, 'IPR033459', NULL, 'Spirocyclase AveC-like', 'AveC-like', 4, NULL),
(31501, NULL, 'IPR037749', NULL, 'Extended synaptotagmin, C2B domain', 'Ext_Synaptotagmin_C2B', 3, NULL),
(31502, NULL, 'IPR038125', NULL, 'HTHP domain superfamily', 'HTHP_sf', 5, NULL),
(31503, NULL, 'IPR038137', NULL, 'Excisionase-like superfamily', 'Excisionase-like_sf', 5, NULL),
(31504, NULL, 'IPR042074', NULL, 'Mycoplasma arthritidis-derived mitogen, C-terminal', 'M_arthritidis-der_mitogen_C', 5, NULL),
(31505, NULL, 'IPR037190', NULL, 'LIS1, N-terminal', 'LIS1_N', 5, NULL),
(31506, NULL, 'IPR039101', NULL, 'Thioredoxin-related transmembrane protein 2', 'TMX2', 4, NULL),
(31507, NULL, 'IPR037822', NULL, 'STXBP6, SNARE domain', 'STXBP6_SNARE', 3, NULL),
(31508, NULL, 'IPR040301', NULL, 'Secretoglobin 3A', 'Secretoglobin_3A', 4, NULL),
(31509, NULL, 'IPR036434', NULL, '1, 4-beta cellobiohydrolase superfamily', 'Beta_cellobiohydrolase_sf', 5, NULL),
(31510, NULL, 'IPR035275', NULL, 'Small integral membrane protein 3', 'Smim3', 4, NULL),
(31511, NULL, 'IPR035296', NULL, 'Mating hormone A-factor 1/2', 'Mfa1/2', 4, NULL),
(31512, NULL, 'IPR033785', NULL, 'Pichia pastoris 6-phosphofructokinase, gamma subunit', 'PpPFK_gamma', 4, NULL),
(31513, NULL, 'IPR036735', NULL, 'NusG, N-terminal domain superfamily', 'NGN_dom_sf', 5, NULL),
(31514, NULL, 'IPR040532', NULL, 'MapZ, extracellular C-terminal domain 2', 'MapZ_C2', 3, NULL),
(31515, NULL, 'IPR035986', NULL, 'PKD domain superfamily', 'PKD_dom_sf', 5, NULL),
(31516, NULL, 'IPR035775', NULL, 'CD2-associated protein, first SH3 domain', 'CD2AP_SH3_1', 3, NULL),
(31517, NULL, 'IPR036304', NULL, 'Hypothetical protein MTH1184', 'MTH1184', 5, NULL),
(31518, NULL, 'IPR035868', NULL, 'Ras and Rab interactor 2, SH2 domain', 'RIN2_SH2', 3, NULL),
(31519, NULL, 'IPR036732', NULL, 'Antifreeze-like/N-acetylneuraminic acid synthase C-terminal domain superfamily', 'AFP_Neu5c_C_sf', 5, NULL),
(31520, NULL, 'IPR036772', NULL, 'SRCR-like domain superfamily', 'SRCR-like_dom_sf', 5, NULL),
(31521, NULL, 'IPR038126', NULL, 'RAMP domain superfamily', 'RAMP_sf', 5, NULL),
(31522, NULL, 'IPR033683', NULL, 'Tyrosine recombinase XerH', 'XerH', 4, NULL),
(31523, NULL, 'IPR037881', NULL, 'RGS14, RGS domain', 'RGS14_RGS', 3, NULL),
(31524, NULL, 'IPR040107', NULL, 'U4/U6.U5 small nuclear ribonucleoprotein component Snu23', 'Snu23', 4, NULL),
(31525, NULL, 'IPR038791', NULL, 'Cilia- and flagella-associated protein 97', 'Cfap97/Hemingway', 4, NULL),
(31526, NULL, 'IPR039255', NULL, 'Large ribosomal RNA subunit accumulation protein YceD, bacteria', 'YceD_bac', 4, NULL),
(31527, NULL, 'IPR040604', NULL, 'Domain of unknown function DUF5632', 'DUF5632', 3, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(31528, NULL, 'IPR037178', NULL, 'Colicin D, C-terminal domain superfamily', 'ColicinD_C_sf', 5, NULL),
(31529, NULL, 'IPR035771', NULL, 'SH3 domain-containing kinase-binding protein 1, second SH3 domain', 'CIN85_SH3_2', 3, NULL),
(31530, NULL, 'IPR037249', NULL, 'TAFH/NHR1 domain superfamily', 'TAFH/NHR1_dom_sf', 5, NULL),
(31531, NULL, 'IPR042078', NULL, 'Lysine tRNA ligase, stem contact fold domain', 'Lys-tRNA-ligase_SC_fold', 5, NULL),
(31532, NULL, 'IPR037189', NULL, 'HBS1-like protein, N-terminal domain superfamily', 'HBS1-like_N_sf', 5, NULL),
(31533, NULL, 'IPR042064', NULL, 'POLG2, C-terminal', 'POLG2_C', 3, NULL),
(31534, NULL, 'IPR037823', NULL, 'Myotubularin-related protein 13, PH-GRAM domain', 'MTMR13_PH-GRAM', 3, NULL),
(31535, NULL, 'IPR035542', NULL, 'Cyclophilin-RNA interacting protein', 'CRIP', 4, NULL),
(31536, NULL, 'IPR038132', NULL, 'Vps16, C-terminal domain superfamily', 'Vps16_C_sf', 5, NULL),
(31537, NULL, 'IPR037884', NULL, 'LARG, RGS domain', 'LARG_RGS', 3, NULL),
(31538, NULL, 'IPR035291', NULL, 'Protein of unknown function DUF5354', 'DUF5354', 4, NULL),
(31539, NULL, 'IPR037775', NULL, 'C2CD3, C2 domain', 'C2_C2CD3', 3, NULL),
(31540, NULL, 'IPR036710', NULL, 'RNA polymerase Rpb5, N-terminal domain superfamily', 'RNA_pol_Rpb5_N_sf', 5, NULL),
(31541, NULL, 'IPR033659', NULL, 'Ferrochelatase, N-terminal', 'Ferrochelatase_N', 3, NULL),
(31542, NULL, 'IPR038944', NULL, 'Outer envelope membrane protein 7-like', 'OEP7-like', 4, NULL),
(31543, NULL, 'IPR036439', NULL, 'Dockerin domain superfamily', 'Dockerin_dom_sf', 5, NULL),
(31544, NULL, 'IPR038946', NULL, 'F-box only protein 47', 'FBXO47', 4, NULL),
(31545, NULL, 'IPR036169', NULL, 'DXP reductoisomerase, C-terminal domain superfamily', 'DXPR_C_sf', 5, NULL),
(31546, NULL, 'IPR040528', NULL, 'Lectin-like domain', 'Lectin-like', 3, NULL),
(31547, NULL, 'IPR036408', NULL, 'Photosystem I PsaA/PsaB superfamily', 'PSI_PsaA/B_sf', 5, NULL),
(31548, NULL, 'IPR040610', NULL, 'SNRNP25, ubiquitin-like domain', 'SNRNP25_ubiquitin', 3, NULL),
(31549, NULL, 'IPR036289', NULL, 'Hypothetical protein YfhH', 'YfhH', 5, NULL),
(31550, NULL, 'IPR035838', NULL, 'SYK/ZAP-70, N-terminal SH2 domain', 'SYK/ZAP-70_N_SH2', 3, NULL),
(31551, NULL, 'IPR036280', NULL, 'Multiheme cytochrome superfamily', 'Multihaem_cyt_sf', 5, NULL),
(31552, NULL, 'IPR036297', NULL, 'PG0816-like superfamily', 'PG0816-like_sf', 5, NULL),
(31553, NULL, 'IPR036723', NULL, 'Alpha-catenin/vinculin-like superfamily', 'Alpha-catenin/vinculin-like_sf', 5, NULL),
(31554, NULL, 'IPR036734', NULL, 'Neurotransmitter-gated ion-channel ligand-binding domain superfamily', 'Neur_chan_lig-bd_sf', 5, NULL),
(31555, NULL, 'IPR036847', NULL, 'Ribosome maturation factor RimP, C-terminal domain superfamily', 'RimP_C_sf', 5, NULL),
(31556, NULL, 'IPR038077', NULL, 'Troponin domain superfamily', 'Troponin_sf', 5, NULL),
(31557, NULL, 'IPR037722', NULL, 'Ferlin, third C2 domain', 'C2C_Ferlin', 3, NULL),
(31558, NULL, 'IPR036406', NULL, 'Oxygen-dependent coproporphyrinogen III oxidase superfamily', 'Coprogen_oxidase_aer_sf', 5, NULL),
(31559, NULL, 'IPR039267', NULL, 'U7 snRNA-associated Sm-like protein Lsm11', 'Lsm11', 4, NULL),
(31560, NULL, 'IPR037876', NULL, 'Heat shock protein beta-1, ACD domain', 'ACD_HspB1', 3, NULL),
(31561, NULL, 'IPR036287', NULL, 'Rv1873-like superfamily', 'Rv1873-like_sf', 5, NULL),
(31562, NULL, 'IPR035867', NULL, 'Ras and Rab interactor 1, SH2 domain', 'RIN1_SH2', 3, NULL),
(31563, NULL, 'IPR040171', NULL, 'Harmonin-binding protein USHBP1-like', 'USBP1-like', 4, NULL),
(31564, NULL, 'IPR035777', NULL, 'CD2-associated protein, third SH3 domain', 'CD2AP_SH3_3', 3, NULL),
(31565, NULL, 'IPR036264', NULL, 'Bacterial exopeptidase dimerisation domain', 'Bact_exopeptidase_dim_dom', 5, NULL),
(31566, NULL, 'IPR036037', NULL, 'Class XVII myosin, motor domain', 'MYSc_Myo17', 3, NULL),
(31567, NULL, 'IPR036854', NULL, 'Photosystem II protein D1/D2 superfamily', 'Photo_II_D1/D2_sf', 5, NULL),
(31568, NULL, 'IPR036702', NULL, 'ComB-like superfamily', 'ComB-like_sf', 5, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(31569, NULL, 'IPR037241', NULL, 'E2F-DP heterodimerization region', 'E2F-DP_heterodim', 5, NULL),
(31570, NULL, 'IPR040204', NULL, 'E3 ubiquitin-protein ligase UBR7', 'UBR7', 4, NULL),
(31571, NULL, 'IPR038512', NULL, 'GpU-like superfamily', 'GpU-like_sf', 5, NULL),
(31572, NULL, 'IPR037832', NULL, 'Vav, PH domain', 'PH_Vav', 3, NULL),
(31573, NULL, 'IPR033998', NULL, 'Fas receptor, death domain', 'TNFRSF6_death', 3, NULL),
(31574, NULL, 'IPR038722', NULL, 'Ner, winged helix-turn-helix DNA-binding domain', 'Ner_HTH_dom', 3, NULL),
(31575, NULL, 'IPR040249', NULL, 'Ricin B-like lectin EULS3-like', 'Ricin_B-like_lectin_EULS3-like', 4, NULL),
(31576, NULL, 'IPR037214', NULL, 'TROVE domain superfamily', 'TROVE_dom_sf', 5, NULL),
(31577, NULL, 'IPR036444', NULL, 'Phospholipase A2 domain superfamily', 'PLipase_A2_dom_sf', 5, NULL),
(31578, NULL, 'IPR036453', NULL, 'Glutamyl tRNA-reductase dimerization domain superfamily', 'GluRdtase_dimer_dom_sf', 5, NULL),
(31579, NULL, 'IPR038079', NULL, 'PA2021-like domain superfamily', 'PA2021-like_sf', 5, NULL),
(31580, NULL, 'IPR036987', NULL, 'SRA-YDG superfamily', 'SRA-YDG_sf', 5, NULL),
(31581, NULL, 'IPR038725', NULL, 'General stress protein, FMN-binding split barrel domain', 'YdaG_split_barrel_FMN-bd', 3, NULL),
(31582, NULL, 'IPR036267', NULL, 'RuvA, C-terminal domain superfamily', 'RuvA_C_sf', 5, NULL),
(31583, NULL, 'IPR036739', NULL, 'SLC41A/MgtE divalent cation transporters, integral membrane domain superfamily', 'SLC41_membr_dom_sf', 5, NULL),
(31584, NULL, 'IPR036707', NULL, 'Cell division topological specificity factor MinE superfamily', 'MinE_sf', 5, NULL),
(31585, NULL, 'IPR033788', NULL, 'Antitoxin VbhA-like', 'VbhA-like', 3, NULL),
(31586, NULL, 'IPR037833', NULL, 'SNX27, PX domain', 'SNX27_PX', 3, NULL),
(31587, NULL, 'IPR040276', NULL, 'Uncharacterized protein At4g26450-like', 'At4g26450-like', 4, NULL),
(31588, NULL, 'IPR037880', NULL, 'RGS12, RGS domain', 'RGS12_RGS', 3, NULL),
(31589, NULL, 'IPR037246', NULL, 'Extracellular hemoglobin linker subunit, heterodimerisation domain', 'Extrac_hemoglob_link_heterodim', 5, NULL),
(31590, NULL, 'IPR042072', NULL, 'DsrC-like protein, C-terminal domain', 'DsrC-like_C', 5, NULL),
(31591, NULL, 'IPR037192', NULL, 'ERO1-like superfamily', 'ERO1-like_sf', 5, NULL),
(31592, NULL, 'IPR036726', NULL, 'GTP1/OBG domain superfamily', 'GTP1_OBG_dom_sf', 5, NULL),
(31593, NULL, 'IPR038938', NULL, 'Beta-carotene isomerase D27-like', 'D27-like', 4, NULL),
(31594, NULL, 'IPR040524', NULL, 'E3 ubiquitin-protein ligase HECW1, helical box domain', 'HECW1_helix', 3, NULL),
(31595, NULL, 'IPR040607', NULL, 'Actin-like protein, N-terminal', 'ALP_N', 3, NULL),
(31596, NULL, 'IPR036274', NULL, 'HR1 repeat superfamily', 'HR1_rpt_sf', 5, NULL),
(31597, NULL, 'IPR037924', NULL, 'Pelle, death domain', 'Pelle_death', 3, NULL),
(31598, NULL, 'IPR037180', NULL, 'Hypothetical protein HI1480', 'HI1480', 5, NULL),
(31599, NULL, 'IPR033824', NULL, 'D-aminopeptidase DppA', 'DppA', 4, NULL),
(31600, NULL, 'IPR036451', NULL, 'Cobalamin adenosyltransferase-like superfamily', 'CblAdoTrfase-like_sf', 5, NULL),
(31601, NULL, 'IPR036301', NULL, 'Necrosis inducing protein-1 superfamily', 'NIP1_sf', 5, NULL),
(31602, NULL, 'IPR035839', NULL, 'SH2D4B, SH2 domain', 'SH2D4B_SH2', 3, NULL),
(31603, NULL, 'IPR038745', NULL, 'AT4G37440-like', 'AT4G37440-like', 3, NULL),
(31604, NULL, 'IPR037282', NULL, 'F-actin-capping protein subunit alpha/beta', 'CapZ_alpha/beta', 5, NULL),
(31605, NULL, 'IPR040096', NULL, 'RAB6A-GEF complex partner protein 1', 'Ric1', 4, NULL),
(31606, NULL, 'IPR033787', NULL, 'ssDNA-binding protein ThermoDBP', 'ThermoDBP', 3, NULL),
(31607, NULL, 'IPR036283', NULL, 'NOB1 zinc finger-like superfamily', 'NOB1_Zf-like_sf', 5, NULL),
(31608, NULL, 'IPR037300', NULL, 'Perforin-1, C2 domain', 'Perforin-1_C2', 3, NULL),
(31609, NULL, 'IPR039972', NULL, 'Sarcoglycan gamma/delta/zeta', 'Sarcoglycan_gamma/delta/zeta', 4, NULL),
(31610, NULL, 'IPR040595', NULL, 'EZH2, N-terminal domain', 'EZH2_N', 3, NULL),
(31611, NULL, 'IPR036901', NULL, 'Aspartate/ornithine carbamoyltransferase superfamily', 'Asp/Orn_carbamoylTrfase_sf', 5, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(31612, NULL, 'IPR036706', NULL, 'Vitelline membrane outer layer protein I (VOMI) superfamily', 'VOMI_sf', 5, NULL),
(31613, NULL, 'IPR036990', NULL, 'Metallocarboxypeptidase-like, propeptide', 'M14A-like_propep', 5, NULL),
(31614, NULL, 'IPR036843', NULL, 'D-lysine 5,6-aminomutase beta subunit KamE, N-terminal domain superfamily', 'KamE_N_sf', 5, NULL),
(31615, NULL, 'IPR039102', NULL, 'Protein FAM13', 'FAM13', 4, NULL),
(31616, NULL, 'IPR037179', NULL, 'Nucleocapsid protein, C-terminal', 'Nucleocapsid_C', 5, NULL),
(31617, NULL, 'IPR036564', NULL, 'AF0941-like superfamily', 'AF0941-like_sf', 5, NULL),
(31618, NULL, 'IPR037831', NULL, 'SNX17/27/31', 'SNX17/27/31', 4, NULL),
(31619, NULL, 'IPR036176', NULL, 'E2 domain superfamily', 'E2_sf', 5, NULL),
(31620, NULL, 'IPR035837', NULL, 'Tyrosine-protein kinase ABL, SH2 domain', 'ABL_SH2', 3, NULL),
(31621, NULL, 'IPR035272', NULL, 'Protein of unknown function DUF5351', 'DUF5351', 4, NULL),
(31622, NULL, 'IPR040519', NULL, 'LepB, N-terminal', 'LepB_N', 3, NULL),
(31623, NULL, 'IPR037862', NULL, 'PLC-beta, PH domain', 'PLC-beta_PH', 3, NULL),
(31624, NULL, 'IPR033162', NULL, 'Tubulin-folding cofactor D', 'TBCD', 4, NULL),
(31625, NULL, 'IPR038947', NULL, 'At3g27210-like', 'At3g27210-like', 4, NULL),
(31626, NULL, 'IPR037816', NULL, 'DOK4/5/6, PH domain', 'DOK4/5/6_PH', 3, NULL),
(31627, NULL, 'IPR035866', NULL, 'SOCS7, SH2 domain', 'SOCS7_SH2', 3, NULL),
(31628, NULL, 'IPR036773', NULL, 'TGF-beta binding (TB) domain superfamily', 'TB_dom_sf', 5, NULL),
(31629, NULL, 'IPR040526', NULL, 'Inulin fructotransferase, beta helix repeat', 'Beta_helix_2', 7, NULL),
(31630, NULL, 'IPR040094', NULL, 'Fatty acid-binding protein homologue 1/2/3/4', 'Lbp1-4', 4, NULL),
(31631, NULL, 'IPR036716', NULL, 'Pesticidal crystal protein, N-terminal domain superfamily', 'Pest_crys_N_sf', 5, NULL),
(31632, NULL, 'IPR036309', NULL, 'T4 recombination endonuclease VII, dimerisation domain superfamily', 'T4_recomb_endonuclease_dim_sf', 5, NULL),
(31633, NULL, 'IPR037879', NULL, 'RGS10, RGS domain', 'RGS10_RGS', 3, NULL),
(31634, NULL, 'IPR033575', NULL, 'DET1- and DDB1-associated protein 1', 'DDA1', 4, NULL),
(31635, NULL, 'IPR042080', NULL, 'RNA 2''-phosphotransferase, N-terminal domain', 'RNA_2''-PTrans_N', 5, NULL),
(31636, NULL, 'IPR038948', NULL, 'Protein POLR1D, isoform 2-like', 'POLR1D-like', 4, NULL),
(31637, NULL, 'IPR040095', NULL, 'KRBA1', 'KRBA1', 4, NULL),
(31638, NULL, 'IPR040613', NULL, 'Nucleotide modification associated domain 4', 'Nmad4', 3, NULL),
(31639, NULL, 'IPR036440', NULL, 'Peptidase C15, pyroglutamyl peptidase I-like superfamily', 'Peptidase_C15-like_sf', 5, NULL),
(31640, NULL, 'IPR033832', NULL, 'Pigment epithelium derived factor, serpin domain', 'PEDF_serpin_dom', 3, NULL),
(31641, NULL, 'IPR033316', NULL, 'DNA endonuclease RBBP8-like', 'RBBP8-like', 4, NULL),
(31642, NULL, 'IPR035581', NULL, 'Domain of unknown function DUF5465', 'DUF5465', 3, NULL),
(31643, NULL, 'IPR036849', NULL, 'Enolase-like, C-terminal domain superfamily', 'Enolase-like_C_sf', 5, NULL),
(31644, NULL, 'IPR037806', NULL, 'ARHGEF2, PH domain', 'ARHGEF2_PH', 3, NULL),
(31645, NULL, 'IPR040299', NULL, 'Protein FERTILITY RESTORER RF2-like', 'RF2K-like', 4, NULL),
(31646, NULL, 'IPR038498', NULL, 'OspF/SpvC superfamily', 'OspF/SpvC_sf', 5, NULL),
(31647, NULL, 'IPR033891', NULL, 'Tetratricopeptide repeat protein 38', 'TTC38', 4, NULL),
(31648, NULL, 'IPR038870', NULL, 'Ubiquitin-associated protein 1', 'UBAP1', 4, NULL),
(31649, NULL, 'IPR040531', NULL, 'Domain of unknown function DUF5623', 'DUF5623', 3, NULL),
(31650, NULL, 'IPR037535', NULL, '[LysW]-L-2-aminoadipate/[LysW]-L-glutamate phosphate reductase', 'LysY', 4, NULL),
(31651, NULL, 'IPR037593', NULL, 'MIOS/Sea4', 'MIOS/Sea4', 4, NULL),
(31652, NULL, 'IPR040089', NULL, 'RNF26, C3HC5-type zinc finger', 'RNF26_mRING-HC-C3HC5', 3, NULL),
(31653, NULL, 'IPR033762', NULL, 'MCM OB domain', 'MCM_OB', 3, NULL),
(31654, NULL, 'IPR036724', NULL, 'Cobalamin-binding domain superfamily', 'Cobalamin-bd_sf', 5, NULL),
(31655, NULL, 'IPR040592', NULL, 'TbRIF5 SNase domain 2', 'RIF5_SNase_2', 3, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(31656, NULL, 'IPR037186', NULL, 'Minicollagen I, C-terminal domain', 'Minicollagen_I_C', 5, NULL),
(31657, NULL, 'IPR034045', NULL, 'CspA-like domain', 'Pep_S8_CspA-like', 3, NULL),
(31658, NULL, 'IPR033987', NULL, 'Aggrecan/versican, C-type lectin-like domain', 'CSPG_CTLD', 3, NULL),
(31659, NULL, 'IPR038943', NULL, 'PLD-regulated protein1-like', 'PLDrp1-like', 4, NULL),
(31660, NULL, 'IPR038729', NULL, 'Rad50/SbcC-type AAA domain', 'Rad50/SbcC_AAA', 3, NULL),
(31661, NULL, 'IPR036454', NULL, 'Amyloidogenic glycoprotein, heparin-binding domain superfamily', 'Amyloid_glyco_heparin-bd_sf', 5, NULL),
(31662, NULL, 'IPR036737', NULL, 'OmpA-like domain superfamily', 'OmpA-like_sf', 5, NULL),
(31663, NULL, 'IPR036295', NULL, 'GlgS superfamily', 'GlgS_sf', 5, NULL),
(31664, NULL, 'IPR038134', NULL, 'YihD-like superfamily', 'YihD_sf', 5, NULL),
(31665, NULL, 'IPR036290', NULL, 'Phenylalanine zipper superfamily', 'Phe_ZIP_sf', 5, NULL),
(31666, NULL, 'IPR033505', NULL, 'USPL1 peptidase', 'USPL1', 4, NULL),
(31667, NULL, 'IPR038122', NULL, 'PFU domain superfamily', 'PFU_sf', 5, NULL),
(31668, NULL, 'IPR037177', NULL, 'Dynein light chain superfamily', 'DLC_sf', 5, NULL),
(31669, NULL, 'IPR036398', NULL, 'Alpha carbonic anhydrase domain superfamily', 'CA_dom_sf', 5, NULL),
(31670, NULL, 'IPR037302', NULL, 'Protein Unc-13, C2B domain', 'Unc-13_C2B', 3, NULL),
(31671, NULL, 'IPR036670', NULL, 'SecA, preprotein cross-linking domain superfamily', 'SecA_X-link_sf', 5, NULL),
(31672, NULL, 'IPR037259', NULL, 'BRK domain superfamily', 'BRK_sf', 5, NULL),
(31673, NULL, 'IPR038939', NULL, 'Plastid division protein PDV1/PDV2', 'PDV1/PDV2', 4, NULL),
(31674, NULL, 'IPR033315', NULL, 'Fanconi-associated nuclease 1-like', 'Fan1-like', 4, NULL),
(31675, NULL, 'IPR033784', NULL, 'DrrA guanine nucleotide-exchange factor domain', 'DrrA_GEF', 3, NULL),
(31676, NULL, 'IPR035772', NULL, 'SH3 domain-containing kinase-binding protein 1, third SH3 domain', 'CIN85_SH3_3', 3, NULL),
(31677, NULL, 'IPR040246', NULL, 'UPF0547 protein C16orf87-like', 'C16orf87-like', 4, NULL),
(31678, NULL, 'IPR035440', NULL, 'Methyl-accepting chemotaxis protein, four helix bundle domain superfamily', '4HB_MCP_dom_sf', 5, NULL),
(31679, NULL, 'IPR040108', NULL, 'Laa1/Sip1/HEATR5', 'Laa1/Sip1/HEATR5', 4, NULL),
(31680, NULL, 'IPR040223', NULL, 'PAR basic leucine zipper protein', 'PAR_bZIP', 4, NULL),
(31681, NULL, 'IPR038246', NULL, 'Phi-29-like late genes activator superfamily', 'Phi-29-like_sf', 5, NULL),
(31682, NULL, 'IPR036985', NULL, 'Transglutaminase-like superfamily', 'Transglutaminase-like_sf', 5, NULL),
(31683, NULL, 'IPR036124', NULL, 'Class X myosin, motor domain', 'MYSc_Myo10', 3, NULL),
(31684, NULL, 'IPR038867', NULL, 'WW domain-containing adapter protein with coiled-coil', 'WAC', 4, NULL),
(31685, NULL, 'IPR037476', NULL, 'PCH1', 'PCH1', 4, NULL),
(31686, NULL, 'IPR036359', NULL, 'Thiol-activated cytolysin superfamily', 'Thiol_cytolysin_sf', 5, NULL),
(31687, NULL, 'IPR037215', NULL, 'GUN4-like superfamily', 'GUN4-like_sf', 5, NULL),
(31688, NULL, 'IPR033244', NULL, 'Mediator of RNA polymerase II transcription subunit 32', 'MED32', 4, NULL),
(31689, NULL, 'IPR033768', NULL, 'Hydin adenylate kinase-like domain', 'Hydin_ADK', 3, NULL),
(31690, NULL, 'IPR038026', NULL, 'MtlR-like superfamily', 'MtlR-like_sf', 5, NULL),
(31691, NULL, 'IPR036407', NULL, 'DM DNA-binding domain superfamily', 'DM_DNA-bd_sf', 5, NULL),
(31692, NULL, 'IPR033231', NULL, 'Secreted and transmembrane protein 1', 'SECTM1', 4, NULL),
(31693, NULL, 'IPR040286', NULL, 'CRM domain-containing protein At3g25440-like', 'At3g25440-like', 4, NULL),
(31694, NULL, 'IPR035286', NULL, 'Protein of unknown function DUF5361', 'DUF5361', 4, NULL),
(31695, NULL, 'IPR036902', NULL, 'Ta1353-like superfamily', 'Ta1353-like_sf', 5, NULL),
(31696, NULL, 'IPR039975', NULL, 'Intraflagellar transport protein 52 homolog', 'IFT52', 4, NULL),
(31697, NULL, 'IPR033742', NULL, 'IQ motif and SEC7 domain-containing protein, PH domain', 'IQSEC_PH', 3, NULL),
(31698, NULL, 'IPR040227', NULL, 'Nibrin-related', 'Nibrin-rel', 4, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(31699, NULL, 'IPR036728', NULL, 'Pheromone/general odorant binding protein superfamily', 'PBP_GOBP_sf', 5, NULL),
(31700, NULL, 'IPR036409', NULL, 'Class II aldolase/adducin N-terminal domain superfamily', 'Aldolase_II/adducin_N_sf', 5, NULL),
(31701, NULL, 'IPR036853', NULL, 'Ribosomal protein L14 superfamily', 'Ribosomal_L14_sf', 5, NULL),
(31702, NULL, 'IPR033441', NULL, 'Chromosome partition protein MukF, C-terminal domain', 'MukF_C', 3, NULL),
(31703, NULL, 'IPR036400', NULL, 'Cytochrome b5-like heme/steroid binding domain superfamily', 'Cyt_B5-like_heme/steroid_sf', 5, NULL),
(31704, NULL, 'IPR037264', NULL, 'TFIID subunit TAF5, NTD2 domain superfamily', 'TFIID_NTD2_sf', 5, NULL),
(31705, NULL, 'IPR035765', NULL, 'Src kinase-associated phosphoprotein 1, SH3 domain', 'SKAP1_SH3', 3, NULL),
(31706, NULL, 'IPR036404', NULL, 'Jacalin-like lectin domain superfamily', 'Jacalin-like_lectin_dom_sf', 5, NULL),
(31707, NULL, 'IPR036695', NULL, 'Arginyl tRNA synthetase N-terminal domain superfamily', 'Arg-tRNA-synth_N_sf', 5, NULL),
(31708, NULL, 'IPR035288', NULL, 'Trans-membrane regulatory protein ToxS', 'ToxS', 4, NULL),
(31709, NULL, 'IPR033439', NULL, 'Chromosome partition protein MukF, winged-helix domain', 'MukF_WHTH', 3, NULL),
(31710, NULL, 'IPR037247', NULL, 'YvfG domain superfamily', 'YvfG_sf', 5, NULL),
(31711, NULL, 'IPR038081', NULL, 'CalX-like domain superfamily', 'CalX-like_sf', 5, NULL),
(31712, NULL, 'IPR036399', NULL, 'Pesticidal crystal protein, central domain superfamily', 'Pest_cryst_cen_dom_sf', 5, NULL),
(31713, NULL, 'IPR036986', NULL, 'RNA-binding S4 domain superfamily', 'S4_RNA-bd_sf', 5, NULL),
(31714, NULL, 'IPR035685', NULL, '4-hydroxy-2-oxovalerate aldolase, N-terminal catalytic TIM barrel domain', 'DRE_TIM_HOA', 3, NULL),
(31715, NULL, 'IPR039257', NULL, 'B- and T-lymphocyte attenuator', 'BTLA', 4, NULL),
(31716, NULL, 'IPR033290', NULL, 'Coiled-coil domain-containing protein 39', 'CCDC39', 4, NULL),
(31717, NULL, 'IPR040448', NULL, 'PanZ, acetyltransferase (GNAT) domain', 'PanZ_GNAT', 3, NULL),
(31718, NULL, 'IPR033783', NULL, 'Tse2 immunity protein Tsi2', 'Tsi2', 4, NULL),
(31719, NULL, 'IPR036714', NULL, 'Flavinator of succinate dehydrogenase superfamily', 'SDH_sf', 5, NULL),
(31720, NULL, 'IPR040489', NULL, 'Flax-rust effector AvrM-A', 'AvrM-A', 3, NULL),
(31721, NULL, 'IPR040614', NULL, 'Integron cassette protein VCH_CASS1 chain', 'VCH_CASS14', 3, NULL),
(31722, NULL, 'IPR035437', NULL, 'SNase-like, OB-fold superfamily', 'SNase_OB-fold_sf', 5, NULL),
(31723, NULL, 'IPR033556', NULL, 'Phospholipase A1-II', 'PLA', 4, NULL),
(31724, NULL, 'IPR035763', NULL, 'Disks Large homologue 3, SH3 domain', 'DLG3_SH3', 3, NULL),
(31725, NULL, 'IPR036401', NULL, 'Ribosomal protein S17e-like superfamily', 'RPS17e-like_sf', 5, NULL),
(31726, NULL, 'IPR037325', NULL, 'Bromodomain adjacent to zinc finger domain protein 1A, bromodomain', 'Acf1_Bromo', 3, NULL),
(31727, NULL, 'IPR035274', NULL, 'Protein of unknown function DUF5352', 'DUF5352', 4, NULL),
(31728, NULL, 'IPR035768', NULL, 'HERC1, SPRY domain', 'SPRY_HERC1', 3, NULL),
(31729, NULL, 'IPR036246', NULL, 'Cytochrome c oxidase polypeptide 2A, ba3 type', 'Cyt_c_oxidase_su2a_ba3', 5, NULL),
(31730, NULL, 'IPR038742', NULL, 'FRS2, PTB domain', 'FRS2_PTB', 3, NULL),
(31731, NULL, 'IPR036292', NULL, 'Proline/betaine transporter ProP, C-terminal', 'ProP_C', 5, NULL),
(31732, NULL, 'IPR037338', NULL, 'Aminopyrrolnitrin oxygenase PrnD, Rieske domain', 'PrnD_Rieske', 3, NULL),
(31733, NULL, 'IPR035649', NULL, 'EFG, domain V', 'EFG_V', 3, NULL),
(31734, NULL, 'IPR040518', NULL, 'Chalcone isomerase, N-terminal', 'Chalcone_N', 3, NULL),
(31735, NULL, 'IPR033836', NULL, 'Maspin, serpin domain', 'SERPINB5_serpin_dom', 3, NULL),
(31736, NULL, 'IPR035443', NULL, 'Herpesvirus protease superfamily', 'Herpes_virus_sf', 5, NULL),
(31737, NULL, 'IPR042071', NULL, 'Phage late-transcription coactivator superfamily', 'Trans_coact_sf', 5, NULL),
(31738, NULL, 'IPR038501', NULL, 'Spore germination GerAC, C-terminal domain  superfamily', 'Spore_GerAC_C_sf', 5, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(31739, NULL, 'IPR039103', NULL, 'Centrosomal protein Spd-2/CEP192', 'Spd-2/CEP192', 4, NULL),
(31740, NULL, 'IPR036410', NULL, 'Heat shock protein DnaJ, cysteine-rich domain superfamily', 'HSP_DnaJ_Cys-rich_dom_sf', 5, NULL),
(31741, NULL, 'IPR040288', NULL, 'PX domain-containing protein 1', 'PXDC1', 4, NULL),
(31742, NULL, 'IPR036282', NULL, 'Glutathione S-transferase, C-terminal domain superfamily', 'Glutathione-S-Trfase_C_sf', 5, NULL),
(31743, NULL, 'IPR035984', NULL, 'Acyl-CoA binding protein superfamily', 'Acyl-CoA-binding_sf', 5, NULL),
(31744, NULL, 'IPR035279', NULL, 'Protein of unknown function DUF5358', 'DUF5358', 4, NULL),
(31745, NULL, 'IPR035987', NULL, 'Ribosomal protein S8 superfamily', 'Ribosomal_S8_sf', 5, NULL),
(31746, NULL, 'IPR040247', NULL, 'Protein of unknown function DUF5524', 'DUF5524', 4, NULL),
(31747, NULL, 'IPR036303', NULL, 'Cag-Z superfamily', 'Cag-Z_sf', 5, NULL),
(31748, NULL, 'IPR036693', NULL, 'Transcription factor LuxR-like, autoinducer-binding domain superfamily', 'TF_LuxR_autoind-bd_dom_sf', 5, NULL),
(31749, NULL, 'IPR035774', NULL, 'RING finger and SPRY domain-containing protein 1, SPRY domain', 'SPRY_RSPRY1', 3, NULL),
(31750, NULL, 'IPR037187', NULL, 'DksA, N-terminal domain superfamily', 'DnaK_N', 5, NULL),
(31751, NULL, 'IPR035543', NULL, 'Translation initiation factor eIF-2B subunit epsilon, N-terminal', 'eIF-2B_epsilon_N', 3, NULL),
(31752, NULL, 'IPR037301', NULL, 'Toll-interacting protein, C2 domain', 'Tollip_C2', 3, NULL),
(31753, NULL, 'IPR033770', NULL, 'Exosome complex exonuclease RRP44, S1 domain', 'RRP44_S1', 3, NULL),
(31754, NULL, 'IPR034256', NULL, 'ALKBH8, RNA recognition motif', 'ALKBH8_RRM', 3, NULL),
(31755, NULL, 'IPR034254', NULL, 'DNAJC17, RNA recognition motif', 'DNAJC17_RRM', 3, NULL),
(31756, NULL, 'IPR035289', NULL, 'Protein of unknown function DUF5366', 'DUF5366', 4, NULL),
(31757, NULL, 'IPR040527', NULL, 'Porphyranase catalytic subdomain 1', 'Porphyrn_cat_1', 3, NULL),
(31758, NULL, 'IPR036029', NULL, 'Class XX myosin, motor domain', 'MYSc_Myo20', 3, NULL),
(31759, NULL, 'IPR037828', NULL, 'N,N''-diacetylchitobiose phosphorylase, N-terminal', 'GH94N_ChBP', 3, NULL),
(31760, NULL, 'IPR038723', NULL, 'ArnR1-like, winged helix-turn-helix domain', 'ArnR1-like_HTH', 3, NULL),
(31761, NULL, 'IPR038050', NULL, 'Neuronal acetylcholine receptor', 'Neuro_actylchol_rec', 5, NULL),
(31762, NULL, 'IPR040529', NULL, 'Protein CROC-4', 'CROC-4', 4, NULL),
(31763, NULL, 'IPR040100', NULL, 'RING finger protein 208, HC type RING finger', 'RNF208_RING-HC', 3, NULL),
(31764, NULL, 'IPR040008', NULL, '39S ribosomal protein L46, mitochondrial', 'MRPL46', 4, NULL),
(31765, NULL, 'IPR040597', NULL, 'Hemagglutinin component HA-70, C-terminal', 'HA70_C', 3, NULL),
(31766, NULL, 'IPR035779', NULL, 'MLK1-3, SH3 domain', 'MLK1-3_SH3', 3, NULL),
(31767, NULL, 'IPR033767', NULL, 'Tail tubular protein Gp11', 'Tail_Gp11', 4, NULL),
(31768, NULL, 'IPR036269', NULL, 'Rho termination factor, N-terminal domain superfamily', 'Rho_N_sf', 5, NULL),
(31769, NULL, 'IPR037812', NULL, 'PLEKHM3, PH domain 1', 'PLEKHM3_PH_1', 3, NULL),
(31770, NULL, 'IPR035980', NULL, 'Ribosomal protein S6 superfamily', 'Ribosomal_S6_sf', 5, NULL),
(31771, NULL, 'IPR040593', NULL, 'Spindle pole body component 110, C-terminal', 'Spc110_C', 3, NULL),
(31772, NULL, 'IPR036315', NULL, 'BRCA2 helical domain superfamily', 'BRCA2_hlx_sf', 5, NULL),
(31773, NULL, 'IPR035770', NULL, 'SH3 domain-containing kinase-binding protein 1, first SH3 domain', 'CIN85_SH3_1', 3, NULL),
(31774, NULL, 'IPR036984', NULL, 'NrpR domain superfamily', 'NrpR_dom_sf', 5, NULL),
(31775, NULL, 'IPR038087', NULL, 'DNA-directed RNA polymerase subunit delta, N-terminal domain superfamily', 'RNAP_delta_N_dom_sf', 5, NULL),
(31776, NULL, 'IPR038055', NULL, 'Flaviviral glycoprotein E, dimerisation domain', 'Glycoprot_E_dimer_dom', 5, NULL),
(31777, NULL, 'IPR035595', NULL, 'UDP-glycosyltransferase family, conserved site', 'UDP_glycos_trans_CS', 3, NULL),
(31778, NULL, 'IPR035441', NULL, 'TFIIS/LEDGF domain superfamily', 'TFIIS/LEDGF_dom_sf', 5, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(31779, NULL, 'IPR035699', NULL, 'Dynein heavy chain, hydrolytic ATP-binding dynein motor region', 'AAA_6', 3, NULL),
(31780, NULL, 'IPR037279', NULL, 'Photosystem I PsaM, reaction centre superfamily', 'PSI_PsaM_sf', 5, NULL),
(31781, NULL, 'IPR033786', NULL, 'Uncharacterized protein TTHB210-like', 'TTHB210-like', 3, NULL),
(31782, NULL, 'IPR035769', NULL, 'Dedicator of cytokinesis 4, SH3 domain', 'DOCK4_SH3', 3, NULL),
(31783, NULL, 'IPR035283', NULL, 'Protein Fmp23', 'Fmp23', 4, NULL),
(31784, NULL, 'IPR033643', NULL, 'SH3YL1-like, SYLF domain', 'SYLF_SH3YL1-like', 3, NULL),
(31785, NULL, 'IPR038124', NULL, 'Beta-retroviral matrix superfamily', 'B_retro_matrix_sf', 5, NULL),
(31786, NULL, 'IPR036294', NULL, 'Rbstp2229-like superfamily', 'Rbstp2229-like_sf', 5, NULL),
(31787, NULL, 'IPR040242', NULL, 'Tumor protein p63-regulated gene 1-like', 'TPRG1-like', 4, NULL),
(31788, NULL, 'IPR037278', NULL, 'ARFGAP/RecO-like zinc finger', 'ARFGAP/RecO', 5, NULL),
(31789, NULL, 'IPR036743', NULL, 'Actin-related protein 2/3 complex subunit 5 superfamily', 'ARPC5_sf', 5, NULL),
(31790, NULL, 'IPR036704', NULL, 'Ribonuclease E inhibitor RraA/RraA-like superfamily', 'RraA/RraA-like_sf', 5, NULL),
(31791, NULL, 'IPR036775', NULL, 'DNA polymerase, Y-family, little finger domain superfamily', 'DNA_pol_Y-fam_lit_finger_sf', 5, NULL),
(31792, NULL, 'IPR036565', NULL, 'Mur-like, catalytic domain superfamily', 'Mur-like_cat_sf', 5, NULL),
(31793, NULL, 'IPR040523', NULL, 'Siroheme decarboxylase , AsnC-like ligand binding domain', 'AsnC_trans_reg2', 3, NULL),
(31794, NULL, 'IPR033579', NULL, 'Transmembrane protein 128', 'TMEM128', 4, NULL),
(31795, NULL, 'IPR036171', NULL, 'Ta0354, soluble domain superfamily', 'Ta0354_soluble_sf', 5, NULL),
(31796, NULL, 'IPR042079', NULL, 'ATP synthase, F1 beta subunit superfamily', 'ATP_synt_F1_beta_sf', 5, NULL),
(31797, NULL, 'IPR035864', NULL, 'SOCS4, SH2 domain', 'SOCS4_SH2', 3, NULL),
(31798, NULL, 'IPR038941', NULL, 'At4g14100-like', 'At4g14100-like', 4, NULL),
(31799, NULL, 'IPR040525', NULL, 'UDP-glucose:glycoprotein glucosyltransferase, thioredoxin-like domain 4', 'UGGT_TRXL_4', 3, NULL),
(31800, NULL, 'IPR038727', NULL, 'NadR/Ttd14, AAA domain', 'NadR/Ttd14_AAA_dom', 3, NULL),
(31801, NULL, 'IPR040599', NULL, 'Pilin PilJ, C-terminal', 'PilJ_C', 3, NULL),
(31802, NULL, 'IPR037181', NULL, 'Suppressor of fused, N-terminal', 'SUFU_N', 5, NULL),
(31803, NULL, 'IPR036697', NULL, 'Hemocyanin, N-terminal domain superfamily', 'Hemocyanin_N_sf', 5, NULL),
(31804, NULL, 'IPR037216', NULL, 'DNA terminal protein Gp3 superfamily', 'DNA_terminal_Gp3_sf', 5, NULL),
(31805, NULL, 'IPR033436', NULL, 'MucB/RseB, C-terminal', 'MucB/RseB_C', 3, NULL),
(31806, NULL, 'IPR042070', NULL, 'PucR C-terminal helix-turn-helix domain superfamily', 'PucR_C-HTH_sf', 5, NULL),
(31807, NULL, 'IPR040427', NULL, 'Fl(2)d-associated complex component', 'Flacc', 4, NULL),
(31808, NULL, 'IPR040516', NULL, 'Phosphoethanolamine N-methyltransferase 2, N-terminal', 'PMT2_N', 3, NULL),
(31809, NULL, 'IPR036173', NULL, 'G39, N-terminal domain superfamily', 'G39-like_N_sf', 5, NULL),
(31810, NULL, 'IPR040092', NULL, 'Transforming growth factor beta regulator 1', 'TBRG1', 4, NULL),
(31811, NULL, 'IPR037926', NULL, 'CRADD, Death domain', 'CRADD_Death', 3, NULL),
(31812, NULL, 'IPR040300', NULL, 'Uncharacterized protein At3g49055-like', 'At3g49055-like', 4, NULL),
(31813, NULL, 'IPR040169', NULL, 'SURP and G-patch domain-containing protein 1/2', 'SUGP1/2', 4, NULL),
(31814, NULL, 'IPR037317', NULL, 'Serine/threonine-protein kinase N1, second HR1 domain', 'PKN1_HR1_2', 3, NULL),
(31815, NULL, 'IPR038868', NULL, 'BRCA1-A complex subunit RAP80', 'RAP80', 4, NULL),
(31816, NULL, 'IPR035865', NULL, 'SOCS6, SH2 domain', 'SOCS6_SH2', 3, NULL),
(31817, NULL, 'IPR037171', NULL, 'NagB/RpiA transferase-like', 'NagB/RpiA_transferase-like', 5, NULL),
(31818, NULL, 'IPR037810', NULL, 'PHLDB1/2/3, PH domain', 'PHLDB1/2/3_PH', 3, NULL),
(31819, NULL, 'IPR040446', NULL, 'Ribosomal RNA-processing protein 7', 'RRP7', 4, NULL),
(31820, NULL, 'IPR035278', NULL, 'Protein of unknown function DUF5355', 'DUF5355', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(31821, NULL, 'IPR040277', NULL, 'Uncharacterized protein Os04g0629400-like', 'Os04g0629400-like', 4, NULL),
(31822, NULL, 'IPR036851', NULL, 'Chloroperoxidase-like superfamily', 'Chloroperoxidase-like_sf', 5, NULL),
(31823, NULL, 'IPR036721', NULL, 'Regulator of K+ conductance, C-terminal domain superfamily', 'RCK_C_sf', 5, NULL),
(31824, NULL, 'IPR037261', NULL, 'YonK superfamily', 'YonK_sf', 5, NULL),
(31825, NULL, 'IPR040304', NULL, 'ATG8-interacting protein 1/2', 'ATG8-IP-1/2', 4, NULL),
(31826, NULL, 'IPR035773', NULL, 'Ring finger protein 123, SPRY domain', 'SPRY_RNF123', 3, NULL),
(31827, NULL, 'IPR039019', NULL, 'Cation channel sperm-associated auxiliary subunit zeta', 'CATSPERZ', 4, NULL),
(31828, NULL, 'IPR035280', NULL, 'Bacteriocin helveticin-J', 'Helveticin_J', 4, NULL),
(31829, NULL, 'IPR033844', NULL, 'Asparaginase-like 1, metazoa', 'ASRGL1_meta', 4, NULL),
(31830, NULL, 'IPR037458', NULL, 'L-mandelate/L-lactate dehydrogenase, FMN-binding domain', 'L-MDH/L-LDH_FMN-bd', 3, NULL),
(31831, NULL, 'IPR040097', NULL, 'Fatty acyl-AMP ligase /fatty acyl-CoA ligase', 'FAAL/FAAC', 4, NULL),
(31832, NULL, 'IPR034260', NULL, 'Yme2, RNA recognition motif', 'Yme2_RRM', 3, NULL),
(31833, NULL, 'IPR037873', NULL, 'BamE-like', 'BamE-like', 5, NULL),
(31834, NULL, 'IPR038909', NULL, 'Protein effector of transcription', 'Effector_transcript', 4, NULL),
(31835, NULL, 'IPR035439', NULL, 'UPF0145 domain superfamily', 'UPF0145_dom_sf', 5, NULL),
(31836, NULL, 'IPR042059', NULL, 'SUSD5, Link domain', 'SUSD5_Link_domain', 3, NULL),
(31837, NULL, 'IPR038743', NULL, 'YjgH-like', 'YjgH-like', 4, NULL),
(31838, NULL, 'IPR040090', NULL, 'Thioredoxin domain-containing protein 16', 'TXNDC16', 4, NULL),
(31839, NULL, 'IPR036777', NULL, 'Nucleoside-specific channel-forming protein, Tsx-like superfamily', 'Channel_Tsx-like_sf', 5, NULL),
(31840, NULL, 'IPR038510', NULL, 'Spt4 superfamily', 'Spt4_sf', 5, NULL),
(31841, NULL, 'IPR040522', NULL, 'Dipeptidyl peptidase 4, low complexity region', 'DPPIV_rep', 3, NULL),
(31842, NULL, 'IPR036438', NULL, 'Insulin-like superfamily', 'Insulin-like_sf', 5, NULL),
(31843, NULL, 'IPR040602', NULL, 'Cucumopine synthase, C-terminal helical bundle domain', 'Cucumopine_C', 3, NULL),
(31844, NULL, 'IPR033440', NULL, 'Chromosome partition protein MukF, middle domain', 'MukF_M', 3, NULL),
(31845, NULL, 'IPR035863', NULL, 'SOCS3, SH2 domain', 'SOCS3_SH2', 3, NULL),
(31846, NULL, 'IPR036285', NULL, 'PRP4-like superfamily', 'PRP4-like_sf', 5, NULL),
(31847, NULL, 'IPR040091', NULL, 'Leucine-rich repeat-containing protein 56', 'LRRC56', 4, NULL),
(31848, NULL, 'IPR036845', NULL, 'RecG, N-terminal domain superfamily', 'RecG_N_sf', 5, NULL),
(31849, NULL, 'IPR035292', NULL, 'Protein of unknown function DUF5363', 'DUF5363', 4, NULL),
(31850, NULL, 'IPR037262', NULL, 'TTHC002-like', 'TTHC002-like', 5, NULL),
(31851, NULL, 'IPR034257', NULL, 'Acinus, RNA recognition motif', 'Acinus_RRM', 3, NULL),
(31852, NULL, 'IPR036435', NULL, 'Leukocidin/porin MspA superfamily', 'Leukocidin/porin_MspA_sf', 5, NULL),
(31853, NULL, 'IPR037821', NULL, 'Syntaxin-binding protein 6, PH domain', 'STXBP6_PH', 3, NULL),
(31854, NULL, 'IPR035983', NULL, 'HECT, E3 ligase catalytic domain', 'Hect_E3_ubiquitin_ligase', 5, NULL),
(31855, NULL, 'IPR034009', NULL, 'Oligopeptidase F type 4', 'M3B_PepF_4', 4, NULL),
(31856, NULL, 'IPR036844', NULL, 'Hint domain superfamily', 'Hint_dom_sf', 5, NULL),
(31857, NULL, 'IPR037475', NULL, 'Kinetochore protein Sos7', 'Sos7', 4, NULL),
(31858, NULL, 'IPR038129', NULL, 'Nanos domain superfamily', 'Nanos_sf', 5, NULL),
(31859, NULL, 'IPR033765', NULL, 'Restriction endonuclease BfiI C-terminal domain', 'BfiI_C', 3, NULL),
(31860, NULL, 'IPR039020', NULL, 'Terpene cyclase PaxB-like', 'PaxB-like', 4, NULL),
(31861, NULL, 'IPR039206', NULL, 'MORF/ORRM1/DAG-like', 'MORF/ORRM1/DAG-like', 4, NULL),
(31862, NULL, 'IPR037172', NULL, 'Flavivirus capsid protein C superfamily', 'Flavi_capsidC_sf', 5, NULL),
(31863, NULL, 'IPR036848', NULL, 'Haemocyanin C-terminal domain superfamily', 'Haemocyanin_C_sf', 5, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(31864, NULL, 'IPR036313', NULL, 'PepX, N-terminal domain superfamily', 'PepX_N_dom_sf', 5, NULL),
(31865, NULL, 'IPR038942', NULL, 'Transmembrane protein 52', 'TMEM52', 4, NULL),
(31866, NULL, 'IPR033562', NULL, 'Patatin-like phospholipase domain-containing protein', 'PLPL', 4, NULL),
(31867, NULL, 'IPR038949', NULL, 'Coiled-coil domain-containing protein 105', 'CCDC105', 4, NULL),
(31868, NULL, 'IPR035888', NULL, 'Myotubularin-related protein 3, PH-GRAM domain', 'MTMR3_PH-GRAM', 3, NULL),
(31869, NULL, 'IPR036278', NULL, 'Sialidase superfamily', 'Sialidase_sf', 5, NULL),
(31870, NULL, 'IPR036442', NULL, 'ProQ/FinO domain superfamily', 'ProQ/FinO_sf', 5, NULL),
(31871, NULL, 'IPR037339', NULL, 'Cytidine monophosphate-N-acetylneuraminic acid hydroxylase, Rieske domain', 'CMP-Neu5Ac_hydroxylase_Rieske', 3, NULL),
(31872, NULL, 'IPR036125', NULL, 'Class XXI myosin, motor domain', 'MYSc_Myo21', 3, NULL),
(31873, NULL, 'IPR038123', NULL, 'Non-structural protein NSP4, C-terminal superfamily, coronavirus', 'NSP4_C_sf_CoV', 5, NULL),
(31874, NULL, 'IPR035695', NULL, 'Endophilin-B1, BAR domain', 'SH3GLB1_BAR', 3, NULL),
(31875, NULL, 'IPR035578', NULL, 'Styelin', 'Styelin', 4, NULL),
(31876, NULL, 'IPR033833', NULL, 'Alpha2-antiplasmin, serpin domain', 'Alpha2AP_serpin_dom', 3, NULL),
(31877, NULL, 'IPR038702', NULL, 'Sodium/potassium-transporting ATPase subunit beta superfamily', 'Na/K_ATPase_sub_beta_sf', 5, NULL),
(31878, NULL, 'IPR039260', NULL, 'Chondroitin proteoglycan 3', 'Cpg-3', 4, NULL),
(31879, NULL, 'IPR040244', NULL, 'Protein enhanced disease resistance 4-like', 'EDR4-like', 4, NULL),
(31880, NULL, 'IPR038744', NULL, 'Hri1, N-terminal', 'Hri1_N', 3, NULL),
(31881, NULL, 'IPR033246', NULL, 'DNA-binding protein BIN4', 'BIN4', 4, NULL),
(31882, NULL, 'IPR033892', NULL, 'Ferredoxin--NADP reductase, bacteria', 'FNR_bac', 4, NULL),
(31883, NULL, 'IPR038728', NULL, 'Uncharacterized membrane protein YkvI', 'YkvI', 4, NULL),
(31884, NULL, 'IPR036709', NULL, 'Autotransporter beta-domain superfamily', 'Autotransporte_beta_dom_sf', 5, NULL),
(31885, NULL, 'IPR038724', NULL, 'Regulatory protein RepA', 'RepA', 4, NULL),
(31886, NULL, 'IPR036846', NULL, 'GM2-AP, lipid-recognition domain superfamily', 'GM2-AP_sf', 5, NULL),
(31887, NULL, 'IPR036852', NULL, 'Peptidase S8/S53 domain superfamily', 'Peptidase_S8/S53_dom_sf', 5, NULL),
(31888, NULL, 'IPR037196', NULL, 'HSP90, C-terminal domain', 'HSP90_C', 5, NULL),
(31889, NULL, 'IPR040285', NULL, 'Prolyl-tRNA editing protein ProX/PRXD1', 'ProX/PRXD1', 4, NULL),
(31890, NULL, 'IPR038503', NULL, 'Stage III sporulation protein AH-like superfamily', 'SpoIIIAH_sf', 5, NULL),
(31891, NULL, 'IPR040241', NULL, 'Transient receptor potential channel Flc/Pkd2-like', 'TRP_Flc/Pkd2-like', 4, NULL),
(31892, NULL, 'IPR039028', NULL, 'PDK/BCKDK protein kinase', 'BCKD/PDK', 4, NULL),
(31893, NULL, 'IPR038508', NULL, 'ArfGAP domain superfamily', 'ArfGAP_dom_sf', 5, NULL),
(31894, NULL, 'IPR040600', NULL, 'Agglutinin, C-terminal', 'Agglutinin_C', 3, NULL),
(31895, NULL, 'IPR037889', NULL, 'Rho guanine nucleotide exchange factor 11, RGS domain', 'PDZRhoGEF_RGS', 3, NULL),
(31896, NULL, 'IPR035767', NULL, 'Dedicator of cytokinesis 3, SH3 domain', 'DOCK3_SH3', 3, NULL),
(31897, NULL, 'IPR034255', NULL, 'Ephrin-B ectodomain', 'Ephrin-B_Ecto', 3, NULL),
(31898, NULL, 'IPR037590', NULL, 'GATOR complex protein WDR24', 'WDR24', 4, NULL),
(31899, NULL, 'IPR036988', NULL, 'Picornavirus coat protein VP4 superfamily', 'Pico_P1A_sf', 5, NULL),
(31900, NULL, 'IPR033023', NULL, 'Glutaredoxin domain-containing cysteine-rich protein 2', 'GRXCR2', 4, NULL),
(31901, NULL, 'IPR036903', NULL, 'Nuclear pore complex protein Nup98-Nup96-like, autopeptidase S59 domain superfamily', 'Nup98_auto-Pept-S59_dom_sf', 5, NULL),
(31902, NULL, 'IPR038500', NULL, 'Antitermination protein Q superfamily', 'Antitermination_sf', 5, NULL),
(31903, NULL, 'IPR040520', NULL, 'Importin 13 repeat', 'Importin_rep_3', 7, NULL),
(31904, NULL, 'IPR040278', NULL, 'UPF0426 protein', 'UPF0426', 4, NULL),
(31905, NULL, 'IPR036740', NULL, 'tRNA intron endonuclease, N-terminal domain superfamily', 'tRNA_intron_Endonuc_N_sf', 5, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(31906, NULL, 'IPR038937', NULL, 'Rop guanine nucleotide exchange factor', 'RopGEF', 4, NULL),
(31907, NULL, 'IPR036712', NULL, 'Amb V Allergen superfamily', 'Amb_V_allergen_sf', 5, NULL),
(31908, NULL, 'IPR040611', NULL, 'Tetracyclin repressor C-terminal, Actinobacteria', 'TetR_C_35', 3, NULL),
(31909, NULL, 'IPR037912', NULL, 'Microspherule protein 1', 'MCRS1', 4, NULL),
(31910, NULL, 'IPR040606', NULL, 'Protein of unknown function DUF5549', 'DUF5549', 4, NULL),
(31911, NULL, 'IPR033789', NULL, 'Gal11, coactivator domain', 'Gal11_coact', 3, NULL),
(31912, NULL, 'IPR038726', NULL, 'PD-(D/E)XK endonuclease-like domain, AddAB-type', 'PDDEXK_AddAB-type', 3, NULL),
(31913, NULL, 'IPR037477', NULL, 'Protein disulfide-isomerase SCO2', 'SCO2', 4, NULL),
(31914, NULL, 'IPR038017', NULL, 'Rotavirus VP4, membrane interaction domain superfamily', 'Rota_VP4_MID_sf', 5, NULL),
(31915, NULL, 'IPR036663', NULL, 'Fumarylacetoacetase-like, C-terminal domain superfamily', 'Fumarylacetoacetase_C_sf', 5, NULL),
(31916, NULL, 'IPR035594', NULL, 'IRSp53, SH3 domain', 'Irsp53_SH3', 3, NULL),
(31917, NULL, 'IPR039974', NULL, 'Pre-mRNA-splicing factor SLU7', 'Splicing_factor_SLU7', 4, NULL),
(31918, NULL, 'IPR034127', NULL, 'CX3C chemokine domain', 'Chemokine_CX3C', 3, NULL),
(31919, NULL, 'IPR036703', NULL, 'MOB kinase activator superfamily', 'MOB_kinase_act_sf', 5, NULL),
(31920, NULL, 'IPR036568', NULL, 'Gamma-glutamyl cyclotransferase-like superfamily', 'GGCT-like_sf', 5, NULL),
(31921, NULL, 'IPR040517', NULL, 'Nucleotidyltransferase, substrate binding domain', 'Ant(4'')-IIb_substrate-bd', 3, NULL),
(31922, NULL, 'IPR036306', NULL, 'ISWI, HAND domain superfamily', 'ISWI_HAND-dom_sf', 5, NULL),
(31923, NULL, 'IPR036456', NULL, 'Polyribonucleotide nucleotidyltransferase, RNA-binding domain superfamily', 'PNPase_PH_RNA-bd_sf', 5, NULL),
(31924, NULL, 'IPR033705', NULL, 'Valyl tRNA synthetase, anticodon-binding domain', 'Anticodon_Ia_Val', 3, NULL),
(31925, NULL, 'IPR040530', NULL, 'Type VI secretion system TssR', 'T6SS_TssR', 4, NULL),
(31926, NULL, 'IPR038133', NULL, 'Ribonuclease III superfamily, archaeal', 'Ribo_III_sf_archaeal', 5, NULL),
(31927, NULL, 'IPR033835', NULL, 'Protein Z-dependent peptidase inhibitor, serpin domain', 'PZI_serpin_dom', 3, NULL),
(31928, NULL, 'IPR037242', NULL, 'Vanadium-binding protein 2 superfamily', 'Vanabin-2_sf', 5, NULL),
(31929, NULL, 'IPR038127', NULL, 'Dinitrogenase iron-molybdenum cofactor, N-terminal domain superfamily', 'NafY_N_sf', 5, NULL),
(31930, NULL, 'IPR033771', NULL, 'Rrp44-like cold shock domain', 'Rrp44_CSD1', 3, NULL),
(31931, NULL, 'IPR042073', NULL, 'TraM, DNA-binding domain', 'TraM_DNA-bd', 5, NULL),
(31932, NULL, 'IPR036363', NULL, 'Thiol-activated cytolysin, alpha-beta domain superfamily', 'Thiol_cytolysin_ab_sf', 5, NULL),
(31933, NULL, 'IPR037588', NULL, 'Target of rapamycin complex subunit LST8', 'MLST8', 4, NULL),
(31934, NULL, 'IPR039264', NULL, 'Tellurite resistance protein TehA', 'TehA', 4, NULL),
(31935, NULL, 'IPR035982', NULL, 'Photosystem I reaction centre subunit PsaK superfamily', 'PSI_centre_PsaK_sf', 5, NULL),
(31936, NULL, 'IPR035985', NULL, 'Ubiquitin-activating enzyme', 'Ubiquitin-activating_enz', 5, NULL),
(31937, NULL, 'IPR042061', NULL, 'Peregrin, ePHD domain', 'Peregrin_ePHD', 3, NULL),
(31938, NULL, 'IPR033670', NULL, 'Elongation of very long chain fatty acids protein 7', 'ELOVL7', 4, NULL),
(31939, NULL, 'IPR036669', NULL, 'Amyloidogenic glycoprotein, copper-binding domain superfamily', 'Amyloid_Cu-bd_sf', 5, NULL),
(31940, NULL, 'IPR036566', NULL, 'Pyrimidine nucleoside phosphorylase-like, C-terminal domain superfamily', 'PYNP-like_C_sf', 5, NULL),
(31941, NULL, 'IPR033344', NULL, 'Protein CURVATURE THYLAKOID 1', 'CURT1', 4, NULL),
(31942, NULL, 'IPR037244', NULL, 'Thylakoid soluble phosphoprotein TSP9 superfamily', 'TSP9_sf', 5, NULL),
(31943, NULL, 'IPR033258', NULL, 'EP300-interacting inhibitor of differentiation', 'EID', 4, NULL),
(31944, NULL, 'IPR036265', NULL, 'HIT-like superfamily', 'HIT-like_sf', 5, NULL),
(31945, NULL, 'IPR037245', NULL, 'FIP-RBD, C-terminal domain superfamily', 'FIP-RBD_C_sf', 5, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(31946, NULL, 'IPR037827', NULL, 'SNX27, atypical FERM-like domain', 'SNX27_FERM-like_dom', 3, NULL),
(31947, NULL, 'IPR033347', NULL, 'Protein DEHYDRATION-INDUCED 19', 'DI19', 4, NULL),
(31948, NULL, 'IPR035615', NULL, 'FiwA/Osa', 'FiwA/Osa', 4, NULL),
(31949, NULL, 'IPR036311', NULL, 'Hypothetical protein Ta0289, C-terminal', 'Ta0289_C', 5, NULL),
(31950, NULL, 'IPR037303', NULL, 'Synaptotagmin-like protein 4/5, C2A domain', 'SLP-4/5_C2A', 3, NULL),
(31951, NULL, 'IPR040287', NULL, 'Repulsive guidance molecule', 'RGM', 4, NULL),
(31952, NULL, 'IPR037191', NULL, 'VPS9 domain superfamily', 'VPS9_dom_sf', 5, NULL),
(31953, NULL, 'IPR036742', NULL, 'ATP synthase, F1 complex, epsilon  subunit superfamily, mitochondrial', 'ATP_synth_F1_esu_sf_mt', 5, NULL),
(31954, NULL, 'IPR033834', NULL, 'Angiotensinogen, serpin domain', 'Angiotensinogen_serpin_dom', 3, NULL),
(31955, NULL, 'IPR036705', NULL, 'ADP-ribosylation/Crystallin J1 superfamily', 'Ribosyl_crysJ1_sf', 5, NULL),
(31956, NULL, 'IPR036661', NULL, 'Luciferase-like domain superfamily', 'Luciferase-like_sf', 5, NULL),
(31957, NULL, 'IPR039022', NULL, 'Circadian clock protein KaiB-like', 'KaiB-like', 4, NULL),
(31958, NULL, 'IPR037394', NULL, 'Protein TBATA-like', 'TBATA-like', 4, NULL),
(31959, NULL, 'IPR036271', NULL, 'Tetracyclin repressor-like, C-terminal domain superfamily', 'Tet_transcr_reg_TetR-rel_C_sf', 5, NULL),
(31960, NULL, 'IPR036983', NULL, 'Mitochondrial biogenesis AIM24 superfamily', 'AIM24_sf', 5, NULL),
(31961, NULL, 'IPR035293', NULL, 'Vacuole-related protein 17', 'Vac17', 4, NULL),
(31962, NULL, 'IPR036460', NULL, 'Copper amine oxidase, catalytic domain superfamily', 'Cu_amine_oxidase_C_sf', 5, NULL),
(31963, NULL, 'IPR037825', NULL, 'Cellobiose phosphorylase, N-terminal', 'GH94N_CBP', 3, NULL),
(31964, NULL, 'IPR038182', NULL, 'HMD, C-terminal domain superfamily', 'HMD_C_sf', 5, NULL),
(31965, NULL, 'IPR033769', NULL, 'KH domain, archaeal', 'KH_arc', 3, NULL),
(31966, NULL, 'IPR037819', NULL, 'ARHGEF28, PH domain', 'ARHGEF28_PH', 3, NULL),
(31967, NULL, 'IPR038746', NULL, 'Alpha-tubulin N-acetyltransferase', 'Atat', 4, NULL),
(31968, NULL, 'IPR038945', NULL, 'Methyl-CpG-binding domain-containing protein 13-like', 'MBD13-like', 4, NULL),
(31969, NULL, 'IPR040521', NULL, 'Kyakuja-Dileera-Zisupton transposase', 'KDZ', 4, NULL),
(31970, NULL, 'IPR036991', NULL, 'Iron hydrogenase, small subunit superfamily', 'Fe_hydrogenase_ssu_sf', 5, NULL),
(31971, NULL, 'IPR036700', NULL, 'Bacterial OB-fold superfamily', 'BOBF_sf', 5, NULL),
(31972, NULL, 'IPR036310', NULL, 'Smp-1-like superfamily', 'Smp-1-like_sf', 5, NULL),
(31973, NULL, 'IPR036850', NULL, 'Nucleoside diphosphate kinase-like domain superfamily', 'NDK-like_dom_sf', 5, NULL),
(31974, NULL, 'IPR035281', NULL, 'Protein of unknown function DUF5359', 'DUF5359', 4, NULL),
(31975, NULL, 'IPR036358', NULL, 'Beta-trefoil domain superfamily', 'BTD_sf', 5, NULL),
(31976, NULL, 'IPR037243', NULL, 'Viral leader polypeptide zinc finger', 'Viral_lead_polypep_zc_finger', 5, NULL),
(31977, NULL, 'IPR040609', NULL, 'RNA ligase 2, C-terminal', 'Rnl2_C', 3, NULL),
(31978, NULL, 'IPR040102', NULL, 'WD repeat-containing protein 41', 'WDR41', 4, NULL),
(31979, NULL, 'IPR033842', NULL, 'Carboxypeptidase M, N-terminal domain', 'CPM_N', 3, NULL),
(31980, NULL, 'IPR036035', NULL, 'Class XIX myosin, motor domain', 'MYSc_Myo19', 3, NULL),
(31981, NULL, 'IPR042081', NULL, 'RNA 2''-phosphotransferase, C-terminal domain', 'RNA_2''-PTrans_C', 5, NULL),
(31982, NULL, 'IPR037887', NULL, 'p115RhoGEF, RGS domain', 'p115RhoGEF_RGS', 3, NULL),
(31983, NULL, 'IPR038086', NULL, 'DUF2789 superfamily', 'DUF2789_sf', 5, NULL),
(31984, NULL, 'IPR035776', NULL, 'CD2-associated protein, second SH3 domain', 'CD2AP_SH_2', 3, NULL),
(31985, NULL, 'IPR039023', NULL, 'Succinate dehydrogenase membrane subunit SdhC, prokaryotes', 'SdhC_prok', 4, NULL),
(31986, NULL, 'IPR035287', NULL, 'Protein of unknown function DUF5362', 'DUF5362', 4, NULL),
(31987, NULL, 'IPR036904', NULL, 'Phycobilisome degradation protein NblA superfamily', 'NblA_sf', 5, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(31988, NULL, 'IPR037943', NULL, 'Nitrate reductase alpha subunit-like, MopB domain', 'MopB_CT_Nitrate-R-NarG-like', 3, NULL),
(31989, NULL, 'IPR036266', NULL, 'SecA, Wing/Scaffold superfamily', 'SecA_Wing/Scaffold_sf', 5, NULL),
(31990, NULL, 'IPR038950', NULL, 'BEN domain-containing protein 4', 'BEND4', 4, NULL),
(31991, NULL, 'IPR040447', NULL, 'Rrp7, RRM-like N-terminal domain', 'RRM_Rrp7', 3, NULL),
(31992, NULL, 'IPR035862', NULL, 'SOCS2, SH2 domain', 'SOCS2_SH2', 3, NULL),
(31993, NULL, 'IPR042069', NULL, 'CLIC5, C-terminal GST domain', 'CLIC5_C_GST', 3, NULL),
(31994, NULL, 'IPR033580', NULL, 'Nurim-like', 'Nurim-like', 4, NULL),
(31995, NULL, 'IPR036273', NULL, 'CRAL/TRIO, N-terminal domain superfamily', 'CRAL/TRIO_N_dom_sf', 5, NULL),
(31996, NULL, 'IPR039241', NULL, 'Ribosomal RNA-processing protein Rrp9-like', 'Rrp9-like', 4, NULL),
(31997, NULL, 'IPR036719', NULL, 'Neurotransmitter-gated ion-channel transmembrane domain superfamily', 'Neuro-gated_channel_TM_sf', 5, NULL),
(31998, NULL, 'IPR037946', NULL, 'Tetrathionate reductase subunit A, MopB domain', 'MopB_CT_Tetrathionate', 3, NULL),
(31999, NULL, 'IPR033434', NULL, 'MucB/RseB, N-terminal', 'MucB/RseB_N', 3, NULL),
(32000, NULL, 'IPR036299', NULL, 'Polyketide synthase, docking domain superfmaily', 'Polyketide_synth_docking_sf', 5, NULL),
(32001, NULL, 'IPR035133', NULL, 'Protein of unknown function DUF5499', 'DUF5499', 4, NULL),
(32002, NULL, 'IPR033946', NULL, 'Ubiquinol oxidase subunit III domain', 'Ubiquinol_oxase_su3_dom', 3, NULL),
(32003, NULL, 'IPR036381', NULL, 'Replication terminator Tus, domain 1', 'Tus_dom1', 5, NULL),
(32004, NULL, 'IPR038763', NULL, 'DHH phosphoesterase superfamily', 'DHH_sf', 5, NULL),
(32005, NULL, 'IPR038461', NULL, 'Schlafen, AlbA_2 domain superfamily', 'Schlafen_AlbA_2_dom_sf', 5, NULL),
(32006, NULL, 'IPR038128', NULL, 'Poly-gamma-glutamate hydrolase, zinc-binding motif superfamily', 'Gamma_PGA_hydro_sf', 5, NULL),
(32007, NULL, 'IPR036411', NULL, 'TorD-like superfamily', 'TorD-like_sf', 5, NULL),
(32008, NULL, 'IPR037987', NULL, 'Four and a half LIM domains protein 2/3/5', 'FHL2/3/5', 4, NULL),
(32009, NULL, 'IPR038469', NULL, 'tRNAHis guanylyltransferase Thg1 superfamily', 'tRNAHis_GuaTrfase_Thg1_sf', 5, NULL),
(32010, NULL, 'IPR037766', NULL, 'Protein FAR-RED ELONGATED HYPOCOTYL 1', 'FHY1', 4, NULL),
(32011, NULL, 'IPR036078', NULL, 'Spo11/DNA topoisomerase VI subunit A superfamily', 'Spo11/TopoVI_A_sf', 5, NULL),
(32012, NULL, 'IPR038622', NULL, 'Cyclodipeptide synthase superfamily', 'CDPS_sf', 5, NULL),
(32013, NULL, 'IPR038493', NULL, 'Toxin MqsR superfamily', 'MqsR_sf', 5, NULL),
(32014, NULL, 'IPR036606', NULL, 'EhaM-like superfamily', 'EhaM-like_sf', 5, NULL),
(32015, NULL, 'IPR035078', NULL, 'Phosphoenolpyruvate carboxykinase, GTP-utilising, N-terminal', 'PEP_carboxykinase_GTP_N', 3, NULL),
(32016, NULL, 'IPR038677', NULL, 'WIF domain superfamily', 'WIF_sf', 5, NULL),
(32017, NULL, 'IPR037636', NULL, 'EPH-B4, SAM domain', 'EPH-B4_SAM', 3, NULL),
(32018, NULL, 'IPR040893', NULL, 'RPA-related protein RADX', 'RADX', 4, NULL),
(32019, NULL, 'IPR038894', NULL, 'X-ray radiation resistance-associated protein 1', 'XRRA1', 4, NULL),
(32020, NULL, 'IPR035639', NULL, 'CPSF2, metallo-hydrolase domain', 'CPSF2_MBL', 3, NULL),
(32021, NULL, 'IPR036596', NULL, 'Bacterial aa3 type cytochrome c oxidase subunit IV superfamily', 'Cyt-C_aa3_sf', 5, NULL),
(32022, NULL, 'IPR036081', NULL, 'Translin superfamily', 'Translin_sf', 5, NULL),
(32023, NULL, 'IPR035782', NULL, 'Ran binding protein 9/10, SPRY domain', 'SPRY_RanBP9/10', 3, NULL),
(32024, NULL, 'IPR033870', NULL, 'FatB domain', 'FatB', 3, NULL),
(32025, NULL, 'IPR035533', NULL, 'Interleukin-1 receptor-associated kinase 1, death domain', 'Death_IRAK1', 3, NULL),
(32026, NULL, 'IPR035843', NULL, 'DAPP1, SH2 domain', 'DAPP1_SH2', 3, NULL),
(32027, NULL, 'IPR036043', NULL, 'Phosphoglycerate kinase superfamily', 'Phosphoglycerate_kinase_sf', 5, NULL),
(32028, NULL, 'IPR038477', NULL, 'Arylsulfotransferase, N-terminal domain superfamily', 'ASST_N_sf', 5, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(32029, NULL, 'IPR039868', NULL, 'Armadillo-like helical domain-containing protein 3-like', 'ARMD3-like', 4, NULL),
(32030, NULL, 'IPR034998', NULL, 'Ankyrin repeat and LEM domain-containing protein 1', 'ANKLE1', 4, NULL),
(32031, NULL, 'IPR035644', NULL, 'MraZ, C-terminal', 'MraZ_C', 3, NULL),
(32032, NULL, 'IPR040792', NULL, 'Zap1, zinc finger 2', 'Zap1_Znf2', 3, NULL),
(32033, NULL, 'IPR038563', NULL, 'Recombination endonuclease VII superfamily', 'Endonuclease_7_sf', 5, NULL),
(32034, NULL, 'IPR036757', NULL, 'Transferrin receptor-like, dimerisation domain superfamily', 'TFR-like_dimer_dom_sf', 5, NULL),
(32035, NULL, 'IPR034496', NULL, 'TIAR, RNA recognition motif 3', 'TIAR_RRM3', 3, NULL),
(32036, NULL, 'IPR038480', NULL, 'YuaB-like superfamily', 'YuaB-like_sf', 5, NULL),
(32037, NULL, 'IPR035655', NULL, '116kDa U5 small nuclear ribonucleoprotein component, C-terminal', 'U5-116kDa_C', 3, NULL),
(32038, NULL, 'IPR040825', NULL, 'FKBP26, C-terminal', 'FKBP26_C', 3, NULL),
(32039, NULL, 'IPR039872', NULL, 'Uncharacterized protein KIAA0513', 'KIAA0513', 4, NULL),
(32040, NULL, 'IPR040239', NULL, 'Beta-lactamase HcpB-like', 'HcpB-like', 4, NULL),
(32041, NULL, 'IPR036715', NULL, 'Alpha-2,3-sialyltransferase superfamily', 'A-2_3-sialylTrfase_sf', 5, NULL),
(32042, NULL, 'IPR038410', NULL, 'GxGYxYP putative glycoside hydrolase, C-terminal domain superfamily', 'GxGYxYP_C_sf', 5, NULL),
(32043, NULL, 'IPR038136', NULL, 'CofD-like domain superfamily', 'CofD-like_dom_sf', 5, NULL),
(32044, NULL, 'IPR037405', NULL, 'HTH-type transcriptional regulator GbpR, PBP2 domain', 'GbpR_PBP2', 3, NULL),
(32045, NULL, 'IPR039893', NULL, 'Centrosomal protein of 120kDa-like', 'CEP120-like', 4, NULL),
(32046, NULL, 'IPR036747', NULL, 'Histone chaperone ASF1-like superfamily', 'ASF1-like_sf', 5, NULL),
(32047, NULL, 'IPR040281', NULL, 'Protein FAM163A', 'FAM163A', 4, NULL),
(32048, NULL, 'IPR040824', NULL, 'Large polyvalent protein-associated domain 3', 'LPD3', 3, NULL),
(32049, NULL, 'IPR038595', NULL, 'LURP-one-related superfamily', 'LOR_sf', 5, NULL),
(32050, NULL, 'IPR040846', NULL, 'ORF 12 gene product, N-terminal', 'ORF_12_N', 3, NULL),
(32051, NULL, 'IPR036073', NULL, 'Desulfoferrodoxin, ferrous iron-binding domain superfamily', 'Desulfoferrodoxin_Fe-bd_dom_sf', 5, NULL),
(32052, NULL, 'IPR037256', NULL, 'ASC domain superfamily', 'ASC_dom_sf', 5, NULL),
(32053, NULL, 'IPR038793', NULL, 'Lysine-rich arabinogalactan protein 19', 'AGP19', 4, NULL),
(32054, NULL, 'IPR038599', NULL, 'LAP1C-like, C-terminal domain superfamily', 'LAP1C-like_C_sf', 5, NULL),
(32055, NULL, 'IPR037449', NULL, 'Formin-binding protein 1, F-BAR domain', 'FNBP1_F-BAR', 3, NULL),
(32056, NULL, 'IPR038438', NULL, 'Alanyl aminopeptidase, Ig-like domain superfamily', 'PepN_Ig-like_sf', 5, NULL),
(32057, NULL, 'IPR038458', NULL, 'NADH-quinone oxidoreductase, subunit 15 superfamily', 'NADH_quinone_OxRdtase_su15_sf', 5, NULL),
(32058, NULL, 'IPR038873', NULL, 'Uncharacterized protein CXorf66', 'CXorf66', 4, NULL),
(32059, NULL, 'IPR040791', NULL, 'Protein of unknown function DUF5555', 'DUF5555', 4, NULL),
(32060, NULL, 'IPR036751', NULL, 'Stage V sporulation protein G superfamily', 'SpoVG_sf', 5, NULL),
(32061, NULL, 'IPR037847', NULL, 'GRAM domain-containing protein 4', 'GRAMDC4', 4, NULL),
(32062, NULL, 'IPR035830', NULL, 'TRIM62, PRY/SPRY domain', 'PRY/SPRY_TRIM62', 3, NULL),
(32063, NULL, 'IPR037403', NULL, 'HTH-type transcriptional regulator CynR, PBP2 domain', 'CynR_PBP2', 3, NULL),
(32064, NULL, 'IPR036756', NULL, 'H/ACA ribonucleoprotein complex, subunit Nop10 superfamily', 'H/ACA_rnp_Nop10_sf', 5, NULL),
(32065, NULL, 'IPR040840', NULL, 'Tc toxin complex TcA, C-terminal TcB-binding domain', 'TcA_TcB_BD', 3, NULL),
(32066, NULL, 'IPR038462', NULL, 'YaiA-like superfamily', 'YaiA-like_sf', 5, NULL),
(32067, NULL, 'IPR034679', NULL, 'ATP synthase, F0 complex, subunit b''', 'ATP_synth_b''', 4, NULL),
(32068, NULL, 'IPR037868', NULL, 'Vacuolar protein sorting-associated protein 5, PX domain', 'PX_Vps5', 3, NULL),
(32069, NULL, 'IPR034523', NULL, 'PSP1, RNA recognition motif 2', 'PSP1_RRM2', 3, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(32070, NULL, 'IPR033516', NULL, 'CARD8/ASC/NALP1, CARD domain', 'CARD8/ASC/NALP1_CARD', 3, NULL),
(32071, NULL, 'IPR037976', NULL, 'HERC2, APC10 domain', 'HERC2_APC10', 3, NULL),
(32072, NULL, 'IPR038883', NULL, 'Uncharacterized protein AN11006-like', 'AN11006-like', 4, NULL),
(32073, NULL, 'IPR038518', NULL, 'Glycosyl hydrolase family 63, N-terminal domain superfamily', 'Glyco_hydro_63N_sf', 5, NULL),
(32074, NULL, 'IPR038591', NULL, 'NolW-like superfamily', 'NolW-like_sf', 5, NULL),
(32075, NULL, 'IPR038445', NULL, 'Neutral ceramidase, C-terminal domain superfamily', 'NCDase_C_sf', 5, NULL),
(32076, NULL, 'IPR040875', NULL, 'Trypsin inhibitor', 'Tryp_inh', 3, NULL),
(32077, NULL, 'IPR039915', NULL, 'TACC family', 'TACC', 4, NULL),
(32078, NULL, 'IPR040803', NULL, 'Tyramine--L-glutamate ligase, pre ATP-grasp domain', 'MfnD_preATP-grasp', 3, NULL),
(32079, NULL, 'IPR038131', NULL, 'Protein PsiB-like superfamily', 'PsiB-like_sf', 5, NULL),
(32080, NULL, 'IPR036755', NULL, 'SRS domain superfamily', 'SRS_dom_sf', 5, NULL),
(32081, NULL, 'IPR037445', NULL, 'Melanoma-associated antigen', 'MAGE', 4, NULL),
(32082, NULL, 'IPR038467', NULL, 'Peptide chain release factor 3, domain III superfamily', 'RF3_dom_3_sf', 5, NULL),
(32083, NULL, 'IPR036386', NULL, 'HscB, C-terminal domain superfamily', 'HscB_C_sf', 5, NULL),
(32084, NULL, 'IPR038853', NULL, 'Small integral membrane protein 9', 'Smim9', 4, NULL),
(32085, NULL, 'IPR038797', NULL, 'Protein Flattop', 'Fltp', 4, NULL),
(32086, NULL, 'IPR034522', NULL, 'PSP1, RNA recognition motif 1', 'PSP1_RRM1', 3, NULL),
(32087, NULL, 'IPR035850', NULL, 'Tyrosine-protein kinase Lck, SH2 domain', 'Lck_SH2', 3, NULL),
(32088, NULL, 'IPR034806', NULL, 'Nop4, RNA recognition motif 2', 'Nop4_RRM2', 3, NULL),
(32089, NULL, 'IPR037974', NULL, 'BICC1, SAM domain', 'BICC1_SAM_dom', 3, NULL),
(32090, NULL, 'IPR037845', NULL, 'GRAMDC4, PH-GRAM domain', 'GRAMDC4_PH-GRAM', 3, NULL),
(32091, NULL, 'IPR036761', NULL, 'Lipid/polyisoprenoid-binding, YceI-like superfamily', 'TTHA0802/YceI-like_sf', 5, NULL),
(32092, NULL, 'IPR035778', NULL, 'Heterogeneous nuclear ribonucleoprotein U, SPRY domain', 'SPRY_hnRNP_U', 3, NULL),
(32093, NULL, 'IPR036076', NULL, 'Fructose-1,6-bisphosphatase, class V superfamily', 'FBPase_V_sf', 5, NULL),
(32094, NULL, 'IPR033758', NULL, 'pGP3 C-terminal domain', 'pGP3_C', 3, NULL),
(32095, NULL, 'IPR038581', NULL, 'Ornithine decarboxylase antizyme superfamily', 'ODC_AZ_sf', 5, NULL),
(32096, NULL, 'IPR035849', NULL, 'Fes/Fps/Fer, SH2 domain', 'Fes/Fps/Fer_SH2', 3, NULL),
(32097, NULL, 'IPR038803', NULL, 'Small integral membrane protein 33', 'SMIM33', 4, NULL),
(32098, NULL, 'IPR038808', NULL, 'Protein modifier of SNC1 1-like', 'MOS1-like', 4, NULL),
(32099, NULL, 'IPR037397', NULL, 'Reticulon-4-interacting protein 1', 'RTN4I1', 4, NULL),
(32100, NULL, 'IPR036765', NULL, 'ZipA, C-terminal FtsZ-binding domain superfamily', 'ZipA_FtsZ-bd_C_sf', 5, NULL),
(32101, NULL, 'IPR038417', NULL, 'Alpha-galactosidase, N-terminal domain superfamily', 'Alpga-gal_N_sf', 5, NULL),
(32102, NULL, 'IPR039869', NULL, 'Ubiquitin domain-containing protein 1/2', 'UBTD1/2', 4, NULL),
(32103, NULL, 'IPR034525', NULL, 'PSF, RNA recognition motif 1', 'PSF_RRM1', 3, NULL),
(32104, NULL, 'IPR040238', NULL, 'Helix-loop-helix protein TAL-like', 'TAL-like', 4, NULL),
(32105, NULL, 'IPR038874', NULL, 'Transmembrane protein 253', 'TMEM253', 4, NULL),
(32106, NULL, 'IPR038056', NULL, 'YjbR-like superfamily', 'YjbR-like_sf', 5, NULL),
(32107, NULL, 'IPR039735', NULL, 'Cysteine-rich hydrophobic domain-containing protein 1/2', 'CHIC1/2', 4, NULL),
(32108, NULL, 'IPR039871', NULL, 'Protein FAM8A1', 'FAM8A1', 4, NULL),
(32109, NULL, 'IPR036091', NULL, 'Propanediol/glycerol dehydratase, small subunit superfamily', 'Prodiol/glycerol_DeHase__sf_su', 5, NULL),
(32110, NULL, 'IPR033449', NULL, 'Rit1, N-terminal domain', 'Rit1_N', 3, NULL),
(32111, NULL, 'IPR040292', NULL, 'Uncharacterized protein C2orf78-like', 'C2orf78-like', 4, NULL),
(32112, NULL, 'IPR037630', NULL, 'SASH1, SAM domain repeat 2', 'SASH1_SAM_repeat2', 3, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(32113, NULL, 'IPR038834', NULL, 'Coiled-coil domain-containing protein 175', 'CCDC175', 4, NULL),
(32114, NULL, 'IPR038810', NULL, 'Centlein', 'CNTLN', 4, NULL),
(32115, NULL, 'IPR038799', NULL, 'Protein LEKR1', 'LEKR1', 4, NULL),
(32116, NULL, 'IPR038459', NULL, 'tRNA methyltransferase TRM10-type domain superfamily', 'MT_TRM10-typ_sf', 5, NULL),
(32117, NULL, 'IPR038513', NULL, 'FAIM1 domain superfamily', 'FAIM1_dom_sf', 5, NULL),
(32118, NULL, 'IPR038268', NULL, 'Ribbon-helix-helix domain superfamily', 'RHH_sf', 5, NULL),
(32119, NULL, 'IPR039941', NULL, 'Tetratricopeptide repeat protein 30', 'TT30', 4, NULL),
(32120, NULL, 'IPR038891', NULL, 'Fibrous sheath-interacting protein 2', 'FSIP2', 4, NULL),
(32121, NULL, 'IPR037763', NULL, 'Transmembrane protein C1orf162', 'C1orf162', 4, NULL),
(32122, NULL, 'IPR038801', NULL, 'TATA box-binding protein-associated factor RNA polymerase I subunit C', 'TAF1C', 4, NULL),
(32123, NULL, 'IPR036379', NULL, 'Alpha-amylase inhibitor superfamily', 'A-amylase_inhib_sf', 5, NULL),
(32124, NULL, 'IPR037984', NULL, 'SGIP1, mu-homology domain', 'SGIP1_MHD', 3, NULL),
(32125, NULL, 'IPR038794', NULL, 'Protein LIAT1', 'LIAT1', 4, NULL),
(32126, NULL, 'IPR040794', NULL, 'Carbohydrate esterase 2, N-terminal', 'CE2_N', 3, NULL),
(32127, NULL, 'IPR038858', NULL, 'Secretogranin-2', 'ScgII', 4, NULL),
(32128, NULL, 'IPR038586', NULL, 'Tctex-1-like superfamily', 'Tctex-1-like_sf', 5, NULL),
(32129, NULL, 'IPR038420', NULL, 'PapG, carbohydrate-binding domain superfamily', 'PapG_carbohydrate-bd_sf', 5, NULL),
(32130, NULL, 'IPR038806', NULL, 'Spermatogenesis-associated protein 45', 'SPATA45', 4, NULL),
(32131, NULL, 'IPR038495', NULL, 'V-type ATPase subunit E, C-terminal domain superfamily', 'ATPase_E_C', 5, NULL),
(32132, NULL, 'IPR036075', NULL, 'Damage-control phosphatase ARMT1-like, metal-binding domain superfamily', 'ARMT-1-like_metal-bd_sf', 5, NULL),
(32133, NULL, 'IPR040828', NULL, 'REase associating with pPIWI, RE domain', 'pPIWI_RE_REase', 3, NULL),
(32134, NULL, 'IPR038269', NULL, 'SCAN domain superfamily', 'SCAN_sf', 5, NULL),
(32135, NULL, 'IPR038692', NULL, 'Cthe_2751-like superfamily', 'Cthe_2751_sf', 5, NULL),
(32136, NULL, 'IPR037759', NULL, 'Uncharacterized protein At4g29660-like', 'At4g29660-like', 4, NULL),
(32137, NULL, 'IPR040834', NULL, 'Nicking enzyme C-terminal middle helical domain', 'NES_C_h', 3, NULL),
(32138, NULL, 'IPR039867', NULL, 'Protein furry/Tao3/Mor2', 'Furry/Tao3/Mor2', 4, NULL),
(32139, NULL, 'IPR037635', NULL, 'VTS1, SAM domain', 'VTS1_SAM', 3, NULL),
(32140, NULL, 'IPR039894', NULL, 'tRNA pseudouridine synthase Pus10-like', 'Pus10-like', 4, NULL),
(32141, NULL, 'IPR040843', NULL, 'Restriction enzyme adenine methylase associated', 'RAMA', 3, NULL),
(32142, NULL, 'IPR033658', NULL, 'Glutaredoxin, PICOT-like', 'GRX_PICOT-like', 3, NULL),
(32143, NULL, 'IPR040897', NULL, 'Plasmodium host cell traversal SPECT1', 'SPECT1', 3, NULL),
(32144, NULL, 'IPR038027', NULL, 'YorP domain superfamily', 'YorP_sf', 5, NULL),
(32145, NULL, 'IPR036727', NULL, 'Olfactory marker superfamily', 'Olfactory_marker_sf', 5, NULL),
(32146, NULL, 'IPR037758', NULL, 'Coiled-coil domain-containing protein 54', 'Ccdc54', 4, NULL),
(32147, NULL, 'IPR037402', NULL, 'HTH-type transcriptional regulator YidZ, PBP2 domain', 'YidZ_PBP2', 3, NULL),
(32148, NULL, 'IPR038838', NULL, 'Telomerase RNA component interacting RNase', 'TRIR', 4, NULL),
(32149, NULL, 'IPR035264', NULL, 'Protein of unknown function DUF5434', 'DUF5434', 4, NULL),
(32150, NULL, 'IPR035780', NULL, 'Ssh4-like, SPRY domain', 'SPRY_Ssh4-like', 3, NULL),
(32151, NULL, 'IPR034331', NULL, 'Uracil phosphoribosyltransferase, archaea', 'Upp_A', 4, NULL),
(32152, NULL, 'IPR038519', NULL, 'Major capsid protein, C-terminal domain superfamily', 'MCP_C_sf', 5, NULL),
(32153, NULL, 'IPR037776', NULL, 'RASAL, RasGAP domain', 'RASAL_RasGAP', 3, NULL),
(32154, NULL, 'IPR038465', NULL, 'APS reductase, beta subunit, C-terminal domain superfamily', 'APS_reduc_Bsu_C_sf', 5, NULL),
(32155, NULL, 'IPR034808', NULL, 'Nop4, RNA recognition motif 3', 'Nop4p_RRM3', 3, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(32156, NULL, 'IPR039876', NULL, '28kDa heat- and acid-stable phosphoprotein', 'HAP28', 4, NULL),
(32157, NULL, 'IPR035582', NULL, 'Protein of unknown function DUF5418', 'DUF5418', 4, NULL),
(32158, NULL, 'IPR040895', NULL, 'Argonaute, PAZ domain', 'Ago_PAZ', 3, NULL),
(32159, NULL, 'IPR040831', NULL, 'YdcK Beta solenoid repeat', 'B_solenoid_ydck_rpt', 7, NULL),
(32160, NULL, 'IPR038593', NULL, 'RNA polymerase Rpb1, domain 7 superfamily', 'RNA_pol_Rpb1_7_sf', 5, NULL),
(32161, NULL, 'IPR038615', NULL, 'Pichia pastoris 6-phosphofructokinase, gamma subunit superfamily', 'PpPFK_gamma_sf', 5, NULL),
(32162, NULL, 'IPR038605', NULL, 'Proteasome chaperone 1 superfamily', 'Pba1_sf', 5, NULL),
(32163, NULL, 'IPR036045', NULL, 'Sec1-like superfamily', 'Sec1-like_sf', 5, NULL),
(32164, NULL, 'IPR038600', NULL, 'CRISPR-associated protein Csn2 superfamily', 'Csn2_sf', 5, NULL),
(32165, NULL, 'IPR040180', NULL, 'Neuregulin', 'Neuregulin', 4, NULL),
(32166, NULL, 'IPR034805', NULL, 'Nop4, RNA recognition motif 1', 'Nop4_RRM1', 3, NULL),
(32167, NULL, 'IPR038654', NULL, 'PINIT domain superfamily', 'PINIT_sf', 5, NULL),
(32168, NULL, 'IPR038051', NULL, 'XRCC4-like, N-terminal domain superfamily', 'XRCC4-like_N_sf', 5, NULL),
(32169, NULL, 'IPR038552', NULL, 'Tim21 IMS domain superfamily', 'Tim21_IMS_sf', 5, NULL),
(32170, NULL, 'IPR034526', NULL, 'PSF, NOPS domain', 'PSF_NOPS', 3, NULL),
(32171, NULL, 'IPR040827', NULL, 'Arcadin 1', 'Arcadin_1', 3, NULL),
(32172, NULL, 'IPR037751', NULL, 'Dok1/2/3, PTB domain', 'Dok1/2/3_PTB', 3, NULL),
(32173, NULL, 'IPR038889', NULL, 'Shugoshin', 'Shugoshin', 4, NULL),
(32174, NULL, 'IPR038768', NULL, 'Small aggregate formation protein', 'SmlA', 4, NULL),
(32175, NULL, 'IPR033489', NULL, 'E3 ubiquitin-protein ligase RBBP6 family', 'RBBP6', 4, NULL),
(32176, NULL, 'IPR035528', NULL, 'Protein of unknown function DUF5388', 'DUF5388', 4, NULL),
(32177, NULL, 'IPR036377', NULL, 'Gp120 core superfamily', 'Gp120_core_sf', 5, NULL),
(32178, NULL, 'IPR035354', NULL, 'Protein of unknown function DUF5424', 'DUF5424', 4, NULL),
(32179, NULL, 'IPR038807', NULL, 'Coiled-coil domain-containing protein 150', 'CCDC150', 4, NULL),
(32180, NULL, 'IPR038651', NULL, 'Yeast killer toxin superfamily', 'Yeast_kill_tox_sf', 5, NULL),
(32181, NULL, 'IPR038656', NULL, 'Peptidase G1 superfamily', 'Peptidase_G1_sf', 5, NULL),
(32182, NULL, 'IPR039921', NULL, 'Inscuteable', 'Inscuteable', 4, NULL),
(32183, NULL, 'IPR035859', NULL, 'STAT1, SH2 domain', 'STAT1_SH2', 3, NULL),
(32184, NULL, 'IPR037316', NULL, 'Yen1, H3TH domain', 'Yen1_H3TH', 3, NULL),
(32185, NULL, 'IPR038273', NULL, 'Ndc80 domain superfamily', 'Ndc80_sf', 5, NULL),
(32186, NULL, 'IPR037197', NULL, 'WWE domain superfamily', 'WWE_dom_sf', 5, NULL),
(32187, NULL, 'IPR034795', NULL, 'PTBPH3, RNA recognition motif 1', 'PTBPH3_RRM1', 3, NULL),
(32188, NULL, 'IPR040847', NULL, 'Mind bomb, SH3 repeat domain', 'SH3_15', 3, NULL),
(32189, NULL, 'IPR037777', NULL, 'RASA4, PH domain', 'RASA4_PH', 3, NULL),
(32190, NULL, 'IPR038270', NULL, 'SopA-like, catalytic domain superfamily', 'SopA-like_catalytic_sf', 5, NULL),
(32191, NULL, 'IPR038611', NULL, 'Rifampin ADP-ribosyltransferase superfamily', 'Arr_sf', 5, NULL),
(32192, NULL, 'IPR037446', NULL, 'Histidine acid phosphatase, VIP1 family', 'His_Pase_VIP1', 4, NULL),
(32193, NULL, 'IPR037315', NULL, 'Exonuclease-1, H3TH domain', 'EXO1_H3TH', 3, NULL),
(32194, NULL, 'IPR033859', NULL, 'COP9 signalosome subunit 6', 'MPN_CSN6', 4, NULL),
(32195, NULL, 'IPR039874', NULL, 'Wings apart-like protein', 'WAPL', 4, NULL),
(32196, NULL, 'IPR037756', NULL, 'Tricalbin, C2D domain', 'C2D_Tricalbin', 3, NULL),
(32197, NULL, 'IPR038609', NULL, 'HDA1 complex subunit 2/3  superfamily', 'HDA1_su2/3_sf', 5, NULL),
(32198, NULL, 'IPR040889', NULL, 'RFX5, N-terminal', 'RFX5_N', 3, NULL),
(32199, NULL, 'IPR040898', NULL, 'CxC6 like cysteine cluster associated with KDZ', 'CxC6', 3, NULL),
(32200, NULL, 'IPR035829', NULL, 'TRIM4, PRY/SPRY domain', 'PRY/SPRY_TRIM4', 3, NULL),
(32201, NULL, 'IPR040887', NULL, 'Aldos-2-ulose dehydratase/isomerase (AUDH), Cupin domain', 'AUDH_Cupin', 3, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(32202, NULL, 'IPR040892', NULL, 'RPN1, N-terminal', 'RPN1_N', 3, NULL),
(32203, NULL, 'IPR039873', NULL, 'Coiled-coil domain-containing protein 78', 'CCDC78', 4, NULL),
(32204, NULL, 'IPR038412', NULL, 'Pepsin inhibitor-3 domain superfamily', 'Pepsin-I3_sf', 5, NULL),
(32205, NULL, 'IPR036086', NULL, 'ParB/Sulfiredoxin superfamily', 'ParB/Sulfiredoxin_sf', 5, NULL),
(32206, NULL, 'IPR038603', NULL, 'FCS-type zinc finger superfamily', 'Znf_FCS_sf', 5, NULL),
(32207, NULL, 'IPR040839', NULL, 'Macroglobulin domain MG4', 'MG4', 3, NULL),
(32208, NULL, 'IPR038741', NULL, 'AP-5 complex subunit beta-1', 'AP5B1', 4, NULL),
(32209, NULL, 'IPR038478', NULL, 'Fimbrillin subunit EcpA superfamily', 'Fimbrillin_EcpA_sf', 5, NULL),
(32210, NULL, 'IPR036085', NULL, 'PAZ domain superfamily', 'PAZ_dom_sf', 5, NULL),
(32211, NULL, 'IPR037774', NULL, 'RASA3, PH domain', 'RASA3_PH', 3, NULL),
(32212, NULL, 'IPR037255', NULL, 'NRDP1, C-terminal', 'NRDP1_C', 5, NULL),
(32213, NULL, 'IPR038811', NULL, 'CUB domain-containing protein 1', 'CDCP1', 4, NULL),
(32214, NULL, 'IPR036587', NULL, 'Nuclease A inhibitor-like superfamily', 'NucleaseA_inhib-like_sf', 5, NULL),
(32215, NULL, 'IPR037787', NULL, 'OCRL1, PH domain', 'OCRL1_PH', 3, NULL),
(32216, NULL, 'IPR037623', NULL, 'SAMSN1, SAM domain', 'SAMSN1_SAM', 3, NULL),
(32217, NULL, 'IPR038678', NULL, 'Spondin, N-terminal domain superfamily', 'Spondin_N_sf', 5, NULL),
(32218, NULL, 'IPR040841', NULL, 'Luciferase', 'Luciferase', 4, NULL),
(32219, NULL, 'IPR036753', NULL, 'Actin-related protein 2/3 complex subunit 3 superfamily', 'ARPC3_sf', 5, NULL),
(32220, NULL, 'IPR038597', NULL, 'GGGP/HepGP synthase superfamily', 'GGGP/HepGP_synthase_sf', 5, NULL),
(32221, NULL, 'IPR038592', NULL, 'CheD-like superfamily', 'CheD-like_sf', 5, NULL),
(32222, NULL, 'IPR035259', NULL, 'Protein of unknown function DUF5437', 'DUF5437', 4, NULL),
(32223, NULL, 'IPR039895', NULL, 'Protein cordon-bleu-like', 'COBL-like', 4, NULL),
(32224, NULL, 'IPR036376', NULL, 'Ribulose bisphosphate carboxylase, large subunit, C-terminal domain superfamily', 'RuBisCO_lsu_C_sf', 5, NULL),
(32225, NULL, 'IPR037400', NULL, 'Malonate utilization transcriptional regulator, PBP2 domain', 'MdcR_PBP2', 3, NULL),
(32226, NULL, 'IPR037858', NULL, 'ARAP, RhoGAP domain', 'RhoGAP_ARAP', 3, NULL),
(32227, NULL, 'IPR035642', NULL, 'MraZ, N-terminal', 'MraZ_N', 3, NULL),
(32228, NULL, 'IPR038613', NULL, 'Peroxin 22, C-terminal domain superfamiliy', 'Peroxin-22_C_sf', 5, NULL),
(32229, NULL, 'IPR036759', NULL, 'Thiamin pyrophosphokinase, catalytic domain superfamily', 'TPK_catalytic_sf', 5, NULL),
(32230, NULL, 'IPR034793', NULL, 'PTBPH1/PTBPH2, RNA recognition motif 2', 'PTBPH1/PTBPH2_RRM2', 3, NULL),
(32231, NULL, 'IPR037634', NULL, 'Protein Smaug, SAM domain', 'Smaug_SAM', 3, NULL),
(32232, NULL, 'IPR040800', NULL, 'Methyltransferase MycE, N-terminal', 'MycE_N', 3, NULL),
(32233, NULL, 'IPR034687', NULL, 'Elongator complex protein 3-like', 'ELP3-like', 4, NULL),
(32234, NULL, 'IPR035262', NULL, 'Protein of unknown function DUF5435', 'DUF5435', 4, NULL),
(32235, NULL, 'IPR036725', NULL, 'Colicin E3-like ribonuclease domain superfamily', 'ColE3_ribonuclease_sf', 5, NULL),
(32236, NULL, 'IPR036718', NULL, 'Quinohemoprotein amine dehydrogenase alpha subunit, domain 2 superfamily', 'H-AmDH_asu_dom2_sf', 5, NULL),
(32237, NULL, 'IPR038463', NULL, 'CedA-like superfamily', 'CedA-like_sf', 5, NULL),
(32238, NULL, 'IPR038871', NULL, 'UPF0653 protein C607.02c-like', 'C607.02c-like', 4, NULL),
(32239, NULL, 'IPR033848', NULL, 'Carboxypeptidase D, carboxypeptidase-like domain 3', 'M14_CPD_III', 3, NULL),
(32240, NULL, 'IPR040837', NULL, 'Bacterial archaeo-eukaryotic release factor family 7', 'Bact_RF_family7', 4, NULL),
(32241, NULL, 'IPR033710', NULL, 'TATA-box binding protein, eukaryotic', 'TBP_eukaryotic', 4, NULL),
(32242, NULL, 'IPR038596', NULL, 'Janus superfamily', 'Janus_sf', 5, NULL),
(32243, NULL, 'IPR036720', NULL, 'Ran-GTPase activating protein 1, C-terminal domain superfamily', 'RanGAP1_C_sf', 5, NULL),
(32244, NULL, 'IPR040845', NULL, 'Aminoarabinose transferase, C-terminal', 'Arnt_C', 3, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(32245, NULL, 'IPR040801', NULL, 'Ski2, N-terminal domain', 'Ski2_N', 3, NULL),
(32246, NULL, 'IPR040248', NULL, 'Ribosome-binding protein 1', 'RRBP1', 4, NULL),
(32247, NULL, 'IPR035783', NULL, 'SPRY domain-containing protein 3, SPRY domain', 'SPRYD3_SPRY', 3, NULL),
(32248, NULL, 'IPR039940', NULL, 'F-box only protein 33', 'FBXO33', 4, NULL),
(32249, NULL, 'IPR038521', NULL, 'ThiC/Bza, core domain', 'ThiC/Bza_core_dom', 5, NULL),
(32250, NULL, 'IPR037620', NULL, 'Liprin-alpha, SAM domain repeat 1', 'Liprin-alpha_SAM_rpt_1', 3, NULL),
(32251, NULL, 'IPR038694', NULL, 'Superfamily of unknown function DUF427', 'DUF427_sf', 5, NULL),
(32252, NULL, 'IPR039013', NULL, 'Inorganic triphosphatase YgiF', 'YgiF', 4, NULL),
(32253, NULL, 'IPR038887', NULL, 'Dehydrodolichyl diphosphate synthase complex subunit Nus1', 'Nus1/NgBR', 4, NULL),
(32254, NULL, 'IPR036754', NULL, 'YbaK/aminoacyl-tRNA synthetase-associated domain superfamily', 'YbaK/aa-tRNA-synt-asso_dom_sf', 5, NULL),
(32255, NULL, 'IPR040826', NULL, 'LA2681-like HEPN domain', 'HEPN_LA2681', 3, NULL),
(32256, NULL, 'IPR037871', NULL, 'Phafin, PH domain', 'PH_Phafin', 3, NULL),
(32257, NULL, 'IPR038882', NULL, 'Respiratory complex factor Rcf3', 'Rcf3', 4, NULL),
(32258, NULL, 'IPR038266', NULL, 'NapC/NirT cytochrome c superfamily', 'NapC/NirT_cytc_sf', 5, NULL),
(32259, NULL, 'IPR040620', NULL, 'Protein of unknown function DUF5560', 'DUF5560', 4, NULL),
(32260, NULL, 'IPR038517', NULL, 'MxiM superfamily', 'MxiM_sf', 5, NULL),
(32261, NULL, 'IPR033452', NULL, 'Glycosyl hydrolase family 30, beta sandwich domain', 'GH30_C', 3, NULL),
(32262, NULL, 'IPR035134', NULL, 'Protein of unknown function DUF5498', 'DUF5498', 4, NULL),
(32263, NULL, 'IPR039942', NULL, 'Somatomedin-B and thrombospondin type-1 domain-containing protein', 'SBSPO', 4, NULL),
(32264, NULL, 'IPR040436', NULL, 'Protein disconnected-like', 'Disconnected-like', 4, NULL),
(32265, NULL, 'IPR037618', NULL, 'Liprin-beta, SAM domain repeat 2', 'Liprin-beta_SAM_rpt_2', 3, NULL),
(32266, NULL, 'IPR040891', NULL, 'SAV_6107-like HEPN', 'HEPN_SAV_6107', 3, NULL),
(32267, NULL, 'IPR033939', NULL, 'Branched-chain aminotransferase', 'BCAT_family', 4, NULL),
(32268, NULL, 'IPR037963', NULL, 'Apoptotic Protease-Activating Factor 1, CARD domain', 'APAF1_CARD_dom', 3, NULL),
(32269, NULL, 'IPR040836', NULL, 'SMODS-associated and fused to various effectors', 'SAVED', 3, NULL),
(32270, NULL, 'IPR035513', NULL, 'Invertase/pectin methylesterase inhibitor domain superfamily', 'Invertase/methylesterase_inhib', 5, NULL),
(32271, NULL, 'IPR034803', NULL, 'hnRNP A1, RNA recognition motif 2', 'hnRNPA1_RRM2', 3, NULL),
(32272, NULL, 'IPR036084', NULL, 'Serine protease inhibitor-like superfamily', 'Ser_inhib-like_sf', 5, NULL),
(32273, NULL, 'IPR037299', NULL, 'TRIM37, MATH domain', 'TRIM37_MATH', 3, NULL),
(32274, NULL, 'IPR038601', NULL, 'MttB-like superfamily', 'MttB-like_sf', 5, NULL),
(32275, NULL, 'IPR038294', NULL, 'SLBP, RNA-binding domain superfamily', 'SLBP_RNA_bind_sf', 5, NULL),
(32276, NULL, 'IPR038479', NULL, 'Transthyretin-like superfamily', 'Transthyretin-like_sf', 5, NULL),
(32277, NULL, 'IPR037773', NULL, 'RASA2, PH domain', 'RASA2_PH', 3, NULL),
(32278, NULL, 'IPR040010', NULL, 'Zinc finger protein 608/609', 'ZN608/ZN609', 4, NULL),
(32279, NULL, 'IPR037764', NULL, 'Protein CEBPZOS', 'CEBPZOS', 4, NULL),
(32280, NULL, 'IPR040280', NULL, 'Protein FAM163B', 'FAM163B', 4, NULL),
(32281, NULL, 'IPR035856', NULL, 'STAT4, SH2 domain', 'STAT4_SH2', 3, NULL),
(32282, NULL, 'IPR036384', NULL, 'Replication terminator Tus superfamily', 'Tus_sf', 5, NULL),
(32283, NULL, 'IPR038608', NULL, 'Csm1/Pcs1, C-terminal domain superfamily', 'Csm1/Pcs1_C_sf', 5, NULL),
(32284, NULL, 'IPR033490', NULL, 'Leucine-rich PPR motif-containing protein', 'LRP130', 4, NULL),
(32285, NULL, 'IPR036080', NULL, 'F420-dependent methylenetetrahydromethanopterin dehydrogenase superfamily', 'MTD_sf', 5, NULL),
(32286, NULL, 'IPR040275', NULL, 'F-box domain containing protein At5g39450-like', 'At5g39450-like', 4, NULL),
(32287, NULL, 'IPR040888', NULL, 'PilN biogenesis protein dimerization domain', 'PilN_bio_d', 3, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(32288, NULL, 'IPR033947', NULL, 'Electron transfer flavoprotein, alpha subunit, N-terminal', 'ETF_alpha_N', 3, NULL),
(32289, NULL, 'IPR038610', NULL, 'FliK-like, C-terminal domain superfamily', 'FliK-like_C_sf', 5, NULL),
(32290, NULL, 'IPR038740', NULL, 'BioF2-like, acetyltransferase domain', 'BioF2-like_GNAT_dom', 3, NULL),
(32291, NULL, 'IPR033894', NULL, 'Heat shock protein beta-3', 'HSPB3', 3, NULL),
(32292, NULL, 'IPR033482', NULL, 'BRCA2-interacting transcriptional repressor EMSY', 'EMSY', 4, NULL),
(32293, NULL, 'IPR040186', NULL, 'Citramalyl-CoA lyase', 'Citramalyl-CoA_lyase', 4, NULL),
(32294, NULL, 'IPR038583', NULL, 'L-arabinose isomerase, N-terminal domain superfamily', 'AraA_N_sf', 5, NULL),
(32295, NULL, 'IPR034799', NULL, 'PTBP2, RNA recognition motif 3', 'PTBP2_RRM3', 3, NULL),
(32296, NULL, 'IPR038504', NULL, 'UL141-like superfamily', 'UL141-like_sf', 5, NULL),
(32297, NULL, 'IPR038604', NULL, 'Type III effector HopJ superfamily', 'HopJ_sf', 5, NULL),
(32298, NULL, 'IPR033945', NULL, 'Cytochrome c oxidase subunit III domain', 'Cyt_c_oxase_su3_dom', 3, NULL),
(32299, NULL, 'IPR038888', NULL, 'Cilia- and flagella-associated protein 36', 'CFAP36', 4, NULL),
(32300, NULL, 'IPR037443', NULL, 'Leucine rich adaptor protein 1', 'LURAP1', 4, NULL),
(32301, NULL, 'IPR037632', NULL, 'ZCCH14, SAM domain', 'ZCCH14_SAM', 3, NULL),
(32302, NULL, 'IPR033949', NULL, 'Cobyric acid synthase, glutamine amidotransferase type 1', 'CobQ_GATase1', 3, NULL),
(32303, NULL, 'IPR036689', NULL, 'ESAT-6-like superfamily', 'ESAT-6-like_sf', 5, NULL),
(32304, NULL, 'IPR038880', NULL, 'Uncharacterized protein MJ0871-like', 'MJ0871-like', 4, NULL),
(32305, NULL, 'IPR040243', NULL, 'Steroid receptor RNA activator 1', 'Steroid_recept_RNA_1', 4, NULL),
(32306, NULL, 'IPR035787', NULL, 'E3 ubiquitin-protein ligase TRIM58, PRY/SPRY domain', 'SPRY/PRY_TRIM58', 3, NULL),
(32307, NULL, 'IPR037627', NULL, 'SASH1, SAM domain repeat 1', 'SASH1_SAM_repeat1', 3, NULL),
(32308, NULL, 'IPR035823', NULL, 'ARHGEF37, first C-terminal SH3 domain', 'ARHGEF37_SH3_C1', 3, NULL),
(32309, NULL, 'IPR040830', NULL, 'Bacterial archaeo-eukaryotic release factor family 8', 'Bact_RF_family8', 4, NULL),
(32310, NULL, 'IPR038571', NULL, 'Bifunctional carbon monoxide dehydrogenase/acetyl-coa synthase, domain 3 superfamily', 'CO_DH/Ac-CoA_synth_bsu_3_sf', 5, NULL),
(32311, NULL, 'IPR033110', NULL, 'ROD1, RNA recognition motif 4', 'PTBP3_RRM4', 3, NULL),
(32312, NULL, 'IPR036382', NULL, 'Guanylin superfamily', 'Guanylin_sf', 5, NULL),
(32313, NULL, 'IPR035824', NULL, 'Endophilin-A, SH3 domain', 'Endophilin_A_SH3', 3, NULL),
(32314, NULL, 'IPR034798', NULL, 'Polypyrimidine tract-binding protein1/2/3, RNA recognition motif 2', 'PTBP1/2/3_RRM2', 3, NULL),
(32315, NULL, 'IPR038054', NULL, 'L,D-transpeptidase central domain-like superfamily', 'LD_TPept-like_central_sf', 5, NULL),
(32316, NULL, 'IPR035654', NULL, 'Elongation factor 4, domain IV', 'LepA_IV', 3, NULL),
(32317, NULL, 'IPR033903', NULL, 'Patatin-like phospholipase domain-containing protein 2', 'PNPLA2', 3, NULL),
(32318, NULL, 'IPR037982', NULL, 'TDRD5, second LOTUS domain', 'TDRD5_LOTUS_2', 3, NULL),
(32319, NULL, 'IPR040873', NULL, 'SopB, HTH domain', 'SoPB_HTH', 3, NULL),
(32320, NULL, 'IPR038837', NULL, 'tRNA ligase 1', 'tRNA_ligase_1', 4, NULL),
(32321, NULL, 'IPR037406', NULL, 'HTH-type transcriptional regulator MetR, PBP2 domain', 'MetR_PBP2', 3, NULL),
(32322, NULL, 'IPR034796', NULL, 'PTBPH3, RNA recognition motif 2', 'PTBPH3_RRM2', 3, NULL),
(32323, NULL, 'IPR033450', NULL, 'NlpE, C-terminal OB domain', 'NlpE_C', 3, NULL),
(32324, NULL, 'IPR036074', NULL, 'CbiD superfamily', 'CbiD_sf', 5, NULL),
(32325, NULL, 'IPR036378', NULL, 'FAS1 domain superfamily', 'FAS1_dom_sf', 5, NULL),
(32326, NULL, 'IPR036717', NULL, 'GFRP superfamily', 'GFRP_sf', 5, NULL),
(32327, NULL, 'IPR038588', NULL, 'XS domain superfamily', 'XS_domain_sf', 5, NULL),
(32328, NULL, 'IPR035667', NULL, 'Plant RIN2/3, CUE domain', 'RIN3_plant_CUE', 3, NULL),
(32329, NULL, 'IPR037444', NULL, 'Putative glycerol kinase 5, FGGY', 'GK5_FGGY', 4, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(32330, NULL, 'IPR038578', NULL, 'GT29-like superfamiliy', 'GT29-like_sf', 5, NULL),
(32331, NULL, 'IPR035781', NULL, 'HECTD4, SPRY domain', 'SPRY_HECTD4', 3, NULL),
(32332, NULL, 'IPR037748', NULL, 'Dok-7, PTB domain', 'Dok-7_PTB', 3, NULL),
(32333, NULL, 'IPR038616', NULL, 'Phosphotransferase RcsD, RcsD-ABL domain superfamily', 'RcsD_ABL_sf', 5, NULL),
(32334, NULL, 'IPR034686', NULL, 'Terpene cyclase-like 2', 'Terpene_cyclase-like_2', 4, NULL),
(32335, NULL, 'IPR040894', NULL, '54S ribosomal protein L8, C-terminal', 'Mrpl_C', 3, NULL),
(32336, NULL, 'IPR037978', NULL, 'TDRD7, third LOTUS domain', 'TDRD7_LOTUS_3', 3, NULL),
(32337, NULL, 'IPR037769', NULL, 'Abr/Bcr', 'Abr/Bcr', 4, NULL),
(32338, NULL, 'IPR038515', NULL, 'Two-component sensor protein CpxA, periplasmic domain superfamily', 'CpxA_peri_sf', 5, NULL),
(32339, NULL, 'IPR038267', NULL, 'Putative ECF-type sigma factor negative effector', 'ECF_sigma_eff', 5, NULL),
(32340, NULL, 'IPR038653', NULL, 'Putative carbohydrate metabolism domain superfamily', 'Put_CMD_sf', 5, NULL),
(32341, NULL, 'IPR039875', NULL, 'Leukocyte receptor cluster member 1-like', 'LENG1-like', 4, NULL),
(32342, NULL, 'IPR037198', NULL, 'MutL, C-terminal domain superfamily', 'MutL_C_sf', 5, NULL),
(32343, NULL, 'IPR040621', NULL, 'Avirulence Effector AvrLm4-7', 'AvrLm4-7', 3, NULL),
(32344, NULL, 'IPR040823', NULL, 'Large polyvalent protein-associated domain 14', 'LPD14', 3, NULL),
(32345, NULL, 'IPR038577', NULL, 'GT10-like, C-terminal domain superfamily', 'GT10-like_C_sf', 5, NULL),
(32346, NULL, 'IPR038594', NULL, 'SepF-like superfamily', 'SepF-like_sf', 5, NULL),
(32347, NULL, 'IPR038579', NULL, 'Ribosomal protein S21e superfamily', 'Ribosomal_S21e_sf', 5, NULL),
(32348, NULL, 'IPR037760', NULL, 'Small lysine-rich protein 1', 'SMKR1', 4, NULL),
(32349, NULL, 'IPR038494', NULL, 'Imidazole glycerol phosphate dehydratase domain superfamily', 'IGPD_sf', 5, NULL),
(32350, NULL, 'IPR040619', NULL, 'Cas9, alpha-helical lobe domain', 'Cas9_alpha-helical_lobe', 3, NULL),
(32351, NULL, 'IPR040832', NULL, 'Domain of unknown function DUF5602', 'DUF5602', 3, NULL),
(32352, NULL, 'IPR037404', NULL, 'HTH-type transcriptional activator IlvY, PBP2 domain', 'IlvY_PBP2', 3, NULL),
(32353, NULL, 'IPR038575', NULL, 'E6 superfamily', 'E6_sf', 5, NULL),
(32354, NULL, 'IPR039937', NULL, 'Sorting nexin SNX20/SNX21', 'SNX20/SNX21', 4, NULL),
(32355, NULL, 'IPR037638', NULL, 'Serine/threonine-protein kinase greatwall, catalytic domain', 'MASTL_STKc', 3, NULL),
(32356, NULL, 'IPR037925', NULL, 'Flagellar hook-basal body protein, FlgE/F/G-like', 'FlgE/F/G-like', 5, NULL),
(32357, NULL, 'IPR038570', NULL, 'HicA superfamily', 'HicA_sf', 5, NULL),
(32358, NULL, 'IPR035351', NULL, 'Non-structural protein 11/12', 'Pns11/12', 4, NULL),
(32359, NULL, 'IPR038138', NULL, 'Phosphopantoate/pantothenate synthetase superfamily', 'PPS/PS_sf', 5, NULL),
(32360, NULL, 'IPR035857', NULL, 'STAT6, SH2 domain', 'STAT6_SH2', 3, NULL),
(32361, NULL, 'IPR038843', NULL, 'Cell wall protein Sed1/Spi1', 'Sed1/Spi1', 4, NULL),
(32362, NULL, 'IPR033817', NULL, 'MIG-17 peptidase', 'MIG-17', 3, NULL),
(32363, NULL, 'IPR040896', NULL, '26S proteasome regulatory subunit RPN5, C-terminal domain', 'RPN5_C', 3, NULL),
(32364, NULL, 'IPR034849', NULL, 'Maltogenic alpha-amylase, CBM20 domain', 'CBM20_novamyl', 3, NULL),
(32365, NULL, 'IPR036385', NULL, 'Ribulose bisphosphate carboxylase, small subunit superfamily', 'RuBisCO_ssu_sf', 5, NULL),
(32366, NULL, 'IPR033860', NULL, 'Brcc36 isopeptidase', 'MPN_BRCC36', 4, NULL),
(32367, NULL, 'IPR035848', NULL, 'SH3 domain-binding protein 2', 'SH3BP2', 4, NULL),
(32368, NULL, 'IPR038423', NULL, 'Calcium-dependent cell adhesion molecule, C-terminal domain superfamily', 'CAD_C_sf', 5, NULL),
(32369, NULL, 'IPR037622', NULL, 'Liprin-alpha, SAM domain repeat 3', 'Liprin-alpha_SAM_rpt_3', 3, NULL),
(32370, NULL, 'IPR034801', NULL, 'hnRNP A0, RNA recognition motif 1', 'hnRNPA0_RRM1', 3, NULL),
(32371, NULL, 'IPR038507', NULL, 'YcnI-like superfamily', 'YcnI-like_sf', 5, NULL),
(32372, NULL, 'IPR033948', NULL, 'Electron transfer flavoprotein, beta subunit, N-terminal', 'ETF_beta_N', 3, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(32373, NULL, 'IPR034797', NULL, 'PTBPH3, RNA recognition motif 3', 'PTBPH3_RRM3', 3, NULL),
(32374, NULL, 'IPR038135', NULL, 'Methylthiotransferase, N-terminal domain superfamily', 'Methylthiotransferase_N_sf', 5, NULL),
(32375, NULL, 'IPR033850', NULL, 'Carboxypeptidase O', 'Carboxypeptidase_O', 3, NULL),
(32376, NULL, 'IPR037891', NULL, 'Immunity protein Cdil-like superfamily', 'Cdil-like_sf', 5, NULL),
(32377, NULL, 'IPR038470', NULL, 'Cellulose synthase subunit D superfamily', 'Cellsynth_D_sf', 5, NULL),
(32378, NULL, 'IPR036766', NULL, 'Fe(II) trafficking protein YggX superfamily', 'Fe_traffick_prot_YggX_sf', 5, NULL),
(32379, NULL, 'IPR035530', NULL, 'Phage-like element PBSX protein XtrA', 'PBSX_XtrA', 4, NULL),
(32380, NULL, 'IPR036686', NULL, 'Hydrophobin superfamily', 'Hydrophobin_sf', 5, NULL),
(32381, NULL, 'IPR040829', NULL, 'SMODS-associated NUDIX domain', 'Sa_NUDIX', 3, NULL),
(32382, NULL, 'IPR035670', NULL, 'Plant AGD1/2/3/4, BAR domain', 'AGD1/2/3/4_BAR_plant', 3, NULL),
(32383, NULL, 'IPR039010', NULL, 'Synaptotagmin, SMP domain', 'Synaptotagmin_SMP', 3, NULL),
(32384, NULL, 'IPR038804', NULL, 'Root meristem growth factor 3', 'RGF3', 4, NULL),
(32385, NULL, 'IPR038607', NULL, 'PhoD-like superfamily', 'PhoD-like_sf', 5, NULL),
(32386, NULL, 'IPR040838', NULL, 'SabA, N-terminal extracellular adhesion domain', 'SabA_N_adhesion', 3, NULL),
(32387, NULL, 'IPR034408', NULL, 'Sulphate/thiosulphate-binding site', 'Sulphate/thiosulphate_BS', 1, NULL),
(32388, NULL, 'IPR037855', NULL, 'Vacuolar protein sorting protein 36', 'Vps36', 4, NULL),
(32389, NULL, 'IPR034494', NULL, 'TIAR, RNA recognition motif 2', 'TIAR_RRM2', 3, NULL),
(32390, NULL, 'IPR038856', NULL, 'Death effector domain-containing protein', 'DEDD/DEDD2', 4, NULL),
(32391, NULL, 'IPR040844', NULL, 'Phosphodiesterase 4 upstream conserved regions (UCR)', 'PDE4_UCR', 3, NULL),
(32392, NULL, 'IPR040886', NULL, 'TRIF, N-terminal', 'TRIF_N', 3, NULL),
(32393, NULL, 'IPR038058', NULL, 'PhnH-like superfamily', 'PhnH-like_sp', 5, NULL),
(32394, NULL, 'IPR035831', NULL, 'TRIM21, PRY/SPRY domain', 'PRY/SPRY_TRIM21', 3, NULL),
(32395, NULL, 'IPR038475', NULL, 'RecG, C-terminal domain superfamily', 'RecG_C_sf', 5, NULL),
(32396, NULL, 'IPR033687', NULL, 'Uncharacterised protein YodQ-like', 'YodQ-like', 4, NULL),
(32397, NULL, 'IPR037619', NULL, 'Liprin-beta, SAM domain repeat 3', 'Liprin-beta_SAM_rpt_3', 3, NULL),
(32398, NULL, 'IPR034800', NULL, 'PTBP2, RNA recognition motif 4', 'PTBP2_RRM4', 3, NULL),
(32399, NULL, 'IPR037639', NULL, 'SMOC-1, extracellular calcium-binding domain', 'SMOC1_EC', 3, NULL),
(32400, NULL, 'IPR033849', NULL, 'Carboxypeptidase B2', 'CPB2', 3, NULL),
(32401, NULL, 'IPR037314', NULL, 'Post-transcriptional regulator MKT1, H3TH domain', 'MKT1_H3TH', 3, NULL),
(32402, NULL, 'IPR038872', NULL, 'Putative glutathione transferase 3', 'Put_GTT3', 4, NULL),
(32403, NULL, 'IPR036593', NULL, 'CPE0013-like superfamily', 'CPE0013-like_sf', 5, NULL),
(32404, NULL, 'IPR037258', NULL, 'PB2, C-terminal', 'PDB2_C', 5, NULL),
(32405, NULL, 'IPR034520', NULL, 'SRSF1, RNA recognition motif  1', 'SRSF1_RRM1', 3, NULL),
(32406, NULL, 'IPR038564', NULL, 'Repressor of RNA polymerase III transcription Maf1 superfamily', 'Maf1_sf', 5, NULL),
(32407, NULL, 'IPR034848', NULL, 'Phosphoglucan water dikinase, CB20 domain', 'CBM20_water_dikinase', 3, NULL),
(32408, NULL, 'IPR038836', NULL, 'Mediator of RNA polymerase II transcription subunit 16', 'MED16', 4, NULL),
(32409, NULL, 'IPR038695', NULL, 'Saro_0823-like superfamily', 'Saro_0823-like_sf', 5, NULL),
(32410, NULL, 'IPR036764', NULL, 'Cysteine protease Prp superfamily', 'Peptidase_Prp_sf', 5, NULL),
(32411, NULL, 'IPR038460', NULL, 'Acetyl-CoA hydrolase/transferase, C-terminal domain superfamily', 'AcetylCoA_hyd_C_sf', 5, NULL),
(32412, NULL, 'IPR040449', NULL, 'LD-carboxypeptidase, N-terminal', 'Peptidase_S66_N', 3, NULL),
(32413, NULL, 'IPR040874', NULL, 'Protein of of unknown function DUF5551', 'DUF5551', 4, NULL),
(32414, NULL, 'IPR038614', NULL, 'Glycerate kinase, N-terminal domain superfamily', 'GK_N_sf', 5, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(32415, NULL, 'IPR035784', NULL, 'Fbxo45, SPRY domain', 'SPRY_FBXO45', 3, NULL),
(32416, NULL, 'IPR037257', NULL, 'Type II secretion system protein GspE, N-terminal superfamily', 'T2SS_E_N_sf', 5, NULL),
(32417, NULL, 'IPR038796', NULL, 'At1g76070-like', 'At1g76070-like', 4, NULL),
(32418, NULL, 'IPR035786', NULL, 'TRIM60, PRY/SPRY domain', 'SPRY/PRY_TRIM60', 3, NULL),
(32419, NULL, 'IPR038886', NULL, 'E3 ubiquitin-protein ligase complex, subunit SLX5/Rfp1', 'E3_SLX5/Rfp1', 4, NULL),
(32420, NULL, 'IPR039014', NULL, 'Protein myomixer', 'Myomixer', 4, NULL),
(32421, NULL, 'IPR035712', NULL, 'TRADD', 'TRADD', 4, NULL),
(32422, NULL, 'IPR035844', NULL, 'ShkA/ShkC, SH2 domain', 'ShkA/ShkC_SH2', 3, NULL),
(32423, NULL, 'IPR038476', NULL, 'UvrC, RNAse H endonuclease domain superfamily', 'UvrC_RNase_H_dom_sf', 5, NULL),
(32424, NULL, 'IPR036687', NULL, 'DinI-like superfamily', 'DinI-like_sf', 5, NULL),
(32425, NULL, 'IPR038798', NULL, 'Coiled-coil domain-containing protein 138', 'CCDC138', 4, NULL),
(32426, NULL, 'IPR034794', NULL, 'PTBPH1/PTBPH2, RNA recognition motif 3', 'PTBPH1/PTBPH2_RRM3', 3, NULL),
(32427, NULL, 'IPR040833', NULL, 'Protein of unknown function DUF5631', 'DUF5631', 3, NULL),
(32428, NULL, 'IPR038652', NULL, 'Circovirus capsid superfamily', 'Circovirus_capsid_sf', 5, NULL),
(32429, NULL, 'IPR037542', NULL, 'Adenovirus hexon protein', 'ADV_hexon', 4, NULL),
(32430, NULL, 'IPR036079', NULL, 'V-type ATP synthase subunit c/d subunit superfamily', 'ATPase_su_c/d_sf', 5, NULL),
(32431, NULL, 'IPR038560', NULL, 'Beta-1,3-xylanase, CBM31 domain superfamily', 'Beta-xylanase_CBM31_sf', 5, NULL),
(32432, NULL, 'IPR037621', NULL, 'Liprin-alpha, SAM domain repeat 2', 'Liprin-alpha_SAM_rpt_2', 3, NULL),
(32433, NULL, 'IPR033993', NULL, 'Tumor necrosis factor receptor 1A, N-terminal', 'TNFRSF1A_N', 3, NULL),
(32434, NULL, 'IPR040890', NULL, 'CopZ, zinc binding domain', 'Znf_CopZ', 3, NULL),
(32435, NULL, 'IPR038466', NULL, 'Peptidase S8, pro-domain superfamily', 'S8_pro-domain_sf', 5, NULL),
(32436, NULL, 'IPR036763', NULL, 'Putative dsDNA mimic superfamily', 'Put_dsDNA_mimic_sf', 5, NULL),
(32437, NULL, 'IPR036375', NULL, 'Hemopexin-like domain superfamily', 'Hemopexin-like_dom_sf', 5, NULL),
(32438, NULL, 'IPR038471', NULL, 'MecA, C-terminal domain superfamily', 'MecA_C_sf', 5, NULL),
(32439, NULL, 'IPR036380', NULL, 'Isochorismatase-like superfamily', 'Isochorismatase-like_sf', 5, NULL),
(32440, NULL, 'IPR036087', NULL, 'Nicotinate-nucleotide-dimethylbenzimidazole phosphoribosyltransferase-like superfamily', 'Nict_dMeBzImd_PRibTrfase_sf', 5, NULL),
(32441, NULL, 'IPR040450', NULL, 'TFIIF beta subunit, HTH domain', 'TFIIF_beta_HTH', 3, NULL),
(32442, NULL, 'IPR034792', NULL, 'PTBPH1/PTBPH2, RNA recognition motif 1', 'PTBPH1/PTBPH2_RRM1', 3, NULL),
(32443, NULL, 'IPR038805', NULL, 'Transmembrane protein 139', 'TMEM139', 4, NULL),
(32444, NULL, 'IPR036729', NULL, 'TRADD, N-terminal domain superfamily', 'TRADD_N_sf', 5, NULL),
(32445, NULL, 'IPR039943', NULL, 'Inducible T-cell costimulator', 'ICOS', 4, NULL),
(32446, NULL, 'IPR034809', NULL, 'Nop4, RNA recognition motif 4', 'Nop4_RRM4', 3, NULL),
(32447, NULL, 'IPR035669', NULL, 'GDSL lipase/esterase-like, plant', 'SGNH_plant_lipase-like', 4, NULL),
(32448, NULL, 'IPR038529', NULL, 'FPRL1/chemotaxis inhibitory protein superfamily', 'FLIPR/CHIP_sf', 5, NULL),
(32449, NULL, 'IPR038869', NULL, 'Defect at low temperature protein 1', 'DLT1', 4, NULL),
(32450, NULL, 'IPR036082', NULL, 'NSP3 superfamily', 'NSP3_sf', 5, NULL),
(32451, NULL, 'IPR033837', NULL, 'Ubiquitinyl hydrolase-L5', 'UCH37', 3, NULL),
(32452, NULL, 'IPR036383', NULL, 'Thrombospondin type-1 (TSP1) repeat superfamily', 'TSP1_rpt_sf', 5, NULL),
(32453, NULL, 'IPR039945', NULL, 'Lymphocyte antigen 86', 'LY86', 4, NULL),
(32454, NULL, 'IPR033167', NULL, 'Archaeal Nre', 'Nre', 4, NULL),
(32455, NULL, 'IPR037210', NULL, 'YoaC-like superfamily', 'YoaC-like_sf', 5, NULL),
(32456, NULL, 'IPR037797', NULL, 'FGD2, N-terminal PH domain', 'FGD2_PH1', 3, NULL),
(32457, NULL, 'IPR037848', NULL, 'GEM-like protein', 'GEM-like', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(32458, NULL, 'IPR035355', NULL, 'Protein of unknown function DUF5423', 'DUF5423', 4, NULL),
(32459, NULL, 'IPR033895', NULL, 'UDP-GlcNAc-dolichyl-phosphate GlcNAc phosphotransferase', 'GPT', 4, NULL),
(32460, NULL, 'IPR035135', NULL, 'Protein of unknown function DUF5496', 'DUF5496', 4, NULL),
(32461, NULL, 'IPR039870', NULL, 'Cytochrome oxidase assembly factor 4-like', 'Coa4-like', 4, NULL),
(32462, NULL, 'IPR038769', NULL, 'Maintenance of telomere capping protein 4', 'MTC4', 4, NULL),
(32463, NULL, 'IPR033711', NULL, 'TATA-box binding protein, archaea', 'TBP_archaea', 4, NULL),
(32464, NULL, 'IPR035353', NULL, 'Gene product 79', 'Gp79', 4, NULL),
(32465, NULL, 'IPR037399', NULL, 'Prostaglandin reductase 2', 'PTGR2', 4, NULL),
(32466, NULL, 'IPR038474', NULL, 'Polyketide synthesis cyclase superfamily', 'Polyketide_synth_cyclase_sf', 5, NULL),
(32467, NULL, 'IPR038464', NULL, 'Ribosomal protein L38e superfamily', 'Ribosomal_L38e_sf', 5, NULL),
(32468, NULL, 'IPR040842', NULL, 'Sorting nexin-17/31, FERM domain', 'SNX17/31_FERM', 3, NULL),
(32469, NULL, 'IPR036722', NULL, 'CART, C-terminal domain superfamily', 'CART_C_sf', 5, NULL),
(32470, NULL, 'IPR038892', NULL, 'Structural maintenance of chromosomes flexible hinge domain-containing protein 1', 'SMCHD1', 4, NULL),
(32471, NULL, 'IPR035785', NULL, 'TRIM75, PRY/SPRY domain', 'SPRY/PRY_TRIM75', 3, NULL),
(32472, NULL, 'IPR038800', NULL, 'Coiled-coil domain-containing protein 17', 'CCDC17', 4, NULL),
(32473, NULL, 'IPR037860', NULL, 'Chimaerin, RhoGAP domain', 'RhoGAP_chimaerin', 3, NULL),
(32474, NULL, 'IPR038018', NULL, 'Uncharacterised protein HP_1531', 'HP_1531', 5, NULL),
(32475, NULL, 'IPR037793', NULL, 'OCRL1/INPP5B, INPP5c domain', 'OCRL1/INPP5B_INPP5c', 3, NULL),
(32476, NULL, 'IPR038765', NULL, 'Papain-like cysteine peptidase superfamily', 'Papain-like_cys_pep_sf', 5, NULL),
(32477, NULL, 'IPR040835', NULL, 'Nucleotide modification associated domain 5', 'Nmad5', 3, NULL),
(32478, NULL, 'IPR033522', NULL, 'Receptor-type tyrosine-protein phosphatase-like N/N2', 'IA-2/IA-2_beta', 4, NULL),
(32479, NULL, 'IPR038747', NULL, 'Stannin', 'Stannin', 4, NULL),
(32480, NULL, 'IPR038832', NULL, 'Cell division cycle-associated protein 3', 'CDCA3', 4, NULL),
(32481, NULL, 'IPR036586', NULL, 'Neurotoxin B-IV-like superfamily', 'Neurotoxin_B-IV-like_sf', 5, NULL),
(32482, NULL, 'IPR039737', NULL, 'Type I inositol 1,4,5-trisphosphate 5-phosphatase', 'INPP5A', 4, NULL),
(32483, NULL, 'IPR037552', NULL, 'Outer dense fibre protein 1, alpha crystallin domain', 'ODF1_ACD', 3, NULL),
(32484, NULL, 'IPR033421', NULL, 'Rit1, DUSP-like domain', 'Rit1_DUSP-like', 3, NULL),
(32485, NULL, 'IPR038764', NULL, 'GNAT family N-acetyltransferase, predicted', 'GNAT_N_AcTrfase_prd', 4, NULL),
(32486, NULL, 'IPR040796', NULL, 'CRISPR-associated endonuclease Cas9, beta-hairpin domain', 'Cas9_b_hairpin', 3, NULL),
(32487, NULL, 'IPR036599', NULL, 'DNA ligase, ATP-dependent, N-terminal domain superfamily', 'DNA_ligase_N_sf', 5, NULL),
(32488, NULL, 'IPR033838', NULL, 'Colicin V processing peptidase', 'CvaB_peptidase', 3, NULL),
(32489, NULL, 'IPR038795', NULL, 'Mediator of RNA polymerase II transcription subunit 8, plant', 'MED8_plant', 4, NULL),
(32490, NULL, 'IPR034492', NULL, 'TIAR, RNA recognition motif 1', 'TIAR_RRM1', 3, NULL),
(32491, NULL, 'IPR040012', NULL, 'Cell surface glycoprotein CD200 receptor', 'CD200R', 4, NULL),
(32492, NULL, 'IPR036749', NULL, 'Expansin, cellulose-binding-like domain superfamily', 'Expansin_CBD_sf', 5, NULL),
(32493, NULL, 'IPR033326', NULL, 'E3 ubiquitin-protein ligase BAH1', 'BAH1', 4, NULL),
(32494, NULL, 'IPR038841', NULL, 'Uncharacterized protein PF07_0086', 'PF07_0086', 4, NULL),
(32495, NULL, 'IPR038473', NULL, 'VirC2, C-terminal domain superfamily', 'VirC2_C_sf', 5, NULL),
(32496, NULL, 'IPR039877', NULL, 'Transmembrane protein 131-like', 'TMEM131-like', 4, NULL),
(32497, NULL, 'IPR037617', NULL, 'Liprin-beta, SAM domain repeat 1', 'Liprin-beta_SAM_rpt_1', 3, NULL),
(32498, NULL, 'IPR037853', NULL, 'Net1, PH domain', 'Net1_PH', 3, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(32499, NULL, 'IPR038890', NULL, 'DBF4-type zinc finger-containing protein 2', 'ZDBF2', 4, NULL),
(32500, NULL, 'IPR038272', NULL, 'Bd37, core domain superfamily', 'Bd37_core_sf', 5, NULL),
(32501, NULL, 'IPR036920', NULL, 'Ribosomal protein L10e/L16 superfamily', 'Ribosomal_L10e/L16_sf', 5, NULL),
(32502, NULL, 'IPR039207', NULL, 'Multiple myeloma tumor-associated protein 2-like', 'MMTAG2-like', 4, NULL),
(32503, NULL, 'IPR035647', NULL, 'EF-G domain III/V-like', 'EFG_III/V', 5, NULL),
(32504, NULL, 'IPR038482', NULL, 'Periplasmic metal-binding protein Tp34-type superfamily', 'Tp34-type_sf', 5, NULL),
(32505, NULL, 'IPR037724', NULL, 'Ferlin, fifth C2 domain', 'C2E_Ferlin', 3, NULL),
(32506, NULL, 'IPR038995', NULL, 'Portal protein, Caudovirales', 'Portal_prot_Caudovirale', 4, NULL),
(32507, NULL, 'IPR038844', NULL, 'Cilia- and flagella-associated protein 157', 'CFAP157', 4, NULL),
(32508, NULL, 'IPR037990', NULL, 'Myosin 5b, cargo-binding domain', 'Myo5b_CBD', 3, NULL),
(32509, NULL, 'IPR037267', NULL, 'Photosystem II PsbJ superfamily', 'PSII_PsbJ_sf', 5, NULL),
(32510, NULL, 'IPR033227', NULL, 'Calcium-dependent secretion activator', 'CAPS', 4, NULL),
(32511, NULL, 'IPR033727', NULL, 'LIM3 prickle', 'LIM3_prickle', 3, NULL),
(32512, NULL, 'IPR038662', NULL, 'F1F0 ATP synthase subunit C superfamily', 'ATP_synth_F0_csu_sf', 5, NULL),
(32513, NULL, 'IPR033432', NULL, 'Glycosyl hydrolase 36, catalytic domain', 'GH36_catalytic', 3, NULL),
(32514, NULL, 'IPR039068', NULL, 'Pyrroloquinoline-quinone synthase-like', 'PqqC-like', 4, NULL),
(32515, NULL, 'IPR040860', NULL, 'Gp37/Dip protein', 'Dip', 4, NULL),
(32516, NULL, 'IPR035884', NULL, 'SH2D2A, SH2 domain', 'SH2D2A_SH2', 3, NULL),
(32517, NULL, 'IPR039217', NULL, 'Lymphocyte antigen 96', 'LY96', 4, NULL),
(32518, NULL, 'IPR035605', NULL, 'CACNB2, SH3 domain', 'CACNB2_SH3', 3, NULL),
(32519, NULL, 'IPR039178', NULL, 'Protein Lag2', 'Lag2', 4, NULL),
(32520, NULL, 'IPR036175', NULL, 'Sec23/Sec24 helical domain superfamily', 'Sec23/24_helical_dom_sf', 5, NULL),
(32521, NULL, 'IPR040861', NULL, 'Large polyvalent protein-associated domain 13', 'LPD13', 3, NULL),
(32522, NULL, 'IPR039011', NULL, 'Insulin receptor substrate', 'IRS', 4, NULL),
(32523, NULL, 'IPR037551', NULL, 'DAZ, RNA recognition motif, vertebrates', 'DAZ_RRM_vert', 3, NULL),
(32524, NULL, 'IPR038993', NULL, 'Internal virion protein Gp15', 'Gp15', 4, NULL),
(32525, NULL, 'IPR036056', NULL, 'Fibrinogen-like, C-terminal', 'Fibrinogen-like_C', 5, NULL),
(32526, NULL, 'IPR037093', NULL, 'Smaug, PHAT domain superfamily', 'PHAT_dom_sf', 5, NULL),
(32527, NULL, 'IPR037951', NULL, 'YdeP-like, MopB domain', 'MopB_CT_YdeP', 3, NULL),
(32528, NULL, 'IPR036924', NULL, 'Prion/Doppel beta-ribbon domain superfamily', 'Prion/Doppel_b-ribbon_dom_sf', 5, NULL),
(32529, NULL, 'IPR038859', NULL, 'DNA-binding protein RHL1', 'RHL1', 4, NULL),
(32530, NULL, 'IPR035880', NULL, 'VAV2, SH2 domain', 'VAV2_SH2', 3, NULL),
(32531, NULL, 'IPR033410', NULL, 'Protein of unknown function DUF5119', 'DUF5119', 4, NULL),
(32532, NULL, 'IPR037656', NULL, 'Family of unknown function DUF5525', 'DUF5525', 4, NULL),
(32533, NULL, 'IPR036602', NULL, 'tRNA wybutosine-synthesizing-like superfamily', 'tRNA_yW-synthesising-like_sf', 5, NULL),
(32534, NULL, 'IPR039242', NULL, 'Mediator of RNA polymerase II transcription subunit 9, metazoan', 'MED9_metazoa', 4, NULL),
(32535, NULL, 'IPR038683', NULL, 'Interleukin-17 receptor A/B, FnIII-like domain 1 superfamily', 'IL17RA/B_FnIII-like_1_sf', 5, NULL),
(32536, NULL, 'IPR037097', NULL, 'Photosynthetic reaction centre, H subunit, N-terminal domain superfamily', 'Photo_RC_H_N_sf', 5, NULL),
(32537, NULL, 'IPR039245', NULL, 'Peroxisomal/glyoxysomal leader peptide-processing protease', 'TYSND1/DEG15', 4, NULL),
(32538, NULL, 'IPR035875', NULL, 'BMX, SH2 domain', 'BMX_SH2', 3, NULL),
(32539, NULL, 'IPR033697', NULL, 'Ribonuclease T2, eukaryotic', 'Ribonuclease_T2_eukaryotic', 4, NULL),
(32540, NULL, 'IPR037668', NULL, 'Uncharacterized protein C1orf100', 'C1orf100', 4, NULL),
(32541, NULL, 'IPR037518', NULL, 'MPN domain', 'MPN', 3, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(32542, NULL, 'IPR037500', NULL, 'Protein MULTIPOLAR SPINDLE 1', 'Msp1', 4, NULL),
(32543, NULL, 'IPR036521', NULL, 'Signal recognition particle, subunit SRP19-like superfamily', 'SRP19-like_sf', 5, NULL),
(32544, NULL, 'IPR039272', NULL, 'CLEC16A/TT9', 'CLEC16A/TT9', 4, NULL),
(32545, NULL, 'IPR036597', NULL, 'Fido-like domain superfamily', 'Fido-like_dom_sf', 5, NULL),
(32546, NULL, 'IPR039165', NULL, 'CREB3 regulatory factor', 'CREBRF', 4, NULL),
(32547, NULL, 'IPR037726', NULL, 'Ferlin, first C2 domain', 'C2A_Ferlin', 3, NULL),
(32548, NULL, 'IPR033717', NULL, 'Undecaprenol kinase', 'UDPK', 4, NULL),
(32549, NULL, 'IPR039315', NULL, 'Chemotaxis protein CheW', 'CheW', 4, NULL),
(32550, NULL, 'IPR038336', NULL, 'NET domain superfamily', 'NET_sf', 5, NULL),
(32551, NULL, 'IPR035182', NULL, 'Protein of unknown function PsaF', 'PsaF', 4, NULL),
(32552, NULL, 'IPR039604', NULL, 'Nuclear segregation protein Bfr1', 'Bfr1', 4, NULL),
(32553, NULL, 'IPR033431', NULL, 'Domain of unknown function DUF5126', 'DUF5126', 3, NULL),
(32554, NULL, 'IPR037661', NULL, 'Transmembrane protein 196', 'TMEM196', 4, NULL),
(32555, NULL, 'IPR036111', NULL, 'Malate/L-sulfolactate/L-lactate dehydrogenase-like superfamily', 'Mal/L-sulfo/L-lacto_DH-like_sf', 5, NULL),
(32556, NULL, 'IPR037716', NULL, 'Rhodopsin kinase, catalytic domain', 'GRK1_dom', 3, NULL),
(32557, NULL, 'IPR038696', NULL, 'Invasion protein B superfamily', 'IalB_sf', 5, NULL),
(32558, NULL, 'IPR039671', NULL, 'Protein THEMIS', 'THEMIS', 4, NULL),
(32559, NULL, 'IPR037837', NULL, 'Kindlin/fermitin, PH domain', 'PH_Kindlin/fermitin', 3, NULL),
(32560, NULL, 'IPR035957', NULL, 'Crustacean CHH/MIH/GIH neurohormone superfamily', 'Crust_neurohorm_sf', 5, NULL),
(32561, NULL, 'IPR035700', NULL, 'Rsc1/Rsc2, bromodomain', 'Rsc1/Rsc2_Bromo', 3, NULL),
(32562, NULL, 'IPR036925', NULL, 'Translation initiation factor IF-2, domain 3 superfamily', 'TIF_IF2_dom3_sf', 5, NULL),
(32563, NULL, 'IPR038481', NULL, 'Melampsora avirulence protein AvrL567 superfamily', 'Melampsora_AvrL567_sf', 5, NULL),
(32564, NULL, 'IPR038781', NULL, 'Uncharacterized membrane protein C365.16-ike', 'C365.16-ike', 4, NULL),
(32565, NULL, 'IPR038372', NULL, 'Influenza RNA-dependent RNA polymerase subunit PA, endonuclease domain', 'PA/PA-X_sf', 5, NULL),
(32566, NULL, 'IPR040856', NULL, 'Glucose ABC transporter, C-terminal', 'GlcV_C', 3, NULL),
(32567, NULL, 'IPR038063', NULL, 'L,D-transpeptidase catalytic domain-like', 'Transpep_catalytic_dom', 5, NULL),
(32568, NULL, 'IPR039069', NULL, 'Carbohydrate esterase 7 family', 'CE7', 4, NULL),
(32569, NULL, 'IPR036590', NULL, 'SOS response associated peptidase-like', 'SRAP-like', 5, NULL),
(32570, NULL, 'IPR037991', NULL, 'Myosin 5c, cargo-binding domain', 'Myo5c_CBD', 3, NULL),
(32571, NULL, 'IPR039183', NULL, 'Coiled-coil domain-containing protein 66', 'CCD66', 4, NULL),
(32572, NULL, 'IPR037293', NULL, 'Galactose oxidase, central domain superfamily', 'Gal_Oxidase_central_sf', 5, NULL),
(32573, NULL, 'IPR035538', NULL, 'PPIL4-like, cyclophilin domain', 'Cyclophilin_PPIL4', 3, NULL),
(32574, NULL, 'IPR033406', NULL, 'Domain of unknown function DUF5113', 'DUF5113', 3, NULL),
(32575, NULL, 'IPR038816', NULL, 'Stationary phase protein 5', 'Stationary_phase_5', 4, NULL),
(32576, NULL, 'IPR037723', NULL, 'Ferlin, fourth C2 domain', 'C2D_Ferlin', 3, NULL),
(32577, NULL, 'IPR037949', NULL, 'Acetylene hydratase, MopB domain', 'MopB_CT_Acetylene-hydratase', 3, NULL),
(32578, NULL, 'IPR037663', NULL, 'Modulator of smoothened protein', 'Mosmo', 4, NULL),
(32579, NULL, 'IPR035466', NULL, 'GlmS/AgaS, SIS domain 1', 'GlmS/AgaS_SIS', 3, NULL),
(32580, NULL, 'IPR038788', NULL, 'Testis-expressed protein 46-like', 'TEX46-like', 4, NULL),
(32581, NULL, 'IPR036592', NULL, 'Photosystem I PsaL, reaction centre subunit XI superfamily', 'PSI_PsaL_sf', 5, NULL),
(32582, NULL, 'IPR039673', NULL, 'DNA-binding protein SATB1/SATB2', 'SATB1/SATB2', 4, NULL),
(32583, NULL, 'IPR038468', NULL, 'Transport accessory protein MmpS, C-terminal', 'MmpS_C', 5, NULL),
(32584, NULL, 'IPR035876', NULL, 'SH2D1A, SH2 domain', 'SH2D1A_SH2', 3, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(32585, NULL, 'IPR039121', NULL, 'Acyl-coenzyme A diphosphatase NUDT19', 'NUDT19', 4, NULL),
(32586, NULL, 'IPR035790', NULL, 'E3 ubiquitin-protein ligase TRIM38, PRY/SPRY domain', 'SPRY/PRY_TRIM38', 3, NULL),
(32587, NULL, 'IPR033952', NULL, 'Stimulator of interferon genes protein, C-terminal', 'STING_C', 3, NULL),
(32588, NULL, 'IPR039204', NULL, 'Magnesium transporter MRS2-like', 'MRS2-like', 4, NULL),
(32589, NULL, 'IPR038340', NULL, 'MRP-L47 superfamily, mitochondrial', 'MRP-L47_sf', 5, NULL),
(32590, NULL, 'IPR035315', NULL, 'Protein of unknown function DUF5372', 'DUF5372', 4, NULL),
(32591, NULL, 'IPR040863', NULL, 'Protein of unknown function DUF5554', 'DUF5554', 4, NULL),
(32592, NULL, 'IPR033378', NULL, 'Protein BRICK1', 'BRICK1', 4, NULL),
(32593, NULL, 'IPR039248', NULL, 'Phosphatase RsbX', 'Ptase_RsbX', 4, NULL),
(32594, NULL, 'IPR034275', NULL, 'Ascorbate oxidase homologue, third cupredoxin domain', 'CuRO_3_AO-like', 3, NULL),
(32595, NULL, 'IPR038149', NULL, 'Scaffold protein B superfamily', 'Phage_B_sf', 5, NULL),
(32596, NULL, 'IPR039273', NULL, 'AP-4 complex accessory subunit Tepsin', 'TEPSIN', 4, NULL),
(32597, NULL, 'IPR033128', NULL, 'Adenylosuccinate synthase,  active site', 'Adenylosuccin_syn_Lys_AS', 0, NULL),
(32598, NULL, 'IPR037929', NULL, 'APPL1, BAR domain', 'APPL1_BAR', 3, NULL),
(32599, NULL, 'IPR035177', NULL, 'Type VI secretion system TssN', 'TssN', 4, NULL),
(32600, NULL, 'IPR036361', NULL, 'SAP domain superfamily', 'SAP_dom_sf', 5, NULL),
(32601, NULL, 'IPR038347', NULL, 'TyeA superfamily', 'TyeA_sf', 5, NULL),
(32602, NULL, 'IPR038737', NULL, 'Splicing factor 3B subunit 1-like', 'SF3b_su1-like', 4, NULL),
(32603, NULL, 'IPR038862', NULL, 'Chloroplast thylakoid lumenal protein MPH2', 'MPH2', 4, NULL),
(32604, NULL, 'IPR035878', NULL, 'STAP2, SH2 domain', 'STAP2_SH2', 3, NULL),
(32605, NULL, 'IPR039120', NULL, 'Ubiquitin domain-containing protein UBFD1', 'UBFD1', 4, NULL),
(32606, NULL, 'IPR038332', NULL, 'PPE superfamily', 'PPE_sf', 5, NULL),
(32607, NULL, 'IPR035797', NULL, 'ARHGEF16/ARHGEF26, SH3 domain', 'ARHGEF16/ARHGEF26_SH3', 3, NULL),
(32608, NULL, 'IPR039179', NULL, 'PDZ domain-containing protein 9', 'PDZD9', 4, NULL),
(32609, NULL, 'IPR037920', NULL, 'Probable oxidoreductase YoaE, C-terminal', 'YoaE_C', 3, NULL),
(32610, NULL, 'IPR038072', NULL, 'GspK, central domain superfamily', 'GspK_central_sf', 5, NULL),
(32611, NULL, 'IPR035883', NULL, 'Nck2, SH2 domain', 'Nck2_SH2', 3, NULL),
(32612, NULL, 'IPR036584', NULL, 'Flagellar protein FliS superfamily', 'FliS_sf', 5, NULL),
(32613, NULL, 'IPR036049', NULL, 'Ribosomal protein L29/L35 superfamily', 'Ribosomal_L29/L35_sf', 5, NULL),
(32614, NULL, 'IPR035881', NULL, 'VAV3, SH2 domain', 'VAV3_SH2', 3, NULL),
(32615, NULL, 'IPR038344', NULL, 'EF-G binding protein, N-terminal domain superfamily', 'EF-G_N_sf', 5, NULL),
(32616, NULL, 'IPR033485', NULL, 'Protein EMSY-LIKE, plant', 'EMSY-LIKE_plant', 4, NULL),
(32617, NULL, 'IPR038342', NULL, 'Effector protein HopAB, BAK1-binding domain superfamily', 'HopAB_BAK-bd_sf', 5, NULL),
(32618, NULL, 'IPR035794', NULL, 'E3 ubiquitin-protein ligase SH3RF2, second SH3 domain', 'SH3RF2_SH3_2', 3, NULL),
(32619, NULL, 'IPR033729', NULL, 'Serine-tRNA ligase catalytic core domain', 'SerRS_core', 3, NULL),
(32620, NULL, 'IPR035319', NULL, 'Protein of unknown function DUF5378', 'DUF5378', 4, NULL),
(32621, NULL, 'IPR038153', NULL, 'dTDP-4-dehydro-6-deoxy-alpha-D-glucopyranose 2,3-dehydratase superfamily', 'EvaA-like_sf', 5, NULL),
(32622, NULL, 'IPR038773', NULL, 'Lymphocyte antigen 6 complex locus protein G5b', 'LY6G5B', 4, NULL),
(32623, NULL, 'IPR033207', NULL, 'Centriolar coiled-coil protein of 110kDa', 'CCP110', 4, NULL),
(32624, NULL, 'IPR038487', NULL, 'Mre11, capping domain', 'Mre11_capping_dom', 5, NULL),
(32625, NULL, 'IPR038721', NULL, 'Transposase IS701-like, DDE domain', 'IS701-like_DDE_dom', 3, NULL),
(32626, NULL, 'IPR035310', NULL, 'Galactose-inhibitable lectin 35kDa subunit', 'Gal_GalNac_35kDa', 4, NULL),
(32627, NULL, 'IPR037761', NULL, 'Tricalbin, C2A domain', 'C2A_Tricalbin', 3, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(32628, NULL, 'IPR035793', NULL, 'GDAP2, macro domain', 'Macro_GDAP2', 3, NULL),
(32629, NULL, 'IPR036520', NULL, 'UPF0759 superfamily', 'UPF0759_sf', 5, NULL),
(32630, NULL, 'IPR038997', NULL, 'Major capsid protein, Myoviridae', 'CAPSID_Myoviridae', 4, NULL),
(32631, NULL, 'IPR038685', NULL, 'PAD, N-terminal domain superfamily', 'PAD_N_sf', 5, NULL),
(32632, NULL, 'IPR038994', NULL, 'Internal virion protein Gp16', 'Gp16', 4, NULL),
(32633, NULL, 'IPR039195', NULL, 'Ankyrin repeat domain-containing protein 40', 'ANKRD40', 4, NULL),
(32634, NULL, 'IPR038896', NULL, 'E3 ubiquitin-protein ligase RNF170', 'RNF170', 4, NULL),
(32635, NULL, 'IPR038762', NULL, 'Antibiotic biosynthesis monooxygenase, predicted', 'ABM_predict', 4, NULL),
(32636, NULL, 'IPR037461', NULL, 'CtCE2-like domain', 'CtCE2-like_dom', 3, NULL),
(32637, NULL, 'IPR036928', NULL, 'Amidase signature (AS) superfamily', 'AS_sf', 5, NULL),
(32638, NULL, 'IPR039555', NULL, 'F plasmid transfer operon protein', 'TraF/TrbB', 4, NULL),
(32639, NULL, 'IPR035318', NULL, 'Protein of unknown function DUF5377', 'DUF5377', 4, NULL),
(32640, NULL, 'IPR039225', NULL, 'Transcription factor Gibbin', 'AHDC1', 4, NULL),
(32641, NULL, 'IPR038366', NULL, 'Zinc finger, ClpX C4-type superfamily', 'Znf_CppX_C4_sf', 5, NULL),
(32642, NULL, 'IPR036108', NULL, 'Tetrapyrrole biosynthesis, uroporphyrinogen III synthase superfamily', '4pyrrol_syn_uPrphyn_synt_sf', 5, NULL),
(32643, NULL, 'IPR038156', NULL, 'Phytochelatin synthase, N-terminal domain superfamily', 'PCS_N_sf', 5, NULL),
(32644, NULL, 'IPR036115', NULL, 'GCM domain superfamily', 'GCM_dom_sf', 5, NULL),
(32645, NULL, 'IPR037762', NULL, 'Tricalbin, C2C domain', 'C2C_Tricalbin', 3, NULL),
(32646, NULL, 'IPR036021', NULL, 'Aldehyde ferredoxin oxidoreductase-like, C-terminal', 'Tungsten_al_ferr_oxy-like_C', 5, NULL),
(32647, NULL, 'IPR033730', NULL, 'Prokaryote proline-tRNA ligase core domain', 'ProRS_core_prok', 3, NULL),
(32648, NULL, 'IPR037936', NULL, 'Netrin receptor UNC5', 'UNC5', 4, NULL),
(32649, NULL, 'IPR039147', NULL, 'Ankyrin repeat and SOCS box protein 17', 'ASB17', 4, NULL),
(32650, NULL, 'IPR040853', NULL, 'RapA2, cadherin-like domain', 'RapA2_cadherin-like', 3, NULL),
(32651, NULL, 'IPR039226', NULL, 'Ski3/TTC37', 'Ski3/TTC37', 4, NULL),
(32652, NULL, 'IPR037438', NULL, 'Talin-1/2, rod-segment', 'Talin1/2-RS', 3, NULL),
(32653, NULL, 'IPR038899', NULL, 'Methyltransferase-like protein 22', 'METTL22', 4, NULL),
(32654, NULL, 'IPR038789', NULL, 'Protein LOW PSII ACCUMULATION 2 like', 'LPA2-like', 4, NULL),
(32655, NULL, 'IPR040855', NULL, 'Origin recognition complex subunit 3, winged helix C-terminal', 'ORC_WH_C', 3, NULL),
(32656, NULL, 'IPR037541', NULL, 'Uncharacterized MFS-type transporter YfcJ', 'MFS_YfcJ', 4, NULL),
(32657, NULL, 'IPR038996', NULL, 'Internal virion protein Gp14', 'Gp14', 4, NULL),
(32658, NULL, 'IPR038345', NULL, 'Flavivirus envelope glycoprotein E, Stem/Anchor domain superfamily', 'Flavi_E_Stem/Anchor_dom_sf', 5, NULL),
(32659, NULL, 'IPR038629', NULL, 'Type II heat-labile enterotoxin, B subunit superfamily', 'LT-IIB_sf', 5, NULL),
(32660, NULL, 'IPR040260', NULL, 'Replication factor A protein-like', 'RFA2-like', 4, NULL),
(32661, NULL, 'IPR038719', NULL, 'Phycobilisome, alpha/beta subunit superfamily', 'Phycobilisome_asu/bsu_sf', 5, NULL),
(32662, NULL, 'IPR035877', NULL, 'STAP1, SH2 domain', 'STAP1_SH2', 3, NULL),
(32663, NULL, 'IPR033157', NULL, 'Cathepsin Z', 'CTSZ', 4, NULL),
(32664, NULL, 'IPR039281', NULL, 'Arabinogalactan protein 3/12/13/14/21', 'AGP3/12/13/14/21', 4, NULL),
(32665, NULL, 'IPR038624', NULL, 'YedD-like superfamily', 'YedD-like_sf', 5, NULL),
(32666, NULL, 'IPR033763', NULL, 'Polycomb group protein, RNA binding region', 'SCML2_RBR', 3, NULL),
(32667, NULL, 'IPR033182', NULL, 'MICOS complex subunit MIC26/MIC27, animal', 'MIC26/MIC27_animal', 4, NULL),
(32668, NULL, 'IPR040862', NULL, 'Hemagglutinin I', 'HA1', 3, NULL),
(32669, NULL, 'IPR038848', NULL, 'Calcium-binding tyrosine phosphorylation-regulated protein', 'CABYR', 4, NULL),
(32670, NULL, 'IPR037624', NULL, 'Nuclear pore complex protein Nup133-like', 'Nup133-like', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(32671, NULL, 'IPR039247', NULL, 'RNA-binding protein KhpB', 'KhpB', 4, NULL),
(32672, NULL, 'IPR038930', NULL, 'Precursor of CEP13/CEP14', 'CEP13/CEP14', 4, NULL),
(32673, NULL, 'IPR039209', NULL, 'ORC ubiquitin ligase 1', 'OBI1', 4, NULL),
(32674, NULL, 'IPR039181', NULL, 'EIG121-like', 'EIG121-like', 4, NULL),
(32675, NULL, 'IPR039465', NULL, 'Interleukin-17 receptor-like', 'IL-17_rcpt-like', 4, NULL),
(32676, NULL, 'IPR040864', NULL, 'Protein of unknown function DUF5553', 'DUF5553', 4, NULL),
(32677, NULL, 'IPR035802', NULL, 'Tepsin, ENTH/VHS domain', 'ENTH/VHS_tepsin', 3, NULL),
(32678, NULL, 'IPR034046', NULL, 'Tumor necrosis factor receptor 16, N-terminal', 'TNFRSF16_N', 3, NULL),
(32679, NULL, 'IPR038735', NULL, 'MSMEG_1276-like, nucleoside triphosphate pyrophosphohydrolase domain', 'MSMEG_1276-like_NTP-PPase_dom', 3, NULL),
(32680, NULL, 'IPR036107', NULL, 'Carbon storage regulator superfamily', 'CsrA_sf', 5, NULL),
(32681, NULL, 'IPR035795', NULL, 'E3 ubiquitin-protein ligase SH3RF1, second SH3 domain', 'SH3RF1_SH3_2', 3, NULL),
(32682, NULL, 'IPR033714', NULL, 'Phenylalanly tRNA synthetase, tRNA-binding-domain', 'tRNA_bind_bactPheRS', 3, NULL),
(32683, NULL, 'IPR039318', NULL, 'Protein O-mannose kinase', 'POMK', 4, NULL),
(32684, NULL, 'IPR036926', NULL, 'Thymidylate synthase/dCMP hydroxymethylase superfamily', 'Thymidate_synth/dCMP_Mease_sf', 5, NULL),
(32685, NULL, 'IPR039150', NULL, 'Transcription elongation factor, mitochondrial', 'TEFM', 4, NULL),
(32686, NULL, 'IPR035792', NULL, 'E3 ubiquitin-protein ligase SH3RF2, first SH3 domain', 'SH3RF2_SH3_1', 3, NULL),
(32687, NULL, 'IPR038368', NULL, 'Mastadenovirus E4/Orf3 superfamily', 'Mastadenovirus_E4/Orf3_sf', 5, NULL),
(32688, NULL, 'IPR033852', NULL, 'Cytosolic aminopeptidase 1/4', 'CBPC1/4', 3, NULL),
(32689, NULL, 'IPR039159', NULL, 'SAYSvFN domain-containing protein 1', 'SAYSD1', 4, NULL),
(32690, NULL, 'IPR039046', NULL, 'PDPK1 family', 'PDPK1', 4, NULL),
(32691, NULL, 'IPR038864', NULL, 'Protein heading date repressor 1', 'HDR1', 4, NULL),
(32692, NULL, 'IPR039047', NULL, 'Phosphorylated adapter RNA export protein', 'PHAX', 4, NULL),
(32693, NULL, 'IPR033686', NULL, 'Tyrosine recombinase XerA', 'XerA', 4, NULL),
(32694, NULL, 'IPR039285', NULL, 'Dehydrin HIRD11-like', 'HIRD11-like', 4, NULL),
(32695, NULL, 'IPR035178', NULL, 'Protein of unknown function DUF5466', 'DUF5466', 4, NULL),
(32696, NULL, 'IPR039275', NULL, 'PDZ domain-containing protein 8', 'PDZD8', 4, NULL),
(32697, NULL, 'IPR038491', NULL, 'Velvet domain superfamily', 'Velvet_dom_sf', 5, NULL),
(32698, NULL, 'IPR040848', NULL, 'Midasin, AAA lid domain 7', 'AAA_lid_7', 3, NULL),
(32699, NULL, 'IPR039007', NULL, 'Rho GTPase-activating protein, pG1 domain', 'pG1', 3, NULL),
(32700, NULL, 'IPR036600', NULL, 'Paired amphipathic helix superfamily', 'PAH_sf', 5, NULL),
(32701, NULL, 'IPR039048', NULL, 'Mitochondrial pseudouridylate synthase Trub2', 'Trub2', 4, NULL),
(32702, NULL, 'IPR039157', NULL, 'RNA-binding protein 18, RNA recognition motif', 'RBM18_RRM', 3, NULL),
(32703, NULL, 'IPR036116', NULL, 'Fibronectin type III superfamily', 'FN3_sf', 5, NULL),
(32704, NULL, 'IPR038341', NULL, 'DNA helicase UvsW superfamily', 'UvsW_sf', 5, NULL),
(32705, NULL, 'IPR039099', NULL, 'Pannexin', 'Pannexin', 4, NULL),
(32706, NULL, 'IPR038850', NULL, 'Endothelial cell-specific molecule 1', 'ESM1', 4, NULL),
(32707, NULL, 'IPR035791', NULL, 'TRIM27, PRY/SPRY domain', 'SPRY/PRY_TRIM27', 3, NULL),
(32708, NULL, 'IPR036114', NULL, 'Class VI myosin, motor domain', 'MYSc_Myo6', 3, NULL),
(32709, NULL, 'IPR038365', NULL, 'EcoRII, C-terminal domain superfamily', 'EcoRII_C_sf', 5, NULL),
(32710, NULL, 'IPR039049', NULL, 'Elongin B', 'ELOB', 4, NULL),
(32711, NULL, 'IPR038663', NULL, 'Bacteriophage PRD1, P5 C-terminal domain superfamily', 'PRD1_P5_C_sf', 5, NULL),
(32712, NULL, 'IPR037094', NULL, 'Glycoside hydrolase family 38, central domain superfamily', 'Glyco_hydro_38_cen_sf', 5, NULL),
(32713, NULL, 'IPR036519', NULL, 'Uncharacterised UPF0058 superfamily', 'UPF0058_sf', 5, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(32714, NULL, 'IPR039523', NULL, 'Alpha-L-glutamate ligase-related protein, ATP-grasp domain', 'RimK-rel_E_lig_ATP-grasp', 3, NULL),
(32715, NULL, 'IPR038150', NULL, 'Protein CHLORORESPIRATORY REDUCTION 7-like superfamily', 'CRR7-like_sf', 5, NULL),
(32716, NULL, 'IPR039203', NULL, 'Disease resistance protein, RPW8-like', 'RPW8-like', 4, NULL),
(32717, NULL, 'IPR039280', NULL, 'VASCULAR-RELATED UNKNOWN PROTEIN', 'VUP', 4, NULL),
(32718, NULL, 'IPR037667', NULL, 'Protein FMC1 homologue', 'FMC1_homologue', 4, NULL),
(32719, NULL, 'IPR033127', NULL, 'Ubiquitin-activating enzyme E1, Cys active site', 'UBQ-activ_enz_E1_Cys_AS', 0, NULL),
(32720, NULL, 'IPR039278', NULL, 'NURS complex subunit red1', 'Red1', 4, NULL),
(32721, NULL, 'IPR038931', NULL, 'Probable NAD(P)H dehydrogenase subunit CRR3, chloroplastic', 'CRR3', 4, NULL),
(32722, NULL, 'IPR037527', NULL, 'Envelope glycoprotein Gp160', 'Gp160', 4, NULL),
(32723, NULL, 'IPR034245', NULL, 'Ephrin type-B receptor 3, ligand binding domain', 'EphB3_rcpt_lig-bd', 3, NULL),
(32724, NULL, 'IPR033125', NULL, 'Deoxyribonuclease I, conservied site', 'DNASE_I_2', 2, NULL),
(32725, NULL, 'IPR038343', NULL, 'DUF4951 superfamily', 'DUF4951_sf', 5, NULL),
(32726, NULL, 'IPR037659', NULL, 'Small integral membrane protein 7', 'SMIM7', 4, NULL),
(32727, NULL, 'IPR037930', NULL, 'Tom40', 'Tom40', 4, NULL),
(32728, NULL, 'IPR038337', NULL, 'Poxvirus poly(A) polymerase, catalytic subunit, N-terminal domain superfamily', 'Poxvirus_polyA_pol_cat_N_sf', 5, NULL),
(32729, NULL, 'IPR036604', NULL, 'Phosphoribosylformylglycinamidine synthase subunit PurS-like superfamily', 'PurS-like_sf', 5, NULL),
(32730, NULL, 'IPR037755', NULL, 'Plc1, PH domain', 'Plc1_PH', 3, NULL),
(32731, NULL, 'IPR035789', NULL, 'Rho guanine nucleotide exchange factor 7, SH3 domain', 'BetaPIX_SH3', 3, NULL),
(32732, NULL, 'IPR039199', NULL, 'FAM91', 'FAM91', 4, NULL),
(32733, NULL, 'IPR033743', NULL, 'Effector protein HopAB, Pto-binding domain', 'HopAB_PID', 3, NULL),
(32734, NULL, 'IPR035882', NULL, 'Nck1, SH2 domain', 'Nck1_SH2', 3, NULL),
(32735, NULL, 'IPR039205', NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 11', 'NDUFA11', 4, NULL),
(32736, NULL, 'IPR035181', NULL, 'Protein of unknown function DUF5463', 'DUF5463', 4, NULL),
(32737, NULL, 'IPR039156', NULL, 'PHAF1/Protein broad-minded', 'PHAF1/BROMI', 4, NULL),
(32738, NULL, 'IPR039066', NULL, 'Hepatocyte nuclear factor 1', 'HNF-1', 4, NULL),
(32739, NULL, 'IPR037268', NULL, 'Photosystem II PsbT superfamily', 'PSII_PsbT_sf', 5, NULL),
(32740, NULL, 'IPR040258', NULL, 'FACT complex subunit Spt16', 'Spt16', 4, NULL),
(32741, NULL, 'IPR037958', NULL, 'Butyrophilin subfamily 1/2, SPRY/PRY domain', 'SPRY/PRY_BTN1/2', 3, NULL),
(32742, NULL, 'IPR039155', NULL, 'Malectin', 'MLEC', 4, NULL),
(32743, NULL, 'IPR035151', NULL, 'Inhibitor of toxin/antitoxin system', 'TA_inhibitor', 4, NULL),
(32744, NULL, 'IPR037732', NULL, 'Synaptotagmin 7, C2A domain', 'C2A_Synaptotagmin-7', 3, NULL),
(32745, NULL, 'IPR038863', NULL, 'Putative NADH dehydrogenase [ubiquinone] 1 beta subcomplex subunit 8, mitochondrial', 'Put_Complex_I_su8', 4, NULL),
(32746, NULL, 'IPR033126', NULL, 'Glycosyl hydrolases family 9, Asp/Glu active sites', 'Glyco_hydro_9_Asp/Glu_AS', 0, NULL),
(32747, NULL, 'IPR033408', NULL, 'Domain of unknown function DUF5115', 'DUF5115', 3, NULL),
(32748, NULL, 'IPR037272', NULL, 'Sodium:neurotransmitter symporter superfamily', 'SNS_sf', 5, NULL),
(32749, NULL, 'IPR039098', NULL, 'TERF1-interacting nuclear factor 2', 'TINF2', 4, NULL),
(32750, NULL, 'IPR036055', NULL, 'LDL receptor-like superfamily', 'LDL_receptor-like_sf', 5, NULL),
(32751, NULL, 'IPR037237', NULL, 'IlvD/EDD, N-terminal domain', 'IlvD/EDD_N', 5, NULL),
(32752, NULL, 'IPR040854', NULL, 'Protein of unknown function DUF5575', 'DUF5575', 4, NULL),
(32753, NULL, 'IPR037095', NULL, 'RBP-J/Cbf11, DNA binding domain superfamily', 'RBP-J/Cbf11_DNA-bd_sf', 5, NULL),
(32754, NULL, 'IPR036525', NULL, 'Tubulin/FtsZ, GTPase domain superfamily', 'Tubulin/FtsZ_GTPase_sf', 5, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(32755, NULL, 'IPR036052', NULL, 'Tryptophan synthase beta chain-like, PALP domain superfamily', 'TrpB-like_PALP_sf', 5, NULL),
(32756, NULL, 'IPR038715', NULL, 'RNA polymerase inhibitor superfamily', 'RNA_pol_inhibitor_sf', 5, NULL),
(32757, NULL, 'IPR037664', NULL, 'BldD, C-terminal', 'BldD_C', 3, NULL),
(32758, NULL, 'IPR035314', NULL, 'Protein of unknown function DUF5370', 'DUF5370', 4, NULL),
(32759, NULL, 'IPR037462', NULL, 'ERp19', 'ERp19', 4, NULL),
(32760, NULL, 'IPR039222', NULL, 'Regulatory solute carrier protein family 1 member 1', 'RSC1A1', 4, NULL),
(32761, NULL, 'IPR038346', NULL, 'DrrA, PI4P binding domain superfamily', 'DrrA_PI4P-bd_sf', 5, NULL),
(32762, NULL, 'IPR039062', NULL, 'Spermatogenesis-associated protein 1', 'SPAT1', 4, NULL),
(32763, NULL, 'IPR039182', NULL, 'Ribonucleases P/MRP protein subunit Pop1', 'Pop1', 4, NULL),
(32764, NULL, 'IPR035505', NULL, 'ZMYND8/11, PWWP domain', 'ZMYND8/11_PWWP', 3, NULL),
(32765, NULL, 'IPR037528', NULL, 'Acetylglutamate kinase ArgB', 'ArgB', 4, NULL),
(32766, NULL, 'IPR036929', NULL, 'Thiol:disulfide interchange protein DsbD, N-terminal domain superfamily', 'DsbDN_sf', 5, NULL),
(32767, NULL, 'IPR039244', NULL, 'Galanin-like peptide', 'GALP', 4, NULL),
(32768, NULL, 'IPR035801', NULL, 'Protein-ADP-ribose hydrolase, macro domain', 'Macro_1', 3, NULL),
(32769, NULL, 'IPR039283', NULL, 'Motile sperm domain-containing protein 1/3', 'MOSPD1/3', 4, NULL),
(32770, NULL, 'IPR038734', NULL, 'Uncharacterized protein YhaN, AAA domain', 'YhaN_AAA', 3, NULL),
(32771, NULL, 'IPR037269', NULL, 'Photosystem II PsbM superfamily', 'PSII_PsbM_sf', 5, NULL),
(32772, NULL, 'IPR037665', NULL, 'Nucleoporin peptidase S59-like', 'Nucleoporin_S59-like', 4, NULL),
(32773, NULL, 'IPR039164', NULL, 'E3 ubiquitin-protein ligase UBR1-like', 'UBR1-like', 4, NULL),
(32774, NULL, 'IPR037733', NULL, 'Extended synaptotagmin, C2A domain', 'Ext_Synaptotagmin_C2A', 3, NULL),
(32775, NULL, 'IPR037460', NULL, 'Streptomyces scabies esterase-like', 'SEST-like', 4, NULL),
(32776, NULL, 'IPR035184', NULL, 'DNA replication protein 17', 'Phage_Gp17', 4, NULL),
(32777, NULL, 'IPR033718', NULL, 'Diacylglycerol kinase, prokaryotic', 'DAGK_prok', 4, NULL),
(32778, NULL, 'IPR037516', NULL, 'Tripartite DENN domain', 'Tripartite_DENN', 3, NULL),
(32779, NULL, 'IPR037360', NULL, 'COMM domain-containing protein 9', 'COMMD9', 4, NULL),
(32780, NULL, 'IPR037817', NULL, 'Transcription initiation factor TFIID subunit 7', 'TAF7', 4, NULL),
(32781, NULL, 'IPR036112', NULL, '(2R)-phospho-3-sulpholactate synthase, ComA superfamily', 'ComA_synth_sf', 5, NULL),
(32782, NULL, 'IPR037274', NULL, 'Zinc finger, CHY-type superfamily', 'Znf_CHY_sf', 5, NULL),
(32783, NULL, 'IPR039212', NULL, 'Putative ribosome-binding factor A, mitochondrial', 'RBFA_mitochondrial', 4, NULL),
(32784, NULL, 'IPR039282', NULL, 'Protein response to low sulfur', 'LSU', 4, NULL),
(32785, NULL, 'IPR039193', NULL, '28S ribosomal protein S17, mitochondrial', 'S17mt', 4, NULL),
(32786, NULL, 'IPR038363', NULL, 'LepA, C-terminal domain superfamily', 'LepA_C_sf', 5, NULL),
(32787, NULL, 'IPR038718', NULL, 'SNF2-like, N-terminal domain superfamily', 'SNF2-like_sf', 5, NULL),
(32788, NULL, 'IPR038846', NULL, 'DNA-directed RNA polymerase III subunit RPC9', 'RPC9', 4, NULL),
(32789, NULL, 'IPR036364', NULL, 'SEA domain superfamily', 'SEA_dom_sf', 5, NULL),
(32790, NULL, 'IPR036524', NULL, 'Frataxin/CyaY superfamily', 'Frataxin/CyaY_sf', 5, NULL),
(32791, NULL, 'IPR035887', NULL, 'CIS, SH2 domain', 'CIS_SH2', 3, NULL),
(32792, NULL, 'IPR037265', NULL, 'Poly(A) polymerase catalytic subunit superfamily', 'PolyA_pol_cat_sf', 5, NULL),
(32793, NULL, 'IPR039554', NULL, 'HigA2-like, helix-turn-helix domain', 'HigA2-like_HTH', 3, NULL),
(32794, NULL, 'IPR035709', NULL, 'RutC family, YoaB-like', 'YoaB-like', 4, NULL),
(32795, NULL, 'IPR037478', NULL, 'YwkD-like domain', 'YwkD-like_dom', 3, NULL),
(32796, NULL, 'IPR038338', NULL, 'PriB/PriC superfamily', 'PriB/PriC_sf', 5, NULL),
(32797, NULL, 'IPR036174', NULL, 'Zinc finger, Sec23/Sec24-type superfamily', 'Znf_Sec23_Sec24_sf', 5, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(32798, NULL, 'IPR038069', NULL, 'Pelota/DOM34, N-terminal domain', 'Pelota/DOM34_N', 5, NULL),
(32799, NULL, 'IPR038371', NULL, 'Multi-copper polyphenol oxidoreductase superfamily', 'Cu_polyphenol_OxRdtase_sf', 5, NULL),
(32800, NULL, 'IPR036117', NULL, 'DhaL domain superfamily', 'DhaL_dom_sf', 5, NULL),
(32801, NULL, 'IPR039189', NULL, 'CTD phosphatase Fcp1', 'Fcp1', 4, NULL),
(32802, NULL, 'IPR038693', NULL, 'Phenylacetyl-CoA epoxidase, subunit B', 'PaaB_sf', 5, NULL),
(32803, NULL, 'IPR037236', NULL, 'STIV B116-like superfamily', 'STIV_B116-like_sf', 5, NULL),
(32804, NULL, 'IPR038472', NULL, 'DNA sulphur modification protein DndE superfamily', 'DndE_sf', 5, NULL),
(32805, NULL, 'IPR039184', NULL, 'Sterile alpha and TIR motif-containing protein 1', 'SARM1', 4, NULL),
(32806, NULL, 'IPR038339', NULL, 'MatP, N-terminal domain superfamily', 'MatP_N_sf', 5, NULL),
(32807, NULL, 'IPR035590', NULL, 'CBY1-interacting BAR domain-containing protein 1/2, BAR domain', 'BAR_CBAR1/2', 3, NULL),
(32808, NULL, 'IPR038772', NULL, 'Sphingomyelin phosphodiesterase 2-like', 'SMPD2-like', 4, NULL),
(32809, NULL, 'IPR037463', NULL, 'Thioredoxin-related transmembrane protein 2, thioredoxin domain', 'TMX2_thioredoxin_dom', 3, NULL),
(32810, NULL, 'IPR039284', NULL, 'Coiled-coil domain-containing protein 159/163', 'CCDC159/163', 4, NULL),
(32811, NULL, 'IPR039158', NULL, 'Solute carrier family 25 member 46', 'SLC25A46', 4, NULL),
(32812, NULL, 'IPR035308', NULL, 'Protein of unknown function DUF5368', 'DUF5368', 4, NULL),
(32813, NULL, 'IPR037275', NULL, 'Zinc finger, CTCHY-type superfamily', 'Znf_CTCHY_sf', 5, NULL),
(32814, NULL, 'IPR038155', NULL, 'Arterivirus papain-like cysteine protease alpha (PCPalpha) domain superfamily', 'AV_PCPalpha_sf', 5, NULL),
(32815, NULL, 'IPR039061', NULL, 'MDN2-binding protein', 'MTBP', 4, NULL),
(32816, NULL, 'IPR039220', NULL, 'FAM3 family', 'FAM3', 4, NULL),
(32817, NULL, 'IPR036522', NULL, 'Molybdopterin cofactor biosynthesis C (MoaC) domain superfamily', 'MoaC_sf', 5, NULL),
(32818, NULL, 'IPR039270', NULL, 'Zinc finger protein 469', 'ZNF469', 4, NULL),
(32819, NULL, 'IPR039123', NULL, 'Protein phosphatase 2C', 'PPTC7', 4, NULL),
(32820, NULL, 'IPR039286', NULL, 'Exosporium protein C', 'CsxC', 4, NULL),
(32821, NULL, 'IPR033124', NULL, 'Serine carboxypeptidases, histidine active site', 'Ser_caboxypep_his_AS', 0, NULL),
(32822, NULL, 'IPR034273', NULL, 'Ascorbate oxidase homologue, first cupredoxin domain', 'CuRO_1_AAO-like', 3, NULL),
(32823, NULL, 'IPR036177', NULL, 'Peptidase M55, D-aminopeptidase superfamily', 'Peptidase_M55_sf', 5, NULL),
(32824, NULL, 'IPR037662', NULL, 'Cilia- and flagella-associated protein 107-like', 'CFAP107-like', 4, NULL),
(32825, NULL, 'IPR033100', NULL, 'Exosome complex component RRP45', 'Rrp45', 4, NULL),
(32826, NULL, 'IPR039192', NULL, 'Glycogen synthase kinase 3, catalytic domain', 'STKc_GSK3', 3, NULL),
(32827, NULL, 'IPR035364', NULL, 'Glycosyl hydrolase 101, beta-sandwich domain', 'Glyco_hyd_101_beta', 3, NULL),
(32828, NULL, 'IPR038057', NULL, 'EV matrix domain superfamily', 'EV_matrix_sf', 5, NULL),
(32829, NULL, 'IPR040852', NULL, 'Cas12a, RuvC nuclease domain', 'RuvC_1', 3, NULL),
(32830, NULL, 'IPR037277', NULL, 'Granulin superfamily', 'Granulin_sf', 5, NULL),
(32831, NULL, 'IPR037671', NULL, 'GPI ethanolamine phosphate transferase 1, N-terminal', 'PIGN_N', 3, NULL),
(32832, NULL, 'IPR039153', NULL, 'Fetal and adult testis-expressed transcript protein', 'FATE1', 4, NULL),
(32833, NULL, 'IPR037791', NULL, 'Ingression protein 1, C2 domain', 'C2_fungal_Inn1', 3, NULL),
(32834, NULL, 'IPR033374', NULL, 'NMDA receptor synaptonuclear signalling and neuronal migration factor', 'NSMF', 4, NULL),
(32835, NULL, 'IPR037658', NULL, 'Voltage-dependent calcium channel beta subunit-associated regulatory protein', 'CBARP', 4, NULL),
(32836, NULL, 'IPR039154', NULL, 'Serine/Threonine kinase LKB1, catalytic domain', 'LKB1_c', 3, NULL),
(32837, NULL, 'IPR038623', NULL, 'Stimulator of interferon genes protein, C-terminal domain superfamily', 'STING_C_sf', 5, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(32838, NULL, 'IPR039196', NULL, 'ATP synthase assembly factor Fmc1, mitochondrial', 'Fmc1', 4, NULL),
(32839, NULL, 'IPR039185', NULL, '1-acylglycerol-3-phosphate O-acyltransferase PNPLA3', 'Pat_PNPLA3', 4, NULL),
(32840, NULL, 'IPR033405', NULL, 'Domain of unknown function DUF5112', 'DUF5112', 3, NULL),
(32841, NULL, 'IPR039197', NULL, 'Mrs1/Cce1', 'Mrs1/Cce1', 4, NULL),
(32842, NULL, 'IPR039525', NULL, 'E3 ubiquitin-protein ligase RNF126-like, zinc-ribbon', 'RNF126-like_zinc-ribbon', 3, NULL),
(32843, NULL, 'IPR036050', NULL, 'E2 regulatory, transactivation domain', 'Regulatory_protein_E2_N', 5, NULL),
(32844, NULL, 'IPR038861', NULL, 'Activity-dependent neuroprotector homeobox protein', 'ADNP/ADNP2', 4, NULL),
(32845, NULL, 'IPR039256', NULL, 'Ketosteroid isomerase', 'Ketosteroid_isomerase', 4, NULL),
(32846, NULL, 'IPR033728', NULL, 'Threonine-tRNA ligase catalytic core domain', 'ThrRS_core', 3, NULL),
(32847, NULL, 'IPR038364', NULL, 'Urocanase, central domain superfamily', 'Urocanase_central_sf', 5, NULL),
(32848, NULL, 'IPR037092', NULL, 'Flavocytochrome c sulphide dehydrogenase, flavin-binding domain superfamily', 'FlavoCytC_S_DH_flav-bd_sf', 5, NULL),
(32849, NULL, 'IPR033731', NULL, 'Glycyl-tRNA synthetase-like core domain', 'GlyRS-like_core', 3, NULL),
(32850, NULL, 'IPR037536', NULL, 'Packaging protein 3', 'ADV_PKG3', 4, NULL),
(32851, NULL, 'IPR033726', NULL, 'LIM2 prickle', 'LIM2_prickle', 3, NULL),
(32852, NULL, 'IPR039148', NULL, '5''-AMP-activated protein kinase catalytic subunit alpha-2, C-terminal', 'AMPKA2_C', 3, NULL),
(32853, NULL, 'IPR037660', NULL, 'Coiled-coil domain-containing protein 51', 'CCDC51', 4, NULL),
(32854, NULL, 'IPR037666', NULL, 'Coiled-coil domain-containing protein 43', 'CCDC43', 4, NULL),
(32855, NULL, 'IPR038756', NULL, 'CheY-P phosphatase CheX-like', 'CheX-like', 4, NULL),
(32856, NULL, 'IPR037928', NULL, 'ASAP1, BAR domain', 'ASAP1_BAR', 3, NULL),
(32857, NULL, 'IPR039187', NULL, 'Strawberry notch, AAA domain', 'SNO_AAA', 3, NULL),
(32858, NULL, 'IPR038367', NULL, 'PelD, GGDEF domain superfamily', 'PelD_GGDEF_sf', 5, NULL),
(32859, NULL, 'IPR033712', NULL, 'Pumilio, RNA binding domain', 'Pumilio_RNA-bd', 3, NULL),
(32860, NULL, 'IPR036357', NULL, 'Photosystem I reaction centre subunit VIII superfamily', 'PSI_PsaI_sf', 5, NULL),
(32861, NULL, 'IPR036594', NULL, 'Methionine synthase domain', 'Meth_synthase_dom', 5, NULL),
(32862, NULL, 'IPR039200', NULL, 'Ectodysplasin-A receptor-associated adapter protein', 'EDARADD', 4, NULL),
(32863, NULL, 'IPR040458', NULL, 'Vacuolar import/degradation Vid27', 'Vid27', 4, NULL),
(32864, NULL, 'IPR037491', NULL, 'Low-temperature-induced 78kDa/65kDa', 'LTI78/LTI65', 4, NULL),
(32865, NULL, 'IPR039227', NULL, 'Guanine nucleotide-binding protein G(I)/G(S)/G(O) subunit gamma-13', 'GNG13', 4, NULL),
(32866, NULL, 'IPR037670', NULL, 'Uncharacterized protein C11orf87', 'C11orf87', 4, NULL),
(32867, NULL, 'IPR038158', NULL, 'H-NOX domain superfamily', 'H-NOX_domain_sf', 5, NULL),
(32868, NULL, 'IPR037657', NULL, 'RAB7A-interacting MON1-CCZ1 complex subunit 1', 'RIMC1', 4, NULL),
(32869, NULL, 'IPR036930', NULL, 'WGR domain superfamily', 'WGR_dom_sf', 5, NULL),
(32870, NULL, 'IPR040858', NULL, 'Rubisco accumulation factor 1, C-terminal', 'Raf1_C', 3, NULL),
(32871, NULL, 'IPR039201', NULL, 'PAK4-inhibitor inka', 'Inka', 4, NULL),
(32872, NULL, 'IPR039149', NULL, 'Zinc finger protein 800', 'ZNF800', 4, NULL),
(32873, NULL, 'IPR037096', NULL, 'KCNMB2, ball/chain domain superfamily', 'KCNMB2_ball/chain_dom_sf', 5, NULL),
(32874, NULL, 'IPR039522', NULL, 'RING finger family 1, prokaryotic', 'RING_finger_1_prok', 4, NULL),
(32875, NULL, 'IPR037972', NULL, 'RepB, N-terminal', 'RepB_N', 3, NULL),
(32876, NULL, 'IPR033430', NULL, 'Domain of unknown function DUF5121', 'DUF5121', 3, NULL),
(32877, NULL, 'IPR039162', NULL, 'Homeodomain-only protein', 'HOPX', 4, NULL),
(32878, NULL, 'IPR038790', NULL, 'Mediator of RNA polymerase II transcription subunit 9, plant', 'Med9_plant', 4, NULL),
(32879, NULL, 'IPR040454', NULL, 'Transcription factor IIIC subunit  Tfc1/Sfc1', 'TF_IIIC_Tfc1/Sfc1', 4, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(32880, NULL, 'IPR035152', NULL, 'GA-like domain', 'GA-like', 3, NULL),
(32881, NULL, 'IPR040865', NULL, 'Primase X', 'PriX', 3, NULL),
(32882, NULL, 'IPR033433', NULL, 'Domain of unknown function DUF5127', 'DUF5127', 3, NULL),
(32883, NULL, 'IPR034224', NULL, 'Carboxypeptidase D,  carboxypeptidase-like domain 2', 'M14_CPD_II', 3, NULL),
(32884, NULL, 'IPR038335', NULL, 'ACP, C-terminal domain superfamily', 'ACP_C_sf', 5, NULL),
(32885, NULL, 'IPR039065', NULL, 'AcoX-like', 'AcoX-like', 4, NULL),
(32886, NULL, 'IPR037271', NULL, 'Photosystem II PsbI superfamily', 'PSII_PsbI_sf', 5, NULL),
(32887, NULL, 'IPR038849', NULL, 'ADP-ribosylation factor-like protein 2-binding protein', 'ARL2BP', 4, NULL),
(32888, NULL, 'IPR038333', NULL, 'Type I restriction enzyme EcoKI-like, methylase subunit, N-terminal domain superfamily', 'T1MK-like_N_sf', 5, NULL),
(32889, NULL, 'IPR039146', NULL, 'G patch domain and ankyrin repeat-containing protein 1', 'GPANK1', 4, NULL),
(32890, NULL, 'IPR039239', NULL, 'Adherens junction-associated protein 1', 'AJAP1', 4, NULL),
(32891, NULL, 'IPR037655', NULL, 'POU domain class 2-associating factor 2', 'POU2AF2', 4, NULL),
(32892, NULL, 'IPR039064', NULL, 'Zinc finger protein 750-like, zinc finger', 'ZNF750_Znf', 3, NULL),
(32893, NULL, 'IPR038375', NULL, 'Protein arginine methyltransferase NDUFAF7 superfamily', 'NDUFAF7_sf', 5, NULL),
(32894, NULL, 'IPR035885', NULL, 'SH2D7, SH2 domain', 'SH2D7_SH2', 3, NULL),
(32895, NULL, 'IPR039177', NULL, 'Nonsense-mediated mRNA decay factor SMG9', 'SMG9', 4, NULL),
(32896, NULL, 'IPR037818', NULL, 'Transcription initiation factor TFIID subunit 8', 'TAF8', 4, NULL),
(32897, NULL, 'IPR039176', NULL, 'Osteocalcin', 'Osteocalcin', 4, NULL),
(32898, NULL, 'IPR036523', NULL, 'SurE-like phosphatase/nucleotidase superfamily', 'SurE-like_sf', 5, NULL),
(32899, NULL, 'IPR039119', NULL, 'ABT1/Esf2', 'ABT1/Esf2', 4, NULL),
(32900, NULL, 'IPR036362', NULL, 'Adenovirus DNA-binding, N-terminal domain superfamily', 'Adenovirus_DNA-bd_N_sf', 5, NULL),
(32901, NULL, 'IPR038374', NULL, 'Restriction endonuclease ThaI superfamily', 'ThaI_sf', 5, NULL),
(32902, NULL, 'IPR039163', NULL, 'ER membrane protein complex subunit 7', 'EMC7', 4, NULL),
(32903, NULL, 'IPR038490', NULL, 'Gingipain propeptide superfamily', 'Gingipain_propep_sf', 5, NULL),
(32904, NULL, 'IPR037719', NULL, 'A-kinase anchor protein 10, PKA-binding (AKB) domain', 'AKAP10_AKB_dom', 3, NULL),
(32905, NULL, 'IPR038065', NULL, 'Tetrabrachion, parallel right-handed coiled coil domain', 'Tetrabrachion_parallel_CC', 5, NULL),
(32906, NULL, 'IPR038665', NULL, 'Voltage-dependent anion channel superfamily', 'Voltage-dep_anion_channel_sf', 5, NULL),
(32907, NULL, 'IPR036918', NULL, 'Pyruvate kinase, C-terminal domain superfamily', 'Pyrv_Knase_C_sf', 5, NULL),
(32908, NULL, 'IPR033429', NULL, 'Domain of unknown function DUF5125', 'DUF5125', 3, NULL),
(32909, NULL, 'IPR036178', NULL, 'Formimidoyltransferase-cyclodeaminase-like superfamily', 'Formintransfe-cycloase-like_sf', 5, NULL),
(32910, NULL, 'IPR033748', NULL, 'L-ribulose-5-phosphate 4-epimerase AraD', 'AraD_entero', 4, NULL),
(32911, NULL, 'IPR036172', NULL, 'Apolipoprotein A-II (ApoA-II) superfamily', 'ApoA-II_sf', 5, NULL),
(32912, NULL, 'IPR038898', NULL, 'BRO1 domain-containing protein BROX', 'BROX', 4, NULL),
(32913, NULL, 'IPR038659', NULL, 'Alternative oxidase superfamily', 'AOX_sf', 5, NULL),
(32914, NULL, 'IPR036927', NULL, 'Cytochrome c oxidase-like, subunit I  superfamily', 'Cyt_c_oxase-like_su1_sf', 5, NULL),
(32915, NULL, 'IPR037270', NULL, 'Photosystem II PsbK superfamily', 'PSII_PsbK_sf', 5, NULL),
(32916, NULL, 'IPR037100', NULL, 'Sporulation initiation phosphotransferase B, C-terminal domain superfamily', 'Spo0B_C_sf', 5, NULL),
(32917, NULL, 'IPR036589', NULL, 'Homocysteine-binding domain superfamily', 'HCY_dom_sf', 5, NULL),
(32918, NULL, 'IPR040851', NULL, 'Centromere-binding protein ParB, C-terminal', 'ParB_C', 3, NULL),
(32919, NULL, 'IPR036922', NULL, 'Rieske [2Fe-2S] iron-sulphur domain superfamily', 'Rieske_2Fe-2S_sf', 5, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(32920, NULL, 'IPR037361', NULL, 'COMM domain-containing protein 10', 'COMMD10', 4, NULL),
(32921, NULL, 'IPR039050', NULL, 'GATA zinc finger domain-containing protein 1', 'GATAD1', 4, NULL),
(32922, NULL, 'IPR035886', NULL, 'STAT5b, SH2 domain', 'STAT5b_SH2', 3, NULL),
(32923, NULL, 'IPR036921', NULL, 'PurM-like, N-terminal domain superfamily', 'PurM-like_N_sf', 5, NULL),
(32924, NULL, 'IPR036919', NULL, 'Ribosomal protein L30, ferredoxin-like fold domain superfamily', 'L30_ferredoxin-like_sf', 5, NULL),
(32925, NULL, 'IPR039085', NULL, 'DDB1- and CUL4-associated factor 10', 'DCA10', 4, NULL),
(32926, NULL, 'IPR038154', NULL, 'Arterivirus papain-like cysteine protease beta (PCPbeta) domain superfamily', 'AV_PCPbeta_sf', 5, NULL),
(32927, NULL, 'IPR038774', NULL, 'Centrosomal protein CEP162-like', 'CEP162-like', 4, NULL),
(32928, NULL, 'IPR037540', NULL, 'DNA-binding protein, Adenovirus', 'ADV_DNB2', 4, NULL),
(32929, NULL, 'IPR033672', NULL, '(4S)-4-hydroxy-5-phosphonooxypentane-2,3-dione isomerase', 'LsrG', 4, NULL),
(32930, NULL, 'IPR037464', NULL, 'Threonine aspartase 1', 'Taspase1', 4, NULL),
(32931, NULL, 'IPR035788', NULL, 'Rho guanine nucleotide exchange factor 6, SH3 domain', 'AlphaPIX_SH3', 3, NULL),
(32932, NULL, 'IPR038457', NULL, '3-mercaptopyruvate sulfurtransferase, C-terminal domain superfamily', 'SulfurTase_C_sf', 5, NULL),
(32933, NULL, 'IPR040456', NULL, 'Ribonuclease H2 subunit B', 'RNase_H2_suB', 4, NULL),
(32934, NULL, 'IPR039294', NULL, 'Probable RNA-binding protein EIF1AD', 'EIF1AD', 4, NULL),
(32935, NULL, 'IPR037795', NULL, 'E3 ubiquitin-protein ligase HECW, C2 domain', 'C2_HECW', 3, NULL),
(32936, NULL, 'IPR039113', NULL, 'Autophagy-related protein 29', 'ATG29', 4, NULL),
(32937, NULL, 'IPR036213', NULL, 'Calpain large subunit, domain III superfamily', 'Calpain_III_sf', 5, NULL),
(32938, NULL, 'IPR040857', NULL, 'VioE domain', 'VioE_dom', 3, NULL),
(32939, NULL, 'IPR033407', NULL, 'Domain of unknown function DUF5114', 'DUF5114', 3, NULL),
(32940, NULL, 'IPR035317', NULL, 'Protein of unknown function DUF5375', 'DUF5375', 4, NULL),
(32941, NULL, 'IPR039243', NULL, 'Leucine-rich repeat-containing protein 25', 'LRRC25', 4, NULL),
(32942, NULL, 'IPR038813', NULL, 'Fertilization-influencing membrane protein', 'FIMP', 4, NULL),
(32943, NULL, 'IPR037934', NULL, 'RIP1, Death domain', 'RIP1_Death', 3, NULL),
(32944, NULL, 'IPR036211', NULL, 'eIF4G, eIF4e-binding domain superfamily', 'eIF4G_eIF4E-bd_sf', 5, NULL),
(32945, NULL, 'IPR033205', NULL, 'COP9 signalosome, subunit CSN8', 'COP9_CSN8', 4, NULL),
(32946, NULL, 'IPR039292', NULL, 'Protein SICKLE', 'SICKLE', 4, NULL),
(32947, NULL, 'IPR038782', NULL, 'Uncharacterized protein C3orf22', 'C3orf22', 4, NULL),
(32948, NULL, 'IPR037493', NULL, 'Exodeoxyribonuclease III-like', 'ExoIII-like', 4, NULL),
(32949, NULL, 'IPR037626', NULL, 'Nucleoporin Nup37', 'NUP37', 4, NULL),
(32950, NULL, 'IPR038488', NULL, 'Integrase, DNA-binding domain superfamily', 'Integrase_DNA-bd_sf', 5, NULL),
(32951, NULL, 'IPR038489', NULL, 'Suppressor of fused, C-terminal domain superfamily', 'SUFU_C_sf', 5, NULL),
(32952, NULL, 'IPR039223', NULL, 'Protein AATF/Bfr2', 'AATF/Bfr2', 4, NULL),
(32953, NULL, 'IPR040850', NULL, 'Knl1, C-terminal RWD domain', 'Knl1_RWD_C', 3, NULL),
(32954, NULL, 'IPR038334', NULL, 'NleF superfamily', 'NleF_sf', 5, NULL),
(32955, NULL, 'IPR035800', NULL, 'Sla1, first SH3 domain', 'Sla1_SH3_1', 3, NULL),
(32956, NULL, 'IPR035879', NULL, 'VAV1, SH2 domain', 'VAV1_SH2', 3, NULL),
(32957, NULL, 'IPR037725', NULL, 'Ferlin, sixth C2 domain', 'C2F_Ferlin', 3, NULL),
(32958, NULL, 'IPR040849', NULL, 'MyBP-C, tri-helix bundle domain', 'MyBP-C_THB', 3, NULL),
(32959, NULL, 'IPR036053', NULL, 'PABC (PABP) domain', 'PABP-dom', 5, NULL),
(32960, NULL, 'IPR038370', NULL, 'ArcTGT, C1 domain superfamily', 'ArcTGT_C1_sf', 5, NULL),
(32961, NULL, 'IPR038369', NULL, 'Stage V sporulation AD superfamily', 'SpoVAD_sf', 5, NULL),
(32962, NULL, 'IPR036170', NULL, 'Immunity protein YezG-like superfamily', 'YezG-like_sf', 5, NULL),
(32963, NULL, 'IPR038152', NULL, 'Carbamoyltransferase, C-terminal domain superfamily', 'Carbam_trans_C_sf', 5, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(32964, NULL, 'IPR039118', NULL, 'Menaquinone reductase, multiheme cytochrome c subunit', 'QrcA', 4, NULL),
(32965, NULL, 'IPR039151', NULL, 'Protein inturned', 'INTU', 4, NULL),
(32966, NULL, 'IPR039269', NULL, 'Ankyrin repeat and fibronectin type-III domain-containing protein 1', 'ANKFN1', 4, NULL),
(32967, NULL, 'IPR040255', NULL, 'Non-specific endonuclease', 'Non-specific_endonuclease', 4, NULL),
(32968, NULL, 'IPR045360', NULL, 'Domain of unknown function DUF5904', 'DUF5904', 3, NULL),
(32969, NULL, 'IPR036931', NULL, 'Polyomavirus capsid protein VP1 superfamily', 'Polyomavir_VP1_sf', 5, NULL),
(32970, NULL, 'IPR033411', NULL, 'Ribonuclease, PIN domain', 'Ribonuclease_PIN', 3, NULL),
(32971, NULL, 'IPR036605', NULL, 'Mago nashi superfamily', 'Mago_nashi_sf', 5, NULL),
(32972, NULL, 'IPR033732', NULL, 'ATP synthase, F1 complex, alpha subunit nucleotide-binding domain', 'ATP_synth_F1_a', 3, NULL),
(32973, NULL, 'IPR036054', NULL, 'BTG-like domain superfamily', 'BTG-like_sf', 5, NULL),
(32974, NULL, 'IPR037266', NULL, 'Photosystem II PsbL superfamily', 'PSII_PsbL_sf', 5, NULL),
(32975, NULL, 'IPR039188', NULL, 'ATPase family AAA domain-containing protein 3', 'ATAD3', 4, NULL),
(32976, NULL, 'IPR039161', NULL, 'Uncharacterized protein C19orf47-like', 'C19orf47-like', 4, NULL),
(32977, NULL, 'IPR035180', NULL, 'Protein of unknown function DUF5464', 'DUF5464', 4, NULL),
(32978, NULL, 'IPR038814', NULL, 'Altered inheritance of mitochondria protein 11', 'AIM11', 4, NULL),
(32979, NULL, 'IPR035679', NULL, 'Magnesium-dependent phosphatase-1, eukaryotic-type', 'MDP-1_euk', 4, NULL),
(32980, NULL, 'IPR036113', NULL, 'Glu-tRNAGln amidotransferase superfamily, subunit C', 'Asp/Glu-ADT_sf_sub_c', 5, NULL),
(32981, NULL, 'IPR035531', NULL, 'GTP binding protein 1-like, GTP-binding domain', 'GTPBP1-like', 3, NULL),
(32982, NULL, 'IPR038998', NULL, 'Highly immunogenic outer capsid protein', 'HOC', 4, NULL),
(32983, NULL, 'IPR036212', NULL, 'Bromelain inhibitor VI superfamily', 'Bromein_sf', 5, NULL),
(32984, NULL, 'IPR039175', NULL, 'Mitochondrial import inner membrane translocase subunit TIM22', 'TIM22', 4, NULL),
(32985, NULL, 'IPR033709', NULL, 'Isoleucyl tRNA synthetase type 2, anticodon-binding domain', 'Anticodon_Ile_ABEc', 3, NULL),
(32986, NULL, 'IPR039081', NULL, 'Thrombospondin-5, coiled coil region', 'TSP-5_cc', 3, NULL),
(32987, NULL, 'IPR038373', NULL, 'Restriction endonuclease, type II, HindIII superfamily', 'Restrct_endonuc_II_HindIII_sf', 5, NULL),
(32988, NULL, 'IPR040859', NULL, 'Midline-1, COS domain', 'Midline-1_COS', 3, NULL),
(32989, NULL, 'IPR036051', NULL, 'KRAB domain superfamily', 'KRAB_dom_sf', 5, NULL),
(32990, NULL, 'IPR037099', NULL, 'Fumarate reductase/succinate dehydrogenase flavoprotein-like, C-terminal domain superfamily', 'Fum_R/Succ_DH_flav-like_C_sf', 5, NULL),
(32991, NULL, 'IPR039246', NULL, 'Flagellar protein FlgA', 'Flagellar_FlgA', 4, NULL),
(32992, NULL, 'IPR039078', NULL, 'Gastric inhibitory polypeptide', 'GIP', 4, NULL),
(32993, NULL, 'IPR038151', NULL, 'Small outer capsid protein superfamily', 'Soc_sf', 5, NULL),
(32994, NULL, 'IPR036591', NULL, 'YggU-like superfamily', 'YggU-like_sf', 5, NULL),
(32995, NULL, 'IPR037550', NULL, 'Sec23, C-terminal', 'Sec23_C', 3, NULL),
(32996, NULL, 'IPR039210', NULL, '2-oxoglutarate and iron-dependent oxygenase domain-containing protein 3', 'OGFOD3', 4, NULL),
(32997, NULL, 'IPR038847', NULL, 'Granulysin-like', 'Granulysin-like', 4, NULL),
(32998, NULL, 'IPR036588', NULL, 'Precorrin-8X methylmutase CobH/CbiC superfamily', 'CobH/CbiC_sf', 5, NULL),
(32999, NULL, 'IPR033181', NULL, 'MICOS subunit Mic26, fungi', 'Mic26_fungi', 4, NULL),
(33000, NULL, 'IPR037813', NULL, 'Transcription initiation factor TFIID subunit 2', 'TAF2', 4, NULL),
(33001, NULL, 'IPR038348', NULL, 'SLED domain superfamily', 'SLED_sf', 5, NULL),
(33002, NULL, 'IPR039357', NULL, '3-oxo-5-alpha-steroid 4-dehydrogenase/very-long-chain enoyl-CoA reductase', 'SRD5A/TECR', 4, NULL),
(33003, NULL, 'IPR036183', NULL, 'YajQ-like superfamily', 'YajQ-like_sf', 5, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(33004, NULL, 'IPR036104', NULL, 'Bifunctional nuclease superfamily', 'BFN_sf', 5, NULL),
(33005, NULL, 'IPR036224', NULL, 'GINS, helical bundle-like domain superfamily', 'GINS_bundle-like_dom_sf', 5, NULL),
(33006, NULL, 'IPR039258', NULL, 'Zinc finger protein 511', 'ZNF511', 4, NULL),
(33007, NULL, 'IPR036796', NULL, 'Ribosomal protein L11/L12, N-terminal domain superfamily', 'Ribosomal_L11/L12_N_sf', 5, NULL),
(33008, NULL, 'IPR038031', NULL, 'Tp47 lipoprotein, middle and C-terminal domain', 'Tp47_mid_C_dom', 5, NULL),
(33009, NULL, 'IPR037252', NULL, 'Mib/herc2 domain superfamily', 'Mib_Herc2_sf', 5, NULL),
(33010, NULL, 'IPR039353', NULL, 'Transcription factor Adf-1', 'TF_Adf1', 4, NULL),
(33011, NULL, 'IPR035560', NULL, 'Nck2, SH3 domain 2', 'Nck2_SH3_2', 3, NULL),
(33012, NULL, 'IPR039678', NULL, 'Beta-catenin-like protein 1', 'CTNNBL1', 4, NULL),
(33013, NULL, 'IPR039373', NULL, 'Glutamate carboxypeptidase 2-like', 'Peptidase_M28B', 4, NULL),
(33014, NULL, 'IPR036736', NULL, 'ACP-like superfamily', 'ACP-like_sf', 5, NULL),
(33015, NULL, 'IPR036733', NULL, 'B transposition protein, C-terminal domain superfamily', 'B_transposit_C_sf', 5, NULL),
(33016, NULL, 'IPR038770', NULL, 'Sodium/solute  symporter  superfamily', 'Na+/solute_symporter_sf', 5, NULL),
(33017, NULL, 'IPR039897', NULL, 'BET1-like protein', 'BET1', 4, NULL),
(33018, NULL, 'IPR035623', NULL, 'SUA-like, OCRE domain', 'SUA-like_OCRE', 3, NULL),
(33019, NULL, 'IPR037537', NULL, '[LysW]-aminoadipate semialdehyde/glutamate semialdehyde transaminase', 'LysJ', 4, NULL),
(33020, NULL, 'IPR036807', NULL, 'PH1570-like superfamily', 'PH1570-like_sf', 5, NULL),
(33021, NULL, 'IPR037850', NULL, 'Retinoblastoma-binding protein 5/Swd1', 'RBBP5/Swd1', 4, NULL),
(33022, NULL, 'IPR036227', NULL, 'Ribosomal L18e/L15P superfamily', 'L18e/L15P_sf', 5, NULL),
(33023, NULL, 'IPR035665', NULL, 'VcfQ, lectin domain', 'VcfQ_lectin', 3, NULL),
(33024, NULL, 'IPR036813', NULL, 'Tachylectin 2 superfamily', 'Tachylectin2_sf', 5, NULL),
(33025, NULL, 'IPR038355', NULL, 'Tumor necrosis factor alpha-induced protein 8-like superfamily', 'TNFAIP8_sf', 5, NULL),
(33026, NULL, 'IPR039289', NULL, 'Mitochondrial intermembrane space import and assembly protein 40', 'CHCHD4', 4, NULL),
(33027, NULL, 'IPR036195', NULL, 'Alpha-L-arabinofuranosidase B, arabinose-binding domain superfamily', 'AbfB_ABD_sf', 5, NULL),
(33028, NULL, 'IPR040879', NULL, 'Spermatogenesis-associated protein 46-like', 'Spt46-like', 4, NULL),
(33029, NULL, 'IPR039397', NULL, 'RagA/B', 'RagA/B', 4, NULL),
(33030, NULL, 'IPR036802', NULL, 'ATP:guanido phosphotransferase, N-terminal domain superfamily', 'ATP-guanido_PTrfase_N_sf', 5, NULL),
(33031, NULL, 'IPR039532', NULL, 'Transcriptional regulator TetR, C-terminal, Firmicutes type', 'TetR_C_Firmicutes', 3, NULL),
(33032, NULL, 'IPR039473', NULL, 'Cell surface hyaluronidase, PANDER-like domain', 'TMEM2_PANDER-like', 3, NULL),
(33033, NULL, 'IPR039517', NULL, 'C6orf106, UBA-like domain', 'C6orf106_UBA-like', 3, NULL),
(33034, NULL, 'IPR039728', NULL, 'Golgi apparatus protein 1', 'GLG1', 4, NULL),
(33035, NULL, 'IPR034817', NULL, 'hnRNP-L, RNA recognition motif 4', 'hnRNPL_RRM4', 3, NULL),
(33036, NULL, 'IPR039784', NULL, 'CUE domain-containing protein 2', 'CUEDC2', 4, NULL),
(33037, NULL, 'IPR033829', NULL, 'Antithrombin-III, serpin domain', 'Antithrombin_3_serpin_domain', 3, NULL),
(33038, NULL, 'IPR040184', NULL, 'Minichromosome maintenance protein 10', 'Mcm10', 4, NULL),
(33039, NULL, 'IPR039428', NULL, 'NADH-ubiquinone oxidoreductase chain 4L/Mnh complex subunit C1-like', 'NUOK/Mnh_C1-like', 4, NULL),
(33040, NULL, 'IPR037547', NULL, 'Protein SAMBA', 'SAMBA', 4, NULL),
(33041, NULL, 'IPR036129', NULL, 'Glycerate kinase superfamily', 'Glycerate_kinase_sf', 5, NULL),
(33042, NULL, 'IPR038001', NULL, 'Alpha-2-macroglobulin RAP, domain 2', 'RAP_D2', 3, NULL),
(33043, NULL, 'IPR039320', NULL, 'RING finger protein 207', 'RNF207', 4, NULL),
(33044, NULL, 'IPR036563', NULL, 'Molybdopterin biosynthesis MoaE subunit superfamily', 'MoaE_sf', 5, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(33045, NULL, 'IPR036366', NULL, 'PGBD superfamily', 'PGBDSf', 5, NULL),
(33046, NULL, 'IPR036185', NULL, 'DNA helicase, DnaB-like, N-terminal domain superfamily', 'DNA_heli_DnaB-like_N_sf', 5, NULL),
(33047, NULL, 'IPR035815', NULL, 'Complement C3-like, NTR domain', 'NTR_complement_C3', 3, NULL),
(33048, NULL, 'IPR040182', NULL, 'Autophagy-related protein 13', 'ATG13', 4, NULL),
(33049, NULL, 'IPR039438', NULL, 'At2g23090-like, zinc-binding domain', 'At2g23090-like_Znf', 3, NULL),
(33050, NULL, 'IPR039365', NULL, 'Transposase IS701-like', 'IS701-like', 4, NULL),
(33051, NULL, 'IPR037538', NULL, 'UTP--glucose-1-phosphate uridylyltransferase, cyanobacteria', 'CugP_cyano', 4, NULL),
(33052, NULL, 'IPR035558', NULL, 'SNX9, SH3 domain', 'SNX9_SH3', 3, NULL),
(33053, NULL, 'IPR035378', NULL, 'Uncharacterized protein YrzK-like', 'YrzK-like', 4, NULL),
(33054, NULL, 'IPR033379', NULL, 'Histidine acid phosphatase active site', 'Acid_Pase_AS', 0, NULL),
(33055, NULL, 'IPR039367', NULL, 'Initiation-specific alpha-1,6-mannosyltransferase Och1-like', 'Och1-like', 4, NULL),
(33056, NULL, 'IPR038353', NULL, 'Decorin-binding superfamily', 'Decorin-db_sf', 5, NULL),
(33057, NULL, 'IPR039435', NULL, 'Diguanylate cyclase DosC, globin sensor domain', 'DosC_GS', 3, NULL),
(33058, NULL, 'IPR037199', NULL, 'Phosphoprotein, C-terminal', 'PP_M1_C', 5, NULL),
(33059, NULL, 'IPR039344', NULL, 'Metallo-beta-lactamase domain-containing protein 1', 'MBLAC1', 4, NULL),
(33060, NULL, 'IPR035593', NULL, 'Pinkbar, SH3', 'Pinkbar_SH3', 3, NULL),
(33061, NULL, 'IPR039370', NULL, 'Transcription factor BTF3', 'BTF3', 4, NULL),
(33062, NULL, 'IPR039672', NULL, 'Lactose permease-like', 'MFS_2', 4, NULL),
(33063, NULL, 'IPR039422', NULL, 'Transcription regulators MarR/SlyA-like', 'MarR/SlyA-like', 4, NULL),
(33064, NULL, 'IPR037428', NULL, 'Bridging integrator 3, BAR domain', 'Bin3_BAR', 3, NULL),
(33065, NULL, 'IPR035583', NULL, 'Tyrosine-protein kinase ITK, SH3 domain', 'ITK_SH3', 3, NULL),
(33066, NULL, 'IPR039519', NULL, 'YokE-like, PH domain', 'YokE-like_PH', 3, NULL),
(33067, NULL, 'IPR037468', NULL, 'ARGOS/ARL/OSR1', 'ARGOS/ARL/OSR1', 4, NULL),
(33068, NULL, 'IPR039475', NULL, 'FAM3C (ILEI) domain', 'ILEI_FAM3C', 3, NULL),
(33069, NULL, 'IPR037206', NULL, 'VPS28, C-terminal domain superfamily', 'VPS28_C_sf', 5, NULL),
(33070, NULL, 'IPR039785', NULL, 'Deubiquitinating enzyme MINDY-3/4', 'MINY3/4', 4, NULL),
(33071, NULL, 'IPR035674', NULL, 'ERdj5, C-terminal thioredoxin domain', 'ERdj5_TRX_C', 3, NULL),
(33072, NULL, 'IPR038349', NULL, 'Surface antigen, GAG-binding domain superfamily', 'GAG_BD_sf', 5, NULL),
(33073, NULL, 'IPR039323', NULL, 'Ankyrin repeat domain-containing protein 60', 'ANKRD60', 4, NULL),
(33074, NULL, 'IPR033544', NULL, 'Nuclear receptor subfamily 0 group B member 1/2', 'NR0B1/2', 4, NULL),
(33075, NULL, 'IPR037587', NULL, 'Ragulator complex protein LAMTOR2-like', 'LAMTOR2-like', 4, NULL),
(33076, NULL, 'IPR035554', NULL, 'Otoraplin, SH3 domain', 'Otoraplin_SH3', 3, NULL),
(33077, NULL, 'IPR035379', NULL, 'Uncharacterized protein YkpC-like', 'YkpC-like', 4, NULL),
(33078, NULL, 'IPR039394', NULL, 'Creatinase, C-terminal', 'Creatinase_C', 3, NULL),
(33079, NULL, 'IPR036137', NULL, 'Focal adhesion kinase, targeting (FAT) domain superfamily', 'Focal_adhe_kin_target_dom_sf', 5, NULL),
(33080, NULL, 'IPR039426', NULL, 'TonB-dependent receptor-like', 'TonB-dep_rcpt-like', 4, NULL),
(33081, NULL, 'IPR039430', NULL, 'Thymidylate kinase-like domain', 'Thymidylate_kin-like_dom', 3, NULL),
(33082, NULL, 'IPR039483', NULL, 'Meiotic expression up-regulated protein 6, PH domain', 'Meu6_PH_dom', 3, NULL),
(33083, NULL, 'IPR039329', NULL, 'Sialate O-acetylesterase', 'SIAE', 4, NULL),
(33084, NULL, 'IPR037469', NULL, 'Putative actin-fragmin kinase', 'Put_AFK', 4, NULL),
(33085, NULL, 'IPR040901', NULL, 'Leukemia inhibitory factor receptor, N-terminal', 'LIFR_N', 3, NULL),
(33086, NULL, 'IPR035555', NULL, 'MIA2, SH3 domain', 'MIA2_SH3', 3, NULL),
(33087, NULL, 'IPR037539', NULL, '4-hydroxythreonine-4-phosphate dehydrogenase, epsilonproteobacteria', 'PdxA_epsilonprot', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(33088, NULL, 'IPR037322', NULL, 'EDEM3, PA domain', 'EDEM3_PA', 3, NULL),
(33089, NULL, 'IPR036793', NULL, 'Aspartate carbamoyltransferase regulatory subunit, N-terminal domain superfamily', 'Asp_carbatrfase_reg_N_sf', 5, NULL),
(33090, NULL, 'IPR036782', NULL, 'NE0471-like, N-terminal', 'NE0471-like_N', 5, NULL),
(33091, NULL, 'IPR036798', NULL, 'EF2947-like superfamily', 'EF2947-like_sf', 5, NULL),
(33092, NULL, 'IPR037193', NULL, 'GDNF receptor alpha', 'GDNF_alpha', 5, NULL),
(33093, NULL, 'IPR036368', NULL, 'Adenovirus DNA-binding, zinc binding domain superfamily', 'ADBP_zn-bd_sf', 5, NULL),
(33094, NULL, 'IPR039529', NULL, 'GPI inositol-deacylase', 'PGAP1/BST1', 4, NULL),
(33095, NULL, 'IPR040883', NULL, 'Fatty acid synthase, meander beta sheet domain', 'FAS_meander', 3, NULL),
(33096, NULL, 'IPR034816', NULL, 'hnRNP-L, RNA recognition motif 3', 'hnRNP-L_RRM3', 3, NULL),
(33097, NULL, 'IPR036541', NULL, 'Phospholipase A1 superfamily', 'PLipase_A1_sf', 5, NULL),
(33098, NULL, 'IPR037321', NULL, 'KIN17-like protein', 'KIN17-like', 4, NULL),
(33099, NULL, 'IPR033102', NULL, 'Negative elongation factor E', 'NELFE', 4, NULL),
(33100, NULL, 'IPR036135', NULL, 'MoeA, N-terminal and linker domain superfamily', 'MoeA_linker/N_sf', 5, NULL),
(33101, NULL, 'IPR037922', NULL, 'E3 ubiquitin-protein ligase MSL2', 'MSL2', 4, NULL),
(33102, NULL, 'IPR036549', NULL, 'Cytochrome c oxidase, subunit VIb superfamily', 'Cyt_c_oxidase_su6B_sf', 5, NULL),
(33103, NULL, 'IPR036120', NULL, 'Staphylokinase/Streptokinase superfamily', 'SAK/SK_sf', 5, NULL),
(33104, NULL, 'IPR036788', NULL, 'Translation initiation factor 3 (IF-3), C-terminal domain superfamily', 'T_IF-3_C_sf', 5, NULL),
(33105, NULL, 'IPR036779', NULL, 'LysM domain superfamily', 'LysM_dom_sf', 5, NULL),
(33106, NULL, 'IPR036545', NULL, 'Cytochrome c oxidase, subunit Va/VI superfamily', 'Cyt_c_oxidase_su5A/6_sf', 5, NULL),
(33107, NULL, 'IPR036809', NULL, 'AF1782-like superfamily', 'AF1782-like_sf', 5, NULL),
(33108, NULL, 'IPR036551', NULL, 'Flavin prenyltransferase-like', 'Flavin_trans-like', 5, NULL),
(33109, NULL, 'IPR038639', NULL, 'AlgX, C-terminal domain superfamily', 'AlgX_C_sf', 5, NULL),
(33110, NULL, 'IPR039547', NULL, '60S ribosomal protein L19', 'RPL19', 4, NULL),
(33111, NULL, 'IPR034833', NULL, 'PGC-1alpha, RNA recognition motif', 'PPARGC1A_RRM', 3, NULL),
(33112, NULL, 'IPR039431', NULL, 'Vta1/callose synthase, N-terminal', 'Vta1/CALS_N', 3, NULL),
(33113, NULL, 'IPR039558', NULL, 'Prolyl 3,4-dihydroxylase TPA1/OFD1, N-terminal domain', 'TPA1/OFD1_N', 3, NULL),
(33114, NULL, 'IPR037204', NULL, 'Non-structural protein NSP7 superfamily, coronavirus', 'NSP7_sf_CoV', 5, NULL),
(33115, NULL, 'IPR033916', NULL, 'Npc2 like, ML domain', 'ML_Npc2-like', 3, NULL),
(33116, NULL, 'IPR033585', NULL, 'Coiled-coil domain-containing protein 153', 'CCDC153', 4, NULL),
(33117, NULL, 'IPR036534', NULL, 'GAR domain superfamily', 'GAR_dom_sf', 5, NULL),
(33118, NULL, 'IPR038357', NULL, 'KEN domain superfamily', 'KEN_sf', 5, NULL),
(33119, NULL, 'IPR040911', NULL, 'Exostosin, GT47 domain', 'Exostosin_GT47', 3, NULL),
(33120, NULL, 'IPR039398', NULL, 'Deltex family', 'Deltex_fam', 4, NULL),
(33121, NULL, 'IPR035622', NULL, 'ZOP1, OCRE domain', 'ZOP1_OCRE', 3, NULL),
(33122, NULL, 'IPR039451', NULL, 'Family of unknown function DUF5419', 'DUF5419', 4, NULL),
(33123, NULL, 'IPR036770', NULL, 'Ankyrin repeat-containing domain superfamily', 'Ankyrin_rpt-contain_sf', 5, NULL),
(33124, NULL, 'IPR039538', NULL, 'BetI-type transcriptional repressor, C-terminal', 'BetI_C', 3, NULL),
(33125, NULL, 'IPR039771', NULL, 'Exosome complex component Csl4', 'Csl4', 4, NULL),
(33126, NULL, 'IPR039584', NULL, 'Heat shock factor 2-binding protein', 'HSF2BP', 4, NULL),
(33127, NULL, 'IPR038492', NULL, 'GBBH-like, N-terminal domain superfamily', 'GBBH-like_N_sf', 5, NULL),
(33128, NULL, 'IPR039761', NULL, 'Ribosome biogenesis protein Bms1/Tsr1', 'Bms1/Tsr1', 4, NULL),
(33129, NULL, 'IPR038860', NULL, 'Uncharacterized protein ycf72', 'YCF72', 4, NULL),
(33130, NULL, 'IPR039429', NULL, 'Serine hydroxymethyltransferase-like domain', 'SHMT-like_dom', 3, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(33131, NULL, 'IPR037486', NULL, 'G-protein-coupled receptor GPR139', 'GPR139', 4, NULL),
(33132, NULL, 'IPR040877', NULL, 'Carbohydrate binding module 65 domain 1', 'CBM65_1', 3, NULL),
(33133, NULL, 'IPR039228', NULL, 'SUZ domain-containing protein 1', 'SZRD1', 4, NULL),
(33134, NULL, 'IPR036785', NULL, 'YkyA-like superfamily', 'YkyA-like_sf', 5, NULL),
(33135, NULL, 'IPR039756', NULL, 'Type II phosphatidylinositol 4-kinase Lsb6/PI4K2', 'Lsb6/PI4K2', 4, NULL),
(33136, NULL, 'IPR036786', NULL, 'Ribosome maturation protein SBDS, N-terminal domain superfamily', 'Ribosome_mat_SBDS_N_sf', 5, NULL),
(33137, NULL, 'IPR037319', NULL, 'Rrp40, S1 domain', 'Rrp40_S1', 3, NULL),
(33138, NULL, 'IPR036412', NULL, 'HAD-like superfamily', 'HAD-like_sf', 5, NULL),
(33139, NULL, 'IPR036555', NULL, 'NusA, N-terminal domain superfamily', 'NusA_N_sf', 5, NULL),
(33140, NULL, 'IPR038381', NULL, 'DNA replication regulator HobA superfamily', 'HobA_sf', 5, NULL),
(33141, NULL, 'IPR039471', NULL, 'Uncharacterized protein CXorf65-like', 'CXorf65-like', 4, NULL),
(33142, NULL, 'IPR039470', NULL, 'Nucleoside 2-deoxyribosyltransferase-like', 'Nuc_deoxyri_tr2', 4, NULL),
(33143, NULL, 'IPR040140', NULL, 'Protein naked cuticle-like', 'Nkd-like', 4, NULL),
(33144, NULL, 'IPR036218', NULL, 'HIV integrase-binding domain superfamily', 'HIVI-bd_sf', 5, NULL),
(33145, NULL, 'IPR039051', NULL, 'SE-cephalotoxin-like', 'SE-CTX-like', 4, NULL),
(33146, NULL, 'IPR037885', NULL, 'Heat shock protein beta-7, ACD domain', 'ACD_HspB7', 3, NULL),
(33147, NULL, 'IPR039421', NULL, 'Type 1 protein exporter', 'Type_1_exporter', 4, NULL),
(33148, NULL, 'IPR036795', NULL, 'Inosine monophosphate cyclohydrolase-like superfamily', 'IMP_cyclohydrolase-like_sf', 5, NULL),
(33149, NULL, 'IPR034834', NULL, 'PGC-1-related coactivator, RNA recognition motif', 'PRC_RRM', 3, NULL),
(33150, NULL, 'IPR036136', NULL, 'Nitrite/Sulfite reductase ferredoxin-like domain superfamily', 'Nit/Sulf_reduc_fer-like_dom_sf', 5, NULL),
(33151, NULL, 'IPR039328', NULL, 'WD repeat-containing protein 89', 'WDR89', 4, NULL),
(33152, NULL, 'IPR036131', NULL, 'Tombusvirus P19 superfamily', 'VP19_sf', 5, NULL),
(33153, NULL, 'IPR036791', NULL, 'Ribosomal protein L9, C-terminal domain superfamily', 'Ribosomal_L9_C_sf', 5, NULL),
(33154, NULL, 'IPR037318', NULL, 'Hex1, S1 domain', 'Hex1_S1', 3, NULL),
(33155, NULL, 'IPR036181', NULL, 'MIT domain superfamily', 'MIT_dom_sf', 5, NULL),
(33156, NULL, 'IPR037218', NULL, 'PTPA superfamily', 'PTPA_sf', 5, NULL),
(33157, NULL, 'IPR039545', NULL, 'Post-GPI attachment to proteins factor 2', 'PGAP2', 4, NULL),
(33158, NULL, 'IPR036367', NULL, 'Adenovirus DNA-binding, C-terminal domain superfamily', 'Ad_DBP_C_sf', 5, NULL),
(33159, NULL, 'IPR035664', NULL, 'VIP36, lectin domain', 'VIP36_lectin', 3, NULL),
(33160, NULL, 'IPR039424', NULL, 'Solute-binding protein family 5', 'SBP_5', 4, NULL),
(33161, NULL, 'IPR039336', NULL, 'Midnolin', 'Midnolin', 4, NULL),
(33162, NULL, 'IPR039026', NULL, 'Protein Kinase B, pleckstrin homology domain', 'PH_PKB', 3, NULL),
(33163, NULL, 'IPR036789', NULL, 'Ribosomal protein L6, alpha-beta domain superfamily', 'Ribosomal_L6_a/b-dom_sf', 5, NULL),
(33164, NULL, 'IPR037207', NULL, 'NADH-ubiquinone oxidoreductase 51kDa subunit, iron-sulphur binding domain superfamily', 'Nuop51_4Fe4S-bd_sf', 5, NULL),
(33165, NULL, 'IPR038028', NULL, 'Nucleosome-remodeling factor subunit BPTF', 'BPTF', 4, NULL),
(33166, NULL, 'IPR035833', NULL, 'SGSM3, SH3 domain', 'SGSM3_SH3', 3, NULL),
(33167, NULL, 'IPR040884', NULL, 'SMODS and SLOG-associating 2TM effector domain 1', 'SLATT_1', 3, NULL),
(33168, NULL, 'IPR035573', NULL, 'Friend leukemia integration 1 transcription factor, pointed domain', 'SAM_PNT-FLI-1', 3, NULL),
(33169, NULL, 'IPR035625', NULL, 'Tfc3, extended winged-helix domain', 'Tfc3_eWH', 3, NULL),
(33170, NULL, 'IPR040902', NULL, 'REase, AHJR-like', 'AHJR-like', 3, NULL),
(33171, NULL, 'IPR033537', NULL, 'Stimulated by retinoic acid gene 8 protein', 'Stra8', 4, NULL),
(33172, NULL, 'IPR040866', NULL, 'Type III secretion system ExsE', 'T3SS_ExsE', 3, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(33173, NULL, 'IPR039767', NULL, 'RalA-binding protein 1', 'RALBP1', 4, NULL),
(33174, NULL, 'IPR039449', NULL, 'Type VI secretion system TssO', 'TssO', 4, NULL),
(33175, NULL, 'IPR035518', NULL, 'Dolichyl-phosphate beta-glucosyltransferase', 'DPG_synthase', 3, NULL),
(33176, NULL, 'IPR036528', NULL, 'Cloacin immunity protein superfamily', 'Cloacn_immnty_sf', 5, NULL),
(33177, NULL, 'IPR036268', NULL, 'ZapD domain superfamily', 'ZapD_sf', 5, NULL),
(33178, NULL, 'IPR039542', NULL, 'Endoplasmic reticulum vesicle transporter, N-terminal', 'Erv_N', 3, NULL),
(33179, NULL, 'IPR039518', NULL, 'WhiA, LAGLIDADG-like domain', 'WhiA_LAGLIDADG_dom', 3, NULL),
(33180, NULL, 'IPR033480', NULL, 'Single Cache domain 2', 'sCache_2', 3, NULL),
(33181, NULL, 'IPR039375', NULL, 'Nodulation protein N-like', 'NodN-like', 4, NULL),
(33182, NULL, 'IPR038032', NULL, 'Capsid assembly scaffolding protein Gp7', 'Gp7', 5, NULL),
(33183, NULL, 'IPR039461', NULL, 'Peptidase family M49', 'Peptidase_M49', 4, NULL),
(33184, NULL, 'IPR039331', NULL, 'Purple acid phosphatase-like', 'PPA-like', 4, NULL),
(33185, NULL, 'IPR039439', NULL, 'SH3b1 domain', 'SH3b1_dom', 3, NULL),
(33186, NULL, 'IPR035559', NULL, 'Nck2, SH3 domain 1', 'Nck2_SH3_1', 3, NULL),
(33187, NULL, 'IPR039541', NULL, 'Metallophosphoesterase 1, metallophosphatase domain', 'MPP_MPPE1', 3, NULL),
(33188, NULL, 'IPR040880', NULL, 'Domain of unknown function DUF5604', 'DUF5604', 3, NULL),
(33189, NULL, 'IPR035383', NULL, 'Methylamine utilization protein MauJ', 'MauJ', 4, NULL),
(33190, NULL, 'IPR039172', NULL, 'Protein parting dancers', 'PTD', 4, NULL),
(33191, NULL, 'IPR039557', NULL, 'AHAS, ACT domain', 'AHAS_ACT', 3, NULL),
(33192, NULL, 'IPR039776', NULL, 'Sister chromatid cohesion protein Pds5', 'Pds5', 4, NULL),
(33193, NULL, 'IPR039559', NULL, 'Altered inheritance of mitochondria protein 6, PI-PLC-like catalytic domain', 'AIM6_PI-PLC-like_dom', 3, NULL),
(33194, NULL, 'IPR039262', NULL, 'DTW domain-containing protein DTWD2/YfiP', 'DTWD2/YfiP', 4, NULL),
(33195, NULL, 'IPR038130', NULL, 'Pleiotrophin/Midkine, C-terminal domain superfamily', 'PTN/MK_C_dom_sf', 5, NULL),
(33196, NULL, 'IPR038350', NULL, 'Orai superfamily', 'Orai_sf', 5, NULL),
(33197, NULL, 'IPR037919', NULL, 'UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase 110kDa subunit', 'OGT', 4, NULL),
(33198, NULL, 'IPR036182', NULL, 'Copper chaperone PCuAC superfamily', 'PCuAC_sf', 5, NULL),
(33199, NULL, 'IPR038356', NULL, 'Tma16 superfamily', 'Tma16_sf', 5, NULL),
(33200, NULL, 'IPR039535', NULL, 'Arylsulfotransferase-like', 'ASST-like', 4, NULL),
(33201, NULL, 'IPR037546', NULL, 'Transcription factor SAC51-like', 'SAC51-like', 4, NULL),
(33202, NULL, 'IPR038003', NULL, 'Alpha-2-macroglobulin receptor-associated protein', 'A2-macroglobuin_RAP', 4, NULL),
(33203, NULL, 'IPR039768', NULL, 'Ribosomal export protein Nmd3', 'Nmd3', 4, NULL),
(33204, NULL, 'IPR039585', NULL, 'SERTA domain-containing protein 3', 'SERTAD3', 4, NULL),
(33205, NULL, 'IPR036413', NULL, 'YaeB-like superfamily', 'YaeB-like_sf', 5, NULL),
(33206, NULL, 'IPR038358', NULL, 'VPS28, N-terminal domain superfamily', 'VPS28_N_sf', 5, NULL),
(33207, NULL, 'IPR038637', NULL, 'NPCBM domain superfamily', 'NPCBM_sf', 5, NULL),
(33208, NULL, 'IPR039670', NULL, 'Sterol transport protein NPC2-like', 'NPC2-like', 4, NULL),
(33209, NULL, 'IPR034844', NULL, 'IGF2BP3, RNA recognition motif 2', 'IGF2BP3_RRM2', 3, NULL),
(33210, NULL, 'IPR039779', NULL, 'RFX-like DNA-binding protein', 'RFX-like', 4, NULL),
(33211, NULL, 'IPR039352', NULL, 'Protein BEAN1', 'BEAN1', 4, NULL),
(33212, NULL, 'IPR037442', NULL, 'Melanophilin, FYVE-related domain', 'Melanophilin_FYVE-rel_dom', 3, NULL),
(33213, NULL, 'IPR034868', NULL, 'Partitioning defective protein 6, PB1 domain', 'PB1_Par6', 3, NULL),
(33214, NULL, 'IPR039291', NULL, 'Late embryogenesis abundant protein At5g17165-like', 'At5g17165-like', 4, NULL),
(33215, NULL, 'IPR037175', NULL, 'Kynurenine formamidase superfamily', 'KFase_sf', 5, NULL),
(33216, NULL, 'IPR036806', NULL, 'YozE SAM-like superfamily', 'YozE_SAM-like_sf', 5, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(33217, NULL, 'IPR034078', NULL, 'Transcription factor NFX1 family', 'NFX1_fam', 4, NULL),
(33218, NULL, 'IPR036738', NULL, 'FKBP12-rapamycin binding domain superfamily', 'FRB_sf', 5, NULL),
(33219, NULL, 'IPR039675', NULL, 'Cartilage intermediate layer protein 1/2', 'CILP1/CILP2', 4, NULL),
(33220, NULL, 'IPR038360', NULL, 'DUF4844 superfamily', 'DUF4844_sf', 5, NULL),
(33221, NULL, 'IPR037448', NULL, 'Zwei Ig domain protein zig-8', 'Zig-8', 4, NULL),
(33222, NULL, 'IPR039356', NULL, '5''-deoxynucleotidase YfbR/HDDC2', 'YfbR/HDDC2', 4, NULL),
(33223, NULL, 'IPR035576', NULL, 'Type VI secretion system TssC', 'T6SS_TssC', 4, NULL),
(33224, NULL, 'IPR037430', NULL, 'Sorting nexin-4, BAR domain', 'SNX4_BAR', 3, NULL),
(33225, NULL, 'IPR036128', NULL, 'Plus3-like superfamily', 'Plus3-like_sf', 5, NULL),
(33226, NULL, 'IPR033994', NULL, 'Tumor necrosis factor receptor 1A, death domain', 'TNFRSF1A_death', 3, NULL),
(33227, NULL, 'IPR036529', NULL, 'Coactivator CBP, KIX domain superfamily', 'KIX_dom_sf', 5, NULL),
(33228, NULL, 'IPR036127', NULL, 'CcmE-like superfamily', 'CcmE-like_sf', 5, NULL),
(33229, NULL, 'IPR039766', NULL, 'Vacuolar protein sorting-associated protein 53', 'Vps53', 4, NULL),
(33230, NULL, 'IPR036132', NULL, 'Vacuolar ATP synthase subunit C superfamily', 'Vac_ATP_synth_c_sf', 5, NULL),
(33231, NULL, 'IPR033917', NULL, 'ML domain, phosphatidylinositol/phosphatidylglycerol transfer protein', 'ML_PG-PI_TP', 3, NULL),
(33232, NULL, 'IPR037176', NULL, 'Osmotin/thaumatin-like superfamily', 'Osmotin/thaumatin-like_sf', 5, NULL),
(33233, NULL, 'IPR039775', NULL, 'Homeodomain containing protein PHTF1/2', 'PHTF1/2', 4, NULL),
(33234, NULL, 'IPR034825', NULL, 'CID8-like protein, RNA recognition motif 2', 'CID8-like_RRM2', 3, NULL),
(33235, NULL, 'IPR037194', NULL, 'NS2, N-terminal', 'NS2_N', 5, NULL),
(33236, NULL, 'IPR039481', NULL, 'Exocyst complex component EXOC2/Sec5, N-terminal domain', 'EXOC2/Sec5_N_dom', 3, NULL),
(33237, NULL, 'IPR039474', NULL, 'Protein O-linked-mannose beta-1,2-N-acetylglucosaminyltransferase 1, PANDER-like domain', 'POMGNT1_PANDER-like', 3, NULL),
(33238, NULL, 'IPR037514', NULL, 'Ribose-phosphate pyrophosphokinase, archaea', 'Rib-P_diPkinase_arc', 4, NULL),
(33239, NULL, 'IPR036119', NULL, 'Nitric oxide synthase, N-terminal domain superfamily', 'NOS_N_sf', 5, NULL),
(33240, NULL, 'IPR036730', NULL, 'Phage P22 tailspike-like, N-terminal domain superfamily', 'P22_tailspike_N_sf', 5, NULL),
(33241, NULL, 'IPR039055', NULL, 'MCU family', 'MCU_fam', 4, NULL),
(33242, NULL, 'IPR036270', NULL, 'UPF0358 superfamily', 'UPF0358_sf', 5, NULL),
(33243, NULL, 'IPR036179', NULL, 'Immunoglobulin-like domain superfamily', 'Ig-like_dom_sf', 5, NULL),
(33244, NULL, 'IPR039552', NULL, 'Transposase IS66, C-terminal', 'IS66_C', 3, NULL),
(33245, NULL, 'IPR037195', NULL, 'Nucleocapsid protein, N-terminal', 'Nucleocapsid_N', 5, NULL),
(33246, NULL, 'IPR036272', NULL, 'Methuselah, N-terminal domain superfamily', 'Methuselah_N_sf', 5, NULL),
(33247, NULL, 'IPR034830', NULL, 'TIA-1, RNA recognition motif 2', 'TIA1_RRM2', 3, NULL),
(33248, NULL, 'IPR037521', NULL, 'Folliculin/SMCR8, tripartite DENN domain', 'FLCN/SMCR8_DENN', 3, NULL),
(33249, NULL, 'IPR039235', NULL, 'Tubulin polyglutamylase complex subunit 1', 'TPGS1', 4, NULL),
(33250, NULL, 'IPR036538', NULL, 'Alpha trans-inducing (Alpha-TIF) superfamily', 'Alpha_TIF_sf', 5, NULL),
(33251, NULL, 'IPR036537', NULL, 'Adaptor protein Cbl, N-terminal domain superfamily', 'Adaptor_Cbl_N_dom_sf', 5, NULL),
(33252, NULL, 'IPR036121', NULL, 'ATPase, F1/V1/A1 complex, alpha/beta subunit, N-terminal domain superfamily', 'ATPase_F1/V1/A1_a/bsu_N_sf', 5, NULL),
(33253, NULL, 'IPR037202', NULL, 'ESCRT assembly domain', 'ESCRT_assembly_dom', 5, NULL),
(33254, NULL, 'IPR036548', NULL, 'Cytochrome c oxidase, subunit 8 superfamily', 'Cyt_c_oxidase_su8_sf', 5, NULL),
(33255, NULL, 'IPR039317', NULL, 'Protein time for coffee', 'TIC', 4, NULL),
(33256, NULL, 'IPR033830', NULL, 'Serpin H1, serpin domain', 'Serpin_H1_serpin_dom', 3, NULL),
(33257, NULL, 'IPR037933', NULL, 'Protein max-like', 'MAX-like', 4, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(33258, NULL, 'IPR036527', NULL, 'SCP2 sterol-binding domain superfamily', 'SCP2_sterol-bd_dom_sf', 5, NULL),
(33259, NULL, 'IPR039392', NULL, 'Gingipain, N-terminal', 'Gingipain_N', 3, NULL),
(33260, NULL, 'IPR035851', NULL, 'Tyrosine-protein kinase HCK, SH2 domain', 'HCK_SH2', 3, NULL),
(33261, NULL, 'IPR040882', NULL, 'Cas12a, nuclease domain', 'Cas12a_NUC', 3, NULL),
(33262, NULL, 'IPR033913', NULL, 'MTH1175 domain', 'MTH1175_dom', 3, NULL),
(33263, NULL, 'IPR037208', NULL, 'Aspartyl-phosphate phosphatase Spo0E-like superfamily', 'Spo0E-like_sf', 5, NULL),
(33264, NULL, 'IPR039540', NULL, 'UBL3-like, ubiquitin domain', 'UBL3-like_ubiquitin_dom', 3, NULL),
(33265, NULL, 'IPR040899', NULL, 'Fatty acid synthase subunit alpha, acyl carrier domain', 'Fas_alpha_ACP', 3, NULL),
(33266, NULL, 'IPR037219', NULL, 'Peptidase M41-like', 'Peptidase_M41-like', 5, NULL),
(33267, NULL, 'IPR036799', NULL, 'Diphtheria toxin, receptor-binding domain superfamily', 'Diphtheria_tox_rcpt-bd_dom_sf', 5, NULL),
(33268, NULL, 'IPR039374', NULL, 'Siderophore-interacting protein', 'SIP_fam', 4, NULL),
(33269, NULL, 'IPR037251', NULL, 'WSSV envelope protein Vp28 superfamily', 'WSSV_Vp28_sf', 5, NULL),
(33270, NULL, 'IPR039059', NULL, 'Major vault protein', 'MVP', 4, NULL),
(33271, NULL, 'IPR039448', NULL, 'Right handed beta helix domain', 'Beta_helix', 3, NULL),
(33272, NULL, 'IPR039482', NULL, 'Neuronal tyrosine-phosphorylated phosphoinositide-3-kinase adapter, N-terminal', 'NYAP_N', 3, NULL),
(33273, NULL, 'IPR039361', NULL, 'Cyclin', 'Cyclin', 4, NULL),
(33274, NULL, 'IPR035977', NULL, 'Ribosomal protein L36 superfamily', 'Ribosomal_L36_sp', 5, NULL),
(33275, NULL, 'IPR037209', NULL, 'RNA-binding protein B2 superfamily', 'RNA-bd_B2_sf', 5, NULL),
(33276, NULL, 'IPR036769', NULL, 'Ribosomal protein L11, C-terminal domain superfamily', 'Ribosomal_L11_C_sf', 5, NULL),
(33277, NULL, 'IPR036784', NULL, 'Alpha-ketoacid/pyruvate dehydrogenase kinase, N-terminal domain superfamily', 'AK/P_DHK_N_sf', 5, NULL),
(33278, NULL, 'IPR037728', NULL, 'Uncharacterized protein C21orf140-like', 'C21orf140-like', 4, NULL),
(33279, NULL, 'IPR037767', NULL, 'Mug190-like, C2A domain', 'C2A_Mug190-like', 3, NULL),
(33280, NULL, 'IPR036771', NULL, 'F0F1 ATP synthase delta/epsilon subunit, N-terminal', 'ATPsynth_dsu/esu_N', 5, NULL),
(33281, NULL, 'IPR039339', NULL, 'Inactive serine/threonine-protein kinase TEX14', 'Tex14', 4, NULL),
(33282, NULL, 'IPR037731', NULL, 'Meiosis-specific protein ASY3-like', 'ASY3-like', 4, NULL),
(33283, NULL, 'IPR037401', NULL, 'SnoaL-like domain', 'SnoaL-like', 3, NULL),
(33284, NULL, 'IPR039360', NULL, 'Ras GTPase-activating protein', 'Ras_GTPase', 4, NULL),
(33285, NULL, 'IPR037323', NULL, 'PRADC1-like protein, PA domain', 'PRADC1-like_PA', 3, NULL),
(33286, NULL, 'IPR037765', NULL, 'Tricalbin, C2B domain', 'C2B_Tricalbin', 3, NULL),
(33287, NULL, 'IPR036550', NULL, 'Peridinin-chlorophyll A binding superfamily', 'Peridinin-chlorophyll-bd_sf', 5, NULL),
(33288, NULL, 'IPR034827', NULL, 'TIA-1, RNA recognition motif 1', 'TIA-1_RRM1', 3, NULL),
(33289, NULL, 'IPR037203', NULL, 'Type III secretion, needle-protein-like superfamily', 'T3SS_needle-like_sf', 5, NULL),
(33290, NULL, 'IPR040885', NULL, 'Synaptotagmin-like, mitochondrial and lipid-binding domain', 'SMP_C2CD2L', 3, NULL),
(33291, NULL, 'IPR038655', NULL, 'Ribosomal protein L27e superfamily', 'L27e_sf', 5, NULL),
(33292, NULL, 'IPR040876', NULL, 'Lantibiotic immunity protein Spa1, C-terminal', 'Spa1_C', 3, NULL),
(33293, NULL, 'IPR037231', NULL, 'NAP-like superfamily', 'NAP-like_sf', 5, NULL),
(33294, NULL, 'IPR039925', NULL, 'RNF37, RING-Ubox', 'RNF37_RING-Ubox', 3, NULL),
(33295, NULL, 'IPR036812', NULL, 'NADP-dependent oxidoreductase domain superfamily', 'NADP_OxRdtase_dom_sf', 5, NULL),
(33296, NULL, 'IPR039433', NULL, 'Mff-like domain', 'Mff-like_dom', 3, NULL),
(33297, NULL, 'IPR039231', NULL, 'Tubulin polyglutamylase complex subunit 2', 'TPGS2', 4, NULL),
(33298, NULL, 'IPR040878', NULL, 'C17orf99, Ig domain', 'Ig_C17orf99', 3, NULL),
(33299, NULL, 'IPR039349', NULL, 'Protein PLASTID REDOX INSENSITIVE 2', 'PRIN2', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(33300, NULL, 'IPR039237', NULL, 'Lymphocyte antigen 6 complex locus protein G6c', 'LY6G6C', 4, NULL),
(33301, NULL, 'IPR039812', NULL, 'Vesicle-fusing ATPase', 'Vesicle-fus_ATPase', 4, NULL),
(33302, NULL, 'IPR039355', NULL, 'Transcription factor GATA', 'Transcription_factor_GATA', 4, NULL),
(33303, NULL, 'IPR039238', NULL, 'Mitochondrial import inner membrane translocase subunit Tim8/13', 'Tim8/13', 4, NULL),
(33304, NULL, 'IPR033536', NULL, 'Spermatogenesis-associated protein 22', 'Spata22', 4, NULL),
(33305, NULL, 'IPR036810', NULL, 'SMc04008-like superfamily', 'SMc04008-like_sf', 5, NULL),
(33306, NULL, 'IPR039017', NULL, 'ATP synthase protein 8, mammals', 'ATP8_mammal', 4, NULL),
(33307, NULL, 'IPR034077', NULL, 'FKBP12-associated protein 1, R3H domain', 'R3H_FAP1', 3, NULL),
(33308, NULL, 'IPR038351', NULL, 'Malonyl-CoA decarboxylase, N-terminal domain superfamily', 'MCD_N_sf', 5, NULL),
(33309, NULL, 'IPR040881', NULL, 'Urease subunit beta-alpha, linker domain', 'Urease_linker', 3, NULL),
(33310, NULL, 'IPR036794', NULL, 'ATP synthase delta/epsilon subunit, C-terminal domain superfamily', 'ATP_F1_dsu/esu_C_sf', 5, NULL),
(33311, NULL, 'IPR037425', NULL, 'Sorting nexin-9, BAR domain', 'SNX9_BAR', 3, NULL),
(33312, NULL, 'IPR035436', NULL, 'Dystrophin/utrophin', 'Dystrophin/utrophin', 4, NULL),
(33313, NULL, 'IPR038062', NULL, 'ScdA-like, N-terminal domain superfamily', 'ScdA-like_N_sf', 5, NULL),
(33314, NULL, 'IPR036559', NULL, 'Bacteriochlorophyll A superfamily', 'Chl_A_sf', 5, NULL),
(33315, NULL, 'IPR039677', NULL, 'Ciliogenesis and planar polarity effector 2', 'RSG1', 4, NULL),
(33316, NULL, 'IPR037429', NULL, 'Rvs161/Hob3, BAR domain', 'Rvs161/Hob3_BAR', 3, NULL),
(33317, NULL, 'IPR039676', NULL, 'Acyloxyacyl hydrolase', 'AOAH', 4, NULL),
(33318, NULL, 'IPR035624', NULL, 'AGGF1, OCRE domain', 'AGGF1_OCRE', 3, NULL),
(33319, NULL, 'IPR039018', NULL, 'Endonuclease VapC20-like', 'VapC20-like', 4, NULL),
(33320, NULL, 'IPR037548', NULL, 'Bouquet formation protein 4', 'Bqt4', 4, NULL),
(33321, NULL, 'IPR038005', NULL, 'Virus X resistance protein-like, coiled-coil domain', 'RX-like_CC', 3, NULL),
(33322, NULL, 'IPR036953', NULL, 'Transcription elongation factor GreA/GreB, C-terminal domain superfamily', 'GreA/GreB_C_sf', 5, NULL),
(33323, NULL, 'IPR039468', NULL, 'WDR19, WD40 repeat', 'WDR19_WD40_rpt', 7, NULL),
(33324, NULL, 'IPR038382', NULL, 'Ste5, Fus3-binding domain superfamily', 'Ste5_C_sf', 5, NULL),
(33325, NULL, 'IPR036540', NULL, 'Poxvirus chemokine inhibitor superfamily', 'Pox_vCCI-like_sf', 5, NULL),
(33326, NULL, 'IPR035814', NULL, 'Procollagen C-endopeptidase enhancer, NTR domain', 'NTR_PCOLCE', 3, NULL),
(33327, NULL, 'IPR036187', NULL, 'DNA mismatch repair protein MutS, core domain superfamily', 'DNA_mismatch_repair_MutS_sf', 5, NULL),
(33328, NULL, 'IPR035520', NULL, 'High-affinity zinc uptake system protein ZnuA', 'ZnuA', 4, NULL),
(33329, NULL, 'IPR037549', NULL, 'Uncharacterized protein C19orf18', 'C19orf18', 4, NULL),
(33330, NULL, 'IPR036134', NULL, 'Cryptochrome/DNA photolyase, FAD-binding domain-like superfamily', 'Crypto/Photolyase_FAD-like_sf', 5, NULL),
(33331, NULL, 'IPR038359', NULL, 'Connexin, N-terminal domain superfamily', 'Connexin_N_sf', 5, NULL),
(33332, NULL, 'IPR036133', NULL, 'EB1, C-terminal domain superfamily', 'EB1_C_sf', 5, NULL),
(33333, NULL, 'IPR035666', NULL, 'Fungal multicopper oxidase, cupredoxin domain  3', 'MCO_CuRO_3', 3, NULL),
(33334, NULL, 'IPR039259', NULL, 'Protein maelstrom', 'Protein_maelstrom', 4, NULL),
(33335, NULL, 'IPR039326', NULL, 'Protein Patronus', 'Patronus', 4, NULL),
(33336, NULL, 'IPR039899', NULL, 'BET1, SNARE domain', 'BET1_SNARE', 3, NULL),
(33337, NULL, 'IPR036804', NULL, 'Chemotaxis receptor methyltransferase CheR, N-terminal domain superfamily', 'CheR_N_sf', 5, NULL),
(33338, NULL, 'IPR034823', NULL, 'CID8-like protein, RNA recognition motif 1', 'CID8-like_RRM1', 3, NULL),
(33339, NULL, 'IPR034704', NULL, 'L28p-like', 'L28p-like', 5, NULL),
(33340, NULL, 'IPR039338', NULL, 'Zinc finger TRAF-type-containing protein 1', 'ZFTRAF1', 4, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(33341, NULL, 'IPR039896', NULL, 'Protein Red-like', 'Red-like', 4, NULL),
(33342, NULL, 'IPR036556', NULL, 'Protein-arginine deiminase, central domain superfamily', 'PAD_central_sf', 5, NULL),
(33343, NULL, 'IPR039333', NULL, 'Partner of Y14 and mago', 'PYM1', 4, NULL),
(33344, NULL, 'IPR039293', NULL, 'Transmembrane protein 81', 'TMEM81', 4, NULL),
(33345, NULL, 'IPR035380', NULL, 'Late transcription unit A', 'LtuA', 4, NULL),
(33346, NULL, 'IPR037988', NULL, 'Myosin 5a, cargo-binding domain', 'Myo5a_CBD', 3, NULL),
(33347, NULL, 'IPR039437', NULL, 'Putative lumazine-binding', 'Put_lumazine-bd', 4, NULL),
(33348, NULL, 'IPR039460', NULL, 'STAGA complex 65 subunit gamma', 'SUPT7L', 4, NULL),
(33349, NULL, 'IPR039605', NULL, 'AT-hook motif nuclear-localized protein', 'AHL', 4, NULL),
(33350, NULL, 'IPR035525', NULL, 'NDPK7, first NDPk domain', 'NDPk7A', 3, NULL),
(33351, NULL, 'IPR034842', NULL, 'IGF2BP1, RNA recognition motif 2', 'IGF2BP1_RRM2', 3, NULL),
(33352, NULL, 'IPR036189', NULL, 'mRNA decapping protein 2, Box A domain superfamily', 'DCP2_BoxA_sf', 5, NULL),
(33353, NULL, 'IPR035673', NULL, 'ERdj5, first thioredoxin domain', 'ERdj5_TRX_N', 3, NULL),
(33354, NULL, 'IPR039351', NULL, 'Keratin-associated protein 8-1', 'KRTAP8-1', 4, NULL),
(33355, NULL, 'IPR037986', NULL, 'Dilute domain-containing protein, fungi, CBD domain', 'Myo5p-like_CBD_DIL', 3, NULL),
(33356, NULL, 'IPR039477', NULL, 'ILEI/PANDER domain', 'ILEI/PANDER_dom', 3, NULL),
(33357, NULL, 'IPR039399', NULL, 'Deltex, C-terminal domain superfamily', 'Deltex_C_sf', 5, NULL),
(33358, NULL, 'IPR035657', NULL, 'STAM1, SH3 domain', 'STAM1_SH3', 3, NULL),
(33359, NULL, 'IPR039072', NULL, 'ATP synthase protein I, Bacilli-type', 'ATP_synth_I_Bacilli', 4, NULL),
(33360, NULL, 'IPR035377', NULL, 'Herpesvirus Glycoprotein B, PH-like domain 1', 'Glycoprot_B_PH1', 3, NULL),
(33361, NULL, 'IPR036560', NULL, 'Methylamine/Aralkylamine dehydrogenase light chain superfamily', 'MADH/AADH_L_sf', 5, NULL),
(33362, NULL, 'IPR038641', NULL, 'Csa superfamily', 'Csa_sf', 5, NULL),
(33363, NULL, 'IPR038643', NULL, 'PliI superfamily', 'PliI_sf', 5, NULL),
(33364, NULL, 'IPR039434', NULL, 'Rift valley fever virus non structural protein-like', 'NSs-like', 4, NULL),
(33365, NULL, 'IPR035381', NULL, 'Herpesvirus Glycoprotein B, PH-like domain 2', 'Glycoprot_B_PH2', 3, NULL),
(33366, NULL, 'IPR036808', NULL, 'PA1123-like superfamily', 'PA1123-like_sf', 5, NULL),
(33367, NULL, 'IPR037426', NULL, 'Sorting nexin-9, PX domain', 'SNX9_PX', 3, NULL),
(33368, NULL, 'IPR034819', NULL, 'Cytoplasmic polyadenylation element-binding protein', 'CPEB', 4, NULL),
(33369, NULL, 'IPR035556', NULL, 'FCHSD2, SH3 domain 2', 'FCHSD2_SH3_2', 3, NULL),
(33370, NULL, 'IPR036731', NULL, 'Baculovirus telokin-like protein 20 superfamily', 'Tlp20_sf', 5, NULL),
(33371, NULL, 'IPR036562', NULL, 'Baculovirus p35 superfamily', 'Baculovirus_p35_sf', 5, NULL),
(33372, NULL, 'IPR036552', NULL, 'Core-binding factor, beta subunit superfamily', 'CBF_bsu_sf', 5, NULL),
(33373, NULL, 'IPR040912', NULL, 'Repeat of unknown function DUF5633', 'DUF5633', 7, NULL),
(33374, NULL, 'IPR033954', NULL, 'Disulphide bond isomerase, DsbC/G', 'DiS-bond_Isoase_DsbC/G', 4, NULL),
(33375, NULL, 'IPR039782', NULL, 'Intermembrane lipid transfer protein VPS13B', 'VPS13B', 4, NULL),
(33376, NULL, 'IPR036558', NULL, 'YqbG-like superfamily', 'YqbG-like_sf', 5, NULL),
(33377, NULL, 'IPR039366', NULL, 'Type 3 secretion system pilotin', 'Pilotin', 4, NULL),
(33378, NULL, 'IPR039758', NULL, 'N-acetyl-D-glucosamine kinase NAGK-like', 'NAGK_prok_euk', 4, NULL),
(33379, NULL, 'IPR036365', NULL, 'PGBD-like superfamily', 'PGBD-like_sf', 5, NULL),
(33380, NULL, 'IPR039420', NULL, 'Transcriptional regulatory protein WalR-like', 'WalR-like', 4, NULL),
(33381, NULL, 'IPR037840', NULL, 'Anillin, PH domain', 'PH_Anillin', 3, NULL),
(33382, NULL, 'IPR035852', NULL, 'Tyrosine-protein kinase Lyn, SH2 domain', 'Lyn_SH2', 3, NULL),
(33383, NULL, 'IPR036105', NULL, 'Dinitrogenase iron-molybdenum cofactor biosynthesis superfamily', 'DiNase_FeMo-co_biosyn_sf', 5, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(33384, NULL, 'IPR036526', NULL, 'Carbon-nitrogen hydrolase superfamily', 'C-N_Hydrolase_sf', 5, NULL),
(33385, NULL, 'IPR039425', NULL, 'RNA polymerase sigma-70 like', 'RNA_pol_sigma-70-like', 4, NULL),
(33386, NULL, 'IPR036790', NULL, 'Frizzled cysteine-rich domain superfamily', 'Frizzled_dom_sf', 5, NULL),
(33387, NULL, 'IPR039780', NULL, 'CCR4-NOT transcription complex subunit 4', 'Mot2', 4, NULL),
(33388, NULL, 'IPR033964', NULL, 'Aromatic prenyltransferase', 'Aro_prenylTrfase', 4, NULL),
(33389, NULL, 'IPR039755', NULL, 'TBC1 domain family member 23', 'TBC1D23', 4, NULL),
(33390, NULL, 'IPR033831', NULL, 'Heparin cofactor II, serpin domain', 'HCII_serpin_dom', 3, NULL),
(33391, NULL, 'IPR039586', NULL, 'Cilia- and flagella-associated protein 46', 'CFAP46', 4, NULL),
(33392, NULL, 'IPR036193', NULL, 'Adenylate kinase, active site lid domain superfamily', 'ADK_active_lid_dom_sf', 5, NULL),
(33393, NULL, 'IPR039236', NULL, 'Gastrin', 'GAST', 4, NULL),
(33394, NULL, 'IPR033695', NULL, 'Second polo-box domain', 'POLO_box_2', 3, NULL),
(33395, NULL, 'IPR035557', NULL, 'Sorting nexin-18, SH3 domain', 'SNX18_SH3', 3, NULL),
(33396, NULL, 'IPR036533', NULL, 'BAG domain superfamily', 'BAG_dom_sf', 5, NULL),
(33397, NULL, 'IPR036811', NULL, 'Ubiquinol-cytochrome C reductase hinge domain superfamily', 'Ubol_cytC_Rdtase_hinge_dom_sf', 5, NULL),
(33398, NULL, 'IPR039395', NULL, 'Peptidase C39-like A', 'Peptidase_C39-like_A', 3, NULL),
(33399, NULL, 'IPR039400', NULL, 'RagC/D', 'RagC/D', 4, NULL),
(33400, NULL, 'IPR036192', NULL, 'Cell division protein ZapA-like superfamily', 'Cell_div_ZapA-like_sf', 5, NULL),
(33401, NULL, 'IPR036778', NULL, 'Oxo-4-hydroxy-4-carboxy-5-ureidoimidazoline decarboxylase superfamily', 'OHCU_decarboxylase_sf', 5, NULL),
(33402, NULL, 'IPR033911', NULL, 'Methioninyl-tRNA synthetase core domain', 'MetRS_core', 3, NULL),
(33403, NULL, 'IPR036138', NULL, 'Penicillin-binding protein, dimerisation domain superfamily', 'PBP_dimer_sf', 5, NULL),
(33404, NULL, 'IPR037517', NULL, 'Hepatitis delta antigen (HDAg) domain', 'HDAG_dom', 3, NULL),
(33405, NULL, 'IPR036792', NULL, 'Aspartate carbamoyltransferase regulatory subunit, C-terminal domain superfamily', 'Asp_carbatrfase_reg_C_sf', 5, NULL),
(33406, NULL, 'IPR039074', NULL, 'GGGP/HepGP synthase group I', 'GGGP/HepGP_synthase_I', 4, NULL),
(33407, NULL, 'IPR037205', NULL, 'ChaB superfamily', 'ChaB_sf', 5, NULL),
(33408, NULL, 'IPR033479', NULL, 'Double Cache domain 1', 'dCache_1', 3, NULL),
(33409, NULL, 'IPR034843', NULL, 'IGF2BP2, RNA recognition motif 1', 'IGF2BP2_RRM1', 3, NULL),
(33410, NULL, 'IPR039436', NULL, 'Asteroid domain', 'Asteroid_dom', 3, NULL),
(33411, NULL, 'IPR036803', NULL, 'Porphobilinogen deaminase, C-terminal domain superfamily', 'Porphobilinogen_deaminase_C_sf', 5, NULL),
(33412, NULL, 'IPR036414', NULL, 'YaeB, N-terminal domain superfamily', 'YaeB_N_sf', 5, NULL),
(33413, NULL, 'IPR036180', NULL, 'Gelsolin-like domain superfamily', 'Gelsolin-like_dom_sf', 5, NULL),
(33414, NULL, 'IPR036539', NULL, 'Cytochrome c oxidase, subunit VIIa superfamily', 'Cyt_c_oxidase_su7a_sf', 5, NULL),
(33415, NULL, 'IPR036543', NULL, 'Guanylate-binding protein, C-terminal domain superfamily', 'Guanylate-bd_C_sf', 5, NULL),
(33416, NULL, 'IPR036797', NULL, 'Acyl-CoA dehydrogenase, C-terminal domain superfamily', 'Acyl-CoA_dehydrogenase_C_sf', 5, NULL),
(33417, NULL, 'IPR039765', NULL, 'Protein Yip5/YIPF1/YIPF2', 'Yip5/YIPF1/YIPF2', 4, NULL),
(33418, NULL, 'IPR039261', NULL, 'Ferredoxin-NADP reductase (FNR), nucleotide-binding domain', 'FNR_nucleotide-bd', 5, NULL),
(33419, NULL, 'IPR039778', NULL, 'Programmed cell death protein 4', 'PDCD4', 4, NULL),
(33420, NULL, 'IPR037213', NULL, 'RUN domain superfamily', 'Run_dom_sf', 5, NULL),
(33421, NULL, 'IPR037727', NULL, 'Microtubule-actin cross-linking factor 1-like', 'MCAF1-like', 4, NULL),
(33422, NULL, 'IPR036542', NULL, 'Phosphotransferase system, lactose/cellobiose-type IIA subunit superfamily', 'PTS_IIA_lac/cel_sf', 5, NULL),
(33423, NULL, 'IPR033864', NULL, 'Deubiquitinating enzyme 14, UBA domain', 'UBA2_scUBP14-like', 3, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(33424, NULL, 'IPR035561', NULL, 'Nck2, SH3 domain 3', 'Nck2_SH3_3', 3, NULL),
(33425, NULL, 'IPR037263', NULL, 'Phosphoprotein, central domain', 'Phosphoprotein_central', 5, NULL),
(33426, NULL, 'IPR039679', NULL, 'Nuclear receptor-binding factor 2', 'NRBF2', 4, NULL),
(33427, NULL, 'IPR039467', NULL, 'Transcription factor TFIIIB component B'''', Myb domain', 'TFIIIB_B''''_Myb', 3, NULL),
(33428, NULL, 'IPR035710', NULL, 'Archaeal gltB', 'Archaeal_gltB', 4, NULL),
(33429, NULL, 'IPR036561', NULL, 'Mitochondrial glycoprotein superfamily', 'MAM33_sf', 5, NULL),
(33430, NULL, 'IPR038760', NULL, 'Photosystem II PsbY, plant', 'PsbY_plant', 4, NULL),
(33431, NULL, 'IPR039380', NULL, 'Toxin-ParB-like', 'Toxin-ParB-like', 3, NULL),
(33432, NULL, 'IPR039674', NULL, 'CASP8-associated protein 2', 'FLASH', 4, NULL),
(33433, NULL, 'IPR034832', NULL, 'TIA-1, RNA recognition motif 3', 'TIA1_RRM3', 3, NULL),
(33434, NULL, 'IPR038759', NULL, 'HSPRO1/HSPRO2', 'HSPRO1/HSPRO2', 4, NULL),
(33435, NULL, 'IPR037479', NULL, 'Tautomerase, MSAD family', 'Tauto_MSAD', 4, NULL),
(33436, NULL, 'IPR034837', NULL, 'IGF2BP1, RNA recognition motif 1', 'IGF2BP1_RRM1', 3, NULL),
(33437, NULL, 'IPR035592', NULL, 'IRTKS, SH3 domain', 'IRTKS_SH3', 3, NULL),
(33438, NULL, 'IPR038352', NULL, 'Imelysin-like domain superfamily', 'Imelysin_sf', 5, NULL),
(33439, NULL, 'IPR037520', NULL, 'Folliculin/SMCR8, longin domain', 'Folliculin/SMCR8_longin', 3, NULL),
(33440, NULL, 'IPR037297', NULL, 'Probable ABC transporter arginine-binding protein ArtJ, PBP2 domain', 'ArtJ_PBP2', 3, NULL),
(33441, NULL, 'IPR037519', NULL, 'LITAF domain containing protein', 'LITAF_fam', 4, NULL),
(33442, NULL, 'IPR033455', NULL, 'Transcriptional regulator AbiEi antitoxin, N-terminal domain', 'AbiEi_3_N', 3, NULL),
(33443, NULL, 'IPR037441', NULL, 'Frizzled-5, CRD domain', 'FZ5_CRD', 3, NULL),
(33444, NULL, 'IPR037407', NULL, 'MbtH-like protein', 'MLP_fam', 4, NULL),
(33445, NULL, 'IPR037729', NULL, 'Neuropeptide CCHamide 1/2', 'CCHa1/2', 4, NULL),
(33446, NULL, 'IPR039174', NULL, 'Chondroitin sulfate ABC lyase', 'Chondroitin_ABC_lyase', 4, NULL),
(33447, NULL, 'IPR036118', NULL, 'UreE urease accessory, N-terminal domain superfamily', 'UreE_N_sf', 5, NULL),
(33448, NULL, 'IPR035804', NULL, 'Aspartokinase 3, N-terminal', 'AKIII_YclM_N', 3, NULL),
(33449, NULL, 'IPR033856', NULL, 'Flavin-dependent tryptophan halogenase', 'Trp_halogen', 4, NULL),
(33450, NULL, 'IPR039781', NULL, 'Rad21/Rec8-like protein', 'Rad21/Rec8-like', 4, NULL),
(33451, NULL, 'IPR036781', NULL, 'Smr-associated-like superfamily', 'Smr_assoc-like_sf', 5, NULL),
(33452, NULL, 'IPR037398', NULL, 'Glucan endo-1,3-beta-glucosidase', 'Glyco_hydro_64', 4, NULL),
(33453, NULL, 'IPR039058', NULL, 'Yippee family', 'Yippee_fam', 4, NULL),
(33454, NULL, 'IPR038642', NULL, 'VioE superfamily', 'VioE_sf', 5, NULL),
(33455, NULL, 'IPR035523', NULL, 'Collagen alpha-1(XVIII) chain, frizzled domain', 'Collagen_XVIII_Fz', 3, NULL),
(33456, NULL, 'IPR037427', NULL, 'Sorting nexin-33, BAR domain', 'SNX33_BAR', 3, NULL),
(33457, NULL, 'IPR036544', NULL, 'Cytochrome b-c1 complex subunit 7 superfamily', 'QCR7_sf', 5, NULL),
(33458, NULL, 'IPR033228', NULL, 'Protein SZT2', 'SZT2', 4, NULL),
(33459, NULL, 'IPR036805', NULL, 'Transcription elongation factor, GreA/GreB, N-terminal domain superfamily', 'Tscrpt_elong_fac_GreA/B_N_sf', 5, NULL),
(33460, NULL, 'IPR034989', NULL, 'Emerin, LEM domain', 'LEM_emerin', 3, NULL),
(33461, NULL, 'IPR039054', NULL, 'Int12, PHD finger', 'Int12_PHD', 3, NULL),
(33462, NULL, 'IPR037730', NULL, 'Mitochondrial inner membrane protease subunit 2', 'IMP2', 4, NULL),
(33463, NULL, 'IPR036130', NULL, 'Pyridoxine 5''-phosphate synthase', 'Pyridoxine-5''_phos_synth', 5, NULL),
(33464, NULL, 'IPR038354', NULL, 'VKOR domain superfamily', 'VKOR_sf', 5, NULL),
(33465, NULL, 'IPR033454', NULL, 'RecG, wedge domain', 'RecG_wedge', 3, NULL),
(33466, NULL, 'IPR040183', NULL, 'THUMP domain-containing protein 1-like', 'THUMPD1-like', 4, NULL),
(33467, NULL, 'IPR038767', NULL, 'Transcriptional regulator containing an HTH domain fused to a Zn-ribbon, predicted', 'Transcriptional_reg_pdt', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(33468, NULL, 'IPR036787', NULL, 'Translation initiation factor 3 (IF-3), N-terminal domain superfamily', 'T_IF-3_N_sf', 5, NULL),
(33469, NULL, 'IPR035586', NULL, 'Phosphatidylinositol 3-kinase regulatory subunit beta, SH3 domain', 'PI3K_p85beta_SH3', 3, NULL),
(33470, NULL, 'IPR035803', NULL, 'Sorting nexin Vps5, BAR domain', 'BAR_Vps5', 3, NULL),
(33471, NULL, 'IPR036801', NULL, 'Diphtheria toxin, translocation domain superfamily', 'Diphtheria_tox_transloc_sf', 5, NULL),
(33472, NULL, 'IPR034669', NULL, 'Novel protein kinase C epsilon, catalytic domain', 'nPKC_epsilon', 3, NULL),
(33473, NULL, 'IPR039412', NULL, 'Cathepsin C', 'CatC', 3, NULL),
(33474, NULL, 'IPR036780', NULL, 'PG1857-like superfamily', 'PG1857-like_sf', 5, NULL),
(33475, NULL, 'IPR039520', NULL, 'E3 ubiquitin-protein ligase CBL-B, RING finger, HC subclass', 'CBL-B_RING-HC', 3, NULL),
(33476, NULL, 'IPR037882', NULL, 'Alpha-crystallin B chain, ACD domain', 'ACD_alphaB-crystallin', 3, NULL),
(33477, NULL, 'IPR039350', NULL, 'Prospero homeodomain family', 'Prospero_homeodomain', 4, NULL),
(33478, NULL, 'IPR037217', NULL, 'Tryptophan/Indoleamine 2,3-dioxygenase-like', 'Trp/Indoleamine_2_3_dOase-like', 5, NULL),
(33479, NULL, 'IPR037324', NULL, 'Transferrin receptor protein 1/2, PA domain', 'TfR1/2_PA', 3, NULL),
(33480, NULL, 'IPR039486', NULL, 'Mug56/Spo71, PH domain', 'Mug56/Spo71_PH', 3, NULL),
(33481, NULL, 'IPR039056', NULL, 'CDC42 small effector protein', 'SPEC', 4, NULL),
(33482, NULL, 'IPR033060', NULL, 'Integrator complex subunit 7', 'INTS7', 4, NULL),
(33483, NULL, 'IPR039396', NULL, 'Deltex, C-terminal', 'Deltex_C', 3, NULL),
(33484, NULL, 'IPR039052', NULL, 'Antitoxin PemI-like', 'Antitox_PemI-like', 4, NULL),
(33485, NULL, 'IPR039556', NULL, 'ICL/PEPM domain', 'ICL/PEPM', 3, NULL),
(33486, NULL, 'IPR040900', NULL, 'Spermine synthase, N-terminal', 'SpmSyn_N', 3, NULL),
(33487, NULL, 'IPR039530', NULL, 'RNA-directed RNA polymerase L methyltransferase domain, rhabdovirus', 'L_methyltransferase_rhabdo', 3, NULL),
(33488, NULL, 'IPR039583', NULL, 'Transcription factor-like 5 protein', 'TCFL5', 4, NULL),
(33489, NULL, 'IPR038021', NULL, 'Putative hydro-lyase', 'Putative_hydro-lyase', 5, NULL),
(33490, NULL, 'IPR036126', NULL, 'Tubulin binding cofactor A superfamily', 'TBCA_sf', 5, NULL),
(33491, NULL, 'IPR039726', NULL, 'Pre-mRNA-processing factor Prp40', 'Prp40-like', 4, NULL),
(33492, NULL, 'IPR036768', NULL, 'DNA polymerase III subunit chi superfamily', 'PolIII_chi_sf', 5, NULL),
(33493, NULL, 'IPR035438', NULL, 'Zinc finger FYVE domain containing protein, SARA/endofin', 'SARA/endofin', 4, NULL),
(33494, NULL, 'IPR039432', NULL, 'SRP9 domain', 'SRP9_dom', 3, NULL),
(33495, NULL, 'IPR037298', NULL, 'Cyclohexadienyl dehydratase PheC', 'PheC_PBP2', 3, NULL),
(33496, NULL, 'IPR035626', NULL, 'N-acetylgalactosamine-6-sulfatase', 'GALNS', 4, NULL),
(33497, NULL, 'IPR040903', NULL, 'Retroviral integrase, C-terminal SH3 domain', 'SH3_11', 3, NULL),
(33498, NULL, 'IPR039340', NULL, 'Transcription factor Tfc4/TFIIIC-102/Sfc4', 'Tfc4/TFIIIC-102/Sfc4', 4, NULL),
(33499, NULL, 'IPR039024', NULL, 'Restriction of telomere capping protein 4', 'RTC4', 4, NULL),
(33500, NULL, 'IPR039762', NULL, 'Nonsense-mediated mRNA decay protein Nmd2/UPF2', 'Nmd2/UPF2', 4, NULL),
(33501, NULL, 'IPR036708', NULL, 'BipD-like superfamily', 'BipD-like_sf', 5, NULL),
(33502, NULL, 'IPR045603', NULL, 'QcrA subunit, N-terminal', 'QcrA_N', 3, NULL),
(33503, NULL, 'IPR038229', NULL, 'Pathogenicity island component CagD superfamily', 'CagD_sf', 5, NULL),
(33504, NULL, 'IPR046368', NULL, 'Tag1', 'Tag1', 4, NULL),
(33505, NULL, 'IPR042450', NULL, 'Eukaryotic translation elongation factor 1 epsilon-1', 'EEF1E1', 4, NULL),
(33506, NULL, 'IPR046589', NULL, 'Protein of unknown function DUF6647', 'DUF6647', 4, NULL),
(33507, NULL, 'IPR038538', NULL, 'MTERF superfamily, mitochondrial/chloroplastic', 'MTERF_sf', 5, NULL),
(33508, NULL, 'IPR037603', NULL, 'SEC23-interacting protein, SAM domain', 'SEC23IP_SAM', 3, NULL),
(33509, NULL, 'IPR038670', NULL, 'HslJ-like superfamily', 'HslJ-like_sf', 5, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(33510, NULL, 'IPR038514', NULL, 'AAR2, C-terminal domain superfamily', 'AAR2_C_sf', 5, NULL),
(33511, NULL, 'IPR044351', NULL, 'RNA-dependent RNA polymerase, SARS-CoV-like', 'RdRp_SARS-CoV-like', 3, NULL),
(33512, NULL, 'IPR039596', NULL, 'Growth arrest-specific protein 1', 'GAS1', 4, NULL),
(33513, NULL, 'IPR036601', NULL, 'CBM10 superfamily', 'CBM10_sf', 5, NULL),
(33514, NULL, 'IPR038235', NULL, 'Respiratory growth induced protein 1 superfamily', 'RGI1_sf', 5, NULL),
(33515, NULL, 'IPR046776', NULL, 'Putative pectate lyase-like adhesive domain', 'Pectate_lyase_5', 7, NULL),
(33516, NULL, 'IPR046891', NULL, 'Prokaryotic E2 domain', 'E2-ntca', 3, NULL),
(33517, NULL, 'IPR038689', NULL, 'Thermostable direct haemolysin superfamily', 'TDH_sf', 5, NULL),
(33518, NULL, 'IPR039590', NULL, 'Developmental pluripotency-associated protein 2/4', 'Dppa2/4', 4, NULL),
(33519, NULL, 'IPR038691', NULL, 'DNA-entry nuclease inhibitor, ComJ superfamily', 'ComJ_sf', 5, NULL),
(33520, NULL, 'IPR035070', NULL, 'Streptogrisin prodomain', 'Streptogrisin_prodomain', 5, NULL),
(33521, NULL, 'IPR045050', NULL, 'Synaptotagmin, plant', 'Synaptotagmin_plant', 4, NULL),
(33522, NULL, 'IPR044341', NULL, 'Spike (S) protein S1 subunit, N-terminal domain, SARS-CoV-like', 'Spike_S1_N_SARS-CoV-like', 3, NULL),
(33523, NULL, 'IPR046766', NULL, 'Bacterial hydrolase', 'Bact_hydrolase', 4, NULL),
(33524, NULL, 'IPR046637', NULL, 'Domain of unknown function DUF6749', 'DUF6749', 3, NULL),
(33525, NULL, 'IPR046356', NULL, 'E3 ubiquitin-protein ligase MARCHF4/9/11', 'MARCHF4/9/11', 4, NULL),
(33526, NULL, 'IPR042140', NULL, 'CARD10, CARD domain', 'CARD_CARD10', 3, NULL),
(33527, NULL, 'IPR039576', NULL, 'Amyloid beta precursor protein binding family B member 1/2/3', 'APBB1/2/3', 4, NULL),
(33528, NULL, 'IPR037604', NULL, 'Scm-like with four MBT domains protein 1/2, SAM domain', 'Scm-like-4MBT1/2_SAM', 3, NULL),
(33529, NULL, 'IPR042245', NULL, 'Tgt2/MlaC superfamily', 'Tgt2/MlaC_sf', 5, NULL),
(33530, NULL, 'IPR046599', NULL, 'Protein of unknown function DUF6658', 'DUF6658', 4, NULL),
(33531, NULL, 'IPR046763', NULL, 'Phage tail tube protein, C-terminal', 'Phage_tube_C', 3, NULL),
(33532, NULL, 'IPR044819', NULL, 'Triacylglycerol lipase OBL1-like', 'OBL-like', 4, NULL),
(33533, NULL, 'IPR044340', NULL, 'Helicase Sen1, 1B domain', 'Helicase_Sen1_1B_dom', 3, NULL),
(33534, NULL, 'IPR035599', NULL, 'MPP7, SH3 domain', 'MPP7_SH3', 3, NULL),
(33535, NULL, 'IPR038522', NULL, 'Type IV / VI secretion system, DotU superfamily', 'T4/T6SS_DotU_sf', 5, NULL),
(33536, NULL, 'IPR039582', NULL, 'Thiamine-triphosphatase', 'THTPA', 4, NULL),
(33537, NULL, 'IPR037601', NULL, 'ANKS4B, SAM domain', 'ANKS4B_SAM', 3, NULL),
(33538, NULL, 'IPR033309', NULL, 'Crossover junction endonuclease Mus81', 'Mus81', 4, NULL),
(33539, NULL, 'IPR042491', NULL, 'Vacuolar protein sorting-associated protein 35, C-terminal', 'Vps35_C', 5, NULL),
(33540, NULL, 'IPR046606', NULL, 'Protein of unknown function DUF6665', 'DUF6665', 4, NULL),
(33541, NULL, 'IPR039564', NULL, 'Peptidase C39-like', 'Peptidase_C39-like', 3, NULL),
(33542, NULL, 'IPR038687', NULL, 'Apoptosis regulator, M-T4 superfamily', 'M-T4_sf', 5, NULL),
(33543, NULL, 'IPR046820', NULL, 'MmeI-like, target recognition domain', 'MmeI_TRD', 3, NULL),
(33544, NULL, 'IPR045581', NULL, 'DNA-dependent protein kinase catalytic subunit, CC5', 'DNAPKcs_CC5', 3, NULL),
(33545, NULL, 'IPR046650', NULL, 'Protein of unknown function DUF6762', 'DUF6762', 4, NULL),
(33546, NULL, 'IPR046818', NULL, 'MmeI-like, C-terminal domain', 'MmeI_C', 3, NULL),
(33547, NULL, 'IPR046649', NULL, 'Protein of unknown function DUF6761', 'DUF6761', 4, NULL),
(33548, NULL, 'IPR046633', NULL, 'Domain of unknown function DUF6745', 'DUF6745', 3, NULL),
(33549, NULL, 'IPR043449', NULL, 'PHD finger protein 20-like', 'PHF20-like', 4, NULL),
(33550, NULL, 'IPR038528', NULL, 'TEL2, C-terminal domain superfamily', 'TEL2_C_sf', 5, NULL),
(33551, NULL, 'IPR046899', NULL, 'KTSC and Metallopeptidase-like, N-terminal fusion domain', 'KMPT_N', 3, NULL),
(33552, NULL, 'IPR046357', NULL, 'Peptidyl-prolyl cis-trans isomerase domain superfamily', 'PPIase_dom_sf', 5, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(33553, NULL, 'IPR046646', NULL, 'Protein of unknown function DUF6758', 'DUF6758', 4, NULL),
(33554, NULL, 'IPR038673', NULL, 'Carbohydrate-selective porin OprB superfamily', 'OprB_sf', 5, NULL),
(33555, NULL, 'IPR046821', NULL, 'PD-(D/E)XK nuclease domain', 'PDDEXK_11', 3, NULL),
(33556, NULL, 'IPR039976', NULL, 'WPP domain-interacting tail-anchored protein', 'WIT1/WIT2', 4, NULL),
(33557, NULL, 'IPR038686', NULL, 'MIC1, C-terminal superfamily', 'MIC1_C_sf', 5, NULL),
(33558, NULL, 'IPR042145', NULL, 'RIG-I, CARD domain repeat 2', 'CARD_RIG-I_r2', 3, NULL),
(33559, NULL, 'IPR038690', NULL, 'NusG, domain 2 superfamily', 'NusG_2_sf', 5, NULL),
(33560, NULL, 'IPR046575', NULL, 'Protein of unknown function DUF6635', 'DUF6635', 4, NULL),
(33561, NULL, 'IPR046852', NULL, 'Neurobeachin, alpha-solenoid region', 'Neurobeachin_a-sol', 3, NULL),
(33562, NULL, 'IPR042125', NULL, 'Small integral membrane protein 11', 'SMIM11', 4, NULL),
(33563, NULL, 'IPR038230', NULL, 'TBP-interacting protein, N-terminal superfamily', 'TIP_N_sf', 5, NULL),
(33564, NULL, 'IPR046338', NULL, 'GAIN domain superfamily', 'GAIN_dom_sf', 5, NULL),
(33565, NULL, 'IPR042153', NULL, 'VDR, DNA-binding domain', 'DBD_VDR', 3, NULL),
(33566, NULL, 'IPR044124', NULL, 'PIK3R1, inter-SH2 domain', 'ISH2_PIK3R1', 3, NULL),
(33567, NULL, 'IPR038505', NULL, 'FANCF, C-terminal domain superfamily', 'FANCF_C_sf', 5, NULL),
(33568, NULL, 'IPR038218', NULL, 'YuzD-like superfamily', 'YuzD-like_sp', 5, NULL),
(33569, NULL, 'IPR046634', NULL, 'Protein of unknown function DUF6746', 'DUF6746', 4, NULL),
(33570, NULL, 'IPR046616', NULL, 'Domain of unknown function DUF6729', 'DUF6729', 3, NULL),
(33571, NULL, 'IPR046844', NULL, 'Lon-like, helical domain', 'Lon-like_helical', 3, NULL),
(33572, NULL, 'IPR036595', NULL, 'Alpha-macroglobulin, receptor-binding domain superfamily', 'A-macroglobulin_rcpt-bd_sf', 5, NULL),
(33573, NULL, 'IPR038658', NULL, 'Sporulation-specific cell division protein SsgB superfamily', 'SsgB_sf', 5, NULL),
(33574, NULL, 'IPR046608', NULL, 'Domain of unknown function DUF6667', 'DUF6667', 3, NULL),
(33575, NULL, 'IPR046764', NULL, 'Phage tail tube protein, N-terminal', 'L_lac_phage_MSP_N', 3, NULL),
(33576, NULL, 'IPR035208', NULL, 'Protein of unknown function DUF5456', 'DUF5456', 4, NULL),
(33577, NULL, 'IPR046443', NULL, 'NSP1, globular domain, alpha/betacoronavirus', 'a/bCoV_NSP1_glob', 3, NULL),
(33578, NULL, 'IPR046624', NULL, 'Secreted protein CSS2, C-terminal domain', 'CSS2_C', 3, NULL),
(33579, NULL, 'IPR045653', NULL, 'Domain of unknown function DUF6396', 'DUF6396', 3, NULL),
(33580, NULL, 'IPR042241', NULL, 'Gamma-tubulin complex component, C-terminal domain superfamily', 'GCP_C_sf', 5, NULL),
(33581, NULL, 'IPR042297', NULL, 'Antirestriction domain superfamily', 'Antirestriction_sf', 5, NULL),
(33582, NULL, 'IPR046464', NULL, 'SWI/SNF and RSC complexes subunit Ssr4, C-terminal', 'SWI-SNF_Ssr4_C', 3, NULL),
(33583, NULL, 'IPR037602', NULL, 'USH1G, SAM domain', 'USH1G_SAM', 3, NULL),
(33584, NULL, 'IPR043072', NULL, 'Staphylcoagulase, N-terminal, subdomain 1', 'Staphylcoagulase_N_1', 5, NULL),
(33585, NULL, 'IPR046403', NULL, '3-oxopimeloyl-[acyl-carrier-protein] synthase', 'BioZ', 4, NULL),
(33586, NULL, 'IPR045555', NULL, 'vWA-MoxR associated protein middle region 0', 'VMAP-M0', 3, NULL),
(33587, NULL, 'IPR045467', NULL, 'Protein of unknown function DUF6497', 'DUF6497', 4, NULL),
(33588, NULL, 'IPR042734', NULL, 'Rho-related GTP-binding protein RhoG', 'RhoG', 4, NULL),
(33589, NULL, 'IPR046596', NULL, 'Protein of unknown function DUF6655', 'DUF6655', 4, NULL),
(33590, NULL, 'IPR038681', NULL, 'Sf6-type phage tail needle knob superfamily', 'Phage_tail_NK_sf', 5, NULL),
(33591, NULL, 'IPR046404', NULL, 'ClpXP adapter protein SpxH', 'Adapter_SpxH', 4, NULL),
(33592, NULL, 'IPR044338', NULL, 'Spike (S) protein S1 subunit, N-terminal domain, HKU9-like', 'Spike_S1_N_batCoV-HKU9-like', 3, NULL),
(33593, NULL, 'IPR046630', NULL, 'Domain of unknown function DUF6742', 'DUF6742', 3, NULL),
(33594, NULL, 'IPR042240', NULL, 'CHASE domain superfamily', 'CHASE_sf', 5, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(33595, NULL, 'IPR035210', NULL, 'Protein of unknown function DUF5455', 'DUF5455', 4, NULL),
(33596, NULL, 'IPR042108', NULL, 'GTPase HflX, N-terminal domain superfamily', 'GTPase_HflX_N_sf', 5, NULL),
(33597, NULL, 'IPR045668', NULL, 'FHF complex subunit HOOK interacting protein, KELAA motif', 'FHIP_KELAA_motif', 2, NULL),
(33598, NULL, 'IPR044487', NULL, 'Aldo-keto reductase family 2D', 'AKR2D', 4, NULL),
(33599, NULL, 'IPR036907', NULL, '5''-Nucleotidase, C-terminal domain superfamily', '5''-Nucleotdase_C_sf', 5, NULL),
(33600, NULL, 'IPR042223', NULL, 'Homeobox protein SEBOX', 'SEBOX', 4, NULL),
(33601, NULL, 'IPR039594', NULL, 'F-box only protein 34/46', 'FBXO34/46', 4, NULL),
(33602, NULL, 'IPR046394', NULL, 'Bacteriophage T7 DNA helicase/primase', 'Helic_Prim_T7', 4, NULL),
(33603, NULL, 'IPR046860', NULL, 'SnoaL-like domain 5', 'SnoaL_5', 3, NULL),
(33604, NULL, 'IPR039330', NULL, 'Chromosome alignment-maintaining phosphoprotein 1', 'CAMP', 4, NULL),
(33605, NULL, 'IPR038497', NULL, 'ATPase, V1 complex, subunit H, C-terminal domain superfamily', 'ATPase_V1-cplx_hsu_C_sf', 5, NULL),
(33606, NULL, 'IPR042787', NULL, 'M3K14, catalytic domain', 'M3K14_STKc', 3, NULL),
(33607, NULL, 'IPR038023', NULL, 'VASP tetramerisation domain superfamily', 'VASP_sf', 5, NULL),
(33608, NULL, 'IPR038225', NULL, 'T6S-associated protein TagF superfamily', 'TagF_sf', 5, NULL),
(33609, NULL, 'IPR044345', NULL, 'Nucleocapsid (N) protein, N-terminal domain,  coronavirus', 'N_prot_N_CoV', 3, NULL),
(33610, NULL, 'IPR046617', NULL, 'Protein of unknown function DUF6730', 'DUF6730', 4, NULL),
(33611, NULL, 'IPR046567', NULL, 'Lysostaphin, N-terminal domain', 'Lysostaphin_N', 3, NULL),
(33612, NULL, 'IPR044377', NULL, 'Envelope small membrane protein, SARS-CoV-2-like', 'E_SARS-CoV-2', 4, NULL),
(33613, NULL, 'IPR044347', NULL, 'RNA-dependent RNA polymerase, coronavirus HKU1-like', 'RdRp_HCoV_HKU1-like', 3, NULL),
(33614, NULL, 'IPR035490', NULL, 'GlmS/FrlB, SIS domain 2', 'GlmS/FrlB_SIS', 3, NULL),
(33615, NULL, 'IPR046862', NULL, 'Rhomboid-like protein', 'Rhomboid_2', 4, NULL),
(33616, NULL, 'IPR038220', NULL, 'Phenol hydroxylase, C-terminal TRX-fold domain superfamily', 'PHOX_C_sf', 5, NULL),
(33617, NULL, 'IPR046635', NULL, 'Protein of unknown function DUF6747', 'DUF6747', 4, NULL),
(33618, NULL, 'IPR046447', NULL, 'DENR, C-terminal domain', 'DENR_C', 3, NULL),
(33619, NULL, 'IPR042224', NULL, 'General transcription factor II-I repeat domain-containing protein 2', 'GTF2IRD2', 4, NULL),
(33620, NULL, 'IPR039589', NULL, 'TBCC domain-containing protein 1', 'TBCC1', 4, NULL),
(33621, NULL, 'IPR038213', NULL, 'IFI6/IFI27-like domain superfamily', 'IFI6/IFI27-like_sf', 5, NULL),
(33622, NULL, 'IPR033549', NULL, 'NFAT activation molecule 1', 'NFAM1', 4, NULL),
(33623, NULL, 'IPR042296', NULL, 'tRNA methyltransferase, Trm1, C-terminal', 'tRNA_met_Trm1_C', 5, NULL),
(33624, NULL, 'IPR037512', NULL, 'Phosphoglycolate phosphatase, prokaryotic', 'PGPase_prok', 4, NULL),
(33625, NULL, 'IPR046590', NULL, 'Protein of unknown function DUF6648', 'DUF6648', 4, NULL),
(33626, NULL, 'IPR046609', NULL, 'Protein of unknown function DUF6668', 'DUF6668', 4, NULL),
(33627, NULL, 'IPR039514', NULL, 'Endo-beta-1,6-galactanase-like', '6GAL-like', 3, NULL),
(33628, NULL, 'IPR046775', NULL, 'Cyclin-D-binding Myb-like transcription factor 1, N-terminal', 'DMTF1_N', 3, NULL),
(33629, NULL, 'IPR042538', NULL, 'Nucleoporin, Nup155-like, C-terminal, subdomain 3', 'Nucleoporin_Nup155_C_3', 5, NULL),
(33630, NULL, 'IPR046807', NULL, 'Tra1, HEAT repeat central region', 'Tra1_central', 7, NULL),
(33631, NULL, 'IPR045634', NULL, 'Protein of unknown function DUF6413', 'DUF6413', 4, NULL),
(33632, NULL, 'IPR038536', NULL, 'Alkyl/aryl-sulfatase, dimerisation domain superfamily', 'Alkyl/aryl-sulf_dimr_sf', 5, NULL),
(33633, NULL, 'IPR046636', NULL, 'Domain of unknown function DUF6748', 'DUF6748', 3, NULL),
(33634, NULL, 'IPR042539', NULL, 'Viral matrix protein, C-terminal domain', 'Matrix_C', 5, NULL),
(33635, NULL, 'IPR042155', NULL, 'UNC5A, death domain', 'Death_UNC5A', 3, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(33636, NULL, 'IPR042735', NULL, 'FCHo1, F-BAR domain', 'FCHo1_F-BAR', 3, NULL),
(33637, NULL, 'IPR038657', NULL, 'Ribosomal protein L19 superfamily', 'L19_sf', 5, NULL),
(33638, NULL, 'IPR046605', NULL, 'Protein of unknown function DUF6664', 'DUF6664', 4, NULL),
(33639, NULL, 'IPR039551', NULL, 'Choline/carnitine acyltransferase domain', 'Cho/carn_acyl_trans', 3, NULL),
(33640, NULL, 'IPR044848', NULL, 'PHR1-like', 'PHR1-like', 4, NULL),
(33641, NULL, 'IPR042146', NULL, 'BinCARD, CARD domain', 'CARD_BinCARD', 3, NULL),
(33642, NULL, 'IPR035598', NULL, 'ZO-2, SH3 domain', 'ZO-2_SH3', 3, NULL),
(33643, NULL, 'IPR046798', NULL, 'Tet-like 2OG-Fe(II) oxygenase', '2OG-FeII_Oxy_6', 3, NULL),
(33644, NULL, 'IPR038921', NULL, 'Uncharacterized protein YOR389W-like', 'YOR389W-like', 4, NULL),
(33645, NULL, 'IPR038911', NULL, 'Sodium channel and clathrin linker 1', 'SCLT1', 4, NULL),
(33646, NULL, 'IPR043405', NULL, 'Chondromodulin/Tenomodulin', 'Chondromodulin/Tenomodulin', 4, NULL),
(33647, NULL, 'IPR046610', NULL, 'Protein of unknown function DUF6669', 'DUF6669', 4, NULL),
(33648, NULL, 'IPR046611', NULL, 'Protein of unknown function DUF6670', 'DUF6670', 4, NULL),
(33649, NULL, 'IPR042298', NULL, 'Proto-chlorophyllide reductase, C-terminal', 'P-CP_red_C', 5, NULL),
(33650, NULL, 'IPR046651', NULL, 'Protein of unknown function DUF6763', 'DUF6763', 4, NULL),
(33651, NULL, 'IPR046784', NULL, 'eIF4E-associated protein', 'Eap1', 4, NULL),
(33652, NULL, 'IPR042302', NULL, 'Ubiquitin-activating enzyme E1, FCCH domain superfamily', 'E1_FCCH_sf', 5, NULL),
(33653, NULL, 'IPR045828', NULL, 'PKD-like domain, Bacteroidetes', 'PKD_Bacteroidetes', 3, NULL),
(33654, NULL, 'IPR038557', NULL, 'RIG-I-like receptor, C-terminal domain superfamily', 'RLR_C_sf', 5, NULL),
(33655, NULL, 'IPR044257', NULL, 'Protein TRM32-like', 'TRM32-like', 4, NULL),
(33656, NULL, 'IPR034956', NULL, 'Regulator of G-protein signalling 5, RGS domain', 'RGS_RGS5', 3, NULL),
(33657, NULL, 'IPR039553', NULL, 'Prefoldin-like', 'Prefoldin-like', 4, NULL),
(33658, NULL, 'IPR046572', NULL, 'Protein of unknown function DUF6632', 'DUF6632', 4, NULL),
(33659, NULL, 'IPR046579', NULL, 'Protein of unknown function DUF6639', 'DUF6639', 4, NULL),
(33660, NULL, 'IPR033308', NULL, 'PGAP5/Cdc1/Ted1', 'PGAP5/Cdc1/Ted1', 4, NULL),
(33661, NULL, 'IPR035596', NULL, 'Src-like-adapter, SH3 domain', 'SLAP_SH3', 3, NULL),
(33662, NULL, 'IPR036204', NULL, 'ATP synthase-coupling factor 6 superfamily, mitochondrial', 'ATP_synth_f6_sf_mt', 5, NULL),
(33663, NULL, 'IPR044349', NULL, 'RNA-dependent RNA polymerase, bat coronavirus HKU9-like', 'RdRp_batCoV_HKU9-like', 3, NULL),
(33664, NULL, 'IPR046327', NULL, 'Homeobox protein Hox-A1/B1/D1', 'HXA1/B1/D1', 4, NULL),
(33665, NULL, 'IPR036711', NULL, 'VSV matrix superfamily', 'VSV_matrix_sf', 5, NULL),
(33666, NULL, 'IPR038664', NULL, 'H/ACA RNP complex subunit Gar1/Naf1, Cbf5-binding domain', 'Gar1/Naf1_Cbf5-bd_sf', 5, NULL),
(33667, NULL, 'IPR039575', NULL, 'Prolyl 3-hydroxylase', 'P3H', 4, NULL),
(33668, NULL, 'IPR042493', NULL, 'Bacterial type XPD DNA helicase, FeS cluster domain', 'XPD_DNA_FeS', 5, NULL),
(33669, NULL, 'IPR046472', NULL, 'DMRT5/1, DMB domain', 'DMRT5_1_DMB_dom', 3, NULL),
(33670, NULL, 'IPR046568', NULL, 'Protein of unknown function DUF6722', 'DUF6722', 4, NULL),
(33671, NULL, 'IPR046621', NULL, 'Domain of unknown function DUF6734', 'DUF6734', 3, NULL),
(33672, NULL, 'IPR039595', NULL, 'TE2IP/Rap1', 'TE2IP/Rap1', 4, NULL),
(33673, NULL, 'IPR039515', NULL, 'NOT4, modified RING finger, HC subclass (C4C4-type)', 'NOT4_mRING-HC-C4C4', 3, NULL),
(33674, NULL, 'IPR046902', NULL, 'ABC-three component system, Middle Component 4', 'ABC-3C_MC4', 4, NULL),
(33675, NULL, 'IPR038525', NULL, 'ATR13 superfamily', 'ATR13_sf', 5, NULL),
(33676, NULL, 'IPR039987', NULL, 'PGR5-like protein 1', 'PGRL1', 4, NULL),
(33677, NULL, 'IPR035634', NULL, 'UBASH3A, SH3 domain', 'UBASH3A_SH3', 3, NULL),
(33678, NULL, 'IPR046640', NULL, 'Domain of unknown function DUF6752', 'DUF6752', 3, NULL),
(33679, NULL, 'IPR039510', NULL, 'Vint domain', 'Vint_dom', 3, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(33680, NULL, 'IPR046626', NULL, 'Domain of unknown function DUF6738', 'DUF6738', 3, NULL),
(33681, NULL, 'IPR034845', NULL, 'hnRNP A1, RNA recognition motif 1', 'hnRNPA1_RRM1', 3, NULL),
(33682, NULL, 'IPR042786', NULL, 'PDZD7, Harmonin N-like domain', 'PDZD7_HN-like', 3, NULL),
(33683, NULL, 'IPR038523', NULL, 'AmiS/UreI transporter superfamily', 'AmiSUreI_transpt_sf', 5, NULL),
(33684, NULL, 'IPR038534', NULL, 'Rtr1/RPAP2 domain superfamily', 'Rtr1/RPAP2_sf', 5, NULL),
(33685, NULL, 'IPR046406', NULL, 'Inner membrane lipoprotein DcrB', 'DcrB', 4, NULL),
(33686, NULL, 'IPR046622', NULL, 'Protein of unknown function DUF6735', 'DUF6735', 4, NULL),
(33687, NULL, 'IPR046816', NULL, 'MmeI-like, DNA-methyltransferase domain', 'MmeI_Mtase', 3, NULL),
(33688, NULL, 'IPR042526', NULL, 'Autophagy protein Atg5, helix rich domain', 'Atg5_HR', 5, NULL),
(33689, NULL, 'IPR038236', NULL, 'GlpG peptidase, N-terminal domain superfamily', 'GlpG_N_sf', 5, NULL),
(33690, NULL, 'IPR046753', NULL, 'Torsin-1A-interacting protein 1/2, AAA+ activator domain', 'TOIP1/2_C', 3, NULL),
(33691, NULL, 'IPR046627', NULL, 'Protein of unknown function DUF6739', 'DUF6739', 4, NULL),
(33692, NULL, 'IPR037598', NULL, 'TFCP2L1, SAM domain', 'TFCP2L1_SAM', 3, NULL),
(33693, NULL, 'IPR046641', NULL, 'Protein of unknown function DUF6753', 'DUF6753', 4, NULL),
(33694, NULL, 'IPR045502', NULL, 'Protein of unknown function DUF6489', 'DUF6489', 4, NULL),
(33695, NULL, 'IPR044782', NULL, 'Sialyltransferase-like protein 1/5', 'SIA1/STLP5', 4, NULL),
(33696, NULL, 'IPR044352', NULL, 'Non-structural protein NSP3, SUD-C domain, bat CoV HKU9-like', 'Nsp3_SUD_C_HKU9_CoV', 3, NULL),
(33697, NULL, 'IPR045782', NULL, 'TrbL/VirB6 plasmid conjugal transfer like protein', 'TrbL_3', 4, NULL),
(33698, NULL, 'IPR033123', NULL, 'Glycosyl hydrolases family 11 (GH11) domain', 'GH11_dom', 3, NULL),
(33699, NULL, 'IPR039986', NULL, 'Cilia- and flagella- associated protein 210', 'CFAP210', 4, NULL),
(33700, NULL, 'IPR034824', NULL, 'Peroxidasin, peroxidase domain', 'Peroxidasin_peroxidase', 3, NULL),
(33701, NULL, 'IPR045031', NULL, 'Dihydropteroate synthase', 'DHP_synth', 4, NULL),
(33702, NULL, 'IPR046825', NULL, 'Prephenate dehydrogenase, dimerization domain', 'PDH_C', 3, NULL),
(33703, NULL, 'IPR039511', NULL, 'RBM26-like, RNA recognition motif 2', 'RBM26-like_RRM2', 3, NULL),
(33704, NULL, 'IPR038535', NULL, 'CCR4-NOT subunit 1, TTP binding domain superfamily', 'CNOT1_TTP_bind_sf', 5, NULL),
(33705, NULL, 'IPR035597', NULL, 'ZO-1, SH3 domain', 'ZO-1_SH3', 3, NULL),
(33706, NULL, 'IPR044154', NULL, 'ADP-ribosylation factor-like protein 8A/8B', 'Arl8a/8b', 4, NULL),
(33707, NULL, 'IPR046620', NULL, 'Protein of unknown function DUF6733', 'DUF6733', 4, NULL),
(33708, NULL, 'IPR044348', NULL, 'Nonstructural protein 10, 1B domain, arterivirus', 'NSP10_1B_Av', 3, NULL),
(33709, NULL, 'IPR043037', NULL, 'CFA/I fimbrial subunit E, adhesin domain', 'CfaE_adhesin', 5, NULL),
(33710, NULL, 'IPR038645', NULL, 'TTC5, OB fold domain superfamily', 'TTC5_OB_sf', 5, NULL),
(33711, NULL, 'IPR046924', NULL, 'CATRA-Associated Small Protein', 'CATASP', 3, NULL),
(33712, NULL, 'IPR033539', NULL, 'Retroviral-like aspartic protease 1', 'Asprv1', 4, NULL),
(33713, NULL, 'IPR046853', NULL, 'PilZN3 domain', 'PilZN3', 3, NULL),
(33714, NULL, 'IPR044152', NULL, 'NADPH dehydrogenase YqjM-like', 'YqjM-like', 4, NULL),
(33715, NULL, 'IPR046647', NULL, 'Protein of unknown function DUF6759', 'DUF6759', 3, NULL),
(33716, NULL, 'IPR046632', NULL, 'Protein of unknown function DUF6744', 'DUF6744', 4, NULL),
(33717, NULL, 'IPR046858', NULL, 'ChrB, N-terminal', 'ChrB_N', 3, NULL),
(33718, NULL, 'IPR046613', NULL, 'Protein of unknown function DUF6726', 'DUF6726', 4, NULL),
(33719, NULL, 'IPR038232', NULL, 'PknH-like extracellular domain superfamily', 'PknH-like_Extracell_sf', 5, NULL),
(33720, NULL, 'IPR046333', NULL, 'Homeobox protein Hox-A10/abdominal-B-like', 'HXA10/ABDB-like', 4, NULL),
(33721, NULL, 'IPR038537', NULL, 'TRAP transporter T-component superfamily', 'TatT_sf', 5, NULL),
(33722, NULL, 'IPR038558', NULL, 'SAS-6, N-terminal domain superfamily', 'SAS-6_N_sf', 5, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(33723, NULL, 'IPR043448', NULL, 'Pleckstrin homology domain-containing family O member 1/2', 'PKHO1/2', 4, NULL),
(33724, NULL, 'IPR038667', NULL, 'XkdH-like superfamily', 'XkdH-like_sf', 5, NULL),
(33725, NULL, 'IPR046631', NULL, 'Domain of unknown function DUF6743', 'DUF6743', 3, NULL),
(33726, NULL, 'IPR046598', NULL, 'Protein of unknown function DUF6657', 'DUF6657', 4, NULL),
(33727, NULL, 'IPR046785', NULL, 'SrpA-like, SigLec-like domain', 'SrpA-like_SigLec-like_dom', 3, NULL),
(33728, NULL, 'IPR044509', NULL, 'CRIB domain-containing protein RIC2/4', 'RIC2/4', 4, NULL),
(33729, NULL, 'IPR046754', NULL, 'Torsin-1A-interacting protein 1/2, N-terminal', 'TOIP1/2_N', 3, NULL),
(33730, NULL, 'IPR046812', NULL, 'RNA-directed RNA polymerase, palm domain superfamily, Birnavirus', 'Birnavirus_RdRp_palm_sf', 5, NULL),
(33731, NULL, 'IPR045889', NULL, 'Methylesterase/Alpha-hydroxynitrile lyase', 'MES/HNL', 4, NULL),
(33732, NULL, 'IPR046581', NULL, 'Protein of unknown function DUF6641', 'DUF6641', 4, NULL),
(33733, NULL, 'IPR045684', NULL, 'Protein of unknown function DUF6191', 'DUF6191', 4, NULL),
(33734, NULL, 'IPR046393', NULL, 'Bacteriophage T4 DnaB-like replicative helicase', 'Helic_T4', 4, NULL),
(33735, NULL, 'IPR043476', NULL, 'Yro2-like,  7TM domain', 'Yro2-like_7TM', 3, NULL),
(33736, NULL, 'IPR038231', NULL, 'MepB-like superfamily', 'MepB-like_sf', 5, NULL),
(33737, NULL, 'IPR039560', NULL, 'Potyviral polyprotein protein 3', 'Potyvirid-P3', 3, NULL),
(33738, NULL, 'IPR046582', NULL, 'Protein of unknown function DUF6630', 'DUF6630', 4, NULL),
(33739, NULL, 'IPR043578', NULL, 'Glutamate synthase large subunit-like protein, archaeal type', 'GltB_archl_type', 4, NULL),
(33740, NULL, 'IPR046607', NULL, 'Protein of unknown function DUF6666', 'DUF6666', 4, NULL),
(33741, NULL, 'IPR044344', NULL, 'Nucleocapsid (N) protein, C-terminal domain, coronavirus', 'N_prot_C_CoV', 3, NULL),
(33742, NULL, 'IPR046783', NULL, 'Helix-turn-helix protein, archaea', 'HTH_63', 4, NULL),
(33743, NULL, 'IPR042137', NULL, 'Vertebrate SNX3,  PX domain', 'PX_SNX3_Vert', 3, NULL),
(33744, NULL, 'IPR046824', NULL, 'Mitochondrial splicing suppressor 51-like, C-terminal domain', 'Mss51-like_C', 3, NULL),
(33745, NULL, 'IPR046460', NULL, 'Protein UNC80, C-terminal', 'UNC80_C', 3, NULL),
(33746, NULL, 'IPR043246', NULL, 'C10orf82-like', 'C10orf82-like', 4, NULL),
(33747, NULL, 'IPR046574', NULL, 'Protein of unknown function DUF6634', 'DUF6634', 4, NULL),
(33748, NULL, 'IPR046755', NULL, 'V-type proton ATPase subunit S1, luminal domain', 'VAS1_LD', 3, NULL),
(33749, NULL, 'IPR038669', NULL, 'TbpB, N-lobe handle domain superfamily', 'TbpB_N-lobe_sf', 5, NULL),
(33750, NULL, 'IPR035068', NULL, 'Metalloprotease TldD/PmbA, N-terminal', 'TldD/PmbA_N', 5, NULL),
(33751, NULL, 'IPR044339', NULL, 'Spike (S) protein S1 subunit, N-terminal domain, murine hepatitis virus-like', 'Spike_S1_NTD_MHV-like', 3, NULL),
(33752, NULL, 'IPR042220', NULL, 'NLR family CARD domain-containing protein 4', 'NLRC4', 4, NULL),
(33753, NULL, 'IPR036906', NULL, 'ATPase, V1 complex, subunit F superfamily', 'ATPase_V1_fsu_sf', 5, NULL),
(33754, NULL, 'IPR045872', NULL, 'ADP-ribosylation factor 1-5', 'Arf1-5-like', 4, NULL),
(33755, NULL, 'IPR046638', NULL, 'Protein of unknown function DUF6750', 'DUF6750', 4, NULL),
(33756, NULL, 'IPR039565', NULL, 'Outer membrane lipoprotein BamD-like', 'BamD-like', 3, NULL),
(33757, NULL, 'IPR045670', NULL, 'Domain of unknown function DUF5916', 'DUF5916', 3, NULL),
(33758, NULL, 'IPR046619', NULL, 'Protein of unknown function DUF6732', 'DUF6732', 4, NULL),
(33759, NULL, 'IPR046751', NULL, 'Thioester domain 2', 'TED_2', 3, NULL),
(33760, NULL, 'IPR046925', NULL, 'WD-like domain, fungi', 'WD-like_fungi', 3, NULL),
(33761, NULL, 'IPR046817', NULL, 'MmeI-like, N-terminal domain', 'MmeI_N', 3, NULL),
(33762, NULL, 'IPR046845', NULL, 'Meiosis-specific protein ASY3-like, coiled-coil', 'ASY3-like_CC', 3, NULL),
(33763, NULL, 'IPR038688', NULL, 'Flavivirus polyprotein propeptide superfamily', 'Flavi_propep_sf', 5, NULL),
(33764, NULL, 'IPR046602', NULL, 'Protein of unknown function DUF6661', 'DUF6661', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(33765, NULL, 'IPR038672', NULL, 'Chromophore lyase CpcT/CpeT superfamily', 'CpcT/CpeT_sf', 5, NULL),
(33766, NULL, 'IPR035069', NULL, 'TTHA1013/TTHA0281-like', 'TTHA1013/TTHA0281-like', 5, NULL),
(33767, NULL, 'IPR038648', NULL, 'PHR domain superfamily', 'PHR_sf', 5, NULL),
(33768, NULL, 'IPR038660', NULL, 'OspE-like superfamily', 'OspE-like_sf', 5, NULL),
(33769, NULL, 'IPR042242', NULL, 'Recombination protein O, C-terminal', 'RecO_C', 5, NULL),
(33770, NULL, 'IPR046762', NULL, 'Putative adhesive domain (group 17)', 'pAdhesive_17', 3, NULL),
(33771, NULL, 'IPR042143', NULL, 'BCL10, CARD domain', 'CARD_BCL10', 3, NULL),
(33772, NULL, 'IPR046652', NULL, 'Protein of unknown function DUF6764', 'DUF6764', 4, NULL),
(33773, NULL, 'IPR039591', NULL, 'AP-5 complex subunit mu-1', 'AP5M1', 4, NULL),
(33774, NULL, 'IPR046639', NULL, 'Protein of unknown function DUF6751', 'DUF6751', 4, NULL),
(33775, NULL, 'IPR044354', NULL, 'RNA-dependent RNA polymerase, deltacoronavirus', 'RdRp_deltaCoV', 3, NULL),
(33776, NULL, 'IPR043477', NULL, 'Peptidase C30, domain 3, coronavirus', 'Peptidase_C30_dom3_CoV', 5, NULL),
(33777, NULL, 'IPR042151', NULL, 'IRAK2, death domain', 'Death_IRAK2', 3, NULL),
(33778, NULL, 'IPR037600', NULL, 'Upstream-binding protein 1, SAM domain', 'Ubp1_SAM', 3, NULL),
(33779, NULL, 'IPR037502', NULL, 'CCG-binding protein 1', 'CBP1', 4, NULL),
(33780, NULL, 'IPR037605', NULL, 'Sfmbt, SAM domain', 'Sfmbt_SAM', 3, NULL),
(33781, NULL, 'IPR046767', NULL, 'Putative adhesive domain (group 8)', 'pAdhesive_8', 3, NULL),
(33782, NULL, 'IPR035632', NULL, 'UBASH3B, SH3 domain', 'UBASH3B_SH3', 3, NULL),
(33783, NULL, 'IPR046747', NULL, 'RNAse III-like, virus', 'Mycovirus_RNAse', 3, NULL),
(33784, NULL, 'IPR045862', NULL, 'Nucleotidyltransferase Trf4-like', 'Trf4-like', 4, NULL),
(33785, NULL, 'IPR046604', NULL, 'Protein of unknown function DUF6663', 'DUF6663', 4, NULL),
(33786, NULL, 'IPR046848', NULL, 'E motif', 'E_motif', 7, NULL),
(33787, NULL, 'IPR046791', NULL, 'Polycystin domain', 'Polycystin_dom', 3, NULL),
(33788, NULL, 'IPR046569', NULL, 'Protein of unknown function DUF6723', 'DUF6723', 4, NULL),
(33789, NULL, 'IPR036603', NULL, 'RNA polymerase, RBP11-like subunit', 'RBP11-like', 5, NULL),
(33790, NULL, 'IPR038506', NULL, 'GLE1-like superfamily', 'GLE1-like_sf', 5, NULL),
(33791, NULL, 'IPR039581', NULL, 'Fibronectin type III domain-containing protein 11', 'FNDC11', 4, NULL),
(33792, NULL, 'IPR046823', NULL, 'BLOC-2 complex member HPS6, N-terminal domain', 'HPS6_N', 3, NULL),
(33793, NULL, 'IPR046761', NULL, 'RNA-binding protein Tab2/Atab2, C-terminal', 'Tab2-like_C', 3, NULL),
(33794, NULL, 'IPR046573', NULL, 'Protein of unknown function DUF6633', 'DUF6633', 4, NULL),
(33795, NULL, 'IPR046760', NULL, 'RNA-binding protein Tab2-like, N-terminal', 'Tab2-like_N', 3, NULL),
(33796, NULL, 'IPR038244', NULL, 'Rhomboid protease, N-terminal domain superfamily', 'NRho_sf', 5, NULL),
(33797, NULL, 'IPR046903', NULL, 'Mab-21-like, nucleotidyltransferase domain', 'Mab-21-like_nuc_Trfase', 3, NULL),
(33798, NULL, 'IPR046822', NULL, 'BLOC-2 complex member HPS6, C-terminal domain', 'HPS6_C', 3, NULL),
(33799, NULL, 'IPR046808', NULL, 'Double strand break localizing Dbl7', 'Dbl7', 4, NULL),
(33800, NULL, 'IPR039597', NULL, 'Myosin phosphatase-RhoA interacting protein, PH domain', 'M-RIP_PH', 3, NULL),
(33801, NULL, 'IPR039574', NULL, 'Opioid growth factor receptor', 'OGFr', 4, NULL),
(33802, NULL, 'IPR038666', NULL, 'Bacteriophage SPP1, head-tail adaptor superfamily', 'SSP1_head-tail_sf', 5, NULL),
(33803, NULL, 'IPR045867', NULL, 'DNA-directed RNA polymerase, subunit beta-prime', 'DNA-dir_RpoC_beta_prime', 4, NULL),
(33804, NULL, 'IPR046644', NULL, 'Protein of unknown function DUF6756', 'DUF6756', 4, NULL),
(33805, NULL, 'IPR039512', NULL, 'RCHY1, zinc-ribbon', 'RCHY1_zinc-ribbon', 3, NULL),
(33806, NULL, 'IPR042107', NULL, 'DNA-directed RNA polymerase, beta subunit, external 1 domain superfamily', 'DNA-dir_RNA_pol_bsu_ext_1_sf', 5, NULL),
(33807, NULL, 'IPR046850', NULL, 'Nuclear speckle splicing regulatory protein 1, RS-like domain', 'NRP1_C', 3, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(33808, NULL, 'IPR044336', NULL, 'SF1 helicase, zinc-binding domain, tornidovirus', 'SF1_Hel_ZBD_tv', 3, NULL),
(33809, NULL, 'IPR042138', NULL, 'Fungal SNX3, PX domain', 'PX_Grd19_PX', 3, NULL),
(33810, NULL, 'IPR039198', NULL, 'Srl3/Whi5', 'Srl3/Whi5', 4, NULL),
(33811, NULL, 'IPR039995', NULL, 'Uncharacterized protein C6orf226-like', 'C6orf226-like', 4, NULL),
(33812, NULL, 'IPR046586', NULL, 'Domain of unknown function DUF6644', 'DUF6644', 3, NULL),
(33813, NULL, 'IPR039587', NULL, 'TMEM248/TMEM219 domain', 'TMEM248/TMEM219_dom', 3, NULL),
(33814, NULL, 'IPR046405', NULL, 'Guanosine-inosine kinase', 'IngK', 4, NULL),
(33815, NULL, 'IPR046451', NULL, 'Homogentisate 1,2-dioxygenase, C-terminal domain', 'HgmA_C', 3, NULL),
(33816, NULL, 'IPR043581', NULL, 'Axin-like', 'Axin-like', 4, NULL),
(33817, NULL, 'IPR046615', NULL, 'Protein of unknown function DUF6728', 'DUF6728', 4, NULL),
(33818, NULL, 'IPR042527', NULL, 'Autophagy protein Atg5, UblA domain', 'Atg5_UblA_dom', 5, NULL),
(33819, NULL, 'IPR046618', NULL, 'Protein of unknown function DUF6731', 'DUF6731', 4, NULL),
(33820, NULL, 'IPR035207', NULL, 'Protein of unknown function DUF5457', 'DUF5457', 4, NULL),
(33821, NULL, 'IPR043451', NULL, 'Myocardin-like', 'Myocardin-like', 4, NULL),
(33822, NULL, 'IPR046849', NULL, 'E+ motif', 'Eplus_motif', 7, NULL),
(33823, NULL, 'IPR043225', NULL, 'BTBD8, BACK domain', 'BACK_BTBD8', 3, NULL),
(33824, NULL, 'IPR043450', NULL, 'Coiled-coil domain-containing protein 89-like', 'CCDC89-like', 4, NULL),
(33825, NULL, 'IPR046768', NULL, 'Exodeoxyribonuclease X-like, C-terminal', 'ExoX-like_C', 3, NULL),
(33826, NULL, 'IPR046577', NULL, 'Protein of unknown function DUF6637', 'DUF6637', 4, NULL),
(33827, NULL, 'IPR036598', NULL, 'GOLD domain superfamily', 'GOLD_dom_sf', 5, NULL),
(33828, NULL, 'IPR046623', NULL, 'Domain of unknown function DUF6536', 'DUF6536', 3, NULL),
(33829, NULL, 'IPR034846', NULL, 'hnRNPAB, RNA recognition motif 1', 'hnRNPAB_RRM1', 3, NULL),
(33830, NULL, 'IPR038496', NULL, 'Rad61, Wapl domain superfamily', 'Rad61_Wapl_sf', 5, NULL),
(33831, NULL, 'IPR046814', NULL, 'RNA-directed RNA polymerase, C-terminal domain superfamily, Avibirnavirus', 'Avibirnavurs_RdRp_C_sf', 5, NULL),
(33832, NULL, 'IPR039991', NULL, 'Protein shortage in chiasmata 1 ortholog', 'SHOC1', 4, NULL),
(33833, NULL, 'IPR035601', NULL, 'MPP5, SH3 domain', 'MPP5_SH3', 3, NULL),
(33834, NULL, 'IPR038228', NULL, 'Syd superfamily', 'Syd_sf', 5, NULL),
(33835, NULL, 'IPR042238', NULL, 'DNA excision repair protein Rad28/ERCC8/Ckn1/ATCSA-1', 'Rad28/ERCC8/Ckn1/ATCSA-1', 4, NULL),
(33836, NULL, 'IPR039057', NULL, 'Sporulation-specific protein 22/ZIP4', 'Spo22/ZIP4', 4, NULL),
(33837, NULL, 'IPR038661', NULL, 'Ribosomal protein L35A superfamily', 'L35A_sf', 5, NULL),
(33838, NULL, 'IPR045854', NULL, 'Nitrite and sulphite reductase 4Fe-4S domain-like superfamily', 'NO2/SO3_Rdtase_4Fe4S_sf', 5, NULL),
(33839, NULL, 'IPR046628', NULL, 'Protein of unknown function DUF6740', 'DUF6740', 4, NULL),
(33840, NULL, 'IPR042494', NULL, 'E3 ubiquitin-protein ligase RNF103', 'RNF103', 4, NULL),
(33841, NULL, 'IPR046584', NULL, 'Protein of unknown function DUF6642', 'DUF6642', 4, NULL),
(33842, NULL, 'IPR042540', NULL, 'Viral matrix protein, N-terminal domain', 'Matrix_N', 5, NULL),
(33843, NULL, 'IPR033310', NULL, 'Mms4/EME1/EME2', 'Mms4/EME1/EME2', 4, NULL),
(33844, NULL, 'IPR045505', NULL, 'Protein of unknown function DUF6486', 'DUF6486', 4, NULL),
(33845, NULL, 'IPR035631', NULL, 'Nebulette, SH3 domain', 'Nebulette_SH3', 3, NULL),
(33846, NULL, 'IPR046758', NULL, 'Sey1/RHD3-like, three-helix bundle domain', 'Sey1/RHD3-like_3HB', 3, NULL),
(33847, NULL, 'IPR042770', NULL, 'RWD domain-containing protein 4', 'RWDD4', 4, NULL),
(33848, NULL, 'IPR044380', NULL, 'Spike (S) protein S1 subunit, receptor-binding domain, HEV', 'Spike_S1_RBD_HEV', 3, NULL),
(33849, NULL, 'IPR046790', NULL, 'KBTB, W-type LIR motif', 'KBTB_W-LIR', 2, NULL),
(33850, NULL, 'IPR046900', NULL, 'ABC-three component system, Middle Component 7', 'ABC-3C_MC7', 4, NULL),
(33851, NULL, 'IPR039513', NULL, 'PL-6 family', 'PL-6', 4, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(33852, NULL, 'IPR046595', NULL, 'Protein of unknown function DUF6653', 'DUF6653', 4, NULL),
(33853, NULL, 'IPR046588', NULL, 'Protein of unknown function DUF6646', 'DUF6646', 4, NULL),
(33854, NULL, 'IPR038668', NULL, 'Lipid-binding superfamily', 'Lipid-bd_sf', 5, NULL),
(33855, NULL, 'IPR038923', NULL, 'Centrobin', 'Centrobin', 4, NULL),
(33856, NULL, 'IPR042301', NULL, 'Glycosyl hydrolase 115 superfamily', 'GH115_sf', 5, NULL),
(33857, NULL, 'IPR046571', NULL, 'Protein of unknown function DUF6725', 'DUF6725', 4, NULL),
(33858, NULL, 'IPR046909', NULL, 'Cyclic-phosphate processing, Receiver domain', 'cREC_REC', 3, NULL),
(33859, NULL, 'IPR042144', NULL, 'IPS1, CARD domain', 'CARD_IPS1', 3, NULL),
(33860, NULL, 'IPR038242', NULL, 'CRISPR-Cas system, Cmr2 subunit, D1 domain, cysteine cluster', 'Cmr2_N', 5, NULL),
(33861, NULL, 'IPR046892', NULL, 'Cysteine-rich domain, C-terminal to E2 domain', 'E2-Crich', 3, NULL),
(33862, NULL, 'IPR046806', NULL, 'MrpA C-terminal/MbhE', 'MrpA_C/MbhE', 3, NULL),
(33863, NULL, 'IPR038223', NULL, 'DNA-mimic protein DMP12 superfamily', 'DMP12_sf', 5, NULL),
(33864, NULL, 'IPR042541', NULL, 'BART domain superfamily', 'BART_sf', 5, NULL),
(33865, NULL, 'IPR046576', NULL, 'Protein of unknown function DUF6636', 'DUF6636', 4, NULL),
(33866, NULL, 'IPR046625', NULL, 'Protein of unknown function DUF6737', 'DUF6737', 3, NULL),
(33867, NULL, 'IPR035067', NULL, 'V-type ATPase subunit C/d', 'V-type_ATPase_suC/d', 5, NULL),
(33868, NULL, 'IPR045420', NULL, 'Domain of unknown function DUF5901', 'DUF5901', 3, NULL),
(33869, NULL, 'IPR039600', NULL, 'TANGO6/Rtp1', 'TANGO6/Rtp1', 4, NULL),
(33870, NULL, 'IPR033541', NULL, 'Dermokine', 'Dermokine', 4, NULL),
(33871, NULL, 'IPR042239', NULL, 'Nop, C-terminal domain', 'Nop_C', 5, NULL),
(33872, NULL, 'IPR042244', NULL, 'HypD, domain 2', 'HypD_2_sf', 5, NULL),
(33873, NULL, 'IPR046587', NULL, 'Domain of unknown function DUF6645', 'DUF6645', 3, NULL),
(33874, NULL, 'IPR044337', NULL, 'Spike (S) protein S1 subunit, N-terminal domain, MERS-CoV-like', 'Spike_S1_N_MERS-CoV-like', 3, NULL),
(33875, NULL, 'IPR045633', NULL, 'Protein of unknown function DUF6414', 'DUF6414', 4, NULL),
(33876, NULL, 'IPR038502', NULL, 'Peptidase M1, LTA-4 hydrolase/aminopeptidase, C-terminal domain superfamily', 'M1_LTA-4_hydro/amino_C_sf', 5, NULL),
(33877, NULL, 'IPR038680', NULL, 'PAW domain superfamily', 'PAW_sf', 5, NULL),
(33878, NULL, 'IPR037501', NULL, 'Protein TPLATE', 'TPLATE', 4, NULL),
(33879, NULL, 'IPR035629', NULL, 'Nebulin, SH3 domain', 'Nebulin_SH3', 3, NULL),
(33880, NULL, 'IPR046769', NULL, 'DOCKER, Lobe A', 'DOCKER_Lobe_A', 3, NULL),
(33881, NULL, 'IPR042453', NULL, 'WD repeat-containing protein 53', 'WDR53', 4, NULL),
(33882, NULL, 'IPR046645', NULL, 'Protein of unknown function DUF6757', 'DUF6757', 4, NULL),
(33883, NULL, 'IPR038547', NULL, 'CBP/p300, atypical RING domain superfamily', 'RING_CBP-p300_sf', 5, NULL),
(33884, NULL, 'IPR042243', NULL, 'HypD, domain 1', 'HypD_1', 5, NULL),
(33885, NULL, 'IPR038499', NULL, 'BRO1 domain superfamily', 'BRO1_sf', 5, NULL),
(33886, NULL, 'IPR045378', NULL, 'Apolipoprotein N-acyltransferase, N-terminal', 'LNT_N', 3, NULL),
(33887, NULL, 'IPR046629', NULL, 'Domain of unknown function DUF6741', 'DUF6741', 3, NULL),
(33888, NULL, 'IPR046442', NULL, 'NSP1, C-terminal domain, betacoronavirus', 'bCoV_NSP1_C', 3, NULL),
(33889, NULL, 'IPR046389', NULL, 'Sliding clamp', 'Sliding_clamp_T4', 4, NULL),
(33890, NULL, 'IPR044149', NULL, 'Nitrilase/Cyanide hydratase', 'Nitrilases_CHs', 4, NULL),
(33891, NULL, 'IPR038362', NULL, 'VP9, N-terminal domain superfamily', 'VP9_N_sf', 5, NULL),
(33892, NULL, 'IPR038212', NULL, 'Transcription factor EnY2 superfamily', 'TF_EnY2_sf', 5, NULL),
(33893, NULL, 'IPR042225', NULL, 'Negative cofactor 2 complex subunit beta', 'Ncb2', 4, NULL),
(33894, NULL, 'IPR035488', NULL, 'Fructosamine deglycase FrlB, SIS domain 1', 'FrlB_SIS', 3, NULL),
(33895, NULL, 'IPR042452', NULL, 'ZPR1, zinc finger domain', 'ZPR1_Znf1/2', 5, NULL),
(33896, NULL, 'IPR038361', NULL, '2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-succinyltransferase, middle domain superfamily', 'THDPS_M_sf', 5, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(33897, NULL, 'IPR042154', NULL, 'UNC5C, death domain', 'Death_UNC5C', 3, NULL),
(33898, NULL, 'IPR046580', NULL, 'Protein of unknown function DUF6640', 'DUF6640', 4, NULL),
(33899, NULL, 'IPR046772', NULL, 'Putative adhesive domain (group 6)', 'pAdhesive_6', 3, NULL),
(33900, NULL, 'IPR044269', NULL, 'Terminase, large subunit SPP1-like', 'Terminase_large_su_SPP1-like', 4, NULL),
(33901, NULL, 'IPR037391', NULL, 'Polyamine-modulated factor 1-binding protein 1', 'PMF1-bd', 4, NULL),
(33902, NULL, 'IPR045655', NULL, 'Protein of unknown function DUF6394', 'DUF6394', 4, NULL),
(33903, NULL, 'IPR046612', NULL, 'Domain of unknown function DUF6671', 'DUF6671', 3, NULL),
(33904, NULL, 'IPR038238', NULL, 'Clp1, C-terminal domain superfamily', 'Clp1_C_sf', 5, NULL),
(33905, NULL, 'IPR046583', NULL, 'Protein of unknown function DUF6631', 'DUF6631', 4, NULL),
(33906, NULL, 'IPR045245', NULL, 'Pre-mRNA 3'' end processing protein Pfs2-like', 'Pfs2-like', 4, NULL),
(33907, NULL, 'IPR046851', NULL, 'Neurobeachin, beta-propeller domain', 'NBCH_WD40', 3, NULL),
(33908, NULL, 'IPR042226', NULL, 'eRF1, domain 2 superfamily', 'eFR1_2_sf', 5, NULL),
(33909, NULL, 'IPR037599', NULL, 'Transcription factor CP2, SAM domain', 'TFCP2_SAM', 3, NULL),
(33910, NULL, 'IPR037509', NULL, 'Phosphomethylpyrimidine synthase', 'ThiC', 4, NULL),
(33911, NULL, 'IPR046594', NULL, 'Protein of unknown function DUF6652', 'DUF6652', 4, NULL),
(33912, NULL, 'IPR044617', NULL, 'Tetrachlorohydroquinone dehalogenase', 'TCHQD', 4, NULL),
(33913, NULL, 'IPR046901', NULL, 'ABC-three component system, Middle Component 5', 'ABC-3C_MC5', 4, NULL),
(33914, NULL, 'IPR046840', NULL, 'Sporulation stage IV protein A, C-terminal', 'SpoIVA_C', 3, NULL),
(33915, NULL, 'IPR034821', NULL, 'Dual oxidase, peroxidase domain', 'DUOX_peroxidase', 3, NULL),
(33916, NULL, 'IPR046841', NULL, 'Stage IV sporulation protein A, middle domain', 'SpoIVA_middle', 3, NULL),
(33917, NULL, 'IPR043104', NULL, 'Putative mobile pathogenicity island, N-terminal domain', 'SAPI_N', 5, NULL),
(33918, NULL, 'IPR046643', NULL, 'Protein of unknown function DUF6755', 'DUF6755', 4, NULL),
(33919, NULL, 'IPR046603', NULL, 'Protein of unknown function DUF6662', 'DUF6662', 4, NULL),
(33920, NULL, 'IPR044342', NULL, 'Orf10 protein, SARS-CoV-2', 'Orf10_SARS-CoV-2', 4, NULL),
(33921, NULL, 'IPR046855', NULL, 'Isocitrate dehydrogenase kinase/phosphatase (AceK), kinase domain', 'AceK_kinase', 3, NULL),
(33922, NULL, 'IPR038214', NULL, 'WPP domain superfamily', 'WPP_sf', 5, NULL),
(33923, NULL, 'IPR038550', NULL, 'GPCR, family 3, nine cysteines domain superfamily', 'GPCR_3_9-Cys_sf', 5, NULL),
(33924, NULL, 'IPR038511', NULL, 'TAP42/TAP46-like superfamily', 'TAP42/TAP46-like_sf', 5, NULL),
(33925, NULL, 'IPR046756', NULL, 'V-type proton ATPase subunit S1/VOA1, transmembrane domain', 'VAS1/VOA1_TM', 3, NULL),
(33926, NULL, 'IPR044350', NULL, 'RNA-dependent RNA polymerase, Middle East respiratory syndrome-related coronavirus', 'RdRp_MERS-CoV-like', 3, NULL),
(33927, NULL, 'IPR033757', NULL, 'Pre-mRNA-splicing regulator WTAP', 'WTAP', 4, NULL),
(33928, NULL, 'IPR038239', NULL, 'Clp1, N-terminal beta-sandwich domain superfamily', 'Clp1_N_sf', 5, NULL),
(33929, NULL, 'IPR045082', NULL, 'ATP synthase, F0 complex, subunit A, bacterial/chloroplast', 'ATP_syn_F0_a_bact/chloroplast', 4, NULL),
(33930, NULL, 'IPR038219', NULL, 'Selenoprotein F/M, thioredoxin-like domain superfamily', 'Sep15/SelM_sf', 5, NULL),
(33931, NULL, 'IPR038533', NULL, 'UpxZ superfamily', 'UpxZ_sf', 5, NULL),
(33932, NULL, 'IPR034866', NULL, 'Sequestosome-1, PB1 domain', 'PB1_p62', 3, NULL),
(33933, NULL, 'IPR037510', NULL, '4-hydroxythreonine-4-phosphate dehydrogenase', 'PdxA', 4, NULL),
(33934, NULL, 'IPR043102', NULL, 'Antiactivator protein ExsD, domain 2', 'ExsD_dom2', 5, NULL),
(33935, NULL, 'IPR046642', NULL, 'Domain of unknown function DUF6754', 'DUF6754', 3, NULL),
(33936, NULL, 'IPR046380', NULL, 'Carboxysome shell protein CcmK', 'CcmK', 4, NULL),
(33937, NULL, 'IPR046593', NULL, 'Domain of unknown function DUF6651', 'DUF6651', 3, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(33938, NULL, 'IPR038215', NULL, 'Transposase, Tn5-like, N-terminal domain superfamily', 'TN5-like_N_sf', 5, NULL),
(33939, NULL, 'IPR042141', NULL, 'CARD11, CARD domain', 'CARD_CARD11', 3, NULL),
(33940, NULL, 'IPR046600', NULL, 'Protein of unknown function DUF6659', 'DUF6659', 4, NULL),
(33941, NULL, 'IPR042553', NULL, 'TSC22 domain family protein 4', 'TSC22D4', 4, NULL),
(33942, NULL, 'IPR045671', NULL, 'Nitrogen regulation protein NtrY-like, N-terminal domain', 'NtrY-like_N', 3, NULL),
(33943, NULL, 'IPR039599', NULL, 'RNA-binding protein 48', 'RBM48', 4, NULL),
(33944, NULL, 'IPR036713', NULL, 'TmoB-like superfamily', 'TmoB-like_sf', 5, NULL),
(33945, NULL, 'IPR038509', NULL, 'IFS superfamily', 'IFS_sf', 5, NULL),
(33946, NULL, 'IPR046591', NULL, 'Protein of unknown function DUF6649', 'DUF6649', 4, NULL),
(33947, NULL, 'IPR046889', NULL, 'Small protein from certain CxC ATPase-based DNA modification systems', 'Sp-CxC', 4, NULL),
(33948, NULL, 'IPR038682', NULL, 'YrpD-like superfamily', 'YrpD-like_sf', 5, NULL),
(33949, NULL, 'IPR046570', NULL, 'Protein of unknown function DUF6724', 'DUF6724', 4, NULL),
(33950, NULL, 'IPR045861', NULL, 'CorA, cytoplasmic domain', 'CorA_cytoplasmic_dom', 5, NULL),
(33951, NULL, 'IPR046813', NULL, 'RNA-directed RNA polymerase, thumb domain superfamily, Birnavirus', 'Birnavirus_RdRp_thumb_sf', 5, NULL),
(33952, NULL, 'IPR046773', NULL, 'DOCKER, Lobe C', 'DOCKER_Lobe_C', 3, NULL),
(33953, NULL, 'IPR038226', NULL, 'LMG 18311 protein-like superfamily', 'LMG18311-like_sf', 5, NULL),
(33954, NULL, 'IPR038679', NULL, 'Signal transduction protein PmrD superfamily', 'PmrD_sf', 5, NULL),
(33955, NULL, 'IPR042752', NULL, 'TRIM54, RING finger, HC subclass', 'TRIM54_RING-HC', 3, NULL),
(33956, NULL, 'IPR034847', NULL, 'hnRNP DL, RNA recognition motif 1', 'hnRPDL_RRM1', 3, NULL),
(33957, NULL, 'IPR046888', NULL, 'Prokaryotic YEATS domain', 'pYEATS', 3, NULL),
(33958, NULL, 'IPR046811', NULL, 'RNA-directed RNA polymerase, thumb domain, Flavivirus', 'Flavi_NS5_thumb', 3, NULL),
(33959, NULL, 'IPR046765', NULL, 'Antitoxin-like, ribbon-helix-helix', 'Antitox_RHH', 3, NULL),
(33960, NULL, 'IPR044180', NULL, 'Peptidyl-prolyl cis-trans isomerase FKBP18-like', 'FKBP18-like', 4, NULL),
(33961, NULL, 'IPR046377', NULL, 'DWD HYPERSENSITIVE TO UV-B 1', 'DHU1', 4, NULL),
(33962, NULL, 'IPR045863', NULL, 'CorA, transmembrane region', 'CorA_TM1_TM2', 5, NULL),
(33963, NULL, 'IPR039588', NULL, 'F-box only protein 4', 'FBXO4', 4, NULL),
(33964, NULL, 'IPR046585', NULL, 'Protein of unknown function DUF6643', 'DUF6643', 4, NULL),
(33965, NULL, 'IPR046467', NULL, 'PHL domain', 'PHL_dom', 3, NULL),
(33966, NULL, 'IPR037504', NULL, '[PSI+] induction protein 2', 'PSI_induc_2', 4, NULL),
(33967, NULL, 'IPR046592', NULL, 'Protein of unknown function DUF6650', 'DUF6650', 4, NULL),
(33968, NULL, 'IPR046601', NULL, 'Protein of unknown function DUF6660', 'DUF6660', 4, NULL),
(33969, NULL, 'IPR046839', NULL, 'ABC toxin, N-terminal domain', 'ABC_toxin_N', 3, NULL),
(33970, NULL, 'IPR046614', NULL, 'Protein of unknown function DUF6727', 'DUF6727', 4, NULL),
(33971, NULL, 'IPR038241', NULL, 'Endoribonuclease antitoxin GhoS superfamily', 'GhoS_sf', 5, NULL),
(33972, NULL, 'IPR046770', NULL, 'DOCKER, Lobe B', 'DOCKER_Lobe_B', 3, NULL),
(33973, NULL, 'IPR038676', NULL, 'Photosystem II Psb28, class 1 superfamily', 'Psb28_c1_sf', 5, NULL),
(33974, NULL, 'IPR033312', NULL, 'DNA damage-binding protein 2', 'DDB2', 4, NULL),
(33975, NULL, 'IPR038216', NULL, 'SATB, CUTL domain superfamily', 'SATB_CUTL_sf', 5, NULL),
(33976, NULL, 'IPR038211', NULL, 'Ant venom allergen, Sol i 2/4 superfamily', 'Ant_venon_allerg_soli_2/4_sf', 5, NULL),
(33977, NULL, 'IPR046597', NULL, 'Protein of unknown function DUF6656', 'DUF6656', 4, NULL),
(33978, NULL, 'IPR038247', NULL, 'Jag, N-terminal domain superfamily', 'Jag_N_dom_sf', 5, NULL),
(33979, NULL, 'IPR046648', NULL, 'Domain of unknown function DUF6760', 'DUF6760', 3, NULL),
(33980, NULL, 'IPR046452', NULL, 'Homogentisate 1,2-dioxygenase, N-terminal domain', 'HgmA_N', 3, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(33981, NULL, 'IPR039563', NULL, 'Peptidase C39 single domain protein', 'Peptidase_C39_single_dom', 3, NULL),
(33982, NULL, 'IPR046786', NULL, 'Motility protein A, N-terminal', 'MotA_N', 3, NULL),
(33983, NULL, 'IPR046890', NULL, 'YEATS-Like-Associating Three TM', 'YLATT', 3, NULL),
(33984, NULL, 'IPR035635', NULL, 'Ephexin-1, SH3 domain', 'Ephexin-1_SH3', 3, NULL),
(33985, NULL, 'IPR042156', NULL, 'UNC5B, death domain', 'Death_UNC5B', 3, NULL),
(33986, NULL, 'IPR046835', NULL, 'Retrotransposon hot spot protein, N-terminal', 'RHS_N', 3, NULL),
(33987, NULL, 'IPR042451', NULL, 'ZPR1, A/B domain', 'ZPR1_A/B_dom', 5, NULL),
(33988, NULL, 'IPR035630', NULL, 'Lasp1, SH3 domain', 'Lasp1_SH3', 3, NULL),
(33989, NULL, 'IPR046578', NULL, 'Protein of unknown function DUF6638', 'DUF6638', 4, NULL),
(33990, NULL, 'IPR046771', NULL, 'Putative adhesive domain (group 11)', 'pAdhesive_11', 3, NULL),
(33991, NULL, 'IPR045881', NULL, 'METABOLIC NETWORK MODULATOR 1-like', 'MNM1-like', 4, NULL),
(33992, NULL, 'IPR035600', NULL, 'MPP4, SH3 domain', 'MPP4_SH3', 3, NULL),
(33993, NULL, 'IPR038542', NULL, 'Spidroin, C-terminal domain superfamily', 'Spidroin_C_sf', 5, NULL),
(33994, NULL, 'IPR039598', NULL, 'HMG domain-containing protein 3', 'HMGXB3', 4, NULL),
(33995, NULL, 'IPR046459', NULL, 'Capsule biosynthesis GfcC-like, N-terminal', 'Caps_syn_GfcC_N', 3, NULL),
(33996, NULL, 'IPR043150', NULL, 'Phytochrome, PHY domain superfamily', 'Phytochrome_PHY_sf', 5, NULL),
(33997, NULL, 'IPR045885', NULL, 'N-acetylgalactosaminyltransferase', 'GalNAc-T', 3, NULL),
(33998, NULL, 'IPR039335', NULL, 'Sigma factor binding protein 1/2', 'SIB1/2', 4, NULL),
(33999, NULL, 'IPR042142', NULL, 'CARD9, CARD domain', 'CARD_CARD9', 3, NULL),
(34000, NULL, 'IPR035209', NULL, 'Floricaula/leafy, DNA-binding C-terminal domain', 'FLO/LFY_C', 3, NULL),
(34001, NULL, 'IPR044901', NULL, 'Malto-oligosyltrehalose trehalohydrolase, E-set domain superfamily', 'Trehalose_TreZ_E-set_sf', 5, NULL),
(34002, NULL, 'IPR044902', NULL, 'Dinoflagellate luciferase repeat', 'Dino_Luciferase_rpt_sf', 5, NULL),
(34003, NULL, 'IPR045619', NULL, 'Domain of unknown function DUF6443', 'DUF6443', 3, NULL),
(34004, NULL, 'IPR042759', NULL, 'Coiled-coil domain-containing protein 126', 'CCDC126', 4, NULL),
(34005, NULL, 'IPR044289', NULL, 'RING-H2 finger protein ATL67-70', 'ATL67-70', 4, NULL),
(34006, NULL, 'IPR043118', NULL, 'Restriction endonuclease, type II SfiI, domain 1', 'Restrct_endonuc_II_SfiI_dom1', 5, NULL),
(34007, NULL, 'IPR044473', NULL, 'Staufen 2, third double-stranded RNA binding domain', 'STAU2_DSRM_3', 3, NULL),
(34008, NULL, 'IPR044680', NULL, 'Protein EXECUTER 1/2', 'EX1/2', 4, NULL),
(34009, NULL, 'IPR045184', NULL, 'WD40 repeat-containing protein SMU1', 'SMU1', 4, NULL),
(34010, NULL, 'IPR044820', NULL, 'ADP-ribosylation factor GTPase-activating protein AGD14-like', 'AGD14-like', 4, NULL),
(34011, NULL, 'IPR043000', NULL, 'Chromobox protein homolog 7', 'CBX7', 4, NULL),
(34012, NULL, 'IPR044109', NULL, 'cAMP-dependent protein kinase catalytic subunit', 'STKc_PKA', 4, NULL),
(34013, NULL, 'IPR042792', NULL, 'Myb/SANT-like DNA-binding domain-containing protein 2', 'MSANTD2', 4, NULL),
(34014, NULL, 'IPR043452', NULL, 'Plant bZIP transcription factors', 'BZIP46-like', 4, NULL),
(34015, NULL, 'IPR044679', NULL, 'PWWP domain containing protein PWWP2-like', 'PWWP2-like', 4, NULL),
(34016, NULL, 'IPR046856', NULL, 'Gem-associated protein 6, C-terminal domain', 'Gemin6_C', 3, NULL),
(34017, NULL, 'IPR044824', NULL, 'Protein MAINTENANCE OF MERISTEMS-like', 'MAIN-like', 4, NULL),
(34018, NULL, 'IPR045737', NULL, 'E3 ubiquitin-protein ligase RKP, N-terminal', 'RKP_N', 3, NULL),
(34019, NULL, 'IPR043318', NULL, 'Killer cell lectin-like receptor subfamily G member 2', 'KLRG2', 4, NULL),
(34020, NULL, 'IPR046826', NULL, 'Prephenate dehydrogenase, nucleotide-binding domain', 'PDH_N', 3, NULL),
(34021, NULL, 'IPR045870', NULL, 'TryX and NRX, thioredoxin domain', 'TryX_NRX_thioredoxin_dom', 3, NULL),
(34022, NULL, 'IPR046364', NULL, 'Exocyst complex subunit Exo70, C-terminal', 'Exo70_C', 3, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(34023, NULL, 'IPR044700', NULL, 'PIP2/PIPL1', 'PIP2/PIPL1', 4, NULL),
(34024, NULL, 'IPR043850', NULL, 'Protein of unknown function DUF5812', 'DUF5812', 4, NULL),
(34025, NULL, 'IPR043868', NULL, 'Protein of unknown function DUF5828', 'DUF5828', 4, NULL),
(34026, NULL, 'IPR046935', NULL, 'DNA helicase E1, DNA-binding domain superfamily, papillomavirus', 'PPV_E1_DBD_sf', 5, NULL),
(34027, NULL, 'IPR046926', NULL, 'GREB1, N-terminal domain', 'GREB1_N', 3, NULL),
(34028, NULL, 'IPR045732', NULL, 'Protein of unknown function DUF6086', 'DUF6086', 4, NULL),
(34029, NULL, 'IPR042269', NULL, 'Serine carboxypeptidase S28, SKS domain', 'Ser_carbopepase_S28_SKS', 5, NULL),
(34030, NULL, 'IPR045182', NULL, 'Protein JINGUBANG-like', 'JINGUBANG-like', 4, NULL),
(34031, NULL, 'IPR045909', NULL, 'Mitochondrial dynamics protein MID49/MID51', 'MID49/MID51', 4, NULL),
(34032, NULL, 'IPR042815', NULL, 'Dynein regulatory complex protein 10', 'DRC10', 4, NULL),
(34033, NULL, 'IPR043540', NULL, 'E3 ubiquitin-protein ligase RING1/RING2', 'RING1/RING2', 4, NULL),
(34034, NULL, 'IPR043408', NULL, 'IQ domain-containing protein K', 'IQCK', 4, NULL),
(34035, NULL, 'IPR043709', NULL, 'Repeats of unknown function DUF5649', 'DUF5649', 7, NULL),
(34036, NULL, 'IPR043887', NULL, 'Protein of unknown function DUF5845', 'DUF5845', 4, NULL),
(34037, NULL, 'IPR045720', NULL, 'Protein of unknown function DUF6074', 'DUF6074', 4, NULL),
(34038, NULL, 'IPR045727', NULL, 'Protein of unknown function DUF6081', 'DUF6081', 4, NULL),
(34039, NULL, 'IPR045724', NULL, 'Protein of unknown function DUF6078', 'DUF6078', 4, NULL),
(34040, NULL, 'IPR045604', NULL, 'Protein of unknown function DUF6453', 'DUF6453', 4, NULL),
(34041, NULL, 'IPR045609', NULL, 'Domain of unknown function DUF6451', 'DUF6451', 3, NULL),
(34042, NULL, 'IPR042267', NULL, 'VTC domain superfamily', 'VTC_sf', 5, NULL),
(34043, NULL, 'IPR045606', NULL, 'Protein SET DOMAIN GROUP 2, C-terminal', 'SDG2_C', 3, NULL),
(34044, NULL, 'IPR045288', NULL, 'Membrane protein At1g75140-like', 'At1g75140-like', 4, NULL),
(34045, NULL, 'IPR042433', NULL, 'Allograft inflammatory factor 1', 'AIF1/AIF1L', 4, NULL),
(34046, NULL, 'IPR045014', NULL, 'Transmembrane protein 41A/B', 'TM41A/B', 4, NULL),
(34047, NULL, 'IPR043875', NULL, 'Domain of unknown function DUF5857', 'DUF5857', 3, NULL),
(34048, NULL, 'IPR045112', NULL, 'Protein Peter Pan-like', 'PPAN-like', 4, NULL),
(34049, NULL, 'IPR043325', NULL, 'Alpha-Amylase Inhibitors (AAI), Lipid Transfer (LT) and Seed Storage (SS) Protein', 'LTSS', 4, NULL),
(34050, NULL, 'IPR043264', NULL, 'Ring-hydroxylating dioxygenase, large/alpha subunit AhdA1c-like, C-terminal', 'AhdA1c-like_alpha_C', 3, NULL),
(34051, NULL, 'IPR045168', NULL, 'YTH domain containing protein', 'YTH_prot', 4, NULL),
(34052, NULL, 'IPR043086', NULL, 'EME1, nuclease domain, subdomain 1', 'EME1_nucdom_sub1', 5, NULL),
(34053, NULL, 'IPR042917', NULL, 'Homeobox protein MIXL1', 'MIXL1', 4, NULL),
(34054, NULL, 'IPR043239', NULL, 'Small integral membrane protein 29', 'SMIM29', 4, NULL),
(34055, NULL, 'IPR042761', NULL, 'CDK15, catalytic domain', 'CDK15_STKc', 3, NULL),
(34056, NULL, 'IPR046750', NULL, 'RNA-directed RNA polymerase, C-terminal, birnavirus', 'Birnavirus_RdRp_C', 3, NULL),
(34057, NULL, 'IPR043737', NULL, 'Family of unknown function DUF5682', 'DUF5682', 4, NULL),
(34058, NULL, 'IPR044591', NULL, 'Microtubule-associated kinase-like protein RUNKEL', 'RUK', 4, NULL),
(34059, NULL, 'IPR043090', NULL, 'Low molecular weight S layer protein, N-terminal, subdomain', 'Low_molc_weight_S-layer_N_sub', 5, NULL),
(34060, NULL, 'IPR045186', NULL, 'Indole-3-glycerol phosphate synthase', 'Indole-3-glycerol_P_synth', 4, NULL),
(34061, NULL, 'IPR043736', NULL, 'Domain of unknown function DUF5681', 'DUF5681', 3, NULL),
(34062, NULL, 'IPR043425', NULL, 'NusG-like', 'NusG-like', 4, NULL),
(34063, NULL, 'IPR042425', NULL, 'Protein APCDD1', 'APCDD1', 4, NULL),
(34064, NULL, 'IPR043894', NULL, '6-phospho-N-acetylmuramidase, C-terminal', 'MupG_C', 3, NULL),
(34065, NULL, 'IPR045621', NULL, 'ABC transporter type 1, GsiC-like, N-terminal domain', 'BPD_transp_1_N', 3, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(34066, NULL, 'IPR044844', NULL, 'Trans-isoprenyl diphosphate synthases, eukaryotic-type', 'Trans_IPPS_euk-type', 4, NULL),
(34067, NULL, 'IPR043750', NULL, 'Protein of unknown function DUF5695', 'DUF5695', 4, NULL),
(34068, NULL, 'IPR043256', NULL, 'Polyferredoxin MvhB-like', 'MvhB-like', 4, NULL),
(34069, NULL, 'IPR046906', NULL, 'Mab-21-like, HhH/H2TH-like domain', 'Mab-21_HhH/H2TH-like', 3, NULL),
(34070, NULL, 'IPR043127', NULL, 'Sec1-like, domain 3a', 'Sec-1-like_dom3a', 5, NULL),
(34071, NULL, 'IPR045768', NULL, 'Stage II sporulation protein E, N-terminal', 'SpoIIE_N', 3, NULL),
(34072, NULL, 'IPR044482', NULL, 'Aldo-keto reductase family 1 member C', 'AKR1C', 4, NULL),
(34073, NULL, 'IPR043706', NULL, 'Protein of unknown function DUF5646', 'DUF5646', 4, NULL),
(34074, NULL, 'IPR045289', NULL, 'KIN14B-interacting protein At4g14310-like', 'At4g14310-like', 4, NULL),
(34075, NULL, 'IPR042270', NULL, 'tRNA-dihydrouridine(16) synthase, C-terminal', 'DusC_C', 5, NULL),
(34076, NULL, 'IPR046910', NULL, 'Domain observed between E2 and E1 domains', 'E2-E1mid', 3, NULL),
(34077, NULL, 'IPR043116', NULL, 'Outer capsid protein VP9, N-terminal', 'VP9_N', 5, NULL),
(34078, NULL, 'IPR044379', NULL, 'Envelope small membrane protein, MERS-CoV-like', 'E_MERS-CoV-like', 4, NULL),
(34079, NULL, 'IPR043861', NULL, 'Protein of unknown function DUF5823', 'DUF5823', 4, NULL),
(34080, NULL, 'IPR043154', NULL, 'Sec1-like, domain 1', 'Sec-1-like_dom1', 5, NULL),
(34081, NULL, 'IPR043854', NULL, 'Protein of unknown function DUF5816', 'DUF5816', 4, NULL),
(34082, NULL, 'IPR043899', NULL, 'Protein of unknown function DUF5789', 'DUF5789', 4, NULL),
(34083, NULL, 'IPR042429', NULL, 'Swi5-dependent recombination DNA repair protein 1 homolog', 'SFR1', 4, NULL),
(34084, NULL, 'IPR043707', NULL, 'Protein of unknown function DUF5647', 'DUF5647', 4, NULL),
(34085, NULL, 'IPR045056', NULL, 'Nucleolar protein Nop56/Nop58', 'Nop56/Nop58', 4, NULL),
(34086, NULL, 'IPR044465', NULL, 'PRKRA, first double-stranded RNA binding domain', 'PRKRA_DSRM_1', 3, NULL),
(34087, NULL, 'IPR044767', NULL, 'Phytochrome A/B/C/D/E-like, histidine-kinase-related domain', 'Phy_HATPase-like', 3, NULL),
(34088, NULL, 'IPR044177', NULL, 'Reticulon-like protein B22/B23', 'RTNLB22/23', 4, NULL),
(34089, NULL, 'IPR044283', NULL, 'Transcription factor FAMA/SPEECHLESS/MUTE', 'FAMA/SPEECHLESS/MUTE', 4, NULL),
(34090, NULL, 'IPR043885', NULL, 'Protein of unknown function DUF5847', 'DUF5847', 4, NULL),
(34091, NULL, 'IPR044763', NULL, 'Ded1/Dbp1, DEAD-box helicase domain', 'Ded1/Dbp1_DEADc', 3, NULL),
(34092, NULL, 'IPR045296', NULL, 'ETFRF1,  LYR domain', 'Complex1_LYR_ETFRF1_LYRM5', 3, NULL),
(34093, NULL, 'IPR046871', NULL, 'Putative carbonic anhydrase', 'Pro_CA_2', 4, NULL),
(34094, NULL, 'IPR046916', NULL, 'ABC-three component systems, C-terminal domain 4', 'ABC-3C_CTD4', 3, NULL),
(34095, NULL, 'IPR044701', NULL, 'Thioredoxin-like fold domain-containing protein MRL7/MRL7L', 'MRL7/MRL7L', 4, NULL),
(34096, NULL, 'IPR044674', NULL, 'ER degradation-enhancing alpha-mannosidase-like protein 1/2/3', 'EDEM1/2/3', 4, NULL),
(34097, NULL, 'IPR042415', NULL, 'Protein canopy homolog', 'CNPY', 4, NULL),
(34098, NULL, 'IPR045011', NULL, 'Arogenate dehydrogenase 1/2', 'TYRAAT1/2', 4, NULL),
(34099, NULL, 'IPR044753', NULL, 'HELLS, N-terminal', 'HELLS_N', 3, NULL),
(34100, NULL, 'IPR045804', NULL, 'Domain of unknown function DUF5920', 'DUF5920', 3, NULL),
(34101, NULL, 'IPR044762', NULL, 'DHX8/ Prp22, DEXH-box helicase domain', 'DHX8/Prp22_DEXHc', 3, NULL),
(34102, NULL, 'IPR044897', NULL, 'Inositol polyphosphate 1-phosphatase, domain 1', 'INPP1_dom_1', 5, NULL),
(34103, NULL, 'IPR045610', NULL, 'Domain of unknown function DUF6450', 'DUF6450', 3, NULL),
(34104, NULL, 'IPR046870', NULL, 'ABC-three component systems, C-terminal domain 3', 'ABC-3C_CTD3', 3, NULL),
(34105, NULL, 'IPR043255', NULL, 'Urotensin-2B', 'U-IIB', 4, NULL),
(34106, NULL, 'IPR046936', NULL, 'Copper acquisition factor BIM1-like', 'BIM1-like', 4, NULL),
(34107, NULL, 'IPR042860', NULL, 'MICOS complex subunit MIC25', 'MIC25', 4, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(34108, NULL, 'IPR044889', NULL, 'TccP2/EspF(U)-like superfamily', 'TccP2/EspF(U)-like_sf', 5, NULL),
(34109, NULL, 'IPR044285', NULL, 'Periodic tryptophan protein 1', 'PWP1', 4, NULL),
(34110, NULL, 'IPR043323', NULL, 'Peptidyl-prolyl cis-trans isomerase PIN4', 'PIN4', 4, NULL),
(34111, NULL, 'IPR044110', NULL, 'RNF146, RING finger, HC subclass', 'RING-HC_RNF146', 3, NULL),
(34112, NULL, 'IPR043851', NULL, 'Protein of unknown function DUF5813', 'DUF5813', 4, NULL),
(34113, NULL, 'IPR045605', NULL, '3-ketosteroid-9-alpha-monooxygenase, oxygenase component-like, C-terminal domain', 'KshA-like_C', 3, NULL),
(34114, NULL, 'IPR045771', NULL, 'Protein of unknown function DUF6224', 'DUF6224', 4, NULL),
(34115, NULL, 'IPR042887', NULL, 'Vesicle-associated membrane protein 4', 'VAMP4', 4, NULL),
(34116, NULL, 'IPR044714', NULL, 'BTB/POZ domain-containing protein AtSIBP1-like', 'AtSIBP1-like', 4, NULL),
(34117, NULL, 'IPR045723', NULL, 'Protein of unknown function DUF6077', 'DUF6077', 4, NULL),
(34118, NULL, 'IPR044467', NULL, 'PRKRA, third double-stranded RNA binding domain', 'PRKRA_DSRM_3', 3, NULL),
(34119, NULL, 'IPR044286', NULL, 'E3 ubiquitin-protein ligase SINA-like, plant', 'SINL_plant', 4, NULL),
(34120, NULL, 'IPR046897', NULL, 'ABC-three component system, Middle Component 6', 'ABC-3C_MC6', 4, NULL),
(34121, NULL, 'IPR046895', NULL, 'ABC-three component system, Middle Component 8', 'ABC-3C_MC8', 4, NULL),
(34122, NULL, 'IPR045810', NULL, 'eIF3h, C-terminal', 'eIF3h_C', 3, NULL),
(34123, NULL, 'IPR045292', NULL, 'NDUFB9, LYR domain', 'Complex1_LYR_NDUFB9_LYRM3', 3, NULL),
(34124, NULL, 'IPR044750', NULL, 'SRC2/BAP, C2 domain', 'C2_SRC2/BAP', 3, NULL),
(34125, NULL, 'IPR044480', NULL, 'D-arabinose 1-dehydrogenase Ara2-like', 'Ara2-like', 4, NULL),
(34126, NULL, 'IPR043426', NULL, 'Membrane-bound lytic murein transglycosylase B-like', 'MltB-like', 4, NULL),
(34127, NULL, 'IPR045615', NULL, 'Protein of unknown function DUF6447', 'DUF6447', 4, NULL),
(34128, NULL, 'IPR043749', NULL, 'Protein of unknown function DUF5694', 'DUF5694', 4, NULL),
(34129, NULL, 'IPR042426', NULL, 'Cysteine-rich DPF motif domain-containing protein 1', 'CDPF1', 4, NULL),
(34130, NULL, 'IPR043247', NULL, 'Coiled-coil domain-containing protein 183', 'CCDC183', 4, NULL),
(34131, NULL, 'IPR045620', NULL, 'Protein of unknown function DUF6442', 'DUF6442', 4, NULL),
(34132, NULL, 'IPR045731', NULL, 'Protein of unknown function DUF6085', 'DUF6085', 4, NULL),
(34133, NULL, 'IPR043876', NULL, 'Protein of unknown function DUF5856', 'DUF5856', 4, NULL),
(34134, NULL, 'IPR044638', NULL, 'Aldehyde dehydrogenase family 7 member A1-like', 'ALDH7A1-like', 4, NULL),
(34135, NULL, 'IPR045617', NULL, 'Protein of unknown function DUF6445', 'DUF6445', 4, NULL),
(34136, NULL, 'IPR044765', NULL, 'DDX47/Rrp3, DEAD-box helicase domain', 'DDX47/Rrp3_DEADc', 3, NULL),
(34137, NULL, 'IPR045612', NULL, 'Domain of unknown function DUF5914', 'DUF5914', 3, NULL),
(34138, NULL, 'IPR044678', NULL, 'Cold-regulated protein 27/28', 'COR27/28', 4, NULL),
(34139, NULL, 'IPR044346', NULL, 'M matrix/glycoprotein, deltacoronavirus', 'M_deltaCoV', 4, NULL),
(34140, NULL, 'IPR044770', NULL, 'Protein spinster-like', 'MFS_spinster-like', 4, NULL),
(34141, NULL, 'IPR044755', NULL, 'SMARCA1, N-terminal', 'SMARCA1_N', 3, NULL),
(34142, NULL, 'IPR044894', NULL, 'TubC, N-terminal docking domain superfamily', 'TubC_N_sf', 5, NULL),
(34143, NULL, 'IPR042859', NULL, 'Nucleolar protein 11', 'NOL11', 4, NULL),
(34144, NULL, 'IPR043728', NULL, 'Domain of unknown function DUF5671', 'DUF5671', 3, NULL),
(34145, NULL, 'IPR042542', NULL, 'Peptidase C53, pestivirus Npro, interaction domain', 'Peptidase_C53_interaction', 5, NULL),
(34146, NULL, 'IPR044943', NULL, 'Nitric oxide synthase, domain 1 superfamily', 'NOS_dom_1', 5, NULL),
(34147, NULL, 'IPR043119', NULL, 'Rac1-binding domain, C-terminal', 'Rac1-bd_C', 5, NULL),
(34148, NULL, 'IPR045773', NULL, 'Protein of unknown function DUF6226', 'DUF6226', 4, NULL),
(34149, NULL, 'IPR044513', NULL, 'BTB/POZ and TAZ domain-containing protein 1/2/3/4/5', 'BT1/2/3/4/5', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(34150, NULL, 'IPR045166', NULL, 'Pre-mRNA-splicing factor Spp2-like', 'Spp2-like', 4, NULL),
(34151, NULL, 'IPR042996', NULL, 'Receptor-type tyrosine-protein phosphatase O', 'PTPRO', 4, NULL),
(34152, NULL, 'IPR046913', NULL, 'ABC-three component systems, C-terminal domain 7', 'ABC-3C_CTD7', 3, NULL),
(34153, NULL, 'IPR046918', NULL, 'ABC-three component systems, C-terminal domain 2', 'ABC-3C_CTD2', 3, NULL),
(34154, NULL, 'IPR042797', NULL, 'Glutaredoxin domain-containing cysteine-rich protein 1', 'GRXCR1', 4, NULL),
(34155, NULL, 'IPR045814', NULL, 'Integrator complex subunit 14, beta-barrel domain', 'IntS14_b-barrel', 3, NULL),
(34156, NULL, 'IPR042793', NULL, 'Zinc finger CCHC domain-containing protein 2', 'ZCCHC2', 4, NULL),
(34157, NULL, 'IPR045613', NULL, 'Protein of unknown function DUF6448', 'DUF6448', 4, NULL),
(34158, NULL, 'IPR045811', NULL, 'MTP large subunit, lipid-binding domain', 'MTP_lip-bd', 3, NULL),
(34159, NULL, 'IPR046834', NULL, 'ATPase of the ABC class, C-terminal', 'ABC_ATPase_C', 3, NULL),
(34160, NULL, 'IPR043741', NULL, 'Family of unknown function DUF5686', 'DUF5686', 4, NULL),
(34161, NULL, 'IPR044675', NULL, 'E3 ubiquitin-protein ligase RING1-like', 'RING1-like', 4, NULL),
(34162, NULL, 'IPR045718', NULL, 'Protein of unknown function DUF6072', 'DUF6072', 4, NULL),
(34163, NULL, 'IPR045614', NULL, 'Protein of unknown function DUF6136', 'DUF6136', 4, NULL),
(34164, NULL, 'IPR043087', NULL, 'EME1, nuclease domain, subdomain 2', 'Eme1_nucdom_sub2', 5, NULL),
(34165, NULL, 'IPR045816', NULL, 'Protein angel homolog 2, N-terminal', 'ANGEL2_N', 3, NULL),
(34166, NULL, 'IPR044281', NULL, 'U3 snoRNP protein/Ribosome production factor 1', 'IMP4/RPF1', 4, NULL),
(34167, NULL, 'IPR045079', NULL, 'Oxoprolinase family', 'Oxoprolinase_fam', 4, NULL),
(34168, NULL, 'IPR043870', NULL, 'Protein of unknown function DUF5830', 'DUF5830', 4, NULL),
(34169, NULL, 'IPR042813', NULL, 'SAMD3, SAM domain', 'SAMD3_SAM', 3, NULL),
(34170, NULL, 'IPR042565', NULL, 'Type VII secretion system EssB, C-terminal', 'T7SS_EssB_C', 5, NULL),
(34171, NULL, 'IPR046842', NULL, 'Stage IV sporulation protein A, ATPase domain', 'SpoIVA_ATPase', 3, NULL),
(34172, NULL, 'IPR043853', NULL, 'Protein of unknown function DUF5815', 'DUF5815', 4, NULL),
(34173, NULL, 'IPR046931', NULL, 'DNA polymerase theta-like, helix-turn-helix domain', 'HTH_61', 3, NULL),
(34174, NULL, 'IPR046917', NULL, 'ABC-three component systems, C-terminal domain 12', 'ABC-3C_CTD12', 3, NULL),
(34175, NULL, 'IPR043725', NULL, 'Domain of unknown function DUF5667', 'DUF5667', 3, NULL),
(34176, NULL, 'IPR044721', NULL, 'Glutamate gated chloride channel, transmembrane domain', 'GluCl_TM', 3, NULL),
(34177, NULL, 'IPR043359', NULL, 'C2H2-type zinc-finger protein GLI-like', 'GLI-like', 4, NULL),
(34178, NULL, 'IPR043856', NULL, 'Protein of unknown function DUF5818', 'DUF5818', 4, NULL),
(34179, NULL, 'IPR043863', NULL, 'Protein of unknown function DUF5825', 'DUF5825', 4, NULL),
(34180, NULL, 'IPR045167', NULL, 'FMP27', 'FMP27', 4, NULL),
(34181, NULL, 'IPR042575', NULL, 'Ubiquitin-associated protein 1, C-terminal', 'UBAP1_C', 5, NULL),
(34182, NULL, 'IPR044805', NULL, 'Mediator of RNA polymerase II transcription subunit 26a/b-like', 'MD26A/B-like', 4, NULL),
(34183, NULL, 'IPR045765', NULL, 'Protein of unknown function DUF6133', 'DUF6133', 4, NULL),
(34184, NULL, 'IPR043872', NULL, 'Protein of unknown function DUF5832', 'DUF5832', 4, NULL),
(34185, NULL, 'IPR044760', NULL, 'Trafficking protein particle complex subunit 2-like', 'TRAPPC2L', 4, NULL),
(34186, NULL, 'IPR045625', NULL, 'Protein of unknown function DUF6427', 'DUF6427', 4, NULL),
(34187, NULL, 'IPR043506', NULL, 'Envelope small membrane protein, betacoronavirus', 'E_protein_bCoV', 4, NULL),
(34188, NULL, 'IPR046859', NULL, 'Ral GTPase-activating protein subunit alpha/beta, N-terminal domain', 'RGPA/RALGAPB_N', 3, NULL),
(34189, NULL, 'IPR044598', NULL, 'Zinc finger CCHC-type and RNA-binding motif-containing protein 1', 'ZCRB1', 4, NULL),
(34190, NULL, 'IPR043862', NULL, 'Domain of unknown function DUF5824', 'DUF5824', 3, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(34191, NULL, 'IPR045246', NULL, 'Argonaute-like, PIWI domain', 'Piwi_ago-like', 3, NULL),
(34192, NULL, 'IPR044888', NULL, 'Mediator complex, subunit Med7 superfmaily', 'Mediatior_Med7_sf', 5, NULL),
(34193, NULL, 'IPR043900', NULL, 'Protein of unknown function DUF5788', 'DUF5788', 4, NULL),
(34194, NULL, 'IPR045012', NULL, 'Protein NLP', 'NLP', 4, NULL),
(34195, NULL, 'IPR043312', NULL, 'E3 ubiquitin ligase BIG BROTHER-like', 'AtBBR-like', 4, NULL),
(34196, NULL, 'IPR044908', NULL, 'Nitrosopumilus output domain 5-like superfamily', 'NitrOD5-like_sf', 5, NULL),
(34197, NULL, 'IPR045733', NULL, 'Protein of unknown function DUF6087', 'DUF6087', 4, NULL),
(34198, NULL, 'IPR046911', NULL, 'ABC-three component systems, C-terminal domain 9', 'ABC-3C_CTD9', 3, NULL),
(34199, NULL, 'IPR045860', NULL, 'Snake toxin-like superfamily', 'Snake_toxin-like_sf', 5, NULL),
(34200, NULL, 'IPR044589', NULL, 'GATA transcription factor 26/27', 'GATA26/27', 4, NULL),
(34201, NULL, 'IPR046832', NULL, 'DNA helicase E1, DNA-binding domain, papillomavirus', 'PPV_E1_DBD', 3, NULL),
(34202, NULL, 'IPR044756', NULL, 'DHX15, DEXH-box helicase domain', 'DHX15_DEXHc', 3, NULL),
(34203, NULL, 'IPR044749', NULL, 'FANCM, DEAH-box helicase domain', 'FANCM_DEXDc', 3, NULL),
(34204, NULL, 'IPR044677', NULL, 'Mitochondrial phosphate carrier protein Pic2/Mir1-like', 'Pic2/Mir1-like', 4, NULL),
(34205, NULL, 'IPR042812', NULL, 'Sterile alpha motif domain-containing protein 3', 'SAMD3', 4, NULL),
(34206, NULL, 'IPR044751', NULL, 'Ion transporter-like, CBS domain', 'Ion_transp-like_CBS', 3, NULL),
(34207, NULL, 'IPR045857', NULL, 'Oligo-1,6-glucosidase, domain 2', 'O16G_dom_2', 5, NULL),
(34208, NULL, 'IPR043710', NULL, 'Repeat of unknown function DUF5650', 'DUF5650', 7, NULL),
(34209, NULL, 'IPR042421', NULL, 'Protein C3orf33-like', 'C3orf33-like', 4, NULL),
(34210, NULL, 'IPR044475', NULL, 'Staufen 1, third double-stranded RNA binding domain', 'STAU1_DSRM_3', 3, NULL),
(34211, NULL, 'IPR045250', NULL, 'Co-chaperone protein p23-like', 'p23-like', 4, NULL),
(34212, NULL, 'IPR043877', NULL, 'Domain of unknown function DUF5855', 'DUF5855', 3, NULL),
(34213, NULL, 'IPR043316', NULL, 'Cysteine and histidine-rich domain-containing protein RAR1', 'RAR1', 4, NULL),
(34214, NULL, 'IPR043555', NULL, 'Sushi repeat-containing protein SRPX-like', 'SRPX-like', 4, NULL),
(34215, NULL, 'IPR043780', NULL, 'Domain of unknown function DUF5722', 'DUF5722', 3, NULL),
(34216, NULL, 'IPR044736', NULL, 'Ran-binding protein Vid30/RanBPM/SPLA, SPRY domain', 'Vid30/RanBPM/SPLA_SPRY', 3, NULL),
(34217, NULL, 'IPR045048', NULL, 'F-box only protein 31/39', 'FBXO31/39', 4, NULL),
(34218, NULL, 'IPR045721', NULL, 'Protein of unknown function DUF6075', 'DUF6075', 4, NULL),
(34219, NULL, 'IPR045738', NULL, 'Protein of unknown function DUF6088', 'DUF6088', 4, NULL),
(34220, NULL, 'IPR042800', NULL, 'MAP3K7 C-terminal-like protein', 'Map3k7cl', 4, NULL),
(34221, NULL, 'IPR044804', NULL, 'AT1G29970-like', 'AT1G29970-like', 4, NULL),
(34222, NULL, 'IPR042418', NULL, 'Thioredoxin domain-containing protein 15', 'TXNDC15', 4, NULL),
(34223, NULL, 'IPR044716', NULL, 'Transcriptional corepressor LEUNIG-like', 'LEUNIG-like', 4, NULL),
(34224, NULL, 'IPR045852', NULL, 'Protein UNC80, central region', 'UNC80_central', 3, NULL),
(34225, NULL, 'IPR042474', NULL, 'Cell surface A33 antigen', 'A33', 4, NULL),
(34226, NULL, 'IPR042419', NULL, 'Leucine-rich repeat-containing protein 31', 'LRC31', 4, NULL),
(34227, NULL, 'IPR046828', NULL, 'Replication initiator protein', 'RepSA', 4, NULL),
(34228, NULL, 'IPR046904', NULL, 'ABC-three component system, Middle Component 2', 'ABC-3C_MC2', 4, NULL),
(34229, NULL, 'IPR042422', NULL, 'Coiled-coil domain-containing protein 103', 'CC103', 4, NULL),
(34230, NULL, 'IPR044759', NULL, 'RF2-like transcription factor, bZIP domain', 'bZIP_RF2', 3, NULL),
(34231, NULL, 'IPR046748', NULL, 'HipA-like kinase', 'HipA_2', 3, NULL),
(34232, NULL, 'IPR045742', NULL, 'LETM2, N-terminal', 'LETM2_N', 3, NULL),
(34233, NULL, 'IPR042454', NULL, 'CXADR-like membrane protein', 'CLMP', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(34234, NULL, 'IPR044764', NULL, 'DDX52/Rok1, DEAD-box helicase domain', 'DDX52/Rok1_DEADc', 3, NULL),
(34235, NULL, 'IPR043708', NULL, 'Repeat of unknown function DUF5648', 'DUF5648', 7, NULL),
(34236, NULL, 'IPR043367', NULL, 'Phospholipase A1 PLIP1/2/3, chloroplastic', 'PLIP1/2/3', 4, NULL),
(34237, NULL, 'IPR046929', NULL, 'Transposon related HTH domain protein', 'HTH_Tnp', 4, NULL),
(34238, NULL, 'IPR045114', NULL, 'Csn12 family', 'Csn12-like', 4, NULL),
(34239, NULL, 'IPR043738', NULL, 'Domain of unknown function DUF5683', 'DUF5683', 3, NULL),
(34240, NULL, 'IPR045806', NULL, 'BMP and activin membrane-bound inhibitor, C-terminal domain', 'BAMBI_C', 3, NULL),
(34241, NULL, 'IPR045249', NULL, 'Putative nuclease HARBI1-like', 'HARBI1-like', 4, NULL),
(34242, NULL, 'IPR043159', NULL, 'D-galactoside/L-rhamnose binding SUEL lectin domain superfamily', 'Lectin_gal-bd_sf', 5, NULL),
(34243, NULL, 'IPR045228', NULL, 'Phosphatase Gpp1/Gpp2-like', 'Gpp1/Gpp2-like', 4, NULL),
(34244, NULL, 'IPR044476', NULL, 'Staufen 2, first double-stranded RNA binding domain', 'STAU2_DSRM_1', 3, NULL),
(34245, NULL, 'IPR043319', NULL, 'ASH1-like, PHD finger', 'PHD_ASH1L', 3, NULL),
(34246, NULL, 'IPR046336', NULL, 'Lon protease, N-terminal domain superfamily', 'Lon_prtase_N_sf', 5, NULL),
(34247, NULL, 'IPR045060', NULL, 'Phenylalanine-tRNA ligase, class IIc, beta subunit', 'Phe-tRNA-ligase_IIc_bsu', 4, NULL),
(34248, NULL, 'IPR042420', NULL, 'Ankycorbin', 'RAI14', 4, NULL),
(34249, NULL, 'IPR044595', NULL, 'F-box/kelch-repeat protein KMD1-4', 'KMD1-4', 4, NULL),
(34250, NULL, 'IPR046930', NULL, 'Bacterial helix-turn-helix', 'HTH_60', 4, NULL),
(34251, NULL, 'IPR043253', NULL, 'Neuromedin S', 'NmS', 4, NULL),
(34252, NULL, 'IPR046363', NULL, 'Malate synthase, N-terminal and TIM-barrel domains', 'MS_N_TIM-barrel_dom', 5, NULL),
(34253, NULL, 'IPR045618', NULL, 'Domain of unknown function DUF6444', 'DUF6444', 3, NULL),
(34254, NULL, 'IPR045109', NULL, 'Histone demethylase JHDM2-like', 'JHDM2-like', 4, NULL),
(34255, NULL, 'IPR045809', NULL, 'MobI protein', 'MobI', 4, NULL),
(34256, NULL, 'IPR043852', NULL, 'Protein of unknown function DUF5814', 'DUF5814', 4, NULL),
(34257, NULL, 'IPR045740', NULL, 'BTB/POZ domain-containing protein KCTD4, C-terminal', 'KCTD4_C', 3, NULL),
(34258, NULL, 'IPR045730', NULL, 'Protein of unknown function DUF6084', 'DUF6084', 4, NULL),
(34259, NULL, 'IPR045311', NULL, 'Long-chain fatty acid CoA synthetase, eukaryotic', 'LC-FACS_euk', 4, NULL),
(34260, NULL, 'IPR044287', NULL, 'Protein SUPPRESSOR OF GENE SILENCING 3', 'SGS3', 4, NULL),
(34261, NULL, 'IPR043121', NULL, 'Restriction endonuclease, type II, BglI superfamily', 'Restrct_endonuc_II_BglI_sf', 5, NULL),
(34262, NULL, 'IPR043322', NULL, 'C-terminal binding protein', 'CtBP', 4, NULL),
(34263, NULL, 'IPR044907', NULL, 'Photosystem I reaction centre subunit N superfamily', 'PSAN_sf', 5, NULL),
(34264, NULL, 'IPR042416', NULL, 'Oligosaccharyltransferase complex subunit OSTC', 'OSTC', 4, NULL),
(34265, NULL, 'IPR045006', NULL, 'Magnesium-chelatase subunit ChlI-like', 'CHLI-like', 4, NULL),
(34266, NULL, 'IPR045247', NULL, 'Oxidoreductase Oye-like', 'Oye-like', 4, NULL),
(34267, NULL, 'IPR044893', NULL, 'RNA polymerase Rpb1, clamp domain superfamily', 'RNA_pol_Rpb1_clamp_domain', 5, NULL),
(34268, NULL, 'IPR044244', NULL, 'Tetratricopeptide repeat protein TTC27/Emw1', 'TTC27/Emw1', 4, NULL),
(34269, NULL, 'IPR045735', NULL, 'Stage III sporulation protein AA, AAA+ ATPase domain', 'Spore_III_AA_AAA+_ATPase', 3, NULL),
(34270, NULL, 'IPR042997', NULL, 'Four and a half LIM domains protein 1', 'Fhl1', 4, NULL),
(34271, NULL, 'IPR045623', NULL, 'LigXa-like, C-terminal domain', 'LigXa_C', 3, NULL),
(34272, NULL, 'IPR045055', NULL, 'DNA2/NAM7-like helicase', 'DNA2/NAM7-like', 4, NULL),
(34273, NULL, 'IPR042801', NULL, 'Otoraplin', 'OTOR', 4, NULL),
(34274, NULL, 'IPR043576', NULL, 'Predicted galactose-1-phosphate uridylyltransferase, Corynebacterium type', 'GalT_Corynebac', 4, NULL),
(34275, NULL, 'IPR044291', NULL, 'Zinc finger protein GIS/GIS2/ZFP8', 'GIS/GIS2/ZFP8', 4, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(34276, NULL, 'IPR042762', NULL, 'PKHF1, FYVE domain', 'PKHF1_FYVE', 3, NULL),
(34277, NULL, 'IPR044588', NULL, 'PX domain-containing protein EREX-like', 'EREX-like', 4, NULL),
(34278, NULL, 'IPR043577', NULL, 'Asparaginyl endopeptidase', 'AE', 4, NULL),
(34279, NULL, 'IPR042999', NULL, 'Beta-catenin-interacting protein 1/LZIC', 'CTNNBIP1/LZIC', 4, NULL),
(34280, NULL, 'IPR044754', NULL, 'Isw1/2, N-terminal', 'Isw1/2_DEXHc', 3, NULL),
(34281, NULL, 'IPR044593', NULL, 'FCS-Like Zinc finger 8/MARD1', 'FLZ8/MARD1', 4, NULL),
(34282, NULL, 'IPR044469', NULL, 'TRBP2 , first double-stranded RNA binding domain', 'TRBP2_DSRM_1', 3, NULL),
(34283, NULL, 'IPR042919', NULL, 'Retrotransposon Gag-like protein 9', 'RTL9', 4, NULL),
(34284, NULL, 'IPR044676', NULL, 'MYB-like transcription factor EOBI/EOBII-like, plant', 'EOBI/EOBII-like_plant', 4, NULL),
(34285, NULL, 'IPR043886', NULL, 'Protein of unknown function DUF5846', 'DUF5846', 4, NULL),
(34286, NULL, 'IPR046829', NULL, 'Calmodulin binding protein, C-terminal domain', 'Calmod_bind_C', 3, NULL),
(34287, NULL, 'IPR045815', NULL, 'Neutrophin-3, N-terminal', 'NTF3_N', 3, NULL),
(34288, NULL, 'IPR044592', NULL, 'Putative E3 ubiquitin-protein ligase RING1a/b', 'RING1A/B', 4, NULL),
(34289, NULL, 'IPR044115', NULL, 'LIMD2,  LIM domain', 'LIM_LIMD2', 3, NULL),
(34290, NULL, 'IPR043864', NULL, 'OMP85-like, membrane spanning beta barrel domain', 'Omp85-like_dom', 3, NULL),
(34291, NULL, 'IPR044477', NULL, 'D-threo-aldose 1-dehydrogenase-like', 'FDH-like', 4, NULL),
(34292, NULL, 'IPR043865', NULL, 'Protein of unknown function DUF5826', 'DUF5826', 4, NULL),
(34293, NULL, 'IPR044511', NULL, 'ProlycopenC2 and GRAM domain-containing protein At1g03370/At5g50170-like', 'At1g03370/At5g50170-like', 4, NULL),
(34294, NULL, 'IPR043711', NULL, 'Domain of unknown function DUF5651', 'DUF5651', 3, NULL),
(34295, NULL, 'IPR043751', NULL, 'Protein  of unknown function DUF5696', 'DUF5696', 4, NULL),
(34296, NULL, 'IPR044472', NULL, 'STRBP, first double-stranded RNA binding domain', 'STRBP_DSRM_1', 3, NULL),
(34297, NULL, 'IPR042150', NULL, 'CAAX prenyl protease 2, MmRce1-like', 'MmRce1-like', 4, NULL),
(34298, NULL, 'IPR043507', NULL, 'Envelope small membrane protein, alphacoronavirus', 'E_protein_aCoV', 4, NULL),
(34299, NULL, 'IPR045722', NULL, 'Protein of unknown function DUF6076', 'DUF6076', 4, NULL),
(34300, NULL, 'IPR045290', NULL, 'Holliday junction resolvase MOC1-like', 'MOC1-like', 4, NULL),
(34301, NULL, 'IPR045346', NULL, 'Ermin', 'Ermin', 4, NULL),
(34302, NULL, 'IPR044801', NULL, 'Filamin family', 'Filamin', 4, NULL),
(34303, NULL, 'IPR043860', NULL, 'Protein of unknown function DUF5822', 'DUF5822', 4, NULL),
(34304, NULL, 'IPR045802', NULL, 'DnaJ homologue subfamily C, GRV2/DNAJC13, N-terminal domain', 'GRV2/DNAJC13_N', 3, NULL),
(34305, NULL, 'IPR043966', NULL, 'Nuclear cap-binding complex subunit CBP110', 'CBP110', 4, NULL),
(34306, NULL, 'IPR045291', NULL, 'LYRM9, LYR domain', 'Complex1_LYR_LYRM9', 3, NULL),
(34307, NULL, 'IPR044282', NULL, 'Armadillo repeat protein ABAP1/ARIA', 'ABAP1/ARIA', 4, NULL),
(34308, NULL, 'IPR045090', NULL, 'Peptidase M3A/M3B', 'Pept_M3A_M3B', 4, NULL),
(34309, NULL, 'IPR042794', NULL, 'Neurite extension and migration factor', 'Nexmif', 4, NULL),
(34310, NULL, 'IPR046907', NULL, 'SH3 fold domain associated with phage DNA polymerases', 'SH3DP', 3, NULL),
(34311, NULL, 'IPR045468', NULL, 'Protein of unknown function DUF6496', 'DUF6496', 4, NULL),
(34312, NULL, 'IPR045179', NULL, 'YgfZ/GcvT', 'YgfZ/GcvT', 4, NULL),
(34313, NULL, 'IPR043089', NULL, 'Dot/Icm secretion system IcmQ, C-terminal', 'Dot_Icm_IcmQ_C', 5, NULL),
(34314, NULL, 'IPR044899', NULL, 'Secreted effector protein SptP, N-terminal domain superfamily', 'SptP_N_sf', 5, NULL),
(34315, NULL, 'IPR042920', NULL, 'Izumo sperm-egg fusion protein 2', 'IZUMO2', 4, NULL),
(34316, NULL, 'IPR043967', NULL, 'Nuclear cap-binding complex subunit CBP30', 'CBP30', 4, NULL),
(34317, NULL, 'IPR044481', NULL, 'Aldo-keto reductase family 1 member A1', 'AKR1A', 4, NULL),
(34318, NULL, 'IPR044768', NULL, 'DRIP1/2, RAWUL domain', 'DRIP-like_RAWUL', 3, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(34319, NULL, 'IPR045729', NULL, 'Protein of unknown function DUF6083', 'DUF6083', 4, NULL),
(34320, NULL, 'IPR045575', NULL, 'Astrotactin-1/2, N-terminal', 'ASTN_1_2_N', 3, NULL),
(34321, NULL, 'IPR043859', NULL, 'Protein of unknown function DUF5821', 'DUF5821', 4, NULL),
(34322, NULL, 'IPR042268', NULL, 'Outer membrane protein assembly factor BamC, C-terminal', 'BamC_C', 5, NULL),
(34323, NULL, 'IPR042862', NULL, 'RING finger protein 32', 'RNF32', 4, NULL),
(34324, NULL, 'IPR045728', NULL, 'Protein of unknown function DUF6082', 'DUF6082', 4, NULL),
(34325, NULL, 'IPR042888', NULL, 'G-protein-signaling modulator 3', 'GPSM3', 4, NULL),
(34326, NULL, 'IPR045803', NULL, 'Domain of unknown function DUF5921', 'DUF5921', 3, NULL),
(34327, NULL, 'IPR042475', NULL, 'V-set and immunoglobulin domain-containing protein 2', 'VSIG2', 4, NULL),
(34328, NULL, 'IPR045608', NULL, 'Trypsin-co-occurring domain 2', 'Trypco2', 3, NULL),
(34329, NULL, 'IPR046898', NULL, 'ATPase RavA, LARA domain', 'RavA_LARA_dom', 3, NULL),
(34330, NULL, 'IPR044732', NULL, 'SMAP1-like, ArfGAP domain', 'ArfGAP_SMAP1-like', 3, NULL),
(34331, NULL, 'IPR043366', NULL, 'HECTD4', 'HECTD4', 4, NULL),
(34332, NULL, 'IPR043740', NULL, 'Family of unknown function DUF5685', 'DUF5685', 4, NULL),
(34333, NULL, 'IPR045736', NULL, 'START-like domain', 'START_2', 3, NULL),
(34334, NULL, 'IPR045307', NULL, 'ADCK1-like domain', 'ADCK1_dom', 3, NULL),
(34335, NULL, 'IPR044284', NULL, 'Regulatory protein NPR5/6', 'NPR5/6', 4, NULL),
(34336, NULL, 'IPR044855', NULL, 'CoA-transferase family III domain 3 superfamily', 'CoA-Trfase_III_dom3_sf', 5, NULL),
(34337, NULL, 'IPR045115', NULL, 'BolA-like protein 2', 'BOL2', 4, NULL),
(34338, NULL, 'IPR045180', NULL, 'La domain containing protein', 'La_dom_prot', 4, NULL),
(34339, NULL, 'IPR043067', NULL, 'Calcium binding protein CcbP, beta-barrel domain', 'CcbP_b-brl', 5, NULL),
(34340, NULL, 'IPR046933', NULL, 'Kinase suppressor RAS 1, N-terminal helical hairpin superfamily', 'SAM_KSR1_N_sf', 5, NULL),
(34341, NULL, 'IPR046342', NULL, 'CBS domain superfamily', 'CBS_dom_sf', 5, NULL),
(34342, NULL, 'IPR042861', NULL, 'Testis-expressed protein 11', 'TEX11', 4, NULL),
(34343, NULL, 'IPR043712', NULL, 'Domain of unknown function DUF5652', 'DUF5652', 3, NULL),
(34344, NULL, 'IPR044245', NULL, 'SprT-like domain-containing protein Spartan', 'Spartan', 4, NULL),
(34345, NULL, 'IPR045081', NULL, 'Acidic leucine-rich nuclear phosphoprotein 32', 'AN32', 4, NULL),
(34346, NULL, 'IPR043101', NULL, 'Antiactivator protein ExsD, domain 1', 'ExsD_dom1', 5, NULL),
(34347, NULL, 'IPR045767', NULL, 'Protein of unknown function DUF6134', 'DUF6134', 4, NULL),
(34348, NULL, 'IPR044247', NULL, 'E3 ubiquitin-protein ligase SPL2-like', 'SPL2-like', 4, NULL),
(34349, NULL, 'IPR045295', NULL, 'SDHAF1, LYR domain', 'Complex1_LYR_SDHAF1_LYRM8', 3, NULL),
(34350, NULL, 'IPR045770', NULL, 'Protein of unknown function DUF6223', 'DUF6223', 4, NULL),
(34351, NULL, 'IPR043373', NULL, 'Ionotropic glutamate receptor, delta subfamily', 'IGluR_D', 4, NULL),
(34352, NULL, 'IPR045240', NULL, 'Ribosomal protein L4, eukaryotic and archaeal type', 'Ribosomal_L4_euk/arch', 4, NULL),
(34353, NULL, 'IPR045251', NULL, 'Vacuolar protein-sorting protein Bro1-like', 'BRO1-like', 4, NULL),
(34354, NULL, 'IPR042918', NULL, 'Pleckstrin homology domain-containing family G member 6', 'PLEKHG6', 4, NULL),
(34355, NULL, 'IPR043446', NULL, 'Neurabin-like family', 'Neurabin-like', 4, NULL),
(34356, NULL, 'IPR046921', NULL, 'ABC-three component systems, C-terminal domain 11', 'ABC-3C_CTD11', 3, NULL),
(34357, NULL, 'IPR044290', NULL, 'Arabinosyltransferase RRA1/2/3', 'RRA1/2/3', 4, NULL),
(34358, NULL, 'IPR044466', NULL, 'PRKRA, second double-stranded RNA binding domain', 'PRKRA_DSRM_2', 3, NULL),
(34359, NULL, 'IPR045183', NULL, 'F-box-like/WD repeat-containing protein Ebi-like', 'Ebi-like', 4, NULL),
(34360, NULL, 'IPR043729', NULL, 'Domain of unknown function DUF5672', 'DUF5672', 3, NULL),
(34361, NULL, 'IPR046919', NULL, 'ABC-three component systems, C-terminal domain 10', 'ABC-3C_CTD10', 3, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(34362, NULL, 'IPR043869', NULL, 'Protein of unknown function DUF5829', 'DUF5829', 4, NULL),
(34363, NULL, 'IPR042916', NULL, 'C-type lectin domain family 12 member A/B', 'CLEC12A/B', 4, NULL),
(34364, NULL, 'IPR044818', NULL, 'Transcription factor ILR3-like', 'ILR3-like', 4, NULL),
(34365, NULL, 'IPR046927', NULL, 'GREB1, C-terminal domain', 'GREB1_C', 3, NULL),
(34366, NULL, 'IPR042864', NULL, 'Transmembrane protein 25', 'TMEM25', 4, NULL),
(34367, NULL, 'IPR043427', NULL, 'Lipoprotein YscJ/Flagellar M-ring protein', 'YscJ/FliF', 4, NULL),
(34368, NULL, 'IPR045760', NULL, '2,4-diaminopentanoate dehydrogenase, C-terminal domain', 'DAP_DH_C', 3, NULL),
(34369, NULL, 'IPR042712', NULL, 'E3 ubiquitin-protein ligase RNF149, RING finger, H2 subclass', 'RNF149_RING-H2', 3, NULL),
(34370, NULL, 'IPR044757', NULL, 'IAA-amino acid hydrolase ILR1-like', 'ILR1-like_Hyd', 4, NULL),
(34371, NULL, 'IPR044733', NULL, 'AP-1 complex subunit sigma', 'AP1_sigma', 4, NULL),
(34372, NULL, 'IPR042788', NULL, 'Protein ANKUB1', 'ANKUB1', 4, NULL),
(34373, NULL, 'IPR045769', NULL, 'Delta and Notch-like epidermal growth factor-related receptor, C-terminal', 'DNER_C', 3, NULL),
(34374, NULL, 'IPR044769', NULL, '1-phosphatidylinositol-3-phosphate 5-kinase, PIPK catalytic domain', 'PIKfyve_PIPKc', 3, NULL),
(34375, NULL, 'IPR042427', NULL, 'Zinc finger FYVE domain-containing protein 1', 'ZFYV1', 4, NULL),
(34376, NULL, 'IPR043727', NULL, 'Family of unknown function DUF5670', 'DUF5670', 4, NULL),
(34377, NULL, 'IPR046896', NULL, 'LYR motif-containing protein Cup1-like, N-terminal domain', 'Cup1-like_N', 3, NULL),
(34378, NULL, 'IPR045657', NULL, 'Protein of unknown function DUF6392', 'DUF6392', 4, NULL),
(34379, NULL, 'IPR045010', NULL, 'Medium-chain dehydrogenase/reductase', 'MDR_fam', 4, NULL),
(34380, NULL, 'IPR042449', NULL, 'Ubiquitin-activating enzyme E1, inactive adenylation domain, subdomain 1', 'Ub-E1_IAD_1', 5, NULL),
(34381, NULL, 'IPR046905', NULL, 'ABC-three component system, Middle Component 1', 'ABC-3C_MC1', 4, NULL),
(34382, NULL, 'IPR044940', NULL, 'Nitric oxide synthase,  domain 2 superfamily', 'NOS_dom_2', 5, NULL),
(34383, NULL, 'IPR044597', NULL, 'Single myb histone 1-6', 'SMH1-6', 4, NULL),
(34384, NULL, 'IPR045808', NULL, 'FBXL5-like, hemerythrin-like domain', 'Hr_FBXL5', 3, NULL),
(34385, NULL, 'IPR045293', NULL, 'LYRM2, LYR domain', 'Complex1_LYR_LYRM2', 3, NULL),
(34386, NULL, 'IPR045607', NULL, 'Protein of unknown function DUF6452', 'DUF6452', 4, NULL),
(34387, NULL, 'IPR045761', NULL, 'ODP domain', 'ODP_dom', 3, NULL),
(34388, NULL, 'IPR042568', NULL, 'Sulfhydryl oxidase, flavin adenine dinucleotide (FAD) binding domain superfamily', 'QSOX_FAD-bd_sf', 5, NULL),
(34389, NULL, 'IPR045362', NULL, 'Contractile injection system spike tip protein', 'CIS_spike_tip', 4, NULL),
(34390, NULL, 'IPR042998', NULL, 'Perilipin-1', 'PLIN1', 4, NULL),
(34391, NULL, 'IPR046884', NULL, 'tRNA-specific 2-thiouridylase MnmA-like, central domain', 'MnmA-like_central', 3, NULL),
(34392, NULL, 'IPR043752', NULL, 'Family of unknown function DUF5697', 'DUF5697', 4, NULL),
(34393, NULL, 'IPR045805', NULL, 'Protein NDNF, C-terminal', 'NDNF_C', 3, NULL),
(34394, NULL, 'IPR044831', NULL, 'Heme-binding peroxidase Ccp1-like', 'Ccp1-like', 4, NULL),
(34395, NULL, 'IPR044308', NULL, 'Non-structural protein 5, gammacoronavirus', 'NSP5_Mpro_GammaCoV', 3, NULL),
(34396, NULL, 'IPR044771', NULL, 'UNC93-like protein 3, plant', 'UN933_plant', 4, NULL),
(34397, NULL, 'IPR043123', NULL, 'Phage bIL170 RBP, head domain', 'Phage_bIL170_RBP_head', 5, NULL),
(34398, NULL, 'IPR044905', NULL, 'Resuscitation-promoting factor Rpf1, C-terminal superfamily', 'Rpf1_C_sf', 5, NULL),
(34399, NULL, 'IPR045486', NULL, 'FtsH ternary system domain X7', 'fvmX7', 3, NULL),
(34400, NULL, 'IPR043265', NULL, 'POU class 2 homeobox associating factor 3', 'OCAT2', 4, NULL),
(34401, NULL, 'IPR044107', NULL, 'ATM, catalytic domain', 'PIKKc_ATM', 3, NULL),
(34402, NULL, 'IPR045685', NULL, 'Protein of unknown function DUF6190', 'DUF6190', 4, NULL),
(34403, NULL, 'IPR043867', NULL, 'Protein of unknown function DUF5827', 'DUF5827', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(34404, NULL, 'IPR045807', NULL, 'BMP and activin membrane-bound inhibitor, N-terminal domain', 'BAMBI_N', 3, NULL),
(34405, NULL, 'IPR045007', NULL, 'LAS seventeen-binding protein 5', 'LSB5', 4, NULL),
(34406, NULL, 'IPR043363', NULL, 'Transcription factor DIVARICATA-like', 'DIVARICATA-like', 4, NULL),
(34407, NULL, 'IPR046914', NULL, 'ABC-three component systems, C-terminal domain 6', 'ABC-3C_CTD6', 3, NULL),
(34408, NULL, 'IPR042567', NULL, 'Spindlin/spermiogenesis-specific domain superfamily', 'SPIN/Ssty_sf', 5, NULL),
(34409, NULL, 'IPR046827', NULL, 'Complex III assembly factor UQCC2/CBP6', 'UQCC2/CBP6', 4, NULL),
(34410, NULL, 'IPR043254', NULL, 'Heat shock protein beta-8', 'HSPB8', 4, NULL),
(34411, NULL, 'IPR046937', NULL, 'Voltage-dependent L-type calcium channel subunit beta-1-4, N-terminal A domain', 'CAB1-4_N_A-dom', 3, NULL),
(34412, NULL, 'IPR042858', NULL, 'DnaJ homolog subfamily C member 8', 'DNAJC8', 4, NULL),
(34413, NULL, 'IPR045622', NULL, 'Protein of unknown function DUF6441', 'DUF6441', 4, NULL),
(34414, NULL, 'IPR042566', NULL, 'L1 transposable element, C-terminal domain', 'L1_C', 5, NULL),
(34415, NULL, 'IPR044912', NULL, 'Epidermal growth factor receptor, juxtamembrane domain', 'Egfr_JX_dom', 5, NULL),
(34416, NULL, 'IPR043575', NULL, 'Macrophage stimulating protein', 'MSP_HGFL', 4, NULL),
(34417, NULL, 'IPR045080', NULL, 'XRCC1, first (central) BRCT domain', 'BRCT_XRCC1_rpt1', 3, NULL),
(34418, NULL, 'IPR043151', NULL, 'Bromo adjacent homology (BAH) domain superfamily', 'BAH_sf', 5, NULL),
(34419, NULL, 'IPR042863', NULL, 'Protein kish-B', 'Kish-B', 4, NULL),
(34420, NULL, 'IPR044945', NULL, 'FokI, recognition domain, subdomain 1 and 2', 'FokI_dom_1_2', 5, NULL),
(34421, NULL, 'IPR043478', NULL, 'Non-structural protein NSP3, SUD-N (Mac2) domain superfamily, betacoronavirus', 'NSP3_SUD-N_sf_bCoV', 5, NULL),
(34422, NULL, 'IPR045611', NULL, 'Domain of unknown function DUF6449', 'DUF6449', 3, NULL),
(34423, NULL, 'IPR044543', NULL, 'Uncharacterized cysteine-rich protein YhjQ-like', 'YHJQ-like', 4, NULL),
(34424, NULL, 'IPR043358', NULL, 'Ras GTPase GNL1-like', 'GNL1-like', 4, NULL),
(34425, NULL, 'IPR043424', NULL, 'Protein BRANCHLESS TRICHOME-like', 'BLT-like', 4, NULL),
(34426, NULL, 'IPR046920', NULL, 'ABC-three component systems, C-terminal domain 1', 'ABC-3C_CTD1', 3, NULL),
(34427, NULL, 'IPR045616', NULL, 'Protein of unknown function DUF6446', 'DUF6446', 4, NULL),
(34428, NULL, 'IPR043739', NULL, 'Family of unknown function DUF5684', 'DUF5684', 4, NULL),
(34429, NULL, 'IPR043368', NULL, 'Peptidyl-prolyl cis-trans isomerase FKBP3', 'FKBP3', 4, NULL),
(34430, NULL, 'IPR045187', NULL, 'Cytochrome c/quinol oxidase subunit II', 'CcO_II', 4, NULL),
(34431, NULL, 'IPR043880', NULL, 'Protein of unknown function DUF5852', 'DUF5852', 4, NULL),
(34432, NULL, 'IPR043557', NULL, 'Dermcidin/Lacritin', 'Dermcidin/Lacritin', 4, NULL),
(34433, NULL, 'IPR043897', NULL, 'Protein of unknown function DUF5835', 'DUF5835', 4, NULL),
(34434, NULL, 'IPR043714', NULL, 'Domain of unknown function DUF5655', 'DUF5655', 3, NULL),
(34435, NULL, 'IPR045108', NULL, 'Thioredoxin domain-containing protein 17-like', 'TXNDC17-like', 4, NULL),
(34436, NULL, 'IPR043742', NULL, 'Family of unknown function DUF5687', 'DUF5687', 4, NULL),
(34437, NULL, 'IPR044800', NULL, 'B3 domain-containing transcription factor LEC2-like', 'LEC2-like', 4, NULL),
(34438, NULL, 'IPR044470', NULL, 'TRBP2 , second double-stranded RNA binding domain', 'TRBP2_DSRM_2', 3, NULL),
(34439, NULL, 'IPR045871', NULL, 'Histidine-containing phosphotransfer protein 1-5/Phosphorelay intermediate protein YPD1', 'AHP1-5/YPD1', 4, NULL),
(34440, NULL, 'IPR044852', NULL, 'WW domain-binding protein 2-like', 'WBP2-like', 4, NULL),
(34441, NULL, 'IPR046361', NULL, 'Exocyst complex subunit Sec15, C-terminal', 'Sec15_C', 3, NULL),
(34442, NULL, 'IPR046830', NULL, 'Calmodulin binding protein, central domain', 'Calmod_bind_M', 3, NULL),
(34443, NULL, 'IPR046857', NULL, 'Gem-associated protein 6, Sm-like domain', 'Gemin6_Sm-like_dom', 3, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(34444, NULL, 'IPR045813', NULL, 'Cysteine-rich motor neuron 1 protein, C-terminal', 'CRIM1_C', 3, NULL),
(34445, NULL, 'IPR045764', NULL, 'Protein of unknown function DUF6132', 'DUF6132', 4, NULL),
(34446, NULL, 'IPR042837', NULL, 'Pentraxin-related protein PTX3', 'PTX3', 4, NULL),
(34447, NULL, 'IPR044108', NULL, 'DNA (cytosine-5)-methyltransferase 3A, ADD domain', 'ADD_DNMT3A', 3, NULL),
(34448, NULL, 'IPR045294', NULL, 'LYRM1, LYR domain', 'Complex1_LYR_LYRM1', 3, NULL),
(34449, NULL, 'IPR044843', NULL, 'Trans-isoprenyl diphosphate synthases, bacterial-type', 'Trans_IPPS_bact-type', 4, NULL),
(34450, NULL, 'IPR043858', NULL, 'Protein of unknown function DUF5820', 'DUF5820', 4, NULL),
(34451, NULL, 'IPR043187', NULL, 'Esterase CM06B1-like', 'CM06B1-like', 4, NULL),
(34452, NULL, 'IPR046846', NULL, 'PKAT, KLD domain', 'PKAT_KLD', 3, NULL),
(34453, NULL, 'IPR042803', NULL, 'Transcription factor 19', 'TCF19', 4, NULL),
(34454, NULL, 'IPR045009', NULL, 'CASP-like protein 5', 'CASPL-5', 4, NULL),
(34455, NULL, 'IPR045111', NULL, 'Vacuolar protein sorting-associated protein Vps41/Vps8', 'Vps41/Vps8', 4, NULL),
(34456, NULL, 'IPR044596', NULL, 'Phosphatidylglycerophosphatase and protein-tyrosine phosphatase 1-like', 'PTPMT1-like', 4, NULL),
(34457, NULL, 'IPR046864', NULL, 'Toxin VasX, N-terminal region', 'VasX_N', 3, NULL),
(34458, NULL, 'IPR045734', NULL, 'Sorting nexin 8/Mvp1, BAR domain', 'Snx8_BAR_dom', 3, NULL),
(34459, NULL, 'IPR044802', NULL, 'Calmodulin calcium-dependent NAD kinase NADKc-like', 'NADKc-like', 4, NULL),
(34460, NULL, 'IPR043857', NULL, 'Protein of unknown function DUF5819', 'DUF5819', 4, NULL),
(34461, NULL, 'IPR044766', NULL, 'NPSN/SNAP25-like, N-terminal SNARE domain', 'NPSN/SNAP25-like_N_SNARE_', 3, NULL),
(34462, NULL, 'IPR045766', NULL, 'MCAfunc domain', 'MCAfunc', 3, NULL),
(34463, NULL, 'IPR043753', NULL, 'Protein of unknown function DUF5699', 'DUF5699', 4, NULL),
(34464, NULL, 'IPR045725', NULL, 'Protein of unknown function DUF6079', 'DUF6079', 4, NULL),
(34465, NULL, 'IPR045812', NULL, 'DAHL domain', 'DAHL', 3, NULL),
(34466, NULL, 'IPR042915', NULL, 'BTB/POZ domain-containing protein 18', 'BTBD18', 4, NULL),
(34467, NULL, 'IPR042804', NULL, 'Probable G-protein coupled receptor 82', 'GPR82', 4, NULL),
(34468, NULL, 'IPR045726', NULL, 'Protein of unknown function DUF6080', 'DUF6080', 4, NULL),
(34469, NULL, 'IPR043888', NULL, 'Protein of unknown function DUF5844', 'DUF5844', 4, NULL),
(34470, NULL, 'IPR046367', NULL, 'GapR-like, DNA-binding domain', 'GapR-like_DNA-bd', 3, NULL),
(34471, NULL, 'IPR045113', NULL, 'RNA polymerase subunit Rpb7-like', 'Rpb7-like', 4, NULL),
(34472, NULL, 'IPR044594', NULL, 'Heavy metal-associated isoprenylated plant protein 1/3/5/6', 'HIP01/3/5/6', 4, NULL),
(34473, NULL, 'IPR042414', NULL, 'T-cell surface glycoprotein CD8 beta chain', 'CD8B', 4, NULL),
(34474, NULL, 'IPR044734', NULL, 'G protein-coupled receptor 35, 7TM', '7tmA_GPR35', 3, NULL),
(34475, NULL, 'IPR044911', NULL, 'V-type ATP synthase c/d subunit, domain 3 superfamily', 'V-type_ATPase_su_c/d_dom_3', 5, NULL),
(34476, NULL, 'IPR045762', NULL, 'ADNP, zinc finger domain', 'ADNP_Znf', 3, NULL),
(34477, NULL, 'IPR044471', NULL, 'TRBP2 , third double-stranded RNA binding domain', 'TRBP2_DSRM_3', 3, NULL),
(34478, NULL, 'IPR044246', NULL, 'Zinc finger protein 3-like', 'ZFP3-like', 4, NULL),
(34479, NULL, 'IPR043556', NULL, 'StAR-related lipid transfer protein 5/6', 'StARD5/6', 4, NULL),
(34480, NULL, 'IPR044947', NULL, 'Bacteriophage T4, Gp32, single-stranded DNA-binding superfamily', 'Phage_T4_Gp32_ssDNA-bd_sf', 5, NULL),
(34481, NULL, 'IPR044353', NULL, 'NSP3, second ubiquitin-like (Ubl) domain, coronavirus', 'Nsp3_Ubl2_dom_CoV', 3, NULL),
(34482, NULL, 'IPR044474', NULL, 'Staufen 2, fourth double-stranded RNA binding domain', 'STAU2_DSRM_4', 3, NULL),
(34483, NULL, 'IPR045202', NULL, 'CHIP/LubX , U box domain', 'CHIP/LubX_RING-Ubox', 3, NULL),
(34484, NULL, 'IPR046912', NULL, 'ABC-three component systems, C-terminal domain 8', 'ABC-3C_CTD8', 3, NULL),
(34485, NULL, 'IPR043726', NULL, 'Domain of unknown function DUF5668', 'DUF5668', 3, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(34486, NULL, 'IPR044479', NULL, 'L-galactose dehydrogenase-like', 'LGALDH-like', 4, NULL),
(34487, NULL, 'IPR043901', NULL, 'Protein of unknown function DUF5787', 'DUF5787', 4, NULL),
(34488, NULL, 'IPR045229', NULL, 'Thiamine pyrophosphate enzyme', 'TPP_enz', 4, NULL),
(34489, NULL, 'IPR045772', NULL, 'Protein of unknown function DUF6225', 'DUF6225', 4, NULL),
(34490, NULL, 'IPR042886', NULL, 'Cystatin-F', 'Cystatin-F', 4, NULL),
(34491, NULL, 'IPR044799', NULL, 'NAC domain-containing protein SOG1-like', 'SOG1-like', 4, NULL),
(34492, NULL, 'IPR044746', NULL, 'ABC transporter C family, six-transmembrane helical domain 1', 'ABCC_6TM_D1', 3, NULL),
(34493, NULL, 'IPR044401', NULL, 'NSP15, NendoU domain, coronavirus', 'NSP15_NendoU_CoV', 3, NULL),
(34494, NULL, 'IPR044381', NULL, 'NSP3, DPUP domain, murine hepatitis virus-like', 'NSP3_DPUP_MHV', 3, NULL),
(34495, NULL, 'IPR044478', NULL, 'Pyridoxal 4-dehydrogenase-like', 'Pld1-like', 4, NULL),
(34496, NULL, 'IPR043120', NULL, 'Rac1-binding domain, N-terminal', 'Rac1-db_N', 5, NULL),
(34497, NULL, 'IPR045739', NULL, 'ACT domain pair', 'ACT_dom_pair', 3, NULL),
(34498, NULL, 'IPR044251', NULL, 'Chromo domain-containing protein LHP1', 'LHP1-like', 4, NULL),
(34499, NULL, 'IPR043871', NULL, 'Protein of unknown function DUF5831', 'DUF5831', 4, NULL),
(34500, NULL, 'IPR046831', NULL, 'Calmodulin binding protein-like, N-terminal domain', 'Calmodulin_bind_N', 3, NULL),
(34501, NULL, 'IPR042802', NULL, 'Ankyrin repeat domain-containing protein 22', 'ANR22', 4, NULL),
(34502, NULL, 'IPR042179', NULL, 'Multifunctional 2-oxoglutarate metabolism enzyme, C-terminal domain superfamily', 'KGD_C_sf', 5, NULL),
(34503, NULL, 'IPR044778', NULL, 'Sugar transport protein STP/MST-like, plant', 'MFS_STP/MST-like_plant', 4, NULL),
(34504, NULL, 'IPR045282', NULL, 'At4g08330-like', 'At4g08330-like', 4, NULL),
(34505, NULL, 'IPR044211', NULL, 'Pheophytinase, chloroplastic', 'PPH_chloroplastic', 4, NULL),
(34506, NULL, 'IPR043147', NULL, 'Penicillin amidase type, A-knob', 'Penicillin_amidase_A-knob', 5, NULL),
(34507, NULL, 'IPR042262', NULL, 'Nitrile hydratase beta subunit, N-terminal', 'CN_hydtase_beta_C', 5, NULL),
(34508, NULL, 'IPR043447', NULL, 'CCDC120/INAVA', 'CCDC120/INAVA', 4, NULL),
(34509, NULL, 'IPR045199', NULL, 'ATPase family AAA domain-containing protein ATAD2-like', 'ATAD2-like', 4, NULL),
(34510, NULL, 'IPR044091', NULL, 'Nei, N-terminal', 'EcNei-like_N', 3, NULL),
(34511, NULL, 'IPR044508', NULL, 'F-box protein At5g50450/At1g67340-like', 'At5g50450/At1g67340-like', 4, NULL),
(34512, NULL, 'IPR042732', NULL, 'WWOX, classical (c)-like SDR domain', 'WWOX_SDR_c-like', 3, NULL),
(34513, NULL, 'IPR042191', NULL, 'GS homeobox 1/2', 'GSH1/2', 4, NULL),
(34514, NULL, 'IPR043179', NULL, 'Major vault protein repeat domain 2 superfamily', 'Vault_2_sf', 5, NULL),
(34515, NULL, 'IPR043361', NULL, 'DnaJ homolog subfamily C member 16, TRX domain', 'DNAJC16_TRX', 3, NULL),
(34516, NULL, 'IPR043968', NULL, 'SGNH domain', 'SGNH', 3, NULL),
(34517, NULL, 'IPR042982', NULL, 'Homeobox protein GBX-1/2', 'GBX-1/2', 4, NULL),
(34518, NULL, 'IPR043684', NULL, 'Ribosome protection protein VmlR', 'VmlR', 4, NULL),
(34519, NULL, 'IPR042265', NULL, 'Diphthamide synthesis DPH1/DPH2, domain 3', 'DPH1/DPH2_3', 5, NULL),
(34520, NULL, 'IPR044410', NULL, 'PRDM16, PR/SET domain', 'PRDM16_PR-SET', 3, NULL),
(34521, NULL, 'IPR045181', NULL, 'Heavy metal binding protein HIPP/ATX1-like', 'HIPP/ATX1-like', 4, NULL),
(34522, NULL, 'IPR042288', NULL, 'Lecithin retinol acyltransferase', 'LRAT', 4, NULL),
(34523, NULL, 'IPR042537', NULL, 'Nucleoporin, Nup155-like, C-terminal, subdomain 2', 'Nucleoporin_Nup155_C_2', 5, NULL),
(34524, NULL, 'IPR042277', NULL, 'Vacuolar protein sorting-associated protein IST1-like', 'IST1-like', 5, NULL),
(34525, NULL, 'IPR043963', NULL, 'Domain of unknown function DUF5751', 'DUF5751', 3, NULL),
(34526, NULL, 'IPR044935', NULL, 'Domain of unknown function DUF5086 superfamily', 'DUF5086_sf', 5, NULL),
(34527, NULL, 'IPR044599', NULL, 'CRS2-associated factor, plant', 'CAF1P_plant', 4, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(34528, NULL, 'IPR045110', NULL, 'XMAP215 family', 'XMAP215', 4, NULL),
(34529, NULL, 'IPR043903', NULL, 'Protein of unknown function DUF5785', 'DUF5785', 4, NULL),
(34530, NULL, 'IPR042315', NULL, 'RELT-like protein 1', 'RELL1', 4, NULL),
(34531, NULL, 'IPR044934', NULL, 'Peptidase C10, streptopain superfmaily', 'Streptopain_sf', 5, NULL),
(34532, NULL, 'IPR044687', NULL, 'Protein LOW PSII ACCUMULATION 3', 'LPA3', 4, NULL),
(34533, NULL, 'IPR045352', NULL, 'Protein of unknown function DUF6530', 'DUF6530', 4, NULL),
(34534, NULL, 'IPR043295', NULL, 'RNF4, RING finger, HC subclass', 'RING-HC_RNF4', 3, NULL),
(34535, NULL, 'IPR043198', NULL, 'Cyclin/Cyclin-like subunit Ssn8', 'Cyclin/Ssn8', 4, NULL),
(34536, NULL, 'IPR044254', NULL, 'BRCT domain-containing protein At4g02110-like', 'At4g02110-like', 4, NULL),
(34537, NULL, 'IPR045843', NULL, 'Transcription factor IND-like', 'IND-like', 4, NULL),
(34538, NULL, 'IPR044212', NULL, 'Protein-tyrosine-phosphatase IBR5-like', 'IBR5-like', 4, NULL),
(34539, NULL, 'IPR042121', NULL, 'MutL, C-terminal domain, regulatory subdomain', 'MutL_C_regsub', 5, NULL),
(34540, NULL, 'IPR044776', NULL, 'Polyol transporter 1-6', 'PLT1-6', 4, NULL),
(34541, NULL, 'IPR044537', NULL, 'Uncharacterized M50 metalloprotease, S2P-like', 'S2P-M50-like', 4, NULL),
(34542, NULL, 'IPR043883', NULL, 'Protein of unknown function DUF5849', 'DUF5849', 4, NULL),
(34543, NULL, 'IPR044221', NULL, 'Protein DYAD/AMEIOTIC 1', 'DYAD/AMEIOTIC1', 4, NULL),
(34544, NULL, 'IPR043520', NULL, 'Spermatogenesis-associated protein 21', 'SPT21', 4, NULL),
(34545, NULL, 'IPR043969', NULL, 'MAP3K, PH domain', 'MAP3K_PH', 3, NULL),
(34546, NULL, 'IPR044698', NULL, 'Vitamin K epoxide reductase-like VKOR/LOT1', 'VKOR/LTO1', 3, NULL),
(34547, NULL, 'IPR044837', NULL, 'B3 domain-containing protein REM16-like', 'REM16-like', 4, NULL),
(34548, NULL, 'IPR043472', NULL, 'Macro domain-like', 'Macro_dom-like', 5, NULL),
(34549, NULL, 'IPR045318', NULL, 'Histone-lysine N-methyltransferase EZH1/2-like', 'EZH1/2-like', 4, NULL),
(34550, NULL, 'IPR045574', NULL, 'Astrotactin-1/2, EGF-like and Fn(III) domains', 'ASTN1_2_EGF_Fn', 3, NULL),
(34551, NULL, 'IPR043509', NULL, 'Brdt, bromodomain, repeat II', 'Bromo_Brdt_II', 3, NULL),
(34552, NULL, 'IPR043375', NULL, 'Fibrous sheath CABYR-binding protein', 'FSCB', 4, NULL),
(34553, NULL, 'IPR043505', NULL, 'Nucleocapsid protein, betacoronavirus', 'NCAP_bCoV', 4, NULL),
(34554, NULL, 'IPR044690', NULL, 'Calcium sensing receptor, plant', 'CAS_plant', 4, NULL),
(34555, NULL, 'IPR044851', NULL, 'Wax synthase', 'Wax_synthase', 4, NULL),
(34556, NULL, 'IPR044741', NULL, 'Non-specific lipid-transfer protein-like', 'NsLTP-like', 3, NULL),
(34557, NULL, 'IPR045054', NULL, 'Prolyl 4-hydroxylase', 'P4HA-like', 4, NULL),
(34558, NULL, 'IPR044494', NULL, 'Aldo-keto reductase family 3C2/3', 'AKR3C2/3', 4, NULL),
(34559, NULL, 'IPR042295', NULL, 'NarX-like, N-terminal domain superfamily', 'NarX-like_N_sf', 5, NULL),
(34560, NULL, 'IPR044493', NULL, 'Polynucleotide kinase PNKP, C-terminal phosphatase domain', 'PNKP_C_HAD', 3, NULL),
(34561, NULL, 'IPR045479', NULL, 'FtsH ternary system vWA domain, fused N-terminal helical region', 'ivWA-helical_N', 3, NULL),
(34562, NULL, 'IPR043879', NULL, 'Domain of unknown function DUF5853', 'DUF5853', 3, NULL),
(34563, NULL, 'IPR042985', NULL, 'Sushi domain-containing protein 4', 'SUSD4', 4, NULL),
(34564, NULL, 'IPR045016', NULL, 'Na(+)/H(+) antiporter NhaD-like', 'NhaD-like', 4, NULL),
(34565, NULL, 'IPR044785', NULL, 'Rho GTPase-activating protein 1-5', 'RopGAP1-5', 4, NULL),
(34566, NULL, 'IPR042569', NULL, 'Ribosome-associated complex head domain superfamily', 'RAC_head_sf', 5, NULL),
(34567, NULL, 'IPR044185', NULL, 'Peptidyl-prolyl cis-trans isomerase CYP26-2-like', 'CYP26-2-like', 4, NULL),
(34568, NULL, 'IPR044532', NULL, 'Protein BREVIS RADIX-like', 'BRX-like', 4, NULL),
(34569, NULL, 'IPR043315', NULL, 'C-type lectin domain family 9 member A', 'CLEC9A', 4, NULL),
(34570, NULL, 'IPR045223', NULL, 'Small (40S) ribosomal subunit Asc1/RACK1', 'Asc1/RACK1', 4, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(34571, NULL, 'IPR044704', NULL, '(S)-ureidoglycine aminohydrolase, N-terminal cupin domain', 'UGlyAH_cupin_N', 3, NULL),
(34572, NULL, 'IPR044814', NULL, 'Terpene cyclases, class 1, plant', 'Terpene_cyclase_plant_C1', 4, NULL),
(34573, NULL, 'IPR043902', NULL, 'Domain of unknown function DUF5786', 'DUF5786', 3, NULL),
(34574, NULL, 'IPR043510', NULL, 'BZW1/2, W2 domain', 'W2_BZW1/2', 3, NULL),
(34575, NULL, 'IPR043884', NULL, 'Domain of unknown function DUF5848', 'DUF5848', 3, NULL),
(34576, NULL, 'IPR043197', NULL, 'Plakin', 'Plakin', 4, NULL),
(34577, NULL, 'IPR044335', NULL, 'Accessory protein NS6, deltacoronavirus', 'NS6_deltaCoV', 3, NULL),
(34578, NULL, 'IPR045254', NULL, 'Nit1/2, carbon-nitrogen hydrolase  domain', 'Nit1/2_C-N_Hydrolase', 3, NULL),
(34579, NULL, 'IPR045900', NULL, 'Peroxisomal adenine nucleotide carrier 1/2', 'Peroxisomal_Ade_carrier', 4, NULL),
(34580, NULL, 'IPR044530', NULL, 'Chaperone protein SicP', 'SicP', 4, NULL),
(34581, NULL, 'IPR043175', NULL, 'F-actin-capping protein subunit beta, N-terminal domain', 'CAPZB_N', 5, NULL),
(34582, NULL, 'IPR043161', NULL, 'Dedicator of cytokinesis, C-terminal, lobe A', 'DOCK_C_lobe_A', 5, NULL),
(34583, NULL, 'IPR045178', NULL, 'Transcription regulator Fhl1/FHA1', 'Fhl1/FHA1', 4, NULL),
(34584, NULL, 'IPR043099', NULL, 'Thiamine-binding lipoprotein, domain I', 'CypI_dom_I', 5, NULL),
(34585, NULL, 'IPR042576', NULL, 'TRAF3-interacting protein 1, N-terminal domain superfamily', 'TRAF3IP1_N_sf', 5, NULL),
(34586, NULL, 'IPR043164', NULL, '50S ribosomal protein L10, insertion domain superfamily', 'RL10_insert_sf', 5, NULL),
(34587, NULL, 'IPR044215', NULL, 'Phosphatidylinositol N-acetylglucosaminyltransferase subunit H', 'PIG-H', 4, NULL),
(34588, NULL, 'IPR045272', NULL, 'Receptor-like protein kinase ANXUR1-like', 'ANXUR1-like', 4, NULL),
(34589, NULL, 'IPR044510', NULL, 'CRIB domain-containing protein RIC1-like', 'RIC1-like', 4, NULL),
(34590, NULL, 'IPR043195', NULL, 'Tetratricopeptide repeat protein 12', 'TTC12', 4, NULL),
(34591, NULL, 'IPR044774', NULL, 'Suv3, DEXQ-box helicase domain', 'Suv3_DEXQc', 3, NULL),
(34592, NULL, 'IPR043070', NULL, 'Spidroin, repetitive domain', 'Spidroin_repeat', 5, NULL),
(34593, NULL, 'IPR045174', NULL, 'Dof zinc finger protein', 'Dof', 4, NULL),
(34594, NULL, 'IPR044488', NULL, 'Aldo-keto reductase family 2E', 'AKR2E', 4, NULL),
(34595, NULL, 'IPR044064', NULL, 'Zinc finger ZBR-type domain', 'ZF_ZBR', 3, NULL),
(34596, NULL, 'IPR044807', NULL, 'E3 ubiquitin protein ligase DRIP1-like', 'DRIP1-like', 4, NULL),
(34597, NULL, 'IPR044409', NULL, 'PRDM15, PR/SET domain', 'PRDM15_PR-SET', 3, NULL),
(34598, NULL, 'IPR043257', NULL, 'Ring-hydroxylating dioxygenase large subunit  NdoB-related protein, N-terminal Rieske domain', 'Rieske_N', 3, NULL),
(34599, NULL, 'IPR044080', NULL, 'MDM2, modified RING finger, HC subclass', 'MDM2_mRING-HC-C2H2C4', 3, NULL),
(34600, NULL, 'IPR043513', NULL, 'Centromere protein Cenp-F', 'Cenp-F', 4, NULL),
(34601, NULL, 'IPR046386', NULL, 'RNA polymerase sigma-like factor', 'T4_sigma-like_factor', 4, NULL),
(34602, NULL, 'IPR044662', NULL, 'Stress-response A/B barrel domain-containing protein HS1/DABB1-like', 'HS1/DABB1-like', 4, NULL),
(34603, NULL, 'IPR044492', NULL, 'P-type ATPase, haloacid dehalogenase domain', 'P_typ_ATPase_HD_dom', 3, NULL),
(34604, NULL, 'IPR042746', NULL, 'EPH-A6 , SAM domain', 'EPH-A6_SAM', 3, NULL),
(34605, NULL, 'IPR045193', NULL, 'Serine/threonine-protein kinase Fused-like', 'Fused-like', 4, NULL),
(34606, NULL, 'IPR043666', NULL, 'Flap endonuclease D15-like', 'FEN_D15-like', 4, NULL),
(34607, NULL, 'IPR042417', NULL, 'Partner and localizer of BRCA2', 'PALB2', 4, NULL),
(34608, NULL, 'IPR044241', NULL, 'Thiol:disulfide interchange protein TxlA/HCF164', 'TxlA/HCF164', 4, NULL),
(34609, NULL, 'IPR042289', NULL, 'Cytochrome c oxidase assembly factor 6 homolog', 'COA6', 4, NULL),
(34610, NULL, 'IPR044225', NULL, 'Ent-kaurene oxidase, chloroplastic', 'KO_chloroplastic', 4, NULL),
(34611, NULL, 'IPR046385', NULL, 'Cell division protein DrpB', 'DrpB', 4, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(34612, NULL, 'IPR043181', NULL, 'Tymovirus endopeptidase domain', 'TYMV_endopept_dom', 5, NULL),
(34613, NULL, 'IPR043512', NULL, 'Mu2, C-terminal domain', 'Mu2_C', 3, NULL),
(34614, NULL, 'IPR043184', NULL, 'Extracellular matrix protein 2', 'ECM2', 4, NULL),
(34615, NULL, 'IPR042574', NULL, 'Alpha-(1,3)-fucosyltransferase FucT, N-terminal domain superfamily', 'FucT_N_sf', 5, NULL),
(34616, NULL, 'IPR044230', NULL, 'General transcription factor 3C polypeptide 4', 'GTF3C4', 4, NULL),
(34617, NULL, 'IPR044408', NULL, 'PRDM14, PR/SET domain', 'PRDM14_PR-SET', 3, NULL),
(34618, NULL, 'IPR044075', NULL, 'PRKCBP1, PHD finger', 'PRKCBP1_PHD', 3, NULL),
(34619, NULL, 'IPR044857', NULL, 'Type VII secretion system EccB, repeat 1 domain', 'T7SS_EccB_R1', 5, NULL),
(34620, NULL, 'IPR042316', NULL, 'IRK-interacting protein-like', 'IRKI-like', 4, NULL),
(34621, NULL, 'IPR042355', NULL, 'IGF-like family receptor 1', 'IGFLR1', 4, NULL),
(34622, NULL, 'IPR043189', NULL, 'Beta-1,4-glucuronyltransferase 1', 'B4GAT1', 4, NULL),
(34623, NULL, 'IPR045008', NULL, 'Acyl-coenzyme A oxidase 4-like', 'ACX4-like', 4, NULL),
(34624, NULL, 'IPR044216', NULL, 'Protein WVD2-like 7', 'WDL7', 4, NULL),
(34625, NULL, 'IPR044992', NULL, 'Glutamine amidotransferase domain containing protein ChyE-like', 'ChyE-like', 4, NULL),
(34626, NULL, 'IPR042791', NULL, 'CDK5 regulatory subunit-associated protein 2', 'CDK5RAP2', 4, NULL),
(34627, NULL, 'IPR043178', NULL, 'Papain-like protease, thumb domain superfamily, coronavirus', 'PLpro_thumb_sf_CoV', 5, NULL),
(34628, NULL, 'IPR044170', NULL, 'Protein RICE SALT SENSITIVE 3-like', 'RSS3-like', 4, NULL),
(34629, NULL, 'IPR044317', NULL, 'Nonstructural protein 14, deltacoronavirus', 'NSP14_deltaCoV', 3, NULL),
(34630, NULL, 'IPR042351', NULL, 'Uncharacterized protein C3orf18-like', 'C3orf18-like', 4, NULL),
(34631, NULL, 'IPR044533', NULL, 'FCS-Like Zinc finger 1/2/3', 'FLZ1/2/3', 4, NULL),
(34632, NULL, 'IPR044772', NULL, 'Nitrate transporter', 'NO3_transporter', 4, NULL),
(34633, NULL, 'IPR042423', NULL, 'PiggyBac transposable element-derived protein 5', 'PGBD5', 4, NULL),
(34634, NULL, 'IPR045104', NULL, 'Alfin', 'Alfin', 4, NULL),
(34635, NULL, 'IPR044226', NULL, 'Aquaporin SIP2-1-like', 'SIP2-1-like', 4, NULL),
(34636, NULL, 'IPR043878', NULL, 'Protein of unknown function DUF5854', 'DUF5854', 4, NULL),
(34637, NULL, 'IPR044207', NULL, 'F-box protein At5g39250-like', 'At5g39250-like', 4, NULL),
(34638, NULL, 'IPR044232', NULL, 'Plant UBX domain-containing protein 1', 'PUX1', 4, NULL),
(34639, NULL, 'IPR042174', NULL, 'DNA-binding RecF, domain 2', 'RecF_2', 5, NULL),
(34640, NULL, 'IPR043828', NULL, 'Protein of unknown function DUF5805', 'DUF5805', 4, NULL),
(34641, NULL, 'IPR044497', NULL, 'Aldo-keto reductase family 4A/B', 'AKR4A/B', 4, NULL),
(34642, NULL, 'IPR044443', NULL, '54S ribosomal protein L3, double-stranded RNA binding domain', 'MRPL3-like_DSRM', 3, NULL),
(34643, NULL, 'IPR044737', NULL, 'TopBP1, first BRCT domain', 'TopBP1_BRCT_1', 3, NULL),
(34644, NULL, 'IPR043124', NULL, 'DNA terminal protein Gp3, C-terminal', 'DNA_terminal_Gp3_C', 5, NULL),
(34645, NULL, 'IPR044715', NULL, 'WD repeat-containing protein 86-like', 'WDR86-like', 4, NULL),
(34646, NULL, 'IPR043615', NULL, 'Nonstructural protein 2, N-terminal domain, coronavirus', 'NSP2_N_CoV', 3, NULL),
(34647, NULL, 'IPR044309', NULL, 'Non-structural protein 5, alphacoronavirus', 'NSP5_Mpro_alphaCoV', 3, NULL),
(34648, NULL, 'IPR045425', NULL, 'Protein of unknown function DUF6508', 'DUF6508', 4, NULL),
(34649, NULL, 'IPR043756', NULL, 'Protein of unknown function DUF5702', 'DUF5702', 4, NULL),
(34650, NULL, 'IPR043193', NULL, 'Glyoxalase domain-containing protein 4', 'GLOD4', 4, NULL),
(34651, NULL, 'IPR044534', NULL, 'TPR repeat-containing thioredoxin TTL1-4', 'TTL1-4', 4, NULL),
(34652, NULL, 'IPR046384', NULL, 'Late transcription coactivator, myovirus', 'LTACT_myovirus', 4, NULL),
(34653, NULL, 'IPR043678', NULL, 'Sulfopropanediol 3-dehydrogenase', 'Sulfopropanediol_dehydrog_HpsN', 4, NULL),
(34654, NULL, 'IPR045351', NULL, 'Domain of unknown function DUF6531', 'DUF6531', 3, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(34655, NULL, 'IPR044702', NULL, 'Arabinogalactan protein 23/40', 'AGP23/40', 4, NULL),
(34656, NULL, 'IPR044243', NULL, 'Protein FLUORESCENT IN BLUE LIGHT', 'FLU', 4, NULL),
(34657, NULL, 'IPR044850', NULL, 'Cysteine-rich and transmembrane domain-containing protein WIH1-like', 'WIH1-like', 4, NULL),
(34658, NULL, 'IPR044208', NULL, 'Peptidyl-prolyl cis-trans isomerase FKBP19-like', 'FKBP19-like', 4, NULL),
(34659, NULL, 'IPR043169', NULL, 'Phosphomannomutase, cap domain', 'PMM_cap', 5, NULL),
(34660, NULL, 'IPR043125', NULL, 'Vibrio cholerae toxin co-regulated pilus biosynthesis F, C-terminal', 'TcpF_C', 5, NULL),
(34661, NULL, 'IPR044536', NULL, 'Peroxisomal targeting signal 2 receptor', 'PEX7', 4, NULL),
(34662, NULL, 'IPR044791', NULL, 'Beta-glucanase/XTH', 'Beta-glucanase/XTH', 4, NULL),
(34663, NULL, 'IPR044621', NULL, 'Protein NEDD1', 'NEDD1', 4, NULL),
(34664, NULL, 'IPR044726', NULL, 'ABC transporter C family, six-transmembrane helical domain 2', 'ABCC_6TM_D2', 3, NULL),
(34665, NULL, 'IPR045015', NULL, 'C-terminal binding protein AN-like', 'AN-like', 4, NULL),
(34666, NULL, 'IPR044955', NULL, 'Cytochrome c biogenesis CcmF C-terminal-like mitochondrial protein', 'CCMFC', 4, NULL),
(34667, NULL, 'IPR044524', NULL, 'Histidine biosynthesis, HisA-like', 'Isoase_HisA-like', 4, NULL),
(34668, NULL, 'IPR044279', NULL, 'Sorting nexin 2A/B', 'SNX2A/B', 4, NULL),
(34669, NULL, 'IPR043243', NULL, 'Small cell adhesion glycoprotein', 'SMAGP', 4, NULL),
(34670, NULL, 'IPR043133', NULL, 'GTP cyclohydrolase I, C-terminal/NADPH-dependent 7-cyano-7-deazaguanine reductase', 'GTP-CH-I_C/QueF', 5, NULL),
(34671, NULL, 'IPR044495', NULL, 'Aldo-keto reductase family 3D', 'AKR3D', 4, NULL),
(34672, NULL, 'IPR043165', NULL, 'Pseudouridine synthase, TruD, insertion domain superfamily', 'TruD_insert_sf', 5, NULL),
(34673, NULL, 'IPR042320', NULL, 'Protein MMS22-like', 'MMS22-like', 4, NULL),
(34674, NULL, 'IPR044138', NULL, 'Sulfate adenylyltransferase subunit CysN, Domain II', 'CysN_II', 3, NULL),
(34675, NULL, 'IPR044691', NULL, 'Thioredoxin DCC1', 'DCC1_Trx', 4, NULL),
(34676, NULL, 'IPR043614', NULL, 'Spike glycoprotein S2, coronavirus, C-terminal', 'Spike_S2_CoV_C', 3, NULL),
(34677, NULL, 'IPR043176', NULL, 'NlpE, N-terminal domain superfamily', 'NlpE_N_sf', 5, NULL),
(34678, NULL, 'IPR043134', NULL, 'GTP cyclohydrolase I, N-terminal domain', 'GTP-CH-I_N', 5, NULL),
(34679, NULL, 'IPR043202', NULL, 'Band-7 stomatin-like', 'Band-7_stomatin-like', 4, NULL),
(34680, NULL, 'IPR046387', NULL, 'Carboxysome shell vertex protein CcmL', 'CcmL', 4, NULL),
(34681, NULL, 'IPR042161', NULL, 'Tetratricopeptide repeat protein 34', 'TTC34', 4, NULL),
(34682, NULL, 'IPR044222', NULL, 'Aquaporin SIP1-1/2-like', 'SIP1-1/2-like', 4, NULL),
(34683, NULL, 'IPR043691', NULL, 'Murein peptide amidase A', 'MpaA', 4, NULL),
(34684, NULL, 'IPR044748', NULL, 'Trm3/ TARBP1, C-terminal', 'Trm3/TARBP1_C', 3, NULL),
(34685, NULL, 'IPR044194', NULL, 'Protein BLISTER', 'BLISTER', 4, NULL),
(34686, NULL, 'IPR043166', NULL, 'LarA-like, C-terminal domain', 'LarA-like_C', 5, NULL),
(34687, NULL, 'IPR043083', NULL, 'Gp27, baseplate hub, domain 3', 'Gp27_dom3', 5, NULL),
(34688, NULL, 'IPR043638', NULL, 'DisA glycoprotein', 'DisA_glycoprotein', 4, NULL),
(34689, NULL, 'IPR043250', NULL, 'Cystatin-9-like', 'CST9-like', 4, NULL),
(34690, NULL, 'IPR044709', NULL, 'Microtubule-binding protein TANGLED1', 'TAN1', 4, NULL),
(34691, NULL, 'IPR045347', NULL, 'HIND motif', 'HIND', 2, NULL),
(34692, NULL, 'IPR044569', NULL, 'Protein disulfide-isomerase A6-like', 'PDIA6-like', 4, NULL),
(34693, NULL, 'IPR044178', NULL, 'Peptidyl-prolyl cis-trans isomerase CYP28-like', 'CYP28-like', 4, NULL),
(34694, NULL, 'IPR042572', NULL, 'Carnitine o-acyltransferase, N-terminal', 'Carn_acyl_trans_N', 5, NULL),
(34695, NULL, 'IPR044788', NULL, 'Carbohydrate-binding X8 domain-containing protein, plant', 'X8_dom_prot', 4, NULL),
(34696, NULL, 'IPR045175', NULL, 'Peptidase M28 family', 'M28_fam', 4, NULL),
(34697, NULL, 'IPR042266', NULL, 'PPPDE peptidase domain superfamily', 'PPPDE_sf', 5, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(34698, NULL, 'IPR044206', NULL, 'EG45-like domain containing protein, plant', 'EGC1/2', 4, NULL),
(34699, NULL, 'IPR046381', NULL, 'RuBisCO chaperone RbcX', 'RbcX', 4, NULL),
(34700, NULL, 'IPR044689', NULL, 'Pectin methyltransferase CGR2/3', 'CGR2/3', 4, NULL),
(34701, NULL, 'IPR044489', NULL, 'Aldo-keto reductase family 3A', 'AKR3A', 4, NULL),
(34702, NULL, 'IPR044738', NULL, 'Autophagy-related protein 22', 'Atg22', 4, NULL),
(34703, NULL, 'IPR045273', NULL, 'Receptor-like protein RLP12/44/30/35', 'RLP12/44/30/35', 4, NULL),
(34704, NULL, 'IPR042123', NULL, 'Zip3/RNF212-like', 'Zip3/RNF212-like', 4, NULL),
(34705, NULL, 'IPR042781', NULL, 'Syntaxin 11, SNARE motif', 'Syntaxin11_SNARE', 3, NULL),
(34706, NULL, 'IPR042185', NULL, 'Serpin superfamily, domain 2', 'Serpin_sf_2', 5, NULL),
(34707, NULL, 'IPR043100', NULL, 'Extracytoplasmic thiamine-binding lipoprotein, domain II', 'CypI_dom_II', 5, NULL),
(34708, NULL, 'IPR044260', NULL, 'F-box protein SKIP8-like', 'SKIP8-like', 4, NULL),
(34709, NULL, 'IPR045185', NULL, 'E3 ubiquitin-protein ligase PUB22/23/24-like', 'PUB22/23/24-like', 4, NULL),
(34710, NULL, 'IPR043881', NULL, 'Protein of unknown function DUF5851', 'DUF5851', 4, NULL),
(34711, NULL, 'IPR044777', NULL, 'Solute carrier family 17 member 9-like', 'SLC17A9-like', 4, NULL),
(34712, NULL, 'IPR042747', NULL, 'IRAK3, death domain', 'IRAK3_death', 3, NULL),
(34713, NULL, 'IPR043896', NULL, 'AbpIP induction peptide', 'AbpIP', 4, NULL),
(34714, NULL, 'IPR043898', NULL, 'FANCL, UBC-like domain 2', 'FANCL_d2', 3, NULL),
(34715, NULL, 'IPR043194', NULL, 'Glyoxalase domain-containing protein 4, C-terminal', 'GLOD4_C', 3, NULL),
(34716, NULL, 'IPR044717', NULL, 'Nicotinamidase 1', 'NIC1', 4, NULL),
(34717, NULL, 'IPR043889', NULL, 'Protein of unknown function DUF5843', 'DUF5843', 4, NULL),
(34718, NULL, 'IPR044590', NULL, 'Probable calcium-binding protein CML48/49/50', 'CML48/49/50', 4, NULL),
(34719, NULL, 'IPR044806', NULL, 'Protein WAVE-DAMPENED 2-like', 'WVD2/WDL1-4', 4, NULL),
(34720, NULL, 'IPR044730', NULL, 'Ribonuclease H-like domain, plant type', 'RNase_H-like_dom_plant', 3, NULL),
(34721, NULL, 'IPR045196', NULL, 'Translation initiation factor IF2/IF5', 'IF2/IF5', 4, NULL),
(34722, NULL, 'IPR044847', NULL, 'Transcription repressor KANADI', 'KAN_fam', 4, NULL),
(34723, NULL, 'IPR043204', NULL, 'Basigin-like', 'Basigin-like', 4, NULL),
(34724, NULL, 'IPR043972', NULL, 'FUZ/MON1/HPS1, first Longin domain', 'FUZ/MON1/HPS1_longin_1', 3, NULL),
(34725, NULL, 'IPR046382', NULL, 'Rubisco accumulation factor 1, cyanobacterial', 'Raf1_cyn', 4, NULL),
(34726, NULL, 'IPR043313', NULL, 'Leucine-rich melanocyte differentiation-associated protein', 'LRMDA', 4, NULL),
(34727, NULL, 'IPR043689', NULL, 'UDP-N-acetyl-alpha-D-muramoyl-L-alanyl-L-glutamate epimerase MurL', 'MurL', 4, NULL),
(34728, NULL, 'IPR043646', NULL, 'Chroparavirus methyltransferase domain', 'Chropara_Vmeth_dom', 3, NULL),
(34729, NULL, 'IPR043855', NULL, 'Domain of unknown function DUF5817', 'DUF5817', 3, NULL),
(34730, NULL, 'IPR045333', NULL, 'ARMET-like', 'ARMET-like', 4, NULL),
(34731, NULL, 'IPR044740', NULL, 'Glucose-6-phosphate exchanger SLC37A1/ SLC37A2', 'SLC37A1_2', 4, NULL),
(34732, NULL, 'IPR045897', NULL, 'Lipid binding protein BPI/LBP, plants', 'BPI/LBP_pln', 4, NULL),
(34733, NULL, 'IPR042247', NULL, 'T-cell leukemia homeobox protein 1/2/3', 'TLX1/2/3', 4, NULL),
(34734, NULL, 'IPR044527', NULL, 'Nitrate/bicarbonate ABC transporter substrate-binding domain', 'NrtA/CpmA_ABC-bd_dom', 3, NULL),
(34735, NULL, 'IPR042796', NULL, 'Chromobox protein homolog 2', 'CBX2', 4, NULL),
(34736, NULL, 'IPR042284', NULL, 'S-adenosylmethionine decarboxylase, N-terminal', 'AdoMetDC_N', 5, NULL),
(34737, NULL, 'IPR042981', NULL, 'RING finger protein 11, RING-H2 finger', 'RNF11_RING-H2', 3, NULL),
(34738, NULL, 'IPR044846', NULL, 'Glycoside hydrolase family 10', 'GH10', 4, NULL),
(34739, NULL, 'IPR045899', NULL, 'Putative RING-H2 finger protein ATL71-like', 'ATL71-like', 4, NULL),
(34740, NULL, 'IPR045478', NULL, 'Exportin-5, C-terminal domain', 'Exportin-5_C', 3, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(34741, NULL, 'IPR043443', NULL, 'FYN-binding protein 1/2-like', 'FYB1/2-like', 4, NULL),
(34742, NULL, 'IPR043699', NULL, 'tRNA (cytosine(72)-C(5))-methyltransferase', 'NSUN6', 4, NULL),
(34743, NULL, 'IPR044237', NULL, 'Histone-lysine N-methyltransferase ATXR2-like', 'ATXR2-like', 4, NULL),
(34744, NULL, 'IPR045477', NULL, 'FtsH ternary systems, vWA domain', 'ivWA', 3, NULL),
(34745, NULL, 'IPR044439', NULL, 'EZH2, SET domain', 'EZH2_SET', 3, NULL),
(34746, NULL, 'IPR044402', NULL, 'PRDM8, PR/SET domain', 'PRDM8_PR/SET', 3, NULL),
(34747, NULL, 'IPR043317', NULL, 'Ubiquitin-like protein 4B', 'UBL4B', 4, NULL),
(34748, NULL, 'IPR044235', NULL, 'RING finger and transmembrane domain-containing protein 1/2', 'RNFT1/2', 4, NULL),
(34749, NULL, 'IPR043892', NULL, 'Protein of unknown function DUF5841', 'DUF5841', 4, NULL),
(34750, NULL, 'IPR044793', NULL, 'E3 ubiquitin-protein ligase SIS3', 'SIS3', 4, NULL),
(34751, NULL, 'IPR043163', NULL, 'DsrC-like protein, N-terminal domain', 'DsrC-like_N', 5, NULL),
(34752, NULL, 'IPR042510', NULL, 'Protein CIP2A', 'CIP2A', 4, NULL),
(34753, NULL, 'IPR045329', NULL, 'Leucine zipper putative tumor suppressor', 'LZTS', 4, NULL),
(34754, NULL, 'IPR044483', NULL, 'Aldo-keto reductase family 1 member D1', 'AKR1D1', 4, NULL),
(34755, NULL, 'IPR042271', NULL, 'Zinicin-like metallopeptidase type 2, N-terminal', 'Zinicin_2_N', 5, NULL),
(34756, NULL, 'IPR043180', NULL, 'Baseplate structural protein Gp11, C-terminal domain', 'Baseplate_struct_Gp11_C', 5, NULL),
(34757, NULL, 'IPR044697', NULL, '(S)-ureidoglycine aminohydrolase, C-terminal cupin domain', 'UGlyAH_cupin_C', 3, NULL),
(34758, NULL, 'IPR044808', NULL, 'Ethylene-responsive transcription factor', 'ERF_plant', 4, NULL),
(34759, NULL, 'IPR044522', NULL, 'CRC domain-containing protein TSO1-like', 'TSO1-like', 4, NULL),
(34760, NULL, 'IPR043874', NULL, 'Protein of unknown function DUF5834', 'DUF5834', 4, NULL),
(34761, NULL, 'IPR044779', NULL, 'SS18 family', 'SS18', 4, NULL),
(34762, NULL, 'IPR042163', NULL, 'PHD finger protein 12', 'PHF12', 4, NULL),
(34763, NULL, 'IPR045192', NULL, 'Clathrin coat assembly protein AP180-like', 'AP180-like', 4, NULL),
(34764, NULL, 'IPR044810', NULL, 'WRKY transcription factor, plant', 'WRKY_plant', 4, NULL),
(34765, NULL, 'IPR045876', NULL, 'Pathogenesis-related homeodomain protein, PHD finger', 'PRHA-like_PHD-finger', 3, NULL),
(34766, NULL, 'IPR044293', NULL, 'Transcription factor PRE', 'PRE', 4, NULL),
(34767, NULL, 'IPR044725', NULL, 'CBS domain-containing protein CBSX3, CBS domain', 'CBSX3_CBS_dom', 3, NULL),
(34768, NULL, 'IPR044500', NULL, 'Aldo-keto reductase family 5G', 'AKR5G', 4, NULL),
(34769, NULL, 'IPR042534', NULL, 'Sin3 associated polypeptide p18 superfamily', 'SAP18_sf', 5, NULL),
(34770, NULL, 'IPR043268', NULL, 'Protein unc-93 homolog B1', 'UNC93B1', 4, NULL),
(34771, NULL, 'IPR043923', NULL, 'Protein of unknown function DUF5774', 'DUF5774', 4, NULL),
(34772, NULL, 'IPR042184', NULL, 'YqeY/Aim41, N-terminal domain', 'YqeY/Aim41_N', 5, NULL),
(34773, NULL, 'IPR042190', NULL, 'Killer cell lectin-like receptor subfamily G member 1', 'KLRG1', 4, NULL),
(34774, NULL, 'IPR042261', NULL, 'Lsr2, dimerization domain', 'Lsr2_dimerization', 5, NULL),
(34775, NULL, 'IPR044790', NULL, 'Mediator of RNA polymerase II transcription subunit 26c-like', 'MD26C-like', 4, NULL),
(34776, NULL, 'IPR042259', NULL, 'RACo, middle domain superfamily', 'Raco_middle_sf', 5, NULL),
(34777, NULL, 'IPR042279', NULL, 'Peptidase M60, enhancin-like domain 3', 'Pep_M60_3', 5, NULL),
(34778, NULL, 'IPR042352', NULL, 'EF-hand calcium-binding domain-containing protein 14', 'EFCAB14', 4, NULL),
(34779, NULL, 'IPR042570', NULL, 'Non-structural protein NSP3, nucleic acid-binding domain superfamily, betacoronavirus', 'NSP3_NAB_bCoV_sf', 5, NULL),
(34780, NULL, 'IPR045422', NULL, 'Protein of unknown function DUF6511', 'DUF6511', 4, NULL),
(34781, NULL, 'IPR044231', NULL, 'E3 ubiquitin-protein ligase SP1-like', 'SP1/SPL1', 4, NULL),
(34782, NULL, 'IPR042120', NULL, 'MutL, C-terminal domain, dimerisation subdomain', 'MutL_C_dimsub', 5, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(34783, NULL, 'IPR043185', NULL, 'Dnt1/Tof2/Net1', 'Dnt1/Tof2/Net1', 4, NULL),
(34784, NULL, 'IPR044156', NULL, 'Galectin-like', 'Galectin-like', 4, NULL),
(34785, NULL, 'IPR044587', NULL, 'Heat shock protein 21-like', 'HSP21-like', 4, NULL),
(34786, NULL, 'IPR044217', NULL, 'ATP-dependent Clp protease ATP-binding subunit CLPT1/2', 'CLPT1/2', 4, NULL),
(34787, NULL, 'IPR042263', NULL, 'Diphthamide synthesis DPH1/DPH2, domain 1', 'DPH1/DPH2_1', 5, NULL),
(34788, NULL, 'IPR044191', NULL, 'Chalcone--flavonone isomerase 3-like', 'CHI3-like', 4, NULL),
(34789, NULL, 'IPR044773', NULL, 'DDX18/Has1, DEAD-box helicase domain', 'DDX18/Has1_DEADc', 3, NULL),
(34790, NULL, 'IPR044411', NULL, 'PRDM3, PR/SET domain', 'PRDM3_PR-SET', 3, NULL),
(34791, NULL, 'IPR042186', NULL, 'Outer membrane usher protein FimD, plug domain', 'FimD_plug_dom', 5, NULL),
(34792, NULL, 'IPR043444', NULL, 'Protein  TESPA1-like', 'TESPA1-like', 4, NULL),
(34793, NULL, 'IPR043962', NULL, 'Protein of unknown function DUF5750', 'DUF5750', 4, NULL),
(34794, NULL, 'IPR044490', NULL, 'Aldo-keto reductase family 3B', 'AKR3B', 4, NULL),
(34795, NULL, 'IPR044414', NULL, 'PRDM2, PR/SET domain', 'PRDM2_PR-SET', 3, NULL),
(34796, NULL, 'IPR045348', NULL, 'CPSF complex subunit CPSF4-like', 'CPSF4/Yth1', 4, NULL),
(34797, NULL, 'IPR043662', NULL, 'NAD-protein ADP-ribosyltransferase ModB-like', 'ModB-like', 4, NULL),
(34798, NULL, 'IPR044796', NULL, 'Protein MLN51 homolog, plant', 'MLN51_plant', 4, NULL),
(34799, NULL, 'IPR044526', NULL, 'Protein SODIUM POTASSIUM ROOT DEFECTIVE 1-3/ATX1', 'NAKR1-3/ATX1', 4, NULL),
(34800, NULL, 'IPR044642', NULL, 'U6 snRNA-associated Sm-like protein Lsm1/8', 'PTHR15588', 4, NULL),
(34801, NULL, 'IPR042789', NULL, 'DOMON domain-containing protein FRRS1L', 'FRRS1L', 4, NULL),
(34802, NULL, 'IPR043680', NULL, 'Tape measure protein', 'GpH_LAMBDA', 4, NULL),
(34803, NULL, 'IPR044705', NULL, 'COFACTOR ASSEMBLY OF COMPLEX C SUBUNIT B CCB4', 'CCB4', 4, NULL),
(34804, NULL, 'IPR044693', NULL, 'Shugoshin, plant', 'SGO_plant', 4, NULL),
(34805, NULL, 'IPR042987', NULL, 'Rho guanine nucleotide exchange factor 39', 'ARHGEF39', 4, NULL),
(34806, NULL, 'IPR043539', NULL, 'Grb2-like', 'Grb2-like', 4, NULL),
(34807, NULL, 'IPR044090', NULL, 'Nei2, N-terminal', 'Nei2_N', 3, NULL),
(34808, NULL, 'IPR042983', NULL, 'Extracellular tyrosine-protein kinase PKDCC', 'PKDCC', 4, NULL),
(34809, NULL, 'IPR042176', NULL, 'Pantoate-beta-alanine ligase, C-terminal domain', 'Pantoate_ligase_C', 5, NULL),
(34810, NULL, 'IPR045188', NULL, 'PH domain containing protein Boi1/Boi2-like', 'Boi1/Boi2-like', 4, NULL),
(34811, NULL, 'IPR045907', NULL, 'E3 ubiquitin-protein ligase RNF43, Zinc finger, RING-type', 'RNF43_Znf_RING', 3, NULL),
(34812, NULL, 'IPR043088', NULL, 'Surface-adhesin protein E', 'Adhesin_E', 5, NULL),
(34813, NULL, 'IPR044695', NULL, '30S ribosomal protein S31, plant', 'RPS31_plant', 4, NULL),
(34814, NULL, 'IPR043162', NULL, 'Dedicator of cytokinesis, C-terminal, lobe C', 'DOCK_C_lobe_C', 5, NULL),
(34815, NULL, 'IPR042122', NULL, 'Serine acetyltransferase, N-terminal domain superfamily', 'Ser_AcTrfase_N_sf', 5, NULL),
(34816, NULL, 'IPR044729', NULL, 'CBS domain-containing protein, bacteria', 'CBS_bac', 3, NULL),
(34817, NULL, 'IPR043170', NULL, 'Phosphotyrosyl phosphatase activator, C-terminal lid domain', 'PTPA_C_lid', 5, NULL),
(34818, NULL, 'IPR044692', NULL, 'WPP domain-containing protein 1/2/3', 'WPP1/2/3', 4, NULL),
(34819, NULL, 'IPR043970', NULL, 'FUZ/MON1/HPS1, third Longin domain', 'FUZ/MON1/HPS1_longin_3', 3, NULL),
(34820, NULL, 'IPR043379', NULL, 'Ankyrin and armadillo repeat-containing protein', 'ANKAR', 4, NULL),
(34821, NULL, 'IPR043521', NULL, 'Tumor necrosis factor receptor 13C/17', 'TNFR_13C/17', 4, NULL),
(34822, NULL, 'IPR045308', NULL, 'UbiB domain, bacteria', 'UbiB_bact', 3, NULL),
(34823, NULL, 'IPR044789', NULL, 'Putative alpha 1,4-glycosyltransferase, plant', 'Put_A1-4-GlycosylTfrase_plant', 4, NULL),
(34824, NULL, 'IPR045189', NULL, 'E3 ubiquitin ligase UBR4-like', 'UBR4-like', 4, NULL),
(34825, NULL, 'IPR044209', NULL, 'Protein MODIFIER OF SNC1 11', 'MOS11', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(34826, NULL, 'IPR044835', NULL, 'Auxin response factor', 'ARF_plant', 4, NULL),
(34827, NULL, 'IPR043378', NULL, 'Paired mesoderm homeobox protein 1/2', 'PRRX1/2', 4, NULL),
(34828, NULL, 'IPR043141', NULL, 'Ribosomal protein L10-like domain superfamily', 'Ribosomal_L10-like_sf', 5, NULL),
(34829, NULL, 'IPR043132', NULL, 'Branched-chain-amino-acid aminotransferase-like, C-terminal', 'BCAT-like_C', 5, NULL),
(34830, NULL, 'IPR043658', NULL, 'Protein of unknown function DUF5875', 'DUF5875', 4, NULL),
(34831, NULL, 'IPR043174', NULL, 'Non-structural protein NSP15, middle domain superfamily', 'NSP15_middle_sf', 5, NULL),
(34832, NULL, 'IPR043873', NULL, 'Domain of unknown function DUF5858', 'DUF5858', 3, NULL),
(34833, NULL, 'IPR043320', NULL, 'ASH1-like, Bromodomain', 'Bromo_ASH1L', 3, NULL),
(34834, NULL, 'IPR043171', NULL, 'Ap4A phosphorylase 1/2-like', 'Ap4A_phos1/2-like', 5, NULL),
(34835, NULL, 'IPR044987', NULL, 'Uncharacterized mitochondrial protein AtMg00030-like', 'AtMg00030-like', 4, NULL),
(34836, NULL, 'IPR043964', NULL, 'TraG, P-loop domain', 'P-loop_TraG', 3, NULL),
(34837, NULL, 'IPR044694', NULL, 'Nuclear pore complex protein NUP214', 'NUP214', 4, NULL),
(34838, NULL, 'IPR044078', NULL, 'Mot1, ATP-binding domain', 'Mot1_ATP-bd', 3, NULL),
(34839, NULL, 'IPR042264', NULL, 'Diphthamide synthesis DPH1/DPH2, domain 2', 'DPH1/DPH2_2', 5, NULL),
(34840, NULL, 'IPR044727', NULL, 'Kelch-like protein 42, BTB and C-terminal Kelch domain', 'KLHL42_BACK', 3, NULL),
(34841, NULL, 'IPR044684', NULL, 'Rhodanese-like domain-containing protein STR17/STR18/HARC1-like', 'STR17/STR18/HARC1-like', 4, NULL),
(34842, NULL, 'IPR043687', NULL, 'UDP-N-acetylmuramoyl-L-alanine--L-glutamate ligase MurD2', 'MurD2', 4, NULL),
(34843, NULL, 'IPR044708', NULL, 'Constitutive expression of pathogenesis-related genes 5', 'CPR5', 4, NULL),
(34844, NULL, 'IPR044376', NULL, 'Spike (S) protein S1 subunit, receptor-binding domain, MERS-CoV', 'Spike_S1_RBD_MERS-CoV', 3, NULL),
(34845, NULL, 'IPR042172', NULL, 'Adenosylhomocysteinase-like superfamily', 'Adenosylhomocyst_ase-like_sf', 5, NULL),
(34846, NULL, 'IPR043374', NULL, 'GPCR-associated sorting protein', 'BHLHb9/GASP-1/GASP-2', 4, NULL),
(34847, NULL, 'IPR043630', NULL, 'Sgo0707, N-terminal domain', 'Sgo0707_N1', 3, NULL),
(34848, NULL, 'IPR044126', NULL, 'IF2a, S1-like domain', 'S1_IF2_alpha', 3, NULL),
(34849, NULL, 'IPR045494', NULL, 'Domain of unknown function DUF6436', 'DUF6436', 3, NULL),
(34850, NULL, 'IPR044786', NULL, 'YeaK', 'YeaK', 4, NULL),
(34851, NULL, 'IPR044823', NULL, 'Trihelix transcription factor ASIL1/2-like', 'ASIL1/2-like', 4, NULL),
(34852, NULL, 'IPR042481', NULL, 'Coiled-coil domain-containing protein 57', 'CCDC57', 4, NULL),
(34853, NULL, 'IPR043758', NULL, 'Protein of unknown function DUF5703', 'DUF5703', 4, NULL),
(34854, NULL, 'IPR044218', NULL, 'Protein SWEETIE', 'SWEETIE', 4, NULL),
(34855, NULL, 'IPR042986', NULL, 'Pleckstrin homology domain-containing family S member 1', 'PLEKHS1', 4, NULL),
(34856, NULL, 'IPR044463', NULL, 'DUS2, double-stranded RNA binding domain', 'DUS2_DSRM', 3, NULL),
(34857, NULL, 'IPR042164', NULL, 'Solute carrier family 25 member 44', 'SLC25A44', 4, NULL),
(34858, NULL, 'IPR042274', NULL, 'Regulatory protein YycH/YycI , domain 2', 'YycH/YycI_2', 5, NULL),
(34859, NULL, 'IPR044713', NULL, 'DnaJ homolog subfamily A member 1/2-like', 'DNJA1/2-like', 4, NULL),
(34860, NULL, 'IPR043168', NULL, 'DegV, C-terminal domain', 'DegV_C', 5, NULL),
(34861, NULL, 'IPR044397', NULL, 'NendoU domain, porcine torovirus-like', 'NendoU_PToV-like', 3, NULL),
(34862, NULL, 'IPR045173', NULL, 'DNA replication factor Cdt1', 'Cdt1', 4, NULL),
(34863, NULL, 'IPR044528', NULL, 'Persulfide dioxygenase-like, MBL-fold metallo-hydrolase domain', 'POD-like_MBL-fold', 3, NULL),
(34864, NULL, 'IPR043428', NULL, 'High-affinity branched-chain amino acid transport system permease protein LivM-like', 'LivM-like', 4, NULL),
(34865, NULL, 'IPR044407', NULL, 'PRDM13, PR/SET domain', 'PRDM13_PR/SET', 3, NULL),
(34866, NULL, 'IPR044081', NULL, 'Domain of unknown function DUF5776', 'DUF5776', 3, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(34867, NULL, 'IPR043188', NULL, 'Doublecortin domain-containing protein 1', 'DCDC1', 4, NULL),
(34868, NULL, 'IPR044343', NULL, 'Nonstructural protein 13, 1B domain, coronavirus', 'NSP13_1B_dom_CoV', 3, NULL),
(34869, NULL, 'IPR042784', NULL, 'TRIM10, RING-HC finger', 'TRIM10_RING-HC', 3, NULL),
(34870, NULL, 'IPR044067', NULL, 'Picornavirales 3C/3C-like protease domain', 'PCV_3C_PRO', 3, NULL),
(34871, NULL, 'IPR043429', NULL, 'ABC transporter membrane protein permease protein ArtM/GltK/GlnP/TcyL/YhdX-like', 'ArtM/GltK/GlnP/TcyL/YhdX-like', 4, NULL),
(34872, NULL, 'IPR042119', NULL, 'QueA, domain 2', 'QueA_dom2', 5, NULL),
(34873, NULL, 'IPR043504', NULL, 'Peptidase S1, PA clan, chymotrypsin-like fold', 'Peptidase_S1_PA_chymotrypsin', 5, NULL),
(34874, NULL, 'IPR042162', NULL, 'Chaperone protein DnaJ 13', 'AtJ13', 4, NULL),
(34875, NULL, 'IPR042280', NULL, '4F2 cell-surface antigen heavy chain', 'SLC3A2', 4, NULL),
(34876, NULL, 'IPR043130', NULL, 'CDP-alcohol phosphatidyltransferase, transmembrane domain', 'CDP-OH_PTrfase_TM_dom', 5, NULL),
(34877, NULL, 'IPR042293', NULL, 'AT-rich interactive domain-containing protein 4', 'ARID4', 4, NULL),
(34878, NULL, 'IPR042272', NULL, 'ATP12, ATP synthase F1-assembly protein, N-terminal', 'ATP12_ATP_synth-F1-assembly_N', 5, NULL),
(34879, NULL, 'IPR042192', NULL, 'Glycophorin-C', 'Glycophorin-C', 4, NULL),
(34880, NULL, 'IPR044813', NULL, 'Acyl carrier protein, chloroplastic', 'ACP_chloroplastic', 4, NULL),
(34881, NULL, 'IPR044120', NULL, 'Nek8, catalytic domain', 'STKc_Nek8', 3, NULL),
(34882, NULL, 'IPR043160', NULL, 'Dynein heavy chain, C-terminal domain, barrel region', 'Dynein_C_barrel', 5, NULL),
(34883, NULL, 'IPR044224', NULL, 'Glycosyltransferase-like KOBITO 1', 'KOBITO1-like', 4, NULL),
(34884, NULL, 'IPR046388', NULL, 'Sliding-clamp-loader large subunit', 'T4_Clamp_Loader_L', 4, NULL),
(34885, NULL, 'IPR044202', NULL, 'LETM1/MDM38-like', 'LETM1/MDM38-like', 4, NULL),
(34886, NULL, 'IPR044259', NULL, 'Peptidyl-prolyl cis-trans isomerase CYP37-like', 'CYP37-like', 4, NULL),
(34887, NULL, 'IPR044539', NULL, 'Pachytene checkpoint protein 2-like', 'Pch2-like', 4, NULL),
(34888, NULL, 'IPR044491', NULL, 'Aldo-keto reductase family 3C1', 'AKR3C1', 4, NULL),
(34889, NULL, 'IPR045195', NULL, 'MGRN1/RNF157, modified RING finger, C3HC5-type', 'MGRN1/RNF157_mRING_C3HC5', 3, NULL),
(34890, NULL, 'IPR042988', NULL, 'Homeobox protein NOBOX', 'NOBOX', 4, NULL),
(34891, NULL, 'IPR043177', NULL, 'Papain-like protease, N-terminal domain superfamily, coronavirus', 'PLpro_N_sf_CoV', 5, NULL),
(34892, NULL, 'IPR044712', NULL, 'NAD/FAD transporter SLC25A32-like', 'SLC25A32-like', 4, NULL),
(34893, NULL, 'IPR042183', NULL, 'MmgE/PrpD superfamily, domain 1', 'MmgE/PrpD_sf_1', 5, NULL),
(34894, NULL, 'IPR044219', NULL, 'Alkaline ceramidase, plant', 'ACER_plant', 4, NULL),
(34895, NULL, 'IPR044087', NULL, '2-hydroxychromene-2-carboxylate isomerase NahD-like', 'NahD-like', 4, NULL),
(34896, NULL, 'IPR044310', NULL, 'mRNA-capping enzyme P5, phytoreovirus', 'P5_Phytoreov', 4, NULL),
(34897, NULL, 'IPR044523', NULL, 'RING domain-containing protein NIP1/2-like', 'NIP1/2-like', 4, NULL),
(34898, NULL, 'IPR044854', NULL, 'Signal transduction protein PmrD', 'PmrD_dom', 3, NULL),
(34899, NULL, 'IPR042512', NULL, 'TLC domain-containing protein 5', 'TLCD5', 4, NULL),
(34900, NULL, 'IPR045197', NULL, 'Nuclear pore membrane glycoprotein 210-like', 'NUP210-like', 4, NULL),
(34901, NULL, 'IPR045134', NULL, 'UHRF1/2-like', 'UHRF1/2-like', 4, NULL),
(34902, NULL, 'IPR044210', NULL, 'Transcription facto Tfc3-like', 'Tfc3-like', 4, NULL),
(34903, NULL, 'IPR045039', NULL, 'Acetyltransferase NSI-like', 'NSI-like', 4, NULL),
(34904, NULL, 'IPR044060', NULL, 'Bacterial repeat domain', 'Bacterial_rp_domain', 3, NULL),
(34905, NULL, 'IPR044288', NULL, 'E3 ubiquitin-protein ligase ZNF598/Hel2', 'ZNF598/Hel2', 4, NULL),
(34906, NULL, 'IPR043326', NULL, 'Slitrk family', 'Slitrk', 4, NULL),
(34907, NULL, 'IPR042473', NULL, 'V-type immunoglobulin domain-containing suppressor of T-cell activation', 'VISTA', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(34908, NULL, 'IPR044229', NULL, 'NO-associated protein 1', 'NOA1', 4, NULL),
(34909, NULL, 'IPR045155', NULL, 'Beta-lactamase class A, catalytic domain', 'Beta-lactam_cat', 3, NULL),
(34910, NULL, 'IPR043203', NULL, 'Voltage-gated cation channel calcium and sodium', 'VGCC_Ca_Na', 4, NULL),
(34911, NULL, 'IPR044520', NULL, 'ADP-ribosylation factor GTPase-activating protein AGD5/15', 'ARF_GAP_AGD5/15', 4, NULL),
(34912, NULL, 'IPR044173', NULL, 'Casparian strip membrane protein/CASP-like protein', 'CASPL', 4, NULL),
(34913, NULL, 'IPR043895', NULL, 'Protein of unknown function DUF5839', 'DUF5839', 4, NULL),
(34914, NULL, 'IPR044688', NULL, 'Style cell-cycle inhibitor 1-like', 'SCI-1-like', 4, NULL),
(34915, NULL, 'IPR042544', NULL, 'S-adenosylmethionine synthetase, domain 3', 'AdoMet_synthase_3', 5, NULL),
(34916, NULL, 'IPR044685', NULL, 'Protein ACCUMULATION AND REPLICATION OF CHLOROPLASTS 6-like', 'ARC6-like', 4, NULL),
(34917, NULL, 'IPR042278', NULL, 'Fimbrillin-like 1, N-terminal', 'Mfa-like_1_N', 5, NULL),
(34918, NULL, 'IPR044609', NULL, 'Peptidyl-prolyl cis-trans isomerase FKBP2/11', 'FKBP2/11', 4, NULL),
(34919, NULL, 'IPR043173', NULL, 'Prp8 RNase domain IV, fingers region', 'Prp8_domainIV_fingers', 5, NULL),
(34920, NULL, 'IPR045190', NULL, 'Methylcrotonoyl-CoA carboxylase beta chain MCCB/AccD1-like', 'MCCB/AccD1-like', 4, NULL),
(34921, NULL, 'IPR042106', NULL, 'NADH-ubiquinone/plastoquinone oxidoreductase chain 6, subunit NuoJ', 'Nuo/plastoQ_OxRdtase_6_NuoJ', 5, NULL),
(34922, NULL, 'IPR042160', NULL, 'Homeobox-leucine zipper protein GLABRA2/ANL2/PDF2/ATML1-like', 'GLABRA2/ANL2/PDF2/ATML1-like', 4, NULL),
(34923, NULL, 'IPR042281', NULL, 'GpdQ, beta-strand dimerisation domain', 'GpdQ_beta-strand', 5, NULL),
(34924, NULL, 'IPR044671', NULL, 'Metallothionein-like protein 3', 'MT3', 4, NULL),
(34925, NULL, 'IPR043167', NULL, 'LpxI, C-terminal domain superfamily', 'LpxI_C_sf', 5, NULL),
(34926, NULL, 'IPR044413', NULL, 'PRDM1, PR/SET domain', 'PRDM1_PR-SET', 3, NULL),
(34927, NULL, 'IPR044198', NULL, 'Protein DEK', 'DEK', 4, NULL),
(34928, NULL, 'IPR045194', NULL, 'E3 ubiquitin-protein ligase MGRN1/RNF157-like', 'MGRN1/RNF157-like', 4, NULL),
(34929, NULL, 'IPR042461', NULL, 'LapD/MoxY periplasmic domain, C-terminal', 'LapD_MoxY_peri_C', 5, NULL),
(34930, NULL, 'IPR045133', NULL, 'Serine/threonine-protein kinase/endoribonuclease IRE1/2-like', 'IRE1/2-like', 4, NULL),
(34931, NULL, 'IPR044564', NULL, 'Voltage-gated sodium channel alpha subunit, inactivation gate', 'Na_chnl_inactivation_gate', 3, NULL),
(34932, NULL, 'IPR042175', NULL, 'Cell/Rod shape-determining protein MreC, domain 2', 'Cell/Rod_MreC_2', 5, NULL),
(34933, NULL, 'IPR044812', NULL, 'LysM domain receptor kinase CERK1/LYK3-like', 'CERK1/LYK3-like', 4, NULL),
(34934, NULL, 'IPR042402', NULL, 'Epididymal secretory protein E3-alpha/beta', 'EDDM3A/EDDM3B', 4, NULL),
(34935, NULL, 'IPR043971', NULL, 'FUZ/MON1/HPS1, second Longin domain', 'FUZ/MON1/HPS1_longin_2', 3, NULL),
(34936, NULL, 'IPR045349', NULL, 'SLC41A divalent cation transporter', 'SLC41A1-3', 4, NULL),
(34937, NULL, 'IPR044234', NULL, 'Transmembrane protein 230', 'TMEM230', 4, NULL),
(34938, NULL, 'IPR044263', NULL, 'RNA ligase 2, viral', 'Rnl2_vir', 4, NULL),
(34939, NULL, 'IPR044529', NULL, 'Sarcoplasmic/endoplasmic reticulum calcium ATPase regulator DWORF', 'DWORF', 4, NULL),
(34940, NULL, 'IPR044739', NULL, 'NRT1/PTR family', 'NRT1/PTR', 4, NULL),
(34941, NULL, 'IPR044752', NULL, 'Exonuclease 1-like, PIN-like domain', 'PIN-like_EXO1', 3, NULL),
(34942, NULL, 'IPR045177', NULL, 'Factor of DNA methylation 1-5/IDN2', 'FDM1-5/IDN2', 4, NULL),
(34943, NULL, 'IPR043069', NULL, 'Stc1 domain superfamily', 'Stc1_sf', 5, NULL),
(34944, NULL, 'IPR045895', NULL, 'Transcription factor bHLH91-like', 'bHLH91-like', 4, NULL),
(34945, NULL, 'IPR042294', NULL, 'Histone-lysine N-methyltransferase SETD2, animal', 'SETD2_animal', 4, NULL),
(34946, NULL, 'IPR046383', NULL, 'N6-succino-2-amino-2''-deoxyadenylate synthase', 'Phage_PurZ', 4, NULL),
(34947, NULL, 'IPR044542', NULL, 'N-alpha-acetyltransferase 30-like', 'NAA30-like', 4, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(34948, NULL, 'IPR045310', NULL, 'Oxalate--CoA ligase Pcs60-like', 'Pcs60-like', 4, NULL),
(34949, NULL, 'IPR045335', NULL, 'Cell division protein FtsQ, C-terminal', 'FtsQ_C_sf', 5, NULL),
(34950, NULL, 'IPR045719', NULL, 'Protein of unknown function DUF6073', 'DUF6073', 4, NULL),
(34951, NULL, 'IPR045894', NULL, 'At5g08430-like', 'At5g08430-like', 4, NULL),
(34952, NULL, 'IPR044205', NULL, 'Calcium-binding protein KIC/PBP1/KRP1', 'KIC/PBP1/KRP1', 4, NULL),
(34953, NULL, 'IPR046409', NULL, 'Programmed cell death protein 10, dimerisation domain superfamily', 'PDC10_dimerisation_sf', 5, NULL),
(34954, NULL, 'IPR044718', NULL, 'E3 ubiquitin-protein ligase HOS1', 'HOS1', 4, NULL),
(34955, NULL, 'IPR043216', NULL, 'Phosphatidate (PA) phosphatase-related', 'PA_PP_rel', 4, NULL),
(34956, NULL, 'IPR045350', NULL, 'Protein of unknown function DUF5968', 'DUF5968', 4, NULL),
(34957, NULL, 'IPR043755', NULL, 'Protein of unknown function DUF5701', 'DUF5701', 4, NULL),
(34958, NULL, 'IPR043759', NULL, 'Domain of unknown function DUF5704', 'DUF5704', 3, NULL),
(34959, NULL, 'IPR044020', NULL, 'Protein of unknown function DUF5676', 'DUF5676', 4, NULL),
(34960, NULL, 'IPR042755', NULL, 'E3 ubiquitin-protein ligase COP1', 'COP1', 4, NULL),
(34961, NULL, 'IPR044318', NULL, 'Non-structural protein 3c, bat coronavirus HKU5', 'ORF4b_HKU5-CoV', 4, NULL),
(34962, NULL, 'IPR043654', NULL, 'Protein of unknown function DUF5879', 'DUF5879', 4, NULL),
(34963, NULL, 'IPR043196', NULL, 'Leucine-rich repeat-containing protein 51', 'LRTOMT1', 4, NULL),
(34964, NULL, 'IPR042753', NULL, 'TRIM25, PRY/SPRY domain', 'TRIM25_SPRY_PRY', 3, NULL),
(34965, NULL, 'IPR044187', NULL, 'Universal stress protein A-like protein, plant', 'At3g01520-like_plant', 4, NULL),
(34966, NULL, 'IPR042276', NULL, 'F-actin-capping protein subunit alpha/beta, domain 2', 'CapZ_alpha/beta_2', 5, NULL),
(34967, NULL, 'IPR043965', NULL, 'Nuclear cap-binding complex subunit CBP66', 'CBP66', 4, NULL),
(34968, NULL, 'IPR043266', NULL, 'Ring-hydroxylating dioxygenase, alpha subunit NdoB-like, C-terminal', 'RHO_NdoB-like_C', 3, NULL),
(34969, NULL, 'IPR045423', NULL, 'Protein of unknown function DUF6510', 'DUF6510', 4, NULL),
(34970, NULL, 'IPR042187', NULL, 'Flagellin, C-terminal domain, subdomain 2', 'Flagellin_C_sub2', 5, NULL),
(34971, NULL, 'IPR044720', NULL, 'Small zinc finger protein HVO_2753-like', 'HVO_2753-like', 4, NULL),
(34972, NULL, 'IPR044086', NULL, 'Aldehyde dehydrogenase LUC3-like', 'LUC3-like', 3, NULL),
(34973, NULL, 'IPR044938', NULL, 'Enhancer of mRNA-decapping protein 4, conserved C-terminal domain', 'EDC4_C', 5, NULL),
(34974, NULL, 'IPR044719', NULL, 'Protein TIC 62-like', 'TIC62', 4, NULL),
(34975, NULL, 'IPR043135', NULL, 'Ferric-uptake regulator, C-terminal domain', 'Fur_C', 5, NULL),
(34976, NULL, 'IPR044227', NULL, 'Protein TONSOKU', 'TONSOKU', 4, NULL),
(34977, NULL, 'IPR045774', NULL, 'Methylcrotonoyl-CoA carboxylase subunit alpha, BT domain', 'MCCA_BT_dom', 3, NULL),
(34978, NULL, 'IPR042287', NULL, 'FhaA, N-terminal domain superfamily', 'FhaA_N_sf', 5, NULL),
(34979, NULL, 'IPR042283', NULL, 'GpdQ, catalytic alpha/beta sandwich domain', 'GpdQ_catalytic', 5, NULL),
(34980, NULL, 'IPR044538', NULL, 'Vacuolar protein sorting-associated protein Vta1-like', 'Vta1-like', 4, NULL),
(34981, NULL, 'IPR044036', NULL, 'Protein of unknown function DUF5752', 'DUF5752', 4, NULL),
(34982, NULL, 'IPR046408', NULL, 'Anamorsin, C-terminal', 'CIAPIN1', 3, NULL),
(34983, NULL, 'IPR042286', NULL, 'S-adenosylmethionine decarboxylase, C-terminal', 'AdoMetDC_C', 5, NULL),
(34984, NULL, 'IPR044496', NULL, 'Aldo-keto reductase family 3G', 'AKR3G', 4, NULL),
(34985, NULL, 'IPR043084', NULL, 'Gp27, baseplate hub, domain 4', 'Gp27_dom4', 5, NULL),
(34986, NULL, 'IPR042299', NULL, 'Ufd1-like, Nn domain', 'Ufd1-like_Nn', 5, NULL),
(34987, NULL, 'IPR042173', NULL, 'Ribonuclease J, domain 2', 'RNase_J_2', 5, NULL),
(34988, NULL, 'IPR044699', NULL, 'Membrane-associated kinase regulator 6', 'MAKR6', 4, NULL),
(34989, NULL, 'IPR045049', NULL, 'Choline-phosphate cytidylyltransferase Pcy1-like', 'Pcy1-like', 4, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(34990, NULL, 'IPR044204', NULL, 'Protein IWS1 homolog 1/2', 'IWS1/2', 4, NULL),
(34991, NULL, 'IPR043866', NULL, 'E3 ubiquitin-protein ligase TTC3/DZIP3 domain', 'TTC3/DZIP3_dom', 3, NULL),
(34992, NULL, 'IPR044238', NULL, 'Histone-lysine N-methyltransferase ASHR2-like', 'ASHR2-like', 4, NULL),
(34993, NULL, 'IPR044603', NULL, 'Senescence-associated carboxylesterase 101-like', 'SAG101-like', 4, NULL),
(34994, NULL, 'IPR043891', NULL, 'SPARK domain', 'SPARK', 3, NULL),
(34995, NULL, 'IPR043882', NULL, 'Protein of unknown function DUF5850', 'DUF5850', 4, NULL),
(34996, NULL, 'IPR044262', NULL, '(S)-8-amino-7-oxononanoate synthase BioU-like', 'BioU-like', 4, NULL),
(34997, NULL, 'IPR042178', NULL, 'Serpin superfamily, domain 1', 'Serpin_sf_1', 5, NULL),
(34998, NULL, 'IPR044518', NULL, 'ADP-ribosylation factor GTPase-activating protein AGD11/12/13', 'ARF_GAP_AGD11/12/13', 4, NULL),
(34999, NULL, 'IPR042782', NULL, 'Tetraspanin-32, extracellular domain', 'PHEMX_LEL', 3, NULL),
(35000, NULL, 'IPR042285', NULL, 'E3 ubiquitin-protein ligase RNF182', 'RNF182', 4, NULL),
(35001, NULL, 'IPR042118', NULL, 'QueA, domain 1', 'QueA_dom1', 5, NULL),
(35002, NULL, 'IPR044275', NULL, 'Cyclin-dependent kinase inhibitor, plant', 'KRP', 4, NULL),
(35003, NULL, 'IPR043695', NULL, 'N-acetylornithine carbamoyltransferase ArgF''-like', 'ArgF''', 4, NULL),
(35004, NULL, 'IPR043582', NULL, 'Calcium binding protein 1/2/4/5', 'CaBP1/2/4/5', 4, NULL),
(35005, NULL, 'IPR042171', NULL, 'Acyl-CoA thioesterase, double hotdog domain', 'Acyl-CoA_hotdog', 5, NULL),
(35006, NULL, 'IPR044256', NULL, 'High chlorophyll fluorescence 244-like', 'HCF244-like', 4, NULL),
(35007, NULL, 'IPR044660', NULL, 'Transcription factor IBH1-like', 'IBH1-like', 4, NULL),
(35008, NULL, 'IPR042836', NULL, 'Sialic acid-binding Ig-like lectin 15', 'SIG15', 4, NULL),
(35009, NULL, 'IPR043935', NULL, 'SidE, mono-ADP-ribosyltransferase domain', 'SidE_mART', 3, NULL),
(35010, NULL, 'IPR044968', NULL, 'Protein PUTATIVE RECOMBINATION INITIATION DEFECT 1', 'PRD1', 4, NULL),
(35011, NULL, 'IPR044102', NULL, 'SHEP1/BCAR3/NSP1, SH2 domain', 'SH2_SHEP1/BCAR3/NSP1', 3, NULL),
(35012, NULL, 'IPR044021', NULL, 'Glycosyl-4,4''-diaponeurosporenoate acyltransferase', 'CrtO', 4, NULL),
(35013, NULL, 'IPR042743', NULL, 'Serine/threonine-protein kinase 10, catalytic domain', 'STK10_STKc', 3, NULL),
(35014, NULL, 'IPR044103', NULL, 'LAS seventeen-binding protein 5 , GAT domain', 'GAT_LSB5', 3, NULL),
(35015, NULL, 'IPR044838', NULL, 'Probable metalloprotease EGY1-like', 'EGY1-like', 4, NULL),
(35016, NULL, 'IPR043031', NULL, 'Viral ssDNA binding protein, head domain', 'Viral_ssDBP_head', 5, NULL),
(35017, NULL, 'IPR043639', NULL, 'AF4 interaction motif', 'AF4_int', 2, NULL),
(35018, NULL, 'IPR043698', NULL, 'Racemase Bsr/Lyr', 'Racemase_Bsr/Lyr', 4, NULL),
(35019, NULL, 'IPR045354', NULL, 'BURAN domain', 'BURAN', 3, NULL),
(35020, NULL, 'IPR043108', NULL, 'Her-1, C-terminal', 'Her-1_C', 5, NULL),
(35021, NULL, 'IPR043562', NULL, 'Retinal homeobox protein  RAX/RAX2', 'RAX/RAX2', 4, NULL),
(35022, NULL, 'IPR043682', NULL, 'Rqc2 homolog RqcH, bacterial', 'RqcH_bacterial', 4, NULL),
(35023, NULL, 'IPR044297', NULL, 'Protein CELLULOSE SYNTHASE INTERACTIVE 1/2/3', 'CSI1/2/3', 4, NULL),
(35024, NULL, 'IPR043077', NULL, 'Phage p2 ORF12', 'Phage_p2_ORF12', 5, NULL),
(35025, NULL, 'IPR044357', NULL, 'NSP3, first ubiquitin-like (Ubl) domain, coronavirus', 'NSP3_Ubl1_dom_CoV', 3, NULL),
(35026, NULL, 'IPR043567', NULL, 'Synaptotagmin-like 1-5, C2B domain', 'SYTL1-5_C2B', 3, NULL),
(35027, NULL, 'IPR043563', NULL, 'Nuclear body protein Sp110/Sp140/Sp140L-like', 'Sp110/Sp140/Sp140L-like', 4, NULL),
(35028, NULL, 'IPR044365', NULL, 'Non-structural protein 6, deltacoronavirus', 'NSP6_deltaCoV', 3, NULL),
(35029, NULL, 'IPR042199', NULL, 'Aspartokinase/Bifunctional aspartokinase/homoserine dehydrogenase, catalytic domain', 'AsparK_Bifunc_asparK/hSer_DH', 5, NULL),
(35030, NULL, 'IPR042255', NULL, 'Ethanolamine ammonia-lyase light chain, N-terminal', 'EutC_N', 5, NULL),
(35031, NULL, 'IPR042546', NULL, 'Outer capsid protein VP4', 'Rota_A_VP4', 4, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(35032, NULL, 'IPR042211', NULL, 'CRISPR-associated endonuclease Cas1, N-terminal domain', 'CRISPR-assoc_Cas1_N', 5, NULL),
(35033, NULL, 'IPR042785', NULL, 'Tyrosine-protein kinase ITK/TSK, catalytic domain', 'ITK_PTKc', 3, NULL),
(35034, NULL, 'IPR044455', NULL, 'ADAD1, double-stranded RNA binding domain', 'ADAD1_DSRM', 3, NULL),
(35035, NULL, 'IPR043992', NULL, 'Transglycosylase SLT domain 3', 'SLT_3', 3, NULL),
(35036, NULL, 'IPR044484', NULL, 'Aldo-keto reductase family 1 member E2', 'AKR1E2', 4, NULL),
(35037, NULL, 'IPR043459', NULL, 'NFD6/NOXY2-like', 'NFD6/NOXY2-like', 4, NULL),
(35038, NULL, 'IPR042745', NULL, 'RNase L, RNase domain', 'RNase-L_RNase', 3, NULL),
(35039, NULL, 'IPR042834', NULL, 'Armadillo repeat-containing protein 12', 'Armc12', 4, NULL),
(35040, NULL, 'IPR043073', NULL, 'Baseplate protein Gp16, domain D4', 'Gp16_domD4', 5, NULL),
(35041, NULL, 'IPR042208', NULL, 'D-serine dehydratase-like domain superfamily', 'D-ser_dehydrat-like_sf', 5, NULL),
(35042, NULL, 'IPR042557', NULL, 'SCO4226, nickel-binding ferredoxin-like monomer', 'SCO4226', 5, NULL),
(35043, NULL, 'IPR044079', NULL, 'TBCE, ubiquitin-like (Ubl) domain', 'Ubl_TBCE', 3, NULL),
(35044, NULL, 'IPR043847', NULL, 'Domain of unknown function (DUF5862)', 'DUF5862', 3, NULL),
(35045, NULL, 'IPR043937', NULL, 'Golgin subfamily A member 2, C-terminal binding motif', 'GM130_C', 2, NULL),
(35046, NULL, 'IPR043696', NULL, 'N-succinylornithine carbamoyltransferase ArgF''-like', 'ArgF''-like', 4, NULL),
(35047, NULL, 'IPR044444', NULL, 'MRPL44, double-stranded RNA binding domain', 'MRPL44_DSRM', 3, NULL),
(35048, NULL, 'IPR044190', NULL, 'Protein THYLAKOID ASSEMBLY 8-like', 'THA8-like', 4, NULL),
(35049, NULL, 'IPR042614', NULL, 'Ubiquitin-conjugating enzyme E2-22kDa (UbcD4) , UBA domain', 'UBCD4_UBA', 3, NULL),
(35050, NULL, 'IPR043360', NULL, 'PP2B', 'PP2B', 4, NULL),
(35051, NULL, 'IPR044094', NULL, 'AtsA-like, MBL-fold', 'AtsA-like_MBL-fold', 3, NULL),
(35052, NULL, 'IPR042552', NULL, 'Spike glycoprotein, Alphacoronavirus', 'ALPHA_CORONA_SPIKE', 4, NULL),
(35053, NULL, 'IPR043784', NULL, 'Domain of unknown function DUF5726', 'DUF5726', 3, NULL),
(35054, NULL, 'IPR043795', NULL, 'N-alpha-acetyl diaminobutyric acid deacetylase-like', 'N-alpha-Ac-DABA-like', 4, NULL),
(35055, NULL, 'IPR045357', NULL, 'Aminopeptidase N-like , N-terminal domain', 'Aminopeptidase_N-like_N', 3, NULL),
(35056, NULL, 'IPR043796', NULL, 'ESX-1 secretion-associated protein EspA/EspE-like', 'ESX-1_EspA/EspE-like', 3, NULL),
(35057, NULL, 'IPR043597', NULL, 'Trichohyalin-plectin-homology domain', 'TPH_dom', 3, NULL),
(35058, NULL, 'IPR044199', NULL, 'NAD(P)H-quinone oxidoreductase subunit U, chloroplastic', 'NdhU_chloroplastic', 4, NULL),
(35059, NULL, 'IPR042318', NULL, 'Consortin', 'Consortin', 4, NULL),
(35060, NULL, 'IPR044525', NULL, 'Digalactosyldiacylglycerol synthase 1/2', 'DGDG1/2', 4, NULL),
(35061, NULL, 'IPR045355', NULL, 'Poly(A) polymerase catalytic subunit', 'PolyA_pol_cat_su', 3, NULL),
(35062, NULL, 'IPR044131', NULL, 'Dual specificity tyrosine-phosphorylation-regulated kinase 1A/1B, catalytic domain', 'PKc_DYR1A/1B', 3, NULL),
(35063, NULL, 'IPR044450', NULL, 'AtDRB-like, first double-stranded RNA binding domain, plant', 'AtDRB-like_DSRM_1', 3, NULL),
(35064, NULL, 'IPR042783', NULL, 'Synaptotagmin-l, FYVE-related domain', 'SYTL5_FYVE', 3, NULL),
(35065, NULL, 'IPR044549', NULL, 'Transcription factor IBH1-like, bHLH domain', 'bHLH_AtIBH1-like', 3, NULL),
(35066, NULL, 'IPR044082', NULL, 'SpaK/NisK-like, Histidine kinase-like ATPase domain', 'SpaK_NisK-like_HATPase', 3, NULL),
(35067, NULL, 'IPR042845', NULL, 'Proto-oncogene c-Rel, RHD, N-terminal subdomain', 'RHD-n_c-Rel', 3, NULL),
(35068, NULL, 'IPR043242', NULL, 'Proline-rich transmembrane protein 3', 'PRRT3', 4, NULL),
(35069, NULL, 'IPR042204', NULL, '2Fe-2S iron-sulfur cluster binding domain, N-terminal', '2Fe-2S-bd_N', 5, NULL),
(35070, NULL, 'IPR043502', NULL, 'DNA/RNA polymerase superfamily', 'DNA/RNA_pol_sf', 5, NULL),
(35071, NULL, 'IPR042210', NULL, 'Glycoprotein VP7, domain 2', 'VP7_2', 5, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(35072, NULL, 'IPR044462', NULL, 'RBM46, double-stranded RNA binding domain', 'RBM46_DSR', 3, NULL),
(35073, NULL, 'IPR044505', NULL, 'Glycogen debranching enzyme GlgX/isoamylase, N-terminal Early set domain', 'GlgX_Isoamylase_N_E_set', 3, NULL),
(35074, NULL, 'IPR044093', NULL, 'Cyclin-dependent kinase 10, catalytic domain', 'STKc_CDK10', 3, NULL),
(35075, NULL, 'IPR043804', NULL, 'Protein  of unknown function DUF5871', 'DUF5871', 4, NULL),
(35076, NULL, 'IPR043688', NULL, 'SAR-endolysin-like', 'SAR_endolysin-like', 4, NULL),
(35077, NULL, 'IPR043921', NULL, 'Protein of unknown function DUF5772', 'DUF5772', 4, NULL),
(35078, NULL, 'IPR042188', NULL, 'MmgE/PrpD superfamily, domain 2', 'MmgE/PrpD_sf_2', 5, NULL),
(35079, NULL, 'IPR042116', NULL, 'GTP-binding protein TypA/BipA, C-terminal', 'TypA/BipA_C', 5, NULL),
(35080, NULL, 'IPR042970', NULL, 'NUDT18, NUDIX hydrolase domain', 'NUDT18_NUDIX', 3, NULL),
(35081, NULL, 'IPR043839', NULL, 'PafC, HTH domain', 'PafC_HTH', 3, NULL),
(35082, NULL, 'IPR043034', NULL, 'DNA polymerase alpha, subunit B, N-terminal domain superfamily', 'DNA_pol_alpha_B_N_sf', 5, NULL),
(35083, NULL, 'IPR044486', NULL, 'Aldo-keto reductase family 2B', 'AKR2B1', 4, NULL),
(35084, NULL, 'IPR043561', NULL, 'Transcription factor LHW-like', 'LHW-like', 4, NULL),
(35085, NULL, 'IPR044628', NULL, 'Elongation factor 1-gamma, plant', 'EF-1-gamma_plant', 4, NULL),
(35086, NULL, 'IPR042209', NULL, 'Hepatitis C virus non-structural protein NS2, N-terminal domain', 'HCV_NS2_N', 5, NULL),
(35087, NULL, 'IPR042251', NULL, 'Ethanolamine ammonia-lyase light chain, C-terminal', 'EutC_C', 5, NULL),
(35088, NULL, 'IPR043703', NULL, 'Lipid II isoglutaminyl synthase (glutamine-hydrolyzing) subunit MurT', 'Lipid_II_synth_MurT', 4, NULL),
(35089, NULL, 'IPR043842', NULL, 'Domain of unknown function DUF5866', 'DUF5866', 3, NULL),
(35090, NULL, 'IPR043846', NULL, 'Protein of unknown function DUF5863', 'DUF5863', 4, NULL),
(35091, NULL, 'IPR043915', NULL, 'Protein of unknown function DUF5762', 'DUF5762', 4, NULL),
(35092, NULL, 'IPR043906', NULL, 'Gfo/Idh/MocA-like oxidoreductase, bacterial type, C-terminal', 'Gfo/Idh/MocA_OxRdtase_bact_C', 3, NULL),
(35093, NULL, 'IPR042334', NULL, 'Putative ankyrin repeat domain-containing protein 31', 'ANKRD31', 4, NULL),
(35094, NULL, 'IPR044963', NULL, 'Succinate dehydrogenase subunit 4, mitochondrial', 'SDH4', 4, NULL),
(35095, NULL, 'IPR044954', NULL, 'Ribosomal protein S3, mitochondrial, plant', 'RPS3_plant', 4, NULL),
(35096, NULL, 'IPR043686', NULL, 'ATP-binding protein Uup', 'Uup', 4, NULL),
(35097, NULL, 'IPR043145', NULL, 'Zinc finger, ZZ-type superfamily', 'Znf_ZZ_sf', 5, NULL),
(35098, NULL, 'IPR043149', NULL, 'CDP-glycerol glycerophosphotransferase, N-terminal domain', 'TagF_N', 5, NULL),
(35099, NULL, 'IPR042977', NULL, 'Chaperone protein AtJ6-like', 'AtJ6-like', 4, NULL),
(35100, NULL, 'IPR043532', NULL, 'AP-2 complex subunit mu, N-terminal', 'AP2_Mu_N', 3, NULL),
(35101, NULL, 'IPR044253', NULL, 'Thioredoxin-like 3-1/3-2', 'WCRKC1/2', 4, NULL),
(35102, NULL, 'IPR044967', NULL, 'Protein PLASTID TRANSCRIPTIONALLY ACTIVE 10', 'PTAC10', 4, NULL),
(35103, NULL, 'IPR044498', NULL, 'Aldo-keto reductase family 4C', 'AKR4C', 4, NULL),
(35104, NULL, 'IPR043681', NULL, 'Rqc2 homolog RqcH, archaeal', 'RqcH_archaeal', 4, NULL),
(35105, NULL, 'IPR044122', NULL, 'UPF0261 domain', 'UPF0261_dom', 3, NULL),
(35106, NULL, 'IPR044186', NULL, 'WUSCHEL-related homeobox 4', 'WOX4', 4, NULL),
(35107, NULL, 'IPR043143', NULL, 'Malate/L-sulfolactate/L-lactate dehydrogenase-like, NADPH binding domain', 'Mal/L-sulf/L-lact_DH-like_NADP', 5, NULL),
(35108, NULL, 'IPR043805', NULL, 'Uracil-DNA glycosylase inhibitor', 'Ugi', 4, NULL),
(35109, NULL, 'IPR043148', NULL, 'CDP-glycerol glycerophosphotransferase, C-terminal domain', 'TagF_C', 5, NULL),
(35110, NULL, 'IPR044142', NULL, 'AhpF, N-terminal domain, N-terminal TRX-fold subdomain', 'AhpF_NTD_N', 3, NULL),
(35111, NULL, 'IPR044425', NULL, 'KMT5C , SET domain', 'KMT5C_SET', 3, NULL),
(35112, NULL, 'IPR043938', NULL, 'Ligase-CoA domain', 'Ligase_CoA_dom', 3, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(35113, NULL, 'IPR044744', NULL, 'ZNRF4 /RNF13/RNF167, PA domain', 'ZNRF4/RNF13/RNF167_PA', 3, NULL),
(35114, NULL, 'IPR043922', NULL, 'Protein of unknown function DUF5773', 'DUF5773', 4, NULL),
(35115, NULL, 'IPR042306', NULL, 'Alphavirus E2 glycoprotein, domain C', 'Alphavir_E2_C', 5, NULL),
(35116, NULL, 'IPR043137', NULL, 'Gamma-glutamyltranspeptidase, small subunit', 'GGT_ssub', 5, NULL),
(35117, NULL, 'IPR044239', NULL, 'Peptidyl-prolyl cis-trans isomerase FKBP20-2-like', 'FKBP20-2-like', 4, NULL),
(35118, NULL, 'IPR042558', NULL, 'Glutaminyl-tRNA synthetase, class Ib, non-specific RNA-binding domain, N-terminal, subdomain 1', 'Gln-tRNA-synth_Ib_RNA-bd_N_1', 5, NULL),
(35119, NULL, 'IPR044974', NULL, 'Disease resistance protein, plants', 'Disease_R_plants', 4, NULL),
(35120, NULL, 'IPR042822', NULL, 'Membrane Guanylate Cyclase receptor GC-C, pseudokinase domain', 'GC-C_PK', 3, NULL),
(35121, NULL, 'IPR043032', NULL, 'PvsD/AcsD-like, thumb domain, helical bundle', 'PvsD/AcsD-like_thumb_helix', 5, NULL),
(35122, NULL, 'IPR043631', NULL, 'QPE repeat', 'QPE_rpt', 7, NULL),
(35123, NULL, 'IPR042216', NULL, 'MitoNEET, CDGSH iron-sulfur domain', 'MitoNEET_CISD', 5, NULL),
(35124, NULL, 'IPR043651', NULL, 'KNL1 MELT repeat', 'KNL1_MELT_rep', 7, NULL),
(35125, NULL, 'IPR044130', NULL, 'Iron transport multicopper oxidase Fet3-like, the second Cupredoxin domain', 'CuRO_2_Fet3-like', 3, NULL),
(35126, NULL, 'IPR042971', NULL, 'Late embryogenesis abundant protein, SMP subgroup', 'LEA_SMP', 4, NULL),
(35127, NULL, 'IPR042214', NULL, 'Pseudouridine synthase, TruD, catalytic domain', 'TruD_catalytic', 5, NULL),
(35128, NULL, 'IPR043035', NULL, 'Growth arrest and DNA damage-inducible proteins-interacting protein 1 domain superfamily', 'Damage-induce-interact_sf', 5, NULL),
(35129, NULL, 'IPR044092', NULL, 'Serine/threonine-protein PRP4, catalytic domain', 'STKc_PRP4', 3, NULL),
(35130, NULL, 'IPR042305', NULL, 'Alphavirus E2 glycoprotein, domain B', 'Alphavir_E2_B', 5, NULL),
(35131, NULL, 'IPR043904', NULL, 'PhoD-like phosphatase', 'PhoD_2-like', 3, NULL),
(35132, NULL, 'IPR044416', NULL, 'PRDM6, PR/SET domain', 'PRDM6_PR-SET', 3, NULL),
(35133, NULL, 'IPR043142', NULL, 'PapC-like, C-terminal domain superfamily', 'PapC-like_C_sf', 5, NULL),
(35134, NULL, 'IPR042548', NULL, 'Nucleocapsid protein, alphacoronavirus', 'NCAP_aCoV', 4, NULL),
(35135, NULL, 'IPR044163', NULL, 'Sanguinarine reductase SARED1-like', 'SARED1-like', 4, NULL),
(35136, NULL, 'IPR042217', NULL, 'Type IV secretion system, VirB10/TrbI', 'T4SS_VirB10/TrbI', 5, NULL),
(35137, NULL, 'IPR042989', NULL, 'Zinc finger MYND domain-containing protein 15', 'ZMY15', 4, NULL),
(35138, NULL, 'IPR044875', NULL, 'ToxT, HTH1 motif superfamily', 'ToxT_HTH1', 5, NULL),
(35139, NULL, 'IPR043588', NULL, 'Slingshot, N-terminal', 'SSH-N', 3, NULL),
(35140, NULL, 'IPR044521', NULL, 'Basic leucine zipper 8/43', 'AtbZIP8/43', 4, NULL),
(35141, NULL, 'IPR042511', NULL, 'DNA replication regulator Sld3', 'Sld3', 4, NULL),
(35142, NULL, 'IPR043787', NULL, 'Domain of unknown function DUF5729', 'DUF5729', 3, NULL),
(35143, NULL, 'IPR042197', NULL, 'Apoptotic protease-activating factors, helical domain', 'Apaf_helical', 5, NULL),
(35144, NULL, 'IPR044951', NULL, 'Kinetochore protein SPC24-like', 'SPC24-like', 4, NULL),
(35145, NULL, 'IPR042827', NULL, 'PLEKHM1, PH domain', 'PLEKHM1_PH', 3, NULL),
(35146, NULL, 'IPR042757', NULL, 'Endothelial cell-selective adhesion molecule', 'ESAM', 4, NULL),
(35147, NULL, 'IPR043763', NULL, 'Protein of unknown function DUF5709', 'DUF5709', 3, NULL),
(35148, NULL, 'IPR043385', NULL, 'Granule associated Rac and RHOG effector protein 1', 'GARRE1', 4, NULL),
(35149, NULL, 'IPR042207', NULL, 'Glycoprotein VP7, domain 1', 'VP7_1', 5, NULL),
(35150, NULL, 'IPR043523', NULL, 'G protein-coupled receptor 176, rhodopsin-like, 7TM', 'GPCR_176_Rhodpsn_7TM', 3, NULL),
(35151, NULL, 'IPR043647', NULL, 'Nodavirus methyltransferase domain', 'Noda_Vmethyltr_dom', 3, NULL),
(35152, NULL, 'IPR042742', NULL, 'Frizzled-7, cysteine-rich Wnt-binding domain', 'Frizzled-7_CRD', 3, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(35153, NULL, 'IPR044548', NULL, 'Uncharacterised protein AF_0060, NTP Pyrophosphohydrolase MazG-like domain', 'AF0060_NTP-PPase_MazG-like', 3, NULL),
(35154, NULL, 'IPR042693', NULL, 'ETS-related transcription factor Elf-3, pointed domain', 'Elf-3_PNT', 3, NULL),
(35155, NULL, 'IPR044661', NULL, 'Mediator of RNA polymerase II transcription subunit 15a/b/c-like', 'MED15a/b/c-like', 4, NULL),
(35156, NULL, 'IPR046457', NULL, 'Phosphomannose isomerase type I, catalytic domain', 'PMI_typeI_cat', 3, NULL),
(35157, NULL, 'IPR044165', NULL, 'Dolichyl-diphosphooligosaccharide--protein glycosyltransferase subunit 4, plant', 'OST4_plant', 4, NULL),
(35158, NULL, 'IPR042202', NULL, 'Duffy-antigen binding superfamily', 'Duffy-ag-bd_sf', 5, NULL),
(35159, NULL, 'IPR044783', NULL, 'Phytolongin', 'PHYL', 4, NULL),
(35160, NULL, 'IPR044458', NULL, 'ADAR2, first double-stranded RNA binding domain', 'ADAR2_DSRM_1', 3, NULL),
(35161, NULL, 'IPR043799', NULL, 'Domain of unknown function DUF5738', 'DUF5738', 3, NULL),
(35162, NULL, 'IPR043537', NULL, 'Tiam1/Tiam2/Protein still life', 'Tiam1/Tiam2/Sif', 4, NULL),
(35163, NULL, 'IPR042321', NULL, 'Integral inner nuclear membrane protein ima1', 'Ima1', 4, NULL),
(35164, NULL, 'IPR044121', NULL, 'Snu114, GTP-binding domain', 'Snu114_GTP-bd', 3, NULL),
(35165, NULL, 'IPR044849', NULL, 'Ion channel CASTOR/POLLUX/SYM8-like', 'CASTOR/POLLUX/SYM8-like', 4, NULL),
(35166, NULL, 'IPR043702', NULL, 'Lipid II isoglutaminyl synthase (glutamine-hydrolyzing) subunit GatD', 'Lipid_II_synth_GatD', 4, NULL),
(35167, NULL, 'IPR044577', NULL, 'Heavy metal-associated isoprenylated plant protein 4/7/8/17/18/19', 'HIPP4/7/8/17/18/19', 4, NULL),
(35168, NULL, 'IPR043640', NULL, 'AF4/FMR2, C-terminal homology domain', 'AF4/FMR2_CHD', 3, NULL),
(35169, NULL, 'IPR043676', NULL, 'Glucosyltransferase 3', 'Gtf3', 4, NULL),
(35170, NULL, 'IPR043697', NULL, 'N-acetyl-L-citrulline deacetylase ArgE''-like', 'ACDase_ArgE''-like', 4, NULL),
(35171, NULL, 'IPR042547', NULL, 'Nucleocapsid protein, gammacoronavirus', 'NCAP_gCoV', 4, NULL),
(35172, NULL, 'IPR044639', NULL, 'Cystathionine gamma-synthase 1/2', 'CGS1/2', 4, NULL),
(35173, NULL, 'IPR042206', NULL, 'CRISPR-associated endonuclease Cas1, C-terminal domain', 'CRISPR-assoc_Cas1_C', 5, NULL),
(35174, NULL, 'IPR044424', NULL, 'KMT5B , SET domain', 'KMT5B_SET', 3, NULL),
(35175, NULL, 'IPR042973', NULL, 'RING finger protein 222', 'RNF222', 4, NULL),
(35176, NULL, 'IPR044233', NULL, 'Peptidyl-prolyl cis-trans isomerase CYP23-like', 'CYP23-like', 4, NULL),
(35177, NULL, 'IPR042128', NULL, 'NuoE domain', 'NuoE_dom', 3, NULL),
(35178, NULL, 'IPR043766', NULL, 'Protein of unknown function DUF5712', 'DUF5712', 4, NULL),
(35179, NULL, 'IPR044123', NULL, 'Translation initiation factor eIF-2B subunit epsilon, W2 domain', 'W2_eIF2B_epsilon', 3, NULL),
(35180, NULL, 'IPR044420', NULL, 'SMYD3, SET domain', 'SMYD3_SET', 3, NULL),
(35181, NULL, 'IPR042799', NULL, 'Talin rod domain-containing protein 1', 'TLNRD1', 4, NULL),
(35182, NULL, 'IPR043914', NULL, 'Protein of unknown function DUF5763', 'DUF5763', 4, NULL),
(35183, NULL, 'IPR043645', NULL, 'Peripherally associated ATOM36', 'pATOM36', 4, NULL),
(35184, NULL, 'IPR044436', NULL, 'SETD7, SET domain', 'SETD7_SET', 3, NULL),
(35185, NULL, 'IPR044723', NULL, 'AAI/SS protein, conserved domain', 'AAI_SS_dom', 3, NULL),
(35186, NULL, 'IPR042846', NULL, 'BTB/POZ domain-containing protein 19', 'BTBD19', 4, NULL),
(35187, NULL, 'IPR044433', NULL, 'SETD5, SET domain', 'SETD5_SET', 3, NULL),
(35188, NULL, 'IPR044454', NULL, 'ADAD2, double-stranded RNA binding domain', 'ADAD2_DSRM', 3, NULL),
(35189, NULL, 'IPR043519', NULL, 'Nucleotidyltransferase superfamily', 'NT_sf', 5, NULL),
(35190, NULL, 'IPR042561', NULL, 'Exocyst component Exo84, C-terminal, subdomain 1', 'Exo84_C_1', 5, NULL),
(35191, NULL, 'IPR044441', NULL, 'Dicer, double-stranded RNA-binding domain', 'DICER_DSRM', 3, NULL),
(35192, NULL, 'IPR044367', NULL, 'Non-structural protein 6, betacoronavirus', 'NSP6_betaCoV', 3, NULL),
(35193, NULL, 'IPR042559', NULL, 'Glutaminyl-tRNA synthetase, class Ib, non-specific RNA-binding domain, N-terminal, subdomain 2', 'Gln-tRNA-synth_Ib_RNA-bd_N_2', 5, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(35194, NULL, 'IPR043441', NULL, 'Junction-associated protein Tjap1/BEGAIN', 'Tjap1/BEGAIN', 4, NULL),
(35195, NULL, 'IPR043138', NULL, 'Gamma-glutamyltranspeptidase, large subunit, C-terminal domain', 'GGT_lsub_C', 5, NULL),
(35196, NULL, 'IPR043952', NULL, 'Protein of unknown function DUF5783', 'DUF5783', 4, NULL),
(35197, NULL, 'IPR042767', NULL, 'Serine/threonine-protein kinase Nek9, catalytic domain', 'Nek9_STKc', 3, NULL),
(35198, NULL, 'IPR044866', NULL, 'HNF-1, dimerization domain', 'HNF_P1', 3, NULL),
(35199, NULL, 'IPR043905', NULL, 'Protein of unknown function DUF5771', 'DUF5771', 4, NULL),
(35200, NULL, 'IPR044160', NULL, 'Protein TRIGALACTOSYLDIACYLGLYCEROL 4-like', 'TGD4-like', 4, NULL),
(35201, NULL, 'IPR043912', NULL, 'Protein of unknown function DUF5765', 'DUF5765', 4, NULL),
(35202, NULL, 'IPR044797', NULL, 'Uncharacterized protein At4g06598-like', 'At4g06598-like', 4, NULL),
(35203, NULL, 'IPR042319', NULL, 'Glycoprotein integral membrane protein 1', 'GINM1', 4, NULL),
(35204, NULL, 'IPR043442', NULL, 'PGC-1 and ERR-induced regulator in muscle protein 1', 'Perm1', 4, NULL),
(35205, NULL, 'IPR044146', NULL, 'Tex, S1 domain', 'S1_Tex', 3, NULL),
(35206, NULL, 'IPR045359', NULL, 'Protein of unknown function DUF5903', 'DUF5903', 4, NULL),
(35207, NULL, 'IPR043592', NULL, 'Formin-like protein, animal', 'FMNL_animal', 4, NULL),
(35208, NULL, 'IPR043602', NULL, 'Cation efflux system protein CusB,  domain 1', 'CusB_dom_1', 3, NULL),
(35209, NULL, 'IPR043659', NULL, 'Domain of unknown function DUF5874', 'DUF5874', 3, NULL),
(35210, NULL, 'IPR043128', NULL, 'Reverse transcriptase/Diguanylate cyclase domain', 'Rev_trsase/Diguanyl_cyclase', 5, NULL),
(35211, NULL, 'IPR043062', NULL, 'Pneumovirus matrix, N-terminal', 'Pneu_matrix_N', 5, NULL),
(35212, NULL, 'IPR045053', NULL, 'Mannan endo-1,4-beta-mannosidase-like', 'MAN-like', 4, NULL),
(35213, NULL, 'IPR045191', NULL, 'E3 ubiquitin-protein ligase MBR1/2-like', 'MBR1/2-like', 4, NULL),
(35214, NULL, 'IPR044268', NULL, 'Phosphatidylinositol phosphate synthase PgsA1', 'PIP_synthase_PgsA1', 4, NULL),
(35215, NULL, 'IPR044044', NULL, 'Domain of unknown function DUF5679', 'DUF5679', 3, NULL),
(35216, NULL, 'IPR042841', NULL, 'Splicing factor, arginine/serine-rich 19', 'SCAF1', 4, NULL),
(35217, NULL, 'IPR043653', NULL, 'Domain of unknown function DUF5880', 'DUF5880', 3, NULL),
(35218, NULL, 'IPR044159', NULL, 'IQ domain-containing protein IQM', 'IQM', 4, NULL),
(35219, NULL, 'IPR044519', NULL, 'ADP-ribosylation factor GTPase-activating protein AGD6/7', 'ARF_GAP_AGD6/7', 4, NULL),
(35220, NULL, 'IPR043538', NULL, 'Xylosyltransferase', 'XYLT', 4, NULL),
(35221, NULL, 'IPR044076', NULL, 'Ribosomal protein P2', 'Ribosomal_P2', 4, NULL),
(35222, NULL, 'IPR042839', NULL, 'Forkhead box protein M1', 'FOXM1', 4, NULL),
(35223, NULL, 'IPR043226', NULL, 'Natural cytotoxicity triggering receptor 3', 'NCR3', 4, NULL),
(35224, NULL, 'IPR043046', NULL, 'Interleukin-17 receptor A/B, FnIII-like domain 2 superfamily', 'IL17RA/B_FnIII-like_2_sf', 5, NULL),
(35225, NULL, 'IPR043683', NULL, 'Flavin-dependent monooxygenase TetX', 'TetX_monooxygenase', 4, NULL),
(35226, NULL, 'IPR042847', NULL, 'EF-hand calcium-binding domain-containing protein 12', 'EFC12', 4, NULL),
(35227, NULL, 'IPR042317', NULL, 'F-box protein she-1-like', 'She-1-like', 4, NULL),
(35228, NULL, 'IPR044953', NULL, 'BTB/POZ domain-containing protein At1g04390-like', 'At1g04390-like', 4, NULL),
(35229, NULL, 'IPR042838', NULL, 'Uncharacterized protein KIAA1958', 'KIAA1958', 4, NULL),
(35230, NULL, 'IPR044815', NULL, 'Serine/threonine-protein kinase-like protein CCR3/CCR4', 'CCR3/4', 4, NULL),
(35231, NULL, 'IPR043402', NULL, 'Homeobox expressed in ES cells 1', 'Hesx1', 4, NULL),
(35232, NULL, 'IPR043677', NULL, 'D-allulose-6-phosphate 3-epimerase', 'AlluloseP_3_epimer_AlsE', 4, NULL),
(35233, NULL, 'IPR044426', NULL, 'Suv4-20, SET domain', 'Suv4-20_SET', 3, NULL),
(35234, NULL, 'IPR043924', NULL, 'Protein of unknown function DUF5775', 'DUF5775', 4, NULL),
(35235, NULL, 'IPR043533', NULL, 'Cyclic nucleotide-binding domain-containing protein 1/2', 'CNBD1/2', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(35236, NULL, 'IPR044273', NULL, 'Transcription factor PIF3-like', 'PIF3-like', 4, NULL),
(35237, NULL, 'IPR043909', NULL, 'Protein of unknown function DUF5768', 'DUF5768', 4, NULL),
(35238, NULL, 'IPR042215', NULL, 'CarD-like, C-terminal domain', 'CarD-like_C', 5, NULL),
(35239, NULL, 'IPR042719', NULL, 'Plexin-D1, sema domain', 'Plexin-D1_Sema', 3, NULL),
(35240, NULL, 'IPR043934', NULL, 'SidE, DUB domain', 'SidE_DUB', 3, NULL),
(35241, NULL, 'IPR044461', NULL, 'A1CF, double-stranded RNA binding domain', 'A1CF_DSRM', 3, NULL),
(35242, NULL, 'IPR042842', NULL, 'CD226 antigen', 'CD226', 4, NULL),
(35243, NULL, 'IPR044485', NULL, 'Aldo-keto reductase family 2A', 'AKR2A1', 4, NULL),
(35244, NULL, 'IPR042832', NULL, 'PHLDA family', 'PHLA1/2/3', 4, NULL),
(35245, NULL, 'IPR043081', NULL, 'Apolipoprotein C-I domain superfamily', 'ApoC-1_sf', 5, NULL),
(35246, NULL, 'IPR044270', NULL, 'Archaetidylinositol phosphate synthase', 'AIP_synthase', 4, NULL),
(35247, NULL, 'IPR044644', NULL, 'Multi antimicrobial extrusion protein DinF-like', 'DinF-like', 4, NULL),
(35248, NULL, 'IPR044304', NULL, 'Iron-sulfur protein NUBPL-like', 'NUBPL-like', 4, NULL),
(35249, NULL, 'IPR043587', NULL, 'Protein phosphatase Slingshot-like', 'Phosphatase_SSH-like', 4, NULL),
(35250, NULL, 'IPR043785', NULL, 'Domain of unknown function DUF5727', 'DUF5727', 3, NULL),
(35251, NULL, 'IPR042194', NULL, 'FHIPEP, domain 1', 'FHIPEP_1', 5, NULL),
(35252, NULL, 'IPR042798', NULL, 'EF-hand calcium-binding domain-containing protein 9', 'EFCAB9', 4, NULL),
(35253, NULL, 'IPR042551', NULL, 'M matrix/glycoprotein, alphacoronavirus', 'ALPHA_CORONA_M', 4, NULL),
(35254, NULL, 'IPR043530', NULL, 'HLA class II histocompatibility antigen, gamma subunit', 'CD74_antigen', 4, NULL),
(35255, NULL, 'IPR043765', NULL, 'Protein of unknown function DUF5711', 'DUF5711', 4, NULL),
(35256, NULL, 'IPR042849', NULL, 'Rho guanine nucleotide exchange factor 33', 'ARHGEF33', 4, NULL),
(35257, NULL, 'IPR043117', NULL, 'Restriction endonuclease, type II SfiI, domain 2', 'Restrct_endonuc_II_SfiI_dom2', 5, NULL),
(35258, NULL, 'IPR043760', NULL, 'Pycsar effector protein', 'PycTM', 4, NULL),
(35259, NULL, 'IPR045356', NULL, 'Protein of unknown function DUF5882', 'DUF5882', 4, NULL),
(35260, NULL, 'IPR042196', NULL, 'FHIPEP, domain 4', 'FHIPEP_4', 5, NULL),
(35261, NULL, 'IPR044321', NULL, 'Non-structural protein 3c (NS3c), Middle East respiratory syndrome (MERS)-related CoV', 'ORF4b_MERS-CoV-like', 4, NULL),
(35262, NULL, 'IPR043663', NULL, 'NAD-protein ADP-ribosyltransferase ModA-like', 'MODA-like', 4, NULL),
(35263, NULL, 'IPR043762', NULL, 'Family of unknown function DUF5708', 'DUF5708', 4, NULL),
(35264, NULL, 'IPR043803', NULL, 'Domain of unknown function DUF5872', 'DUF5872', 3, NULL),
(35265, NULL, 'IPR044048', NULL, 'Bacterial Ig-like domain 12', 'Big_12', 3, NULL),
(35266, NULL, 'IPR043458', NULL, 'G-protein coupled receptor 158/179', 'GPR158/179', 4, NULL),
(35267, NULL, 'IPR043764', NULL, 'Domain of unknown function DUF5710', 'DUF5710', 3, NULL),
(35268, NULL, 'IPR044422', NULL, 'SMYD5, SET domain', 'SMYD5_SET', 3, NULL),
(35269, NULL, 'IPR042736', NULL, 'CAPN2, penta-EF hand, calcium binding motif', 'EFh_PEF_CAPN2', 3, NULL),
(35270, NULL, 'IPR043772', NULL, 'MBG domain', 'MBG_3', 3, NULL),
(35271, NULL, 'IPR044958', NULL, 'Ribosomal protein L32p, plant/cyanobacteria type', 'Ribosomal_L32p_plant/cyanobact', 4, NULL),
(35272, NULL, 'IPR042157', NULL, 'Hydroxyacid-oxoacid transhydrogenase', 'HOT', 4, NULL),
(35273, NULL, 'IPR042213', NULL, 'Four-carbon acid sugar kinase, nucleotide binding domain superfamily', 'NBD_C_sf', 5, NULL),
(35274, NULL, 'IPR043541', NULL, 'Synaptotagmin-14/14L/16', 'SYT14/14L/16', 4, NULL),
(35275, NULL, 'IPR043554', NULL, 'SNF1-related protein kinase regulatory subunit beta', 'KINB', 4, NULL),
(35276, NULL, 'IPR042205', NULL, 'Hepatitis C virus non-structural protein NS2, C-terminal domain', 'HCV_NS2_C', 5, NULL),
(35277, NULL, 'IPR042304', NULL, 'Alphavirus E2 glycoprotein, domain A', 'Alphavir_E2_A', 5, NULL),
(35278, NULL, 'IPR043675', NULL, 'tRNA 5-hydroxyuridine methyltransferase', 'TrmR_methyltr', 4, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(35279, NULL, 'IPR043656', NULL, 'Protein of unknown function DUF5877', 'DUF5877', 4, NULL),
(35280, NULL, 'IPR042763', NULL, 'Serine/threonine-protein kinase 17B,  catalytic domain', 'ST17B_STKc', 3, NULL),
(35281, NULL, 'IPR043460', NULL, 'MEDAG/TEX26', 'MEDAG/TEX26', 4, NULL),
(35282, NULL, 'IPR042303', NULL, 'Malonyl-CoA decarboxylase, C-terminal catalytic domain superfamily', 'Malonyl_CoA_deC_C_sf', 5, NULL),
(35283, NULL, 'IPR044164', NULL, 'Chalcone--flavonone isomerase', 'CFI', 4, NULL),
(35284, NULL, 'IPR042974', NULL, 'Junctional adhesion molecule C', 'JAM-C', 4, NULL),
(35285, NULL, 'IPR044143', NULL, 'Glycogen branching enzyme GlgB, N-terminal Early set domain', 'GlgB_N_E_set_prok', 3, NULL),
(35286, NULL, 'IPR042840', NULL, 'Lamin tail domain-containing protein 1', 'LMNTD1', 4, NULL),
(35287, NULL, 'IPR043593', NULL, 'Arf-GAP with SH3 domain, ANK repeat and PH domain-containing protein', 'ASAP', 4, NULL),
(35288, NULL, 'IPR043144', NULL, 'Malate/L-sulfolactate/L-lactate dehydrogenase-like, alpha-helical domain', 'Mal/L-sulf/L-lact_DH-like_ah', 5, NULL),
(35289, NULL, 'IPR044037', NULL, 'FANCL, UBC-like domain 3', 'FANCL_d3', 3, NULL),
(35290, NULL, 'IPR044255', NULL, 'Protein Dr1 homolog', 'Dr1-like', 4, NULL),
(35291, NULL, 'IPR042326', NULL, 'CTD kinase subunit gamma', 'Ctk3', 4, NULL),
(35292, NULL, 'IPR042555', NULL, 'StAR-related lipid transfer protein 4', 'StarD4', 4, NULL),
(35293, NULL, 'IPR043840', NULL, 'Protein of unknown function DUF5868', 'DUF5868', 4, NULL),
(35294, NULL, 'IPR043601', NULL, 'R-spondin, Fu-CRD domain', 'Rspo_Fu-CRD_dom', 3, NULL),
(35295, NULL, 'IPR044328', NULL, 'Nonstructural protein 15, N-terminal, gammacoronavirus', 'NSP15_gammaCoV_N', 3, NULL),
(35296, NULL, 'IPR042821', NULL, 'Semaphorin-5A, sema domain', 'Sema5A_sema', 3, NULL),
(35297, NULL, 'IPR044445', NULL, 'DHX9, first double-stranded RNA binding domain', 'DHX9_DSRM_1', 3, NULL),
(35298, NULL, 'IPR044112', NULL, 'Sulfoquinovosidase YihQ-like', 'YihQ-like', 4, NULL),
(35299, NULL, 'IPR043245', NULL, 'Complement component C8 gamma chain', 'C8G', 4, NULL),
(35300, NULL, 'IPR044043', NULL, 'Vanillate O-demethylase oxygenase-like, C-terminal catalytic domain', 'VanA_C_cat', 3, NULL),
(35301, NULL, 'IPR043580', NULL, 'Cutinase, serine active site', 'CUTINASE_1', 2, NULL),
(35302, NULL, 'IPR042833', NULL, 'BTB/POZ domain-containing protein 16', 'BTBD16', 4, NULL),
(35303, NULL, 'IPR044710', NULL, 'PLASTID TRANSCRIPTIONALLY ACTIVE protein 6', 'PTAC6', 4, NULL),
(35304, NULL, 'IPR044686', NULL, 'Transcription repressor OFP17', 'OFP17', 4, NULL),
(35305, NULL, 'IPR044104', NULL, 'Alfin1-like, PHD finger', 'PHD_AL_plant', 3, NULL),
(35306, NULL, 'IPR043786', NULL, 'Domain of unknown function DUF5728', 'DUF5728', 3, NULL),
(35307, NULL, 'IPR044274', NULL, 'E3 ubiquitin-protein ligase RFI2', 'RFI2', 4, NULL),
(35308, NULL, 'IPR043673', NULL, 'Carbamoyl-phosphate synthase', 'CPSase_Archaea', 4, NULL),
(35309, NULL, 'IPR043387', NULL, 'Insulin-like INSL3/INSL4', 'INSL3/INSL4', 4, NULL),
(35310, NULL, 'IPR043063', NULL, 'Agglutinin-like protein, N-terminal, N2 subdomain', 'Agglutinin-like_N_N2', 5, NULL),
(35311, NULL, 'IPR043579', NULL, 'Cutinase, aspartate and histidine active sites', 'CUTINASE_2', 2, NULL),
(35312, NULL, 'IPR043693', NULL, 'Ubiquinone biosynthesis protein UbiV', 'UbiV', 4, NULL),
(35313, NULL, 'IPR044399', NULL, 'Myoglobin-like, M family globin domain', 'Mb-like_M', 3, NULL),
(35314, NULL, 'IPR044145', NULL, 'Translation initiation factor IF-2, domain II', 'IF2_II', 3, NULL),
(35315, NULL, 'IPR044412', NULL, 'PRDM17, PR/SET domain', 'PRDM17_PR-SET', 3, NULL),
(35316, NULL, 'IPR044258', NULL, 'Heavy metal-associated isoprenylated plant protein 9-like', 'HIPP09-like', 4, NULL),
(35317, NULL, 'IPR042948', NULL, 'T-cell immunoglobulin and ITIM domain receptor', 'TIGIT', 4, NULL),
(35318, NULL, 'IPR043790', NULL, 'Domain of unknown function DUF5732', 'DUF5732', 3, NULL),
(35319, NULL, 'IPR043783', NULL, 'Domain of unknown function DUF5725', 'DUF5725', 3, NULL),
(35320, NULL, 'IPR043503', NULL, 'Papain-like viral protease, palm and finger domains, coronavirus', 'PLpro_palm_finger_dom_CoV', 5, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(35321, NULL, 'IPR044841', NULL, 'Transcription factor LUX/BOA-like', 'LUX/BOA-like', 4, NULL),
(35322, NULL, 'IPR044065', NULL, 'Archaeal CBS protein, (ACP)-type metal binding domain', 'ACP_MB', 3, NULL),
(35323, NULL, 'IPR044330', NULL, 'Nonstructural protein 15, N-terminal domain, alpha/beta-coronavirus', 'NSP15_alpha_betaCoV_N', 3, NULL),
(35324, NULL, 'IPR043471', NULL, 'Zinc finger BED domain-containing protein 2/3', 'ZBED2/3', 4, NULL),
(35325, NULL, 'IPR044460', NULL, 'ADAR3, first double-stranded RNA binding domain', 'ADAR3_DSRM_1', 3, NULL),
(35326, NULL, 'IPR043022', NULL, 'Peptide-N-glycosidase F, N-terminal domain superfamily', 'PngaseF_N_sf', 5, NULL),
(35327, NULL, 'IPR042744', NULL, 'Plexin-A1, Sema domain', 'Plexin-A1_Sema', 3, NULL),
(35328, NULL, 'IPR044083', NULL, '(R)-stereoselective amidase RamA-like', 'RamA-like', 3, NULL),
(35329, NULL, 'IPR044825', NULL, 'Transcription activator GLK1/2-like', 'GLK1/2-like', 4, NULL),
(35330, NULL, 'IPR044358', NULL, 'RNA-dependent RNA polymerase, gammacoronavirus', 'RdRp_gammaCoV', 3, NULL),
(35331, NULL, 'IPR044141', NULL, 'AhpF, N-terminal domain, C-terminal TRX-fold subdomain', 'AhpF_NTD_C', 3, NULL),
(35332, NULL, 'IPR044456', NULL, 'ADAR1, first double-stranded RNA binding domain', 'ADAR1_DSRM_1', 3, NULL),
(35333, NULL, 'IPR043158', NULL, 'Wnt, C-terminal domain', 'Wnt_C', 5, NULL),
(35334, NULL, 'IPR044320', NULL, 'NSP11, N-terminal, arterivirus', 'NSP11_Av_N', 3, NULL),
(35335, NULL, 'IPR043928', NULL, 'DVNP family', 'DNVP', 4, NULL),
(35336, NULL, 'IPR042828', NULL, 'TRIM41, PRY/SPRY domain', 'TRIM41_SPRY_PRY', 3, NULL),
(35337, NULL, 'IPR044950', NULL, 'Protein TRACHEARY ELEMENT DIFFERENTIATION-RELATED 6/7', 'TED6/7', 4, NULL),
(35338, NULL, 'IPR043770', NULL, 'Domain of unknown function DUF5716', 'DUF5716_C', 3, NULL),
(35339, NULL, 'IPR044294', NULL, 'Lipase-like', 'Lipase-like', 4, NULL),
(35340, NULL, 'IPR044434', NULL, 'KMT2E, SET domain', 'KMT2E_SET', 3, NULL),
(35341, NULL, 'IPR044957', NULL, 'Ribosomal protein L32p, bacterial type', 'Ribosomal_L32p_bact', 4, NULL),
(35342, NULL, 'IPR044129', NULL, 'Rho guanine nucleotide exchange factor 3, PH domain', 'PH_RhoGEF3_XPLN', 3, NULL),
(35343, NULL, 'IPR042790', NULL, 'Heat shock protein beta-8, alpha-crystallin domain (ACD)', 'HspB8_ACD', 3, NULL),
(35344, NULL, 'IPR043473', NULL, 'Spike glycoprotein S2 superfamily, coronavirus', 'S2_sf_CoV', 5, NULL),
(35345, NULL, 'IPR043454', NULL, 'NPH3/RPT2-like family', 'NPH3/RPT2-like', 4, NULL),
(35346, NULL, 'IPR044415', NULL, 'PRDM5, PR/SET domain', 'PRDM5_PR-SET', 3, NULL),
(35347, NULL, 'IPR044137', NULL, 'Aconitase A, swivel domain', 'AcnA_IRP_Swivel', 3, NULL),
(35348, NULL, 'IPR043769', NULL, 'Protein of unknown function DUF5715', 'DUF5715', 4, NULL),
(35349, NULL, 'IPR044430', NULL, 'SETD6, SET domain', 'SETD6_SET', 3, NULL),
(35350, NULL, 'IPR042940', NULL, 'Heat shock protein beta-9', 'HSPB9', 4, NULL),
(35351, NULL, 'IPR043240', NULL, 'Cysteine-rich and transmembrane domain-containing protein 1-like', 'CYSTM1-like', 4, NULL),
(35352, NULL, 'IPR043461', NULL, 'UDP-2,3-diacylglucosamine hydrolase LpxH-like', 'LpxH-like', 4, NULL),
(35353, NULL, 'IPR044459', NULL, 'ADAR2, second double-stranded RNA binding domain', 'ADAR2_DSRM_2', 3, NULL),
(35354, NULL, 'IPR042313', NULL, 'RELT-like protein 2', 'RELL2', 4, NULL),
(35355, NULL, 'IPR043700', NULL, '3-dehydroshikimate dehydratase', 'DSD', 4, NULL),
(35356, NULL, 'IPR043834', NULL, 'Response receiver domain', 'REC', 3, NULL),
(35357, NULL, 'IPR043036', NULL, 'Phosphoprotein, C-terminal domain, viral', 'Phosphoprotein_C_viral', 5, NULL),
(35358, NULL, 'IPR042310', NULL, 'Pestivirus envelope glycoprotein E2, domain B', 'Pestivirus_E2_B', 5, NULL),
(35359, NULL, 'IPR044515', NULL, 'Ankyrin repeat and BTB/POZ domain-containing protein 1-like', 'ABTB1', 4, NULL),
(35360, NULL, 'IPR043652', NULL, 'Crescentin, coiled-coil domain', 'CreS_coiled-coil', 3, NULL),
(35361, NULL, 'IPR042257', NULL, '2-keto-3-deoxy-galactonokinase, C-terminal domain', 'DGOK_C', 5, NULL),
(35362, NULL, 'IPR044059', NULL, 'Cns1/TTC4, wheel domain', 'Csn1/TTC4_wheel', 3, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(35363, NULL, 'IPR042152', NULL, 'Uncharacterized protein Y4yA-like', 'Y4yA-like', 4, NULL),
(35364, NULL, 'IPR043927', NULL, 'Protein of unknown function DUF5778', 'DUF5778', 4, NULL),
(35365, NULL, 'IPR044448', NULL, 'DND1, double-stranded RNA binding domain', 'DND1_DSRM', 3, NULL),
(35366, NULL, 'IPR044267', NULL, 'Terminase, large subunit, gp17-like', 'Terminase_large_su_gp17-like', 4, NULL),
(35367, NULL, 'IPR043129', NULL, 'ATPase, nucleotide binding domain', 'ATPase_NBD', 5, NULL),
(35368, NULL, 'IPR044038', NULL, 'dATP/dGTP diphosphohydrolase, N-terminal', 'dATP/dGTP_diPOhydrolase_N', 3, NULL),
(35369, NULL, 'IPR042825', NULL, 'PLK2, catalytic domain', 'PLK2_STKc', 3, NULL),
(35370, NULL, 'IPR043156', NULL, 'Catalase, mono-functional, haem-containing, clade 2, helical domain', 'Catalase_clade2_helical', 5, NULL),
(35371, NULL, 'IPR044228', NULL, 'Fatty-acid-binding protein 1', 'FAP1', 4, NULL),
(35372, NULL, 'IPR042201', NULL, 'Formin, FH2 domain superfamily', 'FH2_Formin_sf', 5, NULL),
(35373, NULL, 'IPR043606', NULL, 'Coronavirus replicase NSP15, N-terminal oligomerization', 'CoV_NSP15_N', 3, NULL),
(35374, NULL, 'IPR043692', NULL, 'Ubiquinone biosynthesis protein UbiU', 'UbiU', 4, NULL),
(35375, NULL, 'IPR044264', NULL, 'Protoporphyrinogen IX dehydrogenase [quinone] HemG', 'HemG', 4, NULL),
(35376, NULL, 'IPR044369', NULL, 'Non-structural protein 6, alphacoronavirus', 'NSP6_alphaCoV', 3, NULL),
(35377, NULL, 'IPR043907', NULL, 'Protein of unknown function DUF5770', 'DUF5770', 4, NULL),
(35378, NULL, 'IPR043916', NULL, 'Protein of unknown function DUF5761', 'DUF5761', 4, NULL),
(35379, NULL, 'IPR044099', NULL, 'mRNA decapping enzyme 2 ,  NUDIX hydrolase domain', 'Dcp2_NUDIX', 3, NULL),
(35380, NULL, 'IPR044100', NULL, 'Homer, EVH1 domain', 'Homer_EVH1', 3, NULL),
(35381, NULL, 'IPR044428', NULL, 'SETD3, SET domain', 'SETD3_SET', 3, NULL),
(35382, NULL, 'IPR042312', NULL, 'Uncharacterized protein F26C11.3-like', 'F26C11.3-like', 4, NULL),
(35383, NULL, 'IPR043146', NULL, 'Penicillin amidase type, N-terminal domain, B-knob', 'Penicillin_amidase_N_B-knob', 5, NULL),
(35384, NULL, 'IPR045358', NULL, 'Ty3 transposon capsid-like protein', 'Ty3_capsid', 3, NULL),
(35385, NULL, 'IPR043610', NULL, 'Non-structural protein 6, coronavirus', 'NSP6_CoV', 3, NULL),
(35386, NULL, 'IPR044798', NULL, 'Chromatin modification-related protein EAF1A/B', 'EAF1A/B', 4, NULL),
(35387, NULL, 'IPR042829', NULL, '3-keto-steroid reductase', 'HSD17B7/Erg27', 4, NULL),
(35388, NULL, 'IPR042617', NULL, 'CST complex subunit CTC1-like', 'CTC1-like', 4, NULL),
(35389, NULL, 'IPR042814', NULL, 'MORN repeat-containing protein 5', 'Morn5', 4, NULL),
(35390, NULL, 'IPR045344', NULL, 'C-JID domain', 'C-JID', 3, NULL),
(35391, NULL, 'IPR044427', NULL, 'LegAS4-like, SET domain', 'LegAS4-like_SET', 3, NULL),
(35392, NULL, 'IPR042616', NULL, 'Proline and serine-rich protein 1', 'PROSER1', 4, NULL),
(35393, NULL, 'IPR044114', NULL, 'Bile acid receptor,  ligand binding domain', 'NR_LBD_NR1H4', 3, NULL),
(35394, NULL, 'IPR043679', NULL, '5-deoxyribose 1-phosphate isomerase', 'Deoxyribose1P_isomerase_DrdI', 4, NULL),
(35395, NULL, 'IPR044056', NULL, 'Internalin I, Ig-like domain', 'InlI_Ig-like', 3, NULL),
(35396, NULL, 'IPR043140', NULL, 'Ribosomal protein S14/S29', 'Ribosomal_S14/S29', 5, NULL),
(35397, NULL, 'IPR044431', NULL, 'RBCMT, SET domain', 'SET_RBCMT', 3, NULL),
(35398, NULL, 'IPR042835', NULL, 'Pleckstrin homology domain-containing family N member 1', 'PLEKHN1', 4, NULL),
(35399, NULL, 'IPR043954', NULL, 'Snu56-like U1 small nuclear ribonucleoprotein component', 'Snu56_snRNP', 4, NULL),
(35400, NULL, 'IPR044200', NULL, 'Uncharacterized protein At5g03900-like', 'At5g03900-like', 4, NULL),
(35401, NULL, 'IPR044966', NULL, 'Protein RESISTANCE TO PHYTOPHTHORA 1, chloroplastic', 'RPH1', 4, NULL),
(35402, NULL, 'IPR043701', NULL, 'Splicing factor Yju2', 'Yju2', 4, NULL),
(35403, NULL, 'IPR042311', NULL, 'Pestivirus envelope glycoprotein E2, domain D', 'Pestivirus_E2_D', 5, NULL),
(35404, NULL, 'IPR043844', NULL, 'Domain of unknown function DUF5865', 'DUF5865', 3, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(35405, NULL, 'IPR042979', NULL, 'von Willebrand factor C domain-containing protein 2-like', 'VWC2/VWC2L', 4, NULL),
(35406, NULL, 'IPR043566', NULL, 'Rabphilin/DOC2/Noc2', 'Rabphilin/DOC2/Noc2', 4, NULL),
(35407, NULL, 'IPR044952', NULL, 'Protein SENSITIVE TO UV 2', 'SUV2', 4, NULL),
(35408, NULL, 'IPR044119', NULL, 'LigC-like, adenylation domain', 'Adenylation_LigC-like', 3, NULL),
(35409, NULL, 'IPR043186', NULL, 'Rhodanese-like domain-containing protein 14', 'Str14', 4, NULL),
(35410, NULL, 'IPR046431', NULL, 'Fantastic Four domain', 'FAF_dom', 3, NULL),
(35411, NULL, 'IPR043609', NULL, 'NendoU domain, nidovirus', 'NendoU_nidovirus', 3, NULL),
(35412, NULL, 'IPR042771', NULL, 'TFIIIC subunit GTF3C6-like', 'GTF3C6-like', 4, NULL),
(35413, NULL, 'IPR042560', NULL, 'Exocyst component Exo84, C-terminal, subdomain 2', 'Exo84_C_2', 5, NULL),
(35414, NULL, 'IPR042573', NULL, 'GNAT acetyltransferase, N-terminal', 'GNAT_acetyltra_N', 5, NULL),
(35415, NULL, 'IPR043773', NULL, 'Wadjet protein JetA', 'JetA', 4, NULL),
(35416, NULL, 'IPR043612', NULL, 'Non-structural protein NSP4, N-terminal, coronavirus', 'CoV_NSP4_N', 3, NULL),
(35417, NULL, 'IPR042253', NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase superfamily', 'Pglycerate_mutase_ApgM_sf', 5, NULL),
(35418, NULL, 'IPR043920', NULL, 'Protein of unknown function DUF5757', 'DUF5757', 4, NULL),
(35419, NULL, 'IPR044169', NULL, 'Protein PYRICULARIA ORYZAE RESISTANCE 21', 'PI21', 4, NULL),
(35420, NULL, 'IPR044499', NULL, 'Aldo-keto reductase family 5A', 'AKR5A', 4, NULL),
(35421, NULL, 'IPR042843', NULL, 'DTX3L, RING-HC finger', 'TX3L_RING-HC', 3, NULL),
(35422, NULL, 'IPR044878', NULL, 'UbiA prenyltransferase superfamily', 'UbiA_sf', 5, NULL),
(35423, NULL, 'IPR042826', NULL, 'Plexin-A2, sema domain', 'Plexin-A2_sema', 3, NULL),
(35424, NULL, 'IPR044965', NULL, 'Glycoside hydrolase family 17, plant', 'Glyco_hydro_17_plant', 4, NULL),
(35425, NULL, 'IPR042766', NULL, 'RSK3, C-terminal catalytic domain', 'RSK3_STKc', 3, NULL),
(35426, NULL, 'IPR043908', NULL, 'Protein of unknown function DUF5769', 'DUF5769', 4, NULL),
(35427, NULL, 'IPR044127', NULL, 'Initiation factor eIF2 gamma, domain 2', 'eIF2g_dom_2', 3, NULL),
(35428, NULL, 'IPR043761', NULL, 'Protein of unknown function DUF5707', 'DUF5707', 4, NULL),
(35429, NULL, 'IPR043841', NULL, 'Domain of unknown function DUF5867', 'DUF5867', 3, NULL),
(35430, NULL, 'IPR042127', NULL, 'Transmembrane protein 45', 'TMEM45', 4, NULL),
(35431, NULL, 'IPR044865', NULL, 'MRH domain', 'MRH_dom', 3, NULL),
(35432, NULL, 'IPR044095', NULL, 'ADCK2-like dom', 'ADCK2_dom', 3, NULL),
(35433, NULL, 'IPR044876', NULL, 'HRDC domain superfamily', 'HRDC_dom_sf', 5, NULL),
(35434, NULL, 'IPR043791', NULL, 'Domain of unknown function DUF5733', 'DUF5733', 3, NULL),
(35435, NULL, 'IPR046448', NULL, 'ECSIT, N-terminal', 'ECSIT_N', 3, NULL),
(35436, NULL, 'IPR043603', NULL, 'Phlebovirus glycoprotein G2, C-terminal domain', 'Phlebo_G2_C', 3, NULL),
(35437, NULL, 'IPR042667', NULL, 'E3 ubiquitin-protein ligase TRIM63, RING finger, HC subclass', 'TRIM63_RING-HC', 3, NULL),
(35438, NULL, 'IPR044144', NULL, 'UxaA/GarD, SAF domain', 'UxaA/GarD_SAF', 3, NULL),
(35439, NULL, 'IPR044265', NULL, 'Terminase, large subunit BPP22-like', 'Terminase_large_su_BPP22', 4, NULL),
(35440, NULL, 'IPR044213', NULL, 'Thylakoid lumenal 15kDa protein 1-like', 'At2g44920-like', 4, NULL),
(35441, NULL, 'IPR043929', NULL, 'Protein of unknown function DUF5755', 'DUF5755', 4, NULL),
(35442, NULL, 'IPR042550', NULL, 'M matrix/glycoprotein, gammacoronavirus', 'GAMMA_CORONA_M', 4, NULL),
(35443, NULL, 'IPR044419', NULL, 'SMYD2, SET domain', 'SMYD2_SET', 3, NULL),
(35444, NULL, 'IPR044457', NULL, 'ADAR1, third double-stranded RNA binding domain', 'ADAR1_DSRM_3', 3, NULL),
(35445, NULL, 'IPR044066', NULL, 'TRIAD supradomain', 'TRIAD_supradom', 3, NULL),
(35446, NULL, 'IPR044863', NULL, 'Nidovirus  RdRp-associated nucleotidyl transferase (NiRAN) domain', 'NIRAN', 3, NULL),
(35447, NULL, 'IPR044266', NULL, 'Phosphoserine phosphatase YsaA', 'PSP_YsaA', 4, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(35448, NULL, 'IPR044312', NULL, 'MERS-CoV  ORF8b protein-like', 'merbe_CoV_ORF8b-like', 4, NULL),
(35449, NULL, 'IPR043774', NULL, 'Domain of unknown function DUF5717, C-terminal', 'DUF5717_C', 3, NULL),
(35450, NULL, 'IPR044088', NULL, 'Glutathione S-transferase kappa', 'GSTK', 4, NULL),
(35451, NULL, 'IPR042615', NULL, 'DHX57, UBA domain', 'DHX57_UBA', 3, NULL),
(35452, NULL, 'IPR043518', NULL, '2-5-oligoadenylate synthetase, N-terminal conserved site', '2-5OAS_N_CS', 2, NULL),
(35453, NULL, 'IPR044452', NULL, 'EIF2AK2, first double-stranded RNA binding domain', 'EIF2AK2_DSRM_1', 3, NULL),
(35454, NULL, 'IPR043690', NULL, 'N-acetyltransferase RimI', 'RimI', 4, NULL),
(35455, NULL, 'IPR042823', NULL, 'E3 ubiquitin-protein ligase Dma1/Dma2, RING finger, H2 subclass', 'Dma1/Dma2_RING-H2', 3, NULL),
(35456, NULL, 'IPR044873', NULL, 'Spike glycoprotein S2, coronavirus, heptad repeat 1', 'Spike_S2_CoV_HR1', 3, NULL),
(35457, NULL, 'IPR042158', NULL, 'PI-PLC X domain-containing protein 1/2/3', 'PLCXD1/2/3', 4, NULL),
(35458, NULL, 'IPR044432', NULL, 'Set10/Efm1, SET domain', 'Set10/Efm1_SET', 3, NULL),
(35459, NULL, 'IPR046458', NULL, 'Phosphomannose isomerase type I, helical insertion domain', 'PMI_typeI_hel', 3, NULL),
(35460, NULL, 'IPR044969', NULL, 'Protein DOUBLE-STRAND BREAK FORMATION', 'DFO', 4, NULL),
(35461, NULL, 'IPR043953', NULL, 'Protein of unknown function DUF5784', 'DUF5784', 4, NULL),
(35462, NULL, 'IPR042741', NULL, 'RING1 , RING finger, HC subclass', 'RING1_RING-HC', 3, NULL),
(35463, NULL, 'IPR043911', NULL, 'Protein of unknown function DUF5766', 'DUF5766', 4, NULL),
(35464, NULL, 'IPR043453', NULL, 'Slm1, PH domain', 'Slm1_PH', 3, NULL),
(35465, NULL, 'IPR043973', NULL, 'CCN, TSP1 domain', 'TSP1_CCN', 3, NULL),
(35466, NULL, 'IPR044418', NULL, 'SMYD1, SET domain', 'SMYD1_SET', 3, NULL),
(35467, NULL, 'IPR042252', NULL, 'MtfA, N-terminal', 'MtfA_N', 5, NULL),
(35468, NULL, 'IPR043798', NULL, 'Domain of unknown function DUF5737', 'DUF5737', 3, NULL),
(35469, NULL, 'IPR042731', NULL, 'Sodium/myo-inositol cotransporter SMIT', 'SMIT', 4, NULL),
(35470, NULL, 'IPR043913', NULL, 'Protein of unknown function DUF5764', 'DUF5764', 4, NULL),
(35471, NULL, 'IPR044096', NULL, 'Isoamylase 2, catalytic domain', 'AmyAc_plant_ISA2', 3, NULL),
(35472, NULL, 'IPR042831', NULL, '54S ribosomal protein L28, mitochondrial', 'YmL28', 4, NULL),
(35473, NULL, 'IPR043105', NULL, 'Tenuivirus NS3', 'Tenui_NS3', 5, NULL),
(35474, NULL, 'IPR043936', NULL, 'HOOK, N-terminal', 'HOOK_N', 3, NULL),
(35475, NULL, 'IPR044629', NULL, 'Glutathione S-transferase L1/2/3', 'GSTL1/2/3', 4, NULL),
(35476, NULL, 'IPR044541', NULL, 'FAF1, UBA-like domain', 'FAF1_UBA', 3, NULL),
(35477, NULL, 'IPR043136', NULL, 'B30.2/SPRY domain superfamily', 'B30.2/SPRY_sf', 5, NULL),
(35478, NULL, 'IPR042824', NULL, 'Semaphorin-7A, sema domain', 'Sema7A_sema', 3, NULL),
(35479, NULL, 'IPR044437', NULL, 'SETD2/Set2, SET domain', 'SETD2/Set2_SET', 3, NULL),
(35480, NULL, 'IPR042820', NULL, 'Semaphorin-3A, sema domain', 'Sema3A_sema', 3, NULL),
(35481, NULL, 'IPR044168', NULL, 'bZIP transcription factor RISBZ3/4/5', 'RISBZ3/4/5', 4, NULL),
(35482, NULL, 'IPR044111', NULL, 'GGA3, GAT domain', 'GAT_GGA3', 3, NULL),
(35483, NULL, 'IPR044331', NULL, 'Nonstructural protein 15, N-terminal, deltacoronavirus', 'NSP15_N_deltaCoV', 3, NULL),
(35484, NULL, 'IPR043269', NULL, 'Lateral signaling target protein 2, FYVE domain', 'FYVE_LST2', 3, NULL),
(35485, NULL, 'IPR044295', NULL, 'Transcription factor BIM1/2/3', 'BIM1/2/3', 4, NULL),
(35486, NULL, 'IPR042258', NULL, '2-keto-3-deoxy-galactonokinase, N-terminal', 'DGOK_N', 5, NULL),
(35487, NULL, 'IPR042193', NULL, 'FHIPEP, domain 3', 'FHIPEP_3', 5, NULL),
(35488, NULL, 'IPR042332', NULL, 'DASH complex subunit Hsk3', 'Hsk3', 4, NULL),
(35489, NULL, 'IPR043926', NULL, 'ABC transporter family G domain', 'ABCG_dom', 3, NULL),
(35490, NULL, 'IPR044101', NULL, 'Retinoid-related orphan receptors, DNA-binding domain', 'NR_DBD_ROR', 3, NULL),
(35491, NULL, 'IPR043381', NULL, 'Solute carrier family 15 member 2', 'SLC15A2', 3, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(35492, NULL, 'IPR044392', NULL, 'ORF8, bat coronavirus Rf1-like', 'ORF8_Bat_SARS_CoV_Rf1-like', 4, NULL),
(35493, NULL, 'IPR043919', NULL, 'Protein of unknown function DUF5758', 'DUF5758', 4, NULL),
(35494, NULL, 'IPR042969', NULL, 'Ubiquitin D', 'Ubiquitin_D', 4, NULL),
(35495, NULL, 'IPR042978', NULL, 'DnaJ homolog subfamily C member 24', 'DNAJC24', 4, NULL),
(35496, NULL, 'IPR043607', NULL, 'Coronavirus spike glycoprotein S1, C-terminal', 'CoV_S1_C', 3, NULL),
(35497, NULL, 'IPR043033', NULL, 'PvsD/AcsD-like, thumb domain, four stranded beta-sheet', 'PvsD/AcsD-like_thumb_beta', 5, NULL),
(35498, NULL, 'IPR042972', NULL, 'Insulinoma-associated protein 1/2', 'INSM1/2', 4, NULL),
(35499, NULL, 'IPR044451', NULL, 'AtDRB-like, second double-stranded RNA binding domain, plant', 'AtDRB-like_DSRM_2', 3, NULL),
(35500, NULL, 'IPR042563', NULL, 'Ribosomal protein S8e subdomain, eukaryotes', 'Ribosomal_protein_S8e_euk', 5, NULL),
(35501, NULL, 'IPR043628', NULL, 'DAZ domain', 'DAZ_dom', 3, NULL),
(35502, NULL, 'IPR045456', NULL, 'vWA-MoxR associated protein middle region 14', 'VMAP-M14', 3, NULL),
(35503, NULL, 'IPR043988', NULL, 'CCZ1/INTU, second Longin domain', 'CCZ1/INTU_longin_2', 3, NULL),
(35504, NULL, 'IPR043959', NULL, 'CRISPR system CMR subunit Cmr7 1', 'Cmr7A', 4, NULL),
(35505, NULL, 'IPR044440', NULL, 'Plant glutamate receptor, periplasmic ligand-binding domain', 'GABAb_receptor_plant_PBP1', 3, NULL),
(35506, NULL, 'IPR042580', NULL, 'AIRE, PHD finger 2', 'AIRE_PHD2', 3, NULL),
(35507, NULL, 'IPR043732', NULL, 'Domain of unknown function DUF5675', 'DUF5675', 3, NULL),
(35508, NULL, 'IPR043531', NULL, 'E3 SUMO-protein ligase CBX4', 'CBX4', 4, NULL),
(35509, NULL, 'IPR045051', NULL, 'Subtilisin-like protease', 'SBT', 4, NULL),
(35510, NULL, 'IPR043380', NULL, 'Germ cell-less protein-like', 'Gcl-like', 4, NULL),
(35511, NULL, 'IPR043748', NULL, 'Family of unknown function DUF5693', 'DUF5693', 4, NULL),
(35512, NULL, 'IPR043961', NULL, 'Protein of unknown function DUF5749', 'DUF5749', 4, NULL),
(35513, NULL, 'IPR043957', NULL, 'Vanin, C-terminal', 'Vanin_C', 3, NULL),
(35514, NULL, 'IPR042517', NULL, 'Beta-1,3-glucanase, N-terminal, subdomain 2', 'Glyco_hydro_64_N_2', 5, NULL),
(35515, NULL, 'IPR045046', NULL, 'Vacuolar protein sorting-associated protein 9-like', 'Vps9-like', 4, NULL),
(35516, NULL, 'IPR042627', NULL, 'F-box/WD repeat-containing protein 2', 'FBXW2', 4, NULL),
(35517, NULL, 'IPR042921', NULL, 'Cystatin-like 1', 'CSTL1', 4, NULL),
(35518, NULL, 'IPR042702', NULL, 'Myosin-13, motor domain', 'Myh13_MYSc', 3, NULL),
(35519, NULL, 'IPR043535', NULL, 'Tubulin epsilon and delta complex protein 1', 'TEDC1', 4, NULL),
(35520, NULL, 'IPR045475', NULL, 'Inactive STAND domain', 'iSTAND', 3, NULL),
(35521, NULL, 'IPR045077', NULL, 'Ribosomal protein L3, archaeal/eukaryotic type', 'L3_arc_euk', 4, NULL),
(35522, NULL, 'IPR042480', NULL, 'Protein dispatched homolog 3', 'DISP3', 4, NULL),
(35523, NULL, 'IPR044049', NULL, 'EccD-like transmembrane domain', 'EccD_transm', 3, NULL),
(35524, NULL, 'IPR045520', NULL, 'GPAT/DHAPAT, C-terminal domain', 'GPAT/DHAPAT_C', 3, NULL),
(35525, NULL, 'IPR044641', NULL, 'Sm-like protein Lsm7/SmG', 'Lsm7/SmG-like', 4, NULL),
(35526, NULL, 'IPR045523', NULL, 'GTPase-associated system helical domain', 'GASH', 3, NULL),
(35527, NULL, 'IPR044113', NULL, 'DDX41, DEAD-box helicase domain', 'DEADc_DDX41', 3, NULL),
(35528, NULL, 'IPR045367', NULL, 'Protein of unknown function DUF5885', 'DUF5885', 4, NULL),
(35529, NULL, 'IPR044077', NULL, 'Amylosucrase, catalytic domain', 'Amylosucrase', 3, NULL),
(35530, NULL, 'IPR043595', NULL, 'Feruloyl esterase B/C/D', 'FaeB/C/D', 4, NULL),
(35531, NULL, 'IPR042447', NULL, 'Anosmin-1', 'Anosmin-1', 4, NULL),
(35532, NULL, 'IPR045538', NULL, 'Contractile injection system tape measure protein', 'CIS_TMP', 4, NULL),
(35533, NULL, 'IPR046854', NULL, 'Isocitrate dehydrogenase kinase/phosphatase (AceK), regulatory domain', 'AceK_regulatory', 3, NULL),
(35534, NULL, 'IPR045043', NULL, 'Late embryogenesis abundant protein Lea14-like', 'Lea14-like', 4, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(35535, NULL, 'IPR042865', NULL, 'Aspartate-rich protein 1-like', 'DRICH1-like', 4, NULL),
(35536, NULL, 'IPR044975', NULL, 'ATP synthase protein YMF19', 'YMF19-like', 4, NULL),
(35537, NULL, 'IPR043547', NULL, 'Mimecan/Epiphycan/Opticin', 'Mimecan/Epiphycan/Opticin', 4, NULL),
(35538, NULL, 'IPR043833', NULL, 'Protein of unknown function DUF5810', 'DUF5810', 4, NULL),
(35539, NULL, 'IPR043781', NULL, 'Domain of unknown function DUF5723', 'DUF5723', 3, NULL),
(35540, NULL, 'IPR043716', NULL, 'Family of unknown function DUF5657', 'DUF5657', 4, NULL),
(35541, NULL, 'IPR043824', NULL, 'Domain of unknown function DUF5801', 'DUF5801', 3, NULL),
(35542, NULL, 'IPR042478', NULL, '72kDa inositol polyphosphate 5-phosphatase', 'INPP5E', 4, NULL),
(35543, NULL, 'IPR044061', NULL, 'Oxytoxin-type inhibitor cystine knot (ICK) domain', 'OXYTX_ICK', 3, NULL),
(35544, NULL, 'IPR042944', NULL, 'Collectrin', 'Collectrin', 4, NULL),
(35545, NULL, 'IPR043657', NULL, 'Protein of unknown function DUF5876', 'DUF5876', 4, NULL),
(35546, NULL, 'IPR044031', NULL, 'TssC1, N-terminal', 'TssC1_N', 3, NULL),
(35547, NULL, 'IPR042462', NULL, 'Armadillo repeat-containing protein 7', 'ARMC7', 4, NULL),
(35548, NULL, 'IPR043604', NULL, 'DUF883, N-terminal domain', 'DUF883_N', 3, NULL),
(35549, NULL, 'IPR044035', NULL, 'Domain of unknown function DUF5698', 'DUF5698', 3, NULL),
(35550, NULL, 'IPR043713', NULL, 'Family of unknown function DUF5654', 'DUF5654', 4, NULL),
(35551, NULL, 'IPR046863', NULL, 'Methanobactin biosynthesis cassette protein MbnP-like', 'MbnP-like', 4, NULL),
(35552, NULL, 'IPR043813', NULL, 'Protein of unknown function DUF5795', 'DUF5795', 4, NULL),
(35553, NULL, 'IPR043705', NULL, 'Plasmodium repeat of length 46', 'P_repeat_46', 7, NULL),
(35554, NULL, 'IPR043835', NULL, 'Protein of unknown function DUF5811', 'DUF5811', 4, NULL),
(35555, NULL, 'IPR045345', NULL, 'Retroviral nucleocapsid Gag protein p24, C-terminal domain', 'Gag_p24_C', 3, NULL),
(35556, NULL, 'IPR046454', NULL, 'Terminase large subunit GpA, endonuclease domain', 'GpA_endonuclease', 3, NULL),
(35557, NULL, 'IPR044976', NULL, 'FIPS3/FIPS5-like', 'FIPS3/FIPS5-like', 4, NULL),
(35558, NULL, 'IPR043734', NULL, 'Domain of unknown function DUF5678', 'DUF5678', 3, NULL),
(35559, NULL, 'IPR045484', NULL, 'FtsH ternary system domain X5', 'fvmX5', 3, NULL),
(35560, NULL, 'IPR044389', NULL, 'Non-structural protein 2, SARS-CoV-like', 'NSP2_SARS-CoV-like', 3, NULL),
(35561, NULL, 'IPR044040', NULL, 'Domain of unknown function DUF5744', 'DUF5744', 3, NULL),
(35562, NULL, 'IPR043721', NULL, 'Family of unknown function DUF5662', 'DUF5662', 4, NULL),
(35563, NULL, 'IPR043040', NULL, 'Phospholipase B-like, domain 1', 'PLipase_B-like_dom1', 5, NULL),
(35564, NULL, 'IPR045036', NULL, 'Spartin-like', 'Spartin-like', 4, NULL),
(35565, NULL, 'IPR045383', NULL, 'Protein of unknown function DUF6528', 'DUF6528', 4, NULL),
(35566, NULL, 'IPR044973', NULL, 'Senescence-associated protein AAF-like, chlorolplastic', 'AAF-like', 4, NULL),
(35567, NULL, 'IPR042476', NULL, 'Amyloid protein-binding protein 2', 'APPBP2', 4, NULL),
(35568, NULL, 'IPR044388', NULL, 'Non-structural protein 2, MERS-CoV-like', 'NSP2_MERS-like', 3, NULL),
(35569, NULL, 'IPR043777', NULL, 'Protein of unknown function DUF5719', 'DUF5719', 4, NULL),
(35570, NULL, 'IPR045073', NULL, 'Glutathione S-transferase Omega/Tau-like', 'Omega/Tau-like', 4, NULL),
(35571, NULL, 'IPR045057', NULL, 'Gcn5-related N-acetyltransferase', 'Gcn5-rel_NAT', 4, NULL),
(35572, NULL, 'IPR045303', NULL, 'HMGB9-like, ARID/BRIGHT DNA binding domain', 'ARID_HMGB9-like', 3, NULL),
(35573, NULL, 'IPR044051', NULL, 'Prophage endopeptidase tail, N-terminal', 'Prophage_tail_N', 3, NULL),
(35574, NULL, 'IPR043039', NULL, 'TBC1 domain family member 7, domain 2', 'TBC1D7_dom2', 5, NULL),
(35575, NULL, 'IPR045381', NULL, 'Brassinosteroid receptor  BRI1, island domain', 'BRI1_island_dom', 3, NULL),
(35576, NULL, 'IPR043984', NULL, 'Domain of unknown function DUF5742', 'DUF5742', 3, NULL),
(35577, NULL, 'IPR042110', NULL, 'Adenylosuccinate synthetase, domain 2', 'Adenylosuccinate_synth_dom2', 5, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(35578, NULL, 'IPR043806', NULL, 'Protein of unknown function DUF5870', 'DUF5870', 4, NULL),
(35579, NULL, 'IPR043735', NULL, 'Domain of unknown function DUF5680', 'DUF5680', 3, NULL),
(35580, NULL, 'IPR044271', NULL, 'Terminase, large subunit gp19', 'Terminase_large_su_gp19', 4, NULL),
(35581, NULL, 'IPR045389', NULL, 'Protein of unknown function DUF6522', 'DUF6522', 4, NULL),
(35582, NULL, 'IPR044502', NULL, 'Homogentisate solanesyltransferase  AtHST-like', 'AtHST-like', 4, NULL),
(35583, NULL, 'IPR045233', NULL, 'Mannose-1-phosphate guanyltransferase, N-terminal domain', 'GMPPB_N', 3, NULL),
(35584, NULL, 'IPR042626', NULL, 'THO complex subunit 6', 'THOC6', 4, NULL),
(35585, NULL, 'IPR042113', NULL, 'Phosphate acetyltransferase, domain 1', 'P_AcTrfase_dom1', 5, NULL),
(35586, NULL, 'IPR042778', NULL, 'Zinc finger CW-type PWWP domain protein ZCWPW1/ZCWPW2', 'ZCWPW1/ZCWPW2', 4, NULL),
(35587, NULL, 'IPR043053', NULL, 'Pre-hexon-linking protein IIIa, N-terminal', 'Hex_IIIa_N', 5, NULL),
(35588, NULL, 'IPR045426', NULL, 'ADYC domain', 'ADYC', 3, NULL),
(35589, NULL, 'IPR042636', NULL, 'Ankyrin repeat domain-containing protein 11', 'ANKRD11', 4, NULL),
(35590, NULL, 'IPR042485', NULL, 'Type VII secretion system EccB, repeat 3 domain', 'T7SS_EccB_R3', 5, NULL),
(35591, NULL, 'IPR045543', NULL, 'Ternary complex associated domain 7', 'TCAD7', 3, NULL),
(35592, NULL, 'IPR042465', NULL, 'Xyloside xylosyltransferase 1', 'XXLT1', 4, NULL),
(35593, NULL, 'IPR046793', NULL, 'Cysteine protease ATG4, F-type LIR motif', 'ATG4_LIR', 2, NULL),
(35594, NULL, 'IPR045261', NULL, 'MICRORCHIDIA ATPase family', 'MORC_ATPase', 4, NULL),
(35595, NULL, 'IPR045464', NULL, 'F-box protein Hrt3/FBXO9, C-terminal', 'Hrt3/FBXO9_C', 3, NULL),
(35596, NULL, 'IPR043939', NULL, 'Domain of unknown function DUF5780', 'DUF5780', 3, NULL),
(35597, NULL, 'IPR045085', NULL, 'DNA polymerase III, subunit gamma/tau, helical lid domain', 'HLD_clamp_pol_III_gamma_tau', 3, NULL),
(35598, NULL, 'IPR044446', NULL, 'DHX9, second double-stranded RNA binding domain', 'DHX9_DSRM_2', 3, NULL),
(35599, NULL, 'IPR042949', NULL, 'KBTBD4, BTB/POZ domain', 'KBTBD4_BTB_POZ', 3, NULL),
(35600, NULL, 'IPR042635', NULL, 'Scavenger receptor class F member SREC1/2', 'SREC1/2', 4, NULL),
(35601, NULL, 'IPR042618', NULL, 'Dynein regulatory complex protein 9', 'IQCG', 4, NULL),
(35602, NULL, 'IPR045402', NULL, 'GTPase-associated protein 1, N-terminal domain type 2', 'GAP1-N2', 3, NULL),
(35603, NULL, 'IPR044980', NULL, 'NADH dehydrogenase [ubiquinone] 1 beta subcomplex subunit 2, plant/fungi', 'NDUFB2_plant/fungi', 4, NULL),
(35604, NULL, 'IPR045086', NULL, 'OBG-type GTPase', 'OBG_GTPase', 4, NULL),
(35605, NULL, 'IPR044023', NULL, 'Ig-like domain CHU_C associated', 'Ig_7', 3, NULL),
(35606, NULL, 'IPR042584', NULL, '14-3-3 theta', '14-3-3_theta', 4, NULL),
(35607, NULL, 'IPR044016', NULL, 'Bacterial Ig-like domain 13', 'Big_13', 3, NULL),
(35608, NULL, 'IPR043508', NULL, 'Brdt, bromodomain, repeat I', 'Bromo_Brdt_I', 3, NULL),
(35609, NULL, 'IPR044384', NULL, 'Non-structural protein 2, MHV-like', 'NSP2_MHV-like', 3, NULL),
(35610, NULL, 'IPR045427', NULL, 'MoxR domain', 'MoxR', 3, NULL),
(35611, NULL, 'IPR045437', NULL, 'Effector-associated domain 8', 'EAD8', 3, NULL),
(35612, NULL, 'IPR042772', NULL, 'SH3 domain and tetratricopeptide repeat-containing protein  SH3TC1/SH3TC2', 'SH3TC1/SH3TC2', 4, NULL),
(35613, NULL, 'IPR042942', NULL, 'Laforin', 'Laforin', 4, NULL),
(35614, NULL, 'IPR045268', NULL, 'LIM domain and actin-binding protein LIMA-like', 'LIMA-like', 4, NULL),
(35615, NULL, 'IPR045025', NULL, 'TPP-binding domain containing protein HACL1-like', 'HACL1-like', 4, NULL),
(35616, NULL, 'IPR045392', NULL, 'Protein of unknown function DUF6519', 'DUF6519', 4, NULL),
(35617, NULL, 'IPR045365', NULL, 'Protein of unknown function DUF5884', 'DUF5884', 4, NULL),
(35618, NULL, 'IPR045394', NULL, 'Alpha/beta hydrolase domain', 'Abhydrolase_dom', 3, NULL),
(35619, NULL, 'IPR043788', NULL, 'Domain of unknown function DUF5730', 'DUF5730', 3, NULL),
(35620, NULL, 'IPR043745', NULL, 'Family of unknown function DUF5690', 'DUF5690', 4, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(35621, NULL, 'IPR045283', NULL, 'Cytokinin-induced F-Box protein AT3G44326-like', 'AT3G44326-like', 4, NULL),
(35622, NULL, 'IPR046774', NULL, 'Putative adhesin domain (group 10)', 'pAdhesive_10', 3, NULL),
(35623, NULL, 'IPR045471', NULL, 'Protein of unknown function DUF6494', 'DUF6494', 4, NULL),
(35624, NULL, 'IPR044024', NULL, 'Atypical Rib domain', 'aRib', 3, NULL),
(35625, NULL, 'IPR045458', NULL, 'Wolframin, Sel1-like repeat', 'Wolframin_Sel1-like_rpt', 7, NULL),
(35626, NULL, 'IPR042704', NULL, 'Serine/threonine-protein kinase 17A, catalytic domain', 'DRAK1_STKc', 3, NULL),
(35627, NULL, 'IPR043244', NULL, 'Biorientation of chromosomes in cell division protein 1-like 1', 'BOD1L1', 4, NULL),
(35628, NULL, 'IPR042756', NULL, 'Protein sel-1 homolog 3', 'Sel-1L3', 4, NULL),
(35629, NULL, 'IPR043836', NULL, 'Dimerisation and histidine phosphotransfer (DHp) domain', 'DHp', 3, NULL),
(35630, NULL, 'IPR045279', NULL, 'Two-component response regulator ARR-like', 'ARR-like', 4, NULL),
(35631, NULL, 'IPR042700', NULL, 'Sodium-coupled monocarboxylate transporter 2, solute-binding domain', 'SMCT2_SLC5sbd', 3, NULL),
(35632, NULL, 'IPR045399', NULL, 'Trypanosoma Tc-38 (p38) protein', 'Tc-38', 3, NULL),
(35633, NULL, 'IPR044925', NULL, 'His-Me finger superfamily', 'His-Me_finger_sf', 5, NULL),
(35634, NULL, 'IPR045368', NULL, 'Protein of unknown function DUF5886', 'DUF5886', 4, NULL),
(35635, NULL, 'IPR043545', NULL, 'Glutamate receptor-interacting protein 1/2', 'GRIP1/2', 4, NULL),
(35636, NULL, 'IPR045373', NULL, 'Domain of unknown function DUF5889', 'DUF5889', 3, NULL),
(35637, NULL, 'IPR045452', NULL, 'vWA-MoxR associated protein middle region 7', 'VMAP-M7', 3, NULL),
(35638, NULL, 'IPR044503', NULL, 'Aldo-keto reductase family 5C1', 'AKR5C1', 4, NULL),
(35639, NULL, 'IPR043719', NULL, 'Domain of unknown function DUF5660', 'DUF5660', 3, NULL),
(35640, NULL, 'IPR044098', NULL, 'STAMBP/STALP-like, MPN domain', 'STAMBP/STALP-like_MPN', 3, NULL),
(35641, NULL, 'IPR045319', NULL, 'Potassium channel KAT/AKT', 'KAT/AKT', 4, NULL),
(35642, NULL, 'IPR045372', NULL, 'YidB-like protein', 'YidB', 4, NULL),
(35643, NULL, 'IPR045029', NULL, 'Hydroxymethylpyrimidine kinase/phosphomethylpyrimidine kinase', 'HMP/HMP-P_kinase', 4, NULL),
(35644, NULL, 'IPR044652', NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-like 1.1/1.2/1.3/1.4/1.5', 'LRK10L-1.1/1.2/1.3/1.4/1.5', 4, NULL),
(35645, NULL, 'IPR042109', NULL, 'Adenylosuccinate synthetase, domain 1', 'Adenylosuccinate_synth_dom1', 5, NULL),
(35646, NULL, 'IPR045535', NULL, 'Thoeris protein ThsA, Macro domain', 'ThsA_Macro', 3, NULL),
(35647, NULL, 'IPR043529', NULL, 'Alpha-protein kinase 1', 'ALPK1', 4, NULL),
(35648, NULL, 'IPR043849', NULL, 'Protein of unknown function DUF5859', 'DUF5859', 4, NULL),
(35649, NULL, 'IPR045489', NULL, 'Domain of unknown function DUF6429', 'DUF6429', 3, NULL),
(35650, NULL, 'IPR043573', NULL, 'Polyphosphoinositide phosphatase Fig4-like', 'Fig4-like', 4, NULL),
(35651, NULL, 'IPR043720', NULL, 'Protein of unknown function DUF5661', 'DUF5661', 4, NULL),
(35652, NULL, 'IPR045521', NULL, 'Domain of unknown function DUF6475', 'DUF6475', 3, NULL),
(35653, NULL, 'IPR045396', NULL, 'Protein of unknown function DUF6517', 'DUF6517', 4, NULL),
(35654, NULL, 'IPR045401', NULL, 'GTPase-associated protein 1, middle domain', 'GAP1-M', 3, NULL),
(35655, NULL, 'IPR045398', NULL, 'Protein of unknown function DUF6515', 'DUF6515', 4, NULL),
(35656, NULL, 'IPR043584', NULL, 'Zinc finger protein WIP', 'WIP1/2/3/4/5/6', 4, NULL),
(35657, NULL, 'IPR045024', NULL, 'Alternative NADH dehydrogenase', 'NDH-2', 4, NULL),
(35658, NULL, 'IPR042950', NULL, 'KBTBD4, BACK domain', 'KBTBD4_BACK', 3, NULL),
(35659, NULL, 'IPR045404', NULL, 'Major capsid protein 13-like', 'Gp13-like', 4, NULL),
(35660, NULL, 'IPR043544', NULL, 'Sorting nexin-10/11', 'SNX10/11', 4, NULL),
(35661, NULL, 'IPR043941', NULL, 'EMC6-arch', 'EMC6-arch', 4, NULL),
(35662, NULL, 'IPR045525', NULL, 'Domain of unknown function DUF6472', 'DUF6472', 3, NULL),
(35663, NULL, 'IPR043958', NULL, 'Ta1207 family', 'Ta1207', 4, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(35664, NULL, 'IPR043955', NULL, 'Domain of unknown function DUF5746', 'DUF5746', 3, NULL),
(35665, NULL, 'IPR042941', NULL, 'Kelch domain-containing protein 9', 'KLDC9', 4, NULL),
(35666, NULL, 'IPR045128', NULL, 'Proteasome inhibitor PI31-like', 'PI31-like', 4, NULL),
(35667, NULL, 'IPR045487', NULL, 'YukD-like, N-terminal domain', 'fvmYukD-like_N', 3, NULL),
(35668, NULL, 'IPR042774', NULL, 'UBXN6, PUB domain', 'UBXN6_PUB', 3, NULL),
(35669, NULL, 'IPR043809', NULL, 'Protein of unknown function DUF5791', 'DUF5791', 4, NULL),
(35670, NULL, 'IPR042711', NULL, 'CD80, immunoglobulin variable domain', 'CD80_IgV', 3, NULL),
(35671, NULL, 'IPR045395', NULL, 'ALTTAQ repeat', 'ALTTAQ_rpt', 7, NULL),
(35672, NULL, 'IPR043546', NULL, 'Vesicle-trafficking protein Sec22a/c', 'Sec22a/c', 4, NULL),
(35673, NULL, 'IPR045441', NULL, 'Protein of unknown function DUF6506', 'DUF6506', 4, NULL),
(35674, NULL, 'IPR045030', NULL, 'LysM and putative peptidoglycan-binding domain-containing protein 1-4', 'LYSM1-4', 4, NULL),
(35675, NULL, 'IPR043917', NULL, 'Domain of unknown function DUF5753', 'DUF5753', 3, NULL),
(35676, NULL, 'IPR042599', NULL, 'Vertebrate ubiquitin-conjugating enzyme E2 K, UBA domain', 'UBE2K_UBA', 3, NULL),
(35677, NULL, 'IPR043800', NULL, 'Domain of unknown function DUF5739', 'DUF5739', 3, NULL),
(35678, NULL, 'IPR043718', NULL, 'Domain of unknown function DUF5659', 'DUF5659', 3, NULL),
(35679, NULL, 'IPR044325', NULL, 'Nonstructural protein 15, middle domain, gammacoronavirus', 'NSP15_M_gammaCoV', 3, NULL),
(35680, NULL, 'IPR043838', NULL, 'Adhesion G protein-coupled receptor B, N-terminal domain', 'AGRB_N', 3, NULL),
(35681, NULL, 'IPR042779', NULL, 'MISP/MISP3', 'MISP/MISP3', 4, NULL),
(35682, NULL, 'IPR043096', NULL, 'Poxvirus mRNA capping enzyme, small subunit superfamily', 'Poxvirus_mRNA-cap_ssu_sf', 5, NULL),
(35683, NULL, 'IPR042472', NULL, 'Matrix remodeling-associated protein 8', 'MXRA8', 4, NULL),
(35684, NULL, 'IPR045035', NULL, 'Metal-nicotianamine transporter YSL-like', 'YSL-like', 4, NULL),
(35685, NULL, 'IPR043674', NULL, 'Glucosamine kinase', 'GlcN_kinase', 4, NULL),
(35686, NULL, 'IPR045022', NULL, '3-ketodihydrosphingosine reductase KDSR-like', 'KDSR-like', 4, NULL),
(35687, NULL, 'IPR042699', NULL, 'E3 ubiquitin-protein ligase TRIM58, RING finger, HC subclass', 'TRIM58_RING-HC', 3, NULL),
(35688, NULL, 'IPR045544', NULL, 'Ternary complex associated domain 9', 'TCAD9', 3, NULL),
(35689, NULL, 'IPR043407', NULL, 'Nkap domain containing  1', 'Nkap_D1', 4, NULL),
(35690, NULL, 'IPR045021', NULL, 'Protein PSK SIMULATOR', 'PSI1/2/3', 4, NULL),
(35691, NULL, 'IPR045408', NULL, 'Protein of unknown function DUF5890', 'DUF5890', 4, NULL),
(35692, NULL, 'IPR043801', NULL, 'Domain of unknown function DUF5740', 'DUF5740', 3, NULL),
(35693, NULL, 'IPR045387', NULL, 'Protein of unknown function DUF6524', 'DUF6524', 4, NULL),
(35694, NULL, 'IPR042625', NULL, 'Junctional adhesion molecule B', 'JAM2', 4, NULL),
(35695, NULL, 'IPR042884', NULL, 'Kelch repeat and BTB domain-containing protein 4', 'KBTBD4', 4, NULL),
(35696, NULL, 'IPR045040', NULL, 'PORR family', 'PORR_fam', 4, NULL),
(35697, NULL, 'IPR045418', NULL, 'Domain of unknown function DUF5899', 'DUF5899', 3, NULL),
(35698, NULL, 'IPR045472', NULL, 'Domain of unknown function DUF6493', 'DUF6493', 3, NULL),
(35699, NULL, 'IPR042709', NULL, 'Testis-specific serine/threonine-protein kinase 3, catalytic domain', 'TSSK3_STKc', 3, NULL),
(35700, NULL, 'IPR045436', NULL, 'Protein of unknown function DUF6507', 'DUF6507', 4, NULL),
(35701, NULL, 'IPR045139', NULL, 'Aladin', 'Aladin', 4, NULL),
(35702, NULL, 'IPR044933', NULL, 'Diaphanous, GTPase-binding domain superfamily', 'DIA_GBD_sf', 5, NULL),
(35703, NULL, 'IPR043550', NULL, 'Histone-lysine N-methyltransferase EHMT1/EHMT2', 'EHMT1/EHMT2', 4, NULL),
(35704, NULL, 'IPR043629', NULL, 'Salyut domain', 'Salyut_dom', 3, NULL),
(35705, NULL, 'IPR046799', NULL, 'ROXA-like, winged helix', 'ROXA-like_wH', 3, NULL),
(35706, NULL, 'IPR043810', NULL, 'Protein of unknown function DUF5792', 'DUF5792', 4, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(35707, NULL, 'IPR044926', NULL, 'RGS, subdomain 2', 'RGS_subdomain_2', 5, NULL),
(35708, NULL, 'IPR045106', NULL, 'Protein Kti12', 'Kti12', 4, NULL),
(35709, NULL, 'IPR042655', NULL, 'Leucine-rich repeat-containing protein 72', 'LRC72', 4, NULL),
(35710, NULL, 'IPR044794', NULL, '5''-adenylylsulfate reductase-like 5/7', 'APRL5/7', 4, NULL),
(35711, NULL, 'IPR042710', NULL, 'Testis-specific serine/threonine-protein kinase 6, catalytic domain', 'TSSK6_STKc', 3, NULL),
(35712, NULL, 'IPR042637', NULL, 'Ankyrin repeat domain-containing protein AN34A/B/C', 'AN34A/B/C', 4, NULL),
(35713, NULL, 'IPR043574', NULL, 'Caspase recruitment domain-containing protein 19', 'CARD19', 4, NULL),
(35714, NULL, 'IPR045482', NULL, 'FtsH ternary system domain X2', 'fvmX2', 3, NULL),
(35715, NULL, 'IPR042855', NULL, 'v-SNARE, coiled-coil homology domain', 'V_SNARE_CC', 3, NULL),
(35716, NULL, 'IPR045070', NULL, 'Multidrug and toxic compound extrusion MepA-like', 'MATE_MepA-like', 4, NULL),
(35717, NULL, 'IPR045529', NULL, 'Domain of unknown function DUF6469', 'DUF6469', 3, NULL),
(35718, NULL, 'IPR042582', NULL, 'Semaphorin-3D, Sema domain', 'Sema3D_Sema', 3, NULL),
(35719, NULL, 'IPR043744', NULL, 'Domain of unknown function DUF5689', 'DUF5689', 3, NULL),
(35720, NULL, 'IPR043042', NULL, 'Phospholipase B-like, domain 3', 'PLipase_B-like_dom3', 5, NULL),
(35721, NULL, 'IPR043058', NULL, 'KRIT, N-terminal NPxY motif-rich domain superfamily', 'NUDIX_sf', 5, NULL),
(35722, NULL, 'IPR046441', NULL, 'NSP12 RNA-dependent RNA polymerase, coronavirus', 'CoV_NSP12_RDRP', 3, NULL),
(35723, NULL, 'IPR044550', NULL, 'Lipid III flippase WzxE', 'WzxE', 4, NULL),
(35724, NULL, 'IPR043821', NULL, 'Protein of unknown function DUF5799', 'DUF5799', 4, NULL),
(35725, NULL, 'IPR042947', NULL, 'FHL5, second LIM domain', 'FHL5_LIM2', 3, NULL),
(35726, NULL, 'IPR043048', NULL, 'Birnavirus VP3, domain 1', 'Birna_VP3_dom1', 5, NULL),
(35727, NULL, 'IPR045328', NULL, 'Yeast cell wall synthesis Kre9/Knh1', 'Kre9/Knh1', 4, NULL),
(35728, NULL, 'IPR045067', NULL, 'Wee1-like protein kinase, catalytic domain', 'PKc_Wee1-like', 3, NULL),
(35729, NULL, 'IPR044622', NULL, 'WD repeat-containing protein PCN', 'PCN', 4, NULL),
(35730, NULL, 'IPR044063', NULL, 'Gid-type RING finger domain', 'ZF_RING_GID', 3, NULL),
(35731, NULL, 'IPR045099', NULL, 'PITH domain-containing protein 1-like', 'PITH1-like', 4, NULL),
(35732, NULL, 'IPR045413', NULL, 'Domain of unknown function DUF5894', 'DUF5894', 3, NULL),
(35733, NULL, 'IPR042139', NULL, 'Rho GTPase-activating protein 32, PX domain', 'PX_ARHGAP32', 3, NULL),
(35734, NULL, 'IPR042768', NULL, 'Homeobox protein MNX1/Ceh-12', 'MNX1/Ceh-12', 4, NULL),
(35735, NULL, 'IPR042322', NULL, 'Protein Pbn1', 'Pbn1', 4, NULL),
(35736, NULL, 'IPR043789', NULL, 'Domain of unknown function DUF5731', 'DUF5731', 3, NULL),
(35737, NULL, 'IPR044504', NULL, 'Aldo-keto reductase family 5C2', 'AKR5C2', 4, NULL),
(35738, NULL, 'IPR045405', NULL, 'Peptidase S80 family', 'Peptidase_S80', 4, NULL),
(35739, NULL, 'IPR044650', NULL, 'Tetratricopeptide repeat protein SRFR1-like', 'SRFR1-like', 4, NULL),
(35740, NULL, 'IPR044972', NULL, 'TATA-binding protein-associated factor Mot1', 'Mot1', 4, NULL),
(35741, NULL, 'IPR045453', NULL, 'vWA-MoxR associated protein middle region 8', 'VMAP-M8', 3, NULL),
(35742, NULL, 'IPR042984', NULL, 'Bardet-Biedl syndrome 12 protein', 'BBS12', 4, NULL),
(35743, NULL, 'IPR043794', NULL, 'Domain of unknown function DUF5736', 'DUF5736', 3, NULL),
(35744, NULL, 'IPR045103', NULL, 'E3 ubiquitin-protein ligase RNF5/RNF185-like', 'RNF5/RNF185-like', 4, NULL),
(35745, NULL, 'IPR043827', NULL, 'Protein of unknown function DUF5804', 'DUF5804', 4, NULL),
(35746, NULL, 'IPR042621', NULL, 'Tetratricopeptide repeat protein TTC23/TTC23L', 'TTC23/TTC23L', 4, NULL),
(35747, NULL, 'IPR044360', NULL, 'M matrix/glycoprotein, bat coronavirus HKU9-like', 'M_batCoV_HKU9-like', 4, NULL),
(35748, NULL, 'IPR043831', NULL, 'Domain of unknown function DUF5808', 'DUF5808', 3, NULL),
(35749, NULL, 'IPR046439', NULL, 'Zinc finger, RZ-type', 'ZF_RZ_dom', 3, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(35750, NULL, 'IPR042653', NULL, 'Leukocyte receptor cluster member 9', 'Leng9', 4, NULL),
(35751, NULL, 'IPR042708', NULL, 'HSPA4L, nucleotide-binding domain', 'HSPA4L_NBD', 3, NULL),
(35752, NULL, 'IPR045400', NULL, 'Wolframin, cysteine-rich domain', 'Wolframin_Cys-rich', 3, NULL),
(35753, NULL, 'IPR043596', NULL, 'CFAP53/TCHP', 'CFAP53/TCHP', 4, NULL),
(35754, NULL, 'IPR043549', NULL, 'C2 calcium-dependent domain-containing protein 4C/4D', 'C2C4C/C2C4D', 4, NULL),
(35755, NULL, 'IPR045491', NULL, 'Protein of unknown function DUF6433', 'DUF6433', 4, NULL),
(35756, NULL, 'IPR045353', NULL, 'LAIKA domain', 'LAIKA', 3, NULL),
(35757, NULL, 'IPR044058', NULL, 'Uncharacterised lipoprotein', 'Lipoprotein_23', 4, NULL),
(35758, NULL, 'IPR043126', NULL, 'Esp1, core domain', 'Esp1_core', 5, NULL),
(35759, NULL, 'IPR045121', NULL, 'Coenzyme A pyrophosphatase', 'CoAse', 4, NULL),
(35760, NULL, 'IPR043730', NULL, 'Domain of unknown function DUF5673', 'DUF5673', 3, NULL),
(35761, NULL, 'IPR042579', NULL, 'XIAP/BIRC8, UBA domain', 'XIAP/BIRC8_UBA', 3, NULL),
(35762, NULL, 'IPR042961', NULL, 'Spermatogenic leucine zipper protein 1', 'Spz1', 4, NULL),
(35763, NULL, 'IPR045393', NULL, 'Protein of unknown function DUF6518', 'DUF6518', 4, NULL),
(35764, NULL, 'IPR042448', NULL, 'E3 ubiquitin-protein ligase CCNB1IP1', 'CCNB1IP1', 4, NULL),
(35765, NULL, 'IPR045097', NULL, 'Thymidylate synthase/dCMP hydroxymethylase', 'Thymidate_synth/dCMP_Mease', 4, NULL),
(35766, NULL, 'IPR045410', NULL, 'Zinc finger domain-containing protein', 'Zn_finger_prot', 4, NULL),
(35767, NULL, 'IPR044062', NULL, 'LCN-type cysteine-stabilized alpha/beta (CS-alpha/beta) domain', 'LCN-type_CS_alpha_beta_dom', 3, NULL),
(35768, NULL, 'IPR042620', NULL, 'Putative methyltransferase NSUN7', 'NSUN7', 4, NULL),
(35769, NULL, 'IPR045038', NULL, 'Protein AIG2-like', 'AIG2-like', 4, NULL),
(35770, NULL, 'IPR046757', NULL, 'Vps72/YL1, N-terminal', 'YL1_N', 3, NULL),
(35771, NULL, 'IPR043746', NULL, 'Family of unknown function DUF5691', 'DUF5691', 4, NULL),
(35772, NULL, 'IPR045369', NULL, 'Protein of unknown function DUF5887', 'DUF5887', 4, NULL),
(35773, NULL, 'IPR045431', NULL, 'Effector-associated domain 2', 'EAD2', 3, NULL),
(35774, NULL, 'IPR043731', NULL, 'Protein of unknown function DUF5674', 'DUF5674', 4, NULL),
(35775, NULL, 'IPR042701', NULL, 'B0AT3, solute-binding domain', 'B0AT3_SLC6sbd', 3, NULL),
(35776, NULL, 'IPR044089', NULL, 'Magnesium transporter Alr1-like', 'Alr1-like', 4, NULL),
(35777, NULL, 'IPR043815', NULL, 'Protein of unknown function DUF5797', 'DUF5797', 4, NULL),
(35778, NULL, 'IPR042516', NULL, 'Pre-mRNA-processing-splicing factor 8, U5-snRNA-binding domain superfamily', 'Prp8_U5-snRNA-bd_sf', 5, NULL),
(35779, NULL, 'IPR045154', NULL, 'Protein PCF11-like', 'PCF11-like', 4, NULL),
(35780, NULL, 'IPR045532', NULL, 'Protein of unknown function DUF6467', 'DUF6467', 4, NULL),
(35781, NULL, 'IPR045403', NULL, 'Helix-turn-helix domain, Firmicutes-type', 'HTH_59_Firmicutes_type', 3, NULL),
(35782, NULL, 'IPR043832', NULL, 'Protein of unknown function DUF5809', 'DUF5809', 4, NULL),
(35783, NULL, 'IPR042697', NULL, 'Nuclear receptor-binding protein 2, pseudokinase domain', 'NRBP2_PK', 3, NULL),
(35784, NULL, 'IPR045530', NULL, 'Double-GTPase 1', 'DO-GTPase1', 3, NULL),
(35785, NULL, 'IPR044032', NULL, 'TssC1, C-terminal', 'TssC1_C', 3, NULL),
(35786, NULL, 'IPR043743', NULL, 'Family of unknown function DUF5688', 'DUF5688', 4, NULL),
(35787, NULL, 'IPR043049', NULL, 'Birnavirus VP3, domain 2', 'Birna_VP3_dom2', 5, NULL),
(35788, NULL, 'IPR044019', NULL, 'Cyanophycin synthase-like, N-terminal', 'Cyanophycin_syn_N', 3, NULL),
(35789, NULL, 'IPR044057', NULL, 'SnTox1, chitin binding-like domain', 'SnTox1_CBL', 3, NULL),
(35790, NULL, 'IPR044845', NULL, 'Glycosyltransferase HPAT/SRGT1-like', 'HPAT/SRGT1-like', 4, NULL),
(35791, NULL, 'IPR043641', NULL, 'PPE-PPW subfamily, C-terminal', 'PPE-PPW_C', 3, NULL),
(35792, NULL, 'IPR045059', NULL, '60S ribosomal protein L35', 'RL35', 4, NULL),
(35793, NULL, 'IPR042583', NULL, 'MARCH10, RING-CH finger, C4HC3-type', 'MARCH10_RING_CH-C4HC3', 3, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(35794, NULL, 'IPR043655', NULL, 'Domain of unknown function DUF5878', 'DUF5878', 3, NULL),
(35795, NULL, 'IPR044046', NULL, 'E3 ubiquitin-protein ligase UBR-like, C-terminal', 'E3_ligase_UBR-like_C', 3, NULL),
(35796, NULL, 'IPR045033', NULL, 'Protein PIN-LIKES 1/3/4/5/7', 'PILS1/3/4/5/7', 4, NULL),
(35797, NULL, 'IPR043594', NULL, 'HMG-CoA lyase', 'HMGL', 4, NULL),
(35798, NULL, 'IPR042703', NULL, 'Serine/threonine-protein kinase PLK3, catalytic domain', 'PLK3_STKc', 3, NULL),
(35799, NULL, 'IPR044672', NULL, 'Molybdopterin synthase sulfur carrier subunit', 'MOCS2A', 4, NULL),
(35800, NULL, 'IPR043823', NULL, 'Protein of unknown function DUF5800', 'DUF5800', 4, NULL),
(35801, NULL, 'IPR043768', NULL, 'Domain of unknown function DUF5714', 'DUF5714', 3, NULL),
(35802, NULL, 'IPR044681', NULL, 'Calmodulin binding protein PICBP-like', 'PICBP-like', 4, NULL),
(35803, NULL, 'IPR045469', NULL, 'Nis1-like', 'Nis1', 4, NULL),
(35804, NULL, 'IPR045032', NULL, 'Pectin lyase family', 'PEL', 4, NULL),
(35805, NULL, 'IPR045384', NULL, 'Protein of unknown function DUF6527', 'DUF6527', 4, NULL),
(35806, NULL, 'IPR043812', NULL, 'Protein of unknown function DUF5794', 'DUF5794', 4, NULL),
(35807, NULL, 'IPR044501', NULL, 'Dehydrogenase, bacteria', 'BaDH-like', 4, NULL),
(35808, NULL, 'IPR043910', NULL, 'Protein of unknown function DUF5767', 'DUF5767', 4, NULL),
(35809, NULL, 'IPR042624', NULL, 'GRAM domain-containing protein 2A', 'RAMD2A', 4, NULL),
(35810, NULL, 'IPR045023', NULL, 'Acyl-[acyl-carrier-protein] hydrolase FATA/B', 'FATA/B', 4, NULL),
(35811, NULL, 'IPR045485', NULL, 'FtsH ternary system domain X6', 'fvmX6', 3, NULL),
(35812, NULL, 'IPR043811', NULL, 'Protein of unknown function DUF5793', 'DUF5793', 4, NULL),
(35813, NULL, 'IPR045267', NULL, 'Cyclin-dependent kinase 11/PITSLRE, catalytic domain', 'CDK11/PITSLRE_STKc', 3, NULL),
(35814, NULL, 'IPR044988', NULL, 'ATP synthase, F0 complex, subunit MI25, plants', 'MI25_plants', 4, NULL),
(35815, NULL, 'IPR045028', NULL, 'Helicase superfamily 1/2, DinG/Rad3-like', 'DinG/Rad3-like', 4, NULL),
(35816, NULL, 'IPR043608', NULL, 'Nonstructural protein 15, middle domain, coronavirus', 'CoV_NSP15_M', 3, NULL),
(35817, NULL, 'IPR045470', NULL, 'Protein of unknown function DUF6495', 'DUF6495', 4, NULL),
(35818, NULL, 'IPR045455', NULL, 'Domain of unknown function DUF5906', 'DUF5906', 3, NULL),
(35819, NULL, 'IPR045027', NULL, 'Homer family', 'Homer', 4, NULL),
(35820, NULL, 'IPR042111', NULL, 'Adenylosuccinate synthetase, domain 3', 'Adenylosuccinate_synth_dom3', 5, NULL),
(35821, NULL, 'IPR043782', NULL, 'Domain of unknown function DUF5724', 'DUF5724', 3, NULL),
(35822, NULL, 'IPR043522', NULL, 'DNA damage-induced apoptosis suppressor protein', 'DDIAS', 4, NULL),
(35823, NULL, 'IPR045536', NULL, 'Domain of unknown function DUF6431', 'DUF6431', 3, NULL),
(35824, NULL, 'IPR045260', NULL, 'Guanine nucleotide-exchange factor Sec12-like', 'Sec12-like', 4, NULL),
(35825, NULL, 'IPR046445', NULL, '3a-like viroporin, transmembrane domain, alpha/betacoronavirus', 'a/bCoV_VIROPORIN_3A-like_TM', 3, NULL),
(35826, NULL, 'IPR045238', NULL, 'Tim23-like', 'Tim23-like', 4, NULL),
(35827, NULL, 'IPR042857', NULL, 'Transmembrane protein 266', 'TMEM266', 4, NULL),
(35828, NULL, 'IPR044055', NULL, 'Long Rib domain', 'RibLong', 3, NULL),
(35829, NULL, 'IPR043660', NULL, 'Domain of unknown function DUF5873', 'DUF5873', 3, NULL),
(35830, NULL, 'IPR042581', NULL, 'VAMP5, SNARE motif', 'VAMP5_R-SNARE_', 3, NULL),
(35831, NULL, 'IPR042651', NULL, 'Regulator of G-protein signaling 22', 'Rgs22', 4, NULL),
(35832, NULL, 'IPR043543', NULL, 'Pappalysin-1/2', 'PAPPA/PAPPA2', 4, NULL),
(35833, NULL, 'IPR043733', NULL, 'Family of unknown function DUF5677', 'DUF5677', 4, NULL),
(35834, NULL, 'IPR045496', NULL, 'Domain of unknown function DUF64370', 'DUF6437', 3, NULL),
(35835, NULL, 'IPR043038', NULL, 'Antitoxin VbhA domain superfamily', 'VbhA_sf', 5, NULL),
(35836, NULL, 'IPR045286', NULL, 'F-box protein FBS1-like', 'FBS1-like', 4, NULL),
(35837, NULL, 'IPR043989', NULL, 'CCZ1/INTU/HPS4, third Longin domain', 'CCZ1/INTU/HSP4_longin_3', 3, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(35838, NULL, 'IPR043845', NULL, 'Protein of unknown function DUF5864', 'DUF5864', 4, NULL),
(35839, NULL, 'IPR045539', NULL, 'Tail virion protein G7P', 'Inovirus_G7P_2', 4, NULL),
(35840, NULL, 'IPR046809', NULL, 'Lipoprotein YfjS/YafY domain', 'YfjS_YafY_dom', 3, NULL),
(35841, NULL, 'IPR044658', NULL, 'Transcription factor bHLH92/bHLH041-like', 'bHLH92/bHLH041-like', 4, NULL),
(35842, NULL, 'IPR043757', NULL, 'Domain of unknown function DUF5703', 'DUF5703_N', 3, NULL),
(35843, NULL, 'IPR042650', NULL, 'ASZ1, SAM domain', 'Asz1_SAM', 3, NULL),
(35844, NULL, 'IPR043534', NULL, 'Exo-beta-D-glucosaminidase/Endo-beta-mannosidase', 'EBDG/EBM', 4, NULL),
(35845, NULL, 'IPR046865', NULL, 'Flagellar Assembly Protein A, beta solenoid domain', 'FapA_b_solenoid', 7, NULL),
(35846, NULL, 'IPR043724', NULL, 'Domain of unknown function DUF5666', 'DUF5666', 3, NULL),
(35847, NULL, 'IPR045100', NULL, 'TUTase nucleotidyltransferase domain', 'TUTase_dom', 3, NULL),
(35848, NULL, 'IPR042805', NULL, 'Proline-rich protein 3', 'PRR3', 4, NULL),
(35849, NULL, 'IPR045026', NULL, 'L10-interacting MYB domain-containing protein', 'LIMYB', 4, NULL),
(35850, NULL, 'IPR042112', NULL, 'Phosphate acetyltransferase, domain 2', 'P_AcTrfase_dom2', 5, NULL),
(35851, NULL, 'IPR044034', NULL, 'Nascent polypeptide-associated complex subunit alpha-like, UBA domain', 'NAC-like_UBA', 3, NULL),
(35852, NULL, 'IPR045461', NULL, 'Wolframin, OB-fold domain', 'Wolframin_OB_fold', 3, NULL),
(35853, NULL, 'IPR042619', NULL, 'Bardet-Biedl syndrome 10 protein', 'BBS10', 4, NULL),
(35854, NULL, 'IPR045287', NULL, 'Protein IN CHLOROPLAST ATPASE BIOGENESIS', 'PAB', 4, NULL),
(35855, NULL, 'IPR044656', NULL, 'Heat shock protein HSP14.7/HSP23.5/HSP23.6-like', 'HSP14.7/HSP23.5/HSP23.6-like', 4, NULL),
(35856, NULL, 'IPR046800', NULL, 'Plexin, cytoplasmic RhoGTPase-binding domain', 'Plexin_RBD', 3, NULL),
(35857, NULL, 'IPR044084', NULL, 'AvModA-like, substrate binding domain', 'AvModA-like_subst-bd', 3, NULL),
(35858, NULL, 'IPR043717', NULL, 'Domain of unknown function DUF5658', 'DUF5658', 3, NULL),
(35859, NULL, 'IPR043754', NULL, 'Putative zinc dependent peptidase DUF5700', 'DUF5700', 4, NULL),
(35860, NULL, 'IPR043636', NULL, 'L1 transposable element, RRM domain', 'L1_RRM_dom', 3, NULL),
(35861, NULL, 'IPR044041', NULL, 'Domain of unknown function DUF5743', 'DUF5743', 3, NULL),
(35862, NULL, 'IPR045432', NULL, 'Effector-associated domain 5', 'EAD5', 3, NULL),
(35863, NULL, 'IPR043047', NULL, 'Hri1, N-terminal domain superfamily', 'Hri1_N_sf', 5, NULL),
(35864, NULL, 'IPR045042', NULL, 'Mechanosensitive ion channel protein YnaI-like', 'YnaI-like', 4, NULL),
(35865, NULL, 'IPR045483', NULL, 'FtsH ternary system domain X3-analog', 'fvmX3-analog', 3, NULL),
(35866, NULL, 'IPR042777', NULL, 'tRNA-splicing endonuclease subunit Sen15, fungi', 'Sen15_fungi', 4, NULL),
(35867, NULL, 'IPR043043', NULL, 'DNA packaging protein FI, C-terminal beta-strand domain', 'Packaging_FI_C', 5, NULL),
(35868, NULL, 'IPR045419', NULL, 'Domain of unknown function DUF5900', 'DUF5900', 3, NULL),
(35869, NULL, 'IPR043605', NULL, 'DUF883, C-terminal domain', 'DUF883_C', 3, NULL),
(35870, NULL, 'IPR045388', NULL, 'Protein HHL1-like', 'HHL1-like', 4, NULL),
(35871, NULL, 'IPR045433', NULL, 'Effector-associated domain 6', 'EAD6', 3, NULL),
(35872, NULL, 'IPR043816', NULL, 'Protein of unknown function DUF5798', 'DUF5798', 4, NULL),
(35873, NULL, 'IPR045542', NULL, 'Ternary complex associated domain 3', 'TCAD3', 3, NULL),
(35874, NULL, 'IPR042518', NULL, 'Precorrin-2 dehydrogenase, C-terminal helical domain', 'SirC_C', 5, NULL),
(35875, NULL, 'IPR043775', NULL, 'Domain  of unknown function DUF5717, N-terminal', 'DUF5717_N', 3, NULL),
(35876, NULL, 'IPR042945', NULL, 'LBH domain containing protein', 'LBH_dom_prot', 4, NULL),
(35877, NULL, 'IPR044862', NULL, 'Prolyl 4-hydroxylase alpha subunit, Fe(2+) 2OG dioxygenase domain', 'Pro_4_hyd_alph_FE2OG_OXY', 3, NULL),
(35878, NULL, 'IPR043060', NULL, 'Filoviruses VP35 interferon inhibitory domain, helical subdomain', 'VP35_IID_hlx', 5, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(35879, NULL, 'IPR042468', NULL, 'Peptidase C65, otubain, subdomain 1', 'Peptidase_C65_otubain_sub1', 5, NULL),
(35880, NULL, 'IPR045442', NULL, 'Protein of unknown function DUF6505', 'DUF6505', 4, NULL),
(35881, NULL, 'IPR043723', NULL, 'Domain of unknown function DUF5665', 'DUF5665', 4, NULL),
(35882, NULL, 'IPR044039', NULL, 'Domain of unknown function DUF5745', 'DUF5745', 3, NULL),
(35883, NULL, 'IPR044984', NULL, 'SEED MATURATION PROTEIN 1', 'SMP1', 4, NULL),
(35884, NULL, 'IPR045531', NULL, 'Domain of unknown function DUF6468', 'DUF6468', 3, NULL),
(35885, NULL, 'IPR043560', NULL, 'Zinc finger CCCH-type with G patch domain-containing protein', 'ZGPAT', 4, NULL),
(35886, NULL, 'IPR045415', NULL, 'Protein of unknown function DUF5896', 'DUF5896', 4, NULL),
(35887, NULL, 'IPR045406', NULL, 'Domain of unknown function DUF6513', 'DUF6513', 3, NULL),
(35888, NULL, 'IPR043470', NULL, 'Tight junction-associated protein 1 domain', 'Tjap1_dom', 3, NULL),
(35889, NULL, 'IPR045490', NULL, 'Protein of unknown function DUF6432', 'DUF6432', 4, NULL),
(35890, NULL, 'IPR043848', NULL, 'Domain of unknown function DUF5860', 'DUF5860', 3, NULL),
(35891, NULL, 'IPR045390', NULL, 'ABC-three component system, Middle Component 3', 'ABC-3C_MC3', 4, NULL),
(35892, NULL, 'IPR043987', NULL, 'CCZ1/INTU/HSP4, first Longin domain', 'CCZ1/INTU/HSP4_longin_1', 3, NULL),
(35893, NULL, 'IPR045325', NULL, 'TMEM70/TMEM186/TMEM223 protein family', 'TMEM70/TMEM186/TMEM223', 4, NULL),
(35894, NULL, 'IPR042946', NULL, 'Carboxymethylenebutenolidase homolog', 'CMBL', 4, NULL),
(35895, NULL, 'IPR044050', NULL, 'Protein of unknown function (DUF5837)', 'DUF5837', 4, NULL),
(35896, NULL, 'IPR045454', NULL, 'vWA-MoxR associated protein middle region 9', 'VMAP-M9', 3, NULL),
(35897, NULL, 'IPR045481', NULL, 'FtsH ternary system domain X3', 'fvmX3', 3, NULL),
(35898, NULL, 'IPR042455', NULL, 'Dedicator of cytokinesis, N-terminal, subdomain 1', 'DOCK_N_sub1', 5, NULL),
(35899, NULL, 'IPR045391', NULL, 'Protein of unknown function DUF6520', 'DUF6520', 4, NULL),
(35900, NULL, 'IPR042698', NULL, 'Interleukin-1 receptor-associated kinase 3, pseudokinase domain', 'IRAK3_PK', 3, NULL),
(35901, NULL, 'IPR045098', NULL, 'Fyv10 family', 'Fyv10_fam', 4, NULL),
(35902, NULL, 'IPR044054', NULL, 'Rv0078B-like antitoxin', 'Rv0078B', 4, NULL),
(35903, NULL, 'IPR042666', NULL, 'Serine/threonine-protein kinase Nek10, catalytic domain', 'Nek10_STKc', 3, NULL),
(35904, NULL, 'IPR045262', NULL, 'Sugar transport protein STP/Polyol transporter PLT, plant', 'STP/PLT_plant', 4, NULL),
(35905, NULL, 'IPR044005', NULL, 'Double zinc ribbon domain', 'DZR_2', 3, NULL),
(35906, NULL, 'IPR045000', NULL, 'Tropinone reductase', 'TR', 4, NULL),
(35907, NULL, 'IPR044106', NULL, 'Snx41 /Atg20, PX domain', 'PX_Snx41/Atg20', 3, NULL),
(35908, NULL, 'IPR045278', NULL, 'Intron splicing facilitator CRS1/CFM2/CFM3', 'CRS1/CFM2/CFM3', 4, NULL),
(35909, NULL, 'IPR045414', NULL, 'Domain of unknown function DUF5895', 'DUF5895', 3, NULL),
(35910, NULL, 'IPR044970', NULL, 'COFACTOR ASSEMBLY OF COMPLEX C SUBUNIT B CCB2, chloroplastic', 'CCB2', 4, NULL),
(35911, NULL, 'IPR043793', NULL, 'Domain of unknown function DUF5735', 'DUF5735', 3, NULL),
(35912, NULL, 'IPR043611', NULL, 'Coronavirus replicase NSP3, C-terminal', 'CoV_NSP3_C', 3, NULL),
(35913, NULL, 'IPR042652', NULL, 'CDK2-associated and cullin domain-containing protein 1', 'CACUL1', 4, NULL),
(35914, NULL, 'IPR044276', NULL, 'Coiled-coil SMC6 And NSE5 INteracting (CANIN) domain', 'CANIN_dom', 3, NULL),
(35915, NULL, 'IPR043722', NULL, 'Protein of unknown function DUF5663', 'DUF5663', 4, NULL),
(35916, NULL, 'IPR045366', NULL, 'Protein of unknown function DUF5905', 'DUF5905', 4, NULL),
(35917, NULL, 'IPR042713', NULL, 'TIF1-beta, RING finger, HC subclass', 'TIF1beta_RING-HC', 3, NULL),
(35918, NULL, 'IPR044983', NULL, 'Photosynthetic NDH subunit of subcomplex B 1, chloroplastic', 'PNSB1', 4, NULL),
(35919, NULL, 'IPR044982', NULL, 'O-FUCOSYLTRANSFERASE1-like', 'AtOFT1-like', 4, NULL),
(35920, NULL, 'IPR045363', NULL, 'Ceramide kinase, C-terminal domain', 'CERK_C', 3, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(35921, NULL, 'IPR045424', NULL, 'Protein of unknown function DUF6509', 'DUF6509', 4, NULL),
(35922, NULL, 'IPR043918', NULL, 'Protein of unknown function DUF5760', 'DUF5760', 4, NULL),
(35923, NULL, 'IPR044860', NULL, 'Methuselah ectodomain, domain 1', 'Methusela_ecto_dom_1', 5, NULL),
(35924, NULL, 'IPR043993', NULL, 'Type IV secretion system pilin', 'T4SS_pilin', 4, NULL),
(35925, NULL, 'IPR045020', NULL, '1-Cys peroxiredoxin', 'PRX_1cys', 4, NULL),
(35926, NULL, 'IPR042934', NULL, 'B(0)AT2, solute-binding domain', 'B(0)AT2', 3, NULL),
(35927, NULL, 'IPR042633', NULL, 'Quinone oxidoreductase-like protein 1', 'CRYZL1', 4, NULL),
(35928, NULL, 'IPR044070', NULL, 'Rubella virus (RUBV) nonstructural (NS) protease domain', 'RUBV_NS_PRO', 3, NULL),
(35929, NULL, 'IPR045397', NULL, 'Protein of unknown function DUF6516', 'DUF6516', 4, NULL),
(35930, NULL, 'IPR044033', NULL, 'GpV, apex motif', 'GpV_apex', 2, NULL),
(35931, NULL, 'IPR045440', NULL, 'vWA-MoxR associated protein middle region 1', 'VMAP-M1', 3, NULL),
(35932, NULL, 'IPR043977', NULL, 'Protein of unknown function DUF5759', 'DUF5759', 4, NULL),
(35933, NULL, 'IPR045241', NULL, 'WD repeat Prp46/PLRG1-like', 'Prp46/PLRG1-like', 4, NULL),
(35934, NULL, 'IPR045473', NULL, 'Sphingomyelin phosphodiesterase, C-terminal domain', 'ASM_C', 3, NULL),
(35935, NULL, 'IPR045417', NULL, 'Domain of unknown function DUF5898', 'DUF5898', 3, NULL),
(35936, NULL, 'IPR043940', NULL, 'Protein of unknown function DUF5781', 'DUF5781', 4, NULL),
(35937, NULL, 'IPR043044', NULL, 'TPA1/Ofd1, C-terminal', 'TPA1/Ofd1_C', 5, NULL),
(35938, NULL, 'IPR044383', NULL, 'Non-structural protein 2, IBV-like', 'NSP2_IBV-like', 3, NULL),
(35939, NULL, 'IPR045528', NULL, 'Double-GTPase 2', 'DO-GTPase2', 3, NULL),
(35940, NULL, 'IPR044985', NULL, 'Large ribosomal RNA subunit accumulation protein YceD homologue 2, chloroplastic', 'YceD_plant', 4, NULL),
(35941, NULL, 'IPR045488', NULL, 'FtsH ternary system-associated peptide', 'fvmRadSAM-pep', 4, NULL),
(35942, NULL, 'IPR042885', NULL, 'Heavy metal-associated isoprenylated plant protein 47', 'HIP47', 4, NULL),
(35943, NULL, 'IPR045004', NULL, 'Enoyl-CoA hydratase/isomerase domain', 'ECH_dom', 3, NULL),
(35944, NULL, 'IPR045527', NULL, 'Protein of unknown function DUF6470', 'DUF6470', 4, NULL),
(35945, NULL, 'IPR045148', NULL, 'Transcription elongation regulator 1-like', 'TCRG1-like', 4, NULL),
(35946, NULL, 'IPR045386', NULL, 'Protein of unknown function DUF6525', 'DUF6525', 4, NULL),
(35947, NULL, 'IPR043715', NULL, 'Protein of unknown function DUF5656', 'DUF5656', 4, NULL),
(35948, NULL, 'IPR045457', NULL, 'vWA-MoxR associated protein middle region 19', 'VMAP-M19', 3, NULL),
(35949, NULL, 'IPR045370', NULL, 'Protein of unknown function DUF5888', 'DUF5888', 4, NULL),
(35950, NULL, 'IPR042515', NULL, 'Non-structural protein NSP15,  N-terminal domain superfamily, coronavirus', 'NSP15_N_CoV', 5, NULL),
(35951, NULL, 'IPR045466', NULL, 'Protein of unknown function DUF6498', 'DUF6498', 4, NULL),
(35952, NULL, 'IPR043830', NULL, 'Protein of unknown function DUF5807', 'DUF5807', 4, NULL),
(35953, NULL, 'IPR045116', NULL, 'Polyribonucleotide 5-hydroxyl-kinase Clp1/Grc3', 'Clp1/Grc3', 4, NULL),
(35954, NULL, 'IPR043807', NULL, 'Domain of unknown function DUF5869', 'DUF5869', 3, NULL),
(35955, NULL, 'IPR042870', NULL, 'DAPK3, catalytic domain', 'DAPK3_STKc', 3, NULL),
(35956, NULL, 'IPR045474', NULL, 'GEVED domain', 'GEVED', 3, NULL),
(35957, NULL, 'IPR043747', NULL, 'Protein of unknown function DUF5692', 'DUF5692', 4, NULL),
(35958, NULL, 'IPR043792', NULL, 'Domain of unknown function (DUF5734)', 'DUF5734', 3, NULL),
(35959, NULL, 'IPR043384', NULL, 'Reticulophagy receptor 1/3', 'RETREG1/3', 4, NULL),
(35960, NULL, 'IPR045280', NULL, 'GATA transcription factor TIFY-like', 'TIFY-like', 4, NULL),
(35961, NULL, 'IPR043041', NULL, 'Phospholipase B-like, domain 2', 'PLipase_B-like_dom2', 5, NULL),
(35962, NULL, 'IPR045428', NULL, 'Effector Associated Constant Component 1', 'EACC1', 4, NULL),
(35963, NULL, 'IPR044981', NULL, 'Lysine-rich arabinogalactan protein AGP9/17/18', 'AGP9/17/18', 4, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(35964, NULL, 'IPR043931', NULL, 'Protein of unknown function DUF5779', 'DUF5779', 4, NULL),
(35965, NULL, 'IPR043814', NULL, 'Protein of unknown function DUF5796', 'DUF5796', 4, NULL),
(35966, NULL, 'IPR043767', NULL, 'Protein of unknown function DUF5713', 'DUF5713', 4, NULL),
(35967, NULL, 'IPR043808', NULL, 'Protein of unknown function DUF5790', 'DUF5790', 4, NULL),
(35968, NULL, 'IPR043979', NULL, 'Domain of unknown function DUF5741', 'DUF5741', 3, NULL),
(35969, NULL, 'IPR043837', NULL, 'Mtf2-like, C-terminal domain', 'Mtf2-like_C', 3, NULL),
(35970, NULL, 'IPR044784', NULL, 'BTB/POZ domain containing protein At1g01640-like', 'At1g01640-like', 4, NULL),
(35971, NULL, 'IPR042868', NULL, 'Phytanoyl-CoA hydroxylase-interacting protein-like', 'PHYHIP/PHYHIPL', 4, NULL),
(35972, NULL, 'IPR043930', NULL, 'Protein of unknown function DUF5754', 'DUF5754', 4, NULL),
(35973, NULL, 'IPR045158', NULL, 'K(+) efflux antiporter 4/5/6-like', 'KEA4/5/6-like', 4, NULL),
(35974, NULL, 'IPR044128', NULL, 'Initiation factor eIF2 gamma, GTP-binding domain', 'eIF2g_GTP-bd', 3, NULL),
(35975, NULL, 'IPR043056', NULL, 'LuxQ periplasmic domain, N-terminal subdomain', 'LuxQ-periplasm_N', 5, NULL),
(35976, NULL, 'IPR046934', NULL, 'PP2CA INTERACTING RING FINGER PROTEIN 2-like', 'PIR2-like', 4, NULL),
(35977, NULL, 'IPR042808', NULL, 'C-type lectin domain family 7 member A', 'CLEC7A', 4, NULL),
(35978, NULL, 'IPR045374', NULL, 'Cas5fv helical domain', 'Cas5fv_helical', 3, NULL),
(35979, NULL, 'IPR043976', NULL, 'Golgin subfamily A, conserved domain', 'GOLGA_cons_dom', 3, NULL),
(35980, NULL, 'IPR045084', NULL, 'Transcription factor AIB/MYC-like', 'AIB/MYC-like', 4, NULL),
(35981, NULL, 'IPR045524', NULL, 'Domain of unknown function DUF6473', 'DUF6473', 3, NULL),
(35982, NULL, 'IPR045451', NULL, 'vWA-MoxR associated protein middle region 5', 'VMAP-M5', 3, NULL),
(35983, NULL, 'IPR043829', NULL, 'Protein of unknown function DUF5806', 'DUF5806', 4, NULL),
(35984, NULL, 'IPR042869', NULL, 'Rho GTPase-activating protein 11', 'ARHGAP11A/B', 4, NULL),
(35985, NULL, 'IPR045017', NULL, 'Peroxisomal 2,4-dienoyl-CoA reductase [(3E)-enoyl-CoA-producing]', 'DECR2-like', 4, NULL),
(35986, NULL, 'IPR042733', NULL, 'WDFY1, FYVE domain', 'WDFY1_FYVE', 3, NULL),
(35987, NULL, 'IPR045430', NULL, 'Effector-associated domain 1', 'EAD1', 3, NULL),
(35988, NULL, 'IPR045034', NULL, 'O-acyltransferase WSD1-like', 'O-acyltransferase_WSD1-like', 4, NULL),
(35989, NULL, 'IPR042866', NULL, 'Sushi domain-containing protein 6', 'SUSD6', 4, NULL),
(35990, NULL, 'IPR045493', NULL, 'Protein of unknown function DUF6435', 'DUF6435', 4, NULL),
(35991, NULL, 'IPR043637', NULL, 'Spo16 protein', 'Spo16', 4, NULL),
(35992, NULL, 'IPR042656', NULL, 'E3 ubiquitin-protein ligase TRIM68, RING finger, HC subclass', 'TRIM68_RING-HC', 3, NULL),
(35993, NULL, 'IPR044097', NULL, 'Alkyl/aryl-sulfatase Bds1/ SdsA1  , MBL-fold', 'Bds1/SdsA1_MBL-fold', 3, NULL),
(35994, NULL, 'IPR043822', NULL, 'EsV-1-7 cysteine-rich motif', 'EsV_1_7_cys', 7, NULL),
(35995, NULL, 'IPR045407', NULL, 'Protein of unknown function DUF6512', 'DUF6512', 4, NULL),
(35996, NULL, 'IPR044795', NULL, 'Pentatricopeptide repeat-containing protein THA8L-like', 'THA8L-like', 4, NULL),
(35997, NULL, 'IPR043045', NULL, 'PvsD/AcsD-like, palm domain, helix bundle', 'PvsD/AcsD-like_palm_helix', 5, NULL),
(35998, NULL, 'IPR044085', NULL, 'D-galactose-binding periplasmic protein MglB-like, PBP domain', 'MglB-like_PBP1', 3, NULL),
(35999, NULL, 'IPR043776', NULL, 'Protein  of unknown function DUF5718', 'DUF5718', 4, NULL),
(36000, NULL, 'IPR043960', NULL, 'Protein of unknown function DUF5748', 'DUF5748', 4, NULL),
(36001, NULL, 'IPR045681', NULL, 'Protein of unknown function DUF6201', 'DUF6201', 4, NULL),
(36002, NULL, 'IPR044663', NULL, 'MACPF domain-containing protein CAD1/NSL1-like', 'CAD1/NSL1-like', 4, NULL),
(36003, NULL, 'IPR045641', NULL, 'Type 2A encapsulin shell protein SrpI-like', 'SrpI-like', 3, NULL),
(36004, NULL, 'IPR045215', NULL, 'Pentatricopeptide repeat-containing protein, plant', 'PPR_prot_plant', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(36005, NULL, 'IPR045708', NULL, 'Protein of unknown function DUF6064', 'DUF6064', 4, NULL),
(36006, NULL, 'IPR045703', NULL, 'POU domain, class 2, transcription factor 1, C-terminal', 'POU2F1_C', 3, NULL),
(36007, NULL, 'IPR042219', NULL, 'Dynein heavy chain AAA lid domain superfamily', 'AAA_lid_11_sf', 5, NULL),
(36008, NULL, 'IPR045662', NULL, 'Protein of unknown function DUF6388', 'DUF6388', 4, NULL),
(36009, NULL, 'IPR045846', NULL, 'DNA polymerase alpha catalytic subunit, catalytic domain', 'POLBc_alpha', 3, NULL),
(36010, NULL, 'IPR045849', NULL, 'Inositol polyphosphate 5-phosphatase, plant', 'IP5P_plant', 4, NULL),
(36011, NULL, 'IPR042222', NULL, 'Dynein heavy chain, domain 2, N-terminal', 'Dynein_2_N', 5, NULL),
(36012, NULL, 'IPR045580', NULL, 'PIK3 catalytic subunit gamma, adaptor-binding domain', 'PIK3CG_ABD', 3, NULL),
(36013, NULL, 'IPR044633', NULL, 'Cleavage stimulation factor subunit 1-like', 'CstF1-like', 4, NULL),
(36014, NULL, 'IPR044869', NULL, 'HNF-1, POU-specific (POUs) atypical domain', 'HNF-1_POU', 3, NULL),
(36015, NULL, 'IPR042230', NULL, 'Copper binding periplasmic protein CusF superfamily', 'CusF_sf', 5, NULL),
(36016, NULL, 'IPR044405', NULL, 'PRDM11, PR/SET domain', 'PRDM11_PR/SET', 3, NULL),
(36017, NULL, 'IPR043065', NULL, 'Carboxysome shell carbonic anhydrase, N-terminal', 'Carboxysome_shell_carb_anhy_N', 5, NULL),
(36018, NULL, 'IPR045692', NULL, 'Protein of unknown function DUF6057', 'DUF6057', 4, NULL),
(36019, NULL, 'IPR044272', NULL, 'GATA transcription factor 18/19/20', 'GATA18/19/20', 4, NULL),
(36020, NULL, 'IPR045595', NULL, 'SUF system FeS cluster assembly, SufBD, N-terminal', 'SufBD_N', 3, NULL),
(36021, NULL, 'IPR045796', NULL, 'Failed axon connections homolog, N-terminal domain', 'FAXC_N', 3, NULL),
(36022, NULL, 'IPR044900', NULL, 'Photosystem II CP43 reaction centre protein superfamily', 'PSII_PsbC_sf', 5, NULL),
(36023, NULL, 'IPR045865', NULL, 'ACT-like domain', 'ACT-like_dom_sf', 5, NULL),
(36024, NULL, 'IPR043008', NULL, 'Cyanuric acid hydrolase/Barbiturase, repeating unit A', 'AtzD/Barbiturase_RUA', 5, NULL),
(36025, NULL, 'IPR044648', NULL, 'DNAJ protein JJJ1 homolog, plant', 'JJJ1_plant', 4, NULL),
(36026, NULL, 'IPR044192', NULL, 'Thioredoxin-like protein CDSP32', 'CDSP32', 4, NULL),
(36027, NULL, 'IPR044562', NULL, 'Protein C2-DOMAIN ABA-RELATED', 'CAR1-11', 4, NULL),
(36028, NULL, 'IPR044053', NULL, 'Hydroxylase/desaturase AsaB-like', 'AsaB-like', 4, NULL),
(36029, NULL, 'IPR044610', NULL, 'Beta-glucuronosyltransferase GlcAT14A/B/C', 'GLCAT14A/B/C', 4, NULL),
(36030, NULL, 'IPR044560', NULL, 'Monooxygenase/2-heptyl-3-hydroxy-4(1H)-quinolone synthase', 'MO/PqsH', 4, NULL),
(36031, NULL, 'IPR043613', NULL, 'Non-structural protein 2, C-terminal domain, coronavirus', 'CoV_NSP2_C', 3, NULL),
(36032, NULL, 'IPR044162', NULL, 'Universal stress protein PHOS32/34', 'PHOS32/34', 4, NULL),
(36033, NULL, 'IPR042848', NULL, 'Ribonuclease P protein subunit Rpp38', 'Rpp38', 4, NULL),
(36034, NULL, 'IPR042147', NULL, 'CASP9, CARD domain', 'CARD_CASP9', 3, NULL),
(36035, NULL, 'IPR045753', NULL, 'Protein of unknown function DUF6181', 'DUF6181', 4, NULL),
(36036, NULL, 'IPR044651', NULL, 'Trehalose 6-phosphate  OTSB-like', 'OTSB-like', 4, NULL),
(36037, NULL, 'IPR045696', NULL, 'RING finger protein 37, N-terminal', 'Ubox5_N', 3, NULL),
(36038, NULL, 'IPR044280', NULL, 'Transcriptional activator Hac1/HY5', 'Hac1/HY5', 4, NULL),
(36039, NULL, 'IPR044913', NULL, 'P-type trefoil domain superfamily', 'P_trefoil_dom_sf', 5, NULL),
(36040, NULL, 'IPR044839', NULL, 'Protein NDR1-like', 'NDR1-like', 4, NULL),
(36041, NULL, 'IPR045643', NULL, 'Protein of unknown function DUF6405', 'DUF6405', 4, NULL),
(36042, NULL, 'IPR043007', NULL, 'Cyanuric acid hydrolase/Barbiturase, repeating unit C', 'AtzD/Barbiturase_RUC', 5, NULL),
(36043, NULL, 'IPR044299', NULL, 'Zinc finger protein GIS3/ZFP5/ZFP6', 'GIS3/ZFP5/ZFP6', 4, NULL),
(36044, NULL, 'IPR045779', NULL, 'Protein of unknown function DUF6205', 'DUF6205', 4, NULL),
(36045, NULL, 'IPR042340', NULL, 'High affinity immunoglobulin epsilon receptor subunit gamma', 'FCER1G', 4, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(36046, NULL, 'IPR045066', NULL, 'Beta carbonic anhydrases, cladeB', 'Beta_CA_cladeB', 4, NULL),
(36047, NULL, 'IPR044722', NULL, 'SecA,  C-terminal helicase domain', 'SecA_SF2_C', 3, NULL),
(36048, NULL, 'IPR044585', NULL, 'FCS-Like Zinc finger 10/11', 'FLZ10/11', 4, NULL),
(36049, NULL, 'IPR044302', NULL, 'Costars family', 'Costars', 4, NULL),
(36050, NULL, 'IPR044624', NULL, 'Tetratricopeptide-like repeat protein Mbb1-like', 'Mbb1-like', 4, NULL),
(36051, NULL, 'IPR045336', NULL, 'MmgE/PrpD, N-terminal', 'MmgE_PrpD_N', 3, NULL),
(36052, NULL, 'IPR044896', NULL, 'Hepatitis C virus core protein, chain A superfamily', 'HCV_core_chain_A', 5, NULL),
(36053, NULL, 'IPR042577', NULL, 'EYA domain, metazoan', 'EYA_dom_metazoan', 3, NULL),
(36054, NULL, 'IPR045750', NULL, 'Protein of unknown function DUF6178', 'DUF6178', 4, NULL),
(36055, NULL, 'IPR044683', NULL, 'LAZY family', 'LAZY', 4, NULL),
(36056, NULL, 'IPR045211', NULL, 'TFP11/STIP/Ntr1', 'TFP11/STIP/Ntr1', 4, NULL),
(36057, NULL, 'IPR044372', NULL, 'Spike (S) protein S1 subunit, receptor-binding domain, HCoV-OC43-like', 'Spike_S1_RBD_HCoV-OC43-like', 3, NULL),
(36058, NULL, 'IPR044196', NULL, 'Uncharacterized protein At5g19025-like', 'At5g19025-like', 4, NULL),
(36059, NULL, 'IPR045647', NULL, 'Protein of unknown function DUF6401', 'DUF6401', 4, NULL),
(36060, NULL, 'IPR045331', NULL, 'MITD1, N-terminal domain', 'MITD1_N', 3, NULL),
(36061, NULL, 'IPR045868', NULL, 'Zinc finger CCCH domain-containing protein 13/40', 'Znf_C3H13/40', 4, NULL),
(36062, NULL, 'IPR042714', NULL, 'Tau-tubulin kinase 1, catalytic domain', 'TTBK1_STKc', 3, NULL),
(36063, NULL, 'IPR045651', NULL, 'Domain of unknown function DUF6398', 'DUF6398', 3, NULL),
(36064, NULL, 'IPR045795', NULL, 'Transglycosylase, SLT domain', 'SLT_4', 3, NULL),
(36065, NULL, 'IPR044366', NULL, 'Spike (S) protein S1 subunit, receptor-binding domain, SARS-CoV-2', 'Spike_S1_RBD_SARS-CoV-2', 3, NULL),
(36066, NULL, 'IPR044606', NULL, '5''-adenylylsulfate reductase-like 4/6', 'APRL4/6', 4, NULL),
(36067, NULL, 'IPR045710', NULL, 'Protein of unknown function DUF6066', 'DUF6066', 4, NULL),
(36068, NULL, 'IPR043057', NULL, 'Erythrocyte binding antigen 175, C-terminal domain superfamily', 'EBA-175_C_sf', 5, NULL),
(36069, NULL, 'IPR045557', NULL, 'Activity-regulated cytoskeleton-associated protein,  N-terminal domain', 'Arc_N', 3, NULL),
(36070, NULL, 'IPR045694', NULL, 'Protein of unknown function DUF6058', 'DUF6058', 4, NULL),
(36071, NULL, 'IPR044604', NULL, 'FCS-Like Zinc finger 12/13/14', 'FLZ12/13/14', 4, NULL),
(36072, NULL, 'IPR044326', NULL, 'NS7b protein, bat coronavirus HKU9-like', 'NS7b_batCoV-HKU9', 3, NULL),
(36073, NULL, 'IPR044612', NULL, 'ADP-ribosylation factor-like protein 2/3', 'ARL2/3', 4, NULL),
(36074, NULL, 'IPR042344', NULL, 'Zinc finger CCHC domain-containing protein 14', 'ZCCHC14', 4, NULL),
(36075, NULL, 'IPR044552', NULL, 'GDSL esterase/lipase GLIP1-5/GLL25', 'GLIP1-5/GLL25', 4, NULL),
(36076, NULL, 'IPR045741', NULL, 'Type IX secretion system protein PorV', 'PorV', 3, NULL),
(36077, NULL, 'IPR043017', NULL, 'WIYLD domain superfamily', 'WIYLD_dom_sf', 5, NULL),
(36078, NULL, 'IPR044711', NULL, 'Egg cell-secreted protein 1.1-1.5', 'EC11-15', 4, NULL),
(36079, NULL, 'IPR045787', NULL, 'Mesoderm induction early response protein 1/3, C-terminal', 'MIER1/3_C', 3, NULL),
(36080, NULL, 'IPR042706', NULL, 'Serine/threonine-protein kinase LATS1,  catalytic domain', 'LATS1_STKc', 3, NULL),
(36081, NULL, 'IPR045269', NULL, 'Serine/threonine-protein kinase Atg1-like', 'Atg1-like', 4, NULL),
(36082, NULL, 'IPR045693', NULL, 'NAD(P)H-quinone oxidoreductase subunit 2, N-terminal', 'Ndh2_N', 3, NULL),
(36083, NULL, 'IPR045705', NULL, 'Protein of unknown function DUF6061', 'DUF6061', 4, NULL),
(36084, NULL, 'IPR042564', NULL, 'CRISPR-associated endoribonuclease Cas6/Csy4, subtype I-F/YPEST superfamily', 'CRISPR-Cas6/Csy4_sf', 5, NULL),
(36085, NULL, 'IPR042696', NULL, 'Calcium/calmodulin-dependent protein kinase type 1B, catalytic domain', 'CaMKI_beta_STKc', 3, NULL),
(36086, NULL, 'IPR045851', NULL, 'AMP-binding enzyme, C-terminal domain superfamily', 'AMP-bd_C_sf', 5, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(36087, NULL, 'IPR044811', NULL, 'DNA glycosylase, plant', 'DME/ROS1', 4, NULL),
(36088, NULL, 'IPR044579', NULL, 'Transcription factor bHLH11/121', 'bHLH11/121', 4, NULL),
(36089, NULL, 'IPR043002', NULL, 'Spike glycoprotein, N-terminal domain superfamily', 'Spike_N_sf', 5, NULL),
(36090, NULL, 'IPR044646', NULL, 'Pentatricopeptide repeat-containing protein EMB1417-like', 'EMB1417-like', 4, NULL),
(36091, NULL, 'IPR044136', NULL, 'Lysine-tRNA ligase, class II, N-terminal', 'Lys-tRNA-ligase_II_N', 3, NULL),
(36092, NULL, 'IPR043015', NULL, 'Arenavirus glycoprotein, zinc binding domain', 'Arena_glycoprot_zinc-bd', 5, NULL),
(36093, NULL, 'IPR044892', NULL, 'Ribosomal protein L3, domain 3, archaeal type superfamily', 'Ribosomal_L3_dom_3_arc_sf', 5, NULL),
(36094, NULL, 'IPR044133', NULL, 'KMT2A, PHD domain 3', 'KMT2A_PHD3', 3, NULL),
(36095, NULL, 'IPR045689', NULL, 'S-layer protein Slr4', 'Slr4', 4, NULL),
(36096, NULL, 'IPR044611', NULL, 'Ubiquitin-protein ligase E3A/B/C-like', 'E3A/B/C-like', 4, NULL),
(36097, NULL, 'IPR044557', NULL, 'WUSCHEL-related homeobox 8/9-like', 'WOX8/9-like', 4, NULL),
(36098, NULL, 'IPR044507', NULL, 'D-alanine:D-alanyl carrier protein ligase-like', 'DltA-like', 4, NULL),
(36099, NULL, 'IPR044647', NULL, 'Reticulon-like protein B17/18/21', 'RTNLB17/18/21', 4, NULL),
(36100, NULL, 'IPR042634', NULL, 'Homeobox protein MOX-1/MOX-2', 'MOX-1/MOX-2', 4, NULL),
(36101, NULL, 'IPR045748', NULL, 'DcaP outer membrane protein', 'DcaP', 4, NULL),
(36102, NULL, 'IPR045780', NULL, 'Protein of unknown function DUF6206', 'DUF6206', 4, NULL),
(36103, NULL, 'IPR044903', NULL, 'Luciferase, helical bundle domain superfamily', 'Luciferase_hlx-bundle_dom_sf', 5, NULL),
(36104, NULL, 'IPR045687', NULL, 'GPI ethanolamine phosphate transferase 2, C-terminal', 'PIGG/GPI7_C', 3, NULL),
(36105, NULL, 'IPR044364', NULL, 'Spike (S) protein S1 subunit, receptor-binding domain, MERS-CoV-like', 'Spike_S1_RBD_MERS-CoV-like', 3, NULL),
(36106, NULL, 'IPR044669', NULL, 'UPF0187 family', 'UPF0187', 4, NULL),
(36107, NULL, 'IPR045628', NULL, 'Helicase Lhr-like, winged helix domain', 'Lhr_WH_dom', 3, NULL),
(36108, NULL, 'IPR044874', NULL, 'Spike glycoprotein S2, coronavirus, heptad repeat 2', 'Spike_S2_CoV_HR2', 3, NULL),
(36109, NULL, 'IPR044885', NULL, 'Plasmodium RESA, N-terminal helical domain superfamily', 'PRESA_N_sf', 5, NULL),
(36110, NULL, 'IPR045786', NULL, 'Rho GTPase-activating protein, pG1 and pG2 domain', 'RhoGAP_pG1_pG2', 3, NULL),
(36111, NULL, 'IPR043025', NULL, 'Dam replacing family, catalytic PD-(D/E)XK domain', 'DRP_PD-(D/E)XK_dom', 5, NULL),
(36112, NULL, 'IPR043061', NULL, 'Filoviruses VP35 interferon inhibitory domain, beta-sheet subdomain', 'VP35_IID_b-sht', 5, NULL),
(36113, NULL, 'IPR044570', NULL, 'Histone-lysine N-methyltransferase Set1-like', 'Set1-like', 4, NULL),
(36114, NULL, 'IPR045698', NULL, 'Rab3GAP catalytic subunit, C-terminal', 'Rab3GAP1_C', 3, NULL),
(36115, NULL, 'IPR044139', NULL, 'Sulfate adenylyltransferase subunit CysN, Domain III', 'CysN_NoDQ_III', 3, NULL),
(36116, NULL, 'IPR044635', NULL, 'Ubiquitin carboxyl-terminal hydrolase 14-like', 'UBP14-like', 4, NULL),
(36117, NULL, 'IPR044332', NULL, 'Accessory protein NS7a, deltacoronavirus, HKU30-like', 'NS7a_deltaCoV_HKU30-like', 3, NULL),
(36118, NULL, 'IPR045695', NULL, 'Transmembrane protein 131-like, conserved domain', 'TMEM131-like_conserved', 3, NULL),
(36119, NULL, 'IPR045376', NULL, 'Glycosyltransferase Maf, N-terminal', 'Maf_N', 3, NULL),
(36120, NULL, 'IPR042314', NULL, 'Transmembrane protein 121', 'TMEM121', 4, NULL),
(36121, NULL, 'IPR042795', NULL, 'WD repeat-containing protein 73', 'Wdr73', 4, NULL),
(36122, NULL, 'IPR045480', NULL, 'FtsH ternary system domain X1', 'fvmX1', 3, NULL),
(36123, NULL, 'IPR045214', NULL, 'Surfeit locus 1/4', 'Surf1/Surf4', 4, NULL),
(36124, NULL, 'IPR044666', NULL, 'Cyclophilin-type peptidyl-prolyl cis-trans isomerase, cyclophilin A-like', 'Cyclophilin_A-like', 4, NULL),
(36125, NULL, 'IPR042229', NULL, 'Listeria-Bacteroides repeat domain superfamily', 'Listeria/Bacterioides_rpt_sf', 5, NULL);             
INSERT INTO "PUBLIC"."ENTRY" VALUES
(36126, NULL, 'IPR044632', NULL, 'DnaJ homolog subfamily C member 25-like', 'DNAJC25-like', 4, NULL),
(36127, NULL, 'IPR045677', NULL, 'Protein of unknown function DUF6197', 'DUF6197', 4, NULL),
(36128, NULL, 'IPR045752', NULL, 'Protein of unknown function DUF6180', 'DUF6180', 4, NULL),
(36129, NULL, 'IPR044706', NULL, 'AUGMIN subunit 5, plant', 'AUG5_plant', 4, NULL),
(36130, NULL, 'IPR044193', NULL, 'Thioredoxin-like 3-3', 'TRL33', 4, NULL),
(36131, NULL, 'IPR045095', NULL, 'Ancient conserved domain protein family', 'ACDP', 4, NULL),
(36132, NULL, 'IPR043115', NULL, 'D212, catalytic domain superfamily', 'D212_cat_dom_sf', 5, NULL),
(36133, NULL, 'IPR045083', NULL, 'ATP synthase, F0 complex, subunit A, bacterial/mitochondria', 'ATP_synth_F0_asu_bact/mt', 4, NULL),
(36134, NULL, 'IPR045832', NULL, 'Cell cycle link protein Clink', 'Clink', 4, NULL),
(36135, NULL, 'IPR044614', NULL, 'Rhodanese-like domain-containing protein 10', 'STR10', 4, NULL),
(36136, NULL, 'IPR044743', NULL, 'Ubiquitin-specific-processing protease 48, Ubl domain', 'Ubl_USP48', 3, NULL),
(36137, NULL, 'IPR045785', NULL, 'Dipeptidyl peptidase 8 /9 ,N-terminal', 'Dpp_8/9_N', 3, NULL),
(36138, NULL, 'IPR045715', NULL, 'Protein of unknown function DUF6071', 'DUF6071', 4, NULL),
(36139, NULL, 'IPR042723', NULL, 'RNF135, PRY/SPRY domain', 'RNF135_SPRY_PRY_dom', 3, NULL),
(36140, NULL, 'IPR044559', NULL, 'WUSCHEL-related homeobox 13-like', 'WOX13-like', 4, NULL),
(36141, NULL, 'IPR044696', NULL, 'WPP domain-interacting protein 1/2/3', 'WIP1/2/3', 4, NULL),
(36142, NULL, 'IPR044828', NULL, 'Stem-specific protein TSJT1-like', 'TSJT1-like', 4, NULL),
(36143, NULL, 'IPR044203', NULL, 'Group 2 truncated hemoglobin GlbO/Two-on-two hemoglobin-3-like', 'GlbO/GLB3-like', 4, NULL),
(36144, NULL, 'IPR044565', NULL, 'Vesicle-trafficking protein Sec22', 'Sec22', 4, NULL),
(36145, NULL, 'IPR042688', NULL, 'Lmx1a, first LIM domain', 'Lmx1a_LIM1', 3, NULL),
(36146, NULL, 'IPR042338', NULL, 'Tumor necrosis factor ligand superfamily member 4', 'TNFSF4', 4, NULL),
(36147, NULL, 'IPR045584', NULL, 'Pilin-like', 'Pilin-like', 5, NULL),
(36148, NULL, 'IPR044074', NULL, 'Formyltetrahydrofolate deformylase,  ACT domain', 'PurU_ACT', 3, NULL),
(36149, NULL, 'IPR044277', NULL, 'GBF-interacting protein 1', 'GIP1', 4, NULL),
(36150, NULL, 'IPR044374', NULL, 'Non-structural protein 3, SUD-N macrodomain, SARS-CoV', 'NSP3_SUD-N_SARS-CoV', 3, NULL),
(36151, NULL, 'IPR044323', NULL, 'Non-structural protein ORF5, MERS-CoV-like', 'MERS-CoV-like_ORF5', 4, NULL),
(36152, NULL, 'IPR044311', NULL, 'Accessory protein N2-like', 'N2-like_embe-CoV', 3, NULL),
(36153, NULL, 'IPR045875', NULL, 'Nuclear transport factor 2/Mtr2', 'NTF2/Mtr2', 4, NULL),
(36154, NULL, 'IPR044607', NULL, 'Transcription factor RKD-like', 'RKD-like', 4, NULL),
(36155, NULL, 'IPR044608', NULL, 'Ethanolamine-phosphate cytidylyltransferase', 'Ect1/PCYT2', 4, NULL),
(36156, NULL, 'IPR044834', NULL, 'Patellin', 'PATL', 4, NULL),
(36157, NULL, 'IPR042233', NULL, 'Cell division protein ZapA, N-terminal', 'Cell_div_ZapA_N', 5, NULL),
(36158, NULL, 'IPR044615', NULL, 'Rhodanese-like domain-containing protein 9, chloroplastic', 'STR9', 4, NULL),
(36159, NULL, 'IPR045712', NULL, 'Protein of unknown function DUF6068', 'DUF6068', 4, NULL),
(36160, NULL, 'IPR044881', NULL, 'RecQ-mediated genome instability protein 1, N-terminal helical domain superfamily', 'RMI1_N_N_sf', 5, NULL),
(36161, NULL, 'IPR045559', NULL, 'Ribbon-helix-helix protein, RHH domain', 'RHH_9', 3, NULL),
(36162, NULL, 'IPR044904', NULL, '3,4-dihydroxyphenylacetate 2,3-dioxygenase, C-terminal domain superfamily', 'HPCD_C_sf', 5, NULL),
(36163, NULL, 'IPR045682', NULL, 'Protein of unknown function DUF6193', 'DUF6193', 4, NULL),
(36164, NULL, 'IPR044558', NULL, 'WUSCHEL-related homeobox 11-like', 'WOX11-like', 4, NULL),
(36165, NULL, 'IPR044864', NULL, 'Non-structural protein NSP3, SUD-N (Mac2) domain, betacoronavirus', 'NSP3_SUD-N_bCoV', 3, NULL),
(36166, NULL, 'IPR044574', NULL, 'ATPase ARIP4-like', 'ARIP4-like', 4, NULL),
(36167, NULL, 'IPR044895', NULL, 'Kinetochore null protein 2, Myb-like DNA-binding domain superfamily', 'Knl-2_Myb-like_DNA-bd_sf', 5, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(36168, NULL, 'IPR044643', NULL, 'N-(5''-phosphoribosyl)anthranilate isomerase family', 'TrpF_fam', 4, NULL),
(36169, NULL, 'IPR045231', NULL, 'Protein Yip1/4-like', 'Yip1/4-like', 4, NULL),
(36170, NULL, 'IPR045826', NULL, 'SpaA-like, prealbumin-like fold domain', 'SpaA-like', 3, NULL),
(36171, NULL, 'IPR044867', NULL, 'DEUBAD  domain', 'DEUBAD_dom', 3, NULL),
(36172, NULL, 'IPR042695', NULL, 'ACAP3, BAR domain', 'ACAP3_BAR', 3, NULL),
(36173, NULL, 'IPR044859', NULL, 'Allene oxide cyclase/Dirigent protein', 'Allene_oxi_cyc_Dirigent', 5, NULL),
(36174, NULL, 'IPR045676', NULL, 'Protein of unknown function DUF6194', 'DUF6194', 4, NULL),
(36175, NULL, 'IPR044870', NULL, 'Bacterial microcompartment (BMC) circularly permuted domain', 'BMC_CP', 3, NULL),
(36176, NULL, 'IPR044135', NULL, 'Methionyl-tRNA formyltransferase, C-terminal domain', 'Met-tRNA-FMT_C', 3, NULL),
(36177, NULL, 'IPR045570', NULL, 'Metalloprotease TldD/E, central domain', 'Metalloprtase-TldD/E_cen_dom', 3, NULL),
(36178, NULL, 'IPR042715', NULL, 'Rhophilin-1, BRO1 domain', 'Rhophilin-1_BRO1', 3, NULL),
(36179, NULL, 'IPR045800', NULL, 'Heavy metal binding domain', 'HMBD', 3, NULL),
(36180, NULL, 'IPR045822', NULL, 'CO dehydrogenase/acetyl-CoA synthase complex beta subunit , C-terminal', 'ACS_CODH_B_C', 3, NULL),
(36181, NULL, 'IPR044602', NULL, 'RING-H2 finger protein ATL10/ATL75-79-like', 'ATL10/ATL75-79-like', 4, NULL),
(36182, NULL, 'IPR042339', NULL, 'Lymphocyte antigen 6D', 'Ly6D', 4, NULL),
(36183, NULL, 'IPR044117', NULL, 'Lig-like, OB-fold domain', 'OBF_LigC-like', 3, NULL),
(36184, NULL, 'IPR044324', NULL, 'Nonstructural protein 15, middle domain, deltacoronavirus', 'NSP15_M_deltaCoV', 3, NULL),
(36185, NULL, 'IPR045656', NULL, 'Protein of unknown function DUF6393', 'DUF6393', 4, NULL),
(36186, NULL, 'IPR045546', NULL, 'Exportin-T, C-terminal domain', 'Exportin-T_C', 3, NULL),
(36187, NULL, 'IPR044616', NULL, 'WD repeat-containing protein RUP1/2', 'RUP1/2', 4, NULL),
(36188, NULL, 'IPR044868', NULL, 'Rpn13/ADRM1, Pru domain', 'Rpn13/ADRM1_Pru', 3, NULL),
(36189, NULL, 'IPR045217', NULL, 'Patatin-like phospholipase domain containing protein 8-like', 'PNPLA8-like', 3, NULL),
(36190, NULL, 'IPR045833', NULL, 'Astrovirus p19 protein', 'Astro_p19', 4, NULL),
(36191, NULL, 'IPR045385', NULL, 'Protein of unknown function DUF6526', 'DUF6526', 4, NULL),
(36192, NULL, 'IPR044909', NULL, 'TM_1086 superfamily', 'TM_1086_sf', 5, NULL),
(36193, NULL, 'IPR042623', NULL, 'Transmembrane protein 205', 'TMEM205', 4, NULL),
(36194, NULL, 'IPR045817', NULL, 'Dynamin-like GTPase OPA1, C-terminal', 'OPA1_C', 3, NULL),
(36195, NULL, 'IPR044817', NULL, 'Squamosa promoter-binding-like protein', 'SPL', 4, NULL),
(36196, NULL, 'IPR045585', NULL, 'Diadenylate cyclase CdaA, N-terminal domain', 'CdaA_N', 3, NULL),
(36197, NULL, 'IPR045825', NULL, 'Lanthionine-containing peptide SapB precursor RamS', 'RamS', 4, NULL),
(36198, NULL, 'IPR044830', NULL, 'Class III homeodomain-leucine zipper family', 'HD-Zip_III', 4, NULL),
(36199, NULL, 'IPR044668', NULL, 'Peptidase C26, gamma-glutamyl-gamma-aminobutyrate hydrolase PuuD-like', 'PuuD-like', 4, NULL),
(36200, NULL, 'IPR044334', NULL, 'Accessory protein NS7, porcine deltacoronavirus (PDCoV)', 'NS7_PDCoV', 3, NULL),
(36201, NULL, 'IPR044554', NULL, 'Anaphase-promoting complex subunit 2', 'APC2-like', 4, NULL),
(36202, NULL, 'IPR043012', NULL, 'Bunyavirus nucleocapsid (N) , N-terminal domain', 'Bunya_nucleocap_N', 5, NULL),
(36203, NULL, 'IPR045576', NULL, 'DNA-directed RNA polymerase III subunit RPC5, C-terminal', 'RPC5_C', 3, NULL),
(36204, NULL, 'IPR045602', NULL, 'MARF1, first and second LOTUS domain', 'MARF1_LOTUS', 3, NULL),
(36205, NULL, 'IPR043565', NULL, 'PAX family', 'PAX_fam', 4, NULL),
(36206, NULL, 'IPR045216', NULL, 'Casein Kinase 2, subunit alpha', 'CK2_alpha', 4, NULL),
(36207, NULL, 'IPR045562', NULL, 'ATP-dependent DNA helicase RecG, domain 3, C-terminal', 'RecG_dom3_C', 3, NULL),
(36208, NULL, 'IPR045788', NULL, 'MobC-like protein', 'MobC_2', 4, NULL),
(36209, NULL, 'IPR042228', NULL, 'Dynein heavy chain, linker, subdomain 3', 'Dynein_linker_3', 5, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(36210, NULL, 'IPR044175', NULL, 'Pentatricopeptide repeat-containing protein At5g66631-like', 'At5g66631-like', 4, NULL),
(36211, NULL, 'IPR045058', NULL, 'GTPase GIMA/IAN/Toc', 'GIMA/IAN/Toc', 4, NULL),
(36212, NULL, 'IPR045746', NULL, 'Putative acyltransferase ACT14924-like, acyltransferase domain', 'ACT14924-like_Acyltransf_dom', 3, NULL),
(36213, NULL, 'IPR043825', NULL, 'Protein of unknown function DUF5802', 'DUF5802', 4, NULL),
(36214, NULL, 'IPR043021', NULL, 'GCM, small domain', 'GCM_small', 5, NULL),
(36215, NULL, 'IPR044883', NULL, 'Hemolysin, pre-stem domain', 'Hemolysin_pre-stem_dom_sf', 5, NULL),
(36216, NULL, 'IPR044575', NULL, 'Beta-arabinofuranosyltransferase RAY1-like', 'RAY1-like', 4, NULL),
(36217, NULL, 'IPR044816', NULL, 'BURP domain-containing protein', 'BURP', 4, NULL),
(36218, NULL, 'IPR044601', NULL, '3xHMG-box protein HMGB6/HMGB13', 'HMGB6/HMGB13', 4, NULL),
(36219, NULL, 'IPR044000', NULL, 'Phage tail tube protein-like', 'Phage_tube_2', 4, NULL),
(36220, NULL, 'IPR044659', NULL, 'Protein PELPK2', 'PELPK2', 4, NULL),
(36221, NULL, 'IPR045645', NULL, 'Protein of unknown function DUF6403', 'DUF6403', 4, NULL),
(36222, NULL, 'IPR045572', NULL, 'Type III restriction enzyme, C-terminal endonuclease domain', 'RE_endonuc_C', 3, NULL),
(36223, NULL, 'IPR042951', NULL, 'ADP-ribosylation factor-like protein 10', 'ARL10', 4, NULL),
(36224, NULL, 'IPR045569', NULL, 'Metalloprotease TldD/E, C-terminal domain', 'Metalloprtase-TldD/E_C', 3, NULL),
(36225, NULL, 'IPR044670', NULL, 'SOB-five-Like (SOFL) family', 'SOFL', 4, NULL),
(36226, NULL, 'IPR044898', NULL, 'Cyclin-dependent kinase inhibitor domain superfamily', 'CDI_dom_sf', 5, NULL),
(36227, NULL, 'IPR045679', NULL, 'Protein of unknown function DUF6199', 'DUF6199', 4, NULL),
(36228, NULL, 'IPR044327', NULL, 'Nonstructural protein 15, middle domain, MERS', 'NSP15_M_MERS', 3, NULL),
(36229, NULL, 'IPR045674', NULL, 'Protein of unknown function DUF6196', 'DUF6196', 4, NULL),
(36230, NULL, 'IPR042335', NULL, 'Ankyrin repeat domain-containing protein 53', 'ANKRD53', 4, NULL),
(36231, NULL, 'IPR045313', NULL, 'Carbonyl reductase [NADPH] 1-like', 'CBR1-like', 4, NULL),
(36232, NULL, 'IPR045534', NULL, 'Protein of unknown function DUF6428', 'DUF6428', 4, NULL),
(36233, NULL, 'IPR045792', NULL, 'Domain of unknown function DUF6036', 'DUF6036', 3, NULL),
(36234, NULL, 'IPR044363', NULL, 'M matrix/glycoprotein, MERS-like-CoV', 'M_MERS-like-CoV', 4, NULL),
(36235, NULL, 'IPR044371', NULL, 'Non-structural protein 3, X-domain-like', 'Macro_X_NSP3-like', 3, NULL),
(36236, NULL, 'IPR045835', NULL, 'Astrovirus transmembrane protein 1A', 'Astro_1A', 4, NULL),
(36237, NULL, 'IPR044914', NULL, 'Endosialidase, C-terminal domain superfamily', 'Endosialidase_C_dom_sf', 5, NULL),
(36238, NULL, 'IPR045853', NULL, 'Peptide chain release factor class I superfamily', 'Pep_chain_release_fac_I_sf', 5, NULL),
(36239, NULL, 'IPR045541', NULL, 'Ternary complex associated domain 2', 'TCAD2', 3, NULL),
(36240, NULL, 'IPR045794', NULL, 'Trypsin-co-occurring domain 1', 'Trypco1', 3, NULL),
(36241, NULL, 'IPR044775', NULL, 'Sugar transporter ERD6/Tret1-like', 'MFS_ERD6/Tret1-like', 4, NULL),
(36242, NULL, 'IPR042235', NULL, 'Zona pellucida, ZP-C domain', 'ZP-C', 5, NULL),
(36243, NULL, 'IPR045220', NULL, 'Oxidoreductase FRHB/FDHB/HCAR-like', 'FRHB/FDHB/HCAR-like', 4, NULL),
(36244, NULL, 'IPR045218', NULL, 'Protein DA1-like', 'DA1-like', 4, NULL),
(36245, NULL, 'IPR045476', NULL, 'JAB-N domain', 'FvmJAB_N', 3, NULL),
(36246, NULL, 'IPR043019', NULL, 'T3SS negative regulator GrlR domain superfamily', 'GrlR_sf', 5, NULL),
(36247, NULL, 'IPR045842', NULL, 'Protein furry, C-terminal', 'Fry_C', 3, NULL),
(36248, NULL, 'IPR043106', NULL, 'Rubella capsid domain superfamily', 'Rubella_Capsid_sf', 5, NULL),
(36249, NULL, 'IPR045749', NULL, 'Protein of unknown function DUF6090', 'DUF6090', 4, NULL),
(36250, NULL, 'IPR044618', NULL, 'NAD(P)H-quinone oxidoreductase subunit T-like', 'NdhT-like', 4, NULL),
(36251, NULL, 'IPR045198', NULL, 'Calcineurin B-like', 'CNBL1-10', 4, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(36252, NULL, 'IPR042943', NULL, 'Kunitz-type protease inhibitor 4', 'SPINT4', 4, NULL),
(36253, NULL, 'IPR045678', NULL, 'Protein of unknown function DUF6198', 'DUF6198', 4, NULL),
(36254, NULL, 'IPR045659', NULL, 'LPS-assembly protein LptD, central domain', 'LptD_2', 3, NULL),
(36255, NULL, 'IPR043003', NULL, 'FANCL, UBC-like domain 3 superfamily', 'FANCL_d3_sf', 5, NULL),
(36256, NULL, 'IPR044627', NULL, 'Dehydroascorbate reductases DHAR1/2/3/4', 'DHAR1/2/3/4', 4, NULL),
(36257, NULL, 'IPR045627', NULL, 'F-box/LRR-repeat protein 18, LRR domain', 'FBXL18_LRR', 3, NULL),
(36258, NULL, 'IPR044880', NULL, 'NCX, central ion-binding domain superfamily', 'NCX_ion-bd_dom_sf', 5, NULL),
(36259, NULL, 'IPR045756', NULL, 'Protein of unknown function DUF6183', 'DUF6183', 4, NULL),
(36260, NULL, 'IPR044882', NULL, 'Interferon regulatory factor 2-binding protein 1/2, C3HC4-type RING finger superfamily', 'I2BP1/2_C3HC4-RING_sf', 5, NULL),
(36261, NULL, 'IPR045594', NULL, 'Domain of unknown function DUF6460', 'DUF6460', 3, NULL),
(36262, NULL, 'IPR044316', NULL, 'Nonstructural protein 14, gammacoronavirus', 'NSP14_gammaCoV', 3, NULL),
(36263, NULL, 'IPR045642', NULL, 'Protein of unknown function DUF6406', 'DUF6406', 4, NULL),
(36264, NULL, 'IPR044884', NULL, 'Mitochondrial ribosomal protein L55 superfamily', 'Ribosomal_L55_sf', 5, NULL),
(36265, NULL, 'IPR045593', NULL, 'Atg11, middle domain', 'Atg11_middle', 3, NULL),
(36266, NULL, 'IPR044673', NULL, 'Protein DCL-like', 'DCL-like', 4, NULL),
(36267, NULL, 'IPR044322', NULL, 'Nonstructural protein 15, middle domain, alpha/betacoronavirus', 'NSP15_M_alpha_beta_CoV', 3, NULL),
(36268, NULL, 'IPR043030', NULL, 'Beta-1,3-glucan-binding protein, N-terminal domain superfamily', 'BGBP_N_sf', 5, NULL),
(36269, NULL, 'IPR044453', NULL, 'EIF2AK2, second double-stranded RNA binding domain', 'EIF2AK2_DSRM_2', 3, NULL),
(36270, NULL, 'IPR045200', NULL, 'E3 ubiquitin-protein ligase CHIP', 'CHIP', 4, NULL),
(36271, NULL, 'IPR045337', NULL, 'MmgE/PrpD, C-terminal', 'MmgE_PrpD_C', 3, NULL),
(36272, NULL, 'IPR045834', NULL, 'Csd3-like, second N-terminal domain', 'Csd3_N2', 3, NULL),
(36273, NULL, 'IPR044435', NULL, 'Set3/4, SET domain', 'Set3/4_SET', 3, NULL),
(36274, NULL, 'IPR042937', NULL, 'Trichohyalin-like protein 1', 'TCHHL1', 4, NULL),
(36275, NULL, 'IPR044370', NULL, 'Spike (S) protein S1 subunit, receptor-binding domain, SARS-CoV', 'Spike_S1_RBD_SARS-CoV', 3, NULL),
(36276, NULL, 'IPR045706', NULL, 'Protein of unknown function DUF6062', 'DUF6062', 4, NULL),
(36277, NULL, 'IPR045837', NULL, 'Bacterial toxin, RNase RnlA/LsoA, N-terminal', 'RnlA_toxin_N', 3, NULL),
(36278, NULL, 'IPR043064', NULL, 'Long-chain fatty acyl-CoA thioesterase, Rv0098-like superfamily', 'FcoT_ThioEstase_Rv0098-like_sf', 5, NULL),
(36279, NULL, 'IPR045644', NULL, 'Protein of unknown function DUF6404', 'DUF6404', 4, NULL),
(36280, NULL, 'IPR045845', NULL, 'Serine/threonine-protein kinase BSK', 'BSK', 4, NULL),
(36281, NULL, 'IPR043548', NULL, '1-phosphatidylinositol-3phosphate-5-kinase', 'PIKfyve', 4, NULL),
(36282, NULL, 'IPR045818', NULL, 'Gamma-tubulin complex component 6, N-terminal', 'GCP6_N', 3, NULL),
(36283, NULL, 'IPR042935', NULL, 'tRNA-specific adenosine deaminase 1', 'Tad1', 4, NULL),
(36284, NULL, 'IPR044840', NULL, 'Nucleoporin Nup188', 'Nup188', 4, NULL),
(36285, NULL, 'IPR043001', NULL, 'Inositol-pentakisphosphate 2-kinase, N-terminal lobe', 'IP5_2-K_N_lobe', 5, NULL),
(36286, NULL, 'IPR045586', NULL, 'Diadenylate cyclase DacZ, N-terminal domain', 'DacZ_N', 3, NULL),
(36287, NULL, 'IPR044314', NULL, 'NSP11, NendoU domain, arterivirus', 'NSP11_NendoU_Av', 3, NULL),
(36288, NULL, 'IPR044315', NULL, 'Nonstructural protein 14, betacoronavirus', 'NSP14_betaCoV', 3, NULL),
(36289, NULL, 'IPR044390', NULL, 'Structural accessory protein ORF7a, SARS-CoV-2-like', 'ORF7a_SARS-CoV-2-like', 4, NULL),
(36290, NULL, 'IPR044634', NULL, 'J-protein Zuotin/DnaJC2', 'Zuotin/DnaJC2', 4, NULL),
(36291, NULL, 'IPR043066', NULL, 'Carboxysome shell carbonic anhydrase, C-terminal', 'Carboxysome_shell_carb_anhy_C', 5, NULL);  
INSERT INTO "PUBLIC"."ENTRY" VALUES
(36292, NULL, 'IPR045661', NULL, 'Protein of unknown function DUF6389', 'DUF6389', 4, NULL),
(36293, NULL, 'IPR044148', NULL, 'Succinate-semialdehyde dehydrogenase GabD1-like', 'ALDH_GabD1-like', 3, NULL),
(36294, NULL, 'IPR043020', NULL, 'GCM domain, large subdomain', 'GCM_large', 5, NULL),
(36295, NULL, 'IPR045877', NULL, 'RNA-binding protein ZFP36-like', 'ZFP36-like', 4, NULL),
(36296, NULL, 'IPR044655', NULL, 'BAG-associated GRAM protein 1-like', 'BAGP1-like', 4, NULL),
(36297, NULL, 'IPR044506', NULL, 'Dual-specificity phosphatase CDC14, C-terminal', 'CDC14_C', 3, NULL),
(36298, NULL, 'IPR043018', NULL, 'Poxvirus domain superfamily', 'Poxvirus_sf', 5, NULL),
(36299, NULL, 'IPR044356', NULL, 'RNA-dependent RNA polymerase, alphacoronavirus', 'RdRp_alphaCoV', 3, NULL),
(36300, NULL, 'IPR044563', NULL, 'Protein Sgt1-like', 'Sgt1-like', 4, NULL),
(36301, NULL, 'IPR045836', NULL, 'Astrovirus VPg protein', 'Astro_VPg', 4, NULL),
(36302, NULL, 'IPR044665', NULL, 'Cyclophilin-type peptidyl-prolyl cis-trans isomerase, E. coli cyclophilin A-like', 'E_coli_cyclophilin_A-like', 4, NULL),
(36303, NULL, 'IPR044240', NULL, 'Rhodanese-like domain-containing protein STR4-like', 'STR4-like', 4, NULL),
(36304, NULL, 'IPR044313', NULL, 'Nonstructural protein 14, alphacoronavirus', 'NSP14_alphaCoV', 3, NULL),
(36305, NULL, 'IPR044626', NULL, 'NADPH-dependent oxidoreductase AOR-like', 'AOR-like', 4, NULL),
(36306, NULL, 'IPR042353', NULL, 'Probable G-protein coupled receptor 160', 'GPR160', 4, NULL),
(36307, NULL, 'IPR045838', NULL, 'DEPDC5 protein, C-terminal', 'DEPDC5_CTD', 3, NULL),
(36308, NULL, 'IPR043400', NULL, 'RNF141, RING finger, HC subclass', 'RING-HC_RNF141', 3, NULL),
(36309, NULL, 'IPR042694', NULL, 'Proline-serine-threonine phosphatase-interacting protein 2, F-BAR domain', 'PSTPIP2_F-BAR', 3, NULL),
(36310, NULL, 'IPR043004', NULL, 'MvaI/BcnI restriction endonuclease, catalytic domain', 'MvaI_BcnI_cat', 5, NULL),
(36311, NULL, 'IPR045744', NULL, 'E3 ubiquitin-protein ligase RNF152, C-terminal', 'RNF152_C', 3, NULL),
(36312, NULL, 'IPR044613', NULL, 'NEDD8-specific protease 1/2-like', 'Nep1/2-like', 4, NULL),
(36313, NULL, 'IPR044555', NULL, 'Protein WUSCHEL-like', 'WUSCHEL-like', 4, NULL),
(36314, NULL, 'IPR044438', NULL, 'EZH1, SET domain', 'EZH1_SET', 3, NULL),
(36315, NULL, 'IPR045230', NULL, 'Zinc finger protein MBS1/2-like', 'MBS1/2-like', 4, NULL),
(36316, NULL, 'IPR044375', NULL, 'Spike (S) protein S1 subunit, receptor-binding domain, HKU1-like', 'Spike_S1_RBD_CoV_HKU1-like', 3, NULL),
(36317, NULL, 'IPR045587', NULL, 'Ribitol-5-phosphate transferase FKTN, N-terminal', 'FKTN_N', 3, NULL),
(36318, NULL, 'IPR044664', NULL, 'Rhodanese-like domain-containing protein 11-like', 'STR11-like', 4, NULL),
(36319, NULL, 'IPR044134', NULL, 'Synaptotagmin-like protein 4 , FYVE-related domain', 'FYVE_Slp4', 3, NULL),
(36320, NULL, 'IPR044623', NULL, 'ERAD-associated E3 ubiquitin-protein ligase component HRD3', 'HRD3', 4, NULL),
(36321, NULL, 'IPR043423', NULL, 'Esterase FrsA', 'FrsA', 4, NULL),
(36322, NULL, 'IPR044553', NULL, 'ANCHR, B-box-type 1 zinc finger domain', 'Bbox1_ANCHR', 3, NULL),
(36323, NULL, 'IPR045219', NULL, 'PKD- and KLD-Associated Transmembrane', 'PKAT', 4, NULL),
(36324, NULL, 'IPR044421', NULL, 'SMYD4, SET domain', 'SMYD4_SET', 3, NULL),
(36325, NULL, 'IPR042231', NULL, 'Choline/Carnitine o-acyltransferase, domain 2', 'Cho/carn_acyl_trans_2', 5, NULL),
(36326, NULL, 'IPR044581', NULL, 'Two pore calcium channel protein 1, plant', 'TPC1_plant', 4, NULL),
(36327, NULL, 'IPR044584', NULL, 'E3 ubiquitin-protein ligase KEG', 'KEG', 4, NULL),
(36328, NULL, 'IPR044578', NULL, 'Pentatricopeptide repeat-containing protein BIR6-like', 'BIR6-like', 4, NULL),
(36329, NULL, 'IPR043029', NULL, 'Catechol 1,2-dioxygenase multimerisation domain', '1_2-CTD_multi_dom', 5, NULL),
(36330, NULL, 'IPR044619', NULL, 'F-box protein At3g18720-like', 'At3g18720-like', 4, NULL),
(36331, NULL, 'IPR044877', NULL, 'Sulfolobus spindle-shape virus 1 F-112 protein-like superfamily', 'F-112-like_sf', 5, NULL),
(36332, NULL, 'IPR043013', NULL, 'Zinc finger, TRAF-type, N-terminal', 'Znf_TRAF_N', 5, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(36333, NULL, 'IPR044150', NULL, 'Histone deacetylase 11', 'HDAC_classIV', 3, NULL),
(36334, NULL, 'IPR045596', NULL, 'Protein of unknown function DUF6459', 'DUF6459', 4, NULL),
(36335, NULL, 'IPR044573', NULL, 'ARIP4, DEXH-box helicase domain', 'ARIP4_DEXHc', 3, NULL),
(36336, NULL, 'IPR044201', NULL, 'Divinyl reductase-like', 'DVR-like', 4, NULL),
(36337, NULL, 'IPR044567', NULL, 'SNF2 domain-containing protein CLSY/DRD1', 'CLSY/DRD1', 4, NULL),
(36338, NULL, 'IPR044890', NULL, 'TMEM14 superfamily', 'TMEM14_sf', 5, NULL),
(36339, NULL, 'IPR045649', NULL, 'Protein of unknown function DUF6400', 'DUF6400', 4, NULL),
(36340, NULL, 'IPR045654', NULL, 'Protein of unknown function DUF6395', 'DUF6395', 4, NULL),
(36341, NULL, 'IPR043024', NULL, 'Kinase associated-1 domain superfamily, fungal', 'KA1_sf_fungal', 5, NULL),
(36342, NULL, 'IPR045819', NULL, 'Tetratricopeptide repeat protein 7, N-terminal', 'TTC7_N', 3, NULL),
(36343, NULL, 'IPR045717', NULL, 'Chordin-like protein 1/2', 'CHRDL1/2', 4, NULL),
(36344, NULL, 'IPR045751', NULL, 'Protein of unknown function DUF6179', 'DUF6179', 4, NULL),
(36345, NULL, 'IPR044858', NULL, 'Stomagen, C-terminal domain', 'Stomagen_C', 3, NULL),
(36346, NULL, 'IPR044906', NULL, 'Nitrate reductase, alpha subunit, N-terminal domain superfamily', 'Nitr_red_alph_N_sf', 5, NULL),
(36347, NULL, 'IPR045840', NULL, 'Ariadne domain', 'Ariadne', 3, NULL),
(36348, NULL, 'IPR044861', NULL, 'Isopenicillin N synthase-like, Fe(2+) 2OG dioxygenase domain', 'IPNS-like_FE2OG_OXY', 3, NULL),
(36349, NULL, 'IPR044792', NULL, 'Protein TAR1', 'TAR1', 4, NULL),
(36350, NULL, 'IPR045460', NULL, 'Wolframin, EF-hand domain', 'Wolframin_EF-hand', 3, NULL),
(36351, NULL, 'IPR044355', NULL, 'SF1 helicase, uncharacterised linker domain, tornidovirus', 'SF1_Hel_unc_tv', 3, NULL),
(36352, NULL, 'IPR044630', NULL, 'WD-repeat protein SPA1/2/3/4', 'SPA1/2/3/4', 4, NULL),
(36353, NULL, 'IPR045793', NULL, 'YetA-like protein', 'YetA', 4, NULL),
(36354, NULL, 'IPR044248', NULL, 'Diphthamide biosynthesis protein 3/4-like', 'DPH3/4-like', 4, NULL),
(36355, NULL, 'IPR042177', NULL, 'Cell/Rod shape-determining protein MreC, domain 1', 'Cell/Rod_1', 5, NULL),
(36356, NULL, 'IPR044386', NULL, 'Non-structural protein 2, bat coronavirus HKU9-like', 'NSP2_HKU9-like', 3, NULL),
(36357, NULL, 'IPR045601', NULL, 'Domain of unknown function DUF6455', 'DUF6455', 3, NULL),
(36358, NULL, 'IPR045759', NULL, 'Ap4A phosphorylase 1/2, N-terminal domain', 'Ap4A_phos1/2_N', 3, NULL),
(36359, NULL, 'IPR044832', NULL, 'DCD domain-containing protein NRP-like', 'NRP-like', 4, NULL),
(36360, NULL, 'IPR044361', NULL, 'M matrix/glycoprotein,  SARS-CoV-like', 'M_SARS-like-CoV', 4, NULL),
(36361, NULL, 'IPR044296', NULL, 'Heavy metal-associated isoprenylated plant protein 16/46', 'HIPP16/46', 4, NULL),
(36362, NULL, 'IPR044649', NULL, '2-methyl-6-phytyl-1,4-hydroquinone methyltransferase', 'MPBQ/MSBQ_MT', 4, NULL),
(36363, NULL, 'IPR044822', NULL, 'Myb/SANT-like DNA-binding domain 4', 'Myb_DNA-bind_4', 3, NULL),
(36364, NULL, 'IPR045660', NULL, 'Protein of unknown function DUF6390', 'DUF6390', 4, NULL),
(36365, NULL, 'IPR045841', NULL, 'E3 ubiquitin-protein ligase UBR4, N-terminal', 'E3_UBR4_N', 3, NULL),
(36366, NULL, 'IPR045716', NULL, 'Chordin-like protein 1/2, C-terminal', 'CHRDL_1/2_C', 3, NULL),
(36367, NULL, 'IPR045839', NULL, 'Mgp-operon protein 3, C-terminal domain', 'MGP3_C', 3, NULL),
(36368, NULL, 'IPR044600', NULL, 'RING-H2 finger protein ATL1/ATL16-like', 'ATL1/ATL16-like', 4, NULL),
(36369, NULL, 'IPR045844', NULL, 'Ist3-like, RNA recognition motif', 'RRM_Ist3-like', 3, NULL),
(36370, NULL, 'IPR044236', NULL, 'Glycerophosphodiester phosphodiesterase GDPD4', 'GDPD4', 4, NULL),
(36371, NULL, 'IPR045321', NULL, 'Chitinase Cts1-like', 'Cts1-like', 3, NULL),
(36372, NULL, 'IPR045204', NULL, 'Laforin-like, dual specificity phosphatase domain', 'DSP_laforin-like', 3, NULL),
(36373, NULL, 'IPR045635', NULL, 'Protein of unknown function DUF6412', 'DUF6412', 4, NULL),
(36374, NULL, 'IPR045571', NULL, 'Repeat of unknown function DUF5907', 'DUF5907', 7, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(36375, NULL, 'IPR044916', NULL, 'Short tail fibre protein, C-terminal superfamily', 'Short_tail_fibre_C_sf', 5, NULL),
(36376, NULL, 'IPR043009', NULL, 'LOR/SDH bifunctional enzyme, conserved domain superfamily', 'LOR/SDH_bifunc_enz_cons_dom_sf', 5, NULL),
(36377, NULL, 'IPR043210', NULL, 'CD44 antigen-like', 'CD44_antigen-like', 4, NULL),
(36378, NULL, 'IPR045709', NULL, 'Protein of unknown function DUF6065', 'DUF6065', 4, NULL),
(36379, NULL, 'IPR045888', NULL, 'Endoplasmic reticulum vesicle transporter', 'Erv', 4, NULL),
(36380, NULL, 'IPR043299', NULL, 'Protein LRATD1/ LRATD2', 'LRATD1_LRATD2', 4, NULL),
(36381, NULL, 'IPR042345', NULL, 'BTB/POZ domain-containing protein 7', 'Btbd7', 4, NULL),
(36382, NULL, 'IPR042336', NULL, 'Golgi integral membrane protein 4', 'GOLIM4', 4, NULL),
(36383, NULL, 'IPR044605', NULL, 'Pentatricopeptide repeat-containing protein At1g26460-like', 'At1g26460-like', 4, NULL),
(36384, NULL, 'IPR044278', NULL, 'Transcription factor BHLH95-like', 'BHLH95-like', 4, NULL),
(36385, NULL, 'IPR045577', NULL, 'Sentrin-specific protease 3/5, conserved domain', 'SENP3_5_cons_dom', 3, NULL),
(36386, NULL, 'IPR045680', NULL, 'Protein of unknown function DUF6200', 'DUF6200', 4, NULL),
(36387, NULL, 'IPR042343', NULL, 'Protein BANP', 'BANP', 4, NULL),
(36388, NULL, 'IPR044396', NULL, 'SF1 helicase, uncharacterized domain, ronidovirus-like', 'SF1_Hel_unc_rv-like', 3, NULL),
(36389, NULL, 'IPR043111', NULL, 'JBP1, DNA-binding domain superfamily', 'DB_JBP1_sf', 5, NULL),
(36390, NULL, 'IPR044636', NULL, 'Transcription factor RADIALIS-like', 'RADIALIS-like', 4, NULL),
(36391, NULL, 'IPR043014', NULL, 'Nibrin, second BRCT domain superfamily', 'Nibrin_BRCT2_sf', 5, NULL),
(36392, NULL, 'IPR045747', NULL, 'CRISPR-associated protein Cas6, N-terminal domain superfamily', 'CRISPR-assoc_prot_Cas6_N_sf', 5, NULL),
(36393, NULL, 'IPR043826', NULL, 'Protein of unknown function DUF5803', 'DUF5803', 4, NULL),
(36394, NULL, 'IPR042337', NULL, 'Genetic suppressor element 1', 'GSE1', 4, NULL),
(36395, NULL, 'IPR045588', NULL, 'Calsyntenin, C-terminal', 'CLSTN_C', 3, NULL),
(36396, NULL, 'IPR045592', NULL, 'Protein of unknown function DUF6461', 'DUF6461', 4, NULL),
(36397, NULL, 'IPR044809', NULL, 'F-box protein AUF1-like', 'AUF1-like', 4, NULL),
(36398, NULL, 'IPR045827', NULL, 'Deubiquitinating protein VCPIP1, N-terminal', 'VCPIP1_N', 3, NULL),
(36399, NULL, 'IPR044556', NULL, 'Endonuclease II-like, GIY-YIG domain', 'EndoII-like_GIY-YIG', 3, NULL),
(36400, NULL, 'IPR044368', NULL, 'Non-structural protein 6, gammacoronavirus', 'NSP6_gammaCoV', 3, NULL),
(36401, NULL, 'IPR045210', NULL, 'PUB protein, U-box domain, plant', 'RING-Ubox_PUB', 3, NULL),
(36402, NULL, 'IPR045652', NULL, 'Protein of unknown function DUF6397', 'DUF6397', 4, NULL),
(36403, NULL, 'IPR044362', NULL, 'M matrix/glycoprotein, HCoV-like', 'M_HCoV-like', 4, NULL),
(36404, NULL, 'IPR044292', NULL, 'Regulatory protein NPR', 'NPR', 4, NULL),
(36405, NULL, 'IPR043068', NULL, 'Uracil DNA glycosylase inhibitor superfamily', 'SAUGI_sf', 5, NULL),
(36406, NULL, 'IPR045847', NULL, 'Transcription factor AIG1-like', 'AIG1-like', 4, NULL),
(36407, NULL, 'IPR044449', NULL, 'Rnt1/Pac1, double-stranded RNA binding domain, fungi', 'Rnt1/Pac1_DSRM_fungi', 3, NULL),
(36408, NULL, 'IPR045213', NULL, 'Malic enzyme, NAD-binding domain, bacterial type', 'Malic_NAD-bd_bact_type', 3, NULL),
(36409, NULL, 'IPR042773', NULL, 'Protease-associated domain-containing protein 1', 'PADC1', 4, NULL),
(36410, NULL, 'IPR045209', NULL, 'rRNA biogenesis protein Rrp5', 'Rrp5', 4, NULL),
(36411, NULL, 'IPR044417', NULL, 'PRDM7/PRDM9, PR/SET domain', 'PRDM7_9_PR-SET', 3, NULL),
(36412, NULL, 'IPR044404', NULL, 'PRDM4, PR/SET domain', 'PRDM4_PR/SET', 3, NULL),
(36413, NULL, 'IPR044464', NULL, 'Staufen 2, second double-stranded RNA binding domain', 'STAU2_DSRM_2', 3, NULL),
(36414, NULL, 'IPR045465', NULL, 'Domain of unknown function DUF6499', 'DUF6499', 3, NULL),
(36415, NULL, 'IPR044872', NULL, 'CcmK/CsoS1, bacterial microcompartment domain', 'CcmK/CsoS1_BMC', 3, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(36416, NULL, 'IPR042236', NULL, 'Phosphoinositide 3-kinase, accessory (PIK) domain superfamily', 'PI3K_accessory_sf', 5, NULL),
(36417, NULL, 'IPR045626', NULL, 'D-3-phosphoglycerate dehydrogenase, ASB domain', 'PGDH_ASB_dom', 3, NULL),
(36418, NULL, 'IPR044887', NULL, 'Putative substrate of the Dot/Icm secretion system superfamily', 'SoDot-IcmSS_sf', 5, NULL),
(36419, NULL, 'IPR042930', NULL, 'Cystatin-11', 'CST11', 4, NULL),
(36420, NULL, 'IPR044561', NULL, 'L-threonine ammonia-lyase, ACT domain', 'ACT_ThrD-II-like', 3, NULL),
(36421, NULL, 'IPR045561', NULL, 'Neuromedin-U receptor 2, C-terminal domain', 'NMU-R2_C', 3, NULL),
(36422, NULL, 'IPR044836', NULL, 'TOM1-like protein, plant', 'TOL_plant', 4, NULL),
(36423, NULL, 'IPR045567', NULL, 'CofH/MqnC-like, C-terminal domain', 'CofH/MnqC-like_C', 3, NULL),
(36424, NULL, 'IPR045658', NULL, 'FRAS1-related extracellular matrix protein, N-terminal domain', 'FRAS1-rel_N', 3, NULL),
(36425, NULL, 'IPR045848', NULL, 'YKT6, SNARE motif', 'R-SNARE_YKT6', 3, NULL),
(36426, NULL, 'IPR043005', NULL, 'MvaI/BcnI restriction endonuclease, recognition domain', 'MvaI_BcnI_rec', 5, NULL),
(36427, NULL, 'IPR043779', NULL, 'Protein of unknown function DUF5721', 'DUF5721', 4, NULL),
(36428, NULL, 'IPR043023', NULL, 'Major vault protein repeat domain superfamily', 'MVP_rep_sf', 5, NULL),
(36429, NULL, 'IPR045492', NULL, 'Domain of unknown function DUF6434', 'DUF6434', 3, NULL),
(36430, NULL, 'IPR045597', NULL, 'Domain of unknown function DUF6458', 'DUF6458', 3, NULL),
(36431, NULL, 'IPR045232', NULL, 'Protein FAM234', 'FAM234', 4, NULL),
(36432, NULL, 'IPR045883', NULL, 'Transmembrane protein At4g13530-like', 'At4g13530-like', 4, NULL),
(36433, NULL, 'IPR045332', NULL, 'ARMET, N-terminal', 'ARMET_N', 3, NULL),
(36434, NULL, 'IPR042769', NULL, 'SPATA6 family', 'SPATA6_fam', 4, NULL),
(36435, NULL, 'IPR044429', NULL, 'SETD4, SET domain', 'SETD4_SET', 3, NULL),
(36436, NULL, 'IPR045821', NULL, 'Beta-1,3-galactosyltransferase 2, N-terminal', 'B3GT2_N', 3, NULL),
(36437, NULL, 'IPR045330', NULL, 'Probable methyltransferase Trm3/TARBP1', 'Trm3/TARBP1', 4, NULL),
(36438, NULL, 'IPR045599', NULL, 'Domain of unknown function DUF6456', 'DUF6456', 3, NULL),
(36439, NULL, 'IPR044653', NULL, 'C2H2-type zinc-finger protein AZF1/2/3-like', 'AZF1/2/3-like', 4, NULL),
(36440, NULL, 'IPR043205', NULL, 'Cytochrome b561/Cytochrome b reductase 1-like', 'CYB561/CYBRD1-like', 4, NULL),
(36441, NULL, 'IPR044891', NULL, 'Histone chaperone Rtt106, N-terminal domain superfamily', 'Rtt106_N_sf', 5, NULL),
(36442, NULL, 'IPR044333', NULL, 'Accessory protein NS7a, deltacoronavirus, avian coronavirus HKU16-like', 'NS7a_deltaCoV_HKU16-like', 3, NULL),
(36443, NULL, 'IPR043112', NULL, 'TBP-interacting protein, C-terminal', 'TIP_C', 5, NULL),
(36444, NULL, 'IPR044571', NULL, 'Phosphatidylinositol 4-kinase gamma 1-8', 'P4KG1-8', 4, NULL),
(36445, NULL, 'IPR045784', NULL, 'Radical SAM domain-containing protein, N-terminal', 'Radical_SAM_N2', 3, NULL),
(36446, NULL, 'IPR043778', NULL, 'Domain of unknown function DUF5720', 'DUF5720', 3, NULL),
(36447, NULL, 'IPR045754', NULL, 'Protein of unknown function DUF6182', 'DUF6182', 4, NULL),
(36448, NULL, 'IPR045697', NULL, 'Domain of unknown function DUF5919', 'DUF5919', 3, NULL),
(36449, NULL, 'IPR044566', NULL, 'Polyamine transporter RMV1-like', 'RMV1-like', 4, NULL),
(36450, NULL, 'IPR044631', NULL, 'ETO1-like', 'ETO1-like', 4, NULL),
(36451, NULL, 'IPR045566', NULL, 'Putative endonuclease SegE, GIY-YIG domain', 'SegE_GIY-YIG', 3, NULL),
(36452, NULL, 'IPR044886', NULL, 'Folliculin, DENN domain, C-terminal superfamily', 'FLCN_DENN_C_sf', 5, NULL),
(36453, NULL, 'IPR045563', NULL, 'Domain of unknown function DUF5909', 'DUF5909', 3, NULL),
(36454, NULL, 'IPR043011', NULL, 'Bunyavirus nucleocapsid (N) , C-terminal domain', 'Bunya_nucleocap_C', 5, NULL),
(36455, NULL, 'IPR045673', NULL, 'Phenol-soluble modulin delta protein', 'PSM_delta', 4, NULL),
(36456, NULL, 'IPR045824', NULL, 'Type II secretion system protein TadB-like, N-terminal domain', 'T2SS_TadB-like_N', 3, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(36457, NULL, 'IPR045745', NULL, 'Helix-turn-helix domain, Actinobacteria-type', 'HTH_58_Actinobacteria-type', 3, NULL),
(36458, NULL, 'IPR042722', NULL, 'RelA-associated inhibitor, SH3 domain', 'SH3_iASPP', 3, NULL),
(36459, NULL, 'IPR045497', NULL, 'Domain of unknown function DUF6438', 'DUF6438', 3, NULL),
(36460, NULL, 'IPR045781', NULL, 'Saxitoxin biosynthesis operon protein SxtJ', 'SxtJ', 4, NULL),
(36461, NULL, 'IPR045675', NULL, 'Protein of unknown function DUF6195', 'DUF6195', 4, NULL),
(36462, NULL, 'IPR045646', NULL, 'Protein of unknown function DUF6402', 'DUF6402', 4, NULL),
(36463, NULL, 'IPR043016', NULL, 'IFT81, N-terminal domain superfamily', 'IFT81_N_sf', 5, NULL),
(36464, NULL, 'IPR042350', NULL, 'All-trans retinoic acid-induced differentiation factor', 'ATRAID', 4, NULL),
(36465, NULL, 'IPR045683', NULL, 'Protein of unknown function DUF6192', 'DUF6192', 4, NULL),
(36466, NULL, 'IPR044620', NULL, 'DnaJ protein P58IPK-like', 'P58IPK-like', 4, NULL),
(36467, NULL, 'IPR043113', NULL, 'LntA, helical domain', 'LntA_helix', 5, NULL),
(36468, NULL, 'IPR044645', NULL, 'Pentatricopeptide repeat-containing protein DG1/EMB2279-like', 'DG1/EMB2279-like', 4, NULL),
(36469, NULL, 'IPR043107', NULL, 'Fimbrillin-like, C-terminal', 'Mfa-like_2_C', 5, NULL),
(36470, NULL, 'IPR045887', NULL, 'Kelch repeat F-box protein SAGL1-like', 'SAGL1-like', 4, NULL),
(36471, NULL, 'IPR044853', NULL, 'IrrE, HTH domain', 'G3DSA:1.10.10.1030', 5, NULL),
(36472, NULL, 'IPR044298', NULL, 'Adenine/Thymine-DNA glycosylase', 'MIG/MutY', 4, NULL),
(36473, NULL, 'IPR043006', NULL, 'Cyanuric acid hydrolase/Barbiturase, repeating unit B', 'AtzD/Barbiturase_RUB', 5, NULL),
(36474, NULL, 'IPR045755', NULL, 'Bacteriodetes cell division protein FtsL-like', 'FtsL-like', 4, NULL),
(36475, NULL, 'IPR044261', NULL, 'Pyruvate dehydrogenase [ubiquinone] PoxB-like', 'PoxB-like', 4, NULL),
(36476, NULL, 'IPR044319', NULL, 'Non-structural protein 3c (NS3c), bat coronavirus HKU4-like', 'ORF4b_HKU4-CoV', 4, NULL),
(36477, NULL, 'IPR045650', NULL, 'Protein of unknown function DUF6399', 'DUF6399', 4, NULL),
(36478, NULL, 'IPR044140', NULL, 'Proline--tRNA ligase, anticodon binding domain', 'ProRS_anticodon_short', 3, NULL),
(36479, NULL, 'IPR045221', NULL, 'Sphingomyelin synthase-like', 'Sphingomyelin_synth-like', 4, NULL),
(36480, NULL, 'IPR044910', NULL, 'TM_1086, SG structure domain', 'TM_1086_SG_dom', 5, NULL),
(36481, NULL, 'IPR042936', NULL, 'Nuclear hormone receptor family member nhr-150', 'Nhr-150', 4, NULL),
(36482, NULL, 'IPR045707', NULL, 'Protein of unknown function DUF6063', 'DUF6063', 4, NULL),
(36483, NULL, 'IPR044252', NULL, '60S acidic ribosomal protein P3-like', 'RPP3A/B', 4, NULL),
(36484, NULL, 'IPR044406', NULL, 'PRDM12, PR/SET domain', 'PRDM12_PR/SET', 3, NULL),
(36485, NULL, 'IPR045688', NULL, 'Ets1, N-terminal flanking region of Ets domain', 'Ets1_N_flank', 3, NULL),
(36486, NULL, 'IPR045798', NULL, 'TrbL/VirB6 plasmid conjugal transfer like protein, Firmicutes', 'TrbL_Firmicutes', 4, NULL),
(36487, NULL, 'IPR044303', NULL, 'Zinc finger protein ZAT1/4/9', 'ZAT1/4/9', 4, NULL),
(36488, NULL, 'IPR044394', NULL, 'Structural accessory protein ORF7b, SARS-CoV-like', 'ORF7b_SARS-CoV-like', 4, NULL),
(36489, NULL, 'IPR045518', NULL, '2EXR domain', '2EXR', 3, NULL),
(36490, NULL, 'IPR044787', NULL, 'Myb family transcription factor HRS1-like', 'HRS1-like', 4, NULL),
(36491, NULL, 'IPR044682', NULL, 'Violaxanthin de-epoxidase', 'VDE', 4, NULL),
(36492, NULL, 'IPR045711', NULL, 'Glycoside hydrolase 123, N-terminal domain', 'GH123_N', 3, NULL),
(36493, NULL, 'IPR044576', NULL, 'Receptor-like serine/threonine-protein kinase At4g25390-like', 'At4g25390-like', 4, NULL),
(36494, NULL, 'IPR045699', NULL, 'Galactofuranosyltransferase-2, C-terminal', 'GlfT2_C', 3, NULL),
(36495, NULL, 'IPR044871', NULL, 'Structural accessory protein ORF7a, SARS-CoV-like, X4e domain', 'ORF7a_SARS-CoV-like_X4e', 3, NULL),
(36496, NULL, 'IPR045558', NULL, 'Protein of unknown function DUF6317', 'DUF6317', 4, NULL),
(36497, NULL, 'IPR045714', NULL, 'Protein of unknown function DUF6070', 'DUF6070', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(36498, NULL, 'IPR044842', NULL, 'RNA demethylase ALKBH9B/ALKBH10B-like', 'ALKBH9B/ALKBH10B-like', 4, NULL),
(36499, NULL, 'IPR045763', NULL, 'BTB/POZ domain-containing protein KCTD11/21, C-terminal domain', 'KCTD11/21_C', 3, NULL),
(36500, NULL, 'IPR044301', NULL, 'Pathogenesis-related protein-4', 'PR4', 4, NULL),
(36501, NULL, 'IPR046054', NULL, 'Protein of unknown function DUF6012', 'DUF6012', 4, NULL),
(36502, NULL, 'IPR045957', NULL, 'Domain of unknown function DUF6377', 'DUF6377', 3, NULL),
(36503, NULL, 'IPR045874', NULL, 'Rust resistance kinase Lr10', 'LRK10-like', 4, NULL),
(36504, NULL, 'IPR046072', NULL, 'Protein of unknown function DUF6031', 'DUF6031', 4, NULL),
(36505, NULL, 'IPR045905', NULL, 'Receptor-type tyrosine-protein phosphatase delta, PTPase domain, repeat 1', 'R-PTP-delta_cat', 3, NULL),
(36506, NULL, 'IPR042490', NULL, 'Acyl-CoA thioester hydrolase/BAAT, N-terminal', 'Thio_Ohase/BAAT_N', 5, NULL),
(36507, NULL, 'IPR043114', NULL, 'T26-6p, C-terminal', 'T26-6p_C', 5, NULL),
(36508, NULL, 'IPR045141', NULL, 'N-alpha-acetyltransferase 60-like', 'NAA60-like', 4, NULL),
(36509, NULL, 'IPR044398', NULL, 'Globin-sensor domain', 'Globin-sensor_dom', 3, NULL),
(36510, NULL, 'IPR045138', NULL, 'Methyl-CpG binding protein MeCP2/MBD4', 'MeCP2/MBD4', 4, NULL),
(36511, NULL, 'IPR045122', NULL, 'Calcium permeable stress-gated cation channel 1-like', 'Csc1-like', 4, NULL),
(36512, NULL, 'IPR042356', NULL, 'Claudin domain-containing protein 1', 'CLDN1', 4, NULL),
(36513, NULL, 'IPR045930', NULL, 'Protein of unknown function DUF6349', 'DUF6349', 4, NULL),
(36514, NULL, 'IPR044153', NULL, 'Pae0151-like, PIN domain', 'PIN_Pae0151-like', 3, NULL),
(36515, NULL, 'IPR045165', NULL, 'Nitrobindin family', 'Nitrobindin', 4, NULL),
(36516, NULL, 'IPR045971', NULL, 'Domain of unknown function DUF5927', 'DUF5927', 3, NULL),
(36517, NULL, 'IPR042308', NULL, 'Helper-component proteinase (HC-Pro) cysteine protease (CPD) domain superfamily', 'HC_PRO_CPD_sf', 5, NULL),
(36518, NULL, 'IPR044989', NULL, 'Protein TILLER ANGLE CONTROL 1', 'TAC1', 4, NULL),
(36519, NULL, 'IPR044827', NULL, 'G-box-binding factor-like', 'GBF-like', 4, NULL),
(36520, NULL, 'IPR045965', NULL, 'Domain of unknown function DUF6385', 'DUF6385', 3, NULL),
(36521, NULL, 'IPR044949', NULL, 'Inner capsid protein lambda-1/ VP3', 'Lambda-1/VP3', 5, NULL),
(36522, NULL, 'IPR042716', NULL, 'E3 ubiquitin-protein ligase RNF114, RING finger, HC subclass', 'RNF114_RING-HC', 3, NULL),
(36523, NULL, 'IPR045892', NULL, 'Prolycopene isomerase-like', 'CrtISO-like', 4, NULL),
(36524, NULL, 'IPR045925', NULL, 'Protein of unknown function DUF6344', 'DUF6344', 4, NULL),
(36525, NULL, 'IPR045093', NULL, 'Cullin', 'Cullin', 4, NULL),
(36526, NULL, 'IPR045129', NULL, 'E3 ubiquitin-protein ligase RNF123/RSPRY1-like', 'RNF123/RSPRY1-like', 4, NULL),
(36527, NULL, 'IPR042509', NULL, 'Zinc finger CCHC domain-containing protein 3', 'ZCCHC3', 4, NULL),
(36528, NULL, 'IPR042432', NULL, 'Cytochrome c oxidase assembly factor 1, fungi', 'Coa1_fungi', 4, NULL),
(36529, NULL, 'IPR046062', NULL, 'Protein of unknown function DUF6020', 'DUF6020', 4, NULL),
(36530, NULL, 'IPR046069', NULL, 'Protein of unknown function DUF6027', 'DUF6027', 4, NULL),
(36531, NULL, 'IPR045164', NULL, 'RNA-binding region-containing protein RBM41/RNPC3', 'RBM41/RNPC3', 4, NULL),
(36532, NULL, 'IPR042487', NULL, 'RuvBL1/2, DNA/RNA binding domain', 'RuvBL1/2_DNA/RNA_bd_dom', 5, NULL),
(36533, NULL, 'IPR045962', NULL, 'Protein of unknown function DUF6382', 'DUF6382', 3, NULL),
(36534, NULL, 'IPR046021', NULL, 'Protein of unknown function DUF5978', 'DUF5978', 3, NULL),
(36535, NULL, 'IPR042486', NULL, 'Arabinosyltransferase, C-terminal, subdomain 2', 'Arabino_trans_C_2', 5, NULL),
(36536, NULL, 'IPR046407', NULL, 'Carboxylic acid reductase', 'CAR', 4, NULL),
(36537, NULL, 'IPR042381', NULL, 'T-cell surface protein tactile', 'CD96', 4, NULL),
(36538, NULL, 'IPR046006', NULL, 'Protein of unknown function DUF5962', 'DUF5962', 4, NULL),
(36539, NULL, 'IPR046893', NULL, 'MutS2 and Smr-associated SH3 domain', 'MSSS', 3, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(36540, NULL, 'IPR046000', NULL, 'Protein of unknown function DUF5956', 'DUF5956', 4, NULL),
(36541, NULL, 'IPR044928', NULL, 'Secreted effector protein SifA, C-terminal domain superfamily', 'SifA_C_sf', 5, NULL),
(36542, NULL, 'IPR045912', NULL, 'Forkhead box protein J2/3-like', 'FOXJ2/3-like', 4, NULL),
(36543, NULL, 'IPR045157', NULL, 'CagA, N-terminal', 'CagA_N', 3, NULL),
(36544, NULL, 'IPR046051', NULL, 'Protein of unknown function DUF6009', 'DUF6009', 4, NULL),
(36545, NULL, 'IPR046094', NULL, 'Protein of unknown function DUF6112', 'DUF6112', 4, NULL),
(36546, NULL, 'IPR042504', NULL, 'E2 regulatory, transactivation domain, subdomain 2', 'Regulatory_protein_E2_N_2', 5, NULL),
(36547, NULL, 'IPR045001', NULL, 'Developmentally regulated GTP-binding protein', 'DRG', 4, NULL),
(36548, NULL, 'IPR045921', NULL, 'Protein of unknown function DUF6340', 'DUF6340', 4, NULL),
(36549, NULL, 'IPR046038', NULL, 'Protein of unknown function DUF5996', 'DUF5996', 4, NULL),
(36550, NULL, 'IPR045902', NULL, 'SANBR-like', 'SANBR-like', 4, NULL),
(36551, NULL, 'IPR046097', NULL, 'Protein of unknown function DUF6033', 'DUF6033', 4, NULL),
(36552, NULL, 'IPR044189', NULL, 'Exportin 4/7-like', 'XPO4/7-like', 4, NULL),
(36553, NULL, 'IPR045935', NULL, 'Protein of unknown function DUF6355', 'DUF6355', 4, NULL),
(36554, NULL, 'IPR044991', NULL, 'Tetraspani, plant', 'TET_plant', 4, NULL),
(36555, NULL, 'IPR045998', NULL, 'Protein of unknown function DUF5954', 'DUF5954', 4, NULL),
(36556, NULL, 'IPR044962', NULL, 'CLV3/ESR signal peptide family', 'CLV3/ESR', 4, NULL),
(36557, NULL, 'IPR046819', NULL, 'MmeI-like, helicase spacer domain', 'MmeI_hel', 3, NULL),
(36558, NULL, 'IPR044393', NULL, 'ORF8,  bat SARS coronavirus HKU3-1-like', 'ORF8_bat_SARS-CoV_HKU3-1-like', 4, NULL),
(36559, NULL, 'IPR046091', NULL, 'Protein of unknown function DUF6109', 'DUF6109', 4, NULL),
(36560, NULL, 'IPR045143', NULL, 'Kinetochore protein Spc25', 'Spc25', 4, NULL),
(36561, NULL, 'IPR045985', NULL, 'Domain of unknown function DUF5941', 'DUF5941', 3, NULL),
(36562, NULL, 'IPR042341', NULL, 'B-lymphocyte antigen CD19', 'CD19', 4, NULL),
(36563, NULL, 'IPR045124', NULL, 'Protein suppressor of sable-like', 'Su(sable)-like', 4, NULL),
(36564, NULL, 'IPR045982', NULL, 'Domain of unknown function DUF5938', 'DUF5938', 3, NULL),
(36565, NULL, 'IPR045981', NULL, 'Domin of unknown function DUF5937', 'DUF5937', 3, NULL),
(36566, NULL, 'IPR045075', NULL, 'Pre-mRNA-splicing factor Syf1-like', 'Syf1-like', 4, NULL),
(36567, NULL, 'IPR044182', NULL, 'Thioredoxin-like protein CITRX, chloroplastic', 'CITRX', 4, NULL),
(36568, NULL, 'IPR045929', NULL, 'Protein of unknown function DUF6348', 'DUF6348', 4, NULL),
(36569, NULL, 'IPR044378', NULL, 'Spike (S) protein S1 subunit, receptor-binding domain, HKU4-like', 'Spike_S1_RBD_HKU4-like', 3, NULL),
(36570, NULL, 'IPR046427', NULL, 'Legumain prodomain superfamily', 'Legumain_prodom_sf', 5, NULL),
(36571, NULL, 'IPR045954', NULL, 'Protein of unknown function DUF6374', 'DUF6374', 4, NULL),
(36572, NULL, 'IPR045947', NULL, 'Protein of unknown function DUF6367', 'DUF6367', 4, NULL),
(36573, NULL, 'IPR042189', NULL, 'Sigma-70 factor, region 1.1 superfamily', 'RNA_pol_sigma_70_r1_1_sf', 5, NULL),
(36574, NULL, 'IPR045916', NULL, 'Domain of unknown function DUF5777', 'DUF5777', 3, NULL),
(36575, NULL, 'IPR045932', NULL, 'Protein of unknown function DUF6352', 'DUF6352', 4, NULL),
(36576, NULL, 'IPR046003', NULL, 'Protein of unknown function DUF5959', 'DUF5959', 4, NULL),
(36577, NULL, 'IPR045153', NULL, 'Est1/Ebs1-like', 'Est1/Ebs1-like', 4, NULL),
(36578, NULL, 'IPR042342', NULL, 'Tetratricopeptide repeat protein 22', 'TTC22', 4, NULL),
(36579, NULL, 'IPR045974', NULL, 'Domain of unknown function DUF5930', 'DUF5930', 3, NULL),
(36580, NULL, 'IPR044993', NULL, 'Beta-D-xylosidase', 'BXL', 4, NULL),
(36581, NULL, 'IPR046043', NULL, 'Protein of unknown function DUF6001', 'DUF6001', 4, NULL),
(36582, NULL, 'IPR046034', NULL, 'Protein of unknown function DUF5992', 'DUF5992', 4, NULL),
(36583, NULL, 'IPR046027', NULL, 'Protein of unknown function DUF5985', 'DUF5985', 4, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(36584, NULL, 'IPR044516', NULL, 'UDP-glucuronic acid decarboxylase', 'UXS', 4, NULL),
(36585, NULL, 'IPR045135', NULL, '26S proteasome regulatory subunit Rpn7, N-terminal', 'Rpn7_N', 3, NULL),
(36586, NULL, 'IPR042380', NULL, 'Tumor necrosis factor ligand superfamily member 18', 'TNFSF18', 4, NULL),
(36587, NULL, 'IPR046462', NULL, 'Terminase large subunit-like, endonuclease domain', 'TerL_nuclease', 3, NULL),
(36588, NULL, 'IPR042403', NULL, 'Spt21/Ams2', 'Spt21/Ams2', 4, NULL),
(36589, NULL, 'IPR044924', NULL, 'HAD-superfamily hydrolase, subfamily IA, REG-2-like, capping domain superfamily', 'HAD-SF_hydro_IA_REG-2-like_cap', 5, NULL),
(36590, NULL, 'IPR045096', NULL, 'Protein ENHANCED DISEASE RESISTANCE 2-like', 'EDR2-like', 4, NULL),
(36591, NULL, 'IPR042358', NULL, 'Filensin', 'BFSP1', 4, NULL),
(36592, NULL, 'IPR045136', NULL, 'Isoamyl acetate-hydrolyzing esterase Iah1-like', 'Iah1-like', 4, NULL),
(36593, NULL, 'IPR044929', NULL, 'DNA/RNA non-specific endonuclease superfamily', 'DNA/RNA_non-sp_Endonuclease_sf', 5, NULL),
(36594, NULL, 'IPR045994', NULL, 'Protein of unknown function DUF5950', 'DUF5950', 4, NULL),
(36595, NULL, 'IPR045063', NULL, 'Dynamin, N-terminal', 'Dynamin_N', 3, NULL),
(36596, NULL, 'IPR046011', NULL, 'Protein of unknown function DUF5967', 'DUF5967', 4, NULL),
(36597, NULL, 'IPR044997', NULL, 'F-box protein, plant', 'F-box_plant', 4, NULL),
(36598, NULL, 'IPR042374', NULL, 'CD70 antigen', 'CD70', 4, NULL),
(36599, NULL, 'IPR042817', NULL, 'Serine/threonine-protein kinase LMTK1, catalytic domain', 'LMTK1_c', 3, NULL),
(36600, NULL, 'IPR046435', NULL, 'NSP14, guanine-N7-methyltransferase domain, coronavirus', 'COV_N7_MTASE', 3, NULL),
(36601, NULL, 'IPR046035', NULL, 'Protein of unknown function DUF5993', 'DUF5993', 4, NULL),
(36602, NULL, 'IPR046086', NULL, 'Protein of unknown function DUF6104', 'DUF6104', 4, NULL),
(36603, NULL, 'IPR045203', NULL, 'RAN GTPase-activating protein 1/2', 'RanGAP1/2', 4, NULL),
(36604, NULL, 'IPR046100', NULL, 'Protein of unknown function DUF6037', 'DUF6037', 4, NULL),
(36605, NULL, 'IPR046885', NULL, 'tRNA-specific 2-thiouridylase MnmA-like, C-terminal domain', 'MnmA-like_C', 3, NULL),
(36606, NULL, 'IPR042543', NULL, 'S-adenosylmethionine synthetase, domain 2', 'AdoMet_synthase_2', 5, NULL),
(36607, NULL, 'IPR046469', NULL, 'S-adenosyl-l-methionine hydroxide adenosyltransferase, N-terminal domain', 'SAM_HAT_N', 3, NULL),
(36608, NULL, 'IPR045986', NULL, 'Domain of unknown function DUF5942', 'DUF5942', 3, NULL),
(36609, NULL, 'IPR044923', NULL, 'PolC, middle finger subdomain superfamily', 'PolC_middle_finger_sf', 5, NULL),
(36610, NULL, 'IPR045102', NULL, 'TPTE, protein tyrosine phosphatase-like catalytic domain', 'PTP_VSP_TPTE', 3, NULL),
(36611, NULL, 'IPR045942', NULL, 'Domain of unknown function DUF6362', 'DUF6362', 3, NULL),
(36612, NULL, 'IPR044932', NULL, 'Plasmodium falciparum erythrocyte membrane protein 1, acidic terminal segment superfamily', 'PfEMP1_ATS_sf', 5, NULL),
(36613, NULL, 'IPR046009', NULL, 'Protein of unknown function DUF5965', 'DUF5965', 4, NULL),
(36614, NULL, 'IPR045244', NULL, 'Phosphoglucomutase', 'PGM', 4, NULL),
(36615, NULL, 'IPR042816', NULL, 'Nuclear speckle splicing regulatory protein 1', 'Nsrp1', 4, NULL),
(36616, NULL, 'IPR045869', NULL, 'Bifunctional polymyxin resistance protein ArnA-like, extended (e) SDRs', 'Arna-like_SDR_e', 3, NULL),
(36617, NULL, 'IPR045955', NULL, 'Protein of unknown function DUF6375', 'DUF6375', 4, NULL),
(36618, NULL, 'IPR045002', NULL, 'Delta(3,5)-Delta(2,4)-dienoyl-CoA isomerase Ech1-like', 'Ech1-like', 4, NULL),
(36619, NULL, 'IPR046016', NULL, 'Protein of unknown function DUF5973', 'DUF5973', 4, NULL),
(36620, NULL, 'IPR042506', NULL, 'IQ domain-containing protein C', 'IQCC', 4, NULL),
(36621, NULL, 'IPR045052', NULL, 'Copine', 'Copine', 4, NULL),
(36622, NULL, 'IPR042488', NULL, 'Rad4, beta-hairpin domain 3 superfamily', 'Rad4_BHD3_sf', 5, NULL),
(36623, NULL, 'IPR046037', NULL, 'Protein of unknown function DUF5995', 'DUF5995', 4, NULL),
(36624, NULL, 'IPR046328', NULL, 'ETS family', 'ETS_fam', 4, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(36625, NULL, 'IPR046095', NULL, 'Protein of unknown function DUF6113', 'DUF6113', 4, NULL),
(36626, NULL, 'IPR046047', NULL, 'Protein of unknown function DUF6005', 'DUF6005', 4, NULL),
(36627, NULL, 'IPR043324', NULL, 'PKHG1/2/3, pleckstrin homology (PH) domain', 'PH_PLEKHG1_G2_G3', 3, NULL),
(36628, NULL, 'IPR044971', NULL, 'Stress enhanced protein 1/2, chloroplastic', 'SEP1/2', 4, NULL),
(36629, NULL, 'IPR045163', NULL, 'Focadhesin/RST1', 'Focadhesin/RST1', 4, NULL),
(36630, NULL, 'IPR046060', NULL, 'Protein of unknown function DUF6018', 'DUF6018', 4, NULL),
(36631, NULL, 'IPR046075', NULL, 'Protein of unknown function DUF6093', 'DUF6093', 4, NULL),
(36632, NULL, 'IPR042379', NULL, 'Programmed cell death protein 1', 'PDCD1', 4, NULL),
(36633, NULL, 'IPR046103', NULL, 'Protein of unknown function DUF6040', 'DUF6040', 4, NULL),
(36634, NULL, 'IPR045161', NULL, 'U3 small nucleolar RNA-associated protein 18', 'Utp18', 4, NULL),
(36635, NULL, 'IPR042384', NULL, 'Neuromedin-U', 'NMU', 4, NULL),
(36636, NULL, 'IPR045091', NULL, 'Mad2-like', 'Mad2-like', 4, NULL),
(36637, NULL, 'IPR045137', NULL, 'RNA-binding protein 26/27', 'RBM26/27', 4, NULL),
(36638, NULL, 'IPR045237', NULL, 'Eukaryotic translation initiation factor 3 subunit M eIF3m/COP9 signalosome complex subunit 7 COPS7', 'COPS7/eIF3m', 4, NULL),
(36639, NULL, 'IPR045995', NULL, 'Protein of unknown function DUF5951', 'DUF5951', 4, NULL),
(36640, NULL, 'IPR045958', NULL, 'Domain of unknown function DUF6378', 'DUF6378', 3, NULL),
(36641, NULL, 'IPR046352', NULL, 'Myotubularin-related protein 3, phosphatase domain', 'MTMR3_Pase_dom', 3, NULL),
(36642, NULL, 'IPR046071', NULL, 'Protein of unknown function DUF6030', 'DUF6030', 4, NULL),
(36643, NULL, 'IPR042499', NULL, 'Rubella membrane glycoprotein E1, domain 3', 'Rubella_E1_3', 5, NULL),
(36644, NULL, 'IPR045159', NULL, 'WD repeat-containing protein DCAF7-like', 'DCAF7-like', 4, NULL),
(36645, NULL, 'IPR042371', NULL, 'Z-binding domain', 'Z_dom', 3, NULL),
(36646, NULL, 'IPR044919', NULL, 'HP0184-like superfamily', 'HP0184-like_sf', 5, NULL),
(36647, NULL, 'IPR046794', NULL, 'Anaphase-promoting complex subunit 1, middle domain', 'Apc1_MidN', 3, NULL),
(36648, NULL, 'IPR045940', NULL, 'Protein of unknown function DUF6360', 'DUF6360', 4, NULL),
(36649, NULL, 'IPR044941', NULL, 'Ethanolamine ammonia-lyase heavy chain, N-terminal domain', 'EutB_N_sf', 5, NULL),
(36650, NULL, 'IPR046045', NULL, 'Protein of unknown function DUF6003', 'DUF6003', 4, NULL),
(36651, NULL, 'IPR043094', NULL, 'Nab2/ZC3H14, N-terminal domain superfamily', 'Nab2/ZC3H14_N_sf', 5, NULL),
(36652, NULL, 'IPR045072', NULL, 'MKRN-like', 'MKRN-like', 4, NULL),
(36653, NULL, 'IPR042938', NULL, 'Phosphatidylinositol transfer protein Sfh5', 'Sfh5', 4, NULL),
(36654, NULL, 'IPR044514', NULL, 'Vernalization insensitive 3-like', 'VIN3-like', 4, NULL),
(36655, NULL, 'IPR045926', NULL, 'Protein of unknown function DUF6345', 'DUF6345', 4, NULL),
(36656, NULL, 'IPR046057', NULL, 'Protein of unknown function DUF6015', 'DUF6015', 4, NULL),
(36657, NULL, 'IPR045131', NULL, 'CDGSH iron-sulfur domain-containing protein 1/2', 'CISD1/2', 4, NULL),
(36658, NULL, 'IPR045170', NULL, 'MTOX family', 'MTOX', 4, NULL),
(36659, NULL, 'IPR043383', NULL, 'Reprimo family', 'Reprimo_fam', 4, NULL),
(36660, NULL, 'IPR046070', NULL, 'Protein of unknown function DUF6029', 'DUF6029', 4, NULL),
(36661, NULL, 'IPR046438', NULL, 'Nidovirus 2-O-methyltransferase', 'NIV_2_O_MTASE', 3, NULL),
(36662, NULL, 'IPR046015', NULL, 'Protein of unknown function DUF5972', 'DUF5972', 4, NULL),
(36663, NULL, 'IPR045156', NULL, 'Vacuolar protein 8', 'Vac8', 4, NULL),
(36664, NULL, 'IPR046040', NULL, 'Protein of unknown function DUF5998', 'DUF5998', 4, NULL),
(36665, NULL, 'IPR042501', NULL, 'MukB, hinge domain superfamily', 'MukB_hinge_sf', 5, NULL),
(36666, NULL, 'IPR042309', NULL, 'Pestivirus envelope glycoprotein E2, domain A', 'Pestivirus_E2_A', 5, NULL),
(36667, NULL, 'IPR046073', NULL, 'Protein of unknown function DUF6032', 'DUF6032', 4, NULL),
(36668, NULL, 'IPR042385', NULL, 'CD160 ANTIGEN', 'CD160', 4, NULL); 
INSERT INTO "PUBLIC"."ENTRY" VALUES
(36669, NULL, 'IPR044917', NULL, 'DNA-directed primase/polymerase protein', 'PRIMPOL', 4, NULL),
(36670, NULL, 'IPR045928', NULL, 'Protein of unknown function DUF6347', 'DUF6347', 4, NULL),
(36671, NULL, 'IPR042411', NULL, 'WD repeat-containing protein 27', 'WDR27', 4, NULL),
(36672, NULL, 'IPR044930', NULL, 'Homing endonuclease, His-Me finger superfamily', 'Homing_endonuclease_His-Me', 5, NULL),
(36673, NULL, 'IPR042819', NULL, 'EphB1 , SAM domain', 'EphB1_SAM', 3, NULL),
(36674, NULL, 'IPR042718', NULL, 'Serine/threonine-protein kinase MRCK beta, catalytic domain', 'MRCKB_STKc', 3, NULL),
(36675, NULL, 'IPR045145', NULL, 'Chromatin assembly factor 1 subunit Cac2/CHAF1B/FAS2', 'PTHR15271', 4, NULL),
(36676, NULL, 'IPR042412', NULL, 'Homeobox protein prophet of Pit-1', 'PROP1', 4, NULL),
(36677, NULL, 'IPR044927', NULL, 'Type VII secretion system protein  EssD-like', 'Endonuclea_NS_2', 3, NULL),
(36678, NULL, 'IPR046002', NULL, 'Protein of unknown function DUF5958', 'DUF5958', 4, NULL),
(36679, NULL, 'IPR046032', NULL, 'Protein of unknown function DUF5990', 'DUF5990', 4, NULL),
(36680, NULL, 'IPR046066', NULL, 'Protein of unknown function DUF6024', 'DUF6024', 4, NULL),
(36681, NULL, 'IPR045089', NULL, 'Prenyltransferase subunit beta', 'PGGT1B-like', 4, NULL),
(36682, NULL, 'IPR046031', NULL, 'Protein of unknown function DUF5989', 'DUF5989', 4, NULL),
(36683, NULL, 'IPR042489', NULL, 'F-actin capping protein, alpha subunit, domain 1', 'CapZ_alpha_1', 5, NULL),
(36684, NULL, 'IPR044166', NULL, 'Ferredoxin-thioredoxin reductase, variable chain', 'FTRV', 4, NULL),
(36685, NULL, 'IPR044939', NULL, 'Ethanolamine ammonia-lyase heavy chain, domain 2', 'EutB_dom_2_sf', 5, NULL),
(36686, NULL, 'IPR045176', NULL, 'Protein transport protein Got1', 'Got1', 4, NULL),
(36687, NULL, 'IPR045126', NULL, 'Trafficking protein particle complex subunit TRAPPC10/Trs130', 'TRAPPC10/Trs130', 4, NULL),
(36688, NULL, 'IPR046433', NULL, 'Acetyl-CoA hydrolase/transferase', 'ActCoA_hydro', 4, NULL),
(36689, NULL, 'IPR046025', NULL, 'Protein of unknown function DUF5983', 'DUF5983', 4, NULL),
(36690, NULL, 'IPR046083', NULL, 'Protein of unknown function DUF6101', 'DUF6101', 4, NULL),
(36691, NULL, 'IPR042357', NULL, 'WAP four-disulfide core domain protein 1', 'WFDC1', 4, NULL),
(36692, NULL, 'IPR045951', NULL, 'Domain of unknown function DUF6371', 'DUF6371', 3, NULL),
(36693, NULL, 'IPR044944', NULL, 'Nitric oxide synthase, domain 3 superfamily', 'NOS_dom_3', 5, NULL),
(36694, NULL, 'IPR045150', NULL, 'Transmembrane reductase CYB561D1/2', 'CYB561D1/2', 4, NULL),
(36695, NULL, 'IPR046804', NULL, 'DNA-PKcs, N-terminal', 'DNA-PKcs_N', 3, NULL),
(36696, NULL, 'IPR044151', NULL, 'Alpha-ketoglutaric semialdehyde dehydrogenase', 'ALDH_KGSADH', 4, NULL),
(36697, NULL, 'IPR046013', NULL, 'Protein of unknown function DUF5970', 'DUF5970', 4, NULL),
(36698, NULL, 'IPR045146', NULL, 'Splicing factor 3A subunit 1', 'SF3A1', 4, NULL),
(36699, NULL, 'IPR045208', NULL, 'Initiation factor 4G', 'IF4G', 4, NULL),
(36700, NULL, 'IPR045991', NULL, 'Protein of unknown function DUF5947', 'DUF5947', 4, NULL),
(36701, NULL, 'IPR046078', NULL, 'Protein of unknown function DUF6096', 'DUF6096', 4, NULL),
(36702, NULL, 'IPR045243', NULL, 'mRNA 3''-end-processing protein Rna14-like', 'Rna14-like', 4, NULL),
(36703, NULL, 'IPR045142', NULL, 'BCAS3-like', 'BCAS3-like', 4, NULL),
(36704, NULL, 'IPR046042', NULL, 'Protein of unknown function DUF6000', 'DUF6000', 4, NULL),
(36705, NULL, 'IPR046099', NULL, 'Protein of unknown function DUF6035', 'DUF6035', 4, NULL),
(36706, NULL, 'IPR042578', NULL, 'Spike glycoprotein, betacoronavirus', 'BETA_CORONA_SPIKE', 4, NULL),
(36707, NULL, 'IPR045952', NULL, 'Protein of unknown function DUF6372', 'DUF6372', 4, NULL),
(36708, NULL, 'IPR045252', NULL, 'Lysophosphatidylcholine acyltransferase LPCAT1-like', 'LPCAT1-like', 3, NULL),
(36709, NULL, 'IPR045945', NULL, 'Protein of unknown function DUF6365', 'DUF6365', 4, NULL),
(36710, NULL, 'IPR045938', NULL, 'Protein of unknown function DUF6358', 'DUF6358', 4, NULL),
(36711, NULL, 'IPR045151', NULL, 'DDB1- and CUL4-associated factor 8-like', 'DCAF8', 4, NULL);   
INSERT INTO "PUBLIC"."ENTRY" VALUES
(36712, NULL, 'IPR044172', NULL, 'Transcription factor ILI2-like', 'ILI2-like', 4, NULL),
(36713, NULL, 'IPR045226', NULL, 'DSC E3 ubiquitin ligase complex subunit 3', 'Dsc3', 4, NULL),
(36714, NULL, 'IPR042382', NULL, 'Chondroitin sulfate proteoglycan 5', 'CSPG5', 4, NULL),
(36715, NULL, 'IPR045977', NULL, 'Domain of unknown function DUF5933', 'DUF5933', 3, NULL),
(36716, NULL, 'IPR045964', NULL, 'Protein of unknown function DUF6384', 'DUF6384', 4, NULL),
(36717, NULL, 'IPR044781', NULL, 'Pentatricopeptide repeat-containing protein At5g10690-like', 'At5g10690-like', 4, NULL),
(36718, NULL, 'IPR042622', NULL, 'Zinc finger protein 106', 'Znf106', 4, NULL),
(36719, NULL, 'IPR044300', NULL, 'Protein SENSITIVE TO PROTON RHIZOTOXICITY 1/2', 'STOP1/2', 4, NULL),
(36720, NULL, 'IPR045065', NULL, 'Exportin-1/5', 'XPO1/5', 4, NULL),
(36721, NULL, 'IPR044132', NULL, 'Glutamine-binding periplasmic protein GlnH,  type 2 periplasmic binding protein fold', 'PBP2_GlnH', 3, NULL),
(36722, NULL, 'IPR045997', NULL, 'Protein of unknown function DUF5953', 'DUF5953', 4, NULL),
(36723, NULL, 'IPR046843', NULL, 'LonB, AAA+ ATPase LID domain, archaeal-type', 'LonB_AAA-LID', 3, NULL),
(36724, NULL, 'IPR044580', NULL, '5''-Methylthioadenosine/S-adenosylhomocysteine nucleosidase', 'MTAN', 4, NULL),
(36725, NULL, 'IPR045984', NULL, 'Domain of unknown function DUF5940', 'DUF5940', 3, NULL),
(36726, NULL, 'IPR046102', NULL, 'Protein of unknown function DUF6039', 'DUF6039', 4, NULL),
(36727, NULL, 'IPR045074', NULL, 'Glutathione S-transferases Tau, C-terminal alpha helical domain, plant', 'GST_C_Tau', 3, NULL),
(36728, NULL, 'IPR044183', NULL, 'Photosynthetic NDH subunit of lumenal location 4/FKBP13-like', 'PNSL4/FKBP13-like', 4, NULL),
(36729, NULL, 'IPR046088', NULL, 'Protein of unknown function DUF6106', 'DUF6106', 4, NULL),
(36730, NULL, 'IPR044181', NULL, 'FCS-Like Zinc finger 17/18', 'FLZ17/18', 4, NULL),
(36731, NULL, 'IPR044961', NULL, 'Tetratricopeptide repeat protein POLLENLESS 3/SULFUR DEFICIENCY-INDUCED 1', 'MS5/SDI1', 4, NULL),
(36732, NULL, 'IPR044214', NULL, 'EDS1-like', 'EDS1-like', 4, NULL),
(36733, NULL, 'IPR046081', NULL, 'Protein of unknown function DUF6099', 'DUF6099', 4, NULL),
(36734, NULL, 'IPR044403', NULL, 'PRDM10, PR/SET domain', 'PRDM10_PR/SET', 3, NULL),
(36735, NULL, 'IPR045987', NULL, 'Domain of unknown function DUF5943', 'DUF5943', 3, NULL),
(36736, NULL, 'IPR044176', NULL, 'Thioredoxin-like 4, chloroplastic', 'TRL4_chloroplastic', 4, NULL),
(36737, NULL, 'IPR042378', NULL, 'Integral membrane protein DGCR2/IDD', 'IDD', 4, NULL),
(36738, NULL, 'IPR045225', NULL, 'Uracil/uridine/allantoin permease', 'Uracil/uridine/allantoin_perm', 4, NULL),
(36739, NULL, 'IPR046101', NULL, 'Protein of unknown function DUF6038', 'DUF6038', 4, NULL),
(36740, NULL, 'IPR042405', NULL, 'Protrudin', 'Protrudin', 4, NULL),
(36741, NULL, 'IPR045062', NULL, 'Cytochrome c-type biogenesis protein CcsA/CcmC', 'Cyt_c_biogenesis_CcsA/CcmC', 4, NULL),
(36742, NULL, 'IPR045970', NULL, 'Protein of unknown function DUF5926', 'DUF5926', 3, NULL),
(36743, NULL, 'IPR045019', NULL, 'Beta-carotene hydroxylase-like', 'BETA-OHASE-like', 4, NULL),
(36744, NULL, 'IPR045227', NULL, 'WD repeat-containing protein WDR18/Ipi3/RID3', 'WDR18/Ipi3/RID3', 4, NULL),
(36745, NULL, 'IPR044964', NULL, 'Inactive poly [ADP-ribose] polymerase RCD1/SRO1-5', 'RCD1/SRO1-5', 4, NULL),
(36746, NULL, 'IPR042410', NULL, 'Transducin beta-like protein 2', 'WBSCR13', 4, NULL),
(36747, NULL, 'IPR046436', NULL, 'Nidovirus 3''-5'' exoribonuclease domain', 'NIV_EXON', 3, NULL),
(36748, NULL, 'IPR046096', NULL, 'Protein of unknown function DUF6114', 'DUF6114', 4, NULL),
(36749, NULL, 'IPR045996', NULL, 'Protein of unknown function DUF5952', 'DUF5952', 4, NULL),
(36750, NULL, 'IPR046061', NULL, 'Protein of unknown function DUF6019', 'DUF6019', 4, NULL),
(36751, NULL, 'IPR043076', NULL, 'Cell-cell fusogen EFF/AFF, domain 3', 'Fusogen_EFF/AFF_dom3', 5, NULL),
(36752, NULL, 'IPR045078', NULL, 'Sulfurtransferase TST/MPST-like', 'TST/MPST-like', 4, NULL),
(36753, NULL, 'IPR046048', NULL, 'Protein of unknown function DUF6006', 'DUF6006', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(36754, NULL, 'IPR045169', NULL, 'Nitrite and sulphite reductase 4Fe-4S domain containing protein', 'NO2/SO3_Rdtase_4Fe4S_prot', 4, NULL),
(36755, NULL, 'IPR046018', NULL, 'Protein of unknown function DUF5975', 'DUF5975', 4, NULL),
(36756, NULL, 'IPR046022', NULL, 'Domain of unknown function DUF5979', 'DUF5979', 3, NULL),
(36757, NULL, 'IPR042717', NULL, 'Myosin light chain kinase 2, catalytic domain', 'MLCK2_STKc', 3, NULL),
(36758, NULL, 'IPR045919', NULL, 'Protein of unknown function DUF6338', 'DUF6338', 4, NULL),
(36759, NULL, 'IPR042939', NULL, 'RUN and FYVE domain-containing protein 4', 'RUFY4', 4, NULL),
(36760, NULL, 'IPR042502', NULL, 'Transmembrane 7 superfamily member 3', 'TM7SF3', 4, NULL),
(36761, NULL, 'IPR045248', NULL, 'Heat shock protein Sti1-like', 'Sti1-like', 4, NULL),
(36762, NULL, 'IPR045959', NULL, 'Domain of unknown function DUF6379', 'DUF6379', 3, NULL),
(36763, NULL, 'IPR046056', NULL, 'Protein of unknown function DUF6014', 'DUF6014', 4, NULL),
(36764, NULL, 'IPR045931', NULL, 'Protein of unknown function DUF6350', 'DUF6350', 4, NULL),
(36765, NULL, 'IPR045988', NULL, 'Protein of unknown function DUF5944', 'DUF5944', 4, NULL),
(36766, NULL, 'IPR045978', NULL, 'TraC, central domain', 'TRAC_dom', 3, NULL),
(36767, NULL, 'IPR045119', NULL, 'SUN domain-containing protein 1-5', 'SUN1-5', 4, NULL),
(36768, NULL, 'IPR045253', NULL, 'Vacuolar protein sorting-associated protein 4, MIT domain', 'VPS4_MIT', 3, NULL),
(36769, NULL, 'IPR045207', NULL, 'NUP50, Ran-binding domain', 'RanBD_NUP50_plant', 3, NULL),
(36770, NULL, 'IPR042498', NULL, 'Rubella membrane glycoprotein E1, domain 2', 'Rubella_E1_2', 5, NULL),
(36771, NULL, 'IPR046838', NULL, 'BREX system Lon protease-like BrxL, N-terminal', 'BrxL_N', 3, NULL),
(36772, NULL, 'IPR042115', NULL, 'Primosomal protein N'', 3'' DNA-binding domain superfamily', 'PriA_3primeBD_sf', 5, NULL),
(36773, NULL, 'IPR045933', NULL, 'Protein of unknown function DUF6353', 'DUF6353', 4, NULL),
(36774, NULL, 'IPR046064', NULL, 'Protein of unknown function DUF6022', 'DUF6022', 4, NULL),
(36775, NULL, 'IPR046365', NULL, 'FAM124 domain', 'FAM124_dom', 3, NULL),
(36776, NULL, 'IPR045937', NULL, 'Protein of unknown function DUF6357', 'DUF6357', 4, NULL),
(36777, NULL, 'IPR045130', NULL, 'GDP-fucose protein O-fucosyltransferase 2-like', 'OFUT2-like', 4, NULL),
(36778, NULL, 'IPR045993', NULL, 'Protein of unknown function DUF5949', 'DUF5949', 4, NULL),
(36779, NULL, 'IPR042354', NULL, 'F-box only protein 38', 'FBX38', 4, NULL),
(36780, NULL, 'IPR045088', NULL, 'Aminotransferase ALAT1/2-like', 'ALAT1/2-like', 4, NULL),
(36781, NULL, 'IPR045120', NULL, 'SUN domain-containing Suco/Slp1-like', 'Suco/Slp1-like', 4, NULL),
(36782, NULL, 'IPR045920', NULL, 'Protein of unknown function DUF6339', 'DUF6339', 4, NULL),
(36783, NULL, 'IPR045923', NULL, 'Protein of unknown function DUF6342', 'DUF6342', 4, NULL),
(36784, NULL, 'IPR045087', NULL, 'Multicopper oxidase', 'Cu-oxidase_fam', 4, NULL),
(36785, NULL, 'IPR046371', NULL, 'Bcl-2, Bcl-2 homology region 1-3', 'Bcl-2_BH1-3', 3, NULL),
(36786, NULL, 'IPR045917', NULL, 'Outer capsid protein VP3-like', 'VP3-like', 4, NULL),
(36787, NULL, 'IPR044998', NULL, 'Timeless', 'Timeless', 4, NULL),
(36788, NULL, 'IPR044072', NULL, 'Kelch-like protein 2 , BTB/POZ domain', 'KLHL2_BTB/POZ', 3, NULL),
(36789, NULL, 'IPR045105', NULL, 'Med25/PTOV1', 'Med25/PTOV1', 4, NULL),
(36790, NULL, 'IPR045891', NULL, 'Zinc transporter ZIP9', 'ZIP9', 4, NULL),
(36791, NULL, 'IPR046036', NULL, 'Protein of unknown function DUF5994', 'DUF5994', 4, NULL),
(36792, NULL, 'IPR044068', NULL, 'Core-binding (CB) domain', 'CB', 3, NULL),
(36793, NULL, 'IPR046104', NULL, 'Protein of unknown function DUF6041', 'DUF6041', 4, NULL),
(36794, NULL, 'IPR043110', NULL, 'Cystovirus, RNA-directed RNA polymerase, N-terminal', 'Cystovir_RNA-dir_pol_N', 5, NULL),
(36795, NULL, 'IPR046012', NULL, 'Protein of unknown function DUF5969', 'DUF5969', 4, NULL),
(36796, NULL, 'IPR045092', NULL, 'Exosome complex exonuclease Rrp6-like', 'Rrp6-like', 4, NULL),
(36797, NULL, 'IPR044174', NULL, 'Glycosyltransferase BC10-like', 'BC10-like', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(36798, NULL, 'IPR046366', NULL, 'ER-bound oxygenase mpaB/B''', 'MPAB', 4, NULL),
(36799, NULL, 'IPR045149', NULL, 'Protein OS-9-like', 'OS-9-like', 4, NULL),
(36800, NULL, 'IPR045956', NULL, 'Protein of unknown function DUF6376', 'DUF6376', 4, NULL),
(36801, NULL, 'IPR045160', NULL, 'Autophagy-related protein 16', 'ATG16', 4, NULL),
(36802, NULL, 'IPR043376', NULL, 'Protein NPG1-like', 'NPG1-like', 4, NULL),
(36803, NULL, 'IPR042508', NULL, 'F-box/WD repeat-containing protein 5', 'FBXW5', 4, NULL),
(36804, NULL, 'IPR042307', NULL, 'Reeler domain superfamily', 'Reeler_sf', 5, NULL),
(36805, NULL, 'IPR046052', NULL, 'Protein of unknown function DUF6010', 'DUF6010', 4, NULL),
(36806, NULL, 'IPR045222', NULL, 'DNA-directed RNA polymerase II subunit Rpb4-like', 'Rpb4-like', 4, NULL),
(36807, NULL, 'IPR046008', NULL, 'Protein of unknown function DUF5964', 'DUF5964', 4, NULL),
(36808, NULL, 'IPR046024', NULL, 'Protein of unknown function DUF5982', 'DUF5982', 3, NULL),
(36809, NULL, 'IPR044999', NULL, 'Protein CbbY-like', 'CbbY-like', 4, NULL),
(36810, NULL, 'IPR045152', NULL, 'Enhancer of mRNA-decapping protein 4-like', 'EDC4-like', 4, NULL),
(36811, NULL, 'IPR045968', NULL, 'Domain of unknown function DUF5924', 'DUF5924', 3, NULL),
(36812, NULL, 'IPR045961', NULL, 'Protein of unknown function DUF6381', 'DUF6381', 4, NULL),
(36813, NULL, 'IPR044821', NULL, 'Putative nucleotide-diphospho-sugar transferase At1g28695/At4g15970-like', 'At1g28695/At4g15970-like', 4, NULL),
(36814, NULL, 'IPR044978', NULL, 'DnaJ homologue subfamily C, GRV2/DNAJC13', 'GRV2/DNAJC13', 4, NULL),
(36815, NULL, 'IPR045990', NULL, 'Protein of unknown function DUF5946', 'DUF5946', 4, NULL),
(36816, NULL, 'IPR043369', NULL, 'Melanoma-derived growth regulatory protein', 'MIA', 4, NULL),
(36817, NULL, 'IPR046010', NULL, 'Protein of unknown function DUF5966', 'DUF5966', 4, NULL),
(36818, NULL, 'IPR045973', NULL, 'Domain of unknown function DUF5929', 'DUF5929', 3, NULL),
(36819, NULL, 'IPR046020', NULL, 'Protein of unknown function DUF5977', 'DUF5977', 3, NULL),
(36820, NULL, 'IPR045967', NULL, 'Domain of unknown function DUF5923', 'DUF5923', 3, NULL),
(36821, NULL, 'IPR042349', NULL, 'Uncharacterized protein C9orf40-like', 'C9orf40-like', 4, NULL),
(36822, NULL, 'IPR045980', NULL, 'Domain of unknown function DUF5936', 'DUF5936', 3, NULL),
(36823, NULL, 'IPR046030', NULL, 'Protein of unknown function DUF5988', 'DUF5988', 4, NULL),
(36824, NULL, 'IPR045235', NULL, 'Uncharacterized prokaryotic polysaccharide deacetylases PuuE/HpPgdA-like', 'CE4_PuuE_HpPgdA-like_2', 4, NULL),
(36825, NULL, 'IPR043365', NULL, 'NACHT domain- and WD repeat-containing protein 1', 'NWD1', 4, NULL),
(36826, NULL, 'IPR046004', NULL, 'Protein of unknown function DUF5960', 'DUF5960', 4, NULL),
(36827, NULL, 'IPR044920', NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme, C-terminal subdomain', 'MnmG_C_subdom', 5, NULL),
(36828, NULL, 'IPR044780', NULL, 'Heh2/Src1-like', 'Heh2/Src1', 4, NULL),
(36829, NULL, 'IPR046092', NULL, 'Protein of unknown function DUF6110', 'DUF6110', 4, NULL),
(36830, NULL, 'IPR045236', NULL, 'Reverse rubrerythrin, di-iron-binding domain', 'RevRr_diiron-bd_dom', 3, NULL),
(36831, NULL, 'IPR042383', NULL, 'Fibrinogen silencer-binding protein', 'FSBP', 4, NULL),
(36832, NULL, 'IPR046005', NULL, 'Protein of unknown function DUF5961', 'DUF5961', 4, NULL),
(36833, NULL, 'IPR044994', NULL, 'Tubulin-specific chaperone E', 'TBCE', 4, NULL),
(36834, NULL, 'IPR046085', NULL, 'Protein of unknown function DUF6103', 'DUF6103', 4, NULL),
(36835, NULL, 'IPR045975', NULL, 'Domain of unknown function DUF5931', 'DUF5931', 3, NULL),
(36836, NULL, 'IPR042818', NULL, 'RIbeta, dimerization/docking domain', 'RIbeta_DD', 3, NULL),
(36837, NULL, 'IPR042221', NULL, 'Leucyl/phenylalanyl-tRNA-protein transferase, N-terminal', 'Leu/Phe-tRNA_Trfase_N', 5, NULL),
(36838, NULL, 'IPR046358', NULL, 'Flagellin, C-terminal domain', 'Flagellin_C', 3, NULL),
(36839, NULL, 'IPR044517', NULL, 'Protein PHOX1-4', 'PHOX1-4', 4, NULL),
(36840, NULL, 'IPR042431', NULL, 'DENN domain-containing protein 10', 'FAM45', 4, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(36841, NULL, 'IPR046894', NULL, 'Methylase-associated X1', 'MTaX1', 3, NULL),
(36842, NULL, 'IPR046461', NULL, 'Terminase large subunit-like, ATPase domain', 'TerL_ATPase', 3, NULL),
(36843, NULL, 'IPR045132', NULL, 'Ubiquitin conjugation factor E4', 'UBE4', 4, NULL),
(36844, NULL, 'IPR046059', NULL, 'Domain of unknown function DUF6017', 'DUF6017', 3, NULL),
(36845, NULL, 'IPR042933', NULL, 'Ataxin-7-like protein 3B', 'ATXN7L3B', 4, NULL),
(36846, NULL, 'IPR046039', NULL, 'Protein of unknown function DUF5997', 'DUF5997', 4, NULL),
(36847, NULL, 'IPR045003', NULL, 'Fasciclin-like arabinogalactan protein, group A', 'FLA_A', 4, NULL),
(36848, NULL, 'IPR044195', NULL, 'Pentapeptide repeat containing protein TL17-like', 'TL17-like', 4, NULL),
(36849, NULL, 'IPR045983', NULL, 'Guanylate cyclase domain-containing protein, N-terminal', 'GUC-dom-containing_N', 3, NULL),
(36850, NULL, 'IPR044986', NULL, 'Kinesin-like protein KIF15/KIN-12', 'KIF15/KIN-12', 4, NULL),
(36851, NULL, 'IPR046023', NULL, 'Protein of unknown function DUF5980', 'DUF5980', 4, NULL),
(36852, NULL, 'IPR046063', NULL, 'Protein of unknown function DUF6021', 'DUF6021', 4, NULL),
(36853, NULL, 'IPR046041', NULL, 'Protein of unknown function DUF5999', 'DUF5999', 4, NULL),
(36854, NULL, 'IPR045999', NULL, 'Protein of unknown function DUF5955', 'DUF5955', 4, NULL),
(36855, NULL, 'IPR044918', NULL, 'DUF3349, helical bundle', 'DUF3349_helical', 5, NULL),
(36856, NULL, 'IPR046028', NULL, 'Protein of unknown function DUF5986', 'DUF5986', 4, NULL),
(36857, NULL, 'IPR045206', NULL, 'Maestro heat-like repeat-containing protein', 'Maestro_heat-like_prot', 4, NULL),
(36858, NULL, 'IPR046837', NULL, 'Laa1/Sip1/HEATR5-like, HEAT repeat region', 'Laa1/Sip1/HEATR5-like_HEAT', 7, NULL),
(36859, NULL, 'IPR045125', NULL, 'RNA polymerase II transcriptional coactivator Sub1/Tcp4-like', 'Sub1/Tcp4-like', 4, NULL),
(36860, NULL, 'IPR045312', NULL, 'Phenylcoumaran benzylic ether reductase-like', 'PCBER-like', 3, NULL),
(36861, NULL, 'IPR046093', NULL, 'Protein of unknown function DUF6111', 'DUF6111', 4, NULL),
(36862, NULL, 'IPR046044', NULL, 'Protein of unknown function DUF6002', 'DUF6002', 4, NULL),
(36863, NULL, 'IPR042404', NULL, 'KATNB1-like protein 1', 'KATNBL1', 4, NULL),
(36864, NULL, 'IPR046067', NULL, 'Protein of unknown function DUF6025', 'DUF6025', 4, NULL),
(36865, NULL, 'IPR046369', NULL, 'Mastermind-like 1-3', 'MAML1-3', 4, NULL),
(36866, NULL, 'IPR044728', NULL, 'ATP-dependent RNA helicase eIF4A, DEAD-box helicase domain', 'EIF4A_DEADc', 3, NULL),
(36867, NULL, 'IPR042765', NULL, 'TRIM42, RING-HC finger', 'TRIM42_RING-HC', 3, NULL),
(36868, NULL, 'IPR045123', NULL, 'N6-adenosine-methyltransferase non-catalytic subunit METTL14-like', 'METTL14-like', 4, NULL),
(36869, NULL, 'IPR045094', NULL, 'Nicotinamide/nicotinate mononucleotide adenylyltransferase, eukaryotic', 'NMNAT_euk', 4, NULL),
(36870, NULL, 'IPR045948', NULL, 'Protein of unknown function DUF6368', 'DUF6368', 4, NULL),
(36871, NULL, 'IPR045979', NULL, 'Domain of unknown function DUF5935', 'DUF5935', 3, NULL),
(36872, NULL, 'IPR043075', NULL, 'Baseplate protein Gp16, domain 1 and 2', 'Gp16_dom1_2', 5, NULL),
(36873, NULL, 'IPR045068', NULL, 'BTB/POZ domain-containing adapter for CUL3-mediated RhoA degradation protein 1/2/3', 'BACURD1-3', 4, NULL),
(36874, NULL, 'IPR046050', NULL, 'Protein of unknown function DUF6008', 'DUF6008', 4, NULL),
(36875, NULL, 'IPR045239', NULL, 'Transcription factor bHLH95-like, basic helix-loop-helix domain', 'bHLH95_bHLH', 3, NULL),
(36876, NULL, 'IPR045147', NULL, 'AT-rich interactive domain-containing protein 3', 'ARI3A/B/C', 4, NULL),
(36877, NULL, 'IPR042406', NULL, 'Vitamin K epoxide reductase complex subunit 1', 'VKORC1/VKORC1L1', 4, NULL),
(36878, NULL, 'IPR045936', NULL, 'Protein of unknown function DUF6356', 'DUF6356', 4, NULL),
(36879, NULL, 'IPR042398', NULL, 'Bcl-2-like protein 13', 'BCL2L13', 4, NULL),
(36880, NULL, 'IPR045005', NULL, 'BTB/POZ and MATH domain-containing protein 1-6', 'BPM1-6', 4, NULL),
(36881, NULL, 'IPR046360', NULL, 'T-box transcription factor, DNA-binding domain', 'T-box_DNA-bd', 3, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(36882, NULL, 'IPR045242', NULL, 'Syntaxin', 'Syntaxin', 4, NULL),
(36883, NULL, 'IPR045071', NULL, 'KH domain-containing BBP-like', 'BBP-like', 4, NULL),
(36884, NULL, 'IPR044069', NULL, 'Zinc finger C4H2-type', 'ZF_C4H2', 3, NULL),
(36885, NULL, 'IPR045989', NULL, 'Protein of unknown function DUF5945', 'DUF5945', 4, NULL),
(36886, NULL, 'IPR045061', NULL, 'Tubulin-like protein  FtsZ/CetZ', 'FtsZ/CetZ', 4, NULL),
(36887, NULL, 'IPR045924', NULL, 'Protein of unknown function DUF6343', 'DUF6343', 4, NULL),
(36888, NULL, 'IPR044731', NULL, 'Butanol dehydrogenase-like', 'BDH-like', 4, NULL),
(36889, NULL, 'IPR042503', NULL, 'E2 regulatory, transactivation domain, subdomain 1', 'Regulatory_protein_E2_N_1', 5, NULL),
(36890, NULL, 'IPR042477', NULL, 'HMG domain-containing protein 4', 'HMGXB4', 4, NULL),
(36891, NULL, 'IPR046372', NULL, 'Poly (ADP-ribose) glycohydrolase (PARG), catalytic domain', 'PARG_cat', 3, NULL),
(36892, NULL, 'IPR045950', NULL, 'Protein of unknown function DUF6370', 'DUF6370', 4, NULL),
(36893, NULL, 'IPR045171', NULL, 'Rad50, ATP-binding cassette domain', 'ABC_Rad50', 3, NULL),
(36894, NULL, 'IPR045314', NULL, 'G-box binding factor 1-like, bZIP domain, plant', 'bZIP_plant_GBF1', 3, NULL),
(36895, NULL, 'IPR046080', NULL, 'Protein of unknown function DUF6098', 'DUF6098', 4, NULL),
(36896, NULL, 'IPR046055', NULL, 'Protein of unknown function DUF6013', 'DUF6013', 4, NULL),
(36897, NULL, 'IPR044382', NULL, 'NSP3, SUD-C domain, MERS-CoV-like', 'NSP3_SUD_C_MERS-CoV', 3, NULL),
(36898, NULL, 'IPR045076', NULL, 'DNA mismatch repair MutS family', 'MutS_family', 4, NULL),
(36899, NULL, 'IPR046353', NULL, 'Cystathionine beta-synthase, C-terminal domain', 'CBS_C', 3, NULL),
(36900, NULL, 'IPR045963', NULL, 'Protein of unknown function DUF6383', 'DUF6383', 3, NULL),
(36901, NULL, 'IPR045918', NULL, 'Protein of unknown function DUF6337', 'DUF6337', 4, NULL),
(36902, NULL, 'IPR042496', NULL, 'Cell growth regulator with RING finger domain protein 1', 'CGRF1', 4, NULL),
(36903, NULL, 'IPR046077', NULL, 'Protein of unknown function DUF6095', 'DUF6095', 4, NULL),
(36904, NULL, 'IPR042397', NULL, 'Podocalyxin-like protein 2', 'PODXL2', 4, NULL),
(36905, NULL, 'IPR043536', NULL, 'Host cell factor', 'HCF1/2', 4, NULL),
(36906, NULL, 'IPR044167', NULL, 'Bowman-Birk type wound-induced proteinase inhibitor WIP1', 'WIP1', 4, NULL),
(36907, NULL, 'IPR046359', NULL, 'Aftiphilin-like', 'Aftin-like', 4, NULL),
(36908, NULL, 'IPR046049', NULL, 'Protein of unknown function DUF6007', 'DUF6007', 4, NULL),
(36909, NULL, 'IPR045224', NULL, 'Homeobox-leucine zipper protein, class I, plant', 'HDZip_class_I_plant', 4, NULL),
(36910, NULL, 'IPR045069', NULL, 'Multidrug and toxic compound extrusion family, eukaryotic', 'MATE_euk', 4, NULL),
(36911, NULL, 'IPR046019', NULL, 'Protein of unknown function DUF5976', 'DUF5976', 4, NULL),
(36912, NULL, 'IPR046068', NULL, 'Protein of unknown function DUF6026', 'DUF6026', 4, NULL),
(36913, NULL, 'IPR045893', NULL, 'FREE1', 'FREE1', 4, NULL),
(36914, NULL, 'IPR045943', NULL, 'Domain of unknown function DUF6363', 'DUF6363', 3, NULL),
(36915, NULL, 'IPR046847', NULL, 'Antitoxin Xre-like, helix-turn-helix domain', 'Xre-like_HTH', 3, NULL),
(36916, NULL, 'IPR044307', NULL, 'Non-structural protein 5, deltacoronavirus', 'NSP5_Mpro_deltaCoV', 3, NULL),
(36917, NULL, 'IPR044956', NULL, 'Ankyrin repeat protein SKIP35', 'SKIP35', 4, NULL),
(36918, NULL, 'IPR046076', NULL, 'Domain of unknown function DUF6094', 'DUF6094', 3, NULL),
(36919, NULL, 'IPR046017', NULL, 'Protein of unknown function DUF5974', 'DUF5974', 4, NULL),
(36920, NULL, 'IPR045944', NULL, 'Protein of unknown function DUF6364', 'DUF6364', 4, NULL),
(36921, NULL, 'IPR042500', NULL, 'Rubella membrane glycoprotein E1, domain 1', 'Rubella_E1_1', 5, NULL),
(36922, NULL, 'IPR044197', NULL, 'Peptidyl-prolyl cis-trans isomerase FKBP17-1-like', 'FKBP17-1-like', 4, NULL),
(36923, NULL, 'IPR045879', NULL, 'Cytochrome b561, DM13 and DOMON domain-containing protein At5g54830', 'B561A', 4, NULL),
(36924, NULL, 'IPR045101', NULL, 'PTEN,  phosphatase domain', 'PTP_PTEN', 3, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(36925, NULL, 'IPR042776', NULL, '54S ribosomal protein L44, mitochondrial', 'MRPL44', 4, NULL),
(36926, NULL, 'IPR046087', NULL, 'Protein of unknown function DUF6105', 'DUF6105', 4, NULL),
(36927, NULL, 'IPR046089', NULL, 'Protein of unknown function DUF6107', 'DUF6107', 4, NULL),
(36928, NULL, 'IPR045018', NULL, 'Azaguanine-like transporters', 'Azg-like', 4, NULL),
(36929, NULL, 'IPR043098', NULL, 'Cysteine protease, VirA/EspG, N-terminal', 'Cys_protease_VirA/EspG_N', 5, NULL),
(36930, NULL, 'IPR046029', NULL, 'Protein of unknown function DUF5987', 'DUF5987', 4, NULL),
(36931, NULL, 'IPR044959', NULL, 'Classical arabinogalactan protein', 'AGP', 4, NULL),
(36932, NULL, 'IPR046082', NULL, 'Protein of unknown function DUF6100', 'DUF6100', 4, NULL),
(36933, NULL, 'IPR045949', NULL, 'Protein of unknown function DUF6369', 'DUF6369', 4, NULL),
(36934, NULL, 'IPR045172', NULL, 'Tubulin-folding cofactor B, N-terminal ubiquitin-like domain', 'TBCB_N_Ubl', 3, NULL),
(36935, NULL, 'IPR045903', NULL, 'E3 ubiquitin-protein ligase ZNRF3, Zinc finger, RING-type', 'ZNRF3_Znf_RING', 3, NULL),
(36936, NULL, 'IPR045064', NULL, 'Reticulon-like protein, plant', 'Reticulon-like_plant', 4, NULL),
(36937, NULL, 'IPR044946', NULL, 'Type I restriction modification DNA specificity domain superfamily', 'Restrct_endonuc_typeI_TRD_sf', 5, NULL),
(36938, NULL, 'IPR045939', NULL, 'Endonuclease YhcR, N-terminal domain', 'YhcR_N', 3, NULL),
(36939, NULL, 'IPR045118', NULL, 'F-box only protein FBXO9/FBXO48', 'FBXO9/FBXO48', 4, NULL),
(36940, NULL, 'IPR046098', NULL, 'Protein of unknown function DUF6034', 'DUF6034', 4, NULL),
(36941, NULL, 'IPR046465', NULL, 'BLOC-1-related complex subunit 6, C-terminal helix', 'BORCS6_C', 3, NULL),
(36942, NULL, 'IPR046432', NULL, 'TASOR', 'TASOR', 4, NULL),
(36943, NULL, 'IPR046090', NULL, 'Protein of unknown function DUF6108', 'DUF6108', 4, NULL),
(36944, NULL, 'IPR045976', NULL, 'Domain of unknown function DUF5932', 'DUF5932', 3, NULL),
(36945, NULL, 'IPR042359', NULL, 'Telomere repeats-binding bouquet formation protein 1', 'TERB1', 4, NULL),
(36946, NULL, 'IPR045047', NULL, 'N-acetyltransferase Ard1-like', 'Ard1-like', 4, NULL),
(36947, NULL, 'IPR046079', NULL, 'Protein of unknown function DUF6097', 'DUF6097', 4, NULL),
(36948, NULL, 'IPR046014', NULL, 'Protein of unknown function DUF5971', 'DUF5971', 4, NULL),
(36949, NULL, 'IPR044996', NULL, 'Coenzyme Q-binding protein COQ10-like', 'COQ10-like', 4, NULL),
(36950, NULL, 'IPR043377', NULL, 'Glutathione S-transferase T1/2/3', 'GSTT1/2/3', 4, NULL),
(36951, NULL, 'IPR044922', NULL, 'DUF2063, N-terminal superfamily', 'DUF2063_N_sf', 5, NULL),
(36952, NULL, 'IPR045960', NULL, 'Protein of unknown function DUF6380', 'DUF6380', 4, NULL),
(36953, NULL, 'IPR045946', NULL, 'Protein of unknown function DUF6366', 'DUF6366', 4, NULL),
(36954, NULL, 'IPR044942', NULL, 'Adenovirus Pll, hexon, subdomain 2', 'Adenovirus_Pll_hexon_sub2', 5, NULL),
(36955, NULL, 'IPR045140', NULL, 'SHC SH2 domain-binding protein 1-like', 'SHCBP1-like', 4, NULL),
(36956, NULL, 'IPR046001', NULL, 'Protein of unknown function DUF5957', 'DUF5957', 4, NULL),
(36957, NULL, 'IPR046026', NULL, 'Protein of unknown function DUF5984', 'DUF5984', 4, NULL),
(36958, NULL, 'IPR045953', NULL, 'Protein of unknown function DUF6373', 'DUF6373', 4, NULL),
(36959, NULL, 'IPR044937', NULL, 'Mu1 membrane penetration protein, domain III', 'Mu1_membr_pen_domIII', 5, NULL),
(36960, NULL, 'IPR046084', NULL, 'Protein of unknown function DUF6102', 'DUF6102', 4, NULL),
(36961, NULL, 'IPR045969', NULL, 'Domain of unknown function DUF5925', 'DUF5925', 3, NULL),
(36962, NULL, 'IPR045992', NULL, 'Protein of unknown function DUF5948', 'DUF5948', 4, NULL),
(36963, NULL, 'IPR044179', NULL, 'Pentatricopeptide repeat-containing protein PPR5-like', 'PPR5-like', 4, NULL),
(36964, NULL, 'IPR042720', NULL, 'Piccolo, FYVE-related domain 1', 'PCLO_FYVE1', 3, NULL),
(36965, NULL, 'IPR046887', NULL, 'Ribosomal RNA small subunit methyltransferase E, PUA-like domain', 'RsmE_PUA-like', 3, NULL),
(36966, NULL, 'IPR043010', NULL, 'Phenol hydroxylase domain superfamily', 'Phenol_hydroxylase_sf', 5, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(36967, NULL, 'IPR045972', NULL, 'Domain of unknown function DUF5928', 'DUF5928', 3, NULL),
(36968, NULL, 'IPR045162', NULL, 'Serine/threonine-protein kinase Vps15-like', 'Vps15-like', 4, NULL),
(36969, NULL, 'IPR046033', NULL, 'Protein of unknown function DUF5991', 'DUF5991', 4, NULL),
(36970, NULL, 'IPR045144', NULL, 'Transcription initiation factor TFIID component TAF4', 'TAF4', 4, NULL),
(36971, NULL, 'IPR045922', NULL, 'Protein of unknown function DUF6341', 'DUF6341', 4, NULL),
(36972, NULL, 'IPR045927', NULL, 'Protein of unknown function DUF6346', 'DUF6346', 4, NULL),
(36973, NULL, 'IPR045107', NULL, 'SAC3/GANP/THP3', 'SAC3/GANP/THP3', 4, NULL),
(36974, NULL, 'IPR045117', NULL, 'Ataxin2-like', 'ATXN2-like', 4, NULL),
(36975, NULL, 'IPR042507', NULL, 'TBC1 domain family member 19', 'TBC1D19', 4, NULL),
(36976, NULL, 'IPR044385', NULL, 'Nonstructural protein 2, HCoV-229E-like', 'NSP2_HCoV-229E-like', 3, NULL),
(36977, NULL, 'IPR045941', NULL, 'Protein of unknown function DUF6361', 'DUF6361', 4, NULL),
(36978, NULL, 'IPR044995', NULL, 'Thiocyanate methyltransferase/thiol methyltransferase', 'TMT/HOL', 4, NULL),
(36979, NULL, 'IPR043403', NULL, 'Protein Gurken/Spitz', 'Gurken/Spitz', 4, NULL),
(36980, NULL, 'IPR046058', NULL, 'Cupin fold metalloprotein WbuC, N-terminal domain', 'Cupin_WbuC_N', 3, NULL),
(36981, NULL, 'IPR044936', NULL, 'Alphavirus nsP2 protease domain superfamily', 'Alphavirus_nsp2pro_sf', 5, NULL),
(36982, NULL, 'IPR045934', NULL, 'Protein of unknown function DUF6354', 'DUF6354', 4, NULL),
(36983, NULL, 'IPR044977', NULL, 'Homeobox-DDT domain protein RLT1/2', 'RLT1/2', 4, NULL),
(36984, NULL, 'IPR046074', NULL, 'Protein of unknown function DUF6092', 'DUF6092', 4, NULL),
(36985, NULL, 'IPR044960', NULL, 'Ribulose bisphosphate carboxylase/oxygenase activase-like', 'RCA-like', 4, NULL),
(36986, NULL, 'IPR044833', NULL, 'Protein WVD2-like 5/6', 'WDL5/6', 4, NULL),
(36987, NULL, 'IPR044654', NULL, 'Fasciclin-like arabinogalactan protein 15/16/17/18', 'FLA15/16/17/18', 4, NULL),
(36988, NULL, 'IPR045234', NULL, 'RING finger protein Unkempt-like', 'Unkempt-like', 4, NULL),
(36989, NULL, 'IPR046875', NULL, 'Predicted novel nucleotide synthetase', 'Pred_NTSase1', 4, NULL),
(36990, NULL, 'IPR046007', NULL, 'Protein of unknown function DUF5963', 'DUF5963', 4, NULL),
(36991, NULL, 'IPR043401', NULL, 'Glial cell line-derived neurotrophic factor family', 'GDNF_fam', 4, NULL),
(36992, NULL, 'IPR046053', NULL, 'Protein of unknown function DUF6011', 'DUF6011', 4, NULL),
(36993, NULL, 'IPR046810', NULL, 'Ezrin/radixin/moesin, alpha-helical domain', 'ERM_helical', 3, NULL),
(36994, NULL, 'IPR042721', NULL, 'Transposase A from transposon Tn554, C-terminal catalytic domain', 'INT_tnpA_C_Tn554', 3, NULL),
(36995, NULL, 'IPR046065', NULL, 'Protein of unknown function DUF6023', 'DUF6023', 4, NULL),
(36996, NULL, 'IPR046046', NULL, 'Protein of unknown function DUF6004', 'DUF6004', 4, NULL),
(36997, NULL, 'IPR042407', NULL, 'Protein NCBP2AS2', 'NCBP2-AS2', 4, NULL),
(36998, NULL, 'IPR046392', NULL, 'DNA primase, bacteriophage T4', 'PRIMASE_T4', 4, NULL),
(36999, NULL, 'IPR045127', NULL, 'Transcription initiation factor TFIID subunit 11-like', 'TAF11-like', 4, NULL),
(37000, NULL, 'IPR044184', NULL, 'F-box protein SNE/GID2', 'SNE/GID2', 4, NULL),
(37001, NULL, 'IPR042132', NULL, 'Ribosomal protein S6 kinase delta-1, PX domain', 'PX_S6K-delta-1', 3, NULL),
(37002, NULL, 'IPR042780', NULL, 'TRIM47, PRY/SPRY domain', 'TRIM47_SPRY_PRY', 3, NULL),
(37003, NULL, 'IPR045522', NULL, 'Protein of unknown function DUF6474', 'DUF6474', 4, NULL),
(37004, NULL, 'IPR045639', NULL, 'Protein of unknown function DUF6408', 'DUF6408', 4, NULL),
(37005, NULL, 'IPR046737', NULL, 'Protein of unknown function DUF6629', 'DUF6629', 4, NULL),
(37006, NULL, 'IPR046177', NULL, 'Protein of unknown function DUF6186', 'DUF6186', 4, NULL),
(37007, NULL, 'IPR045324', NULL, 'Small multidrug resistance protein', 'Small_multidrug_res', 4, NULL),
(37008, NULL, 'IPR045886', NULL, 'ThiF/MoeB/HesA family', 'ThiF/MoeB/HesA', 4, NULL),
(37009, NULL, 'IPR045790', NULL, 'E3 ubiquitin-protein ligase RNF180, C-terminal domain', 'RNF180_C', 3, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(37010, NULL, 'IPR042529', NULL, 'Initiation factor 2B-like, C-terminal', 'IF_2B-like_C', 5, NULL),
(37011, NULL, 'IPR042375', NULL, 'A-kinase anchor protein 5', 'AKAP5', 4, NULL),
(37012, NULL, 'IPR046714', NULL, 'Domain of unknown function DUF6787', 'DUF6787', 3, NULL),
(37013, NULL, 'IPR045439', NULL, 'Effector-associated domain 11', 'EAD11', 3, NULL),
(37014, NULL, 'IPR046702', NULL, 'Protein of unknown function DUF6572', 'DUF6572', 4, NULL),
(37015, NULL, 'IPR046666', NULL, 'Protein of unknown function DUF6775', 'DUF6775', 4, NULL),
(37016, NULL, 'IPR046672', NULL, 'Protein of unknown function DUF6542', 'DUF6542', 3, NULL),
(37017, NULL, 'IPR046709', NULL, 'Domain of unknown function DUF6782', 'DUF6782', 3, NULL),
(37018, NULL, 'IPR046191', NULL, 'Protein of unknown function DUF6219', 'DUF6219', 4, NULL),
(37019, NULL, 'IPR046680', NULL, 'Protein of unknown function DUF6550', 'DUF6550', 4, NULL),
(37020, NULL, 'IPR042373', NULL, 'Tumor necrosis factor ligand superfamily member 9', 'TNFSF9', 4, NULL),
(37021, NULL, 'IPR042520', NULL, 'Glutamate--cysteine ligase GshA, N-terminal', 'GshA_N', 5, NULL),
(37022, NULL, 'IPR045713', NULL, 'Protein of unknown function DUF6069', 'DUF6069', 4, NULL),
(37023, NULL, 'IPR046120', NULL, 'Protein of unknown function DUF6117', 'DUF6117', 4, NULL),
(37024, NULL, 'IPR046706', NULL, 'Domain of unknown function DUF6779', 'DUF6779', 3, NULL),
(37025, NULL, 'IPR042456', NULL, 'Junctional adhesion molecule A', 'F11R', 4, NULL),
(37026, NULL, 'IPR043157', NULL, 'Dynein heavy chain, AAA1 domain, small subdomain', 'Dynein_AAA1S', 5, NULL),
(37027, NULL, 'IPR045275', NULL, 'Mechanosensitive ion channel MscS, archaea/bacteria type', 'MscS_archaea/bacteria_type', 4, NULL),
(37028, NULL, 'IPR046159', NULL, 'Domain of unknown function DUF6161', 'DUF6161', 3, NULL),
(37029, NULL, 'IPR046186', NULL, 'Protein of unknown function DUF6214', 'DUF6214', 4, NULL),
(37030, NULL, 'IPR046655', NULL, 'Domainn of unknown function DUF6673', 'DUF6673', 3, NULL),
(37031, NULL, 'IPR046656', NULL, 'Protein of unknown function DUF6674', 'DUF6674', 4, NULL),
(37032, NULL, 'IPR046150', NULL, 'Protein of unknown function DUF6152', 'DUF6152', 4, NULL),
(37033, NULL, 'IPR045884', NULL, 'Transmembrane protein At5g59350-like', 'At5g59350-like', 4, NULL),
(37034, NULL, 'IPR046207', NULL, 'Protein of unknown function DUF6240', 'DUF6240', 4, NULL),
(37035, NULL, 'IPR046668', NULL, 'Protein of unknown function DUF6538', 'DUF6538', 3, NULL),
(37036, NULL, 'IPR046730', NULL, 'Protein of unknown function DUF6622', 'DUF6622', 4, NULL),
(37037, NULL, 'IPR046134', NULL, 'Protein of unknown function DUF6131', 'DUF6131', 4, NULL),
(37038, NULL, 'IPR046251', NULL, 'Protein of unknown function DUF6284', 'DUF6284', 4, NULL),
(37039, NULL, 'IPR046219', NULL, 'Protein of unknown function DUF6252', 'DUF6252', 4, NULL),
(37040, NULL, 'IPR045823', NULL, 'Tetracyclin repressor-like MT0489/Rv0472c, C-terminal domain', 'TetR_C_32', 3, NULL),
(37041, NULL, 'IPR046728', NULL, 'Protein of unknown function DUF6620', 'DUF6620', 4, NULL),
(37042, NULL, 'IPR046263', NULL, 'Protein of unknown function DUF6296', 'DUF6296', 4, NULL),
(37043, NULL, 'IPR046154', NULL, 'Protein of unknown function DUF6156', 'DUF6156', 4, NULL),
(37044, NULL, 'IPR046173', NULL, 'Protein of unknown function DUF6175', 'DUF6175', 4, NULL),
(37045, NULL, 'IPR046694', NULL, 'Domain of unknown function DUF6564', 'DUF6564', 3, NULL),
(37046, NULL, 'IPR046722', NULL, 'Protein of unknown function DUF6614', 'DUF6614', 4, NULL),
(37047, NULL, 'IPR046198', NULL, 'Protein of unknown function DUF6230', 'DUF6230', 4, NULL),
(37048, NULL, 'IPR042130', NULL, 'SNX7, PX domain', 'PX_SNX7', 3, NULL),
(37049, NULL, 'IPR046194', NULL, 'Protein of unknown function DUF6222', 'DUF6222', 4, NULL),
(37050, NULL, 'IPR046106', NULL, 'Protein of unknown function DUF6043', 'DUF6043', 4, NULL),
(37051, NULL, 'IPR045285', NULL, 'GPI-anchored protein At5g19230-like', 'At5g19230-like', 4, NULL),
(37052, NULL, 'IPR042522', NULL, 'Ubiquitin-like modifier-activating enzyme Atg7, N-terminal, subdomain 1', 'Atg7_N_1', 5, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(37053, NULL, 'IPR046182', NULL, 'Protein of unknown function DUF6210', 'DUF6210', 4, NULL),
(37054, NULL, 'IPR045548', NULL, 'MoxR-vWA-beta-propeller ternary system domain bpX5', 'bpX5', 3, NULL),
(37055, NULL, 'IPR045791', NULL, 'Semaphorin 4F, C-terminal', 'Sema4F_C', 3, NULL),
(37056, NULL, 'IPR045640', NULL, 'Protein of unknown function DUF6407', 'DUF6407', 4, NULL),
(37057, NULL, 'IPR045564', NULL, 'Protein of unknown function DUF5910', 'DUF5910', 4, NULL),
(37058, NULL, 'IPR045663', NULL, 'Origin recognition complex subunit 3, insertion domain', 'ORC3_ins', 3, NULL),
(37059, NULL, 'IPR045665', NULL, 'Protein of unknown function DUF6386', 'DUF6386', 4, NULL),
(37060, NULL, 'IPR045797', NULL, 'Evasins Class A', 'EVA_Class_A', 4, NULL),
(37061, NULL, 'IPR046658', NULL, 'Protein of unknown function DUF6767', 'DUF6767', 4, NULL),
(37062, NULL, 'IPR045375', NULL, 'Putative radical SAM, N-terminal', 'Put_radical_SAM-like_N', 3, NULL),
(37063, NULL, 'IPR046238', NULL, 'Protein of unknown function DUF6271', 'DUF6271', 4, NULL),
(37064, NULL, 'IPR046676', NULL, 'Protein of unknown function DUF6546', 'DUF6546', 4, NULL),
(37065, NULL, 'IPR045533', NULL, 'GTPase-associated adaptor domain', 'GAAD', 3, NULL),
(37066, NULL, 'IPR046157', NULL, 'Protein of unknown function DUF6159', 'DUF6159', 4, NULL),
(37067, NULL, 'IPR045343', NULL, 'VpsR domain', 'VpsR', 3, NULL),
(37068, NULL, 'IPR045878', NULL, 'Guanine nucleotide-binding protein subunit gamma 1/2', 'GG1/2', 4, NULL),
(37069, NULL, 'IPR046660', NULL, 'Protein of unknown function DUF6769', 'DUF6769', 4, NULL),
(37070, NULL, 'IPR045537', NULL, 'La-related protein 7 homolog, xRRM domain', 'Lar7_xRRM', 3, NULL),
(37071, NULL, 'IPR045276', NULL, 'Mechanosensitive ion channel YbiO', 'YbiO_bact', 4, NULL),
(37072, NULL, 'IPR045421', NULL, 'Domain of unknown function DUF5902', 'DUF5902', 3, NULL),
(37073, NULL, 'IPR045462', NULL, 'Aminoacyl-tRNA synthetase, class I, anticodon-binding', 'aa-tRNA-synth_I_cd-bd', 3, NULL),
(37074, NULL, 'IPR042519', NULL, 'Non-structural protein NSP3, N-terminal, rotavirus', 'NSP3_N_rotavirus', 5, NULL),
(37075, NULL, 'IPR046195', NULL, 'Protein of unknown function DUF6227', 'DUF6227', 4, NULL),
(37076, NULL, 'IPR046204', NULL, 'Protein of unknown function DUF6237', 'DUF6237', 4, NULL),
(37077, NULL, 'IPR045554', NULL, 'MoxR-vWA-beta-propeller ternary system domain bpX0', 'bpX0', 3, NULL),
(37078, NULL, 'IPR046725', NULL, 'Protein of unknown function DUF6617', 'DUF6617', 4, NULL),
(37079, NULL, 'IPR043082', NULL, 'Baculovirus occlusion-derived virus envelope, E66, core domain', 'Baculo_ODV-E66_core', 5, NULL),
(37080, NULL, 'IPR046687', NULL, 'Protein of unknown function DUF6557', 'DUF6557', 4, NULL),
(37081, NULL, 'IPR046662', NULL, 'Protein of unknown function DUF6771', 'DUF6771', 4, NULL),
(37082, NULL, 'IPR046113', NULL, 'Protein of unknown function DUF6050', 'DUF6050', 4, NULL),
(37083, NULL, 'IPR045298', NULL, 'LYRM7, LYR domain', 'Complex1_LYR_LYRM7', 3, NULL),
(37084, NULL, 'IPR045306', NULL, 'Sorbitol dehydrogenase-like', 'SDH-like', 4, NULL),
(37085, NULL, 'IPR046711', NULL, 'Domain of unknown function DUF6784', 'DUF6784', 3, NULL),
(37086, NULL, 'IPR046227', NULL, 'Protein of unknown function DUF6260', 'DUF6260', 4, NULL),
(37087, NULL, 'IPR046135', NULL, 'Protein of unknown function DUF6137', 'DUF6137', 4, NULL),
(37088, NULL, 'IPR042460', NULL, 'DCN1-like, PONY binding domain', 'DCN1-like_PONY', 5, NULL),
(37089, NULL, 'IPR046795', NULL, 'Transmembrane protein 127, transmembrane region', 'TMEM127_TM', 3, NULL),
(37090, NULL, 'IPR046123', NULL, 'Protein of unknown function DUF6120', 'DUF6120', 4, NULL),
(37091, NULL, 'IPR045514', NULL, 'Protein of unknown function DUF6478', 'DUF6478', 4, NULL),
(37092, NULL, 'IPR045416', NULL, 'Domain of unknown function DUF5897', 'DUF5897', 3, NULL),
(37093, NULL, 'IPR046142', NULL, 'Protein of unknown function DUF6144', 'DUF6144', 4, NULL),
(37094, NULL, 'IPR046679', NULL, 'Protein of unknown function DUF6549', 'DUF6549', 4, NULL),
(37095, NULL, 'IPR046226', NULL, 'Domain of unknown function DUF6259', 'DUF6259', 3, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(37096, NULL, 'IPR046183', NULL, 'Protein of unknown function DUF6211', 'DUF6211', 4, NULL),
(37097, NULL, 'IPR045361', NULL, 'Contractile injection system tube protein, N-terminal domain', 'CIS_tube_prot_N', 3, NULL),
(37098, NULL, 'IPR046105', NULL, 'Protein of unknown function DUF6042', 'DUF6042', 4, NULL),
(37099, NULL, 'IPR046836', NULL, 'Retrotransposon hot spot protein,C-terminal', 'RHS_C', 3, NULL),
(37100, NULL, 'IPR046273', NULL, 'Domain of unknown function DUF6306', 'DUF6306', 3, NULL),
(37101, NULL, 'IPR046111', NULL, 'Protein of unknown function DUF6048', 'DUF6048', 4, NULL),
(37102, NULL, 'IPR046117', NULL, 'Protein of unknown function DUF6054', 'DUF6054', 4, NULL),
(37103, NULL, 'IPR042203', NULL, 'Leucyl/phenylalanyl-tRNA-protein transferase, C-terminal', 'Leu/Phe-tRNA_Trfase_C', 5, NULL),
(37104, NULL, 'IPR045302', NULL, 'NHL2, NHL repeat domain', 'NHL2_NHL_rpt_dom', 3, NULL),
(37105, NULL, 'IPR045552', NULL, 'MoxR-vWA-beta-propeller ternary system domain bpX2', 'bpX2', 3, NULL),
(37106, NULL, 'IPR045850', NULL, 'tRNA (uracil(54)-C(5))-methyltransferase, metazoa type', 'TRM2_met', 4, NULL),
(37107, NULL, 'IPR045297', NULL, 'LYRM4, LYR domain', 'Complex1_LYR_LYRM4', 3, NULL),
(37108, NULL, 'IPR045890', NULL, 'BTB/POZ domain-containing protein POB1-like', 'POB1-like', 4, NULL),
(37109, NULL, 'IPR045371', NULL, 'ADAMTS/ADAMTS-like, cysteine-rich domain 3', 'ADAMTS_CR_3', 3, NULL),
(37110, NULL, 'IPR046165', NULL, 'Protein of unknown function DUF6167', 'DUF6167', 4, NULL),
(37111, NULL, 'IPR045499', NULL, 'Protein of unknown function DUF6492', 'DUF6492', 4, NULL),
(37112, NULL, 'IPR045757', NULL, 'Protein of unknown function DUF6184', 'DUF6184', 4, NULL),
(37113, NULL, 'IPR046665', NULL, 'Domain of unknown function DUF6774', 'DUF6774', 3, NULL),
(37114, NULL, 'IPR046726', NULL, 'Protein of unknown function DUF6618', 'DUF6618', 4, NULL),
(37115, NULL, 'IPR046745', NULL, 'Protein of unknown function DUF6675', 'DUF6675', 4, NULL),
(37116, NULL, 'IPR046153', NULL, 'Protein of unknown function DUF6155', 'DUF6155', 4, NULL),
(37117, NULL, 'IPR046239', NULL, 'Protein of unknown function DUF6272', 'DUF6272', 4, NULL),
(37118, NULL, 'IPR045509', NULL, 'HD-associated domain', 'HD_assoc_2', 3, NULL),
(37119, NULL, 'IPR046675', NULL, 'Protein of unknown function DUF6545', 'DUF6545', 4, NULL),
(37120, NULL, 'IPR046146', NULL, 'Protein of unknown function DUF6148', 'DUF6148', 4, NULL),
(37121, NULL, 'IPR046733', NULL, 'Protein of unknown function DUF6625', 'DUF6625', 4, NULL),
(37122, NULL, 'IPR045270', NULL, 'Serine/Threonine Kinase AGC, catalytic domain', 'STKc_AGC', 3, NULL),
(37123, NULL, 'IPR046267', NULL, 'Protein of unknown function DUF6300', 'DUF6300', 4, NULL),
(37124, NULL, 'IPR045540', NULL, 'YegS/DAGK, C-terminal domain', 'YegS/DAGK_C', 3, NULL),
(37125, NULL, 'IPR046185', NULL, 'Protein of unknown function DUF6213', 'DUF6213', 4, NULL),
(37126, NULL, 'IPR045266', NULL, 'Copper-dependent monooxygenases, DOMON domain', 'DOH_DOMON', 3, NULL),
(37127, NULL, 'IPR045444', NULL, 'Protein of unknown function DUF6503', 'DUF6503', 4, NULL),
(37128, NULL, 'IPR045516', NULL, 'Protein of unknown function DUF6477', 'DUF6477', 4, NULL),
(37129, NULL, 'IPR046223', NULL, 'Protein of unknown function DUF6256', 'DUF6256', 4, NULL),
(37130, NULL, 'IPR046928', NULL, 'Ribosome maturation protein SDO1/SBDS, C-terminal domain', 'SDO1/SBDS_C', 3, NULL),
(37131, NULL, 'IPR046721', NULL, 'Protein of unknown function DUF6613', 'DUF6613', 4, NULL),
(37132, NULL, 'IPR045265', NULL, 'AIR12, DOMON domain', 'AIR12_DOMON', 3, NULL),
(37133, NULL, 'IPR045510', NULL, 'Protein of unknown function DUF6481', 'DUF6481', 4, NULL),
(37134, NULL, 'IPR045700', NULL, 'Rab3GAP catalytic subunit', 'Rab3GAP1', 4, NULL),
(37135, NULL, 'IPR045560', NULL, '4-carboxy-2-hydroxymuconate-6-semialdehyde dehydrogenase-like, C-terminal', 'LigC_C', 3, NULL),
(37136, NULL, 'IPR046739', NULL, 'Protein of unknown function DUF6789', 'DUF6789', 4, NULL),
(37137, NULL, 'IPR046138', NULL, 'Protein of unknown function DUF6140', 'DUF6140', 4, NULL);      
INSERT INTO "PUBLIC"."ENTRY" VALUES
(37138, NULL, 'IPR045507', NULL, 'Protein of unknown function DUF6483', 'DUF6483', 4, NULL),
(37139, NULL, 'IPR046137', NULL, 'Protein of unknown function DUF6139', 'DUF6139', 4, NULL),
(37140, NULL, 'IPR042246', NULL, 'Zinc finger CCHC domain-containing protein 9', 'ZCCHC9', 4, NULL),
(37141, NULL, 'IPR046736', NULL, 'Protein of unknown function DUF6628', 'DUF6628', 4, NULL),
(37142, NULL, 'IPR046701', NULL, 'Protein of unknown function DUF6571', 'DUF6571', 4, NULL),
(37143, NULL, 'IPR046161', NULL, 'Protein of unknown function DUF6163', 'DUF6163', 4, NULL),
(37144, NULL, 'IPR042521', NULL, 'Dual specificity tyrosine-phosphorylation-regulated kinase', 'DYRK', 5, NULL),
(37145, NULL, 'IPR045590', NULL, 'Protein of unknown function DUF6463', 'DUF6463', 4, NULL),
(37146, NULL, 'IPR046121', NULL, 'Protein of unknown function DUF6118', 'DUF6118', 4, NULL),
(37147, NULL, 'IPR046700', NULL, 'Domain of unknown function DUF6570', 'DUF6570', 3, NULL),
(37148, NULL, 'IPR046209', NULL, 'Domain of unknown function DUF6242', 'DUF6242', 3, NULL),
(37149, NULL, 'IPR046688', NULL, 'Protein of unknown function DUF6558', 'DUF6558', 4, NULL),
(37150, NULL, 'IPR046225', NULL, 'Protein of unknown function DUF6258', 'DUF6258', 4, NULL),
(37151, NULL, 'IPR046253', NULL, 'Domain of unknown function DUF6286', 'DUF6286', 3, NULL),
(37152, NULL, 'IPR046663', NULL, 'Protein of unknown function DUF6772', 'DUF6772', 4, NULL),
(37153, NULL, 'IPR046734', NULL, 'Protein of unknown function DUF6626', 'DUF6626', 4, NULL),
(37154, NULL, 'IPR046257', NULL, 'Protein of unknown function DUF6290', 'DUF6290', 4, NULL),
(37155, NULL, 'IPR046147', NULL, 'Protein of unknown function DUF6149', 'DUF6149', 4, NULL),
(37156, NULL, 'IPR045829', NULL, 'PKD-like domain', 'PKD_6', 3, NULL),
(37157, NULL, 'IPR046244', NULL, 'Protein of unknown function DUF6277', 'DUF6277', 4, NULL),
(37158, NULL, 'IPR046187', NULL, 'Protein of unknown function DUF6215', 'DUF6215', 4, NULL),
(37159, NULL, 'IPR046671', NULL, 'Protein of unknown function DUF6541', 'DUF6541', 4, NULL),
(37160, NULL, 'IPR045411', NULL, 'Protein of unknown function DUF5892', 'DUF5892', 4, NULL),
(37161, NULL, 'IPR042525', NULL, 'DNA repair protein Rad52/59/22 superfamily', 'Rad52_Rad59_Rad22_sf', 5, NULL),
(37162, NULL, 'IPR045882', NULL, 'GROWING PLUS-END TRACKING 1/2', 'GPT1/2', 4, NULL),
(37163, NULL, 'IPR045322', NULL, 'E3 ubiquitin-protein ligase HECTD1/TRIP12-like', 'HECTD1/TRIP12-like', 4, NULL),
(37164, NULL, 'IPR046715', NULL, 'Protein of unknown function DUF6607', 'DUF6607', 4, NULL),
(37165, NULL, 'IPR045320', NULL, 'Zinc finger protein JAGGED/STAMENLESS 1-like', 'JAGGED/SL1-like', 4, NULL),
(37166, NULL, 'IPR046169', NULL, 'Protein of unknown function DUF6171', 'DUF6171', 4, NULL),
(37167, NULL, 'IPR046653', NULL, 'Protein of unknown function DUF6765', 'DUF6765', 4, NULL),
(37168, NULL, 'IPR042361', NULL, 'Z-DNA-binding protein 1', 'ZBP1', 4, NULL),
(37169, NULL, 'IPR046256', NULL, 'Protein of unknown function DUF6289', 'DUF6289', 4, NULL),
(37170, NULL, 'IPR045264', NULL, 'SPXM, SPX domain', 'SPXM_SPX_plant', 3, NULL),
(37171, NULL, 'IPR043321', NULL, 'BACH, basic leucine zipper (bZIP) domain', 'bZIP_BACH', 3, NULL),
(37172, NULL, 'IPR046683', NULL, 'Protein of unknown function DUF6553', 'DUF6553', 4, NULL),
(37173, NULL, 'IPR046148', NULL, 'Protein of unknown function DUF6150', 'DUF6150', 4, NULL),
(37174, NULL, 'IPR046166', NULL, 'Protein of unknown function DUF6168', 'DUF6168', 4, NULL),
(37175, NULL, 'IPR045448', NULL, 'Protein of unknown function DUF6500', 'DUF6500', 4, NULL),
(37176, NULL, 'IPR046242', NULL, 'Protein of unknown function DUF6275', 'DUF6275', 4, NULL),
(37177, NULL, 'IPR042167', NULL, 'Serine protease inhibitor Kazal-type 2', 'SPINK2', 4, NULL),
(37178, NULL, 'IPR045512', NULL, 'Protein of unknown function DUF6480', 'DUF6480', 4, NULL),
(37179, NULL, 'IPR046125', NULL, 'Protein of unknown function DUF6122', 'DUF6122', 4, NULL),
(37180, NULL, 'IPR045743', NULL, 'Domain of unknown function DUF6089', 'DUF6089', 3, NULL),
(37181, NULL, 'IPR042165', NULL, 'Phosphatidylglycerophosphatase and protein-tyrosine phosphatase 1', 'PTPMT1', 4, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(37182, NULL, 'IPR045598', NULL, 'Domain of unknown function DUF6457', 'DUF6457', 3, NULL),
(37183, NULL, 'IPR043990', NULL, 'Autochaperone domain type 1', 'AC_1', 3, NULL),
(37184, NULL, 'IPR046118', NULL, 'Protein of unknown function DUF6115', 'DUF6115', 4, NULL),
(37185, NULL, 'IPR046678', NULL, 'Protein of unknown function DUF6548', 'DUF6548', 4, NULL),
(37186, NULL, 'IPR045434', NULL, 'Effector-associated domain 4', 'EAD4', 3, NULL),
(37187, NULL, 'IPR045304', NULL, 'Serine acetyltransferase, LbH domain', 'LbH_SAT', 3, NULL),
(37188, NULL, 'IPR043994', NULL, 'Bacterial toxin, RNase RnlA/LsoA, DBD domain', 'RnlA/LsoA-toxin_DBD', 3, NULL),
(37189, NULL, 'IPR046724', NULL, 'Protein of unknown function DUF6616', 'DUF6616', 4, NULL),
(37190, NULL, 'IPR046699', NULL, 'Domain of unknown function DUF6569', 'DUF6569', 3, NULL),
(37191, NULL, 'IPR046718', NULL, 'Protein of unknown function DUF6610', 'DUF6610', 4, NULL),
(37192, NULL, 'IPR046163', NULL, 'Protein of unknown function DUF6165', 'DUF6165', 4, NULL),
(37193, NULL, 'IPR046717', NULL, 'Protein of unknown function DUF6609', 'DUF6609', 4, NULL),
(37194, NULL, 'IPR046170', NULL, 'Protein of unknown function DUF6172', 'DUF6172', 4, NULL),
(37195, NULL, 'IPR042530', NULL, 'EME1/EME2, C-terminal domain', 'EME1/EME2_C', 5, NULL),
(37196, NULL, 'IPR046156', NULL, 'Protein of unknown function DUF6158', 'DUF6158', 4, NULL),
(37197, NULL, 'IPR043172', NULL, 'Prp8 RNase domain IV, palm region', 'Prp8_domainIV_palm', 5, NULL),
(37198, NULL, 'IPR044147', NULL, 'Uracil DNA glycosylase family 5', 'UdgB-like', 3, NULL),
(37199, NULL, 'IPR042135', NULL, 'SNX5, PX domain', 'PX_SNX5', 3, NULL),
(37200, NULL, 'IPR046731', NULL, 'Protein of unknown function DUF6623', 'DUF6623', 4, NULL),
(37201, NULL, 'IPR046685', NULL, 'Protein of unknown function DUF6555', 'DUF6555', 4, NULL),
(37202, NULL, 'IPR043131', NULL, 'Branched-chain-amino-acid aminotransferase-like, N-terminal', 'BCAT-like_N', 5, NULL),
(37203, NULL, 'IPR045301', NULL, 'Protein GAMETE EXPRESSED 3-like', 'GEX3-like', 4, NULL),
(37204, NULL, 'IPR046115', NULL, 'Protein of unknown function DUF6052', 'DUF6052', 4, NULL),
(37205, NULL, 'IPR045831', NULL, 'LIN-9, C-terminal', 'LIN9_C', 3, NULL),
(37206, NULL, 'IPR046108', NULL, 'Protein of unknown function DUF6045', 'DUF6045', 4, NULL),
(37207, NULL, 'IPR045341', NULL, 'Domain of unknown function DUF6532', 'DUF6532', 3, NULL),
(37208, NULL, 'IPR046213', NULL, 'Protein of unknown function DUF6246', 'DUF6246', 4, NULL),
(37209, NULL, 'IPR046197', NULL, 'Protein of unknown function DUF6229', 'DUF6229', 4, NULL),
(37210, NULL, 'IPR046259', NULL, 'Domain of unknown function DUF6292', 'DUF6292', 3, NULL),
(37211, NULL, 'IPR046220', NULL, 'Protein of unknown function DUF6253', 'DUF6253', 4, NULL),
(37212, NULL, 'IPR045309', NULL, 'Xanthoxin dehydrogenase  ABA2-like', 'ABA2-like', 4, NULL),
(37213, NULL, 'IPR046206', NULL, 'Protein of unknown function DUF6239', 'DUF6239', 4, NULL),
(37214, NULL, 'IPR046265', NULL, 'Domain of unknown function DUF6298', 'DUF6298', 3, NULL),
(37215, NULL, 'IPR046201', NULL, 'Protein of unknown function DUF6234', 'DUF6234', 4, NULL),
(37216, NULL, 'IPR046271', NULL, 'Protein of unknown function DUF6304', 'DUF6304', 4, NULL),
(37217, NULL, 'IPR045501', NULL, 'Protein of unknown function DUF6490', 'DUF6490', 4, NULL),
(37218, NULL, 'IPR042168', NULL, 'Purkinje cell protein 2', 'Pcp2', 4, NULL),
(37219, NULL, 'IPR046229', NULL, 'Transposase for transposon Tn554-like', 'TnpC-like', 4, NULL),
(37220, NULL, 'IPR042134', NULL, 'Phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit beta, PX domain', 'PX_PI3K_C2_beta', 3, NULL),
(37221, NULL, 'IPR045342', NULL, 'Septation protein Etd1', 'Etd1', 4, NULL),
(37222, NULL, 'IPR045449', NULL, 'vWA-MoxR associated protein middle region 4', 'VMAP-M4', 3, NULL),
(37223, NULL, 'IPR046144', NULL, 'Protein of unknown function DUF6146', 'DUF6146', 4, NULL),
(37224, NULL, 'IPR043085', NULL, 'Gp27, baseplate hub, domain 2', 'Gp27_dom2', 5, NULL),
(37225, NULL, 'IPR045775', NULL, 'Protein of unknown function DUF6207', 'DUF6207', 4, NULL);        
INSERT INTO "PUBLIC"."ENTRY" VALUES
(37226, NULL, 'IPR045271', NULL, 'Receptor-like protein kinase SRF-like', 'SRF-like', 4, NULL),
(37227, NULL, 'IPR046667', NULL, 'Protein of unknown function DUF6537', 'DUF6537', 3, NULL),
(37228, NULL, 'IPR043080', NULL, 'Hemolytic toxin, N-terminal domain superfamily', 'Hemolysin_N_sf', 5, NULL),
(37229, NULL, 'IPR045506', NULL, 'Domain of unknown function DUF6484', 'DUF6484', 3, NULL),
(37230, NULL, 'IPR045305', NULL, 'PABP, RNA recognition motif 2', 'RRM2_I_PABPs', 3, NULL),
(37231, NULL, 'IPR042136', NULL, 'SNX6, PX domain', 'PX_SNX6', 3, NULL),
(37232, NULL, 'IPR046151', NULL, 'Protein of unknown function DUF6153', 'DUF6153', 4, NULL),
(37233, NULL, 'IPR045515', NULL, 'Domain of unknown function DUF6440', 'DUF6440', 3, NULL),
(37234, NULL, 'IPR045636', NULL, 'Protein of unknown function DUF6411', 'DUF6411', 4, NULL),
(37235, NULL, 'IPR043079', NULL, 'EV matrix protein, N-terminal', 'EV_matrix_protein_N', 5, NULL),
(37236, NULL, 'IPR045495', NULL, 'PI4-kinase, N-terminal', 'PI4K_N', 3, NULL),
(37237, NULL, 'IPR045338', NULL, 'Domain of unknown function DUF6535', 'DUF6535', 3, NULL),
(37238, NULL, 'IPR042166', NULL, 'Vesicle-associated membrane protein 5', 'Vamp5', 4, NULL),
(37239, NULL, 'IPR045545', NULL, 'Phytanoyl-CoA hydroxylase-interacting protein-like, C-terminal', 'PHYIP/PHIPL_C', 3, NULL),
(37240, NULL, 'IPR045638', NULL, 'Protein of unknown function DUF6409', 'DUF6409', 4, NULL),
(37241, NULL, 'IPR045504', NULL, 'Domain of unknown function DUF6487', 'DUF6487', 3, NULL),
(37242, NULL, 'IPR046738', NULL, 'Protein of unknown function DUF6788', 'DUF6788', 4, NULL),
(37243, NULL, 'IPR046160', NULL, 'Protein of unknown function DUF6162', 'DUF6162', 4, NULL),
(37244, NULL, 'IPR046697', NULL, 'Protein of unknown function DUF6567', 'DUF6567', 4, NULL),
(37245, NULL, 'IPR046230', NULL, 'Protein of unknown function DUF6263', 'DUF6263', 4, NULL),
(37246, NULL, 'IPR042401', NULL, 'Testicular haploid expressed gene protein-like', 'THEG-like', 4, NULL),
(37247, NULL, 'IPR045667', NULL, 'Origin recognition complex subunit 3, N-terminal', 'ORC3_N', 3, NULL),
(37248, NULL, 'IPR045758', NULL, 'Solute-binding protein AdeT 1/2', 'AdeT1/2', 4, NULL),
(37249, NULL, 'IPR046674', NULL, 'Protein of unknown function DUF6544', 'DUF6544', 4, NULL),
(37250, NULL, 'IPR045258', NULL, 'ArfGAP ACAP1/2/3-like', 'ACAP1/2/3-like', 4, NULL),
(37251, NULL, 'IPR045519', NULL, 'Protein of unknown function DUF6476', 'DUF6476', 4, NULL),
(37252, NULL, 'IPR045873', NULL, 'ADP-ribosylation factor-like protein 2', 'Arl2', 4, NULL),
(37253, NULL, 'IPR045316', NULL, 'Zinc transporter Msc2-like', 'Msc2-like', 4, NULL),
(37254, NULL, 'IPR045600', NULL, 'RelA/SpoT, AH and RIS domains', 'RelA/SpoT_AH_RIS', 3, NULL),
(37255, NULL, 'IPR045255', NULL, 'Ran binding protein RanBP1-like', 'RanBP1-like', 4, NULL),
(37256, NULL, 'IPR043183', NULL, 'DnaJ homolog subfamily B member 2/6-like', 'DNJB2/6-like', 4, NULL),
(37257, NULL, 'IPR046268', NULL, 'Protein of unknown function DUF6301', 'DUF6301', 4, NULL),
(37258, NULL, 'IPR046272', NULL, 'Domain of unknown function DUF6305', 'DUF6305', 3, NULL),
(37259, NULL, 'IPR046707', NULL, 'Domain of unknown function DUF6780', 'DUF6780', 3, NULL),
(37260, NULL, 'IPR045547', NULL, 'MoxR-vWA-beta-propeller ternary system domain bpX6', 'bpX6', 3, NULL),
(37261, NULL, 'IPR042148', NULL, 'RAIDD, CARD domain', 'CARD_RAIDD', 3, NULL),
(37262, NULL, 'IPR046192', NULL, 'Protein of unknown function DUF6220', 'DUF6220', 4, NULL),
(37263, NULL, 'IPR045549', NULL, 'MoxR-vWA-beta-propeller ternary system domain bpX4', 'bpX4', 3, NULL),
(37264, NULL, 'IPR046179', NULL, 'Protein of unknown function DUF6188', 'DUF6188', 4, NULL),
(37265, NULL, 'IPR045263', NULL, 'Glucose transporter GLUT', 'GLUT', 4, NULL),
(37266, NULL, 'IPR046175', NULL, 'Protein of unknown function DUF6177', 'DUF6177', 4, NULL),
(37267, NULL, 'IPR045896', NULL, 'Transcription factor MYC1-like, bHLH domain', 'MYC1-like_bHLH', 3, NULL),
(37268, NULL, 'IPR046139', NULL, 'Protein of unknown function DUF6141', 'DUF6141', 4, NULL),
(37269, NULL, 'IPR046673', NULL, 'Domain of unknown function DUF6543', 'DUF6543', 3, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(37270, NULL, 'IPR046245', NULL, 'Protein of unknown function DUF6278', 'DUF6278', 4, NULL),
(37271, NULL, 'IPR046248', NULL, 'Protein of unknown function DUF6281', 'DUF6281', 4, NULL),
(37272, NULL, 'IPR046252', NULL, 'Domain of unknown function DUF6285', 'DUF6285', 3, NULL),
(37273, NULL, 'IPR045880', NULL, 'ZCF37', 'ZCF37', 4, NULL),
(37274, NULL, 'IPR045379', NULL, 'Crinkler effector protein, N-terminal', 'Crinkler_N', 3, NULL),
(37275, NULL, 'IPR045500', NULL, 'Protein of unknown function DUF6491', 'DUF6491', 4, NULL),
(37276, NULL, 'IPR046136', NULL, 'Protein of unknown function DUF6138', 'DUF6138', 4, NULL),
(37277, NULL, 'IPR045799', NULL, 'TBC1 domain family member 23, C-terminal domain', 'TBC1D23_C', 3, NULL),
(37278, NULL, 'IPR045830', NULL, 'AraR-like, winged helix DNA-binding domain', 'AraR_wHTH_dom', 3, NULL),
(37279, NULL, 'IPR043220', NULL, 'POM121-like protein 1', 'POM121-like_prot_1', 4, NULL),
(37280, NULL, 'IPR046708', NULL, 'Protein of unknown function DUF6781', 'DUF6781', 4, NULL),
(37281, NULL, 'IPR043097', NULL, 'Phosphoprotein P, oligomerisation domain 1', 'PProtein_oligomer_dom1', 5, NULL),
(37282, NULL, 'IPR046690', NULL, 'Protein of unknown function DUF6560', 'DUF6560', 4, NULL),
(37283, NULL, 'IPR045551', NULL, 'MoxR-vWA-beta-propeller ternary system domain bpX3', 'bpX3', 3, NULL),
(37284, NULL, 'IPR042528', NULL, 'Translation initiation factor eIF-2B subunit alpha, N-terminal', 'elF-2B_alpha_N', 5, NULL),
(37285, NULL, 'IPR046184', NULL, 'Protein of unknown function DUF6212', 'DUF6212', 4, NULL),
(37286, NULL, 'IPR046260', NULL, 'Domain of unknown function DUF6293', 'DUF6293', 3, NULL),
(37287, NULL, 'IPR046214', NULL, 'Protein of unknown function DUF6247', 'DUF6247', 4, NULL),
(37288, NULL, 'IPR046181', NULL, 'Protein of unknown function DUF6209', 'DUF6209', 4, NULL),
(37289, NULL, 'IPR042227', NULL, 'NF-kappa-B inhibitor-interacting Ras-like protein', 'KBRS', 4, NULL),
(37290, NULL, 'IPR045517', NULL, 'Glyoxalase-related protein', 'Glyoxalase_8', 3, NULL),
(37291, NULL, 'IPR045556', NULL, 'Domain of unknown function DUF6351', 'DUF6351', 3, NULL),
(37292, NULL, 'IPR042105', NULL, 'Ribosomal protein L31 superfamily', 'Ribosomal_L31_sf', 5, NULL),
(37293, NULL, 'IPR046258', NULL, 'Domain of unknown function DUF6291', 'DUF6291', 3, NULL),
(37294, NULL, 'IPR046132', NULL, 'Domain of unknown function DUF6129', 'DUF6129', 3, NULL),
(37295, NULL, 'IPR045409', NULL, 'Protein of unknown function DUF5891', 'DUF5891', 4, NULL),
(37296, NULL, 'IPR045690', NULL, 'Protein of unknown function DUF6055', 'DUF6055', 4, NULL),
(37297, NULL, 'IPR044125', NULL, 'DNA Ligase 4, adenylation domain', 'Adenylation_DNA_ligase_IV', 3, NULL),
(37298, NULL, 'IPR042237', NULL, 'Putative peptidyl-tRNA hydrolase PTRHD1', 'PTRHD1', 4, NULL),
(37299, NULL, 'IPR042372', NULL, 'Interleukin-15 receptor subunit alpha', 'IL15RA', 4, NULL),
(37300, NULL, 'IPR046720', NULL, 'Protein of unknown function DUF6612', 'DUF6612', 4, NULL),
(37301, NULL, 'IPR045364', NULL, 'Protein of unknown function DUF5883', 'DUF5883', 4, NULL),
(37302, NULL, 'IPR045315', NULL, 'Mitochondrial carrier protein Mtm1-like', 'Mtm1-like', 4, NULL),
(37303, NULL, 'IPR046152', NULL, 'Protein of unknown function DUF6154', 'DUF6154', 4, NULL),
(37304, NULL, 'IPR045630', NULL, 'Domain of unknown function DUF6316', 'DUF6316', 3, NULL),
(37305, NULL, 'IPR045777', NULL, 'Protein of unknown function DUF6203', 'DUF6203', 4, NULL),
(37306, NULL, 'IPR046696', NULL, 'Domain of unknown function DUF6566', 'DUF6566', 3, NULL),
(37307, NULL, 'IPR046164', NULL, 'Protein of unknown function DUF6166', 'DUF6166', 4, NULL),
(37308, NULL, 'IPR046232', NULL, 'Domain of unknown function DUF6265', 'DUF6265', 3, NULL),
(37309, NULL, 'IPR045281', NULL, 'Zinc finger protein CONSTANS-like', 'CONSTANS-like', 4, NULL),
(37310, NULL, 'IPR042234', NULL, 'WD repeat and FYVE domain-containing protein 1/2', 'WDFY1/WDFY2', 4, NULL),
(37311, NULL, 'IPR046661', NULL, 'Protein of unknown function DUF6770', 'DUF6770', 4, NULL),
(37312, NULL, 'IPR045446', NULL, 'vWA-MoxR associated protein middle region 2', 'VMAP-M2', 3, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(37313, NULL, 'IPR046158', NULL, 'Protein of unknown function DUF6160', 'DUF6160', 4, NULL),
(37314, NULL, 'IPR046234', NULL, 'Protein of unknown function DUF6267', 'DUF6267', 4, NULL),
(37315, NULL, 'IPR046211', NULL, 'Protein of unknown function DUF6244', 'DUF6244', 4, NULL),
(37316, NULL, 'IPR046705', NULL, 'Protein of unknown function DUF6778', 'DUF6778', 4, NULL),
(37317, NULL, 'IPR046796', NULL, 'Putative plant transposon protein domain', 'Transposase_32_dom', 3, NULL),
(37318, NULL, 'IPR046732', NULL, 'Protein of unknown function DUF6624', 'DUF6624', 4, NULL),
(37319, NULL, 'IPR046719', NULL, 'Protein of unknown function DUF6611', 'DUF6611', 4, NULL),
(37320, NULL, 'IPR046171', NULL, 'Protein of unknown function DUF6173', 'DUF6173', 4, NULL),
(37321, NULL, 'IPR046693', NULL, 'Protein of unknown function DUF6563', 'DUF6563', 4, NULL),
(37322, NULL, 'IPR045578', NULL, 'Ubiquitin carboxyl-terminal hydrolase 47, C-terminal', 'USP47_C', 3, NULL),
(37323, NULL, 'IPR046241', NULL, 'Protein of unknown function DUF6274', 'DUF6274', 4, NULL),
(37324, NULL, 'IPR045256', NULL, 'Ran-specific GTPase-activating protein 1, Ran-binding domain', 'RanBP1_RanBD', 3, NULL),
(37325, NULL, 'IPR046670', NULL, 'Protein of unknown function DUF6540', 'DUF6540', 4, NULL),
(37326, NULL, 'IPR045704', NULL, 'BTB/POZ domain-containing protein KCTD18, C-terminal domain', 'KCTD18_C', 3, NULL),
(37327, NULL, 'IPR046264', NULL, 'Protein of unknown function DUF6297', 'DUF6297', 4, NULL),
(37328, NULL, 'IPR046141', NULL, 'Protein of unknown function DUF6143', 'DUF6143', 4, NULL),
(37329, NULL, 'IPR046210', NULL, 'Protein of unknown function DUF6243', 'DUF6243', 4, NULL),
(37330, NULL, 'IPR046240', NULL, 'Domain of unknown function DUF6273', 'DUF6273', 3, NULL),
(37331, NULL, 'IPR045582', NULL, 'Trehalase-like, N-terminal domain', 'Trehalase-like_N', 3, NULL),
(37332, NULL, 'IPR045438', NULL, 'Effector-associated domain 9', 'EAD9', 3, NULL),
(37333, NULL, 'IPR043182', NULL, 'Paired DNA-binding domain', 'PAIRED_DNA-bd_dom', 3, NULL),
(37334, NULL, 'IPR043071', NULL, 'Staphylcoagulase, N-terminal, subdomain 2', 'Staphylcoagulase_N_2', 5, NULL),
(37335, NULL, 'IPR046233', NULL, 'Protein of unknown function DUF6266', 'DUF6266', 4, NULL),
(37336, NULL, 'IPR045257', NULL, 'Dihydrolipoamide acetyltransferase/Pyruvate dehydrogenase protein X component', 'E2/Pdx1', 4, NULL),
(37337, NULL, 'IPR046692', NULL, 'Domain of unknown function DUF6562', 'DUF6562', 3, NULL),
(37338, NULL, 'IPR045274', NULL, 'Receptor-like kinase WAK-like', 'WAK-like', 4, NULL),
(37339, NULL, 'IPR046112', NULL, 'Protein of unknown function DUF6049', 'DUF6049', 4, NULL),
(37340, NULL, 'IPR045864', NULL, 'Class II Aminoacyl-tRNA synthetase/Biotinyl protein ligase (BPL) and lipoyl protein ligase (LPL)', 'aa-tRNA-synth_II/BPL/LPL', 5, NULL),
(37341, NULL, 'IPR045299', NULL, 'NDUFA6, LYR domain', 'Complex1_LYR_NDUFA6_LYRM6', 3, NULL),
(37342, NULL, 'IPR045382', NULL, 'Protein of unknown function DUF6529', 'DUF6529', 4, NULL),
(37343, NULL, 'IPR046704', NULL, 'Domain of unknown function DUF6777', 'DUF6777', 3, NULL),
(37344, NULL, 'IPR045664', NULL, 'Protein of unknown function DUF6387', 'DUF6387', 4, NULL),
(37345, NULL, 'IPR046124', NULL, 'Protein of unknown function DUF6121', 'DUF6121', 4, NULL),
(37346, NULL, 'IPR046228', NULL, 'Protein of unknown function DUF6261', 'DUF6261', 4, NULL),
(37347, NULL, 'IPR042169', NULL, 'NKG2-D type II integral membrane protein', 'NKG2D', 4, NULL),
(37348, NULL, 'IPR046686', NULL, 'Protein of unknown function DUF6556', 'DUF6556', 4, NULL),
(37349, NULL, 'IPR046712', NULL, 'Domain of unknown function DUF6785', 'DUF6785', 3, NULL),
(37350, NULL, 'IPR045412', NULL, 'Protein of unknown function DUF5893', 'DUF5893', 4, NULL),
(37351, NULL, 'IPR046188', NULL, 'Protein of unknown function DUF6216', 'DUF6216', 4, NULL),
(37352, NULL, 'IPR045300', NULL, 'MIEF1-MP, LYR domain', 'Complex1_LYR_MIEF1-MP', 3, NULL),
(37353, NULL, 'IPR045778', NULL, 'Protein of unknown function DUF6204', 'DUF6204', 4, NULL),
(37354, NULL, 'IPR046654', NULL, 'Protein of unknown function DUF6672', 'DUF6672', 4, NULL);
INSERT INTO "PUBLIC"."ENTRY" VALUES
(37355, NULL, 'IPR042195', NULL, 'ArgJ beta chain, C-terminal domain', 'ArgJ_beta_C', 5, NULL),
(37356, NULL, 'IPR046713', NULL, 'Protein of unknown function DUF6786', 'DUF6786', 4, NULL),
(37357, NULL, 'IPR045553', NULL, 'MoxR-vWA-beta-propeller ternary system domain bpX1', 'bpX1', 3, NULL),
(37358, NULL, 'IPR046176', NULL, 'Protein of unknown function DUF6185', 'DUF6185', 4, NULL),
(37359, NULL, 'IPR045573', NULL, 'Alpha-(1,6)-fucosyltransferase, N- and catalytic domain', 'Fut8_N_cat', 3, NULL),
(37360, NULL, 'IPR046130', NULL, 'Protein of unknown function DUF6127', 'DUF6127', 4, NULL),
(37361, NULL, 'IPR045632', NULL, 'Domain of unknown function DUF6314', 'DUF6314', 3, NULL),
(37362, NULL, 'IPR045380', NULL, 'L,D-transpeptidase, scaffold domain', 'LD_TPept_scaffold_dom', 3, NULL),
(37363, NULL, 'IPR045904', NULL, 'KCTD15, tetramerisation-type BTB domain', 'KCTD15_T1-type_BTB', 3, NULL),
(37364, NULL, 'IPR046203', NULL, 'Protein of unknown function DUF6236', 'DUF6236', 4, NULL),
(37365, NULL, 'IPR045789', NULL, 'Protein inscuteable homologue, C-terminal domain', 'Insc_C', 3, NULL),
(37366, NULL, 'IPR045323', NULL, 'Coiled-coil domain-containing protein 34', 'CCDC34', 4, NULL),
(37367, NULL, 'IPR046215', NULL, 'Protein of unknown function DUF6248', 'DUF6248', 4, NULL),
(37368, NULL, 'IPR045591', NULL, 'Protein of unknown function DUF6462', 'DUF6462', 4, NULL),
(37369, NULL, 'IPR042523', NULL, 'Ubiquitin-like modifier-activating enzyme Atg7, N-terminal, subdomain 2', 'Atg7_N_2', 5, NULL),
(37370, NULL, 'IPR046172', NULL, 'Protein of unknown function DUF6174', 'DUF6174', 4, NULL),
(37371, NULL, 'IPR045686', NULL, 'Protein of unknown function DUF6189', 'DUF6189', 4, NULL),
(37372, NULL, 'IPR046682', NULL, 'Protein of unknown function DUF6552', 'DUF6552', 4, NULL),
(37373, NULL, 'IPR046222', NULL, 'Protein of unknown function DUF6255', 'DUF6255', 4, NULL),
(37374, NULL, 'IPR045513', NULL, 'Protein of unknown function DUF6479', 'DUF6479', 4, NULL),
(37375, NULL, 'IPR046247', NULL, 'Protein of unknown function DUF6280', 'DUF6280', 4, NULL),
(37376, NULL, 'IPR046681', NULL, 'Protein of unknown function DUF6551', 'DUF6551', 4, NULL),
(37377, NULL, 'IPR046145', NULL, 'Protein of unknown function DUF6147', 'DUF6147', 4, NULL),
(37378, NULL, 'IPR043998', NULL, 'Putative phage metallopeptidase', 'Put_Metallopep', 3, NULL),
(37379, NULL, 'IPR046129', NULL, 'Protein of unknown function DUF6126', 'DUF6126', 4, NULL),
(37380, NULL, 'IPR046659', NULL, 'Protein of unknown function DUF6768', 'DUF6768', 4, NULL),
(37381, NULL, 'IPR046695', NULL, 'Domain of unknown function DUF6565', 'DUF6565', 3, NULL),
(37382, NULL, 'IPR046178', NULL, 'Protein of unknown function DUF6187', 'DUF6187', 4, NULL),
(37383, NULL, 'IPR046698', NULL, 'Protein of unknown function DUF6568', 'DUF6568', 4, NULL),
(37384, NULL, 'IPR045443', NULL, 'Protein of unknown function DUF6504', 'DUF6504', 4, NULL),
(37385, NULL, 'IPR045866', NULL, 'Protein FAM210A/B-like', 'FAM210A/B-like', 4, NULL),
(37386, NULL, 'IPR046742', NULL, 'Domain of unknown function DUF6792', 'DUF6792', 3, NULL),
(37387, NULL, 'IPR045445', NULL, 'Protein of unknown function DUF6502', 'DUF6502', 4, NULL),
(37388, NULL, 'IPR045550', NULL, 'Acylamino-acid-releasing enzyme, N-terminal domain', 'AARE_N', 3, NULL),
(37389, NULL, 'IPR045579', NULL, 'Acylglycerol kinase, C-terminal', 'AGK_C', 3, NULL),
(37390, NULL, 'IPR046200', NULL, 'Protein of unknown function DUF6233', 'DUF6233', 4, NULL),
(37391, NULL, 'IPR045498', NULL, 'HflX, C-terminal domain', 'HflX_C', 3, NULL),
(37392, NULL, 'IPR045317', NULL, 'E3 ubiquitin-protein ligase RGLG, RING finger, plant', 'RING-HC_RGLG_plant', 3, NULL),
(37393, NULL, 'IPR046266', NULL, 'Domain of unknown function DUF6299', 'DUF6299', 3, NULL),
(37394, NULL, 'IPR046208', NULL, 'Protein of unknown function DUF6241', 'DUF6241', 4, NULL),
(37395, NULL, 'IPR045259', NULL, 'Transposase-like protein DAYSLEEPER', 'DAYSLEEPER-like', 4, NULL),
(37396, NULL, 'IPR046109', NULL, 'Domain of unknown function DUF6046', 'DUF6046', 3, NULL),
(37397, NULL, 'IPR046190', NULL, 'Protein of unknown function DUF6218', 'DUF6218', 4, NULL);              
INSERT INTO "PUBLIC"."ENTRY" VALUES
(37398, NULL, 'IPR046199', NULL, 'Protein of unknown function DUF6231', 'DUF6231', 4, NULL),
(37399, NULL, 'IPR045450', NULL, 'vWA-MoxR associated protein, C-terminal domain', 'VMAP_C', 3, NULL),
(37400, NULL, 'IPR045589', NULL, 'Protein of unknown function DUF6464', 'DUF6464', 4, NULL),
(37401, NULL, 'IPR045629', NULL, 'Protein of unknown function DUF6232', 'DUF6232', 4, NULL),
(37402, NULL, 'IPR046231', NULL, 'Protein of unknown function DUF6264', 'DUF6264', 4, NULL),
(37403, NULL, 'IPR045463', NULL, 'Collagen type XV/XVIII, trimerization domain', 'XV/XVIII_trimerization_dom', 3, NULL),
(37404, NULL, 'IPR046193', NULL, 'Protein of unknown function DUF6221', 'DUF6221', 4, NULL),
(37405, NULL, 'IPR046269', NULL, 'Protein of unknown function DUF6302', 'DUF6302', 4, NULL),
(37406, NULL, 'IPR045637', NULL, 'Protein of unknown function DUF6410', 'DUF6410', 4, NULL),
(37407, NULL, 'IPR045503', NULL, 'Protein of unknown function DUF6488', 'DUF6488', 4, NULL),
(37408, NULL, 'IPR043153', NULL, 'DENN domain, C-terminal lobe', 'DENN_C', 5, NULL),
(37409, NULL, 'IPR046143', NULL, 'Protein of unknown function DUF6145', 'DUF6145', 4, NULL),
(37410, NULL, 'IPR045666', NULL, 'Oligopeptidase A, N-terminal domain', 'OpdA_N', 3, NULL),
(37411, NULL, 'IPR045820', NULL, 'CLEC16A/TT9, C-terminal', 'CLEC16A/TT9_C', 3, NULL),
(37412, NULL, 'IPR045284', NULL, 'At2g27730-like', 'At2g27730-like', 4, NULL),
(37413, NULL, 'IPR046116', NULL, 'Protein of unknown function DUF6053', 'DUF6053', 4, NULL),
(37414, NULL, 'IPR043215', NULL, 'Secretoglobin family 1C-like', 'Secretoglobin_1C-like', 4, NULL),
(37415, NULL, 'IPR046270', NULL, 'Protein of unknown function DUF6303', 'DUF6303', 4, NULL),
(37416, NULL, 'IPR045526', NULL, 'Domain of unknown function DUF6471', 'DUF6471', 3, NULL),
(37417, NULL, 'IPR046110', NULL, 'Protein of unknown function DUF6047', 'DUF6047', 4, NULL),
(37418, NULL, 'IPR042360', NULL, 'Aminoacyl tRNA synthase complex-interacting multifunctional protein 2', 'AIMP2', 4, NULL),
(37419, NULL, 'IPR046189', NULL, 'Protein of unknown function DUF6217', 'DUF6217', 4, NULL),
(37420, NULL, 'IPR045327', NULL, 'Protein of unknown function DUF5881', 'DUF5881', 4, NULL),
(37421, NULL, 'IPR045429', NULL, 'Effector-associated domain 10', 'EAD10', 3, NULL),
(37422, NULL, 'IPR046221', NULL, 'Protein of unknown function DUF6254', 'DUF6254', 4, NULL),
(37423, NULL, 'IPR046797', NULL, 'PD-(D/E)XK nuclease-like', 'PDDEXK_12', 3, NULL),
(37424, NULL, 'IPR042524', NULL, 'Presenilin, C-terminal', 'Presenilin_C', 5, NULL),
(37425, NULL, 'IPR046743', NULL, 'Protein of unknown function DUF6793', 'DUF6793', 4, NULL),
(37426, NULL, 'IPR046202', NULL, 'Protein of unknown function DUF6235', 'DUF6235', 4, NULL),
(37427, NULL, 'IPR046744', NULL, 'Domain of unknown function DUF6794', 'DUF6794', 3, NULL),
(37428, NULL, 'IPR046114', NULL, 'Protein of unknown function DUF6051', 'DUF6051', 4, NULL),
(37429, NULL, 'IPR046180', NULL, 'Protein of unknown function DUF6208', 'DUF6208', 4, NULL),
(37430, NULL, 'IPR045701', NULL, 'Protein of unknown function DUF6059', 'DUF6059', 4, NULL),
(37431, NULL, 'IPR045334', NULL, 'Integrator complex subunit 3', 'INTS3', 4, NULL),
(37432, NULL, 'IPR046107', NULL, 'Protein of unknown function DUF6044', 'DUF6044', 4, NULL),
(37433, NULL, 'IPR045702', NULL, 'Protein of unknown function DUF6060', 'DUF6060', 4, NULL),
(37434, NULL, 'IPR045776', NULL, 'Protein of unknown function DUF6202', 'DUF6202', 4, NULL),
(37435, NULL, 'IPR042149', NULL, 'RIP2, CARD domain', 'CARD_RIP2', 3, NULL),
(37436, NULL, 'IPR046140', NULL, 'Protein of unknown function DUF6142', 'DUF6142', 4, NULL),
(37437, NULL, 'IPR045459', NULL, 'Protein of unknown function DUF5908', 'DUF5908', 4, NULL),
(37438, NULL, 'IPR045669', NULL, 'FHF complex subunit HOOK interacting protein, C-terminal', 'FHIP_C', 3, NULL),
(37439, NULL, 'IPR046205', NULL, 'Protein of unknown function DUF6238', 'DUF6238', 4, NULL),
(37440, NULL, 'IPR046196', NULL, 'Protein of unknown function DUF6228', 'DUF6228', 4, NULL),
(37441, NULL, 'IPR045801', NULL, 'Mitogen-activated protein kinase kinase kinase, N-terminal', 'MEKK4_N', 3, NULL);         
INSERT INTO "PUBLIC"."ENTRY" VALUES
(37442, NULL, 'IPR045339', NULL, 'Domain of unknown function DUF6534', 'DUF6534', 3, NULL),
(37443, NULL, 'IPR045277', NULL, 'Dehydration-responsive element-binding protein 1A-I', 'DRE1A-I', 4, NULL),
(37444, NULL, 'IPR045447', NULL, 'Protein of unknown function DUF6501', 'DUF6501', 4, NULL),
(37445, NULL, 'IPR045511', NULL, 'Protein of unknown function DUF6439', 'DUF6439', 4, NULL),
(37446, NULL, 'IPR046374', NULL, 'Protein disulfide-isomerase A5, TRX (a) domain', 'PDI_a_PDIR', 3, NULL),
(37447, NULL, 'IPR045631', NULL, 'Protein of unknown function DUF6315', 'DUF6315', 4, NULL),
(37448, NULL, 'IPR046740', NULL, 'Protein of unknown function DUF6790', 'DUF6790', 4, NULL),
(37449, NULL, 'IPR046723', NULL, 'Protein of unknown function DUF6615', 'DUF6615', 4, NULL),
(37450, NULL, 'IPR045377', NULL, 'Flagellin glycosyltransferase Maf, helical bundle domain', 'Maf_C', 3, NULL),
(37451, NULL, 'IPR046212', NULL, 'Protein of unknown function DUF6245', 'DUF6245', 4, NULL),
(37452, NULL, 'IPR046162', NULL, 'Protein of unknown function DUF6164', 'DUF6164', 4, NULL),
(37453, NULL, 'IPR045691', NULL, 'Protein of unknown function DUF6056', 'DUF6056', 4, NULL),
(37454, NULL, 'IPR042505', NULL, 'Cytoplasmic dynein 2 intermediate chain 1', 'DYNC2I1', 4, NULL),
(37455, NULL, 'IPR042133', NULL, 'Phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit alpha, PX domain', 'PX_PI3K_C2_alpha', 3, NULL),
(37456, NULL, 'IPR046149', NULL, 'Protein of unknown function DUF6151', 'DUF6151', 4, NULL),
(37457, NULL, 'IPR046155', NULL, 'Protein of unknown function DUF6157', 'DUF6157', 4, NULL),
(37458, NULL, 'IPR046716', NULL, 'Protein of unknown function DUF6608', 'DUF6608', 4, NULL),
(37459, NULL, 'IPR045672', NULL, 'Mesaconyl-CoA hydratase', 'MC_hydratase', 4, NULL),
(37460, NULL, 'IPR045435', NULL, 'Effector-associated domain 7', 'EAD7', 3, NULL),
(37461, NULL, 'IPR045340', NULL, 'Domain of unknown function DUF6533', 'DUF6533', 3, NULL),
(37462, NULL, 'IPR046249', NULL, 'Protein of unknown function DUF6282', 'DUF6282', 4, NULL),
(37463, NULL, 'IPR046167', NULL, 'Protein of unknown function DUF6169', 'DUF6169', 4, NULL),
(37464, NULL, 'IPR046677', NULL, 'Protein of unknown function DUF6547', 'DUF6547', 4, NULL),
(37465, NULL, 'IPR046703', NULL, 'Protein of unknown function DUF6776', 'DUF6776', 4, NULL),
(37466, NULL, 'IPR046243', NULL, 'Protein of unknown function DUF6276', 'DUF6276', 4, NULL),
(37467, NULL, 'IPR046710', NULL, 'Protein of unknown function DUF6783', 'DUF6783', 4, NULL),
(37468, NULL, 'IPR046237', NULL, 'Protein of unknown function DUF6270', 'DUF6270', 4, NULL),
(37469, NULL, 'IPR046261', NULL, 'Domain of unknown function DUF6294', 'DUF6294', 3, NULL),
(37470, NULL, 'IPR046691', NULL, 'Protein of unknown function DUF6561', 'DUF6561', 4, NULL),
(37471, NULL, 'IPR046224', NULL, 'Protein of unknown function DUF6257', 'DUF6257', 4, NULL),
(37472, NULL, 'IPR046174', NULL, 'Protein of unknown function DUF6176', 'DUF6176', 4, NULL),
(37473, NULL, 'IPR046735', NULL, 'Protein of unknown function DUF6627', 'DUF6627', 4, NULL),
(37474, NULL, 'IPR046254', NULL, 'Domain of unknown function DUF6287', 'DUF6287', 3, NULL),
(37475, NULL, 'IPR046217', NULL, 'Domain of unknown function DUF6250', 'DUF6250', 3, NULL),
(37476, NULL, 'IPR046684', NULL, 'Protein of unknown function DUF6554', 'DUF6554', 4, NULL),
(37477, NULL, 'IPR046250', NULL, 'Protein of unknown function DUF6283', 'DUF6283', 4, NULL),
(37478, NULL, 'IPR046119', NULL, 'Protein of unknown function DUF6116', 'DUF6116', 4, NULL),
(37479, NULL, 'IPR046126', NULL, 'Protein of unknown function DUF6123', 'DUF6123', 4, NULL),
(37480, NULL, 'IPR045326', NULL, 'Autophagy protein ATG17-like domain', 'ATG17-like_dom', 3, NULL),
(37481, NULL, 'IPR046133', NULL, 'Protein of unknown function DUF6130', 'DUF6130', 4, NULL),
(37482, NULL, 'IPR045583', NULL, 'Phosphorylase b kinase regulatory subunit alpha/beta, C-terminal domain', 'KPBA/B_C', 3, NULL),
(37483, NULL, 'IPR044171', NULL, 'Protein LAX PANICLE 2-like', 'LAX2-like', 4, NULL),
(37484, NULL, 'IPR046235', NULL, 'Domain of unknown function DUF6268', 'DUF6268', 3, NULL);           
INSERT INTO "PUBLIC"."ENTRY" VALUES
(37485, NULL, 'IPR046236', NULL, 'Protein of unknown function DUF6269', 'DUF6269', 4, NULL),
(37486, NULL, 'IPR046168', NULL, 'Protein of unknown function DUF6170', 'DUF6170', 4, NULL),
(37487, NULL, 'IPR042131', NULL, 'SNX7, BAR domain', 'BAR_SNX7', 3, NULL),
(37488, NULL, 'IPR046729', NULL, 'Protein of unknown function DUF6621', 'DUF6621', 4, NULL),
(37489, NULL, 'IPR046218', NULL, 'Protein of unknown function DUF6251', 'DUF6251', 4, NULL),
(37490, NULL, 'IPR046657', NULL, 'Protein of unknown function DUF6766', 'DUF6766', 4, NULL),
(37491, NULL, 'IPR046262', NULL, 'Protein of unknown function DUF6295', 'DUF6295', 4, NULL),
(37492, NULL, 'IPR046216', NULL, 'Domain of unknown function DUF6249', 'DUF6249', 3, NULL),
(37493, NULL, 'IPR045508', NULL, 'Protein of unknown function DUF6482', 'DUF6482', 4, NULL),
(37494, NULL, 'IPR046255', NULL, 'Protein of unknown function DUF6288', 'DUF6288', 4, NULL),
(37495, NULL, 'IPR045565', NULL, 'Phage capsid protein', 'Phage_capsid_2', 4, NULL),
(37496, NULL, 'IPR046689', NULL, 'Protein of unknown function DUF6559', 'DUF6559', 4, NULL),
(37497, NULL, 'IPR046664', NULL, 'Protein of unknown function DUF6773', 'DUF6773', 4, NULL),
(37498, NULL, 'IPR046727', NULL, 'Domain of unknown function DUF6619', 'DUF6619', 3, NULL),
(37499, NULL, 'IPR046131', NULL, 'Domain of unknown function DUF6128', 'DUF6128', 3, NULL),
(37500, NULL, 'IPR046741', NULL, 'Protein of unknown function DUF6791', 'DUF6791', 3, NULL),
(37501, NULL, 'IPR046310', NULL, 'Protein of unknown function DUF6425', 'DUF6425', 4, NULL),
(37502, NULL, 'IPR046509', NULL, 'Protein of unknown function DUF6687', 'DUF6687', 4, NULL),
(37503, NULL, 'IPR046295', NULL, 'Protein of unknown function DUF6332', 'DUF6332', 4, NULL),
(37504, NULL, 'IPR046553', NULL, 'Protein of unknown function DUF6707', 'DUF6707', 4, NULL),
(37505, NULL, 'IPR046517', NULL, 'Protein of unknown function DUF6695', 'DUF6695', 4, NULL),
(37506, NULL, 'IPR046548', NULL, 'Protein of unknown function DUF6804', 'DUF6804', 4, NULL),
(37507, NULL, 'IPR046876', NULL, 'Prokaryotic STING domain', 'Prok_STING', 3, NULL),
(37508, NULL, 'IPR046287', NULL, 'Protein of unknown function DUF6324', 'DUF6324', 4, NULL),
(37509, NULL, 'IPR043404', NULL, 'ATAXIN1-like', 'ATAXIN1-like', 4, NULL),
(37510, NULL, 'IPR046326', NULL, 'Domain of unknown function DUF5136', 'DUF5136', 3, NULL),
(37511, NULL, 'IPR042533', NULL, 'Nucleoporin, Nup155-like, C-terminal, subdomain 1', 'Nucleoporin_Nup155_C_1', 5, NULL),
(37512, NULL, 'IPR046877', NULL, 'Nucleotidyltransferase-Associated Rossmannoid Fold', 'NARF', 3, NULL),
(37513, NULL, 'IPR046535', NULL, 'Protein of unknown function DUF6600', 'DUF6600', 4, NULL),
(37514, NULL, 'IPR045913', NULL, 'GTPase-activating protein TBC20/Gyp8-like', 'TBC20/Gyp8-like', 4, NULL),
(37515, NULL, 'IPR046483', NULL, 'Domain of unknown function DUF6576', 'DUF6576', 3, NULL),
(37516, NULL, 'IPR046556', NULL, 'Protein of unknown function DUF6710', 'DUF6710', 4, NULL),
(37517, NULL, 'IPR046529', NULL, 'Domain of unknown function DUF6594', 'DUF6594', 3, NULL),
(37518, NULL, 'IPR046932', NULL, 'ATPase RavA, LARA domain superfamily', 'RavA_LARA_sf', 5, NULL),
(37519, NULL, 'IPR046484', NULL, 'Protein of unknown function DUF6577', 'DUF6577', 4, NULL),
(37520, NULL, 'IPR042377', NULL, 'Gasdermin-E', 'GSDME', 4, NULL),
(37521, NULL, 'IPR044004', NULL, 'Spondin-like TSP1 domain', 'TSP1_spondin_dom', 3, NULL),
(37522, NULL, 'IPR046487', NULL, 'Protein of unknown function DUF6580', 'DUF6580', 4, NULL),
(37523, NULL, 'IPR045914', NULL, 'Zinc finger protein 532-like', 'Zn532-like', 4, NULL),
(37524, NULL, 'IPR046513', NULL, 'Protein of unknown function DUF6691', 'DUF6691', 4, NULL),
(37525, NULL, 'IPR046497', NULL, 'Domain of unknown function DUF6590', 'DUF6590', 3, NULL),
(37526, NULL, 'IPR046305', NULL, 'Protein of unknown function DUF6420', 'DUF6420', 4, NULL),
(37527, NULL, 'IPR046749', NULL, 'SHOCT-like domain', 'SHOCT_2', 3, NULL),
(37528, NULL, 'IPR046275', NULL, 'Protein of unknown function DUF6308', 'DUF6308', 4, NULL),
(37529, NULL, 'IPR044116', NULL, 'TRIM14, PRY/SPRY domain', 'SPRY_PRY_TRIM14', 3, NULL);       
INSERT INTO "PUBLIC"."ENTRY" VALUES
(37530, NULL, 'IPR042531', NULL, 'Phospholipase C-beta, C-terminal domain superfamily', 'PLC-beta_C_sf', 5, NULL),
(37531, NULL, 'IPR046538', NULL, 'Domain of unknown function DUF6603', 'DUF6603', 3, NULL),
(37532, NULL, 'IPR046309', NULL, 'Protein of unknown function DUF6424', 'DUF6424', 4, NULL),
(37533, NULL, 'IPR046397', NULL, 'Pre-baseplate central spike protein Gp5', 'NEEDLE_T4', 4, NULL),
(37534, NULL, 'IPR042457', NULL, 'Thiosulfate:glutathione sulfurtransferase, mammal', 'TSTD1_mammal', 4, NULL),
(37535, NULL, 'IPR046428', NULL, 'mRNA-capping enzyme catalytic subunit, OB fold domain superfamily', 'MCEL_OB_dom_sf', 5, NULL),
(37536, NULL, 'IPR046789', NULL, 'Recombinase-like', 'HTH_62', 3, NULL),
(37537, NULL, 'IPR046510', NULL, 'Protein of unknown function DUF6688', 'DUF6688', 4, NULL),
(37538, NULL, 'IPR046565', NULL, 'Protein of unknown function DUF6719', 'DUF6719', 4, NULL),
(37539, NULL, 'IPR043364', NULL, 'Immunoglobulin superfamily member 5', 'IgSF5', 4, NULL),
(37540, NULL, 'IPR046444', NULL, 'SARS-like ORF8 accessory protein, Ig-like domain', 'SARS_ORF8_IG', 3, NULL),
(37541, NULL, 'IPR046277', NULL, 'Domain of unknown function DUF6310', 'DUF6310', 3, NULL),
(37542, NULL, 'IPR046908', NULL, 'Divergent Family B DNA polymerase', 'divDNApol', 4, NULL),
(37543, NULL, 'IPR046440', NULL, 'Arterivirus Nsp11 N-terminal/Coronavirus NSP15 middle domain', 'AV_NSP11N_COV_NSP15M', 3, NULL),
(37544, NULL, 'IPR042467', NULL, 'Peptidase C65,  otubain, subdomain 2', 'Peptidase_C65_otubain_sub2', 5, NULL),
(37545, NULL, 'IPR046398', NULL, 'Acyl-coenzyme A diphosphatase YFT2', 'YFT2', 4, NULL),
(37546, NULL, 'IPR046308', NULL, 'Protein of unknown function DUF6423', 'DUF6423', 4, NULL),
(37547, NULL, 'IPR046923', NULL, 'CASPASE and TPR Repeat-Associated, C-terminal domain', 'CATRA-C', 3, NULL),
(37548, NULL, 'IPR046492', NULL, 'Protein of unknown function DUF6585', 'DUF6585', 4, NULL),
(37549, NULL, 'IPR046537', NULL, 'Domain of unknown function DUF6602', 'DUF6602', 3, NULL),
(37550, NULL, 'IPR046426', NULL, 'Daxx, histone-binding domain superfamily', 'DAXX_histone-bd_sf', 5, NULL),
(37551, NULL, 'IPR043797', NULL, '6-phospho-N-acetylmuramidase, N-terminal', 'MupG_N', 3, NULL),
(37552, NULL, 'IPR046867', NULL, 'Aldehyde oxidase/xanthine dehydrogenase, second molybdopterin binding domain', 'AldOxase/xan_DH_MoCoBD2', 3, NULL),
(37553, NULL, 'IPR046480', NULL, 'Protein of unknown function DUF6573', 'DUF6573', 4, NULL),
(37554, NULL, 'IPR046498', NULL, 'Protein of unknown function DUF6676', 'DUF6676', 4, NULL),
(37555, NULL, 'IPR044015', NULL, 'Fructose-1-6-bisphosphatase class 1, C-terminal', 'FBPase_C_dom', 3, NULL),
(37556, NULL, 'IPR046347', NULL, 'Basic-leucine zipper domain superfamily', 'bZIP_sf', 5, NULL),
(37557, NULL, 'IPR046350', NULL, 'Cystatin superfamily', 'Cystatin_sf', 5, NULL),
(37558, NULL, 'IPR046868', NULL, 'SLM1/RGC1-like, BAR-like domain', 'BAR_4', 3, NULL),
(37559, NULL, 'IPR046788', NULL, 'Putative O-methyltransferase', 'Methyltransf_35', 4, NULL),
(37560, NULL, 'IPR046362', NULL, 'Zw10/DSL1, C-terminal', 'Zw10/DSL1_C_sf', 5, NULL),
(37561, NULL, 'IPR046564', NULL, 'Protein of unknown function DUF6718', 'DUF6718', 4, NULL),
(37562, NULL, 'IPR042376', NULL, 'Mediator of RNA polymerase II transcription subunit 26', 'MED26', 4, NULL),
(37563, NULL, 'IPR042114', NULL, 'Aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase, C-terminal, domain 1', 'GatB_C_1', 5, NULL),
(37564, NULL, 'IPR046869', NULL, 'SLM1/RGC1-like, PH domain', 'SLM1/RGC1-like_PH', 3, NULL),
(37565, NULL, 'IPR046551', NULL, 'Domain of unknown function DUF6705', 'DUF6705', 3, NULL),
(37566, NULL, 'IPR046532', NULL, 'Protein of unknown function DUF6597', 'DUF6597', 3, NULL),
(37567, NULL, 'IPR046543', NULL, 'Domain of unknown function DUF6802', 'DUF6802', 3, NULL),
(37568, NULL, 'IPR046292', NULL, 'Domain of unknown function DUF6329', 'DUF6329', 3, NULL),
(37569, NULL, 'IPR046280', NULL, 'Protein of unknown function DUF6313', 'DUF6313', 4, NULL),
(37570, NULL, 'IPR046345', NULL, 'TraB/PryY-like', 'TraB_PrgY-like', 4, NULL);    
INSERT INTO "PUBLIC"."ENTRY" VALUES
(37571, NULL, 'IPR046560', NULL, 'Protein of unknown function DUF6714', 'DUF6714', 4, NULL),
(37572, NULL, 'IPR046516', NULL, 'Protein of unknown function DUF6694', 'DUF6694', 4, NULL),
(37573, NULL, 'IPR044250', NULL, 'Isochorismate synthase MenF-like', 'MenF-like', 4, NULL),
(37574, NULL, 'IPR046274', NULL, 'Protein of unknown function DUF6307', 'DUF6307', 4, NULL),
(37575, NULL, 'IPR046552', NULL, 'Protein of unknown function DUF6706', 'DUF6706', 4, NULL),
(37576, NULL, 'IPR046514', NULL, 'Protein of unknown function DUF6692', 'DUF6692', 3, NULL),
(37577, NULL, 'IPR046294', NULL, 'Protein of unknown function DUF6331', 'DUF6331', 4, NULL),
(37578, NULL, 'IPR046354', NULL, 'Sperm acrosome membrane-associated protein 4/Protein Bouncer', 'SPACA4/Bouncer', 4, NULL),
(37579, NULL, 'IPR044242', NULL, 'Protein LHCP TRANSLOCATION DEFECT-like', 'LTD-like', 4, NULL),
(37580, NULL, 'IPR046778', NULL, 'UPF0758, N-terminal', 'UPF0758_N', 3, NULL),
(37581, NULL, 'IPR046500', NULL, 'Protein of unknown function DUF6678', 'DUF6678', 4, NULL),
(37582, NULL, 'IPR046482', NULL, 'Domain of unknown function DUF6575', 'DUF6575', 3, NULL),
(37583, NULL, 'IPR046519', NULL, 'Protein of unknown function DUF6696', 'DUF6696', 3, NULL),
(37584, NULL, 'IPR046446', NULL, '3a-like viroporin, cytosolic domain, alpha/betacoronavirus', 'a/bCoV_VIROPORIN_3A-like_CD', 3, NULL),
(37585, NULL, 'IPR046562', NULL, 'Protein of unknown function DUF6717', 'DUF6717', 4, NULL),
(37586, NULL, 'IPR046378', NULL, 'Daxx, histone-binding domain', 'DAXX_histone-bd', 3, NULL),
(37587, NULL, 'IPR043026', NULL, 'Orbivirus VP4 core, C-terminal', 'Orbi_VP4_C', 5, NULL),
(37588, NULL, 'IPR046549', NULL, 'Protein of unknown function DUF6703', 'DUF6703', 4, NULL),
(37589, NULL, 'IPR046542', NULL, 'Domain of unknown function DUF6801', 'DUF6801', 3, NULL),
(37590, NULL, 'IPR046481', NULL, 'Protein of unknown function DUF6574', 'DUF6574', 4, NULL),
(37591, NULL, 'IPR045906', NULL, 'Serine/threonine-protein kinase ULK4', 'ULK4', 4, NULL),
(37592, NULL, 'IPR043091', NULL, 'Restriction endonuclease, type II, AvaI/BsoBI, helical domain', 'Restr_endonucII_AvaI/BsoBI_hel', 5, NULL),
(37593, NULL, 'IPR046506', NULL, 'Protein of unknown function DUF6684', 'DUF6684', 4, NULL),
(37594, NULL, 'IPR046456', NULL, 'Phosphomannose isomerase type I, C-terminal domain', 'PMI_typeI_C', 3, NULL),
(37595, NULL, 'IPR046833', NULL, 'ATPase of the ABC class, N-terminal', 'ABC_N', 3, NULL),
(37596, NULL, 'IPR046493', NULL, 'Protein of unknown function DUF6586', 'DUF6586', 4, NULL),
(37597, NULL, 'IPR043078', NULL, 'Sialyltransferase, N-terminal GT-B Rossman nucleotide-binding domain', 'Sialyltransferase_N', 5, NULL),
(37598, NULL, 'IPR046866', NULL, 'Flagellar Assembly Protein A , N-terminal region', 'FapA_N', 3, NULL),
(37599, NULL, 'IPR045910', NULL, 'Long-chain primary alcohol dehydrogenase AdhA-like', 'AdhA-like', 4, NULL),
(37600, NULL, 'IPR045915', NULL, 'Solute carrier family 22 members 4/5', 'S22A4/5', 4, NULL),
(37601, NULL, 'IPR046449', NULL, 'Protease Do-like, PDZ domain superfamily', 'DEGP_PDZ_sf', 5, NULL),
(37602, NULL, 'IPR046489', NULL, 'Protein of unknown function DUF6582', 'DUF6582', 4, NULL),
(37603, NULL, 'IPR046566', NULL, 'Protein of unknown function DUF6720', 'DUF6720', 4, NULL),
(37604, NULL, 'IPR046805', NULL, 'Tra1, HEAT repeat ring region', 'Tra1_ring', 7, NULL),
(37605, NULL, 'IPR046539', NULL, 'Domain of unknown function DUF6604', 'DUF6604', 3, NULL),
(37606, NULL, 'IPR046559', NULL, 'Protein of unknown function DUF6713', 'DUF6713', 4, NULL),
(37607, NULL, 'IPR042532', NULL, 'Exocyst complex component EXOC3/Sec6, C-terminal domain', 'EXOC3/Sec6_C', 5, NULL),
(37608, NULL, 'IPR046478', NULL, 'Domain of unknown function DUF6799', 'DUF6799', 3, NULL),
(37609, NULL, 'IPR046792', NULL, 'Peptidase C54, catalytic domain', 'Peptidase_C54_cat', 3, NULL),
(37610, NULL, 'IPR046526', NULL, 'Domain of unknown function DUF6591', 'DUF6591', 3, NULL),
(37611, NULL, 'IPR046453', NULL, 'Phage terminase large subunit GpA, ATPase domain', 'GpA_ATPase', 3, NULL),
(37612, NULL, 'IPR046777', NULL, 'GvpD, basic region 2', 'GvpD_bR2', 3, NULL);               
INSERT INTO "PUBLIC"."ENTRY" VALUES
(37613, NULL, 'IPR046495', NULL, 'Protein of unknown function DUF6588', 'DUF6588', 4, NULL),
(37614, NULL, 'IPR046450', NULL, 'PA domain superfamily', 'PA_dom_sf', 5, NULL),
(37615, NULL, 'IPR046290', NULL, 'Protein of unknown function DUF6327', 'DUF6327', 4, NULL),
(37616, NULL, 'IPR046473', NULL, 'Sgo0707-like, N2 domain', 'Sgo0707-like_N2', 3, NULL),
(37617, NULL, 'IPR046299', NULL, 'Protein of unknown function DUF6336', 'DUF6336', 4, NULL),
(37618, NULL, 'IPR046554', NULL, 'Domain of unknown function DUF6708', 'DUF6708', 3, NULL),
(37619, NULL, 'IPR046399', NULL, 'DNA-directed RNA polymerase subunit Rpo7', 'RNApol_Rpo7', 4, NULL),
(37620, NULL, 'IPR046555', NULL, 'Protein of unknown function DUF6709', 'DUF6709', 4, NULL),
(37621, NULL, 'IPR042479', NULL, 'SMC5-SMC6 complex localization factor protein 1', 'Slf1', 4, NULL),
(37622, NULL, 'IPR046346', NULL, 'Aminoacid dehydrogenase-like, N-terminal domain superfamily', 'Aminiacid_DH-like_N_sf', 5, NULL),
(37623, NULL, 'IPR046355', NULL, 'GRB2-associated-binding protein 1-4-like', 'Gab1-4-like', 4, NULL),
(37624, NULL, 'IPR046376', NULL, 'RhoGEF 6/7, PH domain', 'PH_Cool_Pix', 3, NULL),
(37625, NULL, 'IPR046520', NULL, 'Protein of unknown function DUF6697', 'DUF6697', 3, NULL),
(37626, NULL, 'IPR046306', NULL, 'Protein of unknown function DUF6421', 'DUF6421', 4, NULL),
(37627, NULL, 'IPR046499', NULL, 'Domain of unknown function DUF6677', 'DUF6677', 3, NULL),
(37628, NULL, 'IPR046883', NULL, 'Type VI secretion system, FHA domain-containing protein, C-terminal domain', 'T6SS_FHA_C', 3, NULL),
(37629, NULL, 'IPR042470', NULL, 'RecQ mediated genome instability protein, N-terminal OB-fold superfamily', 'RMI1_N_C_sf', 5, NULL),
(37630, NULL, 'IPR046276', NULL, 'Protein of unknown function DUF6309', 'DUF6309', 4, NULL),
(37631, NULL, 'IPR046550', NULL, 'Protein of unknown function DUF6704', 'DUF6704', 4, NULL),
(37632, NULL, 'IPR045911', NULL, 'Receptor-type tyrosine-protein phosphatase mu, PTPase domain, repeat 1', 'R-PTP-mu_cat_rpt1', 3, NULL),
(37633, NULL, 'IPR046313', NULL, 'Protein of unknown function DUF6465', 'DUF6465', 4, NULL),
(37634, NULL, 'IPR046474', NULL, 'Protein of unknown function DUF6795', 'DUF6795', 3, NULL),
(37635, NULL, 'IPR046490', NULL, 'Protein of unknown function DUF6583', 'DUF6583', 4, NULL),
(37636, NULL, 'IPR046331', NULL, 'GPALPP motifs-containing protein 1-like', 'GPAM1-like', 4, NULL),
(37637, NULL, 'IPR046541', NULL, 'Domain of unknown function DUF6606', 'DUF6606', 3, NULL),
(37638, NULL, 'IPR044391', NULL, 'ORF8, SARS-CoV-2', 'ORF8_SARS-CoV-2-like', 4, NULL),
(37639, NULL, 'IPR046320', NULL, 'Domain of unknown function DUF4922', 'DUF4922', 3, NULL),
(37640, NULL, 'IPR046779', NULL, 'LapA adhesin domain', 'LapA_adhesin_dom', 3, NULL),
(37641, NULL, 'IPR046878', NULL, 'Bacterial Ig-like domain 14', 'Big_14', 3, NULL),
(37642, NULL, 'IPR046344', NULL, 'TAF6, C-terminal HEAT repeat domain superfamily', 'TAF6_C_sf', 5, NULL),
(37643, NULL, 'IPR043445', NULL, 'TMEPAI family', 'TMEPAI/LRAD4', 4, NULL),
(37644, NULL, 'IPR046304', NULL, 'Protein of unknown function DUF6419', 'DUF6419', 4, NULL),
(37645, NULL, 'IPR046518', NULL, 'Protein of unknown function DUF1583_N', 'DUF1583_N', 3, NULL),
(37646, NULL, 'IPR046515', NULL, 'Protein of unknown function DUF6693', 'DUF6693', 4, NULL),
(37647, NULL, 'IPR046525', NULL, 'Protein of unknown function DUF6702', 'DUF6702', 3, NULL),
(37648, NULL, 'IPR046379', NULL, '3'',5''-cyclic adenosine monophosphate phosphodiesterase CpdA', 'cAMP_phosphodiest_CpdA', 4, NULL),
(37649, NULL, 'IPR046496', NULL, 'Domain of unknown function DUF6589', 'DUF6589', 3, NULL),
(37650, NULL, 'IPR046523', NULL, 'U3 small nucleolar RNA-associated protein 20, C-terminal', 'UTP20_C', 3, NULL),
(37651, NULL, 'IPR044395', NULL, 'SF1 helicase-like, zinc-binding domain, ronidovirus', 'SF1_Hel-like_ZBD_rv', 3, NULL),
(37652, NULL, 'IPR046303', NULL, 'Domain of unknown function DUF6418', 'DUF6418', 3, NULL),
(37653, NULL, 'IPR046501', NULL, 'Protein of unknown function DUF6679', 'DUF6679', 4, NULL),
(37654, NULL, 'IPR046307', NULL, 'Protein of unknown function DUF6422', 'DUF6422', 4, NULL);            
INSERT INTO "PUBLIC"."ENTRY" VALUES
(37655, NULL, 'IPR046375', NULL, 'IKBKB, scaffold dimerization domain superfamily', 'IKBKB_SDD_sf', 5, NULL),
(37656, NULL, 'IPR046873', NULL, 'MAP3K, HisK-N-like globin domain', 'HisK-N-like', 3, NULL),
(37657, NULL, 'IPR046802', NULL, 'Glucose-6-phosphate dehydrogenase assembly protein OpcA, C-terminal domain', 'OpcA_G6PD_C', 3, NULL),
(37658, NULL, 'IPR046300', NULL, 'Protein of unknown function DUF6415', 'DUF6415', 4, NULL),
(37659, NULL, 'IPR046470', NULL, 'S-adenosyl-l-methionine hydroxide adenosyltransferase, C-terminal domain', 'SAM_HAT_C', 3, NULL),
(37660, NULL, 'IPR046486', NULL, 'Protein of unknown function DUF6579', 'DUF6579', 4, NULL),
(37661, NULL, 'IPR046522', NULL, 'Protein of unknown function DUF6699', 'DUF6699', 4, NULL),
(37662, NULL, 'IPR046314', NULL, 'Protein of unknown function DUF6466', 'DUF6466', 4, NULL),
(37663, NULL, 'IPR046504', NULL, 'Protein of unknown function DUF6682', 'DUF6682', 4, NULL),
(37664, NULL, 'IPR046782', NULL, 'HEWD domain', 'HEWD', 3, NULL),
(37665, NULL, 'IPR046524', NULL, 'Domain of unknown function DUF6701', 'DUF6701', 3, NULL),
(37666, NULL, 'IPR046391', NULL, 'Protein spackle', 'SPACKLE_T4', 4, NULL),
(37667, NULL, 'IPR046534', NULL, 'Protein of unknown function DUF6599', 'DUF6599', 4, NULL),
(37668, NULL, 'IPR046289', NULL, 'Protein of unknown function DUF6326', 'DUF6326', 4, NULL),
(37669, NULL, 'IPR046349', NULL, 'C1-like domain superfamily', 'C1-like_sf', 5, NULL),
(37670, NULL, 'IPR046533', NULL, 'Protein of unknown function DUF6598', 'DUF6598', 3, NULL),
(37671, NULL, 'IPR046879', NULL, 'KANL3/Tex30, alpha/beta hydrolase-like domain', 'KANL3/Tex30_Abhydrolase', 3, NULL),
(37672, NULL, 'IPR046279', NULL, 'Protein of unknown function DUF6312', 'DUF6312', 4, NULL),
(37673, NULL, 'IPR046425', NULL, 'Clp protease, ATP-binding subunit ClpX, bacteria', 'ClpX_bact', 4, NULL),
(37674, NULL, 'IPR046468', NULL, 'Spt20-like, SEP domain', 'Spt20-like_SEP', 3, NULL),
(37675, NULL, 'IPR046558', NULL, 'Protein of unknown function DUF6712', 'DUF6712', 4, NULL),
(37676, NULL, 'IPR046546', NULL, 'Protein of unknown function DUF4784_N', 'DUF4784_N', 3, NULL),
(37677, NULL, 'IPR044442', NULL, 'RNase III, double-stranded RNA binding domain, animal', 'RNAse_III_DSRM__animal', 3, NULL),
(37678, NULL, 'IPR046285', NULL, 'Protein of unknown function DUF6322', 'DUF6322', 4, NULL),
(37679, NULL, 'IPR046477', NULL, 'Domain of unknown function DUF6798', 'DUF6798', 3, NULL),
(37680, NULL, 'IPR046476', NULL, 'Domain of unknown function DUF6797', 'DUF6797', 3, NULL),
(37681, NULL, 'IPR046528', NULL, 'Domain of unknown function DUF6593', 'DUF6593', 3, NULL),
(37682, NULL, 'IPR046815', NULL, 'P2X purinoreceptor 7, intracellular domain', 'P2RX7_C', 3, NULL),
(37683, NULL, 'IPR046512', NULL, 'Protein of unknown function DUF6690', 'DUF6690', 3, NULL),
(37684, NULL, 'IPR046557', NULL, 'Protein of unknown function DUF6711', 'DUF6711', 4, NULL),
(37685, NULL, 'IPR046872', NULL, 'MAP3K, deoxyribohydrolase domain', 'DRHyd-ASK', 3, NULL),
(37686, NULL, 'IPR046502', NULL, 'Domain of unknown function DUF6680', 'DUF6680', 3, NULL),
(37687, NULL, 'IPR046882', NULL, 'Small protein found in certain Dnd DNA modification systems', 'Sp-DndD', 4, NULL),
(37688, NULL, 'IPR046915', NULL, 'ABC-three component systems, C-terminal domain 5', 'ABC-3C_CTD5', 3, NULL),
(37689, NULL, 'IPR046390', NULL, 'Head completion nuclease', 'NUCL_HEAD_T4', 4, NULL),
(37690, NULL, 'IPR046466', NULL, 'Borealin, C-terminal', 'Borealin_C', 3, NULL),
(37691, NULL, 'IPR046507', NULL, 'Protein of unknown function DUF6685', 'DUF6685', 4, NULL),
(37692, NULL, 'IPR046284', NULL, 'Domain of unknown function DUF6321', 'DUF6321', 3, NULL),
(37693, NULL, 'IPR046293', NULL, 'Protein of unknown function DUF6330', 'DUF6330', 4, NULL),
(37694, NULL, 'IPR046485', NULL, 'Protein of unknown function DUF6578', 'DUF6578', 4, NULL),
(37695, NULL, 'IPR046746', NULL, 'Bacterial Ig domain 15', 'Big_15', 3, NULL),
(37696, NULL, 'IPR046503', NULL, 'Protein of unknown function DUF6681', 'DUF6681', 4, NULL),
(37697, NULL, 'IPR046297', NULL, 'Protein of unknown function DUF6334', 'DUF6334', 4, NULL);          
INSERT INTO "PUBLIC"."ENTRY" VALUES
(37698, NULL, 'IPR046874', NULL, 'Mitogen-activated protein kinase kinase kinase 5/6/15', 'MAPK5/6/15', 4, NULL),
(37699, NULL, 'IPR046861', NULL, 'Kinase suppressor RAS 1, N-terminal helical hairpin', 'SAM_KSR1_N', 3, NULL),
(37700, NULL, 'IPR044640', NULL, 'U2 small nuclear ribonucleoprotein A''', 'RU2A', 4, NULL),
(37701, NULL, 'IPR046332', NULL, 'Small ubiquitin-related modifier 1, Ubl domain', 'SUMO1_Ubl', 3, NULL),
(37702, NULL, 'IPR042556', NULL, 'Ubiquitin-protein ligase E3A, N-terminal zinc-binding domain superfamily', 'AZUL_sf', 5, NULL),
(37703, NULL, 'IPR046278', NULL, 'Domain of unknown function DUF6311', 'DUF6311', 3, NULL),
(37704, NULL, 'IPR043155', NULL, 'Vacuolar protein sorting-associated protein 33, domain 3b', 'VPS33_dom3b', 5, NULL),
(37705, NULL, 'IPR046521', NULL, 'Protein of unknown function DUF6698', 'DUF6698', 4, NULL),
(37706, NULL, 'IPR046341', NULL, 'SET domain superfamily', 'SET_dom_sf', 5, NULL),
(37707, NULL, 'IPR046463', NULL, 'Envelope glycoprotein E, N-terminal', 'Herpes_gE_N', 3, NULL),
(37708, NULL, 'IPR044249', NULL, 'Probable E3 ubiquitin-protein ligase XERICO-like', 'XERICO-like', 4, NULL),
(37709, NULL, 'IPR046288', NULL, 'Protein of unknown function DUF6325', 'DUF6325', 4, NULL),
(37710, NULL, 'IPR046475', NULL, 'Protein of unknown function DUF6796', 'DUF6796', 4, NULL),
(37711, NULL, 'IPR046752', NULL, 'RNA-directed RNA polymerase, thumb domain, birnavirus', 'Birnavirus_RdRp_thumb', 3, NULL),
(37712, NULL, 'IPR046351', NULL, 'U3 small nucleolar RNA-associated protein 4', 'UTP4', 4, NULL),
(37713, NULL, 'IPR046402', NULL, 'Fat storage-inducing transmembrane protein 1', 'FIT1', 4, NULL),
(37714, NULL, 'IPR046536', NULL, 'Protein of unknown function DUF6601', 'DUF6601', 4, NULL),
(37715, NULL, 'IPR046801', NULL, 'Glucose-6-phosphate dehydrogenase assembly protein OpcA, N-terminal domain', 'OpcA_G6PD_N', 3, NULL),
(37716, NULL, 'IPR043991', NULL, 'Recombination directionality factor-like', 'Gp3-like', 4, NULL),
(37717, NULL, 'IPR044724', NULL, 'UBL4A-like,  ubiquitin-like domain', 'Ubl_UBL4A-like', 3, NULL),
(37718, NULL, 'IPR046508', NULL, 'Protein of unknown function DUF6686', 'DUF6686', 4, NULL),
(37719, NULL, 'IPR046540', NULL, 'N,N-dimethylformamidase beta subunit-like, C-terminal', 'DMFA2_C', 3, NULL),
(37720, NULL, 'IPR046922', NULL, 'CASPASE and TPR Repeat-Associated, N-terminal domain', 'CATRA-N', 3, NULL),
(37721, NULL, 'IPR046348', NULL, 'SIS domain superfamily', 'SIS_dom_sf', 5, NULL),
(37722, NULL, 'IPR046530', NULL, 'Copper acquisition factor BIM1-like domain', 'BIM1-like_dom', 3, NULL),
(37723, NULL, 'IPR046311', NULL, 'Protein of unknown function DUF6426', 'DUF6426', 4, NULL),
(37724, NULL, 'IPR046370', NULL, 'Neurogenic mastermind-like, N-terminal domain superfamily', 'MAML_N_sf', 5, NULL),
(37725, NULL, 'IPR042545', NULL, 'Hemagglutinin-esterase', 'HEMA', 4, NULL),
(37726, NULL, 'IPR046330', NULL, 'DEAD box protein 17, ATP-binding domain', 'DDX17_ATP-bd-dom', 3, NULL),
(37727, NULL, 'IPR046318', NULL, 'Protein of unknown function DUF5344', 'DUF5344', 4, NULL),
(37728, NULL, 'IPR046286', NULL, 'Protein of unknown function DUF6323', 'DUF6323', 4, NULL),
(37729, NULL, 'IPR046429', NULL, 'mRNA-capping enzyme catalytic subunit, nucleotidyltransferase domain superfamily', 'MCEL_NTPase_sf', 5, NULL),
(37730, NULL, 'IPR042536', NULL, 'TFIIIC, subcomplex tauA subunit Sfc1, triple barrel domain superfamily', 'TFIIIC_tauA_Sfc1', 5, NULL),
(37731, NULL, 'IPR046527', NULL, 'PIR2-like, helical domain', 'PIR2-like_helical', 3, NULL),
(37732, NULL, 'IPR046881', NULL, 'Divergent DnaB-like ATPase', 'divDNAB', 3, NULL),
(37733, NULL, 'IPR046291', NULL, 'Protein of unknown function DUF6328', 'DUF6328', 4, NULL),
(37734, NULL, 'IPR046298', NULL, 'Protein of unknown function DUF6335', 'DUF6335', 4, NULL),
(37735, NULL, 'IPR043406', NULL, 'Transmembrane glycoprotein EPCAM/Trop-2', 'EPCAM/Trop-2', 4, NULL),
(37736, NULL, 'IPR046544', NULL, 'Domain of unknown function DUF6805', 'DUF6805', 3, NULL),
(37737, NULL, 'IPR046787', NULL, 'Putative DnaT-like domain', 'DnaT_2', 3, NULL);     
INSERT INTO "PUBLIC"."ENTRY" VALUES
(37738, NULL, 'IPR046563', NULL, 'Protein of unknown function DUF6715', 'DUF6715', 4, NULL),
(37739, NULL, 'IPR046488', NULL, 'Transcription factor tau subunit sfc3/Tfc3, C-terminal', 'Sfc3/Tfc3_C', 3, NULL),
(37740, NULL, 'IPR046401', NULL, 'Fat storage-inducing transmembrane protein 1/2', 'FITM1/2', 4, NULL),
(37741, NULL, 'IPR046491', NULL, 'Protein of unknown function DUF6584', 'DUF6584', 4, NULL),
(37742, NULL, 'IPR046430', NULL, 'mRNA-capping enzyme catalytic subunit, RNA triphosphatase domain superfamily', 'MCEL_TPase_sf', 5, NULL),
(37743, NULL, 'IPR046545', NULL, 'Protein of unknown function DUF6806', 'DUF6806', 4, NULL),
(37744, NULL, 'IPR046471', NULL, 'Integrator complex subunit 14, C-terminal', 'IntS14_C', 3, NULL),
(37745, NULL, 'IPR046880', NULL, 'Tetratricopeptide Repeats-Sensor', 'TPR-S', 7, NULL),
(37746, NULL, 'IPR046282', NULL, 'Protein of unknown function DUF6319', 'DUF6319', 4, NULL),
(37747, NULL, 'IPR046511', NULL, 'Protein of unknown function DUF6689', 'DUF6689', 4, NULL),
(37748, NULL, 'IPR046494', NULL, 'Protein of unknown function DUF6587', 'DUF6587', 4, NULL),
(37749, NULL, 'IPR042463', NULL, 'Haem NO binding associated domain superfamily', 'HNOB_dom_associated_sf', 5, NULL),
(37750, NULL, 'IPR046329', NULL, 'Solute carrier organic anion transporter family member 4A1-like', 'SO4A1-like', 4, NULL),
(37751, NULL, 'IPR046531', NULL, 'Domain of unknown function DUF6596', 'DUF6596', 3, NULL),
(37752, NULL, 'IPR046395', NULL, 'Bacteriophage T4, Gp32, single-stranded DNA-binding', 'SSB_T4', 4, NULL),
(37753, NULL, 'IPR046479', NULL, 'Protein of unknown function DUF6800', 'DUF6800', 4, NULL),
(37754, NULL, 'IPR046561', NULL, 'Protein of unknown function DUF6716', 'DUF6716', 4, NULL),
(37755, NULL, 'IPR046437', NULL, 'Serine/threonine-protein kinase, first cryptic polo-box domain superfamily', 'Ser_Thr-PK_POLO_box_1_sf', 5, NULL),
(37756, NULL, 'IPR046396', NULL, 'Probable inorganic carbon transporter subunit DabB', 'Transporter_DabB', 4, NULL),
(37757, NULL, 'IPR046803', NULL, 'DNA-dependent protein kinase catalytic subunit, CC1/2', 'DNAPKcs_CC1-2', 3, NULL),
(37758, NULL, 'IPR046301', NULL, 'Protein of unknown function DUF6416', 'DUF6416', 4, NULL),
(37759, NULL, 'IPR042469', NULL, 'E3 ubiquitin-protein ligase HECTD3', 'HECTD3', 4, NULL),
(37760, NULL, 'IPR046400', NULL, 'Acyl-coenzyme A diphosphatase SCS3', 'SCS3', 4, NULL),
(37761, NULL, 'IPR046373', NULL, 'Acyl-CoA oxidase/dehydrogenase, middle domain superfamily', 'Acyl-CoA_Oxase/DH_mid-dom_sf', 5, NULL),
(37762, NULL, 'IPR046455', NULL, 'Sec7/BIG1-like, C-terminal domain', 'Sec7/BIG1-like_C', 3, NULL),
(37763, NULL, 'IPR046335', NULL, 'Transcriptional regulator LacI/GalR-like, sensor domain', 'LacI/GalR-like_sensor', 3, NULL),
(37764, NULL, 'IPR046781', NULL, 'Phage ORF5 protein', 'Phage_ORF5', 4, NULL),
(37765, NULL, 'IPR046780', NULL, 'Atrophied bacterial Ig domain', 'aBig_2', 3, NULL),
(37766, NULL, 'IPR046281', NULL, 'Domain of unknown function DUF6318', 'DUF6318', 3, NULL),
(37767, NULL, 'IPR046547', NULL, 'Protein of unknown function DUF6803', 'DUF6803', 4, NULL),
(37768, NULL, 'IPR046886', NULL, 'Ribosomal RNA small subunit methyltransferase E, methyltransferase domain', 'RsmE_MTase_dom', 3, NULL),
(37769, NULL, 'IPR046283', NULL, 'Protein of unknown function DUF6320', 'DUF6320', 4, NULL),
(37770, NULL, 'IPR046505', NULL, 'Protein of unknown function DUF6683', 'DUF6683', 4, NULL),
(37771, NULL, 'IPR044447', NULL, 'DHX9, DEXH-box helicase domain', 'DHX9_DEXHc', 3, NULL);              
CREATE INDEX "PUBLIC"."ENTRY_AC_IDX" ON "PUBLIC"."ENTRY"("ACCESSION");         
CREATE INDEX "PUBLIC"."ENTRY_NAME_IDX" ON "PUBLIC"."ENTRY"("NAME");            
CREATE INDEX "PUBLIC"."ENTRY_TYPE_IDX" ON "PUBLIC"."ENTRY"("TYPE");            
CREATE CACHED TABLE "PUBLIC"."ENTRY_ABSTRACT_CHUNK"(
    "ENTRY_ID" BIGINT NOT NULL,
    "ABSTRACT_CHUNK" VARCHAR(4000),
    "CHUNK_INDEX" INTEGER NOT NULL
); 
ALTER TABLE "PUBLIC"."ENTRY_ABSTRACT_CHUNK" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_7" PRIMARY KEY("ENTRY_ID", "CHUNK_INDEX");     
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.ENTRY_ABSTRACT_CHUNK;     
CREATE CACHED TABLE "PUBLIC"."ENTRY_DESCRIPTION_CHUNK"(
    "ENTRY_ID" BIGINT NOT NULL,
    "DESCRIPTION_CHUNKS" VARCHAR(4000),
    "CHUNK_INDEX" INTEGER NOT NULL
);          
ALTER TABLE "PUBLIC"."ENTRY_DESCRIPTION_CHUNK" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_9C" PRIMARY KEY("ENTRY_ID", "CHUNK_INDEX"); 
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.ENTRY_DESCRIPTION_CHUNK;  
CREATE CACHED TABLE "PUBLIC"."ENTRY_GO_XREF"(
    "ENTRY_ID" BIGINT NOT NULL,
    "GO_XREF_ID" BIGINT NOT NULL
);              
ALTER TABLE "PUBLIC"."ENTRY_GO_XREF" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_C6" PRIMARY KEY("ENTRY_ID", "GO_XREF_ID");            
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.ENTRY_GO_XREF;            
CREATE CACHED TABLE "PUBLIC"."ENTRY_PATHWAY_XREF"(
    "ENTRY_ID" BIGINT NOT NULL,
    "PATHWAY_XREF_ID" BIGINT NOT NULL
);    
ALTER TABLE "PUBLIC"."ENTRY_PATHWAY_XREF" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_CE" PRIMARY KEY("ENTRY_ID", "PATHWAY_XREF_ID");  
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.ENTRY_PATHWAY_XREF;       
CREATE CACHED TABLE "PUBLIC"."ENTRY_RELEASE"(
    "ENTRY_ID" BIGINT NOT NULL,
    "RELEASE_ID" BIGINT NOT NULL
);              
ALTER TABLE "PUBLIC"."ENTRY_RELEASE" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_40" PRIMARY KEY("ENTRY_ID", "RELEASE_ID");            
-- 37771 +/- SELECT COUNT(*) FROM PUBLIC.ENTRY_RELEASE;        
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(1, 1),
(2, 1),
(3, 1),
(4, 1),
(5, 1),
(6, 1),
(7, 1),
(8, 1),
(9, 1),
(10, 1),
(11, 1),
(12, 1),
(13, 1),
(14, 1),
(15, 1),
(16, 1),
(17, 1),
(18, 1),
(19, 1),
(20, 1),
(21, 1),
(22, 1),
(23, 1),
(24, 1),
(25, 1),
(26, 1),
(27, 1),
(28, 1),
(29, 1),
(30, 1),
(31, 1),
(32, 1),
(33, 1),
(34, 1),
(35, 1),
(36, 1),
(37, 1),
(38, 1),
(39, 1),
(40, 1),
(41, 1),
(42, 1),
(43, 1),
(44, 1),
(45, 1),
(46, 1),
(47, 1),
(48, 1),
(49, 1),
(50, 1),
(51, 1),
(52, 1),
(53, 1),
(54, 1),
(55, 1),
(56, 1),
(57, 1),
(58, 1),
(59, 1),
(60, 1),
(61, 1),
(62, 1),
(63, 1),
(64, 1),
(65, 1),
(66, 1),
(67, 1),
(68, 1),
(69, 1),
(70, 1),
(71, 1),
(72, 1),
(73, 1),
(74, 1),
(75, 1),
(76, 1),
(77, 1),
(78, 1),
(79, 1),
(80, 1),
(81, 1),
(82, 1),
(83, 1),
(84, 1),
(85, 1),
(86, 1),
(87, 1),
(88, 1),
(89, 1),
(90, 1),
(91, 1),
(92, 1),
(93, 1),
(94, 1),
(95, 1),
(96, 1),
(97, 1),
(98, 1),
(99, 1),
(100, 1),
(101, 1),
(102, 1),
(103, 1),
(104, 1),
(105, 1),
(106, 1),
(107, 1),
(108, 1),
(109, 1),
(110, 1),
(111, 1),
(112, 1),
(113, 1),
(114, 1),
(115, 1),
(116, 1),
(117, 1),
(118, 1),
(119, 1),
(120, 1),
(121, 1),
(122, 1),
(123, 1),
(124, 1),
(125, 1),
(126, 1),
(127, 1),
(128, 1),
(129, 1),
(130, 1),
(131, 1),
(132, 1),
(133, 1),
(134, 1),
(135, 1),
(136, 1),
(137, 1),
(138, 1),
(139, 1),
(140, 1),
(141, 1),
(142, 1),
(143, 1),
(144, 1),
(145, 1),
(146, 1),
(147, 1),
(148, 1),
(149, 1),
(150, 1),
(151, 1),
(152, 1),
(153, 1),
(154, 1),
(155, 1),
(156, 1),
(157, 1),
(158, 1),
(159, 1),
(160, 1),
(161, 1),
(162, 1),
(163, 1),
(164, 1),
(165, 1),
(166, 1),
(167, 1),
(168, 1),
(169, 1),
(170, 1),
(171, 1),
(172, 1),
(173, 1),
(174, 1),
(175, 1),
(176, 1),
(177, 1),
(178, 1),
(179, 1),
(180, 1),
(181, 1),
(182, 1),
(183, 1),
(184, 1),
(185, 1),
(186, 1),
(187, 1),
(188, 1),
(189, 1),
(190, 1),
(191, 1),
(192, 1),
(193, 1),
(194, 1),
(195, 1),
(196, 1),
(197, 1),
(198, 1),
(199, 1),
(200, 1),
(201, 1),
(202, 1),
(203, 1),
(204, 1),
(205, 1),
(206, 1),
(207, 1),
(208, 1),
(209, 1),
(210, 1),
(211, 1),
(212, 1),
(213, 1),
(214, 1),
(215, 1),
(216, 1),
(217, 1),
(218, 1),
(219, 1),
(220, 1),
(221, 1),
(222, 1),
(223, 1),
(224, 1),
(225, 1),
(226, 1),
(227, 1),
(228, 1),
(229, 1),
(230, 1),
(231, 1),
(232, 1),
(233, 1),
(234, 1),
(235, 1),
(236, 1),
(237, 1),
(238, 1),
(239, 1),
(240, 1),
(241, 1),
(242, 1),
(243, 1),
(244, 1),
(245, 1),
(246, 1),
(247, 1),
(248, 1),
(249, 1),
(250, 1),
(251, 1),
(252, 1),
(253, 1),
(254, 1),
(255, 1),
(256, 1),
(257, 1),
(258, 1),
(259, 1),
(260, 1),
(261, 1),
(262, 1),
(263, 1),
(264, 1),
(265, 1),
(266, 1),
(267, 1),
(268, 1),
(269, 1),
(270, 1),
(271, 1),
(272, 1),
(273, 1),
(274, 1),
(275, 1),
(276, 1),
(277, 1),
(278, 1),
(279, 1),
(280, 1),
(281, 1),
(282, 1),
(283, 1),
(284, 1),
(285, 1),
(286, 1),
(287, 1),
(288, 1),
(289, 1),
(290, 1),
(291, 1),
(292, 1),
(293, 1),
(294, 1),
(295, 1),
(296, 1),
(297, 1),
(298, 1),
(299, 1),
(300, 1),
(301, 1),
(302, 1),
(303, 1),
(304, 1),
(305, 1),
(306, 1),
(307, 1),
(308, 1),
(309, 1),
(310, 1),
(311, 1),
(312, 1),
(313, 1),
(314, 1),
(315, 1),
(316, 1),
(317, 1),
(318, 1),
(319, 1),
(320, 1),
(321, 1),
(322, 1),
(323, 1),
(324, 1),
(325, 1),
(326, 1),
(327, 1),
(328, 1),
(329, 1),
(330, 1),
(331, 1),
(332, 1),
(333, 1),
(334, 1),
(335, 1),
(336, 1),
(337, 1),
(338, 1),
(339, 1),
(340, 1),
(341, 1),
(342, 1),
(343, 1),
(344, 1),
(345, 1),
(346, 1),
(347, 1),
(348, 1),
(349, 1),
(350, 1),
(351, 1),
(352, 1),
(353, 1),
(354, 1),
(355, 1),
(356, 1),
(357, 1),
(358, 1),
(359, 1),
(360, 1),
(361, 1),
(362, 1),
(363, 1),
(364, 1),
(365, 1),
(366, 1),
(367, 1),
(368, 1),
(369, 1),
(370, 1),
(371, 1),
(372, 1),
(373, 1),
(374, 1),
(375, 1),
(376, 1),
(377, 1),
(378, 1),
(379, 1),
(380, 1),
(381, 1),
(382, 1),
(383, 1),
(384, 1),
(385, 1),
(386, 1),
(387, 1),
(388, 1),
(389, 1),
(390, 1),
(391, 1),
(392, 1),
(393, 1),
(394, 1),
(395, 1),
(396, 1),
(397, 1),
(398, 1),
(399, 1),
(400, 1),
(401, 1),
(402, 1),
(403, 1),
(404, 1),
(405, 1),
(406, 1),
(407, 1),
(408, 1),
(409, 1),
(410, 1),
(411, 1),
(412, 1),
(413, 1),
(414, 1),
(415, 1),
(416, 1),
(417, 1);      
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(418, 1),
(419, 1),
(420, 1),
(421, 1),
(422, 1),
(423, 1),
(424, 1),
(425, 1),
(426, 1),
(427, 1),
(428, 1),
(429, 1),
(430, 1),
(431, 1),
(432, 1),
(433, 1),
(434, 1),
(435, 1),
(436, 1),
(437, 1),
(438, 1),
(439, 1),
(440, 1),
(441, 1),
(442, 1),
(443, 1),
(444, 1),
(445, 1),
(446, 1),
(447, 1),
(448, 1),
(449, 1),
(450, 1),
(451, 1),
(452, 1),
(453, 1),
(454, 1),
(455, 1),
(456, 1),
(457, 1),
(458, 1),
(459, 1),
(460, 1),
(461, 1),
(462, 1),
(463, 1),
(464, 1),
(465, 1),
(466, 1),
(467, 1),
(468, 1),
(469, 1),
(470, 1),
(471, 1),
(472, 1),
(473, 1),
(474, 1),
(475, 1),
(476, 1),
(477, 1),
(478, 1),
(479, 1),
(480, 1),
(481, 1),
(482, 1),
(483, 1),
(484, 1),
(485, 1),
(486, 1),
(487, 1),
(488, 1),
(489, 1),
(490, 1),
(491, 1),
(492, 1),
(493, 1),
(494, 1),
(495, 1),
(496, 1),
(497, 1),
(498, 1),
(499, 1),
(500, 1),
(501, 1),
(502, 1),
(503, 1),
(504, 1),
(505, 1),
(506, 1),
(507, 1),
(508, 1),
(509, 1),
(510, 1),
(511, 1),
(512, 1),
(513, 1),
(514, 1),
(515, 1),
(516, 1),
(517, 1),
(518, 1),
(519, 1),
(520, 1),
(521, 1),
(522, 1),
(523, 1),
(524, 1),
(525, 1),
(526, 1),
(527, 1),
(528, 1),
(529, 1),
(530, 1),
(531, 1),
(532, 1),
(533, 1),
(534, 1),
(535, 1),
(536, 1),
(537, 1),
(538, 1),
(539, 1),
(540, 1),
(541, 1),
(542, 1),
(543, 1),
(544, 1),
(545, 1),
(546, 1),
(547, 1),
(548, 1),
(549, 1),
(550, 1),
(551, 1),
(552, 1),
(553, 1),
(554, 1),
(555, 1),
(556, 1),
(557, 1),
(558, 1),
(559, 1),
(560, 1),
(561, 1),
(562, 1),
(563, 1),
(564, 1),
(565, 1),
(566, 1),
(567, 1),
(568, 1),
(569, 1),
(570, 1),
(571, 1),
(572, 1),
(573, 1),
(574, 1),
(575, 1),
(576, 1),
(577, 1),
(578, 1),
(579, 1),
(580, 1),
(581, 1),
(582, 1),
(583, 1),
(584, 1),
(585, 1),
(586, 1),
(587, 1),
(588, 1),
(589, 1),
(590, 1),
(591, 1),
(592, 1),
(593, 1),
(594, 1),
(595, 1),
(596, 1),
(597, 1),
(598, 1),
(599, 1),
(600, 1),
(601, 1),
(602, 1),
(603, 1),
(604, 1),
(605, 1),
(606, 1),
(607, 1),
(608, 1),
(609, 1),
(610, 1),
(611, 1),
(612, 1),
(613, 1),
(614, 1),
(615, 1),
(616, 1),
(617, 1),
(618, 1),
(619, 1),
(620, 1),
(621, 1),
(622, 1),
(623, 1),
(624, 1),
(625, 1),
(626, 1),
(627, 1),
(628, 1),
(629, 1),
(630, 1),
(631, 1),
(632, 1),
(633, 1),
(634, 1),
(635, 1),
(636, 1),
(637, 1),
(638, 1),
(639, 1),
(640, 1),
(641, 1),
(642, 1),
(643, 1),
(644, 1),
(645, 1),
(646, 1),
(647, 1),
(648, 1),
(649, 1),
(650, 1),
(651, 1),
(652, 1),
(653, 1),
(654, 1),
(655, 1),
(656, 1),
(657, 1),
(658, 1),
(659, 1),
(660, 1),
(661, 1),
(662, 1),
(663, 1),
(664, 1),
(665, 1),
(666, 1),
(667, 1),
(668, 1),
(669, 1),
(670, 1),
(671, 1),
(672, 1),
(673, 1),
(674, 1),
(675, 1),
(676, 1),
(677, 1),
(678, 1),
(679, 1),
(680, 1),
(681, 1),
(682, 1),
(683, 1),
(684, 1),
(685, 1),
(686, 1),
(687, 1),
(688, 1),
(689, 1),
(690, 1),
(691, 1),
(692, 1),
(693, 1),
(694, 1),
(695, 1),
(696, 1),
(697, 1),
(698, 1),
(699, 1),
(700, 1),
(701, 1),
(702, 1),
(703, 1),
(704, 1),
(705, 1),
(706, 1),
(707, 1),
(708, 1),
(709, 1),
(710, 1),
(711, 1),
(712, 1),
(713, 1),
(714, 1),
(715, 1),
(716, 1),
(717, 1),
(718, 1),
(719, 1),
(720, 1),
(721, 1),
(722, 1),
(723, 1),
(724, 1),
(725, 1),
(726, 1),
(727, 1),
(728, 1),
(729, 1),
(730, 1),
(731, 1),
(732, 1),
(733, 1),
(734, 1),
(735, 1),
(736, 1),
(737, 1),
(738, 1),
(739, 1),
(740, 1),
(741, 1),
(742, 1),
(743, 1),
(744, 1),
(745, 1),
(746, 1),
(747, 1),
(748, 1),
(749, 1),
(750, 1),
(751, 1),
(752, 1),
(753, 1),
(754, 1),
(755, 1),
(756, 1),
(757, 1),
(758, 1),
(759, 1),
(760, 1),
(761, 1),
(762, 1),
(763, 1),
(764, 1),
(765, 1),
(766, 1),
(767, 1),
(768, 1),
(769, 1),
(770, 1),
(771, 1),
(772, 1),
(773, 1),
(774, 1),
(775, 1),
(776, 1),
(777, 1),
(778, 1),
(779, 1),
(780, 1),
(781, 1),
(782, 1),
(783, 1),
(784, 1),
(785, 1),
(786, 1),
(787, 1),
(788, 1),
(789, 1),
(790, 1),
(791, 1),
(792, 1),
(793, 1),
(794, 1),
(795, 1),
(796, 1),
(797, 1),
(798, 1),
(799, 1),
(800, 1),
(801, 1),
(802, 1),
(803, 1),
(804, 1),
(805, 1),
(806, 1),
(807, 1),
(808, 1),
(809, 1),
(810, 1),
(811, 1),
(812, 1),
(813, 1),
(814, 1),
(815, 1),
(816, 1),
(817, 1),
(818, 1),
(819, 1),
(820, 1),
(821, 1),
(822, 1),
(823, 1);        
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(824, 1),
(825, 1),
(826, 1),
(827, 1),
(828, 1),
(829, 1),
(830, 1),
(831, 1),
(832, 1),
(833, 1),
(834, 1),
(835, 1),
(836, 1),
(837, 1),
(838, 1),
(839, 1),
(840, 1),
(841, 1),
(842, 1),
(843, 1),
(844, 1),
(845, 1),
(846, 1),
(847, 1),
(848, 1),
(849, 1),
(850, 1),
(851, 1),
(852, 1),
(853, 1),
(854, 1),
(855, 1),
(856, 1),
(857, 1),
(858, 1),
(859, 1),
(860, 1),
(861, 1),
(862, 1),
(863, 1),
(864, 1),
(865, 1),
(866, 1),
(867, 1),
(868, 1),
(869, 1),
(870, 1),
(871, 1),
(872, 1),
(873, 1),
(874, 1),
(875, 1),
(876, 1),
(877, 1),
(878, 1),
(879, 1),
(880, 1),
(881, 1),
(882, 1),
(883, 1),
(884, 1),
(885, 1),
(886, 1),
(887, 1),
(888, 1),
(889, 1),
(890, 1),
(891, 1),
(892, 1),
(893, 1),
(894, 1),
(895, 1),
(896, 1),
(897, 1),
(898, 1),
(899, 1),
(900, 1),
(901, 1),
(902, 1),
(903, 1),
(904, 1),
(905, 1),
(906, 1),
(907, 1),
(908, 1),
(909, 1),
(910, 1),
(911, 1),
(912, 1),
(913, 1),
(914, 1),
(915, 1),
(916, 1),
(917, 1),
(918, 1),
(919, 1),
(920, 1),
(921, 1),
(922, 1),
(923, 1),
(924, 1),
(925, 1),
(926, 1),
(927, 1),
(928, 1),
(929, 1),
(930, 1),
(931, 1),
(932, 1),
(933, 1),
(934, 1),
(935, 1),
(936, 1),
(937, 1),
(938, 1),
(939, 1),
(940, 1),
(941, 1),
(942, 1),
(943, 1),
(944, 1),
(945, 1),
(946, 1),
(947, 1),
(948, 1),
(949, 1),
(950, 1),
(951, 1),
(952, 1),
(953, 1),
(954, 1),
(955, 1),
(956, 1),
(957, 1),
(958, 1),
(959, 1),
(960, 1),
(961, 1),
(962, 1),
(963, 1),
(964, 1),
(965, 1),
(966, 1),
(967, 1),
(968, 1),
(969, 1),
(970, 1),
(971, 1),
(972, 1),
(973, 1),
(974, 1),
(975, 1),
(976, 1),
(977, 1),
(978, 1),
(979, 1),
(980, 1),
(981, 1),
(982, 1),
(983, 1),
(984, 1),
(985, 1),
(986, 1),
(987, 1),
(988, 1),
(989, 1),
(990, 1),
(991, 1),
(992, 1),
(993, 1),
(994, 1),
(995, 1),
(996, 1),
(997, 1),
(998, 1),
(999, 1),
(1000, 1),
(1001, 1),
(1002, 1),
(1003, 1),
(1004, 1),
(1005, 1),
(1006, 1),
(1007, 1),
(1008, 1),
(1009, 1),
(1010, 1),
(1011, 1),
(1012, 1),
(1013, 1),
(1014, 1),
(1015, 1),
(1016, 1),
(1017, 1),
(1018, 1),
(1019, 1),
(1020, 1),
(1021, 1),
(1022, 1),
(1023, 1),
(1024, 1),
(1025, 1),
(1026, 1),
(1027, 1),
(1028, 1),
(1029, 1),
(1030, 1),
(1031, 1),
(1032, 1),
(1033, 1),
(1034, 1),
(1035, 1),
(1036, 1),
(1037, 1),
(1038, 1),
(1039, 1),
(1040, 1),
(1041, 1),
(1042, 1),
(1043, 1),
(1044, 1),
(1045, 1),
(1046, 1),
(1047, 1),
(1048, 1),
(1049, 1),
(1050, 1),
(1051, 1),
(1052, 1),
(1053, 1),
(1054, 1),
(1055, 1),
(1056, 1),
(1057, 1),
(1058, 1),
(1059, 1),
(1060, 1),
(1061, 1),
(1062, 1),
(1063, 1),
(1064, 1),
(1065, 1),
(1066, 1),
(1067, 1),
(1068, 1),
(1069, 1),
(1070, 1),
(1071, 1),
(1072, 1),
(1073, 1),
(1074, 1),
(1075, 1),
(1076, 1),
(1077, 1),
(1078, 1),
(1079, 1),
(1080, 1),
(1081, 1),
(1082, 1),
(1083, 1),
(1084, 1),
(1085, 1),
(1086, 1),
(1087, 1),
(1088, 1),
(1089, 1),
(1090, 1),
(1091, 1),
(1092, 1),
(1093, 1),
(1094, 1),
(1095, 1),
(1096, 1),
(1097, 1),
(1098, 1),
(1099, 1),
(1100, 1),
(1101, 1),
(1102, 1),
(1103, 1),
(1104, 1),
(1105, 1),
(1106, 1),
(1107, 1),
(1108, 1),
(1109, 1),
(1110, 1),
(1111, 1),
(1112, 1),
(1113, 1),
(1114, 1),
(1115, 1),
(1116, 1),
(1117, 1),
(1118, 1),
(1119, 1),
(1120, 1),
(1121, 1),
(1122, 1),
(1123, 1),
(1124, 1),
(1125, 1),
(1126, 1),
(1127, 1),
(1128, 1),
(1129, 1),
(1130, 1),
(1131, 1),
(1132, 1),
(1133, 1),
(1134, 1),
(1135, 1),
(1136, 1),
(1137, 1),
(1138, 1),
(1139, 1),
(1140, 1),
(1141, 1),
(1142, 1),
(1143, 1),
(1144, 1),
(1145, 1),
(1146, 1),
(1147, 1),
(1148, 1),
(1149, 1),
(1150, 1),
(1151, 1),
(1152, 1),
(1153, 1),
(1154, 1),
(1155, 1),
(1156, 1),
(1157, 1),
(1158, 1),
(1159, 1),
(1160, 1),
(1161, 1),
(1162, 1),
(1163, 1),
(1164, 1),
(1165, 1),
(1166, 1),
(1167, 1),
(1168, 1),
(1169, 1),
(1170, 1),
(1171, 1),
(1172, 1),
(1173, 1),
(1174, 1),
(1175, 1),
(1176, 1),
(1177, 1),
(1178, 1),
(1179, 1),
(1180, 1),
(1181, 1),
(1182, 1),
(1183, 1),
(1184, 1),
(1185, 1),
(1186, 1),
(1187, 1),
(1188, 1),
(1189, 1),
(1190, 1),
(1191, 1),
(1192, 1),
(1193, 1),
(1194, 1),
(1195, 1),
(1196, 1),
(1197, 1),
(1198, 1),
(1199, 1),
(1200, 1),
(1201, 1),
(1202, 1),
(1203, 1),
(1204, 1),
(1205, 1),
(1206, 1),
(1207, 1),
(1208, 1);         
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(1209, 1),
(1210, 1),
(1211, 1),
(1212, 1),
(1213, 1),
(1214, 1),
(1215, 1),
(1216, 1),
(1217, 1),
(1218, 1),
(1219, 1),
(1220, 1),
(1221, 1),
(1222, 1),
(1223, 1),
(1224, 1),
(1225, 1),
(1226, 1),
(1227, 1),
(1228, 1),
(1229, 1),
(1230, 1),
(1231, 1),
(1232, 1),
(1233, 1),
(1234, 1),
(1235, 1),
(1236, 1),
(1237, 1),
(1238, 1),
(1239, 1),
(1240, 1),
(1241, 1),
(1242, 1),
(1243, 1),
(1244, 1),
(1245, 1),
(1246, 1),
(1247, 1),
(1248, 1),
(1249, 1),
(1250, 1),
(1251, 1),
(1252, 1),
(1253, 1),
(1254, 1),
(1255, 1),
(1256, 1),
(1257, 1),
(1258, 1),
(1259, 1),
(1260, 1),
(1261, 1),
(1262, 1),
(1263, 1),
(1264, 1),
(1265, 1),
(1266, 1),
(1267, 1),
(1268, 1),
(1269, 1),
(1270, 1),
(1271, 1),
(1272, 1),
(1273, 1),
(1274, 1),
(1275, 1),
(1276, 1),
(1277, 1),
(1278, 1),
(1279, 1),
(1280, 1),
(1281, 1),
(1282, 1),
(1283, 1),
(1284, 1),
(1285, 1),
(1286, 1),
(1287, 1),
(1288, 1),
(1289, 1),
(1290, 1),
(1291, 1),
(1292, 1),
(1293, 1),
(1294, 1),
(1295, 1),
(1296, 1),
(1297, 1),
(1298, 1),
(1299, 1),
(1300, 1),
(1301, 1),
(1302, 1),
(1303, 1),
(1304, 1),
(1305, 1),
(1306, 1),
(1307, 1),
(1308, 1),
(1309, 1),
(1310, 1),
(1311, 1),
(1312, 1),
(1313, 1),
(1314, 1),
(1315, 1),
(1316, 1),
(1317, 1),
(1318, 1),
(1319, 1),
(1320, 1),
(1321, 1),
(1322, 1),
(1323, 1),
(1324, 1),
(1325, 1),
(1326, 1),
(1327, 1),
(1328, 1),
(1329, 1),
(1330, 1),
(1331, 1),
(1332, 1),
(1333, 1),
(1334, 1),
(1335, 1),
(1336, 1),
(1337, 1),
(1338, 1),
(1339, 1),
(1340, 1),
(1341, 1),
(1342, 1),
(1343, 1),
(1344, 1),
(1345, 1),
(1346, 1),
(1347, 1),
(1348, 1),
(1349, 1),
(1350, 1),
(1351, 1),
(1352, 1),
(1353, 1),
(1354, 1),
(1355, 1),
(1356, 1),
(1357, 1),
(1358, 1),
(1359, 1),
(1360, 1),
(1361, 1),
(1362, 1),
(1363, 1),
(1364, 1),
(1365, 1),
(1366, 1),
(1367, 1),
(1368, 1),
(1369, 1),
(1370, 1),
(1371, 1),
(1372, 1),
(1373, 1),
(1374, 1),
(1375, 1),
(1376, 1),
(1377, 1),
(1378, 1),
(1379, 1),
(1380, 1),
(1381, 1),
(1382, 1),
(1383, 1),
(1384, 1),
(1385, 1),
(1386, 1),
(1387, 1),
(1388, 1),
(1389, 1),
(1390, 1),
(1391, 1),
(1392, 1),
(1393, 1),
(1394, 1),
(1395, 1),
(1396, 1),
(1397, 1),
(1398, 1),
(1399, 1),
(1400, 1),
(1401, 1),
(1402, 1),
(1403, 1),
(1404, 1),
(1405, 1),
(1406, 1),
(1407, 1),
(1408, 1),
(1409, 1),
(1410, 1),
(1411, 1),
(1412, 1),
(1413, 1),
(1414, 1),
(1415, 1),
(1416, 1),
(1417, 1),
(1418, 1),
(1419, 1),
(1420, 1),
(1421, 1),
(1422, 1),
(1423, 1),
(1424, 1),
(1425, 1),
(1426, 1),
(1427, 1),
(1428, 1),
(1429, 1),
(1430, 1),
(1431, 1),
(1432, 1),
(1433, 1),
(1434, 1),
(1435, 1),
(1436, 1),
(1437, 1),
(1438, 1),
(1439, 1),
(1440, 1),
(1441, 1),
(1442, 1),
(1443, 1),
(1444, 1),
(1445, 1),
(1446, 1),
(1447, 1),
(1448, 1),
(1449, 1),
(1450, 1),
(1451, 1),
(1452, 1),
(1453, 1),
(1454, 1),
(1455, 1),
(1456, 1),
(1457, 1),
(1458, 1),
(1459, 1),
(1460, 1),
(1461, 1),
(1462, 1),
(1463, 1),
(1464, 1),
(1465, 1),
(1466, 1),
(1467, 1),
(1468, 1),
(1469, 1),
(1470, 1),
(1471, 1),
(1472, 1),
(1473, 1),
(1474, 1),
(1475, 1),
(1476, 1),
(1477, 1),
(1478, 1),
(1479, 1),
(1480, 1),
(1481, 1),
(1482, 1),
(1483, 1),
(1484, 1),
(1485, 1),
(1486, 1),
(1487, 1),
(1488, 1),
(1489, 1),
(1490, 1),
(1491, 1),
(1492, 1),
(1493, 1),
(1494, 1),
(1495, 1),
(1496, 1),
(1497, 1),
(1498, 1),
(1499, 1),
(1500, 1),
(1501, 1),
(1502, 1),
(1503, 1),
(1504, 1),
(1505, 1),
(1506, 1),
(1507, 1),
(1508, 1),
(1509, 1),
(1510, 1),
(1511, 1),
(1512, 1),
(1513, 1),
(1514, 1),
(1515, 1),
(1516, 1),
(1517, 1),
(1518, 1),
(1519, 1),
(1520, 1),
(1521, 1),
(1522, 1),
(1523, 1),
(1524, 1),
(1525, 1),
(1526, 1),
(1527, 1),
(1528, 1),
(1529, 1),
(1530, 1),
(1531, 1),
(1532, 1),
(1533, 1),
(1534, 1),
(1535, 1),
(1536, 1),
(1537, 1),
(1538, 1),
(1539, 1),
(1540, 1),
(1541, 1),
(1542, 1),
(1543, 1),
(1544, 1),
(1545, 1),
(1546, 1),
(1547, 1),
(1548, 1),
(1549, 1),
(1550, 1),
(1551, 1),
(1552, 1),
(1553, 1),
(1554, 1),
(1555, 1),
(1556, 1),
(1557, 1),
(1558, 1),
(1559, 1),
(1560, 1),
(1561, 1),
(1562, 1),
(1563, 1),
(1564, 1),
(1565, 1),
(1566, 1),
(1567, 1),
(1568, 1),
(1569, 1),
(1570, 1),
(1571, 1),
(1572, 1),
(1573, 1),
(1574, 1),
(1575, 1),
(1576, 1),
(1577, 1);         
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(1578, 1),
(1579, 1),
(1580, 1),
(1581, 1),
(1582, 1),
(1583, 1),
(1584, 1),
(1585, 1),
(1586, 1),
(1587, 1),
(1588, 1),
(1589, 1),
(1590, 1),
(1591, 1),
(1592, 1),
(1593, 1),
(1594, 1),
(1595, 1),
(1596, 1),
(1597, 1),
(1598, 1),
(1599, 1),
(1600, 1),
(1601, 1),
(1602, 1),
(1603, 1),
(1604, 1),
(1605, 1),
(1606, 1),
(1607, 1),
(1608, 1),
(1609, 1),
(1610, 1),
(1611, 1),
(1612, 1),
(1613, 1),
(1614, 1),
(1615, 1),
(1616, 1),
(1617, 1),
(1618, 1),
(1619, 1),
(1620, 1),
(1621, 1),
(1622, 1),
(1623, 1),
(1624, 1),
(1625, 1),
(1626, 1),
(1627, 1),
(1628, 1),
(1629, 1),
(1630, 1),
(1631, 1),
(1632, 1),
(1633, 1),
(1634, 1),
(1635, 1),
(1636, 1),
(1637, 1),
(1638, 1),
(1639, 1),
(1640, 1),
(1641, 1),
(1642, 1),
(1643, 1),
(1644, 1),
(1645, 1),
(1646, 1),
(1647, 1),
(1648, 1),
(1649, 1),
(1650, 1),
(1651, 1),
(1652, 1),
(1653, 1),
(1654, 1),
(1655, 1),
(1656, 1),
(1657, 1),
(1658, 1),
(1659, 1),
(1660, 1),
(1661, 1),
(1662, 1),
(1663, 1),
(1664, 1),
(1665, 1),
(1666, 1),
(1667, 1),
(1668, 1),
(1669, 1),
(1670, 1),
(1671, 1),
(1672, 1),
(1673, 1),
(1674, 1),
(1675, 1),
(1676, 1),
(1677, 1),
(1678, 1),
(1679, 1),
(1680, 1),
(1681, 1),
(1682, 1),
(1683, 1),
(1684, 1),
(1685, 1),
(1686, 1),
(1687, 1),
(1688, 1),
(1689, 1),
(1690, 1),
(1691, 1),
(1692, 1),
(1693, 1),
(1694, 1),
(1695, 1),
(1696, 1),
(1697, 1),
(1698, 1),
(1699, 1),
(1700, 1),
(1701, 1),
(1702, 1),
(1703, 1),
(1704, 1),
(1705, 1),
(1706, 1),
(1707, 1),
(1708, 1),
(1709, 1),
(1710, 1),
(1711, 1),
(1712, 1),
(1713, 1),
(1714, 1),
(1715, 1),
(1716, 1),
(1717, 1),
(1718, 1),
(1719, 1),
(1720, 1),
(1721, 1),
(1722, 1),
(1723, 1),
(1724, 1),
(1725, 1),
(1726, 1),
(1727, 1),
(1728, 1),
(1729, 1),
(1730, 1),
(1731, 1),
(1732, 1),
(1733, 1),
(1734, 1),
(1735, 1),
(1736, 1),
(1737, 1),
(1738, 1),
(1739, 1),
(1740, 1),
(1741, 1),
(1742, 1),
(1743, 1),
(1744, 1),
(1745, 1),
(1746, 1),
(1747, 1),
(1748, 1),
(1749, 1),
(1750, 1),
(1751, 1),
(1752, 1),
(1753, 1),
(1754, 1),
(1755, 1),
(1756, 1),
(1757, 1),
(1758, 1),
(1759, 1),
(1760, 1),
(1761, 1),
(1762, 1),
(1763, 1),
(1764, 1),
(1765, 1),
(1766, 1),
(1767, 1),
(1768, 1),
(1769, 1),
(1770, 1),
(1771, 1),
(1772, 1),
(1773, 1),
(1774, 1),
(1775, 1),
(1776, 1),
(1777, 1),
(1778, 1),
(1779, 1),
(1780, 1),
(1781, 1),
(1782, 1),
(1783, 1),
(1784, 1),
(1785, 1),
(1786, 1),
(1787, 1),
(1788, 1),
(1789, 1),
(1790, 1),
(1791, 1),
(1792, 1),
(1793, 1),
(1794, 1),
(1795, 1),
(1796, 1),
(1797, 1),
(1798, 1),
(1799, 1),
(1800, 1),
(1801, 1),
(1802, 1),
(1803, 1),
(1804, 1),
(1805, 1),
(1806, 1),
(1807, 1),
(1808, 1),
(1809, 1),
(1810, 1),
(1811, 1),
(1812, 1),
(1813, 1),
(1814, 1),
(1815, 1),
(1816, 1),
(1817, 1),
(1818, 1),
(1819, 1),
(1820, 1),
(1821, 1),
(1822, 1),
(1823, 1),
(1824, 1),
(1825, 1),
(1826, 1),
(1827, 1),
(1828, 1),
(1829, 1),
(1830, 1),
(1831, 1),
(1832, 1),
(1833, 1),
(1834, 1),
(1835, 1),
(1836, 1),
(1837, 1),
(1838, 1),
(1839, 1),
(1840, 1),
(1841, 1),
(1842, 1),
(1843, 1),
(1844, 1),
(1845, 1),
(1846, 1),
(1847, 1),
(1848, 1),
(1849, 1),
(1850, 1),
(1851, 1),
(1852, 1),
(1853, 1),
(1854, 1),
(1855, 1),
(1856, 1),
(1857, 1),
(1858, 1),
(1859, 1),
(1860, 1),
(1861, 1),
(1862, 1),
(1863, 1),
(1864, 1),
(1865, 1),
(1866, 1),
(1867, 1),
(1868, 1),
(1869, 1),
(1870, 1),
(1871, 1),
(1872, 1),
(1873, 1),
(1874, 1),
(1875, 1),
(1876, 1),
(1877, 1),
(1878, 1),
(1879, 1),
(1880, 1),
(1881, 1),
(1882, 1),
(1883, 1),
(1884, 1),
(1885, 1),
(1886, 1),
(1887, 1),
(1888, 1),
(1889, 1),
(1890, 1),
(1891, 1),
(1892, 1),
(1893, 1),
(1894, 1),
(1895, 1),
(1896, 1),
(1897, 1),
(1898, 1),
(1899, 1),
(1900, 1),
(1901, 1),
(1902, 1),
(1903, 1),
(1904, 1),
(1905, 1),
(1906, 1),
(1907, 1),
(1908, 1),
(1909, 1),
(1910, 1),
(1911, 1),
(1912, 1),
(1913, 1),
(1914, 1),
(1915, 1),
(1916, 1),
(1917, 1),
(1918, 1),
(1919, 1),
(1920, 1),
(1921, 1),
(1922, 1),
(1923, 1),
(1924, 1),
(1925, 1),
(1926, 1),
(1927, 1),
(1928, 1),
(1929, 1),
(1930, 1),
(1931, 1),
(1932, 1),
(1933, 1),
(1934, 1),
(1935, 1),
(1936, 1),
(1937, 1),
(1938, 1),
(1939, 1),
(1940, 1),
(1941, 1),
(1942, 1),
(1943, 1),
(1944, 1),
(1945, 1),
(1946, 1);         
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(1947, 1),
(1948, 1),
(1949, 1),
(1950, 1),
(1951, 1),
(1952, 1),
(1953, 1),
(1954, 1),
(1955, 1),
(1956, 1),
(1957, 1),
(1958, 1),
(1959, 1),
(1960, 1),
(1961, 1),
(1962, 1),
(1963, 1),
(1964, 1),
(1965, 1),
(1966, 1),
(1967, 1),
(1968, 1),
(1969, 1),
(1970, 1),
(1971, 1),
(1972, 1),
(1973, 1),
(1974, 1),
(1975, 1),
(1976, 1),
(1977, 1),
(1978, 1),
(1979, 1),
(1980, 1),
(1981, 1),
(1982, 1),
(1983, 1),
(1984, 1),
(1985, 1),
(1986, 1),
(1987, 1),
(1988, 1),
(1989, 1),
(1990, 1),
(1991, 1),
(1992, 1),
(1993, 1),
(1994, 1),
(1995, 1),
(1996, 1),
(1997, 1),
(1998, 1),
(1999, 1),
(2000, 1),
(2001, 1),
(2002, 1),
(2003, 1),
(2004, 1),
(2005, 1),
(2006, 1),
(2007, 1),
(2008, 1),
(2009, 1),
(2010, 1),
(2011, 1),
(2012, 1),
(2013, 1),
(2014, 1),
(2015, 1),
(2016, 1),
(2017, 1),
(2018, 1),
(2019, 1),
(2020, 1),
(2021, 1),
(2022, 1),
(2023, 1),
(2024, 1),
(2025, 1),
(2026, 1),
(2027, 1),
(2028, 1),
(2029, 1),
(2030, 1),
(2031, 1),
(2032, 1),
(2033, 1),
(2034, 1),
(2035, 1),
(2036, 1),
(2037, 1),
(2038, 1),
(2039, 1),
(2040, 1),
(2041, 1),
(2042, 1),
(2043, 1),
(2044, 1),
(2045, 1),
(2046, 1),
(2047, 1),
(2048, 1),
(2049, 1),
(2050, 1),
(2051, 1),
(2052, 1),
(2053, 1),
(2054, 1),
(2055, 1),
(2056, 1),
(2057, 1),
(2058, 1),
(2059, 1),
(2060, 1),
(2061, 1),
(2062, 1),
(2063, 1),
(2064, 1),
(2065, 1),
(2066, 1),
(2067, 1),
(2068, 1),
(2069, 1),
(2070, 1),
(2071, 1),
(2072, 1),
(2073, 1),
(2074, 1),
(2075, 1),
(2076, 1),
(2077, 1),
(2078, 1),
(2079, 1),
(2080, 1),
(2081, 1),
(2082, 1),
(2083, 1),
(2084, 1),
(2085, 1),
(2086, 1),
(2087, 1),
(2088, 1),
(2089, 1),
(2090, 1),
(2091, 1),
(2092, 1),
(2093, 1),
(2094, 1),
(2095, 1),
(2096, 1),
(2097, 1),
(2098, 1),
(2099, 1),
(2100, 1),
(2101, 1),
(2102, 1),
(2103, 1),
(2104, 1),
(2105, 1),
(2106, 1),
(2107, 1),
(2108, 1),
(2109, 1),
(2110, 1),
(2111, 1),
(2112, 1),
(2113, 1),
(2114, 1),
(2115, 1),
(2116, 1),
(2117, 1),
(2118, 1),
(2119, 1),
(2120, 1),
(2121, 1),
(2122, 1),
(2123, 1),
(2124, 1),
(2125, 1),
(2126, 1),
(2127, 1),
(2128, 1),
(2129, 1),
(2130, 1),
(2131, 1),
(2132, 1),
(2133, 1),
(2134, 1),
(2135, 1),
(2136, 1),
(2137, 1),
(2138, 1),
(2139, 1),
(2140, 1),
(2141, 1),
(2142, 1),
(2143, 1),
(2144, 1),
(2145, 1),
(2146, 1),
(2147, 1),
(2148, 1),
(2149, 1),
(2150, 1),
(2151, 1),
(2152, 1),
(2153, 1),
(2154, 1),
(2155, 1),
(2156, 1),
(2157, 1),
(2158, 1),
(2159, 1),
(2160, 1),
(2161, 1),
(2162, 1),
(2163, 1),
(2164, 1),
(2165, 1),
(2166, 1),
(2167, 1),
(2168, 1),
(2169, 1),
(2170, 1),
(2171, 1),
(2172, 1),
(2173, 1),
(2174, 1),
(2175, 1),
(2176, 1),
(2177, 1),
(2178, 1),
(2179, 1),
(2180, 1),
(2181, 1),
(2182, 1),
(2183, 1),
(2184, 1),
(2185, 1),
(2186, 1),
(2187, 1),
(2188, 1),
(2189, 1),
(2190, 1),
(2191, 1),
(2192, 1),
(2193, 1),
(2194, 1),
(2195, 1),
(2196, 1),
(2197, 1),
(2198, 1),
(2199, 1),
(2200, 1),
(2201, 1),
(2202, 1),
(2203, 1),
(2204, 1),
(2205, 1),
(2206, 1),
(2207, 1),
(2208, 1),
(2209, 1),
(2210, 1),
(2211, 1),
(2212, 1),
(2213, 1),
(2214, 1),
(2215, 1),
(2216, 1),
(2217, 1),
(2218, 1),
(2219, 1),
(2220, 1),
(2221, 1),
(2222, 1),
(2223, 1),
(2224, 1),
(2225, 1),
(2226, 1),
(2227, 1),
(2228, 1),
(2229, 1),
(2230, 1),
(2231, 1),
(2232, 1),
(2233, 1),
(2234, 1),
(2235, 1),
(2236, 1),
(2237, 1),
(2238, 1),
(2239, 1),
(2240, 1),
(2241, 1),
(2242, 1),
(2243, 1),
(2244, 1),
(2245, 1),
(2246, 1),
(2247, 1),
(2248, 1),
(2249, 1),
(2250, 1),
(2251, 1),
(2252, 1),
(2253, 1),
(2254, 1),
(2255, 1),
(2256, 1),
(2257, 1),
(2258, 1),
(2259, 1),
(2260, 1),
(2261, 1),
(2262, 1),
(2263, 1),
(2264, 1),
(2265, 1),
(2266, 1),
(2267, 1),
(2268, 1),
(2269, 1),
(2270, 1),
(2271, 1),
(2272, 1),
(2273, 1),
(2274, 1),
(2275, 1),
(2276, 1),
(2277, 1),
(2278, 1),
(2279, 1),
(2280, 1),
(2281, 1),
(2282, 1),
(2283, 1),
(2284, 1),
(2285, 1),
(2286, 1),
(2287, 1),
(2288, 1),
(2289, 1),
(2290, 1),
(2291, 1),
(2292, 1),
(2293, 1),
(2294, 1),
(2295, 1),
(2296, 1),
(2297, 1),
(2298, 1),
(2299, 1),
(2300, 1),
(2301, 1),
(2302, 1),
(2303, 1),
(2304, 1),
(2305, 1),
(2306, 1),
(2307, 1),
(2308, 1),
(2309, 1),
(2310, 1),
(2311, 1),
(2312, 1),
(2313, 1),
(2314, 1),
(2315, 1);         
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(2316, 1),
(2317, 1),
(2318, 1),
(2319, 1),
(2320, 1),
(2321, 1),
(2322, 1),
(2323, 1),
(2324, 1),
(2325, 1),
(2326, 1),
(2327, 1),
(2328, 1),
(2329, 1),
(2330, 1),
(2331, 1),
(2332, 1),
(2333, 1),
(2334, 1),
(2335, 1),
(2336, 1),
(2337, 1),
(2338, 1),
(2339, 1),
(2340, 1),
(2341, 1),
(2342, 1),
(2343, 1),
(2344, 1),
(2345, 1),
(2346, 1),
(2347, 1),
(2348, 1),
(2349, 1),
(2350, 1),
(2351, 1),
(2352, 1),
(2353, 1),
(2354, 1),
(2355, 1),
(2356, 1),
(2357, 1),
(2358, 1),
(2359, 1),
(2360, 1),
(2361, 1),
(2362, 1),
(2363, 1),
(2364, 1),
(2365, 1),
(2366, 1),
(2367, 1),
(2368, 1),
(2369, 1),
(2370, 1),
(2371, 1),
(2372, 1),
(2373, 1),
(2374, 1),
(2375, 1),
(2376, 1),
(2377, 1),
(2378, 1),
(2379, 1),
(2380, 1),
(2381, 1),
(2382, 1),
(2383, 1),
(2384, 1),
(2385, 1),
(2386, 1),
(2387, 1),
(2388, 1),
(2389, 1),
(2390, 1),
(2391, 1),
(2392, 1),
(2393, 1),
(2394, 1),
(2395, 1),
(2396, 1),
(2397, 1),
(2398, 1),
(2399, 1),
(2400, 1),
(2401, 1),
(2402, 1),
(2403, 1),
(2404, 1),
(2405, 1),
(2406, 1),
(2407, 1),
(2408, 1),
(2409, 1),
(2410, 1),
(2411, 1),
(2412, 1),
(2413, 1),
(2414, 1),
(2415, 1),
(2416, 1),
(2417, 1),
(2418, 1),
(2419, 1),
(2420, 1),
(2421, 1),
(2422, 1),
(2423, 1),
(2424, 1),
(2425, 1),
(2426, 1),
(2427, 1),
(2428, 1),
(2429, 1),
(2430, 1),
(2431, 1),
(2432, 1),
(2433, 1),
(2434, 1),
(2435, 1),
(2436, 1),
(2437, 1),
(2438, 1),
(2439, 1),
(2440, 1),
(2441, 1),
(2442, 1),
(2443, 1),
(2444, 1),
(2445, 1),
(2446, 1),
(2447, 1),
(2448, 1),
(2449, 1),
(2450, 1),
(2451, 1),
(2452, 1),
(2453, 1),
(2454, 1),
(2455, 1),
(2456, 1),
(2457, 1),
(2458, 1),
(2459, 1),
(2460, 1),
(2461, 1),
(2462, 1),
(2463, 1),
(2464, 1),
(2465, 1),
(2466, 1),
(2467, 1),
(2468, 1),
(2469, 1),
(2470, 1),
(2471, 1),
(2472, 1),
(2473, 1),
(2474, 1),
(2475, 1),
(2476, 1),
(2477, 1),
(2478, 1),
(2479, 1),
(2480, 1),
(2481, 1),
(2482, 1),
(2483, 1),
(2484, 1),
(2485, 1),
(2486, 1),
(2487, 1),
(2488, 1),
(2489, 1),
(2490, 1),
(2491, 1),
(2492, 1),
(2493, 1),
(2494, 1),
(2495, 1),
(2496, 1),
(2497, 1),
(2498, 1),
(2499, 1),
(2500, 1),
(2501, 1),
(2502, 1),
(2503, 1),
(2504, 1),
(2505, 1),
(2506, 1),
(2507, 1),
(2508, 1),
(2509, 1),
(2510, 1),
(2511, 1),
(2512, 1),
(2513, 1),
(2514, 1),
(2515, 1),
(2516, 1),
(2517, 1),
(2518, 1),
(2519, 1),
(2520, 1),
(2521, 1),
(2522, 1),
(2523, 1),
(2524, 1),
(2525, 1),
(2526, 1),
(2527, 1),
(2528, 1),
(2529, 1),
(2530, 1),
(2531, 1),
(2532, 1),
(2533, 1),
(2534, 1),
(2535, 1),
(2536, 1),
(2537, 1),
(2538, 1),
(2539, 1),
(2540, 1),
(2541, 1),
(2542, 1),
(2543, 1),
(2544, 1),
(2545, 1),
(2546, 1),
(2547, 1),
(2548, 1),
(2549, 1),
(2550, 1),
(2551, 1),
(2552, 1),
(2553, 1),
(2554, 1),
(2555, 1),
(2556, 1),
(2557, 1),
(2558, 1),
(2559, 1),
(2560, 1),
(2561, 1),
(2562, 1),
(2563, 1),
(2564, 1),
(2565, 1),
(2566, 1),
(2567, 1),
(2568, 1),
(2569, 1),
(2570, 1),
(2571, 1),
(2572, 1),
(2573, 1),
(2574, 1),
(2575, 1),
(2576, 1),
(2577, 1),
(2578, 1),
(2579, 1),
(2580, 1),
(2581, 1),
(2582, 1),
(2583, 1),
(2584, 1),
(2585, 1),
(2586, 1),
(2587, 1),
(2588, 1),
(2589, 1),
(2590, 1),
(2591, 1),
(2592, 1),
(2593, 1),
(2594, 1),
(2595, 1),
(2596, 1),
(2597, 1),
(2598, 1),
(2599, 1),
(2600, 1),
(2601, 1),
(2602, 1),
(2603, 1),
(2604, 1),
(2605, 1),
(2606, 1),
(2607, 1),
(2608, 1),
(2609, 1),
(2610, 1),
(2611, 1),
(2612, 1),
(2613, 1),
(2614, 1),
(2615, 1),
(2616, 1),
(2617, 1),
(2618, 1),
(2619, 1),
(2620, 1),
(2621, 1),
(2622, 1),
(2623, 1),
(2624, 1),
(2625, 1),
(2626, 1),
(2627, 1),
(2628, 1),
(2629, 1),
(2630, 1),
(2631, 1),
(2632, 1),
(2633, 1),
(2634, 1),
(2635, 1),
(2636, 1),
(2637, 1),
(2638, 1),
(2639, 1),
(2640, 1),
(2641, 1),
(2642, 1),
(2643, 1),
(2644, 1),
(2645, 1),
(2646, 1),
(2647, 1),
(2648, 1),
(2649, 1),
(2650, 1),
(2651, 1),
(2652, 1),
(2653, 1),
(2654, 1),
(2655, 1),
(2656, 1),
(2657, 1),
(2658, 1),
(2659, 1),
(2660, 1),
(2661, 1),
(2662, 1),
(2663, 1),
(2664, 1),
(2665, 1),
(2666, 1),
(2667, 1),
(2668, 1),
(2669, 1),
(2670, 1),
(2671, 1),
(2672, 1),
(2673, 1),
(2674, 1),
(2675, 1),
(2676, 1),
(2677, 1),
(2678, 1),
(2679, 1),
(2680, 1),
(2681, 1),
(2682, 1),
(2683, 1),
(2684, 1);         
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(2685, 1),
(2686, 1),
(2687, 1),
(2688, 1),
(2689, 1),
(2690, 1),
(2691, 1),
(2692, 1),
(2693, 1),
(2694, 1),
(2695, 1),
(2696, 1),
(2697, 1),
(2698, 1),
(2699, 1),
(2700, 1),
(2701, 1),
(2702, 1),
(2703, 1),
(2704, 1),
(2705, 1),
(2706, 1),
(2707, 1),
(2708, 1),
(2709, 1),
(2710, 1),
(2711, 1),
(2712, 1),
(2713, 1),
(2714, 1),
(2715, 1),
(2716, 1),
(2717, 1),
(2718, 1),
(2719, 1),
(2720, 1),
(2721, 1),
(2722, 1),
(2723, 1),
(2724, 1),
(2725, 1),
(2726, 1),
(2727, 1),
(2728, 1),
(2729, 1),
(2730, 1),
(2731, 1),
(2732, 1),
(2733, 1),
(2734, 1),
(2735, 1),
(2736, 1),
(2737, 1),
(2738, 1),
(2739, 1),
(2740, 1),
(2741, 1),
(2742, 1),
(2743, 1),
(2744, 1),
(2745, 1),
(2746, 1),
(2747, 1),
(2748, 1),
(2749, 1),
(2750, 1),
(2751, 1),
(2752, 1),
(2753, 1),
(2754, 1),
(2755, 1),
(2756, 1),
(2757, 1),
(2758, 1),
(2759, 1),
(2760, 1),
(2761, 1),
(2762, 1),
(2763, 1),
(2764, 1),
(2765, 1),
(2766, 1),
(2767, 1),
(2768, 1),
(2769, 1),
(2770, 1),
(2771, 1),
(2772, 1),
(2773, 1),
(2774, 1),
(2775, 1),
(2776, 1),
(2777, 1),
(2778, 1),
(2779, 1),
(2780, 1),
(2781, 1),
(2782, 1),
(2783, 1),
(2784, 1),
(2785, 1),
(2786, 1),
(2787, 1),
(2788, 1),
(2789, 1),
(2790, 1),
(2791, 1),
(2792, 1),
(2793, 1),
(2794, 1),
(2795, 1),
(2796, 1),
(2797, 1),
(2798, 1),
(2799, 1),
(2800, 1),
(2801, 1),
(2802, 1),
(2803, 1),
(2804, 1),
(2805, 1),
(2806, 1),
(2807, 1),
(2808, 1),
(2809, 1),
(2810, 1),
(2811, 1),
(2812, 1),
(2813, 1),
(2814, 1),
(2815, 1),
(2816, 1),
(2817, 1),
(2818, 1),
(2819, 1),
(2820, 1),
(2821, 1),
(2822, 1),
(2823, 1),
(2824, 1),
(2825, 1),
(2826, 1),
(2827, 1),
(2828, 1),
(2829, 1),
(2830, 1),
(2831, 1),
(2832, 1),
(2833, 1),
(2834, 1),
(2835, 1),
(2836, 1),
(2837, 1),
(2838, 1),
(2839, 1),
(2840, 1),
(2841, 1),
(2842, 1),
(2843, 1),
(2844, 1),
(2845, 1),
(2846, 1),
(2847, 1),
(2848, 1),
(2849, 1),
(2850, 1),
(2851, 1),
(2852, 1),
(2853, 1),
(2854, 1),
(2855, 1),
(2856, 1),
(2857, 1),
(2858, 1),
(2859, 1),
(2860, 1),
(2861, 1),
(2862, 1),
(2863, 1),
(2864, 1),
(2865, 1),
(2866, 1),
(2867, 1),
(2868, 1),
(2869, 1),
(2870, 1),
(2871, 1),
(2872, 1),
(2873, 1),
(2874, 1),
(2875, 1),
(2876, 1),
(2877, 1),
(2878, 1),
(2879, 1),
(2880, 1),
(2881, 1),
(2882, 1),
(2883, 1),
(2884, 1),
(2885, 1),
(2886, 1),
(2887, 1),
(2888, 1),
(2889, 1),
(2890, 1),
(2891, 1),
(2892, 1),
(2893, 1),
(2894, 1),
(2895, 1),
(2896, 1),
(2897, 1),
(2898, 1),
(2899, 1),
(2900, 1),
(2901, 1),
(2902, 1),
(2903, 1),
(2904, 1),
(2905, 1),
(2906, 1),
(2907, 1),
(2908, 1),
(2909, 1),
(2910, 1),
(2911, 1),
(2912, 1),
(2913, 1),
(2914, 1),
(2915, 1),
(2916, 1),
(2917, 1),
(2918, 1),
(2919, 1),
(2920, 1),
(2921, 1),
(2922, 1),
(2923, 1),
(2924, 1),
(2925, 1),
(2926, 1),
(2927, 1),
(2928, 1),
(2929, 1),
(2930, 1),
(2931, 1),
(2932, 1),
(2933, 1),
(2934, 1),
(2935, 1),
(2936, 1),
(2937, 1),
(2938, 1),
(2939, 1),
(2940, 1),
(2941, 1),
(2942, 1),
(2943, 1),
(2944, 1),
(2945, 1),
(2946, 1),
(2947, 1),
(2948, 1),
(2949, 1),
(2950, 1),
(2951, 1),
(2952, 1),
(2953, 1),
(2954, 1),
(2955, 1),
(2956, 1),
(2957, 1),
(2958, 1),
(2959, 1),
(2960, 1),
(2961, 1),
(2962, 1),
(2963, 1),
(2964, 1),
(2965, 1),
(2966, 1),
(2967, 1),
(2968, 1),
(2969, 1),
(2970, 1),
(2971, 1),
(2972, 1),
(2973, 1),
(2974, 1),
(2975, 1),
(2976, 1),
(2977, 1),
(2978, 1),
(2979, 1),
(2980, 1),
(2981, 1),
(2982, 1),
(2983, 1),
(2984, 1),
(2985, 1),
(2986, 1),
(2987, 1),
(2988, 1),
(2989, 1),
(2990, 1),
(2991, 1),
(2992, 1),
(2993, 1),
(2994, 1),
(2995, 1),
(2996, 1),
(2997, 1),
(2998, 1),
(2999, 1),
(3000, 1),
(3001, 1),
(3002, 1),
(3003, 1),
(3004, 1),
(3005, 1),
(3006, 1),
(3007, 1),
(3008, 1),
(3009, 1),
(3010, 1),
(3011, 1),
(3012, 1),
(3013, 1),
(3014, 1),
(3015, 1),
(3016, 1),
(3017, 1),
(3018, 1),
(3019, 1),
(3020, 1),
(3021, 1),
(3022, 1),
(3023, 1),
(3024, 1),
(3025, 1),
(3026, 1),
(3027, 1),
(3028, 1),
(3029, 1),
(3030, 1),
(3031, 1),
(3032, 1),
(3033, 1),
(3034, 1),
(3035, 1),
(3036, 1),
(3037, 1),
(3038, 1),
(3039, 1),
(3040, 1),
(3041, 1),
(3042, 1),
(3043, 1),
(3044, 1),
(3045, 1),
(3046, 1),
(3047, 1),
(3048, 1),
(3049, 1),
(3050, 1),
(3051, 1),
(3052, 1),
(3053, 1);         
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(3054, 1),
(3055, 1),
(3056, 1),
(3057, 1),
(3058, 1),
(3059, 1),
(3060, 1),
(3061, 1),
(3062, 1),
(3063, 1),
(3064, 1),
(3065, 1),
(3066, 1),
(3067, 1),
(3068, 1),
(3069, 1),
(3070, 1),
(3071, 1),
(3072, 1),
(3073, 1),
(3074, 1),
(3075, 1),
(3076, 1),
(3077, 1),
(3078, 1),
(3079, 1),
(3080, 1),
(3081, 1),
(3082, 1),
(3083, 1),
(3084, 1),
(3085, 1),
(3086, 1),
(3087, 1),
(3088, 1),
(3089, 1),
(3090, 1),
(3091, 1),
(3092, 1),
(3093, 1),
(3094, 1),
(3095, 1),
(3096, 1),
(3097, 1),
(3098, 1),
(3099, 1),
(3100, 1),
(3101, 1),
(3102, 1),
(3103, 1),
(3104, 1),
(3105, 1),
(3106, 1),
(3107, 1),
(3108, 1),
(3109, 1),
(3110, 1),
(3111, 1),
(3112, 1),
(3113, 1),
(3114, 1),
(3115, 1),
(3116, 1),
(3117, 1),
(3118, 1),
(3119, 1),
(3120, 1),
(3121, 1),
(3122, 1),
(3123, 1),
(3124, 1),
(3125, 1),
(3126, 1),
(3127, 1),
(3128, 1),
(3129, 1),
(3130, 1),
(3131, 1),
(3132, 1),
(3133, 1),
(3134, 1),
(3135, 1),
(3136, 1),
(3137, 1),
(3138, 1),
(3139, 1),
(3140, 1),
(3141, 1),
(3142, 1),
(3143, 1),
(3144, 1),
(3145, 1),
(3146, 1),
(3147, 1),
(3148, 1),
(3149, 1),
(3150, 1),
(3151, 1),
(3152, 1),
(3153, 1),
(3154, 1),
(3155, 1),
(3156, 1),
(3157, 1),
(3158, 1),
(3159, 1),
(3160, 1),
(3161, 1),
(3162, 1),
(3163, 1),
(3164, 1),
(3165, 1),
(3166, 1),
(3167, 1),
(3168, 1),
(3169, 1),
(3170, 1),
(3171, 1),
(3172, 1),
(3173, 1),
(3174, 1),
(3175, 1),
(3176, 1),
(3177, 1),
(3178, 1),
(3179, 1),
(3180, 1),
(3181, 1),
(3182, 1),
(3183, 1),
(3184, 1),
(3185, 1),
(3186, 1),
(3187, 1),
(3188, 1),
(3189, 1),
(3190, 1),
(3191, 1),
(3192, 1),
(3193, 1),
(3194, 1),
(3195, 1),
(3196, 1),
(3197, 1),
(3198, 1),
(3199, 1),
(3200, 1),
(3201, 1),
(3202, 1),
(3203, 1),
(3204, 1),
(3205, 1),
(3206, 1),
(3207, 1),
(3208, 1),
(3209, 1),
(3210, 1),
(3211, 1),
(3212, 1),
(3213, 1),
(3214, 1),
(3215, 1),
(3216, 1),
(3217, 1),
(3218, 1),
(3219, 1),
(3220, 1),
(3221, 1),
(3222, 1),
(3223, 1),
(3224, 1),
(3225, 1),
(3226, 1),
(3227, 1),
(3228, 1),
(3229, 1),
(3230, 1),
(3231, 1),
(3232, 1),
(3233, 1),
(3234, 1),
(3235, 1),
(3236, 1),
(3237, 1),
(3238, 1),
(3239, 1),
(3240, 1),
(3241, 1),
(3242, 1),
(3243, 1),
(3244, 1),
(3245, 1),
(3246, 1),
(3247, 1),
(3248, 1),
(3249, 1),
(3250, 1),
(3251, 1),
(3252, 1),
(3253, 1),
(3254, 1),
(3255, 1),
(3256, 1),
(3257, 1),
(3258, 1),
(3259, 1),
(3260, 1),
(3261, 1),
(3262, 1),
(3263, 1),
(3264, 1),
(3265, 1),
(3266, 1),
(3267, 1),
(3268, 1),
(3269, 1),
(3270, 1),
(3271, 1),
(3272, 1),
(3273, 1),
(3274, 1),
(3275, 1),
(3276, 1),
(3277, 1),
(3278, 1),
(3279, 1),
(3280, 1),
(3281, 1),
(3282, 1),
(3283, 1),
(3284, 1),
(3285, 1),
(3286, 1),
(3287, 1),
(3288, 1),
(3289, 1),
(3290, 1),
(3291, 1),
(3292, 1),
(3293, 1),
(3294, 1),
(3295, 1),
(3296, 1),
(3297, 1),
(3298, 1),
(3299, 1),
(3300, 1),
(3301, 1),
(3302, 1),
(3303, 1),
(3304, 1),
(3305, 1),
(3306, 1),
(3307, 1),
(3308, 1),
(3309, 1),
(3310, 1),
(3311, 1),
(3312, 1),
(3313, 1),
(3314, 1),
(3315, 1),
(3316, 1),
(3317, 1),
(3318, 1),
(3319, 1),
(3320, 1),
(3321, 1),
(3322, 1),
(3323, 1),
(3324, 1),
(3325, 1),
(3326, 1),
(3327, 1),
(3328, 1),
(3329, 1),
(3330, 1),
(3331, 1),
(3332, 1),
(3333, 1),
(3334, 1),
(3335, 1),
(3336, 1),
(3337, 1),
(3338, 1),
(3339, 1),
(3340, 1),
(3341, 1),
(3342, 1),
(3343, 1),
(3344, 1),
(3345, 1),
(3346, 1),
(3347, 1),
(3348, 1),
(3349, 1),
(3350, 1),
(3351, 1),
(3352, 1),
(3353, 1),
(3354, 1),
(3355, 1),
(3356, 1),
(3357, 1),
(3358, 1),
(3359, 1),
(3360, 1),
(3361, 1),
(3362, 1),
(3363, 1),
(3364, 1),
(3365, 1),
(3366, 1),
(3367, 1),
(3368, 1),
(3369, 1),
(3370, 1),
(3371, 1),
(3372, 1),
(3373, 1),
(3374, 1),
(3375, 1),
(3376, 1),
(3377, 1),
(3378, 1),
(3379, 1),
(3380, 1),
(3381, 1),
(3382, 1),
(3383, 1),
(3384, 1),
(3385, 1),
(3386, 1),
(3387, 1),
(3388, 1),
(3389, 1),
(3390, 1),
(3391, 1),
(3392, 1),
(3393, 1),
(3394, 1),
(3395, 1),
(3396, 1),
(3397, 1),
(3398, 1),
(3399, 1),
(3400, 1),
(3401, 1),
(3402, 1),
(3403, 1),
(3404, 1),
(3405, 1),
(3406, 1),
(3407, 1),
(3408, 1),
(3409, 1),
(3410, 1),
(3411, 1),
(3412, 1),
(3413, 1),
(3414, 1),
(3415, 1),
(3416, 1),
(3417, 1),
(3418, 1),
(3419, 1),
(3420, 1),
(3421, 1),
(3422, 1);         
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(3423, 1),
(3424, 1),
(3425, 1),
(3426, 1),
(3427, 1),
(3428, 1),
(3429, 1),
(3430, 1),
(3431, 1),
(3432, 1),
(3433, 1),
(3434, 1),
(3435, 1),
(3436, 1),
(3437, 1),
(3438, 1),
(3439, 1),
(3440, 1),
(3441, 1),
(3442, 1),
(3443, 1),
(3444, 1),
(3445, 1),
(3446, 1),
(3447, 1),
(3448, 1),
(3449, 1),
(3450, 1),
(3451, 1),
(3452, 1),
(3453, 1),
(3454, 1),
(3455, 1),
(3456, 1),
(3457, 1),
(3458, 1),
(3459, 1),
(3460, 1),
(3461, 1),
(3462, 1),
(3463, 1),
(3464, 1),
(3465, 1),
(3466, 1),
(3467, 1),
(3468, 1),
(3469, 1),
(3470, 1),
(3471, 1),
(3472, 1),
(3473, 1),
(3474, 1),
(3475, 1),
(3476, 1),
(3477, 1),
(3478, 1),
(3479, 1),
(3480, 1),
(3481, 1),
(3482, 1),
(3483, 1),
(3484, 1),
(3485, 1),
(3486, 1),
(3487, 1),
(3488, 1),
(3489, 1),
(3490, 1),
(3491, 1),
(3492, 1),
(3493, 1),
(3494, 1),
(3495, 1),
(3496, 1),
(3497, 1),
(3498, 1),
(3499, 1),
(3500, 1),
(3501, 1),
(3502, 1),
(3503, 1),
(3504, 1),
(3505, 1),
(3506, 1),
(3507, 1),
(3508, 1),
(3509, 1),
(3510, 1),
(3511, 1),
(3512, 1),
(3513, 1),
(3514, 1),
(3515, 1),
(3516, 1),
(3517, 1),
(3518, 1),
(3519, 1),
(3520, 1),
(3521, 1),
(3522, 1),
(3523, 1),
(3524, 1),
(3525, 1),
(3526, 1),
(3527, 1),
(3528, 1),
(3529, 1),
(3530, 1),
(3531, 1),
(3532, 1),
(3533, 1),
(3534, 1),
(3535, 1),
(3536, 1),
(3537, 1),
(3538, 1),
(3539, 1),
(3540, 1),
(3541, 1),
(3542, 1),
(3543, 1),
(3544, 1),
(3545, 1),
(3546, 1),
(3547, 1),
(3548, 1),
(3549, 1),
(3550, 1),
(3551, 1),
(3552, 1),
(3553, 1),
(3554, 1),
(3555, 1),
(3556, 1),
(3557, 1),
(3558, 1),
(3559, 1),
(3560, 1),
(3561, 1),
(3562, 1),
(3563, 1),
(3564, 1),
(3565, 1),
(3566, 1),
(3567, 1),
(3568, 1),
(3569, 1),
(3570, 1),
(3571, 1),
(3572, 1),
(3573, 1),
(3574, 1),
(3575, 1),
(3576, 1),
(3577, 1),
(3578, 1),
(3579, 1),
(3580, 1),
(3581, 1),
(3582, 1),
(3583, 1),
(3584, 1),
(3585, 1),
(3586, 1),
(3587, 1),
(3588, 1),
(3589, 1),
(3590, 1),
(3591, 1),
(3592, 1),
(3593, 1),
(3594, 1),
(3595, 1),
(3596, 1),
(3597, 1),
(3598, 1),
(3599, 1),
(3600, 1),
(3601, 1),
(3602, 1),
(3603, 1),
(3604, 1),
(3605, 1),
(3606, 1),
(3607, 1),
(3608, 1),
(3609, 1),
(3610, 1),
(3611, 1),
(3612, 1),
(3613, 1),
(3614, 1),
(3615, 1),
(3616, 1),
(3617, 1),
(3618, 1),
(3619, 1),
(3620, 1),
(3621, 1),
(3622, 1),
(3623, 1),
(3624, 1),
(3625, 1),
(3626, 1),
(3627, 1),
(3628, 1),
(3629, 1),
(3630, 1),
(3631, 1),
(3632, 1),
(3633, 1),
(3634, 1),
(3635, 1),
(3636, 1),
(3637, 1),
(3638, 1),
(3639, 1),
(3640, 1),
(3641, 1),
(3642, 1),
(3643, 1),
(3644, 1),
(3645, 1),
(3646, 1),
(3647, 1),
(3648, 1),
(3649, 1),
(3650, 1),
(3651, 1),
(3652, 1),
(3653, 1),
(3654, 1),
(3655, 1),
(3656, 1),
(3657, 1),
(3658, 1),
(3659, 1),
(3660, 1),
(3661, 1),
(3662, 1),
(3663, 1),
(3664, 1),
(3665, 1),
(3666, 1),
(3667, 1),
(3668, 1),
(3669, 1),
(3670, 1),
(3671, 1),
(3672, 1),
(3673, 1),
(3674, 1),
(3675, 1),
(3676, 1),
(3677, 1),
(3678, 1),
(3679, 1),
(3680, 1),
(3681, 1),
(3682, 1),
(3683, 1),
(3684, 1),
(3685, 1),
(3686, 1),
(3687, 1),
(3688, 1),
(3689, 1),
(3690, 1),
(3691, 1),
(3692, 1),
(3693, 1),
(3694, 1),
(3695, 1),
(3696, 1),
(3697, 1),
(3698, 1),
(3699, 1),
(3700, 1),
(3701, 1),
(3702, 1),
(3703, 1),
(3704, 1),
(3705, 1),
(3706, 1),
(3707, 1),
(3708, 1),
(3709, 1),
(3710, 1),
(3711, 1),
(3712, 1),
(3713, 1),
(3714, 1),
(3715, 1),
(3716, 1),
(3717, 1),
(3718, 1),
(3719, 1),
(3720, 1),
(3721, 1),
(3722, 1),
(3723, 1),
(3724, 1),
(3725, 1),
(3726, 1),
(3727, 1),
(3728, 1),
(3729, 1),
(3730, 1),
(3731, 1),
(3732, 1),
(3733, 1),
(3734, 1),
(3735, 1),
(3736, 1),
(3737, 1),
(3738, 1),
(3739, 1),
(3740, 1),
(3741, 1),
(3742, 1),
(3743, 1),
(3744, 1),
(3745, 1),
(3746, 1),
(3747, 1),
(3748, 1),
(3749, 1),
(3750, 1),
(3751, 1),
(3752, 1),
(3753, 1),
(3754, 1),
(3755, 1),
(3756, 1),
(3757, 1),
(3758, 1),
(3759, 1),
(3760, 1),
(3761, 1),
(3762, 1),
(3763, 1),
(3764, 1),
(3765, 1),
(3766, 1),
(3767, 1),
(3768, 1),
(3769, 1),
(3770, 1),
(3771, 1),
(3772, 1),
(3773, 1),
(3774, 1),
(3775, 1),
(3776, 1),
(3777, 1),
(3778, 1),
(3779, 1),
(3780, 1),
(3781, 1),
(3782, 1),
(3783, 1),
(3784, 1),
(3785, 1),
(3786, 1),
(3787, 1),
(3788, 1),
(3789, 1),
(3790, 1),
(3791, 1);         
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(3792, 1),
(3793, 1),
(3794, 1),
(3795, 1),
(3796, 1),
(3797, 1),
(3798, 1),
(3799, 1),
(3800, 1),
(3801, 1),
(3802, 1),
(3803, 1),
(3804, 1),
(3805, 1),
(3806, 1),
(3807, 1),
(3808, 1),
(3809, 1),
(3810, 1),
(3811, 1),
(3812, 1),
(3813, 1),
(3814, 1),
(3815, 1),
(3816, 1),
(3817, 1),
(3818, 1),
(3819, 1),
(3820, 1),
(3821, 1),
(3822, 1),
(3823, 1),
(3824, 1),
(3825, 1),
(3826, 1),
(3827, 1),
(3828, 1),
(3829, 1),
(3830, 1),
(3831, 1),
(3832, 1),
(3833, 1),
(3834, 1),
(3835, 1),
(3836, 1),
(3837, 1),
(3838, 1),
(3839, 1),
(3840, 1),
(3841, 1),
(3842, 1),
(3843, 1),
(3844, 1),
(3845, 1),
(3846, 1),
(3847, 1),
(3848, 1),
(3849, 1),
(3850, 1),
(3851, 1),
(3852, 1),
(3853, 1),
(3854, 1),
(3855, 1),
(3856, 1),
(3857, 1),
(3858, 1),
(3859, 1),
(3860, 1),
(3861, 1),
(3862, 1),
(3863, 1),
(3864, 1),
(3865, 1),
(3866, 1),
(3867, 1),
(3868, 1),
(3869, 1),
(3870, 1),
(3871, 1),
(3872, 1),
(3873, 1),
(3874, 1),
(3875, 1),
(3876, 1),
(3877, 1),
(3878, 1),
(3879, 1),
(3880, 1),
(3881, 1),
(3882, 1),
(3883, 1),
(3884, 1),
(3885, 1),
(3886, 1),
(3887, 1),
(3888, 1),
(3889, 1),
(3890, 1),
(3891, 1),
(3892, 1),
(3893, 1),
(3894, 1),
(3895, 1),
(3896, 1),
(3897, 1),
(3898, 1),
(3899, 1),
(3900, 1),
(3901, 1),
(3902, 1),
(3903, 1),
(3904, 1),
(3905, 1),
(3906, 1),
(3907, 1),
(3908, 1),
(3909, 1),
(3910, 1),
(3911, 1),
(3912, 1),
(3913, 1),
(3914, 1),
(3915, 1),
(3916, 1),
(3917, 1),
(3918, 1),
(3919, 1),
(3920, 1),
(3921, 1),
(3922, 1),
(3923, 1),
(3924, 1),
(3925, 1),
(3926, 1),
(3927, 1),
(3928, 1),
(3929, 1),
(3930, 1),
(3931, 1),
(3932, 1),
(3933, 1),
(3934, 1),
(3935, 1),
(3936, 1),
(3937, 1),
(3938, 1),
(3939, 1),
(3940, 1),
(3941, 1),
(3942, 1),
(3943, 1),
(3944, 1),
(3945, 1),
(3946, 1),
(3947, 1),
(3948, 1),
(3949, 1),
(3950, 1),
(3951, 1),
(3952, 1),
(3953, 1),
(3954, 1),
(3955, 1),
(3956, 1),
(3957, 1),
(3958, 1),
(3959, 1),
(3960, 1),
(3961, 1),
(3962, 1),
(3963, 1),
(3964, 1),
(3965, 1),
(3966, 1),
(3967, 1),
(3968, 1),
(3969, 1),
(3970, 1),
(3971, 1),
(3972, 1),
(3973, 1),
(3974, 1),
(3975, 1),
(3976, 1),
(3977, 1),
(3978, 1),
(3979, 1),
(3980, 1),
(3981, 1),
(3982, 1),
(3983, 1),
(3984, 1),
(3985, 1),
(3986, 1),
(3987, 1),
(3988, 1),
(3989, 1),
(3990, 1),
(3991, 1),
(3992, 1),
(3993, 1),
(3994, 1),
(3995, 1),
(3996, 1),
(3997, 1),
(3998, 1),
(3999, 1),
(4000, 1),
(4001, 1),
(4002, 1),
(4003, 1),
(4004, 1),
(4005, 1),
(4006, 1),
(4007, 1),
(4008, 1),
(4009, 1),
(4010, 1),
(4011, 1),
(4012, 1),
(4013, 1),
(4014, 1),
(4015, 1),
(4016, 1),
(4017, 1),
(4018, 1),
(4019, 1),
(4020, 1),
(4021, 1),
(4022, 1),
(4023, 1),
(4024, 1),
(4025, 1),
(4026, 1),
(4027, 1),
(4028, 1),
(4029, 1),
(4030, 1),
(4031, 1),
(4032, 1),
(4033, 1),
(4034, 1),
(4035, 1),
(4036, 1),
(4037, 1),
(4038, 1),
(4039, 1),
(4040, 1),
(4041, 1),
(4042, 1),
(4043, 1),
(4044, 1),
(4045, 1),
(4046, 1),
(4047, 1),
(4048, 1),
(4049, 1),
(4050, 1),
(4051, 1),
(4052, 1),
(4053, 1),
(4054, 1),
(4055, 1),
(4056, 1),
(4057, 1),
(4058, 1),
(4059, 1),
(4060, 1),
(4061, 1),
(4062, 1),
(4063, 1),
(4064, 1),
(4065, 1),
(4066, 1),
(4067, 1),
(4068, 1),
(4069, 1),
(4070, 1),
(4071, 1),
(4072, 1),
(4073, 1),
(4074, 1),
(4075, 1),
(4076, 1),
(4077, 1),
(4078, 1),
(4079, 1),
(4080, 1),
(4081, 1),
(4082, 1),
(4083, 1),
(4084, 1),
(4085, 1),
(4086, 1),
(4087, 1),
(4088, 1),
(4089, 1),
(4090, 1),
(4091, 1),
(4092, 1),
(4093, 1),
(4094, 1),
(4095, 1),
(4096, 1),
(4097, 1),
(4098, 1),
(4099, 1),
(4100, 1),
(4101, 1),
(4102, 1),
(4103, 1),
(4104, 1),
(4105, 1),
(4106, 1),
(4107, 1),
(4108, 1),
(4109, 1),
(4110, 1),
(4111, 1),
(4112, 1),
(4113, 1),
(4114, 1),
(4115, 1),
(4116, 1),
(4117, 1),
(4118, 1),
(4119, 1),
(4120, 1),
(4121, 1),
(4122, 1),
(4123, 1),
(4124, 1),
(4125, 1),
(4126, 1),
(4127, 1),
(4128, 1),
(4129, 1),
(4130, 1),
(4131, 1),
(4132, 1),
(4133, 1),
(4134, 1),
(4135, 1),
(4136, 1),
(4137, 1),
(4138, 1),
(4139, 1),
(4140, 1),
(4141, 1),
(4142, 1),
(4143, 1),
(4144, 1),
(4145, 1),
(4146, 1),
(4147, 1),
(4148, 1),
(4149, 1),
(4150, 1),
(4151, 1),
(4152, 1),
(4153, 1),
(4154, 1),
(4155, 1),
(4156, 1),
(4157, 1),
(4158, 1),
(4159, 1),
(4160, 1);         
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(4161, 1),
(4162, 1),
(4163, 1),
(4164, 1),
(4165, 1),
(4166, 1),
(4167, 1),
(4168, 1),
(4169, 1),
(4170, 1),
(4171, 1),
(4172, 1),
(4173, 1),
(4174, 1),
(4175, 1),
(4176, 1),
(4177, 1),
(4178, 1),
(4179, 1),
(4180, 1),
(4181, 1),
(4182, 1),
(4183, 1),
(4184, 1),
(4185, 1),
(4186, 1),
(4187, 1),
(4188, 1),
(4189, 1),
(4190, 1),
(4191, 1),
(4192, 1),
(4193, 1),
(4194, 1),
(4195, 1),
(4196, 1),
(4197, 1),
(4198, 1),
(4199, 1),
(4200, 1),
(4201, 1),
(4202, 1),
(4203, 1),
(4204, 1),
(4205, 1),
(4206, 1),
(4207, 1),
(4208, 1),
(4209, 1),
(4210, 1),
(4211, 1),
(4212, 1),
(4213, 1),
(4214, 1),
(4215, 1),
(4216, 1),
(4217, 1),
(4218, 1),
(4219, 1),
(4220, 1),
(4221, 1),
(4222, 1),
(4223, 1),
(4224, 1),
(4225, 1),
(4226, 1),
(4227, 1),
(4228, 1),
(4229, 1),
(4230, 1),
(4231, 1),
(4232, 1),
(4233, 1),
(4234, 1),
(4235, 1),
(4236, 1),
(4237, 1),
(4238, 1),
(4239, 1),
(4240, 1),
(4241, 1),
(4242, 1),
(4243, 1),
(4244, 1),
(4245, 1),
(4246, 1),
(4247, 1),
(4248, 1),
(4249, 1),
(4250, 1),
(4251, 1),
(4252, 1),
(4253, 1),
(4254, 1),
(4255, 1),
(4256, 1),
(4257, 1),
(4258, 1),
(4259, 1),
(4260, 1),
(4261, 1),
(4262, 1),
(4263, 1),
(4264, 1),
(4265, 1),
(4266, 1),
(4267, 1),
(4268, 1),
(4269, 1),
(4270, 1),
(4271, 1),
(4272, 1),
(4273, 1),
(4274, 1),
(4275, 1),
(4276, 1),
(4277, 1),
(4278, 1),
(4279, 1),
(4280, 1),
(4281, 1),
(4282, 1),
(4283, 1),
(4284, 1),
(4285, 1),
(4286, 1),
(4287, 1),
(4288, 1),
(4289, 1),
(4290, 1),
(4291, 1),
(4292, 1),
(4293, 1),
(4294, 1),
(4295, 1),
(4296, 1),
(4297, 1),
(4298, 1),
(4299, 1),
(4300, 1),
(4301, 1),
(4302, 1),
(4303, 1),
(4304, 1),
(4305, 1),
(4306, 1),
(4307, 1),
(4308, 1),
(4309, 1),
(4310, 1),
(4311, 1),
(4312, 1),
(4313, 1),
(4314, 1),
(4315, 1),
(4316, 1),
(4317, 1),
(4318, 1),
(4319, 1),
(4320, 1),
(4321, 1),
(4322, 1),
(4323, 1),
(4324, 1),
(4325, 1),
(4326, 1),
(4327, 1),
(4328, 1),
(4329, 1),
(4330, 1),
(4331, 1),
(4332, 1),
(4333, 1),
(4334, 1),
(4335, 1),
(4336, 1),
(4337, 1),
(4338, 1),
(4339, 1),
(4340, 1),
(4341, 1),
(4342, 1),
(4343, 1),
(4344, 1),
(4345, 1),
(4346, 1),
(4347, 1),
(4348, 1),
(4349, 1),
(4350, 1),
(4351, 1),
(4352, 1),
(4353, 1),
(4354, 1),
(4355, 1),
(4356, 1),
(4357, 1),
(4358, 1),
(4359, 1),
(4360, 1),
(4361, 1),
(4362, 1),
(4363, 1),
(4364, 1),
(4365, 1),
(4366, 1),
(4367, 1),
(4368, 1),
(4369, 1),
(4370, 1),
(4371, 1),
(4372, 1),
(4373, 1),
(4374, 1),
(4375, 1),
(4376, 1),
(4377, 1),
(4378, 1),
(4379, 1),
(4380, 1),
(4381, 1),
(4382, 1),
(4383, 1),
(4384, 1),
(4385, 1),
(4386, 1),
(4387, 1),
(4388, 1),
(4389, 1),
(4390, 1),
(4391, 1),
(4392, 1),
(4393, 1),
(4394, 1),
(4395, 1),
(4396, 1),
(4397, 1),
(4398, 1),
(4399, 1),
(4400, 1),
(4401, 1),
(4402, 1),
(4403, 1),
(4404, 1),
(4405, 1),
(4406, 1),
(4407, 1),
(4408, 1),
(4409, 1),
(4410, 1),
(4411, 1),
(4412, 1),
(4413, 1),
(4414, 1),
(4415, 1),
(4416, 1),
(4417, 1),
(4418, 1),
(4419, 1),
(4420, 1),
(4421, 1),
(4422, 1),
(4423, 1),
(4424, 1),
(4425, 1),
(4426, 1),
(4427, 1),
(4428, 1),
(4429, 1),
(4430, 1),
(4431, 1),
(4432, 1),
(4433, 1),
(4434, 1),
(4435, 1),
(4436, 1),
(4437, 1),
(4438, 1),
(4439, 1),
(4440, 1),
(4441, 1),
(4442, 1),
(4443, 1),
(4444, 1),
(4445, 1),
(4446, 1),
(4447, 1),
(4448, 1),
(4449, 1),
(4450, 1),
(4451, 1),
(4452, 1),
(4453, 1),
(4454, 1),
(4455, 1),
(4456, 1),
(4457, 1),
(4458, 1),
(4459, 1),
(4460, 1),
(4461, 1),
(4462, 1),
(4463, 1),
(4464, 1),
(4465, 1),
(4466, 1),
(4467, 1),
(4468, 1),
(4469, 1),
(4470, 1),
(4471, 1),
(4472, 1),
(4473, 1),
(4474, 1),
(4475, 1),
(4476, 1),
(4477, 1),
(4478, 1),
(4479, 1),
(4480, 1),
(4481, 1),
(4482, 1),
(4483, 1),
(4484, 1),
(4485, 1),
(4486, 1),
(4487, 1),
(4488, 1),
(4489, 1),
(4490, 1),
(4491, 1),
(4492, 1),
(4493, 1),
(4494, 1),
(4495, 1),
(4496, 1),
(4497, 1),
(4498, 1),
(4499, 1),
(4500, 1),
(4501, 1),
(4502, 1),
(4503, 1),
(4504, 1),
(4505, 1),
(4506, 1),
(4507, 1),
(4508, 1),
(4509, 1),
(4510, 1),
(4511, 1),
(4512, 1),
(4513, 1),
(4514, 1),
(4515, 1),
(4516, 1),
(4517, 1),
(4518, 1),
(4519, 1),
(4520, 1),
(4521, 1),
(4522, 1),
(4523, 1),
(4524, 1),
(4525, 1),
(4526, 1),
(4527, 1),
(4528, 1),
(4529, 1);         
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(4530, 1),
(4531, 1),
(4532, 1),
(4533, 1),
(4534, 1),
(4535, 1),
(4536, 1),
(4537, 1),
(4538, 1),
(4539, 1),
(4540, 1),
(4541, 1),
(4542, 1),
(4543, 1),
(4544, 1),
(4545, 1),
(4546, 1),
(4547, 1),
(4548, 1),
(4549, 1),
(4550, 1),
(4551, 1),
(4552, 1),
(4553, 1),
(4554, 1),
(4555, 1),
(4556, 1),
(4557, 1),
(4558, 1),
(4559, 1),
(4560, 1),
(4561, 1),
(4562, 1),
(4563, 1),
(4564, 1),
(4565, 1),
(4566, 1),
(4567, 1),
(4568, 1),
(4569, 1),
(4570, 1),
(4571, 1),
(4572, 1),
(4573, 1),
(4574, 1),
(4575, 1),
(4576, 1),
(4577, 1),
(4578, 1),
(4579, 1),
(4580, 1),
(4581, 1),
(4582, 1),
(4583, 1),
(4584, 1),
(4585, 1),
(4586, 1),
(4587, 1),
(4588, 1),
(4589, 1),
(4590, 1),
(4591, 1),
(4592, 1),
(4593, 1),
(4594, 1),
(4595, 1),
(4596, 1),
(4597, 1),
(4598, 1),
(4599, 1),
(4600, 1),
(4601, 1),
(4602, 1),
(4603, 1),
(4604, 1),
(4605, 1),
(4606, 1),
(4607, 1),
(4608, 1),
(4609, 1),
(4610, 1),
(4611, 1),
(4612, 1),
(4613, 1),
(4614, 1),
(4615, 1),
(4616, 1),
(4617, 1),
(4618, 1),
(4619, 1),
(4620, 1),
(4621, 1),
(4622, 1),
(4623, 1),
(4624, 1),
(4625, 1),
(4626, 1),
(4627, 1),
(4628, 1),
(4629, 1),
(4630, 1),
(4631, 1),
(4632, 1),
(4633, 1),
(4634, 1),
(4635, 1),
(4636, 1),
(4637, 1),
(4638, 1),
(4639, 1),
(4640, 1),
(4641, 1),
(4642, 1),
(4643, 1),
(4644, 1),
(4645, 1),
(4646, 1),
(4647, 1),
(4648, 1),
(4649, 1),
(4650, 1),
(4651, 1),
(4652, 1),
(4653, 1),
(4654, 1),
(4655, 1),
(4656, 1),
(4657, 1),
(4658, 1),
(4659, 1),
(4660, 1),
(4661, 1),
(4662, 1),
(4663, 1),
(4664, 1),
(4665, 1),
(4666, 1),
(4667, 1),
(4668, 1),
(4669, 1),
(4670, 1),
(4671, 1),
(4672, 1),
(4673, 1),
(4674, 1),
(4675, 1),
(4676, 1),
(4677, 1),
(4678, 1),
(4679, 1),
(4680, 1),
(4681, 1),
(4682, 1),
(4683, 1),
(4684, 1),
(4685, 1),
(4686, 1),
(4687, 1),
(4688, 1),
(4689, 1),
(4690, 1),
(4691, 1),
(4692, 1),
(4693, 1),
(4694, 1),
(4695, 1),
(4696, 1),
(4697, 1),
(4698, 1),
(4699, 1),
(4700, 1),
(4701, 1),
(4702, 1),
(4703, 1),
(4704, 1),
(4705, 1),
(4706, 1),
(4707, 1),
(4708, 1),
(4709, 1),
(4710, 1),
(4711, 1),
(4712, 1),
(4713, 1),
(4714, 1),
(4715, 1),
(4716, 1),
(4717, 1),
(4718, 1),
(4719, 1),
(4720, 1),
(4721, 1),
(4722, 1),
(4723, 1),
(4724, 1),
(4725, 1),
(4726, 1),
(4727, 1),
(4728, 1),
(4729, 1),
(4730, 1),
(4731, 1),
(4732, 1),
(4733, 1),
(4734, 1),
(4735, 1),
(4736, 1),
(4737, 1),
(4738, 1),
(4739, 1),
(4740, 1),
(4741, 1),
(4742, 1),
(4743, 1),
(4744, 1),
(4745, 1),
(4746, 1),
(4747, 1),
(4748, 1),
(4749, 1),
(4750, 1),
(4751, 1),
(4752, 1),
(4753, 1),
(4754, 1),
(4755, 1),
(4756, 1),
(4757, 1),
(4758, 1),
(4759, 1),
(4760, 1),
(4761, 1),
(4762, 1),
(4763, 1),
(4764, 1),
(4765, 1),
(4766, 1),
(4767, 1),
(4768, 1),
(4769, 1),
(4770, 1),
(4771, 1),
(4772, 1),
(4773, 1),
(4774, 1),
(4775, 1),
(4776, 1),
(4777, 1),
(4778, 1),
(4779, 1),
(4780, 1),
(4781, 1),
(4782, 1),
(4783, 1),
(4784, 1),
(4785, 1),
(4786, 1),
(4787, 1),
(4788, 1),
(4789, 1),
(4790, 1),
(4791, 1),
(4792, 1),
(4793, 1),
(4794, 1),
(4795, 1),
(4796, 1),
(4797, 1),
(4798, 1),
(4799, 1),
(4800, 1),
(4801, 1),
(4802, 1),
(4803, 1),
(4804, 1),
(4805, 1),
(4806, 1),
(4807, 1),
(4808, 1),
(4809, 1),
(4810, 1),
(4811, 1),
(4812, 1),
(4813, 1),
(4814, 1),
(4815, 1),
(4816, 1),
(4817, 1),
(4818, 1),
(4819, 1),
(4820, 1),
(4821, 1),
(4822, 1),
(4823, 1),
(4824, 1),
(4825, 1),
(4826, 1),
(4827, 1),
(4828, 1),
(4829, 1),
(4830, 1),
(4831, 1),
(4832, 1),
(4833, 1),
(4834, 1),
(4835, 1),
(4836, 1),
(4837, 1),
(4838, 1),
(4839, 1),
(4840, 1),
(4841, 1),
(4842, 1),
(4843, 1),
(4844, 1),
(4845, 1),
(4846, 1),
(4847, 1),
(4848, 1),
(4849, 1),
(4850, 1),
(4851, 1),
(4852, 1),
(4853, 1),
(4854, 1),
(4855, 1),
(4856, 1),
(4857, 1),
(4858, 1),
(4859, 1),
(4860, 1),
(4861, 1),
(4862, 1),
(4863, 1),
(4864, 1),
(4865, 1),
(4866, 1),
(4867, 1),
(4868, 1),
(4869, 1),
(4870, 1),
(4871, 1),
(4872, 1),
(4873, 1),
(4874, 1),
(4875, 1),
(4876, 1),
(4877, 1),
(4878, 1),
(4879, 1),
(4880, 1),
(4881, 1),
(4882, 1),
(4883, 1),
(4884, 1),
(4885, 1),
(4886, 1),
(4887, 1),
(4888, 1),
(4889, 1),
(4890, 1),
(4891, 1),
(4892, 1),
(4893, 1),
(4894, 1),
(4895, 1),
(4896, 1),
(4897, 1),
(4898, 1);         
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(4899, 1),
(4900, 1),
(4901, 1),
(4902, 1),
(4903, 1),
(4904, 1),
(4905, 1),
(4906, 1),
(4907, 1),
(4908, 1),
(4909, 1),
(4910, 1),
(4911, 1),
(4912, 1),
(4913, 1),
(4914, 1),
(4915, 1),
(4916, 1),
(4917, 1),
(4918, 1),
(4919, 1),
(4920, 1),
(4921, 1),
(4922, 1),
(4923, 1),
(4924, 1),
(4925, 1),
(4926, 1),
(4927, 1),
(4928, 1),
(4929, 1),
(4930, 1),
(4931, 1),
(4932, 1),
(4933, 1),
(4934, 1),
(4935, 1),
(4936, 1),
(4937, 1),
(4938, 1),
(4939, 1),
(4940, 1),
(4941, 1),
(4942, 1),
(4943, 1),
(4944, 1),
(4945, 1),
(4946, 1),
(4947, 1),
(4948, 1),
(4949, 1),
(4950, 1),
(4951, 1),
(4952, 1),
(4953, 1),
(4954, 1),
(4955, 1),
(4956, 1),
(4957, 1),
(4958, 1),
(4959, 1),
(4960, 1),
(4961, 1),
(4962, 1),
(4963, 1),
(4964, 1),
(4965, 1),
(4966, 1),
(4967, 1),
(4968, 1),
(4969, 1),
(4970, 1),
(4971, 1),
(4972, 1),
(4973, 1),
(4974, 1),
(4975, 1),
(4976, 1),
(4977, 1),
(4978, 1),
(4979, 1),
(4980, 1),
(4981, 1),
(4982, 1),
(4983, 1),
(4984, 1),
(4985, 1),
(4986, 1),
(4987, 1),
(4988, 1),
(4989, 1),
(4990, 1),
(4991, 1),
(4992, 1),
(4993, 1),
(4994, 1),
(4995, 1),
(4996, 1),
(4997, 1),
(4998, 1),
(4999, 1),
(5000, 1),
(5001, 1),
(5002, 1),
(5003, 1),
(5004, 1),
(5005, 1),
(5006, 1),
(5007, 1),
(5008, 1),
(5009, 1),
(5010, 1),
(5011, 1),
(5012, 1),
(5013, 1),
(5014, 1),
(5015, 1),
(5016, 1),
(5017, 1),
(5018, 1),
(5019, 1),
(5020, 1),
(5021, 1),
(5022, 1),
(5023, 1),
(5024, 1),
(5025, 1),
(5026, 1),
(5027, 1),
(5028, 1),
(5029, 1),
(5030, 1),
(5031, 1),
(5032, 1),
(5033, 1),
(5034, 1),
(5035, 1),
(5036, 1),
(5037, 1),
(5038, 1),
(5039, 1),
(5040, 1),
(5041, 1),
(5042, 1),
(5043, 1),
(5044, 1),
(5045, 1),
(5046, 1),
(5047, 1),
(5048, 1),
(5049, 1),
(5050, 1),
(5051, 1),
(5052, 1),
(5053, 1),
(5054, 1),
(5055, 1),
(5056, 1),
(5057, 1),
(5058, 1),
(5059, 1),
(5060, 1),
(5061, 1),
(5062, 1),
(5063, 1),
(5064, 1),
(5065, 1),
(5066, 1),
(5067, 1),
(5068, 1),
(5069, 1),
(5070, 1),
(5071, 1),
(5072, 1),
(5073, 1),
(5074, 1),
(5075, 1),
(5076, 1),
(5077, 1),
(5078, 1),
(5079, 1),
(5080, 1),
(5081, 1),
(5082, 1),
(5083, 1),
(5084, 1),
(5085, 1),
(5086, 1),
(5087, 1),
(5088, 1),
(5089, 1),
(5090, 1),
(5091, 1),
(5092, 1),
(5093, 1),
(5094, 1),
(5095, 1),
(5096, 1),
(5097, 1),
(5098, 1),
(5099, 1),
(5100, 1),
(5101, 1),
(5102, 1),
(5103, 1),
(5104, 1),
(5105, 1),
(5106, 1),
(5107, 1),
(5108, 1),
(5109, 1),
(5110, 1),
(5111, 1),
(5112, 1),
(5113, 1),
(5114, 1),
(5115, 1),
(5116, 1),
(5117, 1),
(5118, 1),
(5119, 1),
(5120, 1),
(5121, 1),
(5122, 1),
(5123, 1),
(5124, 1),
(5125, 1),
(5126, 1),
(5127, 1),
(5128, 1),
(5129, 1),
(5130, 1),
(5131, 1),
(5132, 1),
(5133, 1),
(5134, 1),
(5135, 1),
(5136, 1),
(5137, 1),
(5138, 1),
(5139, 1),
(5140, 1),
(5141, 1),
(5142, 1),
(5143, 1),
(5144, 1),
(5145, 1),
(5146, 1),
(5147, 1),
(5148, 1),
(5149, 1),
(5150, 1),
(5151, 1),
(5152, 1),
(5153, 1),
(5154, 1),
(5155, 1),
(5156, 1),
(5157, 1),
(5158, 1),
(5159, 1),
(5160, 1),
(5161, 1),
(5162, 1),
(5163, 1),
(5164, 1),
(5165, 1),
(5166, 1),
(5167, 1),
(5168, 1),
(5169, 1),
(5170, 1),
(5171, 1),
(5172, 1),
(5173, 1),
(5174, 1),
(5175, 1),
(5176, 1),
(5177, 1),
(5178, 1),
(5179, 1),
(5180, 1),
(5181, 1),
(5182, 1),
(5183, 1),
(5184, 1),
(5185, 1),
(5186, 1),
(5187, 1),
(5188, 1),
(5189, 1),
(5190, 1),
(5191, 1),
(5192, 1),
(5193, 1),
(5194, 1),
(5195, 1),
(5196, 1),
(5197, 1),
(5198, 1),
(5199, 1),
(5200, 1),
(5201, 1),
(5202, 1),
(5203, 1),
(5204, 1),
(5205, 1),
(5206, 1),
(5207, 1),
(5208, 1),
(5209, 1),
(5210, 1),
(5211, 1),
(5212, 1),
(5213, 1),
(5214, 1),
(5215, 1),
(5216, 1),
(5217, 1),
(5218, 1),
(5219, 1),
(5220, 1),
(5221, 1),
(5222, 1),
(5223, 1),
(5224, 1),
(5225, 1),
(5226, 1),
(5227, 1),
(5228, 1),
(5229, 1),
(5230, 1),
(5231, 1),
(5232, 1),
(5233, 1),
(5234, 1),
(5235, 1),
(5236, 1),
(5237, 1),
(5238, 1),
(5239, 1),
(5240, 1),
(5241, 1),
(5242, 1),
(5243, 1),
(5244, 1),
(5245, 1),
(5246, 1),
(5247, 1),
(5248, 1),
(5249, 1),
(5250, 1),
(5251, 1),
(5252, 1),
(5253, 1),
(5254, 1),
(5255, 1),
(5256, 1),
(5257, 1),
(5258, 1),
(5259, 1),
(5260, 1),
(5261, 1),
(5262, 1),
(5263, 1),
(5264, 1),
(5265, 1),
(5266, 1),
(5267, 1);         
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(5268, 1),
(5269, 1),
(5270, 1),
(5271, 1),
(5272, 1),
(5273, 1),
(5274, 1),
(5275, 1),
(5276, 1),
(5277, 1),
(5278, 1),
(5279, 1),
(5280, 1),
(5281, 1),
(5282, 1),
(5283, 1),
(5284, 1),
(5285, 1),
(5286, 1),
(5287, 1),
(5288, 1),
(5289, 1),
(5290, 1),
(5291, 1),
(5292, 1),
(5293, 1),
(5294, 1),
(5295, 1),
(5296, 1),
(5297, 1),
(5298, 1),
(5299, 1),
(5300, 1),
(5301, 1),
(5302, 1),
(5303, 1),
(5304, 1),
(5305, 1),
(5306, 1),
(5307, 1),
(5308, 1),
(5309, 1),
(5310, 1),
(5311, 1),
(5312, 1),
(5313, 1),
(5314, 1),
(5315, 1),
(5316, 1),
(5317, 1),
(5318, 1),
(5319, 1),
(5320, 1),
(5321, 1),
(5322, 1),
(5323, 1),
(5324, 1),
(5325, 1),
(5326, 1),
(5327, 1),
(5328, 1),
(5329, 1),
(5330, 1),
(5331, 1),
(5332, 1),
(5333, 1),
(5334, 1),
(5335, 1),
(5336, 1),
(5337, 1),
(5338, 1),
(5339, 1),
(5340, 1),
(5341, 1),
(5342, 1),
(5343, 1),
(5344, 1),
(5345, 1),
(5346, 1),
(5347, 1),
(5348, 1),
(5349, 1),
(5350, 1),
(5351, 1),
(5352, 1),
(5353, 1),
(5354, 1),
(5355, 1),
(5356, 1),
(5357, 1),
(5358, 1),
(5359, 1),
(5360, 1),
(5361, 1),
(5362, 1),
(5363, 1),
(5364, 1),
(5365, 1),
(5366, 1),
(5367, 1),
(5368, 1),
(5369, 1),
(5370, 1),
(5371, 1),
(5372, 1),
(5373, 1),
(5374, 1),
(5375, 1),
(5376, 1),
(5377, 1),
(5378, 1),
(5379, 1),
(5380, 1),
(5381, 1),
(5382, 1),
(5383, 1),
(5384, 1),
(5385, 1),
(5386, 1),
(5387, 1),
(5388, 1),
(5389, 1),
(5390, 1),
(5391, 1),
(5392, 1),
(5393, 1),
(5394, 1),
(5395, 1),
(5396, 1),
(5397, 1),
(5398, 1),
(5399, 1),
(5400, 1),
(5401, 1),
(5402, 1),
(5403, 1),
(5404, 1),
(5405, 1),
(5406, 1),
(5407, 1),
(5408, 1),
(5409, 1),
(5410, 1),
(5411, 1),
(5412, 1),
(5413, 1),
(5414, 1),
(5415, 1),
(5416, 1),
(5417, 1),
(5418, 1),
(5419, 1),
(5420, 1),
(5421, 1),
(5422, 1),
(5423, 1),
(5424, 1),
(5425, 1),
(5426, 1),
(5427, 1),
(5428, 1),
(5429, 1),
(5430, 1),
(5431, 1),
(5432, 1),
(5433, 1),
(5434, 1),
(5435, 1),
(5436, 1),
(5437, 1),
(5438, 1),
(5439, 1),
(5440, 1),
(5441, 1),
(5442, 1),
(5443, 1),
(5444, 1),
(5445, 1),
(5446, 1),
(5447, 1),
(5448, 1),
(5449, 1),
(5450, 1),
(5451, 1),
(5452, 1),
(5453, 1),
(5454, 1),
(5455, 1),
(5456, 1),
(5457, 1),
(5458, 1),
(5459, 1),
(5460, 1),
(5461, 1),
(5462, 1),
(5463, 1),
(5464, 1),
(5465, 1),
(5466, 1),
(5467, 1),
(5468, 1),
(5469, 1),
(5470, 1),
(5471, 1),
(5472, 1),
(5473, 1),
(5474, 1),
(5475, 1),
(5476, 1),
(5477, 1),
(5478, 1),
(5479, 1),
(5480, 1),
(5481, 1),
(5482, 1),
(5483, 1),
(5484, 1),
(5485, 1),
(5486, 1),
(5487, 1),
(5488, 1),
(5489, 1),
(5490, 1),
(5491, 1),
(5492, 1),
(5493, 1),
(5494, 1),
(5495, 1),
(5496, 1),
(5497, 1),
(5498, 1),
(5499, 1),
(5500, 1),
(5501, 1),
(5502, 1),
(5503, 1),
(5504, 1),
(5505, 1),
(5506, 1),
(5507, 1),
(5508, 1),
(5509, 1),
(5510, 1),
(5511, 1),
(5512, 1),
(5513, 1),
(5514, 1),
(5515, 1),
(5516, 1),
(5517, 1),
(5518, 1),
(5519, 1),
(5520, 1),
(5521, 1),
(5522, 1),
(5523, 1),
(5524, 1),
(5525, 1),
(5526, 1),
(5527, 1),
(5528, 1),
(5529, 1),
(5530, 1),
(5531, 1),
(5532, 1),
(5533, 1),
(5534, 1),
(5535, 1),
(5536, 1),
(5537, 1),
(5538, 1),
(5539, 1),
(5540, 1),
(5541, 1),
(5542, 1),
(5543, 1),
(5544, 1),
(5545, 1),
(5546, 1),
(5547, 1),
(5548, 1),
(5549, 1),
(5550, 1),
(5551, 1),
(5552, 1),
(5553, 1),
(5554, 1),
(5555, 1),
(5556, 1),
(5557, 1),
(5558, 1),
(5559, 1),
(5560, 1),
(5561, 1),
(5562, 1),
(5563, 1),
(5564, 1),
(5565, 1),
(5566, 1),
(5567, 1),
(5568, 1),
(5569, 1),
(5570, 1),
(5571, 1),
(5572, 1),
(5573, 1),
(5574, 1),
(5575, 1),
(5576, 1),
(5577, 1),
(5578, 1),
(5579, 1),
(5580, 1),
(5581, 1),
(5582, 1),
(5583, 1),
(5584, 1),
(5585, 1),
(5586, 1),
(5587, 1),
(5588, 1),
(5589, 1),
(5590, 1),
(5591, 1),
(5592, 1),
(5593, 1),
(5594, 1),
(5595, 1),
(5596, 1),
(5597, 1),
(5598, 1),
(5599, 1),
(5600, 1),
(5601, 1),
(5602, 1),
(5603, 1),
(5604, 1),
(5605, 1),
(5606, 1),
(5607, 1),
(5608, 1),
(5609, 1),
(5610, 1),
(5611, 1),
(5612, 1),
(5613, 1),
(5614, 1),
(5615, 1),
(5616, 1),
(5617, 1),
(5618, 1),
(5619, 1),
(5620, 1),
(5621, 1),
(5622, 1),
(5623, 1),
(5624, 1),
(5625, 1),
(5626, 1),
(5627, 1),
(5628, 1),
(5629, 1),
(5630, 1),
(5631, 1),
(5632, 1),
(5633, 1),
(5634, 1),
(5635, 1),
(5636, 1);         
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(5637, 1),
(5638, 1),
(5639, 1),
(5640, 1),
(5641, 1),
(5642, 1),
(5643, 1),
(5644, 1),
(5645, 1),
(5646, 1),
(5647, 1),
(5648, 1),
(5649, 1),
(5650, 1),
(5651, 1),
(5652, 1),
(5653, 1),
(5654, 1),
(5655, 1),
(5656, 1),
(5657, 1),
(5658, 1),
(5659, 1),
(5660, 1),
(5661, 1),
(5662, 1),
(5663, 1),
(5664, 1),
(5665, 1),
(5666, 1),
(5667, 1),
(5668, 1),
(5669, 1),
(5670, 1),
(5671, 1),
(5672, 1),
(5673, 1),
(5674, 1),
(5675, 1),
(5676, 1),
(5677, 1),
(5678, 1),
(5679, 1),
(5680, 1),
(5681, 1),
(5682, 1),
(5683, 1),
(5684, 1),
(5685, 1),
(5686, 1),
(5687, 1),
(5688, 1),
(5689, 1),
(5690, 1),
(5691, 1),
(5692, 1),
(5693, 1),
(5694, 1),
(5695, 1),
(5696, 1),
(5697, 1),
(5698, 1),
(5699, 1),
(5700, 1),
(5701, 1),
(5702, 1),
(5703, 1),
(5704, 1),
(5705, 1),
(5706, 1),
(5707, 1),
(5708, 1),
(5709, 1),
(5710, 1),
(5711, 1),
(5712, 1),
(5713, 1),
(5714, 1),
(5715, 1),
(5716, 1),
(5717, 1),
(5718, 1),
(5719, 1),
(5720, 1),
(5721, 1),
(5722, 1),
(5723, 1),
(5724, 1),
(5725, 1),
(5726, 1),
(5727, 1),
(5728, 1),
(5729, 1),
(5730, 1),
(5731, 1),
(5732, 1),
(5733, 1),
(5734, 1),
(5735, 1),
(5736, 1),
(5737, 1),
(5738, 1),
(5739, 1),
(5740, 1),
(5741, 1),
(5742, 1),
(5743, 1),
(5744, 1),
(5745, 1),
(5746, 1),
(5747, 1),
(5748, 1),
(5749, 1),
(5750, 1),
(5751, 1),
(5752, 1),
(5753, 1),
(5754, 1),
(5755, 1),
(5756, 1),
(5757, 1),
(5758, 1),
(5759, 1),
(5760, 1),
(5761, 1),
(5762, 1),
(5763, 1),
(5764, 1),
(5765, 1),
(5766, 1),
(5767, 1),
(5768, 1),
(5769, 1),
(5770, 1),
(5771, 1),
(5772, 1),
(5773, 1),
(5774, 1),
(5775, 1),
(5776, 1),
(5777, 1),
(5778, 1),
(5779, 1),
(5780, 1),
(5781, 1),
(5782, 1),
(5783, 1),
(5784, 1),
(5785, 1),
(5786, 1),
(5787, 1),
(5788, 1),
(5789, 1),
(5790, 1),
(5791, 1),
(5792, 1),
(5793, 1),
(5794, 1),
(5795, 1),
(5796, 1),
(5797, 1),
(5798, 1),
(5799, 1),
(5800, 1),
(5801, 1),
(5802, 1),
(5803, 1),
(5804, 1),
(5805, 1),
(5806, 1),
(5807, 1),
(5808, 1),
(5809, 1),
(5810, 1),
(5811, 1),
(5812, 1),
(5813, 1),
(5814, 1),
(5815, 1),
(5816, 1),
(5817, 1),
(5818, 1),
(5819, 1),
(5820, 1),
(5821, 1),
(5822, 1),
(5823, 1),
(5824, 1),
(5825, 1),
(5826, 1),
(5827, 1),
(5828, 1),
(5829, 1),
(5830, 1),
(5831, 1),
(5832, 1),
(5833, 1),
(5834, 1),
(5835, 1),
(5836, 1),
(5837, 1),
(5838, 1),
(5839, 1),
(5840, 1),
(5841, 1),
(5842, 1),
(5843, 1),
(5844, 1),
(5845, 1),
(5846, 1),
(5847, 1),
(5848, 1),
(5849, 1),
(5850, 1),
(5851, 1),
(5852, 1),
(5853, 1),
(5854, 1),
(5855, 1),
(5856, 1),
(5857, 1),
(5858, 1),
(5859, 1),
(5860, 1),
(5861, 1),
(5862, 1),
(5863, 1),
(5864, 1),
(5865, 1),
(5866, 1),
(5867, 1),
(5868, 1),
(5869, 1),
(5870, 1),
(5871, 1),
(5872, 1),
(5873, 1),
(5874, 1),
(5875, 1),
(5876, 1),
(5877, 1),
(5878, 1),
(5879, 1),
(5880, 1),
(5881, 1),
(5882, 1),
(5883, 1),
(5884, 1),
(5885, 1),
(5886, 1),
(5887, 1),
(5888, 1),
(5889, 1),
(5890, 1),
(5891, 1),
(5892, 1),
(5893, 1),
(5894, 1),
(5895, 1),
(5896, 1),
(5897, 1),
(5898, 1),
(5899, 1),
(5900, 1),
(5901, 1),
(5902, 1),
(5903, 1),
(5904, 1),
(5905, 1),
(5906, 1),
(5907, 1),
(5908, 1),
(5909, 1),
(5910, 1),
(5911, 1),
(5912, 1),
(5913, 1),
(5914, 1),
(5915, 1),
(5916, 1),
(5917, 1),
(5918, 1),
(5919, 1),
(5920, 1),
(5921, 1),
(5922, 1),
(5923, 1),
(5924, 1),
(5925, 1),
(5926, 1),
(5927, 1),
(5928, 1),
(5929, 1),
(5930, 1),
(5931, 1),
(5932, 1),
(5933, 1),
(5934, 1),
(5935, 1),
(5936, 1),
(5937, 1),
(5938, 1),
(5939, 1),
(5940, 1),
(5941, 1),
(5942, 1),
(5943, 1),
(5944, 1),
(5945, 1),
(5946, 1),
(5947, 1),
(5948, 1),
(5949, 1),
(5950, 1),
(5951, 1),
(5952, 1),
(5953, 1),
(5954, 1),
(5955, 1),
(5956, 1),
(5957, 1),
(5958, 1),
(5959, 1),
(5960, 1),
(5961, 1),
(5962, 1),
(5963, 1),
(5964, 1),
(5965, 1),
(5966, 1),
(5967, 1),
(5968, 1),
(5969, 1),
(5970, 1),
(5971, 1),
(5972, 1),
(5973, 1),
(5974, 1),
(5975, 1),
(5976, 1),
(5977, 1),
(5978, 1),
(5979, 1),
(5980, 1),
(5981, 1),
(5982, 1),
(5983, 1),
(5984, 1),
(5985, 1),
(5986, 1),
(5987, 1),
(5988, 1),
(5989, 1),
(5990, 1),
(5991, 1),
(5992, 1),
(5993, 1),
(5994, 1),
(5995, 1),
(5996, 1),
(5997, 1),
(5998, 1),
(5999, 1),
(6000, 1),
(6001, 1),
(6002, 1),
(6003, 1),
(6004, 1),
(6005, 1);         
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(6006, 1),
(6007, 1),
(6008, 1),
(6009, 1),
(6010, 1),
(6011, 1),
(6012, 1),
(6013, 1),
(6014, 1),
(6015, 1),
(6016, 1),
(6017, 1),
(6018, 1),
(6019, 1),
(6020, 1),
(6021, 1),
(6022, 1),
(6023, 1),
(6024, 1),
(6025, 1),
(6026, 1),
(6027, 1),
(6028, 1),
(6029, 1),
(6030, 1),
(6031, 1),
(6032, 1),
(6033, 1),
(6034, 1),
(6035, 1),
(6036, 1),
(6037, 1),
(6038, 1),
(6039, 1),
(6040, 1),
(6041, 1),
(6042, 1),
(6043, 1),
(6044, 1),
(6045, 1),
(6046, 1),
(6047, 1),
(6048, 1),
(6049, 1),
(6050, 1),
(6051, 1),
(6052, 1),
(6053, 1),
(6054, 1),
(6055, 1),
(6056, 1),
(6057, 1),
(6058, 1),
(6059, 1),
(6060, 1),
(6061, 1),
(6062, 1),
(6063, 1),
(6064, 1),
(6065, 1),
(6066, 1),
(6067, 1),
(6068, 1),
(6069, 1),
(6070, 1),
(6071, 1),
(6072, 1),
(6073, 1),
(6074, 1),
(6075, 1),
(6076, 1),
(6077, 1),
(6078, 1),
(6079, 1),
(6080, 1),
(6081, 1),
(6082, 1),
(6083, 1),
(6084, 1),
(6085, 1),
(6086, 1),
(6087, 1),
(6088, 1),
(6089, 1),
(6090, 1),
(6091, 1),
(6092, 1),
(6093, 1),
(6094, 1),
(6095, 1),
(6096, 1),
(6097, 1),
(6098, 1),
(6099, 1),
(6100, 1),
(6101, 1),
(6102, 1),
(6103, 1),
(6104, 1),
(6105, 1),
(6106, 1),
(6107, 1),
(6108, 1),
(6109, 1),
(6110, 1),
(6111, 1),
(6112, 1),
(6113, 1),
(6114, 1),
(6115, 1),
(6116, 1),
(6117, 1),
(6118, 1),
(6119, 1),
(6120, 1),
(6121, 1),
(6122, 1),
(6123, 1),
(6124, 1),
(6125, 1),
(6126, 1),
(6127, 1),
(6128, 1),
(6129, 1),
(6130, 1),
(6131, 1),
(6132, 1),
(6133, 1),
(6134, 1),
(6135, 1),
(6136, 1),
(6137, 1),
(6138, 1),
(6139, 1),
(6140, 1),
(6141, 1),
(6142, 1),
(6143, 1),
(6144, 1),
(6145, 1),
(6146, 1),
(6147, 1),
(6148, 1),
(6149, 1),
(6150, 1),
(6151, 1),
(6152, 1),
(6153, 1),
(6154, 1),
(6155, 1),
(6156, 1),
(6157, 1),
(6158, 1),
(6159, 1),
(6160, 1),
(6161, 1),
(6162, 1),
(6163, 1),
(6164, 1),
(6165, 1),
(6166, 1),
(6167, 1),
(6168, 1),
(6169, 1),
(6170, 1),
(6171, 1),
(6172, 1),
(6173, 1),
(6174, 1),
(6175, 1),
(6176, 1),
(6177, 1),
(6178, 1),
(6179, 1),
(6180, 1),
(6181, 1),
(6182, 1),
(6183, 1),
(6184, 1),
(6185, 1),
(6186, 1),
(6187, 1),
(6188, 1),
(6189, 1),
(6190, 1),
(6191, 1),
(6192, 1),
(6193, 1),
(6194, 1),
(6195, 1),
(6196, 1),
(6197, 1),
(6198, 1),
(6199, 1),
(6200, 1),
(6201, 1),
(6202, 1),
(6203, 1),
(6204, 1),
(6205, 1),
(6206, 1),
(6207, 1),
(6208, 1),
(6209, 1),
(6210, 1),
(6211, 1),
(6212, 1),
(6213, 1),
(6214, 1),
(6215, 1),
(6216, 1),
(6217, 1),
(6218, 1),
(6219, 1),
(6220, 1),
(6221, 1),
(6222, 1),
(6223, 1),
(6224, 1),
(6225, 1),
(6226, 1),
(6227, 1),
(6228, 1),
(6229, 1),
(6230, 1),
(6231, 1),
(6232, 1),
(6233, 1),
(6234, 1),
(6235, 1),
(6236, 1),
(6237, 1),
(6238, 1),
(6239, 1),
(6240, 1),
(6241, 1),
(6242, 1),
(6243, 1),
(6244, 1),
(6245, 1),
(6246, 1),
(6247, 1),
(6248, 1),
(6249, 1),
(6250, 1),
(6251, 1),
(6252, 1),
(6253, 1),
(6254, 1),
(6255, 1),
(6256, 1),
(6257, 1),
(6258, 1),
(6259, 1),
(6260, 1),
(6261, 1),
(6262, 1),
(6263, 1),
(6264, 1),
(6265, 1),
(6266, 1),
(6267, 1),
(6268, 1),
(6269, 1),
(6270, 1),
(6271, 1),
(6272, 1),
(6273, 1),
(6274, 1),
(6275, 1),
(6276, 1),
(6277, 1),
(6278, 1),
(6279, 1),
(6280, 1),
(6281, 1),
(6282, 1),
(6283, 1),
(6284, 1),
(6285, 1),
(6286, 1),
(6287, 1),
(6288, 1),
(6289, 1),
(6290, 1),
(6291, 1),
(6292, 1),
(6293, 1),
(6294, 1),
(6295, 1),
(6296, 1),
(6297, 1),
(6298, 1),
(6299, 1),
(6300, 1),
(6301, 1),
(6302, 1),
(6303, 1),
(6304, 1),
(6305, 1),
(6306, 1),
(6307, 1),
(6308, 1),
(6309, 1),
(6310, 1),
(6311, 1),
(6312, 1),
(6313, 1),
(6314, 1),
(6315, 1),
(6316, 1),
(6317, 1),
(6318, 1),
(6319, 1),
(6320, 1),
(6321, 1),
(6322, 1),
(6323, 1),
(6324, 1),
(6325, 1),
(6326, 1),
(6327, 1),
(6328, 1),
(6329, 1),
(6330, 1),
(6331, 1),
(6332, 1),
(6333, 1),
(6334, 1),
(6335, 1),
(6336, 1),
(6337, 1),
(6338, 1),
(6339, 1),
(6340, 1),
(6341, 1),
(6342, 1),
(6343, 1),
(6344, 1),
(6345, 1),
(6346, 1),
(6347, 1),
(6348, 1),
(6349, 1),
(6350, 1),
(6351, 1),
(6352, 1),
(6353, 1),
(6354, 1),
(6355, 1),
(6356, 1),
(6357, 1),
(6358, 1),
(6359, 1),
(6360, 1),
(6361, 1),
(6362, 1),
(6363, 1),
(6364, 1),
(6365, 1),
(6366, 1),
(6367, 1),
(6368, 1),
(6369, 1),
(6370, 1),
(6371, 1),
(6372, 1),
(6373, 1),
(6374, 1);         
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(6375, 1),
(6376, 1),
(6377, 1),
(6378, 1),
(6379, 1),
(6380, 1),
(6381, 1),
(6382, 1),
(6383, 1),
(6384, 1),
(6385, 1),
(6386, 1),
(6387, 1),
(6388, 1),
(6389, 1),
(6390, 1),
(6391, 1),
(6392, 1),
(6393, 1),
(6394, 1),
(6395, 1),
(6396, 1),
(6397, 1),
(6398, 1),
(6399, 1),
(6400, 1),
(6401, 1),
(6402, 1),
(6403, 1),
(6404, 1),
(6405, 1),
(6406, 1),
(6407, 1),
(6408, 1),
(6409, 1),
(6410, 1),
(6411, 1),
(6412, 1),
(6413, 1),
(6414, 1),
(6415, 1),
(6416, 1),
(6417, 1),
(6418, 1),
(6419, 1),
(6420, 1),
(6421, 1),
(6422, 1),
(6423, 1),
(6424, 1),
(6425, 1),
(6426, 1),
(6427, 1),
(6428, 1),
(6429, 1),
(6430, 1),
(6431, 1),
(6432, 1),
(6433, 1),
(6434, 1),
(6435, 1),
(6436, 1),
(6437, 1),
(6438, 1),
(6439, 1),
(6440, 1),
(6441, 1),
(6442, 1),
(6443, 1),
(6444, 1),
(6445, 1),
(6446, 1),
(6447, 1),
(6448, 1),
(6449, 1),
(6450, 1),
(6451, 1),
(6452, 1),
(6453, 1),
(6454, 1),
(6455, 1),
(6456, 1),
(6457, 1),
(6458, 1),
(6459, 1),
(6460, 1),
(6461, 1),
(6462, 1),
(6463, 1),
(6464, 1),
(6465, 1),
(6466, 1),
(6467, 1),
(6468, 1),
(6469, 1),
(6470, 1),
(6471, 1),
(6472, 1),
(6473, 1),
(6474, 1),
(6475, 1),
(6476, 1),
(6477, 1),
(6478, 1),
(6479, 1),
(6480, 1),
(6481, 1),
(6482, 1),
(6483, 1),
(6484, 1),
(6485, 1),
(6486, 1),
(6487, 1),
(6488, 1),
(6489, 1),
(6490, 1),
(6491, 1),
(6492, 1),
(6493, 1),
(6494, 1),
(6495, 1),
(6496, 1),
(6497, 1),
(6498, 1),
(6499, 1),
(6500, 1),
(6501, 1),
(6502, 1),
(6503, 1),
(6504, 1),
(6505, 1),
(6506, 1),
(6507, 1),
(6508, 1),
(6509, 1),
(6510, 1),
(6511, 1),
(6512, 1),
(6513, 1),
(6514, 1),
(6515, 1),
(6516, 1),
(6517, 1),
(6518, 1),
(6519, 1),
(6520, 1),
(6521, 1),
(6522, 1),
(6523, 1),
(6524, 1),
(6525, 1),
(6526, 1),
(6527, 1),
(6528, 1),
(6529, 1),
(6530, 1),
(6531, 1),
(6532, 1),
(6533, 1),
(6534, 1),
(6535, 1),
(6536, 1),
(6537, 1),
(6538, 1),
(6539, 1),
(6540, 1),
(6541, 1),
(6542, 1),
(6543, 1),
(6544, 1),
(6545, 1),
(6546, 1),
(6547, 1),
(6548, 1),
(6549, 1),
(6550, 1),
(6551, 1),
(6552, 1),
(6553, 1),
(6554, 1),
(6555, 1),
(6556, 1),
(6557, 1),
(6558, 1),
(6559, 1),
(6560, 1),
(6561, 1),
(6562, 1),
(6563, 1),
(6564, 1),
(6565, 1),
(6566, 1),
(6567, 1),
(6568, 1),
(6569, 1),
(6570, 1),
(6571, 1),
(6572, 1),
(6573, 1),
(6574, 1),
(6575, 1),
(6576, 1),
(6577, 1),
(6578, 1),
(6579, 1),
(6580, 1),
(6581, 1),
(6582, 1),
(6583, 1),
(6584, 1),
(6585, 1),
(6586, 1),
(6587, 1),
(6588, 1),
(6589, 1),
(6590, 1),
(6591, 1),
(6592, 1),
(6593, 1),
(6594, 1),
(6595, 1),
(6596, 1),
(6597, 1),
(6598, 1),
(6599, 1),
(6600, 1),
(6601, 1),
(6602, 1),
(6603, 1),
(6604, 1),
(6605, 1),
(6606, 1),
(6607, 1),
(6608, 1),
(6609, 1),
(6610, 1),
(6611, 1),
(6612, 1),
(6613, 1),
(6614, 1),
(6615, 1),
(6616, 1),
(6617, 1),
(6618, 1),
(6619, 1),
(6620, 1),
(6621, 1),
(6622, 1),
(6623, 1),
(6624, 1),
(6625, 1),
(6626, 1),
(6627, 1),
(6628, 1),
(6629, 1),
(6630, 1),
(6631, 1),
(6632, 1),
(6633, 1),
(6634, 1),
(6635, 1),
(6636, 1),
(6637, 1),
(6638, 1),
(6639, 1),
(6640, 1),
(6641, 1),
(6642, 1),
(6643, 1),
(6644, 1),
(6645, 1),
(6646, 1),
(6647, 1),
(6648, 1),
(6649, 1),
(6650, 1),
(6651, 1),
(6652, 1),
(6653, 1),
(6654, 1),
(6655, 1),
(6656, 1),
(6657, 1),
(6658, 1),
(6659, 1),
(6660, 1),
(6661, 1),
(6662, 1),
(6663, 1),
(6664, 1),
(6665, 1),
(6666, 1),
(6667, 1),
(6668, 1),
(6669, 1),
(6670, 1),
(6671, 1),
(6672, 1),
(6673, 1),
(6674, 1),
(6675, 1),
(6676, 1),
(6677, 1),
(6678, 1),
(6679, 1),
(6680, 1),
(6681, 1),
(6682, 1),
(6683, 1),
(6684, 1),
(6685, 1),
(6686, 1),
(6687, 1),
(6688, 1),
(6689, 1),
(6690, 1),
(6691, 1),
(6692, 1),
(6693, 1),
(6694, 1),
(6695, 1),
(6696, 1),
(6697, 1),
(6698, 1),
(6699, 1),
(6700, 1),
(6701, 1),
(6702, 1),
(6703, 1),
(6704, 1),
(6705, 1),
(6706, 1),
(6707, 1),
(6708, 1),
(6709, 1),
(6710, 1),
(6711, 1),
(6712, 1),
(6713, 1),
(6714, 1),
(6715, 1),
(6716, 1),
(6717, 1),
(6718, 1),
(6719, 1),
(6720, 1),
(6721, 1),
(6722, 1),
(6723, 1),
(6724, 1),
(6725, 1),
(6726, 1),
(6727, 1),
(6728, 1),
(6729, 1),
(6730, 1),
(6731, 1),
(6732, 1),
(6733, 1),
(6734, 1),
(6735, 1),
(6736, 1),
(6737, 1),
(6738, 1),
(6739, 1),
(6740, 1),
(6741, 1),
(6742, 1),
(6743, 1);         
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(6744, 1),
(6745, 1),
(6746, 1),
(6747, 1),
(6748, 1),
(6749, 1),
(6750, 1),
(6751, 1),
(6752, 1),
(6753, 1),
(6754, 1),
(6755, 1),
(6756, 1),
(6757, 1),
(6758, 1),
(6759, 1),
(6760, 1),
(6761, 1),
(6762, 1),
(6763, 1),
(6764, 1),
(6765, 1),
(6766, 1),
(6767, 1),
(6768, 1),
(6769, 1),
(6770, 1),
(6771, 1),
(6772, 1),
(6773, 1),
(6774, 1),
(6775, 1),
(6776, 1),
(6777, 1),
(6778, 1),
(6779, 1),
(6780, 1),
(6781, 1),
(6782, 1),
(6783, 1),
(6784, 1),
(6785, 1),
(6786, 1),
(6787, 1),
(6788, 1),
(6789, 1),
(6790, 1),
(6791, 1),
(6792, 1),
(6793, 1),
(6794, 1),
(6795, 1),
(6796, 1),
(6797, 1),
(6798, 1),
(6799, 1),
(6800, 1),
(6801, 1),
(6802, 1),
(6803, 1),
(6804, 1),
(6805, 1),
(6806, 1),
(6807, 1),
(6808, 1),
(6809, 1),
(6810, 1),
(6811, 1),
(6812, 1),
(6813, 1),
(6814, 1),
(6815, 1),
(6816, 1),
(6817, 1),
(6818, 1),
(6819, 1),
(6820, 1),
(6821, 1),
(6822, 1),
(6823, 1),
(6824, 1),
(6825, 1),
(6826, 1),
(6827, 1),
(6828, 1),
(6829, 1),
(6830, 1),
(6831, 1),
(6832, 1),
(6833, 1),
(6834, 1),
(6835, 1),
(6836, 1),
(6837, 1),
(6838, 1),
(6839, 1),
(6840, 1),
(6841, 1),
(6842, 1),
(6843, 1),
(6844, 1),
(6845, 1),
(6846, 1),
(6847, 1),
(6848, 1),
(6849, 1),
(6850, 1),
(6851, 1),
(6852, 1),
(6853, 1),
(6854, 1),
(6855, 1),
(6856, 1),
(6857, 1),
(6858, 1),
(6859, 1),
(6860, 1),
(6861, 1),
(6862, 1),
(6863, 1),
(6864, 1),
(6865, 1),
(6866, 1),
(6867, 1),
(6868, 1),
(6869, 1),
(6870, 1),
(6871, 1),
(6872, 1),
(6873, 1),
(6874, 1),
(6875, 1),
(6876, 1),
(6877, 1),
(6878, 1),
(6879, 1),
(6880, 1),
(6881, 1),
(6882, 1),
(6883, 1),
(6884, 1),
(6885, 1),
(6886, 1),
(6887, 1),
(6888, 1),
(6889, 1),
(6890, 1),
(6891, 1),
(6892, 1),
(6893, 1),
(6894, 1),
(6895, 1),
(6896, 1),
(6897, 1),
(6898, 1),
(6899, 1),
(6900, 1),
(6901, 1),
(6902, 1),
(6903, 1),
(6904, 1),
(6905, 1),
(6906, 1),
(6907, 1),
(6908, 1),
(6909, 1),
(6910, 1),
(6911, 1),
(6912, 1),
(6913, 1),
(6914, 1),
(6915, 1),
(6916, 1),
(6917, 1),
(6918, 1),
(6919, 1),
(6920, 1),
(6921, 1),
(6922, 1),
(6923, 1),
(6924, 1),
(6925, 1),
(6926, 1),
(6927, 1),
(6928, 1),
(6929, 1),
(6930, 1),
(6931, 1),
(6932, 1),
(6933, 1),
(6934, 1),
(6935, 1),
(6936, 1),
(6937, 1),
(6938, 1),
(6939, 1),
(6940, 1),
(6941, 1),
(6942, 1),
(6943, 1),
(6944, 1),
(6945, 1),
(6946, 1),
(6947, 1),
(6948, 1),
(6949, 1),
(6950, 1),
(6951, 1),
(6952, 1),
(6953, 1),
(6954, 1),
(6955, 1),
(6956, 1),
(6957, 1),
(6958, 1),
(6959, 1),
(6960, 1),
(6961, 1),
(6962, 1),
(6963, 1),
(6964, 1),
(6965, 1),
(6966, 1),
(6967, 1),
(6968, 1),
(6969, 1),
(6970, 1),
(6971, 1),
(6972, 1),
(6973, 1),
(6974, 1),
(6975, 1),
(6976, 1),
(6977, 1),
(6978, 1),
(6979, 1),
(6980, 1),
(6981, 1),
(6982, 1),
(6983, 1),
(6984, 1),
(6985, 1),
(6986, 1),
(6987, 1),
(6988, 1),
(6989, 1),
(6990, 1),
(6991, 1),
(6992, 1),
(6993, 1),
(6994, 1),
(6995, 1),
(6996, 1),
(6997, 1),
(6998, 1),
(6999, 1),
(7000, 1),
(7001, 1),
(7002, 1),
(7003, 1),
(7004, 1),
(7005, 1),
(7006, 1),
(7007, 1),
(7008, 1),
(7009, 1),
(7010, 1),
(7011, 1),
(7012, 1),
(7013, 1),
(7014, 1),
(7015, 1),
(7016, 1),
(7017, 1),
(7018, 1),
(7019, 1),
(7020, 1),
(7021, 1),
(7022, 1),
(7023, 1),
(7024, 1),
(7025, 1),
(7026, 1),
(7027, 1),
(7028, 1),
(7029, 1),
(7030, 1),
(7031, 1),
(7032, 1),
(7033, 1),
(7034, 1),
(7035, 1),
(7036, 1),
(7037, 1),
(7038, 1),
(7039, 1),
(7040, 1),
(7041, 1),
(7042, 1),
(7043, 1),
(7044, 1),
(7045, 1),
(7046, 1),
(7047, 1),
(7048, 1),
(7049, 1),
(7050, 1),
(7051, 1),
(7052, 1),
(7053, 1),
(7054, 1),
(7055, 1),
(7056, 1),
(7057, 1),
(7058, 1),
(7059, 1),
(7060, 1),
(7061, 1),
(7062, 1),
(7063, 1),
(7064, 1),
(7065, 1),
(7066, 1),
(7067, 1),
(7068, 1),
(7069, 1),
(7070, 1),
(7071, 1),
(7072, 1),
(7073, 1),
(7074, 1),
(7075, 1),
(7076, 1),
(7077, 1),
(7078, 1),
(7079, 1),
(7080, 1),
(7081, 1),
(7082, 1),
(7083, 1),
(7084, 1),
(7085, 1),
(7086, 1),
(7087, 1),
(7088, 1),
(7089, 1),
(7090, 1),
(7091, 1),
(7092, 1),
(7093, 1),
(7094, 1),
(7095, 1),
(7096, 1),
(7097, 1),
(7098, 1),
(7099, 1),
(7100, 1),
(7101, 1),
(7102, 1),
(7103, 1),
(7104, 1),
(7105, 1),
(7106, 1),
(7107, 1),
(7108, 1),
(7109, 1),
(7110, 1),
(7111, 1),
(7112, 1);         
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(7113, 1),
(7114, 1),
(7115, 1),
(7116, 1),
(7117, 1),
(7118, 1),
(7119, 1),
(7120, 1),
(7121, 1),
(7122, 1),
(7123, 1),
(7124, 1),
(7125, 1),
(7126, 1),
(7127, 1),
(7128, 1),
(7129, 1),
(7130, 1),
(7131, 1),
(7132, 1),
(7133, 1),
(7134, 1),
(7135, 1),
(7136, 1),
(7137, 1),
(7138, 1),
(7139, 1),
(7140, 1),
(7141, 1),
(7142, 1),
(7143, 1),
(7144, 1),
(7145, 1),
(7146, 1),
(7147, 1),
(7148, 1),
(7149, 1),
(7150, 1),
(7151, 1),
(7152, 1),
(7153, 1),
(7154, 1),
(7155, 1),
(7156, 1),
(7157, 1),
(7158, 1),
(7159, 1),
(7160, 1),
(7161, 1),
(7162, 1),
(7163, 1),
(7164, 1),
(7165, 1),
(7166, 1),
(7167, 1),
(7168, 1),
(7169, 1),
(7170, 1),
(7171, 1),
(7172, 1),
(7173, 1),
(7174, 1),
(7175, 1),
(7176, 1),
(7177, 1),
(7178, 1),
(7179, 1),
(7180, 1),
(7181, 1),
(7182, 1),
(7183, 1),
(7184, 1),
(7185, 1),
(7186, 1),
(7187, 1),
(7188, 1),
(7189, 1),
(7190, 1),
(7191, 1),
(7192, 1),
(7193, 1),
(7194, 1),
(7195, 1),
(7196, 1),
(7197, 1),
(7198, 1),
(7199, 1),
(7200, 1),
(7201, 1),
(7202, 1),
(7203, 1),
(7204, 1),
(7205, 1),
(7206, 1),
(7207, 1),
(7208, 1),
(7209, 1),
(7210, 1),
(7211, 1),
(7212, 1),
(7213, 1),
(7214, 1),
(7215, 1),
(7216, 1),
(7217, 1),
(7218, 1),
(7219, 1),
(7220, 1),
(7221, 1),
(7222, 1),
(7223, 1),
(7224, 1),
(7225, 1),
(7226, 1),
(7227, 1),
(7228, 1),
(7229, 1),
(7230, 1),
(7231, 1),
(7232, 1),
(7233, 1),
(7234, 1),
(7235, 1),
(7236, 1),
(7237, 1),
(7238, 1),
(7239, 1),
(7240, 1),
(7241, 1),
(7242, 1),
(7243, 1),
(7244, 1),
(7245, 1),
(7246, 1),
(7247, 1),
(7248, 1),
(7249, 1),
(7250, 1),
(7251, 1),
(7252, 1),
(7253, 1),
(7254, 1),
(7255, 1),
(7256, 1),
(7257, 1),
(7258, 1),
(7259, 1),
(7260, 1),
(7261, 1),
(7262, 1),
(7263, 1),
(7264, 1),
(7265, 1),
(7266, 1),
(7267, 1),
(7268, 1),
(7269, 1),
(7270, 1),
(7271, 1),
(7272, 1),
(7273, 1),
(7274, 1),
(7275, 1),
(7276, 1),
(7277, 1),
(7278, 1),
(7279, 1),
(7280, 1),
(7281, 1),
(7282, 1),
(7283, 1),
(7284, 1),
(7285, 1),
(7286, 1),
(7287, 1),
(7288, 1),
(7289, 1),
(7290, 1),
(7291, 1),
(7292, 1),
(7293, 1),
(7294, 1),
(7295, 1),
(7296, 1),
(7297, 1),
(7298, 1),
(7299, 1),
(7300, 1),
(7301, 1),
(7302, 1),
(7303, 1),
(7304, 1),
(7305, 1),
(7306, 1),
(7307, 1),
(7308, 1),
(7309, 1),
(7310, 1),
(7311, 1),
(7312, 1),
(7313, 1),
(7314, 1),
(7315, 1),
(7316, 1),
(7317, 1),
(7318, 1),
(7319, 1),
(7320, 1),
(7321, 1),
(7322, 1),
(7323, 1),
(7324, 1),
(7325, 1),
(7326, 1),
(7327, 1),
(7328, 1),
(7329, 1),
(7330, 1),
(7331, 1),
(7332, 1),
(7333, 1),
(7334, 1),
(7335, 1),
(7336, 1),
(7337, 1),
(7338, 1),
(7339, 1),
(7340, 1),
(7341, 1),
(7342, 1),
(7343, 1),
(7344, 1),
(7345, 1),
(7346, 1),
(7347, 1),
(7348, 1),
(7349, 1),
(7350, 1),
(7351, 1),
(7352, 1),
(7353, 1),
(7354, 1),
(7355, 1),
(7356, 1),
(7357, 1),
(7358, 1),
(7359, 1),
(7360, 1),
(7361, 1),
(7362, 1),
(7363, 1),
(7364, 1),
(7365, 1),
(7366, 1),
(7367, 1),
(7368, 1),
(7369, 1),
(7370, 1),
(7371, 1),
(7372, 1),
(7373, 1),
(7374, 1),
(7375, 1),
(7376, 1),
(7377, 1),
(7378, 1),
(7379, 1),
(7380, 1),
(7381, 1),
(7382, 1),
(7383, 1),
(7384, 1),
(7385, 1),
(7386, 1),
(7387, 1),
(7388, 1),
(7389, 1),
(7390, 1),
(7391, 1),
(7392, 1),
(7393, 1),
(7394, 1),
(7395, 1),
(7396, 1),
(7397, 1),
(7398, 1),
(7399, 1),
(7400, 1),
(7401, 1),
(7402, 1),
(7403, 1),
(7404, 1),
(7405, 1),
(7406, 1),
(7407, 1),
(7408, 1),
(7409, 1),
(7410, 1),
(7411, 1),
(7412, 1),
(7413, 1),
(7414, 1),
(7415, 1),
(7416, 1),
(7417, 1),
(7418, 1),
(7419, 1),
(7420, 1),
(7421, 1),
(7422, 1),
(7423, 1),
(7424, 1),
(7425, 1),
(7426, 1),
(7427, 1),
(7428, 1),
(7429, 1),
(7430, 1),
(7431, 1),
(7432, 1),
(7433, 1),
(7434, 1),
(7435, 1),
(7436, 1),
(7437, 1),
(7438, 1),
(7439, 1),
(7440, 1),
(7441, 1),
(7442, 1),
(7443, 1),
(7444, 1),
(7445, 1),
(7446, 1),
(7447, 1),
(7448, 1),
(7449, 1),
(7450, 1),
(7451, 1),
(7452, 1),
(7453, 1),
(7454, 1),
(7455, 1),
(7456, 1),
(7457, 1),
(7458, 1),
(7459, 1),
(7460, 1),
(7461, 1),
(7462, 1),
(7463, 1),
(7464, 1),
(7465, 1),
(7466, 1),
(7467, 1),
(7468, 1),
(7469, 1),
(7470, 1),
(7471, 1),
(7472, 1),
(7473, 1),
(7474, 1),
(7475, 1),
(7476, 1),
(7477, 1),
(7478, 1),
(7479, 1),
(7480, 1),
(7481, 1);         
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(7482, 1),
(7483, 1),
(7484, 1),
(7485, 1),
(7486, 1),
(7487, 1),
(7488, 1),
(7489, 1),
(7490, 1),
(7491, 1),
(7492, 1),
(7493, 1),
(7494, 1),
(7495, 1),
(7496, 1),
(7497, 1),
(7498, 1),
(7499, 1),
(7500, 1),
(7501, 1),
(7502, 1),
(7503, 1),
(7504, 1),
(7505, 1),
(7506, 1),
(7507, 1),
(7508, 1),
(7509, 1),
(7510, 1),
(7511, 1),
(7512, 1),
(7513, 1),
(7514, 1),
(7515, 1),
(7516, 1),
(7517, 1),
(7518, 1),
(7519, 1),
(7520, 1),
(7521, 1),
(7522, 1),
(7523, 1),
(7524, 1),
(7525, 1),
(7526, 1),
(7527, 1),
(7528, 1),
(7529, 1),
(7530, 1),
(7531, 1),
(7532, 1),
(7533, 1),
(7534, 1),
(7535, 1),
(7536, 1),
(7537, 1),
(7538, 1),
(7539, 1),
(7540, 1),
(7541, 1),
(7542, 1),
(7543, 1),
(7544, 1),
(7545, 1),
(7546, 1),
(7547, 1),
(7548, 1),
(7549, 1),
(7550, 1),
(7551, 1),
(7552, 1),
(7553, 1),
(7554, 1),
(7555, 1),
(7556, 1),
(7557, 1),
(7558, 1),
(7559, 1),
(7560, 1),
(7561, 1),
(7562, 1),
(7563, 1),
(7564, 1),
(7565, 1),
(7566, 1),
(7567, 1),
(7568, 1),
(7569, 1),
(7570, 1),
(7571, 1),
(7572, 1),
(7573, 1),
(7574, 1),
(7575, 1),
(7576, 1),
(7577, 1),
(7578, 1),
(7579, 1),
(7580, 1),
(7581, 1),
(7582, 1),
(7583, 1),
(7584, 1),
(7585, 1),
(7586, 1),
(7587, 1),
(7588, 1),
(7589, 1),
(7590, 1),
(7591, 1),
(7592, 1),
(7593, 1),
(7594, 1),
(7595, 1),
(7596, 1),
(7597, 1),
(7598, 1),
(7599, 1),
(7600, 1),
(7601, 1),
(7602, 1),
(7603, 1),
(7604, 1),
(7605, 1),
(7606, 1),
(7607, 1),
(7608, 1),
(7609, 1),
(7610, 1),
(7611, 1),
(7612, 1),
(7613, 1),
(7614, 1),
(7615, 1),
(7616, 1),
(7617, 1),
(7618, 1),
(7619, 1),
(7620, 1),
(7621, 1),
(7622, 1),
(7623, 1),
(7624, 1),
(7625, 1),
(7626, 1),
(7627, 1),
(7628, 1),
(7629, 1),
(7630, 1),
(7631, 1),
(7632, 1),
(7633, 1),
(7634, 1),
(7635, 1),
(7636, 1),
(7637, 1),
(7638, 1),
(7639, 1),
(7640, 1),
(7641, 1),
(7642, 1),
(7643, 1),
(7644, 1),
(7645, 1),
(7646, 1),
(7647, 1),
(7648, 1),
(7649, 1),
(7650, 1),
(7651, 1),
(7652, 1),
(7653, 1),
(7654, 1),
(7655, 1),
(7656, 1),
(7657, 1),
(7658, 1),
(7659, 1),
(7660, 1),
(7661, 1),
(7662, 1),
(7663, 1),
(7664, 1),
(7665, 1),
(7666, 1),
(7667, 1),
(7668, 1),
(7669, 1),
(7670, 1),
(7671, 1),
(7672, 1),
(7673, 1),
(7674, 1),
(7675, 1),
(7676, 1),
(7677, 1),
(7678, 1),
(7679, 1),
(7680, 1),
(7681, 1),
(7682, 1),
(7683, 1),
(7684, 1),
(7685, 1),
(7686, 1),
(7687, 1),
(7688, 1),
(7689, 1),
(7690, 1),
(7691, 1),
(7692, 1),
(7693, 1),
(7694, 1),
(7695, 1),
(7696, 1),
(7697, 1),
(7698, 1),
(7699, 1),
(7700, 1),
(7701, 1),
(7702, 1),
(7703, 1),
(7704, 1),
(7705, 1),
(7706, 1),
(7707, 1),
(7708, 1),
(7709, 1),
(7710, 1),
(7711, 1),
(7712, 1),
(7713, 1),
(7714, 1),
(7715, 1),
(7716, 1),
(7717, 1),
(7718, 1),
(7719, 1),
(7720, 1),
(7721, 1),
(7722, 1),
(7723, 1),
(7724, 1),
(7725, 1),
(7726, 1),
(7727, 1),
(7728, 1),
(7729, 1),
(7730, 1),
(7731, 1),
(7732, 1),
(7733, 1),
(7734, 1),
(7735, 1),
(7736, 1),
(7737, 1),
(7738, 1),
(7739, 1),
(7740, 1),
(7741, 1),
(7742, 1),
(7743, 1),
(7744, 1),
(7745, 1),
(7746, 1),
(7747, 1),
(7748, 1),
(7749, 1),
(7750, 1),
(7751, 1),
(7752, 1),
(7753, 1),
(7754, 1),
(7755, 1),
(7756, 1),
(7757, 1),
(7758, 1),
(7759, 1),
(7760, 1),
(7761, 1),
(7762, 1),
(7763, 1),
(7764, 1),
(7765, 1),
(7766, 1),
(7767, 1),
(7768, 1),
(7769, 1),
(7770, 1),
(7771, 1),
(7772, 1),
(7773, 1),
(7774, 1),
(7775, 1),
(7776, 1),
(7777, 1),
(7778, 1),
(7779, 1),
(7780, 1),
(7781, 1),
(7782, 1),
(7783, 1),
(7784, 1),
(7785, 1),
(7786, 1),
(7787, 1),
(7788, 1),
(7789, 1),
(7790, 1),
(7791, 1),
(7792, 1),
(7793, 1),
(7794, 1),
(7795, 1),
(7796, 1),
(7797, 1),
(7798, 1),
(7799, 1),
(7800, 1),
(7801, 1),
(7802, 1),
(7803, 1),
(7804, 1),
(7805, 1),
(7806, 1),
(7807, 1),
(7808, 1),
(7809, 1),
(7810, 1),
(7811, 1),
(7812, 1),
(7813, 1),
(7814, 1),
(7815, 1),
(7816, 1),
(7817, 1),
(7818, 1),
(7819, 1),
(7820, 1),
(7821, 1),
(7822, 1),
(7823, 1),
(7824, 1),
(7825, 1),
(7826, 1),
(7827, 1),
(7828, 1),
(7829, 1),
(7830, 1),
(7831, 1),
(7832, 1),
(7833, 1),
(7834, 1),
(7835, 1),
(7836, 1),
(7837, 1),
(7838, 1),
(7839, 1),
(7840, 1),
(7841, 1),
(7842, 1),
(7843, 1),
(7844, 1),
(7845, 1),
(7846, 1),
(7847, 1),
(7848, 1),
(7849, 1),
(7850, 1);         
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(7851, 1),
(7852, 1),
(7853, 1),
(7854, 1),
(7855, 1),
(7856, 1),
(7857, 1),
(7858, 1),
(7859, 1),
(7860, 1),
(7861, 1),
(7862, 1),
(7863, 1),
(7864, 1),
(7865, 1),
(7866, 1),
(7867, 1),
(7868, 1),
(7869, 1),
(7870, 1),
(7871, 1),
(7872, 1),
(7873, 1),
(7874, 1),
(7875, 1),
(7876, 1),
(7877, 1),
(7878, 1),
(7879, 1),
(7880, 1),
(7881, 1),
(7882, 1),
(7883, 1),
(7884, 1),
(7885, 1),
(7886, 1),
(7887, 1),
(7888, 1),
(7889, 1),
(7890, 1),
(7891, 1),
(7892, 1),
(7893, 1),
(7894, 1),
(7895, 1),
(7896, 1),
(7897, 1),
(7898, 1),
(7899, 1),
(7900, 1),
(7901, 1),
(7902, 1),
(7903, 1),
(7904, 1),
(7905, 1),
(7906, 1),
(7907, 1),
(7908, 1),
(7909, 1),
(7910, 1),
(7911, 1),
(7912, 1),
(7913, 1),
(7914, 1),
(7915, 1),
(7916, 1),
(7917, 1),
(7918, 1),
(7919, 1),
(7920, 1),
(7921, 1),
(7922, 1),
(7923, 1),
(7924, 1),
(7925, 1),
(7926, 1),
(7927, 1),
(7928, 1),
(7929, 1),
(7930, 1),
(7931, 1),
(7932, 1),
(7933, 1),
(7934, 1),
(7935, 1),
(7936, 1),
(7937, 1),
(7938, 1),
(7939, 1),
(7940, 1),
(7941, 1),
(7942, 1),
(7943, 1),
(7944, 1),
(7945, 1),
(7946, 1),
(7947, 1),
(7948, 1),
(7949, 1),
(7950, 1),
(7951, 1),
(7952, 1),
(7953, 1),
(7954, 1),
(7955, 1),
(7956, 1),
(7957, 1),
(7958, 1),
(7959, 1),
(7960, 1),
(7961, 1),
(7962, 1),
(7963, 1),
(7964, 1),
(7965, 1),
(7966, 1),
(7967, 1),
(7968, 1),
(7969, 1),
(7970, 1),
(7971, 1),
(7972, 1),
(7973, 1),
(7974, 1),
(7975, 1),
(7976, 1),
(7977, 1),
(7978, 1),
(7979, 1),
(7980, 1),
(7981, 1),
(7982, 1),
(7983, 1),
(7984, 1),
(7985, 1),
(7986, 1),
(7987, 1),
(7988, 1),
(7989, 1),
(7990, 1),
(7991, 1),
(7992, 1),
(7993, 1),
(7994, 1),
(7995, 1),
(7996, 1),
(7997, 1),
(7998, 1),
(7999, 1),
(8000, 1),
(8001, 1),
(8002, 1),
(8003, 1),
(8004, 1),
(8005, 1),
(8006, 1),
(8007, 1),
(8008, 1),
(8009, 1),
(8010, 1),
(8011, 1),
(8012, 1),
(8013, 1),
(8014, 1),
(8015, 1),
(8016, 1),
(8017, 1),
(8018, 1),
(8019, 1),
(8020, 1),
(8021, 1),
(8022, 1),
(8023, 1),
(8024, 1),
(8025, 1),
(8026, 1),
(8027, 1),
(8028, 1),
(8029, 1),
(8030, 1),
(8031, 1),
(8032, 1),
(8033, 1),
(8034, 1),
(8035, 1),
(8036, 1),
(8037, 1),
(8038, 1),
(8039, 1),
(8040, 1),
(8041, 1),
(8042, 1),
(8043, 1),
(8044, 1),
(8045, 1),
(8046, 1),
(8047, 1),
(8048, 1),
(8049, 1),
(8050, 1),
(8051, 1),
(8052, 1),
(8053, 1),
(8054, 1),
(8055, 1),
(8056, 1),
(8057, 1),
(8058, 1),
(8059, 1),
(8060, 1),
(8061, 1),
(8062, 1),
(8063, 1),
(8064, 1),
(8065, 1),
(8066, 1),
(8067, 1),
(8068, 1),
(8069, 1),
(8070, 1),
(8071, 1),
(8072, 1),
(8073, 1),
(8074, 1),
(8075, 1),
(8076, 1),
(8077, 1),
(8078, 1),
(8079, 1),
(8080, 1),
(8081, 1),
(8082, 1),
(8083, 1),
(8084, 1),
(8085, 1),
(8086, 1),
(8087, 1),
(8088, 1),
(8089, 1),
(8090, 1),
(8091, 1),
(8092, 1),
(8093, 1),
(8094, 1),
(8095, 1),
(8096, 1),
(8097, 1),
(8098, 1),
(8099, 1),
(8100, 1),
(8101, 1),
(8102, 1),
(8103, 1),
(8104, 1),
(8105, 1),
(8106, 1),
(8107, 1),
(8108, 1),
(8109, 1),
(8110, 1),
(8111, 1),
(8112, 1),
(8113, 1),
(8114, 1),
(8115, 1),
(8116, 1),
(8117, 1),
(8118, 1),
(8119, 1),
(8120, 1),
(8121, 1),
(8122, 1),
(8123, 1),
(8124, 1),
(8125, 1),
(8126, 1),
(8127, 1),
(8128, 1),
(8129, 1),
(8130, 1),
(8131, 1),
(8132, 1),
(8133, 1),
(8134, 1),
(8135, 1),
(8136, 1),
(8137, 1),
(8138, 1),
(8139, 1),
(8140, 1),
(8141, 1),
(8142, 1),
(8143, 1),
(8144, 1),
(8145, 1),
(8146, 1),
(8147, 1),
(8148, 1),
(8149, 1),
(8150, 1),
(8151, 1),
(8152, 1),
(8153, 1),
(8154, 1),
(8155, 1),
(8156, 1),
(8157, 1),
(8158, 1),
(8159, 1),
(8160, 1),
(8161, 1),
(8162, 1),
(8163, 1),
(8164, 1),
(8165, 1),
(8166, 1),
(8167, 1),
(8168, 1),
(8169, 1),
(8170, 1),
(8171, 1),
(8172, 1),
(8173, 1),
(8174, 1),
(8175, 1),
(8176, 1),
(8177, 1),
(8178, 1),
(8179, 1),
(8180, 1),
(8181, 1),
(8182, 1),
(8183, 1),
(8184, 1),
(8185, 1),
(8186, 1),
(8187, 1),
(8188, 1),
(8189, 1),
(8190, 1),
(8191, 1),
(8192, 1),
(8193, 1),
(8194, 1),
(8195, 1),
(8196, 1),
(8197, 1),
(8198, 1),
(8199, 1),
(8200, 1),
(8201, 1),
(8202, 1),
(8203, 1),
(8204, 1),
(8205, 1),
(8206, 1),
(8207, 1),
(8208, 1),
(8209, 1),
(8210, 1),
(8211, 1),
(8212, 1),
(8213, 1),
(8214, 1),
(8215, 1),
(8216, 1),
(8217, 1),
(8218, 1),
(8219, 1);         
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(8220, 1),
(8221, 1),
(8222, 1),
(8223, 1),
(8224, 1),
(8225, 1),
(8226, 1),
(8227, 1),
(8228, 1),
(8229, 1),
(8230, 1),
(8231, 1),
(8232, 1),
(8233, 1),
(8234, 1),
(8235, 1),
(8236, 1),
(8237, 1),
(8238, 1),
(8239, 1),
(8240, 1),
(8241, 1),
(8242, 1),
(8243, 1),
(8244, 1),
(8245, 1),
(8246, 1),
(8247, 1),
(8248, 1),
(8249, 1),
(8250, 1),
(8251, 1),
(8252, 1),
(8253, 1),
(8254, 1),
(8255, 1),
(8256, 1),
(8257, 1),
(8258, 1),
(8259, 1),
(8260, 1),
(8261, 1),
(8262, 1),
(8263, 1),
(8264, 1),
(8265, 1),
(8266, 1),
(8267, 1),
(8268, 1),
(8269, 1),
(8270, 1),
(8271, 1),
(8272, 1),
(8273, 1),
(8274, 1),
(8275, 1),
(8276, 1),
(8277, 1),
(8278, 1),
(8279, 1),
(8280, 1),
(8281, 1),
(8282, 1),
(8283, 1),
(8284, 1),
(8285, 1),
(8286, 1),
(8287, 1),
(8288, 1),
(8289, 1),
(8290, 1),
(8291, 1),
(8292, 1),
(8293, 1),
(8294, 1),
(8295, 1),
(8296, 1),
(8297, 1),
(8298, 1),
(8299, 1),
(8300, 1),
(8301, 1),
(8302, 1),
(8303, 1),
(8304, 1),
(8305, 1),
(8306, 1),
(8307, 1),
(8308, 1),
(8309, 1),
(8310, 1),
(8311, 1),
(8312, 1),
(8313, 1),
(8314, 1),
(8315, 1),
(8316, 1),
(8317, 1),
(8318, 1),
(8319, 1),
(8320, 1),
(8321, 1),
(8322, 1),
(8323, 1),
(8324, 1),
(8325, 1),
(8326, 1),
(8327, 1),
(8328, 1),
(8329, 1),
(8330, 1),
(8331, 1),
(8332, 1),
(8333, 1),
(8334, 1),
(8335, 1),
(8336, 1),
(8337, 1),
(8338, 1),
(8339, 1),
(8340, 1),
(8341, 1),
(8342, 1),
(8343, 1),
(8344, 1),
(8345, 1),
(8346, 1),
(8347, 1),
(8348, 1),
(8349, 1),
(8350, 1),
(8351, 1),
(8352, 1),
(8353, 1),
(8354, 1),
(8355, 1),
(8356, 1),
(8357, 1),
(8358, 1),
(8359, 1),
(8360, 1),
(8361, 1),
(8362, 1),
(8363, 1),
(8364, 1),
(8365, 1),
(8366, 1),
(8367, 1),
(8368, 1),
(8369, 1),
(8370, 1),
(8371, 1),
(8372, 1),
(8373, 1),
(8374, 1),
(8375, 1),
(8376, 1),
(8377, 1),
(8378, 1),
(8379, 1),
(8380, 1),
(8381, 1),
(8382, 1),
(8383, 1),
(8384, 1),
(8385, 1),
(8386, 1),
(8387, 1),
(8388, 1),
(8389, 1),
(8390, 1),
(8391, 1),
(8392, 1),
(8393, 1),
(8394, 1),
(8395, 1),
(8396, 1),
(8397, 1),
(8398, 1),
(8399, 1),
(8400, 1),
(8401, 1),
(8402, 1),
(8403, 1),
(8404, 1),
(8405, 1),
(8406, 1),
(8407, 1),
(8408, 1),
(8409, 1),
(8410, 1),
(8411, 1),
(8412, 1),
(8413, 1),
(8414, 1),
(8415, 1),
(8416, 1),
(8417, 1),
(8418, 1),
(8419, 1),
(8420, 1),
(8421, 1),
(8422, 1),
(8423, 1),
(8424, 1),
(8425, 1),
(8426, 1),
(8427, 1),
(8428, 1),
(8429, 1),
(8430, 1),
(8431, 1),
(8432, 1),
(8433, 1),
(8434, 1),
(8435, 1),
(8436, 1),
(8437, 1),
(8438, 1),
(8439, 1),
(8440, 1),
(8441, 1),
(8442, 1),
(8443, 1),
(8444, 1),
(8445, 1),
(8446, 1),
(8447, 1),
(8448, 1),
(8449, 1),
(8450, 1),
(8451, 1),
(8452, 1),
(8453, 1),
(8454, 1),
(8455, 1),
(8456, 1),
(8457, 1),
(8458, 1),
(8459, 1),
(8460, 1),
(8461, 1),
(8462, 1),
(8463, 1),
(8464, 1),
(8465, 1),
(8466, 1),
(8467, 1),
(8468, 1),
(8469, 1),
(8470, 1),
(8471, 1),
(8472, 1),
(8473, 1),
(8474, 1),
(8475, 1),
(8476, 1),
(8477, 1),
(8478, 1),
(8479, 1),
(8480, 1),
(8481, 1),
(8482, 1),
(8483, 1),
(8484, 1),
(8485, 1),
(8486, 1),
(8487, 1),
(8488, 1),
(8489, 1),
(8490, 1),
(8491, 1),
(8492, 1),
(8493, 1),
(8494, 1),
(8495, 1),
(8496, 1),
(8497, 1),
(8498, 1),
(8499, 1),
(8500, 1),
(8501, 1),
(8502, 1),
(8503, 1),
(8504, 1),
(8505, 1),
(8506, 1),
(8507, 1),
(8508, 1),
(8509, 1),
(8510, 1),
(8511, 1),
(8512, 1),
(8513, 1),
(8514, 1),
(8515, 1),
(8516, 1),
(8517, 1),
(8518, 1),
(8519, 1),
(8520, 1),
(8521, 1),
(8522, 1),
(8523, 1),
(8524, 1),
(8525, 1),
(8526, 1),
(8527, 1),
(8528, 1),
(8529, 1),
(8530, 1),
(8531, 1),
(8532, 1),
(8533, 1),
(8534, 1),
(8535, 1),
(8536, 1),
(8537, 1),
(8538, 1),
(8539, 1),
(8540, 1),
(8541, 1),
(8542, 1),
(8543, 1),
(8544, 1),
(8545, 1),
(8546, 1),
(8547, 1),
(8548, 1),
(8549, 1),
(8550, 1),
(8551, 1),
(8552, 1),
(8553, 1),
(8554, 1),
(8555, 1),
(8556, 1),
(8557, 1),
(8558, 1),
(8559, 1),
(8560, 1),
(8561, 1),
(8562, 1),
(8563, 1),
(8564, 1),
(8565, 1),
(8566, 1),
(8567, 1),
(8568, 1),
(8569, 1),
(8570, 1),
(8571, 1),
(8572, 1),
(8573, 1),
(8574, 1),
(8575, 1),
(8576, 1),
(8577, 1),
(8578, 1),
(8579, 1),
(8580, 1),
(8581, 1),
(8582, 1),
(8583, 1),
(8584, 1),
(8585, 1),
(8586, 1),
(8587, 1),
(8588, 1);         
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(8589, 1),
(8590, 1),
(8591, 1),
(8592, 1),
(8593, 1),
(8594, 1),
(8595, 1),
(8596, 1),
(8597, 1),
(8598, 1),
(8599, 1),
(8600, 1),
(8601, 1),
(8602, 1),
(8603, 1),
(8604, 1),
(8605, 1),
(8606, 1),
(8607, 1),
(8608, 1),
(8609, 1),
(8610, 1),
(8611, 1),
(8612, 1),
(8613, 1),
(8614, 1),
(8615, 1),
(8616, 1),
(8617, 1),
(8618, 1),
(8619, 1),
(8620, 1),
(8621, 1),
(8622, 1),
(8623, 1),
(8624, 1),
(8625, 1),
(8626, 1),
(8627, 1),
(8628, 1),
(8629, 1),
(8630, 1),
(8631, 1),
(8632, 1),
(8633, 1),
(8634, 1),
(8635, 1),
(8636, 1),
(8637, 1),
(8638, 1),
(8639, 1),
(8640, 1),
(8641, 1),
(8642, 1),
(8643, 1),
(8644, 1),
(8645, 1),
(8646, 1),
(8647, 1),
(8648, 1),
(8649, 1),
(8650, 1),
(8651, 1),
(8652, 1),
(8653, 1),
(8654, 1),
(8655, 1),
(8656, 1),
(8657, 1),
(8658, 1),
(8659, 1),
(8660, 1),
(8661, 1),
(8662, 1),
(8663, 1),
(8664, 1),
(8665, 1),
(8666, 1),
(8667, 1),
(8668, 1),
(8669, 1),
(8670, 1),
(8671, 1),
(8672, 1),
(8673, 1),
(8674, 1),
(8675, 1),
(8676, 1),
(8677, 1),
(8678, 1),
(8679, 1),
(8680, 1),
(8681, 1),
(8682, 1),
(8683, 1),
(8684, 1),
(8685, 1),
(8686, 1),
(8687, 1),
(8688, 1),
(8689, 1),
(8690, 1),
(8691, 1),
(8692, 1),
(8693, 1),
(8694, 1),
(8695, 1),
(8696, 1),
(8697, 1),
(8698, 1),
(8699, 1),
(8700, 1),
(8701, 1),
(8702, 1),
(8703, 1),
(8704, 1),
(8705, 1),
(8706, 1),
(8707, 1),
(8708, 1),
(8709, 1),
(8710, 1),
(8711, 1),
(8712, 1),
(8713, 1),
(8714, 1),
(8715, 1),
(8716, 1),
(8717, 1),
(8718, 1),
(8719, 1),
(8720, 1),
(8721, 1),
(8722, 1),
(8723, 1),
(8724, 1),
(8725, 1),
(8726, 1),
(8727, 1),
(8728, 1),
(8729, 1),
(8730, 1),
(8731, 1),
(8732, 1),
(8733, 1),
(8734, 1),
(8735, 1),
(8736, 1),
(8737, 1),
(8738, 1),
(8739, 1),
(8740, 1),
(8741, 1),
(8742, 1),
(8743, 1),
(8744, 1),
(8745, 1),
(8746, 1),
(8747, 1),
(8748, 1),
(8749, 1),
(8750, 1),
(8751, 1),
(8752, 1),
(8753, 1),
(8754, 1),
(8755, 1),
(8756, 1),
(8757, 1),
(8758, 1),
(8759, 1),
(8760, 1),
(8761, 1),
(8762, 1),
(8763, 1),
(8764, 1),
(8765, 1),
(8766, 1),
(8767, 1),
(8768, 1),
(8769, 1),
(8770, 1),
(8771, 1),
(8772, 1),
(8773, 1),
(8774, 1),
(8775, 1),
(8776, 1),
(8777, 1),
(8778, 1),
(8779, 1),
(8780, 1),
(8781, 1),
(8782, 1),
(8783, 1),
(8784, 1),
(8785, 1),
(8786, 1),
(8787, 1),
(8788, 1),
(8789, 1),
(8790, 1),
(8791, 1),
(8792, 1),
(8793, 1),
(8794, 1),
(8795, 1),
(8796, 1),
(8797, 1),
(8798, 1),
(8799, 1),
(8800, 1),
(8801, 1),
(8802, 1),
(8803, 1),
(8804, 1),
(8805, 1),
(8806, 1),
(8807, 1),
(8808, 1),
(8809, 1),
(8810, 1),
(8811, 1),
(8812, 1),
(8813, 1),
(8814, 1),
(8815, 1),
(8816, 1),
(8817, 1),
(8818, 1),
(8819, 1),
(8820, 1),
(8821, 1),
(8822, 1),
(8823, 1),
(8824, 1),
(8825, 1),
(8826, 1),
(8827, 1),
(8828, 1),
(8829, 1),
(8830, 1),
(8831, 1),
(8832, 1),
(8833, 1),
(8834, 1),
(8835, 1),
(8836, 1),
(8837, 1),
(8838, 1),
(8839, 1),
(8840, 1),
(8841, 1),
(8842, 1),
(8843, 1),
(8844, 1),
(8845, 1),
(8846, 1),
(8847, 1),
(8848, 1),
(8849, 1),
(8850, 1),
(8851, 1),
(8852, 1),
(8853, 1),
(8854, 1),
(8855, 1),
(8856, 1),
(8857, 1),
(8858, 1),
(8859, 1),
(8860, 1),
(8861, 1),
(8862, 1),
(8863, 1),
(8864, 1),
(8865, 1),
(8866, 1),
(8867, 1),
(8868, 1),
(8869, 1),
(8870, 1),
(8871, 1),
(8872, 1),
(8873, 1),
(8874, 1),
(8875, 1),
(8876, 1),
(8877, 1),
(8878, 1),
(8879, 1),
(8880, 1),
(8881, 1),
(8882, 1),
(8883, 1),
(8884, 1),
(8885, 1),
(8886, 1),
(8887, 1),
(8888, 1),
(8889, 1),
(8890, 1),
(8891, 1),
(8892, 1),
(8893, 1),
(8894, 1),
(8895, 1),
(8896, 1),
(8897, 1),
(8898, 1),
(8899, 1),
(8900, 1),
(8901, 1),
(8902, 1),
(8903, 1),
(8904, 1),
(8905, 1),
(8906, 1),
(8907, 1),
(8908, 1),
(8909, 1),
(8910, 1),
(8911, 1),
(8912, 1),
(8913, 1),
(8914, 1),
(8915, 1),
(8916, 1),
(8917, 1),
(8918, 1),
(8919, 1),
(8920, 1),
(8921, 1),
(8922, 1),
(8923, 1),
(8924, 1),
(8925, 1),
(8926, 1),
(8927, 1),
(8928, 1),
(8929, 1),
(8930, 1),
(8931, 1),
(8932, 1),
(8933, 1),
(8934, 1),
(8935, 1),
(8936, 1),
(8937, 1),
(8938, 1),
(8939, 1),
(8940, 1),
(8941, 1),
(8942, 1),
(8943, 1),
(8944, 1),
(8945, 1),
(8946, 1),
(8947, 1),
(8948, 1),
(8949, 1),
(8950, 1),
(8951, 1),
(8952, 1),
(8953, 1),
(8954, 1),
(8955, 1),
(8956, 1),
(8957, 1);         
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(8958, 1),
(8959, 1),
(8960, 1),
(8961, 1),
(8962, 1),
(8963, 1),
(8964, 1),
(8965, 1),
(8966, 1),
(8967, 1),
(8968, 1),
(8969, 1),
(8970, 1),
(8971, 1),
(8972, 1),
(8973, 1),
(8974, 1),
(8975, 1),
(8976, 1),
(8977, 1),
(8978, 1),
(8979, 1),
(8980, 1),
(8981, 1),
(8982, 1),
(8983, 1),
(8984, 1),
(8985, 1),
(8986, 1),
(8987, 1),
(8988, 1),
(8989, 1),
(8990, 1),
(8991, 1),
(8992, 1),
(8993, 1),
(8994, 1),
(8995, 1),
(8996, 1),
(8997, 1),
(8998, 1),
(8999, 1),
(9000, 1),
(9001, 1),
(9002, 1),
(9003, 1),
(9004, 1),
(9005, 1),
(9006, 1),
(9007, 1),
(9008, 1),
(9009, 1),
(9010, 1),
(9011, 1),
(9012, 1),
(9013, 1),
(9014, 1),
(9015, 1),
(9016, 1),
(9017, 1),
(9018, 1),
(9019, 1),
(9020, 1),
(9021, 1),
(9022, 1),
(9023, 1),
(9024, 1),
(9025, 1),
(9026, 1),
(9027, 1),
(9028, 1),
(9029, 1),
(9030, 1),
(9031, 1),
(9032, 1),
(9033, 1),
(9034, 1),
(9035, 1),
(9036, 1),
(9037, 1),
(9038, 1),
(9039, 1),
(9040, 1),
(9041, 1),
(9042, 1),
(9043, 1),
(9044, 1),
(9045, 1),
(9046, 1),
(9047, 1),
(9048, 1),
(9049, 1),
(9050, 1),
(9051, 1),
(9052, 1),
(9053, 1),
(9054, 1),
(9055, 1),
(9056, 1),
(9057, 1),
(9058, 1),
(9059, 1),
(9060, 1),
(9061, 1),
(9062, 1),
(9063, 1),
(9064, 1),
(9065, 1),
(9066, 1),
(9067, 1),
(9068, 1),
(9069, 1),
(9070, 1),
(9071, 1),
(9072, 1),
(9073, 1),
(9074, 1),
(9075, 1),
(9076, 1),
(9077, 1),
(9078, 1),
(9079, 1),
(9080, 1),
(9081, 1),
(9082, 1),
(9083, 1),
(9084, 1),
(9085, 1),
(9086, 1),
(9087, 1),
(9088, 1),
(9089, 1),
(9090, 1),
(9091, 1),
(9092, 1),
(9093, 1),
(9094, 1),
(9095, 1),
(9096, 1),
(9097, 1),
(9098, 1),
(9099, 1),
(9100, 1),
(9101, 1),
(9102, 1),
(9103, 1),
(9104, 1),
(9105, 1),
(9106, 1),
(9107, 1),
(9108, 1),
(9109, 1),
(9110, 1),
(9111, 1),
(9112, 1),
(9113, 1),
(9114, 1),
(9115, 1),
(9116, 1),
(9117, 1),
(9118, 1),
(9119, 1),
(9120, 1),
(9121, 1),
(9122, 1),
(9123, 1),
(9124, 1),
(9125, 1),
(9126, 1),
(9127, 1),
(9128, 1),
(9129, 1),
(9130, 1),
(9131, 1),
(9132, 1),
(9133, 1),
(9134, 1),
(9135, 1),
(9136, 1),
(9137, 1),
(9138, 1),
(9139, 1),
(9140, 1),
(9141, 1),
(9142, 1),
(9143, 1),
(9144, 1),
(9145, 1),
(9146, 1),
(9147, 1),
(9148, 1),
(9149, 1),
(9150, 1),
(9151, 1),
(9152, 1),
(9153, 1),
(9154, 1),
(9155, 1),
(9156, 1),
(9157, 1),
(9158, 1),
(9159, 1),
(9160, 1),
(9161, 1),
(9162, 1),
(9163, 1),
(9164, 1),
(9165, 1),
(9166, 1),
(9167, 1),
(9168, 1),
(9169, 1),
(9170, 1),
(9171, 1),
(9172, 1),
(9173, 1),
(9174, 1),
(9175, 1),
(9176, 1),
(9177, 1),
(9178, 1),
(9179, 1),
(9180, 1),
(9181, 1),
(9182, 1),
(9183, 1),
(9184, 1),
(9185, 1),
(9186, 1),
(9187, 1),
(9188, 1),
(9189, 1),
(9190, 1),
(9191, 1),
(9192, 1),
(9193, 1),
(9194, 1),
(9195, 1),
(9196, 1),
(9197, 1),
(9198, 1),
(9199, 1),
(9200, 1),
(9201, 1),
(9202, 1),
(9203, 1),
(9204, 1),
(9205, 1),
(9206, 1),
(9207, 1),
(9208, 1),
(9209, 1),
(9210, 1),
(9211, 1),
(9212, 1),
(9213, 1),
(9214, 1),
(9215, 1),
(9216, 1),
(9217, 1),
(9218, 1),
(9219, 1),
(9220, 1),
(9221, 1),
(9222, 1),
(9223, 1),
(9224, 1),
(9225, 1),
(9226, 1),
(9227, 1),
(9228, 1),
(9229, 1),
(9230, 1),
(9231, 1),
(9232, 1),
(9233, 1),
(9234, 1),
(9235, 1),
(9236, 1),
(9237, 1),
(9238, 1),
(9239, 1),
(9240, 1),
(9241, 1),
(9242, 1),
(9243, 1),
(9244, 1),
(9245, 1),
(9246, 1),
(9247, 1),
(9248, 1),
(9249, 1),
(9250, 1),
(9251, 1),
(9252, 1),
(9253, 1),
(9254, 1),
(9255, 1),
(9256, 1),
(9257, 1),
(9258, 1),
(9259, 1),
(9260, 1),
(9261, 1),
(9262, 1),
(9263, 1),
(9264, 1),
(9265, 1),
(9266, 1),
(9267, 1),
(9268, 1),
(9269, 1),
(9270, 1),
(9271, 1),
(9272, 1),
(9273, 1),
(9274, 1),
(9275, 1),
(9276, 1),
(9277, 1),
(9278, 1),
(9279, 1),
(9280, 1),
(9281, 1),
(9282, 1),
(9283, 1),
(9284, 1),
(9285, 1),
(9286, 1),
(9287, 1),
(9288, 1),
(9289, 1),
(9290, 1),
(9291, 1),
(9292, 1),
(9293, 1),
(9294, 1),
(9295, 1),
(9296, 1),
(9297, 1),
(9298, 1),
(9299, 1),
(9300, 1),
(9301, 1),
(9302, 1),
(9303, 1),
(9304, 1),
(9305, 1),
(9306, 1),
(9307, 1),
(9308, 1),
(9309, 1),
(9310, 1),
(9311, 1),
(9312, 1),
(9313, 1),
(9314, 1),
(9315, 1),
(9316, 1),
(9317, 1),
(9318, 1),
(9319, 1),
(9320, 1),
(9321, 1),
(9322, 1),
(9323, 1),
(9324, 1),
(9325, 1),
(9326, 1);         
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(9327, 1),
(9328, 1),
(9329, 1),
(9330, 1),
(9331, 1),
(9332, 1),
(9333, 1),
(9334, 1),
(9335, 1),
(9336, 1),
(9337, 1),
(9338, 1),
(9339, 1),
(9340, 1),
(9341, 1),
(9342, 1),
(9343, 1),
(9344, 1),
(9345, 1),
(9346, 1),
(9347, 1),
(9348, 1),
(9349, 1),
(9350, 1),
(9351, 1),
(9352, 1),
(9353, 1),
(9354, 1),
(9355, 1),
(9356, 1),
(9357, 1),
(9358, 1),
(9359, 1),
(9360, 1),
(9361, 1),
(9362, 1),
(9363, 1),
(9364, 1),
(9365, 1),
(9366, 1),
(9367, 1),
(9368, 1),
(9369, 1),
(9370, 1),
(9371, 1),
(9372, 1),
(9373, 1),
(9374, 1),
(9375, 1),
(9376, 1),
(9377, 1),
(9378, 1),
(9379, 1),
(9380, 1),
(9381, 1),
(9382, 1),
(9383, 1),
(9384, 1),
(9385, 1),
(9386, 1),
(9387, 1),
(9388, 1),
(9389, 1),
(9390, 1),
(9391, 1),
(9392, 1),
(9393, 1),
(9394, 1),
(9395, 1),
(9396, 1),
(9397, 1),
(9398, 1),
(9399, 1),
(9400, 1),
(9401, 1),
(9402, 1),
(9403, 1),
(9404, 1),
(9405, 1),
(9406, 1),
(9407, 1),
(9408, 1),
(9409, 1),
(9410, 1),
(9411, 1),
(9412, 1),
(9413, 1),
(9414, 1),
(9415, 1),
(9416, 1),
(9417, 1),
(9418, 1),
(9419, 1),
(9420, 1),
(9421, 1),
(9422, 1),
(9423, 1),
(9424, 1),
(9425, 1),
(9426, 1),
(9427, 1),
(9428, 1),
(9429, 1),
(9430, 1),
(9431, 1),
(9432, 1),
(9433, 1),
(9434, 1),
(9435, 1),
(9436, 1),
(9437, 1),
(9438, 1),
(9439, 1),
(9440, 1),
(9441, 1),
(9442, 1),
(9443, 1),
(9444, 1),
(9445, 1),
(9446, 1),
(9447, 1),
(9448, 1),
(9449, 1),
(9450, 1),
(9451, 1),
(9452, 1),
(9453, 1),
(9454, 1),
(9455, 1),
(9456, 1),
(9457, 1),
(9458, 1),
(9459, 1),
(9460, 1),
(9461, 1),
(9462, 1),
(9463, 1),
(9464, 1),
(9465, 1),
(9466, 1),
(9467, 1),
(9468, 1),
(9469, 1),
(9470, 1),
(9471, 1),
(9472, 1),
(9473, 1),
(9474, 1),
(9475, 1),
(9476, 1),
(9477, 1),
(9478, 1),
(9479, 1),
(9480, 1),
(9481, 1),
(9482, 1),
(9483, 1),
(9484, 1),
(9485, 1),
(9486, 1),
(9487, 1),
(9488, 1),
(9489, 1),
(9490, 1),
(9491, 1),
(9492, 1),
(9493, 1),
(9494, 1),
(9495, 1),
(9496, 1),
(9497, 1),
(9498, 1),
(9499, 1),
(9500, 1),
(9501, 1),
(9502, 1),
(9503, 1),
(9504, 1),
(9505, 1),
(9506, 1),
(9507, 1),
(9508, 1),
(9509, 1),
(9510, 1),
(9511, 1),
(9512, 1),
(9513, 1),
(9514, 1),
(9515, 1),
(9516, 1),
(9517, 1),
(9518, 1),
(9519, 1),
(9520, 1),
(9521, 1),
(9522, 1),
(9523, 1),
(9524, 1),
(9525, 1),
(9526, 1),
(9527, 1),
(9528, 1),
(9529, 1),
(9530, 1),
(9531, 1),
(9532, 1),
(9533, 1),
(9534, 1),
(9535, 1),
(9536, 1),
(9537, 1),
(9538, 1),
(9539, 1),
(9540, 1),
(9541, 1),
(9542, 1),
(9543, 1),
(9544, 1),
(9545, 1),
(9546, 1),
(9547, 1),
(9548, 1),
(9549, 1),
(9550, 1),
(9551, 1),
(9552, 1),
(9553, 1),
(9554, 1),
(9555, 1),
(9556, 1),
(9557, 1),
(9558, 1),
(9559, 1),
(9560, 1),
(9561, 1),
(9562, 1),
(9563, 1),
(9564, 1),
(9565, 1),
(9566, 1),
(9567, 1),
(9568, 1),
(9569, 1),
(9570, 1),
(9571, 1),
(9572, 1),
(9573, 1),
(9574, 1),
(9575, 1),
(9576, 1),
(9577, 1),
(9578, 1),
(9579, 1),
(9580, 1),
(9581, 1),
(9582, 1),
(9583, 1),
(9584, 1),
(9585, 1),
(9586, 1),
(9587, 1),
(9588, 1),
(9589, 1),
(9590, 1),
(9591, 1),
(9592, 1),
(9593, 1),
(9594, 1),
(9595, 1),
(9596, 1),
(9597, 1),
(9598, 1),
(9599, 1),
(9600, 1),
(9601, 1),
(9602, 1),
(9603, 1),
(9604, 1),
(9605, 1),
(9606, 1),
(9607, 1),
(9608, 1),
(9609, 1),
(9610, 1),
(9611, 1),
(9612, 1),
(9613, 1),
(9614, 1),
(9615, 1),
(9616, 1),
(9617, 1),
(9618, 1),
(9619, 1),
(9620, 1),
(9621, 1),
(9622, 1),
(9623, 1),
(9624, 1),
(9625, 1),
(9626, 1),
(9627, 1),
(9628, 1),
(9629, 1),
(9630, 1),
(9631, 1),
(9632, 1),
(9633, 1),
(9634, 1),
(9635, 1),
(9636, 1),
(9637, 1),
(9638, 1),
(9639, 1),
(9640, 1),
(9641, 1),
(9642, 1),
(9643, 1),
(9644, 1),
(9645, 1),
(9646, 1),
(9647, 1),
(9648, 1),
(9649, 1),
(9650, 1),
(9651, 1),
(9652, 1),
(9653, 1),
(9654, 1),
(9655, 1),
(9656, 1),
(9657, 1),
(9658, 1),
(9659, 1),
(9660, 1),
(9661, 1),
(9662, 1),
(9663, 1),
(9664, 1),
(9665, 1),
(9666, 1),
(9667, 1),
(9668, 1),
(9669, 1),
(9670, 1),
(9671, 1),
(9672, 1),
(9673, 1),
(9674, 1),
(9675, 1),
(9676, 1),
(9677, 1),
(9678, 1),
(9679, 1),
(9680, 1),
(9681, 1),
(9682, 1),
(9683, 1),
(9684, 1),
(9685, 1),
(9686, 1),
(9687, 1),
(9688, 1),
(9689, 1),
(9690, 1),
(9691, 1),
(9692, 1),
(9693, 1),
(9694, 1),
(9695, 1);         
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(9696, 1),
(9697, 1),
(9698, 1),
(9699, 1),
(9700, 1),
(9701, 1),
(9702, 1),
(9703, 1),
(9704, 1),
(9705, 1),
(9706, 1),
(9707, 1),
(9708, 1),
(9709, 1),
(9710, 1),
(9711, 1),
(9712, 1),
(9713, 1),
(9714, 1),
(9715, 1),
(9716, 1),
(9717, 1),
(9718, 1),
(9719, 1),
(9720, 1),
(9721, 1),
(9722, 1),
(9723, 1),
(9724, 1),
(9725, 1),
(9726, 1),
(9727, 1),
(9728, 1),
(9729, 1),
(9730, 1),
(9731, 1),
(9732, 1),
(9733, 1),
(9734, 1),
(9735, 1),
(9736, 1),
(9737, 1),
(9738, 1),
(9739, 1),
(9740, 1),
(9741, 1),
(9742, 1),
(9743, 1),
(9744, 1),
(9745, 1),
(9746, 1),
(9747, 1),
(9748, 1),
(9749, 1),
(9750, 1),
(9751, 1),
(9752, 1),
(9753, 1),
(9754, 1),
(9755, 1),
(9756, 1),
(9757, 1),
(9758, 1),
(9759, 1),
(9760, 1),
(9761, 1),
(9762, 1),
(9763, 1),
(9764, 1),
(9765, 1),
(9766, 1),
(9767, 1),
(9768, 1),
(9769, 1),
(9770, 1),
(9771, 1),
(9772, 1),
(9773, 1),
(9774, 1),
(9775, 1),
(9776, 1),
(9777, 1),
(9778, 1),
(9779, 1),
(9780, 1),
(9781, 1),
(9782, 1),
(9783, 1),
(9784, 1),
(9785, 1),
(9786, 1),
(9787, 1),
(9788, 1),
(9789, 1),
(9790, 1),
(9791, 1),
(9792, 1),
(9793, 1),
(9794, 1),
(9795, 1),
(9796, 1),
(9797, 1),
(9798, 1),
(9799, 1),
(9800, 1),
(9801, 1),
(9802, 1),
(9803, 1),
(9804, 1),
(9805, 1),
(9806, 1),
(9807, 1),
(9808, 1),
(9809, 1),
(9810, 1),
(9811, 1),
(9812, 1),
(9813, 1),
(9814, 1),
(9815, 1),
(9816, 1),
(9817, 1),
(9818, 1),
(9819, 1),
(9820, 1),
(9821, 1),
(9822, 1),
(9823, 1),
(9824, 1),
(9825, 1),
(9826, 1),
(9827, 1),
(9828, 1),
(9829, 1),
(9830, 1),
(9831, 1),
(9832, 1),
(9833, 1),
(9834, 1),
(9835, 1),
(9836, 1),
(9837, 1),
(9838, 1),
(9839, 1),
(9840, 1),
(9841, 1),
(9842, 1),
(9843, 1),
(9844, 1),
(9845, 1),
(9846, 1),
(9847, 1),
(9848, 1),
(9849, 1),
(9850, 1),
(9851, 1),
(9852, 1),
(9853, 1),
(9854, 1),
(9855, 1),
(9856, 1),
(9857, 1),
(9858, 1),
(9859, 1),
(9860, 1),
(9861, 1),
(9862, 1),
(9863, 1),
(9864, 1),
(9865, 1),
(9866, 1),
(9867, 1),
(9868, 1),
(9869, 1),
(9870, 1),
(9871, 1),
(9872, 1),
(9873, 1),
(9874, 1),
(9875, 1),
(9876, 1),
(9877, 1),
(9878, 1),
(9879, 1),
(9880, 1),
(9881, 1),
(9882, 1),
(9883, 1),
(9884, 1),
(9885, 1),
(9886, 1),
(9887, 1),
(9888, 1),
(9889, 1),
(9890, 1),
(9891, 1),
(9892, 1),
(9893, 1),
(9894, 1),
(9895, 1),
(9896, 1),
(9897, 1),
(9898, 1),
(9899, 1),
(9900, 1),
(9901, 1),
(9902, 1),
(9903, 1),
(9904, 1),
(9905, 1),
(9906, 1),
(9907, 1),
(9908, 1),
(9909, 1),
(9910, 1),
(9911, 1),
(9912, 1),
(9913, 1),
(9914, 1),
(9915, 1),
(9916, 1),
(9917, 1),
(9918, 1),
(9919, 1),
(9920, 1),
(9921, 1),
(9922, 1),
(9923, 1),
(9924, 1),
(9925, 1),
(9926, 1),
(9927, 1),
(9928, 1),
(9929, 1),
(9930, 1),
(9931, 1),
(9932, 1),
(9933, 1),
(9934, 1),
(9935, 1),
(9936, 1),
(9937, 1),
(9938, 1),
(9939, 1),
(9940, 1),
(9941, 1),
(9942, 1),
(9943, 1),
(9944, 1),
(9945, 1),
(9946, 1),
(9947, 1),
(9948, 1),
(9949, 1),
(9950, 1),
(9951, 1),
(9952, 1),
(9953, 1),
(9954, 1),
(9955, 1),
(9956, 1),
(9957, 1),
(9958, 1),
(9959, 1),
(9960, 1),
(9961, 1),
(9962, 1),
(9963, 1),
(9964, 1),
(9965, 1),
(9966, 1),
(9967, 1),
(9968, 1),
(9969, 1),
(9970, 1),
(9971, 1),
(9972, 1),
(9973, 1),
(9974, 1),
(9975, 1),
(9976, 1),
(9977, 1),
(9978, 1),
(9979, 1),
(9980, 1),
(9981, 1),
(9982, 1),
(9983, 1),
(9984, 1),
(9985, 1),
(9986, 1),
(9987, 1),
(9988, 1),
(9989, 1),
(9990, 1),
(9991, 1),
(9992, 1),
(9993, 1),
(9994, 1),
(9995, 1),
(9996, 1),
(9997, 1),
(9998, 1),
(9999, 1),
(10000, 1),
(10001, 1),
(10002, 1),
(10003, 1),
(10004, 1),
(10005, 1),
(10006, 1),
(10007, 1),
(10008, 1),
(10009, 1),
(10010, 1),
(10011, 1),
(10012, 1),
(10013, 1),
(10014, 1),
(10015, 1),
(10016, 1),
(10017, 1),
(10018, 1),
(10019, 1),
(10020, 1),
(10021, 1),
(10022, 1),
(10023, 1),
(10024, 1),
(10025, 1),
(10026, 1),
(10027, 1),
(10028, 1),
(10029, 1),
(10030, 1),
(10031, 1),
(10032, 1),
(10033, 1),
(10034, 1),
(10035, 1),
(10036, 1),
(10037, 1),
(10038, 1),
(10039, 1),
(10040, 1),
(10041, 1),
(10042, 1),
(10043, 1),
(10044, 1),
(10045, 1),
(10046, 1),
(10047, 1),
(10048, 1),
(10049, 1),
(10050, 1),
(10051, 1),
(10052, 1),
(10053, 1),
(10054, 1),
(10055, 1),
(10056, 1),
(10057, 1),
(10058, 1),
(10059, 1);    
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(10060, 1),
(10061, 1),
(10062, 1),
(10063, 1),
(10064, 1),
(10065, 1),
(10066, 1),
(10067, 1),
(10068, 1),
(10069, 1),
(10070, 1),
(10071, 1),
(10072, 1),
(10073, 1),
(10074, 1),
(10075, 1),
(10076, 1),
(10077, 1),
(10078, 1),
(10079, 1),
(10080, 1),
(10081, 1),
(10082, 1),
(10083, 1),
(10084, 1),
(10085, 1),
(10086, 1),
(10087, 1),
(10088, 1),
(10089, 1),
(10090, 1),
(10091, 1),
(10092, 1),
(10093, 1),
(10094, 1),
(10095, 1),
(10096, 1),
(10097, 1),
(10098, 1),
(10099, 1),
(10100, 1),
(10101, 1),
(10102, 1),
(10103, 1),
(10104, 1),
(10105, 1),
(10106, 1),
(10107, 1),
(10108, 1),
(10109, 1),
(10110, 1),
(10111, 1),
(10112, 1),
(10113, 1),
(10114, 1),
(10115, 1),
(10116, 1),
(10117, 1),
(10118, 1),
(10119, 1),
(10120, 1),
(10121, 1),
(10122, 1),
(10123, 1),
(10124, 1),
(10125, 1),
(10126, 1),
(10127, 1),
(10128, 1),
(10129, 1),
(10130, 1),
(10131, 1),
(10132, 1),
(10133, 1),
(10134, 1),
(10135, 1),
(10136, 1),
(10137, 1),
(10138, 1),
(10139, 1),
(10140, 1),
(10141, 1),
(10142, 1),
(10143, 1),
(10144, 1),
(10145, 1),
(10146, 1),
(10147, 1),
(10148, 1),
(10149, 1),
(10150, 1),
(10151, 1),
(10152, 1),
(10153, 1),
(10154, 1),
(10155, 1),
(10156, 1),
(10157, 1),
(10158, 1),
(10159, 1),
(10160, 1),
(10161, 1),
(10162, 1),
(10163, 1),
(10164, 1),
(10165, 1),
(10166, 1),
(10167, 1),
(10168, 1),
(10169, 1),
(10170, 1),
(10171, 1),
(10172, 1),
(10173, 1),
(10174, 1),
(10175, 1),
(10176, 1),
(10177, 1),
(10178, 1),
(10179, 1),
(10180, 1),
(10181, 1),
(10182, 1),
(10183, 1),
(10184, 1),
(10185, 1),
(10186, 1),
(10187, 1),
(10188, 1),
(10189, 1),
(10190, 1),
(10191, 1),
(10192, 1),
(10193, 1),
(10194, 1),
(10195, 1),
(10196, 1),
(10197, 1),
(10198, 1),
(10199, 1),
(10200, 1),
(10201, 1),
(10202, 1),
(10203, 1),
(10204, 1),
(10205, 1),
(10206, 1),
(10207, 1),
(10208, 1),
(10209, 1),
(10210, 1),
(10211, 1),
(10212, 1),
(10213, 1),
(10214, 1),
(10215, 1),
(10216, 1),
(10217, 1),
(10218, 1),
(10219, 1),
(10220, 1),
(10221, 1),
(10222, 1),
(10223, 1),
(10224, 1),
(10225, 1),
(10226, 1),
(10227, 1),
(10228, 1),
(10229, 1),
(10230, 1),
(10231, 1),
(10232, 1),
(10233, 1),
(10234, 1),
(10235, 1),
(10236, 1),
(10237, 1),
(10238, 1),
(10239, 1),
(10240, 1),
(10241, 1),
(10242, 1),
(10243, 1),
(10244, 1),
(10245, 1),
(10246, 1),
(10247, 1),
(10248, 1),
(10249, 1),
(10250, 1),
(10251, 1),
(10252, 1),
(10253, 1),
(10254, 1),
(10255, 1),
(10256, 1),
(10257, 1),
(10258, 1),
(10259, 1),
(10260, 1),
(10261, 1),
(10262, 1),
(10263, 1),
(10264, 1),
(10265, 1),
(10266, 1),
(10267, 1),
(10268, 1),
(10269, 1),
(10270, 1),
(10271, 1),
(10272, 1),
(10273, 1),
(10274, 1),
(10275, 1),
(10276, 1),
(10277, 1),
(10278, 1),
(10279, 1),
(10280, 1),
(10281, 1),
(10282, 1),
(10283, 1),
(10284, 1),
(10285, 1),
(10286, 1),
(10287, 1),
(10288, 1),
(10289, 1),
(10290, 1),
(10291, 1),
(10292, 1),
(10293, 1),
(10294, 1),
(10295, 1),
(10296, 1),
(10297, 1),
(10298, 1),
(10299, 1),
(10300, 1),
(10301, 1),
(10302, 1),
(10303, 1),
(10304, 1),
(10305, 1),
(10306, 1),
(10307, 1),
(10308, 1),
(10309, 1),
(10310, 1),
(10311, 1),
(10312, 1),
(10313, 1),
(10314, 1),
(10315, 1),
(10316, 1),
(10317, 1),
(10318, 1),
(10319, 1),
(10320, 1),
(10321, 1),
(10322, 1),
(10323, 1),
(10324, 1),
(10325, 1),
(10326, 1),
(10327, 1),
(10328, 1),
(10329, 1),
(10330, 1),
(10331, 1),
(10332, 1),
(10333, 1),
(10334, 1),
(10335, 1),
(10336, 1),
(10337, 1),
(10338, 1),
(10339, 1),
(10340, 1),
(10341, 1),
(10342, 1),
(10343, 1),
(10344, 1),
(10345, 1),
(10346, 1),
(10347, 1),
(10348, 1),
(10349, 1),
(10350, 1),
(10351, 1),
(10352, 1),
(10353, 1),
(10354, 1),
(10355, 1),
(10356, 1),
(10357, 1),
(10358, 1),
(10359, 1),
(10360, 1),
(10361, 1),
(10362, 1),
(10363, 1),
(10364, 1),
(10365, 1),
(10366, 1),
(10367, 1),
(10368, 1),
(10369, 1),
(10370, 1),
(10371, 1),
(10372, 1),
(10373, 1),
(10374, 1),
(10375, 1),
(10376, 1),
(10377, 1),
(10378, 1),
(10379, 1),
(10380, 1),
(10381, 1),
(10382, 1),
(10383, 1),
(10384, 1),
(10385, 1),
(10386, 1),
(10387, 1),
(10388, 1),
(10389, 1),
(10390, 1),
(10391, 1),
(10392, 1),
(10393, 1),
(10394, 1),
(10395, 1),
(10396, 1),
(10397, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(10398, 1),
(10399, 1),
(10400, 1),
(10401, 1),
(10402, 1),
(10403, 1),
(10404, 1),
(10405, 1),
(10406, 1),
(10407, 1),
(10408, 1),
(10409, 1),
(10410, 1),
(10411, 1),
(10412, 1),
(10413, 1),
(10414, 1),
(10415, 1),
(10416, 1),
(10417, 1),
(10418, 1),
(10419, 1),
(10420, 1),
(10421, 1),
(10422, 1),
(10423, 1),
(10424, 1),
(10425, 1),
(10426, 1),
(10427, 1),
(10428, 1),
(10429, 1),
(10430, 1),
(10431, 1),
(10432, 1),
(10433, 1),
(10434, 1),
(10435, 1),
(10436, 1),
(10437, 1),
(10438, 1),
(10439, 1),
(10440, 1),
(10441, 1),
(10442, 1),
(10443, 1),
(10444, 1),
(10445, 1),
(10446, 1),
(10447, 1),
(10448, 1),
(10449, 1),
(10450, 1),
(10451, 1),
(10452, 1),
(10453, 1),
(10454, 1),
(10455, 1),
(10456, 1),
(10457, 1),
(10458, 1),
(10459, 1),
(10460, 1),
(10461, 1),
(10462, 1),
(10463, 1),
(10464, 1),
(10465, 1),
(10466, 1),
(10467, 1),
(10468, 1),
(10469, 1),
(10470, 1),
(10471, 1),
(10472, 1),
(10473, 1),
(10474, 1),
(10475, 1),
(10476, 1),
(10477, 1),
(10478, 1),
(10479, 1),
(10480, 1),
(10481, 1),
(10482, 1),
(10483, 1),
(10484, 1),
(10485, 1),
(10486, 1),
(10487, 1),
(10488, 1),
(10489, 1),
(10490, 1),
(10491, 1),
(10492, 1),
(10493, 1),
(10494, 1),
(10495, 1),
(10496, 1),
(10497, 1),
(10498, 1),
(10499, 1),
(10500, 1),
(10501, 1),
(10502, 1),
(10503, 1),
(10504, 1),
(10505, 1),
(10506, 1),
(10507, 1),
(10508, 1),
(10509, 1),
(10510, 1),
(10511, 1),
(10512, 1),
(10513, 1),
(10514, 1),
(10515, 1),
(10516, 1),
(10517, 1),
(10518, 1),
(10519, 1),
(10520, 1),
(10521, 1),
(10522, 1),
(10523, 1),
(10524, 1),
(10525, 1),
(10526, 1),
(10527, 1),
(10528, 1),
(10529, 1),
(10530, 1),
(10531, 1),
(10532, 1),
(10533, 1),
(10534, 1),
(10535, 1),
(10536, 1),
(10537, 1),
(10538, 1),
(10539, 1),
(10540, 1),
(10541, 1),
(10542, 1),
(10543, 1),
(10544, 1),
(10545, 1),
(10546, 1),
(10547, 1),
(10548, 1),
(10549, 1),
(10550, 1),
(10551, 1),
(10552, 1),
(10553, 1),
(10554, 1),
(10555, 1),
(10556, 1),
(10557, 1),
(10558, 1),
(10559, 1),
(10560, 1),
(10561, 1),
(10562, 1),
(10563, 1),
(10564, 1),
(10565, 1),
(10566, 1),
(10567, 1),
(10568, 1),
(10569, 1),
(10570, 1),
(10571, 1),
(10572, 1),
(10573, 1),
(10574, 1),
(10575, 1),
(10576, 1),
(10577, 1),
(10578, 1),
(10579, 1),
(10580, 1),
(10581, 1),
(10582, 1),
(10583, 1),
(10584, 1),
(10585, 1),
(10586, 1),
(10587, 1),
(10588, 1),
(10589, 1),
(10590, 1),
(10591, 1),
(10592, 1),
(10593, 1),
(10594, 1),
(10595, 1),
(10596, 1),
(10597, 1),
(10598, 1),
(10599, 1),
(10600, 1),
(10601, 1),
(10602, 1),
(10603, 1),
(10604, 1),
(10605, 1),
(10606, 1),
(10607, 1),
(10608, 1),
(10609, 1),
(10610, 1),
(10611, 1),
(10612, 1),
(10613, 1),
(10614, 1),
(10615, 1),
(10616, 1),
(10617, 1),
(10618, 1),
(10619, 1),
(10620, 1),
(10621, 1),
(10622, 1),
(10623, 1),
(10624, 1),
(10625, 1),
(10626, 1),
(10627, 1),
(10628, 1),
(10629, 1),
(10630, 1),
(10631, 1),
(10632, 1),
(10633, 1),
(10634, 1),
(10635, 1),
(10636, 1),
(10637, 1),
(10638, 1),
(10639, 1),
(10640, 1),
(10641, 1),
(10642, 1),
(10643, 1),
(10644, 1),
(10645, 1),
(10646, 1),
(10647, 1),
(10648, 1),
(10649, 1),
(10650, 1),
(10651, 1),
(10652, 1),
(10653, 1),
(10654, 1),
(10655, 1),
(10656, 1),
(10657, 1),
(10658, 1),
(10659, 1),
(10660, 1),
(10661, 1),
(10662, 1),
(10663, 1),
(10664, 1),
(10665, 1),
(10666, 1),
(10667, 1),
(10668, 1),
(10669, 1),
(10670, 1),
(10671, 1),
(10672, 1),
(10673, 1),
(10674, 1),
(10675, 1),
(10676, 1),
(10677, 1),
(10678, 1),
(10679, 1),
(10680, 1),
(10681, 1),
(10682, 1),
(10683, 1),
(10684, 1),
(10685, 1),
(10686, 1),
(10687, 1),
(10688, 1),
(10689, 1),
(10690, 1),
(10691, 1),
(10692, 1),
(10693, 1),
(10694, 1),
(10695, 1),
(10696, 1),
(10697, 1),
(10698, 1),
(10699, 1),
(10700, 1),
(10701, 1),
(10702, 1),
(10703, 1),
(10704, 1),
(10705, 1),
(10706, 1),
(10707, 1),
(10708, 1),
(10709, 1),
(10710, 1),
(10711, 1),
(10712, 1),
(10713, 1),
(10714, 1),
(10715, 1),
(10716, 1),
(10717, 1),
(10718, 1),
(10719, 1),
(10720, 1),
(10721, 1),
(10722, 1),
(10723, 1),
(10724, 1),
(10725, 1),
(10726, 1),
(10727, 1),
(10728, 1),
(10729, 1),
(10730, 1),
(10731, 1),
(10732, 1),
(10733, 1),
(10734, 1),
(10735, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(10736, 1),
(10737, 1),
(10738, 1),
(10739, 1),
(10740, 1),
(10741, 1),
(10742, 1),
(10743, 1),
(10744, 1),
(10745, 1),
(10746, 1),
(10747, 1),
(10748, 1),
(10749, 1),
(10750, 1),
(10751, 1),
(10752, 1),
(10753, 1),
(10754, 1),
(10755, 1),
(10756, 1),
(10757, 1),
(10758, 1),
(10759, 1),
(10760, 1),
(10761, 1),
(10762, 1),
(10763, 1),
(10764, 1),
(10765, 1),
(10766, 1),
(10767, 1),
(10768, 1),
(10769, 1),
(10770, 1),
(10771, 1),
(10772, 1),
(10773, 1),
(10774, 1),
(10775, 1),
(10776, 1),
(10777, 1),
(10778, 1),
(10779, 1),
(10780, 1),
(10781, 1),
(10782, 1),
(10783, 1),
(10784, 1),
(10785, 1),
(10786, 1),
(10787, 1),
(10788, 1),
(10789, 1),
(10790, 1),
(10791, 1),
(10792, 1),
(10793, 1),
(10794, 1),
(10795, 1),
(10796, 1),
(10797, 1),
(10798, 1),
(10799, 1),
(10800, 1),
(10801, 1),
(10802, 1),
(10803, 1),
(10804, 1),
(10805, 1),
(10806, 1),
(10807, 1),
(10808, 1),
(10809, 1),
(10810, 1),
(10811, 1),
(10812, 1),
(10813, 1),
(10814, 1),
(10815, 1),
(10816, 1),
(10817, 1),
(10818, 1),
(10819, 1),
(10820, 1),
(10821, 1),
(10822, 1),
(10823, 1),
(10824, 1),
(10825, 1),
(10826, 1),
(10827, 1),
(10828, 1),
(10829, 1),
(10830, 1),
(10831, 1),
(10832, 1),
(10833, 1),
(10834, 1),
(10835, 1),
(10836, 1),
(10837, 1),
(10838, 1),
(10839, 1),
(10840, 1),
(10841, 1),
(10842, 1),
(10843, 1),
(10844, 1),
(10845, 1),
(10846, 1),
(10847, 1),
(10848, 1),
(10849, 1),
(10850, 1),
(10851, 1),
(10852, 1),
(10853, 1),
(10854, 1),
(10855, 1),
(10856, 1),
(10857, 1),
(10858, 1),
(10859, 1),
(10860, 1),
(10861, 1),
(10862, 1),
(10863, 1),
(10864, 1),
(10865, 1),
(10866, 1),
(10867, 1),
(10868, 1),
(10869, 1),
(10870, 1),
(10871, 1),
(10872, 1),
(10873, 1),
(10874, 1),
(10875, 1),
(10876, 1),
(10877, 1),
(10878, 1),
(10879, 1),
(10880, 1),
(10881, 1),
(10882, 1),
(10883, 1),
(10884, 1),
(10885, 1),
(10886, 1),
(10887, 1),
(10888, 1),
(10889, 1),
(10890, 1),
(10891, 1),
(10892, 1),
(10893, 1),
(10894, 1),
(10895, 1),
(10896, 1),
(10897, 1),
(10898, 1),
(10899, 1),
(10900, 1),
(10901, 1),
(10902, 1),
(10903, 1),
(10904, 1),
(10905, 1),
(10906, 1),
(10907, 1),
(10908, 1),
(10909, 1),
(10910, 1),
(10911, 1),
(10912, 1),
(10913, 1),
(10914, 1),
(10915, 1),
(10916, 1),
(10917, 1),
(10918, 1),
(10919, 1),
(10920, 1),
(10921, 1),
(10922, 1),
(10923, 1),
(10924, 1),
(10925, 1),
(10926, 1),
(10927, 1),
(10928, 1),
(10929, 1),
(10930, 1),
(10931, 1),
(10932, 1),
(10933, 1),
(10934, 1),
(10935, 1),
(10936, 1),
(10937, 1),
(10938, 1),
(10939, 1),
(10940, 1),
(10941, 1),
(10942, 1),
(10943, 1),
(10944, 1),
(10945, 1),
(10946, 1),
(10947, 1),
(10948, 1),
(10949, 1),
(10950, 1),
(10951, 1),
(10952, 1),
(10953, 1),
(10954, 1),
(10955, 1),
(10956, 1),
(10957, 1),
(10958, 1),
(10959, 1),
(10960, 1),
(10961, 1),
(10962, 1),
(10963, 1),
(10964, 1),
(10965, 1),
(10966, 1),
(10967, 1),
(10968, 1),
(10969, 1),
(10970, 1),
(10971, 1),
(10972, 1),
(10973, 1),
(10974, 1),
(10975, 1),
(10976, 1),
(10977, 1),
(10978, 1),
(10979, 1),
(10980, 1),
(10981, 1),
(10982, 1),
(10983, 1),
(10984, 1),
(10985, 1),
(10986, 1),
(10987, 1),
(10988, 1),
(10989, 1),
(10990, 1),
(10991, 1),
(10992, 1),
(10993, 1),
(10994, 1),
(10995, 1),
(10996, 1),
(10997, 1),
(10998, 1),
(10999, 1),
(11000, 1),
(11001, 1),
(11002, 1),
(11003, 1),
(11004, 1),
(11005, 1),
(11006, 1),
(11007, 1),
(11008, 1),
(11009, 1),
(11010, 1),
(11011, 1),
(11012, 1),
(11013, 1),
(11014, 1),
(11015, 1),
(11016, 1),
(11017, 1),
(11018, 1),
(11019, 1),
(11020, 1),
(11021, 1),
(11022, 1),
(11023, 1),
(11024, 1),
(11025, 1),
(11026, 1),
(11027, 1),
(11028, 1),
(11029, 1),
(11030, 1),
(11031, 1),
(11032, 1),
(11033, 1),
(11034, 1),
(11035, 1),
(11036, 1),
(11037, 1),
(11038, 1),
(11039, 1),
(11040, 1),
(11041, 1),
(11042, 1),
(11043, 1),
(11044, 1),
(11045, 1),
(11046, 1),
(11047, 1),
(11048, 1),
(11049, 1),
(11050, 1),
(11051, 1),
(11052, 1),
(11053, 1),
(11054, 1),
(11055, 1),
(11056, 1),
(11057, 1),
(11058, 1),
(11059, 1),
(11060, 1),
(11061, 1),
(11062, 1),
(11063, 1),
(11064, 1),
(11065, 1),
(11066, 1),
(11067, 1),
(11068, 1),
(11069, 1),
(11070, 1),
(11071, 1),
(11072, 1),
(11073, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(11074, 1),
(11075, 1),
(11076, 1),
(11077, 1),
(11078, 1),
(11079, 1),
(11080, 1),
(11081, 1),
(11082, 1),
(11083, 1),
(11084, 1),
(11085, 1),
(11086, 1),
(11087, 1),
(11088, 1),
(11089, 1),
(11090, 1),
(11091, 1),
(11092, 1),
(11093, 1),
(11094, 1),
(11095, 1),
(11096, 1),
(11097, 1),
(11098, 1),
(11099, 1),
(11100, 1),
(11101, 1),
(11102, 1),
(11103, 1),
(11104, 1),
(11105, 1),
(11106, 1),
(11107, 1),
(11108, 1),
(11109, 1),
(11110, 1),
(11111, 1),
(11112, 1),
(11113, 1),
(11114, 1),
(11115, 1),
(11116, 1),
(11117, 1),
(11118, 1),
(11119, 1),
(11120, 1),
(11121, 1),
(11122, 1),
(11123, 1),
(11124, 1),
(11125, 1),
(11126, 1),
(11127, 1),
(11128, 1),
(11129, 1),
(11130, 1),
(11131, 1),
(11132, 1),
(11133, 1),
(11134, 1),
(11135, 1),
(11136, 1),
(11137, 1),
(11138, 1),
(11139, 1),
(11140, 1),
(11141, 1),
(11142, 1),
(11143, 1),
(11144, 1),
(11145, 1),
(11146, 1),
(11147, 1),
(11148, 1),
(11149, 1),
(11150, 1),
(11151, 1),
(11152, 1),
(11153, 1),
(11154, 1),
(11155, 1),
(11156, 1),
(11157, 1),
(11158, 1),
(11159, 1),
(11160, 1),
(11161, 1),
(11162, 1),
(11163, 1),
(11164, 1),
(11165, 1),
(11166, 1),
(11167, 1),
(11168, 1),
(11169, 1),
(11170, 1),
(11171, 1),
(11172, 1),
(11173, 1),
(11174, 1),
(11175, 1),
(11176, 1),
(11177, 1),
(11178, 1),
(11179, 1),
(11180, 1),
(11181, 1),
(11182, 1),
(11183, 1),
(11184, 1),
(11185, 1),
(11186, 1),
(11187, 1),
(11188, 1),
(11189, 1),
(11190, 1),
(11191, 1),
(11192, 1),
(11193, 1),
(11194, 1),
(11195, 1),
(11196, 1),
(11197, 1),
(11198, 1),
(11199, 1),
(11200, 1),
(11201, 1),
(11202, 1),
(11203, 1),
(11204, 1),
(11205, 1),
(11206, 1),
(11207, 1),
(11208, 1),
(11209, 1),
(11210, 1),
(11211, 1),
(11212, 1),
(11213, 1),
(11214, 1),
(11215, 1),
(11216, 1),
(11217, 1),
(11218, 1),
(11219, 1),
(11220, 1),
(11221, 1),
(11222, 1),
(11223, 1),
(11224, 1),
(11225, 1),
(11226, 1),
(11227, 1),
(11228, 1),
(11229, 1),
(11230, 1),
(11231, 1),
(11232, 1),
(11233, 1),
(11234, 1),
(11235, 1),
(11236, 1),
(11237, 1),
(11238, 1),
(11239, 1),
(11240, 1),
(11241, 1),
(11242, 1),
(11243, 1),
(11244, 1),
(11245, 1),
(11246, 1),
(11247, 1),
(11248, 1),
(11249, 1),
(11250, 1),
(11251, 1),
(11252, 1),
(11253, 1),
(11254, 1),
(11255, 1),
(11256, 1),
(11257, 1),
(11258, 1),
(11259, 1),
(11260, 1),
(11261, 1),
(11262, 1),
(11263, 1),
(11264, 1),
(11265, 1),
(11266, 1),
(11267, 1),
(11268, 1),
(11269, 1),
(11270, 1),
(11271, 1),
(11272, 1),
(11273, 1),
(11274, 1),
(11275, 1),
(11276, 1),
(11277, 1),
(11278, 1),
(11279, 1),
(11280, 1),
(11281, 1),
(11282, 1),
(11283, 1),
(11284, 1),
(11285, 1),
(11286, 1),
(11287, 1),
(11288, 1),
(11289, 1),
(11290, 1),
(11291, 1),
(11292, 1),
(11293, 1),
(11294, 1),
(11295, 1),
(11296, 1),
(11297, 1),
(11298, 1),
(11299, 1),
(11300, 1),
(11301, 1),
(11302, 1),
(11303, 1),
(11304, 1),
(11305, 1),
(11306, 1),
(11307, 1),
(11308, 1),
(11309, 1),
(11310, 1),
(11311, 1),
(11312, 1),
(11313, 1),
(11314, 1),
(11315, 1),
(11316, 1),
(11317, 1),
(11318, 1),
(11319, 1),
(11320, 1),
(11321, 1),
(11322, 1),
(11323, 1),
(11324, 1),
(11325, 1),
(11326, 1),
(11327, 1),
(11328, 1),
(11329, 1),
(11330, 1),
(11331, 1),
(11332, 1),
(11333, 1),
(11334, 1),
(11335, 1),
(11336, 1),
(11337, 1),
(11338, 1),
(11339, 1),
(11340, 1),
(11341, 1),
(11342, 1),
(11343, 1),
(11344, 1),
(11345, 1),
(11346, 1),
(11347, 1),
(11348, 1),
(11349, 1),
(11350, 1),
(11351, 1),
(11352, 1),
(11353, 1),
(11354, 1),
(11355, 1),
(11356, 1),
(11357, 1),
(11358, 1),
(11359, 1),
(11360, 1),
(11361, 1),
(11362, 1),
(11363, 1),
(11364, 1),
(11365, 1),
(11366, 1),
(11367, 1),
(11368, 1),
(11369, 1),
(11370, 1),
(11371, 1),
(11372, 1),
(11373, 1),
(11374, 1),
(11375, 1),
(11376, 1),
(11377, 1),
(11378, 1),
(11379, 1),
(11380, 1),
(11381, 1),
(11382, 1),
(11383, 1),
(11384, 1),
(11385, 1),
(11386, 1),
(11387, 1),
(11388, 1),
(11389, 1),
(11390, 1),
(11391, 1),
(11392, 1),
(11393, 1),
(11394, 1),
(11395, 1),
(11396, 1),
(11397, 1),
(11398, 1),
(11399, 1),
(11400, 1),
(11401, 1),
(11402, 1),
(11403, 1),
(11404, 1),
(11405, 1),
(11406, 1),
(11407, 1),
(11408, 1),
(11409, 1),
(11410, 1),
(11411, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(11412, 1),
(11413, 1),
(11414, 1),
(11415, 1),
(11416, 1),
(11417, 1),
(11418, 1),
(11419, 1),
(11420, 1),
(11421, 1),
(11422, 1),
(11423, 1),
(11424, 1),
(11425, 1),
(11426, 1),
(11427, 1),
(11428, 1),
(11429, 1),
(11430, 1),
(11431, 1),
(11432, 1),
(11433, 1),
(11434, 1),
(11435, 1),
(11436, 1),
(11437, 1),
(11438, 1),
(11439, 1),
(11440, 1),
(11441, 1),
(11442, 1),
(11443, 1),
(11444, 1),
(11445, 1),
(11446, 1),
(11447, 1),
(11448, 1),
(11449, 1),
(11450, 1),
(11451, 1),
(11452, 1),
(11453, 1),
(11454, 1),
(11455, 1),
(11456, 1),
(11457, 1),
(11458, 1),
(11459, 1),
(11460, 1),
(11461, 1),
(11462, 1),
(11463, 1),
(11464, 1),
(11465, 1),
(11466, 1),
(11467, 1),
(11468, 1),
(11469, 1),
(11470, 1),
(11471, 1),
(11472, 1),
(11473, 1),
(11474, 1),
(11475, 1),
(11476, 1),
(11477, 1),
(11478, 1),
(11479, 1),
(11480, 1),
(11481, 1),
(11482, 1),
(11483, 1),
(11484, 1),
(11485, 1),
(11486, 1),
(11487, 1),
(11488, 1),
(11489, 1),
(11490, 1),
(11491, 1),
(11492, 1),
(11493, 1),
(11494, 1),
(11495, 1),
(11496, 1),
(11497, 1),
(11498, 1),
(11499, 1),
(11500, 1),
(11501, 1),
(11502, 1),
(11503, 1),
(11504, 1),
(11505, 1),
(11506, 1),
(11507, 1),
(11508, 1),
(11509, 1),
(11510, 1),
(11511, 1),
(11512, 1),
(11513, 1),
(11514, 1),
(11515, 1),
(11516, 1),
(11517, 1),
(11518, 1),
(11519, 1),
(11520, 1),
(11521, 1),
(11522, 1),
(11523, 1),
(11524, 1),
(11525, 1),
(11526, 1),
(11527, 1),
(11528, 1),
(11529, 1),
(11530, 1),
(11531, 1),
(11532, 1),
(11533, 1),
(11534, 1),
(11535, 1),
(11536, 1),
(11537, 1),
(11538, 1),
(11539, 1),
(11540, 1),
(11541, 1),
(11542, 1),
(11543, 1),
(11544, 1),
(11545, 1),
(11546, 1),
(11547, 1),
(11548, 1),
(11549, 1),
(11550, 1),
(11551, 1),
(11552, 1),
(11553, 1),
(11554, 1),
(11555, 1),
(11556, 1),
(11557, 1),
(11558, 1),
(11559, 1),
(11560, 1),
(11561, 1),
(11562, 1),
(11563, 1),
(11564, 1),
(11565, 1),
(11566, 1),
(11567, 1),
(11568, 1),
(11569, 1),
(11570, 1),
(11571, 1),
(11572, 1),
(11573, 1),
(11574, 1),
(11575, 1),
(11576, 1),
(11577, 1),
(11578, 1),
(11579, 1),
(11580, 1),
(11581, 1),
(11582, 1),
(11583, 1),
(11584, 1),
(11585, 1),
(11586, 1),
(11587, 1),
(11588, 1),
(11589, 1),
(11590, 1),
(11591, 1),
(11592, 1),
(11593, 1),
(11594, 1),
(11595, 1),
(11596, 1),
(11597, 1),
(11598, 1),
(11599, 1),
(11600, 1),
(11601, 1),
(11602, 1),
(11603, 1),
(11604, 1),
(11605, 1),
(11606, 1),
(11607, 1),
(11608, 1),
(11609, 1),
(11610, 1),
(11611, 1),
(11612, 1),
(11613, 1),
(11614, 1),
(11615, 1),
(11616, 1),
(11617, 1),
(11618, 1),
(11619, 1),
(11620, 1),
(11621, 1),
(11622, 1),
(11623, 1),
(11624, 1),
(11625, 1),
(11626, 1),
(11627, 1),
(11628, 1),
(11629, 1),
(11630, 1),
(11631, 1),
(11632, 1),
(11633, 1),
(11634, 1),
(11635, 1),
(11636, 1),
(11637, 1),
(11638, 1),
(11639, 1),
(11640, 1),
(11641, 1),
(11642, 1),
(11643, 1),
(11644, 1),
(11645, 1),
(11646, 1),
(11647, 1),
(11648, 1),
(11649, 1),
(11650, 1),
(11651, 1),
(11652, 1),
(11653, 1),
(11654, 1),
(11655, 1),
(11656, 1),
(11657, 1),
(11658, 1),
(11659, 1),
(11660, 1),
(11661, 1),
(11662, 1),
(11663, 1),
(11664, 1),
(11665, 1),
(11666, 1),
(11667, 1),
(11668, 1),
(11669, 1),
(11670, 1),
(11671, 1),
(11672, 1),
(11673, 1),
(11674, 1),
(11675, 1),
(11676, 1),
(11677, 1),
(11678, 1),
(11679, 1),
(11680, 1),
(11681, 1),
(11682, 1),
(11683, 1),
(11684, 1),
(11685, 1),
(11686, 1),
(11687, 1),
(11688, 1),
(11689, 1),
(11690, 1),
(11691, 1),
(11692, 1),
(11693, 1),
(11694, 1),
(11695, 1),
(11696, 1),
(11697, 1),
(11698, 1),
(11699, 1),
(11700, 1),
(11701, 1),
(11702, 1),
(11703, 1),
(11704, 1),
(11705, 1),
(11706, 1),
(11707, 1),
(11708, 1),
(11709, 1),
(11710, 1),
(11711, 1),
(11712, 1),
(11713, 1),
(11714, 1),
(11715, 1),
(11716, 1),
(11717, 1),
(11718, 1),
(11719, 1),
(11720, 1),
(11721, 1),
(11722, 1),
(11723, 1),
(11724, 1),
(11725, 1),
(11726, 1),
(11727, 1),
(11728, 1),
(11729, 1),
(11730, 1),
(11731, 1),
(11732, 1),
(11733, 1),
(11734, 1),
(11735, 1),
(11736, 1),
(11737, 1),
(11738, 1),
(11739, 1),
(11740, 1),
(11741, 1),
(11742, 1),
(11743, 1),
(11744, 1),
(11745, 1),
(11746, 1),
(11747, 1),
(11748, 1),
(11749, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(11750, 1),
(11751, 1),
(11752, 1),
(11753, 1),
(11754, 1),
(11755, 1),
(11756, 1),
(11757, 1),
(11758, 1),
(11759, 1),
(11760, 1),
(11761, 1),
(11762, 1),
(11763, 1),
(11764, 1),
(11765, 1),
(11766, 1),
(11767, 1),
(11768, 1),
(11769, 1),
(11770, 1),
(11771, 1),
(11772, 1),
(11773, 1),
(11774, 1),
(11775, 1),
(11776, 1),
(11777, 1),
(11778, 1),
(11779, 1),
(11780, 1),
(11781, 1),
(11782, 1),
(11783, 1),
(11784, 1),
(11785, 1),
(11786, 1),
(11787, 1),
(11788, 1),
(11789, 1),
(11790, 1),
(11791, 1),
(11792, 1),
(11793, 1),
(11794, 1),
(11795, 1),
(11796, 1),
(11797, 1),
(11798, 1),
(11799, 1),
(11800, 1),
(11801, 1),
(11802, 1),
(11803, 1),
(11804, 1),
(11805, 1),
(11806, 1),
(11807, 1),
(11808, 1),
(11809, 1),
(11810, 1),
(11811, 1),
(11812, 1),
(11813, 1),
(11814, 1),
(11815, 1),
(11816, 1),
(11817, 1),
(11818, 1),
(11819, 1),
(11820, 1),
(11821, 1),
(11822, 1),
(11823, 1),
(11824, 1),
(11825, 1),
(11826, 1),
(11827, 1),
(11828, 1),
(11829, 1),
(11830, 1),
(11831, 1),
(11832, 1),
(11833, 1),
(11834, 1),
(11835, 1),
(11836, 1),
(11837, 1),
(11838, 1),
(11839, 1),
(11840, 1),
(11841, 1),
(11842, 1),
(11843, 1),
(11844, 1),
(11845, 1),
(11846, 1),
(11847, 1),
(11848, 1),
(11849, 1),
(11850, 1),
(11851, 1),
(11852, 1),
(11853, 1),
(11854, 1),
(11855, 1),
(11856, 1),
(11857, 1),
(11858, 1),
(11859, 1),
(11860, 1),
(11861, 1),
(11862, 1),
(11863, 1),
(11864, 1),
(11865, 1),
(11866, 1),
(11867, 1),
(11868, 1),
(11869, 1),
(11870, 1),
(11871, 1),
(11872, 1),
(11873, 1),
(11874, 1),
(11875, 1),
(11876, 1),
(11877, 1),
(11878, 1),
(11879, 1),
(11880, 1),
(11881, 1),
(11882, 1),
(11883, 1),
(11884, 1),
(11885, 1),
(11886, 1),
(11887, 1),
(11888, 1),
(11889, 1),
(11890, 1),
(11891, 1),
(11892, 1),
(11893, 1),
(11894, 1),
(11895, 1),
(11896, 1),
(11897, 1),
(11898, 1),
(11899, 1),
(11900, 1),
(11901, 1),
(11902, 1),
(11903, 1),
(11904, 1),
(11905, 1),
(11906, 1),
(11907, 1),
(11908, 1),
(11909, 1),
(11910, 1),
(11911, 1),
(11912, 1),
(11913, 1),
(11914, 1),
(11915, 1),
(11916, 1),
(11917, 1),
(11918, 1),
(11919, 1),
(11920, 1),
(11921, 1),
(11922, 1),
(11923, 1),
(11924, 1),
(11925, 1),
(11926, 1),
(11927, 1),
(11928, 1),
(11929, 1),
(11930, 1),
(11931, 1),
(11932, 1),
(11933, 1),
(11934, 1),
(11935, 1),
(11936, 1),
(11937, 1),
(11938, 1),
(11939, 1),
(11940, 1),
(11941, 1),
(11942, 1),
(11943, 1),
(11944, 1),
(11945, 1),
(11946, 1),
(11947, 1),
(11948, 1),
(11949, 1),
(11950, 1),
(11951, 1),
(11952, 1),
(11953, 1),
(11954, 1),
(11955, 1),
(11956, 1),
(11957, 1),
(11958, 1),
(11959, 1),
(11960, 1),
(11961, 1),
(11962, 1),
(11963, 1),
(11964, 1),
(11965, 1),
(11966, 1),
(11967, 1),
(11968, 1),
(11969, 1),
(11970, 1),
(11971, 1),
(11972, 1),
(11973, 1),
(11974, 1),
(11975, 1),
(11976, 1),
(11977, 1),
(11978, 1),
(11979, 1),
(11980, 1),
(11981, 1),
(11982, 1),
(11983, 1),
(11984, 1),
(11985, 1),
(11986, 1),
(11987, 1),
(11988, 1),
(11989, 1),
(11990, 1),
(11991, 1),
(11992, 1),
(11993, 1),
(11994, 1),
(11995, 1),
(11996, 1),
(11997, 1),
(11998, 1),
(11999, 1),
(12000, 1),
(12001, 1),
(12002, 1),
(12003, 1),
(12004, 1),
(12005, 1),
(12006, 1),
(12007, 1),
(12008, 1),
(12009, 1),
(12010, 1),
(12011, 1),
(12012, 1),
(12013, 1),
(12014, 1),
(12015, 1),
(12016, 1),
(12017, 1),
(12018, 1),
(12019, 1),
(12020, 1),
(12021, 1),
(12022, 1),
(12023, 1),
(12024, 1),
(12025, 1),
(12026, 1),
(12027, 1),
(12028, 1),
(12029, 1),
(12030, 1),
(12031, 1),
(12032, 1),
(12033, 1),
(12034, 1),
(12035, 1),
(12036, 1),
(12037, 1),
(12038, 1),
(12039, 1),
(12040, 1),
(12041, 1),
(12042, 1),
(12043, 1),
(12044, 1),
(12045, 1),
(12046, 1),
(12047, 1),
(12048, 1),
(12049, 1),
(12050, 1),
(12051, 1),
(12052, 1),
(12053, 1),
(12054, 1),
(12055, 1),
(12056, 1),
(12057, 1),
(12058, 1),
(12059, 1),
(12060, 1),
(12061, 1),
(12062, 1),
(12063, 1),
(12064, 1),
(12065, 1),
(12066, 1),
(12067, 1),
(12068, 1),
(12069, 1),
(12070, 1),
(12071, 1),
(12072, 1),
(12073, 1),
(12074, 1),
(12075, 1),
(12076, 1),
(12077, 1),
(12078, 1),
(12079, 1),
(12080, 1),
(12081, 1),
(12082, 1),
(12083, 1),
(12084, 1),
(12085, 1),
(12086, 1),
(12087, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(12088, 1),
(12089, 1),
(12090, 1),
(12091, 1),
(12092, 1),
(12093, 1),
(12094, 1),
(12095, 1),
(12096, 1),
(12097, 1),
(12098, 1),
(12099, 1),
(12100, 1),
(12101, 1),
(12102, 1),
(12103, 1),
(12104, 1),
(12105, 1),
(12106, 1),
(12107, 1),
(12108, 1),
(12109, 1),
(12110, 1),
(12111, 1),
(12112, 1),
(12113, 1),
(12114, 1),
(12115, 1),
(12116, 1),
(12117, 1),
(12118, 1),
(12119, 1),
(12120, 1),
(12121, 1),
(12122, 1),
(12123, 1),
(12124, 1),
(12125, 1),
(12126, 1),
(12127, 1),
(12128, 1),
(12129, 1),
(12130, 1),
(12131, 1),
(12132, 1),
(12133, 1),
(12134, 1),
(12135, 1),
(12136, 1),
(12137, 1),
(12138, 1),
(12139, 1),
(12140, 1),
(12141, 1),
(12142, 1),
(12143, 1),
(12144, 1),
(12145, 1),
(12146, 1),
(12147, 1),
(12148, 1),
(12149, 1),
(12150, 1),
(12151, 1),
(12152, 1),
(12153, 1),
(12154, 1),
(12155, 1),
(12156, 1),
(12157, 1),
(12158, 1),
(12159, 1),
(12160, 1),
(12161, 1),
(12162, 1),
(12163, 1),
(12164, 1),
(12165, 1),
(12166, 1),
(12167, 1),
(12168, 1),
(12169, 1),
(12170, 1),
(12171, 1),
(12172, 1),
(12173, 1),
(12174, 1),
(12175, 1),
(12176, 1),
(12177, 1),
(12178, 1),
(12179, 1),
(12180, 1),
(12181, 1),
(12182, 1),
(12183, 1),
(12184, 1),
(12185, 1),
(12186, 1),
(12187, 1),
(12188, 1),
(12189, 1),
(12190, 1),
(12191, 1),
(12192, 1),
(12193, 1),
(12194, 1),
(12195, 1),
(12196, 1),
(12197, 1),
(12198, 1),
(12199, 1),
(12200, 1),
(12201, 1),
(12202, 1),
(12203, 1),
(12204, 1),
(12205, 1),
(12206, 1),
(12207, 1),
(12208, 1),
(12209, 1),
(12210, 1),
(12211, 1),
(12212, 1),
(12213, 1),
(12214, 1),
(12215, 1),
(12216, 1),
(12217, 1),
(12218, 1),
(12219, 1),
(12220, 1),
(12221, 1),
(12222, 1),
(12223, 1),
(12224, 1),
(12225, 1),
(12226, 1),
(12227, 1),
(12228, 1),
(12229, 1),
(12230, 1),
(12231, 1),
(12232, 1),
(12233, 1),
(12234, 1),
(12235, 1),
(12236, 1),
(12237, 1),
(12238, 1),
(12239, 1),
(12240, 1),
(12241, 1),
(12242, 1),
(12243, 1),
(12244, 1),
(12245, 1),
(12246, 1),
(12247, 1),
(12248, 1),
(12249, 1),
(12250, 1),
(12251, 1),
(12252, 1),
(12253, 1),
(12254, 1),
(12255, 1),
(12256, 1),
(12257, 1),
(12258, 1),
(12259, 1),
(12260, 1),
(12261, 1),
(12262, 1),
(12263, 1),
(12264, 1),
(12265, 1),
(12266, 1),
(12267, 1),
(12268, 1),
(12269, 1),
(12270, 1),
(12271, 1),
(12272, 1),
(12273, 1),
(12274, 1),
(12275, 1),
(12276, 1),
(12277, 1),
(12278, 1),
(12279, 1),
(12280, 1),
(12281, 1),
(12282, 1),
(12283, 1),
(12284, 1),
(12285, 1),
(12286, 1),
(12287, 1),
(12288, 1),
(12289, 1),
(12290, 1),
(12291, 1),
(12292, 1),
(12293, 1),
(12294, 1),
(12295, 1),
(12296, 1),
(12297, 1),
(12298, 1),
(12299, 1),
(12300, 1),
(12301, 1),
(12302, 1),
(12303, 1),
(12304, 1),
(12305, 1),
(12306, 1),
(12307, 1),
(12308, 1),
(12309, 1),
(12310, 1),
(12311, 1),
(12312, 1),
(12313, 1),
(12314, 1),
(12315, 1),
(12316, 1),
(12317, 1),
(12318, 1),
(12319, 1),
(12320, 1),
(12321, 1),
(12322, 1),
(12323, 1),
(12324, 1),
(12325, 1),
(12326, 1),
(12327, 1),
(12328, 1),
(12329, 1),
(12330, 1),
(12331, 1),
(12332, 1),
(12333, 1),
(12334, 1),
(12335, 1),
(12336, 1),
(12337, 1),
(12338, 1),
(12339, 1),
(12340, 1),
(12341, 1),
(12342, 1),
(12343, 1),
(12344, 1),
(12345, 1),
(12346, 1),
(12347, 1),
(12348, 1),
(12349, 1),
(12350, 1),
(12351, 1),
(12352, 1),
(12353, 1),
(12354, 1),
(12355, 1),
(12356, 1),
(12357, 1),
(12358, 1),
(12359, 1),
(12360, 1),
(12361, 1),
(12362, 1),
(12363, 1),
(12364, 1),
(12365, 1),
(12366, 1),
(12367, 1),
(12368, 1),
(12369, 1),
(12370, 1),
(12371, 1),
(12372, 1),
(12373, 1),
(12374, 1),
(12375, 1),
(12376, 1),
(12377, 1),
(12378, 1),
(12379, 1),
(12380, 1),
(12381, 1),
(12382, 1),
(12383, 1),
(12384, 1),
(12385, 1),
(12386, 1),
(12387, 1),
(12388, 1),
(12389, 1),
(12390, 1),
(12391, 1),
(12392, 1),
(12393, 1),
(12394, 1),
(12395, 1),
(12396, 1),
(12397, 1),
(12398, 1),
(12399, 1),
(12400, 1),
(12401, 1),
(12402, 1),
(12403, 1),
(12404, 1),
(12405, 1),
(12406, 1),
(12407, 1),
(12408, 1),
(12409, 1),
(12410, 1),
(12411, 1),
(12412, 1),
(12413, 1),
(12414, 1),
(12415, 1),
(12416, 1),
(12417, 1),
(12418, 1),
(12419, 1),
(12420, 1),
(12421, 1),
(12422, 1),
(12423, 1),
(12424, 1),
(12425, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(12426, 1),
(12427, 1),
(12428, 1),
(12429, 1),
(12430, 1),
(12431, 1),
(12432, 1),
(12433, 1),
(12434, 1),
(12435, 1),
(12436, 1),
(12437, 1),
(12438, 1),
(12439, 1),
(12440, 1),
(12441, 1),
(12442, 1),
(12443, 1),
(12444, 1),
(12445, 1),
(12446, 1),
(12447, 1),
(12448, 1),
(12449, 1),
(12450, 1),
(12451, 1),
(12452, 1),
(12453, 1),
(12454, 1),
(12455, 1),
(12456, 1),
(12457, 1),
(12458, 1),
(12459, 1),
(12460, 1),
(12461, 1),
(12462, 1),
(12463, 1),
(12464, 1),
(12465, 1),
(12466, 1),
(12467, 1),
(12468, 1),
(12469, 1),
(12470, 1),
(12471, 1),
(12472, 1),
(12473, 1),
(12474, 1),
(12475, 1),
(12476, 1),
(12477, 1),
(12478, 1),
(12479, 1),
(12480, 1),
(12481, 1),
(12482, 1),
(12483, 1),
(12484, 1),
(12485, 1),
(12486, 1),
(12487, 1),
(12488, 1),
(12489, 1),
(12490, 1),
(12491, 1),
(12492, 1),
(12493, 1),
(12494, 1),
(12495, 1),
(12496, 1),
(12497, 1),
(12498, 1),
(12499, 1),
(12500, 1),
(12501, 1),
(12502, 1),
(12503, 1),
(12504, 1),
(12505, 1),
(12506, 1),
(12507, 1),
(12508, 1),
(12509, 1),
(12510, 1),
(12511, 1),
(12512, 1),
(12513, 1),
(12514, 1),
(12515, 1),
(12516, 1),
(12517, 1),
(12518, 1),
(12519, 1),
(12520, 1),
(12521, 1),
(12522, 1),
(12523, 1),
(12524, 1),
(12525, 1),
(12526, 1),
(12527, 1),
(12528, 1),
(12529, 1),
(12530, 1),
(12531, 1),
(12532, 1),
(12533, 1),
(12534, 1),
(12535, 1),
(12536, 1),
(12537, 1),
(12538, 1),
(12539, 1),
(12540, 1),
(12541, 1),
(12542, 1),
(12543, 1),
(12544, 1),
(12545, 1),
(12546, 1),
(12547, 1),
(12548, 1),
(12549, 1),
(12550, 1),
(12551, 1),
(12552, 1),
(12553, 1),
(12554, 1),
(12555, 1),
(12556, 1),
(12557, 1),
(12558, 1),
(12559, 1),
(12560, 1),
(12561, 1),
(12562, 1),
(12563, 1),
(12564, 1),
(12565, 1),
(12566, 1),
(12567, 1),
(12568, 1),
(12569, 1),
(12570, 1),
(12571, 1),
(12572, 1),
(12573, 1),
(12574, 1),
(12575, 1),
(12576, 1),
(12577, 1),
(12578, 1),
(12579, 1),
(12580, 1),
(12581, 1),
(12582, 1),
(12583, 1),
(12584, 1),
(12585, 1),
(12586, 1),
(12587, 1),
(12588, 1),
(12589, 1),
(12590, 1),
(12591, 1),
(12592, 1),
(12593, 1),
(12594, 1),
(12595, 1),
(12596, 1),
(12597, 1),
(12598, 1),
(12599, 1),
(12600, 1),
(12601, 1),
(12602, 1),
(12603, 1),
(12604, 1),
(12605, 1),
(12606, 1),
(12607, 1),
(12608, 1),
(12609, 1),
(12610, 1),
(12611, 1),
(12612, 1),
(12613, 1),
(12614, 1),
(12615, 1),
(12616, 1),
(12617, 1),
(12618, 1),
(12619, 1),
(12620, 1),
(12621, 1),
(12622, 1),
(12623, 1),
(12624, 1),
(12625, 1),
(12626, 1),
(12627, 1),
(12628, 1),
(12629, 1),
(12630, 1),
(12631, 1),
(12632, 1),
(12633, 1),
(12634, 1),
(12635, 1),
(12636, 1),
(12637, 1),
(12638, 1),
(12639, 1),
(12640, 1),
(12641, 1),
(12642, 1),
(12643, 1),
(12644, 1),
(12645, 1),
(12646, 1),
(12647, 1),
(12648, 1),
(12649, 1),
(12650, 1),
(12651, 1),
(12652, 1),
(12653, 1),
(12654, 1),
(12655, 1),
(12656, 1),
(12657, 1),
(12658, 1),
(12659, 1),
(12660, 1),
(12661, 1),
(12662, 1),
(12663, 1),
(12664, 1),
(12665, 1),
(12666, 1),
(12667, 1),
(12668, 1),
(12669, 1),
(12670, 1),
(12671, 1),
(12672, 1),
(12673, 1),
(12674, 1),
(12675, 1),
(12676, 1),
(12677, 1),
(12678, 1),
(12679, 1),
(12680, 1),
(12681, 1),
(12682, 1),
(12683, 1),
(12684, 1),
(12685, 1),
(12686, 1),
(12687, 1),
(12688, 1),
(12689, 1),
(12690, 1),
(12691, 1),
(12692, 1),
(12693, 1),
(12694, 1),
(12695, 1),
(12696, 1),
(12697, 1),
(12698, 1),
(12699, 1),
(12700, 1),
(12701, 1),
(12702, 1),
(12703, 1),
(12704, 1),
(12705, 1),
(12706, 1),
(12707, 1),
(12708, 1),
(12709, 1),
(12710, 1),
(12711, 1),
(12712, 1),
(12713, 1),
(12714, 1),
(12715, 1),
(12716, 1),
(12717, 1),
(12718, 1),
(12719, 1),
(12720, 1),
(12721, 1),
(12722, 1),
(12723, 1),
(12724, 1),
(12725, 1),
(12726, 1),
(12727, 1),
(12728, 1),
(12729, 1),
(12730, 1),
(12731, 1),
(12732, 1),
(12733, 1),
(12734, 1),
(12735, 1),
(12736, 1),
(12737, 1),
(12738, 1),
(12739, 1),
(12740, 1),
(12741, 1),
(12742, 1),
(12743, 1),
(12744, 1),
(12745, 1),
(12746, 1),
(12747, 1),
(12748, 1),
(12749, 1),
(12750, 1),
(12751, 1),
(12752, 1),
(12753, 1),
(12754, 1),
(12755, 1),
(12756, 1),
(12757, 1),
(12758, 1),
(12759, 1),
(12760, 1),
(12761, 1),
(12762, 1),
(12763, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(12764, 1),
(12765, 1),
(12766, 1),
(12767, 1),
(12768, 1),
(12769, 1),
(12770, 1),
(12771, 1),
(12772, 1),
(12773, 1),
(12774, 1),
(12775, 1),
(12776, 1),
(12777, 1),
(12778, 1),
(12779, 1),
(12780, 1),
(12781, 1),
(12782, 1),
(12783, 1),
(12784, 1),
(12785, 1),
(12786, 1),
(12787, 1),
(12788, 1),
(12789, 1),
(12790, 1),
(12791, 1),
(12792, 1),
(12793, 1),
(12794, 1),
(12795, 1),
(12796, 1),
(12797, 1),
(12798, 1),
(12799, 1),
(12800, 1),
(12801, 1),
(12802, 1),
(12803, 1),
(12804, 1),
(12805, 1),
(12806, 1),
(12807, 1),
(12808, 1),
(12809, 1),
(12810, 1),
(12811, 1),
(12812, 1),
(12813, 1),
(12814, 1),
(12815, 1),
(12816, 1),
(12817, 1),
(12818, 1),
(12819, 1),
(12820, 1),
(12821, 1),
(12822, 1),
(12823, 1),
(12824, 1),
(12825, 1),
(12826, 1),
(12827, 1),
(12828, 1),
(12829, 1),
(12830, 1),
(12831, 1),
(12832, 1),
(12833, 1),
(12834, 1),
(12835, 1),
(12836, 1),
(12837, 1),
(12838, 1),
(12839, 1),
(12840, 1),
(12841, 1),
(12842, 1),
(12843, 1),
(12844, 1),
(12845, 1),
(12846, 1),
(12847, 1),
(12848, 1),
(12849, 1),
(12850, 1),
(12851, 1),
(12852, 1),
(12853, 1),
(12854, 1),
(12855, 1),
(12856, 1),
(12857, 1),
(12858, 1),
(12859, 1),
(12860, 1),
(12861, 1),
(12862, 1),
(12863, 1),
(12864, 1),
(12865, 1),
(12866, 1),
(12867, 1),
(12868, 1),
(12869, 1),
(12870, 1),
(12871, 1),
(12872, 1),
(12873, 1),
(12874, 1),
(12875, 1),
(12876, 1),
(12877, 1),
(12878, 1),
(12879, 1),
(12880, 1),
(12881, 1),
(12882, 1),
(12883, 1),
(12884, 1),
(12885, 1),
(12886, 1),
(12887, 1),
(12888, 1),
(12889, 1),
(12890, 1),
(12891, 1),
(12892, 1),
(12893, 1),
(12894, 1),
(12895, 1),
(12896, 1),
(12897, 1),
(12898, 1),
(12899, 1),
(12900, 1),
(12901, 1),
(12902, 1),
(12903, 1),
(12904, 1),
(12905, 1),
(12906, 1),
(12907, 1),
(12908, 1),
(12909, 1),
(12910, 1),
(12911, 1),
(12912, 1),
(12913, 1),
(12914, 1),
(12915, 1),
(12916, 1),
(12917, 1),
(12918, 1),
(12919, 1),
(12920, 1),
(12921, 1),
(12922, 1),
(12923, 1),
(12924, 1),
(12925, 1),
(12926, 1),
(12927, 1),
(12928, 1),
(12929, 1),
(12930, 1),
(12931, 1),
(12932, 1),
(12933, 1),
(12934, 1),
(12935, 1),
(12936, 1),
(12937, 1),
(12938, 1),
(12939, 1),
(12940, 1),
(12941, 1),
(12942, 1),
(12943, 1),
(12944, 1),
(12945, 1),
(12946, 1),
(12947, 1),
(12948, 1),
(12949, 1),
(12950, 1),
(12951, 1),
(12952, 1),
(12953, 1),
(12954, 1),
(12955, 1),
(12956, 1),
(12957, 1),
(12958, 1),
(12959, 1),
(12960, 1),
(12961, 1),
(12962, 1),
(12963, 1),
(12964, 1),
(12965, 1),
(12966, 1),
(12967, 1),
(12968, 1),
(12969, 1),
(12970, 1),
(12971, 1),
(12972, 1),
(12973, 1),
(12974, 1),
(12975, 1),
(12976, 1),
(12977, 1),
(12978, 1),
(12979, 1),
(12980, 1),
(12981, 1),
(12982, 1),
(12983, 1),
(12984, 1),
(12985, 1),
(12986, 1),
(12987, 1),
(12988, 1),
(12989, 1),
(12990, 1),
(12991, 1),
(12992, 1),
(12993, 1),
(12994, 1),
(12995, 1),
(12996, 1),
(12997, 1),
(12998, 1),
(12999, 1),
(13000, 1),
(13001, 1),
(13002, 1),
(13003, 1),
(13004, 1),
(13005, 1),
(13006, 1),
(13007, 1),
(13008, 1),
(13009, 1),
(13010, 1),
(13011, 1),
(13012, 1),
(13013, 1),
(13014, 1),
(13015, 1),
(13016, 1),
(13017, 1),
(13018, 1),
(13019, 1),
(13020, 1),
(13021, 1),
(13022, 1),
(13023, 1),
(13024, 1),
(13025, 1),
(13026, 1),
(13027, 1),
(13028, 1),
(13029, 1),
(13030, 1),
(13031, 1),
(13032, 1),
(13033, 1),
(13034, 1),
(13035, 1),
(13036, 1),
(13037, 1),
(13038, 1),
(13039, 1),
(13040, 1),
(13041, 1),
(13042, 1),
(13043, 1),
(13044, 1),
(13045, 1),
(13046, 1),
(13047, 1),
(13048, 1),
(13049, 1),
(13050, 1),
(13051, 1),
(13052, 1),
(13053, 1),
(13054, 1),
(13055, 1),
(13056, 1),
(13057, 1),
(13058, 1),
(13059, 1),
(13060, 1),
(13061, 1),
(13062, 1),
(13063, 1),
(13064, 1),
(13065, 1),
(13066, 1),
(13067, 1),
(13068, 1),
(13069, 1),
(13070, 1),
(13071, 1),
(13072, 1),
(13073, 1),
(13074, 1),
(13075, 1),
(13076, 1),
(13077, 1),
(13078, 1),
(13079, 1),
(13080, 1),
(13081, 1),
(13082, 1),
(13083, 1),
(13084, 1),
(13085, 1),
(13086, 1),
(13087, 1),
(13088, 1),
(13089, 1),
(13090, 1),
(13091, 1),
(13092, 1),
(13093, 1),
(13094, 1),
(13095, 1),
(13096, 1),
(13097, 1),
(13098, 1),
(13099, 1),
(13100, 1),
(13101, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(13102, 1),
(13103, 1),
(13104, 1),
(13105, 1),
(13106, 1),
(13107, 1),
(13108, 1),
(13109, 1),
(13110, 1),
(13111, 1),
(13112, 1),
(13113, 1),
(13114, 1),
(13115, 1),
(13116, 1),
(13117, 1),
(13118, 1),
(13119, 1),
(13120, 1),
(13121, 1),
(13122, 1),
(13123, 1),
(13124, 1),
(13125, 1),
(13126, 1),
(13127, 1),
(13128, 1),
(13129, 1),
(13130, 1),
(13131, 1),
(13132, 1),
(13133, 1),
(13134, 1),
(13135, 1),
(13136, 1),
(13137, 1),
(13138, 1),
(13139, 1),
(13140, 1),
(13141, 1),
(13142, 1),
(13143, 1),
(13144, 1),
(13145, 1),
(13146, 1),
(13147, 1),
(13148, 1),
(13149, 1),
(13150, 1),
(13151, 1),
(13152, 1),
(13153, 1),
(13154, 1),
(13155, 1),
(13156, 1),
(13157, 1),
(13158, 1),
(13159, 1),
(13160, 1),
(13161, 1),
(13162, 1),
(13163, 1),
(13164, 1),
(13165, 1),
(13166, 1),
(13167, 1),
(13168, 1),
(13169, 1),
(13170, 1),
(13171, 1),
(13172, 1),
(13173, 1),
(13174, 1),
(13175, 1),
(13176, 1),
(13177, 1),
(13178, 1),
(13179, 1),
(13180, 1),
(13181, 1),
(13182, 1),
(13183, 1),
(13184, 1),
(13185, 1),
(13186, 1),
(13187, 1),
(13188, 1),
(13189, 1),
(13190, 1),
(13191, 1),
(13192, 1),
(13193, 1),
(13194, 1),
(13195, 1),
(13196, 1),
(13197, 1),
(13198, 1),
(13199, 1),
(13200, 1),
(13201, 1),
(13202, 1),
(13203, 1),
(13204, 1),
(13205, 1),
(13206, 1),
(13207, 1),
(13208, 1),
(13209, 1),
(13210, 1),
(13211, 1),
(13212, 1),
(13213, 1),
(13214, 1),
(13215, 1),
(13216, 1),
(13217, 1),
(13218, 1),
(13219, 1),
(13220, 1),
(13221, 1),
(13222, 1),
(13223, 1),
(13224, 1),
(13225, 1),
(13226, 1),
(13227, 1),
(13228, 1),
(13229, 1),
(13230, 1),
(13231, 1),
(13232, 1),
(13233, 1),
(13234, 1),
(13235, 1),
(13236, 1),
(13237, 1),
(13238, 1),
(13239, 1),
(13240, 1),
(13241, 1),
(13242, 1),
(13243, 1),
(13244, 1),
(13245, 1),
(13246, 1),
(13247, 1),
(13248, 1),
(13249, 1),
(13250, 1),
(13251, 1),
(13252, 1),
(13253, 1),
(13254, 1),
(13255, 1),
(13256, 1),
(13257, 1),
(13258, 1),
(13259, 1),
(13260, 1),
(13261, 1),
(13262, 1),
(13263, 1),
(13264, 1),
(13265, 1),
(13266, 1),
(13267, 1),
(13268, 1),
(13269, 1),
(13270, 1),
(13271, 1),
(13272, 1),
(13273, 1),
(13274, 1),
(13275, 1),
(13276, 1),
(13277, 1),
(13278, 1),
(13279, 1),
(13280, 1),
(13281, 1),
(13282, 1),
(13283, 1),
(13284, 1),
(13285, 1),
(13286, 1),
(13287, 1),
(13288, 1),
(13289, 1),
(13290, 1),
(13291, 1),
(13292, 1),
(13293, 1),
(13294, 1),
(13295, 1),
(13296, 1),
(13297, 1),
(13298, 1),
(13299, 1),
(13300, 1),
(13301, 1),
(13302, 1),
(13303, 1),
(13304, 1),
(13305, 1),
(13306, 1),
(13307, 1),
(13308, 1),
(13309, 1),
(13310, 1),
(13311, 1),
(13312, 1),
(13313, 1),
(13314, 1),
(13315, 1),
(13316, 1),
(13317, 1),
(13318, 1),
(13319, 1),
(13320, 1),
(13321, 1),
(13322, 1),
(13323, 1),
(13324, 1),
(13325, 1),
(13326, 1),
(13327, 1),
(13328, 1),
(13329, 1),
(13330, 1),
(13331, 1),
(13332, 1),
(13333, 1),
(13334, 1),
(13335, 1),
(13336, 1),
(13337, 1),
(13338, 1),
(13339, 1),
(13340, 1),
(13341, 1),
(13342, 1),
(13343, 1),
(13344, 1),
(13345, 1),
(13346, 1),
(13347, 1),
(13348, 1),
(13349, 1),
(13350, 1),
(13351, 1),
(13352, 1),
(13353, 1),
(13354, 1),
(13355, 1),
(13356, 1),
(13357, 1),
(13358, 1),
(13359, 1),
(13360, 1),
(13361, 1),
(13362, 1),
(13363, 1),
(13364, 1),
(13365, 1),
(13366, 1),
(13367, 1),
(13368, 1),
(13369, 1),
(13370, 1),
(13371, 1),
(13372, 1),
(13373, 1),
(13374, 1),
(13375, 1),
(13376, 1),
(13377, 1),
(13378, 1),
(13379, 1),
(13380, 1),
(13381, 1),
(13382, 1),
(13383, 1),
(13384, 1),
(13385, 1),
(13386, 1),
(13387, 1),
(13388, 1),
(13389, 1),
(13390, 1),
(13391, 1),
(13392, 1),
(13393, 1),
(13394, 1),
(13395, 1),
(13396, 1),
(13397, 1),
(13398, 1),
(13399, 1),
(13400, 1),
(13401, 1),
(13402, 1),
(13403, 1),
(13404, 1),
(13405, 1),
(13406, 1),
(13407, 1),
(13408, 1),
(13409, 1),
(13410, 1),
(13411, 1),
(13412, 1),
(13413, 1),
(13414, 1),
(13415, 1),
(13416, 1),
(13417, 1),
(13418, 1),
(13419, 1),
(13420, 1),
(13421, 1),
(13422, 1),
(13423, 1),
(13424, 1),
(13425, 1),
(13426, 1),
(13427, 1),
(13428, 1),
(13429, 1),
(13430, 1),
(13431, 1),
(13432, 1),
(13433, 1),
(13434, 1),
(13435, 1),
(13436, 1),
(13437, 1),
(13438, 1),
(13439, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(13440, 1),
(13441, 1),
(13442, 1),
(13443, 1),
(13444, 1),
(13445, 1),
(13446, 1),
(13447, 1),
(13448, 1),
(13449, 1),
(13450, 1),
(13451, 1),
(13452, 1),
(13453, 1),
(13454, 1),
(13455, 1),
(13456, 1),
(13457, 1),
(13458, 1),
(13459, 1),
(13460, 1),
(13461, 1),
(13462, 1),
(13463, 1),
(13464, 1),
(13465, 1),
(13466, 1),
(13467, 1),
(13468, 1),
(13469, 1),
(13470, 1),
(13471, 1),
(13472, 1),
(13473, 1),
(13474, 1),
(13475, 1),
(13476, 1),
(13477, 1),
(13478, 1),
(13479, 1),
(13480, 1),
(13481, 1),
(13482, 1),
(13483, 1),
(13484, 1),
(13485, 1),
(13486, 1),
(13487, 1),
(13488, 1),
(13489, 1),
(13490, 1),
(13491, 1),
(13492, 1),
(13493, 1),
(13494, 1),
(13495, 1),
(13496, 1),
(13497, 1),
(13498, 1),
(13499, 1),
(13500, 1),
(13501, 1),
(13502, 1),
(13503, 1),
(13504, 1),
(13505, 1),
(13506, 1),
(13507, 1),
(13508, 1),
(13509, 1),
(13510, 1),
(13511, 1),
(13512, 1),
(13513, 1),
(13514, 1),
(13515, 1),
(13516, 1),
(13517, 1),
(13518, 1),
(13519, 1),
(13520, 1),
(13521, 1),
(13522, 1),
(13523, 1),
(13524, 1),
(13525, 1),
(13526, 1),
(13527, 1),
(13528, 1),
(13529, 1),
(13530, 1),
(13531, 1),
(13532, 1),
(13533, 1),
(13534, 1),
(13535, 1),
(13536, 1),
(13537, 1),
(13538, 1),
(13539, 1),
(13540, 1),
(13541, 1),
(13542, 1),
(13543, 1),
(13544, 1),
(13545, 1),
(13546, 1),
(13547, 1),
(13548, 1),
(13549, 1),
(13550, 1),
(13551, 1),
(13552, 1),
(13553, 1),
(13554, 1),
(13555, 1),
(13556, 1),
(13557, 1),
(13558, 1),
(13559, 1),
(13560, 1),
(13561, 1),
(13562, 1),
(13563, 1),
(13564, 1),
(13565, 1),
(13566, 1),
(13567, 1),
(13568, 1),
(13569, 1),
(13570, 1),
(13571, 1),
(13572, 1),
(13573, 1),
(13574, 1),
(13575, 1),
(13576, 1),
(13577, 1),
(13578, 1),
(13579, 1),
(13580, 1),
(13581, 1),
(13582, 1),
(13583, 1),
(13584, 1),
(13585, 1),
(13586, 1),
(13587, 1),
(13588, 1),
(13589, 1),
(13590, 1),
(13591, 1),
(13592, 1),
(13593, 1),
(13594, 1),
(13595, 1),
(13596, 1),
(13597, 1),
(13598, 1),
(13599, 1),
(13600, 1),
(13601, 1),
(13602, 1),
(13603, 1),
(13604, 1),
(13605, 1),
(13606, 1),
(13607, 1),
(13608, 1),
(13609, 1),
(13610, 1),
(13611, 1),
(13612, 1),
(13613, 1),
(13614, 1),
(13615, 1),
(13616, 1),
(13617, 1),
(13618, 1),
(13619, 1),
(13620, 1),
(13621, 1),
(13622, 1),
(13623, 1),
(13624, 1),
(13625, 1),
(13626, 1),
(13627, 1),
(13628, 1),
(13629, 1),
(13630, 1),
(13631, 1),
(13632, 1),
(13633, 1),
(13634, 1),
(13635, 1),
(13636, 1),
(13637, 1),
(13638, 1),
(13639, 1),
(13640, 1),
(13641, 1),
(13642, 1),
(13643, 1),
(13644, 1),
(13645, 1),
(13646, 1),
(13647, 1),
(13648, 1),
(13649, 1),
(13650, 1),
(13651, 1),
(13652, 1),
(13653, 1),
(13654, 1),
(13655, 1),
(13656, 1),
(13657, 1),
(13658, 1),
(13659, 1),
(13660, 1),
(13661, 1),
(13662, 1),
(13663, 1),
(13664, 1),
(13665, 1),
(13666, 1),
(13667, 1),
(13668, 1),
(13669, 1),
(13670, 1),
(13671, 1),
(13672, 1),
(13673, 1),
(13674, 1),
(13675, 1),
(13676, 1),
(13677, 1),
(13678, 1),
(13679, 1),
(13680, 1),
(13681, 1),
(13682, 1),
(13683, 1),
(13684, 1),
(13685, 1),
(13686, 1),
(13687, 1),
(13688, 1),
(13689, 1),
(13690, 1),
(13691, 1),
(13692, 1),
(13693, 1),
(13694, 1),
(13695, 1),
(13696, 1),
(13697, 1),
(13698, 1),
(13699, 1),
(13700, 1),
(13701, 1),
(13702, 1),
(13703, 1),
(13704, 1),
(13705, 1),
(13706, 1),
(13707, 1),
(13708, 1),
(13709, 1),
(13710, 1),
(13711, 1),
(13712, 1),
(13713, 1),
(13714, 1),
(13715, 1),
(13716, 1),
(13717, 1),
(13718, 1),
(13719, 1),
(13720, 1),
(13721, 1),
(13722, 1),
(13723, 1),
(13724, 1),
(13725, 1),
(13726, 1),
(13727, 1),
(13728, 1),
(13729, 1),
(13730, 1),
(13731, 1),
(13732, 1),
(13733, 1),
(13734, 1),
(13735, 1),
(13736, 1),
(13737, 1),
(13738, 1),
(13739, 1),
(13740, 1),
(13741, 1),
(13742, 1),
(13743, 1),
(13744, 1),
(13745, 1),
(13746, 1),
(13747, 1),
(13748, 1),
(13749, 1),
(13750, 1),
(13751, 1),
(13752, 1),
(13753, 1),
(13754, 1),
(13755, 1),
(13756, 1),
(13757, 1),
(13758, 1),
(13759, 1),
(13760, 1),
(13761, 1),
(13762, 1),
(13763, 1),
(13764, 1),
(13765, 1),
(13766, 1),
(13767, 1),
(13768, 1),
(13769, 1),
(13770, 1),
(13771, 1),
(13772, 1),
(13773, 1),
(13774, 1),
(13775, 1),
(13776, 1),
(13777, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(13778, 1),
(13779, 1),
(13780, 1),
(13781, 1),
(13782, 1),
(13783, 1),
(13784, 1),
(13785, 1),
(13786, 1),
(13787, 1),
(13788, 1),
(13789, 1),
(13790, 1),
(13791, 1),
(13792, 1),
(13793, 1),
(13794, 1),
(13795, 1),
(13796, 1),
(13797, 1),
(13798, 1),
(13799, 1),
(13800, 1),
(13801, 1),
(13802, 1),
(13803, 1),
(13804, 1),
(13805, 1),
(13806, 1),
(13807, 1),
(13808, 1),
(13809, 1),
(13810, 1),
(13811, 1),
(13812, 1),
(13813, 1),
(13814, 1),
(13815, 1),
(13816, 1),
(13817, 1),
(13818, 1),
(13819, 1),
(13820, 1),
(13821, 1),
(13822, 1),
(13823, 1),
(13824, 1),
(13825, 1),
(13826, 1),
(13827, 1),
(13828, 1),
(13829, 1),
(13830, 1),
(13831, 1),
(13832, 1),
(13833, 1),
(13834, 1),
(13835, 1),
(13836, 1),
(13837, 1),
(13838, 1),
(13839, 1),
(13840, 1),
(13841, 1),
(13842, 1),
(13843, 1),
(13844, 1),
(13845, 1),
(13846, 1),
(13847, 1),
(13848, 1),
(13849, 1),
(13850, 1),
(13851, 1),
(13852, 1),
(13853, 1),
(13854, 1),
(13855, 1),
(13856, 1),
(13857, 1),
(13858, 1),
(13859, 1),
(13860, 1),
(13861, 1),
(13862, 1),
(13863, 1),
(13864, 1),
(13865, 1),
(13866, 1),
(13867, 1),
(13868, 1),
(13869, 1),
(13870, 1),
(13871, 1),
(13872, 1),
(13873, 1),
(13874, 1),
(13875, 1),
(13876, 1),
(13877, 1),
(13878, 1),
(13879, 1),
(13880, 1),
(13881, 1),
(13882, 1),
(13883, 1),
(13884, 1),
(13885, 1),
(13886, 1),
(13887, 1),
(13888, 1),
(13889, 1),
(13890, 1),
(13891, 1),
(13892, 1),
(13893, 1),
(13894, 1),
(13895, 1),
(13896, 1),
(13897, 1),
(13898, 1),
(13899, 1),
(13900, 1),
(13901, 1),
(13902, 1),
(13903, 1),
(13904, 1),
(13905, 1),
(13906, 1),
(13907, 1),
(13908, 1),
(13909, 1),
(13910, 1),
(13911, 1),
(13912, 1),
(13913, 1),
(13914, 1),
(13915, 1),
(13916, 1),
(13917, 1),
(13918, 1),
(13919, 1),
(13920, 1),
(13921, 1),
(13922, 1),
(13923, 1),
(13924, 1),
(13925, 1),
(13926, 1),
(13927, 1),
(13928, 1),
(13929, 1),
(13930, 1),
(13931, 1),
(13932, 1),
(13933, 1),
(13934, 1),
(13935, 1),
(13936, 1),
(13937, 1),
(13938, 1),
(13939, 1),
(13940, 1),
(13941, 1),
(13942, 1),
(13943, 1),
(13944, 1),
(13945, 1),
(13946, 1),
(13947, 1),
(13948, 1),
(13949, 1),
(13950, 1),
(13951, 1),
(13952, 1),
(13953, 1),
(13954, 1),
(13955, 1),
(13956, 1),
(13957, 1),
(13958, 1),
(13959, 1),
(13960, 1),
(13961, 1),
(13962, 1),
(13963, 1),
(13964, 1),
(13965, 1),
(13966, 1),
(13967, 1),
(13968, 1),
(13969, 1),
(13970, 1),
(13971, 1),
(13972, 1),
(13973, 1),
(13974, 1),
(13975, 1),
(13976, 1),
(13977, 1),
(13978, 1),
(13979, 1),
(13980, 1),
(13981, 1),
(13982, 1),
(13983, 1),
(13984, 1),
(13985, 1),
(13986, 1),
(13987, 1),
(13988, 1),
(13989, 1),
(13990, 1),
(13991, 1),
(13992, 1),
(13993, 1),
(13994, 1),
(13995, 1),
(13996, 1),
(13997, 1),
(13998, 1),
(13999, 1),
(14000, 1),
(14001, 1),
(14002, 1),
(14003, 1),
(14004, 1),
(14005, 1),
(14006, 1),
(14007, 1),
(14008, 1),
(14009, 1),
(14010, 1),
(14011, 1),
(14012, 1),
(14013, 1),
(14014, 1),
(14015, 1),
(14016, 1),
(14017, 1),
(14018, 1),
(14019, 1),
(14020, 1),
(14021, 1),
(14022, 1),
(14023, 1),
(14024, 1),
(14025, 1),
(14026, 1),
(14027, 1),
(14028, 1),
(14029, 1),
(14030, 1),
(14031, 1),
(14032, 1),
(14033, 1),
(14034, 1),
(14035, 1),
(14036, 1),
(14037, 1),
(14038, 1),
(14039, 1),
(14040, 1),
(14041, 1),
(14042, 1),
(14043, 1),
(14044, 1),
(14045, 1),
(14046, 1),
(14047, 1),
(14048, 1),
(14049, 1),
(14050, 1),
(14051, 1),
(14052, 1),
(14053, 1),
(14054, 1),
(14055, 1),
(14056, 1),
(14057, 1),
(14058, 1),
(14059, 1),
(14060, 1),
(14061, 1),
(14062, 1),
(14063, 1),
(14064, 1),
(14065, 1),
(14066, 1),
(14067, 1),
(14068, 1),
(14069, 1),
(14070, 1),
(14071, 1),
(14072, 1),
(14073, 1),
(14074, 1),
(14075, 1),
(14076, 1),
(14077, 1),
(14078, 1),
(14079, 1),
(14080, 1),
(14081, 1),
(14082, 1),
(14083, 1),
(14084, 1),
(14085, 1),
(14086, 1),
(14087, 1),
(14088, 1),
(14089, 1),
(14090, 1),
(14091, 1),
(14092, 1),
(14093, 1),
(14094, 1),
(14095, 1),
(14096, 1),
(14097, 1),
(14098, 1),
(14099, 1),
(14100, 1),
(14101, 1),
(14102, 1),
(14103, 1),
(14104, 1),
(14105, 1),
(14106, 1),
(14107, 1),
(14108, 1),
(14109, 1),
(14110, 1),
(14111, 1),
(14112, 1),
(14113, 1),
(14114, 1),
(14115, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(14116, 1),
(14117, 1),
(14118, 1),
(14119, 1),
(14120, 1),
(14121, 1),
(14122, 1),
(14123, 1),
(14124, 1),
(14125, 1),
(14126, 1),
(14127, 1),
(14128, 1),
(14129, 1),
(14130, 1),
(14131, 1),
(14132, 1),
(14133, 1),
(14134, 1),
(14135, 1),
(14136, 1),
(14137, 1),
(14138, 1),
(14139, 1),
(14140, 1),
(14141, 1),
(14142, 1),
(14143, 1),
(14144, 1),
(14145, 1),
(14146, 1),
(14147, 1),
(14148, 1),
(14149, 1),
(14150, 1),
(14151, 1),
(14152, 1),
(14153, 1),
(14154, 1),
(14155, 1),
(14156, 1),
(14157, 1),
(14158, 1),
(14159, 1),
(14160, 1),
(14161, 1),
(14162, 1),
(14163, 1),
(14164, 1),
(14165, 1),
(14166, 1),
(14167, 1),
(14168, 1),
(14169, 1),
(14170, 1),
(14171, 1),
(14172, 1),
(14173, 1),
(14174, 1),
(14175, 1),
(14176, 1),
(14177, 1),
(14178, 1),
(14179, 1),
(14180, 1),
(14181, 1),
(14182, 1),
(14183, 1),
(14184, 1),
(14185, 1),
(14186, 1),
(14187, 1),
(14188, 1),
(14189, 1),
(14190, 1),
(14191, 1),
(14192, 1),
(14193, 1),
(14194, 1),
(14195, 1),
(14196, 1),
(14197, 1),
(14198, 1),
(14199, 1),
(14200, 1),
(14201, 1),
(14202, 1),
(14203, 1),
(14204, 1),
(14205, 1),
(14206, 1),
(14207, 1),
(14208, 1),
(14209, 1),
(14210, 1),
(14211, 1),
(14212, 1),
(14213, 1),
(14214, 1),
(14215, 1),
(14216, 1),
(14217, 1),
(14218, 1),
(14219, 1),
(14220, 1),
(14221, 1),
(14222, 1),
(14223, 1),
(14224, 1),
(14225, 1),
(14226, 1),
(14227, 1),
(14228, 1),
(14229, 1),
(14230, 1),
(14231, 1),
(14232, 1),
(14233, 1),
(14234, 1),
(14235, 1),
(14236, 1),
(14237, 1),
(14238, 1),
(14239, 1),
(14240, 1),
(14241, 1),
(14242, 1),
(14243, 1),
(14244, 1),
(14245, 1),
(14246, 1),
(14247, 1),
(14248, 1),
(14249, 1),
(14250, 1),
(14251, 1),
(14252, 1),
(14253, 1),
(14254, 1),
(14255, 1),
(14256, 1),
(14257, 1),
(14258, 1),
(14259, 1),
(14260, 1),
(14261, 1),
(14262, 1),
(14263, 1),
(14264, 1),
(14265, 1),
(14266, 1),
(14267, 1),
(14268, 1),
(14269, 1),
(14270, 1),
(14271, 1),
(14272, 1),
(14273, 1),
(14274, 1),
(14275, 1),
(14276, 1),
(14277, 1),
(14278, 1),
(14279, 1),
(14280, 1),
(14281, 1),
(14282, 1),
(14283, 1),
(14284, 1),
(14285, 1),
(14286, 1),
(14287, 1),
(14288, 1),
(14289, 1),
(14290, 1),
(14291, 1),
(14292, 1),
(14293, 1),
(14294, 1),
(14295, 1),
(14296, 1),
(14297, 1),
(14298, 1),
(14299, 1),
(14300, 1),
(14301, 1),
(14302, 1),
(14303, 1),
(14304, 1),
(14305, 1),
(14306, 1),
(14307, 1),
(14308, 1),
(14309, 1),
(14310, 1),
(14311, 1),
(14312, 1),
(14313, 1),
(14314, 1),
(14315, 1),
(14316, 1),
(14317, 1),
(14318, 1),
(14319, 1),
(14320, 1),
(14321, 1),
(14322, 1),
(14323, 1),
(14324, 1),
(14325, 1),
(14326, 1),
(14327, 1),
(14328, 1),
(14329, 1),
(14330, 1),
(14331, 1),
(14332, 1),
(14333, 1),
(14334, 1),
(14335, 1),
(14336, 1),
(14337, 1),
(14338, 1),
(14339, 1),
(14340, 1),
(14341, 1),
(14342, 1),
(14343, 1),
(14344, 1),
(14345, 1),
(14346, 1),
(14347, 1),
(14348, 1),
(14349, 1),
(14350, 1),
(14351, 1),
(14352, 1),
(14353, 1),
(14354, 1),
(14355, 1),
(14356, 1),
(14357, 1),
(14358, 1),
(14359, 1),
(14360, 1),
(14361, 1),
(14362, 1),
(14363, 1),
(14364, 1),
(14365, 1),
(14366, 1),
(14367, 1),
(14368, 1),
(14369, 1),
(14370, 1),
(14371, 1),
(14372, 1),
(14373, 1),
(14374, 1),
(14375, 1),
(14376, 1),
(14377, 1),
(14378, 1),
(14379, 1),
(14380, 1),
(14381, 1),
(14382, 1),
(14383, 1),
(14384, 1),
(14385, 1),
(14386, 1),
(14387, 1),
(14388, 1),
(14389, 1),
(14390, 1),
(14391, 1),
(14392, 1),
(14393, 1),
(14394, 1),
(14395, 1),
(14396, 1),
(14397, 1),
(14398, 1),
(14399, 1),
(14400, 1),
(14401, 1),
(14402, 1),
(14403, 1),
(14404, 1),
(14405, 1),
(14406, 1),
(14407, 1),
(14408, 1),
(14409, 1),
(14410, 1),
(14411, 1),
(14412, 1),
(14413, 1),
(14414, 1),
(14415, 1),
(14416, 1),
(14417, 1),
(14418, 1),
(14419, 1),
(14420, 1),
(14421, 1),
(14422, 1),
(14423, 1),
(14424, 1),
(14425, 1),
(14426, 1),
(14427, 1),
(14428, 1),
(14429, 1),
(14430, 1),
(14431, 1),
(14432, 1),
(14433, 1),
(14434, 1),
(14435, 1),
(14436, 1),
(14437, 1),
(14438, 1),
(14439, 1),
(14440, 1),
(14441, 1),
(14442, 1),
(14443, 1),
(14444, 1),
(14445, 1),
(14446, 1),
(14447, 1),
(14448, 1),
(14449, 1),
(14450, 1),
(14451, 1),
(14452, 1),
(14453, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(14454, 1),
(14455, 1),
(14456, 1),
(14457, 1),
(14458, 1),
(14459, 1),
(14460, 1),
(14461, 1),
(14462, 1),
(14463, 1),
(14464, 1),
(14465, 1),
(14466, 1),
(14467, 1),
(14468, 1),
(14469, 1),
(14470, 1),
(14471, 1),
(14472, 1),
(14473, 1),
(14474, 1),
(14475, 1),
(14476, 1),
(14477, 1),
(14478, 1),
(14479, 1),
(14480, 1),
(14481, 1),
(14482, 1),
(14483, 1),
(14484, 1),
(14485, 1),
(14486, 1),
(14487, 1),
(14488, 1),
(14489, 1),
(14490, 1),
(14491, 1),
(14492, 1),
(14493, 1),
(14494, 1),
(14495, 1),
(14496, 1),
(14497, 1),
(14498, 1),
(14499, 1),
(14500, 1),
(14501, 1),
(14502, 1),
(14503, 1),
(14504, 1),
(14505, 1),
(14506, 1),
(14507, 1),
(14508, 1),
(14509, 1),
(14510, 1),
(14511, 1),
(14512, 1),
(14513, 1),
(14514, 1),
(14515, 1),
(14516, 1),
(14517, 1),
(14518, 1),
(14519, 1),
(14520, 1),
(14521, 1),
(14522, 1),
(14523, 1),
(14524, 1),
(14525, 1),
(14526, 1),
(14527, 1),
(14528, 1),
(14529, 1),
(14530, 1),
(14531, 1),
(14532, 1),
(14533, 1),
(14534, 1),
(14535, 1),
(14536, 1),
(14537, 1),
(14538, 1),
(14539, 1),
(14540, 1),
(14541, 1),
(14542, 1),
(14543, 1),
(14544, 1),
(14545, 1),
(14546, 1),
(14547, 1),
(14548, 1),
(14549, 1),
(14550, 1),
(14551, 1),
(14552, 1),
(14553, 1),
(14554, 1),
(14555, 1),
(14556, 1),
(14557, 1),
(14558, 1),
(14559, 1),
(14560, 1),
(14561, 1),
(14562, 1),
(14563, 1),
(14564, 1),
(14565, 1),
(14566, 1),
(14567, 1),
(14568, 1),
(14569, 1),
(14570, 1),
(14571, 1),
(14572, 1),
(14573, 1),
(14574, 1),
(14575, 1),
(14576, 1),
(14577, 1),
(14578, 1),
(14579, 1),
(14580, 1),
(14581, 1),
(14582, 1),
(14583, 1),
(14584, 1),
(14585, 1),
(14586, 1),
(14587, 1),
(14588, 1),
(14589, 1),
(14590, 1),
(14591, 1),
(14592, 1),
(14593, 1),
(14594, 1),
(14595, 1),
(14596, 1),
(14597, 1),
(14598, 1),
(14599, 1),
(14600, 1),
(14601, 1),
(14602, 1),
(14603, 1),
(14604, 1),
(14605, 1),
(14606, 1),
(14607, 1),
(14608, 1),
(14609, 1),
(14610, 1),
(14611, 1),
(14612, 1),
(14613, 1),
(14614, 1),
(14615, 1),
(14616, 1),
(14617, 1),
(14618, 1),
(14619, 1),
(14620, 1),
(14621, 1),
(14622, 1),
(14623, 1),
(14624, 1),
(14625, 1),
(14626, 1),
(14627, 1),
(14628, 1),
(14629, 1),
(14630, 1),
(14631, 1),
(14632, 1),
(14633, 1),
(14634, 1),
(14635, 1),
(14636, 1),
(14637, 1),
(14638, 1),
(14639, 1),
(14640, 1),
(14641, 1),
(14642, 1),
(14643, 1),
(14644, 1),
(14645, 1),
(14646, 1),
(14647, 1),
(14648, 1),
(14649, 1),
(14650, 1),
(14651, 1),
(14652, 1),
(14653, 1),
(14654, 1),
(14655, 1),
(14656, 1),
(14657, 1),
(14658, 1),
(14659, 1),
(14660, 1),
(14661, 1),
(14662, 1),
(14663, 1),
(14664, 1),
(14665, 1),
(14666, 1),
(14667, 1),
(14668, 1),
(14669, 1),
(14670, 1),
(14671, 1),
(14672, 1),
(14673, 1),
(14674, 1),
(14675, 1),
(14676, 1),
(14677, 1),
(14678, 1),
(14679, 1),
(14680, 1),
(14681, 1),
(14682, 1),
(14683, 1),
(14684, 1),
(14685, 1),
(14686, 1),
(14687, 1),
(14688, 1),
(14689, 1),
(14690, 1),
(14691, 1),
(14692, 1),
(14693, 1),
(14694, 1),
(14695, 1),
(14696, 1),
(14697, 1),
(14698, 1),
(14699, 1),
(14700, 1),
(14701, 1),
(14702, 1),
(14703, 1),
(14704, 1),
(14705, 1),
(14706, 1),
(14707, 1),
(14708, 1),
(14709, 1),
(14710, 1),
(14711, 1),
(14712, 1),
(14713, 1),
(14714, 1),
(14715, 1),
(14716, 1),
(14717, 1),
(14718, 1),
(14719, 1),
(14720, 1),
(14721, 1),
(14722, 1),
(14723, 1),
(14724, 1),
(14725, 1),
(14726, 1),
(14727, 1),
(14728, 1),
(14729, 1),
(14730, 1),
(14731, 1),
(14732, 1),
(14733, 1),
(14734, 1),
(14735, 1),
(14736, 1),
(14737, 1),
(14738, 1),
(14739, 1),
(14740, 1),
(14741, 1),
(14742, 1),
(14743, 1),
(14744, 1),
(14745, 1),
(14746, 1),
(14747, 1),
(14748, 1),
(14749, 1),
(14750, 1),
(14751, 1),
(14752, 1),
(14753, 1),
(14754, 1),
(14755, 1),
(14756, 1),
(14757, 1),
(14758, 1),
(14759, 1),
(14760, 1),
(14761, 1),
(14762, 1),
(14763, 1),
(14764, 1),
(14765, 1),
(14766, 1),
(14767, 1),
(14768, 1),
(14769, 1),
(14770, 1),
(14771, 1),
(14772, 1),
(14773, 1),
(14774, 1),
(14775, 1),
(14776, 1),
(14777, 1),
(14778, 1),
(14779, 1),
(14780, 1),
(14781, 1),
(14782, 1),
(14783, 1),
(14784, 1),
(14785, 1),
(14786, 1),
(14787, 1),
(14788, 1),
(14789, 1),
(14790, 1),
(14791, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(14792, 1),
(14793, 1),
(14794, 1),
(14795, 1),
(14796, 1),
(14797, 1),
(14798, 1),
(14799, 1),
(14800, 1),
(14801, 1),
(14802, 1),
(14803, 1),
(14804, 1),
(14805, 1),
(14806, 1),
(14807, 1),
(14808, 1),
(14809, 1),
(14810, 1),
(14811, 1),
(14812, 1),
(14813, 1),
(14814, 1),
(14815, 1),
(14816, 1),
(14817, 1),
(14818, 1),
(14819, 1),
(14820, 1),
(14821, 1),
(14822, 1),
(14823, 1),
(14824, 1),
(14825, 1),
(14826, 1),
(14827, 1),
(14828, 1),
(14829, 1),
(14830, 1),
(14831, 1),
(14832, 1),
(14833, 1),
(14834, 1),
(14835, 1),
(14836, 1),
(14837, 1),
(14838, 1),
(14839, 1),
(14840, 1),
(14841, 1),
(14842, 1),
(14843, 1),
(14844, 1),
(14845, 1),
(14846, 1),
(14847, 1),
(14848, 1),
(14849, 1),
(14850, 1),
(14851, 1),
(14852, 1),
(14853, 1),
(14854, 1),
(14855, 1),
(14856, 1),
(14857, 1),
(14858, 1),
(14859, 1),
(14860, 1),
(14861, 1),
(14862, 1),
(14863, 1),
(14864, 1),
(14865, 1),
(14866, 1),
(14867, 1),
(14868, 1),
(14869, 1),
(14870, 1),
(14871, 1),
(14872, 1),
(14873, 1),
(14874, 1),
(14875, 1),
(14876, 1),
(14877, 1),
(14878, 1),
(14879, 1),
(14880, 1),
(14881, 1),
(14882, 1),
(14883, 1),
(14884, 1),
(14885, 1),
(14886, 1),
(14887, 1),
(14888, 1),
(14889, 1),
(14890, 1),
(14891, 1),
(14892, 1),
(14893, 1),
(14894, 1),
(14895, 1),
(14896, 1),
(14897, 1),
(14898, 1),
(14899, 1),
(14900, 1),
(14901, 1),
(14902, 1),
(14903, 1),
(14904, 1),
(14905, 1),
(14906, 1),
(14907, 1),
(14908, 1),
(14909, 1),
(14910, 1),
(14911, 1),
(14912, 1),
(14913, 1),
(14914, 1),
(14915, 1),
(14916, 1),
(14917, 1),
(14918, 1),
(14919, 1),
(14920, 1),
(14921, 1),
(14922, 1),
(14923, 1),
(14924, 1),
(14925, 1),
(14926, 1),
(14927, 1),
(14928, 1),
(14929, 1),
(14930, 1),
(14931, 1),
(14932, 1),
(14933, 1),
(14934, 1),
(14935, 1),
(14936, 1),
(14937, 1),
(14938, 1),
(14939, 1),
(14940, 1),
(14941, 1),
(14942, 1),
(14943, 1),
(14944, 1),
(14945, 1),
(14946, 1),
(14947, 1),
(14948, 1),
(14949, 1),
(14950, 1),
(14951, 1),
(14952, 1),
(14953, 1),
(14954, 1),
(14955, 1),
(14956, 1),
(14957, 1),
(14958, 1),
(14959, 1),
(14960, 1),
(14961, 1),
(14962, 1),
(14963, 1),
(14964, 1),
(14965, 1),
(14966, 1),
(14967, 1),
(14968, 1),
(14969, 1),
(14970, 1),
(14971, 1),
(14972, 1),
(14973, 1),
(14974, 1),
(14975, 1),
(14976, 1),
(14977, 1),
(14978, 1),
(14979, 1),
(14980, 1),
(14981, 1),
(14982, 1),
(14983, 1),
(14984, 1),
(14985, 1),
(14986, 1),
(14987, 1),
(14988, 1),
(14989, 1),
(14990, 1),
(14991, 1),
(14992, 1),
(14993, 1),
(14994, 1),
(14995, 1),
(14996, 1),
(14997, 1),
(14998, 1),
(14999, 1),
(15000, 1),
(15001, 1),
(15002, 1),
(15003, 1),
(15004, 1),
(15005, 1),
(15006, 1),
(15007, 1),
(15008, 1),
(15009, 1),
(15010, 1),
(15011, 1),
(15012, 1),
(15013, 1),
(15014, 1),
(15015, 1),
(15016, 1),
(15017, 1),
(15018, 1),
(15019, 1),
(15020, 1),
(15021, 1),
(15022, 1),
(15023, 1),
(15024, 1),
(15025, 1),
(15026, 1),
(15027, 1),
(15028, 1),
(15029, 1),
(15030, 1),
(15031, 1),
(15032, 1),
(15033, 1),
(15034, 1),
(15035, 1),
(15036, 1),
(15037, 1),
(15038, 1),
(15039, 1),
(15040, 1),
(15041, 1),
(15042, 1),
(15043, 1),
(15044, 1),
(15045, 1),
(15046, 1),
(15047, 1),
(15048, 1),
(15049, 1),
(15050, 1),
(15051, 1),
(15052, 1),
(15053, 1),
(15054, 1),
(15055, 1),
(15056, 1),
(15057, 1),
(15058, 1),
(15059, 1),
(15060, 1),
(15061, 1),
(15062, 1),
(15063, 1),
(15064, 1),
(15065, 1),
(15066, 1),
(15067, 1),
(15068, 1),
(15069, 1),
(15070, 1),
(15071, 1),
(15072, 1),
(15073, 1),
(15074, 1),
(15075, 1),
(15076, 1),
(15077, 1),
(15078, 1),
(15079, 1),
(15080, 1),
(15081, 1),
(15082, 1),
(15083, 1),
(15084, 1),
(15085, 1),
(15086, 1),
(15087, 1),
(15088, 1),
(15089, 1),
(15090, 1),
(15091, 1),
(15092, 1),
(15093, 1),
(15094, 1),
(15095, 1),
(15096, 1),
(15097, 1),
(15098, 1),
(15099, 1),
(15100, 1),
(15101, 1),
(15102, 1),
(15103, 1),
(15104, 1),
(15105, 1),
(15106, 1),
(15107, 1),
(15108, 1),
(15109, 1),
(15110, 1),
(15111, 1),
(15112, 1),
(15113, 1),
(15114, 1),
(15115, 1),
(15116, 1),
(15117, 1),
(15118, 1),
(15119, 1),
(15120, 1),
(15121, 1),
(15122, 1),
(15123, 1),
(15124, 1),
(15125, 1),
(15126, 1),
(15127, 1),
(15128, 1),
(15129, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(15130, 1),
(15131, 1),
(15132, 1),
(15133, 1),
(15134, 1),
(15135, 1),
(15136, 1),
(15137, 1),
(15138, 1),
(15139, 1),
(15140, 1),
(15141, 1),
(15142, 1),
(15143, 1),
(15144, 1),
(15145, 1),
(15146, 1),
(15147, 1),
(15148, 1),
(15149, 1),
(15150, 1),
(15151, 1),
(15152, 1),
(15153, 1),
(15154, 1),
(15155, 1),
(15156, 1),
(15157, 1),
(15158, 1),
(15159, 1),
(15160, 1),
(15161, 1),
(15162, 1),
(15163, 1),
(15164, 1),
(15165, 1),
(15166, 1),
(15167, 1),
(15168, 1),
(15169, 1),
(15170, 1),
(15171, 1),
(15172, 1),
(15173, 1),
(15174, 1),
(15175, 1),
(15176, 1),
(15177, 1),
(15178, 1),
(15179, 1),
(15180, 1),
(15181, 1),
(15182, 1),
(15183, 1),
(15184, 1),
(15185, 1),
(15186, 1),
(15187, 1),
(15188, 1),
(15189, 1),
(15190, 1),
(15191, 1),
(15192, 1),
(15193, 1),
(15194, 1),
(15195, 1),
(15196, 1),
(15197, 1),
(15198, 1),
(15199, 1),
(15200, 1),
(15201, 1),
(15202, 1),
(15203, 1),
(15204, 1),
(15205, 1),
(15206, 1),
(15207, 1),
(15208, 1),
(15209, 1),
(15210, 1),
(15211, 1),
(15212, 1),
(15213, 1),
(15214, 1),
(15215, 1),
(15216, 1),
(15217, 1),
(15218, 1),
(15219, 1),
(15220, 1),
(15221, 1),
(15222, 1),
(15223, 1),
(15224, 1),
(15225, 1),
(15226, 1),
(15227, 1),
(15228, 1),
(15229, 1),
(15230, 1),
(15231, 1),
(15232, 1),
(15233, 1),
(15234, 1),
(15235, 1),
(15236, 1),
(15237, 1),
(15238, 1),
(15239, 1),
(15240, 1),
(15241, 1),
(15242, 1),
(15243, 1),
(15244, 1),
(15245, 1),
(15246, 1),
(15247, 1),
(15248, 1),
(15249, 1),
(15250, 1),
(15251, 1),
(15252, 1),
(15253, 1),
(15254, 1),
(15255, 1),
(15256, 1),
(15257, 1),
(15258, 1),
(15259, 1),
(15260, 1),
(15261, 1),
(15262, 1),
(15263, 1),
(15264, 1),
(15265, 1),
(15266, 1),
(15267, 1),
(15268, 1),
(15269, 1),
(15270, 1),
(15271, 1),
(15272, 1),
(15273, 1),
(15274, 1),
(15275, 1),
(15276, 1),
(15277, 1),
(15278, 1),
(15279, 1),
(15280, 1),
(15281, 1),
(15282, 1),
(15283, 1),
(15284, 1),
(15285, 1),
(15286, 1),
(15287, 1),
(15288, 1),
(15289, 1),
(15290, 1),
(15291, 1),
(15292, 1),
(15293, 1),
(15294, 1),
(15295, 1),
(15296, 1),
(15297, 1),
(15298, 1),
(15299, 1),
(15300, 1),
(15301, 1),
(15302, 1),
(15303, 1),
(15304, 1),
(15305, 1),
(15306, 1),
(15307, 1),
(15308, 1),
(15309, 1),
(15310, 1),
(15311, 1),
(15312, 1),
(15313, 1),
(15314, 1),
(15315, 1),
(15316, 1),
(15317, 1),
(15318, 1),
(15319, 1),
(15320, 1),
(15321, 1),
(15322, 1),
(15323, 1),
(15324, 1),
(15325, 1),
(15326, 1),
(15327, 1),
(15328, 1),
(15329, 1),
(15330, 1),
(15331, 1),
(15332, 1),
(15333, 1),
(15334, 1),
(15335, 1),
(15336, 1),
(15337, 1),
(15338, 1),
(15339, 1),
(15340, 1),
(15341, 1),
(15342, 1),
(15343, 1),
(15344, 1),
(15345, 1),
(15346, 1),
(15347, 1),
(15348, 1),
(15349, 1),
(15350, 1),
(15351, 1),
(15352, 1),
(15353, 1),
(15354, 1),
(15355, 1),
(15356, 1),
(15357, 1),
(15358, 1),
(15359, 1),
(15360, 1),
(15361, 1),
(15362, 1),
(15363, 1),
(15364, 1),
(15365, 1),
(15366, 1),
(15367, 1),
(15368, 1),
(15369, 1),
(15370, 1),
(15371, 1),
(15372, 1),
(15373, 1),
(15374, 1),
(15375, 1),
(15376, 1),
(15377, 1),
(15378, 1),
(15379, 1),
(15380, 1),
(15381, 1),
(15382, 1),
(15383, 1),
(15384, 1),
(15385, 1),
(15386, 1),
(15387, 1),
(15388, 1),
(15389, 1),
(15390, 1),
(15391, 1),
(15392, 1),
(15393, 1),
(15394, 1),
(15395, 1),
(15396, 1),
(15397, 1),
(15398, 1),
(15399, 1),
(15400, 1),
(15401, 1),
(15402, 1),
(15403, 1),
(15404, 1),
(15405, 1),
(15406, 1),
(15407, 1),
(15408, 1),
(15409, 1),
(15410, 1),
(15411, 1),
(15412, 1),
(15413, 1),
(15414, 1),
(15415, 1),
(15416, 1),
(15417, 1),
(15418, 1),
(15419, 1),
(15420, 1),
(15421, 1),
(15422, 1),
(15423, 1),
(15424, 1),
(15425, 1),
(15426, 1),
(15427, 1),
(15428, 1),
(15429, 1),
(15430, 1),
(15431, 1),
(15432, 1),
(15433, 1),
(15434, 1),
(15435, 1),
(15436, 1),
(15437, 1),
(15438, 1),
(15439, 1),
(15440, 1),
(15441, 1),
(15442, 1),
(15443, 1),
(15444, 1),
(15445, 1),
(15446, 1),
(15447, 1),
(15448, 1),
(15449, 1),
(15450, 1),
(15451, 1),
(15452, 1),
(15453, 1),
(15454, 1),
(15455, 1),
(15456, 1),
(15457, 1),
(15458, 1),
(15459, 1),
(15460, 1),
(15461, 1),
(15462, 1),
(15463, 1),
(15464, 1),
(15465, 1),
(15466, 1),
(15467, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(15468, 1),
(15469, 1),
(15470, 1),
(15471, 1),
(15472, 1),
(15473, 1),
(15474, 1),
(15475, 1),
(15476, 1),
(15477, 1),
(15478, 1),
(15479, 1),
(15480, 1),
(15481, 1),
(15482, 1),
(15483, 1),
(15484, 1),
(15485, 1),
(15486, 1),
(15487, 1),
(15488, 1),
(15489, 1),
(15490, 1),
(15491, 1),
(15492, 1),
(15493, 1),
(15494, 1),
(15495, 1),
(15496, 1),
(15497, 1),
(15498, 1),
(15499, 1),
(15500, 1),
(15501, 1),
(15502, 1),
(15503, 1),
(15504, 1),
(15505, 1),
(15506, 1),
(15507, 1),
(15508, 1),
(15509, 1),
(15510, 1),
(15511, 1),
(15512, 1),
(15513, 1),
(15514, 1),
(15515, 1),
(15516, 1),
(15517, 1),
(15518, 1),
(15519, 1),
(15520, 1),
(15521, 1),
(15522, 1),
(15523, 1),
(15524, 1),
(15525, 1),
(15526, 1),
(15527, 1),
(15528, 1),
(15529, 1),
(15530, 1),
(15531, 1),
(15532, 1),
(15533, 1),
(15534, 1),
(15535, 1),
(15536, 1),
(15537, 1),
(15538, 1),
(15539, 1),
(15540, 1),
(15541, 1),
(15542, 1),
(15543, 1),
(15544, 1),
(15545, 1),
(15546, 1),
(15547, 1),
(15548, 1),
(15549, 1),
(15550, 1),
(15551, 1),
(15552, 1),
(15553, 1),
(15554, 1),
(15555, 1),
(15556, 1),
(15557, 1),
(15558, 1),
(15559, 1),
(15560, 1),
(15561, 1),
(15562, 1),
(15563, 1),
(15564, 1),
(15565, 1),
(15566, 1),
(15567, 1),
(15568, 1),
(15569, 1),
(15570, 1),
(15571, 1),
(15572, 1),
(15573, 1),
(15574, 1),
(15575, 1),
(15576, 1),
(15577, 1),
(15578, 1),
(15579, 1),
(15580, 1),
(15581, 1),
(15582, 1),
(15583, 1),
(15584, 1),
(15585, 1),
(15586, 1),
(15587, 1),
(15588, 1),
(15589, 1),
(15590, 1),
(15591, 1),
(15592, 1),
(15593, 1),
(15594, 1),
(15595, 1),
(15596, 1),
(15597, 1),
(15598, 1),
(15599, 1),
(15600, 1),
(15601, 1),
(15602, 1),
(15603, 1),
(15604, 1),
(15605, 1),
(15606, 1),
(15607, 1),
(15608, 1),
(15609, 1),
(15610, 1),
(15611, 1),
(15612, 1),
(15613, 1),
(15614, 1),
(15615, 1),
(15616, 1),
(15617, 1),
(15618, 1),
(15619, 1),
(15620, 1),
(15621, 1),
(15622, 1),
(15623, 1),
(15624, 1),
(15625, 1),
(15626, 1),
(15627, 1),
(15628, 1),
(15629, 1),
(15630, 1),
(15631, 1),
(15632, 1),
(15633, 1),
(15634, 1),
(15635, 1),
(15636, 1),
(15637, 1),
(15638, 1),
(15639, 1),
(15640, 1),
(15641, 1),
(15642, 1),
(15643, 1),
(15644, 1),
(15645, 1),
(15646, 1),
(15647, 1),
(15648, 1),
(15649, 1),
(15650, 1),
(15651, 1),
(15652, 1),
(15653, 1),
(15654, 1),
(15655, 1),
(15656, 1),
(15657, 1),
(15658, 1),
(15659, 1),
(15660, 1),
(15661, 1),
(15662, 1),
(15663, 1),
(15664, 1),
(15665, 1),
(15666, 1),
(15667, 1),
(15668, 1),
(15669, 1),
(15670, 1),
(15671, 1),
(15672, 1),
(15673, 1),
(15674, 1),
(15675, 1),
(15676, 1),
(15677, 1),
(15678, 1),
(15679, 1),
(15680, 1),
(15681, 1),
(15682, 1),
(15683, 1),
(15684, 1),
(15685, 1),
(15686, 1),
(15687, 1),
(15688, 1),
(15689, 1),
(15690, 1),
(15691, 1),
(15692, 1),
(15693, 1),
(15694, 1),
(15695, 1),
(15696, 1),
(15697, 1),
(15698, 1),
(15699, 1),
(15700, 1),
(15701, 1),
(15702, 1),
(15703, 1),
(15704, 1),
(15705, 1),
(15706, 1),
(15707, 1),
(15708, 1),
(15709, 1),
(15710, 1),
(15711, 1),
(15712, 1),
(15713, 1),
(15714, 1),
(15715, 1),
(15716, 1),
(15717, 1),
(15718, 1),
(15719, 1),
(15720, 1),
(15721, 1),
(15722, 1),
(15723, 1),
(15724, 1),
(15725, 1),
(15726, 1),
(15727, 1),
(15728, 1),
(15729, 1),
(15730, 1),
(15731, 1),
(15732, 1),
(15733, 1),
(15734, 1),
(15735, 1),
(15736, 1),
(15737, 1),
(15738, 1),
(15739, 1),
(15740, 1),
(15741, 1),
(15742, 1),
(15743, 1),
(15744, 1),
(15745, 1),
(15746, 1),
(15747, 1),
(15748, 1),
(15749, 1),
(15750, 1),
(15751, 1),
(15752, 1),
(15753, 1),
(15754, 1),
(15755, 1),
(15756, 1),
(15757, 1),
(15758, 1),
(15759, 1),
(15760, 1),
(15761, 1),
(15762, 1),
(15763, 1),
(15764, 1),
(15765, 1),
(15766, 1),
(15767, 1),
(15768, 1),
(15769, 1),
(15770, 1),
(15771, 1),
(15772, 1),
(15773, 1),
(15774, 1),
(15775, 1),
(15776, 1),
(15777, 1),
(15778, 1),
(15779, 1),
(15780, 1),
(15781, 1),
(15782, 1),
(15783, 1),
(15784, 1),
(15785, 1),
(15786, 1),
(15787, 1),
(15788, 1),
(15789, 1),
(15790, 1),
(15791, 1),
(15792, 1),
(15793, 1),
(15794, 1),
(15795, 1),
(15796, 1),
(15797, 1),
(15798, 1),
(15799, 1),
(15800, 1),
(15801, 1),
(15802, 1),
(15803, 1),
(15804, 1),
(15805, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(15806, 1),
(15807, 1),
(15808, 1),
(15809, 1),
(15810, 1),
(15811, 1),
(15812, 1),
(15813, 1),
(15814, 1),
(15815, 1),
(15816, 1),
(15817, 1),
(15818, 1),
(15819, 1),
(15820, 1),
(15821, 1),
(15822, 1),
(15823, 1),
(15824, 1),
(15825, 1),
(15826, 1),
(15827, 1),
(15828, 1),
(15829, 1),
(15830, 1),
(15831, 1),
(15832, 1),
(15833, 1),
(15834, 1),
(15835, 1),
(15836, 1),
(15837, 1),
(15838, 1),
(15839, 1),
(15840, 1),
(15841, 1),
(15842, 1),
(15843, 1),
(15844, 1),
(15845, 1),
(15846, 1),
(15847, 1),
(15848, 1),
(15849, 1),
(15850, 1),
(15851, 1),
(15852, 1),
(15853, 1),
(15854, 1),
(15855, 1),
(15856, 1),
(15857, 1),
(15858, 1),
(15859, 1),
(15860, 1),
(15861, 1),
(15862, 1),
(15863, 1),
(15864, 1),
(15865, 1),
(15866, 1),
(15867, 1),
(15868, 1),
(15869, 1),
(15870, 1),
(15871, 1),
(15872, 1),
(15873, 1),
(15874, 1),
(15875, 1),
(15876, 1),
(15877, 1),
(15878, 1),
(15879, 1),
(15880, 1),
(15881, 1),
(15882, 1),
(15883, 1),
(15884, 1),
(15885, 1),
(15886, 1),
(15887, 1),
(15888, 1),
(15889, 1),
(15890, 1),
(15891, 1),
(15892, 1),
(15893, 1),
(15894, 1),
(15895, 1),
(15896, 1),
(15897, 1),
(15898, 1),
(15899, 1),
(15900, 1),
(15901, 1),
(15902, 1),
(15903, 1),
(15904, 1),
(15905, 1),
(15906, 1),
(15907, 1),
(15908, 1),
(15909, 1),
(15910, 1),
(15911, 1),
(15912, 1),
(15913, 1),
(15914, 1),
(15915, 1),
(15916, 1),
(15917, 1),
(15918, 1),
(15919, 1),
(15920, 1),
(15921, 1),
(15922, 1),
(15923, 1),
(15924, 1),
(15925, 1),
(15926, 1),
(15927, 1),
(15928, 1),
(15929, 1),
(15930, 1),
(15931, 1),
(15932, 1),
(15933, 1),
(15934, 1),
(15935, 1),
(15936, 1),
(15937, 1),
(15938, 1),
(15939, 1),
(15940, 1),
(15941, 1),
(15942, 1),
(15943, 1),
(15944, 1),
(15945, 1),
(15946, 1),
(15947, 1),
(15948, 1),
(15949, 1),
(15950, 1),
(15951, 1),
(15952, 1),
(15953, 1),
(15954, 1),
(15955, 1),
(15956, 1),
(15957, 1),
(15958, 1),
(15959, 1),
(15960, 1),
(15961, 1),
(15962, 1),
(15963, 1),
(15964, 1),
(15965, 1),
(15966, 1),
(15967, 1),
(15968, 1),
(15969, 1),
(15970, 1),
(15971, 1),
(15972, 1),
(15973, 1),
(15974, 1),
(15975, 1),
(15976, 1),
(15977, 1),
(15978, 1),
(15979, 1),
(15980, 1),
(15981, 1),
(15982, 1),
(15983, 1),
(15984, 1),
(15985, 1),
(15986, 1),
(15987, 1),
(15988, 1),
(15989, 1),
(15990, 1),
(15991, 1),
(15992, 1),
(15993, 1),
(15994, 1),
(15995, 1),
(15996, 1),
(15997, 1),
(15998, 1),
(15999, 1),
(16000, 1),
(16001, 1),
(16002, 1),
(16003, 1),
(16004, 1),
(16005, 1),
(16006, 1),
(16007, 1),
(16008, 1),
(16009, 1),
(16010, 1),
(16011, 1),
(16012, 1),
(16013, 1),
(16014, 1),
(16015, 1),
(16016, 1),
(16017, 1),
(16018, 1),
(16019, 1),
(16020, 1),
(16021, 1),
(16022, 1),
(16023, 1),
(16024, 1),
(16025, 1),
(16026, 1),
(16027, 1),
(16028, 1),
(16029, 1),
(16030, 1),
(16031, 1),
(16032, 1),
(16033, 1),
(16034, 1),
(16035, 1),
(16036, 1),
(16037, 1),
(16038, 1),
(16039, 1),
(16040, 1),
(16041, 1),
(16042, 1),
(16043, 1),
(16044, 1),
(16045, 1),
(16046, 1),
(16047, 1),
(16048, 1),
(16049, 1),
(16050, 1),
(16051, 1),
(16052, 1),
(16053, 1),
(16054, 1),
(16055, 1),
(16056, 1),
(16057, 1),
(16058, 1),
(16059, 1),
(16060, 1),
(16061, 1),
(16062, 1),
(16063, 1),
(16064, 1),
(16065, 1),
(16066, 1),
(16067, 1),
(16068, 1),
(16069, 1),
(16070, 1),
(16071, 1),
(16072, 1),
(16073, 1),
(16074, 1),
(16075, 1),
(16076, 1),
(16077, 1),
(16078, 1),
(16079, 1),
(16080, 1),
(16081, 1),
(16082, 1),
(16083, 1),
(16084, 1),
(16085, 1),
(16086, 1),
(16087, 1),
(16088, 1),
(16089, 1),
(16090, 1),
(16091, 1),
(16092, 1),
(16093, 1),
(16094, 1),
(16095, 1),
(16096, 1),
(16097, 1),
(16098, 1),
(16099, 1),
(16100, 1),
(16101, 1),
(16102, 1),
(16103, 1),
(16104, 1),
(16105, 1),
(16106, 1),
(16107, 1),
(16108, 1),
(16109, 1),
(16110, 1),
(16111, 1),
(16112, 1),
(16113, 1),
(16114, 1),
(16115, 1),
(16116, 1),
(16117, 1),
(16118, 1),
(16119, 1),
(16120, 1),
(16121, 1),
(16122, 1),
(16123, 1),
(16124, 1),
(16125, 1),
(16126, 1),
(16127, 1),
(16128, 1),
(16129, 1),
(16130, 1),
(16131, 1),
(16132, 1),
(16133, 1),
(16134, 1),
(16135, 1),
(16136, 1),
(16137, 1),
(16138, 1),
(16139, 1),
(16140, 1),
(16141, 1),
(16142, 1),
(16143, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(16144, 1),
(16145, 1),
(16146, 1),
(16147, 1),
(16148, 1),
(16149, 1),
(16150, 1),
(16151, 1),
(16152, 1),
(16153, 1),
(16154, 1),
(16155, 1),
(16156, 1),
(16157, 1),
(16158, 1),
(16159, 1),
(16160, 1),
(16161, 1),
(16162, 1),
(16163, 1),
(16164, 1),
(16165, 1),
(16166, 1),
(16167, 1),
(16168, 1),
(16169, 1),
(16170, 1),
(16171, 1),
(16172, 1),
(16173, 1),
(16174, 1),
(16175, 1),
(16176, 1),
(16177, 1),
(16178, 1),
(16179, 1),
(16180, 1),
(16181, 1),
(16182, 1),
(16183, 1),
(16184, 1),
(16185, 1),
(16186, 1),
(16187, 1),
(16188, 1),
(16189, 1),
(16190, 1),
(16191, 1),
(16192, 1),
(16193, 1),
(16194, 1),
(16195, 1),
(16196, 1),
(16197, 1),
(16198, 1),
(16199, 1),
(16200, 1),
(16201, 1),
(16202, 1),
(16203, 1),
(16204, 1),
(16205, 1),
(16206, 1),
(16207, 1),
(16208, 1),
(16209, 1),
(16210, 1),
(16211, 1),
(16212, 1),
(16213, 1),
(16214, 1),
(16215, 1),
(16216, 1),
(16217, 1),
(16218, 1),
(16219, 1),
(16220, 1),
(16221, 1),
(16222, 1),
(16223, 1),
(16224, 1),
(16225, 1),
(16226, 1),
(16227, 1),
(16228, 1),
(16229, 1),
(16230, 1),
(16231, 1),
(16232, 1),
(16233, 1),
(16234, 1),
(16235, 1),
(16236, 1),
(16237, 1),
(16238, 1),
(16239, 1),
(16240, 1),
(16241, 1),
(16242, 1),
(16243, 1),
(16244, 1),
(16245, 1),
(16246, 1),
(16247, 1),
(16248, 1),
(16249, 1),
(16250, 1),
(16251, 1),
(16252, 1),
(16253, 1),
(16254, 1),
(16255, 1),
(16256, 1),
(16257, 1),
(16258, 1),
(16259, 1),
(16260, 1),
(16261, 1),
(16262, 1),
(16263, 1),
(16264, 1),
(16265, 1),
(16266, 1),
(16267, 1),
(16268, 1),
(16269, 1),
(16270, 1),
(16271, 1),
(16272, 1),
(16273, 1),
(16274, 1),
(16275, 1),
(16276, 1),
(16277, 1),
(16278, 1),
(16279, 1),
(16280, 1),
(16281, 1),
(16282, 1),
(16283, 1),
(16284, 1),
(16285, 1),
(16286, 1),
(16287, 1),
(16288, 1),
(16289, 1),
(16290, 1),
(16291, 1),
(16292, 1),
(16293, 1),
(16294, 1),
(16295, 1),
(16296, 1),
(16297, 1),
(16298, 1),
(16299, 1),
(16300, 1),
(16301, 1),
(16302, 1),
(16303, 1),
(16304, 1),
(16305, 1),
(16306, 1),
(16307, 1),
(16308, 1),
(16309, 1),
(16310, 1),
(16311, 1),
(16312, 1),
(16313, 1),
(16314, 1),
(16315, 1),
(16316, 1),
(16317, 1),
(16318, 1),
(16319, 1),
(16320, 1),
(16321, 1),
(16322, 1),
(16323, 1),
(16324, 1),
(16325, 1),
(16326, 1),
(16327, 1),
(16328, 1),
(16329, 1),
(16330, 1),
(16331, 1),
(16332, 1),
(16333, 1),
(16334, 1),
(16335, 1),
(16336, 1),
(16337, 1),
(16338, 1),
(16339, 1),
(16340, 1),
(16341, 1),
(16342, 1),
(16343, 1),
(16344, 1),
(16345, 1),
(16346, 1),
(16347, 1),
(16348, 1),
(16349, 1),
(16350, 1),
(16351, 1),
(16352, 1),
(16353, 1),
(16354, 1),
(16355, 1),
(16356, 1),
(16357, 1),
(16358, 1),
(16359, 1),
(16360, 1),
(16361, 1),
(16362, 1),
(16363, 1),
(16364, 1),
(16365, 1),
(16366, 1),
(16367, 1),
(16368, 1),
(16369, 1),
(16370, 1),
(16371, 1),
(16372, 1),
(16373, 1),
(16374, 1),
(16375, 1),
(16376, 1),
(16377, 1),
(16378, 1),
(16379, 1),
(16380, 1),
(16381, 1),
(16382, 1),
(16383, 1),
(16384, 1),
(16385, 1),
(16386, 1),
(16387, 1),
(16388, 1),
(16389, 1),
(16390, 1),
(16391, 1),
(16392, 1),
(16393, 1),
(16394, 1),
(16395, 1),
(16396, 1),
(16397, 1),
(16398, 1),
(16399, 1),
(16400, 1),
(16401, 1),
(16402, 1),
(16403, 1),
(16404, 1),
(16405, 1),
(16406, 1),
(16407, 1),
(16408, 1),
(16409, 1),
(16410, 1),
(16411, 1),
(16412, 1),
(16413, 1),
(16414, 1),
(16415, 1),
(16416, 1),
(16417, 1),
(16418, 1),
(16419, 1),
(16420, 1),
(16421, 1),
(16422, 1),
(16423, 1),
(16424, 1),
(16425, 1),
(16426, 1),
(16427, 1),
(16428, 1),
(16429, 1),
(16430, 1),
(16431, 1),
(16432, 1),
(16433, 1),
(16434, 1),
(16435, 1),
(16436, 1),
(16437, 1),
(16438, 1),
(16439, 1),
(16440, 1),
(16441, 1),
(16442, 1),
(16443, 1),
(16444, 1),
(16445, 1),
(16446, 1),
(16447, 1),
(16448, 1),
(16449, 1),
(16450, 1),
(16451, 1),
(16452, 1),
(16453, 1),
(16454, 1),
(16455, 1),
(16456, 1),
(16457, 1),
(16458, 1),
(16459, 1),
(16460, 1),
(16461, 1),
(16462, 1),
(16463, 1),
(16464, 1),
(16465, 1),
(16466, 1),
(16467, 1),
(16468, 1),
(16469, 1),
(16470, 1),
(16471, 1),
(16472, 1),
(16473, 1),
(16474, 1),
(16475, 1),
(16476, 1),
(16477, 1),
(16478, 1),
(16479, 1),
(16480, 1),
(16481, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(16482, 1),
(16483, 1),
(16484, 1),
(16485, 1),
(16486, 1),
(16487, 1),
(16488, 1),
(16489, 1),
(16490, 1),
(16491, 1),
(16492, 1),
(16493, 1),
(16494, 1),
(16495, 1),
(16496, 1),
(16497, 1),
(16498, 1),
(16499, 1),
(16500, 1),
(16501, 1),
(16502, 1),
(16503, 1),
(16504, 1),
(16505, 1),
(16506, 1),
(16507, 1),
(16508, 1),
(16509, 1),
(16510, 1),
(16511, 1),
(16512, 1),
(16513, 1),
(16514, 1),
(16515, 1),
(16516, 1),
(16517, 1),
(16518, 1),
(16519, 1),
(16520, 1),
(16521, 1),
(16522, 1),
(16523, 1),
(16524, 1),
(16525, 1),
(16526, 1),
(16527, 1),
(16528, 1),
(16529, 1),
(16530, 1),
(16531, 1),
(16532, 1),
(16533, 1),
(16534, 1),
(16535, 1),
(16536, 1),
(16537, 1),
(16538, 1),
(16539, 1),
(16540, 1),
(16541, 1),
(16542, 1),
(16543, 1),
(16544, 1),
(16545, 1),
(16546, 1),
(16547, 1),
(16548, 1),
(16549, 1),
(16550, 1),
(16551, 1),
(16552, 1),
(16553, 1),
(16554, 1),
(16555, 1),
(16556, 1),
(16557, 1),
(16558, 1),
(16559, 1),
(16560, 1),
(16561, 1),
(16562, 1),
(16563, 1),
(16564, 1),
(16565, 1),
(16566, 1),
(16567, 1),
(16568, 1),
(16569, 1),
(16570, 1),
(16571, 1),
(16572, 1),
(16573, 1),
(16574, 1),
(16575, 1),
(16576, 1),
(16577, 1),
(16578, 1),
(16579, 1),
(16580, 1),
(16581, 1),
(16582, 1),
(16583, 1),
(16584, 1),
(16585, 1),
(16586, 1),
(16587, 1),
(16588, 1),
(16589, 1),
(16590, 1),
(16591, 1),
(16592, 1),
(16593, 1),
(16594, 1),
(16595, 1),
(16596, 1),
(16597, 1),
(16598, 1),
(16599, 1),
(16600, 1),
(16601, 1),
(16602, 1),
(16603, 1),
(16604, 1),
(16605, 1),
(16606, 1),
(16607, 1),
(16608, 1),
(16609, 1),
(16610, 1),
(16611, 1),
(16612, 1),
(16613, 1),
(16614, 1),
(16615, 1),
(16616, 1),
(16617, 1),
(16618, 1),
(16619, 1),
(16620, 1),
(16621, 1),
(16622, 1),
(16623, 1),
(16624, 1),
(16625, 1),
(16626, 1),
(16627, 1),
(16628, 1),
(16629, 1),
(16630, 1),
(16631, 1),
(16632, 1),
(16633, 1),
(16634, 1),
(16635, 1),
(16636, 1),
(16637, 1),
(16638, 1),
(16639, 1),
(16640, 1),
(16641, 1),
(16642, 1),
(16643, 1),
(16644, 1),
(16645, 1),
(16646, 1),
(16647, 1),
(16648, 1),
(16649, 1),
(16650, 1),
(16651, 1),
(16652, 1),
(16653, 1),
(16654, 1),
(16655, 1),
(16656, 1),
(16657, 1),
(16658, 1),
(16659, 1),
(16660, 1),
(16661, 1),
(16662, 1),
(16663, 1),
(16664, 1),
(16665, 1),
(16666, 1),
(16667, 1),
(16668, 1),
(16669, 1),
(16670, 1),
(16671, 1),
(16672, 1),
(16673, 1),
(16674, 1),
(16675, 1),
(16676, 1),
(16677, 1),
(16678, 1),
(16679, 1),
(16680, 1),
(16681, 1),
(16682, 1),
(16683, 1),
(16684, 1),
(16685, 1),
(16686, 1),
(16687, 1),
(16688, 1),
(16689, 1),
(16690, 1),
(16691, 1),
(16692, 1),
(16693, 1),
(16694, 1),
(16695, 1),
(16696, 1),
(16697, 1),
(16698, 1),
(16699, 1),
(16700, 1),
(16701, 1),
(16702, 1),
(16703, 1),
(16704, 1),
(16705, 1),
(16706, 1),
(16707, 1),
(16708, 1),
(16709, 1),
(16710, 1),
(16711, 1),
(16712, 1),
(16713, 1),
(16714, 1),
(16715, 1),
(16716, 1),
(16717, 1),
(16718, 1),
(16719, 1),
(16720, 1),
(16721, 1),
(16722, 1),
(16723, 1),
(16724, 1),
(16725, 1),
(16726, 1),
(16727, 1),
(16728, 1),
(16729, 1),
(16730, 1),
(16731, 1),
(16732, 1),
(16733, 1),
(16734, 1),
(16735, 1),
(16736, 1),
(16737, 1),
(16738, 1),
(16739, 1),
(16740, 1),
(16741, 1),
(16742, 1),
(16743, 1),
(16744, 1),
(16745, 1),
(16746, 1),
(16747, 1),
(16748, 1),
(16749, 1),
(16750, 1),
(16751, 1),
(16752, 1),
(16753, 1),
(16754, 1),
(16755, 1),
(16756, 1),
(16757, 1),
(16758, 1),
(16759, 1),
(16760, 1),
(16761, 1),
(16762, 1),
(16763, 1),
(16764, 1),
(16765, 1),
(16766, 1),
(16767, 1),
(16768, 1),
(16769, 1),
(16770, 1),
(16771, 1),
(16772, 1),
(16773, 1),
(16774, 1),
(16775, 1),
(16776, 1),
(16777, 1),
(16778, 1),
(16779, 1),
(16780, 1),
(16781, 1),
(16782, 1),
(16783, 1),
(16784, 1),
(16785, 1),
(16786, 1),
(16787, 1),
(16788, 1),
(16789, 1),
(16790, 1),
(16791, 1),
(16792, 1),
(16793, 1),
(16794, 1),
(16795, 1),
(16796, 1),
(16797, 1),
(16798, 1),
(16799, 1),
(16800, 1),
(16801, 1),
(16802, 1),
(16803, 1),
(16804, 1),
(16805, 1),
(16806, 1),
(16807, 1),
(16808, 1),
(16809, 1),
(16810, 1),
(16811, 1),
(16812, 1),
(16813, 1),
(16814, 1),
(16815, 1),
(16816, 1),
(16817, 1),
(16818, 1),
(16819, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(16820, 1),
(16821, 1),
(16822, 1),
(16823, 1),
(16824, 1),
(16825, 1),
(16826, 1),
(16827, 1),
(16828, 1),
(16829, 1),
(16830, 1),
(16831, 1),
(16832, 1),
(16833, 1),
(16834, 1),
(16835, 1),
(16836, 1),
(16837, 1),
(16838, 1),
(16839, 1),
(16840, 1),
(16841, 1),
(16842, 1),
(16843, 1),
(16844, 1),
(16845, 1),
(16846, 1),
(16847, 1),
(16848, 1),
(16849, 1),
(16850, 1),
(16851, 1),
(16852, 1),
(16853, 1),
(16854, 1),
(16855, 1),
(16856, 1),
(16857, 1),
(16858, 1),
(16859, 1),
(16860, 1),
(16861, 1),
(16862, 1),
(16863, 1),
(16864, 1),
(16865, 1),
(16866, 1),
(16867, 1),
(16868, 1),
(16869, 1),
(16870, 1),
(16871, 1),
(16872, 1),
(16873, 1),
(16874, 1),
(16875, 1),
(16876, 1),
(16877, 1),
(16878, 1),
(16879, 1),
(16880, 1),
(16881, 1),
(16882, 1),
(16883, 1),
(16884, 1),
(16885, 1),
(16886, 1),
(16887, 1),
(16888, 1),
(16889, 1),
(16890, 1),
(16891, 1),
(16892, 1),
(16893, 1),
(16894, 1),
(16895, 1),
(16896, 1),
(16897, 1),
(16898, 1),
(16899, 1),
(16900, 1),
(16901, 1),
(16902, 1),
(16903, 1),
(16904, 1),
(16905, 1),
(16906, 1),
(16907, 1),
(16908, 1),
(16909, 1),
(16910, 1),
(16911, 1),
(16912, 1),
(16913, 1),
(16914, 1),
(16915, 1),
(16916, 1),
(16917, 1),
(16918, 1),
(16919, 1),
(16920, 1),
(16921, 1),
(16922, 1),
(16923, 1),
(16924, 1),
(16925, 1),
(16926, 1),
(16927, 1),
(16928, 1),
(16929, 1),
(16930, 1),
(16931, 1),
(16932, 1),
(16933, 1),
(16934, 1),
(16935, 1),
(16936, 1),
(16937, 1),
(16938, 1),
(16939, 1),
(16940, 1),
(16941, 1),
(16942, 1),
(16943, 1),
(16944, 1),
(16945, 1),
(16946, 1),
(16947, 1),
(16948, 1),
(16949, 1),
(16950, 1),
(16951, 1),
(16952, 1),
(16953, 1),
(16954, 1),
(16955, 1),
(16956, 1),
(16957, 1),
(16958, 1),
(16959, 1),
(16960, 1),
(16961, 1),
(16962, 1),
(16963, 1),
(16964, 1),
(16965, 1),
(16966, 1),
(16967, 1),
(16968, 1),
(16969, 1),
(16970, 1),
(16971, 1),
(16972, 1),
(16973, 1),
(16974, 1),
(16975, 1),
(16976, 1),
(16977, 1),
(16978, 1),
(16979, 1),
(16980, 1),
(16981, 1),
(16982, 1),
(16983, 1),
(16984, 1),
(16985, 1),
(16986, 1),
(16987, 1),
(16988, 1),
(16989, 1),
(16990, 1),
(16991, 1),
(16992, 1),
(16993, 1),
(16994, 1),
(16995, 1),
(16996, 1),
(16997, 1),
(16998, 1),
(16999, 1),
(17000, 1),
(17001, 1),
(17002, 1),
(17003, 1),
(17004, 1),
(17005, 1),
(17006, 1),
(17007, 1),
(17008, 1),
(17009, 1),
(17010, 1),
(17011, 1),
(17012, 1),
(17013, 1),
(17014, 1),
(17015, 1),
(17016, 1),
(17017, 1),
(17018, 1),
(17019, 1),
(17020, 1),
(17021, 1),
(17022, 1),
(17023, 1),
(17024, 1),
(17025, 1),
(17026, 1),
(17027, 1),
(17028, 1),
(17029, 1),
(17030, 1),
(17031, 1),
(17032, 1),
(17033, 1),
(17034, 1),
(17035, 1),
(17036, 1),
(17037, 1),
(17038, 1),
(17039, 1),
(17040, 1),
(17041, 1),
(17042, 1),
(17043, 1),
(17044, 1),
(17045, 1),
(17046, 1),
(17047, 1),
(17048, 1),
(17049, 1),
(17050, 1),
(17051, 1),
(17052, 1),
(17053, 1),
(17054, 1),
(17055, 1),
(17056, 1),
(17057, 1),
(17058, 1),
(17059, 1),
(17060, 1),
(17061, 1),
(17062, 1),
(17063, 1),
(17064, 1),
(17065, 1),
(17066, 1),
(17067, 1),
(17068, 1),
(17069, 1),
(17070, 1),
(17071, 1),
(17072, 1),
(17073, 1),
(17074, 1),
(17075, 1),
(17076, 1),
(17077, 1),
(17078, 1),
(17079, 1),
(17080, 1),
(17081, 1),
(17082, 1),
(17083, 1),
(17084, 1),
(17085, 1),
(17086, 1),
(17087, 1),
(17088, 1),
(17089, 1),
(17090, 1),
(17091, 1),
(17092, 1),
(17093, 1),
(17094, 1),
(17095, 1),
(17096, 1),
(17097, 1),
(17098, 1),
(17099, 1),
(17100, 1),
(17101, 1),
(17102, 1),
(17103, 1),
(17104, 1),
(17105, 1),
(17106, 1),
(17107, 1),
(17108, 1),
(17109, 1),
(17110, 1),
(17111, 1),
(17112, 1),
(17113, 1),
(17114, 1),
(17115, 1),
(17116, 1),
(17117, 1),
(17118, 1),
(17119, 1),
(17120, 1),
(17121, 1),
(17122, 1),
(17123, 1),
(17124, 1),
(17125, 1),
(17126, 1),
(17127, 1),
(17128, 1),
(17129, 1),
(17130, 1),
(17131, 1),
(17132, 1),
(17133, 1),
(17134, 1),
(17135, 1),
(17136, 1),
(17137, 1),
(17138, 1),
(17139, 1),
(17140, 1),
(17141, 1),
(17142, 1),
(17143, 1),
(17144, 1),
(17145, 1),
(17146, 1),
(17147, 1),
(17148, 1),
(17149, 1),
(17150, 1),
(17151, 1),
(17152, 1),
(17153, 1),
(17154, 1),
(17155, 1),
(17156, 1),
(17157, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(17158, 1),
(17159, 1),
(17160, 1),
(17161, 1),
(17162, 1),
(17163, 1),
(17164, 1),
(17165, 1),
(17166, 1),
(17167, 1),
(17168, 1),
(17169, 1),
(17170, 1),
(17171, 1),
(17172, 1),
(17173, 1),
(17174, 1),
(17175, 1),
(17176, 1),
(17177, 1),
(17178, 1),
(17179, 1),
(17180, 1),
(17181, 1),
(17182, 1),
(17183, 1),
(17184, 1),
(17185, 1),
(17186, 1),
(17187, 1),
(17188, 1),
(17189, 1),
(17190, 1),
(17191, 1),
(17192, 1),
(17193, 1),
(17194, 1),
(17195, 1),
(17196, 1),
(17197, 1),
(17198, 1),
(17199, 1),
(17200, 1),
(17201, 1),
(17202, 1),
(17203, 1),
(17204, 1),
(17205, 1),
(17206, 1),
(17207, 1),
(17208, 1),
(17209, 1),
(17210, 1),
(17211, 1),
(17212, 1),
(17213, 1),
(17214, 1),
(17215, 1),
(17216, 1),
(17217, 1),
(17218, 1),
(17219, 1),
(17220, 1),
(17221, 1),
(17222, 1),
(17223, 1),
(17224, 1),
(17225, 1),
(17226, 1),
(17227, 1),
(17228, 1),
(17229, 1),
(17230, 1),
(17231, 1),
(17232, 1),
(17233, 1),
(17234, 1),
(17235, 1),
(17236, 1),
(17237, 1),
(17238, 1),
(17239, 1),
(17240, 1),
(17241, 1),
(17242, 1),
(17243, 1),
(17244, 1),
(17245, 1),
(17246, 1),
(17247, 1),
(17248, 1),
(17249, 1),
(17250, 1),
(17251, 1),
(17252, 1),
(17253, 1),
(17254, 1),
(17255, 1),
(17256, 1),
(17257, 1),
(17258, 1),
(17259, 1),
(17260, 1),
(17261, 1),
(17262, 1),
(17263, 1),
(17264, 1),
(17265, 1),
(17266, 1),
(17267, 1),
(17268, 1),
(17269, 1),
(17270, 1),
(17271, 1),
(17272, 1),
(17273, 1),
(17274, 1),
(17275, 1),
(17276, 1),
(17277, 1),
(17278, 1),
(17279, 1),
(17280, 1),
(17281, 1),
(17282, 1),
(17283, 1),
(17284, 1),
(17285, 1),
(17286, 1),
(17287, 1),
(17288, 1),
(17289, 1),
(17290, 1),
(17291, 1),
(17292, 1),
(17293, 1),
(17294, 1),
(17295, 1),
(17296, 1),
(17297, 1),
(17298, 1),
(17299, 1),
(17300, 1),
(17301, 1),
(17302, 1),
(17303, 1),
(17304, 1),
(17305, 1),
(17306, 1),
(17307, 1),
(17308, 1),
(17309, 1),
(17310, 1),
(17311, 1),
(17312, 1),
(17313, 1),
(17314, 1),
(17315, 1),
(17316, 1),
(17317, 1),
(17318, 1),
(17319, 1),
(17320, 1),
(17321, 1),
(17322, 1),
(17323, 1),
(17324, 1),
(17325, 1),
(17326, 1),
(17327, 1),
(17328, 1),
(17329, 1),
(17330, 1),
(17331, 1),
(17332, 1),
(17333, 1),
(17334, 1),
(17335, 1),
(17336, 1),
(17337, 1),
(17338, 1),
(17339, 1),
(17340, 1),
(17341, 1),
(17342, 1),
(17343, 1),
(17344, 1),
(17345, 1),
(17346, 1),
(17347, 1),
(17348, 1),
(17349, 1),
(17350, 1),
(17351, 1),
(17352, 1),
(17353, 1),
(17354, 1),
(17355, 1),
(17356, 1),
(17357, 1),
(17358, 1),
(17359, 1),
(17360, 1),
(17361, 1),
(17362, 1),
(17363, 1),
(17364, 1),
(17365, 1),
(17366, 1),
(17367, 1),
(17368, 1),
(17369, 1),
(17370, 1),
(17371, 1),
(17372, 1),
(17373, 1),
(17374, 1),
(17375, 1),
(17376, 1),
(17377, 1),
(17378, 1),
(17379, 1),
(17380, 1),
(17381, 1),
(17382, 1),
(17383, 1),
(17384, 1),
(17385, 1),
(17386, 1),
(17387, 1),
(17388, 1),
(17389, 1),
(17390, 1),
(17391, 1),
(17392, 1),
(17393, 1),
(17394, 1),
(17395, 1),
(17396, 1),
(17397, 1),
(17398, 1),
(17399, 1),
(17400, 1),
(17401, 1),
(17402, 1),
(17403, 1),
(17404, 1),
(17405, 1),
(17406, 1),
(17407, 1),
(17408, 1),
(17409, 1),
(17410, 1),
(17411, 1),
(17412, 1),
(17413, 1),
(17414, 1),
(17415, 1),
(17416, 1),
(17417, 1),
(17418, 1),
(17419, 1),
(17420, 1),
(17421, 1),
(17422, 1),
(17423, 1),
(17424, 1),
(17425, 1),
(17426, 1),
(17427, 1),
(17428, 1),
(17429, 1),
(17430, 1),
(17431, 1),
(17432, 1),
(17433, 1),
(17434, 1),
(17435, 1),
(17436, 1),
(17437, 1),
(17438, 1),
(17439, 1),
(17440, 1),
(17441, 1),
(17442, 1),
(17443, 1),
(17444, 1),
(17445, 1),
(17446, 1),
(17447, 1),
(17448, 1),
(17449, 1),
(17450, 1),
(17451, 1),
(17452, 1),
(17453, 1),
(17454, 1),
(17455, 1),
(17456, 1),
(17457, 1),
(17458, 1),
(17459, 1),
(17460, 1),
(17461, 1),
(17462, 1),
(17463, 1),
(17464, 1),
(17465, 1),
(17466, 1),
(17467, 1),
(17468, 1),
(17469, 1),
(17470, 1),
(17471, 1),
(17472, 1),
(17473, 1),
(17474, 1),
(17475, 1),
(17476, 1),
(17477, 1),
(17478, 1),
(17479, 1),
(17480, 1),
(17481, 1),
(17482, 1),
(17483, 1),
(17484, 1),
(17485, 1),
(17486, 1),
(17487, 1),
(17488, 1),
(17489, 1),
(17490, 1),
(17491, 1),
(17492, 1),
(17493, 1),
(17494, 1),
(17495, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(17496, 1),
(17497, 1),
(17498, 1),
(17499, 1),
(17500, 1),
(17501, 1),
(17502, 1),
(17503, 1),
(17504, 1),
(17505, 1),
(17506, 1),
(17507, 1),
(17508, 1),
(17509, 1),
(17510, 1),
(17511, 1),
(17512, 1),
(17513, 1),
(17514, 1),
(17515, 1),
(17516, 1),
(17517, 1),
(17518, 1),
(17519, 1),
(17520, 1),
(17521, 1),
(17522, 1),
(17523, 1),
(17524, 1),
(17525, 1),
(17526, 1),
(17527, 1),
(17528, 1),
(17529, 1),
(17530, 1),
(17531, 1),
(17532, 1),
(17533, 1),
(17534, 1),
(17535, 1),
(17536, 1),
(17537, 1),
(17538, 1),
(17539, 1),
(17540, 1),
(17541, 1),
(17542, 1),
(17543, 1),
(17544, 1),
(17545, 1),
(17546, 1),
(17547, 1),
(17548, 1),
(17549, 1),
(17550, 1),
(17551, 1),
(17552, 1),
(17553, 1),
(17554, 1),
(17555, 1),
(17556, 1),
(17557, 1),
(17558, 1),
(17559, 1),
(17560, 1),
(17561, 1),
(17562, 1),
(17563, 1),
(17564, 1),
(17565, 1),
(17566, 1),
(17567, 1),
(17568, 1),
(17569, 1),
(17570, 1),
(17571, 1),
(17572, 1),
(17573, 1),
(17574, 1),
(17575, 1),
(17576, 1),
(17577, 1),
(17578, 1),
(17579, 1),
(17580, 1),
(17581, 1),
(17582, 1),
(17583, 1),
(17584, 1),
(17585, 1),
(17586, 1),
(17587, 1),
(17588, 1),
(17589, 1),
(17590, 1),
(17591, 1),
(17592, 1),
(17593, 1),
(17594, 1),
(17595, 1),
(17596, 1),
(17597, 1),
(17598, 1),
(17599, 1),
(17600, 1),
(17601, 1),
(17602, 1),
(17603, 1),
(17604, 1),
(17605, 1),
(17606, 1),
(17607, 1),
(17608, 1),
(17609, 1),
(17610, 1),
(17611, 1),
(17612, 1),
(17613, 1),
(17614, 1),
(17615, 1),
(17616, 1),
(17617, 1),
(17618, 1),
(17619, 1),
(17620, 1),
(17621, 1),
(17622, 1),
(17623, 1),
(17624, 1),
(17625, 1),
(17626, 1),
(17627, 1),
(17628, 1),
(17629, 1),
(17630, 1),
(17631, 1),
(17632, 1),
(17633, 1),
(17634, 1),
(17635, 1),
(17636, 1),
(17637, 1),
(17638, 1),
(17639, 1),
(17640, 1),
(17641, 1),
(17642, 1),
(17643, 1),
(17644, 1),
(17645, 1),
(17646, 1),
(17647, 1),
(17648, 1),
(17649, 1),
(17650, 1),
(17651, 1),
(17652, 1),
(17653, 1),
(17654, 1),
(17655, 1),
(17656, 1),
(17657, 1),
(17658, 1),
(17659, 1),
(17660, 1),
(17661, 1),
(17662, 1),
(17663, 1),
(17664, 1),
(17665, 1),
(17666, 1),
(17667, 1),
(17668, 1),
(17669, 1),
(17670, 1),
(17671, 1),
(17672, 1),
(17673, 1),
(17674, 1),
(17675, 1),
(17676, 1),
(17677, 1),
(17678, 1),
(17679, 1),
(17680, 1),
(17681, 1),
(17682, 1),
(17683, 1),
(17684, 1),
(17685, 1),
(17686, 1),
(17687, 1),
(17688, 1),
(17689, 1),
(17690, 1),
(17691, 1),
(17692, 1),
(17693, 1),
(17694, 1),
(17695, 1),
(17696, 1),
(17697, 1),
(17698, 1),
(17699, 1),
(17700, 1),
(17701, 1),
(17702, 1),
(17703, 1),
(17704, 1),
(17705, 1),
(17706, 1),
(17707, 1),
(17708, 1),
(17709, 1),
(17710, 1),
(17711, 1),
(17712, 1),
(17713, 1),
(17714, 1),
(17715, 1),
(17716, 1),
(17717, 1),
(17718, 1),
(17719, 1),
(17720, 1),
(17721, 1),
(17722, 1),
(17723, 1),
(17724, 1),
(17725, 1),
(17726, 1),
(17727, 1),
(17728, 1),
(17729, 1),
(17730, 1),
(17731, 1),
(17732, 1),
(17733, 1),
(17734, 1),
(17735, 1),
(17736, 1),
(17737, 1),
(17738, 1),
(17739, 1),
(17740, 1),
(17741, 1),
(17742, 1),
(17743, 1),
(17744, 1),
(17745, 1),
(17746, 1),
(17747, 1),
(17748, 1),
(17749, 1),
(17750, 1),
(17751, 1),
(17752, 1),
(17753, 1),
(17754, 1),
(17755, 1),
(17756, 1),
(17757, 1),
(17758, 1),
(17759, 1),
(17760, 1),
(17761, 1),
(17762, 1),
(17763, 1),
(17764, 1),
(17765, 1),
(17766, 1),
(17767, 1),
(17768, 1),
(17769, 1),
(17770, 1),
(17771, 1),
(17772, 1),
(17773, 1),
(17774, 1),
(17775, 1),
(17776, 1),
(17777, 1),
(17778, 1),
(17779, 1),
(17780, 1),
(17781, 1),
(17782, 1),
(17783, 1),
(17784, 1),
(17785, 1),
(17786, 1),
(17787, 1),
(17788, 1),
(17789, 1),
(17790, 1),
(17791, 1),
(17792, 1),
(17793, 1),
(17794, 1),
(17795, 1),
(17796, 1),
(17797, 1),
(17798, 1),
(17799, 1),
(17800, 1),
(17801, 1),
(17802, 1),
(17803, 1),
(17804, 1),
(17805, 1),
(17806, 1),
(17807, 1),
(17808, 1),
(17809, 1),
(17810, 1),
(17811, 1),
(17812, 1),
(17813, 1),
(17814, 1),
(17815, 1),
(17816, 1),
(17817, 1),
(17818, 1),
(17819, 1),
(17820, 1),
(17821, 1),
(17822, 1),
(17823, 1),
(17824, 1),
(17825, 1),
(17826, 1),
(17827, 1),
(17828, 1),
(17829, 1),
(17830, 1),
(17831, 1),
(17832, 1),
(17833, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(17834, 1),
(17835, 1),
(17836, 1),
(17837, 1),
(17838, 1),
(17839, 1),
(17840, 1),
(17841, 1),
(17842, 1),
(17843, 1),
(17844, 1),
(17845, 1),
(17846, 1),
(17847, 1),
(17848, 1),
(17849, 1),
(17850, 1),
(17851, 1),
(17852, 1),
(17853, 1),
(17854, 1),
(17855, 1),
(17856, 1),
(17857, 1),
(17858, 1),
(17859, 1),
(17860, 1),
(17861, 1),
(17862, 1),
(17863, 1),
(17864, 1),
(17865, 1),
(17866, 1),
(17867, 1),
(17868, 1),
(17869, 1),
(17870, 1),
(17871, 1),
(17872, 1),
(17873, 1),
(17874, 1),
(17875, 1),
(17876, 1),
(17877, 1),
(17878, 1),
(17879, 1),
(17880, 1),
(17881, 1),
(17882, 1),
(17883, 1),
(17884, 1),
(17885, 1),
(17886, 1),
(17887, 1),
(17888, 1),
(17889, 1),
(17890, 1),
(17891, 1),
(17892, 1),
(17893, 1),
(17894, 1),
(17895, 1),
(17896, 1),
(17897, 1),
(17898, 1),
(17899, 1),
(17900, 1),
(17901, 1),
(17902, 1),
(17903, 1),
(17904, 1),
(17905, 1),
(17906, 1),
(17907, 1),
(17908, 1),
(17909, 1),
(17910, 1),
(17911, 1),
(17912, 1),
(17913, 1),
(17914, 1),
(17915, 1),
(17916, 1),
(17917, 1),
(17918, 1),
(17919, 1),
(17920, 1),
(17921, 1),
(17922, 1),
(17923, 1),
(17924, 1),
(17925, 1),
(17926, 1),
(17927, 1),
(17928, 1),
(17929, 1),
(17930, 1),
(17931, 1),
(17932, 1),
(17933, 1),
(17934, 1),
(17935, 1),
(17936, 1),
(17937, 1),
(17938, 1),
(17939, 1),
(17940, 1),
(17941, 1),
(17942, 1),
(17943, 1),
(17944, 1),
(17945, 1),
(17946, 1),
(17947, 1),
(17948, 1),
(17949, 1),
(17950, 1),
(17951, 1),
(17952, 1),
(17953, 1),
(17954, 1),
(17955, 1),
(17956, 1),
(17957, 1),
(17958, 1),
(17959, 1),
(17960, 1),
(17961, 1),
(17962, 1),
(17963, 1),
(17964, 1),
(17965, 1),
(17966, 1),
(17967, 1),
(17968, 1),
(17969, 1),
(17970, 1),
(17971, 1),
(17972, 1),
(17973, 1),
(17974, 1),
(17975, 1),
(17976, 1),
(17977, 1),
(17978, 1),
(17979, 1),
(17980, 1),
(17981, 1),
(17982, 1),
(17983, 1),
(17984, 1),
(17985, 1),
(17986, 1),
(17987, 1),
(17988, 1),
(17989, 1),
(17990, 1),
(17991, 1),
(17992, 1),
(17993, 1),
(17994, 1),
(17995, 1),
(17996, 1),
(17997, 1),
(17998, 1),
(17999, 1),
(18000, 1),
(18001, 1),
(18002, 1),
(18003, 1),
(18004, 1),
(18005, 1),
(18006, 1),
(18007, 1),
(18008, 1),
(18009, 1),
(18010, 1),
(18011, 1),
(18012, 1),
(18013, 1),
(18014, 1),
(18015, 1),
(18016, 1),
(18017, 1),
(18018, 1),
(18019, 1),
(18020, 1),
(18021, 1),
(18022, 1),
(18023, 1),
(18024, 1),
(18025, 1),
(18026, 1),
(18027, 1),
(18028, 1),
(18029, 1),
(18030, 1),
(18031, 1),
(18032, 1),
(18033, 1),
(18034, 1),
(18035, 1),
(18036, 1),
(18037, 1),
(18038, 1),
(18039, 1),
(18040, 1),
(18041, 1),
(18042, 1),
(18043, 1),
(18044, 1),
(18045, 1),
(18046, 1),
(18047, 1),
(18048, 1),
(18049, 1),
(18050, 1),
(18051, 1),
(18052, 1),
(18053, 1),
(18054, 1),
(18055, 1),
(18056, 1),
(18057, 1),
(18058, 1),
(18059, 1),
(18060, 1),
(18061, 1),
(18062, 1),
(18063, 1),
(18064, 1),
(18065, 1),
(18066, 1),
(18067, 1),
(18068, 1),
(18069, 1),
(18070, 1),
(18071, 1),
(18072, 1),
(18073, 1),
(18074, 1),
(18075, 1),
(18076, 1),
(18077, 1),
(18078, 1),
(18079, 1),
(18080, 1),
(18081, 1),
(18082, 1),
(18083, 1),
(18084, 1),
(18085, 1),
(18086, 1),
(18087, 1),
(18088, 1),
(18089, 1),
(18090, 1),
(18091, 1),
(18092, 1),
(18093, 1),
(18094, 1),
(18095, 1),
(18096, 1),
(18097, 1),
(18098, 1),
(18099, 1),
(18100, 1),
(18101, 1),
(18102, 1),
(18103, 1),
(18104, 1),
(18105, 1),
(18106, 1),
(18107, 1),
(18108, 1),
(18109, 1),
(18110, 1),
(18111, 1),
(18112, 1),
(18113, 1),
(18114, 1),
(18115, 1),
(18116, 1),
(18117, 1),
(18118, 1),
(18119, 1),
(18120, 1),
(18121, 1),
(18122, 1),
(18123, 1),
(18124, 1),
(18125, 1),
(18126, 1),
(18127, 1),
(18128, 1),
(18129, 1),
(18130, 1),
(18131, 1),
(18132, 1),
(18133, 1),
(18134, 1),
(18135, 1),
(18136, 1),
(18137, 1),
(18138, 1),
(18139, 1),
(18140, 1),
(18141, 1),
(18142, 1),
(18143, 1),
(18144, 1),
(18145, 1),
(18146, 1),
(18147, 1),
(18148, 1),
(18149, 1),
(18150, 1),
(18151, 1),
(18152, 1),
(18153, 1),
(18154, 1),
(18155, 1),
(18156, 1),
(18157, 1),
(18158, 1),
(18159, 1),
(18160, 1),
(18161, 1),
(18162, 1),
(18163, 1),
(18164, 1),
(18165, 1),
(18166, 1),
(18167, 1),
(18168, 1),
(18169, 1),
(18170, 1),
(18171, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(18172, 1),
(18173, 1),
(18174, 1),
(18175, 1),
(18176, 1),
(18177, 1),
(18178, 1),
(18179, 1),
(18180, 1),
(18181, 1),
(18182, 1),
(18183, 1),
(18184, 1),
(18185, 1),
(18186, 1),
(18187, 1),
(18188, 1),
(18189, 1),
(18190, 1),
(18191, 1),
(18192, 1),
(18193, 1),
(18194, 1),
(18195, 1),
(18196, 1),
(18197, 1),
(18198, 1),
(18199, 1),
(18200, 1),
(18201, 1),
(18202, 1),
(18203, 1),
(18204, 1),
(18205, 1),
(18206, 1),
(18207, 1),
(18208, 1),
(18209, 1),
(18210, 1),
(18211, 1),
(18212, 1),
(18213, 1),
(18214, 1),
(18215, 1),
(18216, 1),
(18217, 1),
(18218, 1),
(18219, 1),
(18220, 1),
(18221, 1),
(18222, 1),
(18223, 1),
(18224, 1),
(18225, 1),
(18226, 1),
(18227, 1),
(18228, 1),
(18229, 1),
(18230, 1),
(18231, 1),
(18232, 1),
(18233, 1),
(18234, 1),
(18235, 1),
(18236, 1),
(18237, 1),
(18238, 1),
(18239, 1),
(18240, 1),
(18241, 1),
(18242, 1),
(18243, 1),
(18244, 1),
(18245, 1),
(18246, 1),
(18247, 1),
(18248, 1),
(18249, 1),
(18250, 1),
(18251, 1),
(18252, 1),
(18253, 1),
(18254, 1),
(18255, 1),
(18256, 1),
(18257, 1),
(18258, 1),
(18259, 1),
(18260, 1),
(18261, 1),
(18262, 1),
(18263, 1),
(18264, 1),
(18265, 1),
(18266, 1),
(18267, 1),
(18268, 1),
(18269, 1),
(18270, 1),
(18271, 1),
(18272, 1),
(18273, 1),
(18274, 1),
(18275, 1),
(18276, 1),
(18277, 1),
(18278, 1),
(18279, 1),
(18280, 1),
(18281, 1),
(18282, 1),
(18283, 1),
(18284, 1),
(18285, 1),
(18286, 1),
(18287, 1),
(18288, 1),
(18289, 1),
(18290, 1),
(18291, 1),
(18292, 1),
(18293, 1),
(18294, 1),
(18295, 1),
(18296, 1),
(18297, 1),
(18298, 1),
(18299, 1),
(18300, 1),
(18301, 1),
(18302, 1),
(18303, 1),
(18304, 1),
(18305, 1),
(18306, 1),
(18307, 1),
(18308, 1),
(18309, 1),
(18310, 1),
(18311, 1),
(18312, 1),
(18313, 1),
(18314, 1),
(18315, 1),
(18316, 1),
(18317, 1),
(18318, 1),
(18319, 1),
(18320, 1),
(18321, 1),
(18322, 1),
(18323, 1),
(18324, 1),
(18325, 1),
(18326, 1),
(18327, 1),
(18328, 1),
(18329, 1),
(18330, 1),
(18331, 1),
(18332, 1),
(18333, 1),
(18334, 1),
(18335, 1),
(18336, 1),
(18337, 1),
(18338, 1),
(18339, 1),
(18340, 1),
(18341, 1),
(18342, 1),
(18343, 1),
(18344, 1),
(18345, 1),
(18346, 1),
(18347, 1),
(18348, 1),
(18349, 1),
(18350, 1),
(18351, 1),
(18352, 1),
(18353, 1),
(18354, 1),
(18355, 1),
(18356, 1),
(18357, 1),
(18358, 1),
(18359, 1),
(18360, 1),
(18361, 1),
(18362, 1),
(18363, 1),
(18364, 1),
(18365, 1),
(18366, 1),
(18367, 1),
(18368, 1),
(18369, 1),
(18370, 1),
(18371, 1),
(18372, 1),
(18373, 1),
(18374, 1),
(18375, 1),
(18376, 1),
(18377, 1),
(18378, 1),
(18379, 1),
(18380, 1),
(18381, 1),
(18382, 1),
(18383, 1),
(18384, 1),
(18385, 1),
(18386, 1),
(18387, 1),
(18388, 1),
(18389, 1),
(18390, 1),
(18391, 1),
(18392, 1),
(18393, 1),
(18394, 1),
(18395, 1),
(18396, 1),
(18397, 1),
(18398, 1),
(18399, 1),
(18400, 1),
(18401, 1),
(18402, 1),
(18403, 1),
(18404, 1),
(18405, 1),
(18406, 1),
(18407, 1),
(18408, 1),
(18409, 1),
(18410, 1),
(18411, 1),
(18412, 1),
(18413, 1),
(18414, 1),
(18415, 1),
(18416, 1),
(18417, 1),
(18418, 1),
(18419, 1),
(18420, 1),
(18421, 1),
(18422, 1),
(18423, 1),
(18424, 1),
(18425, 1),
(18426, 1),
(18427, 1),
(18428, 1),
(18429, 1),
(18430, 1),
(18431, 1),
(18432, 1),
(18433, 1),
(18434, 1),
(18435, 1),
(18436, 1),
(18437, 1),
(18438, 1),
(18439, 1),
(18440, 1),
(18441, 1),
(18442, 1),
(18443, 1),
(18444, 1),
(18445, 1),
(18446, 1),
(18447, 1),
(18448, 1),
(18449, 1),
(18450, 1),
(18451, 1),
(18452, 1),
(18453, 1),
(18454, 1),
(18455, 1),
(18456, 1),
(18457, 1),
(18458, 1),
(18459, 1),
(18460, 1),
(18461, 1),
(18462, 1),
(18463, 1),
(18464, 1),
(18465, 1),
(18466, 1),
(18467, 1),
(18468, 1),
(18469, 1),
(18470, 1),
(18471, 1),
(18472, 1),
(18473, 1),
(18474, 1),
(18475, 1),
(18476, 1),
(18477, 1),
(18478, 1),
(18479, 1),
(18480, 1),
(18481, 1),
(18482, 1),
(18483, 1),
(18484, 1),
(18485, 1),
(18486, 1),
(18487, 1),
(18488, 1),
(18489, 1),
(18490, 1),
(18491, 1),
(18492, 1),
(18493, 1),
(18494, 1),
(18495, 1),
(18496, 1),
(18497, 1),
(18498, 1),
(18499, 1),
(18500, 1),
(18501, 1),
(18502, 1),
(18503, 1),
(18504, 1),
(18505, 1),
(18506, 1),
(18507, 1),
(18508, 1),
(18509, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(18510, 1),
(18511, 1),
(18512, 1),
(18513, 1),
(18514, 1),
(18515, 1),
(18516, 1),
(18517, 1),
(18518, 1),
(18519, 1),
(18520, 1),
(18521, 1),
(18522, 1),
(18523, 1),
(18524, 1),
(18525, 1),
(18526, 1),
(18527, 1),
(18528, 1),
(18529, 1),
(18530, 1),
(18531, 1),
(18532, 1),
(18533, 1),
(18534, 1),
(18535, 1),
(18536, 1),
(18537, 1),
(18538, 1),
(18539, 1),
(18540, 1),
(18541, 1),
(18542, 1),
(18543, 1),
(18544, 1),
(18545, 1),
(18546, 1),
(18547, 1),
(18548, 1),
(18549, 1),
(18550, 1),
(18551, 1),
(18552, 1),
(18553, 1),
(18554, 1),
(18555, 1),
(18556, 1),
(18557, 1),
(18558, 1),
(18559, 1),
(18560, 1),
(18561, 1),
(18562, 1),
(18563, 1),
(18564, 1),
(18565, 1),
(18566, 1),
(18567, 1),
(18568, 1),
(18569, 1),
(18570, 1),
(18571, 1),
(18572, 1),
(18573, 1),
(18574, 1),
(18575, 1),
(18576, 1),
(18577, 1),
(18578, 1),
(18579, 1),
(18580, 1),
(18581, 1),
(18582, 1),
(18583, 1),
(18584, 1),
(18585, 1),
(18586, 1),
(18587, 1),
(18588, 1),
(18589, 1),
(18590, 1),
(18591, 1),
(18592, 1),
(18593, 1),
(18594, 1),
(18595, 1),
(18596, 1),
(18597, 1),
(18598, 1),
(18599, 1),
(18600, 1),
(18601, 1),
(18602, 1),
(18603, 1),
(18604, 1),
(18605, 1),
(18606, 1),
(18607, 1),
(18608, 1),
(18609, 1),
(18610, 1),
(18611, 1),
(18612, 1),
(18613, 1),
(18614, 1),
(18615, 1),
(18616, 1),
(18617, 1),
(18618, 1),
(18619, 1),
(18620, 1),
(18621, 1),
(18622, 1),
(18623, 1),
(18624, 1),
(18625, 1),
(18626, 1),
(18627, 1),
(18628, 1),
(18629, 1),
(18630, 1),
(18631, 1),
(18632, 1),
(18633, 1),
(18634, 1),
(18635, 1),
(18636, 1),
(18637, 1),
(18638, 1),
(18639, 1),
(18640, 1),
(18641, 1),
(18642, 1),
(18643, 1),
(18644, 1),
(18645, 1),
(18646, 1),
(18647, 1),
(18648, 1),
(18649, 1),
(18650, 1),
(18651, 1),
(18652, 1),
(18653, 1),
(18654, 1),
(18655, 1),
(18656, 1),
(18657, 1),
(18658, 1),
(18659, 1),
(18660, 1),
(18661, 1),
(18662, 1),
(18663, 1),
(18664, 1),
(18665, 1),
(18666, 1),
(18667, 1),
(18668, 1),
(18669, 1),
(18670, 1),
(18671, 1),
(18672, 1),
(18673, 1),
(18674, 1),
(18675, 1),
(18676, 1),
(18677, 1),
(18678, 1),
(18679, 1),
(18680, 1),
(18681, 1),
(18682, 1),
(18683, 1),
(18684, 1),
(18685, 1),
(18686, 1),
(18687, 1),
(18688, 1),
(18689, 1),
(18690, 1),
(18691, 1),
(18692, 1),
(18693, 1),
(18694, 1),
(18695, 1),
(18696, 1),
(18697, 1),
(18698, 1),
(18699, 1),
(18700, 1),
(18701, 1),
(18702, 1),
(18703, 1),
(18704, 1),
(18705, 1),
(18706, 1),
(18707, 1),
(18708, 1),
(18709, 1),
(18710, 1),
(18711, 1),
(18712, 1),
(18713, 1),
(18714, 1),
(18715, 1),
(18716, 1),
(18717, 1),
(18718, 1),
(18719, 1),
(18720, 1),
(18721, 1),
(18722, 1),
(18723, 1),
(18724, 1),
(18725, 1),
(18726, 1),
(18727, 1),
(18728, 1),
(18729, 1),
(18730, 1),
(18731, 1),
(18732, 1),
(18733, 1),
(18734, 1),
(18735, 1),
(18736, 1),
(18737, 1),
(18738, 1),
(18739, 1),
(18740, 1),
(18741, 1),
(18742, 1),
(18743, 1),
(18744, 1),
(18745, 1),
(18746, 1),
(18747, 1),
(18748, 1),
(18749, 1),
(18750, 1),
(18751, 1),
(18752, 1),
(18753, 1),
(18754, 1),
(18755, 1),
(18756, 1),
(18757, 1),
(18758, 1),
(18759, 1),
(18760, 1),
(18761, 1),
(18762, 1),
(18763, 1),
(18764, 1),
(18765, 1),
(18766, 1),
(18767, 1),
(18768, 1),
(18769, 1),
(18770, 1),
(18771, 1),
(18772, 1),
(18773, 1),
(18774, 1),
(18775, 1),
(18776, 1),
(18777, 1),
(18778, 1),
(18779, 1),
(18780, 1),
(18781, 1),
(18782, 1),
(18783, 1),
(18784, 1),
(18785, 1),
(18786, 1),
(18787, 1),
(18788, 1),
(18789, 1),
(18790, 1),
(18791, 1),
(18792, 1),
(18793, 1),
(18794, 1),
(18795, 1),
(18796, 1),
(18797, 1),
(18798, 1),
(18799, 1),
(18800, 1),
(18801, 1),
(18802, 1),
(18803, 1),
(18804, 1),
(18805, 1),
(18806, 1),
(18807, 1),
(18808, 1),
(18809, 1),
(18810, 1),
(18811, 1),
(18812, 1),
(18813, 1),
(18814, 1),
(18815, 1),
(18816, 1),
(18817, 1),
(18818, 1),
(18819, 1),
(18820, 1),
(18821, 1),
(18822, 1),
(18823, 1),
(18824, 1),
(18825, 1),
(18826, 1),
(18827, 1),
(18828, 1),
(18829, 1),
(18830, 1),
(18831, 1),
(18832, 1),
(18833, 1),
(18834, 1),
(18835, 1),
(18836, 1),
(18837, 1),
(18838, 1),
(18839, 1),
(18840, 1),
(18841, 1),
(18842, 1),
(18843, 1),
(18844, 1),
(18845, 1),
(18846, 1),
(18847, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(18848, 1),
(18849, 1),
(18850, 1),
(18851, 1),
(18852, 1),
(18853, 1),
(18854, 1),
(18855, 1),
(18856, 1),
(18857, 1),
(18858, 1),
(18859, 1),
(18860, 1),
(18861, 1),
(18862, 1),
(18863, 1),
(18864, 1),
(18865, 1),
(18866, 1),
(18867, 1),
(18868, 1),
(18869, 1),
(18870, 1),
(18871, 1),
(18872, 1),
(18873, 1),
(18874, 1),
(18875, 1),
(18876, 1),
(18877, 1),
(18878, 1),
(18879, 1),
(18880, 1),
(18881, 1),
(18882, 1),
(18883, 1),
(18884, 1),
(18885, 1),
(18886, 1),
(18887, 1),
(18888, 1),
(18889, 1),
(18890, 1),
(18891, 1),
(18892, 1),
(18893, 1),
(18894, 1),
(18895, 1),
(18896, 1),
(18897, 1),
(18898, 1),
(18899, 1),
(18900, 1),
(18901, 1),
(18902, 1),
(18903, 1),
(18904, 1),
(18905, 1),
(18906, 1),
(18907, 1),
(18908, 1),
(18909, 1),
(18910, 1),
(18911, 1),
(18912, 1),
(18913, 1),
(18914, 1),
(18915, 1),
(18916, 1),
(18917, 1),
(18918, 1),
(18919, 1),
(18920, 1),
(18921, 1),
(18922, 1),
(18923, 1),
(18924, 1),
(18925, 1),
(18926, 1),
(18927, 1),
(18928, 1),
(18929, 1),
(18930, 1),
(18931, 1),
(18932, 1),
(18933, 1),
(18934, 1),
(18935, 1),
(18936, 1),
(18937, 1),
(18938, 1),
(18939, 1),
(18940, 1),
(18941, 1),
(18942, 1),
(18943, 1),
(18944, 1),
(18945, 1),
(18946, 1),
(18947, 1),
(18948, 1),
(18949, 1),
(18950, 1),
(18951, 1),
(18952, 1),
(18953, 1),
(18954, 1),
(18955, 1),
(18956, 1),
(18957, 1),
(18958, 1),
(18959, 1),
(18960, 1),
(18961, 1),
(18962, 1),
(18963, 1),
(18964, 1),
(18965, 1),
(18966, 1),
(18967, 1),
(18968, 1),
(18969, 1),
(18970, 1),
(18971, 1),
(18972, 1),
(18973, 1),
(18974, 1),
(18975, 1),
(18976, 1),
(18977, 1),
(18978, 1),
(18979, 1),
(18980, 1),
(18981, 1),
(18982, 1),
(18983, 1),
(18984, 1),
(18985, 1),
(18986, 1),
(18987, 1),
(18988, 1),
(18989, 1),
(18990, 1),
(18991, 1),
(18992, 1),
(18993, 1),
(18994, 1),
(18995, 1),
(18996, 1),
(18997, 1),
(18998, 1),
(18999, 1),
(19000, 1),
(19001, 1),
(19002, 1),
(19003, 1),
(19004, 1),
(19005, 1),
(19006, 1),
(19007, 1),
(19008, 1),
(19009, 1),
(19010, 1),
(19011, 1),
(19012, 1),
(19013, 1),
(19014, 1),
(19015, 1),
(19016, 1),
(19017, 1),
(19018, 1),
(19019, 1),
(19020, 1),
(19021, 1),
(19022, 1),
(19023, 1),
(19024, 1),
(19025, 1),
(19026, 1),
(19027, 1),
(19028, 1),
(19029, 1),
(19030, 1),
(19031, 1),
(19032, 1),
(19033, 1),
(19034, 1),
(19035, 1),
(19036, 1),
(19037, 1),
(19038, 1),
(19039, 1),
(19040, 1),
(19041, 1),
(19042, 1),
(19043, 1),
(19044, 1),
(19045, 1),
(19046, 1),
(19047, 1),
(19048, 1),
(19049, 1),
(19050, 1),
(19051, 1),
(19052, 1),
(19053, 1),
(19054, 1),
(19055, 1),
(19056, 1),
(19057, 1),
(19058, 1),
(19059, 1),
(19060, 1),
(19061, 1),
(19062, 1),
(19063, 1),
(19064, 1),
(19065, 1),
(19066, 1),
(19067, 1),
(19068, 1),
(19069, 1),
(19070, 1),
(19071, 1),
(19072, 1),
(19073, 1),
(19074, 1),
(19075, 1),
(19076, 1),
(19077, 1),
(19078, 1),
(19079, 1),
(19080, 1),
(19081, 1),
(19082, 1),
(19083, 1),
(19084, 1),
(19085, 1),
(19086, 1),
(19087, 1),
(19088, 1),
(19089, 1),
(19090, 1),
(19091, 1),
(19092, 1),
(19093, 1),
(19094, 1),
(19095, 1),
(19096, 1),
(19097, 1),
(19098, 1),
(19099, 1),
(19100, 1),
(19101, 1),
(19102, 1),
(19103, 1),
(19104, 1),
(19105, 1),
(19106, 1),
(19107, 1),
(19108, 1),
(19109, 1),
(19110, 1),
(19111, 1),
(19112, 1),
(19113, 1),
(19114, 1),
(19115, 1),
(19116, 1),
(19117, 1),
(19118, 1),
(19119, 1),
(19120, 1),
(19121, 1),
(19122, 1),
(19123, 1),
(19124, 1),
(19125, 1),
(19126, 1),
(19127, 1),
(19128, 1),
(19129, 1),
(19130, 1),
(19131, 1),
(19132, 1),
(19133, 1),
(19134, 1),
(19135, 1),
(19136, 1),
(19137, 1),
(19138, 1),
(19139, 1),
(19140, 1),
(19141, 1),
(19142, 1),
(19143, 1),
(19144, 1),
(19145, 1),
(19146, 1),
(19147, 1),
(19148, 1),
(19149, 1),
(19150, 1),
(19151, 1),
(19152, 1),
(19153, 1),
(19154, 1),
(19155, 1),
(19156, 1),
(19157, 1),
(19158, 1),
(19159, 1),
(19160, 1),
(19161, 1),
(19162, 1),
(19163, 1),
(19164, 1),
(19165, 1),
(19166, 1),
(19167, 1),
(19168, 1),
(19169, 1),
(19170, 1),
(19171, 1),
(19172, 1),
(19173, 1),
(19174, 1),
(19175, 1),
(19176, 1),
(19177, 1),
(19178, 1),
(19179, 1),
(19180, 1),
(19181, 1),
(19182, 1),
(19183, 1),
(19184, 1),
(19185, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(19186, 1),
(19187, 1),
(19188, 1),
(19189, 1),
(19190, 1),
(19191, 1),
(19192, 1),
(19193, 1),
(19194, 1),
(19195, 1),
(19196, 1),
(19197, 1),
(19198, 1),
(19199, 1),
(19200, 1),
(19201, 1),
(19202, 1),
(19203, 1),
(19204, 1),
(19205, 1),
(19206, 1),
(19207, 1),
(19208, 1),
(19209, 1),
(19210, 1),
(19211, 1),
(19212, 1),
(19213, 1),
(19214, 1),
(19215, 1),
(19216, 1),
(19217, 1),
(19218, 1),
(19219, 1),
(19220, 1),
(19221, 1),
(19222, 1),
(19223, 1),
(19224, 1),
(19225, 1),
(19226, 1),
(19227, 1),
(19228, 1),
(19229, 1),
(19230, 1),
(19231, 1),
(19232, 1),
(19233, 1),
(19234, 1),
(19235, 1),
(19236, 1),
(19237, 1),
(19238, 1),
(19239, 1),
(19240, 1),
(19241, 1),
(19242, 1),
(19243, 1),
(19244, 1),
(19245, 1),
(19246, 1),
(19247, 1),
(19248, 1),
(19249, 1),
(19250, 1),
(19251, 1),
(19252, 1),
(19253, 1),
(19254, 1),
(19255, 1),
(19256, 1),
(19257, 1),
(19258, 1),
(19259, 1),
(19260, 1),
(19261, 1),
(19262, 1),
(19263, 1),
(19264, 1),
(19265, 1),
(19266, 1),
(19267, 1),
(19268, 1),
(19269, 1),
(19270, 1),
(19271, 1),
(19272, 1),
(19273, 1),
(19274, 1),
(19275, 1),
(19276, 1),
(19277, 1),
(19278, 1),
(19279, 1),
(19280, 1),
(19281, 1),
(19282, 1),
(19283, 1),
(19284, 1),
(19285, 1),
(19286, 1),
(19287, 1),
(19288, 1),
(19289, 1),
(19290, 1),
(19291, 1),
(19292, 1),
(19293, 1),
(19294, 1),
(19295, 1),
(19296, 1),
(19297, 1),
(19298, 1),
(19299, 1),
(19300, 1),
(19301, 1),
(19302, 1),
(19303, 1),
(19304, 1),
(19305, 1),
(19306, 1),
(19307, 1),
(19308, 1),
(19309, 1),
(19310, 1),
(19311, 1),
(19312, 1),
(19313, 1),
(19314, 1),
(19315, 1),
(19316, 1),
(19317, 1),
(19318, 1),
(19319, 1),
(19320, 1),
(19321, 1),
(19322, 1),
(19323, 1),
(19324, 1),
(19325, 1),
(19326, 1),
(19327, 1),
(19328, 1),
(19329, 1),
(19330, 1),
(19331, 1),
(19332, 1),
(19333, 1),
(19334, 1),
(19335, 1),
(19336, 1),
(19337, 1),
(19338, 1),
(19339, 1),
(19340, 1),
(19341, 1),
(19342, 1),
(19343, 1),
(19344, 1),
(19345, 1),
(19346, 1),
(19347, 1),
(19348, 1),
(19349, 1),
(19350, 1),
(19351, 1),
(19352, 1),
(19353, 1),
(19354, 1),
(19355, 1),
(19356, 1),
(19357, 1),
(19358, 1),
(19359, 1),
(19360, 1),
(19361, 1),
(19362, 1),
(19363, 1),
(19364, 1),
(19365, 1),
(19366, 1),
(19367, 1),
(19368, 1),
(19369, 1),
(19370, 1),
(19371, 1),
(19372, 1),
(19373, 1),
(19374, 1),
(19375, 1),
(19376, 1),
(19377, 1),
(19378, 1),
(19379, 1),
(19380, 1),
(19381, 1),
(19382, 1),
(19383, 1),
(19384, 1),
(19385, 1),
(19386, 1),
(19387, 1),
(19388, 1),
(19389, 1),
(19390, 1),
(19391, 1),
(19392, 1),
(19393, 1),
(19394, 1),
(19395, 1),
(19396, 1),
(19397, 1),
(19398, 1),
(19399, 1),
(19400, 1),
(19401, 1),
(19402, 1),
(19403, 1),
(19404, 1),
(19405, 1),
(19406, 1),
(19407, 1),
(19408, 1),
(19409, 1),
(19410, 1),
(19411, 1),
(19412, 1),
(19413, 1),
(19414, 1),
(19415, 1),
(19416, 1),
(19417, 1),
(19418, 1),
(19419, 1),
(19420, 1),
(19421, 1),
(19422, 1),
(19423, 1),
(19424, 1),
(19425, 1),
(19426, 1),
(19427, 1),
(19428, 1),
(19429, 1),
(19430, 1),
(19431, 1),
(19432, 1),
(19433, 1),
(19434, 1),
(19435, 1),
(19436, 1),
(19437, 1),
(19438, 1),
(19439, 1),
(19440, 1),
(19441, 1),
(19442, 1),
(19443, 1),
(19444, 1),
(19445, 1),
(19446, 1),
(19447, 1),
(19448, 1),
(19449, 1),
(19450, 1),
(19451, 1),
(19452, 1),
(19453, 1),
(19454, 1),
(19455, 1),
(19456, 1),
(19457, 1),
(19458, 1),
(19459, 1),
(19460, 1),
(19461, 1),
(19462, 1),
(19463, 1),
(19464, 1),
(19465, 1),
(19466, 1),
(19467, 1),
(19468, 1),
(19469, 1),
(19470, 1),
(19471, 1),
(19472, 1),
(19473, 1),
(19474, 1),
(19475, 1),
(19476, 1),
(19477, 1),
(19478, 1),
(19479, 1),
(19480, 1),
(19481, 1),
(19482, 1),
(19483, 1),
(19484, 1),
(19485, 1),
(19486, 1),
(19487, 1),
(19488, 1),
(19489, 1),
(19490, 1),
(19491, 1),
(19492, 1),
(19493, 1),
(19494, 1),
(19495, 1),
(19496, 1),
(19497, 1),
(19498, 1),
(19499, 1),
(19500, 1),
(19501, 1),
(19502, 1),
(19503, 1),
(19504, 1),
(19505, 1),
(19506, 1),
(19507, 1),
(19508, 1),
(19509, 1),
(19510, 1),
(19511, 1),
(19512, 1),
(19513, 1),
(19514, 1),
(19515, 1),
(19516, 1),
(19517, 1),
(19518, 1),
(19519, 1),
(19520, 1),
(19521, 1),
(19522, 1),
(19523, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(19524, 1),
(19525, 1),
(19526, 1),
(19527, 1),
(19528, 1),
(19529, 1),
(19530, 1),
(19531, 1),
(19532, 1),
(19533, 1),
(19534, 1),
(19535, 1),
(19536, 1),
(19537, 1),
(19538, 1),
(19539, 1),
(19540, 1),
(19541, 1),
(19542, 1),
(19543, 1),
(19544, 1),
(19545, 1),
(19546, 1),
(19547, 1),
(19548, 1),
(19549, 1),
(19550, 1),
(19551, 1),
(19552, 1),
(19553, 1),
(19554, 1),
(19555, 1),
(19556, 1),
(19557, 1),
(19558, 1),
(19559, 1),
(19560, 1),
(19561, 1),
(19562, 1),
(19563, 1),
(19564, 1),
(19565, 1),
(19566, 1),
(19567, 1),
(19568, 1),
(19569, 1),
(19570, 1),
(19571, 1),
(19572, 1),
(19573, 1),
(19574, 1),
(19575, 1),
(19576, 1),
(19577, 1),
(19578, 1),
(19579, 1),
(19580, 1),
(19581, 1),
(19582, 1),
(19583, 1),
(19584, 1),
(19585, 1),
(19586, 1),
(19587, 1),
(19588, 1),
(19589, 1),
(19590, 1),
(19591, 1),
(19592, 1),
(19593, 1),
(19594, 1),
(19595, 1),
(19596, 1),
(19597, 1),
(19598, 1),
(19599, 1),
(19600, 1),
(19601, 1),
(19602, 1),
(19603, 1),
(19604, 1),
(19605, 1),
(19606, 1),
(19607, 1),
(19608, 1),
(19609, 1),
(19610, 1),
(19611, 1),
(19612, 1),
(19613, 1),
(19614, 1),
(19615, 1),
(19616, 1),
(19617, 1),
(19618, 1),
(19619, 1),
(19620, 1),
(19621, 1),
(19622, 1),
(19623, 1),
(19624, 1),
(19625, 1),
(19626, 1),
(19627, 1),
(19628, 1),
(19629, 1),
(19630, 1),
(19631, 1),
(19632, 1),
(19633, 1),
(19634, 1),
(19635, 1),
(19636, 1),
(19637, 1),
(19638, 1),
(19639, 1),
(19640, 1),
(19641, 1),
(19642, 1),
(19643, 1),
(19644, 1),
(19645, 1),
(19646, 1),
(19647, 1),
(19648, 1),
(19649, 1),
(19650, 1),
(19651, 1),
(19652, 1),
(19653, 1),
(19654, 1),
(19655, 1),
(19656, 1),
(19657, 1),
(19658, 1),
(19659, 1),
(19660, 1),
(19661, 1),
(19662, 1),
(19663, 1),
(19664, 1),
(19665, 1),
(19666, 1),
(19667, 1),
(19668, 1),
(19669, 1),
(19670, 1),
(19671, 1),
(19672, 1),
(19673, 1),
(19674, 1),
(19675, 1),
(19676, 1),
(19677, 1),
(19678, 1),
(19679, 1),
(19680, 1),
(19681, 1),
(19682, 1),
(19683, 1),
(19684, 1),
(19685, 1),
(19686, 1),
(19687, 1),
(19688, 1),
(19689, 1),
(19690, 1),
(19691, 1),
(19692, 1),
(19693, 1),
(19694, 1),
(19695, 1),
(19696, 1),
(19697, 1),
(19698, 1),
(19699, 1),
(19700, 1),
(19701, 1),
(19702, 1),
(19703, 1),
(19704, 1),
(19705, 1),
(19706, 1),
(19707, 1),
(19708, 1),
(19709, 1),
(19710, 1),
(19711, 1),
(19712, 1),
(19713, 1),
(19714, 1),
(19715, 1),
(19716, 1),
(19717, 1),
(19718, 1),
(19719, 1),
(19720, 1),
(19721, 1),
(19722, 1),
(19723, 1),
(19724, 1),
(19725, 1),
(19726, 1),
(19727, 1),
(19728, 1),
(19729, 1),
(19730, 1),
(19731, 1),
(19732, 1),
(19733, 1),
(19734, 1),
(19735, 1),
(19736, 1),
(19737, 1),
(19738, 1),
(19739, 1),
(19740, 1),
(19741, 1),
(19742, 1),
(19743, 1),
(19744, 1),
(19745, 1),
(19746, 1),
(19747, 1),
(19748, 1),
(19749, 1),
(19750, 1),
(19751, 1),
(19752, 1),
(19753, 1),
(19754, 1),
(19755, 1),
(19756, 1),
(19757, 1),
(19758, 1),
(19759, 1),
(19760, 1),
(19761, 1),
(19762, 1),
(19763, 1),
(19764, 1),
(19765, 1),
(19766, 1),
(19767, 1),
(19768, 1),
(19769, 1),
(19770, 1),
(19771, 1),
(19772, 1),
(19773, 1),
(19774, 1),
(19775, 1),
(19776, 1),
(19777, 1),
(19778, 1),
(19779, 1),
(19780, 1),
(19781, 1),
(19782, 1),
(19783, 1),
(19784, 1),
(19785, 1),
(19786, 1),
(19787, 1),
(19788, 1),
(19789, 1),
(19790, 1),
(19791, 1),
(19792, 1),
(19793, 1),
(19794, 1),
(19795, 1),
(19796, 1),
(19797, 1),
(19798, 1),
(19799, 1),
(19800, 1),
(19801, 1),
(19802, 1),
(19803, 1),
(19804, 1),
(19805, 1),
(19806, 1),
(19807, 1),
(19808, 1),
(19809, 1),
(19810, 1),
(19811, 1),
(19812, 1),
(19813, 1),
(19814, 1),
(19815, 1),
(19816, 1),
(19817, 1),
(19818, 1),
(19819, 1),
(19820, 1),
(19821, 1),
(19822, 1),
(19823, 1),
(19824, 1),
(19825, 1),
(19826, 1),
(19827, 1),
(19828, 1),
(19829, 1),
(19830, 1),
(19831, 1),
(19832, 1),
(19833, 1),
(19834, 1),
(19835, 1),
(19836, 1),
(19837, 1),
(19838, 1),
(19839, 1),
(19840, 1),
(19841, 1),
(19842, 1),
(19843, 1),
(19844, 1),
(19845, 1),
(19846, 1),
(19847, 1),
(19848, 1),
(19849, 1),
(19850, 1),
(19851, 1),
(19852, 1),
(19853, 1),
(19854, 1),
(19855, 1),
(19856, 1),
(19857, 1),
(19858, 1),
(19859, 1),
(19860, 1),
(19861, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(19862, 1),
(19863, 1),
(19864, 1),
(19865, 1),
(19866, 1),
(19867, 1),
(19868, 1),
(19869, 1),
(19870, 1),
(19871, 1),
(19872, 1),
(19873, 1),
(19874, 1),
(19875, 1),
(19876, 1),
(19877, 1),
(19878, 1),
(19879, 1),
(19880, 1),
(19881, 1),
(19882, 1),
(19883, 1),
(19884, 1),
(19885, 1),
(19886, 1),
(19887, 1),
(19888, 1),
(19889, 1),
(19890, 1),
(19891, 1),
(19892, 1),
(19893, 1),
(19894, 1),
(19895, 1),
(19896, 1),
(19897, 1),
(19898, 1),
(19899, 1),
(19900, 1),
(19901, 1),
(19902, 1),
(19903, 1),
(19904, 1),
(19905, 1),
(19906, 1),
(19907, 1),
(19908, 1),
(19909, 1),
(19910, 1),
(19911, 1),
(19912, 1),
(19913, 1),
(19914, 1),
(19915, 1),
(19916, 1),
(19917, 1),
(19918, 1),
(19919, 1),
(19920, 1),
(19921, 1),
(19922, 1),
(19923, 1),
(19924, 1),
(19925, 1),
(19926, 1),
(19927, 1),
(19928, 1),
(19929, 1),
(19930, 1),
(19931, 1),
(19932, 1),
(19933, 1),
(19934, 1),
(19935, 1),
(19936, 1),
(19937, 1),
(19938, 1),
(19939, 1),
(19940, 1),
(19941, 1),
(19942, 1),
(19943, 1),
(19944, 1),
(19945, 1),
(19946, 1),
(19947, 1),
(19948, 1),
(19949, 1),
(19950, 1),
(19951, 1),
(19952, 1),
(19953, 1),
(19954, 1),
(19955, 1),
(19956, 1),
(19957, 1),
(19958, 1),
(19959, 1),
(19960, 1),
(19961, 1),
(19962, 1),
(19963, 1),
(19964, 1),
(19965, 1),
(19966, 1),
(19967, 1),
(19968, 1),
(19969, 1),
(19970, 1),
(19971, 1),
(19972, 1),
(19973, 1),
(19974, 1),
(19975, 1),
(19976, 1),
(19977, 1),
(19978, 1),
(19979, 1),
(19980, 1),
(19981, 1),
(19982, 1),
(19983, 1),
(19984, 1),
(19985, 1),
(19986, 1),
(19987, 1),
(19988, 1),
(19989, 1),
(19990, 1),
(19991, 1),
(19992, 1),
(19993, 1),
(19994, 1),
(19995, 1),
(19996, 1),
(19997, 1),
(19998, 1),
(19999, 1),
(20000, 1),
(20001, 1),
(20002, 1),
(20003, 1),
(20004, 1),
(20005, 1),
(20006, 1),
(20007, 1),
(20008, 1),
(20009, 1),
(20010, 1),
(20011, 1),
(20012, 1),
(20013, 1),
(20014, 1),
(20015, 1),
(20016, 1),
(20017, 1),
(20018, 1),
(20019, 1),
(20020, 1),
(20021, 1),
(20022, 1),
(20023, 1),
(20024, 1),
(20025, 1),
(20026, 1),
(20027, 1),
(20028, 1),
(20029, 1),
(20030, 1),
(20031, 1),
(20032, 1),
(20033, 1),
(20034, 1),
(20035, 1),
(20036, 1),
(20037, 1),
(20038, 1),
(20039, 1),
(20040, 1),
(20041, 1),
(20042, 1),
(20043, 1),
(20044, 1),
(20045, 1),
(20046, 1),
(20047, 1),
(20048, 1),
(20049, 1),
(20050, 1),
(20051, 1),
(20052, 1),
(20053, 1),
(20054, 1),
(20055, 1),
(20056, 1),
(20057, 1),
(20058, 1),
(20059, 1),
(20060, 1),
(20061, 1),
(20062, 1),
(20063, 1),
(20064, 1),
(20065, 1),
(20066, 1),
(20067, 1),
(20068, 1),
(20069, 1),
(20070, 1),
(20071, 1),
(20072, 1),
(20073, 1),
(20074, 1),
(20075, 1),
(20076, 1),
(20077, 1),
(20078, 1),
(20079, 1),
(20080, 1),
(20081, 1),
(20082, 1),
(20083, 1),
(20084, 1),
(20085, 1),
(20086, 1),
(20087, 1),
(20088, 1),
(20089, 1),
(20090, 1),
(20091, 1),
(20092, 1),
(20093, 1),
(20094, 1),
(20095, 1),
(20096, 1),
(20097, 1),
(20098, 1),
(20099, 1),
(20100, 1),
(20101, 1),
(20102, 1),
(20103, 1),
(20104, 1),
(20105, 1),
(20106, 1),
(20107, 1),
(20108, 1),
(20109, 1),
(20110, 1),
(20111, 1),
(20112, 1),
(20113, 1),
(20114, 1),
(20115, 1),
(20116, 1),
(20117, 1),
(20118, 1),
(20119, 1),
(20120, 1),
(20121, 1),
(20122, 1),
(20123, 1),
(20124, 1),
(20125, 1),
(20126, 1),
(20127, 1),
(20128, 1),
(20129, 1),
(20130, 1),
(20131, 1),
(20132, 1),
(20133, 1),
(20134, 1),
(20135, 1),
(20136, 1),
(20137, 1),
(20138, 1),
(20139, 1),
(20140, 1),
(20141, 1),
(20142, 1),
(20143, 1),
(20144, 1),
(20145, 1),
(20146, 1),
(20147, 1),
(20148, 1),
(20149, 1),
(20150, 1),
(20151, 1),
(20152, 1),
(20153, 1),
(20154, 1),
(20155, 1),
(20156, 1),
(20157, 1),
(20158, 1),
(20159, 1),
(20160, 1),
(20161, 1),
(20162, 1),
(20163, 1),
(20164, 1),
(20165, 1),
(20166, 1),
(20167, 1),
(20168, 1),
(20169, 1),
(20170, 1),
(20171, 1),
(20172, 1),
(20173, 1),
(20174, 1),
(20175, 1),
(20176, 1),
(20177, 1),
(20178, 1),
(20179, 1),
(20180, 1),
(20181, 1),
(20182, 1),
(20183, 1),
(20184, 1),
(20185, 1),
(20186, 1),
(20187, 1),
(20188, 1),
(20189, 1),
(20190, 1),
(20191, 1),
(20192, 1),
(20193, 1),
(20194, 1),
(20195, 1),
(20196, 1),
(20197, 1),
(20198, 1),
(20199, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(20200, 1),
(20201, 1),
(20202, 1),
(20203, 1),
(20204, 1),
(20205, 1),
(20206, 1),
(20207, 1),
(20208, 1),
(20209, 1),
(20210, 1),
(20211, 1),
(20212, 1),
(20213, 1),
(20214, 1),
(20215, 1),
(20216, 1),
(20217, 1),
(20218, 1),
(20219, 1),
(20220, 1),
(20221, 1),
(20222, 1),
(20223, 1),
(20224, 1),
(20225, 1),
(20226, 1),
(20227, 1),
(20228, 1),
(20229, 1),
(20230, 1),
(20231, 1),
(20232, 1),
(20233, 1),
(20234, 1),
(20235, 1),
(20236, 1),
(20237, 1),
(20238, 1),
(20239, 1),
(20240, 1),
(20241, 1),
(20242, 1),
(20243, 1),
(20244, 1),
(20245, 1),
(20246, 1),
(20247, 1),
(20248, 1),
(20249, 1),
(20250, 1),
(20251, 1),
(20252, 1),
(20253, 1),
(20254, 1),
(20255, 1),
(20256, 1),
(20257, 1),
(20258, 1),
(20259, 1),
(20260, 1),
(20261, 1),
(20262, 1),
(20263, 1),
(20264, 1),
(20265, 1),
(20266, 1),
(20267, 1),
(20268, 1),
(20269, 1),
(20270, 1),
(20271, 1),
(20272, 1),
(20273, 1),
(20274, 1),
(20275, 1),
(20276, 1),
(20277, 1),
(20278, 1),
(20279, 1),
(20280, 1),
(20281, 1),
(20282, 1),
(20283, 1),
(20284, 1),
(20285, 1),
(20286, 1),
(20287, 1),
(20288, 1),
(20289, 1),
(20290, 1),
(20291, 1),
(20292, 1),
(20293, 1),
(20294, 1),
(20295, 1),
(20296, 1),
(20297, 1),
(20298, 1),
(20299, 1),
(20300, 1),
(20301, 1),
(20302, 1),
(20303, 1),
(20304, 1),
(20305, 1),
(20306, 1),
(20307, 1),
(20308, 1),
(20309, 1),
(20310, 1),
(20311, 1),
(20312, 1),
(20313, 1),
(20314, 1),
(20315, 1),
(20316, 1),
(20317, 1),
(20318, 1),
(20319, 1),
(20320, 1),
(20321, 1),
(20322, 1),
(20323, 1),
(20324, 1),
(20325, 1),
(20326, 1),
(20327, 1),
(20328, 1),
(20329, 1),
(20330, 1),
(20331, 1),
(20332, 1),
(20333, 1),
(20334, 1),
(20335, 1),
(20336, 1),
(20337, 1),
(20338, 1),
(20339, 1),
(20340, 1),
(20341, 1),
(20342, 1),
(20343, 1),
(20344, 1),
(20345, 1),
(20346, 1),
(20347, 1),
(20348, 1),
(20349, 1),
(20350, 1),
(20351, 1),
(20352, 1),
(20353, 1),
(20354, 1),
(20355, 1),
(20356, 1),
(20357, 1),
(20358, 1),
(20359, 1),
(20360, 1),
(20361, 1),
(20362, 1),
(20363, 1),
(20364, 1),
(20365, 1),
(20366, 1),
(20367, 1),
(20368, 1),
(20369, 1),
(20370, 1),
(20371, 1),
(20372, 1),
(20373, 1),
(20374, 1),
(20375, 1),
(20376, 1),
(20377, 1),
(20378, 1),
(20379, 1),
(20380, 1),
(20381, 1),
(20382, 1),
(20383, 1),
(20384, 1),
(20385, 1),
(20386, 1),
(20387, 1),
(20388, 1),
(20389, 1),
(20390, 1),
(20391, 1),
(20392, 1),
(20393, 1),
(20394, 1),
(20395, 1),
(20396, 1),
(20397, 1),
(20398, 1),
(20399, 1),
(20400, 1),
(20401, 1),
(20402, 1),
(20403, 1),
(20404, 1),
(20405, 1),
(20406, 1),
(20407, 1),
(20408, 1),
(20409, 1),
(20410, 1),
(20411, 1),
(20412, 1),
(20413, 1),
(20414, 1),
(20415, 1),
(20416, 1),
(20417, 1),
(20418, 1),
(20419, 1),
(20420, 1),
(20421, 1),
(20422, 1),
(20423, 1),
(20424, 1),
(20425, 1),
(20426, 1),
(20427, 1),
(20428, 1),
(20429, 1),
(20430, 1),
(20431, 1),
(20432, 1),
(20433, 1),
(20434, 1),
(20435, 1),
(20436, 1),
(20437, 1),
(20438, 1),
(20439, 1),
(20440, 1),
(20441, 1),
(20442, 1),
(20443, 1),
(20444, 1),
(20445, 1),
(20446, 1),
(20447, 1),
(20448, 1),
(20449, 1),
(20450, 1),
(20451, 1),
(20452, 1),
(20453, 1),
(20454, 1),
(20455, 1),
(20456, 1),
(20457, 1),
(20458, 1),
(20459, 1),
(20460, 1),
(20461, 1),
(20462, 1),
(20463, 1),
(20464, 1),
(20465, 1),
(20466, 1),
(20467, 1),
(20468, 1),
(20469, 1),
(20470, 1),
(20471, 1),
(20472, 1),
(20473, 1),
(20474, 1),
(20475, 1),
(20476, 1),
(20477, 1),
(20478, 1),
(20479, 1),
(20480, 1),
(20481, 1),
(20482, 1),
(20483, 1),
(20484, 1),
(20485, 1),
(20486, 1),
(20487, 1),
(20488, 1),
(20489, 1),
(20490, 1),
(20491, 1),
(20492, 1),
(20493, 1),
(20494, 1),
(20495, 1),
(20496, 1),
(20497, 1),
(20498, 1),
(20499, 1),
(20500, 1),
(20501, 1),
(20502, 1),
(20503, 1),
(20504, 1),
(20505, 1),
(20506, 1),
(20507, 1),
(20508, 1),
(20509, 1),
(20510, 1),
(20511, 1),
(20512, 1),
(20513, 1),
(20514, 1),
(20515, 1),
(20516, 1),
(20517, 1),
(20518, 1),
(20519, 1),
(20520, 1),
(20521, 1),
(20522, 1),
(20523, 1),
(20524, 1),
(20525, 1),
(20526, 1),
(20527, 1),
(20528, 1),
(20529, 1),
(20530, 1),
(20531, 1),
(20532, 1),
(20533, 1),
(20534, 1),
(20535, 1),
(20536, 1),
(20537, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(20538, 1),
(20539, 1),
(20540, 1),
(20541, 1),
(20542, 1),
(20543, 1),
(20544, 1),
(20545, 1),
(20546, 1),
(20547, 1),
(20548, 1),
(20549, 1),
(20550, 1),
(20551, 1),
(20552, 1),
(20553, 1),
(20554, 1),
(20555, 1),
(20556, 1),
(20557, 1),
(20558, 1),
(20559, 1),
(20560, 1),
(20561, 1),
(20562, 1),
(20563, 1),
(20564, 1),
(20565, 1),
(20566, 1),
(20567, 1),
(20568, 1),
(20569, 1),
(20570, 1),
(20571, 1),
(20572, 1),
(20573, 1),
(20574, 1),
(20575, 1),
(20576, 1),
(20577, 1),
(20578, 1),
(20579, 1),
(20580, 1),
(20581, 1),
(20582, 1),
(20583, 1),
(20584, 1),
(20585, 1),
(20586, 1),
(20587, 1),
(20588, 1),
(20589, 1),
(20590, 1),
(20591, 1),
(20592, 1),
(20593, 1),
(20594, 1),
(20595, 1),
(20596, 1),
(20597, 1),
(20598, 1),
(20599, 1),
(20600, 1),
(20601, 1),
(20602, 1),
(20603, 1),
(20604, 1),
(20605, 1),
(20606, 1),
(20607, 1),
(20608, 1),
(20609, 1),
(20610, 1),
(20611, 1),
(20612, 1),
(20613, 1),
(20614, 1),
(20615, 1),
(20616, 1),
(20617, 1),
(20618, 1),
(20619, 1),
(20620, 1),
(20621, 1),
(20622, 1),
(20623, 1),
(20624, 1),
(20625, 1),
(20626, 1),
(20627, 1),
(20628, 1),
(20629, 1),
(20630, 1),
(20631, 1),
(20632, 1),
(20633, 1),
(20634, 1),
(20635, 1),
(20636, 1),
(20637, 1),
(20638, 1),
(20639, 1),
(20640, 1),
(20641, 1),
(20642, 1),
(20643, 1),
(20644, 1),
(20645, 1),
(20646, 1),
(20647, 1),
(20648, 1),
(20649, 1),
(20650, 1),
(20651, 1),
(20652, 1),
(20653, 1),
(20654, 1),
(20655, 1),
(20656, 1),
(20657, 1),
(20658, 1),
(20659, 1),
(20660, 1),
(20661, 1),
(20662, 1),
(20663, 1),
(20664, 1),
(20665, 1),
(20666, 1),
(20667, 1),
(20668, 1),
(20669, 1),
(20670, 1),
(20671, 1),
(20672, 1),
(20673, 1),
(20674, 1),
(20675, 1),
(20676, 1),
(20677, 1),
(20678, 1),
(20679, 1),
(20680, 1),
(20681, 1),
(20682, 1),
(20683, 1),
(20684, 1),
(20685, 1),
(20686, 1),
(20687, 1),
(20688, 1),
(20689, 1),
(20690, 1),
(20691, 1),
(20692, 1),
(20693, 1),
(20694, 1),
(20695, 1),
(20696, 1),
(20697, 1),
(20698, 1),
(20699, 1),
(20700, 1),
(20701, 1),
(20702, 1),
(20703, 1),
(20704, 1),
(20705, 1),
(20706, 1),
(20707, 1),
(20708, 1),
(20709, 1),
(20710, 1),
(20711, 1),
(20712, 1),
(20713, 1),
(20714, 1),
(20715, 1),
(20716, 1),
(20717, 1),
(20718, 1),
(20719, 1),
(20720, 1),
(20721, 1),
(20722, 1),
(20723, 1),
(20724, 1),
(20725, 1),
(20726, 1),
(20727, 1),
(20728, 1),
(20729, 1),
(20730, 1),
(20731, 1),
(20732, 1),
(20733, 1),
(20734, 1),
(20735, 1),
(20736, 1),
(20737, 1),
(20738, 1),
(20739, 1),
(20740, 1),
(20741, 1),
(20742, 1),
(20743, 1),
(20744, 1),
(20745, 1),
(20746, 1),
(20747, 1),
(20748, 1),
(20749, 1),
(20750, 1),
(20751, 1),
(20752, 1),
(20753, 1),
(20754, 1),
(20755, 1),
(20756, 1),
(20757, 1),
(20758, 1),
(20759, 1),
(20760, 1),
(20761, 1),
(20762, 1),
(20763, 1),
(20764, 1),
(20765, 1),
(20766, 1),
(20767, 1),
(20768, 1),
(20769, 1),
(20770, 1),
(20771, 1),
(20772, 1),
(20773, 1),
(20774, 1),
(20775, 1),
(20776, 1),
(20777, 1),
(20778, 1),
(20779, 1),
(20780, 1),
(20781, 1),
(20782, 1),
(20783, 1),
(20784, 1),
(20785, 1),
(20786, 1),
(20787, 1),
(20788, 1),
(20789, 1),
(20790, 1),
(20791, 1),
(20792, 1),
(20793, 1),
(20794, 1),
(20795, 1),
(20796, 1),
(20797, 1),
(20798, 1),
(20799, 1),
(20800, 1),
(20801, 1),
(20802, 1),
(20803, 1),
(20804, 1),
(20805, 1),
(20806, 1),
(20807, 1),
(20808, 1),
(20809, 1),
(20810, 1),
(20811, 1),
(20812, 1),
(20813, 1),
(20814, 1),
(20815, 1),
(20816, 1),
(20817, 1),
(20818, 1),
(20819, 1),
(20820, 1),
(20821, 1),
(20822, 1),
(20823, 1),
(20824, 1),
(20825, 1),
(20826, 1),
(20827, 1),
(20828, 1),
(20829, 1),
(20830, 1),
(20831, 1),
(20832, 1),
(20833, 1),
(20834, 1),
(20835, 1),
(20836, 1),
(20837, 1),
(20838, 1),
(20839, 1),
(20840, 1),
(20841, 1),
(20842, 1),
(20843, 1),
(20844, 1),
(20845, 1),
(20846, 1),
(20847, 1),
(20848, 1),
(20849, 1),
(20850, 1),
(20851, 1),
(20852, 1),
(20853, 1),
(20854, 1),
(20855, 1),
(20856, 1),
(20857, 1),
(20858, 1),
(20859, 1),
(20860, 1),
(20861, 1),
(20862, 1),
(20863, 1),
(20864, 1),
(20865, 1),
(20866, 1),
(20867, 1),
(20868, 1),
(20869, 1),
(20870, 1),
(20871, 1),
(20872, 1),
(20873, 1),
(20874, 1),
(20875, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(20876, 1),
(20877, 1),
(20878, 1),
(20879, 1),
(20880, 1),
(20881, 1),
(20882, 1),
(20883, 1),
(20884, 1),
(20885, 1),
(20886, 1),
(20887, 1),
(20888, 1),
(20889, 1),
(20890, 1),
(20891, 1),
(20892, 1),
(20893, 1),
(20894, 1),
(20895, 1),
(20896, 1),
(20897, 1),
(20898, 1),
(20899, 1),
(20900, 1),
(20901, 1),
(20902, 1),
(20903, 1),
(20904, 1),
(20905, 1),
(20906, 1),
(20907, 1),
(20908, 1),
(20909, 1),
(20910, 1),
(20911, 1),
(20912, 1),
(20913, 1),
(20914, 1),
(20915, 1),
(20916, 1),
(20917, 1),
(20918, 1),
(20919, 1),
(20920, 1),
(20921, 1),
(20922, 1),
(20923, 1),
(20924, 1),
(20925, 1),
(20926, 1),
(20927, 1),
(20928, 1),
(20929, 1),
(20930, 1),
(20931, 1),
(20932, 1),
(20933, 1),
(20934, 1),
(20935, 1),
(20936, 1),
(20937, 1),
(20938, 1),
(20939, 1),
(20940, 1),
(20941, 1),
(20942, 1),
(20943, 1),
(20944, 1),
(20945, 1),
(20946, 1),
(20947, 1),
(20948, 1),
(20949, 1),
(20950, 1),
(20951, 1),
(20952, 1),
(20953, 1),
(20954, 1),
(20955, 1),
(20956, 1),
(20957, 1),
(20958, 1),
(20959, 1),
(20960, 1),
(20961, 1),
(20962, 1),
(20963, 1),
(20964, 1),
(20965, 1),
(20966, 1),
(20967, 1),
(20968, 1),
(20969, 1),
(20970, 1),
(20971, 1),
(20972, 1),
(20973, 1),
(20974, 1),
(20975, 1),
(20976, 1),
(20977, 1),
(20978, 1),
(20979, 1),
(20980, 1),
(20981, 1),
(20982, 1),
(20983, 1),
(20984, 1),
(20985, 1),
(20986, 1),
(20987, 1),
(20988, 1),
(20989, 1),
(20990, 1),
(20991, 1),
(20992, 1),
(20993, 1),
(20994, 1),
(20995, 1),
(20996, 1),
(20997, 1),
(20998, 1),
(20999, 1),
(21000, 1),
(21001, 1),
(21002, 1),
(21003, 1),
(21004, 1),
(21005, 1),
(21006, 1),
(21007, 1),
(21008, 1),
(21009, 1),
(21010, 1),
(21011, 1),
(21012, 1),
(21013, 1),
(21014, 1),
(21015, 1),
(21016, 1),
(21017, 1),
(21018, 1),
(21019, 1),
(21020, 1),
(21021, 1),
(21022, 1),
(21023, 1),
(21024, 1),
(21025, 1),
(21026, 1),
(21027, 1),
(21028, 1),
(21029, 1),
(21030, 1),
(21031, 1),
(21032, 1),
(21033, 1),
(21034, 1),
(21035, 1),
(21036, 1),
(21037, 1),
(21038, 1),
(21039, 1),
(21040, 1),
(21041, 1),
(21042, 1),
(21043, 1),
(21044, 1),
(21045, 1),
(21046, 1),
(21047, 1),
(21048, 1),
(21049, 1),
(21050, 1),
(21051, 1),
(21052, 1),
(21053, 1),
(21054, 1),
(21055, 1),
(21056, 1),
(21057, 1),
(21058, 1),
(21059, 1),
(21060, 1),
(21061, 1),
(21062, 1),
(21063, 1),
(21064, 1),
(21065, 1),
(21066, 1),
(21067, 1),
(21068, 1),
(21069, 1),
(21070, 1),
(21071, 1),
(21072, 1),
(21073, 1),
(21074, 1),
(21075, 1),
(21076, 1),
(21077, 1),
(21078, 1),
(21079, 1),
(21080, 1),
(21081, 1),
(21082, 1),
(21083, 1),
(21084, 1),
(21085, 1),
(21086, 1),
(21087, 1),
(21088, 1),
(21089, 1),
(21090, 1),
(21091, 1),
(21092, 1),
(21093, 1),
(21094, 1),
(21095, 1),
(21096, 1),
(21097, 1),
(21098, 1),
(21099, 1),
(21100, 1),
(21101, 1),
(21102, 1),
(21103, 1),
(21104, 1),
(21105, 1),
(21106, 1),
(21107, 1),
(21108, 1),
(21109, 1),
(21110, 1),
(21111, 1),
(21112, 1),
(21113, 1),
(21114, 1),
(21115, 1),
(21116, 1),
(21117, 1),
(21118, 1),
(21119, 1),
(21120, 1),
(21121, 1),
(21122, 1),
(21123, 1),
(21124, 1),
(21125, 1),
(21126, 1),
(21127, 1),
(21128, 1),
(21129, 1),
(21130, 1),
(21131, 1),
(21132, 1),
(21133, 1),
(21134, 1),
(21135, 1),
(21136, 1),
(21137, 1),
(21138, 1),
(21139, 1),
(21140, 1),
(21141, 1),
(21142, 1),
(21143, 1),
(21144, 1),
(21145, 1),
(21146, 1),
(21147, 1),
(21148, 1),
(21149, 1),
(21150, 1),
(21151, 1),
(21152, 1),
(21153, 1),
(21154, 1),
(21155, 1),
(21156, 1),
(21157, 1),
(21158, 1),
(21159, 1),
(21160, 1),
(21161, 1),
(21162, 1),
(21163, 1),
(21164, 1),
(21165, 1),
(21166, 1),
(21167, 1),
(21168, 1),
(21169, 1),
(21170, 1),
(21171, 1),
(21172, 1),
(21173, 1),
(21174, 1),
(21175, 1),
(21176, 1),
(21177, 1),
(21178, 1),
(21179, 1),
(21180, 1),
(21181, 1),
(21182, 1),
(21183, 1),
(21184, 1),
(21185, 1),
(21186, 1),
(21187, 1),
(21188, 1),
(21189, 1),
(21190, 1),
(21191, 1),
(21192, 1),
(21193, 1),
(21194, 1),
(21195, 1),
(21196, 1),
(21197, 1),
(21198, 1),
(21199, 1),
(21200, 1),
(21201, 1),
(21202, 1),
(21203, 1),
(21204, 1),
(21205, 1),
(21206, 1),
(21207, 1),
(21208, 1),
(21209, 1),
(21210, 1),
(21211, 1),
(21212, 1),
(21213, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(21214, 1),
(21215, 1),
(21216, 1),
(21217, 1),
(21218, 1),
(21219, 1),
(21220, 1),
(21221, 1),
(21222, 1),
(21223, 1),
(21224, 1),
(21225, 1),
(21226, 1),
(21227, 1),
(21228, 1),
(21229, 1),
(21230, 1),
(21231, 1),
(21232, 1),
(21233, 1),
(21234, 1),
(21235, 1),
(21236, 1),
(21237, 1),
(21238, 1),
(21239, 1),
(21240, 1),
(21241, 1),
(21242, 1),
(21243, 1),
(21244, 1),
(21245, 1),
(21246, 1),
(21247, 1),
(21248, 1),
(21249, 1),
(21250, 1),
(21251, 1),
(21252, 1),
(21253, 1),
(21254, 1),
(21255, 1),
(21256, 1),
(21257, 1),
(21258, 1),
(21259, 1),
(21260, 1),
(21261, 1),
(21262, 1),
(21263, 1),
(21264, 1),
(21265, 1),
(21266, 1),
(21267, 1),
(21268, 1),
(21269, 1),
(21270, 1),
(21271, 1),
(21272, 1),
(21273, 1),
(21274, 1),
(21275, 1),
(21276, 1),
(21277, 1),
(21278, 1),
(21279, 1),
(21280, 1),
(21281, 1),
(21282, 1),
(21283, 1),
(21284, 1),
(21285, 1),
(21286, 1),
(21287, 1),
(21288, 1),
(21289, 1),
(21290, 1),
(21291, 1),
(21292, 1),
(21293, 1),
(21294, 1),
(21295, 1),
(21296, 1),
(21297, 1),
(21298, 1),
(21299, 1),
(21300, 1),
(21301, 1),
(21302, 1),
(21303, 1),
(21304, 1),
(21305, 1),
(21306, 1),
(21307, 1),
(21308, 1),
(21309, 1),
(21310, 1),
(21311, 1),
(21312, 1),
(21313, 1),
(21314, 1),
(21315, 1),
(21316, 1),
(21317, 1),
(21318, 1),
(21319, 1),
(21320, 1),
(21321, 1),
(21322, 1),
(21323, 1),
(21324, 1),
(21325, 1),
(21326, 1),
(21327, 1),
(21328, 1),
(21329, 1),
(21330, 1),
(21331, 1),
(21332, 1),
(21333, 1),
(21334, 1),
(21335, 1),
(21336, 1),
(21337, 1),
(21338, 1),
(21339, 1),
(21340, 1),
(21341, 1),
(21342, 1),
(21343, 1),
(21344, 1),
(21345, 1),
(21346, 1),
(21347, 1),
(21348, 1),
(21349, 1),
(21350, 1),
(21351, 1),
(21352, 1),
(21353, 1),
(21354, 1),
(21355, 1),
(21356, 1),
(21357, 1),
(21358, 1),
(21359, 1),
(21360, 1),
(21361, 1),
(21362, 1),
(21363, 1),
(21364, 1),
(21365, 1),
(21366, 1),
(21367, 1),
(21368, 1),
(21369, 1),
(21370, 1),
(21371, 1),
(21372, 1),
(21373, 1),
(21374, 1),
(21375, 1),
(21376, 1),
(21377, 1),
(21378, 1),
(21379, 1),
(21380, 1),
(21381, 1),
(21382, 1),
(21383, 1),
(21384, 1),
(21385, 1),
(21386, 1),
(21387, 1),
(21388, 1),
(21389, 1),
(21390, 1),
(21391, 1),
(21392, 1),
(21393, 1),
(21394, 1),
(21395, 1),
(21396, 1),
(21397, 1),
(21398, 1),
(21399, 1),
(21400, 1),
(21401, 1),
(21402, 1),
(21403, 1),
(21404, 1),
(21405, 1),
(21406, 1),
(21407, 1),
(21408, 1),
(21409, 1),
(21410, 1),
(21411, 1),
(21412, 1),
(21413, 1),
(21414, 1),
(21415, 1),
(21416, 1),
(21417, 1),
(21418, 1),
(21419, 1),
(21420, 1),
(21421, 1),
(21422, 1),
(21423, 1),
(21424, 1),
(21425, 1),
(21426, 1),
(21427, 1),
(21428, 1),
(21429, 1),
(21430, 1),
(21431, 1),
(21432, 1),
(21433, 1),
(21434, 1),
(21435, 1),
(21436, 1),
(21437, 1),
(21438, 1),
(21439, 1),
(21440, 1),
(21441, 1),
(21442, 1),
(21443, 1),
(21444, 1),
(21445, 1),
(21446, 1),
(21447, 1),
(21448, 1),
(21449, 1),
(21450, 1),
(21451, 1),
(21452, 1),
(21453, 1),
(21454, 1),
(21455, 1),
(21456, 1),
(21457, 1),
(21458, 1),
(21459, 1),
(21460, 1),
(21461, 1),
(21462, 1),
(21463, 1),
(21464, 1),
(21465, 1),
(21466, 1),
(21467, 1),
(21468, 1),
(21469, 1),
(21470, 1),
(21471, 1),
(21472, 1),
(21473, 1),
(21474, 1),
(21475, 1),
(21476, 1),
(21477, 1),
(21478, 1),
(21479, 1),
(21480, 1),
(21481, 1),
(21482, 1),
(21483, 1),
(21484, 1),
(21485, 1),
(21486, 1),
(21487, 1),
(21488, 1),
(21489, 1),
(21490, 1),
(21491, 1),
(21492, 1),
(21493, 1),
(21494, 1),
(21495, 1),
(21496, 1),
(21497, 1),
(21498, 1),
(21499, 1),
(21500, 1),
(21501, 1),
(21502, 1),
(21503, 1),
(21504, 1),
(21505, 1),
(21506, 1),
(21507, 1),
(21508, 1),
(21509, 1),
(21510, 1),
(21511, 1),
(21512, 1),
(21513, 1),
(21514, 1),
(21515, 1),
(21516, 1),
(21517, 1),
(21518, 1),
(21519, 1),
(21520, 1),
(21521, 1),
(21522, 1),
(21523, 1),
(21524, 1),
(21525, 1),
(21526, 1),
(21527, 1),
(21528, 1),
(21529, 1),
(21530, 1),
(21531, 1),
(21532, 1),
(21533, 1),
(21534, 1),
(21535, 1),
(21536, 1),
(21537, 1),
(21538, 1),
(21539, 1),
(21540, 1),
(21541, 1),
(21542, 1),
(21543, 1),
(21544, 1),
(21545, 1),
(21546, 1),
(21547, 1),
(21548, 1),
(21549, 1),
(21550, 1),
(21551, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(21552, 1),
(21553, 1),
(21554, 1),
(21555, 1),
(21556, 1),
(21557, 1),
(21558, 1),
(21559, 1),
(21560, 1),
(21561, 1),
(21562, 1),
(21563, 1),
(21564, 1),
(21565, 1),
(21566, 1),
(21567, 1),
(21568, 1),
(21569, 1),
(21570, 1),
(21571, 1),
(21572, 1),
(21573, 1),
(21574, 1),
(21575, 1),
(21576, 1),
(21577, 1),
(21578, 1),
(21579, 1),
(21580, 1),
(21581, 1),
(21582, 1),
(21583, 1),
(21584, 1),
(21585, 1),
(21586, 1),
(21587, 1),
(21588, 1),
(21589, 1),
(21590, 1),
(21591, 1),
(21592, 1),
(21593, 1),
(21594, 1),
(21595, 1),
(21596, 1),
(21597, 1),
(21598, 1),
(21599, 1),
(21600, 1),
(21601, 1),
(21602, 1),
(21603, 1),
(21604, 1),
(21605, 1),
(21606, 1),
(21607, 1),
(21608, 1),
(21609, 1),
(21610, 1),
(21611, 1),
(21612, 1),
(21613, 1),
(21614, 1),
(21615, 1),
(21616, 1),
(21617, 1),
(21618, 1),
(21619, 1),
(21620, 1),
(21621, 1),
(21622, 1),
(21623, 1),
(21624, 1),
(21625, 1),
(21626, 1),
(21627, 1),
(21628, 1),
(21629, 1),
(21630, 1),
(21631, 1),
(21632, 1),
(21633, 1),
(21634, 1),
(21635, 1),
(21636, 1),
(21637, 1),
(21638, 1),
(21639, 1),
(21640, 1),
(21641, 1),
(21642, 1),
(21643, 1),
(21644, 1),
(21645, 1),
(21646, 1),
(21647, 1),
(21648, 1),
(21649, 1),
(21650, 1),
(21651, 1),
(21652, 1),
(21653, 1),
(21654, 1),
(21655, 1),
(21656, 1),
(21657, 1),
(21658, 1),
(21659, 1),
(21660, 1),
(21661, 1),
(21662, 1),
(21663, 1),
(21664, 1),
(21665, 1),
(21666, 1),
(21667, 1),
(21668, 1),
(21669, 1),
(21670, 1),
(21671, 1),
(21672, 1),
(21673, 1),
(21674, 1),
(21675, 1),
(21676, 1),
(21677, 1),
(21678, 1),
(21679, 1),
(21680, 1),
(21681, 1),
(21682, 1),
(21683, 1),
(21684, 1),
(21685, 1),
(21686, 1),
(21687, 1),
(21688, 1),
(21689, 1),
(21690, 1),
(21691, 1),
(21692, 1),
(21693, 1),
(21694, 1),
(21695, 1),
(21696, 1),
(21697, 1),
(21698, 1),
(21699, 1),
(21700, 1),
(21701, 1),
(21702, 1),
(21703, 1),
(21704, 1),
(21705, 1),
(21706, 1),
(21707, 1),
(21708, 1),
(21709, 1),
(21710, 1),
(21711, 1),
(21712, 1),
(21713, 1),
(21714, 1),
(21715, 1),
(21716, 1),
(21717, 1),
(21718, 1),
(21719, 1),
(21720, 1),
(21721, 1),
(21722, 1),
(21723, 1),
(21724, 1),
(21725, 1),
(21726, 1),
(21727, 1),
(21728, 1),
(21729, 1),
(21730, 1),
(21731, 1),
(21732, 1),
(21733, 1),
(21734, 1),
(21735, 1),
(21736, 1),
(21737, 1),
(21738, 1),
(21739, 1),
(21740, 1),
(21741, 1),
(21742, 1),
(21743, 1),
(21744, 1),
(21745, 1),
(21746, 1),
(21747, 1),
(21748, 1),
(21749, 1),
(21750, 1),
(21751, 1),
(21752, 1),
(21753, 1),
(21754, 1),
(21755, 1),
(21756, 1),
(21757, 1),
(21758, 1),
(21759, 1),
(21760, 1),
(21761, 1),
(21762, 1),
(21763, 1),
(21764, 1),
(21765, 1),
(21766, 1),
(21767, 1),
(21768, 1),
(21769, 1),
(21770, 1),
(21771, 1),
(21772, 1),
(21773, 1),
(21774, 1),
(21775, 1),
(21776, 1),
(21777, 1),
(21778, 1),
(21779, 1),
(21780, 1),
(21781, 1),
(21782, 1),
(21783, 1),
(21784, 1),
(21785, 1),
(21786, 1),
(21787, 1),
(21788, 1),
(21789, 1),
(21790, 1),
(21791, 1),
(21792, 1),
(21793, 1),
(21794, 1),
(21795, 1),
(21796, 1),
(21797, 1),
(21798, 1),
(21799, 1),
(21800, 1),
(21801, 1),
(21802, 1),
(21803, 1),
(21804, 1),
(21805, 1),
(21806, 1),
(21807, 1),
(21808, 1),
(21809, 1),
(21810, 1),
(21811, 1),
(21812, 1),
(21813, 1),
(21814, 1),
(21815, 1),
(21816, 1),
(21817, 1),
(21818, 1),
(21819, 1),
(21820, 1),
(21821, 1),
(21822, 1),
(21823, 1),
(21824, 1),
(21825, 1),
(21826, 1),
(21827, 1),
(21828, 1),
(21829, 1),
(21830, 1),
(21831, 1),
(21832, 1),
(21833, 1),
(21834, 1),
(21835, 1),
(21836, 1),
(21837, 1),
(21838, 1),
(21839, 1),
(21840, 1),
(21841, 1),
(21842, 1),
(21843, 1),
(21844, 1),
(21845, 1),
(21846, 1),
(21847, 1),
(21848, 1),
(21849, 1),
(21850, 1),
(21851, 1),
(21852, 1),
(21853, 1),
(21854, 1),
(21855, 1),
(21856, 1),
(21857, 1),
(21858, 1),
(21859, 1),
(21860, 1),
(21861, 1),
(21862, 1),
(21863, 1),
(21864, 1),
(21865, 1),
(21866, 1),
(21867, 1),
(21868, 1),
(21869, 1),
(21870, 1),
(21871, 1),
(21872, 1),
(21873, 1),
(21874, 1),
(21875, 1),
(21876, 1),
(21877, 1),
(21878, 1),
(21879, 1),
(21880, 1),
(21881, 1),
(21882, 1),
(21883, 1),
(21884, 1),
(21885, 1),
(21886, 1),
(21887, 1),
(21888, 1),
(21889, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(21890, 1),
(21891, 1),
(21892, 1),
(21893, 1),
(21894, 1),
(21895, 1),
(21896, 1),
(21897, 1),
(21898, 1),
(21899, 1),
(21900, 1),
(21901, 1),
(21902, 1),
(21903, 1),
(21904, 1),
(21905, 1),
(21906, 1),
(21907, 1),
(21908, 1),
(21909, 1),
(21910, 1),
(21911, 1),
(21912, 1),
(21913, 1),
(21914, 1),
(21915, 1),
(21916, 1),
(21917, 1),
(21918, 1),
(21919, 1),
(21920, 1),
(21921, 1),
(21922, 1),
(21923, 1),
(21924, 1),
(21925, 1),
(21926, 1),
(21927, 1),
(21928, 1),
(21929, 1),
(21930, 1),
(21931, 1),
(21932, 1),
(21933, 1),
(21934, 1),
(21935, 1),
(21936, 1),
(21937, 1),
(21938, 1),
(21939, 1),
(21940, 1),
(21941, 1),
(21942, 1),
(21943, 1),
(21944, 1),
(21945, 1),
(21946, 1),
(21947, 1),
(21948, 1),
(21949, 1),
(21950, 1),
(21951, 1),
(21952, 1),
(21953, 1),
(21954, 1),
(21955, 1),
(21956, 1),
(21957, 1),
(21958, 1),
(21959, 1),
(21960, 1),
(21961, 1),
(21962, 1),
(21963, 1),
(21964, 1),
(21965, 1),
(21966, 1),
(21967, 1),
(21968, 1),
(21969, 1),
(21970, 1),
(21971, 1),
(21972, 1),
(21973, 1),
(21974, 1),
(21975, 1),
(21976, 1),
(21977, 1),
(21978, 1),
(21979, 1),
(21980, 1),
(21981, 1),
(21982, 1),
(21983, 1),
(21984, 1),
(21985, 1),
(21986, 1),
(21987, 1),
(21988, 1),
(21989, 1),
(21990, 1),
(21991, 1),
(21992, 1),
(21993, 1),
(21994, 1),
(21995, 1),
(21996, 1),
(21997, 1),
(21998, 1),
(21999, 1),
(22000, 1),
(22001, 1),
(22002, 1),
(22003, 1),
(22004, 1),
(22005, 1),
(22006, 1),
(22007, 1),
(22008, 1),
(22009, 1),
(22010, 1),
(22011, 1),
(22012, 1),
(22013, 1),
(22014, 1),
(22015, 1),
(22016, 1),
(22017, 1),
(22018, 1),
(22019, 1),
(22020, 1),
(22021, 1),
(22022, 1),
(22023, 1),
(22024, 1),
(22025, 1),
(22026, 1),
(22027, 1),
(22028, 1),
(22029, 1),
(22030, 1),
(22031, 1),
(22032, 1),
(22033, 1),
(22034, 1),
(22035, 1),
(22036, 1),
(22037, 1),
(22038, 1),
(22039, 1),
(22040, 1),
(22041, 1),
(22042, 1),
(22043, 1),
(22044, 1),
(22045, 1),
(22046, 1),
(22047, 1),
(22048, 1),
(22049, 1),
(22050, 1),
(22051, 1),
(22052, 1),
(22053, 1),
(22054, 1),
(22055, 1),
(22056, 1),
(22057, 1),
(22058, 1),
(22059, 1),
(22060, 1),
(22061, 1),
(22062, 1),
(22063, 1),
(22064, 1),
(22065, 1),
(22066, 1),
(22067, 1),
(22068, 1),
(22069, 1),
(22070, 1),
(22071, 1),
(22072, 1),
(22073, 1),
(22074, 1),
(22075, 1),
(22076, 1),
(22077, 1),
(22078, 1),
(22079, 1),
(22080, 1),
(22081, 1),
(22082, 1),
(22083, 1),
(22084, 1),
(22085, 1),
(22086, 1),
(22087, 1),
(22088, 1),
(22089, 1),
(22090, 1),
(22091, 1),
(22092, 1),
(22093, 1),
(22094, 1),
(22095, 1),
(22096, 1),
(22097, 1),
(22098, 1),
(22099, 1),
(22100, 1),
(22101, 1),
(22102, 1),
(22103, 1),
(22104, 1),
(22105, 1),
(22106, 1),
(22107, 1),
(22108, 1),
(22109, 1),
(22110, 1),
(22111, 1),
(22112, 1),
(22113, 1),
(22114, 1),
(22115, 1),
(22116, 1),
(22117, 1),
(22118, 1),
(22119, 1),
(22120, 1),
(22121, 1),
(22122, 1),
(22123, 1),
(22124, 1),
(22125, 1),
(22126, 1),
(22127, 1),
(22128, 1),
(22129, 1),
(22130, 1),
(22131, 1),
(22132, 1),
(22133, 1),
(22134, 1),
(22135, 1),
(22136, 1),
(22137, 1),
(22138, 1),
(22139, 1),
(22140, 1),
(22141, 1),
(22142, 1),
(22143, 1),
(22144, 1),
(22145, 1),
(22146, 1),
(22147, 1),
(22148, 1),
(22149, 1),
(22150, 1),
(22151, 1),
(22152, 1),
(22153, 1),
(22154, 1),
(22155, 1),
(22156, 1),
(22157, 1),
(22158, 1),
(22159, 1),
(22160, 1),
(22161, 1),
(22162, 1),
(22163, 1),
(22164, 1),
(22165, 1),
(22166, 1),
(22167, 1),
(22168, 1),
(22169, 1),
(22170, 1),
(22171, 1),
(22172, 1),
(22173, 1),
(22174, 1),
(22175, 1),
(22176, 1),
(22177, 1),
(22178, 1),
(22179, 1),
(22180, 1),
(22181, 1),
(22182, 1),
(22183, 1),
(22184, 1),
(22185, 1),
(22186, 1),
(22187, 1),
(22188, 1),
(22189, 1),
(22190, 1),
(22191, 1),
(22192, 1),
(22193, 1),
(22194, 1),
(22195, 1),
(22196, 1),
(22197, 1),
(22198, 1),
(22199, 1),
(22200, 1),
(22201, 1),
(22202, 1),
(22203, 1),
(22204, 1),
(22205, 1),
(22206, 1),
(22207, 1),
(22208, 1),
(22209, 1),
(22210, 1),
(22211, 1),
(22212, 1),
(22213, 1),
(22214, 1),
(22215, 1),
(22216, 1),
(22217, 1),
(22218, 1),
(22219, 1),
(22220, 1),
(22221, 1),
(22222, 1),
(22223, 1),
(22224, 1),
(22225, 1),
(22226, 1),
(22227, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(22228, 1),
(22229, 1),
(22230, 1),
(22231, 1),
(22232, 1),
(22233, 1),
(22234, 1),
(22235, 1),
(22236, 1),
(22237, 1),
(22238, 1),
(22239, 1),
(22240, 1),
(22241, 1),
(22242, 1),
(22243, 1),
(22244, 1),
(22245, 1),
(22246, 1),
(22247, 1),
(22248, 1),
(22249, 1),
(22250, 1),
(22251, 1),
(22252, 1),
(22253, 1),
(22254, 1),
(22255, 1),
(22256, 1),
(22257, 1),
(22258, 1),
(22259, 1),
(22260, 1),
(22261, 1),
(22262, 1),
(22263, 1),
(22264, 1),
(22265, 1),
(22266, 1),
(22267, 1),
(22268, 1),
(22269, 1),
(22270, 1),
(22271, 1),
(22272, 1),
(22273, 1),
(22274, 1),
(22275, 1),
(22276, 1),
(22277, 1),
(22278, 1),
(22279, 1),
(22280, 1),
(22281, 1),
(22282, 1),
(22283, 1),
(22284, 1),
(22285, 1),
(22286, 1),
(22287, 1),
(22288, 1),
(22289, 1),
(22290, 1),
(22291, 1),
(22292, 1),
(22293, 1),
(22294, 1),
(22295, 1),
(22296, 1),
(22297, 1),
(22298, 1),
(22299, 1),
(22300, 1),
(22301, 1),
(22302, 1),
(22303, 1),
(22304, 1),
(22305, 1),
(22306, 1),
(22307, 1),
(22308, 1),
(22309, 1),
(22310, 1),
(22311, 1),
(22312, 1),
(22313, 1),
(22314, 1),
(22315, 1),
(22316, 1),
(22317, 1),
(22318, 1),
(22319, 1),
(22320, 1),
(22321, 1),
(22322, 1),
(22323, 1),
(22324, 1),
(22325, 1),
(22326, 1),
(22327, 1),
(22328, 1),
(22329, 1),
(22330, 1),
(22331, 1),
(22332, 1),
(22333, 1),
(22334, 1),
(22335, 1),
(22336, 1),
(22337, 1),
(22338, 1),
(22339, 1),
(22340, 1),
(22341, 1),
(22342, 1),
(22343, 1),
(22344, 1),
(22345, 1),
(22346, 1),
(22347, 1),
(22348, 1),
(22349, 1),
(22350, 1),
(22351, 1),
(22352, 1),
(22353, 1),
(22354, 1),
(22355, 1),
(22356, 1),
(22357, 1),
(22358, 1),
(22359, 1),
(22360, 1),
(22361, 1),
(22362, 1),
(22363, 1),
(22364, 1),
(22365, 1),
(22366, 1),
(22367, 1),
(22368, 1),
(22369, 1),
(22370, 1),
(22371, 1),
(22372, 1),
(22373, 1),
(22374, 1),
(22375, 1),
(22376, 1),
(22377, 1),
(22378, 1),
(22379, 1),
(22380, 1),
(22381, 1),
(22382, 1),
(22383, 1),
(22384, 1),
(22385, 1),
(22386, 1),
(22387, 1),
(22388, 1),
(22389, 1),
(22390, 1),
(22391, 1),
(22392, 1),
(22393, 1),
(22394, 1),
(22395, 1),
(22396, 1),
(22397, 1),
(22398, 1),
(22399, 1),
(22400, 1),
(22401, 1),
(22402, 1),
(22403, 1),
(22404, 1),
(22405, 1),
(22406, 1),
(22407, 1),
(22408, 1),
(22409, 1),
(22410, 1),
(22411, 1),
(22412, 1),
(22413, 1),
(22414, 1),
(22415, 1),
(22416, 1),
(22417, 1),
(22418, 1),
(22419, 1),
(22420, 1),
(22421, 1),
(22422, 1),
(22423, 1),
(22424, 1),
(22425, 1),
(22426, 1),
(22427, 1),
(22428, 1),
(22429, 1),
(22430, 1),
(22431, 1),
(22432, 1),
(22433, 1),
(22434, 1),
(22435, 1),
(22436, 1),
(22437, 1),
(22438, 1),
(22439, 1),
(22440, 1),
(22441, 1),
(22442, 1),
(22443, 1),
(22444, 1),
(22445, 1),
(22446, 1),
(22447, 1),
(22448, 1),
(22449, 1),
(22450, 1),
(22451, 1),
(22452, 1),
(22453, 1),
(22454, 1),
(22455, 1),
(22456, 1),
(22457, 1),
(22458, 1),
(22459, 1),
(22460, 1),
(22461, 1),
(22462, 1),
(22463, 1),
(22464, 1),
(22465, 1),
(22466, 1),
(22467, 1),
(22468, 1),
(22469, 1),
(22470, 1),
(22471, 1),
(22472, 1),
(22473, 1),
(22474, 1),
(22475, 1),
(22476, 1),
(22477, 1),
(22478, 1),
(22479, 1),
(22480, 1),
(22481, 1),
(22482, 1),
(22483, 1),
(22484, 1),
(22485, 1),
(22486, 1),
(22487, 1),
(22488, 1),
(22489, 1),
(22490, 1),
(22491, 1),
(22492, 1),
(22493, 1),
(22494, 1),
(22495, 1),
(22496, 1),
(22497, 1),
(22498, 1),
(22499, 1),
(22500, 1),
(22501, 1),
(22502, 1),
(22503, 1),
(22504, 1),
(22505, 1),
(22506, 1),
(22507, 1),
(22508, 1),
(22509, 1),
(22510, 1),
(22511, 1),
(22512, 1),
(22513, 1),
(22514, 1),
(22515, 1),
(22516, 1),
(22517, 1),
(22518, 1),
(22519, 1),
(22520, 1),
(22521, 1),
(22522, 1),
(22523, 1),
(22524, 1),
(22525, 1),
(22526, 1),
(22527, 1),
(22528, 1),
(22529, 1),
(22530, 1),
(22531, 1),
(22532, 1),
(22533, 1),
(22534, 1),
(22535, 1),
(22536, 1),
(22537, 1),
(22538, 1),
(22539, 1),
(22540, 1),
(22541, 1),
(22542, 1),
(22543, 1),
(22544, 1),
(22545, 1),
(22546, 1),
(22547, 1),
(22548, 1),
(22549, 1),
(22550, 1),
(22551, 1),
(22552, 1),
(22553, 1),
(22554, 1),
(22555, 1),
(22556, 1),
(22557, 1),
(22558, 1),
(22559, 1),
(22560, 1),
(22561, 1),
(22562, 1),
(22563, 1),
(22564, 1),
(22565, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(22566, 1),
(22567, 1),
(22568, 1),
(22569, 1),
(22570, 1),
(22571, 1),
(22572, 1),
(22573, 1),
(22574, 1),
(22575, 1),
(22576, 1),
(22577, 1),
(22578, 1),
(22579, 1),
(22580, 1),
(22581, 1),
(22582, 1),
(22583, 1),
(22584, 1),
(22585, 1),
(22586, 1),
(22587, 1),
(22588, 1),
(22589, 1),
(22590, 1),
(22591, 1),
(22592, 1),
(22593, 1),
(22594, 1),
(22595, 1),
(22596, 1),
(22597, 1),
(22598, 1),
(22599, 1),
(22600, 1),
(22601, 1),
(22602, 1),
(22603, 1),
(22604, 1),
(22605, 1),
(22606, 1),
(22607, 1),
(22608, 1),
(22609, 1),
(22610, 1),
(22611, 1),
(22612, 1),
(22613, 1),
(22614, 1),
(22615, 1),
(22616, 1),
(22617, 1),
(22618, 1),
(22619, 1),
(22620, 1),
(22621, 1),
(22622, 1),
(22623, 1),
(22624, 1),
(22625, 1),
(22626, 1),
(22627, 1),
(22628, 1),
(22629, 1),
(22630, 1),
(22631, 1),
(22632, 1),
(22633, 1),
(22634, 1),
(22635, 1),
(22636, 1),
(22637, 1),
(22638, 1),
(22639, 1),
(22640, 1),
(22641, 1),
(22642, 1),
(22643, 1),
(22644, 1),
(22645, 1),
(22646, 1),
(22647, 1),
(22648, 1),
(22649, 1),
(22650, 1),
(22651, 1),
(22652, 1),
(22653, 1),
(22654, 1),
(22655, 1),
(22656, 1),
(22657, 1),
(22658, 1),
(22659, 1),
(22660, 1),
(22661, 1),
(22662, 1),
(22663, 1),
(22664, 1),
(22665, 1),
(22666, 1),
(22667, 1),
(22668, 1),
(22669, 1),
(22670, 1),
(22671, 1),
(22672, 1),
(22673, 1),
(22674, 1),
(22675, 1),
(22676, 1),
(22677, 1),
(22678, 1),
(22679, 1),
(22680, 1),
(22681, 1),
(22682, 1),
(22683, 1),
(22684, 1),
(22685, 1),
(22686, 1),
(22687, 1),
(22688, 1),
(22689, 1),
(22690, 1),
(22691, 1),
(22692, 1),
(22693, 1),
(22694, 1),
(22695, 1),
(22696, 1),
(22697, 1),
(22698, 1),
(22699, 1),
(22700, 1),
(22701, 1),
(22702, 1),
(22703, 1),
(22704, 1),
(22705, 1),
(22706, 1),
(22707, 1),
(22708, 1),
(22709, 1),
(22710, 1),
(22711, 1),
(22712, 1),
(22713, 1),
(22714, 1),
(22715, 1),
(22716, 1),
(22717, 1),
(22718, 1),
(22719, 1),
(22720, 1),
(22721, 1),
(22722, 1),
(22723, 1),
(22724, 1),
(22725, 1),
(22726, 1),
(22727, 1),
(22728, 1),
(22729, 1),
(22730, 1),
(22731, 1),
(22732, 1),
(22733, 1),
(22734, 1),
(22735, 1),
(22736, 1),
(22737, 1),
(22738, 1),
(22739, 1),
(22740, 1),
(22741, 1),
(22742, 1),
(22743, 1),
(22744, 1),
(22745, 1),
(22746, 1),
(22747, 1),
(22748, 1),
(22749, 1),
(22750, 1),
(22751, 1),
(22752, 1),
(22753, 1),
(22754, 1),
(22755, 1),
(22756, 1),
(22757, 1),
(22758, 1),
(22759, 1),
(22760, 1),
(22761, 1),
(22762, 1),
(22763, 1),
(22764, 1),
(22765, 1),
(22766, 1),
(22767, 1),
(22768, 1),
(22769, 1),
(22770, 1),
(22771, 1),
(22772, 1),
(22773, 1),
(22774, 1),
(22775, 1),
(22776, 1),
(22777, 1),
(22778, 1),
(22779, 1),
(22780, 1),
(22781, 1),
(22782, 1),
(22783, 1),
(22784, 1),
(22785, 1),
(22786, 1),
(22787, 1),
(22788, 1),
(22789, 1),
(22790, 1),
(22791, 1),
(22792, 1),
(22793, 1),
(22794, 1),
(22795, 1),
(22796, 1),
(22797, 1),
(22798, 1),
(22799, 1),
(22800, 1),
(22801, 1),
(22802, 1),
(22803, 1),
(22804, 1),
(22805, 1),
(22806, 1),
(22807, 1),
(22808, 1),
(22809, 1),
(22810, 1),
(22811, 1),
(22812, 1),
(22813, 1),
(22814, 1),
(22815, 1),
(22816, 1),
(22817, 1),
(22818, 1),
(22819, 1),
(22820, 1),
(22821, 1),
(22822, 1),
(22823, 1),
(22824, 1),
(22825, 1),
(22826, 1),
(22827, 1),
(22828, 1),
(22829, 1),
(22830, 1),
(22831, 1),
(22832, 1),
(22833, 1),
(22834, 1),
(22835, 1),
(22836, 1),
(22837, 1),
(22838, 1),
(22839, 1),
(22840, 1),
(22841, 1),
(22842, 1),
(22843, 1),
(22844, 1),
(22845, 1),
(22846, 1),
(22847, 1),
(22848, 1),
(22849, 1),
(22850, 1),
(22851, 1),
(22852, 1),
(22853, 1),
(22854, 1),
(22855, 1),
(22856, 1),
(22857, 1),
(22858, 1),
(22859, 1),
(22860, 1),
(22861, 1),
(22862, 1),
(22863, 1),
(22864, 1),
(22865, 1),
(22866, 1),
(22867, 1),
(22868, 1),
(22869, 1),
(22870, 1),
(22871, 1),
(22872, 1),
(22873, 1),
(22874, 1),
(22875, 1),
(22876, 1),
(22877, 1),
(22878, 1),
(22879, 1),
(22880, 1),
(22881, 1),
(22882, 1),
(22883, 1),
(22884, 1),
(22885, 1),
(22886, 1),
(22887, 1),
(22888, 1),
(22889, 1),
(22890, 1),
(22891, 1),
(22892, 1),
(22893, 1),
(22894, 1),
(22895, 1),
(22896, 1),
(22897, 1),
(22898, 1),
(22899, 1),
(22900, 1),
(22901, 1),
(22902, 1),
(22903, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(22904, 1),
(22905, 1),
(22906, 1),
(22907, 1),
(22908, 1),
(22909, 1),
(22910, 1),
(22911, 1),
(22912, 1),
(22913, 1),
(22914, 1),
(22915, 1),
(22916, 1),
(22917, 1),
(22918, 1),
(22919, 1),
(22920, 1),
(22921, 1),
(22922, 1),
(22923, 1),
(22924, 1),
(22925, 1),
(22926, 1),
(22927, 1),
(22928, 1),
(22929, 1),
(22930, 1),
(22931, 1),
(22932, 1),
(22933, 1),
(22934, 1),
(22935, 1),
(22936, 1),
(22937, 1),
(22938, 1),
(22939, 1),
(22940, 1),
(22941, 1),
(22942, 1),
(22943, 1),
(22944, 1),
(22945, 1),
(22946, 1),
(22947, 1),
(22948, 1),
(22949, 1),
(22950, 1),
(22951, 1),
(22952, 1),
(22953, 1),
(22954, 1),
(22955, 1),
(22956, 1),
(22957, 1),
(22958, 1),
(22959, 1),
(22960, 1),
(22961, 1),
(22962, 1),
(22963, 1),
(22964, 1),
(22965, 1),
(22966, 1),
(22967, 1),
(22968, 1),
(22969, 1),
(22970, 1),
(22971, 1),
(22972, 1),
(22973, 1),
(22974, 1),
(22975, 1),
(22976, 1),
(22977, 1),
(22978, 1),
(22979, 1),
(22980, 1),
(22981, 1),
(22982, 1),
(22983, 1),
(22984, 1),
(22985, 1),
(22986, 1),
(22987, 1),
(22988, 1),
(22989, 1),
(22990, 1),
(22991, 1),
(22992, 1),
(22993, 1),
(22994, 1),
(22995, 1),
(22996, 1),
(22997, 1),
(22998, 1),
(22999, 1),
(23000, 1),
(23001, 1),
(23002, 1),
(23003, 1),
(23004, 1),
(23005, 1),
(23006, 1),
(23007, 1),
(23008, 1),
(23009, 1),
(23010, 1),
(23011, 1),
(23012, 1),
(23013, 1),
(23014, 1),
(23015, 1),
(23016, 1),
(23017, 1),
(23018, 1),
(23019, 1),
(23020, 1),
(23021, 1),
(23022, 1),
(23023, 1),
(23024, 1),
(23025, 1),
(23026, 1),
(23027, 1),
(23028, 1),
(23029, 1),
(23030, 1),
(23031, 1),
(23032, 1),
(23033, 1),
(23034, 1),
(23035, 1),
(23036, 1),
(23037, 1),
(23038, 1),
(23039, 1),
(23040, 1),
(23041, 1),
(23042, 1),
(23043, 1),
(23044, 1),
(23045, 1),
(23046, 1),
(23047, 1),
(23048, 1),
(23049, 1),
(23050, 1),
(23051, 1),
(23052, 1),
(23053, 1),
(23054, 1),
(23055, 1),
(23056, 1),
(23057, 1),
(23058, 1),
(23059, 1),
(23060, 1),
(23061, 1),
(23062, 1),
(23063, 1),
(23064, 1),
(23065, 1),
(23066, 1),
(23067, 1),
(23068, 1),
(23069, 1),
(23070, 1),
(23071, 1),
(23072, 1),
(23073, 1),
(23074, 1),
(23075, 1),
(23076, 1),
(23077, 1),
(23078, 1),
(23079, 1),
(23080, 1),
(23081, 1),
(23082, 1),
(23083, 1),
(23084, 1),
(23085, 1),
(23086, 1),
(23087, 1),
(23088, 1),
(23089, 1),
(23090, 1),
(23091, 1),
(23092, 1),
(23093, 1),
(23094, 1),
(23095, 1),
(23096, 1),
(23097, 1),
(23098, 1),
(23099, 1),
(23100, 1),
(23101, 1),
(23102, 1),
(23103, 1),
(23104, 1),
(23105, 1),
(23106, 1),
(23107, 1),
(23108, 1),
(23109, 1),
(23110, 1),
(23111, 1),
(23112, 1),
(23113, 1),
(23114, 1),
(23115, 1),
(23116, 1),
(23117, 1),
(23118, 1),
(23119, 1),
(23120, 1),
(23121, 1),
(23122, 1),
(23123, 1),
(23124, 1),
(23125, 1),
(23126, 1),
(23127, 1),
(23128, 1),
(23129, 1),
(23130, 1),
(23131, 1),
(23132, 1),
(23133, 1),
(23134, 1),
(23135, 1),
(23136, 1),
(23137, 1),
(23138, 1),
(23139, 1),
(23140, 1),
(23141, 1),
(23142, 1),
(23143, 1),
(23144, 1),
(23145, 1),
(23146, 1),
(23147, 1),
(23148, 1),
(23149, 1),
(23150, 1),
(23151, 1),
(23152, 1),
(23153, 1),
(23154, 1),
(23155, 1),
(23156, 1),
(23157, 1),
(23158, 1),
(23159, 1),
(23160, 1),
(23161, 1),
(23162, 1),
(23163, 1),
(23164, 1),
(23165, 1),
(23166, 1),
(23167, 1),
(23168, 1),
(23169, 1),
(23170, 1),
(23171, 1),
(23172, 1),
(23173, 1),
(23174, 1),
(23175, 1),
(23176, 1),
(23177, 1),
(23178, 1),
(23179, 1),
(23180, 1),
(23181, 1),
(23182, 1),
(23183, 1),
(23184, 1),
(23185, 1),
(23186, 1),
(23187, 1),
(23188, 1),
(23189, 1),
(23190, 1),
(23191, 1),
(23192, 1),
(23193, 1),
(23194, 1),
(23195, 1),
(23196, 1),
(23197, 1),
(23198, 1),
(23199, 1),
(23200, 1),
(23201, 1),
(23202, 1),
(23203, 1),
(23204, 1),
(23205, 1),
(23206, 1),
(23207, 1),
(23208, 1),
(23209, 1),
(23210, 1),
(23211, 1),
(23212, 1),
(23213, 1),
(23214, 1),
(23215, 1),
(23216, 1),
(23217, 1),
(23218, 1),
(23219, 1),
(23220, 1),
(23221, 1),
(23222, 1),
(23223, 1),
(23224, 1),
(23225, 1),
(23226, 1),
(23227, 1),
(23228, 1),
(23229, 1),
(23230, 1),
(23231, 1),
(23232, 1),
(23233, 1),
(23234, 1),
(23235, 1),
(23236, 1),
(23237, 1),
(23238, 1),
(23239, 1),
(23240, 1),
(23241, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(23242, 1),
(23243, 1),
(23244, 1),
(23245, 1),
(23246, 1),
(23247, 1),
(23248, 1),
(23249, 1),
(23250, 1),
(23251, 1),
(23252, 1),
(23253, 1),
(23254, 1),
(23255, 1),
(23256, 1),
(23257, 1),
(23258, 1),
(23259, 1),
(23260, 1),
(23261, 1),
(23262, 1),
(23263, 1),
(23264, 1),
(23265, 1),
(23266, 1),
(23267, 1),
(23268, 1),
(23269, 1),
(23270, 1),
(23271, 1),
(23272, 1),
(23273, 1),
(23274, 1),
(23275, 1),
(23276, 1),
(23277, 1),
(23278, 1),
(23279, 1),
(23280, 1),
(23281, 1),
(23282, 1),
(23283, 1),
(23284, 1),
(23285, 1),
(23286, 1),
(23287, 1),
(23288, 1),
(23289, 1),
(23290, 1),
(23291, 1),
(23292, 1),
(23293, 1),
(23294, 1),
(23295, 1),
(23296, 1),
(23297, 1),
(23298, 1),
(23299, 1),
(23300, 1),
(23301, 1),
(23302, 1),
(23303, 1),
(23304, 1),
(23305, 1),
(23306, 1),
(23307, 1),
(23308, 1),
(23309, 1),
(23310, 1),
(23311, 1),
(23312, 1),
(23313, 1),
(23314, 1),
(23315, 1),
(23316, 1),
(23317, 1),
(23318, 1),
(23319, 1),
(23320, 1),
(23321, 1),
(23322, 1),
(23323, 1),
(23324, 1),
(23325, 1),
(23326, 1),
(23327, 1),
(23328, 1),
(23329, 1),
(23330, 1),
(23331, 1),
(23332, 1),
(23333, 1),
(23334, 1),
(23335, 1),
(23336, 1),
(23337, 1),
(23338, 1),
(23339, 1),
(23340, 1),
(23341, 1),
(23342, 1),
(23343, 1),
(23344, 1),
(23345, 1),
(23346, 1),
(23347, 1),
(23348, 1),
(23349, 1),
(23350, 1),
(23351, 1),
(23352, 1),
(23353, 1),
(23354, 1),
(23355, 1),
(23356, 1),
(23357, 1),
(23358, 1),
(23359, 1),
(23360, 1),
(23361, 1),
(23362, 1),
(23363, 1),
(23364, 1),
(23365, 1),
(23366, 1),
(23367, 1),
(23368, 1),
(23369, 1),
(23370, 1),
(23371, 1),
(23372, 1),
(23373, 1),
(23374, 1),
(23375, 1),
(23376, 1),
(23377, 1),
(23378, 1),
(23379, 1),
(23380, 1),
(23381, 1),
(23382, 1),
(23383, 1),
(23384, 1),
(23385, 1),
(23386, 1),
(23387, 1),
(23388, 1),
(23389, 1),
(23390, 1),
(23391, 1),
(23392, 1),
(23393, 1),
(23394, 1),
(23395, 1),
(23396, 1),
(23397, 1),
(23398, 1),
(23399, 1),
(23400, 1),
(23401, 1),
(23402, 1),
(23403, 1),
(23404, 1),
(23405, 1),
(23406, 1),
(23407, 1),
(23408, 1),
(23409, 1),
(23410, 1),
(23411, 1),
(23412, 1),
(23413, 1),
(23414, 1),
(23415, 1),
(23416, 1),
(23417, 1),
(23418, 1),
(23419, 1),
(23420, 1),
(23421, 1),
(23422, 1),
(23423, 1),
(23424, 1),
(23425, 1),
(23426, 1),
(23427, 1),
(23428, 1),
(23429, 1),
(23430, 1),
(23431, 1),
(23432, 1),
(23433, 1),
(23434, 1),
(23435, 1),
(23436, 1),
(23437, 1),
(23438, 1),
(23439, 1),
(23440, 1),
(23441, 1),
(23442, 1),
(23443, 1),
(23444, 1),
(23445, 1),
(23446, 1),
(23447, 1),
(23448, 1),
(23449, 1),
(23450, 1),
(23451, 1),
(23452, 1),
(23453, 1),
(23454, 1),
(23455, 1),
(23456, 1),
(23457, 1),
(23458, 1),
(23459, 1),
(23460, 1),
(23461, 1),
(23462, 1),
(23463, 1),
(23464, 1),
(23465, 1),
(23466, 1),
(23467, 1),
(23468, 1),
(23469, 1),
(23470, 1),
(23471, 1),
(23472, 1),
(23473, 1),
(23474, 1),
(23475, 1),
(23476, 1),
(23477, 1),
(23478, 1),
(23479, 1),
(23480, 1),
(23481, 1),
(23482, 1),
(23483, 1),
(23484, 1),
(23485, 1),
(23486, 1),
(23487, 1),
(23488, 1),
(23489, 1),
(23490, 1),
(23491, 1),
(23492, 1),
(23493, 1),
(23494, 1),
(23495, 1),
(23496, 1),
(23497, 1),
(23498, 1),
(23499, 1),
(23500, 1),
(23501, 1),
(23502, 1),
(23503, 1),
(23504, 1),
(23505, 1),
(23506, 1),
(23507, 1),
(23508, 1),
(23509, 1),
(23510, 1),
(23511, 1),
(23512, 1),
(23513, 1),
(23514, 1),
(23515, 1),
(23516, 1),
(23517, 1),
(23518, 1),
(23519, 1),
(23520, 1),
(23521, 1),
(23522, 1),
(23523, 1),
(23524, 1),
(23525, 1),
(23526, 1),
(23527, 1),
(23528, 1),
(23529, 1),
(23530, 1),
(23531, 1),
(23532, 1),
(23533, 1),
(23534, 1),
(23535, 1),
(23536, 1),
(23537, 1),
(23538, 1),
(23539, 1),
(23540, 1),
(23541, 1),
(23542, 1),
(23543, 1),
(23544, 1),
(23545, 1),
(23546, 1),
(23547, 1),
(23548, 1),
(23549, 1),
(23550, 1),
(23551, 1),
(23552, 1),
(23553, 1),
(23554, 1),
(23555, 1),
(23556, 1),
(23557, 1),
(23558, 1),
(23559, 1),
(23560, 1),
(23561, 1),
(23562, 1),
(23563, 1),
(23564, 1),
(23565, 1),
(23566, 1),
(23567, 1),
(23568, 1),
(23569, 1),
(23570, 1),
(23571, 1),
(23572, 1),
(23573, 1),
(23574, 1),
(23575, 1),
(23576, 1),
(23577, 1),
(23578, 1),
(23579, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(23580, 1),
(23581, 1),
(23582, 1),
(23583, 1),
(23584, 1),
(23585, 1),
(23586, 1),
(23587, 1),
(23588, 1),
(23589, 1),
(23590, 1),
(23591, 1),
(23592, 1),
(23593, 1),
(23594, 1),
(23595, 1),
(23596, 1),
(23597, 1),
(23598, 1),
(23599, 1),
(23600, 1),
(23601, 1),
(23602, 1),
(23603, 1),
(23604, 1),
(23605, 1),
(23606, 1),
(23607, 1),
(23608, 1),
(23609, 1),
(23610, 1),
(23611, 1),
(23612, 1),
(23613, 1),
(23614, 1),
(23615, 1),
(23616, 1),
(23617, 1),
(23618, 1),
(23619, 1),
(23620, 1),
(23621, 1),
(23622, 1),
(23623, 1),
(23624, 1),
(23625, 1),
(23626, 1),
(23627, 1),
(23628, 1),
(23629, 1),
(23630, 1),
(23631, 1),
(23632, 1),
(23633, 1),
(23634, 1),
(23635, 1),
(23636, 1),
(23637, 1),
(23638, 1),
(23639, 1),
(23640, 1),
(23641, 1),
(23642, 1),
(23643, 1),
(23644, 1),
(23645, 1),
(23646, 1),
(23647, 1),
(23648, 1),
(23649, 1),
(23650, 1),
(23651, 1),
(23652, 1),
(23653, 1),
(23654, 1),
(23655, 1),
(23656, 1),
(23657, 1),
(23658, 1),
(23659, 1),
(23660, 1),
(23661, 1),
(23662, 1),
(23663, 1),
(23664, 1),
(23665, 1),
(23666, 1),
(23667, 1),
(23668, 1),
(23669, 1),
(23670, 1),
(23671, 1),
(23672, 1),
(23673, 1),
(23674, 1),
(23675, 1),
(23676, 1),
(23677, 1),
(23678, 1),
(23679, 1),
(23680, 1),
(23681, 1),
(23682, 1),
(23683, 1),
(23684, 1),
(23685, 1),
(23686, 1),
(23687, 1),
(23688, 1),
(23689, 1),
(23690, 1),
(23691, 1),
(23692, 1),
(23693, 1),
(23694, 1),
(23695, 1),
(23696, 1),
(23697, 1),
(23698, 1),
(23699, 1),
(23700, 1),
(23701, 1),
(23702, 1),
(23703, 1),
(23704, 1),
(23705, 1),
(23706, 1),
(23707, 1),
(23708, 1),
(23709, 1),
(23710, 1),
(23711, 1),
(23712, 1),
(23713, 1),
(23714, 1),
(23715, 1),
(23716, 1),
(23717, 1),
(23718, 1),
(23719, 1),
(23720, 1),
(23721, 1),
(23722, 1),
(23723, 1),
(23724, 1),
(23725, 1),
(23726, 1),
(23727, 1),
(23728, 1),
(23729, 1),
(23730, 1),
(23731, 1),
(23732, 1),
(23733, 1),
(23734, 1),
(23735, 1),
(23736, 1),
(23737, 1),
(23738, 1),
(23739, 1),
(23740, 1),
(23741, 1),
(23742, 1),
(23743, 1),
(23744, 1),
(23745, 1),
(23746, 1),
(23747, 1),
(23748, 1),
(23749, 1),
(23750, 1),
(23751, 1),
(23752, 1),
(23753, 1),
(23754, 1),
(23755, 1),
(23756, 1),
(23757, 1),
(23758, 1),
(23759, 1),
(23760, 1),
(23761, 1),
(23762, 1),
(23763, 1),
(23764, 1),
(23765, 1),
(23766, 1),
(23767, 1),
(23768, 1),
(23769, 1),
(23770, 1),
(23771, 1),
(23772, 1),
(23773, 1),
(23774, 1),
(23775, 1),
(23776, 1),
(23777, 1),
(23778, 1),
(23779, 1),
(23780, 1),
(23781, 1),
(23782, 1),
(23783, 1),
(23784, 1),
(23785, 1),
(23786, 1),
(23787, 1),
(23788, 1),
(23789, 1),
(23790, 1),
(23791, 1),
(23792, 1),
(23793, 1),
(23794, 1),
(23795, 1),
(23796, 1),
(23797, 1),
(23798, 1),
(23799, 1),
(23800, 1),
(23801, 1),
(23802, 1),
(23803, 1),
(23804, 1),
(23805, 1),
(23806, 1),
(23807, 1),
(23808, 1),
(23809, 1),
(23810, 1),
(23811, 1),
(23812, 1),
(23813, 1),
(23814, 1),
(23815, 1),
(23816, 1),
(23817, 1),
(23818, 1),
(23819, 1),
(23820, 1),
(23821, 1),
(23822, 1),
(23823, 1),
(23824, 1),
(23825, 1),
(23826, 1),
(23827, 1),
(23828, 1),
(23829, 1),
(23830, 1),
(23831, 1),
(23832, 1),
(23833, 1),
(23834, 1),
(23835, 1),
(23836, 1),
(23837, 1),
(23838, 1),
(23839, 1),
(23840, 1),
(23841, 1),
(23842, 1),
(23843, 1),
(23844, 1),
(23845, 1),
(23846, 1),
(23847, 1),
(23848, 1),
(23849, 1),
(23850, 1),
(23851, 1),
(23852, 1),
(23853, 1),
(23854, 1),
(23855, 1),
(23856, 1),
(23857, 1),
(23858, 1),
(23859, 1),
(23860, 1),
(23861, 1),
(23862, 1),
(23863, 1),
(23864, 1),
(23865, 1),
(23866, 1),
(23867, 1),
(23868, 1),
(23869, 1),
(23870, 1),
(23871, 1),
(23872, 1),
(23873, 1),
(23874, 1),
(23875, 1),
(23876, 1),
(23877, 1),
(23878, 1),
(23879, 1),
(23880, 1),
(23881, 1),
(23882, 1),
(23883, 1),
(23884, 1),
(23885, 1),
(23886, 1),
(23887, 1),
(23888, 1),
(23889, 1),
(23890, 1),
(23891, 1),
(23892, 1),
(23893, 1),
(23894, 1),
(23895, 1),
(23896, 1),
(23897, 1),
(23898, 1),
(23899, 1),
(23900, 1),
(23901, 1),
(23902, 1),
(23903, 1),
(23904, 1),
(23905, 1),
(23906, 1),
(23907, 1),
(23908, 1),
(23909, 1),
(23910, 1),
(23911, 1),
(23912, 1),
(23913, 1),
(23914, 1),
(23915, 1),
(23916, 1),
(23917, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(23918, 1),
(23919, 1),
(23920, 1),
(23921, 1),
(23922, 1),
(23923, 1),
(23924, 1),
(23925, 1),
(23926, 1),
(23927, 1),
(23928, 1),
(23929, 1),
(23930, 1),
(23931, 1),
(23932, 1),
(23933, 1),
(23934, 1),
(23935, 1),
(23936, 1),
(23937, 1),
(23938, 1),
(23939, 1),
(23940, 1),
(23941, 1),
(23942, 1),
(23943, 1),
(23944, 1),
(23945, 1),
(23946, 1),
(23947, 1),
(23948, 1),
(23949, 1),
(23950, 1),
(23951, 1),
(23952, 1),
(23953, 1),
(23954, 1),
(23955, 1),
(23956, 1),
(23957, 1),
(23958, 1),
(23959, 1),
(23960, 1),
(23961, 1),
(23962, 1),
(23963, 1),
(23964, 1),
(23965, 1),
(23966, 1),
(23967, 1),
(23968, 1),
(23969, 1),
(23970, 1),
(23971, 1),
(23972, 1),
(23973, 1),
(23974, 1),
(23975, 1),
(23976, 1),
(23977, 1),
(23978, 1),
(23979, 1),
(23980, 1),
(23981, 1),
(23982, 1),
(23983, 1),
(23984, 1),
(23985, 1),
(23986, 1),
(23987, 1),
(23988, 1),
(23989, 1),
(23990, 1),
(23991, 1),
(23992, 1),
(23993, 1),
(23994, 1),
(23995, 1),
(23996, 1),
(23997, 1),
(23998, 1),
(23999, 1),
(24000, 1),
(24001, 1),
(24002, 1),
(24003, 1),
(24004, 1),
(24005, 1),
(24006, 1),
(24007, 1),
(24008, 1),
(24009, 1),
(24010, 1),
(24011, 1),
(24012, 1),
(24013, 1),
(24014, 1),
(24015, 1),
(24016, 1),
(24017, 1),
(24018, 1),
(24019, 1),
(24020, 1),
(24021, 1),
(24022, 1),
(24023, 1),
(24024, 1),
(24025, 1),
(24026, 1),
(24027, 1),
(24028, 1),
(24029, 1),
(24030, 1),
(24031, 1),
(24032, 1),
(24033, 1),
(24034, 1),
(24035, 1),
(24036, 1),
(24037, 1),
(24038, 1),
(24039, 1),
(24040, 1),
(24041, 1),
(24042, 1),
(24043, 1),
(24044, 1),
(24045, 1),
(24046, 1),
(24047, 1),
(24048, 1),
(24049, 1),
(24050, 1),
(24051, 1),
(24052, 1),
(24053, 1),
(24054, 1),
(24055, 1),
(24056, 1),
(24057, 1),
(24058, 1),
(24059, 1),
(24060, 1),
(24061, 1),
(24062, 1),
(24063, 1),
(24064, 1),
(24065, 1),
(24066, 1),
(24067, 1),
(24068, 1),
(24069, 1),
(24070, 1),
(24071, 1),
(24072, 1),
(24073, 1),
(24074, 1),
(24075, 1),
(24076, 1),
(24077, 1),
(24078, 1),
(24079, 1),
(24080, 1),
(24081, 1),
(24082, 1),
(24083, 1),
(24084, 1),
(24085, 1),
(24086, 1),
(24087, 1),
(24088, 1),
(24089, 1),
(24090, 1),
(24091, 1),
(24092, 1),
(24093, 1),
(24094, 1),
(24095, 1),
(24096, 1),
(24097, 1),
(24098, 1),
(24099, 1),
(24100, 1),
(24101, 1),
(24102, 1),
(24103, 1),
(24104, 1),
(24105, 1),
(24106, 1),
(24107, 1),
(24108, 1),
(24109, 1),
(24110, 1),
(24111, 1),
(24112, 1),
(24113, 1),
(24114, 1),
(24115, 1),
(24116, 1),
(24117, 1),
(24118, 1),
(24119, 1),
(24120, 1),
(24121, 1),
(24122, 1),
(24123, 1),
(24124, 1),
(24125, 1),
(24126, 1),
(24127, 1),
(24128, 1),
(24129, 1),
(24130, 1),
(24131, 1),
(24132, 1),
(24133, 1),
(24134, 1),
(24135, 1),
(24136, 1),
(24137, 1),
(24138, 1),
(24139, 1),
(24140, 1),
(24141, 1),
(24142, 1),
(24143, 1),
(24144, 1),
(24145, 1),
(24146, 1),
(24147, 1),
(24148, 1),
(24149, 1),
(24150, 1),
(24151, 1),
(24152, 1),
(24153, 1),
(24154, 1),
(24155, 1),
(24156, 1),
(24157, 1),
(24158, 1),
(24159, 1),
(24160, 1),
(24161, 1),
(24162, 1),
(24163, 1),
(24164, 1),
(24165, 1),
(24166, 1),
(24167, 1),
(24168, 1),
(24169, 1),
(24170, 1),
(24171, 1),
(24172, 1),
(24173, 1),
(24174, 1),
(24175, 1),
(24176, 1),
(24177, 1),
(24178, 1),
(24179, 1),
(24180, 1),
(24181, 1),
(24182, 1),
(24183, 1),
(24184, 1),
(24185, 1),
(24186, 1),
(24187, 1),
(24188, 1),
(24189, 1),
(24190, 1),
(24191, 1),
(24192, 1),
(24193, 1),
(24194, 1),
(24195, 1),
(24196, 1),
(24197, 1),
(24198, 1),
(24199, 1),
(24200, 1),
(24201, 1),
(24202, 1),
(24203, 1),
(24204, 1),
(24205, 1),
(24206, 1),
(24207, 1),
(24208, 1),
(24209, 1),
(24210, 1),
(24211, 1),
(24212, 1),
(24213, 1),
(24214, 1),
(24215, 1),
(24216, 1),
(24217, 1),
(24218, 1),
(24219, 1),
(24220, 1),
(24221, 1),
(24222, 1),
(24223, 1),
(24224, 1),
(24225, 1),
(24226, 1),
(24227, 1),
(24228, 1),
(24229, 1),
(24230, 1),
(24231, 1),
(24232, 1),
(24233, 1),
(24234, 1),
(24235, 1),
(24236, 1),
(24237, 1),
(24238, 1),
(24239, 1),
(24240, 1),
(24241, 1),
(24242, 1),
(24243, 1),
(24244, 1),
(24245, 1),
(24246, 1),
(24247, 1),
(24248, 1),
(24249, 1),
(24250, 1),
(24251, 1),
(24252, 1),
(24253, 1),
(24254, 1),
(24255, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(24256, 1),
(24257, 1),
(24258, 1),
(24259, 1),
(24260, 1),
(24261, 1),
(24262, 1),
(24263, 1),
(24264, 1),
(24265, 1),
(24266, 1),
(24267, 1),
(24268, 1),
(24269, 1),
(24270, 1),
(24271, 1),
(24272, 1),
(24273, 1),
(24274, 1),
(24275, 1),
(24276, 1),
(24277, 1),
(24278, 1),
(24279, 1),
(24280, 1),
(24281, 1),
(24282, 1),
(24283, 1),
(24284, 1),
(24285, 1),
(24286, 1),
(24287, 1),
(24288, 1),
(24289, 1),
(24290, 1),
(24291, 1),
(24292, 1),
(24293, 1),
(24294, 1),
(24295, 1),
(24296, 1),
(24297, 1),
(24298, 1),
(24299, 1),
(24300, 1),
(24301, 1),
(24302, 1),
(24303, 1),
(24304, 1),
(24305, 1),
(24306, 1),
(24307, 1),
(24308, 1),
(24309, 1),
(24310, 1),
(24311, 1),
(24312, 1),
(24313, 1),
(24314, 1),
(24315, 1),
(24316, 1),
(24317, 1),
(24318, 1),
(24319, 1),
(24320, 1),
(24321, 1),
(24322, 1),
(24323, 1),
(24324, 1),
(24325, 1),
(24326, 1),
(24327, 1),
(24328, 1),
(24329, 1),
(24330, 1),
(24331, 1),
(24332, 1),
(24333, 1),
(24334, 1),
(24335, 1),
(24336, 1),
(24337, 1),
(24338, 1),
(24339, 1),
(24340, 1),
(24341, 1),
(24342, 1),
(24343, 1),
(24344, 1),
(24345, 1),
(24346, 1),
(24347, 1),
(24348, 1),
(24349, 1),
(24350, 1),
(24351, 1),
(24352, 1),
(24353, 1),
(24354, 1),
(24355, 1),
(24356, 1),
(24357, 1),
(24358, 1),
(24359, 1),
(24360, 1),
(24361, 1),
(24362, 1),
(24363, 1),
(24364, 1),
(24365, 1),
(24366, 1),
(24367, 1),
(24368, 1),
(24369, 1),
(24370, 1),
(24371, 1),
(24372, 1),
(24373, 1),
(24374, 1),
(24375, 1),
(24376, 1),
(24377, 1),
(24378, 1),
(24379, 1),
(24380, 1),
(24381, 1),
(24382, 1),
(24383, 1),
(24384, 1),
(24385, 1),
(24386, 1),
(24387, 1),
(24388, 1),
(24389, 1),
(24390, 1),
(24391, 1),
(24392, 1),
(24393, 1),
(24394, 1),
(24395, 1),
(24396, 1),
(24397, 1),
(24398, 1),
(24399, 1),
(24400, 1),
(24401, 1),
(24402, 1),
(24403, 1),
(24404, 1),
(24405, 1),
(24406, 1),
(24407, 1),
(24408, 1),
(24409, 1),
(24410, 1),
(24411, 1),
(24412, 1),
(24413, 1),
(24414, 1),
(24415, 1),
(24416, 1),
(24417, 1),
(24418, 1),
(24419, 1),
(24420, 1),
(24421, 1),
(24422, 1),
(24423, 1),
(24424, 1),
(24425, 1),
(24426, 1),
(24427, 1),
(24428, 1),
(24429, 1),
(24430, 1),
(24431, 1),
(24432, 1),
(24433, 1),
(24434, 1),
(24435, 1),
(24436, 1),
(24437, 1),
(24438, 1),
(24439, 1),
(24440, 1),
(24441, 1),
(24442, 1),
(24443, 1),
(24444, 1),
(24445, 1),
(24446, 1),
(24447, 1),
(24448, 1),
(24449, 1),
(24450, 1),
(24451, 1),
(24452, 1),
(24453, 1),
(24454, 1),
(24455, 1),
(24456, 1),
(24457, 1),
(24458, 1),
(24459, 1),
(24460, 1),
(24461, 1),
(24462, 1),
(24463, 1),
(24464, 1),
(24465, 1),
(24466, 1),
(24467, 1),
(24468, 1),
(24469, 1),
(24470, 1),
(24471, 1),
(24472, 1),
(24473, 1),
(24474, 1),
(24475, 1),
(24476, 1),
(24477, 1),
(24478, 1),
(24479, 1),
(24480, 1),
(24481, 1),
(24482, 1),
(24483, 1),
(24484, 1),
(24485, 1),
(24486, 1),
(24487, 1),
(24488, 1),
(24489, 1),
(24490, 1),
(24491, 1),
(24492, 1),
(24493, 1),
(24494, 1),
(24495, 1),
(24496, 1),
(24497, 1),
(24498, 1),
(24499, 1),
(24500, 1),
(24501, 1),
(24502, 1),
(24503, 1),
(24504, 1),
(24505, 1),
(24506, 1),
(24507, 1),
(24508, 1),
(24509, 1),
(24510, 1),
(24511, 1),
(24512, 1),
(24513, 1),
(24514, 1),
(24515, 1),
(24516, 1),
(24517, 1),
(24518, 1),
(24519, 1),
(24520, 1),
(24521, 1),
(24522, 1),
(24523, 1),
(24524, 1),
(24525, 1),
(24526, 1),
(24527, 1),
(24528, 1),
(24529, 1),
(24530, 1),
(24531, 1),
(24532, 1),
(24533, 1),
(24534, 1),
(24535, 1),
(24536, 1),
(24537, 1),
(24538, 1),
(24539, 1),
(24540, 1),
(24541, 1),
(24542, 1),
(24543, 1),
(24544, 1),
(24545, 1),
(24546, 1),
(24547, 1),
(24548, 1),
(24549, 1),
(24550, 1),
(24551, 1),
(24552, 1),
(24553, 1),
(24554, 1),
(24555, 1),
(24556, 1),
(24557, 1),
(24558, 1),
(24559, 1),
(24560, 1),
(24561, 1),
(24562, 1),
(24563, 1),
(24564, 1),
(24565, 1),
(24566, 1),
(24567, 1),
(24568, 1),
(24569, 1),
(24570, 1),
(24571, 1),
(24572, 1),
(24573, 1),
(24574, 1),
(24575, 1),
(24576, 1),
(24577, 1),
(24578, 1),
(24579, 1),
(24580, 1),
(24581, 1),
(24582, 1),
(24583, 1),
(24584, 1),
(24585, 1),
(24586, 1),
(24587, 1),
(24588, 1),
(24589, 1),
(24590, 1),
(24591, 1),
(24592, 1),
(24593, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(24594, 1),
(24595, 1),
(24596, 1),
(24597, 1),
(24598, 1),
(24599, 1),
(24600, 1),
(24601, 1),
(24602, 1),
(24603, 1),
(24604, 1),
(24605, 1),
(24606, 1),
(24607, 1),
(24608, 1),
(24609, 1),
(24610, 1),
(24611, 1),
(24612, 1),
(24613, 1),
(24614, 1),
(24615, 1),
(24616, 1),
(24617, 1),
(24618, 1),
(24619, 1),
(24620, 1),
(24621, 1),
(24622, 1),
(24623, 1),
(24624, 1),
(24625, 1),
(24626, 1),
(24627, 1),
(24628, 1),
(24629, 1),
(24630, 1),
(24631, 1),
(24632, 1),
(24633, 1),
(24634, 1),
(24635, 1),
(24636, 1),
(24637, 1),
(24638, 1),
(24639, 1),
(24640, 1),
(24641, 1),
(24642, 1),
(24643, 1),
(24644, 1),
(24645, 1),
(24646, 1),
(24647, 1),
(24648, 1),
(24649, 1),
(24650, 1),
(24651, 1),
(24652, 1),
(24653, 1),
(24654, 1),
(24655, 1),
(24656, 1),
(24657, 1),
(24658, 1),
(24659, 1),
(24660, 1),
(24661, 1),
(24662, 1),
(24663, 1),
(24664, 1),
(24665, 1),
(24666, 1),
(24667, 1),
(24668, 1),
(24669, 1),
(24670, 1),
(24671, 1),
(24672, 1),
(24673, 1),
(24674, 1),
(24675, 1),
(24676, 1),
(24677, 1),
(24678, 1),
(24679, 1),
(24680, 1),
(24681, 1),
(24682, 1),
(24683, 1),
(24684, 1),
(24685, 1),
(24686, 1),
(24687, 1),
(24688, 1),
(24689, 1),
(24690, 1),
(24691, 1),
(24692, 1),
(24693, 1),
(24694, 1),
(24695, 1),
(24696, 1),
(24697, 1),
(24698, 1),
(24699, 1),
(24700, 1),
(24701, 1),
(24702, 1),
(24703, 1),
(24704, 1),
(24705, 1),
(24706, 1),
(24707, 1),
(24708, 1),
(24709, 1),
(24710, 1),
(24711, 1),
(24712, 1),
(24713, 1),
(24714, 1),
(24715, 1),
(24716, 1),
(24717, 1),
(24718, 1),
(24719, 1),
(24720, 1),
(24721, 1),
(24722, 1),
(24723, 1),
(24724, 1),
(24725, 1),
(24726, 1),
(24727, 1),
(24728, 1),
(24729, 1),
(24730, 1),
(24731, 1),
(24732, 1),
(24733, 1),
(24734, 1),
(24735, 1),
(24736, 1),
(24737, 1),
(24738, 1),
(24739, 1),
(24740, 1),
(24741, 1),
(24742, 1),
(24743, 1),
(24744, 1),
(24745, 1),
(24746, 1),
(24747, 1),
(24748, 1),
(24749, 1),
(24750, 1),
(24751, 1),
(24752, 1),
(24753, 1),
(24754, 1),
(24755, 1),
(24756, 1),
(24757, 1),
(24758, 1),
(24759, 1),
(24760, 1),
(24761, 1),
(24762, 1),
(24763, 1),
(24764, 1),
(24765, 1),
(24766, 1),
(24767, 1),
(24768, 1),
(24769, 1),
(24770, 1),
(24771, 1),
(24772, 1),
(24773, 1),
(24774, 1),
(24775, 1),
(24776, 1),
(24777, 1),
(24778, 1),
(24779, 1),
(24780, 1),
(24781, 1),
(24782, 1),
(24783, 1),
(24784, 1),
(24785, 1),
(24786, 1),
(24787, 1),
(24788, 1),
(24789, 1),
(24790, 1),
(24791, 1),
(24792, 1),
(24793, 1),
(24794, 1),
(24795, 1),
(24796, 1),
(24797, 1),
(24798, 1),
(24799, 1),
(24800, 1),
(24801, 1),
(24802, 1),
(24803, 1),
(24804, 1),
(24805, 1),
(24806, 1),
(24807, 1),
(24808, 1),
(24809, 1),
(24810, 1),
(24811, 1),
(24812, 1),
(24813, 1),
(24814, 1),
(24815, 1),
(24816, 1),
(24817, 1),
(24818, 1),
(24819, 1),
(24820, 1),
(24821, 1),
(24822, 1),
(24823, 1),
(24824, 1),
(24825, 1),
(24826, 1),
(24827, 1),
(24828, 1),
(24829, 1),
(24830, 1),
(24831, 1),
(24832, 1),
(24833, 1),
(24834, 1),
(24835, 1),
(24836, 1),
(24837, 1),
(24838, 1),
(24839, 1),
(24840, 1),
(24841, 1),
(24842, 1),
(24843, 1),
(24844, 1),
(24845, 1),
(24846, 1),
(24847, 1),
(24848, 1),
(24849, 1),
(24850, 1),
(24851, 1),
(24852, 1),
(24853, 1),
(24854, 1),
(24855, 1),
(24856, 1),
(24857, 1),
(24858, 1),
(24859, 1),
(24860, 1),
(24861, 1),
(24862, 1),
(24863, 1),
(24864, 1),
(24865, 1),
(24866, 1),
(24867, 1),
(24868, 1),
(24869, 1),
(24870, 1),
(24871, 1),
(24872, 1),
(24873, 1),
(24874, 1),
(24875, 1),
(24876, 1),
(24877, 1),
(24878, 1),
(24879, 1),
(24880, 1),
(24881, 1),
(24882, 1),
(24883, 1),
(24884, 1),
(24885, 1),
(24886, 1),
(24887, 1),
(24888, 1),
(24889, 1),
(24890, 1),
(24891, 1),
(24892, 1),
(24893, 1),
(24894, 1),
(24895, 1),
(24896, 1),
(24897, 1),
(24898, 1),
(24899, 1),
(24900, 1),
(24901, 1),
(24902, 1),
(24903, 1),
(24904, 1),
(24905, 1),
(24906, 1),
(24907, 1),
(24908, 1),
(24909, 1),
(24910, 1),
(24911, 1),
(24912, 1),
(24913, 1),
(24914, 1),
(24915, 1),
(24916, 1),
(24917, 1),
(24918, 1),
(24919, 1),
(24920, 1),
(24921, 1),
(24922, 1),
(24923, 1),
(24924, 1),
(24925, 1),
(24926, 1),
(24927, 1),
(24928, 1),
(24929, 1),
(24930, 1),
(24931, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(24932, 1),
(24933, 1),
(24934, 1),
(24935, 1),
(24936, 1),
(24937, 1),
(24938, 1),
(24939, 1),
(24940, 1),
(24941, 1),
(24942, 1),
(24943, 1),
(24944, 1),
(24945, 1),
(24946, 1),
(24947, 1),
(24948, 1),
(24949, 1),
(24950, 1),
(24951, 1),
(24952, 1),
(24953, 1),
(24954, 1),
(24955, 1),
(24956, 1),
(24957, 1),
(24958, 1),
(24959, 1),
(24960, 1),
(24961, 1),
(24962, 1),
(24963, 1),
(24964, 1),
(24965, 1),
(24966, 1),
(24967, 1),
(24968, 1),
(24969, 1),
(24970, 1),
(24971, 1),
(24972, 1),
(24973, 1),
(24974, 1),
(24975, 1),
(24976, 1),
(24977, 1),
(24978, 1),
(24979, 1),
(24980, 1),
(24981, 1),
(24982, 1),
(24983, 1),
(24984, 1),
(24985, 1),
(24986, 1),
(24987, 1),
(24988, 1),
(24989, 1),
(24990, 1),
(24991, 1),
(24992, 1),
(24993, 1),
(24994, 1),
(24995, 1),
(24996, 1),
(24997, 1),
(24998, 1),
(24999, 1),
(25000, 1),
(25001, 1),
(25002, 1),
(25003, 1),
(25004, 1),
(25005, 1),
(25006, 1),
(25007, 1),
(25008, 1),
(25009, 1),
(25010, 1),
(25011, 1),
(25012, 1),
(25013, 1),
(25014, 1),
(25015, 1),
(25016, 1),
(25017, 1),
(25018, 1),
(25019, 1),
(25020, 1),
(25021, 1),
(25022, 1),
(25023, 1),
(25024, 1),
(25025, 1),
(25026, 1),
(25027, 1),
(25028, 1),
(25029, 1),
(25030, 1),
(25031, 1),
(25032, 1),
(25033, 1),
(25034, 1),
(25035, 1),
(25036, 1),
(25037, 1),
(25038, 1),
(25039, 1),
(25040, 1),
(25041, 1),
(25042, 1),
(25043, 1),
(25044, 1),
(25045, 1),
(25046, 1),
(25047, 1),
(25048, 1),
(25049, 1),
(25050, 1),
(25051, 1),
(25052, 1),
(25053, 1),
(25054, 1),
(25055, 1),
(25056, 1),
(25057, 1),
(25058, 1),
(25059, 1),
(25060, 1),
(25061, 1),
(25062, 1),
(25063, 1),
(25064, 1),
(25065, 1),
(25066, 1),
(25067, 1),
(25068, 1),
(25069, 1),
(25070, 1),
(25071, 1),
(25072, 1),
(25073, 1),
(25074, 1),
(25075, 1),
(25076, 1),
(25077, 1),
(25078, 1),
(25079, 1),
(25080, 1),
(25081, 1),
(25082, 1),
(25083, 1),
(25084, 1),
(25085, 1),
(25086, 1),
(25087, 1),
(25088, 1),
(25089, 1),
(25090, 1),
(25091, 1),
(25092, 1),
(25093, 1),
(25094, 1),
(25095, 1),
(25096, 1),
(25097, 1),
(25098, 1),
(25099, 1),
(25100, 1),
(25101, 1),
(25102, 1),
(25103, 1),
(25104, 1),
(25105, 1),
(25106, 1),
(25107, 1),
(25108, 1),
(25109, 1),
(25110, 1),
(25111, 1),
(25112, 1),
(25113, 1),
(25114, 1),
(25115, 1),
(25116, 1),
(25117, 1),
(25118, 1),
(25119, 1),
(25120, 1),
(25121, 1),
(25122, 1),
(25123, 1),
(25124, 1),
(25125, 1),
(25126, 1),
(25127, 1),
(25128, 1),
(25129, 1),
(25130, 1),
(25131, 1),
(25132, 1),
(25133, 1),
(25134, 1),
(25135, 1),
(25136, 1),
(25137, 1),
(25138, 1),
(25139, 1),
(25140, 1),
(25141, 1),
(25142, 1),
(25143, 1),
(25144, 1),
(25145, 1),
(25146, 1),
(25147, 1),
(25148, 1),
(25149, 1),
(25150, 1),
(25151, 1),
(25152, 1),
(25153, 1),
(25154, 1),
(25155, 1),
(25156, 1),
(25157, 1),
(25158, 1),
(25159, 1),
(25160, 1),
(25161, 1),
(25162, 1),
(25163, 1),
(25164, 1),
(25165, 1),
(25166, 1),
(25167, 1),
(25168, 1),
(25169, 1),
(25170, 1),
(25171, 1),
(25172, 1),
(25173, 1),
(25174, 1),
(25175, 1),
(25176, 1),
(25177, 1),
(25178, 1),
(25179, 1),
(25180, 1),
(25181, 1),
(25182, 1),
(25183, 1),
(25184, 1),
(25185, 1),
(25186, 1),
(25187, 1),
(25188, 1),
(25189, 1),
(25190, 1),
(25191, 1),
(25192, 1),
(25193, 1),
(25194, 1),
(25195, 1),
(25196, 1),
(25197, 1),
(25198, 1),
(25199, 1),
(25200, 1),
(25201, 1),
(25202, 1),
(25203, 1),
(25204, 1),
(25205, 1),
(25206, 1),
(25207, 1),
(25208, 1),
(25209, 1),
(25210, 1),
(25211, 1),
(25212, 1),
(25213, 1),
(25214, 1),
(25215, 1),
(25216, 1),
(25217, 1),
(25218, 1),
(25219, 1),
(25220, 1),
(25221, 1),
(25222, 1),
(25223, 1),
(25224, 1),
(25225, 1),
(25226, 1),
(25227, 1),
(25228, 1),
(25229, 1),
(25230, 1),
(25231, 1),
(25232, 1),
(25233, 1),
(25234, 1),
(25235, 1),
(25236, 1),
(25237, 1),
(25238, 1),
(25239, 1),
(25240, 1),
(25241, 1),
(25242, 1),
(25243, 1),
(25244, 1),
(25245, 1),
(25246, 1),
(25247, 1),
(25248, 1),
(25249, 1),
(25250, 1),
(25251, 1),
(25252, 1),
(25253, 1),
(25254, 1),
(25255, 1),
(25256, 1),
(25257, 1),
(25258, 1),
(25259, 1),
(25260, 1),
(25261, 1),
(25262, 1),
(25263, 1),
(25264, 1),
(25265, 1),
(25266, 1),
(25267, 1),
(25268, 1),
(25269, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(25270, 1),
(25271, 1),
(25272, 1),
(25273, 1),
(25274, 1),
(25275, 1),
(25276, 1),
(25277, 1),
(25278, 1),
(25279, 1),
(25280, 1),
(25281, 1),
(25282, 1),
(25283, 1),
(25284, 1),
(25285, 1),
(25286, 1),
(25287, 1),
(25288, 1),
(25289, 1),
(25290, 1),
(25291, 1),
(25292, 1),
(25293, 1),
(25294, 1),
(25295, 1),
(25296, 1),
(25297, 1),
(25298, 1),
(25299, 1),
(25300, 1),
(25301, 1),
(25302, 1),
(25303, 1),
(25304, 1),
(25305, 1),
(25306, 1),
(25307, 1),
(25308, 1),
(25309, 1),
(25310, 1),
(25311, 1),
(25312, 1),
(25313, 1),
(25314, 1),
(25315, 1),
(25316, 1),
(25317, 1),
(25318, 1),
(25319, 1),
(25320, 1),
(25321, 1),
(25322, 1),
(25323, 1),
(25324, 1),
(25325, 1),
(25326, 1),
(25327, 1),
(25328, 1),
(25329, 1),
(25330, 1),
(25331, 1),
(25332, 1),
(25333, 1),
(25334, 1),
(25335, 1),
(25336, 1),
(25337, 1),
(25338, 1),
(25339, 1),
(25340, 1),
(25341, 1),
(25342, 1),
(25343, 1),
(25344, 1),
(25345, 1),
(25346, 1),
(25347, 1),
(25348, 1),
(25349, 1),
(25350, 1),
(25351, 1),
(25352, 1),
(25353, 1),
(25354, 1),
(25355, 1),
(25356, 1),
(25357, 1),
(25358, 1),
(25359, 1),
(25360, 1),
(25361, 1),
(25362, 1),
(25363, 1),
(25364, 1),
(25365, 1),
(25366, 1),
(25367, 1),
(25368, 1),
(25369, 1),
(25370, 1),
(25371, 1),
(25372, 1),
(25373, 1),
(25374, 1),
(25375, 1),
(25376, 1),
(25377, 1),
(25378, 1),
(25379, 1),
(25380, 1),
(25381, 1),
(25382, 1),
(25383, 1),
(25384, 1),
(25385, 1),
(25386, 1),
(25387, 1),
(25388, 1),
(25389, 1),
(25390, 1),
(25391, 1),
(25392, 1),
(25393, 1),
(25394, 1),
(25395, 1),
(25396, 1),
(25397, 1),
(25398, 1),
(25399, 1),
(25400, 1),
(25401, 1),
(25402, 1),
(25403, 1),
(25404, 1),
(25405, 1),
(25406, 1),
(25407, 1),
(25408, 1),
(25409, 1),
(25410, 1),
(25411, 1),
(25412, 1),
(25413, 1),
(25414, 1),
(25415, 1),
(25416, 1),
(25417, 1),
(25418, 1),
(25419, 1),
(25420, 1),
(25421, 1),
(25422, 1),
(25423, 1),
(25424, 1),
(25425, 1),
(25426, 1),
(25427, 1),
(25428, 1),
(25429, 1),
(25430, 1),
(25431, 1),
(25432, 1),
(25433, 1),
(25434, 1),
(25435, 1),
(25436, 1),
(25437, 1),
(25438, 1),
(25439, 1),
(25440, 1),
(25441, 1),
(25442, 1),
(25443, 1),
(25444, 1),
(25445, 1),
(25446, 1),
(25447, 1),
(25448, 1),
(25449, 1),
(25450, 1),
(25451, 1),
(25452, 1),
(25453, 1),
(25454, 1),
(25455, 1),
(25456, 1),
(25457, 1),
(25458, 1),
(25459, 1),
(25460, 1),
(25461, 1),
(25462, 1),
(25463, 1),
(25464, 1),
(25465, 1),
(25466, 1),
(25467, 1),
(25468, 1),
(25469, 1),
(25470, 1),
(25471, 1),
(25472, 1),
(25473, 1),
(25474, 1),
(25475, 1),
(25476, 1),
(25477, 1),
(25478, 1),
(25479, 1),
(25480, 1),
(25481, 1),
(25482, 1),
(25483, 1),
(25484, 1),
(25485, 1),
(25486, 1),
(25487, 1),
(25488, 1),
(25489, 1),
(25490, 1),
(25491, 1),
(25492, 1),
(25493, 1),
(25494, 1),
(25495, 1),
(25496, 1),
(25497, 1),
(25498, 1),
(25499, 1),
(25500, 1),
(25501, 1),
(25502, 1),
(25503, 1),
(25504, 1),
(25505, 1),
(25506, 1),
(25507, 1),
(25508, 1),
(25509, 1),
(25510, 1),
(25511, 1),
(25512, 1),
(25513, 1),
(25514, 1),
(25515, 1),
(25516, 1),
(25517, 1),
(25518, 1),
(25519, 1),
(25520, 1),
(25521, 1),
(25522, 1),
(25523, 1),
(25524, 1),
(25525, 1),
(25526, 1),
(25527, 1),
(25528, 1),
(25529, 1),
(25530, 1),
(25531, 1),
(25532, 1),
(25533, 1),
(25534, 1),
(25535, 1),
(25536, 1),
(25537, 1),
(25538, 1),
(25539, 1),
(25540, 1),
(25541, 1),
(25542, 1),
(25543, 1),
(25544, 1),
(25545, 1),
(25546, 1),
(25547, 1),
(25548, 1),
(25549, 1),
(25550, 1),
(25551, 1),
(25552, 1),
(25553, 1),
(25554, 1),
(25555, 1),
(25556, 1),
(25557, 1),
(25558, 1),
(25559, 1),
(25560, 1),
(25561, 1),
(25562, 1),
(25563, 1),
(25564, 1),
(25565, 1),
(25566, 1),
(25567, 1),
(25568, 1),
(25569, 1),
(25570, 1),
(25571, 1),
(25572, 1),
(25573, 1),
(25574, 1),
(25575, 1),
(25576, 1),
(25577, 1),
(25578, 1),
(25579, 1),
(25580, 1),
(25581, 1),
(25582, 1),
(25583, 1),
(25584, 1),
(25585, 1),
(25586, 1),
(25587, 1),
(25588, 1),
(25589, 1),
(25590, 1),
(25591, 1),
(25592, 1),
(25593, 1),
(25594, 1),
(25595, 1),
(25596, 1),
(25597, 1),
(25598, 1),
(25599, 1),
(25600, 1),
(25601, 1),
(25602, 1),
(25603, 1),
(25604, 1),
(25605, 1),
(25606, 1),
(25607, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(25608, 1),
(25609, 1),
(25610, 1),
(25611, 1),
(25612, 1),
(25613, 1),
(25614, 1),
(25615, 1),
(25616, 1),
(25617, 1),
(25618, 1),
(25619, 1),
(25620, 1),
(25621, 1),
(25622, 1),
(25623, 1),
(25624, 1),
(25625, 1),
(25626, 1),
(25627, 1),
(25628, 1),
(25629, 1),
(25630, 1),
(25631, 1),
(25632, 1),
(25633, 1),
(25634, 1),
(25635, 1),
(25636, 1),
(25637, 1),
(25638, 1),
(25639, 1),
(25640, 1),
(25641, 1),
(25642, 1),
(25643, 1),
(25644, 1),
(25645, 1),
(25646, 1),
(25647, 1),
(25648, 1),
(25649, 1),
(25650, 1),
(25651, 1),
(25652, 1),
(25653, 1),
(25654, 1),
(25655, 1),
(25656, 1),
(25657, 1),
(25658, 1),
(25659, 1),
(25660, 1),
(25661, 1),
(25662, 1),
(25663, 1),
(25664, 1),
(25665, 1),
(25666, 1),
(25667, 1),
(25668, 1),
(25669, 1),
(25670, 1),
(25671, 1),
(25672, 1),
(25673, 1),
(25674, 1),
(25675, 1),
(25676, 1),
(25677, 1),
(25678, 1),
(25679, 1),
(25680, 1),
(25681, 1),
(25682, 1),
(25683, 1),
(25684, 1),
(25685, 1),
(25686, 1),
(25687, 1),
(25688, 1),
(25689, 1),
(25690, 1),
(25691, 1),
(25692, 1),
(25693, 1),
(25694, 1),
(25695, 1),
(25696, 1),
(25697, 1),
(25698, 1),
(25699, 1),
(25700, 1),
(25701, 1),
(25702, 1),
(25703, 1),
(25704, 1),
(25705, 1),
(25706, 1),
(25707, 1),
(25708, 1),
(25709, 1),
(25710, 1),
(25711, 1),
(25712, 1),
(25713, 1),
(25714, 1),
(25715, 1),
(25716, 1),
(25717, 1),
(25718, 1),
(25719, 1),
(25720, 1),
(25721, 1),
(25722, 1),
(25723, 1),
(25724, 1),
(25725, 1),
(25726, 1),
(25727, 1),
(25728, 1),
(25729, 1),
(25730, 1),
(25731, 1),
(25732, 1),
(25733, 1),
(25734, 1),
(25735, 1),
(25736, 1),
(25737, 1),
(25738, 1),
(25739, 1),
(25740, 1),
(25741, 1),
(25742, 1),
(25743, 1),
(25744, 1),
(25745, 1),
(25746, 1),
(25747, 1),
(25748, 1),
(25749, 1),
(25750, 1),
(25751, 1),
(25752, 1),
(25753, 1),
(25754, 1),
(25755, 1),
(25756, 1),
(25757, 1),
(25758, 1),
(25759, 1),
(25760, 1),
(25761, 1),
(25762, 1),
(25763, 1),
(25764, 1),
(25765, 1),
(25766, 1),
(25767, 1),
(25768, 1),
(25769, 1),
(25770, 1),
(25771, 1),
(25772, 1),
(25773, 1),
(25774, 1),
(25775, 1),
(25776, 1),
(25777, 1),
(25778, 1),
(25779, 1),
(25780, 1),
(25781, 1),
(25782, 1),
(25783, 1),
(25784, 1),
(25785, 1),
(25786, 1),
(25787, 1),
(25788, 1),
(25789, 1),
(25790, 1),
(25791, 1),
(25792, 1),
(25793, 1),
(25794, 1),
(25795, 1),
(25796, 1),
(25797, 1),
(25798, 1),
(25799, 1),
(25800, 1),
(25801, 1),
(25802, 1),
(25803, 1),
(25804, 1),
(25805, 1),
(25806, 1),
(25807, 1),
(25808, 1),
(25809, 1),
(25810, 1),
(25811, 1),
(25812, 1),
(25813, 1),
(25814, 1),
(25815, 1),
(25816, 1),
(25817, 1),
(25818, 1),
(25819, 1),
(25820, 1),
(25821, 1),
(25822, 1),
(25823, 1),
(25824, 1),
(25825, 1),
(25826, 1),
(25827, 1),
(25828, 1),
(25829, 1),
(25830, 1),
(25831, 1),
(25832, 1),
(25833, 1),
(25834, 1),
(25835, 1),
(25836, 1),
(25837, 1),
(25838, 1),
(25839, 1),
(25840, 1),
(25841, 1),
(25842, 1),
(25843, 1),
(25844, 1),
(25845, 1),
(25846, 1),
(25847, 1),
(25848, 1),
(25849, 1),
(25850, 1),
(25851, 1),
(25852, 1),
(25853, 1),
(25854, 1),
(25855, 1),
(25856, 1),
(25857, 1),
(25858, 1),
(25859, 1),
(25860, 1),
(25861, 1),
(25862, 1),
(25863, 1),
(25864, 1),
(25865, 1),
(25866, 1),
(25867, 1),
(25868, 1),
(25869, 1),
(25870, 1),
(25871, 1),
(25872, 1),
(25873, 1),
(25874, 1),
(25875, 1),
(25876, 1),
(25877, 1),
(25878, 1),
(25879, 1),
(25880, 1),
(25881, 1),
(25882, 1),
(25883, 1),
(25884, 1),
(25885, 1),
(25886, 1),
(25887, 1),
(25888, 1),
(25889, 1),
(25890, 1),
(25891, 1),
(25892, 1),
(25893, 1),
(25894, 1),
(25895, 1),
(25896, 1),
(25897, 1),
(25898, 1),
(25899, 1),
(25900, 1),
(25901, 1),
(25902, 1),
(25903, 1),
(25904, 1),
(25905, 1),
(25906, 1),
(25907, 1),
(25908, 1),
(25909, 1),
(25910, 1),
(25911, 1),
(25912, 1),
(25913, 1),
(25914, 1),
(25915, 1),
(25916, 1),
(25917, 1),
(25918, 1),
(25919, 1),
(25920, 1),
(25921, 1),
(25922, 1),
(25923, 1),
(25924, 1),
(25925, 1),
(25926, 1),
(25927, 1),
(25928, 1),
(25929, 1),
(25930, 1),
(25931, 1),
(25932, 1),
(25933, 1),
(25934, 1),
(25935, 1),
(25936, 1),
(25937, 1),
(25938, 1),
(25939, 1),
(25940, 1),
(25941, 1),
(25942, 1),
(25943, 1),
(25944, 1),
(25945, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(25946, 1),
(25947, 1),
(25948, 1),
(25949, 1),
(25950, 1),
(25951, 1),
(25952, 1),
(25953, 1),
(25954, 1),
(25955, 1),
(25956, 1),
(25957, 1),
(25958, 1),
(25959, 1),
(25960, 1),
(25961, 1),
(25962, 1),
(25963, 1),
(25964, 1),
(25965, 1),
(25966, 1),
(25967, 1),
(25968, 1),
(25969, 1),
(25970, 1),
(25971, 1),
(25972, 1),
(25973, 1),
(25974, 1),
(25975, 1),
(25976, 1),
(25977, 1),
(25978, 1),
(25979, 1),
(25980, 1),
(25981, 1),
(25982, 1),
(25983, 1),
(25984, 1),
(25985, 1),
(25986, 1),
(25987, 1),
(25988, 1),
(25989, 1),
(25990, 1),
(25991, 1),
(25992, 1),
(25993, 1),
(25994, 1),
(25995, 1),
(25996, 1),
(25997, 1),
(25998, 1),
(25999, 1),
(26000, 1),
(26001, 1),
(26002, 1),
(26003, 1),
(26004, 1),
(26005, 1),
(26006, 1),
(26007, 1),
(26008, 1),
(26009, 1),
(26010, 1),
(26011, 1),
(26012, 1),
(26013, 1),
(26014, 1),
(26015, 1),
(26016, 1),
(26017, 1),
(26018, 1),
(26019, 1),
(26020, 1),
(26021, 1),
(26022, 1),
(26023, 1),
(26024, 1),
(26025, 1),
(26026, 1),
(26027, 1),
(26028, 1),
(26029, 1),
(26030, 1),
(26031, 1),
(26032, 1),
(26033, 1),
(26034, 1),
(26035, 1),
(26036, 1),
(26037, 1),
(26038, 1),
(26039, 1),
(26040, 1),
(26041, 1),
(26042, 1),
(26043, 1),
(26044, 1),
(26045, 1),
(26046, 1),
(26047, 1),
(26048, 1),
(26049, 1),
(26050, 1),
(26051, 1),
(26052, 1),
(26053, 1),
(26054, 1),
(26055, 1),
(26056, 1),
(26057, 1),
(26058, 1),
(26059, 1),
(26060, 1),
(26061, 1),
(26062, 1),
(26063, 1),
(26064, 1),
(26065, 1),
(26066, 1),
(26067, 1),
(26068, 1),
(26069, 1),
(26070, 1),
(26071, 1),
(26072, 1),
(26073, 1),
(26074, 1),
(26075, 1),
(26076, 1),
(26077, 1),
(26078, 1),
(26079, 1),
(26080, 1),
(26081, 1),
(26082, 1),
(26083, 1),
(26084, 1),
(26085, 1),
(26086, 1),
(26087, 1),
(26088, 1),
(26089, 1),
(26090, 1),
(26091, 1),
(26092, 1),
(26093, 1),
(26094, 1),
(26095, 1),
(26096, 1),
(26097, 1),
(26098, 1),
(26099, 1),
(26100, 1),
(26101, 1),
(26102, 1),
(26103, 1),
(26104, 1),
(26105, 1),
(26106, 1),
(26107, 1),
(26108, 1),
(26109, 1),
(26110, 1),
(26111, 1),
(26112, 1),
(26113, 1),
(26114, 1),
(26115, 1),
(26116, 1),
(26117, 1),
(26118, 1),
(26119, 1),
(26120, 1),
(26121, 1),
(26122, 1),
(26123, 1),
(26124, 1),
(26125, 1),
(26126, 1),
(26127, 1),
(26128, 1),
(26129, 1),
(26130, 1),
(26131, 1),
(26132, 1),
(26133, 1),
(26134, 1),
(26135, 1),
(26136, 1),
(26137, 1),
(26138, 1),
(26139, 1),
(26140, 1),
(26141, 1),
(26142, 1),
(26143, 1),
(26144, 1),
(26145, 1),
(26146, 1),
(26147, 1),
(26148, 1),
(26149, 1),
(26150, 1),
(26151, 1),
(26152, 1),
(26153, 1),
(26154, 1),
(26155, 1),
(26156, 1),
(26157, 1),
(26158, 1),
(26159, 1),
(26160, 1),
(26161, 1),
(26162, 1),
(26163, 1),
(26164, 1),
(26165, 1),
(26166, 1),
(26167, 1),
(26168, 1),
(26169, 1),
(26170, 1),
(26171, 1),
(26172, 1),
(26173, 1),
(26174, 1),
(26175, 1),
(26176, 1),
(26177, 1),
(26178, 1),
(26179, 1),
(26180, 1),
(26181, 1),
(26182, 1),
(26183, 1),
(26184, 1),
(26185, 1),
(26186, 1),
(26187, 1),
(26188, 1),
(26189, 1),
(26190, 1),
(26191, 1),
(26192, 1),
(26193, 1),
(26194, 1),
(26195, 1),
(26196, 1),
(26197, 1),
(26198, 1),
(26199, 1),
(26200, 1),
(26201, 1),
(26202, 1),
(26203, 1),
(26204, 1),
(26205, 1),
(26206, 1),
(26207, 1),
(26208, 1),
(26209, 1),
(26210, 1),
(26211, 1),
(26212, 1),
(26213, 1),
(26214, 1),
(26215, 1),
(26216, 1),
(26217, 1),
(26218, 1),
(26219, 1),
(26220, 1),
(26221, 1),
(26222, 1),
(26223, 1),
(26224, 1),
(26225, 1),
(26226, 1),
(26227, 1),
(26228, 1),
(26229, 1),
(26230, 1),
(26231, 1),
(26232, 1),
(26233, 1),
(26234, 1),
(26235, 1),
(26236, 1),
(26237, 1),
(26238, 1),
(26239, 1),
(26240, 1),
(26241, 1),
(26242, 1),
(26243, 1),
(26244, 1),
(26245, 1),
(26246, 1),
(26247, 1),
(26248, 1),
(26249, 1),
(26250, 1),
(26251, 1),
(26252, 1),
(26253, 1),
(26254, 1),
(26255, 1),
(26256, 1),
(26257, 1),
(26258, 1),
(26259, 1),
(26260, 1),
(26261, 1),
(26262, 1),
(26263, 1),
(26264, 1),
(26265, 1),
(26266, 1),
(26267, 1),
(26268, 1),
(26269, 1),
(26270, 1),
(26271, 1),
(26272, 1),
(26273, 1),
(26274, 1),
(26275, 1),
(26276, 1),
(26277, 1),
(26278, 1),
(26279, 1),
(26280, 1),
(26281, 1),
(26282, 1),
(26283, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(26284, 1),
(26285, 1),
(26286, 1),
(26287, 1),
(26288, 1),
(26289, 1),
(26290, 1),
(26291, 1),
(26292, 1),
(26293, 1),
(26294, 1),
(26295, 1),
(26296, 1),
(26297, 1),
(26298, 1),
(26299, 1),
(26300, 1),
(26301, 1),
(26302, 1),
(26303, 1),
(26304, 1),
(26305, 1),
(26306, 1),
(26307, 1),
(26308, 1),
(26309, 1),
(26310, 1),
(26311, 1),
(26312, 1),
(26313, 1),
(26314, 1),
(26315, 1),
(26316, 1),
(26317, 1),
(26318, 1),
(26319, 1),
(26320, 1),
(26321, 1),
(26322, 1),
(26323, 1),
(26324, 1),
(26325, 1),
(26326, 1),
(26327, 1),
(26328, 1),
(26329, 1),
(26330, 1),
(26331, 1),
(26332, 1),
(26333, 1),
(26334, 1),
(26335, 1),
(26336, 1),
(26337, 1),
(26338, 1),
(26339, 1),
(26340, 1),
(26341, 1),
(26342, 1),
(26343, 1),
(26344, 1),
(26345, 1),
(26346, 1),
(26347, 1),
(26348, 1),
(26349, 1),
(26350, 1),
(26351, 1),
(26352, 1),
(26353, 1),
(26354, 1),
(26355, 1),
(26356, 1),
(26357, 1),
(26358, 1),
(26359, 1),
(26360, 1),
(26361, 1),
(26362, 1),
(26363, 1),
(26364, 1),
(26365, 1),
(26366, 1),
(26367, 1),
(26368, 1),
(26369, 1),
(26370, 1),
(26371, 1),
(26372, 1),
(26373, 1),
(26374, 1),
(26375, 1),
(26376, 1),
(26377, 1),
(26378, 1),
(26379, 1),
(26380, 1),
(26381, 1),
(26382, 1),
(26383, 1),
(26384, 1),
(26385, 1),
(26386, 1),
(26387, 1),
(26388, 1),
(26389, 1),
(26390, 1),
(26391, 1),
(26392, 1),
(26393, 1),
(26394, 1),
(26395, 1),
(26396, 1),
(26397, 1),
(26398, 1),
(26399, 1),
(26400, 1),
(26401, 1),
(26402, 1),
(26403, 1),
(26404, 1),
(26405, 1),
(26406, 1),
(26407, 1),
(26408, 1),
(26409, 1),
(26410, 1),
(26411, 1),
(26412, 1),
(26413, 1),
(26414, 1),
(26415, 1),
(26416, 1),
(26417, 1),
(26418, 1),
(26419, 1),
(26420, 1),
(26421, 1),
(26422, 1),
(26423, 1),
(26424, 1),
(26425, 1),
(26426, 1),
(26427, 1),
(26428, 1),
(26429, 1),
(26430, 1),
(26431, 1),
(26432, 1),
(26433, 1),
(26434, 1),
(26435, 1),
(26436, 1),
(26437, 1),
(26438, 1),
(26439, 1),
(26440, 1),
(26441, 1),
(26442, 1),
(26443, 1),
(26444, 1),
(26445, 1),
(26446, 1),
(26447, 1),
(26448, 1),
(26449, 1),
(26450, 1),
(26451, 1),
(26452, 1),
(26453, 1),
(26454, 1),
(26455, 1),
(26456, 1),
(26457, 1),
(26458, 1),
(26459, 1),
(26460, 1),
(26461, 1),
(26462, 1),
(26463, 1),
(26464, 1),
(26465, 1),
(26466, 1),
(26467, 1),
(26468, 1),
(26469, 1),
(26470, 1),
(26471, 1),
(26472, 1),
(26473, 1),
(26474, 1),
(26475, 1),
(26476, 1),
(26477, 1),
(26478, 1),
(26479, 1),
(26480, 1),
(26481, 1),
(26482, 1),
(26483, 1),
(26484, 1),
(26485, 1),
(26486, 1),
(26487, 1),
(26488, 1),
(26489, 1),
(26490, 1),
(26491, 1),
(26492, 1),
(26493, 1),
(26494, 1),
(26495, 1),
(26496, 1),
(26497, 1),
(26498, 1),
(26499, 1),
(26500, 1),
(26501, 1),
(26502, 1),
(26503, 1),
(26504, 1),
(26505, 1),
(26506, 1),
(26507, 1),
(26508, 1),
(26509, 1),
(26510, 1),
(26511, 1),
(26512, 1),
(26513, 1),
(26514, 1),
(26515, 1),
(26516, 1),
(26517, 1),
(26518, 1),
(26519, 1),
(26520, 1),
(26521, 1),
(26522, 1),
(26523, 1),
(26524, 1),
(26525, 1),
(26526, 1),
(26527, 1),
(26528, 1),
(26529, 1),
(26530, 1),
(26531, 1),
(26532, 1),
(26533, 1),
(26534, 1),
(26535, 1),
(26536, 1),
(26537, 1),
(26538, 1),
(26539, 1),
(26540, 1),
(26541, 1),
(26542, 1),
(26543, 1),
(26544, 1),
(26545, 1),
(26546, 1),
(26547, 1),
(26548, 1),
(26549, 1),
(26550, 1),
(26551, 1),
(26552, 1),
(26553, 1),
(26554, 1),
(26555, 1),
(26556, 1),
(26557, 1),
(26558, 1),
(26559, 1),
(26560, 1),
(26561, 1),
(26562, 1),
(26563, 1),
(26564, 1),
(26565, 1),
(26566, 1),
(26567, 1),
(26568, 1),
(26569, 1),
(26570, 1),
(26571, 1),
(26572, 1),
(26573, 1),
(26574, 1),
(26575, 1),
(26576, 1),
(26577, 1),
(26578, 1),
(26579, 1),
(26580, 1),
(26581, 1),
(26582, 1),
(26583, 1),
(26584, 1),
(26585, 1),
(26586, 1),
(26587, 1),
(26588, 1),
(26589, 1),
(26590, 1),
(26591, 1),
(26592, 1),
(26593, 1),
(26594, 1),
(26595, 1),
(26596, 1),
(26597, 1),
(26598, 1),
(26599, 1),
(26600, 1),
(26601, 1),
(26602, 1),
(26603, 1),
(26604, 1),
(26605, 1),
(26606, 1),
(26607, 1),
(26608, 1),
(26609, 1),
(26610, 1),
(26611, 1),
(26612, 1),
(26613, 1),
(26614, 1),
(26615, 1),
(26616, 1),
(26617, 1),
(26618, 1),
(26619, 1),
(26620, 1),
(26621, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(26622, 1),
(26623, 1),
(26624, 1),
(26625, 1),
(26626, 1),
(26627, 1),
(26628, 1),
(26629, 1),
(26630, 1),
(26631, 1),
(26632, 1),
(26633, 1),
(26634, 1),
(26635, 1),
(26636, 1),
(26637, 1),
(26638, 1),
(26639, 1),
(26640, 1),
(26641, 1),
(26642, 1),
(26643, 1),
(26644, 1),
(26645, 1),
(26646, 1),
(26647, 1),
(26648, 1),
(26649, 1),
(26650, 1),
(26651, 1),
(26652, 1),
(26653, 1),
(26654, 1),
(26655, 1),
(26656, 1),
(26657, 1),
(26658, 1),
(26659, 1),
(26660, 1),
(26661, 1),
(26662, 1),
(26663, 1),
(26664, 1),
(26665, 1),
(26666, 1),
(26667, 1),
(26668, 1),
(26669, 1),
(26670, 1),
(26671, 1),
(26672, 1),
(26673, 1),
(26674, 1),
(26675, 1),
(26676, 1),
(26677, 1),
(26678, 1),
(26679, 1),
(26680, 1),
(26681, 1),
(26682, 1),
(26683, 1),
(26684, 1),
(26685, 1),
(26686, 1),
(26687, 1),
(26688, 1),
(26689, 1),
(26690, 1),
(26691, 1),
(26692, 1),
(26693, 1),
(26694, 1),
(26695, 1),
(26696, 1),
(26697, 1),
(26698, 1),
(26699, 1),
(26700, 1),
(26701, 1),
(26702, 1),
(26703, 1),
(26704, 1),
(26705, 1),
(26706, 1),
(26707, 1),
(26708, 1),
(26709, 1),
(26710, 1),
(26711, 1),
(26712, 1),
(26713, 1),
(26714, 1),
(26715, 1),
(26716, 1),
(26717, 1),
(26718, 1),
(26719, 1),
(26720, 1),
(26721, 1),
(26722, 1),
(26723, 1),
(26724, 1),
(26725, 1),
(26726, 1),
(26727, 1),
(26728, 1),
(26729, 1),
(26730, 1),
(26731, 1),
(26732, 1),
(26733, 1),
(26734, 1),
(26735, 1),
(26736, 1),
(26737, 1),
(26738, 1),
(26739, 1),
(26740, 1),
(26741, 1),
(26742, 1),
(26743, 1),
(26744, 1),
(26745, 1),
(26746, 1),
(26747, 1),
(26748, 1),
(26749, 1),
(26750, 1),
(26751, 1),
(26752, 1),
(26753, 1),
(26754, 1),
(26755, 1),
(26756, 1),
(26757, 1),
(26758, 1),
(26759, 1),
(26760, 1),
(26761, 1),
(26762, 1),
(26763, 1),
(26764, 1),
(26765, 1),
(26766, 1),
(26767, 1),
(26768, 1),
(26769, 1),
(26770, 1),
(26771, 1),
(26772, 1),
(26773, 1),
(26774, 1),
(26775, 1),
(26776, 1),
(26777, 1),
(26778, 1),
(26779, 1),
(26780, 1),
(26781, 1),
(26782, 1),
(26783, 1),
(26784, 1),
(26785, 1),
(26786, 1),
(26787, 1),
(26788, 1),
(26789, 1),
(26790, 1),
(26791, 1),
(26792, 1),
(26793, 1),
(26794, 1),
(26795, 1),
(26796, 1),
(26797, 1),
(26798, 1),
(26799, 1),
(26800, 1),
(26801, 1),
(26802, 1),
(26803, 1),
(26804, 1),
(26805, 1),
(26806, 1),
(26807, 1),
(26808, 1),
(26809, 1),
(26810, 1),
(26811, 1),
(26812, 1),
(26813, 1),
(26814, 1),
(26815, 1),
(26816, 1),
(26817, 1),
(26818, 1),
(26819, 1),
(26820, 1),
(26821, 1),
(26822, 1),
(26823, 1),
(26824, 1),
(26825, 1),
(26826, 1),
(26827, 1),
(26828, 1),
(26829, 1),
(26830, 1),
(26831, 1),
(26832, 1),
(26833, 1),
(26834, 1),
(26835, 1),
(26836, 1),
(26837, 1),
(26838, 1),
(26839, 1),
(26840, 1),
(26841, 1),
(26842, 1),
(26843, 1),
(26844, 1),
(26845, 1),
(26846, 1),
(26847, 1),
(26848, 1),
(26849, 1),
(26850, 1),
(26851, 1),
(26852, 1),
(26853, 1),
(26854, 1),
(26855, 1),
(26856, 1),
(26857, 1),
(26858, 1),
(26859, 1),
(26860, 1),
(26861, 1),
(26862, 1),
(26863, 1),
(26864, 1),
(26865, 1),
(26866, 1),
(26867, 1),
(26868, 1),
(26869, 1),
(26870, 1),
(26871, 1),
(26872, 1),
(26873, 1),
(26874, 1),
(26875, 1),
(26876, 1),
(26877, 1),
(26878, 1),
(26879, 1),
(26880, 1),
(26881, 1),
(26882, 1),
(26883, 1),
(26884, 1),
(26885, 1),
(26886, 1),
(26887, 1),
(26888, 1),
(26889, 1),
(26890, 1),
(26891, 1),
(26892, 1),
(26893, 1),
(26894, 1),
(26895, 1),
(26896, 1),
(26897, 1),
(26898, 1),
(26899, 1),
(26900, 1),
(26901, 1),
(26902, 1),
(26903, 1),
(26904, 1),
(26905, 1),
(26906, 1),
(26907, 1),
(26908, 1),
(26909, 1),
(26910, 1),
(26911, 1),
(26912, 1),
(26913, 1),
(26914, 1),
(26915, 1),
(26916, 1),
(26917, 1),
(26918, 1),
(26919, 1),
(26920, 1),
(26921, 1),
(26922, 1),
(26923, 1),
(26924, 1),
(26925, 1),
(26926, 1),
(26927, 1),
(26928, 1),
(26929, 1),
(26930, 1),
(26931, 1),
(26932, 1),
(26933, 1),
(26934, 1),
(26935, 1),
(26936, 1),
(26937, 1),
(26938, 1),
(26939, 1),
(26940, 1),
(26941, 1),
(26942, 1),
(26943, 1),
(26944, 1),
(26945, 1),
(26946, 1),
(26947, 1),
(26948, 1),
(26949, 1),
(26950, 1),
(26951, 1),
(26952, 1),
(26953, 1),
(26954, 1),
(26955, 1),
(26956, 1),
(26957, 1),
(26958, 1),
(26959, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(26960, 1),
(26961, 1),
(26962, 1),
(26963, 1),
(26964, 1),
(26965, 1),
(26966, 1),
(26967, 1),
(26968, 1),
(26969, 1),
(26970, 1),
(26971, 1),
(26972, 1),
(26973, 1),
(26974, 1),
(26975, 1),
(26976, 1),
(26977, 1),
(26978, 1),
(26979, 1),
(26980, 1),
(26981, 1),
(26982, 1),
(26983, 1),
(26984, 1),
(26985, 1),
(26986, 1),
(26987, 1),
(26988, 1),
(26989, 1),
(26990, 1),
(26991, 1),
(26992, 1),
(26993, 1),
(26994, 1),
(26995, 1),
(26996, 1),
(26997, 1),
(26998, 1),
(26999, 1),
(27000, 1),
(27001, 1),
(27002, 1),
(27003, 1),
(27004, 1),
(27005, 1),
(27006, 1),
(27007, 1),
(27008, 1),
(27009, 1),
(27010, 1),
(27011, 1),
(27012, 1),
(27013, 1),
(27014, 1),
(27015, 1),
(27016, 1),
(27017, 1),
(27018, 1),
(27019, 1),
(27020, 1),
(27021, 1),
(27022, 1),
(27023, 1),
(27024, 1),
(27025, 1),
(27026, 1),
(27027, 1),
(27028, 1),
(27029, 1),
(27030, 1),
(27031, 1),
(27032, 1),
(27033, 1),
(27034, 1),
(27035, 1),
(27036, 1),
(27037, 1),
(27038, 1),
(27039, 1),
(27040, 1),
(27041, 1),
(27042, 1),
(27043, 1),
(27044, 1),
(27045, 1),
(27046, 1),
(27047, 1),
(27048, 1),
(27049, 1),
(27050, 1),
(27051, 1),
(27052, 1),
(27053, 1),
(27054, 1),
(27055, 1),
(27056, 1),
(27057, 1),
(27058, 1),
(27059, 1),
(27060, 1),
(27061, 1),
(27062, 1),
(27063, 1),
(27064, 1),
(27065, 1),
(27066, 1),
(27067, 1),
(27068, 1),
(27069, 1),
(27070, 1),
(27071, 1),
(27072, 1),
(27073, 1),
(27074, 1),
(27075, 1),
(27076, 1),
(27077, 1),
(27078, 1),
(27079, 1),
(27080, 1),
(27081, 1),
(27082, 1),
(27083, 1),
(27084, 1),
(27085, 1),
(27086, 1),
(27087, 1),
(27088, 1),
(27089, 1),
(27090, 1),
(27091, 1),
(27092, 1),
(27093, 1),
(27094, 1),
(27095, 1),
(27096, 1),
(27097, 1),
(27098, 1),
(27099, 1),
(27100, 1),
(27101, 1),
(27102, 1),
(27103, 1),
(27104, 1),
(27105, 1),
(27106, 1),
(27107, 1),
(27108, 1),
(27109, 1),
(27110, 1),
(27111, 1),
(27112, 1),
(27113, 1),
(27114, 1),
(27115, 1),
(27116, 1),
(27117, 1),
(27118, 1),
(27119, 1),
(27120, 1),
(27121, 1),
(27122, 1),
(27123, 1),
(27124, 1),
(27125, 1),
(27126, 1),
(27127, 1),
(27128, 1),
(27129, 1),
(27130, 1),
(27131, 1),
(27132, 1),
(27133, 1),
(27134, 1),
(27135, 1),
(27136, 1),
(27137, 1),
(27138, 1),
(27139, 1),
(27140, 1),
(27141, 1),
(27142, 1),
(27143, 1),
(27144, 1),
(27145, 1),
(27146, 1),
(27147, 1),
(27148, 1),
(27149, 1),
(27150, 1),
(27151, 1),
(27152, 1),
(27153, 1),
(27154, 1),
(27155, 1),
(27156, 1),
(27157, 1),
(27158, 1),
(27159, 1),
(27160, 1),
(27161, 1),
(27162, 1),
(27163, 1),
(27164, 1),
(27165, 1),
(27166, 1),
(27167, 1),
(27168, 1),
(27169, 1),
(27170, 1),
(27171, 1),
(27172, 1),
(27173, 1),
(27174, 1),
(27175, 1),
(27176, 1),
(27177, 1),
(27178, 1),
(27179, 1),
(27180, 1),
(27181, 1),
(27182, 1),
(27183, 1),
(27184, 1),
(27185, 1),
(27186, 1),
(27187, 1),
(27188, 1),
(27189, 1),
(27190, 1),
(27191, 1),
(27192, 1),
(27193, 1),
(27194, 1),
(27195, 1),
(27196, 1),
(27197, 1),
(27198, 1),
(27199, 1),
(27200, 1),
(27201, 1),
(27202, 1),
(27203, 1),
(27204, 1),
(27205, 1),
(27206, 1),
(27207, 1),
(27208, 1),
(27209, 1),
(27210, 1),
(27211, 1),
(27212, 1),
(27213, 1),
(27214, 1),
(27215, 1),
(27216, 1),
(27217, 1),
(27218, 1),
(27219, 1),
(27220, 1),
(27221, 1),
(27222, 1),
(27223, 1),
(27224, 1),
(27225, 1),
(27226, 1),
(27227, 1),
(27228, 1),
(27229, 1),
(27230, 1),
(27231, 1),
(27232, 1),
(27233, 1),
(27234, 1),
(27235, 1),
(27236, 1),
(27237, 1),
(27238, 1),
(27239, 1),
(27240, 1),
(27241, 1),
(27242, 1),
(27243, 1),
(27244, 1),
(27245, 1),
(27246, 1),
(27247, 1),
(27248, 1),
(27249, 1),
(27250, 1),
(27251, 1),
(27252, 1),
(27253, 1),
(27254, 1),
(27255, 1),
(27256, 1),
(27257, 1),
(27258, 1),
(27259, 1),
(27260, 1),
(27261, 1),
(27262, 1),
(27263, 1),
(27264, 1),
(27265, 1),
(27266, 1),
(27267, 1),
(27268, 1),
(27269, 1),
(27270, 1),
(27271, 1),
(27272, 1),
(27273, 1),
(27274, 1),
(27275, 1),
(27276, 1),
(27277, 1),
(27278, 1),
(27279, 1),
(27280, 1),
(27281, 1),
(27282, 1),
(27283, 1),
(27284, 1),
(27285, 1),
(27286, 1),
(27287, 1),
(27288, 1),
(27289, 1),
(27290, 1),
(27291, 1),
(27292, 1),
(27293, 1),
(27294, 1),
(27295, 1),
(27296, 1),
(27297, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(27298, 1),
(27299, 1),
(27300, 1),
(27301, 1),
(27302, 1),
(27303, 1),
(27304, 1),
(27305, 1),
(27306, 1),
(27307, 1),
(27308, 1),
(27309, 1),
(27310, 1),
(27311, 1),
(27312, 1),
(27313, 1),
(27314, 1),
(27315, 1),
(27316, 1),
(27317, 1),
(27318, 1),
(27319, 1),
(27320, 1),
(27321, 1),
(27322, 1),
(27323, 1),
(27324, 1),
(27325, 1),
(27326, 1),
(27327, 1),
(27328, 1),
(27329, 1),
(27330, 1),
(27331, 1),
(27332, 1),
(27333, 1),
(27334, 1),
(27335, 1),
(27336, 1),
(27337, 1),
(27338, 1),
(27339, 1),
(27340, 1),
(27341, 1),
(27342, 1),
(27343, 1),
(27344, 1),
(27345, 1),
(27346, 1),
(27347, 1),
(27348, 1),
(27349, 1),
(27350, 1),
(27351, 1),
(27352, 1),
(27353, 1),
(27354, 1),
(27355, 1),
(27356, 1),
(27357, 1),
(27358, 1),
(27359, 1),
(27360, 1),
(27361, 1),
(27362, 1),
(27363, 1),
(27364, 1),
(27365, 1),
(27366, 1),
(27367, 1),
(27368, 1),
(27369, 1),
(27370, 1),
(27371, 1),
(27372, 1),
(27373, 1),
(27374, 1),
(27375, 1),
(27376, 1),
(27377, 1),
(27378, 1),
(27379, 1),
(27380, 1),
(27381, 1),
(27382, 1),
(27383, 1),
(27384, 1),
(27385, 1),
(27386, 1),
(27387, 1),
(27388, 1),
(27389, 1),
(27390, 1),
(27391, 1),
(27392, 1),
(27393, 1),
(27394, 1),
(27395, 1),
(27396, 1),
(27397, 1),
(27398, 1),
(27399, 1),
(27400, 1),
(27401, 1),
(27402, 1),
(27403, 1),
(27404, 1),
(27405, 1),
(27406, 1),
(27407, 1),
(27408, 1),
(27409, 1),
(27410, 1),
(27411, 1),
(27412, 1),
(27413, 1),
(27414, 1),
(27415, 1),
(27416, 1),
(27417, 1),
(27418, 1),
(27419, 1),
(27420, 1),
(27421, 1),
(27422, 1),
(27423, 1),
(27424, 1),
(27425, 1),
(27426, 1),
(27427, 1),
(27428, 1),
(27429, 1),
(27430, 1),
(27431, 1),
(27432, 1),
(27433, 1),
(27434, 1),
(27435, 1),
(27436, 1),
(27437, 1),
(27438, 1),
(27439, 1),
(27440, 1),
(27441, 1),
(27442, 1),
(27443, 1),
(27444, 1),
(27445, 1),
(27446, 1),
(27447, 1),
(27448, 1),
(27449, 1),
(27450, 1),
(27451, 1),
(27452, 1),
(27453, 1),
(27454, 1),
(27455, 1),
(27456, 1),
(27457, 1),
(27458, 1),
(27459, 1),
(27460, 1),
(27461, 1),
(27462, 1),
(27463, 1),
(27464, 1),
(27465, 1),
(27466, 1),
(27467, 1),
(27468, 1),
(27469, 1),
(27470, 1),
(27471, 1),
(27472, 1),
(27473, 1),
(27474, 1),
(27475, 1),
(27476, 1),
(27477, 1),
(27478, 1),
(27479, 1),
(27480, 1),
(27481, 1),
(27482, 1),
(27483, 1),
(27484, 1),
(27485, 1),
(27486, 1),
(27487, 1),
(27488, 1),
(27489, 1),
(27490, 1),
(27491, 1),
(27492, 1),
(27493, 1),
(27494, 1),
(27495, 1),
(27496, 1),
(27497, 1),
(27498, 1),
(27499, 1),
(27500, 1),
(27501, 1),
(27502, 1),
(27503, 1),
(27504, 1),
(27505, 1),
(27506, 1),
(27507, 1),
(27508, 1),
(27509, 1),
(27510, 1),
(27511, 1),
(27512, 1),
(27513, 1),
(27514, 1),
(27515, 1),
(27516, 1),
(27517, 1),
(27518, 1),
(27519, 1),
(27520, 1),
(27521, 1),
(27522, 1),
(27523, 1),
(27524, 1),
(27525, 1),
(27526, 1),
(27527, 1),
(27528, 1),
(27529, 1),
(27530, 1),
(27531, 1),
(27532, 1),
(27533, 1),
(27534, 1),
(27535, 1),
(27536, 1),
(27537, 1),
(27538, 1),
(27539, 1),
(27540, 1),
(27541, 1),
(27542, 1),
(27543, 1),
(27544, 1),
(27545, 1),
(27546, 1),
(27547, 1),
(27548, 1),
(27549, 1),
(27550, 1),
(27551, 1),
(27552, 1),
(27553, 1),
(27554, 1),
(27555, 1),
(27556, 1),
(27557, 1),
(27558, 1),
(27559, 1),
(27560, 1),
(27561, 1),
(27562, 1),
(27563, 1),
(27564, 1),
(27565, 1),
(27566, 1),
(27567, 1),
(27568, 1),
(27569, 1),
(27570, 1),
(27571, 1),
(27572, 1),
(27573, 1),
(27574, 1),
(27575, 1),
(27576, 1),
(27577, 1),
(27578, 1),
(27579, 1),
(27580, 1),
(27581, 1),
(27582, 1),
(27583, 1),
(27584, 1),
(27585, 1),
(27586, 1),
(27587, 1),
(27588, 1),
(27589, 1),
(27590, 1),
(27591, 1),
(27592, 1),
(27593, 1),
(27594, 1),
(27595, 1),
(27596, 1),
(27597, 1),
(27598, 1),
(27599, 1),
(27600, 1),
(27601, 1),
(27602, 1),
(27603, 1),
(27604, 1),
(27605, 1),
(27606, 1),
(27607, 1),
(27608, 1),
(27609, 1),
(27610, 1),
(27611, 1),
(27612, 1),
(27613, 1),
(27614, 1),
(27615, 1),
(27616, 1),
(27617, 1),
(27618, 1),
(27619, 1),
(27620, 1),
(27621, 1),
(27622, 1),
(27623, 1),
(27624, 1),
(27625, 1),
(27626, 1),
(27627, 1),
(27628, 1),
(27629, 1),
(27630, 1),
(27631, 1),
(27632, 1),
(27633, 1),
(27634, 1),
(27635, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(27636, 1),
(27637, 1),
(27638, 1),
(27639, 1),
(27640, 1),
(27641, 1),
(27642, 1),
(27643, 1),
(27644, 1),
(27645, 1),
(27646, 1),
(27647, 1),
(27648, 1),
(27649, 1),
(27650, 1),
(27651, 1),
(27652, 1),
(27653, 1),
(27654, 1),
(27655, 1),
(27656, 1),
(27657, 1),
(27658, 1),
(27659, 1),
(27660, 1),
(27661, 1),
(27662, 1),
(27663, 1),
(27664, 1),
(27665, 1),
(27666, 1),
(27667, 1),
(27668, 1),
(27669, 1),
(27670, 1),
(27671, 1),
(27672, 1),
(27673, 1),
(27674, 1),
(27675, 1),
(27676, 1),
(27677, 1),
(27678, 1),
(27679, 1),
(27680, 1),
(27681, 1),
(27682, 1),
(27683, 1),
(27684, 1),
(27685, 1),
(27686, 1),
(27687, 1),
(27688, 1),
(27689, 1),
(27690, 1),
(27691, 1),
(27692, 1),
(27693, 1),
(27694, 1),
(27695, 1),
(27696, 1),
(27697, 1),
(27698, 1),
(27699, 1),
(27700, 1),
(27701, 1),
(27702, 1),
(27703, 1),
(27704, 1),
(27705, 1),
(27706, 1),
(27707, 1),
(27708, 1),
(27709, 1),
(27710, 1),
(27711, 1),
(27712, 1),
(27713, 1),
(27714, 1),
(27715, 1),
(27716, 1),
(27717, 1),
(27718, 1),
(27719, 1),
(27720, 1),
(27721, 1),
(27722, 1),
(27723, 1),
(27724, 1),
(27725, 1),
(27726, 1),
(27727, 1),
(27728, 1),
(27729, 1),
(27730, 1),
(27731, 1),
(27732, 1),
(27733, 1),
(27734, 1),
(27735, 1),
(27736, 1),
(27737, 1),
(27738, 1),
(27739, 1),
(27740, 1),
(27741, 1),
(27742, 1),
(27743, 1),
(27744, 1),
(27745, 1),
(27746, 1),
(27747, 1),
(27748, 1),
(27749, 1),
(27750, 1),
(27751, 1),
(27752, 1),
(27753, 1),
(27754, 1),
(27755, 1),
(27756, 1),
(27757, 1),
(27758, 1),
(27759, 1),
(27760, 1),
(27761, 1),
(27762, 1),
(27763, 1),
(27764, 1),
(27765, 1),
(27766, 1),
(27767, 1),
(27768, 1),
(27769, 1),
(27770, 1),
(27771, 1),
(27772, 1),
(27773, 1),
(27774, 1),
(27775, 1),
(27776, 1),
(27777, 1),
(27778, 1),
(27779, 1),
(27780, 1),
(27781, 1),
(27782, 1),
(27783, 1),
(27784, 1),
(27785, 1),
(27786, 1),
(27787, 1),
(27788, 1),
(27789, 1),
(27790, 1),
(27791, 1),
(27792, 1),
(27793, 1),
(27794, 1),
(27795, 1),
(27796, 1),
(27797, 1),
(27798, 1),
(27799, 1),
(27800, 1),
(27801, 1),
(27802, 1),
(27803, 1),
(27804, 1),
(27805, 1),
(27806, 1),
(27807, 1),
(27808, 1),
(27809, 1),
(27810, 1),
(27811, 1),
(27812, 1),
(27813, 1),
(27814, 1),
(27815, 1),
(27816, 1),
(27817, 1),
(27818, 1),
(27819, 1),
(27820, 1),
(27821, 1),
(27822, 1),
(27823, 1),
(27824, 1),
(27825, 1),
(27826, 1),
(27827, 1),
(27828, 1),
(27829, 1),
(27830, 1),
(27831, 1),
(27832, 1),
(27833, 1),
(27834, 1),
(27835, 1),
(27836, 1),
(27837, 1),
(27838, 1),
(27839, 1),
(27840, 1),
(27841, 1),
(27842, 1),
(27843, 1),
(27844, 1),
(27845, 1),
(27846, 1),
(27847, 1),
(27848, 1),
(27849, 1),
(27850, 1),
(27851, 1),
(27852, 1),
(27853, 1),
(27854, 1),
(27855, 1),
(27856, 1),
(27857, 1),
(27858, 1),
(27859, 1),
(27860, 1),
(27861, 1),
(27862, 1),
(27863, 1),
(27864, 1),
(27865, 1),
(27866, 1),
(27867, 1),
(27868, 1),
(27869, 1),
(27870, 1),
(27871, 1),
(27872, 1),
(27873, 1),
(27874, 1),
(27875, 1),
(27876, 1),
(27877, 1),
(27878, 1),
(27879, 1),
(27880, 1),
(27881, 1),
(27882, 1),
(27883, 1),
(27884, 1),
(27885, 1),
(27886, 1),
(27887, 1),
(27888, 1),
(27889, 1),
(27890, 1),
(27891, 1),
(27892, 1),
(27893, 1),
(27894, 1),
(27895, 1),
(27896, 1),
(27897, 1),
(27898, 1),
(27899, 1),
(27900, 1),
(27901, 1),
(27902, 1),
(27903, 1),
(27904, 1),
(27905, 1),
(27906, 1),
(27907, 1),
(27908, 1),
(27909, 1),
(27910, 1),
(27911, 1),
(27912, 1),
(27913, 1),
(27914, 1),
(27915, 1),
(27916, 1),
(27917, 1),
(27918, 1),
(27919, 1),
(27920, 1),
(27921, 1),
(27922, 1),
(27923, 1),
(27924, 1),
(27925, 1),
(27926, 1),
(27927, 1),
(27928, 1),
(27929, 1),
(27930, 1),
(27931, 1),
(27932, 1),
(27933, 1),
(27934, 1),
(27935, 1),
(27936, 1),
(27937, 1),
(27938, 1),
(27939, 1),
(27940, 1),
(27941, 1),
(27942, 1),
(27943, 1),
(27944, 1),
(27945, 1),
(27946, 1),
(27947, 1),
(27948, 1),
(27949, 1),
(27950, 1),
(27951, 1),
(27952, 1),
(27953, 1),
(27954, 1),
(27955, 1),
(27956, 1),
(27957, 1),
(27958, 1),
(27959, 1),
(27960, 1),
(27961, 1),
(27962, 1),
(27963, 1),
(27964, 1),
(27965, 1),
(27966, 1),
(27967, 1),
(27968, 1),
(27969, 1),
(27970, 1),
(27971, 1),
(27972, 1),
(27973, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(27974, 1),
(27975, 1),
(27976, 1),
(27977, 1),
(27978, 1),
(27979, 1),
(27980, 1),
(27981, 1),
(27982, 1),
(27983, 1),
(27984, 1),
(27985, 1),
(27986, 1),
(27987, 1),
(27988, 1),
(27989, 1),
(27990, 1),
(27991, 1),
(27992, 1),
(27993, 1),
(27994, 1),
(27995, 1),
(27996, 1),
(27997, 1),
(27998, 1),
(27999, 1),
(28000, 1),
(28001, 1),
(28002, 1),
(28003, 1),
(28004, 1),
(28005, 1),
(28006, 1),
(28007, 1),
(28008, 1),
(28009, 1),
(28010, 1),
(28011, 1),
(28012, 1),
(28013, 1),
(28014, 1),
(28015, 1),
(28016, 1),
(28017, 1),
(28018, 1),
(28019, 1),
(28020, 1),
(28021, 1),
(28022, 1),
(28023, 1),
(28024, 1),
(28025, 1),
(28026, 1),
(28027, 1),
(28028, 1),
(28029, 1),
(28030, 1),
(28031, 1),
(28032, 1),
(28033, 1),
(28034, 1),
(28035, 1),
(28036, 1),
(28037, 1),
(28038, 1),
(28039, 1),
(28040, 1),
(28041, 1),
(28042, 1),
(28043, 1),
(28044, 1),
(28045, 1),
(28046, 1),
(28047, 1),
(28048, 1),
(28049, 1),
(28050, 1),
(28051, 1),
(28052, 1),
(28053, 1),
(28054, 1),
(28055, 1),
(28056, 1),
(28057, 1),
(28058, 1),
(28059, 1),
(28060, 1),
(28061, 1),
(28062, 1),
(28063, 1),
(28064, 1),
(28065, 1),
(28066, 1),
(28067, 1),
(28068, 1),
(28069, 1),
(28070, 1),
(28071, 1),
(28072, 1),
(28073, 1),
(28074, 1),
(28075, 1),
(28076, 1),
(28077, 1),
(28078, 1),
(28079, 1),
(28080, 1),
(28081, 1),
(28082, 1),
(28083, 1),
(28084, 1),
(28085, 1),
(28086, 1),
(28087, 1),
(28088, 1),
(28089, 1),
(28090, 1),
(28091, 1),
(28092, 1),
(28093, 1),
(28094, 1),
(28095, 1),
(28096, 1),
(28097, 1),
(28098, 1),
(28099, 1),
(28100, 1),
(28101, 1),
(28102, 1),
(28103, 1),
(28104, 1),
(28105, 1),
(28106, 1),
(28107, 1),
(28108, 1),
(28109, 1),
(28110, 1),
(28111, 1),
(28112, 1),
(28113, 1),
(28114, 1),
(28115, 1),
(28116, 1),
(28117, 1),
(28118, 1),
(28119, 1),
(28120, 1),
(28121, 1),
(28122, 1),
(28123, 1),
(28124, 1),
(28125, 1),
(28126, 1),
(28127, 1),
(28128, 1),
(28129, 1),
(28130, 1),
(28131, 1),
(28132, 1),
(28133, 1),
(28134, 1),
(28135, 1),
(28136, 1),
(28137, 1),
(28138, 1),
(28139, 1),
(28140, 1),
(28141, 1),
(28142, 1),
(28143, 1),
(28144, 1),
(28145, 1),
(28146, 1),
(28147, 1),
(28148, 1),
(28149, 1),
(28150, 1),
(28151, 1),
(28152, 1),
(28153, 1),
(28154, 1),
(28155, 1),
(28156, 1),
(28157, 1),
(28158, 1),
(28159, 1),
(28160, 1),
(28161, 1),
(28162, 1),
(28163, 1),
(28164, 1),
(28165, 1),
(28166, 1),
(28167, 1),
(28168, 1),
(28169, 1),
(28170, 1),
(28171, 1),
(28172, 1),
(28173, 1),
(28174, 1),
(28175, 1),
(28176, 1),
(28177, 1),
(28178, 1),
(28179, 1),
(28180, 1),
(28181, 1),
(28182, 1),
(28183, 1),
(28184, 1),
(28185, 1),
(28186, 1),
(28187, 1),
(28188, 1),
(28189, 1),
(28190, 1),
(28191, 1),
(28192, 1),
(28193, 1),
(28194, 1),
(28195, 1),
(28196, 1),
(28197, 1),
(28198, 1),
(28199, 1),
(28200, 1),
(28201, 1),
(28202, 1),
(28203, 1),
(28204, 1),
(28205, 1),
(28206, 1),
(28207, 1),
(28208, 1),
(28209, 1),
(28210, 1),
(28211, 1),
(28212, 1),
(28213, 1),
(28214, 1),
(28215, 1),
(28216, 1),
(28217, 1),
(28218, 1),
(28219, 1),
(28220, 1),
(28221, 1),
(28222, 1),
(28223, 1),
(28224, 1),
(28225, 1),
(28226, 1),
(28227, 1),
(28228, 1),
(28229, 1),
(28230, 1),
(28231, 1),
(28232, 1),
(28233, 1),
(28234, 1),
(28235, 1),
(28236, 1),
(28237, 1),
(28238, 1),
(28239, 1),
(28240, 1),
(28241, 1),
(28242, 1),
(28243, 1),
(28244, 1),
(28245, 1),
(28246, 1),
(28247, 1),
(28248, 1),
(28249, 1),
(28250, 1),
(28251, 1),
(28252, 1),
(28253, 1),
(28254, 1),
(28255, 1),
(28256, 1),
(28257, 1),
(28258, 1),
(28259, 1),
(28260, 1),
(28261, 1),
(28262, 1),
(28263, 1),
(28264, 1),
(28265, 1),
(28266, 1),
(28267, 1),
(28268, 1),
(28269, 1),
(28270, 1),
(28271, 1),
(28272, 1),
(28273, 1),
(28274, 1),
(28275, 1),
(28276, 1),
(28277, 1),
(28278, 1),
(28279, 1),
(28280, 1),
(28281, 1),
(28282, 1),
(28283, 1),
(28284, 1),
(28285, 1),
(28286, 1),
(28287, 1),
(28288, 1),
(28289, 1),
(28290, 1),
(28291, 1),
(28292, 1),
(28293, 1),
(28294, 1),
(28295, 1),
(28296, 1),
(28297, 1),
(28298, 1),
(28299, 1),
(28300, 1),
(28301, 1),
(28302, 1),
(28303, 1),
(28304, 1),
(28305, 1),
(28306, 1),
(28307, 1),
(28308, 1),
(28309, 1),
(28310, 1),
(28311, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(28312, 1),
(28313, 1),
(28314, 1),
(28315, 1),
(28316, 1),
(28317, 1),
(28318, 1),
(28319, 1),
(28320, 1),
(28321, 1),
(28322, 1),
(28323, 1),
(28324, 1),
(28325, 1),
(28326, 1),
(28327, 1),
(28328, 1),
(28329, 1),
(28330, 1),
(28331, 1),
(28332, 1),
(28333, 1),
(28334, 1),
(28335, 1),
(28336, 1),
(28337, 1),
(28338, 1),
(28339, 1),
(28340, 1),
(28341, 1),
(28342, 1),
(28343, 1),
(28344, 1),
(28345, 1),
(28346, 1),
(28347, 1),
(28348, 1),
(28349, 1),
(28350, 1),
(28351, 1),
(28352, 1),
(28353, 1),
(28354, 1),
(28355, 1),
(28356, 1),
(28357, 1),
(28358, 1),
(28359, 1),
(28360, 1),
(28361, 1),
(28362, 1),
(28363, 1),
(28364, 1),
(28365, 1),
(28366, 1),
(28367, 1),
(28368, 1),
(28369, 1),
(28370, 1),
(28371, 1),
(28372, 1),
(28373, 1),
(28374, 1),
(28375, 1),
(28376, 1),
(28377, 1),
(28378, 1),
(28379, 1),
(28380, 1),
(28381, 1),
(28382, 1),
(28383, 1),
(28384, 1),
(28385, 1),
(28386, 1),
(28387, 1),
(28388, 1),
(28389, 1),
(28390, 1),
(28391, 1),
(28392, 1),
(28393, 1),
(28394, 1),
(28395, 1),
(28396, 1),
(28397, 1),
(28398, 1),
(28399, 1),
(28400, 1),
(28401, 1),
(28402, 1),
(28403, 1),
(28404, 1),
(28405, 1),
(28406, 1),
(28407, 1),
(28408, 1),
(28409, 1),
(28410, 1),
(28411, 1),
(28412, 1),
(28413, 1),
(28414, 1),
(28415, 1),
(28416, 1),
(28417, 1),
(28418, 1),
(28419, 1),
(28420, 1),
(28421, 1),
(28422, 1),
(28423, 1),
(28424, 1),
(28425, 1),
(28426, 1),
(28427, 1),
(28428, 1),
(28429, 1),
(28430, 1),
(28431, 1),
(28432, 1),
(28433, 1),
(28434, 1),
(28435, 1),
(28436, 1),
(28437, 1),
(28438, 1),
(28439, 1),
(28440, 1),
(28441, 1),
(28442, 1),
(28443, 1),
(28444, 1),
(28445, 1),
(28446, 1),
(28447, 1),
(28448, 1),
(28449, 1),
(28450, 1),
(28451, 1),
(28452, 1),
(28453, 1),
(28454, 1),
(28455, 1),
(28456, 1),
(28457, 1),
(28458, 1),
(28459, 1),
(28460, 1),
(28461, 1),
(28462, 1),
(28463, 1),
(28464, 1),
(28465, 1),
(28466, 1),
(28467, 1),
(28468, 1),
(28469, 1),
(28470, 1),
(28471, 1),
(28472, 1),
(28473, 1),
(28474, 1),
(28475, 1),
(28476, 1),
(28477, 1),
(28478, 1),
(28479, 1),
(28480, 1),
(28481, 1),
(28482, 1),
(28483, 1),
(28484, 1),
(28485, 1),
(28486, 1),
(28487, 1),
(28488, 1),
(28489, 1),
(28490, 1),
(28491, 1),
(28492, 1),
(28493, 1),
(28494, 1),
(28495, 1),
(28496, 1),
(28497, 1),
(28498, 1),
(28499, 1),
(28500, 1),
(28501, 1),
(28502, 1),
(28503, 1),
(28504, 1),
(28505, 1),
(28506, 1),
(28507, 1),
(28508, 1),
(28509, 1),
(28510, 1),
(28511, 1),
(28512, 1),
(28513, 1),
(28514, 1),
(28515, 1),
(28516, 1),
(28517, 1),
(28518, 1),
(28519, 1),
(28520, 1),
(28521, 1),
(28522, 1),
(28523, 1),
(28524, 1),
(28525, 1),
(28526, 1),
(28527, 1),
(28528, 1),
(28529, 1),
(28530, 1),
(28531, 1),
(28532, 1),
(28533, 1),
(28534, 1),
(28535, 1),
(28536, 1),
(28537, 1),
(28538, 1),
(28539, 1),
(28540, 1),
(28541, 1),
(28542, 1),
(28543, 1),
(28544, 1),
(28545, 1),
(28546, 1),
(28547, 1),
(28548, 1),
(28549, 1),
(28550, 1),
(28551, 1),
(28552, 1),
(28553, 1),
(28554, 1),
(28555, 1),
(28556, 1),
(28557, 1),
(28558, 1),
(28559, 1),
(28560, 1),
(28561, 1),
(28562, 1),
(28563, 1),
(28564, 1),
(28565, 1),
(28566, 1),
(28567, 1),
(28568, 1),
(28569, 1),
(28570, 1),
(28571, 1),
(28572, 1),
(28573, 1),
(28574, 1),
(28575, 1),
(28576, 1),
(28577, 1),
(28578, 1),
(28579, 1),
(28580, 1),
(28581, 1),
(28582, 1),
(28583, 1),
(28584, 1),
(28585, 1),
(28586, 1),
(28587, 1),
(28588, 1),
(28589, 1),
(28590, 1),
(28591, 1),
(28592, 1),
(28593, 1),
(28594, 1),
(28595, 1),
(28596, 1),
(28597, 1),
(28598, 1),
(28599, 1),
(28600, 1),
(28601, 1),
(28602, 1),
(28603, 1),
(28604, 1),
(28605, 1),
(28606, 1),
(28607, 1),
(28608, 1),
(28609, 1),
(28610, 1),
(28611, 1),
(28612, 1),
(28613, 1),
(28614, 1),
(28615, 1),
(28616, 1),
(28617, 1),
(28618, 1),
(28619, 1),
(28620, 1),
(28621, 1),
(28622, 1),
(28623, 1),
(28624, 1),
(28625, 1),
(28626, 1),
(28627, 1),
(28628, 1),
(28629, 1),
(28630, 1),
(28631, 1),
(28632, 1),
(28633, 1),
(28634, 1),
(28635, 1),
(28636, 1),
(28637, 1),
(28638, 1),
(28639, 1),
(28640, 1),
(28641, 1),
(28642, 1),
(28643, 1),
(28644, 1),
(28645, 1),
(28646, 1),
(28647, 1),
(28648, 1),
(28649, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(28650, 1),
(28651, 1),
(28652, 1),
(28653, 1),
(28654, 1),
(28655, 1),
(28656, 1),
(28657, 1),
(28658, 1),
(28659, 1),
(28660, 1),
(28661, 1),
(28662, 1),
(28663, 1),
(28664, 1),
(28665, 1),
(28666, 1),
(28667, 1),
(28668, 1),
(28669, 1),
(28670, 1),
(28671, 1),
(28672, 1),
(28673, 1),
(28674, 1),
(28675, 1),
(28676, 1),
(28677, 1),
(28678, 1),
(28679, 1),
(28680, 1),
(28681, 1),
(28682, 1),
(28683, 1),
(28684, 1),
(28685, 1),
(28686, 1),
(28687, 1),
(28688, 1),
(28689, 1),
(28690, 1),
(28691, 1),
(28692, 1),
(28693, 1),
(28694, 1),
(28695, 1),
(28696, 1),
(28697, 1),
(28698, 1),
(28699, 1),
(28700, 1),
(28701, 1),
(28702, 1),
(28703, 1),
(28704, 1),
(28705, 1),
(28706, 1),
(28707, 1),
(28708, 1),
(28709, 1),
(28710, 1),
(28711, 1),
(28712, 1),
(28713, 1),
(28714, 1),
(28715, 1),
(28716, 1),
(28717, 1),
(28718, 1),
(28719, 1),
(28720, 1),
(28721, 1),
(28722, 1),
(28723, 1),
(28724, 1),
(28725, 1),
(28726, 1),
(28727, 1),
(28728, 1),
(28729, 1),
(28730, 1),
(28731, 1),
(28732, 1),
(28733, 1),
(28734, 1),
(28735, 1),
(28736, 1),
(28737, 1),
(28738, 1),
(28739, 1),
(28740, 1),
(28741, 1),
(28742, 1),
(28743, 1),
(28744, 1),
(28745, 1),
(28746, 1),
(28747, 1),
(28748, 1),
(28749, 1),
(28750, 1),
(28751, 1),
(28752, 1),
(28753, 1),
(28754, 1),
(28755, 1),
(28756, 1),
(28757, 1),
(28758, 1),
(28759, 1),
(28760, 1),
(28761, 1),
(28762, 1),
(28763, 1),
(28764, 1),
(28765, 1),
(28766, 1),
(28767, 1),
(28768, 1),
(28769, 1),
(28770, 1),
(28771, 1),
(28772, 1),
(28773, 1),
(28774, 1),
(28775, 1),
(28776, 1),
(28777, 1),
(28778, 1),
(28779, 1),
(28780, 1),
(28781, 1),
(28782, 1),
(28783, 1),
(28784, 1),
(28785, 1),
(28786, 1),
(28787, 1),
(28788, 1),
(28789, 1),
(28790, 1),
(28791, 1),
(28792, 1),
(28793, 1),
(28794, 1),
(28795, 1),
(28796, 1),
(28797, 1),
(28798, 1),
(28799, 1),
(28800, 1),
(28801, 1),
(28802, 1),
(28803, 1),
(28804, 1),
(28805, 1),
(28806, 1),
(28807, 1),
(28808, 1),
(28809, 1),
(28810, 1),
(28811, 1),
(28812, 1),
(28813, 1),
(28814, 1),
(28815, 1),
(28816, 1),
(28817, 1),
(28818, 1),
(28819, 1),
(28820, 1),
(28821, 1),
(28822, 1),
(28823, 1),
(28824, 1),
(28825, 1),
(28826, 1),
(28827, 1),
(28828, 1),
(28829, 1),
(28830, 1),
(28831, 1),
(28832, 1),
(28833, 1),
(28834, 1),
(28835, 1),
(28836, 1),
(28837, 1),
(28838, 1),
(28839, 1),
(28840, 1),
(28841, 1),
(28842, 1),
(28843, 1),
(28844, 1),
(28845, 1),
(28846, 1),
(28847, 1),
(28848, 1),
(28849, 1),
(28850, 1),
(28851, 1),
(28852, 1),
(28853, 1),
(28854, 1),
(28855, 1),
(28856, 1),
(28857, 1),
(28858, 1),
(28859, 1),
(28860, 1),
(28861, 1),
(28862, 1),
(28863, 1),
(28864, 1),
(28865, 1),
(28866, 1),
(28867, 1),
(28868, 1),
(28869, 1),
(28870, 1),
(28871, 1),
(28872, 1),
(28873, 1),
(28874, 1),
(28875, 1),
(28876, 1),
(28877, 1),
(28878, 1),
(28879, 1),
(28880, 1),
(28881, 1),
(28882, 1),
(28883, 1),
(28884, 1),
(28885, 1),
(28886, 1),
(28887, 1),
(28888, 1),
(28889, 1),
(28890, 1),
(28891, 1),
(28892, 1),
(28893, 1),
(28894, 1),
(28895, 1),
(28896, 1),
(28897, 1),
(28898, 1),
(28899, 1),
(28900, 1),
(28901, 1),
(28902, 1),
(28903, 1),
(28904, 1),
(28905, 1),
(28906, 1),
(28907, 1),
(28908, 1),
(28909, 1),
(28910, 1),
(28911, 1),
(28912, 1),
(28913, 1),
(28914, 1),
(28915, 1),
(28916, 1),
(28917, 1),
(28918, 1),
(28919, 1),
(28920, 1),
(28921, 1),
(28922, 1),
(28923, 1),
(28924, 1),
(28925, 1),
(28926, 1),
(28927, 1),
(28928, 1),
(28929, 1),
(28930, 1),
(28931, 1),
(28932, 1),
(28933, 1),
(28934, 1),
(28935, 1),
(28936, 1),
(28937, 1),
(28938, 1),
(28939, 1),
(28940, 1),
(28941, 1),
(28942, 1),
(28943, 1),
(28944, 1),
(28945, 1),
(28946, 1),
(28947, 1),
(28948, 1),
(28949, 1),
(28950, 1),
(28951, 1),
(28952, 1),
(28953, 1),
(28954, 1),
(28955, 1),
(28956, 1),
(28957, 1),
(28958, 1),
(28959, 1),
(28960, 1),
(28961, 1),
(28962, 1),
(28963, 1),
(28964, 1),
(28965, 1),
(28966, 1),
(28967, 1),
(28968, 1),
(28969, 1),
(28970, 1),
(28971, 1),
(28972, 1),
(28973, 1),
(28974, 1),
(28975, 1),
(28976, 1),
(28977, 1),
(28978, 1),
(28979, 1),
(28980, 1),
(28981, 1),
(28982, 1),
(28983, 1),
(28984, 1),
(28985, 1),
(28986, 1),
(28987, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(28988, 1),
(28989, 1),
(28990, 1),
(28991, 1),
(28992, 1),
(28993, 1),
(28994, 1),
(28995, 1),
(28996, 1),
(28997, 1),
(28998, 1),
(28999, 1),
(29000, 1),
(29001, 1),
(29002, 1),
(29003, 1),
(29004, 1),
(29005, 1),
(29006, 1),
(29007, 1),
(29008, 1),
(29009, 1),
(29010, 1),
(29011, 1),
(29012, 1),
(29013, 1),
(29014, 1),
(29015, 1),
(29016, 1),
(29017, 1),
(29018, 1),
(29019, 1),
(29020, 1),
(29021, 1),
(29022, 1),
(29023, 1),
(29024, 1),
(29025, 1),
(29026, 1),
(29027, 1),
(29028, 1),
(29029, 1),
(29030, 1),
(29031, 1),
(29032, 1),
(29033, 1),
(29034, 1),
(29035, 1),
(29036, 1),
(29037, 1),
(29038, 1),
(29039, 1),
(29040, 1),
(29041, 1),
(29042, 1),
(29043, 1),
(29044, 1),
(29045, 1),
(29046, 1),
(29047, 1),
(29048, 1),
(29049, 1),
(29050, 1),
(29051, 1),
(29052, 1),
(29053, 1),
(29054, 1),
(29055, 1),
(29056, 1),
(29057, 1),
(29058, 1),
(29059, 1),
(29060, 1),
(29061, 1),
(29062, 1),
(29063, 1),
(29064, 1),
(29065, 1),
(29066, 1),
(29067, 1),
(29068, 1),
(29069, 1),
(29070, 1),
(29071, 1),
(29072, 1),
(29073, 1),
(29074, 1),
(29075, 1),
(29076, 1),
(29077, 1),
(29078, 1),
(29079, 1),
(29080, 1),
(29081, 1),
(29082, 1),
(29083, 1),
(29084, 1),
(29085, 1),
(29086, 1),
(29087, 1),
(29088, 1),
(29089, 1),
(29090, 1),
(29091, 1),
(29092, 1),
(29093, 1),
(29094, 1),
(29095, 1),
(29096, 1),
(29097, 1),
(29098, 1),
(29099, 1),
(29100, 1),
(29101, 1),
(29102, 1),
(29103, 1),
(29104, 1),
(29105, 1),
(29106, 1),
(29107, 1),
(29108, 1),
(29109, 1),
(29110, 1),
(29111, 1),
(29112, 1),
(29113, 1),
(29114, 1),
(29115, 1),
(29116, 1),
(29117, 1),
(29118, 1),
(29119, 1),
(29120, 1),
(29121, 1),
(29122, 1),
(29123, 1),
(29124, 1),
(29125, 1),
(29126, 1),
(29127, 1),
(29128, 1),
(29129, 1),
(29130, 1),
(29131, 1),
(29132, 1),
(29133, 1),
(29134, 1),
(29135, 1),
(29136, 1),
(29137, 1),
(29138, 1),
(29139, 1),
(29140, 1),
(29141, 1),
(29142, 1),
(29143, 1),
(29144, 1),
(29145, 1),
(29146, 1),
(29147, 1),
(29148, 1),
(29149, 1),
(29150, 1),
(29151, 1),
(29152, 1),
(29153, 1),
(29154, 1),
(29155, 1),
(29156, 1),
(29157, 1),
(29158, 1),
(29159, 1),
(29160, 1),
(29161, 1),
(29162, 1),
(29163, 1),
(29164, 1),
(29165, 1),
(29166, 1),
(29167, 1),
(29168, 1),
(29169, 1),
(29170, 1),
(29171, 1),
(29172, 1),
(29173, 1),
(29174, 1),
(29175, 1),
(29176, 1),
(29177, 1),
(29178, 1),
(29179, 1),
(29180, 1),
(29181, 1),
(29182, 1),
(29183, 1),
(29184, 1),
(29185, 1),
(29186, 1),
(29187, 1),
(29188, 1),
(29189, 1),
(29190, 1),
(29191, 1),
(29192, 1),
(29193, 1),
(29194, 1),
(29195, 1),
(29196, 1),
(29197, 1),
(29198, 1),
(29199, 1),
(29200, 1),
(29201, 1),
(29202, 1),
(29203, 1),
(29204, 1),
(29205, 1),
(29206, 1),
(29207, 1),
(29208, 1),
(29209, 1),
(29210, 1),
(29211, 1),
(29212, 1),
(29213, 1),
(29214, 1),
(29215, 1),
(29216, 1),
(29217, 1),
(29218, 1),
(29219, 1),
(29220, 1),
(29221, 1),
(29222, 1),
(29223, 1),
(29224, 1),
(29225, 1),
(29226, 1),
(29227, 1),
(29228, 1),
(29229, 1),
(29230, 1),
(29231, 1),
(29232, 1),
(29233, 1),
(29234, 1),
(29235, 1),
(29236, 1),
(29237, 1),
(29238, 1),
(29239, 1),
(29240, 1),
(29241, 1),
(29242, 1),
(29243, 1),
(29244, 1),
(29245, 1),
(29246, 1),
(29247, 1),
(29248, 1),
(29249, 1),
(29250, 1),
(29251, 1),
(29252, 1),
(29253, 1),
(29254, 1),
(29255, 1),
(29256, 1),
(29257, 1),
(29258, 1),
(29259, 1),
(29260, 1),
(29261, 1),
(29262, 1),
(29263, 1),
(29264, 1),
(29265, 1),
(29266, 1),
(29267, 1),
(29268, 1),
(29269, 1),
(29270, 1),
(29271, 1),
(29272, 1),
(29273, 1),
(29274, 1),
(29275, 1),
(29276, 1),
(29277, 1),
(29278, 1),
(29279, 1),
(29280, 1),
(29281, 1),
(29282, 1),
(29283, 1),
(29284, 1),
(29285, 1),
(29286, 1),
(29287, 1),
(29288, 1),
(29289, 1),
(29290, 1),
(29291, 1),
(29292, 1),
(29293, 1),
(29294, 1),
(29295, 1),
(29296, 1),
(29297, 1),
(29298, 1),
(29299, 1),
(29300, 1),
(29301, 1),
(29302, 1),
(29303, 1),
(29304, 1),
(29305, 1),
(29306, 1),
(29307, 1),
(29308, 1),
(29309, 1),
(29310, 1),
(29311, 1),
(29312, 1),
(29313, 1),
(29314, 1),
(29315, 1),
(29316, 1),
(29317, 1),
(29318, 1),
(29319, 1),
(29320, 1),
(29321, 1),
(29322, 1),
(29323, 1),
(29324, 1),
(29325, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(29326, 1),
(29327, 1),
(29328, 1),
(29329, 1),
(29330, 1),
(29331, 1),
(29332, 1),
(29333, 1),
(29334, 1),
(29335, 1),
(29336, 1),
(29337, 1),
(29338, 1),
(29339, 1),
(29340, 1),
(29341, 1),
(29342, 1),
(29343, 1),
(29344, 1),
(29345, 1),
(29346, 1),
(29347, 1),
(29348, 1),
(29349, 1),
(29350, 1),
(29351, 1),
(29352, 1),
(29353, 1),
(29354, 1),
(29355, 1),
(29356, 1),
(29357, 1),
(29358, 1),
(29359, 1),
(29360, 1),
(29361, 1),
(29362, 1),
(29363, 1),
(29364, 1),
(29365, 1),
(29366, 1),
(29367, 1),
(29368, 1),
(29369, 1),
(29370, 1),
(29371, 1),
(29372, 1),
(29373, 1),
(29374, 1),
(29375, 1),
(29376, 1),
(29377, 1),
(29378, 1),
(29379, 1),
(29380, 1),
(29381, 1),
(29382, 1),
(29383, 1),
(29384, 1),
(29385, 1),
(29386, 1),
(29387, 1),
(29388, 1),
(29389, 1),
(29390, 1),
(29391, 1),
(29392, 1),
(29393, 1),
(29394, 1),
(29395, 1),
(29396, 1),
(29397, 1),
(29398, 1),
(29399, 1),
(29400, 1),
(29401, 1),
(29402, 1),
(29403, 1),
(29404, 1),
(29405, 1),
(29406, 1),
(29407, 1),
(29408, 1),
(29409, 1),
(29410, 1),
(29411, 1),
(29412, 1),
(29413, 1),
(29414, 1),
(29415, 1),
(29416, 1),
(29417, 1),
(29418, 1),
(29419, 1),
(29420, 1),
(29421, 1),
(29422, 1),
(29423, 1),
(29424, 1),
(29425, 1),
(29426, 1),
(29427, 1),
(29428, 1),
(29429, 1),
(29430, 1),
(29431, 1),
(29432, 1),
(29433, 1),
(29434, 1),
(29435, 1),
(29436, 1),
(29437, 1),
(29438, 1),
(29439, 1),
(29440, 1),
(29441, 1),
(29442, 1),
(29443, 1),
(29444, 1),
(29445, 1),
(29446, 1),
(29447, 1),
(29448, 1),
(29449, 1),
(29450, 1),
(29451, 1),
(29452, 1),
(29453, 1),
(29454, 1),
(29455, 1),
(29456, 1),
(29457, 1),
(29458, 1),
(29459, 1),
(29460, 1),
(29461, 1),
(29462, 1),
(29463, 1),
(29464, 1),
(29465, 1),
(29466, 1),
(29467, 1),
(29468, 1),
(29469, 1),
(29470, 1),
(29471, 1),
(29472, 1),
(29473, 1),
(29474, 1),
(29475, 1),
(29476, 1),
(29477, 1),
(29478, 1),
(29479, 1),
(29480, 1),
(29481, 1),
(29482, 1),
(29483, 1),
(29484, 1),
(29485, 1),
(29486, 1),
(29487, 1),
(29488, 1),
(29489, 1),
(29490, 1),
(29491, 1),
(29492, 1),
(29493, 1),
(29494, 1),
(29495, 1),
(29496, 1),
(29497, 1),
(29498, 1),
(29499, 1),
(29500, 1),
(29501, 1),
(29502, 1),
(29503, 1),
(29504, 1),
(29505, 1),
(29506, 1),
(29507, 1),
(29508, 1),
(29509, 1),
(29510, 1),
(29511, 1),
(29512, 1),
(29513, 1),
(29514, 1),
(29515, 1),
(29516, 1),
(29517, 1),
(29518, 1),
(29519, 1),
(29520, 1),
(29521, 1),
(29522, 1),
(29523, 1),
(29524, 1),
(29525, 1),
(29526, 1),
(29527, 1),
(29528, 1),
(29529, 1),
(29530, 1),
(29531, 1),
(29532, 1),
(29533, 1),
(29534, 1),
(29535, 1),
(29536, 1),
(29537, 1),
(29538, 1),
(29539, 1),
(29540, 1),
(29541, 1),
(29542, 1),
(29543, 1),
(29544, 1),
(29545, 1),
(29546, 1),
(29547, 1),
(29548, 1),
(29549, 1),
(29550, 1),
(29551, 1),
(29552, 1),
(29553, 1),
(29554, 1),
(29555, 1),
(29556, 1),
(29557, 1),
(29558, 1),
(29559, 1),
(29560, 1),
(29561, 1),
(29562, 1),
(29563, 1),
(29564, 1),
(29565, 1),
(29566, 1),
(29567, 1),
(29568, 1),
(29569, 1),
(29570, 1),
(29571, 1),
(29572, 1),
(29573, 1),
(29574, 1),
(29575, 1),
(29576, 1),
(29577, 1),
(29578, 1),
(29579, 1),
(29580, 1),
(29581, 1),
(29582, 1),
(29583, 1),
(29584, 1),
(29585, 1),
(29586, 1),
(29587, 1),
(29588, 1),
(29589, 1),
(29590, 1),
(29591, 1),
(29592, 1),
(29593, 1),
(29594, 1),
(29595, 1),
(29596, 1),
(29597, 1),
(29598, 1),
(29599, 1),
(29600, 1),
(29601, 1),
(29602, 1),
(29603, 1),
(29604, 1),
(29605, 1),
(29606, 1),
(29607, 1),
(29608, 1),
(29609, 1),
(29610, 1),
(29611, 1),
(29612, 1),
(29613, 1),
(29614, 1),
(29615, 1),
(29616, 1),
(29617, 1),
(29618, 1),
(29619, 1),
(29620, 1),
(29621, 1),
(29622, 1),
(29623, 1),
(29624, 1),
(29625, 1),
(29626, 1),
(29627, 1),
(29628, 1),
(29629, 1),
(29630, 1),
(29631, 1),
(29632, 1),
(29633, 1),
(29634, 1),
(29635, 1),
(29636, 1),
(29637, 1),
(29638, 1),
(29639, 1),
(29640, 1),
(29641, 1),
(29642, 1),
(29643, 1),
(29644, 1),
(29645, 1),
(29646, 1),
(29647, 1),
(29648, 1),
(29649, 1),
(29650, 1),
(29651, 1),
(29652, 1),
(29653, 1),
(29654, 1),
(29655, 1),
(29656, 1),
(29657, 1),
(29658, 1),
(29659, 1),
(29660, 1),
(29661, 1),
(29662, 1),
(29663, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(29664, 1),
(29665, 1),
(29666, 1),
(29667, 1),
(29668, 1),
(29669, 1),
(29670, 1),
(29671, 1),
(29672, 1),
(29673, 1),
(29674, 1),
(29675, 1),
(29676, 1),
(29677, 1),
(29678, 1),
(29679, 1),
(29680, 1),
(29681, 1),
(29682, 1),
(29683, 1),
(29684, 1),
(29685, 1),
(29686, 1),
(29687, 1),
(29688, 1),
(29689, 1),
(29690, 1),
(29691, 1),
(29692, 1),
(29693, 1),
(29694, 1),
(29695, 1),
(29696, 1),
(29697, 1),
(29698, 1),
(29699, 1),
(29700, 1),
(29701, 1),
(29702, 1),
(29703, 1),
(29704, 1),
(29705, 1),
(29706, 1),
(29707, 1),
(29708, 1),
(29709, 1),
(29710, 1),
(29711, 1),
(29712, 1),
(29713, 1),
(29714, 1),
(29715, 1),
(29716, 1),
(29717, 1),
(29718, 1),
(29719, 1),
(29720, 1),
(29721, 1),
(29722, 1),
(29723, 1),
(29724, 1),
(29725, 1),
(29726, 1),
(29727, 1),
(29728, 1),
(29729, 1),
(29730, 1),
(29731, 1),
(29732, 1),
(29733, 1),
(29734, 1),
(29735, 1),
(29736, 1),
(29737, 1),
(29738, 1),
(29739, 1),
(29740, 1),
(29741, 1),
(29742, 1),
(29743, 1),
(29744, 1),
(29745, 1),
(29746, 1),
(29747, 1),
(29748, 1),
(29749, 1),
(29750, 1),
(29751, 1),
(29752, 1),
(29753, 1),
(29754, 1),
(29755, 1),
(29756, 1),
(29757, 1),
(29758, 1),
(29759, 1),
(29760, 1),
(29761, 1),
(29762, 1),
(29763, 1),
(29764, 1),
(29765, 1),
(29766, 1),
(29767, 1),
(29768, 1),
(29769, 1),
(29770, 1),
(29771, 1),
(29772, 1),
(29773, 1),
(29774, 1),
(29775, 1),
(29776, 1),
(29777, 1),
(29778, 1),
(29779, 1),
(29780, 1),
(29781, 1),
(29782, 1),
(29783, 1),
(29784, 1),
(29785, 1),
(29786, 1),
(29787, 1),
(29788, 1),
(29789, 1),
(29790, 1),
(29791, 1),
(29792, 1),
(29793, 1),
(29794, 1),
(29795, 1),
(29796, 1),
(29797, 1),
(29798, 1),
(29799, 1),
(29800, 1),
(29801, 1),
(29802, 1),
(29803, 1),
(29804, 1),
(29805, 1),
(29806, 1),
(29807, 1),
(29808, 1),
(29809, 1),
(29810, 1),
(29811, 1),
(29812, 1),
(29813, 1),
(29814, 1),
(29815, 1),
(29816, 1),
(29817, 1),
(29818, 1),
(29819, 1),
(29820, 1),
(29821, 1),
(29822, 1),
(29823, 1),
(29824, 1),
(29825, 1),
(29826, 1),
(29827, 1),
(29828, 1),
(29829, 1),
(29830, 1),
(29831, 1),
(29832, 1),
(29833, 1),
(29834, 1),
(29835, 1),
(29836, 1),
(29837, 1),
(29838, 1),
(29839, 1),
(29840, 1),
(29841, 1),
(29842, 1),
(29843, 1),
(29844, 1),
(29845, 1),
(29846, 1),
(29847, 1),
(29848, 1),
(29849, 1),
(29850, 1),
(29851, 1),
(29852, 1),
(29853, 1),
(29854, 1),
(29855, 1),
(29856, 1),
(29857, 1),
(29858, 1),
(29859, 1),
(29860, 1),
(29861, 1),
(29862, 1),
(29863, 1),
(29864, 1),
(29865, 1),
(29866, 1),
(29867, 1),
(29868, 1),
(29869, 1),
(29870, 1),
(29871, 1),
(29872, 1),
(29873, 1),
(29874, 1),
(29875, 1),
(29876, 1),
(29877, 1),
(29878, 1),
(29879, 1),
(29880, 1),
(29881, 1),
(29882, 1),
(29883, 1),
(29884, 1),
(29885, 1),
(29886, 1),
(29887, 1),
(29888, 1),
(29889, 1),
(29890, 1),
(29891, 1),
(29892, 1),
(29893, 1),
(29894, 1),
(29895, 1),
(29896, 1),
(29897, 1),
(29898, 1),
(29899, 1),
(29900, 1),
(29901, 1),
(29902, 1),
(29903, 1),
(29904, 1),
(29905, 1),
(29906, 1),
(29907, 1),
(29908, 1),
(29909, 1),
(29910, 1),
(29911, 1),
(29912, 1),
(29913, 1),
(29914, 1),
(29915, 1),
(29916, 1),
(29917, 1),
(29918, 1),
(29919, 1),
(29920, 1),
(29921, 1),
(29922, 1),
(29923, 1),
(29924, 1),
(29925, 1),
(29926, 1),
(29927, 1),
(29928, 1),
(29929, 1),
(29930, 1),
(29931, 1),
(29932, 1),
(29933, 1),
(29934, 1),
(29935, 1),
(29936, 1),
(29937, 1),
(29938, 1),
(29939, 1),
(29940, 1),
(29941, 1),
(29942, 1),
(29943, 1),
(29944, 1),
(29945, 1),
(29946, 1),
(29947, 1),
(29948, 1),
(29949, 1),
(29950, 1),
(29951, 1),
(29952, 1),
(29953, 1),
(29954, 1),
(29955, 1),
(29956, 1),
(29957, 1),
(29958, 1),
(29959, 1),
(29960, 1),
(29961, 1),
(29962, 1),
(29963, 1),
(29964, 1),
(29965, 1),
(29966, 1),
(29967, 1),
(29968, 1),
(29969, 1),
(29970, 1),
(29971, 1),
(29972, 1),
(29973, 1),
(29974, 1),
(29975, 1),
(29976, 1),
(29977, 1),
(29978, 1),
(29979, 1),
(29980, 1),
(29981, 1),
(29982, 1),
(29983, 1),
(29984, 1),
(29985, 1),
(29986, 1),
(29987, 1),
(29988, 1),
(29989, 1),
(29990, 1),
(29991, 1),
(29992, 1),
(29993, 1),
(29994, 1),
(29995, 1),
(29996, 1),
(29997, 1),
(29998, 1),
(29999, 1),
(30000, 1),
(30001, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(30002, 1),
(30003, 1),
(30004, 1),
(30005, 1),
(30006, 1),
(30007, 1),
(30008, 1),
(30009, 1),
(30010, 1),
(30011, 1),
(30012, 1),
(30013, 1),
(30014, 1),
(30015, 1),
(30016, 1),
(30017, 1),
(30018, 1),
(30019, 1),
(30020, 1),
(30021, 1),
(30022, 1),
(30023, 1),
(30024, 1),
(30025, 1),
(30026, 1),
(30027, 1),
(30028, 1),
(30029, 1),
(30030, 1),
(30031, 1),
(30032, 1),
(30033, 1),
(30034, 1),
(30035, 1),
(30036, 1),
(30037, 1),
(30038, 1),
(30039, 1),
(30040, 1),
(30041, 1),
(30042, 1),
(30043, 1),
(30044, 1),
(30045, 1),
(30046, 1),
(30047, 1),
(30048, 1),
(30049, 1),
(30050, 1),
(30051, 1),
(30052, 1),
(30053, 1),
(30054, 1),
(30055, 1),
(30056, 1),
(30057, 1),
(30058, 1),
(30059, 1),
(30060, 1),
(30061, 1),
(30062, 1),
(30063, 1),
(30064, 1),
(30065, 1),
(30066, 1),
(30067, 1),
(30068, 1),
(30069, 1),
(30070, 1),
(30071, 1),
(30072, 1),
(30073, 1),
(30074, 1),
(30075, 1),
(30076, 1),
(30077, 1),
(30078, 1),
(30079, 1),
(30080, 1),
(30081, 1),
(30082, 1),
(30083, 1),
(30084, 1),
(30085, 1),
(30086, 1),
(30087, 1),
(30088, 1),
(30089, 1),
(30090, 1),
(30091, 1),
(30092, 1),
(30093, 1),
(30094, 1),
(30095, 1),
(30096, 1),
(30097, 1),
(30098, 1),
(30099, 1),
(30100, 1),
(30101, 1),
(30102, 1),
(30103, 1),
(30104, 1),
(30105, 1),
(30106, 1),
(30107, 1),
(30108, 1),
(30109, 1),
(30110, 1),
(30111, 1),
(30112, 1),
(30113, 1),
(30114, 1),
(30115, 1),
(30116, 1),
(30117, 1),
(30118, 1),
(30119, 1),
(30120, 1),
(30121, 1),
(30122, 1),
(30123, 1),
(30124, 1),
(30125, 1),
(30126, 1),
(30127, 1),
(30128, 1),
(30129, 1),
(30130, 1),
(30131, 1),
(30132, 1),
(30133, 1),
(30134, 1),
(30135, 1),
(30136, 1),
(30137, 1),
(30138, 1),
(30139, 1),
(30140, 1),
(30141, 1),
(30142, 1),
(30143, 1),
(30144, 1),
(30145, 1),
(30146, 1),
(30147, 1),
(30148, 1),
(30149, 1),
(30150, 1),
(30151, 1),
(30152, 1),
(30153, 1),
(30154, 1),
(30155, 1),
(30156, 1),
(30157, 1),
(30158, 1),
(30159, 1),
(30160, 1),
(30161, 1),
(30162, 1),
(30163, 1),
(30164, 1),
(30165, 1),
(30166, 1),
(30167, 1),
(30168, 1),
(30169, 1),
(30170, 1),
(30171, 1),
(30172, 1),
(30173, 1),
(30174, 1),
(30175, 1),
(30176, 1),
(30177, 1),
(30178, 1),
(30179, 1),
(30180, 1),
(30181, 1),
(30182, 1),
(30183, 1),
(30184, 1),
(30185, 1),
(30186, 1),
(30187, 1),
(30188, 1),
(30189, 1),
(30190, 1),
(30191, 1),
(30192, 1),
(30193, 1),
(30194, 1),
(30195, 1),
(30196, 1),
(30197, 1),
(30198, 1),
(30199, 1),
(30200, 1),
(30201, 1),
(30202, 1),
(30203, 1),
(30204, 1),
(30205, 1),
(30206, 1),
(30207, 1),
(30208, 1),
(30209, 1),
(30210, 1),
(30211, 1),
(30212, 1),
(30213, 1),
(30214, 1),
(30215, 1),
(30216, 1),
(30217, 1),
(30218, 1),
(30219, 1),
(30220, 1),
(30221, 1),
(30222, 1),
(30223, 1),
(30224, 1),
(30225, 1),
(30226, 1),
(30227, 1),
(30228, 1),
(30229, 1),
(30230, 1),
(30231, 1),
(30232, 1),
(30233, 1),
(30234, 1),
(30235, 1),
(30236, 1),
(30237, 1),
(30238, 1),
(30239, 1),
(30240, 1),
(30241, 1),
(30242, 1),
(30243, 1),
(30244, 1),
(30245, 1),
(30246, 1),
(30247, 1),
(30248, 1),
(30249, 1),
(30250, 1),
(30251, 1),
(30252, 1),
(30253, 1),
(30254, 1),
(30255, 1),
(30256, 1),
(30257, 1),
(30258, 1),
(30259, 1),
(30260, 1),
(30261, 1),
(30262, 1),
(30263, 1),
(30264, 1),
(30265, 1),
(30266, 1),
(30267, 1),
(30268, 1),
(30269, 1),
(30270, 1),
(30271, 1),
(30272, 1),
(30273, 1),
(30274, 1),
(30275, 1),
(30276, 1),
(30277, 1),
(30278, 1),
(30279, 1),
(30280, 1),
(30281, 1),
(30282, 1),
(30283, 1),
(30284, 1),
(30285, 1),
(30286, 1),
(30287, 1),
(30288, 1),
(30289, 1),
(30290, 1),
(30291, 1),
(30292, 1),
(30293, 1),
(30294, 1),
(30295, 1),
(30296, 1),
(30297, 1),
(30298, 1),
(30299, 1),
(30300, 1),
(30301, 1),
(30302, 1),
(30303, 1),
(30304, 1),
(30305, 1),
(30306, 1),
(30307, 1),
(30308, 1),
(30309, 1),
(30310, 1),
(30311, 1),
(30312, 1),
(30313, 1),
(30314, 1),
(30315, 1),
(30316, 1),
(30317, 1),
(30318, 1),
(30319, 1),
(30320, 1),
(30321, 1),
(30322, 1),
(30323, 1),
(30324, 1),
(30325, 1),
(30326, 1),
(30327, 1),
(30328, 1),
(30329, 1),
(30330, 1),
(30331, 1),
(30332, 1),
(30333, 1),
(30334, 1),
(30335, 1),
(30336, 1),
(30337, 1),
(30338, 1),
(30339, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(30340, 1),
(30341, 1),
(30342, 1),
(30343, 1),
(30344, 1),
(30345, 1),
(30346, 1),
(30347, 1),
(30348, 1),
(30349, 1),
(30350, 1),
(30351, 1),
(30352, 1),
(30353, 1),
(30354, 1),
(30355, 1),
(30356, 1),
(30357, 1),
(30358, 1),
(30359, 1),
(30360, 1),
(30361, 1),
(30362, 1),
(30363, 1),
(30364, 1),
(30365, 1),
(30366, 1),
(30367, 1),
(30368, 1),
(30369, 1),
(30370, 1),
(30371, 1),
(30372, 1),
(30373, 1),
(30374, 1),
(30375, 1),
(30376, 1),
(30377, 1),
(30378, 1),
(30379, 1),
(30380, 1),
(30381, 1),
(30382, 1),
(30383, 1),
(30384, 1),
(30385, 1),
(30386, 1),
(30387, 1),
(30388, 1),
(30389, 1),
(30390, 1),
(30391, 1),
(30392, 1),
(30393, 1),
(30394, 1),
(30395, 1),
(30396, 1),
(30397, 1),
(30398, 1),
(30399, 1),
(30400, 1),
(30401, 1),
(30402, 1),
(30403, 1),
(30404, 1),
(30405, 1),
(30406, 1),
(30407, 1),
(30408, 1),
(30409, 1),
(30410, 1),
(30411, 1),
(30412, 1),
(30413, 1),
(30414, 1),
(30415, 1),
(30416, 1),
(30417, 1),
(30418, 1),
(30419, 1),
(30420, 1),
(30421, 1),
(30422, 1),
(30423, 1),
(30424, 1),
(30425, 1),
(30426, 1),
(30427, 1),
(30428, 1),
(30429, 1),
(30430, 1),
(30431, 1),
(30432, 1),
(30433, 1),
(30434, 1),
(30435, 1),
(30436, 1),
(30437, 1),
(30438, 1),
(30439, 1),
(30440, 1),
(30441, 1),
(30442, 1),
(30443, 1),
(30444, 1),
(30445, 1),
(30446, 1),
(30447, 1),
(30448, 1),
(30449, 1),
(30450, 1),
(30451, 1),
(30452, 1),
(30453, 1),
(30454, 1),
(30455, 1),
(30456, 1),
(30457, 1),
(30458, 1),
(30459, 1),
(30460, 1),
(30461, 1),
(30462, 1),
(30463, 1),
(30464, 1),
(30465, 1),
(30466, 1),
(30467, 1),
(30468, 1),
(30469, 1),
(30470, 1),
(30471, 1),
(30472, 1),
(30473, 1),
(30474, 1),
(30475, 1),
(30476, 1),
(30477, 1),
(30478, 1),
(30479, 1),
(30480, 1),
(30481, 1),
(30482, 1),
(30483, 1),
(30484, 1),
(30485, 1),
(30486, 1),
(30487, 1),
(30488, 1),
(30489, 1),
(30490, 1),
(30491, 1),
(30492, 1),
(30493, 1),
(30494, 1),
(30495, 1),
(30496, 1),
(30497, 1),
(30498, 1),
(30499, 1),
(30500, 1),
(30501, 1),
(30502, 1),
(30503, 1),
(30504, 1),
(30505, 1),
(30506, 1),
(30507, 1),
(30508, 1),
(30509, 1),
(30510, 1),
(30511, 1),
(30512, 1),
(30513, 1),
(30514, 1),
(30515, 1),
(30516, 1),
(30517, 1),
(30518, 1),
(30519, 1),
(30520, 1),
(30521, 1),
(30522, 1),
(30523, 1),
(30524, 1),
(30525, 1),
(30526, 1),
(30527, 1),
(30528, 1),
(30529, 1),
(30530, 1),
(30531, 1),
(30532, 1),
(30533, 1),
(30534, 1),
(30535, 1),
(30536, 1),
(30537, 1),
(30538, 1),
(30539, 1),
(30540, 1),
(30541, 1),
(30542, 1),
(30543, 1),
(30544, 1),
(30545, 1),
(30546, 1),
(30547, 1),
(30548, 1),
(30549, 1),
(30550, 1),
(30551, 1),
(30552, 1),
(30553, 1),
(30554, 1),
(30555, 1),
(30556, 1),
(30557, 1),
(30558, 1),
(30559, 1),
(30560, 1),
(30561, 1),
(30562, 1),
(30563, 1),
(30564, 1),
(30565, 1),
(30566, 1),
(30567, 1),
(30568, 1),
(30569, 1),
(30570, 1),
(30571, 1),
(30572, 1),
(30573, 1),
(30574, 1),
(30575, 1),
(30576, 1),
(30577, 1),
(30578, 1),
(30579, 1),
(30580, 1),
(30581, 1),
(30582, 1),
(30583, 1),
(30584, 1),
(30585, 1),
(30586, 1),
(30587, 1),
(30588, 1),
(30589, 1),
(30590, 1),
(30591, 1),
(30592, 1),
(30593, 1),
(30594, 1),
(30595, 1),
(30596, 1),
(30597, 1),
(30598, 1),
(30599, 1),
(30600, 1),
(30601, 1),
(30602, 1),
(30603, 1),
(30604, 1),
(30605, 1),
(30606, 1),
(30607, 1),
(30608, 1),
(30609, 1),
(30610, 1),
(30611, 1),
(30612, 1),
(30613, 1),
(30614, 1),
(30615, 1),
(30616, 1),
(30617, 1),
(30618, 1),
(30619, 1),
(30620, 1),
(30621, 1),
(30622, 1),
(30623, 1),
(30624, 1),
(30625, 1),
(30626, 1),
(30627, 1),
(30628, 1),
(30629, 1),
(30630, 1),
(30631, 1),
(30632, 1),
(30633, 1),
(30634, 1),
(30635, 1),
(30636, 1),
(30637, 1),
(30638, 1),
(30639, 1),
(30640, 1),
(30641, 1),
(30642, 1),
(30643, 1),
(30644, 1),
(30645, 1),
(30646, 1),
(30647, 1),
(30648, 1),
(30649, 1),
(30650, 1),
(30651, 1),
(30652, 1),
(30653, 1),
(30654, 1),
(30655, 1),
(30656, 1),
(30657, 1),
(30658, 1),
(30659, 1),
(30660, 1),
(30661, 1),
(30662, 1),
(30663, 1),
(30664, 1),
(30665, 1),
(30666, 1),
(30667, 1),
(30668, 1),
(30669, 1),
(30670, 1),
(30671, 1),
(30672, 1),
(30673, 1),
(30674, 1),
(30675, 1),
(30676, 1),
(30677, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(30678, 1),
(30679, 1),
(30680, 1),
(30681, 1),
(30682, 1),
(30683, 1),
(30684, 1),
(30685, 1),
(30686, 1),
(30687, 1),
(30688, 1),
(30689, 1),
(30690, 1),
(30691, 1),
(30692, 1),
(30693, 1),
(30694, 1),
(30695, 1),
(30696, 1),
(30697, 1),
(30698, 1),
(30699, 1),
(30700, 1),
(30701, 1),
(30702, 1),
(30703, 1),
(30704, 1),
(30705, 1),
(30706, 1),
(30707, 1),
(30708, 1),
(30709, 1),
(30710, 1),
(30711, 1),
(30712, 1),
(30713, 1),
(30714, 1),
(30715, 1),
(30716, 1),
(30717, 1),
(30718, 1),
(30719, 1),
(30720, 1),
(30721, 1),
(30722, 1),
(30723, 1),
(30724, 1),
(30725, 1),
(30726, 1),
(30727, 1),
(30728, 1),
(30729, 1),
(30730, 1),
(30731, 1),
(30732, 1),
(30733, 1),
(30734, 1),
(30735, 1),
(30736, 1),
(30737, 1),
(30738, 1),
(30739, 1),
(30740, 1),
(30741, 1),
(30742, 1),
(30743, 1),
(30744, 1),
(30745, 1),
(30746, 1),
(30747, 1),
(30748, 1),
(30749, 1),
(30750, 1),
(30751, 1),
(30752, 1),
(30753, 1),
(30754, 1),
(30755, 1),
(30756, 1),
(30757, 1),
(30758, 1),
(30759, 1),
(30760, 1),
(30761, 1),
(30762, 1),
(30763, 1),
(30764, 1),
(30765, 1),
(30766, 1),
(30767, 1),
(30768, 1),
(30769, 1),
(30770, 1),
(30771, 1),
(30772, 1),
(30773, 1),
(30774, 1),
(30775, 1),
(30776, 1),
(30777, 1),
(30778, 1),
(30779, 1),
(30780, 1),
(30781, 1),
(30782, 1),
(30783, 1),
(30784, 1),
(30785, 1),
(30786, 1),
(30787, 1),
(30788, 1),
(30789, 1),
(30790, 1),
(30791, 1),
(30792, 1),
(30793, 1),
(30794, 1),
(30795, 1),
(30796, 1),
(30797, 1),
(30798, 1),
(30799, 1),
(30800, 1),
(30801, 1),
(30802, 1),
(30803, 1),
(30804, 1),
(30805, 1),
(30806, 1),
(30807, 1),
(30808, 1),
(30809, 1),
(30810, 1),
(30811, 1),
(30812, 1),
(30813, 1),
(30814, 1),
(30815, 1),
(30816, 1),
(30817, 1),
(30818, 1),
(30819, 1),
(30820, 1),
(30821, 1),
(30822, 1),
(30823, 1),
(30824, 1),
(30825, 1),
(30826, 1),
(30827, 1),
(30828, 1),
(30829, 1),
(30830, 1),
(30831, 1),
(30832, 1),
(30833, 1),
(30834, 1),
(30835, 1),
(30836, 1),
(30837, 1),
(30838, 1),
(30839, 1),
(30840, 1),
(30841, 1),
(30842, 1),
(30843, 1),
(30844, 1),
(30845, 1),
(30846, 1),
(30847, 1),
(30848, 1),
(30849, 1),
(30850, 1),
(30851, 1),
(30852, 1),
(30853, 1),
(30854, 1),
(30855, 1),
(30856, 1),
(30857, 1),
(30858, 1),
(30859, 1),
(30860, 1),
(30861, 1),
(30862, 1),
(30863, 1),
(30864, 1),
(30865, 1),
(30866, 1),
(30867, 1),
(30868, 1),
(30869, 1),
(30870, 1),
(30871, 1),
(30872, 1),
(30873, 1),
(30874, 1),
(30875, 1),
(30876, 1),
(30877, 1),
(30878, 1),
(30879, 1),
(30880, 1),
(30881, 1),
(30882, 1),
(30883, 1),
(30884, 1),
(30885, 1),
(30886, 1),
(30887, 1),
(30888, 1),
(30889, 1),
(30890, 1),
(30891, 1),
(30892, 1),
(30893, 1),
(30894, 1),
(30895, 1),
(30896, 1),
(30897, 1),
(30898, 1),
(30899, 1),
(30900, 1),
(30901, 1),
(30902, 1),
(30903, 1),
(30904, 1),
(30905, 1),
(30906, 1),
(30907, 1),
(30908, 1),
(30909, 1),
(30910, 1),
(30911, 1),
(30912, 1),
(30913, 1),
(30914, 1),
(30915, 1),
(30916, 1),
(30917, 1),
(30918, 1),
(30919, 1),
(30920, 1),
(30921, 1),
(30922, 1),
(30923, 1),
(30924, 1),
(30925, 1),
(30926, 1),
(30927, 1),
(30928, 1),
(30929, 1),
(30930, 1),
(30931, 1),
(30932, 1),
(30933, 1),
(30934, 1),
(30935, 1),
(30936, 1),
(30937, 1),
(30938, 1),
(30939, 1),
(30940, 1),
(30941, 1),
(30942, 1),
(30943, 1),
(30944, 1),
(30945, 1),
(30946, 1),
(30947, 1),
(30948, 1),
(30949, 1),
(30950, 1),
(30951, 1),
(30952, 1),
(30953, 1),
(30954, 1),
(30955, 1),
(30956, 1),
(30957, 1),
(30958, 1),
(30959, 1),
(30960, 1),
(30961, 1),
(30962, 1),
(30963, 1),
(30964, 1),
(30965, 1),
(30966, 1),
(30967, 1),
(30968, 1),
(30969, 1),
(30970, 1),
(30971, 1),
(30972, 1),
(30973, 1),
(30974, 1),
(30975, 1),
(30976, 1),
(30977, 1),
(30978, 1),
(30979, 1),
(30980, 1),
(30981, 1),
(30982, 1),
(30983, 1),
(30984, 1),
(30985, 1),
(30986, 1),
(30987, 1),
(30988, 1),
(30989, 1),
(30990, 1),
(30991, 1),
(30992, 1),
(30993, 1),
(30994, 1),
(30995, 1),
(30996, 1),
(30997, 1),
(30998, 1),
(30999, 1),
(31000, 1),
(31001, 1),
(31002, 1),
(31003, 1),
(31004, 1),
(31005, 1),
(31006, 1),
(31007, 1),
(31008, 1),
(31009, 1),
(31010, 1),
(31011, 1),
(31012, 1),
(31013, 1),
(31014, 1),
(31015, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(31016, 1),
(31017, 1),
(31018, 1),
(31019, 1),
(31020, 1),
(31021, 1),
(31022, 1),
(31023, 1),
(31024, 1),
(31025, 1),
(31026, 1),
(31027, 1),
(31028, 1),
(31029, 1),
(31030, 1),
(31031, 1),
(31032, 1),
(31033, 1),
(31034, 1),
(31035, 1),
(31036, 1),
(31037, 1),
(31038, 1),
(31039, 1),
(31040, 1),
(31041, 1),
(31042, 1),
(31043, 1),
(31044, 1),
(31045, 1),
(31046, 1),
(31047, 1),
(31048, 1),
(31049, 1),
(31050, 1),
(31051, 1),
(31052, 1),
(31053, 1),
(31054, 1),
(31055, 1),
(31056, 1),
(31057, 1),
(31058, 1),
(31059, 1),
(31060, 1),
(31061, 1),
(31062, 1),
(31063, 1),
(31064, 1),
(31065, 1),
(31066, 1),
(31067, 1),
(31068, 1),
(31069, 1),
(31070, 1),
(31071, 1),
(31072, 1),
(31073, 1),
(31074, 1),
(31075, 1),
(31076, 1),
(31077, 1),
(31078, 1),
(31079, 1),
(31080, 1),
(31081, 1),
(31082, 1),
(31083, 1),
(31084, 1),
(31085, 1),
(31086, 1),
(31087, 1),
(31088, 1),
(31089, 1),
(31090, 1),
(31091, 1),
(31092, 1),
(31093, 1),
(31094, 1),
(31095, 1),
(31096, 1),
(31097, 1),
(31098, 1),
(31099, 1),
(31100, 1),
(31101, 1),
(31102, 1),
(31103, 1),
(31104, 1),
(31105, 1),
(31106, 1),
(31107, 1),
(31108, 1),
(31109, 1),
(31110, 1),
(31111, 1),
(31112, 1),
(31113, 1),
(31114, 1),
(31115, 1),
(31116, 1),
(31117, 1),
(31118, 1),
(31119, 1),
(31120, 1),
(31121, 1),
(31122, 1),
(31123, 1),
(31124, 1),
(31125, 1),
(31126, 1),
(31127, 1),
(31128, 1),
(31129, 1),
(31130, 1),
(31131, 1),
(31132, 1),
(31133, 1),
(31134, 1),
(31135, 1),
(31136, 1),
(31137, 1),
(31138, 1),
(31139, 1),
(31140, 1),
(31141, 1),
(31142, 1),
(31143, 1),
(31144, 1),
(31145, 1),
(31146, 1),
(31147, 1),
(31148, 1),
(31149, 1),
(31150, 1),
(31151, 1),
(31152, 1),
(31153, 1),
(31154, 1),
(31155, 1),
(31156, 1),
(31157, 1),
(31158, 1),
(31159, 1),
(31160, 1),
(31161, 1),
(31162, 1),
(31163, 1),
(31164, 1),
(31165, 1),
(31166, 1),
(31167, 1),
(31168, 1),
(31169, 1),
(31170, 1),
(31171, 1),
(31172, 1),
(31173, 1),
(31174, 1),
(31175, 1),
(31176, 1),
(31177, 1),
(31178, 1),
(31179, 1),
(31180, 1),
(31181, 1),
(31182, 1),
(31183, 1),
(31184, 1),
(31185, 1),
(31186, 1),
(31187, 1),
(31188, 1),
(31189, 1),
(31190, 1),
(31191, 1),
(31192, 1),
(31193, 1),
(31194, 1),
(31195, 1),
(31196, 1),
(31197, 1),
(31198, 1),
(31199, 1),
(31200, 1),
(31201, 1),
(31202, 1),
(31203, 1),
(31204, 1),
(31205, 1),
(31206, 1),
(31207, 1),
(31208, 1),
(31209, 1),
(31210, 1),
(31211, 1),
(31212, 1),
(31213, 1),
(31214, 1),
(31215, 1),
(31216, 1),
(31217, 1),
(31218, 1),
(31219, 1),
(31220, 1),
(31221, 1),
(31222, 1),
(31223, 1),
(31224, 1),
(31225, 1),
(31226, 1),
(31227, 1),
(31228, 1),
(31229, 1),
(31230, 1),
(31231, 1),
(31232, 1),
(31233, 1),
(31234, 1),
(31235, 1),
(31236, 1),
(31237, 1),
(31238, 1),
(31239, 1),
(31240, 1),
(31241, 1),
(31242, 1),
(31243, 1),
(31244, 1),
(31245, 1),
(31246, 1),
(31247, 1),
(31248, 1),
(31249, 1),
(31250, 1),
(31251, 1),
(31252, 1),
(31253, 1),
(31254, 1),
(31255, 1),
(31256, 1),
(31257, 1),
(31258, 1),
(31259, 1),
(31260, 1),
(31261, 1),
(31262, 1),
(31263, 1),
(31264, 1),
(31265, 1),
(31266, 1),
(31267, 1),
(31268, 1),
(31269, 1),
(31270, 1),
(31271, 1),
(31272, 1),
(31273, 1),
(31274, 1),
(31275, 1),
(31276, 1),
(31277, 1),
(31278, 1),
(31279, 1),
(31280, 1),
(31281, 1),
(31282, 1),
(31283, 1),
(31284, 1),
(31285, 1),
(31286, 1),
(31287, 1),
(31288, 1),
(31289, 1),
(31290, 1),
(31291, 1),
(31292, 1),
(31293, 1),
(31294, 1),
(31295, 1),
(31296, 1),
(31297, 1),
(31298, 1),
(31299, 1),
(31300, 1),
(31301, 1),
(31302, 1),
(31303, 1),
(31304, 1),
(31305, 1),
(31306, 1),
(31307, 1),
(31308, 1),
(31309, 1),
(31310, 1),
(31311, 1),
(31312, 1),
(31313, 1),
(31314, 1),
(31315, 1),
(31316, 1),
(31317, 1),
(31318, 1),
(31319, 1),
(31320, 1),
(31321, 1),
(31322, 1),
(31323, 1),
(31324, 1),
(31325, 1),
(31326, 1),
(31327, 1),
(31328, 1),
(31329, 1),
(31330, 1),
(31331, 1),
(31332, 1),
(31333, 1),
(31334, 1),
(31335, 1),
(31336, 1),
(31337, 1),
(31338, 1),
(31339, 1),
(31340, 1),
(31341, 1),
(31342, 1),
(31343, 1),
(31344, 1),
(31345, 1),
(31346, 1),
(31347, 1),
(31348, 1),
(31349, 1),
(31350, 1),
(31351, 1),
(31352, 1),
(31353, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(31354, 1),
(31355, 1),
(31356, 1),
(31357, 1),
(31358, 1),
(31359, 1),
(31360, 1),
(31361, 1),
(31362, 1),
(31363, 1),
(31364, 1),
(31365, 1),
(31366, 1),
(31367, 1),
(31368, 1),
(31369, 1),
(31370, 1),
(31371, 1),
(31372, 1),
(31373, 1),
(31374, 1),
(31375, 1),
(31376, 1),
(31377, 1),
(31378, 1),
(31379, 1),
(31380, 1),
(31381, 1),
(31382, 1),
(31383, 1),
(31384, 1),
(31385, 1),
(31386, 1),
(31387, 1),
(31388, 1),
(31389, 1),
(31390, 1),
(31391, 1),
(31392, 1),
(31393, 1),
(31394, 1),
(31395, 1),
(31396, 1),
(31397, 1),
(31398, 1),
(31399, 1),
(31400, 1),
(31401, 1),
(31402, 1),
(31403, 1),
(31404, 1),
(31405, 1),
(31406, 1),
(31407, 1),
(31408, 1),
(31409, 1),
(31410, 1),
(31411, 1),
(31412, 1),
(31413, 1),
(31414, 1),
(31415, 1),
(31416, 1),
(31417, 1),
(31418, 1),
(31419, 1),
(31420, 1),
(31421, 1),
(31422, 1),
(31423, 1),
(31424, 1),
(31425, 1),
(31426, 1),
(31427, 1),
(31428, 1),
(31429, 1),
(31430, 1),
(31431, 1),
(31432, 1),
(31433, 1),
(31434, 1),
(31435, 1),
(31436, 1),
(31437, 1),
(31438, 1),
(31439, 1),
(31440, 1),
(31441, 1),
(31442, 1),
(31443, 1),
(31444, 1),
(31445, 1),
(31446, 1),
(31447, 1),
(31448, 1),
(31449, 1),
(31450, 1),
(31451, 1),
(31452, 1),
(31453, 1),
(31454, 1),
(31455, 1),
(31456, 1),
(31457, 1),
(31458, 1),
(31459, 1),
(31460, 1),
(31461, 1),
(31462, 1),
(31463, 1),
(31464, 1),
(31465, 1),
(31466, 1),
(31467, 1),
(31468, 1),
(31469, 1),
(31470, 1),
(31471, 1),
(31472, 1),
(31473, 1),
(31474, 1),
(31475, 1),
(31476, 1),
(31477, 1),
(31478, 1),
(31479, 1),
(31480, 1),
(31481, 1),
(31482, 1),
(31483, 1),
(31484, 1),
(31485, 1),
(31486, 1),
(31487, 1),
(31488, 1),
(31489, 1),
(31490, 1),
(31491, 1),
(31492, 1),
(31493, 1),
(31494, 1),
(31495, 1),
(31496, 1),
(31497, 1),
(31498, 1),
(31499, 1),
(31500, 1),
(31501, 1),
(31502, 1),
(31503, 1),
(31504, 1),
(31505, 1),
(31506, 1),
(31507, 1),
(31508, 1),
(31509, 1),
(31510, 1),
(31511, 1),
(31512, 1),
(31513, 1),
(31514, 1),
(31515, 1),
(31516, 1),
(31517, 1),
(31518, 1),
(31519, 1),
(31520, 1),
(31521, 1),
(31522, 1),
(31523, 1),
(31524, 1),
(31525, 1),
(31526, 1),
(31527, 1),
(31528, 1),
(31529, 1),
(31530, 1),
(31531, 1),
(31532, 1),
(31533, 1),
(31534, 1),
(31535, 1),
(31536, 1),
(31537, 1),
(31538, 1),
(31539, 1),
(31540, 1),
(31541, 1),
(31542, 1),
(31543, 1),
(31544, 1),
(31545, 1),
(31546, 1),
(31547, 1),
(31548, 1),
(31549, 1),
(31550, 1),
(31551, 1),
(31552, 1),
(31553, 1),
(31554, 1),
(31555, 1),
(31556, 1),
(31557, 1),
(31558, 1),
(31559, 1),
(31560, 1),
(31561, 1),
(31562, 1),
(31563, 1),
(31564, 1),
(31565, 1),
(31566, 1),
(31567, 1),
(31568, 1),
(31569, 1),
(31570, 1),
(31571, 1),
(31572, 1),
(31573, 1),
(31574, 1),
(31575, 1),
(31576, 1),
(31577, 1),
(31578, 1),
(31579, 1),
(31580, 1),
(31581, 1),
(31582, 1),
(31583, 1),
(31584, 1),
(31585, 1),
(31586, 1),
(31587, 1),
(31588, 1),
(31589, 1),
(31590, 1),
(31591, 1),
(31592, 1),
(31593, 1),
(31594, 1),
(31595, 1),
(31596, 1),
(31597, 1),
(31598, 1),
(31599, 1),
(31600, 1),
(31601, 1),
(31602, 1),
(31603, 1),
(31604, 1),
(31605, 1),
(31606, 1),
(31607, 1),
(31608, 1),
(31609, 1),
(31610, 1),
(31611, 1),
(31612, 1),
(31613, 1),
(31614, 1),
(31615, 1),
(31616, 1),
(31617, 1),
(31618, 1),
(31619, 1),
(31620, 1),
(31621, 1),
(31622, 1),
(31623, 1),
(31624, 1),
(31625, 1),
(31626, 1),
(31627, 1),
(31628, 1),
(31629, 1),
(31630, 1),
(31631, 1),
(31632, 1),
(31633, 1),
(31634, 1),
(31635, 1),
(31636, 1),
(31637, 1),
(31638, 1),
(31639, 1),
(31640, 1),
(31641, 1),
(31642, 1),
(31643, 1),
(31644, 1),
(31645, 1),
(31646, 1),
(31647, 1),
(31648, 1),
(31649, 1),
(31650, 1),
(31651, 1),
(31652, 1),
(31653, 1),
(31654, 1),
(31655, 1),
(31656, 1),
(31657, 1),
(31658, 1),
(31659, 1),
(31660, 1),
(31661, 1),
(31662, 1),
(31663, 1),
(31664, 1),
(31665, 1),
(31666, 1),
(31667, 1),
(31668, 1),
(31669, 1),
(31670, 1),
(31671, 1),
(31672, 1),
(31673, 1),
(31674, 1),
(31675, 1),
(31676, 1),
(31677, 1),
(31678, 1),
(31679, 1),
(31680, 1),
(31681, 1),
(31682, 1),
(31683, 1),
(31684, 1),
(31685, 1),
(31686, 1),
(31687, 1),
(31688, 1),
(31689, 1),
(31690, 1),
(31691, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(31692, 1),
(31693, 1),
(31694, 1),
(31695, 1),
(31696, 1),
(31697, 1),
(31698, 1),
(31699, 1),
(31700, 1),
(31701, 1),
(31702, 1),
(31703, 1),
(31704, 1),
(31705, 1),
(31706, 1),
(31707, 1),
(31708, 1),
(31709, 1),
(31710, 1),
(31711, 1),
(31712, 1),
(31713, 1),
(31714, 1),
(31715, 1),
(31716, 1),
(31717, 1),
(31718, 1),
(31719, 1),
(31720, 1),
(31721, 1),
(31722, 1),
(31723, 1),
(31724, 1),
(31725, 1),
(31726, 1),
(31727, 1),
(31728, 1),
(31729, 1),
(31730, 1),
(31731, 1),
(31732, 1),
(31733, 1),
(31734, 1),
(31735, 1),
(31736, 1),
(31737, 1),
(31738, 1),
(31739, 1),
(31740, 1),
(31741, 1),
(31742, 1),
(31743, 1),
(31744, 1),
(31745, 1),
(31746, 1),
(31747, 1),
(31748, 1),
(31749, 1),
(31750, 1),
(31751, 1),
(31752, 1),
(31753, 1),
(31754, 1),
(31755, 1),
(31756, 1),
(31757, 1),
(31758, 1),
(31759, 1),
(31760, 1),
(31761, 1),
(31762, 1),
(31763, 1),
(31764, 1),
(31765, 1),
(31766, 1),
(31767, 1),
(31768, 1),
(31769, 1),
(31770, 1),
(31771, 1),
(31772, 1),
(31773, 1),
(31774, 1),
(31775, 1),
(31776, 1),
(31777, 1),
(31778, 1),
(31779, 1),
(31780, 1),
(31781, 1),
(31782, 1),
(31783, 1),
(31784, 1),
(31785, 1),
(31786, 1),
(31787, 1),
(31788, 1),
(31789, 1),
(31790, 1),
(31791, 1),
(31792, 1),
(31793, 1),
(31794, 1),
(31795, 1),
(31796, 1),
(31797, 1),
(31798, 1),
(31799, 1),
(31800, 1),
(31801, 1),
(31802, 1),
(31803, 1),
(31804, 1),
(31805, 1),
(31806, 1),
(31807, 1),
(31808, 1),
(31809, 1),
(31810, 1),
(31811, 1),
(31812, 1),
(31813, 1),
(31814, 1),
(31815, 1),
(31816, 1),
(31817, 1),
(31818, 1),
(31819, 1),
(31820, 1),
(31821, 1),
(31822, 1),
(31823, 1),
(31824, 1),
(31825, 1),
(31826, 1),
(31827, 1),
(31828, 1),
(31829, 1),
(31830, 1),
(31831, 1),
(31832, 1),
(31833, 1),
(31834, 1),
(31835, 1),
(31836, 1),
(31837, 1),
(31838, 1),
(31839, 1),
(31840, 1),
(31841, 1),
(31842, 1),
(31843, 1),
(31844, 1),
(31845, 1),
(31846, 1),
(31847, 1),
(31848, 1),
(31849, 1),
(31850, 1),
(31851, 1),
(31852, 1),
(31853, 1),
(31854, 1),
(31855, 1),
(31856, 1),
(31857, 1),
(31858, 1),
(31859, 1),
(31860, 1),
(31861, 1),
(31862, 1),
(31863, 1),
(31864, 1),
(31865, 1),
(31866, 1),
(31867, 1),
(31868, 1),
(31869, 1),
(31870, 1),
(31871, 1),
(31872, 1),
(31873, 1),
(31874, 1),
(31875, 1),
(31876, 1),
(31877, 1),
(31878, 1),
(31879, 1),
(31880, 1),
(31881, 1),
(31882, 1),
(31883, 1),
(31884, 1),
(31885, 1),
(31886, 1),
(31887, 1),
(31888, 1),
(31889, 1),
(31890, 1),
(31891, 1),
(31892, 1),
(31893, 1),
(31894, 1),
(31895, 1),
(31896, 1),
(31897, 1),
(31898, 1),
(31899, 1),
(31900, 1),
(31901, 1),
(31902, 1),
(31903, 1),
(31904, 1),
(31905, 1),
(31906, 1),
(31907, 1),
(31908, 1),
(31909, 1),
(31910, 1),
(31911, 1),
(31912, 1),
(31913, 1),
(31914, 1),
(31915, 1),
(31916, 1),
(31917, 1),
(31918, 1),
(31919, 1),
(31920, 1),
(31921, 1),
(31922, 1),
(31923, 1),
(31924, 1),
(31925, 1),
(31926, 1),
(31927, 1),
(31928, 1),
(31929, 1),
(31930, 1),
(31931, 1),
(31932, 1),
(31933, 1),
(31934, 1),
(31935, 1),
(31936, 1),
(31937, 1),
(31938, 1),
(31939, 1),
(31940, 1),
(31941, 1),
(31942, 1),
(31943, 1),
(31944, 1),
(31945, 1),
(31946, 1),
(31947, 1),
(31948, 1),
(31949, 1),
(31950, 1),
(31951, 1),
(31952, 1),
(31953, 1),
(31954, 1),
(31955, 1),
(31956, 1),
(31957, 1),
(31958, 1),
(31959, 1),
(31960, 1),
(31961, 1),
(31962, 1),
(31963, 1),
(31964, 1),
(31965, 1),
(31966, 1),
(31967, 1),
(31968, 1),
(31969, 1),
(31970, 1),
(31971, 1),
(31972, 1),
(31973, 1),
(31974, 1),
(31975, 1),
(31976, 1),
(31977, 1),
(31978, 1),
(31979, 1),
(31980, 1),
(31981, 1),
(31982, 1),
(31983, 1),
(31984, 1),
(31985, 1),
(31986, 1),
(31987, 1),
(31988, 1),
(31989, 1),
(31990, 1),
(31991, 1),
(31992, 1),
(31993, 1),
(31994, 1),
(31995, 1),
(31996, 1),
(31997, 1),
(31998, 1),
(31999, 1),
(32000, 1),
(32001, 1),
(32002, 1),
(32003, 1),
(32004, 1),
(32005, 1),
(32006, 1),
(32007, 1),
(32008, 1),
(32009, 1),
(32010, 1),
(32011, 1),
(32012, 1),
(32013, 1),
(32014, 1),
(32015, 1),
(32016, 1),
(32017, 1),
(32018, 1),
(32019, 1),
(32020, 1),
(32021, 1),
(32022, 1),
(32023, 1),
(32024, 1),
(32025, 1),
(32026, 1),
(32027, 1),
(32028, 1),
(32029, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(32030, 1),
(32031, 1),
(32032, 1),
(32033, 1),
(32034, 1),
(32035, 1),
(32036, 1),
(32037, 1),
(32038, 1),
(32039, 1),
(32040, 1),
(32041, 1),
(32042, 1),
(32043, 1),
(32044, 1),
(32045, 1),
(32046, 1),
(32047, 1),
(32048, 1),
(32049, 1),
(32050, 1),
(32051, 1),
(32052, 1),
(32053, 1),
(32054, 1),
(32055, 1),
(32056, 1),
(32057, 1),
(32058, 1),
(32059, 1),
(32060, 1),
(32061, 1),
(32062, 1),
(32063, 1),
(32064, 1),
(32065, 1),
(32066, 1),
(32067, 1),
(32068, 1),
(32069, 1),
(32070, 1),
(32071, 1),
(32072, 1),
(32073, 1),
(32074, 1),
(32075, 1),
(32076, 1),
(32077, 1),
(32078, 1),
(32079, 1),
(32080, 1),
(32081, 1),
(32082, 1),
(32083, 1),
(32084, 1),
(32085, 1),
(32086, 1),
(32087, 1),
(32088, 1),
(32089, 1),
(32090, 1),
(32091, 1),
(32092, 1),
(32093, 1),
(32094, 1),
(32095, 1),
(32096, 1),
(32097, 1),
(32098, 1),
(32099, 1),
(32100, 1),
(32101, 1),
(32102, 1),
(32103, 1),
(32104, 1),
(32105, 1),
(32106, 1),
(32107, 1),
(32108, 1),
(32109, 1),
(32110, 1),
(32111, 1),
(32112, 1),
(32113, 1),
(32114, 1),
(32115, 1),
(32116, 1),
(32117, 1),
(32118, 1),
(32119, 1),
(32120, 1),
(32121, 1),
(32122, 1),
(32123, 1),
(32124, 1),
(32125, 1),
(32126, 1),
(32127, 1),
(32128, 1),
(32129, 1),
(32130, 1),
(32131, 1),
(32132, 1),
(32133, 1),
(32134, 1),
(32135, 1),
(32136, 1),
(32137, 1),
(32138, 1),
(32139, 1),
(32140, 1),
(32141, 1),
(32142, 1),
(32143, 1),
(32144, 1),
(32145, 1),
(32146, 1),
(32147, 1),
(32148, 1),
(32149, 1),
(32150, 1),
(32151, 1),
(32152, 1),
(32153, 1),
(32154, 1),
(32155, 1),
(32156, 1),
(32157, 1),
(32158, 1),
(32159, 1),
(32160, 1),
(32161, 1),
(32162, 1),
(32163, 1),
(32164, 1),
(32165, 1),
(32166, 1),
(32167, 1),
(32168, 1),
(32169, 1),
(32170, 1),
(32171, 1),
(32172, 1),
(32173, 1),
(32174, 1),
(32175, 1),
(32176, 1),
(32177, 1),
(32178, 1),
(32179, 1),
(32180, 1),
(32181, 1),
(32182, 1),
(32183, 1),
(32184, 1),
(32185, 1),
(32186, 1),
(32187, 1),
(32188, 1),
(32189, 1),
(32190, 1),
(32191, 1),
(32192, 1),
(32193, 1),
(32194, 1),
(32195, 1),
(32196, 1),
(32197, 1),
(32198, 1),
(32199, 1),
(32200, 1),
(32201, 1),
(32202, 1),
(32203, 1),
(32204, 1),
(32205, 1),
(32206, 1),
(32207, 1),
(32208, 1),
(32209, 1),
(32210, 1),
(32211, 1),
(32212, 1),
(32213, 1),
(32214, 1),
(32215, 1),
(32216, 1),
(32217, 1),
(32218, 1),
(32219, 1),
(32220, 1),
(32221, 1),
(32222, 1),
(32223, 1),
(32224, 1),
(32225, 1),
(32226, 1),
(32227, 1),
(32228, 1),
(32229, 1),
(32230, 1),
(32231, 1),
(32232, 1),
(32233, 1),
(32234, 1),
(32235, 1),
(32236, 1),
(32237, 1),
(32238, 1),
(32239, 1),
(32240, 1),
(32241, 1),
(32242, 1),
(32243, 1),
(32244, 1),
(32245, 1),
(32246, 1),
(32247, 1),
(32248, 1),
(32249, 1),
(32250, 1),
(32251, 1),
(32252, 1),
(32253, 1),
(32254, 1),
(32255, 1),
(32256, 1),
(32257, 1),
(32258, 1),
(32259, 1),
(32260, 1),
(32261, 1),
(32262, 1),
(32263, 1),
(32264, 1),
(32265, 1),
(32266, 1),
(32267, 1),
(32268, 1),
(32269, 1),
(32270, 1),
(32271, 1),
(32272, 1),
(32273, 1),
(32274, 1),
(32275, 1),
(32276, 1),
(32277, 1),
(32278, 1),
(32279, 1),
(32280, 1),
(32281, 1),
(32282, 1),
(32283, 1),
(32284, 1),
(32285, 1),
(32286, 1),
(32287, 1),
(32288, 1),
(32289, 1),
(32290, 1),
(32291, 1),
(32292, 1),
(32293, 1),
(32294, 1),
(32295, 1),
(32296, 1),
(32297, 1),
(32298, 1),
(32299, 1),
(32300, 1),
(32301, 1),
(32302, 1),
(32303, 1),
(32304, 1),
(32305, 1),
(32306, 1),
(32307, 1),
(32308, 1),
(32309, 1),
(32310, 1),
(32311, 1),
(32312, 1),
(32313, 1),
(32314, 1),
(32315, 1),
(32316, 1),
(32317, 1),
(32318, 1),
(32319, 1),
(32320, 1),
(32321, 1),
(32322, 1),
(32323, 1),
(32324, 1),
(32325, 1),
(32326, 1),
(32327, 1),
(32328, 1),
(32329, 1),
(32330, 1),
(32331, 1),
(32332, 1),
(32333, 1),
(32334, 1),
(32335, 1),
(32336, 1),
(32337, 1),
(32338, 1),
(32339, 1),
(32340, 1),
(32341, 1),
(32342, 1),
(32343, 1),
(32344, 1),
(32345, 1),
(32346, 1),
(32347, 1),
(32348, 1),
(32349, 1),
(32350, 1),
(32351, 1),
(32352, 1),
(32353, 1),
(32354, 1),
(32355, 1),
(32356, 1),
(32357, 1),
(32358, 1),
(32359, 1),
(32360, 1),
(32361, 1),
(32362, 1),
(32363, 1),
(32364, 1),
(32365, 1),
(32366, 1),
(32367, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(32368, 1),
(32369, 1),
(32370, 1),
(32371, 1),
(32372, 1),
(32373, 1),
(32374, 1),
(32375, 1),
(32376, 1),
(32377, 1),
(32378, 1),
(32379, 1),
(32380, 1),
(32381, 1),
(32382, 1),
(32383, 1),
(32384, 1),
(32385, 1),
(32386, 1),
(32387, 1),
(32388, 1),
(32389, 1),
(32390, 1),
(32391, 1),
(32392, 1),
(32393, 1),
(32394, 1),
(32395, 1),
(32396, 1),
(32397, 1),
(32398, 1),
(32399, 1),
(32400, 1),
(32401, 1),
(32402, 1),
(32403, 1),
(32404, 1),
(32405, 1),
(32406, 1),
(32407, 1),
(32408, 1),
(32409, 1),
(32410, 1),
(32411, 1),
(32412, 1),
(32413, 1),
(32414, 1),
(32415, 1),
(32416, 1),
(32417, 1),
(32418, 1),
(32419, 1),
(32420, 1),
(32421, 1),
(32422, 1),
(32423, 1),
(32424, 1),
(32425, 1),
(32426, 1),
(32427, 1),
(32428, 1),
(32429, 1),
(32430, 1),
(32431, 1),
(32432, 1),
(32433, 1),
(32434, 1),
(32435, 1),
(32436, 1),
(32437, 1),
(32438, 1),
(32439, 1),
(32440, 1),
(32441, 1),
(32442, 1),
(32443, 1),
(32444, 1),
(32445, 1),
(32446, 1),
(32447, 1),
(32448, 1),
(32449, 1),
(32450, 1),
(32451, 1),
(32452, 1),
(32453, 1),
(32454, 1),
(32455, 1),
(32456, 1),
(32457, 1),
(32458, 1),
(32459, 1),
(32460, 1),
(32461, 1),
(32462, 1),
(32463, 1),
(32464, 1),
(32465, 1),
(32466, 1),
(32467, 1),
(32468, 1),
(32469, 1),
(32470, 1),
(32471, 1),
(32472, 1),
(32473, 1),
(32474, 1),
(32475, 1),
(32476, 1),
(32477, 1),
(32478, 1),
(32479, 1),
(32480, 1),
(32481, 1),
(32482, 1),
(32483, 1),
(32484, 1),
(32485, 1),
(32486, 1),
(32487, 1),
(32488, 1),
(32489, 1),
(32490, 1),
(32491, 1),
(32492, 1),
(32493, 1),
(32494, 1),
(32495, 1),
(32496, 1),
(32497, 1),
(32498, 1),
(32499, 1),
(32500, 1),
(32501, 1),
(32502, 1),
(32503, 1),
(32504, 1),
(32505, 1),
(32506, 1),
(32507, 1),
(32508, 1),
(32509, 1),
(32510, 1),
(32511, 1),
(32512, 1),
(32513, 1),
(32514, 1),
(32515, 1),
(32516, 1),
(32517, 1),
(32518, 1),
(32519, 1),
(32520, 1),
(32521, 1),
(32522, 1),
(32523, 1),
(32524, 1),
(32525, 1),
(32526, 1),
(32527, 1),
(32528, 1),
(32529, 1),
(32530, 1),
(32531, 1),
(32532, 1),
(32533, 1),
(32534, 1),
(32535, 1),
(32536, 1),
(32537, 1),
(32538, 1),
(32539, 1),
(32540, 1),
(32541, 1),
(32542, 1),
(32543, 1),
(32544, 1),
(32545, 1),
(32546, 1),
(32547, 1),
(32548, 1),
(32549, 1),
(32550, 1),
(32551, 1),
(32552, 1),
(32553, 1),
(32554, 1),
(32555, 1),
(32556, 1),
(32557, 1),
(32558, 1),
(32559, 1),
(32560, 1),
(32561, 1),
(32562, 1),
(32563, 1),
(32564, 1),
(32565, 1),
(32566, 1),
(32567, 1),
(32568, 1),
(32569, 1),
(32570, 1),
(32571, 1),
(32572, 1),
(32573, 1),
(32574, 1),
(32575, 1),
(32576, 1),
(32577, 1),
(32578, 1),
(32579, 1),
(32580, 1),
(32581, 1),
(32582, 1),
(32583, 1),
(32584, 1),
(32585, 1),
(32586, 1),
(32587, 1),
(32588, 1),
(32589, 1),
(32590, 1),
(32591, 1),
(32592, 1),
(32593, 1),
(32594, 1),
(32595, 1),
(32596, 1),
(32597, 1),
(32598, 1),
(32599, 1),
(32600, 1),
(32601, 1),
(32602, 1),
(32603, 1),
(32604, 1),
(32605, 1),
(32606, 1),
(32607, 1),
(32608, 1),
(32609, 1),
(32610, 1),
(32611, 1),
(32612, 1),
(32613, 1),
(32614, 1),
(32615, 1),
(32616, 1),
(32617, 1),
(32618, 1),
(32619, 1),
(32620, 1),
(32621, 1),
(32622, 1),
(32623, 1),
(32624, 1),
(32625, 1),
(32626, 1),
(32627, 1),
(32628, 1),
(32629, 1),
(32630, 1),
(32631, 1),
(32632, 1),
(32633, 1),
(32634, 1),
(32635, 1),
(32636, 1),
(32637, 1),
(32638, 1),
(32639, 1),
(32640, 1),
(32641, 1),
(32642, 1),
(32643, 1),
(32644, 1),
(32645, 1),
(32646, 1),
(32647, 1),
(32648, 1),
(32649, 1),
(32650, 1),
(32651, 1),
(32652, 1),
(32653, 1),
(32654, 1),
(32655, 1),
(32656, 1),
(32657, 1),
(32658, 1),
(32659, 1),
(32660, 1),
(32661, 1),
(32662, 1),
(32663, 1),
(32664, 1),
(32665, 1),
(32666, 1),
(32667, 1),
(32668, 1),
(32669, 1),
(32670, 1),
(32671, 1),
(32672, 1),
(32673, 1),
(32674, 1),
(32675, 1),
(32676, 1),
(32677, 1),
(32678, 1),
(32679, 1),
(32680, 1),
(32681, 1),
(32682, 1),
(32683, 1),
(32684, 1),
(32685, 1),
(32686, 1),
(32687, 1),
(32688, 1),
(32689, 1),
(32690, 1),
(32691, 1),
(32692, 1),
(32693, 1),
(32694, 1),
(32695, 1),
(32696, 1),
(32697, 1),
(32698, 1),
(32699, 1),
(32700, 1),
(32701, 1),
(32702, 1),
(32703, 1),
(32704, 1),
(32705, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(32706, 1),
(32707, 1),
(32708, 1),
(32709, 1),
(32710, 1),
(32711, 1),
(32712, 1),
(32713, 1),
(32714, 1),
(32715, 1),
(32716, 1),
(32717, 1),
(32718, 1),
(32719, 1),
(32720, 1),
(32721, 1),
(32722, 1),
(32723, 1),
(32724, 1),
(32725, 1),
(32726, 1),
(32727, 1),
(32728, 1),
(32729, 1),
(32730, 1),
(32731, 1),
(32732, 1),
(32733, 1),
(32734, 1),
(32735, 1),
(32736, 1),
(32737, 1),
(32738, 1),
(32739, 1),
(32740, 1),
(32741, 1),
(32742, 1),
(32743, 1),
(32744, 1),
(32745, 1),
(32746, 1),
(32747, 1),
(32748, 1),
(32749, 1),
(32750, 1),
(32751, 1),
(32752, 1),
(32753, 1),
(32754, 1),
(32755, 1),
(32756, 1),
(32757, 1),
(32758, 1),
(32759, 1),
(32760, 1),
(32761, 1),
(32762, 1),
(32763, 1),
(32764, 1),
(32765, 1),
(32766, 1),
(32767, 1),
(32768, 1),
(32769, 1),
(32770, 1),
(32771, 1),
(32772, 1),
(32773, 1),
(32774, 1),
(32775, 1),
(32776, 1),
(32777, 1),
(32778, 1),
(32779, 1),
(32780, 1),
(32781, 1),
(32782, 1),
(32783, 1),
(32784, 1),
(32785, 1),
(32786, 1),
(32787, 1),
(32788, 1),
(32789, 1),
(32790, 1),
(32791, 1),
(32792, 1),
(32793, 1),
(32794, 1),
(32795, 1),
(32796, 1),
(32797, 1),
(32798, 1),
(32799, 1),
(32800, 1),
(32801, 1),
(32802, 1),
(32803, 1),
(32804, 1),
(32805, 1),
(32806, 1),
(32807, 1),
(32808, 1),
(32809, 1),
(32810, 1),
(32811, 1),
(32812, 1),
(32813, 1),
(32814, 1),
(32815, 1),
(32816, 1),
(32817, 1),
(32818, 1),
(32819, 1),
(32820, 1),
(32821, 1),
(32822, 1),
(32823, 1),
(32824, 1),
(32825, 1),
(32826, 1),
(32827, 1),
(32828, 1),
(32829, 1),
(32830, 1),
(32831, 1),
(32832, 1),
(32833, 1),
(32834, 1),
(32835, 1),
(32836, 1),
(32837, 1),
(32838, 1),
(32839, 1),
(32840, 1),
(32841, 1),
(32842, 1),
(32843, 1),
(32844, 1),
(32845, 1),
(32846, 1),
(32847, 1),
(32848, 1),
(32849, 1),
(32850, 1),
(32851, 1),
(32852, 1),
(32853, 1),
(32854, 1),
(32855, 1),
(32856, 1),
(32857, 1),
(32858, 1),
(32859, 1),
(32860, 1),
(32861, 1),
(32862, 1),
(32863, 1),
(32864, 1),
(32865, 1),
(32866, 1),
(32867, 1),
(32868, 1),
(32869, 1),
(32870, 1),
(32871, 1),
(32872, 1),
(32873, 1),
(32874, 1),
(32875, 1),
(32876, 1),
(32877, 1),
(32878, 1),
(32879, 1),
(32880, 1),
(32881, 1),
(32882, 1),
(32883, 1),
(32884, 1),
(32885, 1),
(32886, 1),
(32887, 1),
(32888, 1),
(32889, 1),
(32890, 1),
(32891, 1),
(32892, 1),
(32893, 1),
(32894, 1),
(32895, 1),
(32896, 1),
(32897, 1),
(32898, 1),
(32899, 1),
(32900, 1),
(32901, 1),
(32902, 1),
(32903, 1),
(32904, 1),
(32905, 1),
(32906, 1),
(32907, 1),
(32908, 1),
(32909, 1),
(32910, 1),
(32911, 1),
(32912, 1),
(32913, 1),
(32914, 1),
(32915, 1),
(32916, 1),
(32917, 1),
(32918, 1),
(32919, 1),
(32920, 1),
(32921, 1),
(32922, 1),
(32923, 1),
(32924, 1),
(32925, 1),
(32926, 1),
(32927, 1),
(32928, 1),
(32929, 1),
(32930, 1),
(32931, 1),
(32932, 1),
(32933, 1),
(32934, 1),
(32935, 1),
(32936, 1),
(32937, 1),
(32938, 1),
(32939, 1),
(32940, 1),
(32941, 1),
(32942, 1),
(32943, 1),
(32944, 1),
(32945, 1),
(32946, 1),
(32947, 1),
(32948, 1),
(32949, 1),
(32950, 1),
(32951, 1),
(32952, 1),
(32953, 1),
(32954, 1),
(32955, 1),
(32956, 1),
(32957, 1),
(32958, 1),
(32959, 1),
(32960, 1),
(32961, 1),
(32962, 1),
(32963, 1),
(32964, 1),
(32965, 1),
(32966, 1),
(32967, 1),
(32968, 1),
(32969, 1),
(32970, 1),
(32971, 1),
(32972, 1),
(32973, 1),
(32974, 1),
(32975, 1),
(32976, 1),
(32977, 1),
(32978, 1),
(32979, 1),
(32980, 1),
(32981, 1),
(32982, 1),
(32983, 1),
(32984, 1),
(32985, 1),
(32986, 1),
(32987, 1),
(32988, 1),
(32989, 1),
(32990, 1),
(32991, 1),
(32992, 1),
(32993, 1),
(32994, 1),
(32995, 1),
(32996, 1),
(32997, 1),
(32998, 1),
(32999, 1),
(33000, 1),
(33001, 1),
(33002, 1),
(33003, 1),
(33004, 1),
(33005, 1),
(33006, 1),
(33007, 1),
(33008, 1),
(33009, 1),
(33010, 1),
(33011, 1),
(33012, 1),
(33013, 1),
(33014, 1),
(33015, 1),
(33016, 1),
(33017, 1),
(33018, 1),
(33019, 1),
(33020, 1),
(33021, 1),
(33022, 1),
(33023, 1),
(33024, 1),
(33025, 1),
(33026, 1),
(33027, 1),
(33028, 1),
(33029, 1),
(33030, 1),
(33031, 1),
(33032, 1),
(33033, 1),
(33034, 1),
(33035, 1),
(33036, 1),
(33037, 1),
(33038, 1),
(33039, 1),
(33040, 1),
(33041, 1),
(33042, 1),
(33043, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(33044, 1),
(33045, 1),
(33046, 1),
(33047, 1),
(33048, 1),
(33049, 1),
(33050, 1),
(33051, 1),
(33052, 1),
(33053, 1),
(33054, 1),
(33055, 1),
(33056, 1),
(33057, 1),
(33058, 1),
(33059, 1),
(33060, 1),
(33061, 1),
(33062, 1),
(33063, 1),
(33064, 1),
(33065, 1),
(33066, 1),
(33067, 1),
(33068, 1),
(33069, 1),
(33070, 1),
(33071, 1),
(33072, 1),
(33073, 1),
(33074, 1),
(33075, 1),
(33076, 1),
(33077, 1),
(33078, 1),
(33079, 1),
(33080, 1),
(33081, 1),
(33082, 1),
(33083, 1),
(33084, 1),
(33085, 1),
(33086, 1),
(33087, 1),
(33088, 1),
(33089, 1),
(33090, 1),
(33091, 1),
(33092, 1),
(33093, 1),
(33094, 1),
(33095, 1),
(33096, 1),
(33097, 1),
(33098, 1),
(33099, 1),
(33100, 1),
(33101, 1),
(33102, 1),
(33103, 1),
(33104, 1),
(33105, 1),
(33106, 1),
(33107, 1),
(33108, 1),
(33109, 1),
(33110, 1),
(33111, 1),
(33112, 1),
(33113, 1),
(33114, 1),
(33115, 1),
(33116, 1),
(33117, 1),
(33118, 1),
(33119, 1),
(33120, 1),
(33121, 1),
(33122, 1),
(33123, 1),
(33124, 1),
(33125, 1),
(33126, 1),
(33127, 1),
(33128, 1),
(33129, 1),
(33130, 1),
(33131, 1),
(33132, 1),
(33133, 1),
(33134, 1),
(33135, 1),
(33136, 1),
(33137, 1),
(33138, 1),
(33139, 1),
(33140, 1),
(33141, 1),
(33142, 1),
(33143, 1),
(33144, 1),
(33145, 1),
(33146, 1),
(33147, 1),
(33148, 1),
(33149, 1),
(33150, 1),
(33151, 1),
(33152, 1),
(33153, 1),
(33154, 1),
(33155, 1),
(33156, 1),
(33157, 1),
(33158, 1),
(33159, 1),
(33160, 1),
(33161, 1),
(33162, 1),
(33163, 1),
(33164, 1),
(33165, 1),
(33166, 1),
(33167, 1),
(33168, 1),
(33169, 1),
(33170, 1),
(33171, 1),
(33172, 1),
(33173, 1),
(33174, 1),
(33175, 1),
(33176, 1),
(33177, 1),
(33178, 1),
(33179, 1),
(33180, 1),
(33181, 1),
(33182, 1),
(33183, 1),
(33184, 1),
(33185, 1),
(33186, 1),
(33187, 1),
(33188, 1),
(33189, 1),
(33190, 1),
(33191, 1),
(33192, 1),
(33193, 1),
(33194, 1),
(33195, 1),
(33196, 1),
(33197, 1),
(33198, 1),
(33199, 1),
(33200, 1),
(33201, 1),
(33202, 1),
(33203, 1),
(33204, 1),
(33205, 1),
(33206, 1),
(33207, 1),
(33208, 1),
(33209, 1),
(33210, 1),
(33211, 1),
(33212, 1),
(33213, 1),
(33214, 1),
(33215, 1),
(33216, 1),
(33217, 1),
(33218, 1),
(33219, 1),
(33220, 1),
(33221, 1),
(33222, 1),
(33223, 1),
(33224, 1),
(33225, 1),
(33226, 1),
(33227, 1),
(33228, 1),
(33229, 1),
(33230, 1),
(33231, 1),
(33232, 1),
(33233, 1),
(33234, 1),
(33235, 1),
(33236, 1),
(33237, 1),
(33238, 1),
(33239, 1),
(33240, 1),
(33241, 1),
(33242, 1),
(33243, 1),
(33244, 1),
(33245, 1),
(33246, 1),
(33247, 1),
(33248, 1),
(33249, 1),
(33250, 1),
(33251, 1),
(33252, 1),
(33253, 1),
(33254, 1),
(33255, 1),
(33256, 1),
(33257, 1),
(33258, 1),
(33259, 1),
(33260, 1),
(33261, 1),
(33262, 1),
(33263, 1),
(33264, 1),
(33265, 1),
(33266, 1),
(33267, 1),
(33268, 1),
(33269, 1),
(33270, 1),
(33271, 1),
(33272, 1),
(33273, 1),
(33274, 1),
(33275, 1),
(33276, 1),
(33277, 1),
(33278, 1),
(33279, 1),
(33280, 1),
(33281, 1),
(33282, 1),
(33283, 1),
(33284, 1),
(33285, 1),
(33286, 1),
(33287, 1),
(33288, 1),
(33289, 1),
(33290, 1),
(33291, 1),
(33292, 1),
(33293, 1),
(33294, 1),
(33295, 1),
(33296, 1),
(33297, 1),
(33298, 1),
(33299, 1),
(33300, 1),
(33301, 1),
(33302, 1),
(33303, 1),
(33304, 1),
(33305, 1),
(33306, 1),
(33307, 1),
(33308, 1),
(33309, 1),
(33310, 1),
(33311, 1),
(33312, 1),
(33313, 1),
(33314, 1),
(33315, 1),
(33316, 1),
(33317, 1),
(33318, 1),
(33319, 1),
(33320, 1),
(33321, 1),
(33322, 1),
(33323, 1),
(33324, 1),
(33325, 1),
(33326, 1),
(33327, 1),
(33328, 1),
(33329, 1),
(33330, 1),
(33331, 1),
(33332, 1),
(33333, 1),
(33334, 1),
(33335, 1),
(33336, 1),
(33337, 1),
(33338, 1),
(33339, 1),
(33340, 1),
(33341, 1),
(33342, 1),
(33343, 1),
(33344, 1),
(33345, 1),
(33346, 1),
(33347, 1),
(33348, 1),
(33349, 1),
(33350, 1),
(33351, 1),
(33352, 1),
(33353, 1),
(33354, 1),
(33355, 1),
(33356, 1),
(33357, 1),
(33358, 1),
(33359, 1),
(33360, 1),
(33361, 1),
(33362, 1),
(33363, 1),
(33364, 1),
(33365, 1),
(33366, 1),
(33367, 1),
(33368, 1),
(33369, 1),
(33370, 1),
(33371, 1),
(33372, 1),
(33373, 1),
(33374, 1),
(33375, 1),
(33376, 1),
(33377, 1),
(33378, 1),
(33379, 1),
(33380, 1),
(33381, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(33382, 1),
(33383, 1),
(33384, 1),
(33385, 1),
(33386, 1),
(33387, 1),
(33388, 1),
(33389, 1),
(33390, 1),
(33391, 1),
(33392, 1),
(33393, 1),
(33394, 1),
(33395, 1),
(33396, 1),
(33397, 1),
(33398, 1),
(33399, 1),
(33400, 1),
(33401, 1),
(33402, 1),
(33403, 1),
(33404, 1),
(33405, 1),
(33406, 1),
(33407, 1),
(33408, 1),
(33409, 1),
(33410, 1),
(33411, 1),
(33412, 1),
(33413, 1),
(33414, 1),
(33415, 1),
(33416, 1),
(33417, 1),
(33418, 1),
(33419, 1),
(33420, 1),
(33421, 1),
(33422, 1),
(33423, 1),
(33424, 1),
(33425, 1),
(33426, 1),
(33427, 1),
(33428, 1),
(33429, 1),
(33430, 1),
(33431, 1),
(33432, 1),
(33433, 1),
(33434, 1),
(33435, 1),
(33436, 1),
(33437, 1),
(33438, 1),
(33439, 1),
(33440, 1),
(33441, 1),
(33442, 1),
(33443, 1),
(33444, 1),
(33445, 1),
(33446, 1),
(33447, 1),
(33448, 1),
(33449, 1),
(33450, 1),
(33451, 1),
(33452, 1),
(33453, 1),
(33454, 1),
(33455, 1),
(33456, 1),
(33457, 1),
(33458, 1),
(33459, 1),
(33460, 1),
(33461, 1),
(33462, 1),
(33463, 1),
(33464, 1),
(33465, 1),
(33466, 1),
(33467, 1),
(33468, 1),
(33469, 1),
(33470, 1),
(33471, 1),
(33472, 1),
(33473, 1),
(33474, 1),
(33475, 1),
(33476, 1),
(33477, 1),
(33478, 1),
(33479, 1),
(33480, 1),
(33481, 1),
(33482, 1),
(33483, 1),
(33484, 1),
(33485, 1),
(33486, 1),
(33487, 1),
(33488, 1),
(33489, 1),
(33490, 1),
(33491, 1),
(33492, 1),
(33493, 1),
(33494, 1),
(33495, 1),
(33496, 1),
(33497, 1),
(33498, 1),
(33499, 1),
(33500, 1),
(33501, 1),
(33502, 1),
(33503, 1),
(33504, 1),
(33505, 1),
(33506, 1),
(33507, 1),
(33508, 1),
(33509, 1),
(33510, 1),
(33511, 1),
(33512, 1),
(33513, 1),
(33514, 1),
(33515, 1),
(33516, 1),
(33517, 1),
(33518, 1),
(33519, 1),
(33520, 1),
(33521, 1),
(33522, 1),
(33523, 1),
(33524, 1),
(33525, 1),
(33526, 1),
(33527, 1),
(33528, 1),
(33529, 1),
(33530, 1),
(33531, 1),
(33532, 1),
(33533, 1),
(33534, 1),
(33535, 1),
(33536, 1),
(33537, 1),
(33538, 1),
(33539, 1),
(33540, 1),
(33541, 1),
(33542, 1),
(33543, 1),
(33544, 1),
(33545, 1),
(33546, 1),
(33547, 1),
(33548, 1),
(33549, 1),
(33550, 1),
(33551, 1),
(33552, 1),
(33553, 1),
(33554, 1),
(33555, 1),
(33556, 1),
(33557, 1),
(33558, 1),
(33559, 1),
(33560, 1),
(33561, 1),
(33562, 1),
(33563, 1),
(33564, 1),
(33565, 1),
(33566, 1),
(33567, 1),
(33568, 1),
(33569, 1),
(33570, 1),
(33571, 1),
(33572, 1),
(33573, 1),
(33574, 1),
(33575, 1),
(33576, 1),
(33577, 1),
(33578, 1),
(33579, 1),
(33580, 1),
(33581, 1),
(33582, 1),
(33583, 1),
(33584, 1),
(33585, 1),
(33586, 1),
(33587, 1),
(33588, 1),
(33589, 1),
(33590, 1),
(33591, 1),
(33592, 1),
(33593, 1),
(33594, 1),
(33595, 1),
(33596, 1),
(33597, 1),
(33598, 1),
(33599, 1),
(33600, 1),
(33601, 1),
(33602, 1),
(33603, 1),
(33604, 1),
(33605, 1),
(33606, 1),
(33607, 1),
(33608, 1),
(33609, 1),
(33610, 1),
(33611, 1),
(33612, 1),
(33613, 1),
(33614, 1),
(33615, 1),
(33616, 1),
(33617, 1),
(33618, 1),
(33619, 1),
(33620, 1),
(33621, 1),
(33622, 1),
(33623, 1),
(33624, 1),
(33625, 1),
(33626, 1),
(33627, 1),
(33628, 1),
(33629, 1),
(33630, 1),
(33631, 1),
(33632, 1),
(33633, 1),
(33634, 1),
(33635, 1),
(33636, 1),
(33637, 1),
(33638, 1),
(33639, 1),
(33640, 1),
(33641, 1),
(33642, 1),
(33643, 1),
(33644, 1),
(33645, 1),
(33646, 1),
(33647, 1),
(33648, 1),
(33649, 1),
(33650, 1),
(33651, 1),
(33652, 1),
(33653, 1),
(33654, 1),
(33655, 1),
(33656, 1),
(33657, 1),
(33658, 1),
(33659, 1),
(33660, 1),
(33661, 1),
(33662, 1),
(33663, 1),
(33664, 1),
(33665, 1),
(33666, 1),
(33667, 1),
(33668, 1),
(33669, 1),
(33670, 1),
(33671, 1),
(33672, 1),
(33673, 1),
(33674, 1),
(33675, 1),
(33676, 1),
(33677, 1),
(33678, 1),
(33679, 1),
(33680, 1),
(33681, 1),
(33682, 1),
(33683, 1),
(33684, 1),
(33685, 1),
(33686, 1),
(33687, 1),
(33688, 1),
(33689, 1),
(33690, 1),
(33691, 1),
(33692, 1),
(33693, 1),
(33694, 1),
(33695, 1),
(33696, 1),
(33697, 1),
(33698, 1),
(33699, 1),
(33700, 1),
(33701, 1),
(33702, 1),
(33703, 1),
(33704, 1),
(33705, 1),
(33706, 1),
(33707, 1),
(33708, 1),
(33709, 1),
(33710, 1),
(33711, 1),
(33712, 1),
(33713, 1),
(33714, 1),
(33715, 1),
(33716, 1),
(33717, 1),
(33718, 1),
(33719, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(33720, 1),
(33721, 1),
(33722, 1),
(33723, 1),
(33724, 1),
(33725, 1),
(33726, 1),
(33727, 1),
(33728, 1),
(33729, 1),
(33730, 1),
(33731, 1),
(33732, 1),
(33733, 1),
(33734, 1),
(33735, 1),
(33736, 1),
(33737, 1),
(33738, 1),
(33739, 1),
(33740, 1),
(33741, 1),
(33742, 1),
(33743, 1),
(33744, 1),
(33745, 1),
(33746, 1),
(33747, 1),
(33748, 1),
(33749, 1),
(33750, 1),
(33751, 1),
(33752, 1),
(33753, 1),
(33754, 1),
(33755, 1),
(33756, 1),
(33757, 1),
(33758, 1),
(33759, 1),
(33760, 1),
(33761, 1),
(33762, 1),
(33763, 1),
(33764, 1),
(33765, 1),
(33766, 1),
(33767, 1),
(33768, 1),
(33769, 1),
(33770, 1),
(33771, 1),
(33772, 1),
(33773, 1),
(33774, 1),
(33775, 1),
(33776, 1),
(33777, 1),
(33778, 1),
(33779, 1),
(33780, 1),
(33781, 1),
(33782, 1),
(33783, 1),
(33784, 1),
(33785, 1),
(33786, 1),
(33787, 1),
(33788, 1),
(33789, 1),
(33790, 1),
(33791, 1),
(33792, 1),
(33793, 1),
(33794, 1),
(33795, 1),
(33796, 1),
(33797, 1),
(33798, 1),
(33799, 1),
(33800, 1),
(33801, 1),
(33802, 1),
(33803, 1),
(33804, 1),
(33805, 1),
(33806, 1),
(33807, 1),
(33808, 1),
(33809, 1),
(33810, 1),
(33811, 1),
(33812, 1),
(33813, 1),
(33814, 1),
(33815, 1),
(33816, 1),
(33817, 1),
(33818, 1),
(33819, 1),
(33820, 1),
(33821, 1),
(33822, 1),
(33823, 1),
(33824, 1),
(33825, 1),
(33826, 1),
(33827, 1),
(33828, 1),
(33829, 1),
(33830, 1),
(33831, 1),
(33832, 1),
(33833, 1),
(33834, 1),
(33835, 1),
(33836, 1),
(33837, 1),
(33838, 1),
(33839, 1),
(33840, 1),
(33841, 1),
(33842, 1),
(33843, 1),
(33844, 1),
(33845, 1),
(33846, 1),
(33847, 1),
(33848, 1),
(33849, 1),
(33850, 1),
(33851, 1),
(33852, 1),
(33853, 1),
(33854, 1),
(33855, 1),
(33856, 1),
(33857, 1),
(33858, 1),
(33859, 1),
(33860, 1),
(33861, 1),
(33862, 1),
(33863, 1),
(33864, 1),
(33865, 1),
(33866, 1),
(33867, 1),
(33868, 1),
(33869, 1),
(33870, 1),
(33871, 1),
(33872, 1),
(33873, 1),
(33874, 1),
(33875, 1),
(33876, 1),
(33877, 1),
(33878, 1),
(33879, 1),
(33880, 1),
(33881, 1),
(33882, 1),
(33883, 1),
(33884, 1),
(33885, 1),
(33886, 1),
(33887, 1),
(33888, 1),
(33889, 1),
(33890, 1),
(33891, 1),
(33892, 1),
(33893, 1),
(33894, 1),
(33895, 1),
(33896, 1),
(33897, 1),
(33898, 1),
(33899, 1),
(33900, 1),
(33901, 1),
(33902, 1),
(33903, 1),
(33904, 1),
(33905, 1),
(33906, 1),
(33907, 1),
(33908, 1),
(33909, 1),
(33910, 1),
(33911, 1),
(33912, 1),
(33913, 1),
(33914, 1),
(33915, 1),
(33916, 1),
(33917, 1),
(33918, 1),
(33919, 1),
(33920, 1),
(33921, 1),
(33922, 1),
(33923, 1),
(33924, 1),
(33925, 1),
(33926, 1),
(33927, 1),
(33928, 1),
(33929, 1),
(33930, 1),
(33931, 1),
(33932, 1),
(33933, 1),
(33934, 1),
(33935, 1),
(33936, 1),
(33937, 1),
(33938, 1),
(33939, 1),
(33940, 1),
(33941, 1),
(33942, 1),
(33943, 1),
(33944, 1),
(33945, 1),
(33946, 1),
(33947, 1),
(33948, 1),
(33949, 1),
(33950, 1),
(33951, 1),
(33952, 1),
(33953, 1),
(33954, 1),
(33955, 1),
(33956, 1),
(33957, 1),
(33958, 1),
(33959, 1),
(33960, 1),
(33961, 1),
(33962, 1),
(33963, 1),
(33964, 1),
(33965, 1),
(33966, 1),
(33967, 1),
(33968, 1),
(33969, 1),
(33970, 1),
(33971, 1),
(33972, 1),
(33973, 1),
(33974, 1),
(33975, 1),
(33976, 1),
(33977, 1),
(33978, 1),
(33979, 1),
(33980, 1),
(33981, 1),
(33982, 1),
(33983, 1),
(33984, 1),
(33985, 1),
(33986, 1),
(33987, 1),
(33988, 1),
(33989, 1),
(33990, 1),
(33991, 1),
(33992, 1),
(33993, 1),
(33994, 1),
(33995, 1),
(33996, 1),
(33997, 1),
(33998, 1),
(33999, 1),
(34000, 1),
(34001, 1),
(34002, 1),
(34003, 1),
(34004, 1),
(34005, 1),
(34006, 1),
(34007, 1),
(34008, 1),
(34009, 1),
(34010, 1),
(34011, 1),
(34012, 1),
(34013, 1),
(34014, 1),
(34015, 1),
(34016, 1),
(34017, 1),
(34018, 1),
(34019, 1),
(34020, 1),
(34021, 1),
(34022, 1),
(34023, 1),
(34024, 1),
(34025, 1),
(34026, 1),
(34027, 1),
(34028, 1),
(34029, 1),
(34030, 1),
(34031, 1),
(34032, 1),
(34033, 1),
(34034, 1),
(34035, 1),
(34036, 1),
(34037, 1),
(34038, 1),
(34039, 1),
(34040, 1),
(34041, 1),
(34042, 1),
(34043, 1),
(34044, 1),
(34045, 1),
(34046, 1),
(34047, 1),
(34048, 1),
(34049, 1),
(34050, 1),
(34051, 1),
(34052, 1),
(34053, 1),
(34054, 1),
(34055, 1),
(34056, 1),
(34057, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(34058, 1),
(34059, 1),
(34060, 1),
(34061, 1),
(34062, 1),
(34063, 1),
(34064, 1),
(34065, 1),
(34066, 1),
(34067, 1),
(34068, 1),
(34069, 1),
(34070, 1),
(34071, 1),
(34072, 1),
(34073, 1),
(34074, 1),
(34075, 1),
(34076, 1),
(34077, 1),
(34078, 1),
(34079, 1),
(34080, 1),
(34081, 1),
(34082, 1),
(34083, 1),
(34084, 1),
(34085, 1),
(34086, 1),
(34087, 1),
(34088, 1),
(34089, 1),
(34090, 1),
(34091, 1),
(34092, 1),
(34093, 1),
(34094, 1),
(34095, 1),
(34096, 1),
(34097, 1),
(34098, 1),
(34099, 1),
(34100, 1),
(34101, 1),
(34102, 1),
(34103, 1),
(34104, 1),
(34105, 1),
(34106, 1),
(34107, 1),
(34108, 1),
(34109, 1),
(34110, 1),
(34111, 1),
(34112, 1),
(34113, 1),
(34114, 1),
(34115, 1),
(34116, 1),
(34117, 1),
(34118, 1),
(34119, 1),
(34120, 1),
(34121, 1),
(34122, 1),
(34123, 1),
(34124, 1),
(34125, 1),
(34126, 1),
(34127, 1),
(34128, 1),
(34129, 1),
(34130, 1),
(34131, 1),
(34132, 1),
(34133, 1),
(34134, 1),
(34135, 1),
(34136, 1),
(34137, 1),
(34138, 1),
(34139, 1),
(34140, 1),
(34141, 1),
(34142, 1),
(34143, 1),
(34144, 1),
(34145, 1),
(34146, 1),
(34147, 1),
(34148, 1),
(34149, 1),
(34150, 1),
(34151, 1),
(34152, 1),
(34153, 1),
(34154, 1),
(34155, 1),
(34156, 1),
(34157, 1),
(34158, 1),
(34159, 1),
(34160, 1),
(34161, 1),
(34162, 1),
(34163, 1),
(34164, 1),
(34165, 1),
(34166, 1),
(34167, 1),
(34168, 1),
(34169, 1),
(34170, 1),
(34171, 1),
(34172, 1),
(34173, 1),
(34174, 1),
(34175, 1),
(34176, 1),
(34177, 1),
(34178, 1),
(34179, 1),
(34180, 1),
(34181, 1),
(34182, 1),
(34183, 1),
(34184, 1),
(34185, 1),
(34186, 1),
(34187, 1),
(34188, 1),
(34189, 1),
(34190, 1),
(34191, 1),
(34192, 1),
(34193, 1),
(34194, 1),
(34195, 1),
(34196, 1),
(34197, 1),
(34198, 1),
(34199, 1),
(34200, 1),
(34201, 1),
(34202, 1),
(34203, 1),
(34204, 1),
(34205, 1),
(34206, 1),
(34207, 1),
(34208, 1),
(34209, 1),
(34210, 1),
(34211, 1),
(34212, 1),
(34213, 1),
(34214, 1),
(34215, 1),
(34216, 1),
(34217, 1),
(34218, 1),
(34219, 1),
(34220, 1),
(34221, 1),
(34222, 1),
(34223, 1),
(34224, 1),
(34225, 1),
(34226, 1),
(34227, 1),
(34228, 1),
(34229, 1),
(34230, 1),
(34231, 1),
(34232, 1),
(34233, 1),
(34234, 1),
(34235, 1),
(34236, 1),
(34237, 1),
(34238, 1),
(34239, 1),
(34240, 1),
(34241, 1),
(34242, 1),
(34243, 1),
(34244, 1),
(34245, 1),
(34246, 1),
(34247, 1),
(34248, 1),
(34249, 1),
(34250, 1),
(34251, 1),
(34252, 1),
(34253, 1),
(34254, 1),
(34255, 1),
(34256, 1),
(34257, 1),
(34258, 1),
(34259, 1),
(34260, 1),
(34261, 1),
(34262, 1),
(34263, 1),
(34264, 1),
(34265, 1),
(34266, 1),
(34267, 1),
(34268, 1),
(34269, 1),
(34270, 1),
(34271, 1),
(34272, 1),
(34273, 1),
(34274, 1),
(34275, 1),
(34276, 1),
(34277, 1),
(34278, 1),
(34279, 1),
(34280, 1),
(34281, 1),
(34282, 1),
(34283, 1),
(34284, 1),
(34285, 1),
(34286, 1),
(34287, 1),
(34288, 1),
(34289, 1),
(34290, 1),
(34291, 1),
(34292, 1),
(34293, 1),
(34294, 1),
(34295, 1),
(34296, 1),
(34297, 1),
(34298, 1),
(34299, 1),
(34300, 1),
(34301, 1),
(34302, 1),
(34303, 1),
(34304, 1),
(34305, 1),
(34306, 1),
(34307, 1),
(34308, 1),
(34309, 1),
(34310, 1),
(34311, 1),
(34312, 1),
(34313, 1),
(34314, 1),
(34315, 1),
(34316, 1),
(34317, 1),
(34318, 1),
(34319, 1),
(34320, 1),
(34321, 1),
(34322, 1),
(34323, 1),
(34324, 1),
(34325, 1),
(34326, 1),
(34327, 1),
(34328, 1),
(34329, 1),
(34330, 1),
(34331, 1),
(34332, 1),
(34333, 1),
(34334, 1),
(34335, 1),
(34336, 1),
(34337, 1),
(34338, 1),
(34339, 1),
(34340, 1),
(34341, 1),
(34342, 1),
(34343, 1),
(34344, 1),
(34345, 1),
(34346, 1),
(34347, 1),
(34348, 1),
(34349, 1),
(34350, 1),
(34351, 1),
(34352, 1),
(34353, 1),
(34354, 1),
(34355, 1),
(34356, 1),
(34357, 1),
(34358, 1),
(34359, 1),
(34360, 1),
(34361, 1),
(34362, 1),
(34363, 1),
(34364, 1),
(34365, 1),
(34366, 1),
(34367, 1),
(34368, 1),
(34369, 1),
(34370, 1),
(34371, 1),
(34372, 1),
(34373, 1),
(34374, 1),
(34375, 1),
(34376, 1),
(34377, 1),
(34378, 1),
(34379, 1),
(34380, 1),
(34381, 1),
(34382, 1),
(34383, 1),
(34384, 1),
(34385, 1),
(34386, 1),
(34387, 1),
(34388, 1),
(34389, 1),
(34390, 1),
(34391, 1),
(34392, 1),
(34393, 1),
(34394, 1),
(34395, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(34396, 1),
(34397, 1),
(34398, 1),
(34399, 1),
(34400, 1),
(34401, 1),
(34402, 1),
(34403, 1),
(34404, 1),
(34405, 1),
(34406, 1),
(34407, 1),
(34408, 1),
(34409, 1),
(34410, 1),
(34411, 1),
(34412, 1),
(34413, 1),
(34414, 1),
(34415, 1),
(34416, 1),
(34417, 1),
(34418, 1),
(34419, 1),
(34420, 1),
(34421, 1),
(34422, 1),
(34423, 1),
(34424, 1),
(34425, 1),
(34426, 1),
(34427, 1),
(34428, 1),
(34429, 1),
(34430, 1),
(34431, 1),
(34432, 1),
(34433, 1),
(34434, 1),
(34435, 1),
(34436, 1),
(34437, 1),
(34438, 1),
(34439, 1),
(34440, 1),
(34441, 1),
(34442, 1),
(34443, 1),
(34444, 1),
(34445, 1),
(34446, 1),
(34447, 1),
(34448, 1),
(34449, 1),
(34450, 1),
(34451, 1),
(34452, 1),
(34453, 1),
(34454, 1),
(34455, 1),
(34456, 1),
(34457, 1),
(34458, 1),
(34459, 1),
(34460, 1),
(34461, 1),
(34462, 1),
(34463, 1),
(34464, 1),
(34465, 1),
(34466, 1),
(34467, 1),
(34468, 1),
(34469, 1),
(34470, 1),
(34471, 1),
(34472, 1),
(34473, 1),
(34474, 1),
(34475, 1),
(34476, 1),
(34477, 1),
(34478, 1),
(34479, 1),
(34480, 1),
(34481, 1),
(34482, 1),
(34483, 1),
(34484, 1),
(34485, 1),
(34486, 1),
(34487, 1),
(34488, 1),
(34489, 1),
(34490, 1),
(34491, 1),
(34492, 1),
(34493, 1),
(34494, 1),
(34495, 1),
(34496, 1),
(34497, 1),
(34498, 1),
(34499, 1),
(34500, 1),
(34501, 1),
(34502, 1),
(34503, 1),
(34504, 1),
(34505, 1),
(34506, 1),
(34507, 1),
(34508, 1),
(34509, 1),
(34510, 1),
(34511, 1),
(34512, 1),
(34513, 1),
(34514, 1),
(34515, 1),
(34516, 1),
(34517, 1),
(34518, 1),
(34519, 1),
(34520, 1),
(34521, 1),
(34522, 1),
(34523, 1),
(34524, 1),
(34525, 1),
(34526, 1),
(34527, 1),
(34528, 1),
(34529, 1),
(34530, 1),
(34531, 1),
(34532, 1),
(34533, 1),
(34534, 1),
(34535, 1),
(34536, 1),
(34537, 1),
(34538, 1),
(34539, 1),
(34540, 1),
(34541, 1),
(34542, 1),
(34543, 1),
(34544, 1),
(34545, 1),
(34546, 1),
(34547, 1),
(34548, 1),
(34549, 1),
(34550, 1),
(34551, 1),
(34552, 1),
(34553, 1),
(34554, 1),
(34555, 1),
(34556, 1),
(34557, 1),
(34558, 1),
(34559, 1),
(34560, 1),
(34561, 1),
(34562, 1),
(34563, 1),
(34564, 1),
(34565, 1),
(34566, 1),
(34567, 1),
(34568, 1),
(34569, 1),
(34570, 1),
(34571, 1),
(34572, 1),
(34573, 1),
(34574, 1),
(34575, 1),
(34576, 1),
(34577, 1),
(34578, 1),
(34579, 1),
(34580, 1),
(34581, 1),
(34582, 1),
(34583, 1),
(34584, 1),
(34585, 1),
(34586, 1),
(34587, 1),
(34588, 1),
(34589, 1),
(34590, 1),
(34591, 1),
(34592, 1),
(34593, 1),
(34594, 1),
(34595, 1),
(34596, 1),
(34597, 1),
(34598, 1),
(34599, 1),
(34600, 1),
(34601, 1),
(34602, 1),
(34603, 1),
(34604, 1),
(34605, 1),
(34606, 1),
(34607, 1),
(34608, 1),
(34609, 1),
(34610, 1),
(34611, 1),
(34612, 1),
(34613, 1),
(34614, 1),
(34615, 1),
(34616, 1),
(34617, 1),
(34618, 1),
(34619, 1),
(34620, 1),
(34621, 1),
(34622, 1),
(34623, 1),
(34624, 1),
(34625, 1),
(34626, 1),
(34627, 1),
(34628, 1),
(34629, 1),
(34630, 1),
(34631, 1),
(34632, 1),
(34633, 1),
(34634, 1),
(34635, 1),
(34636, 1),
(34637, 1),
(34638, 1),
(34639, 1),
(34640, 1),
(34641, 1),
(34642, 1),
(34643, 1),
(34644, 1),
(34645, 1),
(34646, 1),
(34647, 1),
(34648, 1),
(34649, 1),
(34650, 1),
(34651, 1),
(34652, 1),
(34653, 1),
(34654, 1),
(34655, 1),
(34656, 1),
(34657, 1),
(34658, 1),
(34659, 1),
(34660, 1),
(34661, 1),
(34662, 1),
(34663, 1),
(34664, 1),
(34665, 1),
(34666, 1),
(34667, 1),
(34668, 1),
(34669, 1),
(34670, 1),
(34671, 1),
(34672, 1),
(34673, 1),
(34674, 1),
(34675, 1),
(34676, 1),
(34677, 1),
(34678, 1),
(34679, 1),
(34680, 1),
(34681, 1),
(34682, 1),
(34683, 1),
(34684, 1),
(34685, 1),
(34686, 1),
(34687, 1),
(34688, 1),
(34689, 1),
(34690, 1),
(34691, 1),
(34692, 1),
(34693, 1),
(34694, 1),
(34695, 1),
(34696, 1),
(34697, 1),
(34698, 1),
(34699, 1),
(34700, 1),
(34701, 1),
(34702, 1),
(34703, 1),
(34704, 1),
(34705, 1),
(34706, 1),
(34707, 1),
(34708, 1),
(34709, 1),
(34710, 1),
(34711, 1),
(34712, 1),
(34713, 1),
(34714, 1),
(34715, 1),
(34716, 1),
(34717, 1),
(34718, 1),
(34719, 1),
(34720, 1),
(34721, 1),
(34722, 1),
(34723, 1),
(34724, 1),
(34725, 1),
(34726, 1),
(34727, 1),
(34728, 1),
(34729, 1),
(34730, 1),
(34731, 1),
(34732, 1),
(34733, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(34734, 1),
(34735, 1),
(34736, 1),
(34737, 1),
(34738, 1),
(34739, 1),
(34740, 1),
(34741, 1),
(34742, 1),
(34743, 1),
(34744, 1),
(34745, 1),
(34746, 1),
(34747, 1),
(34748, 1),
(34749, 1),
(34750, 1),
(34751, 1),
(34752, 1),
(34753, 1),
(34754, 1),
(34755, 1),
(34756, 1),
(34757, 1),
(34758, 1),
(34759, 1),
(34760, 1),
(34761, 1),
(34762, 1),
(34763, 1),
(34764, 1),
(34765, 1),
(34766, 1),
(34767, 1),
(34768, 1),
(34769, 1),
(34770, 1),
(34771, 1),
(34772, 1),
(34773, 1),
(34774, 1),
(34775, 1),
(34776, 1),
(34777, 1),
(34778, 1),
(34779, 1),
(34780, 1),
(34781, 1),
(34782, 1),
(34783, 1),
(34784, 1),
(34785, 1),
(34786, 1),
(34787, 1),
(34788, 1),
(34789, 1),
(34790, 1),
(34791, 1),
(34792, 1),
(34793, 1),
(34794, 1),
(34795, 1),
(34796, 1),
(34797, 1),
(34798, 1),
(34799, 1),
(34800, 1),
(34801, 1),
(34802, 1),
(34803, 1),
(34804, 1),
(34805, 1),
(34806, 1),
(34807, 1),
(34808, 1),
(34809, 1),
(34810, 1),
(34811, 1),
(34812, 1),
(34813, 1),
(34814, 1),
(34815, 1),
(34816, 1),
(34817, 1),
(34818, 1),
(34819, 1),
(34820, 1),
(34821, 1),
(34822, 1),
(34823, 1),
(34824, 1),
(34825, 1),
(34826, 1),
(34827, 1),
(34828, 1),
(34829, 1),
(34830, 1),
(34831, 1),
(34832, 1),
(34833, 1),
(34834, 1),
(34835, 1),
(34836, 1),
(34837, 1),
(34838, 1),
(34839, 1),
(34840, 1),
(34841, 1),
(34842, 1),
(34843, 1),
(34844, 1),
(34845, 1),
(34846, 1),
(34847, 1),
(34848, 1),
(34849, 1),
(34850, 1),
(34851, 1),
(34852, 1),
(34853, 1),
(34854, 1),
(34855, 1),
(34856, 1),
(34857, 1),
(34858, 1),
(34859, 1),
(34860, 1),
(34861, 1),
(34862, 1),
(34863, 1),
(34864, 1),
(34865, 1),
(34866, 1),
(34867, 1),
(34868, 1),
(34869, 1),
(34870, 1),
(34871, 1),
(34872, 1),
(34873, 1),
(34874, 1),
(34875, 1),
(34876, 1),
(34877, 1),
(34878, 1),
(34879, 1),
(34880, 1),
(34881, 1),
(34882, 1),
(34883, 1),
(34884, 1),
(34885, 1),
(34886, 1),
(34887, 1),
(34888, 1),
(34889, 1),
(34890, 1),
(34891, 1),
(34892, 1),
(34893, 1),
(34894, 1),
(34895, 1),
(34896, 1),
(34897, 1),
(34898, 1),
(34899, 1),
(34900, 1),
(34901, 1),
(34902, 1),
(34903, 1),
(34904, 1),
(34905, 1),
(34906, 1),
(34907, 1),
(34908, 1),
(34909, 1),
(34910, 1),
(34911, 1),
(34912, 1),
(34913, 1),
(34914, 1),
(34915, 1),
(34916, 1),
(34917, 1),
(34918, 1),
(34919, 1),
(34920, 1),
(34921, 1),
(34922, 1),
(34923, 1),
(34924, 1),
(34925, 1),
(34926, 1),
(34927, 1),
(34928, 1),
(34929, 1),
(34930, 1),
(34931, 1),
(34932, 1),
(34933, 1),
(34934, 1),
(34935, 1),
(34936, 1),
(34937, 1),
(34938, 1),
(34939, 1),
(34940, 1),
(34941, 1),
(34942, 1),
(34943, 1),
(34944, 1),
(34945, 1),
(34946, 1),
(34947, 1),
(34948, 1),
(34949, 1),
(34950, 1),
(34951, 1),
(34952, 1),
(34953, 1),
(34954, 1),
(34955, 1),
(34956, 1),
(34957, 1),
(34958, 1),
(34959, 1),
(34960, 1),
(34961, 1),
(34962, 1),
(34963, 1),
(34964, 1),
(34965, 1),
(34966, 1),
(34967, 1),
(34968, 1),
(34969, 1),
(34970, 1),
(34971, 1),
(34972, 1),
(34973, 1),
(34974, 1),
(34975, 1),
(34976, 1),
(34977, 1),
(34978, 1),
(34979, 1),
(34980, 1),
(34981, 1),
(34982, 1),
(34983, 1),
(34984, 1),
(34985, 1),
(34986, 1),
(34987, 1),
(34988, 1),
(34989, 1),
(34990, 1),
(34991, 1),
(34992, 1),
(34993, 1),
(34994, 1),
(34995, 1),
(34996, 1),
(34997, 1),
(34998, 1),
(34999, 1),
(35000, 1),
(35001, 1),
(35002, 1),
(35003, 1),
(35004, 1),
(35005, 1),
(35006, 1),
(35007, 1),
(35008, 1),
(35009, 1),
(35010, 1),
(35011, 1),
(35012, 1),
(35013, 1),
(35014, 1),
(35015, 1),
(35016, 1),
(35017, 1),
(35018, 1),
(35019, 1),
(35020, 1),
(35021, 1),
(35022, 1),
(35023, 1),
(35024, 1),
(35025, 1),
(35026, 1),
(35027, 1),
(35028, 1),
(35029, 1),
(35030, 1),
(35031, 1),
(35032, 1),
(35033, 1),
(35034, 1),
(35035, 1),
(35036, 1),
(35037, 1),
(35038, 1),
(35039, 1),
(35040, 1),
(35041, 1),
(35042, 1),
(35043, 1),
(35044, 1),
(35045, 1),
(35046, 1),
(35047, 1),
(35048, 1),
(35049, 1),
(35050, 1),
(35051, 1),
(35052, 1),
(35053, 1),
(35054, 1),
(35055, 1),
(35056, 1),
(35057, 1),
(35058, 1),
(35059, 1),
(35060, 1),
(35061, 1),
(35062, 1),
(35063, 1),
(35064, 1),
(35065, 1),
(35066, 1),
(35067, 1),
(35068, 1),
(35069, 1),
(35070, 1),
(35071, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(35072, 1),
(35073, 1),
(35074, 1),
(35075, 1),
(35076, 1),
(35077, 1),
(35078, 1),
(35079, 1),
(35080, 1),
(35081, 1),
(35082, 1),
(35083, 1),
(35084, 1),
(35085, 1),
(35086, 1),
(35087, 1),
(35088, 1),
(35089, 1),
(35090, 1),
(35091, 1),
(35092, 1),
(35093, 1),
(35094, 1),
(35095, 1),
(35096, 1),
(35097, 1),
(35098, 1),
(35099, 1),
(35100, 1),
(35101, 1),
(35102, 1),
(35103, 1),
(35104, 1),
(35105, 1),
(35106, 1),
(35107, 1),
(35108, 1),
(35109, 1),
(35110, 1),
(35111, 1),
(35112, 1),
(35113, 1),
(35114, 1),
(35115, 1),
(35116, 1),
(35117, 1),
(35118, 1),
(35119, 1),
(35120, 1),
(35121, 1),
(35122, 1),
(35123, 1),
(35124, 1),
(35125, 1),
(35126, 1),
(35127, 1),
(35128, 1),
(35129, 1),
(35130, 1),
(35131, 1),
(35132, 1),
(35133, 1),
(35134, 1),
(35135, 1),
(35136, 1),
(35137, 1),
(35138, 1),
(35139, 1),
(35140, 1),
(35141, 1),
(35142, 1),
(35143, 1),
(35144, 1),
(35145, 1),
(35146, 1),
(35147, 1),
(35148, 1),
(35149, 1),
(35150, 1),
(35151, 1),
(35152, 1),
(35153, 1),
(35154, 1),
(35155, 1),
(35156, 1),
(35157, 1),
(35158, 1),
(35159, 1),
(35160, 1),
(35161, 1),
(35162, 1),
(35163, 1),
(35164, 1),
(35165, 1),
(35166, 1),
(35167, 1),
(35168, 1),
(35169, 1),
(35170, 1),
(35171, 1),
(35172, 1),
(35173, 1),
(35174, 1),
(35175, 1),
(35176, 1),
(35177, 1),
(35178, 1),
(35179, 1),
(35180, 1),
(35181, 1),
(35182, 1),
(35183, 1),
(35184, 1),
(35185, 1),
(35186, 1),
(35187, 1),
(35188, 1),
(35189, 1),
(35190, 1),
(35191, 1),
(35192, 1),
(35193, 1),
(35194, 1),
(35195, 1),
(35196, 1),
(35197, 1),
(35198, 1),
(35199, 1),
(35200, 1),
(35201, 1),
(35202, 1),
(35203, 1),
(35204, 1),
(35205, 1),
(35206, 1),
(35207, 1),
(35208, 1),
(35209, 1),
(35210, 1),
(35211, 1),
(35212, 1),
(35213, 1),
(35214, 1),
(35215, 1),
(35216, 1),
(35217, 1),
(35218, 1),
(35219, 1),
(35220, 1),
(35221, 1),
(35222, 1),
(35223, 1),
(35224, 1),
(35225, 1),
(35226, 1),
(35227, 1),
(35228, 1),
(35229, 1),
(35230, 1),
(35231, 1),
(35232, 1),
(35233, 1),
(35234, 1),
(35235, 1),
(35236, 1),
(35237, 1),
(35238, 1),
(35239, 1),
(35240, 1),
(35241, 1),
(35242, 1),
(35243, 1),
(35244, 1),
(35245, 1),
(35246, 1),
(35247, 1),
(35248, 1),
(35249, 1),
(35250, 1),
(35251, 1),
(35252, 1),
(35253, 1),
(35254, 1),
(35255, 1),
(35256, 1),
(35257, 1),
(35258, 1),
(35259, 1),
(35260, 1),
(35261, 1),
(35262, 1),
(35263, 1),
(35264, 1),
(35265, 1),
(35266, 1),
(35267, 1),
(35268, 1),
(35269, 1),
(35270, 1),
(35271, 1),
(35272, 1),
(35273, 1),
(35274, 1),
(35275, 1),
(35276, 1),
(35277, 1),
(35278, 1),
(35279, 1),
(35280, 1),
(35281, 1),
(35282, 1),
(35283, 1),
(35284, 1),
(35285, 1),
(35286, 1),
(35287, 1),
(35288, 1),
(35289, 1),
(35290, 1),
(35291, 1),
(35292, 1),
(35293, 1),
(35294, 1),
(35295, 1),
(35296, 1),
(35297, 1),
(35298, 1),
(35299, 1),
(35300, 1),
(35301, 1),
(35302, 1),
(35303, 1),
(35304, 1),
(35305, 1),
(35306, 1),
(35307, 1),
(35308, 1),
(35309, 1),
(35310, 1),
(35311, 1),
(35312, 1),
(35313, 1),
(35314, 1),
(35315, 1),
(35316, 1),
(35317, 1),
(35318, 1),
(35319, 1),
(35320, 1),
(35321, 1),
(35322, 1),
(35323, 1),
(35324, 1),
(35325, 1),
(35326, 1),
(35327, 1),
(35328, 1),
(35329, 1),
(35330, 1),
(35331, 1),
(35332, 1),
(35333, 1),
(35334, 1),
(35335, 1),
(35336, 1),
(35337, 1),
(35338, 1),
(35339, 1),
(35340, 1),
(35341, 1),
(35342, 1),
(35343, 1),
(35344, 1),
(35345, 1),
(35346, 1),
(35347, 1),
(35348, 1),
(35349, 1),
(35350, 1),
(35351, 1),
(35352, 1),
(35353, 1),
(35354, 1),
(35355, 1),
(35356, 1),
(35357, 1),
(35358, 1),
(35359, 1),
(35360, 1),
(35361, 1),
(35362, 1),
(35363, 1),
(35364, 1),
(35365, 1),
(35366, 1),
(35367, 1),
(35368, 1),
(35369, 1),
(35370, 1),
(35371, 1),
(35372, 1),
(35373, 1),
(35374, 1),
(35375, 1),
(35376, 1),
(35377, 1),
(35378, 1),
(35379, 1),
(35380, 1),
(35381, 1),
(35382, 1),
(35383, 1),
(35384, 1),
(35385, 1),
(35386, 1),
(35387, 1),
(35388, 1),
(35389, 1),
(35390, 1),
(35391, 1),
(35392, 1),
(35393, 1),
(35394, 1),
(35395, 1),
(35396, 1),
(35397, 1),
(35398, 1),
(35399, 1),
(35400, 1),
(35401, 1),
(35402, 1),
(35403, 1),
(35404, 1),
(35405, 1),
(35406, 1),
(35407, 1),
(35408, 1),
(35409, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(35410, 1),
(35411, 1),
(35412, 1),
(35413, 1),
(35414, 1),
(35415, 1),
(35416, 1),
(35417, 1),
(35418, 1),
(35419, 1),
(35420, 1),
(35421, 1),
(35422, 1),
(35423, 1),
(35424, 1),
(35425, 1),
(35426, 1),
(35427, 1),
(35428, 1),
(35429, 1),
(35430, 1),
(35431, 1),
(35432, 1),
(35433, 1),
(35434, 1),
(35435, 1),
(35436, 1),
(35437, 1),
(35438, 1),
(35439, 1),
(35440, 1),
(35441, 1),
(35442, 1),
(35443, 1),
(35444, 1),
(35445, 1),
(35446, 1),
(35447, 1),
(35448, 1),
(35449, 1),
(35450, 1),
(35451, 1),
(35452, 1),
(35453, 1),
(35454, 1),
(35455, 1),
(35456, 1),
(35457, 1),
(35458, 1),
(35459, 1),
(35460, 1),
(35461, 1),
(35462, 1),
(35463, 1),
(35464, 1),
(35465, 1),
(35466, 1),
(35467, 1),
(35468, 1),
(35469, 1),
(35470, 1),
(35471, 1),
(35472, 1),
(35473, 1),
(35474, 1),
(35475, 1),
(35476, 1),
(35477, 1),
(35478, 1),
(35479, 1),
(35480, 1),
(35481, 1),
(35482, 1),
(35483, 1),
(35484, 1),
(35485, 1),
(35486, 1),
(35487, 1),
(35488, 1),
(35489, 1),
(35490, 1),
(35491, 1),
(35492, 1),
(35493, 1),
(35494, 1),
(35495, 1),
(35496, 1),
(35497, 1),
(35498, 1),
(35499, 1),
(35500, 1),
(35501, 1),
(35502, 1),
(35503, 1),
(35504, 1),
(35505, 1),
(35506, 1),
(35507, 1),
(35508, 1),
(35509, 1),
(35510, 1),
(35511, 1),
(35512, 1),
(35513, 1),
(35514, 1),
(35515, 1),
(35516, 1),
(35517, 1),
(35518, 1),
(35519, 1),
(35520, 1),
(35521, 1),
(35522, 1),
(35523, 1),
(35524, 1),
(35525, 1),
(35526, 1),
(35527, 1),
(35528, 1),
(35529, 1),
(35530, 1),
(35531, 1),
(35532, 1),
(35533, 1),
(35534, 1),
(35535, 1),
(35536, 1),
(35537, 1),
(35538, 1),
(35539, 1),
(35540, 1),
(35541, 1),
(35542, 1),
(35543, 1),
(35544, 1),
(35545, 1),
(35546, 1),
(35547, 1),
(35548, 1),
(35549, 1),
(35550, 1),
(35551, 1),
(35552, 1),
(35553, 1),
(35554, 1),
(35555, 1),
(35556, 1),
(35557, 1),
(35558, 1),
(35559, 1),
(35560, 1),
(35561, 1),
(35562, 1),
(35563, 1),
(35564, 1),
(35565, 1),
(35566, 1),
(35567, 1),
(35568, 1),
(35569, 1),
(35570, 1),
(35571, 1),
(35572, 1),
(35573, 1),
(35574, 1),
(35575, 1),
(35576, 1),
(35577, 1),
(35578, 1),
(35579, 1),
(35580, 1),
(35581, 1),
(35582, 1),
(35583, 1),
(35584, 1),
(35585, 1),
(35586, 1),
(35587, 1),
(35588, 1),
(35589, 1),
(35590, 1),
(35591, 1),
(35592, 1),
(35593, 1),
(35594, 1),
(35595, 1),
(35596, 1),
(35597, 1),
(35598, 1),
(35599, 1),
(35600, 1),
(35601, 1),
(35602, 1),
(35603, 1),
(35604, 1),
(35605, 1),
(35606, 1),
(35607, 1),
(35608, 1),
(35609, 1),
(35610, 1),
(35611, 1),
(35612, 1),
(35613, 1),
(35614, 1),
(35615, 1),
(35616, 1),
(35617, 1),
(35618, 1),
(35619, 1),
(35620, 1),
(35621, 1),
(35622, 1),
(35623, 1),
(35624, 1),
(35625, 1),
(35626, 1),
(35627, 1),
(35628, 1),
(35629, 1),
(35630, 1),
(35631, 1),
(35632, 1),
(35633, 1),
(35634, 1),
(35635, 1),
(35636, 1),
(35637, 1),
(35638, 1),
(35639, 1),
(35640, 1),
(35641, 1),
(35642, 1),
(35643, 1),
(35644, 1),
(35645, 1),
(35646, 1),
(35647, 1),
(35648, 1),
(35649, 1),
(35650, 1),
(35651, 1),
(35652, 1),
(35653, 1),
(35654, 1),
(35655, 1),
(35656, 1),
(35657, 1),
(35658, 1),
(35659, 1),
(35660, 1),
(35661, 1),
(35662, 1),
(35663, 1),
(35664, 1),
(35665, 1),
(35666, 1),
(35667, 1),
(35668, 1),
(35669, 1),
(35670, 1),
(35671, 1),
(35672, 1),
(35673, 1),
(35674, 1),
(35675, 1),
(35676, 1),
(35677, 1),
(35678, 1),
(35679, 1),
(35680, 1),
(35681, 1),
(35682, 1),
(35683, 1),
(35684, 1),
(35685, 1),
(35686, 1),
(35687, 1),
(35688, 1),
(35689, 1),
(35690, 1),
(35691, 1),
(35692, 1),
(35693, 1),
(35694, 1),
(35695, 1),
(35696, 1),
(35697, 1),
(35698, 1),
(35699, 1),
(35700, 1),
(35701, 1),
(35702, 1),
(35703, 1),
(35704, 1),
(35705, 1),
(35706, 1),
(35707, 1),
(35708, 1),
(35709, 1),
(35710, 1),
(35711, 1),
(35712, 1),
(35713, 1),
(35714, 1),
(35715, 1),
(35716, 1),
(35717, 1),
(35718, 1),
(35719, 1),
(35720, 1),
(35721, 1),
(35722, 1),
(35723, 1),
(35724, 1),
(35725, 1),
(35726, 1),
(35727, 1),
(35728, 1),
(35729, 1),
(35730, 1),
(35731, 1),
(35732, 1),
(35733, 1),
(35734, 1),
(35735, 1),
(35736, 1),
(35737, 1),
(35738, 1),
(35739, 1),
(35740, 1),
(35741, 1),
(35742, 1),
(35743, 1),
(35744, 1),
(35745, 1),
(35746, 1),
(35747, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(35748, 1),
(35749, 1),
(35750, 1),
(35751, 1),
(35752, 1),
(35753, 1),
(35754, 1),
(35755, 1),
(35756, 1),
(35757, 1),
(35758, 1),
(35759, 1),
(35760, 1),
(35761, 1),
(35762, 1),
(35763, 1),
(35764, 1),
(35765, 1),
(35766, 1),
(35767, 1),
(35768, 1),
(35769, 1),
(35770, 1),
(35771, 1),
(35772, 1),
(35773, 1),
(35774, 1),
(35775, 1),
(35776, 1),
(35777, 1),
(35778, 1),
(35779, 1),
(35780, 1),
(35781, 1),
(35782, 1),
(35783, 1),
(35784, 1),
(35785, 1),
(35786, 1),
(35787, 1),
(35788, 1),
(35789, 1),
(35790, 1),
(35791, 1),
(35792, 1),
(35793, 1),
(35794, 1),
(35795, 1),
(35796, 1),
(35797, 1),
(35798, 1),
(35799, 1),
(35800, 1),
(35801, 1),
(35802, 1),
(35803, 1),
(35804, 1),
(35805, 1),
(35806, 1),
(35807, 1),
(35808, 1),
(35809, 1),
(35810, 1),
(35811, 1),
(35812, 1),
(35813, 1),
(35814, 1),
(35815, 1),
(35816, 1),
(35817, 1),
(35818, 1),
(35819, 1),
(35820, 1),
(35821, 1),
(35822, 1),
(35823, 1),
(35824, 1),
(35825, 1),
(35826, 1),
(35827, 1),
(35828, 1),
(35829, 1),
(35830, 1),
(35831, 1),
(35832, 1),
(35833, 1),
(35834, 1),
(35835, 1),
(35836, 1),
(35837, 1),
(35838, 1),
(35839, 1),
(35840, 1),
(35841, 1),
(35842, 1),
(35843, 1),
(35844, 1),
(35845, 1),
(35846, 1),
(35847, 1),
(35848, 1),
(35849, 1),
(35850, 1),
(35851, 1),
(35852, 1),
(35853, 1),
(35854, 1),
(35855, 1),
(35856, 1),
(35857, 1),
(35858, 1),
(35859, 1),
(35860, 1),
(35861, 1),
(35862, 1),
(35863, 1),
(35864, 1),
(35865, 1),
(35866, 1),
(35867, 1),
(35868, 1),
(35869, 1),
(35870, 1),
(35871, 1),
(35872, 1),
(35873, 1),
(35874, 1),
(35875, 1),
(35876, 1),
(35877, 1),
(35878, 1),
(35879, 1),
(35880, 1),
(35881, 1),
(35882, 1),
(35883, 1),
(35884, 1),
(35885, 1),
(35886, 1),
(35887, 1),
(35888, 1),
(35889, 1),
(35890, 1),
(35891, 1),
(35892, 1),
(35893, 1),
(35894, 1),
(35895, 1),
(35896, 1),
(35897, 1),
(35898, 1),
(35899, 1),
(35900, 1),
(35901, 1),
(35902, 1),
(35903, 1),
(35904, 1),
(35905, 1),
(35906, 1),
(35907, 1),
(35908, 1),
(35909, 1),
(35910, 1),
(35911, 1),
(35912, 1),
(35913, 1),
(35914, 1),
(35915, 1),
(35916, 1),
(35917, 1),
(35918, 1),
(35919, 1),
(35920, 1),
(35921, 1),
(35922, 1),
(35923, 1),
(35924, 1),
(35925, 1),
(35926, 1),
(35927, 1),
(35928, 1),
(35929, 1),
(35930, 1),
(35931, 1),
(35932, 1),
(35933, 1),
(35934, 1),
(35935, 1),
(35936, 1),
(35937, 1),
(35938, 1),
(35939, 1),
(35940, 1),
(35941, 1),
(35942, 1),
(35943, 1),
(35944, 1),
(35945, 1),
(35946, 1),
(35947, 1),
(35948, 1),
(35949, 1),
(35950, 1),
(35951, 1),
(35952, 1),
(35953, 1),
(35954, 1),
(35955, 1),
(35956, 1),
(35957, 1),
(35958, 1),
(35959, 1),
(35960, 1),
(35961, 1),
(35962, 1),
(35963, 1),
(35964, 1),
(35965, 1),
(35966, 1),
(35967, 1),
(35968, 1),
(35969, 1),
(35970, 1),
(35971, 1),
(35972, 1),
(35973, 1),
(35974, 1),
(35975, 1),
(35976, 1),
(35977, 1),
(35978, 1),
(35979, 1),
(35980, 1),
(35981, 1),
(35982, 1),
(35983, 1),
(35984, 1),
(35985, 1),
(35986, 1),
(35987, 1),
(35988, 1),
(35989, 1),
(35990, 1),
(35991, 1),
(35992, 1),
(35993, 1),
(35994, 1),
(35995, 1),
(35996, 1),
(35997, 1),
(35998, 1),
(35999, 1),
(36000, 1),
(36001, 1),
(36002, 1),
(36003, 1),
(36004, 1),
(36005, 1),
(36006, 1),
(36007, 1),
(36008, 1),
(36009, 1),
(36010, 1),
(36011, 1),
(36012, 1),
(36013, 1),
(36014, 1),
(36015, 1),
(36016, 1),
(36017, 1),
(36018, 1),
(36019, 1),
(36020, 1),
(36021, 1),
(36022, 1),
(36023, 1),
(36024, 1),
(36025, 1),
(36026, 1),
(36027, 1),
(36028, 1),
(36029, 1),
(36030, 1),
(36031, 1),
(36032, 1),
(36033, 1),
(36034, 1),
(36035, 1),
(36036, 1),
(36037, 1),
(36038, 1),
(36039, 1),
(36040, 1),
(36041, 1),
(36042, 1),
(36043, 1),
(36044, 1),
(36045, 1),
(36046, 1),
(36047, 1),
(36048, 1),
(36049, 1),
(36050, 1),
(36051, 1),
(36052, 1),
(36053, 1),
(36054, 1),
(36055, 1),
(36056, 1),
(36057, 1),
(36058, 1),
(36059, 1),
(36060, 1),
(36061, 1),
(36062, 1),
(36063, 1),
(36064, 1),
(36065, 1),
(36066, 1),
(36067, 1),
(36068, 1),
(36069, 1),
(36070, 1),
(36071, 1),
(36072, 1),
(36073, 1),
(36074, 1),
(36075, 1),
(36076, 1),
(36077, 1),
(36078, 1),
(36079, 1),
(36080, 1),
(36081, 1),
(36082, 1),
(36083, 1),
(36084, 1),
(36085, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(36086, 1),
(36087, 1),
(36088, 1),
(36089, 1),
(36090, 1),
(36091, 1),
(36092, 1),
(36093, 1),
(36094, 1),
(36095, 1),
(36096, 1),
(36097, 1),
(36098, 1),
(36099, 1),
(36100, 1),
(36101, 1),
(36102, 1),
(36103, 1),
(36104, 1),
(36105, 1),
(36106, 1),
(36107, 1),
(36108, 1),
(36109, 1),
(36110, 1),
(36111, 1),
(36112, 1),
(36113, 1),
(36114, 1),
(36115, 1),
(36116, 1),
(36117, 1),
(36118, 1),
(36119, 1),
(36120, 1),
(36121, 1),
(36122, 1),
(36123, 1),
(36124, 1),
(36125, 1),
(36126, 1),
(36127, 1),
(36128, 1),
(36129, 1),
(36130, 1),
(36131, 1),
(36132, 1),
(36133, 1),
(36134, 1),
(36135, 1),
(36136, 1),
(36137, 1),
(36138, 1),
(36139, 1),
(36140, 1),
(36141, 1),
(36142, 1),
(36143, 1),
(36144, 1),
(36145, 1),
(36146, 1),
(36147, 1),
(36148, 1),
(36149, 1),
(36150, 1),
(36151, 1),
(36152, 1),
(36153, 1),
(36154, 1),
(36155, 1),
(36156, 1),
(36157, 1),
(36158, 1),
(36159, 1),
(36160, 1),
(36161, 1),
(36162, 1),
(36163, 1),
(36164, 1),
(36165, 1),
(36166, 1),
(36167, 1),
(36168, 1),
(36169, 1),
(36170, 1),
(36171, 1),
(36172, 1),
(36173, 1),
(36174, 1),
(36175, 1),
(36176, 1),
(36177, 1),
(36178, 1),
(36179, 1),
(36180, 1),
(36181, 1),
(36182, 1),
(36183, 1),
(36184, 1),
(36185, 1),
(36186, 1),
(36187, 1),
(36188, 1),
(36189, 1),
(36190, 1),
(36191, 1),
(36192, 1),
(36193, 1),
(36194, 1),
(36195, 1),
(36196, 1),
(36197, 1),
(36198, 1),
(36199, 1),
(36200, 1),
(36201, 1),
(36202, 1),
(36203, 1),
(36204, 1),
(36205, 1),
(36206, 1),
(36207, 1),
(36208, 1),
(36209, 1),
(36210, 1),
(36211, 1),
(36212, 1),
(36213, 1),
(36214, 1),
(36215, 1),
(36216, 1),
(36217, 1),
(36218, 1),
(36219, 1),
(36220, 1),
(36221, 1),
(36222, 1),
(36223, 1),
(36224, 1),
(36225, 1),
(36226, 1),
(36227, 1),
(36228, 1),
(36229, 1),
(36230, 1),
(36231, 1),
(36232, 1),
(36233, 1),
(36234, 1),
(36235, 1),
(36236, 1),
(36237, 1),
(36238, 1),
(36239, 1),
(36240, 1),
(36241, 1),
(36242, 1),
(36243, 1),
(36244, 1),
(36245, 1),
(36246, 1),
(36247, 1),
(36248, 1),
(36249, 1),
(36250, 1),
(36251, 1),
(36252, 1),
(36253, 1),
(36254, 1),
(36255, 1),
(36256, 1),
(36257, 1),
(36258, 1),
(36259, 1),
(36260, 1),
(36261, 1),
(36262, 1),
(36263, 1),
(36264, 1),
(36265, 1),
(36266, 1),
(36267, 1),
(36268, 1),
(36269, 1),
(36270, 1),
(36271, 1),
(36272, 1),
(36273, 1),
(36274, 1),
(36275, 1),
(36276, 1),
(36277, 1),
(36278, 1),
(36279, 1),
(36280, 1),
(36281, 1),
(36282, 1),
(36283, 1),
(36284, 1),
(36285, 1),
(36286, 1),
(36287, 1),
(36288, 1),
(36289, 1),
(36290, 1),
(36291, 1),
(36292, 1),
(36293, 1),
(36294, 1),
(36295, 1),
(36296, 1),
(36297, 1),
(36298, 1),
(36299, 1),
(36300, 1),
(36301, 1),
(36302, 1),
(36303, 1),
(36304, 1),
(36305, 1),
(36306, 1),
(36307, 1),
(36308, 1),
(36309, 1),
(36310, 1),
(36311, 1),
(36312, 1),
(36313, 1),
(36314, 1),
(36315, 1),
(36316, 1),
(36317, 1),
(36318, 1),
(36319, 1),
(36320, 1),
(36321, 1),
(36322, 1),
(36323, 1),
(36324, 1),
(36325, 1),
(36326, 1),
(36327, 1),
(36328, 1),
(36329, 1),
(36330, 1),
(36331, 1),
(36332, 1),
(36333, 1),
(36334, 1),
(36335, 1),
(36336, 1),
(36337, 1),
(36338, 1),
(36339, 1),
(36340, 1),
(36341, 1),
(36342, 1),
(36343, 1),
(36344, 1),
(36345, 1),
(36346, 1),
(36347, 1),
(36348, 1),
(36349, 1),
(36350, 1),
(36351, 1),
(36352, 1),
(36353, 1),
(36354, 1),
(36355, 1),
(36356, 1),
(36357, 1),
(36358, 1),
(36359, 1),
(36360, 1),
(36361, 1),
(36362, 1),
(36363, 1),
(36364, 1),
(36365, 1),
(36366, 1),
(36367, 1),
(36368, 1),
(36369, 1),
(36370, 1),
(36371, 1),
(36372, 1),
(36373, 1),
(36374, 1),
(36375, 1),
(36376, 1),
(36377, 1),
(36378, 1),
(36379, 1),
(36380, 1),
(36381, 1),
(36382, 1),
(36383, 1),
(36384, 1),
(36385, 1),
(36386, 1),
(36387, 1),
(36388, 1),
(36389, 1),
(36390, 1),
(36391, 1),
(36392, 1),
(36393, 1),
(36394, 1),
(36395, 1),
(36396, 1),
(36397, 1),
(36398, 1),
(36399, 1),
(36400, 1),
(36401, 1),
(36402, 1),
(36403, 1),
(36404, 1),
(36405, 1),
(36406, 1),
(36407, 1),
(36408, 1),
(36409, 1),
(36410, 1),
(36411, 1),
(36412, 1),
(36413, 1),
(36414, 1),
(36415, 1),
(36416, 1),
(36417, 1),
(36418, 1),
(36419, 1),
(36420, 1),
(36421, 1),
(36422, 1),
(36423, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(36424, 1),
(36425, 1),
(36426, 1),
(36427, 1),
(36428, 1),
(36429, 1),
(36430, 1),
(36431, 1),
(36432, 1),
(36433, 1),
(36434, 1),
(36435, 1),
(36436, 1),
(36437, 1),
(36438, 1),
(36439, 1),
(36440, 1),
(36441, 1),
(36442, 1),
(36443, 1),
(36444, 1),
(36445, 1),
(36446, 1),
(36447, 1),
(36448, 1),
(36449, 1),
(36450, 1),
(36451, 1),
(36452, 1),
(36453, 1),
(36454, 1),
(36455, 1),
(36456, 1),
(36457, 1),
(36458, 1),
(36459, 1),
(36460, 1),
(36461, 1),
(36462, 1),
(36463, 1),
(36464, 1),
(36465, 1),
(36466, 1),
(36467, 1),
(36468, 1),
(36469, 1),
(36470, 1),
(36471, 1),
(36472, 1),
(36473, 1),
(36474, 1),
(36475, 1),
(36476, 1),
(36477, 1),
(36478, 1),
(36479, 1),
(36480, 1),
(36481, 1),
(36482, 1),
(36483, 1),
(36484, 1),
(36485, 1),
(36486, 1),
(36487, 1),
(36488, 1),
(36489, 1),
(36490, 1),
(36491, 1),
(36492, 1),
(36493, 1),
(36494, 1),
(36495, 1),
(36496, 1),
(36497, 1),
(36498, 1),
(36499, 1),
(36500, 1),
(36501, 1),
(36502, 1),
(36503, 1),
(36504, 1),
(36505, 1),
(36506, 1),
(36507, 1),
(36508, 1),
(36509, 1),
(36510, 1),
(36511, 1),
(36512, 1),
(36513, 1),
(36514, 1),
(36515, 1),
(36516, 1),
(36517, 1),
(36518, 1),
(36519, 1),
(36520, 1),
(36521, 1),
(36522, 1),
(36523, 1),
(36524, 1),
(36525, 1),
(36526, 1),
(36527, 1),
(36528, 1),
(36529, 1),
(36530, 1),
(36531, 1),
(36532, 1),
(36533, 1),
(36534, 1),
(36535, 1),
(36536, 1),
(36537, 1),
(36538, 1),
(36539, 1),
(36540, 1),
(36541, 1),
(36542, 1),
(36543, 1),
(36544, 1),
(36545, 1),
(36546, 1),
(36547, 1),
(36548, 1),
(36549, 1),
(36550, 1),
(36551, 1),
(36552, 1),
(36553, 1),
(36554, 1),
(36555, 1),
(36556, 1),
(36557, 1),
(36558, 1),
(36559, 1),
(36560, 1),
(36561, 1),
(36562, 1),
(36563, 1),
(36564, 1),
(36565, 1),
(36566, 1),
(36567, 1),
(36568, 1),
(36569, 1),
(36570, 1),
(36571, 1),
(36572, 1),
(36573, 1),
(36574, 1),
(36575, 1),
(36576, 1),
(36577, 1),
(36578, 1),
(36579, 1),
(36580, 1),
(36581, 1),
(36582, 1),
(36583, 1),
(36584, 1),
(36585, 1),
(36586, 1),
(36587, 1),
(36588, 1),
(36589, 1),
(36590, 1),
(36591, 1),
(36592, 1),
(36593, 1),
(36594, 1),
(36595, 1),
(36596, 1),
(36597, 1),
(36598, 1),
(36599, 1),
(36600, 1),
(36601, 1),
(36602, 1),
(36603, 1),
(36604, 1),
(36605, 1),
(36606, 1),
(36607, 1),
(36608, 1),
(36609, 1),
(36610, 1),
(36611, 1),
(36612, 1),
(36613, 1),
(36614, 1),
(36615, 1),
(36616, 1),
(36617, 1),
(36618, 1),
(36619, 1),
(36620, 1),
(36621, 1),
(36622, 1),
(36623, 1),
(36624, 1),
(36625, 1),
(36626, 1),
(36627, 1),
(36628, 1),
(36629, 1),
(36630, 1),
(36631, 1),
(36632, 1),
(36633, 1),
(36634, 1),
(36635, 1),
(36636, 1),
(36637, 1),
(36638, 1),
(36639, 1),
(36640, 1),
(36641, 1),
(36642, 1),
(36643, 1),
(36644, 1),
(36645, 1),
(36646, 1),
(36647, 1),
(36648, 1),
(36649, 1),
(36650, 1),
(36651, 1),
(36652, 1),
(36653, 1),
(36654, 1),
(36655, 1),
(36656, 1),
(36657, 1),
(36658, 1),
(36659, 1),
(36660, 1),
(36661, 1),
(36662, 1),
(36663, 1),
(36664, 1),
(36665, 1),
(36666, 1),
(36667, 1),
(36668, 1),
(36669, 1),
(36670, 1),
(36671, 1),
(36672, 1),
(36673, 1),
(36674, 1),
(36675, 1),
(36676, 1),
(36677, 1),
(36678, 1),
(36679, 1),
(36680, 1),
(36681, 1),
(36682, 1),
(36683, 1),
(36684, 1),
(36685, 1),
(36686, 1),
(36687, 1),
(36688, 1),
(36689, 1),
(36690, 1),
(36691, 1),
(36692, 1),
(36693, 1),
(36694, 1),
(36695, 1),
(36696, 1),
(36697, 1),
(36698, 1),
(36699, 1),
(36700, 1),
(36701, 1),
(36702, 1),
(36703, 1),
(36704, 1),
(36705, 1),
(36706, 1),
(36707, 1),
(36708, 1),
(36709, 1),
(36710, 1),
(36711, 1),
(36712, 1),
(36713, 1),
(36714, 1),
(36715, 1),
(36716, 1),
(36717, 1),
(36718, 1),
(36719, 1),
(36720, 1),
(36721, 1),
(36722, 1),
(36723, 1),
(36724, 1),
(36725, 1),
(36726, 1),
(36727, 1),
(36728, 1),
(36729, 1),
(36730, 1),
(36731, 1),
(36732, 1),
(36733, 1),
(36734, 1),
(36735, 1),
(36736, 1),
(36737, 1),
(36738, 1),
(36739, 1),
(36740, 1),
(36741, 1),
(36742, 1),
(36743, 1),
(36744, 1),
(36745, 1),
(36746, 1),
(36747, 1),
(36748, 1),
(36749, 1),
(36750, 1),
(36751, 1),
(36752, 1),
(36753, 1),
(36754, 1),
(36755, 1),
(36756, 1),
(36757, 1),
(36758, 1),
(36759, 1),
(36760, 1),
(36761, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(36762, 1),
(36763, 1),
(36764, 1),
(36765, 1),
(36766, 1),
(36767, 1),
(36768, 1),
(36769, 1),
(36770, 1),
(36771, 1),
(36772, 1),
(36773, 1),
(36774, 1),
(36775, 1),
(36776, 1),
(36777, 1),
(36778, 1),
(36779, 1),
(36780, 1),
(36781, 1),
(36782, 1),
(36783, 1),
(36784, 1),
(36785, 1),
(36786, 1),
(36787, 1),
(36788, 1),
(36789, 1),
(36790, 1),
(36791, 1),
(36792, 1),
(36793, 1),
(36794, 1),
(36795, 1),
(36796, 1),
(36797, 1),
(36798, 1),
(36799, 1),
(36800, 1),
(36801, 1),
(36802, 1),
(36803, 1),
(36804, 1),
(36805, 1),
(36806, 1),
(36807, 1),
(36808, 1),
(36809, 1),
(36810, 1),
(36811, 1),
(36812, 1),
(36813, 1),
(36814, 1),
(36815, 1),
(36816, 1),
(36817, 1),
(36818, 1),
(36819, 1),
(36820, 1),
(36821, 1),
(36822, 1),
(36823, 1),
(36824, 1),
(36825, 1),
(36826, 1),
(36827, 1),
(36828, 1),
(36829, 1),
(36830, 1),
(36831, 1),
(36832, 1),
(36833, 1),
(36834, 1),
(36835, 1),
(36836, 1),
(36837, 1),
(36838, 1),
(36839, 1),
(36840, 1),
(36841, 1),
(36842, 1),
(36843, 1),
(36844, 1),
(36845, 1),
(36846, 1),
(36847, 1),
(36848, 1),
(36849, 1),
(36850, 1),
(36851, 1),
(36852, 1),
(36853, 1),
(36854, 1),
(36855, 1),
(36856, 1),
(36857, 1),
(36858, 1),
(36859, 1),
(36860, 1),
(36861, 1),
(36862, 1),
(36863, 1),
(36864, 1),
(36865, 1),
(36866, 1),
(36867, 1),
(36868, 1),
(36869, 1),
(36870, 1),
(36871, 1),
(36872, 1),
(36873, 1),
(36874, 1),
(36875, 1),
(36876, 1),
(36877, 1),
(36878, 1),
(36879, 1),
(36880, 1),
(36881, 1),
(36882, 1),
(36883, 1),
(36884, 1),
(36885, 1),
(36886, 1),
(36887, 1),
(36888, 1),
(36889, 1),
(36890, 1),
(36891, 1),
(36892, 1),
(36893, 1),
(36894, 1),
(36895, 1),
(36896, 1),
(36897, 1),
(36898, 1),
(36899, 1),
(36900, 1),
(36901, 1),
(36902, 1),
(36903, 1),
(36904, 1),
(36905, 1),
(36906, 1),
(36907, 1),
(36908, 1),
(36909, 1),
(36910, 1),
(36911, 1),
(36912, 1),
(36913, 1),
(36914, 1),
(36915, 1),
(36916, 1),
(36917, 1),
(36918, 1),
(36919, 1),
(36920, 1),
(36921, 1),
(36922, 1),
(36923, 1),
(36924, 1),
(36925, 1),
(36926, 1),
(36927, 1),
(36928, 1),
(36929, 1),
(36930, 1),
(36931, 1),
(36932, 1),
(36933, 1),
(36934, 1),
(36935, 1),
(36936, 1),
(36937, 1),
(36938, 1),
(36939, 1),
(36940, 1),
(36941, 1),
(36942, 1),
(36943, 1),
(36944, 1),
(36945, 1),
(36946, 1),
(36947, 1),
(36948, 1),
(36949, 1),
(36950, 1),
(36951, 1),
(36952, 1),
(36953, 1),
(36954, 1),
(36955, 1),
(36956, 1),
(36957, 1),
(36958, 1),
(36959, 1),
(36960, 1),
(36961, 1),
(36962, 1),
(36963, 1),
(36964, 1),
(36965, 1),
(36966, 1),
(36967, 1),
(36968, 1),
(36969, 1),
(36970, 1),
(36971, 1),
(36972, 1),
(36973, 1),
(36974, 1),
(36975, 1),
(36976, 1),
(36977, 1),
(36978, 1),
(36979, 1),
(36980, 1),
(36981, 1),
(36982, 1),
(36983, 1),
(36984, 1),
(36985, 1),
(36986, 1),
(36987, 1),
(36988, 1),
(36989, 1),
(36990, 1),
(36991, 1),
(36992, 1),
(36993, 1),
(36994, 1),
(36995, 1),
(36996, 1),
(36997, 1),
(36998, 1),
(36999, 1),
(37000, 1),
(37001, 1),
(37002, 1),
(37003, 1),
(37004, 1),
(37005, 1),
(37006, 1),
(37007, 1),
(37008, 1),
(37009, 1),
(37010, 1),
(37011, 1),
(37012, 1),
(37013, 1),
(37014, 1),
(37015, 1),
(37016, 1),
(37017, 1),
(37018, 1),
(37019, 1),
(37020, 1),
(37021, 1),
(37022, 1),
(37023, 1),
(37024, 1),
(37025, 1),
(37026, 1),
(37027, 1),
(37028, 1),
(37029, 1),
(37030, 1),
(37031, 1),
(37032, 1),
(37033, 1),
(37034, 1),
(37035, 1),
(37036, 1),
(37037, 1),
(37038, 1),
(37039, 1),
(37040, 1),
(37041, 1),
(37042, 1),
(37043, 1),
(37044, 1),
(37045, 1),
(37046, 1),
(37047, 1),
(37048, 1),
(37049, 1),
(37050, 1),
(37051, 1),
(37052, 1),
(37053, 1),
(37054, 1),
(37055, 1),
(37056, 1),
(37057, 1),
(37058, 1),
(37059, 1),
(37060, 1),
(37061, 1),
(37062, 1),
(37063, 1),
(37064, 1),
(37065, 1),
(37066, 1),
(37067, 1),
(37068, 1),
(37069, 1),
(37070, 1),
(37071, 1),
(37072, 1),
(37073, 1),
(37074, 1),
(37075, 1),
(37076, 1),
(37077, 1),
(37078, 1),
(37079, 1),
(37080, 1),
(37081, 1),
(37082, 1),
(37083, 1),
(37084, 1),
(37085, 1),
(37086, 1),
(37087, 1),
(37088, 1),
(37089, 1),
(37090, 1),
(37091, 1),
(37092, 1),
(37093, 1),
(37094, 1),
(37095, 1),
(37096, 1),
(37097, 1),
(37098, 1),
(37099, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(37100, 1),
(37101, 1),
(37102, 1),
(37103, 1),
(37104, 1),
(37105, 1),
(37106, 1),
(37107, 1),
(37108, 1),
(37109, 1),
(37110, 1),
(37111, 1),
(37112, 1),
(37113, 1),
(37114, 1),
(37115, 1),
(37116, 1),
(37117, 1),
(37118, 1),
(37119, 1),
(37120, 1),
(37121, 1),
(37122, 1),
(37123, 1),
(37124, 1),
(37125, 1),
(37126, 1),
(37127, 1),
(37128, 1),
(37129, 1),
(37130, 1),
(37131, 1),
(37132, 1),
(37133, 1),
(37134, 1),
(37135, 1),
(37136, 1),
(37137, 1),
(37138, 1),
(37139, 1),
(37140, 1),
(37141, 1),
(37142, 1),
(37143, 1),
(37144, 1),
(37145, 1),
(37146, 1),
(37147, 1),
(37148, 1),
(37149, 1),
(37150, 1),
(37151, 1),
(37152, 1),
(37153, 1),
(37154, 1),
(37155, 1),
(37156, 1),
(37157, 1),
(37158, 1),
(37159, 1),
(37160, 1),
(37161, 1),
(37162, 1),
(37163, 1),
(37164, 1),
(37165, 1),
(37166, 1),
(37167, 1),
(37168, 1),
(37169, 1),
(37170, 1),
(37171, 1),
(37172, 1),
(37173, 1),
(37174, 1),
(37175, 1),
(37176, 1),
(37177, 1),
(37178, 1),
(37179, 1),
(37180, 1),
(37181, 1),
(37182, 1),
(37183, 1),
(37184, 1),
(37185, 1),
(37186, 1),
(37187, 1),
(37188, 1),
(37189, 1),
(37190, 1),
(37191, 1),
(37192, 1),
(37193, 1),
(37194, 1),
(37195, 1),
(37196, 1),
(37197, 1),
(37198, 1),
(37199, 1),
(37200, 1),
(37201, 1),
(37202, 1),
(37203, 1),
(37204, 1),
(37205, 1),
(37206, 1),
(37207, 1),
(37208, 1),
(37209, 1),
(37210, 1),
(37211, 1),
(37212, 1),
(37213, 1),
(37214, 1),
(37215, 1),
(37216, 1),
(37217, 1),
(37218, 1),
(37219, 1),
(37220, 1),
(37221, 1),
(37222, 1),
(37223, 1),
(37224, 1),
(37225, 1),
(37226, 1),
(37227, 1),
(37228, 1),
(37229, 1),
(37230, 1),
(37231, 1),
(37232, 1),
(37233, 1),
(37234, 1),
(37235, 1),
(37236, 1),
(37237, 1),
(37238, 1),
(37239, 1),
(37240, 1),
(37241, 1),
(37242, 1),
(37243, 1),
(37244, 1),
(37245, 1),
(37246, 1),
(37247, 1),
(37248, 1),
(37249, 1),
(37250, 1),
(37251, 1),
(37252, 1),
(37253, 1),
(37254, 1),
(37255, 1),
(37256, 1),
(37257, 1),
(37258, 1),
(37259, 1),
(37260, 1),
(37261, 1),
(37262, 1),
(37263, 1),
(37264, 1),
(37265, 1),
(37266, 1),
(37267, 1),
(37268, 1),
(37269, 1),
(37270, 1),
(37271, 1),
(37272, 1),
(37273, 1),
(37274, 1),
(37275, 1),
(37276, 1),
(37277, 1),
(37278, 1),
(37279, 1),
(37280, 1),
(37281, 1),
(37282, 1),
(37283, 1),
(37284, 1),
(37285, 1),
(37286, 1),
(37287, 1),
(37288, 1),
(37289, 1),
(37290, 1),
(37291, 1),
(37292, 1),
(37293, 1),
(37294, 1),
(37295, 1),
(37296, 1),
(37297, 1),
(37298, 1),
(37299, 1),
(37300, 1),
(37301, 1),
(37302, 1),
(37303, 1),
(37304, 1),
(37305, 1),
(37306, 1),
(37307, 1),
(37308, 1),
(37309, 1),
(37310, 1),
(37311, 1),
(37312, 1),
(37313, 1),
(37314, 1),
(37315, 1),
(37316, 1),
(37317, 1),
(37318, 1),
(37319, 1),
(37320, 1),
(37321, 1),
(37322, 1),
(37323, 1),
(37324, 1),
(37325, 1),
(37326, 1),
(37327, 1),
(37328, 1),
(37329, 1),
(37330, 1),
(37331, 1),
(37332, 1),
(37333, 1),
(37334, 1),
(37335, 1),
(37336, 1),
(37337, 1),
(37338, 1),
(37339, 1),
(37340, 1),
(37341, 1),
(37342, 1),
(37343, 1),
(37344, 1),
(37345, 1),
(37346, 1),
(37347, 1),
(37348, 1),
(37349, 1),
(37350, 1),
(37351, 1),
(37352, 1),
(37353, 1),
(37354, 1),
(37355, 1),
(37356, 1),
(37357, 1),
(37358, 1),
(37359, 1),
(37360, 1),
(37361, 1),
(37362, 1),
(37363, 1),
(37364, 1),
(37365, 1),
(37366, 1),
(37367, 1),
(37368, 1),
(37369, 1),
(37370, 1),
(37371, 1),
(37372, 1),
(37373, 1),
(37374, 1),
(37375, 1),
(37376, 1),
(37377, 1),
(37378, 1),
(37379, 1),
(37380, 1),
(37381, 1),
(37382, 1),
(37383, 1),
(37384, 1),
(37385, 1),
(37386, 1),
(37387, 1),
(37388, 1),
(37389, 1),
(37390, 1),
(37391, 1),
(37392, 1),
(37393, 1),
(37394, 1),
(37395, 1),
(37396, 1),
(37397, 1),
(37398, 1),
(37399, 1),
(37400, 1),
(37401, 1),
(37402, 1),
(37403, 1),
(37404, 1),
(37405, 1),
(37406, 1),
(37407, 1),
(37408, 1),
(37409, 1),
(37410, 1),
(37411, 1),
(37412, 1),
(37413, 1),
(37414, 1),
(37415, 1),
(37416, 1),
(37417, 1),
(37418, 1),
(37419, 1),
(37420, 1),
(37421, 1),
(37422, 1),
(37423, 1),
(37424, 1),
(37425, 1),
(37426, 1),
(37427, 1),
(37428, 1),
(37429, 1),
(37430, 1),
(37431, 1),
(37432, 1),
(37433, 1),
(37434, 1),
(37435, 1),
(37436, 1),
(37437, 1);            
INSERT INTO "PUBLIC"."ENTRY_RELEASE" VALUES
(37438, 1),
(37439, 1),
(37440, 1),
(37441, 1),
(37442, 1),
(37443, 1),
(37444, 1),
(37445, 1),
(37446, 1),
(37447, 1),
(37448, 1),
(37449, 1),
(37450, 1),
(37451, 1),
(37452, 1),
(37453, 1),
(37454, 1),
(37455, 1),
(37456, 1),
(37457, 1),
(37458, 1),
(37459, 1),
(37460, 1),
(37461, 1),
(37462, 1),
(37463, 1),
(37464, 1),
(37465, 1),
(37466, 1),
(37467, 1),
(37468, 1),
(37469, 1),
(37470, 1),
(37471, 1),
(37472, 1),
(37473, 1),
(37474, 1),
(37475, 1),
(37476, 1),
(37477, 1),
(37478, 1),
(37479, 1),
(37480, 1),
(37481, 1),
(37482, 1),
(37483, 1),
(37484, 1),
(37485, 1),
(37486, 1),
(37487, 1),
(37488, 1),
(37489, 1),
(37490, 1),
(37491, 1),
(37492, 1),
(37493, 1),
(37494, 1),
(37495, 1),
(37496, 1),
(37497, 1),
(37498, 1),
(37499, 1),
(37500, 1),
(37501, 1),
(37502, 1),
(37503, 1),
(37504, 1),
(37505, 1),
(37506, 1),
(37507, 1),
(37508, 1),
(37509, 1),
(37510, 1),
(37511, 1),
(37512, 1),
(37513, 1),
(37514, 1),
(37515, 1),
(37516, 1),
(37517, 1),
(37518, 1),
(37519, 1),
(37520, 1),
(37521, 1),
(37522, 1),
(37523, 1),
(37524, 1),
(37525, 1),
(37526, 1),
(37527, 1),
(37528, 1),
(37529, 1),
(37530, 1),
(37531, 1),
(37532, 1),
(37533, 1),
(37534, 1),
(37535, 1),
(37536, 1),
(37537, 1),
(37538, 1),
(37539, 1),
(37540, 1),
(37541, 1),
(37542, 1),
(37543, 1),
(37544, 1),
(37545, 1),
(37546, 1),
(37547, 1),
(37548, 1),
(37549, 1),
(37550, 1),
(37551, 1),
(37552, 1),
(37553, 1),
(37554, 1),
(37555, 1),
(37556, 1),
(37557, 1),
(37558, 1),
(37559, 1),
(37560, 1),
(37561, 1),
(37562, 1),
(37563, 1),
(37564, 1),
(37565, 1),
(37566, 1),
(37567, 1),
(37568, 1),
(37569, 1),
(37570, 1),
(37571, 1),
(37572, 1),
(37573, 1),
(37574, 1),
(37575, 1),
(37576, 1),
(37577, 1),
(37578, 1),
(37579, 1),
(37580, 1),
(37581, 1),
(37582, 1),
(37583, 1),
(37584, 1),
(37585, 1),
(37586, 1),
(37587, 1),
(37588, 1),
(37589, 1),
(37590, 1),
(37591, 1),
(37592, 1),
(37593, 1),
(37594, 1),
(37595, 1),
(37596, 1),
(37597, 1),
(37598, 1),
(37599, 1),
(37600, 1),
(37601, 1),
(37602, 1),
(37603, 1),
(37604, 1),
(37605, 1),
(37606, 1),
(37607, 1),
(37608, 1),
(37609, 1),
(37610, 1),
(37611, 1),
(37612, 1),
(37613, 1),
(37614, 1),
(37615, 1),
(37616, 1),
(37617, 1),
(37618, 1),
(37619, 1),
(37620, 1),
(37621, 1),
(37622, 1),
(37623, 1),
(37624, 1),
(37625, 1),
(37626, 1),
(37627, 1),
(37628, 1),
(37629, 1),
(37630, 1),
(37631, 1),
(37632, 1),
(37633, 1),
(37634, 1),
(37635, 1),
(37636, 1),
(37637, 1),
(37638, 1),
(37639, 1),
(37640, 1),
(37641, 1),
(37642, 1),
(37643, 1),
(37644, 1),
(37645, 1),
(37646, 1),
(37647, 1),
(37648, 1),
(37649, 1),
(37650, 1),
(37651, 1),
(37652, 1),
(37653, 1),
(37654, 1),
(37655, 1),
(37656, 1),
(37657, 1),
(37658, 1),
(37659, 1),
(37660, 1),
(37661, 1),
(37662, 1),
(37663, 1),
(37664, 1),
(37665, 1),
(37666, 1),
(37667, 1),
(37668, 1),
(37669, 1),
(37670, 1),
(37671, 1),
(37672, 1),
(37673, 1),
(37674, 1),
(37675, 1),
(37676, 1),
(37677, 1),
(37678, 1),
(37679, 1),
(37680, 1),
(37681, 1),
(37682, 1),
(37683, 1),
(37684, 1),
(37685, 1),
(37686, 1),
(37687, 1),
(37688, 1),
(37689, 1),
(37690, 1),
(37691, 1),
(37692, 1),
(37693, 1),
(37694, 1),
(37695, 1),
(37696, 1),
(37697, 1),
(37698, 1),
(37699, 1),
(37700, 1),
(37701, 1),
(37702, 1),
(37703, 1),
(37704, 1),
(37705, 1),
(37706, 1),
(37707, 1),
(37708, 1),
(37709, 1),
(37710, 1),
(37711, 1),
(37712, 1),
(37713, 1),
(37714, 1),
(37715, 1),
(37716, 1),
(37717, 1),
(37718, 1),
(37719, 1),
(37720, 1),
(37721, 1),
(37722, 1),
(37723, 1),
(37724, 1),
(37725, 1),
(37726, 1),
(37727, 1),
(37728, 1),
(37729, 1),
(37730, 1),
(37731, 1),
(37732, 1),
(37733, 1),
(37734, 1),
(37735, 1),
(37736, 1),
(37737, 1),
(37738, 1),
(37739, 1),
(37740, 1),
(37741, 1),
(37742, 1),
(37743, 1),
(37744, 1),
(37745, 1),
(37746, 1),
(37747, 1),
(37748, 1),
(37749, 1),
(37750, 1),
(37751, 1),
(37752, 1),
(37753, 1),
(37754, 1),
(37755, 1),
(37756, 1),
(37757, 1),
(37758, 1),
(37759, 1),
(37760, 1),
(37761, 1),
(37762, 1),
(37763, 1),
(37764, 1),
(37765, 1),
(37766, 1),
(37767, 1),
(37768, 1),
(37769, 1),
(37770, 1),
(37771, 1);            
CREATE CACHED TABLE "PUBLIC"."EXCEPTION_CHUNK"(
    "STEP_EXECUTION_ID" BIGINT NOT NULL,
    "EXCEPTION_CHUNKS" VARCHAR(4000),
    "CHUNK_INDEX" INTEGER NOT NULL
);           
ALTER TABLE "PUBLIC"."EXCEPTION_CHUNK" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_25" PRIMARY KEY("STEP_EXECUTION_ID", "CHUNK_INDEX");
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.EXCEPTION_CHUNK;          
CREATE CACHED TABLE "PUBLIC"."FINGER_PRINTS_LOCATION"(
    "ID" BIGINT NOT NULL,
    "LOC_END" INTEGER NOT NULL,
    "LOC_START" INTEGER NOT NULL,
    "MATCH_ID" BIGINT NOT NULL,
    "MOTIF_NUMBER" INTEGER NOT NULL,
    "PVALUE" DOUBLE NOT NULL,
    "SCORE" DOUBLE NOT NULL
);           
ALTER TABLE "PUBLIC"."FINGER_PRINTS_LOCATION" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_1" PRIMARY KEY("ID");        
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.FINGER_PRINTS_LOCATION;   
CREATE CACHED TABLE "PUBLIC"."FINGER_PRINTS_LOCAT_FRAGMENT"(
    "ID" BIGINT NOT NULL,
    "DC_STATUS" VARCHAR(255) NOT NULL,
    "LOC_END" INTEGER NOT NULL,
    "LOC_START" INTEGER NOT NULL,
    "LOCATION_ID" BIGINT NOT NULL
);           
ALTER TABLE "PUBLIC"."FINGER_PRINTS_LOCAT_FRAGMENT" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_18" PRIMARY KEY("ID"); 
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.FINGER_PRINTS_LOCAT_FRAGMENT;             
CREATE CACHED TABLE "PUBLIC"."FINGER_PRINTS_MATCH"(
    "ID" BIGINT NOT NULL,
    "SIGNATURE_MODELS" VARCHAR(255),
    "PROTEIN_ID" BIGINT NOT NULL,
    "SIGNATURE_ID" BIGINT NOT NULL,
    "EVALUE" DOUBLE NOT NULL,
    "GRAPHSCAN" VARCHAR(25) NOT NULL
); 
ALTER TABLE "PUBLIC"."FINGER_PRINTS_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_5" PRIMARY KEY("ID");           
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.FINGER_PRINTS_MATCH;      
CREATE CACHED TABLE "PUBLIC"."FUNFAM_HMMER3_RAW_MATCH"(
    "ID" BIGINT NOT NULL,
    "LOC_FRAGMENT_DCS_TATUS" VARCHAR(255),
    "LOCATION_END" INTEGER,
    "LOCATION_START" INTEGER,
    "MODEL_ID" VARCHAR(255),
    "NUMERIC_SEQUENCE_ID" BIGINT,
    "SEQUENCE_ID" VARCHAR(255),
    "SIGNATURE_LIBRARY" VARCHAR(255),
    "SIG_LIB_RELEASE" VARCHAR(255),
    "EVALUE" DOUBLE NOT NULL,
    "HMM_BOUNDS" VARCHAR(2),
    "HMM_END" INTEGER NOT NULL,
    "HMM_START" INTEGER NOT NULL,
    "LOCATION_SCORE" DOUBLE NOT NULL,
    "SCORE" DOUBLE NOT NULL,
    "DOMAIN_BIAS" DOUBLE NOT NULL,
    "DOMAIN_CE_VALUE" DOUBLE NOT NULL,
    "DOMAIN_IE_VALUE" DOUBLE NOT NULL,
    "ENVELOPE_END" INTEGER NOT NULL,
    "ENVELOPE_START" INTEGER NOT NULL,
    "EXPECTED_ACCURACY" DOUBLE NOT NULL,
    "FULL_SEQUENCE_BIAS" DOUBLE NOT NULL,
    "SPLIT_GROUP" BINARY,
    "ALIGNMENT" VARCHAR(4000) NOT NULL
);            
ALTER TABLE "PUBLIC"."FUNFAM_HMMER3_RAW_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_5F" PRIMARY KEY("ID");      
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.FUNFAM_HMMER3_RAW_MATCH;  
CREATE INDEX "PUBLIC"."FUNFAM_RW_SEQ_IDX" ON "PUBLIC"."FUNFAM_HMMER3_RAW_MATCH"("SEQUENCE_ID");
CREATE INDEX "PUBLIC"."FUNFAM_RW_NUM_SEQ_IDX" ON "PUBLIC"."FUNFAM_HMMER3_RAW_MATCH"("NUMERIC_SEQUENCE_ID");    
CREATE INDEX "PUBLIC"."FUNFAM_RW_MODEL_IDX" ON "PUBLIC"."FUNFAM_HMMER3_RAW_MATCH"("MODEL_ID"); 
CREATE INDEX "PUBLIC"."FUNFAM_RW_SIGLIB_IDX" ON "PUBLIC"."FUNFAM_HMMER3_RAW_MATCH"("SIGNATURE_LIBRARY");       
CREATE INDEX "PUBLIC"."FUNFAM_RW_SIGLIB_REL_IDX" ON "PUBLIC"."FUNFAM_HMMER3_RAW_MATCH"("SIG_LIB_RELEASE");     
CREATE CACHED TABLE "PUBLIC"."GENE3D_HMMER3_RAW_MATCH"(
    "ID" BIGINT NOT NULL,
    "LOC_FRAGMENT_DCS_TATUS" VARCHAR(255),
    "LOCATION_END" INTEGER,
    "LOCATION_START" INTEGER,
    "MODEL_ID" VARCHAR(255),
    "NUMERIC_SEQUENCE_ID" BIGINT,
    "SEQUENCE_ID" VARCHAR(255),
    "SIGNATURE_LIBRARY" VARCHAR(255),
    "SIG_LIB_RELEASE" VARCHAR(255),
    "EVALUE" DOUBLE NOT NULL,
    "HMM_BOUNDS" VARCHAR(2),
    "HMM_END" INTEGER NOT NULL,
    "HMM_START" INTEGER NOT NULL,
    "LOCATION_SCORE" DOUBLE NOT NULL,
    "SCORE" DOUBLE NOT NULL,
    "DOMAIN_BIAS" DOUBLE NOT NULL,
    "DOMAIN_CE_VALUE" DOUBLE NOT NULL,
    "DOMAIN_IE_VALUE" DOUBLE NOT NULL,
    "ENVELOPE_END" INTEGER NOT NULL,
    "ENVELOPE_START" INTEGER NOT NULL,
    "EXPECTED_ACCURACY" DOUBLE NOT NULL,
    "FULL_SEQUENCE_BIAS" DOUBLE NOT NULL,
    "SPLIT_GROUP" BINARY,
    "CATH_FAMILY_ID" VARCHAR(4000) NOT NULL,
    "CIGAR_ALIGNMENT" VARCHAR(4000) NOT NULL,
    "HIT_MODEL_NAME" VARCHAR(4000) NOT NULL,
    "REGION_COMMENT" VARCHAR(4000) NOT NULL
);               
ALTER TABLE "PUBLIC"."GENE3D_HMMER3_RAW_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_31" PRIMARY KEY("ID");      
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.GENE3D_HMMER3_RAW_MATCH;  
CREATE INDEX "PUBLIC"."G3D_RW_SEQ_IDX" ON "PUBLIC"."GENE3D_HMMER3_RAW_MATCH"("SEQUENCE_ID");   
CREATE INDEX "PUBLIC"."G3D_RW_NUM_SEQ_IDX" ON "PUBLIC"."GENE3D_HMMER3_RAW_MATCH"("NUMERIC_SEQUENCE_ID");       
CREATE INDEX "PUBLIC"."G3D_RW_MODEL_IDX" ON "PUBLIC"."GENE3D_HMMER3_RAW_MATCH"("MODEL_ID");    
CREATE INDEX "PUBLIC"."G3D_RW_SIGLIB_IDX" ON "PUBLIC"."GENE3D_HMMER3_RAW_MATCH"("SIGNATURE_LIBRARY");          
CREATE INDEX "PUBLIC"."G3D_RW_SIGLIB_REL_IDX" ON "PUBLIC"."GENE3D_HMMER3_RAW_MATCH"("SIG_LIB_RELEASE");        
CREATE CACHED TABLE "PUBLIC"."GO_XREF"(
    "ID" BIGINT NOT NULL,
    "DATABASE_NAME" VARCHAR(255),
    "IDENTIFIER" VARCHAR(255) NOT NULL,
    "NAME" VARCHAR(255),
    "CATEGORY" INTEGER
); 
ALTER TABLE "PUBLIC"."GO_XREF" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_38" PRIMARY KEY("ID");      
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.GO_XREF;  
CREATE INDEX "PUBLIC"."IDXOJ9LJW7TMNUF4L4GXVCDUCTJA" ON "PUBLIC"."GO_XREF"("IDENTIFIER");      
CREATE CACHED TABLE "PUBLIC"."HAMAP_RAW_MATCH"(
    "ID" BIGINT NOT NULL,
    "LOC_FRAGMENT_DCS_TATUS" VARCHAR(255),
    "LOCATION_END" INTEGER,
    "LOCATION_START" INTEGER,
    "MODEL_ID" VARCHAR(255),
    "NUMERIC_SEQUENCE_ID" BIGINT,
    "SEQUENCE_ID" VARCHAR(255),
    "SIGNATURE_LIBRARY" VARCHAR(255),
    "SIG_LIB_RELEASE" VARCHAR(255),
    "CIGAR_ALIGNMENT" VARCHAR(4000) NOT NULL,
    "PF_SCAN_LEVEL" VARCHAR(255) NOT NULL,
    "SCORE" DOUBLE
);         
ALTER TABLE "PUBLIC"."HAMAP_RAW_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_FE" PRIMARY KEY("ID");              
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.HAMAP_RAW_MATCH;          
CREATE INDEX "PUBLIC"."HAMAP_RW_SEQ_IDX" ON "PUBLIC"."HAMAP_RAW_MATCH"("SEQUENCE_ID");         
CREATE INDEX "PUBLIC"."HAMAP_RW_NUM_SEQ_IDX" ON "PUBLIC"."HAMAP_RAW_MATCH"("NUMERIC_SEQUENCE_ID");             
CREATE INDEX "PUBLIC"."HAMAP_RW_MODEL_IDX" ON "PUBLIC"."HAMAP_RAW_MATCH"("MODEL_ID");          
CREATE INDEX "PUBLIC"."HAMAP_RW_SIGLIB_IDX" ON "PUBLIC"."HAMAP_RAW_MATCH"("SIGNATURE_LIBRARY");
CREATE INDEX "PUBLIC"."HAMAP_RW_SIGLIB_REL_IDX" ON "PUBLIC"."HAMAP_RAW_MATCH"("SIG_LIB_RELEASE");              
CREATE CACHED TABLE "PUBLIC"."HMMER2_LOCATION"(
    "ID" BIGINT NOT NULL,
    "LOC_END" INTEGER NOT NULL,
    "LOC_START" INTEGER NOT NULL,
    "MATCH_ID" BIGINT NOT NULL,
    "EVALUE" DOUBLE NOT NULL,
    "HMM_BOUNDS" VARCHAR(2) NOT NULL,
    "HMM_END" INTEGER NOT NULL,
    "HMM_LENGTH" INTEGER NOT NULL,
    "HMM_START" INTEGER NOT NULL,
    "SCORE" DOUBLE NOT NULL
);            
ALTER TABLE "PUBLIC"."HMMER2_LOCATION" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_12" PRIMARY KEY("ID");              
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.HMMER2_LOCATION;          
CREATE CACHED TABLE "PUBLIC"."HMMER2_LOCATION_FRAGMENT"(
    "ID" BIGINT NOT NULL,
    "DC_STATUS" VARCHAR(255) NOT NULL,
    "LOC_END" INTEGER NOT NULL,
    "LOC_START" INTEGER NOT NULL,
    "LOCATION_ID" BIGINT NOT NULL
);               
ALTER TABLE "PUBLIC"."HMMER2_LOCATION_FRAGMENT" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_6" PRIMARY KEY("ID");      
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.HMMER2_LOCATION_FRAGMENT; 
CREATE CACHED TABLE "PUBLIC"."HMMER2_MATCH"(
    "ID" BIGINT NOT NULL,
    "SIGNATURE_MODELS" VARCHAR(255),
    "PROTEIN_ID" BIGINT NOT NULL,
    "SIGNATURE_ID" BIGINT NOT NULL,
    "EVALUE" DOUBLE NOT NULL,
    "SCORE" DOUBLE NOT NULL
); 
ALTER TABLE "PUBLIC"."HMMER2_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_A" PRIMARY KEY("ID");  
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.HMMER2_MATCH;             
CREATE CACHED TABLE "PUBLIC"."HMMER3_LOCATION"(
    "ID" BIGINT NOT NULL,
    "LOC_END" INTEGER NOT NULL,
    "LOC_START" INTEGER NOT NULL,
    "MATCH_ID" BIGINT NOT NULL,
    "EVALUE" DOUBLE NOT NULL,
    "HMM_BOUNDS" VARCHAR(2) NOT NULL,
    "HMM_END" INTEGER NOT NULL,
    "HMM_LENGTH" INTEGER NOT NULL,
    "HMM_START" INTEGER NOT NULL,
    "SCORE" DOUBLE NOT NULL,
    "ALIGNMENT" VARCHAR(4000),
    "ENVELOPE_END" INTEGER NOT NULL,
    "ENVELOPE_START" INTEGER NOT NULL,
    "POST_PROCESSED" BOOLEAN NOT NULL
);          
ALTER TABLE "PUBLIC"."HMMER3_LOCATION" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_6F" PRIMARY KEY("ID");              
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.HMMER3_LOCATION;          
CREATE CACHED TABLE "PUBLIC"."HMMER3_LOCATION_FRAGMENT"(
    "ID" BIGINT NOT NULL,
    "DC_STATUS" VARCHAR(255) NOT NULL,
    "LOC_END" INTEGER NOT NULL,
    "LOC_START" INTEGER NOT NULL,
    "LOCATION_ID" BIGINT NOT NULL
);               
ALTER TABLE "PUBLIC"."HMMER3_LOCATION_FRAGMENT" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_3D" PRIMARY KEY("ID");     
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.HMMER3_LOCATION_FRAGMENT; 
CREATE CACHED TABLE "PUBLIC"."HMMER3_LOCATION_WITH_SITES"(
    "ID" BIGINT NOT NULL,
    "LOC_END" INTEGER NOT NULL,
    "LOC_START" INTEGER NOT NULL,
    "MATCH_ID" BIGINT NOT NULL,
    "EVALUE" DOUBLE NOT NULL,
    "HMM_BOUNDS" VARCHAR(2) NOT NULL,
    "HMM_END" INTEGER NOT NULL,
    "HMM_LENGTH" INTEGER NOT NULL,
    "HMM_START" INTEGER NOT NULL,
    "SCORE" DOUBLE NOT NULL,
    "ENVELOPE_END" INTEGER NOT NULL,
    "ENVELOPE_START" INTEGER NOT NULL
);     
ALTER TABLE "PUBLIC"."HMMER3_LOCATION_WITH_SITES" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_B" PRIMARY KEY("ID");    
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.HMMER3_LOCATION_WITH_SITES;               
CREATE CACHED TABLE "PUBLIC"."HMMER3_LOCN_FRAG_WITH_SITES"(
    "ID" BIGINT NOT NULL,
    "DC_STATUS" VARCHAR(255) NOT NULL,
    "LOC_END" INTEGER NOT NULL,
    "LOC_START" INTEGER NOT NULL,
    "LOCATION_ID" BIGINT NOT NULL
);            
ALTER TABLE "PUBLIC"."HMMER3_LOCN_FRAG_WITH_SITES" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_57" PRIMARY KEY("ID");  
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.HMMER3_LOCN_FRAG_WITH_SITES;              
CREATE CACHED TABLE "PUBLIC"."HMMER3_MATCH"(
    "ID" BIGINT NOT NULL,
    "SIGNATURE_MODELS" VARCHAR(255),
    "PROTEIN_ID" BIGINT NOT NULL,
    "SIGNATURE_ID" BIGINT NOT NULL,
    "EVALUE" DOUBLE NOT NULL,
    "SCORE" DOUBLE NOT NULL
); 
ALTER TABLE "PUBLIC"."HMMER3_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_D" PRIMARY KEY("ID");  
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.HMMER3_MATCH;             
CREATE CACHED TABLE "PUBLIC"."HMMER3_MATCH_WITH_SITES"(
    "ID" BIGINT NOT NULL,
    "SIGNATURE_MODELS" VARCHAR(255),
    "PROTEIN_ID" BIGINT NOT NULL,
    "SIGNATURE_ID" BIGINT NOT NULL,
    "EVALUE" DOUBLE NOT NULL,
    "SCORE" DOUBLE NOT NULL,
    "SCOPE" VARCHAR(255)
);            
ALTER TABLE "PUBLIC"."HMMER3_MATCH_WITH_SITES" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_CE1" PRIMARY KEY("ID");     
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.HMMER3_MATCH_WITH_SITES;  
CREATE CACHED TABLE "PUBLIC"."HMMER3_SITE"(
    "ID" BIGINT NOT NULL,
    "DESCRIPTION" VARCHAR(255),
    "NUM_LOCATIONS" INTEGER NOT NULL,
    "LOCATION_ID" BIGINT NOT NULL,
    "SITE_GROUP" INTEGER,
    "HMM_END" INTEGER,
    "HMM_START" INTEGER,
    "SITE_LABEL" VARCHAR(255)
);      
ALTER TABLE "PUBLIC"."HMMER3_SITE" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_40D" PRIMARY KEY("ID"); 
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.HMMER3_SITE;              
CREATE CACHED TABLE "PUBLIC"."HMMER_SITE"(
    "ID" BIGINT NOT NULL,
    "DESCRIPTION" VARCHAR(255),
    "NUM_LOCATIONS" INTEGER NOT NULL,
    "LOCATION_ID" BIGINT NOT NULL
);
ALTER TABLE "PUBLIC"."HMMER_SITE" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_5F5" PRIMARY KEY("ID");  
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.HMMER_SITE;               
CREATE CACHED TABLE "PUBLIC"."KEY_GEN"(
    "SEQUENCE_NAME" VARCHAR(255) NOT NULL,
    "NEXT_VAL" BIGINT
);    
ALTER TABLE "PUBLIC"."KEY_GEN" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_FA" PRIMARY KEY("SEQUENCE_NAME");           
-- 16 +/- SELECT COUNT(*) FROM PUBLIC.KEY_GEN; 
INSERT INTO "PUBLIC"."KEY_GEN" VALUES
('signature', 291350),
('locationFragment', 0),
('signature_library_release', 23),
('match', 0),
('step_execution', 0),
('nucleotide', 0),
('protein', 0),
('release', 1),
('location', 0),
('step_instance', 0),
('orf', 0),
('entry', 37850),
('model', 485700),
('site', 0),
('residue_location', 0),
('xref', 0);    
CREATE CACHED TABLE "PUBLIC"."MOBIDB_LOCATION"(
    "ID" BIGINT NOT NULL,
    "LOC_END" INTEGER NOT NULL,
    "LOC_START" INTEGER NOT NULL,
    "MATCH_ID" BIGINT NOT NULL,
    "SEQUENCE_FEATURE" VARCHAR(255)
);             
ALTER TABLE "PUBLIC"."MOBIDB_LOCATION" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_96" PRIMARY KEY("ID");              
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.MOBIDB_LOCATION;          
CREATE CACHED TABLE "PUBLIC"."MOBIDB_LOCATION_FRAGMENT"(
    "ID" BIGINT NOT NULL,
    "DC_STATUS" VARCHAR(255) NOT NULL,
    "LOC_END" INTEGER NOT NULL,
    "LOC_START" INTEGER NOT NULL,
    "LOCATION_ID" BIGINT NOT NULL
);               
ALTER TABLE "PUBLIC"."MOBIDB_LOCATION_FRAGMENT" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_8" PRIMARY KEY("ID");      
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.MOBIDB_LOCATION_FRAGMENT; 
CREATE CACHED TABLE "PUBLIC"."MOBIDB_MATCH"(
    "ID" BIGINT NOT NULL,
    "SIGNATURE_MODELS" VARCHAR(255),
    "PROTEIN_ID" BIGINT NOT NULL,
    "SIGNATURE_ID" BIGINT NOT NULL
);            
ALTER TABLE "PUBLIC"."MOBIDB_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_67" PRIMARY KEY("ID"); 
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.MOBIDB_MATCH;             
CREATE CACHED TABLE "PUBLIC"."MOBIDB_RAW_MATCH"(
    "ID" BIGINT NOT NULL,
    "LOC_FRAGMENT_DCS_TATUS" VARCHAR(255),
    "LOCATION_END" INTEGER,
    "LOCATION_START" INTEGER,
    "MODEL_ID" VARCHAR(255),
    "NUMERIC_SEQUENCE_ID" BIGINT,
    "SEQUENCE_ID" VARCHAR(255),
    "SIGNATURE_LIBRARY" VARCHAR(255),
    "SIG_LIB_RELEASE" VARCHAR(255),
    "DESCRIPTION" VARCHAR(255)
);     
ALTER TABLE "PUBLIC"."MOBIDB_RAW_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_66" PRIMARY KEY("ID");             
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.MOBIDB_RAW_MATCH;         
CREATE INDEX "PUBLIC"."MOBIDB_RW_SEQ_IDX" ON "PUBLIC"."MOBIDB_RAW_MATCH"("SEQUENCE_ID");       
CREATE INDEX "PUBLIC"."MOBIDB_RW_NUM_SEQ_IDX" ON "PUBLIC"."MOBIDB_RAW_MATCH"("NUMERIC_SEQUENCE_ID");           
CREATE INDEX "PUBLIC"."MOBIDB_RW_MODEL_IDX" ON "PUBLIC"."MOBIDB_RAW_MATCH"("MODEL_ID");        
CREATE INDEX "PUBLIC"."MOBIDB_RW_SIGLIB_IDX" ON "PUBLIC"."MOBIDB_RAW_MATCH"("SIGNATURE_LIBRARY");              
CREATE INDEX "PUBLIC"."MOBIDB_RW_SIGLIB_REL_IDX" ON "PUBLIC"."MOBIDB_RAW_MATCH"("SIG_LIB_RELEASE");            
CREATE CACHED TABLE "PUBLIC"."MODEL"(
    "ID" BIGINT NOT NULL SELECTIVITY 100,
    "ACCESSION" VARCHAR(255) NOT NULL SELECTIVITY 100,
    "DEFINITION_FIRST_CHUNK" VARCHAR(4000) SELECTIVITY 1,
    "DESCRIPTION_FIRST_CHUNK" VARCHAR(4000) SELECTIVITY 95,
    "MODEL_LENGTH" INTEGER SELECTIVITY 16,
    "MD5" VARCHAR(255) SELECTIVITY 1,
    "MODEL_NAME" VARCHAR(4000) SELECTIVITY 99,
    "SIGNATURE_ID" BIGINT SELECTIVITY 100
);      
ALTER TABLE "PUBLIC"."MODEL" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_46" PRIMARY KEY("ID");        
-- 485610 +/- SELECT COUNT(*) FROM PUBLIC.MODEL;               
INSERT INTO "PUBLIC"."MODEL" VALUES
(1, 'ANF00102', NULL, 'Shadow ORF (opposite aat)', 97, NULL, 'Spurious_ORF_102', 1),
(2, 'ANF00185', NULL, 'Shadow ORF (opposite ybhD)', 77, NULL, 'Spurious_ORF_185', 2),
(3, 'ANF00222', NULL, 'Shadow ORF (opposite groL1)', 512, NULL, 'Spurious_ORF_222', 3),
(4, 'ANF00047', NULL, 'Overlaps RNaseP, same strand', 64, NULL, 'Spurious_ORF_47', 4),
(5, 'ANF00207', NULL, 'Shadow ORF (opposite glnS)', 81, NULL, 'Spurious_ORF_207', 5),
(6, 'ANF00119', NULL, 'Shadow ORF (opposite ftsZ)', 303, NULL, 'Spurious_ORF_119', 6),
(7, 'ANF00062', NULL, 'Shadow ORF (opposite ABC transporter protein)', 39, NULL, 'Spurious_ORF_62', 7),
(8, 'ANF00153', NULL, 'Shadow ORF (opposite rodA)', 74, NULL, 'Spurious_ORF_153', 8),
(9, 'ANF00081', NULL, 'Shadow ORF (opposite lysS)', 139, NULL, 'Spurious_ORF_81', 9),
(10, 'ANF00121', NULL, 'Shadow ORF (opposite algI)', 184, NULL, 'Spurious_ORF_121', 10),
(11, 'ANF00134', NULL, 'Shadow ORF (opposite odhA)', 289, NULL, 'Spurious_ORF_134', 11),
(12, 'ANF00079', NULL, 'Shadow ORF (opposite rarA)', 33, NULL, 'Spurious_ORF_79', 12),
(13, 'ANF00094', NULL, 'Shadow ORF (opposite kynA)', 202, NULL, 'Spurious_ORF_94', 13),
(14, 'ANF00015', NULL, 'tRNA translation', 29, NULL, 'Spurious_ORF_15', 14),
(15, 'ANF00106', NULL, 'Shadow ORF (opposite InsH)', 63, NULL, 'Spurious_ORF_106', 15),
(16, 'ANF00239', NULL, 'Shadow ORF (opposite y4bM)', 112, NULL, 'Spurious_ORF_239', 16),
(17, 'ANF00043', NULL, 'Antisense to RNaseP', 45, NULL, 'Spurious_ORF_43', 17),
(18, 'ANF00066', NULL, 'Translation of palindromic DNA repeat', 35, NULL, 'Spurious_ORF_66', 18),
(19, 'ANF00140', NULL, 'Shadow ORF (opposite ResIII Domain)', 404, NULL, 'Spurious_ORF_140', 19),
(20, 'ANF00260', NULL, 'Protein of unknown function (DUF2575)', 71, NULL, 'Spurious_ORF_260', 20),
(21, 'ANF00172', NULL, 'Shadow ORF (opposite lhr)', 197, NULL, 'Spurious_ORF_172', 21),
(22, 'ANF00019', NULL, 'tRNA translation', 29, NULL, 'Spurious_ORF_19', 22),
(23, 'ANF00130', NULL, 'Shadow ORF (opposite rnfC)', 166, NULL, 'Spurious_ORF_130', 23),
(24, 'ANF00235', NULL, 'Shadow ORF (opposite ycf24)', 322, NULL, 'Spurious_ORF_235', 24),
(25, 'ANF00258', NULL, 'Domain of unknown function (DUF1196)', 51, NULL, 'Spurious_ORF_258', 25),
(26, 'ANF00254', NULL, 'DNA repeat', 52, NULL, 'Spurious_ORF_254', 26),
(27, 'ANF00176', NULL, 'Shadow ORF (opposite nrdR)', 33, NULL, 'Spurious_ORF_176', 27),
(28, 'ANF00085', NULL, 'Shadow ORF (opposite pacL)', 208, NULL, 'Spurious_ORF_85', 28),
(29, 'ANF00166', NULL, 'Shadow ORF (opposite ndh)', 192, NULL, 'Spurious_ORF_166', 29),
(30, 'ANF00179', NULL, 'Shadow ORF (opposite mobL)', 126, NULL, 'Spurious_ORF_179', 30),
(31, 'ANF00098', NULL, 'Shadow ORF (opposite leuC)', 218, NULL, 'Spurious_ORF_98', 31),
(32, 'ANF00075', NULL, 'Shadow ORF (opposite prpE)', 131, NULL, 'Spurious_ORF_75', 32),
(33, 'ANF00241', NULL, 'Shadow ORF (opposite mro)', 157, NULL, 'Spurious_ORF_241', 33),
(34, 'ANF00189', NULL, 'Shadow ORF (opposite fumA)', 45, NULL, 'Spurious_ORF_189', 34),
(35, 'ANF00071', NULL, 'Translation of intergenic region', 52, NULL, 'Spurious_ORF_71', 35),
(36, 'ANF00248', NULL, 'Shadow ORF (opposite ppsD)', 121, NULL, 'Spurious_ORF_248', 36),
(37, 'ANF00264', NULL, 'Spurious protein deried frameshifted phage protein', 55, NULL, 'Spurious_ORF_264', 37),
(38, 'ANF00089', NULL, 'Shadow ORF (opposite rplC)', 129, NULL, 'Spurious_ORF_89', 38),
(39, 'ANF00144', NULL, 'Shadow ORF (opposite pstP)', 237, NULL, 'Spurious_ORF_144', 39),
(40, 'ANF00231', NULL, 'Shadow ORF (opposite rplA)', 179, NULL, 'Spurious_ORF_231', 40),
(41, 'ANF00006', NULL, 'Translation of CRISPR region', 50, NULL, 'Spurious_ORF_06', 41),
(42, 'ANF00056', NULL, 'Translation of DNA repeat', 36, NULL, 'Spurious_ORF_56', 42),
(43, 'ANF00111', NULL, 'Shadow ORF (opposite rpfG)', 114, NULL, 'Spurious_ORF_111', 43),
(44, 'ANF00263', NULL, 'Spurious protein deried from human HSATII repeats', 92, NULL, 'Spurious_ORF_263', 44),
(45, 'ANF00038', NULL, 'Overlaps SRP RNA, same strand', 86, NULL, 'Spurious_ORF_38', 45),
(46, 'ANF00112', NULL, 'Shadow ORF (opposite phnC)', 76, NULL, 'Spurious_ORF_112', 46);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(47, 'ANF00005', NULL, 'Antisense to 23S rRNA', 105, NULL, 'Spurious_ORF_05', 47),
(48, 'ANF00249', NULL, 'Shadow ORF (ywcA)', 176, NULL, 'Spurious_ORF_249', 48),
(49, 'ANF00191', NULL, 'Shadow ORF (opposite rplU)', 63, NULL, 'Spurious_ORF_191', 49),
(50, 'ANF00216', NULL, 'Shadow ORF (opposite pepPI)', 295, NULL, 'Spurious_ORF_216', 50),
(51, 'ANF00250', NULL, 'Shadow ORF (opposite ACADL)', 90, NULL, 'Spurious_ORF_250', 51),
(52, 'ANF00124', NULL, 'Shadow ORF (opposite mscK)', 80, NULL, 'Spurious_ORF_124', 52),
(53, 'ANF00229', NULL, 'Shadow ORF (opposite tilS)', 89, NULL, 'Spurious_ORF_229', 53),
(54, 'ANF00025', NULL, 'Antisense to 23S rRNA', 95, NULL, 'Spurious_ORF_25', 54),
(55, 'ANF00198', NULL, 'Shadow ORF (opposite pilG)', 87, NULL, 'Spurious_ORF_198', 55),
(56, 'ANF00076', NULL, 'Shadow ORF (opposite copA)', 224, NULL, 'Spurious_ORF_76', 56),
(57, 'ANF00157', NULL, 'Shadow ORF (opposite ileS)', 107, NULL, 'Spurious_ORF_157', 57),
(58, 'ANF00131', NULL, 'Shadow ORF (opposite qseC)', 84, NULL, 'Spurious_ORF_131', 58),
(59, 'ANF00018', NULL, 'tRNA translation', 28, NULL, 'Spurious_ORF_18', 59),
(60, 'ANF00190', NULL, 'Shadow ORF (opposite fur)', 94, NULL, 'Spurious_ORF_190', 60),
(61, 'ANF00203', NULL, 'Shadow ORF (opposite algB)', 94, NULL, 'Spurious_ORF_203', 61),
(62, 'ANF00236', NULL, 'Shadow ORF (opposite sadA)', 77, NULL, 'Spurious_ORF_236', 62),
(63, 'ANF00171', NULL, 'Shadow ORF (opposite pikAII)', 370, NULL, 'Spurious_ORF_171', 63),
(64, 'ANF00090', NULL, 'Shadow ORF (opposite yegE)', 108, NULL, 'Spurious_ORF_90', 64),
(65, 'ANF00024', NULL, 'Antisense to 23S rRNA', 121, NULL, 'Spurious_ORF_24', 65),
(66, 'ANF00037', NULL, 'Overlap with RNaseP, same strand', 65, NULL, 'Spurious_ORF_37', 66),
(67, 'ANF00217', NULL, 'Shadow ORF (opposite uvrB)', 429, NULL, 'Spurious_ORF_217', 67),
(68, 'ANF00011', NULL, 'tRNA translation', 25, NULL, 'Spurious_ORF_11', 68),
(69, 'ANF00138', NULL, 'Shadow ORF (opposite ppc)', 86, NULL, 'Spurious_ORF_138', 69),
(70, 'ANF00044', NULL, 'Antisense to RNaseP', 139, NULL, 'Spurious_ORF_44', 70),
(71, 'ANF00105', NULL, 'Shadow ORF (opposite purF)', 51, NULL, 'Spurious_ORF_105', 71),
(72, 'ANF00125', NULL, 'Shadow ORF (opposite lpxD)', 210, NULL, 'Spurious_ORF_125', 72),
(73, 'ANF00057', NULL, 'Translation of E. coli type CRISPR repeat', 111, NULL, 'Spurious_ORF_57', 73),
(74, 'ANF00103', NULL, 'Shadow ORF (opposite can)', 121, NULL, 'Spurious_ORF_103', 74),
(75, 'ANF00046', NULL, 'Overlaps RNaseP, same strand', 117, NULL, 'Spurious_ORF_46', 75),
(76, 'ANF00095', NULL, 'Shadow ORF (opposite ABC transporters)', 229, NULL, 'Spurious_ORF_95', 76),
(77, 'ANF00221', NULL, 'Shadow ORF (opposite ureE)', 191, NULL, 'Spurious_ORF_221', 77),
(78, 'ANF00169', NULL, 'Shadow ORF (opposite dgdR)', 107, NULL, 'Spurious_ORF_169', 78),
(79, 'ANF00186', NULL, 'Shadow ORF (opposite rpmB)', 59, NULL, 'Spurious_ORF_186', 79),
(80, 'ANF00188', NULL, 'Shadow ORF (opposite dtd)', 89, NULL, 'Spurious_ORF_188', 80),
(81, 'ANF00150', NULL, 'Shadow ORF (opposite gltB)', 130, NULL, 'Spurious_ORF_150', 81),
(82, 'ANF00240', NULL, 'Shadow ORF (opposite frmR)', 64, NULL, 'Spurious_ORF_240', 82),
(83, 'ANF00167', NULL, 'Shadow ORF (opposite uxaA)', 225, NULL, 'Spurious_ORF_167', 83),
(84, 'ANF00257', NULL, 'Protein of unknown function (DUF1560)', 49, NULL, 'Spurious_ORF_257', 84),
(85, 'ANF00242', NULL, 'Shadow ORF (opposite carB)', 52, NULL, 'Spurious_ORF_242', 85),
(86, 'ANF00048', NULL, 'Contained within repeat in Vibrio superintegron', 31, NULL, 'Spurious_ORF_48', 86),
(87, 'ANF00101', NULL, 'Shadow ORF (opposite yjhX)', 59, NULL, 'Spurious_ORF_101', 87),
(88, 'ANF00010', NULL, 'tRNA translation', 25, NULL, 'Spurious_ORF_10', 88),
(89, 'ANF00139', NULL, 'Shadow ORF (opposite cya)', 81, NULL, 'Spurious_ORF_139', 89),
(90, 'ANF00084', NULL, 'Shadow ORF (opposite mutS)', 122, NULL, 'Spurious_ORF_84', 90),
(91, 'ANF00202', NULL, 'Shadow ORF (opposite gacS)', 53, NULL, 'Spurious_ORF_202', 91),
(92, 'ANF00219', NULL, 'Shadow ORF (opposite fpr)', 131, NULL, 'Spurious_ORF_219', 92),
(93, 'ANF00091', NULL, 'Shadow ORF (opposite smc)', 204, NULL, 'Spurious_ORF_91', 93);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(94, 'ANF00069', NULL, 'Translation of predicted DNA regulatory sequence', 89, NULL, 'Spurious_ORF_69', 94),
(95, 'ANF00029', NULL, 'Antisense to 16S rRNA', 62, NULL, 'Spurious_ORF_29', 95),
(96, 'ANF00261', NULL, 'Protein of unknown function (DUF1534)', 48, NULL, 'Spurious_ORF_261', 96),
(97, 'ANF00065', NULL, 'Translation of REP sequence', 34, NULL, 'Spurious_ORF_65', 97),
(98, 'ANF00146', NULL, 'Shadow ORF (opposite fprA)', 95, NULL, 'Spurious_ORF_146', 98),
(99, 'ANF00003', NULL, 'Shadow ORF', 61, NULL, 'Spurious_ORF_03', 99),
(100, 'ANF00120', NULL, 'Shadow ORF (opposite pinE)', 64, NULL, 'Spurious_ORF_120', 100),
(101, 'ANF00143', NULL, 'Shadow ORF (opposite mdtB)', 250, NULL, 'Spurious_ORF_143', 101),
(102, 'ANF00238', NULL, 'Shadow ORF (opposite gpx1)', 112, NULL, 'Spurious_ORF_238', 102),
(103, 'ANF00160', NULL, 'Shadow ORF (opposite NIK1)', 125, NULL, 'Spurious_ORF_160', 103),
(104, 'ANF00055', NULL, 'Translation of DNA repeat', 16, NULL, 'Spurious_ORF_55', 104),
(105, 'ANF00088', NULL, 'Shadow ORF (opposite Fdh)', 126, NULL, 'Spurious_ORF_88', 105),
(106, 'ANF00129', NULL, 'Shadow ORF (opposite rpoB)', 112, NULL, 'Spurious_ORF_129', 106),
(107, 'ANF00193', NULL, 'Shadow ORF (opposite ilvB)', 109, NULL, 'Spurious_ORF_193', 107),
(108, 'ANF00127', NULL, 'Shadow ORF (opposite eno)', 244, NULL, 'Spurious_ORF_127', 108),
(109, 'ANF00162', NULL, 'Shadow ORF (opposite ppdK)', 354, NULL, 'Spurious_ORF_162', 109),
(110, 'ANF00022', NULL, 'Long non-coding RNA', 124, NULL, 'Spurious_ORF_22', 110),
(111, 'ANF00195', NULL, 'Shadow ORF (opposite cca)', 159, NULL, 'Spurious_ORF_195', 111),
(112, 'ANF00072', NULL, 'Shadow ORF (opposite TypA)', 143, NULL, 'Spurious_ORF_72', 112),
(113, 'ANF00212', NULL, 'Shadow ORF (opposite kdsA)', 170, NULL, 'Spurious_ORF_212', 113),
(114, 'ANF00086', NULL, 'Shadow ORF (opposite lon)', 379, NULL, 'Spurious_ORF_86', 114),
(115, 'ANF00074', NULL, 'Shadow ORF (opposite alaS)', 242, NULL, 'Spurious_ORF_74', 115),
(116, 'ANF00020', NULL, 'tRNA translation', 27, NULL, 'Spurious_ORF_20', 116),
(117, 'ANF00245', NULL, 'Shadow ORF (opposite aceB)', 65, NULL, 'Spurious_ORF_245', 117),
(118, 'ANF00053', NULL, 'Translation of DNA repeat', 28, NULL, 'Spurious_ORF_53', 118),
(119, 'ANF00041', NULL, 'Antisense to RNaseP', 117, NULL, 'Spurious_ORF_41', 119),
(120, 'ANF00214', NULL, 'Shadow ORF (opposite aco-1)', 106, NULL, 'Spurious_ORF_214', 120),
(121, 'ANF00247', NULL, 'Shadow ORF (opposite tnpA)', 92, NULL, 'Spurious_ORF_247', 121),
(122, 'ANF00001', NULL, 'Shadow ORF', 50, NULL, 'Spurious_ORF_01', 122),
(123, 'ANF00181', NULL, 'Shadow ORF (opposite rpmE)', 43, NULL, 'Spurious_ORF_181', 123),
(124, 'ANF00027', NULL, 'Antisense to SAM riboswitch', 38, NULL, 'Spurious_ORF_27', 124),
(125, 'ANF00108', NULL, 'Shadow ORF (opposite rnpA)', 71, NULL, 'Spurious_ORF_108', 125),
(126, 'ANF00226', NULL, 'Shadow ORF (opposite pknB)', 146, NULL, 'Spurious_ORF_226', 126),
(127, 'ANF00252', NULL, 'Shadow ORF (formerly DUF1590)', 32, NULL, 'Spurious_ORF_252', 127),
(128, 'ANF00122', NULL, 'Shadow ORF (opposite clpB)', 179, NULL, 'Spurious_ORF_122', 128),
(129, 'ANF00259', NULL, 'Protein of unknown function (DUF1472)', 101, NULL, 'Spurious_ORF_259', 129),
(130, 'ANF00233', NULL, 'Shadow ORF (opposite trxB)', 275, NULL, 'Spurious_ORF_233', 130),
(131, 'ANF00008', NULL, 'Translation of CRISPR region', 39, NULL, 'Spurious_ORF_08', 131),
(132, 'ANF00093', NULL, 'Shadow ORF (opposite nagR)', 142, NULL, 'Spurious_ORF_93', 132),
(133, 'ANF00174', NULL, 'Shadow ORF (irp2)', 209, NULL, 'Spurious_ORF_174', 133),
(134, 'ANF00067', NULL, 'Translation of non-protein-coding upstream region of an enzyme', 50, NULL, 'Spurious_ORF_67', 134),
(135, 'ANF00141', NULL, 'Shadow ORF (opposite guaB)', 315, NULL, 'Spurious_ORF_141', 135),
(136, 'ANF00060', NULL, 'FAM74 lncRNA', 127, NULL, 'Spurious_ORF_60', 136),
(137, 'ANF00034', NULL, 'Antisense to 5.8S rRNA', 51, NULL, 'Spurious_ORF_34', 137),
(138, 'ANF00115', NULL, 'Shadow ORF (opposite Oplah)', 157, NULL, 'Spurious_ORF_115', 138),
(139, 'ANF00200', NULL, 'Shadow ORF (opposite yrdD)', 44, NULL, 'Spurious_ORF_200', 139);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(140, 'ANF00148', NULL, 'Shadow ORF (opposite flhA)', 263, NULL, 'Spurious_ORF_148', 140),
(141, 'ANF00256', NULL, 'Protein of unknown function (DUF1586)', 22, NULL, 'Spurious_ORF_256', 141),
(142, 'ANF00104', NULL, 'Shadow ORF (opposite FlhA)', 134, NULL, 'Spurious_ORF_104', 142),
(143, 'ANF00064', NULL, 'Unclear; Possibly translation of poorly localized IS Element IS621', 35, NULL, 'Spurious_ORF_64', 143),
(144, 'ANF00187', NULL, 'Shadow ORF (opposite parA)', 203, NULL, 'Spurious_ORF_187', 144),
(145, 'ANF00168', NULL, 'Shadow ORF (opposite smc)', 267, NULL, 'Spurious_ORF_168', 145),
(146, 'ANF00013', NULL, 'tRNA translation', 24, NULL, 'Spurious_ORF_13', 146),
(147, 'ANF00136', NULL, 'Shadow ORF (opposite garK)', 64, NULL, 'Spurious_ORF_136', 147),
(148, 'ANF00209', NULL, 'Shadow ORF (opposite thrS)', 192, NULL, 'Spurious_ORF_209', 148),
(149, 'ANF00045', NULL, 'Antisense to RNaseP', 59, NULL, 'Spurious_ORF_45', 149),
(150, 'ANF00155', NULL, 'Shadow ORF (opposite secY)', 394, NULL, 'Spurious_ORF_155', 150),
(151, 'ANF00237', NULL, 'Shadow ORF (opposite ahcY)', 401, NULL, 'Spurious_ORF_237', 151),
(152, 'ANF00170', NULL, 'Shadow ORF (opposite rpoB)', 27, NULL, 'Spurious_ORF_170', 152),
(153, 'ANF00017', NULL, 'tRNA translation', 24, NULL, 'Spurious_ORF_17', 153),
(154, 'ANF00224', NULL, 'Shadow ORF (opposite pntA)', 55, NULL, 'Spurious_ORF_224', 154),
(155, 'ANF00183', NULL, 'Shadow ORF (opposite rarD)', 117, NULL, 'Spurious_ORF_183', 155),
(156, 'ANF00068', NULL, 'Translation of DNA repeat', 35, NULL, 'Spurious_ORF_68', 156),
(157, 'ANF00149', NULL, 'Shadow ORF (opposite cshA)', 313, NULL, 'Spurious_ORF_149', 157),
(158, 'ANF00092', NULL, 'Shadow ORF (opposite soxA)', 326, NULL, 'Spurious_ORF_92', 158),
(159, 'ANF00201', NULL, 'Shadow ORF (opposite gacS)', 86, NULL, 'Spurious_ORF_201', 159),
(160, 'ANF00026', NULL, 'Overlaps glmS ribozyme', 57, NULL, 'Spurious_ORF_26', 160),
(161, 'ANF00123', NULL, 'Shadow ORF (opposite nasD)', 101, NULL, 'Spurious_ORF_123', 161),
(162, 'ANF00228', NULL, 'Shadow ORF (opposite rbsA1)', 48, NULL, 'Spurious_ORF_228', 162),
(163, 'ANF00218', NULL, 'Shadow ORF (opposite Oca2)', 103, NULL, 'Spurious_ORF_218', 163),
(164, 'ANF00211', NULL, 'Shadow ORF (opposite nasD)', 185, NULL, 'Spurious_ORF_211', 164),
(165, 'ANF00036', NULL, 'Antisense to RNaseP', 110, NULL, 'Spurious_ORF_36', 165),
(166, 'ANF00032', NULL, 'Antisense to tmRNA', 57, NULL, 'Spurious_ORF_32', 166),
(167, 'ANF00113', NULL, 'Shadow ORF (opposite OPLAH)', 76, NULL, 'Spurious_ORF_113', 167),
(168, 'ANF00100', NULL, 'Shadow ORF (opposite leuC)', 105, NULL, 'Spurious_ORF_100', 168),
(169, 'ANF00117', NULL, 'Shadow ORF (opposite PRN2)', 105, NULL, 'Spurious_ORF_117', 169),
(170, 'ANF00205', NULL, 'Shadow ORF (opposite nemA)', 85, NULL, 'Spurious_ORF_205', 170),
(171, 'ANF00049', NULL, 'Contained within insertion sequence ISlin1', 76, NULL, 'Spurious_ORF_49', 171),
(172, 'ANF00110', NULL, 'Shadow ORF (opposite hemE)', 289, NULL, 'Spurious_ORF_110', 172),
(173, 'ANF00039', NULL, 'Antisense to SRP RNA', 90, NULL, 'Spurious_ORF_39', 173),
(174, 'ANF00230', NULL, 'Shadow ORF (opposite rpoZ)', 96, NULL, 'Spurious_ORF_230', 174),
(175, 'ANF00178', NULL, 'Shadow ORF (opposite dhbF)', 858, NULL, 'Spurious_ORF_178', 175),
(176, 'ANF00023', NULL, 'Spurious family', 70, NULL, 'Spurious_ORF_23', 176),
(177, 'ANF00004', NULL, 'Shadow ORF', 40, NULL, 'Spurious_ORF_04', 177),
(178, 'ANF00177', NULL, 'Shadow ORF (opposite rpsU)', 78, NULL, 'Spurious_ORF_177', 178),
(179, 'ANF00262', NULL, 'Sheep genome contamination of bacterial genome', 68, NULL, 'Spurious_ORF_262', 179),
(180, 'ANF00145', NULL, 'Shadow ORF (opposite macB)', 46, NULL, 'Spurious_ORF_145', 180),
(181, 'ANF00126', NULL, 'Shadow ORF (opposite kdpA)', 45, NULL, 'Spurious_ORF_126', 181),
(182, 'ANF00196', NULL, 'Shadow ORF (opposite deoA)', 216, NULL, 'Spurious_ORF_196', 182),
(183, 'ANF00159', NULL, 'Shadow ORF (opposite uvrA)', 142, NULL, 'Spurious_ORF_159', 183),
(184, 'ANF00058', NULL, 'Translation of ribosomal DNA repeat', 80, NULL, 'Spurious_ORF_58', 184);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(185, 'ANF00051', NULL, 'Translation of DNA tandem repeat', 29, NULL, 'Spurious_ORF_51', 185),
(186, 'ANF00165', NULL, 'Shadow ORF (opposite Transposase_Mut domain)', 72, NULL, 'Spurious_ORF_165', 186),
(187, 'ANF00243', NULL, 'Shadow ORF (opposite yfeH)', 306, NULL, 'Spurious_ORF_243', 187),
(188, 'ANF00132', NULL, 'Shadow ORF (opposite rne)', 263, NULL, 'Spurious_ORF_132', 188),
(189, 'ANF00050', NULL, 'Translation of CRISPR YPEST repeat 1', 29, NULL, 'Spurious_ORF_50', 189),
(190, 'ANF00164', NULL, 'Shadow ORF (opposite btuB)', 70, NULL, 'Spurious_ORF_164', 190),
(191, 'ANF00210', NULL, 'Shadow ORF (opposite tuaD)', 78, NULL, 'Spurious_ORF_210', 191),
(192, 'ANF00077', NULL, 'Shadow ORF (opposite AtoC)', 135, NULL, 'Spurious_ORF_77', 192),
(193, 'ANF00158', NULL, 'Shadow ORF (opposite ftsK2)', 184, NULL, 'Spurious_ORF_158', 193),
(194, 'ANF00070', NULL, 'Spurious family', 82, NULL, 'Spurious_ORF_70', 194),
(195, 'ANF00151', NULL, 'Shadow ORF (opposite dapD)', 153, NULL, 'Spurious_ORF_151', 195),
(196, 'ANF00184', NULL, 'Shadow ORF (opposite pur8)', 41, NULL, 'Spurious_ORF_184', 196),
(197, 'ANF00083', NULL, 'Shadow ORF (opposite leuS)', 216, NULL, 'Spurious_ORF_83', 197),
(198, 'ANF00197', NULL, 'Shadow ORF (opposite mdh)', 320, NULL, 'Spurious_ORF_197', 198),
(199, 'ANF00223', NULL, 'Shadow ORF (opposite guaB)', 61, NULL, 'Spurious_ORF_223', 199),
(200, 'ANF00063', NULL, 'Antisense to ATP synthase alpha subunit', 156, NULL, 'Spurious_ORF_63', 200),
(201, 'ANF00152', NULL, 'Shadow ORF (opposite nadB1)', 350, NULL, 'Spurious_ORF_152', 201),
(202, 'ANF00014', NULL, 'tRNA translation', 25, NULL, 'Spurious_ORF_14', 202),
(203, 'ANF00097', NULL, 'Shadow ORF (opposite CRYZ)', 152, NULL, 'Spurious_ORF_97', 203),
(204, 'ANF00135', NULL, 'Shadow ORF (opposite gmr)', 100, NULL, 'Spurious_ORF_135', 204),
(205, 'ANF00031', NULL, 'Antisense to tmRNA', 39, NULL, 'Spurious_ORF_31', 205),
(206, 'ANF00137', NULL, 'Shadow ORF (opposite dnaQ)', 99, NULL, 'Spurious_ORF_137', 206),
(207, 'ANF00208', NULL, 'Shadow ORF (opposite rpmJ)', 25, NULL, 'Spurious_ORF_208', 207),
(208, 'ANF00080', NULL, 'Shadow ORF (opposite dnaE)', 171, NULL, 'Spurious_ORF_80', 208),
(209, 'ANF00154', NULL, 'Shadow ORF (opposite mnmG)', 221, NULL, 'Spurious_ORF_154', 209),
(210, 'ANF00099', NULL, 'Shadow ORF (opposite glcB)', 489, NULL, 'Spurious_ORF_99', 210),
(211, 'ANF00204', NULL, 'Shadow ORF (opposite rpsA)', 193, NULL, 'Spurious_ORF_204', 211),
(212, 'ANF00118', NULL, 'Shadow ORF (opposite ucp12)', 164, NULL, 'Spurious_ORF_118', 212),
(213, 'ANF00061', NULL, 'FAM182 lncRNA', 95, NULL, 'Spurious_ORF_61', 213),
(214, 'ANF00082', NULL, 'Shadow ORF (opposite glgX)', 121, NULL, 'Spurious_ORF_82', 214),
(215, 'ANF00012', NULL, 'tRNA translation', 25, NULL, 'Spurious_ORF_12', 215),
(216, 'ANF00255', NULL, 'Protein of unknown function (DUF1584)', 27, NULL, 'Spurious_ORF_255', 216),
(217, 'ANF00033', NULL, 'Antisense to tmRNA', 96, NULL, 'Spurious_ORF_33', 217),
(218, 'ANF00116', NULL, 'Shadow ORF (opposite cobK)', 216, NULL, 'Spurious_ORF_116', 218),
(219, 'ANF00206', NULL, 'Shadow ORF (opposite sucB)', 80, NULL, 'Spurious_ORF_206', 219),
(220, 'ANF00251', NULL, 'Shadow ORF (opposite moaA)', 190, NULL, 'Spurious_ORF_251', 220),
(221, 'ANF00042', NULL, 'Antisense to RNaseP', 78, NULL, 'Spurious_ORF_42', 221),
(222, 'ANF00035', NULL, 'Antisense to 23S rRNA', 36, NULL, 'Spurious_ORF_35', 222),
(223, 'ANF00199', NULL, 'Shadow ORF (opposite gltB)', 293, NULL, 'Spurious_ORF_199', 223),
(224, 'ANF00059', NULL, 'Ret finger protein-like 3 antisense', 124, NULL, 'Spurious_ORF_59', 224),
(225, 'ANF00173', NULL, 'Shadow ORF (opposite ppk)', 424, NULL, 'Spurious_ORF_173', 225),
(226, 'ANF00234', NULL, 'Shadow ORF (opposite dnaE1)', 145, NULL, 'Spurious_ORF_234', 226),
(227, 'ANF00163', NULL, 'Shadow ORF (opposite pspPIM)', 166, NULL, 'Spurious_ORF_163', 227),
(228, 'ANF00078', NULL, 'Shadow ORF (opposite pccB)', 93, NULL, 'Spurious_ORF_78', 228),
(229, 'ANF00244', NULL, 'Shadow ORF (yokA)', 169, NULL, 'Spurious_ORF_244', 229),
(230, 'ANF00225', NULL, 'Shadow ORF (opposite tuf)', 356, NULL, 'Spurious_ORF_225', 230);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(231, 'ANF00182', NULL, 'Shadow ORF (opposite rplL)', 115, NULL, 'Spurious_ORF_182', 231),
(232, 'ANF00156', NULL, 'Shadow ORF (opposite yahK)', 169, NULL, 'Spurious_ORF_156', 232),
(233, 'ANF00052', NULL, 'Translation of DNA tandem repeat', 46, NULL, 'Spurious_ORF_52', 233),
(234, 'ANF00215', NULL, 'Shadow ORF (opposite nolG)', 52, NULL, 'Spurious_ORF_215', 234),
(235, 'ANF00107', NULL, 'Shadow ORF (opposite qor)', 125, NULL, 'Spurious_ORF_107', 235),
(236, 'ANF00192', NULL, 'Shadow ORF (opposite ethA)', 261, NULL, 'Spurious_ORF_192', 236),
(237, 'ANF00016', NULL, 'tRNA translation', 28, NULL, 'Spurious_ORF_16', 237),
(238, 'ANF00133', NULL, 'Shadow ORF (opposite mccA)', 242, NULL, 'Spurious_ORF_133', 238),
(239, 'ANF00128', NULL, 'Shadow ORF (ftsA)', 149, NULL, 'Spurious_ORF_128', 239),
(240, 'ANF00021', NULL, 'Incorrect frame translation', 23, NULL, 'Spurious_ORF_21', 240),
(241, 'ANF00194', NULL, 'Shadow ORF (opposite ams)', 283, NULL, 'Spurious_ORF_194', 241),
(242, 'ANF00161', NULL, 'Shadow ORF (opposite leuA)', 77, NULL, 'Spurious_ORF_161', 242),
(243, 'ANF00054', NULL, 'Translation of long non-coding RNA DLEU2', 53, NULL, 'Spurious_ORF_54', 243),
(244, 'ANF00087', NULL, 'Shadow ORF (opposite mnmG)', 177, NULL, 'Spurious_ORF_87', 244),
(245, 'ANF00147', NULL, 'Shadow ORF (opposite ptlH)', 153, NULL, 'Spurious_ORF_147', 245),
(246, 'ANF00175', NULL, 'Shadow ORF (opposite plcN)', 217, NULL, 'Spurious_ORF_175', 246),
(247, 'ANF00009', NULL, 'Shadow ORF (opposite transposase protein)', 94, NULL, 'Spurious_ORF_09', 247),
(248, 'ANF00114', NULL, 'Shadow ORF (opposite afsK)', 46, NULL, 'Spurious_ORF_114', 248),
(249, 'ANF00007', NULL, 'Shadow ORF (opposite clpB)', 609, NULL, 'Spurious_ORF_07', 249),
(250, 'ANF00265', NULL, 'Borrelia repeat', 18, NULL, 'Spurious_ORF_265', 250),
(251, 'ANF00002', NULL, 'Shadow ORF', 114, NULL, 'Spurious_ORF_02', 251),
(252, 'ANF00142', NULL, 'Shadow ORF (opposite yadG)', 74, NULL, 'Spurious_ORF_142', 252),
(253, 'ANF00232', NULL, 'Shadow ORF (opposite metK)', 124, NULL, 'Spurious_ORF_232', 253),
(254, 'ANF00227', NULL, 'Shadow ORF (opposite hmrR)', 97, NULL, 'Spurious_ORF_227', 254),
(255, 'ANF00109', NULL, 'Shadow ORF (opposite afsK)', 72, NULL, 'Spurious_ORF_109', 255),
(256, 'ANF00253', NULL, 'DNA repeat (formerly DUF1658)', 21, NULL, 'Spurious_ORF_253', 256),
(257, 'ANF00028', NULL, 'Antisense to SRP RNA', 65, NULL, 'Spurious_ORF_28', 257),
(258, 'ANF00180', NULL, 'Shadow ORF (opposite PGK1)', 157, NULL, 'Spurious_ORF_180', 258),
(259, 'ANF00040', NULL, 'Overlaps SRP RNA, same strand', 97, NULL, 'Spurious_ORF_40', 259),
(260, 'ANF00220', NULL, 'Shadow ORF (opposite fdxA)', 55, NULL, 'Spurious_ORF_220', 260),
(261, 'ANF00246', NULL, 'Shadow ORF (opposite dctM)', 82, NULL, 'Spurious_ORF_246', 261),
(262, 'ANF00073', NULL, 'Shadow ORF', 161, NULL, 'Spurious_ORF_73', 262),
(263, 'ANF00213', NULL, 'Shadow ORF (opposite glyS)', 121, NULL, 'Spurious_ORF_213', 263),
(264, 'cd12843', NULL, 'Bvu_2165_C_like', NULL, NULL, 'Bvu_2165_C_like', 264),
(265, 'cd10287', NULL, 'prolactin_2', NULL, NULL, 'prolactin_2', 265),
(266, 'cd03714', NULL, 'RT_DIRS1', NULL, NULL, 'RT_DIRS1', 266),
(267, 'cd17228', NULL, 'RA_ARAP3', NULL, NULL, 'RA_ARAP3', 267),
(268, 'cd16001', NULL, '7tmA_P2Y3-like', NULL, NULL, '7tmA_P2Y3-like', 268),
(269, 'cd18664', NULL, 'CD2_tandem_ScCHD1_like', NULL, NULL, 'CD2_tandem_ScCHD1_like', 269),
(270, 'cd05487', NULL, 'renin_like', NULL, NULL, 'renin_like', 270),
(271, 'cd02608', NULL, 'P-type_ATPase_Na-K_like', NULL, NULL, 'P-type_ATPase_Na-K_like', 271),
(272, 'cd07727', NULL, 'YmaE-like_MBL-fold', NULL, NULL, 'YmaE-like_MBL-fold', 272),
(273, 'cd09204', NULL, 'PLDc_N_DEXD_b2', NULL, NULL, 'PLDc_N_DEXD_b2', 273),
(274, 'cd08963', NULL, 'L-asparaginase_I', NULL, NULL, 'L-asparaginase_I', 274),
(275, 'cd05349', NULL, 'BKR_2_SDR_c', NULL, NULL, 'BKR_2_SDR_c', 275),
(276, 'cd12708', NULL, 'RRM_RCAN1', NULL, NULL, 'RRM_RCAN1', 276),
(277, 'cd10376', NULL, 'SH2_STAT5', NULL, NULL, 'SH2_STAT5', 277),
(278, 'cd16783', NULL, 'mRING-HC-C2H2C4_MDM2', NULL, NULL, 'mRING-HC-C2H2C4_MDM2', 278);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(279, 'cd11583', NULL, 'Orc6_mid', NULL, NULL, 'Orc6_mid', 279),
(280, 'cd05704', NULL, 'S1_Rrp5_repeat_hs13', NULL, NULL, 'S1_Rrp5_repeat_hs13', 280),
(281, 'cd04334', NULL, 'ProRS-INS', NULL, NULL, 'ProRS-INS', 281),
(282, 'cd03128', NULL, 'GAT_1', NULL, NULL, 'GAT_1', 282),
(283, 'cd21589', NULL, 'betaCoV_RdRp', NULL, NULL, 'betaCoV_RdRp', 283),
(284, 'cd11750', NULL, 'GH94N_like_3', NULL, NULL, 'GH94N_like_3', 284),
(285, 'cd03187', NULL, 'GST_C_Phi', NULL, NULL, 'GST_C_Phi', 285),
(286, 'cd11402', NULL, 'bHLHzip_Mnt', NULL, NULL, 'bHLHzip_Mnt', 286),
(287, 'cd07972', NULL, 'OBF_DNA_ligase_Arch_LigB', NULL, NULL, 'OBF_DNA_ligase_Arch_LigB', 287),
(288, 'cd18087', NULL, 'TrmY-like', NULL, NULL, 'TrmY-like', 288),
(289, 'cd12903', NULL, 'SPRY_PRY_SPRYD4', NULL, NULL, 'SPRY_PRY_SPRYD4', 289),
(290, 'cd14054', NULL, 'STKc_BMPR2_AMHR2', NULL, NULL, 'STKc_BMPR2_AMHR2', 290),
(291, 'cd12635', NULL, 'RRM2_CELF3_4_5_6', NULL, NULL, 'RRM2_CELF3_4_5_6', 291),
(292, 'cd17101', NULL, 'FERM_F1_PTPN13_like', NULL, NULL, 'FERM_F1_PTPN13_like', 292),
(293, 'cd14080', NULL, 'STKc_TSSK-like', NULL, NULL, 'STKc_TSSK-like', 293),
(294, 'cd08179', NULL, 'NADPH_BDH', NULL, NULL, 'NADPH_BDH', 294),
(295, 'cd07052', NULL, 'BMC_like_1_repeat2', NULL, NULL, 'BMC_like_1_repeat2', 295),
(296, 'cd01995', NULL, 'ExsB', NULL, NULL, 'ExsB', 296),
(297, 'cd16568', NULL, 'RING-HC_ScPSH1_like', NULL, NULL, 'RING-HC_ScPSH1_like', 297),
(298, 'cd03045', NULL, 'GST_N_Delta_Epsilon', NULL, NULL, 'GST_N_Delta_Epsilon', 298),
(299, 'cd11736', NULL, 'HSPA12B_like_NBD', NULL, NULL, 'HSPA12B_like_NBD', 299),
(300, 'cd15203', NULL, '7tmA_NPYR-like', NULL, NULL, '7tmA_NPYR-like', 300),
(301, 'cd00950', NULL, 'DHDPS', NULL, NULL, 'DHDPS', 301),
(302, 'cd12183', NULL, 'LDH_like_2', NULL, NULL, 'LDH_like_2', 302),
(303, 'cd04501', NULL, 'SGNH_hydrolase_like_4', NULL, NULL, 'SGNH_hydrolase_like_4', 303),
(304, 'cd18992', NULL, 'LGIC_ECD_HisCl', NULL, NULL, 'LGIC_ECD_HisCl', 304),
(305, 'cd17436', NULL, 'MFS_GLUT10_Class3', NULL, NULL, 'MFS_GLUT10_Class3', 305),
(306, 'cd14758', NULL, 'GS_GGDEF_1', NULL, NULL, 'GS_GGDEF_1', 306),
(307, 'cd06142', NULL, 'RNaseD_exo', NULL, NULL, 'RNaseD_exo', 307),
(308, 'cd06350', NULL, 'PBP1_GPCR_family_C-like', NULL, NULL, 'PBP1_GPCR_family_C-like', 308),
(309, 'cd07028', NULL, 'RNAP_RPB3_like', NULL, NULL, 'RNAP_RPB3_like', 309),
(310, 'cd12271', NULL, 'RRM1_PHIP1', NULL, NULL, 'RRM1_PHIP1', 310),
(311, 'cd02183', NULL, 'GH16_fungal_CRH1_transglycosylase', NULL, NULL, 'GH16_fungal_CRH1_transglycosylase', 311),
(312, 'cd00078', NULL, 'HECTc', NULL, NULL, 'HECTc', 312),
(313, 'cd15470', NULL, 'Myo5_CBD', NULL, NULL, 'Myo5_CBD', 313),
(314, 'cd09146', NULL, 'PLDc_vPLD5_1', NULL, NULL, 'PLDc_vPLD5_1', 314),
(315, 'cd09444', NULL, 'LIM_Mical_like_1', NULL, NULL, 'LIM_Mical_like_1', 315),
(316, 'cd19404', NULL, 'TGF_beta_INHBA', NULL, NULL, 'TGF_beta_INHBA', 316),
(317, 'cd19114', NULL, 'AKR_AKR2C1', NULL, NULL, 'AKR_AKR2C1', 317),
(318, 'cd07802', NULL, 'FGGY_L-XK', NULL, NULL, 'FGGY_L-XK', 318),
(319, 'cd01972', NULL, 'Nitrogenase_VnfE_like', NULL, NULL, 'Nitrogenase_VnfE_like', 319),
(320, 'cd01944', NULL, 'YegV_kinase_like', NULL, NULL, 'YegV_kinase_like', 320),
(321, 'cd11653', NULL, 'rap1_RCT', NULL, NULL, 'rap1_RCT', 321),
(322, 'cd05675', NULL, 'M20_yscS_like', NULL, NULL, 'M20_yscS_like', 322),
(323, 'cd15441', NULL, '7tmB2_CELSR_Adhesion_IV', NULL, NULL, '7tmB2_CELSR_Adhesion_IV', 323),
(324, 'cd12069', NULL, 'SH3_ARHGAP27', NULL, NULL, 'SH3_ARHGAP27', 324),
(325, 'cd06060', NULL, 'misato', NULL, NULL, 'misato', 325),
(326, 'cd03821', NULL, 'GT4_Bme6-like', NULL, NULL, 'GT4_Bme6-like', 326),
(327, 'cd04445', NULL, 'DEP_PLEK1', NULL, NULL, 'DEP_PLEK1', 327),
(328, 'cd16690', NULL, 'RING-H2_Vps41', NULL, NULL, 'RING-H2_Vps41', 328),
(329, 'cd07039', NULL, 'TPP_PYR_POX', NULL, NULL, 'TPP_PYR_POX', 329),
(330, 'cd09572', NULL, 'SAM_tumor-p63', NULL, NULL, 'SAM_tumor-p63', 330),
(331, 'cd12591', NULL, 'RRM2_p54nrb', NULL, NULL, 'RRM2_p54nrb', 331),
(332, 'cd17215', NULL, 'RA_Rin1', NULL, NULL, 'RA_Rin1', 332);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(333, 'cd19767', NULL, 'Bbox2_TRIM13_C-XI', NULL, NULL, 'Bbox2_TRIM13_C-XI', 333),
(334, 'cd18627', NULL, 'CD_polycomb_like', NULL, NULL, 'CD_polycomb_like', 334),
(335, 'cd08376', NULL, 'C2B_MCTP_PRT', NULL, NULL, 'C2B_MCTP_PRT', 335),
(336, 'cd06590', NULL, 'RNase_HII_bacteria_HIII_like', NULL, NULL, 'RNase_HII_bacteria_HIII_like', 336),
(337, 'cd07676', NULL, 'F-BAR_FBP17', NULL, NULL, 'F-BAR_FBP17', 337),
(338, 'cd07224', NULL, 'Pat_like', NULL, NULL, 'Pat_like', 338),
(339, 'cd04617', NULL, 'CBS_pair_CcpN', NULL, NULL, 'CBS_pair_CcpN', 339),
(340, 'cd18986', NULL, 'CBD_ESA1_like', NULL, NULL, 'CBD_ESA1_like', 340),
(341, 'cd04892', NULL, 'ACT_AK-like_2', NULL, NULL, 'ACT_AK-like_2', 341),
(342, 'cd10807', NULL, 'YdjC_like_3', NULL, NULL, 'YdjC_like_3', 342),
(343, 'cd01181', NULL, 'IPT_plexin_repeat3', NULL, NULL, 'IPT_plexin_repeat3', 343),
(344, 'cd11285', NULL, 'ADF_Twf-N_like', NULL, NULL, 'ADF_Twf-N_like', 344),
(345, 'cd09141', NULL, 'PLDc_vPLD1_2_yPLD_like_2', NULL, NULL, 'PLDc_vPLD1_2_yPLD_like_2', 345),
(346, 'cd05102', NULL, 'PTKc_VEGFR3', NULL, NULL, 'PTKc_VEGFR3', 346),
(347, 'cd12450', NULL, 'RRM1_NUCLs', NULL, NULL, 'RRM1_NUCLs', 347),
(348, 'cd08706', NULL, 'RGS_R12-like', NULL, NULL, 'RGS_R12-like', 348),
(349, 'cd14760', NULL, 'GS_PAS-GGDEF-EAL', NULL, NULL, 'GS_PAS-GGDEF-EAL', 349),
(350, 'cd15024', NULL, '7tm_TAS2R42', NULL, NULL, '7tm_TAS2R42', 350),
(351, 'cd07662', NULL, 'BAR_SNX6', NULL, NULL, 'BAR_SNX6', 351),
(352, 'cd19079', NULL, 'AKR_EcYajO-like', NULL, NULL, 'AKR_EcYajO-like', 352),
(353, 'cd15708', NULL, 'ePHD_AF10', NULL, NULL, 'ePHD_AF10', 353),
(354, 'cd09926', NULL, 'SH2_CRK_like', NULL, NULL, 'SH2_CRK_like', 354),
(355, 'cd08937', NULL, 'DHB_DH-like_SDR_c', NULL, NULL, 'DHB_DH-like_SDR_c', 355),
(356, 'cd00160', NULL, 'RhoGEF', NULL, NULL, 'RhoGEF', 356),
(357, 'cd05701', NULL, 'S1_Rrp5_repeat_hs10', NULL, NULL, 'S1_Rrp5_repeat_hs10', 357),
(358, 'cd17994', NULL, 'DEXHc_CHD3_4_5', NULL, NULL, 'DEXHc_CHD3_4_5', 358),
(359, 'cd07080', NULL, 'ALDH_Acyl-CoA-Red_LuxC', NULL, NULL, 'ALDH_Acyl-CoA-Red_LuxC', 359),
(360, 'cd15697', NULL, 'ePHD2_KMT2C', NULL, NULL, 'ePHD2_KMT2C', 360),
(361, 'cd14994', NULL, '7tmA_GPR141', NULL, NULL, '7tmA_GPR141', 361),
(362, 'cd16139', NULL, 'RA_GRB14', NULL, NULL, 'RA_GRB14', 362),
(363, 'cd19930', NULL, 'REC_DesR-like', NULL, NULL, 'REC_DesR-like', 363),
(364, 'cd14668', NULL, 'mlta_B', NULL, NULL, 'mlta_B', 364),
(365, 'cd11755', NULL, 'GH94N_ChBP_like', NULL, NULL, 'GH94N_ChBP_like', 365),
(366, 'cd19421', NULL, 'lipocalin_5_8-like', NULL, NULL, 'lipocalin_5_8-like', 366),
(367, 'cd13857', NULL, 'CuRO_1_Diphenol_Ox', NULL, NULL, 'CuRO_1_Diphenol_Ox', 367),
(368, 'cd19616', NULL, 'FABP11', NULL, NULL, 'FABP11', 368),
(369, 'cd12341', NULL, 'RRM_hnRNPC_like', NULL, NULL, 'RRM_hnRNPC_like', 369),
(370, 'cd13529', NULL, 'PBP2_transferrin', NULL, NULL, 'PBP2_transferrin', 370),
(371, 'cd17919', NULL, 'DEXHc_Snf', NULL, NULL, 'DEXHc_Snf', 371),
(372, 'cd11570', NULL, 'FAT-like_NEDD9_C', NULL, NULL, 'FAT-like_NEDD9_C', 372),
(373, 'cd10941', NULL, 'CE4_PuuE_HpPgdA_like_2', NULL, NULL, 'CE4_PuuE_HpPgdA_like_2', 373),
(374, 'cd12214', NULL, 'ChiA1_BD', NULL, NULL, 'ChiA1_BD', 374),
(375, 'cd18328', NULL, 'BTB_POZ_ZBTB7C_ZBTB36', NULL, NULL, 'BTB_POZ_ZBTB7C_ZBTB36', 375),
(376, 'cd10144', NULL, 'Peptidase_S74_CIMCD', NULL, NULL, 'Peptidase_S74_CIMCD', 376),
(377, 'cd14639', NULL, 'DSP_DUSP5', NULL, NULL, 'DSP_DUSP5', 377),
(378, 'cd12780', NULL, 'RRM1_hnRNPL', NULL, NULL, 'RRM1_hnRNPL', 378),
(379, 'cd14953', NULL, 'NHL_like_1', NULL, NULL, 'NHL_like_1', 379),
(380, 'cd01611', NULL, 'Ubl_Autophagy_like', NULL, NULL, 'Ubl_Autophagy_like', 380),
(381, 'cd01107', NULL, 'HTH_BmrR', NULL, NULL, 'HTH_BmrR', 381),
(382, 'cd01338', NULL, 'MDH_choloroplast_like', NULL, NULL, 'MDH_choloroplast_like', 382),
(383, 'cd07886', NULL, 'RHD-n_RelB', NULL, NULL, 'RHD-n_RelB', 383),
(384, 'cd01471', NULL, 'vWA_micronemal_protein', NULL, NULL, 'vWA_micronemal_protein', 384),
(385, 'cd11534', NULL, 'NTP-PPase_HisIE_like', NULL, NULL, 'NTP-PPase_HisIE_like', 385);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(386, 'cd05476', NULL, 'pepsin_A_like_plant', NULL, NULL, 'pepsin_A_like_plant', 386),
(387, 'cd13414', NULL, 'TNFRSF17', NULL, NULL, 'TNFRSF17', 387),
(388, 'cd18176', NULL, 'ATP-synt_Vo_c_ATP6C_rpt2', NULL, NULL, 'ATP-synt_Vo_c_ATP6C_rpt2', 388),
(389, 'cd13619', NULL, 'PBP2_GlnP', NULL, NULL, 'PBP2_GlnP', 389),
(390, 'cd04970', NULL, 'Ig6_Contactin', NULL, NULL, 'Ig6_Contactin', 390),
(391, 'cd19753', NULL, 'Mb-like_oxidoreductase', NULL, NULL, 'Mb-like_oxidoreductase', 391),
(392, 'cd15275', NULL, '7tmB1_secretin', NULL, NULL, '7tmB1_secretin', 392),
(393, 'cd09891', NULL, 'NGN_Bact_1', NULL, NULL, 'NGN_Bact_1', 393),
(394, 'cd15359', NULL, '7tmA_LHCGR', NULL, NULL, '7tmA_LHCGR', 394),
(395, 'cd06494', NULL, 'p23_NUDCD2_like', NULL, NULL, 'p23_NUDCD2_like', 395),
(396, 'cd17455', NULL, 'MFS_FLVCR1', NULL, NULL, 'MFS_FLVCR1', 396),
(397, 'cd01022', NULL, 'GH57N_like', NULL, NULL, 'GH57N_like', 397),
(398, 'cd15749', NULL, 'FYVE_ZFY19', NULL, NULL, 'FYVE_ZFY19', 398),
(399, 'cd18529', NULL, 'BACK_RCBTB2', NULL, NULL, 'BACK_RCBTB2', 399),
(400, 'cd00326', NULL, 'alpha_CA', NULL, NULL, 'alpha_CA', 400),
(401, 'cd15244', NULL, '7tm_bacteriorhodopsin', NULL, NULL, '7tm_bacteriorhodopsin', 401),
(402, 'cd08647', NULL, 'FMT_core_FDH_N', NULL, NULL, 'FMT_core_FDH_N', 402),
(403, 'cd00411', NULL, 'L-asparaginase_like', NULL, NULL, 'L-asparaginase_like', 403),
(404, 'cd10047', NULL, 'Reelin_repeat_3_subrepeat_2', NULL, NULL, 'Reelin_repeat_3_subrepeat_2', 404),
(405, 'cd01948', NULL, 'EAL', NULL, NULL, 'EAL', 405),
(406, 'cd13775', NULL, 'SPFH_eoslipins_u3', NULL, NULL, 'SPFH_eoslipins_u3', 406),
(407, 'cd09466', NULL, 'LIM1_Lhx3a', NULL, NULL, 'LIM1_Lhx3a', 407),
(408, 'cd05651', NULL, 'M20_ArgE_DapE-like', NULL, NULL, 'M20_ArgE_DapE-like', 408),
(409, 'cd14436', NULL, 'LepB', NULL, NULL, 'LepB', 409),
(410, 'cd18442', NULL, 'BRCT_polymerase_mu', NULL, NULL, 'BRCT_polymerase_mu', 410),
(411, 'cd01412', NULL, 'SIRT5_Af1_CobB', NULL, NULL, 'SIRT5_Af1_CobB', 411),
(412, 'cd07211', NULL, 'Pat_PNPLA8', NULL, NULL, 'Pat_PNPLA8', 412),
(413, 'cd11860', NULL, 'SH3_DLG5', NULL, NULL, 'SH3_DLG5', 413),
(414, 'cd19129', NULL, 'AKR_BaDH-like', NULL, NULL, 'AKR_BaDH-like', 414),
(415, 'cd09570', NULL, 'SAM_kazrin_repeat3', NULL, NULL, 'SAM_kazrin_repeat3', 415),
(416, 'cd00599', NULL, 'GH25_muramidase', NULL, NULL, 'GH25_muramidase', 416),
(417, 'cd07548', NULL, 'P-type_ATPase-Cd_Zn_Co_like', NULL, NULL, 'P-type_ATPase-Cd_Zn_Co_like', 417),
(418, 'cd08428', NULL, 'PBP2_IciA_ArgP', NULL, NULL, 'PBP2_IciA_ArgP', 418),
(419, 'cd14772', NULL, 'TrHb2_Bs-trHb-like_O', NULL, NULL, 'TrHb2_Bs-trHb-like_O', 419),
(420, 'cd16249', NULL, 'EFh_DTNA', NULL, NULL, 'EFh_DTNA', 420),
(421, 'cd04872', NULL, 'ACT_1ZPV', NULL, NULL, 'ACT_1ZPV', 421),
(422, 'cd10933', NULL, 'CE4_u9', NULL, NULL, 'CE4_u9', 422),
(423, 'cd05887', NULL, 'Ig1_Nectin-3_like', NULL, NULL, 'Ig1_Nectin-3_like', 423),
(424, 'cd15933', NULL, '7tmB2_GPR133-like_Adhesion_V', NULL, NULL, '7tmB2_GPR133-like_Adhesion_V', 424),
(425, 'cd17396', NULL, 'MFS_YdiM_like', NULL, NULL, 'MFS_YdiM_like', 425),
(426, 'cd00197', NULL, 'VHS_ENTH_ANTH', NULL, NULL, 'VHS_ENTH_ANTH', 426),
(427, 'cd13969', NULL, 'ADCK1-like', NULL, NULL, 'ADCK1-like', 427),
(428, 'cd00951', NULL, 'KDGDH', NULL, NULL, 'KDGDH', 428),
(429, 'cd12703', NULL, 'RRM4_ROD1', NULL, NULL, 'RRM4_ROD1', 429),
(430, 'cd12595', NULL, 'RRM1_SRSF5', NULL, NULL, 'RRM1_SRSF5', 430),
(431, 'cd16310', NULL, 'Mbl1b-like_MBL-B3', NULL, NULL, 'Mbl1b-like_MBL-B3', 431),
(432, 'cd05105', NULL, 'PTKc_PDGFR_alpha', NULL, NULL, 'PTKc_PDGFR_alpha', 432),
(433, 'cd17317', NULL, 'MFS_SLC22', NULL, NULL, 'MFS_SLC22', 433),
(434, 'cd16023', NULL, 'GPI_EPT_3', NULL, NULL, 'GPI_EPT_3', 434),
(435, 'cd06175', NULL, 'MFS_POT', NULL, NULL, 'MFS_POT', 435),
(436, 'cd04259', NULL, 'AAK_AK-DapDC', NULL, NULL, 'AAK_AK-DapDC', 436),
(437, 'cd19711', NULL, 'bHLH_TS_MIST1', NULL, NULL, 'bHLH_TS_MIST1', 437),
(438, 'cd04167', NULL, 'Snu114p', NULL, NULL, 'Snu114p', 438),
(439, 'cd07463', NULL, 'CRD_FZ9', NULL, NULL, 'CRD_FZ9', 439),
(440, 'cd12368', NULL, 'RRM3_RBM45', NULL, NULL, 'RRM3_RBM45', 440);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(441, 'cd06240', NULL, 'M14-like', NULL, NULL, 'M14-like', 441),
(442, 'cd12021', NULL, 'SH3_p47phox_1', NULL, NULL, 'SH3_p47phox_1', 442),
(443, 'cd16645', NULL, 'mRING-HC-C3HC3D_TRIM23_C-IX', NULL, NULL, 'mRING-HC-C3HC3D_TRIM23_C-IX', 443),
(444, 'cd11998', NULL, 'SH3_PACSIN1-2', NULL, NULL, 'SH3_PACSIN1-2', 444),
(445, 'cd07107', NULL, 'ALDH_PhdK-like', NULL, NULL, 'ALDH_PhdK-like', 445),
(446, 'cd14535', NULL, 'PTP-MTM1-like', NULL, NULL, 'PTP-MTM1-like', 446),
(447, 'cd19977', NULL, 'PBP1_EndR-like', NULL, NULL, 'PBP1_EndR-like', 447),
(448, 'cd08169', NULL, 'DHQ-like', NULL, NULL, 'DHQ-like', 448),
(449, 'cd09881', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, 'PIN_VapC4-5_FitB-like', 449),
(450, 'cd10373', NULL, 'SH2_STAT2', NULL, NULL, 'SH2_STAT2', 450),
(451, 'cd13629', NULL, 'PBP2_Dsm1740', NULL, NULL, 'PBP2_Dsm1740', 451),
(452, 'cd13965', NULL, 'PT_UbiA_3', NULL, NULL, 'PT_UbiA_3', 452),
(453, 'cd14235', NULL, 'GAT_GGA_fungi', NULL, NULL, 'GAT_GGA_fungi', 453),
(454, 'cd02253', NULL, 'DmpA', NULL, NULL, 'DmpA', 454),
(455, 'cd04146', NULL, 'RERG_RasL11_like', NULL, NULL, 'RERG_RasL11_like', 455),
(456, 'cd17150', NULL, 'DCX1_DCDC2B', NULL, NULL, 'DCX1_DCDC2B', 456),
(457, 'cd04738', NULL, 'DHOD_2_like', NULL, NULL, 'DHOD_2_like', 457),
(458, 'cd19599', NULL, 'serpin18-like_insects', NULL, NULL, 'serpin18-like_insects', 458),
(459, 'cd01235', NULL, 'PH_Sbf1_hMTMR5', NULL, NULL, 'PH_Sbf1_hMTMR5', 459),
(460, 'cd11827', NULL, 'SH3_MyoIe_If_like', NULL, NULL, 'SH3_MyoIe_If_like', 460),
(461, 'cd14411', NULL, 'UBA_DCNL1', NULL, NULL, 'UBA_DCNL1', 461),
(462, 'cd11944', NULL, 'SH3_Endophilin_B2', NULL, NULL, 'SH3_Endophilin_B2', 462),
(463, 'cd13729', NULL, 'PBP2_iGluR_AMPA_GluR1', NULL, NULL, 'PBP2_iGluR_AMPA_GluR1', 463),
(464, 'cd01982', NULL, 'Chlide_reductase_Z', NULL, NULL, 'Chlide_reductase_Z', 464),
(465, 'cd08321', NULL, 'Pyrin_ASC-like', NULL, NULL, 'Pyrin_ASC-like', 465),
(466, 'cd17340', NULL, 'MFS_MFSD1', NULL, NULL, 'MFS_MFSD1', 466),
(467, 'cd01284', NULL, 'Riboflavin_deaminase-reductase', NULL, NULL, 'Riboflavin_deaminase-reductase', 467),
(468, 'cd15637', NULL, 'PHD_dPYGO', NULL, NULL, 'PHD_dPYGO', 468),
(469, 'cd00274', NULL, 'Chemokine_CX3C', NULL, NULL, 'Chemokine_CX3C', 469),
(470, 'cd03486', NULL, 'MutL_Trans_MLH3', NULL, NULL, 'MutL_Trans_MLH3', 470),
(471, 'cd18619', NULL, 'GH43_CoXyl43_like', NULL, NULL, 'GH43_CoXyl43_like', 471),
(472, 'cd05090', NULL, 'PTKc_Ror1', NULL, NULL, 'PTKc_Ror1', 472),
(473, 'cd01514', NULL, 'Elongation_Factor_C', NULL, NULL, 'Elongation_Factor_C', 473),
(474, 'cd02237', NULL, 'cupin_DAD_ChrR', NULL, NULL, 'cupin_DAD_ChrR', 474),
(475, 'cd11890', NULL, 'MIA', NULL, NULL, 'MIA', 475),
(476, 'cd11568', NULL, 'FAT-like_CASS4_C', NULL, NULL, 'FAT-like_CASS4_C', 476),
(477, 'cd17758', NULL, 'MCM7', NULL, NULL, 'MCM7', 477),
(478, 'cd09396', NULL, 'LIM_DA1', NULL, NULL, 'LIM_DA1', 478),
(479, 'cd03336', NULL, 'TCP1_beta', NULL, NULL, 'TCP1_beta', 479),
(480, 'cd19786', NULL, 'Bbox2_TRIM46_C-I', NULL, NULL, 'Bbox2_TRIM46_C-I', 480),
(481, 'cd15804', NULL, 'RLR_C', NULL, NULL, 'RLR_C', 481),
(482, 'cd06903', NULL, 'lectin_EMP46_EMP47', NULL, NULL, 'lectin_EMP46_EMP47', 482),
(483, 'cd17653', NULL, 'A_NRPS_GliP_like', NULL, NULL, 'A_NRPS_GliP_like', 483),
(484, 'cd15173', NULL, '7tmA_CXCR6', NULL, NULL, '7tmA_CXCR6', 484),
(485, 'cd19870', NULL, 'DSRM_SON-like', NULL, NULL, 'DSRM_SON-like', 485),
(486, 'cd07090', NULL, 'ALDH_F9_TMBADH', NULL, NULL, 'ALDH_F9_TMBADH', 486),
(487, 'cd13379', NULL, 'PH_RhoGap24', NULL, NULL, 'PH_RhoGap24', 487),
(488, 'cd09608', NULL, 'M3B_PepF', NULL, NULL, 'M3B_PepF', 488),
(489, 'cd06870', NULL, 'PX_CISK', NULL, NULL, 'PX_CISK', 489),
(490, 'cd13353', NULL, 'PH-GRAM2_TBC1D8', NULL, NULL, 'PH-GRAM2_TBC1D8', 490),
(491, 'cd12312', NULL, 'RRM_SRSF10_SRSF12', NULL, NULL, 'RRM_SRSF10_SRSF12', 491),
(492, 'cd13583', NULL, 'PBP2_AlgQ_like_4', NULL, NULL, 'PBP2_AlgQ_like_4', 492),
(493, 'cd19851', NULL, 'lipocalin_CHL', NULL, NULL, 'lipocalin_CHL', 493),
(494, 'cd15187', NULL, '7tmA_CCR8', NULL, NULL, '7tmA_CCR8', 494);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(495, 'cd16504', NULL, 'RING-HC_COP1', NULL, NULL, 'RING-HC_COP1', 495),
(496, 'cd13580', NULL, 'PBP2_AlgQ_like_1', NULL, NULL, 'PBP2_AlgQ_like_1', 496),
(497, 'cd15175', NULL, '7tmA_CCR7', NULL, NULL, '7tmA_CCR7', 497),
(498, 'cd14485', NULL, 'mltA_like_LT_A', NULL, NULL, 'mltA_like_LT_A', 498),
(499, 'cd16763', NULL, 'RING-HC_TRIM59_C-V', NULL, NULL, 'RING-HC_TRIM59_C-V', 499),
(500, 'cd00342', NULL, 'gram_neg_porins', NULL, NULL, 'gram_neg_porins', 500),
(501, 'cd17328', NULL, 'MFS_spinster_like', NULL, NULL, 'MFS_spinster_like', 501),
(502, 'cd02793', NULL, 'MopB_CT_DMSOR-BSOR-TMAOR', NULL, NULL, 'MopB_CT_DMSOR-BSOR-TMAOR', 502),
(503, 'cd15157', NULL, '7tmA_CysLTR2', NULL, NULL, '7tmA_CysLTR2', 503),
(504, 'cd01865', NULL, 'Rab3', NULL, NULL, 'Rab3', 504),
(505, 'sd00002', NULL, 'TSP3', NULL, NULL, 'TSP3', 505),
(506, 'cd06124', NULL, 'cupin_NimR-like_N', NULL, NULL, 'cupin_NimR-like_N', 506),
(507, 'cd18450', NULL, 'BACK_KLHL10', NULL, NULL, 'BACK_KLHL10', 507),
(508, 'cd02014', NULL, 'TPP_POX', NULL, NULL, 'TPP_POX', 508),
(509, 'cd02182', NULL, 'GH16_Strep_laminarinase_like', NULL, NULL, 'GH16_Strep_laminarinase_like', 509),
(510, 'cd06339', NULL, 'PBP1_YraM_LppC_lipoprotein-like', NULL, NULL, 'PBP1_YraM_LppC_lipoprotein-like', 510),
(511, 'cd17992', NULL, 'DEXHc_RecG', NULL, NULL, 'DEXHc_RecG', 511),
(512, 'cd01609', NULL, 'RNAP_beta''_N', NULL, NULL, 'RNAP_beta''_N', 512),
(513, 'cd08443', NULL, 'PBP2_CysB', NULL, NULL, 'PBP2_CysB', 513),
(514, 'cd16934', NULL, 'HATPase_RsbT-like', NULL, NULL, 'HATPase_RsbT-like', 514),
(515, 'cd13654', NULL, 'PBP2_phosphate_like_2', NULL, NULL, 'PBP2_phosphate_like_2', 515),
(516, 'cd14835', NULL, 'AP1_Mu_N', NULL, NULL, 'AP1_Mu_N', 516),
(517, 'cd17290', NULL, 'RMtype1_S_AleSS8ORF2795P_TRD1-CR1_like', NULL, NULL, 'RMtype1_S_AleSS8ORF2795P_TRD1-CR1_like', 517),
(518, 'cd00074', NULL, 'H2A', NULL, NULL, 'H2A', 518),
(519, 'cd08284', NULL, 'FDH_like_2', NULL, NULL, 'FDH_like_2', 519),
(520, 'cd11424', NULL, 'bHLH_TS_OUT', NULL, NULL, 'bHLH_TS_OUT', 520),
(521, 'cd19126', NULL, 'AKR_AKR5A_5G', NULL, NULL, 'AKR_AKR5A_5G', 521),
(522, 'cd03426', NULL, 'CoAse', NULL, NULL, 'CoAse', 522),
(523, 'cd01274', NULL, 'PTB_Anks', NULL, NULL, 'PTB_Anks', 523),
(524, 'cd05135', NULL, 'RasGAP_RASAL', NULL, NULL, 'RasGAP_RASAL', 524),
(525, 'cd07867', NULL, 'STKc_CDC2L6', NULL, NULL, 'STKc_CDC2L6', 525),
(526, 'cd15497', NULL, 'PHD1_Snt2p_like', NULL, NULL, 'PHD1_Snt2p_like', 526),
(527, 'cd21565', NULL, 'betaCoV_M', NULL, NULL, 'betaCoV_M', 527),
(528, 'cd02563', NULL, 'PseudoU_synth_TruC', NULL, NULL, 'PseudoU_synth_TruC', 528),
(529, 'cd17755', NULL, 'MCM4', NULL, NULL, 'MCM4', 529),
(530, 'cd19776', NULL, 'Bbox2_TRIM25_C-IV', NULL, NULL, 'Bbox2_TRIM25_C-IV', 530),
(531, 'cd19730', NULL, 'bHLH-PAS_spineless_like', NULL, NULL, 'bHLH-PAS_spineless_like', 531),
(532, 'cd03689', NULL, 'RF3_II', NULL, NULL, 'RF3_II', 532),
(533, 'cd07707', NULL, 'MBL-B1-B2-like', NULL, NULL, 'MBL-B1-B2-like', 533),
(534, 'cd06310', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, 'PBP1_ABC_sugar_binding-like', 534),
(535, 'cd02906', NULL, 'Macro_1', NULL, NULL, 'Macro_1', 535),
(536, 'cd11393', NULL, 'bHLH_AtbHLH_like', NULL, NULL, 'bHLH_AtbHLH_like', 536),
(537, 'cd18543', NULL, 'ABC_6TM_Rv0194_D1_like', NULL, NULL, 'ABC_6TM_Rv0194_D1_like', 537),
(538, 'cd06212', NULL, 'monooxygenase_like', NULL, NULL, 'monooxygenase_like', 538),
(539, 'cd00260', NULL, 'Sialidase', NULL, NULL, 'Sialidase', 539),
(540, 'cd06326', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, 'PBP1_ABC_ligand_binding-like', 540),
(541, 'cd02191', NULL, 'FtsZ_CetZ-like', NULL, NULL, 'FtsZ_CetZ-like', 541),
(542, 'cd12697', NULL, 'RRM3_ROD1', NULL, NULL, 'RRM3_ROD1', 542),
(543, 'cd05899', NULL, 'IgV_TCR_beta', NULL, NULL, 'IgV_TCR_beta', 543),
(544, 'cd05167', NULL, 'PI4Kc_III_alpha', NULL, NULL, 'PI4Kc_III_alpha', 544),
(545, 'cd16545', NULL, 'RING-HC_RNF141', NULL, NULL, 'RING-HC_RNF141', 545),
(546, 'cd10445', NULL, 'GIY-YIG_bI1_like', NULL, NULL, 'GIY-YIG_bI1_like', 546),
(547, 'cd07111', NULL, 'ALDH_F16', NULL, NULL, 'ALDH_F16', 547);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(548, 'cd13733', NULL, 'SPRY_PRY_C-I_1', NULL, NULL, 'SPRY_PRY_C-I_1', 548),
(549, 'cd01624', NULL, 'HAD_VSP_like', NULL, NULL, 'HAD_VSP_like', 549),
(550, 'cd08178', NULL, 'AAD_C', NULL, NULL, 'AAD_C', 550),
(551, 'cd14598', NULL, 'PTPc-N21', NULL, NULL, 'PTPc-N21', 551),
(552, 'cd16428', NULL, 'TcpC_C', NULL, NULL, 'TcpC_C', 552),
(553, 'cd15415', NULL, '7tmA_OR5J-like', NULL, NULL, '7tmA_OR5J-like', 553),
(554, 'cd04269', NULL, 'ZnMc_adamalysin_II_like', NULL, NULL, 'ZnMc_adamalysin_II_like', 554),
(555, 'cd13576', NULL, 'PBP2_BugD_Asp', NULL, NULL, 'PBP2_BugD_Asp', 555),
(556, 'cd14310', NULL, 'UBA_cnDdi1_like', NULL, NULL, 'UBA_cnDdi1_like', 556),
(557, 'cd05303', NULL, 'PGDH_2', NULL, NULL, 'PGDH_2', 557),
(558, 'cd11637', NULL, 'HR1_PKN3_3', NULL, NULL, 'HR1_PKN3_3', 558),
(559, 'cd09179', NULL, 'PLDc_N_DEXD_a', NULL, NULL, 'PLDc_N_DEXD_a', 559),
(560, 'cd17159', NULL, 'DCX4_DCDC5', NULL, NULL, 'DCX4_DCDC5', 560),
(561, 'cd05910', NULL, 'FACL_like_1', NULL, NULL, 'FACL_like_1', 561),
(562, 'cd16091', NULL, 'Ig_HHLA2', NULL, NULL, 'Ig_HHLA2', 562),
(563, 'cd07956', NULL, 'Anticodon_Ia_Arg', NULL, NULL, 'Anticodon_Ia_Arg', 563),
(564, 'cd18734', NULL, 'PIN_RfVapC2-like', NULL, NULL, 'PIN_RfVapC2-like', 564),
(565, 'cd03887', NULL, 'M20_Acy1L2', NULL, NULL, 'M20_Acy1L2', 565),
(566, 'cd07470', NULL, 'CYTH-like_mRNA_RTPase', NULL, NULL, 'CYTH-like_mRNA_RTPase', 566),
(567, 'cd12774', NULL, 'RRM2_HuD', NULL, NULL, 'RRM2_HuD', 567),
(568, 'cd10979', NULL, 'CE4_PuuE_like', NULL, NULL, 'CE4_PuuE_like', 568),
(569, 'cd11258', NULL, 'Sema_4C', NULL, NULL, 'Sema_4C', 569),
(570, 'cd12190', NULL, 'Bacova_04320_like', NULL, NULL, 'Bacova_04320_like', 570),
(571, 'cd21642', NULL, 'ORF8-Ig_Bat_SARS_CoV_Rf1_type-II-like', NULL, NULL, 'ORF8-Ig_Bat_SARS_CoV_Rf1_type-II-like', 571),
(572, 'cd09486', NULL, 'LIM_Eplin_like_1', NULL, NULL, 'LIM_Eplin_like_1', 572),
(573, 'cd00618', NULL, 'PLA2_like', NULL, NULL, 'PLA2_like', 573),
(574, 'cd03392', NULL, 'PAP2_like_2', NULL, NULL, 'PAP2_like_2', 574),
(575, 'cd04480', NULL, 'RPA1_DBD_A_like', NULL, NULL, 'RPA1_DBD_A_like', 575),
(576, 'cd00779', NULL, 'ProRS_core_prok', NULL, NULL, 'ProRS_core_prok', 576),
(577, 'cd13867', NULL, 'CuRO_2_CueO_FtsP', NULL, NULL, 'CuRO_2_CueO_FtsP', 577),
(578, 'cd17183', NULL, 'FERM_F1_KIND1', NULL, NULL, 'FERM_F1_KIND1', 578),
(579, 'cd08010', NULL, 'MltG_like', NULL, NULL, 'MltG_like', 579),
(580, 'cd12734', NULL, 'RRM3_hnRNPH_hnRNPH2_hnRNPF', NULL, NULL, 'RRM3_hnRNPH_hnRNPH2_hnRNPF', 580),
(581, 'cd18610', NULL, 'GH130_BT3780-like', NULL, NULL, 'GH130_BT3780-like', 581),
(582, 'cd00517', NULL, 'ATPS', NULL, NULL, 'ATPS', 582),
(583, 'cd16553', NULL, 'RING-HC_RNF170', NULL, NULL, 'RING-HC_RNF170', 583),
(584, 'cd01307', NULL, 'Met_dep_hydrolase_B', NULL, NULL, 'Met_dep_hydrolase_B', 584),
(585, 'cd07027', NULL, 'RNAP_RPB11_like', NULL, NULL, 'RNAP_RPB11_like', 585),
(586, 'cd15537', NULL, 'PHD_BS69', NULL, NULL, 'PHD_BS69', 586),
(587, 'cd05244', NULL, 'BVR-B_like_SDR_a', NULL, NULL, 'BVR-B_like_SDR_a', 587),
(588, 'cd05087', NULL, 'PTKc_Aatyk1', NULL, NULL, 'PTKc_Aatyk1', 588),
(589, 'cd12206', NULL, 'RasGAP_IQGAP_related', NULL, NULL, 'RasGAP_IQGAP_related', 589),
(590, 'cd13300', NULL, 'PH1_TECPR1', NULL, NULL, 'PH1_TECPR1', 590),
(591, 'cd09890', NULL, 'NGN_plant', NULL, NULL, 'NGN_plant', 591),
(592, 'cd01327', NULL, 'KAZAL_PSTI', NULL, NULL, 'KAZAL_PSTI', 592),
(593, 'cd16623', NULL, 'RING-HC_RBR_TRIAD1_like', NULL, NULL, 'RING-HC_RBR_TRIAD1_like', 593),
(594, 'cd19373', NULL, 'UDG-F1_NsUNG-like', NULL, NULL, 'UDG-F1_NsUNG-like', 594),
(595, 'cd12511', NULL, 'RRM2_RBM12_like', NULL, NULL, 'RRM2_RBM12_like', 595),
(596, 'cd11763', NULL, 'SH3_SNX9_like', NULL, NULL, 'SH3_SNX9_like', 596),
(597, 'cd12317', NULL, 'RRM4_RBM19_RRM3_MRD1', NULL, NULL, 'RRM4_RBM19_RRM3_MRD1', 597),
(598, 'cd05367', NULL, 'SPR-like_SDR_c', NULL, NULL, 'SPR-like_SDR_c', 598),
(599, 'cd18691', NULL, 'PIN_VapC-like', NULL, NULL, 'PIN_VapC-like', 599),
(600, 'cd08730', NULL, 'RGS-like_3', NULL, NULL, 'RGS-like_3', 600),
(601, 'cd16192', NULL, 'EFh_PEF_CAPN9', NULL, NULL, 'EFh_PEF_CAPN9', 601);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(602, 'cd03233', NULL, 'ABCG_PDR_domain1', NULL, NULL, 'ABCG_PDR_domain1', 602),
(603, 'cd15861', NULL, 'SNARE_SNAP25N_23N_29N_SEC9N', NULL, NULL, 'SNARE_SNAP25N_23N_29N_SEC9N', 603),
(604, 'cd03011', NULL, 'TlpA_like_ScsD_MtbDsbE', NULL, NULL, 'TlpA_like_ScsD_MtbDsbE', 604),
(605, 'cd15942', NULL, '7tmA_OR10G6-like', NULL, NULL, '7tmA_OR10G6-like', 605),
(606, 'cd12528', NULL, 'RRM2_MEI2_fungi', NULL, NULL, 'RRM2_MEI2_fungi', 606),
(607, 'cd11675', NULL, 'SCAB1_middle', NULL, NULL, 'SCAB1_middle', 607),
(608, 'cd15268', NULL, '7tmB1_GLP1R', NULL, NULL, '7tmB1_GLP1R', 608),
(609, 'cd00776', NULL, 'AsxRS_core', NULL, NULL, 'AsxRS_core', 609),
(610, 'cd02434', NULL, 'Nodulin-21_like_3', NULL, NULL, 'Nodulin-21_like_3', 610),
(611, 'cd05918', NULL, 'A_NRPS_SidN3_like', NULL, NULL, 'A_NRPS_SidN3_like', 611),
(612, 'cd07640', NULL, 'BAR_ASAP3', NULL, NULL, 'BAR_ASAP3', 612),
(613, 'cd19393', NULL, 'TGF_beta_BMP3', NULL, NULL, 'TGF_beta_BMP3', 613),
(614, 'cd16738', NULL, 'RING-HC_PCGF6', NULL, NULL, 'RING-HC_PCGF6', 614),
(615, 'cd00542', NULL, 'Ntn_PVA', NULL, NULL, 'Ntn_PVA', 615),
(616, 'cd10930', NULL, 'CE4_u6', NULL, NULL, 'CE4_u6', 616),
(617, 'cd07021', NULL, 'Clp_protease_NfeD_like', NULL, NULL, 'Clp_protease_NfeD_like', 617),
(618, 'cd14278', NULL, 'UBA_NAC_like', NULL, NULL, 'UBA_NAC_like', 618),
(619, 'cd00730', NULL, 'rubredoxin', NULL, NULL, 'rubredoxin', 619),
(620, 'cd04210', NULL, 'Cupredoxin_like_1', NULL, NULL, 'Cupredoxin_like_1', 620),
(621, 'cd08538', NULL, 'SAM_PNT-ESE-2-like', NULL, NULL, 'SAM_PNT-ESE-2-like', 621),
(622, 'cd01640', NULL, 'IPPase', NULL, NULL, 'IPPase', 622),
(623, 'cd14695', NULL, 'bZIP_HLF', NULL, NULL, 'bZIP_HLF', 623),
(624, 'cd18519', NULL, 'BACK_SPOPL', NULL, NULL, 'BACK_SPOPL', 624),
(625, 'cd16932', NULL, 'HATPase_Phy-like', NULL, NULL, 'HATPase_Phy-like', 625),
(626, 'cd10322', NULL, 'SLC5sbd', NULL, NULL, 'SLC5sbd', 626),
(627, 'cd13373', NULL, 'PH_nGAP', NULL, NULL, 'PH_nGAP', 627),
(628, 'cd08747', NULL, 'RGS_GRK2_GRK3', NULL, NULL, 'RGS_GRK2_GRK3', 628),
(629, 'cd09600', NULL, 'M1_APN', NULL, NULL, 'M1_APN', 629),
(630, 'cd11715', NULL, 'THUMP_AdoMetMT', NULL, NULL, 'THUMP_AdoMetMT', 630),
(631, 'cd08198', NULL, 'DHQS-like', NULL, NULL, 'DHQS-like', 631),
(632, 'cd06416', NULL, 'GH25_Lys1-like', NULL, NULL, 'GH25_Lys1-like', 632),
(633, 'cd09627', NULL, 'DOMON_murB_like', NULL, NULL, 'DOMON_murB_like', 633),
(634, 'cd08908', NULL, 'START_STARD12-like', NULL, NULL, 'START_STARD12-like', 634),
(635, 'cd02680', NULL, 'MIT_calpain7_2', NULL, NULL, 'MIT_calpain7_2', 635),
(636, 'cd18048', NULL, 'DEADc_DDX25', NULL, NULL, 'DEADc_DDX25', 636),
(637, 'cd14120', NULL, 'STKc_ULK1_2-like', NULL, NULL, 'STKc_ULK1_2-like', 637),
(638, 'cd17202', NULL, 'FERM_F1_EPB41L2', NULL, NULL, 'FERM_F1_EPB41L2', 638),
(639, 'cd18938', NULL, 'bHLH_TS_Mesp', NULL, NULL, 'bHLH_TS_Mesp', 639),
(640, 'cd03123', NULL, 'alpha_CA_VI_IX_XII_XIV', NULL, NULL, 'alpha_CA_VI_IX_XII_XIV', 640),
(641, 'cd07832', NULL, 'STKc_CCRK', NULL, NULL, 'STKc_CCRK', 641),
(642, 'cd05746', NULL, 'Ig4_Peroxidasin', NULL, NULL, 'Ig4_Peroxidasin', 642),
(643, 'cd11327', NULL, 'AmyAc_Glg_debranch_2', NULL, NULL, 'AmyAc_Glg_debranch_2', 643),
(644, 'cd15361', NULL, '7tmA_LGR4', NULL, NULL, '7tmA_LGR4', 644),
(645, 'cd07838', NULL, 'STKc_CDK4_6_like', NULL, NULL, 'STKc_CDK4_6_like', 645),
(646, 'cd04451', NULL, 'S1_IF1', NULL, NULL, 'S1_IF1', 646),
(647, 'cd17555', NULL, 'REC_RssB-like', NULL, NULL, 'REC_RssB-like', 647),
(648, 'cd12878', NULL, 'SPRY2_RyR', NULL, NULL, 'SPRY2_RyR', 648),
(649, 'cd14783', NULL, 'FHb-globin_3', NULL, NULL, 'FHb-globin_3', 649),
(650, 'cd16815', NULL, 'RING-HC_RNF40', NULL, NULL, 'RING-HC_RNF40', 650),
(651, 'cd14156', NULL, 'PKc_LIMK_like_unk', NULL, NULL, 'PKc_LIMK_like_unk', 651),
(652, 'cd16405', NULL, 'RepB_like_N', NULL, NULL, 'RepB_like_N', 652),
(653, 'cd01660', NULL, 'ba3-like_Oxidase_I', NULL, NULL, 'ba3-like_Oxidase_I', 653),
(654, 'cd15604', NULL, 'PHD1_KDM5C_5D', NULL, NULL, 'PHD1_KDM5C_5D', 654),
(655, 'cd04254', NULL, 'AAK_UMPK-PyrH-Ec', NULL, NULL, 'AAK_UMPK-PyrH-Ec', 655);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(656, 'cd16016', NULL, 'AP-SPAP', NULL, NULL, 'AP-SPAP', 656),
(657, 'cd14766', NULL, 'CeGLB25-like', NULL, NULL, 'CeGLB25-like', 657),
(658, 'cd05482', NULL, 'HIV_retropepsin_like', NULL, NULL, 'HIV_retropepsin_like', 658),
(659, 'cd11491', NULL, 'SLC5sbd_SMIT', NULL, NULL, 'SLC5sbd_SMIT', 659),
(660, 'cd05046', NULL, 'PTK_CCK4', NULL, NULL, 'PTK_CCK4', 660),
(661, 'cd19973', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, 'PBP1_ABC_sugar_binding-like', 661),
(662, 'cd04729', NULL, 'NanE', NULL, NULL, 'NanE', 662),
(663, 'cd14744', NULL, 'PAAR_CT_2', NULL, NULL, 'PAAR_CT_2', 663),
(664, 'cd16112', NULL, 'DCX1_DCX', NULL, NULL, 'DCX1_DCX', 664),
(665, 'cd19981', NULL, 'PBP1_ABC_HAAT-like', NULL, NULL, 'PBP1_ABC_HAAT-like', 665),
(666, 'cd18722', NULL, 'PIN_NicB-like', NULL, NULL, 'PIN_NicB-like', 666),
(667, 'cd08554', NULL, 'Cyt_b561', NULL, NULL, 'Cyt_b561', 667),
(668, 'cd15195', NULL, '7tmA_GnRHR-like', NULL, NULL, '7tmA_GnRHR-like', 668),
(669, 'cd14195', NULL, 'STKc_DAPK3', NULL, NULL, 'STKc_DAPK3', 669),
(670, 'cd08452', NULL, 'PBP2_AlsR', NULL, NULL, 'PBP2_AlsR', 670),
(671, 'cd10234', NULL, 'HSPA9-Ssq1-like_NBD', NULL, NULL, 'HSPA9-Ssq1-like_NBD', 671),
(672, 'cd04394', NULL, 'RhoGAP-ARHGAP11A', NULL, NULL, 'RhoGAP-ARHGAP11A', 672),
(673, 'cd08472', NULL, 'PBP2_CrgA_like_3', NULL, NULL, 'PBP2_CrgA_like_3', 673),
(674, 'cd19817', NULL, 'Bbox1_ANCHR-like', NULL, NULL, 'Bbox1_ANCHR-like', 674),
(675, 'cd08927', NULL, 'Hb-alpha-like', NULL, NULL, 'Hb-alpha-like', 675),
(676, 'cd10408', NULL, 'SH2_Nck1', NULL, NULL, 'SH2_Nck1', 676),
(677, 'cd16354', NULL, 'BAT', NULL, NULL, 'BAT', 677),
(678, 'sd00044', NULL, 'HEAT', NULL, NULL, 'HEAT', 678),
(679, 'cd04662', NULL, 'Nudix_Hydrolase_5', NULL, NULL, 'Nudix_Hydrolase_5', 679),
(680, 'cd00354', NULL, 'FBPase', NULL, NULL, 'FBPase', 680),
(681, 'cd17221', NULL, 'RA_RASSF2', NULL, NULL, 'RA_RASSF2', 681),
(682, 'cd17365', NULL, 'MFS_PcaK_like', NULL, NULL, 'MFS_PcaK_like', 682),
(683, 'cd02685', NULL, 'MIT_C', NULL, NULL, 'MIT_C', 683),
(684, 'cd11269', NULL, 'Sema_6D', NULL, NULL, 'Sema_6D', 684),
(685, 'cd06631', NULL, 'STKc_YSK4', NULL, NULL, 'STKc_YSK4', 685),
(686, 'cd03808', NULL, 'GT4_CapM-like', NULL, NULL, 'GT4_CapM-like', 686),
(687, 'cd07632', NULL, 'BAR_APPL2', NULL, NULL, 'BAR_APPL2', 687),
(688, 'cd11635', NULL, 'HR1_PKN2_3', NULL, NULL, 'HR1_PKN2_3', 688),
(689, 'cd05162', NULL, 'PWWP', NULL, NULL, 'PWWP', 689),
(690, 'cd15572', NULL, 'PHD_BRPF', NULL, NULL, 'PHD_BRPF', 690),
(691, 'cd17395', NULL, 'MFS_MFSD4', NULL, NULL, 'MFS_MFSD4', 691),
(692, 'cd11917', NULL, 'SH3_Sorbs2_3', NULL, NULL, 'SH3_Sorbs2_3', 692),
(693, 'cd11922', NULL, 'SH3_Sorbs1_2', NULL, NULL, 'SH3_Sorbs1_2', 693),
(694, 'cd13343', NULL, 'PH-GRAM_MTMR6', NULL, NULL, 'PH-GRAM_MTMR6', 694),
(695, 'cd03028', NULL, 'GRX_PICOT_like', NULL, NULL, 'GRX_PICOT_like', 695),
(696, 'cd05678', NULL, 'M20_dipept_like', NULL, NULL, 'M20_dipept_like', 696),
(697, 'cd09934', NULL, 'SH2_Tec_family', NULL, NULL, 'SH2_Tec_family', 697),
(698, 'cd12445', NULL, 'RRM2_CPEBs', NULL, NULL, 'RRM2_CPEBs', 698),
(699, 'cd03587', NULL, 'SOCS', NULL, NULL, 'SOCS', 699),
(700, 'cd11525', NULL, 'SYLF_SH3YL1_like', NULL, NULL, 'SYLF_SH3YL1_like', 700),
(701, 'cd07198', NULL, 'Patatin', NULL, NULL, 'Patatin', 701),
(702, 'cd11638', NULL, 'HR1_ROCK2', NULL, NULL, 'HR1_ROCK2', 702),
(703, 'cd00873', NULL, 'KU80', NULL, NULL, 'KU80', 703),
(704, 'cd09762', NULL, 'HSDL2_SDR_c', NULL, NULL, 'HSDL2_SDR_c', 704),
(705, 'cd00419', NULL, 'Ferrochelatase_C', NULL, NULL, 'Ferrochelatase_C', 705),
(706, 'cd02032', NULL, 'Bchl-like', NULL, NULL, 'Bchl-like', 706),
(707, 'cd04493', NULL, 'BRCA2DBD_OB1', NULL, NULL, 'BRCA2DBD_OB1', 707),
(708, 'cd16426', NULL, 'VirB10_like', NULL, NULL, 'VirB10_like', 708),
(709, 'cd16127', NULL, 'Ubl_ATG8_GABARAP_like', NULL, NULL, 'Ubl_ATG8_GABARAP_like', 709),
(710, 'cd03819', NULL, 'GT4_WavL-like', NULL, NULL, 'GT4_WavL-like', 710),
(711, 'cd17662', NULL, 'PFA-DSP_Oca4', NULL, NULL, 'PFA-DSP_Oca4', 711),
(712, 'cd18478', NULL, 'BACK_KLHL42_KLHDC5', NULL, NULL, 'BACK_KLHL42_KLHDC5', 712);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(713, 'cd20308', NULL, 'cupin_YdaE', NULL, NULL, 'cupin_YdaE', 713),
(714, 'cd08619', NULL, 'PI-PLCXDc_plant', NULL, NULL, 'PI-PLCXDc_plant', 714),
(715, 'cd16632', NULL, 'mRING-HC-C4C4_RBR_RNF144', NULL, NULL, 'mRING-HC-C4C4_RBR_RNF144', 715),
(716, 'cd14036', NULL, 'STKc_GAK', NULL, NULL, 'STKc_GAK', 716),
(717, 'cd00034', NULL, 'CSD', NULL, NULL, 'CSD', 717),
(718, 'cd03762', NULL, 'proteasome_beta_type_6', NULL, NULL, 'proteasome_beta_type_6', 718),
(719, 'cd18701', NULL, 'PIN_VapC_like', NULL, NULL, 'PIN_VapC_like', 719),
(720, 'cd17343', NULL, 'MFS_SLC37A4', NULL, NULL, 'MFS_SLC37A4', 720),
(721, 'cd17498', NULL, 'RMtype1_S_Aco12261I-TRD1-CR1_like', NULL, NULL, 'RMtype1_S_Aco12261I-TRD1-CR1_like', 721),
(722, 'cd10424', NULL, 'GST_C_9', NULL, NULL, 'GST_C_9', 722),
(723, 'cd01335', NULL, 'Radical_SAM', NULL, NULL, 'Radical_SAM', 723),
(724, 'cd01912', NULL, 'proteasome_beta', NULL, NULL, 'proteasome_beta', 724),
(725, 'cd11887', NULL, 'SH3_Bbc1', NULL, NULL, 'SH3_Bbc1', 725),
(726, 'cd00213', NULL, 'S-100', NULL, NULL, 'S-100', 726),
(727, 'cd00825', NULL, 'decarbox_cond_enzymes', NULL, NULL, 'decarbox_cond_enzymes', 727),
(728, 'cd03380', NULL, 'PAP2_like_1', NULL, NULL, 'PAP2_like_1', 728),
(729, 'cd13416', NULL, 'TNFRSF16', NULL, NULL, 'TNFRSF16', 729),
(730, 'cd14067', NULL, 'STKc_LRRK1', NULL, NULL, 'STKc_LRRK1', 730),
(731, 'cd00925', NULL, 'Cyt_c_Oxidase_VIa', NULL, NULL, 'Cyt_c_Oxidase_VIa', 731),
(732, 'cd01038', NULL, 'Endonuclease_DUF559', NULL, NULL, 'Endonuclease_DUF559', 732),
(733, 'cd06227', NULL, 'M14-CPA-like', NULL, NULL, 'M14-CPA-like', 733),
(734, 'cd17279', NULL, 'RMtype1_S_BmuCF2ORF3362P_TRD1-CR1_like', NULL, NULL, 'RMtype1_S_BmuCF2ORF3362P_TRD1-CR1_like', 734),
(735, 'cd11291', NULL, 'gelsolin_S6_like', NULL, NULL, 'gelsolin_S6_like', 735),
(736, 'cd00084', NULL, 'HMG-box', NULL, NULL, 'HMG-box', 736),
(737, 'cd14132', NULL, 'STKc_CK2_alpha', NULL, NULL, 'STKc_CK2_alpha', 737),
(738, 'cd14198', NULL, 'STKc_DRAK2', NULL, NULL, 'STKc_DRAK2', 738),
(739, 'cd17988', NULL, 'DEXHc_TDRD9', NULL, NULL, 'DEXHc_TDRD9', 739),
(740, 'cd08545', NULL, 'YcnI_like', NULL, NULL, 'YcnI_like', 740),
(741, 'cd07120', NULL, 'ALDH_PsfA-ACA09737', NULL, NULL, 'ALDH_PsfA-ACA09737', 741),
(742, 'cd05506', NULL, 'Bromo_plant1', NULL, NULL, 'Bromo_plant1', 742),
(743, 'cd11009', NULL, 'Zn_dep_PLPC', NULL, NULL, 'Zn_dep_PLPC', 743),
(744, 'cd07168', NULL, 'NR_DBD_DHR4_like', NULL, NULL, 'NR_DBD_DHR4_like', 744),
(745, 'cd08682', NULL, 'C2_Rab11-FIP_classI', NULL, NULL, 'C2_Rab11-FIP_classI', 745),
(746, 'cd17259', NULL, 'RMtype1_S_StySKI-TRD2-CR2_like', NULL, NULL, 'RMtype1_S_StySKI-TRD2-CR2_like', 746),
(747, 'cd07015', NULL, 'Clp_protease_NfeD', NULL, NULL, 'Clp_protease_NfeD', 747),
(748, 'cd10031', NULL, 'UDG-F5_TTUDGB_like', NULL, NULL, 'UDG-F5_TTUDGB_like', 748),
(749, 'cd09508', NULL, 'SAM_HD', NULL, NULL, 'SAM_HD', 749),
(750, 'cd16263', NULL, 'BipA_III', NULL, NULL, 'BipA_III', 750),
(751, 'cd15117', NULL, '7tmA_FPR-like', NULL, NULL, '7tmA_FPR-like', 751),
(752, 'cd19002', NULL, 'LGIC_ECD_GABAAR_E', NULL, NULL, 'LGIC_ECD_GABAAR_E', 752),
(753, 'cd04106', NULL, 'Rab23_like', NULL, NULL, 'Rab23_like', 753),
(754, 'cd11447', NULL, 'bHLH-O_HEYL', NULL, NULL, 'bHLH-O_HEYL', 754),
(755, 'cd03300', NULL, 'ABC_PotA_N', NULL, NULL, 'ABC_PotA_N', 755),
(756, 'cd18294', NULL, 'BTB_POZ_BTBD19', NULL, NULL, 'BTB_POZ_BTBD19', 756),
(757, 'cd09267', NULL, 'FCHo2_MHD', NULL, NULL, 'FCHo2_MHD', 757),
(758, 'cd13984', NULL, 'PK_NRBP1_like', NULL, NULL, 'PK_NRBP1_like', 758),
(759, 'cd19890', NULL, 'DSRM_TARBP2_rpt1', NULL, NULL, 'DSRM_TARBP2_rpt1', 759),
(760, 'cd01792', NULL, 'Ubl1_ISG15', NULL, NULL, 'Ubl1_ISG15', 760),
(761, 'cd16218', NULL, 'EFh_PI-PLCdelta3', NULL, NULL, 'EFh_PI-PLCdelta3', 761),
(762, 'cd12489', NULL, 'RRM2_hnRNPQ', NULL, NULL, 'RRM2_hnRNPQ', 762),
(763, 'cd12515', NULL, 'RRM5_RBM12_like', NULL, NULL, 'RRM5_RBM12_like', 763),
(764, 'cd16980', NULL, 'VHS_Lsb5', NULL, NULL, 'VHS_Lsb5', 764),
(765, 'cd00353', NULL, 'Ribosomal_S15p_S13e', NULL, NULL, 'Ribosomal_S15p_S13e', 765);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(766, 'cd15793', NULL, 'PH1_FGD6', NULL, NULL, 'PH1_FGD6', 766),
(767, 'cd11608', NULL, 'eIF2D_C', NULL, NULL, 'eIF2D_C', 767),
(768, 'cd12742', NULL, 'RRM3_ESRP1_ESRP2', NULL, NULL, 'RRM3_ESRP1_ESRP2', 768),
(769, 'cd18381', NULL, 'BTB_POZ_Kv5_KCNF1', NULL, NULL, 'BTB_POZ_Kv5_KCNF1', 769),
(770, 'cd05564', NULL, 'PTS_IIB_chitobiose_lichenan', NULL, NULL, 'PTS_IIB_chitobiose_lichenan', 770),
(771, 'cd17238', NULL, 'FERM_F1_Radixin', NULL, NULL, 'FERM_F1_Radixin', 771),
(772, 'cd19138', NULL, 'AKR_YeaE', NULL, NULL, 'AKR_YeaE', 772),
(773, 'cd18227', NULL, 'BTB_POZ_ZBTB43', NULL, NULL, 'BTB_POZ_ZBTB43', 773),
(774, 'cd03164', NULL, 'CD53_like_LEL', NULL, NULL, 'CD53_like_LEL', 774),
(775, 'cd06536', NULL, 'CIDE_N_ICAD', NULL, NULL, 'CIDE_N_ICAD', 775),
(776, 'cd18831', NULL, 'GH43_AnAbnA-like', NULL, NULL, 'GH43_AnAbnA-like', 776),
(777, 'cd08716', NULL, 'RGS_RGS13', NULL, NULL, 'RGS_RGS13', 777),
(778, 'cd03893', NULL, 'M20_Dipept_like', NULL, NULL, 'M20_Dipept_like', 778),
(779, 'cd19857', NULL, 'DSRM_STAU_rpt1', NULL, NULL, 'DSRM_STAU_rpt1', 779),
(780, 'cd16156', NULL, 'sulfatase_like', NULL, NULL, 'sulfatase_like', 780),
(781, 'cd19458', NULL, 'lipocalin_12', NULL, NULL, 'lipocalin_12', 781),
(782, 'cd12260', NULL, 'RRM2_SREK1', NULL, NULL, 'RRM2_SREK1', 782),
(783, 'cd17711', NULL, 'BRCT_PAXIP1_rpt3', NULL, NULL, 'BRCT_PAXIP1_rpt3', 783),
(784, 'cd16103', NULL, 'Ubl2_OASL', NULL, NULL, 'Ubl2_OASL', 784),
(785, 'cd17251', NULL, 'RMtype1_S_HinAWORF1578P-TRD2-CR2_like', NULL, NULL, 'RMtype1_S_HinAWORF1578P-TRD2-CR2_like', 785),
(786, 'cd19336', NULL, 'Wnt_Wnt4', NULL, NULL, 'Wnt_Wnt4', 786),
(787, 'cd14686', NULL, 'bZIP', NULL, NULL, 'bZIP', 787),
(788, 'cd16212', NULL, 'EFh_NorpA_like', NULL, NULL, 'EFh_NorpA_like', 788),
(789, 'cd10488', NULL, 'MH1_R-SMAD', NULL, NULL, 'MH1_R-SMAD', 789),
(790, 'cd04613', NULL, 'CBS_pair_voltage-gated_CLC_bac', NULL, NULL, 'CBS_pair_voltage-gated_CLC_bac', 790),
(791, 'cd06929', NULL, 'NR_LBD_F1', NULL, NULL, 'NR_LBD_F1', 791),
(792, 'cd11552', NULL, 'Serine_rich_BCAR1', NULL, NULL, 'Serine_rich_BCAR1', 792),
(793, 'cd18929', NULL, 'bHLHzip_Mad4', NULL, NULL, 'bHLHzip_Mad4', 793),
(794, 'cd16286', NULL, 'SPM-1-like_MBL-B1-B2-like', NULL, NULL, 'SPM-1-like_MBL-B1-B2-like', 794),
(795, 'cd19868', NULL, 'DSRM_DGCR8_rpt2', NULL, NULL, 'DSRM_DGCR8_rpt2', 795),
(796, 'cd13700', NULL, 'PBP2_Arg_STM4351', NULL, NULL, 'PBP2_Arg_STM4351', 796),
(797, 'cd04470', NULL, 'S1_EF-P_repeat_1', NULL, NULL, 'S1_EF-P_repeat_1', 797),
(798, 'cd17779', NULL, 'CBS_archAMPK_gamma-repeat1', NULL, NULL, 'CBS_archAMPK_gamma-repeat1', 798),
(799, 'cd05351', NULL, 'XR_like_SDR_c', NULL, NULL, 'XR_like_SDR_c', 799),
(800, 'cd16322', NULL, 'TTHA1623-like_MBL-fold', NULL, NULL, 'TTHA1623-like_MBL-fold', 800),
(801, 'cd09710', NULL, 'Cas3_I-D', NULL, NULL, 'Cas3_I-D', 801),
(802, 'cd06596', NULL, 'GH31_CPE1046', NULL, NULL, 'GH31_CPE1046', 802),
(803, 'cd06148', NULL, 'Egl_like_exo', NULL, NULL, 'Egl_like_exo', 803),
(804, 'cd11358', NULL, 'RNase_PH', NULL, NULL, 'RNase_PH', 804),
(805, 'cd19124', NULL, 'AKR_AKR4A_4B', NULL, NULL, 'AKR_AKR4A_4B', 805),
(806, 'cd14597', NULL, 'PTPc-N13', NULL, NULL, 'PTPc-N13', 806),
(807, 'cd15446', NULL, '7tmB1_CRF-R2', NULL, NULL, '7tmB1_CRF-R2', 807),
(808, 'cd01364', NULL, 'KISc_BimC_Eg5', NULL, NULL, 'KISc_BimC_Eg5', 808),
(809, 'cd04857', NULL, 'Peptidases_S8_Tripeptidyl_Aminopeptidase_II', NULL, NULL, 'Peptidases_S8_Tripeptidyl_Aminopeptidase_II', 809),
(810, 'cd14062', NULL, 'STKc_Raf', NULL, NULL, 'STKc_Raf', 810),
(811, 'cd16304', NULL, 'BcII-like_MBL-B1', NULL, NULL, 'BcII-like_MBL-B1', 811),
(812, 'cd19201', NULL, 'PR-SET_ZFPM', NULL, NULL, 'PR-SET_ZFPM', 812),
(813, 'cd15039', NULL, '7tmB3_Methuselah-like', NULL, NULL, '7tmB3_Methuselah-like', 813),
(814, 'cd00806', NULL, 'TrpRS_core', NULL, NULL, 'TrpRS_core', 814),
(815, 'cd08415', NULL, 'PBP2_LysR_opines_like', NULL, NULL, 'PBP2_LysR_opines_like', 815),
(816, 'cd11990', NULL, 'SH3_Intersectin2_2', NULL, NULL, 'SH3_Intersectin2_2', 816),
(817, 'cd15292', NULL, '7tmC_GPR156', NULL, NULL, '7tmC_GPR156', 817);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(818, 'cd06887', NULL, 'PX_p47phox', NULL, NULL, 'PX_p47phox', 818),
(819, 'cd15249', NULL, '7tmF_FZD5', NULL, NULL, '7tmF_FZD5', 819),
(820, 'cd13978', NULL, 'STKc_RIP', NULL, NULL, 'STKc_RIP', 820),
(821, 'cd19178', NULL, 'SET_SETD6', NULL, NULL, 'SET_SETD6', 821),
(822, 'cd07356', NULL, 'HN_L-whirlin_R1_like', NULL, NULL, 'HN_L-whirlin_R1_like', 822),
(823, 'cd06086', NULL, 'KOW_Spt5_6', NULL, NULL, 'KOW_Spt5_6', 823),
(824, 'cd12548', NULL, 'RRM_Set1A', NULL, NULL, 'RRM_Set1A', 824),
(825, 'cd02587', NULL, 'HAD_5-3dNT', NULL, NULL, 'HAD_5-3dNT', 825),
(826, 'cd14700', NULL, 'bZIP_ATF6', NULL, NULL, 'bZIP_ATF6', 826),
(827, 'cd08709', NULL, 'RGS_RGS2', NULL, NULL, 'RGS_RGS2', 827),
(828, 'cd13962', NULL, 'PT_UbiA_UBIAD1', NULL, NULL, 'PT_UbiA_UBIAD1', 828),
(829, 'cd06555', NULL, 'ASCH_PF0470_like', NULL, NULL, 'ASCH_PF0470_like', 829),
(830, 'cd11906', NULL, 'SH3_BTK', NULL, NULL, 'SH3_BTK', 830),
(831, 'cd00137', NULL, 'PI-PLCc', NULL, NULL, 'PI-PLCc', 831),
(832, 'cd05485', NULL, 'Cathepsin_D_like', NULL, NULL, 'Cathepsin_D_like', 832),
(833, 'cd14655', NULL, 'ZIP_Hap1', NULL, NULL, 'ZIP_Hap1', 833),
(834, 'cd03691', NULL, 'BipA_TypA_II', NULL, NULL, 'BipA_TypA_II', 834),
(835, 'cd10426', NULL, 'Ephrin-B_Ectodomain', NULL, NULL, 'Ephrin-B_Ectodomain', 835),
(836, 'cd14351', NULL, 'UBA_Ubx1_like', NULL, NULL, 'UBA_Ubx1_like', 836),
(837, 'cd17006', NULL, 'ANTH_N_HIP1_like', NULL, NULL, 'ANTH_N_HIP1_like', 837),
(838, 'cd18813', NULL, 'CAP_CRISPLD1', NULL, NULL, 'CAP_CRISPLD1', 838),
(839, 'cd09155', NULL, 'PLDc_PaCLS_like_1', NULL, NULL, 'PLDc_PaCLS_like_1', 839),
(840, 'cd07673', NULL, 'F-BAR_FCHO2', NULL, NULL, 'F-BAR_FCHO2', 840),
(841, 'cd18491', NULL, 'BACK_ABTB2_like', NULL, NULL, 'BACK_ABTB2_like', 841),
(842, 'cd07187', NULL, 'YvcK_like', NULL, NULL, 'YvcK_like', 842),
(843, 'cd07805', NULL, 'FGGY_XK_like_2', NULL, NULL, 'FGGY_XK_like_2', 843),
(844, 'cd13854', NULL, 'CuRO_1_MaLCC_like', NULL, NULL, 'CuRO_1_MaLCC_like', 844),
(845, 'cd07708', NULL, 'MBL-B3-like', NULL, NULL, 'MBL-B3-like', 845),
(846, 'cd17538', NULL, 'REC_D1_PleD-like', NULL, NULL, 'REC_D1_PleD-like', 846),
(847, 'cd19047', NULL, 'LGIC_ECD_GABAAR_rho2', NULL, NULL, 'LGIC_ECD_GABAAR_rho2', 847),
(848, 'cd17460', NULL, 'MFS_SLCO2B_OATP2B', NULL, NULL, 'MFS_SLCO2B_OATP2B', 848),
(849, 'cd14809', NULL, 'bZIP_AUREO-like', NULL, NULL, 'bZIP_AUREO-like', 849),
(850, 'cd01016', NULL, 'TroA', NULL, NULL, 'TroA', 850),
(851, 'cd01092', NULL, 'APP-like', NULL, NULL, 'APP-like', 851),
(852, 'cd14091', NULL, 'STKc_RSK_C', NULL, NULL, 'STKc_RSK_C', 852),
(853, 'cd09450', NULL, 'LIM_ALP', NULL, NULL, 'LIM_ALP', 853),
(854, 'cd17513', NULL, 'RMtype1_S_AveSPN6ORF1907P_TRD2-CR2_like', NULL, NULL, 'RMtype1_S_AveSPN6ORF1907P_TRD2-CR2_like', 854),
(855, 'cd16424', NULL, 'VirB8', NULL, NULL, 'VirB8', 855),
(856, 'cd17645', NULL, 'A_NRPS_LgrA-like', NULL, NULL, 'A_NRPS_LgrA-like', 856),
(857, 'cd11714', NULL, 'GINS_A_archaea', NULL, NULL, 'GINS_A_archaea', 857),
(858, 'cd16248', NULL, 'EFh_DRP-2', NULL, NULL, 'EFh_DRP-2', 858),
(859, 'cd04256', NULL, 'AAK_P5CS_ProBA', NULL, NULL, 'AAK_P5CS_ProBA', 859),
(860, 'cd09104', NULL, 'PLDc_vPLD1_2_like_1', NULL, NULL, 'PLDc_vPLD1_2_like_1', 860),
(861, 'cd04129', NULL, 'Rho2', NULL, NULL, 'Rho2', 861),
(862, 'cd09542', NULL, 'SAM_EPH-A1', NULL, NULL, 'SAM_EPH-A1', 862),
(863, 'cd10963', NULL, 'CE4_RC0012_like', NULL, NULL, 'CE4_RC0012_like', 863),
(864, 'cd01815', NULL, 'Ubl_UBL7', NULL, NULL, 'Ubl_UBL7', 864),
(865, 'cd14915', NULL, 'MYSc_Myh4', NULL, NULL, 'MYSc_Myh4', 865),
(866, 'cd13358', NULL, 'PH-GRAM_MTMR1', NULL, NULL, 'PH-GRAM_MTMR1', 866),
(867, 'cd16201', NULL, 'EFh_PI-PLCgamma', NULL, NULL, 'EFh_PI-PLCgamma', 867),
(868, 'cd12661', NULL, 'RRM3_hnRNPM', NULL, NULL, 'RRM3_hnRNPM', 868),
(869, 'cd00352', NULL, 'Gn_AT_II', NULL, NULL, 'Gn_AT_II', 869),
(870, 'cd00445', NULL, 'Uricase', NULL, NULL, 'Uricase', 870),
(871, 'cd13163', NULL, 'PTB_ICAP1', NULL, NULL, 'PTB_ICAP1', 871),
(872, 'cd08867', NULL, 'START_STARD4_5_6-like', NULL, NULL, 'START_STARD4_5_6-like', 872),
(873, 'cd16903', NULL, 'pesticin_lyz-like', NULL, NULL, 'pesticin_lyz-like', 873);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(874, 'cd07465', NULL, 'CRD_FZ1', NULL, NULL, 'CRD_FZ1', 874),
(875, 'cd16944', NULL, 'HATPase_NtrY-like', NULL, NULL, 'HATPase_NtrY-like', 875),
(876, 'cd00577', NULL, 'PCNA', NULL, NULL, 'PCNA', 876),
(877, 'cd07960', NULL, 'Anticodon_Ia_Ile_BEm', NULL, NULL, 'Anticodon_Ia_Ile_BEm', 877),
(878, 'cd04276', NULL, 'ZnMc_MMP_like_2', NULL, NULL, 'ZnMc_MMP_like_2', 878),
(879, 'cd05818', NULL, 'CBM20_water_dikinase', NULL, NULL, 'CBM20_water_dikinase', 879),
(880, 'cd05080', NULL, 'PTKc_Tyk2_rpt2', NULL, NULL, 'PTKc_Tyk2_rpt2', 880),
(881, 'cd03411', NULL, 'Ferrochelatase_N', NULL, NULL, 'Ferrochelatase_N', 881),
(882, 'cd09098', NULL, 'INPP5c_Synj1', NULL, NULL, 'INPP5c_Synj1', 882),
(883, 'cd18720', NULL, 'PIN_YqxD-like', NULL, NULL, 'PIN_YqxD-like', 883),
(884, 'cd05728', NULL, 'Ig4_Contactin-2-like', NULL, NULL, 'Ig4_Contactin-2-like', 884),
(885, 'cd18736', NULL, 'PIN_CcVapC1-like', NULL, NULL, 'PIN_CcVapC1-like', 885),
(886, 'cd07637', NULL, 'BAR_ACAP3', NULL, NULL, 'BAR_ACAP3', 886),
(887, 'cd01673', NULL, 'dNK', NULL, NULL, 'dNK', 887),
(888, 'cd03522', NULL, 'MoeA_like', NULL, NULL, 'MoeA_like', 888),
(889, 'cd13680', NULL, 'PBP2_TRAP_SBP_like_4', NULL, NULL, 'PBP2_TRAP_SBP_like_4', 889),
(890, 'cd03390', NULL, 'PAP2_containing_1_like', NULL, NULL, 'PAP2_containing_1_like', 890),
(891, 'cd06638', NULL, 'STKc_myosinIIIA_N', NULL, NULL, 'STKc_myosinIIIA_N', 891),
(892, 'cd18924', NULL, 'bHLHzip_USF1', NULL, NULL, 'bHLHzip_USF1', 892),
(893, 'cd12560', NULL, 'RRM_SRSF12', NULL, NULL, 'RRM_SRSF12', 893),
(894, 'cd09273', NULL, 'RNase_HI_RT_Bel', NULL, NULL, 'RNase_HI_RT_Bel', 894),
(895, 'cd10556', NULL, 'SER_beta', NULL, NULL, 'SER_beta', 895),
(896, 'cd01457', NULL, 'vWA_ORF176_type', NULL, NULL, 'vWA_ORF176_type', 896),
(897, 'cd18343', NULL, 'BTB_POZ_SPOPL', NULL, NULL, 'BTB_POZ_SPOPL', 897),
(898, 'cd17043', NULL, 'RA', NULL, NULL, 'RA', 898),
(899, 'cd03178', NULL, 'GST_C_Ure2p_like', NULL, NULL, 'GST_C_Ure2p_like', 899),
(900, 'cd01079', NULL, 'NAD_bind_m-THF_DH', NULL, NULL, 'NAD_bind_m-THF_DH', 900),
(901, 'cd04709', NULL, 'BAH_MTA', NULL, NULL, 'BAH_MTA', 901),
(902, 'cd06324', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, 'PBP1_ABC_sugar_binding-like', 902),
(903, 'cd01814', NULL, 'Ubl_MUBs_plant', NULL, NULL, 'Ubl_MUBs_plant', 903),
(904, 'cd09827', NULL, 'PET_Prickle', NULL, NULL, 'PET_Prickle', 904),
(905, 'cd00713', NULL, 'GltS', NULL, NULL, 'GltS', 905),
(906, 'cd17937', NULL, 'DEXXYc_viral_SF1-N', NULL, NULL, 'DEXXYc_viral_SF1-N', 906),
(907, 'cd09431', NULL, 'LIM3_Fhl2', NULL, NULL, 'LIM3_Fhl2', 907),
(908, 'cd13551', NULL, 'PBP2_Fbp_like_5', NULL, NULL, 'PBP2_Fbp_like_5', 908),
(909, 'cd04866', NULL, 'LigD_Pol_like_3', NULL, NULL, 'LigD_Pol_like_3', 909),
(910, 'cd01175', NULL, 'IPT_COE', NULL, NULL, 'IPT_COE', 910),
(911, 'cd05540', NULL, 'UreG', NULL, NULL, 'UreG', 911),
(912, 'cd07365', NULL, 'MhpB_like', NULL, NULL, 'MhpB_like', 912),
(913, 'cd04933', NULL, 'ACT_AK1-AT_1', NULL, NULL, 'ACT_AK1-AT_1', 913),
(914, 'cd01804', NULL, 'Ubl_midnolin', NULL, NULL, 'Ubl_midnolin', 914),
(915, 'cd07331', NULL, 'M48C_Oma1_like', NULL, NULL, 'M48C_Oma1_like', 915),
(916, 'cd06424', NULL, 'UGGPase', NULL, NULL, 'UGGPase', 916),
(917, 'cd10973', NULL, 'CE4_DAC_u4_5s', NULL, NULL, 'CE4_DAC_u4_5s', 917),
(918, 'cd15926', NULL, '7tmA_RNL3R1', NULL, NULL, '7tmA_RNL3R1', 918),
(919, 'cd07812', NULL, 'SRPBCC', NULL, NULL, 'SRPBCC', 919),
(920, 'cd20334', NULL, 'Cas13b', NULL, NULL, 'Cas13b', 920),
(921, 'cd16333', NULL, 'RELM', NULL, NULL, 'RELM', 921),
(922, 'cd14631', NULL, 'R-PTPc-K-1', NULL, NULL, 'R-PTPc-K-1', 922),
(923, 'cd19376', NULL, 'TGF_beta_GDF15', NULL, NULL, 'TGF_beta_GDF15', 923),
(924, 'cd04784', NULL, 'HTH_CadR-PbrR', NULL, NULL, 'HTH_CadR-PbrR', 924),
(925, 'cd10312', NULL, 'Deadenylase_CCR4b', NULL, NULL, 'Deadenylase_CCR4b', 925),
(926, 'cd19554', NULL, 'serpinA6_CBG', NULL, NULL, 'serpinA6_CBG', 926),
(927, 'cd12150', NULL, 'talin-RS', NULL, NULL, 'talin-RS', 927),
(928, 'cd01255', NULL, 'PH2_Tiam1_2', NULL, NULL, 'PH2_Tiam1_2', 928),
(929, 'cd11648', NULL, 'RsmI', NULL, NULL, 'RsmI', 929);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(930, 'cd18636', NULL, 'CD_Chp1_like', NULL, NULL, 'CD_Chp1_like', 930),
(931, 'cd15539', NULL, 'PHD1_AIRE', NULL, NULL, 'PHD1_AIRE', 931),
(932, 'cd00226', NULL, 'PRCH', NULL, NULL, 'PRCH', 932),
(933, 'cd06373', NULL, 'PBP1_NPR-like', NULL, NULL, 'PBP1_NPR-like', 933),
(934, 'cd10231', NULL, 'YegD_like', NULL, NULL, 'YegD_like', 934),
(935, 'cd13578', NULL, 'PBP2_Bug27', NULL, NULL, 'PBP2_Bug27', 935),
(936, 'cd18344', NULL, 'BTB_POZ_TDPOZ', NULL, NULL, 'BTB_POZ_TDPOZ', 936),
(937, 'cd03879', NULL, 'M28_AAP', NULL, NULL, 'M28_AAP', 937),
(938, 'cd06083', NULL, 'KOW_Spt5_3', NULL, NULL, 'KOW_Spt5_3', 938),
(939, 'cd05520', NULL, 'Bromo_polybromo_III', NULL, NULL, 'Bromo_polybromo_III', 939),
(940, 'cd14938', NULL, 'MYSc_Myo24B', NULL, NULL, 'MYSc_Myo24B', 940),
(941, 'cd16292', NULL, 'CPSF3-like_MBL-fold', NULL, NULL, 'CPSF3-like_MBL-fold', 941),
(942, 'cd07590', NULL, 'BAR_Bin3', NULL, NULL, 'BAR_Bin3', 942),
(943, 'cd15510', NULL, 'PHD2_KMT2C_like', NULL, NULL, 'PHD2_KMT2C_like', 943),
(944, 'cd06957', NULL, 'NR_DBD_PNR_like_2', NULL, NULL, 'NR_DBD_PNR_like_2', 944),
(945, 'cd11665', NULL, 'LamB_like', NULL, NULL, 'LamB_like', 945),
(946, 'cd16656', NULL, 'RING-Ubox_PRP19', NULL, NULL, 'RING-Ubox_PRP19', 946),
(947, 'cd10316', NULL, 'RGL4_M', NULL, NULL, 'RGL4_M', 947),
(948, 'cd04910', NULL, 'ACT_AK-Ectoine_1', NULL, NULL, 'ACT_AK-Ectoine_1', 948),
(949, 'cd06897', NULL, 'PX_SNARE', NULL, NULL, 'PX_SNARE', 949),
(950, 'cd17076', NULL, 'UBX_UBXN10', NULL, NULL, 'UBX_UBXN10', 950),
(951, 'cd09008', NULL, 'MTAN', NULL, NULL, 'MTAN', 951),
(952, 'cd18642', NULL, 'CBD_MOF_like', NULL, NULL, 'CBD_MOF_like', 952),
(953, 'cd08254', NULL, 'hydroxyacyl_CoA_DH', NULL, NULL, 'hydroxyacyl_CoA_DH', 953),
(954, 'cd18673', NULL, 'PIN_XRN1-2-like', NULL, NULL, 'PIN_XRN1-2-like', 954),
(955, 'cd11689', NULL, 'SidM_DrrA_GEF', NULL, NULL, 'SidM_DrrA_GEF', 955),
(956, 'cd05915', NULL, 'ttLC_FACS_like', NULL, NULL, 'ttLC_FACS_like', 956),
(957, 'cd08465', NULL, 'PBP2_ToxR', NULL, NULL, 'PBP2_ToxR', 957),
(958, 'cd16797', NULL, 'RING-H2_RNF167', NULL, NULL, 'RING-H2_RNF167', 958),
(959, 'cd16822', NULL, 'SP-RING_ZMIZ1', NULL, NULL, 'SP-RING_ZMIZ1', 959),
(960, 'cd01392', NULL, 'HTH_LacI', NULL, NULL, 'HTH_LacI', 960),
(961, 'cd09717', NULL, 'Cas7_I', NULL, NULL, 'Cas7_I', 961),
(962, 'cd11699', NULL, 'DHR2_DOCK10', NULL, NULL, 'DHR2_DOCK10', 962),
(963, 'cd12228', NULL, 'RRM_ENOX', NULL, NULL, 'RRM_ENOX', 963),
(964, 'cd09720', NULL, 'Cas1_II', NULL, NULL, 'Cas1_II', 964),
(965, 'cd05764', NULL, 'Ig_2', NULL, NULL, 'Ig_2', 965),
(966, 'cd01279', NULL, 'HTH_HspR-like', NULL, NULL, 'HTH_HspR-like', 966),
(967, 'cd00583', NULL, 'MutH_Sau3AI', NULL, NULL, 'MutH_Sau3AI', 967),
(968, 'cd03802', NULL, 'GT4_AviGT4-like', NULL, NULL, 'GT4_AviGT4-like', 968),
(969, 'cd01373', NULL, 'KISc_KLP2_like', NULL, NULL, 'KISc_KLP2_like', 969),
(970, 'cd00795', NULL, 'NOS_oxygenase_euk', NULL, NULL, 'NOS_oxygenase_euk', 970),
(971, 'cd06641', NULL, 'STKc_MST3', NULL, NULL, 'STKc_MST3', 971),
(972, 'cd11820', NULL, 'SH3_STAM', NULL, NULL, 'SH3_STAM', 972),
(973, 'cd18698', NULL, 'PIN_VapC_C-like', NULL, NULL, 'PIN_VapC_C-like', 973),
(974, 'cd17107', NULL, 'FERM_F1_EPB41L4A', NULL, NULL, 'FERM_F1_EPB41L4A', 974),
(975, 'cd09164', NULL, 'PLDc_EcPPK1_C1_like', NULL, NULL, 'PLDc_EcPPK1_C1_like', 975),
(976, 'cd13615', NULL, 'PBP2_ProWY', NULL, NULL, 'PBP2_ProWY', 976),
(977, 'cd09133', NULL, 'PLDc_unchar5', NULL, NULL, 'PLDc_unchar5', 977),
(978, 'cd15183', NULL, '7tmA_CCR1', NULL, NULL, '7tmA_CCR1', 978),
(979, 'cd16684', NULL, 'RING-H2_RNF145', NULL, NULL, 'RING-H2_RNF145', 979),
(980, 'cd19086', NULL, 'AKR_AKR11C1', NULL, NULL, 'AKR_AKR11C1', 980),
(981, 'cd04113', NULL, 'Rab4', NULL, NULL, 'Rab4', 981),
(982, 'cd05853', NULL, 'Ig6_Contactin-4', NULL, NULL, 'Ig6_Contactin-4', 982),
(983, 'cd16209', NULL, 'EFh_PI-PLCbeta2', NULL, NULL, 'EFh_PI-PLCbeta2', 983),
(984, 'cd17658', NULL, 'PTPc_plant_PTP1', NULL, NULL, 'PTPc_plant_PTP1', 984),
(985, 'cd01891', NULL, 'TypA_BipA', NULL, NULL, 'TypA_BipA', 985),
(986, 'cd14954', NULL, 'NHL_TRIM71_like', NULL, NULL, 'NHL_TRIM71_like', 986);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(987, 'cd02419', NULL, 'Peptidase_C39C', NULL, NULL, 'Peptidase_C39C', 987),
(988, 'cd12877', NULL, 'SPRY1_RyR', NULL, NULL, 'SPRY1_RyR', 988),
(989, 'cd09287', NULL, 'GluRS_non_core', NULL, NULL, 'GluRS_non_core', 989),
(990, 'cd15847', NULL, 'SNARE_syntaxin7_like', NULL, NULL, 'SNARE_syntaxin7_like', 990),
(991, 'cd10164', NULL, 'ClassIIa_HDAC5_Gln-rich-N', NULL, NULL, 'ClassIIa_HDAC5_Gln-rich-N', 991),
(992, 'cd02642', NULL, 'R3H_encore_like', NULL, NULL, 'R3H_encore_like', 992),
(993, 'cd14965', NULL, '7tm_Opsins_type1', NULL, NULL, '7tm_Opsins_type1', 993),
(994, 'cd04039', NULL, 'C2_PSD', NULL, NULL, 'C2_PSD', 994),
(995, 'cd14768', NULL, 'PC_PEC_beta', NULL, NULL, 'PC_PEC_beta', 995),
(996, 'cd09592', NULL, 'SAM_DLC2', NULL, NULL, 'SAM_DLC2', 996),
(997, 'cd14698', NULL, 'bZIP_CNC', NULL, NULL, 'bZIP_CNC', 997),
(998, 'cd18758', NULL, 'PIN_MtVapC3-like', NULL, NULL, 'PIN_MtVapC3-like', 998),
(999, 'cd12075', NULL, 'SH3_Tks4_1', NULL, NULL, 'SH3_Tks4_1', 999),
(1000, 'cd12705', NULL, 'RRM4_hnRPLL', NULL, NULL, 'RRM4_hnRPLL', 1000),
(1001, 'cd15436', NULL, '7tmB2_Latrophilin', NULL, NULL, '7tmB2_Latrophilin', 1001),
(1002, 'cd10236', NULL, 'HscA_like_NBD', NULL, NULL, 'HscA_like_NBD', 1002),
(1003, 'cd11426', NULL, 'bHLH_TS_MIST1_like', NULL, NULL, 'bHLH_TS_MIST1_like', 1003),
(1004, 'cd10500', NULL, 'MH2_SMAD_7', NULL, NULL, 'MH2_SMAD_7', 1004),
(1005, 'cd10471', NULL, 'FAM20C_C', NULL, NULL, 'FAM20C_C', 1005),
(1006, 'cd13387', NULL, 'PH1_FGD3', NULL, NULL, 'PH1_FGD3', 1006),
(1007, 'cd14209', NULL, 'STKc_PKA', NULL, NULL, 'STKc_PKA', 1007),
(1008, 'cd08215', NULL, 'STKc_Nek', NULL, NULL, 'STKc_Nek', 1008),
(1009, 'cd11851', NULL, 'SH3_RIM-BP', NULL, NULL, 'SH3_RIM-BP', 1009),
(1010, 'cd07633', NULL, 'BAR_OPHN1', NULL, NULL, 'BAR_OPHN1', 1010),
(1011, 'cd14531', NULL, 'PFA-DSP_Oca1', NULL, NULL, 'PFA-DSP_Oca1', 1011),
(1012, 'cd04143', NULL, 'Rhes_like', NULL, NULL, 'Rhes_like', 1012),
(1013, 'cd09330', NULL, 'LIM4_abLIM', NULL, NULL, 'LIM4_abLIM', 1013),
(1014, 'cd19026', NULL, 'LGIC_ECD_nAChR_B3', NULL, NULL, 'LGIC_ECD_nAChR_B3', 1014),
(1015, 'cd19918', NULL, 'RsmI_like', NULL, NULL, 'RsmI_like', 1015),
(1016, 'cd07433', NULL, 'PHP_PolIIIA_DnaE1', NULL, NULL, 'PHP_PolIIIA_DnaE1', 1016),
(1017, 'cd09902', NULL, 'H3TH_MKT1', NULL, NULL, 'H3TH_MKT1', 1017),
(1018, 'cd20761', NULL, 'capping_2-OMTase_Flaviviridae', NULL, NULL, 'capping_2-OMTase_Flaviviridae', 1018),
(1019, 'cd12639', NULL, 'RRM3_CELF3_4_5_6', NULL, NULL, 'RRM3_CELF3_4_5_6', 1019),
(1020, 'cd07078', NULL, 'ALDH', NULL, NULL, 'ALDH', 1020),
(1021, 'cd02847', NULL, 'E_set_Chitobiase_C', NULL, NULL, 'E_set_Chitobiase_C', 1021),
(1022, 'cd04885', NULL, 'ACT_ThrD-I', NULL, NULL, 'ACT_ThrD-I', 1022),
(1023, 'cd17388', NULL, 'MFS_TetA', NULL, NULL, 'MFS_TetA', 1023),
(1024, 'cd12384', NULL, 'RRM_RBM24_RBM38_like', NULL, NULL, 'RRM_RBM24_RBM38_like', 1024),
(1025, 'cd17307', NULL, 'PIPKc_PIP5K1B', NULL, NULL, 'PIPKc_PIP5K1B', 1025),
(1026, 'cd19473', NULL, 'SET_SUV39H_DIM5-like', NULL, NULL, 'SET_SUV39H_DIM5-like', 1026),
(1027, 'cd09501', NULL, 'SAM_SARM1-like_repeat1', NULL, NULL, 'SAM_SARM1-like_repeat1', 1027),
(1028, 'cd09923', NULL, 'SH2_SOCS_family', NULL, NULL, 'SH2_SOCS_family', 1028),
(1029, 'cd15644', NULL, 'PHD_KDM2B', NULL, NULL, 'PHD_KDM2B', 1029),
(1030, 'cd08291', NULL, 'ETR_like_1', NULL, NULL, 'ETR_like_1', 1030),
(1031, 'cd12393', NULL, 'RRM_ZCRB1', NULL, NULL, 'RRM_ZCRB1', 1031),
(1032, 'cd05234', NULL, 'UDP_G4E_2_SDR_e', NULL, NULL, 'UDP_G4E_2_SDR_e', 1032),
(1033, 'cd05497', NULL, 'Bromo_Brdt_I_like', NULL, NULL, 'Bromo_Brdt_I_like', 1033),
(1034, 'cd03718', NULL, 'SOCS_SSB1_4', NULL, NULL, 'SOCS_SSB1_4', 1034),
(1035, 'cd19954', NULL, 'serpin42Dd-like_insects', NULL, NULL, 'serpin42Dd-like_insects', 1035),
(1036, 'cd05619', NULL, 'STKc_nPKC_theta', NULL, NULL, 'STKc_nPKC_theta', 1036),
(1037, 'cd12258', NULL, 'RRM2_RBM26_like', NULL, NULL, 'RRM2_RBM26_like', 1037),
(1038, 'cd12689', NULL, 'RRM1_hnRNPL_like', NULL, NULL, 'RRM1_hnRNPL_like', 1038),
(1039, 'cd15632', NULL, 'PHD_PHF13', NULL, NULL, 'PHD_PHF13', 1039); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(1040, 'cd18990', NULL, 'LGIC_ECD_GABAAR', NULL, NULL, 'LGIC_ECD_GABAAR', 1040),
(1041, 'cd15307', NULL, '7tmA_5-HT2_insect-like', NULL, NULL, '7tmA_5-HT2_insect-like', 1041),
(1042, 'cd09638', NULL, 'Cas2_I_II_III', NULL, NULL, 'Cas2_I_II_III', 1042),
(1043, 'cd21170', NULL, 'NTD_cv_Nsp15-like', NULL, NULL, 'NTD_cv_Nsp15-like', 1043),
(1044, 'cd08175', NULL, 'G1PDH', NULL, NULL, 'G1PDH', 1044),
(1045, 'cd12372', NULL, 'RRM_CFIm68_CFIm59', NULL, NULL, 'RRM_CFIm68_CFIm59', 1045),
(1046, 'cd13272', NULL, 'PH_INPP4A_INPP4B', NULL, NULL, 'PH_INPP4A_INPP4B', 1046),
(1047, 'cd01389', NULL, 'MATA_HMG-box', NULL, NULL, 'MATA_HMG-box', 1047),
(1048, 'cd07866', NULL, 'STKc_BUR1', NULL, NULL, 'STKc_BUR1', 1048),
(1049, 'cd12452', NULL, 'RRM_ARP_like', NULL, NULL, 'RRM_ARP_like', 1049),
(1050, 'cd09846', NULL, 'DUF1312', NULL, NULL, 'DUF1312', 1050),
(1051, 'cd17205', NULL, 'FERM_F1_EPB41L5', NULL, NULL, 'FERM_F1_EPB41L5', 1051),
(1052, 'cd14025', NULL, 'STKc_RIP4_like', NULL, NULL, 'STKc_RIP4_like', 1052),
(1053, 'cd18222', NULL, 'BTB_POZ_ZBTB37', NULL, NULL, 'BTB_POZ_ZBTB37', 1053),
(1054, 'cd08205', NULL, 'RuBisCO_IV_RLP', NULL, NULL, 'RuBisCO_IV_RLP', 1054),
(1055, 'cd01314', NULL, 'D-HYD', NULL, NULL, 'D-HYD', 1055),
(1056, 'cd15645', NULL, 'PHD_FXL19', NULL, NULL, 'PHD_FXL19', 1056),
(1057, 'cd14577', NULL, 'DUSP13B', NULL, NULL, 'DUSP13B', 1057),
(1058, 'cd11529', NULL, 'NTP-PPase_MazG_Cterm', NULL, NULL, 'NTP-PPase_MazG_Cterm', 1058),
(1059, 'cd12755', NULL, 'RRM2_RBM5', NULL, NULL, 'RRM2_RBM5', 1059),
(1060, 'cd00559', NULL, 'Cyanase_C', NULL, NULL, 'Cyanase_C', 1060),
(1061, 'cd18423', NULL, 'BTB_POZ_KCNG4', NULL, NULL, 'BTB_POZ_KCNG4', 1061),
(1062, 'cd09159', NULL, 'PLDc_ybhO_like_2', NULL, NULL, 'PLDc_ybhO_like_2', 1062),
(1063, 'cd07048', NULL, 'BMC_PduB_repeat2', NULL, NULL, 'BMC_PduB_repeat2', 1063),
(1064, 'cd07826', NULL, 'SRPBCC_CalC_Aha1-like_9', NULL, NULL, 'SRPBCC_CalC_Aha1-like_9', 1064),
(1065, 'cd00251', NULL, 'Mth_Ecto', NULL, NULL, 'Mth_Ecto', 1065),
(1066, 'cd14827', NULL, 'AP_sigma', NULL, NULL, 'AP_sigma', 1066),
(1067, 'cd08759', NULL, 'Type_III_cohesin_like', NULL, NULL, 'Type_III_cohesin_like', 1067),
(1068, 'cd04031', NULL, 'C2A_RIM1alpha', NULL, NULL, 'C2A_RIM1alpha', 1068),
(1069, 'cd09425', NULL, 'LIM4_LIMPETin', NULL, NULL, 'LIM4_LIMPETin', 1069),
(1070, 'cd08734', NULL, 'RGS-like_1', NULL, NULL, 'RGS-like_1', 1070),
(1071, 'cd13710', NULL, 'PBP2_TcyK', NULL, NULL, 'PBP2_TcyK', 1071),
(1072, 'cd04216', NULL, 'Phytocyanin', NULL, NULL, 'Phytocyanin', 1072),
(1073, 'cd06842', NULL, 'PLPDE_III_Y4yA_like', NULL, NULL, 'PLPDE_III_Y4yA_like', 1073),
(1074, 'cd19710', NULL, 'bHLH_TS_TCF24', NULL, NULL, 'bHLH_TS_TCF24', 1074),
(1075, 'cd01900', NULL, 'YchF', NULL, NULL, 'YchF', 1075),
(1076, 'cd03447', NULL, 'FAS_MaoC', NULL, NULL, 'FAS_MaoC', 1076),
(1077, 'cd03781', NULL, 'MATH_TRAF4', NULL, NULL, 'MATH_TRAF4', 1077),
(1078, 'cd16295', NULL, 'TTHA0252-CPSF-like_MBL-fold', NULL, NULL, 'TTHA0252-CPSF-like_MBL-fold', 1078),
(1079, 'cd03009', NULL, 'TryX_like_TryX_NRX', NULL, NULL, 'TryX_like_TryX_NRX', 1079),
(1080, 'cd16925', NULL, 'HATPase_TutC-TodS-like', NULL, NULL, 'HATPase_TutC-TodS-like', 1080),
(1081, 'cd16449', NULL, 'RING-HC', NULL, NULL, 'RING-HC', 1081),
(1082, 'cd19788', NULL, 'Bbox2_MuRF', NULL, NULL, 'Bbox2_MuRF', 1082),
(1083, 'cd05837', NULL, 'MSH6_like', NULL, NULL, 'MSH6_like', 1083),
(1084, 'cd19531', NULL, 'LCL_NRPS-like', NULL, NULL, 'LCL_NRPS-like', 1084),
(1085, 'cd14819', NULL, 'Translin', NULL, NULL, 'Translin', 1085),
(1086, 'cd18378', NULL, 'BTB_POZ_Kv2_KCNB', NULL, NULL, 'BTB_POZ_Kv2_KCNB', 1086),
(1087, 'cd18612', NULL, 'GH130_Lin0857-like', NULL, NULL, 'GH130_Lin0857-like', 1087),
(1088, 'cd06423', NULL, 'CESA_like', NULL, NULL, 'CESA_like', 1088),
(1089, 'cd18278', NULL, 'BTB_POZ_BACH2', NULL, NULL, 'BTB_POZ_BACH2', 1089),
(1090, 'cd14638', NULL, 'DSP_DUSP1', NULL, NULL, 'DSP_DUSP1', 1090),
(1091, 'cd15684', NULL, 'PHD_ING4', NULL, NULL, 'PHD_ING4', 1091),
(1092, 'cd00402', NULL, 'Riboflavin_synthase_like', NULL, NULL, 'Riboflavin_synthase_like', 1092);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(1093, 'cd17651', NULL, 'A_NRPS_VisG_like', NULL, NULL, 'A_NRPS_VisG_like', 1093),
(1094, 'cd11969', NULL, 'SH3_PLCgamma2', NULL, NULL, 'SH3_PLCgamma2', 1094),
(1095, 'cd02770', NULL, 'MopB_DmsA-EC', NULL, NULL, 'MopB_DmsA-EC', 1095),
(1096, 'cd08435', NULL, 'PBP2_GbpR', NULL, NULL, 'PBP2_GbpR', 1096),
(1097, 'cd14849', NULL, 'DD-dipeptidase_VanXYc', NULL, NULL, 'DD-dipeptidase_VanXYc', 1097),
(1098, 'cd08264', NULL, 'Zn_ADH_like2', NULL, NULL, 'Zn_ADH_like2', 1098),
(1099, 'cd01451', NULL, 'vWA_Magnesium_chelatase', NULL, NULL, 'vWA_Magnesium_chelatase', 1099),
(1100, 'cd15405', NULL, '7tmA_OR8B-like', NULL, NULL, '7tmA_OR8B-like', 1100),
(1101, 'cd03110', NULL, 'SIMIBI_bact_arch', NULL, NULL, 'SIMIBI_bact_arch', 1101),
(1102, 'cd07647', NULL, 'F-BAR_PSTPIP', NULL, NULL, 'F-BAR_PSTPIP', 1102),
(1103, 'cd00044', NULL, 'CysPc', NULL, NULL, 'CysPc', 1103),
(1104, 'cd03569', NULL, 'VHS_Hrs', NULL, NULL, 'VHS_Hrs', 1104),
(1105, 'cd19459', NULL, 'lipocalin_C1_moubatin-like', NULL, NULL, 'lipocalin_C1_moubatin-like', 1105),
(1106, 'cd15123', NULL, '7tmA_BRS-3', NULL, NULL, '7tmA_BRS-3', 1106),
(1107, 'cd00161', NULL, 'RICIN', NULL, NULL, 'RICIN', 1107),
(1108, 'cd01917', NULL, 'ACS_2', NULL, NULL, 'ACS_2', 1108),
(1109, 'cd20609', NULL, 'nitroreductase', NULL, NULL, 'nitroreductase', 1109),
(1110, 'cd16005', NULL, '7tmB2_Latrophilin-3', NULL, NULL, '7tmB2_Latrophilin-3', 1110),
(1111, 'cd09741', NULL, 'Csx1_III-U', NULL, NULL, 'Csx1_III-U', 1111),
(1112, 'cd18324', NULL, 'BTB_POZ_ZBTB18_RP58', NULL, NULL, 'BTB_POZ_ZBTB18_RP58', 1112),
(1113, 'cd05092', NULL, 'PTKc_TrkA', NULL, NULL, 'PTKc_TrkA', 1113),
(1114, 'cd11862', NULL, 'SH3_MPP', NULL, NULL, 'SH3_MPP', 1114),
(1115, 'cd18753', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, 'PIN_VapC4-5_FitB-like', 1115),
(1116, 'cd17218', NULL, 'RA_RASSF1', NULL, NULL, 'RA_RASSF1', 1116),
(1117, 'cd00581', NULL, 'QFR_TypeB_TM', NULL, NULL, 'QFR_TypeB_TM', 1117),
(1118, 'cd19724', NULL, 'bHLH_TS_ASCL3_like', NULL, NULL, 'bHLH_TS_ASCL3_like', 1118),
(1119, 'cd21404', NULL, 'ZBD_rv_SF1_Hel-like', NULL, NULL, 'ZBD_rv_SF1_Hel-like', 1119),
(1120, 'cd15546', NULL, 'PHD_PHF13_like', NULL, NULL, 'PHD_PHF13_like', 1120),
(1121, 'cd03267', NULL, 'ABC_NatA_like', NULL, NULL, 'ABC_NatA_like', 1121),
(1122, 'cd16002', NULL, '7tmA_NK1R', NULL, NULL, '7tmA_NK1R', 1122),
(1123, 'cd15008', NULL, '7tmA_GPR19', NULL, NULL, '7tmA_GPR19', 1123),
(1124, 'cd14828', NULL, 'AP_Mu_N', NULL, NULL, 'AP_Mu_N', 1124),
(1125, 'cd01210', NULL, 'PTB_EPS8', NULL, NULL, 'PTB_EPS8', 1125),
(1126, 'cd08513', NULL, 'PBP2_thermophilic_Hb8_like', NULL, NULL, 'PBP2_thermophilic_Hb8_like', 1126),
(1127, 'cd18464', NULL, 'BACK_KLHL25_like', NULL, NULL, 'BACK_KLHL25_like', 1127),
(1128, 'cd17058', NULL, 'Ubl_SNRNP25', NULL, NULL, 'Ubl_SNRNP25', 1128),
(1129, 'cd18069', NULL, 'DEXHc_ARIP4', NULL, NULL, 'DEXHc_ARIP4', 1129),
(1130, 'cd12006', NULL, 'SH3_Fyn_Yrk', NULL, NULL, 'SH3_Fyn_Yrk', 1130),
(1131, 'cd07588', NULL, 'BAR_Amphiphysin', NULL, NULL, 'BAR_Amphiphysin', 1131),
(1132, 'cd01000', NULL, 'PBP2_Cys_DEBP_like', NULL, NULL, 'PBP2_Cys_DEBP_like', 1132),
(1133, 'cd13440', NULL, 'CamS_repeat_2', NULL, NULL, 'CamS_repeat_2', 1133),
(1134, 'cd14818', NULL, 'longin-like', NULL, NULL, 'longin-like', 1134),
(1135, 'cd15767', NULL, 'FYVE_SPIR1', NULL, NULL, 'FYVE_SPIR1', 1135),
(1136, 'cd12011', NULL, 'SH3_SLAP2', NULL, NULL, 'SH3_SLAP2', 1136),
(1137, 'cd12036', NULL, 'SH3_MPP5', NULL, NULL, 'SH3_MPP5', 1137),
(1138, 'cd00035', NULL, 'ChtBD1', NULL, NULL, 'ChtBD1', 1138),
(1139, 'cd18579', NULL, 'ABC_6TM_ABCC_D1', NULL, NULL, 'ABC_6TM_ABCC_D1', 1139),
(1140, 'cd08520', NULL, 'PBP2_NikA_DppA_OppA_like_21', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_21', 1140),
(1141, 'cd05488', NULL, 'Proteinase_A_fungi', NULL, NULL, 'Proteinase_A_fungi', 1141),
(1142, 'cd01556', NULL, 'EPSP_synthase', NULL, NULL, 'EPSP_synthase', 1142),
(1143, 'cd15641', NULL, 'PHD_PHF2', NULL, NULL, 'PHD_PHF2', 1143),
(1144, 'cd13339', NULL, 'PH-GRAM_MTMR13', NULL, NULL, 'PH-GRAM_MTMR13', 1144),
(1145, 'cd01650', NULL, 'RT_nLTR_like', NULL, NULL, 'RT_nLTR_like', 1145);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(1146, 'cd14018', NULL, 'STKc_PINK1', NULL, NULL, 'STKc_PINK1', 1146),
(1147, 'cd16297', NULL, 'artemis-SNM1C-like_MBL-fold', NULL, NULL, 'artemis-SNM1C-like_MBL-fold', 1147),
(1148, 'cd12162', NULL, '2-Hacid_dh_4', NULL, NULL, '2-Hacid_dh_4', 1148),
(1149, 'cd16152', NULL, 'sulfatase_like', NULL, NULL, 'sulfatase_like', 1149),
(1150, 'cd01759', NULL, 'PLAT_PL', NULL, NULL, 'PLAT_PL', 1150),
(1151, 'cd19548', NULL, 'serpinA_A1AT-like', NULL, NULL, 'serpinA_A1AT-like', 1151),
(1152, 'cd06935', NULL, 'NR_LBD_TR', NULL, NULL, 'NR_LBD_TR', 1152),
(1153, 'cd19351', NULL, 'Wnt_Wnt8a', NULL, NULL, 'Wnt_Wnt8a', 1153),
(1154, 'cd09163', NULL, 'PLDc_CLS_unchar2_2', NULL, NULL, 'PLDc_CLS_unchar2_2', 1154),
(1155, 'cd04367', NULL, 'IlGF_insulin_like', NULL, NULL, 'IlGF_insulin_like', 1155),
(1156, 'cd15225', NULL, '7tmA_OR10A-like', NULL, NULL, '7tmA_OR10A-like', 1156),
(1157, 'cd06382', NULL, 'PBP1_iGluR_Kainate', NULL, NULL, 'PBP1_iGluR_Kainate', 1157),
(1158, 'cd18202', NULL, 'BTB_POZ_ZBTB11', NULL, NULL, 'BTB_POZ_ZBTB11', 1158),
(1159, 'cd06991', NULL, 'cupin_TcmJ-like', NULL, NULL, 'cupin_TcmJ-like', 1159),
(1160, 'cd09134', NULL, 'PLDc_PSS_G_neg_1', NULL, NULL, 'PLDc_PSS_G_neg_1', 1160),
(1161, 'cd07438', NULL, 'PHP_HisPPase_AMP', NULL, NULL, 'PHP_HisPPase_AMP', 1161),
(1162, 'cd18258', NULL, 'BTB_POZ_KLHL29_KBTBD9', NULL, NULL, 'BTB_POZ_KLHL29_KBTBD9', 1162),
(1163, 'cd01426', NULL, 'ATP-synt_F1_V1_A1_AB_FliI_N', NULL, NULL, 'ATP-synt_F1_V1_A1_AB_FliI_N', 1163),
(1164, 'cd15827', NULL, 'SPRY_PRY_TRIM10', NULL, NULL, 'SPRY_PRY_TRIM10', 1164),
(1165, 'cd17983', NULL, 'DEXHc_DHX38', NULL, NULL, 'DEXHc_DHX38', 1165),
(1166, 'cd09348', NULL, 'LIM4_FHL1', NULL, NULL, 'LIM4_FHL1', 1166),
(1167, 'cd19552', NULL, 'serpinA4_KST', NULL, NULL, 'serpinA4_KST', 1167),
(1168, 'cd05040', NULL, 'PTKc_Ack_like', NULL, NULL, 'PTKc_Ack_like', 1168),
(1169, 'cd02933', NULL, 'OYE_like_FMN', NULL, NULL, 'OYE_like_FMN', 1169),
(1170, 'cd17284', NULL, 'RMtype1_S_Cbo7060ORF11580P_TRD2-CR2_like', NULL, NULL, 'RMtype1_S_Cbo7060ORF11580P_TRD2-CR2_like', 1170),
(1171, 'cd00918', NULL, 'Der-p2_like', NULL, NULL, 'Der-p2_like', 1171),
(1172, 'cd19418', NULL, 'lipocalin_A1M-like', NULL, NULL, 'lipocalin_A1M-like', 1172),
(1173, 'cd06007', NULL, 'R3H_DEXH_helicase', NULL, NULL, 'R3H_DEXH_helicase', 1173),
(1174, 'cd01475', NULL, 'vWA_Matrilin', NULL, NULL, 'vWA_Matrilin', 1174),
(1175, 'cd04158', NULL, 'ARD1', NULL, NULL, 'ARD1', 1175),
(1176, 'cd09093', NULL, 'INPP5c_INPP5B', NULL, NULL, 'INPP5c_INPP5B', 1176),
(1177, 'cd15443', NULL, '7tmB2_GPR114', NULL, NULL, '7tmB2_GPR114', 1177),
(1178, 'cd10802', NULL, 'YdjC_TTHB029_like', NULL, NULL, 'YdjC_TTHB029_like', 1178),
(1179, 'cd10033', NULL, 'UDG_like', NULL, NULL, 'UDG_like', 1179),
(1180, 'cd01068', NULL, 'globin_sensor', NULL, NULL, 'globin_sensor', 1180),
(1181, 'cd08449', NULL, 'PBP2_XapR', NULL, NULL, 'PBP2_XapR', 1181),
(1182, 'cd06330', NULL, 'PBP1_As_SBP-like', NULL, NULL, 'PBP1_As_SBP-like', 1182),
(1183, 'cd12324', NULL, 'RRM_RBM8', NULL, NULL, 'RRM_RBM8', 1183),
(1184, 'cd13152', NULL, 'KOW_GPKOW_A', NULL, NULL, 'KOW_GPKOW_A', 1184),
(1185, 'cd10014', NULL, 'TFIIA_gamma_C', NULL, NULL, 'TFIIA_gamma_C', 1185),
(1186, 'cd11420', NULL, 'bHLH_E-protein', NULL, NULL, 'bHLH_E-protein', 1186),
(1187, 'cd19339', NULL, 'Wnt_Wnt7', NULL, NULL, 'Wnt_Wnt7', 1187),
(1188, 'cd00381', NULL, 'IMPDH', NULL, NULL, 'IMPDH', 1188),
(1189, 'cd05719', NULL, 'Ig2_PVR_like', NULL, NULL, 'Ig2_PVR_like', 1189),
(1190, 'cd14637', NULL, 'R-PTPc-U-2', NULL, NULL, 'R-PTPc-U-2', 1190),
(1191, 'cd17176', NULL, 'FERM_F0_SHANK2', NULL, NULL, 'FERM_F0_SHANK2', 1191),
(1192, 'cd03422', NULL, 'YedF', NULL, NULL, 'YedF', 1192),
(1193, 'cd18589', NULL, 'ABC_6TM_TAP1', NULL, NULL, 'ABC_6TM_TAP1', 1193),
(1194, 'cd11838', NULL, 'SH3_Intersectin_3', NULL, NULL, 'SH3_Intersectin_3', 1194),
(1195, 'cd10917', NULL, 'CE4_NodB_like_6s_7s', NULL, NULL, 'CE4_NodB_like_6s_7s', 1195),
(1196, 'cd09901', NULL, 'H3TH_FEN1-like', NULL, NULL, 'H3TH_FEN1-like', 1196),
(1197, 'cd06118', NULL, 'citrate_synt_like_1', NULL, NULL, 'citrate_synt_like_1', 1197);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(1198, 'cd07927', NULL, 'RHD-n_NFAT_like', NULL, NULL, 'RHD-n_NFAT_like', 1198),
(1199, 'cd04392', NULL, 'RhoGAP_ARHGAP19', NULL, NULL, 'RhoGAP_ARHGAP19', 1199),
(1200, 'cd14594', NULL, 'PTP-MTMR12', NULL, NULL, 'PTP-MTMR12', 1200),
(1201, 'cd04320', NULL, 'AspRS_cyto_N', NULL, NULL, 'AspRS_cyto_N', 1201),
(1202, 'cd15975', NULL, '7tmA_ET-AR', NULL, NULL, '7tmA_ET-AR', 1202),
(1203, 'cd12533', NULL, 'RRM_EWS', NULL, NULL, 'RRM_EWS', 1203),
(1204, 'cd14040', NULL, 'STKc_TLK1', NULL, NULL, 'STKc_TLK1', 1204),
(1205, 'cd06281', NULL, 'PBP1_LacI-like', NULL, NULL, 'PBP1_LacI-like', 1205),
(1206, 'cd17939', NULL, 'DEADc_EIF4A', NULL, NULL, 'DEADc_EIF4A', 1206),
(1207, 'cd03536', NULL, 'Rieske_RO_Alpha_DTDO', NULL, NULL, 'Rieske_RO_Alpha_DTDO', 1207),
(1208, 'cd08954', NULL, 'KR_1_FAS_SDR_x', NULL, NULL, 'KR_1_FAS_SDR_x', 1208),
(1209, 'cd11486', NULL, 'SLC5sbd_SGLT1', NULL, NULL, 'SLC5sbd_SGLT1', 1209),
(1210, 'cd15872', NULL, 'R-SNARE_VAMP5', NULL, NULL, 'R-SNARE_VAMP5', 1210),
(1211, 'cd04498', NULL, 'hPOT1_OB2', NULL, NULL, 'hPOT1_OB2', 1211),
(1212, 'cd01005', NULL, 'PBP2_CysP', NULL, NULL, 'PBP2_CysP', 1212),
(1213, 'cd19191', NULL, 'PR-SET_PRDM6', NULL, NULL, 'PR-SET_PRDM6', 1213),
(1214, 'cd06231', NULL, 'M14_REP34-like', NULL, NULL, 'M14_REP34-like', 1214),
(1215, 'cd07642', NULL, 'BAR_ASAP2', NULL, NULL, 'BAR_ASAP2', 1215),
(1216, 'cd16328', NULL, 'RseA_N', NULL, NULL, 'RseA_N', 1216),
(1217, 'cd02244', NULL, 'cupin_7S_vicilin-like_N', NULL, NULL, 'cupin_7S_vicilin-like_N', 1217),
(1218, 'cd03117', NULL, 'alpha_CA_IV_XV_like', NULL, NULL, 'alpha_CA_IV_XV_like', 1218),
(1219, 'cd03236', NULL, 'ABC_RNaseL_inhibitor_domain1', NULL, NULL, 'ABC_RNaseL_inhibitor_domain1', 1219),
(1220, 'cd07981', NULL, 'TAF12', NULL, NULL, 'TAF12', 1220),
(1221, 'cd12043', NULL, 'SH3_CACNB4', NULL, NULL, 'SH3_CACNB4', 1221),
(1222, 'cd07855', NULL, 'STKc_ERK5', NULL, NULL, 'STKc_ERK5', 1222),
(1223, 'cd03147', NULL, 'GATase1_Ydr533c_like', NULL, NULL, 'GATase1_Ydr533c_like', 1223),
(1224, 'cd11296', NULL, 'O-FucT_like', NULL, NULL, 'O-FucT_like', 1224),
(1225, 'cd17404', NULL, 'MFS_SLCO5_OATP5', NULL, NULL, 'MFS_SLCO5_OATP5', 1225),
(1226, 'cd07281', NULL, 'PX_SNX1', NULL, NULL, 'PX_SNX1', 1226),
(1227, 'cd16792', NULL, 'SP-RING_Siz_plant', NULL, NULL, 'SP-RING_Siz_plant', 1227),
(1228, 'cd14226', NULL, 'PKc_DYRK1', NULL, NULL, 'PKc_DYRK1', 1228),
(1229, 'cd15388', NULL, '7tmA_V2R', NULL, NULL, '7tmA_V2R', 1229),
(1230, 'cd07206', NULL, 'Pat_TGL3-4-5_SDP1', NULL, NULL, 'Pat_TGL3-4-5_SDP1', 1230),
(1231, 'cd17742', NULL, 'BRCT_CHS5_like', NULL, NULL, 'BRCT_CHS5_like', 1231),
(1232, 'cd17666', NULL, 'PTP-MTM-like_fungal', NULL, NULL, 'PTP-MTM-like_fungal', 1232),
(1233, 'cd02526', NULL, 'GT2_RfbF_like', NULL, NULL, 'GT2_RfbF_like', 1233),
(1234, 'cd17963', NULL, 'DEADc_DDX19_DDX25', NULL, NULL, 'DEADc_DDX19_DDX25', 1234),
(1235, 'cd19873', NULL, 'DSRM_MRPL3_like', NULL, NULL, 'DSRM_MRPL3_like', 1235),
(1236, 'cd02808', NULL, 'GltS_FMN', NULL, NULL, 'GltS_FMN', 1236),
(1237, 'cd07088', NULL, 'ALDH_LactADH-AldA', NULL, NULL, 'ALDH_LactADH-AldA', 1237),
(1238, 'cd16709', NULL, 'RING-HC_Cbl-b', NULL, NULL, 'RING-HC_Cbl-b', 1238),
(1239, 'cd19389', NULL, 'TGF_beta_GDF11', NULL, NULL, 'TGF_beta_GDF11', 1239),
(1240, 'cd19828', NULL, 'Bbox2_TIF1a_C-VI', NULL, NULL, 'Bbox2_TIF1a_C-VI', 1240),
(1241, 'cd19887', NULL, 'DSRM_STAU1_rpt5', NULL, NULL, 'DSRM_STAU1_rpt5', 1241),
(1242, 'cd13584', NULL, 'PBP2_AlgQ1_2', NULL, NULL, 'PBP2_AlgQ1_2', 1242),
(1243, 'cd11391', NULL, 'bHLH_PAS', NULL, NULL, 'bHLH_PAS', 1243),
(1244, 'cd15724', NULL, 'FYVE_ZFY26', NULL, NULL, 'FYVE_ZFY26', 1244),
(1245, 'cd12309', NULL, 'RRM2_Spen', NULL, NULL, 'RRM2_Spen', 1245),
(1246, 'cd16359', NULL, 'VOC_BsCatE_like_C', NULL, NULL, 'VOC_BsCatE_like_C', 1246),
(1247, 'cd03881', NULL, 'M28_Nicastrin', NULL, NULL, 'M28_Nicastrin', 1247),
(1248, 'cd13540', NULL, 'PBP2_ModA_WtpA', NULL, NULL, 'PBP2_ModA_WtpA', 1248),
(1249, 'cd18700', NULL, 'PIN_GNAT-like', NULL, NULL, 'PIN_GNAT-like', 1249),
(1250, 'cd17458', NULL, 'MFS_SLCO1A_OATP1A', NULL, NULL, 'MFS_SLCO1A_OATP1A', 1250); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(1251, 'cd07456', NULL, 'CRD_FZ5_like', NULL, NULL, 'CRD_FZ5_like', 1251),
(1252, 'cd18064', NULL, 'DEXHc_SMARCA5', NULL, NULL, 'DEXHc_SMARCA5', 1252),
(1253, 'cd00887', NULL, 'MoeA', NULL, NULL, 'MoeA', 1253),
(1254, 'cd08825', NULL, 'MVP_shoulder', NULL, NULL, 'MVP_shoulder', 1254),
(1255, 'cd06913', NULL, 'beta3GnTL1_like', NULL, NULL, 'beta3GnTL1_like', 1255),
(1256, 'cd01387', NULL, 'MYSc_Myo15', NULL, NULL, 'MYSc_Myo15', 1256),
(1257, 'cd08702', NULL, 'Arna_FMT_C', NULL, NULL, 'Arna_FMT_C', 1257),
(1258, 'cd00290', NULL, 'cytochrome_b_C', NULL, NULL, 'cytochrome_b_C', 1258),
(1259, 'cd04925', NULL, 'ACT_ACR_2', NULL, NULL, 'ACT_ACR_2', 1259),
(1260, 'cd03864', NULL, 'M14_CPN', NULL, NULL, 'M14_CPN', 1260),
(1261, 'cd18743', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, 'PIN_VapC4-5_FitB-like', 1261),
(1262, 'cd04377', NULL, 'RhoGAP_myosin_IX', NULL, NULL, 'RhoGAP_myosin_IX', 1262),
(1263, 'cd09116', NULL, 'PLDc_Nuc_like', NULL, NULL, 'PLDc_Nuc_like', 1263),
(1264, 'cd15269', NULL, '7tmB1_VIP-R1', NULL, NULL, '7tmB1_VIP-R1', 1264),
(1265, 'cd10554', NULL, 'HycB_like', NULL, NULL, 'HycB_like', 1265),
(1266, 'cd16828', NULL, 'HemS-like', NULL, NULL, 'HemS-like', 1266),
(1267, 'cd10580', NULL, 'TNFRSF10', NULL, NULL, 'TNFRSF10', 1267),
(1268, 'cd05255', NULL, 'SQD1_like_SDR_e', NULL, NULL, 'SQD1_like_SDR_e', 1268),
(1269, 'cd18975', NULL, 'CD_MarY1_POL_like', NULL, NULL, 'CD_MarY1_POL_like', 1269),
(1270, 'cd10911', NULL, 'PIN_LabA', NULL, NULL, 'PIN_LabA', 1270),
(1271, 'cd06524', NULL, 'GH25_YegX-like', NULL, NULL, 'GH25_YegX-like', 1271),
(1272, 'cd03022', NULL, 'DsbA_HCCA_Iso', NULL, NULL, 'DsbA_HCCA_Iso', 1272),
(1273, 'cd00538', NULL, 'PA', NULL, NULL, 'PA', 1273),
(1274, 'cd12139', NULL, 'SH3_Bin1', NULL, NULL, 'SH3_Bin1', 1274),
(1275, 'cd13178', NULL, 'RanBD4_RanBP2-like', NULL, NULL, 'RanBD4_RanBP2-like', 1275),
(1276, 'cd06006', NULL, 'R3H_unknown_2', NULL, NULL, 'R3H_unknown_2', 1276),
(1277, 'cd12356', NULL, 'RRM_PPARGC1B', NULL, NULL, 'RRM_PPARGC1B', 1277),
(1278, 'cd05326', NULL, 'secoisolariciresinol-DH_like_SDR_c', NULL, NULL, 'secoisolariciresinol-DH_like_SDR_c', 1278),
(1279, 'cd07905', NULL, 'Adenylation_DNA_ligase_LigC', NULL, NULL, 'Adenylation_DNA_ligase_LigC', 1279),
(1280, 'cd02576', NULL, 'PseudoU_synth_ScPUS7', NULL, NULL, 'PseudoU_synth_ScPUS7', 1280),
(1281, 'cd14962', NULL, 'NHL_like_6', NULL, NULL, 'NHL_like_6', 1281),
(1282, 'cd02636', NULL, 'R3H_sperm-antigen', NULL, NULL, 'R3H_sperm-antigen', 1282),
(1283, 'cd09598', NULL, 'M4_like', NULL, NULL, 'M4_like', 1283),
(1284, 'cd17361', NULL, 'MFS_STP', NULL, NULL, 'MFS_STP', 1284),
(1285, 'cd10562', NULL, 'FDH_b_like', NULL, NULL, 'FDH_b_like', 1285),
(1286, 'cd09573', NULL, 'SAM_STIM1', NULL, NULL, 'SAM_STIM1', 1286),
(1287, 'cd15344', NULL, '7tmA_LPAR1_Edg2', NULL, NULL, '7tmA_LPAR1_Edg2', 1287),
(1288, 'cd08991', NULL, 'GH43_HoAraf43-like', NULL, NULL, 'GH43_HoAraf43-like', 1288),
(1289, 'cd04400', NULL, 'RhoGAP_fBEM3', NULL, NULL, 'RhoGAP_fBEM3', 1289),
(1290, 'cd18566', NULL, 'ABC_6TM_PrtD_LapB_HlyB_like', NULL, NULL, 'ABC_6TM_PrtD_LapB_HlyB_like', 1290),
(1291, 'cd08681', NULL, 'C2_fungal_Inn1p-like', NULL, NULL, 'C2_fungal_Inn1p-like', 1291),
(1292, 'cd09579', NULL, 'SAM_Samd7,11', NULL, NULL, 'SAM_Samd7,11', 1292),
(1293, 'cd19045', NULL, 'LGIC_ECD_GABAAR_G3', NULL, NULL, 'LGIC_ECD_GABAAR_G3', 1293),
(1294, 'cd12573', NULL, 'RRM2_MSI2', NULL, NULL, 'RRM2_MSI2', 1294),
(1295, 'cd02235', NULL, 'cupin_BLL4011-like', NULL, NULL, 'cupin_BLL4011-like', 1295),
(1296, 'cd04459', NULL, 'Rho_CSD', NULL, NULL, 'Rho_CSD', 1296),
(1297, 'cd07992', NULL, 'LPLAT_AAK14816-like', NULL, NULL, 'LPLAT_AAK14816-like', 1297),
(1298, 'cd01785', NULL, 'RA_PDZ-GEF1', NULL, NULL, 'RA_PDZ-GEF1', 1298),
(1299, 'cd18055', NULL, 'DEXHc_CHD3', NULL, NULL, 'DEXHc_CHD3', 1299),
(1300, 'cd12323', NULL, 'RRM2_MSI', NULL, NULL, 'RRM2_MSI', 1300),
(1301, 'cd19011', NULL, 'LGIC_ECD_5-HT3A', NULL, NULL, 'LGIC_ECD_5-HT3A', 1301),
(1302, 'cd19550', NULL, 'serpinA2_PIL', NULL, NULL, 'serpinA2_PIL', 1302),
(1303, 'cd03268', NULL, 'ABC_BcrA_bacitracin_resist', NULL, NULL, 'ABC_BcrA_bacitracin_resist', 1303);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(1304, 'cd07551', NULL, 'P-type_ATPase_HM_ZosA_PfeT-like', NULL, NULL, 'P-type_ATPase_HM_ZosA_PfeT-like', 1304),
(1305, 'cd07611', NULL, 'BAR_Amphiphysin_I_II', NULL, NULL, 'BAR_Amphiphysin_I_II', 1305),
(1306, 'cd14872', NULL, 'MYSc_Myo4', NULL, NULL, 'MYSc_Myo4', 1306),
(1307, 'cd14523', NULL, 'DSP_DUSP19', NULL, NULL, 'DSP_DUSP19', 1307),
(1308, 'cd11303', NULL, 'Dystroglycan_repeat', NULL, NULL, 'Dystroglycan_repeat', 1308),
(1309, 'cd16236', NULL, 'EFh_SPARC_SPARCL1', NULL, NULL, 'EFh_SPARC_SPARCL1', 1309),
(1310, 'cd16796', NULL, 'RING-H2_RNF13', NULL, NULL, 'RING-H2_RNF13', 1310),
(1311, 'cd17088', NULL, 'FERM_F1_FRMPD1_like', NULL, NULL, 'FERM_F1_FRMPD1_like', 1311),
(1312, 'cd14792', NULL, 'GH27', NULL, NULL, 'GH27', 1312),
(1313, 'cd17706', NULL, 'MCM', NULL, NULL, 'MCM', 1313),
(1314, 'cd06370', NULL, 'PBP1_SAP_GC-like', NULL, NULL, 'PBP1_SAP_GC-like', 1314),
(1315, 'cd04112', NULL, 'Rab26', NULL, NULL, 'Rab26', 1315),
(1316, 'cd06856', NULL, 'GT_GPT_archaea', NULL, NULL, 'GT_GPT_archaea', 1316),
(1317, 'cd10490', NULL, 'MH1_SMAD_1_5_9', NULL, NULL, 'MH1_SMAD_1_5_9', 1317),
(1318, 'cd03194', NULL, 'GST_C_3', NULL, NULL, 'GST_C_3', 1318),
(1319, 'cd12798', NULL, 'Alt_A1', NULL, NULL, 'Alt_A1', 1319),
(1320, 'cd14118', NULL, 'STKc_CAMKK', NULL, NULL, 'STKc_CAMKK', 1320),
(1321, 'cd12650', NULL, 'RRM1_Hu', NULL, NULL, 'RRM1_Hu', 1321),
(1322, 'cd12282', NULL, 'RRM2_TatSF1_like', NULL, NULL, 'RRM2_TatSF1_like', 1322),
(1323, 'cd11806', NULL, 'SH3_PRMT2', NULL, NULL, 'SH3_PRMT2', 1323),
(1324, 'cd07007', NULL, 'cupin_CapF-like_C', NULL, NULL, 'cupin_CapF-like_C', 1324),
(1325, 'cd12145', NULL, 'Rev1_C', NULL, NULL, 'Rev1_C', 1325),
(1326, 'cd21654', NULL, 'embe-merbe_CoV_ORF8b_protein-I-like', NULL, NULL, 'embe-merbe_CoV_ORF8b_protein-I-like', 1326),
(1327, 'cd00015', NULL, 'ALBUMIN', NULL, NULL, 'ALBUMIN', 1327),
(1328, 'cd14731', NULL, 'LodA_like_1', NULL, NULL, 'LodA_like_1', 1328),
(1329, 'cd13553', NULL, 'PBP2_NrtA_CpmA_like', NULL, NULL, 'PBP2_NrtA_CpmA_like', 1329),
(1330, 'cd17193', NULL, 'FERM_F1_PTPN3', NULL, NULL, 'FERM_F1_PTPN3', 1330),
(1331, 'cd00446', NULL, 'GrpE', NULL, NULL, 'GrpE', 1331),
(1332, 'cd15569', NULL, 'PHD_RAG2', NULL, NULL, 'PHD_RAG2', 1332),
(1333, 'cd17156', NULL, 'DCX1_DCDC5', NULL, NULL, 'DCX1_DCDC5', 1333),
(1334, 'cd05762', NULL, 'Ig8_hMLCK_like', NULL, NULL, 'Ig8_hMLCK_like', 1334),
(1335, 'cd07681', NULL, 'F-BAR_PACSIN3', NULL, NULL, 'F-BAR_PACSIN3', 1335),
(1336, 'cd16338', NULL, 'CpcT', NULL, NULL, 'CpcT', 1336),
(1337, 'cd09500', NULL, 'SAM_AIDA1AB-like_repeat2', NULL, NULL, 'SAM_AIDA1AB-like_repeat2', 1337),
(1338, 'cd08541', NULL, 'SAM_PNT-FLI-1', NULL, NULL, 'SAM_PNT-FLI-1', 1338),
(1339, 'cd19388', NULL, 'TGF_beta_GDF8', NULL, NULL, 'TGF_beta_GDF8', 1339),
(1340, 'cd10238', NULL, 'HSPA14-like_NBD', NULL, NULL, 'HSPA14-like_NBD', 1340),
(1341, 'cd16189', NULL, 'EFh_PEF_CAPN1_like', NULL, NULL, 'EFh_PEF_CAPN1_like', 1341),
(1342, 'cd07469', NULL, 'CRD_TK_ROR_related', NULL, NULL, 'CRD_TK_ROR_related', 1342),
(1343, 'cd11318', NULL, 'AmyAc_bac_fung_AmyA', NULL, NULL, 'AmyAc_bac_fung_AmyA', 1343),
(1344, 'cd12424', NULL, 'RRM3_hnRNPL_like', NULL, NULL, 'RRM3_hnRNPL_like', 1344),
(1345, 'cd05827', NULL, 'Sortase_C', NULL, NULL, 'Sortase_C', 1345),
(1346, 'cd06945', NULL, 'NR_LBD_Nurr1_like', NULL, NULL, 'NR_LBD_Nurr1_like', 1346),
(1347, 'cd01260', NULL, 'PH_CNK_mammalian-like', NULL, NULL, 'PH_CNK_mammalian-like', 1347),
(1348, 'cd01675', NULL, 'RNR_III', NULL, NULL, 'RNR_III', 1348),
(1349, 'cd05780', NULL, 'DNA_polB_Kod1_like_exo', NULL, NULL, 'DNA_polB_Kod1_like_exo', 1349),
(1350, 'cd14824', NULL, 'Longin', NULL, NULL, 'Longin', 1350),
(1351, 'cd01423', NULL, 'MGS_CPS_I_III', NULL, NULL, 'MGS_CPS_I_III', 1351),
(1352, 'cd13935', NULL, 'RNase_H_bacteria_like', NULL, NULL, 'RNase_H_bacteria_like', 1352),
(1353, 'cd17790', NULL, '7tmA_mAChR_M1', NULL, NULL, '7tmA_mAChR_M1', 1353),
(1354, 'cd05735', NULL, 'Ig_DSCAM', NULL, NULL, 'Ig_DSCAM', 1354),
(1355, 'cd04226', NULL, 'CuRO_1_FV_like', NULL, NULL, 'CuRO_1_FV_like', 1355),
(1356, 'cd12464', NULL, 'RRM_G3BP2', NULL, NULL, 'RRM_G3BP2', 1356);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(1357, 'cd19738', NULL, 'bHLH-PAS_SIM1', NULL, NULL, 'bHLH-PAS_SIM1', 1357),
(1358, 'cd03586', NULL, 'PolY_Pol_IV_kappa', NULL, NULL, 'PolY_Pol_IV_kappa', 1358),
(1359, 'cd14379', NULL, 'UBA1_Rad23_plant', NULL, NULL, 'UBA1_Rad23_plant', 1359),
(1360, 'cd00659', NULL, 'Topo_IB_C', NULL, NULL, 'Topo_IB_C', 1360),
(1361, 'cd14143', NULL, 'STKc_TGFbR1_ACVR1b_ACVR1c', NULL, NULL, 'STKc_TGFbR1_ACVR1b_ACVR1c', 1361),
(1362, 'cd02644', NULL, 'R3H_jag', NULL, NULL, 'R3H_jag', 1362),
(1363, 'cd09752', NULL, 'Cas5_I-C', NULL, NULL, 'Cas5_I-C', 1363),
(1364, 'cd09991', NULL, 'HDAC_classI', NULL, NULL, 'HDAC_classI', 1364),
(1365, 'cd14683', NULL, 'PH-EXOC1', NULL, NULL, 'PH-EXOC1', 1365),
(1366, 'cd00468', NULL, 'HIT_like', NULL, NULL, 'HIT_like', 1366),
(1367, 'cd18002', NULL, 'DEXQc_INO80', NULL, NULL, 'DEXQc_INO80', 1367),
(1368, 'cd07094', NULL, 'ALDH_F21_LactADH-like', NULL, NULL, 'ALDH_F21_LactADH-like', 1368),
(1369, 'cd07508', NULL, 'HAD_Pase_UmpH-like', NULL, NULL, 'HAD_Pase_UmpH-like', 1369),
(1370, 'cd19743', NULL, 'bHLH_TS_ASCL2_Mash2', NULL, NULL, 'bHLH_TS_ASCL2_Mash2', 1370),
(1371, 'cd05657', NULL, 'M42_glucanase_like', NULL, NULL, 'M42_glucanase_like', 1371),
(1372, 'cd16133', NULL, 'RA_RASSF9', NULL, NULL, 'RA_RASSF9', 1372),
(1373, 'cd15587', NULL, 'PHD_Yng1p_like', NULL, NULL, 'PHD_Yng1p_like', 1373),
(1374, 'cd05992', NULL, 'PB1', NULL, NULL, 'PB1', 1374),
(1375, 'cd10414', NULL, 'SH2_Grb14', NULL, NULL, 'SH2_Grb14', 1375),
(1376, 'cd01371', NULL, 'KISc_KIF3', NULL, NULL, 'KISc_KIF3', 1376),
(1377, 'cd07976', NULL, 'TFIIA_alpha_beta_like', NULL, NULL, 'TFIIA_alpha_beta_like', 1377),
(1378, 'cd13243', NULL, 'PH_PLEKHG1_G2_G3', NULL, NULL, 'PH_PLEKHG1_G2_G3', 1378),
(1379, 'cd04154', NULL, 'Arl2', NULL, NULL, 'Arl2', 1379),
(1380, 'cd17417', NULL, 'MFS_NPF5', NULL, NULL, 'MFS_NPF5', 1380),
(1381, 'cd01374', NULL, 'KISc_CENP_E', NULL, NULL, 'KISc_CENP_E', 1381),
(1382, 'cd04151', NULL, 'Arl1', NULL, NULL, 'Arl1', 1382),
(1383, 'cd14012', NULL, 'PK_eIF2AK_GCN2_rpt1', NULL, NULL, 'PK_eIF2AK_GCN2_rpt1', 1383),
(1384, 'cd11448', NULL, 'bHLH_AtFAMA_like', NULL, NULL, 'bHLH_AtFAMA_like', 1384),
(1385, 'cd08285', NULL, 'NADP_ADH', NULL, NULL, 'NADP_ADH', 1385),
(1386, 'cd03413', NULL, 'CbiK_C', NULL, NULL, 'CbiK_C', 1386),
(1387, 'cd14853', NULL, 'TRAPPC_longin-like', NULL, NULL, 'TRAPPC_longin-like', 1387),
(1388, 'cd15509', NULL, 'PHD1_KMT2C_like', NULL, NULL, 'PHD1_KMT2C_like', 1388),
(1389, 'cd19040', NULL, 'LGIC_ECD_GABAAR_B1', NULL, NULL, 'LGIC_ECD_GABAAR_B1', 1389),
(1390, 'cd21591', NULL, 'SARS-CoV-like_RdRp', NULL, NULL, 'SARS-CoV-like_RdRp', 1390),
(1391, 'cd16278', NULL, 'metallo-hydrolase-like_MBL-fold', NULL, NULL, 'metallo-hydrolase-like_MBL-fold', 1391),
(1392, 'cd06292', NULL, 'PBP1_AglR_RafR-like', NULL, NULL, 'PBP1_AglR_RafR-like', 1392),
(1393, 'cd15624', NULL, 'PHD_TIF1gamma', NULL, NULL, 'PHD_TIF1gamma', 1393),
(1394, 'cd13422', NULL, 'TNFRSF5_teleost', NULL, NULL, 'TNFRSF5_teleost', 1394),
(1395, 'cd01616', NULL, 'TGS', NULL, NULL, 'TGS', 1395),
(1396, 'cd11908', NULL, 'SH3_ITK', NULL, NULL, 'SH3_ITK', 1396),
(1397, 'cd18281', NULL, 'BTB_POZ_BTBD1_2', NULL, NULL, 'BTB_POZ_BTBD1_2', 1397),
(1398, 'cd12642', NULL, 'RRM_TRA2A', NULL, NULL, 'RRM_TRA2A', 1398),
(1399, 'cd17020', NULL, 'T3SC_IA_ShcM-like', NULL, NULL, 'T3SC_IA_ShcM-like', 1399),
(1400, 'cd05759', NULL, 'Ig2_KIRREL3-like', NULL, NULL, 'Ig2_KIRREL3-like', 1400),
(1401, 'cd16864', NULL, 'ARID_JARID', NULL, NULL, 'ARID_JARID', 1401),
(1402, 'cd08793', NULL, 'Death_IRAK4', NULL, NULL, 'Death_IRAK4', 1402),
(1403, 'cd12303', NULL, 'RRM_spSet1p_like', NULL, NULL, 'RRM_spSet1p_like', 1403),
(1404, 'cd05039', NULL, 'PTKc_Csk_like', NULL, NULL, 'PTKc_Csk_like', 1404),
(1405, 'cd15823', NULL, 'SPRY_PRY_TRIM6', NULL, NULL, 'SPRY_PRY_TRIM6', 1405),
(1406, 'cd05856', NULL, 'Ig2_FGFRL1-like', NULL, NULL, 'Ig2_FGFRL1-like', 1406),
(1407, 'cd09360', NULL, 'LIM_ALP_like', NULL, NULL, 'LIM_ALP_like', 1407),
(1408, 'cd07296', NULL, 'PX_PLD1', NULL, NULL, 'PX_PLD1', 1408),
(1409, 'cd14452', NULL, 'CuRO_1_FVIII_like', NULL, NULL, 'CuRO_1_FVIII_like', 1409);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(1410, 'cd09384', NULL, 'LIM1_LMO2', NULL, NULL, 'LIM1_LMO2', 1410),
(1411, 'cd09434', NULL, 'LIM4_FHL3', NULL, NULL, 'LIM4_FHL3', 1411),
(1412, 'cd04337', NULL, 'Rieske_RO_Alpha_Cao', NULL, NULL, 'Rieske_RO_Alpha_Cao', 1412),
(1413, 'cd07846', NULL, 'STKc_CDKL2_3', NULL, NULL, 'STKc_CDKL2_3', 1413),
(1414, 'cd11433', NULL, 'bHLH-PAS_HIF', NULL, NULL, 'bHLH-PAS_HIF', 1414),
(1415, 'cd19399', NULL, 'TGF_beta_GDF5', NULL, NULL, 'TGF_beta_GDF5', 1415),
(1416, 'cd16688', NULL, 'RING-H2_Vps11', NULL, NULL, 'RING-H2_Vps11', 1416),
(1417, 'cd09626', NULL, 'DOMON_glucodextranase_like', NULL, NULL, 'DOMON_glucodextranase_like', 1417),
(1418, 'cd06646', NULL, 'STKc_MAP4K5', NULL, NULL, 'STKc_MAP4K5', 1418),
(1419, 'cd01482', NULL, 'vWA_collagen_alphaI-XII-like', NULL, NULL, 'vWA_collagen_alphaI-XII-like', 1419),
(1420, 'cd11695', NULL, 'DHR2_DOCK_C', NULL, NULL, 'DHR2_DOCK_C', 1420),
(1421, 'cd18419', NULL, 'BTB_POZ_KCND3', NULL, NULL, 'BTB_POZ_KCND3', 1421),
(1422, 'cd13115', NULL, 'POLO_box_Plk4_2', NULL, NULL, 'POLO_box_Plk4_2', 1422),
(1423, 'cd18256', NULL, 'BTB_POZ_KLHL27_IPP', NULL, NULL, 'BTB_POZ_KLHL27_IPP', 1423),
(1424, 'cd00613', NULL, 'GDC-P', NULL, NULL, 'GDC-P', 1424),
(1425, 'cd17967', NULL, 'DEADc_DDX3_DDX4', NULL, NULL, 'DEADc_DDX3_DDX4', 1425),
(1426, 'cd20294', NULL, 'cupin_KduI_N', NULL, NULL, 'cupin_KduI_N', 1426),
(1427, 'cd05840', NULL, 'SPBC215_ISWI_like', NULL, NULL, 'SPBC215_ISWI_like', 1427),
(1428, 'cd12399', NULL, 'RRM_HP0827_like', NULL, NULL, 'RRM_HP0827_like', 1428),
(1429, 'cd07535', NULL, 'HAD_VSP', NULL, NULL, 'HAD_VSP', 1429),
(1430, 'cd19825', NULL, 'Bbox2_TRIM3_C-VII', NULL, NULL, 'Bbox2_TRIM3_C-VII', 1430),
(1431, 'cd15797', NULL, 'PMEI', NULL, NULL, 'PMEI', 1431),
(1432, 'cd11421', NULL, 'bHLH_TS_ATOH8', NULL, NULL, 'bHLH_TS_ATOH8', 1432),
(1433, 'cd14533', NULL, 'PTP-MTMR3-like', NULL, NULL, 'PTP-MTMR3-like', 1433),
(1434, 'cd20249', NULL, 'Hemotin', NULL, NULL, 'Hemotin', 1434),
(1435, 'cd08606', NULL, 'GDPD_YPL110cp_fungi', NULL, NULL, 'GDPD_YPL110cp_fungi', 1435),
(1436, 'cd16642', NULL, 'mRING-HC-C3HC3D_TRAF5', NULL, NULL, 'mRING-HC-C3HC3D_TRAF5', 1436),
(1437, 'cd00060', NULL, 'FHA', NULL, NULL, 'FHA', 1437),
(1438, 'cd12397', NULL, 'RRM2_Nop13p_fungi', NULL, NULL, 'RRM2_Nop13p_fungi', 1438),
(1439, 'cd03575', NULL, 'NTR_WFIKKN', NULL, NULL, 'NTR_WFIKKN', 1439),
(1440, 'cd17220', NULL, 'RA_RASSF5', NULL, NULL, 'RA_RASSF5', 1440),
(1441, 'cd08038', NULL, 'LARP_2', NULL, NULL, 'LARP_2', 1441),
(1442, 'cd04778', NULL, 'HTH_MerR-like_sg2', NULL, NULL, 'HTH_MerR-like_sg2', 1442),
(1443, 'cd05726', NULL, 'Ig4_Robo', NULL, NULL, 'Ig4_Robo', 1443),
(1444, 'cd04458', NULL, 'CSP_CDS', NULL, NULL, 'CSP_CDS', 1444),
(1445, 'cd12015', NULL, 'SH3_Tks_1', NULL, NULL, 'SH3_Tks_1', 1445),
(1446, 'cd16267', NULL, 'HBS1-like_II', NULL, NULL, 'HBS1-like_II', 1446),
(1447, 'cd01892', NULL, 'Miro2', NULL, NULL, 'Miro2', 1447),
(1448, 'cd19837', NULL, 'Bbox1_MID2_C-I', NULL, NULL, 'Bbox1_MID2_C-I', 1448),
(1449, 'cd12428', NULL, 'RRM_PARN', NULL, NULL, 'RRM_PARN', 1449),
(1450, 'cd07749', NULL, 'NT_Pol-beta-like_1', NULL, NULL, 'NT_Pol-beta-like_1', 1450),
(1451, 'cd16589', NULL, 'RING-HC_TRIM71_C-VII', NULL, NULL, 'RING-HC_TRIM71_C-VII', 1451),
(1452, 'cd14401', NULL, 'UBA_HERC1', NULL, NULL, 'UBA_HERC1', 1452),
(1453, 'cd09708', NULL, 'Csf4_U', NULL, NULL, 'Csf4_U', 1453),
(1454, 'cd05958', NULL, 'ABCL', NULL, NULL, 'ABCL', 1454),
(1455, 'cd09978', NULL, 'LOTUS_2_Limkain_b1', NULL, NULL, 'LOTUS_2_Limkain_b1', 1455),
(1456, 'cd02843', NULL, 'PAZ_dicer_like', NULL, NULL, 'PAZ_dicer_like', 1456),
(1457, 'cd00119', NULL, 'LYZ', NULL, NULL, 'LYZ', 1457),
(1458, 'cd14939', NULL, '7tmD_STE2', NULL, NULL, '7tmD_STE2', 1458),
(1459, 'cd08181', NULL, 'PPD-like', NULL, NULL, 'PPD-like', 1459),
(1460, 'cd14335', NULL, 'UBA_SnRK1_plant', NULL, NULL, 'UBA_SnRK1_plant', 1460),
(1461, 'cd14590', NULL, 'PTP-MTMR2', NULL, NULL, 'PTP-MTMR2', 1461),
(1462, 'cd09525', NULL, 'SAM_GAREM', NULL, NULL, 'SAM_GAREM', 1462),
(1463, 'cd01227', NULL, 'PH_Dbs', NULL, NULL, 'PH_Dbs', 1463),
(1464, 'cd02932', NULL, 'OYE_YqiM_FMN', NULL, NULL, 'OYE_YqiM_FMN', 1464);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(1465, 'cd01802', NULL, 'Ubl_ZFAND4', NULL, NULL, 'Ubl_ZFAND4', 1465),
(1466, 'cd09506', NULL, 'SAM_Shank1,2,3', NULL, NULL, 'SAM_Shank1,2,3', 1466),
(1467, 'cd18300', NULL, 'BTB2_POZ_RhoBTB', NULL, NULL, 'BTB2_POZ_RhoBTB', 1467),
(1468, 'cd18107', NULL, 'SpoU-like_AviRb', NULL, NULL, 'SpoU-like_AviRb', 1468),
(1469, 'cd14393', NULL, 'UBA_c-Cbl', NULL, NULL, 'UBA_c-Cbl', 1469),
(1470, 'cd13971', NULL, 'ADCK2-like', NULL, NULL, 'ADCK2-like', 1470),
(1471, 'cd15514', NULL, 'PHD6_KMT2C_like', NULL, NULL, 'PHD6_KMT2C_like', 1471),
(1472, 'cd06562', NULL, 'GH20_HexA_HexB-like', NULL, NULL, 'GH20_HexA_HexB-like', 1472),
(1473, 'cd07532', NULL, 'HAD_PNPase_UmpH-like', NULL, NULL, 'HAD_PNPase_UmpH-like', 1473),
(1474, 'cd04822', NULL, 'PA_M28_1_3', NULL, NULL, 'PA_M28_1_3', 1474),
(1475, 'cd16473', NULL, 'RING-H2_RNF103', NULL, NULL, 'RING-H2_RNF103', 1475),
(1476, 'cd17153', NULL, 'DCX2_DCDC2B', NULL, NULL, 'DCX2_DCDC2B', 1476),
(1477, 'cd17465', NULL, 'MFS_MCT8', NULL, NULL, 'MFS_MCT8', 1477),
(1478, 'cd09537', NULL, 'SAM_CP2-like', NULL, NULL, 'SAM_CP2-like', 1478),
(1479, 'cd06940', NULL, 'NR_LBD_REV_ERB', NULL, NULL, 'NR_LBD_REV_ERB', 1479),
(1480, 'cd03089', NULL, 'PMM_PGM', NULL, NULL, 'PMM_PGM', 1480),
(1481, 'cd07613', NULL, 'BAR_Endophilin_A1', NULL, NULL, 'BAR_Endophilin_A1', 1481),
(1482, 'cd19985', NULL, 'PBP1_ABC_HAAT-like', NULL, NULL, 'PBP1_ABC_HAAT-like', 1482),
(1483, 'cd06820', NULL, 'PLPDE_III_LS_D-TA_like', NULL, NULL, 'PLPDE_III_LS_D-TA_like', 1483),
(1484, 'cd05723', NULL, 'Ig4_Neogenin', NULL, NULL, 'Ig4_Neogenin', 1484),
(1485, 'cd14059', NULL, 'STKc_MAP3K12_13', NULL, NULL, 'STKc_MAP3K12_13', 1485),
(1486, 'cd18516', NULL, 'BACK_KLHL40_KBTBD5', NULL, NULL, 'BACK_KLHL40_KBTBD5', 1486),
(1487, 'cd00826', NULL, 'nondecarbox_cond_enzymes', NULL, NULL, 'nondecarbox_cond_enzymes', 1487),
(1488, 'cd03360', NULL, 'LbH_AT_putative', NULL, NULL, 'LbH_AT_putative', 1488),
(1489, 'cd15135', NULL, '7tmA_GPR39', NULL, NULL, '7tmA_GPR39', 1489),
(1490, 'cd03895', NULL, 'M20_ArgE_DapE-like', NULL, NULL, 'M20_ArgE_DapE-like', 1490),
(1491, 'cd15215', NULL, '7tmA_GPR101', NULL, NULL, '7tmA_GPR101', 1491),
(1492, 'cd06108', NULL, 'Ec2MCS_like', NULL, NULL, 'Ec2MCS_like', 1492),
(1493, 'cd08232', NULL, 'idonate-5-DH', NULL, NULL, 'idonate-5-DH', 1493),
(1494, 'cd10146', NULL, 'LabA_like_C', NULL, NULL, 'LabA_like_C', 1494),
(1495, 'cd18432', NULL, 'BRCT_PAXIP1_rpt6_like', NULL, NULL, 'BRCT_PAXIP1_rpt6_like', 1495),
(1496, 'cd03033', NULL, 'ArsC_15kD', NULL, NULL, 'ArsC_15kD', 1496),
(1497, 'cd17673', NULL, 'MDM4', NULL, NULL, 'MDM4', 1497),
(1498, 'cd13901', NULL, 'CuRO_3_MaLCC_like', NULL, NULL, 'CuRO_3_MaLCC_like', 1498),
(1499, 'cd12416', NULL, 'RRM4_RBM28_like', NULL, NULL, 'RRM4_RBM28_like', 1499),
(1500, 'cd02394', NULL, 'vigilin_like_KH', NULL, NULL, 'vigilin_like_KH', 1500),
(1501, 'cd01351', NULL, 'Aconitase', NULL, NULL, 'Aconitase', 1501),
(1502, 'cd09604', NULL, 'M1_APN_like', NULL, NULL, 'M1_APN_like', 1502),
(1503, 'cd03705', NULL, 'EF1_alpha_III', NULL, NULL, 'EF1_alpha_III', 1503),
(1504, 'cd06622', NULL, 'PKc_PBS2_like', NULL, NULL, 'PKc_PBS2_like', 1504),
(1505, 'cd19353', NULL, 'Wnt_Wnt9a', NULL, NULL, 'Wnt_Wnt9a', 1505),
(1506, 'cd19818', NULL, 'Bbox1_ZBBX', NULL, NULL, 'Bbox1_ZBBX', 1506),
(1507, 'cd08956', NULL, 'KR_3_FAS_SDR_x', NULL, NULL, 'KR_3_FAS_SDR_x', 1507),
(1508, 'cd17507', NULL, 'GT28_Beta-DGS-like', NULL, NULL, 'GT28_Beta-DGS-like', 1508),
(1509, 'cd05562', NULL, 'Peptidases_S53_like', NULL, NULL, 'Peptidases_S53_like', 1509),
(1510, 'cd14755', NULL, 'GS_BA2291-HK-like', NULL, NULL, 'GS_BA2291-HK-like', 1510),
(1511, 'cd07522', NULL, 'HAD_cN-II', NULL, NULL, 'HAD_cN-II', 1511),
(1512, 'cd02130', NULL, 'PA_ScAPY_like', NULL, NULL, 'PA_ScAPY_like', 1512),
(1513, 'cd15680', NULL, 'PHD_JADE2', NULL, NULL, 'PHD_JADE2', 1513),
(1514, 'cd14805', NULL, 'Translin-like', NULL, NULL, 'Translin-like', 1514),
(1515, 'cd17406', NULL, 'MFS_unc93A_like', NULL, NULL, 'MFS_unc93A_like', 1515),
(1516, 'cd05486', NULL, 'Cathespin_E', NULL, NULL, 'Cathespin_E', 1516),
(1517, 'cd13148', NULL, 'MATE_like_3', NULL, NULL, 'MATE_like_3', 1517);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(1518, 'cd05297', NULL, 'GH4_alpha_glucosidase_galactosidase', NULL, NULL, 'GH4_alpha_glucosidase_galactosidase', 1518),
(1519, 'cd14170', NULL, 'STKc_MAPKAPK2', NULL, NULL, 'STKc_MAPKAPK2', 1519),
(1520, 'cd03670', NULL, 'ADPRase_NUDT9', NULL, NULL, 'ADPRase_NUDT9', 1520),
(1521, 'cd14316', NULL, 'UBA2_UBAP1_like', NULL, NULL, 'UBA2_UBAP1_like', 1521),
(1522, 'cd00303', NULL, 'retropepsin_like', NULL, NULL, 'retropepsin_like', 1522),
(1523, 'cd11673', NULL, 'hemoglobin_linker_C', NULL, NULL, 'hemoglobin_linker_C', 1523),
(1524, 'cd15226', NULL, '7tmA_OR4-like', NULL, NULL, '7tmA_OR4-like', 1524),
(1525, 'cd08966', NULL, 'EcFpg-like_N', NULL, NULL, 'EcFpg-like_N', 1525),
(1526, 'cd19834', NULL, 'Bbox2_BSPRY', NULL, NULL, 'Bbox2_BSPRY', 1526),
(1527, 'cd11514', NULL, 'SLC6sbd_DAT1', NULL, NULL, 'SLC6sbd_DAT1', 1527),
(1528, 'cd13975', NULL, 'PKc_Dusty', NULL, NULL, 'PKc_Dusty', 1528),
(1529, 'cd06172', NULL, 'MFS_LacY', NULL, NULL, 'MFS_LacY', 1529),
(1530, 'cd06319', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, 'PBP1_ABC_sugar_binding-like', 1530),
(1531, 'cd08521', NULL, 'C2A_SLP', NULL, NULL, 'C2A_SLP', 1531),
(1532, 'cd08880', NULL, 'RHO_alpha_C_ahdA1c-like', NULL, NULL, 'RHO_alpha_C_ahdA1c-like', 1532),
(1533, 'cd18704', NULL, 'PIN_VapC-like', NULL, NULL, 'PIN_VapC-like', 1533),
(1534, 'cd13338', NULL, 'FERM-like_C_SNX27', NULL, NULL, 'FERM-like_C_SNX27', 1534),
(1535, 'cd00024', NULL, 'CD_CSD', NULL, NULL, 'CD_CSD', 1535),
(1536, 'cd09623', NULL, 'DOMON_EBDH', NULL, NULL, 'DOMON_EBDH', 1536),
(1537, 'cd04450', NULL, 'DEP_RGS7-like', NULL, NULL, 'DEP_RGS7-like', 1537),
(1538, 'cd14314', NULL, 'UBA_II_E2_pyUCE_like', NULL, NULL, 'UBA_II_E2_pyUCE_like', 1538),
(1539, 'cd17171', NULL, 'FERM_F0_TLN1', NULL, NULL, 'FERM_F0_TLN1', 1539),
(1540, 'cd00094', NULL, 'HX', NULL, NULL, 'HX', 1540),
(1541, 'cd17774', NULL, 'CBS_two-component_sensor_histidine_kinase_repeat2', NULL, NULL, 'CBS_two-component_sensor_histidine_kinase_repeat2', 1541),
(1542, 'cd13319', NULL, 'PH_RARhoGAP', NULL, NULL, 'PH_RARhoGAP', 1542),
(1543, 'cd01428', NULL, 'ADK', NULL, NULL, 'ADK', 1543),
(1544, 'cd14524', NULL, 'PTPMT1', NULL, NULL, 'PTPMT1', 1544),
(1545, 'cd09107', NULL, 'PLDc_vPLD3_4_5_like_2', NULL, NULL, 'PLDc_vPLD3_4_5_like_2', 1545),
(1546, 'cd09982', NULL, 'LOTUS_6_Limkain_b1', NULL, NULL, 'LOTUS_6_Limkain_b1', 1546),
(1547, 'cd11741', NULL, 'TIN2_TBM', NULL, NULL, 'TIN2_TBM', 1547),
(1548, 'cd15988', NULL, '7tmB2_BAI2', NULL, NULL, '7tmB2_BAI2', 1548),
(1549, 'cd14396', NULL, 'UBA_XtBIRC7_like', NULL, NULL, 'UBA_XtBIRC7_like', 1549),
(1550, 'cd15732', NULL, 'FYVE_MTMR3', NULL, NULL, 'FYVE_MTMR3', 1550),
(1551, 'cd09652', NULL, 'Cas6-I-III', NULL, NULL, 'Cas6-I-III', 1551),
(1552, 'cd02877', NULL, 'GH18_hevamine_XipI_class_III', NULL, NULL, 'GH18_hevamine_XipI_class_III', 1552),
(1553, 'cd17581', NULL, 'REC_typeA_ARR', NULL, NULL, 'REC_typeA_ARR', 1553),
(1554, 'cd01988', NULL, 'Na_H_Antiporter_C', NULL, NULL, 'Na_H_Antiporter_C', 1554),
(1555, 'cd11951', NULL, 'SH3_GRAP_C', NULL, NULL, 'SH3_GRAP_C', 1555),
(1556, 'cd01614', NULL, 'EutN_CcmL', NULL, NULL, 'EutN_CcmL', 1556),
(1557, 'cd14029', NULL, 'STKc_BubR1_vert', NULL, NULL, 'STKc_BubR1_vert', 1557),
(1558, 'cd02048', NULL, 'serpinI1_NSP', NULL, NULL, 'serpinI1_NSP', 1558),
(1559, 'cd00340', NULL, 'GSH_Peroxidase', NULL, NULL, 'GSH_Peroxidase', 1559),
(1560, 'cd18362', NULL, 'BTB_POZ_KCTD2-like', NULL, NULL, 'BTB_POZ_KCTD2-like', 1560),
(1561, 'cd02667', NULL, 'Peptidase_C19K', NULL, NULL, 'Peptidase_C19K', 1561),
(1562, 'cd17490', NULL, 'MFS_YxlH_like', NULL, NULL, 'MFS_YxlH_like', 1562),
(1563, 'cd19088', NULL, 'AKR_AKR13B1', NULL, NULL, 'AKR_AKR13B1', 1563),
(1564, 'cd11247', NULL, 'Sema_plexin_D1', NULL, NULL, 'Sema_plexin_D1', 1564),
(1565, 'cd12824', NULL, 'ZntB-like', NULL, NULL, 'ZntB-like', 1565),
(1566, 'cd05755', NULL, 'Ig2_ICAM-1_like', NULL, NULL, 'Ig2_ICAM-1_like', 1566),
(1567, 'cd19064', NULL, 'LGIC_TM_nAChR', NULL, NULL, 'LGIC_TM_nAChR', 1567),
(1568, 'cd11764', NULL, 'SH3_Eps8', NULL, NULL, 'SH3_Eps8', 1568),
(1569, 'cd12812', NULL, 'BPSL1549', NULL, NULL, 'BPSL1549', 1569);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(1570, 'cd06376', NULL, 'PBP1_mGluR_groupIII', NULL, NULL, 'PBP1_mGluR_groupIII', 1570),
(1571, 'cd05758', NULL, 'Ig5_KIRREL3-like', NULL, NULL, 'Ig5_KIRREL3-like', 1571),
(1572, 'cd18250', NULL, 'BTB_POZ_KLHL21', NULL, NULL, 'BTB_POZ_KLHL21', 1572),
(1573, 'cd00602', NULL, 'IPT_TF', NULL, NULL, 'IPT_TF', 1573),
(1574, 'cd03043', NULL, 'GST_N_1', NULL, NULL, 'GST_N_1', 1574),
(1575, 'cd07574', NULL, 'nitrilase_Rim1_like', NULL, NULL, 'nitrilase_Rim1_like', 1575),
(1576, 'cd06341', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, 'PBP1_ABC_ligand_binding-like', 1576),
(1577, 'cd10020', NULL, '14-3-3_epsilon', NULL, NULL, '14-3-3_epsilon', 1577),
(1578, 'cd03743', NULL, 'SOCS_SSB4', NULL, NULL, 'SOCS_SSB4', 1578),
(1579, 'cd05589', NULL, 'STKc_PKN', NULL, NULL, 'STKc_PKN', 1579),
(1580, 'cd11586', NULL, 'VbhA_like', NULL, NULL, 'VbhA_like', 1580),
(1581, 'cd03002', NULL, 'PDI_a_MPD1_like', NULL, NULL, 'PDI_a_MPD1_like', 1581),
(1582, 'cd12148', NULL, 'fungal_TF_MHR', NULL, NULL, 'fungal_TF_MHR', 1582),
(1583, 'cd08354', NULL, 'VOC_like', NULL, NULL, 'VOC_like', 1583),
(1584, 'cd17528', NULL, 'HAMP_III', NULL, NULL, 'HAMP_III', 1584),
(1585, 'cd14704', NULL, 'bZIP_HY5-like', NULL, NULL, 'bZIP_HY5-like', 1585),
(1586, 'cd17971', NULL, 'DEXHc_DHX8', NULL, NULL, 'DEXHc_DHX8', 1586),
(1587, 'cd09663', NULL, 'Csm4_III-A', NULL, NULL, 'Csm4_III-A', 1587),
(1588, 'cd18301', NULL, 'BTB1_POZ_IBtk', NULL, NULL, 'BTB1_POZ_IBtk', 1588),
(1589, 'cd01530', NULL, 'Cdc25', NULL, NULL, 'Cdc25', 1589),
(1590, 'cd02002', NULL, 'TPP_BFDC', NULL, NULL, 'TPP_BFDC', 1590),
(1591, 'cd13588', NULL, 'PBP2_polyamine_1', NULL, NULL, 'PBP2_polyamine_1', 1591),
(1592, 'cd06628', NULL, 'STKc_Byr2_like', NULL, NULL, 'STKc_Byr2_like', 1592),
(1593, 'cd07354', NULL, 'HN_L-delphilin-R1_like', NULL, NULL, 'HN_L-delphilin-R1_like', 1593),
(1594, 'cd19017', NULL, 'LGIC_ECD_nAChR_A4', NULL, NULL, 'LGIC_ECD_nAChR_A4', 1594),
(1595, 'cd19869', NULL, 'DSRM_DCL_plant', NULL, NULL, 'DSRM_DCL_plant', 1595),
(1596, 'cd10572', NULL, 'PH_RhoGEF3_XPLN', NULL, NULL, 'PH_RhoGEF3_XPLN', 1596),
(1597, 'cd02677', NULL, 'MIT_SNX15', NULL, NULL, 'MIT_SNX15', 1597),
(1598, 'cd10302', NULL, 'GST_C_GDAP1L1', NULL, NULL, 'GST_C_GDAP1L1', 1598),
(1599, 'cd18714', NULL, 'PIN_VapC-like', NULL, NULL, 'PIN_VapC-like', 1599),
(1600, 'cd02017', NULL, 'TPP_E1_EcPDC_like', NULL, NULL, 'TPP_E1_EcPDC_like', 1600),
(1601, 'cd07373', NULL, '2A5CPDO_A', NULL, NULL, '2A5CPDO_A', 1601),
(1602, 'cd17030', NULL, 'T3SC_IA_SycH-like', NULL, NULL, 'T3SC_IA_SycH-like', 1602),
(1603, 'cd19402', NULL, 'TGF_beta_GDF9B', NULL, NULL, 'TGF_beta_GDF9B', 1603),
(1604, 'cd00408', NULL, 'DHDPS-like', NULL, NULL, 'DHDPS-like', 1604),
(1605, 'cd00519', NULL, 'Lipase_3', NULL, NULL, 'Lipase_3', 1605),
(1606, 'cd10920', NULL, 'CE4_WbmS', NULL, NULL, 'CE4_WbmS', 1606),
(1607, 'cd16410', NULL, 'ParB_N_like', NULL, NULL, 'ParB_N_like', 1607),
(1608, 'cd09208', NULL, 'Lumazine_synthase-II', NULL, NULL, 'Lumazine_synthase-II', 1608),
(1609, 'cd11737', NULL, 'HSPA4_NBD', NULL, NULL, 'HSPA4_NBD', 1609),
(1610, 'cd13589', NULL, 'PBP2_polyamine_RpCGA009', NULL, NULL, 'PBP2_polyamine_RpCGA009', 1610),
(1611, 'cd14596', NULL, 'PTPc-N20', NULL, NULL, 'PTPc-N20', 1611),
(1612, 'cd11452', NULL, 'bHLH_AtNAI1_like', NULL, NULL, 'bHLH_AtNAI1_like', 1612),
(1613, 'cd12066', NULL, 'SH3_GRAF3', NULL, NULL, 'SH3_GRAF3', 1613),
(1614, 'cd12727', NULL, 'RRM_like_Smg4_UPF3A', NULL, NULL, 'RRM_like_Smg4_UPF3A', 1614),
(1615, 'cd17650', NULL, 'A_NRPS_PpsD_like', NULL, NULL, 'A_NRPS_PpsD_like', 1615),
(1616, 'cd07817', NULL, 'SRPBCC_8', NULL, NULL, 'SRPBCC_8', 1616),
(1617, 'cd21598', NULL, 'ORF7b_SARS_bat-CoV-like', NULL, NULL, 'ORF7b_SARS_bat-CoV-like', 1617),
(1618, 'cd09740', NULL, 'Csx3_III-U', NULL, NULL, 'Csx3_III-U', 1618),
(1619, 'cd03019', NULL, 'DsbA_DsbA', NULL, NULL, 'DsbA_DsbA', 1619),
(1620, 'cd01117', NULL, 'YbiR_permease', NULL, NULL, 'YbiR_permease', 1620),
(1621, 'cd01160', NULL, 'LCAD', NULL, NULL, 'LCAD', 1621),
(1622, 'cd06300', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, 'PBP1_ABC_sugar_binding-like', 1622);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(1623, 'cd16974', NULL, 'Alpha_kinase_ALPK2', NULL, NULL, 'Alpha_kinase_ALPK2', 1623),
(1624, 'cd01898', NULL, 'Obg', NULL, NULL, 'Obg', 1624),
(1625, 'cd09619', NULL, 'CBM9_like_4', NULL, NULL, 'CBM9_like_4', 1625),
(1626, 'cd07509', NULL, 'HAD_PPase', NULL, NULL, 'HAD_PPase', 1626),
(1627, 'cd01081', NULL, 'Aldose_epim', NULL, NULL, 'Aldose_epim', 1627),
(1628, 'cd18825', NULL, 'GH43_CtGH43-like', NULL, NULL, 'GH43_CtGH43-like', 1628),
(1629, 'cd05669', NULL, 'M20_Acy1_YxeP-like', NULL, NULL, 'M20_Acy1_YxeP-like', 1629),
(1630, 'cd18121', NULL, 'ATP-synt_Fo_c', NULL, NULL, 'ATP-synt_Fo_c', 1630),
(1631, 'cd00576', NULL, 'RNR_PFL', NULL, NULL, 'RNR_PFL', 1631),
(1632, 'cd19750', NULL, 'bHLH-O_DEC2', NULL, NULL, 'bHLH-O_DEC2', 1632),
(1633, 'cd03481', NULL, 'TopoIIA_Trans_ScTopoIIA', NULL, NULL, 'TopoIIA_Trans_ScTopoIIA', 1633),
(1634, 'cd15836', NULL, 'TNFRSF11A_teleost', NULL, NULL, 'TNFRSF11A_teleost', 1634),
(1635, 'cd12828', NULL, 'TmCorA-like_1', NULL, NULL, 'TmCorA-like_1', 1635),
(1636, 'cd15086', NULL, '7tmA_tmt_opsin', NULL, NULL, '7tmA_tmt_opsin', 1636),
(1637, 'cd17945', NULL, 'DEADc_DDX23', NULL, NULL, 'DEADc_DDX23', 1637),
(1638, 'cd07238', NULL, 'VOC_like', NULL, NULL, 'VOC_like', 1638),
(1639, 'cd19604', NULL, 'serpin_protozoa', NULL, NULL, 'serpin_protozoa', 1639),
(1640, 'cd00606', NULL, 'fungal_RNase', NULL, NULL, 'fungal_RNase', 1640),
(1641, 'cd20243', NULL, 'NoBody', NULL, NULL, 'NoBody', 1641),
(1642, 'cd15759', NULL, 'FYVE_RUFY2', NULL, NULL, 'FYVE_RUFY2', 1642),
(1643, 'cd16530', NULL, 'RING-HC_RAG1', NULL, NULL, 'RING-HC_RAG1', 1643),
(1644, 'cd12791', NULL, 'RasGAP_plexin_B3', NULL, NULL, 'RasGAP_plexin_B3', 1644),
(1645, 'cd20292', NULL, 'cupin_QdtA-like', NULL, NULL, 'cupin_QdtA-like', 1645),
(1646, 'cd18480', NULL, 'BACK_KBTBD3', NULL, NULL, 'BACK_KBTBD3', 1646),
(1647, 'cd01017', NULL, 'AdcA', NULL, NULL, 'AdcA', 1647),
(1648, 'cd09165', NULL, 'PLDc_PaPPK1_C1_like', NULL, NULL, 'PLDc_PaPPK1_C1_like', 1648),
(1649, 'cd06896', NULL, 'PX_PI3K_C2_gamma', NULL, NULL, 'PX_PI3K_C2_gamma', 1649),
(1650, 'cd16011', NULL, 'iPGM_like', NULL, NULL, 'iPGM_like', 1650),
(1651, 'cd03153', NULL, 'PHEMX_like_LEL', NULL, NULL, 'PHEMX_like_LEL', 1651),
(1652, 'cd10534', NULL, 'PR-SET_PRDM-like', NULL, NULL, 'PR-SET_PRDM-like', 1652),
(1653, 'cd07046', NULL, 'BMC_PduU-EutS', NULL, NULL, 'BMC_PduU-EutS', 1653),
(1654, 'cd17763', NULL, 'UP_hUPP-like', NULL, NULL, 'UP_hUPP-like', 1654),
(1655, 'cd00833', NULL, 'PKS', NULL, NULL, 'PKS', 1655),
(1656, 'cd06645', NULL, 'STKc_MAP4K3', NULL, NULL, 'STKc_MAP4K3', 1656),
(1657, 'cd09804', NULL, 'Dcp1', NULL, NULL, 'Dcp1', 1657),
(1658, 'cd19170', NULL, 'SET_KMT2A_2B', NULL, NULL, 'SET_KMT2A_2B', 1658),
(1659, 'cd07723', NULL, 'hydroxyacylglutathione_hydrolase_MBL-fold', NULL, NULL, 'hydroxyacylglutathione_hydrolase_MBL-fold', 1659),
(1660, 'cd16880', NULL, 'ARID_ARID3C', NULL, NULL, 'ARID_ARID3C', 1660),
(1661, 'cd07667', NULL, 'BAR_SNX30', NULL, NULL, 'BAR_SNX30', 1661),
(1662, 'cd08814', NULL, 'DED_Caspase_10_r2', NULL, NULL, 'DED_Caspase_10_r2', 1662),
(1663, 'cd09080', NULL, 'TDP2', NULL, NULL, 'TDP2', 1663),
(1664, 'cd13879', NULL, 'CuRO_2_McoP_like', NULL, NULL, 'CuRO_2_McoP_like', 1664),
(1665, 'cd09757', NULL, 'Cas8c_I-C', NULL, NULL, 'Cas8c_I-C', 1665),
(1666, 'cd06107', NULL, 'EcCS_AthCS-per_like', NULL, NULL, 'EcCS_AthCS-per_like', 1666),
(1667, 'cd11414', NULL, 'bHLH_TS_HEN', NULL, NULL, 'bHLH_TS_HEN', 1667),
(1668, 'cd19863', NULL, 'DSRM_PRKRA-like_rpt2', NULL, NULL, 'DSRM_PRKRA-like_rpt2', 1668),
(1669, 'cd01662', NULL, 'Ubiquinol_Oxidase_I', NULL, NULL, 'Ubiquinol_Oxidase_I', 1669),
(1670, 'cd05851', NULL, 'Ig3_Contactin-1', NULL, NULL, 'Ig3_Contactin-1', 1670),
(1671, 'cd08061', NULL, 'MPN_NPL4', NULL, NULL, 'MPN_NPL4', 1671),
(1672, 'cd16833', NULL, 'YfiH', NULL, NULL, 'YfiH', 1672),
(1673, 'cd07358', NULL, 'HN_PDZD7_like', NULL, NULL, 'HN_PDZD7_like', 1673),
(1674, 'cd15465', NULL, 'bS6_mito', NULL, NULL, 'bS6_mito', 1674),
(1675, 'cd01357', NULL, 'Aspartase', NULL, NULL, 'Aspartase', 1675),
(1676, 'cd06435', NULL, 'CESA_NdvC_like', NULL, NULL, 'CESA_NdvC_like', 1676);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(1677, 'cd10423', NULL, 'RNase_RNase-L', NULL, NULL, 'RNase_RNase-L', 1677),
(1678, 'cd19826', NULL, 'Bbox2_TRIM9_C-I', NULL, NULL, 'Bbox2_TRIM9_C-I', 1678),
(1679, 'cd09605', NULL, 'M3A', NULL, NULL, 'M3A', 1679),
(1680, 'cd09545', NULL, 'SAM_EPH-A4', NULL, NULL, 'SAM_EPH-A4', 1680),
(1681, 'cd15745', NULL, 'FYVE_RUFY4', NULL, NULL, 'FYVE_RUFY4', 1681),
(1682, 'cd19150', NULL, 'AKR_AKR14A1', NULL, NULL, 'AKR_AKR14A1', 1682),
(1683, 'cd17771', NULL, 'CBS_pair_CAP-ED_NT_Pol-beta-like_DUF294_assoc', NULL, NULL, 'CBS_pair_CAP-ED_NT_Pol-beta-like_DUF294_assoc', 1683),
(1684, 'cd19532', NULL, 'C_PKS-NRPS', NULL, NULL, 'C_PKS-NRPS', 1684),
(1685, 'cd05271', NULL, 'NDUFA9_like_SDR_a', NULL, NULL, 'NDUFA9_like_SDR_a', 1685),
(1686, 'cd17009', NULL, 'VHS_GGA1', NULL, NULL, 'VHS_GGA1', 1686),
(1687, 'cd05305', NULL, 'L-AlaDH', NULL, NULL, 'L-AlaDH', 1687),
(1688, 'cd19135', NULL, 'AKR_CeZK1290-like', NULL, NULL, 'AKR_CeZK1290-like', 1688),
(1689, 'cd15000', NULL, '7tmA_BNGR-A34-like', NULL, NULL, '7tmA_BNGR-A34-like', 1689),
(1690, 'cd10441', NULL, 'GIY-YIG_COG1833', NULL, NULL, 'GIY-YIG_COG1833', 1690),
(1691, 'cd01897', NULL, 'NOG', NULL, NULL, 'NOG', 1691),
(1692, 'cd05616', NULL, 'STKc_cPKC_beta', NULL, NULL, 'STKc_cPKC_beta', 1692),
(1693, 'cd06328', NULL, 'PBP1_SBP-like', NULL, NULL, 'PBP1_SBP-like', 1693),
(1694, 'cd08675', NULL, 'C2B_RasGAP', NULL, NULL, 'C2B_RasGAP', 1694),
(1695, 'cd15016', NULL, '7tm_TAS2R1', NULL, NULL, '7tm_TAS2R1', 1695),
(1696, 'cd07808', NULL, 'FGGY_D-XK_EcXK-like', NULL, NULL, 'FGGY_D-XK_EcXK-like', 1696),
(1697, 'cd08835', NULL, 'ArfGap_ACAP', NULL, NULL, 'ArfGap_ACAP', 1697),
(1698, 'cd03752', NULL, 'proteasome_alpha_type_4', NULL, NULL, 'proteasome_alpha_type_4', 1698),
(1699, 'cd14551', NULL, 'R-PTPc-A-E-1', NULL, NULL, 'R-PTPc-A-E-1', 1699),
(1700, 'cd13294', NULL, 'PH_ORP_plant', NULL, NULL, 'PH_ORP_plant', 1700),
(1701, 'cd13862', NULL, 'CuRO_1_MCO_like_1', NULL, NULL, 'CuRO_1_MCO_like_1', 1701),
(1702, 'cd11434', NULL, 'bHLH-PAS_SIM', NULL, NULL, 'bHLH-PAS_SIM', 1702),
(1703, 'cd15486', NULL, 'ZIP_Sip4', NULL, NULL, 'ZIP_Sip4', 1703),
(1704, 'cd05613', NULL, 'STKc_MSK1_N', NULL, NULL, 'STKc_MSK1_N', 1704),
(1705, 'cd05828', NULL, 'Sortase_D_1', NULL, NULL, 'Sortase_D_1', 1705),
(1706, 'cd08811', NULL, 'CARD_IPS1', NULL, NULL, 'CARD_IPS1', 1706),
(1707, 'cd12326', NULL, 'RRM1_hnRNPA0', NULL, NULL, 'RRM1_hnRNPA0', 1707),
(1708, 'cd08641', NULL, 'DNA_pol_gammaA', NULL, NULL, 'DNA_pol_gammaA', 1708),
(1709, 'cd16862', NULL, 'ING_ING4', NULL, NULL, 'ING_ING4', 1709),
(1710, 'cd18337', NULL, 'BTB_POZ_KLHL5', NULL, NULL, 'BTB_POZ_KLHL5', 1710),
(1711, 'cd09557', NULL, 'SAM_Smaug', NULL, NULL, 'SAM_Smaug', 1711),
(1712, 'cd19198', NULL, 'PR-SET_PRDM14', NULL, NULL, 'PR-SET_PRDM14', 1712),
(1713, 'cd13693', NULL, 'PBP2_polar_AA', NULL, NULL, 'PBP2_polar_AA', 1713),
(1714, 'cd01667', NULL, 'TGS_ThrRS', NULL, NULL, 'TGS_ThrRS', 1714),
(1715, 'cd02994', NULL, 'PDI_a_TMX', NULL, NULL, 'PDI_a_TMX', 1715),
(1716, 'cd18508', NULL, 'BACK_KEL_like', NULL, NULL, 'BACK_KEL_like', 1716),
(1717, 'cd13290', NULL, 'PH_ORP9', NULL, NULL, 'PH_ORP9', 1717),
(1718, 'cd17505', NULL, 'Ubl_SAMP1_like', NULL, NULL, 'Ubl_SAMP1_like', 1718),
(1719, 'cd01979', NULL, 'Pchlide_reductase_N', NULL, NULL, 'Pchlide_reductase_N', 1719),
(1720, 'cd17638', NULL, 'FadD3', NULL, NULL, 'FadD3', 1720),
(1721, 'cd07118', NULL, 'ALDH_SNDH', NULL, NULL, 'ALDH_SNDH', 1721),
(1722, 'cd01779', NULL, 'RA_Myosin-IX', NULL, NULL, 'RA_Myosin-IX', 1722),
(1723, 'cd11237', NULL, 'Sema_1A', NULL, NULL, 'Sema_1A', 1723),
(1724, 'cd12646', NULL, 'RRM_SRSF7', NULL, NULL, 'RRM_SRSF7', 1724),
(1725, 'cd16808', NULL, 'RING_CH-C4HC3_MARCH2', NULL, NULL, 'RING_CH-C4HC3_MARCH2', 1725),
(1726, 'cd16993', NULL, 'ENTH_Ent5', NULL, NULL, 'ENTH_Ent5', 1726),
(1727, 'cd13886', NULL, 'CuRO_2_MCO_like_1', NULL, NULL, 'CuRO_2_MCO_like_1', 1727),
(1728, 'cd12160', NULL, '2-Hacid_dh_3', NULL, NULL, '2-Hacid_dh_3', 1728),
(1729, 'cd17217', NULL, 'RA_Myosin-IXb', NULL, NULL, 'RA_Myosin-IXb', 1729),
(1730, 'cd01169', NULL, 'HMPP_kinase', NULL, NULL, 'HMPP_kinase', 1730);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(1731, 'cd09613', NULL, 'Jacalin_metallopeptidase_like', NULL, NULL, 'Jacalin_metallopeptidase_like', 1731),
(1732, 'cd14006', NULL, 'STKc_MLCK-like', NULL, NULL, 'STKc_MLCK-like', 1732),
(1733, 'cd12105', NULL, 'HmuY', NULL, NULL, 'HmuY', 1733),
(1734, 'cd16605', NULL, 'RING-HC_TRIM50_like_C-IV', NULL, NULL, 'RING-HC_TRIM50_like_C-IV', 1734),
(1735, 'cd04801', NULL, 'CBS_pair_peptidase_M50', NULL, NULL, 'CBS_pair_peptidase_M50', 1735),
(1736, 'cd09411', NULL, 'LIM4_Paxillin', NULL, NULL, 'LIM4_Paxillin', 1736),
(1737, 'cd18608', NULL, 'GH43_F5-8_typeC-like', NULL, NULL, 'GH43_F5-8_typeC-like', 1737),
(1738, 'cd12804', NULL, 'AKAP10_AKB', NULL, NULL, 'AKAP10_AKB', 1738),
(1739, 'cd04116', NULL, 'Rab9', NULL, NULL, 'Rab9', 1739),
(1740, 'cd19334', NULL, 'Wnt_Wnt2_like', NULL, NULL, 'Wnt_Wnt2_like', 1740),
(1741, 'cd18789', NULL, 'SF2_C_XPB', NULL, NULL, 'SF2_C_XPB', 1741),
(1742, 'cd19896', NULL, 'DSRM_RED2_rpt1', NULL, NULL, 'DSRM_RED2_rpt1', 1742),
(1743, 'cd16719', NULL, 'RING-HC_LNX4', NULL, NULL, 'RING-HC_LNX4', 1743),
(1744, 'cd11350', NULL, 'AmyAc_4', NULL, NULL, 'AmyAc_4', 1744),
(1745, 'cd05146', NULL, 'RIO3_euk', NULL, NULL, 'RIO3_euk', 1745),
(1746, 'cd10386', NULL, 'SH2_SOCS5', NULL, NULL, 'SH2_SOCS5', 1746),
(1747, 'cd14512', NULL, 'DSP_MKP', NULL, NULL, 'DSP_MKP', 1747),
(1748, 'cd08386', NULL, 'C2A_Synaptotagmin-7', NULL, NULL, 'C2A_Synaptotagmin-7', 1748),
(1749, 'cd09558', NULL, 'SAM_ZCCH14', NULL, NULL, 'SAM_ZCCH14', 1749),
(1750, 'cd16392', NULL, 'toxin-ParB', NULL, NULL, 'toxin-ParB', 1750),
(1751, 'cd03277', NULL, 'ABC_SMC5_euk', NULL, NULL, 'ABC_SMC5_euk', 1751),
(1752, 'cd06815', NULL, 'PLPDE_III_AR_like_1', NULL, NULL, 'PLPDE_III_AR_like_1', 1752),
(1753, 'cd09112', NULL, 'PLDc_CLS_2', NULL, NULL, 'PLDc_CLS_2', 1753),
(1754, 'cd19815', NULL, 'Bbox1_HOIP', NULL, NULL, 'Bbox1_HOIP', 1754),
(1755, 'cd12879', NULL, 'SPRY3_RyR', NULL, NULL, 'SPRY3_RyR', 1755),
(1756, 'cd12052', NULL, 'SH3_CIN85_1', NULL, NULL, 'SH3_CIN85_1', 1756),
(1757, 'cd06191', NULL, 'FNR_iron_sulfur_binding', NULL, NULL, 'FNR_iron_sulfur_binding', 1757),
(1758, 'cd17332', NULL, 'MFS_MelB_like', NULL, NULL, 'MFS_MelB_like', 1758),
(1759, 'cd03230', NULL, 'ABC_DR_subfamily_A', NULL, NULL, 'ABC_DR_subfamily_A', 1759),
(1760, 'cd09628', NULL, 'DOMON_SDR_2_like', NULL, NULL, 'DOMON_SDR_2_like', 1760),
(1761, 'cd08560', NULL, 'GDPD_EcGlpQ_like_1', NULL, NULL, 'GDPD_EcGlpQ_like_1', 1761),
(1762, 'cd12440', NULL, 'RRM_SYNJ', NULL, NULL, 'RRM_SYNJ', 1762),
(1763, 'cd08743', NULL, 'RGS_RGS14', NULL, NULL, 'RGS_RGS14', 1763),
(1764, 'cd12055', NULL, 'SH3_CIN85_2', NULL, NULL, 'SH3_CIN85_2', 1764),
(1765, 'cd16340', NULL, 'CpcS_T', NULL, NULL, 'CpcS_T', 1765),
(1766, 'cd00687', NULL, 'Terpene_cyclase_nonplant_C1', NULL, NULL, 'Terpene_cyclase_nonplant_C1', 1766),
(1767, 'cd07346', NULL, 'ABC_6TM_exporters', NULL, NULL, 'ABC_6TM_exporters', 1767),
(1768, 'cd17644', NULL, 'A_NRPS_ApnA-like', NULL, NULL, 'A_NRPS_ApnA-like', 1768),
(1769, 'cd16090', NULL, 'IgV_CD47', NULL, NULL, 'IgV_CD47', 1769),
(1770, 'cd03338', NULL, 'TCP1_delta', NULL, NULL, 'TCP1_delta', 1770),
(1771, 'cd00794', NULL, 'NOS_oxygenase_prok', NULL, NULL, 'NOS_oxygenase_prok', 1771),
(1772, 'cd06345', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, 'PBP1_ABC_ligand_binding-like', 1772),
(1773, 'cd01295', NULL, 'AdeC', NULL, NULL, 'AdeC', 1773),
(1774, 'cd02649', NULL, 'nuc_hydro_CeIAG', NULL, NULL, 'nuc_hydro_CeIAG', 1774),
(1775, 'cd05713', NULL, 'Ig_MOG_like', NULL, NULL, 'Ig_MOG_like', 1775),
(1776, 'cd09443', NULL, 'LIM_Ltd-1', NULL, NULL, 'LIM_Ltd-1', 1776),
(1777, 'cd16025', NULL, 'PAS_like', NULL, NULL, 'PAS_like', 1777),
(1778, 'cd08693', NULL, 'C2_PI3K_class_I_beta_delta', NULL, NULL, 'C2_PI3K_class_I_beta_delta', 1778),
(1779, 'cd19173', NULL, 'SET_NSD', NULL, NULL, 'SET_NSD', 1779),
(1780, 'cd07400', NULL, 'MPP_1', NULL, NULL, 'MPP_1', 1780),
(1781, 'cd07435', NULL, 'PHP_PolIIIA_POLC', NULL, NULL, 'PHP_PolIIIA_POLC', 1781),
(1782, 'cd16093', NULL, 'IgC_CH2_Mu', NULL, NULL, 'IgC_CH2_Mu', 1782),
(1783, 'cd08905', NULL, 'START_STARD1-like', NULL, NULL, 'START_STARD1-like', 1783);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(1784, 'cd14072', NULL, 'STKc_MARK', NULL, NULL, 'STKc_MARK', 1784),
(1785, 'cd10043', NULL, 'Reelin_repeat_7_subrepeat_1', NULL, NULL, 'Reelin_repeat_7_subrepeat_1', 1785),
(1786, 'cd00611', NULL, 'PSAT_like', NULL, NULL, 'PSAT_like', 1786),
(1787, 'cd10241', NULL, 'HSPA5-like_NBD', NULL, NULL, 'HSPA5-like_NBD', 1787),
(1788, 'cd06297', NULL, 'PBP1_CcpA_TTHA0807', NULL, NULL, 'PBP1_CcpA_TTHA0807', 1788),
(1789, 'cd05592', NULL, 'STKc_nPKC_theta_like', NULL, NULL, 'STKc_nPKC_theta_like', 1789),
(1790, 'cd12383', NULL, 'RRM_RBM42', NULL, NULL, 'RRM_RBM42', 1790),
(1791, 'cd08718', NULL, 'RGS_RZ-like', NULL, NULL, 'RGS_RZ-like', 1791),
(1792, 'cd07903', NULL, 'Adenylation_DNA_ligase_IV', NULL, NULL, 'Adenylation_DNA_ligase_IV', 1792),
(1793, 'cd14359', NULL, 'UBA_AeNAC', NULL, NULL, 'UBA_AeNAC', 1793),
(1794, 'cd14761', NULL, 'GS_GsGCS-like', NULL, NULL, 'GS_GsGCS-like', 1794),
(1795, 'cd07049', NULL, 'BMC_EutL_repeat1', NULL, NULL, 'BMC_EutL_repeat1', 1795),
(1796, 'cd20253', NULL, 'Sarcolipin', NULL, NULL, 'Sarcolipin', 1796),
(1797, 'cd06985', NULL, 'cupin_BF4112', NULL, NULL, 'cupin_BF4112', 1797),
(1798, 'cd11266', NULL, 'Sema_6A', NULL, NULL, 'Sema_6A', 1798),
(1799, 'cd16469', NULL, 'RING-H2_RNF24_like', NULL, NULL, 'RING-H2_RNF24_like', 1799),
(1800, 'cd14929', NULL, 'MYSc_Myh15_mammals', NULL, NULL, 'MYSc_Myh15_mammals', 1800),
(1801, 'cd04190', NULL, 'Chitin_synth_C', NULL, NULL, 'Chitin_synth_C', 1801),
(1802, 'cd08540', NULL, 'SAM_PNT-ERG', NULL, NULL, 'SAM_PNT-ERG', 1802),
(1803, 'cd18950', NULL, 'bHLH-PAS_NCoA2_SRC2', NULL, NULL, 'bHLH-PAS_NCoA2_SRC2', 1803),
(1804, 'cd05932', NULL, 'LC_FACS_bac', NULL, NULL, 'LC_FACS_bac', 1804),
(1805, 'cd02042', NULL, 'ParAB_family', NULL, NULL, 'ParAB_family', 1805),
(1806, 'cd12205', NULL, 'RasGAP_plexin', NULL, NULL, 'RasGAP_plexin', 1806),
(1807, 'cd15154', NULL, '7tmA_LPAR5', NULL, NULL, '7tmA_LPAR5', 1807),
(1808, 'cd18314', NULL, 'BTB_POZ_trishanku-like', NULL, NULL, 'BTB_POZ_trishanku-like', 1808),
(1809, 'cd12685', NULL, 'RRM_RBM20', NULL, NULL, 'RRM_RBM20', 1809),
(1810, 'cd01585', NULL, 'AcnA_Bact', NULL, NULL, 'AcnA_Bact', 1810),
(1811, 'cd19449', NULL, 'ReP1-NCXSQ-like', NULL, NULL, 'ReP1-NCXSQ-like', 1811),
(1812, 'cd19083', NULL, 'AKR_AKR11A1_11D1', NULL, NULL, 'AKR_AKR11A1_11D1', 1812),
(1813, 'cd20216', NULL, 'PFM_HFR-2-like', NULL, NULL, 'PFM_HFR-2-like', 1813),
(1814, 'cd17912', NULL, 'DEAD-like_helicase_N', NULL, NULL, 'DEAD-like_helicase_N', 1814),
(1815, 'cd20234', NULL, 'PFM_fascin-like', NULL, NULL, 'PFM_fascin-like', 1815),
(1816, 'cd01669', NULL, 'TGS_MJ1332_like', NULL, NULL, 'TGS_MJ1332_like', 1816),
(1817, 'cd02071', NULL, 'MM_CoA_mut_B12_BD', NULL, NULL, 'MM_CoA_mut_B12_BD', 1817),
(1818, 'cd03565', NULL, 'VHS_Tom1_like', NULL, NULL, 'VHS_Tom1_like', 1818),
(1819, 'cd03474', NULL, 'Rieske_T4moC', NULL, NULL, 'Rieske_T4moC', 1819),
(1820, 'cd19181', NULL, 'SET_SETD5', NULL, NULL, 'SET_SETD5', 1820),
(1821, 'cd00974', NULL, 'DSRD', NULL, NULL, 'DSRD', 1821),
(1822, 'cd07888', NULL, 'CRD_corin_2', NULL, NULL, 'CRD_corin_2', 1822),
(1823, 'cd13745', NULL, 'SPRY_PRY_TRIM39', NULL, NULL, 'SPRY_PRY_TRIM39', 1823),
(1824, 'cd15938', NULL, '7tmA_OR4Q2-like', NULL, NULL, '7tmA_OR4Q2-like', 1824),
(1825, 'cd08789', NULL, 'CARD_IPS-1_RIG-I', NULL, NULL, 'CARD_IPS-1_RIG-I', 1825),
(1826, 'cd18792', NULL, 'SF2_C_RecG_TRCF', NULL, NULL, 'SF2_C_RecG_TRCF', 1826),
(1827, 'cd03183', NULL, 'GST_C_Theta', NULL, NULL, 'GST_C_Theta', 1827),
(1828, 'cd00775', NULL, 'LysRS_core', NULL, NULL, 'LysRS_core', 1828),
(1829, 'cd18562', NULL, 'ABC_6TM_NdvA_beta-glucan_exporter_like', NULL, NULL, 'ABC_6TM_NdvA_beta-glucan_exporter_like', 1829),
(1830, 'cd16547', NULL, 'RING-HC_RNF151', NULL, NULL, 'RING-HC_RNF151', 1830),
(1831, 'cd11626', NULL, 'HR1_ROCK', NULL, NULL, 'HR1_ROCK', 1831),
(1832, 'cd00680', NULL, 'RHO_alpha_C', NULL, NULL, 'RHO_alpha_C', 1832),
(1833, 'cd13705', NULL, 'PBP2_BvgS_D1', NULL, NULL, 'PBP2_BvgS_D1', 1833),
(1834, 'cd17360', NULL, 'MFS_HMIT_like', NULL, NULL, 'MFS_HMIT_like', 1834),
(1835, 'cd12340', NULL, 'RBD_RRM1_NPL3', NULL, NULL, 'RBD_RRM1_NPL3', 1835);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(1836, 'cd16498', NULL, 'RING-HC_BRCA1', NULL, NULL, 'RING-HC_BRCA1', 1836),
(1837, 'cd10282', NULL, 'DNase1', NULL, NULL, 'DNase1', 1837),
(1838, 'cd11523', NULL, 'NTP-PPase', NULL, NULL, 'NTP-PPase', 1838),
(1839, 'cd16361', NULL, 'VOC_ShValD_like', NULL, NULL, 'VOC_ShValD_like', 1839),
(1840, 'cd04488', NULL, 'RecG_wedge_OBF', NULL, NULL, 'RecG_wedge_OBF', 1840),
(1841, 'cd14185', NULL, 'STKc_DCKL3', NULL, NULL, 'STKc_DCKL3', 1841),
(1842, 'cd08266', NULL, 'Zn_ADH_like1', NULL, NULL, 'Zn_ADH_like1', 1842),
(1843, 'cd07967', NULL, 'OBF_DNA_ligase_III', NULL, NULL, 'OBF_DNA_ligase_III', 1843),
(1844, 'cd10017', NULL, 'B3_DNA', NULL, NULL, 'B3_DNA', 1844),
(1845, 'cd11657', NULL, 'TIN2_N', NULL, NULL, 'TIN2_N', 1845),
(1846, 'cd17903', NULL, 'ArfGap_AGFG2', NULL, NULL, 'ArfGap_AGFG2', 1846),
(1847, 'cd05165', NULL, 'PI3Kc_I', NULL, NULL, 'PI3Kc_I', 1847),
(1848, 'cd07577', NULL, 'Ph0642_like', NULL, NULL, 'Ph0642_like', 1848),
(1849, 'cd15383', NULL, '7tmA_GnRHR_vertebrate', NULL, NULL, '7tmA_GnRHR_vertebrate', 1849),
(1850, 'cd03535', NULL, 'Rieske_RO_Alpha_NDO', NULL, NULL, 'Rieske_RO_Alpha_NDO', 1850),
(1851, 'cd08430', NULL, 'PBP2_IlvY', NULL, NULL, 'PBP2_IlvY', 1851),
(1852, 'cd07136', NULL, 'ALDH_YwdH-P39616', NULL, NULL, 'ALDH_YwdH-P39616', 1852),
(1853, 'cd14416', NULL, 'UBA_NACAD', NULL, NULL, 'UBA_NACAD', 1853),
(1854, 'cd15035', NULL, '7tmF_FZD5_FZD8-like', NULL, NULL, '7tmF_FZD5_FZD8-like', 1854),
(1855, 'cd00305', NULL, 'Cu-Zn_Superoxide_Dismutase', NULL, NULL, 'Cu-Zn_Superoxide_Dismutase', 1855),
(1856, 'cd06102', NULL, 'citrate_synt_like_2', NULL, NULL, 'citrate_synt_like_2', 1856),
(1857, 'cd07127', NULL, 'ALDH_PAD-PaaZ', NULL, NULL, 'ALDH_PAD-PaaZ', 1857),
(1858, 'cd05068', NULL, 'PTKc_Frk_like', NULL, NULL, 'PTKc_Frk_like', 1858),
(1859, 'cd16573', NULL, 'RING-HC_TFB3_like', NULL, NULL, 'RING-HC_TFB3_like', 1859),
(1860, 'cd01520', NULL, 'RHOD_YbbB', NULL, NULL, 'RHOD_YbbB', 1860),
(1861, 'cd12470', NULL, 'RRM1_MSSP1', NULL, NULL, 'RRM1_MSSP1', 1861),
(1862, 'cd18514', NULL, 'BACK_KLHL25_ENC2', NULL, NULL, 'BACK_KLHL25_ENC2', 1862),
(1863, 'cd15340', NULL, '7tmA_CB1', NULL, NULL, '7tmA_CB1', 1863),
(1864, 'cd07834', NULL, 'STKc_MAPK', NULL, NULL, 'STKc_MAPK', 1864),
(1865, 'cd04877', NULL, 'ACT_TyrR', NULL, NULL, 'ACT_TyrR', 1865),
(1866, 'cd14829', NULL, 'Zeta-COP', NULL, NULL, 'Zeta-COP', 1866),
(1867, 'cd06239', NULL, 'M14-like', NULL, NULL, 'M14-like', 1867),
(1868, 'cd18436', NULL, 'BRCT_BRC1_like_rpt2', NULL, NULL, 'BRCT_BRC1_like_rpt2', 1868),
(1869, 'cd00105', NULL, 'KH-I', NULL, NULL, 'KH-I', 1869),
(1870, 'cd10814', NULL, 'GH38N_AMII_SpGH38_like', NULL, NULL, 'GH38N_AMII_SpGH38_like', 1870),
(1871, 'sd00036', NULL, 'LRR_3', NULL, NULL, 'LRR_3', 1871),
(1872, 'cd09994', NULL, 'HDAC_AcuC_like', NULL, NULL, 'HDAC_AcuC_like', 1872),
(1873, 'cd07553', NULL, 'P-type_ATPase_HM', NULL, NULL, 'P-type_ATPase_HM', 1873),
(1874, 'cd09232', NULL, 'Snurportin-1_C', NULL, NULL, 'Snurportin-1_C', 1874),
(1875, 'cd15207', NULL, '7tmA_NPFFR', NULL, NULL, '7tmA_NPFFR', 1875),
(1876, 'cd00821', NULL, 'PH', NULL, NULL, 'PH', 1876),
(1877, 'cd08512', NULL, 'PBP2_NikA_DppA_OppA_like_7', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_7', 1877),
(1878, 'cd07544', NULL, 'P-type_ATPase_HM', NULL, NULL, 'P-type_ATPase_HM', 1878),
(1879, 'cd05296', NULL, 'GH4_P_beta_glucosidase', NULL, NULL, 'GH4_P_beta_glucosidase', 1879),
(1880, 'cd09690', NULL, 'Cas7_I-B', NULL, NULL, 'Cas7_I-B', 1880),
(1881, 'cd04985', NULL, 'IgC_CH1_IgAEGM', NULL, NULL, 'IgC_CH1_IgAEGM', 1881),
(1882, 'cd06136', NULL, 'TREX1_2', NULL, NULL, 'TREX1_2', 1882),
(1883, 'cd06469', NULL, 'p23_DYX1C1_like', NULL, NULL, 'p23_DYX1C1_like', 1883),
(1884, 'cd06990', NULL, 'cupin_DUF861', NULL, NULL, 'cupin_DUF861', 1884),
(1885, 'cd12943', NULL, 'LEM_ANKL1', NULL, NULL, 'LEM_ANKL1', 1885),
(1886, 'cd03067', NULL, 'PDI_b_PDIR_N', NULL, NULL, 'PDI_b_PDIR_N', 1886),
(1887, 'cd17189', NULL, 'FERM_F1_FARP1', NULL, NULL, 'FERM_F1_FARP1', 1887),
(1888, 'cd01813', NULL, 'Ubl_UBLCP1', NULL, NULL, 'Ubl_UBLCP1', 1888),
(1889, 'cd15875', NULL, 'SNARE_syntaxin7', NULL, NULL, 'SNARE_syntaxin7', 1889);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(1890, 'cd01869', NULL, 'Rab1_Ypt1', NULL, NULL, 'Rab1_Ypt1', 1890),
(1891, 'cd03800', NULL, 'GT4_sucrose_synthase', NULL, NULL, 'GT4_sucrose_synthase', 1891),
(1892, 'cd14517', NULL, 'DSP_STYXL1', NULL, NULL, 'DSP_STYXL1', 1892),
(1893, 'cd15150', NULL, '7tmA_P2Y12', NULL, NULL, '7tmA_P2Y12', 1893),
(1894, 'cd07454', NULL, 'CRD_LIN_17', NULL, NULL, 'CRD_LIN_17', 1894),
(1895, 'cd00435', NULL, 'ACBP', NULL, NULL, 'ACBP', 1895),
(1896, 'cd13393', NULL, 'PH_ARHGEF2', NULL, NULL, 'PH_ARHGEF2', 1896),
(1897, 'cd16786', NULL, 'mRING-HC-C3HC5_NEU1B', NULL, NULL, 'mRING-HC-C3HC5_NEU1B', 1897),
(1898, 'cd19804', NULL, 'Bbox1_TRIM19_C-V', NULL, NULL, 'Bbox1_TRIM19_C-V', 1898),
(1899, 'cd05767', NULL, 'IgC_MHC_II_alpha', NULL, NULL, 'IgC_MHC_II_alpha', 1899),
(1900, 'cd01810', NULL, 'Ubl2_ISG15', NULL, NULL, 'Ubl2_ISG15', 1900),
(1901, 'cd08843', NULL, 'ArfGap_ADAP1', NULL, NULL, 'ArfGap_ADAP1', 1901),
(1902, 'cd13659', NULL, 'PBP2_PotF', NULL, NULL, 'PBP2_PotF', 1902),
(1903, 'cd17128', NULL, 'Ubl_IKKE', NULL, NULL, 'Ubl_IKKE', 1903),
(1904, 'cd16497', NULL, 'RING-HC_BAR', NULL, NULL, 'RING-HC_BAR', 1904),
(1905, 'cd03346', NULL, 'eu_TrpOH', NULL, NULL, 'eu_TrpOH', 1905),
(1906, 'cd11633', NULL, 'HR1_Rhophilin-1', NULL, NULL, 'HR1_Rhophilin-1', 1906),
(1907, 'cd10914', NULL, 'Peptidase_C25_N_1', NULL, NULL, 'Peptidase_C25_N_1', 1907),
(1908, 'cd13530', NULL, 'PBP2_peptides_like', NULL, NULL, 'PBP2_peptides_like', 1908),
(1909, 'cd19912', NULL, 'DSRM_ILF3_rpt2', NULL, NULL, 'DSRM_ILF3_rpt2', 1909),
(1910, 'cd00050', NULL, 'MH2', NULL, NULL, 'MH2', 1910),
(1911, 'cd15136', NULL, '7tmA_Glyco_hormone_R', NULL, NULL, '7tmA_Glyco_hormone_R', 1911),
(1912, 'cd01301', NULL, 'rDP_like', NULL, NULL, 'rDP_like', 1912),
(1913, 'cd09667', NULL, 'Csb2_I-U', NULL, NULL, 'Csb2_I-U', 1913),
(1914, 'cd13602', NULL, 'PBP2_TRAP_BpDctp6_7', NULL, NULL, 'PBP2_TRAP_BpDctp6_7', 1914),
(1915, 'cd17052', NULL, 'Ubl1_FAT10', NULL, NULL, 'Ubl1_FAT10', 1915),
(1916, 'cd06956', NULL, 'NR_DBD_RXR', NULL, NULL, 'NR_DBD_RXR', 1916),
(1917, 'cd14624', NULL, 'R-PTPc-D-1', NULL, NULL, 'R-PTPc-D-1', 1917),
(1918, 'cd15067', NULL, '7tmA_Dop1R2-like', NULL, NULL, '7tmA_Dop1R2-like', 1918),
(1919, 'cd05647', NULL, 'M20_DapE_actinobac', NULL, NULL, 'M20_DapE_actinobac', 1919),
(1920, 'cd09192', NULL, 'PLDc_DNaseII_beta_2', NULL, NULL, 'PLDc_DNaseII_beta_2', 1920),
(1921, 'cd16258', NULL, 'Tet_III', NULL, NULL, 'Tet_III', 1921),
(1922, 'cd08990', NULL, 'GH43_AXH_like', NULL, NULL, 'GH43_AXH_like', 1922),
(1923, 'cd12140', NULL, 'SH3_Amphiphysin_I', NULL, NULL, 'SH3_Amphiphysin_I', 1923),
(1924, 'cd11826', NULL, 'SH3_Abi', NULL, NULL, 'SH3_Abi', 1924),
(1925, 'cd20170', NULL, 'Peptidase_M90-like', NULL, NULL, 'Peptidase_M90-like', 1925),
(1926, 'cd12500', NULL, 'RRM_BsYxiN_like', NULL, NULL, 'RRM_BsYxiN_like', 1926),
(1927, 'cd14186', NULL, 'STKc_PLK4', NULL, NULL, 'STKc_PLK4', 1927),
(1928, 'cd03353', NULL, 'LbH_GlmU_C', NULL, NULL, 'LbH_GlmU_C', 1928),
(1929, 'cd19872', NULL, 'DSRM_A1CF-like', NULL, NULL, 'DSRM_A1CF-like', 1929),
(1930, 'cd00739', NULL, 'DHPS', NULL, NULL, 'DHPS', 1930),
(1931, 'cd11774', NULL, 'SH3_Sla1p_2', NULL, NULL, 'SH3_Sla1p_2', 1931),
(1932, 'cd04439', NULL, 'DEP_1_P-Rex', NULL, NULL, 'DEP_1_P-Rex', 1932),
(1933, 'cd07134', NULL, 'ALDH_AlkH-like', NULL, NULL, 'ALDH_AlkH-like', 1933),
(1934, 'cd18932', NULL, 'bHLHzip_Mad3', NULL, NULL, 'bHLHzip_Mad3', 1934),
(1935, 'cd05599', NULL, 'STKc_NDR_like', NULL, NULL, 'STKc_NDR_like', 1935),
(1936, 'cd09242', NULL, 'BRO1_ScBro1_like', NULL, NULL, 'BRO1_ScBro1_like', 1936),
(1937, 'cd05496', NULL, 'Bromo_WDR9_II', NULL, NULL, 'Bromo_WDR9_II', 1937),
(1938, 'cd07233', NULL, 'GlxI_Zn', NULL, NULL, 'GlxI_Zn', 1938),
(1939, 'cd02860', NULL, 'E_set_Pullulanase', NULL, NULL, 'E_set_Pullulanase', 1939),
(1940, 'cd06336', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, 'PBP1_ABC_ligand_binding-like', 1940),
(1941, 'cd14045', NULL, 'PK_GC_unk', NULL, NULL, 'PK_GC_unk', 1941),
(1942, 'cd07151', NULL, 'ALDH_HBenzADH', NULL, NULL, 'ALDH_HBenzADH', 1942),
(1943, 'cd14607', NULL, 'PTPc-N2', NULL, NULL, 'PTPc-N2', 1943);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(1944, 'cd15079', NULL, '7tmA_photoreceptors_insect', NULL, NULL, '7tmA_photoreceptors_insect', 1944),
(1945, 'cd16137', NULL, 'RA_MRL_RIAM', NULL, NULL, 'RA_MRL_RIAM', 1945),
(1946, 'cd03381', NULL, 'PAP2_glucose_6_phosphatase', NULL, NULL, 'PAP2_glucose_6_phosphatase', 1946),
(1947, 'cd11585', NULL, 'SATB1_N', NULL, NULL, 'SATB1_N', 1947),
(1948, 'cd00085', NULL, 'HNHc', NULL, NULL, 'HNHc', 1948),
(1949, 'cd01526', NULL, 'RHOD_ThiF', NULL, NULL, 'RHOD_ThiF', 1949),
(1950, 'cd09027', NULL, 'PET', NULL, NULL, 'PET', 1950),
(1951, 'cd15285', NULL, '7tmC_mGluR_group1', NULL, NULL, '7tmC_mGluR_group1', 1951),
(1952, 'cd06466', NULL, 'p23_CS_SGT1_like', NULL, NULL, 'p23_CS_SGT1_like', 1952),
(1953, 'cd05344', NULL, 'BKR_like_SDR_like', NULL, NULL, 'BKR_like_SDR_like', 1953),
(1954, 'cd17323', NULL, 'MFS_Tpo1_MDR_like', NULL, NULL, 'MFS_Tpo1_MDR_like', 1954),
(1955, 'cd00884', NULL, 'beta_CA_cladeB', NULL, NULL, 'beta_CA_cladeB', 1955),
(1956, 'cd15410', NULL, '7tmA_OR5D-like', NULL, NULL, '7tmA_OR5D-like', 1956),
(1957, 'cd15873', NULL, 'R-SNARE_STXBP5_6', NULL, NULL, 'R-SNARE_STXBP5_6', 1957),
(1958, 'cd18082', NULL, 'SpoU-like_family', NULL, NULL, 'SpoU-like_family', 1958),
(1959, 'cd05612', NULL, 'STKc_PRKX_like', NULL, NULL, 'STKc_PRKX_like', 1959),
(1960, 'cd05850', NULL, 'Ig1_Contactin-2', NULL, NULL, 'Ig1_Contactin-2', 1960),
(1961, 'cd06553', NULL, 'ASCH_Ef3133_like', NULL, NULL, 'ASCH_Ef3133_like', 1961),
(1962, 'cd07502', NULL, 'HAD_PNKP-C', NULL, NULL, 'HAD_PNKP-C', 1962),
(1963, 'cd06093', NULL, 'PX_domain', NULL, NULL, 'PX_domain', 1963),
(1964, 'cd19108', NULL, 'AKR_AKR1C1-35', NULL, NULL, 'AKR_AKR1C1-35', 1964),
(1965, 'cd06629', NULL, 'STKc_Bck1_like', NULL, NULL, 'STKc_Bck1_like', 1965),
(1966, 'cd12002', NULL, 'SH3_NEDD9', NULL, NULL, 'SH3_NEDD9', 1966),
(1967, 'cd08515', NULL, 'PBP2_NikA_DppA_OppA_like_10', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_10', 1967),
(1968, 'cd06893', NULL, 'PX_SNX19', NULL, NULL, 'PX_SNX19', 1968),
(1969, 'cd15832', NULL, 'SNAP', NULL, NULL, 'SNAP', 1969),
(1970, 'cd17454', NULL, 'MFS_NaGLT1_MFSD4B', NULL, NULL, 'MFS_NaGLT1_MFSD4B', 1970),
(1971, 'cd17743', NULL, 'BRCT_BRC1_like_rpt5', NULL, NULL, 'BRCT_BRC1_like_rpt5', 1971),
(1972, 'cd03025', NULL, 'DsbA_FrnE_like', NULL, NULL, 'DsbA_FrnE_like', 1972),
(1973, 'cd14716', NULL, 'bZIP_CEBP-like_1', NULL, NULL, 'bZIP_CEBP-like_1', 1973),
(1974, 'cd16493', NULL, 'RING-CH-C4HC3_NSE1', NULL, NULL, 'RING-CH-C4HC3_NSE1', 1974),
(1975, 'cd02584', NULL, 'RNAP_II_Rpb1_C', NULL, NULL, 'RNAP_II_Rpb1_C', 1975),
(1976, 'cd00396', NULL, 'PurM-like', NULL, NULL, 'PurM-like', 1976),
(1977, 'cd16634', NULL, 'mRING-HC-C3HC3D_Nrdp1', NULL, NULL, 'mRING-HC-C3HC3D_Nrdp1', 1977),
(1978, 'cd00740', NULL, 'MeTr', NULL, NULL, 'MeTr', 1978),
(1979, 'cd16165', NULL, 'OCRE_ZOP1_plant', NULL, NULL, 'OCRE_ZOP1_plant', 1979),
(1980, 'cd05483', NULL, 'retropepsin_like_bacteria', NULL, NULL, 'retropepsin_like_bacteria', 1980),
(1981, 'cd06244', NULL, 'M14-like', NULL, NULL, 'M14-like', 1981),
(1982, 'cd07291', NULL, 'PX_SNX5', NULL, NULL, 'PX_SNX5', 1982),
(1983, 'cd04713', NULL, 'BAH_plant_3', NULL, NULL, 'BAH_plant_3', 1983),
(1984, 'cd14097', NULL, 'STKc_STK33', NULL, NULL, 'STKc_STK33', 1984),
(1985, 'cd02429', NULL, 'PTH2_like', NULL, NULL, 'PTH2_like', 1985),
(1986, 'cd16341', NULL, 'FdhE', NULL, NULL, 'FdhE', 1986),
(1987, 'cd16704', NULL, 'RING-HC_RNF20_like', NULL, NULL, 'RING-HC_RNF20_like', 1987),
(1988, 'cd03892', NULL, 'M20_peptT', NULL, NULL, 'M20_peptT', 1988),
(1989, 'cd15607', NULL, 'PHD2_KDM5B', NULL, NULL, 'PHD2_KDM5B', 1989),
(1990, 'cd03738', NULL, 'SOCS_SOCS4', NULL, NULL, 'SOCS_SOCS4', 1990),
(1991, 'cd06989', NULL, 'cupin_DRT102', NULL, NULL, 'cupin_DRT102', 1991),
(1992, 'cd09877', NULL, 'PIN_YacL-like', NULL, NULL, 'PIN_YacL-like', 1992),
(1993, 'cd14878', NULL, 'MYSc_Myo16', NULL, NULL, 'MYSc_Myo16', 1993),
(1994, 'cd02661', NULL, 'Peptidase_C19E', NULL, NULL, 'Peptidase_C19E', 1994),
(1995, 'cd10367', NULL, 'SH2_Src_Fgr', NULL, NULL, 'SH2_Src_Fgr', 1995),
(1996, 'cd15968', NULL, '7tmA_P2Y6_P2Y3-like', NULL, NULL, '7tmA_P2Y6_P2Y3-like', 1996);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(1997, 'cd15826', NULL, 'SPRY_PRY_TRIM15', NULL, NULL, 'SPRY_PRY_TRIM15', 1997),
(1998, 'cd08822', NULL, 'FMT_core_like_2', NULL, NULL, 'FMT_core_like_2', 1998),
(1999, 'cd10452', NULL, 'GIY-YIG_RE_Eco29kI_NgoMIII', NULL, NULL, 'GIY-YIG_RE_Eco29kI_NgoMIII', 1999),
(2000, 'cd19892', NULL, 'DSRM_PRKRA_rpt3', NULL, NULL, 'DSRM_PRKRA_rpt3', 2000),
(2001, 'cd05095', NULL, 'PTKc_DDR2', NULL, NULL, 'PTKc_DDR2', 2001),
(2002, 'cd15666', NULL, 'ePHD2_KMT2C_like', NULL, NULL, 'ePHD2_KMT2C_like', 2002),
(2003, 'cd18247', NULL, 'BTB_POZ_KLHL18', NULL, NULL, 'BTB_POZ_KLHL18', 2003),
(2004, 'cd03867', NULL, 'M14_CPZ', NULL, NULL, 'M14_CPZ', 2004),
(2005, 'cd06165', NULL, 'Sortase_A', NULL, NULL, 'Sortase_A', 2005),
(2006, 'cd00385', NULL, 'Isoprenoid_Biosyn_C1', NULL, NULL, 'Isoprenoid_Biosyn_C1', 2006),
(2007, 'cd05157', NULL, 'ETNK_euk', NULL, NULL, 'ETNK_euk', 2007),
(2008, 'cd08423', NULL, 'PBP2_LTTR_like_6', NULL, NULL, 'PBP2_LTTR_like_6', 2008),
(2009, 'cd04903', NULL, 'ACT_LSD', NULL, NULL, 'ACT_LSD', 2009),
(2010, 'cd10550', NULL, 'DMSOR_beta_like', NULL, NULL, 'DMSOR_beta_like', 2010),
(2011, 'cd16735', NULL, 'RING-HC_PCGF3', NULL, NULL, 'RING-HC_PCGF3', 2011),
(2012, 'cd03415', NULL, 'CbiX_CbiC', NULL, NULL, 'CbiX_CbiC', 2012),
(2013, 'cd04248', NULL, 'AAK_AK-Ectoine', NULL, NULL, 'AAK_AK-Ectoine', 2013),
(2014, 'cd06234', NULL, 'M14_PaCCP-like', NULL, NULL, 'M14_PaCCP-like', 2014),
(2015, 'cd09241', NULL, 'BRO1_ScRim20-like', NULL, NULL, 'BRO1_ScRim20-like', 2015),
(2016, 'cd07418', NULL, 'MPP_PP7', NULL, NULL, 'MPP_PP7', 2016),
(2017, 'cd12373', NULL, 'RRM_SRSF3_like', NULL, NULL, 'RRM_SRSF3_like', 2017),
(2018, 'cd14078', NULL, 'STKc_MELK', NULL, NULL, 'STKc_MELK', 2018),
(2019, 'cd06404', NULL, 'PB1_aPKC', NULL, NULL, 'PB1_aPKC', 2019),
(2020, 'cd09235', NULL, 'V_Alix', NULL, NULL, 'V_Alix', 2020),
(2021, 'cd05156', NULL, 'ChoK_euk', NULL, NULL, 'ChoK_euk', 2021),
(2022, 'cd13944', NULL, 'lytB_ispH', NULL, NULL, 'lytB_ispH', 2022),
(2023, 'cd18365', NULL, 'BTB_POZ_KCTD6_like', NULL, NULL, 'BTB_POZ_KCTD6_like', 2023),
(2024, 'cd03192', NULL, 'GST_C_Sigma_like', NULL, NULL, 'GST_C_Sigma_like', 2024),
(2025, 'cd01453', NULL, 'vWA_transcription_factor_IIH_type', NULL, NULL, 'vWA_transcription_factor_IIH_type', 2025),
(2026, 'cd13998', NULL, 'STKc_TGFbR-like', NULL, NULL, 'STKc_TGFbR-like', 2026),
(2027, 'cd17534', NULL, 'REC_DC-like', NULL, NULL, 'REC_DC-like', 2027),
(2028, 'cd14898', NULL, 'MYSc_Myo37', NULL, NULL, 'MYSc_Myo37', 2028),
(2029, 'cd16032', NULL, 'choline-sulfatase', NULL, NULL, 'choline-sulfatase', 2029),
(2030, 'cd09096', NULL, 'Deadenylase_nocturnin', NULL, NULL, 'Deadenylase_nocturnin', 2030),
(2031, 'cd07320', NULL, 'Extradiol_Dioxygenase_3B_like', NULL, NULL, 'Extradiol_Dioxygenase_3B_like', 2031),
(2032, 'cd09265', NULL, 'AP_Syp1_like_MHD', NULL, NULL, 'AP_Syp1_like_MHD', 2032),
(2033, 'cd10156', NULL, 'FpFrmR-Cterm-like_DUF156', NULL, NULL, 'FpFrmR-Cterm-like_DUF156', 2033),
(2034, 'cd15006', NULL, '7tmA_GPR176', NULL, NULL, '7tmA_GPR176', 2034),
(2035, 'cd08481', NULL, 'PBP2_GcdR_like', NULL, NULL, 'PBP2_GcdR_like', 2035),
(2036, 'cd10353', NULL, 'SH2_Nterm_RasGAP', NULL, NULL, 'SH2_Nterm_RasGAP', 2036),
(2037, 'cd19346', NULL, 'Wnt_Wnt2b', NULL, NULL, 'Wnt_Wnt2b', 2037),
(2038, 'cd12667', NULL, 'RRM3_RAVER1', NULL, NULL, 'RRM3_RAVER1', 2038),
(2039, 'cd16465', NULL, 'RING-H2_PJA1_2', NULL, NULL, 'RING-H2_PJA1_2', 2039),
(2040, 'cd06263', NULL, 'MAM', NULL, NULL, 'MAM', 2040),
(2041, 'cd00365', NULL, 'HMG-CoA_reductase', NULL, NULL, 'HMG-CoA_reductase', 2041),
(2042, 'cd12215', NULL, 'ChiC_BD', NULL, NULL, 'ChiC_BD', 2042),
(2043, 'cd00295', NULL, 'RNA_Cyclase', NULL, NULL, 'RNA_Cyclase', 2043),
(2044, 'cd14406', NULL, 'UBA_MARK2', NULL, NULL, 'UBA_MARK2', 2044),
(2045, 'cd04899', NULL, 'ACT_ACR-UUR-like_2', NULL, NULL, 'ACT_ACR-UUR-like_2', 2045),
(2046, 'cd06203', NULL, 'methionine_synthase_red', NULL, NULL, 'methionine_synthase_red', 2046),
(2047, 'cd10407', NULL, 'SH2_Vav3', NULL, NULL, 'SH2_Vav3', 2047),
(2048, 'cd00115', NULL, 'LMWP', NULL, NULL, 'LMWP', 2048),
(2049, 'cd02216', NULL, 'cupin_GDO-like_N', NULL, NULL, 'cupin_GDO-like_N', 2049);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(2050, 'cd06455', NULL, 'M3A_TOP', NULL, NULL, 'M3A_TOP', 2050),
(2051, 'cd03476', NULL, 'Rieske_ArOX_small', NULL, NULL, 'Rieske_ArOX_small', 2051),
(2052, 'cd19746', NULL, 'bHLH_TS_ASCL4', NULL, NULL, 'bHLH_TS_ASCL4', 2052),
(2053, 'cd15420', NULL, '7tmA_OR2A-like', NULL, NULL, '7tmA_OR2A-like', 2053),
(2054, 'cd07419', NULL, 'MPP_Bsu1_C', NULL, NULL, 'MPP_Bsu1_C', 2054),
(2055, 'cd09850', NULL, 'Ebola-like_HR1-HR2', NULL, NULL, 'Ebola-like_HR1-HR2', 2055),
(2056, 'cd13225', NULL, 'PH-like_bacteria', NULL, NULL, 'PH-like_bacteria', 2056),
(2057, 'cd03003', NULL, 'PDI_a_ERdj5_N', NULL, NULL, 'PDI_a_ERdj5_N', 2057),
(2058, 'cd17031', NULL, 'T3SC_IA_SycN-like', NULL, NULL, 'T3SC_IA_SycN-like', 2058),
(2059, 'cd18733', NULL, 'PIN_RfVapC1-like', NULL, NULL, 'PIN_RfVapC1-like', 2059),
(2060, 'cd06968', NULL, 'NR_DBD_ROR', NULL, NULL, 'NR_DBD_ROR', 2060),
(2061, 'cd06836', NULL, 'PLPDE_III_ODC_DapDC_like_1', NULL, NULL, 'PLPDE_III_ODC_DapDC_like_1', 2061),
(2062, 'cd11690', NULL, 'Tsi2_like', NULL, NULL, 'Tsi2_like', 2062),
(2063, 'cd14948', NULL, 'BACON', NULL, NULL, 'BACON', 2063),
(2064, 'cd17652', NULL, 'A_NRPS_CmdD_like', NULL, NULL, 'A_NRPS_CmdD_like', 2064),
(2065, 'cd02236', NULL, 'cupin_CV2614-like', NULL, NULL, 'cupin_CV2614-like', 2065),
(2066, 'cd05111', NULL, 'PTK_HER3', NULL, NULL, 'PTK_HER3', 2066),
(2067, 'cd09083', NULL, 'EEP-1', NULL, NULL, 'EEP-1', 2067),
(2068, 'cd05610', NULL, 'STKc_MASTL', NULL, NULL, 'STKc_MASTL', 2068),
(2069, 'cd07504', NULL, 'HAD_5NT', NULL, NULL, 'HAD_5NT', 2069),
(2070, 'cd02335', NULL, 'ZZ_ADA2', NULL, NULL, 'ZZ_ADA2', 2070),
(2071, 'cd00673', NULL, 'AlaRS_core', NULL, NULL, 'AlaRS_core', 2071),
(2072, 'cd15148', NULL, '7tmA_GPR34-like', NULL, NULL, '7tmA_GPR34-like', 2072),
(2073, 'cd15757', NULL, 'FYVE_WDFY2', NULL, NULL, 'FYVE_WDFY2', 2073),
(2074, 'cd04745', NULL, 'LbH_paaY_like', NULL, NULL, 'LbH_paaY_like', 2074),
(2075, 'cd13383', NULL, 'PH_OCRL2', NULL, NULL, 'PH_OCRL2', 2075),
(2076, 'cd20219', NULL, 'PFM_physalysin-1-like', NULL, NULL, 'PFM_physalysin-1-like', 2076),
(2077, 'cd15506', NULL, 'PHD1_KMT2A_like', NULL, NULL, 'PHD1_KMT2A_like', 2077),
(2078, 'cd10974', NULL, 'CE4_CDA_like_1', NULL, NULL, 'CE4_CDA_like_1', 2078),
(2079, 'cd17409', NULL, 'MFS_NIMT_like', NULL, NULL, 'MFS_NIMT_like', 2079),
(2080, 'cd18774', NULL, 'PDC2_HK_sensor', NULL, NULL, 'PDC2_HK_sensor', 2080),
(2081, 'cd16143', NULL, 'ARS_like', NULL, NULL, 'ARS_like', 2081),
(2082, 'cd14653', NULL, 'ZIP_Gal4p-like', NULL, NULL, 'ZIP_Gal4p-like', 2082),
(2083, 'cd05059', NULL, 'PTKc_Tec_like', NULL, NULL, 'PTKc_Tec_like', 2083),
(2084, 'cd12127', NULL, 'PE-PC-PEC_beta', NULL, NULL, 'PE-PC-PEC_beta', 2084),
(2085, 'cd02413', NULL, '40S_S3_KH', NULL, NULL, '40S_S3_KH', 2085),
(2086, 'cd08717', NULL, 'RGS_RGS5', NULL, NULL, 'RGS_RGS5', 2086),
(2087, 'cd08445', NULL, 'PBP2_BenM_CatM_CatR', NULL, NULL, 'PBP2_BenM_CatM_CatR', 2087),
(2088, 'cd18548', NULL, 'ABC_6TM_Tm287_like', NULL, NULL, 'ABC_6TM_Tm287_like', 2088),
(2089, 'cd10466', NULL, 'FimH_man-bind', NULL, NULL, 'FimH_man-bind', 2089),
(2090, 'cd07112', NULL, 'ALDH_GABALDH-PuuC', NULL, NULL, 'ALDH_GABALDH-PuuC', 2090),
(2091, 'cd12046', NULL, 'SH3_p67phox_C', NULL, NULL, 'SH3_p67phox_C', 2091),
(2092, 'cd12157', NULL, 'PTDH', NULL, NULL, 'PTDH', 2092),
(2093, 'cd03184', NULL, 'GST_C_Omega', NULL, NULL, 'GST_C_Omega', 2093),
(2094, 'cd15301', NULL, '7tmA_mAChR_DM1-like', NULL, NULL, '7tmA_mAChR_DM1-like', 2094),
(2095, 'cd05115', NULL, 'PTKc_Zap-70', NULL, NULL, 'PTKc_Zap-70', 2095),
(2096, 'cd17902', NULL, 'ArfGap_ARAP3', NULL, NULL, 'ArfGap_ARAP3', 2096),
(2097, 'cd12442', NULL, 'RRM_RBM48', NULL, NULL, 'RRM_RBM48', 2097),
(2098, 'cd19379', NULL, 'TGF_beta_GSDF', NULL, NULL, 'TGF_beta_GSDF', 2098),
(2099, 'cd14194', NULL, 'STKc_DAPK1', NULL, NULL, 'STKc_DAPK1', 2099),
(2100, 'cd08154', NULL, 'catalase_clade_1', NULL, NULL, 'catalase_clade_1', 2100),
(2101, 'cd15368', NULL, '7tmA_P2Y8', NULL, NULL, '7tmA_P2Y8', 2101),
(2102, 'cd08799', NULL, 'Death_UNC5C', NULL, NULL, 'Death_UNC5C', 2102),
(2103, 'cd11023', NULL, 'CuRO_2_ceruloplasmin_like_2', NULL, NULL, 'CuRO_2_ceruloplasmin_like_2', 2103);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(2104, 'cd17374', NULL, 'MFS_OAT', NULL, NULL, 'MFS_OAT', 2104),
(2105, 'cd00384', NULL, 'ALAD_PBGS', NULL, NULL, 'ALAD_PBGS', 2105),
(2106, 'cd06881', NULL, 'PX_SNX15_like', NULL, NULL, 'PX_SNX15_like', 2106),
(2107, 'cd13676', NULL, 'PBP2_TRAP_DctP2_like', NULL, NULL, 'PBP2_TRAP_DctP2_like', 2107),
(2108, 'cd07474', NULL, 'Peptidases_S8_subtilisin_Vpr-like', NULL, NULL, 'Peptidases_S8_subtilisin_Vpr-like', 2108),
(2109, 'cd17248', NULL, 'RMtype1_S_AmiI-TRD2-CR2_like', NULL, NULL, 'RMtype1_S_AmiI-TRD2-CR2_like', 2109),
(2110, 'cd13183', NULL, 'FERM_C_FRMPD1_FRMPD3_FRMPD4', NULL, NULL, 'FERM_C_FRMPD1_FRMPD3_FRMPD4', 2110),
(2111, 'cd15771', NULL, 'FYVE1_BSN_PCLO', NULL, NULL, 'FYVE1_BSN_PCLO', 2111),
(2112, 'cd06243', NULL, 'M14_CP_Csd4-like', NULL, NULL, 'M14_CP_Csd4-like', 2112),
(2113, 'cd10334', NULL, 'SLC6sbd_u1', NULL, NULL, 'SLC6sbd_u1', 2113),
(2114, 'cd08879', NULL, 'RHO_alpha_C_AntDO-like', NULL, NULL, 'RHO_alpha_C_AntDO-like', 2114),
(2115, 'cd19356', NULL, 'Wnt_Wnt10b', NULL, NULL, 'Wnt_Wnt10b', 2115),
(2116, 'cd11522', NULL, 'SLC6sbd_SBAT1', NULL, NULL, 'SLC6sbd_SBAT1', 2116),
(2117, 'cd17809', NULL, 'HipA_So_like', NULL, NULL, 'HipA_So_like', 2117),
(2118, 'cd10051', NULL, 'Reelin_repeat_7_subrepeat_2', NULL, NULL, 'Reelin_repeat_7_subrepeat_2', 2118),
(2119, 'cd03137', NULL, 'GATase1_AraC_1', NULL, NULL, 'GATase1_AraC_1', 2119),
(2120, 'cd02035', NULL, 'ArsA', NULL, NULL, 'ArsA', 2120),
(2121, 'cd04460', NULL, 'S1_RpoE', NULL, NULL, 'S1_RpoE', 2121),
(2122, 'cd16443', NULL, 'LplA', NULL, NULL, 'LplA', 2122),
(2123, 'cd10378', NULL, 'SH2_Jak1', NULL, NULL, 'SH2_Jak1', 2123),
(2124, 'cd03005', NULL, 'PDI_a_ERp46', NULL, NULL, 'PDI_a_ERp46', 2124),
(2125, 'cd08866', NULL, 'SRPBCC_11', NULL, NULL, 'SRPBCC_11', 2125),
(2126, 'cd15282', NULL, '7tmC_CaSR', NULL, NULL, '7tmC_CaSR', 2126),
(2127, 'cd16308', NULL, 'GOB1-like_MBL-B3', NULL, NULL, 'GOB1-like_MBL-B3', 2127),
(2128, 'cd16506', NULL, 'RING-HC_DTX3_like', NULL, NULL, 'RING-HC_DTX3_like', 2128),
(2129, 'cd01894', NULL, 'EngA1', NULL, NULL, 'EngA1', 2129),
(2130, 'cd03682', NULL, 'ClC_sycA_like', NULL, NULL, 'ClC_sycA_like', 2130),
(2131, 'cd05743', NULL, 'Ig_Perlecan_like', NULL, NULL, 'Ig_Perlecan_like', 2131),
(2132, 'cd12605', NULL, 'RRM_RALYL', NULL, NULL, 'RRM_RALYL', 2132),
(2133, 'cd19031', NULL, 'LGIC_ECD_nAChR_proto_alpha-like', NULL, NULL, 'LGIC_ECD_nAChR_proto_alpha-like', 2133),
(2134, 'cd12371', NULL, 'RRM2_PUF60', NULL, NULL, 'RRM2_PUF60', 2134),
(2135, 'cd06907', NULL, 'M14_AGBL2-3_like', NULL, NULL, 'M14_AGBL2-3_like', 2135),
(2136, 'cd08055', NULL, 'gp15', NULL, NULL, 'gp15', 2136),
(2137, 'cd09949', NULL, 'RSV-like_HR1-HR2', NULL, NULL, 'RSV-like_HR1-HR2', 2137),
(2138, 'cd19430', NULL, 'lipocalin_trichosorin-like', NULL, NULL, 'lipocalin_trichosorin-like', 2138),
(2139, 'cd15138', NULL, '7tmA_LRR_GPR', NULL, NULL, '7tmA_LRR_GPR', 2139),
(2140, 'cd05688', NULL, 'S1_RPS1_repeat_ec3', NULL, NULL, 'S1_RPS1_repeat_ec3', 2140),
(2141, 'cd11919', NULL, 'SH3_Sorbs1_1', NULL, NULL, 'SH3_Sorbs1_1', 2141),
(2142, 'cd01730', NULL, 'LSm3', NULL, NULL, 'LSm3', 2142),
(2143, 'cd09494', NULL, 'SAM_liprin-kazrin_repeat1', NULL, NULL, 'SAM_liprin-kazrin_repeat1', 2143),
(2144, 'cd17341', NULL, 'MFS_NRT2_like', NULL, NULL, 'MFS_NRT2_like', 2144),
(2145, 'cd18982', NULL, 'CSD', NULL, NULL, 'CSD', 2145),
(2146, 'cd18738', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, 'PIN_VapC4-5_FitB-like', 2146),
(2147, 'cd09818', NULL, 'PIOX_like', NULL, NULL, 'PIOX_like', 2147),
(2148, 'cd01224', NULL, 'PH_Collybistin_ASEF', NULL, NULL, 'PH_Collybistin_ASEF', 2148),
(2149, 'cd05283', NULL, 'CAD1', NULL, NULL, 'CAD1', 2149),
(2150, 'cd08982', NULL, 'GH43-like', NULL, NULL, 'GH43-like', 2150),
(2151, 'cd17338', NULL, 'MFS_unc93_like', NULL, NULL, 'MFS_unc93_like', 2151),
(2152, 'cd04755', NULL, 'Commd7', NULL, NULL, 'Commd7', 2152),
(2153, 'cd11995', NULL, 'SH3_Intersectin1_5', NULL, NULL, 'SH3_Intersectin1_5', 2153),
(2154, 'cd16183', NULL, 'EFh_PEF_ALG-2', NULL, NULL, 'EFh_PEF_ALG-2', 2154),
(2155, 'cd11550', NULL, 'Serine_rich_NEDD9', NULL, NULL, 'Serine_rich_NEDD9', 2155);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(2156, 'cd03478', NULL, 'Rieske_AIFL_N', NULL, NULL, 'Rieske_AIFL_N', 2156),
(2157, 'cd15638', NULL, 'PHD_PHF3', NULL, NULL, 'PHD_PHF3', 2157),
(2158, 'cd12750', NULL, 'RRM5_RBM12B', NULL, NULL, 'RRM5_RBM12B', 2158),
(2159, 'cd08062', NULL, 'MPN_RPN7_8', NULL, NULL, 'MPN_RPN7_8', 2159),
(2160, 'cd16896', NULL, 'LT_Slt70-like', NULL, NULL, 'LT_Slt70-like', 2160),
(2161, 'cd00957', NULL, 'Transaldolase_TalAB', NULL, NULL, 'Transaldolase_TalAB', 2161),
(2162, 'cd15692', NULL, 'PHD1_DPF3', NULL, NULL, 'PHD1_DPF3', 2162),
(2163, 'cd01143', NULL, 'YvrC', NULL, NULL, 'YvrC', 2163),
(2164, 'cd05753', NULL, 'Ig2_FcgammaR_like', NULL, NULL, 'Ig2_FcgammaR_like', 2164),
(2165, 'cd15143', NULL, '7tmA_TXA2_R', NULL, NULL, '7tmA_TXA2_R', 2165),
(2166, 'cd17294', NULL, 'RMtype1_S_MmaC7ORF19P_TRD1-CR1_like', NULL, NULL, 'RMtype1_S_MmaC7ORF19P_TRD1-CR1_like', 2166),
(2167, 'cd03813', NULL, 'GT4-like', NULL, NULL, 'GT4-like', 2167),
(2168, 'cd11932', NULL, 'SH3_SH3RF2_2', NULL, NULL, 'SH3_SH3RF2_2', 2168),
(2169, 'cd04468', NULL, 'S1_eIF5A', NULL, NULL, 'S1_eIF5A', 2169),
(2170, 'cd19806', NULL, 'Bbox1_TRIM32_C-VII', NULL, NULL, 'Bbox1_TRIM32_C-VII', 2170),
(2171, 'cd00571', NULL, 'UreE', NULL, NULL, 'UreE', 2171),
(2172, 'cd17377', NULL, 'MFS_SLC22A15', NULL, NULL, 'MFS_SLC22A15', 2172),
(2173, 'cd13282', NULL, 'PH1_PLEKHH1_PLEKHH2', NULL, NULL, 'PH1_PLEKHH1_PLEKHH2', 2173),
(2174, 'cd18394', NULL, 'BTB_POZ_KCTD6', NULL, NULL, 'BTB_POZ_KCTD6', 2174),
(2175, 'cd12902', NULL, 'SPRY_PRY_RNF135', NULL, NULL, 'SPRY_PRY_RNF135', 2175),
(2176, 'cd14348', NULL, 'UBA_p47', NULL, NULL, 'UBA_p47', 2176),
(2177, 'cd11724', NULL, 'TP_methylase', NULL, NULL, 'TP_methylase', 2177),
(2178, 'cd14790', NULL, 'GH_D', NULL, NULL, 'GH_D', 2178),
(2179, 'cd10966', NULL, 'CE4_yadE_5s', NULL, NULL, 'CE4_yadE_5s', 2179),
(2180, 'cd12191', NULL, 'gal11_coact', NULL, NULL, 'gal11_coact', 2180),
(2181, 'cd13982', NULL, 'STKc_IRE1', NULL, NULL, 'STKc_IRE1', 2181),
(2182, 'cd17285', NULL, 'RMtype1_S_Csp16704I_TRD2-CR2_like', NULL, NULL, 'RMtype1_S_Csp16704I_TRD2-CR2_like', 2182),
(2183, 'cd11706', NULL, 'DHR2_DOCK2', NULL, NULL, 'DHR2_DOCK2', 2183),
(2184, 'cd15551', NULL, 'PHD_PYGO', NULL, NULL, 'PHD_PYGO', 2184),
(2185, 'cd19154', NULL, 'AKR_AKR1G1_CeAKR', NULL, NULL, 'AKR_AKR1G1_CeAKR', 2185),
(2186, 'cd09414', NULL, 'LIM1_LIMPETin', NULL, NULL, 'LIM1_LIMPETin', 2186),
(2187, 'cd14141', NULL, 'STKc_ACVR2a', NULL, NULL, 'STKc_ACVR2a', 2187),
(2188, 'cd10356', NULL, 'SH2_ShkA_ShkC', NULL, NULL, 'SH2_ShkA_ShkC', 2188),
(2189, 'cd16935', NULL, 'HATPase_AgrC-ComD-like', NULL, NULL, 'HATPase_AgrC-ComD-like', 2189),
(2190, 'cd10007', NULL, 'HDAC5', NULL, NULL, 'HDAC5', 2190),
(2191, 'cd04848', NULL, 'Peptidases_S8_Autotransporter_serine_protease_like', NULL, NULL, 'Peptidases_S8_Autotransporter_serine_protease_like', 2191),
(2192, 'cd13293', NULL, 'PH_CpORP2-like', NULL, NULL, 'PH_CpORP2-like', 2192),
(2193, 'cd05661', NULL, 'M28_like_PA', NULL, NULL, 'M28_like_PA', 2193),
(2194, 'cd06229', NULL, 'M14_Endopeptidase_I', NULL, NULL, 'M14_Endopeptidase_I', 2194),
(2195, 'cd17304', NULL, 'PIPKc_PIP5KL1', NULL, NULL, 'PIPKc_PIP5KL1', 2195),
(2196, 'cd18641', NULL, 'CBD_RBP1_like', NULL, NULL, 'CBD_RBP1_like', 2196),
(2197, 'cd11265', NULL, 'Sema_5C', NULL, NULL, 'Sema_5C', 2197),
(2198, 'cd06605', NULL, 'PKc_MAPKK', NULL, NULL, 'PKc_MAPKK', 2198),
(2199, 'cd00799', NULL, 'INT_Cre_C', NULL, NULL, 'INT_Cre_C', 2199),
(2200, 'cd03727', NULL, 'SOCS_ASB8', NULL, NULL, 'SOCS_ASB8', 2200),
(2201, 'cd00765', NULL, 'Pyrophosphate_PFK', NULL, NULL, 'Pyrophosphate_PFK', 2201),
(2202, 'cd03341', NULL, 'TCP1_theta', NULL, NULL, 'TCP1_theta', 2202),
(2203, 'cd01488', NULL, 'Uba3_RUB', NULL, NULL, 'Uba3_RUB', 2203),
(2204, 'cd10161', NULL, 'CsoR-like_DUF156_4', NULL, NULL, 'CsoR-like_DUF156_4', 2204),
(2205, 'cd04163', NULL, 'Era', NULL, NULL, 'Era', 2205),
(2206, 'cd05392', NULL, 'RasGAP_Neurofibromin_like', NULL, NULL, 'RasGAP_Neurofibromin_like', 2206),
(2207, 'cd14580', NULL, 'DUSP13A', NULL, NULL, 'DUSP13A', 2207),
(2208, 'cd18588', NULL, 'ABC_6TM_CyaB_HlyB_like', NULL, NULL, 'ABC_6TM_CyaB_HlyB_like', 2208);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(2209, 'cd09872', NULL, 'PIN_Sll0205-like', NULL, NULL, 'PIN_Sll0205-like', 2209),
(2210, 'cd11557', NULL, 'ST7', NULL, NULL, 'ST7', 2210),
(2211, 'cd06285', NULL, 'PBP1_LacI-like', NULL, NULL, 'PBP1_LacI-like', 2211),
(2212, 'cd06556', NULL, 'ICL_KPHMT', NULL, NULL, 'ICL_KPHMT', 2212),
(2213, 'cd16939', NULL, 'HATPase_RstB-like', NULL, NULL, 'HATPase_RstB-like', 2213),
(2214, 'cd11704', NULL, 'DHR2_DOCK3', NULL, NULL, 'DHR2_DOCK3', 2214),
(2215, 'cd15417', NULL, '7tmA_OR5A1-like', NULL, NULL, '7tmA_OR5A1-like', 2215),
(2216, 'cd13119', NULL, 'BF2867_like', NULL, NULL, 'BF2867_like', 2216),
(2217, 'cd01857', NULL, 'HSR1_MMR1', NULL, NULL, 'HSR1_MMR1', 2217),
(2218, 'cd02767', NULL, 'MopB_ydeP', NULL, NULL, 'MopB_ydeP', 2218),
(2219, 'cd04374', NULL, 'RhoGAP_Graf', NULL, NULL, 'RhoGAP_Graf', 2219),
(2220, 'cd14863', NULL, 'Fe-ADH-like', NULL, NULL, 'Fe-ADH-like', 2220),
(2221, 'cd01434', NULL, 'EFG_mtEFG1_IV', NULL, NULL, 'EFG_mtEFG1_IV', 2221),
(2222, 'cd07338', NULL, 'M48B_HtpX_like', NULL, NULL, 'M48B_HtpX_like', 2222),
(2223, 'cd17474', NULL, 'MFS_YfmO_like', NULL, NULL, 'MFS_YfmO_like', 2223),
(2224, 'cd10977', NULL, 'CE4_PuuE_SpCDA1', NULL, NULL, 'CE4_PuuE_SpCDA1', 2224),
(2225, 'cd01309', NULL, 'Met_dep_hydrolase_C', NULL, NULL, 'Met_dep_hydrolase_C', 2225),
(2226, 'cd17322', NULL, 'MFS_ARN_like', NULL, NULL, 'MFS_ARN_like', 2226),
(2227, 'cd16551', NULL, 'RING-HC_RNF169', NULL, NULL, 'RING-HC_RNF169', 2227),
(2228, 'cd20250', NULL, 'Phospholamban', NULL, NULL, 'Phospholamban', 2228),
(2229, 'cd08433', NULL, 'PBP2_Nac', NULL, NULL, 'PBP2_Nac', 2229),
(2230, 'cd14611', NULL, 'R-PTPc-R', NULL, NULL, 'R-PTPc-R', 2230),
(2231, 'cd00328', NULL, 'catalase', NULL, NULL, 'catalase', 2231),
(2232, 'cd05480', NULL, 'NRIP_C', NULL, NULL, 'NRIP_C', 2232),
(2233, 'cd04469', NULL, 'S1_Hex1', NULL, NULL, 'S1_Hex1', 2233),
(2234, 'cd03446', NULL, 'MaoC_like', NULL, NULL, 'MaoC_like', 2234),
(2235, 'cd10936', NULL, 'CE4_DAC2', NULL, NULL, 'CE4_DAC2', 2235),
(2236, 'cd10815', NULL, 'GH38N_AMII_EcMngB_like', NULL, NULL, 'GH38N_AMII_EcMngB_like', 2236),
(2237, 'cd19369', NULL, 'TenA_C-like', NULL, NULL, 'TenA_C-like', 2237),
(2238, 'cd01243', NULL, 'PH_MRCK', NULL, NULL, 'PH_MRCK', 2238),
(2239, 'cd14999', NULL, '7tmA_UII-R', NULL, NULL, '7tmA_UII-R', 2239),
(2240, 'cd17663', NULL, 'PFA-DSP_Oca6', NULL, NULL, 'PFA-DSP_Oca6', 2240),
(2241, 'cd05571', NULL, 'STKc_PKB', NULL, NULL, 'STKc_PKB', 2241),
(2242, 'cd02152', NULL, 'OAT', NULL, NULL, 'OAT', 2242),
(2243, 'cd15492', NULL, 'PHD_BRPF_JADE_like', NULL, NULL, 'PHD_BRPF_JADE_like', 2243),
(2244, 'cd17375', NULL, 'MFS_SLC22A16_CT2', NULL, NULL, 'MFS_SLC22A16_CT2', 2244),
(2245, 'cd01202', NULL, 'PTB_FRS2', NULL, NULL, 'PTB_FRS2', 2245),
(2246, 'cd15791', NULL, 'PH1_FDG4', NULL, NULL, 'PH1_FDG4', 2246),
(2247, 'cd17489', NULL, 'MFS_YfcJ_like', NULL, NULL, 'MFS_YfcJ_like', 2247),
(2248, 'cd18061', NULL, 'DEXHc_CHD9', NULL, NULL, 'DEXHc_CHD9', 2248),
(2249, 'cd17045', NULL, 'Ubl_TBCEL', NULL, NULL, 'Ubl_TBCEL', 2249),
(2250, 'cd14263', NULL, 'DAGK_IM_like', NULL, NULL, 'DAGK_IM_like', 2250),
(2251, 'cd07600', NULL, 'BAR_Gvp36', NULL, NULL, 'BAR_Gvp36', 2251),
(2252, 'cd18653', NULL, 'CD_HP1a_insect', NULL, NULL, 'CD_HP1a_insect', 2252),
(2253, 'cd20072', NULL, 'SET_SET1', NULL, NULL, 'SET_SET1', 2253),
(2254, 'cd16144', NULL, 'ARS_like', NULL, NULL, 'ARS_like', 2254),
(2255, 'cd05590', NULL, 'STKc_nPKC_eta', NULL, NULL, 'STKc_nPKC_eta', 2255),
(2256, 'cd13698', NULL, 'PBP2_HisGluGlnArgOpine', NULL, NULL, 'PBP2_HisGluGlnArgOpine', 2256),
(2257, 'cd19021', NULL, 'LGIC_ECD_nAChR_A7L', NULL, NULL, 'LGIC_ECD_nAChR_A7L', 2257),
(2258, 'cd03675', NULL, 'Nudix_Hydrolase_2', NULL, NULL, 'Nudix_Hydrolase_2', 2258),
(2259, 'cd15430', NULL, '7tmA_OR13-like', NULL, NULL, '7tmA_OR13-like', 2259),
(2260, 'cd01784', NULL, 'RA_RASSF2_like', NULL, NULL, 'RA_RASSF2_like', 2260),
(2261, 'cd04928', NULL, 'ACT_TyrKc', NULL, NULL, 'ACT_TyrKc', 2261),
(2262, 'cd17357', NULL, 'MFS_GLUT_Class1_2_like', NULL, NULL, 'MFS_GLUT_Class1_2_like', 2262),
(2263, 'cd18052', NULL, 'DEADc_DDX4', NULL, NULL, 'DEADc_DDX4', 2263);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(2264, 'cd15908', NULL, '7tm_TAS2R40-like', NULL, NULL, '7tm_TAS2R40-like', 2264),
(2265, 'cd01830', NULL, 'XynE_like', NULL, NULL, 'XynE_like', 2265),
(2266, 'cd08349', NULL, 'BLMA_like', NULL, NULL, 'BLMA_like', 2266),
(2267, 'cd12213', NULL, 'ABD', NULL, NULL, 'ABD', 2267),
(2268, 'cd04453', NULL, 'S1_RNase_E', NULL, NULL, 'S1_RNase_E', 2268),
(2269, 'cd14808', NULL, 'RAP_D3', NULL, NULL, 'RAP_D3', 2269),
(2270, 'cd18200', NULL, 'BTB_POZ_ZBTB9', NULL, NULL, 'BTB_POZ_ZBTB9', 2270),
(2271, 'cd19704', NULL, 'bHLH_TS_TCF21_capsulin', NULL, NULL, 'bHLH_TS_TCF21_capsulin', 2271),
(2272, 'cd05070', NULL, 'PTKc_Fyn', NULL, NULL, 'PTKc_Fyn', 2272),
(2273, 'cd09479', NULL, 'LIM1_CRP1', NULL, NULL, 'LIM1_CRP1', 2273),
(2274, 'cd10486', NULL, 'EphR_LBD_A8', NULL, NULL, 'EphR_LBD_A8', 2274),
(2275, 'cd15327', NULL, '7tmA_alpha1D_AR', NULL, NULL, '7tmA_alpha1D_AR', 2275),
(2276, 'cd11937', NULL, 'SH3_UBASH3A', NULL, NULL, 'SH3_UBASH3A', 2276),
(2277, 'cd03672', NULL, 'Dcp2p', NULL, NULL, 'Dcp2p', 2277),
(2278, 'cd13357', NULL, 'PH-GRAM_MTMR2_insect-like', NULL, NULL, 'PH-GRAM_MTMR2_insect-like', 2278),
(2279, 'cd06447', NULL, 'D-Ser-dehyd', NULL, NULL, 'D-Ser-dehyd', 2279),
(2280, 'cd10528', NULL, 'SET_SETD8', NULL, NULL, 'SET_SETD8', 2280),
(2281, 'cd08058', NULL, 'MPN_euk_mb', NULL, NULL, 'MPN_euk_mb', 2281),
(2282, 'cd06096', NULL, 'Plasmepsin_5', NULL, NULL, 'Plasmepsin_5', 2282),
(2283, 'cd11796', NULL, 'SH3_DNMBP_N3', NULL, NULL, 'SH3_DNMBP_N3', 2283),
(2284, 'cd03776', NULL, 'MATH_TRAF6', NULL, NULL, 'MATH_TRAF6', 2284),
(2285, 'cd11246', NULL, 'Sema_plexin_C1', NULL, NULL, 'Sema_plexin_C1', 2285),
(2286, 'cd13142', NULL, 'MATE_like_12', NULL, NULL, 'MATE_like_12', 2286),
(2287, 'cd14038', NULL, 'STKc_IKK_beta', NULL, NULL, 'STKc_IKK_beta', 2287),
(2288, 'cd02145', NULL, 'BluB', NULL, NULL, 'BluB', 2288),
(2289, 'cd10357', NULL, 'SH2_ShkD_ShkE', NULL, NULL, 'SH2_ShkD_ShkE', 2289),
(2290, 'cd11510', NULL, 'SLC6sbd_TauT', NULL, NULL, 'SLC6sbd_TauT', 2290),
(2291, 'cd05597', NULL, 'STKc_DMPK_like', NULL, NULL, 'STKc_DMPK_like', 2291),
(2292, 'cd09449', NULL, 'LIM_Mystique', NULL, NULL, 'LIM_Mystique', 2292),
(2293, 'cd11332', NULL, 'AmyAc_OligoGlu_TS', NULL, NULL, 'AmyAc_OligoGlu_TS', 2293),
(2294, 'cd15266', NULL, '7tmB1_GLP2R', NULL, NULL, '7tmB1_GLP2R', 2294),
(2295, 'cd08567', NULL, 'GDPD_SpGDE_like', NULL, NULL, 'GDPD_SpGDE_like', 2295),
(2296, 'cd06456', NULL, 'M3A_DCP', NULL, NULL, 'M3A_DCP', 2296),
(2297, 'cd15358', NULL, '7tmA_NMU-R1', NULL, NULL, '7tmA_NMU-R1', 2297),
(2298, 'cd17947', NULL, 'DEADc_DDX27', NULL, NULL, 'DEADc_DDX27', 2298),
(2299, 'cd12176', NULL, 'PGDH_3', NULL, NULL, 'PGDH_3', 2299),
(2300, 'cd01265', NULL, 'PH_TBC1D2A', NULL, NULL, 'PH_TBC1D2A', 2300),
(2301, 'cd01913', NULL, 'protease_HslV', NULL, NULL, 'protease_HslV', 2301),
(2302, 'cd15895', NULL, 'SNARE_SNAP23N', NULL, NULL, 'SNARE_SNAP23N', 2302),
(2303, 'cd04699', NULL, 'Nudix_Hydrolase_39', NULL, NULL, 'Nudix_Hydrolase_39', 2303),
(2304, 'cd08707', NULL, 'RGS_Axin', NULL, NULL, 'RGS_Axin', 2304),
(2305, 'cd14026', NULL, 'STKc_RIP2', NULL, NULL, 'STKc_RIP2', 2305),
(2306, 'cd00986', NULL, 'PDZ_LON_protease', NULL, NULL, 'PDZ_LON_protease', 2306),
(2307, 'cd00497', NULL, 'PseudoU_synth_TruA_like', NULL, NULL, 'PseudoU_synth_TruA_like', 2307),
(2308, 'cd00738', NULL, 'HGTP_anticodon', NULL, NULL, 'HGTP_anticodon', 2308),
(2309, 'cd18067', NULL, 'DEXHc_RAD54A', NULL, NULL, 'DEXHc_RAD54A', 2309),
(2310, 'cd09422', NULL, 'LIM1_FHL2', NULL, NULL, 'LIM1_FHL2', 2310),
(2311, 'cd20493', NULL, 'M34_ATLF_C-like', NULL, NULL, 'M34_ATLF_C-like', 2311),
(2312, 'cd09640', NULL, 'Cas7_I-C', NULL, NULL, 'Cas7_I-C', 2312),
(2313, 'cd04870', NULL, 'ACT_PSP_1', NULL, NULL, 'ACT_PSP_1', 2313),
(2314, 'cd08887', NULL, 'RHO_alpha_C_3', NULL, NULL, 'RHO_alpha_C_3', 2314),
(2315, 'cd04108', NULL, 'Rab36_Rab34', NULL, NULL, 'Rab36_Rab34', 2315),
(2316, 'cd09215', NULL, 'Thaumatin-like', NULL, NULL, 'Thaumatin-like', 2316),
(2317, 'cd00667', NULL, 'ring_hydroxylating_dioxygenases_beta', NULL, NULL, 'ring_hydroxylating_dioxygenases_beta', 2317);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(2318, 'cd11873', NULL, 'SH3_CD2AP-like_1', NULL, NULL, 'SH3_CD2AP-like_1', 2318),
(2319, 'cd14556', NULL, 'R-PTPc-typeIIb-2', NULL, NULL, 'R-PTPc-typeIIb-2', 2319),
(2320, 'cd08589', NULL, 'PI-PLCc_SaPLC1_like', NULL, NULL, 'PI-PLCc_SaPLC1_like', 2320),
(2321, 'cd04509', NULL, 'PBP1_ABC_transporter_GPCR_C-like', NULL, NULL, 'PBP1_ABC_transporter_GPCR_C-like', 2321),
(2322, 'cd06425', NULL, 'M1P_guanylylT_B_like_N', NULL, NULL, 'M1P_guanylylT_B_like_N', 2322),
(2323, 'cd01170', NULL, 'THZ_kinase', NULL, NULL, 'THZ_kinase', 2323),
(2324, 'cd07487', NULL, 'Peptidases_S8_1', NULL, NULL, 'Peptidases_S8_1', 2324),
(2325, 'cd05900', NULL, 'Ig_Aggrecan', NULL, NULL, 'Ig_Aggrecan', 2325),
(2326, 'cd06176', NULL, 'MFS_BCD_PucC-like', NULL, NULL, 'MFS_BCD_PucC-like', 2326),
(2327, 'cd21661', NULL, 'merbe_CoV_ORF8b-like', NULL, NULL, 'merbe_CoV_ORF8b-like', 2327),
(2328, 'cd02435', NULL, 'CCC1', NULL, NULL, 'CCC1', 2328),
(2329, 'cd08953', NULL, 'KR_2_SDR_x', NULL, NULL, 'KR_2_SDR_x', 2329),
(2330, 'cd14398', NULL, 'UBA_LATS2', NULL, NULL, 'UBA_LATS2', 2330),
(2331, 'cd00907', NULL, 'Bacterioferritin', NULL, NULL, 'Bacterioferritin', 2331),
(2332, 'cd03026', NULL, 'AhpF_NTD_C', NULL, NULL, 'AhpF_NTD_C', 2332),
(2333, 'cd17252', NULL, 'RMtype1_S_EcoKI-TRD1-CR1_like', NULL, NULL, 'RMtype1_S_EcoKI-TRD1-CR1_like', 2333),
(2334, 'cd05026', NULL, 'S-100Z', NULL, NULL, 'S-100Z', 2334),
(2335, 'cd07726', NULL, 'ST1585-like_MBL-fold', NULL, NULL, 'ST1585-like_MBL-fold', 2335),
(2336, 'cd18494', NULL, 'BACK_BTBD19', NULL, NULL, 'BACK_BTBD19', 2336),
(2337, 'cd14217', NULL, 'STKc_SRPK2', NULL, NULL, 'STKc_SRPK2', 2337),
(2338, 'cd00505', NULL, 'Glyco_transf_8', NULL, NULL, 'Glyco_transf_8', 2338),
(2339, 'cd00040', NULL, 'CSF2', NULL, NULL, 'CSF2', 2339),
(2340, 'cd07475', NULL, 'Peptidases_S8_C5a_Peptidase', NULL, NULL, 'Peptidases_S8_C5a_Peptidase', 2340),
(2341, 'cd01798', NULL, 'Ubl_parkin', NULL, NULL, 'Ubl_parkin', 2341),
(2342, 'cd14139', NULL, 'PTKc_Wee1b', NULL, NULL, 'PTKc_Wee1b', 2342),
(2343, 'cd15237', NULL, '7tmA_OR2-like', NULL, NULL, '7tmA_OR2-like', 2343),
(2344, 'cd18022', NULL, 'DEXHc_ASCC3_2', NULL, NULL, 'DEXHc_ASCC3_2', 2344),
(2345, 'cd13302', NULL, 'PH2_Pleckstrin_2', NULL, NULL, 'PH2_Pleckstrin_2', 2345),
(2346, 'cd19574', NULL, 'serpinE3', NULL, NULL, 'serpinE3', 2346),
(2347, 'cd12171', NULL, '2-Hacid_dh_10', NULL, NULL, '2-Hacid_dh_10', 2347),
(2348, 'cd20220', NULL, 'PFM_natterin-3-like', NULL, NULL, 'PFM_natterin-3-like', 2348),
(2349, 'sd00031', NULL, 'LRR_1', NULL, NULL, 'LRR_1', 2349),
(2350, 'cd07597', NULL, 'BAR_SNX8', NULL, NULL, 'BAR_SNX8', 2350),
(2351, 'cd16996', NULL, 'VHS_Tom1L2', NULL, NULL, 'VHS_Tom1L2', 2351),
(2352, 'cd04716', NULL, 'BAH_plantDCM_I', NULL, NULL, 'BAH_plantDCM_I', 2352),
(2353, 'cd11884', NULL, 'SH3_MYO15', NULL, NULL, 'SH3_MYO15', 2353),
(2354, 'cd17243', NULL, 'RMtype1_S_AchA6I-TRD2-CR2_like', NULL, NULL, 'RMtype1_S_AchA6I-TRD2-CR2_like', 2354),
(2355, 'cd18820', NULL, 'GH43_LbAraf43-like', NULL, NULL, 'GH43_LbAraf43-like', 2355),
(2356, 'cd13375', NULL, 'PH_SynGAP', NULL, NULL, 'PH_SynGAP', 2356),
(2357, 'cd18354', NULL, 'BTB_POZ_RCBTB2_CHC1L', NULL, NULL, 'BTB_POZ_RCBTB2_CHC1L', 2357),
(2358, 'cd18949', NULL, 'bHLH-PAS_NCoA3_SRC3', NULL, NULL, 'bHLH-PAS_NCoA3_SRC3', 2358),
(2359, 'cd12422', NULL, 'RRM2_PTBP1_hnRNPL_like', NULL, NULL, 'RRM2_PTBP1_hnRNPL_like', 2359),
(2360, 'cd15342', NULL, '7tmA_LPAR2_Edg4', NULL, NULL, '7tmA_LPAR2_Edg4', 2360),
(2361, 'cd16883', NULL, 'ARID_ARID4B', NULL, NULL, 'ARID_ARID4B', 2361),
(2362, 'cd19964', NULL, 'PBP1_BMP-like', NULL, NULL, 'PBP1_BMP-like', 2362),
(2363, 'cd19217', NULL, 'SET_EZH1', NULL, NULL, 'SET_EZH1', 2363),
(2364, 'cd09910', NULL, 'NGN-insert_like', NULL, NULL, 'NGN-insert_like', 2364),
(2365, 'cd00123', NULL, 'DmpA_OAT', NULL, NULL, 'DmpA_OAT', 2365),
(2366, 'cd18583', NULL, 'ABC_6TM_HMT1', NULL, NULL, 'ABC_6TM_HMT1', 2366),
(2367, 'cd01570', NULL, 'NAPRTase_A', NULL, NULL, 'NAPRTase_A', 2367),
(2368, 'cd16740', NULL, 'RING-HC_RING2', NULL, NULL, 'RING-HC_RING2', 2368),
(2369, 'cd06313', NULL, 'PBP1_ABC_ThpA_XypA', NULL, NULL, 'PBP1_ABC_ThpA_XypA', 2369);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(2370, 'cd21560', NULL, 'betaCoV-Nsp6', NULL, NULL, 'betaCoV-Nsp6', 2370),
(2371, 'cd13417', NULL, 'TNFRSF18', NULL, NULL, 'TNFRSF18', 2371),
(2372, 'cd16106', NULL, 'Ubl_Dsk2p_like', NULL, NULL, 'Ubl_Dsk2p_like', 2372),
(2373, 'cd06495', NULL, 'p23_NUDCD3_like', NULL, NULL, 'p23_NUDCD3_like', 2373),
(2374, 'cd02554', NULL, 'PseudoU_synth_RluF', NULL, NULL, 'PseudoU_synth_RluF', 2374),
(2375, 'cd18449', NULL, 'BACK_KLHL9_13', NULL, NULL, 'BACK_KLHL9_13', 2375),
(2376, 'cd07239', NULL, 'BphC5-RK37_C_like', NULL, NULL, 'BphC5-RK37_C_like', 2376),
(2377, 'cd15321', NULL, '7tmA_alpha2B_AR', NULL, NULL, '7tmA_alpha2B_AR', 2377),
(2378, 'cd05110', NULL, 'PTKc_HER4', NULL, NULL, 'PTKc_HER4', 2378),
(2379, 'cd13255', NULL, 'PH_TAAP2-like', NULL, NULL, 'PH_TAAP2-like', 2379),
(2380, 'cd13765', NULL, 'TGF_beta_ADMP', NULL, NULL, 'TGF_beta_ADMP', 2380),
(2381, 'cd00997', NULL, 'PBP2_GluR0', NULL, NULL, 'PBP2_GluR0', 2381),
(2382, 'cd03264', NULL, 'ABC_drug_resistance_like', NULL, NULL, 'ABC_drug_resistance_like', 2382),
(2383, 'cd16871', NULL, 'ARID_Swi1p-like', NULL, NULL, 'ARID_Swi1p-like', 2383),
(2384, 'cd02953', NULL, 'DsbDgamma', NULL, NULL, 'DsbDgamma', 2384),
(2385, 'cd13691', NULL, 'PBP2_Peb1a_like', NULL, NULL, 'PBP2_Peb1a_like', 2385),
(2386, 'cd11297', NULL, 'PIN_LabA-like_N_1', NULL, NULL, 'PIN_LabA-like_N_1', 2386),
(2387, 'cd12064', NULL, 'SH3_GRAF', NULL, NULL, 'SH3_GRAF', 2387),
(2388, 'cd19808', NULL, 'Bbox1_TRIM42_C-III', NULL, NULL, 'Bbox1_TRIM42_C-III', 2388),
(2389, 'cd01062', NULL, 'RNase_T2_prok', NULL, NULL, 'RNase_T2_prok', 2389),
(2390, 'cd12346', NULL, 'RRM3_NGR1_NAM8_like', NULL, NULL, 'RRM3_NGR1_NAM8_like', 2390),
(2391, 'cd00333', NULL, 'MIP', NULL, NULL, 'MIP', 2391),
(2392, 'cd18980', NULL, 'CD_NC-like', NULL, NULL, 'CD_NC-like', 2392),
(2393, 'cd14886', NULL, 'MYSc_Myo25', NULL, NULL, 'MYSc_Myo25', 2393),
(2394, 'cd14919', NULL, 'MYSc_Myh9', NULL, NULL, 'MYSc_Myh9', 2394),
(2395, 'cd08289', NULL, 'MDR_yhfp_like', NULL, NULL, 'MDR_yhfp_like', 2395),
(2396, 'cd09340', NULL, 'LIM1_Testin_like', NULL, NULL, 'LIM1_Testin_like', 2396),
(2397, 'cd00398', NULL, 'Aldolase_II', NULL, NULL, 'Aldolase_II', 2397),
(2398, 'cd11654', NULL, 'TRF2_RBM', NULL, NULL, 'TRF2_RBM', 2398),
(2399, 'cd18781', NULL, 'ABC_6TM_AarD_CydDC_like', NULL, NULL, 'ABC_6TM_AarD_CydDC_like', 2399),
(2400, 'cd07949', NULL, 'PCA_45_Doxase_B_like_1', NULL, NULL, 'PCA_45_Doxase_B_like_1', 2400),
(2401, 'cd06615', NULL, 'PKc_MEK', NULL, NULL, 'PKc_MEK', 2401),
(2402, 'cd14089', NULL, 'STKc_MAPKAPK', NULL, NULL, 'STKc_MAPKAPK', 2402),
(2403, 'cd09410', NULL, 'LIM3_Leupaxin', NULL, NULL, 'LIM3_Leupaxin', 2403),
(2404, 'cd00829', NULL, 'SCP-x_thiolase', NULL, NULL, 'SCP-x_thiolase', 2404),
(2405, 'cd17976', NULL, 'DEXHc_DHX30', NULL, NULL, 'DEXHc_DHX30', 2405),
(2406, 'cd05888', NULL, 'Ig1_Nectin-4_like', NULL, NULL, 'Ig1_Nectin-4_like', 2406),
(2407, 'cd20184', NULL, 'M34_peptidase_like', NULL, NULL, 'M34_peptidase_like', 2407),
(2408, 'cd18919', NULL, 'bHLH_AtBPE_like', NULL, NULL, 'bHLH_AtBPE_like', 2408),
(2409, 'cd15571', NULL, 'ePHD', NULL, NULL, 'ePHD', 2409),
(2410, 'cd04686', NULL, 'Nudix_Hydrolase_27', NULL, NULL, 'Nudix_Hydrolase_27', 2410),
(2411, 'cd03284', NULL, 'ABC_MutS1', NULL, NULL, 'ABC_MutS1', 2411),
(2412, 'cd19980', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, 'PBP1_ABC_ligand_binding-like', 2412),
(2413, 'cd13670', NULL, 'PBP2_TRAP_Tp0957_like', NULL, NULL, 'PBP2_TRAP_Tp0957_like', 2413),
(2414, 'cd15484', NULL, 'uS7_plant', NULL, NULL, 'uS7_plant', 2414),
(2415, 'cd04463', NULL, 'S1_EF_like', NULL, NULL, 'S1_EF_like', 2415),
(2416, 'cd16285', NULL, 'MBL-B1', NULL, NULL, 'MBL-B1', 2416),
(2417, 'cd05668', NULL, 'M20_Acy1-like', NULL, NULL, 'M20_Acy1-like', 2417),
(2418, 'cd16436', NULL, 'beta_Kdo_transferase', NULL, NULL, 'beta_Kdo_transferase', 2418),
(2419, 'cd07340', NULL, 'M48B_Htpx_like', NULL, NULL, 'M48B_Htpx_like', 2419),
(2420, 'cd00840', NULL, 'MPP_Mre11_N', NULL, NULL, 'MPP_Mre11_N', 2420),
(2421, 'cd07170', NULL, 'NR_DBD_ERR', NULL, NULL, 'NR_DBD_ERR', 2421),
(2422, 'cd06437', NULL, 'CESA_CaSu_A2', NULL, NULL, 'CESA_CaSu_A2', 2422);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(2423, 'cd13876', NULL, 'CuRO_2_Abr2_like', NULL, NULL, 'CuRO_2_Abr2_like', 2423),
(2424, 'cd16256', NULL, 'LumP', NULL, NULL, 'LumP', 2424),
(2425, 'cd10483', NULL, 'EphR_LBD_A5', NULL, NULL, 'EphR_LBD_A5', 2425),
(2426, 'cd15958', NULL, '7tmA_Beta1_AR', NULL, NULL, '7tmA_Beta1_AR', 2426),
(2427, 'cd06094', NULL, 'RP_Saci_like', NULL, NULL, 'RP_Saci_like', 2427),
(2428, 'cd13660', NULL, 'PBP2_PotD', NULL, NULL, 'PBP2_PotD', 2428),
(2429, 'cd01846', NULL, 'fatty_acyltransferase_like', NULL, NULL, 'fatty_acyltransferase_like', 2429),
(2430, 'cd03352', NULL, 'LbH_LpxD', NULL, NULL, 'LbH_LpxD', 2430),
(2431, 'cd12712', NULL, 'RRM_TNRC6B', NULL, NULL, 'RRM_TNRC6B', 2431),
(2432, 'cd03716', NULL, 'SOCS_ASB_like', NULL, NULL, 'SOCS_ASB_like', 2432),
(2433, 'cd09325', NULL, 'TDT_C4-dicarb_trans', NULL, NULL, 'TDT_C4-dicarb_trans', 2433),
(2434, 'cd01939', NULL, 'Ketohexokinase', NULL, NULL, 'Ketohexokinase', 2434),
(2435, 'cd05803', NULL, 'PGM_like4', NULL, NULL, 'PGM_like4', 2435),
(2436, 'cd16799', NULL, 'RING-H2_ZNRF3', NULL, NULL, 'RING-H2_ZNRF3', 2436),
(2437, 'cd00496', NULL, 'PheRS_alpha_core', NULL, NULL, 'PheRS_alpha_core', 2437),
(2438, 'cd01180', NULL, 'IPT_plexin_repeat1', NULL, NULL, 'IPT_plexin_repeat1', 2438),
(2439, 'cd00580', NULL, 'CHMI', NULL, NULL, 'CHMI', 2439),
(2440, 'cd11547', NULL, 'NTP-PPase_HisE', NULL, NULL, 'NTP-PPase_HisE', 2440),
(2441, 'cd19187', NULL, 'PR-SET_PRDM1', NULL, NULL, 'PR-SET_PRDM1', 2441),
(2442, 'cd15992', NULL, '7tmB2_CELSR2', NULL, NULL, '7tmB2_CELSR2', 2442),
(2443, 'cd14295', NULL, 'UBA1_atUBP14', NULL, NULL, 'UBA1_atUBP14', 2443),
(2444, 'cd15390', NULL, '7tmA_TACR', NULL, NULL, '7tmA_TACR', 2444),
(2445, 'cd03376', NULL, 'TPP_PFOR_porB_like', NULL, NULL, 'TPP_PFOR_porB_like', 2445),
(2446, 'cd09966', NULL, 'UP_III_II', NULL, NULL, 'UP_III_II', 2446),
(2447, 'cd16652', NULL, 'dRing_Rmd5p_like', NULL, NULL, 'dRing_Rmd5p_like', 2447),
(2448, 'cd17517', NULL, 'RMtype1_S_EcoKI_StySPI-TRD2-CR2_like', NULL, NULL, 'RMtype1_S_EcoKI_StySPI-TRD2-CR2_like', 2448),
(2449, 'cd02234', NULL, 'cupin_BLR7677-like', NULL, NULL, 'cupin_BLR7677-like', 2449),
(2450, 'cd12118', NULL, 'ttLC_FACS_AEE21_like', NULL, NULL, 'ttLC_FACS_AEE21_like', 2450),
(2451, 'cd09363', NULL, 'LIM3_Enigma_like', NULL, NULL, 'LIM3_Enigma_like', 2451),
(2452, 'cd05843', NULL, 'Peptidase_M48_M56', NULL, NULL, 'Peptidase_M48_M56', 2452),
(2453, 'cd09895', NULL, 'NGN_SP_UpxY', NULL, NULL, 'NGN_SP_UpxY', 2453),
(2454, 'cd14916', NULL, 'MYSc_Myh6', NULL, NULL, 'MYSc_Myh6', 2454),
(2455, 'cd18326', NULL, 'BTB_POZ_ZBTB7A', NULL, NULL, 'BTB_POZ_ZBTB7A', 2455),
(2456, 'cd19717', NULL, 'bHLH_TS_NGN2_ATOH4', NULL, NULL, 'bHLH_TS_NGN2_ATOH4', 2456),
(2457, 'cd12782', NULL, 'RRM2_PTBP1', NULL, NULL, 'RRM2_PTBP1', 2457),
(2458, 'cd06385', NULL, 'PBP1_NPR_A', NULL, NULL, 'PBP1_NPR_A', 2458),
(2459, 'cd12224', NULL, 'RRM_RBM22', NULL, NULL, 'RRM_RBM22', 2459),
(2460, 'cd12192', NULL, 'GCN4_cent', NULL, NULL, 'GCN4_cent', 2460),
(2461, 'cd04150', NULL, 'Arf1_5_like', NULL, NULL, 'Arf1_5_like', 2461),
(2462, 'cd07998', NULL, 'WGR_DNA_ligase', NULL, NULL, 'WGR_DNA_ligase', 2462),
(2463, 'cd07328', NULL, 'M48_Ste24p_like', NULL, NULL, 'M48_Ste24p_like', 2463),
(2464, 'cd17924', NULL, 'DDXDc_reverse_gyrase', NULL, NULL, 'DDXDc_reverse_gyrase', 2464),
(2465, 'cd08023', NULL, 'GH16_laminarinase_like', NULL, NULL, 'GH16_laminarinase_like', 2465),
(2466, 'cd01021', NULL, 'GEWL', NULL, NULL, 'GEWL', 2466),
(2467, 'cd14883', NULL, 'MYSc_Myo22', NULL, NULL, 'MYSc_Myo22', 2467),
(2468, 'cd07636', NULL, 'BAR_GRAF', NULL, NULL, 'BAR_GRAF', 2468),
(2469, 'cd02132', NULL, 'PA_GO-like', NULL, NULL, 'PA_GO-like', 2469),
(2470, 'cd14344', NULL, 'UBA_TYDP2', NULL, NULL, 'UBA_TYDP2', 2470),
(2471, 'cd06926', NULL, 'RNAP_II_RPB11', NULL, NULL, 'RNAP_II_RPB11', 2471),
(2472, 'cd17669', NULL, 'R-PTP-Z-2', NULL, NULL, 'R-PTP-Z-2', 2472),
(2473, 'cd01241', NULL, 'PH_PKB', NULL, NULL, 'PH_PKB', 2473),
(2474, 'cd01399', NULL, 'GlcN6P_deaminase', NULL, NULL, 'GlcN6P_deaminase', 2474),
(2475, 'cd02568', NULL, 'PseudoU_synth_PUS1_PUS2', NULL, NULL, 'PseudoU_synth_PUS1_PUS2', 2475);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(2476, 'cd20275', NULL, 'Sarcolamban_B', NULL, NULL, 'Sarcolamban_B', 2476),
(2477, 'cd02015', NULL, 'TPP_AHAS', NULL, NULL, 'TPP_AHAS', 2477),
(2478, 'cd18545', NULL, 'ABC_6TM_YknV_like', NULL, NULL, 'ABC_6TM_YknV_like', 2478),
(2479, 'cd16253', NULL, 'EFh_parvalbumins', NULL, NULL, 'EFh_parvalbumins', 2479),
(2480, 'cd09333', NULL, 'LIM3_PINCH', NULL, NULL, 'LIM3_PINCH', 2480),
(2481, 'cd01390', NULL, 'HMGB-UBF_HMG-box', NULL, NULL, 'HMGB-UBF_HMG-box', 2481),
(2482, 'cd01765', NULL, 'FERM_F0_F1', NULL, NULL, 'FERM_F0_F1', 2482),
(2483, 'cd01072', NULL, 'PBP2_SMa0082_like', NULL, NULL, 'PBP2_SMa0082_like', 2483),
(2484, 'cd04683', NULL, 'Nudix_Hydrolase_24', NULL, NULL, 'Nudix_Hydrolase_24', 2484),
(2485, 'cd08713', NULL, 'RGS_RGS3', NULL, NULL, 'RGS_RGS3', 2485),
(2486, 'cd18095', NULL, 'SpoU-like_rRNA-MTase', NULL, NULL, 'SpoU-like_rRNA-MTase', 2486),
(2487, 'cd14588', NULL, 'PTP-MTMR5', NULL, NULL, 'PTP-MTMR5', 2487),
(2488, 'cd00030', NULL, 'C2', NULL, NULL, 'C2', 2488),
(2489, 'cd09476', NULL, 'LIM1_TLP', NULL, NULL, 'LIM1_TLP', 2489),
(2490, 'cd14608', NULL, 'PTPc-N1', NULL, NULL, 'PTPc-N1', 2490),
(2491, 'cd06499', NULL, 'GT_MraY-like', NULL, NULL, 'GT_MraY-like', 2491),
(2492, 'cd17511', NULL, 'YbjN_AmyR-like', NULL, NULL, 'YbjN_AmyR-like', 2492),
(2493, 'cd01264', NULL, 'PH_MELT_VEPH1', NULL, NULL, 'PH_MELT_VEPH1', 2493),
(2494, 'cd07316', NULL, 'terB_like_DjlA', NULL, NULL, 'terB_like_DjlA', 2494),
(2495, 'cd15318', NULL, '7tmA_TAAR5', NULL, NULL, '7tmA_TAAR5', 2495),
(2496, 'cd18213', NULL, 'BTB_POZ_ZBTB25_ZNF46_KUP', NULL, NULL, 'BTB_POZ_ZBTB25_ZNF46_KUP', 2496),
(2497, 'cd01782', NULL, 'RA1_Afadin', NULL, NULL, 'RA1_Afadin', 2497),
(2498, 'cd14167', NULL, 'STKc_CaMKI_alpha', NULL, NULL, 'STKc_CaMKI_alpha', 2498),
(2499, 'cd00704', NULL, 'MDH', NULL, NULL, 'MDH', 2499),
(2500, 'cd09216', NULL, 'GH64-LPHase-like', NULL, NULL, 'GH64-LPHase-like', 2500),
(2501, 'cd14010', NULL, 'STKc_ULK4', NULL, NULL, 'STKc_ULK4', 2501),
(2502, 'cd05212', NULL, 'NAD_bind_m-THF_DH_Cyclohyd_like', NULL, NULL, 'NAD_bind_m-THF_DH_Cyclohyd_like', 2502),
(2503, 'cd08628', NULL, 'PI-PLCc_gamma2', NULL, NULL, 'PI-PLCc_gamma2', 2503),
(2504, 'cd16665', NULL, 'RING-H2_RNF13_like', NULL, NULL, 'RING-H2_RNF13_like', 2504),
(2505, 'cd08568', NULL, 'GDPD_TmGDE_like', NULL, NULL, 'GDPD_TmGDE_like', 2505),
(2506, 'cd07782', NULL, 'FGGY_YpCarbK_like', NULL, NULL, 'FGGY_YpCarbK_like', 2506),
(2507, 'cd11891', NULL, 'MIAL', NULL, NULL, 'MIAL', 2507),
(2508, 'cd17593', NULL, 'REC_CheC-like', NULL, NULL, 'REC_CheC-like', 2508),
(2509, 'cd17389', NULL, 'MFS_MFSD10', NULL, NULL, 'MFS_MFSD10', 2509),
(2510, 'cd06383', NULL, 'PBP1_iGluR_AMPA_Like', NULL, NULL, 'PBP1_iGluR_AMPA_Like', 2510),
(2511, 'cd14340', NULL, 'UBA_BRSK', NULL, NULL, 'UBA_BRSK', 2511),
(2512, 'cd17253', NULL, 'RMtype1_S_Eco933I-TRD2-CR2_like', NULL, NULL, 'RMtype1_S_Eco933I-TRD2-CR2_like', 2512),
(2513, 'cd15864', NULL, 'SNARE_GS28', NULL, NULL, 'SNARE_GS28', 2513),
(2514, 'cd16789', NULL, 'mRING-HC-C3HC5_MGRN1_like---blasttree', NULL, NULL, 'mRING-HC-C3HC5_MGRN1_like---blasttree', 2514),
(2515, 'cd14148', NULL, 'STKc_MLK2', NULL, NULL, 'STKc_MLK2', 2515),
(2516, 'cd05286', NULL, 'QOR2', NULL, NULL, 'QOR2', 2516),
(2517, 'cd08929', NULL, 'SDR_c4', NULL, NULL, 'SDR_c4', 2517),
(2518, 'cd11493', NULL, 'SLC5sbd_NIS-like_u1', NULL, NULL, 'SLC5sbd_NIS-like_u1', 2518),
(2519, 'cd11475', NULL, 'SLC5sbd_PutP', NULL, NULL, 'SLC5sbd_PutP', 2519),
(2520, 'cd09349', NULL, 'LIM1_Zyxin', NULL, NULL, 'LIM1_Zyxin', 2520),
(2521, 'cd13645', NULL, 'PBP2_HuPBGD_like', NULL, NULL, 'PBP2_HuPBGD_like', 2521),
(2522, 'cd12942', NULL, 'LEM_Man1', NULL, NULL, 'LEM_Man1', 2522),
(2523, 'cd11644', NULL, 'Precorrin-6Y-MT', NULL, NULL, 'Precorrin-6Y-MT', 2523),
(2524, 'cd09271', NULL, 'RNase_H2-C', NULL, NULL, 'RNase_H2-C', 2524),
(2525, 'cd14536', NULL, 'PTP-MTMR9', NULL, NULL, 'PTP-MTMR9', 2525),
(2526, 'cd12656', NULL, 'RRM3_HuD', NULL, NULL, 'RRM3_HuD', 2526),
(2527, 'cd08201', NULL, 'plant_peroxidase_like_1', NULL, NULL, 'plant_peroxidase_like_1', 2527),
(2528, 'cd16030', NULL, 'iduronate-2-sulfatase', NULL, NULL, 'iduronate-2-sulfatase', 2528); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(2529, 'cd08859', NULL, 'ArfGap_SMAP2', NULL, NULL, 'ArfGap_SMAP2', 2529),
(2530, 'cd05574', NULL, 'STKc_phototropin_like', NULL, NULL, 'STKc_phototropin_like', 2530),
(2531, 'cd12117', NULL, 'A_NRPS_Srf_like', NULL, NULL, 'A_NRPS_Srf_like', 2531),
(2532, 'cd10314', NULL, 'FAM20_C', NULL, NULL, 'FAM20_C', 2532),
(2533, 'cd19094', NULL, 'AKR_Tas-like', NULL, NULL, 'AKR_Tas-like', 2533),
(2534, 'cd09912', NULL, 'DLP_2', NULL, NULL, 'DLP_2', 2534),
(2535, 'cd06651', NULL, 'STKc_MEKK3', NULL, NULL, 'STKc_MEKK3', 2535),
(2536, 'cd15209', NULL, '7tmA_Mel1', NULL, NULL, '7tmA_Mel1', 2536),
(2537, 'cd16400', NULL, 'ParB_Srx_like_nuclease', NULL, NULL, 'ParB_Srx_like_nuclease', 2537),
(2538, 'cd07795', NULL, 'FGGY_ScGut1p_like', NULL, NULL, 'FGGY_ScGut1p_like', 2538),
(2539, 'cd04598', NULL, 'CBS_pair_GGDEF_EAL', NULL, NULL, 'CBS_pair_GGDEF_EAL', 2539),
(2540, 'cd18350', NULL, 'BTB_POZ_ABTB2_BPOZ2', NULL, NULL, 'BTB_POZ_ABTB2_BPOZ2', 2540),
(2541, 'cd03463', NULL, '3,4-PCD_alpha', NULL, NULL, '3,4-PCD_alpha', 2541),
(2542, 'cd07951', NULL, 'ED_3B_N_AMMECR1', NULL, NULL, 'ED_3B_N_AMMECR1', 2542),
(2543, 'cd06996', NULL, 'cupin_Lmo2851-like_N', NULL, NULL, 'cupin_Lmo2851-like_N', 2543),
(2544, 'cd08195', NULL, 'DHQS', NULL, NULL, 'DHQS', 2544),
(2545, 'cd03037', NULL, 'GST_N_GRX2', NULL, NULL, 'GST_N_GRX2', 2545),
(2546, 'cd12920', NULL, 'VKOR_3', NULL, NULL, 'VKOR_3', 2546),
(2547, 'cd16529', NULL, 'RING-HC_RAD18', NULL, NULL, 'RING-HC_RAD18', 2547),
(2548, 'cd02573', NULL, 'PseudoU_synth_EcTruB', NULL, NULL, 'PseudoU_synth_EcTruB', 2548),
(2549, 'cd17732', NULL, 'BRCT_Ect2_rpt2', NULL, NULL, 'BRCT_Ect2_rpt2', 2549),
(2550, 'cd05920', NULL, '23DHB-AMP_lg', NULL, NULL, '23DHB-AMP_lg', 2550),
(2551, 'cd08834', NULL, 'ArfGap_ASAP', NULL, NULL, 'ArfGap_ASAP', 2551),
(2552, 'cd19060', NULL, 'LGIC_TM_GlyR_alpha', NULL, NULL, 'LGIC_TM_GlyR_alpha', 2552),
(2553, 'cd18397', NULL, 'BTB_POZ_KCTD12_Pfetin', NULL, NULL, 'BTB_POZ_KCTD12_Pfetin', 2553),
(2554, 'cd16578', NULL, 'RING-HC_TRIM42_C-III', NULL, NULL, 'RING-HC_TRIM42_C-III', 2554),
(2555, 'cd11765', NULL, 'SH3_Nck_1', NULL, NULL, 'SH3_Nck_1', 2555),
(2556, 'cd05176', NULL, 'PI3Kc_C2_alpha', NULL, NULL, 'PI3Kc_C2_alpha', 2556),
(2557, 'cd19768', NULL, 'Bbox2_TRIM14', NULL, NULL, 'Bbox2_TRIM14', 2557),
(2558, 'cd20236', NULL, 'PFM_SP17-like', NULL, NULL, 'PFM_SP17-like', 2558),
(2559, 'cd05892', NULL, 'Ig_Myotilin_C', NULL, NULL, 'Ig_Myotilin_C', 2559),
(2560, 'cd14271', NULL, 'UBA_YLR419W_like', NULL, NULL, 'UBA_YLR419W_like', 2560),
(2561, 'cd17186', NULL, 'FERM_F1_Merlin', NULL, NULL, 'FERM_F1_Merlin', 2561),
(2562, 'cd05769', NULL, 'IgC_TCR_beta', NULL, NULL, 'IgC_TCR_beta', 2562),
(2563, 'cd13881', NULL, 'CuRO_2_McoC_like', NULL, NULL, 'CuRO_2_McoC_like', 2563),
(2564, 'cd03217', NULL, 'ABC_FeS_Assembly', NULL, NULL, 'ABC_FeS_Assembly', 2564),
(2565, 'cd01192', NULL, 'INT_C_like_3', NULL, NULL, 'INT_C_like_3', 2565),
(2566, 'sd00030', NULL, 'zf-RanBP2', NULL, NULL, 'zf-RanBP2', 2566),
(2567, 'cd07140', NULL, 'ALDH_F1L_FTFDH', NULL, NULL, 'ALDH_F1L_FTFDH', 2567),
(2568, 'cd12315', NULL, 'RRM1_RBM19_MRD1', NULL, NULL, 'RRM1_RBM19_MRD1', 2568),
(2569, 'cd13895', NULL, 'CuRO_3_AAO_like_2', NULL, NULL, 'CuRO_3_AAO_like_2', 2569),
(2570, 'cd01693', NULL, 'mtEFG2_like_IV', NULL, NULL, 'mtEFG2_like_IV', 2570),
(2571, 'cd09140', NULL, 'PLDc_vPLD1_2_like_bac_1', NULL, NULL, 'PLDc_vPLD1_2_like_bac_1', 2571),
(2572, 'cd00530', NULL, 'PTE', NULL, NULL, 'PTE', 2572),
(2573, 'cd05833', NULL, 'Ribosomal_P2', NULL, NULL, 'Ribosomal_P2', 2573),
(2574, 'cd04098', NULL, 'eEF2_C_snRNP', NULL, NULL, 'eEF2_C_snRNP', 2574),
(2575, 'cd13905', NULL, 'CuRO_3_tcLLC2_insect_like', NULL, NULL, 'CuRO_3_tcLLC2_insect_like', 2575),
(2576, 'cd15544', NULL, 'PHD_BAZ1A_like', NULL, NULL, 'PHD_BAZ1A_like', 2576),
(2577, 'cd01980', NULL, 'Chlide_reductase_Y', NULL, NULL, 'Chlide_reductase_Y', 2577),
(2578, 'cd05354', NULL, 'SDR_c7', NULL, NULL, 'SDR_c7', 2578),
(2579, 'cd08356', NULL, 'VOC_CChe_VCA0619_like', NULL, NULL, 'VOC_CChe_VCA0619_like', 2579),
(2580, 'cd07879', NULL, 'STKc_p38delta', NULL, NULL, 'STKc_p38delta', 2580);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(2581, 'cd03076', NULL, 'GST_N_Pi', NULL, NULL, 'GST_N_Pi', 2581),
(2582, 'cd04852', NULL, 'Peptidases_S8_3', NULL, NULL, 'Peptidases_S8_3', 2582),
(2583, 'cd16482', NULL, 'RING-H2_UBR1_like', NULL, NULL, 'RING-H2_UBR1_like', 2583),
(2584, 'cd17219', NULL, 'RA_RASSF3', NULL, NULL, 'RA_RASSF3', 2584),
(2585, 'cd08832', NULL, 'ArfGap_ADAP', NULL, NULL, 'ArfGap_ADAP', 2585),
(2586, 'cd00433', NULL, 'Peptidase_M17', NULL, NULL, 'Peptidase_M17', 2586),
(2587, 'cd01838', NULL, 'Isoamyl_acetate_hydrolase_like', NULL, NULL, 'Isoamyl_acetate_hydrolase_like', 2587),
(2588, 'cd09408', NULL, 'LIM2_Leupaxin', NULL, NULL, 'LIM2_Leupaxin', 2588),
(2589, 'cd05145', NULL, 'RIO1_like', NULL, NULL, 'RIO1_like', 2589),
(2590, 'cd13964', NULL, 'PT_UbiA_1', NULL, NULL, 'PT_UbiA_1', 2590),
(2591, 'cd15814', NULL, 'SPRY_PRY_TRIM27', NULL, NULL, 'SPRY_PRY_TRIM27', 2591),
(2592, 'cd09687', NULL, 'Cas7_I-C', NULL, NULL, 'Cas7_I-C', 2592),
(2593, 'cd07481', NULL, 'Peptidases_S8_BacillopeptidaseF-like', NULL, NULL, 'Peptidases_S8_BacillopeptidaseF-like', 2593),
(2594, 'cd14404', NULL, 'UBA_AID_AAPK2', NULL, NULL, 'UBA_AID_AAPK2', 2594),
(2595, 'cd08764', NULL, 'Cyt_b561_CG1275_like', NULL, NULL, 'Cyt_b561_CG1275_like', 2595),
(2596, 'cd01474', NULL, 'vWA_ATR', NULL, NULL, 'vWA_ATR', 2596),
(2597, 'cd06878', NULL, 'PX_SNX25', NULL, NULL, 'PX_SNX25', 2597),
(2598, 'cd10152', NULL, 'SaCsoR-like_DUF156', NULL, NULL, 'SaCsoR-like_DUF156', 2598),
(2599, 'cd10541', NULL, 'SET_SETDB', NULL, NULL, 'SET_SETDB', 2599),
(2600, 'cd09321', NULL, 'TDT_like_3', NULL, NULL, 'TDT_like_3', 2600),
(2601, 'cd00604', NULL, 'IPT_CGTD', NULL, NULL, 'IPT_CGTD', 2601),
(2602, 'cd01989', NULL, 'STK_N', NULL, NULL, 'STK_N', 2602),
(2603, 'cd06059', NULL, 'Tubulin', NULL, NULL, 'Tubulin', 2603),
(2604, 'cd04050', NULL, 'C2B_Synaptotagmin-like', NULL, NULL, 'C2B_Synaptotagmin-like', 2604),
(2605, 'cd11579', NULL, 'Glyco_tran_WbsX', NULL, NULL, 'Glyco_tran_WbsX', 2605),
(2606, 'cd15930', NULL, '7tmB1_Secretin_R-like', NULL, NULL, '7tmB1_Secretin_R-like', 2606),
(2607, 'cd11835', NULL, 'SH3_ARHGAP32_33', NULL, NULL, 'SH3_ARHGAP32_33', 2607),
(2608, 'cd07060', NULL, 'SPOUT_MTase', NULL, NULL, 'SPOUT_MTase', 2608),
(2609, 'cd18531', NULL, 'BACK_RHOBTB2', NULL, NULL, 'BACK_RHOBTB2', 2609),
(2610, 'cd09675', NULL, 'Csy1_I-F', NULL, NULL, 'Csy1_I-F', 2610),
(2611, 'cd06392', NULL, 'PBP1_iGluR_delta_1', NULL, NULL, 'PBP1_iGluR_delta_1', 2611),
(2612, 'cd00568', NULL, 'TPP_enzymes', NULL, NULL, 'TPP_enzymes', 2612),
(2613, 'cd15305', NULL, '7tmA_5-HT2C', NULL, NULL, '7tmA_5-HT2C', 2613),
(2614, 'cd14701', NULL, 'bZIP_BATF', NULL, NULL, 'bZIP_BATF', 2614),
(2615, 'cd07690', NULL, 'Ig1_CD4', NULL, NULL, 'Ig1_CD4', 2615),
(2616, 'cd15367', NULL, '7tmA_GPR68_OGR1', NULL, NULL, '7tmA_GPR68_OGR1', 2616),
(2617, 'cd08852', NULL, 'ArfGap_ACAP1', NULL, NULL, 'ArfGap_ACAP1', 2617),
(2618, 'cd16215', NULL, 'EFh_PI-PLCgamma2', NULL, NULL, 'EFh_PI-PLCgamma2', 2618),
(2619, 'cd07995', NULL, 'TPK', NULL, NULL, 'TPK', 2619),
(2620, 'cd05005', NULL, 'SIS_PHI', NULL, NULL, 'SIS_PHI', 2620),
(2621, 'cd04264', NULL, 'DUF619-NAGS', NULL, NULL, 'DUF619-NAGS', 2621),
(2622, 'cd02430', NULL, 'PTH2', NULL, NULL, 'PTH2', 2622),
(2623, 'cd12507', NULL, 'RRM1_ESRPs_Fusilli', NULL, NULL, 'RRM1_ESRPs_Fusilli', 2623),
(2624, 'cd17102', NULL, 'FERM_F1_FRMD3', NULL, NULL, 'FERM_F1_FRMD3', 2624),
(2625, 'cd11885', NULL, 'SH3_SH3TC', NULL, NULL, 'SH3_SH3TC', 2625),
(2626, 'cd04695', NULL, 'Nudix_Hydrolase_36', NULL, NULL, 'Nudix_Hydrolase_36', 2626),
(2627, 'cd16723', NULL, 'RING-HC_MEX3D', NULL, NULL, 'RING-HC_MEX3D', 2627),
(2628, 'cd17370', NULL, 'MFS_MJ1317_like', NULL, NULL, 'MFS_MJ1317_like', 2628),
(2629, 'cd19415', NULL, 'lipocalin_ApoM_AGP', NULL, NULL, 'lipocalin_ApoM_AGP', 2629),
(2630, 'cd16188', NULL, 'EFh_PEF_CPNS1_2', NULL, NULL, 'EFh_PEF_CPNS1_2', 2630),
(2631, 'cd11628', NULL, 'HR1_CIP4_FNBP1L', NULL, NULL, 'HR1_CIP4_FNBP1L', 2631),
(2632, 'cd19141', NULL, 'Aldo_ket_red_shaker', NULL, NULL, 'Aldo_ket_red_shaker', 2632),
(2633, 'cd13400', NULL, 'LT_IagB-like', NULL, NULL, 'LT_IagB-like', 2633);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(2634, 'cd09114', NULL, 'PLDc_PPK1_C1', NULL, NULL, 'PLDc_PPK1_C1', 2634),
(2635, 'cd06179', NULL, 'MFS_TRI12_like', NULL, NULL, 'MFS_TRI12_like', 2635),
(2636, 'cd01237', NULL, 'PH_fermitin', NULL, NULL, 'PH_fermitin', 2636),
(2637, 'cd01774', NULL, 'UBX_UBXN8', NULL, NULL, 'UBX_UBXN8', 2637),
(2638, 'cd17523', NULL, 'RMtype1_S_StySPI-TRD2-CR2_like', NULL, NULL, 'RMtype1_S_StySPI-TRD2-CR2_like', 2638),
(2639, 'cd18539', NULL, 'SRP_G', NULL, NULL, 'SRP_G', 2639),
(2640, 'cd09724', NULL, 'CsaX_III-U', NULL, NULL, 'CsaX_III-U', 2640),
(2641, 'cd12128', NULL, 'PBP_PBS-LCM', NULL, NULL, 'PBP_PBS-LCM', 2641),
(2642, 'cd03205', NULL, 'GST_C_6', NULL, NULL, 'GST_C_6', 2642),
(2643, 'cd19558', NULL, 'serpinA12_vaspin', NULL, NULL, 'serpinA12_vaspin', 2643),
(2644, 'cd10317', NULL, 'RGL4_C', NULL, NULL, 'RGL4_C', 2644),
(2645, 'cd08694', NULL, 'C2_Dock-A', NULL, NULL, 'C2_Dock-A', 2645),
(2646, 'cd09081', NULL, 'CdtB', NULL, NULL, 'CdtB', 2646),
(2647, 'cd18979', NULL, 'CD_POL_like', NULL, NULL, 'CD_POL_like', 2647),
(2648, 'cd07534', NULL, 'HAD_CAP', NULL, NULL, 'HAD_CAP', 2648),
(2649, 'cd08241', NULL, 'QOR1', NULL, NULL, 'QOR1', 2649),
(2650, 'cd16442', NULL, 'BPL', NULL, NULL, 'BPL', 2650),
(2651, 'cd04764', NULL, 'HTH_MlrA-like_sg1', NULL, NULL, 'HTH_MlrA-like_sg1', 2651),
(2652, 'cd14579', NULL, 'DUSP3', NULL, NULL, 'DUSP3', 2652),
(2653, 'cd15280', NULL, '7tmC_V2R-like', NULL, NULL, '7tmC_V2R-like', 2653),
(2654, 'cd18669', NULL, 'M20_18_42', NULL, NULL, 'M20_18_42', 2654),
(2655, 'cd15325', NULL, '7tmA_alpha1A_AR', NULL, NULL, '7tmA_alpha1A_AR', 2655),
(2656, 'cd04669', NULL, 'Nudix_Hydrolase_11', NULL, NULL, 'Nudix_Hydrolase_11', 2656),
(2657, 'cd00187', NULL, 'TOP4c', NULL, NULL, 'TOP4c', 2657),
(2658, 'cd04255', NULL, 'AAK_UMPK-MosAB', NULL, NULL, 'AAK_UMPK-MosAB', 2658),
(2659, 'cd13727', NULL, 'PBP2_iGluR_AMPA_GluR4', NULL, NULL, 'PBP2_iGluR_AMPA_GluR4', 2659),
(2660, 'cd05241', NULL, '3b-HSD-like_SDR_e', NULL, NULL, '3b-HSD-like_SDR_e', 2660),
(2661, 'cd18912', NULL, 'bHLH_TS_bHLHa9', NULL, NULL, 'bHLH_TS_bHLHa9', 2661),
(2662, 'cd10796', NULL, 'GH57N_APU', NULL, NULL, 'GH57N_APU', 2662),
(2663, 'cd15735', NULL, 'FYVE_spVPS27p_like', NULL, NULL, 'FYVE_spVPS27p_like', 2663),
(2664, 'cd07408', NULL, 'MPP_SA0022_N', NULL, NULL, 'MPP_SA0022_N', 2664),
(2665, 'cd14930', NULL, 'MYSc_Myh14_mammals', NULL, NULL, 'MYSc_Myh14_mammals', 2665),
(2666, 'cd16157', NULL, 'GALNS', NULL, NULL, 'GALNS', 2666),
(2667, 'cd09718', NULL, 'Cas1_I-F', NULL, NULL, 'Cas1_I-F', 2667),
(2668, 'cd16242', NULL, 'EFh_DMD_like', NULL, NULL, 'EFh_DMD_like', 2668),
(2669, 'cd05559', NULL, 'CAP_PI16_HrTT-1', NULL, NULL, 'CAP_PI16_HrTT-1', 2669),
(2670, 'cd12295', NULL, 'RRM_YRA2', NULL, NULL, 'RRM_YRA2', 2670),
(2671, 'cd15869', NULL, 'R-SNARE_VAMP4', NULL, NULL, 'R-SNARE_VAMP4', 2671),
(2672, 'cd02876', NULL, 'GH18_SI-CLP', NULL, NULL, 'GH18_SI-CLP', 2672),
(2673, 'cd09575', NULL, 'SAM_DGK-delta', NULL, NULL, 'SAM_DGK-delta', 2673),
(2674, 'cd00086', NULL, 'homeodomain', NULL, NULL, 'homeodomain', 2674),
(2675, 'cd16585', NULL, 'RING-HC_TIF1_C-VI', NULL, NULL, 'RING-HC_TIF1_C-VI', 2675),
(2676, 'cd04025', NULL, 'C2B_RasA1_RasA4', NULL, NULL, 'C2B_RasA1_RasA4', 2676),
(2677, 'cd08273', NULL, 'MDR8', NULL, NULL, 'MDR8', 2677),
(2678, 'cd09028', NULL, 'ArfGap_ArfGap3', NULL, NULL, 'ArfGap_ArfGap3', 2678),
(2679, 'cd09460', NULL, 'LIM3_ZASP_Cypher', NULL, NULL, 'LIM3_ZASP_Cypher', 2679),
(2680, 'cd01637', NULL, 'IMPase_like', NULL, NULL, 'IMPase_like', 2680),
(2681, 'cd05386', NULL, 'TraL', NULL, NULL, 'TraL', 2681),
(2682, 'cd18367', NULL, 'BTB_POZ_KCTD8-like', NULL, NULL, 'BTB_POZ_KCTD8-like', 2682),
(2683, 'cd09633', NULL, 'Deltex_C', NULL, NULL, 'Deltex_C', 2683),
(2684, 'cd14267', NULL, 'Rif1_CTD_C-II_like', NULL, NULL, 'Rif1_CTD_C-II_like', 2684),
(2685, 'cd04814', NULL, 'PA_M28_1', NULL, NULL, 'PA_M28_1', 2685),
(2686, 'cd06252', NULL, 'M14_ASTE_ASPA-like', NULL, NULL, 'M14_ASTE_ASPA-like', 2686),
(2687, 'cd11253', NULL, 'Sema_3E', NULL, NULL, 'Sema_3E', 2687),
(2688, 'cd13168', NULL, 'PTB_LOC417372', NULL, NULL, 'PTB_LOC417372', 2688);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(2689, 'cd08894', NULL, 'SRPBCC_CalC_Aha1-like_1', NULL, NULL, 'SRPBCC_CalC_Aha1-like_1', 2689),
(2690, 'cd11846', NULL, 'SH3_Srms', NULL, NULL, 'SH3_Srms', 2690),
(2691, 'cd18086', NULL, 'HsC9orf114-like', NULL, NULL, 'HsC9orf114-like', 2691),
(2692, 'cd12637', NULL, 'RRM2_FCA', NULL, NULL, 'RRM2_FCA', 2692),
(2693, 'cd15363', NULL, '7tmA_LGR5', NULL, NULL, '7tmA_LGR5', 2693),
(2694, 'cd03589', NULL, 'CLECT_CEL-1_like', NULL, NULL, 'CLECT_CEL-1_like', 2694),
(2695, 'cd08500', NULL, 'PBP2_NikA_DppA_OppA_like_4', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_4', 2695),
(2696, 'cd11979', NULL, 'SH3_VAV1_1', NULL, NULL, 'SH3_VAV1_1', 2696),
(2697, 'cd06187', NULL, 'O2ase_reductase_like', NULL, NULL, 'O2ase_reductase_like', 2697),
(2698, 'cd02140', NULL, 'Frm2-like', NULL, NULL, 'Frm2-like', 2698),
(2699, 'cd19755', NULL, 'TrHb2_AtGlb3-like_O', NULL, NULL, 'TrHb2_AtGlb3-like_O', 2699),
(2700, 'cd00156', NULL, 'REC', NULL, NULL, 'REC', 2700),
(2701, 'cd07125', NULL, 'ALDH_PutA-P5CDH', NULL, NULL, 'ALDH_PutA-P5CDH', 2701),
(2702, 'cd02616', NULL, 'HAD_PPase', NULL, NULL, 'HAD_PPase', 2702),
(2703, 'cd00632', NULL, 'Prefoldin_beta', NULL, NULL, 'Prefoldin_beta', 2703),
(2704, 'cd15045', NULL, '7tmC_mGluRs', NULL, NULL, '7tmC_mGluRs', 2704),
(2705, 'cd18682', NULL, 'PIN_VapC-like', NULL, NULL, 'PIN_VapC-like', 2705),
(2706, 'cd08723', NULL, 'RGS_RGS21', NULL, NULL, 'RGS_RGS21', 2706),
(2707, 'cd19205', NULL, 'SET_SETD1B', NULL, NULL, 'SET_SETD1B', 2707),
(2708, 'cd21628', NULL, 'deltaCoV_NS7_NS7a', NULL, NULL, 'deltaCoV_NS7_NS7a', 2708),
(2709, 'cd14387', NULL, 'UBA2_UBP13', NULL, NULL, 'UBA2_UBP13', 2709),
(2710, 'cd17283', NULL, 'RMtype1_S_Hpy180ORF7835P_TRD2-CR2_like', NULL, NULL, 'RMtype1_S_Hpy180ORF7835P_TRD2-CR2_like', 2710),
(2711, 'cd04009', NULL, 'C2B_Munc13-like', NULL, NULL, 'C2B_Munc13-like', 2711),
(2712, 'cd14968', NULL, '7tmA_Adenosine_R', NULL, NULL, '7tmA_Adenosine_R', 2712),
(2713, 'cd14725', NULL, 'ZIP_Gal4-like_2', NULL, NULL, 'ZIP_Gal4-like_2', 2713),
(2714, 'cd16919', NULL, 'HATPase_CckA-like', NULL, NULL, 'HATPase_CckA-like', 2714),
(2715, 'cd14996', NULL, '7tmA_GPR82', NULL, NULL, '7tmA_GPR82', 2715),
(2716, 'cd11929', NULL, 'SH3_SH3RF2_1', NULL, NULL, 'SH3_SH3RF2_1', 2716),
(2717, 'cd16129', NULL, 'Ubl_ATG8_MAP1LC3', NULL, NULL, 'Ubl_ATG8_MAP1LC3', 2717),
(2718, 'cd17327', NULL, 'MFS_FEN2_like', NULL, NULL, 'MFS_FEN2_like', 2718),
(2719, 'cd18028', NULL, 'DEXHc_archSki2', NULL, NULL, 'DEXHc_archSki2', 2719),
(2720, 'cd09616', NULL, 'Peptidase_C12_UCH_L1_L3', NULL, NULL, 'Peptidase_C12_UCH_L1_L3', 2720),
(2721, 'cd17019', NULL, 'T3SC_IA_ShcA-like', NULL, NULL, 'T3SC_IA_ShcA-like', 2721),
(2722, 'cd19370', NULL, 'TenA_PqqC', NULL, NULL, 'TenA_PqqC', 2722),
(2723, 'cd04049', NULL, 'C2_putative_Elicitor-responsive_gene', NULL, NULL, 'C2_putative_Elicitor-responsive_gene', 2723),
(2724, 'cd12694', NULL, 'RRM2_hnRNPL_like', NULL, NULL, 'RRM2_hnRNPL_like', 2724),
(2725, 'cd19166', NULL, 'HemeO-bac', NULL, NULL, 'HemeO-bac', 2725),
(2726, 'cd14341', NULL, 'UBA_MELK', NULL, NULL, 'UBA_MELK', 2726),
(2727, 'cd13980', NULL, 'STKc_Vps15', NULL, NULL, 'STKc_Vps15', 2727),
(2728, 'cd11324', NULL, 'AmyAc_Amylosucrase', NULL, NULL, 'AmyAc_Amylosucrase', 2728),
(2729, 'cd11598', NULL, 'HDAC_Hos2', NULL, NULL, 'HDAC_Hos2', 2729),
(2730, 'cd03459', NULL, '3,4-PCD', NULL, NULL, '3,4-PCD', 2730),
(2731, 'cd14368', NULL, 'CUE_DEF1_like', NULL, NULL, 'CUE_DEF1_like', 2731),
(2732, 'cd14211', NULL, 'STKc_HIPK', NULL, NULL, 'STKc_HIPK', 2732),
(2733, 'cd05640', NULL, 'M28_like', NULL, NULL, 'M28_like', 2733),
(2734, 'cd17125', NULL, 'Ubl_TECRL', NULL, NULL, 'Ubl_TECRL', 2734),
(2735, 'cd00591', NULL, 'HU_IHF', NULL, NULL, 'HU_IHF', 2735),
(2736, 'cd05819', NULL, 'NHL', NULL, NULL, 'NHL', 2736),
(2737, 'cd11295', NULL, 'Mago_nashi', NULL, NULL, 'Mago_nashi', 2737),
(2738, 'cd15414', NULL, '7tmA_OR5G-like', NULL, NULL, '7tmA_OR5G-like', 2738),
(2739, 'cd07942', NULL, 'DRE_TIM_LeuA', NULL, NULL, 'DRE_TIM_LeuA', 2739),
(2740, 'cd00138', NULL, 'PLDc_SF', NULL, NULL, 'PLDc_SF', 2740),
(2741, 'cd03471', NULL, 'Rieske_cytochrome_b6f', NULL, NULL, 'Rieske_cytochrome_b6f', 2741);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(2742, 'cd00551', NULL, 'AmyAc_family', NULL, NULL, 'AmyAc_family', 2742),
(2743, 'cd11909', NULL, 'SH3_PI3K_p85beta', NULL, NULL, 'SH3_PI3K_p85beta', 2743),
(2744, 'cd08192', NULL, 'MAR-like', NULL, NULL, 'MAR-like', 2744),
(2745, 'cd10347', NULL, 'SH2_Nterm_shark_like', NULL, NULL, 'SH2_Nterm_shark_like', 2745),
(2746, 'cd18916', NULL, 'bHLH-O_ESM5_like', NULL, NULL, 'bHLH-O_ESM5_like', 2746),
(2747, 'cd13836', NULL, 'IHF_B', NULL, NULL, 'IHF_B', 2747),
(2748, 'cd07217', NULL, 'Pat17_PNPLA8_PNPLA9_like4', NULL, NULL, 'Pat17_PNPLA8_PNPLA9_like4', 2748),
(2749, 'cd13936', NULL, 'PANDER_like', NULL, NULL, 'PANDER_like', 2749),
(2750, 'cd19442', NULL, 'CRBP', NULL, NULL, 'CRBP', 2750),
(2751, 'cd05782', NULL, 'DNA_polB_like1_exo', NULL, NULL, 'DNA_polB_like1_exo', 2751),
(2752, 'cd02845', NULL, 'PAZ_piwi_like', NULL, NULL, 'PAZ_piwi_like', 2752),
(2753, 'cd02893', NULL, 'FTase', NULL, NULL, 'FTase', 2753),
(2754, 'cd15505', NULL, 'PHD_ING', NULL, NULL, 'PHD_ING', 2754),
(2755, 'cd19059', NULL, 'LGIC_TM_GABAAR_rho', NULL, NULL, 'LGIC_TM_GABAAR_rho', 2755),
(2756, 'cd08341', NULL, 'DED_Caspase_10_r1', NULL, NULL, 'DED_Caspase_10_r1', 2756),
(2757, 'cd04238', NULL, 'AAK_NAGK-like', NULL, NULL, 'AAK_NAGK-like', 2757),
(2758, 'cd14369', NULL, 'CUE_VPS9_like', NULL, NULL, 'CUE_VPS9_like', 2758),
(2759, 'cd14706', NULL, 'bZIP_CREBZF', NULL, NULL, 'bZIP_CREBZF', 2759),
(2760, 'cd14669', NULL, 'mlta_related_B', NULL, NULL, 'mlta_related_B', 2760),
(2761, 'cd13672', NULL, 'PBP2_TRAP_Siap', NULL, NULL, 'PBP2_TRAP_Siap', 2761),
(2762, 'cd13630', NULL, 'PBP2_PDT_1', NULL, NULL, 'PBP2_PDT_1', 2762),
(2763, 'cd14721', NULL, 'bZIP_Fos', NULL, NULL, 'bZIP_Fos', 2763),
(2764, 'cd00607', NULL, 'RNase_Sa', NULL, NULL, 'RNase_Sa', 2764),
(2765, 'cd16166', NULL, 'OCRE_SUA_like', NULL, NULL, 'OCRE_SUA_like', 2765),
(2766, 'cd21638', NULL, 'NS7a_deltaCoV_HKU16-like', NULL, NULL, 'NS7a_deltaCoV_HKU16-like', 2766),
(2767, 'cd14445', NULL, 'RILP-like', NULL, NULL, 'RILP-like', 2767),
(2768, 'cd18818', NULL, 'GH43_GbtXyl43B-like', NULL, NULL, 'GH43_GbtXyl43B-like', 2768),
(2769, 'cd02123', NULL, 'PA_C_RZF_like', NULL, NULL, 'PA_C_RZF_like', 2769),
(2770, 'cd17619', NULL, 'REC_OmpR_ArcA_TorR-like', NULL, NULL, 'REC_OmpR_ArcA_TorR-like', 2770),
(2771, 'cd18411', NULL, 'BTB_POZ_KCNB1', NULL, NULL, 'BTB_POZ_KCNB1', 2771),
(2772, 'cd18460', NULL, 'BACK_KLHL21', NULL, NULL, 'BACK_KLHL21', 2772),
(2773, 'cd12567', NULL, 'RRM3_RBM19', NULL, NULL, 'RRM3_RBM19', 2773),
(2774, 'cd04024', NULL, 'C2A_Synaptotagmin-like', NULL, NULL, 'C2A_Synaptotagmin-like', 2774),
(2775, 'cd16085', NULL, 'IgC_SIRP_domain_3', NULL, NULL, 'IgC_SIRP_domain_3', 2775),
(2776, 'cd08768', NULL, 'Cdc6_C', NULL, NULL, 'Cdc6_C', 2776),
(2777, 'cd13322', NULL, 'PH_PHLPP-like', NULL, NULL, 'PH_PHLPP-like', 2777),
(2778, 'cd04097', NULL, 'mtEFG1_C', NULL, NULL, 'mtEFG1_C', 2778),
(2779, 'cd11559', NULL, 'W2_eIF4G1_like', NULL, NULL, 'W2_eIF4G1_like', 2779),
(2780, 'cd15762', NULL, 'FYVE_RP3A', NULL, NULL, 'FYVE_RP3A', 2780),
(2781, 'cd00022', NULL, 'BIR', NULL, NULL, 'BIR', 2781),
(2782, 'cd20483', NULL, 'C_PKS-NRPS', NULL, NULL, 'C_PKS-NRPS', 2782),
(2783, 'cd06598', NULL, 'GH31_transferase_CtsZ', NULL, NULL, 'GH31_transferase_CtsZ', 2783),
(2784, 'cd12300', NULL, 'RRM1_PAR14', NULL, NULL, 'RRM1_PAR14', 2784),
(2785, 'cd14583', NULL, 'PTP-MTMR7', NULL, NULL, 'PTP-MTMR7', 2785),
(2786, 'cd12325', NULL, 'RRM1_hnRNPA_hnRNPD_like', NULL, NULL, 'RRM1_hnRNPA_hnRNPD_like', 2786),
(2787, 'cd01557', NULL, 'BCAT_beta_family', NULL, NULL, 'BCAT_beta_family', 2787),
(2788, 'cd11406', NULL, 'bHLHzip_Max', NULL, NULL, 'bHLHzip_Max', 2788),
(2789, 'cd19692', NULL, 'bHLH_dnHLH_ID2', NULL, NULL, 'bHLH_dnHLH_ID2', 2789),
(2790, 'sd00004', NULL, 'PPR', NULL, NULL, 'PPR', 2790),
(2791, 'cd14079', NULL, 'STKc_AMPK_alpha', NULL, NULL, 'STKc_AMPK_alpha', 2791),
(2792, 'cd11620', NULL, 'HR1_PKC-like_2_fungi', NULL, NULL, 'HR1_PKC-like_2_fungi', 2792),
(2793, 'cd08969', NULL, 'MeNeil3_N', NULL, NULL, 'MeNeil3_N', 2793),
(2794, 'cd16991', NULL, 'ENTH_Ent1_Ent2', NULL, NULL, 'ENTH_Ent1_Ent2', 2794);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(2795, 'cd13950', NULL, '7tm_TAS2R', NULL, NULL, '7tm_TAS2R', 2795),
(2796, 'cd14388', NULL, 'UBA2_atUBP14', NULL, NULL, 'UBA2_atUBP14', 2796),
(2797, 'cd01579', NULL, 'AcnA_Bact_Swivel', NULL, NULL, 'AcnA_Bact_Swivel', 2797),
(2798, 'cd21593', NULL, 'HCoV_HKU1-like_RdRp', NULL, NULL, 'HCoV_HKU1-like_RdRp', 2798),
(2799, 'cd10039', NULL, 'Reelin_repeat_3_subrepeat_1', NULL, NULL, 'Reelin_repeat_3_subrepeat_1', 2799),
(2800, 'cd12790', NULL, 'RasGAP_plexin_A', NULL, NULL, 'RasGAP_plexin_A', 2800),
(2801, 'cd01700', NULL, 'PolY_Pol_V_umuC', NULL, NULL, 'PolY_Pol_V_umuC', 2801),
(2802, 'cd16217', NULL, 'EFh_PI-PLCdelta1', NULL, NULL, 'EFh_PI-PLCdelta1', 2802),
(2803, 'cd08239', NULL, 'THR_DH_like', NULL, NULL, 'THR_DH_like', 2803),
(2804, 'cd12777', NULL, 'RRM1_PTBP1', NULL, NULL, 'RRM1_PTBP1', 2804),
(2805, 'cd15854', NULL, 'SNARE_SNAP47C', NULL, NULL, 'SNARE_SNAP47C', 2805),
(2806, 'cd12723', NULL, 'RRM1_CPEB1', NULL, NULL, 'RRM1_CPEB1', 2806),
(2807, 'cd19130', NULL, 'AKR_AKR5C1', NULL, NULL, 'AKR_AKR5C1', 2807),
(2808, 'cd06871', NULL, 'PX_MONaKA', NULL, NULL, 'PX_MONaKA', 2808),
(2809, 'cd08853', NULL, 'ArfGap_AGAP2', NULL, NULL, 'ArfGap_AGAP2', 2809),
(2810, 'cd18667', NULL, 'CD1_tandem_CHD3-4_like', NULL, NULL, 'CD1_tandem_CHD3-4_like', 2810),
(2811, 'cd08710', NULL, 'RGS_RGS16', NULL, NULL, 'RGS_RGS16', 2811),
(2812, 'cd14222', NULL, 'STKc_LIMK2', NULL, NULL, 'STKc_LIMK2', 2812),
(2813, 'cd18816', NULL, 'CAP_CRISPLD2', NULL, NULL, 'CAP_CRISPLD2', 2813),
(2814, 'cd13346', NULL, 'PH-GRAM_MTMR10', NULL, NULL, 'PH-GRAM_MTMR10', 2814),
(2815, 'cd15089', NULL, '7tmA_Delta_opioid_R', NULL, NULL, '7tmA_Delta_opioid_R', 2815),
(2816, 'cd15815', NULL, 'SPRY_PRY_TRIM38', NULL, NULL, 'SPRY_PRY_TRIM38', 2816),
(2817, 'cd16664', NULL, 'RING-Ubox_PUB', NULL, NULL, 'RING-Ubox_PUB', 2817),
(2818, 'cd16034', NULL, 'sulfatase_like', NULL, NULL, 'sulfatase_like', 2818),
(2819, 'cd17098', NULL, 'FERM_F1_FARP1_like', NULL, NULL, 'FERM_F1_FARP1_like', 2819),
(2820, 'cd03174', NULL, 'DRE_TIM_metallolyase', NULL, NULL, 'DRE_TIM_metallolyase', 2820),
(2821, 'cd01867', NULL, 'Rab8_Rab10_Rab13_like', NULL, NULL, 'Rab8_Rab10_Rab13_like', 2821),
(2822, 'cd07473', NULL, 'Peptidases_S8_Subtilisin_like', NULL, NULL, 'Peptidases_S8_Subtilisin_like', 2822),
(2823, 'cd08767', NULL, 'Cdt1_c', NULL, NULL, 'Cdt1_c', 2823),
(2824, 'cd16121', NULL, 'FERM_F1_SNX17', NULL, NULL, 'FERM_F1_SNX17', 2824),
(2825, 'cd20492', NULL, 'cupin_HQDO_large_C', NULL, NULL, 'cupin_HQDO_large_C', 2825),
(2826, 'cd07813', NULL, 'COQ10p_like', NULL, NULL, 'COQ10p_like', 2826),
(2827, 'cd10928', NULL, 'CE4_u4', NULL, NULL, 'CE4_u4', 2827),
(2828, 'cd01375', NULL, 'KISc_KIF9_like', NULL, NULL, 'KISc_KIF9_like', 2828),
(2829, 'cd13539', NULL, 'PBP2_AvModA', NULL, NULL, 'PBP2_AvModA', 2829),
(2830, 'cd05340', NULL, 'Ycik_SDR_c', NULL, NULL, 'Ycik_SDR_c', 2830),
(2831, 'cd00387', NULL, 'Ribosomal_L7_L12', NULL, NULL, 'Ribosomal_L7_L12', 2831),
(2832, 'cd01981', NULL, 'Pchlide_reductase_B', NULL, NULL, 'Pchlide_reductase_B', 2832),
(2833, 'cd10276', NULL, 'BamB_YfgL', NULL, NULL, 'BamB_YfgL', 2833),
(2834, 'cd16877', NULL, 'ARID_ARID1B', NULL, NULL, 'ARID_ARID1B', 2834),
(2835, 'cd10306', NULL, 'GST_C_GluRS_N', NULL, NULL, 'GST_C_GluRS_N', 2835),
(2836, 'cd18616', NULL, 'GH43_ABN-like', NULL, NULL, 'GH43_ABN-like', 2836),
(2837, 'cd18730', NULL, 'PIN_PH0500-like', NULL, NULL, 'PIN_PH0500-like', 2837),
(2838, 'cd14804', NULL, 'Tra_M', NULL, NULL, 'Tra_M', 2838),
(2839, 'cd11955', NULL, 'SH3_srGAP1-3', NULL, NULL, 'SH3_srGAP1-3', 2839),
(2840, 'cd01998', NULL, 'tRNA_Me_trans', NULL, NULL, 'tRNA_Me_trans', 2840),
(2841, 'cd13174', NULL, 'RanBD4_RanBP2_insect-like', NULL, NULL, 'RanBD4_RanBP2_insect-like', 2841),
(2842, 'cd05901', NULL, 'Ig_Versican', NULL, NULL, 'Ig_Versican', 2842),
(2843, 'cd15333', NULL, '7tmA_5-HT1B_1D', NULL, NULL, '7tmA_5-HT1B_1D', 2843),
(2844, 'cd06100', NULL, 'CCL_ACL-C', NULL, NULL, 'CCL_ACL-C', 2844),
(2845, 'cd08013', NULL, 'M20_ArgE_DapE-like', NULL, NULL, 'M20_ArgE_DapE-like', 2845),
(2846, 'cd19207', NULL, 'SET_KMT2B', NULL, NULL, 'SET_KMT2B', 2846);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(2847, 'cd01030', NULL, 'TOPRIM_TopoIIA_like', NULL, NULL, 'TOPRIM_TopoIIA_like', 2847),
(2848, 'cd01596', NULL, 'Aspartase_like', NULL, NULL, 'Aspartase_like', 2848),
(2849, 'cd15255', NULL, '7tmB2_GPR144', NULL, NULL, '7tmB2_GPR144', 2849),
(2850, 'cd16202', NULL, 'EFh_PI-PLCdelta', NULL, NULL, 'EFh_PI-PLCdelta', 2850),
(2851, 'cd18215', NULL, 'BTB_POZ_ZBTB27-like', NULL, NULL, 'BTB_POZ_ZBTB27-like', 2851),
(2852, 'cd17729', NULL, 'BRCT_CTDP1', NULL, NULL, 'BRCT_CTDP1', 2852),
(2853, 'cd00645', NULL, 'AsnA', NULL, NULL, 'AsnA', 2853),
(2854, 'cd06550', NULL, 'TM_ABC_iron-siderophores_like', NULL, NULL, 'TM_ABC_iron-siderophores_like', 2854),
(2855, 'cd12153', NULL, 'F1-ATPase_epsilon', NULL, NULL, 'F1-ATPase_epsilon', 2855),
(2856, 'cd15651', NULL, 'PHD2_NSD2', NULL, NULL, 'PHD2_NSD2', 2856),
(2857, 'cd00421', NULL, 'intradiol_dioxygenase', NULL, NULL, 'intradiol_dioxygenase', 2857),
(2858, 'cd19172', NULL, 'SET_SETD2', NULL, NULL, 'SET_SETD2', 2858),
(2859, 'cd20263', NULL, 'Complex1_LYR_NDUFB9_LYRM3', NULL, NULL, 'Complex1_LYR_NDUFB9_LYRM3', 2859),
(2860, 'cd17721', NULL, 'BRCT_BRCA1_rpt2', NULL, NULL, 'BRCT_BRCA1_rpt2', 2860),
(2861, 'cd07370', NULL, 'HPCD', NULL, NULL, 'HPCD', 2861),
(2862, 'cd13420', NULL, 'TNFRSF25', NULL, NULL, 'TNFRSF25', 2862),
(2863, 'cd15171', NULL, '7tmA_CCRL2', NULL, NULL, '7tmA_CCRL2', 2863),
(2864, 'cd15241', NULL, '7tm_ChRs', NULL, NULL, '7tm_ChRs', 2864),
(2865, 'cd19997', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, 'PBP1_ABC_sugar_binding-like', 2865),
(2866, 'cd19885', NULL, 'DSRM_STAU1_rpt4', NULL, NULL, 'DSRM_STAU1_rpt4', 2866),
(2867, 'cd14172', NULL, 'STKc_MAPKAPK3', NULL, NULL, 'STKc_MAPKAPK3', 2867),
(2868, 'cd06967', NULL, 'NR_DBD_TR2_like', NULL, NULL, 'NR_DBD_TR2_like', 2868),
(2869, 'cd18744', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, 'PIN_VapC4-5_FitB-like', 2869),
(2870, 'cd01244', NULL, 'PH_GAP1-like', NULL, NULL, 'PH_GAP1-like', 2870),
(2871, 'cd16120', NULL, 'UBX_UBXN3B', NULL, NULL, 'UBX_UBXN3B', 2871),
(2872, 'cd17315', NULL, 'MFS_GLUT_like', NULL, NULL, 'MFS_GLUT_like', 2872),
(2873, 'cd06206', NULL, 'bifunctional_CYPOR', NULL, NULL, 'bifunctional_CYPOR', 2873),
(2874, 'cd11698', NULL, 'DHR2_DOCK9', NULL, NULL, 'DHR2_DOCK9', 2874),
(2875, 'cd00394', NULL, 'Clp_protease_like', NULL, NULL, 'Clp_protease_like', 2875),
(2876, 'cd12019', NULL, 'SH3_Tks5_4', NULL, NULL, 'SH3_Tks5_4', 2876),
(2877, 'cd16555', NULL, 'RING-HC_RNF182', NULL, NULL, 'RING-HC_RNF182', 2877),
(2878, 'cd19791', NULL, 'Bbox2_TRIM60-like', NULL, NULL, 'Bbox2_TRIM60-like', 2878),
(2879, 'cd00174', NULL, 'SH3', NULL, NULL, 'SH3', 2879),
(2880, 'cd04658', NULL, 'Piwi_piwi-like_Euk', NULL, NULL, 'Piwi_piwi-like_Euk', 2880),
(2881, 'cd09913', NULL, 'EHD', NULL, NULL, 'EHD', 2881),
(2882, 'cd13434', NULL, 'SPFH_SLPs', NULL, NULL, 'SPFH_SLPs', 2882),
(2883, 'cd02763', NULL, 'MopB_2', NULL, NULL, 'MopB_2', 2883),
(2884, 'cd08775', NULL, 'DED_Caspase-like_r2', NULL, NULL, 'DED_Caspase-like_r2', 2884),
(2885, 'cd12459', NULL, 'RRM1_CID8_like', NULL, NULL, 'RRM1_CID8_like', 2885),
(2886, 'cd20272', NULL, 'Complex1_LYR_MIEF1-MP', NULL, NULL, 'Complex1_LYR_MIEF1-MP', 2886),
(2887, 'cd07570', NULL, 'GAT_Gln-NAD-synth', NULL, NULL, 'GAT_Gln-NAD-synth', 2887),
(2888, 'cd16981', NULL, 'CID_RPRD_like', NULL, NULL, 'CID_RPRD_like', 2888),
(2889, 'cd07736', NULL, 'PhnP-like_MBL-fold', NULL, NULL, 'PhnP-like_MBL-fold', 2889),
(2890, 'cd10509', NULL, 'Zn-ribbon_RPC11', NULL, NULL, 'Zn-ribbon_RPC11', 2890),
(2891, 'cd09453', NULL, 'LIM1_ENH', NULL, NULL, 'LIM1_ENH', 2891),
(2892, 'cd08365', NULL, 'APC10-like1', NULL, NULL, 'APC10-like1', 2892),
(2893, 'cd07569', NULL, 'DCase', NULL, NULL, 'DCase', 2893),
(2894, 'cd02507', NULL, 'eIF-2B_gamma_N_like', NULL, NULL, 'eIF-2B_gamma_N_like', 2894),
(2895, 'cd05846', NULL, 'Ig1_MRC-OX-2_like', NULL, NULL, 'Ig1_MRC-OX-2_like', 2895),
(2896, 'cd13241', NULL, 'PH2_Kalirin_Trio_p63RhoGEF', NULL, NULL, 'PH2_Kalirin_Trio_p63RhoGEF', 2896),
(2897, 'cd06362', NULL, 'PBP1_mGluR', NULL, NULL, 'PBP1_mGluR', 2897),
(2898, 'cd06171', NULL, 'Sigma70_r4', NULL, NULL, 'Sigma70_r4', 2898);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(2899, 'cd10507', NULL, 'Zn-ribbon_RPA12', NULL, NULL, 'Zn-ribbon_RPA12', 2899),
(2900, 'cd19946', NULL, 'GlpA-like_Fer2_BFD-like', NULL, NULL, 'GlpA-like_Fer2_BFD-like', 2900),
(2901, 'cd18303', NULL, 'BTB_POZ_Rank-5', NULL, NULL, 'BTB_POZ_Rank-5', 2901),
(2902, 'cd12380', NULL, 'RRM3_I_PABPs', NULL, NULL, 'RRM3_I_PABPs', 2902),
(2903, 'cd13432', NULL, 'LDT_IgD_like_2', NULL, NULL, 'LDT_IgD_like_2', 2903),
(2904, 'cd02961', NULL, 'PDI_a_family', NULL, NULL, 'PDI_a_family', 2904),
(2905, 'cd01046', NULL, 'Rubrerythrin_like', NULL, NULL, 'Rubrerythrin_like', 2905),
(2906, 'cd02541', NULL, 'UGPase_prokaryotic', NULL, NULL, 'UGPase_prokaryotic', 2906),
(2907, 'cd09150', NULL, 'PLDc_Ymt_1', NULL, NULL, 'PLDc_Ymt_1', 2907),
(2908, 'cd08838', NULL, 'ArfGap_AGFG', NULL, NULL, 'ArfGap_AGFG', 2908),
(2909, 'cd03506', NULL, 'Delta6-FADS-like', NULL, NULL, 'Delta6-FADS-like', 2909),
(2910, 'cd02058', NULL, 'serpinB_MENT-like', NULL, NULL, 'serpinB_MENT-like', 2910),
(2911, 'cd19335', NULL, 'Wnt_Wnt3_Wnt3a', NULL, NULL, 'Wnt_Wnt3_Wnt3a', 2911),
(2912, 'cd06266', NULL, 'RNase_HII', NULL, NULL, 'RNase_HII', 2912),
(2913, 'cd08948', NULL, '5beta-POR_like_SDR_a', NULL, NULL, '5beta-POR_like_SDR_a', 2913),
(2914, 'cd00284', NULL, 'Cytochrome_b_N', NULL, NULL, 'Cytochrome_b_N', 2914),
(2915, 'cd12447', NULL, 'RRM1_gar2', NULL, NULL, 'RRM1_gar2', 2915),
(2916, 'cd19367', NULL, 'TenA_C_ScTHI20-like', NULL, NULL, 'TenA_C_ScTHI20-like', 2916),
(2917, 'cd08275', NULL, 'MDR3', NULL, NULL, 'MDR3', 2917),
(2918, 'cd19603', NULL, 'serpin_platyhelminthes', NULL, NULL, 'serpin_platyhelminthes', 2918),
(2919, 'cd20310', NULL, 'cupin_L-RbI', NULL, NULL, 'cupin_L-RbI', 2919),
(2920, 'cd15115', NULL, '7tmA_C3aR', NULL, NULL, '7tmA_C3aR', 2920),
(2921, 'cd01977', NULL, 'Nitrogenase_VFe_alpha', NULL, NULL, 'Nitrogenase_VFe_alpha', 2921),
(2922, 'cd12892', NULL, 'SPRY_PRY_TRIM18', NULL, NULL, 'SPRY_PRY_TRIM18', 2922),
(2923, 'cd18811', NULL, 'SF2_C_RecG', NULL, NULL, 'SF2_C_RecG', 2923),
(2924, 'cd06299', NULL, 'PBP1_LacI-like', NULL, NULL, 'PBP1_LacI-like', 2924),
(2925, 'cd07751', NULL, 'PolyPPase_VTC4_like', NULL, NULL, 'PolyPPase_VTC4_like', 2925),
(2926, 'cd11914', NULL, 'SH3_BAIAP2L2', NULL, NULL, 'SH3_BAIAP2L2', 2926),
(2927, 'cd16782', NULL, 'mRING-HC-C3HC3D_Roquin2', NULL, NULL, 'mRING-HC-C3HC3D_Roquin2', 2927),
(2928, 'cd18657', NULL, 'CSD_Swi6', NULL, NULL, 'CSD_Swi6', 2928),
(2929, 'cd17640', NULL, 'LC_FACS_like', NULL, NULL, 'LC_FACS_like', 2929),
(2930, 'cd11805', NULL, 'SH3_GRB2_like_C', NULL, NULL, 'SH3_GRB2_like_C', 2930),
(2931, 'cd09653', NULL, 'Csa5_I-A', NULL, NULL, 'Csa5_I-A', 2931),
(2932, 'cd12391', NULL, 'RRM1_SART3', NULL, NULL, 'RRM1_SART3', 2932),
(2933, 'cd08788', NULL, 'CARD_NOD2_2_CARD15', NULL, NULL, 'CARD_NOD2_2_CARD15', 2933),
(2934, 'cd18639', NULL, 'CD_SUV39H1_like', NULL, NULL, 'CD_SUV39H1_like', 2934),
(2935, 'cd13568', NULL, 'PBP2_TAXI_TRAP_like_3', NULL, NULL, 'PBP2_TAXI_TRAP_like_3', 2935),
(2936, 'cd07416', NULL, 'MPP_PP2B', NULL, NULL, 'MPP_PP2B', 2936),
(2937, 'cd11271', NULL, 'Sema_plexin_A1', NULL, NULL, 'Sema_plexin_A1', 2937),
(2938, 'cd15676', NULL, 'PHD_BRPF1', NULL, NULL, 'PHD_BRPF1', 2938),
(2939, 'cd03160', NULL, 'CD37_CD82_like_LEL', NULL, NULL, 'CD37_CD82_like_LEL', 2939),
(2940, 'cd07429', NULL, 'Cby_like', NULL, NULL, 'Cby_like', 2940),
(2941, 'cd19733', NULL, 'bHLH-PAS_trachealess_like', NULL, NULL, 'bHLH-PAS_trachealess_like', 2941),
(2942, 'cd02653', NULL, 'nuc_hydro_3', NULL, NULL, 'nuc_hydro_3', 2942),
(2943, 'cd11840', NULL, 'SH3_Intersectin_5', NULL, NULL, 'SH3_Intersectin_5', 2943),
(2944, 'cd11619', NULL, 'HR1_CIP4-like', NULL, NULL, 'HR1_CIP4-like', 2944),
(2945, 'cd17383', NULL, 'MFS_SLC18A3_VAChT', NULL, NULL, 'MFS_SLC18A3_VAChT', 2945),
(2946, 'cd04487', NULL, 'RecJ_OBF2_like', NULL, NULL, 'RecJ_OBF2_like', 2946),
(2947, 'cd02226', NULL, 'cupin_YdbB-like', NULL, NULL, 'cupin_YdbB-like', 2947),
(2948, 'cd17722', NULL, 'BRCT_DNA_ligase_IV_rpt1', NULL, NULL, 'BRCT_DNA_ligase_IV_rpt1', 2948),
(2949, 'cd19440', NULL, 'lipocalin_Bla_g_4_Per_a_4', NULL, NULL, 'lipocalin_Bla_g_4_Per_a_4', 2949);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(2950, 'cd14238', NULL, 'GAT_TM1L2', NULL, NULL, 'GAT_TM1L2', 2950),
(2951, 'cd17908', NULL, 'FliM', NULL, NULL, 'FliM', 2951),
(2952, 'cd04770', NULL, 'HTH_HMRTR', NULL, NULL, 'HTH_HMRTR', 2952),
(2953, 'cd06323', NULL, 'PBP1_ribose_binding', NULL, NULL, 'PBP1_ribose_binding', 2953),
(2954, 'cd01836', NULL, 'FeeA_FeeB_like', NULL, NULL, 'FeeA_FeeB_like', 2954),
(2955, 'cd08416', NULL, 'PBP2_MdcR', NULL, NULL, 'PBP2_MdcR', 2955),
(2956, 'cd07688', NULL, 'IgC_TCR_alpha', NULL, NULL, 'IgC_TCR_alpha', 2956),
(2957, 'cd16531', NULL, 'RING-HC_RING1_like', NULL, NULL, 'RING-HC_RING1_like', 2957),
(2958, 'cd02869', NULL, 'PseudoU_synth_RluA_like', NULL, NULL, 'PseudoU_synth_RluA_like', 2958),
(2959, 'cd01454', NULL, 'vWA_norD_type', NULL, NULL, 'vWA_norD_type', 2959),
(2960, 'cd10327', NULL, 'SLC5sbd_PanF', NULL, NULL, 'SLC5sbd_PanF', 2960),
(2961, 'cd12413', NULL, 'RRM1_RBM28_like', NULL, NULL, 'RRM1_RBM28_like', 2961),
(2962, 'cd08869', NULL, 'START_RhoGAP', NULL, NULL, 'START_RhoGAP', 2962),
(2963, 'cd18017', NULL, 'DEXHc_RecQ3', NULL, NULL, 'DEXHc_RecQ3', 2963),
(2964, 'cd14003', NULL, 'STKc_AMPK-like', NULL, NULL, 'STKc_AMPK-like', 2964),
(2965, 'cd07715', NULL, 'TaR3-like_MBL-fold', NULL, NULL, 'TaR3-like_MBL-fold', 2965),
(2966, 'cd12622', NULL, 'RRM3_PUB1', NULL, NULL, 'RRM3_PUB1', 2966),
(2967, 'cd06157', NULL, 'NR_LBD', NULL, NULL, 'NR_LBD', 2967),
(2968, 'cd09199', NULL, 'PLDc_pPLDalpha_2', NULL, NULL, 'PLDc_pPLDalpha_2', 2968),
(2969, 'cd18778', NULL, 'ABC_6TM_exporter_like', NULL, NULL, 'ABC_6TM_exporter_like', 2969),
(2970, 'cd12660', NULL, 'RRM2_MYEF2', NULL, NULL, 'RRM2_MYEF2', 2970),
(2971, 'cd18576', NULL, 'ABC_6TM_bac_exporter_ABCB8_10_like', NULL, NULL, 'ABC_6TM_bac_exporter_ABCB8_10_like', 2971),
(2972, 'cd07412', NULL, 'MPP_YhcR_N', NULL, NULL, 'MPP_YhcR_N', 2972),
(2973, 'cd18219', NULL, 'BTB_POZ_ZBTB33_KAISO', NULL, NULL, 'BTB_POZ_ZBTB33_KAISO', 2973),
(2974, 'cd19152', NULL, 'AKR_AKR15A', NULL, NULL, 'AKR_AKR15A', 2974),
(2975, 'cd15336', NULL, '7tmA_Melanopsin', NULL, NULL, '7tmA_Melanopsin', 2975),
(2976, 'cd16970', NULL, 'Alpha_kinase_VwkA_like', NULL, NULL, 'Alpha_kinase_VwkA_like', 2976),
(2977, 'cd10462', NULL, 'PUB_UBA', NULL, NULL, 'PUB_UBA', 2977),
(2978, 'cd15973', NULL, '7tmA_SSTR4', NULL, NULL, '7tmA_SSTR4', 2978),
(2979, 'cd04183', NULL, 'GT2_BcE_like', NULL, NULL, 'GT2_BcE_like', 2979),
(2980, 'cd10434', NULL, 'GIY-YIG_UvrC_Cho', NULL, NULL, 'GIY-YIG_UvrC_Cho', 2980),
(2981, 'cd06911', NULL, 'VirB9_CagX_TrbG', NULL, NULL, 'VirB9_CagX_TrbG', 2981),
(2982, 'cd10803', NULL, 'YdjC_EF3048_like', NULL, NULL, 'YdjC_EF3048_like', 2982),
(2983, 'cd11431', NULL, 'bHLH_TS_taxi_Dei', NULL, NULL, 'bHLH_TS_taxi_Dei', 2983),
(2984, 'cd00470', NULL, 'PTPS', NULL, NULL, 'PTPS', 2984),
(2985, 'cd15355', NULL, '7tmA_NTSR1', NULL, NULL, '7tmA_NTSR1', 2985),
(2986, 'cd19216', NULL, 'PR-SET_ZFPM2', NULL, NULL, 'PR-SET_ZFPM2', 2986),
(2987, 'cd17174', NULL, 'FERM_F1_TLN2', NULL, NULL, 'FERM_F1_TLN2', 2987),
(2988, 'cd19884', NULL, 'DSRM_STAU2_rpt3', NULL, NULL, 'DSRM_STAU2_rpt3', 2988),
(2989, 'cd11471', NULL, 'bHLH_TS_HAND2', NULL, NULL, 'bHLH_TS_HAND2', 2989),
(2990, 'cd07792', NULL, 'FGGY_GK1-3_metazoa', NULL, NULL, 'FGGY_GK1-3_metazoa', 2990),
(2991, 'cd09077', NULL, 'R1-I-EN', NULL, NULL, 'R1-I-EN', 2991),
(2992, 'cd10450', NULL, 'GIY-YIG_AtGrxS16_like', NULL, NULL, 'GIY-YIG_AtGrxS16_like', 2992),
(2993, 'cd00844', NULL, 'MPP_Dbr1_N', NULL, NULL, 'MPP_Dbr1_N', 2993),
(2994, 'cd04979', NULL, 'Ig_Semaphorin_C', NULL, NULL, 'Ig_Semaphorin_C', 2994),
(2995, 'cd14028', NULL, 'STKc_Bub1_vert', NULL, NULL, 'STKc_Bub1_vert', 2995),
(2996, 'cd20238', NULL, 'PFM_ABFB-like', NULL, NULL, 'PFM_ABFB-like', 2996),
(2997, 'cd03162', NULL, 'peripherin_like_LEL', NULL, NULL, 'peripherin_like_LEL', 2997),
(2998, 'cd07093', NULL, 'ALDH_F8_HMSADH', NULL, NULL, 'ALDH_F8_HMSADH', 2998),
(2999, 'cd11381', NULL, 'NSA2', NULL, NULL, 'NSA2', 2999),
(3000, 'cd17647', NULL, 'A_NRPS_alphaAR', NULL, NULL, 'A_NRPS_alphaAR', 3000),
(3001, 'cd18282', NULL, 'BTB_POZ_BTBD3_6', NULL, NULL, 'BTB_POZ_BTBD3_6', 3001);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(3002, 'cd19085', NULL, 'AKR_AKR11B3', NULL, NULL, 'AKR_AKR11B3', 3002),
(3003, 'cd01367', NULL, 'KISc_KIF2_like', NULL, NULL, 'KISc_KIF2_like', 3003),
(3004, 'cd04189', NULL, 'G1P_TT_long', NULL, NULL, 'G1P_TT_long', 3004),
(3005, 'cd05148', NULL, 'PTKc_Srm_Brk', NULL, NULL, 'PTKc_Srm_Brk', 3005),
(3006, 'cd12950', NULL, 'RRP7_Rrp7p', NULL, NULL, 'RRP7_Rrp7p', 3006),
(3007, 'cd18183', NULL, 'ATP-synt_Fo_c_ATPH', NULL, NULL, 'ATP-synt_Fo_c_ATPH', 3007),
(3008, 'cd01167', NULL, 'bac_FRK', NULL, NULL, 'bac_FRK', 3008),
(3009, 'cd18071', NULL, 'DEXHc_HLTF1_SMARC3', NULL, NULL, 'DEXHc_HLTF1_SMARC3', 3009),
(3010, 'cd09552', NULL, 'SAM_EPH-B2', NULL, NULL, 'SAM_EPH-B2', 3010),
(3011, 'cd04229', NULL, 'CuRO_1_Ceruloplasmin_like_1', NULL, NULL, 'CuRO_1_Ceruloplasmin_like_1', 3011),
(3012, 'cd13604', NULL, 'PBP2_TRAP_ketoacid_lactate_like', NULL, NULL, 'PBP2_TRAP_ketoacid_lactate_like', 3012),
(3013, 'cd15296', NULL, '7tmA_Histamine_H3R', NULL, NULL, '7tmA_Histamine_H3R', 3013),
(3014, 'cd18321', NULL, 'BTB_POZ_EloC', NULL, NULL, 'BTB_POZ_EloC', 3014),
(3015, 'cd07618', NULL, 'BAR_Rich1', NULL, NULL, 'BAR_Rich1', 3015),
(3016, 'cd10553', NULL, 'PhsB_like', NULL, NULL, 'PhsB_like', 3016),
(3017, 'cd07126', NULL, 'ALDH_F12_P5CDH', NULL, NULL, 'ALDH_F12_P5CDH', 3017),
(3018, 'cd17050', NULL, 'Ubl1_ANKUB1', NULL, NULL, 'Ubl1_ANKUB1', 3018),
(3019, 'cd19446', NULL, 'FABP6', NULL, NULL, 'FABP6', 3019),
(3020, 'cd03254', NULL, 'ABCC_Glucan_exporter_like', NULL, NULL, 'ABCC_Glucan_exporter_like', 3020),
(3021, 'cd16683', NULL, 'RING-H2_RNF139', NULL, NULL, 'RING-H2_RNF139', 3021),
(3022, 'cd09190', NULL, 'PLDc_DNaseII_beta_1', NULL, NULL, 'PLDc_DNaseII_beta_1', 3022),
(3023, 'cd10389', NULL, 'SH2_SHB', NULL, NULL, 'SH2_SHB', 3023),
(3024, 'cd15618', NULL, 'PHD1_MOZ_MORF', NULL, NULL, 'PHD1_MOZ_MORF', 3024),
(3025, 'cd14581', NULL, 'DUSP22', NULL, NULL, 'DUSP22', 3025),
(3026, 'cd01044', NULL, 'Ferritin_CCC1_N', NULL, NULL, 'Ferritin_CCC1_N', 3026),
(3027, 'cd06462', NULL, 'Peptidase_S24_S26', NULL, NULL, 'Peptidase_S24_S26', 3027),
(3028, 'cd00899', NULL, 'b4GalT', NULL, NULL, 'b4GalT', 3028),
(3029, 'cd03220', NULL, 'ABC_KpsT_Wzt', NULL, NULL, 'ABC_KpsT_Wzt', 3029),
(3030, 'cd06380', NULL, 'PBP1_iGluR_AMPA', NULL, NULL, 'PBP1_iGluR_AMPA', 3030),
(3031, 'cd08911', NULL, 'START_STARD7-like', NULL, NULL, 'START_STARD7-like', 3031),
(3032, 'cd17966', NULL, 'DEADc_DDX5_DDX17', NULL, NULL, 'DEADc_DDX5_DDX17', 3032),
(3033, 'cd06481', NULL, 'ACD_HspB9_like', NULL, NULL, 'ACD_HspB9_like', 3033),
(3034, 'cd04133', NULL, 'Rop_like', NULL, NULL, 'Rop_like', 3034),
(3035, 'cd11791', NULL, 'SH3_UBASH3', NULL, NULL, 'SH3_UBASH3', 3035),
(3036, 'cd09845', NULL, 'PLDc_vPLD2_2', NULL, NULL, 'PLDc_vPLD2_2', 3036),
(3037, 'cd15378', NULL, '7tmA_SUCNR1_GPR91', NULL, NULL, '7tmA_SUCNR1_GPR91', 3037),
(3038, 'cd03289', NULL, 'ABCC_CFTR2', NULL, NULL, 'ABCC_CFTR2', 3038),
(3039, 'cd18896', NULL, 'TET2', NULL, NULL, 'TET2', 3039),
(3040, 'cd08403', NULL, 'C2B_Synaptotagmin-3-5-6-9-10', NULL, NULL, 'C2B_Synaptotagmin-3-5-6-9-10', 3040),
(3041, 'cd13566', NULL, 'PBP2_phosphate', NULL, NULL, 'PBP2_phosphate', 3041),
(3042, 'cd04200', NULL, 'CuRO_2_ceruloplasmin_like', NULL, NULL, 'CuRO_2_ceruloplasmin_like', 3042),
(3043, 'cd05567', NULL, 'PTS_IIB_mannitol', NULL, NULL, 'PTS_IIB_mannitol', 3043),
(3044, 'cd13591', NULL, 'PBP2_HisGL1', NULL, NULL, 'PBP2_HisGL1', 3044),
(3045, 'cd12275', NULL, 'RRM1_MEI2_EAR1_like', NULL, NULL, 'RRM1_MEI2_EAR1_like', 3045),
(3046, 'cd05301', NULL, 'GDH', NULL, NULL, 'GDH', 3046),
(3047, 'cd17627', NULL, 'REC_OmpR_PrrA-like', NULL, NULL, 'REC_OmpR_PrrA-like', 3047),
(3048, 'cd19790', NULL, 'Bbox2_TRIM59_C-XI', NULL, NULL, 'Bbox2_TRIM59_C-XI', 3048),
(3049, 'cd16401', NULL, 'ParB_N_like_MT', NULL, NULL, 'ParB_N_like_MT', 3049),
(3050, 'cd15193', NULL, '7tmA_GPR25', NULL, NULL, '7tmA_GPR25', 3050),
(3051, 'cd06218', NULL, 'DHOD_e_trans', NULL, NULL, 'DHOD_e_trans', 3051),
(3052, 'cd13145', NULL, 'MATE_like_5', NULL, NULL, 'MATE_like_5', 3052),
(3053, 'cd16193', NULL, 'EFh_PEF_CAPN11', NULL, NULL, 'EFh_PEF_CAPN11', 3053);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(3054, 'cd09672', NULL, 'Cas8a1_I-A', NULL, NULL, 'Cas8a1_I-A', 3054),
(3055, 'cd04081', NULL, 'CBM35_galactosidase-like', NULL, NULL, 'CBM35_galactosidase-like', 3055),
(3056, 'cd10467', NULL, 'FAM20_C_like', NULL, NULL, 'FAM20_C_like', 3056),
(3057, 'cd10339', NULL, 'SH2_RIN_family', NULL, NULL, 'SH2_RIN_family', 3057),
(3058, 'cd15494', NULL, 'PHD_ATX1_2_like', NULL, NULL, 'PHD_ATX1_2_like', 3058),
(3059, 'cd12602', NULL, 'RRM2_SF2_plant_like', NULL, NULL, 'RRM2_SF2_plant_like', 3059),
(3060, 'cd11776', NULL, 'SH3_PI3K_p85', NULL, NULL, 'SH3_PI3K_p85', 3060),
(3061, 'cd03530', NULL, 'Rieske_NirD_small_Bacillus', NULL, NULL, 'Rieske_NirD_small_Bacillus', 3061),
(3062, 'cd11994', NULL, 'SH3_Intersectin2_4', NULL, NULL, 'SH3_Intersectin2_4', 3062),
(3063, 'cd17942', NULL, 'DEADc_DDX18', NULL, NULL, 'DEADc_DDX18', 3063),
(3064, 'cd08492', NULL, 'PBP2_NikA_DppA_OppA_like_15', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_15', 3064),
(3065, 'cd03687', NULL, 'Dehydratase_LU', NULL, NULL, 'Dehydratase_LU', 3065),
(3066, 'cd18046', NULL, 'DEADc_EIF4AII_EIF4AI_DDX2', NULL, NULL, 'DEADc_EIF4AII_EIF4AI_DDX2', 3066),
(3067, 'cd01049', NULL, 'RNRR2', NULL, NULL, 'RNRR2', 3067),
(3068, 'cd09618', NULL, 'CBM9_like_2', NULL, NULL, 'CBM9_like_2', 3068),
(3069, 'cd01305', NULL, 'archeal_chlorohydrolases', NULL, NULL, 'archeal_chlorohydrolases', 3069),
(3070, 'cd04794', NULL, 'euk_LANCL', NULL, NULL, 'euk_LANCL', 3070),
(3071, 'cd07823', NULL, 'SRPBCC_5', NULL, NULL, 'SRPBCC_5', 3071),
(3072, 'cd08915', NULL, 'V_Alix_like', NULL, NULL, 'V_Alix_like', 3072),
(3073, 'cd01254', NULL, 'PH_PLD', NULL, NULL, 'PH_PLD', 3073),
(3074, 'cd12188', NULL, 'SDH', NULL, NULL, 'SDH', 3074),
(3075, 'cd05107', NULL, 'PTKc_PDGFR_beta', NULL, NULL, 'PTKc_PDGFR_beta', 3075),
(3076, 'cd16752', NULL, 'RING-HC_SIAH2', NULL, NULL, 'RING-HC_SIAH2', 3076),
(3077, 'cd19797', NULL, 'Bbox2_TRIM72_C-IV', NULL, NULL, 'Bbox2_TRIM72_C-IV', 3077),
(3078, 'cd02737', NULL, 'RNAP_IV_NRPD1_C', NULL, NULL, 'RNAP_IV_NRPD1_C', 3078),
(3079, 'cd17572', NULL, 'REC_NtrC1-like', NULL, NULL, 'REC_NtrC1-like', 3079),
(3080, 'cd18962', NULL, 'CD_MT_like', NULL, NULL, 'CD_MT_like', 3080),
(3081, 'cd19022', NULL, 'LGIC_ECD_nAChR_A9', NULL, NULL, 'LGIC_ECD_nAChR_A9', 3081),
(3082, 'cd09940', NULL, 'SH2_Vav_family', NULL, NULL, 'SH2_Vav_family', 3082),
(3083, 'cd12107', NULL, 'Hemerythrin', NULL, NULL, 'Hemerythrin', 3083),
(3084, 'cd09020', NULL, 'D-hex-6-P-epi_like', NULL, NULL, 'D-hex-6-P-epi_like', 3084),
(3085, 'cd11432', NULL, 'bHLH-PAS_NPAS1_3_like', NULL, NULL, 'bHLH-PAS_NPAS1_3_like', 3085),
(3086, 'cd12238', NULL, 'RRM1_RBM40_like', NULL, NULL, 'RRM1_RBM40_like', 3086),
(3087, 'cd05939', NULL, 'hsFATP4_like', NULL, NULL, 'hsFATP4_like', 3087),
(3088, 'cd14846', NULL, 'Peptidase_M15_like', NULL, NULL, 'Peptidase_M15_like', 3088),
(3089, 'cd01721', NULL, 'Sm_D3', NULL, NULL, 'Sm_D3', 3089),
(3090, 'cd14553', NULL, 'R-PTPc-LAR-1', NULL, NULL, 'R-PTPc-LAR-1', 3090),
(3091, 'cd20233', NULL, 'PFM_unzipped-like', NULL, NULL, 'PFM_unzipped-like', 3091),
(3092, 'cd21410', NULL, '1B_av_Nsp10-like', NULL, NULL, '1B_av_Nsp10-like', 3092),
(3093, 'cd11010', NULL, 'S1-P1_nuclease', NULL, NULL, 'S1-P1_nuclease', 3093),
(3094, 'cd18024', NULL, 'DEXHc_Mtr4-like', NULL, NULL, 'DEXHc_Mtr4-like', 3094),
(3095, 'cd17736', NULL, 'BRCT_microcephalin_rpt2', NULL, NULL, 'BRCT_microcephalin_rpt2', 3095),
(3096, 'cd15912', NULL, '7tmA_OR6C-like', NULL, NULL, '7tmA_OR6C-like', 3096),
(3097, 'cd07355', NULL, 'HN_L-delphilin-R2_like', NULL, NULL, 'HN_L-delphilin-R2_like', 3097),
(3098, 'cd04234', NULL, 'AAK_AK', NULL, NULL, 'AAK_AK', 3098),
(3099, 'cd16028', NULL, 'PMH', NULL, NULL, 'PMH', 3099),
(3100, 'cd02672', NULL, 'Peptidase_C19P', NULL, NULL, 'Peptidase_C19P', 3100),
(3101, 'cd06286', NULL, 'PBP1_CcpB-like', NULL, NULL, 'PBP1_CcpB-like', 3101),
(3102, 'cd07740', NULL, 'metallo-hydrolase-like_MBL-fold', NULL, NULL, 'metallo-hydrolase-like_MBL-fold', 3102),
(3103, 'cd14425', NULL, 'UBA1_HR23A', NULL, NULL, 'UBA1_HR23A', 3103),
(3104, 'cd02947', NULL, 'TRX_family', NULL, NULL, 'TRX_family', 3104);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(3105, 'cd00055', NULL, 'EGF_Lam', NULL, NULL, 'EGF_Lam', 3105),
(3106, 'cd03419', NULL, 'GRX_GRXh_1_2_like', NULL, NULL, 'GRX_GRXh_1_2_like', 3106),
(3107, 'cd18935', NULL, 'bHLH_TS_MYOG_Myf4', NULL, NULL, 'bHLH_TS_MYOG_Myf4', 3107),
(3108, 'cd02696', NULL, 'MurNAc-LAA', NULL, NULL, 'MurNAc-LAA', 3108),
(3109, 'cd14675', NULL, 'PH-SEC3_like', NULL, NULL, 'PH-SEC3_like', 3109),
(3110, 'cd04776', NULL, 'HTH_GnyR', NULL, NULL, 'HTH_GnyR', 3110),
(3111, 'cd12836', NULL, 'HpCorA-like', NULL, NULL, 'HpCorA-like', 3111),
(3112, 'cd00865', NULL, 'PEBP_bact_arch', NULL, NULL, 'PEBP_bact_arch', 3112),
(3113, 'cd08366', NULL, 'APC10', NULL, NULL, 'APC10', 3113),
(3114, 'cd18827', NULL, 'GH43_XlnD-like', NULL, NULL, 'GH43_XlnD-like', 3114),
(3115, 'cd13518', NULL, 'PBP2_Fe3_thiamine_like', NULL, NULL, 'PBP2_Fe3_thiamine_like', 3115),
(3116, 'cd08184', NULL, 'Fe-ADH_KdnB-like', NULL, NULL, 'Fe-ADH_KdnB-like', 3116),
(3117, 'cd18520', NULL, 'BACK_roadkill_like', NULL, NULL, 'BACK_roadkill_like', 3117),
(3118, 'cd18615', NULL, 'GH130', NULL, NULL, 'GH130', 3118),
(3119, 'cd08459', NULL, 'PBP2_DntR_NahR_LinR_like', NULL, NULL, 'PBP2_DntR_NahR_LinR_like', 3119),
(3120, 'cd15972', NULL, '7tmA_SSTR3', NULL, NULL, '7tmA_SSTR3', 3120),
(3121, 'cd18676', NULL, 'PIN_asteroid-like', NULL, NULL, 'PIN_asteroid-like', 3121),
(3122, 'cd04677', NULL, 'Nudix_Hydrolase_18', NULL, NULL, 'Nudix_Hydrolase_18', 3122),
(3123, 'cd01733', NULL, 'LSm10', NULL, NULL, 'LSm10', 3123),
(3124, 'cd03461', NULL, '1,2-HQD', NULL, NULL, '1,2-HQD', 3124),
(3125, 'cd07148', NULL, 'ALDH_RL0313', NULL, NULL, 'ALDH_RL0313', 3125),
(3126, 'cd15655', NULL, 'PHD3_NSD3', NULL, NULL, 'PHD3_NSD3', 3126),
(3127, 'cd05083', NULL, 'PTKc_Chk', NULL, NULL, 'PTKc_Chk', 3127),
(3128, 'cd14830', NULL, 'Delta_COP_N', NULL, NULL, 'Delta_COP_N', 3128),
(3129, 'cd05681', NULL, 'M20_dipept_Sso-CP2', NULL, NULL, 'M20_dipept_Sso-CP2', 3129),
(3130, 'cd19093', NULL, 'AKR_AtPLR-like', NULL, NULL, 'AKR_AtPLR-like', 3130),
(3131, 'cd19732', NULL, 'bHLH-PAS_NPAS3_PASD6', NULL, NULL, 'bHLH-PAS_NPAS3_PASD6', 3131),
(3132, 'cd14066', NULL, 'STKc_IRAK', NULL, NULL, 'STKc_IRAK', 3132),
(3133, 'cd02690', NULL, 'M28', NULL, NULL, 'M28', 3133),
(3134, 'cd06315', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, 'PBP1_ABC_sugar_binding-like', 3134),
(3135, 'cd12749', NULL, 'RRM4_RBM12', NULL, NULL, 'RRM4_RBM12', 3135),
(3136, 'cd15999', NULL, '7tmB2_GPR125', NULL, NULL, '7tmB2_GPR125', 3136),
(3137, 'cd11526', NULL, 'SYLF_FYVE', NULL, NULL, 'SYLF_FYVE', 3137),
(3138, 'cd16725', NULL, 'RING2-HC_MIB1', NULL, NULL, 'RING2-HC_MIB1', 3138),
(3139, 'cd17134', NULL, 'RBD_BRAF', NULL, NULL, 'RBD_BRAF', 3139),
(3140, 'cd02067', NULL, 'B12-binding', NULL, NULL, 'B12-binding', 3140),
(3141, 'cd09879', NULL, 'PIN_VapC_AF0591-like', NULL, NULL, 'PIN_VapC_AF0591-like', 3141),
(3142, 'cd17400', NULL, 'MFS_SLCO1_OATP1', NULL, NULL, 'MFS_SLCO1_OATP1', 3142),
(3143, 'cd10438', NULL, 'GIY-YIG_MSH', NULL, NULL, 'GIY-YIG_MSH', 3143),
(3144, 'cd16239', NULL, 'EFh_SPARC_TICN3', NULL, NULL, 'EFh_SPARC_TICN3', 3144),
(3145, 'cd19906', NULL, 'DSRM_ADAD2', NULL, NULL, 'DSRM_ADAD2', 3145),
(3146, 'cd16906', NULL, 'YEATS_AF-9_like', NULL, NULL, 'YEATS_AF-9_like', 3146),
(3147, 'cd12698', NULL, 'RRM3_PTBPH3', NULL, NULL, 'RRM3_PTBPH3', 3147),
(3148, 'cd03773', NULL, 'MATH_TRIM37', NULL, NULL, 'MATH_TRIM37', 3148),
(3149, 'cd19034', NULL, 'LGIC_ECD_GABAAR_A1', NULL, NULL, 'LGIC_ECD_GABAAR_A1', 3149),
(3150, 'cd10410', NULL, 'SH2_SH2B1', NULL, NULL, 'SH2_SH2B1', 3150),
(3151, 'cd14243', NULL, 'PT-AcyF_like', NULL, NULL, 'PT-AcyF_like', 3151),
(3152, 'cd09646', NULL, 'Cas7_I-E', NULL, NULL, 'Cas7_I-E', 3152),
(3153, 'cd18587', NULL, 'ABC_6TM_LapB_like', NULL, NULL, 'ABC_6TM_LapB_like', 3153),
(3154, 'cd09707', NULL, 'Csf3_U', NULL, NULL, 'Csf3_U', 3154),
(3155, 'cd15231', NULL, '7tmA_OR5V1-like', NULL, NULL, '7tmA_OR5V1-like', 3155),
(3156, 'cd16222', NULL, 'EFh_PRIP1', NULL, NULL, 'EFh_PRIP1', 3156),
(3157, 'cd13220', NULL, 'PH-GRAM_GRAMDC', NULL, NULL, 'PH-GRAM_GRAMDC', 3157),
(3158, 'cd16299', NULL, 'IND_BlaB-like_MBL-B1', NULL, NULL, 'IND_BlaB-like_MBL-B1', 3158);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(3159, 'cd07608', NULL, 'BAR_ArfGAP_fungi', NULL, NULL, 'BAR_ArfGAP_fungi', 3159),
(3160, 'cd18487', NULL, 'BACK_BTBD1_like', NULL, NULL, 'BACK_BTBD1_like', 3160),
(3161, 'cd01152', NULL, 'ACAD_fadE6_17_26', NULL, NULL, 'ACAD_fadE6_17_26', 3161),
(3162, 'cd12311', NULL, 'RRM_SRSF2_SRSF8', NULL, NULL, 'RRM_SRSF2_SRSF8', 3162),
(3163, 'cd03008', NULL, 'TryX_like_RdCVF', NULL, NULL, 'TryX_like_RdCVF', 3163),
(3164, 'cd13918', NULL, 'CuRO_HCO_II_like_6', NULL, NULL, 'CuRO_HCO_II_like_6', 3164),
(3165, 'cd13668', NULL, 'PBP2_TRAP_UehA_TeaA', NULL, NULL, 'PBP2_TRAP_UehA_TeaA', 3165),
(3166, 'cd02873', NULL, 'GH18_IDGF', NULL, NULL, 'GH18_IDGF', 3166),
(3167, 'cd07089', NULL, 'ALDH_CddD-AldA-like', NULL, NULL, 'ALDH_CddD-AldA-like', 3167),
(3168, 'cd07247', NULL, 'SgaA_N_like', NULL, NULL, 'SgaA_N_like', 3168),
(3169, 'cd09588', NULL, 'SAM_LBP1', NULL, NULL, 'SAM_LBP1', 3169),
(3170, 'cd19374', NULL, 'UDG-F3_SMUG1-like', NULL, NULL, 'UDG-F3_SMUG1-like', 3170),
(3171, 'cd05022', NULL, 'S-100A13', NULL, NULL, 'S-100A13', 3171),
(3172, 'cd00494', NULL, 'PBP2_HMBS', NULL, NULL, 'PBP2_HMBS', 3172),
(3173, 'cd00229', NULL, 'SGNH_hydrolase', NULL, NULL, 'SGNH_hydrolase', 3173),
(3174, 'cd07005', NULL, 'cupin_WbuC-like', NULL, NULL, 'cupin_WbuC-like', 3174),
(3175, 'cd13639', NULL, 'PBP2_OpuAC_like', NULL, NULL, 'PBP2_OpuAC_like', 3175),
(3176, 'cd05598', NULL, 'STKc_LATS', NULL, NULL, 'STKc_LATS', 3176),
(3177, 'cd10361', NULL, 'SH2_Fps_family', NULL, NULL, 'SH2_Fps_family', 3177),
(3178, 'cd09299', NULL, 'TDT', NULL, NULL, 'TDT', 3178),
(3179, 'cd17872', NULL, 'GPN3', NULL, NULL, 'GPN3', 3179),
(3180, 'cd11709', NULL, 'SPRY', NULL, NULL, 'SPRY', 3180),
(3181, 'cd14982', NULL, '7tmA_purinoceptor-like', NULL, NULL, '7tmA_purinoceptor-like', 3181),
(3182, 'cd02036', NULL, 'MinD', NULL, NULL, 'MinD', 3182),
(3183, 'cd03214', NULL, 'ABC_Iron-Siderophores_B12_Hemin', NULL, NULL, 'ABC_Iron-Siderophores_B12_Hemin', 3183),
(3184, 'cd05334', NULL, 'DHPR_SDR_c_like', NULL, NULL, 'DHPR_SDR_c_like', 3184),
(3185, 'cd15264', NULL, '7tmB1_CRF-R', NULL, NULL, '7tmB1_CRF-R', 3185),
(3186, 'cd01197', NULL, 'INT_FimBE_like', NULL, NULL, 'INT_FimBE_like', 3186),
(3187, 'cd08276', NULL, 'MDR7', NULL, NULL, 'MDR7', 3187),
(3188, 'cd10958', NULL, 'CE4_NodB_like_2', NULL, NULL, 'CE4_NodB_like_2', 3188),
(3189, 'cd11459', NULL, 'bHLH-O_HES1_4', NULL, NULL, 'bHLH-O_HES1_4', 3189),
(3190, 'cd03713', NULL, 'EFG_mtEFG_C', NULL, NULL, 'EFG_mtEFG_C', 3190),
(3191, 'cd14892', NULL, 'MYSc_Myo31', NULL, NULL, 'MYSc_Myo31', 3191),
(3192, 'cd06949', NULL, 'NR_LBD_ER', NULL, NULL, 'NR_LBD_ER', 3192),
(3193, 'cd14246', NULL, 'ADAM17_MPD', NULL, NULL, 'ADAM17_MPD', 3193),
(3194, 'cd10401', NULL, 'SH2_C-SH2_Syk_like', NULL, NULL, 'SH2_C-SH2_Syk_like', 3194),
(3195, 'cd15700', NULL, 'ePHD_RAI1', NULL, NULL, 'ePHD_RAI1', 3195),
(3196, 'cd05617', NULL, 'STKc_aPKC_zeta', NULL, NULL, 'STKc_aPKC_zeta', 3196),
(3197, 'cd14907', NULL, 'MYSc_Myo46', NULL, NULL, 'MYSc_Myo46', 3197),
(3198, 'cd01253', NULL, 'PH_ARHGAP21-like', NULL, NULL, 'PH_ARHGAP21-like', 3198),
(3199, 'cd03868', NULL, 'M14_CPD_I', NULL, NULL, 'M14_CPD_I', 3199),
(3200, 'cd16928', NULL, 'HATPase_GyrB-like', NULL, NULL, 'HATPase_GyrB-like', 3200),
(3201, 'cd12966', NULL, 'CBM-Ec_CBM-Fc', NULL, NULL, 'CBM-Ec_CBM-Fc', 3201),
(3202, 'cd00570', NULL, 'GST_N_family', NULL, NULL, 'GST_N_family', 3202),
(3203, 'cd15714', NULL, 'ePHD_JMJD2B', NULL, NULL, 'ePHD_JMJD2B', 3203),
(3204, 'cd02064', NULL, 'FAD_synthetase_N', NULL, NULL, 'FAD_synthetase_N', 3204),
(3205, 'cd07447', NULL, 'CRD_Carboxypeptidase_Z', NULL, NULL, 'CRD_Carboxypeptidase_Z', 3205),
(3206, 'cd06160', NULL, 'S2P-M50_like_2', NULL, NULL, 'S2P-M50_like_2', 3206),
(3207, 'cd04692', NULL, 'Nudix_Hydrolase_33', NULL, NULL, 'Nudix_Hydrolase_33', 3207),
(3208, 'cd07492', NULL, 'Peptidases_S8_8', NULL, NULL, 'Peptidases_S8_8', 3208),
(3209, 'cd13563', NULL, 'PBP2_SsuA_like_6', NULL, NULL, 'PBP2_SsuA_like_6', 3209),
(3210, 'cd02209', NULL, 'cupin_XRE_C', NULL, NULL, 'cupin_XRE_C', 3210),
(3211, 'cd08382', NULL, 'C2_Smurf-like', NULL, NULL, 'C2_Smurf-like', 3211);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(3212, 'cd13939', NULL, 'PANDER_FAM3B', NULL, NULL, 'PANDER_FAM3B', 3212),
(3213, 'cd19606', NULL, 'GH113-like', NULL, NULL, 'GH113-like', 3213),
(3214, 'cd18806', NULL, 'SF2_C_viral', NULL, NULL, 'SF2_C_viral', 3214),
(3215, 'cd18635', NULL, 'CD_CMT3_like', NULL, NULL, 'CD_CMT3_like', 3215),
(3216, 'cd12880', NULL, 'SPRYD7', NULL, NULL, 'SPRYD7', 3216),
(3217, 'cd13134', NULL, 'MATE_like_8', NULL, NULL, 'MATE_like_8', 3217),
(3218, 'cd09742', NULL, 'Csm6_III-A', NULL, NULL, 'Csm6_III-A', 3218),
(3219, 'cd06406', NULL, 'PB1_P67', NULL, NULL, 'PB1_P67', 3219),
(3220, 'cd16910', NULL, 'YEATS_TFIID14_like', NULL, NULL, 'YEATS_TFIID14_like', 3220),
(3221, 'cd16720', NULL, 'RING-HC_MEX3A', NULL, NULL, 'RING-HC_MEX3A', 3221),
(3222, 'cd11519', NULL, 'SLC5sbd_SMCT1', NULL, NULL, 'SLC5sbd_SMCT1', 3222),
(3223, 'cd11993', NULL, 'SH3_Intersectin1_4', NULL, NULL, 'SH3_Intersectin1_4', 3223),
(3224, 'cd01699', NULL, 'RNA_dep_RNAP', NULL, NULL, 'RNA_dep_RNAP', 3224),
(3225, 'cd05611', NULL, 'STKc_Rim15_like', NULL, NULL, 'STKc_Rim15_like', 3225),
(3226, 'cd03120', NULL, 'alpha_CARP_VIII', NULL, NULL, 'alpha_CARP_VIII', 3226),
(3227, 'cd04981', NULL, 'IgV_H', NULL, NULL, 'IgV_H', 3227),
(3228, 'cd13126', NULL, 'MATE_like_11', NULL, NULL, 'MATE_like_11', 3228),
(3229, 'cd14297', NULL, 'UBA2_spUBP14_like', NULL, NULL, 'UBA2_spUBP14_like', 3229),
(3230, 'cd07221', NULL, 'Pat_PNPLA3', NULL, NULL, 'Pat_PNPLA3', 3230),
(3231, 'cd12026', NULL, 'SH3_ZO-1', NULL, NULL, 'SH3_ZO-1', 3231),
(3232, 'cd16409', NULL, 'ParB_N_like', NULL, NULL, 'ParB_N_like', 3232),
(3233, 'cd12633', NULL, 'RRM1_FCA', NULL, NULL, 'RRM1_FCA', 3233),
(3234, 'cd18772', NULL, 'PIN_Mut7-C-like', NULL, NULL, 'PIN_Mut7-C-like', 3234),
(3235, 'cd04078', NULL, 'CBM36_xylanase-like', NULL, NULL, 'CBM36_xylanase-like', 3235),
(3236, 'cd08208', NULL, 'RLP_Photo', NULL, NULL, 'RLP_Photo', 3236),
(3237, 'cd16230', NULL, 'EFh_CREC_RCN3', NULL, NULL, 'EFh_CREC_RCN3', 3237),
(3238, 'cd19987', NULL, 'PBP1_SBP-like', NULL, NULL, 'PBP1_SBP-like', 3238),
(3239, 'cd08571', NULL, 'GDPD_SHV3_plant', NULL, NULL, 'GDPD_SHV3_plant', 3239),
(3240, 'cd06413', NULL, 'GH25_muramidase_1', NULL, NULL, 'GH25_muramidase_1', 3240),
(3241, 'cd01480', NULL, 'vWA_collagen_alpha_1-VI-type', NULL, NULL, 'vWA_collagen_alpha_1-VI-type', 3241),
(3242, 'cd16476', NULL, 'RING-H2_RNF139_like', NULL, NULL, 'RING-H2_RNF139_like', 3242),
(3243, 'cd16812', NULL, 'RING_CH-C4HC3_MARCH7', NULL, NULL, 'RING_CH-C4HC3_MARCH7', 3243),
(3244, 'cd14566', NULL, 'DSP_MKP_classII', NULL, NULL, 'DSP_MKP_classII', 3244),
(3245, 'cd16561', NULL, 'RING-HC_RNF213', NULL, NULL, 'RING-HC_RNF213', 3245),
(3246, 'cd19836', NULL, 'Bbox1_MID1_C-I', NULL, NULL, 'Bbox1_MID1_C-I', 3246),
(3247, 'cd08262', NULL, 'Zn_ADH8', NULL, NULL, 'Zn_ADH8', 3247),
(3248, 'cd19445', NULL, 'FABP2', NULL, NULL, 'FABP2', 3248),
(3249, 'cd05173', NULL, 'PI3Kc_IA_beta', NULL, NULL, 'PI3Kc_IA_beta', 3249),
(3250, 'cd17120', NULL, 'Ubl_UBTD1', NULL, NULL, 'Ubl_UBTD1', 3250),
(3251, 'cd02121', NULL, 'PA_GCPII_like', NULL, NULL, 'PA_GCPII_like', 3251),
(3252, 'cd18072', NULL, 'DEXHc_TTF2', NULL, NULL, 'DEXHc_TTF2', 3252),
(3253, 'cd15467', NULL, 'MV-h', NULL, NULL, 'MV-h', 3253),
(3254, 'cd06282', NULL, 'PBP1_LacI-like', NULL, NULL, 'PBP1_LacI-like', 3254),
(3255, 'cd01519', NULL, 'RHOD_HSP67B2', NULL, NULL, 'RHOD_HSP67B2', 3255),
(3256, 'cd14745', NULL, 'GH66', NULL, NULL, 'GH66', 3256),
(3257, 'cd14866', NULL, 'Fe-ADH-like', NULL, NULL, 'Fe-ADH-like', 3257),
(3258, 'cd16379', NULL, 'YitT_C_like', NULL, NULL, 'YitT_C_like', 3258),
(3259, 'cd17444', NULL, 'MFS_SLC22A23', NULL, NULL, 'MFS_SLC22A23', 3259),
(3260, 'cd09594', NULL, 'GluZincin', NULL, NULL, 'GluZincin', 3260),
(3261, 'cd19888', NULL, 'DSRM_STAU2_rpt5', NULL, NULL, 'DSRM_STAU2_rpt5', 3261),
(3262, 'cd09151', NULL, 'PLDc_Ymt_2', NULL, NULL, 'PLDc_Ymt_2', 3262),
(3263, 'cd09474', NULL, 'LIM2_Lhx2', NULL, NULL, 'LIM2_Lhx2', 3263),
(3264, 'cd18971', NULL, 'CD_POL_like', NULL, NULL, 'CD_POL_like', 3264),
(3265, 'cd12318', NULL, 'RRM5_RBM19_like', NULL, NULL, 'RRM5_RBM19_like', 3265);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(3266, 'cd14196', NULL, 'STKc_DAPK2', NULL, NULL, 'STKc_DAPK2', 3266),
(3267, 'cd15527', NULL, 'PHD2_KAT6A_6B', NULL, NULL, 'PHD2_KAT6A_6B', 3267),
(3268, 'cd19102', NULL, 'AKR_unchar', NULL, NULL, 'AKR_unchar', 3268),
(3269, 'cd02605', NULL, 'HAD_SPP', NULL, NULL, 'HAD_SPP', 3269),
(3270, 'cd18618', NULL, 'GH43_Xsa43E-like', NULL, NULL, 'GH43_Xsa43E-like', 3270),
(3271, 'cd10381', NULL, 'SH2_Jak_Tyk2', NULL, NULL, 'SH2_Jak_Tyk2', 3271),
(3272, 'cd17173', NULL, 'FERM_F1_TLN1', NULL, NULL, 'FERM_F1_TLN1', 3272),
(3273, 'cd11649', NULL, 'RsmI_like', NULL, NULL, 'RsmI_like', 3273),
(3274, 'cd16211', NULL, 'EFh_PI-PLCbeta4', NULL, NULL, 'EFh_PI-PLCbeta4', 3274),
(3275, 'cd03296', NULL, 'ABC_CysA_sulfate_importer', NULL, NULL, 'ABC_CysA_sulfate_importer', 3275),
(3276, 'cd11589', NULL, 'Agmatinase_like_1', NULL, NULL, 'Agmatinase_like_1', 3276),
(3277, 'cd16125', NULL, 'RA_ASPP1_2', NULL, NULL, 'RA_ASPP1_2', 3277),
(3278, 'cd12255', NULL, 'RRM1_LKAP', NULL, NULL, 'RRM1_LKAP', 3278),
(3279, 'cd16136', NULL, 'RA_MRL_Lpd', NULL, NULL, 'RA_MRL_Lpd', 3279),
(3280, 'cd17195', NULL, 'FERM_F1_PTPN13', NULL, NULL, 'FERM_F1_PTPN13', 3280),
(3281, 'cd04393', NULL, 'RhoGAP_FAM13A1a', NULL, NULL, 'RhoGAP_FAM13A1a', 3281),
(3282, 'cd09138', NULL, 'PLDc_vPLD1_2_yPLD_like_1', NULL, NULL, 'PLDc_vPLD1_2_yPLD_like_1', 3282),
(3283, 'cd00276', NULL, 'C2B_Synaptotagmin', NULL, NULL, 'C2B_Synaptotagmin', 3283),
(3284, 'cd18515', NULL, 'BACK_KLHL37_ENC1', NULL, NULL, 'BACK_KLHL37_ENC1', 3284),
(3285, 'cd03884', NULL, 'M20_bAS', NULL, NULL, 'M20_bAS', 3285),
(3286, 'cd17672', NULL, 'MDM2', NULL, NULL, 'MDM2', 3286),
(3287, 'cd16220', NULL, 'EFh_PI-PLCeta1', NULL, NULL, 'EFh_PI-PLCeta1', 3287),
(3288, 'cd06880', NULL, 'PX_SNX22', NULL, NULL, 'PX_SNX22', 3288),
(3289, 'cd14337', NULL, 'UBA_MARK_Par1', NULL, NULL, 'UBA_MARK_Par1', 3289),
(3290, 'cd18185', NULL, 'ATP-synt_Fo_c_ATPE', NULL, NULL, 'ATP-synt_Fo_c_ATPE', 3290),
(3291, 'cd15324', NULL, '7tmA_alpha-2D_AR', NULL, NULL, '7tmA_alpha-2D_AR', 3291),
(3292, 'cd15418', NULL, '7tmA_OR9G-like', NULL, NULL, '7tmA_OR9G-like', 3292),
(3293, 'cd04100', NULL, 'Asp_Lys_Asn_RS_N', NULL, NULL, 'Asp_Lys_Asn_RS_N', 3293),
(3294, 'cd05630', NULL, 'STKc_GRK6', NULL, NULL, 'STKc_GRK6', 3294),
(3295, 'cd15407', NULL, '7tmA_OR5B-like', NULL, NULL, '7tmA_OR5B-like', 3295),
(3296, 'cd16425', NULL, 'TrbF', NULL, NULL, 'TrbF', 3296),
(3297, 'cd01013', NULL, 'isochorismatase', NULL, NULL, 'isochorismatase', 3297),
(3298, 'cd14600', NULL, 'PTPc-N3', NULL, NULL, 'PTPc-N3', 3298),
(3299, 'cd16404', NULL, 'pNOB8_ParB_N_like', NULL, NULL, 'pNOB8_ParB_N_like', 3299),
(3300, 'cd02129', NULL, 'PA_hSPPL_like', NULL, NULL, 'PA_hSPPL_like', 3300),
(3301, 'cd09888', NULL, 'NGN_Euk', NULL, NULL, 'NGN_Euk', 3301),
(3302, 'cd00984', NULL, 'DnaB_C', NULL, NULL, 'DnaB_C', 3302),
(3303, 'cd17632', NULL, 'AFD_CAR-like', NULL, NULL, 'AFD_CAR-like', 3303),
(3304, 'cd09677', NULL, 'Csy3_I-F', NULL, NULL, 'Csy3_I-F', 3304),
(3305, 'cd12965', NULL, 'CBM-Eb_CBM-Fb', NULL, NULL, 'CBM-Eb_CBM-Fb', 3305),
(3306, 'cd02257', NULL, 'Peptidase_C19', NULL, NULL, 'Peptidase_C19', 3306),
(3307, 'cd09989', NULL, 'Arginase', NULL, NULL, 'Arginase', 3307),
(3308, 'cd05766', NULL, 'IgC_MHC_II_beta', NULL, NULL, 'IgC_MHC_II_beta', 3308),
(3309, 'cd16534', NULL, 'RING-HC_RNF5_like', NULL, NULL, 'RING-HC_RNF5_like', 3309),
(3310, 'cd11277', NULL, 'Sema_plexin_B3', NULL, NULL, 'Sema_plexin_B3', 3310),
(3311, 'cd15625', NULL, 'PHD_TIF1delta', NULL, NULL, 'PHD_TIF1delta', 3311),
(3312, 'cd11900', NULL, 'SH3_Nck1_1', NULL, NULL, 'SH3_Nck1_1', 3312),
(3313, 'cd10532', NULL, 'SET_SUV39H2', NULL, NULL, 'SET_SUV39H2', 3313),
(3314, 'cd17122', NULL, 'Ubl_UHRF1', NULL, NULL, 'Ubl_UHRF1', 3314),
(3315, 'cd09385', NULL, 'LIM2_LMO2', NULL, NULL, 'LIM2_LMO2', 3315),
(3316, 'cd15293', NULL, '7tmC_GPR158-like', NULL, NULL, '7tmC_GPR158-like', 3316),
(3317, 'cd17018', NULL, 'T3SC_IA_ExsC-like', NULL, NULL, 'T3SC_IA_ExsC-like', 3317),
(3318, 'cd17876', NULL, 'SRalpha_C', NULL, NULL, 'SRalpha_C', 3318),
(3319, 'cd11417', NULL, 'bHLH_TS_PTF1A', NULL, NULL, 'bHLH_TS_PTF1A', 3319);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(3320, 'cd16554', NULL, 'RING-HC_RNF180', NULL, NULL, 'RING-HC_RNF180', 3320),
(3321, 'cd17237', NULL, 'FERM_F1_Moesin', NULL, NULL, 'FERM_F1_Moesin', 3321),
(3322, 'cd03532', NULL, 'Rieske_RO_Alpha_VanA_DdmC', NULL, NULL, 'Rieske_RO_Alpha_VanA_DdmC', 3322),
(3323, 'cd11606', NULL, 'COE_DBD', NULL, NULL, 'COE_DBD', 3323),
(3324, 'cd08332', NULL, 'CARD_CASP2', NULL, NULL, 'CARD_CASP2', 3324),
(3325, 'cd15913', NULL, '7tmA_OR11G-like', NULL, NULL, '7tmA_OR11G-like', 3325),
(3326, 'cd08741', NULL, 'RGS_RGS10', NULL, NULL, 'RGS_RGS10', 3326),
(3327, 'cd00216', NULL, 'PQQ_DH_like', NULL, NULL, 'PQQ_DH_like', 3327),
(3328, 'cd03731', NULL, 'SOCS_ASB15', NULL, NULL, 'SOCS_ASB15', 3328),
(3329, 'cd01921', NULL, 'cyclophilin_RRM', NULL, NULL, 'cyclophilin_RRM', 3329),
(3330, 'cd01409', NULL, 'SIRT4', NULL, NULL, 'SIRT4', 3330),
(3331, 'cd08965', NULL, 'EcNei-like_N', NULL, NULL, 'EcNei-like_N', 3331),
(3332, 'cd16376', NULL, 'Avd_like', NULL, NULL, 'Avd_like', 3332),
(3333, 'cd15356', NULL, '7tmA_NTSR2', NULL, NULL, '7tmA_NTSR2', 3333),
(3334, 'cd13904', NULL, 'CuRO_3_Diphenol_Ox', NULL, NULL, 'CuRO_3_Diphenol_Ox', 3334),
(3335, 'cd15728', NULL, 'FYVE_ANFY1', NULL, NULL, 'FYVE_ANFY1', 3335),
(3336, 'cd18524', NULL, 'BACK_BTBD3', NULL, NULL, 'BACK_BTBD3', 3336),
(3337, 'cd01646', NULL, 'RT_Bac_retron_I', NULL, NULL, 'RT_Bac_retron_I', 3337),
(3338, 'cd09527', NULL, 'SAM_Samd5', NULL, NULL, 'SAM_Samd5', 3338),
(3339, 'cd18763', NULL, 'PIN_MtVapC3-like', NULL, NULL, 'PIN_MtVapC3-like', 3339),
(3340, 'cd08591', NULL, 'PI-PLCc_beta', NULL, NULL, 'PI-PLCc_beta', 3340),
(3341, 'cd12425', NULL, 'RRM4_PTBP1_like', NULL, NULL, 'RRM4_PTBP1_like', 3341),
(3342, 'cd16182', NULL, 'EFh_PEF_Group_II_CAPN_like', NULL, NULL, 'EFh_PEF_Group_II_CAPN_like', 3342),
(3343, 'cd08438', NULL, 'PBP2_CidR', NULL, NULL, 'PBP2_CidR', 3343),
(3344, 'cd20290', NULL, 'cupin_Mj0764-like', NULL, NULL, 'cupin_Mj0764-like', 3344),
(3345, 'cd07458', NULL, 'CRD_FZ1_like', NULL, NULL, 'CRD_FZ1_like', 3345),
(3346, 'cd14728', NULL, 'Ere-like', NULL, NULL, 'Ere-like', 3346),
(3347, 'cd19424', NULL, 'lipocalin_NPs-like', NULL, NULL, 'lipocalin_NPs-like', 3347),
(3348, 'cd18234', NULL, 'BTB_POZ_KLHL1-like', NULL, NULL, 'BTB_POZ_KLHL1-like', 3348),
(3349, 'cd04862', NULL, 'PaeLigD_Pol_like', NULL, NULL, 'PaeLigD_Pol_like', 3349),
(3350, 'cd00124', NULL, 'MYSc', NULL, NULL, 'MYSc', 3350),
(3351, 'cd05312', NULL, 'NAD_bind_1_malic_enz', NULL, NULL, 'NAD_bind_1_malic_enz', 3351),
(3352, 'cd14986', NULL, '7tmA_Vasopressin-like', NULL, NULL, '7tmA_Vasopressin-like', 3352),
(3353, 'cd00347', NULL, 'Flavin_utilizing_monoxygenases', NULL, NULL, 'Flavin_utilizing_monoxygenases', 3353),
(3354, 'cd00423', NULL, 'Pterin_binding', NULL, NULL, 'Pterin_binding', 3354),
(3355, 'cd18112', NULL, 'ATP-synt_V_A-type_beta_C', NULL, NULL, 'ATP-synt_V_A-type_beta_C', 3355),
(3356, 'cd18573', NULL, 'ABC_6TM_ABCB10_like', NULL, NULL, 'ABC_6TM_ABCB10_like', 3356),
(3357, 'cd01625', NULL, 'HAD_PNP', NULL, NULL, 'HAD_PNP', 3357),
(3358, 'cd08172', NULL, 'GlyDH-like', NULL, NULL, 'GlyDH-like', 3358),
(3359, 'cd06368', NULL, 'PBP1_iGluR_non_NMDA-like', NULL, NULL, 'PBP1_iGluR_non_NMDA-like', 3359),
(3360, 'cd06398', NULL, 'PB1_Joka2', NULL, NULL, 'PB1_Joka2', 3360),
(3361, 'cd00710', NULL, 'LbH_gamma_CA', NULL, NULL, 'LbH_gamma_CA', 3361),
(3362, 'cd14129', NULL, 'STKc_TTBK2', NULL, NULL, 'STKc_TTBK2', 3362),
(3363, 'cd00117', NULL, 'LU', NULL, NULL, 'LU', 3363),
(3364, 'cd08988', NULL, 'GH43_ABN', NULL, NULL, 'GH43_ABN', 3364),
(3365, 'cd03027', NULL, 'GRX_DEP', NULL, NULL, 'GRX_DEP', 3365),
(3366, 'cd15513', NULL, 'PHD5_KMT2C_like', NULL, NULL, 'PHD5_KMT2C_like', 3366),
(3367, 'cd11539', NULL, 'NTP-PPase_u2', NULL, NULL, 'NTP-PPase_u2', 3367),
(3368, 'cd18909', NULL, 'bHLH_TCFL5', NULL, NULL, 'bHLH_TCFL5', 3368),
(3369, 'cd17920', NULL, 'DEXHc_RecQ', NULL, NULL, 'DEXHc_RecQ', 3369),
(3370, 'cd00306', NULL, 'Peptidases_S8_S53', NULL, NULL, 'Peptidases_S8_S53', 3370),
(3371, 'cd13707', NULL, 'PBP2_BvgS_D2', NULL, NULL, 'PBP2_BvgS_D2', 3371),
(3372, 'cd16287', NULL, 'CphS_ImiS-like_MBL-B2', NULL, NULL, 'CphS_ImiS-like_MBL-B2', 3372);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(3373, 'cd19841', NULL, 'Bbox1_TRIM44', NULL, NULL, 'Bbox1_TRIM44', 3373),
(3374, 'cd02125', NULL, 'PA_VSR', NULL, NULL, 'PA_VSR', 3374),
(3375, 'cd05085', NULL, 'PTKc_Fer', NULL, NULL, 'PTKc_Fer', 3375),
(3376, 'cd13279', NULL, 'PH_Cla4_Ste20', NULL, NULL, 'PH_Cla4_Ste20', 3376),
(3377, 'cd20227', NULL, 'PFM_CPE-like', NULL, NULL, 'PFM_CPE-like', 3377),
(3378, 'cd12344', NULL, 'RRM1_SECp43_like', NULL, NULL, 'RRM1_SECp43_like', 3378),
(3379, 'cd14413', NULL, 'UBA_FAF1', NULL, NULL, 'UBA_FAF1', 3379),
(3380, 'cd21524', NULL, 'DPUP_MHV_Nsp3', NULL, NULL, 'DPUP_MHV_Nsp3', 3380),
(3381, 'cd16933', NULL, 'HATPase_TopVIB-like', NULL, NULL, 'HATPase_TopVIB-like', 3381),
(3382, 'cd19942', NULL, 'Fer2_BFD-like', NULL, NULL, 'Fer2_BFD-like', 3382),
(3383, 'cd12199', NULL, 'AMPKA1_C', NULL, NULL, 'AMPKA1_C', 3383),
(3384, 'cd13410', NULL, 'TNFRSF9', NULL, NULL, 'TNFRSF9', 3384),
(3385, 'cd04646', NULL, 'LbH_Dynactin_6', NULL, NULL, 'LbH_Dynactin_6', 3385),
(3386, 'cd12898', NULL, 'SPRY_PRY_TRIM76', NULL, NULL, 'SPRY_PRY_TRIM76', 3386),
(3387, 'cd02855', NULL, 'E_set_GBE_prok_N', NULL, NULL, 'E_set_GBE_prok_N', 3387),
(3388, 'cd04037', NULL, 'C2E_Ferlin', NULL, NULL, 'C2E_Ferlin', 3388),
(3389, 'cd00555', NULL, 'Maf', NULL, NULL, 'Maf', 3389),
(3390, 'cd03708', NULL, 'GTPBP_III', NULL, NULL, 'GTPBP_III', 3390),
(3391, 'cd05917', NULL, 'FACL_like_2', NULL, NULL, 'FACL_like_2', 3391),
(3392, 'cd17793', NULL, 'HipA', NULL, NULL, 'HipA', 3392),
(3393, 'cd03857', NULL, 'M14-like', NULL, NULL, 'M14-like', 3393),
(3394, 'cd14642', NULL, 'DSP_DUSP6', NULL, NULL, 'DSP_DUSP6', 3394),
(3395, 'cd04512', NULL, 'Ntn_Asparaginase_2_like', NULL, NULL, 'Ntn_Asparaginase_2_like', 3395),
(3396, 'cd04898', NULL, 'ACT_ACR-like_4', NULL, NULL, 'ACT_ACR-like_4', 3396),
(3397, 'cd18581', NULL, 'ABC_6TM_ABCB6', NULL, NULL, 'ABC_6TM_ABCB6', 3397),
(3398, 'cd09734', NULL, 'Csb2_I-U', NULL, NULL, 'Csb2_I-U', 3398),
(3399, 'cd16160', NULL, 'spARS_like', NULL, NULL, 'spARS_like', 3399),
(3400, 'cd09103', NULL, 'PLDc_CDP-OH_P_transf_II_2', NULL, NULL, 'PLDc_CDP-OH_P_transf_II_2', 3400),
(3401, 'cd01058', NULL, 'AAMH_B', NULL, NULL, 'AAMH_B', 3401),
(3402, 'cd12726', NULL, 'RRM2_CPEB2_like', NULL, NULL, 'RRM2_CPEB2_like', 3402),
(3403, 'cd07566', NULL, 'ScNTA1_like', NULL, NULL, 'ScNTA1_like', 3403),
(3404, 'cd05054', NULL, 'PTKc_VEGFR', NULL, NULL, 'PTKc_VEGFR', 3404),
(3405, 'cd14274', NULL, 'UBA_ACK1', NULL, NULL, 'UBA_ACK1', 3405),
(3406, 'cd08368', NULL, 'LIM', NULL, NULL, 'LIM', 3406),
(3407, 'cd13909', NULL, 'CuRO_3_MCO_like_3', NULL, NULL, 'CuRO_3_MCO_like_3', 3407),
(3408, 'cd20246', NULL, 'CASIMO1', NULL, NULL, 'CASIMO1', 3408),
(3409, 'cd04894', NULL, 'ACT_ACR-like_1', NULL, NULL, 'ACT_ACR-like_1', 3409),
(3410, 'cd15887', NULL, 'SNARE_SNAP29N', NULL, NULL, 'SNARE_SNAP29N', 3410),
(3411, 'cd02194', NULL, 'ThiL', NULL, NULL, 'ThiL', 3411),
(3412, 'cd16369', NULL, 'DMSOR_beta_like', NULL, NULL, 'DMSOR_beta_like', 3412),
(3413, 'cd01424', NULL, 'MGS_CPS_II', NULL, NULL, 'MGS_CPS_II', 3413),
(3414, 'cd13708', NULL, 'PBP2_BvgS_like_1', NULL, NULL, 'PBP2_BvgS_like_1', 3414),
(3415, 'cd11407', NULL, 'bHLH-O_HERP', NULL, NULL, 'bHLH-O_HERP', 3415),
(3416, 'cd17475', NULL, 'MFS_MT3072_like', NULL, NULL, 'MFS_MT3072_like', 3416),
(3417, 'cd18643', NULL, 'CBD', NULL, NULL, 'CBD', 3417),
(3418, 'cd06101', NULL, 'citrate_synt', NULL, NULL, 'citrate_synt', 3418),
(3419, 'cd19038', NULL, 'LGIC_ECD_GABAAR_A5', NULL, NULL, 'LGIC_ECD_GABAAR_A5', 3419),
(3420, 'cd20297', NULL, 'cupin_HQDO_small', NULL, NULL, 'cupin_HQDO_small', 3420),
(3421, 'cd04747', NULL, 'OYE_like_5_FMN', NULL, NULL, 'OYE_like_5_FMN', 3421),
(3422, 'cd21169', NULL, 'M_dcv_Nsp15-like', NULL, NULL, 'M_dcv_Nsp15-like', 3422),
(3423, 'cd12929', NULL, 'GUCT', NULL, NULL, 'GUCT', 3423),
(3424, 'cd19049', NULL, 'LGIC_TM_anion', NULL, NULL, 'LGIC_TM_anion', 3424),
(3425, 'cd05387', NULL, 'BY-kinase', NULL, NULL, 'BY-kinase', 3425),
(3426, 'cd17953', NULL, 'DEADc_DDX46', NULL, NULL, 'DEADc_DDX46', 3426),
(3427, 'cd04022', NULL, 'C2A_MCTP_PRT_plant', NULL, NULL, 'C2A_MCTP_PRT_plant', 3427);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(3428, 'cd13848', NULL, 'CuRO_1_CopA', NULL, NULL, 'CuRO_1_CopA', 3428),
(3429, 'cd21470', NULL, 'CoV_Spike_S1_RBD', NULL, NULL, 'CoV_Spike_S1_RBD', 3429),
(3430, 'cd03001', NULL, 'PDI_a_P5', NULL, NULL, 'PDI_a_P5', 3430),
(3431, 'cd13239', NULL, 'PH_Obscurin', NULL, NULL, 'PH_Obscurin', 3431),
(3432, 'cd08683', NULL, 'C2_C2cd3', NULL, NULL, 'C2_C2cd3', 3432),
(3433, 'cd14383', NULL, 'UBA1_UBP5', NULL, NULL, 'UBA1_UBP5', 3433),
(3434, 'cd06593', NULL, 'GH31_xylosidase_YicI', NULL, NULL, 'GH31_xylosidase_YicI', 3434),
(3435, 'cd12390', NULL, 'RRM3_RAVER', NULL, NULL, 'RRM3_RAVER', 3435),
(3436, 'cd14214', NULL, 'PKc_CLK3', NULL, NULL, 'PKc_CLK3', 3436),
(3437, 'cd07173', NULL, 'NR_DBD_AR', NULL, NULL, 'NR_DBD_AR', 3437),
(3438, 'cd18933', NULL, 'bHLH-O_HES3', NULL, NULL, 'bHLH-O_HES3', 3438),
(3439, 'cd18569', NULL, 'ABC_6TM_NHLM_bacteriocin', NULL, NULL, 'ABC_6TM_NHLM_bacteriocin', 3439),
(3440, 'cd05749', NULL, 'Ig2_Axl_Tyro3_like', NULL, NULL, 'Ig2_Axl_Tyro3_like', 3440),
(3441, 'cd15687', NULL, 'PHD3_KDM5B', NULL, NULL, 'PHD3_KDM5B', 3441),
(3442, 'cd05124', NULL, 'AFK', NULL, NULL, 'AFK', 3442),
(3443, 'cd14495', NULL, 'PTPLP-like', NULL, NULL, 'PTPLP-like', 3443),
(3444, 'cd01204', NULL, 'PTB_IRS', NULL, NULL, 'PTB_IRS', 3444),
(3445, 'cd12088', NULL, 'helicase_insert_domain', NULL, NULL, 'helicase_insert_domain', 3445),
(3446, 'cd10495', NULL, 'MH2_R-SMAD', NULL, NULL, 'MH2_R-SMAD', 3446),
(3447, 'cd07514', NULL, 'HAD_Pase', NULL, NULL, 'HAD_Pase', 3447),
(3448, 'cd15434', NULL, '7tmA_OR2W-like', NULL, NULL, '7tmA_OR2W-like', 3448),
(3449, 'cd18240', NULL, 'BTB_POZ_KLHL10', NULL, NULL, 'BTB_POZ_KLHL10', 3449),
(3450, 'cd08323', NULL, 'CARD_APAF1', NULL, NULL, 'CARD_APAF1', 3450),
(3451, 'cd19097', NULL, 'AKR_unchar', NULL, NULL, 'AKR_unchar', 3451),
(3452, 'cd13297', NULL, 'PH3_MyoX-like', NULL, NULL, 'PH3_MyoX-like', 3452),
(3453, 'cd09564', NULL, 'SAM_kazrin_repeat1', NULL, NULL, 'SAM_kazrin_repeat1', 3453),
(3454, 'cd17376', NULL, 'MFS_SLC22A4_5_OCTN1_2', NULL, NULL, 'MFS_SLC22A4_5_OCTN1_2', 3454),
(3455, 'cd06438', NULL, 'EpsO_like', NULL, NULL, 'EpsO_like', 3455),
(3456, 'cd09567', NULL, 'SAM_kazrin_repeat2', NULL, NULL, 'SAM_kazrin_repeat2', 3456),
(3457, 'cd09907', NULL, 'H3TH_FEN1-Euk', NULL, NULL, 'H3TH_FEN1-Euk', 3457),
(3458, 'cd10943', NULL, 'CE4_NodB', NULL, NULL, 'CE4_NodB', 3458),
(3459, 'cd04370', NULL, 'BAH', NULL, NULL, 'BAH', 3459),
(3460, 'cd18807', NULL, 'SF1_C_UvrD', NULL, NULL, 'SF1_C_UvrD', 3460),
(3461, 'cd12037', NULL, 'SH3_MPP2', NULL, NULL, 'SH3_MPP2', 3461),
(3462, 'cd11907', NULL, 'SH3_TXK', NULL, NULL, 'SH3_TXK', 3462),
(3463, 'cd13620', NULL, 'PBP2_GltS', NULL, NULL, 'PBP2_GltS', 3463),
(3464, 'cd15994', NULL, '7tmB2_GPR111_115', NULL, NULL, '7tmB2_GPR111_115', 3464),
(3465, 'cd04518', NULL, 'TBP_archaea', NULL, NULL, 'TBP_archaea', 3465),
(3466, 'cd04088', NULL, 'EFG_mtEFG_II', NULL, NULL, 'EFG_mtEFG_II', 3466),
(3467, 'cd16905', NULL, 'YEATS_Taf14_like', NULL, NULL, 'YEATS_Taf14_like', 3467),
(3468, 'cd10159', NULL, 'CsoR-like_DUF156_2', NULL, NULL, 'CsoR-like_DUF156_2', 3468),
(3469, 'cd02115', NULL, 'AAK', NULL, NULL, 'AAK', 3469),
(3470, 'cd01037', NULL, 'Restriction_endonuclease_like', NULL, NULL, 'Restriction_endonuclease_like', 3470),
(3471, 'cd20756', NULL, 'capping_2-OMTase_Poxviridae', NULL, NULL, 'capping_2-OMTase_Poxviridae', 3471),
(3472, 'cd11610', NULL, 'eIF2D_N', NULL, NULL, 'eIF2D_N', 3472),
(3473, 'cd07712', NULL, 'MBLAC2-like_MBL-fold', NULL, NULL, 'MBLAC2-like_MBL-fold', 3473),
(3474, 'cd14257', NULL, 'CttA_X', NULL, NULL, 'CttA_X', 3474),
(3475, 'cd04186', NULL, 'GT_2_like_c', NULL, NULL, 'GT_2_like_c', 3475),
(3476, 'cd12670', NULL, 'RRM2_Nop12p_like', NULL, NULL, 'RRM2_Nop12p_like', 3476),
(3477, 'cd12535', NULL, 'RRM_FUS_TAF15', NULL, NULL, 'RRM_FUS_TAF15', 3477),
(3478, 'cd03707', NULL, 'EFTU_III', NULL, NULL, 'EFTU_III', 3478),
(3479, 'cd07113', NULL, 'ALDH_PADH_NahF', NULL, NULL, 'ALDH_PADH_NahF', 3479),
(3480, 'cd12924', NULL, 'iSH2_PIK3R1', NULL, NULL, 'iSH2_PIK3R1', 3480),
(3481, 'cd06636', NULL, 'STKc_MAP4K4_6_N', NULL, NULL, 'STKc_MAP4K4_6_N', 3481);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(3482, 'cd04931', NULL, 'ACT_PAH', NULL, NULL, 'ACT_PAH', 3482),
(3483, 'cd12030', NULL, 'SH3_DLG4', NULL, NULL, 'SH3_DLG4', 3483),
(3484, 'cd13154', NULL, 'KOW_Mtr4', NULL, NULL, 'KOW_Mtr4', 3484),
(3485, 'cd15603', NULL, 'PHD1_KDM5B', NULL, NULL, 'PHD1_KDM5B', 3485),
(3486, 'cd10951', NULL, 'CE4_ClCDA_like', NULL, NULL, 'CE4_ClCDA_like', 3486),
(3487, 'cd15083', NULL, '7tmA_Melanopsin-like', NULL, NULL, '7tmA_Melanopsin-like', 3487),
(3488, 'cd18049', NULL, 'DEADc_DDX5', NULL, NULL, 'DEADc_DDX5', 3488),
(3489, 'cd02609', NULL, 'P-type_ATPase', NULL, NULL, 'P-type_ATPase', 3489),
(3490, 'cd07552', NULL, 'P-type_ATPase_Cu-like', NULL, NULL, 'P-type_ATPase_Cu-like', 3490),
(3491, 'cd10163', NULL, 'ClassIIa_HDAC9_Gln-rich-N', NULL, NULL, 'ClassIIa_HDAC9_Gln-rich-N', 3491),
(3492, 'cd19994', NULL, 'PBP1_ChvE', NULL, NULL, 'PBP1_ChvE', 3492),
(3493, 'cd08464', NULL, 'PBP2_DntR_like_2', NULL, NULL, 'PBP2_DntR_like_2', 3493),
(3494, 'cd16791', NULL, 'SP-RING_ZMIZ', NULL, NULL, 'SP-RING_ZMIZ', 3494),
(3495, 'cd02128', NULL, 'PA_TfR', NULL, NULL, 'PA_TfR', 3495),
(3496, 'cd06977', NULL, 'cupin_RhaR_RhaS-like_N', NULL, NULL, 'cupin_RhaR_RhaS-like_N', 3496),
(3497, 'cd03308', NULL, 'CmuA_CmuC_like', NULL, NULL, 'CmuA_CmuC_like', 3497),
(3498, 'cd16759', NULL, 'RING-HC_MuRF1', NULL, NULL, 'RING-HC_MuRF1', 3498),
(3499, 'cd16891', NULL, 'CwlT-like', NULL, NULL, 'CwlT-like', 3499),
(3500, 'cd18565', NULL, 'ABC_6TM_exporter_like', NULL, NULL, 'ABC_6TM_exporter_like', 3500),
(3501, 'cd17033', NULL, 'DR1245-like', NULL, NULL, 'DR1245-like', 3501),
(3502, 'cd17940', NULL, 'DEADc_DDX6', NULL, NULL, 'DEADc_DDX6', 3502),
(3503, 'cd00307', NULL, 'RuBisCO_small_like', NULL, NULL, 'RuBisCO_small_like', 3503),
(3504, 'cd14435', NULL, 'SPO1_TF1_like', NULL, NULL, 'SPO1_TF1_like', 3504),
(3505, 'cd12490', NULL, 'RRM2_ACF', NULL, NULL, 'RRM2_ACF', 3505),
(3506, 'cd05909', NULL, 'AAS_C', NULL, NULL, 'AAS_C', 3506),
(3507, 'cd02011', NULL, 'TPP_PK', NULL, NULL, 'TPP_PK', 3507),
(3508, 'cd03757', NULL, 'proteasome_beta_type_1', NULL, NULL, 'proteasome_beta_type_1', 3508),
(3509, 'cd05834', NULL, 'HDGF_related', NULL, NULL, 'HDGF_related', 3509),
(3510, 'cd13224', NULL, 'PH_Net1', NULL, NULL, 'PH_Net1', 3510),
(3511, 'cd15831', NULL, 'BTAD', NULL, NULL, 'BTAD', 3511),
(3512, 'cd11484', NULL, 'SLC-NCS1sbd_CobB-like', NULL, NULL, 'SLC-NCS1sbd_CobB-like', 3512),
(3513, 'cd18931', NULL, 'bHLHzip_Mad1', NULL, NULL, 'bHLHzip_Mad1', 3513),
(3514, 'cd00685', NULL, 'Trans_IPPS_HT', NULL, NULL, 'Trans_IPPS_HT', 3514),
(3515, 'cd09894', NULL, 'NGN_SP_AnfA1', NULL, NULL, 'NGN_SP_AnfA1', 3515),
(3516, 'cd07401', NULL, 'MPP_TMEM62_N', NULL, NULL, 'MPP_TMEM62_N', 3516),
(3517, 'cd03199', NULL, 'GST_C_GRX2', NULL, NULL, 'GST_C_GRX2', 3517),
(3518, 'cd12109', NULL, 'Hr_FBXL5', NULL, NULL, 'Hr_FBXL5', 3518),
(3519, 'cd04740', NULL, 'DHOD_1B_like', NULL, NULL, 'DHOD_1B_like', 3519),
(3520, 'cd05033', NULL, 'PTKc_EphR', NULL, NULL, 'PTKc_EphR', 3520),
(3521, 'cd09866', NULL, 'PIN_Fcf1-Utp23-H', NULL, NULL, 'PIN_Fcf1-Utp23-H', 3521),
(3522, 'cd19359', NULL, 'TenA_C_Bt3146-like', NULL, NULL, 'TenA_C_Bt3146-like', 3522),
(3523, 'cd02621', NULL, 'Peptidase_C1A_CathepsinC', NULL, NULL, 'Peptidase_C1A_CathepsinC', 3523),
(3524, 'cd15935', NULL, '7tmA_OR4Q3-like', NULL, NULL, '7tmA_OR4Q3-like', 3524),
(3525, 'cd12579', NULL, 'RRM2_hnRNPA0', NULL, NULL, 'RRM2_hnRNPA0', 3525),
(3526, 'cd08784', NULL, 'Death_DRs', NULL, NULL, 'Death_DRs', 3526),
(3527, 'cd10473', NULL, 'EphR_LBD_A', NULL, NULL, 'EphR_LBD_A', 3527),
(3528, 'cd04792', NULL, 'LanM-like', NULL, NULL, 'LanM-like', 3528),
(3529, 'cd19391', NULL, 'TGF_beta_BMP4_BMP2B', NULL, NULL, 'TGF_beta_BMP4_BMP2B', 3529),
(3530, 'cd17775', NULL, 'CBS_pair_bact_arch', NULL, NULL, 'CBS_pair_bact_arch', 3530),
(3531, 'cd13368', NULL, 'PH_BCR_arthropod', NULL, NULL, 'PH_BCR_arthropod', 3531),
(3532, 'cd08742', NULL, 'RGS_RGS12', NULL, NULL, 'RGS_RGS12', 3532),
(3533, 'cd10366', NULL, 'SH2_Src_Yes', NULL, NULL, 'SH2_Src_Yes', 3533),
(3534, 'cd18386', NULL, 'BTB_POZ_KCTD20', NULL, NULL, 'BTB_POZ_KCTD20', 3534);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(3535, 'cd12456', NULL, 'RRM_p65', NULL, NULL, 'RRM_p65', 3535),
(3536, 'cd00855', NULL, 'SWIB-MDM2', NULL, NULL, 'SWIB-MDM2', 3536),
(3537, 'cd01263', NULL, 'PH_anillin', NULL, NULL, 'PH_anillin', 3537),
(3538, 'cd07213', NULL, 'Pat17_PNPLA8_PNPLA9_like1', NULL, NULL, 'Pat17_PNPLA8_PNPLA9_like1', 3538),
(3539, 'cd09248', NULL, 'BRO1_Rhophilin_1', NULL, NULL, 'BRO1_Rhophilin_1', 3539),
(3540, 'cd02019', NULL, 'NK', NULL, NULL, 'NK', 3540),
(3541, 'cd01370', NULL, 'KISc_KIP3_like', NULL, NULL, 'KISc_KIP3_like', 3541),
(3542, 'cd10028', NULL, 'UDG-F2_TDG_MUG', NULL, NULL, 'UDG-F2_TDG_MUG', 3542),
(3543, 'cd15818', NULL, 'SPRY_PRY_TRIM69', NULL, NULL, 'SPRY_PRY_TRIM69', 3543),
(3544, 'cd15748', NULL, 'FYVE_SPIR', NULL, NULL, 'FYVE_SPIR', 3544),
(3545, 'cd08761', NULL, 'Cyt_b561_CYB561D2_like', NULL, NULL, 'Cyt_b561_CYB561D2_like', 3545),
(3546, 'cd13611', NULL, 'PBP2_YehZ', NULL, NULL, 'PBP2_YehZ', 3546),
(3547, 'cd02338', NULL, 'ZZ_PCMF_like', NULL, NULL, 'ZZ_PCMF_like', 3547),
(3548, 'cd00179', NULL, 'SynN', NULL, NULL, 'SynN', 3548),
(3549, 'cd10792', NULL, 'GH57N_AmyC_like', NULL, NULL, 'GH57N_AmyC_like', 3549),
(3550, 'cd17391', NULL, 'MFS_MdtG_MDR_like', NULL, NULL, 'MFS_MdtG_MDR_like', 3550),
(3551, 'cd14810', NULL, 'bZIP_u1', NULL, NULL, 'bZIP_u1', 3551),
(3552, 'cd03680', NULL, 'MM_CoA_mutase_ICM_like', NULL, NULL, 'MM_CoA_mutase_ICM_like', 3552),
(3553, 'cd07696', NULL, 'IgC_CH3_IgAEM_CH2_IgG', NULL, NULL, 'IgC_CH3_IgAEM_CH2_IgG', 3553),
(3554, 'cd02081', NULL, 'P-type_ATPase_Ca_PMCA-like', NULL, NULL, 'P-type_ATPase_Ca_PMCA-like', 3554),
(3555, 'cd20207', NULL, 'Bbox2_GefO-like', NULL, NULL, 'Bbox2_GefO-like', 3555),
(3556, 'cd16612', NULL, 'RING-HC_TRIM72_C-IV', NULL, NULL, 'RING-HC_TRIM72_C-IV', 3556),
(3557, 'cd02164', NULL, 'PPAT_CoAS', NULL, NULL, 'PPAT_CoAS', 3557),
(3558, 'cd00191', NULL, 'TY', NULL, NULL, 'TY', 3558),
(3559, 'cd00643', NULL, 'HMG-CoA_reductase_classI', NULL, NULL, 'HMG-CoA_reductase_classI', 3559),
(3560, 'cd05748', NULL, 'Ig_Titin_like', NULL, NULL, 'Ig_Titin_like', 3560),
(3561, 'cd01282', NULL, 'HTH_MerR-like_sg3', NULL, NULL, 'HTH_MerR-like_sg3', 3561),
(3562, 'cd09135', NULL, 'PLDc_PGS1_euk_1', NULL, NULL, 'PLDc_PGS1_euk_1', 3562),
(3563, 'cd16985', NULL, 'ANTH_N_AP180', NULL, NULL, 'ANTH_N_AP180', 3563),
(3564, 'cd18116', NULL, 'ATP-synt_F1_alpha_N', NULL, NULL, 'ATP-synt_F1_alpha_N', 3564),
(3565, 'cd15646', NULL, 'PHD_p300', NULL, NULL, 'PHD_p300', 3565),
(3566, 'cd14694', NULL, 'bZIP_NFIL3', NULL, NULL, 'bZIP_NFIL3', 3566),
(3567, 'cd16082', NULL, 'IgC_CRIg', NULL, NULL, 'IgC_CRIg', 3567),
(3568, 'cd04123', NULL, 'Rab21', NULL, NULL, 'Rab21', 3568),
(3569, 'cd15232', NULL, '7tmA_OR13-like', NULL, NULL, '7tmA_OR13-like', 3569),
(3570, 'cd21532', NULL, 'HKU1-CoV-like_E', NULL, NULL, 'HKU1-CoV-like_E', 3570),
(3571, 'cd01141', NULL, 'TroA_d', NULL, NULL, 'TroA_d', 3571),
(3572, 'cd07739', NULL, 'metallo-hydrolase-like_MBL-fold', NULL, NULL, 'metallo-hydrolase-like_MBL-fold', 3572),
(3573, 'cd03440', NULL, 'hot_dog', NULL, NULL, 'hot_dog', 3573),
(3574, 'cd14100', NULL, 'STKc_PIM1', NULL, NULL, 'STKc_PIM1', 3574),
(3575, 'cd13240', NULL, 'PH1_Kalirin_Trio_like', NULL, NULL, 'PH1_Kalirin_Trio_like', 3575),
(3576, 'cd02825', NULL, 'PAZ', NULL, NULL, 'PAZ', 3576),
(3577, 'cd16931', NULL, 'HATPase_MORC-like', NULL, NULL, 'HATPase_MORC-like', 3577),
(3578, 'cd07629', NULL, 'BAR_Atg20p', NULL, NULL, 'BAR_Atg20p', 3578),
(3579, 'cd00350', NULL, 'rubredoxin_like', NULL, NULL, 'rubredoxin_like', 3579),
(3580, 'cd14971', NULL, '7tmA_Galanin_R-like', NULL, NULL, '7tmA_Galanin_R-like', 3580),
(3581, 'cd19587', NULL, 'serpinA16_HongrES1-like', NULL, NULL, 'serpinA16_HongrES1-like', 3581),
(3582, 'cd07521', NULL, 'HAD_FCP1-like', NULL, NULL, 'HAD_FCP1-like', 3582),
(3583, 'cd14984', NULL, '7tmA_Chemokine_R', NULL, NULL, '7tmA_Chemokine_R', 3583),
(3584, 'cd00106', NULL, 'KISc', NULL, NULL, 'KISc', 3584),
(3585, 'cd19447', NULL, 'L-BABP-like', NULL, NULL, 'L-BABP-like', 3585),
(3586, 'cd03883', NULL, 'M28_Pgcp_like', NULL, NULL, 'M28_Pgcp_like', 3586),
(3587, 'cd07686', NULL, 'F-BAR_Fer', NULL, NULL, 'F-BAR_Fer', 3587);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(3588, 'cd16517', NULL, 'RING-HC_MAT1', NULL, NULL, 'RING-HC_MAT1', 3588),
(3589, 'cd00004', NULL, 'Sortase', NULL, NULL, 'Sortase', 3589),
(3590, 'cd05484', NULL, 'retropepsin_like_LTR_2', NULL, NULL, 'retropepsin_like_LTR_2', 3590),
(3591, 'cd13547', NULL, 'PBP2_Fbp_like_2', NULL, NULL, 'PBP2_Fbp_like_2', 3591),
(3592, 'cd16489', NULL, 'mRING-CH-C4HC2H_ZNRF', NULL, NULL, 'mRING-CH-C4HC2H_ZNRF', 3592),
(3593, 'cd07526', NULL, 'HAD_BPGM_like', NULL, NULL, 'HAD_BPGM_like', 3593),
(3594, 'cd13577', NULL, 'PBP2_BugE_Glu', NULL, NULL, 'PBP2_BugE_Glu', 3594),
(3595, 'cd18117', NULL, 'ATP-synt_flagellum-secretory_path_III_N', NULL, NULL, 'ATP-synt_flagellum-secretory_path_III_N', 3595),
(3596, 'cd14150', NULL, 'STKc_A-Raf', NULL, NULL, 'STKc_A-Raf', 3596),
(3597, 'cd15070', NULL, '7tmA_Adenosine_R_A3', NULL, NULL, '7tmA_Adenosine_R_A3', 3597),
(3598, 'cd02171', NULL, 'G3P_Cytidylyltransferase', NULL, NULL, 'G3P_Cytidylyltransferase', 3598),
(3599, 'cd08935', NULL, 'mannonate_red_SDR_c', NULL, NULL, 'mannonate_red_SDR_c', 3599),
(3600, 'cd05721', NULL, 'IgV_CTLA-4', NULL, NULL, 'IgV_CTLA-4', 3600),
(3601, 'cd06810', NULL, 'PLPDE_III_ODC_DapDC_like', NULL, NULL, 'PLPDE_III_ODC_DapDC_like', 3601),
(3602, 'cd01760', NULL, 'RBD', NULL, NULL, 'RBD', 3602),
(3603, 'cd00205', NULL, 'rhv_like', NULL, NULL, 'rhv_like', 3603),
(3604, 'cd09599', NULL, 'M1_LTA4H', NULL, NULL, 'M1_LTA4H', 3604),
(3605, 'cd13544', NULL, 'PBP2_Fbp_like_1', NULL, NULL, 'PBP2_Fbp_like_1', 3605),
(3606, 'cd05481', NULL, 'retropepsin_like_LTR_1', NULL, NULL, 'retropepsin_like_LTR_1', 3606),
(3607, 'cd11787', NULL, 'SH3_SH3RF_2', NULL, NULL, 'SH3_SH3RF_2', 3607),
(3608, 'cd01847', NULL, 'Triacylglycerol_lipase_like', NULL, NULL, 'Triacylglycerol_lipase_like', 3608),
(3609, 'cd11593', NULL, 'Agmatinase-like_2', NULL, NULL, 'Agmatinase-like_2', 3609),
(3610, 'cd02111', NULL, 'eukary_SO_Moco', NULL, NULL, 'eukary_SO_Moco', 3610),
(3611, 'cd14641', NULL, 'DSP_DUSP2', NULL, NULL, 'DSP_DUSP2', 3611),
(3612, 'cd19789', NULL, 'Bbox2_TRIM56_C-V', NULL, NULL, 'Bbox2_TRIM56_C-V', 3612),
(3613, 'cd08334', NULL, 'DED_Caspase_8_10_r2', NULL, NULL, 'DED_Caspase_8_10_r2', 3613),
(3614, 'cd00516', NULL, 'PRTase_typeII', NULL, NULL, 'PRTase_typeII', 3614),
(3615, 'cd01270', NULL, 'PTB_CAPON-like', NULL, NULL, 'PTB_CAPON-like', 3615),
(3616, 'cd01871', NULL, 'Rac1_like', NULL, NULL, 'Rac1_like', 3616),
(3617, 'cd17923', NULL, 'DEXHc_Hrq1-like', NULL, NULL, 'DEXHc_Hrq1-like', 3617),
(3618, 'cd06954', NULL, 'NR_LBD_LXR', NULL, NULL, 'NR_LBD_LXR', 3618),
(3619, 'cd08216', NULL, 'PK_STRAD', NULL, NULL, 'PK_STRAD', 3619),
(3620, 'cd02846', NULL, 'PAZ_argonaute_like', NULL, NULL, 'PAZ_argonaute_like', 3620),
(3621, 'cd16811', NULL, 'RING_CH-C4HC3_MARCH4_9', NULL, NULL, 'RING_CH-C4HC3_MARCH4_9', 3621),
(3622, 'cd07582', NULL, 'nitrilase_4', NULL, NULL, 'nitrilase_4', 3622),
(3623, 'cd11782', NULL, 'SH3_Sorbs_2', NULL, NULL, 'SH3_Sorbs_2', 3623),
(3624, 'cd01164', NULL, 'FruK_PfkB_like', NULL, NULL, 'FruK_PfkB_like', 3624),
(3625, 'cd12809', NULL, 'Esterase_713_like-2', NULL, NULL, 'Esterase_713_like-2', 3625),
(3626, 'cd06405', NULL, 'PB1_Mekk2_3', NULL, NULL, 'PB1_Mekk2_3', 3626),
(3627, 'cd09736', NULL, 'Csy2_I-F', NULL, NULL, 'Csy2_I-F', 3627),
(3628, 'cd09021', NULL, 'Aldose_epim_Ec_YphB', NULL, NULL, 'Aldose_epim_Ec_YphB', 3628),
(3629, 'cd14895', NULL, 'MYSc_Myo34', NULL, NULL, 'MYSc_Myo34', 3629),
(3630, 'cd12033', NULL, 'SH3_MPP7', NULL, NULL, 'SH3_MPP7', 3630),
(3631, 'cd01130', NULL, 'VirB11-like_ATPase', NULL, NULL, 'VirB11-like_ATPase', 3631),
(3632, 'cd10230', NULL, 'HYOU1-like_NBD', NULL, NULL, 'HYOU1-like_NBD', 3632),
(3633, 'cd01581', NULL, 'AcnB', NULL, NULL, 'AcnB', 3633),
(3634, 'cd09562', NULL, 'SAM_liprin-alpha1,2,3,4_repeat1', NULL, NULL, 'SAM_liprin-alpha1,2,3,4_repeat1', 3634),
(3635, 'cd15924', NULL, '7tmA_P2Y12-like', NULL, NULL, '7tmA_P2Y12-like', 3635),
(3636, 'cd13419', NULL, 'TNFRSF19L', NULL, NULL, 'TNFRSF19L', 3636),
(3637, 'cd01743', NULL, 'GATase1_Anthranilate_Synthase', NULL, NULL, 'GATase1_Anthranilate_Synthase', 3637),
(3638, 'cd01873', NULL, 'RhoBTB', NULL, NULL, 'RhoBTB', 3638);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(3639, 'cd11240', NULL, 'Sema_4', NULL, NULL, 'Sema_4', 3639),
(3640, 'cd12438', NULL, 'RRM_CNOT4', NULL, NULL, 'RRM_CNOT4', 3640),
(3641, 'cd15532', NULL, 'PHD2_CHD_II', NULL, NULL, 'PHD2_CHD_II', 3641),
(3642, 'cd17915', NULL, 'DEAHc_XPD-like', NULL, NULL, 'DEAHc_XPD-like', 3642),
(3643, 'cd18274', NULL, 'BTB_POZ_KBTBD8', NULL, NULL, 'BTB_POZ_KBTBD8', 3643),
(3644, 'cd12773', NULL, 'RRM2_HuR', NULL, NULL, 'RRM2_HuR', 3644),
(3645, 'cd18458', NULL, 'BACK_KLHL19_KEAP1', NULL, NULL, 'BACK_KLHL19_KEAP1', 3645),
(3646, 'cd05325', NULL, 'carb_red_sniffer_like_SDR_c', NULL, NULL, 'carb_red_sniffer_like_SDR_c', 3646),
(3647, 'cd16911', NULL, 'AfaD_SafA-like', NULL, NULL, 'AfaD_SafA-like', 3647),
(3648, 'cd17990', NULL, 'DEXHc_HrpB', NULL, NULL, 'DEXHc_HrpB', 3648),
(3649, 'cd01033', NULL, 'ClC_like', NULL, NULL, 'ClC_like', 3649),
(3650, 'cd11466', NULL, 'bHLH_TS_HAND', NULL, NULL, 'bHLH_TS_HAND', 3650),
(3651, 'cd09946', NULL, 'SH2_HSH2_like', NULL, NULL, 'SH2_HSH2_like', 3651),
(3652, 'cd05495', NULL, 'Bromo_cbp_like', NULL, NULL, 'Bromo_cbp_like', 3652),
(3653, 'cd11306', NULL, 'M35_peptidyl-Lys', NULL, NULL, 'M35_peptidyl-Lys', 3653),
(3654, 'cd12669', NULL, 'RRM1_Nop12p_like', NULL, NULL, 'RRM1_Nop12p_like', 3654),
(3655, 'cd13199', NULL, 'FERM_C2_MyoVII', NULL, NULL, 'FERM_C2_MyoVII', 3655),
(3656, 'cd17649', NULL, 'A_NRPS_PvdJ-like', NULL, NULL, 'A_NRPS_PvdJ-like', 3656),
(3657, 'cd06340', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, 'PBP1_ABC_ligand_binding-like', 3657),
(3658, 'cd00520', NULL, 'RRF', NULL, NULL, 'RRF', 3658),
(3659, 'cd03292', NULL, 'ABC_FtsE_transporter', NULL, NULL, 'ABC_FtsE_transporter', 3659),
(3660, 'cd00518', NULL, 'H2MP', NULL, NULL, 'H2MP', 3660),
(3661, 'cd05824', NULL, 'LbH_M1P_guanylylT_C', NULL, NULL, 'LbH_M1P_guanylylT_C', 3661),
(3662, 'cd05582', NULL, 'STKc_RSK_N', NULL, NULL, 'STKc_RSK_N', 3662),
(3663, 'cd15966', NULL, '7tmA_RXFP2_LGR8', NULL, NULL, '7tmA_RXFP2_LGR8', 3663),
(3664, 'cd01854', NULL, 'YjeQ_EngC', NULL, NULL, 'YjeQ_EngC', 3664),
(3665, 'cd09878', NULL, 'PIN_VapC_VirB11L-ATPase-like', NULL, NULL, 'PIN_VapC_VirB11L-ATPase-like', 3665),
(3666, 'cd15723', NULL, 'FYVE_protrudin', NULL, NULL, 'FYVE_protrudin', 3666),
(3667, 'cd17004', NULL, 'CID_SCAF8', NULL, NULL, 'CID_SCAF8', 3667),
(3668, 'cd12763', NULL, 'RRM1_hnRNPA3', NULL, NULL, 'RRM1_hnRNPA3', 3668),
(3669, 'cd11317', NULL, 'AmyAc_bac_euk_AmyA', NULL, NULL, 'AmyAc_bac_euk_AmyA', 3669),
(3670, 'cd15164', NULL, '7tmA_GPR35-like', NULL, NULL, '7tmA_GPR35-like', 3670),
(3671, 'cd00144', NULL, 'MPP_PPP_family', NULL, NULL, 'MPP_PPP_family', 3671),
(3672, 'cd03564', NULL, 'ANTH_N', NULL, NULL, 'ANTH_N', 3672),
(3673, 'cd04883', NULL, 'ACT_AcuB', NULL, NULL, 'ACT_AcuB', 3673),
(3674, 'cd19377', NULL, 'TGF_beta_INHA_B_like', NULL, NULL, 'TGF_beta_INHA_B_like', 3674),
(3675, 'cd17405', NULL, 'MFS_SLCO6_OATP6', NULL, NULL, 'MFS_SLCO6_OATP6', 3675),
(3676, 'cd18819', NULL, 'GH43_LbAraf43-like', NULL, NULL, 'GH43_LbAraf43-like', 3676),
(3677, 'cd02975', NULL, 'PfPDO_like_N', NULL, NULL, 'PfPDO_like_N', 3677),
(3678, 'cd05035', NULL, 'PTKc_TAM', NULL, NULL, 'PTKc_TAM', 3678),
(3679, 'cd13846', NULL, 'CuRO_1_AAO_like_1', NULL, NULL, 'CuRO_1_AAO_like_1', 3679),
(3680, 'cd18244', NULL, 'BTB_POZ_KLHL15', NULL, NULL, 'BTB_POZ_KLHL15', 3680),
(3681, 'cd17546', NULL, 'REC_hyHK_CKI1_RcsC-like', NULL, NULL, 'REC_hyHK_CKI1_RcsC-like', 3681),
(3682, 'cd12559', NULL, 'RRM_SRSF10', NULL, NULL, 'RRM_SRSF10', 3682),
(3683, 'cd07652', NULL, 'F-BAR_Rgd1', NULL, NULL, 'F-BAR_Rgd1', 3683),
(3684, 'cd13864', NULL, 'CuRO_1_MCO_like_2', NULL, NULL, 'CuRO_1_MCO_like_2', 3684),
(3685, 'cd04791', NULL, 'LanC_SerThrkinase', NULL, NULL, 'LanC_SerThrkinase', 3685),
(3686, 'cd04969', NULL, 'Ig5_Contactin', NULL, NULL, 'Ig5_Contactin', 3686),
(3687, 'cd00922', NULL, 'Cyt_c_Oxidase_IV', NULL, NULL, 'Cyt_c_Oxidase_IV', 3687),
(3688, 'cd11337', NULL, 'AmyAc_CMD_like', NULL, NULL, 'AmyAc_CMD_like', 3688),
(3689, 'cd06959', NULL, 'NR_DBD_EcR_like', NULL, NULL, 'NR_DBD_EcR_like', 3689),
(3690, 'cd01862', NULL, 'Rab7', NULL, NULL, 'Rab7', 3690);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(3691, 'cd06067', NULL, 'H2MP_MemB-H2evol', NULL, NULL, 'H2MP_MemB-H2evol', 3691),
(3692, 'cd00990', NULL, 'PDZ_glycyl_aminopeptidase', NULL, NULL, 'PDZ_glycyl_aminopeptidase', 3692),
(3693, 'cd18009', NULL, 'DEXHc_HELLS_SMARCA6', NULL, NULL, 'DEXHc_HELLS_SMARCA6', 3693),
(3694, 'cd05875', NULL, 'Ig_hNeurofascin_like', NULL, NULL, 'Ig_hNeurofascin_like', 3694),
(3695, 'cd11423', NULL, 'bHLH_TS_musculin_like', NULL, NULL, 'bHLH_TS_musculin_like', 3695),
(3696, 'cd08190', NULL, 'HOT', NULL, NULL, 'HOT', 3696),
(3697, 'cd00255', NULL, 'nidG2', NULL, NULL, 'nidG2', 3697),
(3698, 'cd14616', NULL, 'R-PTPc-Q', NULL, NULL, 'R-PTPc-Q', 3698),
(3699, 'cd01535', NULL, '4RHOD_Repeat_4', NULL, NULL, '4RHOD_Repeat_4', 3699),
(3700, 'cd14421', NULL, 'CUE_AMFR', NULL, NULL, 'CUE_AMFR', 3700),
(3701, 'cd01437', NULL, 'parp_like', NULL, NULL, 'parp_like', 3701),
(3702, 'cd13940', NULL, 'ILEI_FAM3C', NULL, NULL, 'ILEI_FAM3C', 3702),
(3703, 'cd03078', NULL, 'GST_N_Metaxin1_like', NULL, NULL, 'GST_N_Metaxin1_like', 3703),
(3704, 'cd03404', NULL, 'SPFH_HflK', NULL, NULL, 'SPFH_HflK', 3704),
(3705, 'cd05938', NULL, 'hsFATP2a_ACSVL_like', NULL, NULL, 'hsFATP2a_ACSVL_like', 3705),
(3706, 'cd17952', NULL, 'DEADc_DDX42', NULL, NULL, 'DEADc_DDX42', 3706),
(3707, 'cd13391', NULL, 'PH_PRG', NULL, NULL, 'PH_PRG', 3707),
(3708, 'cd12531', NULL, 'RRM3_MEI2_like', NULL, NULL, 'RRM3_MEI2_like', 3708),
(3709, 'cd02242', NULL, 'cupin_11S_legumin_N', NULL, NULL, 'cupin_11S_legumin_N', 3709),
(3710, 'cd12349', NULL, 'RRM2_SHARP', NULL, NULL, 'RRM2_SHARP', 3710),
(3711, 'cd01832', NULL, 'SGNH_hydrolase_like_1', NULL, NULL, 'SGNH_hydrolase_like_1', 3711),
(3712, 'cd05109', NULL, 'PTKc_HER2', NULL, NULL, 'PTKc_HER2', 3712),
(3713, 'cd20291', NULL, 'cupin_CucA-like', NULL, NULL, 'cupin_CucA-like', 3713),
(3714, 'cd12041', NULL, 'SH3_CACNB1', NULL, NULL, 'SH3_CACNB1', 3714),
(3715, 'cd00159', NULL, 'RhoGAP', NULL, NULL, 'RhoGAP', 3715),
(3716, 'cd03084', NULL, 'phosphohexomutase', NULL, NULL, 'phosphohexomutase', 3716),
(3717, 'cd17709', NULL, 'BRCT_pescadillo_like', NULL, NULL, 'BRCT_pescadillo_like', 3717),
(3718, 'cd02883', NULL, 'Nudix_Hydrolase', NULL, NULL, 'Nudix_Hydrolase', 3718),
(3719, 'cd01277', NULL, 'HINT_subgroup', NULL, NULL, 'HINT_subgroup', 3719),
(3720, 'cd16024', NULL, 'GPI_EPT_2', NULL, NULL, 'GPI_EPT_2', 3720),
(3721, 'cd16845', NULL, 'STAT1_DBD', NULL, NULL, 'STAT1_DBD', 3721),
(3722, 'cd02538', NULL, 'G1P_TT_short', NULL, NULL, 'G1P_TT_short', 3722),
(3723, 'cd02520', NULL, 'Glucosylceramide_synthase', NULL, NULL, 'Glucosylceramide_synthase', 3723),
(3724, 'cd09596', NULL, 'M36', NULL, NULL, 'M36', 3724),
(3725, 'cd06427', NULL, 'CESA_like_2', NULL, NULL, 'CESA_like_2', 3725),
(3726, 'cd05862', NULL, 'Ig_VEGFR', NULL, NULL, 'Ig_VEGFR', 3726),
(3727, 'cd15575', NULL, 'PHD_JMJD2A', NULL, NULL, 'PHD_JMJD2A', 3727),
(3728, 'cd03571', NULL, 'ENTH', NULL, NULL, 'ENTH', 3728),
(3729, 'cd08639', NULL, 'DNA_pol_A_Aquificae_like', NULL, NULL, 'DNA_pol_A_Aquificae_like', 3729),
(3730, 'cd16992', NULL, 'ENTH_Ent3', NULL, NULL, 'ENTH_Ent3', 3730),
(3731, 'cd19938', NULL, 'REC_OmpR_BaeR-like', NULL, NULL, 'REC_OmpR_BaeR-like', 3731),
(3732, 'cd05390', NULL, 'HypB', NULL, NULL, 'HypB', 3732),
(3733, 'cd11274', NULL, 'Sema_plexin_A4', NULL, NULL, 'Sema_plexin_A4', 3733),
(3734, 'cd16830', NULL, 'HemS-like_N', NULL, NULL, 'HemS-like_N', 3734),
(3735, 'cd19425', NULL, 'lipocalin_10-like', NULL, NULL, 'lipocalin_10-like', 3735),
(3736, 'cd04715', NULL, 'BAH_Orc1p_like', NULL, NULL, 'BAH_Orc1p_like', 3736),
(3737, 'cd00763', NULL, 'Bacterial_PFK', NULL, NULL, 'Bacterial_PFK', 3737),
(3738, 'cd07450', NULL, 'CRD_FZ6', NULL, NULL, 'CRD_FZ6', 3738),
(3739, 'cd16705', NULL, 'RING-HC_dBre1_like', NULL, NULL, 'RING-HC_dBre1_like', 3739),
(3740, 'cd16955', NULL, 'HATPase_YpdA-like', NULL, NULL, 'HATPase_YpdA-like', 3740),
(3741, 'cd02202', NULL, 'CetZ_tubulin-like', NULL, NULL, 'CetZ_tubulin-like', 3741),
(3742, 'cd17522', NULL, 'RMtype1_S_MjaORF1531P-TRD1-CR1_like', NULL, NULL, 'RMtype1_S_MjaORF1531P-TRD1-CR1_like', 3742),
(3743, 'cd07003', NULL, 'cupin_YobQ-like_N', NULL, NULL, 'cupin_YobQ-like_N', 3743);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(3744, 'cd15980', NULL, '7tmA_NPFFR2', NULL, NULL, '7tmA_NPFFR2', 3744),
(3745, 'cd05715', NULL, 'Ig_P0-like', NULL, NULL, 'Ig_P0-like', 3745),
(3746, 'cd06331', NULL, 'PBP1_AmiC-like', NULL, NULL, 'PBP1_AmiC-like', 3746),
(3747, 'cd16227', NULL, 'EFh_CREC_RCN2_like', NULL, NULL, 'EFh_CREC_RCN2_like', 3747),
(3748, 'cd08819', NULL, 'CARD_MDA5_r2', NULL, NULL, 'CARD_MDA5_r2', 3748),
(3749, 'cd09887', NULL, 'NGN_Arch', NULL, NULL, 'NGN_Arch', 3749),
(3750, 'cd17451', NULL, 'MFS_NLS1_MFSD2A', NULL, NULL, 'MFS_NLS1_MFSD2A', 3750),
(3751, 'cd17192', NULL, 'FERM_F1_PTPN21', NULL, NULL, 'FERM_F1_PTPN21', 3751),
(3752, 'cd09319', NULL, 'TDT_like_1', NULL, NULL, 'TDT_like_1', 3752),
(3753, 'cd01968', NULL, 'Nitrogenase_NifE_I', NULL, NULL, 'Nitrogenase_NifE_I', 3753),
(3754, 'cd01003', NULL, 'PBP2_YckB', NULL, NULL, 'PBP2_YckB', 3754),
(3755, 'cd03423', NULL, 'SirA', NULL, NULL, 'SirA', 3755),
(3756, 'cd01393', NULL, 'recA_like', NULL, NULL, 'recA_like', 3756),
(3757, 'cd14559', NULL, 'PTP_YopH-like', NULL, NULL, 'PTP_YopH-like', 3757),
(3758, 'cd15808', NULL, 'SPRY_PRY_TRIM47', NULL, NULL, 'SPRY_PRY_TRIM47', 3758),
(3759, 'cd10456', NULL, 'GIY-YIG_UPF0213', NULL, NULL, 'GIY-YIG_UPF0213', 3759),
(3760, 'cd15261', NULL, '7tmB1_PDFR', NULL, NULL, '7tmB1_PDFR', 3760),
(3761, 'cd05043', NULL, 'PTK_Ryk', NULL, NULL, 'PTK_Ryk', 3761),
(3762, 'cd07586', NULL, 'nitrilase_8', NULL, NULL, 'nitrilase_8', 3762),
(3763, 'cd17785', NULL, 'CBS_pair_bac_arch', NULL, NULL, 'CBS_pair_bac_arch', 3763),
(3764, 'cd04516', NULL, 'TBP_eukaryotes', NULL, NULL, 'TBP_eukaryotes', 3764),
(3765, 'cd06647', NULL, 'STKc_PAK_I', NULL, NULL, 'STKc_PAK_I', 3765),
(3766, 'cd08753', NULL, 'RGS_PDZRhoGEF', NULL, NULL, 'RGS_PDZRhoGEF', 3766),
(3767, 'cd12343', NULL, 'RRM1_2_CoAA_like', NULL, NULL, 'RRM1_2_CoAA_like', 3767),
(3768, 'cd14605', NULL, 'PTPc-N11', NULL, NULL, 'PTPc-N11', 3768),
(3769, 'cd00214', NULL, 'Calpain_III', NULL, NULL, 'Calpain_III', 3769),
(3770, 'cd08583', NULL, 'PI-PLCc_GDPD_SF_unchar1', NULL, NULL, 'PI-PLCc_GDPD_SF_unchar1', 3770),
(3771, 'cd15034', NULL, '7tmF_FZD1_2_7-like', NULL, NULL, '7tmF_FZD1_2_7-like', 3771),
(3772, 'cd15473', NULL, 'Myo5p-like_CBD_DIL_ANK', NULL, NULL, 'Myo5p-like_CBD_DIL_ANK', 3772),
(3773, 'cd10526', NULL, 'SET_SMYD1', NULL, NULL, 'SET_SMYD1', 3773),
(3774, 'cd13832', NULL, 'IHF', NULL, NULL, 'IHF', 3774),
(3775, 'cd09803', NULL, 'UBAN', NULL, NULL, 'UBAN', 3775),
(3776, 'cd14236', NULL, 'GAT_TOM1', NULL, NULL, 'GAT_TOM1', 3776),
(3777, 'cd05078', NULL, 'PTK_Jak2_rpt1', NULL, NULL, 'PTK_Jak2_rpt1', 3777),
(3778, 'cd13351', NULL, 'PH-GRAM1_TCB1D9_TCB1D9B', NULL, NULL, 'PH-GRAM1_TCB1D9_TCB1D9B', 3778),
(3779, 'cd04144', NULL, 'Ras2', NULL, NULL, 'Ras2', 3779),
(3780, 'cd09238', NULL, 'V_Alix_like_1', NULL, NULL, 'V_Alix_like_1', 3780),
(3781, 'cd15478', NULL, 'Myo5a_CBD', NULL, NULL, 'Myo5a_CBD', 3781),
(3782, 'cd16406', NULL, 'ParB_N_like', NULL, NULL, 'ParB_N_like', 3782),
(3783, 'cd14423', NULL, 'CUE_UBR5', NULL, NULL, 'CUE_UBR5', 3783),
(3784, 'cd03737', NULL, 'SOCS_SOCS3', NULL, NULL, 'SOCS_SOCS3', 3784),
(3785, 'cd15931', NULL, '7tmB2_EMR_Adhesion_II', NULL, NULL, '7tmB2_EMR_Adhesion_II', 3785),
(3786, 'cd13223', NULL, 'PH-GRAM_MTM-like', NULL, NULL, 'PH-GRAM_MTM-like', 3786),
(3787, 'cd08287', NULL, 'FDH_like_ADH3', NULL, NULL, 'FDH_like_ADH3', 3787),
(3788, 'cd09194', NULL, 'PLDc_yTdp1_1', NULL, NULL, 'PLDc_yTdp1_1', 3788),
(3789, 'cd03679', NULL, 'MM_CoA_mutase_alpha_like', NULL, NULL, 'MM_CoA_mutase_alpha_like', 3789),
(3790, 'cd17078', NULL, 'Ubl_SLD1_NFATC2ip', NULL, NULL, 'Ubl_SLD1_NFATC2ip', 3790),
(3791, 'cd05941', NULL, 'MCS', NULL, NULL, 'MCS', 3791),
(3792, 'cd14408', NULL, 'UBA_SIK1', NULL, NULL, 'UBA_SIK1', 3792),
(3793, 'cd15976', NULL, '7tmA_ET-BR', NULL, NULL, '7tmA_ET-BR', 3793),
(3794, 'cd08301', NULL, 'alcohol_DH_plants', NULL, NULL, 'alcohol_DH_plants', 3794),
(3795, 'cd05857', NULL, 'Ig2_FGFR', NULL, NULL, 'Ig2_FGFR', 3795),
(3796, 'cd18591', NULL, 'ABC_6TM_SUR1_D1_like', NULL, NULL, 'ABC_6TM_SUR1_D1_like', 3796),
(3797, 'cd14504', NULL, 'DUSP23', NULL, NULL, 'DUSP23', 3797);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(3798, 'cd19773', NULL, 'Bbox2_TRIM23_C-IX_rpt1', NULL, NULL, 'Bbox2_TRIM23_C-IX_rpt1', 3798),
(3799, 'cd16100', NULL, 'ARID', NULL, NULL, 'ARID', 3799),
(3800, 'cd18965', NULL, 'chromodomain', NULL, NULL, 'chromodomain', 3800),
(3801, 'cd14002', NULL, 'STKc_STK36', NULL, NULL, 'STKc_STK36', 3801),
(3802, 'cd13585', NULL, 'PBP2_TMBP_like', NULL, NULL, 'PBP2_TMBP_like', 3802),
(3803, 'cd07381', NULL, 'MPP_CapA', NULL, NULL, 'MPP_CapA', 3803),
(3804, 'cd11478', NULL, 'SLC5sbd_u2', NULL, NULL, 'SLC5sbd_u2', 3804),
(3805, 'cd11320', NULL, 'AmyAc_AmyMalt_CGTase_like', NULL, NULL, 'AmyAc_AmyMalt_CGTase_like', 3805),
(3806, 'cd07978', NULL, 'TAF13', NULL, NULL, 'TAF13', 3806),
(3807, 'cd20298', NULL, 'cupin_UAH', NULL, NULL, 'cupin_UAH', 3807),
(3808, 'cd07249', NULL, 'MMCE', NULL, NULL, 'MMCE', 3808),
(3809, 'cd10925', NULL, 'CE4_u1', NULL, NULL, 'CE4_u1', 3809),
(3810, 'cd04020', NULL, 'C2B_SLP_1-2-3-4', NULL, NULL, 'C2B_SLP_1-2-3-4', 3810),
(3811, 'cd13859', NULL, 'CuRO_D1_2dMcoN_like', NULL, NULL, 'CuRO_D1_2dMcoN_like', 3811),
(3812, 'cd14927', NULL, 'MYSc_Myh7b', NULL, NULL, 'MYSc_Myh7b', 3812),
(3813, 'cd17298', NULL, 'DUF1907', NULL, NULL, 'DUF1907', 3813),
(3814, 'cd19756', NULL, 'Bbox2', NULL, NULL, 'Bbox2', 3814),
(3815, 'cd12914', NULL, 'PDC1_DGC_like', NULL, NULL, 'PDC1_DGC_like', 3815),
(3816, 'cd08891', NULL, 'SRPBCC_CalC', NULL, NULL, 'SRPBCC_CalC', 3816),
(3817, 'cd13689', NULL, 'PBP2_BsGlnH', NULL, NULL, 'PBP2_BsGlnH', 3817),
(3818, 'cd13769', NULL, 'ApoLp-III_like', NULL, NULL, 'ApoLp-III_like', 3818),
(3819, 'cd10787', NULL, 'LamB_YcsF_like', NULL, NULL, 'LamB_YcsF_like', 3819),
(3820, 'cd16229', NULL, 'EFh_CREC_RCN1', NULL, NULL, 'EFh_CREC_RCN1', 3820),
(3821, 'cd16913', NULL, 'YkuD_like', NULL, NULL, 'YkuD_like', 3821),
(3822, 'cd05937', NULL, 'FATP_chFAT1_like', NULL, NULL, 'FATP_chFAT1_like', 3822),
(3823, 'cd04433', NULL, 'AFD_class_I', NULL, NULL, 'AFD_class_I', 3823),
(3824, 'cd10301', NULL, 'GST_C_CLIC6', NULL, NULL, 'GST_C_CLIC6', 3824),
(3825, 'cd09999', NULL, 'Arginase-like_1', NULL, NULL, 'Arginase-like_1', 3825),
(3826, 'cd19192', NULL, 'PR-SET_PRDM8', NULL, NULL, 'PR-SET_PRDM8', 3826),
(3827, 'cd03517', NULL, 'Link_domain_CSPGs_modules_1_3', NULL, NULL, 'Link_domain_CSPGs_modules_1_3', 3827),
(3828, 'cd19856', NULL, 'DSRM_Kanadaptin', NULL, NULL, 'DSRM_Kanadaptin', 3828),
(3829, 'cd16599', NULL, 'RING-HC_TRIM35_C-IV', NULL, NULL, 'RING-HC_TRIM35_C-IV', 3829),
(3830, 'cd05687', NULL, 'S1_RPS1_repeat_ec1_hs1', NULL, NULL, 'S1_RPS1_repeat_ec1_hs1', 3830),
(3831, 'cd07378', NULL, 'MPP_ACP5', NULL, NULL, 'MPP_ACP5', 3831),
(3832, 'cd16360', NULL, 'ED_TypeI_classII_N', NULL, NULL, 'ED_TypeI_classII_N', 3832),
(3833, 'cd16617', NULL, 'mRING-HC-C4C4_CesA_plant', NULL, NULL, 'mRING-HC-C4C4_CesA_plant', 3833),
(3834, 'cd18793', NULL, 'SF2_C_SNF', NULL, NULL, 'SF2_C_SNF', 3834),
(3835, 'cd14511', NULL, 'PTP_auxilin-like', NULL, NULL, 'PTP_auxilin-like', 3835),
(3836, 'cd07969', NULL, 'OBF_DNA_ligase_I', NULL, NULL, 'OBF_DNA_ligase_I', 3836),
(3837, 'cd15411', NULL, '7tmA_OR8H-like', NULL, NULL, '7tmA_OR8H-like', 3837),
(3838, 'cd01885', NULL, 'EF2', NULL, NULL, 'EF2', 3838),
(3839, 'cd18601', NULL, 'ABC_6TM_MRP4_D2_like', NULL, NULL, 'ABC_6TM_MRP4_D2_like', 3839),
(3840, 'cd06879', NULL, 'PX_UP1_plant', NULL, NULL, 'PX_UP1_plant', 3840),
(3841, 'cd14360', NULL, 'UBA_NAC_like_bac', NULL, NULL, 'UBA_NAC_like_bac', 3841),
(3842, 'cd03113', NULL, 'CTPS_N', NULL, NULL, 'CTPS_N', 3842),
(3843, 'cd06222', NULL, 'RNase_H_like', NULL, NULL, 'RNase_H_like', 3843),
(3844, 'cd08350', NULL, 'BLMT_like', NULL, NULL, 'BLMT_like', 3844),
(3845, 'cd12839', NULL, 'Killer_toxin_beta', NULL, NULL, 'Killer_toxin_beta', 3845),
(3846, 'cd01768', NULL, 'RA_FERM_F0_F1_like', NULL, NULL, 'RA_FERM_F0_F1_like', 3846),
(3847, 'cd00043', NULL, 'CYCLIN', NULL, NULL, 'CYCLIN', 3847),
(3848, 'sd00005', NULL, 'TPR', NULL, NULL, 'TPR', 3848),
(3849, 'cd00371', NULL, 'HMA', NULL, NULL, 'HMA', 3849),
(3850, 'cd09531', NULL, 'SAM_CS047', NULL, NULL, 'SAM_CS047', 3850),
(3851, 'cd18327', NULL, 'BTB_POZ_ZBTB7B_ZBTB15', NULL, NULL, 'BTB_POZ_ZBTB7B_ZBTB15', 3851);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(3852, 'cd16840', NULL, 'toxin_MLD', NULL, NULL, 'toxin_MLD', 3852),
(3853, 'cd14225', NULL, 'PKc_DYRK4', NULL, NULL, 'PKc_DYRK4', 3853),
(3854, 'cd15468', NULL, 'HeV-G', NULL, NULL, 'HeV-G', 3854),
(3855, 'cd11387', NULL, 'bHLHzip_USF_MITF', NULL, NULL, 'bHLHzip_USF_MITF', 3855),
(3856, 'cd08922', NULL, 'FHb-globin', NULL, NULL, 'FHb-globin', 3856),
(3857, 'cd20221', NULL, 'PFM_Dln1-like', NULL, NULL, 'PFM_Dln1-like', 3857),
(3858, 'cd12430', NULL, 'RRM_LARP4_5_like', NULL, NULL, 'RRM_LARP4_5_like', 3858),
(3859, 'cd05847', NULL, 'IgC_CH2_IgE', NULL, NULL, 'IgC_CH2_IgE', 3859),
(3860, 'cd16949', NULL, 'HATPase_CpxA-like', NULL, NULL, 'HATPase_CpxA-like', 3860),
(3861, 'cd19891', NULL, 'DSRM_PRKRA_rpt2', NULL, NULL, 'DSRM_PRKRA_rpt2', 3861),
(3862, 'cd16869', NULL, 'ARID_ARID5', NULL, NULL, 'ARID_ARID5', 3862),
(3863, 'cd02144', NULL, 'iodotyrosine_dehalogenase', NULL, NULL, 'iodotyrosine_dehalogenase', 3863),
(3864, 'cd04056', NULL, 'Peptidases_S53', NULL, NULL, 'Peptidases_S53', 3864),
(3865, 'cd14086', NULL, 'STKc_CaMKII', NULL, NULL, 'STKc_CaMKII', 3865),
(3866, 'cd16418', NULL, 'HAD_Pase', NULL, NULL, 'HAD_Pase', 3866),
(3867, 'cd16716', NULL, 'vRING-HC_IRF2BP2', NULL, NULL, 'vRING-HC_IRF2BP2', 3867),
(3868, 'cd04300', NULL, 'GT35_Glycogen_Phosphorylase', NULL, NULL, 'GT35_Glycogen_Phosphorylase', 3868),
(3869, 'cd12056', NULL, 'SH3_CD2AP_3', NULL, NULL, 'SH3_CD2AP_3', 3869),
(3870, 'cd03580', NULL, 'NTR_Sfrp1_like', NULL, NULL, 'NTR_Sfrp1_like', 3870),
(3871, 'cd02550', NULL, 'PseudoU_synth_Rsu_Rlu_like', NULL, NULL, 'PseudoU_synth_Rsu_Rlu_like', 3871),
(3872, 'cd08497', NULL, 'PBP2_NikA_DppA_OppA_like_14', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_14', 3872),
(3873, 'cd12553', NULL, 'RRM1_RBM15', NULL, NULL, 'RRM1_RBM15', 3873),
(3874, 'cd11752', NULL, 'GH94N_CDP_like', NULL, NULL, 'GH94N_CDP_like', 3874),
(3875, 'cd03431', NULL, 'DNA_Glycosylase_C', NULL, NULL, 'DNA_Glycosylase_C', 3875),
(3876, 'cd07330', NULL, 'M48A_Ste24p', NULL, NULL, 'M48A_Ste24p', 3876),
(3877, 'cd01524', NULL, 'RHOD_Pyr_redox', NULL, NULL, 'RHOD_Pyr_redox', 3877),
(3878, 'cd18833', NULL, 'GH43_PcXyl-like', NULL, NULL, 'GH43_PcXyl-like', 3878),
(3879, 'cd09329', NULL, 'LIM3_abLIM', NULL, NULL, 'LIM3_abLIM', 3879),
(3880, 'cd02760', NULL, 'MopB_Phenylacetyl-CoA-OR', NULL, NULL, 'MopB_Phenylacetyl-CoA-OR', 3880),
(3881, 'cd17146', NULL, 'DCX1_RP1L1', NULL, NULL, 'DCX1_RP1L1', 3881),
(3882, 'cd06245', NULL, 'M14_CPD_III', NULL, NULL, 'M14_CPD_III', 3882),
(3883, 'cd15763', NULL, 'FYVE_RPH3L', NULL, NULL, 'FYVE_RPH3L', 3883),
(3884, 'cd21662', NULL, 'embe-CoV_Protein-I_like', NULL, NULL, 'embe-CoV_Protein-I_like', 3884),
(3885, 'cd08003', NULL, 'WGR_PARP2_like', NULL, NULL, 'WGR_PARP2_like', 3885),
(3886, 'cd17540', NULL, 'REC_PhyR', NULL, NULL, 'REC_PhyR', 3886),
(3887, 'cd13157', NULL, 'PTB_tensin-related', NULL, NULL, 'PTB_tensin-related', 3887),
(3888, 'cd04010', NULL, 'C2B_RasA3', NULL, NULL, 'C2B_RasA3', 3888),
(3889, 'cd14777', NULL, 'Yhb1-globin-like', NULL, NULL, 'Yhb1-globin-like', 3889),
(3890, 'cd15119', NULL, '7tmA_GPR1', NULL, NULL, '7tmA_GPR1', 3890),
(3891, 'cd18759', NULL, 'PIN_MtVapC3-like', NULL, NULL, 'PIN_MtVapC3-like', 3891),
(3892, 'cd11962', NULL, 'SH3_Abp1_fungi_C1', NULL, NULL, 'SH3_Abp1_fungi_C1', 3892),
(3893, 'cd08550', NULL, 'GlyDH-like', NULL, NULL, 'GlyDH-like', 3893),
(3894, 'cd11490', NULL, 'SLC5sbd_SGLT6', NULL, NULL, 'SLC5sbd_SGLT6', 3894),
(3895, 'cd05860', NULL, 'Ig4_SCFR', NULL, NULL, 'Ig4_SCFR', 3895),
(3896, 'cd14328', NULL, 'UBA_TNK1', NULL, NULL, 'UBA_TNK1', 3896),
(3897, 'cd17095', NULL, 'FERM_F0_kindlins', NULL, NULL, 'FERM_F0_kindlins', 3897),
(3898, 'cd05716', NULL, 'Ig_pIgR_like', NULL, NULL, 'Ig_pIgR_like', 3898),
(3899, 'cd15047', NULL, '7tmC_GABA-B-like', NULL, NULL, '7tmC_GABA-B-like', 3899),
(3900, 'cd03221', NULL, 'ABCF_EF-3', NULL, NULL, 'ABCF_EF-3', 3900),
(3901, 'cd12092', NULL, 'TM_ErbB4', NULL, NULL, 'TM_ErbB4', 3901),
(3902, 'cd14418', NULL, 'CUE_DMA_DMRTA2', NULL, NULL, 'CUE_DMA_DMRTA2', 3902),
(3903, 'cd08558', NULL, 'PI-PLCc_eukaryota', NULL, NULL, 'PI-PLCc_eukaryota', 3903);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(3904, 'cd11458', NULL, 'bHLHzip_c-Myc', NULL, NULL, 'bHLHzip_c-Myc', 3904),
(3905, 'cd01448', NULL, 'TST_Repeat_1', NULL, NULL, 'TST_Repeat_1', 3905),
(3906, 'cd06255', NULL, 'M14_ASTE_ASPA-like', NULL, NULL, 'M14_ASTE_ASPA-like', 3906),
(3907, 'cd08307', NULL, 'Death_Pelle', NULL, NULL, 'Death_Pelle', 3907),
(3908, 'cd12121', NULL, 'MARK_C_like', NULL, NULL, 'MARK_C_like', 3908),
(3909, 'cd05645', NULL, 'M20_peptidase_T', NULL, NULL, 'M20_peptidase_T', 3909),
(3910, 'cd08802', NULL, 'Death_UNC5B', NULL, NULL, 'Death_UNC5B', 3910),
(3911, 'cd15304', NULL, '7tmA_5-HT2A', NULL, NULL, '7tmA_5-HT2A', 3911),
(3912, 'cd05071', NULL, 'PTKc_Src', NULL, NULL, 'PTKc_Src', 3912),
(3913, 'cd06467', NULL, 'p23_NUDC_like', NULL, NULL, 'p23_NUDC_like', 3913),
(3914, 'cd09407', NULL, 'LIM2_Paxillin', NULL, NULL, 'LIM2_Paxillin', 3914),
(3915, 'cd14486', NULL, '3D_domain', NULL, NULL, '3D_domain', 3915),
(3916, 'cd15149', NULL, '7tmA_P2Y14', NULL, NULL, '7tmA_P2Y14', 3916),
(3917, 'cd19986', NULL, 'PBP1_ABC_HAAT-like', NULL, NULL, 'PBP1_ABC_HAAT-like', 3917),
(3918, 'cd12166', NULL, '2-Hacid_dh_7', NULL, NULL, '2-Hacid_dh_7', 3918),
(3919, 'sd00017', NULL, 'ZF_C2H2', NULL, NULL, 'ZF_C2H2', 3919),
(3920, 'cd11622', NULL, 'HR1_PKN_1', NULL, NULL, 'HR1_PKN_1', 3920),
(3921, 'cd16567', NULL, 'RING-HC_RAD16_like', NULL, NULL, 'RING-HC_RAD16_like', 3921),
(3922, 'cd00259', NULL, 'STNV', NULL, NULL, 'STNV', 3922),
(3923, 'cd08914', NULL, 'START_STARD15-like', NULL, NULL, 'START_STARD15-like', 3923),
(3924, 'cd09625', NULL, 'DOMON_like_cytochrome', NULL, NULL, 'DOMON_like_cytochrome', 3924),
(3925, 'cd05082', NULL, 'PTKc_Csk', NULL, NULL, 'PTKc_Csk', 3925),
(3926, 'cd05924', NULL, 'FACL_like_5', NULL, NULL, 'FACL_like_5', 3926),
(3927, 'cd10345', NULL, 'SH2_C-SH2_Zap70_Syk_like', NULL, NULL, 'SH2_C-SH2_Zap70_Syk_like', 3927),
(3928, 'cd09559', NULL, 'SAM_SASH1_repeat1', NULL, NULL, 'SAM_SASH1_repeat1', 3928),
(3929, 'cd07599', NULL, 'BAR_Rvs167p', NULL, NULL, 'BAR_Rvs167p', 3929),
(3930, 'cd10942', NULL, 'CE4_u11', NULL, NULL, 'CE4_u11', 3930),
(3931, 'cd06974', NULL, 'TerD_like', NULL, NULL, 'TerD_like', 3931),
(3932, 'cd21517', NULL, 'cv_beta_Nsp2_MERS-like', NULL, NULL, 'cv_beta_Nsp2_MERS-like', 3932),
(3933, 'cd13325', NULL, 'PH_unc89', NULL, NULL, 'PH_unc89', 3933),
(3934, 'cd01168', NULL, 'adenosine_kinase', NULL, NULL, 'adenosine_kinase', 3934),
(3935, 'cd10394', NULL, 'SH2_RIN2', NULL, NULL, 'SH2_RIN2', 3935),
(3936, 'cd17162', NULL, 'UBX_UBXN2C', NULL, NULL, 'UBX_UBXN2C', 3936),
(3937, 'cd19139', NULL, 'AKR_AKR3F2', NULL, NULL, 'AKR_AKR3F2', 3937),
(3938, 'cd12222', NULL, 'Caa3-IV', NULL, NULL, 'Caa3-IV', 3938),
(3939, 'cd10406', NULL, 'SH2_Vav2', NULL, NULL, 'SH2_Vav2', 3939),
(3940, 'cd00067', NULL, 'GAL4', NULL, NULL, 'GAL4', 3940),
(3941, 'cd01794', NULL, 'Ubl_UBTD', NULL, NULL, 'Ubl_UBTD', 3941),
(3942, 'cd04110', NULL, 'Rab35', NULL, NULL, 'Rab35', 3942),
(3943, 'cd20374', NULL, 'Pot1C', NULL, NULL, 'Pot1C', 3943),
(3944, 'cd06188', NULL, 'NADH_quinone_reductase', NULL, NULL, 'NADH_quinone_reductase', 3944),
(3945, 'cd00769', NULL, 'PheRS_beta_core', NULL, NULL, 'PheRS_beta_core', 3945),
(3946, 'cd09659', NULL, 'Cas4_I-A', NULL, NULL, 'Cas4_I-A', 3946),
(3947, 'cd07144', NULL, 'ALDH_ALD2-YMR170C', NULL, NULL, 'ALDH_ALD2-YMR170C', 3947),
(3948, 'cd11630', NULL, 'HR1_PKN1_2', NULL, NULL, 'HR1_PKN1_2', 3948),
(3949, 'cd11639', NULL, 'HR1_ROCK1', NULL, NULL, 'HR1_ROCK1', 3949),
(3950, 'cd00636', NULL, 'TroA-like', NULL, NULL, 'TroA-like', 3950),
(3951, 'cd01386', NULL, 'MYSc_Myo18', NULL, NULL, 'MYSc_Myo18', 3951),
(3952, 'cd05778', NULL, 'DNA_polB_zeta_exo', NULL, NULL, 'DNA_polB_zeta_exo', 3952),
(3953, 'cd06656', NULL, 'STKc_PAK3', NULL, NULL, 'STKc_PAK3', 3953),
(3954, 'cd06194', NULL, 'FNR_N-term_Iron_sulfur_binding', NULL, NULL, 'FNR_N-term_Iron_sulfur_binding', 3954),
(3955, 'cd09683', NULL, 'Csm3_III-A', NULL, NULL, 'Csm3_III-A', 3955),
(3956, 'cd18008', NULL, 'DEXDc_SHPRH-like', NULL, NULL, 'DEXDc_SHPRH-like', 3956),
(3957, 'cd00098', NULL, 'IgC', NULL, NULL, 'IgC', 3957),
(3958, 'cd13657', NULL, 'PBP2_Maltodextrin', NULL, NULL, 'PBP2_Maltodextrin', 3958);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(3959, 'cd03710', NULL, 'BipA_TypA_C', NULL, NULL, 'BipA_TypA_C', 3959),
(3960, 'cd20004', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, 'PBP1_ABC_sugar_binding-like', 3960),
(3961, 'cd01031', NULL, 'EriC', NULL, NULL, 'EriC', 3961),
(3962, 'cd07680', NULL, 'F-BAR_PACSIN1', NULL, NULL, 'F-BAR_PACSIN1', 3962),
(3963, 'cd07816', NULL, 'Bet_v1-like', NULL, NULL, 'Bet_v1-like', 3963),
(3964, 'cd13681', NULL, 'PBP2_TRAP_lactate', NULL, NULL, 'PBP2_TRAP_lactate', 3964),
(3965, 'cd09084', NULL, 'EEP-2', NULL, NULL, 'EEP-2', 3965),
(3966, 'cd18428', NULL, 'BTB_POZ_KCNS3', NULL, NULL, 'BTB_POZ_KCNS3', 3966),
(3967, 'cd08925', NULL, 'Hb-beta-like', NULL, NULL, 'Hb-beta-like', 3967),
(3968, 'cd01368', NULL, 'KISc_KIF23_like', NULL, NULL, 'KISc_KIF23_like', 3968),
(3969, 'cd03699', NULL, 'EF4_II', NULL, NULL, 'EF4_II', 3969),
(3970, 'cd03112', NULL, 'CobW-like', NULL, NULL, 'CobW-like', 3970),
(3971, 'cd15695', NULL, 'ePHD1_KMT2D', NULL, NULL, 'ePHD1_KMT2D', 3971),
(3972, 'cd08045', NULL, 'TAF4', NULL, NULL, 'TAF4', 3972),
(3973, 'cd16559', NULL, 'RING-HC_RNF208', NULL, NULL, 'RING-HC_RNF208', 3973),
(3974, 'cd16441', NULL, 'beta_Kdo_transferase_KpsS', NULL, NULL, 'beta_Kdo_transferase_KpsS', 3974),
(3975, 'cd17239', NULL, 'FERM_F1_Ezrin', NULL, NULL, 'FERM_F1_Ezrin', 3975),
(3976, 'cd05037', NULL, 'PTK_Jak_rpt1', NULL, NULL, 'PTK_Jak_rpt1', 3976),
(3977, 'cd21528', NULL, 'CoV_Nsp14', NULL, NULL, 'CoV_Nsp14', 3977),
(3978, 'cd15967', NULL, '7tmA_P2Y1-like', NULL, NULL, '7tmA_P2Y1-like', 3978),
(3979, 'cd01026', NULL, 'TOPRIM_OLD', NULL, NULL, 'TOPRIM_OLD', 3979),
(3980, 'cd12627', NULL, 'RRM1_IGF2BP3', NULL, NULL, 'RRM1_IGF2BP3', 3980),
(3981, 'cd02664', NULL, 'Peptidase_C19H', NULL, NULL, 'Peptidase_C19H', 3981),
(3982, 'cd05228', NULL, 'AR_FR_like_1_SDR_e', NULL, NULL, 'AR_FR_like_1_SDR_e', 3982),
(3983, 'cd12306', NULL, 'RRM_II_PABPs', NULL, NULL, 'RRM_II_PABPs', 3983),
(3984, 'cd15092', NULL, '7tmA_NOFQ_opioid_R', NULL, NULL, '7tmA_NOFQ_opioid_R', 3984),
(3985, 'cd18473', NULL, 'BACK_KLHL34', NULL, NULL, 'BACK_KLHL34', 3985),
(3986, 'cd06660', NULL, 'AKR_SF', NULL, NULL, 'AKR_SF', 3986),
(3987, 'cd08688', NULL, 'C2_KIAA0528-like', NULL, NULL, 'C2_KIAA0528-like', 3987),
(3988, 'cd15667', NULL, 'ePHD_Snt2p_like', NULL, NULL, 'ePHD_Snt2p_like', 3988),
(3989, 'cd16653', NULL, 'RING-like_Rtf2', NULL, NULL, 'RING-like_Rtf2', 3989),
(3990, 'cd13136', NULL, 'MATE_DinF_like', NULL, NULL, 'MATE_DinF_like', 3990),
(3991, 'cd05820', NULL, 'CBM20_novamyl', NULL, NULL, 'CBM20_novamyl', 3991),
(3992, 'cd00113', NULL, 'PLAT', NULL, NULL, 'PLAT', 3992),
(3993, 'cd07933', NULL, 'RHD-n_c-Rel', NULL, NULL, 'RHD-n_c-Rel', 3993),
(3994, 'cd01418', NULL, 'Ribosomal_L19e_A', NULL, NULL, 'Ribosomal_L19e_A', 3994),
(3995, 'cd08778', NULL, 'Death_TNFRSF21', NULL, NULL, 'Death_TNFRSF21', 3995),
(3996, 'cd11848', NULL, 'SH3_SLAP-like', NULL, NULL, 'SH3_SLAP-like', 3996),
(3997, 'cd21485', NULL, 'HCoV-OC43-like_Spike_S1_RBD', NULL, NULL, 'HCoV-OC43-like_Spike_S1_RBD', 3997),
(3998, 'cd13176', NULL, 'RanBD_RanBP2-like', NULL, NULL, 'RanBD_RanBP2-like', 3998),
(3999, 'cd15337', NULL, '7tmA_Opsin_Gq_invertebrates', NULL, NULL, '7tmA_Opsin_Gq_invertebrates', 3999),
(4000, 'cd16691', NULL, 'mRING-H2-C3H3C2_Mio', NULL, NULL, 'mRING-H2-C3H3C2_Mio', 4000),
(4001, 'cd06997', NULL, 'cupin_MelR-like_N', NULL, NULL, 'cupin_MelR-like_N', 4001),
(4002, 'cd16370', NULL, 'DMSOR_beta_like', NULL, NULL, 'DMSOR_beta_like', 4002),
(4003, 'cd19725', NULL, 'bHLH_TS_OLIG2_like', NULL, NULL, 'bHLH_TS_OLIG2_like', 4003),
(4004, 'cd14122', NULL, 'STKc_VRK1', NULL, NULL, 'STKc_VRK1', 4004),
(4005, 'cd19162', NULL, 'AKR_FDH', NULL, NULL, 'AKR_FDH', 4005),
(4006, 'cd12588', NULL, 'RRM1_p54nrb', NULL, NULL, 'RRM1_p54nrb', 4006),
(4007, 'cd13332', NULL, 'FERM_C_JAK1', NULL, NULL, 'FERM_C_JAK1', 4007),
(4008, 'cd15204', NULL, '7tmA_prokineticin-R', NULL, NULL, '7tmA_prokineticin-R', 4008),
(4009, 'cd00165', NULL, 'S4', NULL, NULL, 'S4', 4009),
(4010, 'cd06419', NULL, 'GH25_muramidase_2', NULL, NULL, 'GH25_muramidase_2', 4010),
(4011, 'cd10543', NULL, 'SET_EHMT', NULL, NULL, 'SET_EHMT', 4011);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(4012, 'cd14046', NULL, 'STKc_EIF2AK4_GCN2_rpt2', NULL, NULL, 'STKc_EIF2AK4_GCN2_rpt2', 4012),
(4013, 'cd17213', NULL, 'RA_PHLPP', NULL, NULL, 'RA_PHLPP', 4013),
(4014, 'cd12045', NULL, 'SH3_SKAP2', NULL, NULL, 'SH3_SKAP2', 4014),
(4015, 'cd16430', NULL, 'TraB', NULL, NULL, 'TraB', 4015),
(4016, 'cd10468', NULL, 'Four-jointed-like_C', NULL, NULL, 'Four-jointed-like_C', 4016),
(4017, 'cd13995', NULL, 'STKc_MAP3K8', NULL, NULL, 'STKc_MAP3K8', 4017),
(4018, 'cd09692', NULL, 'Cas5_I-B', NULL, NULL, 'Cas5_I-B', 4018),
(4019, 'cd14574', NULL, 'DUSP28', NULL, NULL, 'DUSP28', 4019),
(4020, 'cd08155', NULL, 'catalase_clade_2', NULL, NULL, 'catalase_clade_2', 4020),
(4021, 'cd00677', NULL, 'S15_NS1_EPRS_RNA-bind', NULL, NULL, 'S15_NS1_EPRS_RNA-bind', 4021),
(4022, 'cd17234', NULL, 'Ubl_ATG8_MAP1LC3A', NULL, NULL, 'Ubl_ATG8_MAP1LC3A', 4022),
(4023, 'cd19386', NULL, 'TGF_beta_TGFB3', NULL, NULL, 'TGF_beta_TGFB3', 4023),
(4024, 'cd09636', NULL, 'Cas1_I-II-III', NULL, NULL, 'Cas1_I-II-III', 4024),
(4025, 'cd02789', NULL, 'MopB_CT_FmdC-FwdD', NULL, NULL, 'MopB_CT_FmdC-FwdD', 4025),
(4026, 'cd11313', NULL, 'AmyAc_arch_bac_AmyA', NULL, NULL, 'AmyAc_arch_bac_AmyA', 4026),
(4027, 'cd19014', NULL, 'LGIC_ECD_nAChR_A1', NULL, NULL, 'LGIC_ECD_nAChR_A1', 4027),
(4028, 'cd21409', NULL, '1B_cv_Nsp13-like', NULL, NULL, '1B_cv_Nsp13-like', 4028),
(4029, 'cd08881', NULL, 'RHO_alpha_C_NDO-like', NULL, NULL, 'RHO_alpha_C_NDO-like', 4029),
(4030, 'cd12170', NULL, '2-Hacid_dh_9', NULL, NULL, '2-Hacid_dh_9', 4030),
(4031, 'cd00772', NULL, 'ProRS_core', NULL, NULL, 'ProRS_core', 4031),
(4032, 'cd08073', NULL, 'MPN_NLPC_P60', NULL, NULL, 'MPN_NLPC_P60', 4032),
(4033, 'cd07165', NULL, 'NR_DBD_DmE78_like', NULL, NULL, 'NR_DBD_DmE78_like', 4033),
(4034, 'cd17529', NULL, 'HAMP_I', NULL, NULL, 'HAMP_I', 4034),
(4035, 'cd00637', NULL, '7tm_classA_rhodopsin-like', NULL, NULL, '7tm_classA_rhodopsin-like', 4035),
(4036, 'cd16929', NULL, 'HATPase_PDK-like', NULL, NULL, 'HATPase_PDK-like', 4036),
(4037, 'cd03688', NULL, 'eIF2_gamma_II', NULL, NULL, 'eIF2_gamma_II', 4037),
(4038, 'cd17913', NULL, 'DEXQc_Suv3', NULL, NULL, 'DEXQc_Suv3', 4038),
(4039, 'cd00163', NULL, 'RNase_A', NULL, NULL, 'RNase_A', 4039),
(4040, 'cd17466', NULL, 'T3SS_Flik_C_like', NULL, NULL, 'T3SS_Flik_C_like', 4040),
(4041, 'cd00063', NULL, 'FN3', NULL, NULL, 'FN3', 4041),
(4042, 'cd15097', NULL, '7tmA_Gal2_Gal3_R', NULL, NULL, '7tmA_Gal2_Gal3_R', 4042),
(4043, 'cd17470', NULL, 'T3SS_Flik_C', NULL, NULL, 'T3SS_Flik_C', 4043),
(4044, 'cd07218', NULL, 'Pat_iPLA2', NULL, NULL, 'Pat_iPLA2', 4044),
(4045, 'cd08224', NULL, 'STKc_Nek6_7', NULL, NULL, 'STKc_Nek6_7', 4045),
(4046, 'cd11515', NULL, 'SLC6sbd_NTT4-like', NULL, NULL, 'SLC6sbd_NTT4-like', 4046),
(4047, 'cd17792', NULL, 'CtkA', NULL, NULL, 'CtkA', 4047),
(4048, 'cd12618', NULL, 'RRM2_TIA1', NULL, NULL, 'RRM2_TIA1', 4048),
(4049, 'cd04950', NULL, 'GT4_TuaH-like', NULL, NULL, 'GT4_TuaH-like', 4049),
(4050, 'cd07146', NULL, 'ALDH_PhpJ', NULL, NULL, 'ALDH_PhpJ', 4050),
(4051, 'cd03744', NULL, 'SOCS_SSB1', NULL, NULL, 'SOCS_SSB1', 4051),
(4052, 'cd10315', NULL, 'CBM41_pullulanase', NULL, NULL, 'CBM41_pullulanase', 4052),
(4053, 'cd12427', NULL, 'RRM4_hnRNPL_like', NULL, NULL, 'RRM4_hnRNPL_like', 4053),
(4054, 'cd05368', NULL, 'DHRS6_like_SDR_c', NULL, NULL, 'DHRS6_like_SDR_c', 4054),
(4055, 'cd12301', NULL, 'RRM1_2_PAR10_like', NULL, NULL, 'RRM1_2_PAR10_like', 4055),
(4056, 'cd12200', NULL, 'AMPKA2_C', NULL, NULL, 'AMPKA2_C', 4056),
(4057, 'cd04301', NULL, 'NAT_SF', NULL, NULL, 'NAT_SF', 4057),
(4058, 'cd03334', NULL, 'Fab1_TCP', NULL, NULL, 'Fab1_TCP', 4058),
(4059, 'cd06497', NULL, 'ACD_alphaA-crystallin_HspB4', NULL, NULL, 'ACD_alphaA-crystallin_HspB4', 4059),
(4060, 'cd08697', NULL, 'C2_Dock-D', NULL, NULL, 'C2_Dock-D', 4060),
(4061, 'cd11511', NULL, 'SLC6sbd_BGT1', NULL, NULL, 'SLC6sbd_BGT1', 4061),
(4062, 'cd17335', NULL, 'MFS_MFSD6', NULL, NULL, 'MFS_MFSD6', 4062),
(4063, 'cd06844', NULL, 'STAS', NULL, NULL, 'STAS', 4063),
(4064, 'cd02957', NULL, 'Phd_like', NULL, NULL, 'Phd_like', 4064),
(4065, 'cd00018', NULL, 'AP2', NULL, NULL, 'AP2', 4065);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(4066, 'cd09097', NULL, 'Deadenylase_CCR4', NULL, NULL, 'Deadenylase_CCR4', 4066),
(4067, 'cd19819', NULL, 'Bbox1_ZFYVE1_rpt1', NULL, NULL, 'Bbox1_ZFYVE1_rpt1', 4067),
(4068, 'cd15716', NULL, 'FYVE_RBNS5', NULL, NULL, 'FYVE_RBNS5', 4068),
(4069, 'cd08035', NULL, 'LARP_4', NULL, NULL, 'LARP_4', 4069),
(4070, 'cd02992', NULL, 'PDI_a_QSOX', NULL, NULL, 'PDI_a_QSOX', 4070),
(4071, 'cd10040', NULL, 'Reelin_repeat_4_subrepeat_1', NULL, NULL, 'Reelin_repeat_4_subrepeat_1', 4071),
(4072, 'cd16843', NULL, 'Ig_LILR_KIR_like', NULL, NULL, 'Ig_LILR_KIR_like', 4072),
(4073, 'cd05254', NULL, 'dTDP_HR_like_SDR_e', NULL, NULL, 'dTDP_HR_like_SDR_e', 4073),
(4074, 'cd13292', NULL, 'PH_Osh1p_Osh2p_yeast', NULL, NULL, 'PH_Osh1p_Osh2p_yeast', 4074),
(4075, 'cd13296', NULL, 'PH2_MyoX', NULL, NULL, 'PH2_MyoX', 4075),
(4076, 'cd18363', NULL, 'BTB_POZ_KCTD3-like', NULL, NULL, 'BTB_POZ_KCTD3-like', 4076),
(4077, 'cd01149', NULL, 'HutB', NULL, NULL, 'HutB', 4077),
(4078, 'cd13634', NULL, 'PBP2_Sco4506', NULL, NULL, 'PBP2_Sco4506', 4078),
(4079, 'cd17003', NULL, 'CID_Rtt103', NULL, NULL, 'CID_Rtt103', 4079),
(4080, 'cd03138', NULL, 'GATase1_AraC_2', NULL, NULL, 'GATase1_AraC_2', 4080),
(4081, 'cd07678', NULL, 'F-BAR_FCHSD1', NULL, NULL, 'F-BAR_FCHSD1', 4081),
(4082, 'cd07994', NULL, 'WGR', NULL, NULL, 'WGR', 4082),
(4083, 'cd19821', NULL, 'Bbox1_BBX-like', NULL, NULL, 'Bbox1_BBX-like', 4083),
(4084, 'cd09490', NULL, 'SAM_Arap1,2,3', NULL, NULL, 'SAM_Arap1,2,3', 4084),
(4085, 'cd07171', NULL, 'NR_DBD_ER', NULL, NULL, 'NR_DBD_ER', 4085),
(4086, 'cd18003', NULL, 'DEXQc_SRCAP', NULL, NULL, 'DEXQc_SRCAP', 4086),
(4087, 'cd18602', NULL, 'ABC_6TM_SUR1_D2_like', NULL, NULL, 'ABC_6TM_SUR1_D2_like', 4087),
(4088, 'cd00412', NULL, 'pyrophosphatase', NULL, NULL, 'pyrophosphatase', 4088),
(4089, 'cd17270', NULL, 'RMtype1_S_Sba223ORF3470P-TRD1-CR1_like', NULL, NULL, 'RMtype1_S_Sba223ORF3470P-TRD1-CR1_like', 4089),
(4090, 'cd05580', NULL, 'STKc_PKA_like', NULL, NULL, 'STKc_PKA_like', 4090),
(4091, 'cd19363', NULL, 'TenA_C_PH1161-like', NULL, NULL, 'TenA_C_PH1161-like', 4091),
(4092, 'cd09262', NULL, 'AP_stonin-1_MHD', NULL, NULL, 'AP_stonin-1_MHD', 4092),
(4093, 'cd03783', NULL, 'MATH_Meprin_Alpha', NULL, NULL, 'MATH_Meprin_Alpha', 4093),
(4094, 'cd12740', NULL, 'RRM2_ESRP2', NULL, NULL, 'RRM2_ESRP2', 4094),
(4095, 'cd11825', NULL, 'SH3_PLCgamma', NULL, NULL, 'SH3_PLCgamma', 4095),
(4096, 'cd09585', NULL, 'SAM_DDHD2', NULL, NULL, 'SAM_DDHD2', 4096),
(4097, 'cd18197', NULL, 'BTB_POZ_ZBTB6', NULL, NULL, 'BTB_POZ_ZBTB6', 4097),
(4098, 'cd15042', NULL, '7tmC_Boss', NULL, NULL, '7tmC_Boss', 4098),
(4099, 'cd01920', NULL, 'cyclophilin_EcCYP_like', NULL, NULL, 'cyclophilin_EcCYP_like', 4099),
(4100, 'cd06386', NULL, 'PBP1_NPR_C', NULL, NULL, 'PBP1_NPR_C', 4100),
(4101, 'cd14947', NULL, 'NBR1_like', NULL, NULL, 'NBR1_like', 4101),
(4102, 'cd19056', NULL, 'LGIC_TM_GABAAR_theta', NULL, NULL, 'LGIC_TM_GABAAR_theta', 4102),
(4103, 'cd04170', NULL, 'EF-G_bact', NULL, NULL, 'EF-G_bact', 4103),
(4104, 'cd04447', NULL, 'DEP_BRCC3', NULL, NULL, 'DEP_BRCC3', 4104),
(4105, 'cd12177', NULL, '2-Hacid_dh_12', NULL, NULL, '2-Hacid_dh_12', 4105),
(4106, 'cd07997', NULL, 'WGR_PARP', NULL, NULL, 'WGR_PARP', 4106),
(4107, 'cd01883', NULL, 'EF1_alpha', NULL, NULL, 'EF1_alpha', 4107),
(4108, 'cd10277', NULL, 'PQQ_ADH_I', NULL, NULL, 'PQQ_ADH_I', 4108),
(4109, 'cd04935', NULL, 'ACT_AKiii-DAPDC_1', NULL, NULL, 'ACT_AKiii-DAPDC_1', 4109),
(4110, 'cd03331', NULL, 'Macro_Poa1p-like_SNF2', NULL, NULL, 'Macro_Poa1p-like_SNF2', 4110),
(4111, 'cd07361', NULL, 'MEMO_like', NULL, NULL, 'MEMO_like', 4111),
(4112, 'cd08643', NULL, 'DNA_pol_A_pol_I_B', NULL, NULL, 'DNA_pol_A_pol_I_B', 4112),
(4113, 'cd01781', NULL, 'RA2_Afadin', NULL, NULL, 'RA2_Afadin', 4113),
(4114, 'cd15464', NULL, 'HN_like', NULL, NULL, 'HN_like', 4114),
(4115, 'cd03167', NULL, 'oculospanin_like_LEL', NULL, NULL, 'oculospanin_like_LEL', 4115),
(4116, 'cd17789', NULL, 'CBS_pair_plant_CBSX', NULL, NULL, 'CBS_pair_plant_CBSX', 4116),
(4117, 'cd17491', NULL, 'MFS_MFSD12', NULL, NULL, 'MFS_MFSD12', 4117),
(4118, 'cd03356', NULL, 'LbH_G1P_AT_C_like', NULL, NULL, 'LbH_G1P_AT_C_like', 4118);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(4119, 'cd04762', NULL, 'HTH_MerR-trunc', NULL, NULL, 'HTH_MerR-trunc', 4119),
(4120, 'cd13946', NULL, 'LysW', NULL, NULL, 'LysW', 4120),
(4121, 'cd14545', NULL, 'PTPc-N1_2', NULL, NULL, 'PTPc-N1_2', 4121),
(4122, 'cd14061', NULL, 'STKc_MLK', NULL, NULL, 'STKc_MLK', 4122),
(4123, 'cd07722', NULL, 'LACTB2-like_MBL-fold', NULL, NULL, 'LACTB2-like_MBL-fold', 4123),
(4124, 'cd16536', NULL, 'RING-HC_RNF10', NULL, NULL, 'RING-HC_RNF10', 4124),
(4125, 'cd18921', NULL, 'bHLHzip_SREBP1', NULL, NULL, 'bHLHzip_SREBP1', 4125),
(4126, 'cd04597', NULL, 'CBS_pair_inorgPPase', NULL, NULL, 'CBS_pair_inorgPPase', 4126),
(4127, 'cd14200', NULL, 'STKc_CaMKK1', NULL, NULL, 'STKc_CaMKK1', 4127),
(4128, 'cd14232', NULL, 'GAT_LSB5', NULL, NULL, 'GAT_LSB5', 4128),
(4129, 'cd08475', NULL, 'PBP2_CrgA_like_6', NULL, NULL, 'PBP2_CrgA_like_6', 4129),
(4130, 'cd08817', NULL, 'CARD_RIG-I_r2', NULL, NULL, 'CARD_RIG-I_r2', 4130),
(4131, 'cd09883', NULL, 'PIN_VapC_PhoHL-ATPase', NULL, NULL, 'PIN_VapC_PhoHL-ATPase', 4131),
(4132, 'cd03312', NULL, 'CIMS_N_terminal_like', NULL, NULL, 'CIMS_N_terminal_like', 4132),
(4133, 'cd19614', NULL, 'FABP_Der_p_13-like', NULL, NULL, 'FABP_Der_p_13-like', 4133),
(4134, 'cd14747', NULL, 'PBP2_MalE', NULL, NULL, 'PBP2_MalE', 4134),
(4135, 'cd01858', NULL, 'NGP_1', NULL, NULL, 'NGP_1', 4135),
(4136, 'cd05047', NULL, 'PTKc_Tie', NULL, NULL, 'PTKc_Tie', 4136),
(4137, 'cd07988', NULL, 'LPLAT_ABO13168-like', NULL, NULL, 'LPLAT_ABO13168-like', 4137),
(4138, 'cd10148', NULL, 'CsoR-like_DUF156', NULL, NULL, 'CsoR-like_DUF156', 4138),
(4139, 'cd16844', NULL, 'ParB_N_like_MT', NULL, NULL, 'ParB_N_like_MT', 4139),
(4140, 'cd04589', NULL, 'CBS_pair_CAP-ED_NT_Pol-beta-like_DUF294_assoc', NULL, NULL, 'CBS_pair_CAP-ED_NT_Pol-beta-like_DUF294_assoc', 4140),
(4141, 'cd03130', NULL, 'GATase1_CobB', NULL, NULL, 'GATase1_CobB', 4141),
(4142, 'cd04142', NULL, 'RRP22', NULL, NULL, 'RRP22', 4142),
(4143, 'cd12252', NULL, 'RRM_DbpA', NULL, NULL, 'RRM_DbpA', 4143),
(4144, 'cd14832', NULL, 'AP4_sigma', NULL, NULL, 'AP4_sigma', 4144),
(4145, 'cd18173', NULL, 'M14_CP_bacteria', NULL, NULL, 'M14_CP_bacteria', 4145),
(4146, 'cd15178', NULL, '7tmA_CXCR1_2', NULL, NULL, '7tmA_CXCR1_2', 4146),
(4147, 'cd08431', NULL, 'PBP2_HupR', NULL, NULL, 'PBP2_HupR', 4147),
(4148, 'cd08700', NULL, 'FMT_C_OzmH_like', NULL, NULL, 'FMT_C_OzmH_like', 4148),
(4149, 'cd12691', NULL, 'RRM2_PTBPH1_PTBPH2', NULL, NULL, 'RRM2_PTBPH1_PTBPH2', 4149),
(4150, 'cd07955', NULL, 'Anticodon_Ia_Cys_like', NULL, NULL, 'Anticodon_Ia_Cys_like', 4150),
(4151, 'cd03795', NULL, 'GT4_WfcD-like', NULL, NULL, 'GT4_WfcD-like', 4151),
(4152, 'cd02794', NULL, 'MopB_CT_DmsA-EC', NULL, NULL, 'MopB_CT_DmsA-EC', 4152),
(4153, 'cd13869', NULL, 'CuRO_2_PHS', NULL, NULL, 'CuRO_2_PHS', 4153),
(4154, 'cd14355', NULL, 'UBA_UBP28', NULL, NULL, 'UBA_UBP28', 4154),
(4155, 'cd06177', NULL, 'MFS_NHS', NULL, NULL, 'MFS_NHS', 4155),
(4156, 'cd04456', NULL, 'S1_IF1A_like', NULL, NULL, 'S1_IF1A_like', 4156),
(4157, 'cd11008', NULL, 'M35_deuterolysin_like', NULL, NULL, 'M35_deuterolysin_like', 4157),
(4158, 'cd09239', NULL, 'BRO1_HD-PTP_like', NULL, NULL, 'BRO1_HD-PTP_like', 4158),
(4159, 'cd08898', NULL, 'SRPBCC_CalC_Aha1-like_5', NULL, NULL, 'SRPBCC_CalC_Aha1-like_5', 4159),
(4160, 'cd18291', NULL, 'BTB_POZ_BTBD16', NULL, NULL, 'BTB_POZ_BTBD16', 4160),
(4161, 'cd00413', NULL, 'Glyco_hydrolase_16', NULL, NULL, 'Glyco_hydrolase_16', 4161),
(4162, 'cd04198', NULL, 'eIF-2B_gamma_N', NULL, NULL, 'eIF-2B_gamma_N', 4162),
(4163, 'cd03755', NULL, 'proteasome_alpha_type_7', NULL, NULL, 'proteasome_alpha_type_7', 4163),
(4164, 'cd11443', NULL, 'bHLH_AtAMS_like', NULL, NULL, 'bHLH_AtAMS_like', 4164),
(4165, 'cd19759', NULL, 'Bbox2_TRIM2-like', NULL, NULL, 'Bbox2_TRIM2-like', 4165),
(4166, 'cd04217', NULL, 'Cupredoxin_Fibrocystin-L_like', NULL, NULL, 'Cupredoxin_Fibrocystin-L_like', 4166),
(4167, 'cd10506', NULL, 'RNAP_IV_RPD1_N', NULL, NULL, 'RNAP_IV_RPD1_N', 4167),
(4168, 'cd14032', NULL, 'STKc_WNK2_like', NULL, NULL, 'STKc_WNK2_like', 4168),
(4169, 'cd01936', NULL, 'Ntn_CA', NULL, NULL, 'Ntn_CA', 4169); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(4170, 'cd02199', NULL, 'YjgF_YER057c_UK114_like_1', NULL, NULL, 'YjgF_YER057c_UK114_like_1', 4170),
(4171, 'cd11508', NULL, 'SLC6sbd_GAT3', NULL, NULL, 'SLC6sbd_GAT3', 4171),
(4172, 'cd06618', NULL, 'PKc_MKK7', NULL, NULL, 'PKc_MKK7', 4172),
(4173, 'cd16615', NULL, 'RING-HC_ZNF598', NULL, NULL, 'RING-HC_ZNF598', 4173),
(4174, 'cd04365', NULL, 'IlGF_relaxin_like', NULL, NULL, 'IlGF_relaxin_like', 4174),
(4175, 'cd12038', NULL, 'SH3_MPP6', NULL, NULL, 'SH3_MPP6', 4175),
(4176, 'cd00379', NULL, 'Ribosomal_L10_P0', NULL, NULL, 'Ribosomal_L10_P0', 4176),
(4177, 'cd07593', NULL, 'BAR_MUG137_fungi', NULL, NULL, 'BAR_MUG137_fungi', 4177),
(4178, 'cd07368', NULL, 'PhnC_Bs_like', NULL, NULL, 'PhnC_Bs_like', 4178),
(4179, 'cd04714', NULL, 'BAH_BAHCC1', NULL, NULL, 'BAH_BAHCC1', 4179),
(4180, 'cd05756', NULL, 'Ig1_IL1R_like', NULL, NULL, 'Ig1_IL1R_like', 4180),
(4181, 'cd16661', NULL, 'RING-Ubox1_NOSIP', NULL, NULL, 'RING-Ubox1_NOSIP', 4181),
(4182, 'cd07371', NULL, '2A5CPDO_AB', NULL, NULL, '2A5CPDO_AB', 4182),
(4183, 'cd07009', NULL, 'cupin_BLL0285-like', NULL, NULL, 'cupin_BLL0285-like', 4183),
(4184, 'cd17777', NULL, 'CBS_arch_repeat1', NULL, NULL, 'CBS_arch_repeat1', 4184),
(4185, 'cd19769', NULL, 'Bbox2_TRIM16-like', NULL, NULL, 'Bbox2_TRIM16-like', 4185),
(4186, 'cd21685', NULL, 'ORF7a_SARS-CoV-like', NULL, NULL, 'ORF7a_SARS-CoV-like', 4186),
(4187, 'cd03083', NULL, 'TRX_Fd_NuoE_hoxF', NULL, NULL, 'TRX_Fd_NuoE_hoxF', 4187),
(4188, 'cd13341', NULL, 'PH-GRAM_MTMR3', NULL, NULL, 'PH-GRAM_MTMR3', 4188),
(4189, 'cd12687', NULL, 'RRM1_PTBPH3', NULL, NULL, 'RRM1_PTBPH3', 4189),
(4190, 'cd17390', NULL, 'MFS_MFSD9', NULL, NULL, 'MFS_MFSD9', 4190),
(4191, 'cd11674', NULL, 'lambda-1', NULL, NULL, 'lambda-1', 4191),
(4192, 'cd00860', NULL, 'ThrRS_anticodon', NULL, NULL, 'ThrRS_anticodon', 4192),
(4193, 'cd16677', NULL, 'RING1-H2_RNF32', NULL, NULL, 'RING1-H2_RNF32', 4193),
(4194, 'cd16335', NULL, 'MukF_N', NULL, NULL, 'MukF_N', 4194),
(4195, 'cd08434', NULL, 'PBP2_GltC_like', NULL, NULL, 'PBP2_GltC_like', 4195),
(4196, 'cd17563', NULL, 'REC_RegA-like', NULL, NULL, 'REC_RegA-like', 4196),
(4197, 'cd10365', NULL, 'SH2_Src_Src', NULL, NULL, 'SH2_Src_Src', 4197),
(4198, 'cd16293', NULL, 'CPSF2-like_MBL-fold', NULL, NULL, 'CPSF2-like_MBL-fold', 4198),
(4199, 'cd15165', NULL, '7tmA_GPR55-like', NULL, NULL, '7tmA_GPR55-like', 4199),
(4200, 'cd13692', NULL, 'PBP2_BztA', NULL, NULL, 'PBP2_BztA', 4200),
(4201, 'cd02954', NULL, 'DIM1', NULL, NULL, 'DIM1', 4201),
(4202, 'cd05967', NULL, 'PrpE', NULL, NULL, 'PrpE', 4202),
(4203, 'cd17072', NULL, 'DCX_DCDC5_like', NULL, NULL, 'DCX_DCDC5_like', 4203),
(4204, 'cd14160', NULL, 'PK_IRAK3', NULL, NULL, 'PK_IRAK3', 4204),
(4205, 'cd16495', NULL, 'RING_CH-C4HC3_MARCH', NULL, NULL, 'RING_CH-C4HC3_MARCH', 4205),
(4206, 'cd04236', NULL, 'AAK_NAGS-Urea', NULL, NULL, 'AAK_NAGS-Urea', 4206),
(4207, 'cd11802', NULL, 'SH3_Endophilin_B', NULL, NULL, 'SH3_Endophilin_B', 4207),
(4208, 'cd00158', NULL, 'RHOD', NULL, NULL, 'RHOD', 4208),
(4209, 'cd18493', NULL, 'BACK_BTBD17', NULL, NULL, 'BACK_BTBD17', 4209),
(4210, 'cd14168', NULL, 'STKc_CaMKI_delta', NULL, NULL, 'STKc_CaMKI_delta', 4210),
(4211, 'cd07819', NULL, 'SRPBCC_2', NULL, NULL, 'SRPBCC_2', 4211),
(4212, 'cd17447', NULL, 'MFS_SLC22A7_OAT2', NULL, NULL, 'MFS_SLC22A7_OAT2', 4212),
(4213, 'cd21508', NULL, 'HEV_Spike_S1_RBD', NULL, NULL, 'HEV_Spike_S1_RBD', 4213),
(4214, 'cd06379', NULL, 'PBP1_iGluR_NMDA_NR1', NULL, NULL, 'PBP1_iGluR_NMDA_NR1', 4214),
(4215, 'cd12738', NULL, 'RRM1_Fusilli', NULL, NULL, 'RRM1_Fusilli', 4215),
(4216, 'cd05776', NULL, 'DNA_polB_alpha_exo', NULL, NULL, 'DNA_polB_alpha_exo', 4216),
(4217, 'cd19549', NULL, 'serpinA_A1AT-like', NULL, NULL, 'serpinA_A1AT-like', 4217),
(4218, 'cd00731', NULL, 'CheA_reg', NULL, NULL, 'CheA_reg', 4218),
(4219, 'cd11304', NULL, 'Cadherin_repeat', NULL, NULL, 'Cadherin_repeat', 4219),
(4220, 'cd11401', NULL, 'bHLHzip_Mad', NULL, NULL, 'bHLHzip_Mad', 4220),
(4221, 'cd20608', NULL, 'nitroreductase', NULL, NULL, 'nitroreductase', 4221),
(4222, 'cd07303', NULL, 'Porin3', NULL, NULL, 'Porin3', 4222);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(4223, 'sd00029', NULL, 'zf-RanBP2', NULL, NULL, 'zf-RanBP2', 4223),
(4224, 'cd00635', NULL, 'PLPDE_III_YBL036c_like', NULL, NULL, 'PLPDE_III_YBL036c_like', 4224),
(4225, 'cd04111', NULL, 'Rab39', NULL, NULL, 'Rab39', 4225),
(4226, 'cd07770', NULL, 'FGGY_GntK', NULL, NULL, 'FGGY_GntK', 4226),
(4227, 'cd08297', NULL, 'CAD3', NULL, NULL, 'CAD3', 4227),
(4228, 'cd13750', NULL, 'TGF_beta_GDNF_like', NULL, NULL, 'TGF_beta_GDNF_like', 4228),
(4229, 'cd03339', NULL, 'TCP1_epsilon', NULL, NULL, 'TCP1_epsilon', 4229),
(4230, 'cd07132', NULL, 'ALDH_F3AB', NULL, NULL, 'ALDH_F3AB', 4230),
(4231, 'cd04665', NULL, 'Nudix_Hydrolase_8', NULL, NULL, 'Nudix_Hydrolase_8', 4231),
(4232, 'cd08543', NULL, 'SAM_PNT-ETS-2', NULL, NULL, 'SAM_PNT-ETS-2', 4232),
(4233, 'cd16770', NULL, 'RING-HC_UHRF2', NULL, NULL, 'RING-HC_UHRF2', 4233),
(4234, 'cd11287', NULL, 'Sec23_C', NULL, NULL, 'Sec23_C', 4234),
(4235, 'cd00513', NULL, 'Ribosomal_L32_L32e', NULL, NULL, 'Ribosomal_L32_L32e', 4235),
(4236, 'cd05600', NULL, 'STKc_Sid2p_like', NULL, NULL, 'STKc_Sid2p_like', 4236),
(4237, 'cd03087', NULL, 'PGM_like1', NULL, NULL, 'PGM_like1', 4237),
(4238, 'cd08388', NULL, 'C2A_Synaptotagmin-4-11', NULL, NULL, 'C2A_Synaptotagmin-4-11', 4238),
(4239, 'cd17172', NULL, 'FERM_F0_TLN2', NULL, NULL, 'FERM_F0_TLN2', 4239),
(4240, 'cd13893', NULL, 'CuRO_3_AAO', NULL, NULL, 'CuRO_3_AAO', 4240),
(4241, 'cd14101', NULL, 'STKc_PIM2', NULL, NULL, 'STKc_PIM2', 4241),
(4242, 'cd18974', NULL, 'CD_POL_like', NULL, NULL, 'CD_POL_like', 4242),
(4243, 'cd19010', NULL, 'LGIC_ECD_GlyR_beta', NULL, NULL, 'LGIC_ECD_GlyR_beta', 4243),
(4244, 'cd10303', NULL, 'GST_C_GDAP1', NULL, NULL, 'GST_C_GDAP1', 4244),
(4245, 'cd00317', NULL, 'cyclophilin', NULL, NULL, 'cyclophilin', 4245),
(4246, 'cd19215', NULL, 'PR-SET_ZFPM1', NULL, NULL, 'PR-SET_ZFPM1', 4246),
(4247, 'cd12649', NULL, 'RRM1_SXL', NULL, NULL, 'RRM1_SXL', 4247),
(4248, 'cd13855', NULL, 'CuRO_1_McoC_like', NULL, NULL, 'CuRO_1_McoC_like', 4248),
(4249, 'cd18777', NULL, 'PsaA_MyfA', NULL, NULL, 'PsaA_MyfA', 4249),
(4250, 'cd11871', NULL, 'SH3_p67phox_N', NULL, NULL, 'SH3_p67phox_N', 4250),
(4251, 'cd15658', NULL, 'PHD4_NSD3', NULL, NULL, 'PHD4_NSD3', 4251),
(4252, 'cd11621', NULL, 'HR1_PKC-like_1_fungi', NULL, NULL, 'HR1_PKC-like_1_fungi', 4252),
(4253, 'cd08071', NULL, 'MPN_DUF2466', NULL, NULL, 'MPN_DUF2466', 4253),
(4254, 'cd12432', NULL, 'RRM_ACINU', NULL, NULL, 'RRM_ACINU', 4254),
(4255, 'cd06864', NULL, 'PX_SNX4', NULL, NULL, 'PX_SNX4', 4255),
(4256, 'cd07923', NULL, 'Gallate_dioxygenase_C', NULL, NULL, 'Gallate_dioxygenase_C', 4256),
(4257, 'cd17972', NULL, 'DEXHc_DHX9', NULL, NULL, 'DEXHc_DHX9', 4257),
(4258, 'cd03704', NULL, 'eRF3_C_III', NULL, NULL, 'eRF3_C_III', 4258),
(4259, 'cd19839', NULL, 'Bbox1_TRIM16', NULL, NULL, 'Bbox1_TRIM16', 4259),
(4260, 'cd03467', NULL, 'Rieske', NULL, NULL, 'Rieske', 4260),
(4261, 'cd04921', NULL, 'ACT_AKi-HSDH-ThrA-like_1', NULL, NULL, 'ACT_AKi-HSDH-ThrA-like_1', 4261),
(4262, 'cd05388', NULL, 'CobB_N', NULL, NULL, 'CobB_N', 4262),
(4263, 'cd17225', NULL, 'RA_ASPP2', NULL, NULL, 'RA_ASPP2', 4263),
(4264, 'cd09376', NULL, 'LIM2_Lhx3_Lhx4', NULL, NULL, 'LIM2_Lhx3_Lhx4', 4264),
(4265, 'cd14176', NULL, 'STKc_RSK2_C', NULL, NULL, 'STKc_RSK2_C', 4265),
(4266, 'cd15990', NULL, '7tmB2_BAI1', NULL, NULL, '7tmB2_BAI1', 4266),
(4267, 'cd07332', NULL, 'M48C_Oma1_like', NULL, NULL, 'M48C_Oma1_like', 4267),
(4268, 'cd15852', NULL, 'SNARE_Syntaxin8', NULL, NULL, 'SNARE_Syntaxin8', 4268),
(4269, 'cd03228', NULL, 'ABCC_MRP_Like', NULL, NULL, 'ABCC_MRP_Like', 4269),
(4270, 'cd18927', NULL, 'bHLHzip_TFEB', NULL, NULL, 'bHLHzip_TFEB', 4270),
(4271, 'cd14502', NULL, 'RNA_5''-triphosphatase', NULL, NULL, 'RNA_5''-triphosphatase', 4271),
(4272, 'cd01751', NULL, 'PLAT_LH2', NULL, NULL, 'PLAT_LH2', 4272),
(4273, 'cd00991', NULL, 'PDZ_archaeal_metalloprotease', NULL, NULL, 'PDZ_archaeal_metalloprotease', 4273),
(4274, 'cd16077', NULL, 'TSP-5cc', NULL, NULL, 'TSP-5cc', 4274),
(4275, 'cd12070', NULL, 'SH3_ARHGAP12', NULL, NULL, 'SH3_ARHGAP12', 4275),
(4276, 'cd03244', NULL, 'ABCC_MRP_domain2', NULL, NULL, 'ABCC_MRP_domain2', 4276);
INSERT INTO "PUBLIC"."MODEL" VALUES
(4277, 'cd06361', NULL, 'PBP1_GPC6A-like', NULL, NULL, 'PBP1_GPC6A-like', 4277),
(4278, 'cd00939', NULL, 'MetRS_RNA', NULL, NULL, 'MetRS_RNA', 4278),
(4279, 'cd13519', NULL, 'PBP2_PEB3_AcfC', NULL, NULL, 'PBP2_PEB3_AcfC', 4279),
(4280, 'cd06166', NULL, 'Sortase_D_2', NULL, NULL, 'Sortase_D_2', 4280),
(4281, 'cd18702', NULL, 'PIN_VapC_like', NULL, NULL, 'PIN_VapC_like', 4281),
(4282, 'cd07263', NULL, 'VOC_like', NULL, NULL, 'VOC_like', 4282),
(4283, 'cd18346', NULL, 'BTB_POZ_BTBD1', NULL, NULL, 'BTB_POZ_BTBD1', 4283),
(4284, 'cd07921', NULL, 'PCA_45_Doxase_A_like', NULL, NULL, 'PCA_45_Doxase_A_like', 4284),
(4285, 'cd16461', NULL, 'RING-H2_EL5_like', NULL, NULL, 'RING-H2_EL5_like', 4285),
(4286, 'cd12658', NULL, 'RRM1_MYEF2', NULL, NULL, 'RRM1_MYEF2', 4286),
(4287, 'cd04888', NULL, 'ACT_PheB-BS', NULL, NULL, 'ACT_PheB-BS', 4287),
(4288, 'cd15606', NULL, 'PHD2_KDM5A', NULL, NULL, 'PHD2_KDM5A', 4288),
(4289, 'cd10748', NULL, 'anti-TRAP', NULL, NULL, 'anti-TRAP', 4289),
(4290, 'cd16870', NULL, 'ARID_JARD2', NULL, NULL, 'ARID_JARD2', 4290),
(4291, 'cd03209', NULL, 'GST_C_Mu', NULL, NULL, 'GST_C_Mu', 4291),
(4292, 'cd03291', NULL, 'ABCC_CFTR1', NULL, NULL, 'ABCC_CFTR1', 4292),
(4293, 'cd18078', NULL, 'DEXXQc_Mov10L1', NULL, NULL, 'DEXXQc_Mov10L1', 4293),
(4294, 'cd19882', NULL, 'DSRM_STAU2_rpt2', NULL, NULL, 'DSRM_STAU2_rpt2', 4294),
(4295, 'cd13214', NULL, 'PH-GRAM_WBP2', NULL, NULL, 'PH-GRAM_WBP2', 4295),
(4296, 'cd13891', NULL, 'CuRO_3_CotA_like', NULL, NULL, 'CuRO_3_CotA_like', 4296),
(4297, 'cd14204', NULL, 'PTKc_Mer', NULL, NULL, 'PTKc_Mer', 4297),
(4298, 'cd01559', NULL, 'ADCL_like', NULL, NULL, 'ADCL_like', 4298),
(4299, 'cd09145', NULL, 'PLDc_vPLD4_1', NULL, NULL, 'PLDc_vPLD4_1', 4299),
(4300, 'cd05329', NULL, 'TR_SDR_c', NULL, NULL, 'TR_SDR_c', 4300),
(4301, 'cd14039', NULL, 'STKc_IKK_alpha', NULL, NULL, 'STKc_IKK_alpha', 4301),
(4302, 'cd12094', NULL, 'TM_ErbB2', NULL, NULL, 'TM_ErbB2', 4302),
(4303, 'cd07656', NULL, 'F-BAR_srGAP', NULL, NULL, 'F-BAR_srGAP', 4303),
(4304, 'cd02409', NULL, 'KH-II', NULL, NULL, 'KH-II', 4304),
(4305, 'cd04606', NULL, 'CBS_pair_Mg_transporter', NULL, NULL, 'CBS_pair_Mg_transporter', 4305),
(4306, 'cd09882', NULL, 'PIN_MtVapC3-like_start', NULL, NULL, 'PIN_MtVapC3-like_start', 4306),
(4307, 'cd07309', NULL, 'PHP', NULL, NULL, 'PHP', 4307),
(4308, 'cd08820', NULL, 'FMT_core_like_6', NULL, NULL, 'FMT_core_like_6', 4308),
(4309, 'cd03860', NULL, 'M14_CP_A-B_like', NULL, NULL, 'M14_CP_A-B_like', 4309),
(4310, 'cd15998', NULL, '7tmB2_GPR124', NULL, NULL, '7tmB2_GPR124', 4310),
(4311, 'cd14894', NULL, 'MYSc_Myo33', NULL, NULL, 'MYSc_Myo33', 4311),
(4312, 'cd08555', NULL, 'PI-PLCc_GDPD_SF', NULL, NULL, 'PI-PLCc_GDPD_SF', 4312),
(4313, 'cd15082', NULL, '7tmA_VA_opsin', NULL, NULL, '7tmA_VA_opsin', 4313),
(4314, 'cd02192', NULL, 'PurM-like3', NULL, NULL, 'PurM-like3', 4314),
(4315, 'cd07844', NULL, 'STKc_PCTAIRE_like', NULL, NULL, 'STKc_PCTAIRE_like', 4315),
(4316, 'cd13987', NULL, 'STKc_SBK1', NULL, NULL, 'STKc_SBK1', 4316),
(4317, 'cd16950', NULL, 'HATPase_EnvZ-like', NULL, NULL, 'HATPase_EnvZ-like', 4317),
(4318, 'cd10037', NULL, 'Reelin_repeat_1_subrepeat_1', NULL, NULL, 'Reelin_repeat_1_subrepeat_1', 4318),
(4319, 'cd21486', NULL, 'human_MERS-CoV_Spike_S1_RBD', NULL, NULL, 'human_MERS-CoV_Spike_S1_RBD', 4319),
(4320, 'cd00812', NULL, 'LeuRS_core', NULL, NULL, 'LeuRS_core', 4320),
(4321, 'cd02949', NULL, 'TRX_NTR', NULL, NULL, 'TRX_NTR', 4321),
(4322, 'cd07954', NULL, 'AP_MHD_Cterm', NULL, NULL, 'AP_MHD_Cterm', 4322),
(4323, 'cd14071', NULL, 'STKc_SIK', NULL, NULL, 'STKc_SIK', 4323),
(4324, 'cd15041', NULL, '7tmB1_hormone_R', NULL, NULL, '7tmB1_hormone_R', 4324),
(4325, 'cd06333', NULL, 'PBP1_ABC_RPA1789-like', NULL, NULL, 'PBP1_ABC_RPA1789-like', 4325),
(4326, 'cd03383', NULL, 'PAP2_diacylglycerolkinase', NULL, NULL, 'PAP2_diacylglycerolkinase', 4326),
(4327, 'cd15727', NULL, 'FYVE_ZF21', NULL, NULL, 'FYVE_ZF21', 4327),
(4328, 'cd18393', NULL, 'BTB_POZ_SHKBP1', NULL, NULL, 'BTB_POZ_SHKBP1', 4328),
(4329, 'cd17311', NULL, 'PIPKc_PIP5K2C', NULL, NULL, 'PIPKc_PIP5K2C', 4329);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(4330, 'cd15829', NULL, 'SPRY_PRY_TRIM75', NULL, NULL, 'SPRY_PRY_TRIM75', 4330),
(4331, 'cd18435', NULL, 'BRCT_BRC1_like_rpt1', NULL, NULL, 'BRCT_BRC1_like_rpt1', 4331),
(4332, 'cd01965', NULL, 'Nitrogenase_MoFe_beta_like', NULL, NULL, 'Nitrogenase_MoFe_beta_like', 4332),
(4333, 'cd03425', NULL, 'MutT_pyrophosphohydrolase', NULL, NULL, 'MutT_pyrophosphohydrolase', 4333),
(4334, 'cd01259', NULL, 'PH_APBB1IP', NULL, NULL, 'PH_APBB1IP', 4334),
(4335, 'cd04641', NULL, 'CBS_euAMPK_gamma-like_repeat2', NULL, NULL, 'CBS_euAMPK_gamma-like_repeat2', 4335),
(4336, 'cd15073', NULL, '7tmA_Peropsin', NULL, NULL, '7tmA_Peropsin', 4336),
(4337, 'cd00210', NULL, 'PTS_IIA_glc', NULL, NULL, 'PTS_IIA_glc', 4337),
(4338, 'cd12754', NULL, 'RRM2_RBM10', NULL, NULL, 'RRM2_RBM10', 4338),
(4339, 'cd18737', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, 'PIN_VapC4-5_FitB-like', 4339),
(4340, 'cd15939', NULL, '7tmA_OR4A-like', NULL, NULL, '7tmA_OR4A-like', 4340),
(4341, 'cd09906', NULL, 'H3TH_YEN1', NULL, NULL, 'H3TH_YEN1', 4341),
(4342, 'cd16626', NULL, 'RING-HC_RBR_HHARI', NULL, NULL, 'RING-HC_RBR_HHARI', 4342),
(4343, 'cd00484', NULL, 'PEPCK_ATP', NULL, NULL, 'PEPCK_ATP', 4343),
(4344, 'cd07624', NULL, 'BAR_SNX7_30', NULL, NULL, 'BAR_SNX7_30', 4344),
(4345, 'cd18289', NULL, 'BTB_POZ_BTBD14A_NAC2', NULL, NULL, 'BTB_POZ_BTBD14A_NAC2', 4345),
(4346, 'cd01066', NULL, 'APP_MetAP', NULL, NULL, 'APP_MetAP', 4346),
(4347, 'cd06603', NULL, 'GH31_GANC_GANAB_alpha', NULL, NULL, 'GH31_GANC_GANAB_alpha', 4347),
(4348, 'cd08703', NULL, 'FDH_Hydrolase_C', NULL, NULL, 'FDH_Hydrolase_C', 4348),
(4349, 'cd15590', NULL, 'PHD2_KMT2A', NULL, NULL, 'PHD2_KMT2A', 4349),
(4350, 'cd13709', NULL, 'PBP2_YxeM', NULL, NULL, 'PBP2_YxeM', 4350),
(4351, 'cd14043', NULL, 'PK_GC-2D', NULL, NULL, 'PK_GC-2D', 4351),
(4352, 'cd18727', NULL, 'PIN_Swt1-like', NULL, NULL, 'PIN_Swt1-like', 4352),
(4353, 'cd18561', NULL, 'ABC_6TM_AarD_CydDC_like', NULL, NULL, 'ABC_6TM_AarD_CydDC_like', 4353),
(4354, 'cd18760', NULL, 'PIN_MtVapC3-like', NULL, NULL, 'PIN_MtVapC3-like', 4354),
(4355, 'cd07932', NULL, 'arginine_kinase_like', NULL, NULL, 'arginine_kinase_like', 4355),
(4356, 'cd11544', NULL, 'NTP-PPase_DR2231', NULL, NULL, 'NTP-PPase_DR2231', 4356),
(4357, 'cd07702', NULL, 'Ig_VEGFR-1', NULL, NULL, 'Ig_VEGFR-1', 4357),
(4358, 'cd14422', NULL, 'CUE_RIN3_plant', NULL, NULL, 'CUE_RIN3_plant', 4358),
(4359, 'cd16541', NULL, 'RING-HC_RNF123', NULL, NULL, 'RING-HC_RNF123', 4359),
(4360, 'cd05943', NULL, 'AACS', NULL, NULL, 'AACS', 4360),
(4361, 'cd18681', NULL, 'PIN_MtVapC27-VapC40_like', NULL, NULL, 'PIN_MtVapC27-VapC40_like', 4361),
(4362, 'cd08037', NULL, 'LARP_1', NULL, NULL, 'LARP_1', 4362),
(4363, 'cd08565', NULL, 'GDPD_pAtGDE_like', NULL, NULL, 'GDPD_pAtGDE_like', 4363),
(4364, 'cd19972', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, 'PBP1_ABC_sugar_binding-like', 4364),
(4365, 'cd01839', NULL, 'SGNH_arylesterase_like', NULL, NULL, 'SGNH_arylesterase_like', 4365),
(4366, 'cd00923', NULL, 'Cyt_c_Oxidase_Va', NULL, NULL, 'Cyt_c_Oxidase_Va', 4366),
(4367, 'cd06906', NULL, 'M14_Nna1', NULL, NULL, 'M14_Nna1', 4367),
(4368, 'cd08557', NULL, 'PI-PLCc_bacteria_like', NULL, NULL, 'PI-PLCc_bacteria_like', 4368),
(4369, 'cd03702', NULL, 'IF2_mtIF2_II', NULL, NULL, 'IF2_mtIF2_II', 4369),
(4370, 'cd06168', NULL, 'LSMD1', NULL, NULL, 'LSMD1', 4370),
(4371, 'cd08738', NULL, 'RGS_RGS7', NULL, NULL, 'RGS_RGS7', 4371),
(4372, 'cd02826', NULL, 'Piwi-like', NULL, NULL, 'Piwi-like', 4372),
(4373, 'cd12473', NULL, 'RRM2_MSSP1', NULL, NULL, 'RRM2_MSSP1', 4373),
(4374, 'cd00013', NULL, 'ADF_gelsolin', NULL, NULL, 'ADF_gelsolin', 4374),
(4375, 'cd18325', NULL, 'BTB_POZ_ZBTB18_2-like', NULL, NULL, 'BTB_POZ_ZBTB18_2-like', 4375),
(4376, 'cd05279', NULL, 'Zn_ADH1', NULL, NULL, 'Zn_ADH1', 4376),
(4377, 'cd06288', NULL, 'PBP1_sucrose_transcription_regulator', NULL, NULL, 'PBP1_sucrose_transcription_regulator', 4377),
(4378, 'cd08374', NULL, 'C2F_Ferlin', NULL, NULL, 'C2F_Ferlin', 4378),
(4379, 'cd19754', NULL, 'FHb_fungal-globin', NULL, NULL, 'FHb_fungal-globin', 4379),
(4380, 'cd07543', NULL, 'P-type_ATPase_cation', NULL, NULL, 'P-type_ATPase_cation', 4380);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(4381, 'cd13892', NULL, 'CuRO_3_PHS', NULL, NULL, 'CuRO_3_PHS', 4381),
(4382, 'cd15081', NULL, '7tmA_LWS_opsin', NULL, NULL, '7tmA_LWS_opsin', 4382),
(4383, 'cd00200', NULL, 'WD40', NULL, NULL, 'WD40', 4383),
(4384, 'cd03882', NULL, 'M28_nicalin_like', NULL, NULL, 'M28_nicalin_like', 4384),
(4385, 'cd12028', NULL, 'SH3_ZO-3', NULL, NULL, 'SH3_ZO-3', 4385),
(4386, 'cd06825', NULL, 'PLPDE_III_VanT', NULL, NULL, 'PLPDE_III_VanT', 4386),
(4387, 'cd16898', NULL, 'LYZ_LA', NULL, NULL, 'LYZ_LA', 4387),
(4388, 'cd08579', NULL, 'GDPD_memb_like', NULL, NULL, 'GDPD_memb_like', 4388),
(4389, 'cd18788', NULL, 'SF2_C_XPD', NULL, NULL, 'SF2_C_XPD', 4389),
(4390, 'cd00798', NULL, 'INT_XerDC_C', NULL, NULL, 'INT_XerDC_C', 4390),
(4391, 'cd08293', NULL, 'PTGR2', NULL, NULL, 'PTGR2', 4391),
(4392, 'cd14426', NULL, 'UBA1_HR23B', NULL, NULL, 'UBA1_HR23B', 4392),
(4393, 'cd03823', NULL, 'GT4_ExpE7-like', NULL, NULL, 'GT4_ExpE7-like', 4393),
(4394, 'cd06133', NULL, 'ERI-1_3''hExo_like', NULL, NULL, 'ERI-1_3''hExo_like', 4394),
(4395, 'cd07448', NULL, 'CRD_FZ4', NULL, NULL, 'CRD_FZ4', 4395),
(4396, 'cd18357', NULL, 'BTB1_POZ_RHOBTB3', NULL, NULL, 'BTB1_POZ_RHOBTB3', 4396),
(4397, 'cd09586', NULL, 'SAM_USH1G', NULL, NULL, 'SAM_USH1G', 4397),
(4398, 'cd10435', NULL, 'GIY-YIG_RE_Eco29kI_like', NULL, NULL, 'GIY-YIG_RE_Eco29kI_like', 4398),
(4399, 'cd03681', NULL, 'MM_CoA_mutase_MeaA', NULL, NULL, 'MM_CoA_mutase_MeaA', 4399),
(4400, 'cd13404', NULL, 'UreI_AmiS_like', NULL, NULL, 'UreI_AmiS_like', 4400),
(4401, 'cd11302', NULL, 'O-FucT-1', NULL, NULL, 'O-FucT-1', 4401),
(4402, 'cd19208', NULL, 'SET_KMT2C', NULL, NULL, 'SET_KMT2C', 4402),
(4403, 'cd07541', NULL, 'P-type_ATPase_APLT_Neo1-like', NULL, NULL, 'P-type_ATPase_APLT_Neo1-like', 4403),
(4404, 'cd02648', NULL, 'nuc_hydro_1', NULL, NULL, 'nuc_hydro_1', 4404),
(4405, 'cd18212', NULL, 'BTB_POZ_ZBTB24_ZNF450', NULL, NULL, 'BTB_POZ_ZBTB24_ZNF450', 4405),
(4406, 'cd08316', NULL, 'Death_FAS_TNFRSF6', NULL, NULL, 'Death_FAS_TNFRSF6', 4406),
(4407, 'cd08981', NULL, 'GH43_Bt1873-like', NULL, NULL, 'GH43_Bt1873-like', 4407),
(4408, 'cd15583', NULL, 'PHD_ash2p_like', NULL, NULL, 'PHD_ash2p_like', 4408),
(4409, 'cd07561', NULL, 'Peptidase_S41_CPP_like', NULL, NULL, 'Peptidase_S41_CPP_like', 4409),
(4410, 'cd08510', NULL, 'PBP2_Lactococcal_OppA_like', NULL, NULL, 'PBP2_Lactococcal_OppA_like', 4410),
(4411, 'cd12916', NULL, 'VKOR_1', NULL, NULL, 'VKOR_1', 4411),
(4412, 'cd17532', NULL, 'REC_LytTR_AlgR-like', NULL, NULL, 'REC_LytTR_AlgR-like', 4412),
(4413, 'cd13171', NULL, 'RanBD1_RanBP2_insect-like', NULL, NULL, 'RanBD1_RanBP2_insect-like', 4413),
(4414, 'cd12074', NULL, 'SH3_Tks5_1', NULL, NULL, 'SH3_Tks5_1', 4414),
(4415, 'cd01927', NULL, 'cyclophilin_WD40', NULL, NULL, 'cyclophilin_WD40', 4415),
(4416, 'cd04368', NULL, 'IlGF', NULL, NULL, 'IlGF', 4416),
(4417, 'cd12682', NULL, 'RRM_RBPMS', NULL, NULL, 'RRM_RBPMS', 4417),
(4418, 'cd16312', NULL, 'THIN-B-like_MBL-B3', NULL, NULL, 'THIN-B-like_MBL-B3', 4418),
(4419, 'cd18489', NULL, 'BACK_BTBD7', NULL, NULL, 'BACK_BTBD7', 4419),
(4420, 'cd12690', NULL, 'RRM3_PTBPH1_PTBPH2', NULL, NULL, 'RRM3_PTBPH1_PTBPH2', 4420),
(4421, 'cd09018', NULL, 'DEDDy_polA_RNaseD_like_exo', NULL, NULL, 'DEDDy_polA_RNaseD_like_exo', 4421),
(4422, 'cd17347', NULL, 'MFS_SLC15A1_2_like', NULL, NULL, 'MFS_SLC15A1_2_like', 4422),
(4423, 'cd06577', NULL, 'PASTA_pknB', NULL, NULL, 'PASTA_pknB', 4423),
(4424, 'cd08479', NULL, 'PBP2_CrgA_like_9', NULL, NULL, 'PBP2_CrgA_like_9', 4424),
(4425, 'cd12186', NULL, 'LDH', NULL, NULL, 'LDH', 4425),
(4426, 'cd19112', NULL, 'AKR_AKR2A1-2', NULL, NULL, 'AKR_AKR2A1-2', 4426),
(4427, 'cd00985', NULL, 'Maf_Ham1', NULL, NULL, 'Maf_Ham1', 4427),
(4428, 'cd08972', NULL, 'PF_Nei_N', NULL, NULL, 'PF_Nei_N', 4428),
(4429, 'cd09656', NULL, 'Cmr3_III-B', NULL, NULL, 'Cmr3_III-B', 4429),
(4430, 'cd17198', NULL, 'FERM_F1_FRMD6', NULL, NULL, 'FERM_F1_FRMD6', 4430),
(4431, 'cd09091', NULL, 'INPP5c_SHIP', NULL, NULL, 'INPP5c_SHIP', 4431),
(4432, 'cd19560', NULL, 'serpinB1_LEI', NULL, NULL, 'serpinB1_LEI', 4432),
(4433, 'cd00069', NULL, 'GHB_like', NULL, NULL, 'GHB_like', 4433); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(4434, 'cd06902', NULL, 'lectin_ERGIC-53_ERGL', NULL, NULL, 'lectin_ERGIC-53_ERGL', 4434),
(4435, 'cd12216', NULL, 'Csn2_like', NULL, NULL, 'Csn2_like', 4435),
(4436, 'cd08028', NULL, 'LARP_3', NULL, NULL, 'LARP_3', 4436),
(4437, 'cd06936', NULL, 'NR_LBD_Fxr', NULL, NULL, 'NR_LBD_Fxr', 4437),
(4438, 'cd13250', NULL, 'PH_ACAP', NULL, NULL, 'PH_ACAP', 4438),
(4439, 'cd01575', NULL, 'PBP1_GntR', NULL, NULL, 'PBP1_GntR', 4439),
(4440, 'cd02056', NULL, 'serpinA1_A1AT', NULL, NULL, 'serpinA1_A1AT', 4440),
(4441, 'cd17145', NULL, 'DCX1_RP1', NULL, NULL, 'DCX1_RP1', 4441),
(4442, 'cd07329', NULL, 'M56_like', NULL, NULL, 'M56_like', 4442),
(4443, 'cd07730', NULL, 'metallo-hydrolase-like_MBL-fold', NULL, NULL, 'metallo-hydrolase-like_MBL-fold', 4443),
(4444, 'cd18917', NULL, 'bHLH_AtSAC51_like', NULL, NULL, 'bHLH_AtSAC51_like', 4444),
(4445, 'cd19161', NULL, 'AKR_AKR15A1', NULL, NULL, 'AKR_AKR15A1', 4445),
(4446, 'cd16846', NULL, 'STAT2_DBD', NULL, NULL, 'STAT2_DBD', 4446),
(4447, 'cd18552', NULL, 'ABC_6TM_MsbA_like', NULL, NULL, 'ABC_6TM_MsbA_like', 4447),
(4448, 'cd09402', NULL, 'LIM1_CRP', NULL, NULL, 'LIM1_CRP', 4448),
(4449, 'cd02138', NULL, 'TdsD-like', NULL, NULL, 'TdsD-like', 4449),
(4450, 'cd07943', NULL, 'DRE_TIM_HOA', NULL, NULL, 'DRE_TIM_HOA', 4450),
(4451, 'cd12521', NULL, 'RRM3_MRN1', NULL, NULL, 'RRM3_MRN1', 4451),
(4452, 'cd16039', NULL, 'PHD_SPP1', NULL, NULL, 'PHD_SPP1', 4452),
(4453, 'cd03829', NULL, 'Sina', NULL, NULL, 'Sina', 4453),
(4454, 'cd01856', NULL, 'YlqF', NULL, NULL, 'YlqF', 4454),
(4455, 'cd07670', NULL, 'BAR_SNX18', NULL, NULL, 'BAR_SNX18', 4455),
(4456, 'cd14771', NULL, 'TrHb2_Mt-trHbO-like_O', NULL, NULL, 'TrHb2_Mt-trHbO-like_O', 4456),
(4457, 'cd20758', NULL, 'capping_2-OMTase_Orbivirus', NULL, NULL, 'capping_2-OMTase_Orbivirus', 4457),
(4458, 'cd06602', NULL, 'GH31_MGAM_SI_GAA', NULL, NULL, 'GH31_MGAM_SI_GAA', 4458),
(4459, 'cd07201', NULL, 'cPLA2_Grp-IVB-IVD-IVE-IVF', NULL, NULL, 'cPLA2_Grp-IVB-IVD-IVE-IVF', 4459),
(4460, 'cd09448', NULL, 'LIM_CLP36', NULL, NULL, 'LIM_CLP36', 4460),
(4461, 'cd03171', NULL, 'SORL_Dfx_classI', NULL, NULL, 'SORL_Dfx_classI', 4461),
(4462, 'cd10508', NULL, 'Zn-ribbon_RPB9', NULL, NULL, 'Zn-ribbon_RPB9', 4462),
(4463, 'cd05076', NULL, 'PTK_Tyk2_rpt1', NULL, NULL, 'PTK_Tyk2_rpt1', 4463),
(4464, 'cd17433', NULL, 'MFS_GLUT8_Class3', NULL, NULL, 'MFS_GLUT8_Class3', 4464),
(4465, 'cd05332', NULL, '11beta-HSD1_like_SDR_c', NULL, NULL, '11beta-HSD1_like_SDR_c', 4465),
(4466, 'cd14563', NULL, 'PTP_auxilin_N', NULL, NULL, 'PTP_auxilin_N', 4466),
(4467, 'cd05806', NULL, 'CBM20_laforin', NULL, NULL, 'CBM20_laforin', 4467),
(4468, 'cd15121', NULL, '7tmA_LTB4R1', NULL, NULL, '7tmA_LTB4R1', 4468),
(4469, 'cd15802', NULL, 'RING_CBP-p300', NULL, NULL, 'RING_CBP-p300', 4469),
(4470, 'cd15681', NULL, 'PHD_JADE3', NULL, NULL, 'PHD_JADE3', 4470),
(4471, 'cd03086', NULL, 'PGM3', NULL, NULL, 'PGM3', 4471),
(4472, 'cd07390', NULL, 'MPP_AQ1575', NULL, NULL, 'MPP_AQ1575', 4472),
(4473, 'cd17265', NULL, 'RMtype1_S_Eco4255III-TRD2-CR2_like', NULL, NULL, 'RMtype1_S_Eco4255III-TRD2-CR2_like', 4473),
(4474, 'cd11353', NULL, 'AmyAc_euk_bac_CMD_like', NULL, NULL, 'AmyAc_euk_bac_CMD_like', 4474),
(4475, 'cd19360', NULL, 'TenA_C_SaTenA-like', NULL, NULL, 'TenA_C_SaTenA-like', 4475),
(4476, 'cd13746', NULL, 'Sir4p-SID_like', NULL, NULL, 'Sir4p-SID_like', 4476),
(4477, 'cd19937', NULL, 'REC_OmpR_BsPhoP-like', NULL, NULL, 'REC_OmpR_BsPhoP-like', 4477),
(4478, 'cd14180', NULL, 'STKc_MSK2_C', NULL, NULL, 'STKc_MSK2_C', 4478),
(4479, 'cd07219', NULL, 'Pat_PNPLA1', NULL, NULL, 'Pat_PNPLA1', 4479),
(4480, 'sd00010', NULL, 'SLR', NULL, NULL, 'SLR', 4480),
(4481, 'cd11735', NULL, 'HSPA12A_like_NBD', NULL, NULL, 'HSPA12A_like_NBD', 4481),
(4482, 'cd04671', NULL, 'Nudix_Hydrolase_13', NULL, NULL, 'Nudix_Hydrolase_13', 4482),
(4483, 'cd02783', NULL, 'MopB_CT_2', NULL, NULL, 'MopB_CT_2', 4483),
(4484, 'cd09086', NULL, 'ExoIII-like_AP-endo', NULL, NULL, 'ExoIII-like_AP-endo', 4484),
(4485, 'cd00894', NULL, 'PI3Kc_IB_gamma', NULL, NULL, 'PI3Kc_IB_gamma', 4485),
(4486, 'cd13606', NULL, 'PBP2_ProX_like', NULL, NULL, 'PBP2_ProX_like', 4486);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(4487, 'cd01491', NULL, 'Ube1_repeat1', NULL, NULL, 'Ube1_repeat1', 4487),
(4488, 'cd19559', NULL, 'serpinA14_UTMP_UABP-2', NULL, NULL, 'serpinA14_UTMP_UABP-2', 4488),
(4489, 'cd17233', NULL, 'Ubl_ATG8_GABARAPL1_like', NULL, NULL, 'Ubl_ATG8_GABARAPL1_like', 4489),
(4490, 'cd16581', NULL, 'RING-HC_TRIM13_like_C-V', NULL, NULL, 'RING-HC_TRIM13_like_C-V', 4490),
(4491, 'cd19553', NULL, 'serpinA5_PCI', NULL, NULL, 'serpinA5_PCI', 4491),
(4492, 'cd02113', NULL, 'bact_SoxC_Moco', NULL, NULL, 'bact_SoxC_Moco', 4492),
(4493, 'cd17424', NULL, 'MFS_MCT12', NULL, NULL, 'MFS_MCT12', 4493),
(4494, 'cd04083', NULL, 'CBM35_Lmo2446-like', NULL, NULL, 'CBM35_Lmo2446-like', 4494),
(4495, 'cd14131', NULL, 'PKc_Mps1', NULL, NULL, 'PKc_Mps1', 4495),
(4496, 'cd12889', NULL, 'SPRY_PRY_TRIM67_9', NULL, NULL, 'SPRY_PRY_TRIM67_9', 4496),
(4497, 'cd06230', NULL, 'M14_ASTE_ASPA_like', NULL, NULL, 'M14_ASTE_ASPA_like', 4497),
(4498, 'cd05500', NULL, 'Bromo_BDF1_2_I', NULL, NULL, 'Bromo_BDF1_2_I', 4498),
(4499, 'cd00271', NULL, 'Chemokine_C', NULL, NULL, 'Chemokine_C', 4499),
(4500, 'cd05797', NULL, 'Ribosomal_L10', NULL, NULL, 'Ribosomal_L10', 4500),
(4501, 'cd02201', NULL, 'FtsZ_type1', NULL, NULL, 'FtsZ_type1', 4501),
(4502, 'cd10015', NULL, 'BfiI_C_EcoRII_N_B3', NULL, NULL, 'BfiI_C_EcoRII_N_B3', 4502),
(4503, 'cd17643', NULL, 'A_NRPS_Cytc1-like', NULL, NULL, 'A_NRPS_Cytc1-like', 4503),
(4504, 'cd01642', NULL, 'Arch_FBPase_2', NULL, NULL, 'Arch_FBPase_2', 4504),
(4505, 'cd13618', NULL, 'PBP2_transferrin_N', NULL, NULL, 'PBP2_transferrin_N', 4505),
(4506, 'cd03195', NULL, 'GST_C_4', NULL, NULL, 'GST_C_4', 4506),
(4507, 'cd06845', NULL, 'Bcl-2_like', NULL, NULL, 'Bcl-2_like', 4507),
(4508, 'cd03749', NULL, 'proteasome_alpha_type_1', NULL, NULL, 'proteasome_alpha_type_1', 4508),
(4509, 'cd03766', NULL, 'Gn_AT_II_novel', NULL, NULL, 'Gn_AT_II_novel', 4509),
(4510, 'cd06318', NULL, 'PBP1_ABC_D-talitol-like', NULL, NULL, 'PBP1_ABC_D-talitol-like', 4510),
(4511, 'cd15267', NULL, '7tmB1_GCGR', NULL, NULL, '7tmB1_GCGR', 4511),
(4512, 'cd16339', NULL, 'CpcS', NULL, NULL, 'CpcS', 4512),
(4513, 'cd18801', NULL, 'SF2_C_FANCM_Hef', NULL, NULL, 'SF2_C_FANCM_Hef', 4513),
(4514, 'cd07253', NULL, 'GLOD5', NULL, NULL, 'GLOD5', 4514),
(4515, 'cd02043', NULL, 'serpinP_plants', NULL, NULL, 'serpinP_plants', 4515),
(4516, 'cd19099', NULL, 'AKR_unchar', NULL, NULL, 'AKR_unchar', 4516),
(4517, 'cd19803', NULL, 'Bbox1_TRIM9-like_C-I', NULL, NULL, 'Bbox1_TRIM9-like_C-I', 4517),
(4518, 'cd04759', NULL, 'Rib_hydrolase', NULL, NULL, 'Rib_hydrolase', 4518),
(4519, 'cd14900', NULL, 'MYSc_Myo39', NULL, NULL, 'MYSc_Myo39', 4519),
(4520, 'cd18712', NULL, 'PIN_VapC-like_DUF411', NULL, NULL, 'PIN_VapC-like_DUF411', 4520),
(4521, 'cd16006', NULL, '7tmB2_Latrophilin-2', NULL, NULL, '7tmB2_Latrophilin-2', 4521),
(4522, 'cd11800', NULL, 'SH3_DNMBP_C2_like', NULL, NULL, 'SH3_DNMBP_C2_like', 4522),
(4523, 'cd04674', NULL, 'Nudix_Hydrolase_16', NULL, NULL, 'Nudix_Hydrolase_16', 4523),
(4524, 'cd17870', NULL, 'GPN1', NULL, NULL, 'GPN1', 4524),
(4525, 'cd01947', NULL, 'Guanosine_kinase_like', NULL, NULL, 'Guanosine_kinase_like', 4525),
(4526, 'cd07863', NULL, 'STKc_CDK4', NULL, NULL, 'STKc_CDK4', 4526),
(4527, 'cd00757', NULL, 'ThiF_MoeB_HesA_family', NULL, NULL, 'ThiF_MoeB_HesA_family', 4527),
(4528, 'cd05042', NULL, 'PTKc_Aatyk', NULL, NULL, 'PTKc_Aatyk', 4528),
(4529, 'cd16147', NULL, 'G6S', NULL, NULL, 'G6S', 4529),
(4530, 'cd12079', NULL, 'SH3_Tks5_3', NULL, NULL, 'SH3_Tks5_3', 4530),
(4531, 'cd14552', NULL, 'R-PTPc-A-E-2', NULL, NULL, 'R-PTPc-A-E-2', 4531),
(4532, 'cd13757', NULL, 'TGF_beta_AMH', NULL, NULL, 'TGF_beta_AMH', 4532),
(4533, 'cd11865', NULL, 'SH3_Nbp2-like', NULL, NULL, 'SH3_Nbp2-like', 4533),
(4534, 'cd13951', NULL, '7tmF_Frizzled_SMO', NULL, NULL, '7tmF_Frizzled_SMO', 4534),
(4535, 'cd19758', NULL, 'Bbox2_MID', NULL, NULL, 'Bbox2_MID', 4535),
(4536, 'cd16560', NULL, 'RING-HC_RNF212_like', NULL, NULL, 'RING-HC_RNF212_like', 4536),
(4537, 'cd02122', NULL, 'PA_GRAIL_like', NULL, NULL, 'PA_GRAIL_like', 4537),
(4538, 'cd04765', NULL, 'HTH_MlrA-like_sg2', NULL, NULL, 'HTH_MlrA-like_sg2', 4538);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(4539, 'cd13307', NULL, 'PH2_AFAP', NULL, NULL, 'PH2_AFAP', 4539),
(4540, 'cd19050', NULL, 'LGIC_TM_bact', NULL, NULL, 'LGIC_TM_bact', 4540),
(4541, 'cd01540', NULL, 'PBP1_arabinose_binding', NULL, NULL, 'PBP1_arabinose_binding', 4541),
(4542, 'cd15240', NULL, '7tm_ASR-like', NULL, NULL, '7tm_ASR-like', 4542),
(4543, 'cd07507', NULL, 'HAD_Pase', NULL, NULL, 'HAD_Pase', 4543),
(4544, 'cd00081', NULL, 'Hint', NULL, NULL, 'Hint', 4544),
(4545, 'cd14475', NULL, 'SPX_SYG1_like', NULL, NULL, 'SPX_SYG1_like', 4545),
(4546, 'cd20005', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, 'PBP1_ABC_sugar_binding-like', 4546),
(4547, 'cd09574', NULL, 'SAM_STIM2', NULL, NULL, 'SAM_STIM2', 4547),
(4548, 'cd18649', NULL, 'CD_Cbx8', NULL, NULL, 'CD_Cbx8', 4548),
(4549, 'cd16362', NULL, 'TflA', NULL, NULL, 'TflA', 4549),
(4550, 'cd05777', NULL, 'DNA_polB_delta_exo', NULL, NULL, 'DNA_polB_delta_exo', 4550),
(4551, 'cd19691', NULL, 'bHLH_dnHLH_ID1', NULL, NULL, 'bHLH_dnHLH_ID1', 4551),
(4552, 'cd13231', NULL, 'PH2_SSRP1-like', NULL, NULL, 'PH2_SSRP1-like', 4552),
(4553, 'cd18401', NULL, 'BTB_POZ_TNFAIP1_BACURD2', NULL, NULL, 'BTB_POZ_TNFAIP1_BACURD2', 4553),
(4554, 'cd19020', NULL, 'LGIC_ECD_nAChR_A7', NULL, NULL, 'LGIC_ECD_nAChR_A7', 4554),
(4555, 'cd15090', NULL, '7tmA_Mu_opioid_R', NULL, NULL, '7tmA_Mu_opioid_R', 4555),
(4556, 'cd03273', NULL, 'ABC_SMC2_euk', NULL, NULL, 'ABC_SMC2_euk', 4556),
(4557, 'cd04660', NULL, 'nsLTP_like', NULL, NULL, 'nsLTP_like', 4557),
(4558, 'cd07674', NULL, 'F-BAR_FCHO1', NULL, NULL, 'F-BAR_FCHO1', 4558),
(4559, 'cd03542', NULL, 'Rieske_RO_Alpha_HBDO', NULL, NULL, 'Rieske_RO_Alpha_HBDO', 4559),
(4560, 'cd07160', NULL, 'NR_DBD_LXR', NULL, NULL, 'NR_DBD_LXR', 4560),
(4561, 'cd07393', NULL, 'MPP_DR1119', NULL, NULL, 'MPP_DR1119', 4561),
(4562, 'cd08610', NULL, 'GDPD_GDE6', NULL, NULL, 'GDPD_GDE6', 4562),
(4563, 'cd19058', NULL, 'LGIC_TM_GABAAR_pi', NULL, NULL, 'LGIC_TM_GABAAR_pi', 4563),
(4564, 'cd05601', NULL, 'STKc_CRIK', NULL, NULL, 'STKc_CRIK', 4564),
(4565, 'cd08244', NULL, 'MDR_enoyl_red', NULL, NULL, 'MDR_enoyl_red', 4565),
(4566, 'cd03375', NULL, 'TPP_OGFOR', NULL, NULL, 'TPP_OGFOR', 4566),
(4567, 'cd02570', NULL, 'PseudoU_synth_EcTruA', NULL, NULL, 'PseudoU_synth_EcTruA', 4567),
(4568, 'cd07520', NULL, 'HAD_like', NULL, NULL, 'HAD_like', 4568),
(4569, 'cd07432', NULL, 'PHP_HisPPase', NULL, NULL, 'PHP_HisPPase', 4569),
(4570, 'cd13362', NULL, 'PH_PLC_gamma', NULL, NULL, 'PH_PLC_gamma', 4570),
(4571, 'cd19566', NULL, 'serpinB7_megsin', NULL, NULL, 'serpinB7_megsin', 4571),
(4572, 'cd12060', NULL, 'SH3_alphaPIX', NULL, NULL, 'SH3_alphaPIX', 4572),
(4573, 'cd14251', NULL, 'PL-6', NULL, NULL, 'PL-6', 4573),
(4574, 'cd14565', NULL, 'DSP_MKP_classI', NULL, NULL, 'DSP_MKP_classI', 4574),
(4575, 'cd16620', NULL, 'vRING-HC-C4C4_RBBP6', NULL, NULL, 'vRING-HC-C4C4_RBBP6', 4575),
(4576, 'cd00041', NULL, 'CUB', NULL, NULL, 'CUB', 4576),
(4577, 'cd00540', NULL, 'AAG', NULL, NULL, 'AAG', 4577),
(4578, 'cd15044', NULL, '7tmC_V2R_AA_sensing_receptor-like', NULL, NULL, '7tmC_V2R_AA_sensing_receptor-like', 4578),
(4579, 'cd14787', NULL, 'Tiki_TraB-like', NULL, NULL, 'Tiki_TraB-like', 4579),
(4580, 'cd08576', NULL, 'GDPD_like_SMaseD_PLD', NULL, NULL, 'GDPD_like_SMaseD_PLD', 4580),
(4581, 'cd01555', NULL, 'UdpNAET', NULL, NULL, 'UdpNAET', 4581),
(4582, 'cd14265', NULL, 'UDPK_IM_like', NULL, NULL, 'UDPK_IM_like', 4582),
(4583, 'cd07137', NULL, 'ALDH_F3FHI', NULL, NULL, 'ALDH_F3FHI', 4583),
(4584, 'cd21641', NULL, 'ORF8-Ig_SARS-CoV-2-like', NULL, NULL, 'ORF8-Ig_SARS-CoV-2-like', 4584),
(4585, 'cd19547', NULL, 'beta-lac_NRPS', NULL, NULL, 'beta-lac_NRPS', 4585),
(4586, 'cd03193', NULL, 'GST_C_Metaxin', NULL, NULL, 'GST_C_Metaxin', 4586),
(4587, 'cd03145', NULL, 'GAT1_cyanophycinase', NULL, NULL, 'GAT1_cyanophycinase', 4587),
(4588, 'cd18690', NULL, 'PIN_VapC-like', NULL, NULL, 'PIN_VapC-like', 4588),
(4589, 'cd20235', NULL, 'PFM_spherulin-2a-like', NULL, NULL, 'PFM_spherulin-2a-like', 4589),
(4590, 'cd02612', NULL, 'HAD_PGPPase', NULL, NULL, 'HAD_PGPPase', 4590),
(4591, 'cd13287', NULL, 'PH_ORP3_ORP6_ORP7', NULL, NULL, 'PH_ORP3_ORP6_ORP7', 4591);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(4592, 'cd17975', NULL, 'DEXHc_DHX29', NULL, NULL, 'DEXHc_DHX29', 4592),
(4593, 'cd04783', NULL, 'HTH_MerR1', NULL, NULL, 'HTH_MerR1', 4593),
(4594, 'cd07589', NULL, 'BAR_DNMBP', NULL, NULL, 'BAR_DNMBP', 4594),
(4595, 'cd03421', NULL, 'SirA_like_N', NULL, NULL, 'SirA_like_N', 4595),
(4596, 'cd07043', NULL, 'STAS_anti-anti-sigma_factors', NULL, NULL, 'STAS_anti-anti-sigma_factors', 4596),
(4597, 'cd16491', NULL, 'RING-CH-C4HC3_LTN1', NULL, NULL, 'RING-CH-C4HC3_LTN1', 4597),
(4598, 'cd11454', NULL, 'bHLH_AtIND_like', NULL, NULL, 'bHLH_AtIND_like', 4598),
(4599, 'cd17275', NULL, 'RMtype1_S_MjaORF132P-TRD1-CR1_like', NULL, NULL, 'RMtype1_S_MjaORF132P-TRD1-CR1_like', 4599),
(4600, 'cd03031', NULL, 'GRX_GRX_like', NULL, NULL, 'GRX_GRX_like', 4600),
(4601, 'cd07900', NULL, 'Adenylation_DNA_ligase_I_Euk', NULL, NULL, 'Adenylation_DNA_ligase_I_Euk', 4601),
(4602, 'cd11532', NULL, 'NTP-PPase_COG4997', NULL, NULL, 'NTP-PPase_COG4997', 4602),
(4603, 'cd13887', NULL, 'CuRO_2_MCO_like_2', NULL, NULL, 'CuRO_2_MCO_like_2', 4603),
(4604, 'cd07980', NULL, 'TFIIF_beta', NULL, NULL, 'TFIIF_beta', 4604),
(4605, 'cd13587', NULL, 'PBP2_polyamine_2', NULL, NULL, 'PBP2_polyamine_2', 4605),
(4606, 'cd08665', NULL, 'APC10-CUL7', NULL, NULL, 'APC10-CUL7', 4606),
(4607, 'cd15957', NULL, '7tmA_Beta2_AR', NULL, NULL, '7tmA_Beta2_AR', 4607),
(4608, 'cd12357', NULL, 'RRM_PPARGC1A_like', NULL, NULL, 'RRM_PPARGC1A_like', 4608),
(4609, 'cd12104', NULL, 'DD_RIIbeta_PKA', NULL, NULL, 'DD_RIIbeta_PKA', 4609),
(4610, 'cd09143', NULL, 'PLDc_vPLD1_2_like_bac_2', NULL, NULL, 'PLDc_vPLD1_2_like_bac_2', 4610),
(4611, 'cd21644', NULL, 'batCoV-HKU9_NS7b', NULL, NULL, 'batCoV-HKU9_NS7b', 4611),
(4612, 'cd13113', NULL, 'Wnt', NULL, NULL, 'Wnt', 4612),
(4613, 'cd16492', NULL, 'RING-CH-C4HC3_NFX1_like', NULL, NULL, 'RING-CH-C4HC3_NFX1_like', 4613),
(4614, 'cd00088', NULL, 'HPT', NULL, NULL, 'HPT', 4614),
(4615, 'cd15058', NULL, '7tmA_Beta_AR', NULL, NULL, '7tmA_Beta_AR', 4615),
(4616, 'cd19701', NULL, 'bHLH_TS_HEN1', NULL, NULL, 'bHLH_TS_HEN1', 4616),
(4617, 'cd18490', NULL, 'BACK_BTBD8', NULL, NULL, 'BACK_BTBD8', 4617),
(4618, 'cd09252', NULL, 'AP-3_Mu3_Cterm', NULL, NULL, 'AP-3_Mu3_Cterm', 4618),
(4619, 'cd02008', NULL, 'TPP_IOR_alpha', NULL, NULL, 'TPP_IOR_alpha', 4619),
(4620, 'cd05298', NULL, 'GH4_GlvA_pagL_like', NULL, NULL, 'GH4_GlvA_pagL_like', 4620),
(4621, 'cd16750', NULL, 'RING-HC_SH3RF3', NULL, NULL, 'RING-HC_SH3RF3', 4621),
(4622, 'cd03719', NULL, 'SOCS_SSB2', NULL, NULL, 'SOCS_SSB2', 4622),
(4623, 'cd16595', NULL, 'RING-HC_TRIM17_C-IV', NULL, NULL, 'RING-HC_TRIM17_C-IV', 4623),
(4624, 'cd04816', NULL, 'PA_SaNapH_like', NULL, NULL, 'PA_SaNapH_like', 4624),
(4625, 'cd12483', NULL, 'RRM1_hnRNPQ', NULL, NULL, 'RRM1_hnRNPQ', 4625),
(4626, 'cd06872', NULL, 'PX_SNX19_like_plant', NULL, NULL, 'PX_SNX19_like_plant', 4626),
(4627, 'cd15925', NULL, '7tmA_RNL3R2', NULL, NULL, '7tmA_RNL3R2', 4627),
(4628, 'cd06942', NULL, 'NR_LBD_Sex_1_like', NULL, NULL, 'NR_LBD_Sex_1_like', 4628),
(4629, 'cd01918', NULL, 'HprK_C', NULL, NULL, 'HprK_C', 4629),
(4630, 'cd00009', NULL, 'AAA', NULL, NULL, 'AAA', 4630),
(4631, 'cd07884', NULL, 'RHD-n_Relish', NULL, NULL, 'RHD-n_Relish', 4631),
(4632, 'cd16544', NULL, 'RING-HC_RNF138', NULL, NULL, 'RING-HC_RNF138', 4632),
(4633, 'cd16342', NULL, 'FusC_FusB', NULL, NULL, 'FusC_FusB', 4633),
(4634, 'cd02879', NULL, 'GH18_plant_chitinase_class_V', NULL, NULL, 'GH18_plant_chitinase_class_V', 4634),
(4635, 'cd08242', NULL, 'MDR_like', NULL, NULL, 'MDR_like', 4635),
(4636, 'cd15776', NULL, 'FYVE2_PCLO', NULL, NULL, 'FYVE2_PCLO', 4636),
(4637, 'cd20174', NULL, 'GH18_LinChi78-like_UFR', NULL, NULL, 'GH18_LinChi78-like_UFR', 4637),
(4638, 'cd01801', NULL, 'Ubl_TECR_like', NULL, NULL, 'Ubl_TECR_like', 4638),
(4639, 'cd15934', NULL, '7tmC_mGluRs_group2_3', NULL, NULL, '7tmC_mGluRs_group2_3', 4639),
(4640, 'cd00462', NULL, 'PTH', NULL, NULL, 'PTH', 4640),
(4641, 'cd11663', NULL, 'GH119_BcIgtZ-like', NULL, NULL, 'GH119_BcIgtZ-like', 4641),
(4642, 'cd05016', NULL, 'SIS_PGI_2', NULL, NULL, 'SIS_PGI_2', 4642),
(4643, 'cd05299', NULL, 'CtBP_dh', NULL, NULL, 'CtBP_dh', 4643);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(4644, 'cd01657', NULL, 'Ribosomal_L7_archeal_euk', NULL, NULL, 'Ribosomal_L7_archeal_euk', 4644),
(4645, 'cd18832', NULL, 'GH43_GsAbnA-like', NULL, NULL, 'GH43_GsAbnA-like', 4645),
(4646, 'cd01788', NULL, 'Ubl_ElonginB', NULL, NULL, 'Ubl_ElonginB', 4646),
(4647, 'cd03407', NULL, 'SPFH_like_u4', NULL, NULL, 'SPFH_like_u4', 4647),
(4648, 'cd00327', NULL, 'cond_enzymes', NULL, NULL, 'cond_enzymes', 4648),
(4649, 'cd14876', NULL, 'MYSc_Myo14', NULL, NULL, 'MYSc_Myo14', 4649),
(4650, 'cd09695', NULL, 'Csx16_III-U', NULL, NULL, 'Csx16_III-U', 4650),
(4651, 'cd05628', NULL, 'STKc_NDR1', NULL, NULL, 'STKc_NDR1', 4651),
(4652, 'cd07494', NULL, 'Peptidases_S8_10', NULL, NULL, 'Peptidases_S8_10', 4652),
(4653, 'cd21399', NULL, 'ZBD_nv_SF1_Hel-like', NULL, NULL, 'ZBD_nv_SF1_Hel-like', 4653),
(4654, 'cd13112', NULL, 'POLO_box', NULL, NULL, 'POLO_box', 4654),
(4655, 'cd17015', NULL, 'ING_plant', NULL, NULL, 'ING_plant', 4655),
(4656, 'cd12577', NULL, 'RRM1_Hrp1p', NULL, NULL, 'RRM1_Hrp1p', 4656),
(4657, 'cd13137', NULL, 'MATE_NorM_like', NULL, NULL, 'MATE_NorM_like', 4657),
(4658, 'cd02670', NULL, 'Peptidase_C19N', NULL, NULL, 'Peptidase_C19N', 4658),
(4659, 'cd07037', NULL, 'TPP_PYR_MenD', NULL, NULL, 'TPP_PYR_MenD', 4659),
(4660, 'cd14503', NULL, 'PTP-bact', NULL, NULL, 'PTP-bact', 4660),
(4661, 'cd08517', NULL, 'PBP2_NikA_DppA_OppA_like_13', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_13', 4661),
(4662, 'cd21406', NULL, '1B_nv_SF1_Hel-like', NULL, NULL, '1B_nv_SF1_Hel-like', 4662),
(4663, 'cd01413', NULL, 'SIR2_Af2', NULL, NULL, 'SIR2_Af2', 4663),
(4664, 'cd01465', NULL, 'vWA_subgroup', NULL, NULL, 'vWA_subgroup', 4664),
(4665, 'cd13253', NULL, 'PH1_ARAP', NULL, NULL, 'PH1_ARAP', 4665),
(4666, 'cd19354', NULL, 'Wnt_Wnt9b', NULL, NULL, 'Wnt_Wnt9b', 4666),
(4667, 'cd08765', NULL, 'Cyt_b561_CYBRD1', NULL, NULL, 'Cyt_b561_CYBRD1', 4667),
(4668, 'cd12494', NULL, 'RRM3_hnRNPR', NULL, NULL, 'RRM3_hnRNPR', 4668),
(4669, 'cd03044', NULL, 'GST_N_EF1Bgamma', NULL, NULL, 'GST_N_EF1Bgamma', 4669),
(4670, 'cd05649', NULL, 'M20_ArgE_DapE-like', NULL, NULL, 'M20_ArgE_DapE-like', 4670),
(4671, 'cd11696', NULL, 'DHR2_DOCK_B', NULL, NULL, 'DHR2_DOCK_B', 4671),
(4672, 'cd17065', NULL, 'Ubl_UBP24', NULL, NULL, 'Ubl_UBP24', 4672),
(4673, 'cd03568', NULL, 'VHS_STAM', NULL, NULL, 'VHS_STAM', 4673),
(4674, 'cd07121', NULL, 'ALDH_EutE', NULL, NULL, 'ALDH_EutE', 4674),
(4675, 'cd17071', NULL, 'DCX1_DCDC2_like', NULL, NULL, 'DCX1_DCDC2_like', 4675),
(4676, 'cd02962', NULL, 'TMX2', NULL, NULL, 'TMX2', 4676),
(4677, 'cd01703', NULL, 'PolY_Pol_iota', NULL, NULL, 'PolY_Pol_iota', 4677),
(4678, 'cd07883', NULL, 'RHD-n_NFkB', NULL, NULL, 'RHD-n_NFkB', 4678),
(4679, 'cd14840', NULL, 'D-Ala-D-Ala_dipeptidase_Aad', NULL, NULL, 'D-Ala-D-Ala_dipeptidase_Aad', 4679),
(4680, 'cd15214', NULL, '7tmA_GPR161', NULL, NULL, '7tmA_GPR161', 4680),
(4681, 'cd00876', NULL, 'Ras', NULL, NULL, 'Ras', 4681),
(4682, 'cd08231', NULL, 'MDR_TM0436_like', NULL, NULL, 'MDR_TM0436_like', 4682),
(4683, 'cd14868', NULL, 'uS7_Mitochondria_Fungi', NULL, NULL, 'uS7_Mitochondria_Fungi', 4683),
(4684, 'cd03574', NULL, 'NTR_complement_C345C', NULL, NULL, 'NTR_complement_C345C', 4684),
(4685, 'cd21537', NULL, 'SUD_C_HKU9_CoV_Nsp3', NULL, NULL, 'SUD_C_HKU9_CoV_Nsp3', 4685),
(4686, 'cd13310', NULL, 'PH_RalGPS1_2', NULL, NULL, 'PH_RalGPS1_2', 4686),
(4687, 'cd18027', NULL, 'DEXHc_SKIV2L', NULL, NULL, 'DEXHc_SKIV2L', 4687),
(4688, 'cd01750', NULL, 'GATase1_CobQ', NULL, NULL, 'GATase1_CobQ', 4688),
(4689, 'cd15030', NULL, '7tmF_SMO_homolog', NULL, NULL, '7tmF_SMO_homolog', 4689),
(4690, 'cd15322', NULL, '7tmA_alpha2A_AR', NULL, NULL, '7tmA_alpha2A_AR', 4690),
(4691, 'cd17954', NULL, 'DEADc_DDX47', NULL, NULL, 'DEADc_DDX47', 4691),
(4692, 'cd12129', NULL, 'PE-PC-PEC_alpha', NULL, NULL, 'PE-PC-PEC_alpha', 4692),
(4693, 'cd18662', NULL, 'CD2_tandem_CHD3-4_like', NULL, NULL, 'CD2_tandem_CHD3-4_like', 4693),
(4694, 'cd18417', NULL, 'BTB_POZ_KCND1', NULL, NULL, 'BTB_POZ_KCND1', 4694),
(4695, 'cd12319', NULL, 'RRM4_MRD1', NULL, NULL, 'RRM4_MRD1', 4695),
(4696, 'cd11272', NULL, 'Sema_plexin_A2', NULL, NULL, 'Sema_plexin_A2', 4696);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(4697, 'cd08695', NULL, 'C2_Dock-B', NULL, NULL, 'C2_Dock-B', 4697),
(4698, 'cd12457', NULL, 'RRM_XMAS2', NULL, NULL, 'RRM_XMAS2', 4698),
(4699, 'cd18388', NULL, 'BTB_POZ_KCTD15', NULL, NULL, 'BTB_POZ_KCTD15', 4699),
(4700, 'cd18040', NULL, 'DEXXc_HELZ2-C', NULL, NULL, 'DEXXc_HELZ2-C', 4700),
(4701, 'cd09395', NULL, 'LIM2_Rga', NULL, NULL, 'LIM2_Rga', 4701),
(4702, 'cd15339', NULL, '7tmA_MCHR2', NULL, NULL, '7tmA_MCHR2', 4702),
(4703, 'cd05508', NULL, 'Bromo_RACK7', NULL, NULL, 'Bromo_RACK7', 4703),
(4704, 'cd07362', NULL, 'HPCD_like', NULL, NULL, 'HPCD_like', 4704),
(4705, 'cd17423', NULL, 'MFS_MCT11_13', NULL, NULL, 'MFS_MCT11_13', 4705),
(4706, 'cd00822', NULL, 'TopoII_Trans_DNA_gyrase', NULL, NULL, 'TopoII_Trans_DNA_gyrase', 4706),
(4707, 'cd01250', NULL, 'PH_AGAP', NULL, NULL, 'PH_AGAP', 4707),
(4708, 'cd15678', NULL, 'PHD_BRPF3', NULL, NULL, 'PHD_BRPF3', 4708),
(4709, 'cd15870', NULL, 'R-SNARE_VAMP2', NULL, NULL, 'R-SNARE_VAMP2', 4709),
(4710, 'cd08750', NULL, 'RGS_GRK4', NULL, NULL, 'RGS_GRK4', 4710),
(4711, 'cd01576', NULL, 'AcnB_Swivel', NULL, NULL, 'AcnB_Swivel', 4711),
(4712, 'cd00817', NULL, 'ValRS_core', NULL, NULL, 'ValRS_core', 4712),
(4713, 'cd09012', NULL, 'VOC_like', NULL, NULL, 'VOC_like', 4713),
(4714, 'cd17280', NULL, 'RMtype1_S_MspEN3ORF6650P_TRD2-CR2_like', NULL, NULL, 'RMtype1_S_MspEN3ORF6650P_TRD2-CR2_like', 4714),
(4715, 'cd12948', NULL, 'NOPS_PSF', NULL, NULL, 'NOPS_PSF', 4715),
(4716, 'cd03378', NULL, 'beta_CA_cladeC', NULL, NULL, 'beta_CA_cladeC', 4716),
(4717, 'cd19783', NULL, 'Bbox2_TRIM43-like', NULL, NULL, 'Bbox2_TRIM43-like', 4717),
(4718, 'cd16205', NULL, 'EFh_PI-PLCeta', NULL, NULL, 'EFh_PI-PLCeta', 4718),
(4719, 'cd04213', NULL, 'CuRO_CcO_Caa3_II', NULL, NULL, 'CuRO_CcO_Caa3_II', 4719),
(4720, 'cd04751', NULL, 'Commd3', NULL, NULL, 'Commd3', 4720),
(4721, 'cd03745', NULL, 'SOCS_WSB2_SWIP2', NULL, NULL, 'SOCS_WSB2_SWIP2', 4721),
(4722, 'cd15262', NULL, '7tmB1_NPR_B3_insect-like', NULL, NULL, '7tmB1_NPR_B3_insect-like', 4722),
(4723, 'cd18533', NULL, 'PTP_fungal', NULL, NULL, 'PTP_fungal', 4723),
(4724, 'cd00173', NULL, 'SH2', NULL, NULL, 'SH2', 4724),
(4725, 'cd11436', NULL, 'bHLH-PAS_AhR', NULL, NULL, 'bHLH-PAS_AhR', 4725),
(4726, 'cd11450', NULL, 'bHLH_AtFIT_like', NULL, NULL, 'bHLH_AtFIT_like', 4726),
(4727, 'cd13431', NULL, 'LDT_IgD_like_1', NULL, NULL, 'LDT_IgD_like_1', 4727),
(4728, 'cd17595', NULL, 'REC_TrxB', NULL, NULL, 'REC_TrxB', 4728),
(4729, 'cd00780', NULL, 'NTF2', NULL, NULL, 'NTF2', 4729),
(4730, 'cd17127', NULL, 'Ubl_TBK1', NULL, NULL, 'Ubl_TBK1', 4730),
(4731, 'cd15555', NULL, 'PHD_KDM2A_2B', NULL, NULL, 'PHD_KDM2A_2B', 4731),
(4732, 'cd16522', NULL, 'RING-HC_MSL2', NULL, NULL, 'RING-HC_MSL2', 4732),
(4733, 'cd05536', NULL, 'POLBc_B3', NULL, NULL, 'POLBc_B3', 4733),
(4734, 'cd18925', NULL, 'bHLHzip_TFEC', NULL, NULL, 'bHLHzip_TFEC', 4734),
(4735, 'cd09386', NULL, 'LIM1_LMO4', NULL, NULL, 'LIM1_LMO4', 4735),
(4736, 'cd09401', NULL, 'LIM_TLP_like', NULL, NULL, 'LIM_TLP_like', 4736),
(4737, 'cd11335', NULL, 'AmyAc_MTase_N', NULL, NULL, 'AmyAc_MTase_N', 4737),
(4738, 'cd01056', NULL, 'Euk_Ferritin', NULL, NULL, 'Euk_Ferritin', 4738),
(4739, 'cd11494', NULL, 'SLC5sbd_NIS-like_u2', NULL, NULL, 'SLC5sbd_NIS-like_u2', 4739),
(4740, 'cd19573', NULL, 'serpinE2_GDN', NULL, NULL, 'serpinE2_GDN', 4740),
(4741, 'cd12068', NULL, 'SH3_MYO15B', NULL, NULL, 'SH3_MYO15B', 4741),
(4742, 'cd02170', NULL, 'cytidylyltransferase', NULL, NULL, 'cytidylyltransferase', 4742),
(4743, 'cd17277', NULL, 'RMtype1_M_Cni19672ORF1405P_RMtype11G_Hci611ORF...', NULL, NULL, 'RMtype1_M_Cni19672ORF1405P_RMtype11G_Hci611ORFHP_TRD1-CR1_like', 4743),
(4744, 'cd18631', NULL, 'CD_HP1_like', NULL, NULL, 'CD_HP1_like', 4744),
(4745, 'cd04446', NULL, 'DEP_DEPDC4', NULL, NULL, 'DEP_DEPDC4', 4745),
(4746, 'cd11492', NULL, 'SLC5sbd_NIS-SMVT', NULL, NULL, 'SLC5sbd_NIS-SMVT', 4746),
(4747, 'cd13165', NULL, 'PTB_DOK7', NULL, NULL, 'PTB_DOK7', 4747),
(4748, 'cd09224', NULL, 'CytoC_RC', NULL, NULL, 'CytoC_RC', 4748),
(4749, 'cd20223', NULL, 'PFM_epsilon-toxin-like', NULL, NULL, 'PFM_epsilon-toxin-like', 4749);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(4750, 'cd04717', NULL, 'BAH_polybromo', NULL, NULL, 'BAH_polybromo', 4750),
(4751, 'cd10384', NULL, 'SH2_SOCS3', NULL, NULL, 'SH2_SOCS3', 4751),
(4752, 'cd13222', NULL, 'PH-GRAM_GEM', NULL, NULL, 'PH-GRAM_GEM', 4752),
(4753, 'cd11020', NULL, 'CuRO_1_CuNIR', NULL, NULL, 'CuRO_1_CuNIR', 4753),
(4754, 'cd05213', NULL, 'NAD_bind_Glutamyl_tRNA_reduct', NULL, NULL, 'NAD_bind_Glutamyl_tRNA_reduct', 4754),
(4755, 'cd02645', NULL, 'R3H_AAA', NULL, NULL, 'R3H_AAA', 4755),
(4756, 'cd05790', NULL, 'S1_Rrp40', NULL, NULL, 'S1_Rrp40', 4756),
(4757, 'cd00083', NULL, 'bHLH_SF', NULL, NULL, 'bHLH_SF', 4757),
(4758, 'cd01086', NULL, 'MetAP1', NULL, NULL, 'MetAP1', 4758),
(4759, 'cd05650', NULL, 'M20_ArgE_DapE-like', NULL, NULL, 'M20_ArgE_DapE-like', 4759),
(4760, 'cd10294', NULL, 'GST_C_ValRS_N', NULL, NULL, 'GST_C_ValRS_N', 4760),
(4761, 'cd16513', NULL, 'RING1-HC_LONFs', NULL, NULL, 'RING1-HC_LONFs', 4761),
(4762, 'cd04652', NULL, 'LbH_eIF2B_gamma_C', NULL, NULL, 'LbH_eIF2B_gamma_C', 4762),
(4763, 'cd07536', NULL, 'P-type_ATPase_APLT', NULL, NULL, 'P-type_ATPase_APLT', 4763),
(4764, 'cd03034', NULL, 'ArsC_ArsC', NULL, NULL, 'ArsC_ArsC', 4764),
(4765, 'cd12334', NULL, 'RRM1_SF3B4', NULL, NULL, 'RRM1_SF3B4', 4765),
(4766, 'cd15377', NULL, '7tmA_P2Y1', NULL, NULL, '7tmA_P2Y1', 4766),
(4767, 'cd11281', NULL, 'ADF_drebrin_like', NULL, NULL, 'ADF_drebrin_like', 4767),
(4768, 'cd12462', NULL, 'RRM_SCAF8', NULL, NULL, 'RRM_SCAF8', 4768),
(4769, 'cd14309', NULL, 'UBA_scDdi1_like', NULL, NULL, 'UBA_scDdi1_like', 4769),
(4770, 'cd07122', NULL, 'ALDH_F20_ACDH', NULL, NULL, 'ALDH_F20_ACDH', 4770),
(4771, 'cd20300', NULL, 'cupin_npun_f5605-like_N', NULL, NULL, 'cupin_npun_f5605-like_N', 4771),
(4772, 'cd18329', NULL, 'BTB_POZ_ZBTB8A_BOZF1', NULL, NULL, 'BTB_POZ_ZBTB8A_BOZF1', 4772),
(4773, 'cd07791', NULL, 'FGGY_GK2_bacteria', NULL, NULL, 'FGGY_GK2_bacteria', 4773),
(4774, 'cd06146', NULL, 'mut-7_like_exo', NULL, NULL, 'mut-7_like_exo', 4774),
(4775, 'cd17178', NULL, 'FERM_F1_PLEKHH1', NULL, NULL, 'FERM_F1_PLEKHH1', 4775),
(4776, 'cd13146', NULL, 'MATE_like_6', NULL, NULL, 'MATE_like_6', 4776),
(4777, 'cd04398', NULL, 'RhoGAP_fRGD1', NULL, NULL, 'RhoGAP_fRGD1', 4777),
(4778, 'cd09809', NULL, 'human_WWOX_like_SDR_c-like', NULL, NULL, 'human_WWOX_like_SDR_c-like', 4778),
(4779, 'cd08228', NULL, 'STKc_Nek6', NULL, NULL, 'STKc_Nek6', 4779),
(4780, 'cd06498', NULL, 'ACD_alphaB-crystallin_HspB5', NULL, NULL, 'ACD_alphaB-crystallin_HspB5', 4780),
(4781, 'cd14710', NULL, 'bZIP_HAC1-like', NULL, NULL, 'bZIP_HAC1-like', 4781),
(4782, 'cd15212', NULL, '7tmA_GPR135', NULL, NULL, '7tmA_GPR135', 4782),
(4783, 'cd11935', NULL, 'SH3_Nebulette_C', NULL, NULL, 'SH3_Nebulette_C', 4783),
(4784, 'cd06289', NULL, 'PBP1_MalI-like', NULL, NULL, 'PBP1_MalI-like', 4784),
(4785, 'cd15274', NULL, '7tmB1_calcitonin_R', NULL, NULL, '7tmB1_calcitonin_R', 4785),
(4786, 'cd19796', NULL, 'Bbox2_TRIM71_C-VII', NULL, NULL, 'Bbox2_TRIM71_C-VII', 4786),
(4787, 'cd02080', NULL, 'P-type_ATPase_cation', NULL, NULL, 'P-type_ATPase_cation', 4787),
(4788, 'cd16858', NULL, 'ING_ING3_Yng2p', NULL, NULL, 'ING_ING3_Yng2p', 4788),
(4789, 'cd19787', NULL, 'Bbox2_TRIM50-like', NULL, NULL, 'Bbox2_TRIM50-like', 4789),
(4790, 'cd04490', NULL, 'PolII_SU_OBF', NULL, NULL, 'PolII_SU_OBF', 4790),
(4791, 'cd15258', NULL, '7tmB2_GPR126-like_Adhesion_VIII', NULL, NULL, '7tmB2_GPR126-like_Adhesion_VIII', 4791),
(4792, 'cd14801', NULL, 'STAT_DBD', NULL, NULL, 'STAT_DBD', 4792),
(4793, 'cd01336', NULL, 'MDH_cytoplasmic_cytosolic', NULL, NULL, 'MDH_cytoplasmic_cytosolic', 4793),
(4794, 'cd06988', NULL, 'cupin_DddK', NULL, NULL, 'cupin_DddK', 4794),
(4795, 'cd08439', NULL, 'PBP2_LrhA_like', NULL, NULL, 'PBP2_LrhA_like', 4795),
(4796, 'cd01446', NULL, 'DSP_MapKP', NULL, NULL, 'DSP_MapKP', 4796),
(4797, 'cd06650', NULL, 'PKc_MEK1', NULL, NULL, 'PKc_MEK1', 4797),
(4798, 'cd14108', NULL, 'STKc_SPEG_rpt1', NULL, NULL, 'STKc_SPEG_rpt1', 4798),
(4799, 'cd12220', NULL, 'Pesticin_RB', NULL, NULL, 'Pesticin_RB', 4799),
(4800, 'cd19929', NULL, 'psREC_Atg32', NULL, NULL, 'psREC_Atg32', 4800);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(4801, 'cd02555', NULL, 'PSSA_1', NULL, NULL, 'PSSA_1', 4801),
(4802, 'cd12508', NULL, 'RRM2_ESRPs_Fusilli', NULL, NULL, 'RRM2_ESRPs_Fusilli', 4802),
(4803, 'cd15937', NULL, '7tmA_OR4N-like', NULL, NULL, '7tmA_OR4N-like', 4803),
(4804, 'cd19456', NULL, 'lipocalin_NP4', NULL, NULL, 'lipocalin_NP4', 4804),
(4805, 'cd02024', NULL, 'NRK1', NULL, NULL, 'NRK1', 4805),
(4806, 'cd07417', NULL, 'MPP_PP5_C', NULL, NULL, 'MPP_PP5_C', 4806),
(4807, 'cd13608', NULL, 'PBP2_OpuCC_like', NULL, NULL, 'PBP2_OpuCC_like', 4807),
(4808, 'cd19860', NULL, 'DSRM_STAU_rpt4', NULL, NULL, 'DSRM_STAU_rpt4', 4808),
(4809, 'cd08715', NULL, 'RGS_RGS1', NULL, NULL, 'RGS_RGS1', 4809),
(4810, 'cd04279', NULL, 'ZnMc_MMP_like_1', NULL, NULL, 'ZnMc_MMP_like_1', 4810),
(4811, 'cd03265', NULL, 'ABC_DrrA', NULL, NULL, 'ABC_DrrA', 4811),
(4812, 'cd18288', NULL, 'BTB_POZ_BTBD12_SLX4', NULL, NULL, 'BTB_POZ_BTBD12_SLX4', 4812),
(4813, 'cd18201', NULL, 'BTB_POZ_ZBTB10', NULL, NULL, 'BTB_POZ_ZBTB10', 4813),
(4814, 'cd00104', NULL, 'KAZAL_FS', NULL, NULL, 'KAZAL_FS', 4814),
(4815, 'cd21595', NULL, 'CoV_N-CTD', NULL, NULL, 'CoV_N-CTD', 4815),
(4816, 'cd11850', NULL, 'SH3_Abl', NULL, NULL, 'SH3_Abl', 4816),
(4817, 'cd16893', NULL, 'LT_MltC_MltE', NULL, NULL, 'LT_MltC_MltE', 4817),
(4818, 'cd17325', NULL, 'MFS_MdtG_SLC18_like', NULL, NULL, 'MFS_MdtG_SLC18_like', 4818),
(4819, 'cd08974', NULL, 'BaFpgNei_N_2', NULL, NULL, 'BaFpgNei_N_2', 4819),
(4820, 'cd12604', NULL, 'RRM_RALY', NULL, NULL, 'RRM_RALY', 4820),
(4821, 'cd06236', NULL, 'M14_AGBL5_like', NULL, NULL, 'M14_AGBL5_like', 4821),
(4822, 'cd13545', NULL, 'PBP2_TbpA', NULL, NULL, 'PBP2_TbpA', 4822),
(4823, 'cd18266', NULL, 'BTB_POZ_KLHL36', NULL, NULL, 'BTB_POZ_KLHL36', 4823),
(4824, 'cd15794', NULL, 'PH_ARHGEF18', NULL, NULL, 'PH_ARHGEF18', 4824),
(4825, 'cd08249', NULL, 'enoyl_reductase_like', NULL, NULL, 'enoyl_reductase_like', 4825),
(4826, 'cd09004', NULL, 'GH43_bXyl-like', NULL, NULL, 'GH43_bXyl-like', 4826),
(4827, 'cd14521', NULL, 'DSP_fungal_SDP1-like', NULL, NULL, 'DSP_fungal_SDP1-like', 4827),
(4828, 'cd09607', NULL, 'M3B_PepF', NULL, NULL, 'M3B_PepF', 4828),
(4829, 'cd02220', NULL, 'cupin_ABP1', NULL, NULL, 'cupin_ABP1', 4829),
(4830, 'cd04333', NULL, 'ProX_deacylase', NULL, NULL, 'ProX_deacylase', 4830),
(4831, 'cd13999', NULL, 'STKc_MAP3K-like', NULL, NULL, 'STKc_MAP3K-like', 4831),
(4832, 'cd01139', NULL, 'TroA_f', NULL, NULL, 'TroA_f', 4832),
(4833, 'cd00102', NULL, 'IPT', NULL, NULL, 'IPT', 4833),
(4834, 'cd05522', NULL, 'Bromo_Rsc1_2_II', NULL, NULL, 'Bromo_Rsc1_2_II', 4834),
(4835, 'cd08621', NULL, 'PI-PLCXDc_like_2', NULL, NULL, 'PI-PLCXDc_like_2', 4835),
(4836, 'cd08942', NULL, 'RhlG_SDR_c', NULL, NULL, 'RhlG_SDR_c', 4836),
(4837, 'cd17415', NULL, 'MFS_NPF3', NULL, NULL, 'MFS_NPF3', 4837),
(4838, 'cd09504', NULL, 'SAM_STIM-1,2-like', NULL, NULL, 'SAM_STIM-1,2-like', 4838),
(4839, 'cd13376', NULL, 'PH_DAB2IP', NULL, NULL, 'PH_DAB2IP', 4839),
(4840, 'cd18572', NULL, 'ABC_6TM_TAP', NULL, NULL, 'ABC_6TM_TAP', 4840),
(4841, 'cd04821', NULL, 'PA_M28_1_2', NULL, NULL, 'PA_M28_1_2', 4841),
(4842, 'cd04793', NULL, 'LanC', NULL, NULL, 'LanC', 4842),
(4843, 'cd05798', NULL, 'SIS_TAL_PGI', NULL, NULL, 'SIS_TAL_PGI', 4843),
(4844, 'cd00221', NULL, 'Vsr', NULL, NULL, 'Vsr', 4844),
(4845, 'cd03282', NULL, 'ABC_MSH4_euk', NULL, NULL, 'ABC_MSH4_euk', 4845),
(4846, 'cd21556', NULL, 'Macro_cv_SUD-N-M_Nsp3-like', NULL, NULL, 'Macro_cv_SUD-N-M_Nsp3-like', 4846),
(4847, 'cd18535', NULL, 'PTP-IVa3', NULL, NULL, 'PTP-IVa3', 4847),
(4848, 'cd00148', NULL, 'PROF', NULL, NULL, 'PROF', 4848),
(4849, 'cd11954', NULL, 'SH3_ASPP1', NULL, NULL, 'SH3_ASPP1', 4849),
(4850, 'cd01347', NULL, 'ligand_gated_channel', NULL, NULL, 'ligand_gated_channel', 4850),
(4851, 'cd07961', NULL, 'Anticodon_Ia_Ile_ABEc', NULL, NULL, 'Anticodon_Ia_Ile_ABEc', 4851),
(4852, 'cd01834', NULL, 'SGNH_hydrolase_like_2', NULL, NULL, 'SGNH_hydrolase_like_2', 4852),
(4853, 'cd07619', NULL, 'BAR_Rich2', NULL, NULL, 'BAR_Rich2', 4853),
(4854, 'cd16580', NULL, 'RING-HC_TRIM8_C-V', NULL, NULL, 'RING-HC_TRIM8_C-V', 4854),
(4855, 'cd04742', NULL, 'NPD_FabD', NULL, NULL, 'NPD_FabD', 4855); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(4856, 'cd18968', NULL, 'chromodomain', NULL, NULL, 'chromodomain', 4856),
(4857, 'cd06839', NULL, 'PLPDE_III_Btrk_like', NULL, NULL, 'PLPDE_III_Btrk_like', 4857),
(4858, 'cd14228', NULL, 'STKc_HIPK1', NULL, NULL, 'STKc_HIPK1', 4858),
(4859, 'cd08805', NULL, 'Death_ank1', NULL, NULL, 'Death_ank1', 4859),
(4860, 'cd14275', NULL, 'UBA_EF-Ts', NULL, NULL, 'UBA_EF-Ts', 4860),
(4861, 'cd06983', NULL, 'cupin_dsy2733', NULL, NULL, 'cupin_dsy2733', 4861),
(4862, 'cd15904', NULL, 'TSPO_MBR', NULL, NULL, 'TSPO_MBR', 4862),
(4863, 'cd05499', NULL, 'Bromo_BDF1_2_II', NULL, NULL, 'Bromo_BDF1_2_II', 4863),
(4864, 'cd00235', NULL, 'TLP-20', NULL, NULL, 'TLP-20', 4864),
(4865, 'cd15790', NULL, 'PH-GRAM_MTMR11', NULL, NULL, 'PH-GRAM_MTMR11', 4865),
(4866, 'cd04407', NULL, 'RhoGAP_myosin_IXB', NULL, NULL, 'RhoGAP_myosin_IXB', 4866),
(4867, 'cd05006', NULL, 'SIS_GmhA', NULL, NULL, 'SIS_GmhA', 4867),
(4868, 'cd03023', NULL, 'DsbA_Com1_like', NULL, NULL, 'DsbA_Com1_like', 4868),
(4869, 'cd15198', NULL, '7tmA_GPR150', NULL, NULL, '7tmA_GPR150', 4869),
(4870, 'cd00956', NULL, 'Transaldolase_FSA', NULL, NULL, 'Transaldolase_FSA', 4870),
(4871, 'cd07075', NULL, 'NR_LBD_MR', NULL, NULL, 'NR_LBD_MR', 4871),
(4872, 'cd14789', NULL, 'Tiki', NULL, NULL, 'Tiki', 4872),
(4873, 'cd13961', NULL, 'PT_UbiA_DGGGPS', NULL, NULL, 'PT_UbiA_DGGGPS', 4873),
(4874, 'cd15991', NULL, '7tmB2_CELSR1', NULL, NULL, '7tmB2_CELSR1', 4874),
(4875, 'cd01712', NULL, 'ThiI', NULL, NULL, 'ThiI', 4875),
(4876, 'cd05369', NULL, 'TER_DECR_SDR_a', NULL, NULL, 'TER_DECR_SDR_a', 4876),
(4877, 'cd07713', NULL, 'DHPS-like_MBL-fold', NULL, NULL, 'DHPS-like_MBL-fold', 4877),
(4878, 'cd01645', NULL, 'RT_Rtv', NULL, NULL, 'RT_Rtv', 4878),
(4879, 'cd00622', NULL, 'PLPDE_III_ODC', NULL, NULL, 'PLPDE_III_ODC', 4879),
(4880, 'cd11468', NULL, 'bHLH_TS_bHLHe22_like', NULL, NULL, 'bHLH_TS_bHLHe22_like', 4880),
(4881, 'cd08337', NULL, 'DED_c-FLIP_r1', NULL, NULL, 'DED_c-FLIP_r1', 4881),
(4882, 'cd07991', NULL, 'LPLAT_LPCAT1-like', NULL, NULL, 'LPLAT_LPCAT1-like', 4882),
(4883, 'cd16037', NULL, 'sulfatase_like', NULL, NULL, 'sulfatase_like', 4883),
(4884, 'cd07031', NULL, 'RNAP_II_RPB3', NULL, NULL, 'RNAP_II_RPB3', 4884),
(4885, 'cd01866', NULL, 'Rab2', NULL, NULL, 'Rab2', 4885),
(4886, 'cd14342', NULL, 'UBA_TAP-C', NULL, NULL, 'UBA_TAP-C', 4886),
(4887, 'cd00691', NULL, 'ascorbate_peroxidase', NULL, NULL, 'ascorbate_peroxidase', 4887),
(4888, 'cd05829', NULL, 'Sortase_F', NULL, NULL, 'Sortase_F', 4888),
(4889, 'cd21144', NULL, 'NendoU_XendoU-like', NULL, NULL, 'NendoU_XendoU-like', 4889),
(4890, 'cd19145', NULL, 'AKR_AKR13D1', NULL, NULL, 'AKR_AKR13D1', 4890),
(4891, 'cd19793', NULL, 'Bbox2_TRIM65-like', NULL, NULL, 'Bbox2_TRIM65-like', 4891),
(4892, 'cd18340', NULL, 'BTB_POZ_KLHL40_KBTBD5', NULL, NULL, 'BTB_POZ_KLHL40_KBTBD5', 4892),
(4893, 'cd19777', NULL, 'Bbox2_TRIM35_C-IV', NULL, NULL, 'Bbox2_TRIM35_C-IV', 4893),
(4894, 'cd05741', NULL, 'Ig_CEACAM_like', NULL, NULL, 'Ig_CEACAM_like', 4894),
(4895, 'cd15454', NULL, '7tmC_mGluR8', NULL, NULL, '7tmC_mGluR8', 4895),
(4896, 'cd19383', NULL, 'TGF_beta_Neurturin', NULL, NULL, 'TGF_beta_Neurturin', 4896),
(4897, 'cd20481', NULL, 'phage_tailspike_middle', NULL, NULL, 'phage_tailspike_middle', 4897),
(4898, 'cd11815', NULL, 'SH3_Eve1_2', NULL, NULL, 'SH3_Eve1_2', 4898),
(4899, 'cd06587', NULL, 'VOC', NULL, NULL, 'VOC', 4899),
(4900, 'cd06063', NULL, 'H2MP_Cyano-H2up', NULL, NULL, 'H2MP_Cyano-H2up', 4900),
(4901, 'cd09884', NULL, 'PIN_Smg5-like', NULL, NULL, 'PIN_Smg5-like', 4901),
(4902, 'cd02638', NULL, 'R3H_unknown_1', NULL, NULL, 'R3H_unknown_1', 4902),
(4903, 'cd04753', NULL, 'Commd5_HCaRG', NULL, NULL, 'Commd5_HCaRG', 4903),
(4904, 'cd19686', NULL, 'bHLH_TS_FERD3L_like', NULL, NULL, 'bHLH_TS_FERD3L_like', 4904),
(4905, 'cd12613', NULL, 'RRM2_NGR1_NAM8_like', NULL, NULL, 'RRM2_NGR1_NAM8_like', 4905),
(4906, 'cd08442', NULL, 'PBP2_YofA_SoxR_like', NULL, NULL, 'PBP2_YofA_SoxR_like', 4906),
(4907, 'cd20239', NULL, 'PFM_aerolysin-like', NULL, NULL, 'PFM_aerolysin-like', 4907),
(4908, 'cd09682', NULL, 'Cmr4_III-B', NULL, NULL, 'Cmr4_III-B', 4908);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(4909, 'cd06209', NULL, 'BenDO_FAD_NAD', NULL, NULL, 'BenDO_FAD_NAD', 4909),
(4910, 'cd09294', NULL, 'SmpB', NULL, NULL, 'SmpB', 4910),
(4911, 'cd13158', NULL, 'PTB_APPL', NULL, NULL, 'PTB_APPL', 4911),
(4912, 'cd05974', NULL, 'MACS_like_1', NULL, NULL, 'MACS_like_1', 4912),
(4913, 'cd01234', NULL, 'PH_CADPS', NULL, NULL, 'PH_CADPS', 4913),
(4914, 'cd14595', NULL, 'PTP-MTMR11', NULL, NULL, 'PTP-MTMR11', 4914),
(4915, 'cd03363', NULL, 'TOPRIM_TopoIA_TopoI', NULL, NULL, 'TOPRIM_TopoIA_TopoI', 4915),
(4916, 'cd14189', NULL, 'STKc_PLK3', NULL, NULL, 'STKc_PLK3', 4916),
(4917, 'cd14950', NULL, 'Asparaginase_2_like_2', NULL, NULL, 'Asparaginase_2_like_2', 4917),
(4918, 'cd07734', NULL, 'Int9-11_CPSF2-3-like_MBL-fold', NULL, NULL, 'Int9-11_CPSF2-3-like_MBL-fold', 4918),
(4919, 'cd12042', NULL, 'SH3_CACNB3', NULL, NULL, 'SH3_CACNB3', 4919),
(4920, 'cd03769', NULL, 'SR_IS607_transposase_like', NULL, NULL, 'SR_IS607_transposase_like', 4920),
(4921, 'cd12111', NULL, 'PHP_HisPPase_Thermotoga_like', NULL, NULL, 'PHP_HisPPase_Thermotoga_like', 4921),
(4922, 'cd12221', NULL, 'Cin1', NULL, NULL, 'Cin1', 4922),
(4923, 'cd08393', NULL, 'C2A_SLP-1_2', NULL, NULL, 'C2A_SLP-1_2', 4923),
(4924, 'cd14178', NULL, 'STKc_RSK3_C', NULL, NULL, 'STKc_RSK3_C', 4924),
(4925, 'cd08358', NULL, 'GLOD4_N', NULL, NULL, 'GLOD4_N', 4925),
(4926, 'cd15389', NULL, '7tmA_GPR83', NULL, NULL, '7tmA_GPR83', 4926),
(4927, 'cd09723', NULL, 'Csx1_III-U', NULL, NULL, 'Csx1_III-U', 4927),
(4928, 'cd05905', NULL, 'Dip2', NULL, NULL, 'Dip2', 4928),
(4929, 'cd19731', NULL, 'bHLH-PAS_NPAS1_PASD5', NULL, NULL, 'bHLH-PAS_NPAS1_PASD5', 4929),
(4930, 'cd07128', NULL, 'ALDH_MaoC-N', NULL, NULL, 'ALDH_MaoC-N', 4930),
(4931, 'cd14035', NULL, 'PK_MADML', NULL, NULL, 'PK_MADML', 4931),
(4932, 'cd14909', NULL, 'MYSc_Myh1_insects_crustaceans', NULL, NULL, 'MYSc_Myh1_insects_crustaceans', 4932),
(4933, 'cd02766', NULL, 'MopB_3', NULL, NULL, 'MopB_3', 4933),
(4934, 'cd08360', NULL, 'MhqB_like_C', NULL, NULL, 'MhqB_like_C', 4934),
(4935, 'cd09071', NULL, 'FAR_C', NULL, NULL, 'FAR_C', 4935),
(4936, 'cd17557', NULL, 'REC_Rcp-like', NULL, NULL, 'REC_Rcp-like', 4936),
(4937, 'cd06586', NULL, 'TPP_enzyme_PYR', NULL, NULL, 'TPP_enzyme_PYR', 4937),
(4938, 'cd09024', NULL, 'Aldose_epim_lacX', NULL, NULL, 'Aldose_epim_lacX', 4938),
(4939, 'cd11767', NULL, 'SH3_Nck_3', NULL, NULL, 'SH3_Nck_3', 4939),
(4940, 'cd02995', NULL, 'PDI_a_PDI_a''_C', NULL, NULL, 'PDI_a_PDI_a''_C', 4940),
(4941, 'cd00864', NULL, 'PI3Ka', NULL, NULL, 'PI3Ka', 4941),
(4942, 'cd08319', NULL, 'Death_RAIDD', NULL, NULL, 'Death_RAIDD', 4942),
(4943, 'cd07672', NULL, 'F-BAR_PSTPIP2', NULL, NULL, 'F-BAR_PSTPIP2', 4943),
(4944, 'cd04871', NULL, 'ACT_PSP_2', NULL, NULL, 'ACT_PSP_2', 4944),
(4945, 'cd07410', NULL, 'MPP_CpdB_N', NULL, NULL, 'MPP_CpdB_N', 4945),
(4946, 'cd17093', NULL, 'FERM2_F1_Myosin-VII', NULL, NULL, 'FERM2_F1_Myosin-VII', 4946),
(4947, 'cd01647', NULL, 'RT_LTR', NULL, NULL, 'RT_LTR', 4947),
(4948, 'cd04772', NULL, 'HTH_TioE_rpt1', NULL, NULL, 'HTH_TioE_rpt1', 4948),
(4949, 'cd00436', NULL, 'UP_TbUP-like', NULL, NULL, 'UP_TbUP-like', 4949),
(4950, 'cd11722', NULL, 'SOAR', NULL, NULL, 'SOAR', 4950),
(4951, 'cd14424', NULL, 'CUE_Cue1p_like', NULL, NULL, 'CUE_Cue1p_like', 4951),
(4952, 'cd17111', NULL, 'RA1_DAGK-theta', NULL, NULL, 'RA1_DAGK-theta', 4952),
(4953, 'cd15615', NULL, 'PHD_ARID4_like', NULL, NULL, 'PHD_ARID4_like', 4953),
(4954, 'cd05817', NULL, 'CBM20_DSP', NULL, NULL, 'CBM20_DSP', 4954),
(4955, 'cd17137', NULL, 'RBD1_RGS14', NULL, NULL, 'RBD1_RGS14', 4955),
(4956, 'cd16787', NULL, 'mRING-HC-C3HC5_CGRF1', NULL, NULL, 'mRING-HC-C3HC5_CGRF1', 4956),
(4957, 'cd11276', NULL, 'Sema_plexin_B2', NULL, NULL, 'Sema_plexin_B2', 4957),
(4958, 'cd12010', NULL, 'SH3_SLAP', NULL, NULL, 'SH3_SLAP', 4958),
(4959, 'cd08450', NULL, 'PBP2_HcaR', NULL, NULL, 'PBP2_HcaR', 4959),
(4960, 'cd20607', NULL, 'FbiB_C-like', NULL, NULL, 'FbiB_C-like', 4960),
(4961, 'cd02859', NULL, 'E_set_AMPKbeta_like_N', NULL, NULL, 'E_set_AMPKbeta_like_N', 4961),
(4962, 'cd13696', NULL, 'PBP2_Atu4678_like', NULL, NULL, 'PBP2_Atu4678_like', 4962);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(4963, 'cd21512', NULL, 'cv_gamma-delta_Nsp2_IBV-like', NULL, NULL, 'cv_gamma-delta_Nsp2_IBV-like', 4963),
(4964, 'cd02537', NULL, 'GT8_Glycogenin', NULL, NULL, 'GT8_Glycogenin', 4964),
(4965, 'cd00842', NULL, 'MPP_ASMase', NULL, NULL, 'MPP_ASMase', 4965),
(4966, 'cd12108', NULL, 'Hr-like', NULL, NULL, 'Hr-like', 4966),
(4967, 'cd03088', NULL, 'ManB', NULL, NULL, 'ManB', 4967),
(4968, 'cd15065', NULL, '7tmA_Ap5-HTB1-like', NULL, NULL, '7tmA_Ap5-HTB1-like', 4968),
(4969, 'cd20183', NULL, 'M34_PPEP', NULL, NULL, 'M34_PPEP', 4969),
(4970, 'cd06403', NULL, 'PB1_Par6', NULL, NULL, 'PB1_Par6', 4970),
(4971, 'cd13527', NULL, 'PBP2_TRAP', NULL, NULL, 'PBP2_TRAP', 4971),
(4972, 'cd01231', NULL, 'PH_SH2B_family', NULL, NULL, 'PH_SH2B_family', 4972),
(4973, 'cd14537', NULL, 'PTP-MTMR10-like', NULL, NULL, 'PTP-MTMR10-like', 4973),
(4974, 'cd13226', NULL, 'PH-GRAM-like_Eap45', NULL, NULL, 'PH-GRAM-like_Eap45', 4974),
(4975, 'cd16673', NULL, 'RING-H2_RNF6', NULL, NULL, 'RING-H2_RNF6', 4975),
(4976, 'cd09233', NULL, 'ACE1-Sec16-like', NULL, NULL, 'ACE1-Sec16-like', 4976),
(4977, 'cd16174', NULL, 'EFh_MICU2', NULL, NULL, 'EFh_MICU2', 4977),
(4978, 'cd09852', NULL, 'PIN_SF', NULL, NULL, 'PIN_SF', 4978),
(4979, 'cd10009', NULL, 'HDAC9', NULL, NULL, 'HDAC9', 4979),
(4980, 'cd18193', NULL, 'BTB_POZ_ZBTB2', NULL, NULL, 'BTB_POZ_ZBTB2', 4980),
(4981, 'cd07327', NULL, 'M48B_HtpX_like', NULL, NULL, 'M48B_HtpX_like', 4981),
(4982, 'cd00064', NULL, 'FU', NULL, NULL, 'FU', 4982),
(4983, 'cd10816', NULL, 'GH57N_BE_TK1436_like', NULL, NULL, 'GH57N_BE_TK1436_like', 4983),
(4984, 'cd08772', NULL, 'GH43_62_32_68_117_130', NULL, NULL, 'GH43_62_32_68_117_130', 4984),
(4985, 'cd07394', NULL, 'MPP_Vps29', NULL, NULL, 'MPP_Vps29', 4985),
(4986, 'cd17154', NULL, 'DCX2_DCDC2C', NULL, NULL, 'DCX2_DCDC2C', 4986),
(4987, 'cd16679', NULL, 'RING-H2_RNF38', NULL, NULL, 'RING-H2_RNF38', 4987),
(4988, 'cd10798', NULL, 'GH57N_like_1', NULL, NULL, 'GH57N_like_1', 4988),
(4989, 'cd15498', NULL, 'PHD2_Snt2p_like', NULL, NULL, 'PHD2_Snt2p_like', 4989),
(4990, 'cd08260', NULL, 'Zn_ADH6', NULL, NULL, 'Zn_ADH6', 4990),
(4991, 'cd02911', NULL, 'arch_FMN', NULL, NULL, 'arch_FMN', 4991),
(4992, 'cd08595', NULL, 'PI-PLCc_zeta', NULL, NULL, 'PI-PLCc_zeta', 4992),
(4993, 'cd18742', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, 'PIN_VapC4-5_FitB-like', 4993),
(4994, 'cd09082', NULL, 'Deadenylase', NULL, NULL, 'Deadenylase', 4994),
(4995, 'cd15884', NULL, 'SNARE_SNAP23C', NULL, NULL, 'SNARE_SNAP23C', 4995),
(4996, 'cd04929', NULL, 'ACT_TPH', NULL, NULL, 'ACT_TPH', 4996),
(4997, 'cd18946', NULL, 'bHLH_E-protein_TCF12_HEB', NULL, NULL, 'bHLH_E-protein_TCF12_HEB', 4997),
(4998, 'cd19778', NULL, 'Bbox2_TRIM36_C-I', NULL, NULL, 'Bbox2_TRIM36_C-I', 4998),
(4999, 'cd01778', NULL, 'RA_RASSF1_like', NULL, NULL, 'RA_RASSF1_like', 4999),
(5000, 'cd03750', NULL, 'proteasome_alpha_type_2', NULL, NULL, 'proteasome_alpha_type_2', 5000),
(5001, 'cd14870', NULL, 'uS7_Mitochondria_Mammalian', NULL, NULL, 'uS7_Mitochondria_Mammalian', 5001),
(5002, 'cd15688', NULL, 'PHD1_MOZ', NULL, NULL, 'PHD1_MOZ', 5002),
(5003, 'cd17731', NULL, 'BRCT_TopBP1_rpt2_like', NULL, NULL, 'BRCT_TopBP1_rpt2_like', 5003),
(5004, 'cd06969', NULL, 'NR_DBD_NGFI-B', NULL, NULL, 'NR_DBD_NGFI-B', 5004),
(5005, 'cd12277', NULL, 'RRM3_MEI2_EAR1_like', NULL, NULL, 'RRM3_MEI2_EAR1_like', 5005),
(5006, 'cd01397', NULL, 'HAT_MBD', NULL, NULL, 'HAT_MBD', 5006),
(5007, 'cd18277', NULL, 'BTB_POZ_BACH1', NULL, NULL, 'BTB_POZ_BACH1', 5007),
(5008, 'cd15729', NULL, 'FYVE_endofin', NULL, NULL, 'FYVE_endofin', 5008),
(5009, 'cd06538', NULL, 'CIDE_N_FSP27', NULL, NULL, 'CIDE_N_FSP27', 5009),
(5010, 'cd12316', NULL, 'RRM3_RBM19_RRM2_MRD1', NULL, NULL, 'RRM3_RBM19_RRM2_MRD1', 5010),
(5011, 'cd08483', NULL, 'PBP2_HvrB', NULL, NULL, 'PBP2_HvrB', 5011),
(5012, 'cd09483', NULL, 'LIM1_Prickle_1', NULL, NULL, 'LIM1_Prickle_1', 5012),
(5013, 'cd13374', NULL, 'PH_RASAL3', NULL, NULL, 'PH_RASAL3', 5013),
(5014, 'cd21568', NULL, 'HCoV-like_M', NULL, NULL, 'HCoV-like_M', 5014),
(5015, 'cd07878', NULL, 'STKc_p38beta', NULL, NULL, 'STKc_p38beta', 5015);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(5016, 'cd09524', NULL, 'SAM_tankyrase1,2', NULL, NULL, 'SAM_tankyrase1,2', 5016),
(5017, 'cd10972', NULL, 'CE4_DAC_u3_5s', NULL, NULL, 'CE4_DAC_u3_5s', 5017),
(5018, 'cd12893', NULL, 'SPRY_PRY_TRIM35', NULL, NULL, 'SPRY_PRY_TRIM35', 5018),
(5019, 'cd03207', NULL, 'GST_C_8', NULL, NULL, 'GST_C_8', 5019),
(5020, 'cd17901', NULL, 'ArfGap_ARAP1', NULL, NULL, 'ArfGap_ARAP1', 5020),
(5021, 'cd05257', NULL, 'Arna_like_SDR_e', NULL, NULL, 'Arna_like_SDR_e', 5021),
(5022, 'cd10050', NULL, 'Reelin_repeat_6_subrepeat_2', NULL, NULL, 'Reelin_repeat_6_subrepeat_2', 5022),
(5023, 'cd08240', NULL, '6_hydroxyhexanoate_dh_like', NULL, NULL, '6_hydroxyhexanoate_dh_like', 5023),
(5024, 'cd14555', NULL, 'R-PTPc-typeIIb-1', NULL, NULL, 'R-PTPc-typeIIb-1', 5024),
(5025, 'cd15507', NULL, 'PHD2_KMT2A_like', NULL, NULL, 'PHD2_KMT2A_like', 5025),
(5026, 'cd14081', NULL, 'STKc_BRSK1_2', NULL, NULL, 'STKc_BRSK1_2', 5026),
(5027, 'cd00947', NULL, 'TBP_aldolase_IIB', NULL, NULL, 'TBP_aldolase_IIB', 5027),
(5028, 'cd19466', NULL, 'FABP3', NULL, NULL, 'FABP3', 5028),
(5029, 'cd05127', NULL, 'RasGAP_IQGAP_like', NULL, NULL, 'RasGAP_IQGAP_like', 5029),
(5030, 'cd00501', NULL, 'Peptidase_C15', NULL, NULL, 'Peptidase_C15', 5030),
(5031, 'cd13172', NULL, 'RanBD2_RanBP2_insect-like', NULL, NULL, 'RanBD2_RanBP2_insect-like', 5031),
(5032, 'cd06356', NULL, 'PBP1_amide_urea_BP-like', NULL, NULL, 'PBP1_amide_urea_BP-like', 5032),
(5033, 'cd04893', NULL, 'ACT_GcvR_1', NULL, NULL, 'ACT_GcvR_1', 5033),
(5034, 'cd13849', NULL, 'CuRO_1_LCC_plant', NULL, NULL, 'CuRO_1_LCC_plant', 5034),
(5035, 'cd08901', NULL, 'SRPBCC_CalC_Aha1-like_8', NULL, NULL, 'SRPBCC_CalC_Aha1-like_8', 5035),
(5036, 'cd13217', NULL, 'PH-GRAM1_TCB1D8_TCB1D9_family', NULL, NULL, 'PH-GRAM1_TCB1D8_TCB1D9_family', 5036),
(5037, 'cd01586', NULL, 'AcnA_IRP', NULL, NULL, 'AcnA_IRP', 5037),
(5038, 'cd11687', NULL, 'PpPFK_gamma', NULL, NULL, 'PpPFK_gamma', 5038),
(5039, 'cd17484', NULL, 'MFS_FBT', NULL, NULL, 'MFS_FBT', 5039),
(5040, 'cd02085', NULL, 'P-type_ATPase_SPCA', NULL, NULL, 'P-type_ATPase_SPCA', 5040),
(5041, 'cd08692', NULL, 'C2B_Tac2-N', NULL, NULL, 'C2B_Tac2-N', 5041),
(5042, 'cd10482', NULL, 'EphR_LBD_A4', NULL, NULL, 'EphR_LBD_A4', 5042),
(5043, 'cd17384', NULL, 'MFS_SLC18A1_2_VAT1_2', NULL, NULL, 'MFS_SLC18A1_2_VAT1_2', 5043),
(5044, 'cd05660', NULL, 'M28_like_PA', NULL, NULL, 'M28_like_PA', 5044),
(5045, 'cd05895', NULL, 'Ig_Pro_neuregulin-1', NULL, NULL, 'Ig_Pro_neuregulin-1', 5045),
(5046, 'cd13189', NULL, 'FERM_C_PTPN4_PTPN3_like', NULL, NULL, 'FERM_C_PTPN4_PTPN3_like', 5046),
(5047, 'cd15538', NULL, 'PHD_PRKCBP1', NULL, NULL, 'PHD_PRKCBP1', 5047),
(5048, 'cd16241', NULL, 'EFh_SPARC_SMOC2', NULL, NULL, 'EFh_SPARC_SMOC2', 5048),
(5049, 'cd16479', NULL, 'RING-H2_synoviolin', NULL, NULL, 'RING-H2_synoviolin', 5049),
(5050, 'cd07796', NULL, 'FGGY_NHO1_plant', NULL, NULL, 'FGGY_NHO1_plant', 5050),
(5051, 'cd15903', NULL, 'Dicer_PBD', NULL, NULL, 'Dicer_PBD', 5051),
(5052, 'cd11913', NULL, 'SH3_BAIAP2L1', NULL, NULL, 'SH3_BAIAP2L1', 5052),
(5053, 'cd21344', NULL, '1B_UPF1_nv_SF1_Hel-like', NULL, NULL, '1B_UPF1_nv_SF1_Hel-like', 5053),
(5054, 'cd19602', NULL, 'serpin_mollusks', NULL, NULL, 'serpin_mollusks', 5054),
(5055, 'cd19470', NULL, 'FABP7', NULL, NULL, 'FABP7', 5055),
(5056, 'cd12936', NULL, 'GUCT_RHII_Gualpha_beta', NULL, NULL, 'GUCT_RHII_Gualpha_beta', 5056),
(5057, 'cd02046', NULL, 'serpinH1_CBP1', NULL, NULL, 'serpinH1_CBP1', 5057),
(5058, 'cd05089', NULL, 'PTKc_Tie1', NULL, NULL, 'PTKc_Tie1', 5058),
(5059, 'cd19455', NULL, 'lipocalin_NP1', NULL, NULL, 'lipocalin_NP1', 5059),
(5060, 'cd00838', NULL, 'MPP_superfamily', NULL, NULL, 'MPP_superfamily', 5060),
(5061, 'cd07491', NULL, 'Peptidases_S8_7', NULL, NULL, 'Peptidases_S8_7', 5061),
(5062, 'cd08957', NULL, 'WbmH_like_SDR_e', NULL, NULL, 'WbmH_like_SDR_e', 5062),
(5063, 'cd09660', NULL, 'Csx1_III-U', NULL, NULL, 'Csx1_III-U', 5063),
(5064, 'cd05922', NULL, 'FACL_like_6', NULL, NULL, 'FACL_like_6', 5064),
(5065, 'cd09177', NULL, 'PLDc_RE_NgoFVII', NULL, NULL, 'PLDc_RE_NgoFVII', 5065),
(5066, 'cd03597', NULL, 'CLECT_attractin_like', NULL, NULL, 'CLECT_attractin_like', 5066);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(5067, 'cd05246', NULL, 'dTDP_GD_SDR_e', NULL, NULL, 'dTDP_GD_SDR_e', 5067),
(5068, 'cd14288', NULL, 'UBA_HUWE1', NULL, NULL, 'UBA_HUWE1', 5068),
(5069, 'cd15385', NULL, '7tmA_V1aR', NULL, NULL, '7tmA_V1aR', 5069),
(5070, 'cd06241', NULL, 'M14-like', NULL, NULL, 'M14-like', 5070),
(5071, 'cd13902', NULL, 'CuRO_3_McoC_like', NULL, NULL, 'CuRO_3_McoC_like', 5071),
(5072, 'cd19726', NULL, 'bHLH-PAS_cycle_like', NULL, NULL, 'bHLH-PAS_cycle_like', 5072),
(5073, 'cd08604', NULL, 'GDPD_SHV3_repeat_2', NULL, NULL, 'GDPD_SHV3_repeat_2', 5073),
(5074, 'cd00304', NULL, 'RT_like', NULL, NULL, 'RT_like', 5074),
(5075, 'cd16988', NULL, 'ANTH_N_YAP180', NULL, NULL, 'ANTH_N_YAP180', 5075),
(5076, 'cd17350', NULL, 'MFS_PTR2', NULL, NULL, 'MFS_PTR2', 5076),
(5077, 'cd05801', NULL, 'PGM_like3', NULL, NULL, 'PGM_like3', 5077),
(5078, 'cd06995', NULL, 'cupin_YkgD-like_N', NULL, NULL, 'cupin_YkgD-like_N', 5078),
(5079, 'cd16330', NULL, 'LolA_VioE', NULL, NULL, 'LolA_VioE', 5079),
(5080, 'cd09919', NULL, 'SH2_STAT_family', NULL, NULL, 'SH2_STAT_family', 5080),
(5081, 'cd16689', NULL, 'RING-H2_Vps18', NULL, NULL, 'RING-H2_Vps18', 5081),
(5082, 'cd05389', NULL, 'CobQ_N', NULL, NULL, 'CobQ_N', 5082),
(5083, 'cd06961', NULL, 'NR_DBD_TR', NULL, NULL, 'NR_DBD_TR', 5083),
(5084, 'cd07384', NULL, 'MPP_Cdc1_like', NULL, NULL, 'MPP_Cdc1_like', 5084),
(5085, 'cd12827', NULL, 'EcCorA_ZntB-like_u2', NULL, NULL, 'EcCorA_ZntB-like_u2', 5085),
(5086, 'cd18379', NULL, 'BTB_POZ_Kv3_KCNC', NULL, NULL, 'BTB_POZ_Kv3_KCNC', 5086),
(5087, 'cd18604', NULL, 'ABC_6TM_VMR1_D2_like', NULL, NULL, 'ABC_6TM_VMR1_D2_like', 5087),
(5088, 'cd19740', NULL, 'bHLH-PAS_dSIM_like', NULL, NULL, 'bHLH-PAS_dSIM_like', 5088),
(5089, 'cd01853', NULL, 'Toc34_like', NULL, NULL, 'Toc34_like', 5089),
(5090, 'cd18550', NULL, 'ABC_6TM_exporter_like', NULL, NULL, 'ABC_6TM_exporter_like', 5090),
(5091, 'cd07387', NULL, 'MPP_PolD2_C', NULL, NULL, 'MPP_PolD2_C', 5091),
(5092, 'cd07199', NULL, 'Pat17_PNPLA8_PNPLA9_like', NULL, NULL, 'Pat17_PNPLA8_PNPLA9_like', 5092),
(5093, 'cd16412', NULL, 'dndB', NULL, NULL, 'dndB', 5093),
(5094, 'cd00615', NULL, 'Orn_deC_like', NULL, NULL, 'Orn_deC_like', 5094),
(5095, 'cd03596', NULL, 'CLECT_tetranectin_like', NULL, NULL, 'CLECT_tetranectin_like', 5095),
(5096, 'cd18964', NULL, 'chromodomain', NULL, NULL, 'chromodomain', 5096),
(5097, 'cd13550', NULL, 'PBP2_Fbp_like_4', NULL, NULL, 'PBP2_Fbp_like_4', 5097),
(5098, 'cd15320', NULL, '7tmA_D1A_dopamine_R', NULL, NULL, '7tmA_D1A_dopamine_R', 5098),
(5099, 'cd03299', NULL, 'ABC_ModC_like', NULL, NULL, 'ABC_ModC_like', 5099),
(5100, 'cd06381', NULL, 'PBP1_iGluR_delta-like', NULL, NULL, 'PBP1_iGluR_delta-like', 5100),
(5101, 'cd00823', NULL, 'TopoIIB_Trans', NULL, NULL, 'TopoIIB_Trans', 5101),
(5102, 'cd19180', NULL, 'SET_SpSET10-like', NULL, NULL, 'SET_SpSET10-like', 5102),
(5103, 'cd01176', NULL, 'IPT_RBP-Jkappa', NULL, NULL, 'IPT_RBP-Jkappa', 5103),
(5104, 'cd17494', NULL, 'RMtype1_S_Sma198ORF994P-TRD2-CR2_like', NULL, NULL, 'RMtype1_S_Sma198ORF994P-TRD2-CR2_like', 5104),
(5105, 'cd16126', NULL, 'Ubl_HR23B', NULL, NULL, 'Ubl_HR23B', 5105),
(5106, 'cd19052', NULL, 'LGIC_TM_GABAAR_alpha', NULL, NULL, 'LGIC_TM_GABAAR_alpha', 5106),
(5107, 'cd19431', NULL, 'lipocalin_Can_f_2', NULL, NULL, 'lipocalin_Can_f_2', 5107),
(5108, 'cd13673', NULL, 'PBP2_TRAP_SBP_like_2', NULL, NULL, 'PBP2_TRAP_SBP_like_2', 5108),
(5109, 'cd09468', NULL, 'LIM1_Lhx4', NULL, NULL, 'LIM1_Lhx4', 5109),
(5110, 'cd10962', NULL, 'CE4_GT2-like', NULL, NULL, 'CE4_GT2-like', 5110),
(5111, 'cd12367', NULL, 'RRM2_RBM45', NULL, NULL, 'RRM2_RBM45', 5111),
(5112, 'cd13579', NULL, 'PBP2_Bug_NagM', NULL, NULL, 'PBP2_Bug_NagM', 5112),
(5113, 'cd04028', NULL, 'C2B_RIM1alpha', NULL, NULL, 'C2B_RIM1alpha', 5113),
(5114, 'cd12484', NULL, 'RRM1_RBM46', NULL, NULL, 'RRM1_RBM46', 5114),
(5115, 'cd05230', NULL, 'UGD_SDR_e', NULL, NULL, 'UGD_SDR_e', 5115),
(5116, 'cd07066', NULL, 'CRD_FZ', NULL, NULL, 'CRD_FZ', 5116),
(5117, 'cd11857', NULL, 'SH3_DBS', NULL, NULL, 'SH3_DBS', 5117),
(5118, 'cd18037', NULL, 'DEXSc_Pif1_like', NULL, NULL, 'DEXSc_Pif1_like', 5118);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(5119, 'cd05968', NULL, 'AACS_like', NULL, NULL, 'AACS_like', 5119),
(5120, 'cd09481', NULL, 'LIM1_CRP3', NULL, NULL, 'LIM1_CRP3', 5120),
(5121, 'cd08903', NULL, 'START_STARD5-like', NULL, NULL, 'START_STARD5-like', 5121),
(5122, 'cd15821', NULL, 'SPRY_PRY_RFPL', NULL, NULL, 'SPRY_PRY_RFPL', 5122),
(5123, 'cd00648', NULL, 'Periplasmic_Binding_Protein_Type_2', NULL, NULL, 'Periplasmic_Binding_Protein_Type_2', 5123),
(5124, 'cd03409', NULL, 'Chelatase_Class_II', NULL, NULL, 'Chelatase_Class_II', 5124),
(5125, 'cd07825', NULL, 'SRPBCC_7', NULL, NULL, 'SRPBCC_7', 5125),
(5126, 'cd01422', NULL, 'MGS', NULL, NULL, 'MGS', 5126),
(5127, 'cd09976', NULL, 'LOTUS_3_TDRD5', NULL, NULL, 'LOTUS_3_TDRD5', 5127),
(5128, 'cd13560', NULL, 'PBP2_taurine', NULL, NULL, 'PBP2_taurine', 5128),
(5129, 'cd05605', NULL, 'STKc_GRK4_like', NULL, NULL, 'STKc_GRK4_like', 5129),
(5130, 'cd08051', NULL, 'gp6_gp15_like', NULL, NULL, 'gp6_gp15_like', 5130),
(5131, 'cd08054', NULL, 'gp6', NULL, NULL, 'gp6', 5131),
(5132, 'cd07057', NULL, 'BMC_CcmK', NULL, NULL, 'BMC_CcmK', 5132),
(5133, 'cd07256', NULL, 'HPCD_C_class_II', NULL, NULL, 'HPCD_C_class_II', 5133),
(5134, 'cd08679', NULL, 'C2_DOCK180_related', NULL, NULL, 'C2_DOCK180_related', 5134),
(5135, 'cd13913', NULL, 'ba3_CcO_II_C', NULL, NULL, 'ba3_CcO_II_C', 5135),
(5136, 'cd00935', NULL, 'GlyRS_RNA', NULL, NULL, 'GlyRS_RNA', 5136),
(5137, 'cd10286', NULL, 'somatolactin', NULL, NULL, 'somatolactin', 5137),
(5138, 'cd04309', NULL, 'HAD_PSP_eu', NULL, NULL, 'HAD_PSP_eu', 5138),
(5139, 'cd09977', NULL, 'LOTUS_1_Limkain_b1', NULL, NULL, 'LOTUS_1_Limkain_b1', 5139),
(5140, 'cd06873', NULL, 'PX_SNX13', NULL, NULL, 'PX_SNX13', 5140),
(5141, 'cd19444', NULL, 'FABP1', NULL, NULL, 'FABP1', 5141),
(5142, 'cd07664', NULL, 'BAR_SNX2', NULL, NULL, 'BAR_SNX2', 5142),
(5143, 'cd12520', NULL, 'RRM1_MRN1', NULL, NULL, 'RRM1_MRN1', 5143),
(5144, 'cd04149', NULL, 'Arf6', NULL, NULL, 'Arf6', 5144),
(5145, 'sd00034', NULL, 'LRR_AMN1', NULL, NULL, 'LRR_AMN1', 5145),
(5146, 'cd04115', NULL, 'Rab33B_Rab33A', NULL, NULL, 'Rab33B_Rab33A', 5146),
(5147, 'cd00114', NULL, 'LIGANc', NULL, NULL, 'LIGANc', 5147),
(5148, 'cd19439', NULL, 'lipocalin_Ex-FABP-like', NULL, NULL, 'lipocalin_Ex-FABP-like', 5148),
(5149, 'cd07011', NULL, 'cupin_PMI_type_I_N', NULL, NULL, 'cupin_PMI_type_I_N', 5149),
(5150, 'cd13370', NULL, 'PH_GAP1m_mammal-like', NULL, NULL, 'PH_GAP1m_mammal-like', 5150),
(5151, 'cd07035', NULL, 'TPP_PYR_POX_like', NULL, NULL, 'TPP_PYR_POX_like', 5151),
(5152, 'cd11509', NULL, 'SLC6sbd_CT1', NULL, NULL, 'SLC6sbd_CT1', 5152),
(5153, 'cd12792', NULL, 'RasGAP_plexin_B2', NULL, NULL, 'RasGAP_plexin_B2', 5153),
(5154, 'cd01171', NULL, 'YXKO-related', NULL, NULL, 'YXKO-related', 5154),
(5155, 'cd06446', NULL, 'Trp-synth_B', NULL, NULL, 'Trp-synth_B', 5155),
(5156, 'cd19807', NULL, 'Bbox1_TRIM36-like', NULL, NULL, 'Bbox1_TRIM36-like', 5156),
(5157, 'cd13258', NULL, 'PH_PLEKHJ1', NULL, NULL, 'PH_PLEKHJ1', 5157),
(5158, 'cd13135', NULL, 'MATE_like_9', NULL, NULL, 'MATE_like_9', 5158),
(5159, 'cd07220', NULL, 'Pat_PNPLA2', NULL, NULL, 'Pat_PNPLA2', 5159),
(5160, 'cd01172', NULL, 'RfaE_like', NULL, NULL, 'RfaE_like', 5160),
(5161, 'cd03588', NULL, 'CLECT_CSPGs', NULL, NULL, 'CLECT_CSPGs', 5161),
(5162, 'cd07172', NULL, 'NR_DBD_GR_PR', NULL, NULL, 'NR_DBD_GR_PR', 5162),
(5163, 'cd10845', NULL, 'DSRM_RNAse_III_family', NULL, NULL, 'DSRM_RNAse_III_family', 5163),
(5164, 'cd04373', NULL, 'RhoGAP_p190', NULL, NULL, 'RhoGAP_p190', 5164),
(5165, 'cd12600', NULL, 'RRM2_SRSF4_like', NULL, NULL, 'RRM2_SRSF4_like', 5165),
(5166, 'cd17676', NULL, 'SWIB_BAF60C', NULL, NULL, 'SWIB_BAF60C', 5166),
(5167, 'cd01359', NULL, 'Argininosuccinate_lyase', NULL, NULL, 'Argininosuccinate_lyase', 5167),
(5168, 'cd16081', NULL, 'TSPcc_insect', NULL, NULL, 'TSPcc_insect', 5168),
(5169, 'cd02342', NULL, 'ZZ_UBA_plant', NULL, NULL, 'ZZ_UBA_plant', 5169),
(5170, 'cd03720', NULL, 'SOCS_ASB1', NULL, NULL, 'SOCS_ASB1', 5170),
(5171, 'cd19019', NULL, 'LGIC_ECD_nAChR_A6', NULL, NULL, 'LGIC_ECD_nAChR_A6', 5171),
(5172, 'cd06084', NULL, 'KOW_Spt5_4', NULL, NULL, 'KOW_Spt5_4', 5172);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(5173, 'cd08159', NULL, 'APC10-like', NULL, NULL, 'APC10-like', 5173),
(5174, 'cd00344', NULL, 'FBP_aldolase_I', NULL, NULL, 'FBP_aldolase_I', 5174),
(5175, 'cd09665', NULL, 'Cas8a1_I-A', NULL, NULL, 'Cas8a1_I-A', 5175),
(5176, 'cd13871', NULL, 'CuRO_2_AAO', NULL, NULL, 'CuRO_2_AAO', 5176),
(5177, 'cd06389', NULL, 'PBP1_iGluR_AMPA_GluR2', NULL, NULL, 'PBP1_iGluR_AMPA_GluR2', 5177),
(5178, 'cd03115', NULL, 'SRP_G_like', NULL, NULL, 'SRP_G_like', 5178),
(5179, 'cd09462', NULL, 'LIM1_LIMK1', NULL, NULL, 'LIM1_LIMK1', 5179),
(5180, 'cd19859', NULL, 'DSRM_STAU_rpt3', NULL, NULL, 'DSRM_STAU_rpt3', 5180),
(5181, 'cd00657', NULL, 'Ferritin_like', NULL, NULL, 'Ferritin_like', 5181),
(5182, 'cd08846', NULL, 'ArfGap_GIT1', NULL, NULL, 'ArfGap_GIT1', 5182),
(5183, 'cd14908', NULL, 'MYSc_Myo47', NULL, NULL, 'MYSc_Myo47', 5183),
(5184, 'cd11691', NULL, 'HRI1_like', NULL, NULL, 'HRI1_like', 5184),
(5185, 'cd13227', NULL, 'PH-GRAM-like_Vps36', NULL, NULL, 'PH-GRAM-like_Vps36', 5185),
(5186, 'cd09927', NULL, 'SH2_Tensin_like', NULL, NULL, 'SH2_Tensin_like', 5186),
(5187, 'cd11845', NULL, 'SH3_Src_like', NULL, NULL, 'SH3_Src_like', 5187),
(5188, 'cd18361', NULL, 'BTB_POZ_KCTD1-like', NULL, NULL, 'BTB_POZ_KCTD1-like', 5188),
(5189, 'cd08308', NULL, 'Death_Tube', NULL, NULL, 'Death_Tube', 5189),
(5190, 'cd04691', NULL, 'Nudix_Hydrolase_32', NULL, NULL, 'Nudix_Hydrolase_32', 5190),
(5191, 'cd13632', NULL, 'PBP2_Aa-PDT_like', NULL, NULL, 'PBP2_Aa-PDT_like', 5191),
(5192, 'cd02040', NULL, 'NifH', NULL, NULL, 'NifH', 5192),
(5193, 'cd15442', NULL, '7tmB2_GPR97', NULL, NULL, '7tmB2_GPR97', 5193),
(5194, 'cd16773', NULL, 'RING-HC_RBR_TRIAD1', NULL, NULL, 'RING-HC_RBR_TRIAD1', 5194),
(5195, 'cd14173', NULL, 'STKc_Mnk2', NULL, NULL, 'STKc_Mnk2', 5195),
(5196, 'cd03416', NULL, 'CbiX_SirB_N', NULL, NULL, 'CbiX_SirB_N', 5196),
(5197, 'cd04922', NULL, 'ACT_AKi-HSDH-ThrA_2', NULL, NULL, 'ACT_AKi-HSDH-ThrA_2', 5197),
(5198, 'cd12673', NULL, 'RRM_BOULE', NULL, NULL, 'RRM_BOULE', 5198),
(5199, 'cd03427', NULL, 'MTH1', NULL, NULL, 'MTH1', 5199),
(5200, 'cd05615', NULL, 'STKc_cPKC_alpha', NULL, NULL, 'STKc_cPKC_alpha', 5200),
(5201, 'cd03062', NULL, 'TRX_Fd_Sucrase', NULL, NULL, 'TRX_Fd_Sucrase', 5201),
(5202, 'cd11731', NULL, 'Lin1944_like_SDR_c', NULL, NULL, 'Lin1944_like_SDR_c', 5202),
(5203, 'cd14164', NULL, 'STKc_TSSK6-like', NULL, NULL, 'STKc_TSSK6-like', 5203),
(5204, 'cd16283', NULL, 'RomA-like_MBL-fold', NULL, NULL, 'RomA-like_MBL-fold', 5204),
(5205, 'cd09281', NULL, 'UPF0066', NULL, NULL, 'UPF0066', 5205),
(5206, 'cd18995', NULL, 'LGIC_AChBP', NULL, NULL, 'LGIC_AChBP', 5206),
(5207, 'cd15566', NULL, 'PHD3_NSD', NULL, NULL, 'PHD3_NSD', 5207),
(5208, 'cd15899', NULL, 'EFh_CREC', NULL, NULL, 'EFh_CREC', 5208),
(5209, 'cd03154', NULL, 'TM4SF3_like_LEL', NULL, NULL, 'TM4SF3_like_LEL', 5209),
(5210, 'cd08762', NULL, 'Cyt_b561_CYBASC3', NULL, NULL, 'Cyt_b561_CYBASC3', 5210),
(5211, 'cd11362', NULL, 'RNase_PH_bact', NULL, NULL, 'RNase_PH_bact', 5211),
(5212, 'cd18786', NULL, 'SF1_C', NULL, NULL, 'SF1_C', 5212),
(5213, 'cd05537', NULL, 'POLBc_Pol_II', NULL, NULL, 'POLBc_Pol_II', 5213),
(5214, 'cd13191', NULL, 'FERM_C_FRMD4A_FRMD4B', NULL, NULL, 'FERM_C_FRMD4A_FRMD4B', 5214),
(5215, 'cd02669', NULL, 'Peptidase_C19M', NULL, NULL, 'Peptidase_C19M', 5215),
(5216, 'cd05579', NULL, 'STKc_MAST_like', NULL, NULL, 'STKc_MAST_like', 5216),
(5217, 'cd06581', NULL, 'TM_PBP1_LivM_like', NULL, NULL, 'TM_PBP1_LivM_like', 5217),
(5218, 'cd11965', NULL, 'SH3_ASAP1', NULL, NULL, 'SH3_ASAP1', 5218),
(5219, 'cd13972', NULL, 'UbiB', NULL, NULL, 'UbiB', 5219),
(5220, 'cd02243', NULL, 'cupin_11S_legumin_C', NULL, NULL, 'cupin_11S_legumin_C', 5220),
(5221, 'cd06150', NULL, 'YjgF_YER057c_UK114_like_2', NULL, NULL, 'YjgF_YER057c_UK114_like_2', 5221),
(5222, 'cd05478', NULL, 'pepsin_A', NULL, NULL, 'pepsin_A', 5222),
(5223, 'cd15053', NULL, '7tmA_D2-like_dopamine_R', NULL, NULL, '7tmA_D2-like_dopamine_R', 5223),
(5224, 'cd17091', NULL, 'FERM_F0_SHANK', NULL, NULL, 'FERM_F0_SHANK', 5224),
(5225, 'cd20169', NULL, 'Peptidase_M90_mtfA', NULL, NULL, 'Peptidase_M90_mtfA', 5225);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(5226, 'cd13720', NULL, 'PBP2_iGluR_NMDA_Nr3', NULL, NULL, 'PBP2_iGluR_NMDA_Nr3', 5226),
(5227, 'cd17100', NULL, 'FERM_F1_PTPN3_like', NULL, NULL, 'FERM_F1_PTPN3_like', 5227),
(5228, 'cd08373', NULL, 'C2A_Ferlin', NULL, NULL, 'C2A_Ferlin', 5228),
(5229, 'cd01355', NULL, 'AcnX', NULL, NULL, 'AcnX', 5229),
(5230, 'cd16743', NULL, 'RING-HC_RNF5', NULL, NULL, 'RING-HC_RNF5', 5230),
(5231, 'cd18389', NULL, 'BTB_POZ_KCTD2', NULL, NULL, 'BTB_POZ_KCTD2', 5231),
(5232, 'cd01466', NULL, 'vWA_C3HC4_type', NULL, NULL, 'vWA_C3HC4_type', 5232),
(5233, 'cd07679', NULL, 'F-BAR_PACSIN2', NULL, NULL, 'F-BAR_PACSIN2', 5233),
(5234, 'cd13418', NULL, 'TNFRSF19', NULL, NULL, 'TNFRSF19', 5234),
(5235, 'cd00316', NULL, 'Oxidoreductase_nitrogenase', NULL, NULL, 'Oxidoreductase_nitrogenase', 5235),
(5236, 'cd13756', NULL, 'TGF_beta_BMPs_GDFs', NULL, NULL, 'TGF_beta_BMPs_GDFs', 5236),
(5237, 'cd14134', NULL, 'PKc_CLK', NULL, NULL, 'PKc_CLK', 5237),
(5238, 'cd12513', NULL, 'RRM3_RBM12B', NULL, NULL, 'RRM3_RBM12B', 5238),
(5239, 'cd14709', NULL, 'bZIP_CREBL2', NULL, NULL, 'bZIP_CREBL2', 5239),
(5240, 'cd14560', NULL, 'PTP_tensin-1', NULL, NULL, 'PTP_tensin-1', 5240),
(5241, 'cd07546', NULL, 'P-type_ATPase_Pb_Zn_Cd2-like', NULL, NULL, 'P-type_ATPase_Pb_Zn_Cd2-like', 5241),
(5242, 'cd02150', NULL, 'nitroreductase', NULL, NULL, 'nitroreductase', 5242),
(5243, 'cd12549', NULL, 'RRM_Set1B', NULL, NULL, 'RRM_Set1B', 5243),
(5244, 'cd16538', NULL, 'RING-HC_RNF112', NULL, NULL, 'RING-HC_RNF112', 5244),
(5245, 'cd15751', NULL, 'FYVE_BSN_PCLO', NULL, NULL, 'FYVE_BSN_PCLO', 5245),
(5246, 'cd15834', NULL, 'TNFRSF1A_teleost', NULL, NULL, 'TNFRSF1A_teleost', 5246),
(5247, 'cd01025', NULL, 'TOPRIM_recR', NULL, NULL, 'TOPRIM_recR', 5247),
(5248, 'cd12008', NULL, 'SH3_Src', NULL, NULL, 'SH3_Src', 5248),
(5249, 'cd15892', NULL, 'R-SNARE_STXBP6', NULL, NULL, 'R-SNARE_STXBP6', 5249),
(5250, 'cd09380', NULL, 'LIM1_Lhx6', NULL, NULL, 'LIM1_Lhx6', 5250),
(5251, 'cd08728', NULL, 'RGS-like_2', NULL, NULL, 'RGS-like_2', 5251),
(5252, 'cd04271', NULL, 'ZnMc_ADAM_fungal', NULL, NULL, 'ZnMc_ADAM_fungal', 5252),
(5253, 'cd13218', NULL, 'PH-GRAM2_TCB1D8_TCB1D9_family', NULL, NULL, 'PH-GRAM2_TCB1D8_TCB1D9_family', 5253),
(5254, 'cd01841', NULL, 'NnaC_like', NULL, NULL, 'NnaC_like', 5254),
(5255, 'cd15525', NULL, 'PHD_UHRF1_2', NULL, NULL, 'PHD_UHRF1_2', 5255),
(5256, 'cd08704', NULL, 'Met_tRNA_FMT_C', NULL, NULL, 'Met_tRNA_FMT_C', 5256),
(5257, 'cd02238', NULL, 'cupin_KdgF', NULL, NULL, 'cupin_KdgF', 5257),
(5258, 'cd16109', NULL, 'DCX1', NULL, NULL, 'DCX1', 5258),
(5259, 'cd16860', NULL, 'ING_ING1', NULL, NULL, 'ING_ING1', 5259),
(5260, 'cd06534', NULL, 'ALDH-SF', NULL, NULL, 'ALDH-SF', 5260),
(5261, 'cd07204', NULL, 'Pat_PNPLA_like', NULL, NULL, 'Pat_PNPLA_like', 5261),
(5262, 'cd11397', NULL, 'bHLHzip_MITF_like', NULL, NULL, 'bHLHzip_MITF_like', 5262),
(5263, 'cd13264', NULL, 'PH_ITSN', NULL, NULL, 'PH_ITSN', 5263),
(5264, 'cd15592', NULL, 'PHD3_KMT2A', NULL, NULL, 'PHD3_KMT2A', 5264),
(5265, 'cd03030', NULL, 'GRX_SH3BGR', NULL, NULL, 'GRX_SH3BGR', 5265),
(5266, 'cd21652', NULL, 'ORF4b_HKU4-CoV', NULL, NULL, 'ORF4b_HKU4-CoV', 5266),
(5267, 'cd12721', NULL, 'RRM_Nup53p_fungi', NULL, NULL, 'RRM_Nup53p_fungi', 5267),
(5268, 'cd16728', NULL, 'RING2-HC_MIB2', NULL, NULL, 'RING2-HC_MIB2', 5268),
(5269, 'cd14334', NULL, 'UBA_SNF1_fungi', NULL, NULL, 'UBA_SNF1_fungi', 5269),
(5270, 'cd06640', NULL, 'STKc_MST4', NULL, NULL, 'STKc_MST4', 5270),
(5271, 'cd12461', NULL, 'RRM_SCAF4', NULL, NULL, 'RRM_SCAF4', 5271),
(5272, 'cd08444', NULL, 'PBP2_Cbl', NULL, NULL, 'PBP2_Cbl', 5272),
(5273, 'cd09837', NULL, 'CBS_pair_chlorobiales', NULL, NULL, 'CBS_pair_chlorobiales', 5273),
(5274, 'cd18689', NULL, 'PIN_VapC-like', NULL, NULL, 'PIN_VapC-like', 5274),
(5275, 'cd18242', NULL, 'BTB_POZ_KLHL12_C3IP1_DKIR', NULL, NULL, 'BTB_POZ_KLHL12_C3IP1_DKIR', 5275),
(5276, 'cd01715', NULL, 'ETF_alpha', NULL, NULL, 'ETF_alpha', 5276),
(5277, 'cd12510', NULL, 'RRM1_RBM12_like', NULL, NULL, 'RRM1_RBM12_like', 5277),
(5278, 'cd00719', NULL, 'GIY-YIG_SF', NULL, NULL, 'GIY-YIG_SF', 5278);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(5279, 'cd11945', NULL, 'SH3_Endophilin_B1', NULL, NULL, 'SH3_Endophilin_B1', 5279),
(5280, 'cd05240', NULL, 'UDP_G4E_3_SDR_e', NULL, NULL, 'UDP_G4E_3_SDR_e', 5280),
(5281, 'cd02803', NULL, 'OYE_like_FMN_family', NULL, NULL, 'OYE_like_FMN_family', 5281),
(5282, 'cd16505', NULL, 'RING-HC_CYHR1', NULL, NULL, 'RING-HC_CYHR1', 5282),
(5283, 'cd15558', NULL, 'PHD_Hop1p_like', NULL, NULL, 'PHD_Hop1p_like', 5283),
(5284, 'cd14113', NULL, 'STKc_Trio_C', NULL, NULL, 'STKc_Trio_C', 5284),
(5285, 'cd12189', NULL, 'LKR_SDH_like', NULL, NULL, 'LKR_SDH_like', 5285),
(5286, 'cd17063', NULL, 'Ubl_ANKRD60', NULL, NULL, 'Ubl_ANKRD60', 5286),
(5287, 'cd04789', NULL, 'HTH_Cfa', NULL, NULL, 'HTH_Cfa', 5287),
(5288, 'cd12586', NULL, 'RRM1_PSP1', NULL, NULL, 'RRM1_PSP1', 5288),
(5289, 'cd15721', NULL, 'FYVE_RUFY1_like', NULL, NULL, 'FYVE_RUFY1_like', 5289),
(5290, 'cd18523', NULL, 'BACK_BTBD2', NULL, NULL, 'BACK_BTBD2', 5290),
(5291, 'cd08467', NULL, 'PBP2_SyrM', NULL, NULL, 'PBP2_SyrM', 5291),
(5292, 'cd11359', NULL, 'AmyAc_SLC3A1', NULL, NULL, 'AmyAc_SLC3A1', 5292),
(5293, 'cd11783', NULL, 'SH3_SH3RF_3', NULL, NULL, 'SH3_SH3RF_3', 5293),
(5294, 'cd14798', NULL, 'RX-CC_like', NULL, NULL, 'RX-CC_like', 5294),
(5295, 'cd19423', NULL, 'lipocalin_LTBP1-like', NULL, NULL, 'lipocalin_LTBP1-like', 5295),
(5296, 'cd01890', NULL, 'LepA', NULL, NULL, 'LepA', 5296),
(5297, 'cd19397', NULL, 'TGF_beta_BMP7', NULL, NULL, 'TGF_beta_BMP7', 5297),
(5298, 'cd16018', NULL, 'Enpp', NULL, NULL, 'Enpp', 5298),
(5299, 'cd03581', NULL, 'NTR_Sfrp3_like', NULL, NULL, 'NTR_Sfrp3_like', 5299),
(5300, 'cd09935', NULL, 'SH2_ABL', NULL, NULL, 'SH2_ABL', 5300),
(5301, 'cd04879', NULL, 'ACT_3PGDH-like', NULL, NULL, 'ACT_3PGDH-like', 5301),
(5302, 'cd01291', NULL, 'PseudoU_synth', NULL, NULL, 'PseudoU_synth', 5302),
(5303, 'cd07155', NULL, 'NR_DBD_ER_like', NULL, NULL, 'NR_DBD_ER_like', 5303),
(5304, 'cd06608', NULL, 'STKc_myosinIII_N_like', NULL, NULL, 'STKc_myosinIII_N_like', 5304),
(5305, 'cd19944', NULL, 'NirB_Fer2_BFD-like_2', NULL, NULL, 'NirB_Fer2_BFD-like_2', 5305),
(5306, 'cd09485', NULL, 'LIM_Eplin_alpha_beta', NULL, NULL, 'LIM_Eplin_alpha_beta', 5306),
(5307, 'cd09332', NULL, 'LIM2_PINCH', NULL, NULL, 'LIM2_PINCH', 5307),
(5308, 'cd17635', NULL, 'FADD10', NULL, NULL, 'FADD10', 5308),
(5309, 'cd13703', NULL, 'PBP2_HisJ_LAO', NULL, NULL, 'PBP2_HisJ_LAO', 5309),
(5310, 'cd06342', NULL, 'PBP1_ABC_LIVBP-like', NULL, NULL, 'PBP1_ABC_LIVBP-like', 5310),
(5311, 'cd15401', NULL, '7tmA_Mel1C', NULL, NULL, '7tmA_Mel1C', 5311),
(5312, 'cd18510', NULL, 'BACK_KLHL4', NULL, NULL, 'BACK_KLHL4', 5312),
(5313, 'cd02970', NULL, 'PRX_like2', NULL, NULL, 'PRX_like2', 5313),
(5314, 'cd08339', NULL, 'DED_DEDD-like', NULL, NULL, 'DED_DEDD-like', 5314),
(5315, 'cd13981', NULL, 'STKc_Bub1_BubR1', NULL, NULL, 'STKc_Bub1_BubR1', 5315),
(5316, 'cd16872', NULL, 'ARID_HMGB9-like', NULL, NULL, 'ARID_HMGB9-like', 5316),
(5317, 'cd04442', NULL, 'DEP_1_DEP6', NULL, NULL, 'DEP_1_DEP6', 5317),
(5318, 'cd13922', NULL, 'Azurin', NULL, NULL, 'Azurin', 5318),
(5319, 'cd05099', NULL, 'PTKc_FGFR4', NULL, NULL, 'PTKc_FGFR4', 5319),
(5320, 'cd08766', NULL, 'Cyt_b561_ACYB-1_like', NULL, NULL, 'Cyt_b561_ACYB-1_like', 5320),
(5321, 'cd11707', NULL, 'DHR2_DOCK1', NULL, NULL, 'DHR2_DOCK1', 5321),
(5322, 'cd17754', NULL, 'MCM3', NULL, NULL, 'MCM3', 5322),
(5323, 'cd14169', NULL, 'STKc_CaMKI_beta', NULL, NULL, 'STKc_CaMKI_beta', 5323),
(5324, 'cd02018', NULL, 'TPP_PFOR', NULL, NULL, 'TPP_PFOR', 5324),
(5325, 'cd09893', NULL, 'NGN_SP_TaA', NULL, NULL, 'NGN_SP_TaA', 5325),
(5326, 'cd02769', NULL, 'MopB_DMSOR-BSOR-TMAOR', NULL, NULL, 'MopB_DMSOR-BSOR-TMAOR', 5326),
(5327, 'cd08259', NULL, 'Zn_ADH5', NULL, NULL, 'Zn_ADH5', 5327),
(5328, 'cd14482', NULL, 'SPX_BAH1-like', NULL, NULL, 'SPX_BAH1-like', 5328),
(5329, 'cd16131', NULL, 'RA_Rin2', NULL, NULL, 'RA_Rin2', 5329),
(5330, 'sd00018', NULL, 'ZF_C2H2', NULL, NULL, 'ZF_C2H2', 5330),
(5331, 'cd05251', NULL, 'NmrA_like_SDR_a', NULL, NULL, 'NmrA_like_SDR_a', 5331),
(5332, 'cd11263', NULL, 'Sema_5A', NULL, NULL, 'Sema_5A', 5332),
(5333, 'cd12347', NULL, 'RRM_PPIE', NULL, NULL, 'RRM_PPIE', 5333);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(5334, 'cd09503', NULL, 'SAM_tumor-p63,p73', NULL, NULL, 'SAM_tumor-p63,p73', 5334),
(5335, 'cd12564', NULL, 'RRM1_RBM19', NULL, NULL, 'RRM1_RBM19', 5335),
(5336, 'cd01809', NULL, 'Ubl_BAG6', NULL, NULL, 'Ubl_BAG6', 5336),
(5337, 'cd13549', NULL, 'PBP2_Fbp_like_3', NULL, NULL, 'PBP2_Fbp_like_3', 5337),
(5338, 'cd17380', NULL, 'MFS_SLC17A9_like', NULL, NULL, 'MFS_SLC17A9_like', 5338),
(5339, 'cd08283', NULL, 'FDH_like_1', NULL, NULL, 'FDH_like_1', 5339),
(5340, 'cd12063', NULL, 'SH3_Caskin2', NULL, NULL, 'SH3_Caskin2', 5340),
(5341, 'cd02968', NULL, 'SCO', NULL, NULL, 'SCO', 5341),
(5342, 'cd00688', NULL, 'ISOPREN_C2_like', NULL, NULL, 'ISOPREN_C2_like', 5342),
(5343, 'cd12058', NULL, 'SH3_MLK4', NULL, NULL, 'SH3_MLK4', 5343),
(5344, 'cd09381', NULL, 'LIM1_Lhx7_Lhx8', NULL, NULL, 'LIM1_Lhx7_Lhx8', 5344),
(5345, 'cd00128', NULL, 'PIN_FEN1_EXO1-like', NULL, NULL, 'PIN_FEN1_EXO1-like', 5345),
(5346, 'cd17393', NULL, 'MFS_MosC_like', NULL, NULL, 'MFS_MosC_like', 5346),
(5347, 'cd17105', NULL, 'FERM_F1_EPB41', NULL, NULL, 'FERM_F1_EPB41', 5347),
(5348, 'cd17185', NULL, 'FERM_F1_KIND3', NULL, NULL, 'FERM_F1_KIND3', 5348),
(5349, 'cd16874', NULL, 'ARID_KDM5B', NULL, NULL, 'ARID_KDM5B', 5349),
(5350, 'cd18578', NULL, 'ABC_6TM_Pgp_ABCB1_D2_like', NULL, NULL, 'ABC_6TM_Pgp_ABCB1_D2_like', 5350),
(5351, 'cd18541', NULL, 'ABC_6TM_TmrB_like', NULL, NULL, 'ABC_6TM_TmrB_like', 5351),
(5352, 'cd08977', NULL, 'SusD', NULL, NULL, 'SusD', 5352),
(5353, 'cd17206', NULL, 'FERM_F1_Myosin-X', NULL, NULL, 'FERM_F1_Myosin-X', 5353),
(5354, 'cd09472', NULL, 'LIM2_Lhx3b', NULL, NULL, 'LIM2_Lhx3b', 5354),
(5355, 'cd07117', NULL, 'ALDH_StaphAldA1', NULL, NULL, 'ALDH_StaphAldA1', 5355),
(5356, 'cd13666', NULL, 'PBP2_TRAP_DctP_like_1', NULL, NULL, 'PBP2_TRAP_DctP_like_1', 5356),
(5357, 'cd13730', NULL, 'PBP2_iGluR_delta_1', NULL, NULL, 'PBP2_iGluR_delta_1', 5357),
(5358, 'cd16317', NULL, 'IND_MBL-B1', NULL, NULL, 'IND_MBL-B1', 5358),
(5359, 'cd02051', NULL, 'serpinE1_PAI-1', NULL, NULL, 'serpinE1_PAI-1', 5359),
(5360, 'cd13415', NULL, 'TNFRSF13B', NULL, NULL, 'TNFRSF13B', 5360),
(5361, 'cd10968', NULL, 'CE4_Mlr8448_like_5s', NULL, NULL, 'CE4_Mlr8448_like_5s', 5361),
(5362, 'cd16895', NULL, 'TraH-like', NULL, NULL, 'TraH-like', 5362),
(5363, 'cd16596', NULL, 'RING-HC_TRIM21_C-IV', NULL, NULL, 'RING-HC_TRIM21_C-IV', 5363),
(5364, 'cd17337', NULL, 'MFS_CsbX', NULL, NULL, 'MFS_CsbX', 5364),
(5365, 'cd19928', NULL, 'REC_RcNtrC-like', NULL, NULL, 'REC_RcNtrC-like', 5365),
(5366, 'cd05327', NULL, 'retinol-DH_like_SDR_c_like', NULL, NULL, 'retinol-DH_like_SDR_c_like', 5366),
(5367, 'cd03424', NULL, 'ADPRase_NUDT5', NULL, NULL, 'ADPRase_NUDT5', 5367),
(5368, 'cd17373', NULL, 'MFS_SLC22A17_like', NULL, NULL, 'MFS_SLC22A17_like', 5368),
(5369, 'cd00198', NULL, 'vWFA', NULL, NULL, 'vWFA', 5369),
(5370, 'cd14739', NULL, 'PAAR_3', NULL, NULL, 'PAAR_3', 5370),
(5371, 'cd19117', NULL, 'AKR_AKR3A1-2', NULL, NULL, 'AKR_AKR3A1-2', 5371),
(5372, 'cd10981', NULL, 'ZnPC_S1P1', NULL, NULL, 'ZnPC_S1P1', 5372),
(5373, 'cd05096', NULL, 'PTKc_DDR1', NULL, NULL, 'PTKc_DDR1', 5373),
(5374, 'cd04375', NULL, 'RhoGAP_DLC1', NULL, NULL, 'RhoGAP_DLC1', 5374),
(5375, 'cd00733', NULL, 'GlyRS_alpha_core', NULL, NULL, 'GlyRS_alpha_core', 5375),
(5376, 'cd04454', NULL, 'S1_Rrp4_like', NULL, NULL, 'S1_Rrp4_like', 5376),
(5377, 'cd17371', NULL, 'MFS_MucK', NULL, NULL, 'MFS_MucK', 5377),
(5378, 'cd16074', NULL, 'OCRE', NULL, NULL, 'OCRE', 5378),
(5379, 'cd16594', NULL, 'RING-HC_TRIM11_like_C-IV', NULL, NULL, 'RING-HC_TRIM11_like_C-IV', 5379),
(5380, 'cd15668', NULL, 'ePHD_RAI1_like', NULL, NULL, 'ePHD_RAI1_like', 5380),
(5381, 'cd19894', NULL, 'DSRM_STRBP-like_rpt1', NULL, NULL, 'DSRM_STRBP-like_rpt1', 5381),
(5382, 'cd04093', NULL, 'HBS1_C_III', NULL, NULL, 'HBS1_C_III', 5382),
(5383, 'cd02646', NULL, 'R3H_G-patch', NULL, NULL, 'R3H_G-patch', 5383),
(5384, 'cd09836', NULL, 'CBS_pair_arch', NULL, NULL, 'CBS_pair_arch', 5384),
(5385, 'cd00741', NULL, 'Lipase', NULL, NULL, 'Lipase', 5385),
(5386, 'cd15334', NULL, '7tmA_5-HT1F', NULL, NULL, '7tmA_5-HT1F', 5386),
(5387, 'cd15348', NULL, '7tmA_S1PR5_Edg8', NULL, NULL, '7tmA_S1PR5_Edg8', 5387);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(5388, 'cd19204', NULL, 'SET_SETD1A', NULL, NULL, 'SET_SETD1A', 5388),
(5389, 'cd14410', NULL, 'UBA_SIK3', NULL, NULL, 'UBA_SIK3', 5389),
(5390, 'sd00043', NULL, 'ARM', NULL, NULL, 'ARM', 5390),
(5391, 'cd05603', NULL, 'STKc_SGK2', NULL, NULL, 'STKc_SGK2', 5391),
(5392, 'cd06523', NULL, 'GH25_PlyB-like', NULL, NULL, 'GH25_PlyB-like', 5392),
(5393, 'cd06095', NULL, 'RP_RTVL_H_like', NULL, NULL, 'RP_RTVL_H_like', 5393),
(5394, 'cd04682', NULL, 'Nudix_Hydrolase_23', NULL, NULL, 'Nudix_Hydrolase_23', 5394),
(5395, 'cd16849', NULL, 'STAT5_DBD', NULL, NULL, 'STAT5_DBD', 5395),
(5396, 'cd11286', NULL, 'ADF_cofilin_like', NULL, NULL, 'ADF_cofilin_like', 5396),
(5397, 'cd16744', NULL, 'RING-HC_RNF185', NULL, NULL, 'RING-HC_RNF185', 5397),
(5398, 'cd13355', NULL, 'PH-GRAM_MTM1', NULL, NULL, 'PH-GRAM_MTM1', 5398),
(5399, 'cd06390', NULL, 'PBP1_iGluR_AMPA_GluR1', NULL, NULL, 'PBP1_iGluR_AMPA_GluR1', 5399),
(5400, 'cd07571', NULL, 'ALP_N-acyl_transferase', NULL, NULL, 'ALP_N-acyl_transferase', 5400),
(5401, 'cd19910', NULL, 'DSRM_ILF3_rpt1', NULL, NULL, 'DSRM_ILF3_rpt1', 5401),
(5402, 'cd14021', NULL, 'ChoK-like_euk', NULL, NULL, 'ChoK-like_euk', 5402),
(5403, 'cd02810', NULL, 'DHOD_DHPD_FMN', NULL, NULL, 'DHOD_DHPD_FMN', 5403),
(5404, 'cd00569', NULL, 'HTH_Hin_like', NULL, NULL, 'HTH_Hin_like', 5404),
(5405, 'cd18705', NULL, 'PIN_VapC-like', NULL, NULL, 'PIN_VapC-like', 5405),
(5406, 'cd15489', NULL, 'PHD_SF', NULL, NULL, 'PHD_SF', 5406),
(5407, 'cd09237', NULL, 'V_ScBro1_like', NULL, NULL, 'V_ScBro1_like', 5407),
(5408, 'cd10280', NULL, 'PQQ_mGDH', NULL, NULL, 'PQQ_mGDH', 5408),
(5409, 'cd06279', NULL, 'PBP1_LacI-like', NULL, NULL, 'PBP1_LacI-like', 5409),
(5410, 'cd18823', NULL, 'GH43_RcAra43A-like', NULL, NULL, 'GH43_RcAra43A-like', 5410),
(5411, 'cd00026', NULL, 'BPI2', NULL, NULL, 'BPI2', 5411),
(5412, 'cd04978', NULL, 'Ig4_L1-NrCAM_like', NULL, NULL, 'Ig4_L1-NrCAM_like', 5412),
(5413, 'cd13121', NULL, 'BF2867_like_C', NULL, NULL, 'BF2867_like_C', 5413),
(5414, 'cd12025', NULL, 'SH3_Obscurin_like', NULL, NULL, 'SH3_Obscurin_like', 5414),
(5415, 'cd18039', NULL, 'DEXXQc_UPF1', NULL, NULL, 'DEXXQc_UPF1', 5415),
(5416, 'cd03018', NULL, 'PRX_AhpE_like', NULL, NULL, 'PRX_AhpE_like', 5416),
(5417, 'cd19683', NULL, 'bHLH_SOHLH_like', NULL, NULL, 'bHLH_SOHLH_like', 5417),
(5418, 'cd19809', NULL, 'Bbox1_TRIM45_C-X', NULL, NULL, 'Bbox1_TRIM45_C-X', 5418),
(5419, 'cd15670', NULL, 'ePHD_BRPF', NULL, NULL, 'ePHD_BRPF', 5419),
(5420, 'cd15795', NULL, 'PMEI-Pla_a_1_like', NULL, NULL, 'PMEI-Pla_a_1_like', 5420),
(5421, 'cd07095', NULL, 'ALDH_SGSD_AstD', NULL, NULL, 'ALDH_SGSD_AstD', 5421),
(5422, 'cd16274', NULL, 'PQQB-like_MBL-fold', NULL, NULL, 'PQQB-like_MBL-fold', 5422),
(5423, 'cd03537', NULL, 'Rieske_RO_Alpha_PrnD', NULL, NULL, 'Rieske_RO_Alpha_PrnD', 5423),
(5424, 'cd06367', NULL, 'PBP1_iGluR_NMDA', NULL, NULL, 'PBP1_iGluR_NMDA', 5424),
(5425, 'cd16396', NULL, 'Noc_N', NULL, NULL, 'Noc_N', 5425),
(5426, 'cd06337', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, 'PBP1_ABC_ligand_binding-like', 5426),
(5427, 'cd12805', NULL, 'Allergen_V_VI', NULL, NULL, 'Allergen_V_VI', 5427),
(5428, 'cd14229', NULL, 'STKc_HIPK3', NULL, NULL, 'STKc_HIPK3', 5428),
(5429, 'cd04372', NULL, 'RhoGAP_chimaerin', NULL, NULL, 'RhoGAP_chimaerin', 5429),
(5430, 'cd02684', NULL, 'MIT_2', NULL, NULL, 'MIT_2', 5430),
(5431, 'cd15754', NULL, 'FYVE_PKHF1', NULL, NULL, 'FYVE_PKHF1', 5431),
(5432, 'cd19338', NULL, 'Wnt_Wnt6', NULL, NULL, 'Wnt_Wnt6', 5432),
(5433, 'cd05757', NULL, 'Ig2_IL1R_like', NULL, NULL, 'Ig2_IL1R_like', 5433),
(5434, 'cd06592', NULL, 'GH31_NET37', NULL, NULL, 'GH31_NET37', 5434),
(5435, 'cd15663', NULL, 'ePHD_ATX3_4_5_like', NULL, NULL, 'ePHD_ATX3_4_5_like', 5435),
(5436, 'cd04089', NULL, 'eRF3_II', NULL, NULL, 'eRF3_II', 5436),
(5437, 'cd18229', NULL, 'BTB_POZ_ZBTB45', NULL, NULL, 'BTB_POZ_ZBTB45', 5437),
(5438, 'cd18412', NULL, 'BTB_POZ_KCNB2', NULL, NULL, 'BTB_POZ_KCNB2', 5438),
(5439, 'cd02575', NULL, 'PseudoU_synth_EcTruD', NULL, NULL, 'PseudoU_synth_EcTruD', 5439),
(5440, 'cd13160', NULL, 'PTB_LDLRAP_insect-like', NULL, NULL, 'PTB_LDLRAP_insect-like', 5440);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(5441, 'cd17670', NULL, 'R-PTP-G-2', NULL, NULL, 'R-PTP-G-2', 5441),
(5442, 'cd00196', NULL, 'Ubiquitin_like_fold', NULL, NULL, 'Ubiquitin_like_fold', 5442),
(5443, 'cd02656', NULL, 'MIT', NULL, NULL, 'MIT', 5443),
(5444, 'cd02735', NULL, 'RNAP_I_Rpa1_C', NULL, NULL, 'RNAP_I_Rpa1_C', 5444),
(5445, 'cd17368', NULL, 'MFS_CitA', NULL, NULL, 'MFS_CitA', 5445),
(5446, 'cd00527', NULL, 'IF6', NULL, NULL, 'IF6', 5446),
(5447, 'cd05188', NULL, 'MDR', NULL, NULL, 'MDR', 5447),
(5448, 'cd14037', NULL, 'STKc_NAK_like', NULL, NULL, 'STKc_NAK_like', 5448),
(5449, 'cd09478', NULL, 'LIM_CRIP', NULL, NULL, 'LIM_CRIP', 5449),
(5450, 'cd15306', NULL, '7tmA_5-HT2B', NULL, NULL, '7tmA_5-HT2B', 5450),
(5451, 'cd15373', NULL, '7tmA_P2Y2', NULL, NULL, '7tmA_P2Y2', 5451),
(5452, 'cd06332', NULL, 'PBP1_aromatic_compounds-like', NULL, NULL, 'PBP1_aromatic_compounds-like', 5452),
(5453, 'cd12431', NULL, 'RRM_ALKBH8', NULL, NULL, 'RRM_ALKBH8', 5453),
(5454, 'cd03081', NULL, 'TRX_Fd_NuoE_FDH_gamma', NULL, NULL, 'TRX_Fd_NuoE_FDH_gamma', 5454),
(5455, 'cd07022', NULL, 'S49_Sppa_36K_type', NULL, NULL, 'S49_Sppa_36K_type', 5455),
(5456, 'cd18403', NULL, 'BTB_POZ_KCNA2_KCNA3', NULL, NULL, 'BTB_POZ_KCNA2_KCNA3', 5456),
(5457, 'cd16356', NULL, 'PsjN_like', NULL, NULL, 'PsjN_like', 5457),
(5458, 'cd19401', NULL, 'TGF_beta_BMP10', NULL, NULL, 'TGF_beta_BMP10', 5458),
(5459, 'cd18292', NULL, 'BTB_POZ_BTBD17', NULL, NULL, 'BTB_POZ_BTBD17', 5459),
(5460, 'cd12676', NULL, 'RRM3_Nop4p', NULL, NULL, 'RRM3_Nop4p', 5460),
(5461, 'cd16904', NULL, 'pesticin_lyz-like', NULL, NULL, 'pesticin_lyz-like', 5461),
(5462, 'cd15709', NULL, 'ePHD_AF17', NULL, NULL, 'ePHD_AF17', 5462),
(5463, 'cd03319', NULL, 'L-Ala-DL-Glu_epimerase', NULL, NULL, 'L-Ala-DL-Glu_epimerase', 5463),
(5464, 'cd10344', NULL, 'SH2_SLAP', NULL, NULL, 'SH2_SLAP', 5464),
(5465, 'cd04494', NULL, 'BRCA2DBD_OB2', NULL, NULL, 'BRCA2DBD_OB2', 5465),
(5466, 'cd09234', NULL, 'V_HD-PTP_like', NULL, NULL, 'V_HD-PTP_like', 5466),
(5467, 'cd01855', NULL, 'YqeH', NULL, NULL, 'YqeH', 5467),
(5468, 'cd17144', NULL, 'DCX2_DCLK2', NULL, NULL, 'DCX2_DCLK2', 5468),
(5469, 'cd03822', NULL, 'GT4_mannosyltransferase-like', NULL, NULL, 'GT4_mannosyltransferase-like', 5469),
(5470, 'cd11496', NULL, 'SLC6sbd-TauT-like', NULL, NULL, 'SLC6sbd-TauT-like', 5470),
(5471, 'cd00203', NULL, 'ZnMc', NULL, NULL, 'ZnMc', 5471),
(5472, 'cd17372', NULL, 'MFS_SVOP_like', NULL, NULL, 'MFS_SVOP_like', 5472),
(5473, 'sd00035', NULL, 'LRR_NTF', NULL, NULL, 'LRR_NTF', 5473),
(5474, 'cd00065', NULL, 'FYVE_like_SF', NULL, NULL, 'FYVE_like_SF', 5474),
(5475, 'cd16269', NULL, 'GBP_C', NULL, NULL, 'GBP_C', 5475),
(5476, 'cd11480', NULL, 'SLC5sbd_u4', NULL, NULL, 'SLC5sbd_u4', 5476),
(5477, 'cd16798', NULL, 'RING-H2_RNF43', NULL, NULL, 'RING-H2_RNF43', 5477),
(5478, 'cd19158', NULL, 'AKR_KCAB2B_AKR6A1-like', NULL, NULL, 'AKR_KCAB2B_AKR6A1-like', 5478),
(5479, 'cd05391', NULL, 'RasGAP_p120GAP', NULL, NULL, 'RasGAP_p120GAP', 5479),
(5480, 'cd01104', NULL, 'HTH_MlrA-CarA', NULL, NULL, 'HTH_MlrA-CarA', 5480),
(5481, 'cd09589', NULL, 'SAM_TFCP2', NULL, NULL, 'SAM_TFCP2', 5481),
(5482, 'cd12284', NULL, 'RRM2_RBM23_RBM39', NULL, NULL, 'RRM2_RBM23_RBM39', 5482),
(5483, 'cd16132', NULL, 'RA_RASSF10', NULL, NULL, 'RA_RASSF10', 5483),
(5484, 'cd17655', NULL, 'A_NRPS_Bac', NULL, NULL, 'A_NRPS_Bac', 5484),
(5485, 'cd01725', NULL, 'LSm2', NULL, NULL, 'LSm2', 5485),
(5486, 'cd03709', NULL, 'lepA_C', NULL, NULL, 'lepA_C', 5486),
(5487, 'cd13441', NULL, 'CamS_repeat_1', NULL, NULL, 'CamS_repeat_1', 5487),
(5488, 'cd17032', NULL, 'T3SC_IA_SycT-like', NULL, NULL, 'T3SC_IA_SycT-like', 5488),
(5489, 'cd18341', NULL, 'BTB_POZ_KLHL41_KBTBD10', NULL, NULL, 'BTB_POZ_KLHL41_KBTBD10', 5489),
(5490, 'cd02198', NULL, 'YjgH_like', NULL, NULL, 'YjgH_like', 5490),
(5491, 'cd14544', NULL, 'PTPc-N11_6', NULL, NULL, 'PTPc-N11_6', 5491),
(5492, 'cd04436', NULL, 'DEP_fRgd2', NULL, NULL, 'DEP_fRgd2', 5492),
(5493, 'cd12147', NULL, 'Cep3_C', NULL, NULL, 'Cep3_C', 5493),
(5494, 'cd04731', NULL, 'HisF', NULL, NULL, 'HisF', 5494),
(5495, 'cd09173', NULL, 'PLDc_Nuc_like_unchar1_2', NULL, NULL, 'PLDc_Nuc_like_unchar1_2', 5495);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(5496, 'cd03599', NULL, 'CLECT_DGCR2_like', NULL, NULL, 'CLECT_DGCR2_like', 5496),
(5497, 'cd07443', NULL, 'CRD_SFRP1', NULL, NULL, 'CRD_SFRP1', 5497),
(5498, 'cd18961', NULL, 'CD_CEC-4_like', NULL, NULL, 'CD_CEC-4_like', 5498),
(5499, 'cd06454', NULL, 'KBL_like', NULL, NULL, 'KBL_like', 5499),
(5500, 'cd11280', NULL, 'gelsolin_like', NULL, NULL, 'gelsolin_like', 5500),
(5501, 'cd16463', NULL, 'RING-H2_PHR', NULL, NULL, 'RING-H2_PHR', 5501),
(5502, 'cd15184', NULL, '7tmA_CCR5_CCR2', NULL, NULL, '7tmA_CCR5_CCR2', 5502),
(5503, 'cd09983', NULL, 'LOTUS_7_Limkain_b1', NULL, NULL, 'LOTUS_7_Limkain_b1', 5503),
(5504, 'cd19540', NULL, 'LCL_NRPS-like', NULL, NULL, 'LCL_NRPS-like', 5504),
(5505, 'cd17421', NULL, 'MFS_MCT5', NULL, NULL, 'MFS_MCT5', 5505),
(5506, 'cd04159', NULL, 'Arl10_like', NULL, NULL, 'Arl10_like', 5506),
(5507, 'cd11984', NULL, 'SH3_Shank3', NULL, NULL, 'SH3_Shank3', 5507),
(5508, 'cd07971', NULL, 'OBF_DNA_ligase_LigD', NULL, NULL, 'OBF_DNA_ligase_LigD', 5508),
(5509, 'cd18006', NULL, 'DEXHc_CHD1L', NULL, NULL, 'DEXHc_CHD1L', 5509),
(5510, 'cd06369', NULL, 'PBP1_GC_C_enterotoxin_receptor', NULL, NULL, 'PBP1_GC_C_enterotoxin_receptor', 5510),
(5511, 'cd15182', NULL, '7tmA_XCR1', NULL, NULL, '7tmA_XCR1', 5511),
(5512, 'cd00652', NULL, 'TBP_TLF', NULL, NULL, 'TBP_TLF', 5512),
(5513, 'cd09250', NULL, 'AP-1_Mu1_Cterm', NULL, NULL, 'AP-1_Mu1_Cterm', 5513),
(5514, 'cd10288', NULL, 'prolactin_like', NULL, NULL, 'prolactin_like', 5514),
(5515, 'cd19700', NULL, 'bHLH_TS_TWIST2', NULL, NULL, 'bHLH_TS_TWIST2', 5515),
(5516, 'cd07258', NULL, 'PpCmtC_C', NULL, NULL, 'PpCmtC_C', 5516),
(5517, 'cd19536', NULL, 'DCL_NRPS-like', NULL, NULL, 'DCL_NRPS-like', 5517),
(5518, 'cd15529', NULL, 'PHD2_PHF10', NULL, NULL, 'PHD2_PHF10', 5518),
(5519, 'cd01702', NULL, 'PolY_Pol_eta', NULL, NULL, 'PolY_Pol_eta', 5519),
(5520, 'cd15382', NULL, '7tmA_AKHR', NULL, NULL, '7tmA_AKHR', 5520),
(5521, 'cd00257', NULL, 'Fascin', NULL, NULL, 'Fascin', 5521),
(5522, 'cd04448', NULL, 'DEP_PIKfyve', NULL, NULL, 'DEP_PIKfyve', 5522),
(5523, 'cd16009', NULL, 'PPM', NULL, NULL, 'PPM', 5523),
(5524, 'cd12569', NULL, 'RRM4_RBM19', NULL, NULL, 'RRM4_RBM19', 5524),
(5525, 'cd19120', NULL, 'AKR_AKR3C2-3', NULL, NULL, 'AKR_AKR3C2-3', 5525),
(5526, 'cd07313', NULL, 'terB_like_2', NULL, NULL, 'terB_like_2', 5526),
(5527, 'cd01901', NULL, 'Ntn_hydrolase', NULL, NULL, 'Ntn_hydrolase', 5527),
(5528, 'cd11567', NULL, 'YciH_like', NULL, NULL, 'YciH_like', 5528),
(5529, 'cd12475', NULL, 'RRM2_RBMS3', NULL, NULL, 'RRM2_RBMS3', 5529),
(5530, 'cd14492', NULL, 'lipocalin_MxiM-like', NULL, NULL, 'lipocalin_MxiM-like', 5530),
(5531, 'cd18920', NULL, 'bHLH-O_HEY2', NULL, NULL, 'bHLH-O_HEY2', 5531),
(5532, 'cd11293', NULL, 'gelsolin_S4_like', NULL, NULL, 'gelsolin_S4_like', 5532),
(5533, 'cd12248', NULL, 'RRM_RBM44', NULL, NULL, 'RRM_RBM44', 5533),
(5534, 'cd00596', NULL, 'Peptidase_M14_like', NULL, NULL, 'Peptidase_M14_like', 5534),
(5535, 'cd01381', NULL, 'MYSc_Myo7', NULL, NULL, 'MYSc_Myo7', 5535),
(5536, 'cd09543', NULL, 'SAM_EPH-A2', NULL, NULL, 'SAM_EPH-A2', 5536),
(5537, 'cd09738', NULL, 'Csb1_I-U', NULL, NULL, 'Csb1_I-U', 5537),
(5538, 'cd14670', NULL, 'BslA_like', NULL, NULL, 'BslA_like', 5538),
(5539, 'cd18031', NULL, 'DEXHc_UvsW', NULL, NULL, 'DEXHc_UvsW', 5539),
(5540, 'cd07828', NULL, 'lipocalin_heme-bd-THAP4-like', NULL, NULL, 'lipocalin_heme-bd-THAP4-like', 5540),
(5541, 'cd16213', NULL, 'EFh_PI-PLC21', NULL, NULL, 'EFh_PI-PLC21', 5541),
(5542, 'cd16035', NULL, 'sulfatase_like', NULL, NULL, 'sulfatase_like', 5542),
(5543, 'cd17077', NULL, 'UBX_UBXN11', NULL, NULL, 'UBX_UBXN11', 5543),
(5544, 'cd15168', NULL, '7tmA_P2Y1-like', NULL, NULL, '7tmA_P2Y1-like', 5544),
(5545, 'cd09424', NULL, 'LIM2_FHL1', NULL, NULL, 'LIM2_FHL1', 5545),
(5546, 'cd01055', NULL, 'Nonheme_Ferritin', NULL, NULL, 'Nonheme_Ferritin', 5546),
(5547, 'cd02010', NULL, 'TPP_ALS', NULL, NULL, 'TPP_ALS', 5547),
(5548, 'cd12137', NULL, 'GbX', NULL, NULL, 'GbX', 5548),
(5549, 'cd16823', NULL, 'SP-RING_ZMIZ2', NULL, NULL, 'SP-RING_ZMIZ2', 5549),
(5550, 'cd11824', NULL, 'SH3_PSTPIP1', NULL, NULL, 'SH3_PSTPIP1', 5550);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(5551, 'cd21511', NULL, 'cv-alpha_beta_Nsp2-like', NULL, NULL, 'cv-alpha_beta_Nsp2-like', 5551),
(5552, 'cd03029', NULL, 'GRX_hybridPRX5', NULL, NULL, 'GRX_hybridPRX5', 5552),
(5553, 'cd04281', NULL, 'ZnMc_BMP1_TLD', NULL, NULL, 'ZnMc_BMP1_TLD', 5553),
(5554, 'cd16282', NULL, 'metallo-hydrolase-like_MBL-fold', NULL, NULL, 'metallo-hydrolase-like_MBL-fold', 5554),
(5555, 'cd10370', NULL, 'SH2_Src_Src42', NULL, NULL, 'SH2_Src_Src42', 5555),
(5556, 'cd14813', NULL, 'bZIP_BmCbz-like', NULL, NULL, 'bZIP_BmCbz-like', 5556),
(5557, 'cd14740', NULL, 'PAAR_4', NULL, NULL, 'PAAR_4', 5557),
(5558, 'cd16454', NULL, 'RING-H2_PA-TM-RING', NULL, NULL, 'RING-H2_PA-TM-RING', 5558),
(5559, 'cd12765', NULL, 'RRM2_SRSF5', NULL, NULL, 'RRM2_SRSF5', 5559),
(5560, 'cd08754', NULL, 'RGS_LARG', NULL, NULL, 'RGS_LARG', 5560),
(5561, 'cd12772', NULL, 'RRM1_HuC', NULL, NULL, 'RRM1_HuC', 5561),
(5562, 'cd02426', NULL, 'Pol_gamma_b_Cterm', NULL, NULL, 'Pol_gamma_b_Cterm', 5562),
(5563, 'cd01429', NULL, 'ATP-synt_F1_V1_A1_AB_FliI_C', NULL, NULL, 'ATP-synt_F1_V1_A1_AB_FliI_C', 5563),
(5564, 'cd01120', NULL, 'RecA-like_NTPases', NULL, NULL, 'RecA-like_NTPases', 5564),
(5565, 'cd07464', NULL, 'CRD_FZ2', NULL, NULL, 'CRD_FZ2', 5565),
(5566, 'cd00133', NULL, 'PTS_IIB', NULL, NULL, 'PTS_IIB', 5566),
(5567, 'cd03678', NULL, 'MM_CoA_mutase_1', NULL, NULL, 'MM_CoA_mutase_1', 5567),
(5568, 'cd03340', NULL, 'TCP1_eta', NULL, NULL, 'TCP1_eta', 5568),
(5569, 'cd07061', NULL, 'HP_HAP_like', NULL, NULL, 'HP_HAP_like', 5569),
(5570, 'cd16270', NULL, 'Apc5_N', NULL, NULL, 'Apc5_N', 5570),
(5571, 'cd14825', NULL, 'TRAPPC2_sedlin', NULL, NULL, 'TRAPPC2_sedlin', 5571),
(5572, 'cd17948', NULL, 'DEADc_DDX28', NULL, NULL, 'DEADc_DDX28', 5572),
(5573, 'cd00912', NULL, 'ML', NULL, NULL, 'ML', 5573),
(5574, 'cd11479', NULL, 'SLC5sbd_u3', NULL, NULL, 'SLC5sbd_u3', 5574),
(5575, 'cd01421', NULL, 'IMPCH', NULL, NULL, 'IMPCH', 5575),
(5576, 'cd02758', NULL, 'MopB_Tetrathionate-Ra', NULL, NULL, 'MopB_Tetrathionate-Ra', 5576),
(5577, 'cd13690', NULL, 'PBP2_GluB', NULL, NULL, 'PBP2_GluB', 5577),
(5578, 'cd17539', NULL, 'psREC-like_D2_PleD', NULL, NULL, 'psREC-like_D2_PleD', 5578),
(5579, 'cd03238', NULL, 'ABC_UvrA', NULL, NULL, 'ABC_UvrA', 5579),
(5580, 'cd09347', NULL, 'LIM4_FHL', NULL, NULL, 'LIM4_FHL', 5580),
(5581, 'cd14785', NULL, 'V-ATPase_C', NULL, NULL, 'V-ATPase_C', 5581),
(5582, 'cd12837', NULL, 'EcCorA-like_u1', NULL, NULL, 'EcCorA-like_u1', 5582),
(5583, 'cd11934', NULL, 'SH3_Lasp1_C', NULL, NULL, 'SH3_Lasp1_C', 5583),
(5584, 'cd15128', NULL, '7tmA_ET_R', NULL, NULL, '7tmA_ET_R', 5584),
(5585, 'cd13259', NULL, 'PH5_ARAP', NULL, NULL, 'PH5_ARAP', 5585),
(5586, 'cd00869', NULL, 'PI3Ka_II', NULL, NULL, 'PI3Ka_II', 5586),
(5587, 'cd18713', NULL, 'PIN_VapC-like', NULL, NULL, 'PIN_VapC-like', 5587),
(5588, 'cd15944', NULL, '7tmA_OR5AR1-like', NULL, NULL, '7tmA_OR5AR1-like', 5588),
(5589, 'cd12024', NULL, 'SH3_NoxO1_2', NULL, NULL, 'SH3_NoxO1_2', 5589),
(5590, 'cd04444', NULL, 'DEP_PLEK2', NULL, NULL, 'DEP_PLEK2', 5590),
(5591, 'cd16804', NULL, 'RING-H2_RNF149', NULL, NULL, 'RING-H2_RNF149', 5591),
(5592, 'cd09122', NULL, 'PLDc_Tdp1_1', NULL, NULL, 'PLDc_Tdp1_1', 5592),
(5593, 'cd08952', NULL, 'KR_1_SDR_x', NULL, NULL, 'KR_1_SDR_x', 5593),
(5594, 'cd07179', NULL, '2DBD_NR_DBD2', NULL, NULL, '2DBD_NR_DBD2', 5594),
(5595, 'cd17537', NULL, 'REC_FixJ', NULL, NULL, 'REC_FixJ', 5595),
(5596, 'cd11245', NULL, 'Sema_plexin_B', NULL, NULL, 'Sema_plexin_B', 5596),
(5597, 'cd01994', NULL, 'Alpha_ANH_like_IV', NULL, NULL, 'Alpha_ANH_like_IV', 5597),
(5598, 'cd01416', NULL, 'SAICAR_synt_Ade5', NULL, NULL, 'SAICAR_synt_Ade5', 5598),
(5599, 'cd11582', NULL, 'Axin_TNKS_binding', NULL, NULL, 'Axin_TNKS_binding', 5599),
(5600, 'cd18605', NULL, 'ABC_6TM_MRP7_D2_like', NULL, NULL, 'ABC_6TM_MRP7_D2_like', 5600),
(5601, 'cd04443', NULL, 'DEP_GPR155', NULL, NULL, 'DEP_GPR155', 5601),
(5602, 'cd10447', NULL, 'GIY-YIG_unchar_2', NULL, NULL, 'GIY-YIG_unchar_2', 5602),
(5603, 'cd09874', NULL, 'PIN_MT3492-like', NULL, NULL, 'PIN_MT3492-like', 5603),
(5604, 'cd08864', NULL, 'SRPBCC_DUF3074', NULL, NULL, 'SRPBCC_DUF3074', 5604);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(5605, 'cd05525', NULL, 'Bromo_ASH1', NULL, NULL, 'Bromo_ASH1', 5605),
(5606, 'cd18671', NULL, 'PIN_PRORP-Zc3h12a-like', NULL, NULL, 'PIN_PRORP-Zc3h12a-like', 5606),
(5607, 'cd18074', NULL, 'DEXHc_RLR-2', NULL, NULL, 'DEXHc_RLR-2', 5607),
(5608, 'cd18476', NULL, 'BACK_KLHL38', NULL, NULL, 'BACK_KLHL38', 5608),
(5609, 'cd01716', NULL, 'Hfq', NULL, NULL, 'Hfq', 5609),
(5610, 'cd04221', NULL, 'MauL', NULL, NULL, 'MauL', 5610),
(5611, 'cd14441', NULL, 'AlgX_N', NULL, NULL, 'AlgX_N', 5611),
(5612, 'cd09203', NULL, 'PLDc_N_DEXD_b1', NULL, NULL, 'PLDc_N_DEXD_b1', 5612),
(5613, 'cd04508', NULL, 'TUDOR', NULL, NULL, 'TUDOR', 5613),
(5614, 'cd15222', NULL, '7tmA_OR51-like', NULL, NULL, '7tmA_OR51-like', 5614),
(5615, 'cd16698', NULL, 'RING_CH-C4HC3_MARCH1_like', NULL, NULL, 'RING_CH-C4HC3_MARCH1_like', 5615),
(5616, 'cd15169', NULL, '7tmA_FFAR1', NULL, NULL, '7tmA_FFAR1', 5616),
(5617, 'cd01789', NULL, 'Ubl_TBCB', NULL, NULL, 'Ubl_TBCB', 5617),
(5618, 'cd19082', NULL, 'AKR_AKR10A1_2', NULL, NULL, 'AKR_AKR10A1_2', 5618),
(5619, 'cd16207', NULL, 'EFh_ScPlc1p_like', NULL, NULL, 'EFh_ScPlc1p_like', 5619),
(5620, 'cd06140', NULL, 'DNA_polA_I_Bacillus_like_exo', NULL, NULL, 'DNA_polA_I_Bacillus_like_exo', 5620),
(5621, 'cd04251', NULL, 'AAK_NAGK-UC', NULL, NULL, 'AAK_NAGK-UC', 5621),
(5622, 'cd11681', NULL, 'HDAC_classIIa', NULL, NULL, 'HDAC_classIIa', 5622),
(5623, 'cd10804', NULL, 'YdjC_HpnK_like', NULL, NULL, 'YdjC_HpnK_like', 5623),
(5624, 'cd16930', NULL, 'HATPase_TopII-like', NULL, NULL, 'HATPase_TopII-like', 5624),
(5625, 'cd15576', NULL, 'PHD_JMJD2B', NULL, NULL, 'PHD_JMJD2B', 5625),
(5626, 'cd04926', NULL, 'ACT_ACR_4', NULL, NULL, 'ACT_ACR_4', 5626),
(5627, 'cd03388', NULL, 'PAP2_SPPase1', NULL, NULL, 'PAP2_SPPase1', 5627),
(5628, 'cd12961', NULL, 'CBM58_SusG', NULL, NULL, 'CBM58_SusG', 5628),
(5629, 'cd19157', NULL, 'AKR_AKR5G1-3', NULL, NULL, 'AKR_AKR5G1-3', 5629),
(5630, 'cd11762', NULL, 'SH3_FCHSD_2', NULL, NULL, 'SH3_FCHSD_2', 5630),
(5631, 'cd06268', NULL, 'PBP1_ABC_transporter_LIVBP-like', NULL, NULL, 'PBP1_ABC_transporter_LIVBP-like', 5631),
(5632, 'cd08310', NULL, 'Death_NFkB-like', NULL, NULL, 'Death_NFkB-like', 5632),
(5633, 'cd02796', NULL, 'tRNA_bind_bactPheRS', NULL, NULL, 'tRNA_bind_bactPheRS', 5633),
(5634, 'cd04282', NULL, 'ZnMc_meprin', NULL, NULL, 'ZnMc_meprin', 5634),
(5635, 'cd06354', NULL, 'PBP1_PrnA-like', NULL, NULL, 'PBP1_PrnA-like', 5635),
(5636, 'cd09256', NULL, 'AP_MuD_MHD', NULL, NULL, 'AP_MuD_MHD', 5636),
(5637, 'cd00142', NULL, 'PI3Kc_like', NULL, NULL, 'PI3Kc_like', 5637),
(5638, 'cd07283', NULL, 'PX_SNX30', NULL, NULL, 'PX_SNX30', 5638),
(5639, 'cd17382', NULL, 'MFS_SLC17A6_7_8_VGluT', NULL, NULL, 'MFS_SLC17A6_7_8_VGluT', 5639),
(5640, 'cd01456', NULL, 'vWA_ywmD_type', NULL, NULL, 'vWA_ywmD_type', 5640),
(5641, 'cd05091', NULL, 'PTKc_Ror2', NULL, NULL, 'PTKc_Ror2', 5641),
(5642, 'cd08735', NULL, 'RGS_AKAP2_1', NULL, NULL, 'RGS_AKAP2_1', 5642),
(5643, 'cd05513', NULL, 'Bromo_brd7_like', NULL, NULL, 'Bromo_brd7_like', 5643),
(5644, 'cd00157', NULL, 'Rho', NULL, NULL, 'Rho', 5644),
(5645, 'cd05343', NULL, 'Mgc4172-like_SDR_c', NULL, NULL, 'Mgc4172-like_SDR_c', 5645),
(5646, 'cd13597', NULL, 'PBP2_lipoprotein_Tp32', NULL, NULL, 'PBP2_lipoprotein_Tp32', 5646),
(5647, 'cd19103', NULL, 'AKR_unchar', NULL, NULL, 'AKR_unchar', 5647),
(5648, 'cd21596', NULL, 'batCoV-HKU9-like_RdRp', NULL, NULL, 'batCoV-HKU9-like_RdRp', 5648),
(5649, 'cd14621', NULL, 'R-PTPc-A-1', NULL, NULL, 'R-PTPc-A-1', 5649),
(5650, 'cd10801', NULL, 'LamB_YcsF_like_1', NULL, NULL, 'LamB_YcsF_like_1', 5650),
(5651, 'cd07081', NULL, 'ALDH_F20_ACDH_EutE-like', NULL, NULL, 'ALDH_F20_ACDH_EutE-like', 5651),
(5652, 'cd19585', NULL, 'serpin_poxvirus', NULL, NULL, 'serpin_poxvirus', 5652),
(5653, 'cd05870', NULL, 'Ig_NCAM-2', NULL, NULL, 'Ig_NCAM-2', 5653),
(5654, 'cd07836', NULL, 'STKc_Pho85', NULL, NULL, 'STKc_Pho85', 5654),
(5655, 'cd08502', NULL, 'PBP2_NikA_DppA_OppA_like_16', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_16', 5655),
(5656, 'cd15146', NULL, '7tmA_PGE2_EP3', NULL, NULL, '7tmA_PGE2_EP3', 5656),
(5657, 'cd06639', NULL, 'STKc_myosinIIIB_N', NULL, NULL, 'STKc_myosinIIIB_N', 5657);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(5658, 'cd07322', NULL, 'PriL_PriS_Eukaryotic', NULL, NULL, 'PriL_PriS_Eukaryotic', 5658),
(5659, 'cd18220', NULL, 'BTB_POZ_ZBTB34', NULL, NULL, 'BTB_POZ_ZBTB34', 5659),
(5660, 'cd00141', NULL, 'NT_POLXc', NULL, NULL, 'NT_POLXc', 5660),
(5661, 'cd01713', NULL, 'PAPS_reductase', NULL, NULL, 'PAPS_reductase', 5661),
(5662, 'cd12550', NULL, 'RRM_II_PABPN1', NULL, NULL, 'RRM_II_PABPN1', 5662),
(5663, 'cd14688', NULL, 'bZIP_YAP', NULL, NULL, 'bZIP_YAP', 5663),
(5664, 'cd17342', NULL, 'MFS_SLC37A3', NULL, NULL, 'MFS_SLC37A3', 5664),
(5665, 'cd04760', NULL, 'BAH_Dnmt1_I', NULL, NULL, 'BAH_Dnmt1_I', 5665),
(5666, 'cd07243', NULL, '2_3_CTD_C', NULL, NULL, '2_3_CTD_C', 5666),
(5667, 'cd16550', NULL, 'RING-HC_RNF168', NULL, NULL, 'RING-HC_RNF168', 5667),
(5668, 'cd10024', NULL, '14-3-3_gamma', NULL, NULL, '14-3-3_gamma', 5668),
(5669, 'cd11603', NULL, 'ThermoDBP', NULL, NULL, 'ThermoDBP', 5669),
(5670, 'cd13251', NULL, 'PH_ASAP', NULL, NULL, 'PH_ASAP', 5670),
(5671, 'cd04882', NULL, 'ACT_Bt0572_2', NULL, NULL, 'ACT_Bt0572_2', 5671),
(5672, 'cd01088', NULL, 'MetAP2', NULL, NULL, 'MetAP2', 5672),
(5673, 'cd07053', NULL, 'BMC_PduT_repeat1', NULL, NULL, 'BMC_PduT_repeat1', 5673),
(5674, 'cd06161', NULL, 'S2P-M50_SpoIVFB', NULL, NULL, 'S2P-M50_SpoIVFB', 5674),
(5675, 'cd13213', NULL, 'PH-GRAM_MTMR14', NULL, NULL, 'PH-GRAM_MTMR14', 5675),
(5676, 'cd15076', NULL, '7tmA_SWS1_opsin', NULL, NULL, '7tmA_SWS1_opsin', 5676),
(5677, 'cd04874', NULL, 'ACT_Af1403', NULL, NULL, 'ACT_Af1403', 5677),
(5678, 'cd07503', NULL, 'HAD_HisB-N', NULL, NULL, 'HAD_HisB-N', 5678),
(5679, 'cd11823', NULL, 'SH3_Nostrin', NULL, NULL, 'SH3_Nostrin', 5679),
(5680, 'cd14076', NULL, 'STKc_Kin4', NULL, NULL, 'STKc_Kin4', 5680),
(5681, 'cd08391', NULL, 'C2A_C2C_Synaptotagmin_like', NULL, NULL, 'C2A_C2C_Synaptotagmin_like', 5681),
(5682, 'cd11259', NULL, 'Sema_4D', NULL, NULL, 'Sema_4D', 5682),
(5683, 'cd08774', NULL, '14-3-3', NULL, NULL, '14-3-3', 5683),
(5684, 'cd06894', NULL, 'PX_SNX3_like', NULL, NULL, 'PX_SNX3_like', 5684),
(5685, 'cd16111', NULL, 'DCX_DCLK3', NULL, NULL, 'DCX_DCLK3', 5685),
(5686, 'cd12544', NULL, 'RRM_NMI', NULL, NULL, 'RRM_NMI', 5686),
(5687, 'cd12930', NULL, 'GAT_SF', NULL, NULL, 'GAT_SF', 5687),
(5688, 'cd17410', NULL, 'MFS_CynX_like', NULL, NULL, 'MFS_CynX_like', 5688),
(5689, 'cd15799', NULL, 'PMEI-like_4', NULL, NULL, 'PMEI-like_4', 5689),
(5690, 'cd00735', NULL, 'T4-like_lys', NULL, NULL, 'T4-like_lys', 5690),
(5691, 'cd15741', NULL, 'FYVE_FGD1_2_4', NULL, NULL, 'FYVE_FGD1_2_4', 5691),
(5692, 'cd17464', NULL, 'MFS_MCT10', NULL, NULL, 'MFS_MCT10', 5692),
(5693, 'cd08685', NULL, 'C2_RGS-like', NULL, NULL, 'C2_RGS-like', 5693),
(5694, 'cd17226', NULL, 'RA_ARAP1', NULL, NULL, 'RA_ARAP1', 5694),
(5695, 'cd16622', NULL, 'vRING-HC-C4C4_RBR_RNF217', NULL, NULL, 'vRING-HC-C4C4_RBR_RNF217', 5695),
(5696, 'cd11249', NULL, 'Sema_3A', NULL, NULL, 'Sema_3A', 5696),
(5697, 'cd09326', NULL, 'LIM_CRP_like', NULL, NULL, 'LIM_CRP_like', 5697),
(5698, 'cd18041', NULL, 'DEXXQc_DNA2', NULL, NULL, 'DEXXQc_DNA2', 5698),
(5699, 'cd17726', NULL, 'BRCT_PARP4_like', NULL, NULL, 'BRCT_PARP4_like', 5699),
(5700, 'cd00871', NULL, 'PI4Ka', NULL, NULL, 'PI4Ka', 5700),
(5701, 'cd03173', NULL, 'DUF619-like', NULL, NULL, 'DUF619-like', 5701),
(5702, 'cd09470', NULL, 'LIM1_Lhx9', NULL, NULL, 'LIM1_Lhx9', 5702),
(5703, 'cd15139', NULL, '7tmA_PGE2_EP2', NULL, NULL, '7tmA_PGE2_EP2', 5703),
(5704, 'cd19469', NULL, 'FABP8', NULL, NULL, 'FABP8', 5704),
(5705, 'cd15289', NULL, '7tmC_TAS1R1', NULL, NULL, '7tmC_TAS1R1', 5705),
(5706, 'cd05708', NULL, 'S1_Rrp5_repeat_sc12', NULL, NULL, 'S1_Rrp5_repeat_sc12', 5706),
(5707, 'cd17061', NULL, 'Ubl_IQUB', NULL, NULL, 'Ubl_IQUB', 5707),
(5708, 'cd08944', NULL, 'SDR_c12', NULL, NULL, 'SDR_c12', 5708),
(5709, 'cd14400', NULL, 'UBA_Gts1p_like', NULL, NULL, 'UBA_Gts1p_like', 5709),
(5710, 'cd07559', NULL, 'ALDH_ACDHII_AcoD-like', NULL, NULL, 'ALDH_ACDHII_AcoD-like', 5710),
(5711, 'cd18194', NULL, 'BTB_POZ_ZBTB3-like', NULL, NULL, 'BTB_POZ_ZBTB3-like', 5711),
(5712, 'cd05830', NULL, 'Sortase_E', NULL, NULL, 'Sortase_E', 5712);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(5713, 'cd16650', NULL, 'SP-RING_PIAS_like', NULL, NULL, 'SP-RING_PIAS_like', 5713),
(5714, 'cd19784', NULL, 'Bbox2_TRIM44', NULL, NULL, 'Bbox2_TRIM44', 5714),
(5715, 'cd03047', NULL, 'GST_N_2', NULL, NULL, 'GST_N_2', 5715),
(5716, 'cd16629', NULL, 'RING-HC_RBR_RNF19', NULL, NULL, 'RING-HC_RBR_RNF19', 5716),
(5717, 'cd01541', NULL, 'PBP1_AraR', NULL, NULL, 'PBP1_AraR', 5717),
(5718, 'cd17503', NULL, 'MFS_LmrB_MDR_like', NULL, NULL, 'MFS_LmrB_MDR_like', 5718),
(5719, 'cd05239', NULL, 'GDP_FS_SDR_e', NULL, NULL, 'GDP_FS_SDR_e', 5719),
(5720, 'cd14795', NULL, 'RNLA_N_2', NULL, NULL, 'RNLA_N_2', 5720),
(5721, 'cd17118', NULL, 'Ubl_HERP1', NULL, NULL, 'Ubl_HERP1', 5721),
(5722, 'cd05534', NULL, 'POLBc_zeta', NULL, NULL, 'POLBc_zeta', 5722),
(5723, 'cd09713', NULL, 'Cas8c_I-C', NULL, NULL, 'Cas8c_I-C', 5723),
(5724, 'cd11629', NULL, 'HR1_FBP17', NULL, NULL, 'HR1_FBP17', 5724),
(5725, 'cd14472', NULL, 'mltA_B_like', NULL, NULL, 'mltA_B_like', 5725),
(5726, 'cd16994', NULL, 'ENTH_Ent4', NULL, NULL, 'ENTH_Ent4', 5726),
(5727, 'cd00243', NULL, 'Lysin-Sp18', NULL, NULL, 'Lysin-Sp18', 5727),
(5728, 'cd03583', NULL, 'NTR_complement_C3', NULL, NULL, 'NTR_complement_C3', 5728),
(5729, 'cd07030', NULL, 'RNAP_D', NULL, NULL, 'RNAP_D', 5729),
(5730, 'cd13617', NULL, 'PBP2_transferrin_C', NULL, NULL, 'PBP2_transferrin_C', 5730),
(5731, 'cd01377', NULL, 'MYSc_class_II', NULL, NULL, 'MYSc_class_II', 5731),
(5732, 'cd06287', NULL, 'PBP1_LacI-like', NULL, NULL, 'PBP1_LacI-like', 5732),
(5733, 'cd04474', NULL, 'RPA1_DBD_A', NULL, NULL, 'RPA1_DBD_A', 5733),
(5734, 'cd19163', NULL, 'AKR_galDH', NULL, NULL, 'AKR_galDH', 5734),
(5735, 'cd12565', NULL, 'RRM1_MRD1', NULL, NULL, 'RRM1_MRD1', 5735),
(5736, 'cd06649', NULL, 'PKc_MEK2', NULL, NULL, 'PKc_MEK2', 5736),
(5737, 'cd01419', NULL, 'MoaC_A', NULL, NULL, 'MoaC_A', 5737),
(5738, 'cd19387', NULL, 'TGF_beta_univin', NULL, NULL, 'TGF_beta_univin', 5738),
(5739, 'cd04223', NULL, 'N2OR_C', NULL, NULL, 'N2OR_C', 5739),
(5740, 'cd07016', NULL, 'S14_ClpP_1', NULL, NULL, 'S14_ClpP_1', 5740),
(5741, 'cd11710', NULL, 'GINS_A_psf1', NULL, NULL, 'GINS_A_psf1', 5741),
(5742, 'cd07403', NULL, 'MPP_TTHA0053', NULL, NULL, 'MPP_TTHA0053', 5742),
(5743, 'cd17136', NULL, 'RBD1_RGS12', NULL, NULL, 'RBD1_RGS12', 5743),
(5744, 'cd10583', NULL, 'TNFRSF21', NULL, NULL, 'TNFRSF21', 5744),
(5745, 'cd10967', NULL, 'CE4_GLA_like_6s', NULL, NULL, 'CE4_GLA_like_6s', 5745),
(5746, 'cd00054', NULL, 'EGF_CA', NULL, NULL, 'EGF_CA', 5746),
(5747, 'cd00789', NULL, 'KU_like', NULL, NULL, 'KU_like', 5747),
(5748, 'cd14815', NULL, 'BA_2398_like', NULL, NULL, 'BA_2398_like', 5748),
(5749, 'cd14305', NULL, 'UBA_UBAC2', NULL, NULL, 'UBA_UBAC2', 5749),
(5750, 'cd03210', NULL, 'GST_C_Pi', NULL, NULL, 'GST_C_Pi', 5750),
(5751, 'cd19214', NULL, 'PR-SET_PRDM3', NULL, NULL, 'PR-SET_PRDM3', 5751),
(5752, 'cd13929', NULL, 'PT-DMATS_CymD', NULL, NULL, 'PT-DMATS_CymD', 5752),
(5753, 'cd09127', NULL, 'PLDc_unchar1_1', NULL, NULL, 'PLDc_unchar1_1', 5753),
(5754, 'cd11974', NULL, 'SH3_ASEF2', NULL, NULL, 'SH3_ASEF2', 5754),
(5755, 'cd15106', NULL, '7tmA_MrgprX-like', NULL, NULL, '7tmA_MrgprX-like', 5755),
(5756, 'cd07251', NULL, 'VOC_like', NULL, NULL, 'VOC_like', 5756),
(5757, 'cd17910', NULL, 'CheC_ClassII', NULL, NULL, 'CheC_ClassII', 5757),
(5758, 'cd19605', NULL, 'serpin_protozoa', NULL, NULL, 'serpin_protozoa', 5758),
(5759, 'cd16647', NULL, 'mRING-HC-C3HC5_NEU1', NULL, NULL, 'mRING-HC-C3HC5_NEU1', 5759),
(5760, 'cd18392', NULL, 'BTB_POZ_KCTD3', NULL, NULL, 'BTB_POZ_KCTD3', 5760),
(5761, 'cd01179', NULL, 'IPT_plexin_repeat2', NULL, NULL, 'IPT_plexin_repeat2', 5761),
(5762, 'cd04247', NULL, 'AAK_AK-Hom3', NULL, NULL, 'AAK_AK-Hom3', 5762),
(5763, 'cd01864', NULL, 'Rab19', NULL, NULL, 'Rab19', 5763),
(5764, 'cd03240', NULL, 'ABC_Rad50', NULL, NULL, 'ABC_Rad50', 5764),
(5765, 'cd00617', NULL, 'Tnase_like', NULL, NULL, 'Tnase_like', 5765),
(5766, 'cd15883', NULL, 'SNARE_syntaxin4', NULL, NULL, 'SNARE_syntaxin4', 5766),
(5767, 'cd11708', NULL, 'DHR2_DOCK5', NULL, NULL, 'DHR2_DOCK5', 5767),
(5768, 'cd15563', NULL, 'PHD3_PHF14', NULL, NULL, 'PHD3_PHF14', 5768);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(5769, 'cd19829', NULL, 'Bbox2_TIF1b_C-VI', NULL, NULL, 'Bbox2_TIF1b_C-VI', 5769),
(5770, 'cd16600', NULL, 'RING-HC_TRIM38_C-IV', NULL, NULL, 'RING-HC_TRIM38_C-IV', 5770),
(5771, 'cd18230', NULL, 'BTB_POZ_ZBTB46', NULL, NULL, 'BTB_POZ_ZBTB46', 5771),
(5772, 'cd01726', NULL, 'LSm6', NULL, NULL, 'LSm6', 5772),
(5773, 'cd04980', NULL, 'IgV_L_kappa', NULL, NULL, 'IgV_L_kappa', 5773),
(5774, 'cd12479', NULL, 'RRM2_SNF', NULL, NULL, 'RRM2_SNF', 5774),
(5775, 'cd10313', NULL, 'Deadenylase_CCR4a', NULL, NULL, 'Deadenylase_CCR4a', 5775),
(5776, 'cd00374', NULL, 'RNase_T2', NULL, NULL, 'RNase_T2', 5776),
(5777, 'cd05069', NULL, 'PTKc_Yes', NULL, NULL, 'PTKc_Yes', 5777),
(5778, 'cd02777', NULL, 'MopB_CT_DMSOR-like', NULL, NULL, 'MopB_CT_DMSOR-like', 5778),
(5779, 'cd07008', NULL, 'cupin_yp_001338853-like', NULL, NULL, 'cupin_yp_001338853-like', 5779),
(5780, 'cd09357', NULL, 'LIM3_Zyxin_like', NULL, NULL, 'LIM3_Zyxin_like', 5780),
(5781, 'cd21467', NULL, 'Ubl1_cv_Nsp3_N-like', NULL, NULL, 'Ubl1_cv_Nsp3_N-like', 5781),
(5782, 'cd00090', NULL, 'HTH_ARSR', NULL, NULL, 'HTH_ARSR', 5782),
(5783, 'cd02025', NULL, 'PanK', NULL, NULL, 'PanK', 5783),
(5784, 'cd07444', NULL, 'CRD_SFRP5', NULL, NULL, 'CRD_SFRP5', 5784),
(5785, 'cd02755', NULL, 'MopB_Thiosulfate-R-like', NULL, NULL, 'MopB_Thiosulfate-R-like', 5785),
(5786, 'cd08199', NULL, 'EEVS', NULL, NULL, 'EEVS', 5786),
(5787, 'cd00523', NULL, 'archeal_HJR', NULL, NULL, 'archeal_HJR', 5787),
(5788, 'cd02437', NULL, 'CCC1_like_1', NULL, NULL, 'CCC1_like_1', 5788),
(5789, 'cd14806', NULL, 'RAP_D1', NULL, NULL, 'RAP_D1', 5789),
(5790, 'cd03444', NULL, 'Thioesterase_II_repeat1', NULL, NULL, 'Thioesterase_II_repeat1', 5790),
(5791, 'cd01083', NULL, 'GAG_Lyase', NULL, NULL, 'GAG_Lyase', 5791),
(5792, 'cd02641', NULL, 'R3H_Smubp-2_like', NULL, NULL, 'R3H_Smubp-2_like', 5792),
(5793, 'cd05273', NULL, 'GME-like_SDR_e', NULL, NULL, 'GME-like_SDR_e', 5793),
(5794, 'cd08796', NULL, 'Death_IRAK-M', NULL, NULL, 'Death_IRAK-M', 5794),
(5795, 'cd10806', NULL, 'YdjC_like_2', NULL, NULL, 'YdjC_like_2', 5795),
(5796, 'cd02109', NULL, 'arch_bact_SO_family_Moco', NULL, NULL, 'arch_bact_SO_family_Moco', 5796),
(5797, 'cd13868', NULL, 'CuRO_2_CotA_like', NULL, NULL, 'CuRO_2_CotA_like', 5797),
(5798, 'cd07710', NULL, 'arylsulfatase_Sdsa1-like_MBL-fold', NULL, NULL, 'arylsulfatase_Sdsa1-like_MBL-fold', 5798),
(5799, 'cd10940', NULL, 'CE4_PuuE_HpPgdA_like_1', NULL, NULL, 'CE4_PuuE_HpPgdA_like_1', 5799),
(5800, 'cd17319', NULL, 'MFS_ExuT_GudP_like', NULL, NULL, 'MFS_ExuT_GudP_like', 5800),
(5801, 'cd09341', NULL, 'LIM2_Testin_like', NULL, NULL, 'LIM2_Testin_like', 5801),
(5802, 'cd07562', NULL, 'Peptidase_S41_TRI', NULL, NULL, 'Peptidase_S41_TRI', 5802),
(5803, 'cd01578', NULL, 'AcnA_Mitochon_Swivel', NULL, NULL, 'AcnA_Mitochon_Swivel', 5803),
(5804, 'cd11315', NULL, 'AmyAc_bac1_AmyA', NULL, NULL, 'AmyAc_bac1_AmyA', 5804),
(5805, 'cd17292', NULL, 'RMtype1_S_LlaA17I_TRD2-CR2_like', NULL, NULL, 'RMtype1_S_LlaA17I_TRD2-CR2_like', 5805),
(5806, 'cd17411', NULL, 'MFS_SLC15A2', NULL, NULL, 'MFS_SLC15A2', 5806),
(5807, 'cd16191', NULL, 'EFh_PEF_CAPN8', NULL, NULL, 'EFh_PEF_CAPN8', 5807),
(5808, 'cd13408', NULL, 'TNFRSF7', NULL, NULL, 'TNFRSF7', 5808),
(5809, 'cd18376', NULL, 'BTB_POZ_FIP2-like', NULL, NULL, 'BTB_POZ_FIP2-like', 5809),
(5810, 'cd01118', NULL, 'ArsB_permease', NULL, NULL, 'ArsB_permease', 5810),
(5811, 'cd12696', NULL, 'RRM3_PTBP2', NULL, NULL, 'RRM3_PTBP2', 5811),
(5812, 'cd16700', NULL, 'RING_CH-C4HC3_MARCH4_like', NULL, NULL, 'RING_CH-C4HC3_MARCH4_like', 5812),
(5813, 'cd09603', NULL, 'M1_APN_like', NULL, NULL, 'M1_APN_like', 5813),
(5814, 'cd02077', NULL, 'P-type_ATPase_Mg', NULL, NULL, 'P-type_ATPase_Mg', 5814),
(5815, 'cd14276', NULL, 'UBA_UBP25_like', NULL, NULL, 'UBA_UBP25_like', 5815),
(5816, 'cd21536', NULL, 'SARS-CoV-2_E', NULL, NULL, 'SARS-CoV-2_E', 5816),
(5817, 'cd15543', NULL, 'PHD_RSF1', NULL, NULL, 'PHD_RSF1', 5817),
(5818, 'cd03452', NULL, 'MaoC_C', NULL, NULL, 'MaoC_C', 5818),
(5819, 'cd01532', NULL, '4RHOD_Repeat_1', NULL, NULL, '4RHOD_Repeat_1', 5819),
(5820, 'cd09566', NULL, 'SAM_liprin-beta1,2_repeat2', NULL, NULL, 'SAM_liprin-beta1,2_repeat2', 5820);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(5821, 'cd19935', NULL, 'REC_OmpR_CusR-like', NULL, NULL, 'REC_OmpR_CusR-like', 5821),
(5822, 'cd01893', NULL, 'Miro1', NULL, NULL, 'Miro1', 5822),
(5823, 'cd05512', NULL, 'Bromo_brd1_like', NULL, NULL, 'Bromo_brd1_like', 5823),
(5824, 'cd03281', NULL, 'ABC_MSH5_euk', NULL, NULL, 'ABC_MSH5_euk', 5824),
(5825, 'cd05077', NULL, 'PTK_Jak1_rpt1', NULL, NULL, 'PTK_Jak1_rpt1', 5825),
(5826, 'cd13911', NULL, 'CuRO_3_MCO_like_5', NULL, NULL, 'CuRO_3_MCO_like_5', 5826),
(5827, 'cd08930', NULL, 'SDR_c8', NULL, NULL, 'SDR_c8', 5827),
(5828, 'cd16300', NULL, 'NDM_FIM-like_MBL-B1', NULL, NULL, 'NDM_FIM-like_MBL-B1', 5828),
(5829, 'cd17769', NULL, 'NP_TgUP-like', NULL, NULL, 'NP_TgUP-like', 5829),
(5830, 'cd02203', NULL, 'PurL_repeat1', NULL, NULL, 'PurL_repeat1', 5830),
(5831, 'cd02659', NULL, 'peptidase_C19C', NULL, NULL, 'peptidase_C19C', 5831),
(5832, 'cd20270', NULL, 'Complex1_LYR_SDHAF3_LYRM10', NULL, NULL, 'Complex1_LYR_SDHAF3_LYRM10', 5832),
(5833, 'cd02675', NULL, 'Ephrin_ectodomain', NULL, NULL, 'Ephrin_ectodomain', 5833),
(5834, 'cd09630', NULL, 'CDH_like_cytochrome', NULL, NULL, 'CDH_like_cytochrome', 5834),
(5835, 'cd17654', NULL, 'A_NRPS_acs4', NULL, NULL, 'A_NRPS_acs4', 5835),
(5836, 'cd06941', NULL, 'NR_LBD_DmE78_like', NULL, NULL, 'NR_LBD_DmE78_like', 5836),
(5837, 'cd12963', NULL, 'X45_BaPul_like', NULL, NULL, 'X45_BaPul_like', 5837),
(5838, 'cd12730', NULL, 'RRM1_GRSF1', NULL, NULL, 'RRM1_GRSF1', 5838),
(5839, 'cd04267', NULL, 'ZnMc_ADAM_like', NULL, NULL, 'ZnMc_ADAM_like', 5839),
(5840, 'cd20313', NULL, 'DSRM_DND1', NULL, NULL, 'DSRM_DND1', 5840),
(5841, 'cd08961', NULL, 'GH64-TLP-SF', NULL, NULL, 'GH64-TLP-SF', 5841),
(5842, 'cd19160', NULL, 'AKR_KCAB3B_AKR6A9-like', NULL, NULL, 'AKR_KCAB3B_AKR6A9-like', 5842),
(5843, 'cd10810', NULL, 'GH38N_AMII_LAM_like', NULL, NULL, 'GH38N_AMII_LAM_like', 5843),
(5844, 'cd11344', NULL, 'AmyAc_GlgE_like', NULL, NULL, 'AmyAc_GlgE_like', 5844),
(5845, 'cd09714', NULL, 'Cas8c''_I-D', NULL, NULL, 'Cas8c''_I-D', 5845),
(5846, 'cd01020', NULL, 'TroA_b', NULL, NULL, 'TroA_b', 5846),
(5847, 'cd13204', NULL, 'FERM_C2_myosin_like', NULL, NULL, 'FERM_C2_myosin_like', 5847),
(5848, 'cd17772', NULL, 'CBS_pair_DHH_polyA_Pol_assoc', NULL, NULL, 'CBS_pair_DHH_polyA_Pol_assoc', 5848),
(5849, 'cd06248', NULL, 'M14_CP_insect', NULL, NULL, 'M14_CP_insect', 5849),
(5850, 'cd10158', NULL, 'CsoR-like_DUF156_1', NULL, NULL, 'CsoR-like_DUF156_1', 5850),
(5851, 'cd14821', NULL, 'BACK_SPOP_like', NULL, NULL, 'BACK_SPOP_like', 5851),
(5852, 'cd13269', NULL, 'PH_alsin', NULL, NULL, 'PH_alsin', 5852),
(5853, 'cd11314', NULL, 'AmyAc_arch_bac_plant_AmyA', NULL, NULL, 'AmyAc_arch_bac_plant_AmyA', 5853),
(5854, 'cd04867', NULL, 'TGS_YchF_OLA1', NULL, NULL, 'TGS_YchF_OLA1', 5854),
(5855, 'cd05533', NULL, 'POLBc_delta', NULL, NULL, 'POLBc_delta', 5855),
(5856, 'cd07778', NULL, 'FGGY_L-RBK_like', NULL, NULL, 'FGGY_L-RBK_like', 5856),
(5857, 'cd13276', NULL, 'PH_AtPH1', NULL, NULL, 'PH_AtPH1', 5857),
(5858, 'cd07307', NULL, 'BAR', NULL, NULL, 'BAR', 5858),
(5859, 'cd15787', NULL, 'YycH_N', NULL, NULL, 'YycH_N', 5859),
(5860, 'cd09929', NULL, 'SH2_BLNK_SLP-76', NULL, NULL, 'SH2_BLNK_SLP-76', 5860),
(5861, 'cd12505', NULL, 'RRM2_GRSF1', NULL, NULL, 'RRM2_GRSF1', 5861),
(5862, 'cd02549', NULL, 'Peptidase_C39A', NULL, NULL, 'Peptidase_C39A', 5862),
(5863, 'cd16714', NULL, 'RING-HC_BIRC4_8', NULL, NULL, 'RING-HC_BIRC4_8', 5863),
(5864, 'cd06134', NULL, 'RNaseT', NULL, NULL, 'RNaseT', 5864),
(5865, 'cd19875', NULL, 'DSRM_EIF2AK2-like', NULL, NULL, 'DSRM_EIF2AK2-like', 5865),
(5866, 'cd19179', NULL, 'SET_RBCMT', NULL, NULL, 'SET_RBCMT', 5866),
(5867, 'cd14646', NULL, 'DSP_DUSP16', NULL, NULL, 'DSP_DUSP16', 5867),
(5868, 'cd19349', NULL, 'Wnt_Wnt7a', NULL, NULL, 'Wnt_Wnt7a', 5868),
(5869, 'cd15126', NULL, '7tmA_ETBR-LP2', NULL, NULL, '7tmA_ETBR-LP2', 5869),
(5870, 'cd09464', NULL, 'LIM2_LIMK1', NULL, NULL, 'LIM2_LIMK1', 5870),
(5871, 'cd18987', NULL, 'LGIC_ECD_anion', NULL, NULL, 'LGIC_ECD_anion', 5871),
(5872, 'cd03189', NULL, 'GST_C_GTT1_like', NULL, NULL, 'GST_C_GTT1_like', 5872),
(5873, 'cd06568', NULL, 'GH20_SpHex_like', NULL, NULL, 'GH20_SpHex_like', 5873);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(5874, 'cd07777', NULL, 'FGGY_SHK_like', NULL, NULL, 'FGGY_SHK_like', 5874),
(5875, 'cd00027', NULL, 'BRCT', NULL, NULL, 'BRCT', 5875),
(5876, 'cd13655', NULL, 'PBP2_oligosaccharide_1', NULL, NULL, 'PBP2_oligosaccharide_1', 5876),
(5877, 'cd12956', NULL, 'CBM_SusE-F_like', NULL, NULL, 'CBM_SusE-F_like', 5877),
(5878, 'cd07531', NULL, 'HAD_Pase_UmpH-like', NULL, NULL, 'HAD_Pase_UmpH-like', 5878),
(5879, 'cd02663', NULL, 'Peptidase_C19G', NULL, NULL, 'Peptidase_C19G', 5879),
(5880, 'cd04967', NULL, 'Ig1_Contactin', NULL, NULL, 'Ig1_Contactin', 5880),
(5881, 'cd08180', NULL, 'PDD', NULL, NULL, 'PDD', 5881),
(5882, 'cd18260', NULL, 'BTB_POZ_KLHL31_KBTBD1', NULL, NULL, 'BTB_POZ_KLHL31_KBTBD1', 5882),
(5883, 'cd06196', NULL, 'FNR_like_1', NULL, NULL, 'FNR_like_1', 5883),
(5884, 'cd01119', NULL, 'Chemokine_CC_DCCL', NULL, NULL, 'Chemokine_CC_DCCL', 5884),
(5885, 'cd16277', NULL, 'metallo-hydrolase-like_MBL-fold', NULL, NULL, 'metallo-hydrolase-like_MBL-fold', 5885),
(5886, 'cd04666', NULL, 'Nudix_Hydrolase_9', NULL, NULL, 'Nudix_Hydrolase_9', 5886),
(5887, 'cd08474', NULL, 'PBP2_CrgA_like_5', NULL, NULL, 'PBP2_CrgA_like_5', 5887),
(5888, 'cd08542', NULL, 'SAM_PNT-ETS-1', NULL, NULL, 'SAM_PNT-ETS-1', 5888),
(5889, 'cd09025', NULL, 'Aldose_epim_Slr1438', NULL, NULL, 'Aldose_epim_Slr1438', 5889),
(5890, 'cd12436', NULL, 'RRM1_2_MATR3_like', NULL, NULL, 'RRM1_2_MATR3_like', 5890),
(5891, 'cd17245', NULL, 'RMtype1_S_TteMORF1547P-TRD2-CR2_Aco12261I-TRD1...', NULL, NULL, 'RMtype1_S_TteMORF1547P-TRD2-CR2_Aco12261I-TRD1-CR1_like', 5891),
(5892, 'cd18477', NULL, 'BACK_KLHL40_like', NULL, NULL, 'BACK_KLHL40_like', 5892),
(5893, 'cd14476', NULL, 'SPX_PHO1_like', NULL, NULL, 'SPX_PHO1_like', 5893),
(5894, 'cd10409', NULL, 'SH2_Nck2', NULL, NULL, 'SH2_Nck2', 5894),
(5895, 'cd06563', NULL, 'GH20_chitobiase-like', NULL, NULL, 'GH20_chitobiase-like', 5895),
(5896, 'cd04939', NULL, 'PA2301', NULL, NULL, 'PA2301', 5896),
(5897, 'cd01166', NULL, 'KdgK', NULL, NULL, 'KdgK', 5897),
(5898, 'cd11996', NULL, 'SH3_Intersectin2_5', NULL, NULL, 'SH3_Intersectin2_5', 5898),
(5899, 'cd18518', NULL, 'BACK_SPOP', NULL, NULL, 'BACK_SPOP', 5899),
(5900, 'cd07885', NULL, 'RHD-n_RelA', NULL, NULL, 'RHD-n_RelA', 5900),
(5901, 'cd08057', NULL, 'MPN_euk_non_mb', NULL, NULL, 'MPN_euk_non_mb', 5901),
(5902, 'cd18252', NULL, 'BTB_POZ_KLHL23', NULL, NULL, 'BTB_POZ_KLHL23', 5902),
(5903, 'cd07818', NULL, 'SRPBCC_1', NULL, NULL, 'SRPBCC_1', 5903),
(5904, 'cd05503', NULL, 'Bromo_BAZ2A_B_like', NULL, NULL, 'Bromo_BAZ2A_B_like', 5904),
(5905, 'cd03871', NULL, 'M14_CPB', NULL, NULL, 'M14_CPB', 5905),
(5906, 'cd07873', NULL, 'STKc_PCTAIRE1', NULL, NULL, 'STKc_PCTAIRE1', 5906),
(5907, 'cd00288', NULL, 'Pyruvate_Kinase', NULL, NULL, 'Pyruvate_Kinase', 5907),
(5908, 'cd10049', NULL, 'Reelin_repeat_5_subrepeat_2', NULL, NULL, 'Reelin_repeat_5_subrepeat_2', 5908),
(5909, 'cd15158', NULL, '7tmA_CysLTR1', NULL, NULL, '7tmA_CysLTR1', 5909),
(5910, 'cd08625', NULL, 'PI-PLCc_beta3', NULL, NULL, 'PI-PLCc_beta3', 5910),
(5911, 'cd14661', NULL, 'Imelysin_like_PIBO', NULL, NULL, 'Imelysin_like_PIBO', 5911),
(5912, 'cd16733', NULL, 'RING-HC_PCGF1', NULL, NULL, 'RING-HC_PCGF1', 5912),
(5913, 'cd16228', NULL, 'EFh_CREC_Calumenin', NULL, NULL, 'EFh_CREC_Calumenin', 5913),
(5914, 'cd15429', NULL, '7tmA_OR2F-like', NULL, NULL, '7tmA_OR2F-like', 5914),
(5915, 'cd04718', NULL, 'BAH_plant_2', NULL, NULL, 'BAH_plant_2', 5915),
(5916, 'cd16027', NULL, 'SGSH', NULL, NULL, 'SGSH', 5916),
(5917, 'cd19947', NULL, 'NifU_Fer2_BFD-like', NULL, NULL, 'NifU_Fer2_BFD-like', 5917),
(5918, 'cd01462', NULL, 'VWA_YIEM_type', NULL, NULL, 'VWA_YIEM_type', 5918),
(5919, 'cd11368', NULL, 'RNase_PH_RRP45', NULL, NULL, 'RNase_PH_RRP45', 5919),
(5920, 'cd10542', NULL, 'SET_SUV39H', NULL, NULL, 'SET_SUV39H', 5920),
(5921, 'cd11943', NULL, 'SH3_JIP1', NULL, NULL, 'SH3_JIP1', 5921),
(5922, 'cd03219', NULL, 'ABC_Mj1267_LivG_branched', NULL, NULL, 'ABC_Mj1267_LivG_branched', 5922),
(5923, 'cd12090', NULL, 'MDA5_ID', NULL, NULL, 'MDA5_ID', 5923),
(5924, 'cd15812', NULL, 'SPRY_PRY_TRIM17', NULL, NULL, 'SPRY_PRY_TRIM17', 5924);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(5925, 'cd17996', NULL, 'DEXHc_SMARCA2_SMARCA4', NULL, NULL, 'DEXHc_SMARCA2_SMARCA4', 5925),
(5926, 'cd19979', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, 'PBP1_ABC_ligand_binding-like', 5926),
(5927, 'cd03420', NULL, 'SirA_RHOD_Pry_redox', NULL, NULL, 'SirA_RHOD_Pry_redox', 5927),
(5928, 'cd04902', NULL, 'ACT_3PGDH-xct', NULL, NULL, 'ACT_3PGDH-xct', 5928),
(5929, 'cd15524', NULL, 'PHD_PHF21B', NULL, NULL, 'PHD_PHF21B', 5929),
(5930, 'cd02967', NULL, 'mauD', NULL, NULL, 'mauD', 5930),
(5931, 'cd11260', NULL, 'Sema_4E', NULL, NULL, 'Sema_4E', 5931),
(5932, 'cd21648', NULL, 'SARS-CoV-like_ORF3a', NULL, NULL, 'SARS-CoV-like_ORF3a', 5932),
(5933, 'cd11564', NULL, 'FAT-like_CAS_C', NULL, NULL, 'FAT-like_CAS_C', 5933),
(5934, 'cd08659', NULL, 'M20_ArgE_DapE-like', NULL, NULL, 'M20_ArgE_DapE-like', 5934),
(5935, 'cd15789', NULL, 'PH_ARHGEF2_18_like', NULL, NULL, 'PH_ARHGEF2_18_like', 5935),
(5936, 'cd16646', NULL, 'mRING-HC-C2H2C4_MDM2_like', NULL, NULL, 'mRING-HC-C2H2C4_MDM2_like', 5936),
(5937, 'cd00028', NULL, 'B_lectin', NULL, NULL, 'B_lectin', 5937),
(5938, 'cd13344', NULL, 'PH-GRAM_MTMR7', NULL, NULL, 'PH-GRAM_MTMR7', 5938),
(5939, 'cd02874', NULL, 'GH18_CFLE_spore_hydrolase', NULL, NULL, 'GH18_CFLE_spore_hydrolase', 5939),
(5940, 'cd18297', NULL, 'BTB_POZ_ABTB2-like', NULL, NULL, 'BTB_POZ_ABTB2-like', 5940),
(5941, 'cd14748', NULL, 'PBP2_UgpB', NULL, NULL, 'PBP2_UgpB', 5941),
(5942, 'cd03412', NULL, 'CbiK_N', NULL, NULL, 'CbiK_N', 5942),
(5943, 'cd06927', NULL, 'RNAP_L', NULL, NULL, 'RNAP_L', 5943),
(5944, 'cd12050', NULL, 'SH3_DOCK2_A', NULL, NULL, 'SH3_DOCK2_A', 5944),
(5945, 'cd15323', NULL, '7tmA_alpha2C_AR', NULL, NULL, '7tmA_alpha2C_AR', 5945),
(5946, 'cd10319', NULL, 'EphR_LBD', NULL, NULL, 'EphR_LBD', 5946),
(5947, 'cd05869', NULL, 'Ig_NCAM-1', NULL, NULL, 'Ig_NCAM-1', 5947),
(5948, 'cd06349', NULL, 'PBP1_ABC_HAAT-like', NULL, NULL, 'PBP1_ABC_HAAT-like', 5948),
(5949, 'cd06265', NULL, 'RNase_A_canonical', NULL, NULL, 'RNase_A_canonical', 5949),
(5950, 'cd07230', NULL, 'Pat_TGL4-5_like', NULL, NULL, 'Pat_TGL4-5_like', 5950),
(5951, 'cd09812', NULL, '3b-HSD_like_1_SDR_e', NULL, NULL, '3b-HSD_like_1_SDR_e', 5951),
(5952, 'cd18447', NULL, 'BACK_KLHL7', NULL, NULL, 'BACK_KLHL7', 5952),
(5953, 'cd12962', NULL, 'X25_BaPul_like', NULL, NULL, 'X25_BaPul_like', 5953),
(5954, 'cd05358', NULL, 'GlcDH_SDR_c', NULL, NULL, 'GlcDH_SDR_c', 5954),
(5955, 'cd20013', NULL, 'PBP1_RPA0985_benzoate-like', NULL, NULL, 'PBP1_RPA0985_benzoate-like', 5955),
(5956, 'cd03477', NULL, 'Rieske_YhfW_C', NULL, NULL, 'Rieske_YhfW_C', 5956),
(5957, 'cd04869', NULL, 'ACT_GcvR_2', NULL, NULL, 'ACT_GcvR_2', 5957),
(5958, 'cd11918', NULL, 'SH3_Vinexin_3', NULL, NULL, 'SH3_Vinexin_3', 5958),
(5959, 'cd17313', NULL, 'MFS_SLC45_SUC', NULL, NULL, 'MFS_SLC45_SUC', 5959),
(5960, 'cd05969', NULL, 'MACS_like_4', NULL, NULL, 'MACS_like_4', 5960),
(5961, 'cd16161', NULL, 'ARSG', NULL, NULL, 'ARSG', 5961),
(5962, 'cd12801', NULL, 'HopAB_KID', NULL, NULL, 'HopAB_KID', 5962),
(5963, 'cd19053', NULL, 'LGIC_TM_GABAAR_beta', NULL, NULL, 'LGIC_TM_GABAAR_beta', 5963),
(5964, 'cd14047', NULL, 'STKc_EIF2AK2_PKR', NULL, NULL, 'STKc_EIF2AK2_PKR', 5964),
(5965, 'cd07936', NULL, 'SCAN', NULL, NULL, 'SCAN', 5965),
(5966, 'cd13858', NULL, 'CuRO_1_tcLCC2_insect_like', NULL, NULL, 'CuRO_1_tcLCC2_insect_like', 5966),
(5967, 'cd16494', NULL, 'RING-CH-C4HC3_ZSWM2', NULL, NULL, 'RING-CH-C4HC3_ZSWM2', 5967),
(5968, 'cd11768', NULL, 'SH3_Tec_like', NULL, NULL, 'SH3_Tec_like', 5968),
(5969, 'cd17429', NULL, 'MFS_MCT14', NULL, NULL, 'MFS_MCT14', 5969),
(5970, 'cd21413', NULL, 'unc_tv_SF1_Hel-like', NULL, NULL, 'unc_tv_SF1_Hel-like', 5970),
(5971, 'cd12114', NULL, 'A_NRPS_TlmIV_like', NULL, NULL, 'A_NRPS_TlmIV_like', 5971),
(5972, 'cd06476', NULL, 'ACD_HspB2_like', NULL, NULL, 'ACD_HspB2_like', 5972),
(5973, 'cd01741', NULL, 'GATase1_1', NULL, NULL, 'GATase1_1', 5973),
(5974, 'cd16681', NULL, 'RING-H2_RNF111', NULL, NULL, 'RING-H2_RNF111', 5974),
(5975, 'cd15396', NULL, '7tmA_NPY6R', NULL, NULL, '7tmA_NPY6R', 5975),
(5976, 'cd10555', NULL, 'EBDH_beta', NULL, NULL, 'EBDH_beta', 5976);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(5977, 'cd09236', NULL, 'V_AnPalA_UmRIM20_like', NULL, NULL, 'V_AnPalA_UmRIM20_like', 5977),
(5978, 'cd06068', NULL, 'H2MP_like-1', NULL, NULL, 'H2MP_like-1', 5978),
(5979, 'cd08306', NULL, 'Death_FADD', NULL, NULL, 'Death_FADD', 5979),
(5980, 'cd00068', NULL, 'GGL', NULL, NULL, 'GGL', 5980),
(5981, 'cd02679', NULL, 'MIT_spastin', NULL, NULL, 'MIT_spastin', 5981),
(5982, 'cd07564', NULL, 'nitrilases_CHs', NULL, NULL, 'nitrilases_CHs', 5982),
(5983, 'cd07625', NULL, 'BAR_Vps17p', NULL, NULL, 'BAR_Vps17p', 5983),
(5984, 'cd13941', NULL, 'PANDER_like_KIAA1199', NULL, NULL, 'PANDER_like_KIAA1199', 5984),
(5985, 'cd09277', NULL, 'RNase_HI_bacteria_like', NULL, NULL, 'RNase_HI_bacteria_like', 5985),
(5986, 'cd15220', NULL, '7tmA_GPR61_GPR62-like', NULL, NULL, '7tmA_GPR61_GPR62-like', 5986),
(5987, 'cd16909', NULL, 'YEATS_GAS41_like', NULL, NULL, 'YEATS_GAS41_like', 5987),
(5988, 'cd03572', NULL, 'ENTH_like_Tepsin', NULL, NULL, 'ENTH_like_Tepsin', 5988),
(5989, 'cd04485', NULL, 'DnaE_OBF', NULL, NULL, 'DnaE_OBF', 5989),
(5990, 'cd04395', NULL, 'RhoGAP_ARHGAP21', NULL, NULL, 'RhoGAP_ARHGAP21', 5990),
(5991, 'cd19956', NULL, 'serpinB', NULL, NULL, 'serpinB', 5991),
(5992, 'cd03519', NULL, 'Link_domain_HAPLN_module_2', NULL, NULL, 'Link_domain_HAPLN_module_2', 5992),
(5993, 'cd17092', NULL, 'FERM1_F1_Myosin-VII', NULL, NULL, 'FERM1_F1_Myosin-VII', 5993),
(5994, 'cd10141', NULL, 'CopZ-like_Fer2_BFD-like', NULL, NULL, 'CopZ-like_Fer2_BFD-like', 5994),
(5995, 'cd01162', NULL, 'IBD', NULL, NULL, 'IBD', 5995),
(5996, 'cd07716', NULL, 'RNaseZ_short-form-like_MBL-fold', NULL, NULL, 'RNaseZ_short-form-like_MBL-fold', 5996),
(5997, 'cd18723', NULL, 'PIN_LabA-like', NULL, NULL, 'PIN_LabA-like', 5997),
(5998, 'cd16749', NULL, 'RING-HC_SH3RF2', NULL, NULL, 'RING-HC_SH3RF2', 5998),
(5999, 'cd12378', NULL, 'RRM1_I_PABPs', NULL, NULL, 'RRM1_I_PABPs', 5999),
(6000, 'cd03558', NULL, 'LGIC_ECD', NULL, NULL, 'LGIC_ECD', 6000),
(6001, 'cd14033', NULL, 'STKc_WNK4', NULL, NULL, 'STKc_WNK4', 6001),
(6002, 'cd06164', NULL, 'S2P-M50_SpoIVFB_CBS', NULL, NULL, 'S2P-M50_SpoIVFB_CBS', 6002),
(6003, 'cd08739', NULL, 'RGS_RGS9', NULL, NULL, 'RGS_RGS9', 6003),
(6004, 'cd13860', NULL, 'CuRO_1_2dMco_1', NULL, NULL, 'CuRO_1_2dMco_1', 6004),
(6005, 'cd15747', NULL, 'FYVE_Slp3_4_5', NULL, NULL, 'FYVE_Slp3_4_5', 6005),
(6006, 'cd13402', NULL, 'LT_TF-like', NULL, NULL, 'LT_TF-like', 6006),
(6007, 'cd13626', NULL, 'PBP2_Cystine_like', NULL, NULL, 'PBP2_Cystine_like', 6007),
(6008, 'cd09205', NULL, 'PLDc_N_DEXD_b3', NULL, NULL, 'PLDc_N_DEXD_b3', 6008),
(6009, 'cd03286', NULL, 'ABC_MSH6_euk', NULL, NULL, 'ABC_MSH6_euk', 6009),
(6010, 'cd15550', NULL, 'PHD_MLL5', NULL, NULL, 'PHD_MLL5', 6010),
(6011, 'cd00512', NULL, 'MM_CoA_mutase', NULL, NULL, 'MM_CoA_mutase', 6011),
(6012, 'cd07902', NULL, 'Adenylation_DNA_ligase_III', NULL, NULL, 'Adenylation_DNA_ligase_III', 6012),
(6013, 'cd08913', NULL, 'START_STARD14-like', NULL, NULL, 'START_STARD14-like', 6013),
(6014, 'cd03315', NULL, 'MLE_like', NULL, NULL, 'MLE_like', 6014),
(6015, 'cd08572', NULL, 'GDPD_GDE5_like', NULL, NULL, 'GDPD_GDE5_like', 6015),
(6016, 'cd03729', NULL, 'SOCS_ASB13', NULL, NULL, 'SOCS_ASB13', 6016),
(6017, 'cd18544', NULL, 'ABC_6TM_TmrA_like', NULL, NULL, 'ABC_6TM_TmrA_like', 6017),
(6018, 'cd19899', NULL, 'DSRM_RED2_rpt2', NULL, NULL, 'DSRM_RED2_rpt2', 6018),
(6019, 'cd14050', NULL, 'PKc_Myt1', NULL, NULL, 'PKc_Myt1', 6019),
(6020, 'cd16746', NULL, 'RING-HC_RNF212', NULL, NULL, 'RING-HC_RNF212', 6020),
(6021, 'cd10985', NULL, 'MH2_SMAD_2_3', NULL, NULL, 'MH2_SMAD_2_3', 6021),
(6022, 'cd18333', NULL, 'BTB_POZ_ZBTB29_HIC1', NULL, NULL, 'BTB_POZ_ZBTB29_HIC1', 6022),
(6023, 'cd16502', NULL, 'RING-HC_Cbl_like', NULL, NULL, 'RING-HC_Cbl_like', 6023),
(6024, 'cd05505', NULL, 'Bromo_WSTF_like', NULL, NULL, 'Bromo_WSTF_like', 6024),
(6025, 'cd04317', NULL, 'EcAspRS_like_N', NULL, NULL, 'EcAspRS_like_N', 6025),
(6026, 'cd05889', NULL, 'Ig1_DNAM-1_like', NULL, NULL, 'Ig1_DNAM-1_like', 6026),
(6027, 'cd15019', NULL, '7tm_TAS2R14-like', NULL, NULL, '7tm_TAS2R14-like', 6027),
(6028, 'cd00771', NULL, 'ThrRS_core', NULL, NULL, 'ThrRS_core', 6028);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(6029, 'cd12941', NULL, 'LEM_LEMD2', NULL, NULL, 'LEM_LEMD2', 6029),
(6030, 'cd03246', NULL, 'ABCC_Protease_Secretion', NULL, NULL, 'ABCC_Protease_Secretion', 6030),
(6031, 'cd18253', NULL, 'BTB_POZ_KLHL24_KRIP6', NULL, NULL, 'BTB_POZ_KLHL24_KRIP6', 6031),
(6032, 'cd01876', NULL, 'YihA_EngB', NULL, NULL, 'YihA_EngB', 6032),
(6033, 'cd05852', NULL, 'Ig5_Contactin-1', NULL, NULL, 'Ig5_Contactin-1', 6033),
(6034, 'cd09639', NULL, 'Cas3_I', NULL, NULL, 'Cas3_I', 6034),
(6035, 'cd07237', NULL, 'BphC1-RGP6_C_like', NULL, NULL, 'BphC1-RGP6_C_like', 6035),
(6036, 'cd17486', NULL, 'MFS_AmpG_like', NULL, NULL, 'MFS_AmpG_like', 6036),
(6037, 'cd00175', NULL, 'SNc', NULL, NULL, 'SNc', 6037),
(6038, 'cd18035', NULL, 'DEXHc_Hef', NULL, NULL, 'DEXHc_Hef', 6038),
(6039, 'cd12061', NULL, 'SH3_betaPIX', NULL, NULL, 'SH3_betaPIX', 6039),
(6040, 'cd04387', NULL, 'RhoGAP_Bcr', NULL, NULL, 'RhoGAP_Bcr', 6040),
(6041, 'cd02556', NULL, 'PseudoU_synth_RluB', NULL, NULL, 'PseudoU_synth_RluB', 6041),
(6042, 'cd16003', NULL, '7tmA_NKR_NK3R', NULL, NULL, '7tmA_NKR_NK3R', 6042),
(6043, 'cd12621', NULL, 'RRM3_TIA1', NULL, NULL, 'RRM3_TIA1', 6043),
(6044, 'cd16702', NULL, 'RING_CH-C4HC3_MARCH6', NULL, NULL, 'RING_CH-C4HC3_MARCH6', 6044),
(6045, 'cd06626', NULL, 'STKc_MEKK4', NULL, NULL, 'STKc_MEKK4', 6045),
(6046, 'cd16972', NULL, 'Alpha_kinase_ChaK2_TRPM6', NULL, NULL, 'Alpha_kinase_ChaK2_TRPM6', 6046),
(6047, 'cd07756', NULL, 'CYTH-like_Pase_CHAD', NULL, NULL, 'CYTH-like_Pase_CHAD', 6047),
(6048, 'cd16978', NULL, 'VHS_HSE1', NULL, NULL, 'VHS_HSE1', 6048),
(6049, 'cd07880', NULL, 'STKc_p38gamma', NULL, NULL, 'STKc_p38gamma', 6049),
(6050, 'cd13717', NULL, 'PBP2_iGluR_putative', NULL, NULL, 'PBP2_iGluR_putative', 6050),
(6051, 'cd07851', NULL, 'STKc_p38', NULL, NULL, 'STKc_p38', 6051),
(6052, 'cd17364', NULL, 'MFS_PhT', NULL, NULL, 'MFS_PhT', 6052),
(6053, 'cd08992', NULL, 'GH117', NULL, NULL, 'GH117', 6053),
(6054, 'cd11879', NULL, 'SH3_Bem1p_2', NULL, NULL, 'SH3_Bem1p_2', 6054),
(6055, 'cd02750', NULL, 'MopB_Nitrate-R-NarG-like', NULL, NULL, 'MopB_Nitrate-R-NarG-like', 6055),
(6056, 'cd05871', NULL, 'Ig_Semaphorin_classIII', NULL, NULL, 'Ig_Semaphorin_classIII', 6056),
(6057, 'cd02524', NULL, 'G1P_cytidylyltransferase', NULL, NULL, 'G1P_cytidylyltransferase', 6057),
(6058, 'cd06953', NULL, 'NR_LBD_DHR4_like', NULL, NULL, 'NR_LBD_DHR4_like', 6058),
(6059, 'cd08253', NULL, 'zeta_crystallin', NULL, NULL, 'zeta_crystallin', 6059),
(6060, 'cd16621', NULL, 'vRING-HC-C4C4_RFPL1_like', NULL, NULL, 'vRING-HC-C4C4_RFPL1_like', 6060),
(6061, 'cd01194', NULL, 'INT_C_like_4', NULL, NULL, 'INT_C_like_4', 6061),
(6062, 'cd05930', NULL, 'A_NRPS', NULL, NULL, 'A_NRPS', 6062),
(6063, 'cd09769', NULL, 'Luminal_IRE1', NULL, NULL, 'Luminal_IRE1', 6063),
(6064, 'cd12281', NULL, 'RRM1_TatSF1_like', NULL, NULL, 'RRM1_TatSF1_like', 6064),
(6065, 'cd06975', NULL, 'cupin_BacB', NULL, NULL, 'cupin_BacB', 6065),
(6066, 'cd11549', NULL, 'Serine_rich_CAS', NULL, NULL, 'Serine_rich_CAS', 6066),
(6067, 'cd14902', NULL, 'MYSc_Myo41', NULL, NULL, 'MYSc_Myo41', 6067),
(6068, 'cd13701', NULL, 'PBP2_ml15202_like', NULL, NULL, 'PBP2_ml15202_like', 6068),
(6069, 'cd06979', NULL, 'cupin_RemF-like', NULL, NULL, 'cupin_RemF-like', 6069),
(6070, 'cd20264', NULL, 'Complex1_LYR_LYRM4', NULL, NULL, 'Complex1_LYR_LYRM4', 6070),
(6071, 'cd02572', NULL, 'PseudoU_synth_hDyskerin', NULL, NULL, 'PseudoU_synth_hDyskerin', 6071),
(6072, 'cd09366', NULL, 'LIM1_Isl', NULL, NULL, 'LIM1_Isl', 6072),
(6073, 'cd14409', NULL, 'UBA_SIK2', NULL, NULL, 'UBA_SIK2', 6073),
(6074, 'cd12529', NULL, 'RRM2_MEI2_like', NULL, NULL, 'RRM2_MEI2_like', 6074),
(6075, 'cd18755', NULL, 'PIN_MtVapC3_VapC21-like', NULL, NULL, 'PIN_MtVapC3_VapC21-like', 6075),
(6076, 'cd11889', NULL, 'SH3_Cyk3p-like', NULL, NULL, 'SH3_Cyk3p-like', 6076),
(6077, 'cd18276', NULL, 'BTB_POZ_KBTBD12', NULL, NULL, 'BTB_POZ_KBTBD12', 6077),
(6078, 'cd03885', NULL, 'M20_CPDG2', NULL, NULL, 'M20_CPDG2', 6078),
(6079, 'cd08574', NULL, 'GDPD_GDE_2_3_6', NULL, NULL, 'GDPD_GDE_2_3_6', 6079),
(6080, 'cd15800', NULL, 'PMEI-like_2', NULL, NULL, 'PMEI-like_2', 6080);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(6081, 'cd06824', NULL, 'PLPDE_III_Yggs_like', NULL, NULL, 'PLPDE_III_Yggs_like', 6081),
(6082, 'cd16663', NULL, 'RING-Ubox_PPIL2', NULL, NULL, 'RING-Ubox_PPIL2', 6082),
(6083, 'cd19705', NULL, 'bHLH_TS_LYL1', NULL, NULL, 'bHLH_TS_LYL1', 6083),
(6084, 'cd06307', NULL, 'PBP1_sugar_binding', NULL, NULL, 'PBP1_sugar_binding', 6084),
(6085, 'cd16776', NULL, 'RING-HC_RBR_RNF19B', NULL, NULL, 'RING-HC_RBR_RNF19B', 6085),
(6086, 'cd15956', NULL, '7tmA_OR52W-like', NULL, NULL, '7tmA_OR52W-like', 6086),
(6087, 'cd02867', NULL, 'PseudoU_synth_TruB_4', NULL, NULL, 'PseudoU_synth_TruB_4', 6087),
(6088, 'cd08523', NULL, 'Reeler_cohesin_like', NULL, NULL, 'Reeler_cohesin_like', 6088),
(6089, 'cd05569', NULL, 'PTS_IIB_fructose', NULL, NULL, 'PTS_IIB_fructose', 6089),
(6090, 'cd08524', NULL, 'Reelin_subrepeat_like', NULL, NULL, 'Reelin_subrepeat_like', 6090),
(6091, 'cd12124', NULL, 'Pgbs', NULL, NULL, 'Pgbs', 6091),
(6092, 'cd14585', NULL, 'PTP-MTMR6', NULL, NULL, 'PTP-MTMR6', 6092),
(6093, 'cd18430', NULL, 'M14_ASTE_ASPA_like', NULL, NULL, 'M14_ASTE_ASPA_like', 6093),
(6094, 'cd01987', NULL, 'USP_OKCHK', NULL, NULL, 'USP_OKCHK', 6094),
(6095, 'cd05591', NULL, 'STKc_nPKC_epsilon', NULL, NULL, 'STKc_nPKC_epsilon', 6095),
(6096, 'cd09394', NULL, 'LIM1_Rga', NULL, NULL, 'LIM1_Rga', 6096),
(6097, 'cd13925', NULL, 'RPF', NULL, NULL, 'RPF', 6097),
(6098, 'cd03040', NULL, 'GST_N_mPGES2', NULL, NULL, 'GST_N_mPGES2', 6098),
(6099, 'cd04302', NULL, 'HAD_5NT', NULL, NULL, 'HAD_5NT', 6099),
(6100, 'cd12534', NULL, 'RRM_SARFH', NULL, NULL, 'RRM_SARFH', 6100),
(6101, 'cd04120', NULL, 'Rab12', NULL, NULL, 'Rab12', 6101),
(6102, 'cd02971', NULL, 'PRX_family', NULL, NULL, 'PRX_family', 6102),
(6103, 'cd10476', NULL, 'EphR_LBD_B1', NULL, NULL, 'EphR_LBD_B1', 6103),
(6104, 'cd17463', NULL, 'MFS_SLCO4C_OATP4C', NULL, NULL, 'MFS_SLCO4C_OATP4C', 6104),
(6105, 'cd07389', NULL, 'MPP_PhoD', NULL, NULL, 'MPP_PhoD', 6105),
(6106, 'cd17302', NULL, 'PIPKc_AtPIP5K_like', NULL, NULL, 'PIPKc_AtPIP5K_like', 6106),
(6107, 'cd15331', NULL, '7tmA_5-HT1A_invertebrates', NULL, NULL, '7tmA_5-HT1A_invertebrates', 6107),
(6108, 'cd14303', NULL, 'UBA1_KPC2', NULL, NULL, 'UBA1_KPC2', 6108),
(6109, 'cd01539', NULL, 'PBP1_GGBP', NULL, NULL, 'PBP1_GGBP', 6109),
(6110, 'cd11250', NULL, 'Sema_3B', NULL, NULL, 'Sema_3B', 6110),
(6111, 'cd16591', NULL, 'RING-HC_TRIM5_like-C-IV', NULL, NULL, 'RING-HC_TRIM5_like-C-IV', 6111),
(6112, 'cd04492', NULL, 'YhaM_OBF_like', NULL, NULL, 'YhaM_OBF_like', 6112),
(6113, 'cd17300', NULL, 'PIPKc_PIKfyve', NULL, NULL, 'PIPKc_PIKfyve', 6113),
(6114, 'cd02951', NULL, 'SoxW', NULL, NULL, 'SoxW', 6114),
(6115, 'cd02439', NULL, 'DMB-PRT_CobT', NULL, NULL, 'DMB-PRT_CobT', 6115),
(6116, 'cd21657', NULL, 'deltaCoV_Nsp14', NULL, NULL, 'deltaCoV_Nsp14', 6116),
(6117, 'cd08839', NULL, 'ArfGap_SMAP', NULL, NULL, 'ArfGap_SMAP', 6117),
(6118, 'cd16367', NULL, 'DMSOR_beta_like', NULL, NULL, 'DMSOR_beta_like', 6118),
(6119, 'cd11336', NULL, 'AmyAc_MTSase', NULL, NULL, 'AmyAc_MTSase', 6119),
(6120, 'cd07305', NULL, 'Porin3_Tom40', NULL, NULL, 'Porin3_Tom40', 6120),
(6121, 'cd17957', NULL, 'DEADc_DDX52', NULL, NULL, 'DEADc_DDX52', 6121),
(6122, 'cd06112', NULL, 'citrate_synt_like_1_1', NULL, NULL, 'citrate_synt_like_1_1', 6122),
(6123, 'cd15565', NULL, 'PHD2_NSD', NULL, NULL, 'PHD2_NSD', 6123),
(6124, 'cd09529', NULL, 'SAM_MLTK', NULL, NULL, 'SAM_MLTK', 6124),
(6125, 'cd11680', NULL, 'HDAC_Hos1', NULL, NULL, 'HDAC_Hos1', 6125),
(6126, 'cd15950', NULL, '7tmA_OR52I-like', NULL, NULL, '7tmA_OR52I-like', 6126),
(6127, 'cd15533', NULL, 'PHD1_PHF12', NULL, NULL, 'PHD1_PHF12', 6127),
(6128, 'cd00980', NULL, 'FwdC/FmdC', NULL, NULL, 'FwdC/FmdC', 6128),
(6129, 'cd12819', NULL, 'LbR_vir_like', NULL, NULL, 'LbR_vir_like', 6129),
(6130, 'cd00548', NULL, 'NrfA-like', NULL, NULL, 'NrfA-like', 6130),
(6131, 'cd16313', NULL, 'SMB-1-like_MBL-B3', NULL, NULL, 'SMB-1-like_MBL-B3', 6131),
(6132, 'cd14240', NULL, 'GAT_GGA3', NULL, NULL, 'GAT_GGA3', 6132),
(6133, 'cd07646', NULL, 'I-BAR_IMD_IRSp53', NULL, NULL, 'I-BAR_IMD_IRSp53', 6133),
(6134, 'cd09034', NULL, 'BRO1_Alix_like', NULL, NULL, 'BRO1_Alix_like', 6134);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(6135, 'cd05075', NULL, 'PTKc_Axl', NULL, NULL, 'PTKc_Axl', 6135),
(6136, 'cd13647', NULL, 'PBP2_PBGD_2', NULL, NULL, 'PBP2_PBGD_2', 6136),
(6137, 'cd10454', NULL, 'GIY-YIG_COG3680_Meta', NULL, NULL, 'GIY-YIG_COG3680_Meta', 6137),
(6138, 'cd18159', NULL, 'REC_OmpR_NsrR-like', NULL, NULL, 'REC_OmpR_NsrR-like', 6138),
(6139, 'cd03859', NULL, 'M14_CPT', NULL, NULL, 'M14_CPT', 6139),
(6140, 'cd15909', NULL, '7tmF_FZD4_9_10-like', NULL, NULL, '7tmF_FZD4_9_10-like', 6140),
(6141, 'cd04661', NULL, 'MRP_L46', NULL, NULL, 'MRP_L46', 6141),
(6142, 'cd11465', NULL, 'bHLH_TS_scleraxis_like', NULL, NULL, 'bHLH_TS_scleraxis_like', 6142),
(6143, 'cd12872', NULL, 'SPRY_Ash2', NULL, NULL, 'SPRY_Ash2', 6143),
(6144, 'cd17432', NULL, 'MFS_GLUT_Class2', NULL, NULL, 'MFS_GLUT_Class2', 6144),
(6145, 'cd14007', NULL, 'STKc_Aurora', NULL, NULL, 'STKc_Aurora', 6145),
(6146, 'cd15475', NULL, 'MyosinXI_CBD', NULL, NULL, 'MyosinXI_CBD', 6146),
(6147, 'cd02107', NULL, 'YedY_like_Moco', NULL, NULL, 'YedY_like_Moco', 6147),
(6148, 'cd11572', NULL, 'RlmI_M_like', NULL, NULL, 'RlmI_M_like', 6148),
(6149, 'cd15806', NULL, 'LGP2_C', NULL, NULL, 'LGP2_C', 6149),
(6150, 'cd20477', NULL, 'Cas13b_Pb-like', NULL, NULL, 'Cas13b_Pb-like', 6150),
(6151, 'cd06422', NULL, 'NTP_transferase_like_1', NULL, NULL, 'NTP_transferase_like_1', 6151),
(6152, 'cd07908', NULL, 'Mn_catalase_like', NULL, NULL, 'Mn_catalase_like', 6152),
(6153, 'cd07527', NULL, 'HAD_ScGPP-like', NULL, NULL, 'HAD_ScGPP-like', 6153),
(6154, 'cd02809', NULL, 'alpha_hydroxyacid_oxid_FMN', NULL, NULL, 'alpha_hydroxyacid_oxid_FMN', 6154),
(6155, 'cd11378', NULL, 'DUF296', NULL, NULL, 'DUF296', 6155),
(6156, 'cd17481', NULL, 'MFS_MFSD13A', NULL, NULL, 'MFS_MFSD13A', 6156),
(6157, 'cd18985', NULL, 'CBD_TIP60_like', NULL, NULL, 'CBD_TIP60_like', 6157),
(6158, 'cd19075', NULL, 'AKR_AKR7A1-5', NULL, NULL, 'AKR_AKR7A1-5', 6158),
(6159, 'cd18106', NULL, 'SpoU-like_RNMTL1', NULL, NULL, 'SpoU-like_RNMTL1', 6159),
(6160, 'cd15080', NULL, '7tmA_MWS_opsin', NULL, NULL, '7tmA_MWS_opsin', 6160),
(6161, 'cd03042', NULL, 'GST_N_Zeta', NULL, NULL, 'GST_N_Zeta', 6161),
(6162, 'cd18794', NULL, 'SF2_C_RecQ', NULL, NULL, 'SF2_C_RecQ', 6162),
(6163, 'cd11905', NULL, 'SH3_Tec', NULL, NULL, 'SH3_Tec', 6163),
(6164, 'cd16637', NULL, 'mRING-HC-C3HC3D_LNX1_like', NULL, NULL, 'mRING-HC-C3HC3D_LNX1_like', 6164),
(6165, 'cd11016', NULL, 'CuRO_4_FVIII_like', NULL, NULL, 'CuRO_4_FVIII_like', 6165),
(6166, 'cd02861', NULL, 'E_set_pullulanase_like', NULL, NULL, 'E_set_pullulanase_like', 6166),
(6167, 'cd04486', NULL, 'YhcR_OBF_like', NULL, NULL, 'YhcR_OBF_like', 6167),
(6168, 'cd10469', NULL, 'FAM20A_C', NULL, NULL, 'FAM20A_C', 6168),
(6169, 'cd05231', NULL, 'NmrA_TMR_like_1_SDR_a', NULL, NULL, 'NmrA_TMR_like_1_SDR_a', 6169),
(6170, 'cd18245', NULL, 'BTB_POZ_KLHL16_gigaxonin', NULL, NULL, 'BTB_POZ_KLHL16_gigaxonin', 6170),
(6171, 'cd08188', NULL, 'PDDH', NULL, NULL, 'PDDH', 6171),
(6172, 'cd03122', NULL, 'alpha_CARP_receptor_like', NULL, NULL, 'alpha_CARP_receptor_like', 6172),
(6173, 'cd08586', NULL, 'PI-PLCc_BcPLC_like', NULL, NULL, 'PI-PLCc_BcPLC_like', 6173),
(6174, 'cd08148', NULL, 'RuBisCO_large', NULL, NULL, 'RuBisCO_large', 6174),
(6175, 'cd03394', NULL, 'PAP2_like_5', NULL, NULL, 'PAP2_like_5', 6175),
(6176, 'cd16155', NULL, 'sulfatase_like', NULL, NULL, 'sulfatase_like', 6176),
(6177, 'cd13261', NULL, 'PH_RasGRF1_2', NULL, NULL, 'PH_RasGRF1_2', 6177),
(6178, 'cd19761', NULL, 'Bbox2_TRIM5-like', NULL, NULL, 'Bbox2_TRIM5-like', 6178),
(6179, 'cd03779', NULL, 'MATH_TRAF1', NULL, NULL, 'MATH_TRAF1', 6179),
(6180, 'cd05365', NULL, '7_alpha_HSDH_SDR_c', NULL, NULL, '7_alpha_HSDH_SDR_c', 6180),
(6181, 'cd13933', NULL, 'harmonin_N_like_u1', NULL, NULL, 'harmonin_N_like_u1', 6181),
(6182, 'cd19042', NULL, 'LGIC_ECD_GABAAR_B3', NULL, NULL, 'LGIC_ECD_GABAAR_B3', 6182),
(6183, 'cd00367', NULL, 'PTS-HPr_like', NULL, NULL, 'PTS-HPr_like', 6183),
(6184, 'cd15272', NULL, '7tmB1_PTH-R_related', NULL, NULL, '7tmB1_PTH-R_related', 6184),
(6185, 'cd08714', NULL, 'RGS_RGS4', NULL, NULL, 'RGS_RGS4', 6185),
(6186, 'cd03538', NULL, 'Rieske_RO_Alpha_AntDO', NULL, NULL, 'Rieske_RO_Alpha_AntDO', 6186);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(6187, 'cd02407', NULL, 'PTH2_family', NULL, NULL, 'PTH2_family', 6187),
(6188, 'cd08826', NULL, 'SPFH_eoslipins_u1', NULL, NULL, 'SPFH_eoslipins_u1', 6188),
(6189, 'cd03293', NULL, 'ABC_NrtD_SsuB_transporters', NULL, NULL, 'ABC_NrtD_SsuB_transporters', 6189),
(6190, 'cd18528', NULL, 'BACK_RCBTB1', NULL, NULL, 'BACK_RCBTB1', 6190),
(6191, 'cd08384', NULL, 'C2B_Rabphilin_Doc2', NULL, NULL, 'C2B_Rabphilin_Doc2', 6191),
(6192, 'cd01487', NULL, 'E1_ThiF_like', NULL, NULL, 'E1_ThiF_like', 6192),
(6193, 'cd16576', NULL, 'RING-HC_TRIM9_like_C-I', NULL, NULL, 'RING-HC_TRIM9_like_C-I', 6193),
(6194, 'cd15142', NULL, '7tmA_PGE2_EP4', NULL, NULL, '7tmA_PGE2_EP4', 6194),
(6195, 'cd03453', NULL, 'SAV4209_like', NULL, NULL, 'SAV4209_like', 6195),
(6196, 'cd04095', NULL, 'CysN_NoDQ_III', NULL, NULL, 'CysN_NoDQ_III', 6196),
(6197, 'cd01791', NULL, 'Ubl_UBL5', NULL, NULL, 'Ubl_UBL5', 6197),
(6198, 'cd05885', NULL, 'Ig2_Necl-4', NULL, NULL, 'Ig2_Necl-4', 6198),
(6199, 'cd05710', NULL, 'SIS_1', NULL, NULL, 'SIS_1', 6199),
(6200, 'cd18385', NULL, 'BTB_POZ_BTBD10_GMRP1', NULL, NULL, 'BTB_POZ_BTBD10_GMRP1', 6200),
(6201, 'cd07706', NULL, 'IgV_TCR_delta', NULL, NULL, 'IgV_TCR_delta', 6201),
(6202, 'cd00862', NULL, 'ProRS_anticodon_zinc', NULL, NULL, 'ProRS_anticodon_zinc', 6202),
(6203, 'cd08390', NULL, 'C2A_Synaptotagmin-15-17', NULL, NULL, 'C2A_Synaptotagmin-15-17', 6203),
(6204, 'cd10443', NULL, 'GIY-YIG_HE_Tlr8p_PBC-V_like', NULL, NULL, 'GIY-YIG_HE_Tlr8p_PBC-V_like', 6204),
(6205, 'cd12278', NULL, 'RRM_eIF3B', NULL, NULL, 'RRM_eIF3B', 6205),
(6206, 'cd05841', NULL, 'BS69_related', NULL, NULL, 'BS69_related', 6206),
(6207, 'cd19061', NULL, 'LGIC_TM_GlyR_beta', NULL, NULL, 'LGIC_TM_GlyR_beta', 6207),
(6208, 'cd16816', NULL, 'mRING-HC-C3HC5_MGRN1', NULL, NULL, 'mRING-HC-C3HC5_MGRN1', 6208),
(6209, 'cd05366', NULL, 'meso-BDH-like_SDR_c', NULL, NULL, 'meso-BDH-like_SDR_c', 6209),
(6210, 'cd10795', NULL, 'GH57N_MJA1_like', NULL, NULL, 'GH57N_MJA1_like', 6210),
(6211, 'cd18747', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, 'PIN_VapC4-5_FitB-like', 6211),
(6212, 'cd05751', NULL, 'Ig1_LILR_KIR_like', NULL, NULL, 'Ig1_LILR_KIR_like', 6212),
(6213, 'cd10461', NULL, 'PUB_UBA_plant', NULL, NULL, 'PUB_UBA_plant', 6213),
(6214, 'cd08593', NULL, 'PI-PLCc_delta', NULL, NULL, 'PI-PLCc_delta', 6214),
(6215, 'cd05049', NULL, 'PTKc_Trk', NULL, NULL, 'PTKc_Trk', 6215),
(6216, 'cd06533', NULL, 'Glyco_transf_WecG_TagA', NULL, NULL, 'Glyco_transf_WecG_TagA', 6216),
(6217, 'cd15064', NULL, '7tmA_5-HT1_5_7', NULL, NULL, '7tmA_5-HT1_5_7', 6217),
(6218, 'cd17381', NULL, 'MFS_SLC17A5', NULL, NULL, 'MFS_SLC17A5', 6218),
(6219, 'cd08582', NULL, 'GDPD_like_2', NULL, NULL, 'GDPD_like_2', 6219),
(6220, 'cd10027', NULL, 'UDG-F1-like', NULL, NULL, 'UDG-F1-like', 6220),
(6221, 'cd15120', NULL, '7tmA_GPR33', NULL, NULL, '7tmA_GPR33', 6221),
(6222, 'cd19463', NULL, 'CRBP2', NULL, NULL, 'CRBP2', 6222),
(6223, 'cd17345', NULL, 'MFS_GlpT', NULL, NULL, 'MFS_GlpT', 6223),
(6224, 'cd07725', NULL, 'TTHA1429-like_MBL-fold', NULL, NULL, 'TTHA1429-like_MBL-fold', 6224),
(6225, 'cd11624', NULL, 'HR1_Rhophilin', NULL, NULL, 'HR1_Rhophilin', 6225),
(6226, 'cd03131', NULL, 'GATase1_HTS', NULL, NULL, 'GATase1_HTS', 6226),
(6227, 'cd12047', NULL, 'SH3_Noxa1_C', NULL, NULL, 'SH3_Noxa1_C', 6227),
(6228, 'cd01417', NULL, 'Ribosomal_L19e_E', NULL, NULL, 'Ribosomal_L19e_E', 6228),
(6229, 'cd10149', NULL, 'ClassIIa_HDAC_Gln-rich-N', NULL, NULL, 'ClassIIa_HDAC_Gln-rich-N', 6229),
(6230, 'cd19766', NULL, 'Bbox2_TRIM11_C-IV', NULL, NULL, 'Bbox2_TRIM11_C-IV', 6230),
(6231, 'cd05247', NULL, 'UDP_G4E_1_SDR_e', NULL, NULL, 'UDP_G4E_1_SDR_e', 6231),
(6232, 'cd13702', NULL, 'PBP2_mlr5654_like', NULL, NULL, 'PBP2_mlr5654_like', 6232),
(6233, 'cd05835', NULL, 'Dnmt3b_related', NULL, NULL, 'Dnmt3b_related', 6233),
(6234, 'cd16108', NULL, 'Ubl_ATG8_like', NULL, NULL, 'Ubl_ATG8_like', 6234),
(6235, 'cd16901', NULL, 'lyz_P1', NULL, NULL, 'lyz_P1', 6235),
(6236, 'cd08041', NULL, 'OBF_kDNA_ligase_like', NULL, NULL, 'OBF_kDNA_ligase_like', 6236),
(6237, 'cd19395', NULL, 'TGF_beta_BMP5', NULL, NULL, 'TGF_beta_BMP5', 6237);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(6238, 'cd05737', NULL, 'Ig_Myomesin_like_C', NULL, NULL, 'Ig_Myomesin_like_C', 6238),
(6239, 'cd15788', NULL, 'Clospo_01618_like', NULL, NULL, 'Clospo_01618_like', 6239),
(6240, 'cd09634', NULL, 'Cas1_I-II-III', NULL, NULL, 'Cas1_I-II-III', 6240),
(6241, 'cd12631', NULL, 'RRM1_CELF1_2_Bruno', NULL, NULL, 'RRM1_CELF1_2_Bruno', 6241),
(6242, 'cd16135', NULL, 'RA_RASSF7', NULL, NULL, 'RA_RASSF7', 6242),
(6243, 'cd09703', NULL, 'Cas6-I-III', NULL, NULL, 'Cas6-I-III', 6243),
(6244, 'cd00252', NULL, 'EFh_SPARC_EC', NULL, NULL, 'EFh_SPARC_EC', 6244),
(6245, 'cd04912', NULL, 'ACT_AKiii-LysC-EC-like_1', NULL, NULL, 'ACT_AKiii-LysC-EC-like_1', 6245),
(6246, 'cd14327', NULL, 'UBA_atUPL1_2_like', NULL, NULL, 'UBA_atUPL1_2_like', 6246),
(6247, 'cd09419', NULL, 'LIM3_Testin', NULL, NULL, 'LIM3_Testin', 6247),
(6248, 'cd15062', NULL, '7tmA_alpha1_AR', NULL, NULL, '7tmA_alpha1_AR', 6248),
(6249, 'cd00237', NULL, 'p23', NULL, NULL, 'p23', 6249),
(6250, 'cd16252', NULL, 'EFh_calglandulin_like', NULL, NULL, 'EFh_calglandulin_like', 6250),
(6251, 'cd00578', NULL, 'L-fuc_L-ara-isomerases', NULL, NULL, 'L-fuc_L-ara-isomerases', 6251),
(6252, 'cd10026', NULL, '14-3-3_plant', NULL, NULL, '14-3-3_plant', 6252),
(6253, 'cd18972', NULL, 'CD_POL_like', NULL, NULL, 'CD_POL_like', 6253),
(6254, 'cd06321', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, 'PBP1_ABC_sugar_binding-like', 6254),
(6255, 'cd17149', NULL, 'DCX1_DCDC2', NULL, NULL, 'DCX1_DCDC2', 6255),
(6256, 'cd06366', NULL, 'PBP1_GABAb_receptor', NULL, NULL, 'PBP1_GABAb_receptor', 6256),
(6257, 'cd12279', NULL, 'RRM_TUT1', NULL, NULL, 'RRM_TUT1', 6257),
(6258, 'cd04054', NULL, 'C2A_Rasal1_RasA4', NULL, NULL, 'C2A_Rasal1_RasA4', 6258),
(6259, 'cd06280', NULL, 'PBP1_LacI-like', NULL, NULL, 'PBP1_LacI-like', 6259),
(6260, 'cd04084', NULL, 'CBM6_xylanase-like', NULL, NULL, 'CBM6_xylanase-like', 6260),
(6261, 'cd19936', NULL, 'REC_OmpR_ChvI-like', NULL, NULL, 'REC_OmpR_ChvI-like', 6261),
(6262, 'cd03730', NULL, 'SOCS_ASB14', NULL, NULL, 'SOCS_ASB14', 6262),
(6263, 'cd00777', NULL, 'AspRS_core', NULL, NULL, 'AspRS_core', 6263),
(6264, 'cd08587', NULL, 'PI-PLCXDc_like', NULL, NULL, 'PI-PLCXDc_like', 6264),
(6265, 'cd09471', NULL, 'LIM2_Isl2', NULL, NULL, 'LIM2_Isl2', 6265),
(6266, 'cd05760', NULL, 'Ig2_PTK7', NULL, NULL, 'Ig2_PTK7', 6266),
(6267, 'cd04245', NULL, 'AAK_AKiii-YclM-BS', NULL, NULL, 'AAK_AKiii-YclM-BS', 6267),
(6268, 'cd16244', NULL, 'EFh_DTN', NULL, NULL, 'EFh_DTN', 6268),
(6269, 'cd19934', NULL, 'REC_OmpR_EcPhoP-like', NULL, NULL, 'REC_OmpR_EcPhoP-like', 6269),
(6270, 'cd00508', NULL, 'MopB_CT_Fdh-Nap-like', NULL, NULL, 'MopB_CT_Fdh-Nap-like', 6270),
(6271, 'cd05098', NULL, 'PTKc_FGFR1', NULL, NULL, 'PTKc_FGFR1', 6271),
(6272, 'cd14361', NULL, 'UBA_HYPK', NULL, NULL, 'UBA_HYPK', 6272),
(6273, 'cd14339', NULL, 'UBA_SNRK', NULL, NULL, 'UBA_SNRK', 6273),
(6274, 'cd05324', NULL, 'carb_red_PTCR-like_SDR_c', NULL, NULL, 'carb_red_PTCR-like_SDR_c', 6274),
(6275, 'cd16807', NULL, 'RING_CH-C4HC3_MARCH8', NULL, NULL, 'RING_CH-C4HC3_MARCH8', 6275),
(6276, 'cd18053', NULL, 'DEXHc_CHD1', NULL, NULL, 'DEXHc_CHD1', 6276),
(6277, 'cd17530', NULL, 'REC_RocR', NULL, NULL, 'REC_RocR', 6277),
(6278, 'cd08185', NULL, 'Fe-ADH-like', NULL, NULL, 'Fe-ADH-like', 6278),
(6279, 'cd13600', NULL, 'PBP2_lipoprotein_like_1', NULL, NULL, 'PBP2_lipoprotein_like_1', 6279),
(6280, 'cd20003', NULL, 'PBP1_LsrB_Quorum_Sensing', NULL, NULL, 'PBP1_LsrB_Quorum_Sensing', 6280),
(6281, 'cd14562', NULL, 'PTP_tensin-2', NULL, NULL, 'PTP_tensin-2', 6281),
(6282, 'cd09840', NULL, 'LIM2_CRP2', NULL, NULL, 'LIM2_CRP2', 6282),
(6283, 'cd17087', NULL, 'RAWUL_DRIP_like', NULL, NULL, 'RAWUL_DRIP_like', 6283),
(6284, 'cd11901', NULL, 'SH3_Nck1_2', NULL, NULL, 'SH3_Nck1_2', 6284),
(6285, 'cd18440', NULL, 'BRCT_PAXIP1_rpt6', NULL, NULL, 'BRCT_PAXIP1_rpt6', 6285),
(6286, 'cd08594', NULL, 'PI-PLCc_eta', NULL, NULL, 'PI-PLCc_eta', 6286),
(6287, 'cd01849', NULL, 'YlqF_related_GTPase', NULL, NULL, 'YlqF_related_GTPase', 6287),
(6288, 'cd18261', NULL, 'BTB_POZ_KLHL32', NULL, NULL, 'BTB_POZ_KLHL32', 6288),
(6289, 'cd05768', NULL, 'IgC_CH3_IgAGD_CH4_IgAEM', NULL, NULL, 'IgC_CH3_IgAGD_CH4_IgAEM', 6289);
INSERT INTO "PUBLIC"."MODEL" VALUES
(6290, 'cd08711', NULL, 'RGS_RGS8', NULL, NULL, 'RGS_RGS8', 6290),
(6291, 'cd09174', NULL, 'PLDc_Nuc_like_unchar2', NULL, NULL, 'PLDc_Nuc_like_unchar2', 6291),
(6292, 'cd10036', NULL, 'Reelin_subrepeat_Nt', NULL, NULL, 'Reelin_subrepeat_Nt', 6292),
(6293, 'cd14817', NULL, 'D-Ala-D-Ala_dipeptidase_VanX', NULL, NULL, 'D-Ala-D-Ala_dipeptidase_VanX', 6293),
(6294, 'cd08064', NULL, 'MPN_eIF3f', NULL, NULL, 'MPN_eIF3f', 6294),
(6295, 'cd19984', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, 'PBP1_ABC_ligand_binding-like', 6295),
(6296, 'cd09993', NULL, 'HDAC_classIV', NULL, NULL, 'HDAC_classIV', 6296),
(6297, 'cd00122', NULL, 'MBD', NULL, NULL, 'MBD', 6297),
(6298, 'cd17138', NULL, 'RBD2_RGS12', NULL, NULL, 'RBD2_RGS12', 6298),
(6299, 'cd09749', NULL, 'Cmr5_III-B', NULL, NULL, 'Cmr5_III-B', 6299),
(6300, 'cd13898', NULL, 'CuRO_3_Abr2_like', NULL, NULL, 'CuRO_3_Abr2_like', 6300),
(6301, 'cd08453', NULL, 'PBP2_IlvR', NULL, NULL, 'PBP2_IlvR', 6301),
(6302, 'cd17235', NULL, 'Ubl_ATG8_MAP1LC3B', NULL, NULL, 'Ubl_ATG8_MAP1LC3B', 6302),
(6303, 'cd02812', NULL, 'PcrB_like', NULL, NULL, 'PcrB_like', 6303),
(6304, 'cd05877', NULL, 'Ig_LP_like', NULL, NULL, 'Ig_LP_like', 6304),
(6305, 'cd06374', NULL, 'PBP1_mGluR_groupI', NULL, NULL, 'PBP1_mGluR_groupI', 6305),
(6306, 'cd14963', NULL, 'NHL_like_5', NULL, NULL, 'NHL_like_5', 6306),
(6307, 'cd16703', NULL, 'RING_CH-C4HC3_MARCH7_like', NULL, NULL, 'RING_CH-C4HC3_MARCH7_like', 6307),
(6308, 'cd18762', NULL, 'PIN_MtVapC3-like', NULL, NULL, 'PIN_MtVapC3-like', 6308),
(6309, 'cd00959', NULL, 'DeoC', NULL, NULL, 'DeoC', 6309),
(6310, 'cd18630', NULL, 'CD_Rhino', NULL, NULL, 'CD_Rhino', 6310),
(6311, 'cd04051', NULL, 'C2_SRC2_like', NULL, NULL, 'C2_SRC2_like', 6311),
(6312, 'cd09409', NULL, 'LIM3_Paxillin', NULL, NULL, 'LIM3_Paxillin', 6312),
(6313, 'cd16636', NULL, 'mRING-HC-C3HC3D_SCAF11', NULL, NULL, 'mRING-HC-C3HC3D_SCAF11', 6313),
(6314, 'cd18526', NULL, 'BACK_ABTB2', NULL, NULL, 'BACK_ABTB2', 6314),
(6315, 'cd11607', NULL, 'DENR_C', NULL, NULL, 'DENR_C', 6315),
(6316, 'cd12178', NULL, '2-Hacid_dh_13', NULL, NULL, '2-Hacid_dh_13', 6316),
(6317, 'cd04331', NULL, 'RNAP_E_N', NULL, NULL, 'RNAP_E_N', 6317),
(6318, 'cd16768', NULL, 'RING-HC_TRIM3', NULL, NULL, 'RING-HC_TRIM3', 6318),
(6319, 'cd19957', NULL, 'serpinA', NULL, NULL, 'serpinA', 6319),
(6320, 'cd21516', NULL, 'cv_beta_Nsp2_SARS-like', NULL, NULL, 'cv_beta_Nsp2_SARS-like', 6320),
(6321, 'cd12082', NULL, 'MATE_like', NULL, NULL, 'MATE_like', 6321),
(6322, 'cd16352', NULL, 'CheD', NULL, NULL, 'CheD', 6322),
(6323, 'cd03039', NULL, 'GST_N_Sigma_like', NULL, NULL, 'GST_N_Sigma_like', 6323),
(6324, 'cd16824', NULL, 'RING_CH-C4HC3_MARCH4', NULL, NULL, 'RING_CH-C4HC3_MARCH4', 6324),
(6325, 'cd15853', NULL, 'SNARE_Bet1', NULL, NULL, 'SNARE_Bet1', 6325),
(6326, 'cd15057', NULL, '7tmA_D1-like_dopamine_R', NULL, NULL, '7tmA_D1-like_dopamine_R', 6326),
(6327, 'cd16347', NULL, 'VOC_like', NULL, NULL, 'VOC_like', 6327),
(6328, 'cd16884', NULL, 'ARID_ARID5A', NULL, NULL, 'ARID_ARID5A', 6328),
(6329, 'cd18023', NULL, 'DEXHc_HFM1', NULL, NULL, 'DEXHc_HFM1', 6329),
(6330, 'cd14684', NULL, 'RanBD1_RanBP2-like', NULL, NULL, 'RanBD1_RanBP2-like', 6330),
(6331, 'cd08551', NULL, 'Fe-ADH', NULL, NULL, 'Fe-ADH', 6331),
(6332, 'cd13151', NULL, 'DAXX_helical_bundle', NULL, NULL, 'DAXX_helical_bundle', 6332),
(6333, 'cd21627', NULL, 'batCoV-HKU9-like_Spike_S1_NTD', NULL, NULL, 'batCoV-HKU9-like_Spike_S1_NTD', 6333),
(6334, 'cd15316', NULL, '7tmA_TAAR6_8_9', NULL, NULL, '7tmA_TAAR6_8_9', 6334),
(6335, 'cd04012', NULL, 'C2A_PI3K_class_II', NULL, NULL, 'C2A_PI3K_class_II', 6335),
(6336, 'cd14658', NULL, 'Imelysin-like_IrpA', NULL, NULL, 'Imelysin-like_IrpA', 6336),
(6337, 'cd05691', NULL, 'S1_RPS1_repeat_ec6', NULL, NULL, 'S1_RPS1_repeat_ec6', 6337),
(6338, 'cd00256', NULL, 'VATPase_H', NULL, NULL, 'VATPase_H', 6338),
(6339, 'cd03429', NULL, 'NADH_pyrophosphatase', NULL, NULL, 'NADH_pyrophosphatase', 6339),
(6340, 'cd05972', NULL, 'MACS_like', NULL, NULL, 'MACS_like', 6340),
(6341, 'cd16900', NULL, 'endolysin_R21-like', NULL, NULL, 'endolysin_R21-like', 6341);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(6342, 'cd12396', NULL, 'RRM1_Nop13p_fungi', NULL, NULL, 'RRM1_Nop13p_fungi', 6342),
(6343, 'cd20311', NULL, 'cupin_Yhhw_C', NULL, NULL, 'cupin_Yhhw_C', 6343),
(6344, 'cd01300', NULL, 'YtcJ_like', NULL, NULL, 'YtcJ_like', 6344),
(6345, 'cd15151', NULL, '7tmA_P2Y13', NULL, NULL, '7tmA_P2Y13', 6345),
(6346, 'cd19864', NULL, 'DSRM_PRKRA-like_rpt3', NULL, NULL, 'DSRM_PRKRA-like_rpt3', 6346),
(6347, 'cd16748', NULL, 'RING-HC_SH3RF1', NULL, NULL, 'RING-HC_SH3RF1', 6347),
(6348, 'cd01793', NULL, 'Ubl_FUBI', NULL, NULL, 'Ubl_FUBI', 6348),
(6349, 'cd00169', NULL, 'Chemokine', NULL, NULL, 'Chemokine', 6349),
(6350, 'cd03215', NULL, 'ABC_Carb_Monos_II', NULL, NULL, 'ABC_Carb_Monos_II', 6350),
(6351, 'cd04219', NULL, 'Plastocyanin', NULL, NULL, 'Plastocyanin', 6351),
(6352, 'cd07077', NULL, 'ALDH-like', NULL, NULL, 'ALDH-like', 6352),
(6353, 'cd13318', NULL, 'PH_IQSEC', NULL, NULL, 'PH_IQSEC', 6353),
(6354, 'cd14187', NULL, 'STKc_PLK1', NULL, NULL, 'STKc_PLK1', 6354),
(6355, 'cd16509', NULL, 'RING-HC_HLTF', NULL, NULL, 'RING-HC_HLTF', 6355),
(6356, 'cd07363', NULL, '45_DOPA_Dioxygenase', NULL, NULL, '45_DOPA_Dioxygenase', 6356),
(6357, 'cd07411', NULL, 'MPP_SoxB_N', NULL, NULL, 'MPP_SoxB_N', 6357),
(6358, 'cd03484', NULL, 'MutL_Trans_hPMS_2_like', NULL, NULL, 'MutL_Trans_hPMS_2_like', 6358),
(6359, 'cd18208', NULL, 'BTB_POZ_ZBTB20_DPZF', NULL, NULL, 'BTB_POZ_ZBTB20_DPZF', 6359),
(6360, 'cd00453', NULL, 'FTBP_aldolase_II', NULL, NULL, 'FTBP_aldolase_II', 6360),
(6361, 'cd14959', NULL, 'NHL_brat_like', NULL, NULL, 'NHL_brat_like', 6361),
(6362, 'cd05690', NULL, 'S1_RPS1_repeat_ec5', NULL, NULL, 'S1_RPS1_repeat_ec5', 6362),
(6363, 'cd07957', NULL, 'Anticodon_Ia_Met', NULL, NULL, 'Anticodon_Ia_Met', 6363),
(6364, 'cd11308', NULL, 'Peptidase_M14NE-CP-C_like', NULL, NULL, 'Peptidase_M14NE-CP-C_like', 6364),
(6365, 'cd15310', NULL, '7tmA_D3_dopamine_R', NULL, NULL, '7tmA_D3_dopamine_R', 6365),
(6366, 'cd14767', NULL, 'PE_beta-like', NULL, NULL, 'PE_beta-like', 6366),
(6367, 'cd15224', NULL, '7tmA_OR6B-like', NULL, NULL, '7tmA_OR6B-like', 6367),
(6368, 'cd08265', NULL, 'Zn_ADH3', NULL, NULL, 'Zn_ADH3', 6368),
(6369, 'cd08919', NULL, 'PBP-like', NULL, NULL, 'PBP-like', 6369),
(6370, 'cd18724', NULL, 'PIN_LabA-like', NULL, NULL, 'PIN_LabA-like', 6370),
(6371, 'cd19054', NULL, 'LGIC_TM_GABAAR_gamma', NULL, NULL, 'LGIC_TM_GABAAR_gamma', 6371),
(6372, 'cd08616', NULL, 'PI-PLCXD1c', NULL, NULL, 'PI-PLCXD1c', 6372),
(6373, 'cd15577', NULL, 'PHD_JMJD2C', NULL, NULL, 'PHD_JMJD2C', 6373),
(6374, 'cd06661', NULL, 'GGCT_like', NULL, NULL, 'GGCT_like', 6374),
(6375, 'cd00562', NULL, 'NifX_NifB', NULL, NULL, 'NifX_NifB', 6375),
(6376, 'cd04199', NULL, 'CuRO_1_ceruloplasmin_like', NULL, NULL, 'CuRO_1_ceruloplasmin_like', 6376),
(6377, 'cd13752', NULL, 'TGF_beta_INHB', NULL, NULL, 'TGF_beta_INHB', 6377),
(6378, 'cd09502', NULL, 'SAM_SARM1-like_repeat2', NULL, NULL, 'SAM_SARM1-like_repeat2', 6378),
(6379, 'cd07829', NULL, 'STKc_CDK_like', NULL, NULL, 'STKc_CDK_like', 6379),
(6380, 'cd10451', NULL, 'GIY-YIG_LuxR_like', NULL, NULL, 'GIY-YIG_LuxR_like', 6380),
(6381, 'cd03212', NULL, 'GST_C_Metaxin1_3', NULL, NULL, 'GST_C_Metaxin1_3', 6381),
(6382, 'cd00933', NULL, 'barnase', NULL, NULL, 'barnase', 6382),
(6383, 'cd10449', NULL, 'GIY-YIG_SLX1_like', NULL, NULL, 'GIY-YIG_SLX1_like', 6383),
(6384, 'cd08649', NULL, 'FMT_core_NRPS_like', NULL, NULL, 'FMT_core_NRPS_like', 6384),
(6385, 'cd16584', NULL, 'RING-HC_TRIM56_C-V', NULL, NULL, 'RING-HC_TRIM56_C-V', 6385),
(6386, 'cd08345', NULL, 'Fosfomycin_RP', NULL, NULL, 'Fosfomycin_RP', 6386),
(6387, 'cd14949', NULL, 'Asparaginase_2_like_3', NULL, NULL, 'Asparaginase_2_like_3', 6387),
(6388, 'cd18105', NULL, 'SpoU-like_MRM1', NULL, NULL, 'SpoU-like_MRM1', 6388),
(6389, 'cd09722', NULL, 'Cas1_I-B', NULL, NULL, 'Cas1_I-B', 6389),
(6390, 'cd12894', NULL, 'SPRY_PRY_TRIM36', NULL, NULL, 'SPRY_PRY_TRIM36', 6390),
(6391, 'cd02153', NULL, 'tRNA_bindingDomain', NULL, NULL, 'tRNA_bindingDomain', 6391),
(6392, 'cd05787', NULL, 'LbH_eIF2B_epsilon', NULL, NULL, 'LbH_eIF2B_epsilon', 6392),
(6393, 'cd09169', NULL, 'PLDc_PPK1_C2_unchar', NULL, NULL, 'PLDc_PPK1_C2_unchar', 6393);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(6394, 'cd05114', NULL, 'PTKc_Tec_Rlk', NULL, NULL, 'PTKc_Tec_Rlk', 6394),
(6395, 'cd01048', NULL, 'Ferritin_like_AB2', NULL, NULL, 'Ferritin_like_AB2', 6395),
(6396, 'cd08406', NULL, 'C2B_Synaptotagmin-12', NULL, NULL, 'C2B_Synaptotagmin-12', 6396),
(6397, 'cd12342', NULL, 'RRM_Nab3p', NULL, NULL, 'RRM_Nab3p', 6397),
(6398, 'cd19996', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, 'PBP1_ABC_sugar_binding-like', 6398),
(6399, 'cd09615', NULL, 'Jacalin_EEP', NULL, NULL, 'Jacalin_EEP', 6399),
(6400, 'cd11747', NULL, 'GH94N_like_1', NULL, NULL, 'GH94N_like_1', 6400),
(6401, 'cd14913', NULL, 'MYSc_Myh3', NULL, NULL, 'MYSc_Myh3', 6401),
(6402, 'cd02172', NULL, 'RfaE_N', NULL, NULL, 'RfaE_N', 6402),
(6403, 'cd15312', NULL, '7tmA_TAAR2_3_4', NULL, NULL, '7tmA_TAAR2_3_4', 6403),
(6404, 'cd05141', NULL, 'Barstar_evA4336-like', NULL, NULL, 'Barstar_evA4336-like', 6404),
(6405, 'cd09432', NULL, 'LIM6_LIMPETin', NULL, NULL, 'LIM6_LIMPETin', 6405),
(6406, 'cd09970', NULL, 'UP_IIIa', NULL, NULL, 'UP_IIIa', 6406),
(6407, 'cd13311', NULL, 'PH_Slm1', NULL, NULL, 'PH_Slm1', 6407),
(6408, 'cd13428', NULL, 'UreI_AmiS', NULL, NULL, 'UreI_AmiS', 6408),
(6409, 'cd12923', NULL, 'iSH2_PI3K_IA_R', NULL, NULL, 'iSH2_PI3K_IA_R', 6409),
(6410, 'cd00181', NULL, 'Tar_Tsr_LBD', NULL, NULL, 'Tar_Tsr_LBD', 6410),
(6411, 'cd12243', NULL, 'RRM1_MSSP', NULL, NULL, 'RRM1_MSSP', 6411),
(6412, 'cd10544', NULL, 'SET_SETMAR', NULL, NULL, 'SET_SETMAR', 6412),
(6413, 'cd15774', NULL, 'FYVE1_PCLO', NULL, NULL, 'FYVE1_PCLO', 6413),
(6414, 'cd18457', NULL, 'BACK_KLHL18', NULL, NULL, 'BACK_KLHL18', 6414),
(6415, 'cd12270', NULL, 'RRM_MTHFSD', NULL, NULL, 'RRM_MTHFSD', 6415),
(6416, 'cd04679', NULL, 'Nudix_Hydrolase_20', NULL, NULL, 'Nudix_Hydrolase_20', 6416),
(6417, 'cd09986', NULL, 'LOTUS_1_TDRD7', NULL, NULL, 'LOTUS_1_TDRD7', 6417),
(6418, 'cd09998', NULL, 'HDAC_Hos3', NULL, NULL, 'HDAC_Hos3', 6418),
(6419, 'cd15689', NULL, 'PHD1_MORF', NULL, NULL, 'PHD1_MORF', 6419),
(6420, 'cd01134', NULL, 'V_A-ATPase_A', NULL, NULL, 'V_A-ATPase_A', 6420),
(6421, 'cd13651', NULL, 'PBP2_ThiY', NULL, NULL, 'PBP2_ThiY', 6421),
(6422, 'cd14255', NULL, 'Dockerin_III', NULL, NULL, 'Dockerin_III', 6422),
(6423, 'cd10559', NULL, 'W-FDH', NULL, NULL, 'W-FDH', 6423),
(6424, 'cd16775', NULL, 'RING-HC_RBR_RNF19A', NULL, NULL, 'RING-HC_RBR_RNF19A', 6424),
(6425, 'cd03085', NULL, 'PGM1', NULL, NULL, 'PGM1', 6425),
(6426, 'cd08267', NULL, 'MDR1', NULL, NULL, 'MDR1', 6426),
(6427, 'cd00245', NULL, 'Glm_e', NULL, NULL, 'Glm_e', 6427),
(6428, 'cd12826', NULL, 'EcCorA_ZntB-like_u1', NULL, NULL, 'EcCorA_ZntB-like_u1', 6428),
(6429, 'cd15052', NULL, '7tmA_5-HT2', NULL, NULL, '7tmA_5-HT2', 6429),
(6430, 'cd16518', NULL, 'RING-HC_MEX3', NULL, NULL, 'RING-HC_MEX3', 6430),
(6431, 'cd21646', NULL, 'CoV_Nsp5_Mpro', NULL, NULL, 'CoV_Nsp5_Mpro', 6431),
(6432, 'cd01047', NULL, 'ACSF', NULL, NULL, 'ACSF', 6432),
(6433, 'cd16660', NULL, 'RING-Ubox_RNF37', NULL, NULL, 'RING-Ubox_RNF37', 6433),
(6434, 'cd18732', NULL, 'PIN_MtVapC4-C5_like', NULL, NULL, 'PIN_MtVapC4-C5_like', 6434),
(6435, 'cd02889', NULL, 'SQCY', NULL, NULL, 'SQCY', 6435),
(6436, 'cd02991', NULL, 'UAS_ETEA', NULL, NULL, 'UAS_ETEA', 6436),
(6437, 'cd19451', NULL, 'lipocalin_AGP-like', NULL, NULL, 'lipocalin_AGP-like', 6437),
(6438, 'cd01874', NULL, 'Cdc42', NULL, NULL, 'Cdc42', 6438),
(6439, 'cd13175', NULL, 'RanBD5_RanBP2_insect-like', NULL, NULL, 'RanBD5_RanBP2_insect-like', 6439),
(6440, 'cd05199', NULL, 'SDH_like', NULL, NULL, 'SDH_like', 6440),
(6441, 'cd13380', NULL, 'PH_Skap1', NULL, NULL, 'PH_Skap1', 6441),
(6442, 'cd14285', NULL, 'UBA_scEDE1_like', NULL, NULL, 'UBA_scEDE1_like', 6442),
(6443, 'cd11788', NULL, 'SH3_RasGAP', NULL, NULL, 'SH3_RasGAP', 6443),
(6444, 'cd12400', NULL, 'RRM_Nop6', NULL, NULL, 'RRM_Nop6', 6444),
(6445, 'cd10355', NULL, 'SH2_DAPP1_BAM32_like', NULL, NULL, 'SH2_DAPP1_BAM32_like', 6445),
(6446, 'cd12781', NULL, 'RRM1_hnRPLL', NULL, NULL, 'RRM1_hnRPLL', 6446),
(6447, 'cd17437', NULL, 'MFS_PLT', NULL, NULL, 'MFS_PLT', 6447),
(6448, 'cd17430', NULL, 'MFS_MCT3_4', NULL, NULL, 'MFS_MCT3_4', 6448); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(6449, 'cd03557', NULL, 'L-arabinose_isomerase', NULL, NULL, 'L-arabinose_isomerase', 6449),
(6450, 'cd08900', NULL, 'SRPBCC_CalC_Aha1-like_7', NULL, NULL, 'SRPBCC_CalC_Aha1-like_7', 6450),
(6451, 'cd09637', NULL, 'Cas4_I-A_I-B_I-C_I-D_II-B', NULL, NULL, 'Cas4_I-A_I-B_I-C_I-D_II-B', 6451),
(6452, 'cd07609', NULL, 'BAR_SIP3_fungi', NULL, NULL, 'BAR_SIP3_fungi', 6452),
(6453, 'cd03578', NULL, 'NTR_netrin-4_like', NULL, NULL, 'NTR_netrin-4_like', 6453),
(6454, 'cd11599', NULL, 'HDAC_classII_2', NULL, NULL, 'HDAC_classII_2', 6454),
(6455, 'cd16713', NULL, 'RING-HC_BIRC2_3_7', NULL, NULL, 'RING-HC_BIRC2_3_7', 6455),
(6456, 'cd12583', NULL, 'RRM2_hnRNPD', NULL, NULL, 'RRM2_hnRNPD', 6456),
(6457, 'cd01786', NULL, 'RA_STE50', NULL, NULL, 'RA_STE50', 6457),
(6458, 'cd13342', NULL, 'PH-GRAM_MTMR4', NULL, NULL, 'PH-GRAM_MTMR4', 6458),
(6459, 'cd05838', NULL, 'WHSC1_related', NULL, NULL, 'WHSC1_related', 6459),
(6460, 'cd06549', NULL, 'GH18_trifunctional', NULL, NULL, 'GH18_trifunctional', 6460),
(6461, 'cd07241', NULL, 'VOC_BsYyaH', NULL, NULL, 'VOC_BsYyaH', 6461),
(6462, 'cd15858', NULL, 'SNARE_VAM7', NULL, NULL, 'SNARE_VAM7', 6462),
(6463, 'cd21518', NULL, 'cv_beta_Nsp2_HKU9-like', NULL, NULL, 'cv_beta_Nsp2_HKU9-like', 6463),
(6464, 'cd16503', NULL, 'RING-HC_CHFR', NULL, NULL, 'RING-HC_CHFR', 6464),
(6465, 'cd14627', NULL, 'R-PTP-S-2', NULL, NULL, 'R-PTP-S-2', 6465),
(6466, 'cd12623', NULL, 'RRM_PPARGC1A', NULL, NULL, 'RRM_PPARGC1A', 6466),
(6467, 'cd00291', NULL, 'SirA_YedF_YeeD', NULL, NULL, 'SirA_YedF_YeeD', 6467),
(6468, 'cd00958', NULL, 'DhnA', NULL, NULL, 'DhnA', 6468),
(6469, 'cd01734', NULL, 'YlxS_C', NULL, NULL, 'YlxS_C', 6469),
(6470, 'cd10788', NULL, 'YdjC_like', NULL, NULL, 'YdjC_like', 6470),
(6471, 'cd09400', NULL, 'LIM_like_1', NULL, NULL, 'LIM_like_1', 6471),
(6472, 'cd04380', NULL, 'RhoGAP_OCRL1', NULL, NULL, 'RhoGAP_OCRL1', 6472),
(6473, 'cd19182', NULL, 'SET_KMT2E', NULL, NULL, 'SET_KMT2E', 6473),
(6474, 'cd19454', NULL, 'lipocalin_NP3', NULL, NULL, 'lipocalin_NP3', 6474),
(6475, 'cd05339', NULL, '17beta-HSDXI-like_SDR_c', NULL, NULL, '17beta-HSDXI-like_SDR_c', 6475),
(6476, 'cd12603', NULL, 'RRM_hnRNPC', NULL, NULL, 'RRM_hnRNPC', 6476),
(6477, 'cd10480', NULL, 'EphR_LBD_A2', NULL, NULL, 'EphR_LBD_A2', 6477),
(6478, 'cd11018', NULL, 'CuRO_6_FVIII_like', NULL, NULL, 'CuRO_6_FVIII_like', 6478),
(6479, 'cd05066', NULL, 'PTKc_EphR_A', NULL, NULL, 'PTKc_EphR_A', 6479),
(6480, 'cd19167', NULL, 'SET_SMYD1_2_3-like', NULL, NULL, 'SET_SMYD1_2_3-like', 6480),
(6481, 'cd14578', NULL, 'DUSP26', NULL, NULL, 'DUSP26', 6481),
(6482, 'cd10155', NULL, 'BsYrkD-like_DUF156', NULL, NULL, 'BsYrkD-like_DUF156', 6482),
(6483, 'cd16415', NULL, 'HAD_dREG-2_like', NULL, NULL, 'HAD_dREG-2_like', 6483),
(6484, 'cd17746', NULL, 'BRCT_Rad4_rpt2', NULL, NULL, 'BRCT_Rad4_rpt2', 6484),
(6485, 'cd09440', NULL, 'LIM1_SF3', NULL, NULL, 'LIM1_SF3', 6485),
(6486, 'cd07110', NULL, 'ALDH_F10_BADH', NULL, NULL, 'ALDH_F10_BADH', 6486),
(6487, 'cd06934', NULL, 'NR_LBD_PXR_like', NULL, NULL, 'NR_LBD_PXR_like', 6487),
(6488, 'cd01861', NULL, 'Rab6', NULL, NULL, 'Rab6', 6488),
(6489, 'cd14856', NULL, 'TRAPPC4_synbindin', NULL, NULL, 'TRAPPC4_synbindin', 6489),
(6490, 'cd09217', NULL, 'TLP-P', NULL, NULL, 'TLP-P', 6490),
(6491, 'cd13559', NULL, 'PBP2_SsuA_like_3', NULL, NULL, 'PBP2_SsuA_like_3', 6491),
(6492, 'cd00001', NULL, 'PTS_IIB_man', NULL, NULL, 'PTS_IIB_man', 6492),
(6493, 'cd08236', NULL, 'sugar_DH', NULL, NULL, 'sugar_DH', 6493),
(6494, 'cd11485', NULL, 'SLC-NCS1sbd_YbbW-like', NULL, NULL, 'SLC-NCS1sbd_YbbW-like', 6494),
(6495, 'cd12193', NULL, 'bZIP_GCN4', NULL, NULL, 'bZIP_GCN4', 6495),
(6496, 'cd06984', NULL, 'cupin_Moth_1897', NULL, NULL, 'cupin_Moth_1897', 6496),
(6497, 'cd08722', NULL, 'RGS_SNX14', NULL, NULL, 'RGS_SNX14', 6497),
(6498, 'cd14561', NULL, 'PTP_tensin-3', NULL, NULL, 'PTP_tensin-3', 6498),
(6499, 'cd14098', NULL, 'STKc_Rad53_Cds1', NULL, NULL, 'STKc_Rad53_Cds1', 6499),
(6500, 'cd11592', NULL, 'Agmatinase_PAH', NULL, NULL, 'Agmatinase_PAH', 6500),
(6501, 'cd07461', NULL, 'CRD_FZ8', NULL, NULL, 'CRD_FZ8', 6501);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(6502, 'cd12578', NULL, 'RRM1_hnRNPA_like', NULL, NULL, 'RRM1_hnRNPA_like', 6502),
(6503, 'cd05373', NULL, 'SDR_c10', NULL, NULL, 'SDR_c10', 6503),
(6504, 'cd13389', NULL, 'PH1_FGD5_FGD6', NULL, NULL, 'PH1_FGD5_FGD6', 6504),
(6505, 'cd00820', NULL, 'PEPCK_HprK', NULL, NULL, 'PEPCK_HprK', 6505),
(6506, 'cd11613', NULL, 'SAF_AH_GD', NULL, NULL, 'SAF_AH_GD', 6506),
(6507, 'cd14233', NULL, 'GAT_TOM1_like', NULL, NULL, 'GAT_TOM1_like', 6507),
(6508, 'cd00686', NULL, 'Terpene_cyclase_cis_trans_C1', NULL, NULL, 'Terpene_cyclase_cis_trans_C1', 6508),
(6509, 'cd10560', NULL, 'FDH-O_like', NULL, NULL, 'FDH-O_like', 6509),
(6510, 'cd08381', NULL, 'C2B_PI3K_class_II', NULL, NULL, 'C2B_PI3K_class_II', 6510),
(6511, 'cd14109', NULL, 'PK_Unc-89_rpt1', NULL, NULL, 'PK_Unc-89_rpt1', 6511),
(6512, 'cd00052', NULL, 'EH', NULL, NULL, 'EH', 6512),
(6513, 'cd06493', NULL, 'p23_NUDCD1_like', NULL, NULL, 'p23_NUDCD1_like', 6513),
(6514, 'cd11656', NULL, 'FBX4_GTPase_like', NULL, NULL, 'FBX4_GTPase_like', 6514),
(6515, 'cd10341', NULL, 'SH2_N-SH2_PLC_gamma_like', NULL, NULL, 'SH2_N-SH2_PLC_gamma_like', 6515),
(6516, 'cd11920', NULL, 'SH3_Sorbs2_1', NULL, NULL, 'SH3_Sorbs2_1', 6516),
(6517, 'cd19202', NULL, 'SET_SMYD2', NULL, NULL, 'SET_SMYD2', 6517),
(6518, 'cd03872', NULL, 'M14_CPA6', NULL, NULL, 'M14_CPA6', 6518),
(6519, 'cd14526', NULL, 'DSP_laforin-like', NULL, NULL, 'DSP_laforin-like', 6519),
(6520, 'cd08019', NULL, 'M20_Acy1-like', NULL, NULL, 'M20_Acy1-like', 6520),
(6521, 'cd10349', NULL, 'SH2_SH2D2A_SH2D7', NULL, NULL, 'SH2_SH2D2A_SH2D7', 6521),
(6522, 'cd07380', NULL, 'MPP_CWF19_N', NULL, NULL, 'MPP_CWF19_N', 6522),
(6523, 'cd04763', NULL, 'HTH_MlrA-like', NULL, NULL, 'HTH_MlrA-like', 6523),
(6524, 'cd03065', NULL, 'PDI_b_Calsequestrin_N', NULL, NULL, 'PDI_b_Calsequestrin_N', 6524),
(6525, 'cd10922', NULL, 'CE4_PelA_like_C', NULL, NULL, 'CE4_PelA_like_C', 6525),
(6526, 'cd05740', NULL, 'Ig_CEACAM', NULL, NULL, 'Ig_CEACAM', 6526),
(6527, 'cd16457', NULL, 'RING-H2_BRAP2', NULL, NULL, 'RING-H2_BRAP2', 6527),
(6528, 'cd18648', NULL, 'CD_Cbx6', NULL, NULL, 'CD_Cbx6', 6528),
(6529, 'cd19337', NULL, 'Wnt_Wnt5', NULL, NULL, 'Wnt_Wnt5', 6529),
(6530, 'cd06089', NULL, 'KOW_RPL26', NULL, NULL, 'KOW_RPL26', 6530),
(6531, 'cd16480', NULL, 'RING-H2_TRAIP', NULL, NULL, 'RING-H2_TRAIP', 6531),
(6532, 'cd16437', NULL, 'beta_Kdo_transferase_KpsC', NULL, NULL, 'beta_Kdo_transferase_KpsC', 6532),
(6533, 'cd04192', NULL, 'GT_2_like_e', NULL, NULL, 'GT_2_like_e', 6533),
(6534, 'cd18915', NULL, 'bHLH_AtLHW_like', NULL, NULL, 'bHLH_AtLHW_like', 6534),
(6535, 'cd07937', NULL, 'DRE_TIM_PC_TC_5S', NULL, NULL, 'DRE_TIM_PC_TC_5S', 6535),
(6536, 'cd03495', NULL, 'SQR_TypeC_SdhD_like', NULL, NULL, 'SQR_TypeC_SdhD_like', 6536),
(6537, 'cd03398', NULL, 'PAP2_haloperoxidase', NULL, NULL, 'PAP2_haloperoxidase', 6537),
(6538, 'cd03874', NULL, 'M28_PMSA_TfR_like', NULL, NULL, 'M28_PMSA_TfR_like', 6538),
(6539, 'cd10044', NULL, 'Reelin_repeat_8_subrepeat_1', NULL, NULL, 'Reelin_repeat_8_subrepeat_1', 6539),
(6540, 'cd10030', NULL, 'UDG-F4_TTUDGA_SPO1dp_like', NULL, NULL, 'UDG-F4_TTUDGA_SPO1dp_like', 6540),
(6541, 'cd16332', NULL, 'Prp-like', NULL, NULL, 'Prp-like', 6541),
(6542, 'cd03140', NULL, 'GATase1_PfpI_3', NULL, NULL, 'GATase1_PfpI_3', 6542),
(6543, 'cd17412', NULL, 'MFS_SLC15A1', NULL, NULL, 'MFS_SLC15A1', 6543),
(6544, 'cd01661', NULL, 'cbb3_Oxidase_I', NULL, NULL, 'cbb3_Oxidase_I', 6544),
(6545, 'cd10547', NULL, 'cupin_BacB_C', NULL, NULL, 'cupin_BacB_C', 6545),
(6546, 'cd12530', NULL, 'RRM3_EAR1_like', NULL, NULL, 'RRM3_EAR1_like', 6546),
(6547, 'cd19461', NULL, 'CRABP2', NULL, NULL, 'CRABP2', 6547),
(6548, 'cd08371', NULL, 'Lumazine_synthase-like', NULL, NULL, 'Lumazine_synthase-like', 6548),
(6549, 'cd19762', NULL, 'Bbox2_TRIM7-like', NULL, NULL, 'Bbox2_TRIM7-like', 6549),
(6550, 'cd08973', NULL, 'BaFpgNei_N_1', NULL, NULL, 'BaFpgNei_N_1', 6550),
(6551, 'cd04194', NULL, 'GT8_A4GalT_like', NULL, NULL, 'GT8_A4GalT_like', 6551),
(6552, 'cd04332', NULL, 'YbaK_like', NULL, NULL, 'YbaK_like', 6552),
(6553, 'cd02089', NULL, 'P-type_ATPase_Ca_prok', NULL, NULL, 'P-type_ATPase_Ca_prok', 6553);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(6554, 'cd02208', NULL, 'cupin_RmlC-like', NULL, NULL, 'cupin_RmlC-like', 6554),
(6555, 'cd11798', NULL, 'SH3_DNMBP_C1', NULL, NULL, 'SH3_DNMBP_C1', 6555),
(6556, 'cd17725', NULL, 'BRCT_XRCC1_rpt1', NULL, NULL, 'BRCT_XRCC1_rpt1', 6556),
(6557, 'cd06866', NULL, 'PX_SNX8_Mvp1p_like', NULL, NULL, 'PX_SNX8_Mvp1p_like', 6557),
(6558, 'cd10491', NULL, 'MH1_SMAD_2_3', NULL, NULL, 'MH1_SMAD_2_3', 6558),
(6559, 'cd17723', NULL, 'BRCT_Rad4_rpt4', NULL, NULL, 'BRCT_Rad4_rpt4', 6559),
(6560, 'cd08624', NULL, 'PI-PLCc_beta2', NULL, NULL, 'PI-PLCc_beta2', 6560),
(6561, 'cd08983', NULL, 'GH43_Bt3655-like', NULL, NULL, 'GH43_Bt3655-like', 6561),
(6562, 'cd12789', NULL, 'RasGAP_plexin_C1', NULL, NULL, 'RasGAP_plexin_C1', 6562),
(6563, 'cd13324', NULL, 'PH_Gab-like', NULL, NULL, 'PH_Gab-like', 6563),
(6564, 'cd14762', NULL, 'GS_STAS', NULL, NULL, 'GS_STAS', 6564),
(6565, 'cd01302', NULL, 'Cyclic_amidohydrolases', NULL, NULL, 'Cyclic_amidohydrolases', 6565),
(6566, 'cd12478', NULL, 'RRM1_U2B', NULL, NULL, 'RRM1_U2B', 6566),
(6567, 'cd08311', NULL, 'Death_p75NR', NULL, NULL, 'Death_p75NR', 6567),
(6568, 'cd02603', NULL, 'HAD_sEH-N_like', NULL, NULL, 'HAD_sEH-N_like', 6568),
(6569, 'cd02225', NULL, 'cupin_PA3510-like', NULL, NULL, 'cupin_PA3510-like', 6569),
(6570, 'cd02139', NULL, 'nitroreductase', NULL, NULL, 'nitroreductase', 6570),
(6571, 'cd15074', NULL, '7tmA_Opsin5_neuropsin', NULL, NULL, '7tmA_Opsin5_neuropsin', 6571),
(6572, 'cd15549', NULL, 'PHD_PHF20_like', NULL, NULL, 'PHD_PHF20_like', 6572),
(6573, 'cd15712', NULL, 'ePHD_PHF11', NULL, NULL, 'ePHD_PHF11', 6573),
(6574, 'cd19462', NULL, 'CRBP1', NULL, NULL, 'CRBP1', 6574),
(6575, 'cd18497', NULL, 'BACK_ABTB1_BPOZ', NULL, NULL, 'BACK_ABTB1_BPOZ', 6575),
(6576, 'cd14070', NULL, 'STKc_HUNK', NULL, NULL, 'STKc_HUNK', 6576),
(6577, 'cd09671', NULL, 'Csx1_III-U', NULL, NULL, 'Csx1_III-U', 6577),
(6578, 'cd01157', NULL, 'MCAD', NULL, NULL, 'MCAD', 6578),
(6579, 'cd15672', NULL, 'ePHD_AF10_like', NULL, NULL, 'ePHD_AF10_like', 6579),
(6580, 'cd15291', NULL, '7tmC_GABA-B-R1', NULL, NULL, '7tmC_GABA-B-R1', 6580),
(6581, 'cd04048', NULL, 'C2A_Copine', NULL, NULL, 'C2A_Copine', 6581),
(6582, 'cd16118', NULL, 'UBX2_UBXN9', NULL, NULL, 'UBX2_UBXN9', 6582),
(6583, 'cd19390', NULL, 'TGF_beta_BMP2', NULL, NULL, 'TGF_beta_BMP2', 6583),
(6584, 'cd19417', NULL, 'lipocalin_C8gamma', NULL, NULL, 'lipocalin_C8gamma', 6584),
(6585, 'cd03379', NULL, 'beta_CA_cladeD', NULL, NULL, 'beta_CA_cladeD', 6585),
(6586, 'cd16122', NULL, 'FERM_F1_SNX31', NULL, NULL, 'FERM_F1_SNX31', 6586),
(6587, 'cd11642', NULL, 'SUMT', NULL, NULL, 'SUMT', 6587),
(6588, 'cd05667', NULL, 'M20_Acy1-like', NULL, NULL, 'M20_Acy1-like', 6588),
(6589, 'cd06888', NULL, 'PX_FISH', NULL, NULL, 'PX_FISH', 6589),
(6590, 'cd00139', NULL, 'PIPKc', NULL, NULL, 'PIPKc', 6590),
(6591, 'cd17674', NULL, 'SWIB_BAF60A', NULL, NULL, 'SWIB_BAF60A', 6591),
(6592, 'cd07891', NULL, 'CYTH-like_CthTTM-like_1', NULL, NULL, 'CYTH-like_CthTTM-like_1', 6592),
(6593, 'cd01051', NULL, 'Mn_catalase', NULL, NULL, 'Mn_catalase', 6593),
(6594, 'cd00561', NULL, 'CobA_CobO_BtuR', NULL, NULL, 'CobA_CobO_BtuR', 6594),
(6595, 'cd15197', NULL, '7tmA_NPSR', NULL, NULL, '7tmA_NPSR', 6595),
(6596, 'cd09200', NULL, 'PLDc_pPLDbeta_2', NULL, NULL, 'PLDc_pPLDbeta_2', 6596),
(6597, 'cd11777', NULL, 'SH3_CIP4_Bzz1_like', NULL, NULL, 'SH3_CIP4_Bzz1_like', 6597),
(6598, 'cd06082', NULL, 'KOW_Spt5_2', NULL, NULL, 'KOW_Spt5_2', 6598),
(6599, 'cd15202', NULL, '7tmA_TACR-like', NULL, NULL, '7tmA_TACR-like', 6599),
(6600, 'cd13571', NULL, 'PBP2_PnhD_1', NULL, NULL, 'PBP2_PnhD_1', 6600),
(6601, 'cd06434', NULL, 'GT2_HAS', NULL, NULL, 'GT2_HAS', 6601),
(6602, 'cd18293', NULL, 'BTB_POZ_BTBD18', NULL, NULL, 'BTB_POZ_BTBD18', 6602),
(6603, 'cd11869', NULL, 'SH3_p40phox', NULL, NULL, 'SH3_p40phox', 6603),
(6604, 'cd13275', NULL, 'PH_M-RIP', NULL, NULL, 'PH_M-RIP', 6604),
(6605, 'cd10008', NULL, 'HDAC7', NULL, NULL, 'HDAC7', 6605),
(6606, 'cd16276', NULL, 'metallo-hydrolase-like_MBL-fold', NULL, NULL, 'metallo-hydrolase-like_MBL-fold', 6606),
(6607, 'cd18418', NULL, 'BTB_POZ_KCND2', NULL, NULL, 'BTB_POZ_KCND2', 6607);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(6608, 'cd05245', NULL, 'SDR_a2', NULL, NULL, 'SDR_a2', 6608),
(6609, 'cd11618', NULL, 'ChtBD1_1', NULL, NULL, 'ChtBD1_1', 6609),
(6610, 'cd07482', NULL, 'Peptidases_S8_Lantibiotic_specific_protease', NULL, NULL, 'Peptidases_S8_Lantibiotic_specific_protease', 6610),
(6611, 'cd08794', NULL, 'Death_IRAK1', NULL, NULL, 'Death_IRAK1', 6611),
(6612, 'cd00222', NULL, 'CollagenBindB', NULL, NULL, 'CollagenBindB', 6612),
(6613, 'cd05084', NULL, 'PTKc_Fes', NULL, NULL, 'PTKc_Fes', 6613),
(6614, 'cd21484', NULL, 'MHV-like_Spike_S1_RBD', NULL, NULL, 'MHV-like_Spike_S1_RBD', 6614),
(6615, 'cd05121', NULL, 'ABC1_ADCK3-like', NULL, NULL, 'ABC1_ADCK3-like', 6615),
(6616, 'cd04704', NULL, 'PLA2_bee_venom_like', NULL, NULL, 'PLA2_bee_venom_like', 6616),
(6617, 'cd19615', NULL, 'lipocalin_NP7', NULL, NULL, 'lipocalin_NP7', 6617),
(6618, 'cd14094', NULL, 'STKc_CASK', NULL, NULL, 'STKc_CASK', 6618),
(6619, 'cd19177', NULL, 'SET_SETD4', NULL, NULL, 'SET_SETD4', 6619),
(6620, 'cd04680', NULL, 'Nudix_Hydrolase_21', NULL, NULL, 'Nudix_Hydrolase_21', 6620),
(6621, 'cd03520', NULL, 'Link_domain_CSPGs_modules_2_4', NULL, NULL, 'Link_domain_CSPGs_modules_2_4', 6621),
(6622, 'cd07023', NULL, 'S49_Sppa_N_C', NULL, NULL, 'S49_Sppa_N_C', 6622),
(6623, 'cd09811', NULL, '3b-HSD_HSDB1_like_SDR_e', NULL, NULL, '3b-HSD_HSDB1_like_SDR_e', 6623),
(6624, 'cd12645', NULL, 'RRM_SRSF3', NULL, NULL, 'RRM_SRSF3', 6624),
(6625, 'cd05252', NULL, 'CDP_GD_SDR_e', NULL, NULL, 'CDP_GD_SDR_e', 6625),
(6626, 'cd11999', NULL, 'SH3_PACSIN_like', NULL, NULL, 'SH3_PACSIN_like', 6626),
(6627, 'cd14294', NULL, 'UBA1_UBP5_like', NULL, NULL, 'UBA1_UBP5_like', 6627),
(6628, 'cd13919', NULL, 'CuRO_HCO_II_like_5', NULL, NULL, 'CuRO_HCO_II_like_5', 6628),
(6629, 'cd19739', NULL, 'bHLH-PAS_SIM2', NULL, NULL, 'bHLH-PAS_SIM2', 6629),
(6630, 'cd00475', NULL, 'Cis_IPPS', NULL, NULL, 'Cis_IPPS', 6630),
(6631, 'cd03690', NULL, 'Tet_II', NULL, NULL, 'Tet_II', 6631),
(6632, 'cd00280', NULL, 'TRFH', NULL, NULL, 'TRFH', 6632),
(6633, 'cd11007', NULL, 'M35_like_1', NULL, NULL, 'M35_like_1', 6633),
(6634, 'cd09733', NULL, 'Cas6-I-III', NULL, NULL, 'Cas6-I-III', 6634),
(6635, 'cd18269', NULL, 'BTB_POZ_KLHL40-like', NULL, NULL, 'BTB_POZ_KLHL40-like', 6635),
(6636, 'cd03406', NULL, 'SPFH_like_u3', NULL, NULL, 'SPFH_like_u3', 6636),
(6637, 'cd05288', NULL, 'PGDH', NULL, NULL, 'PGDH', 6637),
(6638, 'cd14391', NULL, 'UBA_II_E2_UBCD4', NULL, NULL, 'UBA_II_E2_UBCD4', 6638),
(6639, 'cd06457', NULL, 'M3A_MIP', NULL, NULL, 'M3A_MIP', 6639),
(6640, 'cd17933', NULL, 'DEXSc_RecD-like', NULL, NULL, 'DEXSc_RecD-like', 6640),
(6641, 'cd17109', NULL, 'FERM_F1_SNX17_like', NULL, NULL, 'FERM_F1_SNX17_like', 6641),
(6642, 'cd14420', NULL, 'CUE_AUP1', NULL, NULL, 'CUE_AUP1', 6642),
(6643, 'cd07793', NULL, 'FGGY_GK5_metazoa', NULL, NULL, 'FGGY_GK5_metazoa', 6643),
(6644, 'cd17416', NULL, 'MFS_NPF1_2', NULL, NULL, 'MFS_NPF1_2', 6644),
(6645, 'cd08970', NULL, 'AcNei1_N', NULL, NULL, 'AcNei1_N', 6645),
(6646, 'cd17271', NULL, 'RMtype1_S_NmaSCMORF606P_TRD2-CR2_like', NULL, NULL, 'RMtype1_S_NmaSCMORF606P_TRD2-CR2_like', 6646),
(6647, 'cd15072', NULL, '7tmA_Retinal_GPR', NULL, NULL, '7tmA_Retinal_GPR', 6647),
(6648, 'cd19867', NULL, 'DSRM_DGCR8_rpt1', NULL, NULL, 'DSRM_DGCR8_rpt1', 6648),
(6649, 'cd07794', NULL, 'FGGY_GK_like_proteobact', NULL, NULL, 'FGGY_GK_like_proteobact', 6649),
(6650, 'cd15851', NULL, 'SNARE_Syntaxin6', NULL, NULL, 'SNARE_Syntaxin6', 6650),
(6651, 'cd18633', NULL, 'CD_MMP8', NULL, NULL, 'CD_MMP8', 6651),
(6652, 'cd00118', NULL, 'LysM', NULL, NULL, 'LysM', 6652),
(6653, 'cd00073', NULL, 'H15', NULL, NULL, 'H15', 6653),
(6654, 'cd16922', NULL, 'HATPase_EvgS-ArcB-TorS-like', NULL, NULL, 'HATPase_EvgS-ArcB-TorS-like', 6654),
(6655, 'cd15242', NULL, '7tm_Proteorhodopsin', NULL, NULL, '7tm_Proteorhodopsin', 6655),
(6656, 'cd06952', NULL, 'NR_LBD_TR2_like', NULL, NULL, 'NR_LBD_TR2_like', 6656),
(6657, 'cd11275', NULL, 'Sema_plexin_B1', NULL, NULL, 'Sema_plexin_B1', 6657),
(6658, 'cd18100', NULL, 'Trm10euk_B', NULL, NULL, 'Trm10euk_B', 6658),
(6659, 'cd11812', NULL, 'SH3_AHI-1', NULL, NULL, 'SH3_AHI-1', 6659);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(6660, 'cd18647', NULL, 'CD_Cbx2', NULL, NULL, 'CD_Cbx2', 6660),
(6661, 'cd02045', NULL, 'serpinC1_AT3', NULL, NULL, 'serpinC1_AT3', 6661),
(6662, 'cd17291', NULL, 'RMtype1_S_MgeORF438P-TRD-CR_like', NULL, NULL, 'RMtype1_S_MgeORF438P-TRD-CR_like', 6662),
(6663, 'cd13364', NULL, 'PH_PLC_eta', NULL, NULL, 'PH_PLC_eta', 6663),
(6664, 'cd11530', NULL, 'NTP-PPase_DR2231_like', NULL, NULL, 'NTP-PPase_DR2231_like', 6664),
(6665, 'cd05866', NULL, 'Ig1_NCAM-2', NULL, NULL, 'Ig1_NCAM-2', 6665),
(6666, 'cd05398', NULL, 'NT_ClassII-CCAase', NULL, NULL, 'NT_ClassII-CCAase', 6666),
(6667, 'cd18783', NULL, 'ABC_6TM_PrtD_LapB_HlyB_like', NULL, NULL, 'ABC_6TM_PrtD_LapB_HlyB_like', 6667),
(6668, 'cd00502', NULL, 'DHQase_I', NULL, NULL, 'DHQase_I', 6668),
(6669, 'cd06269', NULL, 'PBP1_glutamate_receptors-like', NULL, NULL, 'PBP1_glutamate_receptors-like', 6669),
(6670, 'cd12084', NULL, 'DD_R_PKA', NULL, NULL, 'DD_R_PKA', 6670),
(6671, 'cd08456', NULL, 'PBP2_LysR', NULL, NULL, 'PBP2_LysR', 6671),
(6672, 'cd16850', NULL, 'STAT6_DBD', NULL, NULL, 'STAT6_DBD', 6672),
(6673, 'cd17155', NULL, 'DCX_DCDC1', NULL, NULL, 'DCX_DCDC1', 6673),
(6674, 'cd19874', NULL, 'DSRM_MRPL44', NULL, NULL, 'DSRM_MRPL44', 6674),
(6675, 'cd08613', NULL, 'GDPD_GDE4_like_1', NULL, NULL, 'GDPD_GDE4_like_1', 6675),
(6676, 'cd06174', NULL, 'MFS', NULL, NULL, 'MFS', 6676),
(6677, 'cd03735', NULL, 'SOCS_SOCS1', NULL, NULL, 'SOCS_SOCS1', 6677),
(6678, 'cd00162', NULL, 'RING_Ubox', NULL, NULL, 'RING_Ubox', 6678),
(6679, 'cd04452', NULL, 'S1_IF2_alpha', NULL, NULL, 'S1_IF2_alpha', 6679),
(6680, 'cd02432', NULL, 'Nodulin-21_like_1', NULL, NULL, 'Nodulin-21_like_1', 6680),
(6681, 'cd16878', NULL, 'ARID_ARID3A', NULL, NULL, 'ARID_ARID3A', 6681),
(6682, 'cd06848', NULL, 'GCS_H', NULL, NULL, 'GCS_H', 6682),
(6683, 'cd08640', NULL, 'DNA_pol_A_plastid_like', NULL, NULL, 'DNA_pol_A_plastid_like', 6683),
(6684, 'cd07860', NULL, 'STKc_CDK2_3', NULL, NULL, 'STKc_CDK2_3', 6684),
(6685, 'cd19812', NULL, 'Bbox1_TRIM71_C-VII', NULL, NULL, 'Bbox1_TRIM71_C-VII', 6685),
(6686, 'cd08281', NULL, 'liver_ADH_like1', NULL, NULL, 'liver_ADH_like1', 6686),
(6687, 'cd00993', NULL, 'PBP2_ModA_like', NULL, NULL, 'PBP2_ModA_like', 6687),
(6688, 'cd07413', NULL, 'MPP_PA3087', NULL, NULL, 'MPP_PA3087', 6688),
(6689, 'cd01109', NULL, 'HTH_YyaN', NULL, NULL, 'HTH_YyaN', 6689),
(6690, 'cd10351', NULL, 'SH2_SH2D4B', NULL, NULL, 'SH2_SH2D4B', 6690),
(6691, 'cd13265', NULL, 'PH_evt', NULL, NULL, 'PH_evt', 6691),
(6692, 'cd18716', NULL, 'PIN_SSO1118-like', NULL, NULL, 'PIN_SSO1118-like', 6692),
(6693, 'cd21527', NULL, 'CoV_Spike_S1_NTD', NULL, NULL, 'CoV_Spike_S1_NTD', 6693),
(6694, 'cd00199', NULL, 'WAP', NULL, NULL, 'WAP', 6694),
(6695, 'cd06859', NULL, 'PX_SNX1_2_like', NULL, NULL, 'PX_SNX1_2_like', 6695),
(6696, 'cd19968', NULL, 'PBP1_ABC_IbpA-like', NULL, NULL, 'PBP1_ABC_IbpA-like', 6696),
(6697, 'cd02678', NULL, 'MIT_VPS4', NULL, NULL, 'MIT_VPS4', 6697),
(6698, 'cd20271', NULL, 'Complex1_LYR_FMC1', NULL, NULL, 'Complex1_LYR_FMC1', 6698),
(6699, 'cd18767', NULL, 'PIN_MtVapC3-like', NULL, NULL, 'PIN_MtVapC3-like', 6699),
(6700, 'cd16134', NULL, 'RA_RASSF8', NULL, NULL, 'RA_RASSF8', 6700),
(6701, 'cd12410', NULL, 'RRM2_RRT5', NULL, NULL, 'RRM2_RRT5', 6701),
(6702, 'cd12710', NULL, 'RRM_RCAN3', NULL, NULL, 'RRM_RCAN3', 6702),
(6703, 'cd06655', NULL, 'STKc_PAK2', NULL, NULL, 'STKc_PAK2', 6703),
(6704, 'cd00336', NULL, 'Ribosomal_L22', NULL, NULL, 'Ribosomal_L22', 6704),
(6705, 'cd14402', NULL, 'UBA_HERC2', NULL, NULL, 'UBA_HERC2', 6705),
(6706, 'cd18629', NULL, 'CD2_cpSRP43_like', NULL, NULL, 'CD2_cpSRP43_like', 6706),
(6707, 'cd21407', NULL, '1B_UPF1-like', NULL, NULL, '1B_UPF1-like', 6707),
(6708, 'cd15133', NULL, '7tmA_NMU-R', NULL, NULL, '7tmA_NMU-R', 6708),
(6709, 'cd13686', NULL, 'GluR_Plant', NULL, NULL, 'GluR_Plant', 6709),
(6710, 'cd07156', NULL, 'NR_DBD_VDR_like', NULL, NULL, 'NR_DBD_VDR_like', 6710),
(6711, 'cd01644', NULL, 'RT_pepA17', NULL, NULL, 'RT_pepA17', 6711),
(6712, 'cd12542', NULL, 'RRM2_LARP7', NULL, NULL, 'RRM2_LARP7', 6712),
(6713, 'cd01311', NULL, 'PDC_hydrolase', NULL, NULL, 'PDC_hydrolase', 6713);
INSERT INTO "PUBLIC"."MODEL" VALUES
(6714, 'cd11855', NULL, 'SH3_Sho1p', NULL, NULL, 'SH3_Sho1p', 6714),
(6715, 'cd09382', NULL, 'LIM2_Lhx6', NULL, NULL, 'LIM2_Lhx6', 6715),
(6716, 'cd10976', NULL, 'CE4_CDA_like_3', NULL, NULL, 'CE4_CDA_like_3', 6716),
(6717, 'cd12314', NULL, 'RRM1_RBM6', NULL, NULL, 'RRM1_RBM6', 6717),
(6718, 'cd20071', NULL, 'SET_SMYD', NULL, NULL, 'SET_SMYD', 6718),
(6719, 'cd00994', NULL, 'PBP2_GlnH', NULL, NULL, 'PBP2_GlnH', 6719),
(6720, 'cd07505', NULL, 'HAD_BPGM-like', NULL, NULL, 'HAD_BPGM-like', 6720),
(6721, 'cd16172', NULL, 'TorS_sensor_domain', NULL, NULL, 'TorS_sensor_domain', 6721),
(6722, 'cd02552', NULL, 'PseudoU_synth_TruD_like', NULL, NULL, 'PseudoU_synth_TruD_like', 6722),
(6723, 'cd00567', NULL, 'ACAD', NULL, NULL, 'ACAD', 6723),
(6724, 'cd11733', NULL, 'HSPA9-like_NBD', NULL, NULL, 'HSPA9-like_NBD', 6724),
(6725, 'cd09544', NULL, 'SAM_EPH-A3', NULL, NULL, 'SAM_EPH-A3', 6725),
(6726, 'cd12364', NULL, 'RRM_RDM1', NULL, NULL, 'RRM_RDM1', 6726),
(6727, 'cd14601', NULL, 'PTPc-N4', NULL, NULL, 'PTPc-N4', 6727),
(6728, 'cd12407', NULL, 'RRM_FOX1_like', NULL, NULL, 'RRM_FOX1_like', 6728),
(6729, 'cd08068', NULL, 'MPN_BRCC36', NULL, NULL, 'MPN_BRCC36', 6729),
(6730, 'cd15163', NULL, '7tmA_GPR20', NULL, NULL, '7tmA_GPR20', 6730),
(6731, 'cd13596', NULL, 'PBP2_lipoprotein_GmpC', NULL, NULL, 'PBP2_lipoprotein_GmpC', 6731),
(6732, 'cd09245', NULL, 'BRO1_UmRIM23-like', NULL, NULL, 'BRO1_UmRIM23-like', 6732),
(6733, 'cd09172', NULL, 'PLDc_Nuc_like_unchar1_1', NULL, NULL, 'PLDc_Nuc_like_unchar1_1', 6733),
(6734, 'cd00032', NULL, 'CASc', NULL, NULL, 'CASc', 6734),
(6735, 'cd13784', NULL, 'SP_1775_like', NULL, NULL, 'SP_1775_like', 6735),
(6736, 'cd19933', NULL, 'REC_ETR-like', NULL, NULL, 'REC_ETR-like', 6736),
(6737, 'cd02979', NULL, 'PHOX_C', NULL, NULL, 'PHOX_C', 6737),
(6738, 'cd14417', NULL, 'CUE_DMA_DMRTA1', NULL, NULL, 'CUE_DMA_DMRTA1', 6738),
(6739, 'cd14613', NULL, 'PTPc-N5', NULL, NULL, 'PTPc-N5', 6739),
(6740, 'cd15095', NULL, '7tmA_KiSS1R', NULL, NULL, '7tmA_KiSS1R', 6740),
(6741, 'cd00982', NULL, 'gltB_C', NULL, NULL, 'gltB_C', 6741),
(6742, 'cd17119', NULL, 'Ubl_HERP2', NULL, NULL, 'Ubl_HERP2', 6742),
(6743, 'cd11817', NULL, 'SH3_Eve1_4', NULL, NULL, 'SH3_Eve1_4', 6743),
(6744, 'cd08580', NULL, 'GDPD_Rv2277c_like', NULL, NULL, 'GDPD_Rv2277c_like', 6744),
(6745, 'cd05902', NULL, 'Ig_Neurocan', NULL, NULL, 'Ig_Neurocan', 6745),
(6746, 'cd16983', NULL, 'CID_SCAF8_like', NULL, NULL, 'CID_SCAF8_like', 6746),
(6747, 'cd09489', NULL, 'SAM_Smaug-like', NULL, NULL, 'SAM_Smaug-like', 6747),
(6748, 'cd14478', NULL, 'SPX_PHO87_PHO90_like', NULL, NULL, 'SPX_PHO87_PHO90_like', 6748),
(6749, 'cd11435', NULL, 'bHLH-PAS_AhRR', NULL, NULL, 'bHLH-PAS_AhRR', 6749),
(6750, 'cd16221', NULL, 'EFh_PI-PLCeta2', NULL, NULL, 'EFh_PI-PLCeta2', 6750),
(6751, 'cd03191', NULL, 'GST_C_Zeta', NULL, NULL, 'GST_C_Zeta', 6751),
(6752, 'cd12501', NULL, 'RRM_EcDbpA_like', NULL, NULL, 'RRM_EcDbpA_like', 6752),
(6753, 'cd07376', NULL, 'PLPDE_III_DSD_D-TA_like', NULL, NULL, 'PLPDE_III_DSD_D-TA_like', 6753),
(6754, 'cd01098', NULL, 'PAN_AP_plant', NULL, NULL, 'PAN_AP_plant', 6754),
(6755, 'cd03314', NULL, 'MAL', NULL, NULL, 'MAL', 6755),
(6756, 'cd18910', NULL, 'bHLHzip_USF3', NULL, NULL, 'bHLHzip_USF3', 6756),
(6757, 'cd09980', NULL, 'LOTUS_4_Limkain_b1', NULL, NULL, 'LOTUS_4_Limkain_b1', 6757),
(6758, 'cd15400', NULL, '7tmA_Mel1B', NULL, NULL, '7tmA_Mel1B', 6758),
(6759, 'cd05118', NULL, 'STKc_CMGC', NULL, NULL, 'STKc_CMGC', 6759),
(6760, 'cd07186', NULL, 'CofD_like', NULL, NULL, 'CofD_like', 6760),
(6761, 'cd13194', NULL, 'FERM_C_ERM', NULL, NULL, 'FERM_C_ERM', 6761),
(6762, 'cd07279', NULL, 'PX_SNX20_21_like', NULL, NULL, 'PX_SNX20_21_like', 6762),
(6763, 'cd14975', NULL, '7tmA_LTB4R', NULL, NULL, '7tmA_LTB4R', 6763),
(6764, 'cd06296', NULL, 'PBP1_CatR-like', NULL, NULL, 'PBP1_CatR-like', 6764),
(6765, 'cd10808', NULL, 'YdjC', NULL, NULL, 'YdjC', 6765),
(6766, 'cd00254', NULL, 'LT-like', NULL, NULL, 'LT-like', 6766),
(6767, 'cd10785', NULL, 'GH38-57_N_LamB_YdjC_SF', NULL, NULL, 'GH38-57_N_LamB_YdjC_SF', 6767),
(6768, 'cd19104', NULL, 'AKR_unchar', NULL, NULL, 'AKR_unchar', 6768);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(6769, 'cd18180', NULL, 'ATP-synt_Vo_Ao_c_NTPK_rpt2', NULL, NULL, 'ATP-synt_Vo_Ao_c_NTPK_rpt2', 6769),
(6770, 'cd08748', NULL, 'RGS_GRK1', NULL, NULL, 'RGS_GRK1', 6770),
(6771, 'cd05711', NULL, 'Ig2_LILR_KIR_like', NULL, NULL, 'Ig2_LILR_KIR_like', 6771),
(6772, 'cd17998', NULL, 'DEXHc_SMARCAD1', NULL, NULL, 'DEXHc_SMARCAD1', 6772),
(6773, 'cd17207', NULL, 'FERM_F1_PLEKHH3', NULL, NULL, 'FERM_F1_PLEKHH3', 6773),
(6774, 'cd21513', NULL, 'SUD_C_DPUP_CoV_Nsp3', NULL, NULL, 'SUD_C_DPUP_CoV_Nsp3', 6774),
(6775, 'cd16247', NULL, 'EFh_UTRO', NULL, NULL, 'EFh_UTRO', 6775),
(6776, 'cd16542', NULL, 'RING-HC_RNF125', NULL, NULL, 'RING-HC_RNF125', 6776),
(6777, 'cd06909', NULL, 'M14_ASPA', NULL, NULL, 'M14_ASPA', 6777),
(6778, 'cd09689', NULL, 'Cas7_I-C', NULL, NULL, 'Cas7_I-C', 6778),
(6779, 'cd06163', NULL, 'S2P-M50_PDZ_RseP-like', NULL, NULL, 'S2P-M50_PDZ_RseP-like', 6779),
(6780, 'cd12675', NULL, 'RRM2_Nop4p', NULL, NULL, 'RRM2_Nop4p', 6780),
(6781, 'cd20232', NULL, 'PFM_crystallin-like', NULL, NULL, 'PFM_crystallin-like', 6781),
(6782, 'cd06875', NULL, 'PX_IRAS', NULL, NULL, 'PX_IRAS', 6782),
(6783, 'cd14974', NULL, '7tmA_Anaphylatoxin_R-like', NULL, NULL, '7tmA_Anaphylatoxin_R-like', 6783),
(6784, 'cd07339', NULL, 'M48B_HtpX_like', NULL, NULL, 'M48B_HtpX_like', 6784),
(6785, 'cd12072', NULL, 'SH3_FNBP1L', NULL, NULL, 'SH3_FNBP1L', 6785),
(6786, 'cd08031', NULL, 'LARP_4_5_like', NULL, NULL, 'LARP_4_5_like', 6786),
(6787, 'cd18826', NULL, 'GH43_CtGH43-like', NULL, NULL, 'GH43_CtGH43-like', 6787),
(6788, 'cd08602', NULL, 'GDPD_ScGlpQ1_like', NULL, NULL, 'GDPD_ScGlpQ1_like', 6788),
(6789, 'cd14727', NULL, 'ChanN-like', NULL, NULL, 'ChanN-like', 6789),
(6790, 'cd00108', NULL, 'KR', NULL, NULL, 'KR', 6790),
(6791, 'cd08485', NULL, 'PBP2_ClcR', NULL, NULL, 'PBP2_ClcR', 6791),
(6792, 'cd17459', NULL, 'MFS_SLCO1C_OATP1C', NULL, NULL, 'MFS_SLCO1C_OATP1C', 6792),
(6793, 'cd15290', NULL, '7tmC_TAS1R3', NULL, NULL, '7tmC_TAS1R3', 6793),
(6794, 'cd03855', NULL, 'M14_ASTE', NULL, NULL, 'M14_ASTE', 6794),
(6795, 'cd02181', NULL, 'GH16_fungal_Lam16A_glucanase', NULL, NULL, 'GH16_fungal_Lam16A_glucanase', 6795),
(6796, 'cd13244', NULL, 'PH_PLEKHG5_G6', NULL, NULL, 'PH_PLEKHG5_G6', 6796),
(6797, 'cd16552', NULL, 'RING-HC_NEURL3', NULL, NULL, 'RING-HC_NEURL3', 6797),
(6798, 'cd10429', NULL, 'GAAP_like', NULL, NULL, 'GAAP_like', 6798),
(6799, 'cd04673', NULL, 'Nudix_Hydrolase_15', NULL, NULL, 'Nudix_Hydrolase_15', 6799),
(6800, 'cd01678', NULL, 'PFL1', NULL, NULL, 'PFL1', 6800),
(6801, 'cd10336', NULL, 'SLC6sbd_Tyt1-Like', NULL, NULL, 'SLC6sbd_Tyt1-Like', 6801),
(6802, 'cd13991', NULL, 'STKc_NIK', NULL, NULL, 'STKc_NIK', 6802),
(6803, 'cd12582', NULL, 'RRM2_hnRNPA3', NULL, NULL, 'RRM2_hnRNPA3', 6803),
(6804, 'cd01427', NULL, 'HAD_like', NULL, NULL, 'HAD_like', 6804),
(6805, 'cd17527', NULL, 'HAMP_II', NULL, NULL, 'HAMP_II', 6805),
(6806, 'cd06843', NULL, 'PLPDE_III_PvsE_like', NULL, NULL, 'PLPDE_III_PvsE_like', 6806),
(6807, 'cd06344', NULL, 'PBP1_ABC_HAAT-like', NULL, NULL, 'PBP1_ABC_HAAT-like', 6807),
(6808, 'cd19382', NULL, 'TGF_beta_Persephin', NULL, NULL, 'TGF_beta_Persephin', 6808),
(6809, 'cd06099', NULL, 'CS_ACL-C_CCL', NULL, NULL, 'CS_ACL-C_CCL', 6809),
(6810, 'cd13394', NULL, 'Syo1_like', NULL, NULL, 'Syo1_like', 6810),
(6811, 'cd18978', NULL, 'CD_DDE_transposase_like', NULL, NULL, 'CD_DDE_transposase_like', 6811),
(6812, 'cd09576', NULL, 'SAM_DGK-eta', NULL, NULL, 'SAM_DGK-eta', 6812),
(6813, 'cd18251', NULL, 'BTB_POZ_KLHL22', NULL, NULL, 'BTB_POZ_KLHL22', 6813),
(6814, 'cd06261', NULL, 'TM_PBP2', NULL, NULL, 'TM_PBP2', 6814),
(6815, 'cd16190', NULL, 'EFh_PEF_CAPN3', NULL, NULL, 'EFh_PEF_CAPN3', 6815),
(6816, 'cd17756', NULL, 'MCM5', NULL, NULL, 'MCM5', 6816),
(6817, 'cd02210', NULL, 'cupin_BLR2406-like', NULL, NULL, 'cupin_BLR2406-like', 6817),
(6818, 'cd15066', NULL, '7tmA_DmOct-betaAR-like', NULL, NULL, '7tmA_DmOct-betaAR-like', 6818),
(6819, 'cd00447', NULL, 'NusB_Sun', NULL, NULL, 'NusB_Sun', 6819),
(6820, 'cd02940', NULL, 'DHPD_FMN', NULL, NULL, 'DHPD_FMN', 6820),
(6821, 'cd17814', NULL, 'Fe-ADH-like', NULL, NULL, 'Fe-ADH-like', 6821);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(6822, 'cd05604', NULL, 'STKc_SGK3', NULL, NULL, 'STKc_SGK3', 6822),
(6823, 'cd03393', NULL, 'PAP2_like_3', NULL, NULL, 'PAP2_like_3', 6823),
(6824, 'cd05836', NULL, 'N_Pac_NP60', NULL, NULL, 'N_Pac_NP60', 6824),
(6825, 'cd03166', NULL, 'CD63_LEL', NULL, NULL, 'CD63_LEL', 6825),
(6826, 'cd01554', NULL, 'EPT-like', NULL, NULL, 'EPT-like', 6826),
(6827, 'cd01186', NULL, 'INT_tnpA_C_Tn554', NULL, NULL, 'INT_tnpA_C_Tn554', 6827),
(6828, 'cd19877', NULL, 'DSRM_RNAse_III_meta_like', NULL, NULL, 'DSRM_RNAse_III_meta_like', 6828),
(6829, 'cd11877', NULL, 'SH3_PIX', NULL, NULL, 'SH3_PIX', 6829),
(6830, 'cd16176', NULL, 'EFh_HEF_CB', NULL, NULL, 'EFh_HEF_CB', 6830),
(6831, 'cd19429', NULL, 'lipocalin_9', NULL, NULL, 'lipocalin_9', 6831),
(6832, 'cd07457', NULL, 'CRD_FZ9_like', NULL, NULL, 'CRD_FZ9_like', 6832),
(6833, 'cd20009', NULL, 'PBP1_RafR-like', NULL, NULL, 'PBP1_RafR-like', 6833),
(6834, 'cd00201', NULL, 'WW', NULL, NULL, 'WW', 6834),
(6835, 'cd01458', NULL, 'vWA_ku', NULL, NULL, 'vWA_ku', 6835),
(6836, 'cd01208', NULL, 'PTB_X11', NULL, NULL, 'PTB_X11', 6836),
(6837, 'cd03386', NULL, 'PAP2_Aur1_like', NULL, NULL, 'PAP2_Aur1_like', 6837),
(6838, 'cd15885', NULL, 'SNARE_SNAP25C', NULL, NULL, 'SNARE_SNAP25C', 6838),
(6839, 'cd00313', NULL, 'ATP-synt_Fo_Vo_Ao_c', NULL, NULL, 'ATP-synt_Fo_Vo_Ao_c', 6839),
(6840, 'cd07982', NULL, 'TAF10', NULL, NULL, 'TAF10', 6840),
(6841, 'cd14307', NULL, 'UBA_RUP1p', NULL, NULL, 'UBA_RUP1p', 6841),
(6842, 'cd18719', NULL, 'PIN_Zc3h12a-N4BP1-like', NULL, NULL, 'PIN_Zc3h12a-N4BP1-like', 6842),
(6843, 'cd08971', NULL, 'AcNei2_N', NULL, NULL, 'AcNei2_N', 6843),
(6844, 'cd14065', NULL, 'PKc_LIMK_like', NULL, NULL, 'PKc_LIMK_like', 6844),
(6845, 'cd02135', NULL, 'YdjA-like', NULL, NULL, 'YdjA-like', 6845),
(6846, 'cd13164', NULL, 'PTB_DOK4_DOK5_DOK6', NULL, NULL, 'PTB_DOK4_DOK5_DOK6', 6846),
(6847, 'cd15007', NULL, '7tmA_GPR75', NULL, NULL, '7tmA_GPR75', 6847),
(6848, 'cd18632', NULL, 'CD_Clr4_like', NULL, NULL, 'CD_Clr4_like', 6848),
(6849, 'cd15686', NULL, 'PHD3_KDM5A', NULL, NULL, 'PHD3_KDM5A', 6849),
(6850, 'cd02334', NULL, 'ZZ_dystrophin', NULL, NULL, 'ZZ_dystrophin', 6850),
(6851, 'cd12212', NULL, 'Fis1', NULL, NULL, 'Fis1', 6851),
(6852, 'cd19895', NULL, 'DSRM_RED1_rpt1', NULL, NULL, 'DSRM_RED1_rpt1', 6852),
(6853, 'cd04188', NULL, 'DPG_synthase', NULL, NULL, 'DPG_synthase', 6853),
(6854, 'cd17177', NULL, 'FERM_F0_SHANK3', NULL, NULL, 'FERM_F0_SHANK3', 6854),
(6855, 'cd14277', NULL, 'UBA_UBP2_like', NULL, NULL, 'UBA_UBP2_like', 6855),
(6856, 'cd05531', NULL, 'POLBc_B2', NULL, NULL, 'POLBc_B2', 6856),
(6857, 'cd18804', NULL, 'SF2_C_priA', NULL, NULL, 'SF2_C_priA', 6857),
(6858, 'cd19063', NULL, 'LGIC_TM_5-HT3', NULL, NULL, 'LGIC_TM_5-HT3', 6858),
(6859, 'cd14095', NULL, 'STKc_DCKL', NULL, NULL, 'STKc_DCKL', 6859),
(6860, 'cd03066', NULL, 'PDI_b_Calsequestrin_middle', NULL, NULL, 'PDI_b_Calsequestrin_middle', 6860),
(6861, 'cd11799', NULL, 'SH3_ARHGEF37_C1', NULL, NULL, 'SH3_ARHGEF37_C1', 6861),
(6862, 'cd08463', NULL, 'PBP2_DntR_like_4', NULL, NULL, 'PBP2_DntR_like_4', 6862),
(6863, 'cd10431', NULL, 'GHITM', NULL, NULL, 'GHITM', 6863),
(6864, 'cd06808', NULL, 'PLPDE_III', NULL, NULL, 'PLPDE_III', 6864),
(6865, 'cd02553', NULL, 'PseudoU_synth_RsuA', NULL, NULL, 'PseudoU_synth_RsuA', 6865),
(6866, 'cd18683', NULL, 'PIN_VapC-like', NULL, NULL, 'PIN_VapC-like', 6866),
(6867, 'cd02986', NULL, 'DLP', NULL, NULL, 'DLP', 6867),
(6868, 'cd08044', NULL, 'TAF5_NTD2', NULL, NULL, 'TAF5_NTD2', 6868),
(6869, 'cd07073', NULL, 'NR_LBD_AR', NULL, NULL, 'NR_LBD_AR', 6869),
(6870, 'cd01034', NULL, 'EriC_like', NULL, NULL, 'EriC_like', 6870),
(6871, 'cd12116', NULL, 'A_NRPS_Ta1_like', NULL, NULL, 'A_NRPS_Ta1_like', 6871),
(6872, 'cd15896', NULL, 'MYSc_Myh19', NULL, NULL, 'MYSc_Myh19', 6872),
(6873, 'cd03348', NULL, 'pro_PheOH', NULL, NULL, 'pro_PheOH', 6873),
(6874, 'cd03697', NULL, 'EFTU_II', NULL, NULL, 'EFTU_II', 6874),
(6875, 'cd04390', NULL, 'RhoGAP_ARHGAP22_24_25', NULL, NULL, 'RhoGAP_ARHGAP22_24_25', 6875),
(6876, 'cd20276', NULL, 'Sarcolamban_A', NULL, NULL, 'Sarcolamban_A', 6876);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(6877, 'cd15894', NULL, 'SNARE_SNAP25N', NULL, NULL, 'SNARE_SNAP25N', 6877),
(6878, 'cd01303', NULL, 'GDEase', NULL, NULL, 'GDEase', 6878),
(6879, 'cd13861', NULL, 'CuRO_1_CumA_like', NULL, NULL, 'CuRO_1_CumA_like', 6879),
(6880, 'cd17955', NULL, 'DEADc_DDX49', NULL, NULL, 'DEADc_DDX49', 6880),
(6881, 'cd04712', NULL, 'BAH_DCM_I', NULL, NULL, 'BAH_DCM_I', 6881),
(6882, 'cd14259', NULL, 'PUFD_like', NULL, NULL, 'PUFD_like', 6882),
(6883, 'cd17152', NULL, 'DCX2_DCDC2', NULL, NULL, 'DCX2_DCDC2', 6883),
(6884, 'cd01236', NULL, 'PH_RIP', NULL, NULL, 'PH_RIP', 6884),
(6885, 'cd14165', NULL, 'STKc_TSSK1_2-like', NULL, NULL, 'STKc_TSSK1_2-like', 6885),
(6886, 'cd03074', NULL, 'PDI_b''_Calsequestrin_C', NULL, NULL, 'PDI_b''_Calsequestrin_C', 6886),
(6887, 'cd04214', NULL, 'PAD_N', NULL, NULL, 'PAD_N', 6887),
(6888, 'cd03576', NULL, 'NTR_PCOLCE', NULL, NULL, 'NTR_PCOLCE', 6888),
(6889, 'cd07343', NULL, 'M48A_Zmpste24p_like', NULL, NULL, 'M48A_Zmpste24p_like', 6889),
(6890, 'cd05694', NULL, 'S1_Rrp5_repeat_hs2_sc2', NULL, NULL, 'S1_Rrp5_repeat_hs2_sc2', 6890),
(6891, 'cd02619', NULL, 'Peptidase_C1', NULL, NULL, 'Peptidase_C1', 6891),
(6892, 'cd07000', NULL, 'cupin_HGO_N', NULL, NULL, 'cupin_HGO_N', 6892),
(6893, 'cd11983', NULL, 'SH3_Shank2', NULL, NULL, 'SH3_Shank2', 6893),
(6894, 'cd05256', NULL, 'UDP_AE_SDR_e', NULL, NULL, 'UDP_AE_SDR_e', 6894),
(6895, 'cd15286', NULL, '7tmC_mGluR_group3', NULL, NULL, '7tmC_mGluR_group3', 6895),
(6896, 'cd15499', NULL, 'PHD1_MTF2_PHF19_like', NULL, NULL, 'PHD1_MTF2_PHF19_like', 6896),
(6897, 'cd16364', NULL, 'T3SC_I_like', NULL, NULL, 'T3SC_I_like', 6897),
(6898, 'cd12362', NULL, 'RRM3_CELF1-6', NULL, NULL, 'RRM3_CELF1-6', 6898),
(6899, 'cd12502', NULL, 'RRM2_RMB19', NULL, NULL, 'RRM2_RMB19', 6899),
(6900, 'cd11400', NULL, 'bHLHzip_Myc', NULL, NULL, 'bHLHzip_Myc', 6900),
(6901, 'cd14306', NULL, 'UBA_VP13D', NULL, NULL, 'UBA_VP13D', 6901),
(6902, 'cd10296', NULL, 'GST_C_CLIC4', NULL, NULL, 'GST_C_CLIC4', 6902),
(6903, 'cd11946', NULL, 'SH3_GRB2_N', NULL, NULL, 'SH3_GRB2_N', 6903),
(6904, 'cd00253', NULL, 'PL_Passenger_AT', NULL, NULL, 'PL_Passenger_AT', 6904),
(6905, 'cd10358', NULL, 'SH2_PTK6_Brk', NULL, NULL, 'SH2_PTK6_Brk', 6905),
(6906, 'cd18926', NULL, 'bHLHzip_MITF', NULL, NULL, 'bHLHzip_MITF', 6906),
(6907, 'cd18658', NULL, 'CSD_HP1a_insect', NULL, NULL, 'CSD_HP1a_insect', 6907),
(6908, 'cd08493', NULL, 'PBP2_DppA_like', NULL, NULL, 'PBP2_DppA_like', 6908),
(6909, 'cd03721', NULL, 'SOCS_ASB2', NULL, NULL, 'SOCS_ASB2', 6909),
(6910, 'cd15970', NULL, '7tmA_SSTR1', NULL, NULL, '7tmA_SSTR1', 6910),
(6911, 'cd18257', NULL, 'BTB_POZ_KLHL28_BTBD5', NULL, NULL, 'BTB_POZ_KLHL28_BTBD5', 6911),
(6912, 'cd00584', NULL, 'Prefoldin_alpha', NULL, NULL, 'Prefoldin_alpha', 6912),
(6913, 'cd16471', NULL, 'RING-H2_RNF32', NULL, NULL, 'RING-H2_RNF32', 6913),
(6914, 'cd10582', NULL, 'TNFRSF14', NULL, NULL, 'TNFRSF14', 6914),
(6915, 'cd16101', NULL, 'ING', NULL, NULL, 'ING', 6915),
(6916, 'cd12000', NULL, 'SH3_CASS4', NULL, NULL, 'SH3_CASS4', 6916),
(6917, 'cd03057', NULL, 'GST_N_Beta', NULL, NULL, 'GST_N_Beta', 6917),
(6918, 'cd14027', NULL, 'STKc_RIP1', NULL, NULL, 'STKc_RIP1', 6918),
(6919, 'cd17260', NULL, 'RMtype1_S_EcoEI-TRD1-CR1_like', NULL, NULL, 'RMtype1_S_EcoEI-TRD1-CR1_like', 6919),
(6920, 'cd03505', NULL, 'Delta9-FADS-like', NULL, NULL, 'Delta9-FADS-like', 6920),
(6921, 'cd15037', NULL, '7tmF_FZD10', NULL, NULL, '7tmF_FZD10', 6921),
(6922, 'cd15252', NULL, '7tmB2_Latrophilin_Adhesion_I', NULL, NULL, '7tmB2_Latrophilin_Adhesion_I', 6922),
(6923, 'cd16194', NULL, 'EFh_PEF_CAPN12', NULL, NULL, 'EFh_PEF_CAPN12', 6923),
(6924, 'cd10446', NULL, 'GIY-YIG_unchar_1', NULL, NULL, 'GIY-YIG_unchar_1', 6924),
(6925, 'cd13963', NULL, 'PT_UbiA_2', NULL, NULL, 'PT_UbiA_2', 6925),
(6926, 'cd16302', NULL, 'CcrA-like_MBL-B1', NULL, NULL, 'CcrA-like_MBL-B1', 6926),
(6927, 'cd04440', NULL, 'DEP_2_P-Rex', NULL, NULL, 'DEP_2_P-Rex', 6927),
(6928, 'cd16368', NULL, 'DMSOR_beta_like', NULL, NULL, 'DMSOR_beta_like', 6928),
(6929, 'cd12366', NULL, 'RRM1_RBM45', NULL, NULL, 'RRM1_RBM45', 6929);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(6930, 'cd08022', NULL, 'M28_PSMA_like', NULL, NULL, 'M28_PSMA_like', 6930),
(6931, 'cd04782', NULL, 'HTH_BltR', NULL, NULL, 'HTH_BltR', 6931),
(6932, 'cd09591', NULL, 'SAM_DLC1', NULL, NULL, 'SAM_DLC1', 6932),
(6933, 'cd10383', NULL, 'SH2_SOCS2', NULL, NULL, 'SH2_SOCS2', 6933),
(6934, 'cd15210', NULL, '7tmA_GPR84-like', NULL, NULL, '7tmA_GPR84-like', 6934),
(6935, 'cd12294', NULL, 'RRM_Rrp7A', NULL, NULL, 'RRM_Rrp7A', 6935),
(6936, 'cd19727', NULL, 'bHLH-PAS_HIF1a_PASD8', NULL, NULL, 'bHLH-PAS_HIF1a_PASD8', 6936),
(6937, 'cd19879', NULL, 'DSRM_STAU1_rpt1', NULL, NULL, 'DSRM_STAU1_rpt1', 6937),
(6938, 'cd18773', NULL, 'PDC1_HK_sensor', NULL, NULL, 'PDC1_HK_sensor', 6938),
(6939, 'cd04868', NULL, 'ACT_AK-like', NULL, NULL, 'ACT_AK-like', 6939),
(6940, 'cd18175', NULL, 'ATP-synt_Vo_c_ATP6C_rpt1', NULL, NULL, 'ATP-synt_Vo_c_ATP6C_rpt1', 6940),
(6941, 'cd12067', NULL, 'SH3_MYO15A', NULL, NULL, 'SH3_MYO15A', 6941),
(6942, 'cd12601', NULL, 'RRM2_SRSF1_like', NULL, NULL, 'RRM2_SRSF1_like', 6942),
(6943, 'cd09756', NULL, 'Cas5_I-E', NULL, NULL, 'Cas5_I-E', 6943),
(6944, 'cd10229', NULL, 'HSPA12_like_NBD', NULL, NULL, 'HSPA12_like_NBD', 6944),
(6945, 'cd09553', NULL, 'SAM_EPH-B3', NULL, NULL, 'SAM_EPH-B3', 6945),
(6946, 'cd07719', NULL, 'arylsulfatase_AtsA-like_MBL-fold', NULL, NULL, 'arylsulfatase_AtsA-like_MBL-fold', 6946),
(6947, 'cd19169', NULL, 'SET_SETD1', NULL, NULL, 'SET_SETD1', 6947),
(6948, 'cd01268', NULL, 'PTB_Numb', NULL, NULL, 'PTB_Numb', 6948),
(6949, 'cd11677', NULL, 'Gemin7', NULL, NULL, 'Gemin7', 6949),
(6950, 'cd06827', NULL, 'PLPDE_III_AR_proteobact', NULL, NULL, 'PLPDE_III_AR_proteobact', 6950),
(6951, 'cd13266', NULL, 'PH_Skap_family', NULL, NULL, 'PH_Skap_family', 6951),
(6952, 'cd09160', NULL, 'PLDc_SMU_988_like_2', NULL, NULL, 'PLDc_SMU_988_like_2', 6952),
(6953, 'cd13205', NULL, 'FERM_C_fermitin', NULL, NULL, 'FERM_C_fermitin', 6953),
(6954, 'cd10805', NULL, 'YdjC_like_1', NULL, NULL, 'YdjC_like_1', 6954),
(6955, 'cd17309', NULL, 'PIPKc_PIP5K2A', NULL, NULL, 'PIPKc_PIP5K2A', 6955),
(6956, 'cd19814', NULL, 'Bbox1_RNF207-like', NULL, NULL, 'Bbox1_RNF207-like', 6956),
(6957, 'cd07970', NULL, 'OBF_DNA_ligase_LigC', NULL, NULL, 'OBF_DNA_ligase_LigC', 6957),
(6958, 'cd18611', NULL, 'GH130', NULL, NULL, 'GH130', 6958),
(6959, 'cd20255', NULL, 'CASIMO1_SMIM22', NULL, NULL, 'CASIMO1_SMIM22', 6959),
(6960, 'cd07164', NULL, 'NR_DBD_PNR_like_1', NULL, NULL, 'NR_DBD_PNR_like_1', 6960),
(6961, 'cd13778', NULL, 'Aar2_C', NULL, NULL, 'Aar2_C', 6961),
(6962, 'cd09561', NULL, 'SAM_SAMSN1', NULL, NULL, 'SAM_SAMSN1', 6962),
(6963, 'cd15180', NULL, '7tmA_CXCR3', NULL, NULL, '7tmA_CXCR3', 6963),
(6964, 'cd00987', NULL, 'PDZ_serine_protease', NULL, NULL, 'PDZ_serine_protease', 6964),
(6965, 'cd12385', NULL, 'RRM1_hnRNPM_like', NULL, NULL, 'RRM1_hnRNPM_like', 6965),
(6966, 'cd15054', NULL, '7tmA_5-HT6', NULL, NULL, '7tmA_5-HT6', 6966),
(6967, 'cd12112', NULL, 'PHP_HisPPase_Chlorobi_like', NULL, NULL, 'PHP_HisPPase_Chlorobi_like', 6967),
(6968, 'cd16110', NULL, 'DCX1_RP_like', NULL, NULL, 'DCX1_RP_like', 6968),
(6969, 'cd07414', NULL, 'MPP_PP1_PPKL', NULL, NULL, 'MPP_PP1_PPKL', 6969),
(6970, 'cd11843', NULL, 'SH3_PACSIN', NULL, NULL, 'SH3_PACSIN', 6970),
(6971, 'cd12474', NULL, 'RRM2_MSSP2', NULL, NULL, 'RRM2_MSSP2', 6971),
(6972, 'cd09344', NULL, 'LIM1_FHL1', NULL, NULL, 'LIM1_FHL1', 6972),
(6973, 'cd12065', NULL, 'SH3_GRAF2', NULL, NULL, 'SH3_GRAF2', 6973),
(6974, 'cd01292', NULL, 'metallo-dependent_hydrolases', NULL, NULL, 'metallo-dependent_hydrolases', 6974),
(6975, 'cd09806', NULL, 'type1_17beta-HSD-like_SDR_c', NULL, NULL, 'type1_17beta-HSD-like_SDR_c', 6975),
(6976, 'cd07098', NULL, 'ALDH_F15-22', NULL, NULL, 'ALDH_F15-22', 6976),
(6977, 'cd08457', NULL, 'PBP2_OccR', NULL, NULL, 'PBP2_OccR', 6977),
(6978, 'cd18317', NULL, 'BTB_POZ_Kv', NULL, NULL, 'BTB_POZ_Kv', 6978),
(6979, 'cd04860', NULL, 'AE_Prim_S', NULL, NULL, 'AE_Prim_S', 6979),
(6980, 'cd03222', NULL, 'ABC_RNaseL_inhibitor', NULL, NULL, 'ABC_RNaseL_inhibitor', 6980),
(6981, 'cd17714', NULL, 'BRCT_PAXIP1_rpt1', NULL, NULL, 'BRCT_PAXIP1_rpt1', 6981);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(6982, 'cd14051', NULL, 'PTKc_Wee1', NULL, NULL, 'PTKc_Wee1', 6982),
(6983, 'cd15989', NULL, '7tmB2_BAI3', NULL, NULL, '7tmB2_BAI3', 6983),
(6984, 'cd02854', NULL, 'E_set_GBE_euk_N', NULL, NULL, 'E_set_GBE_euk_N', 6984),
(6985, 'cd20315', NULL, 'DSRM_mL44_subfamily', NULL, NULL, 'DSRM_mL44_subfamily', 6985),
(6986, 'cd07143', NULL, 'ALDH_AldA_AN0554', NULL, NULL, 'ALDH_AldA_AN0554', 6986),
(6987, 'cd07324', NULL, 'M48C_Oma1-like', NULL, NULL, 'M48C_Oma1-like', 6987),
(6988, 'cd15393', NULL, '7tmA_leucokinin-like', NULL, NULL, '7tmA_leucokinin-like', 6988),
(6989, 'cd06103', NULL, 'ScCS-like', NULL, NULL, 'ScCS-like', 6989),
(6990, 'cd15619', NULL, 'PHD1_d4', NULL, NULL, 'PHD1_d4', 6990),
(6991, 'cd19729', NULL, 'bHLH-PAS_HIF3a_PASD7', NULL, NULL, 'bHLH-PAS_HIF3a_PASD7', 6991),
(6992, 'cd10954', NULL, 'CE4_CtAXE_like', NULL, NULL, 'CE4_CtAXE_like', 6992),
(6993, 'cd21562', NULL, 'Macro_cv_SUD-N_Nsp3-like', NULL, NULL, 'Macro_cv_SUD-N_Nsp3-like', 6993),
(6994, 'cd16582', NULL, 'RING-HC_TRIM31_C-V', NULL, NULL, 'RING-HC_TRIM31_C-V', 6994),
(6995, 'cd10003', NULL, 'HDAC6-dom2', NULL, NULL, 'HDAC6-dom2', 6995),
(6996, 'cd09822', NULL, 'peroxinectin_like_bacterial', NULL, NULL, 'peroxinectin_like_bacterial', 6996),
(6997, 'cd15102', NULL, '7tmA_S1PR', NULL, NULL, '7tmA_S1PR', 6997),
(6998, 'cd18179', NULL, 'ATP-synt_Vo_Ao_c_NTPK_rpt1', NULL, NULL, 'ATP-synt_Vo_Ao_c_NTPK_rpt1', 6998),
(6999, 'cd15026', NULL, '7tm_TAS2R13', NULL, NULL, '7tm_TAS2R13', 6999),
(7000, 'cd03562', NULL, 'CID', NULL, NULL, 'CID', 7000),
(7001, 'cd04924', NULL, 'ACT_AK-Arch_2', NULL, NULL, 'ACT_AK-Arch_2', 7001),
(7002, 'cd09747', NULL, 'Csx1_III-U', NULL, NULL, 'Csx1_III-U', 7002),
(7003, 'cd15900', NULL, 'EFh_MICU', NULL, NULL, 'EFh_MICU', 7003),
(7004, 'cd17070', NULL, 'DCX2_RP_like', NULL, NULL, 'DCX2_RP_like', 7004),
(7005, 'cd18016', NULL, 'DEXHc_RecQ2_BLM', NULL, NULL, 'DEXHc_RecQ2_BLM', 7005),
(7006, 'cd00586', NULL, '4HBT', NULL, NULL, '4HBT', 7006),
(7007, 'cd04305', NULL, 'HAD_Neu5Ac-Pase_like', NULL, NULL, 'HAD_Neu5Ac-Pase_like', 7007),
(7008, 'cd11977', NULL, 'SH3_VAV2_2', NULL, NULL, 'SH3_VAV2_2', 7008),
(7009, 'cd14693', NULL, 'bZIP_CEBP', NULL, NULL, 'bZIP_CEBP', 7009),
(7010, 'cd03295', NULL, 'ABC_OpuCA_Osmoprotection', NULL, NULL, 'ABC_OpuCA_Osmoprotection', 7010),
(7011, 'cd11978', NULL, 'SH3_VAV3_2', NULL, NULL, 'SH3_VAV3_2', 7011),
(7012, 'cd12614', NULL, 'RRM1_PUB1', NULL, NULL, 'RRM1_PUB1', 7012),
(7013, 'cd16997', NULL, 'VHS_Tom1L1', NULL, NULL, 'VHS_Tom1L1', 7013),
(7014, 'cd04511', NULL, 'Nudix_Hydrolase_4', NULL, NULL, 'Nudix_Hydrolase_4', 7014),
(7015, 'cd12802', NULL, 'HopAB_PID', NULL, NULL, 'HopAB_PID', 7015),
(7016, 'cd15424', NULL, '7tmA_OR2_unk', NULL, NULL, '7tmA_OR2_unk', 7016),
(7017, 'cd11248', NULL, 'Sema_MET_like', NULL, NULL, 'Sema_MET_like', 7017),
(7018, 'cd19974', NULL, 'PBP1_LacI-like', NULL, NULL, 'PBP1_LacI-like', 7018),
(7019, 'cd21588', NULL, 'alphaCoV_RdRp', NULL, NULL, 'alphaCoV_RdRp', 7019),
(7020, 'cd15711', NULL, 'ePHD2_PHF6', NULL, NULL, 'ePHD2_PHF6', 7020),
(7021, 'cd16727', NULL, 'RING3-HC_MIB1', NULL, NULL, 'RING3-HC_MIB1', 7021),
(7022, 'cd17392', NULL, 'MFS_MFSD2', NULL, NULL, 'MFS_MFSD2', 7022),
(7023, 'cd12800', NULL, 'Sol_i_2', NULL, NULL, 'Sol_i_2', 7023),
(7024, 'cd17776', NULL, 'CBS_pair_arch', NULL, NULL, 'CBS_pair_arch', 7024),
(7025, 'cd05130', NULL, 'RasGAP_Neurofibromin', NULL, NULL, 'RasGAP_Neurofibromin', 7025),
(7026, 'cd15170', NULL, '7tmA_FFAR2_FFAR3', NULL, NULL, '7tmA_FFAR2_FFAR3', 7026),
(7027, 'cd15447', NULL, '7tmC_mGluR2', NULL, NULL, '7tmC_mGluR2', 7027),
(7028, 'cd04224', NULL, 'CuRO_3_ceruloplasmin', NULL, NULL, 'CuRO_3_ceruloplasmin', 7028),
(7029, 'cd13899', NULL, 'CuRO_3_Fet3p', NULL, NULL, 'CuRO_3_Fet3p', 7029),
(7030, 'cd16800', NULL, 'RING-H2_RNF115', NULL, NULL, 'RING-H2_RNF115', 7030),
(7031, 'cd07695', NULL, 'Ig3_CD4', NULL, NULL, 'Ig3_CD4', 7031),
(7032, 'cd03288', NULL, 'ABCC_SUR2', NULL, NULL, 'ABCC_SUR2', 7032),
(7033, 'cd05744', NULL, 'Ig_Myotilin_C_like', NULL, NULL, 'Ig_Myotilin_C_like', 7033),
(7034, 'cd13219', NULL, 'PH-GRAM_C2-GRAM', NULL, NULL, 'PH-GRAM_C2-GRAM', 7034);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(7035, 'cd03780', NULL, 'MATH_TRAF5', NULL, NULL, 'MATH_TRAF5', 7035),
(7036, 'cd14692', NULL, 'bZIP_ATF4', NULL, NULL, 'bZIP_ATF4', 7036),
(7037, 'cd19071', NULL, 'AKR_AKR1-5-like', NULL, NULL, 'AKR_AKR1-5-like', 7037),
(7038, 'cd12766', NULL, 'RRM2_SRSF6', NULL, NULL, 'RRM2_SRSF6', 7038),
(7039, 'cd01584', NULL, 'AcnA_Mitochondrial', NULL, NULL, 'AcnA_Mitochondrial', 7039),
(7040, 'cd06567', NULL, 'Peptidase_S41', NULL, NULL, 'Peptidase_S41', 7040),
(7041, 'cd15201', NULL, '7tmA_HCAR1-3', NULL, NULL, '7tmA_HCAR1-3', 7041),
(7042, 'cd19913', NULL, 'DSRM_DRADA_rpt1', NULL, NULL, 'DSRM_DRADA_rpt1', 7042),
(7043, 'cd09090', NULL, 'INPP5c_ScInp51p-like', NULL, NULL, 'INPP5c_ScInp51p-like', 7043),
(7044, 'cd07184', NULL, 'E_set_Isoamylase_like_N', NULL, NULL, 'E_set_Isoamylase_like_N', 7044),
(7045, 'cd02414', NULL, 'jag_KH', NULL, NULL, 'jag_KH', 7045),
(7046, 'cd04413', NULL, 'NDPk_I', NULL, NULL, 'NDPk_I', 7046),
(7047, 'cd00093', NULL, 'HTH_XRE', NULL, NULL, 'HTH_XRE', 7047),
(7048, 'cd15256', NULL, '7tmB2_GPR133', NULL, NULL, '7tmB2_GPR133', 7048),
(7049, 'cd01319', NULL, 'AMPD', NULL, NULL, 'AMPD', 7049),
(7050, 'cd09642', NULL, 'Cas8c_I-C', NULL, NULL, 'Cas8c_I-C', 7050),
(7051, 'cd03275', NULL, 'ABC_SMC1_euk', NULL, NULL, 'ABC_SMC1_euk', 7051),
(7052, 'cd16975', NULL, 'HATPase_SpaK_NisK-like', NULL, NULL, 'HATPase_SpaK_NisK-like', 7052),
(7053, 'cd09178', NULL, 'PLDc_N_Snf2_like', NULL, NULL, 'PLDc_N_Snf2_like', 7053),
(7054, 'cd12835', NULL, 'EcCorA-like_1', NULL, NULL, 'EcCorA-like_1', 7054),
(7055, 'cd01272', NULL, 'PTB1_Fe65', NULL, NULL, 'PTB1_Fe65', 7055),
(7056, 'cd16130', NULL, 'RA_Rin3', NULL, NULL, 'RA_Rin3', 7056),
(7057, 'cd06149', NULL, 'ISG20', NULL, NULL, 'ISG20', 7057),
(7058, 'cd06353', NULL, 'PBP1_Med-like', NULL, NULL, 'PBP1_Med-like', 7058),
(7059, 'cd08622', NULL, 'PI-PLCXDc_CG14945_like', NULL, NULL, 'PI-PLCXDc_CG14945_like', 7059),
(7060, 'cd10952', NULL, 'CE4_MrCDA_like', NULL, NULL, 'CE4_MrCDA_like', 7060),
(7061, 'cd15208', NULL, '7tmA_OXR', NULL, NULL, '7tmA_OXR', 7061),
(7062, 'cd17224', NULL, 'RA_ASPP1', NULL, NULL, 'RA_ASPP1', 7062),
(7063, 'cd17668', NULL, 'R-PTPc-Z-1', NULL, NULL, 'R-PTPc-Z-1', 7063),
(7064, 'cd17367', NULL, 'MFS_KgtP', NULL, NULL, 'MFS_KgtP', 7064),
(7065, 'cd09001', NULL, 'GH43_FsAxh1-like', NULL, NULL, 'GH43_FsAxh1-like', 7065),
(7066, 'cd17554', NULL, 'REC_TrrA-like', NULL, NULL, 'REC_TrrA-like', 7066),
(7067, 'cd14957', NULL, 'NHL_like_2', NULL, NULL, 'NHL_like_2', 7067),
(7068, 'cd13661', NULL, 'PBP2_PotD_PotF_like_1', NULL, NULL, 'PBP2_PotD_PotF_like_1', 7068),
(7069, 'cd16818', NULL, 'SP-RING_PIAS1', NULL, NULL, 'SP-RING_PIAS1', 7069),
(7070, 'cd04774', NULL, 'HTH_YfmP', NULL, NULL, 'HTH_YfmP', 7070),
(7071, 'cd06869', NULL, 'PX_UP2_fungi', NULL, NULL, 'PX_UP2_fungi', 7071),
(7072, 'cd01945', NULL, 'ribokinase_group_B', NULL, NULL, 'ribokinase_group_B', 7072),
(7073, 'cd07993', NULL, 'LPLAT_DHAPAT-like', NULL, NULL, 'LPLAT_DHAPAT-like', 7073),
(7074, 'cd16829', NULL, 'ChuX_HutX-like', NULL, NULL, 'ChuX_HutX-like', 7074),
(7075, 'cd09760', NULL, 'Cas6_III', NULL, NULL, 'Cas6_III', 7075),
(7076, 'cd19835', NULL, 'Bbox2_TRIM65_C-IV', NULL, NULL, 'Bbox2_TRIM65_C-IV', 7076),
(7077, 'cd05150', NULL, 'APH', NULL, NULL, 'APH', 7077),
(7078, 'cd12704', NULL, 'RRM4_hnRNPL', NULL, NULL, 'RRM4_hnRNPL', 7078),
(7079, 'cd09463', NULL, 'LIM1_LIMK2', NULL, NULL, 'LIM1_LIMK2', 7079),
(7080, 'cd17589', NULL, 'REC_TPR', NULL, NULL, 'REC_TPR', 7080),
(7081, 'cd14920', NULL, 'MYSc_Myh10', NULL, NULL, 'MYSc_Myh10', 7081),
(7082, 'cd16625', NULL, 'RING-HC_RBR_HEL2_like', NULL, NULL, 'RING-HC_RBR_HEL2_like', 7082),
(7083, 'cd13127', NULL, 'MATE_tuaB_like', NULL, NULL, 'MATE_tuaB_like', 7083),
(7084, 'cd07563', NULL, 'Peptidase_S41_IRBP', NULL, NULL, 'Peptidase_S41_IRBP', 7084),
(7085, 'cd05596', NULL, 'STKc_ROCK', NULL, NULL, 'STKc_ROCK', 7085),
(7086, 'cd07421', NULL, 'MPP_Rhilphs', NULL, NULL, 'MPP_Rhilphs', 7086),
(7087, 'cd11930', NULL, 'SH3_SH3RF1_2', NULL, NULL, 'SH3_SH3RF1_2', 7087),
(7088, 'cd12709', NULL, 'RRM_RCAN2', NULL, NULL, 'RRM_RCAN2', 7088);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(7089, 'cd04227', NULL, 'CuRO_3_FVIII_like', NULL, NULL, 'CuRO_3_FVIII_like', 7089),
(7090, 'cd05699', NULL, 'S1_Rrp5_repeat_hs7', NULL, NULL, 'S1_Rrp5_repeat_hs7', 7090),
(7091, 'cd11669', NULL, 'TTHB210-like', NULL, NULL, 'TTHB210-like', 7091),
(7092, 'cd13561', NULL, 'PBP2_SsuA_like_4', NULL, NULL, 'PBP2_SsuA_like_4', 7092),
(7093, 'cd08827', NULL, 'SPFH_podocin', NULL, NULL, 'SPFH_podocin', 7093),
(7094, 'cd13185', NULL, 'FERM_C_FRMD1_FRMD6', NULL, NULL, 'FERM_C_FRMD1_FRMD6', 7094),
(7095, 'cd19719', NULL, 'bHLH_TS_NeuroD1', NULL, NULL, 'bHLH_TS_NeuroD1', 7095),
(7096, 'cd02811', NULL, 'IDI-2_FMN', NULL, NULL, 'IDI-2_FMN', 7096),
(7097, 'cd14069', NULL, 'STKc_Chk1', NULL, NULL, 'STKc_Chk1', 7097),
(7098, 'cd15036', NULL, '7tmF_FZD9', NULL, NULL, '7tmF_FZD9', 7098),
(7099, 'cd07459', NULL, 'CRD_TK_ROR_like', NULL, NULL, 'CRD_TK_ROR_like', 7099),
(7100, 'cd07939', NULL, 'DRE_TIM_NifV', NULL, NULL, 'DRE_TIM_NifV', 7100),
(7101, 'cd08907', NULL, 'START_STARD8-like', NULL, NULL, 'START_STARD8-like', 7101),
(7102, 'cd16571', NULL, 'RING-HC_SIAHs', NULL, NULL, 'RING-HC_SIAHs', 7102),
(7103, 'cd19702', NULL, 'bHLH_TS_HEN2', NULL, NULL, 'bHLH_TS_HEN2', 7103),
(7104, 'cd15457', NULL, 'NADAR', NULL, NULL, 'NADAR', 7104),
(7105, 'cd02052', NULL, 'serpinF1_PEDF', NULL, NULL, 'serpinF1_PEDF', 7105),
(7106, 'cd08432', NULL, 'PBP2_GcdR_TrpI_HvrB_AmpR_like', NULL, NULL, 'PBP2_GcdR_TrpI_HvrB_AmpR_like', 7106),
(7107, 'cd06828', NULL, 'PLPDE_III_DapDC', NULL, NULL, 'PLPDE_III_DapDC', 7107),
(7108, 'cd05638', NULL, 'M42', NULL, NULL, 'M42', 7108),
(7109, 'cd01820', NULL, 'PAF_acetylesterase_like', NULL, NULL, 'PAF_acetylesterase_like', 7109),
(7110, 'cd03139', NULL, 'GATase1_PfpI_2', NULL, NULL, 'GATase1_PfpI_2', 7110),
(7111, 'cd19000', NULL, 'LGIC_ECD_GABAAR_G', NULL, NULL, 'LGIC_ECD_GABAAR_G', 7111),
(7112, 'cd12841', NULL, 'TM_EphA1', NULL, NULL, 'TM_EphA1', 7112),
(7113, 'cd00315', NULL, 'Cyt_C5_DNA_methylase', NULL, NULL, 'Cyt_C5_DNA_methylase', 7113),
(7114, 'cd00650', NULL, 'LDH_MDH_like', NULL, NULL, 'LDH_MDH_like', 7114),
(7115, 'cd03149', NULL, 'alpha_CA_VII', NULL, NULL, 'alpha_CA_VII', 7115),
(7116, 'cd16466', NULL, 'RING-H2_RBX2', NULL, NULL, 'RING-H2_RBX2', 7116),
(7117, 'cd12959', NULL, 'MMACHC-like', NULL, NULL, 'MMACHC-like', 7117),
(7118, 'cd11940', NULL, 'SH3_ARHGEF5_19', NULL, NULL, 'SH3_ARHGEF5_19', 7118),
(7119, 'cd04895', NULL, 'ACT_ACR_1', NULL, NULL, 'ACT_ACR_1', 7119),
(7120, 'cd17133', NULL, 'RBD_ARAF', NULL, NULL, 'RBD_ARAF', 7120),
(7121, 'cd18012', NULL, 'DEXQc_arch_SWI2_SNF2', NULL, NULL, 'DEXQc_arch_SWI2_SNF2', 7121),
(7122, 'cd04090', NULL, 'EF2_II_snRNP', NULL, NULL, 'EF2_II_snRNP', 7122),
(7123, 'cd19115', NULL, 'AKR_AKR2D1', NULL, NULL, 'AKR_AKR2D1', 7123),
(7124, 'cd21597', NULL, 'SARS-CoV-2_Orf10', NULL, NULL, 'SARS-CoV-2_Orf10', 7124),
(7125, 'cd14893', NULL, 'MYSc_Myo32', NULL, NULL, 'MYSc_Myo32', 7125),
(7126, 'cd17310', NULL, 'PIPKc_PIP5K2B', NULL, NULL, 'PIPKc_PIP5K2B', 7126),
(7127, 'cd08330', NULL, 'CARD_ASC_NALP1', NULL, NULL, 'CARD_ASC_NALP1', 7127),
(7128, 'cd04689', NULL, 'Nudix_Hydrolase_30', NULL, NULL, 'Nudix_Hydrolase_30', 7128),
(7129, 'cd06572', NULL, 'Histidinol_dh', NULL, NULL, 'Histidinol_dh', 7129),
(7130, 'cd08174', NULL, 'G1PDH-like', NULL, NULL, 'G1PDH-like', 7130),
(7131, 'cd10154', NULL, 'NreA-like_DUF156', NULL, NULL, 'NreA-like_DUF156', 7131),
(7132, 'cd09621', NULL, 'CBM9_like_5', NULL, NULL, 'CBM9_like_5', 7132),
(7133, 'cd05561', NULL, 'Peptidases_S8_4', NULL, NULL, 'Peptidases_S8_4', 7133),
(7134, 'cd06190', NULL, 'T4MO_e_transfer_like', NULL, NULL, 'T4MO_e_transfer_like', 7134),
(7135, 'cd03121', NULL, 'alpha_CARP_X_XI_like', NULL, NULL, 'alpha_CARP_X_XI_like', 7135),
(7136, 'cd12736', NULL, 'RRM1_ESRP1', NULL, NULL, 'RRM1_ESRP1', 7136),
(7137, 'cd16260', NULL, 'EF4_III', NULL, NULL, 'EF4_III', 7137),
(7138, 'cd13751', NULL, 'TGF_beta_GDF8_like', NULL, NULL, 'TGF_beta_GDF8_like', 7138),
(7139, 'cd16819', NULL, 'SP-RING_PIAS2', NULL, NULL, 'SP-RING_PIAS2', 7139),
(7140, 'cd17751', NULL, 'BRCT_microcephalin_rpt3', NULL, NULL, 'BRCT_microcephalin_rpt3', 7140);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(7141, 'cd00232', NULL, 'HemeO-like', NULL, NULL, 'HemeO-like', 7141),
(7142, 'cd17269', NULL, 'RMtype1_S_PluTORF4319P-TRD2-CR2_like', NULL, NULL, 'RMtype1_S_PluTORF4319P-TRD2-CR2_like', 7142),
(7143, 'cd15516', NULL, 'PHD2_KDM5A_like', NULL, NULL, 'PHD2_KDM5A_like', 7143),
(7144, 'cd05010', NULL, 'SIS_AgaS_like', NULL, NULL, 'SIS_AgaS_like', 7144),
(7145, 'cd14234', NULL, 'GAT_GGA_meta', NULL, NULL, 'GAT_GGA_meta', 7145),
(7146, 'cd06111', NULL, 'DsCS_like', NULL, NULL, 'DsCS_like', 7146),
(7147, 'cd17344', NULL, 'MFS_SLC37A1_2', NULL, NULL, 'MFS_SLC37A1_2', 7147),
(7148, 'cd02871', NULL, 'GH18_chitinase_D-like', NULL, NULL, 'GH18_chitinase_D-like', 7148),
(7149, 'cd01396', NULL, 'MeCP2_MBD', NULL, NULL, 'MeCP2_MBD', 7149),
(7150, 'cd17306', NULL, 'PIPKc_PIP5K1A_like', NULL, NULL, 'PIPKc_PIP5K1A_like', 7150),
(7151, 'cd06151', NULL, 'YjgF_YER057c_UK114_like_3', NULL, NULL, 'YjgF_YER057c_UK114_like_3', 7151),
(7152, 'cd19799', NULL, 'Bbox2_MYCBP2', NULL, NULL, 'Bbox2_MYCBP2', 7152),
(7153, 'cd07266', NULL, 'HPCD_N_class_II', NULL, NULL, 'HPCD_N_class_II', 7153),
(7154, 'cd19437', NULL, 'lipocalin_apoD-like', NULL, NULL, 'lipocalin_apoD-like', 7154),
(7155, 'cd00557', NULL, 'Translocase_SecB', NULL, NULL, 'Translocase_SecB', 7155),
(7156, 'cd04788', NULL, 'HTH_NolA-AlbR', NULL, NULL, 'HTH_NolA-AlbR', 7156),
(7157, 'cd18033', NULL, 'DEXDc_FANCM', NULL, NULL, 'DEXDc_FANCM', 7157),
(7158, 'cd02577', NULL, 'PSTD1', NULL, NULL, 'PSTD1', 7158),
(7159, 'cd10479', NULL, 'EphR_LBD_A1', NULL, NULL, 'EphR_LBD_A1', 7159),
(7160, 'cd09295', NULL, 'Sema', NULL, NULL, 'Sema', 7160),
(7161, 'cd05131', NULL, 'RasGAP_IQGAP2', NULL, NULL, 'RasGAP_IQGAP2', 7161),
(7162, 'cd16363', NULL, 'Col_Im_like', NULL, NULL, 'Col_Im_like', 7162),
(7163, 'cd14711', NULL, 'bZIP_CEBPA', NULL, NULL, 'bZIP_CEBPA', 7163),
(7164, 'cd07666', NULL, 'BAR_SNX7', NULL, NULL, 'BAR_SNX7', 7164),
(7165, 'cd12031', NULL, 'SH3_DLG1', NULL, NULL, 'SH3_DLG1', 7165),
(7166, 'cd00186', NULL, 'TOP1Ac', NULL, NULL, 'TOP1Ac', 7166),
(7167, 'cd15087', NULL, '7tmA_NPBWR', NULL, NULL, '7tmA_NPBWR', 7167),
(7168, 'cd09857', NULL, 'PIN_EXO1', NULL, NULL, 'PIN_EXO1', 7168),
(7169, 'cd01766', NULL, 'Ubl_UFM1', NULL, NULL, 'Ubl_UFM1', 7169),
(7170, 'cd19348', NULL, 'Wnt_Wnt5b', NULL, NULL, 'Wnt_Wnt5b', 7170),
(7171, 'cd13535', NULL, 'PBP2_Osm_BCP_like', NULL, NULL, 'PBP2_Osm_BCP_like', 7171),
(7172, 'cd01974', NULL, 'Nitrogenase_MoFe_beta', NULL, NULL, 'Nitrogenase_MoFe_beta', 7172),
(7173, 'cd15162', NULL, '7tmA_PAR', NULL, NULL, '7tmA_PAR', 7173),
(7174, 'cd18315', NULL, 'BTB_POZ_BAB-like', NULL, NULL, 'BTB_POZ_BAB-like', 7174),
(7175, 'cd12543', NULL, 'RRM2_PAR14', NULL, NULL, 'RRM2_PAR14', 7175),
(7176, 'cd14102', NULL, 'STKc_PIM3', NULL, NULL, 'STKc_PIM3', 7176),
(7177, 'cd19209', NULL, 'SET_KMT2D', NULL, NULL, 'SET_KMT2D', 7177),
(7178, 'cd15940', NULL, '7tmA_OR4E-like', NULL, NULL, '7tmA_OR4E-like', 7178),
(7179, 'cd11976', NULL, 'SH3_VAV1_2', NULL, NULL, 'SH3_VAV1_2', 7179),
(7180, 'cd18522', NULL, 'BACK_BTBD1', NULL, NULL, 'BACK_BTBD1', 7180),
(7181, 'cd09493', NULL, 'SAM_SASH-like', NULL, NULL, 'SAM_SASH-like', 7181),
(7182, 'cd01610', NULL, 'PAP2_like', NULL, NULL, 'PAP2_like', 7182),
(7183, 'cd12779', NULL, 'RRM1_ROD1', NULL, NULL, 'RRM1_ROD1', 7183),
(7184, 'cd18697', NULL, 'PIN_VapC_N-like', NULL, NULL, 'PIN_VapC_N-like', 7184),
(7185, 'cd10292', NULL, 'GST_C_YghU_like', NULL, NULL, 'GST_C_YghU_like', 7185),
(7186, 'cd15764', NULL, 'FYVE_Slp4', NULL, NULL, 'FYVE_Slp4', 7186),
(7187, 'cd15071', NULL, '7tmA_Adenosine_R_A1', NULL, NULL, '7tmA_Adenosine_R_A1', 7187),
(7188, 'cd15496', NULL, 'PHD_PHF7_G2E3_like', NULL, NULL, 'PHD_PHF7_G2E3_like', 7188),
(7189, 'cd15108', NULL, '7tmA_MrgprD', NULL, NULL, '7tmA_MrgprD', 7189),
(7190, 'cd02977', NULL, 'ArsC_family', NULL, NULL, 'ArsC_family', 7190),
(7191, 'cd03329', NULL, 'MR_like_4', NULL, NULL, 'MR_like_4', 7191),
(7192, 'cd14024', NULL, 'PK_TRB3', NULL, NULL, 'PK_TRB3', 7192),
(7193, 'cd19422', NULL, 'lipocalin_15-like', NULL, NULL, 'lipocalin_15-like', 7193),
(7194, 'cd04725', NULL, 'OMP_decarboxylase_like', NULL, NULL, 'OMP_decarboxylase_like', 7194);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(7195, 'cd17414', NULL, 'MFS_NPF4', NULL, NULL, 'MFS_NPF4', 7195),
(7196, 'cd17926', NULL, 'DEXHc_RE', NULL, NULL, 'DEXHc_RE', 7196),
(7197, 'cd07762', NULL, 'CYTH-like_Pase_1', NULL, NULL, 'CYTH-like_Pase_1', 7197),
(7198, 'cd02006', NULL, 'TPP_Gcl', NULL, NULL, 'TPP_Gcl', 7198),
(7199, 'cd01737', NULL, 'LSm16_N', NULL, NULL, 'LSm16_N', 7199),
(7200, 'cd15859', NULL, 'SNARE_SYN8', NULL, NULL, 'SNARE_SYN8', 7200),
(7201, 'cd04185', NULL, 'GT_2_like_b', NULL, NULL, 'GT_2_like_b', 7201),
(7202, 'cd02137', NULL, 'MhqN-like', NULL, NULL, 'MhqN-like', 7202),
(7203, 'cd17762', NULL, 'AMN', NULL, NULL, 'AMN', 7203),
(7204, 'cd14252', NULL, 'Dockerin_like', NULL, NULL, 'Dockerin_like', 7204),
(7205, 'cd05882', NULL, 'Ig1_Necl-1', NULL, NULL, 'Ig1_Necl-1', 7205),
(7206, 'cd16861', NULL, 'ING_ING2', NULL, NULL, 'ING_ING2', 7206),
(7207, 'cd12172', NULL, 'PGDH_like_2', NULL, NULL, 'PGDH_like_2', 7207),
(7208, 'cd09915', NULL, 'Rag', NULL, NULL, 'Rag', 7208),
(7209, 'cd08164', NULL, 'MPP_Ted1', NULL, NULL, 'MPP_Ted1', 7209),
(7210, 'cd17631', NULL, 'FACL_FadD13-like', NULL, NULL, 'FACL_FadD13-like', 7210),
(7211, 'cd17457', NULL, 'MFS_SLCO1B_OATP1B', NULL, NULL, 'MFS_SLCO1B_OATP1B', 7211),
(7212, 'cd19720', NULL, 'bHLH_TS_NeuroD2', NULL, NULL, 'bHLH_TS_NeuroD2', 7212),
(7213, 'cd05644', NULL, 'M28_like', NULL, NULL, 'M28_like', 7213),
(7214, 'cd18748', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, 'PIN_VapC4-5_FitB-like', 7214),
(7215, 'cd09868', NULL, 'PIN_XPG_RAD2', NULL, NULL, 'PIN_XPG_RAD2', 7215),
(7216, 'cd06090', NULL, 'KOW_RPL27', NULL, NULL, 'KOW_RPL27', 7216),
(7217, 'cd13633', NULL, 'PBP2_Sa-PDT_like', NULL, NULL, 'PBP2_Sa-PDT_like', 7217),
(7218, 'cd08539', NULL, 'SAM_PNT-ESE-3-like', NULL, NULL, 'SAM_PNT-ESE-3-like', 7218),
(7219, 'cd05700', NULL, 'S1_Rrp5_repeat_hs9', NULL, NULL, 'S1_Rrp5_repeat_hs9', 7219),
(7220, 'cd00892', NULL, 'PIKKc_ATR', NULL, NULL, 'PIKKc_ATR', 7220),
(7221, 'cd15288', NULL, '7tmC_TAS1R2', NULL, NULL, '7tmC_TAS1R2', 7221),
(7222, 'cd05662', NULL, 'M28_like', NULL, NULL, 'M28_like', 7222),
(7223, 'cd08053', NULL, 'Yqbg', NULL, NULL, 'Yqbg', 7223),
(7224, 'cd01467', NULL, 'vWA_BatA_type', NULL, NULL, 'vWA_BatA_type', 7224),
(7225, 'cd14057', NULL, 'PK_ILK', NULL, NULL, 'PK_ILK', 7225),
(7226, 'cd14087', NULL, 'STKc_PSKH1', NULL, NULL, 'STKc_PSKH1', 7226),
(7227, 'cd12443', NULL, 'RRM_MCM3A_like', NULL, NULL, 'RRM_MCM3A_like', 7227),
(7228, 'cd16487', NULL, 'mRING-H2-C3DHC3_ZFPL1', NULL, NULL, 'mRING-H2-C3DHC3_ZFPL1', 7228),
(7229, 'cd19858', NULL, 'DSRM_STAU_rpt2', NULL, NULL, 'DSRM_STAU_rpt2', 7229),
(7230, 'cd15713', NULL, 'ePHD_JMJD2A', NULL, NULL, 'ePHD_JMJD2A', 7230),
(7231, 'cd20283', NULL, 'cupin_DddY', NULL, NULL, 'cupin_DddY', 7231),
(7232, 'cd13203', NULL, 'FERM_C1_myosin_like', NULL, NULL, 'FERM_C1_myosin_like', 7232),
(7233, 'cd11739', NULL, 'HSPH1_NBD', NULL, NULL, 'HSPH1_NBD', 7233),
(7234, 'cd12027', NULL, 'SH3_ZO-2', NULL, NULL, 'SH3_ZO-2', 7234),
(7235, 'cd04235', NULL, 'AAK_CK', NULL, NULL, 'AAK_CK', 7235),
(7236, 'cd09375', NULL, 'LIM2_Lhx1_Lhx5', NULL, NULL, 'LIM2_Lhx1_Lhx5', 7236),
(7237, 'cd11463', NULL, 'bHLH-O_HES2', NULL, NULL, 'bHLH-O_HES2', 7237),
(7238, 'cd06965', NULL, 'NR_DBD_Ppar', NULL, NULL, 'NR_DBD_Ppar', 7238),
(7239, 'cd11679', NULL, 'archaeal_Sm_like', NULL, NULL, 'archaeal_Sm_like', 7239),
(7240, 'cd07489', NULL, 'Peptidases_S8_5', NULL, NULL, 'Peptidases_S8_5', 7240),
(7241, 'cd07580', NULL, 'nitrilase_2', NULL, NULL, 'nitrilase_2', 7241),
(7242, 'cd20759', NULL, 'capping_2-OMTase_Phytoreovirus', NULL, NULL, 'capping_2-OMTase_Phytoreovirus', 7242),
(7243, 'cd04918', NULL, 'ACT_AK1-AT_2', NULL, NULL, 'ACT_AK1-AT_2', 7243),
(7244, 'cd08320', NULL, 'Pyrin_NALPs', NULL, NULL, 'Pyrin_NALPs', 7244),
(7245, 'cd19907', NULL, 'DSRM_AtDRB-like_rpt1', NULL, NULL, 'DSRM_AtDRB-like_rpt1', 7245),
(7246, 'cd08875', NULL, 'START_ArGLABRA2_like', NULL, NULL, 'START_ArGLABRA2_like', 7246),
(7247, 'cd09279', NULL, 'RNase_HI_like', NULL, NULL, 'RNase_HI_like', 7247),
(7248, 'cd10400', NULL, 'SH2_SAP1a', NULL, NULL, 'SH2_SAP1a', 7248),
(7249, 'cd15530', NULL, 'PHD2_d4', NULL, NULL, 'PHD2_d4', 7249);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(7250, 'cd11352', NULL, 'AmyAc_5', NULL, NULL, 'AmyAc_5', 7250),
(7251, 'cd01363', NULL, 'Motor_domain', NULL, NULL, 'Motor_domain', 7251),
(7252, 'cd19048', NULL, 'LGIC_ECD_GABAAR_rho3', NULL, NULL, 'LGIC_ECD_GABAAR_rho3', 7252),
(7253, 'cd14757', NULL, 'GS_EcDosC-like_GGDEF', NULL, NULL, 'GS_EcDosC-like_GGDEF', 7253),
(7254, 'cd03242', NULL, 'ABC_RecF', NULL, NULL, 'ABC_RecF', 7254),
(7255, 'cd08152', NULL, 'y4iL_like', NULL, NULL, 'y4iL_like', 7255),
(7256, 'cd00839', NULL, 'MPP_PAPs', NULL, NULL, 'MPP_PAPs', 7256),
(7257, 'cd18659', NULL, 'CD2_tandem', NULL, NULL, 'CD2_tandem', 7257),
(7258, 'cd08573', NULL, 'GDPD_GDE1', NULL, NULL, 'GDPD_GDE1', 7258),
(7259, 'cd02784', NULL, 'MopB_CT_PHLH', NULL, NULL, 'MopB_CT_PHLH', 7259),
(7260, 'cd09735', NULL, 'Csy1_I-F', NULL, NULL, 'Csy1_I-F', 7260),
(7261, 'cd06865', NULL, 'PX_SNX_like', NULL, NULL, 'PX_SNX_like', 7261),
(7262, 'cd11936', NULL, 'SH3_UBASH3B', NULL, NULL, 'SH3_UBASH3B', 7262),
(7263, 'cd07868', NULL, 'STKc_CDK8', NULL, NULL, 'STKc_CDK8', 7263),
(7264, 'cd18286', NULL, 'BTB2_POZ_BTBD8', NULL, NULL, 'BTB2_POZ_BTBD8', 7264),
(7265, 'cd07862', NULL, 'STKc_CDK6', NULL, NULL, 'STKc_CDK6', 7265),
(7266, 'cd19468', NULL, 'FABP5', NULL, NULL, 'FABP5', 7266),
(7267, 'cd19920', NULL, 'REC_PA4781-like', NULL, NULL, 'REC_PA4781-like', 7267),
(7268, 'cd13742', NULL, 'SPRY_PRY_TRIM72', NULL, NULL, 'SPRY_PRY_TRIM72', 7268),
(7269, 'cd08258', NULL, 'Zn_ADH4', NULL, NULL, 'Zn_ADH4', 7269),
(7270, 'cd05302', NULL, 'FDH', NULL, NULL, 'FDH', 7270),
(7271, 'cd06850', NULL, 'biotinyl_domain', NULL, NULL, 'biotinyl_domain', 7271),
(7272, 'cd01080', NULL, 'NAD_bind_m-THF_DH_Cyclohyd', NULL, NULL, 'NAD_bind_m-THF_DH_Cyclohyd', 7272),
(7273, 'cd05125', NULL, 'Mth938_2P1-like', NULL, NULL, 'Mth938_2P1-like', 7273),
(7274, 'cd19978', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, 'PBP1_ABC_ligand_binding-like', 7274),
(7275, 'cd14347', NULL, 'UBA_Cezanne_like', NULL, NULL, 'UBA_Cezanne_like', 7275),
(7276, 'cd03203', NULL, 'GST_C_Lambda', NULL, NULL, 'GST_C_Lambda', 7276),
(7277, 'cd05346', NULL, 'SDR_c5', NULL, NULL, 'SDR_c5', 7277),
(7278, 'cd12081', NULL, 'SH3_CASK', NULL, NULL, 'SH3_CASK', 7278),
(7279, 'cd11566', NULL, 'eIF1_SUI1', NULL, NULL, 'eIF1_SUI1', 7279),
(7280, 'cd05765', NULL, 'Ig_3', NULL, NULL, 'Ig_3', 7280),
(7281, 'cd15679', NULL, 'PHD_JADE1', NULL, NULL, 'PHD_JADE1', 7281),
(7282, 'cd18422', NULL, 'BTB_POZ_KCNG3', NULL, NULL, 'BTB_POZ_KCNG3', 7282),
(7283, 'cd01805', NULL, 'Ubl_Rad23', NULL, NULL, 'Ubl_Rad23', 7283),
(7284, 'cd14843', NULL, 'D-Ala-D-Ala_dipeptidase_like', NULL, NULL, 'D-Ala-D-Ala_dipeptidase_like', 7284),
(7285, 'cd06663', NULL, 'Biotinyl_lipoyl_domains', NULL, NULL, 'Biotinyl_lipoyl_domains', 7285),
(7286, 'cd12887', NULL, 'SPRY_NHR_like', NULL, NULL, 'SPRY_NHR_like', 7286),
(7287, 'cd15110', NULL, '7tmA_MrgprH', NULL, NULL, '7tmA_MrgprH', 7287),
(7288, 'cd14680', NULL, 'PH_p190RhoGEF', NULL, NULL, 'PH_p190RhoGEF', 7288),
(7289, 'cd18045', NULL, 'DEADc_EIF4AIII_DDX48', NULL, NULL, 'DEADc_EIF4AIII_DDX48', 7289),
(7290, 'cd16602', NULL, 'RING-HC_TRIM41_like_C-IV', NULL, NULL, 'RING-HC_TRIM41_like_C-IV', 7290),
(7291, 'cd03064', NULL, 'TRX_Fd_NuoE', NULL, NULL, 'TRX_Fd_NuoE', 7291),
(7292, 'cd00143', NULL, 'PP2Cc', NULL, NULL, 'PP2Cc', 7292),
(7293, 'cd08868', NULL, 'START_STARD1_3_like', NULL, NULL, 'START_STARD1_3_like', 7293),
(7294, 'cd12480', NULL, 'RRM2_U1A', NULL, NULL, 'RRM2_U1A', 7294),
(7295, 'cd07700', NULL, 'IgV_CD8_beta', NULL, NULL, 'IgV_CD8_beta', 7295),
(7296, 'cd00249', NULL, 'AGE', NULL, NULL, 'AGE', 7296),
(7297, 'cd15796', NULL, 'CIF_like', NULL, NULL, 'CIF_like', 7297),
(7298, 'cd14382', NULL, 'UBA2_RAD23_plant', NULL, NULL, 'UBA2_RAD23_plant', 7298),
(7299, 'cd09765', NULL, 'Csx14_I-U', NULL, NULL, 'Csx14_I-U', 7299),
(7300, 'cd17472', NULL, 'MFS_YajR_like', NULL, NULL, 'MFS_YajR_like', 7300),
(7301, 'cd19827', NULL, 'Bbox2_TRIM67_C-I', NULL, NULL, 'Bbox2_TRIM67_C-I', 7301),
(7302, 'cd12093', NULL, 'TM_ErbB1', NULL, NULL, 'TM_ErbB1', 7302),
(7303, 'cd18267', NULL, 'BTB_POZ_KLHL37_ENC1', NULL, NULL, 'BTB_POZ_KLHL37_ENC1', 7303);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(7304, 'sd00042', NULL, 'LVIVD', NULL, NULL, 'LVIVD', 7304),
(7305, 'cd03693', NULL, 'EF1_alpha_II', NULL, NULL, 'EF1_alpha_II', 7305),
(7306, 'cd08829', NULL, 'SPFH_paraslipin', NULL, NULL, 'SPFH_paraslipin', 7306),
(7307, 'cd04027', NULL, 'C2B_Munc13', NULL, NULL, 'C2B_Munc13', 7307),
(7308, 'cd14836', NULL, 'AP2_Mu_N', NULL, NULL, 'AP2_Mu_N', 7308),
(7309, 'cd00152', NULL, 'PTX', NULL, NULL, 'PTX', 7309),
(7310, 'cd11616', NULL, 'SAF_DH_OX_like', NULL, NULL, 'SAF_DH_OX_like', 7310),
(7311, 'cd15879', NULL, 'SNARE_syntaxin19', NULL, NULL, 'SNARE_syntaxin19', 7311),
(7312, 'cd15734', NULL, 'FYVE_ZFYV1', NULL, NULL, 'FYVE_ZFYV1', 7312),
(7313, 'cd18001', NULL, 'DEXHc_ERCC6L', NULL, NULL, 'DEXHc_ERCC6L', 7313),
(7314, 'cd04131', NULL, 'Rnd', NULL, NULL, 'Rnd', 7314),
(7315, 'cd05873', NULL, 'Ig_Sema4D_like', NULL, NULL, 'Ig_Sema4D_like', 7315),
(7316, 'cd19908', NULL, 'DSRM_AtDRB-like_rpt2', NULL, NULL, 'DSRM_AtDRB-like_rpt2', 7316),
(7317, 'cd16329', NULL, 'LolA_like', NULL, NULL, 'LolA_like', 7317),
(7318, 'cd18015', NULL, 'DEXHc_RecQ1', NULL, NULL, 'DEXHc_RecQ1', 7318),
(7319, 'cd13649', NULL, 'PBP2_Cae31940', NULL, NULL, 'PBP2_Cae31940', 7319),
(7320, 'cd06463', NULL, 'p23_like', NULL, NULL, 'p23_like', 7320),
(7321, 'cd07605', NULL, 'I-BAR_IMD', NULL, NULL, 'I-BAR_IMD', 7321),
(7322, 'cd17094', NULL, 'FERM_F1_Max1_like', NULL, NULL, 'FERM_F1_Max1_like', 7322),
(7323, 'cd17515', NULL, 'RMtype1_S_MjaORF132P_Sau1132ORF3780P-TRD1-CR1_like', NULL, NULL, 'RMtype1_S_MjaORF132P_Sau1132ORF3780P-TRD1-CR1_like', 7323),
(7324, 'cd01296', NULL, 'Imidazolone-5PH', NULL, NULL, 'Imidazolone-5PH', 7324),
(7325, 'cd07973', NULL, 'Spt4', NULL, NULL, 'Spt4', 7325),
(7326, 'cd00318', NULL, 'Phosphoglycerate_kinase', NULL, NULL, 'Phosphoglycerate_kinase', 7326),
(7327, 'cd08292', NULL, 'ETR_like_2', NULL, NULL, 'ETR_like_2', 7327),
(7328, 'cd17773', NULL, 'CBS_pair_NeuB', NULL, NULL, 'CBS_pair_NeuB', 7328),
(7329, 'cd13900', NULL, 'CuRO_3_Tth-MCO_like', NULL, NULL, 'CuRO_3_Tth-MCO_like', 7329),
(7330, 'cd11910', NULL, 'SH3_PI3K_p85alpha', NULL, NULL, 'SH3_PI3K_p85alpha', 7330),
(7331, 'cd14009', NULL, 'STKc_ATG1_ULK_like', NULL, NULL, 'STKc_ATG1_ULK_like', 7331),
(7332, 'cd12896', NULL, 'SPRY_PRY_TRIM65', NULL, NULL, 'SPRY_PRY_TRIM65', 7332),
(7333, 'cd20265', NULL, 'Complex1_LYR_ETFRF1_LYRM5', NULL, NULL, 'Complex1_LYR_ETFRF1_LYRM5', 7333),
(7334, 'cd07064', NULL, 'AlkD_like_1', NULL, NULL, 'AlkD_like_1', 7334),
(7335, 'cd17194', NULL, 'FERM_F1_PTPN4', NULL, NULL, 'FERM_F1_PTPN4', 7335),
(7336, 'cd09275', NULL, 'RNase_HI_RT_DIRS1', NULL, NULL, 'RNase_HI_RT_DIRS1', 7336),
(7337, 'cd12875', NULL, 'SPRY_SOCS_Fbox', NULL, NULL, 'SPRY_SOCS_Fbox', 7337),
(7338, 'cd14498', NULL, 'DSP', NULL, NULL, 'DSP', 7338),
(7339, 'cd08359', NULL, 'VOC_like', NULL, NULL, 'VOC_like', 7339),
(7340, 'cd08909', NULL, 'START_STARD13-like', NULL, NULL, 'START_STARD13-like', 7340),
(7341, 'cd14147', NULL, 'STKc_MLK3', NULL, NULL, 'STKc_MLK3', 7341),
(7342, 'cd11676', NULL, 'Gemin6', NULL, NULL, 'Gemin6', 7342),
(7343, 'cd15250', NULL, '7tmF_FZD8', NULL, NULL, '7tmF_FZD8', 7343),
(7344, 'cd01837', NULL, 'SGNH_plant_lipase_like', NULL, NULL, 'SGNH_plant_lipase_like', 7344),
(7345, 'cd18368', NULL, 'BTB_POZ_KCTD9', NULL, NULL, 'BTB_POZ_KCTD9', 7345),
(7346, 'cd13352', NULL, 'PH-GRAM2_TBC1D8B', NULL, NULL, 'PH-GRAM2_TBC1D8B', 7346),
(7347, 'cd02984', NULL, 'TRX_PICOT', NULL, NULL, 'TRX_PICOT', 7347),
(7348, 'cd09643', NULL, 'Csn1', NULL, NULL, 'Csn1', 7348),
(7349, 'cd09085', NULL, 'Mth212-like_AP-endo', NULL, NULL, 'Mth212-like_AP-endo', 7349),
(7350, 'cd09816', NULL, 'prostaglandin_endoperoxide_synthase', NULL, NULL, 'prostaglandin_endoperoxide_synthase', 7350),
(7351, 'cd16624', NULL, 'RING-HC_RBR_CUL9', NULL, NULL, 'RING-HC_RBR_CUL9', 7351),
(7352, 'cd15233', NULL, '7tmA_OR3A-like', NULL, NULL, '7tmA_OR3A-like', 7352),
(7353, 'cd09404', NULL, 'LIM1_MLP84B_like', NULL, NULL, 'LIM1_MLP84B_like', 7353),
(7354, 'cd13614', NULL, 'PBP2_QAT_like', NULL, NULL, 'PBP2_QAT_like', 7354),
(7355, 'cd10800', NULL, 'LamB_YcsF_YbgL_like', NULL, NULL, 'LamB_YcsF_YbgL_like', 7355);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(7356, 'cd06468', NULL, 'p23_CacyBP', NULL, NULL, 'p23_CacyBP', 7356),
(7357, 'cd02969', NULL, 'PRX_like1', NULL, NULL, 'PRX_like1', 7357),
(7358, 'cd06395', NULL, 'PB1_Map2k5', NULL, NULL, 'PB1_Map2k5', 7358),
(7359, 'cd13406', NULL, 'TNFRSF4', NULL, NULL, 'TNFRSF4', 7359),
(7360, 'cd01923', NULL, 'cyclophilin_RING', NULL, NULL, 'cyclophilin_RING', 7360),
(7361, 'cd07602', NULL, 'BAR_RhoGAP_OPHN1-like', NULL, NULL, 'BAR_RhoGAP_OPHN1-like', 7361),
(7362, 'cd01636', NULL, 'FIG', NULL, NULL, 'FIG', 7362),
(7363, 'cd09681', NULL, 'Csx3_III-U', NULL, NULL, 'Csx3_III-U', 7363),
(7364, 'cd02989', NULL, 'Phd_like_TxnDC9', NULL, NULL, 'Phd_like_TxnDC9', 7364),
(7365, 'cd11659', NULL, 'SANT_CDC5_II', NULL, NULL, 'SANT_CDC5_II', 7365),
(7366, 'cd18575', NULL, 'ABC_6TM_bac_exporter_ABCB8_10_like', NULL, NULL, 'ABC_6TM_bac_exporter_ABCB8_10_like', 7366),
(7367, 'cd12803', NULL, 'HopAB_BID', NULL, NULL, 'HopAB_BID', 7367),
(7368, 'cd19966', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, 'PBP1_ABC_sugar_binding-like', 7368),
(7369, 'cd12308', NULL, 'RRM1_Spen', NULL, NULL, 'RRM1_Spen', 7369),
(7370, 'cd13436', NULL, 'SPFH_SLP-1', NULL, NULL, 'SPFH_SLP-1', 7370),
(7371, 'cd04752', NULL, 'Commd4', NULL, NULL, 'Commd4', 7371),
(7372, 'cd08030', NULL, 'LA_like_plant', NULL, NULL, 'LA_like_plant', 7372),
(7373, 'cd19742', NULL, 'bHLH_TS_ASCL1_Mash1', NULL, NULL, 'bHLH_TS_ASCL1_Mash1', 7373),
(7374, 'cd19352', NULL, 'Wnt_Wnt8b', NULL, NULL, 'Wnt_Wnt8b', 7374),
(7375, 'cd04316', NULL, 'ND_PkAspRS_like_N', NULL, NULL, 'ND_PkAspRS_like_N', 7375),
(7376, 'cd09925', NULL, 'SH2_SHC', NULL, NULL, 'SH2_SHC', 7376),
(7377, 'cd16810', NULL, 'RING_CH-C4HC3_MARCH11', NULL, NULL, 'RING_CH-C4HC3_MARCH11', 7377),
(7378, 'cd14213', NULL, 'PKc_CLK1_4', NULL, NULL, 'PKc_CLK1_4', 7378),
(7379, 'cd18352', NULL, 'BTB_POZ_ARIA_plant', NULL, NULL, 'BTB_POZ_ARIA_plant', 7379),
(7380, 'cd15069', NULL, '7tmA_Adenosine_R_A2B', NULL, NULL, '7tmA_Adenosine_R_A2B', 7380),
(7381, 'cd18372', NULL, 'BTB_POZ_KCTD18', NULL, NULL, 'BTB_POZ_KCTD18', 7381),
(7382, 'cd18483', NULL, 'BACK_KBTBD8', NULL, NULL, 'BACK_KBTBD8', 7382),
(7383, 'cd15696', NULL, 'ePHD1_KMT2C', NULL, NULL, 'ePHD1_KMT2C', 7383),
(7384, 'cd16831', NULL, 'HemS-like_C', NULL, NULL, 'HemS-like_C', 7384),
(7385, 'cd16885', NULL, 'ARID_ARID5B', NULL, NULL, 'ARID_ARID5B', 7385),
(7386, 'cd19924', NULL, 'REC_CheV-like', NULL, NULL, 'REC_CheV-like', 7386),
(7387, 'cd11894', NULL, 'SH3_FCHSD2_2', NULL, NULL, 'SH3_FCHSD2_2', 7387),
(7388, 'cd17916', NULL, 'DEXHc_UvrB', NULL, NULL, 'DEXHc_UvrB', 7388),
(7389, 'cd15043', NULL, '7tmC_RAIG_GPRC5', NULL, NULL, '7tmC_RAIG_GPRC5', 7389),
(7390, 'cd15384', NULL, '7tmA_GnRHR_invertebrate', NULL, NULL, '7tmA_GnRHR_invertebrate', 7390),
(7391, 'cd11251', NULL, 'Sema_3C', NULL, NULL, 'Sema_3C', 7391),
(7392, 'cd03816', NULL, 'GT33_ALG1-like', NULL, NULL, 'GT33_ALG1-like', 7392),
(7393, 'cd08353', NULL, 'VOC_like', NULL, NULL, 'VOC_like', 7393),
(7394, 'cd18181', NULL, 'ATP-synt_Vo_Ao_c_TtATPase_like', NULL, NULL, 'ATP-synt_Vo_Ao_c_TtATPase_like', 7394),
(7395, 'cd01415', NULL, 'SAICAR_synt_PurC', NULL, NULL, 'SAICAR_synt_PurC', 7395),
(7396, 'cd07032', NULL, 'RNAP_I_II_AC40', NULL, NULL, 'RNAP_I_II_AC40', 7396),
(7397, 'cd09684', NULL, 'Csm3_III-A', NULL, NULL, 'Csm3_III-A', 7397),
(7398, 'cd04208', NULL, 'CuRO_2_CuNIR', NULL, NULL, 'CuRO_2_CuNIR', 7398),
(7399, 'cd19372', NULL, 'UDG_F1_VAVC_D4-like', NULL, NULL, 'UDG_F1_VAVC_D4-like', 7399),
(7400, 'cd10291', NULL, 'GST_C_YfcG_like', NULL, NULL, 'GST_C_YfcG_like', 7400),
(7401, 'cd16237', NULL, 'EFh_SPARC_TICN1', NULL, NULL, 'EFh_SPARC_TICN1', 7401),
(7402, 'cd05489', NULL, 'xylanase_inhibitor_I_like', NULL, NULL, 'xylanase_inhibitor_I_like', 7402),
(7403, 'cd05865', NULL, 'Ig1_NCAM-1', NULL, NULL, 'Ig1_NCAM-1', 7403),
(7404, 'cd06625', NULL, 'STKc_MEKK3_like', NULL, NULL, 'STKc_MEKK3_like', 7404),
(7405, 'cd12593', NULL, 'RRM_RBM11', NULL, NULL, 'RRM_RBM11', 7405),
(7406, 'cd16296', NULL, 'RNaseZ_ELAC2-N-term-like_MBL-fold', NULL, NULL, 'RNaseZ_ELAC2-N-term-like_MBL-fold', 7406),
(7407, 'cd02126', NULL, 'PA_EDEM3_like', NULL, NULL, 'PA_EDEM3_like', 7407);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(7408, 'cd06256', NULL, 'M14_ASTE_ASPA-like', NULL, NULL, 'M14_ASTE_ASPA-like', 7408),
(7409, 'cd05633', NULL, 'STKc_GRK3', NULL, NULL, 'STKc_GRK3', 7409),
(7410, 'cd16288', NULL, 'BJP-1_FEZ-1-like_MBL-B3', NULL, NULL, 'BJP-1_FEZ-1-like_MBL-B3', 7410),
(7411, 'cd04700', NULL, 'DR1025_like', NULL, NULL, 'DR1025_like', 7411),
(7412, 'cd09886', NULL, 'NGN_SP', NULL, NULL, 'NGN_SP', 7412),
(7413, 'cd00023', NULL, 'BBI', NULL, NULL, 'BBI', 7413),
(7414, 'cd06121', NULL, 'cupin_YML079wp', NULL, NULL, 'cupin_YML079wp', 7414),
(7415, 'cd15088', NULL, '7tmA_MCHR-like', NULL, NULL, '7tmA_MCHR-like', 7415),
(7416, 'cd01567', NULL, 'NAPRTase_PncB', NULL, NULL, 'NAPRTase_PncB', 7416),
(7417, 'cd14199', NULL, 'STKc_CaMKK2', NULL, NULL, 'STKc_CaMKK2', 7417),
(7418, 'cd09899', NULL, 'H3TH_T4-like', NULL, NULL, 'H3TH_T4-like', 7418),
(7419, 'cd09219', NULL, 'TLP-F', NULL, NULL, 'TLP-F', 7419),
(7420, 'cd13557', NULL, 'PBP2_SsuA', NULL, NULL, 'PBP2_SsuA', 7420),
(7421, 'cd13601', NULL, 'PBP2_TRAP_DctP1_3_4_like', NULL, NULL, 'PBP2_TRAP_DctP1_3_4_like', 7421),
(7422, 'cd15634', NULL, 'PHD_PHF20', NULL, NULL, 'PHD_PHF20', 7422),
(7423, 'cd19583', NULL, 'serpinN_SPI-1_SPI-2', NULL, NULL, 'serpinN_SPI-1_SPI-2', 7423),
(7424, 'cd05168', NULL, 'PI4Kc_III_beta', NULL, NULL, 'PI4Kc_III_beta', 7424),
(7425, 'cd04299', NULL, 'GT35_Glycogen_Phosphorylase-like', NULL, NULL, 'GT35_Glycogen_Phosphorylase-like', 7425),
(7426, 'cd03232', NULL, 'ABCG_PDR_domain2', NULL, NULL, 'ABCG_PDR_domain2', 7426),
(7427, 'cd07761', NULL, 'CYTH-like_CthTTM-like', NULL, NULL, 'CYTH-like_CthTTM-like', 7427),
(7428, 'cd03053', NULL, 'GST_N_Phi', NULL, NULL, 'GST_N_Phi', 7428),
(7429, 'cd12733', NULL, 'RRM3_GRSF1', NULL, NULL, 'RRM3_GRSF1', 7429),
(7430, 'cd07440', NULL, 'RGS', NULL, NULL, 'RGS', 7430),
(7431, 'cd12439', NULL, 'RRM_TRMT2A', NULL, NULL, 'RRM_TRMT2A', 7431),
(7432, 'cd10935', NULL, 'CE4_WalW', NULL, NULL, 'CE4_WalW', 7432),
(7433, 'cd00668', NULL, 'Ile_Leu_Val_MetRS_core', NULL, NULL, 'Ile_Leu_Val_MetRS_core', 7433),
(7434, 'cd01469', NULL, 'vWA_integrins_alpha_subunit', NULL, NULL, 'vWA_integrins_alpha_subunit', 7434),
(7435, 'cd12423', NULL, 'RRM3_PTBP1_like', NULL, NULL, 'RRM3_PTBP1_like', 7435),
(7436, 'cd03114', NULL, 'MMAA-like', NULL, NULL, 'MMAA-like', 7436),
(7437, 'cd14055', NULL, 'STKc_TGFbR2_like', NULL, NULL, 'STKc_TGFbR2_like', 7437),
(7438, 'cd03213', NULL, 'ABCG_EPDR', NULL, NULL, 'ABCG_EPDR', 7438),
(7439, 'cd20171', NULL, 'M34_peptidase', NULL, NULL, 'M34_peptidase', 7439),
(7440, 'cd02393', NULL, 'PNPase_KH', NULL, NULL, 'PNPase_KH', 7440),
(7441, 'cd14786', NULL, 'STAT_CCD', NULL, NULL, 'STAT_CCD', 7441),
(7442, 'cd13386', NULL, 'PH1_FGD2', NULL, NULL, 'PH1_FGD2', 7442),
(7443, 'cd04283', NULL, 'ZnMc_hatching_enzyme', NULL, NULL, 'ZnMc_hatching_enzyme', 7443),
(7444, 'cd17518', NULL, 'RMtype1_S_Asp27244ORF1181P-TRD1-CR1_like', NULL, NULL, 'RMtype1_S_Asp27244ORF1181P-TRD1-CR1_like', 7444),
(7445, 'cd01297', NULL, 'D-aminoacylase', NULL, NULL, 'D-aminoacylase', 7445),
(7446, 'cd08847', NULL, 'ArfGap_GIT2', NULL, NULL, 'ArfGap_GIT2', 7446),
(7447, 'cd05292', NULL, 'LDH_2', NULL, NULL, 'LDH_2', 7447),
(7448, 'cd14245', NULL, 'DMP12', NULL, NULL, 'DMP12', 7448),
(7449, 'cd13360', NULL, 'PH_PLC_fungal', NULL, NULL, 'PH_PLC_fungal', 7449),
(7450, 'cd01356', NULL, 'AcnX_swivel', NULL, NULL, 'AcnX_swivel', 7450),
(7451, 'cd16767', NULL, 'RING-HC_TRIM2', NULL, NULL, 'RING-HC_TRIM2', 7451),
(7452, 'cd18299', NULL, 'BTB1_POZ_RhoBTB', NULL, NULL, 'BTB1_POZ_RhoBTB', 7452),
(7453, 'cd18821', NULL, 'GH43_Pc3Gal43A-like', NULL, NULL, 'GH43_Pc3Gal43A-like', 7453),
(7454, 'cd16377', NULL, '23S_rRNA_IVP_like', NULL, NULL, '23S_rRNA_IVP_like', 7454),
(7455, 'cd04181', NULL, 'NTP_transferase', NULL, NULL, 'NTP_transferase', 7455),
(7456, 'cd04329', NULL, 'RNAP_II_Rpb7_N', NULL, NULL, 'RNAP_II_Rpb7_N', 7456),
(7457, 'cd19838', NULL, 'Bbox1_TRIM8_C-V', NULL, NULL, 'Bbox1_TRIM8_C-V', 7457),
(7458, 'cd06819', NULL, 'PLPDE_III_LS_D-TA', NULL, NULL, 'PLPDE_III_LS_D-TA', 7458),
(7459, 'cd01294', NULL, 'DHOase', NULL, NULL, 'DHOase', 7459);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(7460, 'cd14126', NULL, 'STKc_CK1_gamma', NULL, NULL, 'STKc_CK1_gamma', 7460),
(7461, 'cd00382', NULL, 'beta_CA', NULL, NULL, 'beta_CA', 7461),
(7462, 'cd09867', NULL, 'PIN_FEN1', NULL, NULL, 'PIN_FEN1', 7462),
(7463, 'cd16633', NULL, 'mRING-HC-C3HC3D_RBR_HOIL1', NULL, NULL, 'mRING-HC-C3HC3D_RBR_HOIL1', 7463),
(7464, 'cd00380', NULL, 'KOW', NULL, NULL, 'KOW', 7464),
(7465, 'cd10970', NULL, 'CE4_DAC_u1_6s', NULL, NULL, 'CE4_DAC_u1_6s', 7465),
(7466, 'cd21158', NULL, 'NendoU_nv', NULL, NULL, 'NendoU_nv', 7466),
(7467, 'cd14770', NULL, 'PC-PEC_alpha', NULL, NULL, 'PC-PEC_alpha', 7467),
(7468, 'cd04152', NULL, 'Arl4_Arl7', NULL, NULL, 'Arl4_Arl7', 7468),
(7469, 'cd05623', NULL, 'STKc_MRCK_alpha', NULL, NULL, 'STKc_MRCK_alpha', 7469),
(7470, 'cd13959', NULL, 'PT_UbiA_COQ2', NULL, NULL, 'PT_UbiA_COQ2', 7470),
(7471, 'cd07200', NULL, 'cPLA2_Grp-IVA', NULL, NULL, 'cPLA2_Grp-IVA', 7471),
(7472, 'cd16453', NULL, 'RING-Ubox', NULL, NULL, 'RING-Ubox', 7472),
(7473, 'cd11758', NULL, 'SH3_CRK_N', NULL, NULL, 'SH3_CRK_N', 7473),
(7474, 'cd14085', NULL, 'STKc_CaMKIV', NULL, NULL, 'STKc_CaMKIV', 7474),
(7475, 'cd06139', NULL, 'DNA_polA_I_Ecoli_like_exo', NULL, NULL, 'DNA_polA_I_Ecoli_like_exo', 7475),
(7476, 'cd09362', NULL, 'LIM2_Enigma_like', NULL, NULL, 'LIM2_Enigma_like', 7476),
(7477, 'cd11300', NULL, 'Fut8_like', NULL, NULL, 'Fut8_like', 7477),
(7478, 'cd09268', NULL, 'FCHo1_MHD', NULL, NULL, 'FCHo1_MHD', 7478),
(7479, 'cd13912', NULL, 'CcO_II_C', NULL, NULL, 'CcO_II_C', 7479),
(7480, 'cd01563', NULL, 'Thr-synth_1', NULL, NULL, 'Thr-synth_1', 7480),
(7481, 'cd19118', NULL, 'AKR_AKR3B1-3', NULL, NULL, 'AKR_AKR3B1-3', 7481),
(7482, 'cd19989', NULL, 'PBP1_SBP-like', NULL, NULL, 'PBP1_SBP-like', 7482),
(7483, 'cd04672', NULL, 'Nudix_Hydrolase_14', NULL, NULL, 'Nudix_Hydrolase_14', 7483),
(7484, 'cd16483', NULL, 'RING-H2_UBR3', NULL, NULL, 'RING-H2_UBR3', 7484),
(7485, 'cd04388', NULL, 'RhoGAP_p85', NULL, NULL, 'RhoGAP_p85', 7485),
(7486, 'cd17438', NULL, 'MFS_SV2B', NULL, NULL, 'MFS_SV2B', 7486),
(7487, 'cd18728', NULL, 'PIN_N4BP1-like', NULL, NULL, 'PIN_N4BP1-like', 7487),
(7488, 'cd15109', NULL, '7tmA_MrgprF', NULL, NULL, '7tmA_MrgprF', 7488),
(7489, 'cd17431', NULL, 'MFS_GLUT_Class1', NULL, NULL, 'MFS_GLUT_Class1', 7489),
(7490, 'cd02116', NULL, 'ACT', NULL, NULL, 'ACT', 7490),
(7491, 'cd15882', NULL, 'SNARE_syntaxin2', NULL, NULL, 'SNARE_syntaxin2', 7491),
(7492, 'cd05725', NULL, 'Ig3_Robo', NULL, NULL, 'Ig3_Robo', 7492),
(7493, 'cd13977', NULL, 'STKc_PDIK1L', NULL, NULL, 'STKc_PDIK1L', 7493),
(7494, 'cd09979', NULL, 'LOTUS_3_Limkain_b1', NULL, NULL, 'LOTUS_3_Limkain_b1', 7494),
(7495, 'cd19923', NULL, 'REC_CheY_CheY3', NULL, NULL, 'REC_CheY_CheY3', 7495),
(7496, 'cd00080', NULL, 'H3TH_StructSpec-5''-nucleases', NULL, NULL, 'H3TH_StructSpec-5''-nucleases', 7496),
(7497, 'cd05898', NULL, 'Ig5_KIRREL3', NULL, NULL, 'Ig5_KIRREL3', 7497),
(7498, 'cd06197', NULL, 'FNR_like_2', NULL, NULL, 'FNR_like_2', 7498),
(7499, 'cd13719', NULL, 'PBP2_iGluR_NMDA_Nr1', NULL, NULL, 'PBP2_iGluR_NMDA_Nr1', 7499),
(7500, 'cd00955', NULL, 'Transaldolase_like', NULL, NULL, 'Transaldolase_like', 7500),
(7501, 'cd14582', NULL, 'DSP_DUSP15', NULL, NULL, 'DSP_DUSP15', 7501),
(7502, 'sd00039', NULL, '7WD40', NULL, NULL, '7WD40', 7502),
(7503, 'cd10498', NULL, 'MH2_SMAD_4', NULL, NULL, 'MH2_SMAD_4', 7503),
(7504, 'cd07983', NULL, 'LPLAT_DUF374-like', NULL, NULL, 'LPLAT_DUF374-like', 7504),
(7505, 'cd09353', NULL, 'LIM2_Zyxin', NULL, NULL, 'LIM2_Zyxin', 7505),
(7506, 'cd07265', NULL, '2_3_CTD_N', NULL, NULL, '2_3_CTD_N', 7506),
(7507, 'cd18475', NULL, 'BACK_KLHL36', NULL, NULL, 'BACK_KLHL36', 7507),
(7508, 'cd04273', NULL, 'ZnMc_ADAMTS_like', NULL, NULL, 'ZnMc_ADAMTS_like', 7508),
(7509, 'cd08893', NULL, 'SRPBCC_CalC_Aha1-like_GntR-HTH', NULL, NULL, 'SRPBCC_CalC_Aha1-like_GntR-HTH', 7509),
(7510, 'cd08662', NULL, 'M13', NULL, NULL, 'M13', 7510),
(7511, 'cd09338', NULL, 'LIM3_Paxillin_like', NULL, NULL, 'LIM3_Paxillin_like', 7511),
(7512, 'cd19721', NULL, 'bHLH_TS_NeuroD4_ATOH3', NULL, NULL, 'bHLH_TS_NeuroD4_ATOH3', 7512),
(7513, 'cd15247', NULL, '7tmF_FZD1', NULL, NULL, '7tmF_FZD1', 7513);
INSERT INTO "PUBLIC"."MODEL" VALUES
(7514, 'cd07717', NULL, 'RNaseZ_ZiPD-like_MBL-fold', NULL, NULL, 'RNaseZ_ZiPD-like_MBL-fold', 7514),
(7515, 'cd05709', NULL, 'S2P-M50', NULL, NULL, 'S2P-M50', 7515),
(7516, 'cd16095', NULL, 'IgV_H_TCR_mu', NULL, NULL, 'IgV_H_TCR_mu', 7516),
(7517, 'cd17305', NULL, 'PIPKc_PIP5KII', NULL, NULL, 'PIPKc_PIP5KII', 7517),
(7518, 'cd06470', NULL, 'ACD_IbpA-B_like', NULL, NULL, 'ACD_IbpA-B_like', 7518),
(7519, 'cd01990', NULL, 'Alpha_ANH_like_I', NULL, NULL, 'Alpha_ANH_like_I', 7519),
(7520, 'cd14989', NULL, '7tmA_GPER1', NULL, NULL, '7tmA_GPER1', 7520),
(7521, 'cd15219', NULL, '7tmA_GPR26_GPR78-like', NULL, NULL, '7tmA_GPR26_GPR78-like', 7521),
(7522, 'cd16734', NULL, 'RING-HC_PCGF2', NULL, NULL, 'RING-HC_PCGF2', 7522),
(7523, 'cd07671', NULL, 'F-BAR_PSTPIP1', NULL, NULL, 'F-BAR_PSTPIP1', 7523),
(7524, 'cd15522', NULL, 'PHD_TAF3', NULL, NULL, 'PHD_TAF3', 7524),
(7525, 'cd11577', NULL, 'GH71', NULL, NULL, 'GH71', 7525),
(7526, 'cd08720', NULL, 'RGS_SNX25', NULL, NULL, 'RGS_SNX25', 7526),
(7527, 'cd05097', NULL, 'PTKc_DDR_like', NULL, NULL, 'PTKc_DDR_like', 7527),
(7528, 'cd09089', NULL, 'INPP5c_Synj', NULL, NULL, 'INPP5c_Synj', 7528),
(7529, 'cd04719', NULL, 'BAH_Orc1p_animal', NULL, NULL, 'BAH_Orc1p_animal', 7529),
(7530, 'cd05665', NULL, 'M20_Acy1_IAAspH', NULL, NULL, 'M20_Acy1_IAAspH', 7530),
(7531, 'cd05698', NULL, 'S1_Rrp5_repeat_hs6_sc5', NULL, NULL, 'S1_Rrp5_repeat_hs6_sc5', 7531),
(7532, 'cd02514', NULL, 'GT13_GLCNAC-TI', NULL, NULL, 'GT13_GLCNAC-TI', 7532),
(7533, 'cd18969', NULL, 'chromodomain', NULL, NULL, 'chromodomain', 7533),
(7534, 'cd05170', NULL, 'PIKKc_SMG1', NULL, NULL, 'PIKKc_SMG1', 7534),
(7535, 'cd14769', NULL, 'PE_alpha', NULL, NULL, 'PE_alpha', 7535),
(7536, 'cd16638', NULL, 'mRING-HC-C3HC3D_Roquin', NULL, NULL, 'mRING-HC-C3HC3D_Roquin', 7536),
(7537, 'cd01924', NULL, 'cyclophilin_TLP40_like', NULL, NULL, 'cyclophilin_TLP40_like', 7537),
(7538, 'cd14350', NULL, 'UBA_DCNL', NULL, NULL, 'UBA_DCNL', 7538),
(7539, 'cd15078', NULL, '7tmA_Encephalopsin', NULL, NULL, '7tmA_Encephalopsin', 7539),
(7540, 'cd17456', NULL, 'MFS_FLVCR2', NULL, NULL, 'MFS_FLVCR2', 7540),
(7541, 'cd16805', NULL, 'RING-H2_RNF150', NULL, NULL, 'RING-H2_RNF150', 7541),
(7542, 'cd09420', NULL, 'LIM3_Prickle', NULL, NULL, 'LIM3_Prickle', 7542),
(7543, 'cd01753', NULL, 'PLAT_LOX', NULL, NULL, 'PLAT_LOX', 7543),
(7544, 'cd17129', NULL, 'Ubl1_FAF1', NULL, NULL, 'Ubl1_FAF1', 7544),
(7545, 'cd12519', NULL, 'RRM1_SREK1', NULL, NULL, 'RRM1_SREK1', 7545),
(7546, 'cd15346', NULL, '7tmA_S1PR1_Edg1', NULL, NULL, '7tmA_S1PR1_Edg1', 7546),
(7547, 'cd01209', NULL, 'PTB_Shc', NULL, NULL, 'PTB_Shc', 7547),
(7548, 'cd17508', NULL, 'Alpha_kinase', NULL, NULL, 'Alpha_kinase', 7548),
(7549, 'cd00556', NULL, 'Thioesterase_II', NULL, NULL, 'Thioesterase_II', 7549),
(7550, 'cd14323', NULL, 'UBA_PLCs_like', NULL, NULL, 'UBA_PLCs_like', 7550),
(7551, 'cd09465', NULL, 'LIM2_LIMK2', NULL, NULL, 'LIM2_LIMK2', 7551),
(7552, 'cd01677', NULL, 'PFL2_DhaB_BssA', NULL, NULL, 'PFL2_DhaB_BssA', 7552),
(7553, 'cd04690', NULL, 'Nudix_Hydrolase_31', NULL, NULL, 'Nudix_Hydrolase_31', 7553),
(7554, 'cd09582', NULL, 'SAM_Scm-like-3MBT3,4', NULL, NULL, 'SAM_Scm-like-3MBT3,4', 7554),
(7555, 'cd17675', NULL, 'SWIB_BAF60B', NULL, NULL, 'SWIB_BAF60B', 7555),
(7556, 'cd13694', NULL, 'PBP2_Cysteine', NULL, NULL, 'PBP2_Cysteine', 7556),
(7557, 'cd03126', NULL, 'alpha_CA_XII_XIV', NULL, NULL, 'alpha_CA_XII_XIV', 7557),
(7558, 'cd12587', NULL, 'RRM1_PSF', NULL, NULL, 'RRM1_PSF', 7558),
(7559, 'cd12597', NULL, 'RRM1_SRSF1', NULL, NULL, 'RRM1_SRSF1', 7559),
(7560, 'cd18025', NULL, 'DEXHc_DDX60', NULL, NULL, 'DEXHc_DDX60', 7560),
(7561, 'cd12302', NULL, 'RRM_scSet1p_like', NULL, NULL, 'RRM_scSet1p_like', 7561),
(7562, 'cd05491', NULL, 'Bromo_TBP7_like', NULL, NULL, 'Bromo_TBP7_like', 7562),
(7563, 'cd11236', NULL, 'Sema_plexin_like', NULL, NULL, 'Sema_plexin_like', 7563),
(7564, 'cd12745', NULL, 'RRM1_RBM12', NULL, NULL, 'RRM1_RBM12', 7564),
(7565, 'cd17297', NULL, 'AldB-like', NULL, NULL, 'AldB-like', 7565),
(7566, 'cd00153', NULL, 'RA_RalGDS_like', NULL, NULL, 'RA_RalGDS_like', 7566);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(7567, 'cd00683', NULL, 'Trans_IPPS_HH', NULL, NULL, 'Trans_IPPS_HH', 7567),
(7568, 'cd15523', NULL, 'PHD_PHF21A', NULL, NULL, 'PHD_PHF21A', 7568),
(7569, 'cd09257', NULL, 'AP_muniscins_like_MHD', NULL, NULL, 'AP_muniscins_like_MHD', 7569),
(7570, 'cd06537', NULL, 'CIDE_N_B', NULL, NULL, 'CIDE_N_B', 7570),
(7571, 'cd08996', NULL, 'GH32_FFase', NULL, NULL, 'GH32_FFase', 7571),
(7572, 'cd07533', NULL, 'HAD_like', NULL, NULL, 'HAD_like', 7572),
(7573, 'cd11997', NULL, 'SH3_PACSIN3', NULL, NULL, 'SH3_PACSIN3', 7573),
(7574, 'cd06325', NULL, 'PBP1_ABC_unchar_transporter', NULL, NULL, 'PBP1_ABC_unchar_transporter', 7574),
(7575, 'cd03287', NULL, 'ABC_MSH3_euk', NULL, NULL, 'ABC_MSH3_euk', 7575),
(7576, 'cd02759', NULL, 'MopB_Acetylene-hydratase', NULL, NULL, 'MopB_Acetylene-hydratase', 7576),
(7577, 'cd12195', NULL, 'CIPK_C', NULL, NULL, 'CIPK_C', 7577),
(7578, 'cd12234', NULL, 'RRM1_AtRSp31_like', NULL, NULL, 'RRM1_AtRSp31_like', 7578),
(7579, 'cd12246', NULL, 'RRM1_U1A_like', NULL, NULL, 'RRM1_U1A_like', 7579),
(7580, 'cd14362', NULL, 'CUE_TAB2_TAB3', NULL, NULL, 'CUE_TAB2_TAB3', 7580),
(7581, 'cd17249', NULL, 'RMtype1_S_EcoR124I-TRD2-CR2_like', NULL, NULL, 'RMtype1_S_EcoR124I-TRD2-CR2_like', 7581),
(7582, 'cd05038', NULL, 'PTKc_Jak_rpt2', NULL, NULL, 'PTKc_Jak_rpt2', 7582),
(7583, 'cd13906', NULL, 'CuRO_3_CumA_like', NULL, NULL, 'CuRO_3_CumA_like', 7583),
(7584, 'cd12012', NULL, 'SH3_RIM-BP_2', NULL, NULL, 'SH3_RIM-BP_2', 7584),
(7585, 'cd01230', NULL, 'PH1_Tiam1_2', NULL, NULL, 'PH1_Tiam1_2', 7585),
(7586, 'cd02779', NULL, 'MopB_CT_Arsenite-Ox', NULL, NULL, 'MopB_CT_Arsenite-Ox', 7586),
(7587, 'cd05779', NULL, 'DNA_polB_epsilon_exo', NULL, NULL, 'DNA_polB_epsilon_exo', 7587),
(7588, 'cd05635', NULL, 'LbH_unknown', NULL, NULL, 'LbH_unknown', 7588),
(7589, 'cd18897', NULL, 'TET3', NULL, NULL, 'TET3', 7589),
(7590, 'cd00103', NULL, 'IRF', NULL, NULL, 'IRF', 7590),
(7591, 'cd15552', NULL, 'PHD_PHF3_like', NULL, NULL, 'PHD_PHF3_like', 7591),
(7592, 'cd09726', NULL, 'RAMP_I_III', NULL, NULL, 'RAMP_I_III', 7592),
(7593, 'cd10326', NULL, 'SLC5sbd_NIS-like', NULL, NULL, 'SLC5sbd_NIS-like', 7593),
(7594, 'cd10404', NULL, 'SH2_STAP2', NULL, NULL, 'SH2_STAP2', 7594),
(7595, 'cd06184', NULL, 'flavohem_like_fad_nad_binding', NULL, NULL, 'flavohem_like_fad_nad_binding', 7595),
(7596, 'cd09210', NULL, 'Riboflavin_synthase_archaeal', NULL, NULL, 'Riboflavin_synthase_archaeal', 7596),
(7597, 'cd00928', NULL, 'Cyt_c_Oxidase_VIIa', NULL, NULL, 'Cyt_c_Oxidase_VIIa', 7597),
(7598, 'cd02671', NULL, 'Peptidase_C19O', NULL, NULL, 'Peptidase_C19O', 7598),
(7599, 'cd11816', NULL, 'SH3_Eve1_3', NULL, NULL, 'SH3_Eve1_3', 7599),
(7600, 'cd00228', NULL, 'eu-GS', NULL, NULL, 'eu-GS', 7600),
(7601, 'cd13669', NULL, 'PBP2_TRAP_TM0322_like', NULL, NULL, 'PBP2_TRAP_TM0322_like', 7601),
(7602, 'cd14557', NULL, 'R-PTPc-C-1', NULL, NULL, 'R-PTPc-C-1', 7602),
(7603, 'cd11987', NULL, 'SH3_Intersectin1_1', NULL, NULL, 'SH3_Intersectin1_1', 7603),
(7604, 'cd01123', NULL, 'Rad51_DMC1_radA', NULL, NULL, 'Rad51_DMC1_radA', 7604),
(7605, 'cd07108', NULL, 'ALDH_MGR_2402', NULL, NULL, 'ALDH_MGR_2402', 7605),
(7606, 'cd00309', NULL, 'chaperonin_type_I_II', NULL, NULL, 'chaperonin_type_I_II', 7606),
(7607, 'cd01859', NULL, 'MJ1464', NULL, NULL, 'MJ1464', 7607),
(7608, 'cd08326', NULL, 'CARD_CASP9', NULL, NULL, 'CARD_CASP9', 7608),
(7609, 'cd04946', NULL, 'GT4_AmsK-like', NULL, NULL, 'GT4_AmsK-like', 7609),
(7610, 'cd07530', NULL, 'HAD_Pase_UmpH-like', NULL, NULL, 'HAD_Pase_UmpH-like', 7610),
(7611, 'cd10396', NULL, 'SH2_Tec_Itk', NULL, NULL, 'SH2_Tec_Itk', 7611),
(7612, 'cd12265', NULL, 'RRM_SLT11', NULL, NULL, 'RRM_SLT11', 7612),
(7613, 'cd00642', NULL, 'GTP_cyclohydro1', NULL, NULL, 'GTP_cyclohydro1', 7613),
(7614, 'cd09650', NULL, 'Cas7_I', NULL, NULL, 'Cas7_I', 7614),
(7615, 'cd12181', NULL, 'ceo_syn', NULL, NULL, 'ceo_syn', 7615),
(7616, 'cd08047', NULL, 'TAF7', NULL, NULL, 'TAF7', 7616),
(7617, 'cd01258', NULL, 'PHsplit_syntrophin', NULL, NULL, 'PHsplit_syntrophin', 7617),
(7618, 'cd01940', NULL, 'Fructoselysine_kinase_like', NULL, NULL, 'Fructoselysine_kinase_like', 7618);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(7619, 'cd14449', NULL, 'CuRO_1_2DMCO_NIR_like_2', NULL, NULL, 'CuRO_1_2DMCO_NIR_like_2', 7619),
(7620, 'cd01536', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, 'PBP1_ABC_sugar_binding-like', 7620),
(7621, 'cd06502', NULL, 'TA_like', NULL, NULL, 'TA_like', 7621),
(7622, 'cd21668', NULL, 'deltaCoV_Nsp5_Mpro', NULL, NULL, 'deltaCoV_Nsp5_Mpro', 7622),
(7623, 'cd10548', NULL, 'cupin_CDO', NULL, NULL, 'cupin_CDO', 7623),
(7624, 'cd11536', NULL, 'NTP-PPase_iMazG', NULL, NULL, 'NTP-PPase_iMazG', 7624),
(7625, 'cd02799', NULL, 'tRNA_bind_EMAP-II_like', NULL, NULL, 'tRNA_bind_EMAP-II_like', 7625),
(7626, 'cd05845', NULL, 'Ig2_L1-CAM_like', NULL, NULL, 'Ig2_L1-CAM_like', 7626),
(7627, 'cd08598', NULL, 'PI-PLC1c_yeast', NULL, NULL, 'PI-PLC1c_yeast', 7627),
(7628, 'cd14717', NULL, 'bZIP_Maf_small', NULL, NULL, 'bZIP_Maf_small', 7628),
(7629, 'cd06479', NULL, 'ACD_HspB7_like', NULL, NULL, 'ACD_HspB7_like', 7629),
(7630, 'cd11261', NULL, 'Sema_4F', NULL, NULL, 'Sema_4F', 7630),
(7631, 'cd16954', NULL, 'HATPase_PhoQ-like', NULL, NULL, 'HATPase_PhoQ-like', 7631),
(7632, 'cd17707', NULL, 'BRCT_XRCC1_rpt2', NULL, NULL, 'BRCT_XRCC1_rpt2', 7632),
(7633, 'cd11298', NULL, 'O-FucT-2', NULL, NULL, 'O-FucT-2', 7633),
(7634, 'cd03270', NULL, 'ABC_UvrA_I', NULL, NULL, 'ABC_UvrA_I', 7634),
(7635, 'cd09193', NULL, 'PLDc_mTdp1_1', NULL, NULL, 'PLDc_mTdp1_1', 7635),
(7636, 'cd08920', NULL, 'Ngb', NULL, NULL, 'Ngb', 7636),
(7637, 'cd15186', NULL, '7tmA_CX3CR1', NULL, NULL, '7tmA_CX3CR1', 7637),
(7638, 'cd11822', NULL, 'SH3_SASH_like', NULL, NULL, 'SH3_SASH_like', 7638),
(7639, 'cd15856', NULL, 'SNARE_SNAP29C', NULL, NULL, 'SNARE_SNAP29C', 7639),
(7640, 'cd16857', NULL, 'ING_ING1_2', NULL, NULL, 'ING_ING1_2', 7640),
(7641, 'cd19165', NULL, 'HemeO', NULL, NULL, 'HemeO', 7641),
(7642, 'cd14231', NULL, 'GAT_GGA_like_plant', NULL, NULL, 'GAT_GGA_like_plant', 7642),
(7643, 'cd19366', NULL, 'TenA_C_BhTenA-like', NULL, NULL, 'TenA_C_BhTenA-like', 7643),
(7644, 'cd10530', NULL, 'SET_SETD7', NULL, NULL, 'SET_SETD7', 7644),
(7645, 'cd07853', NULL, 'STKc_NLK', NULL, NULL, 'STKc_NLK', 7645),
(7646, 'cd13856', NULL, 'CuRO_1_Tv-LCC_like', NULL, NULL, 'CuRO_1_Tv-LCC_like', 7646),
(7647, 'cd08347', NULL, 'PcpA_C_like', NULL, NULL, 'PcpA_C_like', 7647),
(7648, 'cd03794', NULL, 'GT4_WbuB-like', NULL, NULL, 'GT4_WbuB-like', 7648),
(7649, 'cd09654', NULL, 'Cmr5_III-B', NULL, NULL, 'Cmr5_III-B', 7649),
(7650, 'cd07084', NULL, 'ALDH_KGSADH-like', NULL, NULL, 'ALDH_KGSADH-like', 7650),
(7651, 'cd07837', NULL, 'STKc_CdkB_plant', NULL, NULL, 'STKc_CdkB_plant', 7651),
(7652, 'cd11957', NULL, 'SH3_RUSC2', NULL, NULL, 'SH3_RUSC2', 7652),
(7653, 'cd14807', NULL, 'RAP_D2', NULL, NULL, 'RAP_D2', 7653),
(7654, 'cd06200', NULL, 'SiR_like1', NULL, NULL, 'SiR_like1', 7654),
(7655, 'cd21487', NULL, 'bat_HKU4-like_Spike_S1_RBD', NULL, NULL, 'bat_HKU4-like_Spike_S1_RBD', 7655),
(7656, 'cd09109', NULL, 'PLDc_PMFPLD_like_2', NULL, NULL, 'PLDc_PMFPLD_like_2', 7656),
(7657, 'cd01742', NULL, 'GATase1_GMP_Synthase', NULL, NULL, 'GATase1_GMP_Synthase', 7657),
(7658, 'cd11953', NULL, 'SH3_ASPP2', NULL, NULL, 'SH3_ASPP2', 7658),
(7659, 'cd12261', NULL, 'RRM1_3_MRN1', NULL, NULL, 'RRM1_3_MRN1', 7659),
(7660, 'cd05034', NULL, 'PTKc_Src_like', NULL, NULL, 'PTKc_Src_like', 7660),
(7661, 'cd08166', NULL, 'MPP_Cdc1_like_1', NULL, NULL, 'MPP_Cdc1_like_1', 7661),
(7662, 'cd08401', NULL, 'C2A_RasA2_RasA3', NULL, NULL, 'C2A_RasA2_RasA3', 7662),
(7663, 'cd16938', NULL, 'HATPase_ETR2_ERS2-EIN4-like', NULL, NULL, 'HATPase_ETR2_ERS2-EIN4-like', 7663),
(7664, 'cd12217', NULL, 'Stu0660_Csn2', NULL, NULL, 'Stu0660_Csn2', 7664),
(7665, 'cd01659', NULL, 'TRX_superfamily', NULL, NULL, 'TRX_superfamily', 7665),
(7666, 'cd18446', NULL, 'BACK_KLHL6', NULL, NULL, 'BACK_KLHL6', 7666),
(7667, 'cd15969', NULL, '7tmA_GPR87', NULL, NULL, '7tmA_GPR87', 7667),
(7668, 'cd10927', NULL, 'CE4_u3', NULL, NULL, 'CE4_u3', 7668),
(7669, 'cd03358', NULL, 'LbH_WxcM_N_like', NULL, NULL, 'LbH_WxcM_N_like', 7669),
(7670, 'cd00473', NULL, 'bS6', NULL, NULL, 'bS6', 7670),
(7671, 'cd08473', NULL, 'PBP2_CrgA_like_4', NULL, NULL, 'PBP2_CrgA_like_4', 7671);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(7672, 'cd09356', NULL, 'LIM2_TRIP6', NULL, NULL, 'LIM2_TRIP6', 7672),
(7673, 'cd20218', NULL, 'PFM_aerolysin', NULL, NULL, 'PFM_aerolysin', 7673),
(7674, 'cd13725', NULL, 'PBP2_iGluR_kainate_KA2', NULL, NULL, 'PBP2_iGluR_kainate_KA2', 7674),
(7675, 'cd20296', NULL, 'cupin_PpnP-like', NULL, NULL, 'cupin_PpnP-like', 7675),
(7676, 'cd00457', NULL, 'PEBP', NULL, NULL, 'PEBP', 7676),
(7677, 'cd04408', NULL, 'RhoGAP_GMIP', NULL, NULL, 'RhoGAP_GMIP', 7677),
(7678, 'cd00188', NULL, 'TOPRIM', NULL, NULL, 'TOPRIM', 7678),
(7679, 'cd07875', NULL, 'STKc_JNK1', NULL, NULL, 'STKc_JNK1', 7679),
(7680, 'cd10145', NULL, 'TFIIA_gamma_N', NULL, NULL, 'TFIIA_gamma_N', 7680),
(7681, 'cd12339', NULL, 'RRM2_SRSF1_4_like', NULL, NULL, 'RRM2_SRSF1_4_like', 7681),
(7682, 'cd18590', NULL, 'ABC_6TM_TAP2', NULL, NULL, 'ABC_6TM_TAP2', 7682),
(7683, 'cd04384', NULL, 'RhoGAP_CdGAP', NULL, NULL, 'RhoGAP_CdGAP', 7683),
(7684, 'cd06616', NULL, 'PKc_MKK4', NULL, NULL, 'PKc_MKK4', 7684),
(7685, 'cd09859', NULL, 'PIN_53EXO', NULL, NULL, 'PIN_53EXO', 7685),
(7686, 'cd17025', NULL, 'T3SC_IA_ShcF-like', NULL, NULL, 'T3SC_IA_ShcF-like', 7686),
(7687, 'cd15230', NULL, '7tmA_OR5-like', NULL, NULL, '7tmA_OR5-like', 7687),
(7688, 'cd01783', NULL, 'RA2_DAGK-theta', NULL, NULL, 'RA2_DAGK-theta', 7688),
(7689, 'cd18945', NULL, 'bHLH_E-protein_TCF4_E2-2', NULL, NULL, 'bHLH_E-protein_TCF4_E2-2', 7689),
(7690, 'cd16832', NULL, 'CNF1_CheD_YfiH-like', NULL, NULL, 'CNF1_CheD_YfiH-like', 7690),
(7691, 'cd08451', NULL, 'PBP2_BudR', NULL, NULL, 'PBP2_BudR', 7691),
(7692, 'cd17082', NULL, 'RAWUL_PCGF2_like', NULL, NULL, 'RAWUL_PCGF2_like', 7692),
(7693, 'cd20304', NULL, 'cupin_OxDC_N', NULL, NULL, 'cupin_OxDC_N', 7693),
(7694, 'cd12720', NULL, 'RRM_SYNJ2', NULL, NULL, 'RRM_SYNJ2', 7694),
(7695, 'cd14875', NULL, 'MYSc_Myo13', NULL, NULL, 'MYSc_Myo13', 7695),
(7696, 'cd06841', NULL, 'PLPDE_III_MccE_like', NULL, NULL, 'PLPDE_III_MccE_like', 7696),
(7697, 'cd16219', NULL, 'EFh_PI-PLCdelta4', NULL, NULL, 'EFh_PI-PLCdelta4', 7697),
(7698, 'cd06193', NULL, 'siderophore_interacting', NULL, NULL, 'siderophore_interacting', 7698),
(7699, 'cd14713', NULL, 'bZIP_CEBPG', NULL, NULL, 'bZIP_CEBPG', 7699),
(7700, 'cd07630', NULL, 'BAR_SNX_like', NULL, NULL, 'BAR_SNX_like', 7700),
(7701, 'cd05379', NULL, 'CAP_bacterial', NULL, NULL, 'CAP_bacterial', 7701),
(7702, 'cd13567', NULL, 'PBP2_TtGluBP', NULL, NULL, 'PBP2_TtGluBP', 7702),
(7703, 'cd15857', NULL, 'SNARE_SEC9C', NULL, NULL, 'SNARE_SEC9C', 7703),
(7704, 'cd14865', NULL, 'Fe-ADH-like', NULL, NULL, 'Fe-ADH-like', 7704),
(7705, 'cd15500', NULL, 'PHD1_PHF1', NULL, NULL, 'PHD1_PHF1', 7705),
(7706, 'cd10333', NULL, 'LeuT-like_sbd', NULL, NULL, 'LeuT-like_sbd', 7706),
(7707, 'cd07017', NULL, 'S14_ClpP_2', NULL, NULL, 'S14_ClpP_2', 7707),
(7708, 'cd06947', NULL, 'NR_LBD_GR_Like', NULL, NULL, 'NR_LBD_GR_Like', 7708),
(7709, 'cd09921', NULL, 'SH2_Jak_family', NULL, NULL, 'SH2_Jak_family', 7709),
(7710, 'cd10377', NULL, 'SH2_STAT6', NULL, NULL, 'SH2_STAT6', 7710),
(7711, 'cd19848', NULL, 'Bbox1_TRIM36_C-I', NULL, NULL, 'Bbox1_TRIM36_C-I', 7711),
(7712, 'cd06428', NULL, 'M1P_guanylylT_A_like_N', NULL, NULL, 'M1P_guanylylT_A_like_N', 7712),
(7713, 'cd09920', NULL, 'SH2_Cbl-b_TKB', NULL, NULL, 'SH2_Cbl-b_TKB', 7713),
(7714, 'cd01973', NULL, 'Nitrogenase_VFe_beta_like', NULL, NULL, 'Nitrogenase_VFe_beta_like', 7714),
(7715, 'cd11022', NULL, 'CuRO_4_ceruloplasmin', NULL, NULL, 'CuRO_4_ceruloplasmin', 7715),
(7716, 'cd12506', NULL, 'RRM3_hnRNPH_CRSF1_like', NULL, NULL, 'RRM3_hnRNPH_CRSF1_like', 7716),
(7717, 'cd16411', NULL, 'ParB_N_like', NULL, NULL, 'ParB_N_like', 7717),
(7718, 'cd18409', NULL, 'BTB_POZ_KCNA10', NULL, NULL, 'BTB_POZ_KCNA10', 7718),
(7719, 'cd07466', NULL, 'CRD_FZ7', NULL, NULL, 'CRD_FZ7', 7719),
(7720, 'cd15432', NULL, '7tmA_OR2B2-like', NULL, NULL, '7tmA_OR2B2-like', 7720),
(7721, 'cd02899', NULL, 'PLAT_SR', NULL, NULL, 'PLAT_SR', 7721),
(7722, 'cd21168', NULL, 'M_gcv_Nsp15-like', NULL, NULL, 'M_gcv_Nsp15-like', 7722),
(7723, 'cd17000', NULL, 'VHS_STAM1', NULL, NULL, 'VHS_STAM1', 7723),
(7724, 'cd19703', NULL, 'bHLH_TS_musculin', NULL, NULL, 'bHLH_TS_musculin', 7724);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(7725, 'cd00424', NULL, 'PolY', NULL, NULL, 'PolY', 7725),
(7726, 'cd00182', NULL, 'TBOX', NULL, NULL, 'TBOX', 7726),
(7727, 'cd11784', NULL, 'SH3_SH3RF2_3', NULL, NULL, 'SH3_SH3RF2_3', 7727),
(7728, 'cd19737', NULL, 'bHLH-PAS_NPAS2_PASD4', NULL, NULL, 'bHLH-PAS_NPAS2_PASD4', 7728),
(7729, 'cd07685', NULL, 'F-BAR_Fes', NULL, NULL, 'F-BAR_Fes', 7729),
(7730, 'cd08263', NULL, 'Zn_ADH10', NULL, NULL, 'Zn_ADH10', 7730),
(7731, 'cd10013', NULL, 'Cas3''''_I', NULL, NULL, 'Cas3''''_I', 7731),
(7732, 'cd16383', NULL, 'GUN4', NULL, NULL, 'GUN4', 7732),
(7733, 'cd17139', NULL, 'RBD2_RGS14', NULL, NULL, 'RBD2_RGS14', 7733),
(7734, 'cd06982', NULL, 'cupin_BauB-like', NULL, NULL, 'cupin_BauB-like', 7734),
(7735, 'cd18030', NULL, 'DEXHc_RE_I_HsdR', NULL, NULL, 'DEXHc_RE_I_HsdR', 7735),
(7736, 'cd20222', NULL, 'PFM_parasporin-2-like', NULL, NULL, 'PFM_parasporin-2-like', 7736),
(7737, 'cd07958', NULL, 'Anticodon_Ia_Leu_BEm', NULL, NULL, 'Anticodon_Ia_Leu_BEm', 7737),
(7738, 'cd12144', NULL, 'SDH_N_domain', NULL, NULL, 'SDH_N_domain', 7738),
(7739, 'cd10455', NULL, 'GIY-YIG_SLX1', NULL, NULL, 'GIY-YIG_SLX1', 7739),
(7740, 'cd19199', NULL, 'PR-SET_PRDM15', NULL, NULL, 'PR-SET_PRDM15', 7740),
(7741, 'cd16806', NULL, 'RING_CH-C4HC3_MARCH1', NULL, NULL, 'RING_CH-C4HC3_MARCH1', 7741),
(7742, 'cd14823', NULL, 'AP_longin-like', NULL, NULL, 'AP_longin-like', 7742),
(7743, 'cd06882', NULL, 'PX_p40phox', NULL, NULL, 'PX_p40phox', 7743),
(7744, 'cd19428', NULL, 'lipocalin_MUP-like', NULL, NULL, 'lipocalin_MUP-like', 7744),
(7745, 'cd17232', NULL, 'Ubl_ATG8_GABARAP', NULL, NULL, 'Ubl_ATG8_GABARAP', 7745),
(7746, 'cd05656', NULL, 'M42_Frv', NULL, NULL, 'M42_Frv', 7746),
(7747, 'cd07105', NULL, 'ALDH_SaliADH', NULL, NULL, 'ALDH_SaliADH', 7747),
(7748, 'cd10499', NULL, 'MH2_SMAD_6', NULL, NULL, 'MH2_SMAD_6', 7748),
(7749, 'cd17449', NULL, 'MFS_SLC46A1_PCFT', NULL, NULL, 'MFS_SLC46A1_PCFT', 7749),
(7750, 'cd05492', NULL, 'Bromo_ZMYND11', NULL, NULL, 'Bromo_ZMYND11', 7750),
(7751, 'cd15617', NULL, 'PHD_UHRF2', NULL, NULL, 'PHD_UHRF2', 7751),
(7752, 'cd15673', NULL, 'ePHD_PHF6_like', NULL, NULL, 'ePHD_PHF6_like', 7752),
(7753, 'cd15677', NULL, 'PHD_BRPF2', NULL, NULL, 'PHD_BRPF2', 7753),
(7754, 'cd06125', NULL, 'DnaQ_like_exo', NULL, NULL, 'DnaQ_like_exo', 7754),
(7755, 'cd02112', NULL, 'eukary_NR_Moco', NULL, NULL, 'eukary_NR_Moco', 7755),
(7756, 'cd14912', NULL, 'MYSc_Myh2_mammals', NULL, NULL, 'MYSc_Myh2_mammals', 7756),
(7757, 'cd00312', NULL, 'Esterase_lipase', NULL, NULL, 'Esterase_lipase', 7757),
(7758, 'cd12585', NULL, 'RRM2_hnRPDL', NULL, NULL, 'RRM2_hnRPDL', 7758),
(7759, 'cd09327', NULL, 'LIM1_abLIM', NULL, NULL, 'LIM1_abLIM', 7759),
(7760, 'cd11738', NULL, 'HSPA4L_NBD', NULL, NULL, 'HSPA4L_NBD', 7760),
(7761, 'cd00978', NULL, 'chitosanase_GH46', NULL, NULL, 'chitosanase_GH46', 7761),
(7762, 'cd10440', NULL, 'GIY-YIG_COG3680', NULL, NULL, 'GIY-YIG_COG3680', 7762),
(7763, 'cd06375', NULL, 'PBP1_mGluR_groupII', NULL, NULL, 'PBP1_mGluR_groupII', 7763),
(7764, 'cd12405', NULL, 'RRM3_NCL', NULL, NULL, 'RRM3_NCL', 7764),
(7765, 'cd14844', NULL, 'Zn-DD-carboxypeptidase_like', NULL, NULL, 'Zn-DD-carboxypeptidase_like', 7765),
(7766, 'cd18502', NULL, 'BACK_NS1BP_IVNS1ABP', NULL, NULL, 'BACK_NS1BP_IVNS1ABP', 7766),
(7767, 'cd12624', NULL, 'RRM_PRC', NULL, NULL, 'RRM_PRC', 7767),
(7768, 'cd13270', NULL, 'PH1_TAPP1_2', NULL, NULL, 'PH1_TAPP1_2', 7768),
(7769, 'cd16327', NULL, 'RseB', NULL, NULL, 'RseB', 7769),
(7770, 'cd07789', NULL, 'FGGY_CsGK_like', NULL, NULL, 'FGGY_CsGK_like', 7770),
(7771, 'cd12466', NULL, 'RRM2_AtRSp31_like', NULL, NULL, 'RRM2_AtRSp31_like', 7771),
(7772, 'cd14488', NULL, 'CBM6-CBM35-CBM36_like_2', NULL, NULL, 'CBM6-CBM35-CBM36_like_2', 7772),
(7773, 'cd00946', NULL, 'FBP_aldolase_IIA', NULL, NULL, 'FBP_aldolase_IIA', 7773),
(7774, 'cd10045', NULL, 'Reelin_repeat_1_subrepeat_2', NULL, NULL, 'Reelin_repeat_1_subrepeat_2', 7774),
(7775, 'cd06853', NULL, 'GT_WecA_like', NULL, NULL, 'GT_WecA_like', 7775),
(7776, 'cd06654', NULL, 'STKc_PAK1', NULL, NULL, 'STKc_PAK1', 7776),
(7777, 'cd16140', NULL, 'RA_GRB7', NULL, NULL, 'RA_GRB7', 7777);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(7778, 'cd04938', NULL, 'TGS_Obg', NULL, NULL, 'TGS_Obg', 7778),
(7779, 'cd10487', NULL, 'EphR_LBD_A10', NULL, NULL, 'EphR_LBD_A10', 7779),
(7780, 'cd02016', NULL, 'TPP_E1_OGDC_like', NULL, NULL, 'TPP_E1_OGDC_like', 7780),
(7781, 'cd07453', NULL, 'CRD_crescent', NULL, NULL, 'CRD_crescent', 7781),
(7782, 'cd03465', NULL, 'URO-D_like', NULL, NULL, 'URO-D_like', 7782),
(7783, 'cd06097', NULL, 'Aspergillopepsin_like', NULL, NULL, 'Aspergillopepsin_like', 7783),
(7784, 'cd06891', NULL, 'PX_Vps17p', NULL, NULL, 'PX_Vps17p', 7784),
(7785, 'cd19578', NULL, 'serpinK_insect_SRPN2-like', NULL, NULL, 'serpinK_insect_SRPN2-like', 7785),
(7786, 'cd17784', NULL, 'CBS_pair_Euryarchaeota', NULL, NULL, 'CBS_pair_Euryarchaeota', 7786),
(7787, 'cd12937', NULL, 'GUCT_RH7_like', NULL, NULL, 'GUCT_RH7_like', 7787),
(7788, 'cd21466', NULL, 'Ubl2_cv_PLpro_N_Nsp3-like', NULL, NULL, 'Ubl2_cv_PLpro_N_Nsp3-like', 7788),
(7789, 'cd15235', NULL, '7tmA_OR1A-like', NULL, NULL, '7tmA_OR1A-like', 7789),
(7790, 'cd07460', NULL, 'CRD_FZ5', NULL, NULL, 'CRD_FZ5', 7790),
(7791, 'cd16962', NULL, 'RuvC', NULL, NULL, 'RuvC', 7791),
(7792, 'cd14508', NULL, 'PTP_tensin', NULL, NULL, 'PTP_tensin', 7792),
(7793, 'cd07286', NULL, 'PX_SNX18', NULL, NULL, 'PX_SNX18', 7793),
(7794, 'cd13140', NULL, 'MATE_like_1', NULL, NULL, 'MATE_like_1', 7794),
(7795, 'cd09154', NULL, 'PLDc_SMU_988_like_1', NULL, NULL, 'PLDc_SMU_988_like_1', 7795),
(7796, 'cd08727', NULL, 'RGS_RGS22_2', NULL, NULL, 'RGS_RGS22_2', 7796),
(7797, 'cd19176', NULL, 'SET_SETD3', NULL, NULL, 'SET_SETD3', 7797),
(7798, 'cd18527', NULL, 'BACK_BTBD11', NULL, NULL, 'BACK_BTBD11', 7798),
(7799, 'cd08251', NULL, 'polyketide_synthase', NULL, NULL, 'polyketide_synthase', 7799),
(7800, 'cd15189', NULL, '7tmA_Bradykinin_R', NULL, NULL, '7tmA_Bradykinin_R', 7800),
(7801, 'cd13201', NULL, 'FERM_C_MyoXV', NULL, NULL, 'FERM_C_MyoXV', 7801),
(7802, 'cd16321', NULL, 'MraZ_C', NULL, NULL, 'MraZ_C', 7802),
(7803, 'cd07587', NULL, 'ML_beta-AS', NULL, NULL, 'ML_beta-AS', 7803),
(7804, 'cd17715', NULL, 'BRCT_polymerase_lambda', NULL, NULL, 'BRCT_polymerase_lambda', 7804),
(7805, 'cd07176', NULL, 'terB', NULL, NULL, 'terB', 7805),
(7806, 'cd06251', NULL, 'M14_ASTE_ASPA-like', NULL, NULL, 'M14_ASTE_ASPA-like', 7806),
(7807, 'cd13247', NULL, 'BAR-PH_APPL', NULL, NULL, 'BAR-PH_APPL', 7807),
(7808, 'cd01748', NULL, 'GATase1_IGP_Synthase', NULL, NULL, 'GATase1_IGP_Synthase', 7808),
(7809, 'cd05814', NULL, 'CBM20_Prei4', NULL, NULL, 'CBM20_Prei4', 7809),
(7810, 'cd00351', NULL, 'TS_Pyrimidine_HMase', NULL, NULL, 'TS_Pyrimidine_HMase', 7810),
(7811, 'cd08878', NULL, 'RHO_alpha_C_DMO-like', NULL, NULL, 'RHO_alpha_C_DMO-like', 7811),
(7812, 'cd02233', NULL, 'cupin_HNL-like', NULL, NULL, 'cupin_HNL-like', 7812),
(7813, 'cd07912', NULL, 'Tweety_N', NULL, NULL, 'Tweety_N', 7813),
(7814, 'cd14603', NULL, 'PTPc-N18', NULL, NULL, 'PTPc-N18', 7814),
(7815, 'cd06158', NULL, 'S2P-M50_like_1', NULL, NULL, 'S2P-M50_like_1', 7815),
(7816, 'cd09914', NULL, 'RocCOR', NULL, NULL, 'RocCOR', 7816),
(7817, 'cd01360', NULL, 'Adenylsuccinate_lyase_1', NULL, NULL, 'Adenylsuccinate_lyase_1', 7817),
(7818, 'cd09438', NULL, 'LIM3_Ajuba_like', NULL, NULL, 'LIM3_Ajuba_like', 7818),
(7819, 'cd08575', NULL, 'GDPD_GDE4_like', NULL, NULL, 'GDPD_GDE4_like', 7819),
(7820, 'cd05717', NULL, 'Ig1_Necl_like', NULL, NULL, 'Ig1_Necl_like', 7820),
(7821, 'cd14121', NULL, 'STKc_ULK3', NULL, NULL, 'STKc_ULK3', 7821),
(7822, 'cd16173', NULL, 'EFh_MICU1', NULL, NULL, 'EFh_MICU1', 7822),
(7823, 'cd16820', NULL, 'SP-RING_PIAS3', NULL, NULL, 'SP-RING_PIAS3', 7823),
(7824, 'cd19184', NULL, 'SET_KMT5B', NULL, NULL, 'SET_KMT5B', 7824),
(7825, 'cd11662', NULL, 'apollo_TRF2_binding', NULL, NULL, 'apollo_TRF2_binding', 7825),
(7826, 'cd07244', NULL, 'FosA', NULL, NULL, 'FosA', 7826),
(7827, 'cd01775', NULL, 'RA_PHLPP_like', NULL, NULL, 'RA_PHLPP_like', 7827),
(7828, 'cd04119', NULL, 'RJL', NULL, NULL, 'RJL', 7828),
(7829, 'cd07704', NULL, 'Ig2_Nectin-3-4_like', NULL, NULL, 'Ig2_Nectin-3-4_like', 7829),
(7830, 'cd05015', NULL, 'SIS_PGI_1', NULL, NULL, 'SIS_PGI_1', 7830);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(7831, 'cd00904', NULL, 'Ferritin', NULL, NULL, 'Ferritin', 7831),
(7832, 'cd16882', NULL, 'ARID_ARID4A', NULL, NULL, 'ARID_ARID4A', 7832),
(7833, 'cd18370', NULL, 'BTB_POZ_KCTD11', NULL, NULL, 'BTB_POZ_KCTD11', 7833),
(7834, 'cd01790', NULL, 'Ubl_HERP', NULL, NULL, 'Ubl_HERP', 7834),
(7835, 'cd01967', NULL, 'Nitrogenase_MoFe_alpha_like', NULL, NULL, 'Nitrogenase_MoFe_alpha_like', 7835),
(7836, 'cd09889', NULL, 'NGN_Bact_2', NULL, NULL, 'NGN_Bact_2', 7836),
(7837, 'cd14751', NULL, 'PBP2_GacH', NULL, NULL, 'PBP2_GacH', 7837),
(7838, 'cd14702', NULL, 'bZIP_plant_GBF1', NULL, NULL, 'bZIP_plant_GBF1', 7838),
(7839, 'cd04984', NULL, 'IgV_L_lambda', NULL, NULL, 'IgV_L_lambda', 7839),
(7840, 'cd18098', NULL, 'SpoU-like', NULL, NULL, 'SpoU-like', 7840),
(7841, 'cd00466', NULL, 'DHQase_II', NULL, NULL, 'DHQase_II', 7841),
(7842, 'cd18663', NULL, 'CD2_tandem_CHD5-9_like', NULL, NULL, 'CD2_tandem_CHD5-9_like', 7842),
(7843, 'cd12257', NULL, 'RRM1_RBM26_like', NULL, NULL, 'RRM1_RBM26_like', 7843),
(7844, 'cd16462', NULL, 'RING-H2_Pep3p_like', NULL, NULL, 'RING-H2_Pep3p_like', 7844),
(7845, 'cd03496', NULL, 'SQR_TypeC_CybS', NULL, NULL, 'SQR_TypeC_CybS', 7845),
(7846, 'cd16888', NULL, 'lyz_G-like_1', NULL, NULL, 'lyz_G-like_1', 7846),
(7847, 'cd01220', NULL, 'PH1_FARP1-like', NULL, NULL, 'PH1_FARP1-like', 7847),
(7848, 'cd13997', NULL, 'PKc_Wee1_like', NULL, NULL, 'PKc_Wee1_like', 7848),
(7849, 'cd19534', NULL, 'E_NRPS', NULL, NULL, 'E_NRPS', 7849),
(7850, 'cd11915', NULL, 'SH3_Irsp53', NULL, NULL, 'SH3_Irsp53', 7850),
(7851, 'cd08544', NULL, 'Reeler', NULL, NULL, 'Reeler', 7851),
(7852, 'cd07308', NULL, 'lectin_leg-like', NULL, NULL, 'lectin_leg-like', 7852),
(7853, 'cd12900', NULL, 'SPRY_PRY_TRIM21', NULL, NULL, 'SPRY_PRY_TRIM21', 7853),
(7854, 'cd00057', NULL, 'FA58C', NULL, NULL, 'FA58C', 7854),
(7855, 'cd08397', NULL, 'C2_PI3K_class_III', NULL, NULL, 'C2_PI3K_class_III', 7855),
(7856, 'cd16527', NULL, 'RING-HC_PEX10', NULL, NULL, 'RING-HC_PEX10', 7856),
(7857, 'cd16839', NULL, 'PCSK9_C-CRD', NULL, NULL, 'PCSK9_C-CRD', 7857),
(7858, 'cd01653', NULL, 'GATase1', NULL, NULL, 'GATase1', 7858),
(7859, 'cd15591', NULL, 'PHD2_KMT2B', NULL, NULL, 'PHD2_KMT2B', 7859),
(7860, 'cd06643', NULL, 'STKc_SLK', NULL, NULL, 'STKc_SLK', 7860),
(7861, 'cd08779', NULL, 'Death_PIDD', NULL, NULL, 'Death_PIDD', 7861),
(7862, 'cd04338', NULL, 'Rieske_RO_Alpha_Tic55', NULL, NULL, 'Rieske_RO_Alpha_Tic55', 7862),
(7863, 'cd04645', NULL, 'LbH_gamma_CA_like', NULL, NULL, 'LbH_gamma_CA_like', 7863),
(7864, 'cd00858', NULL, 'GlyRS_anticodon', NULL, NULL, 'GlyRS_anticodon', 7864),
(7865, 'cd04688', NULL, 'Nudix_Hydrolase_29', NULL, NULL, 'Nudix_Hydrolase_29', 7865),
(7866, 'cd13182', NULL, 'EVH1-like_Dcp1', NULL, NULL, 'EVH1-like_Dcp1', 7866),
(7867, 'cd15181', NULL, '7tmA_CXCR5', NULL, NULL, '7tmA_CXCR5', 7867),
(7868, 'cd17048', NULL, 'Ubl_UBL3', NULL, NULL, 'Ubl_UBL3', 7868),
(7869, 'cd06857', NULL, 'SLC5-6-like_sbd', NULL, NULL, 'SLC5-6-like_sbd', 7869),
(7870, 'cd12752', NULL, 'RRM1_RBM5', NULL, NULL, 'RRM1_RBM5', 7870),
(7871, 'cd07119', NULL, 'ALDH_BADH-GbsA', NULL, NULL, 'ALDH_BADH-GbsA', 7871),
(7872, 'cd07524', NULL, 'HAD_Pase', NULL, NULL, 'HAD_Pase', 7872),
(7873, 'cd02433', NULL, 'Nodulin-21_like_2', NULL, NULL, 'Nodulin-21_like_2', 7873),
(7874, 'cd09003', NULL, 'GH43_XynD-like', NULL, NULL, 'GH43_XynD-like', 7874),
(7875, 'cd14779', NULL, 'FHP_Ae-globin-like', NULL, NULL, 'FHP_Ae-globin-like', 7875),
(7876, 'cd19084', NULL, 'AKR_AKR11B1-like', NULL, NULL, 'AKR_AKR11B1-like', 7876),
(7877, 'cd11672', NULL, 'ADDz', NULL, NULL, 'ADDz', 7877),
(7878, 'cd07425', NULL, 'MPP_Shelphs', NULL, NULL, 'MPP_Shelphs', 7878),
(7879, 'cd11356', NULL, 'AmyAc_Sucrose_phosphorylase-like_1', NULL, NULL, 'AmyAc_Sucrose_phosphorylase-like_1', 7879),
(7880, 'cd16012', NULL, 'ALP', NULL, NULL, 'ALP', 7880),
(7881, 'cd18911', NULL, 'bHLHzip_MGA', NULL, NULL, 'bHLHzip_MGA', 7881),
(7882, 'cd01517', NULL, 'PAP_phosphatase', NULL, NULL, 'PAP_phosphatase', 7882),
(7883, 'cd16365', NULL, 'NarH_like', NULL, NULL, 'NarH_like', 7883),
(7884, 'cd08426', NULL, 'PBP2_LTTR_like_5', NULL, NULL, 'PBP2_LTTR_like_5', 7884);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(7885, 'cd14220', NULL, 'STKc_BMPR1a', NULL, NULL, 'STKc_BMPR1a', 7885),
(7886, 'cd06554', NULL, 'ASCH_ASC-1_like', NULL, NULL, 'ASCH_ASC-1_like', 7886),
(7887, 'cd13237', NULL, 'PH2_FGD5_FGD6', NULL, NULL, 'PH2_FGD5_FGD6', 7887),
(7888, 'cd13894', NULL, 'CuRO_3_AAO_like_1', NULL, NULL, 'CuRO_3_AAO_like_1', 7888),
(7889, 'cd14363', NULL, 'CUE_TOLIP', NULL, NULL, 'CUE_TOLIP', 7889),
(7890, 'cd12057', NULL, 'SH3_CIN85_3', NULL, NULL, 'SH3_CIN85_3', 7890),
(7891, 'cd11761', NULL, 'SH3_FCHSD_1', NULL, NULL, 'SH3_FCHSD_1', 7891),
(7892, 'cd12960', NULL, 'Spider_toxin', NULL, NULL, 'Spider_toxin', 7892),
(7893, 'cd06917', NULL, 'STKc_NAK1_like', NULL, NULL, 'STKc_NAK1_like', 7893),
(7894, 'cd00684', NULL, 'Terpene_cyclase_plant_C1', NULL, NULL, 'Terpene_cyclase_plant_C1', 7894),
(7895, 'cd04601', NULL, 'CBS_pair_IMPDH', NULL, NULL, 'CBS_pair_IMPDH', 7895),
(7896, 'cd05784', NULL, 'DNA_polB_II_exo', NULL, NULL, 'DNA_polB_II_exo', 7896),
(7897, 'cd16394', NULL, 'sopB_N', NULL, NULL, 'sopB_N', 7897),
(7898, 'cd16614', NULL, 'RING-HC_UNK_like', NULL, NULL, 'RING-HC_UNK_like', 7898),
(7899, 'cd11581', NULL, 'GINS_A', NULL, NULL, 'GINS_A', 7899),
(7900, 'cd13354', NULL, 'PH-GRAM2_TCB1D9_TCB1D9B', NULL, NULL, 'PH-GRAM2_TCB1D9_TCB1D9B', 7900),
(7901, 'cd15098', NULL, '7tmA_Gal1_R', NULL, NULL, '7tmA_Gal1_R', 7901),
(7902, 'cd12938', NULL, 'GUCT_Hera', NULL, NULL, 'GUCT_Hera', 7902),
(7903, 'cd17296', NULL, 'RMtype1_S_MmaC5ORF1169P_TRD1-CR1_like', NULL, NULL, 'RMtype1_S_MmaC5ORF1169P_TRD1-CR1_like', 7903),
(7904, 'cd03497', NULL, 'SQR_TypeB_1_TM', NULL, NULL, 'SQR_TypeB_1_TM', 7904),
(7905, 'cd14707', NULL, 'bZIP_plant_BZIP46', NULL, NULL, 'bZIP_plant_BZIP46', 7905),
(7906, 'cd09860', NULL, 'PIN_T4-like', NULL, NULL, 'PIN_T4-like', 7906),
(7907, 'cd17495', NULL, 'RMtype1_S_Cep9333ORF4827P-TRD2-CR2_like', NULL, NULL, 'RMtype1_S_Cep9333ORF4827P-TRD2-CR2_like', 7907),
(7908, 'cd16630', NULL, 'RING-HC_RBR_RNF216', NULL, NULL, 'RING-HC_RBR_RNF216', 7908),
(7909, 'sd00025', NULL, 'zf-RanBP2', NULL, NULL, 'zf-RanBP2', 7909),
(7910, 'cd01342', NULL, 'Translation_Factor_II_like', NULL, NULL, 'Translation_Factor_II_like', 7910),
(7911, 'cd07228', NULL, 'Pat_NTE_like_bacteria', NULL, NULL, 'Pat_NTE_like_bacteria', 7911),
(7912, 'cd07010', NULL, 'cupin_PMI_type_I_N_bac', NULL, NULL, 'cupin_PMI_type_I_N_bac', 7912),
(7913, 'cd11456', NULL, 'bHLHzip_N-Myc_like', NULL, NULL, 'bHLHzip_N-Myc_like', 7913),
(7914, 'cd01727', NULL, 'LSm8', NULL, NULL, 'LSm8', 7914),
(7915, 'cd18791', NULL, 'SF2_C_RHA', NULL, NULL, 'SF2_C_RHA', 7915),
(7916, 'cd14854', NULL, 'TRAPPC2L', NULL, NULL, 'TRAPPC2L', 7916),
(7917, 'cd15949', NULL, '7tmA_OR52M-like', NULL, NULL, '7tmA_OR52M-like', 7917),
(7918, 'cd06482', NULL, 'ACD_HspB10', NULL, NULL, 'ACD_HspB10', 7918),
(7919, 'cd16648', NULL, 'mRING-HC-C3HC5_MAPL', NULL, NULL, 'mRING-HC-C3HC5_MAPL', 7919),
(7920, 'cd01324', NULL, 'cbb3_Oxidase_CcoQ', NULL, NULL, 'cbb3_Oxidase_CcoQ', 7920),
(7921, 'cd01808', NULL, 'Ubl_PLICs', NULL, NULL, 'Ubl_PLICs', 7921),
(7922, 'cd04881', NULL, 'ACT_HSDH-Hom', NULL, NULL, 'ACT_HSDH-Hom', 7922),
(7923, 'cd09000', NULL, 'GH43_SXA-like', NULL, NULL, 'GH43_SXA-like', 7923),
(7924, 'cd21623', NULL, 'ORF7b_SARS-CoV-2', NULL, NULL, 'ORF7b_SARS-CoV-2', 7924),
(7925, 'cd14942', NULL, 'TRAPPC3_bet3', NULL, NULL, 'TRAPPC3_bet3', 7925),
(7926, 'cd21514', NULL, 'cv_alpha_Nsp2_HCoV-229E-like', NULL, NULL, 'cv_alpha_Nsp2_HCoV-229E-like', 7926),
(7927, 'cd07501', NULL, 'HAD_MDP-1_like', NULL, NULL, 'HAD_MDP-1_like', 7927),
(7928, 'cd18894', NULL, 'JBP-like', NULL, NULL, 'JBP-like', 7928),
(7929, 'cd19993', NULL, 'PBP1_ABC_xylose_binding-like', NULL, NULL, 'PBP1_ABC_xylose_binding-like', 7929),
(7930, 'cd05884', NULL, 'Ig2_Necl-3', NULL, NULL, 'Ig2_Necl-3', 7930),
(7931, 'cd09128', NULL, 'PLDc_unchar1_2', NULL, NULL, 'PLDc_unchar1_2', 7931),
(7932, 'cd11720', NULL, 'FANCI', NULL, NULL, 'FANCI', 7932),
(7933, 'cd15277', NULL, '7tmC_RAIG3_GPRC5C', NULL, NULL, '7tmC_RAIG3_GPRC5C', 7933),
(7934, 'cd17551', NULL, 'REC_RpfG-like', NULL, NULL, 'REC_RpfG-like', 7934),
(7935, 'cd01795', NULL, 'Ubl_USP48', NULL, NULL, 'Ubl_USP48', 7935);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(7936, 'cd12179', NULL, '2-Hacid_dh_14', NULL, NULL, '2-Hacid_dh_14', 7936),
(7937, 'cd15648', NULL, 'PHD1_NSD1_2', NULL, NULL, 'PHD1_NSD1_2', 7937),
(7938, 'cd17064', NULL, 'Ubl_TAFs_like', NULL, NULL, 'Ubl_TAFs_like', 7938),
(7939, 'cd01747', NULL, 'GATase1_Glutamyl_Hydrolase', NULL, NULL, 'GATase1_Glutamyl_Hydrolase', 7939),
(7940, 'cd02517', NULL, 'CMP-KDO-Synthetase', NULL, NULL, 'CMP-KDO-Synthetase', 7940),
(7941, 'cd19147', NULL, 'AKR_AKR9A3_9B1-4', NULL, NULL, 'AKR_AKR9A3_9B1-4', 7941),
(7942, 'cd10379', NULL, 'SH2_Jak2', NULL, NULL, 'SH2_Jak2', 7942),
(7943, 'cd07741', NULL, 'metallo-hydrolase-like_MBL-fold', NULL, NULL, 'metallo-hydrolase-like_MBL-fold', 7943),
(7944, 'cd19922', NULL, 'REC_RitR-like', NULL, NULL, 'REC_RitR-like', 7944),
(7945, 'cd12760', NULL, 'RRM1_MSI2', NULL, NULL, 'RRM1_MSI2', 7945),
(7946, 'cd04411', NULL, 'Ribosomal_P1_P2_L12p', NULL, NULL, 'Ribosomal_P1_P2_L12p', 7946),
(7947, 'cd14774', NULL, 'TrHb2_HGbIV-like_O', NULL, NULL, 'TrHb2_HGbIV-like_O', 7947),
(7948, 'cd15897', NULL, 'EFh_PEF', NULL, NULL, 'EFh_PEF', 7948),
(7949, 'cd02114', NULL, 'bact_SorA_Moco', NULL, NULL, 'bact_SorA_Moco', 7949),
(7950, 'cd00575', NULL, 'NOS_oxygenase', NULL, NULL, 'NOS_oxygenase', 7950),
(7951, 'cd18020', NULL, 'DEXHc_ASCC3_1', NULL, NULL, 'DEXHc_ASCC3_1', 7951),
(7952, 'cd19582', NULL, 'serpinM_ShSPI', NULL, NULL, 'serpinM_ShSPI', 7952),
(7953, 'cd09704', NULL, 'Csx12', NULL, NULL, 'Csx12', 7953),
(7954, 'cd12540', NULL, 'RRM_U2AFBPL', NULL, NULL, 'RRM_U2AFBPL', 7954),
(7955, 'cd13438', NULL, 'SPFH_eoslipins_u2', NULL, NULL, 'SPFH_eoslipins_u2', 7955),
(7956, 'cd00805', NULL, 'TyrRS_core', NULL, NULL, 'TyrRS_core', 7956),
(7957, 'cd12719', NULL, 'RRM_SYNJ1', NULL, NULL, 'RRM_SYNJ1', 7957),
(7958, 'cd14448', NULL, 'CuRO_2_BOD_CotA_like', NULL, NULL, 'CuRO_2_BOD_CotA_like', 7958),
(7959, 'cd01486', NULL, 'Apg7', NULL, NULL, 'Apg7', 7959),
(7960, 'cd09073', NULL, 'ExoIII_AP-endo', NULL, NULL, 'ExoIII_AP-endo', 7960),
(7961, 'cd05103', NULL, 'PTKc_VEGFR2', NULL, NULL, 'PTKc_VEGFR2', 7961),
(7962, 'cd18356', NULL, 'BTB1_POZ_RHOBTB2', NULL, NULL, 'BTB1_POZ_RHOBTB2', 7962),
(7963, 'cd10332', NULL, 'SLC6sbd-B0AT-like', NULL, NULL, 'SLC6sbd-B0AT-like', 7963),
(7964, 'cd18207', NULL, 'BTB_POZ_ZBTB19_PATZ1', NULL, NULL, 'BTB_POZ_ZBTB19_PATZ1', 7964),
(7965, 'sd00038', NULL, 'Kelch', NULL, NULL, 'Kelch', 7965),
(7966, 'cd18695', NULL, 'PIN_VapC-like', NULL, NULL, 'PIN_VapC-like', 7966),
(7967, 'cd17626', NULL, 'REC_OmpR_MtrA-like', NULL, NULL, 'REC_OmpR_MtrA-like', 7967),
(7968, 'cd16092', NULL, 'IgC_CH1_IgD', NULL, NULL, 'IgC_CH1_IgD', 7968),
(7969, 'cd16374', NULL, 'DMSOR_beta_like', NULL, NULL, 'DMSOR_beta_like', 7969),
(7970, 'cd13758', NULL, 'TGF_beta_LEFTY1_2', NULL, NULL, 'TGF_beta_LEFTY1_2', 7970),
(7971, 'cd12771', NULL, 'RRM1_HuB', NULL, NULL, 'RRM1_HuB', 7971),
(7972, 'cd04401', NULL, 'RhoGAP_fMSB1', NULL, NULL, 'RhoGAP_fMSB1', 7972),
(7973, 'cd06600', NULL, 'GH31_MGAM-like', NULL, NULL, 'GH31_MGAM-like', 7973),
(7974, 'cd00010', NULL, 'AAI_LTSS', NULL, NULL, 'AAI_LTSS', 7974),
(7975, 'cd16158', NULL, 'ARSA', NULL, NULL, 'ARSA', 7975),
(7976, 'cd11513', NULL, 'SLC6sbd_SERT', NULL, NULL, 'SLC6sbd_SERT', 7976),
(7977, 'cd14053', NULL, 'STKc_ACVR2', NULL, NULL, 'STKc_ACVR2', 7977),
(7978, 'cd01763', NULL, 'Ubl_SUMO_like', NULL, NULL, 'Ubl_SUMO_like', 7978),
(7979, 'cd16017', NULL, 'LptA', NULL, NULL, 'LptA', 7979),
(7980, 'cd15398', NULL, '7tmA_NPY5R', NULL, NULL, '7tmA_NPY5R', 7980),
(7981, 'cd10477', NULL, 'EphR_LBD_B2', NULL, NULL, 'EphR_LBD_B2', 7981),
(7982, 'cd00669', NULL, 'Asp_Lys_Asn_RS_core', NULL, NULL, 'Asp_Lys_Asn_RS_core', 7982),
(7983, 'cd04932', NULL, 'ACT_AKiii-LysC-EC_1', NULL, NULL, 'ACT_AKiii-LysC-EC_1', 7983),
(7984, 'cd14428', NULL, 'UBA2_HR23B', NULL, NULL, 'UBA2_HR23B', 7984),
(7985, 'cd00563', NULL, 'Dtyr_deacylase', NULL, NULL, 'Dtyr_deacylase', 7985),
(7986, 'cd13945', NULL, 'Chs5_N', NULL, NULL, 'Chs5_N', 7986),
(7987, 'cd15911', NULL, '7tmA_OR11A-like', NULL, NULL, '7tmA_OR11A-like', 7987),
(7988, 'cd11952', NULL, 'SH3_iASPP', NULL, NULL, 'SH3_iASPP', 7988);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(7989, 'cd02034', NULL, 'CooC1', NULL, NULL, 'CooC1', 7989),
(7990, 'cd17196', NULL, 'FERM_F1_FRMPD2', NULL, NULL, 'FERM_F1_FRMPD2', 7990),
(7991, 'cd09514', NULL, 'SAM_SGMS1', NULL, NULL, 'SAM_SGMS1', 7991),
(7992, 'cd18199', NULL, 'BTB_POZ_ZBTB8', NULL, NULL, 'BTB_POZ_ZBTB8', 7992),
(7993, 'cd17201', NULL, 'FERM_F1_EPB41L1', NULL, NULL, 'FERM_F1_EPB41L1', 7993),
(7994, 'cd00786', NULL, 'cytidine_deaminase-like', NULL, NULL, 'cytidine_deaminase-like', 7994),
(7995, 'cd21480', NULL, 'SARS-CoV-2_Spike_S1_RBD', NULL, NULL, 'SARS-CoV-2_Spike_S1_RBD', 7995),
(7996, 'cd04726', NULL, 'KGPDC_HPS', NULL, NULL, 'KGPDC_HPS', 7996),
(7997, 'cd10018', NULL, 'BfiI_C', NULL, NULL, 'BfiI_C', 7997),
(7998, 'cd12632', NULL, 'RRM1_CELF3_4_5_6', NULL, NULL, 'RRM1_CELF3_4_5_6', 7998),
(7999, 'cd18521', NULL, 'BACK_Tdpoz', NULL, NULL, 'BACK_Tdpoz', 7999),
(8000, 'cd19368', NULL, 'TenA_C_AtTH2-like', NULL, NULL, 'TenA_C_AtTH2-like', 8000),
(8001, 'cd11501', NULL, 'SLC6sbd_ATB0', NULL, NULL, 'SLC6sbd_ATB0', 8001),
(8002, 'cd11602', NULL, 'Ndc10', NULL, NULL, 'Ndc10', 8002),
(8003, 'cd17399', NULL, 'MFS_MFSD7', NULL, NULL, 'MFS_MFSD7', 8003),
(8004, 'cd00404', NULL, 'Aconitase_swivel', NULL, NULL, 'Aconitase_swivel', 8004),
(8005, 'cd08234', NULL, 'threonine_DH_like', NULL, NULL, 'threonine_DH_like', 8005),
(8006, 'cd16756', NULL, 'RING-HC_TRIM36', NULL, NULL, 'RING-HC_TRIM36', 8006),
(8007, 'cd00953', NULL, 'KDG_aldolase', NULL, NULL, 'KDG_aldolase', 8007),
(8008, 'cd05382', NULL, 'CAP_GAPR1-like', NULL, NULL, 'CAP_GAPR1-like', 8008),
(8009, 'cd17346', NULL, 'MFS_DtpA_like', NULL, NULL, 'MFS_DtpA_like', 8009),
(8010, 'cd12761', NULL, 'RRM1_hnRNPA1', NULL, NULL, 'RRM1_hnRNPA1', 8010),
(8011, 'cd10527', NULL, 'SET_LSMT', NULL, NULL, 'SET_LSMT', 8011),
(8012, 'cd12561', NULL, 'RRM1_RBM5_like', NULL, NULL, 'RRM1_RBM5_like', 8012),
(8013, 'cd10439', NULL, 'GIY-YIG_COG3410', NULL, NULL, 'GIY-YIG_COG3410', 8013),
(8014, 'cd06295', NULL, 'PBP1_CelR', NULL, NULL, 'PBP1_CelR', 8014),
(8015, 'cd11941', NULL, 'SH3_ARHGEF37_C2', NULL, NULL, 'SH3_ARHGEF37_C2', 8015),
(8016, 'cd17250', NULL, 'RMtype1_S_Eco4255II_TRD2-CR2_like', NULL, NULL, 'RMtype1_S_Eco4255II_TRD2-CR2_like', 8016),
(8017, 'cd12769', NULL, 'RRM1_HuR', NULL, NULL, 'RRM1_HuR', 8017),
(8018, 'cd05940', NULL, 'FATP_FACS', NULL, NULL, 'FATP_FACS', 8018),
(8019, 'cd04775', NULL, 'HTH_Cfa-like', NULL, NULL, 'HTH_Cfa-like', 8019),
(8020, 'cd09272', NULL, 'RNase_HI_RT_Ty1', NULL, NULL, 'RNase_HI_RT_Ty1', 8020),
(8021, 'cd15211', NULL, '7tmA_GPR88-like', NULL, NULL, '7tmA_GPR88-like', 8021),
(8022, 'cd16701', NULL, 'RING_CH-C4HC3_MARCH5', NULL, NULL, 'RING_CH-C4HC3_MARCH5', 8022),
(8023, 'cd09969', NULL, 'UP_IIIb', NULL, NULL, 'UP_IIIb', 8023),
(8024, 'cd14640', NULL, 'DSP_DUSP4', NULL, NULL, 'DSP_DUSP4', 8024),
(8025, 'cd03188', NULL, 'GST_C_Beta', NULL, NULL, 'GST_C_Beta', 8025),
(8026, 'cd17519', NULL, 'RMtype1_S_HpyCR35ORFAP-TRD1-CR1_like', NULL, NULL, 'RMtype1_S_HpyCR35ORFAP-TRD1-CR1_like', 8026),
(8027, 'cd20303', NULL, 'cupin_ChrR_1', NULL, NULL, 'cupin_ChrR_1', 8027),
(8028, 'cd07071', NULL, 'NR_LBD_Nurr1', NULL, NULL, 'NR_LBD_Nurr1', 8028),
(8029, 'cd05380', NULL, 'CAP_euk', NULL, NULL, 'CAP_euk', 8029),
(8030, 'cd01145', NULL, 'TroA_c', NULL, NULL, 'TroA_c', 8030),
(8031, 'cd14741', NULL, 'PAAR_5', NULL, NULL, 'PAAR_5', 8031),
(8032, 'cd07437', NULL, 'PHP_HisPPase_Ycdx_like', NULL, NULL, 'PHP_HisPPase_Ycdx_like', 8032),
(8033, 'cd01075', NULL, 'NAD_bind_Leu_Phe_Val_DH', NULL, NULL, 'NAD_bind_Leu_Phe_Val_DH', 8033),
(8034, 'cd02136', NULL, 'PnbA_NfnB-like', NULL, NULL, 'PnbA_NfnB-like', 8034),
(8035, 'cd18275', NULL, 'BTB_POZ_KBTBD11', NULL, NULL, 'BTB_POZ_KBTBD11', 8035),
(8036, 'cd07058', NULL, 'BMC_CsoS1', NULL, NULL, 'BMC_CsoS1', 8036),
(8037, 'cd02904', NULL, 'Macro_H2A-like', NULL, NULL, 'Macro_H2A-like', 8037),
(8038, 'cd07262', NULL, 'VOC_like', NULL, NULL, 'VOC_like', 8038),
(8039, 'cd18214', NULL, 'BTB_POZ_ZBTB26_Bioref', NULL, NULL, 'BTB_POZ_ZBTB26_Bioref', 8039),
(8040, 'cd08698', NULL, 'TGF_beta_SF', NULL, NULL, 'TGF_beta_SF', 8040),
(8041, 'cd09987', NULL, 'Arginase_HDAC', NULL, NULL, 'Arginase_HDAC', 8041);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(8042, 'cd04592', NULL, 'CBS_pair_voltage-gated_CLC_euk_bac', NULL, NULL, 'CBS_pair_voltage-gated_CLC_euk_bac', 8042),
(8043, 'cd12644', NULL, 'RRM_CFIm59', NULL, NULL, 'RRM_CFIm59', 8043),
(8044, 'cd09761', NULL, 'A3DFK9-like_SDR_c', NULL, NULL, 'A3DFK9-like_SDR_c', 8044),
(8045, 'cd14742', NULL, 'PAAR_RHS', NULL, NULL, 'PAAR_RHS', 8045),
(8046, 'cd08941', NULL, '3KS_SDR_c', NULL, NULL, '3KS_SDR_c', 8046),
(8047, 'cd08295', NULL, 'double_bond_reductase_like', NULL, NULL, 'double_bond_reductase_like', 8047),
(8048, 'cd16433', NULL, 'CheB', NULL, NULL, 'CheB', 8048),
(8049, 'cd15116', NULL, '7tmA_CMKLR1', NULL, NULL, '7tmA_CMKLR1', 8049),
(8050, 'cd13229', NULL, 'PH_TFIIH', NULL, NULL, 'PH_TFIIH', 8050),
(8051, 'cd14001', NULL, 'PKc_TOPK', NULL, NULL, 'PKc_TOPK', 8051),
(8052, 'cd09452', NULL, 'LIM1_Enigma', NULL, NULL, 'LIM1_Enigma', 8052),
(8053, 'cd15130', NULL, '7tmA_NTSR', NULL, NULL, '7tmA_NTSR', 8053),
(8054, 'cd15118', NULL, '7tmA_PD2R2_CRTH2', NULL, NULL, '7tmA_PD2R2_CRTH2', 8054),
(8055, 'cd11730', NULL, 'Tthb094_like_SDR_c', NULL, NULL, 'Tthb094_like_SDR_c', 8055),
(8056, 'cd15218', NULL, '7tmA_SREB2_GPR85', NULL, NULL, '7tmA_SREB2_GPR85', 8056),
(8057, 'cd16977', NULL, 'VHS_GGA', NULL, NULL, 'VHS_GGA', 8057),
(8058, 'cd07635', NULL, 'BAR_GRAF2', NULL, NULL, 'BAR_GRAF2', 8058),
(8059, 'cd12747', NULL, 'RRM2_RBM12', NULL, NULL, 'RRM2_RBM12', 8059),
(8060, 'cd13734', NULL, 'SPRY_PRY_C-II', NULL, NULL, 'SPRY_PRY_C-II', 8060),
(8061, 'cd13193', NULL, 'FERM_C_FARP1-like', NULL, NULL, 'FERM_C_FARP1-like', 8061),
(8062, 'cd01971', NULL, 'Nitrogenase_VnfN_like', NULL, NULL, 'Nitrogenase_VnfN_like', 8062),
(8063, 'cd09139', NULL, 'PLDc_pPLD_like_1', NULL, NULL, 'PLDc_pPLD_like_1', 8063),
(8064, 'cd11425', NULL, 'bHLH_TS_Mesp_like', NULL, NULL, 'bHLH_TS_Mesp_like', 8064),
(8065, 'cd18546', NULL, 'ABC_6TM_Rv0194_D2_like', NULL, NULL, 'ABC_6TM_Rv0194_D2_like', 8065),
(8066, 'cd05126', NULL, 'Mth938', NULL, NULL, 'Mth938', 8066),
(8067, 'cd06612', NULL, 'STKc_MST1_2', NULL, NULL, 'STKc_MST1_2', 8067),
(8068, 'cd17956', NULL, 'DEADc_DDX51', NULL, NULL, 'DEADc_DDX51', 8068),
(8069, 'cd01754', NULL, 'PLAT_plant_stress', NULL, NULL, 'PLAT_plant_stress', 8069),
(8070, 'cd12352', NULL, 'RRM1_TIA1_like', NULL, NULL, 'RRM1_TIA1_like', 8070),
(8071, 'cd07163', NULL, 'NR_DBD_TLX', NULL, NULL, 'NR_DBD_TLX', 8071),
(8072, 'cd20754', NULL, 'capping_2-OMTase_viral', NULL, NULL, 'capping_2-OMTase_viral', 8072),
(8073, 'cd15075', NULL, '7tmA_Parapinopsin', NULL, NULL, '7tmA_Parapinopsin', 8073),
(8074, 'cd09367', NULL, 'LIM1_Lhx1_Lhx5', NULL, NULL, 'LIM1_Lhx1_Lhx5', 8074),
(8075, 'cd08346', NULL, 'PcpA_N_like', NULL, NULL, 'PcpA_N_like', 8075),
(8076, 'cd15297', NULL, '7tmA_mAChR_M2', NULL, NULL, '7tmA_mAChR_M2', 8076),
(8077, 'cd16711', NULL, 'RING-HC_DTX3', NULL, NULL, 'RING-HC_DTX3', 8077),
(8078, 'cd03046', NULL, 'GST_N_GTT1_like', NULL, NULL, 'GST_N_GTT1_like', 8078),
(8079, 'cd05572', NULL, 'STKc_cGK', NULL, NULL, 'STKc_cGK', 8079),
(8080, 'cd09111', NULL, 'PLDc_ymdC_like_1', NULL, NULL, 'PLDc_ymdC_like_1', 8080),
(8081, 'cd06543', NULL, 'GH18_PF-ChiA-like', NULL, NULL, 'GH18_PF-ChiA-like', 8081),
(8082, 'cd04204', NULL, 'Pseudoazurin_like', NULL, NULL, 'Pseudoazurin_like', 8082),
(8083, 'cd02106', NULL, 'SPFH_like', NULL, NULL, 'SPFH_like', 8083),
(8084, 'cd07783', NULL, 'FGGY_CarbK-RPE_like', NULL, NULL, 'FGGY_CarbK-RPE_like', 8084),
(8085, 'cd18511', NULL, 'BACK_KLHL5', NULL, NULL, 'BACK_KLHL5', 8085),
(8086, 'cd00190', NULL, 'Tryp_SPc', NULL, NULL, 'Tryp_SPc', 8086),
(8087, 'cd14630', NULL, 'R-PTPc-T-1', NULL, NULL, 'R-PTPc-T-1', 8087),
(8088, 'cd04491', NULL, 'SoSSB_OBF', NULL, NULL, 'SoSSB_OBF', 8088),
(8089, 'cd00655', NULL, 'RNAP_Rpb7_N_like', NULL, NULL, 'RNAP_Rpb7_N_like', 8089),
(8090, 'cd13313', NULL, 'PH_NF1', NULL, NULL, 'PH_NF1', 8090),
(8091, 'cd18574', NULL, 'ABC_6TM_ABCB8_like', NULL, NULL, 'ABC_6TM_ABCB8_like', 8091),
(8092, 'cd17781', NULL, 'CBS_pair_MUG70_1', NULL, NULL, 'CBS_pair_MUG70_1', 8092),
(8093, 'cd20478', NULL, 'Cas13b_Bz-like', NULL, NULL, 'Cas13b_Bz-like', 8093),
(8094, 'cd05689', NULL, 'S1_RPS1_repeat_ec4', NULL, NULL, 'S1_RPS1_repeat_ec4', 8094);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(8095, 'cd03545', NULL, 'Rieske_RO_Alpha_OHBDO_like', NULL, NULL, 'Rieske_RO_Alpha_OHBDO_like', 8095),
(8096, 'cd19420', NULL, 'lipocalin_VDE', NULL, NULL, 'lipocalin_VDE', 8096),
(8097, 'cd10916', NULL, 'CE4_PuuE_HpPgdA_like', NULL, NULL, 'CE4_PuuE_HpPgdA_like', 8097),
(8098, 'cd09129', NULL, 'PLDc_unchar2_1', NULL, NULL, 'PLDc_unchar2_1', 8098),
(8099, 'cd10038', NULL, 'Reelin_repeat_2_subrepeat_1', NULL, NULL, 'Reelin_repeat_2_subrepeat_1', 8099),
(8100, 'cd01478', NULL, 'Sec23-like', NULL, NULL, 'Sec23-like', 8100),
(8101, 'cd08017', NULL, 'M20_IAA_Hyd', NULL, NULL, 'M20_IAA_Hyd', 8101),
(8102, 'cd06826', NULL, 'PLPDE_III_AR2', NULL, NULL, 'PLPDE_III_AR2', 8102),
(8103, 'cd00845', NULL, 'MPP_UshA_N_like', NULL, NULL, 'MPP_UshA_N_like', 8103),
(8104, 'cd05526', NULL, 'Bromo_polybromo_VI', NULL, NULL, 'Bromo_polybromo_VI', 8104),
(8105, 'cd10980', NULL, 'CE4_SpCDA1', NULL, NULL, 'CE4_SpCDA1', 8105),
(8106, 'cd02325', NULL, 'R3H', NULL, NULL, 'R3H', 8106),
(8107, 'cd15698', NULL, 'ePHD2_KMT2D', NULL, NULL, 'ePHD2_KMT2D', 8107),
(8108, 'cd15588', NULL, 'PHD1_KMT2A', NULL, NULL, 'PHD1_KMT2A', 8108),
(8109, 'cd00801', NULL, 'INT_P4_C', NULL, NULL, 'INT_P4_C', 8109),
(8110, 'cd00399', NULL, 'RNAP_largest_subunit_N', NULL, NULL, 'RNAP_largest_subunit_N', 8110),
(8111, 'cd08871', NULL, 'START_STARD10-like', NULL, NULL, 'START_STARD10-like', 8111),
(8112, 'cd04330', NULL, 'RNAP_III_Rpc25_N', NULL, NULL, 'RNAP_III_Rpc25_N', 8112),
(8113, 'cd16741', NULL, 'RING-HC_RNFT1', NULL, NULL, 'RING-HC_RNFT1', 8113),
(8114, 'cd03309', NULL, 'CmuC_like', NULL, NULL, 'CmuC_like', 8114),
(8115, 'cd16459', NULL, 'RING-H2_DTX1_like', NULL, NULL, 'RING-H2_DTX1_like', 8115),
(8116, 'cd17565', NULL, 'REC_GlnL-like', NULL, NULL, 'REC_GlnL-like', 8116),
(8117, 'cd00053', NULL, 'EGF', NULL, NULL, 'EGF', 8117),
(8118, 'cd05473', NULL, 'beta_secretase_like', NULL, NULL, 'beta_secretase_like', 8118),
(8119, 'cd16275', NULL, 'BaeB-like_MBL-fold', NULL, NULL, 'BaeB-like_MBL-fold', 8119),
(8120, 'cd00854', NULL, 'NagA', NULL, NULL, 'NagA', 8120),
(8121, 'cd15188', NULL, '7tmA_ACKR2_D6', NULL, NULL, '7tmA_ACKR2_D6', 8121),
(8122, 'cd06635', NULL, 'STKc_TAO1', NULL, NULL, 'STKc_TAO1', 8122),
(8123, 'cd15190', NULL, '7tmA_Apelin_R', NULL, NULL, '7tmA_Apelin_R', 8123),
(8124, 'cd01767', NULL, 'UBX', NULL, NULL, 'UBX', 8124),
(8125, 'cd18937', NULL, 'bHLH_TS_Myf5', NULL, NULL, 'bHLH_TS_Myf5', 8125),
(8126, 'cd19098', NULL, 'AKR_unchar', NULL, NULL, 'AKR_unchar', 8126),
(8127, 'cd04697', NULL, 'Nudix_Hydrolase_38', NULL, NULL, 'Nudix_Hydrolase_38', 8127),
(8128, 'cd13442', NULL, 'CDI_toxin_Bp1026b_like', NULL, NULL, 'CDI_toxin_Bp1026b_like', 8128),
(8129, 'cd12823', NULL, 'Mrs2_Mfm1p-like', NULL, NULL, 'Mrs2_Mfm1p-like', 8129),
(8130, 'cd05712', NULL, 'Ig_Siglec_N', NULL, NULL, 'Ig_Siglec_N', 8130),
(8131, 'cd08760', NULL, 'Cyt_b561_FRRS1_like', NULL, NULL, 'Cyt_b561_FRRS1_like', 8131),
(8132, 'cd11881', NULL, 'SH3_MYO7A', NULL, NULL, 'SH3_MYO7A', 8132),
(8133, 'cd17044', NULL, 'Ubl_TBCE', NULL, NULL, 'Ubl_TBCE', 8133),
(8134, 'cd03010', NULL, 'TlpA_like_DsbE', NULL, NULL, 'TlpA_like_DsbE', 8134),
(8135, 'cd05848', NULL, 'Ig1_Contactin-5', NULL, NULL, 'Ig1_Contactin-5', 8135),
(8136, 'cd10362', NULL, 'SH2_Src_Lck', NULL, NULL, 'SH2_Src_Lck', 8136),
(8137, 'cd01094', NULL, 'Alkanesulfonate_monoxygenase', NULL, NULL, 'Alkanesulfonate_monoxygenase', 8137),
(8138, 'cd06122', NULL, 'cupin_TTHA0104', NULL, NULL, 'cupin_TTHA0104', 8138),
(8139, 'cd14407', NULL, 'UBA_MARK3_4', NULL, NULL, 'UBA_MARK3_4', 8139),
(8140, 'cd17264', NULL, 'RMtype1_S_Eco3763I-TRD2-CR2_like', NULL, NULL, 'RMtype1_S_Eco3763I-TRD2-CR2_like', 8140),
(8141, 'cd16380', NULL, 'YitT_C', NULL, NULL, 'YitT_C', 8141),
(8142, 'cd11803', NULL, 'SH3_Endophilin_A', NULL, NULL, 'SH3_Endophilin_A', 8142),
(8143, 'cd13957', NULL, 'PT_UbiA_Cox10', NULL, NULL, 'PT_UbiA_Cox10', 8143),
(8144, 'cd09620', NULL, 'CBM9_like_3', NULL, NULL, 'CBM9_like_3', 8144),
(8145, 'cd11880', NULL, 'SH3_Caskin', NULL, NULL, 'SH3_Caskin', 8145),
(8146, 'cd16196', NULL, 'EFh_PEF_CalpA_B', NULL, NULL, 'EFh_PEF_CalpA_B', 8146);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(8147, 'cd18054', NULL, 'DEXHc_CHD2', NULL, NULL, 'DEXHc_CHD2', 8147),
(8148, 'cd02212', NULL, 'cupin_UGlyAH_C', NULL, NULL, 'cupin_UGlyAH_C', 8148),
(8149, 'cd00712', NULL, 'AsnB', NULL, NULL, 'AsnB', 8149),
(8150, 'cd12910', NULL, 'SPRY_SSH4_like', NULL, NULL, 'SPRY_SSH4_like', 8150),
(8151, 'cd03789', NULL, 'GT9_LPS_heptosyltransferase', NULL, NULL, 'GT9_LPS_heptosyltransferase', 8151),
(8152, 'cd04622', NULL, 'CBS_pair_HRP1_like', NULL, NULL, 'CBS_pair_HRP1_like', 8152),
(8153, 'cd02742', NULL, 'GH20_hexosaminidase', NULL, NULL, 'GH20_hexosaminidase', 8153),
(8154, 'cd05501', NULL, 'Bromo_SP100C_like', NULL, NULL, 'Bromo_SP100C_like', 8154),
(8155, 'cd15953', NULL, '7tmA_OR52P-like', NULL, NULL, '7tmA_OR52P-like', 8155),
(8156, 'cd14952', NULL, 'NHL_PKND_like', NULL, NULL, 'NHL_PKND_like', 8156),
(8157, 'cd05383', NULL, 'CAP_CRISP', NULL, NULL, 'CAP_CRISP', 8157),
(8158, 'cd14797', NULL, 'DUF302', NULL, NULL, 'DUF302', 8158),
(8159, 'cd18231', NULL, 'BTB_POZ_ZBTB47_ZNF651', NULL, NULL, 'BTB_POZ_ZBTB47_ZNF651', 8159),
(8160, 'cd18790', NULL, 'SF2_C_UvrB', NULL, NULL, 'SF2_C_UvrB', 8160),
(8161, 'cd05370', NULL, 'SDR_c2', NULL, NULL, 'SDR_c2', 8161),
(8162, 'cd14000', NULL, 'STKc_LRRK', NULL, NULL, 'STKc_LRRK', 8162),
(8163, 'cd00714', NULL, 'GFAT', NULL, NULL, 'GFAT', 8163),
(8164, 'cd13184', NULL, 'FERM_C_4_1_family', NULL, NULL, 'FERM_C_4_1_family', 8164),
(8165, 'cd06365', NULL, 'PBP1_pheromone_receptor', NULL, NULL, 'PBP1_pheromone_receptor', 8165),
(8166, 'cd07102', NULL, 'ALDH_EDX86601', NULL, NULL, 'ALDH_EDX86601', 8166),
(8167, 'cd19355', NULL, 'Wnt_Wnt10a', NULL, NULL, 'Wnt_Wnt10a', 8167),
(8168, 'cd18371', NULL, 'BTB_POZ_KCTD14', NULL, NULL, 'BTB_POZ_KCTD14', 8168),
(8169, 'cd19846', NULL, 'Bbox1_TIF1b_C-VI', NULL, NULL, 'Bbox1_TIF1b_C-VI', 8169),
(8170, 'cd16788', NULL, 'mRING-HC-C3HC5_RNF26', NULL, NULL, 'mRING-HC-C3HC5_RNF26', 8170),
(8171, 'cd19581', NULL, 'serpinL_nematode', NULL, NULL, 'serpinL_nematode', 8171),
(8172, 'cd01009', NULL, 'PBP2_YfhD_N', NULL, NULL, 'PBP2_YfhD_N', 8172),
(8173, 'cd07979', NULL, 'TAF9', NULL, NULL, 'TAF9', 8173),
(8174, 'cd18081', NULL, 'RlmH-like', NULL, NULL, 'RlmH-like', 8174),
(8175, 'cd19576', NULL, 'serpinI2_pancpin', NULL, NULL, 'serpinI2_pancpin', 8175),
(8176, 'cd15027', NULL, '7tm_TAS2R43-like', NULL, NULL, '7tm_TAS2R43-like', 8176),
(8177, 'cd18509', NULL, 'BACK_KLHL1', NULL, NULL, 'BACK_KLHL1', 8177),
(8178, 'cd17401', NULL, 'MFS_SLCO2_OATP2', NULL, NULL, 'MFS_SLCO2_OATP2', 8178),
(8179, 'cd06574', NULL, 'TM_PBP1_branched-chain-AA_like', NULL, NULL, 'TM_PBP1_branched-chain-AA_like', 8179),
(8180, 'cd06578', NULL, 'HemD', NULL, NULL, 'HemD', 8180),
(8181, 'cd15635', NULL, 'PHD_PYGO1', NULL, NULL, 'PHD_PYGO1', 8181),
(8182, 'cd02851', NULL, 'E_set_GO_C', NULL, NULL, 'E_set_GO_C', 8182),
(8183, 'cd12229', NULL, 'RRM_G3BP', NULL, NULL, 'RRM_G3BP', 8183),
(8184, 'cd15216', NULL, '7tmA_SREB1_GPR27', NULL, NULL, '7tmA_SREB1_GPR27', 8184),
(8185, 'cd01372', NULL, 'KISc_KIF4', NULL, NULL, 'KISc_KIF4', 8185),
(8186, 'cd15131', NULL, '7tmA_GHSR', NULL, NULL, '7tmA_GHSR', 8186),
(8187, 'cd15309', NULL, '7tmA_D2_dopamine_R', NULL, NULL, '7tmA_D2_dopamine_R', 8187),
(8188, 'cd15560', NULL, 'PHD2_3_BPTF', NULL, NULL, 'PHD2_3_BPTF', 8188),
(8189, 'cd15166', NULL, '7tmA_NAGly_R_GPR18', NULL, NULL, '7tmA_NAGly_R_GPR18', 8189),
(8190, 'cd06363', NULL, 'PBP1_taste_receptor', NULL, NULL, 'PBP1_taste_receptor', 8190),
(8191, 'cd18754', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, 'PIN_VapC4-5_FitB-like', 8191),
(8192, 'cd12759', NULL, 'RRM1_MSI1', NULL, NULL, 'RRM1_MSI1', 8192),
(8193, 'cd16331', NULL, 'YjgA-like', NULL, NULL, 'YjgA-like', 8193),
(8194, 'cd12180', NULL, '2-Hacid_dh_15', NULL, NULL, '2-Hacid_dh_15', 8194),
(8195, 'cd13321', NULL, 'PH_PLEKHM1', NULL, NULL, 'PH_PLEKHM1', 8195),
(8196, 'cd17936', NULL, 'EEXXEc_NFX1', NULL, NULL, 'EEXXEc_NFX1', 8196),
(8197, 'cd01521', NULL, 'RHOD_PspE2', NULL, NULL, 'RHOD_PspE2', 8197),
(8198, 'cd01533', NULL, '4RHOD_Repeat_2', NULL, NULL, '4RHOD_Repeat_2', 8198),
(8199, 'cd10380', NULL, 'SH2_Jak3', NULL, NULL, 'SH2_Jak3', 8199);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(8200, 'cd16512', NULL, 'RING-HC_LNX3_like', NULL, NULL, 'RING-HC_LNX3_like', 8200),
(8201, 'cd03075', NULL, 'GST_N_Mu', NULL, NULL, 'GST_N_Mu', 8201),
(8202, 'cd17316', NULL, 'MFS_SV2_like', NULL, NULL, 'MFS_SV2_like', 8202),
(8203, 'cd16510', NULL, 'RING-HC_IAPs', NULL, NULL, 'RING-HC_IAPs', 8203),
(8204, 'cd16627', NULL, 'RING-HC_RBR_parkin', NULL, NULL, 'RING-HC_RBR_parkin', 8204),
(8205, 'cd07677', NULL, 'F-BAR_FCHSD2', NULL, NULL, 'F-BAR_FCHSD2', 8205),
(8206, 'cd01543', NULL, 'PBP1_XylR', NULL, NULL, 'PBP1_XylR', 8206),
(8207, 'cd11457', NULL, 'bHLHzip_L-Myc', NULL, NULL, 'bHLHzip_L-Myc', 8207),
(8208, 'cd12891', NULL, 'SPRY_PRY_C-I_2', NULL, NULL, 'SPRY_PRY_C-I_2', 8208),
(8209, 'cd04643', NULL, 'CBS_pair_bac', NULL, NULL, 'CBS_pair_bac', 8209),
(8210, 'cd05879', NULL, 'Ig_P0', NULL, NULL, 'Ig_P0', 8210),
(8211, 'cd17299', NULL, 'acetolactate_decarboxylase', NULL, NULL, 'acetolactate_decarboxylase', 8211),
(8212, 'cd12527', NULL, 'RRM2_EAR1_like', NULL, NULL, 'RRM2_EAR1_like', 8212),
(8213, 'cd14319', NULL, 'UBA_NBR1', NULL, NULL, 'UBA_NBR1', 8213),
(8214, 'cd16148', NULL, 'sulfatase_like', NULL, NULL, 'sulfatase_like', 8214),
(8215, 'cd04237', NULL, 'AAK_NAGS-ABP', NULL, NULL, 'AAK_NAGS-ABP', 8215),
(8216, 'cd15811', NULL, 'SPRY_PRY_TRIM11', NULL, NULL, 'SPRY_PRY_TRIM11', 8216),
(8217, 'cd18956', NULL, 'BTB_POZ_ZBTB42', NULL, NULL, 'BTB_POZ_ZBTB42', 8217),
(8218, 'cd15439', NULL, '7tmB2_EMR', NULL, NULL, '7tmB2_EMR', 8218),
(8219, 'cd11430', NULL, 'bHLH_TS_ATOH1_like', NULL, NULL, 'bHLH_TS_ATOH1_like', 8219),
(8220, 'cd04455', NULL, 'S1_NusA', NULL, NULL, 'S1_NusA', 8220),
(8221, 'cd13327', NULL, 'PH_PLEKHM3_2', NULL, NULL, 'PH_PLEKHM3_2', 8221),
(8222, 'cd07833', NULL, 'STKc_CDKL', NULL, NULL, 'STKc_CDKL', 8222),
(8223, 'cd18273', NULL, 'BTB_POZ_KBTBD6_7', NULL, NULL, 'BTB_POZ_KBTBD6_7', 8223),
(8224, 'cd18259', NULL, 'BTB_POZ_KLHL30', NULL, NULL, 'BTB_POZ_KLHL30', 8224),
(8225, 'cd05374', NULL, '17beta-HSD-like_SDR_c', NULL, NULL, '17beta-HSD-like_SDR_c', 8225),
(8226, 'cd15028', NULL, '7tm_Opsin-1_euk', NULL, NULL, '7tm_Opsin-1_euk', 8226),
(8227, 'cd02885', NULL, 'IPP_Isomerase', NULL, NULL, 'IPP_Isomerase', 8227),
(8228, 'cd13401', NULL, 'Slt70-like', NULL, NULL, 'Slt70-like', 8228),
(8229, 'cd11938', NULL, 'SH3_ARHGEF16_26', NULL, NULL, 'SH3_ARHGEF16_26', 8229),
(8230, 'cd10359', NULL, 'SH2_SH3BP2', NULL, NULL, 'SH2_SH3BP2', 8230),
(8231, 'cd13627', NULL, 'PBP2_AA_binding_like_2', NULL, NULL, 'PBP2_AA_binding_like_2', 8231),
(8232, 'cd05155', NULL, 'APH_ChoK_like_1', NULL, NULL, 'APH_ChoK_like_1', 8232),
(8233, 'cd07728', NULL, 'YtnP-like_MBL-fold', NULL, NULL, 'YtnP-like_MBL-fold', 8233),
(8234, 'cd21531', NULL, 'CoV_E', NULL, NULL, 'CoV_E', 8234),
(8235, 'cd06338', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, 'PBP1_ABC_ligand_binding-like', 8235),
(8236, 'cd04919', NULL, 'ACT_AK-Hom3_2', NULL, NULL, 'ACT_AK-Hom3_2', 8236),
(8237, 'cd05563', NULL, 'PTS_IIB_ascorbate', NULL, NULL, 'PTS_IIB_ascorbate', 8237),
(8238, 'cd13548', NULL, 'PBP2_AEPn_like', NULL, NULL, 'PBP2_AEPn_like', 8238),
(8239, 'cd05123', NULL, 'STKc_AGC', NULL, NULL, 'STKc_AGC', 8239),
(8240, 'cd05565', NULL, 'PTS_IIB_lactose', NULL, NULL, 'PTS_IIB_lactose', 8240),
(8241, 'cd18944', NULL, 'bHLH_E-protein_E2A_TCF3', NULL, NULL, 'bHLH_E-protein_E2A_TCF3', 8241),
(8242, 'cd14901', NULL, 'MYSc_Myo40', NULL, NULL, 'MYSc_Myo40', 8242),
(8243, 'cd18298', NULL, 'BTB_POZ_RCBTB1_2', NULL, NULL, 'BTB_POZ_RCBTB1_2', 8243),
(8244, 'cd03442', NULL, 'BFIT_BACH', NULL, NULL, 'BFIT_BACH', 8244),
(8245, 'cd13245', NULL, 'PH_PLEKHG7', NULL, NULL, 'PH_PLEKHG7', 8245),
(8246, 'cd21658', NULL, 'gammaCoV_Nsp14', NULL, NULL, 'gammaCoV_Nsp14', 8246),
(8247, 'cd12460', NULL, 'RRM2_CID8_like', NULL, NULL, 'RRM2_CID8_like', 8247),
(8248, 'cd03775', NULL, 'MATH_Ubp21p', NULL, NULL, 'MATH_Ubp21p', 8248),
(8249, 'cd02232', NULL, 'cupin_ARD', NULL, NULL, 'cupin_ARD', 8249),
(8250, 'cd12143', NULL, 'SH3_ARHGAP9', NULL, NULL, 'SH3_ARHGAP9', 8250),
(8251, 'cd18089', NULL, 'SPOUT_Trm10-like', NULL, NULL, 'SPOUT_Trm10-like', 8251),
(8252, 'cd11988', NULL, 'SH3_Intersectin2_1', NULL, NULL, 'SH3_Intersectin2_1', 8252);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(8253, 'cd17984', NULL, 'DEXHc_DHX40', NULL, NULL, 'DEXHc_DHX40', 8253),
(8254, 'cd01824', NULL, 'Phospholipase_B_like', NULL, NULL, 'Phospholipase_B_like', 8254),
(8255, 'cd09590', NULL, 'SAM_LBP9', NULL, NULL, 'SAM_LBP9', 8255),
(8256, 'cd16718', NULL, 'RING-HC_LNX3', NULL, NULL, 'RING-HC_LNX3', 8256),
(8257, 'cd15850', NULL, 'SNARE_syntaxin18', NULL, NULL, 'SNARE_syntaxin18', 8257),
(8258, 'cd02996', NULL, 'PDI_a_ERp44', NULL, NULL, 'PDI_a_ERp44', 8258),
(8259, 'cd12097', NULL, 'DD_RI_PKA', NULL, NULL, 'DD_RI_PKA', 8259),
(8260, 'cd00239', NULL, 'PapG_CBD', NULL, NULL, 'PapG_CBD', 8260),
(8261, 'cd16927', NULL, 'HATPase_Hsp90-like', NULL, NULL, 'HATPase_Hsp90-like', 8261),
(8262, 'cd06846', NULL, 'Adenylation_DNA_ligase_like', NULL, NULL, 'Adenylation_DNA_ligase_like', 8262),
(8263, 'cd17661', NULL, 'PFA-DSP_Oca2', NULL, NULL, 'PFA-DSP_Oca2', 8263),
(8264, 'cd01958', NULL, 'HPS_like', NULL, NULL, 'HPS_like', 8264),
(8265, 'cd09331', NULL, 'LIM1_PINCH', NULL, NULL, 'LIM1_PINCH', 8265),
(8266, 'cd03807', NULL, 'GT4_WbnK-like', NULL, NULL, 'GT4_WbnK-like', 8266),
(8267, 'cd17104', NULL, 'FERM_F1_MYLIP', NULL, NULL, 'FERM_F1_MYLIP', 8267),
(8268, 'cd16873', NULL, 'ARID_KDM5A', NULL, NULL, 'ARID_KDM5A', 8268),
(8269, 'cd04102', NULL, 'RabL3', NULL, NULL, 'RabL3', 8269),
(8270, 'cd04818', NULL, 'PA_subtilisin_1', NULL, NULL, 'PA_subtilisin_1', 8270),
(8271, 'cd04403', NULL, 'RhoGAP_ARHGAP27_15_12_9', NULL, NULL, 'RhoGAP_ARHGAP27_15_12_9', 8271),
(8272, 'cd08509', NULL, 'PBP2_TmCBP_oligosaccharides_like', NULL, NULL, 'PBP2_TmCBP_oligosaccharides_like', 8272),
(8273, 'cd14628', NULL, 'R-PTP-D-2', NULL, NULL, 'R-PTP-D-2', 8273),
(8274, 'cd08313', NULL, 'Death_TNFR1', NULL, NULL, 'Death_TNFR1', 8274),
(8275, 'cd13870', NULL, 'CuRO_2_CopA_like_1', NULL, NULL, 'CuRO_2_CopA_like_1', 8275),
(8276, 'cd17236', NULL, 'Ubl_ATG8_MAP1LC3C', NULL, NULL, 'Ubl_ATG8_MAP1LC3C', 8276),
(8277, 'cd09130', NULL, 'PLDc_unchar2_2', NULL, NULL, 'PLDc_unchar2_2', 8277),
(8278, 'cd16481', NULL, 'RING-H2_TTC3', NULL, NULL, 'RING-H2_TTC3', 8278),
(8279, 'cd12259', NULL, 'RRM_SRSF11_SREK1', NULL, NULL, 'RRM_SRSF11_SREK1', 8279),
(8280, 'cd08962', NULL, 'GatD', NULL, NULL, 'GatD', 8280),
(8281, 'cd06451', NULL, 'AGAT_like', NULL, NULL, 'AGAT_like', 8281),
(8282, 'cd06606', NULL, 'STKc_MAPKKK', NULL, NULL, 'STKc_MAPKKK', 8282),
(8283, 'cd08377', NULL, 'C2C_MCTP_PRT', NULL, NULL, 'C2C_MCTP_PRT', 8283),
(8284, 'cd14016', NULL, 'STKc_CK1', NULL, NULL, 'STKc_CK1', 8284),
(8285, 'cd11535', NULL, 'NTP-PPase_SsMazG', NULL, NULL, 'NTP-PPase_SsMazG', 8285),
(8286, 'cd11903', NULL, 'SH3_Nck2_3', NULL, NULL, 'SH3_Nck2_3', 8286),
(8287, 'cd13330', NULL, 'PH_CARM1', NULL, NULL, 'PH_CARM1', 8287),
(8288, 'cd00195', NULL, 'UBCc', NULL, NULL, 'UBCc', 8288),
(8289, 'cd03473', NULL, 'Rieske_CMP_Neu5Ac_hydrolase_N', NULL, NULL, 'Rieske_CMP_Neu5Ac_hydrolase_N', 8289),
(8290, 'cd12185', NULL, 'HGDH_LDH_like', NULL, NULL, 'HGDH_LDH_like', 8290),
(8291, 'cd17348', NULL, 'MFS_SLC15A3_4', NULL, NULL, 'MFS_SLC15A3_4', 8291),
(8292, 'cd08608', NULL, 'GDPD_GDE2', NULL, NULL, 'GDPD_GDE2', 8292),
(8293, 'cd09676', NULL, 'Csy2_I-F', NULL, NULL, 'Csy2_I-F', 8293),
(8294, 'cd01206', NULL, 'EVH1_Homer_Vesl', NULL, NULL, 'EVH1_Homer_Vesl', 8294),
(8295, 'cd12776', NULL, 'RRM2_HuC', NULL, NULL, 'RRM2_HuC', 8295),
(8296, 'cd05535', NULL, 'POLBc_epsilon', NULL, NULL, 'POLBc_epsilon', 8296),
(8297, 'cd00300', NULL, 'LDH_like', NULL, NULL, 'LDH_like', 8297),
(8298, 'cd13555', NULL, 'PBP2_sulfate_ester_like', NULL, NULL, 'PBP2_sulfate_ester_like', 8298),
(8299, 'cd13990', NULL, 'STKc_TLK', NULL, NULL, 'STKc_TLK', 8299),
(8300, 'cd19095', NULL, 'AKR_PA4992-like', NULL, NULL, 'AKR_PA4992-like', 8300),
(8301, 'cd19119', NULL, 'AKR_AKR3C1', NULL, NULL, 'AKR_AKR3C1', 8301),
(8302, 'cd16521', NULL, 'RING-HC_MKRN', NULL, NULL, 'RING-HC_MKRN', 8302),
(8303, 'cd07705', NULL, 'Ig2_Necl-1', NULL, NULL, 'Ig2_Necl-1', 8303),
(8304, 'cd20610', NULL, 'Nitro_FMN_reductase_child_20', NULL, NULL, 'Nitro_FMN_reductase_child_20', 8304),
(8305, 'cd08885', NULL, 'RHO_alpha_C_1', NULL, NULL, 'RHO_alpha_C_1', 8305);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(8306, 'cd01553', NULL, 'EPT_RTPC-like', NULL, NULL, 'EPT_RTPC-like', 8306),
(8307, 'cd14564', NULL, 'PTP_GAK', NULL, NULL, 'PTP_GAK', 8307),
(8308, 'cd11666', NULL, 'GH38N_Man2A1', NULL, NULL, 'GH38N_Man2A1', 8308),
(8309, 'cd16467', NULL, 'RING-H2_RNF6_like', NULL, NULL, 'RING-H2_RNF6_like', 8309),
(8310, 'cd11574', NULL, 'GH99', NULL, NULL, 'GH99', 8310),
(8311, 'cd16643', NULL, 'mRING-HC-C3HC3D_TRAF6', NULL, NULL, 'mRING-HC-C3HC3D_TRAF6', 8311),
(8312, 'cd05791', NULL, 'S1_CSL4', NULL, NULL, 'S1_CSL4', 8312),
(8313, 'cd15048', NULL, '7tmA_Histamine_H3R_H4R', NULL, NULL, '7tmA_Histamine_H3R_H4R', 8313),
(8314, 'cd06228', NULL, 'M14-like', NULL, NULL, 'M14-like', 8314),
(8315, 'cd07653', NULL, 'F-BAR_CIP4-like', NULL, NULL, 'F-BAR_CIP4-like', 8315),
(8316, 'cd10392', NULL, 'SH2_SHF', NULL, NULL, 'SH2_SHF', 8316),
(8317, 'cd02662', NULL, 'Peptidase_C19F', NULL, NULL, 'Peptidase_C19F', 8317),
(8318, 'cd00109', NULL, 'KU', NULL, NULL, 'KU', 8318),
(8319, 'cd15783', NULL, 'SA1633_like', NULL, NULL, 'SA1633_like', 8319),
(8320, 'cd09981', NULL, 'LOTUS_5_Limkain_b1', NULL, NULL, 'LOTUS_5_Limkain_b1', 8320),
(8321, 'cd12832', NULL, 'TmCorA-like_u3', NULL, NULL, 'TmCorA-like_u3', 8321),
(8322, 'cd08883', NULL, 'RHO_alpha_C_CMO-like', NULL, NULL, 'RHO_alpha_C_CMO-like', 8322),
(8323, 'cd11578', NULL, 'GH99_GH71_like_1', NULL, NULL, 'GH99_GH71_like_1', 8323),
(8324, 'cd00323', NULL, 'uS7', NULL, NULL, 'uS7', 8324),
(8325, 'cd14542', NULL, 'PTPc-N22_18_12', NULL, NULL, 'PTPc-N22_18_12', 8325),
(8326, 'cd07821', NULL, 'PYR_PYL_RCAR_like', NULL, NULL, 'PYR_PYL_RCAR_like', 8326),
(8327, 'cd10310', NULL, 'GST_C_CysRS_N', NULL, NULL, 'GST_C_CysRS_N', 8327),
(8328, 'cd01758', NULL, 'PLAT_LPL', NULL, NULL, 'PLAT_LPL', 8328),
(8329, 'cd11949', NULL, 'SH3_GRB2_C', NULL, NULL, 'SH3_GRB2_C', 8329),
(8330, 'cd08252', NULL, 'AL_MDR', NULL, NULL, 'AL_MDR', 8330),
(8331, 'cd19396', NULL, 'TGF_beta_BMP6', NULL, NULL, 'TGF_beta_BMP6', 8331),
(8332, 'cd06970', NULL, 'NR_DBD_PNR', NULL, NULL, 'NR_DBD_PNR', 8332),
(8333, 'cd13640', NULL, 'PBP2_ChoX', NULL, NULL, 'PBP2_ChoX', 8333),
(8334, 'cd19976', NULL, 'PBP1_DegA_Like', NULL, NULL, 'PBP1_DegA_Like', 8334),
(8335, 'cd16378', NULL, 'CcmH_N', NULL, NULL, 'CcmH_N', 8335),
(8336, 'cd18934', NULL, 'bHLH_TS_MRF4_Myf6', NULL, NULL, 'bHLH_TS_MRF4_Myf6', 8336),
(8337, 'cd19800', NULL, 'Bbox2_xNF7-like', NULL, NULL, 'Bbox2_xNF7-like', 8337),
(8338, 'cd08561', NULL, 'GDPD_cytoplasmic_ScUgpQ2_like', NULL, NULL, 'GDPD_cytoplasmic_ScUgpQ2_like', 8338),
(8339, 'cd15983', NULL, '7tmB1_PTH3R', NULL, NULL, '7tmB1_PTH3R', 8339),
(8340, 'cd18496', NULL, 'BACK_LGALS3BP', NULL, NULL, 'BACK_LGALS3BP', 8340),
(8341, 'cd16889', NULL, 'chitinase-like', NULL, NULL, 'chitinase-like', 8341),
(8342, 'cd04202', NULL, 'CuRO_D2_2dMcoN_like', NULL, NULL, 'CuRO_D2_2dMcoN_like', 8342),
(8343, 'cd14788', NULL, 'GumN', NULL, NULL, 'GumN', 8343),
(8344, 'cd12365', NULL, 'RRM_RNPS1', NULL, NULL, 'RRM_RNPS1', 8344),
(8345, 'cd16145', NULL, 'ARS_like', NULL, NULL, 'ARS_like', 8345),
(8346, 'cd19078', NULL, 'AKR_AKR13C1_2', NULL, NULL, 'AKR_AKR13C1_2', 8346),
(8347, 'cd09459', NULL, 'LIM3_ENH', NULL, NULL, 'LIM3_ENH', 8347),
(8348, 'cd00314', NULL, 'plant_peroxidase_like', NULL, NULL, 'plant_peroxidase_like', 8348),
(8349, 'cd05515', NULL, 'Bromo_polybromo_V', NULL, NULL, 'Bromo_polybromo_V', 8349),
(8350, 'cd11728', NULL, 'ADDz_Dnmt3b', NULL, NULL, 'ADDz_Dnmt3b', 8350),
(8351, 'cd14765', NULL, 'Hb', NULL, NULL, 'Hb', 8351),
(8352, 'cd15810', NULL, 'SPRY_PRY_TRIM5_6_22_34', NULL, NULL, 'SPRY_PRY_TRIM5_6_22_34', 8352),
(8353, 'cd18609', NULL, 'GH32-like', NULL, NULL, 'GH32-like', 8353),
(8354, 'cd10151', NULL, 'TthCsoR-like_DUF156', NULL, NULL, 'TthCsoR-like_DUF156', 8354),
(8355, 'cd05811', NULL, 'CBM20_glucoamylase', NULL, NULL, 'CBM20_glucoamylase', 8355),
(8356, 'cd11961', NULL, 'SH3_Abp1_fungi_C2', NULL, NULL, 'SH3_Abp1_fungi_C2', 8356),
(8357, 'cd07650', NULL, 'F-BAR_Syp1p_like', NULL, NULL, 'F-BAR_Syp1p_like', 8357),
(8358, 'cd06144', NULL, 'REX4_like', NULL, NULL, 'REX4_like', 8358),
(8359, 'cd05007', NULL, 'SIS_Etherase', NULL, NULL, 'SIS_Etherase', 8359);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(8360, 'cd06283', NULL, 'PBP1_RegR_EndR_KdgR-like', NULL, NULL, 'PBP1_RegR_EndR_KdgR-like', 8360),
(8361, 'cd19375', NULL, 'UDG-F3-like_SMUG2', NULL, NULL, 'UDG-F3-like_SMUG2', 8361),
(8362, 'cd03513', NULL, 'CrtW_beta-carotene-ketolase', NULL, NULL, 'CrtW_beta-carotene-ketolase', 8362),
(8363, 'cd11334', NULL, 'AmyAc_TreS', NULL, NULL, 'AmyAc_TreS', 8363),
(8364, 'cd09136', NULL, 'PLDc_PSS_G_neg_2', NULL, NULL, 'PLDc_PSS_G_neg_2', 8364),
(8365, 'cd14115', NULL, 'STKc_Kalirin_C', NULL, NULL, 'STKc_Kalirin_C', 8365),
(8366, 'cd10228', NULL, 'HSPA4_like_NDB', NULL, NULL, 'HSPA4_like_NDB', 8366),
(8367, 'cd20491', NULL, 'cupin_KduI_C', NULL, NULL, 'cupin_KduI_C', 8367),
(8368, 'cd20274', NULL, 'Sarcolamban', NULL, NULL, 'Sarcolamban', 8368),
(8369, 'cd08745', NULL, 'RGS_RGS19', NULL, NULL, 'RGS_RGS19', 8369),
(8370, 'cd05013', NULL, 'SIS_RpiR', NULL, NULL, 'SIS_RpiR', 8370),
(8371, 'cd02204', NULL, 'PurL_repeat2', NULL, NULL, 'PurL_repeat2', 8371),
(8372, 'cd15719', NULL, 'FYVE_WDFY3', NULL, NULL, 'FYVE_WDFY3', 8372),
(8373, 'cd03255', NULL, 'ABC_MJ0796_LolCDE_FtsE', NULL, NULL, 'ABC_MJ0796_LolCDE_FtsE', 8373),
(8374, 'cd08248', NULL, 'RTN4I1', NULL, NULL, 'RTN4I1', 8374),
(8375, 'cd05116', NULL, 'PTKc_Syk', NULL, NULL, 'PTKc_Syk', 8375),
(8376, 'cd04741', NULL, 'DHOD_1A_like', NULL, NULL, 'DHOD_1A_like', 8376),
(8377, 'cd18784', NULL, 'ABC_6TM_ABCB9_like', NULL, NULL, 'ABC_6TM_ABCB9_like', 8377),
(8378, 'cd19347', NULL, 'Wnt_Wnt5a', NULL, NULL, 'Wnt_Wnt5a', 8378),
(8379, 'cd06588', NULL, 'PhnB_like', NULL, NULL, 'PhnB_like', 8379),
(8380, 'cd14715', NULL, 'bZIP_CEBPE', NULL, NULL, 'bZIP_CEBPE', 8380),
(8381, 'cd12785', NULL, 'RRM2_hnRNPL', NULL, NULL, 'RRM2_hnRNPL', 8381),
(8382, 'cd15906', NULL, '7tmA_GPR162', NULL, NULL, '7tmA_GPR162', 8382),
(8383, 'cd01091', NULL, 'CDC68-like', NULL, NULL, 'CDC68-like', 8383),
(8384, 'cd15387', NULL, '7tmA_OT_R', NULL, NULL, '7tmA_OT_R', 8384),
(8385, 'cd14171', NULL, 'STKc_MAPKAPK5', NULL, NULL, 'STKc_MAPKAPK5', 8385),
(8386, 'cd14687', NULL, 'bZIP_ATF2', NULL, NULL, 'bZIP_ATF2', 8386),
(8387, 'cd03250', NULL, 'ABCC_MRP_domain1', NULL, NULL, 'ABCC_MRP_domain1', 8387),
(8388, 'cd14672', NULL, 'UBA_ceTYDP2_like', NULL, NULL, 'UBA_ceTYDP2_like', 8388),
(8389, 'cd09144', NULL, 'PLDc_vPLD3_1', NULL, NULL, 'PLDc_vPLD3_1', 8389),
(8390, 'cd20230', NULL, 'PFM_EP37-like', NULL, NULL, 'PFM_EP37-like', 8390),
(8391, 'cd03470', NULL, 'Rieske_cytochrome_bc1', NULL, NULL, 'Rieske_cytochrome_bc1', 8391),
(8392, 'cd14290', NULL, 'UBA_PUB_plant', NULL, NULL, 'UBA_PUB_plant', 8392),
(8393, 'cd03328', NULL, 'MR_like_3', NULL, NULL, 'MR_like_3', 8393),
(8394, 'cd07496', NULL, 'Peptidases_S8_13', NULL, NULL, 'Peptidases_S8_13', 8394),
(8395, 'cd07876', NULL, 'STKc_JNK2', NULL, NULL, 'STKc_JNK2', 8395),
(8396, 'cd11412', NULL, 'bHLH_TS_TWIST1', NULL, NULL, 'bHLH_TS_TWIST1', 8396),
(8397, 'cd00818', NULL, 'IleRS_core', NULL, NULL, 'IleRS_core', 8397),
(8398, 'cd08674', NULL, 'Cdt1_m', NULL, NULL, 'Cdt1_m', 8398),
(8399, 'cd16897', NULL, 'LYZ_C', NULL, NULL, 'LYZ_C', 8399),
(8400, 'cd03479', NULL, 'Rieske_RO_Alpha_PhDO_like', NULL, NULL, 'Rieske_RO_Alpha_PhDO_like', 8400),
(8401, 'cd04678', NULL, 'Nudix_Hydrolase_19', NULL, NULL, 'Nudix_Hydrolase_19', 8401),
(8402, 'cd13421', NULL, 'TNFRSF_EDAR', NULL, NULL, 'TNFRSF_EDAR', 8402),
(8403, 'cd11781', NULL, 'SH3_Sorbs_1', NULL, NULL, 'SH3_Sorbs_1', 8403),
(8404, 'cd08828', NULL, 'SPFH_SLP-3', NULL, NULL, 'SPFH_SLP-3', 8404),
(8405, 'cd17584', NULL, 'REC_typeB_ARR-like', NULL, NULL, 'REC_typeB_ARR-like', 8405),
(8406, 'cd08651', NULL, 'FMT_core_like_4', NULL, NULL, 'FMT_core_like_4', 8406),
(8407, 'cd12374', NULL, 'RRM_UHM_SPF45_PUF60', NULL, NULL, 'RRM_UHM_SPF45_PUF60', 8407),
(8408, 'cd16435', NULL, 'BPL_LplA_LipB', NULL, NULL, 'BPL_LplA_LipB', 8408),
(8409, 'cd00859', NULL, 'HisRS_anticodon', NULL, NULL, 'HisRS_anticodon', 8409),
(8410, 'cd08069', NULL, 'MPN_RPN11_CSN5', NULL, NULL, 'MPN_RPN11_CSN5', 8410),
(8411, 'cd00625', NULL, 'ArsB_NhaD_permease', NULL, NULL, 'ArsB_NhaD_permease', 8411),
(8412, 'cd07293', NULL, 'PX_SNX3', NULL, NULL, 'PX_SNX3', 8412);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(8413, 'cd14443', NULL, 'AlgX_N_like_2', NULL, NULL, 'AlgX_N_like_2', 8413),
(8414, 'cd15452', NULL, '7tmC_mGluR4', NULL, NULL, '7tmC_mGluR4', 8414),
(8415, 'cd02765', NULL, 'MopB_4', NULL, NULL, 'MopB_4', 8415),
(8416, 'cd18785', NULL, 'SF2_C', NULL, NULL, 'SF2_C', 8416),
(8417, 'cd09108', NULL, 'PLDc_PMFPLD_like_1', NULL, NULL, 'PLDc_PMFPLD_like_1', 8417),
(8418, 'cd14175', NULL, 'STKc_RSK1_C', NULL, NULL, 'STKc_RSK1_C', 8418),
(8419, 'cd05863', NULL, 'Ig_VEGFR-3', NULL, NULL, 'Ig_VEGFR-3', 8419),
(8420, 'cd07811', NULL, 'FGGY_D-XK_3', NULL, NULL, 'FGGY_D-XK_3', 8420),
(8421, 'cd12291', NULL, 'RRM1_La', NULL, NULL, 'RRM1_La', 8421),
(8422, 'sd00045', NULL, 'ANK', NULL, NULL, 'ANK', 8422),
(8423, 'cd02423', NULL, 'Peptidase_C39G', NULL, NULL, 'Peptidase_C39G', 8423),
(8424, 'cd13609', NULL, 'PBP2_Opu_like_1', NULL, NULL, 'PBP2_Opu_like_1', 8424),
(8425, 'cd12244', NULL, 'RRM2_MSSP', NULL, NULL, 'RRM2_MSSP', 8425),
(8426, 'cd18004', NULL, 'DEXHc_RAD54', NULL, NULL, 'DEXHc_RAD54', 8426),
(8427, 'cd00072', NULL, 'GYF', NULL, NULL, 'GYF', 8427),
(8428, 'cd01247', NULL, 'PH_FAPP1_FAPP2', NULL, NULL, 'PH_FAPP1_FAPP2', 8428),
(8429, 'cd09581', NULL, 'SAM_Scm-like-4MBT1,2', NULL, NULL, 'SAM_Scm-like-4MBT1,2', 8429),
(8430, 'cd16419', NULL, 'HAD_SPS', NULL, NULL, 'HAD_SPS', 8430),
(8431, 'cd13976', NULL, 'PK_TRB', NULL, NULL, 'PK_TRB', 8431),
(8432, 'cd13286', NULL, 'PH_OPR5_ORP8', NULL, NULL, 'PH_OPR5_ORP8', 8432),
(8433, 'cd20489', NULL, 'cupin_HppE-like_C', NULL, NULL, 'cupin_HppE-like_C', 8433),
(8434, 'cd04157', NULL, 'Arl6', NULL, NULL, 'Arl6', 8434),
(8435, 'cd16597', NULL, 'RING-HC_TRIM25_C-IV', NULL, NULL, 'RING-HC_TRIM25_C-IV', 8435),
(8436, 'cd04383', NULL, 'RhoGAP_srGAP', NULL, NULL, 'RhoGAP_srGAP', 8436),
(8437, 'cd19914', NULL, 'DSRM_DRADA_rpt2', NULL, NULL, 'DSRM_DRADA_rpt2', 8437),
(8438, 'cd14112', NULL, 'STKc_Unc-89_rpt2', NULL, NULL, 'STKc_Unc-89_rpt2', 8438),
(8439, 'cd17533', NULL, 'REC_LytTR_AgrA-like', NULL, NULL, 'REC_LytTR_AgrA-like', 8439),
(8440, 'cd18000', NULL, 'DEXHc_ERCC6', NULL, NULL, 'DEXHc_ERCC6', 8440),
(8441, 'cd21640', NULL, 'ORF8-Ig_SARS-CoV-2-like', NULL, NULL, 'ORF8-Ig_SARS-CoV-2-like', 8441),
(8442, 'cd03584', NULL, 'NTR_complement_C4', NULL, NULL, 'NTR_complement_C4', 8442),
(8443, 'cd01545', NULL, 'PBP1_SalR', NULL, NULL, 'PBP1_SalR', 8443),
(8444, 'cd11444', NULL, 'bHLH_AtIBH1_like', NULL, NULL, 'bHLH_AtIBH1_like', 8444),
(8445, 'cd01680', NULL, 'EFG_like_IV', NULL, NULL, 'EFG_like_IV', 8445),
(8446, 'cd13392', NULL, 'PH_AKAP13', NULL, NULL, 'PH_AKAP13', 8446),
(8447, 'cd16243', NULL, 'EFh_DYTN', NULL, NULL, 'EFh_DYTN', 8447),
(8448, 'cd17657', NULL, 'CDC14_N', NULL, NULL, 'CDC14_N', 8448),
(8449, 'cd19991', NULL, 'PBP1_ABC_xylose_binding', NULL, NULL, 'PBP1_ABC_xylose_binding', 8449),
(8450, 'cd00403', NULL, 'Ribosomal_L1', NULL, NULL, 'Ribosomal_L1', 8450),
(8451, 'cd02127', NULL, 'PA_hPAP21_like', NULL, NULL, 'PA_hPAP21_like', 8451),
(8452, 'cd08917', NULL, 'TrHb2_O', NULL, NULL, 'TrHb2_O', 8452),
(8453, 'cd12897', NULL, 'SPRY_PRY_TRIM50_72', NULL, NULL, 'SPRY_PRY_TRIM50_72', 8453),
(8454, 'cd13427', NULL, 'YncM_like', NULL, NULL, 'YncM_like', 8454),
(8455, 'cd01388', NULL, 'SOX-TCF_HMG-box', NULL, NULL, 'SOX-TCF_HMG-box', 8455),
(8456, 'cd16539', NULL, 'RING-HC_RNF113A_B', NULL, NULL, 'RING-HC_RNF113A_B', 8456),
(8457, 'cd21483', NULL, 'HKU1_N1_CoV_Spike_S1_RBD', NULL, NULL, 'HKU1_N1_CoV_Spike_S1_RBD', 8457),
(8458, 'cd21659', NULL, 'betaCoV_Nsp14', NULL, NULL, 'betaCoV_Nsp14', 8458),
(8459, 'cd14474', NULL, 'SPX_YDR089W', NULL, NULL, 'SPX_YDR089W', 8459),
(8460, 'cd08861', NULL, 'OtcD1_ARO-CYC_like', NULL, NULL, 'OtcD1_ARO-CYC_like', 8460),
(8461, 'cd14320', NULL, 'UBA_SQSTM', NULL, NULL, 'UBA_SQSTM', 8461),
(8462, 'cd20006', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, 'PBP1_ABC_sugar_binding-like', 8462),
(8463, 'cd01679', NULL, 'RNR_I', NULL, NULL, 'RNR_I', 8463),
(8464, 'cd05259', NULL, 'PCBER_SDR_a', NULL, NULL, 'PCBER_SDR_a', 8464),
(8465, 'cd05637', NULL, 'SIS_PGI_PMI_2', NULL, NULL, 'SIS_PGI_PMI_2', 8465),
(8466, 'cd13675', NULL, 'PBP2_TRAP_SBP_like_5', NULL, NULL, 'PBP2_TRAP_SBP_like_5', 8466);
INSERT INTO "PUBLIC"."MODEL" VALUES
(8467, 'cd13637', NULL, 'PBP2_Ca3427_like', NULL, NULL, 'PBP2_Ca3427_like', 8467),
(8468, 'cd14712', NULL, 'bZIP_CEBPB', NULL, NULL, 'bZIP_CEBPB', 8468),
(8469, 'cd09697', NULL, 'Cas8a1_I-A', NULL, NULL, 'Cas8a1_I-A', 8469),
(8470, 'cd13190', NULL, 'FERM_C_FAK1', NULL, NULL, 'FERM_C_FAK1', 8470),
(8471, 'cd13872', NULL, 'CuRO_2_AAO_like_1', NULL, NULL, 'CuRO_2_AAO_like_1', 8471),
(8472, 'cd04321', NULL, 'ScAspRS_mt_like_N', NULL, NULL, 'ScAspRS_mt_like_N', 8472),
(8473, 'cd00853', NULL, 'NifX', NULL, NULL, 'NifX', 8473),
(8474, 'cd06235', NULL, 'M14_AGTPBP-like', NULL, NULL, 'M14_AGTPBP-like', 8474),
(8475, 'cd07621', NULL, 'BAR_SNX5_6', NULL, NULL, 'BAR_SNX5_6', 8475),
(8476, 'cd08823', NULL, 'FMT_core_like_5', NULL, NULL, 'FMT_core_like_5', 8476),
(8477, 'cd04955', NULL, 'GT4-like', NULL, NULL, 'GT4-like', 8477),
(8478, 'cd11262', NULL, 'Sema_4G', NULL, NULL, 'Sema_4G', 8478),
(8479, 'cd11369', NULL, 'RNase_PH_RRP43', NULL, NULL, 'RNase_PH_RRP43', 8479),
(8480, 'cd10427', NULL, 'FGGY_GK_1', NULL, NULL, 'FGGY_GK_1', 8480),
(8481, 'cd12764', NULL, 'RRM2_SRSF4', NULL, NULL, 'RRM2_SRSF4', 8481),
(8482, 'cd02151', NULL, 'nitroreductase', NULL, NULL, 'nitroreductase', 8482),
(8483, 'cd00525', NULL, 'AE_Prim_S_like', NULL, NULL, 'AE_Prim_S_like', 8483),
(8484, 'cd03567', NULL, 'VHS_GGA_metazoan', NULL, NULL, 'VHS_GGA_metazoan', 8484),
(8485, 'cd01173', NULL, 'pyridoxal_pyridoxamine_kinase', NULL, NULL, 'pyridoxal_pyridoxamine_kinase', 8485),
(8486, 'cd04506', NULL, 'SGNH_hydrolase_YpmR_like', NULL, NULL, 'SGNH_hydrolase_YpmR_like', 8486),
(8487, 'cd07665', NULL, 'BAR_SNX1', NULL, NULL, 'BAR_SNX1', 8487),
(8488, 'cd00455', NULL, 'nuc_hydro', NULL, NULL, 'nuc_hydro', 8488),
(8489, 'cd10969', NULL, 'CE4_Ecf1_like_5s', NULL, NULL, 'CE4_Ecf1_like_5s', 8489),
(8490, 'cd02411', NULL, 'archeal_30S_S3_KH', NULL, NULL, 'archeal_30S_S3_KH', 8490),
(8491, 'cd07086', NULL, 'ALDH_F7_AASADH-like', NULL, NULL, 'ALDH_F7_AASADH-like', 8491),
(8492, 'cd15501', NULL, 'PHD_Int12', NULL, NULL, 'PHD_Int12', 8492),
(8493, 'cd11489', NULL, 'SLC5sbd_SGLT5', NULL, NULL, 'SLC5sbd_SGLT5', 8493),
(8494, 'cd20331', NULL, 'JBP-like', NULL, NULL, 'JBP-like', 8494),
(8495, 'cd16890', NULL, 'lyz_i', NULL, NULL, 'lyz_i', 8495),
(8496, 'cd03202', NULL, 'GST_C_etherase_LigE', NULL, NULL, 'GST_C_etherase_LigE', 8496),
(8497, 'cd05560', NULL, 'Xcc1710_like', NULL, NULL, 'Xcc1710_like', 8497),
(8498, 'cd02420', NULL, 'Peptidase_C39D', NULL, NULL, 'Peptidase_C39D', 8498),
(8499, 'cd13575', NULL, 'PBP2_PnhD', NULL, NULL, 'PBP2_PnhD', 8499),
(8500, 'cd06355', NULL, 'PBP1_FmdD-like', NULL, NULL, 'PBP1_FmdD-like', 8500),
(8501, 'cd05707', NULL, 'S1_Rrp5_repeat_sc11', NULL, NULL, 'S1_Rrp5_repeat_sc11', 8501),
(8502, 'cd12722', NULL, 'RRM_Nup53', NULL, NULL, 'RRM_Nup53', 8502),
(8503, 'cd15528', NULL, 'PHD1_PHF10', NULL, NULL, 'PHD1_PHF10', 8503),
(8504, 'cd18205', NULL, 'BTB_POZ_ZBTB16_PLZF', NULL, NULL, 'BTB_POZ_ZBTB16_PLZF', 8504),
(8505, 'cd07350', NULL, 'NR_LBD_Dax1', NULL, NULL, 'NR_LBD_Dax1', 8505),
(8506, 'cd02757', NULL, 'MopB_Arsenate-R', NULL, NULL, 'MopB_Arsenate-R', 8506),
(8507, 'cd10564', NULL, 'NapF_like', NULL, NULL, 'NapF_like', 8507),
(8508, 'cd03401', NULL, 'SPFH_prohibitin', NULL, NULL, 'SPFH_prohibitin', 8508),
(8509, 'cd14645', NULL, 'DSP_DUSP8', NULL, NULL, 'DSP_DUSP8', 8509),
(8510, 'cd11617', NULL, 'Antifreeze_III', NULL, NULL, 'Antifreeze_III', 8510),
(8511, 'cd03539', NULL, 'Rieske_RO_Alpha_S5H', NULL, NULL, 'Rieske_RO_Alpha_S5H', 8511),
(8512, 'cd05524', NULL, 'Bromo_polybromo_I', NULL, NULL, 'Bromo_polybromo_I', 8512),
(8513, 'cd07803', NULL, 'FGGY_D-XK', NULL, NULL, 'FGGY_D-XK', 8513),
(8514, 'cd12677', NULL, 'RRM4_Nop4p', NULL, NULL, 'RRM4_Nop4p', 8514),
(8515, 'cd05973', NULL, 'MACS_like_2', NULL, NULL, 'MACS_like_2', 8515),
(8516, 'cd07689', NULL, 'Ig_VCAM-1', NULL, NULL, 'Ig_VCAM-1', 8516),
(8517, 'cd11405', NULL, 'bHLHzip_MLXIP_like', NULL, NULL, 'bHLHzip_MLXIP_like', 8517),
(8518, 'cd14691', NULL, 'bZIP_XBP1', NULL, NULL, 'bZIP_XBP1', 8518),
(8519, 'cd09523', NULL, 'SAM_TAL', NULL, NULL, 'SAM_TAL', 8519);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(8520, 'cd18940', NULL, 'bHLH_TS_OLIG2', NULL, NULL, 'bHLH_TS_OLIG2', 8520),
(8521, 'cd00045', NULL, 'DED', NULL, NULL, 'DED', 8521),
(8522, 'cd19432', NULL, 'lipocalin_2_12-like', NULL, NULL, 'lipocalin_2_12-like', 8522),
(8523, 'cd10411', NULL, 'SH2_SH2B2', NULL, NULL, 'SH2_SH2B2', 8523),
(8524, 'cd11858', NULL, 'SH3_Myosin-I_fungi', NULL, NULL, 'SH3_Myosin-I_fungi', 8524),
(8525, 'cd18104', NULL, 'SpoU-like_RNA-MTase', NULL, NULL, 'SpoU-like_RNA-MTase', 8525),
(8526, 'cd11389', NULL, 'bHLH-O_HERP_like', NULL, NULL, 'bHLH-O_HERP_like', 8526),
(8527, 'cd06080', NULL, 'MUM1_like', NULL, NULL, 'MUM1_like', 8527),
(8528, 'cd17135', NULL, 'RBD_CRAF', NULL, NULL, 'RBD_CRAF', 8528),
(8529, 'cd09551', NULL, 'SAM_EPH-B1', NULL, NULL, 'SAM_EPH-B1', 8529),
(8530, 'cd09744', NULL, 'Cas8a1_I-A', NULL, NULL, 'Cas8a1_I-A', 8530),
(8531, 'cd13372', NULL, 'PH_CAPRI', NULL, NULL, 'PH_CAPRI', 8531),
(8532, 'cd03445', NULL, 'Thioesterase_II_repeat2', NULL, NULL, 'Thioesterase_II_repeat2', 8532),
(8533, 'cd05646', NULL, 'M20_AcylaseI_like', NULL, NULL, 'M20_AcylaseI_like', 8533),
(8534, 'cd16537', NULL, 'RING-HC_RNF37', NULL, NULL, 'RING-HC_RNF37', 8534),
(8535, 'cd08162', NULL, 'MPP_PhoA_N', NULL, NULL, 'MPP_PhoA_N', 8535),
(8536, 'cd15236', NULL, '7tmA_OR1E-like', NULL, NULL, '7tmA_OR1E-like', 8536),
(8537, 'cd17130', NULL, 'Ubl2_FAF1', NULL, NULL, 'Ubl2_FAF1', 8537),
(8538, 'cd15920', NULL, '7tmA_GPR34-like', NULL, NULL, '7tmA_GPR34-like', 8538),
(8539, 'cd02240', NULL, 'cupin_OxDC', NULL, NULL, 'cupin_OxDC', 8539),
(8540, 'cd11771', NULL, 'SH3_Pex13p_fungal', NULL, NULL, 'SH3_Pex13p_fungal', 8540),
(8541, 'cd01534', NULL, '4RHOD_Repeat_3', NULL, NULL, '4RHOD_Repeat_3', 8541),
(8542, 'cd13124', NULL, 'MATE_SpoVB_like', NULL, NULL, 'MATE_SpoVB_like', 8542),
(8543, 'cd21530', NULL, 'CoV_RdRp', NULL, NULL, 'CoV_RdRp', 8543),
(8544, 'cd04404', NULL, 'RhoGAP-p50rhoGAP', NULL, NULL, 'RhoGAP-p50rhoGAP', 8544),
(8545, 'cd10307', NULL, 'GST_C_MetRS_N', NULL, NULL, 'GST_C_MetRS_N', 8545),
(8546, 'cd11942', NULL, 'SH3_JIP2', NULL, NULL, 'SH3_JIP2', 8546),
(8547, 'cd12412', NULL, 'RRM_DAZL_BOULE', NULL, NULL, 'RRM_DAZL_BOULE', 8547),
(8548, 'cd01812', NULL, 'Ubl_BAG1', NULL, NULL, 'Ubl_BAG1', 8548),
(8549, 'cd04096', NULL, 'eEF2_snRNP_like_C', NULL, NULL, 'eEF2_snRNP_like_C', 8549),
(8550, 'cd12446', NULL, 'RRM_RBM25', NULL, NULL, 'RRM_RBM25', 8550),
(8551, 'cd20237', NULL, 'PFM_LIN24-like', NULL, NULL, 'PFM_LIN24-like', 8551),
(8552, 'cd18661', NULL, 'CD2_tandem_CHD1-2_like', NULL, NULL, 'CD2_tandem_CHD1-2_like', 8552),
(8553, 'cd14353', NULL, 'UBA_FAF', NULL, NULL, 'UBA_FAF', 8553),
(8554, 'cd12793', NULL, 'RasGAP_plexin_B1', NULL, NULL, 'RasGAP_plexin_B1', 8554),
(8555, 'cd07584', NULL, 'nitrilase_6', NULL, NULL, 'nitrilase_6', 8555),
(8556, 'cd09180', NULL, 'PLDc_N_DEXD_b', NULL, NULL, 'PLDc_N_DEXD_b', 8556),
(8557, 'cd09834', NULL, 'CBS_pair_bac', NULL, NULL, 'CBS_pair_bac', 8557),
(8558, 'cd06971', NULL, 'PgpA', NULL, NULL, 'PgpA', 8558),
(8559, 'cd02950', NULL, 'TxlA', NULL, NULL, 'TxlA', 8559),
(8560, 'cd15251', NULL, '7tmB2_BAI_Adhesion_VII', NULL, NULL, '7tmB2_BAI_Adhesion_VII', 8560),
(8561, 'cd03733', NULL, 'SOCS_WSB_SWIP', NULL, NULL, 'SOCS_WSB_SWIP', 8561),
(8562, 'cd00247', NULL, 'Endostatin-like', NULL, NULL, 'Endostatin-like', 8562),
(8563, 'cd07890', NULL, 'CYTH-like_AC_IV-like', NULL, NULL, 'CYTH-like_AC_IV-like', 8563),
(8564, 'cd17231', NULL, 'TGS_DRG2', NULL, NULL, 'TGS_DRG2', 8564),
(8565, 'cd15011', NULL, '7tmA_GPR149', NULL, NULL, '7tmA_GPR149', 8565),
(8566, 'cd16511', NULL, 'vRING-HC_IRF2BP1_like', NULL, NULL, 'vRING-HC_IRF2BP1_like', 8566),
(8567, 'cd15573', NULL, 'PHD_JADE', NULL, NULL, 'PHD_JADE', 8567),
(8568, 'cd03825', NULL, 'GT4_WcaC-like', NULL, NULL, 'GT4_WcaC-like', 8568),
(8569, 'cd11744', NULL, 'MIT_CorA-like', NULL, NULL, 'MIT_CorA-like', 8569),
(8570, 'cd03335', NULL, 'TCP1_alpha', NULL, NULL, 'TCP1_alpha', 8570),
(8571, 'cd06461', NULL, 'M2_ACE', NULL, NULL, 'M2_ACE', 8571),
(8572, 'cd11652', NULL, 'SSH-N', NULL, NULL, 'SSH-N', 8572),
(8573, 'cd00176', NULL, 'SPEC', NULL, NULL, 'SPEC', 8573);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(8574, 'cd03136', NULL, 'GATase1_AraC_ArgR_like', NULL, NULL, 'GATase1_AraC_ArgR_like', 8574),
(8575, 'cd06811', NULL, 'PLPDE_III_yhfX_like', NULL, NULL, 'PLPDE_III_yhfX_like', 8575),
(8576, 'cd15508', NULL, 'PHD3_KMT2A_like', NULL, NULL, 'PHD3_KMT2A_like', 8576),
(8577, 'cd17054', NULL, 'Ubl_AtBAG1_like', NULL, NULL, 'Ubl_AtBAG1_like', 8577),
(8578, 'cd18462', NULL, 'BACK_KLHL23', NULL, NULL, 'BACK_KLHL23', 8578),
(8579, 'cd09274', NULL, 'RNase_HI_RT_Ty3', NULL, NULL, 'RNase_HI_RT_Ty3', 8579),
(8580, 'cd04519', NULL, 'RasGAP', NULL, NULL, 'RasGAP', 8580),
(8581, 'cd18075', NULL, 'DEXHc_RLR-3', NULL, NULL, 'DEXHc_RLR-3', 8581),
(8582, 'cd11575', NULL, 'GH99_GH71_like_3', NULL, NULL, 'GH99_GH71_like_3', 8582),
(8583, 'cd08705', NULL, 'RGS_R7-like', NULL, NULL, 'RGS_R7-like', 8583),
(8584, 'cd13249', NULL, 'PH_rhotekin2', NULL, NULL, 'PH_rhotekin2', 8584),
(8585, 'cd00920', NULL, 'Cupredoxin', NULL, NULL, 'Cupredoxin', 8585),
(8586, 'cd16730', NULL, 'RING-HC_MKRN1_3', NULL, NULL, 'RING-HC_MKRN1_3', 8586),
(8587, 'cd14528', NULL, 'PFA-DSP_Siw14', NULL, NULL, 'PFA-DSP_Siw14', 8587),
(8588, 'cd15376', NULL, '7tmA_P2Y11', NULL, NULL, '7tmA_P2Y11', 8588),
(8589, 'cd18382', NULL, 'BTB_POZ_Kv6_KCNG', NULL, NULL, 'BTB_POZ_Kv6_KCNG', 8589),
(8590, 'cd12496', NULL, 'RRM3_RBM46', NULL, NULL, 'RRM3_RBM46', 8590),
(8591, 'cd01273', NULL, 'PTB_CED-6', NULL, NULL, 'PTB_CED-6', 8591),
(8592, 'cd07644', NULL, 'I-BAR_IMD_BAIAP2L2', NULL, NULL, 'I-BAR_IMD_BAIAP2L2', 8592),
(8593, 'cd17085', NULL, 'RAWUL_PCGF6', NULL, NULL, 'RAWUL_PCGF6', 8593),
(8594, 'cd18665', NULL, 'CD1_tandem_CHD1_yeast_like', NULL, NULL, 'CD1_tandem_CHD1_yeast_like', 8594),
(8595, 'cd10926', NULL, 'CE4_u2', NULL, NULL, 'CE4_u2', 8595),
(8596, 'cd11912', NULL, 'SH3_Bzz1_1', NULL, NULL, 'SH3_Bzz1_1', 8596),
(8597, 'cd18290', NULL, 'BTB_POZ_BTBD14B_NAC1', NULL, NULL, 'BTB_POZ_BTBD14B_NAC1', 8597),
(8598, 'cd17580', NULL, 'REC_2_DhkD-like', NULL, NULL, 'REC_2_DhkD-like', 8598),
(8599, 'cd17115', NULL, 'RA_RHG20', NULL, NULL, 'RA_RHG20', 8599),
(8600, 'cd03414', NULL, 'CbiX_SirB_C', NULL, NULL, 'CbiX_SirB_C', 8600),
(8601, 'cd06966', NULL, 'NR_DBD_CAR', NULL, NULL, 'NR_DBD_CAR', 8601),
(8602, 'cd07054', NULL, 'BMC_PduT_repeat2', NULL, NULL, 'BMC_PduT_repeat2', 8602),
(8603, 'cd09743', NULL, 'Csx16_III-U', NULL, NULL, 'Csx16_III-U', 8603),
(8604, 'cd06271', NULL, 'PBP1_AglR_RafR-like', NULL, NULL, 'PBP1_AglR_RafR-like', 8604),
(8605, 'cd07581', NULL, 'nitrilase_3', NULL, NULL, 'nitrilase_3', 8605),
(8606, 'cd15954', NULL, '7tmA_OR52N-like', NULL, NULL, '7tmA_OR52N-like', 8606),
(8607, 'cd16793', NULL, 'SP-RING_ScSiz_like', NULL, NULL, 'SP-RING_ScSiz_like', 8607),
(8608, 'cd13348', NULL, 'PH-GRAM_MTMR12', NULL, NULL, 'PH-GRAM_MTMR12', 8608),
(8609, 'cd15547', NULL, 'PHD_SHPRH', NULL, NULL, 'PHD_SHPRH', 8609),
(8610, 'cd10448', NULL, 'GIY-YIG_unchar_3', NULL, NULL, 'GIY-YIG_unchar_3', 8610),
(8611, 'cd12152', NULL, 'F1-ATPase_delta', NULL, NULL, 'F1-ATPase_delta', 8611),
(8612, 'cd08646', NULL, 'FMT_core_Met-tRNA-FMT_N', NULL, NULL, 'FMT_core_Met-tRNA-FMT_N', 8612),
(8613, 'cd14910', NULL, 'MYSc_Myh1_mammals', NULL, NULL, 'MYSc_Myh1_mammals', 8613),
(8614, 'cd07959', NULL, 'Anticodon_Ia_Leu_AEc', NULL, NULL, 'Anticodon_Ia_Leu_AEc', 8614),
(8615, 'cd10305', NULL, 'GST_C_AIMP3', NULL, NULL, 'GST_C_AIMP3', 8615),
(8616, 'cd11786', NULL, 'SH3_SH3RF_1', NULL, NULL, 'SH3_SH3RF_1', 8616),
(8617, 'cd15936', NULL, '7tmA_OR4D-like', NULL, NULL, '7tmA_OR4D-like', 8617),
(8618, 'cd13883', NULL, 'CuRO_2_Diphenol_Ox', NULL, NULL, 'CuRO_2_Diphenol_Ox', 8618),
(8619, 'cd17514', NULL, 'RMtype1_S_Eco2747I_MmaC7ORF19P-TRD-CR_like', NULL, NULL, 'RMtype1_S_Eco2747I_MmaC7ORF19P-TRD-CR_like', 8619),
(8620, 'cd18374', NULL, 'BTB2_POZ_KCTD19', NULL, NULL, 'BTB2_POZ_KCTD19', 8620),
(8621, 'cd18942', NULL, 'bHLH_TS_OLIG1', NULL, NULL, 'bHLH_TS_OLIG1', 8621),
(8622, 'cd09678', NULL, 'Csb1_I-U', NULL, NULL, 'Csb1_I-U', 8622),
(8623, 'cd08933', NULL, 'RDH_SDR_c', NULL, NULL, 'RDH_SDR_c', 8623),
(8624, 'cd11842', NULL, 'SH3_Ysc84p_like', NULL, NULL, 'SH3_Ysc84p_like', 8624);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(8625, 'cd01829', NULL, 'SGNH_hydrolase_peri2', NULL, NULL, 'SGNH_hydrolase_peri2', 8625),
(8626, 'cd06436', NULL, 'GlcNAc-1-P_transferase', NULL, NULL, 'GlcNAc-1-P_transferase', 8626),
(8627, 'cd05781', NULL, 'DNA_polB_B3_exo', NULL, NULL, 'DNA_polB_B3_exo', 8627),
(8628, 'cd15541', NULL, 'PHD_TIF1_like', NULL, NULL, 'PHD_TIF1_like', 8628),
(8629, 'cd08749', NULL, 'RGS_GRK7', NULL, NULL, 'RGS_GRK7', 8629),
(8630, 'cd00261', NULL, 'AAI_SS', NULL, NULL, 'AAI_SS', 8630),
(8631, 'cd10929', NULL, 'CE4_u5', NULL, NULL, 'CE4_u5', 8631),
(8632, 'cd06272', NULL, 'PBP1_hexuronate_repressor-like', NULL, NULL, 'PBP1_hexuronate_repressor-like', 8632),
(8633, 'cd18465', NULL, 'BACK_KLHL26', NULL, NULL, 'BACK_KLHL26', 8633),
(8634, 'cd14614', NULL, 'R-PTPc-O', NULL, NULL, 'R-PTPc-O', 8634),
(8635, 'cd06343', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, 'PBP1_ABC_ligand_binding-like', 8635),
(8636, 'cd09617', NULL, 'Peptidase_C12_UCH37_BAP1', NULL, NULL, 'Peptidase_C12_UCH37_BAP1', 8636),
(8637, 'cd09939', NULL, 'SH2_STAP_family', NULL, NULL, 'SH2_STAP_family', 8637),
(8638, 'cd00890', NULL, 'Prefoldin', NULL, NULL, 'Prefoldin', 8638),
(8639, 'cd13242', NULL, 'PH_puratrophin-1', NULL, NULL, 'PH_puratrophin-1', 8639),
(8640, 'cd12492', NULL, 'RRM2_RBM46', NULL, NULL, 'RRM2_RBM46', 8640),
(8641, 'cd19805', NULL, 'Bbox1_TIF1', NULL, NULL, 'Bbox1_TIF1', 8641),
(8642, 'cd00728', NULL, 'malate_synt_G', NULL, NULL, 'malate_synt_G', 8642),
(8643, 'cd07861', NULL, 'STKc_CDK1_euk', NULL, NULL, 'STKc_CDK1_euk', 8643),
(8644, 'cd17478', NULL, 'MFS_FsR', NULL, NULL, 'MFS_FsR', 8644),
(8645, 'cd11477', NULL, 'SLC5sbd_u1', NULL, NULL, 'SLC5sbd_u1', 8645),
(8646, 'cd03169', NULL, 'GATase1_PfpI_1', NULL, NULL, 'GATase1_PfpI_1', 8646),
(8647, 'cd03249', NULL, 'ABC_MTABC3_MDL1_MDL2', NULL, NULL, 'ABC_MTABC3_MDL1_MDL2', 8647),
(8648, 'cd05243', NULL, 'SDR_a5', NULL, NULL, 'SDR_a5', 8648),
(8649, 'cd14304', NULL, 'UBA2_KPC2', NULL, NULL, 'UBA2_KPC2', 8649),
(8650, 'cd01102', NULL, 'Link_Domain', NULL, NULL, 'Link_Domain', 8650),
(8651, 'cd05395', NULL, 'RasGAP_RASA4', NULL, NULL, 'RasGAP_RASA4', 8651),
(8652, 'cd19760', NULL, 'Bbox2_TRIM4-like', NULL, NULL, 'Bbox2_TRIM4-like', 8652),
(8653, 'cd14264', NULL, 'DAGK_IM', NULL, NULL, 'DAGK_IM', 8653),
(8654, 'cd06214', NULL, 'PA_degradation_oxidoreductase_like', NULL, NULL, 'PA_degradation_oxidoreductase_like', 8654),
(8655, 'cd07223', NULL, 'Pat_PNPLA5-mammals', NULL, NULL, 'Pat_PNPLA5-mammals', 8655),
(8656, 'cd14618', NULL, 'R-PTPc-V', NULL, NULL, 'R-PTPc-V', 8656),
(8657, 'cd04623', NULL, 'CBS_pair_bac_euk', NULL, NULL, 'CBS_pair_bac_euk', 8657),
(8658, 'cd03159', NULL, 'TM4SF9_like_LEL', NULL, NULL, 'TM4SF9_like_LEL', 8658),
(8659, 'cd18395', NULL, 'BTB_POZ_KCTD21', NULL, NULL, 'BTB_POZ_KCTD21', 8659),
(8660, 'cd19556', NULL, 'serpinA9_centerin', NULL, NULL, 'serpinA9_centerin', 8660),
(8661, 'cd04475', NULL, 'RPA1_DBD_B', NULL, NULL, 'RPA1_DBD_B', 8661),
(8662, 'cd06892', NULL, 'PX_SNX5_like', NULL, NULL, 'PX_SNX5_like', 8662),
(8663, 'cd09517', NULL, 'SAM_USH1G_HARP', NULL, NULL, 'SAM_USH1G_HARP', 8663),
(8664, 'cd18525', NULL, 'BACK_BTBD6', NULL, NULL, 'BACK_BTBD6', 8664),
(8665, 'cd09593', NULL, 'UDG-like', NULL, NULL, 'UDG-like', 8665),
(8666, 'cd07703', NULL, 'Ig2_Nectin-2_like', NULL, NULL, 'Ig2_Nectin-2_like', 8666),
(8667, 'cd15860', NULL, 'SNARE_USE1', NULL, NULL, 'SNARE_USE1', 8667),
(8668, 'cd15921', NULL, '7tmA_CysLTR', NULL, NULL, '7tmA_CysLTR', 8668),
(8669, 'cd05064', NULL, 'PTKc_EphR_A10', NULL, NULL, 'PTKc_EphR_A10', 8669),
(8670, 'cd15518', NULL, 'PHD_Ecm5p_Lid2p_like', NULL, NULL, 'PHD_Ecm5p_Lid2p_like', 8670),
(8671, 'cd10538', NULL, 'SET_SETDB-like', NULL, NULL, 'SET_SETDB-like', 8671),
(8672, 'cd01863', NULL, 'Rab18', NULL, NULL, 'Rab18', 8672),
(8673, 'cd03770', NULL, 'SR_TndX_transposase', NULL, NULL, 'SR_TndX_transposase', 8673),
(8674, 'cd19131', NULL, 'AKR_AKR5C2', NULL, NULL, 'AKR_AKR5C2', 8674),
(8675, 'cd12904', NULL, 'SPRY_BSPRY', NULL, NULL, 'SPRY_BSPRY', 8675),
(8676, 'cd12799', NULL, 'pesticin_lyz-like', NULL, NULL, 'pesticin_lyz-like', 8676);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(8677, 'cd06503', NULL, 'ATP-synt_Fo_b', NULL, NULL, 'ATP-synt_Fo_b', 8677),
(8678, 'cd11671', NULL, 'TAZ1_RBM', NULL, NULL, 'TAZ1_RBM', 8678),
(8679, 'cd05858', NULL, 'Ig3_FGFR-2', NULL, NULL, 'Ig3_FGFR-2', 8679),
(8680, 'cd02909', NULL, 'cupin_pirin_N', NULL, NULL, 'cupin_pirin_N', 8680),
(8681, 'cd08797', NULL, 'Death_NFkB1_p105', NULL, NULL, 'Death_NFkB1_p105', 8681),
(8682, 'cd13718', NULL, 'PBP2_iGluR_NMDA_Nr2', NULL, NULL, 'PBP2_iGluR_NMDA_Nr2', 8682),
(8683, 'cd00250', NULL, 'CAS_like', NULL, NULL, 'CAS_like', 8683),
(8684, 'cd14177', NULL, 'STKc_RSK4_C', NULL, NULL, 'STKc_RSK4_C', 8684),
(8685, 'cd11778', NULL, 'SH3_Bzz1_2', NULL, NULL, 'SH3_Bzz1_2', 8685),
(8686, 'cd14386', NULL, 'UBA2_UBP5', NULL, NULL, 'UBA2_UBP5', 8686),
(8687, 'cd05585', NULL, 'STKc_YPK1_like', NULL, NULL, 'STKc_YPK1_like', 8687),
(8688, 'cd16687', NULL, 'RING-H2_Vps8', NULL, NULL, 'RING-H2_Vps8', 8688),
(8689, 'cd09763', NULL, 'DHRS1-like_SDR_c', NULL, NULL, 'DHRS1-like_SDR_c', 8689),
(8690, 'cd13695', NULL, 'PBP2_Mlr3796_like', NULL, NULL, 'PBP2_Mlr3796_like', 8690),
(8691, 'cd15068', NULL, '7tmA_Adenosine_R_A2A', NULL, NULL, '7tmA_Adenosine_R_A2A', 8691),
(8692, 'cd16514', NULL, 'RING2-HC_LONFs', NULL, NULL, 'RING2-HC_LONFs', 8692),
(8693, 'cd19185', NULL, 'SET_KMT5C', NULL, NULL, 'SET_KMT5C', 8693),
(8694, 'cd09454', NULL, 'LIM1_ZASP_Cypher', NULL, NULL, 'LIM1_ZASP_Cypher', 8694),
(8695, 'cd19533', NULL, 'starter-C_NRPS', NULL, NULL, 'starter-C_NRPS', 8695),
(8696, 'cd11399', NULL, 'bHLHzip_scHMS1_like', NULL, NULL, 'bHLHzip_scHMS1_like', 8696),
(8697, 'cd01666', NULL, 'TGS_DRG', NULL, NULL, 'TGS_DRG', 8697),
(8698, 'cd03399', NULL, 'SPFH_flotillin', NULL, NULL, 'SPFH_flotillin', 8698),
(8699, 'cd17040', NULL, 'Ubl_MoaD_like', NULL, NULL, 'Ubl_MoaD_like', 8699),
(8700, 'cd17991', NULL, 'DEXHc_TRCF', NULL, NULL, 'DEXHc_TRCF', 8700),
(8701, 'cd01158', NULL, 'SCAD_SBCAD', NULL, NULL, 'SCAD_SBCAD', 8701),
(8702, 'cd18984', NULL, 'CBD_MOF_like', NULL, NULL, 'CBD_MOF_like', 8702),
(8703, 'cd12332', NULL, 'RRM1_p54nrb_like', NULL, NULL, 'RRM1_p54nrb_like', 8703),
(8704, 'cd17938', NULL, 'DEADc_DDX1', NULL, NULL, 'DEADc_DDX1', 8704),
(8705, 'cd03405', NULL, 'SPFH_HflC', NULL, NULL, 'SPFH_HflC', 8705),
(8706, 'cd04162', NULL, 'Arl9_Arfrp2_like', NULL, NULL, 'Arl9_Arfrp2_like', 8706),
(8707, 'cd15094', NULL, '7tmA_AstC_insect', NULL, NULL, '7tmA_AstC_insect', 8707),
(8708, 'cd11333', NULL, 'AmyAc_SI_OligoGlu_DGase', NULL, NULL, 'AmyAc_SI_OligoGlu_DGase', 8708),
(8709, 'cd02688', NULL, 'E_set', NULL, NULL, 'E_set', 8709),
(8710, 'cd05295', NULL, 'MDH_like', NULL, NULL, 'MDH_like', 8710),
(8711, 'cd16162', NULL, 'OCRE_RBM5_like', NULL, NULL, 'OCRE_RBM5_like', 8711),
(8712, 'cd07216', NULL, 'Pat17_PNPLA8_PNPLA9_like3', NULL, NULL, 'Pat17_PNPLA8_PNPLA9_like3', 8712),
(8713, 'cd06478', NULL, 'ACD_HspB4-5-6', NULL, NULL, 'ACD_HspB4-5-6', 8713),
(8714, 'cd14620', NULL, 'R-PTPc-E-1', NULL, NULL, 'R-PTPc-E-1', 8714),
(8715, 'cd01239', NULL, 'PH_PKD', NULL, NULL, 'PH_PKD', 8715),
(8716, 'cd15922', NULL, '7tmA_P2Y-like', NULL, NULL, '7tmA_P2Y-like', 8716),
(8717, 'cd12062', NULL, 'SH3_Caskin1', NULL, NULL, 'SH3_Caskin1', 8717),
(8718, 'cd21660', NULL, 'alphaCoV_Nsp14', NULL, NULL, 'alphaCoV_Nsp14', 8718),
(8719, 'cd16722', NULL, 'RING-HC_MEX3C', NULL, NULL, 'RING-HC_MEX3C', 8719),
(8720, 'cd07285', NULL, 'PX_SNX9', NULL, NULL, 'PX_SNX9', 8720),
(8721, 'cd17900', NULL, 'ArfGap_ASAP3', NULL, NULL, 'ArfGap_ASAP3', 8721),
(8722, 'cd18262', NULL, 'BTB1_POZ_KLHL33', NULL, NULL, 'BTB1_POZ_KLHL33', 8722),
(8723, 'cd05282', NULL, 'ETR_like', NULL, NULL, 'ETR_like', 8723),
(8724, 'cd15113', NULL, '7tmA_MAS1L', NULL, NULL, '7tmA_MAS1L', 8724),
(8725, 'cd18796', NULL, 'SF2_C_LHR', NULL, NULL, 'SF2_C_LHR', 8725),
(8726, 'cd04272', NULL, 'ZnMc_salivary_gland_MPs', NULL, NULL, 'ZnMc_salivary_gland_MPs', 8726),
(8727, 'cd06293', NULL, 'PBP1_LacI-like', NULL, NULL, 'PBP1_LacI-like', 8727),
(8728, 'cd08400', NULL, 'C2_Ras_p21A1', NULL, NULL, 'C2_Ras_p21A1', 8728),
(8729, 'cd15194', NULL, '7tmA_GPR15', NULL, NULL, '7tmA_GPR15', 8729),
(8730, 'cd17385', NULL, 'MFS_SLC18B1', NULL, NULL, 'MFS_SLC18B1', 8730);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(8731, 'cd13263', NULL, 'PH_RhoGap25-like', NULL, NULL, 'PH_RhoGap25-like', 8731),
(8732, 'cd14017', NULL, 'STKc_TTBK', NULL, NULL, 'STKc_TTBK', 8732),
(8733, 'cd13767', NULL, 'TGF_beta_BMP9_like', NULL, NULL, 'TGF_beta_BMP9_like', 8733),
(8734, 'cd08413', NULL, 'PBP2_CysB_like', NULL, NULL, 'PBP2_CysB_like', 8734),
(8735, 'cd11878', NULL, 'SH3_Bem1p_1', NULL, NULL, 'SH3_Bem1p_1', 8735),
(8736, 'cd16199', NULL, 'EFh_PEF_CAPN2', NULL, NULL, 'EFh_PEF_CAPN2', 8736),
(8737, 'cd05056', NULL, 'PTKc_FAK', NULL, NULL, 'PTKc_FAK', 8737),
(8738, 'cd12078', NULL, 'SH3_Tks4_3', NULL, NULL, 'SH3_Tks4_3', 8738),
(8739, 'cd15974', NULL, '7tmA_SSTR5', NULL, NULL, '7tmA_SSTR5', 8739),
(8740, 'cd16325', NULL, 'LolA', NULL, NULL, 'LolA', 8740),
(8741, 'cd04136', NULL, 'Rap_like', NULL, NULL, 'Rap_like', 8741),
(8742, 'cd19357', NULL, 'TenA_E_At3g16990-like', NULL, NULL, 'TenA_E_At3g16990-like', 8742),
(8743, 'cd06552', NULL, 'ASCH_yqfb_like', NULL, NULL, 'ASCH_yqfb_like', 8743),
(8744, 'cd04013', NULL, 'C2_SynGAP_like', NULL, NULL, 'C2_SynGAP_like', 8744),
(8745, 'cd04077', NULL, 'Peptidases_S8_PCSK9_ProteinaseK_like', NULL, NULL, 'Peptidases_S8_PCSK9_ProteinaseK_like', 8745),
(8746, 'cd15825', NULL, 'SPRY_PRY_TRIM34', NULL, NULL, 'SPRY_PRY_TRIM34', 8746),
(8747, 'cd03499', NULL, 'SQR_TypeC_SdhC', NULL, NULL, 'SQR_TypeC_SdhC', 8747),
(8748, 'cd13425', NULL, 'Peptidase_G1_like', NULL, NULL, 'Peptidase_G1_like', 8748),
(8749, 'cd16305', NULL, 'Sfh-1-like_MBL-B2', NULL, NULL, 'Sfh-1-like_MBL-B2', 8749),
(8750, 'cd17553', NULL, 'REC_Spo0F-like', NULL, NULL, 'REC_Spo0F-like', 8750),
(8751, 'cd14282', NULL, 'UBA_TDRD3', NULL, NULL, 'UBA_TDRD3', 8751),
(8752, 'cd19009', NULL, 'LGIC_ECD_GlyR_alpha', NULL, NULL, 'LGIC_ECD_GlyR_alpha', 8752),
(8753, 'cd11437', NULL, 'bHLH-PAS_ARNT_like', NULL, NULL, 'bHLH-PAS_ARNT_like', 8753),
(8754, 'cd00491', NULL, '4Oxalocrotonate_Tautomerase', NULL, NULL, '4Oxalocrotonate_Tautomerase', 8754),
(8755, 'cd07014', NULL, 'S49_SppA', NULL, NULL, 'S49_SppA', 8755),
(8756, 'cd10300', NULL, 'GST_C_CLIC1', NULL, NULL, 'GST_C_CLIC1', 8756),
(8757, 'cd05294', NULL, 'LDH-like_MDH_nadp', NULL, NULL, 'LDH-like_MDH_nadp', 8757),
(8758, 'cd03384', NULL, 'PAP2_wunen', NULL, NULL, 'PAP2_wunen', 8758),
(8759, 'cd08065', NULL, 'MPN_eIF3h', NULL, NULL, 'MPN_eIF3h', 8759),
(8760, 'cd10956', NULL, 'CE4_BH1302_like', NULL, NULL, 'CE4_BH1302_like', 8760),
(8761, 'cd10521', NULL, 'SET_SMYD5', NULL, NULL, 'SET_SMYD5', 8761),
(8762, 'cd02054', NULL, 'serpinA8_AGT', NULL, NULL, 'serpinA8_AGT', 8762),
(8763, 'cd03758', NULL, 'proteasome_beta_type_2', NULL, NULL, 'proteasome_beta_type_2', 8763),
(8764, 'cd05886', NULL, 'Ig1_Nectin-1_like', NULL, NULL, 'Ig1_Nectin-1_like', 8764),
(8765, 'cd14794', NULL, 'RNLA_N_1', NULL, NULL, 'RNLA_N_1', 8765),
(8766, 'cd17330', NULL, 'MFS_SLC46_TetA_like', NULL, NULL, 'MFS_SLC46_TetA_like', 8766),
(8767, 'cd12881', NULL, 'SPRY_HERC1', NULL, NULL, 'SPRY_HERC1', 8767),
(8768, 'cd10934', NULL, 'CE4_cadherin_MopE_like_N', NULL, NULL, 'CE4_cadherin_MopE_like_N', 8768),
(8769, 'cd07999', NULL, 'GH7_CBH_EG', NULL, NULL, 'GH7_CBH_EG', 8769),
(8770, 'cd19036', NULL, 'LGIC_ECD_GABAAR_A3', NULL, NULL, 'LGIC_ECD_GABAAR_A3', 8770),
(8771, 'cd02228', NULL, 'cupin_EutQ', NULL, NULL, 'cupin_EutQ', 8771),
(8772, 'cd16087', NULL, 'IgV_CD86', NULL, NULL, 'IgV_CD86', 8772),
(8773, 'cd07169', NULL, 'NR_DBD_GCNF_like', NULL, NULL, 'NR_DBD_GCNF_like', 8773),
(8774, 'cd03891', NULL, 'M20_DapE_proteobac', NULL, NULL, 'M20_DapE_proteobac', 8774),
(8775, 'cd18600', NULL, 'ABC_6TM_CFTR_D2', NULL, NULL, 'ABC_6TM_CFTR_D2', 8775),
(8776, 'cd00006', NULL, 'PTS_IIA_man', NULL, NULL, 'PTS_IIA_man', 8776),
(8777, 'cd04905', NULL, 'ACT_CM-PDT', NULL, NULL, 'ACT_CM-PDT', 8777),
(8778, 'cd12952', NULL, 'MMP_ACEL2062', NULL, NULL, 'MMP_ACEL2062', 8778),
(8779, 'cd17634', NULL, 'ACS-like', NULL, NULL, 'ACS-like', 8779),
(8780, 'cd06105', NULL, 'ScCit1-2_like', NULL, NULL, 'ScCit1-2_like', 8780),
(8781, 'cd13674', NULL, 'PBP2_TRAP_SBP_like_1', NULL, NULL, 'PBP2_TRAP_SBP_like_1', 8781),
(8782, 'cd14973', NULL, '7tmA_Mrgpr', NULL, NULL, '7tmA_Mrgpr', 8782);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(8783, 'cd16387', NULL, 'ParB_N_Srx', NULL, NULL, 'ParB_N_Srx', 8783),
(8784, 'cd03156', NULL, 'uroplakin_I_like_LEL', NULL, NULL, 'uroplakin_I_like_LEL', 8784),
(8785, 'cd07698', NULL, 'IgC_MHC_I_alpha3', NULL, NULL, 'IgC_MHC_I_alpha3', 8785),
(8786, 'cd01629', NULL, 'HAD_EP', NULL, NULL, 'HAD_EP', 8786),
(8787, 'cd12834', NULL, 'ZntB_u1', NULL, NULL, 'ZntB_u1', 8787),
(8788, 'cd18675', NULL, 'PIN_SpAst1-like', NULL, NULL, 'PIN_SpAst1-like', 8788),
(8789, 'cd06397', NULL, 'PB1_UP1', NULL, NULL, 'PB1_UP1', 8789),
(8790, 'cd18620', NULL, 'GH43_XylA-like', NULL, NULL, 'GH43_XylA-like', 8790),
(8791, 'cd02436', NULL, 'Nodulin-21', NULL, NULL, 'Nodulin-21', 8791),
(8792, 'cd13177', NULL, 'RanBD2_RanBP2-like', NULL, NULL, 'RanBD2_RanBP2-like', 8792),
(8793, 'cd01976', NULL, 'Nitrogenase_MoFe_alpha', NULL, NULL, 'Nitrogenase_MoFe_alpha', 8793),
(8794, 'cd14291', NULL, 'UBA1_NUB1_like', NULL, NULL, 'UBA1_NUB1_like', 8794),
(8795, 'cd00633', NULL, 'Secretoglobin', NULL, NULL, 'Secretoglobin', 8795),
(8796, 'cd18563', NULL, 'ABC_6TM_exporter_like', NULL, NULL, 'ABC_6TM_exporter_like', 8796),
(8797, 'cd12187', NULL, 'LDH_like_1', NULL, NULL, 'LDH_like_1', 8797),
(8798, 'cd12003', NULL, 'SH3_EFS', NULL, NULL, 'SH3_EFS', 8798),
(8799, 'cd14674', NULL, 'PH_PLEKHM3_1', NULL, NULL, 'PH_PLEKHM3_1', 8799),
(8800, 'cd09730', NULL, 'Cas8a1_I-A', NULL, NULL, 'Cas8a1_I-A', 8800),
(8801, 'cd08809', NULL, 'CARD_CARD9', NULL, NULL, 'CARD_CARD9', 8801),
(8802, 'cd13996', NULL, 'STKc_EIF2AK', NULL, NULL, 'STKc_EIF2AK', 8802),
(8803, 'cd08556', NULL, 'GDPD', NULL, NULL, 'GDPD', 8803),
(8804, 'cd16423', NULL, 'HAD_BPGM-like', NULL, NULL, 'HAD_BPGM-like', 8804),
(8805, 'cd01464', NULL, 'vWA_subfamily', NULL, NULL, 'vWA_subfamily', 8805),
(8806, 'cd16610', NULL, 'RING-HC_TRIM68_C-IV', NULL, NULL, 'RING-HC_TRIM68_C-IV', 8806),
(8807, 'cd00299', NULL, 'GST_C_family', NULL, NULL, 'GST_C_family', 8807),
(8808, 'cd02647', NULL, 'nuc_hydro_TvIAG', NULL, NULL, 'nuc_hydro_TvIAG', 8808),
(8809, 'cd10422', NULL, 'RNase_Ire1', NULL, NULL, 'RNase_Ire1', 8809),
(8810, 'cd14584', NULL, 'PTP-MTMR8', NULL, NULL, 'PTP-MTMR8', 8810),
(8811, 'cd17164', NULL, 'RAWUL_PCGF2', NULL, NULL, 'RAWUL_PCGF2', 8811),
(8812, 'cd13593', NULL, 'PBP2_HisGL3', NULL, NULL, 'PBP2_HisGL3', 8812),
(8813, 'cd17199', NULL, 'FERM_F1_FRMD4A', NULL, NULL, 'FERM_F1_FRMD4A', 8813),
(8814, 'cd02028', NULL, 'UMPK_like', NULL, NULL, 'UMPK_like', 8814),
(8815, 'cd18161', NULL, 'REC_hyHK_blue-like', NULL, NULL, 'REC_hyHK_blue-like', 8815),
(8816, 'cd00554', NULL, 'MECDP_synthase', NULL, NULL, 'MECDP_synthase', 8816),
(8817, 'cd15932', NULL, '7tmB2_GPR116-like_Adhesion_VI', NULL, NULL, '7tmB2_GPR116-like_Adhesion_VI', 8817),
(8818, 'cd09123', NULL, 'PLDc_Tdp1_2', NULL, NULL, 'PLDc_Tdp1_2', 8818),
(8819, 'cd00048', NULL, 'DSRM_SF', NULL, NULL, 'DSRM_SF', 8819),
(8820, 'cd01401', NULL, 'PncB_like', NULL, NULL, 'PncB_like', 8820),
(8821, 'cd00788', NULL, 'KU70', NULL, NULL, 'KU70', 8821),
(8822, 'cd15855', NULL, 'SNARE_SNAP25C_23C', NULL, NULL, 'SNARE_SNAP25C_23C', 8822),
(8823, 'cd18029', NULL, 'DEXHc_XPB', NULL, NULL, 'DEXHc_XPB', 8823),
(8824, 'cd14960', NULL, 'NHL_TRIM2_like', NULL, NULL, 'NHL_TRIM2_like', 8824),
(8825, 'cd04681', NULL, 'Nudix_Hydrolase_22', NULL, NULL, 'Nudix_Hydrolase_22', 8825),
(8826, 'cd10794', NULL, 'GH57N_PfGalA_like', NULL, NULL, 'GH57N_PfGalA_like', 8826),
(8827, 'cd14941', NULL, 'TRAPPC_bet3-like', NULL, NULL, 'TRAPPC_bet3-like', 8827),
(8828, 'cd15132', NULL, '7tmA_motilin_R', NULL, NULL, '7tmA_motilin_R', 8828),
(8829, 'cd15699', NULL, 'ePHD_TCF20', NULL, NULL, 'ePHD_TCF20', 8829),
(8830, 'cd04319', NULL, 'PhAsnRS_like_N', NULL, NULL, 'PhAsnRS_like_N', 8830),
(8831, 'cd09975', NULL, 'LOTUS_2_TDRD5', NULL, NULL, 'LOTUS_2_TDRD5', 8831),
(8832, 'cd17615', NULL, 'REC_OmpR_MtPhoP-like', NULL, NULL, 'REC_OmpR_MtPhoP-like', 8832),
(8833, 'cd02086', NULL, 'P-type_ATPase_Na_ENA', NULL, NULL, 'P-type_ATPase_Na_ENA', 8833),
(8834, 'cd12517', NULL, 'RRM_RBM27', NULL, NULL, 'RRM_RBM27', 8834),
(8835, 'cd14099', NULL, 'STKc_PLK', NULL, NULL, 'STKc_PLK', 8835);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(8836, 'cd02001', NULL, 'TPP_ComE_PpyrDC', NULL, NULL, 'TPP_ComE_PpyrDC', 8836),
(8837, 'cd17719', NULL, 'BRCT_Rev1', NULL, NULL, 'BRCT_Rev1', 8837),
(8838, 'cd01014', NULL, 'nicotinamidase_related', NULL, NULL, 'nicotinamidase_related', 8838),
(8839, 'cd01494', NULL, 'AAT_I', NULL, NULL, 'AAT_I', 8839),
(8840, 'cd02955', NULL, 'SSP411', NULL, NULL, 'SSP411', 8840),
(8841, 'cd16007', NULL, '7tmB2_Latrophilin-1', NULL, NULL, '7tmB2_Latrophilin-1', 8841),
(8842, 'cd01262', NULL, 'PH_PDK1', NULL, NULL, 'PH_PDK1', 8842),
(8843, 'cd14114', NULL, 'STKc_Twitchin_like', NULL, NULL, 'STKc_Twitchin_like', 8843),
(8844, 'cd05584', NULL, 'STKc_p70S6K', NULL, NULL, 'STKc_p70S6K', 8844),
(8845, 'cd06207', NULL, 'CyPoR_like', NULL, NULL, 'CyPoR_like', 8845),
(8846, 'cd08153', NULL, 'srpA_like', NULL, NULL, 'srpA_like', 8846),
(8847, 'cd15578', NULL, 'PHD1_MTF2', NULL, NULL, 'PHD1_MTF2', 8847),
(8848, 'cd13735', NULL, 'SPRY_HECT_like', NULL, NULL, 'SPRY_HECT_like', 8848),
(8849, 'cd01124', NULL, 'KaiC', NULL, NULL, 'KaiC', 8849),
(8850, 'cd04011', NULL, 'C2B_Ferlin', NULL, NULL, 'C2B_Ferlin', 8850),
(8851, 'cd17001', NULL, 'CID_RPRD2', NULL, NULL, 'CID_RPRD2', 8851),
(8852, 'cd02800', NULL, 'tRNA_bind_EcMetRS_like', NULL, NULL, 'tRNA_bind_EcMetRS_like', 8852),
(8853, 'cd06930', NULL, 'NR_LBD_F2', NULL, NULL, 'NR_LBD_F2', 8853),
(8854, 'cd08777', NULL, 'Death_RIP1', NULL, NULL, 'Death_RIP1', 8854),
(8855, 'cd14871', NULL, 'uS7_Chloroplast', NULL, NULL, 'uS7_Chloroplast', 8855),
(8856, 'cd01052', NULL, 'DPSL', NULL, NULL, 'DPSL', 8856),
(8857, 'cd11569', NULL, 'FAT-like_BCAR1_C', NULL, NULL, 'FAT-like_BCAR1_C', 8857),
(8858, 'cd07245', NULL, 'VOC_like', NULL, NULL, 'VOC_like', 8858),
(8859, 'cd00244', NULL, 'AlgLyase', NULL, NULL, 'AlgLyase', 8859),
(8860, 'cd08810', NULL, 'CARD_BCL10', NULL, NULL, 'CARD_BCL10', 8860),
(8861, 'cd06061', NULL, 'PurM-like1', NULL, NULL, 'PurM-like1', 8861),
(8862, 'cd01343', NULL, 'PL1_Passenger_AT', NULL, NULL, 'PL1_Passenger_AT', 8862),
(8863, 'cd02339', NULL, 'ZZ_Mind_bomb', NULL, NULL, 'ZZ_Mind_bomb', 8863),
(8864, 'cd06291', NULL, 'PBP1_Qymf-like', NULL, NULL, 'PBP1_Qymf-like', 8864),
(8865, 'cd00481', NULL, 'Ribosomal_L19e', NULL, NULL, 'Ribosomal_L19e', 8865),
(8866, 'cd04121', NULL, 'Rab40', NULL, NULL, 'Rab40', 8866),
(8867, 'cd01569', NULL, 'PBEF_like', NULL, NULL, 'PBEF_like', 8867),
(8868, 'cd05530', NULL, 'POLBc_B1', NULL, NULL, 'POLBc_B1', 8868),
(8869, 'cd05494', NULL, 'Bromodomain_1', NULL, NULL, 'Bromodomain_1', 8869),
(8870, 'cd05732', NULL, 'Ig_NCAM-1_like', NULL, NULL, 'Ig_NCAM-1_like', 8870),
(8871, 'cd03367', NULL, 'Ribosomal_S23', NULL, NULL, 'Ribosomal_S23', 8871),
(8872, 'cd10298', NULL, 'GST_C_CLIC2', NULL, NULL, 'GST_C_CLIC2', 8872),
(8873, 'cd15278', NULL, '7tmC_RAIG2_GPRC5B', NULL, NULL, '7tmC_RAIG2_GPRC5B', 8873),
(8874, 'cd13831', NULL, 'HU', NULL, NULL, 'HU', 8874),
(8875, 'cd15350', NULL, '7tmA_MC2R_ACTH_R', NULL, NULL, '7tmA_MC2R_ACTH_R', 8875),
(8876, 'cd13423', NULL, 'TNFRSF6_teleost', NULL, NULL, 'TNFRSF6_teleost', 8876),
(8877, 'cd00504', NULL, 'GXGXG', NULL, NULL, 'GXGXG', 8877),
(8878, 'cd13903', NULL, 'CuRO_3_Tv-LCC_like', NULL, NULL, 'CuRO_3_Tv-LCC_like', 8878),
(8879, 'cd15437', NULL, '7tmB2_ETL', NULL, NULL, '7tmB2_ETL', 8879),
(8880, 'cd09361', NULL, 'LIM1_Enigma_like', NULL, NULL, 'LIM1_Enigma_like', 8880),
(8881, 'cd15263', NULL, '7tmB1_DH_R', NULL, NULL, '7tmB1_DH_R', 8881),
(8882, 'cd21401', NULL, 'ZBD_cv_Nsp13-like', NULL, NULL, 'ZBD_cv_Nsp13-like', 8882),
(8883, 'cd17051', NULL, 'Ubl2_ANKUB1', NULL, NULL, 'Ubl2_ANKUB1', 8883),
(8884, 'cd18138', NULL, 'HLD_clamp_pol_III_delta', NULL, NULL, 'HLD_clamp_pol_III_delta', 8884),
(8885, 'cd03598', NULL, 'CLECT_EMBP_like', NULL, NULL, 'CLECT_EMBP_like', 8885),
(8886, 'cd01085', NULL, 'APP', NULL, NULL, 'APP', 8886),
(8887, 'cd10342', NULL, 'SH2_SAP1', NULL, NULL, 'SH2_SAP1', 8887),
(8888, 'cd17143', NULL, 'DCX2_DCLK1', NULL, NULL, 'DCX2_DCLK1', 8888),
(8889, 'cd16206', NULL, 'EFh_PRIP', NULL, NULL, 'EFh_PRIP', 8889),
(8890, 'cd20259', NULL, 'pgc', NULL, NULL, 'pgc', 8890),
(8891, 'cd19143', NULL, 'AKR_AKR6C1_2', NULL, NULL, 'AKR_AKR6C1_2', 8891);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(8892, 'cd04630', NULL, 'CBS_pair_bac', NULL, NULL, 'CBS_pair_bac', 8892),
(8893, 'cd13958', NULL, 'PT_UbiA_chlorophyll', NULL, NULL, 'PT_UbiA_chlorophyll', 8893),
(8894, 'cd01287', NULL, 'FabA', NULL, NULL, 'FabA', 8894),
(8895, 'cd10350', NULL, 'SH2_SH2D4A', NULL, NULL, 'SH2_SH2D4A', 8895),
(8896, 'cd14064', NULL, 'PKc_TNNI3K', NULL, NULL, 'PKc_TNNI3K', 8896),
(8897, 'cd02764', NULL, 'MopB_PHLH', NULL, NULL, 'MopB_PHLH', 8897),
(8898, 'cd06490', NULL, 'p23_NCB5OR', NULL, NULL, 'p23_NCB5OR', 8898),
(8899, 'cd14208', NULL, 'PTK_Jak3_rpt1', NULL, NULL, 'PTK_Jak3_rpt1', 8899),
(8900, 'cd20485', NULL, 'USP25_USP28_C-like', NULL, NULL, 'USP25_USP28_C-like', 8900),
(8901, 'cd11717', NULL, 'THUMP_THUMPD1_like', NULL, NULL, 'THUMP_THUMPD1_like', 8901),
(8902, 'cd05401', NULL, 'NT_GlnE_GlnD_like', NULL, NULL, 'NT_GlnE_GlnD_like', 8902),
(8903, 'cd21529', NULL, 'CoV_M', NULL, NULL, 'CoV_M', 8903),
(8904, 'cd07092', NULL, 'ALDH_ABALDH-YdcW', NULL, NULL, 'ALDH_ABALDH-YdcW', 8904),
(8905, 'cd07827', NULL, 'RHD-n', NULL, NULL, 'RHD-n', 8905),
(8906, 'cd16113', NULL, 'DCX2_DCDC2_like', NULL, NULL, 'DCX2_DCDC2_like', 8906),
(8907, 'cd14248', NULL, 'ESP', NULL, NULL, 'ESP', 8907),
(8908, 'cd10162', NULL, 'ClassIIa_HDAC4_Gln-rich-N', NULL, NULL, 'ClassIIa_HDAC4_Gln-rich-N', 8908),
(8909, 'cd14023', NULL, 'PK_TRB1', NULL, NULL, 'PK_TRB1', 8909),
(8910, 'cd03498', NULL, 'SQR_TypeB_2_TM', NULL, NULL, 'SQR_TypeB_2_TM', 8910),
(8911, 'cd15610', NULL, 'PHD3_KDM5A_like', NULL, NULL, 'PHD3_KDM5A_like', 8911),
(8912, 'cd13212', NULL, 'PH-GRAM_MTMR10-like', NULL, NULL, 'PH-GRAM_MTMR10-like', 8912),
(8913, 'cd21166', NULL, 'NTD_av_Nsp11-like', NULL, NULL, 'NTD_av_Nsp11-like', 8913),
(8914, 'cd02762', NULL, 'MopB_1', NULL, NULL, 'MopB_1', 8914),
(8915, 'cd06986', NULL, 'cupin_MmsR-like_N', NULL, NULL, 'cupin_MmsR-like_N', 8915),
(8916, 'cd17321', NULL, 'MFS_MMR_MDR_like', NULL, NULL, 'MFS_MMR_MDR_like', 8916),
(8917, 'cd02773', NULL, 'MopB_Res-Cmplx1_Nad11', NULL, NULL, 'MopB_Res-Cmplx1_Nad11', 8917),
(8918, 'cd02523', NULL, 'PC_cytidylyltransferase', NULL, NULL, 'PC_cytidylyltransferase', 8918),
(8919, 'cd03818', NULL, 'GT4_ExpC-like', NULL, NULL, 'GT4_ExpC-like', 8919),
(8920, 'cd19362', NULL, 'TenA_C_SsTenA-1-like', NULL, NULL, 'TenA_C_SsTenA-1-like', 8920),
(8921, 'cd08548', NULL, 'Type_I_cohesin_like', NULL, NULL, 'Type_I_cohesin_like', 8921),
(8922, 'cd12954', NULL, 'MMP_TTHA0227_like_1', NULL, NULL, 'MMP_TTHA0227_like_1', 8922),
(8923, 'cd04018', NULL, 'C2C_Ferlin', NULL, NULL, 'C2C_Ferlin', 8923),
(8924, 'cd03036', NULL, 'ArsC_like', NULL, NULL, 'ArsC_like', 8924),
(8925, 'cd04104', NULL, 'p47_IIGP_like', NULL, NULL, 'p47_IIGP_like', 8925),
(8926, 'cd05971', NULL, 'MACS_like_3', NULL, NULL, 'MACS_like_3', 8926),
(8927, 'cd15750', NULL, 'FYVE_CARP', NULL, NULL, 'FYVE_CARP', 8927),
(8928, 'cd09985', NULL, 'LOTUS_1_TDRD5', NULL, NULL, 'LOTUS_1_TDRD5', 8928),
(8929, 'cd03082', NULL, 'TRX_Fd_NuoE_W_FDH_beta', NULL, NULL, 'TRX_Fd_NuoE_W_FDH_beta', 8929),
(8930, 'cd17324', NULL, 'MFS_NepI_like', NULL, NULL, 'MFS_NepI_like', 8930),
(8931, 'cd16717', NULL, 'vRING-HC_IRF2BPL', NULL, NULL, 'vRING-HC_IRF2BPL', 8931),
(8932, 'cd12482', NULL, 'RRM1_hnRNPR', NULL, NULL, 'RRM1_hnRNPR', 8932),
(8933, 'cd18283', NULL, 'BTB1_POZ_BTBD7', NULL, NULL, 'BTB1_POZ_BTBD7', 8933),
(8934, 'cd18332', NULL, 'BTB_POZ_ZBTB28_BCL6B', NULL, NULL, 'BTB_POZ_ZBTB28_BCL6B', 8934),
(8935, 'cd16075', NULL, 'ORC6_CTD', NULL, NULL, 'ORC6_CTD', 8935),
(8936, 'cd12711', NULL, 'RRM_TNRC6A', NULL, NULL, 'RRM_TNRC6A', 8936),
(8937, 'cd19816', NULL, 'Bbox1_CYLD', NULL, NULL, 'Bbox1_CYLD', 8937),
(8938, 'cd01163', NULL, 'DszC', NULL, NULL, 'DszC', 8938),
(8939, 'cd01515', NULL, 'Arch_FBPase_1', NULL, NULL, 'Arch_FBPase_1', 8939),
(8940, 'cd07649', NULL, 'F-BAR_GAS7', NULL, NULL, 'F-BAR_GAS7', 8940),
(8941, 'cd09211', NULL, 'Lumazine_synthase_archaeal', NULL, NULL, 'Lumazine_synthase_archaeal', 8941),
(8942, 'cd08070', NULL, 'MPN_like', NULL, NULL, 'MPN_like', 8942),
(8943, 'cd08519', NULL, 'PBP2_NikA_DppA_OppA_like_20', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_20', 8943);
INSERT INTO "PUBLIC"."MODEL" VALUES
(8944, 'cd13278', NULL, 'PH_Bud4', NULL, NULL, 'PH_Bud4', 8944),
(8945, 'cd14493', NULL, 'lipocalin_MxiM', NULL, NULL, 'lipocalin_MxiM', 8945),
(8946, 'cd11321', NULL, 'AmyAc_bac_euk_BE', NULL, NULL, 'AmyAc_bac_euk_BE', 8946),
(8947, 'cd02540', NULL, 'GT2_GlmU_N_bac', NULL, NULL, 'GT2_GlmU_N_bac', 8947),
(8948, 'cd09892', NULL, 'NGN_SP_RfaH', NULL, NULL, 'NGN_SP_RfaH', 8948),
(8949, 'cd00092', NULL, 'HTH_CRP', NULL, NULL, 'HTH_CRP', 8949),
(8950, 'cd07911', NULL, 'RNRR2_Rv0233_like', NULL, NULL, 'RNRR2_Rv0233_like', 8950),
(8951, 'cd03311', NULL, 'CIMS_C_terminal_like', NULL, NULL, 'CIMS_C_terminal_like', 8951),
(8952, 'cd19543', NULL, 'DCL_NRPS', NULL, NULL, 'DCL_NRPS', 8952),
(8953, 'cd18310', NULL, 'BTB_POZ_NPR_plant', NULL, NULL, 'BTB_POZ_NPR_plant', 8953),
(8954, 'cd18542', NULL, 'ABC_6TM_YknU_like', NULL, NULL, 'ABC_6TM_YknU_like', 8954),
(8955, 'cd08014', NULL, 'M20_Acy1-like', NULL, NULL, 'M20_Acy1-like', 8955),
(8956, 'cd14671', NULL, 'PAAR_like', NULL, NULL, 'PAAR_like', 8956),
(8957, 'cd07123', NULL, 'ALDH_F4-17_P5CDH', NULL, NULL, 'ALDH_F4-17_P5CDH', 8957),
(8958, 'cd07579', NULL, 'nitrilase_1_R2', NULL, NULL, 'nitrilase_1_R2', 8958),
(8959, 'cd10535', NULL, 'SET_EHMT1', NULL, NULL, 'SET_EHMT1', 8959),
(8960, 'cd18770', NULL, 'PIN_Mut7-C-like', NULL, NULL, 'PIN_Mut7-C-like', 8960),
(8961, 'cd03801', NULL, 'GT4_PimA-like', NULL, NULL, 'GT4_PimA-like', 8961),
(8962, 'cd13230', NULL, 'PH1_SSRP1-like', NULL, NULL, 'PH1_SSRP1-like', 8962),
(8963, 'cd00439', NULL, 'Transaldolase', NULL, NULL, 'Transaldolase', 8963),
(8964, 'cd16583', NULL, 'RING-HC_TRIM40-C-V', NULL, NULL, 'RING-HC_TRIM40-C-V', 8964),
(8965, 'cd06259', NULL, 'YdcF-like', NULL, NULL, 'YdcF-like', 8965),
(8966, 'cd08534', NULL, 'SAM_PNT-GABP-alpha', NULL, NULL, 'SAM_PNT-GABP-alpha', 8966),
(8967, 'cd19121', NULL, 'AKR_AKR3D1', NULL, NULL, 'AKR_AKR3D1', 8967),
(8968, 'cd08219', NULL, 'STKc_Nek3', NULL, NULL, 'STKc_Nek3', 8968),
(8969, 'cd18580', NULL, 'ABC_6TM_ABCC_D2', NULL, NULL, 'ABC_6TM_ABCC_D2', 8969),
(8970, 'cd07542', NULL, 'P-type_ATPase_cation', NULL, NULL, 'P-type_ATPase_cation', 8970),
(8971, 'cd01028', NULL, 'TOPRIM_TopoIA', NULL, NULL, 'TOPRIM_TopoIA', 8971),
(8972, 'cd04638', NULL, 'CBS_pair_arch2_repeat1', NULL, NULL, 'CBS_pair_arch2_repeat1', 8972),
(8973, 'cd06943', NULL, 'NR_LBD_RXR_like', NULL, NULL, 'NR_LBD_RXR_like', 8973),
(8974, 'cd07769', NULL, 'FGGY_GK', NULL, NULL, 'FGGY_GK', 8974),
(8975, 'cd12146', NULL, 'STING_C', NULL, NULL, 'STING_C', 8975),
(8976, 'cd13291', NULL, 'PH_ORP10_ORP11', NULL, NULL, 'PH_ORP10_ORP11', 8976),
(8977, 'cd12290', NULL, 'RRM1_LARP7', NULL, NULL, 'RRM1_LARP7', 8977),
(8978, 'cd04687', NULL, 'Nudix_Hydrolase_28', NULL, NULL, 'Nudix_Hydrolase_28', 8978),
(8979, 'cd05919', NULL, 'BCL_like', NULL, NULL, 'BCL_like', 8979),
(8980, 'cd14253', NULL, 'Dockerin', NULL, NULL, 'Dockerin', 8980),
(8981, 'cd02197', NULL, 'HypE', NULL, NULL, 'HypE', 8981),
(8982, 'cd17278', NULL, 'RMtype1_S_LdeBORF1052P-TRD2-CR2', NULL, NULL, 'RMtype1_S_LdeBORF1052P-TRD2-CR2', 8982),
(8983, 'cd02068', NULL, 'radical_SAM_B12_BD', NULL, NULL, 'radical_SAM_B12_BD', 8983),
(8984, 'cd11967', NULL, 'SH3_SASH1', NULL, NULL, 'SH3_SASH1', 8984),
(8985, 'cd14811', NULL, 'bZIP_u2', NULL, NULL, 'bZIP_u2', 8985),
(8986, 'cd15141', NULL, '7tmA_PGI2', NULL, NULL, '7tmA_PGI2', 8986),
(8987, 'cd08863', NULL, 'SRPBCC_DUF1857', NULL, NULL, 'SRPBCC_DUF1857', 8987),
(8988, 'cd11989', NULL, 'SH3_Intersectin1_2', NULL, NULL, 'SH3_Intersectin1_2', 8988),
(8989, 'cd18895', NULL, 'TET1', NULL, NULL, 'TET1', 8989),
(8990, 'cd12806', NULL, 'Esterase_713_like', NULL, NULL, 'Esterase_713_like', 8990),
(8991, 'cd16967', NULL, 'Alpha_kinase_eEF2K', NULL, NULL, 'Alpha_kinase_eEF2K', 8991),
(8992, 'cd14484', NULL, 'SPX_GDE1_like', NULL, NULL, 'SPX_GDE1_like', 8992),
(8993, 'cd11647', NULL, 'DHP5_DphB', NULL, NULL, 'DHP5_DphB', 8993),
(8994, 'cd17906', NULL, 'CheX', NULL, NULL, 'CheX', 8994),
(8995, 'cd18506', NULL, 'BACK2_LZTR1', NULL, NULL, 'BACK2_LZTR1', 8995),
(8996, 'cd11794', NULL, 'SH3_DNMBP_N1', NULL, NULL, 'SH3_DNMBP_N1', 8996);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(8997, 'cd05119', NULL, 'RIO', NULL, NULL, 'RIO', 8997),
(8998, 'cd11330', NULL, 'AmyAc_OligoGlu', NULL, NULL, 'AmyAc_OligoGlu', 8998),
(8999, 'cd16015', NULL, 'LTA_synthase', NULL, NULL, 'LTA_synthase', 8999),
(9000, 'cd03561', NULL, 'VHS', NULL, NULL, 'VHS', 9000),
(9001, 'cd02509', NULL, 'GDP-M1P_Guanylyltransferase', NULL, NULL, 'GDP-M1P_Guanylyltransferase', 9001),
(9002, 'cd09301', NULL, 'HDAC', NULL, NULL, 'HDAC', 9002),
(9003, 'sd00046', NULL, 'FHA_bHelix', NULL, NULL, 'FHA_bHelix', 9003),
(9004, 'cd16357', NULL, 'GLOD4_C', NULL, NULL, 'GLOD4_C', 9004),
(9005, 'cd19967', NULL, 'PBP1_TmRBP-like', NULL, NULL, 'PBP1_TmRBP-like', 9005),
(9006, 'cd20760', NULL, 'capping_2-OMTase_Mimiviridae', NULL, NULL, 'capping_2-OMTase_Mimiviridae', 9006),
(9007, 'cd10460', NULL, 'PUB_UBXD1', NULL, NULL, 'PUB_UBXD1', 9007),
(9008, 'cd18050', NULL, 'DEADc_DDX17', NULL, NULL, 'DEADc_DDX17', 9008),
(9009, 'cd19146', NULL, 'AKR_AKR9A1-2', NULL, NULL, 'AKR_AKR9A1-2', 9009),
(9010, 'cd14860', NULL, '4HBD_NAD', NULL, NULL, '4HBD_NAD', 9010),
(9011, 'cd10912', NULL, 'PIN_YacP-like', NULL, NULL, 'PIN_YacP-like', 9011),
(9012, 'cd13712', NULL, 'PBP2_FliY', NULL, NULL, 'PBP2_FliY', 9012),
(9013, 'cd06948', NULL, 'NR_LBD_COUP-TF', NULL, NULL, 'NR_LBD_COUP-TF', 9013),
(9014, 'cd15720', NULL, 'FYVE_Hrs', NULL, NULL, 'FYVE_Hrs', 9014),
(9015, 'cd17013', NULL, 'ANTH_N_HIP1', NULL, NULL, 'ANTH_N_HIP1', 9015),
(9016, 'cd18718', NULL, 'PIN_PRORP', NULL, NULL, 'PIN_PRORP', 9016),
(9017, 'cd15206', NULL, '7tmA_CCK_R', NULL, NULL, '7tmA_CCK_R', 9017),
(9018, 'cd00242', NULL, 'Ecotin', NULL, NULL, 'Ecotin', 9018),
(9019, 'cd06123', NULL, 'cupin_HAO', NULL, NULL, 'cupin_HAO', 9019),
(9020, 'cd19983', NULL, 'PBP1_ABC_HAAT-like', NULL, NULL, 'PBP1_ABC_HAAT-like', 9020),
(9021, 'cd21343', NULL, 'ZBD_UPF1_nv_SF1_Hel-like', NULL, NULL, 'ZBD_UPF1_nv_SF1_Hel-like', 9021),
(9022, 'cd07598', NULL, 'BAR_FAM92', NULL, NULL, 'BAR_FAM92', 9022),
(9023, 'cd16566', NULL, 'RING-HC_RSPRY1', NULL, NULL, 'RING-HC_RSPRY1', 9023),
(9024, 'cd19081', NULL, 'AKR_AKR9C1', NULL, NULL, 'AKR_AKR9C1', 9024),
(9025, 'cd05510', NULL, 'Bromo_SPT7_like', NULL, NULL, 'Bromo_SPT7_like', 9025),
(9026, 'cd06544', NULL, 'GH18_narbonin', NULL, NULL, 'GH18_narbonin', 9026),
(9027, 'cd02956', NULL, 'ybbN', NULL, NULL, 'ybbN', 9027),
(9028, 'cd17958', NULL, 'DEADc_DDX43_DDX53', NULL, NULL, 'DEADc_DDX43_DDX53', 9028),
(9029, 'cd11830', NULL, 'SH3_VAV_2', NULL, NULL, 'SH3_VAV_2', 9029),
(9030, 'cd07567', NULL, 'biotinidase_like', NULL, NULL, 'biotinidase_like', 9030),
(9031, 'cd10321', NULL, 'RNase_Ire1_like', NULL, NULL, 'RNase_Ire1_like', 9031),
(9032, 'cd13125', NULL, 'MATE_like_10', NULL, NULL, 'MATE_like_10', 9032),
(9033, 'cd15962', NULL, '7tmA_GPR6', NULL, NULL, '7tmA_GPR6', 9033),
(9034, 'cd17734', NULL, 'BRCT_Bard1_rpt1', NULL, NULL, 'BRCT_Bard1_rpt1', 9034),
(9035, 'cd19414', NULL, 'lipocalin_1_3_4_13-like', NULL, NULL, 'lipocalin_1_3_4_13-like', 9035),
(9036, 'cd13531', NULL, 'PBP2_MxaJ', NULL, NULL, 'PBP2_MxaJ', 9036),
(9037, 'cd05923', NULL, 'CBAL', NULL, NULL, 'CBAL', 9037),
(9038, 'cd04684', NULL, 'Nudix_Hydrolase_25', NULL, NULL, 'Nudix_Hydrolase_25', 9038),
(9039, 'cd01385', NULL, 'MYSc_Myo9', NULL, NULL, 'MYSc_Myo9', 9039),
(9040, 'cd03450', NULL, 'NodN', NULL, NULL, 'NodN', 9040),
(9041, 'cd00870', NULL, 'PI3Ka_III', NULL, NULL, 'PI3Ka_III', 9041),
(9042, 'cd16348', NULL, 'VOC_YdcJ_like', NULL, NULL, 'VOC_YdcJ_like', 9042),
(9043, 'cd08379', NULL, 'C2D_MCTP_PRT_plant', NULL, NULL, 'C2D_MCTP_PRT_plant', 9043),
(9044, 'cd02221', NULL, 'cupin_TM1287-like', NULL, NULL, 'cupin_TM1287-like', 9044),
(9045, 'cd17575', NULL, 'REC_WspR-like', NULL, NULL, 'REC_WspR-like', 9045),
(9046, 'cd06830', NULL, 'PLPDE_III_ADC', NULL, NULL, 'PLPDE_III_ADC', 9046),
(9047, 'cd07483', NULL, 'Peptidases_S8_Subtilisin_Novo-like', NULL, NULL, 'Peptidases_S8_Subtilisin_Novo-like', 9047),
(9048, 'cd13744', NULL, 'SPRY_PRY_TRIM62', NULL, NULL, 'SPRY_PRY_TRIM62', 9048),
(9049, 'cd05360', NULL, 'SDR_c3', NULL, NULL, 'SDR_c3', 9049),
(9050, 'cd05730', NULL, 'Ig3_NCAM-1_like', NULL, NULL, 'Ig3_NCAM-1_like', 9050);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(9051, 'cd17918', NULL, 'DEXHc_RecG', NULL, NULL, 'DEXHc_RecG', 9051),
(9052, 'cd21163', NULL, 'M_cv_Nsp15-NTD_av_Nsp11-like', NULL, NULL, 'M_cv_Nsp15-NTD_av_Nsp11-like', 9052),
(9053, 'cd07831', NULL, 'STKc_MOK', NULL, NULL, 'STKc_MOK', 9053),
(9054, 'cd08790', NULL, 'DED_DEDD', NULL, NULL, 'DED_DEDD', 9054),
(9055, 'cd09259', NULL, 'AP-1_Mu1B_Cterm', NULL, NULL, 'AP-1_Mu1B_Cterm', 9055),
(9056, 'cd09439', NULL, 'LIM_Mical', NULL, NULL, 'LIM_Mical', 9056),
(9057, 'cd00194', NULL, 'UBA_like_SF', NULL, NULL, 'UBA_like_SF', 9057),
(9058, 'cd10545', NULL, 'SET_AtSUVH-like', NULL, NULL, 'SET_AtSUVH-like', 9058),
(9059, 'cd09911', NULL, 'Lin0431_like', NULL, NULL, 'Lin0431_like', 9059),
(9060, 'cd16240', NULL, 'EFh_SPARC_SMOC1', NULL, NULL, 'EFh_SPARC_SMOC1', 9060),
(9061, 'cd20228', NULL, 'PFM_TDP-like', NULL, NULL, 'PFM_TDP-like', 9061),
(9062, 'cd05293', NULL, 'LDH_1', NULL, NULL, 'LDH_1', 9062),
(9063, 'cd11474', NULL, 'SLC5sbd_CHT', NULL, NULL, 'SLC5sbd_CHT', 9063),
(9064, 'cd13885', NULL, 'CuRO_2_CumA_like', NULL, NULL, 'CuRO_2_CumA_like', 9064),
(9065, 'cd19073', NULL, 'AKR_AKR3F2_3', NULL, NULL, 'AKR_AKR3F2_3', 9065),
(9066, 'cd12388', NULL, 'RRM1_RAVER', NULL, NULL, 'RRM1_RAVER', 9066),
(9067, 'cd01722', NULL, 'Sm_F', NULL, NULL, 'Sm_F', 9067),
(9068, 'cd02007', NULL, 'TPP_DXS', NULL, NULL, 'TPP_DXS', 9068),
(9069, 'cd05067', NULL, 'PTKc_Lck_Blk', NULL, NULL, 'PTKc_Lck_Blk', 9069),
(9070, 'cd07288', NULL, 'PX_SNX15', NULL, NULL, 'PX_SNX15', 9070),
(9071, 'cd13625', NULL, 'PBP2_AA_binding_like_1', NULL, NULL, 'PBP2_AA_binding_like_1', 9071),
(9072, 'cd12264', NULL, 'RRM_AKAP17A', NULL, NULL, 'RRM_AKAP17A', 9072),
(9073, 'cd16821', NULL, 'SP-RING_PIAS4', NULL, NULL, 'SP-RING_PIAS4', 9073),
(9074, 'cd05490', NULL, 'Cathepsin_D2', NULL, NULL, 'Cathepsin_D2', 9074),
(9075, 'cd16543', NULL, 'RING-HC_RNF135_like', NULL, NULL, 'RING-HC_RNF135_like', 9075),
(9076, 'cd12485', NULL, 'RRM1_RBM47', NULL, NULL, 'RRM1_RBM47', 9076),
(9077, 'cd17331', NULL, 'MFS_SLC22A18', NULL, NULL, 'MFS_SLC22A18', 9077),
(9078, 'cd04647', NULL, 'LbH_MAT_like', NULL, NULL, 'LbH_MAT_like', 9078),
(9079, 'cd08501', NULL, 'PBP2_Lpqw', NULL, NULL, 'PBP2_Lpqw', 9079),
(9080, 'cd04908', NULL, 'ACT_Bt0572_1', NULL, NULL, 'ACT_Bt0572_1', 9080),
(9081, 'cd16803', NULL, 'RING-H2_RNF130', NULL, NULL, 'RING-H2_RNF130', 9081),
(9082, 'cd04897', NULL, 'ACT_ACR_3', NULL, NULL, 'ACT_ACR_3', 9082),
(9083, 'cd08317', NULL, 'Death_ank', NULL, NULL, 'Death_ank', 9083),
(9084, 'cd09377', NULL, 'LIM2_Lhx2_Lhx9', NULL, NULL, 'LIM2_Lhx2_Lhx9', 9084),
(9085, 'cd13439', NULL, 'CamS_repeat', NULL, NULL, 'CamS_repeat', 9085),
(9086, 'cd16943', NULL, 'HATPase_AtoS-like', NULL, NULL, 'HATPase_AtoS-like', 9086),
(9087, 'cd09372', NULL, 'LIM2_FBLP-1', NULL, NULL, 'LIM2_FBLP-1', 9087),
(9088, 'cd14313', NULL, 'UBA_II_E2_UBE2K_like', NULL, NULL, 'UBA_II_E2_UBE2K_like', 9088),
(9089, 'cd08261', NULL, 'Zn_ADH7', NULL, NULL, 'Zn_ADH7', 9089),
(9090, 'cd00797', NULL, 'INT_RitB_C_like', NULL, NULL, 'INT_RitB_C_like', 9090),
(9091, 'cd05171', NULL, 'PIKKc_ATM', NULL, NULL, 'PIKKc_ATM', 9091),
(9092, 'cd11864', NULL, 'SH3_PEX13_eumet', NULL, NULL, 'SH3_PEX13_eumet', 9092),
(9093, 'cd19801', NULL, 'Bbox1_MID', NULL, NULL, 'Bbox1_MID', 9093),
(9094, 'cd15582', NULL, 'PHD2_PHF1', NULL, NULL, 'PHD2_PHF1', 9094),
(9095, 'cd04795', NULL, 'SIS', NULL, NULL, 'SIS', 9095),
(9096, 'cd01771', NULL, 'UBX_UBXN3A', NULL, NULL, 'UBX_UBXN3A', 9096),
(9097, 'cd08577', NULL, 'PI-PLCc_GDPD_SF_unchar3', NULL, NULL, 'PI-PLCc_GDPD_SF_unchar3', 9097),
(9098, 'cd21402', NULL, 'ZBD_mv_SF1_Hel-like', NULL, NULL, 'ZBD_mv_SF1_Hel-like', 9098),
(9099, 'cd06278', NULL, 'PBP1_LacI-like', NULL, NULL, 'PBP1_LacI-like', 9099),
(9100, 'cd12197', NULL, 'MARK4_C', NULL, NULL, 'MARK4_C', 9100),
(9101, 'cd14483', NULL, 'SPX_PHO81_NUC-2_like', NULL, NULL, 'SPX_PHO81_NUC-2_like', 9101),
(9102, 'cd18312', NULL, 'BTB_POZ_NPY3-like', NULL, NULL, 'BTB_POZ_NPY3-like', 9102),
(9103, 'cd07326', NULL, 'M56_BlaR1_MecR1_like', NULL, NULL, 'M56_BlaR1_MecR1_like', 9103),
(9104, 'cd05088', NULL, 'PTKc_Tie2', NULL, NULL, 'PTKc_Tie2', 9104);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(9105, 'cd16851', NULL, 'STAT1_CCD', NULL, NULL, 'STAT1_CCD', 9105),
(9106, 'cd19714', NULL, 'bHLH_TS_ATOH7', NULL, NULL, 'bHLH_TS_ATOH7', 9106),
(9107, 'cd00183', NULL, 'TFIIS_I', NULL, NULL, 'TFIIS_I', 9107),
(9108, 'cd08168', NULL, 'Cytochrom_C3', NULL, NULL, 'Cytochrom_C3', 9108),
(9109, 'cd16413', NULL, 'DGQHR_domain', NULL, NULL, 'DGQHR_domain', 9109),
(9110, 'cd12348', NULL, 'RRM1_SHARP', NULL, NULL, 'RRM1_SHARP', 9110),
(9111, 'cd12796', NULL, 'LbR_Ice_bind', NULL, NULL, 'LbR_Ice_bind', 9111),
(9112, 'cd02412', NULL, '30S_S3_KH', NULL, NULL, '30S_S3_KH', 9112),
(9113, 'cd08677', NULL, 'C2A_Synaptotagmin-13', NULL, NULL, 'C2A_Synaptotagmin-13', 9113),
(9114, 'cd12032', NULL, 'SH3_DLG2', NULL, NULL, 'SH3_DLG2', 9114),
(9115, 'cd16225', NULL, 'EFh_CREC_cab45', NULL, NULL, 'EFh_CREC_cab45', 9115),
(9116, 'cd12516', NULL, 'RRM1_RBM26', NULL, NULL, 'RRM1_RBM26', 9116),
(9117, 'cd01537', NULL, 'PBP1_repressor_sugar_binding-like', NULL, NULL, 'PBP1_repressor_sugar_binding-like', 9117),
(9118, 'cd18026', NULL, 'DEXHc_POLQ-like', NULL, NULL, 'DEXHc_POLQ-like', 9118),
(9119, 'cd18051', NULL, 'DEADc_DDX3', NULL, NULL, 'DEADc_DDX3', 9119),
(9120, 'cd07130', NULL, 'ALDH_F7_AASADH', NULL, NULL, 'ALDH_F7_AASADH', 9120),
(9121, 'cd10786', NULL, 'GH38N_AMII_like', NULL, NULL, 'GH38N_AMII_like', 9121),
(9122, 'cd11543', NULL, 'NTP-PPase_u6', NULL, NULL, 'NTP-PPase_u6', 9122),
(9123, 'cd19089', NULL, 'AKR_AKR14A1_2', NULL, NULL, 'AKR_AKR14A1_2', 9123),
(9124, 'cd00311', NULL, 'TIM', NULL, NULL, 'TIM', 9124),
(9125, 'cd15662', NULL, 'ePHD_ATX1_2_like', NULL, NULL, 'ePHD_ATX1_2_like', 9125),
(9126, 'cd08395', NULL, 'C2C_Munc13', NULL, NULL, 'C2C_Munc13', 9126),
(9127, 'cd01571', NULL, 'NAPRTase_B', NULL, NULL, 'NAPRTase_B', 9127),
(9128, 'cd01635', NULL, 'Glycosyltransferase_GTB-type', NULL, NULL, 'Glycosyltransferase_GTB-type', 9128),
(9129, 'cd13132', NULL, 'MATE_eukaryotic', NULL, NULL, 'MATE_eukaryotic', 9129),
(9130, 'cd08025', NULL, 'RNR_PFL_like_DUF711', NULL, NULL, 'RNR_PFL_like_DUF711', 9130),
(9131, 'cd16655', NULL, 'RING-Ubox_WDSUB1_like', NULL, NULL, 'RING-Ubox_WDSUB1_like', 9131),
(9132, 'cd11239', NULL, 'Sema_3', NULL, NULL, 'Sema_3', 9132),
(9133, 'cd15450', NULL, '7tmC_mGluR5', NULL, NULL, '7tmC_mGluR5', 9133),
(9134, 'cd12648', NULL, 'RRM3_UHM_PUF60', NULL, NULL, 'RRM3_UHM_PUF60', 9134),
(9135, 'cd02983', NULL, 'P5_C', NULL, NULL, 'P5_C', 9135),
(9136, 'cd20241', NULL, 'PFM_aerolysin-like', NULL, NULL, 'PFM_aerolysin-like', 9136),
(9137, 'cd18599', NULL, 'ABC_6TM_MRP5_8_9_D2', NULL, NULL, 'ABC_6TM_MRP5_8_9_D2', 9137),
(9138, 'cd16853', NULL, 'STAT3_CCD', NULL, NULL, 'STAT3_CCD', 9138),
(9139, 'cd02000', NULL, 'TPP_E1_PDC_ADC_BCADC', NULL, NULL, 'TPP_E1_PDC_ADC_BCADC', 9139),
(9140, 'cd08795', NULL, 'Death_IRAK2', NULL, NULL, 'Death_IRAK2', 9140),
(9141, 'cd09343', NULL, 'LIM1_FHL', NULL, NULL, 'LIM1_FHL', 9141),
(9142, 'cd18530', NULL, 'BACK_RHOBTB1', NULL, NULL, 'BACK_RHOBTB1', 9142),
(9143, 'cd04046', NULL, 'C2_Calpain', NULL, NULL, 'C2_Calpain', 9143),
(9144, 'cd00537', NULL, 'MTHFR', NULL, NULL, 'MTHFR', 9144),
(9145, 'cd07964', NULL, 'RBP-H', NULL, NULL, 'RBP-H', 9145),
(9146, 'cd06302', NULL, 'PBP1_LsrB_Quorum_Sensing-like', NULL, NULL, 'PBP1_LsrB_Quorum_Sensing-like', 9146),
(9147, 'cd08209', NULL, 'RLP_DK-MTP-1-P-enolase', NULL, NULL, 'RLP_DK-MTP-1-P-enolase', 9147),
(9148, 'cd12688', NULL, 'RRM1_PTBP1_like', NULL, NULL, 'RRM1_PTBP1_like', 9148),
(9149, 'cd04733', NULL, 'OYE_like_2_FMN', NULL, NULL, 'OYE_like_2_FMN', 9149),
(9150, 'cd06348', NULL, 'PBP1_ABC_HAAT-like', NULL, NULL, 'PBP1_ABC_HAAT-like', 9150),
(9151, 'cd13841', NULL, 'ABBA-PTs', NULL, NULL, 'ABBA-PTs', 9151),
(9152, 'cd05621', NULL, 'STKc_ROCK2', NULL, NULL, 'STKc_ROCK2', 9152),
(9153, 'cd16841', NULL, 'RraA_family', NULL, NULL, 'RraA_family', 9153),
(9154, 'cd05789', NULL, 'S1_Rrp4', NULL, NULL, 'S1_Rrp4', 9154),
(9155, 'cd18554', NULL, 'ABC_6TM_Sav1866_like', NULL, NULL, 'ABC_6TM_Sav1866_like', 9155),
(9156, 'cd08806', NULL, 'CARD_CARD14_CARMA2', NULL, NULL, 'CARD_CARD14_CARMA2', 9156),
(9157, 'cd16616', NULL, 'mRING-HC-C4C4_Asi1p_like', NULL, NULL, 'mRING-HC-C4C4_Asi1p_like', 9157); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(9158, 'cd06189', NULL, 'flavin_oxioreductase', NULL, NULL, 'flavin_oxioreductase', 9158),
(9159, 'cd06152', NULL, 'YjgF_YER057c_UK114_like_4', NULL, NULL, 'YjgF_YER057c_UK114_like_4', 9159),
(9160, 'cd06472', NULL, 'ACD_ScHsp26_like', NULL, NULL, 'ACD_ScHsp26_like', 9160),
(9161, 'cd08394', NULL, 'C2A_Munc13', NULL, NULL, 'C2A_Munc13', 9161),
(9162, 'cd18005', NULL, 'DEXHc_ERCC6L2', NULL, NULL, 'DEXHc_ERCC6L2', 9162),
(9163, 'cd05291', NULL, 'HicDH_like', NULL, NULL, 'HicDH_like', 9163),
(9164, 'cd10955', NULL, 'CE4_BH0857_like', NULL, NULL, 'CE4_BH0857_like', 9164),
(9165, 'cd03321', NULL, 'mandelate_racemase', NULL, NULL, 'mandelate_racemase', 9165),
(9166, 'cd03701', NULL, 'IF2_IF5B_II', NULL, NULL, 'IF2_IF5B_II', 9166),
(9167, 'cd14403', NULL, 'UBA_AID_AAPK1', NULL, NULL, 'UBA_AID_AAPK1', 9167),
(9168, 'cd09649', NULL, 'Cas5_I-A', NULL, NULL, 'Cas5_I-A', 9168),
(9169, 'cd12085', NULL, 'DD_cGKI-alpha', NULL, NULL, 'DD_cGKI-alpha', 9169),
(9170, 'cd15753', NULL, 'FYVE_SlaC2-c', NULL, NULL, 'FYVE_SlaC2-c', 9170),
(9171, 'cd09170', NULL, 'PLDc_Nuc', NULL, NULL, 'PLDc_Nuc', 9171),
(9172, 'cd17521', NULL, 'RMtype1_S_Sau13435ORF2165P_TRD2-CR2_like', NULL, NULL, 'RMtype1_S_Sau13435ORF2165P_TRD2-CR2_like', 9172),
(9173, 'sd00032', NULL, 'LRR_2', NULL, NULL, 'LRR_2', 9173),
(9174, 'cd16164', NULL, 'OCRE_VG5Q', NULL, NULL, 'OCRE_VG5Q', 9174),
(9175, 'cd00025', NULL, 'BPI1', NULL, NULL, 'BPI1', 9175),
(9176, 'cd05261', NULL, 'CAPF_like_SDR_e', NULL, NULL, 'CAPF_like_SDR_e', 9176),
(9177, 'cd20258', NULL, 'Tal_Pri', NULL, NULL, 'Tal_Pri', 9177),
(9178, 'cd03347', NULL, 'eu_PheOH', NULL, NULL, 'eu_PheOH', 9178),
(9179, 'cd12395', NULL, 'RRM2_RBM34', NULL, NULL, 'RRM2_RBM34', 9179),
(9180, 'cd16128', NULL, 'Ubl_ATG8', NULL, NULL, 'Ubl_ATG8', 9180),
(9181, 'cd12899', NULL, 'SPRY_PRY_TRIM76_like', NULL, NULL, 'SPRY_PRY_TRIM76_like', 9181),
(9182, 'cd14397', NULL, 'UBA_LATS1', NULL, NULL, 'UBA_LATS1', 9182),
(9183, 'cd07344', NULL, 'M48_yhfN_like', NULL, NULL, 'M48_yhfN_like', 9183),
(9184, 'cd11255', NULL, 'Sema_3G', NULL, NULL, 'Sema_3G', 9184),
(9185, 'cd19943', NULL, 'NirB_Fer2_BFD-like_1', NULL, NULL, 'NirB_Fer2_BFD-like_1', 9185),
(9186, 'cd19535', NULL, 'Cyc_NRPS', NULL, NULL, 'Cyc_NRPS', 9186),
(9187, 'cd03485', NULL, 'MutL_Trans_hPMS_1_like', NULL, NULL, 'MutL_Trans_hPMS_1_like', 9187),
(9188, 'cd04502', NULL, 'SGNH_hydrolase_like_7', NULL, NULL, 'SGNH_hydrolase_like_7', 9188),
(9189, 'cd15294', NULL, '7tmC_GABA-B-R2', NULL, NULL, '7tmC_GABA-B-R2', 9189),
(9190, 'cd01925', NULL, 'cyclophilin_CeCYP16-like', NULL, NULL, 'cyclophilin_CeCYP16-like', 9190),
(9191, 'cd08294', NULL, 'leukotriene_B4_DH_like', NULL, NULL, 'leukotriene_B4_DH_like', 9191),
(9192, 'cd17989', NULL, 'DEXHc_HrpA', NULL, NULL, 'DEXHc_HrpA', 9192),
(9193, 'cd04873', NULL, 'ACT_UUR-ACR-like', NULL, NULL, 'ACT_UUR-ACR-like', 9193),
(9194, 'cd16675', NULL, 'RING-H2_RNF24', NULL, NULL, 'RING-H2_RNF24', 9194),
(9195, 'cd18192', NULL, 'BTB_POZ_ZBTB1', NULL, NULL, 'BTB_POZ_ZBTB1', 9195),
(9196, 'cd01256', NULL, 'PH_dynamin', NULL, NULL, 'PH_dynamin', 9196),
(9197, 'cd12453', NULL, 'RRM1_RIM4_like', NULL, NULL, 'RRM1_RIM4_like', 9197),
(9198, 'cd14906', NULL, 'MYSc_Myo45', NULL, NULL, 'MYSc_Myo45', 9198),
(9199, 'cd00524', NULL, 'SORL', NULL, NULL, 'SORL', 9199),
(9200, 'cd07835', NULL, 'STKc_CDK1_CdkB_like', NULL, NULL, 'STKc_CDK1_CdkB_like', 9200),
(9201, 'cd15986', NULL, '7tmB1_VIP-R2', NULL, NULL, '7tmB1_VIP-R2', 9201),
(9202, 'cd14676', NULL, 'PH_DOK1,2,3', NULL, NULL, 'PH_DOK1,2,3', 9202),
(9203, 'cd13328', NULL, 'PH1_FDG_family', NULL, NULL, 'PH1_FDG_family', 9203),
(9204, 'cd15406', NULL, '7tmA_OR8D-like', NULL, NULL, '7tmA_OR8D-like', 9204),
(9205, 'cd16290', NULL, 'AIM-1_SMB-1-like_MBL-B3', NULL, NULL, 'AIM-1_SMB-1-like_MBL-B3', 9205),
(9206, 'cd18479', NULL, 'BACK_KBTBD2', NULL, NULL, 'BACK_KBTBD2', 9206),
(9207, 'cd05727', NULL, 'Ig2_Contactin-2-like', NULL, NULL, 'Ig2_Contactin-2-like', 9207),
(9208, 'cd10959', NULL, 'CE4_NodB_like_3', NULL, NULL, 'CE4_NodB_like_3', 9208),
(9209, 'cd00112', NULL, 'LDLa', NULL, NULL, 'LDLa', 9209);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(9210, 'cd08987', NULL, 'GH62', NULL, NULL, 'GH62', 9210),
(9211, 'cd05140', NULL, 'Barstar_AU1054-like', NULL, NULL, 'Barstar_AU1054-like', 9211),
(9212, 'cd09644', NULL, 'Csn2', NULL, NULL, 'Csn2', 9212),
(9213, 'cd19889', NULL, 'DSRM_PRKRA_rpt1', NULL, NULL, 'DSRM_PRKRA_rpt1', 9213),
(9214, 'cd16076', NULL, 'TSPcc', NULL, NULL, 'TSPcc', 9214),
(9215, 'cd18470', NULL, 'BACK_KLHL31_KBTBD1', NULL, NULL, 'BACK_KLHL31_KBTBD1', 9215),
(9216, 'cd16307', NULL, 'FEZ-1-like_MBL-B3', NULL, NULL, 'FEZ-1-like_MBL-B3', 9216),
(9217, 'cd13896', NULL, 'CuRO_3_CopA', NULL, NULL, 'CuRO_3_CopA', 9217),
(9218, 'cd15345', NULL, '7tmA_S1PR3_Edg3', NULL, NULL, '7tmA_S1PR3_Edg3', 9218),
(9219, 'cd10964', NULL, 'CE4_PgaB_5s', NULL, NULL, 'CE4_PgaB_5s', 9219),
(9220, 'cd14884', NULL, 'MYSc_Myo23', NULL, NULL, 'MYSc_Myo23', 9220),
(9221, 'cd12778', NULL, 'RRM1_PTBP2', NULL, NULL, 'RRM1_PTBP2', 9221),
(9222, 'cd01889', NULL, 'SelB_euk', NULL, NULL, 'SelB_euk', 9222),
(9223, 'cd19723', NULL, 'bHLH_TS_ASCL1_like', NULL, NULL, 'bHLH_TS_ASCL1_like', 9223),
(9224, 'cd12884', NULL, 'SPRY_hnRNP', NULL, NULL, 'SPRY_hnRNP', 9224),
(9225, 'cd12931', NULL, 'eNOPS_SF', NULL, NULL, 'eNOPS_SF', 9225),
(9226, 'cd07658', NULL, 'F-BAR_NOSTRIN', NULL, NULL, 'F-BAR_NOSTRIN', 9226),
(9227, 'cd19580', NULL, 'serpin_silkworm16_18_22', NULL, NULL, 'serpin_silkworm16_18_22', 9227),
(9228, 'cd00529', NULL, 'RuvC_like', NULL, NULL, 'RuvC_like', 9228),
(9229, 'cd08535', NULL, 'SAM_PNT-Tel_Yan', NULL, NULL, 'SAM_PNT-Tel_Yan', 9229),
(9230, 'cd12912', NULL, 'PDC2_MCP_like', NULL, NULL, 'PDC2_MCP_like', 9230),
(9231, 'cd09484', NULL, 'LIM1_Prickle_2', NULL, NULL, 'LIM1_Prickle_2', 9231),
(9232, 'cd19861', NULL, 'DSRM_STAU_rpt5', NULL, NULL, 'DSRM_STAU_rpt5', 9232),
(9233, 'cd10019', NULL, '14-3-3_sigma', NULL, NULL, '14-3-3_sigma', 9233),
(9234, 'cd01378', NULL, 'MYSc_Myo1', NULL, NULL, 'MYSc_Myo1', 9234),
(9235, 'cd11804', NULL, 'SH3_GRB2_like_N', NULL, NULL, 'SH3_GRB2_like_N', 9235),
(9236, 'cd15017', NULL, '7tm_TAS2R16', NULL, NULL, '7tm_TAS2R16', 9236),
(9237, 'cd13118', NULL, 'POLO_box_1', NULL, NULL, 'POLO_box_1', 9237),
(9238, 'cd13202', NULL, 'FERM_C_MyoX', NULL, NULL, 'FERM_C_MyoX', 9238),
(9239, 'cd03784', NULL, 'GT1_Gtf-like', NULL, NULL, 'GT1_Gtf-like', 9239),
(9240, 'cd15993', NULL, '7tmB2_CELSR3', NULL, NULL, '7tmB2_CELSR3', 9240),
(9241, 'cd13424', NULL, 'TNFRSF9_teleost', NULL, NULL, 'TNFRSF9_teleost', 9241),
(9242, 'cd15335', NULL, '7tmA_5-HT1E', NULL, NULL, '7tmA_5-HT1E', 9242),
(9243, 'cd12927', NULL, 'MMP_TTHA0227_like', NULL, NULL, 'MMP_TTHA0227_like', 9243),
(9244, 'cd09475', NULL, 'LIM2_Lhx9', NULL, NULL, 'LIM2_Lhx9', 9244),
(9245, 'cd11808', NULL, 'SH3_Alpha_Spectrin', NULL, NULL, 'SH3_Alpha_Spectrin', 9245),
(9246, 'cd12905', NULL, 'SPRY_PRY_A33L', NULL, NULL, 'SPRY_PRY_A33L', 9246),
(9247, 'cd07374', NULL, 'CYTH-like_Pase', NULL, NULL, 'CYTH-like_Pase', 9247),
(9248, 'cd16496', NULL, 'RING-HC_BARD1', NULL, NULL, 'RING-HC_BARD1', 9248),
(9249, 'cd12269', NULL, 'RRM_Vip1_like', NULL, NULL, 'RRM_Vip1_like', 9249),
(9250, 'cd03245', NULL, 'ABCC_bacteriocin_exporters', NULL, NULL, 'ABCC_bacteriocin_exporters', 9250),
(9251, 'cd13200', NULL, 'FERM_C_KCBP', NULL, NULL, 'FERM_C_KCBP', 9251),
(9252, 'cd01455', NULL, 'vWA_F11C1-5a_type', NULL, NULL, 'vWA_F11C1-5a_type', 9252),
(9253, 'cd09536', NULL, 'SAM_Ste50_fungal', NULL, NULL, 'SAM_Ste50_fungal', 9253),
(9254, 'cd18761', NULL, 'PIN_MtVapC3-like', NULL, NULL, 'PIN_MtVapC3-like', 9254),
(9255, 'cd03345', NULL, 'eu_TyrOH', NULL, NULL, 'eu_TyrOH', 9255),
(9256, 'cd11740', NULL, 'YajQ_like', NULL, NULL, 'YajQ_like', 9256),
(9257, 'cd11396', NULL, 'bHLHzip_USF', NULL, NULL, 'bHLHzip_USF', 9257),
(9258, 'cd15837', NULL, 'TNFRSF26', NULL, NULL, 'TNFRSF26', 9258),
(9259, 'cd16986', NULL, 'ANTH_N_Sla2p_HIP1_like', NULL, NULL, 'ANTH_N_Sla2p_HIP1_like', 9259),
(9260, 'cd14188', NULL, 'STKc_PLK2', NULL, NULL, 'STKc_PLK2', 9260),
(9261, 'cd18313', NULL, 'BTB_POZ_BT', NULL, NULL, 'BTB_POZ_BT', 9261),
(9262, 'cd21519', NULL, 'cv_beta_Nsp2_MHV-like', NULL, NULL, 'cv_beta_Nsp2_MHV-like', 9262);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(9263, 'cd00076', NULL, 'H4', NULL, NULL, 'H4', 9263),
(9264, 'cd06143', NULL, 'PAN2_exo', NULL, NULL, 'PAN2_exo', 9264),
(9265, 'cd13407', NULL, 'TNFRSF5', NULL, NULL, 'TNFRSF5', 9265),
(9266, 'cd15421', NULL, '7tmA_OR2T-like', NULL, NULL, '7tmA_OR2T-like', 9266),
(9267, 'cd15785', NULL, 'YycH_N_like', NULL, NULL, 'YycH_N_like', 9267),
(9268, 'cd20001', NULL, 'PBP1_LsrB_Quorum_Sensing-like', NULL, NULL, 'PBP1_LsrB_Quorum_Sensing-like', 9268),
(9269, 'cd08653', NULL, 'FMT_core_like_3', NULL, NULL, 'FMT_core_like_3', 9269),
(9270, 'cd11611', NULL, 'SAF', NULL, NULL, 'SAF', 9270),
(9271, 'cd16168', NULL, 'OCRE_RBM5', NULL, NULL, 'OCRE_RBM5', 9271),
(9272, 'cd13517', NULL, 'PBP2_ModA3_like', NULL, NULL, 'PBP2_ModA3_like', 9272),
(9273, 'cd15502', NULL, 'PHD_Phf1p_Phf2p_like', NULL, NULL, 'PHD_Phf1p_Phf2p_like', 9273),
(9274, 'cd18991', NULL, 'LGIC_ECD_GlyR', NULL, NULL, 'LGIC_ECD_GlyR', 9274),
(9275, 'cd14326', NULL, 'UBA_UBL7', NULL, NULL, 'UBA_UBL7', 9275),
(9276, 'cd19467', NULL, 'FABP4', NULL, NULL, 'FABP4', 9276),
(9277, 'cd19607', NULL, 'GTA_TIM-barrel-like', NULL, NULL, 'GTA_TIM-barrel-like', 9277),
(9278, 'cd19443', NULL, 'FABP3-like', NULL, NULL, 'FABP3-like', 9278),
(9279, 'cd07472', NULL, 'HmuY_like', NULL, NULL, 'HmuY_like', 9279),
(9280, 'cd18174', NULL, 'M14_ASTE_ASPA_like', NULL, NULL, 'M14_ASTE_ASPA_like', 9280),
(9281, 'cd15664', NULL, 'ePHD_KMT2A_like', NULL, NULL, 'ePHD_KMT2A_like', 9281),
(9282, 'cd16210', NULL, 'EFh_PI-PLCbeta3', NULL, NULL, 'EFh_PI-PLCbeta3', 9282),
(9283, 'cd07141', NULL, 'ALDH_F1AB_F2_RALDH1', NULL, NULL, 'ALDH_F1AB_F2_RALDH1', 9283),
(9284, 'cd15848', NULL, 'SNARE_syntaxin1-like', NULL, NULL, 'SNARE_syntaxin1-like', 9284),
(9285, 'cd02586', NULL, 'HAD_PHN', NULL, NULL, 'HAD_PHN', 9285),
(9286, 'cd03361', NULL, 'TOPRIM_TopoIA_RevGyr', NULL, NULL, 'TOPRIM_TopoIA_RevGyr', 9286),
(9287, 'cd17648', NULL, 'A_NRPS_ACVS-like', NULL, NULL, 'A_NRPS_ACVS-like', 9287),
(9288, 'cd20306', NULL, 'cupin_OxDC-like', NULL, NULL, 'cupin_OxDC-like', 9288),
(9289, 'cd04228', NULL, 'CuRO_5_FVIII_like', NULL, NULL, 'CuRO_5_FVIII_like', 9289),
(9290, 'cd17182', NULL, 'FERM_F0_KIND3', NULL, NULL, 'FERM_F0_KIND3', 9290),
(9291, 'cd21624', NULL, 'SARS-CoV-like_Spike_S1_NTD', NULL, NULL, 'SARS-CoV-like_Spike_S1_NTD', 9291),
(9292, 'cd04087', NULL, 'PTPA', NULL, NULL, 'PTPA', 9292),
(9293, 'cd16013', NULL, 'AcpA', NULL, NULL, 'AcpA', 9293),
(9294, 'cd19849', NULL, 'Bbox1_TRIM46_C-I', NULL, NULL, 'Bbox1_TRIM46_C-I', 9294),
(9295, 'cd17574', NULL, 'REC_OmpR', NULL, NULL, 'REC_OmpR', 9295),
(9296, 'cd04035', NULL, 'C2A_Rabphilin_Doc2', NULL, NULL, 'C2A_Rabphilin_Doc2', 9296),
(9297, 'cd04126', NULL, 'Rab20', NULL, NULL, 'Rab20', 9297),
(9298, 'cd02981', NULL, 'PDI_b_family', NULL, NULL, 'PDI_b_family', 9298),
(9299, 'cd04085', NULL, 'delta_endotoxin_C', NULL, NULL, 'delta_endotoxin_C', 9299),
(9300, 'cd01140', NULL, 'FatB', NULL, NULL, 'FatB', 9300),
(9301, 'cd15593', NULL, 'PHD3_KMT2B', NULL, NULL, 'PHD3_KMT2B', 9301),
(9302, 'cd10329', NULL, 'SLC5sbd_SGLT1-like', NULL, NULL, 'SLC5sbd_SGLT1-like', 9302),
(9303, 'cd11896', NULL, 'SH3_SNX33', NULL, NULL, 'SH3_SNX33', 9303),
(9304, 'cd06137', NULL, 'DEDDh_RNase', NULL, NULL, 'DEDDh_RNase', 9304),
(9305, 'cd01043', NULL, 'DPS', NULL, NULL, 'DPS', 9305),
(9306, 'cd10035', NULL, 'UDG_like', NULL, NULL, 'UDG_like', 9306),
(9307, 'cd05237', NULL, 'UDP_invert_4-6DH_SDR_e', NULL, NULL, 'UDP_invert_4-6DH_SDR_e', 9307),
(9308, 'cd08235', NULL, 'iditol_2_DH_like', NULL, NULL, 'iditol_2_DH_like', 9308),
(9309, 'cd14415', NULL, 'UBA_NACA_NACP1', NULL, NULL, 'UBA_NACA_NACP1', 9309),
(9310, 'cd04047', NULL, 'C2B_Copine', NULL, NULL, 'C2B_Copine', 9310),
(9311, 'cd10492', NULL, 'MH1_SMAD_4', NULL, NULL, 'MH1_SMAD_4', 9311),
(9312, 'cd01369', NULL, 'KISc_KHC_KIF5', NULL, NULL, 'KISc_KHC_KIF5', 9312),
(9313, 'cd16708', NULL, 'RING-HC_Cbl', NULL, NULL, 'RING-HC_Cbl', 9313),
(9314, 'cd18239', NULL, 'BTB_POZ_KLHL9_13', NULL, NULL, 'BTB_POZ_KLHL9_13', 9314),
(9315, 'cd05627', NULL, 'STKc_NDR2', NULL, NULL, 'STKc_NDR2', 9315),
(9316, 'cd08203', NULL, 'SAM_PNT', NULL, NULL, 'SAM_PNT', 9316);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(9317, 'cd08186', NULL, 'Fe-ADH-like', NULL, NULL, 'Fe-ADH-like', 9317),
(9318, 'cd16141', NULL, 'RA_GRB10', NULL, NULL, 'RA_GRB10', 9318),
(9319, 'cd03767', NULL, 'SR_Res_par', NULL, NULL, 'SR_Res_par', 9319),
(9320, 'cd08161', NULL, 'SET', NULL, NULL, 'SET', 9320),
(9321, 'cd09359', NULL, 'LIM_LASP_like', NULL, NULL, 'LIM_LASP_like', 9321),
(9322, 'cd07391', NULL, 'MPP_PF1019', NULL, NULL, 'MPP_PF1019', 9322),
(9323, 'cd16223', NULL, 'EFh_PRIP2', NULL, NULL, 'EFh_PRIP2', 9323),
(9324, 'cd13850', NULL, 'CuRO_1_Abr2_like', NULL, NULL, 'CuRO_1_Abr2_like', 9324),
(9325, 'cd14308', NULL, 'UBA_Mud1_like', NULL, NULL, 'UBA_Mud1_like', 9325),
(9326, 'cd13562', NULL, 'PBP2_SsuA_like_5', NULL, NULL, 'PBP2_SsuA_like_5', 9326),
(9327, 'cd14293', NULL, 'UBA3_NUB1', NULL, NULL, 'UBA3_NUB1', 9327),
(9328, 'cd11697', NULL, 'DHR2_DOCK_A', NULL, NULL, 'DHR2_DOCK_A', 9328),
(9329, 'cd17187', NULL, 'FERM_F1_ERM', NULL, NULL, 'FERM_F1_ERM', 9329),
(9330, 'cd10809', NULL, 'GH38N_AMII_GMII_SfManIII_like', NULL, NULL, 'GH38N_AMII_GMII_SfManIII_like', 9330),
(9331, 'cd12756', NULL, 'RRM1_hnRNPD', NULL, NULL, 'RRM1_hnRNPD', 9331),
(9332, 'cd01261', NULL, 'PH_SOS', NULL, NULL, 'PH_SOS', 9332),
(9333, 'cd16407', NULL, 'ParB_N_like', NULL, NULL, 'ParB_N_like', 9333),
(9334, 'cd16000', NULL, '7tmB2_GPR123', NULL, NULL, '7tmB2_GPR123', 9334),
(9335, 'cd19905', NULL, 'DSRM_ADAD1', NULL, NULL, 'DSRM_ADAD1', 9335),
(9336, 'cd16588', NULL, 'RING-HC_TRIM45-C-VII', NULL, NULL, 'RING-HC_TRIM45-C-VII', 9336),
(9337, 'cd04033', NULL, 'C2_NEDD4_NEDD4L', NULL, NULL, 'C2_NEDD4_NEDD4L', 9337),
(9338, 'cd05761', NULL, 'Ig2_Necl-1-4_like', NULL, NULL, 'Ig2_Necl-1-4_like', 9338),
(9339, 'cd09355', NULL, 'LIM2_Ajuba_like', NULL, NULL, 'LIM2_Ajuba_like', 9339),
(9340, 'cd13144', NULL, 'MATE_like_4', NULL, NULL, 'MATE_like_4', 9340),
(9341, 'cd02993', NULL, 'PDI_a_APS_reductase', NULL, NULL, 'PDI_a_APS_reductase', 9341),
(9342, 'cd11325', NULL, 'AmyAc_GTHase', NULL, NULL, 'AmyAc_GTHase', 9342),
(9343, 'cd15971', NULL, '7tmA_SSTR2', NULL, NULL, '7tmA_SSTR2', 9343),
(9344, 'cd18498', NULL, 'BACK_RCBTB1_2', NULL, NULL, 'BACK_RCBTB1_2', 9344),
(9345, 'cd05233', NULL, 'SDR_c', NULL, NULL, 'SDR_c', 9345),
(9346, 'cd02023', NULL, 'UMPK', NULL, NULL, 'UMPK', 9346),
(9347, 'cd02931', NULL, 'ER_like_FMN', NULL, NULL, 'ER_like_FMN', 9347),
(9348, 'cd12048', NULL, 'SH3_DOCK3_B', NULL, NULL, 'SH3_DOCK3_B', 9348),
(9349, 'cd17147', NULL, 'DCX2_RP1', NULL, NULL, 'DCX2_RP1', 9349),
(9350, 'cd09554', NULL, 'SAM_EPH-B4', NULL, NULL, 'SAM_EPH-B4', 9350),
(9351, 'cd04968', NULL, 'Ig3_Contactin', NULL, NULL, 'Ig3_Contactin', 9351),
(9352, 'cd09075', NULL, 'DNase1-like', NULL, NULL, 'DNase1-like', 9352),
(9353, 'cd02120', NULL, 'PA_subtilisin_like', NULL, NULL, 'PA_subtilisin_like', 9353),
(9354, 'cd01523', NULL, 'RHOD_Lact_B', NULL, NULL, 'RHOD_Lact_B', 9354),
(9355, 'cd06087', NULL, 'KOW_RPS4', NULL, NULL, 'KOW_RPS4', 9355),
(9356, 'cd05129', NULL, 'RasGAP_RAP6', NULL, NULL, 'RasGAP_RAP6', 9356),
(9357, 'cd06156', NULL, 'eu_AANH_C_2', NULL, NULL, 'eu_AANH_C_2', 9357),
(9358, 'cd07894', NULL, 'Adenylation_RNA_ligase', NULL, NULL, 'Adenylation_RNA_ligase', 9358),
(9359, 'cd17917', NULL, 'DEXHc_RHA-like', NULL, NULL, 'DEXHc_RHA-like', 9359),
(9360, 'cd03674', NULL, 'Nudix_Hydrolase_1', NULL, NULL, 'Nudix_Hydrolase_1', 9360),
(9361, 'cd09421', NULL, 'LIM3_LIMPETin', NULL, NULL, 'LIM3_LIMPETin', 9361),
(9362, 'cd01135', NULL, 'V_A-ATPase_B', NULL, NULL, 'V_A-ATPase_B', 9362),
(9363, 'cd04103', NULL, 'Centaurin_gamma', NULL, NULL, 'Centaurin_gamma', 9363),
(9364, 'cd04594', NULL, 'CBS_pair_voltage-gated_CLC_archaea', NULL, NULL, 'CBS_pair_voltage-gated_CLC_archaea', 9364),
(9365, 'cd17786', NULL, 'CBS_pair_Thermoplasmatales', NULL, NULL, 'CBS_pair_Thermoplasmatales', 9365),
(9366, 'cd05258', NULL, 'CDP_TE_SDR_e', NULL, NULL, 'CDP_TE_SDR_e', 9366),
(9367, 'cd15372', NULL, '7tmA_PAR4', NULL, NULL, '7tmA_PAR4', 9367),
(9368, 'cd03585', NULL, 'NTR_TIMP', NULL, NULL, 'NTR_TIMP', 9368),
(9369, 'cd04435', NULL, 'DEP_fRom2', NULL, NULL, 'DEP_fRom2', 9369),
(9370, 'cd19590', NULL, 'serpin_thermopin-like', NULL, NULL, 'serpin_thermopin-like', 9370);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(9371, 'cd20247', NULL, 'DWORF', NULL, NULL, 'DWORF', 9371),
(9372, 'cd11982', NULL, 'SH3_Shank1', NULL, NULL, 'SH3_Shank1', 9372),
(9373, 'cd04043', NULL, 'C2_Munc13_fungal', NULL, NULL, 'C2_Munc13_fungal', 9373),
(9374, 'cd06294', NULL, 'PBP1_MalR-like', NULL, NULL, 'PBP1_MalR-like', 9374),
(9375, 'cd01006', NULL, 'PBP2_phosphate_binding', NULL, NULL, 'PBP2_phosphate_binding', 9375),
(9376, 'cd14983', NULL, '7tmA_FFAR', NULL, NULL, '7tmA_FFAR', 9376),
(9377, 'cd16154', NULL, 'sulfatase_like', NULL, NULL, 'sulfatase_like', 9377),
(9378, 'cd18068', NULL, 'DEXHc_ATRX', NULL, NULL, 'DEXHc_ATRX', 9378),
(9379, 'cd13159', NULL, 'PTB_LDLRAP-mammal-like', NULL, NULL, 'PTB_LDLRAP-mammal-like', 9379),
(9380, 'cd05281', NULL, 'TDH', NULL, NULL, 'TDH', 9380),
(9381, 'cd02337', NULL, 'ZZ_CBP', NULL, NULL, 'ZZ_CBP', 9381),
(9382, 'cd18120', NULL, 'ATP-synt_Vo_Ao_c', NULL, NULL, 'ATP-synt_Vo_Ao_c', 9382),
(9383, 'cd18536', NULL, 'PTP-IVa2', NULL, NULL, 'PTP-IVa2', 9383),
(9384, 'cd07874', NULL, 'STKc_JNK3', NULL, NULL, 'STKc_JNK3', 9384),
(9385, 'cd04203', NULL, 'Cupredoxin_like_3', NULL, NULL, 'Cupredoxin_like_3', 9385),
(9386, 'cd12951', NULL, 'RRP7_Rrp7A', NULL, NULL, 'RRP7_Rrp7A', 9386),
(9387, 'cd14967', NULL, '7tmA_amine_R-like', NULL, NULL, '7tmA_amine_R-like', 9387),
(9388, 'cd09829', NULL, 'PET_testin', NULL, NULL, 'PET_testin', 9388),
(9389, 'cd06932', NULL, 'NR_LBD_PPAR', NULL, NULL, 'NR_LBD_PPAR', 9389),
(9390, 'cd17552', NULL, 'REC_RR468-like', NULL, NULL, 'REC_RR468-like', 9390),
(9391, 'sd00006', NULL, 'TPR', NULL, NULL, 'TPR', 9391),
(9392, 'cd15196', NULL, '7tmA_Vasopressin_Oxytocin', NULL, NULL, '7tmA_Vasopressin_Oxytocin', 9392),
(9393, 'cd01116', NULL, 'P_permease', NULL, NULL, 'P_permease', 9393),
(9394, 'cd04484', NULL, 'polC_OBF', NULL, NULL, 'polC_OBF', 9394),
(9395, 'cd03177', NULL, 'GST_C_Delta_Epsilon', NULL, NULL, 'GST_C_Delta_Epsilon', 9395),
(9396, 'cd08975', NULL, 'BaFpgNei_N_3', NULL, NULL, 'BaFpgNei_N_3', 9396),
(9397, 'cd09383', NULL, 'LIM2_Lhx7_Lhx8', NULL, NULL, 'LIM2_Lhx7_Lhx8', 9397),
(9398, 'cd09833', NULL, 'CBS_pair_GGDEF_PAS_repeat1', NULL, NULL, 'CBS_pair_GGDEF_PAS_repeat1', 9398),
(9399, 'cd07323', NULL, 'LAM', NULL, NULL, 'LAM', 9399),
(9400, 'cd18453', NULL, 'BACK_KLHL14', NULL, NULL, 'BACK_KLHL14', 9400),
(9401, 'cd05044', NULL, 'PTKc_c-ros', NULL, NULL, 'PTKc_c-ros', 9401),
(9402, 'cd07856', NULL, 'STKc_Sty1_Hog1', NULL, NULL, 'STKc_Sty1_Hog1', 9402),
(9403, 'cd14256', NULL, 'Dockerin_I', NULL, NULL, 'Dockerin_I', 9403),
(9404, 'cd11453', NULL, 'bHLH_AtBIM_like', NULL, NULL, 'bHLH_AtBIM_like', 9404),
(9405, 'cd10371', NULL, 'SH2_Src_Blk', NULL, NULL, 'SH2_Src_Blk', 9405),
(9406, 'cd05608', NULL, 'STKc_GRK1', NULL, NULL, 'STKc_GRK1', 9406),
(9407, 'cd01298', NULL, 'ATZ_TRZ_like', NULL, NULL, 'ATZ_TRZ_like', 9407),
(9408, 'cd04710', NULL, 'BAH_fungalPHD', NULL, NULL, 'BAH_fungalPHD', 9408),
(9409, 'cd13315', NULL, 'PH_Sec3', NULL, NULL, 'PH_Sec3', 9409),
(9410, 'cd14458', NULL, 'DP_DD', NULL, NULL, 'DP_DD', 9410),
(9411, 'cd08191', NULL, 'Fe-ADH-like', NULL, NULL, 'Fe-ADH-like', 9411),
(9412, 'cd15156', NULL, '7tmA_LPAR6_P2Y5', NULL, NULL, '7tmA_LPAR6_P2Y5', 9412),
(9413, 'cd17021', NULL, 'T3SC_IA_SicP-like', NULL, NULL, 'T3SC_IA_SicP-like', 9413),
(9414, 'cd07996', NULL, 'WGR_MMR_like', NULL, NULL, 'WGR_MMR_like', 9414),
(9415, 'cd12731', NULL, 'RRM2_hnRNPH_hnRNPH2_hnRNPF', NULL, NULL, 'RRM2_hnRNPH_hnRNPH2_hnRNPF', 9415),
(9416, 'cd16238', NULL, 'EFh_SPARC_TICN2', NULL, NULL, 'EFh_SPARC_TICN2', 9416),
(9417, 'cd07180', NULL, 'RNase_HII_archaea_like', NULL, NULL, 'RNase_HII_archaea_like', 9417),
(9418, 'cd12795', NULL, 'FILIA_N_like', NULL, NULL, 'FILIA_N_like', 9418),
(9419, 'cd12235', NULL, 'RRM_PPIL4', NULL, NULL, 'RRM_PPIL4', 9419),
(9420, 'cd04366', NULL, 'IlGF_insulin_bombyxin_like', NULL, NULL, 'IlGF_insulin_bombyxin_like', 9420),
(9421, 'cd05235', NULL, 'SDR_e1', NULL, NULL, 'SDR_e1', 9421),
(9422, 'cd15145', NULL, '7tmA_FP', NULL, NULL, '7tmA_FP', 9422),
(9423, 'cd12886', NULL, 'SPRY_like', NULL, NULL, 'SPRY_like', 9423),
(9424, 'cd14918', NULL, 'MYSc_Myh8', NULL, NULL, 'MYSc_Myh8', 9424);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(9425, 'cd00212', NULL, 'PTS_IIB_glc', NULL, NULL, 'PTS_IIB_glc', 9425),
(9426, 'cd02775', NULL, 'MopB_CT', NULL, NULL, 'MopB_CT', 9426),
(9427, 'cd07738', NULL, 'DdPDE5-like_MBL-fold', NULL, NULL, 'DdPDE5-like_MBL-fold', 9427),
(9428, 'cd10481', NULL, 'EphR_LBD_A3', NULL, NULL, 'EphR_LBD_A3', 9428),
(9429, 'cd14543', NULL, 'PTPc-N9', NULL, NULL, 'PTPc-N9', 9429),
(9430, 'cd00472', NULL, 'Ribosomal_L24e_L24', NULL, NULL, 'Ribosomal_L24e_L24', 9430),
(9431, 'cd06420', NULL, 'GT2_Chondriotin_Pol_N', NULL, NULL, 'GT2_Chondriotin_Pol_N', 9431),
(9432, 'cd05238', NULL, 'Gne_like_SDR_e', NULL, NULL, 'Gne_like_SDR_e', 9432),
(9433, 'cd13399', NULL, 'Slt35-like', NULL, NULL, 'Slt35-like', 9433),
(9434, 'cd19696', NULL, 'bHLH-PAS_AhR_like', NULL, NULL, 'bHLH-PAS_AhR_like', 9434),
(9435, 'cd15329', NULL, '7tmA_5-HT7', NULL, NULL, '7tmA_5-HT7', 9435),
(9436, 'cd08686', NULL, 'C2_ABR', NULL, NULL, 'C2_ABR', 9436),
(9437, 'cd10978', NULL, 'CE4_Sll1306_like', NULL, NULL, 'CE4_Sll1306_like', 9437),
(9438, 'cd21564', NULL, 'alphaCoV_M', NULL, NULL, 'alphaCoV_M', 9438),
(9439, 'cd08352', NULL, 'VOC_Bs_YwkD_like', NULL, NULL, 'VOC_Bs_YwkD_like', 9439),
(9440, 'cd00279', NULL, 'YlxR', NULL, NULL, 'YlxR', 9440),
(9441, 'cd03041', NULL, 'GST_N_2GST_N', NULL, NULL, 'GST_N_2GST_N', 9441),
(9442, 'cd05697', NULL, 'S1_Rrp5_repeat_hs5', NULL, NULL, 'S1_Rrp5_repeat_hs5', 9442),
(9443, 'cd08536', NULL, 'SAM_PNT-Mae', NULL, NULL, 'SAM_PNT-Mae', 9443),
(9444, 'cd01050', NULL, 'Acyl_ACP_Desat', NULL, NULL, 'Acyl_ACP_Desat', 9444),
(9445, 'cd07395', NULL, 'MPP_CSTP1', NULL, NULL, 'MPP_CSTP1', 9445),
(9446, 'cd14345', NULL, 'UBA_UBXD7', NULL, NULL, 'UBA_UBXD7', 9446),
(9447, 'cd10232', NULL, 'ScSsz1p_like_NBD', NULL, NULL, 'ScSsz1p_like_NBD', 9447),
(9448, 'cd00835', NULL, 'RanBD_family', NULL, NULL, 'RanBD_family', 9448),
(9449, 'cd20257', NULL, 'Stannin', NULL, NULL, 'Stannin', 9449),
(9450, 'cd00954', NULL, 'NAL', NULL, NULL, 'NAL', 9450),
(9451, 'cd15040', NULL, '7tmB2_Adhesion', NULL, NULL, '7tmB2_Adhesion', 9451),
(9452, 'cd16825', NULL, 'RING_CH-C4HC3_MARCH9', NULL, NULL, 'RING_CH-C4HC3_MARCH9', 9452),
(9453, 'cd05397', NULL, 'NT_Pol-beta-like', NULL, NULL, 'NT_Pol-beta-like', 9453),
(9454, 'cd04813', NULL, 'PA_1', NULL, NULL, 'PA_1', 9454),
(9455, 'cd16373', NULL, 'DMSOR_beta_like', NULL, NULL, 'DMSOR_beta_like', 9455),
(9456, 'cd09971', NULL, 'SdiA-regulated', NULL, NULL, 'SdiA-regulated', 9456),
(9457, 'cd19782', NULL, 'Bbox2_TRIM42_C-III', NULL, NULL, 'Bbox2_TRIM42_C-III', 9457),
(9458, 'cd02022', NULL, 'DPCK', NULL, NULL, 'DPCK', 9458),
(9459, 'cd04951', NULL, 'GT4_WbdM_like', NULL, NULL, 'GT4_WbdM_like', 9459),
(9460, 'cd12240', NULL, 'RRM_NCBP2', NULL, NULL, 'RRM_NCBP2', 9460),
(9461, 'cd03728', NULL, 'SOCS_ASB_9_11', NULL, NULL, 'SOCS_ASB_9_11', 9461),
(9462, 'cd15706', NULL, 'ePHD_JADE3', NULL, NULL, 'ePHD_JADE3', 9462),
(9463, 'cd07321', NULL, 'Extradiol_Dioxygenase_3A_like', NULL, NULL, 'Extradiol_Dioxygenase_3A_like', 9463),
(9464, 'cd07347', NULL, 'harmonin_N_like', NULL, NULL, 'harmonin_N_like', 9464),
(9465, 'cd15050', NULL, '7tmA_Histamine_H1R', NULL, NULL, '7tmA_Histamine_H1R', 9465),
(9466, 'cd04587', NULL, 'CBS_pair_CAP-ED_NT_Pol-beta-like_DUF294_assoc', NULL, NULL, 'CBS_pair_CAP-ED_NT_Pol-beta-like_DUF294_assoc', 9466),
(9467, 'cd10444', NULL, 'GIY-YIG_SegABCDEFG', NULL, NULL, 'GIY-YIG_SegABCDEFG', 9467),
(9468, 'cd02110', NULL, 'SO_family_Moco_dimer', NULL, NULL, 'SO_family_Moco_dimer', 9468),
(9469, 'cd04275', NULL, 'ZnMc_pappalysin_like', NULL, NULL, 'ZnMc_pappalysin_like', 9469),
(9470, 'cd09727', NULL, 'Cas6_I-E', NULL, NULL, 'Cas6_I-E', 9470),
(9471, 'cd10032', NULL, 'UDG-F6_HDG', NULL, NULL, 'UDG-F6_HDG', 9471),
(9472, 'cd09739', NULL, 'Cas6_I-F', NULL, NULL, 'Cas6_I-F', 9472),
(9473, 'cd00477', NULL, 'FTHFS', NULL, NULL, 'FTHFS', 9473),
(9474, 'cd10568', NULL, 'SWIB_like', NULL, NULL, 'SWIB_like', 9474),
(9475, 'cd16159', NULL, 'ES', NULL, NULL, 'ES', 9475),
(9476, 'cd01218', NULL, 'PH_Phafin2-like', NULL, NULL, 'PH_Phafin2-like', 9476),
(9477, 'cd01165', NULL, 'BTB_POZ', NULL, NULL, 'BTB_POZ', 9477);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(9478, 'cd11623', NULL, 'HR1_PKN_2', NULL, NULL, 'HR1_PKN_2', 9478),
(9479, 'cd16781', NULL, 'mRING-HC-C3HC3D_Roquin1', NULL, NULL, 'mRING-HC-C3HC3D_Roquin1', 9479),
(9480, 'cd08696', NULL, 'C2_Dock-C', NULL, NULL, 'C2_Dock-C', 9480),
(9481, 'cd12377', NULL, 'RRM3_Hu', NULL, NULL, 'RRM3_Hu', 9481),
(9482, 'cd16097', NULL, 'IgV_SIRP', NULL, NULL, 'IgV_SIRP', 9482),
(9483, 'cd15842', NULL, 'SNARE_Qb', NULL, NULL, 'SNARE_Qb', 9483),
(9484, 'cd17420', NULL, 'MFS_MCT8_10', NULL, NULL, 'MFS_MCT8_10', 9484),
(9485, 'cd07596', NULL, 'BAR_SNX', NULL, NULL, 'BAR_SNX', 9485),
(9486, 'cd16813', NULL, 'RING_CH-C4HC3_MARCH10', NULL, NULL, 'RING_CH-C4HC3_MARCH10', 9486),
(9487, 'cd05518', NULL, 'Bromo_polybromo_IV', NULL, NULL, 'Bromo_polybromo_IV', 9487),
(9488, 'cd15020', NULL, '7tm_TAS2R3', NULL, NULL, '7tm_TAS2R3', 9488),
(9489, 'cd09115', NULL, 'PLDc_PPK1_C2', NULL, NULL, 'PLDc_PPK1_C2', 9489),
(9490, 'cd13663', NULL, 'PBP2_PotD_PotF_like_2', NULL, NULL, 'PBP2_PotD_PotF_like_2', 9490),
(9491, 'cd11655', NULL, 'rap1_myb-like', NULL, NULL, 'rap1_myb-like', 9491),
(9492, 'cd13150', NULL, 'DAXX_histone_binding', NULL, NULL, 'DAXX_histone_binding', 9492),
(9493, 'cd19155', NULL, 'AKR_AKR1I_CgAKR1', NULL, NULL, 'AKR_AKR1I_CgAKR1', 9493),
(9494, 'cd00184', NULL, 'TNF', NULL, NULL, 'TNF', 9494),
(9495, 'cd10405', NULL, 'SH2_Vav1', NULL, NULL, 'SH2_Vav1', 9495),
(9496, 'cd00879', NULL, 'Sar1', NULL, NULL, 'Sar1', 9496),
(9497, 'cd14976', NULL, '7tmA_RNL3R', NULL, NULL, '7tmA_RNL3R', 9497),
(9498, 'cd16528', NULL, 'RING-HC_prokRING', NULL, NULL, 'RING-HC_prokRING', 9498),
(9499, 'cd07925', NULL, 'LigA_like_1', NULL, NULL, 'LigA_like_1', 9499),
(9500, 'cd00989', NULL, 'PDZ_metalloprotease', NULL, NULL, 'PDZ_metalloprotease', 9500),
(9501, 'cd07591', NULL, 'BAR_Rvs161p', NULL, NULL, 'BAR_Rvs161p', 9501),
(9502, 'cd11627', NULL, 'HR1_Ste20-like', NULL, NULL, 'HR1_Ste20-like', 9502),
(9503, 'cd06260', NULL, 'DUF820', NULL, NULL, 'DUF820', 9503),
(9504, 'cd06421', NULL, 'CESA_CelA_like', NULL, NULL, 'CESA_CelA_like', 9504),
(9505, 'cd14083', NULL, 'STKc_CaMKI', NULL, NULL, 'STKc_CaMKI', 9505),
(9506, 'cd12681', NULL, 'RRM_SKAR', NULL, NULL, 'RRM_SKAR', 9506),
(9507, 'cd00992', NULL, 'PDZ_signaling', NULL, NULL, 'PDZ_signaling', 9507),
(9508, 'cd08156', NULL, 'catalase_clade_3', NULL, NULL, 'catalase_clade_3', 9508),
(9509, 'cd09685', NULL, 'Cas7_I-A', NULL, NULL, 'Cas7_I-A', 9509),
(9510, 'cd14321', NULL, 'UBA_IAPs', NULL, NULL, 'UBA_IAPs', 9510),
(9511, 'cd15649', NULL, 'PHD1_NSD3', NULL, NULL, 'PHD1_NSD3', 9511),
(9512, 'cd00552', NULL, 'RaiA', NULL, NULL, 'RaiA', 9512),
(9513, 'cd14587', NULL, 'PTP-MTMR4', NULL, NULL, 'PTP-MTMR4', 9513),
(9514, 'cd08213', NULL, 'RuBisCO_large_III', NULL, NULL, 'RuBisCO_large_III', 9514),
(9515, 'cd09302', NULL, 'Jacalin_like', NULL, NULL, 'Jacalin_like', 9515),
(9516, 'cd13644', NULL, 'PBP2_HemC_archaea', NULL, NULL, 'PBP2_HemC_archaea', 9516),
(9517, 'cd01308', NULL, 'Isoaspartyl-dipeptidase', NULL, NULL, 'Isoaspartyl-dipeptidase', 9517),
(9518, 'cd00948', NULL, 'FBP_aldolase_I_a', NULL, NULL, 'FBP_aldolase_I_a', 9518),
(9519, 'cd00743', NULL, 'lipocalin_RBP_like', NULL, NULL, 'lipocalin_RBP_like', 9519),
(9520, 'cd17620', NULL, 'REC_OmpR_KdpE-like', NULL, NULL, 'REC_OmpR_KdpE-like', 9520),
(9521, 'cd12626', NULL, 'RRM1_IGF2BP2', NULL, NULL, 'RRM1_IGF2BP2', 9521),
(9522, 'cd10421', NULL, 'SH2_STAT5a', NULL, NULL, 'SH2_STAT5a', 9522),
(9523, 'cd16214', NULL, 'EFh_PI-PLCgamma1', NULL, NULL, 'EFh_PI-PLCgamma1', 9523),
(9524, 'cd12581', NULL, 'RRM2_hnRNPA2B1', NULL, NULL, 'RRM2_hnRNPA2B1', 9524),
(9525, 'cd11766', NULL, 'SH3_Nck_2', NULL, NULL, 'SH3_Nck_2', 9525),
(9526, 'cd08701', NULL, 'FMT_C_HypX', NULL, NULL, 'FMT_C_HypX', 9526),
(9527, 'cd14385', NULL, 'UBA1_spUBP14_like', NULL, NULL, 'UBA1_spUBP14_like', 9527),
(9528, 'cd05891', NULL, 'Ig_M-protein_C', NULL, NULL, 'Ig_M-protein_C', 9528),
(9529, 'cd17262', NULL, 'RMtype1_S_Aco12261I-TRD2-CR2', NULL, NULL, 'RMtype1_S_Aco12261I-TRD2-CR2', 9529),
(9530, 'cd16662', NULL, 'RING-Ubox2_NOSIP', NULL, NULL, 'RING-Ubox2_NOSIP', 9530);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(9531, 'cd04014', NULL, 'C2_PKC_epsilon', NULL, NULL, 'C2_PKC_epsilon', 9531),
(9532, 'cd17010', NULL, 'VHS_GGA2', NULL, NULL, 'VHS_GGA2', 9532),
(9533, 'cd16107', NULL, 'Ubl_AtUPL5_like', NULL, NULL, 'Ubl_AtUPL5_like', 9533),
(9534, 'cd19153', NULL, 'AKR_galDH-like', NULL, NULL, 'AKR_galDH-like', 9534),
(9535, 'cd18140', NULL, 'HLD_clamp_RFC', NULL, NULL, 'HLD_clamp_RFC', 9535),
(9536, 'cd05849', NULL, 'Ig1_Contactin-1', NULL, NULL, 'Ig1_Contactin-1', 9536),
(9537, 'cd00211', NULL, 'PTS_IIA_fru', NULL, NULL, 'PTS_IIA_fru', 9537),
(9538, 'cd11898', NULL, 'SH3_SNX9', NULL, NULL, 'SH3_SNX9', 9538),
(9539, 'cd15526', NULL, 'PHD1_MOZ_d4', NULL, NULL, 'PHD1_MOZ_d4', 9539),
(9540, 'cd08746', NULL, 'RGS_RGS20', NULL, NULL, 'RGS_RGS20', 9540),
(9541, 'cd05897', NULL, 'Ig2_IL1R2_like', NULL, NULL, 'Ig2_IL1R2_like', 9541),
(9542, 'cd17904', NULL, 'PFM_monalysin-like', NULL, NULL, 'PFM_monalysin-like', 9542),
(9543, 'cd00929', NULL, 'Cyt_c_Oxidase_VIIc', NULL, NULL, 'Cyt_c_Oxidase_VIIc', 9543),
(9544, 'cd07830', NULL, 'STKc_MAK_like', NULL, NULL, 'STKc_MAK_like', 9544),
(9545, 'cd00616', NULL, 'AHBA_syn', NULL, NULL, 'AHBA_syn', 9545),
(9546, 'cd07515', NULL, 'HAD-like', NULL, NULL, 'HAD-like', 9546),
(9547, 'cd03877', NULL, 'M28_like', NULL, NULL, 'M28_like', 9547),
(9548, 'cd16771', NULL, 'RING-HC_UNK', NULL, NULL, 'RING-HC_UNK', 9548),
(9549, 'cd18650', NULL, 'CD_HP1beta_Cbx1', NULL, NULL, 'CD_HP1beta_Cbx1', 9549),
(9550, 'cd00754', NULL, 'Ubl_MoaD', NULL, NULL, 'Ubl_MoaD', 9550),
(9551, 'cd11495', NULL, 'SLC5sbd_NIS-like_u3', NULL, NULL, 'SLC5sbd_NIS-like_u3', 9551),
(9552, 'cd01316', NULL, 'CAD_DHOase', NULL, NULL, 'CAD_DHOase', 9552),
(9553, 'cd16865', NULL, 'ARID_ARID1A-like', NULL, NULL, 'ARID_ARID1A-like', 9553),
(9554, 'cd01745', NULL, 'GATase1_2', NULL, NULL, 'GATase1_2', 9554),
(9555, 'cd01881', NULL, 'Obg_like', NULL, NULL, 'Obg_like', 9555),
(9556, 'cd12020', NULL, 'SH3_Tks5_5', NULL, NULL, 'SH3_Tks5_5', 9556),
(9557, 'cd18678', NULL, 'PIN_MtVapC25_VapC33-like', NULL, NULL, 'PIN_MtVapC25_VapC33-like', 9557),
(9558, 'cd09669', NULL, 'Cse1_I-E', NULL, NULL, 'Cse1_I-E', 9558),
(9559, 'cd01985', NULL, 'ETF', NULL, NULL, 'ETF', 9559),
(9560, 'cd09280', NULL, 'RNase_HI_eukaryote_like', NULL, NULL, 'RNase_HI_eukaryote_like', 9560),
(9561, 'cd02055', NULL, 'serpinA10_PZI', NULL, NULL, 'serpinA10_PZI', 9561),
(9562, 'cd07145', NULL, 'ALDH_LactADH_F420-Bios', NULL, NULL, 'ALDH_LactADH_F420-Bios', 9562),
(9563, 'cd17142', NULL, 'DCX2_DCX', NULL, NULL, 'DCX2_DCX', 9563),
(9564, 'cd11975', NULL, 'SH3_ARHGEF9', NULL, NULL, 'SH3_ARHGEF9', 9564),
(9565, 'cd19749', NULL, 'bHLH-O_DEC1', NULL, NULL, 'bHLH-O_DEC1', 9565),
(9566, 'cd09842', NULL, 'PLDc_vPLD1_1', NULL, NULL, 'PLDc_vPLD1_1', 9566),
(9567, 'cd16314', NULL, 'AIM-1-like_MBL-B3', NULL, NULL, 'AIM-1-like_MBL-B3', 9567),
(9568, 'cd04696', NULL, 'Nudix_Hydrolase_37', NULL, NULL, 'Nudix_Hydrolase_37', 9568),
(9569, 'cd10948', NULL, 'CE4_BsPdaA_like', NULL, NULL, 'CE4_BsPdaA_like', 9569),
(9570, 'cd00220', NULL, 'VMO-I', NULL, NULL, 'VMO-I', 9570),
(9571, 'cd15985', NULL, '7tmB1_GlucagonR-like_1', NULL, NULL, '7tmB1_GlucagonR-like_1', 9571),
(9572, 'cd17074', NULL, 'Ubl_CysO_like', NULL, NULL, 'Ubl_CysO_like', 9572),
(9573, 'cd17569', NULL, 'REC_HupR-like', NULL, NULL, 'REC_HupR-like', 9573),
(9574, 'cd08274', NULL, 'MDR9', NULL, NULL, 'MDR9', 9574),
(9575, 'cd04416', NULL, 'NDPk_TX', NULL, NULL, 'NDPk_TX', 9575),
(9576, 'cd02214', NULL, 'cupin_MJ1618', NULL, NULL, 'cupin_MJ1618', 9576),
(9577, 'cd12911', NULL, 'HK_sensor', NULL, NULL, 'HK_sensor', 9577),
(9578, 'cd13323', NULL, 'PH_PLEKHN1', NULL, NULL, 'PH_PLEKHN1', 9578),
(9579, 'cd08270', NULL, 'MDR4', NULL, NULL, 'MDR4', 9579),
(9580, 'cd05906', NULL, 'A_NRPS_TubE_like', NULL, NULL, 'A_NRPS_TubE_like', 9580),
(9581, 'cd13179', NULL, 'RanBD_RanBP1', NULL, NULL, 'RanBD_RanBP1', 9581),
(9582, 'cd00564', NULL, 'TMP_TenI', NULL, NULL, 'TMP_TenI', 9582),
(9583, 'cd06127', NULL, 'DEDDh', NULL, NULL, 'DEDDh', 9583),
(9584, 'cd17121', NULL, 'Ubl_UBTD2', NULL, NULL, 'Ubl_UBTD2', 9584),
(9585, 'cd12337', NULL, 'RRM1_SRSF4_like', NULL, NULL, 'RRM1_SRSF4_like', 9585);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(9586, 'cd15865', NULL, 'SNARE_SEC20', NULL, NULL, 'SNARE_SEC20', 9586),
(9587, 'cd04109', NULL, 'Rab28', NULL, NULL, 'Rab28', 9587),
(9588, 'cd05944', NULL, 'FACL_like_4', NULL, NULL, 'FACL_like_4', 9588),
(9589, 'cd06141', NULL, 'WRN_exo', NULL, NULL, 'WRN_exo', 9589),
(9590, 'cd19457', NULL, 'lipocalin_2-like', NULL, NULL, 'lipocalin_2-like', 9590),
(9591, 'cd05807', NULL, 'CBM20_CGTase', NULL, NULL, 'CBM20_CGTase', 9591),
(9592, 'cd10340', NULL, 'SH2_N-SH2_SHP_like', NULL, NULL, 'SH2_N-SH2_SHP_like', 9592),
(9593, 'cd12638', NULL, 'RRM3_CELF1_2', NULL, NULL, 'RRM3_CELF1_2', 9593),
(9594, 'cd02241', NULL, 'cupin_OxOx', NULL, NULL, 'cupin_OxOx', 9594),
(9595, 'cd02083', NULL, 'P-type_ATPase_SERCA', NULL, NULL, 'P-type_ATPase_SERCA', 9595),
(9596, 'cd11966', NULL, 'SH3_ASAP2', NULL, NULL, 'SH3_ASAP2', 9596),
(9597, 'cd05031', NULL, 'S-100A10_like', NULL, NULL, 'S-100A10_like', 9597),
(9598, 'cd12165', NULL, '2-Hacid_dh_6', NULL, NULL, '2-Hacid_dh_6', 9598),
(9599, 'cd17167', NULL, 'RAWUL_RING2', NULL, NULL, 'RAWUL_RING2', 9599),
(9600, 'cd07934', NULL, 'RHD-n_NFkB2', NULL, NULL, 'RHD-n_NFkB2', 9600),
(9601, 'cd18814', NULL, 'CAP_PI15', NULL, NULL, 'CAP_PI15', 9601),
(9602, 'cd14312', NULL, 'UBA_II_E2_UBC27_like', NULL, NULL, 'UBA_II_E2_UBC27_like', 9602),
(9603, 'cd17036', NULL, 'T3SC_YbjN-like_1', NULL, NULL, 'T3SC_YbjN-like_1', 9603),
(9604, 'cd18988', NULL, 'LGIC_ECD_bact', NULL, NULL, 'LGIC_ECD_bact', 9604),
(9605, 'cd10328', NULL, 'SLC5sbd_YidK', NULL, NULL, 'SLC5sbd_YidK', 9605),
(9606, 'cd11667', NULL, 'GH38N_Man2A2', NULL, NULL, 'GH38N_Man2A2', 9606),
(9607, 'cd04241', NULL, 'AAK_FomA-like', NULL, NULL, 'AAK_FomA-like', 9607),
(9608, 'cd08578', NULL, 'GDPD_NUC-2_fungi', NULL, NULL, 'GDPD_NUC-2_fungi', 9608),
(9609, 'cd18366', NULL, 'BTB_POZ_KCTD7', NULL, NULL, 'BTB_POZ_KCTD7', 9609),
(9610, 'cd03736', NULL, 'SOCS_SOCS2', NULL, NULL, 'SOCS_SOCS2', 9610),
(9611, 'cd05166', NULL, 'PI3Kc_II', NULL, NULL, 'PI3Kc_II', 9611),
(9612, 'cd11294', NULL, 'E_set_Esterase_like_N', NULL, NULL, 'E_set_Esterase_like_N', 9612),
(9613, 'cd16879', NULL, 'ARID_ARID3B', NULL, NULL, 'ARID_ARID3B', 9613),
(9614, 'cd00541', NULL, 'OMPLA', NULL, NULL, 'OMPLA', 9614),
(9615, 'cd03109', NULL, 'DTBS', NULL, NULL, 'DTBS', 9615),
(9616, 'cd04019', NULL, 'C2C_MCTP_PRT_plant', NULL, NULL, 'C2C_MCTP_PRT_plant', 9616),
(9617, 'cd03161', NULL, 'TM4SF2_6_like_LEL', NULL, NULL, 'TM4SF2_6_like_LEL', 9617),
(9618, 'cd07848', NULL, 'STKc_CDKL5', NULL, NULL, 'STKc_CDKL5', 9618),
(9619, 'cd05883', NULL, 'Ig2_Necl-2', NULL, NULL, 'Ig2_Necl-2', 9619),
(9620, 'cd19948', NULL, 'NasA-like_Fer2_BFD-like', NULL, NULL, 'NasA-like_Fer2_BFD-like', 9620),
(9621, 'cd15534', NULL, 'PHD2_PHF12_Rco1', NULL, NULL, 'PHD2_PHF12_Rco1', 9621),
(9622, 'cd03493', NULL, 'SQR_QFR_TM', NULL, NULL, 'SQR_QFR_TM', 9622),
(9623, 'cd09518', NULL, 'SAM_ANKS6', NULL, NULL, 'SAM_ANKS6', 9623),
(9624, 'cd11392', NULL, 'bHLH_ScPHO4_like', NULL, NULL, 'bHLH_ScPHO4_like', 9624),
(9625, 'cd01817', NULL, 'RBD1_RGS12_like', NULL, NULL, 'RBD1_RGS12_like', 9625),
(9626, 'cd02066', NULL, 'GRX_family', NULL, NULL, 'GRX_family', 9626),
(9627, 'cd18556', NULL, 'ABC_6TM_McjD_like', NULL, NULL, 'ABC_6TM_McjD_like', 9627),
(9628, 'cd14491', NULL, 'lipocalin_MxiM-like', NULL, NULL, 'lipocalin_MxiM-like', 9628),
(9629, 'cd01528', NULL, 'RHOD_2', NULL, NULL, 'RHOD_2', 9629),
(9630, 'cd06275', NULL, 'PBP1_PurR', NULL, NULL, 'PBP1_PurR', 9630),
(9631, 'cd07493', NULL, 'Peptidases_S8_9', NULL, NULL, 'Peptidases_S8_9', 9631),
(9632, 'cd19810', NULL, 'Bbox1_TRIM56_C-V', NULL, NULL, 'Bbox1_TRIM56_C-V', 9632),
(9633, 'cd07775', NULL, 'FGGY_AI-2K', NULL, NULL, 'FGGY_AI-2K', 9633),
(9634, 'cd13188', NULL, 'FERM_C_PTPN14_PTPN21', NULL, NULL, 'FERM_C_PTPN14_PTPN21', 9634),
(9635, 'cd10290', NULL, 'GST_C_MetRS_N_fungi', NULL, NULL, 'GST_C_MetRS_N_fungi', 9635),
(9636, 'cd07135', NULL, 'ALDH_F14-YMR110C', NULL, NULL, 'ALDH_F14-YMR110C', 9636),
(9637, 'cd16318', NULL, 'MUS_TUS_MBL-B1', NULL, NULL, 'MUS_TUS_MBL-B1', 9637),
(9638, 'cd19392', NULL, 'TGF_beta_DPP', NULL, NULL, 'TGF_beta_DPP', 9638);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(9639, 'cd14991', NULL, '7tmA_HCAR-like', NULL, NULL, '7tmA_HCAR-like', 9639),
(9640, 'cd00755', NULL, 'YgdL_like', NULL, NULL, 'YgdL_like', 9640),
(9641, 'cd17358', NULL, 'MFS_GLUT6_8_Class3_like', NULL, NULL, 'MFS_GLUT6_8_Class3_like', 9641),
(9642, 'cd14202', NULL, 'STKc_ULK1', NULL, NULL, 'STKc_ULK1', 9642),
(9643, 'cd12155', NULL, 'PGDH_1', NULL, NULL, 'PGDH_1', 9643),
(9644, 'cd16940', NULL, 'HATPase_BasS-like', NULL, NULL, 'HATPase_BasS-like', 9644),
(9645, 'cd18517', NULL, 'BACK_KLHL41_KBTBD10', NULL, NULL, 'BACK_KLHL41_KBTBD10', 9645),
(9646, 'cd16104', NULL, 'Ubl_USP14_like', NULL, NULL, 'Ubl_USP14_like', 9646),
(9647, 'cd09113', NULL, 'PLDc_ymdC_like_2', NULL, NULL, 'PLDc_ymdC_like_2', 9647),
(9648, 'cd03333', NULL, 'chaperonin_like', NULL, NULL, 'chaperonin_like', 9648),
(9649, 'cd04233', NULL, 'Auracyanin', NULL, NULL, 'Auracyanin', 9649),
(9650, 'cd07082', NULL, 'ALDH_F11_NP-GAPDH', NULL, NULL, 'ALDH_F11_NP-GAPDH', 9650),
(9651, 'cd02406', NULL, 'CRS2', NULL, NULL, 'CRS2', 9651),
(9652, 'cd07776', NULL, 'FGGY_D-XK_euk', NULL, NULL, 'FGGY_D-XK_euk', 9652),
(9653, 'cd09767', NULL, 'Csx17_I-U', NULL, NULL, 'Csx17_I-U', 9653),
(9654, 'cd05933', NULL, 'ACSBG_like', NULL, NULL, 'ACSBG_like', 9654),
(9655, 'cd11682', NULL, 'HDAC6-dom1', NULL, NULL, 'HDAC6-dom1', 9655),
(9656, 'cd14219', NULL, 'STKc_BMPR1b', NULL, NULL, 'STKc_BMPR1b', 9656),
(9657, 'cd06129', NULL, 'RNaseD_like', NULL, NULL, 'RNaseD_like', 9657),
(9658, 'cd10325', NULL, 'SLC5sbd_vSGLT', NULL, NULL, 'SLC5sbd_vSGLT', 9658),
(9659, 'cd14182', NULL, 'STKc_PhKG1', NULL, NULL, 'STKc_PhKG1', 9659),
(9660, 'cd17727', NULL, 'BRCT_TopBP1_rpt6', NULL, NULL, 'BRCT_TopBP1_rpt6', 9660),
(9661, 'cd14273', NULL, 'UBA_TAP-C_like', NULL, NULL, 'UBA_TAP-C_like', 9661),
(9662, 'cd07606', NULL, 'BAR_SFC_plant', NULL, NULL, 'BAR_SFC_plant', 9662),
(9663, 'cd08737', NULL, 'RGS_RGS6', NULL, NULL, 'RGS_RGS6', 9663),
(9664, 'cd11947', NULL, 'SH3_GRAP2_N', NULL, NULL, 'SH3_GRAP2_N', 9664),
(9665, 'cd10297', NULL, 'GST_C_CLIC5', NULL, NULL, 'GST_C_CLIC5', 9665),
(9666, 'cd07512', NULL, 'HAD_PGPase', NULL, NULL, 'HAD_PGPase', 9666),
(9667, 'cd18693', NULL, 'PIN_VapC-like', NULL, NULL, 'PIN_VapC-like', 9667),
(9668, 'cd03032', NULL, 'ArsC_Spx', NULL, NULL, 'ArsC_Spx', 9668),
(9669, 'cd18500', NULL, 'BACK_IBtk', NULL, NULL, 'BACK_IBtk', 9669),
(9670, 'cd16868', NULL, 'ARID_ARID4', NULL, NULL, 'ARID_ARID4', 9670),
(9671, 'cd09152', NULL, 'PLDc_EcCLS_like_1', NULL, NULL, 'PLDc_EcCLS_like_1', 9671),
(9672, 'cd12472', NULL, 'RRM1_RBMS3', NULL, NULL, 'RRM1_RBMS3', 9672),
(9673, 'cd01376', NULL, 'KISc_KID_like', NULL, NULL, 'KISc_KID_like', 9673),
(9674, 'cd12753', NULL, 'RRM1_RBM10', NULL, NULL, 'RRM1_RBM10', 9674),
(9675, 'cd16114', NULL, 'Ubl_SUMO1', NULL, NULL, 'Ubl_SUMO1', 9675),
(9676, 'cd09373', NULL, 'LIM1_AWH', NULL, NULL, 'LIM1_AWH', 9676),
(9677, 'cd19926', NULL, 'REC_PilR', NULL, NULL, 'REC_PilR', 9677),
(9678, 'cd16757', NULL, 'RING-HC_TRIM46', NULL, NULL, 'RING-HC_TRIM46', 9678),
(9679, 'cd05624', NULL, 'STKc_MRCK_beta', NULL, NULL, 'STKc_MRCK_beta', 9679),
(9680, 'cd04406', NULL, 'RhoGAP_myosin_IXA', NULL, NULL, 'RhoGAP_myosin_IXA', 9680),
(9681, 'cd15239', NULL, '7tm_YRO2_fungal-like', NULL, NULL, '7tm_YRO2_fungal-like', 9681),
(9682, 'cd15893', NULL, 'R-SNARE_STXBP5', NULL, NULL, 'R-SNARE_STXBP5', 9682),
(9683, 'cd09701', NULL, 'Cas10_III', NULL, NULL, 'Cas10_III', 9683),
(9684, 'cd17132', NULL, 'Ubl_TMUB2', NULL, NULL, 'Ubl_TMUB2', 9684),
(9685, 'cd10025', NULL, '14-3-3_eta', NULL, NULL, '14-3-3_eta', 9685),
(9686, 'cd16916', NULL, 'HATPase_CheA-like', NULL, NULL, 'HATPase_CheA-like', 9686),
(9687, 'cd11349', NULL, 'AmyAc_3', NULL, NULL, 'AmyAc_3', 9687),
(9688, 'cd01214', NULL, 'PTB_FAM43A', NULL, NULL, 'PTB_FAM43A', 9688),
(9689, 'cd09578', NULL, 'SAM_Scm', NULL, NULL, 'SAM_Scm', 9689),
(9690, 'cd08755', NULL, 'RGS_p115RhoGEF', NULL, NULL, 'RGS_p115RhoGEF', 9690),
(9691, 'cd13301', NULL, 'PH1_Pleckstrin_2', NULL, NULL, 'PH1_Pleckstrin_2', 9691),
(9692, 'cd08787', NULL, 'CARD_NOD2_1_CARD15', NULL, NULL, 'CARD_NOD2_1_CARD15', 9692),
(9693, 'cd21414', NULL, 'unc_rv_SF1_Hel-like', NULL, NULL, 'unc_rv_SF1_Hel-like', 9693);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(9694, 'cd16149', NULL, 'sulfatase_like', NULL, NULL, 'sulfatase_like', 9694),
(9695, 'cd05805', NULL, 'MPG1_transferase', NULL, NULL, 'MPG1_transferase', 9695),
(9696, 'cd12404', NULL, 'RRM2_NCL', NULL, NULL, 'RRM2_NCL', 9696),
(9697, 'cd15379', NULL, '7tmA_P2Y6', NULL, NULL, '7tmA_P2Y6', 9697),
(9698, 'cd02231', NULL, 'cupin_BLL6423-like', NULL, NULL, 'cupin_BLL6423-like', 9698),
(9699, 'cd05264', NULL, 'UDP_G4E_5_SDR_e', NULL, NULL, 'UDP_G4E_5_SDR_e', 9699),
(9700, 'cd12794', NULL, 'Hsm3_like', NULL, NULL, 'Hsm3_like', 9700),
(9701, 'cd05151', NULL, 'ChoK-like', NULL, NULL, 'ChoK-like', 9701),
(9702, 'cd14352', NULL, 'UBA_DCN1', NULL, NULL, 'UBA_DCN1', 9702),
(9703, 'cd12552', NULL, 'RRM_Nop15p', NULL, NULL, 'RRM_Nop15p', 9703),
(9704, 'cd18268', NULL, 'BTB_POZ_KLHL38', NULL, NULL, 'BTB_POZ_KLHL38', 9704),
(9705, 'cd18319', NULL, 'BTB_POZ_KLHL42', NULL, NULL, 'BTB_POZ_KLHL42', 9705),
(9706, 'cd07300', NULL, 'PX_SNX20', NULL, NULL, 'PX_SNX20', 9706),
(9707, 'cd11290', NULL, 'gelsolin_S1_like', NULL, NULL, 'gelsolin_S1_like', 9707),
(9708, 'cd07601', NULL, 'BAR_APPL', NULL, NULL, 'BAR_APPL', 9708),
(9709, 'cd07490', NULL, 'Peptidases_S8_6', NULL, NULL, 'Peptidases_S8_6', 9709),
(9710, 'cd18963', NULL, 'chromodomain', NULL, NULL, 'chromodomain', 9710),
(9711, 'cd01221', NULL, 'PH_ephexin', NULL, NULL, 'PH_ephexin', 9711),
(9712, 'cd08490', NULL, 'PBP2_NikA_DppA_OppA_like_3', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_3', 9712),
(9713, 'cd06919', NULL, 'Asp_decarbox', NULL, NULL, 'Asp_decarbox', 9713),
(9714, 'cd00215', NULL, 'PTS_IIA_lac', NULL, NULL, 'PTS_IIA_lac', 9714),
(9715, 'cd16291', NULL, 'INTS11-like_MBL-fold', NULL, NULL, 'INTS11-like_MBL-fold', 9715),
(9716, 'cd11968', NULL, 'SH3_SASH3', NULL, NULL, 'SH3_SASH3', 9716),
(9717, 'cd00361', NULL, 'arom_aa_hydroxylase', NULL, NULL, 'arom_aa_hydroxylase', 9717),
(9718, 'cd19845', NULL, 'Bbox1_TIF1a_C-VI', NULL, NULL, 'Bbox1_TIF1a_C-VI', 9718),
(9719, 'cd12486', NULL, 'RRM1_ACF', NULL, NULL, 'RRM1_ACF', 9719),
(9720, 'cd18316', NULL, 'BTB_POZ_KCTD-like', NULL, NULL, 'BTB_POZ_KCTD-like', 9720),
(9721, 'cd03278', NULL, 'ABC_SMC_barmotin', NULL, NULL, 'ABC_SMC_barmotin', 9721),
(9722, 'cd11828', NULL, 'SH3_ARHGEF9_like', NULL, NULL, 'SH3_ARHGEF9_like', 9722),
(9723, 'cd09624', NULL, 'DOMON_b558_566', NULL, NULL, 'DOMON_b558_566', 9723),
(9724, 'cd13768', NULL, 'DSS1_Sem1', NULL, NULL, 'DSS1_Sem1', 9724),
(9725, 'cd16755', NULL, 'RING-HC_TRIM9', NULL, NULL, 'RING-HC_TRIM9', 9725),
(9726, 'cd18699', NULL, 'PIN_VapC_like', NULL, NULL, 'PIN_VapC_like', 9726),
(9727, 'cd11408', NULL, 'bHLH-O_HELT', NULL, NULL, 'bHLH-O_HELT', 9727),
(9728, 'cd13679', NULL, 'PBP2_TRAP_YiaO_like', NULL, NULL, 'PBP2_TRAP_YiaO_like', 9728),
(9729, 'cd06999', NULL, 'cupin_HpaA-like_N', NULL, NULL, 'cupin_HpaA-like_N', 9729),
(9730, 'cd14793', NULL, 'DUF302_like', NULL, NULL, 'DUF302_like', 9730),
(9731, 'cd01732', NULL, 'LSm5', NULL, NULL, 'LSm5', 9731),
(9732, 'cd09318', NULL, 'TDT_SSU1', NULL, NULL, 'TDT_SSU1', 9732),
(9733, 'cd18571', NULL, 'ABC_6TM_peptidase_like', NULL, NULL, 'ABC_6TM_peptidase_like', 9733),
(9734, 'cd00882', NULL, 'Ras_like_GTPase', NULL, NULL, 'Ras_like_GTPase', 9734),
(9735, 'cd13187', NULL, 'FERM_C_PTPH13', NULL, NULL, 'FERM_C_PTPH13', 9735),
(9736, 'cd06542', NULL, 'GH18_EndoS-like', NULL, NULL, 'GH18_EndoS-like', 9736),
(9737, 'cd14207', NULL, 'PTKc_VEGFR1', NULL, NULL, 'PTKc_VEGFR1', 9737),
(9738, 'cd14887', NULL, 'MYSc_Myo26', NULL, NULL, 'MYSc_Myo26', 9738),
(9739, 'cd17117', NULL, 'RA_ANKFN1_like', NULL, NULL, 'RA_ANKFN1_like', 9739),
(9740, 'cd07038', NULL, 'TPP_PYR_PDC_IPDC_like', NULL, NULL, 'TPP_PYR_PDC_IPDC_like', 9740),
(9741, 'cd15633', NULL, 'PHD_PHF20L1', NULL, NULL, 'PHD_PHF20L1', 9741),
(9742, 'cd11282', NULL, 'ADF_coactosin_like', NULL, NULL, 'ADF_coactosin_like', 9742),
(9743, 'cd15392', NULL, '7tmA_PR4-like', NULL, NULL, '7tmA_PR4-like', 9743),
(9744, 'cd13378', NULL, 'PH_RhoGAP2', NULL, NULL, 'PH_RhoGAP2', 9744),
(9745, 'cd15845', NULL, 'SNARE_syntaxin16', NULL, NULL, 'SNARE_syntaxin16', 9745),
(9746, 'cd04983', NULL, 'IgV_TCR_alpha', NULL, NULL, 'IgV_TCR_alpha', 9746);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(9747, 'cd09458', NULL, 'LIM3_Enigma', NULL, NULL, 'LIM3_Enigma', 9747),
(9748, 'cd11874', NULL, 'SH3_CD2AP-like_2', NULL, NULL, 'SH3_CD2AP-like_2', 9748),
(9749, 'cd15916', NULL, '7tmA_OR10G-like', NULL, NULL, '7tmA_OR10G-like', 9749),
(9750, 'cd09007', NULL, 'NP-I_spr0068', NULL, NULL, 'NP-I_spr0068', 9750),
(9751, 'cd08171', NULL, 'GlyDH-like', NULL, NULL, 'GlyDH-like', 9751),
(9752, 'cd06270', NULL, 'PBP1_GalS-like', NULL, NULL, 'PBP1_GalS-like', 9752),
(9753, 'cd02522', NULL, 'GT_2_like_a', NULL, NULL, 'GT_2_like_a', 9753),
(9754, 'cd03151', NULL, 'CD81_like_LEL', NULL, NULL, 'CD81_like_LEL', 9754),
(9755, 'cd08804', NULL, 'Death_ank2', NULL, NULL, 'Death_ank2', 9755),
(9756, 'cd09759', NULL, 'Cas6_I-A', NULL, NULL, 'Cas6_I-A', 9756),
(9757, 'cd21171', NULL, 'NTD_alpha_beta_cv_Nsp15-like', NULL, NULL, 'NTD_alpha_beta_cv_Nsp15-like', 9757),
(9758, 'cd16195', NULL, 'EFh_PEF_CAPN13_14', NULL, NULL, 'EFh_PEF_CAPN13_14', 9758),
(9759, 'cd00553', NULL, 'NAD_synthase', NULL, NULL, 'NAD_synthase', 9759),
(9760, 'cd20208', NULL, 'Bbox1_DUF2009', NULL, NULL, 'Bbox1_DUF2009', 9760),
(9761, 'cd01850', NULL, 'CDC_Septin', NULL, NULL, 'CDC_Septin', 9761),
(9762, 'cd04094', NULL, 'eSelB_III', NULL, NULL, 'eSelB_III', 9762),
(9763, 'cd00460', NULL, 'RNAP_RPB11_RPB3', NULL, NULL, 'RNAP_RPB11_RPB3', 9763),
(9764, 'cd16184', NULL, 'EFh_PEF_peflin', NULL, NULL, 'EFh_PEF_peflin', 9764),
(9765, 'cd05573', NULL, 'STKc_ROCK_NDR_like', NULL, NULL, 'STKc_ROCK_NDR_like', 9765),
(9766, 'cd03223', NULL, 'ABCD_peroxisomal_ALDP', NULL, NULL, 'ABCD_peroxisomal_ALDP', 9766),
(9767, 'cd05160', NULL, 'DEDDy_DNA_polB_exo', NULL, NULL, 'DEDDy_DNA_polB_exo', 9767),
(9768, 'cd16226', NULL, 'EFh_CREC_Calumenin_like', NULL, NULL, 'EFh_CREC_Calumenin_like', 9768),
(9769, 'cd15589', NULL, 'PHD1_KMT2B', NULL, NULL, 'PHD1_KMT2B', 9769),
(9770, 'cd10416', NULL, 'SH2_SH2D2A', NULL, NULL, 'SH2_SH2D2A', 9770),
(9771, 'cd12821', NULL, 'EcCorA_ZntB-like', NULL, NULL, 'EcCorA_ZntB-like', 9771),
(9772, 'cd18036', NULL, 'DEXHc_RLR', NULL, NULL, 'DEXHc_RLR', 9772),
(9773, 'cd18415', NULL, 'BTB_KCNC2_4', NULL, NULL, 'BTB_KCNC2_4', 9773),
(9774, 'cd03791', NULL, 'GT5_Glycogen_synthase_DULL1-like', NULL, NULL, 'GT5_Glycogen_synthase_DULL1-like', 9774),
(9775, 'cd07859', NULL, 'STKc_TDY_MAPK', NULL, NULL, 'STKc_TDY_MAPK', 9775),
(9776, 'cd18684', NULL, 'PIN_VapC-like', NULL, NULL, 'PIN_VapC-like', 9776),
(9777, 'cd16726', NULL, 'RING1-HC_MIB2', NULL, NULL, 'RING1-HC_MIB2', 9777),
(9778, 'cd19107', NULL, 'AKR_AKR1B1-19', NULL, NULL, 'AKR_AKR1B1-19', 9778),
(9779, 'cd08066', NULL, 'MPN_AMSH_like', NULL, NULL, 'MPN_AMSH_like', 9779),
(9780, 'cd06950', NULL, 'NR_LBD_Tlx_PNR_like', NULL, NULL, 'NR_LBD_Tlx_PNR_like', 9780),
(9781, 'cd11273', NULL, 'Sema_plexin_A3', NULL, NULL, 'Sema_plexin_A3', 9781),
(9782, 'cd14896', NULL, 'MYSc_Myo35', NULL, NULL, 'MYSc_Myo35', 9782),
(9783, 'cd19689', NULL, 'bHLHzip_MLXIPL', NULL, NULL, 'bHLHzip_MLXIPL', 9783),
(9784, 'cd20307', NULL, 'cupin_BacB_N', NULL, NULL, 'cupin_BacB_N', 9784),
(9785, 'cd19584', NULL, 'serpinO_SPI-3_virus', NULL, NULL, 'serpinO_SPI-3_virus', 9785),
(9786, 'cd14270', NULL, 'UBA', NULL, NULL, 'UBA', 9786),
(9787, 'cd12095', NULL, 'TM_ErbB3', NULL, NULL, 'TM_ErbB3', 9787),
(9788, 'cd17413', NULL, 'MFS_NPF6', NULL, NULL, 'MFS_NPF6', 9788),
(9789, 'cd07041', NULL, 'STAS_RsbR_RsbS_like', NULL, NULL, 'STAS_RsbR_RsbS_like', 9789),
(9790, 'cd15982', NULL, '7tmB1_PTH2R', NULL, NULL, '7tmB1_PTH2R', 9790),
(9791, 'cd05278', NULL, 'FDH_like', NULL, NULL, 'FDH_like', 9791),
(9792, 'cd08744', NULL, 'RGS_RGS17', NULL, NULL, 'RGS_RGS17', 9792),
(9793, 'cd17240', NULL, 'RA_PHLPP1', NULL, NULL, 'RA_PHLPP1', 9793),
(9794, 'cd20273', NULL, 'Complex1_LYR_unchar', NULL, NULL, 'Complex1_LYR_unchar', 9794),
(9795, 'cd02866', NULL, 'PseudoU_synth_TruA_Archea', NULL, NULL, 'PseudoU_synth_TruA_Archea', 9795),
(9796, 'cd06630', NULL, 'STKc_MEKK1', NULL, NULL, 'STKc_MEKK1', 9796),
(9797, 'cd12640', NULL, 'RRM3_Bruno_like', NULL, NULL, 'RRM3_Bruno_like', 9797),
(9798, 'cd12401', NULL, 'RRM_eIF4H', NULL, NULL, 'RRM_eIF4H', 9798);
INSERT INTO "PUBLIC"."MODEL" VALUES
(9799, 'cd03206', NULL, 'GST_C_7', NULL, NULL, 'GST_C_7', 9799),
(9800, 'cd09534', NULL, 'SAM_Ste11_fungal', NULL, NULL, 'SAM_Ste11_fungal', 9800),
(9801, 'cd12156', NULL, 'HPPR', NULL, NULL, 'HPPR', 9801),
(9802, 'cd10016', NULL, 'EcoRII_N', NULL, NULL, 'EcoRII_N', 9802),
(9803, 'cd12273', NULL, 'RRM1_NEFsp', NULL, NULL, 'RRM1_NEFsp', 9803),
(9804, 'cd17951', NULL, 'DEADc_DDX41', NULL, NULL, 'DEADc_DDX41', 9804),
(9805, 'cd19855', NULL, 'DSRM_DHX9_rpt2', NULL, NULL, 'DSRM_DHX9_rpt2', 9805),
(9806, 'cd17949', NULL, 'DEADc_DDX31', NULL, NULL, 'DEADc_DDX31', 9806),
(9807, 'cd02990', NULL, 'UAS_FAF1', NULL, NULL, 'UAS_FAF1', 9807),
(9808, 'cd09291', NULL, 'Photo-RC_M', NULL, NULL, 'Photo-RC_M', 9808),
(9809, 'cd12441', NULL, 'RRM_Nup53_like', NULL, NULL, 'RRM_Nup53_like', 9809),
(9810, 'cd02503', NULL, 'MobA', NULL, NULL, 'MobA', 9810),
(9811, 'cd14756', NULL, 'TrHb', NULL, NULL, 'TrHb', 9811),
(9812, 'cd14373', NULL, 'CUE_Cue3p_like', NULL, NULL, 'CUE_Cue3p_like', 9812),
(9813, 'cd17069', NULL, 'DCX2', NULL, NULL, 'DCX2', 9813),
(9814, 'cd07858', NULL, 'STKc_TEY_MAPK', NULL, NULL, 'STKc_TEY_MAPK', 9814),
(9815, 'cd02652', NULL, 'nuc_hydro_2', NULL, NULL, 'nuc_hydro_2', 9815),
(9816, 'cd01946', NULL, 'ribokinase_group_C', NULL, NULL, 'ribokinase_group_C', 9816),
(9817, 'cd02774', NULL, 'MopB_Res-Cmplx1_Nad11-M', NULL, NULL, 'MopB_Res-Cmplx1_Nad11-M', 9817),
(9818, 'cd13238', NULL, 'PH2_FGD4_insect-like', NULL, NULL, 'PH2_FGD4_insect-like', 9818),
(9819, 'cd16609', NULL, 'RING-HC_TRIM65_C-IV', NULL, NULL, 'RING-HC_TRIM65_C-IV', 9819),
(9820, 'cd10153', NULL, 'RcnR-FrmR-like_DUF156', NULL, NULL, 'RcnR-FrmR-like_DUF156', 9820),
(9821, 'cd12414', NULL, 'RRM2_RBM28_like', NULL, NULL, 'RRM2_RBM28_like', 9821),
(9822, 'cd00768', NULL, 'class_II_aaRS-like_core', NULL, NULL, 'class_II_aaRS-like_core', 9822),
(9823, 'cd05752', NULL, 'Ig1_FcgammaR_like', NULL, NULL, 'Ig1_FcgammaR_like', 9823),
(9824, 'cd14298', NULL, 'UBA2_scUBP14_like', NULL, NULL, 'UBA2_scUBP14_like', 9824),
(9825, 'cd02230', NULL, 'cupin_HP0902-like', NULL, NULL, 'cupin_HP0902-like', 9825),
(9826, 'cd12454', NULL, 'RRM2_RIM4_like', NULL, NULL, 'RRM2_RIM4_like', 9826),
(9827, 'cd08177', NULL, 'MAR', NULL, NULL, 'MAR', 9827),
(9828, 'cd01337', NULL, 'MDH_glyoxysomal_mitochondrial', NULL, NULL, 'MDH_glyoxysomal_mitochondrial', 9828),
(9829, 'cd19544', NULL, 'E-C_NRPS', NULL, NULL, 'E-C_NRPS', 9829),
(9830, 'cd13988', NULL, 'STKc_TBK1', NULL, NULL, 'STKc_TBK1', 9830),
(9831, 'cd03786', NULL, 'GTB_UDP-GlcNAc_2-Epimerase', NULL, NULL, 'GTB_UDP-GlcNAc_2-Epimerase', 9831),
(9832, 'cd09967', NULL, 'UP_II', NULL, NULL, 'UP_II', 9832),
(9833, 'cd19774', NULL, 'Bbox2_TRIM23_C-IX_rpt2', NULL, NULL, 'Bbox2_TRIM23_C-IX_rpt2', 9833),
(9834, 'cd07040', NULL, 'HP', NULL, NULL, 'HP', 9834),
(9835, 'cd13623', NULL, 'PBP2_AA_hypothetical', NULL, NULL, 'PBP2_AA_hypothetical', 9835),
(9836, 'cd11614', NULL, 'SAF_CpaB_FlgA_like', NULL, NULL, 'SAF_CpaB_FlgA_like', 9836),
(9837, 'cd15559', NULL, 'PHD1_BPTF', NULL, NULL, 'PHD1_BPTF', 9837),
(9838, 'cd16908', NULL, 'YEATS_Yaf9_like', NULL, NULL, 'YEATS_Yaf9_like', 9838),
(9839, 'cd16485', NULL, 'mRING-H2-C3H2C2D_RBX1', NULL, NULL, 'mRING-H2-C3H2C2D_RBX1', 9839),
(9840, 'cd19878', NULL, 'DSRM_AtDRB-like', NULL, NULL, 'DSRM_AtDRB-like', 9840),
(9841, 'cd10011', NULL, 'HDAC2', NULL, NULL, 'HDAC2', 9841),
(9842, 'cd01483', NULL, 'E1_enzyme_family', NULL, NULL, 'E1_enzyme_family', 9842),
(9843, 'cd18592', NULL, 'ABC_6TM_MRP5_8_9_D1', NULL, NULL, 'ABC_6TM_MRP5_8_9_D1', 9843),
(9844, 'cd04927', NULL, 'ACT_ACR-like_2', NULL, NULL, 'ACT_ACR-like_2', 9844),
(9845, 'cd09821', NULL, 'An_peroxidase_bacterial_2', NULL, NULL, 'An_peroxidase_bacterial_2', 9845),
(9846, 'cd01380', NULL, 'MYSc_Myo5', NULL, NULL, 'MYSc_Myo5', 9846),
(9847, 'cd20251', NULL, 'Complex1_LYR_SF', NULL, NULL, 'Complex1_LYR_SF', 9847),
(9848, 'cd07767', NULL, 'MPN', NULL, NULL, 'MPN', 9848),
(9849, 'cd08348', NULL, 'BphC2-C3-RGP6_C_like', NULL, NULL, 'BphC2-C3-RGP6_C_like', 9849),
(9850, 'cd07841', NULL, 'STKc_CDK7', NULL, NULL, 'STKc_CDK7', 9850),
(9851, 'cd09853', NULL, 'PIN_FEN-like', NULL, NULL, 'PIN_FEN-like', 9851);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(9852, 'cd15941', NULL, '7tmA_OR10S1-like', NULL, NULL, '7tmA_OR10S1-like', 9852),
(9853, 'cd04887', NULL, 'ACT_MalLac-Enz', NULL, NULL, 'ACT_MalLac-Enz', 9853),
(9854, 'cd14679', NULL, 'PH_p115RhoGEF', NULL, NULL, 'PH_p115RhoGEF', 9854),
(9855, 'cd08623', NULL, 'PI-PLCc_beta1', NULL, NULL, 'PI-PLCc_beta1', 9855),
(9856, 'cd18711', NULL, 'PIN_VapC-like_DUF411', NULL, NULL, 'PIN_VapC-like_DUF411', 9856),
(9857, 'cd14690', NULL, 'bZIP_CREB1', NULL, NULL, 'bZIP_CREB1', 9857),
(9858, 'cd00418', NULL, 'GlxRS_core', NULL, NULL, 'GlxRS_core', 9858),
(9859, 'cd00219', NULL, 'ToxGAP', NULL, NULL, 'ToxGAP', 9859),
(9860, 'cd13648', NULL, 'PBP2_PBGD_1', NULL, NULL, 'PBP2_PBGD_1', 9860),
(9861, 'cd13761', NULL, 'TGF_beta_BMP5_like', NULL, NULL, 'TGF_beta_BMP5_like', 9861),
(9862, 'cd18456', NULL, 'BACK_KLHL17', NULL, NULL, 'BACK_KLHL17', 9862),
(9863, 'cd08282', NULL, 'PFDH_like', NULL, NULL, 'PFDH_like', 9863),
(9864, 'cd07067', NULL, 'HP_PGM_like', NULL, NULL, 'HP_PGM_like', 9864),
(9865, 'cd02259', NULL, 'Peptidase_C39_like', NULL, NULL, 'Peptidase_C39_like', 9865),
(9866, 'cd11305', NULL, 'alpha_DG_C', NULL, NULL, 'alpha_DG_C', 9866),
(9867, 'cd14956', NULL, 'NHL_like_3', NULL, NULL, 'NHL_like_3', 9867),
(9868, 'cd14110', NULL, 'STKc_obscurin_rpt2', NULL, NULL, 'STKc_obscurin_rpt2', 9868),
(9869, 'cd04758', NULL, 'Commd10', NULL, NULL, 'Commd10', 9869),
(9870, 'cd09011', NULL, 'VOC_like', NULL, NULL, 'VOC_like', 9870),
(9871, 'cd14978', NULL, '7tmA_FMRFamide_R-like', NULL, NULL, '7tmA_FMRFamide_R-like', 9871),
(9872, 'cd08151', NULL, 'AOS', NULL, NULL, 'AOS', 9872),
(9873, 'cd05136', NULL, 'RasGAP_DAB2IP', NULL, NULL, 'RasGAP_DAB2IP', 9873),
(9874, 'cd10052', NULL, 'Reelin_repeat_8_subrepeat_2', NULL, NULL, 'Reelin_repeat_8_subrepeat_2', 9874),
(9875, 'cd03856', NULL, 'M14_Nna1-like', NULL, NULL, 'M14_Nna1-like', 9875),
(9876, 'cd08336', NULL, 'DED_FADD', NULL, NULL, 'DED_FADD', 9876),
(9877, 'cd15693', NULL, 'ePHD_KMT2A', NULL, NULL, 'ePHD_KMT2A', 9877),
(9878, 'cd12266', NULL, 'RRM_like_XS', NULL, NULL, 'RRM_like_XS', 9878),
(9879, 'cd09270', NULL, 'RNase_H2-B', NULL, NULL, 'RNase_H2-B', 9879),
(9880, 'cd20288', NULL, 'cupin_pirin-like_C', NULL, NULL, 'cupin_pirin-like_C', 9880),
(9881, 'cd15122', NULL, '7tmA_LTB4R2', NULL, NULL, '7tmA_LTB4R2', 9881),
(9882, 'cd03395', NULL, 'PAP2_like_4', NULL, NULL, 'PAP2_like_4', 9882),
(9883, 'cd17027', NULL, 'T3SC_IA_YscB_AscB-like', NULL, NULL, 'T3SC_IA_YscB_AscB-like', 9883),
(9884, 'cd03263', NULL, 'ABC_subfamily_A', NULL, NULL, 'ABC_subfamily_A', 9884),
(9885, 'cd05058', NULL, 'PTKc_Met_Ron', NULL, NULL, 'PTKc_Met_Ron', 9885),
(9886, 'cd09176', NULL, 'PLDc_unchar6', NULL, NULL, 'PLDc_unchar6', 9886),
(9887, 'cd01560', NULL, 'Thr-synth_2', NULL, NULL, 'Thr-synth_2', 9887),
(9888, 'cd19594', NULL, 'serpin_crustaceans_chelicerates_insects', NULL, NULL, 'serpin_crustaceans_chelicerates_insects', 9888),
(9889, 'cd04748', NULL, 'Commd', NULL, NULL, 'Commd', 9889),
(9890, 'cd19460', NULL, 'CRABP1', NULL, NULL, 'CRABP1', 9890),
(9891, 'cd16020', NULL, 'GPI_EPT_1', NULL, NULL, 'GPI_EPT_1', 9891),
(9892, 'cd19080', NULL, 'AKR_AKR9A_9B', NULL, NULL, 'AKR_AKR9A_9B', 9892),
(9893, 'cd11797', NULL, 'SH3_DNMBP_N4', NULL, NULL, 'SH3_DNMBP_N4', 9893),
(9894, 'cd06192', NULL, 'DHOD_e_trans_like', NULL, NULL, 'DHOD_e_trans_like', 9894),
(9895, 'cd11470', NULL, 'bHLH_TS_TCF15_paraxis', NULL, NULL, 'bHLH_TS_TCF15_paraxis', 9895),
(9896, 'cd16574', NULL, 'RING-HC_Topors', NULL, NULL, 'RING-HC_Topors', 9896),
(9897, 'cd17740', NULL, 'BRCT_Rad4_rpt1', NULL, NULL, 'BRCT_Rad4_rpt1', 9897),
(9898, 'cd20245', NULL, 'humanin', NULL, NULL, 'humanin', 9898),
(9899, 'cd05177', NULL, 'PI3Kc_C2_gamma', NULL, NULL, 'PI3Kc_C2_gamma', 9899),
(9900, 'cd15640', NULL, 'PHD_KDM7', NULL, NULL, 'PHD_KDM7', 9900),
(9901, 'cd19218', NULL, 'SET_EZH2', NULL, NULL, 'SET_EZH2', 9901),
(9902, 'cd16572', NULL, 'RING-HC_SpRad8_like', NULL, NULL, 'RING-HC_SpRad8_like', 9902),
(9903, 'cd02510', NULL, 'pp-GalNAc-T', NULL, NULL, 'pp-GalNAc-T', 9903),
(9904, 'cd12327', NULL, 'RRM2_DAZAP1', NULL, NULL, 'RRM2_DAZAP1', 9904);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(9905, 'cd07129', NULL, 'ALDH_KGSADH', NULL, NULL, 'ALDH_KGSADH', 9905),
(9906, 'cd16337', NULL, 'MukF_C', NULL, NULL, 'MukF_C', 9906),
(9907, 'cd11705', NULL, 'DHR2_DOCK4', NULL, NULL, 'DHR2_DOCK4', 9907),
(9908, 'cd16669', NULL, 'RING-H2_RNF181', NULL, NULL, 'RING-H2_RNF181', 9908),
(9909, 'cd09875', NULL, 'PIN_VapC-FitB-like', NULL, NULL, 'PIN_VapC-FitB-like', 9909),
(9910, 'cd19008', NULL, 'LGIC_ECD_GABAR_RDL-like', NULL, NULL, 'LGIC_ECD_GABAR_RDL-like', 9910),
(9911, 'cd07842', NULL, 'STKc_CDK8_like', NULL, NULL, 'STKc_CDK8_like', 9911),
(9912, 'cd02193', NULL, 'PurL', NULL, NULL, 'PurL', 9912),
(9913, 'cd14154', NULL, 'STKc_LIMK', NULL, NULL, 'STKc_LIMK', 9913),
(9914, 'cd17997', NULL, 'DEXHc_SMARCA1_SMARCA5', NULL, NULL, 'DEXHc_SMARCA1_SMARCA5', 9914),
(9915, 'cd03320', NULL, 'OSBS', NULL, NULL, 'OSBS', 9915),
(9916, 'cd12808', NULL, 'Esterase_713_like-1', NULL, NULL, 'Esterase_713_like-1', 9916),
(9917, 'cd01148', NULL, 'TroA_a', NULL, NULL, 'TroA_a', 9917),
(9918, 'cd14633', NULL, 'R-PTPc-M-1', NULL, NULL, 'R-PTPc-M-1', 9918),
(9919, 'cd09519', NULL, 'SAM_ANKS3', NULL, NULL, 'SAM_ANKS3', 9919),
(9920, 'cd05023', NULL, 'S-100A11', NULL, NULL, 'S-100A11', 9920),
(9921, 'cd07557', NULL, 'trimeric_dUTPase', NULL, NULL, 'trimeric_dUTPase', 9921),
(9922, 'cd19413', NULL, 'RsbR_N-like', NULL, NULL, 'RsbR_N-like', 9922),
(9923, 'cd08605', NULL, 'GDPD_GDE5_like_1_plant', NULL, NULL, 'GDPD_GDE5_like_1_plant', 9923),
(9924, 'cd10537', NULL, 'SET_SETD9', NULL, NULL, 'SET_SETD9', 9924),
(9925, 'cd12080', NULL, 'SH3_MPP1', NULL, NULL, 'SH3_MPP1', 9925),
(9926, 'cd07556', NULL, 'Nucleotidyl_cyc_III', NULL, NULL, 'Nucleotidyl_cyc_III', 9926),
(9927, 'cd18347', NULL, 'BTB_POZ_BTBD2', NULL, NULL, 'BTB_POZ_BTBD2', 9927),
(9928, 'cd10493', NULL, 'MH1_SMAD_6', NULL, NULL, 'MH1_SMAD_6', 9928),
(9929, 'cd00594', NULL, 'KU', NULL, NULL, 'KU', 9929),
(9930, 'cd06623', NULL, 'PKc_MAPKK_plant_like', NULL, NULL, 'PKc_MAPKK_plant_like', 9930),
(9931, 'cd07488', NULL, 'Peptidases_S8_2', NULL, NULL, 'Peptidases_S8_2', 9931),
(9932, 'cd15616', NULL, 'PHD_UHRF1', NULL, NULL, 'PHD_UHRF1', 9932),
(9933, 'cd07687', NULL, 'IgC_TCR_delta', NULL, NULL, 'IgC_TCR_delta', 9933),
(9934, 'cd03054', NULL, 'GST_N_Metaxin', NULL, NULL, 'GST_N_Metaxin', 9934),
(9935, 'cd05100', NULL, 'PTKc_FGFR3', NULL, NULL, 'PTKc_FGFR3', 9935),
(9936, 'cd06180', NULL, 'MFS_YjiJ', NULL, NULL, 'MFS_YjiJ', 9936),
(9937, 'cd09930', NULL, 'SH2_cSH2_p85_like', NULL, NULL, 'SH2_cSH2_p85_like', 9937),
(9938, 'cd15107', NULL, '7tmA_MrgprB', NULL, NULL, '7tmA_MrgprB', 9938),
(9939, 'cd20486', NULL, 'USP25_C', NULL, NULL, 'USP25_C', 9939),
(9940, 'cd00140', NULL, 'beta_clamp', NULL, NULL, 'beta_clamp', 9940),
(9941, 'cd02196', NULL, 'PurM', NULL, NULL, 'PurM', 9941),
(9942, 'cd11928', NULL, 'SH3_SH3RF3_1', NULL, NULL, 'SH3_SH3RF3_1', 9942),
(9943, 'cd05323', NULL, 'ADH_SDR_c_like', NULL, NULL, 'ADH_SDR_c_like', 9943),
(9944, 'cd12523', NULL, 'RRM2_MRN1', NULL, NULL, 'RRM2_MRN1', 9944),
(9945, 'cd12262', NULL, 'RRM2_4_MRN1', NULL, NULL, 'RRM2_4_MRN1', 9945),
(9946, 'cd03464', NULL, '3,4-PCD_beta', NULL, NULL, '3,4-PCD_beta', 9946),
(9947, 'cd05197', NULL, 'GH4_glycoside_hydrolases', NULL, NULL, 'GH4_glycoside_hydrolases', 9947),
(9948, 'cd06621', NULL, 'PKc_Pek1_like', NULL, NULL, 'PKc_Pek1_like', 9948),
(9949, 'cd07480', NULL, 'Peptidases_S8_12', NULL, NULL, 'Peptidases_S8_12', 9949),
(9950, 'cd17542', NULL, 'REC_CheY', NULL, NULL, 'REC_CheY', 9950),
(9951, 'cd03556', NULL, 'L-fucose_isomerase', NULL, NULL, 'L-fucose_isomerase', 9951),
(9952, 'cd07735', NULL, 'class_II_PDE_MBL-fold', NULL, NULL, 'class_II_PDE_MBL-fold', 9952),
(9953, 'cd03480', NULL, 'Rieske_RO_Alpha_PaO', NULL, NULL, 'Rieske_RO_Alpha_PaO', 9953),
(9954, 'cd13621', NULL, 'PBP2_AA_binding_like_3', NULL, NULL, 'PBP2_AA_binding_like_3', 9954),
(9955, 'cd06303', NULL, 'PBP1_LuxPQ_Quorum_Sensing', NULL, NULL, 'PBP1_LuxPQ_Quorum_Sensing', 9955),
(9956, 'cd13412', NULL, 'TNFRSF11B_teleost', NULL, NULL, 'TNFRSF11B_teleost', 9956),
(9957, 'cd01903', NULL, 'Ntn_AC_NAAA', NULL, NULL, 'Ntn_AC_NAAA', 9957);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(9958, 'cd04449', NULL, 'DEP_DEPDC5-like', NULL, NULL, 'DEP_DEPDC5-like', 9958),
(9959, 'cd11338', NULL, 'AmyAc_CMD', NULL, NULL, 'AmyAc_CMD', 9959),
(9960, 'cd18221', NULL, 'BTB_POZ_ZBTB35_ZNF131', NULL, NULL, 'BTB_POZ_ZBTB35_ZNF131', 9960),
(9961, 'cd16500', NULL, 'RING-HC_CARP', NULL, NULL, 'RING-HC_CARP', 9961),
(9962, 'cd01663', NULL, 'Cyt_c_Oxidase_I', NULL, NULL, 'Cyt_c_Oxidase_I', 9962),
(9963, 'cd11726', NULL, 'ADDz_ATRX', NULL, NULL, 'ADDz_ATRX', 9963),
(9964, 'cd00392', NULL, 'Ribosomal_L13', NULL, NULL, 'Ribosomal_L13', 9964),
(9965, 'cd14626', NULL, 'R-PTPc-F-1', NULL, NULL, 'R-PTPc-F-1', 9965),
(9966, 'cd00062', NULL, 'FN2', NULL, NULL, 'FN2', 9966),
(9967, 'cd06213', NULL, 'oxygenase_e_transfer_subunit', NULL, NULL, 'oxygenase_e_transfer_subunit', 9967),
(9968, 'cd09428', NULL, 'LIM2_FHL5', NULL, NULL, 'LIM2_FHL5', 9968),
(9969, 'cd14958', NULL, 'NHL_PAL_like', NULL, NULL, 'NHL_PAL_like', 9969),
(9970, 'cd01137', NULL, 'PsaA', NULL, NULL, 'PsaA', 9970),
(9971, 'cd01310', NULL, 'TatD_DNAse', NULL, NULL, 'TatD_DNAse', 9971),
(9972, 'cd09569', NULL, 'SAM_liprin-beta1,2_repeat3', NULL, NULL, 'SAM_liprin-beta1,2_repeat3', 9972),
(9973, 'cd09328', NULL, 'LIM2_abLIM', NULL, NULL, 'LIM2_abLIM', 9973),
(9974, 'cd14260', NULL, 'PUFD_like_1', NULL, NULL, 'PUFD_like_1', 9974),
(9975, 'cd18444', NULL, 'BACK_KLHL1_like', NULL, NULL, 'BACK_KLHL1_like', 9975),
(9976, 'cd21523', NULL, 'SUD_C_MERS-CoV_Nsp3', NULL, NULL, 'SUD_C_MERS-CoV_Nsp3', 9976),
(9977, 'cd07895', NULL, 'Adenylation_mRNA_capping', NULL, NULL, 'Adenylation_mRNA_capping', 9977),
(9978, 'cd18309', NULL, 'BTB2_POZ_LZTR1', NULL, NULL, 'BTB2_POZ_LZTR1', 9978),
(9979, 'cd13724', NULL, 'PBP2_iGluR_kainate_KA1', NULL, NULL, 'PBP2_iGluR_kainate_KA1', 9979),
(9980, 'cd16019', NULL, 'GPI_EPT', NULL, NULL, 'GPI_EPT', 9980),
(9981, 'cd12610', NULL, 'RRM1_SECp43', NULL, NULL, 'RRM1_SECp43', 9981),
(9982, 'cd17273', NULL, 'RMtype1_S_EcoJA69PI-TRD1-CR1_like', NULL, NULL, 'RMtype1_S_EcoJA69PI-TRD1-CR1_like', 9982),
(9983, 'cd12608', NULL, 'RRM1_CoAA', NULL, NULL, 'RRM1_CoAA', 9983),
(9984, 'cd03014', NULL, 'PRX_Atyp2cys', NULL, NULL, 'PRX_Atyp2cys', 9984),
(9985, 'cd02910', NULL, 'cupin_Yhhw_N', NULL, NULL, 'cupin_Yhhw_N', 9985),
(9986, 'cd08724', NULL, 'RGS_GRK-like', NULL, NULL, 'RGS_GRK-like', 9986),
(9987, 'cd18096', NULL, 'SpoU-like', NULL, NULL, 'SpoU-like', 9987),
(9988, 'cd06862', NULL, 'PX_SNX9_18_like', NULL, NULL, 'PX_SNX9_18_like', 9988),
(9989, 'cd01093', NULL, 'CRIB_PAK_like', NULL, NULL, 'CRIB_PAK_like', 9989),
(9990, 'cd21639', NULL, 'NS7a_deltaCoV_HKU30-like', NULL, NULL, 'NS7a_deltaCoV_HKU30-like', 9990),
(9991, 'cd01382', NULL, 'MYSc_Myo6', NULL, NULL, 'MYSc_Myo6', 9991),
(9992, 'cd06624', NULL, 'STKc_ASK', NULL, NULL, 'STKc_ASK', 9992),
(9993, 'cd12921', NULL, 'VKOR_4', NULL, NULL, 'VKOR_4', 9993),
(9994, 'cd03301', NULL, 'ABC_MalK_N', NULL, NULL, 'ABC_MalK_N', 9994),
(9995, 'cd13371', NULL, 'PH_GAP1_mammal-like', NULL, NULL, 'PH_GAP1_mammal-like', 9995),
(9996, 'cd14013', NULL, 'STKc_SNT7_plant', NULL, NULL, 'STKc_SNT7_plant', 9996),
(9997, 'cd04207', NULL, 'CuRO_3_LCC_like', NULL, NULL, 'CuRO_3_LCC_like', 9997),
(9998, 'cd03469', NULL, 'Rieske_RO_Alpha_N', NULL, NULL, 'Rieske_RO_Alpha_N', 9998),
(9999, 'cd06159', NULL, 'S2P-M50_PDZ_Arch', NULL, NULL, 'S2P-M50_PDZ_Arch', 9999),
(10000, 'cd17625', NULL, 'REC_OmpR_DrrD-like', NULL, NULL, 'REC_OmpR_DrrD-like', 10000),
(10001, 'cd15049', NULL, '7tmA_mAChR', NULL, NULL, '7tmA_mAChR', 10001),
(10002, 'cd19452', NULL, 'lipocalin_ABP', NULL, NULL, 'lipocalin_ABP', 10002),
(10003, 'cd08967', NULL, 'MeNeil1_N', NULL, NULL, 'MeNeil1_N', 10003),
(10004, 'cd02340', NULL, 'ZZ_NBR1_like', NULL, NULL, 'ZZ_NBR1_like', 10004),
(10005, 'cd14529', NULL, 'TpbA-like', NULL, NULL, 'TpbA-like', 10005),
(10006, 'cd09918', NULL, 'SH2_Nterm_SPT6_like', NULL, NULL, 'SH2_Nterm_SPT6_like', 10006),
(10007, 'cd15813', NULL, 'SPRY_PRY_TRIM20', NULL, NULL, 'SPRY_PRY_TRIM20', 10007),
(10008, 'cd15964', NULL, '7tmA_TSH-R', NULL, NULL, '7tmA_TSH-R', 10008),
(10009, 'cd17716', NULL, 'BRCT_microcephalin_rpt1', NULL, NULL, 'BRCT_microcephalin_rpt1', 10009);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(10010, 'cd06901', NULL, 'lectin_VIP36_VIPL', NULL, NULL, 'lectin_VIP36_VIPL', 10010),
(10011, 'cd02888', NULL, 'RNR_II_dimer', NULL, NULL, 'RNR_II_dimer', 10011),
(10012, 'cd12465', NULL, 'RRM_UHMK1', NULL, NULL, 'RRM_UHMK1', 10012),
(10013, 'cd01772', NULL, 'UBX_UBXN1', NULL, NULL, 'UBX_UBXN1', 10013),
(10014, 'cd04171', NULL, 'SelB', NULL, NULL, 'SelB', 10014),
(10015, 'cd16644', NULL, 'mRING-HC-C3HC3D_TRAF7', NULL, NULL, 'mRING-HC-C3HC3D_TRAF7', 10015),
(10016, 'cd21482', NULL, 'HKU1_N5-like_CoV_Spike_S1_RBD', NULL, NULL, 'HKU1_N5-like_CoV_Spike_S1_RBD', 10016),
(10017, 'cd01777', NULL, 'FERM_F1_SNX27', NULL, NULL, 'FERM_F1_SNX27', 10017),
(10018, 'cd01822', NULL, 'Lysophospholipase_L1_like', NULL, NULL, 'Lysophospholipase_L1_like', 10018),
(10019, 'cd04982', NULL, 'IgV_TCR_gamma', NULL, NULL, 'IgV_TCR_gamma', 10019),
(10020, 'cd19032', NULL, 'LGIC_ECD_nAChR_proto_beta-like', NULL, NULL, 'LGIC_ECD_nAChR_proto_beta-like', 10020),
(10021, 'cd14643', NULL, 'DSP_DUSP7', NULL, NULL, 'DSP_DUSP7', 10021),
(10022, 'cd16558', NULL, 'RING-HC_RNF207', NULL, NULL, 'RING-HC_RNF207', 10022),
(10023, 'cd02218', NULL, 'cupin_PGI', NULL, NULL, 'cupin_PGI', 10023),
(10024, 'cd04438', NULL, 'DEP_dishevelled', NULL, NULL, 'DEP_dishevelled', 10024),
(10025, 'cd13914', NULL, 'CuRO_HCO_II_like_3', NULL, NULL, 'CuRO_HCO_II_like_3', 10025),
(10026, 'cd12940', NULL, 'LEM_LAP2_LEMD1', NULL, NULL, 'LEM_LAP2_LEMD1', 10026),
(10027, 'cd08642', NULL, 'DNA_pol_A_pol_I_A', NULL, NULL, 'DNA_pol_A_pol_I_A', 10027),
(10028, 'cd12218', NULL, 'Csn2', NULL, NULL, 'Csn2', 10028),
(10029, 'cd05609', NULL, 'STKc_MAST', NULL, NULL, 'STKc_MAST', 10029),
(10030, 'cd11921', NULL, 'SH3_Vinexin_1', NULL, NULL, 'SH3_Vinexin_1', 10030),
(10031, 'cd19342', NULL, 'Wnt_Wnt10', NULL, NULL, 'Wnt_Wnt10', 10031),
(10032, 'cd11422', NULL, 'bHLH_TS_FIGLA', NULL, NULL, 'bHLH_TS_FIGLA', 10032),
(10033, 'cd14155', NULL, 'PKc_TESK', NULL, NULL, 'PKc_TESK', 10033),
(10034, 'cd07020', NULL, 'Clp_protease_NfeD_1', NULL, NULL, 'Clp_protease_NfeD_1', 10034),
(10035, 'cd15636', NULL, 'PHD_PYGO2', NULL, NULL, 'PHD_PYGO2', 10035),
(10036, 'cd02190', NULL, 'epsilon_tubulin', NULL, NULL, 'epsilon_tubulin', 10036),
(10037, 'cd09261', NULL, 'AP-3_Mu3B_Cterm', NULL, NULL, 'AP-3_Mu3B_Cterm', 10037),
(10038, 'cd01285', NULL, 'nucleoside_deaminase', NULL, NULL, 'nucleoside_deaminase', 10038),
(10039, 'cd09870', NULL, 'PIN_YEN1', NULL, NULL, 'PIN_YEN1', 10039),
(10040, 'cd06840', NULL, 'PLPDE_III_Bif_AspK_DapDC', NULL, NULL, 'PLPDE_III_Bif_AspK_DapDC', 10040),
(10041, 'cd17765', NULL, 'PNP_ThPNP_like', NULL, NULL, 'PNP_ThPNP_like', 10041),
(10042, 'cd09342', NULL, 'LIM3_Testin_like', NULL, NULL, 'LIM3_Testin_like', 10042),
(10043, 'cd09754', NULL, 'Cas8a1_I-A', NULL, NULL, 'Cas8a1_I-A', 10043),
(10044, 'cd11924', NULL, 'SH3_Vinexin_2', NULL, NULL, 'SH3_Vinexin_2', 10044),
(10045, 'cd14261', NULL, 'PUFD', NULL, NULL, 'PUFD', 10045),
(10046, 'cd03354', NULL, 'LbH_SAT', NULL, NULL, 'LbH_SAT', 10046),
(10047, 'cd11721', NULL, 'FANCD2', NULL, NULL, 'FANCD2', 10047),
(10048, 'cd11328', NULL, 'AmyAc_maltase', NULL, NULL, 'AmyAc_maltase', 10048),
(10049, 'cd01907', NULL, 'GlxB', NULL, NULL, 'GlxB', 10049),
(10050, 'cd09249', NULL, 'BRO1_Rhophilin_2', NULL, NULL, 'BRO1_Rhophilin_2', 10050),
(10051, 'cd07786', NULL, 'FGGY_EcGK_like', NULL, NULL, 'FGGY_EcGK_like', 10051),
(10052, 'cd03579', NULL, 'NTR_netrin-1_like', NULL, NULL, 'NTR_netrin-1_like', 10052),
(10053, 'cd18178', NULL, 'ATP-synt_Vo_c_ATP6F_rpt2', NULL, NULL, 'ATP-synt_Vo_c_ATP6F_rpt2', 10053),
(10054, 'cd05361', NULL, 'haloalcohol_DH_SDR_c-like', NULL, NULL, 'haloalcohol_DH_SDR_c-like', 10054),
(10055, 'cd15608', NULL, 'PHD2_KDM5C_5D', NULL, NULL, 'PHD2_KDM5C_5D', 10055),
(10056, 'cd00082', NULL, 'HisKA', NULL, NULL, 'HisKA', 10056),
(10057, 'cd14615', NULL, 'R-PTPc-J', NULL, NULL, 'R-PTPc-J', 10057),
(10058, 'cd14133', NULL, 'PKc_DYRK_like', NULL, NULL, 'PKc_DYRK_like', 10058),
(10059, 'cd12693', NULL, 'RRM2_PTBP1_like', NULL, NULL, 'RRM2_PTBP1_like', 10059),
(10060, 'cd14011', NULL, 'PK_SCY1_like', NULL, NULL, 'PK_SCY1_like', 10060);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(10061, 'cd19610', NULL, 'mannanase_GH134', NULL, NULL, 'mannanase_GH134', 10061),
(10062, 'cd00474', NULL, 'eIF1_SUI1_like', NULL, NULL, 'eIF1_SUI1_like', 10062),
(10063, 'cd00999', NULL, 'PBP2_ArtJ', NULL, NULL, 'PBP2_ArtJ', 10063),
(10064, 'cd12276', NULL, 'RRM2_MEI2_EAR1_like', NULL, NULL, 'RRM2_MEI2_EAR1_like', 10064),
(10065, 'cd13908', NULL, 'CuRO_3_MCO_like_2', NULL, NULL, 'CuRO_3_MCO_like_2', 10065),
(10066, 'cd19932', NULL, 'REC_PdtaR-like', NULL, NULL, 'REC_PdtaR-like', 10066),
(10067, 'cd04631', NULL, 'CBS_archAMPK_gamma-repeat2', NULL, NULL, 'CBS_archAMPK_gamma-repeat2', 10067),
(10068, 'cd13739', NULL, 'SPRY_PRY_TRIM1', NULL, NULL, 'SPRY_PRY_TRIM1', 10068),
(10069, 'cd13260', NULL, 'PH_RASA1', NULL, NULL, 'PH_RASA1', 10069),
(10070, 'cd17112', NULL, 'RA_MRL_like', NULL, NULL, 'RA_MRL_like', 10070),
(10071, 'cd05825', NULL, 'LbH_wcaF_like', NULL, NULL, 'LbH_wcaF_like', 10071),
(10072, 'cd12354', NULL, 'RRM3_TIA1_like', NULL, NULL, 'RRM3_TIA1_like', 10072),
(10073, 'cd13532', NULL, 'PBP2_PDT_like', NULL, NULL, 'PBP2_PDT_like', 10073),
(10074, 'cd13622', NULL, 'PBP2_Arg_3', NULL, NULL, 'PBP2_Arg_3', 10074),
(10075, 'cd06627', NULL, 'STKc_Cdc7_like', NULL, NULL, 'STKc_Cdc7_like', 10075),
(10076, 'cd08947', NULL, 'NmrA_TMR_like_SDR_a', NULL, NULL, 'NmrA_TMR_like_SDR_a', 10076),
(10077, 'cd13759', NULL, 'TGF_beta_NODAL', NULL, NULL, 'TGF_beta_NODAL', 10077),
(10078, 'cd15013', NULL, '7tm_TAS2R4', NULL, NULL, '7tm_TAS2R4', 10078),
(10079, 'cd03247', NULL, 'ABCC_cytochrome_bd', NULL, NULL, 'ABCC_cytochrome_bd', 10079),
(10080, 'cd06312', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, 'PBP1_ABC_sugar_binding-like', 10080),
(10081, 'cd07012', NULL, 'PBP2_Bug_TTT', NULL, NULL, 'PBP2_Bug_TTT', 10081),
(10082, 'cd18249', NULL, 'BTB_POZ_KLHL20_KLEIP', NULL, NULL, 'BTB_POZ_KLHL20_KLEIP', 10082),
(10083, 'cd07225', NULL, 'Pat_PNPLA6_PNPLA7', NULL, NULL, 'Pat_PNPLA6_PNPLA7', 10083),
(10084, 'cd15710', NULL, 'ePHD1_PHF6', NULL, NULL, 'ePHD1_PHF6', 10084),
(10085, 'cd00049', NULL, 'MH1', NULL, NULL, 'MH1', 10085),
(10086, 'cd08015', NULL, 'M28_like', NULL, NULL, 'M28_like', 10086),
(10087, 'cd06895', NULL, 'PX_PLD', NULL, NULL, 'PX_PLD', 10087),
(10088, 'cd02791', NULL, 'MopB_CT_Nitrate-R-NapA-like', NULL, NULL, 'MopB_CT_Nitrate-R-NapA-like', 10088),
(10089, 'cd12110', NULL, 'PHP_HisPPase_Hisj_like', NULL, NULL, 'PHP_HisPPase_Hisj_like', 10089),
(10090, 'cd12335', NULL, 'RRM2_SF3B4', NULL, NULL, 'RRM2_SF3B4', 10090),
(10091, 'cd15890', NULL, 'SNARE_Vti1b', NULL, NULL, 'SNARE_Vti1b', 10091),
(10092, 'cd07025', NULL, 'Peptidase_S66', NULL, NULL, 'Peptidase_S66', 10092),
(10093, 'cd17780', NULL, 'CBS_pair_arch1_repeat1', NULL, NULL, 'CBS_pair_arch1_repeat1', 10093),
(10094, 'cd18241', NULL, 'BTB_POZ_KLHL11', NULL, NULL, 'BTB_POZ_KLHL11', 10094),
(10095, 'cd07385', NULL, 'MPP_YkuE_C', NULL, NULL, 'MPP_YkuE_C', 10095),
(10096, 'cd10295', NULL, 'GST_C_Sigma', NULL, NULL, 'GST_C_Sigma', 10096),
(10097, 'sd00019', NULL, 'ZF_C2H2', NULL, NULL, 'ZF_C2H2', 10097),
(10098, 'cd12700', NULL, 'RRM3_hnRPLL', NULL, NULL, 'RRM3_hnRPLL', 10098),
(10099, 'cd05747', NULL, 'Ig_Titin_like', NULL, NULL, 'Ig_Titin_like', 10099),
(10100, 'cd08407', NULL, 'C2B_Synaptotagmin-13', NULL, NULL, 'C2B_Synaptotagmin-13', 10100),
(10101, 'cd09195', NULL, 'PLDc_mTdp1_2', NULL, NULL, 'PLDc_mTdp1_2', 10101),
(10102, 'cd11482', NULL, 'SLC-NCS1sbd_NRT1-like', NULL, NULL, 'SLC-NCS1sbd_NRT1-like', 10102),
(10103, 'cd14729', NULL, 'RtxA-like', NULL, NULL, 'RtxA-like', 10103),
(10104, 'cd21625', NULL, 'MHV-like_Spike_S1_NTD', NULL, NULL, 'MHV-like_Spike_S1_NTD', 10104),
(10105, 'cd02948', NULL, 'TRX_NDPK', NULL, NULL, 'TRX_NDPK', 10105),
(10106, 'cd04590', NULL, 'CBS_pair_CorC_HlyC_assoc', NULL, NULL, 'CBS_pair_CorC_HlyC_assoc', 10106),
(10107, 'cd06488', NULL, 'p23_melusin_like', NULL, NULL, 'p23_melusin_like', 10107),
(10108, 'cd20378', NULL, 'PBP1_SBP-like', NULL, NULL, 'PBP1_SBP-like', 10108),
(10109, 'cd17394', NULL, 'MFS_FucP_like', NULL, NULL, 'MFS_FucP_like', 10109),
(10110, 'cd13390', NULL, 'PH_LARG', NULL, NULL, 'PH_LARG', 10110);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(10111, 'cd00827', NULL, 'init_cond_enzymes', NULL, NULL, 'init_cond_enzymes', 10111),
(10112, 'cd10585', NULL, 'CE4_SF', NULL, NULL, 'CE4_SF', 10112),
(10113, 'cd14719', NULL, 'bZIP_BACH', NULL, NULL, 'bZIP_BACH', 10113),
(10114, 'cd16778', NULL, 'mRING-HC-C4C4_RBR_RNF144B', NULL, NULL, 'mRING-HC-C4C4_RBR_RNF144B', 10114),
(10115, 'cd08029', NULL, 'LA_like_fungal', NULL, NULL, 'LA_like_fungal', 10115),
(10116, 'cd01138', NULL, 'FeuA', NULL, NULL, 'FeuA', 10116),
(10117, 'cd15298', NULL, '7tmA_mAChR_M4', NULL, NULL, '7tmA_mAChR_M4', 10117),
(10118, 'cd17210', NULL, 'RA_RGL', NULL, NULL, 'RA_RGL', 10118),
(10119, 'cd17461', NULL, 'MFS_SLCO2A_OATP2A', NULL, NULL, 'MFS_SLCO2A_OATP2A', 10119),
(10120, 'cd04191', NULL, 'Glucan_BSP_MdoH', NULL, NULL, 'Glucan_BSP_MdoH', 10120),
(10121, 'cd11902', NULL, 'SH3_Nck2_2', NULL, NULL, 'SH3_Nck2_2', 10121),
(10122, 'cd09731', NULL, 'Cse2_I-E', NULL, NULL, 'Cse2_I-E', 10122),
(10123, 'cd11521', NULL, 'SLC6sbd_NTT4', NULL, NULL, 'SLC6sbd_NTT4', 10123),
(10124, 'cd11252', NULL, 'Sema_3D', NULL, NULL, 'Sema_3D', 10124),
(10125, 'cd00017', NULL, 'ANATO', NULL, NULL, 'ANATO', 10125),
(10126, 'cd00819', NULL, 'PEPCK_GTP', NULL, NULL, 'PEPCK_GTP', 10126),
(10127, 'cd17448', NULL, 'MFS_SLC46A3', NULL, NULL, 'MFS_SLC46A3', 10127),
(10128, 'cd10453', NULL, 'GIY-YIG_RE_Cfr42I', NULL, NULL, 'GIY-YIG_RE_Cfr42I', 10128),
(10129, 'cd13186', NULL, 'FERM_C_NBL4_NBL5', NULL, NULL, 'FERM_C_NBL4_NBL5', 10129),
(10130, 'cd00761', NULL, 'Glyco_tranf_GTA_type', NULL, NULL, 'Glyco_tranf_GTA_type', 10130),
(10131, 'cd13652', NULL, 'PBP2_ThiY_THI5_like_1', NULL, NULL, 'PBP2_ThiY_THI5_like_1', 10131),
(10132, 'cd06591', NULL, 'GH31_xylosidase_XylS', NULL, NULL, 'GH31_xylosidase_XylS', 10132),
(10133, 'cd12208', NULL, 'septicolysin_like', NULL, NULL, 'septicolysin_like', 10133),
(10134, 'cd08924', NULL, 'Cygb', NULL, NULL, 'Cygb', 10134),
(10135, 'cd17493', NULL, 'toxin_TenpN', NULL, NULL, 'toxin_TenpN', 10135),
(10136, 'cd03072', NULL, 'PDI_b''_ERp44', NULL, NULL, 'PDI_b''_ERp44', 10136),
(10137, 'cd01803', NULL, 'Ubl_ubiquitin', NULL, NULL, 'Ubl_ubiquitin', 10137),
(10138, 'cd08173', NULL, 'Gro1PDH', NULL, NULL, 'Gro1PDH', 10138),
(10139, 'cd14241', NULL, 'PAD', NULL, NULL, 'PAD', 10139),
(10140, 'cd16979', NULL, 'VHS_Vps27', NULL, NULL, 'VHS_Vps27', 10140),
(10141, 'cd16306', NULL, 'CphA_ImiS-like_MBL-B2', NULL, NULL, 'CphA_ImiS-like_MBL-B2', 10141),
(10142, 'cd04266', NULL, 'DUF619-NAGS-FABP', NULL, NULL, 'DUF619-NAGS-FABP', 10142),
(10143, 'cd12487', NULL, 'RRM1_DND1', NULL, NULL, 'RRM1_DND1', 10143),
(10144, 'cd14158', NULL, 'STKc_IRAK4', NULL, NULL, 'STKc_IRAK4', 10144),
(10145, 'cd06818', NULL, 'PLPDE_III_cryptic_DSD', NULL, NULL, 'PLPDE_III_cryptic_DSD', 10145),
(10146, 'cd03371', NULL, 'TPP_PpyrDC', NULL, NULL, 'TPP_PpyrDC', 10146),
(10147, 'cd04702', NULL, 'ASRGL1_like', NULL, NULL, 'ASRGL1_like', 10147),
(10148, 'cd19893', NULL, 'DSRM_TARBP2_rpt3', NULL, NULL, 'DSRM_TARBP2_rpt3', 10148),
(10149, 'cd09188', NULL, 'PLDc_FAM83H_N', NULL, NULL, 'PLDc_FAM83H_N', 10149),
(10150, 'cd17398', NULL, 'MFS_FLVCR_like', NULL, NULL, 'MFS_FLVCR_like', 10150),
(10151, 'cd00377', NULL, 'ICL_PEPM', NULL, NULL, 'ICL_PEPM', 10151),
(10152, 'cd08597', NULL, 'PI-PLCc_PRIP_metazoa', NULL, NULL, 'PI-PLCc_PRIP_metazoa', 10152),
(10153, 'cd02177', NULL, 'GH16_kappa_carrageenase', NULL, NULL, 'GH16_kappa_carrageenase', 10153),
(10154, 'cd03225', NULL, 'ABC_cobalt_CbiO_domain1', NULL, NULL, 'ABC_cobalt_CbiO_domain1', 10154),
(10155, 'cd08899', NULL, 'SRPBCC_CalC_Aha1-like_6', NULL, NULL, 'SRPBCC_CalC_Aha1-like_6', 10155),
(10156, 'cd19876', NULL, 'DSRM_RNT1p-like', NULL, NULL, 'DSRM_RNT1p-like', 10156),
(10157, 'cd02131', NULL, 'PA_hNAALADL2_like', NULL, NULL, 'PA_hNAALADL2_like', 10157),
(10158, 'cd03725', NULL, 'SOCS_ASB6', NULL, NULL, 'SOCS_ASB6', 10158),
(10159, 'cd08872', NULL, 'START_STARD11-like', NULL, NULL, 'START_STARD11-like', 10159),
(10160, 'cd01151', NULL, 'GCD', NULL, NULL, 'GCD', 10160),
(10161, 'cd08250', NULL, 'Mgc45594_like', NULL, NULL, 'Mgc45594_like', 10161),
(10162, 'cd14993', NULL, '7tmA_CCKR-like', NULL, NULL, '7tmA_CCKR-like', 10162);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(10163, 'cd01188', NULL, 'INT_RitA_C_like', NULL, NULL, 'INT_RitA_C_like', 10163),
(10164, 'cd08411', NULL, 'PBP2_OxyR', NULL, NULL, 'PBP2_OxyR', 10164),
(10165, 'cd09533', NULL, 'SAM_Ste50-like_fungal', NULL, NULL, 'SAM_Ste50-like_fungal', 10165),
(10166, 'cd08630', NULL, 'PI-PLCc_delta3', NULL, NULL, 'PI-PLCc_delta3', 10166),
(10167, 'cd12558', NULL, 'RRM3_RBM15B', NULL, NULL, 'RRM3_RBM15B', 10167),
(10168, 'cd14859', NULL, 'PMEI_like', NULL, NULL, 'PMEI_like', 10168),
(10169, 'cd13938', NULL, 'PANDER_like_TMEM2', NULL, NULL, 'PANDER_like_TMEM2', 10169),
(10170, 'cd01395', NULL, 'HMT_MBD', NULL, NULL, 'HMT_MBD', 10170),
(10171, 'cd02868', NULL, 'PseudoU_synth_hTruB2_like', NULL, NULL, 'PseudoU_synth_hTruB2_like', 10171),
(10172, 'cd07877', NULL, 'STKc_p38alpha', NULL, NULL, 'STKc_p38alpha', 10172),
(10173, 'cd11555', NULL, 'SLC-NCS1sbd_u1', NULL, NULL, 'SLC-NCS1sbd_u1', 10173),
(10174, 'cd12807', NULL, 'Esterase_713', NULL, NULL, 'Esterase_713', 10174),
(10175, 'cd16651', NULL, 'SPL-RING_NSE2', NULL, NULL, 'SPL-RING_NSE2', 10175),
(10176, 'cd14617', NULL, 'R-PTPc-B', NULL, NULL, 'R-PTPc-B', 10176),
(10177, 'cd17037', NULL, 'T3SC_IA_ShcV-like', NULL, NULL, 'T3SC_IA_ShcV-like', 10177),
(10178, 'cd06900', NULL, 'lectin_VcfQ', NULL, NULL, 'lectin_VcfQ', 10178),
(10179, 'cd00268', NULL, 'DEADc', NULL, NULL, 'DEADc', 10179),
(10180, 'cd19771', NULL, 'Bbox2_TRIM20', NULL, NULL, 'Bbox2_TRIM20', 10180),
(10181, 'cd07006', NULL, 'cupin_XcTcmJ-like', NULL, NULL, 'cupin_XcTcmJ-like', 10181),
(10182, 'cd09824', NULL, 'myeloperoxidase_like', NULL, NULL, 'myeloperoxidase_like', 10182),
(10183, 'cd06564', NULL, 'GH20_DspB_LnbB-like', NULL, NULL, 'GH20_DspB_LnbB-like', 10183),
(10184, 'cd18922', NULL, 'bHLHzip_SREBP2', NULL, NULL, 'bHLHzip_SREBP2', 10184),
(10185, 'cd11503', NULL, 'SLC5sbd_NIS', NULL, NULL, 'SLC5sbd_NIS', 10185),
(10186, 'cd16607', NULL, 'RING-HC_TRIM60_like_C-IV', NULL, NULL, 'RING-HC_TRIM60_like_C-IV', 10186),
(10187, 'cd05128', NULL, 'RasGAP_GAP1_like', NULL, NULL, 'RasGAP_GAP1_like', 10187),
(10188, 'cd04336', NULL, 'YeaK', NULL, NULL, 'YeaK', 10188),
(10189, 'cd05936', NULL, 'FC-FACS_FadD_like', NULL, NULL, 'FC-FACS_FadD_like', 10189),
(10190, 'cd12154', NULL, 'FDH_GDH_like', NULL, NULL, 'FDH_GDH_like', 10190),
(10191, 'cd08000', NULL, 'NGN', NULL, NULL, 'NGN', 10191),
(10192, 'cd10913', NULL, 'Peptidase_C25_N_gingipain', NULL, NULL, 'Peptidase_C25_N_gingipain', 10192),
(10193, 'cd09430', NULL, 'LIM5_LIMPETin', NULL, NULL, 'LIM5_LIMPETin', 10193),
(10194, 'cd14576', NULL, 'DSP_iDUSP27', NULL, NULL, 'DSP_iDUSP27', 10194),
(10195, 'cd07341', NULL, 'M56_BlaR1_MecR1_like', NULL, NULL, 'M56_BlaR1_MecR1_like', 10195),
(10196, 'cd01185', NULL, 'INTN1_C_like', NULL, NULL, 'INTN1_C_like', 10196),
(10197, 'cd10938', NULL, 'CE4_HpPgdA_like', NULL, NULL, 'CE4_HpPgdA_like', 10197),
(10198, 'cd15965', NULL, '7tmA_RXFP1_LGR7', NULL, NULL, '7tmA_RXFP1_LGR7', 10198),
(10199, 'cd03208', NULL, 'GST_C_Alpha', NULL, NULL, 'GST_C_Alpha', 10199),
(10200, 'cd19572', NULL, 'serpinB13_headpin', NULL, NULL, 'serpinB13_headpin', 10200),
(10201, 'cd10563', NULL, 'CooF_like', NULL, NULL, 'CooF_like', 10201),
(10202, 'cd05356', NULL, '17beta-HSD1_like_SDR_c', NULL, NULL, '17beta-HSD1_like_SDR_c', 10202),
(10203, 'cd02021', NULL, 'GntK', NULL, NULL, 'GntK', 10203),
(10204, 'cd10399', NULL, 'SH2_Tec_Bmx', NULL, NULL, 'SH2_Tec_Bmx', 10204),
(10205, 'cd14419', NULL, 'CUE_DMA_DMRTA3', NULL, NULL, 'CUE_DMA_DMRTA3', 10205),
(10206, 'cd07499', NULL, 'HAD_CBAP', NULL, NULL, 'HAD_CBAP', 10206),
(10207, 'cd00095', NULL, 'IFab', NULL, NULL, 'IFab', 10207),
(10208, 'cd07231', NULL, 'Pat_SDP1-like', NULL, NULL, 'Pat_SDP1-like', 10208),
(10209, 'cd15554', NULL, 'PHD_PHF2_like', NULL, NULL, 'PHD_PHF2_like', 10209),
(10210, 'cd16432', NULL, 'CheB_Rec', NULL, NULL, 'CheB_Rec', 10210),
(10211, 'cd02776', NULL, 'MopB_CT_Nitrate-R-NarG-like', NULL, NULL, 'MopB_CT_Nitrate-R-NarG-like', 10211),
(10212, 'cd17778', NULL, 'CBS_arch_repeat2', NULL, NULL, 'CBS_arch_repeat2', 10212),
(10213, 'cd11853', NULL, 'SH3_Kalirin_2', NULL, NULL, 'SH3_Kalirin_2', 10213);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(10214, 'cd17011', NULL, 'CID_RPRD1A', NULL, NULL, 'CID_RPRD1A', 10214),
(10215, 'cd18908', NULL, 'bHLH_SOHLH1_2', NULL, NULL, 'bHLH_SOHLH1_2', 10215),
(10216, 'cd18989', NULL, 'LGIC_ECD_cation', NULL, NULL, 'LGIC_ECD_cation', 10216),
(10217, 'cd03812', NULL, 'GT4_CapH-like', NULL, NULL, 'GT4_CapH-like', 10217),
(10218, 'cd17970', NULL, 'DEAHc_FancJ', NULL, NULL, 'DEAHc_FancJ', 10218),
(10219, 'cd02985', NULL, 'TRX_CDSP32', NULL, NULL, 'TRX_CDSP32', 10219),
(10220, 'cd14130', NULL, 'STKc_TTBK1', NULL, NULL, 'STKc_TTBK1', 10220),
(10221, 'cd11427', NULL, 'bHLH_TS_NeuroD', NULL, NULL, 'bHLH_TS_NeuroD', 10221),
(10222, 'cd15803', NULL, 'RLR_C_like', NULL, NULL, 'RLR_C_like', 10222),
(10223, 'cd02039', NULL, 'cytidylyltransferase_like', NULL, NULL, 'cytidylyltransferase_like', 10223),
(10224, 'cd09496', NULL, 'SAM_liprin-kazrin_repeat3', NULL, NULL, 'SAM_liprin-kazrin_repeat3', 10224),
(10225, 'cd15628', NULL, 'PHD_BAZ1B', NULL, NULL, 'PHD_BAZ1B', 10225),
(10226, 'cd00101', NULL, 'IlGF_like', NULL, NULL, 'IlGF_like', 10226),
(10227, 'cd08584', NULL, 'PI-PLCc_GDPD_SF_unchar2', NULL, NULL, 'PI-PLCc_GDPD_SF_unchar2', 10227),
(10228, 'cd12512', NULL, 'RRM3_RBM12', NULL, NULL, 'RRM3_RBM12', 10228),
(10229, 'cd12495', NULL, 'RRM3_hnRNPQ', NULL, NULL, 'RRM3_hnRNPQ', 10229),
(10230, 'cd14946', NULL, 'Tet_JBP', NULL, NULL, 'Tet_JBP', 10230),
(10231, 'cd03888', NULL, 'M20_PepV', NULL, NULL, 'M20_PepV', 10231),
(10232, 'cd15773', NULL, 'FYVE1_BSN', NULL, NULL, 'FYVE1_BSN', 10232),
(10233, 'cd01449', NULL, 'TST_Repeat_2', NULL, NULL, 'TST_Repeat_2', 10233),
(10234, 'cd08218', NULL, 'STKc_Nek1', NULL, NULL, 'STKc_Nek1', 10234),
(10235, 'cd11366', NULL, 'RNase_PH_archRRP41', NULL, NULL, 'RNase_PH_archRRP41', 10235),
(10236, 'cd00298', NULL, 'ACD_sHsps_p23-like', NULL, NULL, 'ACD_sHsps_p23-like', 10236),
(10237, 'cd04412', NULL, 'NDPk7B', NULL, NULL, 'NDPk7B', 10237),
(10238, 'cd12421', NULL, 'RRM1_PTBP1_hnRNPL_like', NULL, NULL, 'RRM1_PTBP1_hnRNPL_like', 10238),
(10239, 'cd18967', NULL, 'chromodomain', NULL, NULL, 'chromodomain', 10239),
(10240, 'cd12783', NULL, 'RRM2_PTBP2', NULL, NULL, 'RRM2_PTBP2', 10240),
(10241, 'cd01797', NULL, 'Ubl_UHRF', NULL, NULL, 'Ubl_UHRF', 10241),
(10242, 'cd19698', NULL, 'bHLH_AtMEE8_like', NULL, NULL, 'bHLH_AtMEE8_like', 10242),
(10243, 'cd19039', NULL, 'LGIC_ECD_GABAAR_A6', NULL, NULL, 'LGIC_ECD_GABAAR_A6', 10243),
(10244, 'cd16216', NULL, 'EFh_PI-PLCgamma1_like', NULL, NULL, 'EFh_PI-PLCgamma1_like', 10244),
(10245, 'cd17303', NULL, 'PIPKc_PIP5K_yeast_like', NULL, NULL, 'PIPKc_PIP5K_yeast_like', 10245),
(10246, 'cd07449', NULL, 'CRD_FZ3', NULL, NULL, 'CRD_FZ3', 10246),
(10247, 'cd04232', NULL, 'CuRO_1_CueO_FtsP', NULL, NULL, 'CuRO_1_CueO_FtsP', 10247),
(10248, 'cd19763', NULL, 'Bbox2_TRIM8_C-V', NULL, NULL, 'Bbox2_TRIM8_C-V', 10248),
(10249, 'cd08886', NULL, 'RHO_alpha_C_2', NULL, NULL, 'RHO_alpha_C_2', 10249),
(10250, 'cd15609', NULL, 'PHD_TCF19', NULL, NULL, 'PHD_TCF19', 10250),
(10251, 'sd00020', NULL, 'ZF_C2H2', NULL, NULL, 'ZF_C2H2', 10251),
(10252, 'cd17440', NULL, 'MFS_SV2C', NULL, NULL, 'MFS_SV2C', 10252),
(10253, 'cd12831', NULL, 'TmCorA-like_u2', NULL, NULL, 'TmCorA-like_u2', 10253),
(10254, 'cd17161', NULL, 'UBX_UBXN2B', NULL, NULL, 'UBX_UBXN2B', 10254),
(10255, 'cd00841', NULL, 'MPP_YfcE', NULL, NULL, 'MPP_YfcE', 10255),
(10256, 'cd14333', NULL, 'UBA_unchar_Eumetazoa', NULL, NULL, 'UBA_unchar_Eumetazoa', 10256),
(10257, 'cd03582', NULL, 'NTR_complement_C5', NULL, NULL, 'NTR_complement_C5', 10257),
(10258, 'cd11505', NULL, 'SLC5sbd_SMCT', NULL, NULL, 'SLC5sbd_SMCT', 10258),
(10259, 'cd18355', NULL, 'BTB1_POZ_RHOBTB1', NULL, NULL, 'BTB1_POZ_RHOBTB1', 10259),
(10260, 'cd19832', NULL, 'Bbox2_MuRF2_C-II', NULL, NULL, 'Bbox2_MuRF2_C-II', 10260),
(10261, 'cd03211', NULL, 'GST_C_Metaxin2', NULL, NULL, 'GST_C_Metaxin2', 10261),
(10262, 'cd17512', NULL, 'RMtype1_S_BceB55ORF5615P-TRD2-CR2_like', NULL, NULL, 'RMtype1_S_BceB55ORF5615P-TRD2-CR2_like', 10262),
(10263, 'cd17745', NULL, 'BRCT_p53bp1_rpt1', NULL, NULL, 'BRCT_p53bp1_rpt1', 10263),
(10264, 'cd00033', NULL, 'CCP', NULL, NULL, 'CCP', 10264);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(10265, 'cd03695', NULL, 'CysN_NodQ_II', NULL, NULL, 'CysN_NodQ_II', 10265),
(10266, 'cd15308', NULL, '7tmA_D4_dopamine_R', NULL, NULL, '7tmA_D4_dopamine_R', 10266),
(10267, 'cd16731', NULL, 'RING-HC_MKRN2', NULL, NULL, 'RING-HC_MKRN2', 10267),
(10268, 'cd04242', NULL, 'AAK_G5K_ProB', NULL, NULL, 'AAK_G5K_ProB', 10268),
(10269, 'cd12073', NULL, 'SH3_HS1', NULL, NULL, 'SH3_HS1', 10269),
(10270, 'cd17017', NULL, 'ING_Yng1p', NULL, NULL, 'ING_Yng1p', 10270),
(10271, 'cd19988', NULL, 'PBP1_ABC_HAAT-like', NULL, NULL, 'PBP1_ABC_HAAT-like', 10271),
(10272, 'cd01984', NULL, 'AANH_like', NULL, NULL, 'AANH_like', 10272),
(10273, 'cd03764', NULL, 'proteasome_beta_archeal', NULL, NULL, 'proteasome_beta_archeal', 10273),
(10274, 'cd20215', NULL, 'PFM_LSL-like', NULL, NULL, 'PFM_LSL-like', 10274),
(10275, 'cd04261', NULL, 'AAK_AKii-LysC-BS', NULL, NULL, 'AAK_AKii-LysC-BS', 10275),
(10276, 'cd12748', NULL, 'RRM4_RBM12B', NULL, NULL, 'RRM4_RBM12B', 10276),
(10277, 'cd13755', NULL, 'TGF_beta_maverick', NULL, NULL, 'TGF_beta_maverick', 10277),
(10278, 'cd06198', NULL, 'FNR_like_3', NULL, NULL, 'FNR_like_3', 10278),
(10279, 'cd15491', NULL, 'selB_III', NULL, NULL, 'selB_III', 10279),
(10280, 'cd07924', NULL, 'PCA_45_Doxase_A', NULL, NULL, 'PCA_45_Doxase_A', 10280),
(10281, 'cd15179', NULL, '7tmA_CXCR4', NULL, NULL, '7tmA_CXCR4', 10281),
(10282, 'cd03524', NULL, 'RPA2_OBF_family', NULL, NULL, 'RPA2_OBF_family', 10282),
(10283, 'cd18607', NULL, 'GH130', NULL, NULL, 'GH130', 10283),
(10284, 'cd08222', NULL, 'STKc_Nek11', NULL, NULL, 'STKc_Nek11', 10284),
(10285, 'cd10533', NULL, 'SET_EHMT2', NULL, NULL, 'SET_EHMT2', 10285),
(10286, 'cd18182', NULL, 'ATP-synt_Fo_c_ATP5G3', NULL, NULL, 'ATP-synt_Fo_c_ATP5G3', 10286),
(10287, 'cd03756', NULL, 'proteasome_alpha_archeal', NULL, NULL, 'proteasome_alpha_archeal', 10287),
(10288, 'cd03778', NULL, 'MATH_TRAF2', NULL, NULL, 'MATH_TRAF2', 10288),
(10289, 'cd16477', NULL, 'RING-H2_RNF214', NULL, NULL, 'RING-H2_RNF214', 10289),
(10290, 'cd14969', NULL, '7tmA_Opsins_type2_animals', NULL, NULL, '7tmA_Opsins_type2_animals', 10290),
(10291, 'cd07872', NULL, 'STKc_PCTAIRE2', NULL, NULL, 'STKc_PCTAIRE2', 10291),
(10292, 'cd18094', NULL, 'SpoU-like_TrmL', NULL, NULL, 'SpoU-like_TrmL', 10292),
(10293, 'cd06569', NULL, 'GH20_Sm-chitobiase-like', NULL, NULL, 'GH20_Sm-chitobiase-like', 10293),
(10294, 'cd16613', NULL, 'RING-HC_UHRF', NULL, NULL, 'RING-HC_UHRF', 10294),
(10295, 'cd09278', NULL, 'RNase_HI_prokaryote_like', NULL, NULL, 'RNase_HI_prokaryote_like', 10295),
(10296, 'cd06657', NULL, 'STKc_PAK4', NULL, NULL, 'STKc_PAK4', 10296),
(10297, 'cd01365', NULL, 'KISc_KIF1A_KIF1B', NULL, NULL, 'KISc_KIF1A_KIF1B', 10297),
(10298, 'cd06316', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, 'PBP1_ABC_sugar_binding-like', 10298),
(10299, 'cd19100', NULL, 'AKR_unchar', NULL, NULL, 'AKR_unchar', 10299),
(10300, 'cd09632', NULL, 'PliI_like', NULL, NULL, 'PliI_like', 10300),
(10301, 'cd08418', NULL, 'PBP2_TdcA', NULL, NULL, 'PBP2_TdcA', 10301),
(10302, 'cd00238', NULL, 'ERp29c', NULL, NULL, 'ERp29c', 10302),
(10303, 'cd09606', NULL, 'M3B_PepF', NULL, NULL, 'M3B_PepF', 10303),
(10304, 'cd14378', NULL, 'UBA1_Rhp23p_like', NULL, NULL, 'UBA1_Rhp23p_like', 10304),
(10305, 'cd13960', NULL, 'PT_UbiA_HPT1', NULL, NULL, 'PT_UbiA_HPT1', 10305),
(10306, 'cd16185', NULL, 'EFh_PEF_ALG-2_like', NULL, NULL, 'EFh_PEF_ALG-2_like', 10306),
(10307, 'cd00672', NULL, 'CysRS_core', NULL, NULL, 'CysRS_core', 10307),
(10308, 'cd11379', NULL, 'DUF4425', NULL, NULL, 'DUF4425', 10308),
(10309, 'cd07264', NULL, 'VOC_like', NULL, NULL, 'VOC_like', 10309),
(10310, 'cd16710', NULL, 'RING-HC_Cbl-c', NULL, NULL, 'RING-HC_Cbl-c', 10310),
(10311, 'cd18285', NULL, 'BTB1_POZ_BTBD8', NULL, NULL, 'BTB1_POZ_BTBD8', 10311),
(10312, 'cd07743', NULL, 'metallo-hydrolase-like_MBL-fold', NULL, NULL, 'metallo-hydrolase-like_MBL-fold', 10312),
(10313, 'cd10395', NULL, 'SH2_RIN3', NULL, NULL, 'SH2_RIN3', 10313),
(10314, 'cd11933', NULL, 'SH3_Nebulin_C', NULL, NULL, 'SH3_Nebulin_C', 10314),
(10315, 'cd03448', NULL, 'HDE_HSD', NULL, NULL, 'HDE_HSD', 10315);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(10316, 'cd15585', NULL, 'PHD_ING3', NULL, NULL, 'PHD_ING3', 10316),
(10317, 'cd17312', NULL, 'MFS_OPA_SLC37', NULL, NULL, 'MFS_OPA_SLC37', 10317),
(10318, 'cd03258', NULL, 'ABC_MetN_methionine_transporter', NULL, NULL, 'ABC_MetN_methionine_transporter', 10318),
(10319, 'cd11021', NULL, 'CuRO_2_ceruloplasmin', NULL, NULL, 'CuRO_2_ceruloplasmin', 10319),
(10320, 'cd11307', NULL, 'M35_Asp_f2_like', NULL, NULL, 'M35_Asp_f2_like', 10320),
(10321, 'cd15177', NULL, '7tmA_CCR10', NULL, NULL, '7tmA_CCR10', 10321),
(10322, 'cd05347', NULL, 'Ga5DH-like_SDR_c', NULL, NULL, 'Ga5DH-like_SDR_c', 10322),
(10323, 'cd13852', NULL, 'CuRO_1_McoP_like', NULL, NULL, 'CuRO_1_McoP_like', 10323),
(10324, 'cd18928', NULL, 'bHLHzip_TFE3', NULL, NULL, 'bHLHzip_TFE3', 10324),
(10325, 'cd00100', NULL, 'IL1', NULL, NULL, 'IL1', 10325),
(10326, 'cd07987', NULL, 'LPLAT_MGAT-like', NULL, NULL, 'LPLAT_MGAT-like', 10326),
(10327, 'cd00407', NULL, 'Urease_beta', NULL, NULL, 'Urease_beta', 10327),
(10328, 'cd07257', NULL, 'THT_oxygenase_C', NULL, NULL, 'THT_oxygenase_C', 10328),
(10329, 'cd07133', NULL, 'ALDH_CALDH_CalB', NULL, NULL, 'ALDH_CALDH_CalB', 10329),
(10330, 'cd04608', NULL, 'CBS_pair_CBS', NULL, NULL, 'CBS_pair_CBS', 10330),
(10331, 'cd07639', NULL, 'BAR_ACAP1', NULL, NULL, 'BAR_ACAP1', 10331),
(10332, 'cd10388', NULL, 'SH2_SOCS7', NULL, NULL, 'SH2_SOCS7', 10332),
(10333, 'cd18468', NULL, 'BACK_KLHL29_KBTBD9', NULL, NULL, 'BACK_KLHL29_KBTBD9', 10333),
(10334, 'cd19690', NULL, 'bHLHzip_spESC1_like', NULL, NULL, 'bHLHzip_spESC1_like', 10334),
(10335, 'cd14456', NULL, 'Menin', NULL, NULL, 'Menin', 10335),
(10336, 'cd15647', NULL, 'PHD_CBP', NULL, NULL, 'PHD_CBP', 10336),
(10337, 'cd17090', NULL, 'FERM_F1_TLN', NULL, NULL, 'FERM_F1_TLN', 10337),
(10338, 'cd15801', NULL, 'PMEI-like_1', NULL, NULL, 'PMEI-like_1', 10338),
(10339, 'cd09647', NULL, 'Csm2_III-A', NULL, NULL, 'Csm2_III-A', 10339),
(10340, 'cd18331', NULL, 'BTB_POZ_ZBTB27_BCL6', NULL, NULL, 'BTB_POZ_ZBTB27_BCL6', 10340),
(10341, 'cd06008', NULL, 'NF-X1-zinc-finger', NULL, NULL, 'NF-X1-zinc-finger', 10341),
(10342, 'cd05684', NULL, 'S1_DHX8_helicase', NULL, NULL, 'S1_DHX8_helicase', 10342),
(10343, 'cd18198', NULL, 'BTB_POZ_ZBTB7', NULL, NULL, 'BTB_POZ_ZBTB7', 10343),
(10344, 'cd19708', NULL, 'bHLH_TS_dHLH3B_like', NULL, NULL, 'bHLH_TS_dHLH3B_like', 10344),
(10345, 'cd00349', NULL, 'Ribosomal_L11', NULL, NULL, 'Ribosomal_L11', 10345),
(10346, 'cd05816', NULL, 'CBM20_DPE2_repeat2', NULL, NULL, 'CBM20_DPE2_repeat2', 10346),
(10347, 'cd16772', NULL, 'RING-HC_UNKL', NULL, NULL, 'RING-HC_UNKL', 10347),
(10348, 'cd02248', NULL, 'Peptidase_C1A', NULL, NULL, 'Peptidase_C1A', 10348),
(10349, 'cd18735', NULL, 'PIN_HiVapC1-like', NULL, NULL, 'PIN_HiVapC1-like', 10349),
(10350, 'cd19435', NULL, 'lipocalin_Bacteroides', NULL, NULL, 'lipocalin_Bacteroides', 10350),
(10351, 'cd01538', NULL, 'PBP1_ABC_xylose_binding-like', NULL, NULL, 'PBP1_ABC_xylose_binding-like', 10351),
(10352, 'cd15948', NULL, '7tmA_OR52K-like', NULL, NULL, '7tmA_OR52K-like', 10352),
(10353, 'cd07386', NULL, 'MPP_DNA_pol_II_small_archeal_C', NULL, NULL, 'MPP_DNA_pol_II_small_archeal_C', 10353),
(10354, 'cd15273', NULL, '7tmB1_NPR_B7_insect-like', NULL, NULL, '7tmB1_NPR_B7_insect-like', 10354),
(10355, 'cd10391', NULL, 'SH2_SHE', NULL, NULL, 'SH2_SHE', 10355),
(10356, 'cd12386', NULL, 'RRM2_hnRNPM_like', NULL, NULL, 'RRM2_hnRNPM_like', 10356),
(10357, 'cd19709', NULL, 'bHLH_TS_TCF23_OUT', NULL, NULL, 'bHLH_TS_TCF23_OUT', 10357),
(10358, 'cd12403', NULL, 'RRM1_NCL', NULL, NULL, 'RRM1_NCL', 10358),
(10359, 'cd15503', NULL, 'PHD2_MTF2_PHF19_like', NULL, NULL, 'PHD2_MTF2_PHF19_like', 10359),
(10360, 'cd06445', NULL, 'ATase', NULL, NULL, 'ATase', 10360),
(10361, 'cd08980', NULL, 'GH43_LbAraf43-like', NULL, NULL, 'GH43_LbAraf43-like', 10361),
(10362, 'cd14589', NULL, 'PTP-MTMR13', NULL, NULL, 'PTP-MTMR13', 10362),
(10363, 'cd08888', NULL, 'SRPBCC_PITPNA-B_like', NULL, NULL, 'SRPBCC_PITPNA-B_like', 10363),
(10364, 'cd03007', NULL, 'PDI_a_ERp29_N', NULL, NULL, 'PDI_a_ERp29_N', 10364),
(10365, 'cd12044', NULL, 'SH3_SKAP1', NULL, NULL, 'SH3_SKAP1', 10365);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(10366, 'cd16022', NULL, 'sulfatase_like', NULL, NULL, 'sulfatase_like', 10366),
(10367, 'cd14162', NULL, 'STKc_TSSK4-like', NULL, NULL, 'STKc_TSSK4-like', 10367),
(10368, 'cd18585', NULL, 'ABC_6TM_CydC', NULL, NULL, 'ABC_6TM_CydC', 10368),
(10369, 'cd14123', NULL, 'STKc_VRK2', NULL, NULL, 'STKc_VRK2', 10369),
(10370, 'cd09379', NULL, 'LIM2_AWH', NULL, NULL, 'LIM2_AWH', 10370),
(10371, 'cd11793', NULL, 'SH3_ephexin1_like', NULL, NULL, 'SH3_ephexin1_like', 10371),
(10372, 'cd08531', NULL, 'SAM_PNT-ERG_FLI-1', NULL, NULL, 'SAM_PNT-ERG_FLI-1', 10372),
(10373, 'cd00729', NULL, 'rubredoxin_SM', NULL, NULL, 'rubredoxin_SM', 10373),
(10374, 'cd08585', NULL, 'GDPD_like_3', NULL, NULL, 'GDPD_like_3', 10374),
(10375, 'cd17060', NULL, 'Ubl_RB1CC1', NULL, NULL, 'Ubl_RB1CC1', 10375),
(10376, 'cd12142', NULL, 'SH3_D21-like', NULL, NULL, 'SH3_D21-like', 10376),
(10377, 'cd14981', NULL, '7tmA_Prostanoid_R', NULL, NULL, '7tmA_Prostanoid_R', 10377),
(10378, 'cd19004', NULL, 'LGIC_ECD_GABAAR_pi', NULL, NULL, 'LGIC_ECD_GABAAR_pi', 10378),
(10379, 'cd09688', NULL, 'Cas5_I-C', NULL, NULL, 'Cas5_I-C', 10379),
(10380, 'cd00029', NULL, 'C1', NULL, NULL, 'C1', 10380),
(10381, 'cd18339', NULL, 'BTB_POZ_KLHL3', NULL, NULL, 'BTB_POZ_KLHL3', 10381),
(10382, 'cd15265', NULL, '7tmB1_PTHR', NULL, NULL, '7tmB1_PTHR', 10382),
(10383, 'cd18688', NULL, 'PIN_VapC-like', NULL, NULL, 'PIN_VapC-like', 10383),
(10384, 'cd08468', NULL, 'PBP2_Pa0477', NULL, NULL, 'PBP2_Pa0477', 10384),
(10385, 'cd13994', NULL, 'STKc_HAL4_like', NULL, NULL, 'STKc_HAL4_like', 10385),
(10386, 'cd18254', NULL, 'BTB_POZ_KLHL25', NULL, NULL, 'BTB_POZ_KLHL25', 10386),
(10387, 'cd00807', NULL, 'GlnRS_core', NULL, NULL, 'GlnRS_core', 10387),
(10388, 'cd15707', NULL, 'ePHD_RNO', NULL, NULL, 'ePHD_RNO', 10388),
(10389, 'cd01755', NULL, 'PLAT_lipase', NULL, NULL, 'PLAT_lipase', 10389),
(10390, 'cd19685', NULL, 'bHLH-O_HERP_HES', NULL, NULL, 'bHLH-O_HERP_HES', 10390),
(10391, 'cd16887', NULL, 'YEATS', NULL, NULL, 'YEATS', 10391),
(10392, 'cd18474', NULL, 'BACK_KLHL35', NULL, NULL, 'BACK_KLHL35', 10392),
(10393, 'cd06371', NULL, 'PBP1_sensory_GC_DEF-like', NULL, NULL, 'PBP1_sensory_GC_DEF-like', 10393),
(10394, 'cd15353', NULL, '7tmA_MC4R', NULL, NULL, '7tmA_MC4R', 10394),
(10395, 'cd14075', NULL, 'STKc_NIM1', NULL, NULL, 'STKc_NIM1', 10395),
(10396, 'cd10939', NULL, 'CE4_ArnD', NULL, NULL, 'CE4_ArnD', 10396),
(10397, 'cd03676', NULL, 'Nudix_hydrolase_3', NULL, NULL, 'Nudix_hydrolase_3', 10397),
(10398, 'cd12381', NULL, 'RRM4_I_PABPs', NULL, NULL, 'RRM4_I_PABPs', 10398),
(10399, 'cd11645', NULL, 'Precorrin_2_C20_MT', NULL, NULL, 'Precorrin_2_C20_MT', 10399),
(10400, 'cd03449', NULL, 'R_hydratase', NULL, NULL, 'R_hydratase', 10400),
(10401, 'cd02982', NULL, 'PDI_b''_family', NULL, NULL, 'PDI_b''_family', 10401),
(10402, 'cd15488', NULL, 'Tm-1-like', NULL, NULL, 'Tm-1-like', 10402),
(10403, 'cd16250', NULL, 'EFh_DTNB', NULL, NULL, 'EFh_DTNB', 10403),
(10404, 'cd15927', NULL, '7tmA_Bombesin_R-like', NULL, NULL, '7tmA_Bombesin_R-like', 10404),
(10405, 'cd00800', NULL, 'INT_Lambda_C', NULL, NULL, 'INT_Lambda_C', 10405),
(10406, 'cd04165', NULL, 'GTPBP1_like', NULL, NULL, 'GTPBP1_like', 10406),
(10407, 'cd17550', NULL, 'REC_NtrX-like', NULL, NULL, 'REC_NtrX-like', 10407),
(10408, 'cd09512', NULL, 'SAM_Neurabin-like', NULL, NULL, 'SAM_Neurabin-like', 10408),
(10409, 'cd02862', NULL, 'NorE_like', NULL, NULL, 'NorE_like', 10409),
(10410, 'cd08526', NULL, 'Reelin_subrepeat_2', NULL, NULL, 'Reelin_subrepeat_2', 10410),
(10411, 'cd09851', NULL, 'HTLV-1-like_HR1-HR2', NULL, NULL, 'HTLV-1-like_HR1-HR2', 10411),
(10412, 'cd18284', NULL, 'BTB2_POZ_BTBD7', NULL, NULL, 'BTB2_POZ_BTBD7', 10412),
(10413, 'cd15746', NULL, 'FYVE_RP3A_like', NULL, NULL, 'FYVE_RP3A_like', 10413),
(10414, 'cd04706', NULL, 'PLA2_plant', NULL, NULL, 'PLA2_plant', 10414),
(10415, 'cd05934', NULL, 'FACL_DitJ_like', NULL, NULL, 'FACL_DitJ_like', 10415),
(10416, 'cd18471', NULL, 'BACK_KLHL32_BKLHD5', NULL, NULL, 'BACK_KLHL32_BKLHD5', 10416),
(10417, 'cd13516', NULL, 'HHD_CCM2', NULL, NULL, 'HHD_CCM2', 10417);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(10418, 'cd08221', NULL, 'STKc_Nek9', NULL, NULL, 'STKc_Nek9', 10418),
(10419, 'cd01159', NULL, 'NcnH', NULL, NULL, 'NcnH', 10419),
(10420, 'cd07079', NULL, 'ALDH_F18-19_ProA-GPR', NULL, NULL, 'ALDH_F18-19_ProA-GPR', 10420),
(10421, 'cd02425', NULL, 'Peptidase_C39F', NULL, NULL, 'Peptidase_C39F', 10421),
(10422, 'cd03685', NULL, 'ClC_6_like', NULL, NULL, 'ClC_6_like', 10422),
(10423, 'cd07097', NULL, 'ALDH_KGSADH-YcbD', NULL, NULL, 'ALDH_KGSADH-YcbD', 10423),
(10424, 'cd17008', NULL, 'VHS_GGA3', NULL, NULL, 'VHS_GGA3', 10424),
(10425, 'cd00430', NULL, 'PLPDE_III_AR', NULL, NULL, 'PLPDE_III_AR', 10425),
(10426, 'cd10398', NULL, 'SH2_Tec_Txk', NULL, NULL, 'SH2_Tec_Txk', 10426),
(10427, 'cd17667', NULL, 'R-PTPc-G-1', NULL, NULL, 'R-PTPc-G-1', 10427),
(10428, 'cd13646', NULL, 'PBP2_EcHMBS_like', NULL, NULL, 'PBP2_EcHMBS_like', 10428),
(10429, 'cd02785', NULL, 'MopB_CT_4', NULL, NULL, 'MopB_CT_4', 10429),
(10430, 'cd14414', NULL, 'UBA_FAF2', NULL, NULL, 'UBA_FAF2', 10430),
(10431, 'cd17435', NULL, 'MFS_GLUT12_Class3', NULL, NULL, 'MFS_GLUT12_Class3', 10431),
(10432, 'cd09728', NULL, 'Csx1_III-U', NULL, NULL, 'Csx1_III-U', 10432),
(10433, 'cd14384', NULL, 'UBA1_UBP13', NULL, NULL, 'UBA1_UBP13', 10433),
(10434, 'cd16852', NULL, 'STAT2_CCD', NULL, NULL, 'STAT2_CCD', 10434),
(10435, 'cd12958', NULL, 'SKA1_N', NULL, NULL, 'SKA1_N', 10435),
(10436, 'cd01099', NULL, 'PAN_AP_HGF', NULL, NULL, 'PAN_AP_HGF', 10436),
(10437, 'cd19183', NULL, 'SET_SpSET3-like', NULL, NULL, 'SET_SpSET3-like', 10437),
(10438, 'cd10457', NULL, 'GIY-YIG_AtGrxS16', NULL, NULL, 'GIY-YIG_AtGrxS16', 10438),
(10439, 'cd14218', NULL, 'STKc_SRPK3', NULL, NULL, 'STKc_SRPK3', 10439),
(10440, 'cd00116', NULL, 'LRR_RI', NULL, NULL, 'LRR_RI', 10440),
(10441, 'cd11015', NULL, 'CuRO_2_FVIII_like', NULL, NULL, 'CuRO_2_FVIII_like', 10441),
(10442, 'cd17934', NULL, 'DEXXQc_Upf1-like', NULL, NULL, 'DEXXQc_Upf1-like', 10442),
(10443, 'cd15914', NULL, '7tmA_OR6N-like', NULL, NULL, '7tmA_OR6N-like', 10443),
(10444, 'cd06210', NULL, 'MMO_FAD_NAD_binding', NULL, NULL, 'MMO_FAD_NAD_binding', 10444),
(10445, 'cd08286', NULL, 'FDH_like_ADH2', NULL, NULL, 'FDH_like_ADH2', 10445),
(10446, 'cd17787', NULL, 'CBS_pair_ACT', NULL, NULL, 'CBS_pair_ACT', 10446),
(10447, 'cd02772', NULL, 'MopB_NDH-1_NuoG2', NULL, NULL, 'MopB_NDH-1_NuoG2', 10447),
(10448, 'cd13983', NULL, 'STKc_WNK', NULL, NULL, 'STKc_WNK', 10448),
(10449, 'cd00038', NULL, 'CAP_ED', NULL, NULL, 'CAP_ED', 10449),
(10450, 'cd06098', NULL, 'phytepsin', NULL, NULL, 'phytepsin', 10450),
(10451, 'cd01513', NULL, 'Translation_factor_III', NULL, NULL, 'Translation_factor_III', 10451),
(10452, 'cd00180', NULL, 'PKc', NULL, NULL, 'PKc', 10452),
(10453, 'cd17982', NULL, 'DEXHc_DHX37', NULL, NULL, 'DEXHc_DHX37', 10453),
(10454, 'cd16175', NULL, 'EFh_MICU3', NULL, NULL, 'EFh_MICU3', 10454),
(10455, 'cd00248', NULL, 'Mth938-like', NULL, NULL, 'Mth938-like', 10455),
(10456, 'cd06460', NULL, 'M32_Taq', NULL, NULL, 'M32_Taq', 10456),
(10457, 'cd14606', NULL, 'PTPc-N6', NULL, NULL, 'PTPc-N6', 10457),
(10458, 'cd07484', NULL, 'Peptidases_S8_Thermitase_like', NULL, NULL, 'Peptidases_S8_Thermitase_like', 10458),
(10459, 'cd10364', NULL, 'SH2_Src_Lyn', NULL, NULL, 'SH2_Src_Lyn', 10459),
(10460, 'cd02668', NULL, 'Peptidase_C19L', NULL, NULL, 'Peptidase_C19L', 10460),
(10461, 'cd02786', NULL, 'MopB_CT_3', NULL, NULL, 'MopB_CT_3', 10461),
(10462, 'cd05036', NULL, 'PTKc_ALK_LTK', NULL, NULL, 'PTKc_ALK_LTK', 10462),
(10463, 'cd20229', NULL, 'PFM_tachylectin-like', NULL, NULL, 'PFM_tachylectin-like', 10463),
(10464, 'cd01574', NULL, 'PBP1_LacI', NULL, NULL, 'PBP1_LacI', 10464),
(10465, 'cd15987', NULL, '7tmB1_PACAP-R1', NULL, NULL, '7tmB1_PACAP-R1', 10465),
(10466, 'cd04017', NULL, 'C2D_Ferlin', NULL, NULL, 'C2D_Ferlin', 10466),
(10467, 'cd18469', NULL, 'BACK_KLHL30', NULL, NULL, 'BACK_KLHL30', 10467),
(10468, 'cd01736', NULL, 'LSm14_N', NULL, NULL, 'LSm14_N', 10468),
(10469, 'cd14124', NULL, 'PK_VRK3', NULL, NULL, 'PK_VRK3', 10469),
(10470, 'cd05017', NULL, 'SIS_PGI_PMI_1', NULL, NULL, 'SIS_PGI_PMI_1', 10470),
(10471, 'cd13524', NULL, 'PBP2_Thiaminase_I', NULL, NULL, 'PBP2_Thiaminase_I', 10471);
INSERT INTO "PUBLIC"."MODEL" VALUES
(10472, 'cd16086', NULL, 'IgV_CD80', NULL, NULL, 'IgV_CD80', 10472),
(10473, 'cd05783', NULL, 'DNA_polB_B1_exo', NULL, NULL, 'DNA_polB_B1_exo', 10473),
(10474, 'cd09693', NULL, 'Cas5_I', NULL, NULL, 'Cas5_I', 10474),
(10475, 'cd03696', NULL, 'SelB_II', NULL, NULL, 'SelB_II', 10475),
(10476, 'cd05876', NULL, 'Ig3_L1-CAM', NULL, NULL, 'Ig3_L1-CAM', 10476),
(10477, 'cd00480', NULL, 'malate_synt', NULL, NULL, 'malate_synt', 10477),
(10478, 'cd12647', NULL, 'RRM_UHM_SPF45', NULL, NULL, 'RRM_UHM_SPF45', 10478),
(10479, 'cd18706', NULL, 'PIN_STKc_like', NULL, NULL, 'PIN_STKc_like', 10479),
(10480, 'cd08420', NULL, 'PBP2_CysL_like', NULL, NULL, 'PBP2_CysL_like', 10480),
(10481, 'cd15868', NULL, 'R-SNARE_VAMP8', NULL, NULL, 'R-SNARE_VAMP8', 10481),
(10482, 'cd01226', NULL, 'PH_RalBD_exo84', NULL, NULL, 'PH_RalBD_exo84', 10482),
(10483, 'cd04769', NULL, 'HTH_MerR2', NULL, NULL, 'HTH_MerR2', 10483),
(10484, 'cd15995', NULL, '7tmB2_GPR56', NULL, NULL, '7tmB2_GPR56', 10484),
(10485, 'cd07519', NULL, 'HAD_PTase', NULL, NULL, 'HAD_PTase', 10485),
(10486, 'cd15381', NULL, '7tmA_BK-2', NULL, NULL, '7tmA_BK-2', 10486),
(10487, 'cd05094', NULL, 'PTKc_TrkC', NULL, NULL, 'PTKc_TrkC', 10487),
(10488, 'cd07594', NULL, 'BAR_Endophilin_B', NULL, NULL, 'BAR_Endophilin_B', 10488),
(10489, 'cd09015', NULL, 'Ureohydrolase', NULL, NULL, 'Ureohydrolase', 10489),
(10490, 'cd08482', NULL, 'PBP2_TrpI', NULL, NULL, 'PBP2_TrpI', 10490),
(10491, 'cd03603', NULL, 'CLECT_VCBS', NULL, NULL, 'CLECT_VCBS', 10491),
(10492, 'cd13138', NULL, 'MATE_yoeA_like', NULL, NULL, 'MATE_yoeA_like', 10492),
(10493, 'cd00331', NULL, 'IGPS', NULL, NULL, 'IGPS', 10493),
(10494, 'cd01128', NULL, 'rho_factor', NULL, NULL, 'rho_factor', 10494),
(10495, 'cd04457', NULL, 'S1_S28E', NULL, NULL, 'S1_S28E', 10495),
(10496, 'cd20244', NULL, 'Toddler', NULL, NULL, 'Toddler', 10496),
(10497, 'cd08516', NULL, 'PBP2_NikA_DppA_OppA_like_11', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_11', 10497),
(10498, 'cd02965', NULL, 'HyaE', NULL, NULL, 'HyaE', 10498),
(10499, 'cd17355', NULL, 'MFS_YcxA_like', NULL, NULL, 'MFS_YcxA_like', 10499),
(10500, 'cd16692', NULL, 'mRING-H2-C3H3C2_WDR59', NULL, NULL, 'mRING-H2-C3H3C2_WDR59', 10500),
(10501, 'cd06135', NULL, 'Orn', NULL, NULL, 'Orn', 10501),
(10502, 'cd07254', NULL, 'VOC_like', NULL, NULL, 'VOC_like', 10502),
(10503, 'cd03051', NULL, 'GST_N_GTT2_like', NULL, NULL, 'GST_N_GTT2_like', 10503),
(10504, 'cd06904', NULL, 'M14_MpaA-like', NULL, NULL, 'M14_MpaA-like', 10504),
(10505, 'cd19471', NULL, 'FABP9', NULL, NULL, 'FABP9', 10505),
(10506, 'cd14937', NULL, 'MYSc_Myo24A', NULL, NULL, 'MYSc_Myo24A', 10506),
(10507, 'cd04584', NULL, 'CBS_pair_AcuB_like', NULL, NULL, 'CBS_pair_AcuB_like', 10507),
(10508, 'cd09686', NULL, 'Csx1_III-U', NULL, NULL, 'Csx1_III-U', 10508),
(10509, 'cd12504', NULL, 'RRM2_hnRNPH_like', NULL, NULL, 'RRM2_hnRNPH_like', 10509),
(10510, 'cd01676', NULL, 'RNR_II_monomer', NULL, NULL, 'RNR_II_monomer', 10510),
(10511, 'cd12775', NULL, 'RRM2_HuB', NULL, NULL, 'RRM2_HuB', 10511),
(10512, 'cd13388', NULL, 'PH1_FGD1-4_like', NULL, NULL, 'PH1_FGD1-4_like', 10512),
(10513, 'cd01522', NULL, 'RHOD_1', NULL, NULL, 'RHOD_1', 10513),
(10514, 'cd10797', NULL, 'GH57N_APU_like_1', NULL, NULL, 'GH57N_APU_like_1', 10514),
(10515, 'cd12370', NULL, 'RRM1_PUF60', NULL, NULL, 'RRM1_PUF60', 10515),
(10516, 'cd00895', NULL, 'PI3Kc_C2_beta', NULL, NULL, 'PI3Kc_C2_beta', 10516),
(10517, 'cd13844', NULL, 'CuRO_1_BOD_CotA_like', NULL, NULL, 'CuRO_1_BOD_CotA_like', 10517),
(10518, 'cd14453', NULL, 'CuRO_2_FV_like', NULL, NULL, 'CuRO_2_FV_like', 10518),
(10519, 'cd12173', NULL, 'PGDH_4', NULL, NULL, 'PGDH_4', 10519),
(10520, 'cd19436', NULL, 'lipocalin_crustacyanin', NULL, NULL, 'lipocalin_crustacyanin', 10520),
(10521, 'cd09571', NULL, 'SAM_tumor-p73', NULL, NULL, 'SAM_tumor-p73', 10521),
(10522, 'cd19881', NULL, 'DSRM_STAU1_rpt2', NULL, NULL, 'DSRM_STAU1_rpt2', 10522),
(10523, 'cd13552', NULL, 'PBP2_Fbp_like_6', NULL, NULL, 'PBP2_Fbp_like_6', 10523),
(10524, 'cd08278', NULL, 'benzyl_alcohol_DH', NULL, NULL, 'benzyl_alcohol_DH', 10524);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(10525, 'cd07407', NULL, 'MPP_YHR202W_N', NULL, NULL, 'MPP_YHR202W_N', 10525),
(10526, 'cd06915', NULL, 'NTP_transferase_WcbM_like', NULL, NULL, 'NTP_transferase_WcbM_like', 10526),
(10527, 'cd09547', NULL, 'SAM_EPH-A6', NULL, NULL, 'SAM_EPH-A6', 10527),
(10528, 'cd15101', NULL, '7tmA_LPAR', NULL, NULL, '7tmA_LPAR', 10528),
(10529, 'cd02050', NULL, 'serpinG1_C1-INH', NULL, NULL, 'serpinG1_C1-INH', 10529),
(10530, 'cd05894', NULL, 'Ig_C5_MyBP-C', NULL, NULL, 'Ig_C5_MyBP-C', 10530),
(10531, 'cd14632', NULL, 'R-PTPc-U-1', NULL, NULL, 'R-PTPc-U-1', 10531),
(10532, 'cd06889', NULL, 'PX_NoxO1', NULL, NULL, 'PX_NoxO1', 10532),
(10533, 'cd09002', NULL, 'GH43_XYL-like', NULL, NULL, 'GH43_XYL-like', 10533),
(10534, 'cd14048', NULL, 'STKc_EIF2AK3_PERK', NULL, NULL, 'STKc_EIF2AK3_PERK', 10534),
(10535, 'cd16345', NULL, 'LMWP_ArsC', NULL, NULL, 'LMWP_ArsC', 10535),
(10536, 'cd08824', NULL, 'LOTUS', NULL, NULL, 'LOTUS', 10536),
(10537, 'cd11883', NULL, 'SH3_Sdc25', NULL, NULL, 'SH3_Sdc25', 10537),
(10538, 'cd01384', NULL, 'MYSc_Myo11', NULL, NULL, 'MYSc_Myo11', 10538),
(10539, 'cd04880', NULL, 'ACT_AAAH-PDT-like', NULL, NULL, 'ACT_AAAH-PDT-like', 10539),
(10540, 'cd02756', NULL, 'MopB_Arsenite-Ox', NULL, NULL, 'MopB_Arsenite-Ox', 10540),
(10541, 'cd09826', NULL, 'peroxidasin_like', NULL, NULL, 'peroxidasin_like', 10541),
(10542, 'cd14372', NULL, 'CUE_Cue5p_like', NULL, NULL, 'CUE_Cue5p_like', 10542),
(10543, 'cd14117', NULL, 'STKc_Aurora-B_like', NULL, NULL, 'STKc_Aurora-B_like', 10543),
(10544, 'cd18776', NULL, 'AfaD-like', NULL, NULL, 'AfaD-like', 10544),
(10545, 'cd00246', NULL, 'RabGEF', NULL, NULL, 'RabGEF', 10545),
(10546, 'cd03322', NULL, 'RspA', NULL, NULL, 'RspA', 10546),
(10547, 'cd18983', NULL, 'CBD_MSL3_like', NULL, NULL, 'CBD_MSL3_like', 10547),
(10548, 'cd01203', NULL, 'PTB_DOK1_DOK2_DOK3', NULL, NULL, 'PTB_DOK1_DOK2_DOK3', 10548),
(10549, 'cd00400', NULL, 'Voltage_gated_ClC', NULL, NULL, 'Voltage_gated_ClC', 10549),
(10550, 'cd01638', NULL, 'CysQ', NULL, NULL, 'CysQ', 10550),
(10551, 'cd06442', NULL, 'DPM1_like', NULL, NULL, 'DPM1_like', 10551),
(10552, 'cd05471', NULL, 'pepsin_like', NULL, NULL, 'pepsin_like', 10552),
(10553, 'cd19939', NULL, 'REC_OmpR_BfmR-like', NULL, NULL, 'REC_OmpR_BfmR-like', 10553),
(10554, 'cd03256', NULL, 'ABC_PhnC_transporter', NULL, NULL, 'ABC_PhnC_transporter', 10554),
(10555, 'cd07302', NULL, 'CHD', NULL, NULL, 'CHD', 10555),
(10556, 'cd07208', NULL, 'Pat_hypo_Ecoli_yjju_like', NULL, NULL, 'Pat_hypo_Ecoli_yjju_like', 10556),
(10557, 'cd00913', NULL, 'PCD_DCoH_subfamily_a', NULL, NULL, 'PCD_DCoH_subfamily_a', 10557),
(10558, 'cd05832', NULL, 'Ribosomal_L12p', NULL, NULL, 'Ribosomal_L12p', 10558),
(10559, 'cd12013', NULL, 'SH3_RIM-BP_3', NULL, NULL, 'SH3_RIM-BP_3', 10559),
(10560, 'cd16863', NULL, 'ING_ING5', NULL, NULL, 'ING_ING5', 10560),
(10561, 'cd06066', NULL, 'H2MP_NAD-link-bidir', NULL, NULL, 'H2MP_NAD-link-bidir', 10561),
(10562, 'cd11371', NULL, 'RNase_PH_MTR3', NULL, NULL, 'RNase_PH_MTR3', 10562),
(10563, 'cd19197', NULL, 'PR-SET_PRDM13', NULL, NULL, 'PR-SET_PRDM13', 10563),
(10564, 'cd09674', NULL, 'Cas6_I-F', NULL, NULL, 'Cas6_I-F', 10564),
(10565, 'cd19434', NULL, 'lipocalin_YxeF', NULL, NULL, 'lipocalin_YxeF', 10565),
(10566, 'cd07729', NULL, 'AHL_lactonase_MBL-fold', NULL, NULL, 'AHL_lactonase_MBL-fold', 10566),
(10567, 'cd12310', NULL, 'RRM3_Spen', NULL, NULL, 'RRM3_Spen', 10567),
(10568, 'cd03058', NULL, 'GST_N_Tau', NULL, NULL, 'GST_N_Tau', 10568),
(10569, 'cd06217', NULL, 'FNR_iron_sulfur_binding_3', NULL, NULL, 'FNR_iron_sulfur_binding_3', 10569),
(10570, 'cd08187', NULL, 'BDH', NULL, NULL, 'BDH', 10570),
(10571, 'cd20256', NULL, 'Stannin_family', NULL, NULL, 'Stannin_family', 10571),
(10572, 'cd05586', NULL, 'STKc_Sck1_like', NULL, NULL, 'STKc_Sck1_like', 10572),
(10573, 'cd09908', NULL, 'H3TH_EXO1', NULL, NULL, 'H3TH_EXO1', 10573),
(10574, 'cd04884', NULL, 'ACT_CBS', NULL, NULL, 'ACT_CBS', 10574),
(10575, 'cd12786', NULL, 'RRM2_hnRPLL', NULL, NULL, 'RRM2_hnRPLL', 10575),
(10576, 'cd18308', NULL, 'BTB1_POZ_LZTR1', NULL, NULL, 'BTB1_POZ_LZTR1', 10576);
INSERT INTO "PUBLIC"."MODEL" VALUES
(10577, 'cd00778', NULL, 'ProRS_core_arch_euk', NULL, NULL, 'ProRS_core_arch_euk', 10577),
(10578, 'cd07896', NULL, 'Adenylation_kDNA_ligase_like', NULL, NULL, 'Adenylation_kDNA_ligase_like', 10578),
(10579, 'cd05025', NULL, 'S-100A1', NULL, NULL, 'S-100A1', 10579),
(10580, 'cd01315', NULL, 'L-HYD_ALN', NULL, NULL, 'L-HYD_ALN', 10580),
(10581, 'cd03751', NULL, 'proteasome_alpha_type_3', NULL, NULL, 'proteasome_alpha_type_3', 10581),
(10582, 'cd11235', NULL, 'Sema_semaphorin', NULL, NULL, 'Sema_semaphorin', 10582),
(10583, 'cd18954', NULL, 'bHLH_TS_bHLHe22_bHLHb5', NULL, NULL, 'bHLH_TS_bHLHe22_bHLHb5', 10583),
(10584, 'cd11867', NULL, 'hSH3_ADAP', NULL, NULL, 'hSH3_ADAP', 10584),
(10585, 'cd00325', NULL, 'chitinase_GH19', NULL, NULL, 'chitinase_GH19', 10585),
(10586, 'cd19350', NULL, 'wnt_Wnt7b', NULL, NULL, 'wnt_Wnt7b', 10586),
(10587, 'cd09900', NULL, 'H3TH_XPG-like', NULL, NULL, 'H3TH_XPG-like', 10587),
(10588, 'cd16563', NULL, 'RING-HC_RNF220', NULL, NULL, 'RING-HC_RNF220', 10588),
(10589, 'cd04820', NULL, 'PA_M28_1_1', NULL, NULL, 'PA_M28_1_1', 10589),
(10590, 'cd12919', NULL, 'VKOR_2', NULL, NULL, 'VKOR_2', 10590),
(10591, 'cd07683', NULL, 'F-BAR_srGAP1', NULL, NULL, 'F-BAR_srGAP1', 10591),
(10592, 'cd21592', NULL, 'MERS-CoV-like_RdRp', NULL, NULL, 'MERS-CoV-like_RdRp', 10592),
(10593, 'cd01674', NULL, 'Homoaconitase_Swivel', NULL, NULL, 'Homoaconitase_Swivel', 10593),
(10594, 'cd17113', NULL, 'RA_ARAPs', NULL, NULL, 'RA_ARAPs', 10594),
(10595, 'cd12662', NULL, 'RRM3_MYEF2', NULL, NULL, 'RRM3_MYEF2', 10595),
(10596, 'cd12204', NULL, 'CBD_like', NULL, NULL, 'CBD_like', 10596),
(10597, 'cd13875', NULL, 'CuRO_2_LCC_plant', NULL, NULL, 'CuRO_2_LCC_plant', 10597),
(10598, 'cd12331', NULL, 'RRM_NRD1_SEB1_like', NULL, NULL, 'RRM_NRD1_SEB1_like', 10598),
(10599, 'cd16989', NULL, 'ENTH_EpsinR', NULL, NULL, 'ENTH_EpsinR', 10599),
(10600, 'cd18232', NULL, 'BTB_POZ_ZBTB48_TZAP_KR3', NULL, NULL, 'BTB_POZ_ZBTB48_TZAP_KR3', 10600),
(10601, 'cd17427', NULL, 'MFS_MCT2', NULL, NULL, 'MFS_MCT2', 10601),
(10602, 'cd16303', NULL, 'VIM_type_MBL-B1', NULL, NULL, 'VIM_type_MBL-B1', 10602),
(10603, 'cd03004', NULL, 'PDI_a_ERdj5_C', NULL, NULL, 'PDI_a_ERdj5_C', 10603),
(10604, 'cd14697', NULL, 'bZIP_Maf', NULL, NULL, 'bZIP_Maf', 10604),
(10605, 'cd02569', NULL, 'PseudoU_synth_ScPus3', NULL, NULL, 'PseudoU_synth_ScPus3', 10605),
(10606, 'cd14654', NULL, 'ZIP_Gal4', NULL, NULL, 'ZIP_Gal4', 10606),
(10607, 'cd13785', NULL, 'CARD_BinCARD_like', NULL, NULL, 'CARD_BinCARD_like', 10607),
(10608, 'cd17986', NULL, 'DEXQc_DQX1', NULL, NULL, 'DEXQc_DQX1', 10608),
(10609, 'cd05108', NULL, 'PTKc_EGFR', NULL, NULL, 'PTKc_EGFR', 10609),
(10610, 'cd12122', NULL, 'AMPKA_C', NULL, NULL, 'AMPKA_C', 10610),
(10611, 'cd15490', NULL, 'eIF2_gamma_III', NULL, NULL, 'eIF2_gamma_III', 10611),
(10612, 'cd19792', NULL, 'Bbox2_TRIM62_C-IV', NULL, NULL, 'Bbox2_TRIM62_C-IV', 10612),
(10613, 'cd08637', NULL, 'DNA_pol_A_pol_I_C', NULL, NULL, 'DNA_pol_A_pol_I_C', 10613),
(10614, 'cd08620', NULL, 'PI-PLCXDc_like_1', NULL, NULL, 'PI-PLCXDc_like_1', 10614),
(10615, 'cd07018', NULL, 'S49_SppA_67K_type', NULL, NULL, 'S49_SppA_67K_type', 10615),
(10616, 'cd19992', NULL, 'PBP1_ABC_xylose_binding-like', NULL, NULL, 'PBP1_ABC_xylose_binding-like', 10616),
(10617, 'cd09766', NULL, 'Csx15_I-U', NULL, NULL, 'Csx15_I-U', 10617),
(10618, 'cd10285', NULL, 'somatotropin_like', NULL, NULL, 'somatotropin_like', 10618),
(10619, 'cd13915', NULL, 'CuRO_HCO_II_like_2', NULL, NULL, 'CuRO_HCO_II_like_2', 10619),
(10620, 'cd10478', NULL, 'EphR_LBD_B3', NULL, NULL, 'EphR_LBD_B3', 10620),
(10621, 'cd02698', NULL, 'Peptidase_C1A_CathepsinX', NULL, NULL, 'Peptidase_C1A_CathepsinX', 10621),
(10622, 'cd18228', NULL, 'BTB_POZ_ZBTB44', NULL, NULL, 'BTB_POZ_ZBTB44', 10622),
(10623, 'cd03260', NULL, 'ABC_PstB_phosphate_transporter', NULL, NULL, 'ABC_PstB_phosphate_transporter', 10623),
(10624, 'cd14060', NULL, 'STKc_MLTK', NULL, NULL, 'STKc_MLTK', 10624),
(10625, 'cd21172', NULL, 'NTD_dcv_Nsp15-like', NULL, NULL, 'NTD_dcv_Nsp15-like', 10625),
(10626, 'cd06444', NULL, 'DNA_pol_A', NULL, NULL, 'DNA_pol_A', 10626);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(10627, 'cd08196', NULL, 'Fe-ADH-like', NULL, NULL, 'Fe-ADH-like', 10627),
(10628, 'cd15562', NULL, 'PHD2_PHF14', NULL, NULL, 'PHD2_PHF14', 10628),
(10629, 'cd18613', NULL, 'GH130', NULL, NULL, 'GH130', 10629),
(10630, 'cd19018', NULL, 'LGIC_ECD_nAChR_A5', NULL, NULL, 'LGIC_ECD_nAChR_A5', 10630),
(10631, 'cd15553', NULL, 'PHD_Cfp1', NULL, NULL, 'PHD_Cfp1', 10631),
(10632, 'cd19608', NULL, 'GH113_mannanase-like', NULL, NULL, 'GH113_mannanase-like', 10632),
(10633, 'cd16508', NULL, 'RING-HC_HAKAI_like', NULL, NULL, 'RING-HC_HAKAI_like', 10633),
(10634, 'cd18237', NULL, 'BTB_POZ_KLHL7', NULL, NULL, 'BTB_POZ_KLHL7', 10634),
(10635, 'cd16515', NULL, 'RING-HC_LRSAM1', NULL, NULL, 'RING-HC_LRSAM1', 10635),
(10636, 'cd18766', NULL, 'PIN_MtVapC3-like', NULL, NULL, 'PIN_MtVapC3-like', 10636),
(10637, 'cd04040', NULL, 'C2D_Tricalbin-like', NULL, NULL, 'C2D_Tricalbin-like', 10637),
(10638, 'cd10558', NULL, 'FDH-N', NULL, NULL, 'FDH-N', 10638),
(10639, 'cd15471', NULL, 'Myo5p-like_CBD_afadin', NULL, NULL, 'Myo5p-like_CBD_afadin', 10639),
(10640, 'cd08056', NULL, 'MPN_PRP8', NULL, NULL, 'MPN_PRP8', 10640),
(10641, 'cd01718', NULL, 'Sm_E', NULL, NULL, 'Sm_E', 10641),
(10642, 'cd08210', NULL, 'RLP_RrRLP', NULL, NULL, 'RLP_RrRLP', 10642),
(10643, 'cd01908', NULL, 'YafJ', NULL, NULL, 'YafJ', 10643),
(10644, 'cd13169', NULL, 'RanBD_NUP50_plant', NULL, NULL, 'RanBD_NUP50_plant', 10644),
(10645, 'cd04258', NULL, 'AAK_AKiii-LysC-EC', NULL, NULL, 'AAK_AKiii-LysC-EC', 10645),
(10646, 'cd03257', NULL, 'ABC_NikE_OppD_transporters', NULL, NULL, 'ABC_NikE_OppD_transporters', 10646),
(10647, 'cd12522', NULL, 'RRM4_MRN1', NULL, NULL, 'RRM4_MRN1', 10647),
(10648, 'cd14569', NULL, 'DSP_slingshot_2', NULL, NULL, 'DSP_slingshot_2', 10648),
(10649, 'cd07177', NULL, 'terB_like', NULL, NULL, 'terB_like', 10649),
(10650, 'cd11019', NULL, 'OsENODL1_like', NULL, NULL, 'OsENODL1_like', 10650),
(10651, 'cd19565', NULL, 'serpinB6_CAP', NULL, NULL, 'serpinB6_CAP', 10651),
(10652, 'cd16540', NULL, 'RING-HC_RNF114', NULL, NULL, 'RING-HC_RNF114', 10652),
(10653, 'cd15111', NULL, '7tmA_MrgprG', NULL, NULL, '7tmA_MrgprG', 10653),
(10654, 'cd15626', NULL, 'PHD_SP110_140', NULL, NULL, 'PHD_SP110_140', 10654),
(10655, 'cd19106', NULL, 'AKR_AKR1A1-4', NULL, NULL, 'AKR_AKR1A1-4', 10655),
(10656, 'cd11973', NULL, 'SH3_ASEF', NULL, NULL, 'SH3_ASEF', 10656),
(10657, 'cd16802', NULL, 'RING-H2_RNF128_like', NULL, NULL, 'RING-H2_RNF128_like', 10657),
(10658, 'cd01320', NULL, 'ADA', NULL, NULL, 'ADA', 10658),
(10659, 'cd08638', NULL, 'DNA_pol_A_theta', NULL, NULL, 'DNA_pol_A_theta', 10659),
(10660, 'cd17637', NULL, 'ACLS-CaiC', NULL, NULL, 'ACLS-CaiC', 10660),
(10661, 'cd18568', NULL, 'ABC_6TM_HetC_like', NULL, NULL, 'ABC_6TM_HetC_like', 10661),
(10662, 'cd13366', NULL, 'PH_ABR', NULL, NULL, 'PH_ABR', 10662),
(10663, 'cd03805', NULL, 'GT4_ALG2-like', NULL, NULL, 'GT4_ALG2-like', 10663),
(10664, 'cd11441', NULL, 'bHLH-PAS_CLOCK_like', NULL, NULL, 'bHLH-PAS_CLOCK_like', 10664),
(10665, 'cd08609', NULL, 'GDPD_GDE3', NULL, NULL, 'GDPD_GDE3', 10665),
(10666, 'cd15876', NULL, 'SNARE_syntaxin12', NULL, NULL, 'SNARE_syntaxin12', 10666),
(10667, 'cd07898', NULL, 'Adenylation_DNA_ligase', NULL, NULL, 'Adenylation_DNA_ligase', 10667),
(10668, 'cd04327', NULL, 'ZnMc_MMP_like_3', NULL, NULL, 'ZnMc_MMP_like_3', 10668),
(10669, 'cd11729', NULL, 'ADDz_Dnmt3a', NULL, NULL, 'ADDz_Dnmt3a', 10669),
(10670, 'cd14685', NULL, 'RanBD3_RanBP2-like', NULL, NULL, 'RanBD3_RanBP2-like', 10670),
(10671, 'cd05720', NULL, 'Ig_CD8_alpha', NULL, NULL, 'Ig_CD8_alpha', 10671),
(10672, 'cd16083', NULL, 'IgC_CD80', NULL, NULL, 'IgC_CD80', 10672),
(10673, 'cd16123', NULL, 'RA_RASSF7_like', NULL, NULL, 'RA_RASSF7_like', 10673),
(10674, 'cd11958', NULL, 'SH3_RUSC1', NULL, NULL, 'SH3_RUSC1', 10674),
(10675, 'cd04399', NULL, 'RhoGAP_fRGD2', NULL, NULL, 'RhoGAP_fRGD2', 10675),
(10676, 'cd17157', NULL, 'DCX2_DCDC5', NULL, NULL, 'DCX2_DCDC5', 10676),
(10677, 'cd08211', NULL, 'RuBisCO_large_II', NULL, NULL, 'RuBisCO_large_II', 10677),
(10678, 'cd16693', NULL, 'mRING-H2-C3H3C2_WDR24', NULL, NULL, 'mRING-H2-C3H3C2_WDR24', 10678);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(10679, 'cd01060', NULL, 'Membrane-FADS-like', NULL, NULL, 'Membrane-FADS-like', 10679),
(10680, 'cd14722', NULL, 'bZIP_ATF3', NULL, NULL, 'bZIP_ATF3', 10680),
(10681, 'cd02187', NULL, 'beta_tubulin', NULL, NULL, 'beta_tubulin', 10681),
(10682, 'cd01334', NULL, 'Lyase_I', NULL, NULL, 'Lyase_I', 10682),
(10683, 'cd09171', NULL, 'PLDc_vPLD6_like', NULL, NULL, 'PLDc_vPLD6_like', 10683),
(10684, 'cd09560', NULL, 'SAM_SASH3', NULL, NULL, 'SAM_SASH3', 10684),
(10685, 'cd19697', NULL, 'bHLH-PAS_NPAS4_PASD10', NULL, NULL, 'bHLH-PAS_NPAS4_PASD10', 10685),
(10686, 'cd00919', NULL, 'Heme_Cu_Oxidase_I', NULL, NULL, 'Heme_Cu_Oxidase_I', 10686),
(10687, 'cd13430', NULL, 'LDT_IgD_like', NULL, NULL, 'LDT_IgD_like', 10687),
(10688, 'cd16923', NULL, 'HATPase_VanS-like', NULL, NULL, 'HATPase_VanS-like', 10688),
(10689, 'cd00836', NULL, 'FERM_C-lobe', NULL, NULL, 'FERM_C-lobe', 10689),
(10690, 'cd07036', NULL, 'TPP_PYR_E1-PDHc-beta_like', NULL, NULL, 'TPP_PYR_E1-PDHc-beta_like', 10690),
(10691, 'cd11284', NULL, 'ADF_Twf-C_like', NULL, NULL, 'ADF_Twf-C_like', 10691),
(10692, 'cd05674', NULL, 'M20_yscS', NULL, NULL, 'M20_yscS', 10692),
(10693, 'cd19122', NULL, 'AKR_AKR3E1', NULL, NULL, 'AKR_AKR3E1', 10693),
(10694, 'cd07377', NULL, 'WHTH_GntR', NULL, NULL, 'WHTH_GntR', 10694),
(10695, 'cd16014', NULL, 'PLC', NULL, NULL, 'PLC', 10695),
(10696, 'cd14427', NULL, 'UBA2_HR23A', NULL, NULL, 'UBA2_HR23A', 10696),
(10697, 'cd01835', NULL, 'SGNH_hydrolase_like_3', NULL, NULL, 'SGNH_hydrolase_like_3', 10697),
(10698, 'cd16119', NULL, 'UBX_UBXN6', NULL, NULL, 'UBX_UBXN6', 10698),
(10699, 'cd07820', NULL, 'SRPBCC_3', NULL, NULL, 'SRPBCC_3', 10699),
(10700, 'cd00814', NULL, 'MetRS_core', NULL, NULL, 'MetRS_core', 10700),
(10701, 'cd03124', NULL, 'alpha_CA_prokaryotic_like', NULL, NULL, 'alpha_CA_prokaryotic_like', 10701),
(10702, 'cd13764', NULL, 'TGF_beta_GDF1_3_like', NULL, NULL, 'TGF_beta_GDF1_3_like', 10702),
(10703, 'cd09417', NULL, 'LIM2_LIMPETin_like', NULL, NULL, 'LIM2_LIMPETin_like', 10703),
(10704, 'cd12572', NULL, 'RRM2_MSI1', NULL, NULL, 'RRM2_MSI1', 10704),
(10705, 'cd07852', NULL, 'STKc_MAPK15-like', NULL, NULL, 'STKc_MAPK15-like', 10705),
(10706, 'cd03350', NULL, 'LbH_THP_succinylT', NULL, NULL, 'LbH_THP_succinylT', 10706),
(10707, 'cd06449', NULL, 'ACCD', NULL, NULL, 'ACCD', 10707),
(10708, 'cd13865', NULL, 'CuRO_1_LCC_like_3', NULL, NULL, 'CuRO_1_LCC_like_3', 10708),
(10709, 'cd18567', NULL, 'ABC_6TM_CvaB_RaxB_like', NULL, NULL, 'ABC_6TM_CvaB_RaxB_like', 10709),
(10710, 'cd08417', NULL, 'PBP2_Nitroaromatics_like', NULL, NULL, 'PBP2_Nitroaromatics_like', 10710),
(10711, 'cd04036', NULL, 'C2_cPLA2', NULL, NULL, 'C2_cPLA2', 10711),
(10712, 'cd18707', NULL, 'PIN_VapC-like', NULL, NULL, 'PIN_VapC-like', 10712),
(10713, 'cd14446', NULL, 'bt3222_like', NULL, NULL, 'bt3222_like', 10713),
(10714, 'cd17089', NULL, 'FERM_F0_TLN', NULL, NULL, 'FERM_F0_TLN', 10714),
(10715, 'cd18330', NULL, 'BTB_POZ_ZBTB8B', NULL, NULL, 'BTB_POZ_ZBTB8B', 10715),
(10716, 'cd15228', NULL, '7tmA_OR10D-like', NULL, NULL, '7tmA_OR10D-like', 10716),
(10717, 'cd18342', NULL, 'BTB_POZ_SPOP', NULL, NULL, 'BTB_POZ_SPOP', 10717),
(10718, 'cd05793', NULL, 'S1_IF1A', NULL, NULL, 'S1_IF1A', 10718),
(10719, 'cd09368', NULL, 'LIM1_Lhx3_Lhx4', NULL, NULL, 'LIM1_Lhx3_Lhx4', 10719),
(10720, 'cd07516', NULL, 'HAD_Pase', NULL, NULL, 'HAD_Pase', 10720),
(10721, 'cd10284', NULL, 'growth_hormone_like', NULL, NULL, 'growth_hormone_like', 10721),
(10722, 'cd15881', NULL, 'SNARE_syntaxin3', NULL, NULL, 'SNARE_syntaxin3', 10722),
(10723, 'cd00881', NULL, 'GTP_translation_factor', NULL, NULL, 'GTP_translation_factor', 10723),
(10724, 'cd05926', NULL, 'FACL_fum10p_like', NULL, NULL, 'FACL_fum10p_like', 10724),
(10725, 'cd10420', NULL, 'SH2_STAT5b', NULL, NULL, 'SH2_STAT5b', 10725),
(10726, 'cd11847', NULL, 'SH3_Brk', NULL, NULL, 'SH3_Brk', 10726),
(10727, 'cd05785', NULL, 'DNA_polB_like2_exo', NULL, NULL, 'DNA_polB_like2_exo', 10727),
(10728, 'cd10413', NULL, 'SH2_Grb7', NULL, NULL, 'SH2_Grb7', 10728),
(10729, 'cd17256', NULL, 'RMtype1_S_EcoJA65PI-TRD1-CR1_like', NULL, NULL, 'RMtype1_S_EcoJA65PI-TRD1-CR1_like', 10729);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(10730, 'cd19567', NULL, 'serpinB8_CAP-2', NULL, NULL, 'serpinB8_CAP-2', 10730),
(10731, 'cd13350', NULL, 'PH-GRAM1_TBC1D8B', NULL, NULL, 'PH-GRAM1_TBC1D8B', 10731),
(10732, 'cd12098', NULL, 'DD_R_PKA_fungi', NULL, NULL, 'DD_R_PKA_fungi', 10732),
(10733, 'cd11743', NULL, 'Cthe_2751_like', NULL, NULL, 'Cthe_2751_like', 10733),
(10734, 'cd19833', NULL, 'Bbox2_MuRF3_C-II', NULL, NULL, 'Bbox2_MuRF3_C-II', 10734),
(10735, 'cd04132', NULL, 'Rho4_like', NULL, NULL, 'Rho4_like', 10735),
(10736, 'cd11367', NULL, 'RNase_PH_RRP42', NULL, NULL, 'RNase_PH_RRP42', 10736),
(10737, 'cd13114', NULL, 'POLO_box_Plk4_1', NULL, NULL, 'POLO_box_Plk4_1', 10737),
(10738, 'cd17602', NULL, 'REC_PatA-like', NULL, NULL, 'REC_PatA-like', 10738),
(10739, 'cd16739', NULL, 'RING-HC_RING1', NULL, NULL, 'RING-HC_RING1', 10739),
(10740, 'cd19728', NULL, 'bHLH-PAS_HIF2a_PASD2', NULL, NULL, 'bHLH-PAS_HIF2a_PASD2', 10740),
(10741, 'cd12219', NULL, 'Ubl_TBK1_like', NULL, NULL, 'Ubl_TBK1_like', 10741),
(10742, 'cd01935', NULL, 'Ntn_CGH_like', NULL, NULL, 'Ntn_CGH_like', 10742),
(10743, 'cd19398', NULL, 'TGF_beta_BMP8', NULL, NULL, 'TGF_beta_BMP8', 10743),
(10744, 'cd07402', NULL, 'MPP_GpdQ', NULL, NULL, 'MPP_GpdQ', 10744),
(10745, 'cd19844', NULL, 'Bbox1_TRIM67_C-I', NULL, NULL, 'Bbox1_TRIM67_C-I', 10745),
(10746, 'cd03377', NULL, 'TPP_PFOR_PNO', NULL, NULL, 'TPP_PFOR_PNO', 10746),
(10747, 'cd12463', NULL, 'RRM_G3BP1', NULL, NULL, 'RRM_G3BP1', 10747),
(10748, 'cd13715', NULL, 'PBP2_iGluR_AMPA', NULL, NULL, 'PBP2_iGluR_AMPA', 10748),
(10749, 'cd16254', NULL, 'EFh_parvalbumin_alpha', NULL, NULL, 'EFh_parvalbumin_alpha', 10749),
(10750, 'cd01089', NULL, 'PA2G4-like', NULL, NULL, 'PA2G4-like', 10750),
(10751, 'cd08437', NULL, 'PBP2_MleR', NULL, NULL, 'PBP2_MleR', 10751),
(10752, 'cd01485', NULL, 'E1-1_like', NULL, NULL, 'E1-1_like', 10752),
(10753, 'cd15032', NULL, '7tmF_FZD6', NULL, NULL, '7tmF_FZD6', 10753),
(10754, 'cd05881', NULL, 'Ig1_Necl-2', NULL, NULL, 'Ig1_Necl-2', 10754),
(10755, 'cd17369', NULL, 'MFS_ShiA_like', NULL, NULL, 'MFS_ShiA_like', 10755),
(10756, 'cd08870', NULL, 'START_STARD2_7-like', NULL, NULL, 'START_STARD2_7-like', 10756),
(10757, 'cd08687', NULL, 'C2_PKN-like', NULL, NULL, 'C2_PKN-like', 10757),
(10758, 'cd16519', NULL, 'RING-HC_MIBs', NULL, NULL, 'RING-HC_MIBs', 10758),
(10759, 'cd02185', NULL, 'AroH', NULL, NULL, 'AroH', 10759),
(10760, 'cd13316', NULL, 'PH_Boi', NULL, NULL, 'PH_Boi', 10760),
(10761, 'cd09691', NULL, 'Cas8b_I-B', NULL, NULL, 'Cas8b_I-B', 10761),
(10762, 'cd04386', NULL, 'RhoGAP_nadrin', NULL, NULL, 'RhoGAP_nadrin', 10762),
(10763, 'cd17526', NULL, 'RMtype1_S_Cje2232P-TRD2-CR2_like', NULL, NULL, 'RMtype1_S_Cje2232P-TRD2-CR2_like', 10763),
(10764, 'cd18399', NULL, 'BTB_POZ_KCTD10_BACURD3', NULL, NULL, 'BTB_POZ_KCTD10_BACURD3', 10764),
(10765, 'cd00590', NULL, 'RRM_SF', NULL, NULL, 'RRM_SF', 10765),
(10766, 'cd05493', NULL, 'Bromo_ALL-1', NULL, NULL, 'Bromo_ALL-1', 10766),
(10767, 'cd06849', NULL, 'lipoyl_domain', NULL, NULL, 'lipoyl_domain', 10767),
(10768, 'cd18696', NULL, 'PIN_MtVapC26-like', NULL, NULL, 'PIN_MtVapC26-like', 10768),
(10769, 'cd06532', NULL, 'Glyco_transf_25', NULL, NULL, 'Glyco_transf_25', 10769),
(10770, 'cd09555', NULL, 'SAM_EPH-B6', NULL, NULL, 'SAM_EPH-B6', 10770),
(10771, 'cd07950', NULL, 'Gallate_Doxase_N', NULL, NULL, 'Gallate_Doxase_N', 10771),
(10772, 'cd18021', NULL, 'DEXHc_Brr2_2', NULL, NULL, 'DEXHc_Brr2_2', 10772),
(10773, 'cd00107', NULL, 'Knot1', NULL, NULL, 'Knot1', 10773),
(10774, 'cd16273', NULL, 'SNM1A-1C-like_MBL-fold', NULL, NULL, 'SNM1A-1C-like_MBL-fold', 10774),
(10775, 'cd00534', NULL, 'DHNA_DHNTPE', NULL, NULL, 'DHNA_DHNTPE', 10775),
(10776, 'cd15910', NULL, '7tmF_FZD3_FZD6-like', NULL, NULL, '7tmF_FZD3_FZD6-like', 10776),
(10777, 'cd07289', NULL, 'PX_PI3K_C2_alpha', NULL, NULL, 'PX_PI3K_C2_alpha', 10777),
(10778, 'cd08599', NULL, 'PI-PLCc_plant', NULL, NULL, 'PI-PLCc_plant', 10778),
(10779, 'cd00936', NULL, 'WEPRS_RNA', NULL, NULL, 'WEPRS_RNA', 10779),
(10780, 'cd18406', NULL, 'BTB_POZ_KCNA5', NULL, NULL, 'BTB_POZ_KCNA5', 10780),
(10781, 'cd14635', NULL, 'R-PTPc-M-2', NULL, NULL, 'R-PTPc-M-2', 10781);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(10782, 'cd16516', NULL, 'RING-HC_malin', NULL, NULL, 'RING-HC_malin', 10782),
(10783, 'cd16742', NULL, 'RING-HC_RNFT2', NULL, NULL, 'RING-HC_RNFT2', 10783),
(10784, 'cd17710', NULL, 'BRCT_PAXIP1_rpt2', NULL, NULL, 'BRCT_PAXIP1_rpt2', 10784),
(10785, 'cd21167', NULL, 'M_alpha_beta_cv_Nsp15-like', NULL, NULL, 'M_alpha_beta_cv_Nsp15-like', 10785),
(10786, 'cd17905', NULL, 'CheC-like', NULL, NULL, 'CheC-like', 10786),
(10787, 'cd01799', NULL, 'Ubl_HOIL1', NULL, NULL, 'Ubl_HOIL1', 10787),
(10788, 'cd16532', NULL, 'RING-HC_RNFT1_like', NULL, NULL, 'RING-HC_RNFT1_like', 10788),
(10789, 'cd01983', NULL, 'SIMIBI', NULL, NULL, 'SIMIBI', 10789),
(10790, 'cd18013', NULL, 'DEXQc_bact_SNF2', NULL, NULL, 'DEXQc_bact_SNF2', 10790),
(10791, 'cd14292', NULL, 'UBA2_NUB1', NULL, NULL, 'UBA2_NUB1', 10791),
(10792, 'cd02781', NULL, 'MopB_CT_Acetylene-hydratase', NULL, NULL, 'MopB_CT_Acetylene-hydratase', 10792),
(10793, 'cd17480', NULL, 'MFS_SLC40A1_like', NULL, NULL, 'MFS_SLC40A1_like', 10793),
(10794, 'cd03763', NULL, 'proteasome_beta_type_7', NULL, NULL, 'proteasome_beta_type_7', 10794),
(10795, 'cd09487', NULL, 'SAM_superfamily', NULL, NULL, 'SAM_superfamily', 10795),
(10796, 'cd12611', NULL, 'RRM1_NGR1_NAM8_like', NULL, NULL, 'RRM1_NGR1_NAM8_like', 10796),
(10797, 'cd13232', NULL, 'Ig-PH_SCAB1', NULL, NULL, 'Ig-PH_SCAB1', 10797),
(10798, 'cd21479', NULL, 'MERS-like_CoV_Spike_S1_RBD', NULL, NULL, 'MERS-like_CoV_Spike_S1_RBD', 10798),
(10799, 'cd17081', NULL, 'RAWUL_PCGF1', NULL, NULL, 'RAWUL_PCGF1', 10799),
(10800, 'cd18782', NULL, 'ABC_6TM_PrtD_LapB_HlyB_like', NULL, NULL, 'ABC_6TM_PrtD_LapB_HlyB_like', 10800),
(10801, 'cd04650', NULL, 'LbH_FBP', NULL, NULL, 'LbH_FBP', 10801),
(10802, 'cd15161', NULL, '7tmA_GPR17', NULL, NULL, '7tmA_GPR17', 10802),
(10803, 'cd07101', NULL, 'ALDH_SSADH2_GabD2', NULL, NULL, 'ALDH_SSADH2_GabD2', 10803),
(10804, 'cd07773', NULL, 'FGGY_FK', NULL, NULL, 'FGGY_FK', 10804),
(10805, 'cd12168', NULL, 'Mand_dh_like', NULL, NULL, 'Mand_dh_like', 10805),
(10806, 'cd14822', NULL, 'BACK_BTBD9', NULL, NULL, 'BACK_BTBD9', 10806),
(10807, 'cd00218', NULL, 'GlcAT-I', NULL, NULL, 'GlcAT-I', 10807),
(10808, 'cd05272', NULL, 'TDH_SDR_e', NULL, NULL, 'TDH_SDR_e', 10808),
(10809, 'cd06334', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, 'PBP1_ABC_ligand_binding-like', 10809),
(10810, 'cd04139', NULL, 'RalA_RalB', NULL, NULL, 'RalA_RalB', 10810),
(10811, 'cd00495', NULL, 'Ribosomal_L25_TL5_CTC', NULL, NULL, 'Ribosomal_L25_TL5_CTC', 10811),
(10812, 'cd13845', NULL, 'CuRO_1_AAO', NULL, NULL, 'CuRO_1_AAO', 10812),
(10813, 'cd08785', NULL, 'CARD_CARD9-like', NULL, NULL, 'CARD_CARD9-like', 10813),
(10814, 'cd12562', NULL, 'RRM2_RBM5_like', NULL, NULL, 'RRM2_RBM5_like', 10814),
(10815, 'cd07948', NULL, 'DRE_TIM_HCS', NULL, NULL, 'DRE_TIM_HCS', 10815),
(10816, 'cd12829', NULL, 'Alr1p-like', NULL, NULL, 'Alr1p-like', 10816),
(10817, 'cd17184', NULL, 'FERM_F1_KIND2', NULL, NULL, 'FERM_F1_KIND2', 10817),
(10818, 'cd04410', NULL, 'DMSOR_beta-like', NULL, NULL, 'DMSOR_beta-like', 10818),
(10819, 'cd08378', NULL, 'C2B_MCTP_PRT_plant', NULL, NULL, 'C2B_MCTP_PRT_plant', 10819),
(10820, 'cd15878', NULL, 'SNARE_syntaxin11', NULL, NULL, 'SNARE_syntaxin11', 10820),
(10821, 'cd12718', NULL, 'RRM_BRAP2', NULL, NULL, 'RRM_BRAP2', 10821),
(10822, 'cd02223', NULL, 'cupin_Bh2720-like', NULL, NULL, 'cupin_Bh2720-like', 10822),
(10823, 'cd19780', NULL, 'Bbox2_TRIM39-like', NULL, NULL, 'Bbox2_TRIM39-like', 10823),
(10824, 'cd04173', NULL, 'Rnd2_Rho7', NULL, NULL, 'Rnd2_Rho7', 10824),
(10825, 'cd03119', NULL, 'alpha_CA_I_II_III_XIII', NULL, NULL, 'alpha_CA_I_II_III_XIII', 10825),
(10826, 'cd18243', NULL, 'BTB_POZ_KLHL14_printor', NULL, NULL, 'BTB_POZ_KLHL14_printor', 10826),
(10827, 'cd08429', NULL, 'PBP2_NhaR', NULL, NULL, 'PBP2_NhaR', 10827),
(10828, 'cd18955', NULL, 'BTB_POZ_BACH', NULL, NULL, 'BTB_POZ_BACH', 10828),
(10829, 'cd15758', NULL, 'FYVE_RUFY1', NULL, NULL, 'FYVE_RUFY1', 10829),
(10830, 'cd12225', NULL, 'RRM1_2_CID8_like', NULL, NULL, 'RRM1_2_CID8_like', 10830),
(10831, 'cd16628', NULL, 'RING-HC_RBR_RNF14', NULL, NULL, 'RING-HC_RBR_RNF14', 10831);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(10832, 'cd06576', NULL, 'PASTA_Pbp2x-like_1', NULL, NULL, 'PASTA_Pbp2x-like_1', 10832),
(10833, 'cd13274', NULL, 'PH_DGK_type2', NULL, NULL, 'PH_DGK_type2', 10833),
(10834, 'cd11005', NULL, 'M35_like', NULL, NULL, 'M35_like', 10834),
(10835, 'cd18775', NULL, 'SafA-like', NULL, NULL, 'SafA-like', 10835),
(10836, 'cd17665', NULL, 'DSP_DUSP11', NULL, NULL, 'DSP_DUSP11', 10836),
(10837, 'cd14682', NULL, 'PH-EXOC1_like', NULL, NULL, 'PH-EXOC1_like', 10837),
(10838, 'cd10571', NULL, 'PH_beta_spectrin', NULL, NULL, 'PH_beta_spectrin', 10838),
(10839, 'cd16678', NULL, 'RING2-H2_RNF32', NULL, NULL, 'RING2-H2_RNF32', 10839),
(10840, 'cd01278', NULL, 'aprataxin_related', NULL, NULL, 'aprataxin_related', 10840),
(10841, 'cd17267', NULL, 'RMtype1_S_EcoAO83I-TRD1-CR1_like', NULL, NULL, 'RMtype1_S_EcoAO83I-TRD1-CR1_like', 10841),
(10842, 'cd00145', NULL, 'POLBc', NULL, NULL, 'POLBc', 10842),
(10843, 'cd12616', NULL, 'RRM1_TIAR', NULL, NULL, 'RRM1_TIAR', 10843),
(10844, 'cd02245', NULL, 'cupin_7S_vicilin-like_C', NULL, NULL, 'cupin_7S_vicilin-like_C', 10844),
(10845, 'cd14004', NULL, 'STKc_PASK', NULL, NULL, 'STKc_PASK', 10845),
(10846, 'cd11476', NULL, 'SLC5sbd_DUR3', NULL, NULL, 'SLC5sbd_DUR3', 10846),
(10847, 'cd14539', NULL, 'PTP-N23', NULL, NULL, 'PTP-N23', 10847),
(10848, 'cd04703', NULL, 'Asparaginase_2_like_1', NULL, NULL, 'Asparaginase_2_like_1', 10848),
(10849, 'cd18595', NULL, 'ABC_6TM_MRP1_2_3_6_D1_like', NULL, NULL, 'ABC_6TM_MRP1_2_3_6_D1_like', 10849),
(10850, 'cd15866', NULL, 'R-SNARE_SEC22', NULL, NULL, 'R-SNARE_SEC22', 10850),
(10851, 'cd06110', NULL, 'BSuCS-II_like', NULL, NULL, 'BSuCS-II_like', 10851),
(10852, 'cd07050', NULL, 'BMC_EutL_repeat2', NULL, NULL, 'BMC_EutL_repeat2', 10852),
(10853, 'cd16186', NULL, 'EFh_PEF_grancalcin', NULL, NULL, 'EFh_PEF_grancalcin', 10853),
(10854, 'cd15238', NULL, '7tm_ARII-like', NULL, NULL, '7tm_ARII-like', 10854),
(10855, 'cd09391', NULL, 'LIM1_Lrg1p_like', NULL, NULL, 'LIM1_Lrg1p_like', 10855),
(10856, 'cd11899', NULL, 'SH3_Nck2_1', NULL, NULL, 'SH3_Nck2_1', 10856),
(10857, 'cd16598', NULL, 'RING-HC_TRIM26_C-IV', NULL, NULL, 'RING-HC_TRIM26_C-IV', 10857),
(10858, 'cd01057', NULL, 'AAMH_A', NULL, NULL, 'AAMH_A', 10858),
(10859, 'cd05502', NULL, 'Bromo_tif1_like', NULL, NULL, 'Bromo_tif1_like', 10859),
(10860, 'cd00233', NULL, 'VIP2', NULL, NULL, 'VIP2', 10860),
(10861, 'cd06944', NULL, 'NR_LBD_Ftz-F1_like', NULL, NULL, 'NR_LBD_Ftz-F1_like', 10861),
(10862, 'cd05260', NULL, 'GDP_MD_SDR_e', NULL, NULL, 'GDP_MD_SDR_e', 10862),
(10863, 'cd18481', NULL, 'BACK_KBTBD4', NULL, NULL, 'BACK_KBTBD4', 10863),
(10864, 'cd13753', NULL, 'TGF_beta_TGFbeta1_2_3', NULL, NULL, 'TGF_beta_TGFbeta1_2_3', 10864),
(10865, 'cd05904', NULL, '4CL', NULL, NULL, '4CL', 10865),
(10866, 'cd09079', NULL, 'RgfB-like', NULL, NULL, 'RgfB-like', 10866),
(10867, 'cd18892', NULL, 'TET', NULL, NULL, 'TET', 10867),
(10868, 'cd05774', NULL, 'Ig_CEACAM_D1', NULL, NULL, 'Ig_CEACAM_D1', 10868),
(10869, 'cd08230', NULL, 'glucose_DH', NULL, NULL, 'glucose_DH', 10869),
(10870, 'cd02699', NULL, 'M4_M36', NULL, NULL, 'M4_M36', 10870),
(10871, 'cd01161', NULL, 'VLCAD', NULL, NULL, 'VLCAD', 10871),
(10872, 'cd04517', NULL, 'TLF', NULL, NULL, 'TLF', 10872),
(10873, 'cd12288', NULL, 'RRM_La_like_plant', NULL, NULL, 'RRM_La_like_plant', 10873),
(10874, 'cd01071', NULL, 'PBP2_PhnD_like', NULL, NULL, 'PBP2_PhnD_like', 10874),
(10875, 'cd17782', NULL, 'CBS_pair_MUG70_2', NULL, NULL, 'CBS_pair_MUG70_2', 10875),
(10876, 'cd10459', NULL, 'PUB_PNGase', NULL, NULL, 'PUB_PNGase', 10876),
(10877, 'cd16680', NULL, 'RING-H2_RNF44', NULL, NULL, 'RING-H2_RNF44', 10877),
(10878, 'cd09668', NULL, 'Csx1_III-U', NULL, NULL, 'Csx1_III-U', 10878),
(10879, 'cd14972', NULL, '7tmA_EDG-like', NULL, NULL, '7tmA_EDG-like', 10879),
(10880, 'cd17624', NULL, 'REC_OmpR_PmrA-like', NULL, NULL, 'REC_OmpR_PmrA-like', 10880),
(10881, 'cd08964', NULL, 'L-asparaginase_II', NULL, NULL, 'L-asparaginase_II', 10881),
(10882, 'cd15185', NULL, '7tmA_CCR3', NULL, NULL, '7tmA_CCR3', 10882),
(10883, 'cd01061', NULL, 'RNase_T2_euk', NULL, NULL, 'RNase_T2_euk', 10883);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(10884, 'cd09612', NULL, 'Jacalin', NULL, NULL, 'Jacalin', 10884),
(10885, 'cd14490', NULL, 'CBM6-CBM35-CBM36_like_1', NULL, NULL, 'CBM6-CBM35-CBM36_like_1', 10885),
(10886, 'cd00641', NULL, 'GTP_cyclohydro2', NULL, NULL, 'GTP_cyclohydro2', 10886),
(10887, 'cd06407', NULL, 'PB1_NLP', NULL, NULL, 'PB1_NLP', 10887),
(10888, 'cd01379', NULL, 'MYSc_Myo3', NULL, NULL, 'MYSc_Myo3', 10888),
(10889, 'cd09897', NULL, 'H3TH_FEN1-XPG-like', NULL, NULL, 'H3TH_FEN1-XPG-like', 10889),
(10890, 'cd19433', NULL, 'lipocalin_CpcS-CpeS', NULL, NULL, 'lipocalin_CpcS-CpeS', 10890),
(10891, 'cd14329', NULL, 'UBA_SWA2p_like', NULL, NULL, 'UBA_SWA2p_like', 10891),
(10892, 'cd17561', NULL, 'REC_Spo0A', NULL, NULL, 'REC_Spo0A', 10892),
(10893, 'cd09948', NULL, 'Ebola_RSV-like_HR1-HR2', NULL, NULL, 'Ebola_RSV-like_HR1-HR2', 10893),
(10894, 'cd11345', NULL, 'AmyAc_SLC3A2', NULL, NULL, 'AmyAc_SLC3A2', 10894),
(10895, 'cd11538', NULL, 'NTP-PPase_u1', NULL, NULL, 'NTP-PPase_u1', 10895),
(10896, 'cd05673', NULL, 'M20_Acy1L2_AbgB', NULL, NULL, 'M20_Acy1L2_AbgB', 10896),
(10897, 'cd17066', NULL, 'Ubl_KPC2', NULL, NULL, 'Ubl_KPC2', 10897),
(10898, 'cd03266', NULL, 'ABC_NatA_sodium_exporter', NULL, NULL, 'ABC_NatA_sodium_exporter', 10898),
(10899, 'cd08993', NULL, 'GH130', NULL, NULL, 'GH130', 10899),
(10900, 'cd02980', NULL, 'TRX_Fd_family', NULL, NULL, 'TRX_Fd_family', 10900),
(10901, 'cd17548', NULL, 'REC_DivK-like', NULL, NULL, 'REC_DivK-like', 10901),
(10902, 'cd07178', NULL, 'terB_like_YebE', NULL, NULL, 'terB_like_YebE', 10902),
(10903, 'cd12091', NULL, 'FANCM_ID', NULL, NULL, 'FANCM_ID', 10903),
(10904, 'cd12932', NULL, 'RRP7_like', NULL, NULL, 'RRP7_like', 10904),
(10905, 'cd05331', NULL, 'DH-DHB-DH_SDR_c', NULL, NULL, 'DH-DHB-DH_SDR_c', 10905),
(10906, 'cd01240', NULL, 'PH_GRK2_subgroup', NULL, NULL, 'PH_GRK2_subgroup', 10906),
(10907, 'cd14864', NULL, 'Fe-ADH-like', NULL, NULL, 'Fe-ADH-like', 10907),
(10908, 'cd15515', NULL, 'PHD1_KDM5A_like', NULL, NULL, 'PHD1_KDM5A_like', 10908),
(10909, 'cd01015', NULL, 'CSHase', NULL, NULL, 'CSHase', 10909),
(10910, 'cd06147', NULL, 'Rrp6p_like_exo', NULL, NULL, 'Rrp6p_like_exo', 10910),
(10911, 'cd14052', NULL, 'PTKc_Wee1_fungi', NULL, NULL, 'PTKc_Wee1_fungi', 10911),
(10912, 'cd18351', NULL, 'BTB_POZ_BTBD11', NULL, NULL, 'BTB_POZ_BTBD11', 10912),
(10913, 'cd15915', NULL, '7tmA_OR12D-like', NULL, NULL, '7tmA_OR12D-like', 10913),
(10914, 'cd10157', NULL, 'BsCsoR-like_DUF156', NULL, NULL, 'BsCsoR-like_DUF156', 10914),
(10915, 'cd07906', NULL, 'Adenylation_DNA_ligase_LigD_LigC', NULL, NULL, 'Adenylation_DNA_ligase_LigD_LigC', 10915),
(10916, 'cd08857', NULL, 'ArfGap_AGFG1', NULL, NULL, 'ArfGap_AGFG1', 10916),
(10917, 'cd12298', NULL, 'RRM3_Prp24', NULL, NULL, 'RRM3_Prp24', 10917),
(10918, 'cd03134', NULL, 'GATase1_PfpI_like', NULL, NULL, 'GATase1_PfpI_like', 10918),
(10919, 'cd16105', NULL, 'Ubl_ASPSCR1_like', NULL, NULL, 'Ubl_ASPSCR1_like', 10919),
(10920, 'cd13677', NULL, 'PBP2_TRAP_SBP_like_6', NULL, NULL, 'PBP2_TRAP_SBP_like_6', 10920),
(10921, 'cd19105', NULL, 'AKR_unchar', NULL, NULL, 'AKR_unchar', 10921),
(10922, 'cd03297', NULL, 'ABC_ModC_molybdenum_transporter', NULL, NULL, 'ABC_ModC_molybdenum_transporter', 10922),
(10923, 'cd19450', NULL, 'lipocalin_ApoM', NULL, NULL, 'lipocalin_ApoM', 10923),
(10924, 'cd14181', NULL, 'STKc_PhKG2', NULL, NULL, 'STKc_PhKG2', 10924),
(10925, 'cd02511', NULL, 'Beta4Glucosyltransferase', NULL, NULL, 'Beta4Glucosyltransferase', 10925),
(10926, 'cd19688', NULL, 'bHLHzip_MLXIP', NULL, NULL, 'bHLHzip_MLXIP', 10926),
(10927, 'cd03186', NULL, 'GST_C_SspA', NULL, NULL, 'GST_C_SspA', 10927),
(10928, 'cd11632', NULL, 'HR1_PKN3_2', NULL, NULL, 'HR1_PKN3_2', 10928),
(10929, 'cd16657', NULL, 'RING-Ubox_UBE4A', NULL, NULL, 'RING-Ubox_UBE4A', 10929),
(10930, 'cd02598', NULL, 'HAD_BPGM', NULL, NULL, 'HAD_BPGM', 10930),
(10931, 'cd06178', NULL, 'MFS_unc93-like', NULL, NULL, 'MFS_unc93-like', 10931),
(10932, 'cd12254', NULL, 'RRM_hnRNPH_ESRPs_RBM12_like', NULL, NULL, 'RRM_hnRNPH_ESRPs_RBM12_like', 10932),
(10933, 'cd16762', NULL, 'RING-HC_TRIM13_C-V', NULL, NULL, 'RING-HC_TRIM13_C-V', 10933);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(10934, 'cd09950', NULL, 'ENVV1-like_HR1-HR2', NULL, NULL, 'ENVV1-like_HR1-HR2', 10934),
(10935, 'cd14874', NULL, 'MYSc_Myo12', NULL, NULL, 'MYSc_Myo12', 10935),
(10936, 'cd03723', NULL, 'SOCS_ASB4_ASB18', NULL, NULL, 'SOCS_ASB4_ASB18', 10936),
(10937, 'cd11641', NULL, 'Precorrin-4_C11-MT', NULL, NULL, 'Precorrin-4_C11-MT', 10937),
(10938, 'cd11664', NULL, 'LamB_YcsF_like_2', NULL, NULL, 'LamB_YcsF_like_2', 10938),
(10939, 'cd14558', NULL, 'R-PTP-C-2', NULL, NULL, 'R-PTP-C-2', 10939),
(10940, 'cd10279', NULL, 'PQQ_ADH_II', NULL, NULL, 'PQQ_ADH_II', 10940),
(10941, 'cd16751', NULL, 'RING-HC_SIAH1', NULL, NULL, 'RING-HC_SIAH1', 10941),
(10942, 'cd04263', NULL, 'DUF619-NAGK-FABP', NULL, NULL, 'DUF619-NAGK-FABP', 10942),
(10943, 'cd16170', NULL, 'MvaT_DBD', NULL, NULL, 'MvaT_DBD', 10943),
(10944, 'cd16150', NULL, 'sulfatase_like', NULL, NULL, 'sulfatase_like', 10944),
(10945, 'cd14826', NULL, 'SR_alpha_SRX', NULL, NULL, 'SR_alpha_SRX', 10945),
(10946, 'cd15978', NULL, '7tmA_CCK-AR', NULL, NULL, '7tmA_CCK-AR', 10946),
(10947, 'cd04817', NULL, 'PA_VapT_like', NULL, NULL, 'PA_VapT_like', 10947),
(10948, 'cd00981', NULL, 'arch_gltB', NULL, NULL, 'arch_gltB', 10948),
(10949, 'cd13161', NULL, 'PTB_TK_HMTK', NULL, NULL, 'PTB_TK_HMTK', 10949),
(10950, 'cd11301', NULL, 'Fut1_Fut2_like', NULL, NULL, 'Fut1_Fut2_like', 10950),
(10951, 'cd18114', NULL, 'ATP-synt_flagellum-secretory_path_III_C', NULL, NULL, 'ATP-synt_flagellum-secretory_path_III_C', 10951),
(10952, 'cd01776', NULL, 'RA_Rin', NULL, NULL, 'RA_Rin', 10952),
(10953, 'cd08170', NULL, 'GlyDH', NULL, NULL, 'GlyDH', 10953),
(10954, 'cd07528', NULL, 'HAD_CbbY-like', NULL, NULL, 'HAD_CbbY-like', 10954),
(10955, 'cd13834', NULL, 'HU_like', NULL, NULL, 'HU_like', 10955),
(10956, 'cd10569', NULL, 'FERM_C_Talin', NULL, NULL, 'FERM_C_Talin', 10956),
(10957, 'cd14518', NULL, 'DSP_fungal_YVH1', NULL, NULL, 'DSP_fungal_YVH1', 10957),
(10958, 'cd15093', NULL, '7tmA_SSTR', NULL, NULL, '7tmA_SSTR', 10958),
(10959, 'cd11640', NULL, 'HutP', NULL, NULL, 'HutP', 10959),
(10960, 'cd12935', NULL, 'LEM_like', NULL, NULL, 'LEM_like', 10960),
(10961, 'cd16969', NULL, 'Alpha_kinase_ALPK1', NULL, NULL, 'Alpha_kinase_ALPK1', 10961),
(10962, 'cd07984', NULL, 'LPLAT_LABLAT-like', NULL, NULL, 'LPLAT_LABLAT-like', 10962),
(10963, 'cd08333', NULL, 'DED_Caspase_8_r1', NULL, NULL, 'DED_Caspase_8_r1', 10963),
(10964, 'cd06237', NULL, 'M14_Nna1-like', NULL, NULL, 'M14_Nna1-like', 10964),
(10965, 'cd13166', NULL, 'PTB_CCM2', NULL, NULL, 'PTB_CCM2', 10965),
(10966, 'cd07250', NULL, 'HPPD_C_like', NULL, NULL, 'HPPD_C_like', 10966),
(10967, 'cd12620', NULL, 'RRM3_TIAR', NULL, NULL, 'RRM3_TIAR', 10967),
(10968, 'cd03865', NULL, 'M14_CPE', NULL, NULL, 'M14_CPE', 10968),
(10969, 'cd18223', NULL, 'BTB_POZ_ZBTB38_CIBZ', NULL, NULL, 'BTB_POZ_ZBTB38_CIBZ', 10969),
(10970, 'cd16026', NULL, 'GALNS_like', NULL, NULL, 'GALNS_like', 10970),
(10971, 'cd19027', NULL, 'LGIC_ECD_nAChR_B4', NULL, NULL, 'LGIC_ECD_nAChR_B4', 10971),
(10972, 'cd15354', NULL, '7tmA_MC5R', NULL, NULL, '7tmA_MC5R', 10972),
(10973, 'cd15338', NULL, '7tmA_MCHR1', NULL, NULL, '7tmA_MCHR1', 10973),
(10974, 'cd12163', NULL, '2-Hacid_dh_5', NULL, NULL, '2-Hacid_dh_5', 10974),
(10975, 'cd01007', NULL, 'PBP2_BvgS_HisK_like', NULL, NULL, 'PBP2_BvgS_HisK_like', 10975),
(10976, 'cd08876', NULL, 'START_1', NULL, NULL, 'START_1', 10976),
(10977, 'cd17055', NULL, 'Ubl_AtNPL4_like', NULL, NULL, 'Ubl_AtNPL4_like', 10977),
(10978, 'cd09124', NULL, 'PLDc_like_TrmB_middle', NULL, NULL, 'PLDc_like_TrmB_middle', 10978),
(10979, 'cd01217', NULL, 'PTB_CG12581', NULL, NULL, 'PTB_CG12581', 10979),
(10980, 'cd09753', NULL, 'Cas5_I-A', NULL, NULL, 'Cas5_I-A', 10980),
(10981, 'cd19212', NULL, 'SET_NSD3', NULL, NULL, 'SET_NSD3', 10981),
(10982, 'cd12659', NULL, 'RRM2_hnRNPM', NULL, NULL, 'RRM2_hnRNPM', 10982),
(10983, 'cd08968', NULL, 'MeNeil2_N', NULL, NULL, 'MeNeil2_N', 10983),
(10984, 'cd17086', NULL, 'RAWUL_RING1_like', NULL, NULL, 'RAWUL_RING1_like', 10984),
(10985, 'cd17871', NULL, 'GPN2', NULL, NULL, 'GPN2', 10985),
(10986, 'cd07944', NULL, 'DRE_TIM_HOA_like', NULL, NULL, 'DRE_TIM_HOA_like', 10986);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(10987, 'cd02736', NULL, 'RNAP_III_Rpc1_C', NULL, NULL, 'RNAP_III_Rpc1_C', 10987),
(10988, 'cd19852', NULL, 'FABP_pancrustacea', NULL, NULL, 'FABP_pancrustacea', 10988),
(10989, 'cd12022', NULL, 'SH3_p47phox_2', NULL, NULL, 'SH3_p47phox_2', 10989),
(10990, 'cd04437', NULL, 'DEP_Epac', NULL, NULL, 'DEP_Epac', 10990),
(10991, 'cd01906', NULL, 'proteasome_protease_HslV', NULL, NULL, 'proteasome_protease_HslV', 10991),
(10992, 'cd11440', NULL, 'bHLH-O_Cwo_like', NULL, NULL, 'bHLH-O_Cwo_like', 10992),
(10993, 'cd15622', NULL, 'PHD_TIF1alpha', NULL, NULL, 'PHD_TIF1alpha', 10993),
(10994, 'cd10463', NULL, 'PUB_WLM', NULL, NULL, 'PUB_WLM', 10994),
(10995, 'cd08932', NULL, 'HetN_like_SDR_c', NULL, NULL, 'HetN_like_SDR_c', 10995),
(10996, 'cd04891', NULL, 'ACT_AK-LysC-DapG-like_1', NULL, NULL, 'ACT_AK-LysC-DapG-like_1', 10996),
(10997, 'cd16672', NULL, 'RING-H2_DTX2', NULL, NULL, 'RING-H2_DTX2', 10997),
(10998, 'cd13888', NULL, 'CuRO_3_McoP_like', NULL, NULL, 'CuRO_3_McoP_like', 10998),
(10999, 'cd09996', NULL, 'HDAC_classII_1', NULL, NULL, 'HDAC_classII_1', 10999),
(11000, 'cd00296', NULL, 'SIR2', NULL, NULL, 'SIR2', 11000),
(11001, 'cd01096', NULL, 'Alkanal_monooxygenase', NULL, NULL, 'Alkanal_monooxygenase', 11001),
(11002, 'cd07854', NULL, 'STKc_MAPK4_6', NULL, NULL, 'STKc_MAPK4_6', 11002),
(11003, 'cd14534', NULL, 'PTP-MTMR5-like', NULL, NULL, 'PTP-MTMR5-like', 11003),
(11004, 'cd12322', NULL, 'RRM2_TDP43', NULL, NULL, 'RRM2_TDP43', 11004),
(11005, 'cd14289', NULL, 'UBA_RHBD3', NULL, NULL, 'UBA_RHBD3', 11005),
(11006, 'cd19713', NULL, 'bHLH_TS_ATOH1', NULL, NULL, 'bHLH_TS_ATOH1', 11006),
(11007, 'cd11841', NULL, 'SH3_SH3YL1_like', NULL, NULL, 'SH3_SH3YL1_like', 11007),
(11008, 'cd19149', NULL, 'AKR_AKR11B2', NULL, NULL, 'AKR_AKR11B2', 11008),
(11009, 'cd21477', NULL, 'SARS-CoV-like_Spike_S1_RBD', NULL, NULL, 'SARS-CoV-like_Spike_S1_RBD', 11009),
(11010, 'cd09854', NULL, 'PIN_VapC-like', NULL, NULL, 'PIN_VapC-like', 11010),
(11011, 'cd11660', NULL, 'SANT_TRF', NULL, NULL, 'SANT_TRF', 11011),
(11012, 'cd18271', NULL, 'BTB_POZ_KBTBD3_BKLHD3', NULL, NULL, 'BTB_POZ_KBTBD3_BKLHD3', 11012),
(11013, 'cd06814', NULL, 'PLPDE_III_DSD_D-TA_like_3', NULL, NULL, 'PLPDE_III_DSD_D-TA_like_3', 11013),
(11014, 'cd03150', NULL, 'alpha_CA_IX', NULL, NULL, 'alpha_CA_IX', 11014),
(11015, 'cd16403', NULL, 'ParB_N_like_MT', NULL, NULL, 'ParB_N_like_MT', 11015),
(11016, 'cd18560', NULL, 'ABC_6TM_ATM1_ABCB7_HMT1_ABCB6', NULL, NULL, 'ABC_6TM_ATM1_ABCB7_HMT1_ABCB6', 11016),
(11017, 'cd03276', NULL, 'ABC_SMC6_euk', NULL, NULL, 'ABC_SMC6_euk', 11017),
(11018, 'cd11415', NULL, 'bHLH_TS_FERD3L_NATO3', NULL, NULL, 'bHLH_TS_FERD3L_NATO3', 11018),
(11019, 'cd17439', NULL, 'MFS_SV2A', NULL, NULL, 'MFS_SV2A', 11019),
(11020, 'cd15738', NULL, 'FYVE_MTMR_unchar', NULL, NULL, 'FYVE_MTMR_unchar', 11020),
(11021, 'cd02421', NULL, 'Peptidase_C39_likeD', NULL, NULL, 'Peptidase_C39_likeD', 11021),
(11022, 'cd01594', NULL, 'Lyase_I_like', NULL, NULL, 'Lyase_I_like', 11022),
(11023, 'cd13537', NULL, 'PBP2_YvgL_like', NULL, NULL, 'PBP2_YvgL_like', 11023),
(11024, 'cd04670', NULL, 'Nudix_Hydrolase_12', NULL, NULL, 'Nudix_Hydrolase_12', 11024),
(11025, 'cd04378', NULL, 'RhoGAP_GMIP_PARG1', NULL, NULL, 'RhoGAP_GMIP_PARG1', 11025),
(11026, 'cd17023', NULL, 'T3SC_IA_CesT-like', NULL, NULL, 'T3SC_IA_CesT-like', 11026),
(11027, 'cd13706', NULL, 'PBP2_HisK_like_1', NULL, NULL, 'PBP2_HisK_like_1', 11027),
(11028, 'cd13335', NULL, 'FERM_C_TYK2', NULL, NULL, 'FERM_C_TYK2', 11028),
(11029, 'cd09076', NULL, 'L1-EN', NULL, NULL, 'L1-EN', 11029),
(11030, 'cd16856', NULL, 'STAT6_CCD', NULL, NULL, 'STAT6_CCD', 11030),
(11031, 'cd07235', NULL, 'MRD', NULL, NULL, 'MRD', 11031),
(11032, 'cd19794', NULL, 'Bbox2_TRIM66-like', NULL, NULL, 'Bbox2_TRIM66-like', 11032),
(11033, 'cd12016', NULL, 'SH3_Tks_2', NULL, NULL, 'SH3_Tks_2', 11033),
(11034, 'cd17783', NULL, 'CBS_pair_bac', NULL, NULL, 'CBS_pair_bac', 11034),
(11035, 'cd08471', NULL, 'PBP2_CrgA_like_2', NULL, NULL, 'PBP2_CrgA_like_2', 11035),
(11036, 'cd00329', NULL, 'TopoII_MutL_Trans', NULL, NULL, 'TopoII_MutL_Trans', 11036);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(11037, 'cd04971', NULL, 'Ig_TrKABC_d5', NULL, NULL, 'Ig_TrKABC_d5', 11037),
(11038, 'cd03237', NULL, 'ABC_RNaseL_inhibitor_domain2', NULL, NULL, 'ABC_RNaseL_inhibitor_domain2', 11038),
(11039, 'cd04705', NULL, 'PLA2_group_III_like', NULL, NULL, 'PLA2_group_III_like', 11039),
(11040, 'cd06664', NULL, 'IscU_like', NULL, NULL, 'IscU_like', 11040),
(11041, 'cd14412', NULL, 'UBA_DCNL2', NULL, NULL, 'UBA_DCNL2', 11041),
(11042, 'cd08923', NULL, 'class1-2_nsHbs_Lbs', NULL, NULL, 'class1-2_nsHbs_Lbs', 11042),
(11043, 'cd06109', NULL, 'BsCS-I_like', NULL, NULL, 'BsCS-I_like', 11043),
(11044, 'cd06201', NULL, 'SiR_like2', NULL, NULL, 'SiR_like2', 11044),
(11045, 'cd12737', NULL, 'RRM1_ESRP2', NULL, NULL, 'RRM1_ESRP2', 11045),
(11046, 'cd03804', NULL, 'GT4_WbaZ-like', NULL, NULL, 'GT4_WbaZ-like', 11046),
(11047, 'cd16204', NULL, 'EFh_PI-PLCzeta', NULL, NULL, 'EFh_PI-PLCzeta', 11047),
(11048, 'cd01870', NULL, 'RhoA_like', NULL, NULL, 'RhoA_like', 11048),
(11049, 'cd12358', NULL, 'RRM1_VICKZ', NULL, NULL, 'RRM1_VICKZ', 11049),
(11050, 'cd07106', NULL, 'ALDH_AldA-AAD23400', NULL, NULL, 'ALDH_AldA-AAD23400', 11050),
(11051, 'cd08603', NULL, 'GDPD_SHV3_repeat_1', NULL, NULL, 'GDPD_SHV3_repeat_1', 11051),
(11052, 'cd10965', NULL, 'CE4_IcaB_5s', NULL, NULL, 'CE4_IcaB_5s', 11052),
(11053, 'cd01922', NULL, 'cyclophilin_SpCYP2_like', NULL, NULL, 'cyclophilin_SpCYP2_like', 11053),
(11054, 'cd03196', NULL, 'GST_C_5', NULL, NULL, 'GST_C_5', 11054),
(11055, 'cd14077', NULL, 'STKc_Kin1_2', NULL, NULL, 'STKc_Kin1_2', 11055),
(11056, 'cd07161', NULL, 'NR_DBD_EcR', NULL, NULL, 'NR_DBD_EcR', 11056),
(11057, 'cd10403', NULL, 'SH2_STAP1', NULL, NULL, 'SH2_STAP1', 11057),
(11058, 'cd04632', NULL, 'CBS_pair_arch1_repeat2', NULL, NULL, 'CBS_pair_arch1_repeat2', 11058),
(11059, 'cd07525', NULL, 'HAD_like', NULL, NULL, 'HAD_like', 11059),
(11060, 'cd15504', NULL, 'PHD_PRHA_like', NULL, NULL, 'PHD_PRHA_like', 11060),
(11061, 'cd12201', NULL, 'MARK2_C', NULL, NULL, 'MARK2_C', 11061),
(11062, 'cd17151', NULL, 'DCX1_DCDC2C', NULL, NULL, 'DCX1_DCDC2C', 11062),
(11063, 'cd17422', NULL, 'MFS_MCT7', NULL, NULL, 'MFS_MCT7', 11063),
(11064, 'cd18191', NULL, 'BTB_POZ_ARMC5', NULL, NULL, 'BTB_POZ_ARMC5', 11064),
(11065, 'cd00071', NULL, 'GMPK', NULL, NULL, 'GMPK', 11065),
(11066, 'cd05792', NULL, 'S1_eIF1AD_like', NULL, NULL, 'S1_eIF1AD_like', 11066),
(11067, 'cd00773', NULL, 'HisRS-like_core', NULL, NULL, 'HisRS-like_core', 11067),
(11068, 'cd11963', NULL, 'SH3_STAM2', NULL, NULL, 'SH3_STAM2', 11068),
(11069, 'cd01053', NULL, 'AOX', NULL, NULL, 'AOX', 11069),
(11070, 'cd08508', NULL, 'PBP2_NikA_DppA_OppA_like_1', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_1', 11070),
(11071, 'cd18311', NULL, 'BTB_POZ_CP190-like', NULL, NULL, 'BTB_POZ_CP190-like', 11071),
(11072, 'cd05253', NULL, 'UDP_GE_SDE_e', NULL, NULL, 'UDP_GE_SDE_e', 11072),
(11073, 'cd12018', NULL, 'SH3_Tks4_4', NULL, NULL, 'SH3_Tks4_4', 11073),
(11074, 'cd12313', NULL, 'RRM1_RRM2_RBM5_like', NULL, NULL, 'RRM1_RRM2_RBM5_like', 11074),
(11075, 'cd15661', NULL, 'PHD5_NSD3', NULL, NULL, 'PHD5_NSD3', 11075),
(11076, 'cd13954', NULL, '7tmA_OR', NULL, NULL, '7tmA_OR', 11076),
(11077, 'cd18318', NULL, 'BTB_POZ_KCTD20-like', NULL, NULL, 'BTB_POZ_KCTD20-like', 11077),
(11078, 'cd21649', NULL, 'SARS-CoV_ORF3b', NULL, NULL, 'SARS-CoV_ORF3b', 11078),
(11079, 'cd05576', NULL, 'STKc_RPK118_like', NULL, NULL, 'STKc_RPK118_like', 11079),
(11080, 'cd18391', NULL, 'BTB_POZ_KCTD17', NULL, NULL, 'BTB_POZ_KCTD17', 11080),
(11081, 'cd07865', NULL, 'STKc_CDK9', NULL, NULL, 'STKc_CDK9', 11081),
(11082, 'cd11836', NULL, 'SH3_Intersectin_1', NULL, NULL, 'SH3_Intersectin_1', 11082),
(11083, 'cd12320', NULL, 'RRM6_RBM19_RRM5_MRD1', NULL, NULL, 'RRM6_RBM19_RRM5_MRD1', 11083),
(11084, 'cd09480', NULL, 'LIM1_CRP2', NULL, NULL, 'LIM1_CRP2', 11084),
(11085, 'cd12607', NULL, 'RRM2_RBM4', NULL, NULL, 'RRM2_RBM4', 11085),
(11086, 'cd16448', NULL, 'RING-H2', NULL, NULL, 'RING-H2', 11086),
(11087, 'cd17308', NULL, 'PIPKc_PIP5K1C', NULL, NULL, 'PIPKc_PIP5K1C', 11087),
(11088, 'cd14629', NULL, 'R-PTP-F-2', NULL, NULL, 'R-PTP-F-2', 11088);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(11089, 'cd17425', NULL, 'MFS_MCT6', NULL, NULL, 'MFS_MCT6', 11089),
(11090, 'cd14287', NULL, 'UBA_At3g58460_like', NULL, NULL, 'UBA_At3g58460_like', 11090),
(11091, 'cd09010', NULL, 'MTAP_SsMTAPII_like_MTIP', NULL, NULL, 'MTAP_SsMTAPII_like_MTIP', 11091),
(11092, 'cd12023', NULL, 'SH3_NoxO1_1', NULL, NULL, 'SH3_NoxO1_1', 11092),
(11093, 'cd16907', NULL, 'YEATS_YEATS2_like', NULL, NULL, 'YEATS_YEATS2_like', 11093),
(11094, 'cd04707', NULL, 'otoconin_90', NULL, NULL, 'otoconin_90', 11094),
(11095, 'cd09885', NULL, 'PIN_Smg6-like', NULL, NULL, 'PIN_Smg6-like', 11095),
(11096, 'cd16556', NULL, 'RING-HC_RNF183_like', NULL, NULL, 'RING-HC_RNF183_like', 11096),
(11097, 'cd19736', NULL, 'bHLH-PAS_PASD1', NULL, NULL, 'bHLH-PAS_PASD1', 11097),
(11098, 'cd09497', NULL, 'SAM_caskin1,2_repeat1', NULL, NULL, 'SAM_caskin1,2_repeat1', 11098),
(11099, 'cd07864', NULL, 'STKc_CDK12', NULL, NULL, 'STKc_CDK12', 11099),
(11100, 'cd12151', NULL, 'F1-ATPase_gamma', NULL, NULL, 'F1-ATPase_gamma', 11100),
(11101, 'cd12268', NULL, 'RRM_Vip1', NULL, NULL, 'RRM_Vip1', 11101),
(11102, 'cd04750', NULL, 'Commd2', NULL, NULL, 'Commd2', 11102),
(11103, 'cd11331', NULL, 'AmyAc_OligoGlu_like', NULL, NULL, 'AmyAc_OligoGlu_like', 11103),
(11104, 'cd13180', NULL, 'RanBD_RanBP3', NULL, NULL, 'RanBD_RanBP3', 11104),
(11105, 'cd14861', NULL, 'Fe-ADH-like', NULL, NULL, 'Fe-ADH-like', 11105),
(11106, 'cd04886', NULL, 'ACT_ThrD-II-like', NULL, NULL, 'ACT_ThrD-II-like', 11106),
(11107, 'cd15736', NULL, 'FYVE_scVPS27p_Vac1p_like', NULL, NULL, 'FYVE_scVPS27p_Vac1p_like', 11107),
(11108, 'cd01899', NULL, 'Ygr210', NULL, NULL, 'Ygr210', 11108),
(11109, 'cd07019', NULL, 'S49_SppA_1', NULL, NULL, 'S49_SppA_1', 11109),
(11110, 'cd05041', NULL, 'PTKc_Fes_like', NULL, NULL, 'PTKc_Fes_like', 11110),
(11111, 'cd01460', NULL, 'vWA_midasin', NULL, NULL, 'vWA_midasin', 11111),
(11112, 'cd12692', NULL, 'RRM2_PTBPH3', NULL, NULL, 'RRM2_PTBPH3', 11112),
(11113, 'cd01627', NULL, 'HAD_TPP', NULL, NULL, 'HAD_TPP', 11113),
(11114, 'cd18538', NULL, 'PFA-DSP_unk', NULL, NULL, 'PFA-DSP_unk', 11114),
(11115, 'cd14193', NULL, 'STKc_MLCK4', NULL, NULL, 'STKc_MLCK4', 11115),
(11116, 'cd11374', NULL, 'CE4_u10', NULL, NULL, 'CE4_u10', 11116),
(11117, 'cd15351', NULL, '7tmA_MC1R', NULL, NULL, '7tmA_MC1R', 11117),
(11118, 'cd18101', NULL, 'Trm10euk_A', NULL, NULL, 'Trm10euk_A', 11118),
(11119, 'cd21645', NULL, 'MERS-CoV-like_ORF5', NULL, NULL, 'MERS-CoV-like_ORF5', 11119),
(11120, 'cd11354', NULL, 'AmyAc_bac_CMD_like', NULL, NULL, 'AmyAc_bac_CMD_like', 11120),
(11121, 'cd10971', NULL, 'CE4_DAC_u2_5s', NULL, NULL, 'CE4_DAC_u2_5s', 11121),
(11122, 'cd00058', NULL, 'FGF', NULL, NULL, 'FGF', 11122),
(11123, 'cd17029', NULL, 'T3SC_IA_SycE_SpcS-like', NULL, NULL, 'T3SC_IA_SycE_SpcS-like', 11123),
(11124, 'cd18206', NULL, 'BTB_POZ_ZBTB17_MIZ1', NULL, NULL, 'BTB_POZ_ZBTB17_MIZ1', 11124),
(11125, 'cd03817', NULL, 'GT4_UGDG-like', NULL, NULL, 'GT4_UGDG-like', 11125),
(11126, 'cd16414', NULL, 'dndB_like', NULL, NULL, 'dndB_like', 11126),
(11127, 'cd10338', NULL, 'SH2_SHA', NULL, NULL, 'SH2_SHA', 11127),
(11128, 'cd09844', NULL, 'PLDc_vPLD1_2', NULL, NULL, 'PLDc_vPLD1_2', 11128),
(11129, 'cd04196', NULL, 'GT_2_like_d', NULL, NULL, 'GT_2_like_d', 11129),
(11130, 'cd09532', NULL, 'SAM_SLA1_fungal', NULL, NULL, 'SAM_SLA1_fungal', 11130),
(11131, 'cd09839', NULL, 'M1_like_TAF2', NULL, NULL, 'M1_like_TAF2', 11131),
(11132, 'cd08848', NULL, 'ArfGap_ASAP1', NULL, NULL, 'ArfGap_ASAP1', 11132),
(11133, 'cd15317', NULL, '7tmA_TAAR5-like', NULL, NULL, '7tmA_TAAR5-like', 11133),
(11134, 'cd01744', NULL, 'GATase1_CPSase', NULL, NULL, 'GATase1_CPSase', 11134),
(11135, 'cd02683', NULL, 'MIT_1', NULL, NULL, 'MIT_1', 11135),
(11136, 'cd13363', NULL, 'PH_PLC_delta', NULL, NULL, 'PH_PLC_delta', 11136),
(11137, 'cd04211', NULL, 'Cupredoxin_like_2', NULL, NULL, 'Cupredoxin_like_2', 11137),
(11138, 'cd12101', NULL, 'DD_RIalpha_PKA', NULL, NULL, 'DD_RIalpha_PKA', 11138),
(11139, 'cd03711', NULL, 'Tet_C', NULL, NULL, 'Tet_C', 11139),
(11140, 'cd21554', NULL, 'CoV_N-NTD', NULL, NULL, 'CoV_N-NTD', 11140);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(11141, 'cd05300', NULL, '2-Hacid_dh_1', NULL, NULL, '2-Hacid_dh_1', 11141),
(11142, 'cd12202', NULL, 'CASP8AP2', NULL, NULL, 'CASP8AP2', 11142),
(11143, 'cd14775', NULL, 'TrHb2_O-like', NULL, NULL, 'TrHb2_O-like', 11143),
(11144, 'cd09657', NULL, 'Cmr1_III-B', NULL, NULL, 'Cmr1_III-B', 11144),
(11145, 'cd09243', NULL, 'BRO1_Brox_like', NULL, NULL, 'BRO1_Brox_like', 11145),
(11146, 'cd14119', NULL, 'STKc_LKB1', NULL, NULL, 'STKc_LKB1', 11146),
(11147, 'cd18765', NULL, 'PIN_MtVapC3-like', NULL, NULL, 'PIN_MtVapC3-like', 11147),
(11148, 'cd00717', NULL, 'URO-D', NULL, NULL, 'URO-D', 11148),
(11149, 'cd16764', NULL, 'RING-HC_TIF1alpha', NULL, NULL, 'RING-HC_TIF1alpha', 11149),
(11150, 'cd00185', NULL, 'TNFRSF', NULL, NULL, 'TNFRSF', 11150),
(11151, 'cd15652', NULL, 'PHD2_NSD3', NULL, NULL, 'PHD2_NSD3', 11151),
(11152, 'cd05353', NULL, 'hydroxyacyl-CoA-like_DH_SDR_c-like', NULL, NULL, 'hydroxyacyl-CoA-like_DH_SDR_c-like', 11152),
(11153, 'cd15453', NULL, '7tmC_mGluR6', NULL, NULL, '7tmC_mGluR6', 11153),
(11154, 'cd06199', NULL, 'SiR', NULL, NULL, 'SiR', 11154),
(11155, 'cd17485', NULL, 'MFS_MFSD3', NULL, NULL, 'MFS_MFSD3', 11155),
(11156, 'cd16458', NULL, 'RING-H2_Dmap_like', NULL, NULL, 'RING-H2_Dmap_like', 11156),
(11157, 'cd15248', NULL, '7tmF_FZD1_insect', NULL, NULL, '7tmF_FZD1_insect', 11157),
(11158, 'cd17877', NULL, 'NP_MTAN-like', NULL, NULL, 'NP_MTAN-like', 11158),
(11159, 'cd00927', NULL, 'Cyt_c_Oxidase_VIc', NULL, NULL, 'Cyt_c_Oxidase_VIc', 11159),
(11160, 'cd18553', NULL, 'ABC_6TM_PglK_like', NULL, NULL, 'ABC_6TM_PglK_like', 11160),
(11161, 'cd15809', NULL, 'SPRY_PRY_TRIM4', NULL, NULL, 'SPRY_PRY_TRIM4', 11161),
(11162, 'cd04253', NULL, 'AAK_UMPK-PyrH-Pf', NULL, NULL, 'AAK_UMPK-PyrH-Pf', 11162),
(11163, 'cd09030', NULL, 'DUF1425', NULL, NULL, 'DUF1425', 11163),
(11164, 'cd14782', NULL, 'FHb-globin_2', NULL, NULL, 'FHb-globin_2', 11164),
(11165, 'cd11703', NULL, 'DHR2_DOCK7', NULL, NULL, 'DHR2_DOCK7', 11165),
(11166, 'cd03747', NULL, 'Ntn_PGA_like', NULL, NULL, 'Ntn_PGA_like', 11166),
(11167, 'cd07182', NULL, 'RNase_HII_bacteria_HII_like', NULL, NULL, 'RNase_HII_bacteria_HII_like', 11167),
(11168, 'cd01701', NULL, 'PolY_Rev1', NULL, NULL, 'PolY_Rev1', 11168),
(11169, 'cd17927', NULL, 'DEXHc_RIG-I', NULL, NULL, 'DEXHc_RIG-I', 11169),
(11170, 'cd04605', NULL, 'CBS_pair_arch_MET2_assoc', NULL, NULL, 'CBS_pair_arch_MET2_assoc', 11170),
(11171, 'cd01150', NULL, 'AXO', NULL, NULL, 'AXO', 11171),
(11172, 'cd07774', NULL, 'FGGY_1', NULL, NULL, 'FGGY_1', 11172),
(11173, 'cd15021', NULL, '7tm_TAS2R10', NULL, NULL, '7tm_TAS2R10', 11173),
(11174, 'cd18186', NULL, 'BTB_POZ_ZBTB_KLHL-like', NULL, NULL, 'BTB_POZ_ZBTB_KLHL-like', 11174),
(11175, 'cd19133', NULL, 'AKR_AKR5F1', NULL, NULL, 'AKR_AKR5F1', 11175),
(11176, 'cd00125', NULL, 'PLA2c', NULL, NULL, 'PLA2c', 11176),
(11177, 'cd12119', NULL, 'ttLC_FACS_AlkK_like', NULL, NULL, 'ttLC_FACS_AlkK_like', 11177),
(11178, 'cd18797', NULL, 'SF2_C_Hrq', NULL, NULL, 'SF2_C_Hrq', 11178),
(11179, 'cd00270', NULL, 'MATH_TRAF_C', NULL, NULL, 'MATH_TRAF_C', 11179),
(11180, 'cd07857', NULL, 'STKc_MPK1', NULL, NULL, 'STKc_MPK1', 11180),
(11181, 'cd10382', NULL, 'SH2_SOCS1', NULL, NULL, 'SH2_SOCS1', 11181),
(11182, 'cd09951', NULL, 'HERV-Rb-like_HR1-HR2', NULL, NULL, 'HERV-Rb-like_HR1-HR2', 11182),
(11183, 'cd18390', NULL, 'BTB_POZ_KCTD5', NULL, NULL, 'BTB_POZ_KCTD5', 11183),
(11184, 'cd05861', NULL, 'Ig_PDGFR-alphabeta', NULL, NULL, 'Ig_PDGFR-alphabeta', 11184),
(11185, 'cd16654', NULL, 'RING-Ubox_CHIP', NULL, NULL, 'RING-Ubox_CHIP', 11185),
(11186, 'cd19764', NULL, 'Bbox2_TRIM9-like', NULL, NULL, 'Bbox2_TRIM9-like', 11186),
(11187, 'cd14759', NULL, 'GS_GGDEF_2', NULL, NULL, 'GS_GGDEF_2', 11187),
(11188, 'cd02053', NULL, 'serpinF2_A2AP', NULL, NULL, 'serpinF2_A2AP', 11188),
(11189, 'cd19577', NULL, 'serpinJ_IRS-2-like', NULL, NULL, 'serpinJ_IRS-2-like', 11189),
(11190, 'cd03077', NULL, 'GST_N_Alpha', NULL, NULL, 'GST_N_Alpha', 11190),
(11191, 'cd01193', NULL, 'INT_IntI_C', NULL, NULL, 'INT_IntI_C', 11191),
(11192, 'cd04773', NULL, 'HTH_TioE_rpt2', NULL, NULL, 'HTH_TioE_rpt2', 11192);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(11193, 'cd09364', NULL, 'LIM1_LIMK', NULL, NULL, 'LIM1_LIMK', 11193),
(11194, 'cd00880', NULL, 'Era_like', NULL, NULL, 'Era_like', 11194),
(11195, 'cd05371', NULL, 'HSD10-like_SDR_c', NULL, NULL, 'HSD10-like_SDR_c', 11195),
(11196, 'cd07268', NULL, 'VOC_EcYecM_like', NULL, NULL, 'VOC_EcYecM_like', 11196),
(11197, 'cd03858', NULL, 'M14_CP_N-E_like', NULL, NULL, 'M14_CP_N-E_like', 11197),
(11198, 'cd05269', NULL, 'TMR_SDR_a', NULL, NULL, 'TMR_SDR_a', 11198),
(11199, 'cd01257', NULL, 'PH_IRS', NULL, NULL, 'PH_IRS', 11199),
(11200, 'cd04651', NULL, 'LbH_G1P_AT_C', NULL, NULL, 'LbH_G1P_AT_C', 11200),
(11201, 'cd09825', NULL, 'thyroid_peroxidase', NULL, NULL, 'thyroid_peroxidase', 11201),
(11202, 'cd11844', NULL, 'SH3_CAS', NULL, NULL, 'SH3_CAS', 11202),
(11203, 'cd17468', NULL, 'T3SS_HrpP_C', NULL, NULL, 'T3SS_HrpP_C', 11203),
(11204, 'cd05337', NULL, 'BKR_1_SDR_c', NULL, NULL, 'BKR_1_SDR_c', 11204),
(11205, 'cd04591', NULL, 'CBS_pair_voltage-gated_CLC_euk_bac', NULL, NULL, 'CBS_pair_voltage-gated_CLC_euk_bac', 11205),
(11206, 'cd09540', NULL, 'SAM_EPS8-like', NULL, NULL, 'SAM_EPS8-like', 11206),
(11207, 'cd14550', NULL, 'R5-PTP-2', NULL, NULL, 'R5-PTP-2', 11207),
(11208, 'cd00089', NULL, 'HR1', NULL, NULL, 'HR1', 11208),
(11209, 'cd10227', NULL, 'ParM_like', NULL, NULL, 'ParM_like', 11209),
(11210, 'cd05073', NULL, 'PTKc_Hck', NULL, NULL, 'PTKc_Hck', 11210),
(11211, 'cd11380', NULL, 'Ribosomal_S8e_like', NULL, NULL, 'Ribosomal_S8e_like', 11211),
(11212, 'cd09941', NULL, 'SH2_Grb2_like', NULL, NULL, 'SH2_Grb2_like', 11212),
(11213, 'cd12526', NULL, 'RRM1_EAR1_like', NULL, NULL, 'RRM1_EAR1_like', 11213),
(11214, 'cd05467', NULL, 'CBM20', NULL, NULL, 'CBM20', 11214),
(11215, 'cd00830', NULL, 'KAS_III', NULL, NULL, 'KAS_III', 11215),
(11216, 'cd17402', NULL, 'MFS_SLCO3_OATP3', NULL, NULL, 'MFS_SLCO3_OATP3', 11216),
(11217, 'cd12674', NULL, 'RRM1_Nop4p', NULL, NULL, 'RRM1_Nop4p', 11217),
(11218, 'cd07699', NULL, 'IgC_L', NULL, NULL, 'IgC_L', 11218),
(11219, 'cd07511', NULL, 'HAD_like', NULL, NULL, 'HAD_like', 11219),
(11220, 'cd13281', NULL, 'PH_PLEKHD1', NULL, NULL, 'PH_PLEKHD1', 11220),
(11221, 'cd17445', NULL, 'MFS_SLC22A17', NULL, NULL, 'MFS_SLC22A17', 11221),
(11222, 'cd10523', NULL, 'SET_SETDB2', NULL, NULL, 'SET_SETDB2', 11222),
(11223, 'cd00585', NULL, 'Peptidase_C1B', NULL, NULL, 'Peptidase_C1B', 11223),
(11224, 'cd02651', NULL, 'nuc_hydro_IU_UC_XIUA', NULL, NULL, 'nuc_hydro_IU_UC_XIUA', 11224),
(11225, 'cd06545', NULL, 'GH18_3CO4_chitinase', NULL, NULL, 'GH18_3CO4_chitinase', 11225),
(11226, 'cd02165', NULL, 'NMNAT', NULL, NULL, 'NMNAT', 11226),
(11227, 'cd18203', NULL, 'BTB_POZ_ZBTB12', NULL, NULL, 'BTB_POZ_ZBTB12', 11227),
(11228, 'cd00952', NULL, 'CHBPH_aldolase', NULL, NULL, 'CHBPH_aldolase', 11228),
(11229, 'cd08357', NULL, 'VOC_like', NULL, NULL, 'VOC_like', 11229),
(11230, 'cd04495', NULL, 'BRCA2DBD_OB3', NULL, NULL, 'BRCA2DBD_OB3', 11230),
(11231, 'cd15886', NULL, 'SNARE_SEC9N', NULL, NULL, 'SNARE_SEC9N', 11231),
(11232, 'cd07404', NULL, 'MPP_MS158', NULL, NULL, 'MPP_MS158', 11232),
(11233, 'cd01620', NULL, 'Ala_dh_like', NULL, NULL, 'Ala_dh_like', 11233),
(11234, 'cd18638', NULL, 'CD_EhHp1_like', NULL, NULL, 'CD_EhHp1_like', 11234),
(11235, 'cd14988', NULL, '7tmA_GPR182', NULL, NULL, '7tmA_GPR182', 11235),
(11236, 'cd19142', NULL, 'AKR_AKR6B1', NULL, NULL, 'AKR_AKR6B1', 11236),
(11237, 'cd03201', NULL, 'GST_C_DHAR', NULL, NULL, 'GST_C_DHAR', 11237),
(11238, 'cd17419', NULL, 'MFS_NPF7', NULL, NULL, 'MFS_NPF7', 11238),
(11239, 'cd04105', NULL, 'SR_beta', NULL, NULL, 'SR_beta', 11239),
(11240, 'cd09167', NULL, 'PLDc_EcPPK1_C2_like', NULL, NULL, 'PLDc_EcPPK1_C2_like', 11240),
(11241, 'cd05142', NULL, 'Barstar', NULL, NULL, 'Barstar', 11241),
(11242, 'cd04462', NULL, 'S1_RNAPII_Rpb7', NULL, NULL, 'S1_RNAPII_Rpb7', 11242),
(11243, 'cd12729', NULL, 'RRM1_hnRNPH_hnRNPH2_hnRNPF', NULL, NULL, 'RRM1_hnRNPH_hnRNPH2_hnRNPF', 11243),
(11244, 'cd02431', NULL, 'Ferritin_CCC1_C', NULL, NULL, 'Ferritin_CCC1_C', 11244),
(11245, 'cd17428', NULL, 'MFS_MCT9', NULL, NULL, 'MFS_MCT9', 11245),
(11246, 'cd00231', NULL, 'ZipA', NULL, NULL, 'ZipA', 11246);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(11247, 'cd17056', NULL, 'Ubl_FAF1', NULL, NULL, 'Ubl_FAF1', 11247),
(11248, 'cd01251', NULL, 'PH2_ADAP', NULL, NULL, 'PH2_ADAP', 11248),
(11249, 'cd18063', NULL, 'DEXHc_SMARCA2', NULL, NULL, 'DEXHc_SMARCA2', 11249),
(11250, 'cd01580', NULL, 'AcnA_IRP_Swivel', NULL, NULL, 'AcnA_IRP_Swivel', 11250),
(11251, 'cd07641', NULL, 'BAR_ASAP1', NULL, NULL, 'BAR_ASAP1', 11251),
(11252, 'cd03602', NULL, 'CLECT_1', NULL, NULL, 'CLECT_1', 11252),
(11253, 'cd08736', NULL, 'RGS_RhoGEF-like', NULL, NULL, 'RGS_RhoGEF-like', 11253),
(11254, 'cd21559', NULL, 'gammaCoV-Nsp6', NULL, NULL, 'gammaCoV-Nsp6', 11254),
(11255, 'cd18694', NULL, 'PIN_VapC-like', NULL, NULL, 'PIN_VapC-like', 11255),
(11256, 'cd11839', NULL, 'SH3_Intersectin_4', NULL, NULL, 'SH3_Intersectin_4', 11256),
(11257, 'cd06360', NULL, 'PBP1_alkylbenzenes-like', NULL, NULL, 'PBP1_alkylbenzenes-like', 11257),
(11258, 'cd05872', NULL, 'Ig_Sema4B_like', NULL, NULL, 'Ig_Sema4B_like', 11258),
(11259, 'cd08998', NULL, 'GH43_Arb43a-like', NULL, NULL, 'GH43_Arb43a-like', 11259),
(11260, 'cd12871', NULL, 'Bacuni_01323_like', NULL, NULL, 'Bacuni_01323_like', 11260),
(11261, 'cd18092', NULL, 'SpoU-like_TrmH', NULL, NULL, 'SpoU-like_TrmH', 11261),
(11262, 'cd05402', NULL, 'NT_PAP_TUTase', NULL, NULL, 'NT_PAP_TUTase', 11262),
(11263, 'cd05809', NULL, 'CBM20_beta_amylase', NULL, NULL, 'CBM20_beta_amylase', 11263),
(11264, 'cd10567', NULL, 'SWIB-MDM2_like', NULL, NULL, 'SWIB-MDM2_like', 11264),
(11265, 'cd01154', NULL, 'AidB', NULL, NULL, 'AidB', 11265),
(11266, 'cd06958', NULL, 'NR_DBD_COUP_TF', NULL, NULL, 'NR_DBD_COUP_TF', 11266),
(11267, 'cd10536', NULL, 'SET_SMYD4', NULL, NULL, 'SET_SMYD4', 11267),
(11268, 'cd12575', NULL, 'RRM1_hnRNPD_like', NULL, NULL, 'RRM1_hnRNPD_like', 11268),
(11269, 'cd01433', NULL, 'Ribosomal_L16_L10e', NULL, NULL, 'Ribosomal_L16_L10e', 11269),
(11270, 'cd09528', NULL, 'SAM_Samd9_Samd9L', NULL, NULL, 'SAM_Samd9_Samd9L', 11270),
(11271, 'cd10790', NULL, 'GH38N_AMII_1', NULL, NULL, 'GH38N_AMII_1', 11271),
(11272, 'cd08958', NULL, 'FR_SDR_e', NULL, NULL, 'FR_SDR_e', 11272),
(11273, 'cd16146', NULL, 'ARS_like', NULL, NULL, 'ARS_like', 11273),
(11274, 'cd19148', NULL, 'AKR_AKR11B1', NULL, NULL, 'AKR_AKR11B1', 11274),
(11275, 'cd08629', NULL, 'PI-PLCc_delta1', NULL, NULL, 'PI-PLCc_delta1', 11275),
(11276, 'cd14489', NULL, 'CBM_SBP_bac_1_like', NULL, NULL, 'CBM_SBP_bac_1_like', 11276),
(11277, 'cd03814', NULL, 'GT4-like', NULL, NULL, 'GT4-like', 11277),
(11278, 'cd15174', NULL, '7tmA_CCR9', NULL, NULL, '7tmA_CCR9', 11278),
(11279, 'cd05027', NULL, 'S-100B', NULL, NULL, 'S-100B', 11279),
(11280, 'cd13605', NULL, 'PBP2_TRAP_DctP_like_2', NULL, NULL, 'PBP2_TRAP_DctP_like_2', 11280),
(11281, 'cd19842', NULL, 'Bbox1_TRIM25-like_C-IV', NULL, NULL, 'Bbox1_TRIM25-like_C-IV', 11281),
(11282, 'cd09389', NULL, 'LIM2_LMO1_LMO3', NULL, NULL, 'LIM2_LMO1_LMO3', 11282),
(11283, 'cd01787', NULL, 'RA_MRL', NULL, NULL, 'RA_MRL', 11283),
(11284, 'cd11299', NULL, 'O-FucT_plant', NULL, NULL, 'O-FucT_plant', 11284),
(11285, 'cd12735', NULL, 'RRM3_hnRNPH3', NULL, NULL, 'RRM3_hnRNPH3', 11285),
(11286, 'cd02418', NULL, 'Peptidase_C39B', NULL, NULL, 'Peptidase_C39B', 11286),
(11287, 'cd17621', NULL, 'REC_OmpR_RegX3-like', NULL, NULL, 'REC_OmpR_RegX3-like', 11287),
(11288, 'cd03197', NULL, 'GST_C_mPGES2', NULL, NULL, 'GST_C_mPGES2', 11288),
(11289, 'cd18302', NULL, 'BTB2_POZ_IBtk', NULL, NULL, 'BTB2_POZ_IBtk', 11289),
(11290, 'cd12375', NULL, 'RRM1_Hu_like', NULL, NULL, 'RRM1_Hu_like', 11290),
(11291, 'cd00503', NULL, 'Frataxin', NULL, NULL, 'Frataxin', 11291),
(11292, 'cd14944', NULL, 'TRAPPC6A_Trs33', NULL, NULL, 'TRAPPC6A_Trs33', 11292),
(11293, 'cd16474', NULL, 'RING-H2_RNF111_like', NULL, NULL, 'RING-H2_RNF111_like', 11293),
(11294, 'cd03290', NULL, 'ABCC_SUR1_N', NULL, NULL, 'ABCC_SUR1_N', 11294),
(11295, 'cd07850', NULL, 'STKc_JNK', NULL, NULL, 'STKc_JNK', 11295),
(11296, 'cd20254', NULL, 'CASIMO1_SMIM5', NULL, NULL, 'CASIMO1_SMIM5', 11296),
(11297, 'cd08874', NULL, 'START_STARD9-like', NULL, NULL, 'START_STARD9-like', 11297),
(11298, 'cd01807', NULL, 'Ubl_UBL4A_like', NULL, NULL, 'Ubl_UBL4A_like', 11298);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(11299, 'cd14934', NULL, 'MYSc_Myh16', NULL, NULL, 'MYSc_Myh16', 11299),
(11300, 'cd08946', NULL, 'SDR_e', NULL, NULL, 'SDR_e', 11300),
(11301, 'cd13688', NULL, 'PBP2_GltI_DEBP', NULL, NULL, 'PBP2_GltI_DEBP', 11301),
(11302, 'cd05511', NULL, 'Bromo_TFIID', NULL, NULL, 'Bromo_TFIID', 11302),
(11303, 'cd09254', NULL, 'AP_delta-COPI_MHD', NULL, NULL, 'AP_delta-COPI_MHD', 11303),
(11304, 'cd03317', NULL, 'NAAAR', NULL, NULL, 'NAAAR', 11304),
(11305, 'cd15768', NULL, 'FYVE_SPIR2', NULL, NULL, 'FYVE_SPIR2', 11305),
(11306, 'cd18402', NULL, 'BTB_POZ_KCNA1', NULL, NULL, 'BTB_POZ_KCNA1', 11306),
(11307, 'cd01445', NULL, 'TST_Repeats', NULL, NULL, 'TST_Repeats', 11307),
(11308, 'cd08559', NULL, 'GDPD_periplasmic_GlpQ_like', NULL, NULL, 'GDPD_periplasmic_GlpQ_like', 11308),
(11309, 'cd07158', NULL, 'NR_DBD_Ppar_like', NULL, NULL, 'NR_DBD_Ppar_like', 11309),
(11310, 'cd11416', NULL, 'bHLH_TS_ceHLH13_like', NULL, NULL, 'bHLH_TS_ceHLH13_like', 11310),
(11311, 'cd17386', NULL, 'MFS_SLC46', NULL, NULL, 'MFS_SLC46', 11311),
(11312, 'cd12353', NULL, 'RRM2_TIA1_like', NULL, NULL, 'RRM2_TIA1_like', 11312),
(11313, 'cd08072', NULL, 'MPN_archaeal', NULL, NULL, 'MPN_archaeal', 11313),
(11314, 'cd17791', NULL, 'HipA-like', NULL, NULL, 'HipA-like', 11314),
(11315, 'cd09541', NULL, 'SAM_KIF24-like', NULL, NULL, 'SAM_KIF24-like', 11315),
(11316, 'cd17753', NULL, 'MCM2', NULL, NULL, 'MCM2', 11316),
(11317, 'cd18482', NULL, 'BACK_KBTBD6_7', NULL, NULL, 'BACK_KBTBD6_7', 11317),
(11318, 'cd08412', NULL, 'PBP2_PAO1_like', NULL, NULL, 'PBP2_PAO1_like', 11318),
(11319, 'cd09539', NULL, 'SAM_TNK-like', NULL, NULL, 'SAM_TNK-like', 11319),
(11320, 'cd13131', NULL, 'MATE_NorM_like', NULL, NULL, 'MATE_NorM_like', 11320),
(11321, 'cd19822', NULL, 'Bbox2_MID1_C-I', NULL, NULL, 'Bbox2_MID1_C-I', 11321),
(11322, 'cd06884', NULL, 'PX_PI3K_C2_68D', NULL, NULL, 'PX_PI3K_C2_68D', 11322),
(11323, 'cd18953', NULL, 'bHLH_TS_bHLHe23_bHLHb4', NULL, NULL, 'bHLH_TS_bHLHe23_bHLHb4', 11323),
(11324, 'cd00515', NULL, 'HAM1', NULL, NULL, 'HAM1', 11324),
(11325, 'cd15822', NULL, 'SPRY_PRY_TRIM5', NULL, NULL, 'SPRY_PRY_TRIM5', 11325),
(11326, 'cd13926', NULL, 'N-acetylmuramidase_GH108', NULL, NULL, 'N-acetylmuramidase_GH108', 11326),
(11327, 'cd15545', NULL, 'PHD_BAZ2A_like', NULL, NULL, 'PHD_BAZ2A_like', 11327),
(11328, 'cd17586', NULL, 'REC_PFxFATGY', NULL, NULL, 'REC_PFxFATGY', 11328),
(11329, 'cd04649', NULL, 'LbH_THP_succinylT_putative', NULL, NULL, 'LbH_THP_succinylT_putative', 11329),
(11330, 'cd10278', NULL, 'PQQ_MDH', NULL, NULL, 'PQQ_MDH', 11330),
(11331, 'cd20490', NULL, 'cupin_HutD_C', NULL, NULL, 'cupin_HutD_C', 11331),
(11332, 'cd05517', NULL, 'Bromo_polybromo_II', NULL, NULL, 'Bromo_polybromo_II', 11332),
(11333, 'cd12957', NULL, 'SKA3_N', NULL, NULL, 'SKA3_N', 11333),
(11334, 'cd21533', NULL, 'MERS-CoV-like_E', NULL, NULL, 'MERS-CoV-like_E', 11334),
(11335, 'cd03362', NULL, 'TOPRIM_TopoIA_TopoIII', NULL, NULL, 'TOPRIM_TopoIA_TopoIII', 11335),
(11336, 'cd07070', NULL, 'NR_LBD_SF-1', NULL, NULL, 'NR_LBD_SF-1', 11336),
(11337, 'cd09392', NULL, 'LIM2_Lrg1p_like', NULL, NULL, 'LIM2_Lrg1p_like', 11337),
(11338, 'cd19911', NULL, 'DSRM_STRBP_rpt2', NULL, NULL, 'DSRM_STRBP_rpt2', 11338),
(11339, 'cd01345', NULL, 'OM_channels', NULL, NULL, 'OM_channels', 11339),
(11340, 'cd02856', NULL, 'E_set_GDE_Isoamylase_N', NULL, NULL, 'E_set_GDE_Isoamylase_N', 11340),
(11341, 'cd11718', NULL, 'THUMP_SPOUT', NULL, NULL, 'THUMP_SPOUT', 11341),
(11342, 'cd06085', NULL, 'KOW_Spt5_5', NULL, NULL, 'KOW_Spt5_5', 11342),
(11343, 'cd07455', NULL, 'CRD_Collagen_XVIII', NULL, NULL, 'CRD_Collagen_XVIII', 11343),
(11344, 'cd16966', NULL, 'Alpha_kinase_ALPK2_3', NULL, NULL, 'Alpha_kinase_ALPK2_3', 11344),
(11345, 'cd09651', NULL, 'Cas5_I-C', NULL, NULL, 'Cas5_I-C', 11345),
(11346, 'cd16124', NULL, 'RA_GRB7_10_14', NULL, NULL, 'RA_GRB7_10_14', 11346),
(11347, 'cd08229', NULL, 'STKc_Nek7', NULL, NULL, 'STKc_Nek7', 11347),
(11348, 'cd14447', NULL, 'SPX', NULL, NULL, 'SPX', 11348),
(11349, 'cd09841', NULL, 'LIM1_Prickle_3', NULL, NULL, 'LIM1_Prickle_3', 11349),
(11350, 'cd04911', NULL, 'ACT_AKiii-YclM-BS_1', NULL, NULL, 'ACT_AKiii-YclM-BS_1', 11350);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(11351, 'cd08889', NULL, 'SRPBCC_PITPNM1-2_like', NULL, NULL, 'SRPBCC_PITPNM1-2_like', 11351),
(11352, 'cd09074', NULL, 'INPP5c', NULL, NULL, 'INPP5c', 11352),
(11353, 'cd00451', NULL, 'GH38N_AMII_euk', NULL, NULL, 'GH38N_AMII_euk', 11353),
(11354, 'cd00762', NULL, 'NAD_bind_malic_enz', NULL, NULL, 'NAD_bind_malic_enz', 11354),
(11355, 'cd14159', NULL, 'STKc_IRAK1', NULL, NULL, 'STKc_IRAK1', 11355),
(11356, 'cd02033', NULL, 'BchX', NULL, NULL, 'BchX', 11356),
(11357, 'cd07742', NULL, 'metallo-hydrolase-like_MBL-fold', NULL, NULL, 'metallo-hydrolase-like_MBL-fold', 11357),
(11358, 'cd16116', NULL, 'Ubl_Smt3_like', NULL, NULL, 'Ubl_Smt3_like', 11358),
(11359, 'cd01966', NULL, 'Nitrogenase_NifN_1', NULL, NULL, 'Nitrogenase_NifN_1', 11359),
(11360, 'cd03307', NULL, 'Mta_CmuA_like', NULL, NULL, 'Mta_CmuA_like', 11360),
(11361, 'cd12524', NULL, 'RRM1_MEI2_like', NULL, NULL, 'RRM1_MEI2_like', 11361),
(11362, 'cd05242', NULL, 'SDR_a8', NULL, NULL, 'SDR_a8', 11362),
(11363, 'cd14346', NULL, 'UBA_Ubx5_like', NULL, NULL, 'UBA_Ubx5_like', 11363),
(11364, 'cd08060', NULL, 'MPN_UPF0172', NULL, NULL, 'MPN_UPF0172', 11364),
(11365, 'cd10318', NULL, 'RGL11', NULL, NULL, 'RGL11', 11365),
(11366, 'cd17179', NULL, 'FERM_F1_PLEKHH2', NULL, NULL, 'FERM_F1_PLEKHH2', 11366),
(11367, 'cd13288', NULL, 'PH_Ses', NULL, NULL, 'PH_Ses', 11367),
(11368, 'cd06653', NULL, 'STKc_MEKK3_like_u1', NULL, NULL, 'STKc_MEKK3_like_u1', 11368),
(11369, 'cd09706', NULL, 'Csf2_U', NULL, NULL, 'Csf2_U', 11369),
(11370, 'cd11386', NULL, 'MCP_signal', NULL, NULL, 'MCP_signal', 11370),
(11371, 'cd11518', NULL, 'SLC6sbd_SIT1', NULL, NULL, 'SLC6sbd_SIT1', 11371),
(11372, 'cd11986', NULL, 'SH3_Stac3_1', NULL, NULL, 'SH3_Stac3_1', 11372),
(11373, 'cd06322', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, 'PBP1_ABC_sugar_binding-like', 11373),
(11374, 'cd04138', NULL, 'H_N_K_Ras_like', NULL, NULL, 'H_N_K_Ras_like', 11374),
(11375, 'cd01941', NULL, 'YeiC_kinase_like', NULL, NULL, 'YeiC_kinase_like', 11375),
(11376, 'cd02798', NULL, 'tRNA_bind_CsaA', NULL, NULL, 'tRNA_bind_CsaA', 11376),
(11377, 'cd01996', NULL, 'Alpha_ANH_like_III', NULL, NULL, 'Alpha_ANH_like_III', 11377),
(11378, 'cd05800', NULL, 'PGM_like2', NULL, NULL, 'PGM_like2', 11378),
(11379, 'cd11814', NULL, 'SH3_Eve1_1', NULL, NULL, 'SH3_Eve1_1', 11379),
(11380, 'cd16611', NULL, 'RING-HC_TRIM69_C-IV', NULL, NULL, 'RING-HC_TRIM69_C-IV', 11380),
(11381, 'cd18488', NULL, 'BACK_BTBD3_like', NULL, NULL, 'BACK_BTBD3_like', 11381),
(11382, 'sd00016', NULL, 'Apc5', NULL, NULL, 'Apc5', 11382),
(11383, 'cd11790', NULL, 'SH3_Amphiphysin', NULL, NULL, 'SH3_Amphiphysin', 11383),
(11384, 'cd18598', NULL, 'ABC_6TM_MRP7_D1_like', NULL, NULL, 'ABC_6TM_MRP7_D1_like', 11384),
(11385, 'cd08034', NULL, 'LARP_1_2', NULL, NULL, 'LARP_1_2', 11385),
(11386, 'cd09516', NULL, 'SAM_sec23ip-like', NULL, NULL, 'SAM_sec23ip-like', 11386),
(11387, 'cd12131', NULL, 'HGbI-like', NULL, NULL, 'HGbI-like', 11387),
(11388, 'cd05053', NULL, 'PTKc_FGFR', NULL, NULL, 'PTKc_FGFR', 11388),
(11389, 'cd07150', NULL, 'ALDH_VaniDH_like', NULL, NULL, 'ALDH_VaniDH_like', 11389),
(11390, 'cd07824', NULL, 'SRPBCC_6', NULL, NULL, 'SRPBCC_6', 11390),
(11391, 'cd16745', NULL, 'RING-HC_AtRMA_like', NULL, NULL, 'RING-HC_AtRMA_like', 11391),
(11392, 'cd07804', NULL, 'FGGY_XK_like_1', NULL, NULL, 'FGGY_XK_like_1', 11392),
(11393, 'cd16942', NULL, 'HATPase_SpoIIAB-like', NULL, NULL, 'HATPase_SpoIIAB-like', 11393),
(11394, 'cd11460', NULL, 'bHLH-O_HES6', NULL, NULL, 'bHLH-O_HES6', 11394),
(11395, 'cd03016', NULL, 'PRX_1cys', NULL, NULL, 'PRX_1cys', 11395),
(11396, 'cd17443', NULL, 'MFS_SLC22A31', NULL, NULL, 'MFS_SLC22A31', 11396),
(11397, 'cd05659', NULL, 'M18_API', NULL, NULL, 'M18_API', 11397),
(11398, 'cd11670', NULL, 'Sp_RAP1_RCT', NULL, NULL, 'Sp_RAP1_RCT', 11398),
(11399, 'cd16965', NULL, 'Alpha_kinase_ChaK', NULL, NULL, 'Alpha_kinase_ChaK', 11399),
(11400, 'cd07398', NULL, 'MPP_YbbF-LpxH', NULL, NULL, 'MPP_YbbF-LpxH', 11400),
(11401, 'cd16200', NULL, 'EFh_PI-PLCbeta', NULL, NULL, 'EFh_PI-PLCbeta', 11401),
(11402, 'cd05588', NULL, 'STKc_aPKC', NULL, NULL, 'STKc_aPKC', 11402);
INSERT INTO "PUBLIC"."MODEL" VALUES
(11403, 'cd02059', NULL, 'serpinB14_OVA', NULL, NULL, 'serpinB14_OVA', 11403),
(11404, 'cd07675', NULL, 'F-BAR_FNBP1L', NULL, NULL, 'F-BAR_FNBP1L', 11404),
(11405, 'cd18746', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, 'PIN_VapC4-5_FitB-like', 11405),
(11406, 'cd14699', NULL, 'bZIP_Fos_like', NULL, NULL, 'bZIP_Fos_like', 11406),
(11407, 'cd11700', NULL, 'DHR2_DOCK11', NULL, NULL, 'DHR2_DOCK11', 11407),
(11408, 'cd14068', NULL, 'STKc_LRRK2', NULL, NULL, 'STKc_LRRK2', 11408),
(11409, 'cd07422', NULL, 'MPP_ApaH', NULL, NULL, 'MPP_ApaH', 11409),
(11410, 'cd03231', NULL, 'ABC_CcmA_heme_exporter', NULL, NULL, 'ABC_CcmA_heme_exporter', 11410),
(11411, 'cd09371', NULL, 'LIM1_Lmx1b', NULL, NULL, 'LIM1_Lmx1b', 11411),
(11412, 'cd11537', NULL, 'NTP-PPase_RS21-C6_like', NULL, NULL, 'NTP-PPase_RS21-C6_like', 11412),
(11413, 'cd09255', NULL, 'AP-like_stonins_MHD', NULL, NULL, 'AP-like_stonins_MHD', 11413),
(11414, 'cd01444', NULL, 'GlpE_ST', NULL, NULL, 'GlpE_ST', 11414),
(11415, 'cd09645', NULL, 'Cas5_I-E', NULL, NULL, 'Cas5_I-E', 11415),
(11416, 'cd06829', NULL, 'PLPDE_III_CANSDC', NULL, NULL, 'PLPDE_III_CANSDC', 11416),
(11417, 'cd18812', NULL, 'CAP_PI15-like', NULL, NULL, 'CAP_PI15-like', 11417),
(11418, 'cd13590', NULL, 'PBP2_PotD_PotF_like', NULL, NULL, 'PBP2_PotD_PotF_like', 11418),
(11419, 'cd01670', NULL, 'Death', NULL, NULL, 'Death', 11419),
(11420, 'cd14781', NULL, 'FHb-globin_1', NULL, NULL, 'FHb-globin_1', 11420),
(11421, 'cd05921', NULL, 'FCS', NULL, NULL, 'FCS', 11421),
(11422, 'cd16659', NULL, 'RING-Ubox_Emp', NULL, NULL, 'RING-Ubox_Emp', 11422),
(11423, 'cd06273', NULL, 'PBP1_LacI-like', NULL, NULL, 'PBP1_LacI-like', 11423),
(11424, 'cd20248', NULL, 'phospholamban_like', NULL, NULL, 'phospholamban_like', 11424),
(11425, 'cd20266', NULL, 'Complex1_LYR_NDUFA6_LYRM6', NULL, NULL, 'Complex1_LYR_NDUFA6_LYRM6', 11425),
(11426, 'cd19785', NULL, 'Bbox2_TRIM45_C-X', NULL, NULL, 'Bbox2_TRIM45_C-X', 11426),
(11427, 'cd02516', NULL, 'CDP-ME_synthetase', NULL, NULL, 'CDP-ME_synthetase', 11427),
(11428, 'cd05060', NULL, 'PTKc_Syk_like', NULL, NULL, 'PTKc_Syk_like', 11428),
(11429, 'cd12732', NULL, 'RRM2_hnRNPH3', NULL, NULL, 'RRM2_hnRNPH3', 11429),
(11430, 'cd07335', NULL, 'M48B_HtpX_like', NULL, NULL, 'M48B_HtpX_like', 11430),
(11431, 'cd09413', NULL, 'LIM1_Testin', NULL, NULL, 'LIM1_Testin', 11431),
(11432, 'cd15542', NULL, 'PHD_UBR7', NULL, NULL, 'PHD_UBR7', 11432),
(11433, 'cd10574', NULL, 'EVH1_SPRED-like', NULL, NULL, 'EVH1_SPRED-like', 11433),
(11434, 'cd17255', NULL, 'RMtype1_S_Fco49512ORF2615P-TRD2-CR2_like', NULL, NULL, 'RMtype1_S_Fco49512ORF2615P-TRD2-CR2_like', 11434),
(11435, 'cd03332', NULL, 'LMO_FMN', NULL, NULL, 'LMO_FMN', 11435),
(11436, 'cd06113', NULL, 'citrate_synt_like_1_2', NULL, NULL, 'citrate_synt_like_1_2', 11436),
(11437, 'cd09337', NULL, 'LIM2_Paxillin_like', NULL, NULL, 'LIM2_Paxillin_like', 11437),
(11438, 'cd12598', NULL, 'RRM1_SRSF9', NULL, NULL, 'RRM1_SRSF9', 11438),
(11439, 'cd07909', NULL, 'YciF', NULL, NULL, 'YciF', 11439),
(11440, 'cd15586', NULL, 'PHD_ING4_5', NULL, NULL, 'PHD_ING4_5', 11440),
(11441, 'cd00448', NULL, 'YjgF_YER057c_UK114_family', NULL, NULL, 'YjgF_YER057c_UK114_family', 11441),
(11442, 'cd18977', NULL, 'CD_POL_like', NULL, NULL, 'CD_POL_like', 11442),
(11443, 'cd06145', NULL, 'REX1_like', NULL, NULL, 'REX1_like', 11443),
(11444, 'cd18824', NULL, 'GH43_CtGH43-like', NULL, NULL, 'GH43_CtGH43-like', 11444),
(11445, 'cd04118', NULL, 'Rab24', NULL, NULL, 'Rab24', 11445),
(11446, 'cd05653', NULL, 'M20_ArgE_LysK', NULL, NULL, 'M20_ArgE_LysK', 11446),
(11447, 'cd16265', NULL, 'Translation_Factor_II', NULL, NULL, 'Translation_Factor_II', 11447),
(11448, 'cd02557', NULL, 'PseudoU_synth_ScRIB2', NULL, NULL, 'PseudoU_synth_ScRIB2', 11448),
(11449, 'cd16827', NULL, 'ChuX-like', NULL, NULL, 'ChuX-like', 11449),
(11450, 'cd18749', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, 'PIN_VapC4-5_FitB-like', 11450),
(11451, 'cd18425', NULL, 'BTB_POZ_KCNV2', NULL, NULL, 'BTB_POZ_KCNV2', 11451),
(11452, 'cd04218', NULL, 'Pseudoazurin', NULL, NULL, 'Pseudoazurin', 11452),
(11453, 'cd04513', NULL, 'Glycosylasparaginase', NULL, NULL, 'Glycosylasparaginase', 11453);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(11454, 'cd09602', NULL, 'M1_APN', NULL, NULL, 'M1_APN', 11454),
(11455, 'cd00096', NULL, 'Ig', NULL, NULL, 'Ig', 11455),
(11456, 'cd01842', NULL, 'SGNH_hydrolase_like_5', NULL, NULL, 'SGNH_hydrolase_like_5', 11456),
(11457, 'cd00732', NULL, 'CheW', NULL, NULL, 'CheW', 11457),
(11458, 'cd01111', NULL, 'HTH_MerD', NULL, NULL, 'HTH_MerD', 11458),
(11459, 'cd18787', NULL, 'SF2_C_DEAD', NULL, NULL, 'SF2_C_DEAD', 11459),
(11460, 'cd01189', NULL, 'INT_ICEBs1_C_like', NULL, NULL, 'INT_ICEBs1_C_like', 11460),
(11461, 'cd16421', NULL, 'HAD_PGPase', NULL, NULL, 'HAD_PGPase', 11461),
(11462, 'cd16388', NULL, 'SbnI_like_N', NULL, NULL, 'SbnI_like_N', 11462),
(11463, 'cd17477', NULL, 'MFS_YcaD_like', NULL, NULL, 'MFS_YcaD_like', 11463),
(11464, 'cd19593', NULL, 'serpin_bacteria_crustaceans', NULL, NULL, 'serpin_bacteria_crustaceans', 11464),
(11465, 'cd02894', NULL, 'GGTase-II', NULL, NULL, 'GGTase-II', 11465),
(11466, 'cd18034', NULL, 'DEXHc_dicer', NULL, NULL, 'DEXHc_dicer', 11466),
(11467, 'cd08414', NULL, 'PBP2_LTTR_aromatics_like', NULL, NULL, 'PBP2_LTTR_aromatics_like', 11467),
(11468, 'cd08440', NULL, 'PBP2_LTTR_like_4', NULL, NULL, 'PBP2_LTTR_like_4', 11468),
(11469, 'cd04936', NULL, 'ACT_AKii-LysC-BS-like_2', NULL, NULL, 'ACT_AKii-LysC-BS-like_2', 11469),
(11470, 'cd17197', NULL, 'FERM_F1_FRMD1', NULL, NULL, 'FERM_F1_FRMD1', 11470),
(11471, 'cd19945', NULL, 'Fer2_BFD', NULL, NULL, 'Fer2_BFD', 11471),
(11472, 'cd05799', NULL, 'PGM2', NULL, NULL, 'PGM2', 11472),
(11473, 'cd11970', NULL, 'SH3_PLCgamma1', NULL, NULL, 'SH3_PLCgamma1', 11473),
(11474, 'cd06357', NULL, 'PBP1_AmiC', NULL, NULL, 'PBP1_AmiC', 11474),
(11475, 'cd09705', NULL, 'Csf1_U', NULL, NULL, 'Csf1_U', 11475),
(11476, 'cd11571', NULL, 'FAT-like_EFS_C', NULL, NULL, 'FAT-like_EFS_C', 11476),
(11477, 'cd12328', NULL, 'RRM2_hnRNPA_like', NULL, NULL, 'RRM2_hnRNPA_like', 11477),
(11478, 'cd14567', NULL, 'DSP_DUSP10', NULL, NULL, 'DSP_DUSP10', 11478),
(11479, 'cd07278', NULL, 'PX_RICS_like', NULL, NULL, 'PX_RICS_like', 11479),
(11480, 'cd07845', NULL, 'STKc_CDK10', NULL, NULL, 'STKc_CDK10', 11480),
(11481, 'cd15360', NULL, '7tmA_FSH-R', NULL, NULL, '7tmA_FSH-R', 11481),
(11482, 'cd12444', NULL, 'RRM1_CPEBs', NULL, NULL, 'RRM1_CPEBs', 11482),
(11483, 'cd20214', NULL, 'PFM_CEL-III-like', NULL, NULL, 'PFM_CEL-III-like', 11483),
(11484, 'cd15963', NULL, '7tmA_GPR3', NULL, NULL, '7tmA_GPR3', 11484),
(11485, 'cd06860', NULL, 'PX_SNX7_30_like', NULL, NULL, 'PX_SNX7_30_like', 11485),
(11486, 'cd11756', NULL, 'GH94N_ChvB_NdvB_1_like', NULL, NULL, 'GH94N_ChvB_NdvB_1_like', 11486),
(11487, 'cd10233', NULL, 'HSPA1-2_6-8-like_NBD', NULL, NULL, 'HSPA1-2_6-8-like_NBD', 11487),
(11488, 'cd14184', NULL, 'STKc_DCKL2', NULL, NULL, 'STKc_DCKL2', 11488),
(11489, 'cd09944', NULL, 'SH2_Grb7_family', NULL, NULL, 'SH2_Grb7_family', 11489),
(11490, 'cd04052', NULL, 'C2B_Tricalbin-like', NULL, NULL, 'C2B_Tricalbin-like', 11490),
(11491, 'cd06662', NULL, 'SURF1', NULL, NULL, 'SURF1', 11491),
(11492, 'cd08243', NULL, 'quinone_oxidoreductase_like_1', NULL, NULL, 'quinone_oxidoreductase_like_1', 11492),
(11493, 'cd11807', NULL, 'SH3_ASPP', NULL, NULL, 'SH3_ASPP', 11493),
(11494, 'cd16010', NULL, 'iPGM', NULL, NULL, 'iPGM', 11494),
(11495, 'cd06394', NULL, 'PBP1_iGluR_Kainate_KA1_2', NULL, NULL, 'PBP1_iGluR_Kainate_KA1_2', 11495),
(11496, 'cd05403', NULL, 'NT_KNTase_like', NULL, NULL, 'NT_KNTase_like', 11496),
(11497, 'cd16569', NULL, 'RING-HC_SHPRH', NULL, NULL, 'RING-HC_SHPRH', 11497),
(11498, 'cd15740', NULL, 'FYVE_FGD3', NULL, NULL, 'FYVE_FGD3', 11498),
(11499, 'cd04180', NULL, 'UGPase_euk_like', NULL, NULL, 'UGPase_euk_like', 11499),
(11500, 'cd01406', NULL, 'SIR2-like', NULL, NULL, 'SIR2-like', 11500),
(11501, 'cd09661', NULL, 'Cmr6_III-B', NULL, NULL, 'Cmr6_III-B', 11501),
(11502, 'cd17630', NULL, 'OSB_MenE-like', NULL, NULL, 'OSB_MenE-like', 11502),
(11503, 'cd04904', NULL, 'ACT_AAAH', NULL, NULL, 'ACT_AAAH', 11503),
(11504, 'cd20762', NULL, 'capping_2-OMTase_Nidovirales', NULL, NULL, 'capping_2-OMTase_Nidovirales', 11504),
(11505, 'cd16281', NULL, 'metallo-hydrolase-like_MBL-fold', NULL, NULL, 'metallo-hydrolase-like_MBL-fold', 11505);
INSERT INTO "PUBLIC"."MODEL" VALUES
(11506, 'cd06609', NULL, 'STKc_MST3_like', NULL, NULL, 'STKc_MST3_like', 11506),
(11507, 'cd06601', NULL, 'GH31_lyase_GLase', NULL, NULL, 'GH31_lyase_GLase', 11507),
(11508, 'cd13206', NULL, 'FERM_C-lobe_PLEKHH1_PLEKHH2', NULL, NULL, 'FERM_C-lobe_PLEKHH1_PLEKHH2', 11508),
(11509, 'cd05663', NULL, 'M28_like_PA_PDZ_associated', NULL, NULL, 'M28_like_PA_PDZ_associated', 11509),
(11510, 'cd00395', NULL, 'Tyr_Trp_RS_core', NULL, NULL, 'Tyr_Trp_RS_core', 11510),
(11511, 'cd15536', NULL, 'PHD_PHRF1', NULL, NULL, 'PHD_PHRF1', 11511),
(11512, 'cd06106', NULL, 'ScCit3_like', NULL, NULL, 'ScCit3_like', 11512),
(11513, 'cd03069', NULL, 'PDI_b_ERp57', NULL, NULL, 'PDI_b_ERp57', 11513),
(11514, 'cd03772', NULL, 'MATH_HAUSP', NULL, NULL, 'MATH_HAUSP', 11514),
(11515, 'cd04032', NULL, 'C2_Perforin', NULL, NULL, 'C2_Perforin', 11515),
(11516, 'cd12272', NULL, 'RRM2_PHIP1', NULL, NULL, 'RRM2_PHIP1', 11516),
(11517, 'cd12299', NULL, 'RRM4_Prp24', NULL, NULL, 'RRM4_Prp24', 11517),
(11518, 'cd08487', NULL, 'PBP2_BlaA', NULL, NULL, 'PBP2_BlaA', 11518),
(11519, 'cd15943', NULL, '7tmA_OR5AP2-like', NULL, NULL, '7tmA_OR5AP2-like', 11519),
(11520, 'cd08496', NULL, 'PBP2_NikA_DppA_OppA_like_9', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_9', 11520),
(11521, 'cd02173', NULL, 'ECT', NULL, NULL, 'ECT', 11521),
(11522, 'cd18375', NULL, 'BTB_POZ_KCNRG', NULL, NULL, 'BTB_POZ_KCNRG', 11522),
(11523, 'cd00736', NULL, 'lambda_lys-like', NULL, NULL, 'lambda_lys-like', 11523),
(11524, 'cd13235', NULL, 'PH2_FARP1-like', NULL, NULL, 'PH2_FARP1-like', 11524),
(11525, 'cd08441', NULL, 'PBP2_MetR', NULL, NULL, 'PBP2_MetR', 11525),
(11526, 'cd19744', NULL, 'bHLH_TS_dAS-C_like', NULL, NULL, 'bHLH_TS_dAS-C_like', 11526),
(11527, 'cd15001', NULL, '7tmA_GPRnna14-like', NULL, NULL, '7tmA_GPRnna14-like', 11527),
(11528, 'cd12574', NULL, 'RRM1_DAZAP1', NULL, NULL, 'RRM1_DAZAP1', 11528),
(11529, 'cd17757', NULL, 'MCM6', NULL, NULL, 'MCM6', 11529),
(11530, 'cd18593', NULL, 'ABC_6TM_MRP4_D1_like', NULL, NULL, 'ABC_6TM_MRP4_D1_like', 11530),
(11531, 'cd03325', NULL, 'D-galactonate_dehydratase', NULL, NULL, 'D-galactonate_dehydratase', 11531),
(11532, 'cd08300', NULL, 'alcohol_DH_class_III', NULL, NULL, 'alcohol_DH_class_III', 11532),
(11533, 'cd11376', NULL, 'Imelysin-like', NULL, NULL, 'Imelysin-like', 11533),
(11534, 'cd12102', NULL, 'DD_RIbeta_PKA', NULL, NULL, 'DD_RIbeta_PKA', 11534),
(11535, 'cd00266', NULL, 'MADS_SRF_like', NULL, NULL, 'MADS_SRF_like', 11535),
(11536, 'cd17108', NULL, 'FERM_F1_EPB41L5_like', NULL, NULL, 'FERM_F1_EPB41L5_like', 11536),
(11537, 'cd08860', NULL, 'TcmN_ARO-CYC_like', NULL, NULL, 'TcmN_ARO-CYC_like', 11537),
(11538, 'cd04915', NULL, 'ACT_AK-Ectoine_2', NULL, NULL, 'ACT_AK-Ectoine_2', 11538),
(11539, 'cd15984', NULL, '7tmB1_PTH1R', NULL, NULL, '7tmB1_PTH1R', 11539),
(11540, 'cd08627', NULL, 'PI-PLCc_gamma1', NULL, NULL, 'PI-PLCc_gamma1', 11540),
(11541, 'cd14394', NULL, 'UBA_BIRC2_3', NULL, NULL, 'UBA_BIRC2_3', 11541),
(11542, 'cd15404', NULL, '7tmA_GPR63', NULL, NULL, '7tmA_GPR63', 11542),
(11543, 'cd16961', NULL, 'RMtype1_S_TRD-CR_like', NULL, NULL, 'RMtype1_S_TRD-CR_like', 11543),
(11544, 'cd13426', NULL, 'Peptidase_G1', NULL, NULL, 'Peptidase_G1', 11544),
(11545, 'cd15127', NULL, '7tmA_GPR37', NULL, NULL, '7tmA_GPR37', 11545),
(11546, 'cd00059', NULL, 'FH', NULL, NULL, 'FH', 11546),
(11547, 'cd00454', NULL, 'TrHb1_N', NULL, NULL, 'TrHb1_N', 11547),
(11548, 'cd06450', NULL, 'DOPA_deC_like', NULL, NULL, 'DOPA_deC_like', 11548),
(11549, 'cd05693', NULL, 'S1_Rrp5_repeat_hs1_sc1', NULL, NULL, 'S1_Rrp5_repeat_hs1_sc1', 11549),
(11550, 'cd15568', NULL, 'PHD5_NSD', NULL, NULL, 'PHD5_NSD', 11550),
(11551, 'cd07931', NULL, 'eukaryotic_phosphagen_kinases', NULL, NULL, 'eukaryotic_phosphagen_kinases', 11551),
(11552, 'cd08690', NULL, 'C2_Freud-1', NULL, NULL, 'C2_Freud-1', 11552),
(11553, 'cd10160', NULL, 'CsoR-like_DUF156_3', NULL, NULL, 'CsoR-like_DUF156_3', 11553),
(11554, 'cd15674', NULL, 'ePHD_PHF14', NULL, NULL, 'ePHD_PHF14', 11554),
(11555, 'cd21481', NULL, 'SARS-CoV_Spike_S1_RBD', NULL, NULL, 'SARS-CoV_Spike_S1_RBD', 11555);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(11556, 'cd03227', NULL, 'ABC_Class2', NULL, NULL, 'ABC_Class2', 11556),
(11557, 'cd14540', NULL, 'PTPc-N21_14', NULL, NULL, 'PTPc-N21_14', 11557),
(11558, 'cd17141', NULL, 'DCX1_DCLK2', NULL, NULL, 'DCX1_DCLK2', 11558),
(11559, 'cd20282', NULL, 'cupin_DddQ', NULL, NULL, 'cupin_DddQ', 11559),
(11560, 'cd11821', NULL, 'SH3_ASAP', NULL, NULL, 'SH3_ASAP', 11560),
(11561, 'cd12089', NULL, 'Hef_ID', NULL, NULL, 'Hef_ID', 11561),
(11562, 'cd17764', NULL, 'MTAP_SsMTAPI_like', NULL, NULL, 'MTAP_SsMTAPI_like', 11562),
(11563, 'cd08200', NULL, 'catalase_peroxidase_2', NULL, NULL, 'catalase_peroxidase_2', 11563),
(11564, 'cd09286', NULL, 'NMNAT_Eukarya', NULL, NULL, 'NMNAT_Eukarya', 11564),
(11565, 'cd17363', NULL, 'MFS_SV2', NULL, NULL, 'MFS_SV2', 11565),
(11566, 'cd18507', NULL, 'BACK_GPRS_like', NULL, NULL, 'BACK_GPRS_like', 11566),
(11567, 'cd18769', NULL, 'PIN_Mut7-C-like', NULL, NULL, 'PIN_Mut7-C-like', 11567),
(11568, 'cd08245', NULL, 'CAD', NULL, NULL, 'CAD', 11568),
(11569, 'cd06402', NULL, 'PB1_p62', NULL, NULL, 'PB1_p62', 11569),
(11570, 'cd18756', NULL, 'PIN_MtVapC15-VapC11-like', NULL, NULL, 'PIN_MtVapC15-VapC11-like', 11570),
(11571, 'cd08375', NULL, 'C2_Intersectin', NULL, NULL, 'C2_Intersectin', 11571),
(11572, 'cd09324', NULL, 'TDT_TehA', NULL, NULL, 'TDT_TehA', 11572),
(11573, 'cd14073', NULL, 'STKc_NUAK', NULL, NULL, 'STKc_NUAK', 11573),
(11574, 'cd05362', NULL, 'THN_reductase-like_SDR_c', NULL, NULL, 'THN_reductase-like_SDR_c', 11574),
(11575, 'cd15951', NULL, '7tmA_OR52R_52L-like', NULL, NULL, '7tmA_OR52R_52L-like', 11575),
(11576, 'cd04396', NULL, 'RhoGAP_fSAC7_BAG7', NULL, NULL, 'RhoGAP_fSAC7_BAG7', 11576),
(11577, 'cd08532', NULL, 'SAM_PNT-PDEF-like', NULL, NULL, 'SAM_PNT-PDEF-like', 11577),
(11578, 'cd06267', NULL, 'PBP1_LacI_sugar_binding-like', NULL, NULL, 'PBP1_LacI_sugar_binding-like', 11578),
(11579, 'cd10923', NULL, 'CE4_COG5298', NULL, NULL, 'CE4_COG5298', 11579),
(11580, 'cd12770', NULL, 'RRM1_HuD', NULL, NULL, 'RRM1_HuD', 11580),
(11581, 'cd19203', NULL, 'SET_SMYD3', NULL, NULL, 'SET_SMYD3', 11581),
(11582, 'cd00449', NULL, 'PLPDE_IV', NULL, NULL, 'PLPDE_IV', 11582),
(11583, 'cd11520', NULL, 'SLC5sbd_SMCT2', NULL, NULL, 'SLC5sbd_SMCT2', 11583),
(11584, 'cd12451', NULL, 'RRM2_NUCLs', NULL, NULL, 'RRM2_NUCLs', 11584),
(11585, 'cd19072', NULL, 'AKR_AKR3F1-like', NULL, NULL, 'AKR_AKR3F1-like', 11585),
(11586, 'cd07423', NULL, 'MPP_Prp_like', NULL, NULL, 'MPP_Prp_like', 11586),
(11587, 'cd11418', NULL, 'bHLH_TS_ASCL', NULL, NULL, 'bHLH_TS_ASCL', 11587),
(11588, 'cd13359', NULL, 'PH_ELMO1_CED-12', NULL, NULL, 'PH_ELMO1_CED-12', 11588),
(11589, 'cd14286', NULL, 'UBA_UBP24', NULL, NULL, 'UBA_UBP24', 11589),
(11590, 'cd15601', NULL, 'PHD5_KMT2D', NULL, NULL, 'PHD5_KMT2D', 11590),
(11591, 'cd02604', NULL, 'HAD_5NT', NULL, NULL, 'HAD_5NT', 11591),
(11592, 'cd14135', NULL, 'STKc_PRP4', NULL, NULL, 'STKc_PRP4', 11592),
(11593, 'cd12083', NULL, 'DD_cGKI', NULL, NULL, 'DD_cGKI', 11593),
(11594, 'cd16682', NULL, 'RING-H2_RNF165', NULL, NULL, 'RING-H2_RNF165', 11594),
(11595, 'cd02410', NULL, 'archeal_CPSF_KH', NULL, NULL, 'archeal_CPSF_KH', 11595),
(11596, 'cd09498', NULL, 'SAM_caskin1,2_repeat2', NULL, NULL, 'SAM_caskin1,2_repeat2', 11596),
(11597, 'cd10975', NULL, 'CE4_CDA_like_2', NULL, NULL, 'CE4_CDA_like_2', 11597),
(11598, 'cd13381', NULL, 'PH_Skap-hom_Skap2', NULL, NULL, 'PH_Skap-hom_Skap2', 11598),
(11599, 'cd05311', NULL, 'NAD_bind_2_malic_enz', NULL, NULL, 'NAD_bind_2_malic_enz', 11599),
(11600, 'cd05683', NULL, 'M20_peptT_like', NULL, NULL, 'M20_peptT_like', 11600),
(11601, 'cd13572', NULL, 'PBP2_PnhD_2', NULL, NULL, 'PBP2_PnhD_2', 11601),
(11602, 'cd03274', NULL, 'ABC_SMC4_euk', NULL, NULL, 'ABC_SMC4_euk', 11602),
(11603, 'cd16390', NULL, 'ParB_N_Srx_like', NULL, NULL, 'ParB_N_Srx_like', 11603),
(11604, 'cd05867', NULL, 'Ig4_L1-CAM_like', NULL, NULL, 'Ig4_L1-CAM_like', 11604),
(11605, 'cd05211', NULL, 'NAD_bind_Glu_Leu_Phe_Val', NULL, NULL, 'NAD_bind_Glu_Leu_Phe_Val', 11605),
(11606, 'cd13345', NULL, 'PH-GRAM_MTMR8', NULL, NULL, 'PH-GRAM_MTMR8', 11606),
(11607, 'cd13658', NULL, 'PBP2_CMBP', NULL, NULL, 'PBP2_CMBP', 11607);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(11608, 'cd11363', NULL, 'RNase_PH_PNPase_1', NULL, NULL, 'RNase_PH_PNPase_1', 11608),
(11609, 'cd11395', NULL, 'bHLHzip_SREBP_like', NULL, NULL, 'bHLHzip_SREBP_like', 11609),
(11610, 'cd12939', NULL, 'LEM_emerin', NULL, NULL, 'LEM_emerin', 11610),
(11611, 'cd03172', NULL, 'SORL_classII', NULL, NULL, 'SORL_classII', 11611),
(11612, 'cd09446', NULL, 'LIM_N_RAP', NULL, NULL, 'LIM_N_RAP', 11612),
(11613, 'cd09513', NULL, 'SAM_BAR', NULL, NULL, 'SAM_BAR', 11613),
(11614, 'cd03595', NULL, 'CLECT_chondrolectin_like', NULL, NULL, 'CLECT_chondrolectin_like', 11614),
(11615, 'cd16169', NULL, 'Tau138_eWH', NULL, NULL, 'Tau138_eWH', 11615),
(11616, 'cd09750', NULL, 'Csa5_I-A', NULL, NULL, 'Csa5_I-A', 11616),
(11617, 'cd18070', NULL, 'DEXQc_SHPRH', NULL, NULL, 'DEXQc_SHPRH', 11617),
(11618, 'cd06464', NULL, 'ACD_sHsps-like', NULL, NULL, 'ACD_sHsps-like', 11618),
(11619, 'cd11604', NULL, 'RTT106_N', NULL, NULL, 'RTT106_N', 11619),
(11620, 'cd12885', NULL, 'SPRY_RanBP_like', NULL, NULL, 'SPRY_RanBP_like', 11620),
(11621, 'cd08931', NULL, 'SDR_c9', NULL, NULL, 'SDR_c9', 11621),
(11622, 'cd00390', NULL, 'Urease_gamma', NULL, NULL, 'Urease_gamma', 11622),
(11623, 'cd11329', NULL, 'AmyAc_maltase-like', NULL, NULL, 'AmyAc_maltase-like', 11623),
(11624, 'cd12810', NULL, 'Esterase_713_like-3', NULL, NULL, 'Esterase_713_like-3', 11624),
(11625, 'cd01577', NULL, 'IPMI_Swivel', NULL, NULL, 'IPMI_Swivel', 11625),
(11626, 'cd15428', NULL, '7tmA_OR2D-like', NULL, NULL, '7tmA_OR2D-like', 11626),
(11627, 'cd00883', NULL, 'beta_CA_cladeA', NULL, NULL, 'beta_CA_cladeA', 11627),
(11628, 'cd08865', NULL, 'SRPBCC_10', NULL, NULL, 'SRPBCC_10', 11628),
(11629, 'cd15129', NULL, '7tmA_GPR142', NULL, NULL, '7tmA_GPR142', 11629),
(11630, 'cd20240', NULL, 'PFM_aerolysin-like', NULL, NULL, 'PFM_aerolysin-like', 11630),
(11631, 'cd17002', NULL, 'CID_RPRD1', NULL, NULL, 'CID_RPRD1', 11631),
(11632, 'cd07042', NULL, 'STAS_SulP_like_sulfate_transporter', NULL, NULL, 'STAS_SulP_like_sulfate_transporter', 11632),
(11633, 'cd18780', NULL, 'ABC_6TM_AtABCB27_like', NULL, NULL, 'ABC_6TM_AtABCB27_like', 11633),
(11634, 'cd18808', NULL, 'SF1_C_Upf1', NULL, NULL, 'SF1_C_Upf1', 11634),
(11635, 'cd07333', NULL, 'M48C_bepA_like', NULL, NULL, 'M48C_bepA_like', 11635),
(11636, 'cd16579', NULL, 'RING-HC_PML_C-V', NULL, NULL, 'RING-HC_PML_C-V', 11636),
(11637, 'cd10531', NULL, 'SET_SETD2-like', NULL, NULL, 'SET_SETD2-like', 11637),
(11638, 'cd08223', NULL, 'STKc_Nek4', NULL, NULL, 'STKc_Nek4', 11638),
(11639, 'cd15685', NULL, 'PHD_ING5', NULL, NULL, 'PHD_ING5', 11639),
(11640, 'cd08890', NULL, 'SRPBCC_PITPNC1_like', NULL, NULL, 'SRPBCC_PITPNC1_like', 11640),
(11641, 'cd16724', NULL, 'RING1-HC_MIB1', NULL, NULL, 'RING1-HC_MIB1', 11641),
(11642, 'cd17266', NULL, 'RMtype1_S_Sau1132ORF3780P-TRD2-CR2_like', NULL, NULL, 'RMtype1_S_Sau1132ORF3780P-TRD2-CR2_like', 11642),
(11643, 'cd06070', NULL, 'H2MP_like-2', NULL, NULL, 'H2MP_like-2', 11643),
(11644, 'cd08985', NULL, 'GH43_CtGH43-like', NULL, NULL, 'GH43_CtGH43-like', 11644),
(11645, 'cd00330', NULL, 'phosphagen_kinases', NULL, NULL, 'phosphagen_kinases', 11645),
(11646, 'cd16814', NULL, 'RING-HC_RNF20', NULL, NULL, 'RING-HC_RNF20', 11646),
(11647, 'cd02012', NULL, 'TPP_TK', NULL, NULL, 'TPP_TK', 11647),
(11648, 'cd12194', NULL, 'Kcc4p_like_C', NULL, NULL, 'Kcc4p_like_C', 11648),
(11649, 'cd13367', NULL, 'PH_BCR_vertebrate', NULL, NULL, 'PH_BCR_vertebrate', 11649),
(11650, 'cd15955', NULL, '7tmA_OR52A-like', NULL, NULL, '7tmA_OR52A-like', 11650),
(11651, 'cd17148', NULL, 'DCX2_RP1L1', NULL, NULL, 'DCX2_RP1L1', 11651),
(11652, 'cd01949', NULL, 'GGDEF', NULL, NULL, 'GGDEF', 11652),
(11653, 'cd03466', NULL, 'Nitrogenase_NifN_2', NULL, NULL, 'Nitrogenase_NifN_2', 11653),
(11654, 'cd07692', NULL, 'Ig_CD3_epsilon', NULL, NULL, 'Ig_CD3_epsilon', 11654),
(11655, 'cd11292', NULL, 'gelsolin_S3_like', NULL, NULL, 'gelsolin_S3_like', 11655),
(11656, 'cd01851', NULL, 'GBP', NULL, NULL, 'GBP', 11656),
(11657, 'cd09873', NULL, 'PIN_Pae0151-like', NULL, NULL, 'PIN_Pae0151-like', 11657),
(11658, 'cd11384', NULL, 'RagA_like', NULL, NULL, 'RagA_like', 11658);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(11659, 'cd15192', NULL, '7tmA_AT1R', NULL, NULL, '7tmA_AT1R', 11659),
(11660, 'cd12699', NULL, 'RRM3_hnRNPL', NULL, NULL, 'RRM3_hnRNPL', 11660),
(11661, 'cd04603', NULL, 'CBS_pair_KefB_assoc', NULL, NULL, 'CBS_pair_KefB_assoc', 11661),
(11662, 'cd03722', NULL, 'SOCS_ASB3', NULL, NULL, 'SOCS_ASB3', 11662),
(11663, 'cd07709', NULL, 'flavodiiron_proteins_MBL-fold', NULL, NULL, 'flavodiiron_proteins_MBL-fold', 11663),
(11664, 'cd18416', NULL, 'BTB_Shaw-like', NULL, NULL, 'BTB_Shaw-like', 11664),
(11665, 'cd10944', NULL, 'CE4_SmPgdA_like', NULL, NULL, 'CE4_SmPgdA_like', 11665),
(11666, 'cd18238', NULL, 'BTB_POZ_KLHL8', NULL, NULL, 'BTB_POZ_KLHL8', 11666),
(11667, 'cd13956', NULL, 'PT_UbiA', NULL, NULL, 'PT_UbiA', 11667),
(11668, 'cd12594', NULL, 'RRM1_SRSF4', NULL, NULL, 'RRM1_SRSF4', 11668),
(11669, 'cd03272', NULL, 'ABC_SMC3_euk', NULL, NULL, 'ABC_SMC3_euk', 11669),
(11670, 'cd05516', NULL, 'Bromo_SNF2L2', NULL, NULL, 'Bromo_SNF2L2', 11670),
(11671, 'cd09009', NULL, 'PNP-EcPNPII_like', NULL, NULL, 'PNP-EcPNPII_like', 11671),
(11672, 'cd03294', NULL, 'ABC_Pro_Gly_Betaine', NULL, NULL, 'ABC_Pro_Gly_Betaine', 11672),
(11673, 'cd00401', NULL, 'SAHH', NULL, NULL, 'SAHH', 11673),
(11674, 'cd03055', NULL, 'GST_N_Omega', NULL, NULL, 'GST_N_Omega', 11674),
(11675, 'cd08355', NULL, 'TioX_like', NULL, NULL, 'TioX_like', 11675),
(11676, 'cd13437', NULL, 'SPFH_alloslipin', NULL, NULL, 'SPFH_alloslipin', 11676),
(11677, 'cd14995', NULL, '7tmA_TRH-R', NULL, NULL, '7tmA_TRH-R', 11677),
(11678, 'cd16233', NULL, 'EFh_SPARC_FSTL1', NULL, NULL, 'EFh_SPARC_FSTL1', 11678),
(11679, 'cd14174', NULL, 'STKc_Mnk1', NULL, NULL, 'STKc_Mnk1', 11679),
(11680, 'cd01212', NULL, 'PTB_JIP', NULL, NULL, 'PTB_JIP', 11680),
(11681, 'cd14224', NULL, 'PKc_DYRK2_3', NULL, NULL, 'PKc_DYRK2_3', 11681),
(11682, 'cd16358', NULL, 'GlxI_Ni', NULL, NULL, 'GlxI_Ni', 11682),
(11683, 'cd11234', NULL, 'E_set_GDE_N', NULL, NULL, 'E_set_GDE_N', 11683),
(11684, 'cd18467', NULL, 'BACK_KLHL28_BTBD5', NULL, NULL, 'BACK_KLHL28_BTBD5', 11684),
(11685, 'cd11410', NULL, 'bHLH_O_HES', NULL, NULL, 'bHLH_O_HES', 11685),
(11686, 'cd15905', NULL, '7tmA_GPBAR1', NULL, NULL, '7tmA_GPBAR1', 11686),
(11687, 'cd05813', NULL, 'CBM20_genethonin_1', NULL, NULL, 'CBM20_genethonin_1', 11687),
(11688, 'cd12059', NULL, 'SH3_MLK1-3', NULL, NULL, 'SH3_MLK1-3', 11688),
(11689, 'cd13528', NULL, 'PBP2_osmoprotectants', NULL, NULL, 'PBP2_osmoprotectants', 11689),
(11690, 'cd09614', NULL, 'griffithsin_like', NULL, NULL, 'griffithsin_like', 11690),
(11691, 'cd03024', NULL, 'DsbA_FrnE', NULL, NULL, 'DsbA_FrnE', 11691),
(11692, 'cd17473', NULL, 'MFS_arabinose_efflux_permease_like', NULL, NULL, 'MFS_arabinose_efflux_permease_like', 11692),
(11693, 'cd21526', NULL, 'CoV_Nsp6', NULL, NULL, 'CoV_Nsp6', 11693),
(11694, 'cd05914', NULL, 'LC_FACL_like', NULL, NULL, 'LC_FACL_like', 11694),
(11695, 'cd03366', NULL, 'TOPRIM_TopoIIA_GyrB', NULL, NULL, 'TOPRIM_TopoIIA_GyrB', 11695),
(11696, 'cd19579', NULL, 'serpin1K-like', NULL, NULL, 'serpin1K-like', 11696),
(11697, 'cd15341', NULL, '7tmA_CB2', NULL, NULL, '7tmA_CB2', 11697),
(11698, 'cd18437', NULL, 'BRCT_BRC1_like_rpt3', NULL, NULL, 'BRCT_BRC1_like_rpt3', 11698),
(11699, 'cd03368', NULL, 'Ribosomal_S12', NULL, NULL, 'Ribosomal_S12', 11699),
(11700, 'cd12086', NULL, 'DD_cGKI-beta', NULL, NULL, 'DD_cGKI-beta', 11700),
(11701, 'cd07445', NULL, 'CRD_corin_1', NULL, NULL, 'CRD_corin_1', 11701),
(11702, 'cd05625', NULL, 'STKc_LATS1', NULL, NULL, 'STKc_LATS1', 11702),
(11703, 'cd07781', NULL, 'FGGY_RBK', NULL, NULL, 'FGGY_RBK', 11703),
(11704, 'cd05050', NULL, 'PTKc_Musk', NULL, NULL, 'PTKc_Musk', 11704),
(11705, 'cd18400', NULL, 'BTB_POZ_KCTD13_BACURD1', NULL, NULL, 'BTB_POZ_KCTD13_BACURD1', 11705),
(11706, 'cd09339', NULL, 'LIM4_Paxillin_like', NULL, NULL, 'LIM4_Paxillin_like', 11706),
(11707, 'cd15798', NULL, 'PMEI-like_3', NULL, NULL, 'PMEI-like_3', 11707),
(11708, 'cd12051', NULL, 'SH3_DOCK1_5_A', NULL, NULL, 'SH3_DOCK1_5_A', 11708),
(11709, 'cd18798', NULL, 'SF2_C_reverse_gyrase', NULL, NULL, 'SF2_C_reverse_gyrase', 11709),
(11710, 'cd07298', NULL, 'PX_RICS', NULL, NULL, 'PX_RICS', 11710);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(11711, 'cd09546', NULL, 'SAM_EPH-A5', NULL, NULL, 'SAM_EPH-A5', 11711),
(11712, 'cd12005', NULL, 'SH3_Lck', NULL, NULL, 'SH3_Lck', 11712),
(11713, 'cd01087', NULL, 'Prolidase', NULL, NULL, 'Prolidase', 11713),
(11714, 'cd16963', NULL, 'CCE1', NULL, NULL, 'CCE1', 11714),
(11715, 'cd05112', NULL, 'PTKc_Itk', NULL, NULL, 'PTKc_Itk', 11715),
(11716, 'cd06565', NULL, 'GH20_GcnA-like', NULL, NULL, 'GH20_GcnA-like', 11716),
(11717, 'cd18265', NULL, 'BTB_POZ_KLHL35', NULL, NULL, 'BTB_POZ_KLHL35', 11717),
(11718, 'cd09213', NULL, 'Luminal_IRE1_like', NULL, NULL, 'Luminal_IRE1_like', 11718),
(11719, 'cd21651', NULL, 'ORF4b_MERS-CoV-like', NULL, NULL, 'ORF4b_MERS-CoV-like', 11719),
(11720, 'cd06831', NULL, 'PLPDE_III_ODC_like_AZI', NULL, NULL, 'PLPDE_III_ODC_like_AZI', 11720),
(11721, 'cd17203', NULL, 'FERM_F1_EPB41L3', NULL, NULL, 'FERM_F1_EPB41L3', 11721),
(11722, 'cd21515', NULL, 'cv_beta_Nsp2_SARS_MHV-like', NULL, NULL, 'cv_beta_Nsp2_SARS_MHV-like', 11722),
(11723, 'cd17227', NULL, 'RA_ARAP2', NULL, NULL, 'RA_ARAP2', 11723),
(11724, 'cd15819', NULL, 'SPRY_PRY_BTN1_2', NULL, NULL, 'SPRY_PRY_BTN1_2', 11724),
(11725, 'cd16548', NULL, 'RING-HC_RNF152', NULL, NULL, 'RING-HC_RNF152', 11725),
(11726, 'cd03509', NULL, 'DesA_FADS-like', NULL, NULL, 'DesA_FADS-like', 11726),
(11727, 'cd17339', NULL, 'MFS_NIMT_CynX_like', NULL, NULL, 'MFS_NIMT_CynX_like', 11727),
(11728, 'cd10385', NULL, 'SH2_SOCS4', NULL, NULL, 'SH2_SOCS4', 11728),
(11729, 'cd17426', NULL, 'MFS_MCT1', NULL, NULL, 'MFS_MCT1', 11729),
(11730, 'cd08049', NULL, 'TAF8', NULL, NULL, 'TAF8', 11730),
(11731, 'cd04409', NULL, 'RhoGAP_PARG1', NULL, NULL, 'RhoGAP_PARG1', 11731),
(11732, 'cd08050', NULL, 'TAF6C', NULL, NULL, 'TAF6C', 11732),
(11733, 'cd01229', NULL, 'PH_Ect2', NULL, NULL, 'PH_Ect2', 11733),
(11734, 'cd02258', NULL, 'Peptidase_C25_N', NULL, NULL, 'Peptidase_C25_N', 11734),
(11735, 'cd12125', NULL, 'APC_alpha', NULL, NULL, 'APC_alpha', 11735),
(11736, 'cd14903', NULL, 'MYSc_Myo42', NULL, NULL, 'MYSc_Myo42', 11736),
(11737, 'cd12695', NULL, 'RRM3_PTBP1', NULL, NULL, 'RRM3_PTBP1', 11737),
(11738, 'cd14104', NULL, 'STKc_Titin', NULL, NULL, 'STKc_Titin', 11738),
(11739, 'cd03068', NULL, 'PDI_b_ERp72', NULL, NULL, 'PDI_b_ERp72', 11739),
(11740, 'cd12589', NULL, 'RRM2_PSP1', NULL, NULL, 'RRM2_PSP1', 11740),
(11741, 'cd16079', NULL, 'TSP-3cc', NULL, NULL, 'TSP-3cc', 11741),
(11742, 'cd16948', NULL, 'HATPase_BceS-YxdK-YvcQ-like', NULL, NULL, 'HATPase_BceS-YxdK-YvcQ-like', 11742),
(11743, 'cd13534', NULL, 'PBP2_MqnD_like', NULL, NULL, 'PBP2_MqnD_like', 11743),
(11744, 'cd11370', NULL, 'RNase_PH_RRP41', NULL, NULL, 'RNase_PH_RRP41', 11744),
(11745, 'cd04471', NULL, 'S1_RNase_R', NULL, NULL, 'S1_RNase_R', 11745),
(11746, 'cd13409', NULL, 'TNFRSF8', NULL, NULL, 'TNFRSF8', 11746),
(11747, 'cd08207', NULL, 'RLP_NonPhot', NULL, NULL, 'RLP_NonPhot', 11747),
(11748, 'cd14505', NULL, 'CDKN3-like', NULL, NULL, 'CDKN3-like', 11748),
(11749, 'cd18459', NULL, 'BACK_KLHL20', NULL, NULL, 'BACK_KLHL20', 11749),
(11750, 'cd02782', NULL, 'MopB_CT_1', NULL, NULL, 'MopB_CT_1', 11750),
(11751, 'cd05304', NULL, 'Rubrum_tdh', NULL, NULL, 'Rubrum_tdh', 11751),
(11752, 'cd01951', NULL, 'lectin_L-type', NULL, NULL, 'lectin_L-type', 11752),
(11753, 'cd03489', NULL, 'Topoisomer_IB_N_LdtopoI_like', NULL, NULL, 'Topoisomer_IB_N_LdtopoI_like', 11753),
(11754, 'cd14636', NULL, 'R-PTPc-K-2', NULL, NULL, 'R-PTPc-K-2', 11754),
(11755, 'cd15657', NULL, 'PHD4_NSD2', NULL, NULL, 'PHD4_NSD2', 11755),
(11756, 'cd10517', NULL, 'SET_SETDB1', NULL, NULL, 'SET_SETDB1', 11756),
(11757, 'cd06409', NULL, 'PB1_MUG70', NULL, NULL, 'PB1_MUG70', 11757),
(11758, 'cd04397', NULL, 'RhoGAP_fLRG1', NULL, NULL, 'RhoGAP_fLRG1', 11758),
(11759, 'cd04169', NULL, 'RF3', NULL, NULL, 'RF3', 11759),
(11760, 'cd14619', NULL, 'R-PTPc-H', NULL, NULL, 'R-PTPc-H', 11760),
(11761, 'cd07295', NULL, 'PX_Grd19', NULL, NULL, 'PX_Grd19', 11761),
(11762, 'cd09817', NULL, 'linoleate_diol_synthase_like', NULL, NULL, 'linoleate_diol_synthase_like', 11762),
(11763, 'cd07604', NULL, 'BAR_ASAPs', NULL, NULL, 'BAR_ASAPs', 11763);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(11764, 'cd04415', NULL, 'NDPk7A', NULL, NULL, 'NDPk7A', 11764),
(11765, 'cd14210', NULL, 'PKc_DYRK', NULL, NULL, 'PKc_DYRK', 11765),
(11766, 'cd11872', NULL, 'SH3_DOCK_AB', NULL, NULL, 'SH3_DOCK_AB', 11766),
(11767, 'cd18951', NULL, 'bHLH_TS_scleraxis', NULL, NULL, 'bHLH_TS_scleraxis', 11767),
(11768, 'cd08305', NULL, 'Pyrin', NULL, NULL, 'Pyrin', 11768),
(11769, 'cd13554', NULL, 'PBP2_DszB', NULL, NULL, 'PBP2_DszB', 11769),
(11770, 'cd09175', NULL, 'PLDc_Bfil', NULL, NULL, 'PLDc_Bfil', 11770),
(11771, 'cd19965', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, 'PBP1_ABC_sugar_binding-like', 11771),
(11772, 'cd09300', NULL, 'DEAD-like_helicase_C', NULL, NULL, 'DEAD-like_helicase_C', 11772),
(11773, 'cd01481', NULL, 'vWA_collagen_alpha3-VI-like', NULL, NULL, 'vWA_collagen_alpha3-VI-like', 11773),
(11774, 'cd04620', NULL, 'CBS_two-component_sensor_histidine_kinase_repeat1', NULL, NULL, 'CBS_two-component_sensor_histidine_kinase_repeat1', 11774),
(11775, 'cd00464', NULL, 'SK', NULL, NULL, 'SK', 11775),
(11776, 'cd11243', NULL, 'Sema_7A', NULL, NULL, 'Sema_7A', 11776),
(11777, 'cd04659', NULL, 'Piwi_piwi-like_ProArk', NULL, NULL, 'Piwi_piwi-like_ProArk', 11777),
(11778, 'cd09354', NULL, 'LIM2_LPP', NULL, NULL, 'LIM2_LPP', 11778),
(11779, 'cd08247', NULL, 'AST1_like', NULL, NULL, 'AST1_like', 11779),
(11780, 'cd14354', NULL, 'UBA_UBP25', NULL, NULL, 'UBA_UBP25', 11780),
(11781, 'cd05718', NULL, 'Ig1_PVR_like', NULL, NULL, 'Ig1_PVR_like', 11781),
(11782, 'cd11760', NULL, 'SH3_MIA_like', NULL, NULL, 'SH3_MIA_like', 11782),
(11783, 'cd01219', NULL, 'PH1_FGD1', NULL, NULL, 'PH1_FGD1', 11783),
(11784, 'cd05731', NULL, 'Ig3_L1-CAM_like', NULL, NULL, 'Ig3_L1-CAM_like', 11784),
(11785, 'cd01414', NULL, 'SAICAR_synt_Sc', NULL, NULL, 'SAICAR_synt_Sc', 11785),
(11786, 'cd13521', NULL, 'PBP2_AlgQ_like', NULL, NULL, 'PBP2_AlgQ_like', 11786),
(11787, 'cd12744', NULL, 'RRM1_RBM12B', NULL, NULL, 'RRM1_RBM12B', 11787),
(11788, 'cd19340', NULL, 'Wnt_Wnt8', NULL, NULL, 'Wnt_Wnt8', 11788),
(11789, 'cd02643', NULL, 'R3H_NF-X1', NULL, NULL, 'R3H_NF-X1', 11789),
(11790, 'cd08684', NULL, 'C2A_Tac2-N', NULL, NULL, 'C2A_Tac2-N', 11790),
(11791, 'cd16187', NULL, 'EFh_PEF_sorcin', NULL, NULL, 'EFh_PEF_sorcin', 11791),
(11792, 'cd21566', NULL, 'gammaCoV_M', NULL, NULL, 'gammaCoV_M', 11792),
(11793, 'cd16179', NULL, 'EFh_HEF_CBN', NULL, NULL, 'EFh_HEF_CBN', 11793),
(11794, 'cd15907', NULL, '7tmA_GPR153', NULL, NULL, '7tmA_GPR153', 11794),
(11795, 'cd01476', NULL, 'VWA_integrin_invertebrates', NULL, NULL, 'VWA_integrin_invertebrates', 11795),
(11796, 'cd01362', NULL, 'Fumarase_classII', NULL, NULL, 'Fumarase_classII', 11796),
(11797, 'cd13268', NULL, 'PH_Brdg1', NULL, NULL, 'PH_Brdg1', 11797),
(11798, 'cd16945', NULL, 'HATPase_CreC-like', NULL, NULL, 'HATPase_CreC-like', 11798),
(11799, 'cd09106', NULL, 'PLDc_vPLD3_4_5_like_1', NULL, NULL, 'PLDc_vPLD3_4_5_like_1', 11799),
(11800, 'cd15012', NULL, '7tmA_Trissin_R', NULL, NULL, '7tmA_Trissin_R', 11800),
(11801, 'cd12417', NULL, 'RRM_SAFB_like', NULL, NULL, 'RRM_SAFB_like', 11801),
(11802, 'cd01770', NULL, 'UBX_UBXN2', NULL, NULL, 'UBX_UBXN2', 11802),
(11803, 'cd04724', NULL, 'Tryptophan_synthase_alpha', NULL, NULL, 'Tryptophan_synthase_alpha', 11803),
(11804, 'cd05907', NULL, 'VL_LC_FACS_like', NULL, NULL, 'VL_LC_FACS_like', 11804),
(11805, 'cd16084', NULL, 'IgC_CH2_IgD', NULL, NULL, 'IgC_CH2_IgD', 11805),
(11806, 'cd17007', NULL, 'ANTH_N_Sla2p', NULL, NULL, 'ANTH_N_Sla2p', 11806),
(11807, 'cd07622', NULL, 'BAR_SNX4', NULL, NULL, 'BAR_SNX4', 11807),
(11808, 'cd03673', NULL, 'Ap6A_hydrolase', NULL, NULL, 'Ap6A_hydrolase', 11808),
(11809, 'cd00111', NULL, 'Trefoil', NULL, NULL, 'Trefoil', 11809),
(11810, 'cd02062', NULL, 'Nitro_FMN_reductase', NULL, NULL, 'Nitro_FMN_reductase', 11810),
(11811, 'cd19405', NULL, 'TGF_beta_INHBB', NULL, NULL, 'TGF_beta_INHBB', 11811),
(11812, 'cd06301', NULL, 'PBP1_rhizopine_binding-like', NULL, NULL, 'PBP1_rhizopine_binding-like', 11812),
(11813, 'cd08549', NULL, 'G1PDH_related', NULL, NULL, 'G1PDH_related', 11813),
(11814, 'cd16604', NULL, 'RING-HC_TRIM47_C-IV', NULL, NULL, 'RING-HC_TRIM47_C-IV', 11814);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(11815, 'cd18184', NULL, 'ATP-synt_Fo_c_NaATPase', NULL, NULL, 'ATP-synt_Fo_c_NaATPase', 11815),
(11816, 'cd10363', NULL, 'SH2_Src_HCK', NULL, NULL, 'SH2_Src_HCK', 11816),
(11817, 'cd06377', NULL, 'PBP1_iGluR_NMDA_NR3', NULL, NULL, 'PBP1_iGluR_NMDA_NR3', 11817),
(11818, 'cd07227', NULL, 'Pat_Fungal_NTE1', NULL, NULL, 'Pat_Fungal_NTE1', 11818),
(11819, 'cd07610', NULL, 'FCH_F-BAR', NULL, NULL, 'FCH_F-BAR', 11819),
(11820, 'cd08182', NULL, 'HEPD', NULL, NULL, 'HEPD', 11820),
(11821, 'cd06599', NULL, 'GH31_glycosidase_Aec37', NULL, NULL, 'GH31_glycosidase_Aec37', 11821),
(11822, 'cd02525', NULL, 'Succinoglycan_BP_ExoA', NULL, NULL, 'Succinoglycan_BP_ExoA', 11822),
(11823, 'cd11818', NULL, 'SH3_Eve1_5', NULL, NULL, 'SH3_Eve1_5', 11823),
(11824, 'cd09568', NULL, 'SAM_liprin-alpha1,2,3,4_repeat3', NULL, NULL, 'SAM_liprin-alpha1,2,3,4_repeat3', 11824),
(11825, 'cd18065', NULL, 'DEXHc_SMARCA1', NULL, NULL, 'DEXHc_SMARCA1', 11825),
(11826, 'cd18097', NULL, 'SpoU-like', NULL, NULL, 'SpoU-like', 11826),
(11827, 'cd02518', NULL, 'GT2_SpsF', NULL, NULL, 'GT2_SpsF', 11827),
(11828, 'cd10718', NULL, 'SH2_CIS', NULL, NULL, 'SH2_CIS', 11828),
(11829, 'cd18113', NULL, 'ATP-synt_F1_alpha_C', NULL, NULL, 'ATP-synt_F1_alpha_C', 11829),
(11830, 'cd17946', NULL, 'DEADc_DDX24', NULL, NULL, 'DEADc_DDX24', 11830),
(11831, 'cd00193', NULL, 'SNARE', NULL, NULL, 'SNARE', 11831),
(11832, 'cd01597', NULL, 'pCLME', NULL, NULL, 'pCLME', 11832),
(11833, 'cd00438', NULL, 'cupin_RmlC', NULL, NULL, 'cupin_RmlC', 11833),
(11834, 'cd10418', NULL, 'SH2_Src_Fyn_isoform_a_like', NULL, NULL, 'SH2_Src_Fyn_isoform_a_like', 11834),
(11835, 'cd14921', NULL, 'MYSc_Myh11', NULL, NULL, 'MYSc_Myh11', 11835),
(11836, 'cd00693', NULL, 'secretory_peroxidase', NULL, NULL, 'secretory_peroxidase', 11836),
(11837, 'cd15960', NULL, '7tmA_GPR185-like', NULL, NULL, '7tmA_GPR185-like', 11837),
(11838, 'cd01318', NULL, 'DHOase_IIb', NULL, NULL, 'DHOase_IIb', 11838),
(11839, 'cd19140', NULL, 'AKR_AKR3F3', NULL, NULL, 'AKR_AKR3F3', 11839),
(11840, 'cd12053', NULL, 'SH3_CD2AP_1', NULL, NULL, 'SH3_CD2AP_1', 11840),
(11841, 'cd11625', NULL, 'HR1_PKN_3', NULL, NULL, 'HR1_PKN_3', 11841),
(11842, 'cd16098', NULL, 'FliS', NULL, NULL, 'FliS', 11842),
(11843, 'cd01583', NULL, 'IPMI', NULL, NULL, 'IPMI', 11843),
(11844, 'cd16577', NULL, 'RING-HC_MuRF_C-II', NULL, NULL, 'RING-HC_MuRF_C-II', 11844),
(11845, 'cd20268', NULL, 'Complex1_LYR_SDHAF1_LYRM8', NULL, NULL, 'Complex1_LYR_SDHAF1_LYRM8', 11845),
(11846, 'cd01992', NULL, 'PP-ATPase', NULL, NULL, 'PP-ATPase', 11846),
(11847, 'cd11244', NULL, 'Sema_plexin_A', NULL, NULL, 'Sema_plexin_A', 11847),
(11848, 'cd17320', NULL, 'MFS_MdfA_MDR_like', NULL, NULL, 'MFS_MdfA_MDR_like', 11848),
(11849, 'cd05348', NULL, 'BphB-like_SDR_c', NULL, NULL, 'BphB-like_SDR_c', 11849),
(11850, 'cd09565', NULL, 'SAM_liprin-alpha1,2,3,4_repeat2', NULL, NULL, 'SAM_liprin-alpha1,2,3,4_repeat2', 11850),
(11851, 'cd00287', NULL, 'ribokinase_pfkB_like', NULL, NULL, 'ribokinase_pfkB_like', 11851),
(11852, 'cd04244', NULL, 'AAK_AK-LysC-like', NULL, NULL, 'AAK_AK-LysC-like', 11852),
(11853, 'cd05622', NULL, 'STKc_ROCK1', NULL, NULL, 'STKc_ROCK1', 11853),
(11854, 'cd21400', NULL, 'ZBD_UPF1-like', NULL, NULL, 'ZBD_UPF1-like', 11854),
(11855, 'cd07044', NULL, 'CofD_YvcK', NULL, NULL, 'CofD_YvcK', 11855),
(11856, 'cd10921', NULL, 'CE4_MJ0505_like', NULL, NULL, 'CE4_MJ0505_like', 11856),
(11857, 'cd04385', NULL, 'RhoGAP_ARAP', NULL, NULL, 'RhoGAP_ARAP', 11857),
(11858, 'cd13384', NULL, 'PH_Gab2_2', NULL, NULL, 'PH_Gab2_2', 11858),
(11859, 'cd06329', NULL, 'PBP1_SBP-like', NULL, NULL, 'PBP1_SBP-like', 11859),
(11860, 'cd18287', NULL, 'BTB_POZ_BTBD9', NULL, NULL, 'BTB_POZ_BTBD9', 11860),
(11861, 'cd03428', NULL, 'Ap4A_hydrolase_human_like', NULL, NULL, 'Ap4A_hydrolase_human_like', 11861),
(11862, 'cd04137', NULL, 'RheB', NULL, NULL, 'RheB', 11862),
(11863, 'cd17229', NULL, 'RA1_PLC-epsilon', NULL, NULL, 'RA1_PLC-epsilon', 11863),
(11864, 'cd13331', NULL, 'PH_Avo1', NULL, NULL, 'PH_Avo1', 11864),
(11865, 'cd13653', NULL, 'PBP2_phosphate_like_1', NULL, NULL, 'PBP2_phosphate_like_1', 11865);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(11866, 'cd15365', NULL, '7tmA_GPR65_TDAG8', NULL, NULL, '7tmA_GPR65_TDAG8', 11866),
(11867, 'cd13616', NULL, 'PBP2_OsmF', NULL, NULL, 'PBP2_OsmF', 11867),
(11868, 'cd16854', NULL, 'STAT4_CCD', NULL, NULL, 'STAT4_CCD', 11868),
(11869, 'cd07087', NULL, 'ALDH_F3-13-14_CALDH-like', NULL, NULL, 'ALDH_F3-13-14_CALDH-like', 11869),
(11870, 'cd08782', NULL, 'Death_DAPK1', NULL, NULL, 'Death_DAPK1', 11870),
(11871, 'cd10489', NULL, 'MH1_SMAD_6_7', NULL, NULL, 'MH1_SMAD_6_7', 11871),
(11872, 'cd08288', NULL, 'MDR_yhdh', NULL, NULL, 'MDR_yhdh', 11872),
(11873, 'cd12615', NULL, 'RRM1_TIA1', NULL, NULL, 'RRM1_TIA1', 11873),
(11874, 'cd21557', NULL, 'Macro_X_Nsp3-like', NULL, NULL, 'Macro_X_Nsp3-like', 11874),
(11875, 'cd09006', NULL, 'PNP_EcPNPI-like', NULL, NULL, 'PNP_EcPNPI-like', 11875),
(11876, 'cd18090', NULL, 'Arginine_MT_Sfm1', NULL, NULL, 'Arginine_MT_Sfm1', 11876),
(11877, 'cd13721', NULL, 'PBP2_iGluR_Kainate_GluR6', NULL, NULL, 'PBP2_iGluR_Kainate_GluR6', 11877),
(11878, 'cd00715', NULL, 'GPATase_N', NULL, NULL, 'GPATase_N', 11878),
(11879, 'cd15581', NULL, 'PHD2_PHF19', NULL, NULL, 'PHD2_PHF19', 11879),
(11880, 'cd05475', NULL, 'nucellin_like', NULL, NULL, 'nucellin_like', 11880),
(11881, 'cd06526', NULL, 'metazoan_ACD', NULL, NULL, 'metazoan_ACD', 11881),
(11882, 'cd06081', NULL, 'KOW_Spt5_1', NULL, NULL, 'KOW_Spt5_1', 11882),
(11883, 'cd18451', NULL, 'BACK_KLHL11', NULL, NULL, 'BACK_KLHL11', 11883),
(11884, 'cd07645', NULL, 'I-BAR_IMD_BAIAP2L1', NULL, NULL, 'I-BAR_IMD_BAIAP2L1', 11884),
(11885, 'cd10170', NULL, 'HSP70_NBD', NULL, NULL, 'HSP70_NBD', 11885),
(11886, 'cd04434', NULL, 'LanC_like', NULL, NULL, 'LanC_like', 11886),
(11887, 'cd00544', NULL, 'CobU', NULL, NULL, 'CobU', 11887),
(11888, 'cd17735', NULL, 'BRCT_BRCA1_rpt1', NULL, NULL, 'BRCT_BRCA1_rpt1', 11888),
(11889, 'cd01190', NULL, 'INT_StrepXerD_C_like', NULL, NULL, 'INT_StrepXerD_C_like', 11889),
(11890, 'cd12292', NULL, 'RRM2_La_like', NULL, NULL, 'RRM2_La_like', 11890),
(11891, 'cd01598', NULL, 'PurB', NULL, NULL, 'PurB', 11891),
(11892, 'cd11554', NULL, 'SLC6sbd_u2', NULL, NULL, 'SLC6sbd_u2', 11892),
(11893, 'cd15271', NULL, '7tmB1_GHRHR2', NULL, NULL, '7tmB1_GHRHR2', 11893),
(11894, 'cd15448', NULL, '7tmC_mGluR3', NULL, NULL, '7tmC_mGluR3', 11894),
(11895, 'cd19820', NULL, 'Bbox1_ZFYVE1_rpt2', NULL, NULL, 'Bbox1_ZFYVE1_rpt2', 11895),
(11896, 'cd16881', NULL, 'ARID_Dri-like', NULL, NULL, 'ARID_Dri-like', 11896),
(11897, 'cd18405', NULL, 'BTB_POZ_KCNA4', NULL, NULL, 'BTB_POZ_KCNA4', 11897),
(11898, 'cd17487', NULL, 'MFS_MFSD5_like', NULL, NULL, 'MFS_MFSD5_like', 11898),
(11899, 'cd15512', NULL, 'PHD4_KMT2C_like', NULL, NULL, 'PHD4_KMT2C_like', 11899),
(11900, 'cd05672', NULL, 'M20_ACY1L2-like', NULL, NULL, 'M20_ACY1L2-like', 11900),
(11901, 'cd00851', NULL, 'MTH1175', NULL, NULL, 'MTH1175', 11901),
(11902, 'cd16294', NULL, 'Int9-like_MBL-fold', NULL, NULL, 'Int9-like_MBL-fold', 11902),
(11903, 'cd14568', NULL, 'DSP_MKP_classIII', NULL, NULL, 'DSP_MKP_classIII', 11903),
(11904, 'cd15557', NULL, 'PHD_CBP_p300', NULL, NULL, 'PHD_CBP_p300', 11904),
(11905, 'cd18093', NULL, 'SpoU-like_TrmJ', NULL, NULL, 'SpoU-like_TrmJ', 11905),
(11906, 'cd08033', NULL, 'LARP_6', NULL, NULL, 'LARP_6', 11906),
(11907, 'cd00742', NULL, 'FABP', NULL, NULL, 'FABP', 11907),
(11908, 'cd15580', NULL, 'PHD2_MTF2', NULL, NULL, 'PHD2_MTF2', 11908),
(11909, 'cd09320', NULL, 'TDT_like_2', NULL, NULL, 'TDT_like_2', 11909),
(11910, 'cd04405', NULL, 'RhoGAP_BRCC3-like', NULL, NULL, 'RhoGAP_BRCC3-like', 11910),
(11911, 'cd04823', NULL, 'ALAD_PBGS_aspartate_rich', NULL, NULL, 'ALAD_PBGS_aspartate_rich', 11911),
(11912, 'cd17397', NULL, 'MFS_DIRC2', NULL, NULL, 'MFS_DIRC2', 11912),
(11913, 'cd01477', NULL, 'vWA_F09G8-8_type', NULL, NULL, 'vWA_F09G8-8_type', 11913),
(11914, 'cd12739', NULL, 'RRM2_ESRP1', NULL, NULL, 'RRM2_ESRP1', 11914),
(11915, 'cd07149', NULL, 'ALDH_y4uC', NULL, NULL, 'ALDH_y4uC', 11915),
(11916, 'cd12141', NULL, 'SH3_DNMBP_C2', NULL, NULL, 'SH3_DNMBP_C2', 11916),
(11917, 'cd04127', NULL, 'Rab27A', NULL, NULL, 'Rab27A', 11917),
(11918, 'cd15871', NULL, 'R-SNARE_VAMP7', NULL, NULL, 'R-SNARE_VAMP7', 11918);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(11919, 'cd06921', NULL, 'ChtBD1_GH19_hevein', NULL, NULL, 'ChtBD1_GH19_hevein', 11919),
(11920, 'cd19113', NULL, 'AKR_AKR2B1-10', NULL, NULL, 'AKR_AKR2B1-10', 11920),
(11921, 'cd05643', NULL, 'M28_like', NULL, NULL, 'M28_like', 11921),
(11922, 'cd02255', NULL, 'Peptidase_C12', NULL, NULL, 'Peptidase_C12', 11922),
(11923, 'cd04124', NULL, 'RabL2', NULL, NULL, 'RabL2', 11923),
(11924, 'cd18032', NULL, 'DEXHc_RE_I_III_res', NULL, NULL, 'DEXHc_RE_I_III_res', 11924),
(11925, 'cd01879', NULL, 'FeoB', NULL, NULL, 'FeoB', 11925),
(11926, 'cd06573', NULL, 'PASTA', NULL, NULL, 'PASTA', 11926),
(11927, 'cd16153', NULL, 'sulfatase_like', NULL, NULL, 'sulfatase_like', 11927),
(11928, 'cd11631', NULL, 'HR1_PKN2_2', NULL, NULL, 'HR1_PKN2_2', 11928),
(11929, 'cd18558', NULL, 'ABC_6TM_Pgp_ABCB1', NULL, NULL, 'ABC_6TM_Pgp_ABCB1', 11929),
(11930, 'cd02844', NULL, 'PAZ_CAF_like', NULL, NULL, 'PAZ_CAF_like', 11930),
(11931, 'cd08751', NULL, 'RGS_GRK6', NULL, NULL, 'RGS_GRK6', 11931),
(11932, 'cd07409', NULL, 'MPP_CD73_N', NULL, NULL, 'MPP_CD73_N', 11932),
(11933, 'cd16382', NULL, 'XisI-like', NULL, NULL, 'XisI-like', 11933),
(11934, 'cd05195', NULL, 'enoyl_red', NULL, NULL, 'enoyl_red', 11934),
(11935, 'cd04246', NULL, 'AAK_AK-DapG-like', NULL, NULL, 'AAK_AK-DapG-like', 11935),
(11936, 'cd04923', NULL, 'ACT_AK-LysC-DapG-like_2', NULL, NULL, 'ACT_AK-LysC-DapG-like_2', 11936),
(11937, 'cd14527', NULL, 'DSP_bac', NULL, NULL, 'DSP_bac', 11937),
(11938, 'cd11394', NULL, 'bHLHzip_SREBP', NULL, NULL, 'bHLHzip_SREBP', 11938),
(11939, 'cd03487', NULL, 'RT_Bac_retron_II', NULL, NULL, 'RT_Bac_retron_II', 11939),
(11940, 'cd02660', NULL, 'Peptidase_C19D', NULL, NULL, 'Peptidase_C19D', 11940),
(11941, 'cd18445', NULL, 'BACK_KLHL2_like', NULL, NULL, 'BACK_KLHL2_like', 11941),
(11942, 'cd01425', NULL, 'RPS2', NULL, NULL, 'RPS2', 11942),
(11943, 'cd02142', NULL, 'McbC_SagB-like_oxidoreductase', NULL, NULL, 'McbC_SagB-like_oxidoreductase', 11943),
(11944, 'cd11693', NULL, 'HRI1_C_like', NULL, NULL, 'HRI1_C_like', 11944),
(11945, 'cd15366', NULL, '7tmA_GPR4', NULL, NULL, '7tmA_GPR4', 11945),
(11946, 'cd17969', NULL, 'DEAHc_XPD', NULL, NULL, 'DEAHc_XPD', 11946),
(11947, 'cd12820', NULL, 'LbR_YadA-like', NULL, NULL, 'LbR_YadA-like', 11947),
(11948, 'cd06091', NULL, 'KOW_NusG', NULL, NULL, 'KOW_NusG', 11948),
(11949, 'cd06877', NULL, 'PX_SNX14', NULL, NULL, 'PX_SNX14', 11949),
(11950, 'cd18204', NULL, 'BTB_POZ_ZBTB14', NULL, NULL, 'BTB_POZ_ZBTB14', 11950),
(11951, 'cd11528', NULL, 'NTP-PPase_MazG_Nterm', NULL, NULL, 'NTP-PPase_MazG_Nterm', 11951),
(11952, 'cd04418', NULL, 'NDPk5', NULL, NULL, 'NDPk5', 11952),
(11953, 'cd03594', NULL, 'CLECT_REG-1_like', NULL, NULL, 'CLECT_REG-1_like', 11953),
(11954, 'cd00867', NULL, 'Trans_IPPS', NULL, NULL, 'Trans_IPPS', 11954),
(11955, 'cd04949', NULL, 'GT4_GtfA-like', NULL, NULL, 'GT4_GtfA-like', 11955),
(11956, 'cd16231', NULL, 'EFh_SPARC_like', NULL, NULL, 'EFh_SPARC_like', 11956),
(11957, 'cd18295', NULL, 'BTB1_POZ_ABTB1_BPOZ1', NULL, NULL, 'BTB1_POZ_ABTB1_BPOZ1', 11957),
(11958, 'cd16736', NULL, 'RING-HC_PCGF4', NULL, NULL, 'RING-HC_PCGF4', 11958),
(11959, 'cd21561', NULL, 'deltaCoV-Nsp6', NULL, NULL, 'deltaCoV-Nsp6', 11959),
(11960, 'cd07147', NULL, 'ALDH_F21_RNP123', NULL, NULL, 'ALDH_F21_RNP123', 11960),
(11961, 'cd19537', NULL, 'C_NRPS-like', NULL, NULL, 'C_NRPS-like', 11961),
(11962, 'cd12174', NULL, 'PGDH_like_3', NULL, NULL, 'PGDH_like_3', 11962),
(11963, 'cd12536', NULL, 'RRM1_RBM39', NULL, NULL, 'RRM1_RBM39', 11963),
(11964, 'cd12537', NULL, 'RRM1_RBM23', NULL, NULL, 'RRM1_RBM23', 11964),
(11965, 'cd13610', NULL, 'PBP2_ChoS', NULL, NULL, 'PBP2_ChoS', 11965),
(11966, 'cd12668', NULL, 'RRM3_RAVER2', NULL, NULL, 'RRM3_RAVER2', 11966),
(11967, 'cd15374', NULL, '7tmA_P2Y4', NULL, NULL, '7tmA_P2Y4', 11967),
(11968, 'cd17214', NULL, 'RA_CYR1_like', NULL, NULL, 'RA_CYR1_like', 11968),
(11969, 'cd19416', NULL, 'lipocalin_beta-LG-like', NULL, NULL, 'lipocalin_beta-LG-like', 11969),
(11970, 'cd05394', NULL, 'RasGAP_RASA2', NULL, NULL, 'RasGAP_RASA2', 11970),
(11971, 'cd08821', NULL, 'FMT_core_like_1', NULL, NULL, 'FMT_core_like_1', 11971);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(11972, 'cd19381', NULL, 'TGF_beta_Artemin', NULL, NULL, 'TGF_beta_Artemin', 11972),
(11973, 'cd09467', NULL, 'LIM1_Lhx3b', NULL, NULL, 'LIM1_Lhx3b', 11973),
(11974, 'cd09441', NULL, 'LIM2_SF3', NULL, NULL, 'LIM2_SF3', 11974),
(11975, 'cd16546', NULL, 'RING-HC_RNF146', NULL, NULL, 'RING-HC_RNF146', 11975),
(11976, 'cd07568', NULL, 'ML_beta-AS_like', NULL, NULL, 'ML_beta-AS_like', 11976),
(11977, 'cd01391', NULL, 'Periplasmic_Binding_Protein_type1', NULL, NULL, 'Periplasmic_Binding_Protein_type1', 11977),
(11978, 'cd11688', NULL, 'THUMP', NULL, NULL, 'THUMP', 11978),
(11979, 'cd14659', NULL, 'Imelysin-like_IPPA', NULL, NULL, 'Imelysin-like_IPPA', 11979),
(11980, 'cd06211', NULL, 'phenol_2-monooxygenase_like', NULL, NULL, 'phenol_2-monooxygenase_like', 11980),
(11981, 'cd14205', NULL, 'PTKc_Jak2_rpt2', NULL, NULL, 'PTKc_Jak2_rpt2', 11981),
(11982, 'cd19453', NULL, 'lipocalin_NP2', NULL, NULL, 'lipocalin_NP2', 11982),
(11983, 'cd18918', NULL, 'bHLH_AtMYC1_like', NULL, NULL, 'bHLH_AtMYC1_like', 11983),
(11984, 'cd04155', NULL, 'Arl3', NULL, NULL, 'Arl3', 11984),
(11985, 'cd13236', NULL, 'PH2_FGD1-4', NULL, NULL, 'PH2_FGD1-4', 11985),
(11986, 'cd07056', NULL, 'BMC_PduK', NULL, NULL, 'BMC_PduK', 11986),
(11987, 'cd12509', NULL, 'RRM3_ESRPs_Fusilli', NULL, NULL, 'RRM3_ESRPs_Fusilli', 11987),
(11988, 'cd14977', NULL, '7tmA_ET_R-like', NULL, NULL, '7tmA_ET_R-like', 11988),
(11989, 'cd21473', NULL, 'cv_Nsp4_TM', NULL, NULL, 'cv_Nsp4_TM', 11989),
(11990, 'cd07721', NULL, 'yflN-like_MBL-fold', NULL, NULL, 'yflN-like_MBL-fold', 11990),
(11991, 'cd14730', NULL, 'LodA_like', NULL, NULL, 'LodA_like', 11991),
(11992, 'cd15399', NULL, '7tmA_NPY2R', NULL, NULL, '7tmA_NPY2R', 11992),
(11993, 'cd08884', NULL, 'RHO_alpha_C_GbcA-like', NULL, NULL, 'RHO_alpha_C_GbcA-like', 11993),
(11994, 'cd04257', NULL, 'AAK_AK-HSDH', NULL, NULL, 'AAK_AK-HSDH', 11994),
(11995, 'cd09990', NULL, 'Agmatinase-like', NULL, NULL, 'Agmatinase-like', 11995),
(11996, 'cd11886', NULL, 'SH3_BOI', NULL, NULL, 'SH3_BOI', 11996),
(11997, 'cd01205', NULL, 'EVH1_WASP-like', NULL, NULL, 'EVH1_WASP-like', 11997),
(11998, 'cd20757', NULL, 'capping_2-OMTase_Rotavirus', NULL, NULL, 'capping_2-OMTase_Rotavirus', 11998),
(11999, 'cd12411', NULL, 'RRM_ist3_like', NULL, NULL, 'RRM_ist3_like', 11999),
(12000, 'cd04178', NULL, 'Nucleostemin_like', NULL, NULL, 'Nucleostemin_like', 12000),
(12001, 'cd04465', NULL, 'S1_RPS1_repeat_ec2_hs2', NULL, NULL, 'S1_RPS1_repeat_ec2_hs2', 12001),
(12002, 'cd09931', NULL, 'SH2_C-SH2_SHP_like', NULL, NULL, 'SH2_C-SH2_SHP_like', 12002),
(12003, 'cd15596', NULL, 'PHD4_KMT2C', NULL, NULL, 'PHD4_KMT2C', 12003),
(12004, 'cd15386', NULL, '7tmA_V1bR', NULL, NULL, '7tmA_V1bR', 12004),
(12005, 'cd05855', NULL, 'Ig_TrkB_d5', NULL, NULL, 'Ig_TrkB_d5', 12005),
(12006, 'cd05796', NULL, 'Ribosomal_P0_like', NULL, NULL, 'Ribosomal_P0_like', 12006),
(12007, 'cd09495', NULL, 'SAM_liprin-kazrin_repeat2', NULL, NULL, 'SAM_liprin-kazrin_repeat2', 12007),
(12008, 'cd01213', NULL, 'PTB_tensin', NULL, NULL, 'PTB_tensin', 12008),
(12009, 'cd07348', NULL, 'NR_LBD_NGFI-B', NULL, NULL, 'NR_LBD_NGFI-B', 12009),
(12010, 'cd19006', NULL, 'LGIC_ECD_GABAAR_LCCH3-like', NULL, NULL, 'LGIC_ECD_GABAAR_LCCH3-like', 12010),
(12011, 'cd04876', NULL, 'ACT_RelA-SpoT', NULL, NULL, 'ACT_RelA-SpoT', 12011),
(12012, 'cd07034', NULL, 'TPP_PYR_PFOR_IOR-alpha_like', NULL, NULL, 'TPP_PYR_PFOR_IOR-alpha_like', 12012),
(12013, 'cd01463', NULL, 'vWA_VGCC_like', NULL, NULL, 'vWA_VGCC_like', 12013),
(12014, 'cd10140', NULL, 'PFM_aerolysin_family', NULL, NULL, 'PFM_aerolysin_family', 12014),
(12015, 'cd17925', NULL, 'DEXDc_ComFA', NULL, NULL, 'DEXDc_ComFA', 12015),
(12016, 'cd07115', NULL, 'ALDH_HMSADH_HapE', NULL, NULL, 'ALDH_HMSADH_HapE', 12016),
(12017, 'cd09629', NULL, 'DOMON_CIL1_like', NULL, NULL, 'DOMON_CIL1_like', 12017),
(12018, 'cd13839', NULL, 'MEF2_binding', NULL, NULL, 'MEF2_binding', 12018),
(12019, 'cd16769', NULL, 'RING-HC_UHRF1', NULL, NULL, 'RING-HC_UHRF1', 12019),
(12020, 'cd19051', NULL, 'LGIC_TM_cation', NULL, NULL, 'LGIC_TM_cation', 12020),
(12021, 'cd16470', NULL, 'RING-H2_RNF25', NULL, NULL, 'RING-H2_RNF25', 12021);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(12022, 'cd15160', NULL, '7tmA_Proton-sensing_R', NULL, NULL, '7tmA_Proton-sensing_R', 12022),
(12023, 'cd12825', NULL, 'EcCorA-like', NULL, NULL, 'EcCorA-like', 12023),
(12024, 'cd16311', NULL, 'THIN-B2-like_MBL-B3', NULL, NULL, 'THIN-B2-like_MBL-B3', 12024),
(12025, 'cd17351', NULL, 'MFS_NPF', NULL, NULL, 'MFS_NPF', 12025),
(12026, 'cd04091', NULL, 'mtEFG1_II_like', NULL, NULL, 'mtEFG1_II_like', 12026),
(12027, 'cd04479', NULL, 'RPA3', NULL, NULL, 'RPA3', 12027),
(12028, 'cd12029', NULL, 'SH3_DLG3', NULL, NULL, 'SH3_DLG3', 12028),
(12029, 'cd16641', NULL, 'mRING-HC-C3HC3D_TRAF4', NULL, NULL, 'mRING-HC-C3HC3D_TRAF4', 12029),
(12030, 'cd19962', NULL, 'PBP1_ABC_RfuA-like', NULL, NULL, 'PBP1_ABC_RfuA-like', 12030),
(12031, 'cd15015', NULL, '7tm_TAS2R39', NULL, NULL, '7tm_TAS2R39', 12031),
(12032, 'cd08436', NULL, 'PBP2_LTTR_like_3', NULL, NULL, 'PBP2_LTTR_like_3', 12032),
(12033, 'cd03013', NULL, 'PRX5_like', NULL, NULL, 'PRX5_like', 12033),
(12034, 'cd08518', NULL, 'PBP2_NikA_DppA_OppA_like_19', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_19', 12034),
(12035, 'cd11753', NULL, 'GH94N_ChvB_NdvB_2_like', NULL, NULL, 'GH94N_ChvB_NdvB_2_like', 12035),
(12036, 'cd18323', NULL, 'BTB_POZ_ZBTB3', NULL, NULL, 'BTB_POZ_ZBTB3', 12036),
(12037, 'cd06173', NULL, 'MFS_MefA_like', NULL, NULL, 'MFS_MefA_like', 12037),
(12038, 'cd09903', NULL, 'H3TH_FEN1-Arc', NULL, NULL, 'H3TH_FEN1-Arc', 12038),
(12039, 'cd15077', NULL, '7tmA_SWS2_opsin', NULL, NULL, '7tmA_SWS2_opsin', 12039),
(12040, 'cd05772', NULL, 'IgC_SIRP_domain_2', NULL, NULL, 'IgC_SIRP_domain_2', 12040),
(12041, 'cd08678', NULL, 'C2_C21orf25-like', NULL, NULL, 'C2_C21orf25-like', 12041),
(12042, 'cd00924', NULL, 'Cyt_c_Oxidase_Vb', NULL, NULL, 'Cyt_c_Oxidase_Vb', 12042),
(12043, 'cd14554', NULL, 'R-PTP-LAR-2', NULL, NULL, 'R-PTP-LAR-2', 12043),
(12044, 'cd05474', NULL, 'SAP_like', NULL, NULL, 'SAP_like', 12044),
(12045, 'cd04909', NULL, 'ACT_PDH-BS', NULL, NULL, 'ACT_PDH-BS', 12045),
(12046, 'cd19862', NULL, 'DSRM_PRKRA-like_rpt1', NULL, NULL, 'DSRM_PRKRA-like_rpt1', 12046),
(12047, 'cd09721', NULL, 'Cas1_I-C', NULL, NULL, 'Cas1_I-C', 12047),
(12048, 'cd11322', NULL, 'AmyAc_Glg_BE', NULL, NULL, 'AmyAc_Glg_BE', 12048),
(12049, 'cd18750', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, 'PIN_VapC4-5_FitB-like', 12049),
(12050, 'cd16381', NULL, 'YitT_C_like_1', NULL, NULL, 'YitT_C_like_1', 12050),
(12051, 'cd01411', NULL, 'SIR2H', NULL, NULL, 'SIR2H', 12051),
(12052, 'cd16758', NULL, 'RING-HC_TRIM67', NULL, NULL, 'RING-HC_TRIM67', 12052),
(12053, 'cd18741', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, 'PIN_VapC4-5_FitB-like', 12053),
(12054, 'cd00378', NULL, 'SHMT', NULL, NULL, 'SHMT', 12054),
(12055, 'cd05521', NULL, 'Bromo_Rsc1_2_I', NULL, NULL, 'Bromo_Rsc1_2_I', 12055),
(12056, 'cd01800', NULL, 'Ubl_SF3a120', NULL, NULL, 'Ubl_SF3a120', 12056),
(12057, 'cd14157', NULL, 'STKc_IRAK2', NULL, NULL, 'STKc_IRAK2', 12057),
(12058, 'cd03671', NULL, 'Ap4A_hydrolase_plant_like', NULL, NULL, 'Ap4A_hydrolase_plant_like', 12058),
(12059, 'cd13992', NULL, 'PK_GC', NULL, NULL, 'PK_GC', 12059),
(12060, 'cd16251', NULL, 'EFh_parvalbumin_like', NULL, NULL, 'EFh_parvalbumin_like', 12060),
(12061, 'cd08771', NULL, 'DLP_1', NULL, NULL, 'DLP_1', 12061),
(12062, 'cd12245', NULL, 'RRM_scw1_like', NULL, NULL, 'RRM_scw1_like', 12062),
(12063, 'cd08458', NULL, 'PBP2_NocR', NULL, NULL, 'PBP2_NocR', 12063),
(12064, 'cd17079', NULL, 'Ubl_SLD2_NFATC2ip', NULL, NULL, 'Ubl_SLD2_NFATC2ip', 12064),
(12065, 'cd12361', NULL, 'RRM1_2_CELF1-6_like', NULL, NULL, 'RRM1_2_CELF1-6_like', 12065),
(12066, 'cd06233', NULL, 'M14-like', NULL, NULL, 'M14-like', 12066),
(12067, 'cd08491', NULL, 'PBP2_NikA_DppA_OppA_like_12', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_12', 12067),
(12068, 'cd18725', NULL, 'PIN_LabA-like', NULL, NULL, 'PIN_LabA-like', 12068),
(12069, 'cd07202', NULL, 'cPLA2_Grp-IVC', NULL, NULL, 'cPLA2_Grp-IVC', 12069),
(12070, 'cd13444', NULL, 'CDI_toxin_EC869_like', NULL, NULL, 'CDI_toxin_EC869_like', 12070),
(12071, 'cd01126', NULL, 'TraG_VirD4', NULL, NULL, 'TraG_VirD4', 12071),
(12072, 'cd19092', NULL, 'AKR_BsYcsN_EcYdhF-like', NULL, NULL, 'AKR_BsYcsN_EcYdhF-like', 12072);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(12073, 'cd07843', NULL, 'STKc_CDC2L1', NULL, NULL, 'STKc_CDC2L1', 12073),
(12074, 'cd08600', NULL, 'GDPD_EcGlpQ_like', NULL, NULL, 'GDPD_EcGlpQ_like', 12074),
(12075, 'cd01110', NULL, 'HTH_SoxR', NULL, NULL, 'HTH_SoxR', 12075),
(12076, 'cd12634', NULL, 'RRM2_CELF1_2', NULL, NULL, 'RRM2_CELF1_2', 12076),
(12077, 'cd16953', NULL, 'HATPase_BvrS-ChvG-like', NULL, NULL, 'HATPase_BvrS-ChvG-like', 12077),
(12078, 'cd00120', NULL, 'MADS', NULL, NULL, 'MADS', 12078),
(12079, 'cd05666', NULL, 'M20_Acy1-like', NULL, NULL, 'M20_Acy1-like', 12079),
(12080, 'cd19772', NULL, 'Bbox2_TRIM21_C-IV', NULL, NULL, 'Bbox2_TRIM21_C-IV', 12080),
(12081, 'cd07306', NULL, 'Porin3_VDAC', NULL, NULL, 'Porin3_VDAC', 12081),
(12082, 'cd16699', NULL, 'RING_CH-C4HC3_MARCH2_like', NULL, NULL, 'RING_CH-C4HC3_MARCH2_like', 12082),
(12083, 'cd13595', NULL, 'PBP2_HisGs', NULL, NULL, 'PBP2_HisGs', 12083),
(12084, 'cd08934', NULL, 'CAD_SDR_c', NULL, NULL, 'CAD_SDR_c', 12084),
(12085, 'cd15556', NULL, 'PHD_MMD1_like', NULL, NULL, 'PHD_MMD1_like', 12085),
(12086, 'cd08902', NULL, 'START_STARD4-like', NULL, NULL, 'START_STARD4-like', 12086),
(12087, 'cd08525', NULL, 'Reelin_subrepeat_1', NULL, NULL, 'Reelin_subrepeat_1', 12087),
(12088, 'cd19012', NULL, 'LGIC_ECD_5-HT3B', NULL, NULL, 'LGIC_ECD_5-HT3B', 12088),
(12089, 'cd19971', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, 'PBP1_ABC_sugar_binding-like', 12089),
(12090, 'cd12743', NULL, 'RRM3_Fusilli', NULL, NULL, 'RRM3_Fusilli', 12090),
(12091, 'cd12009', NULL, 'SH3_Blk', NULL, NULL, 'SH3_Blk', 12091),
(12092, 'cd06874', NULL, 'PX_KIF16B_SNX23', NULL, NULL, 'PX_KIF16B_SNX23', 12092),
(12093, 'cd09451', NULL, 'LIM_RIL', NULL, NULL, 'LIM_RIL', 12093),
(12094, 'cd14945', NULL, 'Myo5-like_CBD', NULL, NULL, 'Myo5-like_CBD', 12094),
(12095, 'cd14718', NULL, 'bZIP_Maf_large', NULL, NULL, 'bZIP_Maf_large', 12095),
(12096, 'cd18501', NULL, 'BACK_ANKFY1_Rank5', NULL, NULL, 'BACK_ANKFY1_Rank5', 12096),
(12097, 'cd05466', NULL, 'PBP2_LTTR_substrate', NULL, NULL, 'PBP2_LTTR_substrate', 12097),
(12098, 'cd11540', NULL, 'NTP-PPase_u3', NULL, NULL, 'NTP-PPase_u3', 12098),
(12099, 'cd03144', NULL, 'GATase1_ScBLP_like', NULL, NULL, 'GATase1_ScBLP_like', 12099),
(12100, 'cd18997', NULL, 'LGIC_ECD_nAChR', NULL, NULL, 'LGIC_ECD_nAChR', 12100),
(12101, 'cd02988', NULL, 'Phd_like_VIAF', NULL, NULL, 'Phd_like_VIAF', 12101),
(12102, 'cd16957', NULL, 'HATPase_LytS-like', NULL, NULL, 'HATPase_LytS-like', 12102),
(12103, 'cd03181', NULL, 'GST_C_EF1Bgamma_like', NULL, NULL, 'GST_C_EF1Bgamma_like', 12103),
(12104, 'cd04607', NULL, 'CBS_pair_NTP_transferase_assoc', NULL, NULL, 'CBS_pair_NTP_transferase_assoc', 12104),
(12105, 'cd07691', NULL, 'Ig_CD3_gamma_delta', NULL, NULL, 'Ig_CD3_gamma_delta', 12105),
(12106, 'cd13920', NULL, 'Stellacyanin', NULL, NULL, 'Stellacyanin', 12106),
(12107, 'cd14332', NULL, 'UBA_RuvA_C', NULL, NULL, 'UBA_RuvA_C', 12107),
(12108, 'cd05032', NULL, 'PTKc_InsR_like', NULL, NULL, 'PTKc_InsR_like', 12108),
(12109, 'cd14223', NULL, 'STKc_GRK2', NULL, NULL, 'STKc_GRK2', 12109),
(12110, 'cd16417', NULL, 'HAD_PGPase', NULL, NULL, 'HAD_PGPase', 12110),
(12111, 'cd13122', NULL, 'MSL2_CXC', NULL, NULL, 'MSL2_CXC', 12111),
(12112, 'cd16564', NULL, 'RING-HC_RNF222', NULL, NULL, 'RING-HC_RNF222', 12112),
(12113, 'cd12813', NULL, 'LbR-like', NULL, NULL, 'LbR-like', 12113),
(12114, 'cd04600', NULL, 'CBS_pair_HPP_assoc', NULL, NULL, 'CBS_pair_HPP_assoc', 12114),
(12115, 'cd18948', NULL, 'bHLH-PAS_NCoA1_SRC1', NULL, NULL, 'bHLH-PAS_NCoA1_SRC1', 12115),
(12116, 'cd06411', NULL, 'PB1_p51', NULL, NULL, 'PB1_p51', 12116),
(12117, 'cd16468', NULL, 'RING-H2_RNF11', NULL, NULL, 'RING-H2_RNF11', 12117),
(12118, 'cd16484', NULL, 'RING-H2_Vps', NULL, NULL, 'RING-H2_Vps', 12118),
(12119, 'cd07634', NULL, 'BAR_GAP10-like', NULL, NULL, 'BAR_GAP10-like', 12119),
(12120, 'cd06885', NULL, 'PX_SNX17_31', NULL, NULL, 'PX_SNX17_31', 12120),
(12121, 'cd08581', NULL, 'GDPD_like_1', NULL, NULL, 'GDPD_like_1', 12121),
(12122, 'cd11888', NULL, 'SH3_ARHGAP9_like', NULL, NULL, 'SH3_ARHGAP9_like', 12122),
(12123, 'cd03798', NULL, 'GT4_WlbH-like', NULL, NULL, 'GT4_WlbH-like', 12123);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(12124, 'cd00075', NULL, 'HATPase', NULL, NULL, 'HATPase', 12124),
(12125, 'cd17509', NULL, 'Alpha_kinase', NULL, NULL, 'Alpha_kinase', 12125),
(12126, 'cd17349', NULL, 'MFS_SLC15A5', NULL, NULL, 'MFS_SLC15A5', 12126),
(12127, 'cd08503', NULL, 'PBP2_NikA_DppA_OppA_like_17', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_17', 12127),
(12128, 'cd08660', NULL, 'M20_Acy1-like', NULL, NULL, 'M20_Acy1-like', 12128),
(12129, 'cd15084', NULL, '7tmA_Pinopsin', NULL, NULL, '7tmA_Pinopsin', 12129),
(12130, 'cd02073', NULL, 'P-type_ATPase_APLT_Dnf-like', NULL, NULL, 'P-type_ATPase_APLT_Dnf-like', 12130),
(12131, 'cd08770', NULL, 'DAP_dppA_3', NULL, NULL, 'DAP_dppA_3', 12131),
(12132, 'cd11267', NULL, 'Sema_6B', NULL, NULL, 'Sema_6B', 12132),
(12133, 'cd06938', NULL, 'NR_LBD_EcR', NULL, NULL, 'NR_LBD_EcR', 12133),
(12134, 'cd13931', NULL, 'PT-CloQ_NphB', NULL, NULL, 'PT-CloQ_NphB', 12134),
(12135, 'cd15701', NULL, 'ePHD_BRPF1', NULL, NULL, 'ePHD_BRPF1', 12135),
(12136, 'cd11870', NULL, 'SH3_p67phox-like_C', NULL, NULL, 'SH3_p67phox-like_C', 12136),
(12137, 'cd15349', NULL, '7tmA_S1PR4_Edg6', NULL, NULL, '7tmA_S1PR4_Edg6', 12137),
(12138, 'cd16549', NULL, 'RING-HC_RNF166', NULL, NULL, 'RING-HC_RNF166', 12138),
(12139, 'cd00539', NULL, 'MCR_gamma', NULL, NULL, 'MCR_gamma', 12139),
(12140, 'cd19538', NULL, 'LCL_NRPS', NULL, NULL, 'LCL_NRPS', 12140),
(12141, 'cd06922', NULL, 'ChtBD1_GH18_1', NULL, NULL, 'ChtBD1_GH18_1', 12141),
(12142, 'cd19917', NULL, 'RsmI_like', NULL, NULL, 'RsmI_like', 12142),
(12143, 'cd06855', NULL, 'GT_GPT_euk', NULL, NULL, 'GT_GPT_euk', 12143),
(12144, 'cd15412', NULL, '7tmA_OR5M-like', NULL, NULL, '7tmA_OR5M-like', 12144),
(12145, 'cd12007', NULL, 'SH3_Yes', NULL, NULL, 'SH3_Yes', 12145),
(12146, 'cd15444', NULL, '7tmB2_GPR64', NULL, NULL, '7tmB2_GPR64', 12146),
(12147, 'cd05854', NULL, 'Ig6_Contactin-2', NULL, NULL, 'Ig6_Contactin-2', 12147),
(12148, 'cd20226', NULL, 'PFM_Cry51Aa-like', NULL, NULL, 'PFM_Cry51Aa-like', 12148),
(12149, 'cd08318', NULL, 'Death_NMPP84', NULL, NULL, 'Death_NMPP84', 12149),
(12150, 'cd20295', NULL, 'cupin_Pac13-like', NULL, NULL, 'cupin_Pac13-like', 12150),
(12151, 'cd14230', NULL, 'GAT_GGA', NULL, NULL, 'GAT_GGA', 12151),
(12152, 'cd00619', NULL, 'Terminator_NusB', NULL, NULL, 'Terminator_NusB', 12152),
(12153, 'cd13283', NULL, 'PH_GPBP', NULL, NULL, 'PH_GPBP', 12153),
(12154, 'cd08631', NULL, 'PI-PLCc_delta4', NULL, NULL, 'PI-PLCc_delta4', 12154),
(12155, 'cd00660', NULL, 'Topoisomer_IB_N', NULL, NULL, 'Topoisomer_IB_N', 12155),
(12156, 'cd08425', NULL, 'PBP2_CynR', NULL, NULL, 'PBP2_CynR', 12156),
(12157, 'cd08726', NULL, 'RGS_RGS22_3', NULL, NULL, 'RGS_RGS22_3', 12157),
(12158, 'cd12406', NULL, 'RRM4_NCL', NULL, NULL, 'RRM4_NCL', 12158),
(12159, 'cd07181', NULL, 'RNase_HII_eukaryota_like', NULL, NULL, 'RNase_HII_eukaryota_like', 12159),
(12160, 'cd17921', NULL, 'DEXHc_Ski2', NULL, NULL, 'DEXHc_Ski2', 12160),
(12161, 'cd13921', NULL, 'Amicyanin', NULL, NULL, 'Amicyanin', 12161),
(12162, 'cd02029', NULL, 'PRK_like', NULL, NULL, 'PRK_like', 12162),
(12163, 'cd04177', NULL, 'RSR1', NULL, NULL, 'RSR1', 12163),
(12164, 'cd14610', NULL, 'R-PTP-N2', NULL, NULL, 'R-PTP-N2', 12164),
(12165, 'cd04134', NULL, 'Rho3', NULL, NULL, 'Rho3', 12165),
(12166, 'cd10417', NULL, 'SH2_SH2D7', NULL, NULL, 'SH2_SH2D7', 12166),
(12167, 'cd08268', NULL, 'MDR2', NULL, NULL, 'MDR2', 12167),
(12168, 'cd11832', NULL, 'SH3_Shank', NULL, NULL, 'SH3_Shank', 12168),
(12169, 'cd09876', NULL, 'PIN_Nob1-like', NULL, NULL, 'PIN_Nob1-like', 12169),
(12170, 'cd04101', NULL, 'RabL4', NULL, NULL, 'RabL4', 12170),
(12171, 'cd03279', NULL, 'ABC_sbcCD', NULL, NULL, 'ABC_sbcCD', 12171),
(12172, 'cd14943', NULL, 'TRAPPC5_Trs31', NULL, NULL, 'TRAPPC5_Trs31', 12172),
(12173, 'cd03793', NULL, 'GT3_GSY2-like', NULL, NULL, 'GT3_GSY2-like', 12173),
(12174, 'cd16921', NULL, 'HATPase_FilI-like', NULL, NULL, 'HATPase_FilI-like', 12174),
(12175, 'cd08546', NULL, 'cohesin_like', NULL, NULL, 'cohesin_like', 12175),
(12176, 'cd11264', NULL, 'Sema_5B', NULL, NULL, 'Sema_5B', 12176),
(12177, 'cd01895', NULL, 'EngA2', NULL, NULL, 'EngA2', 12177);
INSERT INTO "PUBLIC"."MODEL" VALUES
(12178, 'cd10518', NULL, 'SET_SETD1-like', NULL, NULL, 'SET_SETD1-like', 12178),
(12179, 'cd11925', NULL, 'SH3_SH3RF3_3', NULL, NULL, 'SH3_SH3RF3_3', 12179),
(12180, 'cd03369', NULL, 'ABCC_NFT1', NULL, NULL, 'ABCC_NFT1', 12180),
(12181, 'cd16486', NULL, 'mRING-H2-C3H2C2D_ZSWM2', NULL, NULL, 'mRING-H2-C3H2C2D_ZSWM2', 12181),
(12182, 'cd02417', NULL, 'Peptidase_C39_likeA', NULL, NULL, 'Peptidase_C39_likeA', 12182),
(12183, 'cd07839', NULL, 'STKc_CDK5', NULL, NULL, 'STKc_CDK5', 12183),
(12184, 'cd03204', NULL, 'GST_C_GDAP1_like', NULL, NULL, 'GST_C_GDAP1_like', 12184),
(12185, 'cd10551', NULL, 'PsrB', NULL, NULL, 'PsrB', 12185),
(12186, 'cd10437', NULL, 'GIY-YIG_HE_I-TevI_like', NULL, NULL, 'GIY-YIG_HE_I-TevI_like', 12186),
(12187, 'cd00046', NULL, 'SF2-N', NULL, NULL, 'SF2-N', 12187),
(12188, 'cd02222', NULL, 'cupin_TM1459-like', NULL, NULL, 'cupin_TM1459-like', 12188),
(12189, 'cd05804', NULL, 'StaR_like', NULL, NULL, 'StaR_like', 12189),
(12190, 'cd05602', NULL, 'STKc_SGK1', NULL, NULL, 'STKc_SGK1', 12190),
(12191, 'cd09828', NULL, 'PET_OEBT', NULL, NULL, 'PET_OEBT', 12191),
(12192, 'cd08402', NULL, 'C2B_Synaptotagmin-1', NULL, NULL, 'C2B_Synaptotagmin-1', 12192),
(12193, 'cd12164', NULL, 'GDH_like_2', NULL, NULL, 'GDH_like_2', 12193),
(12194, 'cd17110', NULL, 'FERM_F1_Myo10_like', NULL, NULL, 'FERM_F1_Myo10_like', 12194),
(12195, 'cd06412', NULL, 'GH25_CH-type', NULL, NULL, 'GH25_CH-type', 12195),
(12196, 'cd17931', NULL, 'DEXHc_viral_Ns3', NULL, NULL, 'DEXHc_viral_Ns3', 12196),
(12197, 'cd19611', NULL, 'Ctf13_LRR_LRR-insertion', NULL, NULL, 'Ctf13_LRR_LRR-insertion', 12197),
(12198, 'cd10428', NULL, 'LFG_like', NULL, NULL, 'LFG_like', 12198),
(12199, 'cd06987', NULL, 'cupin_MAE_RS03005', NULL, NULL, 'cupin_MAE_RS03005', 12199),
(12200, 'cd18102', NULL, 'Trm10_MRRP1', NULL, NULL, 'Trm10_MRRP1', 12200),
(12201, 'cd11024', NULL, 'CuRO_1_2DMCO_NIR_like', NULL, NULL, 'CuRO_1_2DMCO_NIR_like', 12201),
(12202, 'cd09712', NULL, 'Cas10d_I-D', NULL, NULL, 'Cas10d_I-D', 12202),
(12203, 'cd04195', NULL, 'GT2_AmsE_like', NULL, NULL, 'GT2_AmsE_like', 12203),
(12204, 'cd11754', NULL, 'GH94N_CBP_like', NULL, NULL, 'GH94N_CBP_like', 12204),
(12205, 'cd05738', NULL, 'Ig2_RPTP_IIa_LAR_like', NULL, NULL, 'Ig2_RPTP_IIa_LAR_like', 12205),
(12206, 'cd13565', NULL, 'PBP2_PstS', NULL, NULL, 'PBP2_PstS', 12206),
(12207, 'cd12768', NULL, 'RRM2_SRSF9', NULL, NULL, 'RRM2_SRSF9', 12207),
(12208, 'cd18731', NULL, 'PIN_NgFitB-like', NULL, NULL, 'PIN_NgFitB-like', 12208),
(12209, 'cd13638', NULL, 'PBP2_EcProx_like', NULL, NULL, 'PBP2_EcProx_like', 12209),
(12210, 'cd05055', NULL, 'PTKc_PDGFR', NULL, NULL, 'PTKc_PDGFR', 12210),
(12211, 'cd15114', NULL, '7tmA_C5aR', NULL, NULL, '7tmA_C5aR', 12211),
(12212, 'cd08290', NULL, 'ETR', NULL, NULL, 'ETR', 12212),
(12213, 'cd01125', NULL, 'repA', NULL, NULL, 'repA', 12213),
(12214, 'cd13762', NULL, 'TGF_beta_GDP9_9B_like', NULL, NULL, 'TGF_beta_GDP9_9B_like', 12214),
(12215, 'cd14845', NULL, 'L-Ala-D-Glu_peptidase_like', NULL, NULL, 'L-Ala-D-Glu_peptidase_like', 12215),
(12216, 'cd09698', NULL, 'Cas8a2_I-A', NULL, NULL, 'Cas8a2_I-A', 12216),
(12217, 'cd14477', NULL, 'SPX_XPR1_like', NULL, NULL, 'SPX_XPR1_like', 12217),
(12218, 'cd03224', NULL, 'ABC_TM1139_LivF_branched', NULL, NULL, 'ABC_TM1139_LivF_branched', 12218),
(12219, 'cd12161', NULL, 'GDH_like_1', NULL, NULL, 'GDH_like_1', 12219),
(12220, 'cd16668', NULL, 'RING-H2_GRAIL', NULL, NULL, 'RING-H2_GRAIL', 12220),
(12221, 'cd10360', NULL, 'SH2_Srm', NULL, NULL, 'SH2_Srm', 12221),
(12222, 'cd04596', NULL, 'CBS_pair_DRTGG_assoc', NULL, NULL, 'CBS_pair_DRTGG_assoc', 12222),
(12223, 'cd06561', NULL, 'AlkD_like', NULL, NULL, 'AlkD_like', 12223),
(12224, 'cd00031', NULL, 'CA_like', NULL, NULL, 'CA_like', 12224),
(12225, 'cd00900', NULL, 'PH-like', NULL, NULL, 'PH-like', 12225),
(12226, 'cd15511', NULL, 'PHD3_KMT2C', NULL, NULL, 'PHD3_KMT2C', 12226),
(12227, 'cd17035', NULL, 'T3SC_IB_Spa15-like', NULL, NULL, 'T3SC_IB_Spa15-like', 12227),
(12228, 'cd16760', NULL, 'RING-HC_MuRF2', NULL, NULL, 'RING-HC_MuRF2', 12228),
(12229, 'cd14873', NULL, 'MYSc_Myo10', NULL, NULL, 'MYSc_Myo10', 12229);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(12230, 'cd01452', NULL, 'VWA_26S_proteasome_subunit', NULL, NULL, 'VWA_26S_proteasome_subunit', 12230),
(12231, 'cd02179', NULL, 'GH16_beta_GRP', NULL, NULL, 'GH16_beta_GRP', 12231),
(12232, 'cd14322', NULL, 'UBA_LATS', NULL, NULL, 'UBA_LATS', 12232),
(12233, 'cd14651', NULL, 'ZIP_Put3', NULL, NULL, 'ZIP_Put3', 12233),
(12234, 'cd15752', NULL, 'FYVE_SlaC2-a', NULL, NULL, 'FYVE_SlaC2-a', 12234),
(12235, 'cd16138', NULL, 'RA_MRL_MIG10', NULL, NULL, 'RA_MRL_MIG10', 12235),
(12236, 'cd14107', NULL, 'STKc_obscurin_rpt1', NULL, NULL, 'STKc_obscurin_rpt1', 12236),
(12237, 'cd07684', NULL, 'F-BAR_srGAP3', NULL, NULL, 'F-BAR_srGAP3', 12237),
(12238, 'cd09745', NULL, 'Cas8a2_I-A', NULL, NULL, 'Cas8a2_I-A', 12238),
(12239, 'cd01195', NULL, 'INT_C_like_5', NULL, NULL, 'INT_C_like_5', 12239),
(12240, 'cd10924', NULL, 'CE4_COG4878', NULL, NULL, 'CE4_COG4878', 12240),
(12241, 'cd15051', NULL, '7tmA_Histamine_H2R', NULL, NULL, '7tmA_Histamine_H2R', 12241),
(12242, 'cd09984', NULL, 'LOTUS_8_Limkain_b1', NULL, NULL, 'LOTUS_8_Limkain_b1', 12242),
(12243, 'cd01719', NULL, 'Sm_G', NULL, NULL, 'Sm_G', 12243),
(12244, 'cd02076', NULL, 'P-type_ATPase_H', NULL, NULL, 'P-type_ATPase_H', 12244),
(12245, 'cd03500', NULL, 'SQR_TypeA_SdhD_like', NULL, NULL, 'SQR_TypeA_SdhD_like', 12245),
(12246, 'cd10006', NULL, 'HDAC4', NULL, NULL, 'HDAC4', 12246),
(12247, 'cd12471', NULL, 'RRM1_MSSP2', NULL, NULL, 'RRM1_MSSP2', 12247),
(12248, 'cd05911', NULL, 'Firefly_Luc_like', NULL, NULL, 'Firefly_Luc_like', 12248),
(12249, 'cd02864', NULL, 'Heme_Cu_Oxidase_III_1', NULL, NULL, 'Heme_Cu_Oxidase_III_1', 12249),
(12250, 'cd08994', NULL, 'GH43_62_32_68_117_130-like', NULL, NULL, 'GH43_62_32_68_117_130-like', 12250),
(12251, 'cd06117', NULL, 'Ec2MCS_like_1', NULL, NULL, 'Ec2MCS_like_1', 12251),
(12252, 'cd12476', NULL, 'RRM1_SNF', NULL, NULL, 'RRM1_SNF', 12252),
(12253, 'cd15531', NULL, 'PHD1_CHD_II', NULL, NULL, 'PHD1_CHD_II', 12253),
(12254, 'cd13162', NULL, 'PTB_RGS12', NULL, NULL, 'PTB_RGS12', 12254),
(12255, 'cd11692', NULL, 'HRI1_N_like', NULL, NULL, 'HRI1_N_like', 12255),
(12256, 'cd05620', NULL, 'STKc_nPKC_delta', NULL, NULL, 'STKc_nPKC_delta', 12256),
(12257, 'cd19175', NULL, 'SET_ASHR3-like', NULL, NULL, 'SET_ASHR3-like', 12257),
(12258, 'cd12706', NULL, 'RRM_LARP5', NULL, NULL, 'RRM_LARP5', 12258),
(12259, 'cd19927', NULL, 'REC_Ycf29', NULL, NULL, 'REC_Ycf29', 12259),
(12260, 'cd09488', NULL, 'SAM_EPH-R', NULL, NULL, 'SAM_EPH-R', 12260),
(12261, 'cd17314', NULL, 'MFS_MCT_like', NULL, NULL, 'MFS_MCT_like', 12261),
(12262, 'cd16234', NULL, 'EFh_SPARC_SMOC', NULL, NULL, 'EFh_SPARC_SMOC', 12262),
(12263, 'cd00321', NULL, 'SO_family_Moco', NULL, NULL, 'SO_family_Moco', 12263),
(12264, 'cd11773', NULL, 'SH3_Sla1p_1', NULL, NULL, 'SH3_Sla1p_1', 12264),
(12265, 'cd10046', NULL, 'Reelin_repeat_2_subrepeat_2', NULL, NULL, 'Reelin_repeat_2_subrepeat_2', 12265),
(12266, 'cd01313', NULL, 'Met_dep_hydrolase_E', NULL, NULL, 'Met_dep_hydrolase_E', 12266),
(12267, 'cd06558', NULL, 'crotonase-like', NULL, NULL, 'crotonase-like', 12267),
(12268, 'cd12158', NULL, 'ErythrP_dh', NULL, NULL, 'ErythrP_dh', 12268),
(12269, 'cd12330', NULL, 'RRM2_Hrp1p', NULL, NULL, 'RRM2_Hrp1p', 12269),
(12270, 'cd06530', NULL, 'S26_SPase_I', NULL, NULL, 'S26_SPase_I', 12270),
(12271, 'cd16995', NULL, 'VHS_Tom1', NULL, NULL, 'VHS_Tom1', 12271),
(12272, 'cd01106', NULL, 'HTH_TipAL-Mta', NULL, NULL, 'HTH_TipAL-Mta', 12272),
(12273, 'cd01752', NULL, 'PLAT_polycystin', NULL, NULL, 'PLAT_polycystin', 12273),
(12274, 'cd05030', NULL, 'calgranulins', NULL, NULL, 'calgranulins', 12274),
(12275, 'cd04114', NULL, 'Rab30', NULL, NULL, 'Rab30', 12275),
(12276, 'cd05063', NULL, 'PTKc_EphR_A2', NULL, NULL, 'PTKc_EphR_A2', 12276),
(12277, 'cd11634', NULL, 'HR1_Rhophilin-2', NULL, NULL, 'HR1_Rhophilin-2', 12277),
(12278, 'cd06492', NULL, 'p23_mNUDC_like', NULL, NULL, 'p23_mNUDC_like', 12278),
(12279, 'cd03483', NULL, 'MutL_Trans_MLH1', NULL, NULL, 'MutL_Trans_MLH1', 12279),
(12280, 'cd03518', NULL, 'Link_domain_HAPLN_module_1', NULL, NULL, 'Link_domain_HAPLN_module_1', 12280),
(12281, 'cd13731', NULL, 'PBP2_iGluR_delta_2', NULL, NULL, 'PBP2_iGluR_delta_2', 12281);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(12282, 'cd08999', NULL, 'GH43_ABN-like', NULL, NULL, 'GH43_ABN-like', 12282),
(12283, 'cd07055', NULL, 'BMC_like_2', NULL, NULL, 'BMC_like_2', 12283),
(12284, 'cd12725', NULL, 'RRM2_CPEB1', NULL, NULL, 'RRM2_CPEB1', 12284),
(12285, 'cd07153', NULL, 'Fur_like', NULL, NULL, 'Fur_like', 12285),
(12286, 'cd12944', NULL, 'LEM_ANKL2', NULL, NULL, 'LEM_ANKL2', 12286),
(12287, 'cd01709', NULL, 'RT_like_1', NULL, NULL, 'RT_like_1', 12287),
(12288, 'cd11279', NULL, 'Sema_RON', NULL, NULL, 'Sema_RON', 12288),
(12289, 'cd14015', NULL, 'STKc_VRK', NULL, NULL, 'STKc_VRK', 12289),
(12290, 'cd08421', NULL, 'PBP2_LTTR_like_1', NULL, NULL, 'PBP2_LTTR_like_1', 12290),
(12291, 'cd00319', NULL, 'Ribosomal_S12_like', NULL, NULL, 'Ribosomal_S12_like', 12291),
(12292, 'cd04754', NULL, 'Commd6', NULL, NULL, 'Commd6', 12292),
(12293, 'sd00003', NULL, 'TSP3_1C', NULL, NULL, 'TSP3_1C', 12293),
(12294, 'cd06242', NULL, 'M14-like', NULL, NULL, 'M14-like', 12294),
(12295, 'cd06250', NULL, 'M14_PaAOTO_like', NULL, NULL, 'M14_PaAOTO_like', 12295),
(12296, 'cd01207', NULL, 'EVH1_Ena_VASP-like', NULL, NULL, 'EVH1_Ena_VASP-like', 12296),
(12297, 'cd08984', NULL, 'GH43-like', NULL, NULL, 'GH43-like', 12297),
(12298, 'cd09968', NULL, 'UP_III', NULL, NULL, 'UP_III', 12298),
(12299, 'cd14496', NULL, 'PTP_paladin', NULL, NULL, 'PTP_paladin', 12299),
(12300, 'cd07772', NULL, 'FGGY_NaCK_like', NULL, NULL, 'FGGY_NaCK_like', 12300),
(12301, 'cd03133', NULL, 'GATase1_ES1', NULL, NULL, 'GATase1_ES1', 12301),
(12302, 'cd14838', NULL, 'AP4_Mu_N', NULL, NULL, 'AP4_Mu_N', 12302),
(12303, 'cd05685', NULL, 'S1_Tex', NULL, NULL, 'S1_Tex', 12303),
(12304, 'cd08489', NULL, 'PBP2_NikA', NULL, NULL, 'PBP2_NikA', 12304),
(12305, 'cd14127', NULL, 'STKc_CK1_fungal', NULL, NULL, 'STKc_CK1_fungal', 12305),
(12306, 'cd17728', NULL, 'BRCT_TopBP1_rpt8', NULL, NULL, 'BRCT_TopBP1_rpt8', 12306),
(12307, 'cd04629', NULL, 'CBS_pair_bac', NULL, NULL, 'CBS_pair_bac', 12307),
(12308, 'cd02582', NULL, 'RNAP_archeal_A''', NULL, NULL, 'RNAP_archeal_A''', 12308),
(12309, 'cd07325', NULL, 'M48_Ste24p_like', NULL, NULL, 'M48_Ste24p_like', 12309),
(12310, 'cd01806', NULL, 'Ubl_NEDD8', NULL, NULL, 'Ubl_NEDD8', 12310),
(12311, 'cd20167', NULL, 'Peptidase_M90-like', NULL, NULL, 'Peptidase_M90-like', 12311),
(12312, 'cd08338', NULL, 'DED_PEA15', NULL, NULL, 'DED_PEA15', 12312),
(12313, 'cd08939', NULL, 'KDSR-like_SDR_c', NULL, NULL, 'KDSR-like_SDR_c', 12313),
(12314, 'cd07292', NULL, 'PX_SNX6', NULL, NULL, 'PX_SNX6', 12314),
(12315, 'cd08204', NULL, 'ArfGap', NULL, NULL, 'ArfGap', 12315),
(12316, 'cd09166', NULL, 'PLDc_PPK1_C1_unchar', NULL, NULL, 'PLDc_PPK1_C1_unchar', 12316),
(12317, 'cd16971', NULL, 'Alpha_kinase_ChaK1_TRMP7', NULL, NULL, 'Alpha_kinase_ChaK1_TRMP7', 12317),
(12318, 'cd19001', NULL, 'LGIC_ECD_GABAAR_delta', NULL, NULL, 'LGIC_ECD_GABAAR_delta', 12318),
(12319, 'cd14358', NULL, 'UBA_NAC_euk', NULL, NULL, 'UBA_NAC_euk', 12319),
(12320, 'cd08387', NULL, 'C2A_Synaptotagmin-8', NULL, NULL, 'C2A_Synaptotagmin-8', 12320),
(12321, 'cd10022', NULL, '14-3-3_beta_zeta', NULL, NULL, '14-3-3_beta_zeta', 12321),
(12322, 'cd14324', NULL, 'UBA_Dsk2p_like', NULL, NULL, 'UBA_Dsk2p_like', 12322),
(12323, 'cd01828', NULL, 'sialate_O-acetylesterase_like2', NULL, NULL, 'sialate_O-acetylesterase_like2', 12323),
(12324, 'cd03052', NULL, 'GST_N_GDAP1', NULL, NULL, 'GST_N_GDAP1', 12324),
(12325, 'cd07375', NULL, 'Anticodon_Ia_like', NULL, NULL, 'Anticodon_Ia_like', 12325),
(12326, 'cd01200', NULL, 'WHEPGMRS_RNA', NULL, NULL, 'WHEPGMRS_RNA', 12326),
(12327, 'cd02857', NULL, 'E_set_CDase_PDE_N', NULL, NULL, 'E_set_CDase_PDE_N', 12327),
(12328, 'cd03809', NULL, 'GT4_MtfB-like', NULL, NULL, 'GT4_MtfB-like', 12328),
(12329, 'cd14738', NULL, 'PAAR_2', NULL, NULL, 'PAAR_2', 12329),
(12330, 'cd05057', NULL, 'PTKc_EGFR_like', NULL, NULL, 'PTKc_EGFR_like', 12330),
(12331, 'cd10375', NULL, 'SH2_STAT4', NULL, NULL, 'SH2_STAT4', 12331),
(12332, 'cd14899', NULL, 'MYSc_Myo38', NULL, NULL, 'MYSc_Myo38', 12332),
(12333, 'cd04038', NULL, 'C2_ArfGAP', NULL, NULL, 'C2_ArfGAP', 12333),
(12334, 'cd18596', NULL, 'ABC_6TM_VMR1_D1_like', NULL, NULL, 'ABC_6TM_VMR1_D1_like', 12334);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(12335, 'cd13833', NULL, 'HU_IHF_like', NULL, NULL, 'HU_IHF_like', 12335),
(12336, 'cd06128', NULL, 'DNA_polA_exo', NULL, NULL, 'DNA_polA_exo', 12336),
(12337, 'cd07287', NULL, 'PX_RPK118_like', NULL, NULL, 'PX_RPK118_like', 12337),
(12338, 'cd18091', NULL, 'SpoU-like_TRM3-like', NULL, NULL, 'SpoU-like_TRM3-like', 12338),
(12339, 'cd15046', NULL, '7tmC_TAS1R', NULL, NULL, '7tmC_TAS1R', 12339),
(12340, 'cd01330', NULL, 'KAZAL_SLC21', NULL, NULL, 'KAZAL_SLC21', 12340),
(12341, 'cd04732', NULL, 'HisA', NULL, NULL, 'HisA', 12341),
(12342, 'cd13910', NULL, 'CuRO_3_MCO_like_4', NULL, NULL, 'CuRO_3_MCO_like_4', 12342),
(12343, 'cd13254', NULL, 'PH2_ARAP', NULL, NULL, 'PH2_ARAP', 12343),
(12344, 'cd09288', NULL, 'Photosystem-II_D2', NULL, NULL, 'Photosystem-II_D2', 12344),
(12345, 'cd16301', NULL, 'IMP_DIM-like_MBL-B1', NULL, NULL, 'IMP_DIM-like_MBL-B1', 12345),
(12346, 'cd19600', NULL, 'serpin11-like_insects', NULL, NULL, 'serpin11-like_insects', 12346),
(12347, 'cd07940', NULL, 'DRE_TIM_IPMS', NULL, NULL, 'DRE_TIM_IPMS', 12347),
(12348, 'cd00837', NULL, 'EVH1_family', NULL, NULL, 'EVH1_family', 12348),
(12349, 'cd03359', NULL, 'LbH_Dynactin_5', NULL, NULL, 'LbH_Dynactin_5', 12349),
(12350, 'cd18380', NULL, 'BTB_POZ_Kv4_KCND', NULL, NULL, 'BTB_POZ_Kv4_KCND', 12350),
(12351, 'cd06320', NULL, 'PBP1_allose_binding', NULL, NULL, 'PBP1_allose_binding', 12351),
(12352, 'cd14392', NULL, 'UBA_Cbl-b', NULL, NULL, 'UBA_Cbl-b', 12352),
(12353, 'cd13558', NULL, 'PBP2_SsuA_like_2', NULL, NULL, 'PBP2_SsuA_like_2', 12353),
(12354, 'cd03190', NULL, 'GST_C_Omega_like', NULL, NULL, 'GST_C_Omega_like', 12354),
(12355, 'cd12788', NULL, 'RasGAP_plexin_D1', NULL, NULL, 'RasGAP_plexin_D1', 12355),
(12356, 'cd03060', NULL, 'GST_N_Omega_like', NULL, NULL, 'GST_N_Omega_like', 12356),
(12357, 'cd07345', NULL, 'M48A_Ste24p-like', NULL, NULL, 'M48A_Ste24p-like', 12357),
(12358, 'cd08667', NULL, 'APC10-ZZEF1', NULL, NULL, 'APC10-ZZEF1', 12358),
(12359, 'cd20014', NULL, 'PBP1_RPA0668_benzoate-like', NULL, NULL, 'PBP1_RPA0668_benzoate-like', 12359),
(12360, 'cd00802', NULL, 'class_I_aaRS_core', NULL, NULL, 'class_I_aaRS_core', 12360),
(12361, 'cd17024', NULL, 'T3SC_IA_DspF-like', NULL, NULL, 'T3SC_IA_DspF-like', 12361),
(12362, 'cd17868', NULL, 'GPN', NULL, NULL, 'GPN', 12362),
(12363, 'cd04723', NULL, 'HisA_HisF', NULL, NULL, 'HisA_HisF', 12363),
(12364, 'cd13317', NULL, 'PH_PLEKHO1_PLEKHO2', NULL, NULL, 'PH_PLEKHO1_PLEKHO2', 12364),
(12365, 'cd19464', NULL, 'CRBP3', NULL, NULL, 'CRBP3', 12365),
(12366, 'cd02607', NULL, 'HAD_ThrH_like', NULL, NULL, 'HAD_ThrH_like', 12366),
(12367, 'cd03344', NULL, 'GroEL', NULL, NULL, 'GroEL', 12367),
(12368, 'cd00917', NULL, 'PG-PI_TP', NULL, NULL, 'PG-PI_TP', 12368),
(12369, 'cd09509', NULL, 'SAM_Polycomb', NULL, NULL, 'SAM_Polycomb', 12369),
(12370, 'cd05775', NULL, 'Ig_CD2_like_N', NULL, NULL, 'Ig_CD2_like_N', 12370),
(12371, 'cd19871', NULL, 'DSRM_DUS2L', NULL, NULL, 'DSRM_DUS2L', 12371),
(12372, 'cd15874', NULL, 'R-SNARE_Snc1', NULL, NULL, 'R-SNARE_Snc1', 12372),
(12373, 'cd09499', NULL, 'SAM_AIDA1AB-like_repeat1', NULL, NULL, 'SAM_AIDA1AB-like_repeat1', 12373),
(12374, 'cd14519', NULL, 'DSP_DUSP22_15', NULL, NULL, 'DSP_DUSP22_15', 12374),
(12375, 'cd21684', NULL, 'ORF7a_SARS-CoV-2-like', NULL, NULL, 'ORF7a_SARS-CoV-2-like', 12375),
(12376, 'cd03050', NULL, 'GST_N_Theta', NULL, NULL, 'GST_N_Theta', 12376),
(12377, 'cd06634', NULL, 'STKc_TAO2', NULL, NULL, 'STKc_TAO2', 12377),
(12378, 'cd08626', NULL, 'PI-PLCc_beta4', NULL, NULL, 'PI-PLCc_beta4', 12378),
(12379, 'cd12233', NULL, 'RRM_Srp1p_AtRSp31_like', NULL, NULL, 'RRM_Srp1p_AtRSp31_like', 12379),
(12380, 'cd13257', NULL, 'PH4_ARAP', NULL, NULL, 'PH4_ARAP', 12380),
(12381, 'cd19041', NULL, 'LGIC_ECD_GABAAR_B2', NULL, NULL, 'LGIC_ECD_GABAAR_B2', 12381),
(12382, 'cd11931', NULL, 'SH3_SH3RF3_2', NULL, NULL, 'SH3_SH3RF3_2', 12382),
(12383, 'cd03820', NULL, 'GT4_AmsD-like', NULL, NULL, 'GT4_AmsD-like', 12383),
(12384, 'cd00528', NULL, 'MoaC', NULL, NULL, 'MoaC', 12384),
(12385, 'cd09716', NULL, 'Cas5_I', NULL, NULL, 'Cas5_I', 12385),
(12386, 'cd14546', NULL, 'R-PTP-N-N2', NULL, NULL, 'R-PTP-N-N2', 12386);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(12387, 'cd03870', NULL, 'M14_CPA', NULL, NULL, 'M14_CPA', 12387),
(12388, 'cd15756', NULL, 'FYVE_WDFY1', NULL, NULL, 'FYVE_WDFY1', 12388),
(12389, 'cd19745', NULL, 'bHLH_TS_ASCL3', NULL, NULL, 'bHLH_TS_ASCL3', 12389),
(12390, 'cd02336', NULL, 'ZZ_RSC8', NULL, NULL, 'ZZ_RSC8', 12390),
(12391, 'cd14869', NULL, 'uS7_Bacteria', NULL, NULL, 'uS7_Bacteria', 12391),
(12392, 'cd04743', NULL, 'NPD_PKS', NULL, NULL, 'NPD_PKS', 12392),
(12393, 'cd06396', NULL, 'PB1_NBR1', NULL, NULL, 'PB1_NBR1', 12393),
(12394, 'cd04230', NULL, 'Sulfocyanin', NULL, NULL, 'Sulfocyanin', 12394),
(12395, 'cd10430', NULL, 'BI-1', NULL, NULL, 'BI-1', 12395),
(12396, 'cd04184', NULL, 'GT2_RfbC_Mx_like', NULL, NULL, 'GT2_RfbC_Mx_like', 12396),
(12397, 'cd09831', NULL, 'CBS_pair_ABC_Gly_Pro_assoc', NULL, NULL, 'CBS_pair_ABC_Gly_Pro_assoc', 12397),
(12398, 'cd05528', NULL, 'Bromo_AAA', NULL, NULL, 'Bromo_AAA', 12398),
(12399, 'cd19741', NULL, 'bHLH-O_ESMB_like', NULL, NULL, 'bHLH-O_ESMB_like', 12399),
(12400, 'cd12895', NULL, 'SPRY_PRY_TRIM46', NULL, NULL, 'SPRY_PRY_TRIM46', 12400),
(12401, 'cd17788', NULL, 'CBS_pair_bac', NULL, NULL, 'CBS_pair_bac', 12401),
(12402, 'cd01408', NULL, 'SIRT1', NULL, NULL, 'SIRT1', 12402),
(12403, 'cd18448', NULL, 'BACK_KLHL8', NULL, NULL, 'BACK_KLHL8', 12403),
(12404, 'cd10002', NULL, 'HDAC10_HDAC6-dom1', NULL, NULL, 'HDAC10_HDAC6-dom1', 12404),
(12405, 'cd17761', NULL, 'MCM_arch', NULL, NULL, 'MCM_arch', 12405),
(12406, 'cd17642', NULL, 'Firefly_Luc', NULL, NULL, 'Firefly_Luc', 12406),
(12407, 'cd17510', NULL, 'T3SC_YbjN-like_2', NULL, NULL, 'T3SC_YbjN-like_2', 12407),
(12408, 'cd01036', NULL, 'ClC_euk', NULL, NULL, 'ClC_euk', 12408),
(12409, 'cd00488', NULL, 'PCD_DCoH', NULL, NULL, 'PCD_DCoH', 12409),
(12410, 'cd04734', NULL, 'OYE_like_3_FMN', NULL, NULL, 'OYE_like_3_FMN', 12410),
(12411, 'cd02848', NULL, 'E_set_Chitinase_N', NULL, NULL, 'E_set_Chitinase_N', 12411),
(12412, 'cd12184', NULL, 'HGDH_like', NULL, NULL, 'HGDH_like', 12412),
(12413, 'cd06308', NULL, 'PBP1_sensor_kinase-like', NULL, NULL, 'PBP1_sensor_kinase-like', 12413),
(12414, 'cd15755', NULL, 'FYVE_PKHF2', NULL, NULL, 'FYVE_PKHF2', 12414),
(12415, 'cd19969', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, 'PBP1_ABC_sugar_binding-like', 12415),
(12416, 'cd14440', NULL, 'AlgX_N_like_3', NULL, NULL, 'AlgX_N_like_3', 12416),
(12417, 'cd18263', NULL, 'BTB2_POZ_KLHL33', NULL, NULL, 'BTB2_POZ_KLHL33', 12417),
(12418, 'cd14090', NULL, 'STKc_Mnk', NULL, NULL, 'STKc_Mnk', 12418),
(12419, 'cd04974', NULL, 'Ig3_FGFR', NULL, NULL, 'Ig3_FGFR', 12419),
(12420, 'cd07477', NULL, 'Peptidases_S8_Subtilisin_subset', NULL, NULL, 'Peptidases_S8_Subtilisin_subset', 12420),
(12421, 'cd08997', NULL, 'GH68', NULL, NULL, 'GH68', 12421),
(12422, 'cd16674', NULL, 'RING-H2_RNF12', NULL, NULL, 'RING-H2_RNF12', 12422),
(12423, 'cd00588', NULL, 'CheW_like', NULL, NULL, 'CheW_like', 12423),
(12424, 'cd00363', NULL, 'PFK', NULL, NULL, 'PFK', 12424),
(12425, 'cd05350', NULL, 'SDR_c6', NULL, NULL, 'SDR_c6', 12425),
(12426, 'cd08408', NULL, 'C2B_Synaptotagmin-14_16', NULL, NULL, 'C2B_Synaptotagmin-14_16', 12426),
(12427, 'cd03451', NULL, 'FkbR2', NULL, NULL, 'FkbR2', 12427),
(12428, 'cd06535', NULL, 'CIDE_N_CAD', NULL, NULL, 'CIDE_N_CAD', 12428),
(12429, 'cd13139', NULL, 'MATE_like_14', NULL, NULL, 'MATE_like_14', 12429),
(12430, 'cd12671', NULL, 'RRM_CSTF2_CSTF2T', NULL, NULL, 'RRM_CSTF2_CSTF2T', 12430),
(12431, 'cd13382', NULL, 'PH_OCRL1', NULL, NULL, 'PH_OCRL1', 12431),
(12432, 'cd14612', NULL, 'PTPc-N7', NULL, NULL, 'PTPc-N7', 12432),
(12433, 'cd18503', NULL, 'BACK_calicin', NULL, NULL, 'BACK_calicin', 12433),
(12434, 'cd15140', NULL, '7tmA_PGD2', NULL, NULL, '7tmA_PGD2', 12434),
(12435, 'cd03726', NULL, 'SOCS_ASB7', NULL, NULL, 'SOCS_ASB7', 12435),
(12436, 'cd14897', NULL, 'MYSc_Myo36', NULL, NULL, 'MYSc_Myo36', 12436),
(12437, 'cd09655', NULL, 'CasRa_I-A', NULL, NULL, 'CasRa_I-A', 12437),
(12438, 'cd17582', NULL, 'psREC_PRR', NULL, NULL, 'psREC_PRR', 12438),
(12439, 'cd12576', NULL, 'RRM1_MSI', NULL, NULL, 'RRM1_MSI', 12439),
(12440, 'cd06992', NULL, 'cupin_GDO-like_C', NULL, NULL, 'cupin_GDO-like_C', 12440);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(12441, 'cd09168', NULL, 'PLDc_PaPPK1_C2_like', NULL, NULL, 'PLDc_PaPPK1_C2_like', 12441),
(12442, 'cd19134', NULL, 'AKR_AKR5H1', NULL, NULL, 'AKR_AKR5H1', 12442),
(12443, 'cd15487', NULL, 'bS6_chloro_cyano', NULL, NULL, 'bS6_chloro_cyano', 12443),
(12444, 'cd18438', NULL, 'BRCT_BRC1_like_rpt4', NULL, NULL, 'BRCT_BRC1_like_rpt4', 12444),
(12445, 'cd11643', NULL, 'Precorrin-6A-synthase', NULL, NULL, 'Precorrin-6A-synthase', 12445),
(12446, 'cd18740', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, 'PIN_VapC4-5_FitB-like', 12446),
(12447, 'cd16350', NULL, 'VOC_like', NULL, NULL, 'VOC_like', 12447),
(12448, 'cd01447', NULL, 'Polysulfide_ST', NULL, NULL, 'Polysulfide_ST', 12448),
(12449, 'cd18923', NULL, 'bHLHzip_USF2', NULL, NULL, 'bHLHzip_USF2', 12449),
(12450, 'cd01720', NULL, 'Sm_D2', NULL, NULL, 'Sm_D2', 12450),
(12451, 'cd06304', NULL, 'PBP1_BmpA_Med_PnrA-like', NULL, NULL, 'PBP1_BmpA_Med_PnrA-like', 12451),
(12452, 'cd16197', NULL, 'EFh_PEF_CalpC', NULL, NULL, 'EFh_PEF_CalpC', 12452),
(12453, 'cd01266', NULL, 'PH_Gab1_Gab2', NULL, NULL, 'PH_Gab1_Gab2', 12453),
(12454, 'cd19127', NULL, 'AKR_AKR5B1', NULL, NULL, 'AKR_AKR5B1', 12454),
(12455, 'cd11916', NULL, 'SH3_Sorbs1_3', NULL, NULL, 'SH3_Sorbs1_3', 12455),
(12456, 'cd11451', NULL, 'bHLH_AtTT8_like', NULL, NULL, 'bHLH_AtTT8_like', 12456),
(12457, 'cd11950', NULL, 'SH3_GRAP2_C', NULL, NULL, 'SH3_GRAP2_C', 12457),
(12458, 'cd09550', NULL, 'SAM_EPH-A8', NULL, NULL, 'SAM_EPH-A8', 12458),
(12459, 'cd00019', NULL, 'AP2Ec', NULL, NULL, 'AP2Ec', 12459),
(12460, 'cd11829', NULL, 'SH3_GAS7', NULL, NULL, 'SH3_GAS7', 12460),
(12461, 'cd10747', NULL, 'DnaJ_C', NULL, NULL, 'DnaJ_C', 12461),
(12462, 'cd15627', NULL, 'PHD_BAZ1A', NULL, NULL, 'PHD_BAZ1A', 12462),
(12463, 'cd20073', NULL, 'SET_SUV39H_Clr4-like', NULL, NULL, 'SET_SUV39H_Clr4-like', 12463),
(12464, 'cd06812', NULL, 'PLPDE_III_DSD_D-TA_like_1', NULL, NULL, 'PLPDE_III_DSD_D-TA_like_1', 12464),
(12465, 'cd10010', NULL, 'HDAC1', NULL, NULL, 'HDAC1', 12465),
(12466, 'cd15433', NULL, '7tmA_OR2Y-like', NULL, NULL, '7tmA_OR2Y-like', 12466),
(12467, 'cd19563', NULL, 'serpinB3_B4_SCCA1_2', NULL, NULL, 'serpinB3_B4_SCCA1_2', 12467),
(12468, 'cd06071', NULL, 'Beach', NULL, NULL, 'Beach', 12468),
(12469, 'cd06414', NULL, 'GH25_LytC-like', NULL, NULL, 'GH25_LytC-like', 12469),
(12470, 'cd15733', NULL, 'FYVE_MTMR4', NULL, NULL, 'FYVE_MTMR4', 12470),
(12471, 'cd08212', NULL, 'RuBisCO_large_I', NULL, NULL, 'RuBisCO_large_I', 12471),
(12472, 'cd15099', NULL, '7tmA_Cannabinoid_R', NULL, NULL, '7tmA_Cannabinoid_R', 12472),
(12473, 'cd02896', NULL, 'complement_C3_C4_C5', NULL, NULL, 'complement_C3_C4_C5', 12473),
(12474, 'cd15846', NULL, 'SNARE_syntaxin17', NULL, NULL, 'SNARE_syntaxin17', 12474),
(12475, 'cd20224', NULL, 'PFM_alpha-toxin-like', NULL, NULL, 'PFM_alpha-toxin-like', 12475),
(12476, 'cd08447', NULL, 'PBP2_LTTR_aromatics_like_1', NULL, NULL, 'PBP2_LTTR_aromatics_like_1', 12476),
(12477, 'cd15659', NULL, 'PHD5_NSD1', NULL, NULL, 'PHD5_NSD1', 12477),
(12478, 'cd12351', NULL, 'RRM4_SHARP', NULL, NULL, 'RRM4_SHARP', 12478),
(12479, 'cd05008', NULL, 'SIS_GlmS_GlmD_1', NULL, NULL, 'SIS_GlmS_GlmD_1', 12479),
(12480, 'cd12762', NULL, 'RRM1_hnRNPA2B1', NULL, NULL, 'RRM1_hnRNPA2B1', 12480),
(12481, 'cd02215', NULL, 'cupin_QDO_N_C', NULL, NULL, 'cupin_QDO_N_C', 12481),
(12482, 'cd18654', NULL, 'CSD_HP1beta_Cbx1', NULL, NULL, 'CSD_HP1beta_Cbx1', 12482),
(12483, 'cd07185', NULL, 'OmpA_C-like', NULL, NULL, 'OmpA_C-like', 12483),
(12484, 'cd15096', NULL, '7tmA_AstA_R_insect', NULL, NULL, '7tmA_AstA_R_insect', 12484),
(12485, 'cd11411', NULL, 'bHLH_TS_MRF', NULL, NULL, 'bHLH_TS_MRF', 12485),
(12486, 'cd19925', NULL, 'REC_citrate_TCS', NULL, NULL, 'REC_citrate_TCS', 12486),
(12487, 'cd02174', NULL, 'CCT', NULL, NULL, 'CCT', 12487),
(12488, 'cd08422', NULL, 'PBP2_CrgA_like', NULL, NULL, 'PBP2_CrgA_like', 12488),
(12489, 'cd15690', NULL, 'PHD1_DPF1', NULL, NULL, 'PHD1_DPF1', 12489),
(12490, 'cd04767', NULL, 'HTH_HspR-like_MBC', NULL, NULL, 'HTH_HspR-like_MBC', 12490),
(12491, 'cd14365', NULL, 'CUE_N4BP2', NULL, NULL, 'CUE_N4BP2', 12491);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(12492, 'cd01131', NULL, 'PilT', NULL, NULL, 'PilT', 12492),
(12493, 'cd08769', NULL, 'DAP_dppA_2', NULL, NULL, 'DAP_dppA_2', 12493),
(12494, 'cd11775', NULL, 'SH3_Sla1p_3', NULL, NULL, 'SH3_Sla1p_3', 12494),
(12495, 'cd08757', NULL, 'SAM_PNT_ESE', NULL, NULL, 'SAM_PNT_ESE', 12495),
(12496, 'cd07415', NULL, 'MPP_PP2A_PP4_PP6', NULL, NULL, 'MPP_PP2A_PP4_PP6', 12496),
(12497, 'cd15352', NULL, '7tmA_MC3R', NULL, NULL, '7tmA_MC3R', 12497),
(12498, 'cd18674', NULL, 'PIN_Pox_G5', NULL, NULL, 'PIN_Pox_G5', 12498),
(12499, 'cd00522', NULL, 'Hemerythrin-like', NULL, NULL, 'Hemerythrin-like', 12499),
(12500, 'cd08002', NULL, 'WGR_PARP3_like', NULL, NULL, 'WGR_PARP3_like', 12500),
(12501, 'cd12525', NULL, 'RRM1_MEI2_fungi', NULL, NULL, 'RRM1_MEI2_fungi', 12501),
(12502, 'cd07737', NULL, 'YcbL-like_MBL-fold', NULL, NULL, 'YcbL-like_MBL-fold', 12502),
(12503, 'cd06489', NULL, 'p23_CS_hSgt1_like', NULL, NULL, 'p23_CS_hSgt1_like', 12503),
(12504, 'sd00001', NULL, 'TSP3', NULL, NULL, 'TSP3', 12504),
(12505, 'cd19824', NULL, 'Bbox2_TRIM2_C-VII', NULL, NULL, 'Bbox2_TRIM2_C-VII', 12505),
(12506, 'cd16915', NULL, 'HATPase_DpiB-CitA-like', NULL, NULL, 'HATPase_DpiB-CitA-like', 12506),
(12507, 'cd19111', NULL, 'AKR_AKR1G1_1I', NULL, NULL, 'AKR_AKR1G1_1I', 12507),
(12508, 'cd09823', NULL, 'peroxinectin_like', NULL, NULL, 'peroxinectin_like', 12508),
(12509, 'cd09666', NULL, 'Cas8a2_I-A', NULL, NULL, 'Cas8a2_I-A', 12509),
(12510, 'cd13949', NULL, '7tm_V1R_pheromone', NULL, NULL, '7tm_V1R_pheromone', 12510),
(12511, 'cd06258', NULL, 'M3_like', NULL, NULL, 'M3_like', 12511),
(12512, 'cd14513', NULL, 'DSP_slingshot', NULL, NULL, 'DSP_slingshot', 12512),
(12513, 'cd13877', NULL, 'CuRO_2_Fet3p_like', NULL, NULL, 'CuRO_2_Fet3p_like', 12513),
(12514, 'cd09023', NULL, 'Aldose_epim_Ec_c4013', NULL, NULL, 'Aldose_epim_Ec_c4013', 12514),
(12515, 'cd09350', NULL, 'LIM1_TRIP6', NULL, NULL, 'LIM1_TRIP6', 12515),
(12516, 'cd09095', NULL, 'INPP5c_INPP5E-like', NULL, NULL, 'INPP5c_INPP5E-like', 12516),
(12517, 'cd08712', NULL, 'RGS_RGS18', NULL, NULL, 'RGS_RGS18', 12517),
(12518, 'cd03774', NULL, 'MATH_SPOP', NULL, NULL, 'MATH_SPOP', 12518),
(12519, 'cd12784', NULL, 'RRM2_ROD1', NULL, NULL, 'RRM2_ROD1', 12519),
(12520, 'cd07620', NULL, 'BAR_SH3BP1', NULL, NULL, 'BAR_SH3BP1', 12520),
(12521, 'cd03402', NULL, 'SPFH_like_u2', NULL, NULL, 'SPFH_like_u2', 12521),
(12522, 'cd05341', NULL, '3beta-17beta-HSD_like_SDR_c', NULL, NULL, '3beta-17beta-HSD_like_SDR_c', 12522),
(12523, 'cd01321', NULL, 'ADGF', NULL, NULL, 'ADGF', 12523),
(12524, 'cd11609', NULL, 'MCT1_N', NULL, NULL, 'MCT1_N', 12524),
(12525, 'cd00670', NULL, 'Gly_His_Pro_Ser_Thr_tRS_core', NULL, NULL, 'Gly_His_Pro_Ser_Thr_tRS_core', 12525),
(12526, 'cd00674', NULL, 'LysRS_core_class_I', NULL, NULL, 'LysRS_core_class_I', 12526),
(12527, 'cd08807', NULL, 'CARD_CARD10_CARMA3', NULL, NULL, 'CARD_CARD10_CARMA3', 12527),
(12528, 'cd15682', NULL, 'PHD_ING1', NULL, NULL, 'PHD_ING1', 12528),
(12529, 'cd03788', NULL, 'GT20_TPS', NULL, NULL, 'GT20_TPS', 12529),
(12530, 'cd06589', NULL, 'GH31', NULL, NULL, 'GH31', 12530),
(12531, 'cd11365', NULL, 'RNase_PH_archRRP42', NULL, NULL, 'RNase_PH_archRRP42', 12531),
(12532, 'cd00595', NULL, 'NDPk', NULL, NULL, 'NDPk', 12532),
(12533, 'cd05618', NULL, 'STKc_aPKC_iota', NULL, NULL, 'STKc_aPKC_iota', 12533),
(12534, 'cd03283', NULL, 'ABC_MutS-like', NULL, NULL, 'ABC_MutS-like', 12534),
(12535, 'cd09094', NULL, 'INPP5c_INPP5J-like', NULL, NULL, 'INPP5c_INPP5J-like', 12535),
(12536, 'cd08032', NULL, 'LARP_7', NULL, NULL, 'LARP_7', 12536),
(12537, 'cd03880', NULL, 'M28_QC_like', NULL, NULL, 'M28_QC_like', 12537),
(12538, 'cd18099', NULL, 'Trm10arch', NULL, NULL, 'Trm10arch', 12538),
(12539, 'cd21159', NULL, 'XendoU', NULL, NULL, 'XendoU', 12539),
(12540, 'cd17047', NULL, 'Ubl_UBFD1', NULL, NULL, 'Ubl_UBFD1', 12540),
(12541, 'cd00498', NULL, 'Hsp33', NULL, NULL, 'Hsp33', 12541),
(12542, 'cd11516', NULL, 'SLC6sbd_B0AT1', NULL, NULL, 'SLC6sbd_B0AT1', 12542),
(12543, 'cd07893', NULL, 'OBF_DNA_ligase', NULL, NULL, 'OBF_DNA_ligase', 12543),
(12544, 'cd14405', NULL, 'UBA_MARK1', NULL, NULL, 'UBA_MARK1', 12544);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(12545, 'cd12953', NULL, 'MMP_TTHA0227', NULL, NULL, 'MMP_TTHA0227', 12545),
(12546, 'cd16472', NULL, 'RING-H2_RNF38_like', NULL, NULL, 'RING-H2_RNF38_like', 12546),
(12547, 'cd03155', NULL, 'CD151_like_LEL', NULL, NULL, 'CD151_like_LEL', 12547),
(12548, 'cd19562', NULL, 'serpinB2_PAI-2', NULL, NULL, 'serpinB2_PAI-2', 12548),
(12549, 'cd02396', NULL, 'PCBP_like_KH', NULL, NULL, 'PCBP_like_KH', 12549),
(12550, 'cd17718', NULL, 'BRCT_TopBP1_rpt3', NULL, NULL, 'BRCT_TopBP1_rpt3', 12550),
(12551, 'cd12822', NULL, 'TmCorA-like', NULL, NULL, 'TmCorA-like', 12551),
(12552, 'cd19358', NULL, 'TenA_E_Spr0628-like', NULL, NULL, 'TenA_E_Spr0628-like', 12552),
(12553, 'cd15715', NULL, 'ePHD_JMJD2C', NULL, NULL, 'ePHD_JMJD2C', 12553),
(12554, 'cd05469', NULL, 'Transthyretin_like', NULL, NULL, 'Transthyretin_like', 12554),
(12555, 'cd07366', NULL, '3MGA_Dioxygenase', NULL, NULL, '3MGA_Dioxygenase', 12555),
(12556, 'cd07822', NULL, 'SRPBCC_4', NULL, NULL, 'SRPBCC_4', 12556),
(12557, 'cd15059', NULL, '7tmA_alpha2_AR', NULL, NULL, '7tmA_alpha2_AR', 12557),
(12558, 'cd18335', NULL, 'BTB_POZ_KLHL1', NULL, NULL, 'BTB_POZ_KLHL1', 12558),
(12559, 'cd17656', NULL, 'A_NRPS_ProA', NULL, NULL, 'A_NRPS_ProA', 12559),
(12560, 'cd20002', NULL, 'PBP1_LsrB_Quorum_Sensing-like', NULL, NULL, 'PBP1_LsrB_Quorum_Sensing-like', 12560),
(12561, 'cd06131', NULL, 'DNA_pol_III_epsilon_Ecoli_like', NULL, NULL, 'DNA_pol_III_epsilon_Ecoli_like', 12561),
(12562, 'cd06202', NULL, 'Nitric_oxide_synthase', NULL, NULL, 'Nitric_oxide_synthase', 12562),
(12563, 'cd01911', NULL, 'proteasome_alpha', NULL, NULL, 'proteasome_alpha', 12563),
(12564, 'cd11923', NULL, 'SH3_Sorbs2_2', NULL, NULL, 'SH3_Sorbs2_2', 12564),
(12565, 'cd19949', NULL, 'PDH1_Fer2_BFD-like', NULL, NULL, 'PDH1_Fer2_BFD-like', 12565),
(12566, 'cd01643', NULL, 'Bacterial_IMPase_like_2', NULL, NULL, 'Bacterial_IMPase_like_2', 12566),
(12567, 'cd09609', NULL, 'M3B_PepF', NULL, NULL, 'M3B_PepF', 12567),
(12568, 'cd16224', NULL, 'EFh_CREC_RCN2', NULL, NULL, 'EFh_CREC_RCN2', 12568),
(12569, 'cd03806', NULL, 'GT4_ALG11-like', NULL, NULL, 'GT4_ALG11-like', 12569),
(12570, 'cd18652', NULL, 'CD_HP1gamma_Cbx3', NULL, NULL, 'CD_HP1gamma_Cbx3', 12570),
(12571, 'cd21667', NULL, 'gammaCoV_Nsp5_Mpro', NULL, NULL, 'gammaCoV_Nsp5_Mpro', 12571),
(12572, 'cd17741', NULL, 'BRCT_nibrin', NULL, NULL, 'BRCT_nibrin', 12572),
(12573, 'cd18757', NULL, 'PIN_MtVapC3-like', NULL, NULL, 'PIN_MtVapC3-like', 12573),
(12574, 'cd08892', NULL, 'SRPBCC_Aha1', NULL, NULL, 'SRPBCC_Aha1', 12574),
(12575, 'cd00275', NULL, 'C2_PLC_like', NULL, NULL, 'C2_PLC_like', 12575),
(12576, 'cd02566', NULL, 'PseudoU_synth_RluE', NULL, NULL, 'PseudoU_synth_RluE', 12576),
(12577, 'cd09871', NULL, 'PIN_MtVapC28-VapC30-like', NULL, NULL, 'PIN_MtVapC28-VapC30-like', 12577),
(12578, 'cd03441', NULL, 'R_hydratase_like', NULL, NULL, 'R_hydratase_like', 12578),
(12579, 'cd17987', NULL, 'DEXHc_YTHDC2', NULL, NULL, 'DEXHc_YTHDC2', 12579),
(12580, 'cd18296', NULL, 'BTB2_POZ_ABTB1_BPOZ1', NULL, NULL, 'BTB2_POZ_ABTB1_BPOZ1', 12580),
(12581, 'cd19438', NULL, 'lipocalin_Blc-like', NULL, NULL, 'lipocalin_Blc-like', 12581),
(12582, 'cd17479', NULL, 'MFS_MFSD6L', NULL, NULL, 'MFS_MFSD6L', 12582),
(12583, 'cd12833', NULL, 'ZntB-like_1', NULL, NULL, 'ZntB-like_1', 12583),
(12584, 'cd11956', NULL, 'SH3_srGAP4', NULL, NULL, 'SH3_srGAP4', 12584),
(12585, 'cd13411', NULL, 'TNFRSF11A', NULL, NULL, 'TNFRSF11A', 12585),
(12586, 'cd17216', NULL, 'RA_Myosin-IXa', NULL, NULL, 'RA_Myosin-IXa', 12586),
(12587, 'cd09197', NULL, 'PLDc_pPLDalpha_1', NULL, NULL, 'PLDc_pPLDalpha_1', 12587),
(12588, 'cd08721', NULL, 'RGS_AKAP2_2', NULL, NULL, 'RGS_AKAP2_2', 12588),
(12589, 'cd11734', NULL, 'Ssq1_like_NBD', NULL, NULL, 'Ssq1_like_NBD', 12589),
(12590, 'cd18640', NULL, 'CD_Chro-like', NULL, NULL, 'CD_Chro-like', 12590),
(12591, 'cd08645', NULL, 'FMT_core_GART', NULL, NULL, 'FMT_core_GART', 12591),
(12592, 'cd05770', NULL, 'IgC_beta2m', NULL, NULL, 'IgC_beta2m', 12592),
(12593, 'cd15744', NULL, 'FYVE_RUFY3', NULL, NULL, 'FYVE_RUFY3', 12593),
(12594, 'cd18118', NULL, 'ATP-synt_V_A-type_beta_N', NULL, NULL, 'ATP-synt_V_A-type_beta_N', 12594);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(12595, 'cd02768', NULL, 'MopB_NADH-Q-OR-NuoG2', NULL, NULL, 'MopB_NADH-Q-OR-NuoG2', 12595),
(12596, 'cd15694', NULL, 'ePHD_KMT2B', NULL, NULL, 'ePHD_KMT2B', 12596),
(12597, 'cd13835', NULL, 'IHF_A', NULL, NULL, 'IHF_A', 12597),
(12598, 'cd19076', NULL, 'AKR_AKR13A_13D', NULL, NULL, 'AKR_AKR13A_13D', 12598),
(12599, 'cd15091', NULL, '7tmA_Kappa_opioid_R', NULL, NULL, '7tmA_Kappa_opioid_R', 12599),
(12600, 'cd04768', NULL, 'HTH_BmrR-like', NULL, NULL, 'HTH_BmrR-like', 12600),
(12601, 'cd00241', NULL, 'DOMON_like', NULL, NULL, 'DOMON_like', 12601),
(12602, 'cd14390', NULL, 'UBA_II_E2_UBE2K', NULL, NULL, 'UBA_II_E2_UBE2K', 12602),
(12603, 'cd03127', NULL, 'tetraspanin_LEL', NULL, NULL, 'tetraspanin_LEL', 12603),
(12604, 'cd20267', NULL, 'Complex1_LYR_LYRM7', NULL, NULL, 'Complex1_LYR_LYRM7', 12604),
(12605, 'cd14336', NULL, 'UBA_AID_AMPKalpha', NULL, NULL, 'UBA_AID_AMPKalpha', 12605),
(12606, 'cd00545', NULL, 'MCH', NULL, NULL, 'MCH', 12606),
(12607, 'cd15025', NULL, '7tm_TAS2R38', NULL, NULL, '7tm_TAS2R38', 12607),
(12608, 'cd15302', NULL, '7tmA_mAChR_GAR-2-like', NULL, NULL, '7tmA_mAChR_GAR-2-like', 12608),
(12609, 'cd18084', NULL, 'RsmE-like', NULL, NULL, 'RsmE-like', 12609),
(12610, 'cd07616', NULL, 'BAR_Endophilin_B1', NULL, NULL, 'BAR_Endophilin_B1', 12610),
(12611, 'cd11467', NULL, 'bHLH_E-protein_Da_like', NULL, NULL, 'bHLH_E-protein_Da_like', 12611),
(12612, 'cd02978', NULL, 'KaiB_like', NULL, NULL, 'KaiB_like', 12612),
(12613, 'cd00915', NULL, 'MD-1_MD-2', NULL, NULL, 'MD-1_MD-2', 12613),
(12614, 'cd00427', NULL, 'Ribosomal_L29_HIP', NULL, NULL, 'Ribosomal_L29_HIP', 12614),
(12615, 'cd00489', NULL, 'Barstar_like', NULL, NULL, 'Barstar_like', 12615),
(12616, 'cd07651', NULL, 'F-BAR_PombeCdc15_like', NULL, NULL, 'F-BAR_PombeCdc15_like', 12616),
(12617, 'cd13726', NULL, 'PBP2_iGluR_AMPA_GluR2', NULL, NULL, 'PBP2_iGluR_AMPA_GluR2', 12617),
(12618, 'cd01182', NULL, 'INT_RitC_C_like', NULL, NULL, 'INT_RitC_C_like', 12618),
(12619, 'cd07406', NULL, 'MPP_CG11883_N', NULL, NULL, 'MPP_CG11883_N', 12619),
(12620, 'cd14315', NULL, 'UBA1_UBAP1', NULL, NULL, 'UBA1_UBAP1', 12620),
(12621, 'cd14820', NULL, 'TRAX', NULL, NULL, 'TRAX', 12621),
(12622, 'cd02801', NULL, 'DUS_like_FMN', NULL, NULL, 'DUS_like_FMN', 12622),
(12623, 'cd05101', NULL, 'PTKc_FGFR2', NULL, NULL, 'PTKc_FGFR2', 12623),
(12624, 'cd09416', NULL, 'LIM2_Testin', NULL, NULL, 'LIM2_Testin', 12624),
(12625, 'cd16562', NULL, 'RING-HC_RNF219', NULL, NULL, 'RING-HC_RNF219', 12625),
(12626, 'cd18721', NULL, 'PIN_ZNF451-like', NULL, NULL, 'PIN_ZNF451-like', 12626),
(12627, 'cd00223', NULL, 'TOPRIM_TopoIIB_SPO', NULL, NULL, 'TOPRIM_TopoIIB_SPO', 12627),
(12628, 'cd16899', NULL, 'LYZ_C_invert', NULL, NULL, 'LYZ_C_invert', 12628),
(12629, 'cd02082', NULL, 'P-type_ATPase_cation', NULL, NULL, 'P-type_ATPase_cation', 12629),
(12630, 'cd17407', NULL, 'MFS_MFSD11', NULL, NULL, 'MFS_MFSD11', 12630),
(12631, 'cd16232', NULL, 'EFh_SPARC_TICN', NULL, NULL, 'EFh_SPARC_TICN', 12631),
(12632, 'cd11683', NULL, 'HDAC10', NULL, NULL, 'HDAC10', 12632),
(12633, 'cd15112', NULL, '7tmA_MrgprE', NULL, NULL, '7tmA_MrgprE', 12633),
(12634, 'cd18177', NULL, 'ATP-synt_Vo_c_ATP6F_rpt1', NULL, NULL, 'ATP-synt_Vo_c_ATP6F_rpt1', 12634),
(12635, 'cd07142', NULL, 'ALDH_F2BC', NULL, NULL, 'ALDH_F2BC', 12635),
(12636, 'cd18993', NULL, 'LGIC_ECD_GluCl', NULL, NULL, 'LGIC_ECD_GluCl', 12636),
(12637, 'cd01472', NULL, 'vWA_collagen', NULL, NULL, 'vWA_collagen', 12637),
(12638, 'cd10470', NULL, 'FAM20B_C', NULL, NULL, 'FAM20B_C', 12638),
(12639, 'cd17326', NULL, 'MFS_MFSD8', NULL, NULL, 'MFS_MFSD8', 12639),
(12640, 'cd13304', NULL, 'PH2-like_Rtt106', NULL, NULL, 'PH2-like_Rtt106', 12640),
(12641, 'cd02026', NULL, 'PRK', NULL, NULL, 'PRK', 12641),
(12642, 'cd07840', NULL, 'STKc_CDK9_like', NULL, NULL, 'STKc_CDK9_like', 12642),
(12643, 'cd03694', NULL, 'GTPBP_II', NULL, NULL, 'GTPBP_II', 12643),
(12644, 'cd06311', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, 'PBP1_ABC_sugar_binding-like', 12644),
(12645, 'cd05658', NULL, 'M18_DAP', NULL, NULL, 'M18_DAP', 12645),
(12646, 'cd10390', NULL, 'SH2_SHD', NULL, NULL, 'SH2_SHD', 12646);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(12647, 'cd15597', NULL, 'PHD3_KMT2D', NULL, NULL, 'PHD3_KMT2D', 12647),
(12648, 'cd13228', NULL, 'PHear_NECAP', NULL, NULL, 'PHear_NECAP', 12648),
(12649, 'cd12241', NULL, 'RRM_SF3B14', NULL, NULL, 'RRM_SF3B14', 12649),
(12650, 'cd14634', NULL, 'R-PTPc-T-2', NULL, NULL, 'R-PTPc-T-2', 12650),
(12651, 'cd03457', NULL, 'intradiol_dioxygenase_like', NULL, NULL, 'intradiol_dioxygenase_like', 12651),
(12652, 'cd11727', NULL, 'ADDz_Dnmt3l', NULL, NULL, 'ADDz_Dnmt3l', 12652),
(12653, 'cd12873', NULL, 'SPRY_DDX1', NULL, NULL, 'SPRY_DDX1', 12653),
(12654, 'cd00653', NULL, 'RNA_pol_B_RPB2', NULL, NULL, 'RNA_pol_B_RPB2', 12654),
(12655, 'cd04322', NULL, 'LysRS_N', NULL, NULL, 'LysRS_N', 12655),
(12656, 'cd09100', NULL, 'INPP5c_SHIP1-INPP5D', NULL, NULL, 'INPP5c_SHIP1-INPP5D', 12656),
(12657, 'cd10552', NULL, 'TH_beta_N', NULL, NULL, 'TH_beta_N', 12657),
(12658, 'cd18670', NULL, 'PIN_Mut7-C-like', NULL, NULL, 'PIN_Mut7-C-like', 12658),
(12659, 'cd14192', NULL, 'STKc_MLCK3', NULL, NULL, 'STKc_MLCK3', 12659),
(12660, 'cd02189', NULL, 'delta_zeta_tubulin-like', NULL, NULL, 'delta_zeta_tubulin-like', 12660),
(12661, 'cd06480', NULL, 'ACD_HspB8_like', NULL, NULL, 'ACD_HspB8_like', 12661),
(12662, 'cd13847', NULL, 'CuRO_1_AAO_like_2', NULL, NULL, 'CuRO_1_AAO_like_2', 12662),
(12663, 'cd14183', NULL, 'STKc_DCKL1', NULL, NULL, 'STKc_DCKL1', 12663),
(12664, 'cd09755', NULL, 'Cas2_I-E', NULL, NULL, 'Cas2_I-E', 12664),
(12665, 'cd19903', NULL, 'DSRM_EIF2AK2_rpt1', NULL, NULL, 'DSRM_EIF2AK2_rpt1', 12665),
(12666, 'cd10442', NULL, 'GIY-YIG_PLEs', NULL, NULL, 'GIY-YIG_PLEs', 12666),
(12667, 'cd13526', NULL, 'PBP2_lipoprotein_MetQ_like', NULL, NULL, 'PBP2_lipoprotein_MetQ_like', 12667),
(12668, 'cd07529', NULL, 'HAD_AtGPP-like', NULL, NULL, 'HAD_AtGPP-like', 12668),
(12669, 'cd10793', NULL, 'GH57N_TLGT_like', NULL, NULL, 'GH57N_TLGT_like', 12669),
(12670, 'cd06854', NULL, 'GT_WbpL_WbcO_like', NULL, NULL, 'GT_WbpL_WbcO_like', 12670),
(12671, 'cd14221', NULL, 'STKc_LIMK1', NULL, NULL, 'STKc_LIMK1', 12671),
(12672, 'cd01178', NULL, 'IPT_NFAT', NULL, NULL, 'IPT_NFAT', 12672),
(12673, 'cd05263', NULL, 'MupV_like_SDR_e', NULL, NULL, 'MupV_like_SDR_e', 12673),
(12674, 'cd07765', NULL, 'KRAB_A-box', NULL, NULL, 'KRAB_A-box', 12674),
(12675, 'cd06305', NULL, 'PBP1_methylthioribose_binding-like', NULL, NULL, 'PBP1_methylthioribose_binding-like', 12675),
(12676, 'cd15085', NULL, '7tmA_Parietopsin', NULL, NULL, '7tmA_Parietopsin', 12676),
(12677, 'cd02964', NULL, 'TryX_like_family', NULL, NULL, 'TryX_like_family', 12677),
(12678, 'cd04303', NULL, 'HAD_PGPase', NULL, NULL, 'HAD_PGPase', 12678),
(12679, 'cd15403', NULL, '7tmA_GPR45', NULL, NULL, '7tmA_GPR45', 12679),
(12680, 'cd19400', NULL, 'TGF_beta_BMP9', NULL, NULL, 'TGF_beta_BMP9', 12680),
(12681, 'cd09577', NULL, 'SAM_Ph1,2,3', NULL, NULL, 'SAM_Ph1,2,3', 12681),
(12682, 'cd21653', NULL, 'ORF4b_HKU5-CoV', NULL, NULL, 'ORF4b_HKU5-CoV', 12682),
(12683, 'cd14145', NULL, 'STKc_MLK1', NULL, NULL, 'STKc_MLK1', 12683),
(12684, 'cd18115', NULL, 'ATP-synt_F1_beta_N', NULL, NULL, 'ATP-synt_F1_beta_N', 12684),
(12685, 'cd15614', NULL, 'PHD_HAC_like', NULL, NULL, 'PHD_HAC_like', 12685),
(12686, 'cd14201', NULL, 'STKc_ULK2', NULL, NULL, 'STKc_ULK2', 12686),
(12687, 'cd12949', NULL, 'NOPS_PSPC1', NULL, NULL, 'NOPS_PSPC1', 12687),
(12688, 'cd08663', NULL, 'DAP_dppA_1', NULL, NULL, 'DAP_dppA_1', 12688),
(12689, 'cd13128', NULL, 'MATE_Wzx_like', NULL, NULL, 'MATE_Wzx_like', 12689),
(12690, 'cd03894', NULL, 'M20_ArgE', NULL, NULL, 'M20_ArgE', 12690),
(12691, 'cd19847', NULL, 'Bbox1_TIF1g_C-VI', NULL, NULL, 'Bbox1_TIF1g_C-VI', 12691),
(12692, 'cd04160', NULL, 'Arfrp1', NULL, NULL, 'Arfrp1', 12692),
(12693, 'cd06410', NULL, 'PB1_UP2', NULL, NULL, 'PB1_UP2', 12693),
(12694, 'cd06183', NULL, 'cyt_b5_reduct_like', NULL, NULL, 'cyt_b5_reduct_like', 12694),
(12695, 'cd01155', NULL, 'ACAD_FadE2', NULL, NULL, 'ACAD_FadE2', 12695),
(12696, 'cd08529', NULL, 'STKc_FA2-like', NULL, NULL, 'STKc_FA2-like', 12696),
(12697, 'cd17501', NULL, 'RMtype1_S_Vch69ORF1407P_TRD2-CR2_like', NULL, NULL, 'RMtype1_S_Vch69ORF1407P_TRD2-CR2_like', 12697);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(12698, 'cd02146', NULL, 'NfsA-like', NULL, NULL, 'NfsA-like', 12698),
(12699, 'cd09943', NULL, 'SH2_Nck_family', NULL, NULL, 'SH2_Nck_family', 12699),
(12700, 'cd00217', NULL, 'INT_Flp_C', NULL, NULL, 'INT_Flp_C', 12700),
(12701, 'cd20217', NULL, 'PFM_agglutinin-like', NULL, NULL, 'PFM_agglutinin-like', 12701),
(12702, 'cd06620', NULL, 'PKc_Byr1_like', NULL, NULL, 'PKc_Byr1_like', 12702),
(12703, 'cd15104', NULL, '7tmA_GPR119_R_insulinotropic_receptor', NULL, NULL, '7tmA_GPR119_R_insulinotropic_receptor', 12703),
(12704, 'cd18398', NULL, 'BTB_POZ_KCTD16', NULL, NULL, 'BTB_POZ_KCTD16', 12704),
(12705, 'cd18996', NULL, 'LGIC_ECD_5-HT3', NULL, NULL, 'LGIC_ECD_5-HT3', 12705),
(12706, 'cd11732', NULL, 'HSP105-110_like_NBD', NULL, NULL, 'HSP105-110_like_NBD', 12706),
(12707, 'cd10432', NULL, 'BI-1-like_bacterial', NULL, NULL, 'BI-1-like_bacterial', 12707),
(12708, 'cd16324', NULL, 'LolA_fold-like', NULL, NULL, 'LolA_fold-like', 12708),
(12709, 'cd14572', NULL, 'DUSP14', NULL, NULL, 'DUSP14', 12709),
(12710, 'cd12915', NULL, 'PDC2_DGC_like', NULL, NULL, 'PDC2_DGC_like', 12710),
(12711, 'cd18373', NULL, 'BTB1_POZ_KCTD19', NULL, NULL, 'BTB1_POZ_KCTD19', 12711),
(12712, 'cd18420', NULL, 'BTB_POZ_Shal-like', NULL, NULL, 'BTB_POZ_Shal-like', 12712),
(12713, 'cd19211', NULL, 'SET_NSD2', NULL, NULL, 'SET_NSD2', 12713),
(12714, 'cd17257', NULL, 'RMtype1_S_EcoBI-TRD1-CR1_like', NULL, NULL, 'RMtype1_S_EcoBI-TRD1-CR1_like', 12714),
(12715, 'cd07099', NULL, 'ALDH_DDALDH', NULL, NULL, 'ALDH_DDALDH', 12715),
(12716, 'cd05147', NULL, 'RIO1_euk', NULL, NULL, 'RIO1_euk', 12716),
(12717, 'cd01749', NULL, 'GATase1_PB', NULL, NULL, 'GATase1_PB', 12717),
(12718, 'cd14247', NULL, 'Lmo2686_like', NULL, NULL, 'Lmo2686_like', 12718),
(12719, 'cd16794', NULL, 'dRING_RMD5A', NULL, NULL, 'dRING_RMD5A', 12719),
(12720, 'cd12253', NULL, 'RRM_PIN4_like', NULL, NULL, 'RRM_PIN4_like', 12720),
(12721, 'cd07442', NULL, 'CRD_SFRP4', NULL, NULL, 'CRD_SFRP4', 12721),
(12722, 'cd09276', NULL, 'Rnase_HI_RT_non_LTR', NULL, NULL, 'Rnase_HI_RT_non_LTR', 12722),
(12723, 'cd15033', NULL, '7tmF_FZD3', NULL, NULL, '7tmF_FZD3', 12723),
(12724, 'cd08344', NULL, 'MhqB_like_N', NULL, NULL, 'MhqB_like_N', 12724),
(12725, 'cd09858', NULL, 'PIN_MKT1', NULL, NULL, 'PIN_MKT1', 12725),
(12726, 'cd12678', NULL, 'RRM_SLTM', NULL, NULL, 'RRM_SLTM', 12726),
(12727, 'cd10311', NULL, 'PLDc_N_DEXD_c', NULL, NULL, 'PLDc_N_DEXD_c', 12727),
(12728, 'cd19722', NULL, 'bHLH_TS_NeuroD6_ATOH2', NULL, NULL, 'bHLH_TS_NeuroD6_ATOH2', 12728),
(12729, 'cd05677', NULL, 'M20_dipept_like_DUG2_type', NULL, NULL, 'M20_dipept_like_DUG2_type', 12729),
(12730, 'cd17288', NULL, 'RMtype1_S_LlaAI06ORF1089P_TRD1-CR1_like', NULL, NULL, 'RMtype1_S_LlaAI06ORF1089P_TRD1-CR1_like', 12730),
(12731, 'cd02733', NULL, 'RNAP_II_RPB1_N', NULL, NULL, 'RNAP_II_RPB1_N', 12731),
(12732, 'cd03742', NULL, 'SOCS_Rab40', NULL, NULL, 'SOCS_Rab40', 12732),
(12733, 'cd11326', NULL, 'AmyAc_Glg_debranch', NULL, NULL, 'AmyAc_Glg_debranch', 12733),
(12734, 'cd21665', NULL, 'alphaCoV_Nsp5_Mpro', NULL, NULL, 'alphaCoV_Nsp5_Mpro', 12734),
(12735, 'cd12890', NULL, 'SPRY_PRY_TRIM16', NULL, NULL, 'SPRY_PRY_TRIM16', 12735),
(12736, 'cd16478', NULL, 'RING-H2_Rapsyn', NULL, NULL, 'RING-H2_Rapsyn', 12736),
(12737, 'cd15928', NULL, '7tmA_GHSR-like', NULL, NULL, '7tmA_GHSR-like', 12737),
(12738, 'cd16431', NULL, 'IcmE', NULL, NULL, 'IcmE', 12738),
(12739, 'cd00886', NULL, 'MogA_MoaB', NULL, NULL, 'MogA_MoaB', 12739),
(12740, 'cd06528', NULL, 'RNAP_A''''', NULL, NULL, 'RNAP_A''''', 12740),
(12741, 'cd01531', NULL, 'Acr2p', NULL, NULL, 'Acr2p', 12741),
(12742, 'cd08756', NULL, 'RGS_GEF_like', NULL, NULL, 'RGS_GEF_like', 12742),
(12743, 'cd14932', NULL, 'MYSc_Myh18', NULL, NULL, 'MYSc_Myh18', 12743),
(12744, 'cd01011', NULL, 'nicotinamidase', NULL, NULL, 'nicotinamidase', 12744),
(12745, 'cd04694', NULL, 'Nudix_Hydrolase_35', NULL, NULL, 'Nudix_Hydrolase_35', 12745),
(12746, 'cd19551', NULL, 'serpinA3_A1AC', NULL, NULL, 'serpinA3_A1AC', 12746),
(12747, 'cd01816', NULL, 'RBD_RAF', NULL, NULL, 'RBD_RAF', 12747),
(12748, 'cd01819', NULL, 'Patatin_and_cPLA2', NULL, NULL, 'Patatin_and_cPLA2', 12748); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(12749, 'cd07282', NULL, 'PX_SNX2', NULL, NULL, 'PX_SNX2', 12749),
(12750, 'cd20261', NULL, 'Complex1_LYR_LYRM1', NULL, NULL, 'Complex1_LYR_LYRM1', 12750),
(12751, 'cd12556', NULL, 'RRM2_RBM15B', NULL, NULL, 'RRM2_RBM15B', 12751),
(12752, 'cd17168', NULL, 'FERM_F1_FRMPD1', NULL, NULL, 'FERM_F1_FRMPD1', 12752),
(12753, 'cd05831', NULL, 'Ribosomal_P1', NULL, NULL, 'Ribosomal_P1', 12753),
(12754, 'cd02211', NULL, 'cupin_UGlyAH_N', NULL, NULL, 'cupin_UGlyAH_N', 12754),
(12755, 'cd18110', NULL, 'ATP-synt_F1_beta_C', NULL, NULL, 'ATP-synt_F1_beta_C', 12755),
(12756, 'cd03302', NULL, 'Adenylsuccinate_lyase_2', NULL, NULL, 'Adenylsuccinate_lyase_2', 12756),
(12757, 'cd20480', NULL, 'ArgR-Cyc_NRPS-like', NULL, NULL, 'ArgR-Cyc_NRPS-like', 12757),
(12758, 'cd10494', NULL, 'MH1_SMAD_7', NULL, NULL, 'MH1_SMAD_7', 12758),
(12759, 'cd08815', NULL, 'Death_TNFRSF25_DR3', NULL, NULL, 'Death_TNFRSF25_DR3', 12759),
(12760, 'cd15570', NULL, 'PHD_Bye1p_SIZ1_like', NULL, NULL, 'PHD_Bye1p_SIZ1_like', 12760),
(12761, 'cd00988', NULL, 'PDZ_CTP_protease', NULL, NULL, 'PDZ_CTP_protease', 12761),
(12762, 'cd08392', NULL, 'C2A_SLP-3', NULL, NULL, 'C2A_SLP-3', 12762),
(12763, 'cd09447', NULL, 'LIM_LASP', NULL, NULL, 'LIM_LASP', 12763),
(12764, 'cd08783', NULL, 'Death_MALT1', NULL, NULL, 'Death_MALT1', 12764),
(12765, 'cd15602', NULL, 'PHD1_KDM5A', NULL, NULL, 'PHD1_KDM5A', 12765),
(12766, 'cd19159', NULL, 'AKR_KCAB1B_AKR6A3-like', NULL, NULL, 'AKR_KCAB1B_AKR6A3-like', 12766),
(12767, 'cd13716', NULL, 'PBP2_iGluR_delta_like', NULL, NULL, 'PBP2_iGluR_delta_like', 12767),
(12768, 'cd14677', NULL, 'PH_DOK7', NULL, NULL, 'PH_DOK7', 12768),
(12769, 'cd16520', NULL, 'RING-HC_MIBs_like', NULL, NULL, 'RING-HC_MIBs_like', 12769),
(12770, 'cd11971', NULL, 'SH3_Abi1', NULL, NULL, 'SH3_Abi1', 12770),
(12771, 'cd05692', NULL, 'S1_RPS1_repeat_hs4', NULL, NULL, 'S1_RPS1_repeat_hs4', 12771),
(12772, 'cd06186', NULL, 'NOX_Duox_like_FAD_NADP', NULL, NULL, 'NOX_Duox_like_FAD_NADP', 12772),
(12773, 'cd07246', NULL, 'VOC_like', NULL, NULL, 'VOC_like', 12773),
(12774, 'cd20231', NULL, 'PFM_jacalin-like', NULL, NULL, 'PFM_jacalin-like', 12774),
(12775, 'cd16924', NULL, 'HATPase_YpdA-YehU-LytS-like', NULL, NULL, 'HATPase_YpdA-YehU-LytS-like', 12775),
(12776, 'cd14681', NULL, 'PH-STXBP6', NULL, NULL, 'PH-STXBP6', 12776),
(12777, 'cd06933', NULL, 'NR_LBD_VDR', NULL, NULL, 'NR_LBD_VDR', 12777),
(12778, 'cd11831', NULL, 'SH3_VAV_1', NULL, NULL, 'SH3_VAV_1', 12778),
(12779, 'cd20242', NULL, 'PFM_aerolysin-like', NULL, NULL, 'PFM_aerolysin-like', 12779),
(12780, 'cd14300', NULL, 'UBA_UBS3A_like', NULL, NULL, 'UBA_UBS3A_like', 12780),
(12781, 'cd08780', NULL, 'Death_TRADD', NULL, NULL, 'Death_TRADD', 12781),
(12782, 'cd03063', NULL, 'TRX_Fd_FDH_beta', NULL, NULL, 'TRX_Fd_FDH_beta', 12782),
(12783, 'cd10346', NULL, 'SH2_SH2B_family', NULL, NULL, 'SH2_SH2B_family', 12783),
(12784, 'cd01018', NULL, 'ZntC', NULL, NULL, 'ZntC', 12784),
(12785, 'cd12493', NULL, 'RRM2_DND1', NULL, NULL, 'RRM2_DND1', 12785),
(12786, 'cd00016', NULL, 'ALP_like', NULL, NULL, 'ALP_like', 12786),
(12787, 'cd08304', NULL, 'DD', NULL, NULL, 'DD', 12787),
(12788, 'cd08936', NULL, 'CR_SDR_c', NULL, NULL, 'CR_SDR_c', 12788),
(12789, 'cd20332', NULL, 'JBP', NULL, NULL, 'JBP', 12789),
(12790, 'cd04168', NULL, 'TetM_like', NULL, NULL, 'TetM_like', 12790),
(12791, 'cd01191', NULL, 'INT_C_like_2', NULL, NULL, 'INT_C_like_2', 12791),
(12792, 'cd11545', NULL, 'NTP-PPase_YP_001813558', NULL, NULL, 'NTP-PPase_YP_001813558', 12792),
(12793, 'cd12285', NULL, 'RRM3_RBM39_like', NULL, NULL, 'RRM3_RBM39_like', 12793),
(12794, 'cd15639', NULL, 'PHD_DIDO1_like', NULL, NULL, 'PHD_DIDO1_like', 12794),
(12795, 'cd01714', NULL, 'ETF_beta', NULL, NULL, 'ETF_beta', 12795),
(12796, 'cd00132', NULL, 'CRIB', NULL, NULL, 'CRIB', 12796),
(12797, 'cd13435', NULL, 'SPFH_SLP-4', NULL, NULL, 'SPFH_SLP-4', 12797),
(12798, 'cd09492', NULL, 'SAM_SASH1_repeat2', NULL, NULL, 'SAM_SASH1_repeat2', 12798),
(12799, 'cd18594', NULL, 'ABC_6TM_CFTR_D1', NULL, NULL, 'ABC_6TM_CFTR_D1', 12799),
(12800, 'cd06916', NULL, 'NR_DBD_like', NULL, NULL, 'NR_DBD_like', 12800);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(12801, 'cd07388', NULL, 'MPP_Tt1561', NULL, NULL, 'MPP_Tt1561', 12801),
(12802, 'cd05372', NULL, 'ENR_SDR', NULL, NULL, 'ENR_SDR', 12802),
(12803, 'cd00177', NULL, 'START', NULL, NULL, 'START', 12803),
(12804, 'cd06471', NULL, 'ACD_LpsHSP_like', NULL, NULL, 'ACD_LpsHSP_like', 12804),
(12805, 'cd02976', NULL, 'NrdH', NULL, NULL, 'NrdH', 12805),
(12806, 'cd06637', NULL, 'STKc_TNIK', NULL, NULL, 'STKc_TNIK', 12806),
(12807, 'cd01041', NULL, 'Rubrerythrin', NULL, NULL, 'Rubrerythrin', 12807),
(12808, 'cd20007', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, 'PBP1_ABC_sugar_binding-like', 12808),
(12809, 'cd05679', NULL, 'M20_dipept_like', NULL, NULL, 'M20_dipept_like', 12809),
(12810, 'cd09758', NULL, 'Csn2', NULL, NULL, 'Csn2', 12810),
(12811, 'cd08951', NULL, 'DR_C-13_KR_SDR_c_like', NULL, NULL, 'DR_C-13_KR_SDR_c_like', 12811),
(12812, 'cd12830', NULL, 'MtCorA-like', NULL, NULL, 'MtCorA-like', 12812),
(12813, 'cd02186', NULL, 'alpha_tubulin', NULL, NULL, 'alpha_tubulin', 12813),
(12814, 'cd03000', NULL, 'PDI_a_TMX3', NULL, NULL, 'PDI_a_TMX3', 12814),
(12815, 'cd07870', NULL, 'STKc_PFTAIRE2', NULL, NULL, 'STKc_PFTAIRE2', 12815),
(12816, 'cd07882', NULL, 'RHD-n_TonEBP', NULL, NULL, 'RHD-n_TonEBP', 12816),
(12817, 'cd12625', NULL, 'RRM1_IGF2BP1', NULL, NULL, 'RRM1_IGF2BP1', 12817),
(12818, 'cd17482', NULL, 'MFS_YxiO_like', NULL, NULL, 'MFS_YxiO_like', 12818),
(12819, 'cd18056', NULL, 'DEXHc_CHD4', NULL, NULL, 'DEXHc_CHD4', 12819),
(12820, 'cd18651', NULL, 'CD_HP1alpha_Cbx5', NULL, NULL, 'CD_HP1alpha_Cbx5', 12820),
(12821, 'cd17276', NULL, 'RMtype1_S_Sau1132ORF3780P-TRD1-CR1_like', NULL, NULL, 'RMtype1_S_Sau1132ORF3780P-TRD1-CR1_like', 12821),
(12822, 'cd08495', NULL, 'PBP2_NikA_DppA_OppA_like_8', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_8', 12822),
(12823, 'cd04973', NULL, 'Ig1_FGFR', NULL, NULL, 'Ig1_FGFR', 12823),
(12824, 'cd08916', NULL, 'TrHb3_P', NULL, NULL, 'TrHb3_P', 12824),
(12825, 'cd00207', NULL, 'fer2', NULL, NULL, 'fer2', 12825),
(12826, 'cd17046', NULL, 'Ubl_IKKA_like', NULL, NULL, 'Ubl_IKKA_like', 12826),
(12827, 'cd12538', NULL, 'RRM_U2AF35', NULL, NULL, 'RRM_U2AF35', 12827),
(12828, 'cd01065', NULL, 'NAD_bind_Shikimate_DH', NULL, NULL, 'NAD_bind_Shikimate_DH', 12828),
(12829, 'cd21590', NULL, 'deltaCoV_RdRp', NULL, NULL, 'deltaCoV_RdRp', 12829),
(12830, 'cd14212', NULL, 'PKc_YAK1', NULL, NULL, 'PKc_YAK1', 12830),
(12831, 'cd13704', NULL, 'PBP2_HisK', NULL, NULL, 'PBP2_HisK', 12831),
(12832, 'cd16926', NULL, 'HATPase_MutL-MLH-PMS-like', NULL, NULL, 'HATPase_MutL-MLH-PMS-like', 12832),
(12833, 'cd04777', NULL, 'HTH_MerR-like_sg1', NULL, NULL, 'HTH_MerR-like_sg1', 12833),
(12834, 'cd15476', NULL, 'Myo5c_CBD', NULL, NULL, 'Myo5c_CBD', 12834),
(12835, 'cd19013', NULL, 'LGIC_ECD_5-HT3C_E', NULL, NULL, 'LGIC_ECD_5-HT3C_E', 12835),
(12836, 'cd17131', NULL, 'Ubl_TMUB1', NULL, NULL, 'Ubl_TMUB1', 12836),
(12837, 'cd17241', NULL, 'RA_PHLPP2', NULL, NULL, 'RA_PHLPP2', 12837),
(12838, 'cd16366', NULL, 'FDH_beta_like', NULL, NULL, 'FDH_beta_like', 12838),
(12839, 'cd01012', NULL, 'YcaC_related', NULL, NULL, 'YcaC_related', 12839),
(12840, 'cd04086', NULL, 'CBM35_mannanase-like', NULL, NULL, 'CBM35_mannanase-like', 12840),
(12841, 'cd05839', NULL, 'BR140_related', NULL, NULL, 'BR140_related', 12841),
(12842, 'cd10561', NULL, 'HybA_like', NULL, NULL, 'HybA_like', 12842),
(12843, 'cd10811', NULL, 'GH38N_AMII_Epman_like', NULL, NULL, 'GH38N_AMII_Epman_like', 12843),
(12844, 'cd14254', NULL, 'Dockerin_II', NULL, NULL, 'Dockerin_II', 12844),
(12845, 'cd05959', NULL, 'BCL_4HBCL', NULL, NULL, 'BCL_4HBCL', 12845),
(12846, 'cd16533', NULL, 'RING-HC_RNF4', NULL, NULL, 'RING-HC_RNF4', 12846),
(12847, 'cd01122', NULL, 'GP4d_helicase', NULL, NULL, 'GP4d_helicase', 12847),
(12848, 'cd16163', NULL, 'OCRE_RBM6', NULL, NULL, 'OCRE_RBM6', 12848),
(12849, 'cd19066', NULL, 'C_NRPS-like', NULL, NULL, 'C_NRPS-like', 12849),
(12850, 'cd01875', NULL, 'RhoG', NULL, NULL, 'RhoG', 12850),
(12851, 'cd05626', NULL, 'STKc_LATS2', NULL, NULL, 'STKc_LATS2', 12851),
(12852, 'cd09335', NULL, 'LIM5_PINCH', NULL, NULL, 'LIM5_PINCH', 12852);
INSERT INTO "PUBLIC"."MODEL" VALUES
(12853, 'cd11895', NULL, 'SH3_FCHSD1_2', NULL, NULL, 'SH3_FCHSD1_2', 12853),
(12854, 'cd17014', NULL, 'ANTH_N_HIP1R', NULL, NULL, 'ANTH_N_HIP1R', 12854),
(12855, 'cd19055', NULL, 'LGIC_TM_GABAAR_delta', NULL, NULL, 'LGIC_TM_GABAAR_delta', 12855),
(12856, 'cd07154', NULL, 'NR_DBD_PNR_like', NULL, NULL, 'NR_DBD_PNR_like', 12856),
(12857, 'cd12563', NULL, 'RRM2_RBM6', NULL, NULL, 'RRM2_RBM6', 12857),
(12858, 'cd13628', NULL, 'PBP2_Ala', NULL, NULL, 'PBP2_Ala', 12858),
(12859, 'cd09538', NULL, 'SAM_DLC1,2-like', NULL, NULL, 'SAM_DLC1,2-like', 12859),
(12860, 'cd02148', NULL, 'RutE-like', NULL, NULL, 'RutE-like', 12860),
(12861, 'cd16790', NULL, 'SP-RING_PIAS', NULL, NULL, 'SP-RING_PIAS', 12861),
(12862, 'cd16817', NULL, 'mRING-HC-C3HC5_RNF157', NULL, NULL, 'mRING-HC-C3HC5_RNF157', 12862),
(12863, 'cd16440', NULL, 'beta_Kdo_transferase_KpsC_1', NULL, NULL, 'beta_Kdo_transferase_KpsC_1', 12863),
(12864, 'cd13256', NULL, 'PH3_ARAP', NULL, NULL, 'PH3_ARAP', 12864),
(12865, 'cd19057', NULL, 'LGIC_TM_GABAAR_epsilon', NULL, NULL, 'LGIC_TM_GABAAR_epsilon', 12865),
(12866, 'cd06898', NULL, 'PX_SNX10', NULL, NULL, 'PX_SNX10', 12866),
(12867, 'cd09436', NULL, 'LIM3_TRIP6', NULL, NULL, 'LIM3_TRIP6', 12867),
(12868, 'cd01615', NULL, 'CIDE_N', NULL, NULL, 'CIDE_N', 12868),
(12869, 'cd08664', NULL, 'APC10-HERC2', NULL, NULL, 'APC10-HERC2', 12869),
(12870, 'cd09370', NULL, 'LIM1_Lmx1a', NULL, NULL, 'LIM1_Lmx1a', 12870),
(12871, 'cd01304', NULL, 'FMDH_A', NULL, NULL, 'FMDH_A', 12871),
(12872, 'cd12231', NULL, 'RRM2_U2AF65', NULL, NULL, 'RRM2_U2AF65', 12872),
(12873, 'cd18139', NULL, 'HLD_clamp_RarA', NULL, NULL, 'HLD_clamp_RarA', 12873),
(12874, 'cd08325', NULL, 'CARD_CASP1-like', NULL, NULL, 'CARD_CASP1-like', 12874),
(12875, 'cd02795', NULL, 'CBM6-CBM35-CBM36_like', NULL, NULL, 'CBM6-CBM35-CBM36_like', 12875),
(12876, 'cd14837', NULL, 'AP3_Mu_N', NULL, NULL, 'AP3_Mu_N', 12876),
(12877, 'cd16259', NULL, 'RF3_III', NULL, NULL, 'RF3_III', 12877),
(12878, 'cd19090', NULL, 'AKR_AKR15A-like', NULL, NULL, 'AKR_AKR15A-like', 12878),
(12879, 'cd09196', NULL, 'PLDc_yTdp1_2', NULL, NULL, 'PLDc_yTdp1_2', 12879),
(12880, 'cd09415', NULL, 'LIM1_Prickle', NULL, NULL, 'LIM1_Prickle', 12880),
(12881, 'cd18076', NULL, 'DEXXQc_HELZ2-N', NULL, NULL, 'DEXXQc_HELZ2-N', 12881),
(12882, 'cd01144', NULL, 'BtuF', NULL, NULL, 'BtuF', 12882),
(12883, 'cd02963', NULL, 'TRX_DnaJ', NULL, NULL, 'TRX_DnaJ', 12883),
(12884, 'cd16323', NULL, 'Syd', NULL, NULL, 'Syd', 12884),
(12885, 'cd19136', NULL, 'AKR_DrGR-like', NULL, NULL, 'AKR_DrGR-like', 12885),
(12886, 'cd12207', NULL, 'RasGAP_IQGAP3', NULL, NULL, 'RasGAP_IQGAP3', 12886),
(12887, 'cd08480', NULL, 'PBP2_CrgA_like_10', NULL, NULL, 'PBP2_CrgA_like_10', 12887),
(12888, 'cd19901', NULL, 'DSRM_RBM46', NULL, NULL, 'DSRM_RBM46', 12888),
(12889, 'cd13607', NULL, 'PBP2_AfProX_like', NULL, NULL, 'PBP2_AfProX_like', 12889),
(12890, 'cd01299', NULL, 'Met_dep_hydrolase_A', NULL, NULL, 'Met_dep_hydrolase_A', 12890),
(12891, 'cd05929', NULL, 'BACL_like', NULL, NULL, 'BACL_like', 12891),
(12892, 'cd16456', NULL, 'RING-H2_APC11', NULL, NULL, 'RING-H2_APC11', 12892),
(12893, 'cd09158', NULL, 'PLDc_EcCLS_like_2', NULL, NULL, 'PLDc_EcCLS_like_2', 12893),
(12894, 'cd16353', NULL, 'CheC_CheX_FliY', NULL, NULL, 'CheC_CheX_FliY', 12894),
(12895, 'cd14705', NULL, 'bZIP_Zip1', NULL, NULL, 'bZIP_Zip1', 12895),
(12896, 'cd04737', NULL, 'LOX_like_FMN', NULL, NULL, 'LOX_like_FMN', 12896),
(12897, 'cd15650', NULL, 'PHD2_NSD1', NULL, NULL, 'PHD2_NSD1', 12897),
(12898, 'cd18010', NULL, 'DEXHc_HARP_SMARCAL1', NULL, NULL, 'DEXHc_HARP_SMARCAL1', 12898),
(12899, 'cd08566', NULL, 'GDPD_AtGDE_like', NULL, NULL, 'GDPD_AtGDE_like', 12899),
(12900, 'cd04145', NULL, 'M_R_Ras_like', NULL, NULL, 'M_R_Ras_like', 12900),
(12901, 'cd08351', NULL, 'ChaP_like', NULL, NULL, 'ChaP_like', 12901),
(12902, 'cd14867', NULL, 'uS7_Eukaryote', NULL, NULL, 'uS7_Eukaryote', 12902),
(12903, 'cd06347', NULL, 'PBP1_ABC_LivK_ligand_binding-like', NULL, NULL, 'PBP1_ABC_LivK_ligand_binding-like', 12903),
(12904, 'cd14395', NULL, 'UBA_BIRC4_8', NULL, NULL, 'UBA_BIRC4_8', 12904);
INSERT INTO "PUBLIC"."MODEL" VALUES
(12905, 'cd08533', NULL, 'SAM_PNT-ETS-1,2', NULL, NULL, 'SAM_PNT-ETS-1,2', 12905),
(12906, 'cd08363', NULL, 'FosB', NULL, NULL, 'FosB', 12906),
(12907, 'cd13252', NULL, 'PH1_ADAP', NULL, NULL, 'PH1_ADAP', 12907),
(12908, 'cd10719', NULL, 'DnaJ_zf', NULL, NULL, 'DnaJ_zf', 12908),
(12909, 'cd16876', NULL, 'ARID_ARID1A', NULL, NULL, 'ARID_ARID1A', 12909),
(12910, 'cd01617', NULL, 'DCX', NULL, NULL, 'DCX', 12910),
(12911, 'cd11413', NULL, 'bHLH_TS_TAL_LYL', NULL, NULL, 'bHLH_TS_TAL_LYL', 12911),
(12912, 'cd00014', NULL, 'CH', NULL, NULL, 'CH', 12912),
(12913, 'cd07114', NULL, 'ALDH_DhaS', NULL, NULL, 'ALDH_DhaS', 12913),
(12914, 'cd14442', NULL, 'AlgJ_like', NULL, NULL, 'AlgJ_like', 12914),
(12915, 'cd05280', NULL, 'MDR_yhdh_yhfp', NULL, NULL, 'MDR_yhdh_yhfp', 12915),
(12916, 'cd01076', NULL, 'NAD_bind_1_Glu_DH', NULL, NULL, 'NAD_bind_1_Glu_DH', 12916),
(12917, 'cd17083', NULL, 'RAWUL_PCGF3', NULL, NULL, 'RAWUL_PCGF3', 12917),
(12918, 'cd09258', NULL, 'AP-1_Mu1A_Cterm', NULL, NULL, 'AP-1_Mu1A_Cterm', 12918),
(12919, 'cd11576', NULL, 'GH99_GH71_like_2', NULL, NULL, 'GH99_GH71_like_2', 12919),
(12920, 'cd14030', NULL, 'STKc_WNK1', NULL, NULL, 'STKc_WNK1', 12920),
(12921, 'cd01276', NULL, 'PKCI_related', NULL, NULL, 'PKCI_related', 12921),
(12922, 'cd14106', NULL, 'STKc_DRAK', NULL, NULL, 'STKc_DRAK', 12922),
(12923, 'cd11893', NULL, 'SH3_MIA3', NULL, NULL, 'SH3_MIA3', 12923),
(12924, 'cd03216', NULL, 'ABC_Carb_Monos_I', NULL, NULL, 'ABC_Carb_Monos_I', 12924),
(12925, 'cd15375', NULL, '7tmA_OXGR1', NULL, NULL, '7tmA_OXGR1', 12925),
(12926, 'cd09610', NULL, 'M3B_PepF', NULL, NULL, 'M3B_PepF', 12926),
(12927, 'cd16697', NULL, 'RING-CH-C4HC3_NFXL1', NULL, NULL, 'RING-CH-C4HC3_NFXL1', 12927),
(12928, 'cd10343', NULL, 'SH2_SHIP', NULL, NULL, 'SH2_SHIP', 12928),
(12929, 'cd19546', NULL, 'X-Domain_NRPS', NULL, NULL, 'X-Domain_NRPS', 12929),
(12930, 'cd19898', NULL, 'DSRM_RED1_rpt2', NULL, NULL, 'DSRM_RED1_rpt2', 12930),
(12931, 'cd09522', NULL, 'SAM_SLP76', NULL, NULL, 'SAM_SLP76', 12931),
(12932, 'cd19545', NULL, 'FUM14_C_NRPS-like', NULL, NULL, 'FUM14_C_NRPS-like', 12932),
(12933, 'cd15880', NULL, 'SNARE_syntaxin1', NULL, NULL, 'SNARE_syntaxin1', 12933),
(12934, 'cd00996', NULL, 'PBP2_AatB_like', NULL, NULL, 'PBP2_AatB_like', 12934),
(12935, 'cd11323', NULL, 'AmyAc_AGS', NULL, NULL, 'AmyAc_AGS', 12935),
(12936, 'cd15959', NULL, '7tmA_Beta3_AR', NULL, NULL, '7tmA_Beta3_AR', 12936),
(12937, 'cd17506', NULL, 'Ubl_SAMP2_like', NULL, NULL, 'Ubl_SAMP2_like', 12937),
(12938, 'cd03494', NULL, 'SQR_TypeC_SdhD', NULL, NULL, 'SQR_TypeC_SdhD', 12938),
(12939, 'cd07467', NULL, 'CRD_TK_ROR1', NULL, NULL, 'CRD_TK_ROR1', 12939),
(12940, 'cd12394', NULL, 'RRM1_RBM34', NULL, NULL, 'RRM1_RBM34', 12940),
(12941, 'cd04466', NULL, 'S1_YloQ_GTPase', NULL, NULL, 'S1_YloQ_GTPase', 12941),
(12942, 'cd06522', NULL, 'GH25_AtlA-like', NULL, NULL, 'GH25_AtlA-like', 12942),
(12943, 'cd18692', NULL, 'PIN_VapC-like', NULL, NULL, 'PIN_VapC-like', 12943),
(12944, 'cd14092', NULL, 'STKc_MSK_C', NULL, NULL, 'STKc_MSK_C', 12944),
(12945, 'cd03318', NULL, 'MLE', NULL, NULL, 'MLE', 12945),
(12946, 'cd09583', NULL, 'SAM_Atherin-like', NULL, NULL, 'SAM_Atherin-like', 12946),
(12947, 'cd11636', NULL, 'HR1_PKN1_3', NULL, NULL, 'HR1_PKN1_3', 12947),
(12948, 'cd13520', NULL, 'PBP2_TAXI_TRAP', NULL, NULL, 'PBP2_TAXI_TRAP', 12948),
(12949, 'cd20278', NULL, 'Minion', NULL, NULL, 'Minion', 12949),
(12950, 'cd17995', NULL, 'DEXHc_CHD6_7_8_9', NULL, NULL, 'DEXHc_CHD6_7_8_9', 12950),
(12951, 'cd07869', NULL, 'STKc_PFTAIRE1', NULL, NULL, 'STKc_PFTAIRE1', 12951),
(12952, 'cd15838', NULL, 'TNFRSF27', NULL, NULL, 'TNFRSF27', 12952),
(12953, 'cd02440', NULL, 'AdoMet_MTases', NULL, NULL, 'AdoMet_MTases', 12953),
(12954, 'cd13120', NULL, 'BF2867_like_N', NULL, NULL, 'BF2867_like_N', 12954),
(12955, 'cd12663', NULL, 'RRM1_RAVER1', NULL, NULL, 'RRM1_RAVER1', 12955),
(12956, 'cd09679', NULL, 'Cas10_III', NULL, NULL, 'Cas10_III', 12956),
(12957, 'cd14763', NULL, 'SSDgbs_1', NULL, NULL, 'SSDgbs_1', 12957),
(12958, 'cd15923', NULL, '7tmA_GPR35_55-like', NULL, NULL, '7tmA_GPR35_55-like', 12958);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(12959, 'cd16606', NULL, 'RING-HC_TRIM58_C-IV', NULL, NULL, 'RING-HC_TRIM58_C-IV', 12959),
(12960, 'cd03313', NULL, 'enolase', NULL, NULL, 'enolase', 12960),
(12961, 'cd18364', NULL, 'BTB_POZ_KCTD4', NULL, NULL, 'BTB_POZ_KCTD4', 12961),
(12962, 'cd15595', NULL, 'PHD2_KMT2D', NULL, NULL, 'PHD2_KMT2D', 12962),
(12963, 'cd15246', NULL, '7tmF_FZD7', NULL, NULL, '7tmF_FZD7', 12963),
(12964, 'cd04172', NULL, 'Rnd3_RhoE_Rho8', NULL, NULL, 'Rnd3_RhoE_Rho8', 12964),
(12965, 'cd05606', NULL, 'STKc_beta_ARK', NULL, NULL, 'STKc_beta_ARK', 12965),
(12966, 'cd06439', NULL, 'CESA_like_1', NULL, NULL, 'CESA_like_1', 12966),
(12967, 'cd11875', NULL, 'SH3_CD2AP-like_3', NULL, NULL, 'SH3_CD2AP-like_3', 12967),
(12968, 'cd04721', NULL, 'BAH_plant_1', NULL, NULL, 'BAH_plant_1', 12968),
(12969, 'cd03706', NULL, 'mtEFTU_III', NULL, NULL, 'mtEFTU_III', 12969),
(12970, 'cd18564', NULL, 'ABC_6TM_exporter_like', NULL, NULL, 'ABC_6TM_exporter_like', 12970),
(12971, 'cd16565', NULL, 'RING-HC_RNF224_like', NULL, NULL, 'RING-HC_RNF224_like', 12971),
(12972, 'cd07669', NULL, 'BAR_SNX33', NULL, NULL, 'BAR_SNX33', 12972),
(12973, 'cd00598', NULL, 'GH18_chitinase-like', NULL, NULL, 'GH18_chitinase-like', 12973),
(12974, 'cd07771', NULL, 'FGGY_RhuK', NULL, NULL, 'FGGY_RhuK', 12974),
(12975, 'cd01943', NULL, 'MAK32', NULL, NULL, 'MAK32', 12975),
(12976, 'cd02344', NULL, 'ZZ_HERC2', NULL, NULL, 'ZZ_HERC2', 12976),
(12977, 'cd04376', NULL, 'RhoGAP_ARHGAP6', NULL, NULL, 'RhoGAP_ARHGAP6', 12977),
(12978, 'cd03035', NULL, 'ArsC_Yffb', NULL, NULL, 'ArsC_Yffb', 12978),
(12979, 'cd09251', NULL, 'AP-2_Mu2_Cterm', NULL, NULL, 'AP-2_Mu2_Cterm', 12979),
(12980, 'cd12580', NULL, 'RRM2_hnRNPA1', NULL, NULL, 'RRM2_hnRNPA1', 12980),
(12981, 'cd09209', NULL, 'Lumazine_synthase-I', NULL, NULL, 'Lumazine_synthase-I', 12981),
(12982, 'cd14905', NULL, 'MYSc_Myo44', NULL, NULL, 'MYSc_Myo44', 12982),
(12983, 'cd08837', NULL, 'ArfGap_ARAP', NULL, NULL, 'ArfGap_ARAP', 12983),
(12984, 'cd13973', NULL, 'PK_MviN-like', NULL, NULL, 'PK_MviN-like', 12984),
(12985, 'cd15521', NULL, 'PHD_VIN3_plant', NULL, NULL, 'PHD_VIN3_plant', 12985),
(12986, 'cd11013', NULL, 'Plantacyanin', NULL, NULL, 'Plantacyanin', 12986),
(12987, 'cd19539', NULL, 'SgcC5_NRPS-like', NULL, NULL, 'SgcC5_NRPS-like', 12987),
(12988, 'cd11792', NULL, 'SH3_Fut8', NULL, NULL, 'SH3_Fut8', 12988),
(12989, 'cd04962', NULL, 'GT4_BshA-like', NULL, NULL, 'GT4_BshA-like', 12989),
(12990, 'cd17964', NULL, 'DEADc_MSS116', NULL, NULL, 'DEADc_MSS116', 12990),
(12991, 'cd04761', NULL, 'HTH_MerR-SF', NULL, NULL, 'HTH_MerR-SF', 12991),
(12992, 'cd12071', NULL, 'SH3_FBP17', NULL, NULL, 'SH3_FBP17', 12992),
(12993, 'cd12641', NULL, 'RRM_TRA2B', NULL, NULL, 'RRM_TRA2B', 12993),
(12994, 'cd05024', NULL, 'S-100A10', NULL, NULL, 'S-100A10', 12994),
(12995, 'cd09260', NULL, 'AP-3_Mu3A_Cterm', NULL, NULL, 'AP-3_Mu3A_Cterm', 12995),
(12996, 'cd08296', NULL, 'CAD_like', NULL, NULL, 'CAD_like', 12996),
(12997, 'cd11404', NULL, 'bHLHzip_Mlx_like', NULL, NULL, 'bHLHzip_Mlx_like', 12997),
(12998, 'cd15022', NULL, '7tm_TAS2R8', NULL, NULL, '7tm_TAS2R8', 12998),
(12999, 'cd05802', NULL, 'GlmM', NULL, NULL, 'GlmM', 12999),
(13000, 'cd00546', NULL, 'QFR_TypeD_subunitC', NULL, NULL, 'QFR_TypeD_subunitC', 13000),
(13001, 'cd09535', NULL, 'SAM_BOI-like_fungal', NULL, NULL, 'SAM_BOI-like_fungal', 13001),
(13002, 'cd14203', NULL, 'PTKc_Src_Fyn_like', NULL, NULL, 'PTKc_Src_Fyn_like', 13002),
(13003, 'cd05236', NULL, 'FAR-N_SDR_e', NULL, NULL, 'FAR-N_SDR_e', 13003),
(13004, 'cd09005', NULL, 'NP-I', NULL, NULL, 'NP-I', 13004),
(13005, 'cd00671', NULL, 'ArgRS_core', NULL, NULL, 'ArgRS_core', 13005),
(13006, 'cd17446', NULL, 'MFS_SLC22A6_OAT1_like', NULL, NULL, 'MFS_SLC22A6_OAT1_like', 13006),
(13007, 'cd18943', NULL, 'bHLH_E-protein_E47-like', NULL, NULL, 'bHLH_E-protein_E47-like', 13007),
(13008, 'cd05966', NULL, 'ACS', NULL, NULL, 'ACS', 13008),
(13009, 'cd01997', NULL, 'GMP_synthase_C', NULL, NULL, 'GMP_synthase_C', 13009),
(13010, 'cd11487', NULL, 'SLC5sbd_SGLT2', NULL, NULL, 'SLC5sbd_SGLT2', 13010),
(13011, 'cd17977', NULL, 'DEXHc_DHX32', NULL, NULL, 'DEXHc_DHX32', 13011);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(13012, 'cd01108', NULL, 'HTH_CueR', NULL, NULL, 'HTH_CueR', 13012),
(13013, 'cd04166', NULL, 'CysN_ATPS', NULL, NULL, 'CysN_ATPS', 13013),
(13014, 'cd01344', NULL, 'PL2_Passenger_AT', NULL, NULL, 'PL2_Passenger_AT', 13014),
(13015, 'cd00056', NULL, 'ENDO3c', NULL, NULL, 'ENDO3c', 13015),
(13016, 'cd09126', NULL, 'PLDc_C_DEXD_like', NULL, NULL, 'PLDc_C_DEXD_like', 13016),
(13017, 'cd09819', NULL, 'An_peroxidase_bacterial_1', NULL, NULL, 'An_peroxidase_bacterial_1', 13017),
(13018, 'cd08309', NULL, 'Death_IRAK', NULL, NULL, 'Death_IRAK', 13018),
(13019, 'cd02252', NULL, 'nylC_like', NULL, NULL, 'nylC_like', 13019),
(13020, 'cd06062', NULL, 'H2MP_MemB-H2up', NULL, NULL, 'H2MP_MemB-H2up', 13020),
(13021, 'cd04391', NULL, 'RhoGAP_ARHGAP18', NULL, NULL, 'RhoGAP_ARHGAP18', 13021),
(13022, 'cd12014', NULL, 'SH3_RIM-BP_1', NULL, NULL, 'SH3_RIM-BP_1', 13022),
(13023, 'cd10789', NULL, 'GH38N_AMII_ER_cytosolic', NULL, NULL, 'GH38N_AMII_ER_cytosolic', 13023),
(13024, 'cd07068', NULL, 'NR_LBD_ER_like', NULL, NULL, 'NR_LBD_ER_like', 13024),
(13025, 'cd05079', NULL, 'PTKc_Jak1_rpt2', NULL, NULL, 'PTKc_Jak1_rpt2', 13025),
(13026, 'cd17062', NULL, 'Ubl_NUB1', NULL, NULL, 'Ubl_NUB1', 13026),
(13027, 'cd13662', NULL, 'PBP2_TpPotD_like', NULL, NULL, 'PBP2_TpPotD_like', 13027),
(13028, 'cd16507', NULL, 'RING-HC_GEFO_like', NULL, NULL, 'RING-HC_GEFO_like', 13028),
(13029, 'cd17180', NULL, 'FERM_F0_KIND1', NULL, NULL, 'FERM_F0_KIND1', 13029),
(13030, 'cd05132', NULL, 'RasGAP_GAPA', NULL, NULL, 'RasGAP_GAPA', 13030),
(13031, 'cd07887', NULL, 'RHD-n_Dorsal_Dif', NULL, NULL, 'RHD-n_Dorsal_Dif', 13031),
(13032, 'cd13766', NULL, 'TGF_beta_GDF5_6_7', NULL, NULL, 'TGF_beta_GDF5_6_7', 13032),
(13033, 'cd13149', NULL, 'MATE_like_2', NULL, NULL, 'MATE_like_2', 13033),
(13034, 'cd07550', NULL, 'P-type_ATPase_HM', NULL, NULL, 'P-type_ATPase_HM', 13034),
(13035, 'cd15253', NULL, '7tmB2_GPR113', NULL, NULL, '7tmB2_GPR113', 13035),
(13036, 'cd10000', NULL, 'HDAC8', NULL, NULL, 'HDAC8', 13036),
(13037, 'cd02853', NULL, 'E_set_MTHase_like_N', NULL, NULL, 'E_set_MTHase_like_N', 13037),
(13038, 'cd14152', NULL, 'STKc_KSR1', NULL, NULL, 'STKc_KSR1', 13038),
(13039, 'cd15370', NULL, '7tmA_PAR2', NULL, NULL, '7tmA_PAR2', 13039),
(13040, 'cd09345', NULL, 'LIM2_FHL', NULL, NULL, 'LIM2_FHL', 13040),
(13041, 'cd08039', NULL, 'Adenylation_DNA_ligase_Fungal', NULL, NULL, 'Adenylation_DNA_ligase_Fungal', 13041),
(13042, 'cd18936', NULL, 'bHLH_TS_MYOD1_Myf3', NULL, NULL, 'bHLH_TS_MYOD1_Myf3', 13042),
(13043, 'cd01724', NULL, 'Sm_D1', NULL, NULL, 'Sm_D1', 13043),
(13044, 'cd14042', NULL, 'PK_GC-A_B', NULL, NULL, 'PK_GC-A_B', 13044),
(13045, 'cd04889', NULL, 'ACT_PDH-BS-like', NULL, NULL, 'ACT_PDH-BS-like', 13045),
(13046, 'cd15394', NULL, '7tmA_PrRP_R', NULL, NULL, '7tmA_PrRP_R', 13046),
(13047, 'cd06861', NULL, 'PX_Vps5p', NULL, NULL, 'PX_Vps5p', 13047),
(13048, 'cd09240', NULL, 'BRO1_Alix', NULL, NULL, 'BRO1_Alix', 13048),
(13049, 'cd00272', NULL, 'Chemokine_CC', NULL, NULL, 'Chemokine_CC', 13049),
(13050, 'cd07592', NULL, 'BAR_Endophilin_A', NULL, NULL, 'BAR_Endophilin_A', 13050),
(13051, 'cd08340', NULL, 'DED_c-FLIP_r2', NULL, NULL, 'DED_c-FLIP_r2', 13051),
(13052, 'cd08427', NULL, 'PBP2_LTTR_like_2', NULL, NULL, 'PBP2_LTTR_like_2', 13052),
(13053, 'cd03142', NULL, 'GATase1_ThuA', NULL, NULL, 'GATase1_ThuA', 13053),
(13054, 'cd05250', NULL, 'CC3_like_SDR_a', NULL, NULL, 'CC3_like_SDR_a', 13054),
(13055, 'cd07047', NULL, 'BMC_PduB_repeat1', NULL, NULL, 'BMC_PduB_repeat1', 13055),
(13056, 'cd00131', NULL, 'PAX', NULL, NULL, 'PAX', 13056),
(13057, 'cd15540', NULL, 'PHD2_AIRE', NULL, NULL, 'PHD2_AIRE', 13057),
(13058, 'cd14660', NULL, 'E2F_DD', NULL, NULL, 'E2F_DD', 13058),
(13059, 'cd07941', NULL, 'DRE_TIM_LeuA3', NULL, NULL, 'DRE_TIM_LeuA3', 13059),
(13060, 'cd17752', NULL, 'BRCT_RFC1', NULL, NULL, 'BRCT_RFC1', 13060),
(13061, 'cd13116', NULL, 'POLO_box_Plk4_3', NULL, NULL, 'POLO_box_Plk4_3', 13061),
(13062, 'cd01410', NULL, 'SIRT7', NULL, NULL, 'SIRT7', 13062),
(13063, 'cd05670', NULL, 'M20_Acy1_YkuR-like', NULL, NULL, 'M20_Acy1_YkuR-like', 13063);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(13064, 'cd14301', NULL, 'UBA_UBS3B', NULL, NULL, 'UBA_UBS3B', 13064),
(13065, 'cd02897', NULL, 'A2M_2', NULL, NULL, 'A2M_2', 13065),
(13066, 'cd01668', NULL, 'TGS_RSH', NULL, NULL, 'TGS_RSH', 13066),
(13067, 'cd08001', NULL, 'WGR_PARP1_like', NULL, NULL, 'WGR_PARP1_like', 13067),
(13068, 'cd01542', NULL, 'PBP1_TreR-like', NULL, NULL, 'PBP1_TreR-like', 13068),
(13069, 'cd01435', NULL, 'RNAP_I_RPA1_N', NULL, NULL, 'RNAP_I_RPA1_N', 13069),
(13070, 'cd19699', NULL, 'bHLH_TS_dMYOD_like', NULL, NULL, 'bHLH_TS_dMYOD_like', 13070),
(13071, 'cd07615', NULL, 'BAR_Endophilin_A3', NULL, NULL, 'BAR_Endophilin_A3', 13071),
(13072, 'cd14153', NULL, 'PK_KSR2', NULL, NULL, 'PK_KSR2', 13072),
(13073, 'cd01914', NULL, 'HCP', NULL, NULL, 'HCP', 13073),
(13074, 'cd10960', NULL, 'CE4_NodB_like_1', NULL, NULL, 'CE4_NodB_like_1', 13074),
(13075, 'cd09505', NULL, 'SAM_WDSUB1', NULL, NULL, 'SAM_WDSUB1', 13075),
(13076, 'cd16464', NULL, 'RING-H2_Pirh2', NULL, NULL, 'RING-H2_Pirh2', 13076),
(13077, 'cd17747', NULL, 'BRCT_PARP1', NULL, NULL, 'BRCT_PARP1', 13077),
(13078, 'cd07518', NULL, 'HAD_YbiV-Like', NULL, NULL, 'HAD_YbiV-Like', 13078),
(13079, 'cd09526', NULL, 'SAM_Samd3', NULL, NULL, 'SAM_Samd3', 13079),
(13080, 'cd03601', NULL, 'CLECT_TC14_like', NULL, NULL, 'CLECT_TC14_like', 13080),
(13081, 'cd15061', NULL, '7tmA_tyramine_R-like', NULL, NULL, '7tmA_tyramine_R-like', 13081),
(13082, 'cd08995', NULL, 'GH32_EcAec43-like', NULL, NULL, 'GH32_EcAec43-like', 13082),
(13083, 'cd11498', NULL, 'SLC6sbd_GlyT1', NULL, NULL, 'SLC6sbd_GlyT1', 13083),
(13084, 'cd17073', NULL, 'KHA', NULL, NULL, 'KHA', 13084),
(13085, 'cd07203', NULL, 'cPLA2_Fungal_PLB', NULL, NULL, 'cPLA2_Fungal_PLB', 13085),
(13086, 'cd11419', NULL, 'bHLHzip_TFAP4', NULL, NULL, 'bHLHzip_TFAP4', 13086),
(13087, 'cd18999', NULL, 'LGIC_ECD_GABAAR_B', NULL, NULL, 'LGIC_ECD_GABAAR_B', 13087),
(13088, 'cd04182', NULL, 'GT_2_like_f', NULL, NULL, 'GT_2_like_f', 13088),
(13089, 'cd05632', NULL, 'STKc_GRK5', NULL, NULL, 'STKc_GRK5', 13089),
(13090, 'cd07849', NULL, 'STKc_ERK1_2_like', NULL, NULL, 'STKc_ERK1_2_like', 13090),
(13091, 'cd12130', NULL, 'Apl', NULL, NULL, 'Apl', 13091),
(13092, 'cd09699', NULL, 'Csm6_III-A', NULL, NULL, 'Csm6_III-A', 13092),
(13093, 'cd15018', NULL, '7tm_TAS2R41-like', NULL, NULL, '7tm_TAS2R41-like', 13093),
(13094, 'cd18817', NULL, 'GH43f_LbAraf43-like', NULL, NULL, 'GH43f_LbAraf43-like', 13094),
(13095, 'cd18279', NULL, 'BTB_POZ_SPOP-like', NULL, NULL, 'BTB_POZ_SPOP-like', 13095),
(13096, 'cd15765', NULL, 'FYVE_Slp3', NULL, NULL, 'FYVE_Slp3', 13096),
(13097, 'cd06475', NULL, 'ACD_HspB1_like', NULL, NULL, 'ACD_HspB1_like', 13097),
(13098, 'cd00737', NULL, 'lyz_endolysin_autolysin', NULL, NULL, 'lyz_endolysin_autolysin', 13098),
(13099, 'cd00891', NULL, 'PI3Kc', NULL, NULL, 'PI3Kc', 13099),
(13100, 'cd04514', NULL, 'Taspase1_like', NULL, NULL, 'Taspase1_like', 13100),
(13101, 'cd07166', NULL, 'NR_DBD_REV_ERB', NULL, NULL, 'NR_DBD_REV_ERB', 13101),
(13102, 'cd13974', NULL, 'STKc_SHIK', NULL, NULL, 'STKc_SHIK', 13102),
(13103, 'cd18799', NULL, 'SF2_C_EcoAI-like', NULL, NULL, 'SF2_C_EcoAI-like', 13103),
(13104, 'cd16261', NULL, 'EF2_snRNP_III', NULL, NULL, 'EF2_snRNP_III', 13104),
(13105, 'cd07109', NULL, 'ALDH_AAS00426', NULL, NULL, 'ALDH_AAS00426', 13105),
(13106, 'cd08312', NULL, 'Death_MyD88', NULL, NULL, 'Death_MyD88', 13106),
(13107, 'cd08369', NULL, 'FMT_core', NULL, NULL, 'FMT_core', 13107),
(13108, 'cd17483', NULL, 'MFS_Atg22_like', NULL, NULL, 'MFS_Atg22_like', 13108),
(13109, 'cd01916', NULL, 'ACS_1', NULL, NULL, 'ACS_1', 13109),
(13110, 'cd05734', NULL, 'Ig_DSCAM', NULL, NULL, 'Ig_DSCAM', 13110),
(13111, 'cd13156', NULL, 'KOW_RPL6', NULL, NULL, 'KOW_RPL6', 13111),
(13112, 'cd05352', NULL, 'MDH-like_SDR_c', NULL, NULL, 'MDH-like_SDR_c', 13112),
(13113, 'cd19137', NULL, 'AKR_AKR3F1', NULL, NULL, 'AKR_AKR3F1', 13113),
(13114, 'cd17981', NULL, 'DEXHc_DHX36', NULL, NULL, 'DEXHc_DHX36', 13114),
(13115, 'cd01121', NULL, 'Sms', NULL, NULL, 'Sms', 13115),
(13116, 'cd14146', NULL, 'STKc_MLK4', NULL, NULL, 'STKc_MLK4', 13116),
(13117, 'cd16917', NULL, 'HATPase_UhpB-NarQ-NarX-like', NULL, NULL, 'HATPase_UhpB-NarQ-NarX-like', 13117);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(13118, 'cd11531', NULL, 'NTP-PPase_BsYpjD', NULL, NULL, 'NTP-PPase_BsYpjD', 13118),
(13119, 'cd16180', NULL, 'EFh_PEF_Group_I', NULL, NULL, 'EFh_PEF_Group_I', 13119),
(13120, 'cd09162', NULL, 'PLDc_CLS_unchar1_2', NULL, NULL, 'PLDc_CLS_unchar1_2', 13120),
(13121, 'cd09909', NULL, 'HIV-1-like_HR1-HR2', NULL, NULL, 'HIV-1-like_HR1-HR2', 13121),
(13122, 'cd12488', NULL, 'RRM2_hnRNPR', NULL, NULL, 'RRM2_hnRNPR', 13122),
(13123, 'cd18555', NULL, 'ABC_6TM_T1SS_like', NULL, NULL, 'ABC_6TM_T1SS_like', 13123),
(13124, 'cd15660', NULL, 'PHD5_NSD2', NULL, NULL, 'PHD5_NSD2', 13124),
(13125, 'cd19101', NULL, 'AKR_unchar', NULL, NULL, 'AKR_unchar', 13125),
(13126, 'cd16416', NULL, 'HAD_BsYqeG-like', NULL, NULL, 'HAD_BsYqeG-like', 13126),
(13127, 'cd16523', NULL, 'RING-HC_MYLIP', NULL, NULL, 'RING-HC_MYLIP', 13127),
(13128, 'cd10519', NULL, 'SET_EZH', NULL, NULL, 'SET_EZH', 13128),
(13129, 'cd18626', NULL, 'CD_eEF3', NULL, NULL, 'CD_eEF3', 13129),
(13130, 'cd18505', NULL, 'BACK1_LZTR1', NULL, NULL, 'BACK1_LZTR1', 13130),
(13131, 'cd05232', NULL, 'UDP_G4E_4_SDR_e', NULL, NULL, 'UDP_G4E_4_SDR_e', 13131),
(13132, 'cd01942', NULL, 'ribokinase_group_A', NULL, NULL, 'ribokinase_group_A', 13132),
(13133, 'cd14990', NULL, '7tmA_GPR146', NULL, NULL, '7tmA_GPR146', 13133),
(13134, 'cd15600', NULL, 'PHD6_KMT2C', NULL, NULL, 'PHD6_KMT2C', 13134),
(13135, 'cd15137', NULL, '7tmA_Relaxin_R', NULL, NULL, '7tmA_Relaxin_R', 13135),
(13136, 'cd10235', NULL, 'HscC_like_NBD', NULL, NULL, 'HscC_like_NBD', 13136),
(13137, 'cd03475', NULL, 'Rieske_SoxF_SoxL', NULL, NULL, 'Rieske_SoxF_SoxL', 13137),
(13138, 'cd02901', NULL, 'Macro_Poa1p-like', NULL, NULL, 'Macro_Poa1p-like', 13138),
(13139, 'cd14522', NULL, 'DSP_STYX', NULL, NULL, 'DSP_STYX', 13139),
(13140, 'cd03418', NULL, 'GRX_GRXb_1_3_like', NULL, NULL, 'GRX_GRXb_1_3_like', 13140),
(13141, 'cd20487', NULL, 'USP28_C', NULL, NULL, 'USP28_C', 13141),
(13142, 'cd08238', NULL, 'sorbose_phosphate_red', NULL, NULL, 'sorbose_phosphate_red', 13142),
(13143, 'cd19970', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, 'PBP1_ABC_sugar_binding-like', 13143),
(13144, 'cd13538', NULL, 'PBP2_ModA_like_1', NULL, NULL, 'PBP2_ModA_like_1', 13144),
(13145, 'cd00640', NULL, 'Trp-synth-beta_II', NULL, NULL, 'Trp-synth-beta_II', 13145),
(13146, 'cd09746', NULL, 'Csm6_III-A', NULL, NULL, 'Csm6_III-A', 13146),
(13147, 'cd13763', NULL, 'TGF_beta_BMP3_like', NULL, NULL, 'TGF_beta_BMP3_like', 13147),
(13148, 'cd06351', NULL, 'PBP1_iGluR_N_LIVBP-like', NULL, NULL, 'PBP1_iGluR_N_LIVBP-like', 13148),
(13149, 'cd09972', NULL, 'LOTUS_TDRD_OSKAR', NULL, NULL, 'LOTUS_TDRD_OSKAR', 13149),
(13150, 'cd13337', NULL, 'FERM-like_C_SNX17', NULL, NULL, 'FERM-like_C_SNX17', 13150),
(13151, 'cd11678', NULL, 'archaeal_LSm', NULL, NULL, 'archaeal_LSm', 13151),
(13152, 'cd07439', NULL, 'FANCE_c-term', NULL, NULL, 'FANCE_c-term', 13152),
(13153, 'cd19813', NULL, 'Bbox1_BRAT-like', NULL, NULL, 'Bbox1_BRAT-like', 13153),
(13154, 'cd02908', NULL, 'Macro_OAADPr_deacetylase', NULL, NULL, 'Macro_OAADPr_deacetylase', 13154),
(13155, 'cd14330', NULL, 'UBA_atDRM2_like', NULL, NULL, 'UBA_atDRM2_like', 13155),
(13156, 'cd17499', NULL, 'RMtype1_S_CloLW9ORF3270P-TRD1-CR1_like', NULL, NULL, 'RMtype1_S_CloLW9ORF3270P-TRD1-CR1_like', 13156),
(13157, 'cd04477', NULL, 'RPA1N', NULL, NULL, 'RPA1N', 13157),
(13158, 'cd13953', NULL, '7tm_classC_mGluR-like', NULL, NULL, '7tm_classC_mGluR-like', 13158),
(13159, 'cd16593', NULL, 'RING-HC_TRIM10_C-IV', NULL, NULL, 'RING-HC_TRIM10_C-IV', 13159),
(13160, 'cd14586', NULL, 'PTP-MTMR3', NULL, NULL, 'PTP-MTMR3', 13160),
(13161, 'cd01004', NULL, 'PBP2_MidA_like', NULL, NULL, 'PBP2_MidA_like', 13161),
(13162, 'cd02175', NULL, 'GH16_lichenase', NULL, NULL, 'GH16_lichenase', 13162),
(13163, 'cd17005', NULL, 'CID_SFRS15_SCAF4', NULL, NULL, 'CID_SFRS15_SCAF4', 13163),
(13164, 'cd18537', NULL, 'PTP-IVa1', NULL, NULL, 'PTP-IVa1', 13164),
(13165, 'cd18660', NULL, 'CD1_tandem', NULL, NULL, 'CD1_tandem', 13165),
(13166, 'cd01915', NULL, 'CODH', NULL, NULL, 'CODH', 13166),
(13167, 'cd13667', NULL, 'PBP2_TRAP_DctP1', NULL, NULL, 'PBP2_TRAP_DctP1', 13167);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(13168, 'cd05152', NULL, 'MPH2''', NULL, NULL, 'MPH2''', 13168),
(13169, 'cd17016', NULL, 'ING_Pho23p_like', NULL, NULL, 'ING_Pho23p_like', 13169),
(13170, 'cd02195', NULL, 'SelD', NULL, NULL, 'SelD', 13170),
(13171, 'cd12336', NULL, 'RRM_RBM7_like', NULL, NULL, 'RRM_RBM7_like', 13171),
(13172, 'cd19007', NULL, 'LGIC_ECD_GABAR_GRD-like', NULL, NULL, 'LGIC_ECD_GABAR_GRD-like', 13172),
(13173, 'cd07304', NULL, 'Chorismate_synthase', NULL, NULL, 'Chorismate_synthase', 13173),
(13174, 'cd17541', NULL, 'REC_CheB-like', NULL, NULL, 'REC_CheB-like', 13174),
(13175, 'cd11238', NULL, 'Sema_2A', NULL, NULL, 'Sema_2A', 13175),
(13176, 'cd00322', NULL, 'FNR_like', NULL, NULL, 'FNR_like', 13176),
(13177, 'cd15867', NULL, 'R-SNARE_YKT6', NULL, NULL, 'R-SNARE_YKT6', 13177),
(13178, 'cd03397', NULL, 'PAP2_acid_phosphatase', NULL, NULL, 'PAP2_acid_phosphatase', 13178),
(13179, 'cd09641', NULL, 'Cas3''''_I', NULL, NULL, 'Cas3''''_I', 13179),
(13180, 'cd07627', NULL, 'BAR_Vps5p', NULL, NULL, 'BAR_Vps5p', 13180),
(13181, 'cd15613', NULL, 'PHD_AL_plant', NULL, NULL, 'PHD_AL_plant', 13181),
(13182, 'cd06208', NULL, 'CYPOR_like_FNR', NULL, NULL, 'CYPOR_like_FNR', 13182),
(13183, 'cd18042', NULL, 'DEXXQc_SETX', NULL, NULL, 'DEXXQc_SETX', 13183),
(13184, 'cd08399', NULL, 'C2_PI3K_class_I_gamma', NULL, NULL, 'C2_PI3K_class_I_gamma', 13184),
(13185, 'cd15584', NULL, 'PHD_ING1_2', NULL, NULL, 'PHD_ING1_2', 13185),
(13186, 'cd10953', NULL, 'CE4_SlAXE_like', NULL, NULL, 'CE4_SlAXE_like', 13186),
(13187, 'cd08607', NULL, 'GDPD_GDE5', NULL, NULL, 'GDPD_GDE5', 13187),
(13188, 'cd01420', NULL, 'MoaC_PE', NULL, NULL, 'MoaC_PE', 13188),
(13189, 'cd04610', NULL, 'CBS_pair_ParBc_assoc', NULL, NULL, 'CBS_pair_ParBc_assoc', 13189),
(13190, 'cd14796', NULL, 'RNAse_HIII_N', NULL, NULL, 'RNAse_HIII_N', 13190),
(13191, 'cd18334', NULL, 'BTB_POZ_ZBTB30_HIC2', NULL, NULL, 'BTB_POZ_ZBTB30_HIC2', 13191),
(13192, 'cd06306', NULL, 'PBP1_TorT-like', NULL, NULL, 'PBP1_TorT-like', 13192),
(13193, 'cd11385', NULL, 'RagC_like', NULL, NULL, 'RagC_like', 13193),
(13194, 'cd08854', NULL, 'ArfGap_AGAP1', NULL, NULL, 'ArfGap_AGAP1', 13194),
(13195, 'cd09715', NULL, 'Csp2_I-U', NULL, NULL, 'Csp2_I-U', 13195),
(13196, 'cd12925', NULL, 'iSH2_PIK3R3', NULL, NULL, 'iSH2_PIK3R3', 13196),
(13197, 'cd03403', NULL, 'SPFH_stomatin', NULL, NULL, 'SPFH_stomatin', 13197),
(13198, 'cd06978', NULL, 'cupin_EctC', NULL, NULL, 'cupin_EctC', 13198),
(13199, 'cd19448', NULL, 'FABP_pancrustacea', NULL, NULL, 'FABP_pancrustacea', 13199),
(13200, 'cd11746', NULL, 'GH94N_like', NULL, NULL, 'GH94N_like', 13200),
(13201, 'cd01529', NULL, '4RHOD_Repeats', NULL, NULL, '4RHOD_Repeats', 13201),
(13202, 'cd01518', NULL, 'RHOD_YceA', NULL, NULL, 'RHOD_YceA', 13202),
(13203, 'cd05093', NULL, 'PTKc_TrkB', NULL, NULL, 'PTKc_TrkB', 13203),
(13204, 'cd18810', NULL, 'SF2_C_TRCF', NULL, NULL, 'SF2_C_TRCF', 13204),
(13205, 'cd03200', NULL, 'GST_C_AIMP2', NULL, NULL, 'GST_C_AIMP2', 13205),
(13206, 'cd06525', NULL, 'GH25_Lyc-like', NULL, NULL, 'GH25_Lyc-like', 13206),
(13207, 'cd09662', NULL, 'Csm5_III-A', NULL, NULL, 'Csm5_III-A', 13207),
(13208, 'cd06465', NULL, 'p23_hB-ind1_like', NULL, NULL, 'p23_hB-ind1_like', 13208),
(13209, 'cd12175', NULL, '2-Hacid_dh_11', NULL, NULL, '2-Hacid_dh_11', 13209),
(13210, 'cd16115', NULL, 'Ubl_SUMO2_3_4', NULL, NULL, 'Ubl_SUMO2_3_4', 13210),
(13211, 'cd16951', NULL, 'HATPase_EL346-LOV-HK-like', NULL, NULL, 'HATPase_EL346-LOV-HK-like', 13211),
(13212, 'cd12304', NULL, 'RRM_Set1', NULL, NULL, 'RRM_Set1', 13212),
(13213, 'cd20289', NULL, 'cupin_ADO', NULL, NULL, 'cupin_ADO', 13213),
(13214, 'cd02227', NULL, 'cupin_TM1112-like', NULL, NULL, 'cupin_TM1112-like', 13214),
(13215, 'cd04161', NULL, 'Arl2l1_Arl13_like', NULL, NULL, 'Arl2l1_Arl13_like', 13215),
(13216, 'cd07261', NULL, 'EhpR_like', NULL, NULL, 'EhpR_like', 13216),
(13217, 'cd01045', NULL, 'Ferritin_like_AB', NULL, NULL, 'Ferritin_like_AB', 13217),
(13218, 'cd08849', NULL, 'ArfGap_ASAP2', NULL, NULL, 'ArfGap_ASAP2', 13218),
(13219, 'cd11789', NULL, 'SH3_Nebulin_family_C', NULL, NULL, 'SH3_Nebulin_family_C', 13219);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(13220, 'cd10497', NULL, 'MH2_SMAD_1_5_9', NULL, NULL, 'MH2_SMAD_1_5_9', 13220),
(13221, 'cd16973', NULL, 'Alpha_kinase_ALPK3', NULL, NULL, 'Alpha_kinase_ALPK3', 13221),
(13222, 'cd07947', NULL, 'DRE_TIM_Re_CS', NULL, NULL, 'DRE_TIM_Re_CS', 13222),
(13223, 'cd02891', NULL, 'A2M_like', NULL, NULL, 'A2M_like', 13223),
(13224, 'cd11310', NULL, '14-3-3_1', NULL, NULL, '14-3-3_1', 13224),
(13225, 'cd15391', NULL, '7tmA_NPR-like_invertebrate', NULL, NULL, '7tmA_NPR-like_invertebrate', 13225),
(13226, 'cd10475', NULL, 'EphR_LBD_B6', NULL, NULL, 'EphR_LBD_B6', 13226),
(13227, 'cd12555', NULL, 'RRM2_RBM15', NULL, NULL, 'RRM2_RBM15', 13227),
(13228, 'cd14773', NULL, 'TrHb2_PhHbO-like_O', NULL, NULL, 'TrHb2_PhHbO-like_O', 13228),
(13229, 'cd02792', NULL, 'MopB_CT_Formate-Dh-Na-like', NULL, NULL, 'MopB_CT_Formate-Dh-Na-like', 13229),
(13230, 'cd07538', NULL, 'P-type_ATPase', NULL, NULL, 'P-type_ATPase', 13230),
(13231, 'cd15229', NULL, '7tmA_OR8S1-like', NULL, NULL, '7tmA_OR8S1-like', 13231),
(13232, 'cd07724', NULL, 'POD-like_MBL-fold', NULL, NULL, 'POD-like_MBL-fold', 13232),
(13233, 'cd09751', NULL, 'Cas8a2_I-A', NULL, NULL, 'Cas8a2_I-A', 13233),
(13234, 'cd00983', NULL, 'recA', NULL, NULL, 'recA', 13234),
(13235, 'cd08850', NULL, 'ArfGap_ACAP3', NULL, NULL, 'ArfGap_ACAP3', 13235),
(13236, 'cd13737', NULL, 'SPRY_PRY_TRIM25-like', NULL, NULL, 'SPRY_PRY_TRIM25-like', 13236),
(13237, 'cd09358', NULL, 'LIM_Mical_like', NULL, NULL, 'LIM_Mical_like', 13237),
(13238, 'cd18059', NULL, 'DEXHc_CHD7', NULL, NULL, 'DEXHc_CHD7', 13238),
(13239, 'cd08588', NULL, 'PI-PLCc_At5g67130_like', NULL, NULL, 'PI-PLCc_At5g67130_like', 13239),
(13240, 'cd21626', NULL, 'MERS-CoV-like_Spike_S1_NTD', NULL, NULL, 'MERS-CoV-like_Spike_S1_NTD', 13240),
(13241, 'cd18628', NULL, 'CD3_cpSRP43_like', NULL, NULL, 'CD3_cpSRP43_like', 13241),
(13242, 'cd17525', NULL, 'RMtype1_S_Eco15ORF14057P-TRD1-CR1_like', NULL, NULL, 'RMtype1_S_Eco15ORF14057P-TRD1-CR1_like', 13242),
(13243, 'cd19694', NULL, 'bHLH_dnHLH_ID4', NULL, NULL, 'bHLH_dnHLH_ID4', 13243),
(13244, 'sd00041', NULL, 'GyrA-ParC_C', NULL, NULL, 'GyrA-ParC_C', 13244),
(13245, 'cd05396', NULL, 'An_peroxidase_like', NULL, NULL, 'An_peroxidase_like', 13245),
(13246, 'cd04916', NULL, 'ACT_AKiii-YclM-BS_2', NULL, NULL, 'ACT_AKiii-YclM-BS_2', 13246),
(13247, 'cd14005', NULL, 'STKc_PIM', NULL, NULL, 'STKc_PIM', 13247),
(13248, 'cd04824', NULL, 'eu_ALAD_PBGS_cysteine_rich', NULL, NULL, 'eu_ALAD_PBGS_cysteine_rich', 13248),
(13249, 'cd15002', NULL, '7tmA_GPR151', NULL, NULL, '7tmA_GPR151', 13249),
(13250, 'cd03472', NULL, 'Rieske_RO_Alpha_BPDO_like', NULL, NULL, 'Rieske_RO_Alpha_BPDO_like', 13250),
(13251, 'cd14917', NULL, 'MYSc_Myh7', NULL, NULL, 'MYSc_Myh7', 13251),
(13252, 'cd04382', NULL, 'RhoGAP_MgcRacGAP', NULL, NULL, 'RhoGAP_MgcRacGAP', 13252),
(13253, 'cd04092', NULL, 'mtEFG2_II_like', NULL, NULL, 'mtEFG2_II_like', 13253),
(13254, 'cd12382', NULL, 'RRM_RBMX_like', NULL, NULL, 'RRM_RBMX_like', 13254),
(13255, 'cd08163', NULL, 'MPP_Cdc1', NULL, NULL, 'MPP_Cdc1', 13255),
(13256, 'cd12716', NULL, 'RRM1_2_NP220', NULL, NULL, 'RRM1_2_NP220', 13256),
(13257, 'cd04240', NULL, 'AAK_UC', NULL, NULL, 'AAK_UC', 13257),
(13258, 'cd15031', NULL, '7tmF_FZD3_insect', NULL, NULL, '7tmF_FZD3_insect', 13258),
(13259, 'cd18668', NULL, 'CD1_tandem_CHD5-9_like', NULL, NULL, 'CD1_tandem_CHD5-9_like', 13259),
(13260, 'cd17329', NULL, 'MFS_MdtH_MDR_like', NULL, NULL, 'MFS_MdtH_MDR_like', 13260),
(13261, 'cd05686', NULL, 'S1_pNO40', NULL, NULL, 'S1_pNO40', 13261),
(13262, 'cd11702', NULL, 'DHR2_DOCK6', NULL, NULL, 'DHR2_DOCK6', 13262),
(13263, 'cd05507', NULL, 'Bromo_brd8_like', NULL, NULL, 'Bromo_brd8_like', 13263),
(13264, 'cd04878', NULL, 'ACT_AHAS', NULL, NULL, 'ACT_AHAS', 13264),
(13265, 'cd00146', NULL, 'PKD', NULL, NULL, 'PKD', 13265),
(13266, 'cd06238', NULL, 'M14-like', NULL, NULL, 'M14-like', 13266),
(13267, 'cd11651', NULL, 'YPK1_N_like', NULL, NULL, 'YPK1_N_like', 13267),
(13268, 'cd05081', NULL, 'PTKc_Jak3_rpt2', NULL, NULL, 'PTKc_Jak3_rpt2', 13268),
(13269, 'cd04975', NULL, 'Ig4_SCFR_like', NULL, NULL, 'Ig4_SCFR_like', 13269);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(13270, 'cd17334', NULL, 'MFS_SLC49', NULL, NULL, 'MFS_SLC49', 13270),
(13271, 'cd00764', NULL, 'Eukaryotic_PFK', NULL, NULL, 'Eukaryotic_PFK', 13271),
(13272, 'cd14515', NULL, 'DUSP3-like', NULL, NULL, 'DUSP3-like', 13272),
(13273, 'cd03528', NULL, 'Rieske_RO_ferredoxin', NULL, NULL, 'Rieske_RO_ferredoxin', 13273),
(13274, 'cd13851', NULL, 'CuRO_1_Fet3p', NULL, NULL, 'CuRO_1_Fet3p', 13274),
(13275, 'cd03111', NULL, 'CpaE-like', NULL, NULL, 'CpaE-like', 13275),
(13276, 'cd03163', NULL, 'TM4SF8_like_LEL', NULL, NULL, 'TM4SF8_like_LEL', 13276),
(13277, 'cd13308', NULL, 'PH_3BP2', NULL, NULL, 'PH_3BP2', 13277),
(13278, 'cd09247', NULL, 'BRO1_Alix_like_2', NULL, NULL, 'BRO1_Alix_like_2', 13278),
(13279, 'cd18687', NULL, 'PIN_VapC-like', NULL, NULL, 'PIN_VapC-like', 13279),
(13280, 'cd18358', NULL, 'BTB2_POZ_RHOBTB1', NULL, NULL, 'BTB2_POZ_RHOBTB1', 13280),
(13281, 'cd20484', NULL, 'C_PKS-NRPS_PksJ-like', NULL, NULL, 'C_PKS-NRPS_PksJ-like', 13281),
(13282, 'cd06580', NULL, 'TM_PBP1_transp_TpRbsC_like', NULL, NULL, 'TM_PBP1_transp_TpRbsC_like', 13282),
(13283, 'cd01826', NULL, 'acyloxyacyl_hydrolase_like', NULL, NULL, 'acyloxyacyl_hydrolase_like', 13283),
(13284, 'cd00774', NULL, 'GlyRS-like_core', NULL, NULL, 'GlyRS-like_core', 13284),
(13285, 'cd07059', NULL, 'BMC_PduA', NULL, NULL, 'BMC_PduA', 13285),
(13286, 'cd08484', NULL, 'PBP2_LTTR_beta_lactamase', NULL, NULL, 'PBP2_LTTR_beta_lactamase', 13286),
(13287, 'cd17123', NULL, 'Ubl_UHRF2', NULL, NULL, 'Ubl_UHRF2', 13287),
(13288, 'cd15010', NULL, '7tmA_ACKR1_DARC', NULL, NULL, '7tmA_ACKR1_DARC', 13288),
(13289, 'cd04901', NULL, 'ACT_3PGDH', NULL, NULL, 'ACT_3PGDH', 13289),
(13290, 'cd10419', NULL, 'SH2_Src_Fyn_isoform_b_like', NULL, NULL, 'SH2_Src_Fyn_isoform_b_like', 13290),
(13291, 'cd08959', NULL, 'ArfGap_ArfGap1_like', NULL, NULL, 'ArfGap_ArfGap1_like', 13291),
(13292, 'cd19044', NULL, 'LGIC_ECD_GABAAR_G2', NULL, NULL, 'LGIC_ECD_GABAAR_G2', 13292),
(13293, 'cd18172', NULL, 'M14_CP_plant', NULL, NULL, 'M14_CP_plant', 13293),
(13294, 'cd12617', NULL, 'RRM2_TIAR', NULL, NULL, 'RRM2_TIAR', 13294),
(13295, 'cd11959', NULL, 'SH3_Cortactin', NULL, NULL, 'SH3_Cortactin', 13295),
(13296, 'cd08048', NULL, 'TAF11', NULL, NULL, 'TAF11', 13296),
(13297, 'cd14891', NULL, 'MYSc_Myo30', NULL, NULL, 'MYSc_Myo30', 13297),
(13298, 'cd17985', NULL, 'DEXHc_DHX57', NULL, NULL, 'DEXHc_DHX57', 13298),
(13299, 'cd07033', NULL, 'TPP_PYR_DXS_TK_like', NULL, NULL, 'TPP_PYR_DXS_TK_like', 13299),
(13300, 'cd08499', NULL, 'PBP2_Ylib_like', NULL, NULL, 'PBP2_Ylib_like', 13300),
(13301, 'cd04727', NULL, 'pdxS', NULL, NULL, 'pdxS', 13301),
(13302, 'cd12532', NULL, 'RRM3_MEI2_fungi', NULL, NULL, 'RRM3_MEI2_fungi', 13302),
(13303, 'cd02094', NULL, 'P-type_ATPase_Cu-like', NULL, NULL, 'P-type_ATPase_Cu-like', 13303),
(13304, 'cd14074', NULL, 'STKc_SNRK', NULL, NULL, 'STKc_SNRK', 13304),
(13305, 'cd11573', NULL, 'GH99_GH71_like', NULL, NULL, 'GH99_GH71_like', 13305),
(13306, 'cd14058', NULL, 'STKc_TAK1', NULL, NULL, 'STKc_TAK1', 13306),
(13307, 'cd13167', NULL, 'PTB_P-CLI1', NULL, NULL, 'PTB_P-CLI1', 13307),
(13308, 'cd06346', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, 'PBP1_ABC_ligand_binding-like', 13308),
(13309, 'cd12115', NULL, 'A_NRPS_Sfm_like', NULL, NULL, 'A_NRPS_Sfm_like', 13309),
(13310, 'cd06224', NULL, 'REM', NULL, NULL, 'REM', 13310),
(13311, 'cd18225', NULL, 'BTB_POZ_ZBTB40', NULL, NULL, 'BTB_POZ_ZBTB40', 13311),
(13312, 'cd17096', NULL, 'FERM_F1_kindlins', NULL, NULL, 'FERM_F1_kindlins', 13312),
(13313, 'cd04900', NULL, 'ACT_UUR-like_1', NULL, NULL, 'ACT_UUR-like_1', 13313),
(13314, 'cd19403', NULL, 'TGF_beta_GDF9', NULL, NULL, 'TGF_beta_GDF9', 13314),
(13315, 'cd15630', NULL, 'PHD_BAZ2B', NULL, NULL, 'PHD_BAZ2B', 13315),
(13316, 'cd12713', NULL, 'RRM_TNRC6C', NULL, NULL, 'RRM_TNRC6C', 13316),
(13317, 'cd04685', NULL, 'Nudix_Hydrolase_26', NULL, NULL, 'Nudix_Hydrolase_26', 13317),
(13318, 'cd17039', NULL, 'Ubl_ubiquitin_like', NULL, NULL, 'Ubl_ubiquitin_like', 13318),
(13319, 'cd05029', NULL, 'S-100A6', NULL, NULL, 'S-100A6', 13319),
(13320, 'cd13198', NULL, 'FERM_C1_MyoVII', NULL, NULL, 'FERM_C1_MyoVII', 13320); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(13321, 'cd03182', NULL, 'GST_C_GTT2_like', NULL, NULL, 'GST_C_GTT2_like', 13321),
(13322, 'cd08246', NULL, 'crotonyl_coA_red', NULL, NULL, 'crotonyl_coA_red', 13322),
(13323, 'cd07396', NULL, 'MPP_Nbla03831', NULL, NULL, 'MPP_Nbla03831', 13323),
(13324, 'cd15319', NULL, '7tmA_D1B_dopamine_R', NULL, NULL, '7tmA_D1B_dopamine_R', 13324),
(13325, 'cd17544', NULL, 'REC_2_GGDEF', NULL, NULL, 'REC_2_GGDEF', 13325),
(13326, 'cd01821', NULL, 'Rhamnogalacturan_acetylesterase_like', NULL, NULL, 'Rhamnogalacturan_acetylesterase_like', 13326),
(13327, 'cd04231', NULL, 'Rusticyanin', NULL, NULL, 'Rusticyanin', 13327),
(13328, 'cd18233', NULL, 'BTB_POZ_ZBTB49', NULL, NULL, 'BTB_POZ_ZBTB49', 13328),
(13329, 'cd05913', NULL, 'PaaK', NULL, NULL, 'PaaK', 13329),
(13330, 'cd09856', NULL, 'PIN_FEN1-like', NULL, NULL, 'PIN_FEN1-like', 13330),
(13331, 'cd18966', NULL, 'chromodomain', NULL, NULL, 'chromodomain', 13331),
(13332, 'cd13747', NULL, 'UreI_AmiS_like_1', NULL, NULL, 'UreI_AmiS_like_1', 13332),
(13333, 'cd11939', NULL, 'SH3_ephexin1', NULL, NULL, 'SH3_ephexin1', 13333),
(13334, 'cd00070', NULL, 'GLECT', NULL, NULL, 'GLECT', 13334),
(13335, 'cd16968', NULL, 'Alpha_kinase_MHCK_like', NULL, NULL, 'Alpha_kinase_MHCK_like', 13335),
(13336, 'cd16695', NULL, 'mRING-CH-C4HC2H_ZNRF2', NULL, NULL, 'mRING-CH-C4HC2H_ZNRF2', 13336),
(13337, 'cd05285', NULL, 'sorbitol_DH', NULL, NULL, 'sorbitol_DH', 13337),
(13338, 'cd20305', NULL, 'cupin_OxDC_C', NULL, NULL, 'cupin_OxDC_C', 13338),
(13339, 'cd08237', NULL, 'ribitol-5-phosphate_DH', NULL, NULL, 'ribitol-5-phosphate_DH', 13339),
(13340, 'cd11819', NULL, 'SH3_Cortactin_like', NULL, NULL, 'SH3_Cortactin_like', 13340),
(13341, 'cd18828', NULL, 'GH43_BT3675-like', NULL, NULL, 'GH43_BT3675-like', 13341),
(13342, 'cd03323', NULL, 'D-glucarate_dehydratase', NULL, NULL, 'D-glucarate_dehydratase', 13342),
(13343, 'cd09916', NULL, 'CpxP_like', NULL, NULL, 'CpxP_like', 13343),
(13344, 'cd12566', NULL, 'RRM2_MRD1', NULL, NULL, 'RRM2_MRD1', 13344),
(13345, 'cd13123', NULL, 'MATE_MurJ_like', NULL, NULL, 'MATE_MurJ_like', 13345),
(13346, 'cd14507', NULL, 'PTP-MTM-like', NULL, NULL, 'PTP-MTM-like', 13346),
(13347, 'cd11759', NULL, 'SH3_CRK_C', NULL, NULL, 'SH3_CRK_C', 13347),
(13348, 'cd14510', NULL, 'PTP_VSP_TPTE', NULL, NULL, 'PTP_VSP_TPTE', 13348),
(13349, 'cd14520', NULL, 'DSP_DUSP12', NULL, NULL, 'DSP_DUSP12', 13349),
(13350, 'cd00614', NULL, 'CGS_like', NULL, NULL, 'CGS_like', 13350),
(13351, 'cd09397', NULL, 'LIM1_UF1', NULL, NULL, 'LIM1_UF1', 13351),
(13352, 'cd01999', NULL, 'Argininosuccinate_Synthase', NULL, NULL, 'Argininosuccinate_Synthase', 13352),
(13353, 'cd18007', NULL, 'DEXHc_ATRX-like', NULL, NULL, 'DEXHc_ATRX-like', 13353),
(13354, 'cd06415', NULL, 'GH25_Cpl1-like', NULL, NULL, 'GH25_Cpl1-like', 13354),
(13355, 'cd07434', NULL, 'PHP_PolIIIA_DnaE2', NULL, NULL, 'PHP_PolIIIA_DnaE2', 13355),
(13356, 'cd16946', NULL, 'HATPase_BaeS-like', NULL, NULL, 'HATPase_BaeS-like', 13356),
(13357, 'cd12746', NULL, 'RRM2_RBM12B', NULL, NULL, 'RRM2_RBM12B', 13357),
(13358, 'cd13234', NULL, 'PHsplit_PLC_gamma', NULL, NULL, 'PHsplit_PLC_gamma', 13358),
(13359, 'cd12869', NULL, 'MqsR', NULL, NULL, 'MqsR', 13359),
(13360, 'cd16096', NULL, 'IgV_CD79b_beta', NULL, NULL, 'IgV_CD79b_beta', 13360),
(13361, 'cd09198', NULL, 'PLDc_pPLDbeta_1', NULL, NULL, 'PLDc_pPLDbeta_1', 13361),
(13362, 'cd13314', NULL, 'PH_Rpn13', NULL, NULL, 'PH_Rpn13', 13362),
(13363, 'cd02585', NULL, 'HAD_PMM', NULL, NULL, 'HAD_PMM', 13363),
(13364, 'cd12592', NULL, 'RRM_RBM7', NULL, NULL, 'RRM_RBM7', 13364),
(13365, 'cd16320', NULL, 'MraZ_N', NULL, NULL, 'MraZ_N', 13365),
(13366, 'cd13777', NULL, 'Aar2_N', NULL, NULL, 'Aar2_N', 13366),
(13367, 'cd18739', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, 'PIN_VapC4-5_FitB-like', 13367),
(13368, 'cd17099', NULL, 'FERM_F1_PTPN14_like', NULL, NULL, 'FERM_F1_PTPN14_like', 13368),
(13369, 'cd16671', NULL, 'RING-H2_DTX1_4', NULL, NULL, 'RING-H2_DTX1_4', 13369),
(13370, 'cd19919', NULL, 'REC_NtrC', NULL, NULL, 'REC_NtrC', 13370),
(13371, 'cd09403', NULL, 'LIM2_CRP', NULL, NULL, 'LIM2_CRP', 13371);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(13372, 'cd16780', NULL, 'mRING-HC-C3HC3D_LNX2', NULL, NULL, 'mRING-HC-C3HC3D_LNX2', 13372),
(13373, 'cd16847', NULL, 'STAT3_DBD', NULL, NULL, 'STAT3_DBD', 13373),
(13374, 'cd21408', NULL, '1B_Sen1p-like', NULL, NULL, '1B_Sen1p-like', 13374),
(13375, 'cd06257', NULL, 'DnaJ', NULL, NULL, 'DnaJ', 13375),
(13376, 'cd10549', NULL, 'MtMvhB_like', NULL, NULL, 'MtMvhB_like', 13376),
(13377, 'cd12917', NULL, 'VKOR_euk', NULL, NULL, 'VKOR_euk', 13377),
(13378, 'cd09932', NULL, 'SH2_C-SH2_PLC_gamma_like', NULL, NULL, 'SH2_C-SH2_PLC_gamma_like', 13378),
(13379, 'cd11341', NULL, 'AmyAc_Pullulanase_LD-like', NULL, NULL, 'AmyAc_Pullulanase_LD-like', 13379),
(13380, 'cd09131', NULL, 'PLDc_unchar3', NULL, NULL, 'PLDc_unchar3', 13380),
(13381, 'cd12491', NULL, 'RRM2_RBM47', NULL, NULL, 'RRM2_RBM47', 13381),
(13382, 'cd19811', NULL, 'Bbox1_TRIM66', NULL, NULL, 'Bbox1_TRIM66', 13382),
(13383, 'cd18429', NULL, 'M14_Nna1-like', NULL, NULL, 'M14_Nna1-like', 13383),
(13384, 'cd16834', NULL, 'CNF1-like', NULL, NULL, 'CNF1-like', 13384),
(13385, 'cd18433', NULL, 'BRCT_Rad4_rpt3', NULL, NULL, 'BRCT_Rad4_rpt3', 13385),
(13386, 'cd18466', NULL, 'BACK_KLHL27_IPP', NULL, NULL, 'BACK_KLHL27_IPP', 13386),
(13387, 'cd06960', NULL, 'NR_DBD_HNF4A', NULL, NULL, 'NR_DBD_HNF4A', 13387),
(13388, 'cd15369', NULL, '7tmA_PAR1', NULL, NULL, '7tmA_PAR1', 13388),
(13389, 'cd16524', NULL, 'RING-HC_NHL-1_like', NULL, NULL, 'RING-HC_NHL-1_like', 13389),
(13390, 'cd18717', NULL, 'PIN_ScNmd4p-like', NULL, NULL, 'PIN_ScNmd4p-like', 13390),
(13391, 'cd18119', NULL, 'ATP-synt_V_A-type_alpha_N', NULL, NULL, 'ATP-synt_V_A-type_alpha_N', 13391),
(13392, 'cd11560', NULL, 'W2_eIF5C_like', NULL, NULL, 'W2_eIF5C_like', 13392),
(13393, 'cd11985', NULL, 'SH3_Stac2_C', NULL, NULL, 'SH3_Stac2_C', 13393),
(13394, 'cd09101', NULL, 'INPP5c_SHIP2-INPPL1', NULL, NULL, 'INPP5c_SHIP2-INPPL1', 13394),
(13395, 'cd01671', NULL, 'CARD', NULL, NULL, 'CARD', 13395),
(13396, 'cd00609', NULL, 'AAT_like', NULL, NULL, 'AAT_like', 13396),
(13397, 'cd08466', NULL, 'PBP2_LeuO', NULL, NULL, 'PBP2_LeuO', 13397),
(13398, 'cd09019', NULL, 'galactose_mutarotase_like', NULL, NULL, 'galactose_mutarotase_like', 13398),
(13399, 'cd09595', NULL, 'M1', NULL, NULL, 'M1', 13399),
(13400, 'cd02673', NULL, 'Peptidase_C19Q', NULL, NULL, 'Peptidase_C19Q', 13400),
(13401, 'cd06644', NULL, 'STKc_STK10', NULL, NULL, 'STKc_STK10', 13401),
(13402, 'cd01328', NULL, 'FSL_SPARC', NULL, NULL, 'FSL_SPARC', 13402),
(13403, 'cd11012', NULL, 'CuRO_6_ceruloplasmin', NULL, NULL, 'CuRO_6_ceruloplasmin', 13403),
(13404, 'cd12017', NULL, 'SH3_Tks_3', NULL, NULL, 'SH3_Tks_3', 13404),
(13405, 'cd02974', NULL, 'AhpF_NTD_N', NULL, NULL, 'AhpF_NTD_N', 13405),
(13406, 'cd05018', NULL, 'CoxG', NULL, NULL, 'CoxG', 13406),
(13407, 'cd13192', NULL, 'FERM_C_FRMD3_FRMD5', NULL, NULL, 'FERM_C_FRMD3_FRMD5', 13407),
(13408, 'cd09520', NULL, 'SAM_BICC1', NULL, NULL, 'SAM_BICC1', 13408),
(13409, 'cd10004', NULL, 'RPD3-like', NULL, NULL, 'RPD3-like', 13409),
(13410, 'cd17140', NULL, 'DCX1_DCLK1', NULL, NULL, 'DCX1_DCLK1', 13410),
(13411, 'cd02166', NULL, 'NMNAT_Archaea', NULL, NULL, 'NMNAT_Archaea', 13411),
(13412, 'cd12049', NULL, 'SH3_DOCK4_B', NULL, NULL, 'SH3_DOCK4_B', 13412),
(13413, 'cd15654', NULL, 'PHD3_NSD2', NULL, NULL, 'PHD3_NSD2', 13413),
(13414, 'cd03512', NULL, 'Alkane-hydroxylase', NULL, NULL, 'Alkane-hydroxylase', 13414),
(13415, 'cd16080', NULL, 'TSP-4cc', NULL, NULL, 'TSP-4cc', 13415),
(13416, 'cd05821', NULL, 'TLP_Transthyretin', NULL, NULL, 'TLP_Transthyretin', 13416),
(13417, 'cd03527', NULL, 'RuBisCO_small', NULL, NULL, 'RuBisCO_small', 13417),
(13418, 'cd16094', NULL, 'IgC_CH3_IgD', NULL, NULL, 'IgC_CH3_IgD', 13418),
(13419, 'cd16460', NULL, 'RING-H2_DZIP3', NULL, NULL, 'RING-H2_DZIP3', 13419),
(13420, 'cd06583', NULL, 'PGRP', NULL, NULL, 'PGRP', 13420),
(13421, 'cd09709', NULL, 'Csc2_I-D', NULL, NULL, 'Csc2_I-D', 13421),
(13422, 'cd03526', NULL, 'SQR_QFR_TypeB_TM', NULL, NULL, 'SQR_QFR_TypeB_TM', 13422),
(13423, 'cd05284', NULL, 'arabinose_DH_like', NULL, NULL, 'arabinose_DH_like', 13423),
(13424, 'cd19586', NULL, 'serpin_mimivirus', NULL, NULL, 'serpin_mimivirus', 13424); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(13425, 'cd18606', NULL, 'ABC_6TM_YOR1_D2_like', NULL, NULL, 'ABC_6TM_YOR1_D2_like', 13425),
(13426, 'cd04044', NULL, 'C2A_Tricalbin-like', NULL, NULL, 'C2A_Tricalbin-like', 13426),
(13427, 'cd00286', NULL, 'Tubulin_FtsZ_Cetz-like', NULL, NULL, 'Tubulin_FtsZ_Cetz-like', 13427),
(13428, 'cd04042', NULL, 'C2A_MCTP_PRT', NULL, NULL, 'C2A_MCTP_PRT', 13428),
(13429, 'cd17750', NULL, 'BRCT_SLF1', NULL, NULL, 'BRCT_SLF1', 13429),
(13430, 'cd00442', NULL, 'Lyz-like', NULL, NULL, 'Lyz-like', 13430),
(13431, 'cd08989', NULL, 'GH43_XYL-like', NULL, NULL, 'GH43_XYL-like', 13431),
(13432, 'cd15299', NULL, '7tmA_mAChR_M3', NULL, NULL, '7tmA_mAChR_M3', 13432),
(13433, 'cd01271', NULL, 'PTB2_Fe65', NULL, NULL, 'PTB2_Fe65', 13433),
(13434, 'cd16452', NULL, 'SP-RING_like', NULL, NULL, 'SP-RING_like', 13434),
(13435, 'cd15579', NULL, 'PHD1_PHF19', NULL, NULL, 'PHD1_PHF19', 13435),
(13436, 'cd01544', NULL, 'PBP1_GalR', NULL, NULL, 'PBP1_GalR', 13436),
(13437, 'cd04164', NULL, 'trmE', NULL, NULL, 'trmE', 13437),
(13438, 'cd11716', NULL, 'THUMP_ThiI', NULL, NULL, 'THUMP_ThiI', 13438),
(13439, 'cd02998', NULL, 'PDI_a_ERp38', NULL, NULL, 'PDI_a_ERp38', 13439),
(13440, 'cd12717', NULL, 'RRM_ETP1', NULL, NULL, 'RRM_ETP1', 13440),
(13441, 'cd19378', NULL, 'TGF_beta_DAF7', NULL, NULL, 'TGF_beta_DAF7', 13441),
(13442, 'cd00934', NULL, 'PTB', NULL, NULL, 'PTB', 13442),
(13443, 'cd03152', NULL, 'CD9_LEL', NULL, NULL, 'CD9_LEL', 13443),
(13444, 'cd03146', NULL, 'GAT1_Peptidase_E', NULL, NULL, 'GAT1_Peptidase_E', 13444),
(13445, 'cd17944', NULL, 'DEADc_DDX21_DDX50', NULL, NULL, 'DEADc_DDX21_DDX50', 13445),
(13446, 'cd00938', NULL, 'HisRS_RNA', NULL, NULL, 'HisRS_RNA', 13446),
(13447, 'cd17097', NULL, 'FERM_F1_ERM_like', NULL, NULL, 'FERM_F1_ERM_like', 13447),
(13448, 'cd14979', NULL, '7tmA_NTSR-like', NULL, NULL, '7tmA_NTSR-like', 13448),
(13449, 'cd07595', NULL, 'BAR_RhoGAP_Rich-like', NULL, NULL, 'BAR_RhoGAP_Rich-like', 13449),
(13450, 'cd06225', NULL, 'HAMP', NULL, NULL, 'HAMP', 13450),
(13451, 'cd17496', NULL, 'RMtype1_S_BliBORF2384P-TRD1-CR1_like', NULL, NULL, 'RMtype1_S_BliBORF2384P-TRD1-CR1_like', 13451),
(13452, 'cd18893', NULL, 'TET-like', NULL, NULL, 'TET-like', 13452),
(13453, 'cd19597', NULL, 'serpin28D-like_insects', NULL, NULL, 'serpin28D-like_insects', 13453),
(13454, 'cd05903', NULL, 'CHC_CoA_lg', NULL, NULL, 'CHC_CoA_lg', 13454),
(13455, 'cd05381', NULL, 'CAP_PR-1', NULL, NULL, 'CAP_PR-1', 13455),
(13456, 'cd00877', NULL, 'Ran', NULL, NULL, 'Ran', 13456),
(13457, 'cd02681', NULL, 'MIT_calpain7_1', NULL, NULL, 'MIT_calpain7_1', 13457),
(13458, 'cd19765', NULL, 'Bbox2_TRIM10-like', NULL, NULL, 'Bbox2_TRIM10-like', 13458),
(13459, 'cd00126', NULL, 'PAH', NULL, NULL, 'PAH', 13459),
(13460, 'cd17387', NULL, 'MFS_MFSD14', NULL, NULL, 'MFS_MFSD14', 13460),
(13461, 'cd06358', NULL, 'PBP1_NHase', NULL, NULL, 'PBP1_NHase', 13461),
(13462, 'cd11650', NULL, 'AT4G37440_like', NULL, NULL, 'AT4G37440_like', 13462),
(13463, 'cd13413', NULL, 'TNFRSF12A', NULL, NULL, 'TNFRSF12A', 13463),
(13464, 'cd06529', NULL, 'S24_LexA-like', NULL, NULL, 'S24_LexA-like', 13464),
(13465, 'cd07299', NULL, 'PX_TCGAP', NULL, NULL, 'PX_TCGAP', 13465),
(13466, 'cd07701', NULL, 'Ig1_Necl-3', NULL, NULL, 'Ig1_Necl-3', 13466),
(13467, 'cd11268', NULL, 'Sema_6C', NULL, NULL, 'Sema_6C', 13467),
(13468, 'cd09611', NULL, 'Jacalin_ZG16_like', NULL, NULL, 'Jacalin_ZG16_like', 13468),
(13469, 'cd13273', NULL, 'PH_SWAP-70', NULL, NULL, 'PH_SWAP-70', 13469),
(13470, 'cd13932', NULL, 'HN_RTEL1', NULL, NULL, 'HN_RTEL1', 13470),
(13471, 'cd15766', NULL, 'FYVE_Slp5', NULL, NULL, 'FYVE_Slp5', 13471),
(13472, 'cd04865', NULL, 'LigD_Pol_like_2', NULL, NULL, 'LigD_Pol_like_2', 13472),
(13473, 'cd06433', NULL, 'GT_2_WfgS_like', NULL, NULL, 'GT_2_WfgS_like', 13473),
(13474, 'cd08563', NULL, 'GDPD_TtGDE_like', NULL, NULL, 'GDPD_TtGDE_like', 13474),
(13475, 'cd15717', NULL, 'FYVE_PKHF', NULL, NULL, 'FYVE_PKHF', 13475),
(13476, 'cd14376', NULL, 'CUE_AUP1_AMFR_like', NULL, NULL, 'CUE_AUP1_AMFR_like', 13476),
(13477, 'cd12541', NULL, 'RRM2_La', NULL, NULL, 'RRM2_La', 13477);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(13478, 'cd18603', NULL, 'ABC_6TM_MRP1_2_3_6_D2_like', NULL, NULL, 'ABC_6TM_MRP1_2_3_6_D2_like', 13478),
(13479, 'cd03038', NULL, 'GST_N_etherase_LigE', NULL, NULL, 'GST_N_etherase_LigE', 13479),
(13480, 'cd12435', NULL, 'RRM_GW182_like', NULL, NULL, 'RRM_GW182_like', 13480),
(13481, 'cd07694', NULL, 'Ig2_CD4', NULL, NULL, 'Ig2_CD4', 13481),
(13482, 'cd19955', NULL, 'serpin48-like_insects', NULL, NULL, 'serpin48-like_insects', 13482),
(13483, 'cd18408', NULL, 'BTB_POZ_KCNA7', NULL, NULL, 'BTB_POZ_KCNA7', 13483),
(13484, 'cd17516', NULL, 'RMtype1_S_HinAWORF1578P-TRD2-CR2_like', NULL, NULL, 'RMtype1_S_HinAWORF1578P-TRD2-CR2_like', 13484),
(13485, 'cd12934', NULL, 'LEM', NULL, NULL, 'LEM', 13485),
(13486, 'cd02163', NULL, 'PPAT', NULL, NULL, 'PPAT', 13486),
(13487, 'cd13173', NULL, 'RanBD3_RanBP2_insect-like', NULL, NULL, 'RanBD3_RanBP2_insect-like', 13487),
(13488, 'cd07814', NULL, 'SRPBCC_CalC_Aha1-like', NULL, NULL, 'SRPBCC_CalC_Aha1-like', 13488),
(13489, 'cd11849', NULL, 'SH3_SPIN90', NULL, NULL, 'SH3_SPIN90', 13489),
(13490, 'cd13853', NULL, 'CuRO_1_Tth-MCO_like', NULL, NULL, 'CuRO_1_Tth-MCO_like', 13490),
(13491, 'cd14105', NULL, 'STKc_DAPK', NULL, NULL, 'STKc_DAPK', 13491),
(13492, 'cd19588', NULL, 'serpin_miropin-like', NULL, NULL, 'serpin_miropin-like', 13492),
(13493, 'cd09748', NULL, 'Cmr3_III-B', NULL, NULL, 'Cmr3_III-B', 13493),
(13494, 'cd09336', NULL, 'LIM1_Paxillin_like', NULL, NULL, 'LIM1_Paxillin_like', 13494),
(13495, 'cd18235', NULL, 'BTB_POZ_KLHL2-like', NULL, NULL, 'BTB_POZ_KLHL2-like', 13495),
(13496, 'cd20309', NULL, 'cupin_EcSI', NULL, NULL, 'cupin_EcSI', 13496),
(13497, 'cd01438', NULL, 'tankyrase_like', NULL, NULL, 'tankyrase_like', 13497),
(13498, 'cd18939', NULL, 'bHLH_TS_Msgn1', NULL, NULL, 'bHLH_TS_Msgn1', 13498),
(13499, 'cd16450', NULL, 'mRING-C3HGC3_RFWD3', NULL, NULL, 'mRING-C3HGC3_RFWD3', 13499),
(13500, 'cd06928', NULL, 'RNAP_alpha_NTD', NULL, NULL, 'RNAP_alpha_NTD', 13500),
(13501, 'cd14749', NULL, 'PBP2_XBP1_like', NULL, NULL, 'PBP2_XBP1_like', 13501),
(13502, 'cd01683', NULL, 'EF2_IV_snRNP', NULL, NULL, 'EF2_IV_snRNP', 13502),
(13503, 'cd15159', NULL, '7tmA_EBI2', NULL, NULL, '7tmA_EBI2', 13503),
(13504, 'cd11725', NULL, 'ADDz_Dnmt3', NULL, NULL, 'ADDz_Dnmt3', 13504),
(13505, 'cd07255', NULL, 'VOC_BsCatE_like_N', NULL, NULL, 'VOC_BsCatE_like_N', 13505),
(13506, 'cd01459', NULL, 'vWA_copine_like', NULL, NULL, 'vWA_copine_like', 13506),
(13507, 'cd03792', NULL, 'GT4_trehalose_phosphorylase', NULL, NULL, 'GT4_trehalose_phosphorylase', 13507),
(13508, 'cd00167', NULL, 'SANT', NULL, NULL, 'SANT', 13508),
(13509, 'cd05359', NULL, 'ChcA_like_SDR_c', NULL, NULL, 'ChcA_like_SDR_c', 13509),
(13510, 'cd06182', NULL, 'CYPOR_like', NULL, NULL, 'CYPOR_like', 13510),
(13511, 'cd12287', NULL, 'RRM_U2AF35_like', NULL, NULL, 'RRM_U2AF35_like', 13511),
(13512, 'cd13543', NULL, 'PBP2_Fbp', NULL, NULL, 'PBP2_Fbp', 13512),
(13513, 'cd15778', NULL, 'Lreu_0056_like', NULL, NULL, 'Lreu_0056_like', 13513),
(13514, 'cd17573', NULL, 'REC_HP-RR-like', NULL, NULL, 'REC_HP-RR-like', 13514),
(13515, 'cd12333', NULL, 'RRM2_p54nrb_like', NULL, NULL, 'RRM2_p54nrb_like', 13515),
(13516, 'cd17907', NULL, 'FliY_FliN-Y', NULL, NULL, 'FliY_FliN-Y', 13516),
(13517, 'cd18752', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, 'PIN_VapC4-5_FitB-like', 13517),
(13518, 'cd13592', NULL, 'PBP2_HisGL2', NULL, NULL, 'PBP2_HisGL2', 13518),
(13519, 'cd01283', NULL, 'cytidine_deaminase', NULL, NULL, 'cytidine_deaminase', 13519),
(13520, 'cd07668', NULL, 'BAR_SNX9', NULL, NULL, 'BAR_SNX9', 13520),
(13521, 'cd18224', NULL, 'BTB_POZ_ZBTB39', NULL, NULL, 'BTB_POZ_ZBTB39', 13521),
(13522, 'cd00756', NULL, 'MoaE', NULL, NULL, 'MoaE', 13522),
(13523, 'cd17622', NULL, 'REC_OmpR_kpRstA-like', NULL, NULL, 'REC_OmpR_kpRstA-like', 13523),
(13524, 'cd19897', NULL, 'DSRM_STRBP-like_rpt2', NULL, NULL, 'DSRM_STRBP-like_rpt2', 13524),
(13525, 'cd03516', NULL, 'Link_domain_CD44_like', NULL, NULL, 'Link_domain_CD44_like', 13525),
(13526, 'cd13522', NULL, 'PBP2_ABC_oligosaccharides', NULL, NULL, 'PBP2_ABC_oligosaccharides', 13526);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(13527, 'cd04875', NULL, 'ACT_F4HF-DF', NULL, NULL, 'ACT_F4HF-DF', 13527),
(13528, 'cd16964', NULL, 'YqgF', NULL, NULL, 'YqgF', 13528),
(13529, 'cd16181', NULL, 'EFh_PEF_Group_II_sorcin_like', NULL, NULL, 'EFh_PEF_Group_II_sorcin_like', 13529),
(13530, 'cd04041', NULL, 'C2A_fungal', NULL, NULL, 'C2A_fungal', 13530),
(13531, 'cd14317', NULL, 'UBA_DHX57', NULL, NULL, 'UBA_DHX57', 13531),
(13532, 'cd14349', NULL, 'UBA_CF106', NULL, NULL, 'UBA_CF106', 13532),
(13533, 'cd15495', NULL, 'PHD_ATX3_4_5_like', NULL, NULL, 'PHD_ATX3_4_5_like', 13533),
(13534, 'cd03135', NULL, 'GATase1_DJ-1', NULL, NULL, 'GATase1_DJ-1', 13534),
(13535, 'cd11254', NULL, 'Sema_3F', NULL, NULL, 'Sema_3F', 13535),
(13536, 'cd04176', NULL, 'Rap2', NULL, NULL, 'Rap2', 13536),
(13537, 'cd01739', NULL, 'LSm11_M', NULL, NULL, 'LSm11_M', 13537),
(13538, 'cd06937', NULL, 'NR_LBD_RAR', NULL, NULL, 'NR_LBD_RAR', 13538),
(13539, 'cd03357', NULL, 'LbH_MAT_GAT', NULL, NULL, 'LbH_MAT_GAT', 13539),
(13540, 'cd12651', NULL, 'RRM2_SXL', NULL, NULL, 'RRM2_SXL', 13540),
(13541, 'cd07462', NULL, 'CRD_FZ10', NULL, NULL, 'CRD_FZ10', 13541),
(13542, 'cd16266', NULL, 'IF2_aeIF5B_IV', NULL, NULL, 'IF2_aeIF5B_IV', 13542),
(13543, 'cd09426', NULL, 'LIM2_FHL2', NULL, NULL, 'LIM2_FHL2', 13543),
(13544, 'cd13215', NULL, 'PH-GRAM1_AGT26', NULL, NULL, 'PH-GRAM1_AGT26', 13544),
(13545, 'cd20287', NULL, 'cupin_pirin-like_N', NULL, NULL, 'cupin_pirin-like_N', 13545),
(13546, 'cd00998', NULL, 'PBP2_iGluR_ligand_binding', NULL, NULL, 'PBP2_iGluR_ligand_binding', 13546),
(13547, 'cd04736', NULL, 'MDH_FMN', NULL, NULL, 'MDH_FMN', 13547),
(13548, 'cd12369', NULL, 'RRM4_RBM45', NULL, NULL, 'RRM4_RBM45', 13548),
(13549, 'cd07359', NULL, 'PCA_45_Doxase_B_like', NULL, NULL, 'PCA_45_Doxase_B_like', 13549),
(13550, 'cd08926', NULL, 'Mb', NULL, NULL, 'Mb', 13550),
(13551, 'cd00630', NULL, 'RNAP_largest_subunit_C', NULL, NULL, 'RNAP_largest_subunit_C', 13551),
(13552, 'cd04212', NULL, 'CuRO_UO_II', NULL, NULL, 'CuRO_UO_II', 13552),
(13553, 'cd07892', NULL, 'PolyPPase_VTC2-3_like', NULL, NULL, 'PolyPPase_VTC2-3_like', 13553),
(13554, 'cd10225', NULL, 'MreB_like', NULL, NULL, 'MreB_like', 13554),
(13555, 'cd06548', NULL, 'GH18_chitinase', NULL, NULL, 'GH18_chitinase', 13555),
(13556, 'cd08256', NULL, 'Zn_ADH2', NULL, NULL, 'Zn_ADH2', 13556),
(13557, 'cd06453', NULL, 'SufS_like', NULL, NULL, 'SufS_like', 13557),
(13558, 'cd13699', NULL, 'PBP2_OccT_like', NULL, NULL, 'PBP2_OccT_like', 13558),
(13559, 'cd02870', NULL, 'PseudoU_synth_RsuA_like', NULL, NULL, 'PseudoU_synth_RsuA_like', 13559),
(13560, 'cd03748', NULL, 'Ntn_PGA', NULL, NULL, 'Ntn_PGA', 13560),
(13561, 'cd01341', NULL, 'ADP_ribosyl', NULL, NULL, 'ADP_ribosyl', 13561),
(13562, 'cd12387', NULL, 'RRM3_hnRNPM_like', NULL, NULL, 'RRM3_hnRNPM_like', 13562),
(13563, 'cd16272', NULL, 'RNaseZ_MBL-fold', NULL, NULL, 'RNaseZ_MBL-fold', 13563),
(13564, 'cd01489', NULL, 'Uba2_SUMO', NULL, NULL, 'Uba2_SUMO', 13564),
(13565, 'cd14283', NULL, 'UBA_TNR6C', NULL, NULL, 'UBA_TNR6C', 13565),
(13566, 'cd16779', NULL, 'mRING-HC-C3HC3D_LNX1', NULL, NULL, 'mRING-HC-C3HC3D_LNX1', 13566),
(13567, 'cd14602', NULL, 'PTPc-N22', NULL, NULL, 'PTPc-N22', 13567),
(13568, 'cd03771', NULL, 'MATH_Meprin', NULL, NULL, 'MATH_Meprin', 13568),
(13569, 'cd09898', NULL, 'H3TH_53EXO', NULL, NULL, 'H3TH_53EXO', 13569),
(13570, 'cd14678', NULL, 'PH_DOK4_DOK5_DOK6', NULL, NULL, 'PH_DOK4_DOK5_DOK6', 13570),
(13571, 'cd09530', NULL, 'SAM_Samd14', NULL, NULL, 'SAM_Samd14', 13571),
(13572, 'cd04379', NULL, 'RhoGAP_SYD1', NULL, NULL, 'RhoGAP_SYD1', 13572),
(13573, 'cd09078', NULL, 'nSMase', NULL, NULL, 'nSMase', 13573),
(13574, 'cd07069', NULL, 'NR_LBD_Lrh-1', NULL, NULL, 'NR_LBD_Lrh-1', 13574),
(13575, 'cd09351', NULL, 'LIM1_LPP', NULL, NULL, 'LIM1_LPP', 13575),
(13576, 'cd09511', NULL, 'SAM_CNK1,2,3-suppressor', NULL, NULL, 'SAM_CNK1,2,3-suppressor', 13576),
(13577, 'cd17175', NULL, 'FERM_F0_SHANK1', NULL, NULL, 'FERM_F0_SHANK1', 13577),
(13578, 'cd05771', NULL, 'IgC_Tapasin_R', NULL, NULL, 'IgC_Tapasin_R', 13578),
(13579, 'cd15517', NULL, 'PHD_TCF19_like', NULL, NULL, 'PHD_TCF19_like', 13579);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(13580, 'cd02999', NULL, 'PDI_a_ERp44_like', NULL, NULL, 'PDI_a_ERp44_like', 13580),
(13581, 'cd11382', NULL, 'Ribosomal_S8e', NULL, NULL, 'Ribosomal_S8e', 13581),
(13582, 'cd14318', NULL, 'UBA_Cbl_like', NULL, NULL, 'UBA_Cbl_like', 13582),
(13583, 'cd03761', NULL, 'proteasome_beta_type_5', NULL, NULL, 'proteasome_beta_type_5', 13583),
(13584, 'cd15284', NULL, '7tmC_mGluR_group2', NULL, NULL, '7tmC_mGluR_group2', 13584),
(13585, 'cd15472', NULL, 'Myo5p-like_CBD_Rasip1', NULL, NULL, 'Myo5p-like_CBD_Rasip1', 13585),
(13586, 'cd15631', NULL, 'PHD_PHF23', NULL, NULL, 'PHD_PHF23', 13586),
(13587, 'cd09121', NULL, 'PLDc_DNaseII_2', NULL, NULL, 'PLDc_DNaseII_2', 13587),
(13588, 'cd00405', NULL, 'PRAI', NULL, NULL, 'PRAI', 13588),
(13589, 'cd03863', NULL, 'M14_CPD_II', NULL, NULL, 'M14_CPD_II', 13589),
(13590, 'cd12636', NULL, 'RRM2_Bruno_like', NULL, NULL, 'RRM2_Bruno_like', 13590),
(13591, 'cd16737', NULL, 'RING-HC_PCGF5', NULL, NULL, 'RING-HC_PCGF5', 13591),
(13592, 'cd07364', NULL, 'PCA_45_Dioxygenase_B', NULL, NULL, 'PCA_45_Dioxygenase_B', 13592),
(13593, 'cd18534', NULL, 'DSP_plant_IBR5-like', NULL, NULL, 'DSP_plant_IBR5-like', 13593),
(13594, 'cd00202', NULL, 'ZnF_GATA', NULL, NULL, 'ZnF_GATA', 13594),
(13595, 'cd04277', NULL, 'ZnMc_serralysin_like', NULL, NULL, 'ZnMc_serralysin_like', 13595),
(13596, 'cd12283', NULL, 'RRM1_RBM39_like', NULL, NULL, 'RRM1_RBM39_like', 13596),
(13597, 'cd09815', NULL, 'TP_methylase', NULL, NULL, 'TP_methylase', 13597),
(13598, 'cd17403', NULL, 'MFS_SLCO4_OATP4', NULL, NULL, 'MFS_SLCO4_OATP4', 13598),
(13599, 'cd15824', NULL, 'SPRY_PRY_TRIM22', NULL, NULL, 'SPRY_PRY_TRIM22', 13599),
(13600, 'cd13934', NULL, 'RNase_H_Dikarya_like', NULL, NULL, 'RNase_H_Dikarya_like', 13600),
(13601, 'cd18461', NULL, 'BACK_KLHL22', NULL, NULL, 'BACK_KLHL22', 13601),
(13602, 'cd05163', NULL, 'PIKK_TRRAP', NULL, NULL, 'PIKK_TRRAP', 13602),
(13603, 'cd03118', NULL, 'alpha_CA_V', NULL, NULL, 'alpha_CA_V', 13603),
(13604, 'cd05682', NULL, 'M20_dipept_dapE', NULL, NULL, 'M20_dipept_dapE', 13604),
(13605, 'cd15100', NULL, '7tmA_GPR3_GPR6_GPR12-like', NULL, NULL, '7tmA_GPR3_GPR6_GPR12-like', 13605),
(13606, 'cd11372', NULL, 'RNase_PH_RRP46', NULL, NULL, 'RNase_PH_RRP46', 13606),
(13607, 'cd03508', NULL, 'Delta4-sphingolipid-FADS-like', NULL, NULL, 'Delta4-sphingolipid-FADS-like', 13607),
(13608, 'cd06920', NULL, 'NEAT', NULL, NULL, 'NEAT', 13608),
(13609, 'cd07349', NULL, 'NR_LBD_SHP', NULL, NULL, 'NR_LBD_SHP', 13609),
(13610, 'cd12913', NULL, 'PDC1_MCP_like', NULL, NULL, 'PDC1_MCP_like', 13610),
(13611, 'cd04497', NULL, 'hPOT1_OB1_like', NULL, NULL, 'hPOT1_OB1_like', 13611),
(13612, 'cd05134', NULL, 'RasGAP_RASA3', NULL, NULL, 'RasGAP_RASA3', 13612),
(13613, 'cd16268', NULL, 'EF2_II', NULL, NULL, 'EF2_II', 13613),
(13614, 'cd20000', NULL, 'PBP1_ABC_rhamnose', NULL, NULL, 'PBP1_ABC_rhamnose', 13614),
(13615, 'cd07660', NULL, 'BAR_Arfaptin', NULL, NULL, 'BAR_Arfaptin', 13615),
(13616, 'cd08461', NULL, 'PBP2_DntR_like_3', NULL, NULL, 'PBP2_DntR_like_3', 13616),
(13617, 'cd18396', NULL, 'BTB_POZ_KCTD8', NULL, NULL, 'BTB_POZ_KCTD8', 13617),
(13618, 'cd15743', NULL, 'FYVE_FGD6', NULL, NULL, 'FYVE_FGD6', 13618),
(13619, 'cd08928', NULL, 'KR_fFAS_like_SDR_c_like', NULL, NULL, 'KR_fFAS_like_SDR_c_like', 13619),
(13620, 'cd02753', NULL, 'MopB_Formate-Dh-H', NULL, NULL, 'MopB_Formate-Dh-H', 13620),
(13621, 'cd09865', NULL, 'PIN_ScUtp23p-like', NULL, NULL, 'PIN_ScUtp23p-like', 13621),
(13622, 'cd08633', NULL, 'PI-PLCc_eta2', NULL, NULL, 'PI-PLCc_eta2', 13622),
(13623, 'cd08343', NULL, 'ED_TypeI_classII_C', NULL, NULL, 'ED_TypeI_classII_C', 13623),
(13624, 'cd13989', NULL, 'STKc_IKK', NULL, NULL, 'STKc_IKK', 13624),
(13625, 'cd08708', NULL, 'RGS_FLBA', NULL, NULL, 'RGS_FLBA', 13625),
(13626, 'cd04260', NULL, 'AAK_AKi-DapG-BS', NULL, NULL, 'AAK_AKi-DapG-BS', 13626),
(13627, 'cd07446', NULL, 'CRD_SFRP2', NULL, NULL, 'CRD_SFRP2', 13627),
(13628, 'cd00366', NULL, 'FGGY', NULL, NULL, 'FGGY', 13628),
(13629, 'cd11561', NULL, 'W2_eIF5', NULL, NULL, 'W2_eIF5', 13629),
(13630, 'cd16246', NULL, 'EFh_DMD', NULL, NULL, 'EFh_DMD', 13630);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(13631, 'cd16344', NULL, 'LMWPAP', NULL, NULL, 'LMWPAP', 13631),
(13632, 'cd00592', NULL, 'HTH_MerR-like', NULL, NULL, 'HTH_MerR-like', 13632),
(13633, 'cd13117', NULL, 'POLO_box_2', NULL, NULL, 'POLO_box_2', 13633),
(13634, 'cd12249', NULL, 'RRM1_hnRNPR_like', NULL, NULL, 'RRM1_hnRNPR_like', 13634),
(13635, 'cd18617', NULL, 'GH43_XynB-like', NULL, NULL, 'GH43_XynB-like', 13635),
(13636, 'cd11442', NULL, 'bHLH_AtPRE_like', NULL, NULL, 'bHLH_AtPRE_like', 13636),
(13637, 'cd03012', NULL, 'TlpA_like_DipZ_like', NULL, NULL, 'TlpA_like_DipZ_like', 13637),
(13638, 'cd05289', NULL, 'MDR_like_2', NULL, NULL, 'MDR_like_2', 13638),
(13639, 'cd11926', NULL, 'SH3_SH3RF1_3', NULL, NULL, 'SH3_SH3RF1_3', 13639),
(13640, 'cd14161', NULL, 'STKc_NUAK2', NULL, NULL, 'STKc_NUAK2', 13640),
(13641, 'cd06088', NULL, 'KOW_RPL14', NULL, NULL, 'KOW_RPL14', 13641),
(13642, 'cd17223', NULL, 'RA_RASSF6', NULL, NULL, 'RA_RASSF6', 13642),
(13643, 'cd02905', NULL, 'Macro_GDAP2-like', NULL, NULL, 'Macro_GDAP2-like', 13643),
(13644, 'cd18472', NULL, 'BACK_KLHL33', NULL, NULL, 'BACK_KLHL33', 13644),
(13645, 'cd07045', NULL, 'BMC_CcmK_like', NULL, NULL, 'BMC_CcmK_like', 13645),
(13646, 'cd16696', NULL, 'RING-CH-C4HC3_NFX1', NULL, NULL, 'RING-CH-C4HC3_NFX1', 13646),
(13647, 'cd08798', NULL, 'Death_NFkB2_p100', NULL, NULL, 'Death_NFkB2_p100', 13647),
(13648, 'cd05722', NULL, 'Ig1_Neogenin', NULL, NULL, 'Ig1_Neogenin', 13648),
(13649, 'cd05724', NULL, 'Ig2_Robo', NULL, NULL, 'Ig2_Robo', 13649),
(13650, 'cd06955', NULL, 'NR_DBD_VDR', NULL, NULL, 'NR_DBD_VDR', 13650),
(13651, 'cd08800', NULL, 'Death_UNC5A', NULL, NULL, 'Death_UNC5A', 13651),
(13652, 'cd02247', NULL, 'cupin_pirin_C', NULL, NULL, 'cupin_pirin_C', 13652),
(13653, 'cd06876', NULL, 'PX_MDM1p', NULL, NULL, 'PX_MDM1p', 13653),
(13654, 'cd10237', NULL, 'HSPA13-like_NBD', NULL, NULL, 'HSPA13-like_NBD', 13654),
(13655, 'cd10320', NULL, 'RGL4_N', NULL, NULL, 'RGL4_N', 13655),
(13656, 'cd18685', NULL, 'PIN_VapC-like', NULL, NULL, 'PIN_VapC-like', 13656),
(13657, 'cd14743', NULL, 'PAAR_CT_1', NULL, NULL, 'PAAR_CT_1', 13657),
(13658, 'cd17471', NULL, 'MFS_Set', NULL, NULL, 'MFS_Set', 13658),
(13659, 'cd18019', NULL, 'DEXHc_Brr2_1', NULL, NULL, 'DEXHc_Brr2_1', 13659),
(13660, 'cd09105', NULL, 'PLDc_vPLD1_2_like_2', NULL, NULL, 'PLDc_vPLD1_2_like_2', 13660),
(13661, 'cd13714', NULL, 'PBP2_iGluR_Kainate', NULL, NULL, 'PBP2_iGluR_Kainate', 13661),
(13662, 'cd13736', NULL, 'SPRY_PRY_TRIM25', NULL, NULL, 'SPRY_PRY_TRIM25', 13662),
(13663, 'cd09423', NULL, 'LIM1_FHL3', NULL, NULL, 'LIM1_FHL3', 13663),
(13664, 'cd09945', NULL, 'SH2_SHB_SHD_SHE_SHF_like', NULL, NULL, 'SH2_SHB_SHD_SHE_SHF_like', 13664),
(13665, 'cd06155', NULL, 'eu_AANH_C_1', NULL, NULL, 'eu_AANH_C_1', 13665),
(13666, 'cd08226', NULL, 'PK_STRAD_beta', NULL, NULL, 'PK_STRAD_beta', 13666),
(13667, 'cd16117', NULL, 'UBX_UBXN4', NULL, NULL, 'UBX_UBXN4', 13667),
(13668, 'cd18322', NULL, 'BTB_POZ_SKP1', NULL, NULL, 'BTB_POZ_SKP1', 13668),
(13669, 'cd09461', NULL, 'LIM3_Enigma_like_1', NULL, NULL, 'LIM3_Enigma_like_1', 13669),
(13670, 'cd01288', NULL, 'FabZ', NULL, NULL, 'FabZ', 13670),
(13671, 'cd01619', NULL, 'LDH_like', NULL, NULL, 'LDH_like', 13671),
(13672, 'cd03185', NULL, 'GST_C_Tau', NULL, NULL, 'GST_C_Tau', 13672),
(13673, 'cd06387', NULL, 'PBP1_iGluR_AMPA_GluR3', NULL, NULL, 'PBP1_iGluR_AMPA_GluR3', 13673),
(13674, 'cd14437', NULL, 'nt01cx_1156_like', NULL, NULL, 'nt01cx_1156_like', 13674),
(13675, 'cd01811', NULL, 'Ubl1_OASL', NULL, NULL, 'Ubl1_OASL', 13675),
(13676, 'cd11390', NULL, 'bHLH_TS', NULL, NULL, 'bHLH_TS', 13676),
(13677, 'cd04847', NULL, 'Peptidases_S8_Subtilisin_like_2', NULL, NULL, 'Peptidases_S8_Subtilisin_like_2', 13677),
(13678, 'cd19035', NULL, 'LGIC_ECD_GABAAR_A2', NULL, NULL, 'LGIC_ECD_GABAAR_A2', 13678),
(13679, 'cd14703', NULL, 'bZIP_plant_RF2', NULL, NULL, 'bZIP_plant_RF2', 13679),
(13680, 'cd06352', NULL, 'PBP1_NPR_GC-like', NULL, NULL, 'PBP1_NPR_GC-like', 13680),
(13681, 'cd11795', NULL, 'SH3_DNMBP_N2', NULL, NULL, 'SH3_DNMBP_N2', 13681),
(13682, 'cd11541', NULL, 'NTP-PPase_u4', NULL, NULL, 'NTP-PPase_u4', 13682);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(13683, 'cd18085', NULL, 'TM1570-like', NULL, NULL, 'TM1570-like', 13683),
(13684, 'cd11551', NULL, 'Serine_rich_CASS4', NULL, NULL, 'Serine_rich_CASS4', 13684),
(13685, 'cd17467', NULL, 'T3SS_YscP_C', NULL, NULL, 'T3SS_YscP_C', 13685),
(13686, 'cd17562', NULL, 'REC_CheY4-like', NULL, NULL, 'REC_CheY4-like', 13686),
(13687, 'cd11488', NULL, 'SLC5sbd_SGLT4', NULL, NULL, 'SLC5sbd_SGLT4', 13687),
(13688, 'cd05703', NULL, 'S1_Rrp5_repeat_hs12_sc9', NULL, NULL, 'S1_Rrp5_repeat_hs12_sc9', 13688),
(13689, 'cd09442', NULL, 'LIM_Eplin_like', NULL, NULL, 'LIM_Eplin_like', 13689),
(13690, 'cd16984', NULL, 'CID_Nrd1_like', NULL, NULL, 'CID_Nrd1_like', 13690),
(13691, 'cd02929', NULL, 'TMADH_HD_FMN', NULL, NULL, 'TMADH_HD_FMN', 13691),
(13692, 'cd12557', NULL, 'RRM3_RBM15', NULL, NULL, 'RRM3_RBM15', 13692),
(13693, 'cd00429', NULL, 'RPE', NULL, NULL, 'RPE', 13693),
(13694, 'cd19144', NULL, 'AKR_AKR13A1', NULL, NULL, 'AKR_AKR13A1', 13694),
(13695, 'cd19915', NULL, 'DSRM_DRADA_rpt3', NULL, NULL, 'DSRM_DRADA_rpt3', 13695),
(13696, 'cd13723', NULL, 'PBP2_iGluR_Kainate_GluR7', NULL, NULL, 'PBP2_iGluR_Kainate_GluR7', 13696),
(13697, 'cd06910', NULL, 'M14_ASTE_ASPA-like', NULL, NULL, 'M14_ASTE_ASPA-like', 13697),
(13698, 'cd21405', NULL, 'ZBD_av_Nsp10-like', NULL, NULL, 'ZBD_av_Nsp10-like', 13698),
(13699, 'cd04599', NULL, 'CBS_pair_GGDEF_assoc', NULL, NULL, 'CBS_pair_GGDEF_assoc', 13699),
(13700, 'cd12149', NULL, 'Flavi_E_C', NULL, NULL, 'Flavi_E_C', 13700),
(13701, 'cd01394', NULL, 'radB', NULL, NULL, 'radB', 13701),
(13702, 'cd20299', NULL, 'cupin_YP766765-like', NULL, NULL, 'cupin_YP766765-like', 13702),
(13703, 'cd00861', NULL, 'ProRS_anticodon_short', NULL, NULL, 'ProRS_anticodon_short', 13703),
(13704, 'cd16982', NULL, 'CID_Pcf11', NULL, NULL, 'CID_Pcf11', 13704),
(13705, 'cd05664', NULL, 'M20_Acy1-like', NULL, NULL, 'M20_Acy1-like', 13705),
(13706, 'cd08165', NULL, 'MPP_MPPE1', NULL, NULL, 'MPP_MPPE1', 13706),
(13707, 'cd03521', NULL, 'Link_domain_KIAA0527_like', NULL, NULL, 'Link_domain_KIAA0527_like', 13707),
(13708, 'cd05750', NULL, 'Ig_Pro_neuregulin', NULL, NULL, 'Ig_Pro_neuregulin', 13708),
(13709, 'cd06298', NULL, 'PBP1_CcpA', NULL, NULL, 'PBP1_CcpA', 13709),
(13710, 'cd07372', NULL, '2A5CPDO_B', NULL, NULL, '2A5CPDO_B', 13710),
(13711, 'cd06912', NULL, 'GT_MraY_like', NULL, NULL, 'GT_MraY_like', 13711),
(13712, 'cd15152', NULL, '7tmA_GPR174-like', NULL, NULL, '7tmA_GPR174-like', 13712),
(13713, 'cd07638', NULL, 'BAR_ACAP2', NULL, NULL, 'BAR_ACAP2', 13713),
(13714, 'cd13985', NULL, 'STKc_GAK_like', NULL, NULL, 'STKc_GAK_like', 13714),
(13715, 'cd16455', NULL, 'RING-H2_AMFR', NULL, NULL, 'RING-H2_AMFR', 13715),
(13716, 'cd19046', NULL, 'LGIC_ECD_GABAAR_rho1', NULL, NULL, 'LGIC_ECD_GABAAR_rho1', 13716),
(13717, 'cd06219', NULL, 'DHOD_e_trans_like1', NULL, NULL, 'DHOD_e_trans_like1', 13717),
(13718, 'cd02005', NULL, 'TPP_PDC_IPDC', NULL, NULL, 'TPP_PDC_IPDC', 13718),
(13719, 'cd08189', NULL, 'Fe-ADH-like', NULL, NULL, 'Fe-ADH-like', 13719),
(13720, 'cd17596', NULL, 'REC_HupR', NULL, NULL, 'REC_HupR', 13720),
(13721, 'cd06327', NULL, 'PBP1_SBP-like', NULL, NULL, 'PBP1_SBP-like', 13721),
(13722, 'cd13329', NULL, 'PH_RhoGEF', NULL, NULL, 'PH_RhoGEF', 13722),
(13723, 'cd15343', NULL, '7tmA_LPAR3_Edg7', NULL, NULL, '7tmA_LPAR3_Edg7', 13723),
(13724, 'cd17028', NULL, 'T3SC_IA_SycE_Scc1-like', NULL, NULL, 'T3SC_IA_SycE_Scc1-like', 13724),
(13725, 'cd18557', NULL, 'ABC_6TM_TAP_ABCB8_10_like', NULL, NULL, 'ABC_6TM_TAP_ABCB8_10_like', 13725),
(13726, 'cd00995', NULL, 'PBP2_NikA_DppA_OppA_like', NULL, NULL, 'PBP2_NikA_DppA_OppA_like', 13726),
(13727, 'cd19770', NULL, 'Bbox2_TRIM19_C-V', NULL, NULL, 'Bbox2_TRIM19_C-V', 13727),
(13728, 'cd11751', NULL, 'GH94N_like_4', NULL, NULL, 'GH94N_like_4', 13728),
(13729, 'cd15245', NULL, '7tmF_FZD2', NULL, NULL, '7tmF_FZD2', 13729),
(13730, 'cd12307', NULL, 'RRM_NIFK_like', NULL, NULL, 'RRM_NIFK_like', 13730),
(13731, 'cd17366', NULL, 'MFS_ProP', NULL, NULL, 'MFS_ProP', 13731),
(13732, 'cd13361', NULL, 'PH_PLC_beta', NULL, NULL, 'PH_PLC_beta', 13732),
(13733, 'cd19571', NULL, 'serpinB12_yukopin', NULL, NULL, 'serpinB12_yukopin', 13733);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(13734, 'cd07968', NULL, 'OBF_DNA_ligase_IV', NULL, NULL, 'OBF_DNA_ligase_IV', 13734),
(13735, 'cd09700', NULL, 'Csx10', NULL, NULL, 'Csx10', 13735),
(13736, 'cd03327', NULL, 'MR_like_2', NULL, NULL, 'MR_like_2', 13736),
(13737, 'cd14855', NULL, 'TRAPPC1_MUM2', NULL, NULL, 'TRAPPC1_MUM2', 13737),
(13738, 'cd12286', NULL, 'RRM_Man1', NULL, NULL, 'RRM_Man1', 13738),
(13739, 'cd08206', NULL, 'RuBisCO_large_I_II_III', NULL, NULL, 'RuBisCO_large_I_II_III', 13739),
(13740, 'cd00383', NULL, 'trans_reg_C', NULL, NULL, 'trans_reg_C', 13740),
(13741, 'cd14714', NULL, 'bZIP_CEBPD', NULL, NULL, 'bZIP_CEBPD', 13741),
(13742, 'cd05072', NULL, 'PTKc_Lyn', NULL, NULL, 'PTKc_Lyn', 13742),
(13743, 'cd14239', NULL, 'GAT_GGA1_GGA2', NULL, NULL, 'GAT_GGA1_GGA2', 13743),
(13744, 'cd15862', NULL, 'SNARE_Vti1', NULL, NULL, 'SNARE_Vti1', 13744),
(13745, 'cd01888', NULL, 'eIF2_gamma', NULL, NULL, 'eIF2_gamma', 13745),
(13746, 'cd18377', NULL, 'BTB_POZ_Kv1_KCNA', NULL, NULL, 'BTB_POZ_Kv1_KCNA', 13746),
(13747, 'cd10042', NULL, 'Reelin_repeat_6_subrepeat_1', NULL, NULL, 'Reelin_repeat_6_subrepeat_1', 13747),
(13748, 'cd07336', NULL, 'M48B_HtpX_like', NULL, NULL, 'M48B_HtpX_like', 13748),
(13749, 'cd13993', NULL, 'STKc_Pat1_like', NULL, NULL, 'STKc_Pat1_like', 13749),
(13750, 'cd02778', NULL, 'MopB_CT_Thiosulfate-R-like', NULL, NULL, 'MopB_CT_Thiosulfate-R-like', 13750),
(13751, 'cd00355', NULL, 'Ribosomal_L30_like', NULL, NULL, 'Ribosomal_L30_like', 13751),
(13752, 'cd21558', NULL, 'alphaCoV-Nsp6', NULL, NULL, 'alphaCoV-Nsp6', 13752),
(13753, 'cd05154', NULL, 'ACAD10_11_N-like', NULL, NULL, 'ACAD10_11_N-like', 13753),
(13754, 'cd13656', NULL, 'PBP2_MBP', NULL, NULL, 'PBP2_MBP', 13754),
(13755, 'cd05594', NULL, 'STKc_PKB_alpha', NULL, NULL, 'STKc_PKB_alpha', 13755),
(13756, 'cd18726', NULL, 'PIN_LabA-like', NULL, NULL, 'PIN_LabA-like', 13756),
(13757, 'cd03049', NULL, 'GST_N_3', NULL, NULL, 'GST_N_3', 13757),
(13758, 'cd03389', NULL, 'PAP2_lipid_A_1_phosphatase', NULL, NULL, 'PAP2_lipid_A_1_phosphatase', 13758),
(13759, 'cd11403', NULL, 'bHLH_scINO4_like', NULL, NULL, 'bHLH_scINO4_like', 13759),
(13760, 'cd01919', NULL, 'PEPCK', NULL, NULL, 'PEPCK', 13760),
(13761, 'cd01129', NULL, 'PulE-GspE', NULL, NULL, 'PulE-GspE', 13761),
(13762, 'cd13683', NULL, 'PBP2_TRAP_DctP6_7', NULL, NULL, 'PBP2_TRAP_DctP6_7', 13762),
(13763, 'cd03271', NULL, 'ABC_UvrA_II', NULL, NULL, 'ABC_UvrA_II', 13763),
(13764, 'cd08833', NULL, 'ArfGap_GIT', NULL, NULL, 'ArfGap_GIT', 13764),
(13765, 'cd18421', NULL, 'BTB_POZ_KCNG1_2', NULL, NULL, 'BTB_POZ_KCNG1_2', 13765),
(13766, 'cd02872', NULL, 'GH18_chitolectin_chitotriosidase', NULL, NULL, 'GH18_chitolectin_chitotriosidase', 13766),
(13767, 'cd12467', NULL, 'RRM_Srp1p_like', NULL, NULL, 'RRM_Srp1p_like', 13767),
(13768, 'cd09947', NULL, 'Ebola_HIV-1-like_HR1-HR2', NULL, NULL, 'Ebola_HIV-1-like_HR1-HR2', 13768),
(13769, 'cd10791', NULL, 'GH38N_AMII_like_1', NULL, NULL, 'GH38N_AMII_like_1', 13769),
(13770, 'cd18547', NULL, 'ABC_6TM_Tm288_like', NULL, NULL, 'ABC_6TM_Tm288_like', 13770),
(13771, 'cd05583', NULL, 'STKc_MSK_N', NULL, NULL, 'STKc_MSK_N', 13771),
(13772, 'cd07379', NULL, 'MPP_239FB', NULL, NULL, 'MPP_239FB', 13772),
(13773, 'cd08157', NULL, 'catalase_fungal', NULL, NULL, 'catalase_fungal', 13773),
(13774, 'cd14548', NULL, 'R3-PTPc', NULL, NULL, 'R3-PTPc', 13774),
(13775, 'cd06153', NULL, 'YjgF_YER057c_UK114_like_5', NULL, NULL, 'YjgF_YER057c_UK114_like_5', 13775),
(13776, 'cd15702', NULL, 'ePHD_BRPF2', NULL, NULL, 'ePHD_BRPF2', 13776),
(13777, 'cd18011', NULL, 'DEXDc_RapA', NULL, NULL, 'DEXDc_RapA', 13777),
(13778, 'cd02588', NULL, 'HAD_L2-DEX', NULL, NULL, 'HAD_L2-DEX', 13778),
(13779, 'cd02930', NULL, 'DCR_FMN', NULL, NULL, 'DCR_FMN', 13779),
(13780, 'cd05763', NULL, 'Ig_1', NULL, NULL, 'Ig_1', 13780),
(13781, 'cd02178', NULL, 'GH16_beta_agarase', NULL, NULL, 'GH16_beta_agarase', 13781),
(13782, 'cd16639', NULL, 'RING-HC_TRAF2', NULL, NULL, 'RING-HC_TRAF2', 13782),
(13783, 'cd04215', NULL, 'Nitrosocyanin', NULL, NULL, 'Nitrosocyanin', 13783),
(13784, 'cd07214', NULL, 'Pat17_isozyme_like', NULL, NULL, 'Pat17_isozyme_like', 13784);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(13785, 'cd07152', NULL, 'ALDH_BenzADH', NULL, NULL, 'ALDH_BenzADH', 13785),
(13786, 'cd08895', NULL, 'SRPBCC_CalC_Aha1-like_2', NULL, NULL, 'SRPBCC_CalC_Aha1-like_2', 13786),
(13787, 'cd10323', NULL, 'SLC-NCS1sbd', NULL, NULL, 'SLC-NCS1sbd', 13787),
(13788, 'cd05330', NULL, 'cyclohexanol_reductase_SDR_c', NULL, NULL, 'cyclohexanol_reductase_SDR_c', 13788),
(13789, 'cd14882', NULL, 'MYSc_Myo21', NULL, NULL, 'MYSc_Myo21', 13789),
(13790, 'cd01249', NULL, 'BAR-PH_GRAF_family', NULL, NULL, 'BAR-PH_GRAF_family', 13790),
(13791, 'cd12619', NULL, 'RRM2_PUB1', NULL, NULL, 'RRM2_PUB1', 13791),
(13792, 'cd14497', NULL, 'PTP_PTEN-like', NULL, NULL, 'PTP_PTEN-like', 13792),
(13793, 'cd05614', NULL, 'STKc_MSK2_N', NULL, NULL, 'STKc_MSK2_N', 13793),
(13794, 'cd19364', NULL, 'TenA_C_BsTenA-like', NULL, NULL, 'TenA_C_BsTenA-like', 13794),
(13795, 'cd00770', NULL, 'SerRS_core', NULL, NULL, 'SerRS_core', 13795),
(13796, 'cd05065', NULL, 'PTKc_EphR_B', NULL, NULL, 'PTKc_EphR_B', 13796),
(13797, 'cd05074', NULL, 'PTKc_Tyro3', NULL, NULL, 'PTKc_Tyro3', 13797),
(13798, 'cd06262', NULL, 'metallo-hydrolase-like_MBL-fold', NULL, NULL, 'metallo-hydrolase-like_MBL-fold', 13798),
(13799, 'cd06114', NULL, 'EcCS_like', NULL, NULL, 'EcCS_like', 13799),
(13800, 'cd03006', NULL, 'PDI_a_EFP1_N', NULL, NULL, 'PDI_a_EFP1_N', 13800),
(13801, 'cd16178', NULL, 'EFh_HEF_SCGN', NULL, NULL, 'EFh_HEF_SCGN', 13801),
(13802, 'cd16525', NULL, 'RING-HC_PCGF', NULL, NULL, 'RING-HC_PCGF', 13802),
(13803, 'cd10372', NULL, 'SH2_STAT1', NULL, NULL, 'SH2_STAT1', 13803),
(13804, 'cd14389', NULL, 'UBA_AAA_plant', NULL, NULL, 'UBA_AAA_plant', 13804),
(13805, 'cd06899', NULL, 'lectin_legume_LecRK_Arcelin_ConA', NULL, NULL, 'lectin_legume_LecRK_Arcelin_ConA', 13805),
(13806, 'cd00397', NULL, 'DNA_BRE_C', NULL, NULL, 'DNA_BRE_C', 13806),
(13807, 'cd15223', NULL, '7tmA_OR56-like', NULL, NULL, '7tmA_OR56-like', 13807),
(13808, 'cd19781', NULL, 'Bbox2_TRIM40_C-V', NULL, NULL, 'Bbox2_TRIM40_C-V', 13808),
(13809, 'cd00021', NULL, 'Bbox_SF', NULL, NULL, 'Bbox_SF', 13809),
(13810, 'cd13624', NULL, 'PBP2_Arg_Lys_His', NULL, NULL, 'PBP2_Arg_Lys_His', 13810),
(13811, 'cd20281', NULL, 'cupin_QDO_C', NULL, NULL, 'cupin_QDO_C', 13811),
(13812, 'cd00916', NULL, 'Npc2_like', NULL, NULL, 'Npc2_like', 13812),
(13813, 'cd10577', NULL, 'TNFRSF1B', NULL, NULL, 'TNFRSF1B', 13813),
(13814, 'cd12293', NULL, 'RRM_Rrp7p', NULL, NULL, 'RRM_Rrp7p', 13814),
(13815, 'cd14656', NULL, 'Imelysin-like_EfeO', NULL, NULL, 'Imelysin-like_EfeO', 13815),
(13816, 'cd04122', NULL, 'Rab14', NULL, NULL, 'Rab14', 13816),
(13817, 'cd17928', NULL, 'DEXDc_SecA', NULL, NULL, 'DEXDc_SecA', 13817),
(13818, 'cd12568', NULL, 'RRM3_MRD1', NULL, NULL, 'RRM3_MRD1', 13818),
(13819, 'cd03698', NULL, 'eRF3_II_like', NULL, NULL, 'eRF3_II_like', 13819),
(13820, 'cd08773', NULL, 'FpgNei_N', NULL, NULL, 'FpgNei_N', 13820),
(13821, 'cd09405', NULL, 'LIM1_Paxillin', NULL, NULL, 'LIM1_Paxillin', 13821),
(13822, 'cd05595', NULL, 'STKc_PKB_beta', NULL, NULL, 'STKc_PKB_beta', 13822),
(13823, 'cd18584', NULL, 'ABC_6TM_AarD_CydD', NULL, NULL, 'ABC_6TM_AarD_CydD', 13823),
(13824, 'cd20225', NULL, 'PFM_lysenin-like', NULL, NULL, 'PFM_lysenin-like', 13824),
(13825, 'cd08026', NULL, 'DUF326', NULL, NULL, 'DUF326', 13825),
(13826, 'cd15103', NULL, '7tmA_MCR', NULL, NULL, '7tmA_MCR', 13826),
(13827, 'cd19116', NULL, 'AKR_AKR2E1-5', NULL, NULL, 'AKR_AKR2E1-5', 13827),
(13828, 'cd13582', NULL, 'PBP2_AlgQ_like_3', NULL, NULL, 'PBP2_AlgQ_like_3', 13828),
(13829, 'cd15996', NULL, '7tmB2_GPR126', NULL, NULL, '7tmB2_GPR126', 13829),
(13830, 'cd15440', NULL, '7tmB2_latrophilin-like_invertebrate', NULL, NULL, '7tmB2_latrophilin-like_invertebrate', 13830),
(13831, 'cd16947', NULL, 'HATPase_YcbM-like', NULL, NULL, 'HATPase_YcbM-like', 13831),
(13832, 'cd09477', NULL, 'LIM2_TLP', NULL, NULL, 'LIM2_TLP', 13832),
(13833, 'cd01658', NULL, 'Ribosomal_L30', NULL, NULL, 'Ribosomal_L30', 13833),
(13834, 'cd11340', NULL, 'AmyAc_bac_CMD_like_3', NULL, NULL, 'AmyAc_bac_CMD_like_3', 13834),
(13835, 'cd01959', NULL, 'nsLTP2', NULL, NULL, 'nsLTP2', 13835);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(13836, 'cd09253', NULL, 'AP-4_Mu4_Cterm', NULL, NULL, 'AP-4_Mu4_Cterm', 13836),
(13837, 'cd17274', NULL, 'RMtype1_S_Eco540ANI-TRD1-CR1_like', NULL, NULL, 'RMtype1_S_Eco540ANI-TRD1-CR1_like', 13837),
(13838, 'cd02966', NULL, 'TlpA_like_family', NULL, NULL, 'TlpA_like_family', 13838),
(13839, 'cd03059', NULL, 'GST_N_SspA', NULL, NULL, 'GST_N_SspA', 13839),
(13840, 'cd01133', NULL, 'F1-ATPase_beta', NULL, NULL, 'F1-ATPase_beta', 13840),
(13841, 'cd15483', NULL, 'Influenza_NA', NULL, NULL, 'Influenza_NA', 13841),
(13842, 'cd13952', NULL, '7tm_classB', NULL, NULL, '7tm_classB', 13842),
(13843, 'cd18484', NULL, 'BACK_KBTBD11_CMLAP', NULL, NULL, 'BACK_KBTBD11_CMLAP', 13843),
(13844, 'cd08514', NULL, 'PBP2_AppA_like', NULL, NULL, 'PBP2_AppA_like', 13844),
(13845, 'cd14190', NULL, 'STKc_MLCK2', NULL, NULL, 'STKc_MLCK2', 13845),
(13846, 'cd09346', NULL, 'LIM3_FHL', NULL, NULL, 'LIM3_FHL', 13846),
(13847, 'cd21165', NULL, 'M_cv-Nsp15-like', NULL, NULL, 'M_cv-Nsp15-like', 13847),
(13848, 'cd09118', NULL, 'PLDc_yjhR_C_like', NULL, NULL, 'PLDc_yjhR_C_like', 13848),
(13849, 'cd11748', NULL, 'GH94N_NdvB_like', NULL, NULL, 'GH94N_NdvB_like', 13849),
(13850, 'cd17636', NULL, 'PtmA', NULL, NULL, 'PtmA', 13850),
(13851, 'cd16451', NULL, 'mRING_PEX12', NULL, NULL, 'mRING_PEX12', 13851),
(13852, 'cd10048', NULL, 'Reelin_repeat_4_subrepeat_2', NULL, NULL, 'Reelin_repeat_4_subrepeat_2', 13852),
(13853, 'cd14750', NULL, 'PBP2_TMBP', NULL, NULL, 'PBP2_TMBP', 13853),
(13854, 'cd18060', NULL, 'DEXHc_CHD8', NULL, NULL, 'DEXHc_CHD8', 13854),
(13855, 'cd00930', NULL, 'Cyt_c_Oxidase_VIII', NULL, NULL, 'Cyt_c_Oxidase_VIII', 13855),
(13856, 'cd14532', NULL, 'PTP-MTMR6-like', NULL, NULL, 'PTP-MTMR6-like', 13856),
(13857, 'cd15691', NULL, 'PHD1_DPF2_like', NULL, NULL, 'PHD1_DPF2_like', 13857),
(13858, 'cd17641', NULL, 'LC_FACS_bac1', NULL, NULL, 'LC_FACS_bac1', 13858),
(13859, 'cd15029', NULL, '7tm_SRI_SRII', NULL, NULL, '7tm_SRI_SRII', 13859),
(13860, 'cd12263', NULL, 'RRM_ABT1_like', NULL, NULL, 'RRM_ABT1_like', 13860),
(13861, 'cd03364', NULL, 'TOPRIM_DnaG_primases', NULL, NULL, 'TOPRIM_DnaG_primases', 13861),
(13862, 'cd07167', NULL, 'NR_DBD_Lrh-1_like', NULL, NULL, 'NR_DBD_Lrh-1_like', 13862),
(13863, 'cd05532', NULL, 'POLBc_alpha', NULL, NULL, 'POLBc_alpha', 13863),
(13864, 'cd07871', NULL, 'STKc_PCTAIRE3', NULL, NULL, 'STKc_PCTAIRE3', 13864),
(13865, 'cd17272', NULL, 'RMtype1_S_Eco2747II-TRD2-CR2-like', NULL, NULL, 'RMtype1_S_Eco2747II-TRD2-CR2-like', 13865),
(13866, 'cd12757', NULL, 'RRM1_hnRNPAB', NULL, NULL, 'RRM1_hnRNPAB', 13866),
(13867, 'cd03811', NULL, 'GT4_GT28_WabH-like', NULL, NULL, 'GT4_GT28_WabH-like', 13867),
(13868, 'cd15477', NULL, 'Myo5b_CBD', NULL, NULL, 'Myo5b_CBD', 13868),
(13869, 'cd04117', NULL, 'Rab15', NULL, NULL, 'Rab15', 13869),
(13870, 'cd03523', NULL, 'NTR_like', NULL, NULL, 'NTR_like', 13870),
(13871, 'cd19023', NULL, 'LGIC_ECD_nAChR_A10', NULL, NULL, 'LGIC_ECD_nAChR_A10', 13871),
(13872, 'cd08590', NULL, 'PI-PLCc_Rv2075c_like', NULL, NULL, 'PI-PLCc_Rv2075c_like', 13872),
(13873, 'cd18108', NULL, 'SpoU-like_NHR', NULL, NULL, 'SpoU-like_NHR', 13873),
(13874, 'cd17103', NULL, 'FERM_F1_FRMD4', NULL, NULL, 'FERM_F1_FRMD4', 13874),
(13875, 'cd15770', NULL, 'FYVE_CARP2', NULL, NULL, 'FYVE_CARP2', 13875),
(13876, 'cd00240', NULL, 'TFIIFa', NULL, NULL, 'TFIIFa', 13876),
(13877, 'cd04369', NULL, 'Bromodomain', NULL, NULL, 'Bromodomain', 13877),
(13878, 'cd02958', NULL, 'UAS', NULL, NULL, 'UAS', 13878),
(13879, 'cd01729', NULL, 'LSm7', NULL, NULL, 'LSm7', 13879),
(13880, 'cd01366', NULL, 'KISc_C_terminal', NULL, NULL, 'KISc_C_terminal', 13880),
(13881, 'cd04489', NULL, 'ExoVII_LU_OBF', NULL, NULL, 'ExoVII_LU_OBF', 13881),
(13882, 'cd15564', NULL, 'PHD1_NSD', NULL, NULL, 'PHD1_NSD', 13882),
(13883, 'cd07479', NULL, 'Peptidases_S8_SKI-1_like', NULL, NULL, 'Peptidases_S8_SKI-1_like', 13883),
(13884, 'cd15176', NULL, '7tmA_ACKR4_CCR11', NULL, NULL, '7tmA_ACKR4_CCR11', 13884),
(13885, 'cd15191', NULL, '7tmA_AT2R', NULL, NULL, '7tmA_AT2R', 13885),
(13886, 'cd19365', NULL, 'TenA_C-like', NULL, NULL, 'TenA_C-like', 13886);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(13887, 'cd08410', NULL, 'C2B_Synaptotagmin-17', NULL, NULL, 'C2B_Synaptotagmin-17', 13887),
(13888, 'cd07583', NULL, 'nitrilase_5', NULL, NULL, 'nitrilase_5', 13888),
(13889, 'cd10485', NULL, 'EphR_LBD_A7', NULL, NULL, 'EphR_LBD_A7', 13889),
(13890, 'cd15629', NULL, 'PHD_BAZ2A', NULL, NULL, 'PHD_BAZ2A', 13890),
(13891, 'cd09848', NULL, 'M28_TfR', NULL, NULL, 'M28_TfR', 13891),
(13892, 'cd09264', NULL, 'AP_Syp1_MHD', NULL, NULL, 'AP_Syp1_MHD', 13892),
(13893, 'cd03777', NULL, 'MATH_TRAF3', NULL, NULL, 'MATH_TRAF3', 13893),
(13894, 'cd05864', NULL, 'Ig_VEGFR-2', NULL, NULL, 'Ig_VEGFR-2', 13894),
(13895, 'cd12518', NULL, 'RRM_SRSF11', NULL, NULL, 'RRM_SRSF11', 13895),
(13896, 'cd06852', NULL, 'GT_MraY', NULL, NULL, 'GT_MraY', 13896),
(13897, 'cd16753', NULL, 'RING-HC_MID1', NULL, NULL, 'RING-HC_MID1', 13897),
(13898, 'cd01067', NULL, 'Globin-like', NULL, NULL, 'Globin-like', 13898),
(13899, 'cd12251', NULL, 'RRM3_hnRNPR_like', NULL, NULL, 'RRM3_hnRNPR_like', 13899),
(13900, 'cd04701', NULL, 'Asparaginase_2', NULL, NULL, 'Asparaginase_2', 13900),
(13901, 'cd17488', NULL, 'MFS_UhpC', NULL, NULL, 'MFS_UhpC', 13901),
(13902, 'cd02903', NULL, 'Macro_BAL-like', NULL, NULL, 'Macro_BAL-like', 13902),
(13903, 'cd05104', NULL, 'PTKc_Kit', NULL, NULL, 'PTKc_Kit', 13903),
(13904, 'cd00506', NULL, 'PseudoU_synth_TruB_like', NULL, NULL, 'PseudoU_synth_TruB_like', 13904),
(13905, 'cd14964', NULL, '7tm_GPCRs', NULL, NULL, '7tm_GPCRs', 13905),
(13906, 'cd15380', NULL, '7tmA_BK-1', NULL, NULL, '7tmA_BK-1', 13906),
(13907, 'cd00914', NULL, 'PCD_DCoH_subfamily_b', NULL, NULL, 'PCD_DCoH_subfamily_b', 13907),
(13908, 'cd04249', NULL, 'AAK_NAGK-NC', NULL, NULL, 'AAK_NAGK-NC', 13908),
(13909, 'cd10368', NULL, 'SH2_Src_Fyn', NULL, NULL, 'SH2_Src_Fyn', 13909),
(13910, 'cd19030', NULL, 'LGIC_ECD_nAChR_E', NULL, NULL, 'LGIC_ECD_nAChR_E', 13910),
(13911, 'cd15891', NULL, 'SNARE_Vti1a', NULL, NULL, 'SNARE_Vti1a', 13911),
(13912, 'cd18463', NULL, 'BACK_KLHL24', NULL, NULL, 'BACK_KLHL24', 13912),
(13913, 'cd09099', NULL, 'INPP5c_Synj2', NULL, NULL, 'INPP5c_Synj2', 13913),
(13914, 'cd01019', NULL, 'ZnuA', NULL, NULL, 'ZnuA', 13914),
(13915, 'cd14664', NULL, 'STK_BAK1_like', NULL, NULL, 'STK_BAK1_like', 13915),
(13916, 'cd07731', NULL, 'ComA-like_MBL-fold', NULL, NULL, 'ComA-like_MBL-fold', 13916),
(13917, 'cd10496', NULL, 'MH2_I-SMAD', NULL, NULL, 'MH2_I-SMAD', 13917),
(13918, 'cd05702', NULL, 'S1_Rrp5_repeat_hs11_sc8', NULL, NULL, 'S1_Rrp5_repeat_hs11_sc8', 13918),
(13919, 'cd17124', NULL, 'Ubl_TECR', NULL, NULL, 'Ubl_TECR', 13919),
(13920, 'cd08781', NULL, 'Death_UNC5-like', NULL, NULL, 'Death_UNC5-like', 13920),
(13921, 'cd12655', NULL, 'RRM3_HuC', NULL, NULL, 'RRM3_HuC', 13921),
(13922, 'cd12715', NULL, 'RRM2_MATR3', NULL, NULL, 'RRM2_MATR3', 13922),
(13923, 'cd16685', NULL, 'RING-H2_UBR1', NULL, NULL, 'RING-H2_UBR1', 13923),
(13924, 'cd14056', NULL, 'STKc_TGFbR_I', NULL, NULL, 'STKc_TGFbR_I', 13924),
(13925, 'cd14454', NULL, 'CuRO_4_FV_like', NULL, NULL, 'CuRO_4_FV_like', 13925),
(13926, 'cd03141', NULL, 'GATase1_Hsp31_like', NULL, NULL, 'GATase1_Hsp31_like', 13926),
(13927, 'cd17594', NULL, 'REC_OmpR_VirG', NULL, NULL, 'REC_OmpR_VirG', 13927),
(13928, 'cd01115', NULL, 'SLC13_permease', NULL, NULL, 'SLC13_permease', 13928),
(13929, 'cd19840', NULL, 'Bbox1_TRIM29', NULL, NULL, 'Bbox1_TRIM29', 13929),
(13930, 'cd06541', NULL, 'ASCH', NULL, NULL, 'ASCH', 13930),
(13931, 'cd10918', NULL, 'CE4_NodB_like_5s_6s', NULL, NULL, 'CE4_NodB_like_5s_6s', 13931),
(13932, 'cd07478', NULL, 'Peptidases_S8_CspA-like', NULL, NULL, 'Peptidases_S8_CspA-like', 13932),
(13933, 'cd08547', NULL, 'Type_II_cohesin', NULL, NULL, 'Type_II_cohesin', 13933),
(13934, 'cd13305', NULL, 'PH_SHARPIN', NULL, NULL, 'PH_SHARPIN', 13934),
(13935, 'cd09212', NULL, 'PUB', NULL, NULL, 'PUB', 13935),
(13936, 'cd03125', NULL, 'alpha_CA_VI', NULL, NULL, 'alpha_CA_VI', 13936),
(13937, 'cd01910', NULL, 'Wali7', NULL, NULL, 'Wali7', 13937),
(13938, 'cd08315', NULL, 'Death_TRAILR_DR4_DR5', NULL, NULL, 'Death_TRAILR_DR4_DR5', 13938),
(13939, 'cd15835', NULL, 'TNFRSF1B_teleost', NULL, NULL, 'TNFRSF1B_teleost', 13939);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(13940, 'cd07935', NULL, 'RHD-n_NFkB1', NULL, NULL, 'RHD-n_NFkB1', 13940),
(13941, 'cd02070', NULL, 'corrinoid_protein_B12-BD', NULL, NULL, 'corrinoid_protein_B12-BD', 13941),
(13942, 'cd08036', NULL, 'LARP_5', NULL, NULL, 'LARP_5', 13942),
(13943, 'cd15519', NULL, 'PHD1_Lid2p_like', NULL, NULL, 'PHD1_Lid2p_like', 13943),
(13944, 'cd02959', NULL, 'ERp19', NULL, NULL, 'ERp19', 13944),
(13945, 'cd14970', NULL, '7tmA_Opioid_R-like', NULL, NULL, '7tmA_Opioid_R-like', 13945),
(13946, 'cd05880', NULL, 'Ig_EVA1', NULL, NULL, 'Ig_EVA1', 13946),
(13947, 'cd14516', NULL, 'DSP_fungal_PPS1', NULL, NULL, 'DSP_fungal_PPS1', 13947),
(13948, 'cd20293', NULL, 'cupin_HutD_N', NULL, NULL, 'cupin_HutD_N', 13948),
(13949, 'cd01142', NULL, 'TroA_e', NULL, NULL, 'TroA_e', 13949),
(13950, 'cd05509', NULL, 'Bromo_gcn5_like', NULL, NULL, 'Bromo_gcn5_like', 13950),
(13951, 'cd13749', NULL, 'Zn-ribbon_TFIIS', NULL, NULL, 'Zn-ribbon_TFIIS', 13951),
(13952, 'cd03143', NULL, 'A4_beta-galactosidase_middle_domain', NULL, NULL, 'A4_beta-galactosidase_middle_domain', 13952),
(13953, 'cd02047', NULL, 'serpinD1_HCF2', NULL, NULL, 'serpinD1_HCF2', 13953),
(13954, 'cd01756', NULL, 'PLAT_repeat', NULL, NULL, 'PLAT_repeat', 13954),
(13955, 'cd18196', NULL, 'BTB_POZ_ZBTB5', NULL, NULL, 'BTB_POZ_ZBTB5', 13955),
(13956, 'cd03316', NULL, 'MR_like', NULL, NULL, 'MR_like', 13956),
(13957, 'cd05680', NULL, 'M20_dipept_like', NULL, NULL, 'M20_dipept_like', 13957),
(13958, 'cd17909', NULL, 'CheC_ClassI', NULL, NULL, 'CheC_ClassI', 13958),
(13959, 'cd09563', NULL, 'SAM_liprin-beta1,2_repeat1', NULL, NULL, 'SAM_liprin-beta1,2_repeat1', 13959),
(13960, 'cd08792', NULL, 'DED_Caspase_8_10_r1', NULL, NULL, 'DED_Caspase_8_10_r1', 13960),
(13961, 'cd09805', NULL, 'type2_17beta_HSD-like_SDR_c', NULL, NULL, 'type2_17beta_HSD-like_SDR_c', 13961),
(13962, 'cd18680', NULL, 'PIN_MtVapC20-like', NULL, NULL, 'PIN_MtVapC20-like', 13962),
(13963, 'cd16422', NULL, 'HAD_Pase_UmpH-like', NULL, NULL, 'HAD_Pase_UmpH-like', 13963),
(13964, 'cd08553', NULL, 'PIN_Fcf1-like', NULL, NULL, 'PIN_Fcf1-like', 13964),
(13965, 'cd15839', NULL, 'TNFRSF_viral', NULL, NULL, 'TNFRSF_viral', 13965),
(13966, 'cd17353', NULL, 'MFS_OFA_like', NULL, NULL, 'MFS_OFA_like', 13966),
(13967, 'cd19171', NULL, 'SET_KMT2C_2D', NULL, NULL, 'SET_KMT2C_2D', 13967),
(13968, 'cd11347', NULL, 'AmyAc_1', NULL, NULL, 'AmyAc_1', 13968),
(13969, 'cd09974', NULL, 'LOTUS_3_TDRD7', NULL, NULL, 'LOTUS_3_TDRD7', 13969),
(13970, 'cd13783', NULL, 'SPACA1', NULL, NULL, 'SPACA1', 13970),
(13971, 'cd15314', NULL, '7tmA_TAAR1', NULL, NULL, '7tmA_TAAR1', 13971),
(13972, 'cd17808', NULL, 'HipA_Ec_like', NULL, NULL, 'HipA_Ec_like', 13972),
(13973, 'cd12787', NULL, 'RasGAP_plexin_B', NULL, NULL, 'RasGAP_plexin_B', 13973),
(13974, 'cd08882', NULL, 'RHO_alpha_C_MupW-like', NULL, NULL, 'RHO_alpha_C_MupW-like', 13974),
(13975, 'cd01827', NULL, 'sialate_O-acetylesterase_like1', NULL, NULL, 'sialate_O-acetylesterase_like1', 13975),
(13976, 'cd03157', NULL, 'TM4SF12_like_LEL', NULL, NULL, 'TM4SF12_like_LEL', 13976),
(13977, 'cd11469', NULL, 'bHLH-PAS_ARNTL2_PASD9', NULL, NULL, 'bHLH-PAS_ARNTL2_PASD9', 13977),
(13978, 'cd06659', NULL, 'STKc_PAK6', NULL, NULL, 'STKc_PAK6', 13978),
(13979, 'cd04107', NULL, 'Rab32_Rab38', NULL, NULL, 'Rab32_Rab38', 13979),
(13980, 'cd19557', NULL, 'serpinA11', NULL, NULL, 'serpinA11', 13980),
(13981, 'cd04206', NULL, 'CuRO_1_LCC_like', NULL, NULL, 'CuRO_1_LCC_like', 13981),
(13982, 'cd19866', NULL, 'DSRM_STRBP_RED-like_rpt2', NULL, NULL, 'DSRM_STRBP_RED-like_rpt2', 13982),
(13983, 'cd06399', NULL, 'PB1_P40', NULL, NULL, 'PB1_P40', 13983),
(13984, 'cd06963', NULL, 'NR_DBD_GR_like', NULL, NULL, 'NR_DBD_GR_like', 13984),
(13985, 'cd08731', NULL, 'RGS_RGS22_1', NULL, NULL, 'RGS_RGS22_1', 13985),
(13986, 'cd02079', NULL, 'P-type_ATPase_HM', NULL, NULL, 'P-type_ATPase_HM', 13986),
(13987, 'cd04582', NULL, 'CBS_pair_ABC_OpuCA_assoc', NULL, NULL, 'CBS_pair_ABC_OpuCA_assoc', 13987),
(13988, 'cd17067', NULL, 'RBD2_RGS12_like', NULL, NULL, 'RBD2_RGS12_like', 13988),
(13989, 'cd00949', NULL, 'FBP_aldolase_I_bact', NULL, NULL, 'FBP_aldolase_I_bact', 13989);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(13990, 'cd10474', NULL, 'EphR_LBD_B4', NULL, NULL, 'EphR_LBD_B4', 13990),
(13991, 'cd08018', NULL, 'M20_Acy1_amhX-like', NULL, NULL, 'M20_Acy1_amhX-like', 13991),
(13992, 'cd02637', NULL, 'R3H_PARN', NULL, NULL, 'R3H_PARN', 13992),
(13993, 'cd09102', NULL, 'PLDc_CDP-OH_P_transf_II_1', NULL, NULL, 'PLDc_CDP-OH_P_transf_II_1', 13993),
(13994, 'cd04335', NULL, 'PrdX_deacylase', NULL, NULL, 'PrdX_deacylase', 13994),
(13995, 'cd04640', NULL, 'CBS_pair_proteobact', NULL, NULL, 'CBS_pair_proteobact', 13995),
(13996, 'cd02749', NULL, 'Macro_SF', NULL, NULL, 'Macro_SF', 13996),
(13997, 'cd19963', NULL, 'PBP1_BMP-like', NULL, NULL, 'PBP1_BMP-like', 13997),
(13998, 'cd01317', NULL, 'DHOase_IIa', NULL, NULL, 'DHOase_IIa', 13998),
(13999, 'cd02960', NULL, 'AGR', NULL, NULL, 'AGR', 13999),
(14000, 'cd17200', NULL, 'FERM_F1_FRMD4B', NULL, NULL, 'FERM_F1_FRMD4B', 14000),
(14001, 'cd17246', NULL, 'RMtype1_S_SonII-TRD2-CR2_like', NULL, NULL, 'RMtype1_S_SonII-TRD2-CR2_like', 14001),
(14002, 'cd11257', NULL, 'Sema_4B', NULL, NULL, 'Sema_4B', 14002),
(14003, 'cd13636', NULL, 'PBP2_Af1704', NULL, NULL, 'PBP2_Af1704', 14003),
(14004, 'cd10947', NULL, 'CE4_SpPgdA_BsYjeA_like', NULL, NULL, 'CE4_SpPgdA_BsYjeA_like', 14004),
(14005, 'cd05519', NULL, 'Bromo_SNF2', NULL, NULL, 'Bromo_SNF2', 14005),
(14006, 'cd16631', NULL, 'mRING-HC-C4C4_RBR_HOIP', NULL, NULL, 'mRING-HC-C4C4_RBR_HOIP', 14006),
(14007, 'cd04757', NULL, 'Commd9', NULL, NULL, 'Commd9', 14007),
(14008, 'cd05045', NULL, 'PTKc_RET', NULL, NULL, 'PTKc_RET', 14008),
(14009, 'cd08021', NULL, 'M20_Acy1_YhaA-like', NULL, NULL, 'M20_Acy1_YhaA-like', 14009),
(14010, 'cd14250', NULL, 'ESP36_like', NULL, NULL, 'ESP36_like', 14010),
(14011, 'cd12296', NULL, 'RRM1_Prp24', NULL, NULL, 'RRM1_Prp24', 14011),
(14012, 'cd08194', NULL, 'Fe-ADH-like', NULL, NULL, 'Fe-ADH-like', 14012),
(14013, 'cd06851', NULL, 'GT_GPT_like', NULL, NULL, 'GT_GPT_like', 14013),
(14014, 'cd02224', NULL, 'cupin_SPO2919-like', NULL, NULL, 'cupin_SPO2919-like', 14014),
(14015, 'cd12918', NULL, 'VKOR_arc', NULL, NULL, 'VKOR_arc', 14015),
(14016, 'cd14034', NULL, 'PK_NRBP1', NULL, NULL, 'PK_NRBP1', 14016),
(14017, 'cd00531', NULL, 'NTF2_like', NULL, NULL, 'NTF2_like', 14017),
(14018, 'cd03876', NULL, 'M28_SGAP_like', NULL, NULL, 'M28_SGAP_like', 14018),
(14019, 'cd04250', NULL, 'AAK_NAGK-C', NULL, NULL, 'AAK_NAGK-C', 14019),
(14020, 'cd18805', NULL, 'SF2_C_suv3', NULL, NULL, 'SF2_C_suv3', 14020),
(14021, 'cd17733', NULL, 'BRCT_Ect2_rpt1', NULL, NULL, 'BRCT_Ect2_rpt1', 14021),
(14022, 'cd02620', NULL, 'Peptidase_C1A_CathepsinB', NULL, NULL, 'Peptidase_C1A_CathepsinB', 14022),
(14023, 'cd13917', NULL, 'CuRO_HCO_II_like_4', NULL, NULL, 'CuRO_HCO_II_like_4', 14023),
(14024, 'cd14019', NULL, 'STKc_Cdc7', NULL, NULL, 'STKc_Cdc7', 14024),
(14025, 'cd11462', NULL, 'bHLH-O_HES7', NULL, NULL, 'bHLH-O_HES7', 14025),
(14026, 'cd08227', NULL, 'PK_STRAD_alpha', NULL, NULL, 'PK_STRAD_alpha', 14026),
(14027, 'cd11507', NULL, 'SLC6sbd_GAT2', NULL, NULL, 'SLC6sbd_GAT2', 14027),
(14028, 'cd15144', NULL, '7tmA_PGE2_EP1', NULL, NULL, '7tmA_PGE2_EP1', 14028),
(14029, 'cd04859', NULL, 'Prim_Pol', NULL, NULL, 'Prim_Pol', 14029),
(14030, 'cd11517', NULL, 'SLC6sbd_B0AT3', NULL, NULL, 'SLC6sbd_B0AT3', 14030),
(14031, 'cd07510', NULL, 'HAD_Pase_UmpH-like', NULL, NULL, 'HAD_Pase_UmpH-like', 14031),
(14032, 'cd13333', NULL, 'FERM_C_JAK2', NULL, NULL, 'FERM_C_JAK2', 14032),
(14033, 'cd18345', NULL, 'BTB_POZ_roadkill-like', NULL, NULL, 'BTB_POZ_roadkill-like', 14033),
(14034, 'cd18384', NULL, 'BTB_POZ_Kv9_KCNS', NULL, NULL, 'BTB_POZ_Kv9_KCNS', 14034),
(14035, 'cd02176', NULL, 'GH16_XET', NULL, NULL, 'GH16_XET', 14035),
(14036, 'cd03890', NULL, 'M20_pepD', NULL, NULL, 'M20_pepD', 14036),
(14037, 'cd16429', NULL, 'VirB10', NULL, NULL, 'VirB10', 14037),
(14038, 'cd19385', NULL, 'TGF_beta_TGFB2', NULL, NULL, 'TGF_beta_TGFB2', 14038),
(14039, 'cd11772', NULL, 'SH3_OSTF1', NULL, NULL, 'SH3_OSTF1', 14039),
(14040, 'cd06579', NULL, 'TM_PBP1_transp_AraH_like', NULL, NULL, 'TM_PBP1_transp_AraH_like', 14040),
(14041, 'cd02124', NULL, 'PA_PoS1_like', NULL, NULL, 'PA_PoS1_like', 14041);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(14042, 'cd18637', NULL, 'CD_Swi6_like', NULL, NULL, 'CD_Swi6_like', 14042),
(14043, 'cd04026', NULL, 'C2_PKC_alpha_gamma', NULL, NULL, 'C2_PKC_alpha_gamma', 14043),
(14044, 'cd08364', NULL, 'FosX', NULL, NULL, 'FosX', 14044),
(14045, 'cd14696', NULL, 'bZIP_Jun', NULL, NULL, 'bZIP_Jun', 14045),
(14046, 'cd17453', NULL, 'MFS_MFSD4A', NULL, NULL, 'MFS_MFSD4A', 14046),
(14047, 'cd21161', NULL, 'NendoU_cv_Nsp15-like', NULL, NULL, 'NendoU_cv_Nsp15-like', 14047),
(14048, 'cd04243', NULL, 'AAK_AK-HSDH-like', NULL, NULL, 'AAK_AK-HSDH-like', 14048),
(14049, 'cd14803', NULL, 'RAP', NULL, NULL, 'RAP', 14049),
(14050, 'cd07131', NULL, 'ALDH_AldH-CAJ73105', NULL, NULL, 'ALDH_AldH-CAJ73105', 14050),
(14051, 'cd19589', NULL, 'serpin_tengpin-like', NULL, NULL, 'serpin_tengpin-like', 14051),
(14052, 'cd16902', NULL, 'pesticin_lyz', NULL, NULL, 'pesticin_lyz', 14052),
(14053, 'cd17502', NULL, 'MFS_Azr1_MDR_like', NULL, NULL, 'MFS_Azr1_MDR_like', 14053),
(14054, 'cd09515', NULL, 'SAM_SGMS1-like', NULL, NULL, 'SAM_SGMS1-like', 14054),
(14055, 'cd11449', NULL, 'bHLH_AtAIB_like', NULL, NULL, 'bHLH_AtAIB_like', 14055),
(14056, 'cd04030', NULL, 'C2C_KIAA1228', NULL, NULL, 'C2C_KIAA1228', 14056),
(14057, 'cd08272', NULL, 'MDR6', NULL, NULL, 'MDR6', 14057),
(14058, 'cd04667', NULL, 'Nudix_Hydrolase_10', NULL, NULL, 'Nudix_Hydrolase_10', 14058),
(14059, 'cd00077', NULL, 'HDc', NULL, NULL, 'HDc', 14059),
(14060, 'cd05593', NULL, 'STKc_PKB_gamma', NULL, NULL, 'STKc_PKB_gamma', 14060),
(14061, 'cd01100', NULL, 'APPLE_Factor_XI_like', NULL, NULL, 'APPLE_Factor_XI_like', 14061),
(14062, 'cd03261', NULL, 'ABC_Org_Solvent_Resistant', NULL, NULL, 'ABC_Org_Solvent_Resistant', 14062),
(14063, 'cd00443', NULL, 'ADA_AMPD', NULL, NULL, 'ADA_AMPD', 14063),
(14064, 'cd09189', NULL, 'PLDc_DNaseII_alpha_1', NULL, NULL, 'PLDc_DNaseII_alpha_1', 14064),
(14065, 'cd13979', NULL, 'STKc_Mos', NULL, NULL, 'STKc_Mos', 14065),
(14066, 'cd00692', NULL, 'ligninase', NULL, NULL, 'ligninase', 14066),
(14067, 'cd16987', NULL, 'ANTH_N_AP180_plant', NULL, NULL, 'ANTH_N_AP180_plant', 14067),
(14068, 'cd17932', NULL, 'DEXQc_UvrD', NULL, NULL, 'DEXQc_UvrD', 14068),
(14069, 'cd13573', NULL, 'PBP2_PnhD_3', NULL, NULL, 'PBP2_PnhD_3', 14069),
(14070, 'cd00796', NULL, 'INT_Rci_Hp1_C', NULL, NULL, 'INT_Rci_Hp1_C', 14070),
(14071, 'cd18441', NULL, 'BRCT_MDC1_rpt2', NULL, NULL, 'BRCT_MDC1_rpt2', 14071),
(14072, 'cd15841', NULL, 'SNARE_Qc', NULL, NULL, 'SNARE_Qc', 14072),
(14073, 'cd00600', NULL, 'Sm_like', NULL, NULL, 'Sm_like', 14073),
(14074, 'cd13671', NULL, 'PBP2_TRAP_SBP_like_3', NULL, NULL, 'PBP2_TRAP_SBP_like_3', 14074),
(14075, 'cd19695', NULL, 'bHLH_dnHLH_EMC_like', NULL, NULL, 'bHLH_dnHLH_EMC_like', 14075),
(14076, 'cd04045', NULL, 'C2C_Tricalbin-like', NULL, NULL, 'C2C_Tricalbin-like', 14076),
(14077, 'cd00716', NULL, 'creatine_kinase_like', NULL, NULL, 'creatine_kinase_like', 14077),
(14078, 'cd12684', NULL, 'RRM_cpo', NULL, NULL, 'RRM_cpo', 14078),
(14079, 'cd18822', NULL, 'GH43_CtGH43-like', NULL, NULL, 'GH43_CtGH43-like', 14079),
(14080, 'cd09521', NULL, 'SAM_ASZ1', NULL, NULL, 'SAM_ASZ1', 14080),
(14081, 'cd14216', NULL, 'STKc_SRPK1', NULL, NULL, 'STKc_SRPK1', 14081),
(14082, 'cd06976', NULL, 'cupin_MtlR-like_N', NULL, NULL, 'cupin_MtlR-like_N', 14082),
(14083, 'cd10525', NULL, 'SET_SUV39H1', NULL, NULL, 'SET_SUV39H1', 14083),
(14084, 'cd11713', NULL, 'GINS_A_psf3', NULL, NULL, 'GINS_A_psf3', 14084),
(14085, 'cd14500', NULL, 'PTP-IVa', NULL, NULL, 'PTP-IVa', 14085),
(14086, 'cd06220', NULL, 'DHOD_e_trans_like2', NULL, NULL, 'DHOD_e_trans_like2', 14086),
(14087, 'cd14724', NULL, 'ZIP_Gal4-like_1', NULL, NULL, 'ZIP_Gal4-like_1', 14087),
(14088, 'cd10812', NULL, 'GH38N_AMII_ScAms1_like', NULL, NULL, 'GH38N_AMII_ScAms1_like', 14088),
(14089, 'cd18551', NULL, 'ABC_6TM_LmrA_like', NULL, NULL, 'ABC_6TM_LmrA_like', 14089),
(14090, 'cd14063', NULL, 'PK_KSR', NULL, NULL, 'PK_KSR', 14090),
(14091, 'cd12909', NULL, 'SPRY_RanBP9_10', NULL, NULL, 'SPRY_RanBP9_10', 14091),
(14092, 'cd09658', NULL, 'Cas5_I-B', NULL, NULL, 'Cas5_I-B', 14092),
(14093, 'cd12376', NULL, 'RRM2_Hu_like', NULL, NULL, 'RRM2_Hu_like', 14093);
INSERT INTO "PUBLIC"."MODEL" VALUES
(14094, 'cd12686', NULL, 'RRM1_PTBPH1_PTBPH2', NULL, NULL, 'RRM1_PTBPH1_PTBPH2', 14094),
(14095, 'cd01097', NULL, 'Tetrahydromethanopterin_reductase', NULL, NULL, 'Tetrahydromethanopterin_reductase', 14095),
(14096, 'cd02167', NULL, 'NMNAT_NadR', NULL, NULL, 'NMNAT_NadR', 14096),
(14097, 'cd13882', NULL, 'CuRO_2_Tv-LCC_like', NULL, NULL, 'CuRO_2_Tv-LCC_like', 14097),
(14098, 'cd04920', NULL, 'ACT_AKiii-DAPDC_2', NULL, NULL, 'ACT_AKiii-DAPDC_2', 14098),
(14099, 'cd15480', NULL, 'fMyo2p_CBD', NULL, NULL, 'fMyo2p_CBD', 14099),
(14100, 'cd17212', NULL, 'RA_RGL3', NULL, NULL, 'RA_RGL3', 14100),
(14101, 'cd01001', NULL, 'PBP2_HisJ_LAO_like', NULL, NULL, 'PBP2_HisJ_LAO_like', 14101),
(14102, 'cd11723', NULL, 'YabN_N_like', NULL, NULL, 'YabN_N_like', 14102),
(14103, 'cd00308', NULL, 'enolase_like', NULL, NULL, 'enolase_like', 14103),
(14104, 'cd12239', NULL, 'RRM2_RBM40_like', NULL, NULL, 'RRM2_RBM40_like', 14104),
(14105, 'cd14399', NULL, 'UBA_PLICs', NULL, NULL, 'UBA_PLICs', 14105),
(14106, 'cd01479', NULL, 'Sec24-like', NULL, NULL, 'Sec24-like', 14106),
(14107, 'cd05229', NULL, 'SDR_a3', NULL, NULL, 'SDR_a3', 14107),
(14108, 'cd10005', NULL, 'HDAC3', NULL, NULL, 'HDAC3', 14108),
(14109, 'cd09142', NULL, 'PLDc_pPLD_like_2', NULL, NULL, 'PLDc_pPLD_like_2', 14109),
(14110, 'cd00532', NULL, 'MGS-like', NULL, NULL, 'MGS-like', 14110),
(14111, 'cd16848', NULL, 'STAT4_DBD', NULL, NULL, 'STAT4_DBD', 14111),
(14112, 'cd13968', NULL, 'PKc_like', NULL, NULL, 'PKc_like', 14112),
(14113, 'cd19931', NULL, 'REC_NarL', NULL, NULL, 'REC_NarL', 14113),
(14114, 'cd04441', NULL, 'DEP_2_DEP6', NULL, NULL, 'DEP_2_DEP6', 14114),
(14115, 'cd00206', NULL, 'snake_toxin', NULL, NULL, 'snake_toxin', 14115),
(14116, 'cd12434', NULL, 'RRM_RCAN_like', NULL, NULL, 'RRM_RCAN_like', 14116),
(14117, 'cd08383', NULL, 'C2A_RasGAP', NULL, NULL, 'C2A_RasGAP', 14117),
(14118, 'cd18452', NULL, 'BACK_KLHL12', NULL, NULL, 'BACK_KLHL12', 14118),
(14119, 'cd02266', NULL, 'SDR', NULL, NULL, 'SDR', 14119),
(14120, 'cd16586', NULL, 'RING-HC_TRIM2_like_C-VII', NULL, NULL, 'RING-HC_TRIM2_like_C-VII', 14120),
(14121, 'cd03683', NULL, 'ClC_1_like', NULL, NULL, 'ClC_1_like', 14121),
(14122, 'cd15784', NULL, 'PH_RUTBC', NULL, NULL, 'PH_RUTBC', 14122),
(14123, 'cd14780', NULL, 'HmpPa-globin-like', NULL, NULL, 'HmpPa-globin-like', 14123),
(14124, 'cd17268', NULL, 'RMtype1_S_Ara36733I_TRD1-CR1_like', NULL, NULL, 'RMtype1_S_Ara36733I_TRD1-CR1_like', 14124),
(14125, 'cd03372', NULL, 'TPP_ComE', NULL, NULL, 'TPP_ComE', 14125),
(14126, 'cd11017', NULL, 'Phytocyanin_like_1', NULL, NULL, 'Phytocyanin_like_1', 14126),
(14127, 'cd14723', NULL, 'ZIP_Ppr1', NULL, NULL, 'ZIP_Ppr1', 14127),
(14128, 'cd07280', NULL, 'PX_YPT35', NULL, NULL, 'PX_YPT35', 14128),
(14129, 'cd14732', NULL, 'LodA', NULL, NULL, 'LodA', 14129),
(14130, 'cd05051', NULL, 'PTKc_DDR', NULL, NULL, 'PTKc_DDR', 14130),
(14131, 'cd08650', NULL, 'FMT_core_HypX_N', NULL, NULL, 'FMT_core_HypX_N', 14131),
(14132, 'cd11769', NULL, 'SH3_CSK', NULL, NULL, 'SH3_CSK', 14132),
(14133, 'cd06867', NULL, 'PX_SNX41_42', NULL, NULL, 'PX_SNX41_42', 14133),
(14134, 'cd18913', NULL, 'bHLH-O_hairy_like', NULL, NULL, 'bHLH-O_hairy_like', 14134),
(14135, 'cd19617', NULL, 'FABP12', NULL, NULL, 'FABP12', 14135),
(14136, 'cd01909', NULL, 'betaLS_CarA_N', NULL, NULL, 'betaLS_CarA_N', 14136),
(14137, 'cd06557', NULL, 'KPHMT-like', NULL, NULL, 'KPHMT-like', 14137),
(14138, 'cd00258', NULL, 'GM2-AP', NULL, NULL, 'GM2-AP', 14138),
(14139, 'cd12359', NULL, 'RRM2_VICKZ', NULL, NULL, 'RRM2_VICKZ', 14139),
(14140, 'cd07399', NULL, 'MPP_YvnB', NULL, NULL, 'MPP_YvnB', 14140),
(14141, 'cd11927', NULL, 'SH3_SH3RF1_1', NULL, NULL, 'SH3_SH3RF1_1', 14141),
(14142, 'cd12321', NULL, 'RRM1_TDP43', NULL, NULL, 'RRM1_TDP43', 14142),
(14143, 'cd10909', NULL, 'ChtBD1_GH18_2', NULL, NULL, 'ChtBD1_GH18_2', 14143),
(14144, 'cd18109', NULL, 'SpoU-like_RNA-MTase', NULL, NULL, 'SpoU-like_RNA-MTase', 14144),
(14145, 'cd05676', NULL, 'M20_dipept_like_CNDP', NULL, NULL, 'M20_dipept_like_CNDP', 14145),
(14146, 'cd01684', NULL, 'Tet_like_IV', NULL, NULL, 'Tet_like_IV', 14146);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(14147, 'cd08059', NULL, 'MPN_prok_mb', NULL, NULL, 'MPN_prok_mb', 14147),
(14148, 'cd18018', NULL, 'DEXHc_RecQ4-like', NULL, NULL, 'DEXHc_RecQ4-like', 14148),
(14149, 'cd13248', NULL, 'PH_PEPP1_2_3', NULL, NULL, 'PH_PEPP1_2_3', 14149),
(14150, 'cd15234', NULL, '7tmA_OR7-like', NULL, NULL, '7tmA_OR7-like', 14150),
(14151, 'cd19998', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, 'PBP1_ABC_sugar_binding-like', 14151),
(14152, 'cd06284', NULL, 'PBP1_LacI-like', NULL, NULL, 'PBP1_LacI-like', 14152),
(14153, 'cd18976', NULL, 'CD_POL_like', NULL, NULL, 'CD_POL_like', 14153),
(14154, 'cd17293', NULL, 'RMtype1_S_Ppo21ORF8840P_TRD1-CR1_like', NULL, NULL, 'RMtype1_S_Ppo21ORF8840P_TRD1-CR1_like', 14154),
(14155, 'cd05133', NULL, 'RasGAP_IQGAP1', NULL, NULL, 'RasGAP_IQGAP1', 14155),
(14156, 'cd07294', NULL, 'PX_SNX12', NULL, NULL, 'PX_SNX12', 14156),
(14157, 'cd06459', NULL, 'M3B_PepF', NULL, NULL, 'M3B_PepF', 14157),
(14158, 'cd00154', NULL, 'Rab', NULL, NULL, 'Rab', 14158),
(14159, 'cd18941', NULL, 'bHLH_TS_OLIG3', NULL, NULL, 'bHLH_TS_OLIG3', 14159),
(14160, 'cd19596', NULL, 'serpin_fungal', NULL, NULL, 'serpin_fungal', 14160),
(14161, 'cd05706', NULL, 'S1_Rrp5_repeat_sc10', NULL, NULL, 'S1_Rrp5_repeat_sc10', 14161),
(14162, 'cd10354', NULL, 'SH2_Cterm_RasGAP', NULL, NULL, 'SH2_Cterm_RasGAP', 14162),
(14163, 'cd10511', NULL, 'Zn-ribbon_TFS', NULL, NULL, 'Zn-ribbon_TFS', 14163),
(14164, 'cd14736', NULL, 'BACK_AtBPM-like', NULL, NULL, 'BACK_AtBPM-like', 14164),
(14165, 'cd07612', NULL, 'BAR_Bin2', NULL, NULL, 'BAR_Bin2', 14165),
(14166, 'cd02752', NULL, 'MopB_Formate-Dh-Na-like', NULL, NULL, 'MopB_Formate-Dh-Na-like', 14166),
(14167, 'cd13541', NULL, 'PBP2_ModA_like_2', NULL, NULL, 'PBP2_ModA_like_2', 14167),
(14168, 'cd14140', NULL, 'STKc_ACVR2b', NULL, NULL, 'STKc_ACVR2b', 14168),
(14169, 'cd04843', NULL, 'Peptidases_S8_11', NULL, NULL, 'Peptidases_S8_11', 14169),
(14170, 'cd01242', NULL, 'PH_ROCK', NULL, NULL, 'PH_ROCK', 14170),
(14171, 'cd15952', NULL, '7tmA_OR52E-like', NULL, NULL, '7tmA_OR52E-like', 14171),
(14172, 'cd17960', NULL, 'DEADc_DDX55', NULL, NULL, 'DEADc_DDX55', 14172),
(14173, 'cd05061', NULL, 'PTKc_InsR', NULL, NULL, 'PTKc_InsR', 14173),
(14174, 'cd15063', NULL, '7tmA_Octopamine_R', NULL, NULL, '7tmA_Octopamine_R', 14174),
(14175, 'cd04268', NULL, 'ZnMc_MMP_like', NULL, NULL, 'ZnMc_MMP_like', 14175),
(14176, 'cd15279', NULL, '7tmC_RAIG1_4_GPRC5A_D', NULL, NULL, '7tmC_RAIG1_4_GPRC5A_D', 14176),
(14177, 'cd15777', NULL, 'CRBN_C_like', NULL, NULL, 'CRBN_C_like', 14177),
(14178, 'cd02890', NULL, 'PTase', NULL, NULL, 'PTase', 14178),
(14179, 'cd14022', NULL, 'PK_TRB2', NULL, NULL, 'PK_TRB2', 14179),
(14180, 'cd13930', NULL, 'PT-Tnase', NULL, NULL, 'PT-Tnase', 14180),
(14181, 'cd09587', NULL, 'SAM_HARP', NULL, NULL, 'SAM_HARP', 14181),
(14182, 'cd09223', NULL, 'Photo_RC', NULL, NULL, 'Photo_RC', 14182),
(14183, 'cd16439', NULL, 'beta_Kdo_transferase_KpsC_2', NULL, NULL, 'beta_Kdo_transferase_KpsC_2', 14183),
(14184, 'cd13429', NULL, 'UreI_AmiS_like_2', NULL, NULL, 'UreI_AmiS_like_2', 14184),
(14185, 'cd18795', NULL, 'SF2_C_Ski2', NULL, NULL, 'SF2_C_Ski2', 14185),
(14186, 'cd03253', NULL, 'ABCC_ATM1_transporter', NULL, NULL, 'ABCC_ATM1_transporter', 14186),
(14187, 'cd09696', NULL, 'Cas3_I', NULL, NULL, 'Cas3_I', 14187),
(14188, 'cd02168', NULL, 'NMNAT_Nudix', NULL, NULL, 'NMNAT_Nudix', 14188),
(14189, 'cd13546', NULL, 'PBP2_BitB', NULL, NULL, 'PBP2_BitB', 14189),
(14190, 'cd16670', NULL, 'RING-H2_RNF215', NULL, NULL, 'RING-H2_RNF215', 14190),
(14191, 'cd08570', NULL, 'GDPD_YPL206cp_fungi', NULL, NULL, 'GDPD_YPL206cp_fungi', 14191),
(14192, 'cd08986', NULL, 'GH43-like', NULL, NULL, 'GH43-like', 14192),
(14193, 'cd05587', NULL, 'STKc_cPKC', NULL, NULL, 'STKc_cPKC', 14193),
(14194, 'cd11500', NULL, 'SLC6sbd_PROT', NULL, NULL, 'SLC6sbd_PROT', 14194),
(14195, 'cd01177', NULL, 'IPT_NFkappaB', NULL, NULL, 'IPT_NFkappaB', 14195),
(14196, 'cd04029', NULL, 'C2A_SLP-4_5', NULL, NULL, 'C2A_SLP-4_5', 14196),
(14197, 'cd15775', NULL, 'FYVE2_BSN', NULL, NULL, 'FYVE2_BSN', 14197),
(14198, 'cd02508', NULL, 'ADP_Glucose_PP', NULL, NULL, 'ADP_Glucose_PP', 14198);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(14199, 'cd06359', NULL, 'PBP1_Nba-like', NULL, NULL, 'PBP1_Nba-like', 14199),
(14200, 'cd17287', NULL, 'RMtype1_S_EcoN10ORF171P_TRD2-CR2_like', NULL, NULL, 'RMtype1_S_EcoN10ORF171P_TRD2-CR2_like', 14200),
(14201, 'cd05175', NULL, 'PI3Kc_IA_alpha', NULL, NULL, 'PI3Kc_IA_alpha', 14201),
(14202, 'cd19734', NULL, 'bHLH-PAS_CLOCK', NULL, NULL, 'bHLH-PAS_CLOCK', 14202),
(14203, 'cd00002', NULL, 'YbaK_deacylase', NULL, NULL, 'YbaK_deacylase', 14203),
(14204, 'cd07517', NULL, 'HAD_HPP', NULL, NULL, 'HAD_HPP', 14204),
(14205, 'cd12643', NULL, 'RRM_CFIm68', NULL, NULL, 'RRM_CFIm68', 14205),
(14206, 'cd05355', NULL, 'SDR_c1', NULL, NULL, 'SDR_c1', 14206),
(14207, 'cd14955', NULL, 'NHL_like_4', NULL, NULL, 'NHL_like_4', 14207),
(14208, 'cd01641', NULL, 'Bacterial_IMPase_like_1', NULL, NULL, 'Bacterial_IMPase_like_1', 14208),
(14209, 'cd13642', NULL, 'PBP2_BCP_1', NULL, NULL, 'PBP2_BCP_1', 14209),
(14210, 'cd03741', NULL, 'SOCS_SOCS7', NULL, NULL, 'SOCS_SOCS7', 14210),
(14211, 'cd05164', NULL, 'PIKKc', NULL, NULL, 'PIKKc', 14211),
(14212, 'cd11615', NULL, 'SAF_NeuB_like', NULL, NULL, 'SAF_NeuB_like', 14212),
(14213, 'cd16264', NULL, 'snRNP_III', NULL, NULL, 'snRNP_III', 14213),
(14214, 'cd12628', NULL, 'RRM2_IGF2BP1', NULL, NULL, 'RRM2_IGF2BP1', 14214),
(14215, 'cd18624', NULL, 'GH32_Fruct1-like', NULL, NULL, 'GH32_Fruct1-like', 14215),
(14216, 'cd00831', NULL, 'CHS_like', NULL, NULL, 'CHS_like', 14216),
(14217, 'cd06582', NULL, 'TM_PBP1_LivH_like', NULL, NULL, 'TM_PBP1_LivH_like', 14217),
(14218, 'cd08279', NULL, 'Zn_ADH_class_III', NULL, NULL, 'Zn_ADH_class_III', 14218),
(14219, 'cd14847', NULL, 'DD-carboxypeptidase_like', NULL, NULL, 'DD-carboxypeptidase_like', 14219),
(14220, 'cd15283', NULL, '7tmC_V2R_pheromone', NULL, NULL, '7tmC_V2R_pheromone', 14220),
(14221, 'cd15849', NULL, 'SNARE_Sso1', NULL, NULL, 'SNARE_Sso1', 14221),
(14222, 'cd04381', NULL, 'RhoGap_RalBP1', NULL, NULL, 'RhoGap_RalBP1', 14222),
(14223, 'cd07139', NULL, 'ALDH_AldA-Rv0768', NULL, NULL, 'ALDH_AldA-Rv0768', 14223),
(14224, 'cd16490', NULL, 'RING-CH-C4HC3_FANCL', NULL, NULL, 'RING-CH-C4HC3_FANCL', 14224),
(14225, 'cd16937', NULL, 'HATPase_SMCHD1-like', NULL, NULL, 'HATPase_SMCHD1-like', 14225),
(14226, 'cd17359', NULL, 'MFS_XylE_like', NULL, NULL, 'MFS_XylE_like', 14226),
(14227, 'cd02875', NULL, 'GH18_chitobiase', NULL, NULL, 'GH18_chitobiase', 14227),
(14228, 'cd05935', NULL, 'LC_FACS_like', NULL, NULL, 'LC_FACS_like', 14228),
(14229, 'cd04708', NULL, 'BAH_plantDCM_II', NULL, NULL, 'BAH_plantDCM_II', 14229),
(14230, 'cd03703', NULL, 'aeIF5B_II', NULL, NULL, 'aeIF5B_II', 14230),
(14231, 'cd16747', NULL, 'RING-HC_RNF212B', NULL, NULL, 'RING-HC_RNF212B', 14231),
(14232, 'cd17623', NULL, 'REC_OmpR_CpxR', NULL, NULL, 'REC_OmpR_CpxR', 14232),
(14233, 'cd09694', NULL, 'Csm6_III-A', NULL, NULL, 'Csm6_III-A', 14233),
(14234, 'cd06247', NULL, 'M14_CPO', NULL, NULL, 'M14_CPO', 14234),
(14235, 'cd01136', NULL, 'ATPase_flagellum-secretory_path_III', NULL, NULL, 'ATPase_flagellum-secretory_path_III', 14235),
(14236, 'cd15397', NULL, '7tmA_NPY4R', NULL, NULL, '7tmA_NPY4R', 14236),
(14237, 'cd08385', NULL, 'C2A_Synaptotagmin-1-5-6-9-10', NULL, NULL, 'C2A_Synaptotagmin-1-5-6-9-10', 14237),
(14238, 'cd06432', NULL, 'GT8_HUGT1_C_like', NULL, NULL, 'GT8_HUGT1_C_like', 14238),
(14239, 'cd16990', NULL, 'ENTH_Epsin', NULL, NULL, 'ENTH_Epsin', 14239),
(14240, 'cd06571', NULL, 'Bac_DnaA_C', NULL, NULL, 'Bac_DnaA_C', 14240),
(14241, 'cd05652', NULL, 'M20_ArgE_DapE-like_fungal', NULL, NULL, 'M20_ArgE_DapE-like_fungal', 14241),
(14242, 'cd04270', NULL, 'ZnMc_TACE_like', NULL, NULL, 'ZnMc_TACE_like', 14242),
(14243, 'cd11904', NULL, 'SH3_Nck1_3', NULL, NULL, 'SH3_Nck1_3', 14243),
(14244, 'cd14272', NULL, 'UBA_AMPK-RKs', NULL, NULL, 'UBA_AMPK-RKs', 14244),
(14245, 'cd19196', NULL, 'PR-SET_PRDM12', NULL, NULL, 'PR-SET_PRDM12', 14245),
(14246, 'cd17408', NULL, 'MFS_unc93B1', NULL, NULL, 'MFS_unc93B1', 14246),
(14247, 'cd05504', NULL, 'Bromo_Acf1_like', NULL, NULL, 'Bromo_Acf1_like', 14247),
(14248, 'cd05333', NULL, 'BKR_SDR_c', NULL, NULL, 'BKR_SDR_c', 14248);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(14249, 'cd04728', NULL, 'ThiG', NULL, NULL, 'ThiG', 14249),
(14250, 'cd16031', NULL, 'G6S_like', NULL, NULL, 'G6S_like', 14250),
(14251, 'cd01717', NULL, 'Sm_B', NULL, NULL, 'Sm_B', 14251),
(14252, 'cd06169', NULL, 'BMC', NULL, NULL, 'BMC', 14252),
(14253, 'cd18080', NULL, 'TrmD-like', NULL, NULL, 'TrmD-like', 14253),
(14254, 'cd15548', NULL, 'PHD_ASH1L', NULL, NULL, 'PHD_ASH1L', 14254),
(14255, 'cd16315', NULL, 'EVM-1-like_MBL-B3', NULL, NULL, 'EVM-1-like_MBL-B3', 14255),
(14256, 'cd14737', NULL, 'PAAR_1', NULL, NULL, 'PAAR_1', 14256),
(14257, 'cd17943', NULL, 'DEADc_DDX20', NULL, NULL, 'DEADc_DDX20', 14257),
(14258, 'cd07585', NULL, 'nitrilase_7', NULL, NULL, 'nitrilase_7', 14258),
(14259, 'cd15828', NULL, 'SPRY_PRY_TRIM60', NULL, NULL, 'SPRY_PRY_TRIM60', 14259),
(14260, 'cd01132', NULL, 'F1_ATPase_alpha', NULL, NULL, 'F1_ATPase_alpha', 14260),
(14261, 'cd03239', NULL, 'ABC_SMC_head', NULL, NULL, 'ABC_SMC_head', 14261),
(14262, 'cd10304', NULL, 'GST_C_Arc1p_N_like', NULL, NULL, 'GST_C_Arc1p_N_like', 14262),
(14263, 'cd08897', NULL, 'SRPBCC_CalC_Aha1-like_4', NULL, NULL, 'SRPBCC_CalC_Aha1-like_4', 14263),
(14264, 'cd07162', NULL, 'NR_DBD_PXR', NULL, NULL, 'NR_DBD_PXR', 14264),
(14265, 'cd17434', NULL, 'MFS_GLUT6_Class3', NULL, NULL, 'MFS_GLUT6_Class3', 14265),
(14266, 'cd17254', NULL, 'RMtype1_S_FclI-TRD1-CR1_like', NULL, NULL, 'RMtype1_S_FclI-TRD1-CR1_like', 14266),
(14267, 'cd03460', NULL, '1,2-CTD', NULL, NULL, '1,2-CTD', 14267),
(14268, 'cd19465', NULL, 'CRBP4', NULL, NULL, 'CRBP4', 14268),
(14269, 'cd05144', NULL, 'RIO2_C', NULL, NULL, 'RIO2_C', 14269),
(14270, 'cd12001', NULL, 'SH3_BCAR1', NULL, NULL, 'SH3_BCAR1', 14270),
(14271, 'cd02583', NULL, 'RNAP_III_RPC1_N', NULL, NULL, 'RNAP_III_RPC1_N', 14271),
(14272, 'cd08372', NULL, 'EEP', NULL, NULL, 'EEP', 14272),
(14273, 'cd17059', NULL, 'Ubl_OTU1', NULL, NULL, 'Ubl_OTU1', 14273),
(14274, 'cd14367', NULL, 'CUE_CUED2', NULL, NULL, 'CUE_CUED2', 14274),
(14275, 'cd15929', NULL, '7tmB1_GlucagonR-like', NULL, NULL, '7tmB1_GlucagonR-like', 14275),
(14276, 'cd15671', NULL, 'ePHD_JADE', NULL, NULL, 'ePHD_JADE', 14276),
(14277, 'cd15155', NULL, '7tmA_LPAR4', NULL, NULL, '7tmA_LPAR4', 14277),
(14278, 'cd00320', NULL, 'cpn10', NULL, NULL, 'cpn10', 14278),
(14279, 'cd12329', NULL, 'RRM2_hnRNPD_like', NULL, NULL, 'RRM2_hnRNPD_like', 14279),
(14280, 'cd17929', NULL, 'DEXHc_priA', NULL, NULL, 'DEXHc_priA', 14280),
(14281, 'cd16715', NULL, 'vRING-HC_IRF2BP1', NULL, NULL, 'vRING-HC_IRF2BP1', 14281),
(14282, 'cd08476', NULL, 'PBP2_CrgA_like_7', NULL, NULL, 'PBP2_CrgA_like_7', 14282),
(14283, 'cd04664', NULL, 'Nudix_Hydrolase_7', NULL, NULL, 'Nudix_Hydrolase_7', 14283),
(14284, 'cd00310', NULL, 'ATP-synt_Fo_a_6', NULL, NULL, 'ATP-synt_Fo_a_6', 14284),
(14285, 'cd08873', NULL, 'START_STARD14_15-like', NULL, NULL, 'START_STARD14_15-like', 14285),
(14286, 'cd07914', NULL, 'IGPD', NULL, NULL, 'IGPD', 14286),
(14287, 'cd07663', NULL, 'BAR_SNX5', NULL, NULL, 'BAR_SNX5', 14287),
(14288, 'cd00121', NULL, 'MATH', NULL, NULL, 'MATH', 14288),
(14289, 'cd14657', NULL, 'Imelysin_IrpA-like', NULL, NULL, 'Imelysin_IrpA-like', 14289),
(14290, 'cd07334', NULL, 'M48C_loiP_like', NULL, NULL, 'M48C_loiP_like', 14290),
(14291, 'cd10575', NULL, 'TNFRSF6B', NULL, NULL, 'TNFRSF6B', 14291),
(14292, 'cd00003', NULL, 'PNPsynthase', NULL, NULL, 'PNPsynthase', 14292),
(14293, 'cd14776', NULL, 'HmpEc-globin-like', NULL, NULL, 'HmpEc-globin-like', 14293),
(14294, 'cd08719', NULL, 'RGS_SNX13', NULL, NULL, 'RGS_SNX13', 14294),
(14295, 'cd01470', NULL, 'vWA_complement_factors', NULL, NULL, 'vWA_complement_factors', 14295),
(14296, 'cd04481', NULL, 'RPA1_DBD_B_like', NULL, NULL, 'RPA1_DBD_B_like', 14296),
(14297, 'cd15917', NULL, '7tmA_OR51_52-like', NULL, NULL, '7tmA_OR51_52-like', 14297),
(14298, 'cd15977', NULL, '7tmA_ET-CR', NULL, NULL, '7tmA_ET-CR', 14298),
(14299, 'cd15898', NULL, 'EFh_PI-PLC', NULL, NULL, 'EFh_PI-PLC', 14299),
(14300, 'cd11289', NULL, 'gelsolin_S2_like', NULL, NULL, 'gelsolin_S2_like', 14300),
(14301, 'cd18043', NULL, 'DEXXQc_SF1', NULL, NULL, 'DEXXQc_SF1', 14301);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(14302, 'cd15402', NULL, '7tmA_Mel1A', NULL, NULL, '7tmA_Mel1A', 14302),
(14303, 'cd13743', NULL, 'SPRY_PRY_TRIM50', NULL, NULL, 'SPRY_PRY_TRIM50', 14303),
(14304, 'cd18679', NULL, 'PIN_VapC-Af1683-like', NULL, NULL, 'PIN_VapC-Af1683-like', 14304),
(14305, 'cd16765', NULL, 'RING-HC_TIF1beta', NULL, NULL, 'RING-HC_TIF1beta', 14305),
(14306, 'cd00649', NULL, 'catalase_peroxidase_1', NULL, NULL, 'catalase_peroxidase_1', 14306),
(14307, 'cd12514', NULL, 'RRM4_RBM12_like', NULL, NULL, 'RRM4_RBM12_like', 14307),
(14308, 'cd03462', NULL, '1,2-CCD', NULL, NULL, '1,2-CCD', 14308),
(14309, 'cd01573', NULL, 'modD_like', NULL, NULL, 'modD_like', 14309),
(14310, 'cd09507', NULL, 'SAM_DGK-delta-eta', NULL, NULL, 'SAM_DGK-delta-eta', 14310),
(14311, 'cd02658', NULL, 'Peptidase_C19B', NULL, NULL, 'Peptidase_C19B', 14311),
(14312, 'cd08486', NULL, 'PBP2_CbnR', NULL, NULL, 'PBP2_CbnR', 14312),
(14313, 'cd03768', NULL, 'SR_ResInv', NULL, NULL, 'SR_ResInv', 14313),
(14314, 'cd08398', NULL, 'C2_PI3K_class_I_alpha', NULL, NULL, 'C2_PI3K_class_I_alpha', 14314),
(14315, 'cd07436', NULL, 'PHP_PolX', NULL, NULL, 'PHP_PolX', 14315),
(14316, 'cd05363', NULL, 'SDH_SDR_c', NULL, NULL, 'SDH_SDR_c', 14316),
(14317, 'cd00896', NULL, 'PI3Kc_III', NULL, NULL, 'PI3Kc_III', 14317),
(14318, 'cd03116', NULL, 'MobB', NULL, NULL, 'MobB', 14318),
(14319, 'cd19916', NULL, 'OphMA_like', NULL, NULL, 'OphMA_like', 14319),
(14320, 'cd08537', NULL, 'SAM_PNT-ESE-1-like', NULL, NULL, 'SAM_PNT-ESE-1-like', 14320),
(14321, 'cd10540', NULL, 'SET_SpSet7-like', NULL, NULL, 'SET_SpSet7-like', 14321),
(14322, 'cd05498', NULL, 'Bromo_Brdt_II_like', NULL, NULL, 'Bromo_Brdt_II_like', 14322),
(14323, 'cd13937', NULL, 'PANDER_GnT-1_2_like', NULL, NULL, 'PANDER_GnT-1_2_like', 14323),
(14324, 'cd09369', NULL, 'LIM1_Lhx2_Lhx9', NULL, NULL, 'LIM1_Lhx2_Lhx9', 14324),
(14325, 'cd16151', NULL, 'sulfatase_like', NULL, NULL, 'sulfatase_like', 14325),
(14326, 'cd07648', NULL, 'F-BAR_FCHO', NULL, NULL, 'F-BAR_FCHO', 14326),
(14327, 'cd18492', NULL, 'BACK_BTBD16', NULL, NULL, 'BACK_BTBD16', 14327),
(14328, 'cd04986', NULL, 'IgC_CH2_IgA', NULL, NULL, 'IgC_CH2_IgA', 14328),
(14329, 'cd08601', NULL, 'GDPD_SaGlpQ_like', NULL, NULL, 'GDPD_SaGlpQ_like', 14329),
(14330, 'cd08910', NULL, 'START_STARD2-like', NULL, NULL, 'START_STARD2-like', 14330),
(14331, 'cd13295', NULL, 'PH_EFA6', NULL, NULL, 'PH_EFA6', 14331),
(14332, 'cd12666', NULL, 'RRM2_RAVER2', NULL, NULL, 'RRM2_RAVER2', 14332),
(14333, 'cd04781', NULL, 'HTH_MerR-like_sg6', NULL, NULL, 'HTH_MerR-like_sg6', 14333),
(14334, 'cd09549', NULL, 'SAM_EPH-A10', NULL, NULL, 'SAM_EPH-A10', 14334),
(14335, 'cd12402', NULL, 'RRM_eIF4B', NULL, NULL, 'RRM_eIF4B', 14335),
(14336, 'cd07607', NULL, 'BAR_SH3P_plant', NULL, NULL, 'BAR_SH3P_plant', 14336),
(14337, 'cd01127', NULL, 'TrwB', NULL, NULL, 'TrwB', 14337),
(14338, 'cd09491', NULL, 'SAM_Ship2', NULL, NULL, 'SAM_Ship2', 14338),
(14339, 'cd03079', NULL, 'GST_N_Metaxin2', NULL, NULL, 'GST_N_Metaxin2', 14339),
(14340, 'cd14501', NULL, 'PFA-DSP', NULL, NULL, 'PFA-DSP', 14340),
(14341, 'cd16438', NULL, 'beta_Kdo_transferase_KpsS_like', NULL, NULL, 'beta_Kdo_transferase_KpsS_like', 14341),
(14342, 'cd18427', NULL, 'BTB_POZ_KCNS2', NULL, NULL, 'BTB_POZ_KCNS2', 14342),
(14343, 'cd19752', NULL, 'AKR_unchar', NULL, NULL, 'AKR_unchar', 14343),
(14344, 'cd04128', NULL, 'Spg1', NULL, NULL, 'Spg1', 14344),
(14345, 'cd15704', NULL, 'ePHD_JADE1', NULL, NULL, 'ePHD_JADE1', 14345),
(14346, 'cd16040', NULL, 'SPRY_PRY_SNTX', NULL, NULL, 'SPRY_PRY_SNTX', 14346),
(14347, 'cd21563', NULL, 'Macro_cv_SUD-M_Nsp3-like', NULL, NULL, 'Macro_cv_SUD-M_Nsp3-like', 14347),
(14348, 'cd06560', NULL, 'PriL', NULL, NULL, 'PriL', 14348),
(14349, 'cd21569', NULL, 'SARS-like-CoV_M', NULL, NULL, 'SARS-like-CoV_M', 14349),
(14350, 'cd14179', NULL, 'STKc_MSK1_C', NULL, NULL, 'STKc_MSK1_C', 14350),
(14351, 'cd15485', NULL, 'ZIP_Cat8', NULL, NULL, 'ZIP_Cat8', 14351),
(14352, 'cd10374', NULL, 'SH2_STAT3', NULL, NULL, 'SH2_STAT3', 14352),
(14353, 'cd02639', NULL, 'R3H_RRM', NULL, NULL, 'R3H_RRM', 14353),
(14354, 'cd13299', NULL, 'PH2_PH_fungal', NULL, NULL, 'PH2_PH_fungal', 14354);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(14355, 'cd16501', NULL, 'RING-HC_CblA_like', NULL, NULL, 'RING-HC_CblA_like', 14355),
(14356, 'cd06181', NULL, 'BI-1-like', NULL, NULL, 'BI-1-like', 14356),
(14357, 'cd06863', NULL, 'PX_Atg24p', NULL, NULL, 'PX_Atg24p', 14357),
(14358, 'cd10283', NULL, 'MnuA_DNase1-like', NULL, NULL, 'MnuA_DNase1-like', 14358),
(14359, 'cd19995', NULL, 'PBP1_ABC_xylose_binding-like', NULL, NULL, 'PBP1_ABC_xylose_binding-like', 14359),
(14360, 'cd15270', NULL, '7tmB1_GHRHR', NULL, NULL, '7tmB1_GHRHR', 14360),
(14361, 'cd11346', NULL, 'AmyAc_plant_IsoA', NULL, NULL, 'AmyAc_plant_IsoA', 14361),
(14362, 'cd19033', NULL, 'LGIC_ECD_nAChR_proto-like', NULL, NULL, 'LGIC_ECD_nAChR_proto-like', 14362),
(14363, 'cd09435', NULL, 'LIM3_Zyxin', NULL, NULL, 'LIM3_Zyxin', 14363),
(14364, 'cd17959', NULL, 'DEADc_DDX54', NULL, NULL, 'DEADc_DDX54', 14364),
(14365, 'cd05928', NULL, 'MACS_euk', NULL, NULL, 'MACS_euk', 14365),
(14366, 'cd16866', NULL, 'ARID_ARID2', NULL, NULL, 'ARID_ARID2', 14366),
(14367, 'cd19194', NULL, 'PR-SET_PRDM10', NULL, NULL, 'PR-SET_PRDM10', 14367),
(14368, 'cd10034', NULL, 'UDG_BdiUng_like', NULL, NULL, 'UDG_BdiUng_like', 14368),
(14369, 'cd15718', NULL, 'FYVE_WDFY1_like', NULL, NULL, 'FYVE_WDFY1_like', 14369),
(14370, 'cd01105', NULL, 'HTH_GlnR-like', NULL, NULL, 'HTH_GlnR-like', 14370),
(14371, 'cd11770', NULL, 'SH3_Nephrocystin', NULL, NULL, 'SH3_Nephrocystin', 14371),
(14372, 'cd16372', NULL, 'DMSOR_beta_like', NULL, NULL, 'DMSOR_beta_like', 14372),
(14373, 'cd16761', NULL, 'RING-HC_MuRF3', NULL, NULL, 'RING-HC_MuRF3', 14373),
(14374, 'cd02895', NULL, 'GGTase-I', NULL, NULL, 'GGTase-I', 14374),
(14375, 'cd18549', NULL, 'ABC_6TM_YwjA_like', NULL, NULL, 'ABC_6TM_YwjA_like', 14375),
(14376, 'cd05385', NULL, 'CAP_GLIPR1-like', NULL, NULL, 'CAP_GLIPR1-like', 14376),
(14377, 'cd01403', NULL, 'Cyt_c_Oxidase_VIIb', NULL, NULL, 'Cyt_c_Oxidase_VIIb', 14377),
(14378, 'cd01484', NULL, 'E1-2_like', NULL, NULL, 'E1-2_like', 14378),
(14379, 'cd07103', NULL, 'ALDH_F5_SSADH_GabD', NULL, NULL, 'ALDH_F5_SSADH_GabD', 14379),
(14380, 'cd07116', NULL, 'ALDH_ACDHII-AcoD', NULL, NULL, 'ALDH_ACDHII-AcoD', 14380),
(14381, 'cd12702', NULL, 'RRM4_PTBP2', NULL, NULL, 'RRM4_PTBP2', 14381),
(14382, 'cd00172', NULL, 'serpin', NULL, NULL, 'serpin', 14382),
(14383, 'cd16408', NULL, 'ParB_N_like', NULL, NULL, 'ParB_N_like', 14383),
(14384, 'cd04193', NULL, 'UDPGlcNAc_PPase', NULL, NULL, 'UDPGlcNAc_PPase', 14384),
(14385, 'cd16167', NULL, 'OCRE_RBM10', NULL, NULL, 'OCRE_RBM10', 14385),
(14386, 'cd00782', NULL, 'MutL_Trans', NULL, NULL, 'MutL_Trans', 14386),
(14387, 'cd11801', NULL, 'SH3_JIP1_like', NULL, NULL, 'SH3_JIP1_like', 14387),
(14388, 'cd03782', NULL, 'MATH_Meprin_Beta', NULL, NULL, 'MATH_Meprin_Beta', 14388),
(14389, 'cd05357', NULL, 'PR_SDR_c', NULL, NULL, 'PR_SDR_c', 14389),
(14390, 'cd06162', NULL, 'S2P-M50_PDZ_SREBP', NULL, NULL, 'S2P-M50_PDZ_SREBP', 14390),
(14391, 'cd12087', NULL, 'TM_EGFR-like', NULL, NULL, 'TM_EGFR-like', 14391),
(14392, 'cd08067', NULL, 'MPN_2A_DUB', NULL, NULL, 'MPN_2A_DUB', 14392),
(14393, 'cd07290', NULL, 'PX_PI3K_C2_beta', NULL, NULL, 'PX_PI3K_C2_beta', 14393),
(14394, 'cd13403', NULL, 'MLTF-like', NULL, NULL, 'MLTF-like', 14394),
(14395, 'cd09764', NULL, 'Csb3_I-U', NULL, NULL, 'Csb3_I-U', 14395),
(14396, 'cd11694', NULL, 'DHR2_DOCK_D', NULL, NULL, 'DHR2_DOCK_D', 14396),
(14397, 'cd15482', NULL, 'Sialidase_non-viral', NULL, NULL, 'Sialidase_non-viral', 14397),
(14398, 'cd01468', NULL, 'trunk_domain', NULL, NULL, 'trunk_domain', 14398),
(14399, 'cd09406', NULL, 'LIM1_Leupaxin', NULL, NULL, 'LIM1_Leupaxin', 14399),
(14400, 'cd12230', NULL, 'RRM1_U2AF65', NULL, NULL, 'RRM1_U2AF65', 14400),
(14401, 'cd15843', NULL, 'R-SNARE', NULL, NULL, 'R-SNARE', 14401),
(14402, 'cd14514', NULL, 'DUSP14-like', NULL, NULL, 'DUSP14-like', 14402),
(14403, 'cd05844', NULL, 'GT4-like', NULL, NULL, 'GT4-like', 14403),
(14404, 'cd09928', NULL, 'SH2_Cterm_SPT6_like', NULL, NULL, 'SH2_Cterm_SPT6_like', 14404),
(14405, 'cd17084', NULL, 'RAWUL_PCGF5', NULL, NULL, 'RAWUL_PCGF5', 14405),
(14406, 'cd12455', NULL, 'RRM_like_Smg4_UPF3', NULL, NULL, 'RRM_like_Smg4_UPF3', 14406);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(14407, 'cd02865', NULL, 'Heme_Cu_Oxidase_III_2', NULL, NULL, 'Heme_Cu_Oxidase_III_2', 14407),
(14408, 'cd18280', NULL, 'BTB_POZ_BPM_plant', NULL, NULL, 'BTB_POZ_BPM_plant', 14408),
(14409, 'cd06216', NULL, 'FNR_iron_sulfur_binding_2', NULL, NULL, 'FNR_iron_sulfur_binding_2', 14409),
(14410, 'cd11524', NULL, 'SYLF', NULL, NULL, 'SYLF', 14410),
(14411, 'cd12498', NULL, 'RRM3_ACF', NULL, NULL, 'RRM3_ACF', 14411),
(14412, 'cd04187', NULL, 'DPM1_like_bac', NULL, NULL, 'DPM1_like_bac', 14412),
(14413, 'cd00458', NULL, 'SugarP_isomerase', NULL, NULL, 'SugarP_isomerase', 14413),
(14414, 'cd00225', NULL, 'API3', NULL, NULL, 'API3', 14414),
(14415, 'cd11780', NULL, 'SH3_Sorbs_3', NULL, NULL, 'SH3_Sorbs_3', 14415),
(14416, 'cd01852', NULL, 'AIG1', NULL, NULL, 'AIG1', 14416),
(14417, 'cd09117', NULL, 'PLDc_Bfil_DEXD_like', NULL, NULL, 'PLDc_Bfil_DEXD_like', 14417),
(14418, 'cd01312', NULL, 'Met_dep_hydrolase_D', NULL, NULL, 'Met_dep_hydrolase_D', 14418),
(14419, 'cd14364', NULL, 'CUE_ASCC2', NULL, NULL, 'CUE_ASCC2', 14419),
(14420, 'cd02922', NULL, 'FCB2_FMN', NULL, NULL, 'FCB2_FMN', 14420),
(14421, 'cd01887', NULL, 'IF2_eIF5B', NULL, NULL, 'IF2_eIF5B', 14421),
(14422, 'cd07576', NULL, 'R-amidase_like', NULL, NULL, 'R-amidase_like', 14422),
(14423, 'cd18486', NULL, 'BACK_KBTBD13', NULL, NULL, 'BACK_KBTBD13', 14423),
(14424, 'cd02790', NULL, 'MopB_CT_Formate-Dh_H', NULL, NULL, 'MopB_CT_Formate-Dh_H', 14424),
(14425, 'cd01840', NULL, 'SGNH_hydrolase_yrhL_like', NULL, NULL, 'SGNH_hydrolase_yrhL_like', 14425),
(14426, 'cd19125', NULL, 'AKR_AKR4C1-15', NULL, NULL, 'AKR_AKR4C1-15', 14426),
(14427, 'cd13233', NULL, 'PH_ARHGAP9-like', NULL, NULL, 'PH_ARHGAP9-like', 14427),
(14428, 'cd13525', NULL, 'PBP2_ATP-Prtase_HisG', NULL, NULL, 'PBP2_ATP-Prtase_HisG', 14428),
(14429, 'cd07523', NULL, 'HAD_YsbA-like', NULL, NULL, 'HAD_YsbA-like', 14429),
(14430, 'cd14570', NULL, 'DSP_slingshot_1', NULL, NULL, 'DSP_slingshot_1', 14430),
(14431, 'cd09938', NULL, 'SH2_N-SH2_Zap70_Syk_like', NULL, NULL, 'SH2_N-SH2_Zap70_Syk_like', 14431),
(14432, 'cd17333', NULL, 'MFS_FucP_MFSD4_like', NULL, NULL, 'MFS_FucP_MFSD4_like', 14432),
(14433, 'cd19795', NULL, 'Bbox2_TRIM68_C-IV', NULL, NULL, 'Bbox2_TRIM68_C-IV', 14433),
(14434, 'cd07072', NULL, 'NR_LBD_DHR38_like', NULL, NULL, 'NR_LBD_DHR38_like', 14434),
(14435, 'cd13967', NULL, 'PT_UbiA_5', NULL, NULL, 'PT_UbiA_5', 14435),
(14436, 'cd19427', NULL, 'lipocalin_OBP-like', NULL, NULL, 'lipocalin_OBP-like', 14436),
(14437, 'cd09843', NULL, 'PLDc_vPLD2_1', NULL, NULL, 'PLDc_vPLD2_1', 14437),
(14438, 'cd10425', NULL, 'Ephrin-A_Ectodomain', NULL, NULL, 'Ephrin-A_Ectodomain', 14438),
(14439, 'cd14778', NULL, 'VtHb-like_SDgb', NULL, NULL, 'VtHb-like_SDgb', 14439),
(14440, 'cd18454', NULL, 'BACK_KLHL15', NULL, NULL, 'BACK_KLHL15', 14440),
(14441, 'cd00008', NULL, 'PIN_53EXO-like', NULL, NULL, 'PIN_53EXO-like', 14441),
(14442, 'cd08409', NULL, 'C2B_Synaptotagmin-15', NULL, NULL, 'C2B_Synaptotagmin-15', 14442),
(14443, 'cd01681', NULL, 'aeEF2_snRNP_like_IV', NULL, NULL, 'aeEF2_snRNP_like_IV', 14443),
(14444, 'cd12767', NULL, 'RRM2_SRSF1', NULL, NULL, 'RRM2_SRSF1', 14444),
(14445, 'cd04265', NULL, 'DUF619-NAGS-U', NULL, NULL, 'DUF619-NAGS-U', 14445),
(14446, 'cd10557', NULL, 'NarH_beta-like', NULL, NULL, 'NarH_beta-like', 14446),
(14447, 'cd04278', NULL, 'ZnMc_MMP', NULL, NULL, 'ZnMc_MMP', 14447),
(14448, 'cd21643', NULL, 'ORF8-Ig_bat_SARS-CoV_HKU3-1_type-III-like', NULL, NULL, 'ORF8-Ig_bat_SARS-CoV_HKU3-1_type-III-like', 14448),
(14449, 'cd04478', NULL, 'RPA2_DBD_D', NULL, NULL, 'RPA2_DBD_D', 14449),
(14450, 'cd03700', NULL, 'EF2_snRNP_like_II', NULL, NULL, 'EF2_snRNP_like_II', 14450),
(14451, 'cd03541', NULL, 'Rieske_RO_Alpha_CMO', NULL, NULL, 'Rieske_RO_Alpha_CMO', 14451),
(14452, 'cd12449', NULL, 'RRM_CIRBP_RBM3', NULL, NULL, 'RRM_CIRBP_RBM3', 14452),
(14453, 'cd04201', NULL, 'CuRO_1_CuNIR_like', NULL, NULL, 'CuRO_1_CuNIR_like', 14453),
(14454, 'cd12054', NULL, 'SH3_CD2AP_2', NULL, NULL, 'SH3_CD2AP_2', 14454),
(14455, 'cd14438', NULL, 'Hip_N', NULL, NULL, 'Hip_N', 14455),
(14456, 'cd12040', NULL, 'SH3_CACNB2', NULL, NULL, 'SH3_CACNB2', 14456);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(14457, 'cd03482', NULL, 'MutL_Trans_MutL', NULL, NULL, 'MutL_Trans_MutL', 14457),
(14458, 'cd01196', NULL, 'INT_C_like_6', NULL, NULL, 'INT_C_like_6', 14458),
(14459, 'cd06253', NULL, 'M14_ASTE_ASPA-like', NULL, NULL, 'M14_ASTE_ASPA-like', 14459),
(14460, 'cd12034', NULL, 'SH3_MPP4', NULL, NULL, 'SH3_MPP4', 14460),
(14461, 'cd06607', NULL, 'STKc_TAO', NULL, NULL, 'STKc_TAO', 14461),
(14462, 'cd07623', NULL, 'BAR_SNX1_2', NULL, NULL, 'BAR_SNX1_2', 14462),
(14463, 'cd17520', NULL, 'RMtype1_S_HmoORF3075P-TRD1-CR1_like', NULL, NULL, 'RMtype1_S_HmoORF3075P-TRD1-CR1_like', 14463),
(14464, 'cd09149', NULL, 'PLDc_vPLD5_2', NULL, NULL, 'PLDc_vPLD5_2', 14464),
(14465, 'cd00832', NULL, 'CLF', NULL, NULL, 'CLF', 14465),
(14466, 'cd17244', NULL, 'RMtype1_S_Apa101655I-TRD2-CR2_like', NULL, NULL, 'RMtype1_S_Apa101655I-TRD2-CR2_like', 14466),
(14467, 'cd19779', NULL, 'Bbox2_TRIM37_C-VIII', NULL, NULL, 'Bbox2_TRIM37_C-VIII', 14467),
(14468, 'cd13285', NULL, 'PH_ORP1', NULL, NULL, 'PH_ORP1', 14468),
(14469, 'cd11527', NULL, 'NTP-PPase_dUTPase', NULL, NULL, 'NTP-PPase_dUTPase', 14469),
(14470, 'cd12433', NULL, 'RRM_Yme2p_like', NULL, NULL, 'RRM_Yme2p_like', 14470),
(14471, 'cd05248', NULL, 'ADP_GME_SDR_e', NULL, NULL, 'ADP_GME_SDR_e', 14471),
(14472, 'cd09147', NULL, 'PLDc_vPLD3_2', NULL, NULL, 'PLDc_vPLD3_2', 14472),
(14473, 'cd14149', NULL, 'STKc_C-Raf', NULL, NULL, 'STKc_C-Raf', 14473),
(14474, 'cd03365', NULL, 'TOPRIM_TopoIIA', NULL, NULL, 'TOPRIM_TopoIIA', 14474),
(14475, 'cd15901', NULL, 'EFh_DMD_DYTN_DTN', NULL, NULL, 'EFh_DMD_DYTN_DTN', 14475),
(14476, 'cd05468', NULL, 'pVHL', NULL, NULL, 'pVHL', 14476),
(14477, 'cd15830', NULL, 'BamD', NULL, NULL, 'BamD', 14477),
(14478, 'cd17497', NULL, 'RMtype1_S_TteMORF1547P-TRD2-CR2_like', NULL, NULL, 'RMtype1_S_TteMORF1547P-TRD2-CR2_like', 14478),
(14479, 'cd03529', NULL, 'Rieske_NirD', NULL, NULL, 'Rieske_NirD', 14479),
(14480, 'cd01184', NULL, 'INT_C_like_1', NULL, NULL, 'INT_C_like_1', 14480),
(14481, 'cd11241', NULL, 'Sema_5', NULL, NULL, 'Sema_5', 14481),
(14482, 'cd21478', NULL, 'HKU1-like_CoV_Spike_S1_RBD', NULL, NULL, 'HKU1-like_CoV_Spike_S1_RBD', 14482),
(14483, 'cd17022', NULL, 'T3SC_IA_SigE-like', NULL, NULL, 'T3SC_IA_SigE-like', 14483),
(14484, 'cd10524', NULL, 'SET_Suv4-20-like', NULL, NULL, 'SET_Suv4-20-like', 14484),
(14485, 'cd07382', NULL, 'MPP_DR1281', NULL, NULL, 'MPP_DR1281', 14485),
(14486, 'cd19426', NULL, 'lipocalin_6', NULL, NULL, 'lipocalin_6', 14486),
(14487, 'cd07013', NULL, 'S14_ClpP', NULL, NULL, 'S14_ClpP', 14487),
(14488, 'cd14499', NULL, 'CDC14_C', NULL, NULL, 'CDC14_C', 14488),
(14489, 'cd09148', NULL, 'PLDc_vPLD4_2', NULL, NULL, 'PLDc_vPLD4_2', 14489),
(14490, 'cd18272', NULL, 'BTB_POZ_KBTBD4', NULL, NULL, 'BTB_POZ_KBTBD4', 14490),
(14491, 'cd08776', NULL, 'DED_Caspase-like_r1', NULL, NULL, 'DED_Caspase-like_r1', 14491),
(14492, 'cd04914', NULL, 'ACT_AKi-DapG-BS_1', NULL, NULL, 'ACT_AKi-DapG-BS_1', 14492),
(14493, 'cd05773', NULL, 'Ig_hNephrin_like', NULL, NULL, 'Ig_hNephrin_like', 14493),
(14494, 'cd06364', NULL, 'PBP1_CaSR', NULL, NULL, 'PBP1_CaSR', 14494),
(14495, 'cd18349', NULL, 'BTB_POZ_BTBD6', NULL, NULL, 'BTB_POZ_BTBD6', 14495),
(14496, 'cd02665', NULL, 'Peptidase_C19I', NULL, NULL, 'Peptidase_C19I', 14496),
(14497, 'cd08816', NULL, 'CARD_RIG-I_r1', NULL, NULL, 'CARD_RIG-I_r1', 14497),
(14498, 'cd16208', NULL, 'EFh_PI-PLCbeta1', NULL, NULL, 'EFh_PI-PLCbeta1', 14498),
(14499, 'cd17767', NULL, 'UP_EcUdp-like', NULL, NULL, 'UP_EcUdp-like', 14499),
(14500, 'cd17911', NULL, 'CheC_ClassIII', NULL, NULL, 'CheC_ClassIII', 14500),
(14501, 'cd19687', NULL, 'bHLHzip_Mlx', NULL, NULL, 'bHLHzip_Mlx', 14501),
(14502, 'cd05566', NULL, 'PTS_IIB_galactitol', NULL, NULL, 'PTS_IIB_galactitol', 14502),
(14503, 'cd15328', NULL, '7tmA_5-HT5', NULL, NULL, '7tmA_5-HT5', 14503),
(14504, 'cd10352', NULL, 'SH2_a2chimerin_b2chimerin', NULL, NULL, 'SH2_a2chimerin_b2chimerin', 14504),
(14505, 'cd04739', NULL, 'DHOD_like', NULL, NULL, 'DHOD_like', 14505),
(14506, 'cd14538', NULL, 'PTPc-N20_13', NULL, NULL, 'PTPc-N20_13', 14506),
(14507, 'cd19718', NULL, 'bHLH_TS_NGN3_ATOH5', NULL, NULL, 'bHLH_TS_NGN3_ATOH5', 14507);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(14508, 'cd16021', NULL, 'ALP_like', NULL, NULL, 'ALP_like', 14508),
(14509, 'cd09393', NULL, 'LIM3_Lrg1p_like', NULL, NULL, 'LIM3_Lrg1p_like', 14509),
(14510, 'cd14166', NULL, 'STKc_CaMKI_gamma', NULL, NULL, 'STKc_CaMKI_gamma', 14510),
(14511, 'cd14791', NULL, 'GH36', NULL, NULL, 'GH36', 14511),
(14512, 'cd11288', NULL, 'gelsolin_S5_like', NULL, NULL, 'gelsolin_S5_like', 14512),
(14513, 'cd06317', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, 'PBP1_ABC_sugar_binding-like', 14513),
(14514, 'cd09456', NULL, 'LIM2_Enigma', NULL, NULL, 'LIM2_Enigma', 14514),
(14515, 'cd05538', NULL, 'POLBc_Pol_II_B', NULL, NULL, 'POLBc_Pol_II_B', 14515),
(14516, 'cd00483', NULL, 'HPPK', NULL, NULL, 'HPPK', 14516),
(14517, 'cd19062', NULL, 'LGIC_TM_GluCl', NULL, NULL, 'LGIC_TM_GluCl', 14517),
(14518, 'cd08024', NULL, 'GH16_CCF', NULL, NULL, 'GH16_CCF', 14518),
(14519, 'cd10843', NULL, 'DSRM_DICER', NULL, NULL, 'DSRM_DICER', 14519),
(14520, 'cd17041', NULL, 'Ubl_WDR48', NULL, NULL, 'Ubl_WDR48', 14520),
(14521, 'cd01407', NULL, 'SIR2-fam', NULL, NULL, 'SIR2-fam', 14521),
(14522, 'cd12076', NULL, 'SH3_Tks4_2', NULL, NULL, 'SH3_Tks4_2', 14522),
(14523, 'cd13356', NULL, 'PH-GRAM_MTMR2_mammal-like', NULL, NULL, 'PH-GRAM_MTMR2_mammal-like', 14523),
(14524, 'cd13209', NULL, 'PH-GRAM_MTMR3_MTMR4', NULL, NULL, 'PH-GRAM_MTMR3_MTMR4', 14524),
(14525, 'cd16859', NULL, 'ING_ING4_5', NULL, NULL, 'ING_ING4_5', 14525),
(14526, 'cd16375', NULL, 'Avd_IVP_like', NULL, NULL, 'Avd_IVP_like', 14526),
(14527, 'cd11701', NULL, 'DHR2_DOCK8', NULL, NULL, 'DHR2_DOCK8', 14527),
(14528, 'cd06962', NULL, 'NR_DBD_FXR', NULL, NULL, 'NR_DBD_FXR', 14528),
(14529, 'cd03592', NULL, 'CLECT_selectins_like', NULL, NULL, 'CLECT_selectins_like', 14529),
(14530, 'cd16316', NULL, 'BlaB-like_MBL-B1', NULL, NULL, 'BlaB-like_MBL-B1', 14530),
(14531, 'cd13277', NULL, 'PH_Bem3', NULL, NULL, 'PH_Bem3', 14531),
(14532, 'cd08644', NULL, 'FMT_core_ArnA_N', NULL, NULL, 'FMT_core_ArnA_N', 14532),
(14533, 'cd01648', NULL, 'TERT', NULL, NULL, 'TERT', 14533),
(14534, 'cd00868', NULL, 'Terpene_cyclase_C1', NULL, NULL, 'Terpene_cyclase_C1', 14534),
(14535, 'cd12840', NULL, 'CarS', NULL, NULL, 'CarS', 14535),
(14536, 'cd14279', NULL, 'CUE', NULL, NULL, 'CUE', 14536),
(14537, 'cd14249', NULL, 'ESP1_like', NULL, NULL, 'ESP1_like', 14537),
(14538, 'cd10915', NULL, 'Peptidase_C25_N_2', NULL, NULL, 'Peptidase_C25_N_2', 14538),
(14539, 'cd17247', NULL, 'RMtype1_S_Eco2747I-TRD2-CR2_like', NULL, NULL, 'RMtype1_S_Eco2747I-TRD2-CR2_like', 14539),
(14540, 'cd02156', NULL, 'nt_trans', NULL, NULL, 'nt_trans', 14540),
(14541, 'cd18410', NULL, 'BTB_POZ_Shaker-like', NULL, NULL, 'BTB_POZ_Shaker-like', 14541),
(14542, 'cd04135', NULL, 'Tc10', NULL, NULL, 'Tc10', 14542),
(14543, 'cd06309', NULL, 'PBP1_galactofuranose_YtfQ-like', NULL, NULL, 'PBP1_galactofuranose_YtfQ-like', 14543),
(14544, 'cd19598', NULL, 'serpin77Ba-like_insects', NULL, NULL, 'serpin77Ba-like_insects', 14544),
(14545, 'cd07500', NULL, 'HAD_PSP', NULL, NULL, 'HAD_PSP', 14545),
(14546, 'cd13542', NULL, 'PBP2_FutA1_ilke', NULL, NULL, 'PBP2_FutA1_ilke', 14546),
(14547, 'cd09214', NULL, 'GH64-like', NULL, NULL, 'GH64-like', 14547),
(14548, 'cd19601', NULL, 'serpin42Da-like', NULL, NULL, 'serpin42Da-like', 14548),
(14549, 'cd07989', NULL, 'LPLAT_AGPAT-like', NULL, NULL, 'LPLAT_AGPAT-like', 14549),
(14550, 'cd00897', NULL, 'UGPase_euk', NULL, NULL, 'UGPase_euk', 14550),
(14551, 'cd05578', NULL, 'STKc_Yank1', NULL, NULL, 'STKc_Yank1', 14551),
(14552, 'cd17504', NULL, 'MFS_MMR_MDR_like', NULL, NULL, 'MFS_MMR_MDR_like', 14552),
(14553, 'cd11502', NULL, 'SLC6sbd_NTT5', NULL, NULL, 'SLC6sbd_NTT5', 14553),
(14554, 'cd07963', NULL, 'Anticodon_Ia_Cys', NULL, NULL, 'Anticodon_Ia_Cys', 14554),
(14555, 'cd07930', NULL, 'bacterial_phosphagen_kinase', NULL, NULL, 'bacterial_phosphagen_kinase', 14555),
(14556, 'cd09864', NULL, 'PIN_Fcf1-like', NULL, NULL, 'PIN_Fcf1-like', 14556),
(14557, 'cd08217', NULL, 'STKc_Nek2', NULL, NULL, 'STKc_Nek2', 14557),
(14558, 'cd01042', NULL, 'DMQH', NULL, NULL, 'DMQH', 14558),
(14559, 'cd11684', NULL, 'DHR2_DOCK', NULL, NULL, 'DHR2_DOCK', 14559);
INSERT INTO "PUBLIC"."MODEL" VALUES
(14560, 'cd13289', NULL, 'PH_Osh3p_yeast', NULL, NULL, 'PH_Osh3p_yeast', 14560),
(14561, 'cd18038', NULL, 'DEXXQc_Helz-like', NULL, NULL, 'DEXXQc_Helz-like', 14561),
(14562, 'cd13153', NULL, 'KOW_GPKOW_B', NULL, NULL, 'KOW_GPKOW_B', 14562),
(14563, 'cd03021', NULL, 'DsbA_GSTK', NULL, NULL, 'DsbA_GSTK', 14563),
(14564, 'cd08324', NULL, 'CARD_NOD1_CARD4', NULL, NULL, 'CARD_NOD1_CARD4', 14564),
(14565, 'cd10581', NULL, 'TNFRSF11B', NULL, NULL, 'TNFRSF11B', 14565),
(14566, 'cd11512', NULL, 'SLC6sbd_NET', NULL, NULL, 'SLC6sbd_NET', 14566),
(14567, 'cd07693', NULL, 'Ig1_Robo', NULL, NULL, 'Ig1_Robo', 14567),
(14568, 'cd18434', NULL, 'BRCT_TopBP1_rpt5', NULL, NULL, 'BRCT_TopBP1_rpt5', 14568),
(14569, 'cd08446', NULL, 'PBP2_Chlorocatechol', NULL, NULL, 'PBP2_Chlorocatechol', 14569),
(14570, 'cd02343', NULL, 'ZZ_EF', NULL, NULL, 'ZZ_EF', 14570),
(14571, 'cd00130', NULL, 'PAS', NULL, NULL, 'PAS', 14571),
(14572, 'cd01398', NULL, 'RPI_A', NULL, NULL, 'RPI_A', 14572),
(14573, 'cd04711', NULL, 'BAH_Dnmt1_II', NULL, NULL, 'BAH_Dnmt1_II', 14573),
(14574, 'cd06817', NULL, 'PLPDE_III_DSD', NULL, NULL, 'PLPDE_III_DSD', 14574),
(14575, 'cd16608', NULL, 'RING-HC_TRIM62_C-IV', NULL, NULL, 'RING-HC_TRIM62_C-IV', 14575),
(14576, 'cd10001', NULL, 'HDAC_classII_APAH', NULL, NULL, 'HDAC_classII_APAH', 14576),
(14577, 'cd13884', NULL, 'CuRO_2_tcLCC_insect_like', NULL, NULL, 'CuRO_2_tcLCC_insect_like', 14577),
(14578, 'cd14812', NULL, 'bZIP_u3', NULL, NULL, 'bZIP_u3', 14578),
(14579, 'cd17301', NULL, 'PIPKc_PIP5KI', NULL, NULL, 'PIPKc_PIP5KI', 14579),
(14580, 'cd18621', NULL, 'GH32_XdINV-like', NULL, NULL, 'GH32_XdINV-like', 14580),
(14581, 'cd18218', NULL, 'BTB_POZ_ZBTB32_FAZF_TZFP', NULL, NULL, 'BTB_POZ_ZBTB32_FAZF_TZFP', 14581),
(14582, 'cd04239', NULL, 'AAK_UMPK-like', NULL, NULL, 'AAK_UMPK-like', 14582),
(14583, 'cd06993', NULL, 'cupin_CENP-C_C', NULL, NULL, 'cupin_CENP-C_C', 14583),
(14584, 'cd11558', NULL, 'W2_eIF2B_epsilon', NULL, NULL, 'W2_eIF2B_epsilon', 14584),
(14585, 'cd08803', NULL, 'Death_ank3', NULL, NULL, 'Death_ank3', 14585),
(14586, 'cd06408', NULL, 'PB1_NoxR', NULL, NULL, 'PB1_NoxR', 14586),
(14587, 'cd19015', NULL, 'LGIC_ECD_nAChR_A2', NULL, NULL, 'LGIC_ECD_nAChR_A2', 14587),
(14588, 'cd18264', NULL, 'BTB_POZ_KLHL34', NULL, NULL, 'BTB_POZ_KLHL34', 14588),
(14589, 'cd16587', NULL, 'RING-HC_TRIM32_C-VII', NULL, NULL, 'RING-HC_TRIM32_C-VII', 14589),
(14590, 'cd01938', NULL, 'ADPGK_ADPPFK', NULL, NULL, 'ADPGK_ADPPFK', 14590),
(14591, 'cd13740', NULL, 'SPRY_PRY_TRIM7', NULL, NULL, 'SPRY_PRY_TRIM7', 14591),
(14592, 'cd12683', NULL, 'RRM_RBPMS2', NULL, NULL, 'RRM_RBPMS2', 14592),
(14593, 'cd06115', NULL, 'AthCS_per_like', NULL, NULL, 'AthCS_per_like', 14593),
(14594, 'cd12236', NULL, 'RRM_snRNP70', NULL, NULL, 'RRM_snRNP70', 14594),
(14595, 'cd04153', NULL, 'Arl5_Arl8', NULL, NULL, 'Arl5_Arl8', 14595),
(14596, 'cd11283', NULL, 'ADF_GMF-beta_like', NULL, NULL, 'ADF_GMF-beta_like', 14596),
(14597, 'cd07284', NULL, 'PX_SNX7', NULL, NULL, 'PX_SNX7', 14597),
(14598, 'cd08976', NULL, 'BaFpgNei_N_4', NULL, NULL, 'BaFpgNei_N_4', 14598),
(14599, 'cd08233', NULL, 'butanediol_DH_like', NULL, NULL, 'butanediol_DH_like', 14599),
(14600, 'cd12590', NULL, 'RRM2_PSF', NULL, NULL, 'RRM2_PSF', 14600),
(14601, 'cd03754', NULL, 'proteasome_alpha_type_6', NULL, NULL, 'proteasome_alpha_type_6', 14601),
(14602, 'cd12458', NULL, 'RRM_AtC3H46_like', NULL, NULL, 'RRM_AtC3H46_like', 14602),
(14603, 'cd15416', NULL, '7tmA_OR5P-like', NULL, NULL, '7tmA_OR5P-like', 14603),
(14604, 'cd16033', NULL, 'sulfatase_like', NULL, NULL, 'sulfatase_like', 14604),
(14605, 'cd01825', NULL, 'SGNH_hydrolase_peri1', NULL, NULL, 'SGNH_hydrolase_peri1', 14605),
(14606, 'cd04461', NULL, 'S1_Rrp5_repeat_hs8_sc7', NULL, NULL, 'S1_Rrp5_repeat_hs8_sc7', 14606),
(14607, 'cd06559', NULL, 'Endonuclease_V', NULL, NULL, 'Endonuclease_V', 14607),
(14608, 'cd09648', NULL, 'Cas2_I-E', NULL, NULL, 'Cas2_I-E', 14608),
(14609, 'cd06633', NULL, 'STKc_TAO3', NULL, NULL, 'STKc_TAO3', 14609),
(14610, 'cd07026', NULL, 'Ribosomal_L20', NULL, NULL, 'Ribosomal_L20', 14610);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(14611, 'cd21587', NULL, 'gammaCoV_RdRp', NULL, NULL, 'gammaCoV_RdRp', 14611),
(14612, 'cd08507', NULL, 'PBP2_SgrR_like', NULL, NULL, 'PBP2_SgrR_like', 14612),
(14613, 'cd07657', NULL, 'F-BAR_Fes_Fer', NULL, NULL, 'F-BAR_Fes_Fer', 14613),
(14614, 'cd15330', NULL, '7tmA_5-HT1A_vertebrates', NULL, NULL, '7tmA_5-HT1A_vertebrates', 14614),
(14615, 'cd11863', NULL, 'SH3_CACNB', NULL, NULL, 'SH3_CACNB', 14615),
(14616, 'cd04080', NULL, 'CBM6_cellulase-like', NULL, NULL, 'CBM6_cellulase-like', 14616),
(14617, 'cd16444', NULL, 'LipB', NULL, NULL, 'LipB', 14617),
(14618, 'cd11600', NULL, 'HDAC_Clr3', NULL, NULL, 'HDAC_Clr3', 14618),
(14619, 'cd14377', NULL, 'UBA1_Rad23', NULL, NULL, 'UBA1_Rad23', 14619),
(14620, 'cd00178', NULL, 'STI', NULL, NULL, 'STI', 14620),
(14621, 'cd04402', NULL, 'RhoGAP_ARHGAP20', NULL, NULL, 'RhoGAP_ARHGAP20', 14621),
(14622, 'cd12629', NULL, 'RRM2_IGF2BP2', NULL, NULL, 'RRM2_IGF2BP2', 14622),
(14623, 'cd18625', NULL, 'GH32_BfrA-like', NULL, NULL, 'GH32_BfrA-like', 14623),
(14624, 'cd12882', NULL, 'SPRY_RNF123', NULL, NULL, 'SPRY_RNF123', 14624),
(14625, 'cd04819', NULL, 'PA_2', NULL, NULL, 'PA_2', 14625),
(14626, 'cd07468', NULL, 'CRD_TK_ROR2', NULL, NULL, 'CRD_TK_ROR2', 14626),
(14627, 'cd13271', NULL, 'PH2_TAPP1_2', NULL, NULL, 'PH2_TAPP1_2', 14627),
(14628, 'cd02788', NULL, 'MopB_CT_NDH-1_NuoG2-N7', NULL, NULL, 'MopB_CT_NDH-1_NuoG2-N7', 14628),
(14629, 'cd02858', NULL, 'E_set_Esterase_N', NULL, NULL, 'E_set_Esterase_N', 14629),
(14630, 'cd15371', NULL, '7tmA_PAR3', NULL, NULL, '7tmA_PAR3', 14630),
(14631, 'cd14726', NULL, 'TraB_PrgY-like', NULL, NULL, 'TraB_PrgY-like', 14631),
(14632, 'cd13711', NULL, 'PBP2_Ngo0372_TcyA', NULL, NULL, 'PBP2_Ngo0372_TcyA', 14632),
(14633, 'cd05642', NULL, 'M28_like', NULL, NULL, 'M28_like', 14633),
(14634, 'cd14890', NULL, 'MYSc_Myo29', NULL, NULL, 'MYSc_Myo29', 14634),
(14635, 'cd12159', NULL, '2-Hacid_dh_2', NULL, NULL, '2-Hacid_dh_2', 14635),
(14636, 'cd12077', NULL, 'SH3_Tks5_2', NULL, NULL, 'SH3_Tks5_2', 14636),
(14637, 'cd13143', NULL, 'MATE_MepA_like', NULL, NULL, 'MATE_MepA_like', 14637),
(14638, 'cd04220', NULL, 'Halocyanin', NULL, NULL, 'Halocyanin', 14638),
(14639, 'cd15623', NULL, 'PHD_TIF1beta', NULL, NULL, 'PHD_TIF1beta', 14639),
(14640, 'cd08011', NULL, 'M20_ArgE_DapE-like', NULL, NULL, 'M20_ArgE_DapE-like', 14640),
(14641, 'cd19712', NULL, 'bHLH_TS_dimmed_like', NULL, NULL, 'bHLH_TS_dimmed_like', 14641),
(14642, 'cd00164', NULL, 'S1_like', NULL, NULL, 'S1_like', 14642),
(14643, 'cd15167', NULL, '7tmA_GPR171', NULL, NULL, '7tmA_GPR171', 14643),
(14644, 'cd11587', NULL, 'Arginase-like', NULL, NULL, 'Arginase-like', 14644),
(14645, 'cd11497', NULL, 'SLC6sbd_SERT-like', NULL, NULL, 'SLC6sbd_SERT-like', 14645),
(14646, 'cd14985', NULL, '7tmA_Angiotensin_R-like', NULL, NULL, '7tmA_Angiotensin_R-like', 14646),
(14647, 'cd07603', NULL, 'BAR_ACAPs', NULL, NULL, 'BAR_ACAPs', 14647),
(14648, 'cd19341', NULL, 'Wnt_Wnt9', NULL, NULL, 'Wnt_Wnt9', 14648),
(14649, 'cd01993', NULL, 'Alpha_ANH_like_II', NULL, NULL, 'Alpha_ANH_like_II', 14649),
(14650, 'cd18359', NULL, 'BTB2_POZ_RHOBTB2', NULL, NULL, 'BTB2_POZ_RHOBTB2', 14650),
(14651, 'cd18710', NULL, 'PIN_VapC-like', NULL, NULL, 'PIN_VapC-like', 14651),
(14652, 'cd04618', NULL, 'CBS_euAMPK_gamma-like_repeat1', NULL, NULL, 'CBS_euAMPK_gamma-like_repeat1', 14652),
(14653, 'cd15807', NULL, 'MDA5_C', NULL, NULL, 'MDA5_C', 14653),
(14654, 'cd16999', NULL, 'VHS_STAM2', NULL, NULL, 'VHS_STAM2', 14654),
(14655, 'cd01723', NULL, 'LSm4', NULL, NULL, 'LSm4', 14655),
(14656, 'cd05122', NULL, 'PKc_STE', NULL, NULL, 'PKc_STE', 14656),
(14657, 'cd01561', NULL, 'CBS_like', NULL, NULL, 'CBS_like', 14657),
(14658, 'cd14191', NULL, 'STKc_MLCK1', NULL, NULL, 'STKc_MLCK1', 14658),
(14659, 'cd12947', NULL, 'NOPS_p54nrb', NULL, NULL, 'NOPS_p54nrb', 14659),
(14660, 'cd09110', NULL, 'PLDc_CLS_1', NULL, NULL, 'PLDc_CLS_1', 14660),
(14661, 'cd05636', NULL, 'LbH_G1P_TT_C_like', NULL, NULL, 'LbH_G1P_TT_C_like', 14661),
(14662, 'cd09378', NULL, 'LIM2_Lmx1a_Lmx1b', NULL, NULL, 'LIM2_Lmx1a_Lmx1b', 14662),
(14663, 'cd08940', NULL, 'HBDH_SDR_c', NULL, NULL, 'HBDH_SDR_c', 14663); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(14664, 'cd09862', NULL, 'PIN_Rrp44-like', NULL, NULL, 'PIN_Rrp44-like', 14664),
(14665, 'cd10041', NULL, 'Reelin_repeat_5_subrepeat_1', NULL, NULL, 'Reelin_repeat_5_subrepeat_1', 14665),
(14666, 'cd13196', NULL, 'FERM_C_JAK', NULL, NULL, 'FERM_C_JAK', 14666),
(14667, 'cd18646', NULL, 'CD_Cbx7', NULL, NULL, 'CD_Cbx7', 14667),
(14668, 'cd05927', NULL, 'LC-FACS_euk', NULL, NULL, 'LC-FACS_euk', 14668),
(14669, 'cd07085', NULL, 'ALDH_F6_MMSDH', NULL, NULL, 'ALDH_F6_MMSDH', 14669),
(14670, 'cd08488', NULL, 'PBP2_AmpR', NULL, NULL, 'PBP2_AmpR', 14670),
(14671, 'cd00727', NULL, 'malate_synt_A', NULL, NULL, 'malate_synt_A', 14671),
(14672, 'cd02249', NULL, 'ZZ', NULL, NULL, 'ZZ', 14672),
(14673, 'cd01735', NULL, 'LSm12_N', NULL, NULL, 'LSm12_N', 14673),
(14674, 'cd14479', NULL, 'SPX-MFS_plant', NULL, NULL, 'SPX-MFS_plant', 14674),
(14675, 'cd01630', NULL, 'HAD_KDO-like', NULL, NULL, 'HAD_KDO-like', 14675),
(14676, 'cd06388', NULL, 'PBP1_iGluR_AMPA_GluR4', NULL, NULL, 'PBP1_iGluR_AMPA_GluR4', 14676),
(14677, 'cd15243', NULL, '7tm_Halorhodopsin', NULL, NULL, '7tm_Halorhodopsin', 14677),
(14678, 'cd03454', NULL, 'YdeM', NULL, NULL, 'YdeM', 14678),
(14679, 'cd07091', NULL, 'ALDH_F1-2_Ald2-like', NULL, NULL, 'ALDH_F1-2_Ald2-like', 14679),
(14680, 'cd17962', NULL, 'DEADc_DDX59', NULL, NULL, 'DEADc_DDX59', 14680),
(14681, 'cd16575', NULL, 'RING-HC_MID_C-I', NULL, NULL, 'RING-HC_MID_C-I', 14681),
(14682, 'cd09808', NULL, 'DHRS-12_like_SDR_c-like', NULL, NULL, 'DHRS-12_like_SDR_c-like', 14682),
(14683, 'cd15023', NULL, '7tm_TAS2R7-like', NULL, NULL, '7tm_TAS2R7-like', 14683),
(14684, 'cd12652', NULL, 'RRM2_Hu', NULL, NULL, 'RRM2_Hu', 14684),
(14685, 'cd13866', NULL, 'CuRO_2_BOD', NULL, NULL, 'CuRO_2_BOD', 14685),
(14686, 'cd01174', NULL, 'ribokinase', NULL, NULL, 'ribokinase', 14686),
(14687, 'cd04913', NULL, 'ACT_AKii-LysC-BS-like_1', NULL, NULL, 'ACT_AKii-LysC-BS-like_1', 14687),
(14688, 'cd18930', NULL, 'bHLHzip_MXI1', NULL, NULL, 'bHLHzip_MXI1', 14688),
(14689, 'cd04389', NULL, 'RhoGAP_KIAA1688', NULL, NULL, 'RhoGAP_KIAA1688', 14689),
(14690, 'cd15172', NULL, '7tmA_CCR6', NULL, NULL, '7tmA_CCR6', 14690),
(14691, 'cd00547', NULL, 'QFR_TypeD_subunitD', NULL, NULL, 'QFR_TypeD_subunitD', 14691),
(14692, 'cd06232', NULL, 'M14-like', NULL, NULL, 'M14-like', 14692),
(14693, 'cd15213', NULL, '7tmA_PSP24-like', NULL, NULL, '7tmA_PSP24-like', 14693),
(14694, 'cd18634', NULL, 'CD_CDY', NULL, NULL, 'CD_CDY', 14694),
(14695, 'cd14451', NULL, 'CuRO_5_FV_like', NULL, NULL, 'CuRO_5_FV_like', 14695),
(14696, 'cd00011', NULL, 'BAR_Arfaptin_like', NULL, NULL, 'BAR_Arfaptin_like', 14696),
(14697, 'cd03165', NULL, 'NET-5_like_LEL', NULL, NULL, 'NET-5_like_LEL', 14697),
(14698, 'cd08979', NULL, 'GH_J', NULL, NULL, 'GH_J', 14698),
(14699, 'sd00008', NULL, 'TPR_YbbN', NULL, NULL, 'TPR_YbbN', 14699),
(14700, 'cd14667', NULL, '3D_containing_proteins', NULL, NULL, '3D_containing_proteins', 14700),
(14701, 'cd03490', NULL, 'Topoisomer_IB_N_1', NULL, NULL, 'Topoisomer_IB_N_1', 14701),
(14702, 'cd11014', NULL, 'Mavicyanin', NULL, NULL, 'Mavicyanin', 14702),
(14703, 'cd17057', NULL, 'Ubl_TMUB1_like', NULL, NULL, 'Ubl_TMUB1_like', 14703),
(14704, 'cd07815', NULL, 'SRPBCC_PITP', NULL, NULL, 'SRPBCC_PITP', 14704),
(14705, 'cd04864', NULL, 'LigD_Pol_like_1', NULL, NULL, 'LigD_Pol_like_1', 14705),
(14706, 'cd03108', NULL, 'AdSS', NULL, NULL, 'AdSS', 14706),
(14707, 'cd13536', NULL, 'PBP2_EcModA', NULL, NULL, 'PBP2_EcModA', 14707),
(14708, 'cd01147', NULL, 'HemV-2', NULL, NULL, 'HemV-2', 14708),
(14709, 'cd07565', NULL, 'aliphatic_amidase', NULL, NULL, 'aliphatic_amidase', 14709),
(14710, 'cd06477', NULL, 'ACD_HspB3_Like', NULL, NULL, 'ACD_HspB3_Like', 14710),
(14711, 'cd06611', NULL, 'STKc_SLK_like', NULL, NULL, 'STKc_SLK_like', 14711),
(14712, 'cd17026', NULL, 'T3SC_IA_SpcU-like', NULL, NULL, 'T3SC_IA_SpcU-like', 14712),
(14713, 'cd14020', NULL, 'STKc_KIS', NULL, NULL, 'STKc_KIS', 14713),
(14714, 'cd19569', NULL, 'serpinB10_bomapin', NULL, NULL, 'serpinB10_bomapin', 14714),
(14715, 'cd03468', NULL, 'PolY_like', NULL, NULL, 'PolY_like', 14715);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(14716, 'cd12571', NULL, 'RRM6_RBM19', NULL, NULL, 'RRM6_RBM19', 14716),
(14717, 'cd14375', NULL, 'CUE2_Cue2p_like', NULL, NULL, 'CUE2_Cue2p_like', 14717),
(14718, 'cd18914', NULL, 'bHLH_AtORG2_like', NULL, NULL, 'bHLH_AtORG2_like', 14718),
(14719, 'cd10436', NULL, 'GIY-YIG_EndoII_Hpy188I_like', NULL, NULL, 'GIY-YIG_EndoII_Hpy188I_like', 14719),
(14720, 'cd19831', NULL, 'Bbox2_MuRF1_C-II', NULL, NULL, 'Bbox2_MuRF1_C-II', 14720),
(14721, 'cd14116', NULL, 'STKc_Aurora-A', NULL, NULL, 'STKc_Aurora-A', 14721),
(14722, 'cd09869', NULL, 'PIN_GEN1', NULL, NULL, 'PIN_GEN1', 14722),
(14723, 'cd11964', NULL, 'SH3_STAM1', NULL, NULL, 'SH3_STAM1', 14723),
(14724, 'cd09813', NULL, '3b-HSD-NSDHL-like_SDR_e', NULL, NULL, '3b-HSD-NSDHL-like_SDR_e', 14724),
(14725, 'cd07452', NULL, 'CRD_sizzled', NULL, NULL, 'CRD_sizzled', 14725),
(14726, 'cd12360', NULL, 'RRM_cwf2', NULL, NULL, 'RRM_cwf2', 14726),
(14727, 'cd12679', NULL, 'RRM_SAFB1_SAFB2', NULL, NULL, 'RRM_SAFB1_SAFB2', 14727),
(14728, 'cd01090', NULL, 'Creatinase', NULL, NULL, 'Creatinase', 14728),
(14729, 'cd06335', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, 'PBP1_ABC_ligand_binding-like', 14729),
(14730, 'cd02654', NULL, 'nuc_hydro_CjNH', NULL, NULL, 'nuc_hydro_CjNH', 14730),
(14731, 'cd09457', NULL, 'LIM2_ENH', NULL, NULL, 'LIM2_ENH', 14731),
(14732, 'cd12167', NULL, '2-Hacid_dh_8', NULL, NULL, '2-Hacid_dh_8', 14732),
(14733, 'cd03280', NULL, 'ABC_MutS2', NULL, NULL, 'ABC_MutS2', 14733),
(14734, 'cd02003', NULL, 'TPP_IolD', NULL, NULL, 'TPP_IolD', 14734),
(14735, 'cd01059', NULL, 'CCC1_like', NULL, NULL, 'CCC1_like', 14735),
(14736, 'cd09556', NULL, 'SAM_VTS1_fungal', NULL, NULL, 'SAM_VTS1_fungal', 14736),
(14737, 'cd01443', NULL, 'Cdc25_Acr2p', NULL, NULL, 'Cdc25_Acr2p', 14737),
(14738, 'cd17724', NULL, 'BRCT_p53bp1_rpt2', NULL, NULL, 'BRCT_p53bp1_rpt2', 14738),
(14739, 'cd03324', NULL, 'rTSbeta_L-fuconate_dehydratase', NULL, NULL, 'rTSbeta_L-fuconate_dehydratase', 14739),
(14740, 'cd15199', NULL, '7tmA_GPR31', NULL, NULL, '7tmA_GPR31', 14740),
(14741, 'cd18057', NULL, 'DEXHc_CHD5', NULL, NULL, 'DEXHc_CHD5', 14741),
(14742, 'cd19164', NULL, 'AKR_ARA2', NULL, NULL, 'AKR_ARA2', 14742),
(14743, 'cd06429', NULL, 'GT8_like_1', NULL, NULL, 'GT8_like_1', 14743),
(14744, 'cd13754', NULL, 'TGF_beta_INHA', NULL, NULL, 'TGF_beta_INHA', 14744),
(14745, 'cd18570', NULL, 'ABC_6TM_PCAT1_LagD_like', NULL, NULL, 'ABC_6TM_PCAT1_LagD_like', 14745),
(14746, 'cd14673', NULL, 'PH_PHLDB1_2', NULL, NULL, 'PH_PHLDB1_2', 14746),
(14747, 'cd19568', NULL, 'serpinB9_CAP-3', NULL, NULL, 'serpinB9_CAP-3', 14747),
(14748, 'cd06980', NULL, 'cupin_bxe_c0505', NULL, NULL, 'cupin_bxe_c0505', 14748),
(14749, 'cd08904', NULL, 'START_STARD6-like', NULL, NULL, 'START_STARD6-like', 14749),
(14750, 'cd07962', NULL, 'Anticodon_Ia_Val', NULL, NULL, 'Anticodon_Ia_Val', 14750),
(14751, 'cd09374', NULL, 'LIM2_Isl', NULL, NULL, 'LIM2_Isl', 14751),
(14752, 'cd17289', NULL, 'RMtype1_S_BamJRS5ORF1993P-TRD1-CR1_like', NULL, NULL, 'RMtype1_S_BamJRS5ORF1993P-TRD1-CR1_like', 14752),
(14753, 'cd17536', NULL, 'REC_YesN-like', NULL, NULL, 'REC_YesN-like', 14753),
(14754, 'cd21162', NULL, 'NendoU_tv_PToV-like', NULL, NULL, 'NendoU_tv_PToV-like', 14754),
(14755, 'cd00061', NULL, 'FN1', NULL, NULL, 'FN1', 14755),
(14756, 'cd12196', NULL, 'MARK1-3_C', NULL, NULL, 'MARK1-3_C', 14756),
(14757, 'cd14281', NULL, 'UBA2_Rad23_like', NULL, NULL, 'UBA2_Rad23_like', 14757),
(14758, 'cd13284', NULL, 'PH_OSBP_ORP4', NULL, NULL, 'PH_OSBP_ORP4', 14758),
(14759, 'cd13130', NULL, 'MATE_rft1', NULL, NULL, 'MATE_rft1', 14759),
(14760, 'cd15947', NULL, '7tmA_OR2B-like', NULL, NULL, '7tmA_OR2B-like', 14760),
(14761, 'cd13842', NULL, 'CuRO_HCO_II_like', NULL, NULL, 'CuRO_HCO_II_like', 14761),
(14762, 'cd03180', NULL, 'GST_C_2', NULL, NULL, 'GST_C_2', 14762),
(14763, 'cd12169', NULL, 'PGDH_like_1', NULL, NULL, 'PGDH_like_1', 14763),
(14764, 'cd05226', NULL, 'SDR_e_a', NULL, NULL, 'SDR_e_a', 14764),
(14765, 'cd03391', NULL, 'PAP2_containing_2_like', NULL, NULL, 'PAP2_containing_2_like', 14765),
(14766, 'cd00620', NULL, 'Methyltransferase_Sun', NULL, NULL, 'Methyltransferase_Sun', 14766);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(14767, 'cd04906', NULL, 'ACT_ThrD-I_1', NULL, NULL, 'ACT_ThrD-I_1', 14767),
(14768, 'cd17075', NULL, 'UBX1_UBXN9', NULL, NULL, 'UBX1_UBXN9', 14768),
(14769, 'sd00037', NULL, 'PASTA', NULL, NULL, 'PASTA', 14769),
(14770, 'cd02078', NULL, 'P-type_ATPase_K', NULL, NULL, 'P-type_ATPase_K', 14770),
(14771, 'cd11377', NULL, 'Pro-peptidase_S53', NULL, NULL, 'Pro-peptidase_S53', 14771),
(14772, 'cd13650', NULL, 'PBP2_THI5', NULL, NULL, 'PBP2_THI5', 14772),
(14773, 'cd15520', NULL, 'PHD3_Lid2p_like', NULL, NULL, 'PHD3_Lid2p_like', 14773),
(14774, 'cd03349', NULL, 'LbH_XAT', NULL, NULL, 'LbH_XAT', 14774),
(14775, 'cd00265', NULL, 'MADS_MEF2_like', NULL, NULL, 'MADS_MEF2_like', 14775),
(14776, 'cd11455', NULL, 'bHLH_AtAIG1_like', NULL, NULL, 'bHLH_AtAIG1_like', 14776),
(14777, 'cd12426', NULL, 'RRM4_PTBPH3', NULL, NULL, 'RRM4_PTBPH3', 14777),
(14778, 'cd06551', NULL, 'LPLAT', NULL, NULL, 'LPLAT', 14778),
(14779, 'cd14142', NULL, 'STKc_ACVR1_ALK1', NULL, NULL, 'STKc_ACVR1_ALK1', 14779),
(14780, 'cd14481', NULL, 'SPX_AtSPX1_like', NULL, NULL, 'SPX_AtSPX1_like', 14780),
(14781, 'cd18248', NULL, 'BTB_POZ_KLHL19_KEAP1', NULL, NULL, 'BTB_POZ_KLHL19_KEAP1', 14781),
(14782, 'cd09482', NULL, 'LIM2_CRP3', NULL, NULL, 'LIM2_CRP3', 14782),
(14783, 'cd12338', NULL, 'RRM1_SRSF1_like', NULL, NULL, 'RRM1_SRSF1_like', 14783),
(14784, 'cd10458', NULL, 'GIY-YIG_NifU', NULL, NULL, 'GIY-YIG_NifU', 14784),
(14785, 'cd00593', NULL, 'RIBOc', NULL, NULL, 'RIBOc', 14785),
(14786, 'cd16892', NULL, 'LT_VirB1-like', NULL, NULL, 'LT_VirB1-like', 14786),
(14787, 'cd14593', NULL, 'PTP-MTMR10', NULL, NULL, 'PTP-MTMR10', 14787),
(14788, 'cd14862', NULL, 'Fe-ADH-like', NULL, NULL, 'Fe-ADH-like', 14788),
(14789, 'cd13986', NULL, 'STKc_16', NULL, NULL, 'STKc_16', 14789),
(14790, 'cd14889', NULL, 'MYSc_Myo28', NULL, NULL, 'MYSc_Myo28', 14790),
(14791, 'cd15259', NULL, '7tmB2_GPR124-like_Adhesion_III', NULL, NULL, '7tmB2_GPR124-like_Adhesion_III', 14791),
(14792, 'cd11343', NULL, 'AmyAc_Sucrose_phosphorylase-like', NULL, NULL, 'AmyAc_Sucrose_phosphorylase-like', 14792),
(14793, 'cd13594', NULL, 'PBP2_HisGL4', NULL, NULL, 'PBP2_HisGL4', 14793),
(14794, 'cd08752', NULL, 'RGS_GRK5', NULL, NULL, 'RGS_GRK5', 14794),
(14795, 'cd01400', NULL, '6PGL', NULL, NULL, '6PGL', 14795),
(14796, 'cd02972', NULL, 'DsbA_family', NULL, NULL, 'DsbA_family', 14796),
(14797, 'cd04059', NULL, 'Peptidases_S8_Protein_convertases_Kexins_Furin...', NULL, NULL, 'Peptidases_S8_Protein_convertases_Kexins_Furin-like', 14797),
(14798, 'cd05174', NULL, 'PI3Kc_IA_delta', NULL, NULL, 'PI3Kc_IA_delta', 14798),
(14799, 'cd12946', NULL, 'NOPS_p54nrb_PSF_PSPC1', NULL, NULL, 'NOPS_p54nrb_PSF_PSPC1', 14799),
(14800, 'cd17760', NULL, 'MCM9', NULL, NULL, 'MCM9', 14800),
(14801, 'cd14833', NULL, 'AP2_sigma', NULL, NULL, 'AP2_sigma', 14801),
(14802, 'cd13631', NULL, 'PBP2_Ct-PDT_like', NULL, NULL, 'PBP2_Ct-PDT_like', 14802),
(14803, 'cd10579', NULL, 'TNFRSF6', NULL, NULL, 'TNFRSF6', 14803),
(14804, 'cd15038', NULL, '7tmF_FZD4', NULL, NULL, '7tmF_FZD4', 14804),
(14805, 'cd20262', NULL, 'Complex1_LYR_LYRM2', NULL, NULL, 'Complex1_LYR_LYRM2', 14805),
(14806, 'cd19371', NULL, 'UDG-F1-like', NULL, NULL, 'UDG-F1-like', 14806),
(14807, 'cd07367', NULL, 'CarBb', NULL, NULL, 'CarBb', 14807),
(14808, 'cd11859', NULL, 'SH3_ZO', NULL, NULL, 'SH3_ZO', 14808),
(14809, 'cd05931', NULL, 'FAAL', NULL, NULL, 'FAAL', 14809),
(14810, 'cd12004', NULL, 'SH3_Lyn', NULL, NULL, 'SH3_Lyn', 14810),
(14811, 'cd12120', NULL, 'AMPKA_C_like', NULL, NULL, 'AMPKA_C_like', 14811),
(14812, 'cd17209', NULL, 'RA_RalGDS', NULL, NULL, 'RA_RalGDS', 14812),
(14813, 'cd19110', NULL, 'AKR_AKR1E1-2', NULL, NULL, 'AKR_AKR1E1-2', 14813),
(14814, 'cd19880', NULL, 'DSRM_STAU2_rpt1', NULL, NULL, 'DSRM_STAU2_rpt1', 14814),
(14815, 'cd15772', NULL, 'FYVE2_BSN_PCLO', NULL, NULL, 'FYVE2_BSN_PCLO', 14815),
(14816, 'cd04021', NULL, 'C2_E3_ubiquitin_ligase', NULL, NULL, 'C2_E3_ubiquitin_ligase', 14816),
(14817, 'cd08763', NULL, 'Cyt_b561_CYB561', NULL, NULL, 'Cyt_b561_CYB561', 14817),
(14818, 'cd18708', NULL, 'PIN_VapC-like', NULL, NULL, 'PIN_VapC-like', 14818);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(14819, 'cd01156', NULL, 'IVD', NULL, NULL, 'IVD', 14819),
(14820, 'cd14904', NULL, 'MYSc_Myo43', NULL, NULL, 'MYSc_Myo43', 14820),
(14821, 'cd09119', NULL, 'PLDc_FAM83_N', NULL, NULL, 'PLDc_FAM83_N', 14821),
(14822, 'cd18211', NULL, 'BTB_POZ_ZBTB23_GZF1', NULL, NULL, 'BTB_POZ_ZBTB23_GZF1', 14822),
(14823, 'cd00432', NULL, 'Ribosomal_L18_L5e', NULL, NULL, 'Ribosomal_L18_L5e', 14823),
(14824, 'cd07337', NULL, 'M48B_HtpX_like', NULL, NULL, 'M48B_HtpX_like', 14824),
(14825, 'cd07881', NULL, 'RHD-n_NFAT', NULL, NULL, 'RHD-n_NFAT', 14825),
(14826, 'cd16619', NULL, 'mRING-HC-C4C4_TRIM37_C-VIII', NULL, NULL, 'mRING-HC-C4C4_TRIM37_C-VIII', 14826),
(14827, 'cd17190', NULL, 'FERM_F1_FARP2', NULL, NULL, 'FERM_F1_FARP2', 14827),
(14828, 'cd01595', NULL, 'Adenylsuccinate_lyase_like', NULL, NULL, 'Adenylsuccinate_lyase_like', 14828),
(14829, 'cd18088', NULL, 'Nep1-like', NULL, NULL, 'Nep1-like', 14829),
(14830, 'cd12874', NULL, 'SPRY_PRY', NULL, NULL, 'SPRY_PRY', 14830),
(14831, 'cd12584', NULL, 'RRM2_hnRNPAB', NULL, NULL, 'RRM2_hnRNPAB', 14831),
(14832, 'cd16384', NULL, 'VirB8_like', NULL, NULL, 'VirB8_like', 14832),
(14833, 'cd05859', NULL, 'Ig4_PDGFR', NULL, NULL, 'Ig4_PDGFR', 14833),
(14834, 'cd18133', NULL, 'HLD_clamp', NULL, NULL, 'HLD_clamp', 14834),
(14835, 'cd10393', NULL, 'SH2_RIN1', NULL, NULL, 'SH2_RIN1', 14835),
(14836, 'cd03251', NULL, 'ABCC_MsbA', NULL, NULL, 'ABCC_MsbA', 14836),
(14837, 'cd12418', NULL, 'RRM_Aly_REF_like', NULL, NULL, 'RRM_Aly_REF_like', 14837),
(14838, 'cd14084', NULL, 'STKc_Chk2', NULL, NULL, 'STKc_Chk2', 14838),
(14839, 'cd15481', NULL, 'SRP68-RBD', NULL, NULL, 'SRP68-RBD', 14839),
(14840, 'cd03896', NULL, 'M20_PAAh_like', NULL, NULL, 'M20_PAAh_like', 14840),
(14841, 'cd01339', NULL, 'LDH-like_MDH', NULL, NULL, 'LDH-like_MDH', 14841),
(14842, 'cd02134', NULL, 'NusA_KH', NULL, NULL, 'NusA_KH', 14842),
(14843, 'cd06064', NULL, 'H2MP_F420-Reduc', NULL, NULL, 'H2MP_F420-Reduc', 14843),
(14844, 'cd19707', NULL, 'bHLH_TS_TAL2', NULL, NULL, 'bHLH_TS_TAL2', 14844),
(14845, 'cd21594', NULL, 'deltaCoV_M', NULL, NULL, 'deltaCoV_M', 14845),
(14846, 'cd09187', NULL, 'PLDc_FAM83G_N', NULL, NULL, 'PLDc_FAM83G_N', 14846),
(14847, 'cd11892', NULL, 'SH3_MIA2', NULL, NULL, 'SH3_MIA2', 14847),
(14848, 'cd06570', NULL, 'GH20_chitobiase-like_1', NULL, NULL, 'GH20_chitobiase-like_1', 14848),
(14849, 'cd00852', NULL, 'NifB', NULL, NULL, 'NifB', 14849),
(14850, 'cd17874', NULL, 'FtsY', NULL, NULL, 'FtsY', 14850),
(14851, 'cd00487', NULL, 'Pep_deformylase', NULL, NULL, 'Pep_deformylase', 14851),
(14852, 'cd06604', NULL, 'GH31_glucosidase_II_MalA', NULL, NULL, 'GH31_glucosidase_II_MalA', 14852),
(14853, 'cd06617', NULL, 'PKc_MKK3_6', NULL, NULL, 'PKc_MKK3_6', 14853),
(14854, 'cd11383', NULL, 'YfjP', NULL, NULL, 'YfjP', 14854),
(14855, 'cd07901', NULL, 'Adenylation_DNA_ligase_Arch_LigB', NULL, NULL, 'Adenylation_DNA_ligase_Arch_LigB', 14855),
(14856, 'cd09186', NULL, 'PLDc_FAM83F_N', NULL, NULL, 'PLDc_FAM83F_N', 14856),
(14857, 'cd00885', NULL, 'cinA', NULL, NULL, 'cinA', 14857),
(14858, 'cd00656', NULL, 'Zn-ribbon', NULL, NULL, 'Zn-ribbon', 14858),
(14859, 'cd05908', NULL, 'A_NRPS_MycA_like', NULL, NULL, 'A_NRPS_MycA_like', 14859),
(14860, 'cd19904', NULL, 'DSRM_EIF2AK2_rpt2', NULL, NULL, 'DSRM_EIF2AK2_rpt2', 14860),
(14861, 'cd02180', NULL, 'GH16_fungal_KRE6_glucanase', NULL, NULL, 'GH16_fungal_KRE6_glucanase', 14861),
(14862, 'cd18815', NULL, 'CAP_R3HDML', NULL, NULL, 'CAP_R3HDML', 14862),
(14863, 'cd08506', NULL, 'PBP2_clavulanate_OppA2', NULL, NULL, 'PBP2_clavulanate_OppA2', 14863),
(14864, 'cd06452', NULL, 'SepCysS', NULL, NULL, 'SepCysS', 14864),
(14865, 'cd07614', NULL, 'BAR_Endophilin_A2', NULL, NULL, 'BAR_Endophilin_A2', 14865),
(14866, 'cd16289', NULL, 'L1_POM-1-like_MBL-B3', NULL, NULL, 'L1_POM-1-like_MBL-B3', 14866),
(14867, 'cd00264', NULL, 'BPI', NULL, NULL, 'BPI', 14867),
(14868, 'cd12363', NULL, 'RRM_TRA2', NULL, NULL, 'RRM_TRA2', 14868),
(14869, 'cd09412', NULL, 'LIM4_Leupaxin', NULL, NULL, 'LIM4_Leupaxin', 14869),
(14870, 'cd17080', NULL, 'Ubl_SLD2_Esc2_like', NULL, NULL, 'Ubl_SLD2_Esc2_like', 14870);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(14871, 'cd07714', NULL, 'RNaseJ_MBL-fold', NULL, NULL, 'RNaseJ_MBL-fold', 14871),
(14872, 'cd07847', NULL, 'STKc_CDKL1_4', NULL, NULL, 'STKc_CDKL1_4', 14872),
(14873, 'cd14662', NULL, 'STKc_SnRK2', NULL, NULL, 'STKc_SnRK2', 14873),
(14874, 'cd10289', NULL, 'GST_C_AaRS_like', NULL, NULL, 'GST_C_AaRS_like', 14874),
(14875, 'cd08945', NULL, 'PKR_SDR_c', NULL, NULL, 'PKR_SDR_c', 14875),
(14876, 'cd11542', NULL, 'NTP-PPase_u5', NULL, NULL, 'NTP-PPase_u5', 14876),
(14877, 'cd12933', NULL, 'eIF3G', NULL, NULL, 'eIF3G', 14877),
(14878, 'cd13641', NULL, 'PBP2_HisX_like', NULL, NULL, 'PBP2_HisX_like', 14878),
(14879, 'cd16707', NULL, 'RING-HC_CARP2', NULL, NULL, 'RING-HC_CARP2', 14879),
(14880, 'cd17869', NULL, 'TadZ-like', NULL, NULL, 'TadZ-like', 14880),
(14881, 'cd13880', NULL, 'CuRO_2_MaLCC_like', NULL, NULL, 'CuRO_2_MaLCC_like', 14881),
(14882, 'cd12728', NULL, 'RRM_like_Smg4_UPF3B', NULL, NULL, 'RRM_like_Smg4_UPF3B', 14882),
(14883, 'cd03015', NULL, 'PRX_Typ2cys', NULL, NULL, 'PRX_Typ2cys', 14883),
(14884, 'cd05890', NULL, 'Ig2_Nectin-1_like', NULL, NULL, 'Ig2_Nectin-1_like', 14884),
(14885, 'cd08676', NULL, 'C2A_Munc13-like', NULL, NULL, 'C2A_Munc13-like', 14885),
(14886, 'cd09584', NULL, 'SAM_sec23ip', NULL, NULL, 'SAM_sec23ip', 14886),
(14887, 'cd09427', NULL, 'LIM2_FHL3', NULL, NULL, 'LIM2_FHL3', 14887),
(14888, 'cd01293', NULL, 'Bact_CD', NULL, NULL, 'Bact_CD', 14888),
(14889, 'cd19037', NULL, 'LGIC_ECD_GABAAR_A4', NULL, NULL, 'LGIC_ECD_GABAAR_A4', 14889),
(14890, 'cd08906', NULL, 'START_STARD3-like', NULL, NULL, 'START_STARD3-like', 14890),
(14891, 'cd13221', NULL, 'PH-GRAM_GRAMDC4', NULL, NULL, 'PH-GRAM_GRAMDC4', 14891),
(14892, 'cd13581', NULL, 'PBP2_AlgQ_like_2', NULL, NULL, 'PBP2_AlgQ_like_2', 14892),
(14893, 'cd07572', NULL, 'nit', NULL, NULL, 'nit', 14893),
(14894, 'cd15703', NULL, 'ePHD_BRPF3', NULL, NULL, 'ePHD_BRPF3', 14894),
(14895, 'cd21666', NULL, 'betaCoV_Nsp5_Mpro', NULL, NULL, 'betaCoV_Nsp5_Mpro', 14895),
(14896, 'cd04890', NULL, 'ACT_AK-like_1', NULL, NULL, 'ACT_AK-like_1', 14896),
(14897, 'cd07545', NULL, 'P-type_ATPase_Cd-like', NULL, NULL, 'P-type_ATPase_Cd-like', 14897),
(14898, 'cd01833', NULL, 'XynB_like', NULL, NULL, 'XynB_like', 14898),
(14899, 'cd01986', NULL, 'Alpha_ANH_like', NULL, NULL, 'Alpha_ANH_like', 14899),
(14900, 'cd20301', NULL, 'cupin_ChrR', NULL, NULL, 'cupin_ChrR', 14900),
(14901, 'cd11429', NULL, 'bHLH_TS_OLIG', NULL, NULL, 'bHLH_TS_OLIG', 14901),
(14902, 'cd13262', NULL, 'PH_RasSynGAP-like', NULL, NULL, 'PH_RasSynGAP-like', 14902),
(14903, 'cd19029', NULL, 'LGIC_ECD_nAChR_G', NULL, NULL, 'LGIC_ECD_nAChR_G', 14903),
(14904, 'cd08818', NULL, 'CARD_MDA5_r1', NULL, NULL, 'CARD_MDA5_r1', 14904),
(14905, 'cd01665', NULL, 'Cyt_c_Oxidase_III', NULL, NULL, 'Cyt_c_Oxidase_III', 14905),
(14906, 'cd08786', NULL, 'CARD_RIP2_CARD3', NULL, NULL, 'CARD_RIP2_CARD3', 14906),
(14907, 'cd07342', NULL, 'M48C_Oma1_like', NULL, NULL, 'M48C_Oma1_like', 14907),
(14908, 'cd17950', NULL, 'DEADc_DDX39', NULL, NULL, 'DEADc_DDX39', 14908),
(14909, 'cd11375', NULL, 'Peptidase_M54', NULL, NULL, 'Peptidase_M54', 14909),
(14910, 'cd12419', NULL, 'RRM_Ssp2_like', NULL, NULL, 'RRM_Ssp2_like', 14910),
(14911, 'cd16198', NULL, 'EFh_PEF_CAPN1', NULL, NULL, 'EFh_PEF_CAPN1', 14911),
(14912, 'cd13340', NULL, 'PH-GRAM_MTMR5', NULL, NULL, 'PH-GRAM_MTMR5', 14912),
(14913, 'cd14733', NULL, 'BACK', NULL, NULL, 'BACK', 14913),
(14914, 'cd06154', NULL, 'YjgF_YER057c_UK114_like_6', NULL, NULL, 'YjgF_YER057c_UK114_like_6', 14914),
(14915, 'cd03501', NULL, 'SQR_TypeA_SdhC_like', NULL, NULL, 'SQR_TypeA_SdhC_like', 14915),
(14916, 'cd02997', NULL, 'PDI_a_PDIR', NULL, NULL, 'PDI_a_PDIR', 14916),
(14917, 'cd17166', NULL, 'RAWUL_RING1', NULL, NULL, 'RAWUL_RING1', 14917),
(14918, 'cd02013', NULL, 'TPP_Xsc_like', NULL, NULL, 'TPP_Xsc_like', 14918),
(14919, 'cd13365', NULL, 'PH_PLC_plant-like', NULL, NULL, 'PH_PLC_plant-like', 14919),
(14920, 'cd18656', NULL, 'CSD_HP1gamma_Cbx3', NULL, NULL, 'CSD_HP1gamma_Cbx3', 14920),
(14921, 'cd07002', NULL, 'cupin_SznF-like_C', NULL, NULL, 'cupin_SznF-like_C', 14921);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(14922, 'cd06426', NULL, 'NTP_transferase_like_2', NULL, NULL, 'NTP_transferase_like_2', 14922),
(14923, 'cd08225', NULL, 'STKc_Nek5', NULL, NULL, 'STKc_Nek5', 14923),
(14924, 'cd03351', NULL, 'LbH_UDP-GlcNAc_AT', NULL, NULL, 'LbH_UDP-GlcNAc_AT', 14924),
(14925, 'cd13267', NULL, 'PH_DOCK-D', NULL, NULL, 'PH_DOCK-D', 14925),
(14926, 'cd07986', NULL, 'LPLAT_ACT14924-like', NULL, NULL, 'LPLAT_ACT14924-like', 14926),
(14927, 'cd08648', NULL, 'FMT_core_Formyl-FH4-Hydrolase_C', NULL, NULL, 'FMT_core_Formyl-FH4-Hydrolase_C', 14927),
(14928, 'cd08732', NULL, 'RGS-like_4', NULL, NULL, 'RGS-like_4', 14928),
(14929, 'cd16499', NULL, 'RING-HC_BRE1_like', NULL, NULL, 'RING-HC_BRE1_like', 14929),
(14930, 'cd04766', NULL, 'HTH_HspR', NULL, NULL, 'HTH_HspR', 14930),
(14931, 'cd17261', NULL, 'RMtype1_S_EcoKI-TRD2-CR2_like', NULL, NULL, 'RMtype1_S_EcoKI-TRD2-CR2_like', 14931),
(14932, 'cd04328', NULL, 'RNAP_I_Rpa43_N', NULL, NULL, 'RNAP_I_Rpa43_N', 14932),
(14933, 'cd16393', NULL, 'SPO0J_N', NULL, NULL, 'SPO0J_N', 14933),
(14934, 'cd08943', NULL, 'R1PA_ADH_SDR_c', NULL, NULL, 'R1PA_ADH_SDR_c', 14934),
(14935, 'cd16203', NULL, 'EFh_PI-PLCepsilon', NULL, NULL, 'EFh_PI-PLCepsilon', 14935),
(14936, 'cd03765', NULL, 'proteasome_beta_bacterial', NULL, NULL, 'proteasome_beta_bacterial', 14936),
(14937, 'cd14111', NULL, 'STKc_SPEG_rpt2', NULL, NULL, 'STKc_SPEG_rpt2', 14937),
(14938, 'cd00005', NULL, 'CBM9_like_1', NULL, NULL, 'CBM9_like_1', 14938),
(14939, 'cd16099', NULL, 'TenA_PqqC-like', NULL, NULL, 'TenA_PqqC-like', 14939),
(14940, 'cd07301', NULL, 'PX_SNX21', NULL, NULL, 'PX_SNX21', 14940),
(14941, 'cd13665', NULL, 'PBP2_TRAP_Dctp3_4', NULL, NULL, 'PBP2_TRAP_Dctp3_4', 14941),
(14942, 'cd16774', NULL, 'RING-HC_RBR_ANKIB1', NULL, NULL, 'RING-HC_RBR_ANKIB1', 14942),
(14943, 'cd01612', NULL, 'Ubl_ATG12', NULL, NULL, 'Ubl_ATG12', 14943),
(14944, 'cd07682', NULL, 'F-BAR_srGAP2', NULL, NULL, 'F-BAR_srGAP2', 14944),
(14945, 'cd16326', NULL, 'LolB', NULL, NULL, 'LolB', 14945),
(14946, 'cd13748', NULL, 'CBM29_CBM65', NULL, NULL, 'CBM29_CBM65', 14946),
(14947, 'cd06391', NULL, 'PBP1_iGluR_delta_2', NULL, NULL, 'PBP1_iGluR_delta_2', 14947),
(14948, 'cd15479', NULL, 'fMyo4p_CBD', NULL, NULL, 'fMyo4p_CBD', 14948),
(14949, 'cd19109', NULL, 'AKR_AKR1D1-3', NULL, NULL, 'AKR_AKR1D1-3', 14949),
(14950, 'cd17737', NULL, 'BRCT_TopBP1_rpt1', NULL, NULL, 'BRCT_TopBP1_rpt1', 14950),
(14951, 'cd18047', NULL, 'DEADc_DDX19', NULL, NULL, 'DEADc_DDX19', 14951),
(14952, 'cd05265', NULL, 'SDR_a1', NULL, NULL, 'SDR_a1', 14952),
(14953, 'cd10931', NULL, 'CE4_u7', NULL, NULL, 'CE4_u7', 14953),
(14954, 'cd05400', NULL, 'NT_2-5OAS_ClassI-CCAase', NULL, NULL, 'NT_2-5OAS_ClassI-CCAase', 14954),
(14955, 'cd16334', NULL, 'LppX-like', NULL, NULL, 'LppX-like', 14955),
(14956, 'cd17379', NULL, 'MFS_SLC22A1_2_3', NULL, NULL, 'MFS_SLC22A1_2_3', 14956),
(14957, 'cd02754', NULL, 'MopB_Nitrate-R-NapA-like', NULL, NULL, 'MopB_Nitrate-R-NapA-like', 14957),
(14958, 'cd19189', NULL, 'PR-SET_PRDM4', NULL, NULL, 'PR-SET_PRDM4', 14958),
(14959, 'cd01882', NULL, 'BMS1', NULL, NULL, 'BMS1', 14959),
(14960, 'cd17598', NULL, 'REC_hyHK', NULL, NULL, 'REC_hyHK', 14960),
(14961, 'cd08528', NULL, 'STKc_Nek10', NULL, NULL, 'STKc_Nek10', 14961),
(14962, 'cd05575', NULL, 'STKc_SGK', NULL, NULL, 'STKc_SGK', 14962),
(14963, 'cd03396', NULL, 'PAP2_like_6', NULL, NULL, 'PAP2_like_6', 14963),
(14964, 'cd07353', NULL, 'harmonin_N', NULL, NULL, 'harmonin_N', 14964),
(14965, 'cd21567', NULL, 'MERS-like-CoV_M', NULL, NULL, 'MERS-like-CoV_M', 14965),
(14966, 'cd11533', NULL, 'NTP-PPase_Af0060_like', NULL, NULL, 'NTP-PPase_Af0060_like', 14966),
(14967, 'cd12680', NULL, 'RRM_THOC4', NULL, NULL, 'RRM_THOC4', 14967),
(14968, 'cd07768', NULL, 'FGGY_RBK_like', NULL, NULL, 'FGGY_RBK_like', 14968),
(14969, 'cd03717', NULL, 'SOCS_SOCS_like', NULL, NULL, 'SOCS_SOCS_like', 14969),
(14970, 'cd14992', NULL, '7tmA_TACR_family', NULL, NULL, '7tmA_TACR_family', 14970),
(14971, 'cd17974', NULL, 'DEXHc_DHX16', NULL, NULL, 'DEXHc_DHX16', 14971),
(14972, 'cd01027', NULL, 'TOPRIM_RNase_M5_like', NULL, NULL, 'TOPRIM_RNase_M5_like', 14972);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(14973, 'cd13326', NULL, 'PH_CNK_insect-like', NULL, NULL, 'PH_CNK_insect-like', 14973),
(14974, 'cd00866', NULL, 'PEBP_euk', NULL, NULL, 'PEBP_euk', 14974),
(14975, 'cd14834', NULL, 'AP3_sigma', NULL, NULL, 'AP3_sigma', 14975),
(14976, 'cd03510', NULL, 'Rhizobitoxine-FADS-like', NULL, NULL, 'Rhizobitoxine-FADS-like', 14976),
(14977, 'cd07952', NULL, 'ED_3B_like', NULL, NULL, 'ED_3B_like', 14977),
(14978, 'cd04930', NULL, 'ACT_TH', NULL, NULL, 'ACT_TH', 14978),
(14979, 'cd07311', NULL, 'terB_like_1', NULL, NULL, 'terB_like_1', 14979),
(14980, 'cd11556', NULL, 'SLC6sbd_SERT-like_u1', NULL, NULL, 'SLC6sbd_SERT-like_u1', 14980),
(14981, 'cd07617', NULL, 'BAR_Endophilin_B2', NULL, NULL, 'BAR_Endophilin_B2', 14981),
(14982, 'cd05479', NULL, 'RP_DDI', NULL, NULL, 'RP_DDI', 14982),
(14983, 'cd01269', NULL, 'PTB_TBC1D1_like', NULL, NULL, 'PTB_TBC1D1_like', 14983),
(14984, 'cd08813', NULL, 'DED_Caspase_8_r2', NULL, NULL, 'DED_Caspase_8_r2', 14984),
(14985, 'cd07357', NULL, 'HN_L-whirlin_R2_like', NULL, NULL, 'HN_L-whirlin_R2_like', 14985),
(14986, 'cd16694', NULL, 'mRING-CH-C4HC2H_ZNRF1', NULL, NULL, 'mRING-CH-C4HC2H_ZNRF1', 14986),
(14987, 'cd11339', NULL, 'AmyAc_bac_CMD_like_2', NULL, NULL, 'AmyAc_bac_CMD_like_2', 14987),
(14988, 'cd18597', NULL, 'ABC_6TM_YOR1_D1_like', NULL, NULL, 'ABC_6TM_YOR1_D1_like', 14988),
(14989, 'cd14136', NULL, 'STKc_SRPK', NULL, NULL, 'STKc_SRPK', 14989),
(14990, 'cd03073', NULL, 'PDI_b''_ERp72_ERp57', NULL, NULL, 'PDI_b''_ERp72_ERp57', 14990),
(14991, 'cd00338', NULL, 'Ser_Recombinase', NULL, NULL, 'Ser_Recombinase', 14991),
(14992, 'cd11445', NULL, 'bHLH_AtPIF_like', NULL, NULL, 'bHLH_AtPIF_like', 14992),
(14993, 'cd06372', NULL, 'PBP1_GC_G-like', NULL, NULL, 'PBP1_GC_G-like', 14993),
(14994, 'cd14014', NULL, 'STKc_PknB_like', NULL, NULL, 'STKc_PknB_like', 14994),
(14995, 'cd19570', NULL, 'serpinB11_epipin', NULL, NULL, 'serpinB11_epipin', 14995),
(14996, 'cd16371', NULL, 'DMSOR_beta_like', NULL, NULL, 'DMSOR_beta_like', 14996),
(14997, 'cd14371', NULL, 'CUE_CID7_like', NULL, NULL, 'CUE_CID7_like', 14997),
(14998, 'cd01211', NULL, 'PTB_Rab6GAP', NULL, NULL, 'PTB_Rab6GAP', 14998),
(14999, 'cd12250', NULL, 'RRM2_hnRNPR_like', NULL, NULL, 'RRM2_hnRNPR_like', 14999),
(15000, 'cd18709', NULL, 'PIN_VapC-like', NULL, NULL, 'PIN_VapC-like', 15000),
(15001, 'cd18559', NULL, 'ABC_6TM_ABCC', NULL, NULL, 'ABC_6TM_ABCC', 15001),
(15002, 'cd01868', NULL, 'Rab11_like', NULL, NULL, 'Rab11_like', 15002),
(15003, 'cd06923', NULL, 'ChtBD1_GH16', NULL, NULL, 'ChtBD1_GH16', 15003),
(15004, 'cd15918', NULL, '7tmA_OR1_7-like', NULL, NULL, '7tmA_OR1_7-like', 15004),
(15005, 'cd00170', NULL, 'SEC14', NULL, NULL, 'SEC14', 15005),
(15006, 'cd17418', NULL, 'MFS_NPF8', NULL, NULL, 'MFS_NPF8', 15006),
(15007, 'cd05345', NULL, 'BKR_3_SDR_c', NULL, NULL, 'BKR_3_SDR_c', 15007),
(15008, 'cd11548', NULL, 'NodZ_like', NULL, NULL, 'NodZ_like', 15008),
(15009, 'cd14998', NULL, '7tmA_GPR153_GPR162-like', NULL, NULL, '7tmA_GPR153_GPR162-like', 15009),
(15010, 'cd05736', NULL, 'Ig2_Follistatin_like', NULL, NULL, 'Ig2_Follistatin_like', 15010),
(15011, 'cd09768', NULL, 'Luminal_EIF2AK3', NULL, NULL, 'Luminal_EIF2AK3', 15011),
(15012, 'cd11809', NULL, 'SH3_srGAP', NULL, NULL, 'SH3_srGAP', 15012),
(15013, 'cd18829', NULL, 'GH43_BsArb43A-like', NULL, NULL, 'GH43_BsArb43A-like', 15013),
(15014, 'cd09942', NULL, 'SH2_nSH2_p85_like', NULL, NULL, 'SH2_nSH2_p85_like', 15014),
(15015, 'cd00091', NULL, 'NUC', NULL, NULL, 'NUC', 15015),
(15016, 'cd12964', NULL, 'CBM-Fa', NULL, NULL, 'CBM-Fa', 15016),
(15017, 'cd11866', NULL, 'SH3_SKAP1-like', NULL, NULL, 'SH3_SKAP1-like', 15017),
(15018, 'cd21663', NULL, 'ORF7a_SARS-CoV-like', NULL, NULL, 'ORF7a_SARS-CoV-like', 15018),
(15019, 'cd04476', NULL, 'RPA1_DBD_C', NULL, NULL, 'RPA1_DBD_C', 15019),
(15020, 'cd12609', NULL, 'RRM2_CoAA', NULL, NULL, 'RRM2_CoAA', 15020),
(15021, 'cd15260', NULL, '7tmB1_NPR_B4_insect-like', NULL, NULL, '7tmB1_NPR_B4_insect-like', 15021),
(15022, 'cd05048', NULL, 'PTKc_Ror', NULL, NULL, 'PTKc_Ror', 15022),
(15023, 'cd10293', NULL, 'GST_C_Ure2p', NULL, NULL, 'GST_C_Ure2p', 15023);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(15024, 'cd05113', NULL, 'PTKc_Btk_Bmx', NULL, NULL, 'PTKc_Btk_Bmx', 15024),
(15025, 'cd18802', NULL, 'SF2_C_dicer', NULL, NULL, 'SF2_C_dicer', 15025),
(15026, 'cd02341', NULL, 'ZZ_ZZZ3', NULL, NULL, 'ZZ_ZZZ3', 15026),
(15027, 'cd18655', NULL, 'CSD_HP1alpha_Cbx5', NULL, NULL, 'CSD_HP1alpha_Cbx5', 15027),
(15028, 'cd06167', NULL, 'PIN_LabA-like', NULL, NULL, 'PIN_LabA-like', 15028),
(15029, 'cd12223', NULL, 'RRM_SR140', NULL, NULL, 'RRM_SR140', 15029),
(15030, 'cd14571', NULL, 'DSP_slingshot_3', NULL, NULL, 'DSP_slingshot_3', 15030),
(15031, 'cd04614', NULL, 'CBS_pair_arch2_repeat2', NULL, NULL, 'CBS_pair_arch2_repeat2', 15031),
(15032, 'cd01461', NULL, 'vWA_interalpha_trypsin_inhibitor', NULL, NULL, 'vWA_interalpha_trypsin_inhibitor', 15032),
(15033, 'cd19024', NULL, 'LGIC_ECD_nAChR_B1', NULL, NULL, 'LGIC_ECD_nAChR_B1', 15033),
(15034, 'cd05714', NULL, 'Ig_CSPGs_LP', NULL, NULL, 'Ig_CSPGs_LP', 15034),
(15035, 'cd08851', NULL, 'ArfGap_ACAP2', NULL, NULL, 'ArfGap_ACAP2', 15035),
(15036, 'cd00209', NULL, 'DHFR', NULL, NULL, 'DHFR', 15036),
(15037, 'cd09137', NULL, 'PLDc_PGS1_euk_2', NULL, NULL, 'PLDc_PGS1_euk_2', 15037),
(15038, 'cd10023', NULL, '14-3-3_theta', NULL, NULL, '14-3-3_theta', 15038),
(15039, 'cd11833', NULL, 'SH3_Stac_1', NULL, NULL, 'SH3_Stac_1', 15039),
(15040, 'cd07074', NULL, 'NR_LBD_PR', NULL, NULL, 'NR_LBD_PR', 15040),
(15041, 'cd10299', NULL, 'GST_C_CLIC3', NULL, NULL, 'GST_C_CLIC3', 15041),
(15042, 'cd03061', NULL, 'GST_N_CLIC', NULL, NULL, 'GST_N_CLIC', 15042),
(15043, 'cd21637', NULL, 'NS7_PDCoV', NULL, NULL, 'NS7_PDCoV', 15043),
(15044, 'cd17993', NULL, 'DEXHc_CHD1_2', NULL, NULL, 'DEXHc_CHD1_2', 15044),
(15045, 'cd01248', NULL, 'PH_PLC_ELMO1', NULL, NULL, 'PH_PLC_ELMO1', 15045),
(15046, 'cd16956', NULL, 'HATPase_YehU-like', NULL, NULL, 'HATPase_YehU-like', 15046),
(15047, 'cd17378', NULL, 'MFS_OCT_plant', NULL, NULL, 'MFS_OCT_plant', 15047),
(15048, 'cd15451', NULL, '7tmC_mGluR7', NULL, NULL, '7tmC_mGluR7', 15048),
(15049, 'cd14088', NULL, 'STKc_CaMK_like', NULL, NULL, 'STKc_CaMK_like', 15049),
(15050, 'cd09601', NULL, 'M1_APN-Q_like', NULL, NULL, 'M1_APN-Q_like', 15050),
(15051, 'cd19213', NULL, 'PR-SET_PRDM16', NULL, NULL, 'PR-SET_PRDM16', 15051),
(15052, 'cd09161', NULL, 'PLDc_PaCLS_like_2', NULL, NULL, 'PLDc_PaCLS_like_2', 15052),
(15053, 'cd17053', NULL, 'Ubl2_FAT10', NULL, NULL, 'Ubl2_FAT10', 15053),
(15054, 'cd14151', NULL, 'STKc_B-Raf', NULL, NULL, 'STKc_B-Raf', 15054),
(15055, 'cd07441', NULL, 'CRD_SFRP3', NULL, NULL, 'CRD_SFRP3', 15055),
(15056, 'cd05062', NULL, 'PTKc_IGF-1R', NULL, NULL, 'PTKc_IGF-1R', 15056),
(15057, 'cd07498', NULL, 'Peptidases_S8_15', NULL, NULL, 'Peptidases_S8_15', 15057),
(15058, 'cd10546', NULL, 'VKOR', NULL, NULL, 'VKOR', 15058),
(15059, 'cd01493', NULL, 'APPBP1_RUB', NULL, NULL, 'APPBP1_RUB', 15059),
(15060, 'cd08562', NULL, 'GDPD_EcUgpQ_like', NULL, NULL, 'GDPD_EcUgpQ_like', 15060),
(15061, 'cd13612', NULL, 'PBP2_ProWX', NULL, NULL, 'PBP2_ProWX', 15061),
(15062, 'cd03430', NULL, 'GDPMH', NULL, NULL, 'GDPMH', 15062),
(15063, 'cd09732', NULL, 'Csx1_III-U', NULL, NULL, 'Csx1_III-U', 15063),
(15064, 'cd06204', NULL, 'CYPOR', NULL, NULL, 'CYPOR', 15064),
(15065, 'cd11364', NULL, 'RNase_PH_PNPase_2', NULL, NULL, 'RNase_PH_PNPase_2', 15065),
(15066, 'cd03269', NULL, 'ABC_putative_ATPase', NULL, NULL, 'ABC_putative_ATPase', 15066),
(15067, 'cd04676', NULL, 'Nudix_Hydrolase_17', NULL, NULL, 'Nudix_Hydrolase_17', 15067),
(15068, 'cd07001', NULL, 'cupin_YbfI-like_N', NULL, NULL, 'cupin_YbfI-like_N', 15068),
(15069, 'cd09729', NULL, 'Cse1_I-E', NULL, NULL, 'Cse1_I-E', 15069),
(15070, 'cd06648', NULL, 'STKc_PAK_II', NULL, NULL, 'STKc_PAK_II', 15070),
(15071, 'cd03048', NULL, 'GST_N_Ure2p_like', NULL, NULL, 'GST_N_Ure2p_like', 15071),
(15072, 'cd01289', NULL, 'FabA_like', NULL, NULL, 'FabA_like', 15072),
(15073, 'cd09664', NULL, 'Cas6_I-E', NULL, NULL, 'Cas6_I-E', 15073),
(15074, 'cd20285', NULL, 'cupin_7S_11S_C', NULL, NULL, 'cupin_7S_11S_C', 15074),
(15075, 'cd01492', NULL, 'Aos1_SUMO', NULL, NULL, 'Aos1_SUMO', 15075),
(15076, 'cd01568', NULL, 'QPRTase_NadC', NULL, NULL, 'QPRTase_NadC', 15076);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(15077, 'cd10433', NULL, 'YccA_like', NULL, NULL, 'YccA_like', 15077),
(15078, 'cd01937', NULL, 'ribokinase_group_D', NULL, NULL, 'ribokinase_group_D', 15078),
(15079, 'cd12126', NULL, 'APC_beta', NULL, NULL, 'APC_beta', 15079),
(15080, 'cd14163', NULL, 'STKc_TSSK3-like', NULL, NULL, 'STKc_TSSK3-like', 15080),
(15081, 'cd17492', NULL, 'toxin_CptN', NULL, NULL, 'toxin_CptN', 15081),
(15082, 'cd14880', NULL, 'MYSc_Myo19', NULL, NULL, 'MYSc_Myo19', 15082),
(15083, 'cd06951', NULL, 'NR_LBD_Dax1_like', NULL, NULL, 'NR_LBD_Dax1_like', 15083),
(15084, 'cd19005', NULL, 'LGIC_ECD_GABAAR_rho', NULL, NULL, 'LGIC_ECD_GABAAR_rho', 15084),
(15085, 'cd06170', NULL, 'LuxR_C_like', NULL, NULL, 'LuxR_C_like', 15085),
(15086, 'cd16171', NULL, 'ARSK', NULL, NULL, 'ARSK', 15086),
(15087, 'cd09014', NULL, 'BphC-JF8_C_like', NULL, NULL, 'BphC-JF8_C_like', 15087),
(15088, 'cd09317', NULL, 'TDT_Mae1_like', NULL, NULL, 'TDT_Mae1_like', 15088),
(15089, 'cd14197', NULL, 'STKc_DRAK1', NULL, NULL, 'STKc_DRAK1', 15089),
(15090, 'cd18190', NULL, 'BTB_POZ_ETO1-like', NULL, NULL, 'BTB_POZ_ETO1-like', 15090),
(15091, 'cd15281', NULL, '7tmC_GPRC6A', NULL, NULL, '7tmC_GPRC6A', 15091),
(15092, 'cd16255', NULL, 'EFh_parvalbumin_beta', NULL, NULL, 'EFh_parvalbumin_beta', 15092),
(15093, 'cd13873', NULL, 'CuRO_2_AAO_like_2', NULL, NULL, 'CuRO_2_AAO_like_2', 15093),
(15094, 'cd05262', NULL, 'SDR_a7', NULL, NULL, 'SDR_a7', 15094),
(15095, 'cd16618', NULL, 'mRING-HC-C4C4_CNOT4', NULL, NULL, 'mRING-HC-C4C4_CNOT4', 15095),
(15096, 'cd05570', NULL, 'STKc_PKC', NULL, NULL, 'STKc_PKC', 15096),
(15097, 'cd15431', NULL, '7tmA_OR13H-like', NULL, NULL, '7tmA_OR13H-like', 15097),
(15098, 'cd14311', NULL, 'UBA_II_E2_UBC1', NULL, NULL, 'UBA_II_E2_UBC1', 15098),
(15099, 'cd14951', NULL, 'NHL-2_like', NULL, NULL, 'NHL-2_like', 15099),
(15100, 'cd03866', NULL, 'M14_CPM', NULL, NULL, 'M14_CPM', 15100),
(15101, 'cd06254', NULL, 'M14_ASTE_ASPA-like', NULL, NULL, 'M14_ASTE_ASPA-like', 15101),
(15102, 'cd13195', NULL, 'FERM_C_MYLIP_IDOL', NULL, NULL, 'FERM_C_MYLIP_IDOL', 15102),
(15103, 'cd05052', NULL, 'PTKc_Abl', NULL, NULL, 'PTKc_Abl', 15103),
(15104, 'cd01746', NULL, 'GATase1_CTP_Synthase', NULL, NULL, 'GATase1_CTP_Synthase', 15104),
(15105, 'cd08370', NULL, 'FMT_C_like', NULL, NULL, 'FMT_C_like', 15105),
(15106, 'cd07276', NULL, 'PX_SNX16', NULL, NULL, 'PX_SNX16', 15106),
(15107, 'cd01562', NULL, 'Thr-dehyd', NULL, NULL, 'Thr-dehyd', 15107),
(15108, 'cd00751', NULL, 'thiolase', NULL, NULL, 'thiolase', 15108),
(15109, 'cd07029', NULL, 'RNAP_I_III_AC19', NULL, NULL, 'RNAP_I_III_AC19', 15109),
(15110, 'cd10919', NULL, 'CE4_CDA_like', NULL, NULL, 'CE4_CDA_like', 15110),
(15111, 'cd17362', NULL, 'MFS_GLUT10_12_Class3_like', NULL, NULL, 'MFS_GLUT10_12_Class3_like', 15111),
(15112, 'cd17999', NULL, 'DEXHc_Mot1', NULL, NULL, 'DEXHc_Mot1', 15112),
(15113, 'cd19003', NULL, 'LGIC_ECD_GABAAR_theta', NULL, NULL, 'LGIC_ECD_GABAAR_theta', 15113),
(15114, 'cd00136', NULL, 'PDZ', NULL, NULL, 'PDZ', 15114),
(15115, 'cd13603', NULL, 'PBP2_TRAP_Siap_TeaA_like', NULL, NULL, 'PBP2_TRAP_Siap_TeaA_like', 15115),
(15116, 'cd05695', NULL, 'S1_Rrp5_repeat_hs3', NULL, NULL, 'S1_Rrp5_repeat_hs3', 15116),
(15117, 'cd14338', NULL, 'UBA_SIK', NULL, NULL, 'UBA_SIK', 15117),
(15118, 'cd15656', NULL, 'PHD4_NSD1', NULL, NULL, 'PHD4_NSD1', 15118),
(15119, 'cd09184', NULL, 'PLDc_FAM83D_N', NULL, NULL, 'PLDc_FAM83D_N', 15119),
(15120, 'cd15408', NULL, '7tmA_OR5AK3-like', NULL, NULL, '7tmA_OR5AK3-like', 15120),
(15121, 'sd00033', NULL, 'LRR_RI', NULL, NULL, 'LRR_RI', 15121),
(15122, 'cd03869', NULL, 'M14_CPX_like', NULL, NULL, 'M14_CPX_like', 15122),
(15123, 'cd16280', NULL, 'metallo-hydrolase-like_MBL-fold', NULL, NULL, 'metallo-hydrolase-like_MBL-fold', 15123),
(15124, 'cd13838', NULL, 'RNase_H_like_Prp8_IV', NULL, NULL, 'RNase_H_like_Prp8_IV', 15124),
(15125, 'cd12751', NULL, 'RRM5_RBM12', NULL, NULL, 'RRM5_RBM12', 15125),
(15126, 'cd15945', NULL, '7tmA_OR5C1-like', NULL, NULL, '7tmA_OR5C1-like', 15126),
(15127, 'cd04130', NULL, 'Wrch_1', NULL, NULL, 'Wrch_1', 15127),
(15128, 'cd06195', NULL, 'FNR1', NULL, NULL, 'FNR1', 15128);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(15129, 'cd10308', NULL, 'GST_C_eEF1b_like', NULL, NULL, 'GST_C_eEF1b_like', 15129),
(15130, 'cd02213', NULL, 'cupin_PMI_typeII_C', NULL, NULL, 'cupin_PMI_typeII_C', 15130),
(15131, 'cd17500', NULL, 'RMtype1_S_MmaGORF2198P_TRD1-CR1_like', NULL, NULL, 'RMtype1_S_MmaGORF2198P_TRD1-CR1_like', 15131),
(15132, 'cd13564', NULL, 'PBP2_ThiY_THI5_like', NULL, NULL, 'PBP2_ThiY_THI5_like', 15132),
(15133, 'cd09702', NULL, 'Csx1_III-U', NULL, NULL, 'Csx1_III-U', 15133),
(15134, 'cd05477', NULL, 'gastricsin', NULL, NULL, 'gastricsin', 15134),
(15135, 'cd17114', NULL, 'RA_PLC-epsilon', NULL, NULL, 'RA_PLC-epsilon', 15135),
(15136, 'cd06883', NULL, 'PX_PI3K_C2', NULL, NULL, 'PX_PI3K_C2', 15136),
(15137, 'cd18622', NULL, 'GH32_Inu-like', NULL, NULL, 'GH32_Inu-like', 15137),
(15138, 'cd19802', NULL, 'Bbox1_TRIM8-like', NULL, NULL, 'Bbox1_TRIM8-like', 15138),
(15139, 'cd08666', NULL, 'APC10-HECTD3', NULL, NULL, 'APC10-HECTD3', 15139),
(15140, 'cd14506', NULL, 'PTP_PTPDC1', NULL, NULL, 'PTP_PTPDC1', 15140),
(15141, 'cd16635', NULL, 'mRING-HC-C3HC3D_PHRF1', NULL, NULL, 'mRING-HC-C3HC3D_PHRF1', 15141),
(15142, 'cd05137', NULL, 'RasGAP_CLA2_BUD2', NULL, NULL, 'RasGAP_CLA2_BUD2', 15142),
(15143, 'cd05705', NULL, 'S1_Rrp5_repeat_hs14', NULL, NULL, 'S1_Rrp5_repeat_hs14', 15143),
(15144, 'cd18623', NULL, 'GH32_ScrB-like', NULL, NULL, 'GH32_ScrB-like', 15144),
(15145, 'cd02900', NULL, 'Macro_Appr_pase', NULL, NULL, 'Macro_Appr_pase', 15145),
(15146, 'cd06632', NULL, 'STKc_MEKK1_plant', NULL, NULL, 'STKc_MEKK1_plant', 15146),
(15147, 'cd07497', NULL, 'Peptidases_S8_14', NULL, NULL, 'Peptidases_S8_14', 15147),
(15148, 'cd09022', NULL, 'Aldose_epim_Ec_YihR', NULL, NULL, 'Aldose_epim_Ec_YihR', 15148),
(15149, 'cd18414', NULL, 'BTB_KCNC1_3', NULL, NULL, 'BTB_KCNC1_3', 15149),
(15150, 'cd18079', NULL, 'S-AdoMet_synt', NULL, NULL, 'S-AdoMet_synt', 15150),
(15151, 'cd03248', NULL, 'ABCC_TAP', NULL, NULL, 'ABCC_TAP', 15151),
(15152, 'cd15665', NULL, 'ePHD1_KMT2C_like', NULL, NULL, 'ePHD1_KMT2C_like', 15152),
(15153, 'cd15760', NULL, 'FYVE_scVPS27p_like', NULL, NULL, 'FYVE_scVPS27p_like', 15153),
(15154, 'cd08801', NULL, 'Death_UNC5D', NULL, NULL, 'Death_UNC5D', 15154),
(15155, 'cd13298', NULL, 'PH1_PH_fungal', NULL, NULL, 'PH1_PH_fungal', 15155),
(15156, 'cd15961', NULL, '7tmA_GPR12', NULL, NULL, '7tmA_GPR12', 15156),
(15157, 'cd12926', NULL, 'iSH2_PIK3R2', NULL, NULL, 'iSH2_PIK3R2', 15157),
(15158, 'cd13728', NULL, 'PBP2_iGluR_AMPA_GluR3', NULL, NULL, 'PBP2_iGluR_AMPA_GluR3', 15158),
(15159, 'cd05276', NULL, 'p53_inducible_oxidoreductase', NULL, NULL, 'p53_inducible_oxidoreductase', 15159),
(15160, 'cd04842', NULL, 'Peptidases_S8_Kp43_protease', NULL, NULL, 'Peptidases_S8_Kp43_protease', 15160),
(15161, 'cd12039', NULL, 'SH3_MPP3', NULL, NULL, 'SH3_MPP3', 15161),
(15162, 'cd01831', NULL, 'Endoglucanase_E_like', NULL, NULL, 'Endoglucanase_E_like', 15162),
(15163, 'cd01991', NULL, 'Asn_Synthase_B_C', NULL, NULL, 'Asn_Synthase_B_C', 15163),
(15164, 'cd09218', NULL, 'TLP-PA', NULL, NULL, 'TLP-PA', 15164),
(15165, 'cd00283', NULL, 'GIY-YIG_Cterm', NULL, NULL, 'GIY-YIG_Cterm', 15165),
(15166, 'cd10950', NULL, 'CE4_BsYlxY_like', NULL, NULL, 'CE4_BsYlxY_like', 15166),
(15167, 'cd13433', NULL, 'Na_channel_gate', NULL, NULL, 'Na_channel_gate', 15167),
(15168, 'cd00110', NULL, 'LamG', NULL, NULL, 'LamG', 15168),
(15169, 'cd11409', NULL, 'bHLH-O_DEC', NULL, NULL, 'bHLH-O_DEC', 15169),
(15170, 'cd08470', NULL, 'PBP2_CrgA_like_1', NULL, NULL, 'PBP2_CrgA_like_1', 15170),
(15171, 'cd16640', NULL, 'RING-HC_TRAF3', NULL, NULL, 'RING-HC_TRAF3', 15171),
(15172, 'cd09157', NULL, 'PLDc_CLS_unchar2_1', NULL, NULL, 'PLDc_CLS_unchar2_1', 15172),
(15173, 'cd06905', NULL, 'M14-like', NULL, NULL, 'M14-like', 15173),
(15174, 'cd15438', NULL, '7tmB2_CD97', NULL, NULL, '7tmB2_CD97', 15174),
(15175, 'cd16570', NULL, 'RING-HC_SH3RFs', NULL, NULL, 'RING-HC_SH3RFs', 15175),
(15176, 'cd07659', NULL, 'BAR_PICK1', NULL, NULL, 'BAR_PICK1', 15176),
(15177, 'cd12870', NULL, 'MqsA', NULL, NULL, 'MqsA', 15177),
(15178, 'cd12227', NULL, 'RRM_SCAF4_SCAF8', NULL, NULL, 'RRM_SCAF4_SCAF8', 15178);
INSERT INTO "PUBLIC"."MODEL" VALUES
(15179, 'cd05290', NULL, 'LDH_3', NULL, NULL, 'LDH_3', 15179),
(15180, 'cd18729', NULL, 'PIN_Zc3h12-like', NULL, NULL, 'PIN_Zc3h12-like', 15180),
(15181, 'cd03235', NULL, 'ABC_Metallic_Cations', NULL, NULL, 'ABC_Metallic_Cations', 15181),
(15182, 'cd13170', NULL, 'RanBD_NUP50', NULL, NULL, 'RanBD_NUP50', 15182),
(15183, 'cd16766', NULL, 'RING-HC_TIF1gamma', NULL, NULL, 'RING-HC_TIF1gamma', 15183),
(15184, 'cd11580', NULL, 'eIF2D_N_like', NULL, NULL, 'eIF2D_N_like', 15184),
(15185, 'cd11779', NULL, 'SH3_Irsp53_BAIAP2L', NULL, NULL, 'SH3_Irsp53_BAIAP2L', 15185),
(15186, 'cd00560', NULL, 'PanC', NULL, NULL, 'PanC', 15186),
(15187, 'cd10369', NULL, 'SH2_Src_Frk', NULL, NULL, 'SH2_Src_Frk', 15187),
(15188, 'cd19361', NULL, 'TenA_C_HP1287-like', NULL, NULL, 'TenA_C_HP1287-like', 15188),
(15189, 'cd10412', NULL, 'SH2_SH2B3', NULL, NULL, 'SH2_SH2B3', 15189),
(15190, 'cd09992', NULL, 'HDAC_classII', NULL, NULL, 'HDAC_classII', 15190),
(15191, 'cd12237', NULL, 'RRM_snRNP35', NULL, NULL, 'RRM_snRNP35', 15191),
(15192, 'cd08978', NULL, 'GH_F', NULL, NULL, 'GH_F', 15192),
(15193, 'cd07766', NULL, 'DHQ_Fe-ADH', NULL, NULL, 'DHQ_Fe-ADH', 15193),
(15194, 'cd17639', NULL, 'LC_FACS_euk1', NULL, NULL, 'LC_FACS_euk1', 15194),
(15195, 'cd15726', NULL, 'FYVE_FYCO1', NULL, NULL, 'FYVE_FYCO1', 15195),
(15196, 'cd21570', NULL, 'batCoV_HKU9-like_M', NULL, NULL, 'batCoV_HKU9-like_M', 15196),
(15197, 'cd04175', NULL, 'Rap1', NULL, NULL, 'Rap1', 15197),
(15198, 'cd06946', NULL, 'NR_LBD_ERR', NULL, NULL, 'NR_LBD_ERR', 15198),
(15199, 'cd04657', NULL, 'Piwi_ago-like', NULL, NULL, 'Piwi_ago-like', 15199),
(15200, 'cd14573', NULL, 'DUSP18_21', NULL, NULL, 'DUSP18_21', 15200),
(15201, 'cd07643', NULL, 'I-BAR_IMD_MIM', NULL, NULL, 'I-BAR_IMD_MIM', 15201),
(15202, 'cd17873', NULL, 'FlhF', NULL, NULL, 'FlhF', 15202),
(15203, 'cd10570', NULL, 'PH-GRAM', NULL, NULL, 'PH-GRAM', 15203),
(15204, 'cd15056', NULL, '7tmA_5-HT4', NULL, NULL, '7tmA_5-HT4', 15204),
(15205, 'cd17646', NULL, 'A_NRPS_AB3403-like', NULL, NULL, 'A_NRPS_AB3403-like', 15205),
(15206, 'cd07575', NULL, 'Xc-1258_like', NULL, NULL, 'Xc-1258_like', 15206),
(15207, 'cd09181', NULL, 'PLDc_FAM83A_N', NULL, NULL, 'PLDc_FAM83A_N', 15207),
(15208, 'cd02205', NULL, 'CBS_pair_SF', NULL, NULL, 'CBS_pair_SF', 15208),
(15209, 'cd08505', NULL, 'PBP2_NikA_DppA_OppA_like_18', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_18', 15209),
(15210, 'cd18077', NULL, 'DEXXQc_HELZ', NULL, NULL, 'DEXXQc_HELZ', 15210),
(15211, 'cd19156', NULL, 'AKR_AKR5A1_2', NULL, NULL, 'AKR_AKR5A1_2', 15211),
(15212, 'cd15888', NULL, 'SNARE_SNAP47N', NULL, NULL, 'SNARE_SNAP47N', 15212),
(15213, 'cd08469', NULL, 'PBP2_PnbR', NULL, NULL, 'PBP2_PnbR', 15213),
(15214, 'cd12247', NULL, 'RRM2_U1A_like', NULL, NULL, 'RRM2_U1A_like', 15214),
(15215, 'cd09191', NULL, 'PLDc_DNaseII_alpha_2', NULL, NULL, 'PLDc_DNaseII_alpha_2', 15215),
(15216, 'cd17935', NULL, 'EEXXQc_AQR', NULL, NULL, 'EEXXQc_AQR', 15216),
(15217, 'cd16488', NULL, 'mRING-H2-C3H3C2_Mio_like', NULL, NULL, 'mRING-H2-C3H3C2_Mio_like', 15217),
(15218, 'cd10464', NULL, 'PUB_RNF31', NULL, NULL, 'PUB_RNF31', 15218),
(15219, 'cd18947', NULL, 'bHLH-PAS_ARNT', NULL, NULL, 'bHLH-PAS_ARNT', 15219),
(15220, 'cd08040', NULL, 'OBF_DNA_ligase_family', NULL, NULL, 'OBF_DNA_ligase_family', 15220),
(15221, 'cd11834', NULL, 'SH3_Stac_2', NULL, NULL, 'SH3_Stac_2', 15221),
(15222, 'cd06539', NULL, 'CIDE_N_A', NULL, NULL, 'CIDE_N_A', 15222),
(15223, 'cd00389', NULL, 'microbial_RNases', NULL, NULL, 'microbial_RNases', 15223),
(15224, 'cd12389', NULL, 'RRM2_RAVER', NULL, NULL, 'RRM2_RAVER', 15224),
(15225, 'cd14370', NULL, 'CUE_DMA', NULL, NULL, 'CUE_DMA', 15225),
(15226, 'cd14764', NULL, 'SSDgbs_2', NULL, NULL, 'SSDgbs_2', 15226),
(15227, 'cd02691', NULL, 'PurM-like2', NULL, NULL, 'PurM-like2', 15227),
(15228, 'cd18424', NULL, 'BTB_POZ_KCNV1', NULL, NULL, 'BTB_POZ_KCNV1', 15228),
(15229, 'cd13916', NULL, 'CuRO_HCO_II_like_1', NULL, NULL, 'CuRO_HCO_II_like_1', 15229),
(15230, 'cd09182', NULL, 'PLDc_FAM83B_N', NULL, NULL, 'PLDc_FAM83B_N', 15230),
(15231, 'cd08498', NULL, 'PBP2_NikA_DppA_OppA_like_2', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_2', 15231);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(15232, 'cd17535', NULL, 'REC_NarL-like', NULL, NULL, 'REC_NarL-like', 15232),
(15233, 'cd15653', NULL, 'PHD3_NSD1', NULL, NULL, 'PHD3_NSD1', 15233),
(15234, 'cd08877', NULL, 'START_2', NULL, NULL, 'START_2', 15234),
(15235, 'cd01928', NULL, 'Cyclophilin_PPIL3_like', NULL, NULL, 'Cyclophilin_PPIL3_like', 15235),
(15236, 'cd09937', NULL, 'SH2_csk_like', NULL, NULL, 'SH2_csk_like', 15236),
(15237, 'cd00875', NULL, 'RNA_Cyclase_Class_I', NULL, NULL, 'RNA_Cyclase_Class_I', 15237),
(15238, 'cd09673', NULL, 'Cas3_Cas2_I-F', NULL, NULL, 'Cas3_Cas2_I-F', 15238),
(15239, 'cd15395', NULL, '7tmA_NPY1R', NULL, NULL, '7tmA_NPY1R', 15239),
(15240, 'cd18952', NULL, 'bHLH_TS_HAND1', NULL, NULL, 'bHLH_TS_HAND1', 15240),
(15241, 'cd18360', NULL, 'BTB2_POZ_RHOBTB3', NULL, NULL, 'BTB2_POZ_RHOBTB3', 15241),
(15242, 'cd17978', NULL, 'DEXHc_DHX33', NULL, NULL, 'DEXHc_DHX33', 15242),
(15243, 'cd08656', NULL, 'M28_like', NULL, NULL, 'M28_like', 15243),
(15244, 'cd13349', NULL, 'PH-GRAM1_TBC1D8', NULL, NULL, 'PH-GRAM1_TBC1D8', 15244),
(15245, 'cd16089', NULL, 'IgV_CRIg', NULL, NULL, 'IgV_CRIg', 15245),
(15246, 'cd13840', NULL, 'SMBP_like', NULL, NULL, 'SMBP_like', 15246),
(15247, 'cd14125', NULL, 'STKc_CK1_delta_epsilon', NULL, NULL, 'STKc_CK1_delta_epsilon', 15247),
(15248, 'cd18226', NULL, 'BTB_POZ_ZBTB41', NULL, NULL, 'BTB_POZ_ZBTB41', 15248),
(15249, 'cd14381', NULL, 'UBA2_Rhp23p_like', NULL, NULL, 'UBA2_Rhp23p_like', 15249),
(15250, 'cd00281', NULL, 'DAP_dppA', NULL, NULL, 'DAP_dppA', 15250),
(15251, 'cd04790', NULL, 'HTH_Cfa-like_unk', NULL, NULL, 'HTH_Cfa-like_unk', 15251),
(15252, 'cd12274', NULL, 'RRM2_NEFsp', NULL, NULL, 'RRM2_NEFsp', 15252),
(15253, 'cd03760', NULL, 'proteasome_beta_type_4', NULL, NULL, 'proteasome_beta_type_4', 15253),
(15254, 'cd17116', NULL, 'RA_Radil_like', NULL, NULL, 'RA_Radil_like', 15254),
(15255, 'cd01764', NULL, 'Ubl_Urm1', NULL, NULL, 'Ubl_Urm1', 15255),
(15256, 'cd06575', NULL, 'PASTA_Pbp2x-like_2', NULL, NULL, 'PASTA_Pbp2x-like_2', 15256),
(15257, 'cd16142', NULL, 'ARS_like', NULL, NULL, 'ARS_like', 15257),
(15258, 'cd13697', NULL, 'PBP2_ArtJ_like', NULL, NULL, 'PBP2_ArtJ_like', 15258),
(15259, 'cd17165', NULL, 'RAWUL_PCGF4', NULL, NULL, 'RAWUL_PCGF4', 15259),
(15260, 'cd07485', NULL, 'Peptidases_S8_Fervidolysin_like', NULL, NULL, 'Peptidases_S8_Fervidolysin_like', 15260),
(15261, 'cd02169', NULL, 'Citrate_lyase_ligase', NULL, NULL, 'Citrate_lyase_ligase', 15261),
(15262, 'cd06290', NULL, 'PBP1_LacI-like', NULL, NULL, 'PBP1_LacI-like', 15262),
(15263, 'cd19715', NULL, 'bHLH_TS_amos_like', NULL, NULL, 'bHLH_TS_amos_like', 15263),
(15264, 'cd18586', NULL, 'ABC_6TM_PrtD_like', NULL, NULL, 'ABC_6TM_PrtD_like', 15264),
(15265, 'cd09418', NULL, 'LIM2_Prickle', NULL, NULL, 'LIM2_Prickle', 15265),
(15266, 'cd19043', NULL, 'LGIC_ECD_GABAAR_G1', NULL, NULL, 'LGIC_ECD_GABAAR_G1', 15266),
(15267, 'cd06981', NULL, 'cupin_reut_a1446', NULL, NULL, 'cupin_reut_a1446', 15267),
(15268, 'cd07578', NULL, 'nitrilase_1_R1', NULL, NULL, 'nitrilase_1_R1', 15268),
(15269, 'cd10946', NULL, 'CE4_Mll8295_like', NULL, NULL, 'CE4_Mll8295_like', 15269),
(15270, 'cd07051', NULL, 'BMC_like_1_repeat1', NULL, NULL, 'BMC_like_1_repeat1', 15270),
(15271, 'cd19091', NULL, 'AKR_PsAKR', NULL, NULL, 'AKR_PsAKR', 15271),
(15272, 'cd04785', NULL, 'HTH_CadR-PbrR-like', NULL, NULL, 'HTH_CadR-PbrR-like', 15272),
(15273, 'cd13635', NULL, 'PBP2_Ttha1568_Mqnd', NULL, NULL, 'PBP2_Ttha1568_Mqnd', 15273),
(15274, 'cd02682', NULL, 'MIT_AAA_Arch', NULL, NULL, 'MIT_AAA_Arch', 15274),
(15275, 'cd19380', NULL, 'TGF_beta_GDNF', NULL, NULL, 'TGF_beta_GDNF', 15275),
(15276, 'cd05912', NULL, 'OSB_CoA_lg', NULL, NULL, 'OSB_CoA_lg', 15276),
(15277, 'cd18014', NULL, 'DEXHc_RecQ5', NULL, NULL, 'DEXHc_RecQ5', 15277),
(15278, 'cd12429', NULL, 'RRM_DNAJC17', NULL, NULL, 'RRM_DNAJC17', 15278),
(15279, 'cd05153', NULL, 'HomoserineK_II', NULL, NULL, 'HomoserineK_II', 15279),
(15280, 'cd12481', NULL, 'RRM2_U2B', NULL, NULL, 'RRM2_U2B', 15280),
(15281, 'cd02973', NULL, 'TRX_GRX_like', NULL, NULL, 'TRX_GRX_like', 15281),
(15282, 'cd19394', NULL, 'TGF_beta_GDF10', NULL, NULL, 'TGF_beta_GDF10', 15282);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(15283, 'cd05696', NULL, 'S1_Rrp5_repeat_hs4', NULL, NULL, 'S1_Rrp5_repeat_hs4', 15283),
(15284, 'cd05581', NULL, 'STKc_PDK1', NULL, NULL, 'STKc_PDK1', 15284),
(15285, 'cd11861', NULL, 'SH3_DLG-like', NULL, NULL, 'SH3_DLG-like', 15285),
(15286, 'cd11749', NULL, 'GH94N_LBP_like', NULL, NULL, 'GH94N_LBP_like', 15286),
(15287, 'cd15769', NULL, 'FYVE_CARP1', NULL, NULL, 'FYVE_CARP1', 15287),
(15288, 'cd17158', NULL, 'DCX3_DCDC5', NULL, NULL, 'DCX3_DCDC5', 15288),
(15289, 'cd18751', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, 'PIN_VapC4-5_FitB-like', 15289),
(15290, 'cd10281', NULL, 'Nape_like_AP-endo', NULL, NULL, 'Nape_like_AP-endo', 15290),
(15291, 'cd09156', NULL, 'PLDc_CLS_unchar1_1', NULL, NULL, 'PLDc_CLS_unchar1_1', 15291),
(15292, 'cd04371', NULL, 'DEP', NULL, NULL, 'DEP', 15292),
(15293, 'cd14227', NULL, 'STKc_HIPK2', NULL, NULL, 'STKc_HIPK2', 15293),
(15294, 'cd06642', NULL, 'STKc_STK25', NULL, NULL, 'STKc_STK25', 15294),
(15295, 'cd09334', NULL, 'LIM4_PINCH', NULL, NULL, 'LIM4_PINCH', 15295),
(15296, 'cd08596', NULL, 'PI-PLCc_epsilon', NULL, NULL, 'PI-PLCc_epsilon', 15296),
(15297, 'cd14144', NULL, 'STKc_BMPR1', NULL, NULL, 'STKc_BMPR1', 15297),
(15298, 'cd14494', NULL, 'PTP_DSP_cys', NULL, NULL, 'PTP_DSP_cys', 15298),
(15299, 'cd11837', NULL, 'SH3_Intersectin_2', NULL, NULL, 'SH3_Intersectin_2', 15299),
(15300, 'cd08830', NULL, 'ArfGap_ArfGap1', NULL, NULL, 'ArfGap_ArfGap1', 15300),
(15301, 'cd01233', NULL, 'PH_KIFIA_KIFIB', NULL, NULL, 'PH_KIFIA_KIFIB', 15301),
(15302, 'cd12758', NULL, 'RRM1_hnRPDL', NULL, NULL, 'RRM1_hnRPDL', 15302),
(15303, 'cd00147', NULL, 'cPLA2_like', NULL, NULL, 'cPLA2_like', 15303),
(15304, 'cd16262', NULL, 'EFG_III', NULL, NULL, 'EFG_III', 15304),
(15305, 'cd18960', NULL, 'CD_HP1_like', NULL, NULL, 'CD_HP1_like', 15305),
(15306, 'cd14044', NULL, 'PK_GC-C', NULL, NULL, 'PK_GC-C', 15306),
(15307, 'cd17452', NULL, 'MFS_MFSD2B', NULL, NULL, 'MFS_MFSD2B', 15307),
(15308, 'cd09263', NULL, 'AP_stonin-2_MHD', NULL, NULL, 'AP_stonin-2_MHD', 15308),
(15309, 'cd14082', NULL, 'STKc_PKD', NULL, NULL, 'STKc_PKD', 15309),
(15310, 'cd03715', NULL, 'RT_ZFREV_like', NULL, NULL, 'RT_ZFREV_like', 15310),
(15311, 'cd05795', NULL, 'Ribosomal_P0_L10e', NULL, NULL, 'Ribosomal_P0_L10e', 15311),
(15312, 'cd04156', NULL, 'ARLTS1', NULL, NULL, 'ARLTS1', 15312),
(15313, 'cd14575', NULL, 'DUPD1', NULL, NULL, 'DUPD1', 15313),
(15314, 'cd19190', NULL, 'PR-SET_PRDM5', NULL, NULL, 'PR-SET_PRDM5', 15314),
(15315, 'cd01516', NULL, 'FBPase_glpX', NULL, NULL, 'FBPase_glpX', 15315),
(15316, 'cd01225', NULL, 'PH_Cool_Pix', NULL, NULL, 'PH_Cool_Pix', 15316),
(15317, 'cd11854', NULL, 'SH3_Fus1p', NULL, NULL, 'SH3_Fus1p', 15317),
(15318, 'cd11711', NULL, 'GINS_A_Sld5', NULL, NULL, 'GINS_A_Sld5', 15318),
(15319, 'cd19900', NULL, 'DSRM_A1CF', NULL, NULL, 'DSRM_A1CF', 15319),
(15320, 'cd09473', NULL, 'LIM2_Lhx4', NULL, NULL, 'LIM2_Lhx4', 15320),
(15321, 'cd13760', NULL, 'TGF_beta_BMP2_like', NULL, NULL, 'TGF_beta_BMP2_like', 15321),
(15322, 'cd09580', NULL, 'SAM_Scm-like-4MBT', NULL, NULL, 'SAM_Scm-like-4MBT', 15322),
(15323, 'cd13210', NULL, 'PH-GRAM_MTMR6-like', NULL, NULL, 'PH-GRAM_MTMR6-like', 15323),
(15324, 'cd15005', NULL, '7tmA_SREB-like', NULL, NULL, '7tmA_SREB-like', 15324),
(15325, 'cd04977', NULL, 'Ig1_NCAM-1_like', NULL, NULL, 'Ig1_NCAM-1_like', 15325),
(15326, 'cd17042', NULL, 'Ubl_TmoB', NULL, NULL, 'Ubl_TmoB', 15326),
(15327, 'cd00375', NULL, 'Urease_alpha', NULL, NULL, 'Urease_alpha', 15327),
(15328, 'cd06886', NULL, 'PX_SNX27', NULL, NULL, 'PX_SNX27', 15328),
(15329, 'cd11876', NULL, 'SH3_MLK', NULL, NULL, 'SH3_MLK', 15329),
(15330, 'cd05742', NULL, 'Ig_VEGFR_like', NULL, NULL, 'Ig_VEGFR_like', 15330),
(15331, 'cd18981', NULL, 'CSD_HP1e_insect', NULL, NULL, 'CSD_HP1e_insect', 15331),
(15332, 'cd06430', NULL, 'GT8_like_2', NULL, NULL, 'GT8_like_2', 15332),
(15333, 'cd03515', NULL, 'Link_domain_TSG_6_like', NULL, NULL, 'Link_domain_TSG_6_like', 15333),
(15334, 'cd01926', NULL, 'cyclophilin_ABH_like', NULL, NULL, 'cyclophilin_ABH_like', 15334),
(15335, 'cd02761', NULL, 'MopB_FmdB-FwdB', NULL, NULL, 'MopB_FmdB-FwdB', 15335);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(15336, 'cd11309', NULL, '14-3-3_fungi', NULL, NULL, '14-3-3_fungi', 15336),
(15337, 'cd06223', NULL, 'PRTases_typeI', NULL, NULL, 'PRTases_typeI', 15337),
(15338, 'cd12232', NULL, 'RRM3_U2AF65', NULL, NULL, 'RRM3_U2AF65', 15338),
(15339, 'cd17181', NULL, 'FERM_F0_KIND2', NULL, NULL, 'FERM_F0_KIND2', 15339),
(15340, 'cd08448', NULL, 'PBP2_LTTR_aromatics_like_2', NULL, NULL, 'PBP2_LTTR_aromatics_like_2', 15340),
(15341, 'cd12379', NULL, 'RRM2_I_PABPs', NULL, NULL, 'RRM2_I_PABPs', 15341),
(15342, 'cd02149', NULL, 'NfsB-like', NULL, NULL, 'NfsB-like', 15342),
(15343, 'cd09132', NULL, 'PLDc_unchar4', NULL, NULL, 'PLDc_unchar4', 15343),
(15344, 'cd19693', NULL, 'bHLH_dnHLH_ID3', NULL, NULL, 'bHLH_dnHLH_ID3', 15344),
(15345, 'cd06138', NULL, 'ExoI_N', NULL, NULL, 'ExoI_N', 15345),
(15346, 'cd14473', NULL, 'FERM_B-lobe', NULL, NULL, 'FERM_B-lobe', 15346),
(15347, 'cd12596', NULL, 'RRM1_SRSF6', NULL, NULL, 'RRM1_SRSF6', 15347),
(15348, 'cd01558', NULL, 'D-AAT_like', NULL, NULL, 'D-AAT_like', 15348),
(15349, 'cd11745', NULL, 'Yos9_DD', NULL, NULL, 'Yos9_DD', 15349),
(15350, 'cd14262', NULL, 'VirB5_like', NULL, NULL, 'VirB5_like', 15350),
(15351, 'cd16801', NULL, 'RING-H2_RNF126', NULL, NULL, 'RING-H2_RNF126', 15351),
(15352, 'cd18066', NULL, 'DEXHc_RAD54B', NULL, NULL, 'DEXHc_RAD54B', 15352),
(15353, 'cd19419', NULL, 'lipocalin_L-PGDS', NULL, NULL, 'lipocalin_L-PGDS', 15353),
(15354, 'cd02030', NULL, 'NDUO42', NULL, NULL, 'NDUO42', 15354),
(15355, 'cd01069', NULL, 'PBP2_PheC', NULL, NULL, 'PBP2_PheC', 15355),
(15356, 'cd00834', NULL, 'KAS_I_II', NULL, NULL, 'KAS_I_II', 15356),
(15357, 'cd12099', NULL, 'DD_RII_PKA', NULL, NULL, 'DD_RII_PKA', 15357),
(15358, 'cd18306', NULL, 'BTB_POZ_NS1BP', NULL, NULL, 'BTB_POZ_NS1BP', 15358),
(15359, 'cd16257', NULL, 'EFG_III-like', NULL, NULL, 'EFG_III-like', 15359),
(15360, 'cd19843', NULL, 'Bbox1_TRIM9_C-I', NULL, NULL, 'Bbox1_TRIM9_C-I', 15360),
(15361, 'cd17524', NULL, 'RMtype1_S_EcoUTORF5051P-TRD2-CR2_like', NULL, NULL, 'RMtype1_S_EcoUTORF5051P-TRD2-CR2_like', 15361),
(15362, 'cd15739', NULL, 'FYVE_RABE_unchar', NULL, NULL, 'FYVE_RABE_unchar', 15362),
(15363, 'cd10578', NULL, 'TNFRSF3', NULL, NULL, 'TNFRSF3', 15363),
(15364, 'cd19441', NULL, 'CRABP', NULL, NULL, 'CRABP', 15364),
(15365, 'cd15902', NULL, 'EFh_HEF', NULL, NULL, 'EFh_HEF', 15365),
(15366, 'cd12437', NULL, 'RRM_BRAP2_like', NULL, NULL, 'RRM_BRAP2_like', 15366),
(15367, 'cd15919', NULL, '7tmA_GPR139', NULL, NULL, '7tmA_GPR139', 15367),
(15368, 'cd13556', NULL, 'PBP2_SsuA_like_1', NULL, NULL, 'PBP2_SsuA_like_1', 15368),
(15369, 'cd18803', NULL, 'SF2_C_secA', NULL, NULL, 'SF2_C_secA', 15369),
(15370, 'cd05399', NULL, 'NT_Rel-Spo_like', NULL, NULL, 'NT_Rel-Spo_like', 15370),
(15371, 'cd03020', NULL, 'DsbA_DsbC_DsbG', NULL, NULL, 'DsbA_DsbC_DsbG', 15371),
(15372, 'cd03252', NULL, 'ABCC_Hemolysin', NULL, NULL, 'ABCC_Hemolysin', 15372),
(15373, 'cd00386', NULL, 'Heme_Cu_Oxidase_III_like', NULL, NULL, 'Heme_Cu_Oxidase_III_like', 15373),
(15374, 'cd03862', NULL, 'M14-like', NULL, NULL, 'M14-like', 15374),
(15375, 'cd14966', NULL, '7tmD_STE3', NULL, NULL, '7tmD_STE3', 15375),
(15376, 'cd03591', NULL, 'CLECT_collectin_like', NULL, NULL, 'CLECT_collectin_like', 15376),
(15377, 'cd00155', NULL, 'RasGEF', NULL, NULL, 'RasGEF', 15377),
(15378, 'cd09830', NULL, 'PET_LIMPETin_LIM-9', NULL, NULL, 'PET_LIMPETin_LIM-9', 15378),
(15379, 'cd09269', NULL, 'deoxyribose_mutarotase', NULL, NULL, 'deoxyribose_mutarotase', 15379),
(15380, 'cd00135', NULL, 'PDGF', NULL, NULL, 'PDGF', 15380),
(15381, 'cd17614', NULL, 'REC_OmpR_YycF-like', NULL, NULL, 'REC_OmpR_YycF-like', 15381),
(15382, 'cd16355', NULL, 'VOC_like', NULL, NULL, 'VOC_like', 15382),
(15383, 'cd04749', NULL, 'Commd1_MURR1', NULL, NULL, 'Commd1_MURR1', 15383),
(15384, 'cd13246', NULL, 'PH_Scd1', NULL, NULL, 'PH_Scd1', 15384),
(15385, 'cd06384', NULL, 'PBP1_NPR_B', NULL, NULL, 'PBP1_NPR_B', 15385),
(15386, 'cd11428', NULL, 'bHLH_TS_NGN', NULL, NULL, 'bHLH_TS_NGN', 15386),
(15387, 'cd09183', NULL, 'PLDc_FAM83C_N', NULL, NULL, 'PLDc_FAM83C_N', 15387),
(15388, 'cd02069', NULL, 'methionine_synthase_B12_BD', NULL, NULL, 'methionine_synthase_B12_BD', 15388); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(15389, 'cd01238', NULL, 'PH_Btk', NULL, NULL, 'PH_Btk', 15389),
(15390, 'cd01672', NULL, 'TMPK', NULL, NULL, 'TMPK', 15390),
(15391, 'cd11388', NULL, 'bHLH_ScINO2_like', NULL, NULL, 'bHLH_ScINO2_like', 15391),
(15392, 'cd18413', NULL, 'BTB_POZ_Shab-like', NULL, NULL, 'BTB_POZ_Shab-like', 15392),
(15393, 'cd14049', NULL, 'STKc_EIF2AK1_HRI', NULL, NULL, 'STKc_EIF2AK1_HRI', 15393),
(15394, 'cd09246', NULL, 'BRO1_Alix_like_1', NULL, NULL, 'BRO1_Alix_like_1', 15394),
(15395, 'cd18645', NULL, 'CD_Cbx4', NULL, NULL, 'CD_Cbx4', 15395),
(15396, 'cd06594', NULL, 'GH31_glucosidase_YihQ', NULL, NULL, 'GH31_glucosidase_YihQ', 15396),
(15397, 'cd18083', NULL, 'aTrm56-like', NULL, NULL, 'aTrm56-like', 15397),
(15398, 'cd01201', NULL, 'PH_BEACH', NULL, NULL, 'PH_BEACH', 15398),
(15399, 'cd12477', NULL, 'RRM1_U1A', NULL, NULL, 'RRM1_U1A', 15399),
(15400, 'cd13684', NULL, 'PBP2_TRAP_Dctp5_like', NULL, NULL, 'PBP2_TRAP_Dctp5_like', 15400),
(15401, 'cd05172', NULL, 'PIKKc_DNA-PK', NULL, NULL, 'PIKKc_DNA-PK', 15401),
(15402, 'cd14325', NULL, 'UBA_RNF31', NULL, NULL, 'UBA_RNF31', 15402),
(15403, 'cd17230', NULL, 'TGS_DRG1', NULL, NULL, 'TGS_DRG1', 15403),
(15404, 'cd17616', NULL, 'REC_OmpR_CtrA', NULL, NULL, 'REC_OmpR_CtrA', 15404),
(15405, 'cd10520', NULL, 'PR-SET_PRDM17', NULL, NULL, 'PR-SET_PRDM17', 15405),
(15406, 'cd04225', NULL, 'CuRO_5_ceruloplasmin', NULL, NULL, 'CuRO_5_ceruloplasmin', 15406),
(15407, 'cd12955', NULL, 'SKA2', NULL, NULL, 'SKA2', 15407),
(15408, 'cd15300', NULL, '7tmA_mAChR_M5', NULL, NULL, '7tmA_mAChR_M5', 15408),
(15409, 'cd09390', NULL, 'LIM2_dLMO', NULL, NULL, 'LIM2_dLMO', 15409),
(15410, 'cd12570', NULL, 'RRM5_MRD1', NULL, NULL, 'RRM5_MRD1', 15410),
(15411, 'cd03559', NULL, 'LGIC_TM', NULL, NULL, 'LGIC_TM', 15411),
(15412, 'cd07424', NULL, 'MPP_PrpA_PrpB', NULL, NULL, 'MPP_PrpA_PrpB', 15412),
(15413, 'cd05733', NULL, 'Ig_L1-CAM_like', NULL, NULL, 'Ig_L1-CAM_like', 15413),
(15414, 'cd16784', NULL, 'mRING-HC-C2H2C4_MDM4', NULL, NULL, 'mRING-HC-C2H2C4_MDM4', 15414),
(15415, 'cd05822', NULL, 'TLP_HIUase', NULL, NULL, 'TLP_HIUase', 15415),
(15416, 'cd03285', NULL, 'ABC_MSH2_euk', NULL, NULL, 'ABC_MSH2_euk', 15416),
(15417, 'cd13570', NULL, 'PBP2_TAXI_TRAP_like_2', NULL, NULL, 'PBP2_TAXI_TRAP_like_2', 15417),
(15418, 'cd02143', NULL, 'nitroreductase_FeS-like', NULL, NULL, 'nitroreductase_FeS-like', 15418),
(15419, 'cd00273', NULL, 'Chemokine_CXC', NULL, NULL, 'Chemokine_CXC', 15419),
(15420, 'cd07733', NULL, 'YycJ-like_MBL-fold', NULL, NULL, 'YycJ-like_MBL-fold', 15420),
(15421, 'cd03785', NULL, 'GT28_MurG', NULL, NULL, 'GT28_MurG', 15421),
(15422, 'cd17717', NULL, 'BRCT_DNA_ligase_IV_rpt2', NULL, NULL, 'BRCT_DNA_ligase_IV_rpt2', 15422),
(15423, 'cd11856', NULL, 'SH3_p47phox_like', NULL, NULL, 'SH3_p47phox_like', 15423),
(15424, 'cd03408', NULL, 'SPFH_like_u1', NULL, NULL, 'SPFH_like_u1', 15424),
(15425, 'cd10150', NULL, 'CobN_like', NULL, NULL, 'CobN_like', 15425),
(15426, 'cd12415', NULL, 'RRM3_RBM28_like', NULL, NULL, 'RRM3_RBM28_like', 15426),
(15427, 'cd10949', NULL, 'CE4_BsPdaB_like', NULL, NULL, 'CE4_BsPdaB_like', 15427),
(15428, 'cd16235', NULL, 'EFh_SPARC_SPARC', NULL, NULL, 'EFh_SPARC_SPARC', 15428),
(15429, 'cd16732', NULL, 'RING-HC_MKRN4', NULL, NULL, 'RING-HC_MKRN4', 15429),
(15430, 'cd04205', NULL, 'CuRO_2_LCC_like', NULL, NULL, 'CuRO_2_LCC_like', 15430),
(15431, 'cd08327', NULL, 'CARD_RAIDD', NULL, NULL, 'CARD_RAIDD', 15431),
(15432, 'cd12226', NULL, 'RRM_NOL8', NULL, NULL, 'RRM_NOL8', 15432),
(15433, 'cd12398', NULL, 'RRM_CSTF2_RNA15_like', NULL, NULL, 'RRM_CSTF2_RNA15_like', 15433),
(15434, 'cd07506', NULL, 'HAD_like', NULL, NULL, 'HAD_like', 15434),
(15435, 'cd00037', NULL, 'CLECT', NULL, NULL, 'CLECT', 15435),
(15436, 'cd16658', NULL, 'RING-Ubox_UBE4B', NULL, NULL, 'RING-Ubox_UBE4B', 15436),
(15437, 'cd17442', NULL, 'MFS_SVOPL', NULL, NULL, 'MFS_SVOPL', 15437),
(15438, 'cd12256', NULL, 'RRM2_LKAP', NULL, NULL, 'RRM2_LKAP', 15438),
(15439, 'cd15474', NULL, 'Myo5p-like_CBD_fungal', NULL, NULL, 'Myo5p-like_CBD_fungal', 15439),
(15440, 'cd00587', NULL, 'HCP_like', NULL, NULL, 'HCP_like', 15440);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(15441, 'cd03070', NULL, 'PDI_b_ERp44', NULL, NULL, 'PDI_b_ERp44', 15441),
(15442, 'cd05754', NULL, 'Ig_Perlecan_like', NULL, NULL, 'Ig_Perlecan_like', 15442),
(15443, 'cd12539', NULL, 'RRM_U2AF35B', NULL, NULL, 'RRM_U2AF35B', 15443),
(15444, 'cd17914', NULL, 'DExxQc_SF1-N', NULL, NULL, 'DExxQc_SF1-N', 15444),
(15445, 'cd19344', NULL, 'Wnt_Wnt16', NULL, NULL, 'Wnt_Wnt16', 15445),
(15446, 'cd05120', NULL, 'APH_ChoK_like', NULL, NULL, 'APH_ChoK_like', 15446),
(15447, 'cd03531', NULL, 'Rieske_RO_Alpha_KSH', NULL, NULL, 'Rieske_RO_Alpha_KSH', 15447),
(15448, 'cd16976', NULL, 'HATPase_HupT_MifS-like', NULL, NULL, 'HATPase_HupT_MifS-like', 15448),
(15449, 'cd19193', NULL, 'PR-SET_PRDM7_9', NULL, NULL, 'PR-SET_PRDM7_9', 15449),
(15450, 'cd14128', NULL, 'STKc_CK1_alpha', NULL, NULL, 'STKc_CK1_alpha', 15450),
(15451, 'cd02027', NULL, 'APSK', NULL, NULL, 'APSK', 15451),
(15452, 'cd14380', NULL, 'UBA2_Rad23', NULL, NULL, 'UBA2_Rad23', 15452),
(15453, 'cd13533', NULL, 'PBP2_Yhfz', NULL, NULL, 'PBP2_Yhfz', 15453),
(15454, 'cd17965', NULL, 'DEADc_MRH4', NULL, NULL, 'DEADc_MRH4', 15454),
(15455, 'cd13309', NULL, 'PH_SKIP', NULL, NULL, 'PH_SKIP', 15455),
(15456, 'cd00208', NULL, 'LbetaH', NULL, NULL, 'LbetaH', 15456),
(15457, 'cd15493', NULL, 'PHD_JMJD2', NULL, NULL, 'PHD_JMJD2', 15457),
(15458, 'cd01780', NULL, 'RA2_PLC-epsilon', NULL, NULL, 'RA2_PLC-epsilon', 15458),
(15459, 'cd12554', NULL, 'RRM1_RBM15B', NULL, NULL, 'RRM1_RBM15B', 15459),
(15460, 'cd00066', NULL, 'G-alpha', NULL, NULL, 'G-alpha', 15460),
(15461, 'cd20314', NULL, 'DSRM_EIF2AK2', NULL, NULL, 'DSRM_EIF2AK2', 15461),
(15462, 'cd18768', NULL, 'PIN_MtVapC4-C5-like', NULL, NULL, 'PIN_MtVapC4-C5-like', 15462),
(15463, 'cd05815', NULL, 'CBM20_DPE2_repeat1', NULL, NULL, 'CBM20_DPE2_repeat1', 15463),
(15464, 'cd12724', NULL, 'RRM1_CPEB2_like', NULL, NULL, 'RRM1_CPEB2_like', 15464),
(15465, 'cd16721', NULL, 'RING-HC_MEX3B', NULL, NULL, 'RING-HC_MEX3B', 15465),
(15466, 'cd19823', NULL, 'Bbox2_MID2_C-I', NULL, NULL, 'Bbox2_MID2_C-I', 15466),
(15467, 'cd17160', NULL, 'UBX_UBXN2A', NULL, NULL, 'UBX_UBXN2A', 15467),
(15468, 'cd18577', NULL, 'ABC_6TM_Pgp_ABCB1_D1_like', NULL, NULL, 'ABC_6TM_Pgp_ABCB1_D1_like', 15468),
(15469, 'cd15221', NULL, '7tmA_OR52B-like', NULL, NULL, '7tmA_OR52B-like', 15469),
(15470, 'cd17979', NULL, 'DEXHc_DHX34', NULL, NULL, 'DEXHc_DHX34', 15470),
(15471, 'cd00087', NULL, 'FReD', NULL, NULL, 'FReD', 15471),
(15472, 'cd01146', NULL, 'FhuD', NULL, NULL, 'FhuD', 15472),
(15473, 'cd07369', NULL, 'PydA_Rs_like', NULL, NULL, 'PydA_Rs_like', 15473),
(15474, 'cd14623', NULL, 'R-PTPc-A-2', NULL, NULL, 'R-PTPc-A-2', 15474),
(15475, 'cd04693', NULL, 'Nudix_Hydrolase_34', NULL, NULL, 'Nudix_Hydrolase_34', 15475),
(15476, 'cd03746', NULL, 'SOCS_WSB1_SWIP1', NULL, NULL, 'SOCS_WSB1_SWIP1', 15476),
(15477, 'cd04016', NULL, 'C2_Tollip', NULL, NULL, 'C2_Tollip', 15477),
(15478, 'cd08592', NULL, 'PI-PLCc_gamma', NULL, NULL, 'PI-PLCc_gamma', 15478),
(15479, 'cd00332', NULL, 'PAL-HAL', NULL, NULL, 'PAL-HAL', 15479),
(15480, 'cd19775', NULL, 'Bbox2_TIF1_C-VI', NULL, NULL, 'Bbox2_TIF1_C-VI', 15480),
(15481, 'cd02345', NULL, 'ZZ_dah', NULL, NULL, 'ZZ_dah', 15481),
(15482, 'cd19990', NULL, 'PBP1_GABAb_receptor_plant', NULL, NULL, 'PBP1_GABAb_receptor_plant', 15482),
(15483, 'cd15725', NULL, 'FYVE_PIKfyve_Fab1', NULL, NULL, 'FYVE_PIKfyve_Fab1', 15483),
(15484, 'cd19542', NULL, 'CT_NRPS-like', NULL, NULL, 'CT_NRPS-like', 15484),
(15485, 'cd19757', NULL, 'Bbox1', NULL, NULL, 'Bbox1', 15485),
(15486, 'cd17204', NULL, 'FERM_F1_EPB41L4B', NULL, NULL, 'FERM_F1_EPB41L4B', 15486),
(15487, 'cd16729', NULL, 'RING-HC_RGLG_plant', NULL, NULL, 'RING-HC_RGLG_plant', 15487),
(15488, 'cd09631', NULL, 'DOMON_DOH', NULL, NULL, 'DOMON_DOH', 15488),
(15489, 'cd15561', NULL, 'PHD1_PHF14', NULL, NULL, 'PHD1_PHF14', 15489),
(15490, 'cd09013', NULL, 'BphC-JF8_N_like', NULL, NULL, 'BphC-JF8_N_like', 15490),
(15491, 'cd00493', NULL, 'FabA_FabZ', NULL, NULL, 'FabA_FabZ', 15491),
(15492, 'cd01431', NULL, 'P-type_ATPases', NULL, NULL, 'P-type_ATPases', 15492),
(15493, 'cd09988', NULL, 'Formimidoylglutamase', NULL, NULL, 'Formimidoylglutamase', 15493);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(15494, 'cd18305', NULL, 'BTB_POZ_GCL', NULL, NULL, 'BTB_POZ_GCL', 15494),
(15495, 'cd16389', NULL, 'FIN', NULL, NULL, 'FIN', 15495),
(15496, 'cd06417', NULL, 'GH25_LysA-like', NULL, NULL, 'GH25_LysA-like', 15496),
(15497, 'cd06868', NULL, 'PX_HS1BP3', NULL, NULL, 'PX_HS1BP3', 15497),
(15498, 'cd07711', NULL, 'MBLAC1-like_MBL-fold', NULL, NULL, 'MBLAC1-like_MBL-fold', 15498),
(15499, 'cd06998', NULL, 'cupin_D-LI-like', NULL, NULL, 'cupin_D-LI-like', 15499),
(15500, 'cd02009', NULL, 'TPP_SHCHC_synthase', NULL, NULL, 'TPP_SHCHC_synthase', 15500),
(15501, 'cd08855', NULL, 'ArfGap_AGAP3', NULL, NULL, 'ArfGap_AGAP3', 15501),
(15502, 'cd05328', NULL, '3alpha_HSD_SDR_c', NULL, NULL, '3alpha_HSD_SDR_c', 15502),
(15503, 'cd15761', NULL, 'FYVE1_Vac1p_like', NULL, NULL, 'FYVE1_Vac1p_like', 15503),
(15504, 'cd18270', NULL, 'BTB_POZ_KBTBD2_BKLHD1', NULL, NULL, 'BTB_POZ_KBTBD2_BKLHD1', 15504),
(15505, 'cd16918', NULL, 'HATPase_Glnl-NtrB-like', NULL, NULL, 'HATPase_Glnl-NtrB-like', 15505),
(15506, 'cd09904', NULL, 'H3TH_XPG', NULL, NULL, 'H3TH_XPG', 15506),
(15507, 'cd16894', NULL, 'MltD-like', NULL, NULL, 'MltD-like', 15507),
(15508, 'cd17462', NULL, 'MFS_SLCO4A_OATP4A', NULL, NULL, 'MFS_SLCO4A_OATP4A', 15508),
(15509, 'cd13320', NULL, 'PH_OCRL-like', NULL, NULL, 'PH_OCRL-like', 15509),
(15510, 'cd08689', NULL, 'C2_fungal_Pkc1p', NULL, NULL, 'C2_fungal_Pkc1p', 15510),
(15511, 'cd07560', NULL, 'Peptidase_S41_CPP', NULL, NULL, 'Peptidase_S41_CPP', 15511),
(15512, 'cd07661', NULL, 'BAR_ICA69', NULL, NULL, 'BAR_ICA69', 15512),
(15513, 'cd14041', NULL, 'STKc_TLK2', NULL, NULL, 'STKc_TLK2', 15513),
(15514, 'cd00644', NULL, 'HMG-CoA_reductase_classII', NULL, NULL, 'HMG-CoA_reductase_classII', 15514),
(15515, 'cd17211', NULL, 'RA_RGL2', NULL, NULL, 'RA_RGL2', 15515),
(15516, 'cd18513', NULL, 'BACK_KLHL3', NULL, NULL, 'BACK_KLHL3', 15516),
(15517, 'cd15574', NULL, 'PHD_AF10_AF17', NULL, NULL, 'PHD_AF10_AF17', 15517),
(15518, 'cd19909', NULL, 'DSRM_STRBP_rpt1', NULL, NULL, 'DSRM_STRBP_rpt1', 15518),
(15519, 'cd04496', NULL, 'SSB_OBF', NULL, NULL, 'SSB_OBF', 15519),
(15520, 'cd08063', NULL, 'MPN_CSN6', NULL, NULL, 'MPN_CSN6', 15520),
(15521, 'cd08950', NULL, 'KR_fFAS_SDR_c_like', NULL, NULL, 'KR_fFAS_SDR_c_like', 15521),
(15522, 'cd04787', NULL, 'HTH_HMRTR_unk', NULL, NULL, 'HTH_HMRTR_unk', 15522),
(15523, 'cd16666', NULL, 'RING-H2_RNF43_like', NULL, NULL, 'RING-H2_RNF43_like', 15523),
(15524, 'cd18504', NULL, 'BACK_ARIA_like', NULL, NULL, 'BACK_ARIA_like', 15524),
(15525, 'cd15419', NULL, '7tmA_OR9K2-like', NULL, NULL, '7tmA_OR9K2-like', 15525),
(15526, 'cd00808', NULL, 'GluRS_core', NULL, NULL, 'GluRS_core', 15526),
(15527, 'cd06226', NULL, 'M14_CPT_like', NULL, NULL, 'M14_CPT_like', 15527),
(15528, 'cd07205', NULL, 'Pat_PNPLA6_PNPLA7_NTE1_like', NULL, NULL, 'Pat_PNPLA6_PNPLA7_NTE1_like', 15528),
(15529, 'cd04472', NULL, 'S1_PNPase', NULL, NULL, 'S1_PNPase', 15529),
(15530, 'cd02878', NULL, 'GH18_zymocin_alpha', NULL, NULL, 'GH18_zymocin_alpha', 15530),
(15531, 'cd04323', NULL, 'AsnRS_cyto_like_N', NULL, NULL, 'AsnRS_cyto_like_N', 15531),
(15532, 'cd16667', NULL, 'RING-H2_RNF126_like', NULL, NULL, 'RING-H2_RNF126_like', 15532),
(15533, 'cd17318', NULL, 'MFS_SLC17', NULL, NULL, 'MFS_SLC17', 15533),
(15534, 'cd10309', NULL, 'GST_C_GluProRS_N', NULL, NULL, 'GST_C_GluProRS_N', 15534),
(15535, 'cd18431', NULL, 'BRCT_DNA_ligase_III', NULL, NULL, 'BRCT_DNA_ligase_III', 15535),
(15536, 'cd16676', NULL, 'RING-H2_RNF122', NULL, NULL, 'RING-H2_RNF122', 15536),
(15537, 'cd15792', NULL, 'PH1_FGD5', NULL, NULL, 'PH1_FGD5', 15537),
(15538, 'cd00129', NULL, 'PAN_APPLE', NULL, NULL, 'PAN_APPLE', 15538),
(15539, 'cd21525', NULL, 'SUD_C_SARS-CoV_Nsp3', NULL, NULL, 'SUD_C_SARS-CoV_Nsp3', 15539),
(15540, 'cd11712', NULL, 'GINS_A_psf2', NULL, NULL, 'GINS_A_psf2', 15540),
(15541, 'cd12653', NULL, 'RRM3_HuR', NULL, NULL, 'RRM3_HuR', 15541),
(15542, 'cd19087', NULL, 'AKR_AKR12A1_B1_C1', NULL, NULL, 'AKR_AKR12A1_B1_C1', 15542),
(15543, 'cd17961', NULL, 'DEADc_DDX56', NULL, NULL, 'DEADc_DDX56', 15543),
(15544, 'cd15124', NULL, '7tmA_GRPR', NULL, NULL, '7tmA_GRPR', 15544);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(15545, 'cd00293', NULL, 'USP_Like', NULL, NULL, 'USP_Like', 15545),
(15546, 'cd03684', NULL, 'ClC_3_like', NULL, NULL, 'ClC_3_like', 15546),
(15547, 'cd04252', NULL, 'AAK_NAGK-fArgBP', NULL, NULL, 'AAK_NAGK-fArgBP', 15547),
(15548, 'cd11439', NULL, 'bHLH-PAS_SRC', NULL, NULL, 'bHLH-PAS_SRC', 15548),
(15549, 'cd18973', NULL, 'CD_Tf2-1_POL_like', NULL, NULL, 'CD_Tf2-1_POL_like', 15549),
(15550, 'cd01187', NULL, 'INT_tnpB_C_Tn554', NULL, NULL, 'INT_tnpB_C_Tn554', 15550),
(15551, 'cd08691', NULL, 'C2_NEDL1-like', NULL, NULL, 'C2_NEDL1-like', 15551),
(15552, 'cd02004', NULL, 'TPP_BZL_OCoD_HPCL', NULL, NULL, 'TPP_BZL_OCoD_HPCL', 15552),
(15553, 'cd17286', NULL, 'RMtype1_S_Lla161ORF747P_TRD1-CR1_like', NULL, NULL, 'RMtype1_S_Lla161ORF747P_TRD1-CR1_like', 15553),
(15554, 'cd03056', NULL, 'GST_N_4', NULL, NULL, 'GST_N_4', 15554),
(15555, 'cd14784', NULL, 'class1_nsHb-like', NULL, NULL, 'class1_nsHb-like', 15555),
(15556, 'cd17336', NULL, 'MFS_SLCO_OATP', NULL, NULL, 'MFS_SLCO_OATP', 15556),
(15557, 'cd19798', NULL, 'Bbox2_BRAT-like', NULL, NULL, 'Bbox2_BRAT-like', 15557),
(15558, 'cd16434', NULL, 'CheB-CheR_fusion', NULL, NULL, 'CheB-CheR_fusion', 15558),
(15559, 'cd17973', NULL, 'DEXHc_DHX15', NULL, NULL, 'DEXHc_DHX15', 15559),
(15560, 'cd18216', NULL, 'BTB_POZ_ZBTB29-like', NULL, NULL, 'BTB_POZ_ZBTB29-like', 15560),
(15561, 'cd12551', NULL, 'RRM_II_PABPN1L', NULL, NULL, 'RRM_II_PABPN1L', 15561),
(15562, 'cd14852', NULL, 'LD-carboxypeptidase', NULL, NULL, 'LD-carboxypeptidase', 15562),
(15563, 'cd07222', NULL, 'Pat_PNPLA4', NULL, NULL, 'Pat_PNPLA4', 15563),
(15564, 'cd13133', NULL, 'MATE_like_7', NULL, NULL, 'MATE_like_7', 15564),
(15565, 'cd07697', NULL, 'IgC_TCR_gamma', NULL, NULL, 'IgC_TCR_gamma', 15565),
(15566, 'cd08862', NULL, 'SRPBCC_Smu440-like', NULL, NULL, 'SRPBCC_Smu440-like', 15566),
(15567, 'cd01582', NULL, 'Homoaconitase', NULL, NULL, 'Homoaconitase', 15567),
(15568, 'cd03739', NULL, 'SOCS_SOCS5', NULL, NULL, 'SOCS_SOCS5', 15568),
(15569, 'cd16309', NULL, 'BJP-1-like_MBL-B3', NULL, NULL, 'BJP-1-like_MBL-B3', 15569),
(15570, 'cd00168', NULL, 'CAP', NULL, NULL, 'CAP', 15570),
(15571, 'cd10337', NULL, 'SH2_BCAR3', NULL, NULL, 'SH2_BCAR3', 15571),
(15572, 'cd01029', NULL, 'TOPRIM_primases', NULL, NULL, 'TOPRIM_primases', 15572),
(15573, 'cd19025', NULL, 'LGIC_ECD_nAChR_B2', NULL, NULL, 'LGIC_ECD_nAChR_B2', 15573),
(15574, 'cd04318', NULL, 'EcAsnRS_like_N', NULL, NULL, 'EcAsnRS_like_N', 15574),
(15575, 'cd17875', NULL, 'SRP54_G', NULL, NULL, 'SRP54_G', 15575),
(15576, 'cd05868', NULL, 'Ig4_NrCAM', NULL, NULL, 'Ig4_NrCAM', 15576),
(15577, 'cd14206', NULL, 'PTKc_Aatyk3', NULL, NULL, 'PTKc_Aatyk3', 15577),
(15578, 'cd20010', NULL, 'PBP1_AglR-like', NULL, NULL, 'PBP1_AglR-like', 15578),
(15579, 'cd09244', NULL, 'BRO1_Rhophilin', NULL, NULL, 'BRO1_Rhophilin', 15579),
(15580, 'cd17660', NULL, 'PTP_paladin_2', NULL, NULL, 'PTP_paladin_2', 15580),
(15581, 'cd02674', NULL, 'Peptidase_C19R', NULL, NULL, 'Peptidase_C19R', 15581),
(15582, 'cd17659', NULL, 'PTP_paladin_1', NULL, NULL, 'PTP_paladin_1', 15582),
(15583, 'cd12503', NULL, 'RRM1_hnRNPH_GRSF1_like', NULL, NULL, 'RRM1_hnRNPH_GRSF1_like', 15583),
(15584, 'cd19706', NULL, 'bHLH_TS_TAL1', NULL, NULL, 'bHLH_TS_TAL1', 15584),
(15585, 'cd03873', NULL, 'Zinc_peptidase_like', NULL, NULL, 'Zinc_peptidase_like', 15585),
(15586, 'cd00465', NULL, 'URO-D_CIMS_like', NULL, NULL, 'URO-D_CIMS_like', 15586),
(15587, 'cd05874', NULL, 'Ig_NrCAM', NULL, NULL, 'Ig_NrCAM', 15587),
(15588, 'cd13336', NULL, 'FERM-like_C_SNX31', NULL, NULL, 'FERM-like_C_SNX31', 15588),
(15589, 'cd15643', NULL, 'PHD_KDM2A', NULL, NULL, 'PHD_KDM2A', 15589),
(15590, 'cd01383', NULL, 'MYSc_Myo8', NULL, NULL, 'MYSc_Myo8', 15590),
(15591, 'cd14549', NULL, 'R5-PTPc-1', NULL, NULL, 'R5-PTPc-1', 15591),
(15592, 'cd00878', NULL, 'Arf_Arl', NULL, NULL, 'Arf_Arl', 15592),
(15593, 'cd07076', NULL, 'NR_LBD_GR', NULL, NULL, 'NR_LBD_GR', 15593),
(15594, 'cd19132', NULL, 'AKR_AKR5D1_E1', NULL, NULL, 'AKR_AKR5D1_E1', 15594),
(15595, 'cd19168', NULL, 'SET_EZH-like', NULL, NULL, 'SET_EZH-like', 15595);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(15596, 'cd11499', NULL, 'SLC6sbd_GlyT2', NULL, NULL, 'SLC6sbd_GlyT2', 15596),
(15597, 'cd12599', NULL, 'RRM1_SF2_plant_like', NULL, NULL, 'RRM1_SF2_plant_like', 15597),
(15598, 'cd01153', NULL, 'ACAD_fadE5', NULL, NULL, 'ACAD_fadE5', 15598),
(15599, 'cd06547', NULL, 'GH85_ENGase', NULL, NULL, 'GH85_ENGase', 15599),
(15600, 'cd16336', NULL, 'MukE', NULL, NULL, 'MukE', 15600),
(15601, 'cd03548', NULL, 'Rieske_RO_Alpha_OMO_CARDO', NULL, NULL, 'Rieske_RO_Alpha_OMO_CARDO', 15601),
(15602, 'cd06448', NULL, 'L-Ser-dehyd', NULL, NULL, 'L-Ser-dehyd', 15602),
(15603, 'cd14831', NULL, 'AP1_sigma', NULL, NULL, 'AP1_sigma', 15603),
(15604, 'cd16706', NULL, 'RING-HC_CARP1', NULL, NULL, 'RING-HC_CARP1', 15604),
(15605, 'cd15642', NULL, 'PHD_PHF8', NULL, NULL, 'PHD_PHF8', 15605),
(15606, 'cd02188', NULL, 'gamma_tubulin', NULL, NULL, 'gamma_tubulin', 15606),
(15607, 'cd08530', NULL, 'STKc_CNK2-like', NULL, NULL, 'STKc_CNK2-like', 15607),
(15608, 'cd05267', NULL, 'SDR_a6', NULL, NULL, 'SDR_a6', 15608),
(15609, 'cd21534', NULL, 'SARS-CoV-like_E', NULL, NULL, 'SARS-CoV-like_E', 15609),
(15610, 'cd15413', NULL, '7tmA_OR8K-like', NULL, NULL, '7tmA_OR8K-like', 15610),
(15611, 'cd11757', NULL, 'SH3_SH3BP4', NULL, NULL, 'SH3_SH3BP4', 15611),
(15612, 'cd15863', NULL, 'SNARE_GS27', NULL, NULL, 'SNARE_GS27', 15612),
(15613, 'cd07430', NULL, 'GH15_N', NULL, NULL, 'GH15_N', 15613),
(15614, 'cd05810', NULL, 'CBM20_alpha_MTH', NULL, NULL, 'CBM20_alpha_MTH', 15614),
(15615, 'cd17188', NULL, 'FERM_F1_FRMD7', NULL, NULL, 'FERM_F1_FRMD7', 15615),
(15616, 'cd13369', NULL, 'PH_RASAL1', NULL, NULL, 'PH_RASAL1', 15616),
(15617, 'cd12906', NULL, 'SPRY_SOCS1-2-4', NULL, NULL, 'SPRY_SOCS1-2-4', 15617),
(15618, 'cd13129', NULL, 'MATE_epsE_like', NULL, NULL, 'MATE_epsE_like', 15618),
(15619, 'cd09293', NULL, 'AMN1', NULL, NULL, 'AMN1', 15619),
(15620, 'cd06314', NULL, 'PBP1_tmGBP', NULL, NULL, 'PBP1_tmGBP', 15620),
(15621, 'cd17450', NULL, 'MFS_SLC46A2_TSCOT', NULL, NULL, 'MFS_SLC46A2_TSCOT', 15621),
(15622, 'cd16397', NULL, 'IbrB_like', NULL, NULL, 'IbrB_like', 15622),
(15623, 'cd09719', NULL, 'Cas1_I-E', NULL, NULL, 'Cas1_I-E', 15623),
(15624, 'cd00603', NULL, 'IPT_PCSR', NULL, NULL, 'IPT_PCSR', 15624),
(15625, 'cd08955', NULL, 'KR_2_FAS_SDR_x', NULL, NULL, 'KR_2_FAS_SDR_x', 15625),
(15626, 'cd18044', NULL, 'DEXXQc_SMUBP2', NULL, NULL, 'DEXXQc_SMUBP2', 15626),
(15627, 'cd02065', NULL, 'B12-binding_like', NULL, NULL, 'B12-binding_like', 15627),
(15628, 'cd01008', NULL, 'PBP2_NrtA_SsuA_CpmA_like', NULL, NULL, 'PBP2_NrtA_SsuA_CpmA_like', 15628),
(15629, 'cd15535', NULL, 'PHD1_Rco1', NULL, NULL, 'PHD1_Rco1', 15629),
(15630, 'cd19951', NULL, 'HyaA_family_Fer2_BFD-like', NULL, NULL, 'HyaA_family_Fer2_BFD-like', 15630),
(15631, 'cd06221', NULL, 'sulfite_reductase_like', NULL, NULL, 'sulfite_reductase_like', 15631),
(15632, 'cd14625', NULL, 'R-PTPc-S-1', NULL, NULL, 'R-PTPc-S-1', 15632),
(15633, 'cd00036', NULL, 'ChtBD3', NULL, NULL, 'ChtBD3', 15633),
(15634, 'cd11546', NULL, 'NTP-PPase_His4', NULL, NULL, 'NTP-PPase_His4', 15634),
(15635, 'cd19999', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, 'PBP1_ABC_sugar_binding-like', 15635),
(15636, 'cd03229', NULL, 'ABC_Class3', NULL, NULL, 'ABC_Class3', 15636),
(15637, 'cd14284', NULL, 'UBA_GAWKY', NULL, NULL, 'UBA_GAWKY', 15637),
(15638, 'cd04735', NULL, 'OYE_like_4_FMN', NULL, NULL, 'OYE_like_4_FMN', 15638),
(15639, 'cd07277', NULL, 'PX_RUN', NULL, NULL, 'PX_RUN', 15639),
(15640, 'cd15295', NULL, '7tmA_Histamine_H4R', NULL, NULL, '7tmA_Histamine_H4R', 15640),
(15641, 'cd21629', NULL, 'NS6_deltaCoV', NULL, NULL, 'NS6_deltaCoV', 15641),
(15642, 'cd03458', NULL, 'Catechol_intradiol_dioxygenases', NULL, NULL, 'Catechol_intradiol_dioxygenases', 15642),
(15643, 'cd12672', NULL, 'RRM_DAZL', NULL, NULL, 'RRM_DAZL', 15643),
(15644, 'cd11461', NULL, 'bHLH-O_HES5', NULL, NULL, 'bHLH-O_HES5', 15644),
(15645, 'cd12198', NULL, 'MELK_C', NULL, NULL, 'MELK_C', 15645),
(15646, 'cd14591', NULL, 'PTP-MTM1', NULL, NULL, 'PTP-MTM1', 15646),
(15647, 'cd15820', NULL, 'SPRY_PRY_BTN3', NULL, NULL, 'SPRY_PRY_BTN3', 15647);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(15648, 'cd05227', NULL, 'AR_SDR_e', NULL, NULL, 'AR_SDR_e', 15648),
(15649, 'cd15060', NULL, '7tmA_tyramine_octopamine_R-like', NULL, NULL, '7tmA_tyramine_octopamine_R-like', 15649),
(15650, 'cd02558', NULL, 'PSRA_1', NULL, NULL, 'PSRA_1', 15650),
(15651, 'cd13334', NULL, 'FERM_C_JAK3', NULL, NULL, 'FERM_C_JAK3', 15651),
(15652, 'cd14987', NULL, '7tmA_ACKR3_CXCR7', NULL, NULL, '7tmA_ACKR3_CXCR7', 15652),
(15653, 'cd18217', NULL, 'BTB_POZ_ZBTB31_myoneurin', NULL, NULL, 'BTB_POZ_ZBTB31_myoneurin', 15653),
(15654, 'cd19384', NULL, 'TGF_beta_TGFB1', NULL, NULL, 'TGF_beta_TGFB1', 15654),
(15655, 'cd13208', NULL, 'PH-GRAM_MTMR5_MTMR13', NULL, NULL, 'PH-GRAM_MTMR5_MTMR13', 15655),
(15656, 'cd01728', NULL, 'LSm1', NULL, NULL, 'LSm1', 15656),
(15657, 'cd07420', NULL, 'MPP_RdgC', NULL, NULL, 'MPP_RdgC', 15657),
(15658, 'cd05338', NULL, 'DHRS1_HSDL2-like_SDR_c', NULL, NULL, 'DHRS1_HSDL2-like_SDR_c', 15658),
(15659, 'cd21635', NULL, 'ORF7b_SARS-CoV-like', NULL, NULL, 'ORF7b_SARS-CoV-like', 15659),
(15660, 'cd11992', NULL, 'SH3_Intersectin2_3', NULL, NULL, 'SH3_Intersectin2_3', 15660),
(15661, 'cd13280', NULL, 'PH_SIP3', NULL, NULL, 'PH_SIP3', 15661),
(15662, 'cd07209', NULL, 'Pat_hypo_Ecoli_Z1214_like', NULL, NULL, 'Pat_hypo_Ecoli_Z1214_like', 15662),
(15663, 'cd16279', NULL, 'metallo-hydrolase-like_MBL-fold', NULL, NULL, 'metallo-hydrolase-like_MBL-fold', 15663),
(15664, 'cd01651', NULL, 'RT_G2_intron', NULL, NULL, 'RT_G2_intron', 15664),
(15665, 'cd03886', NULL, 'M20_Acy1', NULL, NULL, 'M20_Acy1', 15665),
(15666, 'cd14343', NULL, 'UBA_F100B_like', NULL, NULL, 'UBA_F100B_like', 15666),
(15667, 'cd14137', NULL, 'STKc_GSK3', NULL, NULL, 'STKc_GSK3', 15667),
(15668, 'cd18058', NULL, 'DEXHc_CHD6', NULL, NULL, 'DEXHc_CHD6', 15668),
(15669, 'cd14547', NULL, 'PTPc-KIM', NULL, NULL, 'PTPc-KIM', 15669),
(15670, 'cd15669', NULL, 'ePHD_PHF7_G2E3_like', NULL, NULL, 'ePHD_PHF7_G2E3_like', 15670),
(15671, 'cd16475', NULL, 'RING-H2_RNF121_like', NULL, NULL, 'RING-H2_RNF121_like', 15671),
(15672, 'cd13312', NULL, 'PH_USP37_like', NULL, NULL, 'PH_USP37_like', 15672),
(15673, 'cd15889', NULL, 'SNARE_SNAP25N_23N', NULL, NULL, 'SNARE_SNAP25N_23N', 15673),
(15674, 'cd02037', NULL, 'Mrp_NBP35', NULL, NULL, 'Mrp_NBP35', 15674),
(15675, 'cd08612', NULL, 'GDPD_GDE4', NULL, NULL, 'GDPD_GDE4', 15675),
(15676, 'cd13685', NULL, 'PBP2_iGluR_non_NMDA_like', NULL, NULL, 'PBP2_iGluR_non_NMDA_like', 15676),
(15677, 'cd09266', NULL, 'SGIP1_MHD', NULL, NULL, 'SGIP1_MHD', 15677),
(15678, 'cd05893', NULL, 'Ig_Palladin_C', NULL, NULL, 'Ig_Palladin_C', 15678),
(15679, 'cd19716', NULL, 'bHLH_TS_NGN1_NeuroD3', NULL, NULL, 'bHLH_TS_NGN1_NeuroD3', 15679),
(15680, 'cd14244', NULL, 'GH_101_like', NULL, NULL, 'GH_101_like', 15680),
(15681, 'cd09365', NULL, 'LIM2_LIMK', NULL, NULL, 'LIM2_LIMK', 15681),
(15682, 'cd01490', NULL, 'Ube1_repeat2', NULL, NULL, 'Ube1_repeat2', 15682),
(15683, 'cd02133', NULL, 'PA_C5a_like', NULL, NULL, 'PA_C5a_like', 15683),
(15684, 'cd17766', NULL, 'futalosine_nucleosidase_MqnB', NULL, NULL, 'futalosine_nucleosidase_MqnB', 15684),
(15685, 'cd14439', NULL, 'AlgX_N_like', NULL, NULL, 'AlgX_N_like', 15685),
(15686, 'cd07758', NULL, 'ThTPase', NULL, NULL, 'ThTPase', 15686),
(15687, 'cd14008', NULL, 'STKc_LKB1_CaMKK', NULL, NULL, 'STKc_LKB1_CaMKK', 15687),
(15688, 'cd02038', NULL, 'FlhG-like', NULL, NULL, 'FlhG-like', 15688),
(15689, 'cd08269', NULL, 'Zn_ADH9', NULL, NULL, 'Zn_ADH9', 15689),
(15690, 'cd07798', NULL, 'FGGY_AI-2K_like', NULL, NULL, 'FGGY_AI-2K_like', 15690),
(15691, 'cd13207', NULL, 'FERM-like_C_SNX', NULL, NULL, 'FERM-like_C_SNX', 15691),
(15692, 'cd14663', NULL, 'STKc_SnRK3', NULL, NULL, 'STKc_SnRK3', 15692),
(15693, 'cd11960', NULL, 'SH3_Abp1_eu', NULL, NULL, 'SH3_Abp1_eu', 15693),
(15694, 'cd05266', NULL, 'SDR_a4', NULL, NULL, 'SDR_a4', 15694),
(15695, 'cd03600', NULL, 'CLECT_thrombomodulin_like', NULL, NULL, 'CLECT_thrombomodulin_like', 15695),
(15696, 'cd18338', NULL, 'BTB_POZ_KLHL2_Mayven', NULL, NULL, 'BTB_POZ_KLHL2_Mayven', 15696),
(15697, 'cd00926', NULL, 'Cyt_c_Oxidase_VIb', NULL, NULL, 'Cyt_c_Oxidase_VIb', 15697);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(15698, 'cd06813', NULL, 'PLPDE_III_DSD_D-TA_like_2', NULL, NULL, 'PLPDE_III_DSD_D-TA_like_2', 15698),
(15699, 'cd14720', NULL, 'bZIP_NFE2-like', NULL, NULL, 'bZIP_NFE2-like', 15699),
(15700, 'cd16398', NULL, 'KorB_N_like', NULL, NULL, 'KorB_N_like', 15700),
(15701, 'cd07252', NULL, 'BphC1-RGP6_N_like', NULL, NULL, 'BphC1-RGP6_N_like', 15701),
(15702, 'cd05009', NULL, 'SIS_GlmS_GlmD_2', NULL, NULL, 'SIS_GlmS_GlmD_2', 15702),
(15703, 'cd04639', NULL, 'CBS_pair_peptidase_M50', NULL, NULL, 'CBS_pair_peptidase_M50', 15703),
(15704, 'cd08361', NULL, 'PpCmtC_N', NULL, NULL, 'PpCmtC_N', 15704),
(15705, 'cd12211', NULL, 'Bc2l-C_N', NULL, NULL, 'Bc2l-C_N', 15705),
(15706, 'cd11242', NULL, 'Sema_6', NULL, NULL, 'Sema_6', 15706),
(15707, 'cd12289', NULL, 'RRM_LARP6', NULL, NULL, 'RRM_LARP6', 15707),
(15708, 'cd16535', NULL, 'RING-HC_RNF8', NULL, NULL, 'RING-HC_RNF8', 15708),
(15709, 'cd08367', NULL, 'P53', NULL, NULL, 'P53', 15709),
(15710, 'cd13843', NULL, 'Azurin_like', NULL, NULL, 'Azurin_like', 15710),
(15711, 'cd18246', NULL, 'BTB_POZ_KLHL17_actinfilin', NULL, NULL, 'BTB_POZ_KLHL17_actinfilin', 15711),
(15712, 'cd07405', NULL, 'MPP_UshA_N', NULL, NULL, 'MPP_UshA_N', 15712),
(15713, 'cd13889', NULL, 'CuRO_3_BOD', NULL, NULL, 'CuRO_3_BOD', 15713),
(15714, 'cd15200', NULL, '7tmA_OXER1', NULL, NULL, '7tmA_OXER1', 15714),
(15715, 'cd05191', NULL, 'NAD_bind_amino_acid_DH', NULL, NULL, 'NAD_bind_amino_acid_DH', 15715),
(15716, 'cd01773', NULL, 'UBX_UBXN7', NULL, NULL, 'UBX_UBXN7', 15716),
(15717, 'cd09220', NULL, 'GH64-GluB-like', NULL, NULL, 'GH64-GluB-like', 15717),
(15718, 'cd00171', NULL, 'Sec7', NULL, NULL, 'Sec7', 15718),
(15719, 'cd07267', NULL, 'THT_Oxygenase_N', NULL, NULL, 'THT_Oxygenase_N', 15719),
(15720, 'cd03875', NULL, 'M28_Fxna_like', NULL, NULL, 'M28_Fxna_like', 15720),
(15721, 'cd11278', NULL, 'Sema_MET', NULL, NULL, 'Sema_MET', 15721),
(15722, 'cd14923', NULL, 'MYSc_Myh13', NULL, NULL, 'MYSc_Myh13', 15722),
(15723, 'cd16603', NULL, 'RING-HC_TRIM43_like_C-IV', NULL, NULL, 'RING-HC_TRIM43_like_C-IV', 15723),
(15724, 'cd07810', NULL, 'FGGY_D-XK_2', NULL, NULL, 'FGGY_D-XK_2', 15724),
(15725, 'cd20008', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, 'PBP1_ABC_sugar_binding-like', 15725),
(15726, 'cd15217', NULL, '7tmA_SREB3_GPR173', NULL, NULL, '7tmA_SREB3_GPR173', 15726),
(15727, 'cd16920', NULL, 'HATPase_TmoS-FixL-DctS-like', NULL, NULL, 'HATPase_TmoS-FixL-DctS-like', 15727),
(15728, 'cd08197', NULL, 'DOIS', NULL, NULL, 'DOIS', 15728),
(15729, 'cd06597', NULL, 'GH31_transferase_CtsY', NULL, NULL, 'GH31_transferase_CtsY', 15729),
(15730, 'cd15445', NULL, '7tmB1_CRF-R1', NULL, NULL, '7tmB1_CRF-R1', 15730),
(15731, 'cd00267', NULL, 'ABC_ATPase', NULL, NULL, 'ABC_ATPase', 15731),
(15732, 'cd14644', NULL, 'DSP_DUSP9', NULL, NULL, 'DSP_DUSP9', 15732),
(15733, 'cd06116', NULL, 'CaCS_like', NULL, NULL, 'CaCS_like', 15733),
(15734, 'cd06185', NULL, 'PDR_like', NULL, NULL, 'PDR_like', 15734),
(15735, 'cd15347', NULL, '7tmA_S1PR2_Edg5', NULL, NULL, '7tmA_S1PR2_Edg5', 15735),
(15736, 'cd16245', NULL, 'EFh_DAH', NULL, NULL, 'EFh_DAH', 15736),
(15737, 'cd14031', NULL, 'STKc_WNK3', NULL, NULL, 'STKc_WNK3', 15737),
(15738, 'cd19151', NULL, 'AKR_AKR14A2', NULL, NULL, 'AKR_AKR14A2', 15738),
(15739, 'cd17738', NULL, 'BRCT_TopBP1_rpt7', NULL, NULL, 'BRCT_TopBP1_rpt7', 15739),
(15740, 'cd12664', NULL, 'RRM1_RAVER2', NULL, NULL, 'RRM1_RAVER2', 15740),
(15741, 'cd10844', NULL, 'DSRM_TARBP2_rpt2', NULL, NULL, 'DSRM_TARBP2_rpt2', 15741),
(15742, 'cd07124', NULL, 'ALDH_PutA-P5CDH-RocA', NULL, NULL, 'ALDH_PutA-P5CDH-RocA', 15742),
(15743, 'cd17968', NULL, 'DEAHc_DDX11_starthere', NULL, NULL, 'DEAHc_DDX11_starthere', 15743),
(15744, 'cd03298', NULL, 'ABC_ThiQ_thiamine_transporter', NULL, NULL, 'ABC_ThiQ_thiamine_transporter', 15744),
(15745, 'cd07938', NULL, 'DRE_TIM_HMGL', NULL, NULL, 'DRE_TIM_HMGL', 15745),
(15746, 'cd06619', NULL, 'PKc_MKK5', NULL, NULL, 'PKc_MKK5', 15746),
(15747, 'cd11897', NULL, 'SH3_SNX18', NULL, NULL, 'SH3_SNX18', 15747),
(15748, 'cd00301', NULL, 'lipocalin_FABP', NULL, NULL, 'lipocalin_FABP', 15748);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(15749, 'cd04147', NULL, 'Ras_dva', NULL, NULL, 'Ras_dva', 15749),
(15750, 'cd08831', NULL, 'ArfGap_ArfGap2_3_like', NULL, NULL, 'ArfGap_ArfGap2_3_like', 15750),
(15751, 'cd19950', NULL, 'Fer2_BFD-like', NULL, NULL, 'Fer2_BFD-like', 15751),
(15752, 'cd20302', NULL, 'cupin_DAD', NULL, NULL, 'cupin_DAD', 15752),
(15753, 'cd08564', NULL, 'GDPD_GsGDE_like', NULL, NULL, 'GDPD_GsGDE_like', 15753),
(15754, 'cd08419', NULL, 'PBP2_CbbR_RubisCO_like', NULL, NULL, 'PBP2_CbbR_RubisCO_like', 15754),
(15755, 'cd07655', NULL, 'F-BAR_PACSIN', NULL, NULL, 'F-BAR_PACSIN', 15755),
(15756, 'cd17170', NULL, 'FERM_F1_FRMPD4', NULL, NULL, 'FERM_F1_FRMPD4', 15756),
(15757, 'cd05364', NULL, 'SDR_c11', NULL, NULL, 'SDR_c11', 15757),
(15758, 'cd12280', NULL, 'RRM_FET', NULL, NULL, 'RRM_FET', 15758),
(15759, 'cd04934', NULL, 'ACT_AK-Hom3_1', NULL, NULL, 'ACT_AK-Hom3_1', 15759),
(15760, 'cd10402', NULL, 'SH2_C-SH2_Zap70', NULL, NULL, 'SH2_C-SH2_Zap70', 15760),
(15761, 'cd04976', NULL, 'Ig_VEGFR', NULL, NULL, 'Ig_VEGFR', 15761),
(15762, 'cd08193', NULL, 'HVD', NULL, NULL, 'HVD', 15762),
(15763, 'cd10576', NULL, 'TNFRSF1A', NULL, NULL, 'TNFRSF1A', 15763),
(15764, 'cd16029', NULL, '4-S', NULL, NULL, '4-S', 15764),
(15765, 'cd12100', NULL, 'DD_CABYR_SP17', NULL, NULL, 'DD_CABYR_SP17', 15765),
(15766, 'cd10932', NULL, 'CE4_u8', NULL, NULL, 'CE4_u8', 15766),
(15767, 'cd06964', NULL, 'NR_DBD_RAR', NULL, NULL, 'NR_DBD_RAR', 15767),
(15768, 'cd07392', NULL, 'MPP_PAE1087', NULL, NULL, 'MPP_PAE1087', 15768),
(15769, 'cd13155', NULL, 'KOW_KIN17', NULL, NULL, 'KOW_KIN17', 15769),
(15770, 'cd09092', NULL, 'INPP5A', NULL, NULL, 'INPP5A', 15770),
(15771, 'cd07207', NULL, 'Pat_ExoU_VipD_like', NULL, NULL, 'Pat_ExoU_VipD_like', 15771),
(15772, 'cd15840', NULL, 'SNARE_Qa', NULL, NULL, 'SNARE_Qa', 15772),
(15773, 'cd17730', NULL, 'BRCT_PAXIP1_rpt4', NULL, NULL, 'BRCT_PAXIP1_rpt4', 15773),
(15774, 'cd12267', NULL, 'RRM_YRA1_MLO3', NULL, NULL, 'RRM_YRA1_MLO3', 15774),
(15775, 'cd20185', NULL, 'M34_PABD', NULL, NULL, 'M34_PABD', 15775),
(15776, 'cd21160', NULL, 'NendoU_av_Nsp11-like', NULL, NULL, 'NendoU_av_Nsp11-like', 15776),
(15777, 'cd15731', NULL, 'FYVE_LST2', NULL, NULL, 'FYVE_LST2', 15777),
(15778, 'cd02020', NULL, 'CMPK', NULL, NULL, 'CMPK', 15778),
(15779, 'cd10573', NULL, 'PH_DAPP1', NULL, NULL, 'PH_DAPP1', 15779),
(15780, 'cd16592', NULL, 'RING-HC_TRIM7_C-IV', NULL, NULL, 'RING-HC_TRIM7_C-IV', 15780),
(15781, 'cd04414', NULL, 'NDPk6', NULL, NULL, 'NDPk6', 15781),
(15782, 'cd17034', NULL, 'T3SC_IA_ShcO1-like', NULL, NULL, 'T3SC_IA_ShcO1-like', 15782),
(15783, 'cd18195', NULL, 'BTB_POZ_ZBTB4', NULL, NULL, 'BTB_POZ_ZBTB4', 15783),
(15784, 'cd06274', NULL, 'PBP1_FruR', NULL, NULL, 'PBP1_FruR', 15784),
(15785, 'cd09469', NULL, 'LIM1_Lhx2', NULL, NULL, 'LIM1_Lhx2', 15785),
(15786, 'cd12350', NULL, 'RRM3_SHARP', NULL, NULL, 'RRM3_SHARP', 15786),
(15787, 'cd17191', NULL, 'FERM_F1_PTPN14', NULL, NULL, 'FERM_F1_PTPN14', 15787),
(15788, 'cd04861', NULL, 'LigD_Pol_like', NULL, NULL, 'LigD_Pol_like', 15788),
(15789, 'cd01823', NULL, 'SEST_like', NULL, NULL, 'SEST_like', 15789),
(15790, 'cd12035', NULL, 'SH3_MPP1-like', NULL, NULL, 'SH3_MPP1-like', 15790),
(15791, 'cd12497', NULL, 'RRM3_RBM47', NULL, NULL, 'RRM3_RBM47', 15791),
(15792, 'cd13682', NULL, 'PBP2_TRAP_alpha-ketoacid', NULL, NULL, 'PBP2_TRAP_alpha-ketoacid', 15792),
(15793, 'cd17038', NULL, 'Flavi_M', NULL, NULL, 'Flavi_M', 15793),
(15794, 'cd01228', NULL, 'PH_BCR-related', NULL, NULL, 'PH_BCR-related', 15794),
(15795, 'cd18348', NULL, 'BTB_POZ_BTBD3', NULL, NULL, 'BTB_POZ_BTBD3', 15795),
(15796, 'cd14997', NULL, '7tmA_ETH-R', NULL, NULL, '7tmA_ETH-R', 15796),
(15797, 'cd12922', NULL, 'VKOR_5', NULL, NULL, 'VKOR_5', 15797),
(15798, 'cd13303', NULL, 'PH1-like_Rtt106', NULL, NULL, 'PH1-like_Rtt106', 15798),
(15799, 'cd17744', NULL, 'BRCT_MDC1_rpt1', NULL, NULL, 'BRCT_MDC1_rpt1', 15799),
(15800, 'cd00945', NULL, 'Aldolase_Class_I', NULL, NULL, 'Aldolase_Class_I', 15800),
(15801, 'cd13141', NULL, 'MATE_like_13', NULL, NULL, 'MATE_like_13', 15801),
(15802, 'cd12409', NULL, 'RRM1_RRT5', NULL, NULL, 'RRM1_RRT5', 15802);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(15803, 'cd14093', NULL, 'STKc_PhKG', NULL, NULL, 'STKc_PhKG', 15803),
(15804, 'cd05313', NULL, 'NAD_bind_2_Glu_DH', NULL, NULL, 'NAD_bind_2_Glu_DH', 15804),
(15805, 'cd02513', NULL, 'CMP-NeuAc_Synthase', NULL, NULL, 'CMP-NeuAc_Synthase', 15805),
(15806, 'cd19065', NULL, 'LGIC_TM_ZAC', NULL, NULL, 'LGIC_TM_ZAC', 15806),
(15807, 'cd12305', NULL, 'RRM_NELFE', NULL, NULL, 'RRM_NELFE', 15807),
(15808, 'cd15816', NULL, 'SPRY_PRY_TRIM58', NULL, NULL, 'SPRY_PRY_TRIM58', 15808),
(15809, 'cd19406', NULL, 'TGF_beta_INHBC_E', NULL, NULL, 'TGF_beta_INHBC_E', 15809),
(15810, 'cd12547', NULL, 'RRM1_2_PAR10', NULL, NULL, 'RRM1_2_PAR10', 15810),
(15811, 'cd04815', NULL, 'PA_M28_2', NULL, NULL, 'PA_M28_2', 15811),
(15812, 'cd05808', NULL, 'CBM20_alpha_amylase', NULL, NULL, 'CBM20_alpha_amylase', 15812),
(15813, 'cd01757', NULL, 'PLAT_RAB6IP1', NULL, NULL, 'PLAT_RAB6IP1', 15813),
(15814, 'cd04583', NULL, 'CBS_pair_ABC_OpuCA_assoc', NULL, NULL, 'CBS_pair_ABC_OpuCA_assoc', 15814),
(15815, 'cd09849', NULL, 'M20_Acy1L2-like', NULL, NULL, 'M20_Acy1L2-like', 15815),
(15816, 'cd09880', NULL, 'PIN_Smg5-6-like', NULL, NULL, 'PIN_Smg5-6-like', 15816),
(15817, 'cd05607', NULL, 'STKc_GRK7', NULL, NULL, 'STKc_GRK7', 15817),
(15818, 'cd00828', NULL, 'elong_cond_enzymes', NULL, NULL, 'elong_cond_enzymes', 15818),
(15819, 'cd02666', NULL, 'Peptidase_C19J', NULL, NULL, 'Peptidase_C19J', 15819),
(15820, 'cd03590', NULL, 'CLECT_DC-SIGN_like', NULL, NULL, 'CLECT_DC-SIGN_like', 15820),
(15821, 'cd13523', NULL, 'PBP2_polyamines', NULL, NULL, 'PBP2_polyamines', 15821),
(15822, 'cd14599', NULL, 'PTPc-N14', NULL, NULL, 'PTPc-N14', 15822),
(15823, 'cd07920', NULL, 'Pumilio', NULL, NULL, 'Pumilio', 15823),
(15824, 'cd04015', NULL, 'C2_plant_PLD', NULL, NULL, 'C2_plant_PLD', 15824),
(15825, 'cd01639', NULL, 'IMPase', NULL, NULL, 'IMPase', 15825),
(15826, 'cd17941', NULL, 'DEADc_DDX10', NULL, NULL, 'DEADc_DDX10', 15826),
(15827, 'cd13197', NULL, 'FERM_C_CCM1', NULL, NULL, 'FERM_C_CCM1', 15827),
(15828, 'cd14444', NULL, 'AlgX_N_like_1', NULL, NULL, 'AlgX_N_like_1', 15828),
(15829, 'cd07215', NULL, 'Pat17_PNPLA8_PNPLA9_like2', NULL, NULL, 'Pat17_PNPLA8_PNPLA9_like2', 15829),
(15830, 'cd07718', NULL, 'RNaseZ_ELAC1_ELAC2-C-term-like_MBL-fold', NULL, NULL, 'RNaseZ_ELAC1_ELAC2-C-term-like_MBL-fold', 15830),
(15831, 'cd13598', NULL, 'PBP2_lipoprotein_IlpA_like', NULL, NULL, 'PBP2_lipoprotein_IlpA_like', 15831),
(15832, 'cd03326', NULL, 'MR_like_1', NULL, NULL, 'MR_like_1', 15832),
(15833, 'cd09680', NULL, 'Cas10_III', NULL, NULL, 'Cas10_III', 15833),
(15834, 'cd04174', NULL, 'Rnd1_Rho6', NULL, NULL, 'Rnd1_Rho6', 15834),
(15835, 'cd05106', NULL, 'PTKc_CSF-1R', NULL, NULL, 'PTKc_CSF-1R', 15835),
(15836, 'cd03017', NULL, 'PRX_BCP', NULL, NULL, 'PRX_BCP', 15836),
(15837, 'cd08462', NULL, 'PBP2_NodD', NULL, NULL, 'PBP2_NodD', 15837),
(15838, 'cd17258', NULL, 'RMtype1_S_Sau13435ORF2165P-TRD1-CR1_like', NULL, NULL, 'RMtype1_S_Sau13435ORF2165P-TRD1-CR1_like', 15838),
(15839, 'cd03514', NULL, 'CrtR_beta-carotene-hydroxylase', NULL, NULL, 'CrtR_beta-carotene-hydroxylase', 15839),
(15840, 'cd17356', NULL, 'MFS_HXT', NULL, NULL, 'MFS_HXT', 15840),
(15841, 'cd04141', NULL, 'Rit_Rin_Ric', NULL, NULL, 'Rit_Rin_Ric', 15841),
(15842, 'cd09711', NULL, 'Csc1_I-D', NULL, NULL, 'Csc1_I-D', 15842),
(15843, 'cd18062', NULL, 'DEXHc_SMARCA4', NULL, NULL, 'DEXHc_SMARCA4', 15843),
(15844, 'cd09445', NULL, 'LIM_Mical_like_2', NULL, NULL, 'LIM_Mical_like_2', 15844),
(15845, 'cd01095', NULL, 'Nitrilotriacetate_monoxgenase', NULL, NULL, 'Nitrilotriacetate_monoxgenase', 15845),
(15846, 'cd10484', NULL, 'EphR_LBD_A6', NULL, NULL, 'EphR_LBD_A6', 15846),
(15847, 'cd18187', NULL, 'BTB_POZ_Kv_KCTD', NULL, NULL, 'BTB_POZ_Kv_KCTD', 15847),
(15848, 'cd09290', NULL, 'Photo-RC_L', NULL, NULL, 'Photo-RC_L', 15848),
(15849, 'cd04937', NULL, 'ACT_AKi-DapG-BS_2', NULL, NULL, 'ACT_AKi-DapG-BS_2', 15849),
(15850, 'cd12612', NULL, 'RRM2_SECp43', NULL, NULL, 'RRM2_SECp43', 15850),
(15851, 'cd17980', NULL, 'DEXHc_DHX35', NULL, NULL, 'DEXHc_DHX35', 15851),
(15852, 'cd15105', NULL, '7tmA_MrgprA', NULL, NULL, '7tmA_MrgprA', 15852);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(15853, 'cd21647', NULL, 'ORF4b_NS3c-betaCoV', NULL, NULL, 'ORF4b_NS3c-betaCoV', 15853),
(15854, 'cd17664', NULL, 'Mce1_N', NULL, NULL, 'Mce1_N', 15854),
(15855, 'cd05169', NULL, 'PIKKc_TOR', NULL, NULL, 'PIKKc_TOR', 15855),
(15856, 'cd17354', NULL, 'MFS_Mch1p_like', NULL, NULL, 'MFS_Mch1p_like', 15856),
(15857, 'cd14541', NULL, 'PTPc-N3_4', NULL, NULL, 'PTPc-N3_4', 15857),
(15858, 'cd04197', NULL, 'eIF-2B_epsilon_N', NULL, NULL, 'eIF-2B_epsilon_N', 15858),
(15859, 'cd15469', NULL, 'HN', NULL, NULL, 'HN', 15859),
(15860, 'cd19854', NULL, 'DSRM_DHX9_rpt1', NULL, NULL, 'DSRM_DHX9_rpt1', 15860),
(15861, 'cd09810', NULL, 'LPOR_like_SDR_c_like', NULL, NULL, 'LPOR_like_SDR_c_like', 15861),
(15862, 'cd02907', NULL, 'Macro_Af1521_BAL-like', NULL, NULL, 'Macro_Af1521_BAL-like', 15862),
(15863, 'cd08299', NULL, 'alcohol_DH_class_I_II_IV', NULL, NULL, 'alcohol_DH_class_I_II_IV', 15863),
(15864, 'cd09597', NULL, 'M4_TLP', NULL, NULL, 'M4_TLP', 15864),
(15865, 'cd18209', NULL, 'BTB_POZ_ZBTB21_ZNF295', NULL, NULL, 'BTB_POZ_ZBTB21_ZNF295', 15865),
(15866, 'cd04907', NULL, 'ACT_ThrD-I_2', NULL, NULL, 'ACT_ThrD-I_2', 15866),
(15867, 'cd02219', NULL, 'cupin_YjlB-like', NULL, NULL, 'cupin_YjlB-like', 15867),
(15868, 'cd16427', NULL, 'TraM-like', NULL, NULL, 'TraM-like', 15868),
(15869, 'cd18672', NULL, 'PIN_FAM120B-like', NULL, NULL, 'PIN_FAM120B-like', 15869),
(15870, 'cd09510', NULL, 'SAM_aveugle-like', NULL, NULL, 'SAM_aveugle-like', 15870),
(15871, 'cd15257', NULL, '7tmB2_GPR128', NULL, NULL, '7tmB2_GPR128', 15871),
(15872, 'cd20260', NULL, 'Myoregulin', NULL, NULL, 'Myoregulin', 15872),
(15873, 'cd04586', NULL, 'CBS_pair_BON_assoc', NULL, NULL, 'CBS_pair_BON_assoc', 15873),
(15874, 'cd16795', NULL, 'dRING_RMD5B', NULL, NULL, 'dRING_RMD5B', 15874),
(15875, 'cd08404', NULL, 'C2B_Synaptotagmin-4', NULL, NULL, 'C2B_Synaptotagmin-4', 15875),
(15876, 'cd14237', NULL, 'GAT_TM1L1', NULL, NULL, 'GAT_TM1L1', 15876),
(15877, 'cd20269', NULL, 'Complex1_LYR_LYRM9', NULL, NULL, 'Complex1_LYR_LYRM9', 15877),
(15878, 'cd00490', NULL, 'Met_repressor_MetJ', NULL, NULL, 'Met_repressor_MetJ', 15878),
(15879, 'cd05631', NULL, 'STKc_GRK4', NULL, NULL, 'STKc_GRK4', 15879),
(15880, 'cd02850', NULL, 'E_set_Cellulase_N', NULL, NULL, 'E_set_Cellulase_N', 15880),
(15881, 'cd02787', NULL, 'MopB_CT_ydeP', NULL, NULL, 'MopB_CT_ydeP', 15881),
(15882, 'cd18644', NULL, 'CD_polycomb', NULL, NULL, 'CD_polycomb', 15882),
(15883, 'cd00150', NULL, 'PlantTI', NULL, NULL, 'PlantTI', 15883),
(15884, 'cd15877', NULL, 'SNARE_TSNARE1', NULL, NULL, 'SNARE_TSNARE1', 15884),
(15885, 'cd01040', NULL, 'Mb-like', NULL, NULL, 'Mb-like', 15885),
(15886, 'cd05970', NULL, 'MACS_AAE_MA_like', NULL, NULL, 'MACS_AAE_MA_like', 15886),
(15887, 'cd00292', NULL, 'EF1B', NULL, NULL, 'EF1B', 15887),
(15888, 'cd01223', NULL, 'PH_Vav', NULL, NULL, 'PH_Vav', 15888),
(15889, 'cd03724', NULL, 'SOCS_ASB5', NULL, NULL, 'SOCS_ASB5', 15889),
(15890, 'cd04720', NULL, 'BAH_Orc1p_Yeast', NULL, NULL, 'BAH_Orc1p_Yeast', 15890),
(15891, 'cd07083', NULL, 'ALDH_P5CDH', NULL, NULL, 'ALDH_P5CDH', 15891),
(15892, 'cd07626', NULL, 'BAR_SNX9_like', NULL, NULL, 'BAR_SNX9_like', 15892),
(15893, 'cd19174', NULL, 'SET_ASH1L', NULL, NULL, 'SET_ASH1L', 15893),
(15894, 'cd16343', NULL, 'LMWPTP', NULL, NULL, 'LMWPTP', 15894),
(15895, 'cd03443', NULL, 'PaaI_thioesterase', NULL, NULL, 'PaaI_thioesterase', 15895),
(15896, 'cd07212', NULL, 'Pat_PNPLA9', NULL, NULL, 'Pat_PNPLA9', 15896),
(15897, 'cd03796', NULL, 'GT4_PIG-A-like', NULL, NULL, 'GT4_PIG-A-like', 15897),
(15898, 'cd06595', NULL, 'GH31_u1', NULL, NULL, 'GH31_u1', 15898),
(15899, 'cd04082', NULL, 'CBM35_pectate_lyase-like', NULL, NULL, 'CBM35_pectate_lyase-like', 15899),
(15900, 'cd19748', NULL, 'bHLH-O_HEY1', NULL, NULL, 'bHLH-O_HEY1', 15900),
(15901, 'cd05470', NULL, 'pepsin_retropepsin_like', NULL, NULL, 'pepsin_retropepsin_like', 15901),
(15902, 'cd18160', NULL, 'REC_CpdR_CckA-like', NULL, NULL, 'REC_CpdR_CckA-like', 15902),
(15903, 'cd19016', NULL, 'LGIC_ECD_nAChR_A3', NULL, NULL, 'LGIC_ECD_nAChR_A3', 15903),
(15904, 'cd00610', NULL, 'OAT_like', NULL, NULL, 'OAT_like', 15904);
INSERT INTO "PUBLIC"."MODEL" VALUES
(15905, 'cd01473', NULL, 'vWA_CTRP', NULL, NULL, 'vWA_CTRP', 15905),
(15906, 'cd15125', NULL, '7tmA_NMBR', NULL, NULL, '7tmA_NMBR', 15906),
(15907, 'cd18532', NULL, 'BACK_RHOBTB3', NULL, NULL, 'BACK_RHOBTB3', 15907),
(15908, 'cd02117', NULL, 'NifH-like', NULL, NULL, 'NifH-like', 15908),
(15909, 'cd14622', NULL, 'R-PTPc-E-2', NULL, NULL, 'R-PTPc-E-2', 15909),
(15910, 'cd08511', NULL, 'PBP2_NikA_DppA_OppA_like_5', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_5', 15910),
(15911, 'cd14509', NULL, 'PTP_PTEN', NULL, NULL, 'PTP_PTEN', 15911),
(15912, 'cd08504', NULL, 'PBP2_OppA', NULL, NULL, 'PBP2_OppA', 15912),
(15913, 'cd14881', NULL, 'MYSc_Myo20', NULL, NULL, 'MYSc_Myo20', 15913),
(15914, 'cd04179', NULL, 'DPM_DPG-synthase_like', NULL, NULL, 'DPM_DPG-synthase_like', 15914),
(15915, 'cd19210', NULL, 'SET_NSD1', NULL, NULL, 'SET_NSD1', 15915),
(15916, 'cd03198', NULL, 'GST_C_CLIC', NULL, NULL, 'GST_C_CLIC', 15916),
(15917, 'cd17352', NULL, 'MFS_MCT_SLC16', NULL, NULL, 'MFS_MCT_SLC16', 15917),
(15918, 'cd04222', NULL, 'CuRO_1_ceruloplasmin', NULL, NULL, 'CuRO_1_ceruloplasmin', 15918),
(15919, 'cd16102', NULL, 'RAWUL_PCGF_like', NULL, NULL, 'RAWUL_PCGF_like', 15919),
(15920, 'cd03343', NULL, 'cpn60', NULL, NULL, 'cpn60', 15920),
(15921, 'cd09429', NULL, 'LIM3_FHL1', NULL, NULL, 'LIM3_FHL1', 15921),
(15922, 'cd07138', NULL, 'ALDH_CddD_SSP0762', NULL, NULL, 'ALDH_CddD_SSP0762', 15922),
(15923, 'cd21403', NULL, 'ZBD_tv_SF1_Hel-like', NULL, NULL, 'ZBD_tv_SF1_Hel-like', 15923),
(15924, 'cd15594', NULL, 'PHD2_KMT2C', NULL, NULL, 'PHD2_KMT2C', 15924),
(15925, 'cd19921', NULL, 'REC_1_GGDEF', NULL, NULL, 'REC_1_GGDEF', 15925),
(15926, 'cd07977', NULL, 'TFIIE_beta_winged_helix', NULL, NULL, 'TFIIE_beta_winged_helix', 15926),
(15927, 'cd03677', NULL, 'MM_CoA_mutase_beta', NULL, NULL, 'MM_CoA_mutase_beta', 15927),
(15928, 'cd07945', NULL, 'DRE_TIM_CMS', NULL, NULL, 'DRE_TIM_CMS', 15928),
(15929, 'cd15134', NULL, '7tmA_capaR', NULL, NULL, '7tmA_capaR', 15929),
(15930, 'cd11882', NULL, 'SH3_GRAF-like', NULL, NULL, 'SH3_GRAF-like', 15930),
(15931, 'cd17208', NULL, 'FERM_F1_DdMyo7_like', NULL, NULL, 'FERM_F1_DdMyo7_like', 15931),
(15932, 'cd18998', NULL, 'LGIC_ECD_GABAAR_A', NULL, NULL, 'LGIC_ECD_GABAAR_A', 15932),
(15933, 'cd11811', NULL, 'SH3_CHK', NULL, NULL, 'SH3_CHK', 15933),
(15934, 'cd18994', NULL, 'LGIC_ECD_ZAC', NULL, NULL, 'LGIC_ECD_ZAC', 15934),
(15935, 'cd11464', NULL, 'bHLH_TS_TWIST', NULL, NULL, 'bHLH_TS_TWIST', 15935),
(15936, 'cd08362', NULL, 'BphC5-RrK37_N_like', NULL, NULL, 'BphC5-RrK37_N_like', 15936),
(15937, 'cd11948', NULL, 'SH3_GRAP_N', NULL, NULL, 'SH3_GRAP_N', 15937),
(15938, 'cd17922', NULL, 'DEXHc_LHR-like', NULL, NULL, 'DEXHc_LHR-like', 15938),
(15939, 'cd02863', NULL, 'Ubiquinol_oxidase_III', NULL, NULL, 'Ubiquinol_oxidase_III', 15939),
(15940, 'cd14266', NULL, 'UDPK_IM_PAP2_like', NULL, NULL, 'UDPK_IM_PAP2_like', 15940),
(15941, 'cd06431', NULL, 'GT8_LARGE_C', NULL, NULL, 'GT8_LARGE_C', 15941),
(15942, 'cd13613', NULL, 'PBP2_Opu_like_2', NULL, NULL, 'PBP2_Opu_like_2', 15942),
(15943, 'cd15844', NULL, 'SNARE_syntaxin5', NULL, NULL, 'SNARE_syntaxin5', 15943),
(15944, 'cd10910', NULL, 'PIN_limkain_b1_N_like', NULL, NULL, 'PIN_limkain_b1_N_like', 15944),
(15945, 'cd05193', NULL, 'AR_like_SDR_e', NULL, NULL, 'AR_like_SDR_e', 15945),
(15946, 'cd12499', NULL, 'RRM_EcCsdA_like', NULL, NULL, 'RRM_EcCsdA_like', 15946),
(15947, 'cd14888', NULL, 'MYSc_Myo27', NULL, NULL, 'MYSc_Myo27', 15947),
(15948, 'cd05945', NULL, 'DltA', NULL, NULL, 'DltA', 15948),
(15949, 'cd06939', NULL, 'NR_LBD_ROR_like', NULL, NULL, 'NR_LBD_ROR_like', 15949),
(15950, 'cd19206', NULL, 'SET_KMT2A', NULL, NULL, 'SET_KMT2A', 15950),
(15951, 'cd03330', NULL, 'Macro_Ttha0132-like', NULL, NULL, 'Macro_Ttha0132-like', 15951),
(15952, 'cd00051', NULL, 'EFh', NULL, NULL, 'EFh', 15952),
(15953, 'cd04140', NULL, 'ARHI_like', NULL, NULL, 'ARHI_like', 15953),
(15954, 'cd04515', NULL, 'Alpha_kinase', NULL, NULL, 'Alpha_kinase', 15954),
(15955, 'cd03129', NULL, 'GAT1_Peptidase_E_like', NULL, NULL, 'GAT1_Peptidase_E_like', 15955),
(15956, 'cd03455', NULL, 'SAV4209', NULL, NULL, 'SAV4209', 15956);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(15957, 'cd18103', NULL, 'SpoU-like_RlmB', NULL, NULL, 'SpoU-like_RlmB', 15957),
(15958, 'cd02057', NULL, 'serpinB5_maspin', NULL, NULL, 'serpinB5_maspin', 15958),
(15959, 'cd09323', NULL, 'TDT_SLAC1_like', NULL, NULL, 'TDT_SLAC1_like', 15959),
(15960, 'cd13586', NULL, 'PBP2_Maltose_binding_like', NULL, NULL, 'PBP2_Maltose_binding_like', 15960),
(15961, 'cd03692', NULL, 'mtIF2_IVc', NULL, NULL, 'mtIF2_IVc', 15961),
(15962, 'cd08342', NULL, 'HPPD_N_like', NULL, NULL, 'HPPD_N_like', 15962),
(15963, 'cd19200', NULL, 'PR-SET_PRDM16_PRDM3', NULL, NULL, 'PR-SET_PRDM16_PRDM3', 15963),
(15964, 'cd13181', NULL, 'RanBD_NUP2', NULL, NULL, 'RanBD_NUP2', 15964),
(15965, 'cd17880', NULL, 'D-Ala-D-Ala_dipeptidase', NULL, NULL, 'D-Ala-D-Ala_dipeptidase', 15965),
(15966, 'cd09088', NULL, 'Ape2-like_AP-endo', NULL, NULL, 'Ape2-like_AP-endo', 15966),
(15967, 'cd12901', NULL, 'SPRY_PRY_FSD1', NULL, NULL, 'SPRY_PRY_FSD1', 15967),
(15968, 'cd18800', NULL, 'SF2_C_EcoR124I-like', NULL, NULL, 'SF2_C_EcoR124I-like', 15968),
(15969, 'cd14689', NULL, 'bZIP_CREB3', NULL, NULL, 'bZIP_CREB3', 15969),
(15970, 'cd05568', NULL, 'PTS_IIB_bgl_like', NULL, NULL, 'PTS_IIB_bgl_like', 15970),
(15971, 'cd18512', NULL, 'BACK_KLHL2_Mayven', NULL, NULL, 'BACK_KLHL2_Mayven', 15971),
(15972, 'cd08012', NULL, 'M20_ArgE-related', NULL, NULL, 'M20_ArgE-related', 15972),
(15973, 'cd07654', NULL, 'F-BAR_FCHSD', NULL, NULL, 'F-BAR_FCHSD', 15973),
(15974, 'cd09289', NULL, 'Photosystem-II_D1', NULL, NULL, 'Photosystem-II_D1', 15974),
(15975, 'cd19982', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, 'PBP1_ABC_ligand_binding-like', 15975),
(15976, 'cd04863', NULL, 'MtLigD_Pol_like', NULL, NULL, 'MtLigD_Pol_like', 15976),
(15977, 'cd08477', NULL, 'PBP2_CrgA_like_8', NULL, NULL, 'PBP2_CrgA_like_8', 15977),
(15978, 'cd18495', NULL, 'BACK_GCL', NULL, NULL, 'BACK_GCL', 15978),
(15979, 'cd19830', NULL, 'Bbox2_TIF1g_C-VI', NULL, NULL, 'Bbox2_TIF1g_C-VI', 15979),
(15980, 'cd00039', NULL, 'COLIPASE', NULL, NULL, 'COLIPASE', 15980),
(15981, 'cd08729', NULL, 'RGS_PX', NULL, NULL, 'RGS_PX', 15981),
(15982, 'cd16004', NULL, '7tmA_SKR_NK2R', NULL, NULL, '7tmA_SKR_NK2R', 15982),
(15983, 'cd07062', NULL, 'Peptidase_S66_mccF_like', NULL, NULL, 'Peptidase_S66_mccF_like', 15983),
(15984, 'cd04786', NULL, 'HTH_MerR-like_sg7', NULL, NULL, 'HTH_MerR-like_sg7', 15984),
(15985, 'cd04588', NULL, 'CBS_pair_archHTH_assoc', NULL, NULL, 'CBS_pair_archHTH_assoc', 15985),
(15986, 'cd08632', NULL, 'PI-PLCc_eta1', NULL, NULL, 'PI-PLCc_eta1', 15986),
(15987, 'cd09433', NULL, 'LIM4_FHL2', NULL, NULL, 'LIM4_FHL2', 15987),
(15988, 'cd18677', NULL, 'PIN_MjVapC2-VapC6_like', NULL, NULL, 'PIN_MjVapC2-VapC6_like', 15988),
(15989, 'cd04663', NULL, 'Nudix_Hydrolase_6', NULL, NULL, 'Nudix_Hydrolase_6', 15989),
(15990, 'cd05878', NULL, 'Ig_Aggrecan_like', NULL, NULL, 'Ig_Aggrecan_like', 15990),
(15991, 'cd01346', NULL, 'Maltoporin-like', NULL, NULL, 'Maltoporin-like', 15991),
(15992, 'cd16385', NULL, 'IcmL', NULL, NULL, 'IcmL', 15992),
(15993, 'cd07242', NULL, 'VOC_BsYqjT', NULL, NULL, 'VOC_BsYqjT', 15993),
(15994, 'cd12707', NULL, 'RRM_LARP4', NULL, NULL, 'RRM_LARP4', 15994),
(15995, 'cd00012', NULL, 'NBD_sugar-kinase_HSP70_actin', NULL, NULL, 'NBD_sugar-kinase_HSP70_actin', 15995),
(15996, 'cd08896', NULL, 'SRPBCC_CalC_Aha1-like_3', NULL, NULL, 'SRPBCC_CalC_Aha1-like_3', 15996),
(15997, 'cd18809', NULL, 'SF1_C_RecD', NULL, NULL, 'SF1_C_RecD', 15997),
(15998, 'cd03385', NULL, 'PAP2_BcrC_like', NULL, NULL, 'PAP2_BcrC_like', 15998),
(15999, 'cd01275', NULL, 'FHIT', NULL, NULL, 'FHIT', 15999),
(16000, 'cd02657', NULL, 'Peptidase_C19A', NULL, NULL, 'Peptidase_C19A', 16000),
(16001, 'cd07476', NULL, 'Peptidases_S8_thiazoline_oxidase_subtilisin-li...', NULL, NULL, 'Peptidases_S8_thiazoline_oxidase_subtilisin-like_protease', 16001),
(16002, 'cd12546', NULL, 'RRM_RBM43', NULL, NULL, 'RRM_RBM43', 16002),
(16003, 'cd04079', NULL, 'CBM6_agarase-like', NULL, NULL, 'CBM6_agarase-like', 16003),
(16004, 'cd06215', NULL, 'FNR_iron_sulfur_binding_1', NULL, NULL, 'FNR_iron_sulfur_binding_1', 16004),
(16005, 'cd15409', NULL, '7tmA_OR5H-like', NULL, NULL, '7tmA_OR5H-like', 16005);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(16006, 'cd03759', NULL, 'proteasome_beta_type_3', NULL, NULL, 'proteasome_beta_type_3', 16006),
(16007, 'cd08460', NULL, 'PBP2_DntR_like_1', NULL, NULL, 'PBP2_DntR_like_1', 16007),
(16008, 'cd03158', NULL, 'penumbra_like_LEL', NULL, NULL, 'penumbra_like_LEL', 16008),
(16009, 'cd07732', NULL, 'metallo-hydrolase-like_MBL-fold', NULL, NULL, 'metallo-hydrolase-like_MBL-fold', 16009),
(16010, 'cd18485', NULL, 'BACK_KBTBD12', NULL, NULL, 'BACK_KBTBD12', 16010),
(16011, 'cd00476', NULL, 'SAICAR_synt', NULL, NULL, 'SAICAR_synt', 16011),
(16012, 'cd09807', NULL, 'retinol-DH_like_SDR_c', NULL, NULL, 'retinol-DH_like_SDR_c', 16012),
(16013, 'cd04595', NULL, 'CBS_pair_DHH_polyA_Pol_assoc', NULL, NULL, 'CBS_pair_DHH_polyA_Pol_assoc', 16013),
(16014, 'cd06931', NULL, 'NR_LBD_HNF4_like', NULL, NULL, 'NR_LBD_HNF4_like', 16014),
(16015, 'cd15742', NULL, 'FYVE_FGD5', NULL, NULL, 'FYVE_FGD5', 16015),
(16016, 'cd02655', NULL, 'RNAP_beta''_C', NULL, NULL, 'RNAP_beta''_C', 16016),
(16017, 'cd01902', NULL, 'Ntn_CGH', NULL, NULL, 'Ntn_CGH', 16017),
(16018, 'cd04730', NULL, 'NPD_like', NULL, NULL, 'NPD_like', 16018),
(16019, 'cd17549', NULL, 'REC_DctD-like', NULL, NULL, 'REC_DctD-like', 16019),
(16020, 'cd12907', NULL, 'SPRY_Fbox', NULL, NULL, 'SPRY_Fbox', 16020),
(16021, 'cd18307', NULL, 'BTB_POZ_calicin', NULL, NULL, 'BTB_POZ_calicin', 16021),
(16022, 'cd07232', NULL, 'Pat_PLPL', NULL, NULL, 'Pat_PLPL', 16022),
(16023, 'cd00651', NULL, 'TFold', NULL, NULL, 'TFold', 16023),
(16024, 'cd05529', NULL, 'Bromo_WDR9_I_like', NULL, NULL, 'Bromo_WDR9_I_like', 16024),
(16025, 'cd00463', NULL, 'Ribosomal_L31e', NULL, NULL, 'Ribosomal_L31e', 16025),
(16026, 'cd09437', NULL, 'LIM3_LPP', NULL, NULL, 'LIM3_LPP', 16026),
(16027, 'cd07897', NULL, 'Adenylation_DNA_ligase_Bac1', NULL, NULL, 'Adenylation_DNA_ligase_Bac1', 16027),
(16028, 'cd13890', NULL, 'CuRO_3_CueO_FtsP', NULL, NULL, 'CuRO_3_CueO_FtsP', 16028),
(16029, 'cd07397', NULL, 'MPP_NostocDevT-like', NULL, NULL, 'MPP_NostocDevT-like', 16029),
(16030, 'cd15326', NULL, '7tmA_alpha1B_AR', NULL, NULL, '7tmA_alpha1B_AR', 16030),
(16031, 'cd19123', NULL, 'AKR_AKR3G1', NULL, NULL, 'AKR_AKR3G1', 16031),
(16032, 'cd14940', NULL, '7tmE_cAMP_R_Slime_mold', NULL, NULL, '7tmE_cAMP_R_Slime_mold', 16032),
(16033, 'cd09905', NULL, 'H3TH_GEN1', NULL, NULL, 'H3TH_GEN1', 16033),
(16034, 'cd06378', NULL, 'PBP1_iGluR_NMDA_NR2', NULL, NULL, 'PBP1_iGluR_NMDA_NR2', 16034),
(16035, 'cd05086', NULL, 'PTKc_Aatyk2', NULL, NULL, 'PTKc_Aatyk2', 16035),
(16036, 'cd06546', NULL, 'GH18_CTS3_chitinase', NULL, NULL, 'GH18_CTS3_chitinase', 16036),
(16037, 'cd18686', NULL, 'PIN_VapC-like', NULL, NULL, 'PIN_VapC-like', 16037),
(16038, 'cd15147', NULL, '7tmA_PAFR', NULL, NULL, '7tmA_PAFR', 16038),
(16039, 'cd16754', NULL, 'RING-HC_MID2', NULL, NULL, 'RING-HC_MID2', 16039),
(16040, 'cd17169', NULL, 'FERM_F1_FRMPD3', NULL, NULL, 'FERM_F1_FRMPD3', 16040),
(16041, 'cd04722', NULL, 'TIM_phosphate_binding', NULL, NULL, 'TIM_phosphate_binding', 16041),
(16042, 'cd08389', NULL, 'C2A_Synaptotagmin-14_16', NULL, NULL, 'C2A_Synaptotagmin-14_16', 16042),
(16043, 'cd16952', NULL, 'HATPase_EcPhoR-like', NULL, NULL, 'HATPase_EcPhoR-like', 16043),
(16044, 'cd01740', NULL, 'GATase1_FGAR_AT', NULL, NULL, 'GATase1_FGAR_AT', 16044),
(16045, 'cd04896', NULL, 'ACT_ACR-like_3', NULL, NULL, 'ACT_ACR-like_3', 16045),
(16046, 'cd18614', NULL, 'GH130', NULL, NULL, 'GH130', 16046),
(16047, 'cd07100', NULL, 'ALDH_SSADH1_GabD1', NULL, NULL, 'ALDH_SSADH1_GabD1', 16047),
(16048, 'cd05729', NULL, 'Ig2_FGFR_like', NULL, NULL, 'Ig2_FGFR_like', 16048),
(16049, 'cd14296', NULL, 'UBA1_scUBP14_like', NULL, NULL, 'UBA1_scUBP14_like', 16049),
(16050, 'cd11852', NULL, 'SH3_Kalirin_1', NULL, NULL, 'SH3_Kalirin_1', 16050),
(16051, 'cd01286', NULL, 'deoxycytidylate_deaminase', NULL, NULL, 'deoxycytidylate_deaminase', 16051),
(16052, 'cd13722', NULL, 'PBP2_iGluR_Kainate_GluR5', NULL, NULL, 'PBP2_iGluR_Kainate_GluR5', 16052),
(16053, 'cd14302', NULL, 'UBA_UBXN1', NULL, NULL, 'UBA_UBXN1', 16053),
(16054, 'cd07297', NULL, 'PX_PLD2', NULL, NULL, 'PX_PLD2', 16054);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(16055, 'cd07779', NULL, 'FGGY_ygcE_like', NULL, NULL, 'FGGY_ygcE_like', 16055),
(16056, 'cd11355', NULL, 'AmyAc_Sucrose_phosphorylase', NULL, NULL, 'AmyAc_Sucrose_phosphorylase', 16056),
(16057, 'cd01860', NULL, 'Rab5_related', NULL, NULL, 'Rab5_related', 16057),
(16058, 'cd12392', NULL, 'RRM2_SART3', NULL, NULL, 'RRM2_SART3', 16058),
(16059, 'cd10324', NULL, 'SLC6sbd', NULL, NULL, 'SLC6sbd', 16059),
(16060, 'cd10539', NULL, 'SET_ATXR5_6-like', NULL, NULL, 'SET_ATXR5_6-like', 16060),
(16061, 'cd17012', NULL, 'CID_RPRD1B', NULL, NULL, 'CID_RPRD1B', 16061),
(16062, 'cd02108', NULL, 'bact_SO_family_Moco', NULL, NULL, 'bact_SO_family_Moco', 16062),
(16063, 'cd08856', NULL, 'ArfGap_ARAP2', NULL, NULL, 'ArfGap_ARAP2', 16063),
(16064, 'cd06890', NULL, 'PX_Bem1p', NULL, NULL, 'PX_Bem1p', 16064),
(16065, 'cd15357', NULL, '7tmA_NMU-R2', NULL, NULL, '7tmA_NMU-R2', 16065),
(16066, 'cd16686', NULL, 'RING-H2_UBR2', NULL, NULL, 'RING-H2_UBR2', 16066),
(16067, 'cd01306', NULL, 'PhnM', NULL, NULL, 'PhnM', 16067),
(16068, 'cd02395', NULL, 'SF1_like-KH', NULL, NULL, 'SF1_like-KH', 16068),
(16069, 'cd16590', NULL, 'RING-HC_TRIM4_C-IV_like', NULL, NULL, 'RING-HC_TRIM4_C-IV_like', 16069),
(16070, 'cd08740', NULL, 'RGS_RGS11', NULL, NULL, 'RGS_RGS11', 16070),
(16071, 'cd08836', NULL, 'ArfGap_AGAP', NULL, NULL, 'ArfGap_AGAP', 16071),
(16072, 'cd04482', NULL, 'RPA2_OBF_like', NULL, NULL, 'RPA2_OBF_like', 16072),
(16073, 'cd09388', NULL, 'LIM1_LMO1_LMO3', NULL, NULL, 'LIM1_LMO1_LMO3', 16073),
(16074, 'cd18715', NULL, 'PIN_VapC-like', NULL, NULL, 'PIN_VapC-like', 16074),
(16075, 'cd17068', NULL, 'RBD_PLEKHG5', NULL, NULL, 'RBD_PLEKHG5', 16075),
(16076, 'cd13385', NULL, 'PH_Gab3', NULL, NULL, 'PH_Gab3', 16076),
(16077, 'cd18304', NULL, 'BTB_POZ_M2BP', NULL, NULL, 'BTB_POZ_M2BP', 16077),
(16078, 'cd03337', NULL, 'TCP1_gamma', NULL, NULL, 'TCP1_gamma', 16078),
(16079, 'cd01436', NULL, 'Dipth_tox_like', NULL, NULL, 'Dipth_tox_like', 16079),
(16080, 'cd06822', NULL, 'PLPDE_III_YBL036c_euk', NULL, NULL, 'PLPDE_III_YBL036c_euk', 16080),
(16081, 'cd13643', NULL, 'PBP2_BCP_2', NULL, NULL, 'PBP2_BCP_2', 16081),
(16082, 'cd19735', NULL, 'bHLH-PAS_dCLOCK', NULL, NULL, 'bHLH-PAS_dCLOCK', 16082),
(16083, 'cd17759', NULL, 'MCM8', NULL, NULL, 'MCM8', 16083),
(16084, 'cd03753', NULL, 'proteasome_alpha_type_5', NULL, NULL, 'proteasome_alpha_type_5', 16084),
(16085, 'cd10522', NULL, 'SET_LegAS4-like', NULL, NULL, 'SET_LegAS4-like', 16085),
(16086, 'cd09087', NULL, 'Ape1-like_AP-endo', NULL, NULL, 'Ape1-like_AP-endo', 16086),
(16087, 'cd17476', NULL, 'MFS_Amf1_MDR_like', NULL, NULL, 'MFS_Amf1_MDR_like', 16087),
(16088, 'cd01796', NULL, 'Ubl_Ddi1_like', NULL, NULL, 'Ubl_Ddi1_like', 16088),
(16089, 'cd10397', NULL, 'SH2_Tec_Btk', NULL, NULL, 'SH2_Tec_Btk', 16089),
(16090, 'cd05198', NULL, 'formate_dh_like', NULL, NULL, 'formate_dh_like', 16090),
(16091, 'cd18073', NULL, 'DEXHc_RIG-I_DDX58', NULL, NULL, 'DEXHc_RIG-I_DDX58', 16091),
(16092, 'cd10529', NULL, 'SET_SETD5-like', NULL, NULL, 'SET_SETD5-like', 16092),
(16093, 'cd18499', NULL, 'BACK_RHOBTB', NULL, NULL, 'BACK_RHOBTB', 16093),
(16094, 'cd08725', NULL, 'RGS_RGS22_4', NULL, NULL, 'RGS_RGS22_4', 16094),
(16095, 'cd15567', NULL, 'PHD4_NSD', NULL, NULL, 'PHD4_NSD', 16095),
(16096, 'cd00227', NULL, 'CPT', NULL, NULL, 'CPT', 16096),
(16097, 'cd18455', NULL, 'BACK_KLHL16_gigaxonin', NULL, NULL, 'BACK_KLHL16_gigaxonin', 16097),
(16098, 'cd18582', NULL, 'ABC_6TM_ATM1_ABCB7', NULL, NULL, 'ABC_6TM_ATM1_ABCB7', 16098),
(16099, 'cd16875', NULL, 'ARID_KDM5C_5D', NULL, NULL, 'ARID_KDM5C_5D', 16099),
(16100, 'cd19333', NULL, 'Wnt_Wnt1', NULL, NULL, 'Wnt_Wnt1', 16100),
(16101, 'cd01886', NULL, 'EF-G', NULL, NULL, 'EF-G', 16101),
(16102, 'cd02780', NULL, 'MopB_CT_Tetrathionate_Arsenate-R', NULL, NULL, 'MopB_CT_Tetrathionate_Arsenate-R', 16102),
(16103, 'cd12654', NULL, 'RRM3_HuB', NULL, NULL, 'RRM3_HuB', 16103),
(16104, 'cd12741', NULL, 'RRM2_Fusilli', NULL, NULL, 'RRM2_Fusilli', 16104),
(16105, 'cd03740', NULL, 'SOCS_SOCS6', NULL, NULL, 'SOCS_SOCS6', 16105),
(16106, 'cd16298', NULL, 'SNM1A-like_MBL-fold', NULL, NULL, 'SNM1A-like_MBL-fold', 16106);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(16107, 'cd00368', NULL, 'Molybdopterin-Binding', NULL, NULL, 'Molybdopterin-Binding', 16107),
(16108, 'cd04917', NULL, 'ACT_AKiii-LysC-EC_2', NULL, NULL, 'ACT_AKiii-LysC-EC_2', 16108),
(16109, 'cd11719', NULL, 'FANC', NULL, NULL, 'FANC', 16109),
(16110, 'cd15205', NULL, '7tmA_QRFPR', NULL, NULL, '7tmA_QRFPR', 16110),
(16111, 'cd00707', NULL, 'Pancreat_lipase_like', NULL, NULL, 'Pancreat_lipase_like', 16111),
(16112, 'cd13687', NULL, 'PBP2_iGluR_NMDA', NULL, NULL, 'PBP2_iGluR_NMDA', 16112),
(16113, 'cd16284', NULL, 'UlaG-like_MBL-fold', NULL, NULL, 'UlaG-like_MBL-fold', 16113),
(16114, 'cd11319', NULL, 'AmyAc_euk_AmyA', NULL, NULL, 'AmyAc_euk_AmyA', 16114),
(16115, 'cd03132', NULL, 'GATase1_catalase', NULL, NULL, 'GATase1_catalase', 16115),
(16116, 'cd07229', NULL, 'Pat_TGL3_like', NULL, NULL, 'Pat_TGL3_like', 16116),
(16117, 'cd11980', NULL, 'SH3_VAV2_1', NULL, NULL, 'SH3_VAV2_1', 16117),
(16118, 'cd14980', NULL, '7tmA_Glycoprotein_LRR_R-like', NULL, NULL, '7tmA_Glycoprotein_LRR_R-like', 16118),
(16119, 'cd00565', NULL, 'Ubl_ThiS', NULL, NULL, 'Ubl_ThiS', 16119),
(16120, 'cd09725', NULL, 'Cas2_I_II_III', NULL, NULL, 'Cas2_I_II_III', 16120),
(16121, 'cd13443', NULL, 'CDI_inhibitor_Bp1026b_like', NULL, NULL, 'CDI_inhibitor_Bp1026b_like', 16121),
(16122, 'cd07631', NULL, 'BAR_APPL1', NULL, NULL, 'BAR_APPL1', 16122),
(16123, 'cd00192', NULL, 'PTKc', NULL, NULL, 'PTKc', 16123),
(16124, 'cd12345', NULL, 'RRM2_SECp43_like', NULL, NULL, 'RRM2_SECp43_like', 16124),
(16125, 'cd17441', NULL, 'MFS_SVOP', NULL, NULL, 'MFS_SVOP', 16125),
(16126, 'cd06908', NULL, 'M14_AGBL4_like', NULL, NULL, 'M14_AGBL4_like', 16126),
(16127, 'cd18336', NULL, 'BTB_POZ_KLHL4', NULL, NULL, 'BTB_POZ_KLHL4', 16127),
(16128, 'cd19128', NULL, 'AKR_GlAR-like', NULL, NULL, 'AKR_GlAR-like', 16128),
(16129, 'cd11785', NULL, 'SH3_SH3RF_C', NULL, NULL, 'SH3_SH3RF_C', 16129),
(16130, 'cd12967', NULL, 'CBM_SusE-F_like_u1', NULL, NULL, 'CBM_SusE-F_like_u1', 16130),
(16131, 'cd03080', NULL, 'GST_N_Metaxin_like', NULL, NULL, 'GST_N_Metaxin_like', 16131),
(16132, 'cd03577', NULL, 'NTR_TIMP_like', NULL, NULL, 'NTR_TIMP_like', 16132),
(16133, 'cd09737', NULL, 'Csy3_I-F', NULL, NULL, 'Csy3_I-F', 16133),
(16134, 'cd16712', NULL, 'RING-HC_DTX3L', NULL, NULL, 'RING-HC_DTX3L', 16134),
(16135, 'cd02515', NULL, 'Glyco_transf_6', NULL, NULL, 'Glyco_transf_6', 16135),
(16136, 'cd11006', NULL, 'M35_peptidyl-Lys_like', NULL, NULL, 'M35_peptidyl-Lys_like', 16136),
(16137, 'cd13966', NULL, 'PT_UbiA_4', NULL, NULL, 'PT_UbiA_4', 16137),
(16138, 'cd05826', NULL, 'Sortase_B', NULL, NULL, 'Sortase_B', 16138),
(16139, 'cd03370', NULL, 'nitroreductase', NULL, NULL, 'nitroreductase', 16139),
(16140, 'cd05745', NULL, 'Ig3_Peroxidasin', NULL, NULL, 'Ig3_Peroxidasin', 16140),
(16141, 'cd14138', NULL, 'PTKc_Wee1a', NULL, NULL, 'PTKc_Wee1a', 16141),
(16142, 'cd17713', NULL, 'BRCT_polymerase_mu_like', NULL, NULL, 'BRCT_polymerase_mu_like', 16142),
(16143, 'cd04473', NULL, 'S1_RecJ_like', NULL, NULL, 'S1_RecJ_like', 16143),
(16144, 'cd13678', NULL, 'PBP2_TRAP_DctP10', NULL, NULL, 'PBP2_TRAP_DctP10', 16144),
(16145, 'cd02697', NULL, 'M20_like', NULL, NULL, 'M20_like', 16145),
(16146, 'cd16777', NULL, 'mRING-HC-C4C4_RBR_RNF144A', NULL, NULL, 'mRING-HC-C4C4_RBR_RNF144A', 16146),
(16147, 'cd19747', NULL, 'bHLH_TS_ASCL5', NULL, NULL, 'bHLH_TS_ASCL5', 16147),
(16148, 'cd02424', NULL, 'Peptidase_C39E', NULL, NULL, 'Peptidase_C39E', 16148),
(16149, 'cd05896', NULL, 'Ig1_IL1RAPL-1_like', NULL, NULL, 'Ig1_IL1RAPL-1_like', 16149),
(16150, 'cd19886', NULL, 'DSRM_STAU2_rpt4', NULL, NULL, 'DSRM_STAU2_rpt4', 16150),
(16151, 'cd17126', NULL, 'Ubl_HR23A', NULL, NULL, 'Ubl_HR23A', 16151),
(16152, 'cd00872', NULL, 'PI3Ka_I', NULL, NULL, 'PI3Ka_I', 16152),
(16153, 'cd03071', NULL, 'PDI_b''_NRX', NULL, NULL, 'PDI_b''_NRX', 16153),
(16154, 'cd07431', NULL, 'PHP_PolIIIA', NULL, NULL, 'PHP_PolIIIA', 16154),
(16155, 'cd05117', NULL, 'STKc_CAMK', NULL, NULL, 'STKc_CAMK', 16155),
(16156, 'cd07104', NULL, 'ALDH_BenzADH-like', NULL, NULL, 'ALDH_BenzADH-like', 16156),
(16157, 'cd12297', NULL, 'RRM2_Prp24', NULL, NULL, 'RRM2_Prp24', 16157);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(16158, 'cd18443', NULL, 'BRCT_DNTT', NULL, NULL, 'BRCT_DNTT', 16158),
(16159, 'cd03593', NULL, 'CLECT_NK_receptors_like', NULL, NULL, 'CLECT_NK_receptors_like', 16159),
(16160, 'cd08808', NULL, 'CARD_CARD11_CARMA1', NULL, NULL, 'CARD_CARD11_CARMA1', 16160),
(16161, 'cd04611', NULL, 'CBS_pair_GGDEF_PAS_repeat2', NULL, NULL, 'CBS_pair_GGDEF_PAS_repeat2', 16161),
(16162, 'cd15805', NULL, 'RIG-I_C', NULL, NULL, 'RIG-I_C', 16162),
(16163, 'cd03241', NULL, 'ABC_RecN', NULL, NULL, 'ABC_RecN', 16163),
(16164, 'cd07985', NULL, 'LPLAT_GPAT', NULL, NULL, 'LPLAT_GPAT', 16164),
(16165, 'cd00893', NULL, 'PI4Kc_III', NULL, NULL, 'PI4Kc_III', 16165),
(16166, 'cd12888', NULL, 'SPRY_PRY_TRIM7_like', NULL, NULL, 'SPRY_PRY_TRIM7_like', 16166),
(16167, 'cd17930', NULL, 'DEXHc_cas3', NULL, NULL, 'DEXHc_cas3', 16167),
(16168, 'cd12420', NULL, 'RRM_RBPMS_like', NULL, NULL, 'RRM_RBPMS_like', 16168),
(16169, 'cd15362', NULL, '7tmA_LGR6', NULL, NULL, '7tmA_LGR6', 16169),
(16170, 'cd09933', NULL, 'SH2_Src_family', NULL, NULL, 'SH2_Src_family', 16170),
(16171, 'cd07750', NULL, 'PolyPPase_VTC_like', NULL, NULL, 'PolyPPase_VTC_like', 16171),
(16172, 'cd05274', NULL, 'KR_FAS_SDR_x', NULL, NULL, 'KR_FAS_SDR_x', 16172),
(16173, 'cd11646', NULL, 'Precorrin_3B_C17_MT', NULL, NULL, 'Precorrin_3B_C17_MT', 16173),
(16174, 'cd17263', NULL, 'RMtype1_S_AbaB8300I-TRD1-CR1_like', NULL, NULL, 'RMtype1_S_AbaB8300I-TRD1-CR1_like', 16174),
(16175, 'cd01844', NULL, 'SGNH_hydrolase_like_6', NULL, NULL, 'SGNH_hydrolase_like_6', 16175),
(16176, 'cd06610', NULL, 'STKc_OSR1_SPAK', NULL, NULL, 'STKc_OSR1_SPAK', 16176),
(16177, 'cd03259', NULL, 'ABC_Carb_Solutes_like', NULL, NULL, 'ABC_Carb_Solutes_like', 16177),
(16178, 'cd19186', NULL, 'SET_Suv4-20', NULL, NULL, 'SET_Suv4-20', 16178),
(16179, 'cd03382', NULL, 'PAP2_dolichyldiphosphatase', NULL, NULL, 'PAP2_dolichyldiphosphatase', 16179),
(16180, 'cd12657', NULL, 'RRM1_hnRNPM', NULL, NULL, 'RRM1_hnRNPM', 16180),
(16181, 'cd00042', NULL, 'CY', NULL, NULL, 'CY', 16181),
(16182, 'cd15730', NULL, 'FYVE_EEA1', NULL, NULL, 'FYVE_EEA1', 16182),
(16183, 'cd11270', NULL, 'Sema_6E', NULL, NULL, 'Sema_6E', 16183),
(16184, 'cd15466', NULL, 'CLU-central', NULL, NULL, 'CLU-central', 16184),
(16185, 'cd13405', NULL, 'TNFRSF14_teleost', NULL, NULL, 'TNFRSF14_teleost', 16185),
(16186, 'cd18407', NULL, 'BTB_POZ_KCNA6', NULL, NULL, 'BTB_POZ_KCNA6', 16186),
(16187, 'cd12876', NULL, 'SPRY_SOCS3', NULL, NULL, 'SPRY_SOCS3', 16187),
(16188, 'cd07910', NULL, 'MiaE', NULL, NULL, 'MiaE', 16188),
(16189, 'cd14374', NULL, 'CUE1_Cue2p_like', NULL, NULL, 'CUE1_Cue2p_like', 16189),
(16190, 'cd18970', NULL, 'CD_POL_like', NULL, NULL, 'CD_POL_like', 16190),
(16191, 'cd11972', NULL, 'SH3_Abi2', NULL, NULL, 'SH3_Abi2', 16191),
(16192, 'cd01527', NULL, 'RHOD_YgaP', NULL, NULL, 'RHOD_YgaP', 16192),
(16193, 'cd03488', NULL, 'Topoisomer_IB_N_htopoI_like', NULL, NULL, 'Topoisomer_IB_N_htopoI_like', 16193),
(16194, 'cd12606', NULL, 'RRM1_RBM4', NULL, NULL, 'RRM1_RBM4', 16194),
(16195, 'cd03511', NULL, 'Rhizopine-oxygenase-like', NULL, NULL, 'Rhizopine-oxygenase-like', 16195),
(16196, 'cd08298', NULL, 'CAD2', NULL, NULL, 'CAD2', 16196),
(16197, 'cd15737', NULL, 'FYVE2_Vac1p_like', NULL, NULL, 'FYVE2_Vac1p_like', 16197),
(16198, 'cd06613', NULL, 'STKc_MAP4K3_like', NULL, NULL, 'STKc_MAP4K3_like', 16198),
(16199, 'cd11446', NULL, 'bHLH_AtILR3_like', NULL, NULL, 'bHLH_AtILR3_like', 16199),
(16200, 'cd17749', NULL, 'BRCT_TopBP1_rpt4', NULL, NULL, 'BRCT_TopBP1_rpt4', 16200),
(16201, 'cd16319', NULL, 'MraZ', NULL, NULL, 'MraZ', 16201),
(16202, 'cd16088', NULL, 'IgV_PD1', NULL, NULL, 'IgV_PD1', 16202),
(16203, 'cd15683', NULL, 'PHD_ING2', NULL, NULL, 'PHD_ING2', 16203),
(16204, 'cd14480', NULL, 'SPX_VTC2_like', NULL, NULL, 'SPX_VTC2_like', 16204),
(16205, 'cd04780', NULL, 'HTH_MerR-like_sg5', NULL, NULL, 'HTH_MerR-like_sg5', 16205),
(16206, 'cd12665', NULL, 'RRM2_RAVER1', NULL, NULL, 'RRM2_RAVER1', 16206),
(16207, 'cd00099', NULL, 'IgV', NULL, NULL, 'IgV', 16207),
(16208, 'cd03734', NULL, 'SOCS_CIS1', NULL, NULL, 'SOCS_CIS1', 16208),
(16209, 'cd18210', NULL, 'BTB_POZ_ZBTB22_BING1', NULL, NULL, 'BTB_POZ_ZBTB22_BING1', 16209);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(16210, 'cd11981', NULL, 'SH3_VAV3_1', NULL, NULL, 'SH3_VAV3_1', 16210),
(16211, 'cd05384', NULL, 'CAP_PRY1-like', NULL, NULL, 'CAP_PRY1-like', 16211),
(16212, 'cd08176', NULL, 'LPO', NULL, NULL, 'LPO', 16212),
(16213, 'cd13970', NULL, 'ABC1_ADCK3', NULL, NULL, 'ABC1_ADCK3', 16213),
(16214, 'cd16395', NULL, 'Srx', NULL, NULL, 'Srx', 16214),
(16215, 'cd06130', NULL, 'DNA_pol_III_epsilon_like', NULL, NULL, 'DNA_pol_III_epsilon_like', 16215),
(16216, 'cd13569', NULL, 'PBP2_TAXI_TRAP_like_1', NULL, NULL, 'PBP2_TAXI_TRAP_like_1', 16216),
(16217, 'cd06277', NULL, 'PBP1_LacI-like', NULL, NULL, 'PBP1_LacI-like', 16217),
(16218, 'cd13713', NULL, 'PBP2_Cystine_like_1', NULL, NULL, 'PBP2_Cystine_like_1', 16218),
(16219, 'cd02650', NULL, 'nuc_hydro_CaPnhB', NULL, NULL, 'nuc_hydro_CaPnhB', 16219),
(16220, 'cd09029', NULL, 'ArfGap_ArfGap2', NULL, NULL, 'ArfGap_ArfGap2', 16220),
(16221, 'cd17768', NULL, 'adenosylhopane_nucleosidase_HpnG-like', NULL, NULL, 'adenosylhopane_nucleosidase_HpnG-like', 16221),
(16222, 'cd18703', NULL, 'PIN_VapC-like', NULL, NULL, 'PIN_VapC-like', 16222),
(16223, 'cd13738', NULL, 'SPRY_PRY_TRIM14', NULL, NULL, 'SPRY_PRY_TRIM14', 16223),
(16224, 'cd03799', NULL, 'GT4_AmsK-like', NULL, NULL, 'GT4_AmsK-like', 16224),
(16225, 'cd12113', NULL, 'PHP_PolIIIA_DnaE3', NULL, NULL, 'PHP_PolIIIA_DnaE3', 16225),
(16226, 'cd16386', NULL, 'TcpC_N', NULL, NULL, 'TcpC_N', 16226),
(16227, 'cd19883', NULL, 'DSRM_STAU1_rpt3', NULL, NULL, 'DSRM_STAU1_rpt3', 16227),
(16228, 'cd17633', NULL, 'AFD_YhfT-like', NULL, NULL, 'AFD_YhfT-like', 16228),
(16229, 'cd01960', NULL, 'nsLTP1', NULL, NULL, 'nsLTP1', 16229),
(16230, 'cd15254', NULL, '7tmB2_GPR116_Ig-Hepta', NULL, NULL, '7tmB2_GPR116_Ig-Hepta', 16230),
(16231, 'cd07628', NULL, 'BAR_Atg24p', NULL, NULL, 'BAR_Atg24p', 16231),
(16232, 'cd07720', NULL, 'OPHC2-like_MBL-fold', NULL, NULL, 'OPHC2-like_MBL-fold', 16232),
(16233, 'cd14752', NULL, 'GH31_N', NULL, NULL, 'GH31_N', 16233),
(16234, 'cd19591', NULL, 'serpin_like', NULL, NULL, 'serpin_like', 16234),
(16235, 'cd03507', NULL, 'Delta12-FADS-like', NULL, NULL, 'Delta12-FADS-like', 16235),
(16236, 'cd10348', NULL, 'SH2_Cterm_shark_like', NULL, NULL, 'SH2_Cterm_shark_like', 16236),
(16237, 'cd04756', NULL, 'Commd8', NULL, NULL, 'Commd8', 16237),
(16238, 'cd15605', NULL, 'PHD1_Lid_like', NULL, NULL, 'PHD1_Lid_like', 16238),
(16239, 'cd01572', NULL, 'QPRTase', NULL, NULL, 'QPRTase', 16239),
(16240, 'cd04467', NULL, 'S1_aIF5A', NULL, NULL, 'S1_aIF5A', 16240),
(16241, 'cd10566', NULL, 'MDM2_like', NULL, NULL, 'MDM2_like', 16241),
(16242, 'cd03234', NULL, 'ABCG_White', NULL, NULL, 'ABCG_White', 16242),
(16243, 'cd14665', NULL, 'STKc_SnRK2-3', NULL, NULL, 'STKc_SnRK2-3', 16243),
(16244, 'cd13874', NULL, 'CuRO_2_CopA', NULL, NULL, 'CuRO_2_CopA', 16244),
(16245, 'cd02601', NULL, 'HAD_Eya', NULL, NULL, 'HAD_Eya', 16245),
(16246, 'cd19188', NULL, 'PR-SET_PRDM2', NULL, NULL, 'PR-SET_PRDM2', 16246),
(16247, 'cd19975', NULL, 'PBP1_CcpA-like', NULL, NULL, 'PBP1_CcpA-like', 16247),
(16248, 'cd11506', NULL, 'SLC6sbd_GAT1', NULL, NULL, 'SLC6sbd_GAT1', 16248),
(16249, 'cd05639', NULL, 'M18', NULL, NULL, 'M18', 16249),
(16250, 'cd03262', NULL, 'ABC_HisP_GlnQ', NULL, NULL, 'ABC_HisP_GlnQ', 16250),
(16251, 'cd08183', NULL, 'Fe-ADH-like', NULL, NULL, 'Fe-ADH-like', 16251),
(16252, 'cd01878', NULL, 'HflX', NULL, NULL, 'HflX', 16252),
(16253, 'cd18764', NULL, 'PIN_MtVapC3-like', NULL, NULL, 'PIN_MtVapC3-like', 16253),
(16254, 'cd11504', NULL, 'SLC5sbd_SMVT', NULL, NULL, 'SLC5sbd_SMVT', 16254),
(16255, 'cd14708', NULL, 'bZIP_HBP1b-like', NULL, NULL, 'bZIP_HBP1b-like', 16255),
(16256, 'cd17106', NULL, 'FERM_F1_EPB41L', NULL, NULL, 'FERM_F1_EPB41L', 16256),
(16257, 'cd10415', NULL, 'SH2_Grb10', NULL, NULL, 'SH2_Grb10', 16257),
(16258, 'cd07197', NULL, 'nitrilase', NULL, NULL, 'nitrilase', 16258),
(16259, 'cd13216', NULL, 'PH-GRAM2_AGT26', NULL, NULL, 'PH-GRAM2_AGT26', 16259),
(16260, 'cd19343', NULL, 'Wnt_Wnt11', NULL, NULL, 'Wnt_Wnt11', 16260),
(16261, 'cd13147', NULL, 'MATE_MJ0709_like', NULL, NULL, 'MATE_MJ0709_like', 16261),
(16262, 'cd15014', NULL, '7tm_TAS2R40', NULL, NULL, '7tm_TAS2R40', 16262);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(16263, 'cd08791', NULL, 'DED_DEDD2', NULL, NULL, 'DED_DEDD2', 16263),
(16264, 'cd05143', NULL, 'Barstar_SaI14_like', NULL, NULL, 'Barstar_SaI14_like', 16264),
(16265, 'cd15946', NULL, '7tmA_OR1330-like', NULL, NULL, '7tmA_OR1330-like', 16265),
(16266, 'cd08220', NULL, 'STKc_Nek8', NULL, NULL, 'STKc_Nek8', 16266),
(16267, 'cd14487', NULL, 'AlgX_C', NULL, NULL, 'AlgX_C', 16267),
(16268, 'cd15153', NULL, '7tmA_P2Y10', NULL, NULL, '7tmA_P2Y10', 16268),
(16269, 'cd05472', NULL, 'cnd41_like', NULL, NULL, 'cnd41_like', 16269),
(16270, 'cd05629', NULL, 'STKc_NDR_like_fungal', NULL, NULL, 'STKc_NDR_like_fungal', 16270),
(16271, 'cd12883', NULL, 'SPRY_RING', NULL, NULL, 'SPRY_RING', 16271),
(16272, 'cd13741', NULL, 'SPRY_PRY_TRIM41', NULL, NULL, 'SPRY_PRY_TRIM41', 16272),
(16273, 'cd07383', NULL, 'MPP_Dcr2', NULL, NULL, 'MPP_Dcr2', 16273),
(16274, 'cd19096', NULL, 'AKR_Fe-S_oxidoreductase', NULL, NULL, 'AKR_Fe-S_oxidoreductase', 16274),
(16275, 'cd00452', NULL, 'KDPG_aldolase', NULL, NULL, 'KDPG_aldolase', 16275),
(16276, 'cd07573', NULL, 'CPA', NULL, NULL, 'CPA', 16276),
(16277, 'cd01078', NULL, 'NAD_bind_H4MPT_DH', NULL, NULL, 'NAD_bind_H4MPT_DH', 16277),
(16278, 'cd06401', NULL, 'PB1_TFG', NULL, NULL, 'PB1_TFG', 16278),
(16279, 'cd08329', NULL, 'CARD_BIRC2_BIRC3', NULL, NULL, 'CARD_BIRC2_BIRC3', 16279),
(16280, 'cd03148', NULL, 'GATase1_EcHsp31_like', NULL, NULL, 'GATase1_EcHsp31_like', 16280),
(16281, 'cd02892', NULL, 'SQCY_1', NULL, NULL, 'SQCY_1', 16281),
(16282, 'cd18745', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, 'PIN_VapC4-5_FitB-like', 16282),
(16283, 'cd11658', NULL, 'SANT_DMAP1_like', NULL, NULL, 'SANT_DMAP1_like', 16283),
(16284, 'cd15287', NULL, '7tmC_TAS1R2a-like', NULL, NULL, '7tmC_TAS1R2a-like', 16284),
(16285, 'cd12945', NULL, 'NOPS_NONA_like', NULL, NULL, 'NOPS_NONA_like', 16285),
(16286, 'cd16855', NULL, 'STAT5_CCD', NULL, NULL, 'STAT5_CCD', 16286),
(16287, 'cd15364', NULL, '7tmA_GPR132_G2A', NULL, NULL, '7tmA_GPR132_G2A', 16287),
(16288, 'cd16998', NULL, 'VHS_GGA_fungi', NULL, NULL, 'VHS_GGA_fungi', 16288),
(16289, 'cd14455', NULL, 'CuRO_6_FV_like', NULL, NULL, 'CuRO_6_FV_like', 16289),
(16290, 'cd18111', NULL, 'ATP-synt_V_A-type_alpha_C', NULL, NULL, 'ATP-synt_V_A-type_alpha_C', 16290),
(16291, 'cd04604', NULL, 'CBS_pair_SIS_assoc', NULL, NULL, 'CBS_pair_SIS_assoc', 16291),
(16292, 'cd17720', NULL, 'BRCT_Bard1_rpt2', NULL, NULL, 'BRCT_Bard1_rpt2', 16292),
(16293, 'cd09352', NULL, 'LIM1_Ajuba_like', NULL, NULL, 'LIM1_Ajuba_like', 16293),
(16294, 'cd18137', NULL, 'HLD_clamp_pol_III_gamma_tau', NULL, NULL, 'HLD_clamp_pol_III_gamma_tau', 16294),
(16295, 'cd11438', NULL, 'bHLH-PAS_ARNTL_PASD3', NULL, NULL, 'bHLH-PAS_ARNTL_PASD3', 16295),
(16296, 'cd09455', NULL, 'LIM1_Enigma_like_1', NULL, NULL, 'LIM1_Enigma_like_1', 16296),
(16297, 'cd16867', NULL, 'ARID_ARID3', NULL, NULL, 'ARID_ARID3', 16297),
(16298, 'cd09322', NULL, 'TDT_TehA_like', NULL, NULL, 'TDT_TehA_like', 16298),
(16299, 'cd08844', NULL, 'ArfGap_ADAP2', NULL, NULL, 'ArfGap_ADAP2', 16299),
(16300, 'cd12448', NULL, 'RRM2_gar2', NULL, NULL, 'RRM2_gar2', 16300),
(16301, 'cd18387', NULL, 'BTB_POZ_KCTD1', NULL, NULL, 'BTB_POZ_KCTD1', 16301),
(16302, 'cd12838', NULL, 'Killer_toxin_alpha', NULL, NULL, 'Killer_toxin_alpha', 16302),
(16303, 'cd13306', NULL, 'PH1_AFAP', NULL, NULL, 'PH1_AFAP', 16303),
(16304, 'cd18771', NULL, 'PIN_Mut7-C-like', NULL, NULL, 'PIN_Mut7-C-like', 16304),
(16305, 'cd01439', NULL, 'TCCD_inducible_PARP_like', NULL, NULL, 'TCCD_inducible_PARP_like', 16305),
(16306, 'cd06821', NULL, 'PLPDE_III_D-TA', NULL, NULL, 'PLPDE_III_D-TA', 16306),
(16307, 'cd10387', NULL, 'SH2_SOCS6', NULL, NULL, 'SH2_SOCS6', 16307),
(16308, 'cd07451', NULL, 'CRD_SMO', NULL, NULL, 'CRD_SMO', 16308),
(16309, 'cd16349', NULL, 'VOC_like', NULL, NULL, 'VOC_like', 16309),
(16310, 'cd15055', NULL, '7tmA_TAARs', NULL, NULL, '7tmA_TAARs', 16310),
(16311, 'cd09120', NULL, 'PLDc_DNaseII_1', NULL, NULL, 'PLDc_DNaseII_1', 16311),
(16312, 'cd12714', NULL, 'RRM1_MATR3', NULL, NULL, 'RRM1_MATR3', 16312),
(16313, 'cd11813', NULL, 'SH3_SGSM3', NULL, NULL, 'SH3_SGSM3', 16313); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(16314, 'cd00236', NULL, 'FinO_conjug_rep', NULL, NULL, 'FinO_conjug_rep', 16314),
(16315, 'cd04779', NULL, 'HTH_MerR-like_sg4', NULL, NULL, 'HTH_MerR-like_sg4', 16315),
(16316, 'cd19077', NULL, 'AKR_AKR8A1-2', NULL, NULL, 'AKR_AKR8A1-2', 16316),
(16317, 'cd15997', NULL, '7tmB2_GPR112', NULL, NULL, '7tmB2_GPR112', 16317),
(16318, 'cd11473', NULL, 'W2', NULL, NULL, 'W2', 16318),
(16319, 'cd00047', NULL, 'PTPc', NULL, NULL, 'PTPc', 16319),
(16320, 'cd12242', NULL, 'RRM_SLIRP', NULL, NULL, 'RRM_SLIRP', 16320),
(16321, 'cd17049', NULL, 'Ubl_Sacsin', NULL, NULL, 'Ubl_Sacsin', 16321),
(16322, 'cd13211', NULL, 'PH-GRAM_MTMR9', NULL, NULL, 'PH-GRAM_MTMR9', 16322),
(16323, 'cd17282', NULL, 'RMtype1_S_Eco16444ORF1681_TRD1-CR1_like', NULL, NULL, 'RMtype1_S_Eco16444ORF1681_TRD1-CR1_like', 16323),
(16324, 'cd04972', NULL, 'Ig_TrkABC_d4', NULL, NULL, 'Ig_TrkABC_d4', 16324),
(16325, 'cd07210', NULL, 'Pat_hypo_W_succinogenes_WS1459_like', NULL, NULL, 'Pat_hypo_W_succinogenes_WS1459_like', 16325),
(16326, 'cd00608', NULL, 'GalT', NULL, NULL, 'GalT', 16326),
(16327, 'cd14592', NULL, 'PTP-MTMR1', NULL, NULL, 'PTP-MTMR1', 16327),
(16328, 'cd15612', NULL, 'PHD_OBE1_like', NULL, NULL, 'PHD_OBE1_like', 16328),
(16329, 'cd16809', NULL, 'RING_CH-C4HC3_MARCH3', NULL, NULL, 'RING_CH-C4HC3_MARCH3', 16329),
(16330, 'cd04280', NULL, 'ZnMc_astacin_like', NULL, NULL, 'ZnMc_astacin_like', 16330),
(16331, 'cd12106', NULL, 'PARMER_03128_N', NULL, NULL, 'PARMER_03128_N', 16331),
(16332, 'cd14103', NULL, 'STKc_MLCK', NULL, NULL, 'STKc_MLCK', 16332),
(16333, 'cd19902', NULL, 'DSRM_DRADA', NULL, NULL, 'DSRM_DRADA', 16333),
(16334, 'cd00874', NULL, 'RNA_Cyclase_Class_II', NULL, NULL, 'RNA_Cyclase_Class_II', 16334),
(16335, 'cd08680', NULL, 'C2_Kibra', NULL, NULL, 'C2_Kibra', 16335),
(16336, 'cd09670', NULL, 'Cse2_I-E', NULL, NULL, 'Cse2_I-E', 16336),
(16337, 'cd07922', NULL, 'CarBa', NULL, NULL, 'CarBa', 16337),
(16338, 'cd16177', NULL, 'EFh_HEF_CR', NULL, NULL, 'EFh_HEF_CR', 16338),
(16339, 'cd05654', NULL, 'M20_ArgE_RocB', NULL, NULL, 'M20_ArgE_RocB', 16339),
(16340, 'cd07990', NULL, 'LPLAT_LCLAT1-like', NULL, NULL, 'LPLAT_LCLAT1-like', 16340),
(16341, 'cd11348', NULL, 'AmyAc_2', NULL, NULL, 'AmyAc_2', 16341),
(16342, 'cd01252', NULL, 'PH_GRP1-like', NULL, NULL, 'PH_GRP1-like', 16342),
(16343, 'cd15979', NULL, '7tmA_CCK-BR', NULL, NULL, '7tmA_CCK-BR', 16343),
(16344, 'cd07539', NULL, 'P-type_ATPase', NULL, NULL, 'P-type_ATPase', 16344),
(16345, 'cd14215', NULL, 'PKc_CLK2', NULL, NULL, 'PKc_CLK2', 16345),
(16346, 'cd02640', NULL, 'R3H_NRF', NULL, NULL, 'R3H_NRF', 16346),
(16347, 'cd05322', NULL, 'SDH_SDR_c_like', NULL, NULL, 'SDH_SDR_c_like', 16347),
(16348, 'cd01450', NULL, 'vWFA_subfamily_ECM', NULL, NULL, 'vWFA_subfamily_ECM', 16348),
(16349, 'cd06614', NULL, 'STKc_PAK', NULL, NULL, 'STKc_PAK', 16349),
(16350, 'cd16936', NULL, 'HATPase_RsbW-like', NULL, NULL, 'HATPase_RsbW-like', 16350),
(16351, 'cd18320', NULL, 'BTB_POZ_KBTBD13', NULL, NULL, 'BTB_POZ_KBTBD13', 16351),
(16352, 'cd08494', NULL, 'PBP2_NikA_DppA_OppA_like_6', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_6', 16352),
(16353, 'cd02092', NULL, 'P-type_ATPase_FixI-like', NULL, NULL, 'P-type_ATPase_FixI-like', 16353),
(16354, 'cd04148', NULL, 'RGK', NULL, NULL, 'RGK', 16354),
(16355, 'cd01896', NULL, 'DRG', NULL, NULL, 'DRG', 16355),
(16356, 'cd19555', NULL, 'serpinA7_TBG', NULL, NULL, 'serpinA7_TBG', 16356),
(16357, 'cd00224', NULL, 'Mog1', NULL, NULL, 'Mog1', 16357),
(16358, 'cd05577', NULL, 'STKc_GRK', NULL, NULL, 'STKc_GRK', 16358),
(16359, 'cd08150', NULL, 'catalase_like', NULL, NULL, 'catalase_like', 16359),
(16360, 'cd02072', NULL, 'Glm_B12_BD', NULL, NULL, 'Glm_B12_BD', 16360),
(16361, 'cd00758', NULL, 'MoCF_BD', NULL, NULL, 'MoCF_BD', 16361),
(16362, 'cd11398', NULL, 'bHLHzip_scCBP1', NULL, NULL, 'bHLHzip_scCBP1', 16362),
(16363, 'cd10813', NULL, 'GH38N_AMII_Man2C1', NULL, NULL, 'GH38N_AMII_Man2C1', 16363),
(16364, 'cd06418', NULL, 'GH25_BacA-like', NULL, NULL, 'GH25_BacA-like', 16364),
(16365, 'cd15817', NULL, 'SPRY_PRY_TRIM60_75', NULL, NULL, 'SPRY_PRY_TRIM60_75', 16365);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(16366, 'cd01731', NULL, 'archaeal_Sm1', NULL, NULL, 'archaeal_Sm1', 16366),
(16367, 'cd17712', NULL, 'BRCT_PAXIP1_rpt5', NULL, NULL, 'BRCT_PAXIP1_rpt5', 16367),
(16368, 'cd12908', NULL, 'SPRYD3', NULL, NULL, 'SPRYD3', 16368),
(16369, 'cd18369', NULL, 'BTB_POZ_KCTD10-like_BACURD', NULL, NULL, 'BTB_POZ_KCTD10-like_BACURD', 16369),
(16370, 'cd16402', NULL, 'ParB_N_like_MT', NULL, NULL, 'ParB_N_like_MT', 16370),
(16371, 'cd14096', NULL, 'STKc_RCK1-like', NULL, NULL, 'STKc_RCK1-like', 16371),
(16372, 'cd13445', NULL, 'CDI_inhibitor_EC869_like', NULL, NULL, 'CDI_inhibitor_EC869_like', 16372),
(16373, 'cd01215', NULL, 'PTB_Dab', NULL, NULL, 'PTB_Dab', 16373),
(16374, 'cd12203', NULL, 'GT1', NULL, NULL, 'GT1', 16374),
(16375, 'cd11661', NULL, 'SANT_MTA3_like', NULL, NULL, 'SANT_MTA3_like', 16375),
(16376, 'cd19682', NULL, 'bHLHzip_MGA_like', NULL, NULL, 'bHLHzip_MGA_like', 16376),
(16377, 'cd14814', NULL, 'Peptidase_M15', NULL, NULL, 'Peptidase_M15', 16377),
(16378, 'cd06652', NULL, 'STKc_MEKK2', NULL, NULL, 'STKc_MEKK2', 16378),
(16379, 'cd14911', NULL, 'MYSc_Myh2_insects_mollusks', NULL, NULL, 'MYSc_Myh2_insects_mollusks', 16379),
(16380, 'cd08255', NULL, '2-desacetyl-2-hydroxyethyl_bacteriochlorophyll...', NULL, NULL, '2-desacetyl-2-hydroxyethyl_bacteriochlorophyllide_like', 16380),
(16381, 'cd01884', NULL, 'EF_Tu', NULL, NULL, 'EF_Tu', 16381),
(16382, 'cd02771', NULL, 'MopB_NDH-1_NuoG2-N7', NULL, NULL, 'MopB_NDH-1_NuoG2-N7', 16382),
(16383, 'cd12408', NULL, 'RRM_eIF3G_like', NULL, NULL, 'RRM_eIF3G_like', 16383),
(16384, 'cd12701', NULL, 'RRM4_PTBP1', NULL, NULL, 'RRM4_PTBP1', 16384),
(16385, 'cd14604', NULL, 'PTPc-N12', NULL, NULL, 'PTPc-N12', 16385),
(16386, 'cd11991', NULL, 'SH3_Intersectin1_3', NULL, NULL, 'SH3_Intersectin1_3', 16386),
(16387, 'cd15786', NULL, 'CPF_1278_like', NULL, NULL, 'CPF_1278_like', 16387),
(16388, 'cd14609', NULL, 'R-PTP-N', NULL, NULL, 'R-PTP-N', 16388),
(16389, 'cd08277', NULL, 'liver_alcohol_DH_like', NULL, NULL, 'liver_alcohol_DH_like', 16389),
(16390, 'cd17163', NULL, 'Ubl_ATG8_GABARAPL2', NULL, NULL, 'Ubl_ATG8_GABARAPL2', 16390),
(16391, 'cd16601', NULL, 'RING-HC_TRIM39_C-IV', NULL, NULL, 'RING-HC_TRIM39_C-IV', 16391),
(16392, 'cd19684', NULL, 'bHLH_dnHLH_ID', NULL, NULL, 'bHLH_dnHLH_ID', 16392),
(16393, 'cd15227', NULL, '7tmA_OR14-like', NULL, NULL, '7tmA_OR14-like', 16393),
(16394, 'cd16785', NULL, 'mRING-HC-C3HC5_NEU1A', NULL, NULL, 'mRING-HC-C3HC5_NEU1A', 16394),
(16395, 'cd02751', NULL, 'MopB_DMSOR-like', NULL, NULL, 'MopB_DMSOR-like', 16395),
(16396, 'cd11911', NULL, 'SH3_CIP4-like', NULL, NULL, 'SH3_CIP4-like', 16396),
(16397, 'cd09548', NULL, 'SAM_EPH-A7', NULL, NULL, 'SAM_EPH-A7', 16397),
(16398, 'cd07809', NULL, 'FGGY_D-XK_1', NULL, NULL, 'FGGY_D-XK_1', 16398),
(16399, 'cd03218', NULL, 'ABC_YhbG', NULL, NULL, 'ABC_YhbG', 16399),
(16400, 'cd19865', NULL, 'DSRM_STRBP_RED-like_rpt1', NULL, NULL, 'DSRM_STRBP_RED-like_rpt1', 16400),
(16401, 'cd10147', NULL, 'Wzt_C-like', NULL, NULL, 'Wzt_C-like', 16401),
(16402, 'cd06658', NULL, 'STKc_PAK5', NULL, NULL, 'STKc_PAK5', 16402),
(16403, 'cd06914', NULL, 'GT8_GNT1', NULL, NULL, 'GT8_GNT1', 16403),
(16404, 'cd12545', NULL, 'RRM_IN35', NULL, NULL, 'RRM_IN35', 16404),
(16405, 'cd18830', NULL, 'GH43_CjArb43A-like', NULL, NULL, 'GH43_CjArb43A-like', 16405),
(16406, 'cd19195', NULL, 'PR-SET_PRDM11', NULL, NULL, 'PR-SET_PRDM11', 16406),
(16407, 'cd17222', NULL, 'RA_RASSF4', NULL, NULL, 'RA_RASSF4', 16407),
(16408, 'cd12355', NULL, 'RRM_RBM18', NULL, NULL, 'RRM_RBM18', 16408),
(16409, 'cd18255', NULL, 'BTB_POZ_KLHL26', NULL, NULL, 'BTB_POZ_KLHL26', 16409),
(16410, 'cd16526', NULL, 'RING-HC_PEX2', NULL, NULL, 'RING-HC_PEX2', 16410),
(16411, 'cd05794', NULL, 'S1_EF-P_repeat_2', NULL, NULL, 'S1_EF-P_repeat_2', 16411),
(16412, 'cd14961', NULL, 'NHL_TRIM32_like', NULL, NULL, 'NHL_TRIM32_like', 16412),
(16413, 'cd02987', NULL, 'Phd_like_Phd', NULL, NULL, 'Phd_like_Phd', 16413),
(16414, 'cd03243', NULL, 'ABC_MutS_homologs', NULL, NULL, 'ABC_MutS_homologs', 16414),
(16415, 'cd14366', NULL, 'CUE_CUED1', NULL, NULL, 'CUE_CUED1', 16415);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(16416, 'cd03226', NULL, 'ABC_cobalt_CbiO_domain2', NULL, NULL, 'ABC_cobalt_CbiO_domain2', 16416),
(16417, 'cd18236', NULL, 'BTB_POZ_KLHL6', NULL, NULL, 'BTB_POZ_KLHL6', 16417),
(16418, 'cd13599', NULL, 'PBP2_lipoprotein_Gna1946', NULL, NULL, 'PBP2_lipoprotein_Gna1946', 16418),
(16419, 'cd17618', NULL, 'REC_OmpR_PhoB', NULL, NULL, 'REC_OmpR_PhoB', 16419),
(16420, 'cd01525', NULL, 'RHOD_Kc', NULL, NULL, 'RHOD_Kc', 16420),
(16421, 'cd08478', NULL, 'PBP2_CrgA', NULL, NULL, 'PBP2_CrgA', 16421),
(16422, 'cd09820', NULL, 'dual_peroxidase_like', NULL, NULL, 'dual_peroxidase_like', 16422),
(16423, 'cd18439', NULL, 'BRCT_BRC1_like_rpt6', NULL, NULL, 'BRCT_BRC1_like_rpt6', 16423),
(16424, 'cd11810', NULL, 'SH3_RUSC1_like', NULL, NULL, 'SH3_RUSC1_like', 16424),
(16425, 'cd15981', NULL, '7tmA_NPFFR1', NULL, NULL, '7tmA_NPFFR1', 16425),
(16426, 'cd17281', NULL, 'RMtype1_S_HpyAXIII_TRD1-CR1_like', NULL, NULL, 'RMtype1_S_HpyAXIII_TRD1-CR1_like', 16426),
(16427, 'cd13897', NULL, 'CuRO_3_LCC_plant', NULL, NULL, 'CuRO_3_LCC_plant', 16427),
(16428, 'cd05739', NULL, 'Ig3_RPTP_IIa_LAR_like', NULL, NULL, 'Ig3_RPTP_IIa_LAR_like', 16428),
(16429, 'cd16351', NULL, 'CheB_like', NULL, NULL, 'CheB_like', 16429),
(16430, 'cd15705', NULL, 'ePHD_JADE2', NULL, NULL, 'ePHD_JADE2', 16430),
(16431, 'cd12630', NULL, 'RRM2_IGF2BP3', NULL, NULL, 'RRM2_IGF2BP3', 16431),
(16432, 'cd08405', NULL, 'C2B_Synaptotagmin-7', NULL, NULL, 'C2B_Synaptotagmin-7', 16432),
(16433, 'cd09387', NULL, 'LIM2_LMO4', NULL, NULL, 'LIM2_LMO4', 16433),
(16434, 'cd18540', NULL, 'ABC_6TM_exporter_like', NULL, NULL, 'ABC_6TM_exporter_like', 16434),
(16435, 'cd19028', NULL, 'LGIC_ECD_nAChR_D', NULL, NULL, 'LGIC_ECD_nAChR_D', 16435),
(16436, 'cd02952', NULL, 'TRP14_like', NULL, NULL, 'TRP14_like', 16436),
(16437, 'cd19074', NULL, 'Aldo_ket_red_shaker-like', NULL, NULL, 'Aldo_ket_red_shaker-like', 16437),
(16438, 'cd13574', NULL, 'PBP2_PnhD_4', NULL, NULL, 'PBP2_PnhD_4', 16438),
(16439, 'cd18426', NULL, 'BTB_POZ_KCNS1', NULL, NULL, 'BTB_POZ_KCNS1', 16439),
(16440, 'cd06246', NULL, 'M14_CPB2', NULL, NULL, 'M14_CPB2', 16440),
(16441, 'cd11256', NULL, 'Sema_4A', NULL, NULL, 'Sema_4A', 16441),
(16442, 'cd14450', NULL, 'CuRO_3_FV_like', NULL, NULL, 'CuRO_3_FV_like', 16442),
(16443, 'cd18666', NULL, 'CD1_tandem_CHD1-2_like', NULL, NULL, 'CD1_tandem_CHD1-2_like', 16443),
(16444, 'cd16842', NULL, 'Ig_SLAM-CD84_like_N', NULL, NULL, 'Ig_SLAM-CD84_like_N', 16444),
(16445, 'cd08271', NULL, 'MDR5', NULL, NULL, 'MDR5', 16445),
(16446, 'cd11483', NULL, 'SLC-NCS1sbd_Mhp1-like', NULL, NULL, 'SLC-NCS1sbd_Mhp1-like', 16446),
(16447, 'cd12103', NULL, 'DD_RIIalpha_PKA', NULL, NULL, 'DD_RIIalpha_PKA', 16447),
(16448, 'cd09622', NULL, 'CBM9_like_HisKa', NULL, NULL, 'CBM9_like_HisKa', 16448),
(16449, 'cd03310', NULL, 'CIMS_like', NULL, NULL, 'CIMS_like', 16449),
(16450, 'cd04483', NULL, 'hOBFC1_like', NULL, NULL, 'hOBFC1_like', 16450),
(16451, 'cd14879', NULL, 'MYSc_Myo17', NULL, NULL, 'MYSc_Myo17', 16451),
(16452, 'cd15449', NULL, '7tmC_mGluR1', NULL, NULL, '7tmC_mGluR1', 16452),
(16453, 'cd18779', NULL, 'ABC_6TM_T1SS_like', NULL, NULL, 'ABC_6TM_T1SS_like', 16453),
(16454, 'cd14331', NULL, 'UBA_HERC1_2', NULL, NULL, 'UBA_HERC1_2', 16454),
(16455, 'cd03342', NULL, 'TCP1_zeta', NULL, NULL, 'TCP1_zeta', 16455),
(16456, 'cd13907', NULL, 'CuRO_3_MCO_like_1', NULL, NULL, 'CuRO_3_MCO_like_1', 16456),
(16457, 'cd08380', NULL, 'C2_PI3K_like', NULL, NULL, 'C2_PI3K_like', 16457),
(16458, 'cd05014', NULL, 'SIS_Kpsf', NULL, NULL, 'SIS_Kpsf', 16458),
(16459, 'cd01002', NULL, 'PBP2_Ehub_like', NULL, NULL, 'PBP2_Ehub_like', 16459),
(16460, 'cd13664', NULL, 'PBP2_PotD_PotF_like_3', NULL, NULL, 'PBP2_PotD_PotF_like_3', 16460),
(16461, 'cd17748', NULL, 'BRCT_DNA_ligase_like', NULL, NULL, 'BRCT_DNA_ligase_like', 16461),
(16462, 'cd14280', NULL, 'UBA1_Rad23_like', NULL, NULL, 'UBA1_Rad23_like', 16462),
(16463, 'cd19575', NULL, 'serpinH2', NULL, NULL, 'serpinH2', 16463),
(16464, 'cd19345', NULL, 'Wnt_Wnt2', NULL, NULL, 'Wnt_Wnt2', 16464),
(16465, 'cd07157', NULL, '2DBD_NR_DBD1', NULL, NULL, '2DBD_NR_DBD1', 16465);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(16466, 'cd15675', NULL, 'ePHD_JMJD2', NULL, NULL, 'ePHD_JMJD2', 16466),
(16467, 'cd16649', NULL, 'mRING-HC-C3HC5_CGRF1_like', NULL, NULL, 'mRING-HC-C3HC5_CGRF1_like', 16467),
(16468, 'cd11316', NULL, 'AmyAc_bac2_AmyA', NULL, NULL, 'AmyAc_bac2_AmyA', 16468),
(16469, 'cd00431', NULL, 'cysteine_hydrolases', NULL, NULL, 'cysteine_hydrolases', 16469),
(16470, 'cd16557', NULL, 'RING-HC_RNF186', NULL, NULL, 'RING-HC_RNF186', 16470),
(16471, 'cd09973', NULL, 'LOTUS_2_TDRD7', NULL, NULL, 'LOTUS_2_TDRD7', 16471),
(16472, 'cd18353', NULL, 'BTB_POZ_RCBTB1_CLLD7', NULL, NULL, 'BTB_POZ_RCBTB1_CLLD7', 16472),
(16473, 'cd16837', NULL, 'BldD_C_like', NULL, NULL, 'BldD_C_like', 16473),
(16474, 'cd00781', NULL, 'ketosteroid_isomerase', NULL, NULL, 'ketosteroid_isomerase', 16474),
(16475, 'cd10472', NULL, 'EphR_LBD_B', NULL, NULL, 'EphR_LBD_B', 16475),
(16476, 'Coil', NULL, NULL, NULL, NULL, 'Coil', 16476),
(16477, '1.20.1070.10-FF-001393', NULL, 'Uncharacterized protein', 243, NULL, NULL, 16477),
(16478, '3.40.50.620-FF-000861', NULL, 'Uncharacterized protein', 171, NULL, NULL, 16478),
(16479, '2.40.50.40-FF-000016', NULL, 'Histone-lysine N-methyltransferase', 61, NULL, NULL, 16479),
(16480, '3.30.160.60-FF-004795', NULL, NULL, 23, NULL, NULL, 16480),
(16481, '3.30.70.100-FF-000088', NULL, 'Copper chaperone', 67, NULL, NULL, 16481),
(16482, '1.20.1250.20-FF-001701', NULL, 'Uncharacterized protein', 391, NULL, NULL, 16482),
(16483, '1.20.1440.360-FF-000002', NULL, 'MAGUK p55 subfamily member 5-A', 127, NULL, NULL, 16483),
(16484, '3.80.10.10-FF-004290', NULL, 'AER145Wp', 239, NULL, NULL, 16484),
(16485, '1.10.287.70-FF-000219', NULL, 'KCNN (Potassium K ChaNNel, calcium activated)-Like', 236, NULL, NULL, 16485),
(16486, '2.60.40.10-FF-000545', NULL, 'Interleukin-11 receptor subunit alpha', 103, NULL, NULL, 16486),
(16487, '1.10.30.10-FF-000167', NULL, 'Uncharacterized protein', 46, NULL, NULL, 16487),
(16488, '3.40.50.300-FF-003137', NULL, 'Splicing endonuclease positive effector sen1, putative', 355, NULL, NULL, 16488),
(16489, '3.30.70.330-FF-002017', NULL, NULL, 53, NULL, NULL, 16489),
(16490, '3.30.70.330-FF-002489', NULL, NULL, 153, NULL, NULL, 16490),
(16491, '3.80.20.20-FF-000050', NULL, 'Predicted protein', 125, NULL, NULL, 16491),
(16492, '1.20.120.1900-FF-000077', NULL, 'Spindle pole body component', 275, NULL, NULL, 16492),
(16493, '2.60.40.1120-FF-000034', NULL, 'Outer membrane receptor for ferrienterochelin and colicins', 93, NULL, NULL, 16493),
(16494, '3.40.800.20-FF-000036', NULL, 'Histone deacetylase', 374, NULL, NULL, 16494),
(16495, '2.170.130.10-FF-000084', NULL, NULL, 127, NULL, NULL, 16495),
(16496, '1.10.135.10-FF-000018', NULL, 'Uncharacterized protein', 76, NULL, NULL, 16496),
(16497, '1.25.40.10-FF-000904', NULL, 'CesD/SycD/LcrH family type III secretion system chaperone', 151, NULL, NULL, 16497),
(16498, '1.10.10.60-FF-000658', NULL, 'Homeobox and leucine zipper encoding a', 61, NULL, NULL, 16498),
(16499, '3.30.980.10-FF-000008', NULL, 'Similar to alanyl-tRNA synthetase', 150, NULL, NULL, 16499),
(16500, '2.40.30.10-FF-000057', NULL, 'Mitochondrial tRNA-specific 2-thiouridylase 1', 88, NULL, NULL, 16500),
(16501, '3.30.200.20-FF-001313', NULL, 'Titin homolog', 85, NULL, NULL, 16501),
(16502, '2.60.120.330-FF-000016', NULL, 'Naringenin,2-oxoglutarate 3-dioxygenase', 328, NULL, NULL, 16502),
(16503, '2.60.40.10-FF-000984', NULL, 'Tyrosine-protein kinase receptor', 97, NULL, NULL, 16503),
(16504, '1.10.1300.10-FF-000042', NULL, 'Uncharacterized protein', 118, NULL, NULL, 16504),
(16505, '3.30.2140.20-FF-000009', NULL, 'Arylamine N-acetyltransferase 1', 287, NULL, NULL, 16505),
(16506, '3.10.450.10-FF-000057', NULL, 'Ovocalyxin-32', 96, NULL, NULL, 16506),
(16507, '3.30.200.20-FF-002302', NULL, 'Protein kinase, putative', 11, NULL, NULL, 16507),
(16508, '2.60.200.10-FF-000026', NULL, 'K9', 161, NULL, NULL, 16508),
(16509, '1.20.1250.20-FF-001168', NULL, 'AGAP005394-PA', 190, NULL, NULL, 16509),
(16510, '2.60.34.10-FF-000132', NULL, 'Stress-70 protein, mitochondrial', 90, NULL, NULL, 16510);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(16511, '3.40.850.10-FF-000070', NULL, 'Myosin A', 248, NULL, NULL, 16511),
(16512, '1.10.510.10-FF-002638', NULL, NULL, 209, NULL, NULL, 16512),
(16513, '1.10.540.10-FF-000049', NULL, 'Dehydrogenase', 107, NULL, NULL, 16513),
(16514, '2.160.20.110-FF-000003', NULL, 'Putative GLUG motif protein', 137, NULL, NULL, 16514),
(16515, '1.10.150.80-FF-000006', NULL, 'Ribonuclease D', 99, NULL, NULL, 16515),
(16516, '3.90.810.10-FF-000039', NULL, NULL, 72, NULL, NULL, 16516),
(16517, '1.20.1250.20-FF-002157', NULL, 'Organic anion transporter polypeptide (oatp) family protein', 194, NULL, NULL, 16517),
(16518, '3.20.20.80-FF-000536', NULL, 'Beta-xylanase', 351, NULL, NULL, 16518),
(16519, '1.25.40.10-FF-005255', NULL, 'Uncharacterized protein', 162, NULL, NULL, 16519),
(16520, '2.10.25.10-FF-001367', NULL, 'Predicted protein', 38, NULL, NULL, 16520),
(16521, '3.40.50.1000-FF-000676', NULL, NULL, 173, NULL, NULL, 16521),
(16522, '3.40.50.300-FF-008460', NULL, 'Uncharacterized protein', 77, NULL, NULL, 16522),
(16523, '1.20.930.40-FF-000030', NULL, 'Glutamate carboxypeptidase, putative', 133, NULL, NULL, 16523),
(16524, '3.40.630.10-FF-000379', NULL, 'Uncharacterized protein', 88, NULL, NULL, 16524),
(16525, '3.40.50.300-FF-000383', NULL, 'Dynamin-like gtpase dnm1', 302, NULL, NULL, 16525),
(16526, '3.30.450.20-FF-000516', NULL, 'Sensory transduction histidine kinase', 105, NULL, NULL, 16526),
(16527, '3.40.50.720-FF-002038', NULL, 'Uncharacterized protein', 185, NULL, NULL, 16527),
(16528, '2.40.70.10-FF-000503', NULL, NULL, 108, NULL, NULL, 16528),
(16529, '3.90.550.10-FF-000120', NULL, 'Glycosyl transferase, family 2', 267, NULL, NULL, 16529),
(16530, '3.20.20.100-FF-000001', NULL, 'voltage-gated potassium channel subunit beta-2 isoform X2', 326, NULL, NULL, 16530),
(16531, '2.40.160.50-FF-000033', NULL, 'Surface antigen-domain-containing protein', 337, NULL, NULL, 16531),
(16532, '3.30.420.10-FF-000478', NULL, 'Uncharacterized protein', 303, NULL, NULL, 16532),
(16533, '1.20.920.10-FF-000189', NULL, 'Uncharacterized protein', 149, NULL, NULL, 16533),
(16534, '3.40.140.10-FF-000212', NULL, 'Uncharacterized protein', 81, NULL, NULL, 16534),
(16535, '3.30.565.10-FF-000364', NULL, 'Uncharacterized protein', 106, NULL, NULL, 16535),
(16536, '1.10.460.10-FF-000015', NULL, 'DNA topoisomerase 1', 152, NULL, NULL, 16536),
(16537, '2.40.50.140-FF-000906', NULL, NULL, 63, NULL, NULL, 16537),
(16538, '3.90.1150.10-FF-000122', NULL, 'Dihydrodipicolinate reductase', 141, NULL, NULL, 16538),
(16539, '3.10.110.10-FF-000066', NULL, 'IMPACT isoform 1', 116, NULL, NULL, 16539),
(16540, '3.30.2350.10-FF-000045', NULL, 'Pseudouridine synthase', 228, NULL, NULL, 16540),
(16541, '3.30.160.60-FF-005784', NULL, NULL, 40, NULL, NULL, 16541),
(16542, '1.20.58.2070-FF-000002', NULL, 'Checkpoint serine/threonine-protein kinase BUB1', 77, NULL, NULL, 16542),
(16543, '1.10.8.10-FF-000064', NULL, 'Similar to CUE domain-containing protein', 52, NULL, NULL, 16543),
(16544, '3.30.420.10-FF-000006', NULL, 'Ribonuclease HII', 198, NULL, NULL, 16544),
(16545, '1.10.1780.10-FF-000010', NULL, 'ATP-dependent Clp protease ATP-binding subunit CLPT2, chloroplastic', 151, NULL, NULL, 16545),
(16546, '3.40.50.300-FF-007471', NULL, 'Helicase, putative', 239, NULL, NULL, 16546),
(16547, '1.20.920.20-FF-000046', NULL, 'Dynein heavy chain 3', 338, NULL, NULL, 16547),
(16548, '3.10.100.10-FF-000301', NULL, NULL, 122, NULL, NULL, 16548),
(16549, '1.10.8.710-FF-000008', NULL, 'Dynein axonemal heavy chain 3', 61, NULL, NULL, 16549),
(16550, '3.30.160.60-FF-004356', NULL, NULL, 59, NULL, NULL, 16550),
(16551, '3.90.950.10-FF-000049', NULL, 'Uncharacterized protein', 109, NULL, NULL, 16551),
(16552, '3.90.70.10-FF-000263', NULL, 'Ribosomal-protein-S18p-alanine acetyltransferase', 140, NULL, NULL, 16552),
(16553, '3.90.640.10-FF-000239', NULL, 'Heat shock protein 70 (HSP70), putative', 34, NULL, NULL, 16553),
(16554, '3.50.50.60-FF-000727', NULL, 'Mercuric reductase', 119, NULL, NULL, 16554),
(16555, '1.10.287.2170-FF-000002', NULL, 'First ORF in transposon ISC1904', 42, NULL, NULL, 16555);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(16556, '3.20.20.120-FF-000007', NULL, 'Mitochondrial enolase superfamily member 1', 307, NULL, NULL, 16556),
(16557, '2.40.50.140-FF-000586', NULL, 'Zgc:101853', 162, NULL, NULL, 16557),
(16558, '3.30.200.20-FF-000796', NULL, 'Non-specific serine/threonine protein kinase', 137, NULL, NULL, 16558),
(16559, '3.40.50.1980-FF-000065', NULL, 'Iron compound ABC transporter, substrate-binding protein, putative', 134, NULL, NULL, 16559),
(16560, '3.30.1490.80-FF-000002', NULL, 'Glutathione synthetase', 77, NULL, NULL, 16560),
(16561, '2.70.98.20-FF-000001', NULL, 'Amine oxidase', 424, NULL, NULL, 16561),
(16562, '3.30.230.10-FF-000295', NULL, 'DNA mismatch repair protein MutL', 117, NULL, NULL, 16562),
(16563, '3.80.10.10-FF-000748', NULL, 'Leucine-rich repeat-containing protein 40', 113, NULL, NULL, 16563),
(16564, '1.25.40.10-FF-001040', NULL, 'Activator of G protein Signalling', 76, NULL, NULL, 16564),
(16565, '2.120.10.80-FF-000106', NULL, 'Transcription factor INI', 109, NULL, NULL, 16565),
(16566, '3.40.50.10810-FF-000274', NULL, 'Uncharacterized protein', 82, NULL, NULL, 16566),
(16567, '1.10.260.40-FF-000082', NULL, '(S)-2-hydroxypropylphosphonic acid epoxidase', 78, NULL, NULL, 16567),
(16568, '3.40.1620.60-FF-000011', NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif A, isoform B', 90, NULL, NULL, 16568),
(16569, '1.20.930.10-FF-000015', NULL, 'Transcription elongation factor A1', 63, NULL, NULL, 16569),
(16570, '2.60.40.60-FF-000127', NULL, 'Protocadherin beta 1', 105, NULL, NULL, 16570),
(16571, '3.90.290.10-FF-000021', NULL, 'follistatin-related protein 3', 74, NULL, NULL, 16571),
(16572, '3.40.50.1000-FF-000204', NULL, 'Copper-translocating P-type ATPase', 170, NULL, NULL, 16572),
(16573, '4.10.240.10-FF-000184', NULL, 'Oleate-activated transcription factor 1', 87, NULL, NULL, 16573),
(16574, '3.40.50.460-FF-000026', NULL, '6-phosphofructokinase', 138, NULL, NULL, 16574),
(16575, '3.10.20.740-FF-000010', NULL, 'Periplasmic [Fe] hydrogenase large subunit', 122, NULL, NULL, 16575),
(16576, '2.60.40.1510-FF-000061', NULL, 'Integrin beta', 20, NULL, NULL, 16576),
(16577, '3.20.20.300-FF-000056', NULL, NULL, 143, NULL, NULL, 16577),
(16578, '3.30.160.60-FF-006301', NULL, NULL, 77, NULL, NULL, 16578),
(16579, '3.30.160.60-FF-000141', NULL, 'C2H2 zinc finger protein', 31, NULL, NULL, 16579),
(16580, '2.40.160.20-FF-000018', NULL, 'Outer membrane protein OmpA', 186, NULL, NULL, 16580),
(16581, '2.60.120.10-FF-000497', NULL, 'Uncharacterized protein', 147, NULL, NULL, 16581),
(16582, '3.40.50.300-FF-008308', NULL, 'SNF2 family DNA-dependent ATPase', 259, NULL, NULL, 16582),
(16583, '3.40.50.300-FF-002148', NULL, 'Putative dynein heavy chain', 133, NULL, NULL, 16583),
(16584, '3.90.226.10-FF-000114', NULL, 'DCI1p Peroxisomal protein', 258, NULL, NULL, 16584),
(16585, '3.40.33.10-FF-000084', NULL, 'Uncharacterized protein', 151, NULL, NULL, 16585),
(16586, '2.10.50.10-FF-000071', NULL, 'Cysteine repeat modular protein 2', 61, NULL, NULL, 16586),
(16587, '3.30.230.120-FF-000001', NULL, 'L-fucose kinase', 365, NULL, NULL, 16587),
(16588, '1.10.238.10-FF-001196', NULL, 'Uncharacterized protein', 79, NULL, NULL, 16588),
(16589, '3.60.40.10-FF-000386', NULL, 'Uncharacterized protein', 134, NULL, NULL, 16589),
(16590, '1.25.10.10-FF-002201', NULL, 'Uncharacterized protein', 439, NULL, NULL, 16590),
(16591, '3.40.50.300-FF-005554', NULL, 'peroxisome biogenesis protein 1-like', 203, NULL, NULL, 16591),
(16592, '3.30.70.1020-FF-000016', NULL, NULL, 43, NULL, NULL, 16592),
(16593, '3.10.20.90-FF-001023', NULL, 'Polycomb group protein Psc-like Protein', 87, NULL, NULL, 16593),
(16594, '3.30.70.660-FF-000087', NULL, 'Uncharacterized protein', 83, NULL, NULL, 16594),
(16595, '3.10.290.10-FF-000022', NULL, 'Tyrosine--tRNA ligase', 72, NULL, NULL, 16595),
(16596, '3.40.532.10-FF-000005', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 230, NULL, NULL, 16596),
(16597, '3.70.10.10-FF-000097', NULL, 'Checkpoint protein', 164, NULL, NULL, 16597),
(16598, '3.40.50.300-FF-001159', NULL, 'Putative P-loop containing nucleoside triphosphate hydrolase', 345, NULL, NULL, 16598);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(16599, '2.60.40.10-FF-003890', NULL, NULL, 110, NULL, NULL, 16599),
(16600, '3.30.420.40-FF-000054', NULL, 'Phosphotransferase', 166, NULL, NULL, 16600),
(16601, '3.30.160.60-FF-002911', NULL, NULL, 29, NULL, NULL, 16601),
(16602, '3.40.50.1480-FF-000005', NULL, 'Adenosylhomocysteinase', 130, NULL, NULL, 16602),
(16603, '1.50.40.10-FF-000492', NULL, 'Uncharacterized protein', 274, NULL, NULL, 16603),
(16604, '2.60.120.590-FF-000015', NULL, 'DNA oxidative demethylase ALKBH2', 219, NULL, NULL, 16604),
(16605, '3.90.245.10-FF-000006', NULL, 'Inosine-uridine preferring nucleoside hydrolase', 370, NULL, NULL, 16605),
(16606, '2.30.29.30-FF-000200', NULL, 'Rho guanine nucleotide exchange factor (GEF) 10-like a', 224, NULL, NULL, 16606),
(16607, '3.40.640.10-FF-000205', NULL, 'Uncharacterized protein', 235, NULL, NULL, 16607),
(16608, '3.30.70.1350-FF-000031', NULL, NULL, 79, NULL, NULL, 16608),
(16609, '2.30.30.100-FF-000106', NULL, 'Gem nuclear organelle associated protein 6', 64, NULL, NULL, 16609),
(16610, '3.90.79.10-FF-000283', NULL, 'Uncharacterized protein', 65, NULL, NULL, 16610),
(16611, '2.60.120.200-FF-000236', NULL, 'Legume lectin family protein', 258, NULL, NULL, 16611),
(16612, '2.60.120.40-FF-000040', NULL, 'Uncharacterized protein', 136, NULL, NULL, 16612),
(16613, '3.40.30.10-FF-000431', NULL, 'Thioredoxin superfamily protein', 172, NULL, NULL, 16613),
(16614, '3.30.360.10-FF-000068', NULL, 'Gfo/Idh/MocA family oxidoreductase', 194, NULL, NULL, 16614),
(16615, '3.30.40.10-FF-002135', NULL, 'Uncharacterized protein', 63, NULL, NULL, 16615),
(16616, '3.40.50.300-FF-000703', NULL, 'Sulfotransferase', 339, NULL, NULL, 16616),
(16617, '3.30.780.10-FF-000027', NULL, 'Mitochondrial ribosomal protein L49, putative', 96, NULL, NULL, 16617),
(16618, '1.20.58.1770-FF-000007', NULL, 'Uncharacterized protein', 67, NULL, NULL, 16618),
(16619, '2.60.40.150-FF-000661', NULL, 'Uncharacterized protein', 92, NULL, NULL, 16619),
(16620, '3.40.50.200-FF-000027', NULL, 'Peptidase S53 propeptide', 368, NULL, NULL, 16620),
(16621, '1.25.40.10-FF-003338', NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', 93, NULL, NULL, 16621),
(16622, '3.30.470.20-FF-000046', NULL, 'inactive polyglycylase TTLL10', 217, NULL, NULL, 16622),
(16623, '1.25.40.10-FF-002349', NULL, 'Putative pentatricopeptide repeat family protein', 185, NULL, NULL, 16623),
(16624, '2.60.40.10-FF-001501', NULL, 'Tyrosine-protein kinase receptor', 94, NULL, NULL, 16624),
(16625, '3.40.605.10-FF-000074', NULL, 'Malonic semialdehyde oxidative decarboxylase', 72, NULL, NULL, 16625),
(16626, '3.40.50.1240-FF-000164', NULL, NULL, 52, NULL, NULL, 16626),
(16627, '2.120.10.30-FF-000496', NULL, 'Uncharacterized protein', 237, NULL, NULL, 16627),
(16628, '3.30.43.10-FF-000051', NULL, 'Uncharacterized protein', 74, NULL, NULL, 16628),
(16629, '2.60.120.10-FF-000025', NULL, 'germin-like protein subfamily 2 member 1', 195, NULL, NULL, 16629),
(16630, '2.40.50.140-FF-001103', NULL, NULL, 72, NULL, NULL, 16630),
(16631, '3.90.730.10-FF-000038', NULL, 'Probable ribonuclease HI_0526', 178, NULL, NULL, 16631),
(16632, '1.10.287.1700-FF-000002', NULL, 'Flagella biosynthesis chaperone FliJ', 145, NULL, NULL, 16632),
(16633, '3.30.300.10-FF-000059', NULL, 'Uncharacterized protein', 38, NULL, NULL, 16633),
(16634, '2.130.10.10-FF-002614', NULL, 'WD-40 repeat-containing protein', 353, NULL, NULL, 16634),
(16635, '1.20.58.90-FF-000035', NULL, NULL, 108, NULL, NULL, 16635),
(16636, '3.40.710.10-FF-000060', NULL, 'Penicillin-binding protein 1B', 328, NULL, NULL, 16636),
(16637, '2.60.40.10-FF-004727', NULL, NULL, 104, NULL, NULL, 16637),
(16638, '3.30.1780.10-FF-000009', NULL, 'Ornithine cyclodeaminase/mu-crystallin family protein', 150, NULL, NULL, 16638),
(16639, '3.40.50.720-FF-000273', NULL, 'Reticulon-like protein', 360, NULL, NULL, 16639),
(16640, '1.20.120.140-FF-000025', NULL, 'Uncharacterized protein', 70, NULL, NULL, 16640),
(16641, '2.130.10.10-FF-005520', NULL, 'Uncharacterized protein', 57, NULL, NULL, 16641),
(16642, '3.40.50.1820-FF-001731', NULL, 'Predicted protein', 94, NULL, NULL, 16642);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(16643, '3.80.10.10-FF-001384', NULL, 'Uncharacterized protein', 142, NULL, NULL, 16643),
(16644, '2.170.270.10-FF-000094', NULL, 'GM20595', 115, NULL, NULL, 16644),
(16645, '1.10.275.10-FF-000028', NULL, NULL, 13, NULL, NULL, 16645),
(16646, '2.60.40.60-FF-000566', NULL, 'Uncharacterized protein', 109, NULL, NULL, 16646),
(16647, '1.25.40.10-FF-002821', NULL, 'At3g09490', 153, NULL, NULL, 16647),
(16648, '1.10.1450.10-FF-000137', NULL, 'Tetraspanin', 97, NULL, NULL, 16648),
(16649, '1.10.10.10-FF-002049', NULL, 'Uncharacterized protein', 98, NULL, NULL, 16649),
(16650, '2.40.50.90-FF-000037', NULL, 'Tudor staphylococcal nuclease', 153, NULL, NULL, 16650),
(16651, '3.30.160.60-FF-005312', NULL, NULL, 98, NULL, NULL, 16651),
(16652, '3.40.50.300-FF-003929', NULL, 'Small GTPase RhoA, putative', 191, NULL, NULL, 16652),
(16653, '3.30.70.1320-FF-000016', NULL, 'Heavy metal efflux pump permease component CzcA family', 111, NULL, NULL, 16653),
(16654, '1.25.40.10-FF-000112', NULL, 'FAM10 family protein', 174, NULL, NULL, 16654),
(16655, '1.20.120.20-FF-000041', NULL, 'Uncharacterized protein', 152, NULL, NULL, 16655),
(16656, '2.30.42.10-FF-000006', NULL, 'Membrane associated guanylate kinase, WW and PDZ domain containing 1', 101, NULL, NULL, 16656),
(16657, '2.10.25.10-FF-000911', NULL, 'LDL receptor protein 1, isoform G', 43, NULL, NULL, 16657),
(16658, '1.25.10.10-FF-000756', NULL, 'Synembryn', 334, NULL, NULL, 16658),
(16659, '3.40.50.850-FF-000020', NULL, 'Nicotinamidase 2', 196, NULL, NULL, 16659),
(16660, '3.30.160.60-FF-002878', NULL, 'Zinc finger protein 652', 26, NULL, NULL, 16660),
(16661, '1.20.58.160-FF-000009', NULL, NULL, 88, NULL, NULL, 16661),
(16662, '3.10.20.90-FF-000534', NULL, 'GD22467', 81, NULL, NULL, 16662),
(16663, '1.10.3860.10-FF-000011', NULL, 'L-cystine transporter', 428, NULL, NULL, 16663),
(16664, '1.10.287.950-FF-000045', NULL, 'Chemotaxis signal transduction system methyl accepting sensory transducer', 323, NULL, NULL, 16664),
(16665, '2.130.10.10-FF-000669', NULL, 'WD repeat-containing protein 82', 76, NULL, NULL, 16665),
(16666, '3.40.1110.10-FF-000171', NULL, 'Phospholipid-transporting P-type ATPase, putative', 197, NULL, NULL, 16666),
(16667, '2.30.40.10-FF-000024', NULL, 'Amidohydrolase', 42, NULL, NULL, 16667),
(16668, '2.30.30.40-FF-000566', NULL, 'Predicted protein', 31, NULL, NULL, 16668),
(16669, '3.30.60.190-FF-000011', NULL, 'Zinc finger protein, putative', 47, NULL, NULL, 16669),
(16670, '1.20.120.1750-FF-000043', NULL, 'RBR-type E3 ubiquitin transferase', 221, NULL, NULL, 16670),
(16671, '3.40.50.300-FF-004565', NULL, 'Uncharacterized protein', 229, NULL, NULL, 16671),
(16672, '3.30.70.330-FF-001680', NULL, NULL, 87, NULL, NULL, 16672),
(16673, '3.40.525.10-FF-000073', NULL, 'RBR-type E3 ubiquitin transferase', 96, NULL, NULL, 16673),
(16674, '3.40.50.1820-FF-001198', NULL, 'Uncharacterized protein', 115, NULL, NULL, 16674),
(16675, '1.10.510.10-FF-001649', NULL, 'Serine/threonine protein kinase, putative', 381, NULL, NULL, 16675),
(16676, '3.40.630.30-FF-000565', NULL, 'Acetyltransferase, putative', 210, NULL, NULL, 16676),
(16677, '1.20.1250.10-FF-000030', NULL, 'Type I interferon', 157, NULL, NULL, 16677),
(16678, '3.30.160.60-FF-003367', NULL, 'Zinc finger protein', 28, NULL, NULL, 16678),
(16679, '1.20.1280.180-FF-000001', NULL, 'Carnitine O-palmitoyltransferase 2, mitochondrial', 43, NULL, NULL, 16679),
(16680, '3.40.50.10490-FF-000015', NULL, 'Glucose-6-phosphate isomerase', 189, NULL, NULL, 16680),
(16681, '3.30.420.40-FF-001010', NULL, 'Uncharacterized protein', 62, NULL, NULL, 16681),
(16682, '3.40.50.300-FF-005054', NULL, 'Elongator complex protein 6-like Protein', 238, NULL, NULL, 16682),
(16683, '3.40.50.11210-FF-000001', NULL, 'Ral GTPase-activating protein subunit alpha-1 isoform 1', 181, NULL, NULL, 16683),
(16684, '3.30.1330.20-FF-000018', NULL, 'Tubulin gamma chain', 110, NULL, NULL, 16684),
(16685, '1.25.10.10-FF-002701', NULL, 'Uncharacterized protein', 62, NULL, NULL, 16685),
(16686, '1.10.533.10-FF-000084', NULL, 'Interferon-induced with helicase C domain 1', 94, NULL, NULL, 16686);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(16687, '3.30.1680.10-FF-000064', NULL, 'Semaphorin-4D', 20, NULL, NULL, 16687),
(16688, '1.20.58.1210-FF-000008', NULL, 'AGAP004207-PA', 117, NULL, NULL, 16688),
(16689, '3.90.150.10-FF-000011', NULL, 'Variant surface glycoprotein (VSG, atypical), putative', 179, NULL, NULL, 16689),
(16690, '3.30.70.1730-FF-000049', NULL, '50S ribosomal protein L10', 106, NULL, NULL, 16690),
(16691, '1.10.1520.10-FF-000053', NULL, 'Dicer-like 1 protein', 131, NULL, NULL, 16691),
(16692, '1.25.40.20-FF-000733', NULL, 'Water witch, isoform D', 40, NULL, NULL, 16692),
(16693, '3.30.160.60-FF-001130', NULL, 'Zinc finger protein 219', 21, NULL, NULL, 16693),
(16694, '3.80.10.10-FF-003654', NULL, 'Uncharacterized protein', 121, NULL, NULL, 16694),
(16695, '3.40.47.10-FF-000054', NULL, 'Acetyl-CoA C-acetyltransferase VraB', 163, NULL, NULL, 16695),
(16696, '3.30.70.330-FF-003006', NULL, NULL, 81, NULL, NULL, 16696),
(16697, '3.30.450.20-FF-000163', NULL, 'Sensor histidine kinase', 116, NULL, NULL, 16697),
(16698, '3.40.50.1820-FF-001259', NULL, 'Protein phosphatase methylesterase 1', 311, NULL, NULL, 16698),
(16699, '3.20.20.70-FF-000207', NULL, 'Anaerobic sulfatase maturase AslB', 386, NULL, NULL, 16699),
(16700, '2.60.40.150-FF-000189', NULL, 'X-linked retinitis pigmentosa GTPase regulator-interacting protein 1', 201, NULL, NULL, 16700),
(16701, '3.40.190.10-FF-000362', NULL, 'Nickel ABC transporter substrate-binding protein', 207, NULL, NULL, 16701),
(16702, '2.60.40.150-FF-000509', NULL, 'Phosphoinositide phospholipase C', 138, NULL, NULL, 16702),
(16703, '1.20.1250.20-FF-000712', NULL, 'Transporter, MFS superfamily', 363, NULL, NULL, 16703),
(16704, '1.10.240.10-FF-000004', NULL, 'Tyrosine--tRNA ligase', 131, NULL, NULL, 16704),
(16705, '3.50.4.10-FF-000017', NULL, 'Uncharacterized protein, isoform A', 81, NULL, NULL, 16705),
(16706, '1.20.58.2220-FF-000036', NULL, 'Formin, putative', 75, NULL, NULL, 16706),
(16707, '1.10.10.60-FF-001294', NULL, NULL, 102, NULL, NULL, 16707),
(16708, '2.60.40.10-FF-001181', NULL, 'Immunoglobulin lambda variable 9-49', 102, NULL, NULL, 16708),
(16709, '1.10.10.60-FF-001114', NULL, NULL, 65, NULL, NULL, 16709),
(16710, '3.30.200.210-FF-000011', NULL, NULL, 81, NULL, NULL, 16710),
(16711, '2.60.120.10-FF-000525', NULL, 'Uncharacterized protein', 130, NULL, NULL, 16711),
(16712, '1.10.132.30-FF-000023', NULL, 'DNA-directed RNA polymerase subunit', 148, NULL, NULL, 16712),
(16713, '3.30.1240.10-FF-000042', NULL, '5-amino-6-(5-phospho-D-ribitylamino)uracil phosphatase YitU', 107, NULL, NULL, 16713),
(16714, '1.25.10.10-FF-000695', NULL, 'Condensin complex subunit 1', 267, NULL, NULL, 16714),
(16715, '2.120.10.80-FF-000078', NULL, 'Kelch like family member 8', 131, NULL, NULL, 16715),
(16716, '1.10.10.10-FF-000284', NULL, 'Anaphase-promoting complex subunit 2', 90, NULL, NULL, 16716),
(16717, '1.10.10.10-FF-000104', NULL, 'AsnC family transcriptional regulator', 52, NULL, NULL, 16717),
(16718, '3.40.120.10-FF-000088', NULL, 'Phosphoglucosamine mutase', 90, NULL, NULL, 16718),
(16719, '2.60.120.620-FF-000159', NULL, 'Prolyl 4-hydroxylase alpha subunit, putative', 185, NULL, NULL, 16719),
(16720, '3.60.21.10-FF-000494', NULL, 'Serine/threonine-protein phosphatase', 340, NULL, NULL, 16720),
(16721, '3.40.190.10-FF-000423', NULL, 'Transcriptional regulator LysR family', 105, NULL, NULL, 16721),
(16722, '3.30.1490.100-FF-000017', NULL, 'DNA polymerase kappa, putative', 111, NULL, NULL, 16722),
(16723, '2.160.20.10-FF-000163', NULL, 'Uncharacterized protein', 315, NULL, NULL, 16723),
(16724, '3.50.50.60-FF-000374', NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase, mitochondrial', 79, NULL, NULL, 16724),
(16725, '1.10.510.10-FF-003566', NULL, NULL, 222, NULL, NULL, 16725),
(16726, '2.60.40.10-FF-001001', NULL, 'Uncharacterized protein, isoform I', 97, NULL, NULL, 16726),
(16727, '3.30.160.60-FF-003867', NULL, NULL, 28, NULL, NULL, 16727),
(16728, '1.25.40.20-FF-000441', NULL, 'Protein CbxX, chromosomal', 39, NULL, NULL, 16728),
(16729, '1.10.238.10-FF-001224', NULL, 'Uncharacterized protein', 124, NULL, NULL, 16729);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(16730, '1.50.10.20-FF-000021', NULL, 'Geranylgeranyl transferase type-1 subunit beta', 342, NULL, NULL, 16730),
(16731, '2.130.10.10-FF-002586', NULL, 'WD-repeat protein, putative', 58, NULL, NULL, 16731),
(16732, '3.30.930.10-FF-000269', NULL, 'AGAP000979-PA', 232, NULL, NULL, 16732),
(16733, '2.40.70.10-FF-000183', NULL, 'Plasmepsin VIII', 91, NULL, NULL, 16733),
(16734, '3.40.1840.10-FF-000001', NULL, 'YNR034W-A-like protein', 83, NULL, NULL, 16734),
(16735, '2.40.10.10-FF-000174', NULL, 'Possible protease', 85, NULL, NULL, 16735),
(16736, '3.30.470.20-FF-000107', NULL, 'D-alanine--D-alanine ligase', 163, NULL, NULL, 16736),
(16737, '1.10.560.10-FF-000079', NULL, '60 kDa chaperonin', 238, NULL, NULL, 16737),
(16738, '3.10.490.10-FF-000003', NULL, 'Gamma-glutamylcyclotransferase', 168, NULL, NULL, 16738),
(16739, '3.40.640.10-FF-000144', NULL, 'Phosphoserine aminotransferase', 237, NULL, NULL, 16739),
(16740, '3.40.50.2020-FF-000061', NULL, 'PRS5p 5-phospho-ribosyl-1(Alpha)-pyrophosphate synthetase', 55, NULL, NULL, 16740),
(16741, '3.40.50.720-FF-002510', NULL, 'Uncharacterized protein', 129, NULL, NULL, 16741),
(16742, '3.30.70.330-FF-002961', NULL, NULL, 102, NULL, NULL, 16742),
(16743, '2.60.120.920-FF-000098', NULL, 'SPRY_domain/HECT-domain_(Ubiquitin-transferase)_-_putative', 169, NULL, NULL, 16743),
(16744, '1.25.40.10-FF-001101', NULL, 'Pentatricopeptide repeat-containing protein', 108, NULL, NULL, 16744),
(16745, '3.100.10.10-FF-000021', NULL, '50S ribosomal protein L15', 87, NULL, NULL, 16745),
(16746, '3.20.20.140-FF-000165', NULL, 'AMP deaminase, putative', 333, NULL, NULL, 16746),
(16747, '3.30.200.20-FF-000824', NULL, 'Serine/threonine kinase', 89, NULL, NULL, 16747),
(16748, '2.40.10.10-FF-000466', NULL, NULL, 239, NULL, NULL, 16748),
(16749, '4.10.280.10-FF-000158', NULL, 'Sterol regulatory element Binding Protein', 76, NULL, NULL, 16749),
(16750, '3.30.230.10-FF-000323', NULL, 'Uncharacterized protein', 129, NULL, NULL, 16750),
(16751, '3.10.450.320-FF-000002', NULL, 'Mitochondrial import inner membrane translocase subunit tim21', 115, NULL, NULL, 16751),
(16752, '2.130.10.10-FF-002294', NULL, 'CG10144', 183, NULL, NULL, 16752),
(16753, '1.20.58.340-FF-000058', NULL, 'CorA family metal ion transporter (Eurofung)', 119, NULL, NULL, 16753),
(16754, '3.20.20.220-FF-000071', NULL, 'Proline dehydrogenase', 350, NULL, NULL, 16754),
(16755, '2.40.70.10-FF-000003', NULL, 'Beta-secretase 1', 244, NULL, NULL, 16755),
(16756, '2.30.29.240-FF-000016', NULL, 'Phosphoinositide phospholipase C', 170, NULL, NULL, 16756),
(16757, '3.10.129.10-FF-000204', NULL, 'Biosynthesis cluster domain-containing protein', 318, NULL, NULL, 16757),
(16758, '3.40.50.300-FF-007971', NULL, 'Uncharacterized protein', 163, NULL, NULL, 16758),
(16759, '2.10.220.10-FF-000055', NULL, 'Furin-like protease 2', 59, NULL, NULL, 16759),
(16760, '3.30.497.10-FF-000138', NULL, 'Uncharacterized protein', 206, NULL, NULL, 16760),
(16761, '1.20.1250.20-FF-001668', NULL, 'Uncharacterized protein', 180, NULL, NULL, 16761),
(16762, '1.10.10.900-FF-000002', NULL, 'Sdo1p', 76, NULL, NULL, 16762),
(16763, '3.30.450.40-FF-000202', NULL, 'Sensor cyclic diguanylate phosphodiesterase, GAF and GAF domain-containing', 169, NULL, NULL, 16763),
(16764, '1.25.10.10-FF-001684', NULL, 'Puf protein', 290, NULL, NULL, 16764),
(16765, '2.60.40.150-FF-000009', NULL, 'dysferlin isoform X2', 140, NULL, NULL, 16765),
(16766, '3.30.260.10-FF-000004', NULL, 'T-complex protein 1 subunit epsilon', 108, NULL, NULL, 16766),
(16767, '3.30.40.10-FF-001938', NULL, 'Uncharacterized protein', 109, NULL, NULL, 16767),
(16768, '1.10.10.60-FF-000597', NULL, 'Putative DNAj-like protein', 60, NULL, NULL, 16768),
(16769, '3.20.20.450-FF-000022', NULL, 'Diguanylate cyclase/phosphodiesterase', 242, NULL, NULL, 16769),
(16770, '3.10.20.90-FF-000034', NULL, 'Ubiquitin carboxyl-terminal hydrolase 13', 98, NULL, NULL, 16770),
(16771, '1.10.8.60-FF-000146', NULL, 'Vesicle-fusing ATPase', 110, NULL, NULL, 16771),
(16772, '1.25.40.10-FF-000084', NULL, 'CTR9 homolog, Paf1/RNA polymerase II complex component', 126, NULL, NULL, 16772);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(16773, '1.25.40.20-FF-001722', NULL, 'Uncharacterized protein', 231, NULL, NULL, 16773),
(16774, '3.50.50.60-FF-001363', NULL, 'Flavin-containing monooxygenase', 58, NULL, NULL, 16774),
(16775, '3.30.530.20-FF-000017', NULL, 'Phosphatidylcholine transfer protein, putative', 207, NULL, NULL, 16775),
(16776, '2.40.10.10-FF-000027', NULL, 'Haptoglobin', 147, NULL, NULL, 16776),
(16777, '3.90.1170.10-FF-000005', NULL, '39S ribosomal protein L16, mitochondrial', 178, NULL, NULL, 16777),
(16778, '1.10.640.10-FF-000052', NULL, 'AGAP009033-PA', 532, NULL, NULL, 16778),
(16779, '1.20.1250.20-FF-001640', NULL, 'Uncharacterized protein', 498, NULL, NULL, 16779),
(16780, '3.60.21.10-FF-000347', NULL, 'Serine/threonine-protein phosphatase', 393, NULL, NULL, 16780),
(16781, '3.40.630.30-FF-000065', NULL, 'N-terminal acetyltransferase complex ARD1 subunit homolog', 175, NULL, NULL, 16781),
(16782, '4.10.280.10-FF-000130', NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', 65, NULL, NULL, 16782),
(16783, '1.20.5.170-FF-000277', NULL, 'Uncharacterized protein', 107, NULL, NULL, 16783),
(16784, '3.30.160.60-FF-001630', NULL, 'Zinc finger protein 888', 43, NULL, NULL, 16784),
(16785, '3.30.160.60-FF-002439', NULL, 'Zinc finger protein 646', 56, NULL, NULL, 16785),
(16786, '1.20.1440.100-FF-000003', NULL, 'HAD-superfamily hydrolase', 77, NULL, NULL, 16786),
(16787, '1.10.60.30-FF-000001', NULL, 'UPF0307 protein YjgA', 74, NULL, NULL, 16787),
(16788, '1.10.20.10-FF-000369', NULL, NULL, 72, NULL, NULL, 16788),
(16789, '3.40.50.150-FF-001597', NULL, NULL, 263, NULL, NULL, 16789),
(16790, '1.25.10.10-FF-000256', NULL, 'Sterile alpha and TIR motif containing 1', 209, NULL, NULL, 16790),
(16791, '6.20.220.20-FF-000001', NULL, 'DNA repair protein RecO', 35, NULL, NULL, 16791),
(16792, '4.10.1000.10-FF-000062', NULL, 'Uncharacterized protein', 28, NULL, NULL, 16792),
(16793, '3.90.226.10-FF-000086', NULL, 'Enoyl-CoA hydratase', 207, NULL, NULL, 16793),
(16794, '1.10.510.10-FF-002285', NULL, NULL, 125, NULL, NULL, 16794),
(16795, '3.40.50.2300-FF-000959', NULL, NULL, 227, NULL, NULL, 16795),
(16796, '2.130.10.10-FF-005048', NULL, 'Uncharacterized protein', 283, NULL, NULL, 16796),
(16797, '1.10.8.60-FF-000438', NULL, 'Peroxisomal acyl-coenzyme A oxidase 1', 75, NULL, NULL, 16797),
(16798, '2.10.110.10-FF-000165', NULL, 'Protein CBG12788', 61, NULL, NULL, 16798),
(16799, '1.10.150.770-FF-000003', NULL, NULL, 69, NULL, NULL, 16799),
(16800, '2.60.120.10-FF-000817', NULL, 'Uncharacterized protein', 99, NULL, NULL, 16800),
(16801, '3.40.30.10-FF-001179', NULL, 'Uncharacterized protein', 113, NULL, NULL, 16801),
(16802, '2.130.10.10-FF-001125', NULL, 'Kinesin family member 21A', 153, NULL, NULL, 16802),
(16803, '1.20.58.390-FF-000112', NULL, 'Acetylcholine receptor subunit alpha-type unc-63', 75, NULL, NULL, 16803),
(16804, '3.40.50.1820-FF-001698', NULL, 'Glycine-AMP ligase', 187, NULL, NULL, 16804),
(16805, '1.20.1070.10-FF-001454', NULL, 'Uncharacterized protein', 219, NULL, NULL, 16805),
(16806, '2.60.120.1030-FF-000001', NULL, 'Protein CLP1 homolog 5', 82, NULL, NULL, 16806),
(16807, '3.90.230.10-FF-000045', NULL, NULL, 55, NULL, NULL, 16807),
(16808, '3.40.50.720-FF-000565', NULL, 'Retinol dehydrogenase 10', 142, NULL, NULL, 16808),
(16809, '2.130.10.10-FF-004531', NULL, 'Uncharacterized protein', 227, NULL, NULL, 16809),
(16810, '3.40.50.880-FF-000208', NULL, 'Anthranilate synthase component II', 212, NULL, NULL, 16810),
(16811, '3.80.10.10-FF-001237', NULL, 'Putative leucine-rich repeat protein', 129, NULL, NULL, 16811),
(16812, '1.25.40.10-FF-004266', NULL, 'Uncharacterized protein', 218, NULL, NULL, 16812),
(16813, '1.20.1250.70-FF-000002', NULL, 'Interleukin', 134, NULL, NULL, 16813),
(16814, '3.30.420.40-FF-000493', NULL, 'Putative NBD/HSP70 family sugar kinase', 131, NULL, NULL, 16814),
(16815, '3.30.40.10-FF-000218', NULL, 'RING-type E3 ubiquitin transferase', 76, NULL, NULL, 16815),
(16816, '2.60.40.1170-FF-000088', NULL, NULL, 142, NULL, NULL, 16816),
(16817, '3.40.50.300-FF-006482', NULL, 'Uncharacterized protein', 116, NULL, NULL, 16817);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(16818, '2.60.40.10-FF-005716', NULL, NULL, 42, NULL, NULL, 16818),
(16819, '1.10.3500.10-FF-000018', NULL, 'Uncharacterized protein', 301, NULL, NULL, 16819),
(16820, '1.10.510.10-FF-000840', NULL, 'Uncharacterized protein, isoform A', 301, NULL, NULL, 16820),
(16821, '3.40.50.300-FF-004918', NULL, 'Elongator complex protein 6', 273, NULL, NULL, 16821),
(16822, '3.30.1390.20-FF-000027', NULL, 'Uncharacterized protein', 28, NULL, NULL, 16822),
(16823, '3.80.10.10-FF-001676', NULL, 'Os02g0215700 protein', 107, NULL, NULL, 16823),
(16824, '3.40.50.2300-FF-000667', NULL, NULL, 20, NULL, NULL, 16824),
(16825, '3.40.1170.10-FF-000028', NULL, 'DNA mismatch repair protein MSH3', 148, NULL, NULL, 16825),
(16826, '1.20.1050.10-FF-000082', NULL, 'Glutathione transferase32', 128, NULL, NULL, 16826),
(16827, '3.20.20.70-FF-000679', NULL, NULL, 199, NULL, NULL, 16827),
(16828, '2.70.98.110-FF-000004', NULL, 'Mannosyl-oligosaccharide glucosidase', 123, NULL, NULL, 16828),
(16829, '1.10.10.1140-FF-000001', NULL, 'Glutamine-dependent NAD(+) synthetase', 122, NULL, NULL, 16829),
(16830, '3.40.50.300-FF-001400', NULL, 'DNA helicase', 182, NULL, NULL, 16830),
(16831, '1.10.400.10-FF-000039', NULL, 'Guanine nucleotide-binding protein G, putative', 32, NULL, NULL, 16831),
(16832, '3.40.50.300-FF-003637', NULL, 'Uncharacterized protein YpbR', 238, NULL, NULL, 16832),
(16833, '1.20.140.150-FF-000010', NULL, 'transmembrane protein 47', 165, NULL, NULL, 16833),
(16834, '3.40.50.1100-FF-000088', NULL, 'Cystathionine beta-synthase, putative', 194, NULL, NULL, 16834),
(16835, '3.30.70.330-FF-002989', NULL, NULL, 87, NULL, NULL, 16835),
(16836, '3.40.50.300-FF-005846', NULL, 'p-glycoprotein 2 putative', 87, NULL, NULL, 16836),
(16837, '1.10.238.10-FF-000740', NULL, 'WD-40 protein, putative', 146, NULL, NULL, 16837),
(16838, '2.130.10.10-FF-003603', NULL, 'Predicted protein', 147, NULL, NULL, 16838),
(16839, '1.25.40.190-FF-000015', NULL, NULL, 99, NULL, NULL, 16839),
(16840, '3.40.50.2300-FF-001595', NULL, NULL, 108, NULL, NULL, 16840),
(16841, '1.10.20.10-FF-000341', NULL, NULL, 103, NULL, NULL, 16841),
(16842, '2.30.42.10-FF-000478', NULL, NULL, 113, NULL, NULL, 16842),
(16843, '3.30.530.20-FF-000197', NULL, 'Uncharacterized protein', 215, NULL, NULL, 16843),
(16844, '3.30.40.10-FF-001146', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 102, NULL, NULL, 16844),
(16845, '3.30.300.180-FF-000013', NULL, 'Chromosomal replication initiator protein DnaA', 102, NULL, NULL, 16845),
(16846, '3.20.70.20-FF-000044', NULL, 'Predicted protein', 294, NULL, NULL, 16846),
(16847, '1.10.880.10-FF-000007', NULL, 'Uncharacterized protein', 53, NULL, NULL, 16847),
(16848, '3.30.160.60-FF-001922', NULL, 'Zinc finger protein 658', 26, NULL, NULL, 16848),
(16849, '3.30.310.50-FF-000049', NULL, 'Phosphoglucomutase', 105, NULL, NULL, 16849),
(16850, '4.10.830.10-FF-000004', NULL, 'Succinate dehydrogenase [ubiquinone] iron-sulfur subunit, mitochondrial', 61, NULL, NULL, 16850),
(16851, '3.20.20.60-FF-000058', NULL, 'Isocitrate lyase', 300, NULL, NULL, 16851),
(16852, '2.120.10.30-FF-000524', NULL, 'Uncharacterized protein', 156, NULL, NULL, 16852),
(16853, '1.10.287.110-FF-000232', NULL, 'DnaJ-like protein', 149, NULL, NULL, 16853),
(16854, '3.90.550.10-FF-000592', NULL, '3-deoxy-manno-octulosonate cytidylyltransferase', 234, NULL, NULL, 16854),
(16855, '3.30.70.870-FF-000032', NULL, 'Translation elongation factor G', 74, NULL, NULL, 16855),
(16856, '1.10.150.20-FF-000034', NULL, 'DNA polymerase I', 144, NULL, NULL, 16856),
(16857, '3.30.110.20-FF-000025', NULL, 'Putative beta-14-xylosyltransferase IRX10L', 48, NULL, NULL, 16857),
(16858, '2.10.25.10-FF-000883', NULL, 'Delta/notch-like EGF repeat containing', 51, NULL, NULL, 16858),
(16859, '1.25.40.270-FF-000005', NULL, 'Protein HOMOLOG OF MAMMALIAN LYST-INTERACTING PROTEIN 5', 152, NULL, NULL, 16859),
(16860, '4.10.60.10-FF-000224', NULL, 'Uncharacterized protein', 45, NULL, NULL, 16860),
(16861, '2.60.40.10-FF-002462', NULL, 'PKHD1 like 1', 90, NULL, NULL, 16861),
(16862, '1.10.150.810-FF-000004', NULL, 'DNA polymerase kappa, putative', 99, NULL, NULL, 16862);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(16863, '2.60.120.920-FF-000070', NULL, 'Neuralized E3 ubiquitin protein ligase 2', 172, NULL, NULL, 16863),
(16864, '2.10.10.10-FF-000006', NULL, 'Insulin-like growth factor 2 receptor', 51, NULL, NULL, 16864),
(16865, '2.110.10.10-FF-000007', NULL, 'stromelysin-3 isoform X2', 198, NULL, NULL, 16865),
(16866, '3.40.50.261-FF-000035', NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta', 141, NULL, NULL, 16866),
(16867, '2.10.60.10-FF-000009', NULL, 'TGF-beta receptor type-2', 116, NULL, NULL, 16867),
(16868, '3.20.20.80-FF-000036', NULL, 'Beta-galactosidase', 273, NULL, NULL, 16868),
(16869, '2.60.40.420-FF-000113', NULL, 'Uncharacterized protein', 197, NULL, NULL, 16869),
(16870, '1.10.630.10-FF-000787', NULL, 'Uncharacterized protein', 116, NULL, NULL, 16870),
(16871, '1.10.150.50-FF-000110', NULL, 'Mammalian ZAK kinase homolog', 85, NULL, NULL, 16871),
(16872, '2.60.40.10-FF-004699', NULL, NULL, 109, NULL, NULL, 16872),
(16873, '2.70.20.10-FF-000021', NULL, 'DNA topoisomerase 3', 163, NULL, NULL, 16873),
(16874, '3.40.1090.10-FF-000027', NULL, 'Patatin like phospholipase domain containing 5', 75, NULL, NULL, 16874),
(16875, '3.80.10.10-FF-003362', NULL, 'Uncharacterized protein', 267, NULL, NULL, 16875),
(16876, '3.30.160.60-FF-003075', NULL, 'GM13856', 61, NULL, NULL, 16876),
(16877, '3.10.20.90-FF-000826', NULL, 'Uncharacterized protein', 102, NULL, NULL, 16877),
(16878, '3.30.60.20-FF-000077', NULL, 'Diacylglycerol kinase', 51, NULL, NULL, 16878),
(16879, '3.40.50.300-FF-003076', NULL, 'Rho family GTPase', 182, NULL, NULL, 16879),
(16880, '2.60.40.10-FF-001973', NULL, 'Plexin A4, B', 101, NULL, NULL, 16880),
(16881, '3.40.390.10-FF-000051', NULL, 'ADAM metallopeptidase domain 17', 68, NULL, NULL, 16881),
(16882, '2.130.10.10-FF-005992', NULL, 'Uncharacterized protein', 226, NULL, NULL, 16882),
(16883, '3.40.50.150-FF-000669', NULL, 'Cyanobacterial-type MPBQ/MSBQ methyltransferase', 277, NULL, NULL, 16883),
(16884, '3.30.1490.190-FF-000004', NULL, 'Transcriptional regulator (Fur family)', 58, NULL, NULL, 16884),
(16885, '3.30.70.330-FF-000191', NULL, 'Oligouridylate-binding protein 1C', 102, NULL, NULL, 16885),
(16886, '3.30.160.60-FF-005284', NULL, NULL, 56, NULL, NULL, 16886),
(16887, '2.30.30.100-FF-000078', NULL, 'Small nuclear ribonucleoprotein E', 27, NULL, NULL, 16887),
(16888, '2.60.120.260-FF-000208', NULL, 'von Willebrand factor D and EGF domains', 90, NULL, NULL, 16888),
(16889, '1.10.510.10-FF-001357', NULL, 'Serine/threonine protein kinase-like protein', 205, NULL, NULL, 16889),
(16890, '3.30.1060.10-FF-000005', NULL, 'Peptide methionine sulfoxide reductase MsrA', 167, NULL, NULL, 16890),
(16891, '1.10.340.70-FF-000007', NULL, 'Transcriptional regulator', 85, NULL, NULL, 16891),
(16892, '2.60.40.790-FF-000145', NULL, NULL, 117, NULL, NULL, 16892),
(16893, '2.170.210.20-FF-000003', NULL, 'Uncharacterized protein, isoform B', 171, NULL, NULL, 16893),
(16894, '3.40.50.360-FF-000114', NULL, 'FMN-dependent NADH-azoreductase 1', 212, NULL, NULL, 16894),
(16895, '3.10.600.10-FF-000002', NULL, 'Pyruvate carboxylase', 60, NULL, NULL, 16895),
(16896, '3.40.50.1820-FF-001670', NULL, 'Uncharacterized protein', 264, NULL, NULL, 16896),
(16897, '3.40.50.2000-FF-000167', NULL, 'Glycosyltransferase', 254, NULL, NULL, 16897),
(16898, '1.10.10.600-FF-000002', NULL, 'FeS assembly protein IscX', 65, NULL, NULL, 16898),
(16899, '1.10.287.1490-FF-000017', NULL, 'Repeat organellar protein', 180, NULL, NULL, 16899),
(16900, '2.60.40.10-FF-000837', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', 90, NULL, NULL, 16900),
(16901, '3.30.70.1620-FF-000016', NULL, 'Chromosome partition protein Smc', 86, NULL, NULL, 16901),
(16902, '2.60.40.10-FF-000253', NULL, 'Sidekick cell adhesion molecule 1', 103, NULL, NULL, 16902),
(16903, '2.30.29.30-FF-000700', NULL, 'Probable serine/threonine-protein kinase DDB_G0272282', 104, NULL, NULL, 16903),
(16904, '3.30.870.10-FF-000118', NULL, 'Phospholipase D/Transphosphatidylase', 165, NULL, NULL, 16904),
(16905, '4.10.400.10-FF-000039', NULL, 'Sortilin related receptor 1', 43, NULL, NULL, 16905);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(16906, '3.40.50.300-FF-000675', NULL, 'V-type ATP synthase alpha chain', 288, NULL, NULL, 16906),
(16907, '1.20.1050.10-FF-000110', NULL, 'Glutathione S-transferase', 112, NULL, NULL, 16907),
(16908, '3.30.60.20-FF-000138', NULL, 'Thymidine kinase', 45, NULL, NULL, 16908),
(16909, '3.80.10.10-FF-001445', NULL, 'F-box protein At5g51380', 267, NULL, NULL, 16909),
(16910, '1.25.10.10-FF-002229', NULL, 'Uncharacterized protein', 392, NULL, NULL, 16910),
(16911, '2.130.10.10-FF-004031', NULL, 'Uncharacterized protein', 220, NULL, NULL, 16911),
(16912, '2.60.200.20-FF-000208', NULL, 'Fork head protein homolog 2', 135, NULL, NULL, 16912),
(16913, '3.30.310.50-FF-000021', NULL, 'GlcNAc phosphomutase', 99, NULL, NULL, 16913),
(16914, '3.30.200.20-FF-001021', NULL, 'Hypoxia Inhibited Receptor tyrosine kinase', 147, NULL, NULL, 16914),
(16915, '3.30.70.240-FF-000017', NULL, 'TetQ family GTPase, putative', 76, NULL, NULL, 16915),
(16916, '1.25.40.10-FF-003310', NULL, 'Pentatricopeptide repeat-containing protein At1g62260, mitochondrial', 108, NULL, NULL, 16916),
(16917, '3.40.50.300-FF-000203', NULL, 'Putative ras-related protein ral-a', 177, NULL, NULL, 16917),
(16918, '1.20.5.190-FF-000024', NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', 45, NULL, NULL, 16918),
(16919, '2.60.40.10-FF-003390', NULL, NULL, 106, NULL, NULL, 16919),
(16920, '3.50.50.60-FF-001155', NULL, 'Flavin-containing monooxygenase', 58, NULL, NULL, 16920),
(16921, '3.40.50.300-FF-004418', NULL, 'Dephospho-CoA kinase', 180, NULL, NULL, 16921),
(16922, '1.50.40.10-FF-000520', NULL, 'Mitochondrial glycine transporter', 181, NULL, NULL, 16922),
(16923, '3.30.210.10-FF-000001', NULL, 'DNA polymerase lambda', 69, NULL, NULL, 16923),
(16924, '1.10.3720.10-FF-000029', NULL, 'Spermidine/putrescine ABC transporter permease PotB', 274, NULL, NULL, 16924),
(16925, '3.40.50.720-FF-000773', NULL, 'High chlorophyll fluorescence phenotype 173', 111, NULL, NULL, 16925),
(16926, '2.60.40.2030-FF-000003', NULL, 'Fraser extracellular matrix complex subunit 1', 124, NULL, NULL, 16926),
(16927, '1.10.510.10-FF-000901', NULL, 'Maternal embryonic leucine zipper kinase', 341, NULL, NULL, 16927),
(16928, '1.10.10.60-FF-000366', NULL, 'Transcriptional coactivator ADA2', 58, NULL, NULL, 16928),
(16929, '1.10.287.70-FF-000399', NULL, 'G protein-activated inward rectifier potassium channel 4', 137, NULL, NULL, 16929),
(16930, '3.40.30.10-FF-000931', NULL, 'Uncharacterized protein', 117, NULL, NULL, 16930),
(16931, '3.30.160.60-FF-002939', NULL, 'Protein CBR-BLMP-1', 34, NULL, NULL, 16931),
(16932, '3.60.130.10-FF-000016', NULL, 'YHL021C-like protein', 332, NULL, NULL, 16932),
(16933, '3.80.10.10-FF-004110', NULL, 'Immunoglobulin superfamily member 10', 118, NULL, NULL, 16933),
(16934, '1.25.40.10-FF-002321', NULL, 'Pentatricopeptide repeat-containing protein At3g18970', 90, NULL, NULL, 16934),
(16935, '3.30.1300.10-FF-000013', NULL, NULL, 118, NULL, NULL, 16935),
(16936, '1.10.287.600-FF-000019', NULL, 'Tubulin alpha-1 chain', 32, NULL, NULL, 16936),
(16937, '2.60.40.60-FF-000274', NULL, 'neural-cadherin isoform X9', 118, NULL, NULL, 16937),
(16938, '3.90.70.10-FF-000555', NULL, 'Calpain-3', 141, NULL, NULL, 16938),
(16939, '2.40.10.10-FF-000674', NULL, NULL, 99, NULL, NULL, 16939),
(16940, '3.30.750.24-FF-000010', NULL, 'Solute carrier family 26 member 9', 140, NULL, NULL, 16940),
(16941, '2.30.30.40-FF-000066', NULL, 'dynamin-binding protein isoform X1', 66, NULL, NULL, 16941),
(16942, '1.20.1310.10-FF-000029', NULL, 'Cullin homolog 1', 151, NULL, NULL, 16942),
(16943, '2.130.10.10-FF-000377', NULL, 'uncharacterized protein LOC108094137 isoform X3', 143, NULL, NULL, 16943),
(16944, '2.170.130.20-FF-000002', NULL, 'Discoidin, CUB and LCCL domain-containing protein 2', 97, NULL, NULL, 16944),
(16945, '3.30.70.330-FF-000752', NULL, 'Peroxisome proliferator-activated receptor gamma, coactivator 1 alpha', 110, NULL, NULL, 16945),
(16946, '3.40.50.300-FF-007499', NULL, 'ATP-dependent RNA helicase dbp10', 223, NULL, NULL, 16946),
(16947, '1.10.287.40-FF-000031', NULL, 'Serine--tRNA ligase, mitochondrial', 106, NULL, NULL, 16947); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(16948, '1.20.120.1760-FF-000080', NULL, NULL, 164, NULL, NULL, 16948),
(16949, '3.90.550.10-FF-000412', NULL, 'Asparagine Linked Glycosylation (ALG) homolog, Nematode', 299, NULL, NULL, 16949),
(16950, '1.10.287.940-FF-000008', NULL, 'P2X purinoceptor', 73, NULL, NULL, 16950),
(16951, '3.10.110.10-FF-000358', NULL, 'Ubiquitin-conjugating enzyme', 163, NULL, NULL, 16951),
(16952, '1.20.58.60-FF-000431', NULL, 'Spectrin, beta, non-erythrocytic 5', 293, NULL, NULL, 16952),
(16953, '2.40.50.140-FF-000614', NULL, '30S ribosomal protein S1', 95, NULL, NULL, 16953),
(16954, '3.30.505.10-FF-000063', NULL, 'Tyrosine-protein kinase', 111, NULL, NULL, 16954),
(16955, '3.30.750.44-FF-000016', NULL, 'Os02g0815700 protein', 82, NULL, NULL, 16955),
(16956, '3.90.600.10-FF-000001', NULL, 'Trifunctional purine biosynthetic protein adenosine-3', 102, NULL, NULL, 16956),
(16957, '2.60.40.150-FF-000689', NULL, 'Phosphoinositide phospholipase C', 163, NULL, NULL, 16957),
(16958, '2.30.42.10-FF-000186', NULL, 'Big bang, isoform F', 108, NULL, NULL, 16958),
(16959, '3.30.497.10-FF-000110', NULL, 'Uncharacterized protein', 67, NULL, NULL, 16959),
(16960, '3.40.50.720-FF-002010', NULL, 'Uncharacterized protein', 221, NULL, NULL, 16960),
(16961, '3.90.1200.10-FF-000003', NULL, 'fructosamine-3-kinase isoform X1', 217, NULL, NULL, 16961),
(16962, '3.30.40.10-FF-002282', NULL, 'Predicted protein', 47, NULL, NULL, 16962),
(16963, '3.30.160.60-FF-000433', NULL, 'zinc finger protein 384 isoform X1', 26, NULL, NULL, 16963),
(16964, '3.30.200.20-FF-000032', NULL, 'Serine/threonine-protein kinase D6PK-like', 86, NULL, NULL, 16964),
(16965, '1.25.40.20-FF-000233', NULL, 'SH3 and multiple ankyrin repeat domains protein 2', 126, NULL, NULL, 16965),
(16966, '3.20.20.70-FF-000387', NULL, 'Nicotinate phosphoribosyltransferase', 117, NULL, NULL, 16966),
(16967, '2.30.30.1190-FF-000011', NULL, 'cDNA clone:002-103-E06, full insert sequence', 57, NULL, NULL, 16967),
(16968, '1.20.58.340-FF-000030', NULL, 'Magnesium transporter MRS2-3', 187, NULL, NULL, 16968),
(16969, '1.10.150.210-FF-000004', NULL, NULL, 55, NULL, NULL, 16969),
(16970, '1.10.10.1050-FF-000007', NULL, 'Unplaced genomic scaffold supercont1.26, whole genome shotgun sequence', 88, NULL, NULL, 16970),
(16971, '2.170.270.10-FF-000122', NULL, 'SET (Trithorax/polycomb) domain containing', 298, NULL, NULL, 16971),
(16972, '3.40.50.1820-FF-001759', NULL, 'Beta-hydroxypalmitic acid methyl ester hydrolase', 232, NULL, NULL, 16972),
(16973, '3.40.50.720-FF-001762', NULL, 'Uncharacterized protein', 189, NULL, NULL, 16973),
(16974, '1.10.472.80-FF-000035', NULL, 'Uncharacterized protein, isoform C', 142, NULL, NULL, 16974),
(16975, '2.60.200.20-FF-000063', NULL, 'Predicted protein', 103, NULL, NULL, 16975),
(16976, '3.30.160.60-FF-000169', NULL, 'transcriptional repressor scratch 2', 25, NULL, NULL, 16976),
(16977, '1.10.510.10-FF-002346', NULL, NULL, 199, NULL, NULL, 16977),
(16978, '1.10.510.10-FF-003066', NULL, NULL, 204, NULL, NULL, 16978),
(16979, '3.40.1390.10-FF-000011', NULL, 'UDP-N-acetylmuramoyl-L-alanyl-D-glutamate--2,6-diaminopimelate ligase', 99, NULL, NULL, 16979),
(16980, '3.40.50.970-FF-000090', NULL, 'Sulfoacetaldehyde acetyltransferase', 172, NULL, NULL, 16980),
(16981, '2.130.10.10-FF-002322', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit WDR4', 183, NULL, NULL, 16981),
(16982, '1.10.8.10-FF-000356', NULL, 'UBA domain-containing protein 6', 38, NULL, NULL, 16982),
(16983, '3.30.1330.30-FF-000055', NULL, 'Group 3 RNA methyltransferase TrmH', 83, NULL, NULL, 16983),
(16984, '3.80.10.10-FF-003154', NULL, 'F-box protein-like', 290, NULL, NULL, 16984),
(16985, '1.10.8.70-FF-000003', NULL, 'Glutamate--tRNA ligase 1', 48, NULL, NULL, 16985),
(16986, '2.40.50.140-FF-000878', NULL, NULL, 119, NULL, NULL, 16986),
(16987, '1.25.10.10-FF-000195', NULL, 'Importin subunit beta-4', 1029, NULL, NULL, 16987),
(16988, '2.60.120.650-FF-000202', NULL, 'Uncharacterized protein', 193, NULL, NULL, 16988),
(16989, '1.10.150.130-FF-000014', NULL, 'Putative integrase', 106, NULL, NULL, 16989);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(16990, '3.30.450.40-FF-000174', NULL, 'Uncharacterized protein', 182, NULL, NULL, 16990),
(16991, '3.40.1810.10-FF-000084', NULL, NULL, 84, NULL, NULL, 16991),
(16992, '1.20.1070.10-FF-001685', NULL, 'Uncharacterized protein', 114, NULL, NULL, 16992),
(16993, '1.50.10.20-FF-000049', NULL, 'Putative cyclase', 223, NULL, NULL, 16993),
(16994, '2.60.40.10-FF-001029', NULL, 'Macrophage colony-stimulating factor 1 receptor', 99, NULL, NULL, 16994),
(16995, '3.90.950.10-FF-000021', NULL, 'Maf-like protein, expressed', 122, NULL, NULL, 16995),
(16996, '1.10.510.10-FF-004494', NULL, NULL, 233, NULL, NULL, 16996),
(16997, '3.30.70.330-FF-002309', NULL, NULL, 120, NULL, NULL, 16997),
(16998, '3.30.40.10-FF-001707', NULL, 'RBR-type E3 ubiquitin transferase', 121, NULL, NULL, 16998),
(16999, '3.10.100.10-FF-000329', NULL, NULL, 106, NULL, NULL, 16999),
(17000, '1.10.10.10-FF-001032', NULL, 'DNA-binding response regulator', 98, NULL, NULL, 17000),
(17001, '3.30.559.30-FF-000018', NULL, 'Nonribosomal siderophore peptide synthase SidC', 257, NULL, NULL, 17001),
(17002, '2.60.220.50-FF-000022', NULL, 'Adhesion G protein-coupled receptor E3', 184, NULL, NULL, 17002),
(17003, '3.30.160.60-FF-005492', NULL, NULL, 19, NULL, NULL, 17003),
(17004, '1.10.150.240-FF-000108', NULL, 'Slr0586 protein', 74, NULL, NULL, 17004),
(17005, '3.30.160.60-FF-004064', NULL, NULL, 38, NULL, NULL, 17005),
(17006, '3.80.10.10-FF-003862', NULL, 'Leucine-rich repeat receptor protein kinase MSL1', 72, NULL, NULL, 17006),
(17007, '2.60.120.10-FF-000789', NULL, 'Cyclic nucleotide-binding', 142, NULL, NULL, 17007),
(17008, '3.40.50.1000-FF-000176', NULL, '5''-nucleotidase domain-containing protein, putative', 192, NULL, NULL, 17008),
(17009, '4.10.280.110-FF-000023', NULL, NULL, 48, NULL, NULL, 17009),
(17010, '3.30.70.2600-FF-000001', NULL, 'Dipeptidyl peptidase 3', 79, NULL, NULL, 17010),
(17011, '1.20.58.60-FF-000200', NULL, 'Karst, isoform B', 221, NULL, NULL, 17011),
(17012, '2.60.210.10-FF-000032', NULL, 'TRAF-like family protein', 148, NULL, NULL, 17012),
(17013, '1.25.40.20-FF-000941', NULL, 'Uncharacterized protein', 138, NULL, NULL, 17013),
(17014, '1.10.510.10-FF-003774', NULL, NULL, 135, NULL, NULL, 17014),
(17015, '1.10.510.10-FF-002610', NULL, NULL, 142, NULL, NULL, 17015),
(17016, '3.40.47.10-FF-000115', NULL, 'Uncharacterized protein', 161, NULL, NULL, 17016),
(17017, '1.10.10.10-FF-000312', NULL, 'Pleckstrin 2', 112, NULL, NULL, 17017),
(17018, '1.10.1170.10-FF-000008', NULL, 'Putative e3 ubiquitin-protein ligase xiap', 118, NULL, NULL, 17018),
(17019, '1.10.20.120-FF-000017', NULL, 'Predicted protein', 78, NULL, NULL, 17019),
(17020, '2.60.40.10-FF-003710', NULL, NULL, 86, NULL, NULL, 17020),
(17021, '1.10.630.10-FF-000107', NULL, 'Benzoate 4-monooxygenase cytochrome P450', 485, NULL, NULL, 17021),
(17022, '3.40.50.620-FF-000889', NULL, 'Uncharacterized protein', 99, NULL, NULL, 17022),
(17023, '3.40.395.10-FF-000039', NULL, 'Predicted protein', 157, NULL, NULL, 17023),
(17024, '1.25.10.10-FF-002381', NULL, 'AGAP004322-PA', 269, NULL, NULL, 17024),
(17025, '1.10.10.410-FF-000012', NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit E', 58, NULL, NULL, 17025),
(17026, '3.40.50.10330-FF-000080', NULL, 'Sphingosine kinase A', 136, NULL, NULL, 17026),
(17027, '2.60.40.60-FF-001055', NULL, 'R-cadherin', 77, NULL, NULL, 17027),
(17028, '3.30.450.20-FF-000016', NULL, 'Circadian locomoter output cycles protein', 142, NULL, NULL, 17028),
(17029, '3.40.50.2300-FF-001448', NULL, NULL, 28, NULL, NULL, 17029),
(17030, '3.30.56.10-FF-000030', NULL, 'Phenylalanyl-tRNA synthetase beta chain', 80, NULL, NULL, 17030),
(17031, '1.20.1560.10-FF-000340', NULL, 'Multiple drug resistance-associated protein-like transporter 1', 339, NULL, NULL, 17031),
(17032, '2.170.150.80-FF-000027', NULL, 'NAC domain transcription factor', 124, NULL, NULL, 17032),
(17033, '3.90.810.10-FF-000011', NULL, 'Serine/threonine protein kinase, putative', 43, NULL, NULL, 17033),
(17034, '2.60.120.1330-FF-000001', NULL, 'Uncharacterized protein', 117, NULL, NULL, 17034);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(17035, '3.40.1410.10-FF-000036', NULL, 'HTH-type transcriptional repressor YvoA', 167, NULL, NULL, 17035),
(17036, '3.40.50.300-FF-007763', NULL, 'Protein CBG01006', 69, NULL, NULL, 17036),
(17037, '3.50.50.60-FF-000435', NULL, 'Amine oxidase', 436, NULL, NULL, 17037),
(17038, '3.30.1120.90-FF-000012', NULL, 'Nucleosome assembly protein-like protein', 205, NULL, NULL, 17038),
(17039, '1.10.533.20-FF-000002', NULL, 'Uncharacterized protein', 101, NULL, NULL, 17039),
(17040, '3.40.50.300-FF-000883', NULL, 'Multidrug ABC transporter ATP-binding protein', 243, NULL, NULL, 17040),
(17041, '1.20.140.40-FF-000082', NULL, NULL, 73, NULL, NULL, 17041),
(17042, '3.30.40.10-FF-002074', NULL, 'Uncharacterized protein', 87, NULL, NULL, 17042),
(17043, '3.40.50.150-FF-001125', NULL, 'Mitochondrial transcription factor 1', 295, NULL, NULL, 17043),
(17044, '3.40.50.300-FF-006774', NULL, 'Predicted protein', 60, NULL, NULL, 17044),
(17045, '2.130.10.10-FF-003311', NULL, 'Protein CBG01041', 197, NULL, NULL, 17045),
(17046, '3.20.20.10-FF-000004', NULL, 'Pyridoxal phosphate homeostasis protein', 228, NULL, NULL, 17046),
(17047, '3.40.50.2300-FF-000375', NULL, 'Hybrid signal transduction histidine kinase K', 212, NULL, NULL, 17047),
(17048, '3.30.200.20-FF-000616', NULL, 'AKT serine/threonine kinase 1', 17, NULL, NULL, 17048),
(17049, '1.10.10.10-FF-000076', NULL, 'Forkhead box protein D3', 107, NULL, NULL, 17049),
(17050, '3.40.50.720-FF-002482', NULL, 'Uncharacterized protein', 198, NULL, NULL, 17050),
(17051, '3.40.50.300-FF-004626', NULL, 'Probable ATP-binding component of ABC transporter', 250, NULL, NULL, 17051),
(17052, '1.10.510.10-FF-001621', NULL, 'Uncharacterized protein', 316, NULL, NULL, 17052),
(17053, '1.10.10.10-FF-000784', NULL, 'Protein CBR-TAG-97', 136, NULL, NULL, 17053),
(17054, '1.25.10.10-FF-002965', NULL, 'Uncharacterized protein', 426, NULL, NULL, 17054),
(17055, '3.30.420.40-FF-000785', NULL, 'AaceriABR084Wp', 156, NULL, NULL, 17055),
(17056, '2.60.40.60-FF-000066', NULL, 'FAT atypical cadherin 1', 102, NULL, NULL, 17056),
(17057, '3.40.50.12550-FF-000009', NULL, 'Uncharacterized protein', 54, NULL, NULL, 17057),
(17058, '2.60.40.10-FF-000484', NULL, 'Tyrosine-protein kinase receptor TYRO3', 97, NULL, NULL, 17058),
(17059, '3.10.100.10-FF-000273', NULL, NULL, 138, NULL, NULL, 17059),
(17060, '2.60.40.420-FF-000085', NULL, 'Multicopper oxidase, putative', 129, NULL, NULL, 17060),
(17061, '3.90.1750.10-FF-000090', NULL, 'Uncharacterized protein', 65, NULL, NULL, 17061),
(17062, '3.40.1190.20-FF-000212', NULL, NULL, 49, NULL, NULL, 17062),
(17063, '2.10.25.10-FF-000939', NULL, 'Low-density lipoprotein receptor-related protein', 43, NULL, NULL, 17063),
(17064, '3.90.1420.10-FF-000014', NULL, '[Ribulose-bisphosphate-carboxylase]-lysine N-methyltransferase, putative', 155, NULL, NULL, 17064),
(17065, '3.30.70.1400-FF-000006', NULL, 'Glycine cleavage system T protein', 88, NULL, NULL, 17065),
(17066, '1.10.238.10-FF-000499', NULL, 'Dual oxidase 1', 206, NULL, NULL, 17066),
(17067, '2.60.40.10-FF-002018', NULL, 'Jitterbug, isoform M', 96, NULL, NULL, 17067),
(17068, '3.90.1290.10-FF-000071', NULL, 'Uncharacterized protein', 147, NULL, NULL, 17068),
(17069, '3.40.50.300-FF-007027', NULL, 'Uncharacterized protein', 204, NULL, NULL, 17069),
(17070, '2.20.100.10-FF-000230', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs gon-1', 54, NULL, NULL, 17070),
(17071, '1.20.58.60-FF-000167', NULL, 'microtubule-actin cross-linking factor 1 isoform X9', 114, NULL, NULL, 17071),
(17072, '1.25.10.10-FF-003218', NULL, 'Predicted protein', 269, NULL, NULL, 17072),
(17073, '3.30.200.20-FF-000296', NULL, 'Receptor-like kinase LRK10', 102, NULL, NULL, 17073),
(17074, '2.70.170.10-FF-000071', NULL, 'Nicotinic acetylcholine receptor Dalpha7 subunit', 198, NULL, NULL, 17074),
(17075, '3.30.572.10-FF-000004', NULL, 'Bifunctional dihydrofolate reductase-thymidylate synthase', 289, NULL, NULL, 17075),
(17076, '3.10.520.10-FF-000001', NULL, 'FAD:protein FMN transferase', 319, NULL, NULL, 17076);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(17077, '1.20.58.390-FF-000292', NULL, 'Uncharacterized protein', 112, NULL, NULL, 17077),
(17078, '3.30.50.10-FF-000163', NULL, 'Uncharacterized protein', 92, NULL, NULL, 17078),
(17079, '1.10.510.10-FF-002138', NULL, 'Kinase, NEK', 220, NULL, NULL, 17079),
(17080, '3.30.70.1730-FF-000021', NULL, '60S acidic ribosomal protein P0', 49, NULL, NULL, 17080),
(17081, '3.10.20.90-FF-000798', NULL, 'UBX domain-containing protein 3', 81, NULL, NULL, 17081),
(17082, '1.20.5.340-FF-000058', NULL, 'MYO-2', 113, NULL, NULL, 17082),
(17083, '2.40.240.10-FF-000050', NULL, 'Uncharacterized protein', 107, NULL, NULL, 17083),
(17084, '2.60.40.150-FF-000161', NULL, 'Synaptotagmin 15', 147, NULL, NULL, 17084),
(17085, '2.40.30.170-FF-000001', NULL, 'Multidrug resistance efflux transporter MdtE', 82, NULL, NULL, 17085),
(17086, '3.40.630.10-FF-000087', NULL, 'Probable cytosol aminopeptidase', 339, NULL, NULL, 17086),
(17087, '3.40.50.300-FF-006251', NULL, 'Uncharacterized protein', 183, NULL, NULL, 17087),
(17088, '3.40.630.10-FF-000407', NULL, 'Succinyl-diaminopimelate desuccinylase', 170, NULL, NULL, 17088),
(17089, '3.40.50.410-FF-000152', NULL, 'TFIIH P44', 176, NULL, NULL, 17089),
(17090, '1.20.1250.20-FF-001229', NULL, 'Uncharacterized protein', 439, NULL, NULL, 17090),
(17091, '3.30.500.10-FF-000012', NULL, 'Glycoprotein UL18', 189, NULL, NULL, 17091),
(17092, '3.40.710.10-FF-000088', NULL, 'Cell division protein', 198, NULL, NULL, 17092),
(17093, '2.130.10.10-FF-000641', NULL, 'F-box/WD repeat-containing protein 9 isoform X2', 214, NULL, NULL, 17093),
(17094, '2.120.10.30-FF-000232', NULL, 'Protein CBR-DPF-5', 160, NULL, NULL, 17094),
(17095, '3.60.10.10-FF-000266', NULL, 'Predicted protein', 85, NULL, NULL, 17095),
(17096, '1.10.10.10-FF-002021', NULL, 'Uncharacterized protein', 108, NULL, NULL, 17096),
(17097, '2.60.260.20-FF-000072', NULL, 'Chaperone protein DnaJ', 111, NULL, NULL, 17097),
(17098, '2.60.40.60-FF-000627', NULL, 'Uncharacterized protein', 90, NULL, NULL, 17098),
(17099, '1.10.8.500-FF-000002', NULL, 'Methyl-accepting chemotaxis protein', 51, NULL, NULL, 17099),
(17100, '1.10.10.60-FF-000630', NULL, 'Photoperiod independent early flowering protein', 62, NULL, NULL, 17100),
(17101, '2.130.10.10-FF-003250', NULL, 'LD47550p', 214, NULL, NULL, 17101),
(17102, '3.30.70.330-FF-002197', NULL, NULL, 115, NULL, NULL, 17102),
(17103, '2.40.10.120-FF-000027', NULL, 'Trypsin domain containing 1', 118, NULL, NULL, 17103),
(17104, '1.10.167.10-FF-000069', NULL, 'Sorting nexin-12', 153, NULL, NULL, 17104),
(17105, '2.40.30.10-FF-000118', NULL, 'Translation elongation factor G', 113, NULL, NULL, 17105),
(17106, '3.30.70.330-FF-002517', NULL, NULL, 63, NULL, NULL, 17106),
(17107, '1.10.510.10-FF-003274', NULL, NULL, 103, NULL, NULL, 17107),
(17108, '1.10.1670.40-FF-000016', NULL, 'DNA-3-methyladenine glycosylase II, putative', 73, NULL, NULL, 17108),
(17109, '3.30.70.370-FF-000005', NULL, 'DNA polymerase theta', 95, NULL, NULL, 17109),
(17110, '3.30.160.60-FF-006273', NULL, NULL, 56, NULL, NULL, 17110),
(17111, '1.10.10.10-FF-000576', NULL, 'Transcriptional regulator HosA', 146, NULL, NULL, 17111),
(17112, '1.50.40.10-FF-000284', NULL, 'Mitochondrial carrier protein (Rim2), putative (AFU_orthologue AFUA_3G06950)', 236, NULL, NULL, 17112),
(17113, '4.10.970.10-FF-000014', NULL, 'Ku70-like protein', 63, NULL, NULL, 17113),
(17114, '3.30.420.40-FF-000993', NULL, 'Uncharacterized protein', 86, NULL, NULL, 17114),
(17115, '3.30.420.110-FF-000047', NULL, 'DNA mismatch repair protein MutS', 134, NULL, NULL, 17115),
(17116, '3.90.980.20-FF-000026', NULL, NULL, 164, NULL, NULL, 17116),
(17117, '1.20.1070.10-FF-000757', NULL, 'Predicted protein', 137, NULL, NULL, 17117),
(17118, '3.40.50.300-FF-002209', NULL, 'Uncharacterized protein', 247, NULL, NULL, 17118),
(17119, '3.90.1150.10-FF-000089', NULL, 'Threonine aldolase, putative', 88, NULL, NULL, 17119),
(17120, '3.30.160.20-FF-000005', NULL, 'Putative double-stranded RNA-specific adenosine deaminase', 87, NULL, NULL, 17120),
(17121, '3.30.160.60-FF-000933', NULL, 'zinc finger protein 771', 29, NULL, NULL, 17121);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(17122, '3.40.50.1820-FF-000742', NULL, 'Putative inactive methylesterase 20', 133, NULL, NULL, 17122),
(17123, '2.130.10.10-FF-006037', NULL, 'Predicted protein', 280, NULL, NULL, 17123),
(17124, '2.60.40.10-FF-005508', NULL, NULL, 81, NULL, NULL, 17124),
(17125, '1.10.418.10-FF-000041', NULL, 'Fimbrin-2 isoform A', 129, NULL, NULL, 17125),
(17126, '1.25.40.10-FF-004474', NULL, 'Uncharacterized protein', 105, NULL, NULL, 17126),
(17127, '2.60.40.820-FF-000025', NULL, 'Uncharacterized protein', 196, NULL, NULL, 17127),
(17128, '3.80.10.10-FF-002373', NULL, 'Os03g0400800 protein', 297, NULL, NULL, 17128),
(17129, '1.10.150.390-FF-000013', NULL, NULL, 46, NULL, NULL, 17129),
(17130, '1.20.1070.10-FF-000173', NULL, 'Free fatty acid receptor 1', 289, NULL, NULL, 17130),
(17131, '3.40.50.300-FF-006982', NULL, 'Uncharacterized protein', 216, NULL, NULL, 17131),
(17132, '3.40.640.10-FF-000436', NULL, 'Transcriptional regulator (DegT/DnrJ/Eryc1 family)', 232, NULL, NULL, 17132),
(17133, '1.25.10.10-FF-000548', NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit', 402, NULL, NULL, 17133),
(17134, '2.60.40.10-FF-004227', NULL, NULL, 65, NULL, NULL, 17134),
(17135, '3.30.2320.40-FF-000001', NULL, 'Capsid vertex protein', 119, NULL, NULL, 17135),
(17136, '2.130.10.10-FF-003103', NULL, 'Uncharacterized protein', 297, NULL, NULL, 17136),
(17137, '2.60.40.10-FF-002518', NULL, 'Protein sidekick homolog', 113, NULL, NULL, 17137),
(17138, '1.20.1280.50-FF-000083', NULL, 'Lysine (K)-specific demethylase 2B', 44, NULL, NULL, 17138),
(17139, '3.30.200.20-FF-002241', NULL, 'Zgc:171775', 32, NULL, NULL, 17139),
(17140, '3.30.559.10-FF-000182', NULL, 'HC-toxin synthetase', 205, NULL, NULL, 17140),
(17141, '1.25.40.10-FF-004327', NULL, 'Uncharacterized protein', 170, NULL, NULL, 17141),
(17142, '3.30.900.10-FF-000060', NULL, 'Uncharacterized protein', 207, NULL, NULL, 17142),
(17143, '2.30.250.10-FF-000013', NULL, 'Clan MH, family M18, aspartyl aminopeptidase-like metallopeptidase', 30, NULL, NULL, 17143),
(17144, '3.40.50.300-FF-001900', NULL, 'Multidrug resistance protein', 87, NULL, NULL, 17144),
(17145, '3.40.50.300-FF-005346', NULL, 'Uncharacterized protein', 230, NULL, NULL, 17145),
(17146, '3.50.50.60-FF-000227', NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase', 241, NULL, NULL, 17146),
(17147, '1.20.1740.10-FF-000258', NULL, 'Uncharacterized protein', 268, NULL, NULL, 17147),
(17148, '1.20.1270.10-FF-000093', NULL, 'Hsp70 protein, putative', 113, NULL, NULL, 17148),
(17149, '3.30.40.10-FF-001354', NULL, 'RBR-type E3 ubiquitin transferase', 87, NULL, NULL, 17149),
(17150, '3.40.50.720-FF-000065', NULL, 'UDP-glucuronic acid decarboxylase 1', 315, NULL, NULL, 17150),
(17151, '3.10.50.10-FF-000057', NULL, 'Chitinase, putative', 74, NULL, NULL, 17151),
(17152, '3.30.450.30-FF-000053', NULL, 'GEO02361p1', 103, NULL, NULL, 17152),
(17153, '1.20.120.1190-FF-000004', NULL, NULL, 154, NULL, NULL, 17153),
(17154, '1.20.1250.20-FF-000151', NULL, 'Sugar efflux transporter SetB', 180, NULL, NULL, 17154),
(17155, '1.10.510.10-FF-002869', NULL, 'Guanylate cyclase', 288, NULL, NULL, 17155),
(17156, '3.40.720.10-FF-000178', NULL, 'N-acetylgalactosamine-6-sulfatase (GALNS)', 220, NULL, NULL, 17156),
(17157, '3.30.300.90-FF-000009', NULL, NULL, 89, NULL, NULL, 17157),
(17158, '3.40.630.10-FF-000351', NULL, 'Carboxypeptidase Z', 196, NULL, NULL, 17158),
(17159, '3.10.20.90-FF-000326', NULL, 'Inhibitor of kappa light polypeptide gene enhancer in B-cells, kinase beta', 88, NULL, NULL, 17159),
(17160, '1.25.40.180-FF-000158', NULL, NULL, 241, NULL, NULL, 17160),
(17161, '3.40.50.11980-FF-000006', NULL, 'AGAP001968-PB', 166, NULL, NULL, 17161),
(17162, '1.10.10.2480-FF-000009', NULL, NULL, 87, NULL, NULL, 17162),
(17163, '3.30.710.10-FF-000225', NULL, 'Phototropic-responsive NPH3 family protein', 114, NULL, NULL, 17163),
(17164, '3.40.50.2300-FF-000167', NULL, 'Two-component response regulator GlrR', 124, NULL, NULL, 17164),
(17165, '3.65.10.20-FF-000028', NULL, 'Uncharacterized protein', 93, NULL, NULL, 17165);
INSERT INTO "PUBLIC"."MODEL" VALUES
(17166, '1.20.80.10-FF-000029', NULL, 'Uncharacterized protein, isoform A', 123, NULL, NULL, 17166),
(17167, '3.60.10.10-FF-000058', NULL, 'Tyrosyl-DNA phosphodiesterase 2', 275, NULL, NULL, 17167),
(17168, '3.80.10.10-FF-001092', NULL, 'NACHT, LRR and PYD domains-containing protein 2', 218, NULL, NULL, 17168),
(17169, '3.40.50.300-FF-006835', NULL, 'Uncharacterized protein', 340, NULL, NULL, 17169),
(17170, '3.90.550.10-FF-000092', NULL, 'Glycogenin 2', 251, NULL, NULL, 17170),
(17171, '3.90.550.10-FF-000148', NULL, 'Glg2p', 281, NULL, NULL, 17171),
(17172, '3.30.450.50-FF-000059', NULL, 'Uncharacterized protein', 134, NULL, NULL, 17172),
(17173, '2.10.25.10-FF-000439', NULL, 'Netrin G2', 60, NULL, NULL, 17173),
(17174, '3.90.570.10-FF-000003', NULL, 'Amyloid beta precursor like protein 1', 102, NULL, NULL, 17174),
(17175, '2.30.36.70-FF-000004', NULL, 'Actin-like 6A, isoform CRA_a', 47, NULL, NULL, 17175),
(17176, '1.25.40.70-FF-000023', NULL, 'Phosphatidylinositol 3-kinase 2', 234, NULL, NULL, 17176),
(17177, '3.30.420.40-FF-000846', NULL, 'Cell division protein FtsA', 47, NULL, NULL, 17177),
(17178, '1.25.40.10-FF-003046', NULL, 'ERAD-associated E3 ubiquitin-protein ligase component HRD3A', 82, NULL, NULL, 17178),
(17179, '2.60.40.10-FF-002670', NULL, 'Fibronectin 1a', 95, NULL, NULL, 17179),
(17180, '2.120.10.30-FF-000024', NULL, 'Low-density lipoprotein receptor-related protein', 261, NULL, NULL, 17180),
(17181, '3.40.50.300-FF-004065', NULL, 'Actin cross-linking, putative', 297, NULL, NULL, 17181),
(17182, '1.10.510.10-FF-000340', NULL, 'Serine threonine protein kinase', 129, NULL, NULL, 17182),
(17183, '3.40.50.620-FF-000389', NULL, 'Tyrosyl-tRNA synthetase putative', 53, NULL, NULL, 17183),
(17184, '4.10.800.20-FF-000005', NULL, 'Adenosine monophosphate deaminase, putative', 98, NULL, NULL, 17184),
(17185, '1.10.1200.10-FF-000006', NULL, 'Acyl carrier protein', 77, NULL, NULL, 17185),
(17186, '3.30.160.60-FF-002378', NULL, 'Uncharacterized protein', 30, NULL, NULL, 17186),
(17187, '1.10.287.110-FF-000440', NULL, 'Uncharacterized protein', 71, NULL, NULL, 17187),
(17188, '2.60.40.10-FF-001765', NULL, 'Cruciform DNA-recognizing protein 1', 93, NULL, NULL, 17188),
(17189, '1.25.40.10-FF-001865', NULL, 'AGAP000119-PA', 296, NULL, NULL, 17189),
(17190, '2.70.98.10-FF-000083', NULL, 'Rhamnogalacturonate lyase B', 296, NULL, NULL, 17190),
(17191, '3.40.30.10-FF-000459', NULL, 'Cytochrome c oxidase assembly factor-like protein', 192, NULL, NULL, 17191),
(17192, '1.20.1560.10-FF-000401', NULL, 'ATP-binding cassette transporter (ABC transporter) family C member 11', 320, NULL, NULL, 17192),
(17193, '1.20.58.70-FF-000057', NULL, 'Syntaxin 1-2', 126, NULL, NULL, 17193),
(17194, '2.20.100.10-FF-000022', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 3', 60, NULL, NULL, 17194),
(17195, '3.40.630.30-FF-000357', NULL, 'CurA', 221, NULL, NULL, 17195),
(17196, '3.30.70.330-FF-001180', NULL, 'RNA recognition motif domain containing protein', 96, NULL, NULL, 17196),
(17197, '3.10.150.10-FF-000012', NULL, 'Beta sliding clamp', 168, NULL, NULL, 17197),
(17198, '3.30.30.30-FF-000050', NULL, 'Protein CBG03751', 60, NULL, NULL, 17198),
(17199, '1.10.630.10-FF-000579', NULL, 'Uncharacterized protein', 306, NULL, NULL, 17199),
(17200, '1.10.437.10-FF-000017', NULL, 'MCL1, BCL2 family apoptosis regulator', 140, NULL, NULL, 17200),
(17201, '1.20.1250.20-FF-001729', NULL, 'Monocarboxylate transporter, putative', 339, NULL, NULL, 17201),
(17202, '2.70.98.20-FF-000029', NULL, 'Amine oxidase', 297, NULL, NULL, 17202),
(17203, '1.25.50.20-FF-000059', NULL, 'Aminopeptidase', 134, NULL, NULL, 17203),
(17204, '1.10.357.10-FF-000016', NULL, 'TetR family transcriptional regulator', 198, NULL, NULL, 17204),
(17205, '3.40.50.10610-FF-000006', NULL, 'Penicillin-binding protein activator LpoB', 134, NULL, NULL, 17205),
(17206, '1.25.40.90-FF-000029', NULL, 'AP-4 complex accessory subunit Tepsin', 130, NULL, NULL, 17206),
(17207, '3.60.20.10-FF-000031', NULL, 'Proteasome subunit alpha type', 249, NULL, NULL, 17207);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(17208, '3.50.50.100-FF-000006', NULL, 'apoptosis-inducing factor 2', 360, NULL, NULL, 17208),
(17209, '3.50.30.50-FF-000015', NULL, 'Uncharacterized protein', 65, NULL, NULL, 17209),
(17210, '1.50.40.10-FF-000020', NULL, 'mitochondrial uncoupling protein 4 isoform X1', 300, NULL, NULL, 17210),
(17211, '3.30.70.330-FF-002461', NULL, NULL, 82, NULL, NULL, 17211),
(17212, '3.30.428.10-FF-000035', NULL, 'Scavenger mRNA decapping enzyme, putative', 188, NULL, NULL, 17212),
(17213, '3.40.140.10-FF-000179', NULL, 'Uncharacterized protein', 179, NULL, NULL, 17213),
(17214, '3.90.650.10-FF-000004', NULL, 'Selenide, water dikinase', 182, NULL, NULL, 17214),
(17215, '2.60.120.260-FF-000147', NULL, 'Mannosidase beta', 107, NULL, NULL, 17215),
(17216, '3.30.160.60-FF-004587', NULL, NULL, 30, NULL, NULL, 17216),
(17217, '3.10.250.10-FF-000076', NULL, NULL, 77, NULL, NULL, 17217),
(17218, '3.60.21.10-FF-000286', NULL, 'Metallophosphoesterase 1', 110, NULL, NULL, 17218),
(17219, '2.60.120.10-FF-000317', NULL, 'Lysophospholipase NTE1', 77, NULL, NULL, 17219),
(17220, '1.25.40.10-FF-003810', NULL, 'Beta-lactamase HcpB', 138, NULL, NULL, 17220),
(17221, '2.40.40.20-FF-000004', NULL, 'Aspartate 1-decarboxylase', 126, NULL, NULL, 17221),
(17222, '3.90.70.10-FF-000616', NULL, 'Ubiquitinyl hydrolase 1', 150, NULL, NULL, 17222),
(17223, '3.30.160.60-FF-003659', NULL, 'LD28458p', 25, NULL, NULL, 17223),
(17224, '2.120.10.80-FF-000286', NULL, 'Serine/threonine-protein phosphatase', 230, NULL, NULL, 17224),
(17225, '1.10.238.10-FF-001016', NULL, 'NADPH oxidase 5', 116, NULL, NULL, 17225),
(17226, '1.10.3720.10-FF-000181', NULL, 'ABC transporter permease protein', 216, NULL, NULL, 17226),
(17227, '1.10.533.10-FF-000229', NULL, 'Uncharacterized protein', 85, NULL, NULL, 17227),
(17228, '2.60.40.4100-FF-000001', NULL, 'alpha-tectorin isoform X1', 154, NULL, NULL, 17228),
(17229, '3.40.50.300-FF-000411', NULL, 'dynein heavy chain 17, axonemal', 132, NULL, NULL, 17229),
(17230, '3.90.70.10-FF-000763', NULL, 'Uncharacterized protein', 87, NULL, NULL, 17230),
(17231, '1.10.472.10-FF-000183', NULL, 'Uncharacterized protein', 128, NULL, NULL, 17231),
(17232, '1.10.287.70-FF-000719', NULL, 'Cyclic nucleotide-gated potassium channel', 243, NULL, NULL, 17232),
(17233, '1.25.40.10-FF-001601', NULL, 'Uncharacterized protein', 160, NULL, NULL, 17233),
(17234, '2.10.25.10-FF-001159', NULL, 'Uncharacterized protein', 40, NULL, NULL, 17234),
(17235, '3.30.60.30-FF-000198', NULL, 'Organic anion transporter, putative', 42, NULL, NULL, 17235),
(17236, '2.60.120.620-FF-000098', NULL, 'Predicted protein', 218, NULL, NULL, 17236),
(17237, '3.40.50.2000-FF-000667', NULL, 'Uncharacterized protein', 214, NULL, NULL, 17237),
(17238, '1.20.1290.10-FF-000004', NULL, 'Alkyl hydroperoxide reductase AhpD', 177, NULL, NULL, 17238),
(17239, '2.130.10.10-FF-002794', NULL, 'Transcriptional corepressor LEUNIG', 202, NULL, NULL, 17239),
(17240, '1.10.1410.10-FF-000016', NULL, 'Poly(A) polymerase, putative', 197, NULL, NULL, 17240),
(17241, '1.10.10.2660-FF-000030', NULL, 'SUMO-activating enzyme subunit', 47, NULL, NULL, 17241),
(17242, '3.30.70.260-FF-000175', NULL, 'Predicted protein', 62, NULL, NULL, 17242),
(17243, '3.40.50.300-FF-002620', NULL, 'Elongator complex protein 5', 232, NULL, NULL, 17243),
(17244, '2.60.120.330-FF-000224', NULL, 'Uncharacterized protein', 181, NULL, NULL, 17244),
(17245, '2.40.50.140-FF-000114', NULL, '30S ribosomal protein S1', 87, NULL, NULL, 17245),
(17246, '3.40.30.10-FF-000723', NULL, 'Grx_C3-glutaredoxin subgroup I', 109, NULL, NULL, 17246),
(17247, '2.130.10.10-FF-002086', NULL, 'Dynein intermediate chain at 61B, isoform B', 238, NULL, NULL, 17247),
(17248, '3.50.80.10-FF-000001', NULL, 'D-aminoacyl-tRNA deacylase', 152, NULL, NULL, 17248),
(17249, '1.25.40.420-FF-000011', NULL, 'gigaxonin isoform X2', 125, NULL, NULL, 17249),
(17250, '3.60.40.10-FF-000094', NULL, 'Protein phosphatase PPM5', 247, NULL, NULL, 17250),
(17251, '3.30.200.20-FF-001521', NULL, 'Uncharacterized protein', 137, NULL, NULL, 17251),
(17252, '1.20.1270.60-FF-000203', NULL, 'rho GTPase-activating protein 26', 260, NULL, NULL, 17252); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(17253, '3.30.420.10-FF-000214', NULL, 'DNA polymerase I', 167, NULL, NULL, 17253),
(17254, '1.10.1450.10-FF-000081', NULL, 'Tetraspanin', 108, NULL, NULL, 17254),
(17255, '3.80.10.10-FF-000164', NULL, 'podocan', 71, NULL, NULL, 17255),
(17256, '3.90.70.10-FF-000055', NULL, 'cysteine protease XCP2', 327, NULL, NULL, 17256),
(17257, '2.60.40.790-FF-000206', NULL, NULL, 159, NULL, NULL, 17257),
(17258, '3.40.1370.10-FF-000009', NULL, '50S ribosomal protein L4', 208, NULL, NULL, 17258),
(17259, '1.25.40.10-FF-002118', NULL, 'Pentatricopeptide repeat-containing protein At4g13650', 134, NULL, NULL, 17259),
(17260, '3.30.460.10-FF-000132', NULL, 'Bifunctional uridylyltransferase/uridylyl-removing enzyme', 102, NULL, NULL, 17260),
(17261, '2.130.10.10-FF-002906', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit wdr4', 143, NULL, NULL, 17261),
(17262, '2.20.70.10-FF-000285', NULL, 'E3 ubiquitin-protein ligase', 58, NULL, NULL, 17262),
(17263, '2.20.70.10-FF-000021', NULL, 'E3 ubiquitin-protein ligase NEDD4', 51, NULL, NULL, 17263),
(17264, '1.10.10.2330-FF-000015', NULL, NULL, 71, NULL, NULL, 17264),
(17265, '1.10.472.80-FF-000243', NULL, NULL, 156, NULL, NULL, 17265),
(17266, '1.20.1310.10-FF-000181', NULL, NULL, 116, NULL, NULL, 17266),
(17267, '3.40.50.720-FF-001554', NULL, 'Pteridine reductase 1-possibly short-chain dehydrogenase', 252, NULL, NULL, 17267),
(17268, '3.40.190.10-FF-000070', NULL, 'HTH-type transcriptional regulator SgrR', 199, NULL, NULL, 17268),
(17269, '2.60.40.150-FF-000217', NULL, 'Tcb1p', 136, NULL, NULL, 17269),
(17270, '1.25.10.10-FF-001212', NULL, 'Early embryogenesis protein zyg-11', 305, NULL, NULL, 17270),
(17271, '3.20.20.70-FF-000179', NULL, 'Nicotinate phosphoribosyltransferase', 61, NULL, NULL, 17271),
(17272, '1.25.40.10-FF-000584', NULL, 'Pentatricopeptide repeat-containing protein', 134, NULL, NULL, 17272),
(17273, '3.40.50.2300-FF-001656', NULL, NULL, 197, NULL, NULL, 17273),
(17274, '3.40.50.2300-FF-001095', NULL, NULL, 155, NULL, NULL, 17274),
(17275, '3.30.70.330-FF-000252', NULL, 'RNA binding motif protein 41', 93, NULL, NULL, 17275),
(17276, '1.20.210.10-FF-000039', NULL, 'Nitric oxide reductase QnorB', 185, NULL, NULL, 17276),
(17277, '3.40.50.2000-FF-000403', NULL, 'Glycosyltransferase family 1 protein', 175, NULL, NULL, 17277),
(17278, '2.40.50.100-FF-000214', NULL, 'ABC-type iron(III) transport system, ATPase component', 46, NULL, NULL, 17278),
(17279, '3.30.720.210-FF-000021', NULL, 'ATP-dependent zinc metalloprotease FtsH', 70, NULL, NULL, 17279),
(17280, '1.10.10.10-FF-001240', NULL, 'Anaphase-promoting complex subunit 2', 86, NULL, NULL, 17280),
(17281, '3.30.230.10-FF-000087', NULL, 'Diphosphomevalonate decarboxylase', 176, NULL, NULL, 17281),
(17282, '1.10.10.1440-FF-000001', NULL, 'phosphorylated adapter RNA export protein-like', 104, NULL, NULL, 17282),
(17283, '2.40.10.10-FF-000527', NULL, NULL, 99, NULL, NULL, 17283),
(17284, '3.40.50.1820-FF-000478', NULL, 'Alpha/beta-hydrolase', 254, NULL, NULL, 17284),
(17285, '2.30.30.140-FF-000011', NULL, 'Zinc finger MYND domain-containing protein 11', 105, NULL, NULL, 17285),
(17286, '1.25.40.10-FF-002793', NULL, 'Uncharacterized protein', 236, NULL, NULL, 17286),
(17287, '1.25.40.570-FF-000005', NULL, '26S proteasome regulatory subunit N7', 327, NULL, NULL, 17287),
(17288, '2.40.50.140-FF-000378', NULL, 'Replication protein A subunit', 189, NULL, NULL, 17288),
(17289, '2.30.30.490-FF-000032', NULL, 'Origin recognition complex subunit 1', 227, NULL, NULL, 17289),
(17290, '2.60.120.920-FF-000159', NULL, 'Uncharacterized protein', 154, NULL, NULL, 17290),
(17291, '2.30.30.40-FF-000274', NULL, '[PSI+] inducibility protein 3', 66, NULL, NULL, 17291),
(17292, '3.30.200.20-FF-001785', NULL, 'Uncharacterized protein', 98, NULL, NULL, 17292),
(17293, '1.25.10.10-FF-003421', NULL, 'Uncharacterized protein', 311, NULL, NULL, 17293),
(17294, '3.40.50.300-FF-008516', NULL, 'Uncharacterized protein', 117, NULL, NULL, 17294),
(17295, '3.40.50.1000-FF-000412', NULL, 'HAD-superfamily hydrolase, subfamily IA, variant 3 containing protein', 145, NULL, NULL, 17295);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(17296, '1.20.90.10-FF-000002', NULL, 'Phospholipase A2 group III', 126, NULL, NULL, 17296),
(17297, '3.90.70.10-FF-000408', NULL, 'Mexicain', 212, NULL, NULL, 17297),
(17298, '1.20.5.500-FF-000005', NULL, 'Keratin 23', 66, NULL, NULL, 17298),
(17299, '3.30.1510.10-FF-000018', NULL, 'Uncharacterized protein', 84, NULL, NULL, 17299),
(17300, '2.60.120.260-FF-000355', NULL, 'proprotein convertase subtilisin/kexin type 7-like', 148, NULL, NULL, 17300),
(17301, '1.10.246.120-FF-000007', NULL, 'Uncharacterized protein', 103, NULL, NULL, 17301),
(17302, '3.30.160.60-FF-005929', NULL, NULL, 36, NULL, NULL, 17302),
(17303, '2.40.30.30-FF-000012', NULL, 'Riboflavin biosynthesis protein', 118, NULL, NULL, 17303),
(17304, '3.30.420.340-FF-000003', NULL, 'UvrABC system protein C', 169, NULL, NULL, 17304),
(17305, '1.20.58.1880-FF-000012', NULL, 'Uncharacterized protein', 82, NULL, NULL, 17305),
(17306, '3.40.630.10-FF-000290', NULL, 'Aspartyl aminopeptidase', 96, NULL, NULL, 17306),
(17307, '2.40.20.10-FF-000028', NULL, 'Uncharacterized protein', 82, NULL, NULL, 17307),
(17308, '2.40.30.130-FF-000045', NULL, 'Alanyl-tRNA synthetase family protein', 71, NULL, NULL, 17308),
(17309, '3.40.30.10-FF-001095', NULL, 'Uncharacterized protein', 80, NULL, NULL, 17309),
(17310, '1.25.10.10-FF-002465', NULL, 'Uncharacterized protein', 218, NULL, NULL, 17310),
(17311, '1.10.630.10-FF-000079', NULL, 'Cytochrome P450 71A26', 487, NULL, NULL, 17311),
(17312, '3.40.30.10-FF-001151', NULL, 'Uncharacterized protein', 38, NULL, NULL, 17312),
(17313, '3.30.2160.10-FF-000007', NULL, 'E3 ubiquitin-protein ligase HUWE1 isoform X2', 80, NULL, NULL, 17313),
(17314, '3.40.50.880-FF-000124', NULL, 'CTP synthase', 242, NULL, NULL, 17314),
(17315, '1.10.510.10-FF-001065', NULL, 'Serine/threonine-protein kinase spk-1', 85, NULL, NULL, 17315),
(17316, '3.40.50.11720-FF-000007', NULL, '3-deoxy-D-manno-octulosonic acid transferase', 164, NULL, NULL, 17316),
(17317, '3.10.450.50-FF-000018', NULL, 'mRNA transport regulator', 172, NULL, NULL, 17317),
(17318, '1.20.1070.10-FF-001977', NULL, 'Uncharacterized protein', 175, NULL, NULL, 17318),
(17319, '1.10.10.60-FF-000074', NULL, 'Distal-less homeobox 1', 67, NULL, NULL, 17319),
(17320, '1.10.510.10-FF-001121', NULL, 'Kinase family protein', 188, NULL, NULL, 17320),
(17321, '3.60.20.10-FF-000115', NULL, 'Probable asparagine synthase', 200, NULL, NULL, 17321),
(17322, '1.20.58.60-FF-000228', NULL, 'Uncharacterized protein, isoform F', 135, NULL, NULL, 17322),
(17323, '3.40.50.2300-FF-001387', NULL, NULL, 85, NULL, NULL, 17323),
(17324, '2.30.29.220-FF-000005', NULL, 'FACT complex subunit SSRP1', 87, NULL, NULL, 17324),
(17325, '3.90.70.10-FF-000847', NULL, 'Uncharacterized protein', 115, NULL, NULL, 17325),
(17326, '2.60.40.10-FF-003210', NULL, 'Cytochrome c oxidase accessory protein CcoG', 119, NULL, NULL, 17326),
(17327, '3.20.20.20-FF-000041', NULL, 'Methionine synthase', 61, NULL, NULL, 17327),
(17328, '2.40.50.140-FF-000322', NULL, '30S ribosomal protein S1', 85, NULL, NULL, 17328),
(17329, '1.10.357.150-FF-000002', NULL, 'Centromere/kinetochore protein zw10-like protein', 209, NULL, NULL, 17329),
(17330, '1.25.40.20-FF-001458', NULL, 'Uncharacterized protein', 124, NULL, NULL, 17330),
(17331, '3.90.550.10-FF-000704', NULL, 'Probable UDP-N-acetylglucosamine pyrophosphorylase', 471, NULL, NULL, 17331),
(17332, '3.50.50.60-FF-001447', NULL, 'Glycerol-3-phosphate dehydrogenase, putative', 91, NULL, NULL, 17332),
(17333, '2.20.70.10-FF-000077', NULL, 'E3 ubiquitin-protein ligase', 46, NULL, NULL, 17333),
(17334, '1.10.8.720-FF-000068', NULL, 'Dynein heavy chain family protein', 160, NULL, NULL, 17334),
(17335, '1.10.510.10-FF-004347', NULL, NULL, 122, NULL, NULL, 17335),
(17336, '3.40.50.300-FF-006751', NULL, 'Uncharacterized protein', 66, NULL, NULL, 17336),
(17337, '3.30.200.20-FF-000116', NULL, 'Non-specific serine/threonine protein kinase', 96, NULL, NULL, 17337),
(17338, '3.40.50.2300-FF-000875', NULL, NULL, 26, NULL, NULL, 17338),
(17339, '2.10.69.10-FF-000001', NULL, 'Bowman-Birk type proteinase inhibitor', 68, NULL, NULL, 17339);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(17340, '1.20.120.1530-FF-000005', NULL, 'Methyl-accepting chemotaxis protein', 145, NULL, NULL, 17340),
(17341, '3.30.160.60-FF-001714', NULL, 'Zinc finger protein 774', 27, NULL, NULL, 17341),
(17342, '3.80.10.10-FF-001592', NULL, 'Leucine-rich repeat receptor-like protein kinase PEPR2', 65, NULL, NULL, 17342),
(17343, '3.40.50.720-FF-001470', NULL, 'Uncharacterized protein', 205, NULL, NULL, 17343),
(17344, '3.40.50.1100-FF-000296', NULL, 'Protein CBG27484', 60, NULL, NULL, 17344),
(17345, '2.30.31.40-FF-000001', NULL, 'Mitochondrial RNA binding protein 1', 154, NULL, NULL, 17345),
(17346, '2.40.180.10-FF-000016', NULL, 'Catalase', 467, NULL, NULL, 17346),
(17347, '2.60.40.10-FF-004935', NULL, NULL, 88, NULL, NULL, 17347),
(17348, '2.170.270.10-FF-000206', NULL, 'Histone-lysine N-methyltransferase', 162, NULL, NULL, 17348),
(17349, '3.90.79.10-FF-000052', NULL, 'Adenine DNA glycosylase', 127, NULL, NULL, 17349),
(17350, '3.30.70.330-FF-000836', NULL, 'Nab6p', 134, NULL, NULL, 17350),
(17351, '2.30.39.10-FF-000010', NULL, 'Serpin family F member 2', 145, NULL, NULL, 17351),
(17352, '3.60.21.10-FF-000263', NULL, 'Metallo-phosphoesterase', 187, NULL, NULL, 17352),
(17353, '1.20.120.980-FF-000013', NULL, 'Clan SC, family S28, unassigned serine peptidase', 134, NULL, NULL, 17353),
(17354, '3.40.50.300-FF-004773', NULL, 'DExH-box ATP-dependent RNA helicase DExH18 mitochondrial', 57, NULL, NULL, 17354),
(17355, '3.40.50.2000-FF-000903', NULL, 'Uncharacterized protein', 167, NULL, NULL, 17355),
(17356, '2.40.50.140-FF-000850', NULL, NULL, 77, NULL, NULL, 17356),
(17357, '1.20.140.150-FF-000038', NULL, 'Voltage-dependent calcium channel gamma-6 subunit', 224, NULL, NULL, 17357),
(17358, '3.30.40.10-FF-001910', NULL, 'Uncharacterized protein', 72, NULL, NULL, 17358),
(17359, '1.10.510.10-FF-000076', NULL, 'Mitogen-activated protein kinase kinase kinase', 232, NULL, NULL, 17359),
(17360, '3.40.50.10090-FF-000075', NULL, 'Chromosome 12, whole genome shotgun sequence', 181, NULL, NULL, 17360),
(17361, '3.30.70.3040-FF-000009', NULL, 'Cell division protein FtsX', 111, NULL, NULL, 17361),
(17362, '2.60.40.60-FF-000358', NULL, 'Si:dkey-30k22.7', 105, NULL, NULL, 17362),
(17363, '3.30.70.330-FF-000460', NULL, 'Polyadenylate-binding protein RBP47B', 115, NULL, NULL, 17363),
(17364, '3.30.750.24-FF-000038', NULL, 'Anti-sigma factor antagonist', 109, NULL, NULL, 17364),
(17365, '2.30.30.40-FF-000358', NULL, 'Putative N-acetylmuramoyl-L-alanine amidase', 62, NULL, NULL, 17365),
(17366, '3.40.850.10-FF-000126', NULL, 'Kinesin-like protein', 252, NULL, NULL, 17366),
(17367, '3.40.309.10-FF-000003', NULL, 'Aldehyde dehydrogenase', 197, NULL, NULL, 17367),
(17368, '1.25.10.10-FF-001004', NULL, 'Integrator complex subunit 7', 216, NULL, NULL, 17368),
(17369, '1.10.20.10-FF-000138', NULL, 'TAF (TBP-associated transcription factor) family', 43, NULL, NULL, 17369),
(17370, '1.10.220.150-FF-000065', NULL, 'Uncharacterized protein', 100, NULL, NULL, 17370),
(17371, '2.40.170.20-FF-000047', NULL, 'TonB-dependent siderophore receptor', 550, NULL, NULL, 17371),
(17372, '3.30.710.10-FF-000141', NULL, 'Radish, isoform N', 111, NULL, NULL, 17372),
(17373, '1.25.40.10-FF-002557', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 123, NULL, NULL, 17373),
(17374, '1.10.150.670-FF-000030', NULL, 'Uncharacterized protein', 70, NULL, NULL, 17374),
(17375, '3.30.1490.120-FF-000028', NULL, 'Uncharacterized protein', 48, NULL, NULL, 17375),
(17376, '1.25.40.10-FF-002613', NULL, 'CCR4-NOT transcription complex subunit 10', 169, NULL, NULL, 17376),
(17377, '3.40.390.10-FF-000135', NULL, 'Matrix metallopeptidase 11b', 226, NULL, NULL, 17377),
(17378, '2.130.10.10-FF-000085', NULL, 'WD repeat domain 33', 95, NULL, NULL, 17378),
(17379, '3.40.50.1760-FF-000027', NULL, NULL, 48, NULL, NULL, 17379),
(17380, '3.40.47.10-FF-000262', NULL, NULL, 248, NULL, NULL, 17380),
(17381, '3.30.40.10-FF-000898', NULL, 'Uncharacterized protein, isoform B', 77, NULL, NULL, 17381),
(17382, '1.25.40.20-FF-000525', NULL, 'Kinase, NEK', 110, NULL, NULL, 17382);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(17383, '3.40.50.300-FF-000967', NULL, 'ABC multidrug transporter mdr4', 243, NULL, NULL, 17383),
(17384, '3.30.230.70-FF-000003', NULL, 'Ribonuclease PH', 229, NULL, NULL, 17384),
(17385, '3.80.10.10-FF-003446', NULL, 'Predicted protein', 52, NULL, NULL, 17385),
(17386, '3.30.160.60-FF-001658', NULL, 'Zinc finger protein 16', 29, NULL, NULL, 17386),
(17387, '3.10.20.90-FF-000742', NULL, 'Neutrophil cytosol factor 4', 106, NULL, NULL, 17387),
(17388, '1.10.287.80-FF-000020', NULL, 'ATP synthase gamma chain', 103, NULL, NULL, 17388),
(17389, '3.50.7.10-FF-000081', NULL, NULL, 34, NULL, NULL, 17389),
(17390, '2.60.40.10-FF-003682', NULL, NULL, 129, NULL, NULL, 17390),
(17391, '3.40.50.450-FF-000080', NULL, '6-phosphofructokinase', 222, NULL, NULL, 17391),
(17392, '1.20.1110.10-FF-000109', NULL, NULL, 165, NULL, NULL, 17392),
(17393, '1.50.40.10-FF-000604', NULL, 'Uncharacterized protein', 288, NULL, NULL, 17393),
(17394, '2.130.10.30-FF-000147', NULL, NULL, 207, NULL, NULL, 17394),
(17395, '3.30.420.80-FF-000015', NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', 135, NULL, NULL, 17395),
(17396, '3.40.50.2300-FF-000931', NULL, NULL, 200, NULL, NULL, 17396),
(17397, '3.40.190.10-FF-000154', NULL, 'LysR family transcriptional regulator', 94, NULL, NULL, 17397),
(17398, '2.130.10.10-FF-002030', NULL, 'Uncharacterized protein', 378, NULL, NULL, 17398),
(17399, '3.10.50.10-FF-000001', NULL, 'Chitinase 3-like 1', 71, NULL, NULL, 17399),
(17400, '2.60.260.20-FF-000095', NULL, 'Radial spoke protein 16', 80, NULL, NULL, 17400),
(17401, '2.60.40.60-FF-000835', NULL, 'Protocadherin beta 2', 31, NULL, NULL, 17401),
(17402, '1.25.70.10-FF-000024', NULL, 'Transcription termination factor, mitochondrial', 220, NULL, NULL, 17402),
(17403, '1.10.287.1060-FF-000006', NULL, 'ESAT-6-like protein', 98, NULL, NULL, 17403),
(17404, '3.30.420.10-FF-000747', NULL, NULL, 99, NULL, NULL, 17404),
(17405, '2.60.120.10-FF-000609', NULL, 'Mannose-6-phosphate isomerase, class I family protein', 165, NULL, NULL, 17405),
(17406, '2.60.40.790-FF-000061', NULL, 'Low molecular weight heat shock protein', 139, NULL, NULL, 17406),
(17407, '1.10.510.10-FF-003482', NULL, NULL, 266, NULL, NULL, 17407),
(17408, '3.40.50.300-FF-002912', NULL, 'Rab family GTPase', 185, NULL, NULL, 17408),
(17409, '1.20.1530.20-FF-000110', NULL, 'Na(+)/H(+) antiporter 1', 402, NULL, NULL, 17409),
(17410, '2.10.25.10-FF-001636', NULL, 'Delta-like protein', 77, NULL, NULL, 17410),
(17411, '1.25.10.10-FF-002729', NULL, 'Transportin', 896, NULL, NULL, 17411),
(17412, '3.20.20.80-FF-000800', NULL, 'Protein CBG10890', 150, NULL, NULL, 17412),
(17413, '3.30.565.10-FF-000095', NULL, 'PAS domain-containing sensor histidine kinase', 153, NULL, NULL, 17413),
(17414, '1.10.10.60-FF-001030', NULL, NULL, 56, NULL, NULL, 17414),
(17415, '1.25.10.10-FF-000048', NULL, '26S proteasome non-ATPase regulatory subunit 1 homolog', 443, NULL, NULL, 17415),
(17416, '3.40.50.150-FF-000905', NULL, NULL, 91, NULL, NULL, 17416),
(17417, '1.20.1070.10-FF-001185', NULL, 'Uncharacterized protein', 302, NULL, NULL, 17417),
(17418, '2.60.40.10-FF-000753', NULL, 'Paired immunoglobulin-like type 2 receptor alpha', 119, NULL, NULL, 17418),
(17419, '2.60.470.10-FF-000017', NULL, 'pickpocket protein 28', 170, NULL, NULL, 17419),
(17420, '3.40.50.300-FF-002856', NULL, 'Dynein heavy chain 11', 163, NULL, NULL, 17420),
(17421, '3.40.50.10810-FF-000010', NULL, 'DNA repair and recombination protein RAD54-like', 275, NULL, NULL, 17421),
(17422, '3.90.1150.10-FF-000353', NULL, 'Beta-eliminating lyase family protein', 122, NULL, NULL, 17422),
(17423, '1.10.10.60-FF-000866', NULL, 'Dharma', 79, NULL, NULL, 17423),
(17424, '3.40.1380.10-FF-000038', NULL, 'Uncharacterized protein', 128, NULL, NULL, 17424),
(17425, '3.40.50.300-FF-007999', NULL, 'Methylenetetrahydrofolate dehydrogenase (NADP+-dependent) 1a, methenyltetrahydrofolate cyclohydrolase, formyltetrahydrofolate synthetase', 151, NULL, NULL, 17425),
(17426, '2.40.50.100-FF-000097', NULL, 'Exosome complex component RRP40', 69, NULL, NULL, 17426);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(17427, '3.10.110.10-FF-000330', NULL, 'Uncharacterized protein', 155, NULL, NULL, 17427),
(17428, '1.10.287.70-FF-000427', NULL, 'Cyclic nucleotide-binding protein', 92, NULL, NULL, 17428),
(17429, '2.40.50.1000-FF-000014', NULL, '40S ribosomal protein S11-like Protein', 151, NULL, NULL, 17429),
(17430, '1.10.150.170-FF-000003', NULL, 'Ribosomal RNA small subunit methyltransferase H', 103, NULL, NULL, 17430),
(17431, '3.90.190.20-FF-000022', NULL, 'Putative dihydrofolate synthetase', 128, NULL, NULL, 17431),
(17432, '1.20.120.1770-FF-000021', NULL, 'Uncharacterized protein', 94, NULL, NULL, 17432),
(17433, '1.10.150.190-FF-000009', NULL, 'Eukaryotic translation initiation factor 2 subunit alpha, putative', 88, NULL, NULL, 17433),
(17434, '2.40.10.10-FF-000258', NULL, 'Anionic trypsin isoform 1', 103, NULL, NULL, 17434),
(17435, '3.30.1330.30-FF-000139', NULL, 'Uncharacterized protein', 66, NULL, NULL, 17435),
(17436, '3.80.10.10-FF-002581', NULL, 'Uncharacterized protein', 108, NULL, NULL, 17436),
(17437, '3.30.420.40-FF-000762', NULL, 'Actin-related protein 10', 29, NULL, NULL, 17437),
(17438, '3.30.1370.10-FF-000023', NULL, 'Heterogeneous nuclear ribonucleoprotein K, like', 76, NULL, NULL, 17438),
(17439, '1.10.510.10-FF-003010', NULL, NULL, 209, NULL, NULL, 17439),
(17440, '4.10.410.50-FF-000001', NULL, 'Small archaeal modifier protein 2', 66, NULL, NULL, 17440),
(17441, '1.25.40.20-FF-000997', NULL, 'Uncharacterized protein', 234, NULL, NULL, 17441),
(17442, '1.20.5.110-FF-000074', NULL, 't-SNARE domain-containing protein 1 isoform X4', 59, NULL, NULL, 17442),
(17443, '1.20.1250.20-FF-001876', NULL, 'Uncharacterized protein', 105, NULL, NULL, 17443),
(17444, '2.60.40.10-FF-004019', NULL, NULL, 98, NULL, NULL, 17444),
(17445, '3.40.50.11660-FF-000023', NULL, 'Uncharacterized protein', 247, NULL, NULL, 17445),
(17446, '1.25.40.10-FF-005047', NULL, 'Uncharacterized protein', 122, NULL, NULL, 17446),
(17447, '3.40.50.300-FF-000175', NULL, 'ATP-dependent zinc metalloprotease FTSH 4', 181, NULL, NULL, 17447),
(17448, '1.20.1250.20-FF-000976', NULL, 'YALI0A00869p', 390, NULL, NULL, 17448),
(17449, '3.40.250.10-FF-000069', NULL, 'Sulfurtransferase', 147, NULL, NULL, 17449),
(17450, '3.30.830.10-FF-000144', NULL, 'Metalloprotease, insulinase family', 279, NULL, NULL, 17450),
(17451, '1.10.490.10-FF-000051', NULL, 'Uncharacterized protein', 98, NULL, NULL, 17451),
(17452, '3.40.50.10420-FF-000039', NULL, '5-formyltetrahydrofolate cyclo-ligase, putative', 175, NULL, NULL, 17452),
(17453, '3.30.2160.10-FF-000070', NULL, 'Uncharacterized protein', 37, NULL, NULL, 17453),
(17454, '2.130.10.10-FF-005312', NULL, 'U3 small nucleolar RNA-associated protein 4', 206, NULL, NULL, 17454),
(17455, '3.30.565.10-FF-000100', NULL, 'Signal transduction histidine-protein kinase AtoS', 154, NULL, NULL, 17455),
(17456, '2.60.120.1560-FF-000008', NULL, 'Predicted protein', 155, NULL, NULL, 17456),
(17457, '1.20.120.80-FF-000008', NULL, 'Cytochrome c oxidase subunit I', 184, NULL, NULL, 17457),
(17458, '2.70.170.10-FF-000099', NULL, 'Gamma-aminobutyric acid type A receptor rho1 subunit', 176, NULL, NULL, 17458),
(17459, '1.10.150.20-FF-000326', NULL, 'Uncharacterized protein', 24, NULL, NULL, 17459),
(17460, '3.90.1150.10-FF-000330', NULL, 'Adenosylmethionine-8-amino-7-oxononanoate aminotransferase', 132, NULL, NULL, 17460),
(17461, '3.30.930.10-FF-000180', NULL, 'Alanyl tRNA synthetase', 233, NULL, NULL, 17461),
(17462, '1.10.8.1220-FF-000020', NULL, 'Dynein heavy chain, putative', 106, NULL, NULL, 17462),
(17463, '2.70.130.10-FF-000153', NULL, NULL, 133, NULL, NULL, 17463),
(17464, '1.20.1250.20-FF-001376', NULL, 'Uncharacterized protein', 195, NULL, NULL, 17464),
(17465, '1.10.720.30-FF-000064', NULL, 'Predicted protein', 46, NULL, NULL, 17465),
(17466, '3.90.550.10-FF-000648', NULL, 'Cellulose synthase-like protein D3', 139, NULL, NULL, 17466),
(17467, '2.130.10.10-FF-002822', NULL, 'Subunit of anaphase promoting complex', 127, NULL, NULL, 17467),
(17468, '3.40.50.300-FF-007263', NULL, 'Predicted protein', 157, NULL, NULL, 17468);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(17469, '3.10.170.20-FF-000016', NULL, NULL, 79, NULL, NULL, 17469),
(17470, '2.60.40.1910-FF-000001', NULL, 'Leucyl-cystinyl aminopeptidase', 86, NULL, NULL, 17470),
(17471, '2.130.10.10-FF-001041', NULL, 'CTF4p Chromatin-associated protein', 186, NULL, NULL, 17471),
(17472, '3.30.160.60-FF-004564', NULL, NULL, 34, NULL, NULL, 17472),
(17473, '3.30.70.330-FF-000308', NULL, 'Serine/arginine-rich splicing factor 2', 91, NULL, NULL, 17473),
(17474, '3.90.70.10-FF-000471', NULL, 'Uncharacterized protein', 274, NULL, NULL, 17474),
(17475, '1.20.1560.10-FF-000901', NULL, 'Uncharacterized protein', 207, NULL, NULL, 17475),
(17476, '3.50.50.60-FF-000935', NULL, 'Thioredoxin reductase 2, mitochondrial', 123, NULL, NULL, 17476),
(17477, '3.40.50.620-FF-000153', NULL, 'Phosphoadenosine phosphosulfate reductase', 225, NULL, NULL, 17477),
(17478, '1.25.10.10-FF-000172', NULL, 'Armadillo repeat-containing protein 6', 223, NULL, NULL, 17478),
(17479, '3.40.50.10190-FF-000279', NULL, 'Uncharacterized protein', 87, NULL, NULL, 17479),
(17480, '1.10.8.20-FF-000005', NULL, 'SEC14 cytosolic factor', 86, NULL, NULL, 17480),
(17481, '3.30.9.10-FF-000096', NULL, 'NAD FAD-dependent dehydrogenase putative', 155, NULL, NULL, 17481),
(17482, '3.90.550.50-FF-000076', NULL, 'Uncharacterized protein', 241, NULL, NULL, 17482),
(17483, '3.40.50.10810-FF-000066', NULL, 'Uncharacterized protein (Fragment)', 258, NULL, NULL, 17483),
(17484, '3.40.50.1110-FF-000029', NULL, 'Unplaced genomic scaffold supercont2.12, whole genome shotgun sequence', 242, NULL, NULL, 17484),
(17485, '3.30.160.60-FF-000669', NULL, 'zinc finger protein 64 isoform X1', 29, NULL, NULL, 17485),
(17486, '1.10.8.60-FF-000354', NULL, 'Pre-initiation complex, subunit CDC6', 109, NULL, NULL, 17486),
(17487, '2.60.120.10-FF-000289', NULL, 'Uncharacterized protein', 153, NULL, NULL, 17487),
(17488, '3.10.50.40-FF-000072', NULL, 'Peptidylprolyl isomerase', 110, NULL, NULL, 17488),
(17489, '2.130.10.10-FF-002878', NULL, 'Predicted protein', 324, NULL, NULL, 17489),
(17490, '3.80.10.10-FF-000956', NULL, 'Nud1p', 181, NULL, NULL, 17490),
(17491, '3.40.50.300-FF-001131', NULL, 'DNA polymerase III subunit delta', 136, NULL, NULL, 17491),
(17492, '2.40.50.140-FF-000794', NULL, NULL, 112, NULL, NULL, 17492),
(17493, '3.30.200.20-FF-002477', NULL, NULL, 42, NULL, NULL, 17493),
(17494, '3.80.10.10-FF-001968', NULL, 'Uncharacterized protein', 97, NULL, NULL, 17494),
(17495, '3.40.50.720-FF-001846', NULL, 'D-3-phosphoglycerate dehydrogenase', 54, NULL, NULL, 17495),
(17496, '3.30.390.60-FF-000006', NULL, 'Heat-inducible transcription repressor HrcA', 102, NULL, NULL, 17496),
(17497, '2.60.120.260-FF-000411', NULL, 'Putative secreted protein', 148, NULL, NULL, 17497),
(17498, '3.30.565.10-FF-000156', NULL, 'Sensor histidine kinase', 143, NULL, NULL, 17498),
(17499, '3.40.50.720-FF-002246', NULL, 'Alanine dehydrogenase 2, putative', 80, NULL, NULL, 17499),
(17500, '3.40.50.800-FF-000027', NULL, 'Histidine--tRNA ligase', 99, NULL, NULL, 17500),
(17501, '2.60.40.10-FF-003154', NULL, 'Titin, tandem duplicate 1', 104, NULL, NULL, 17501),
(17502, '3.40.50.1820-FF-001170', NULL, 'Uncharacterized protein', 140, NULL, NULL, 17502),
(17503, '3.30.420.80-FF-000038', NULL, 'Uncharacterized protein', 69, NULL, NULL, 17503),
(17504, '1.10.579.10-FF-000009', NULL, 'Cryptochrome DASH', 205, NULL, NULL, 17504),
(17505, '2.60.200.20-FF-000147', NULL, 'Fork-head transcriptional regulator 2', 141, NULL, NULL, 17505),
(17506, '2.30.33.40-FF-000016', NULL, '10 kDa chaperonin', 90, NULL, NULL, 17506),
(17507, '3.30.70.1450-FF-000027', NULL, 'Sodium/sulfate symporter', 71, NULL, NULL, 17507),
(17508, '1.10.730.10-FF-000120', NULL, 'Leucine--tRNA ligase, cytoplasmic', 114, NULL, NULL, 17508),
(17509, '1.10.510.10-FF-003858', NULL, NULL, 100, NULL, NULL, 17509),
(17510, '2.60.40.1170-FF-000060', NULL, 'Coatomer subunit delta', 95, NULL, NULL, 17510),
(17511, '2.20.150.10-FF-000002', NULL, 'Sugar kinase, pfkB family', 53, NULL, NULL, 17511),
(17512, '3.60.60.10-FF-000005', NULL, 'Dipeptidase', 331, NULL, NULL, 17512);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(17513, '2.10.25.10-FF-000350', NULL, 'Eater', 33, NULL, NULL, 17513),
(17514, '3.40.109.10-FF-000022', NULL, 'Probable nitroreductase', 196, NULL, NULL, 17514),
(17515, '3.40.30.10-FF-000223', NULL, 'protein disulfide-isomerase isoform X2', 121, NULL, NULL, 17515),
(17516, '4.10.1030.10-FF-000002', NULL, 'cullin homolog 1', 73, NULL, NULL, 17516),
(17517, '1.10.287.370-FF-000023', NULL, 'Pfd1p', 109, NULL, NULL, 17517),
(17518, '1.20.1740.10-FF-000022', NULL, 'Bumetanide-sensitive na-k-cl cotransport protein', 476, NULL, NULL, 17518),
(17519, '1.25.10.10-FF-002881', NULL, 'Importin subunit beta-1', 147, NULL, NULL, 17519),
(17520, '1.10.630.10-FF-000495', NULL, 'Uncharacterized protein', 461, NULL, NULL, 17520),
(17521, '2.10.70.10-FF-000162', NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain containing 1', 63, NULL, NULL, 17521),
(17522, '1.20.1250.20-FF-000443', NULL, 'Solute carrier organic anion transporter family member', 330, NULL, NULL, 17522),
(17523, '3.90.228.10-FF-000040', NULL, 'Poly [ADP-ribose] polymerase', 205, NULL, NULL, 17523),
(17524, '1.20.1280.50-FF-000228', NULL, 'F-box protein PP2-B7', 146, NULL, NULL, 17524),
(17525, '1.25.10.10-FF-003393', NULL, 'Uncharacterized protein', 135, NULL, NULL, 17525),
(17526, '3.90.470.20-FF-000004', NULL, 'Holo-(Acyl carrier protein) synthase 2', 58, NULL, NULL, 17526),
(17527, '2.60.120.200-FF-000028', NULL, 'Blast:Protein ERGIC-53', 234, NULL, NULL, 17527),
(17528, '2.30.42.10-FF-000450', NULL, NULL, 107, NULL, NULL, 17528),
(17529, '3.30.40.10-FF-001062', NULL, 'PHD-finger family protein', 66, NULL, NULL, 17529),
(17530, '3.30.160.60-FF-006329', NULL, NULL, 96, NULL, NULL, 17530),
(17531, '1.20.1050.10-FF-000166', NULL, 'chloride intracellular channel protein 5-like isoform X1', 146, NULL, NULL, 17531),
(17532, '3.30.160.60-FF-002294', NULL, 'zinc finger protein 197 isoform X1', 29, NULL, NULL, 17532),
(17533, '2.170.160.10-FF-000001', NULL, 'Cellulose 1,4-beta-cellobiosidase', 137, NULL, NULL, 17533),
(17534, '2.130.10.10-FF-002406', NULL, 'WD domain, G-beta repeat, putative', 148, NULL, NULL, 17534),
(17535, '3.40.50.300-FF-002592', NULL, 'SNF2 family helicase Ino80', 194, NULL, NULL, 17535),
(17536, '3.10.430.100-FF-000011', NULL, '50S ribosomal protein L9', 89, NULL, NULL, 17536),
(17537, '3.30.200.20-FF-000532', NULL, 'Receptor like protein kinase S.2', 104, NULL, NULL, 17537),
(17538, '3.40.50.970-FF-000151', NULL, '2-oxoisovalerate dehydrogenase subunit alpha', 117, NULL, NULL, 17538),
(17539, '3.40.50.2000-FF-000875', NULL, 'Glycogen [starch] synthase', 302, NULL, NULL, 17539),
(17540, '1.25.10.10-FF-001009', NULL, 'Hypothetical_protein_-_conserved', 215, NULL, NULL, 17540),
(17541, '3.30.230.10-FF-000031', NULL, 'DNA repair protein RadA', 173, NULL, NULL, 17541),
(17542, '3.30.2130.30-FF-000012', NULL, 'RNA methylase, PF01170 family', 173, NULL, NULL, 17542),
(17543, '3.80.10.10-FF-000664', NULL, 'F-box and leucine rich repeat protein 5', 122, NULL, NULL, 17543),
(17544, '3.40.50.1820-FF-000506', NULL, 'Cephalosporin-C deacetylase', 313, NULL, NULL, 17544),
(17545, '1.25.40.10-FF-004035', NULL, 'Os12g0562300 protein', 181, NULL, NULL, 17545),
(17546, '3.30.420.130-FF-000002', NULL, 'Nitrogenase molybdenum-iron protein NifX', 119, NULL, NULL, 17546),
(17547, '1.10.287.520-FF-000001', NULL, 'Noggin', 61, NULL, NULL, 17547),
(17548, '2.60.40.640-FF-000095', NULL, 'Uncharacterized protein', 187, NULL, NULL, 17548),
(17549, '2.40.170.20-FF-000108', NULL, 'TonB-dependent receptor', 637, NULL, NULL, 17549),
(17550, '1.10.533.10-FF-000168', NULL, 'NOD2b protein', 88, NULL, NULL, 17550),
(17551, '3.40.50.300-FF-000911', NULL, 'Nucleolar RNA helicase II', 191, NULL, NULL, 17551),
(17552, '2.130.10.10-FF-001389', NULL, 'UTP13p Nucleolar protein', 149, NULL, NULL, 17552),
(17553, '3.40.1180.10-FF-000001', NULL, '(2E,6E)-farnesyl-diphosphate-specific ditrans,polycis-undecaprenyl-diphosphate synthase', 240, NULL, NULL, 17553),
(17554, '3.60.15.10-FF-000226', NULL, 'Artemis-related DNA-crosslink repair exonuclease', 91, NULL, NULL, 17554);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(17555, '3.30.70.330-FF-001764', NULL, NULL, 139, NULL, NULL, 17555),
(17556, '3.10.100.10-FF-000065', NULL, 'C-type lectin domain family 5 member A', 128, NULL, NULL, 17556),
(17557, '2.60.120.10-FF-000761', NULL, 'Uncharacterized protein', 72, NULL, NULL, 17557),
(17558, '3.30.70.3220-FF-000002', NULL, 'Protein translocase subunit SecD', 105, NULL, NULL, 17558),
(17559, '3.40.190.10-FF-000570', NULL, 'NMDA class glutamate Receptor', 170, NULL, NULL, 17559),
(17560, '3.10.10.10-FF-000055', NULL, NULL, 46, NULL, NULL, 17560),
(17561, '2.130.10.10-FF-001097', NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', 362, NULL, NULL, 17561),
(17562, '1.25.40.10-FF-000376', NULL, 'tetratricopeptide repeat protein 21B isoform X2', 173, NULL, NULL, 17562),
(17563, '3.30.70.330-FF-001472', NULL, 'Uncharacterized protein', 136, NULL, NULL, 17563),
(17564, '3.80.10.10-FF-002957', NULL, 'Putative disease resistance protein At4g11170', 110, NULL, NULL, 17564),
(17565, '1.20.900.10-FF-000098', NULL, 'AT26020p', 128, NULL, NULL, 17565),
(17566, '2.60.40.10-FF-002226', NULL, 'Twitchin', 93, NULL, NULL, 17566),
(17567, '1.20.1280.290-FF-000011', NULL, 'PQ loop repeat protein', 89, NULL, NULL, 17567),
(17568, '1.10.565.10-FF-000163', NULL, 'Uncharacterized protein', 207, NULL, NULL, 17568),
(17569, '1.20.1270.280-FF-000057', NULL, 'Dynein heavy chain, putative', 171, NULL, NULL, 17569),
(17570, '3.30.160.60-FF-002642', NULL, 'Zinc finger protein 517', 34, NULL, NULL, 17570),
(17571, '2.120.10.30-FF-000608', NULL, 'Acylamino acid-releasing enzyme', 115, NULL, NULL, 17571),
(17572, '1.10.287.1770-FF-000011', NULL, 'Ferrous iron transport protein B', 105, NULL, NULL, 17572),
(17573, '1.10.10.440-FF-000055', NULL, 'Pre-mRNA-processing protein 40C', 56, NULL, NULL, 17573),
(17574, '3.30.40.10-FF-000926', NULL, 'TNF receptor-associated factor, putative', 81, NULL, NULL, 17574),
(17575, '1.10.3200.20-FF-000010', NULL, NULL, 193, NULL, NULL, 17575),
(17576, '2.60.40.60-FF-000774', NULL, 'Cadherin', 119, NULL, NULL, 17576),
(17577, '3.30.310.10-FF-000065', NULL, 'AP complex subunit beta', 127, NULL, NULL, 17577),
(17578, '2.60.40.650-FF-000013', NULL, 'Nitrate reductase', 175, NULL, NULL, 17578),
(17579, '3.90.1150.210-FF-000013', NULL, 'F-actin-capping protein subunit beta', 187, NULL, NULL, 17579),
(17580, '3.40.50.300-FF-002120', NULL, 'DNA2/NAM7 helicase', 231, NULL, NULL, 17580),
(17581, '3.20.20.70-FF-000123', NULL, 'Dihydroorotate dehydrogenase (quinone)', 365, NULL, NULL, 17581),
(17582, '1.10.8.160-FF-000001', NULL, 'DNA primase small subunit PriS', 104, NULL, NULL, 17582),
(17583, '1.10.510.10-FF-001060', NULL, 'Probable serine/threonine-protein kinase DDB_G0278535', 206, NULL, NULL, 17583),
(17584, '3.40.50.1460-FF-000027', NULL, 'GM16490', 258, NULL, NULL, 17584),
(17585, '3.40.30.10-FF-000167', NULL, 'Protein disulfide isomerase like, testis expressed', 116, NULL, NULL, 17585),
(17586, '3.30.70.330-FF-001269', NULL, 'RNA Binding Motif protein homolog', 103, NULL, NULL, 17586),
(17587, '2.60.40.1730-FF-000071', NULL, NULL, 236, NULL, NULL, 17587),
(17588, '3.80.10.10-FF-000720', NULL, 'Carboxypeptidase N subunit 2', 197, NULL, NULL, 17588),
(17589, '3.30.830.10-FF-000088', NULL, 'Zinc protease, insulinase family', 205, NULL, NULL, 17589),
(17590, '1.10.287.70-FF-000135', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 144, NULL, NULL, 17590),
(17591, '2.60.40.10-FF-000337', NULL, 'fibronectin type-III domain-containing protein 3A isoform X2', 83, NULL, NULL, 17591),
(17592, '1.10.110.10-FF-000023', NULL, '2S albumin', 106, NULL, NULL, 17592),
(17593, '1.25.40.10-FF-004182', NULL, 'Uncharacterized protein', 85, NULL, NULL, 17593),
(17594, '1.20.1250.20-FF-000920', NULL, 'MFS transporter', 383, NULL, NULL, 17594),
(17595, '3.30.70.330-FF-002725', NULL, NULL, 98, NULL, NULL, 17595),
(17596, '3.40.50.1820-FF-000978', NULL, 'Carboxylic ester hydrolase', 532, NULL, NULL, 17596),
(17597, '1.20.58.530-FF-000025', NULL, 'Myosin-2 heavy chain', 154, NULL, NULL, 17597),
(17598, '1.10.10.10-FF-001857', NULL, 'Uncharacterized protein', 75, NULL, NULL, 17598);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(17599, '3.30.200.20-FF-001993', NULL, 'Predicted protein', 97, NULL, NULL, 17599),
(17600, '1.20.1250.20-FF-001932', NULL, 'Uncharacterized protein', 211, NULL, NULL, 17600),
(17601, '3.30.160.60-FF-002147', NULL, 'Zinc finger, C2H2 type', 27, NULL, NULL, 17601),
(17602, '1.20.1270.60-FF-000259', NULL, 'Uncharacterized protein', 186, NULL, NULL, 17602),
(17603, '2.130.10.10-FF-000113', NULL, 'U4/U6 small nuclear ribonucleoprotein Prp4 isoform X1', 75, NULL, NULL, 17603),
(17604, '1.20.1070.10-FF-000673', NULL, 'Predicted protein', 296, NULL, NULL, 17604),
(17605, '2.60.40.10-FF-001265', NULL, 'Leukemia inhibitory factor receptor', 92, NULL, NULL, 17605),
(17606, '3.30.160.60-FF-003603', NULL, 'zinc finger protein 8', 43, NULL, NULL, 17606),
(17607, '1.20.58.80-FF-000094', NULL, 'Sorting nexin 15', 52, NULL, NULL, 17607),
(17608, '3.30.70.270-FF-000301', NULL, NULL, 55, NULL, NULL, 17608),
(17609, '3.40.50.1820-FF-000950', NULL, 'Alpha/Beta hydrolase protein', 298, NULL, NULL, 17609),
(17610, '1.20.5.190-FF-000108', NULL, NULL, 74, NULL, NULL, 17610),
(17611, '3.20.20.80-FF-000744', NULL, 'Si:dkey-224e22.2', 76, NULL, NULL, 17611),
(17612, '3.40.120.10-FF-000060', NULL, 'Uncharacterized protein', 129, NULL, NULL, 17612),
(17613, '2.40.340.10-FF-000018', NULL, NULL, 59, NULL, NULL, 17613),
(17614, '1.10.10.10-FF-001296', NULL, 'UPF0122 protein A6J86_005860', 110, NULL, NULL, 17614),
(17615, '2.60.120.200-FF-000180', NULL, 'Galectin', 161, NULL, NULL, 17615),
(17616, '1.50.40.10-FF-000548', NULL, 'Predicted protein', 134, NULL, NULL, 17616),
(17617, '2.60.40.10-FF-005896', NULL, NULL, 75, NULL, NULL, 17617),
(17618, '1.10.10.10-FF-000368', NULL, 'vacuolar protein sorting-associated protein 36-like', 72, NULL, NULL, 17618),
(17619, '3.30.160.60-FF-006481', NULL, NULL, 34, NULL, NULL, 17619),
(17620, '1.20.1070.10-FF-000965', NULL, 'Gll0198 protein', 273, NULL, NULL, 17620),
(17621, '1.10.472.10-FF-000059', NULL, 'RB transcriptional corepressor like 1', 187, NULL, NULL, 17621),
(17622, '2.60.40.1180-FF-000153', NULL, 'Alpha-L-fucosidase 2', 88, NULL, NULL, 17622),
(17623, '4.10.400.10-FF-000011', NULL, 'Low-density lipoprotein receptor-related protein 1', 40, NULL, NULL, 17623),
(17624, '1.10.730.10-FF-000148', NULL, 'Putative leucine--tRNA ligase, mitochondrial-like Protein', 22, NULL, NULL, 17624),
(17625, '2.60.410.10-FF-000008', NULL, 'D-alanyl-D-alanine carboxypeptidase', 91, NULL, NULL, 17625),
(17626, '3.30.200.20-FF-000908', NULL, 'CBN-DDR-2 protein', 108, NULL, NULL, 17626),
(17627, '1.25.40.20-FF-001453', NULL, 'Espin-like a', 128, NULL, NULL, 17627),
(17628, '3.30.230.10-FF-000407', NULL, 'Uncharacterized protein', 68, NULL, NULL, 17628),
(17629, '3.40.30.10-FF-000959', NULL, 'Glutathione peroxidase', 101, NULL, NULL, 17629),
(17630, '1.25.40.10-FF-002293', NULL, 'Uncharacterized protein', 151, NULL, NULL, 17630),
(17631, '3.40.50.620-FF-000417', NULL, 'Predicted protein', 236, NULL, NULL, 17631),
(17632, '3.30.40.10-FF-000893', NULL, 'RBR-type E3 ubiquitin transferase', 88, NULL, NULL, 17632),
(17633, '3.40.50.12780-FF-000056', NULL, 'Nonribosomal siderophore peptide synthase SidC', 415, NULL, NULL, 17633),
(17634, '3.30.160.60-FF-000725', NULL, 'zinc finger protein 205 isoform X1', 31, NULL, NULL, 17634),
(17635, '1.10.8.60-FF-000410', NULL, 'ATPase family, AAA domain-containing 2B', 165, NULL, NULL, 17635),
(17636, '3.30.60.30-FF-000175', NULL, 'Agrin', 62, NULL, NULL, 17636),
(17637, '3.30.1460.50-FF-000014', NULL, 'Uncharacterized protein', 161, NULL, NULL, 17637),
(17638, '3.40.50.300-FF-002709', NULL, 'Probable iron inhibited ABC transporter 2', 287, NULL, NULL, 17638),
(17639, '1.20.1250.10-FF-000114', NULL, NULL, 162, NULL, NULL, 17639),
(17640, '2.10.110.10-FF-000081', NULL, 'Uncharacterized protein, isoform A', 62, NULL, NULL, 17640),
(17641, '1.25.40.10-FF-004119', NULL, 'Uncharacterized protein', 130, NULL, NULL, 17641),
(17642, '1.10.287.130-FF-000210', NULL, 'Sensor histidine kinase', 86, NULL, NULL, 17642),
(17643, '2.60.40.2080-FF-000001', NULL, 'Discoidin-1 subunit A', 97, NULL, NULL, 17643);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(17644, '2.170.240.10-FF-000002', NULL, 'Collagen type IV alpha 6 chain', 86, NULL, NULL, 17644),
(17645, '3.30.300.350-FF-000002', NULL, 'GTPase Obg', 73, NULL, NULL, 17645),
(17646, '2.60.40.10-FF-005008', NULL, NULL, 134, NULL, NULL, 17646),
(17647, '3.90.740.10-FF-000011', NULL, 'Valine--tRNA ligase', 45, NULL, NULL, 17647),
(17648, '3.30.420.40-FF-000346', NULL, 'Lumenal Hsp70 protein', 104, NULL, NULL, 17648),
(17649, '3.30.70.100-FF-000060', NULL, 'Antibiotic biosynthesis monooxygenase', 97, NULL, NULL, 17649),
(17650, '1.25.40.20-FF-000469', NULL, 'rabankyrin-5 isoform X1', 188, NULL, NULL, 17650),
(17651, '3.40.50.300-FF-006335', NULL, 'Uncharacterized protein', 158, NULL, NULL, 17651),
(17652, '3.10.260.40-FF-000001', NULL, 'BCL-6 corepressor isoform X2', 118, NULL, NULL, 17652),
(17653, '2.140.10.30-FF-000006', NULL, 'Dipeptidyl aminopeptidase', 497, NULL, NULL, 17653),
(17654, '1.10.287.1660-FF-000001', NULL, 'Erythrocyte binding antigen 175', 32, NULL, NULL, 17654),
(17655, '3.40.50.1000-FF-000468', NULL, 'Uncharacterized protein', 201, NULL, NULL, 17655),
(17656, '3.80.10.10-FF-004407', NULL, 'F-box family protein', 85, NULL, NULL, 17656),
(17657, '1.10.8.1220-FF-000025', NULL, NULL, 96, NULL, NULL, 17657),
(17658, '1.25.40.10-FF-004827', NULL, 'Uncharacterized protein', 148, NULL, NULL, 17658),
(17659, '3.30.40.10-FF-001854', NULL, 'Uncharacterized protein', 81, NULL, NULL, 17659),
(17660, '3.30.160.60-FF-004620', NULL, NULL, 40, NULL, NULL, 17660),
(17661, '2.30.30.30-FF-000153', NULL, 'Mitochondrial ribosomal protein L24', 58, NULL, NULL, 17661),
(17662, '4.10.320.10-FF-000010', NULL, 'Acetyltransferase component of pyruvate dehydrogenase complex', 40, NULL, NULL, 17662),
(17663, '2.70.170.10-FF-000155', NULL, 'Nicotinic acetylcyoline receptor Dalpha 4 subunit', 62, NULL, NULL, 17663),
(17664, '1.10.10.10-FF-001329', NULL, 'Ribosomal protein', 52, NULL, NULL, 17664),
(17665, '1.20.5.110-FF-000102', NULL, '60S ribosomal protein L13', 40, NULL, NULL, 17665),
(17666, '3.30.160.60-FF-005020', NULL, NULL, 50, NULL, NULL, 17666),
(17667, '1.25.40.120-FF-000039', NULL, 'Uncharacterized protein', 372, NULL, NULL, 17667),
(17668, '3.80.10.10-FF-003885', NULL, 'Uncharacterized protein', 157, NULL, NULL, 17668),
(17669, '3.30.505.10-FF-000271', NULL, NULL, 84, NULL, NULL, 17669),
(17670, '3.30.460.20-FF-000017', NULL, 'CorA family metal ion transporter (Eurofung)', 153, NULL, NULL, 17670),
(17671, '1.10.150.20-FF-000298', NULL, 'Uncharacterized protein', 103, NULL, NULL, 17671),
(17672, '2.60.120.740-FF-000021', NULL, 'Latrophilin, putative', 110, NULL, NULL, 17672),
(17673, '2.70.70.10-FF-000024', NULL, 'Peptidase, M23 family', 158, NULL, NULL, 17673),
(17674, '3.40.50.300-FF-002064', NULL, 'Multidrug resistance protein 1, 2, 3', 255, NULL, NULL, 17674),
(17675, '3.20.20.100-FF-000029', NULL, 'Aldo-keto reductase', 309, NULL, NULL, 17675),
(17676, '1.25.40.1010-FF-000011', NULL, 'N-alpha-acetyltransferase 16, NatA auxiliary subunit', 222, NULL, NULL, 17676),
(17677, '1.10.287.2720-FF-000004', NULL, 'Unplaced genomic scaffold supercont1.15, whole genome shotgun sequence', 71, NULL, NULL, 17677),
(17678, '1.25.40.120-FF-000011', NULL, 'Prenyltransferase alpha subunit repeat protein', 326, NULL, NULL, 17678),
(17679, '3.40.390.10-FF-000079', NULL, 'Gone early, isoform B', 186, NULL, NULL, 17679),
(17680, '2.40.50.100-FF-000153', NULL, 'Multidrug resistance protein VceA', 64, NULL, NULL, 17680),
(17681, '1.10.10.10-FF-001301', NULL, 'ArsR family transcriptional regulator', 106, NULL, NULL, 17681),
(17682, '3.20.20.70-FF-000090', NULL, 'Nicotinate-nucleotide pyrophosphorylase [carboxylating]', 146, NULL, NULL, 17682),
(17683, '2.10.220.10-FF-000139', NULL, 'Proprotein convertase subtilisin/kexin type 5', 59, NULL, NULL, 17683),
(17684, '4.10.1000.10-FF-000146', NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', 39, NULL, NULL, 17684),
(17685, '3.30.1010.10-FF-000002', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', 150, NULL, NULL, 17685),
(17686, '2.70.160.11-FF-000015', NULL, 'Probable protein arginine N-methyltransferase 3', 199, NULL, NULL, 17686);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(17687, '2.60.40.60-FF-000830', NULL, 'Proto-oncogene tyrosine-protein kinase receptor Ret', 110, NULL, NULL, 17687),
(17688, '3.30.250.20-FF-000012', NULL, 'Uncharacterized protein', 75, NULL, NULL, 17688),
(17689, '2.40.30.10-FF-000349', NULL, '60S ribosomal protein L3', 98, NULL, NULL, 17689),
(17690, '3.90.1180.10-FF-000006', NULL, '50S ribosomal protein L13', 145, NULL, NULL, 17690),
(17691, '3.40.50.2300-FF-000403', NULL, 'Guanylate cyclase', 162, NULL, NULL, 17691),
(17692, '3.30.160.60-FF-002586', NULL, 'Zinc finger protein 787', 32, NULL, NULL, 17692),
(17693, '2.60.40.150-FF-000392', NULL, 'Coiled-coil and C2 domain-containing protein 1A', 146, NULL, NULL, 17693),
(17694, '1.25.40.790-FF-000015', NULL, 'CCR4-NOT core subunit', 274, NULL, NULL, 17694),
(17695, '1.10.510.10-FF-000132', NULL, 'Serine/threonine-protein kinase SRK2A', 189, NULL, NULL, 17695),
(17696, '3.30.230.10-FF-000059', NULL, '30S small subunit ribosomal protein S5', 73, NULL, NULL, 17696),
(17697, '1.10.10.1740-FF-000001', NULL, 'Transmembrane protein 14A', 75, NULL, NULL, 17697),
(17698, '1.10.510.10-FF-002554', NULL, 'Uncharacterized protein', 279, NULL, NULL, 17698),
(17699, '3.30.420.150-FF-000008', NULL, 'Apyrase 1', 260, NULL, NULL, 17699),
(17700, '1.10.510.10-FF-002369', NULL, NULL, 173, NULL, NULL, 17700),
(17701, '1.10.1510.30-FF-000002', NULL, 'Probable tRNA pseudouridine synthase D', 88, NULL, NULL, 17701),
(17702, '3.40.50.2000-FF-001095', NULL, 'Sulfoquinovosyl transferase SQD2', 61, NULL, NULL, 17702),
(17703, '3.80.10.10-FF-004374', NULL, 'Uncharacterized protein', 172, NULL, NULL, 17703),
(17704, '1.10.287.1060-FF-000001', NULL, 'Charged multivesicular body protein 4b', 79, NULL, NULL, 17704),
(17705, '3.90.190.10-FF-000249', NULL, 'Predicted protein', 212, NULL, NULL, 17705),
(17706, '1.25.40.210-FF-000010', NULL, 'Telomeric repeat-binding factor a', 52, NULL, NULL, 17706),
(17707, '3.40.50.1000-FF-000092', NULL, 'copper-transporting ATPase 1 isoform X2', 65, NULL, NULL, 17707),
(17708, '3.90.640.10-FF-000155', NULL, 'Uncharacterized protein', 82, NULL, NULL, 17708),
(17709, '2.20.230.10-FF-000003', NULL, 'Resuscitation-promoting factor RpfB', 88, NULL, NULL, 17709),
(17710, '2.30.29.30-FF-001212', NULL, 'Uncharacterized protein', 90, NULL, NULL, 17710),
(17711, '3.90.226.10-FF-000350', NULL, 'Uncharacterized protein', 129, NULL, NULL, 17711),
(17712, '3.20.20.80-FF-000828', NULL, 'Beta-galactosidase', 51, NULL, NULL, 17712),
(17713, '3.10.660.10-FF-000011', NULL, 'Putative chaperone protein DNAj', 74, NULL, NULL, 17713),
(17714, '1.20.5.470-FF-000013', NULL, 'Argininosuccinate synthase', 30, NULL, NULL, 17714),
(17715, '2.130.10.10-FF-003991', NULL, 'Uncharacterized protein', 230, NULL, NULL, 17715),
(17716, '2.40.420.20-FF-000033', NULL, 'Periplasmic component of efflux system', 63, NULL, NULL, 17716),
(17717, '2.60.40.10-FF-003007', NULL, 'Glycoside hydrolase family 2 protein', 90, NULL, NULL, 17717),
(17718, '1.25.40.990-FF-000075', NULL, 'Uncharacterized protein', 278, NULL, NULL, 17718),
(17719, '3.40.50.720-FF-001285', NULL, 'Uncharacterized protein', 192, NULL, NULL, 17719),
(17720, '1.10.1060.10-FF-000034', NULL, NULL, 91, NULL, NULL, 17720),
(17721, '3.40.50.720-FF-000301', NULL, 'Hydroxysteroid dehydrogenase like 2', 271, NULL, NULL, 17721),
(17722, '3.80.10.10-FF-001940', NULL, 'Leucine-rich repeat protein kinase family protein', 139, NULL, NULL, 17722),
(17723, '1.10.12.10-FF-000030', NULL, 'Putative enoyl-hydratase isomerase protein', 31, NULL, NULL, 17723),
(17724, '3.30.160.360-FF-000005', NULL, 'Putative lysine-specific demethylase JMJ16', 139, NULL, NULL, 17724),
(17725, '1.25.40.10-FF-003782', NULL, 'Uncharacterized protein', 154, NULL, NULL, 17725),
(17726, '3.90.226.10-FF-000294', NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', 174, NULL, NULL, 17726),
(17727, '2.60.120.260-FF-000063', NULL, 'Putative alpha-L-arabinofuranosidase family protein', 154, NULL, NULL, 17727),
(17728, '3.30.1330.60-FF-000007', NULL, 'Flagellar motor protein MotB', 165, NULL, NULL, 17728);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(17729, '3.30.1370.10-FF-000107', NULL, 'Scp160p', 63, NULL, NULL, 17729),
(17730, '3.40.50.11980-FF-000001', NULL, 'ZC3H12A isoform 1', 162, NULL, NULL, 17730),
(17731, '3.40.50.300-FF-008224', NULL, 'Cytoplasmic dynein heavy chain, putative', 65, NULL, NULL, 17731),
(17732, '1.25.10.10-FF-002173', NULL, 'Uncharacterized protein', 484, NULL, NULL, 17732),
(17733, '3.30.160.60-FF-001366', NULL, 'Zinc finger protein 2', 71, NULL, NULL, 17733),
(17734, '3.80.10.10-FF-001884', NULL, 'SUMO-specific peptidase 7a', 111, NULL, NULL, 17734),
(17735, '2.30.29.30-FF-001156', NULL, 'Uncharacterized protein', 108, NULL, NULL, 17735),
(17736, '3.40.630.30-FF-000626', NULL, 'Predicted protein', 183, NULL, NULL, 17736),
(17737, '3.40.33.10-FF-000168', NULL, 'Predicted protein', 103, NULL, NULL, 17737),
(17738, '3.40.50.1000-FF-000440', NULL, 'Phospholipid-transporting ATPase', 159, NULL, NULL, 17738),
(17739, '3.75.10.10-FF-000002', NULL, 'Arginine deiminase', 312, NULL, NULL, 17739),
(17740, '1.10.287.10-FF-000016', NULL, 'RNA polymerase II CTD phosphatase Fcp1', 15, NULL, NULL, 17740),
(17741, '1.10.1420.10-FF-000017', NULL, 'DNA mismatch repair protein Msh2', 170, NULL, NULL, 17741),
(17742, '2.40.50.140-FF-000030', NULL, '26S protease regulatory subunit 4', 68, NULL, NULL, 17742),
(17743, '2.60.120.260-FF-000591', NULL, 'Uncharacterized protein', 156, NULL, NULL, 17743),
(17744, '3.30.930.10-FF-000213', NULL, 'Probable threonine--tRNA ligase, cytoplasmic', 166, NULL, NULL, 17744),
(17745, '3.40.50.1000-FF-000384', NULL, 'Trehalose 6-phosphate phosphatase', 121, NULL, NULL, 17745),
(17746, '3.30.200.20-FF-001549', NULL, NULL, 121, NULL, NULL, 17746),
(17747, '1.10.10.10-FF-000992', NULL, 'RNA polymerase sigma factor', 85, NULL, NULL, 17747),
(17748, '1.20.120.1490-FF-000004', NULL, 'LTXXQ domain protein', 56, NULL, NULL, 17748),
(17749, '1.25.40.10-FF-000612', NULL, 'Protein prenylyltransferase superfamily protein', 189, NULL, NULL, 17749),
(17750, '3.30.160.60-FF-001422', NULL, 'replication initiator 1 isoform X1', 64, NULL, NULL, 17750),
(17751, '3.30.360.50-FF-000001', NULL, 'S-adenosylmethionine decarboxylase proenzyme', 69, NULL, NULL, 17751),
(17752, '3.30.160.60-FF-005109', NULL, NULL, 35, NULL, NULL, 17752),
(17753, '3.40.50.1100-FF-000116', NULL, 'Threonine dehydratase, putative', 97, NULL, NULL, 17753),
(17754, '3.30.430.20-FF-000072', NULL, 'Uncharacterized protein', 60, NULL, NULL, 17754),
(17755, '2.120.10.90-FF-000019', NULL, 'Type 2 topoisomerase subunit A', 276, NULL, NULL, 17755),
(17756, '3.30.70.980-FF-000042', NULL, 'Translational activator of mitochondrially encoded cytochrome c oxidase I', 81, NULL, NULL, 17756),
(17757, '3.40.630.30-FF-000481', NULL, 'Acetyltransferase, GNAT family protein', 152, NULL, NULL, 17757),
(17758, '2.70.150.10-FF-000244', NULL, 'Cation-transporting ATPase', 98, NULL, NULL, 17758),
(17759, '3.40.190.10-FF-000007', NULL, 'Putative glutamate receptor ionotropic NMDA 2B', 112, NULL, NULL, 17759),
(17760, '3.90.660.10-FF-000010', NULL, 'Amine oxidase [flavin-containing] B', 169, NULL, NULL, 17760),
(17761, '2.160.20.80-FF-000015', NULL, NULL, 82, NULL, NULL, 17761),
(17762, '3.10.20.90-FF-000450', NULL, 'Hypothetical_protein_-_conserved', 89, NULL, NULL, 17762),
(17763, '1.25.40.20-FF-001166', NULL, 'Arginine N-methyltransferase 2', 123, NULL, NULL, 17763),
(17764, '3.40.50.300-FF-006566', NULL, 'Uncharacterized protein', 102, NULL, NULL, 17764),
(17765, '3.30.40.10-FF-000134', NULL, 'Ring finger protein 11', 73, NULL, NULL, 17765),
(17766, '1.25.40.10-FF-001124', NULL, 'Os11g0483950 protein', 208, NULL, NULL, 17766),
(17767, '1.10.3260.10-FF-000038', NULL, 'DNA ligase', 222, NULL, NULL, 17767),
(17768, '3.40.30.10-FF-001004', NULL, 'Uncharacterized protein', 70, NULL, NULL, 17768),
(17769, '3.30.70.580-FF-000006', NULL, 'Pseudouridine synthase', 85, NULL, NULL, 17769),
(17770, '3.30.420.40-FF-000577', NULL, 'Uncharacterized protein', 48, NULL, NULL, 17770),
(17771, '3.50.50.100-FF-000034', NULL, 'Pyridine nucleotide-disulphide oxidoreductase, putative', 227, NULL, NULL, 17771);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(17772, '3.30.710.10-FF-000433', NULL, 'Uncharacterized protein', 73, NULL, NULL, 17772),
(17773, '1.10.510.10-FF-002841', NULL, 'Serine/threonine-protein kinase NEK', 285, NULL, NULL, 17773),
(17774, '3.40.50.1440-FF-000049', NULL, 'Tubulin gamma chain', 407, NULL, NULL, 17774),
(17775, '3.10.20.30-FF-000095', NULL, NULL, 79, NULL, NULL, 17775),
(17776, '3.90.79.10-FF-000136', NULL, 'mRNA-decapping enzyme subunit 2', 50, NULL, NULL, 17776),
(17777, '1.20.142.10-FF-000021', NULL, 'Poly [ADP-ribose] polymerase', 143, NULL, NULL, 17777),
(17778, '1.10.274.30-FF-000015', NULL, 'Mortality factor 4-like protein 1', 43, NULL, NULL, 17778),
(17779, '1.10.472.10-FF-000711', NULL, 'WNK lysine deficient protein kinase 4', 54, NULL, NULL, 17779),
(17780, '1.10.8.270-FF-000034', NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', 111, NULL, NULL, 17780),
(17781, '3.30.450.50-FF-000031', NULL, 'Longin-type vesicle-associated membrane protein, putative', 125, NULL, NULL, 17781),
(17782, '3.30.70.270-FF-000032', NULL, 'Cyclic di-GMP phosphodiesterase Gmr', 173, NULL, NULL, 17782),
(17783, '1.20.1070.10-FF-002146', NULL, 'Uncharacterized protein', 194, NULL, NULL, 17783),
(17784, '3.90.70.80-FF-000087', NULL, 'Uncharacterized protein', 91, NULL, NULL, 17784),
(17785, '3.40.50.300-FF-004481', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', 74, NULL, NULL, 17785),
(17786, '1.25.10.10-FF-003426', NULL, 'Predicted protein', 180, NULL, NULL, 17786),
(17787, '1.10.150.20-FF-000242', NULL, 'Uncharacterized protein', 62, NULL, NULL, 17787),
(17788, '3.40.1770.10-FF-000001', NULL, 'Urocanate hydratase', 333, NULL, NULL, 17788),
(17789, '1.10.132.50-FF-000006', NULL, 'V-type proton ATPase subunit', 115, NULL, NULL, 17789),
(17790, '1.25.40.10-FF-005339', NULL, 'Uncharacterized protein', 70, NULL, NULL, 17790),
(17791, '2.10.25.10-FF-001075', NULL, 'Uncharacterized protein', 37, NULL, NULL, 17791),
(17792, '3.40.50.150-FF-000433', NULL, 'Protein arginine N-methyltransferase 7', 145, NULL, NULL, 17792),
(17793, '2.10.25.10-FF-001131', NULL, 'pro-neuregulin-3, membrane-bound isoform', 40, NULL, NULL, 17793),
(17794, '3.30.450.70-FF-000037', NULL, NULL, 111, NULL, NULL, 17794),
(17795, '1.20.1270.60-FF-000231', NULL, 'Uncharacterized protein', 273, NULL, NULL, 17795),
(17796, '3.30.200.20-FF-001605', NULL, 'Kinase-like domain-containing protein', 103, NULL, NULL, 17796),
(17797, '1.25.40.820-FF-000007', NULL, 'Conserved protein', 164, NULL, NULL, 17797),
(17798, '3.30.70.2280-FF-000006', NULL, 'Nucleolar RNA helicase II, putative', 70, NULL, NULL, 17798),
(17799, '2.30.180.10-FF-000013', NULL, 'Fasciclin-like arabinogalactan protein 4', 148, NULL, NULL, 17799),
(17800, '3.30.497.10-FF-000054', NULL, 'Serpin peptidase inhibitor, clade E (nexin, plasminogen activator inhibitor type 1), member 3', 216, NULL, NULL, 17800),
(17801, '3.10.25.10-FF-000021', NULL, 'Predicted protein', 110, NULL, NULL, 17801),
(17802, '1.25.40.90-FF-000001', NULL, 'phosphatidylinositol-binding clathrin assembly protein-like isoform X1', 146, NULL, NULL, 17802),
(17803, '1.20.1070.10-FF-000257', NULL, 'Histamine H4 receptor', 323, NULL, NULL, 17803),
(17804, '3.30.505.10-FF-000208', NULL, NULL, 117, NULL, NULL, 17804),
(17805, '1.20.1250.20-FF-000212', NULL, 'Solute carrier family 15 member 4', 555, NULL, NULL, 17805),
(17806, '2.130.10.10-FF-003042', NULL, 'YALI0D06435p', 150, NULL, NULL, 17806),
(17807, '3.40.50.2300-FF-001100', NULL, NULL, 26, NULL, NULL, 17807),
(17808, '1.10.840.10-FF-000033', NULL, 'Predicted protein', 295, NULL, NULL, 17808),
(17809, '2.70.150.10-FF-000300', NULL, 'Uncharacterized protein', 87, NULL, NULL, 17809),
(17810, '3.10.180.10-FF-000076', NULL, 'Uncharacterized protein At5g48480', 148, NULL, NULL, 17810),
(17811, '3.40.50.1820-FF-000242', NULL, 'Carboxypeptidase', 327, NULL, NULL, 17811),
(17812, '1.20.1070.10-FF-001038', NULL, 'Adhesion G protein-coupled receptor G7, tandem duplicate 2', 154, NULL, NULL, 17812),
(17813, '1.10.510.10-FF-000368', NULL, 'cold-responsive protein kinase 1', 212, NULL, NULL, 17813);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(17814, '3.30.800.10-FF-000024', NULL, NULL, 156, NULL, NULL, 17814),
(17815, '3.40.50.1240-FF-000017', NULL, 'Histidine acid phosphatase family protein', 429, NULL, NULL, 17815),
(17816, '2.130.10.10-FF-001861', NULL, 'Transducin family protein / WD-40 repeat family protein', 155, NULL, NULL, 17816),
(17817, '3.40.1110.10-FF-000255', NULL, 'Cu-transporting ATPase type-1, putative', 149, NULL, NULL, 17817),
(17818, '1.10.510.10-FF-001149', NULL, 'Alk1p', 50, NULL, NULL, 17818),
(17819, '1.10.418.10-FF-000069', NULL, 'p-loop nucleoside triphosphate hydrolase superfamily protein with CH (Calponin Homology) domain', 134, NULL, NULL, 17819),
(17820, '1.20.5.1500-FF-000005', NULL, 'Nucleosome assembly protein 1', 60, NULL, NULL, 17820),
(17821, '3.30.70.330-FF-000488', NULL, 'Poly(A)-specific ribonuclease PARN', 72, NULL, NULL, 17821),
(17822, '1.10.760.10-FF-000032', NULL, 'L-cysteine S-thiosulfotransferase subunit SoxA', 143, NULL, NULL, 17822),
(17823, '1.10.730.10-FF-000204', NULL, 'Uncharacterized protein', 105, NULL, NULL, 17823),
(17824, '3.90.70.10-FF-000324', NULL, 'Calpain-like cysteine peptidase, putative', 144, NULL, NULL, 17824),
(17825, '2.60.120.200-FF-000472', NULL, 'Plasminogen', 160, NULL, NULL, 17825),
(17826, '3.40.50.300-FF-006190', NULL, 'Translation initiation factor IF-2, mitochondrial', 79, NULL, NULL, 17826),
(17827, '1.50.40.10-FF-000256', NULL, 'GD24129', 190, NULL, NULL, 17827),
(17828, '1.50.40.10-FF-000312', NULL, 'Uncharacterized protein', 115, NULL, NULL, 17828),
(17829, '3.20.20.80-FF-000452', NULL, 'Uncharacterized protein', 111, NULL, NULL, 17829),
(17830, '4.10.400.10-FF-000303', NULL, 'Uncharacterized protein', 44, NULL, NULL, 17830),
(17831, '3.40.50.740-FF-000043', NULL, 'NADH dehydrogenase I, G subunit', 157, NULL, NULL, 17831),
(17832, '3.30.70.1150-FF-000004', NULL, 'Putative nickel-responsive regulator', 94, NULL, NULL, 17832),
(17833, '2.40.160.60-FF-000007', NULL, 'Long-chain fatty acid transport protein', 401, NULL, NULL, 17833),
(17834, '1.10.238.20-FF-000041', NULL, 'Odorant binding protein 20', 112, NULL, NULL, 17834),
(17835, '1.10.10.60-FF-001086', NULL, NULL, 75, NULL, NULL, 17835),
(17836, '3.40.50.970-FF-000179', NULL, 'Probable 2-oxoglutarate dehydrogenase E1 component DHKTD1 homolog, mitochondrial', 366, NULL, NULL, 17836),
(17837, '3.40.50.10470-FF-000065', NULL, 'Uncharacterized protein', 213, NULL, NULL, 17837),
(17838, '1.10.238.10-FF-000504', NULL, 'Protein CBG11013', 71, NULL, NULL, 17838),
(17839, '1.10.30.10-FF-000083', NULL, 'High mobility group B protein 13', 104, NULL, NULL, 17839),
(17840, '4.10.400.10-FF-000247', NULL, 'LDL receptor protein 1, isoform F', 37, NULL, NULL, 17840),
(17841, '2.40.155.10-FF-000003', NULL, 'Green fluorescent protein', 237, NULL, NULL, 17841),
(17842, '2.130.10.10-FF-004823', NULL, 'Uncharacterized protein', 137, NULL, NULL, 17842),
(17843, '2.60.120.260-FF-000439', NULL, 'Uncharacterized protein', 214, NULL, NULL, 17843),
(17844, '3.20.20.140-FF-000249', NULL, 'Formimidoylglutamate deiminase', 344, NULL, NULL, 17844),
(17845, '3.40.50.80-FF-000054', NULL, 'Ferric reduction oxidase 7', 118, NULL, NULL, 17845),
(17846, '3.40.50.10310-FF-000006', NULL, 'Creatinine amidohydrolase', 260, NULL, NULL, 17846),
(17847, '3.30.559.10-FF-000187', NULL, 'HXXXD-type acyl-transferase family protein', 204, NULL, NULL, 17847),
(17848, '3.30.40.10-FF-000421', NULL, 'Cell growth regulator with ring finger domain 1', 67, NULL, NULL, 17848),
(17849, '2.130.10.10-FF-003839', NULL, 'Ectopic P granules protein 6', 295, NULL, NULL, 17849),
(17850, '1.20.1560.10-FF-000396', NULL, 'Uncharacterized protein', 30, NULL, NULL, 17850),
(17851, '1.10.560.10-FF-000051', NULL, 'Thermosome subunit', 238, NULL, NULL, 17851),
(17852, '1.10.287.130-FF-000007', NULL, 'Sensor histidine kinase CpxA', 115, NULL, NULL, 17852),
(17853, '3.30.479.20-FF-000043', NULL, 'Elongation factor Ts, mitochondrial', 96, NULL, NULL, 17853),
(17854, '1.10.510.10-FF-000424', NULL, 'Putative interleukin-1 receptor-associated kinase 1', 236, NULL, NULL, 17854);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(17855, '3.40.1110.10-FF-000199', NULL, 'Phospholipid-transporting ATPase', 129, NULL, NULL, 17855),
(17856, '3.30.40.10-FF-000365', NULL, 'Zinc finger family protein', 74, NULL, NULL, 17856),
(17857, '2.40.50.140-FF-000406', NULL, 'Breast and ovarian cancer susceptibility protein 2 truncated variant', 117, NULL, NULL, 17857),
(17858, '3.30.160.60-FF-003131', NULL, 'Uncharacterized protein', 28, NULL, NULL, 17858),
(17859, '3.30.559.10-FF-000243', NULL, 'Uncharacterized protein', 113, NULL, NULL, 17859),
(17860, '1.10.10.60-FF-000158', NULL, 'MYB transcription factor', 57, NULL, NULL, 17860),
(17861, '1.20.58.100-FF-000014', NULL, NULL, 97, NULL, NULL, 17861),
(17862, '3.30.230.10-FF-000115', NULL, '40S ribosomal protein S16 isoform X1', 86, NULL, NULL, 17862),
(17863, '2.60.40.10-FF-001681', NULL, 'filamin-A isoform X7', 73, NULL, NULL, 17863),
(17864, '3.30.457.60-FF-000010', NULL, 'AGAP006632-PA', 80, NULL, NULL, 17864),
(17865, '1.20.1250.20-FF-000156', NULL, 'monocarboxylate transporter 8 isoform X1', 196, NULL, NULL, 17865),
(17866, '2.40.10.10-FF-000443', NULL, NULL, 109, NULL, NULL, 17866),
(17867, '1.20.80.10-FF-000001', NULL, 'Erythrocyte membrane protein band 4.1', 108, NULL, NULL, 17867),
(17868, '3.40.50.300-FF-001928', NULL, 'V-Ha-ras Harvey rat sarcoma viral oncogene-like protein', 96, NULL, NULL, 17868),
(17869, '3.40.50.970-FF-000235', NULL, 'Oxoglutarate dehydrogenase', 305, NULL, NULL, 17869),
(17870, '2.20.100.10-FF-000106', NULL, 'Spondin-1', 57, NULL, NULL, 17870),
(17871, '3.40.50.2000-FF-000959', NULL, 'Mannosyltransferase B', 102, NULL, NULL, 17871),
(17872, '3.30.70.330-FF-000544', NULL, 'eukaryotic translation initiation factor 4B isoform X5', 70, NULL, NULL, 17872),
(17873, '3.80.20.20-FF-000078', NULL, 'Tyrosine-protein kinase receptor', 136, NULL, NULL, 17873),
(17874, '3.30.200.20-FF-000301', NULL, 'Tyrosine-protein kinase receptor', 95, NULL, NULL, 17874),
(17875, '3.30.160.60-FF-003311', NULL, 'GD19232', 26, NULL, NULL, 17875),
(17876, '2.60.40.10-FF-002193', NULL, 'Polycystin 1, transient receptor potential channel interacting', 82, NULL, NULL, 17876),
(17877, '3.40.50.2300-FF-001572', NULL, NULL, 153, NULL, NULL, 17877),
(17878, '3.90.640.10-FF-000211', NULL, 'Uncharacterized protein', 92, NULL, NULL, 17878),
(17879, '2.60.220.20-FF-000002', NULL, 'Glycoside hydrolase', 138, NULL, NULL, 17879),
(17880, '1.25.40.10-FF-000292', NULL, 'Serine/threonine-protein phosphatase 5', 138, NULL, NULL, 17880),
(17881, '1.25.40.10-FF-004558', NULL, 'Pentatricopeptide repeat-containing protein At5g67570, chloroplastic', 206, NULL, NULL, 17881),
(17882, '2.130.10.10-FF-000169', NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', 352, NULL, NULL, 17882),
(17883, '2.60.120.200-FF-000505', NULL, 'Agrin', 181, NULL, NULL, 17883),
(17884, '2.60.40.10-FF-005424', NULL, NULL, 119, NULL, NULL, 17884),
(17885, '3.90.180.10-FF-000131', NULL, 'Uncharacterized protein', 102, NULL, NULL, 17885),
(17886, '3.80.10.10-FF-000248', NULL, 'Leucine rich repeat containing 39', 157, NULL, NULL, 17886),
(17887, '1.25.10.10-FF-001768', NULL, 'Transportin-3', 926, NULL, NULL, 17887),
(17888, '1.10.510.10-FF-002785', NULL, 'IkB kinase', 308, NULL, NULL, 17888),
(17889, '1.20.5.170-FF-000193', NULL, 'Tropomyosin-1, isoforms 9A/A/B-like Protein', 83, NULL, NULL, 17889),
(17890, '2.130.10.10-FF-005548', NULL, 'zinc finger protein isoform X1', 222, NULL, NULL, 17890),
(17891, '1.25.40.180-FF-000074', NULL, 'Unplaced genomic scaffold supercont1.20, whole genome shotgun sequence', 292, NULL, NULL, 17891),
(17892, '1.10.287.160-FF-000022', NULL, 'Protein kinase N1', 75, NULL, NULL, 17892),
(17893, '3.30.160.60-FF-004912', NULL, NULL, 52, NULL, NULL, 17893),
(17894, '1.20.1250.20-FF-001140', NULL, 'Uncharacterized protein', 361, NULL, NULL, 17894),
(17895, '1.20.58.70-FF-000052', NULL, 'Syntaxin 5 family protein', 231, NULL, NULL, 17895),
(17896, '1.25.10.10-FF-000520', NULL, 'Exportin-7-A', 536, NULL, NULL, 17896),
(17897, '2.70.150.10-FF-000064', NULL, 'Cation-transporting ATPase', 156, NULL, NULL, 17897);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(17898, '3.40.850.10-FF-000362', NULL, 'Heavy chain, Unconventional Myosin', 226, NULL, NULL, 17898),
(17899, '3.40.50.1780-FF-000005', NULL, 'Fe-hydrogenase, putative', 156, NULL, NULL, 17899),
(17900, '3.40.50.1820-FF-000186', NULL, 'Protein phosphatase methylesterase 1', 312, NULL, NULL, 17900),
(17901, '3.30.420.10-FF-000186', NULL, 'Uncharacterized protein', 190, NULL, NULL, 17901),
(17902, '4.10.240.10-FF-000004', NULL, 'Xylanolytic transcriptional activator XlnR', 62, NULL, NULL, 17902),
(17903, '1.20.58.60-FF-000195', NULL, 'Uncharacterized protein, isoform B', 315, NULL, NULL, 17903),
(17904, '3.40.50.1000-FF-000704', NULL, NULL, 106, NULL, NULL, 17904),
(17905, '1.10.238.10-FF-000471', NULL, 'Calcineurin b subunit', 174, NULL, NULL, 17905),
(17906, '2.10.25.160-FF-000011', NULL, 'Cysteine endopeptidase', 69, NULL, NULL, 17906),
(17907, '3.40.50.150-FF-000377', NULL, '50S ribosomal protein L11 methyltransferase', 161, NULL, NULL, 17907),
(17908, '1.10.1670.10-FF-000064', NULL, NULL, 97, NULL, NULL, 17908),
(17909, '2.30.42.10-FF-000394', NULL, NULL, 107, NULL, NULL, 17909),
(17910, '1.20.1070.10-FF-001370', NULL, 'Uncharacterized protein', 333, NULL, NULL, 17910),
(17911, '1.10.405.20-FF-000008', NULL, NULL, 128, NULL, NULL, 17911),
(17912, '3.40.50.300-FF-001895', NULL, 'Putative translation initiation factor IF-2', 187, NULL, NULL, 17912),
(17913, '3.80.10.10-FF-003593', NULL, 'Predicted protein', 276, NULL, NULL, 17913),
(17914, '3.30.40.10-FF-001438', NULL, 'TNF receptor-associated factor 4', 58, NULL, NULL, 17914),
(17915, '1.20.1270.60-FF-000175', NULL, 'SH3 domain signalling protein (AFU_orthologue AFUA_5G07670)', 234, NULL, NULL, 17915),
(17916, '3.90.1140.10-FF-000032', NULL, 'U6 snRNA phosphodiesterase', 201, NULL, NULL, 17916),
(17917, '3.40.50.1010-FF-000241', NULL, NULL, 204, NULL, NULL, 17917),
(17918, '3.30.230.130-FF-000066', NULL, 'Uncharacterized protein', 147, NULL, NULL, 17918),
(17919, '3.40.5.50-FF-000003', NULL, 'DNA replication complex GINS protein PSF2', 83, NULL, NULL, 17919),
(17920, '3.40.50.1980-FF-000149', NULL, 'Iron ABC transporter, periplasmic substrate-binding protein', 156, NULL, NULL, 17920),
(17921, '1.25.40.20-FF-001222', NULL, 'Uncharacterized protein', 139, NULL, NULL, 17921),
(17922, '2.60.40.10-FF-002754', NULL, 'One IG domain', 101, NULL, NULL, 17922),
(17923, '2.30.30.40-FF-000302', NULL, 'Abp1p', 59, NULL, NULL, 17923),
(17924, '3.20.20.70-FF-000595', NULL, NULL, 112, NULL, NULL, 17924),
(17925, '1.10.472.10-FF-000475', NULL, 'Cyclin superfamily protein, putative', 44, NULL, NULL, 17925),
(17926, '1.20.1070.10-FF-001893', NULL, 'Uncharacterized protein', 289, NULL, NULL, 17926),
(17927, '3.90.550.10-FF-000620', NULL, 'Predicted protein', 206, NULL, NULL, 17927),
(17928, '3.40.50.12780-FF-000112', NULL, 'Nonribosomal peptide synthase, putative', 376, NULL, NULL, 17928),
(17929, '1.20.58.60-FF-000700', NULL, 'Uncharacterized protein', 111, NULL, NULL, 17929),
(17930, '1.10.510.10-FF-002077', NULL, 'Protein CBG07288', 344, NULL, NULL, 17930),
(17931, '3.40.390.10-FF-000282', NULL, NULL, 113, NULL, NULL, 17931),
(17932, '3.30.160.60-FF-000641', NULL, 'zinc finger protein 317 isoform X2', 31, NULL, NULL, 17932),
(17933, '3.40.50.300-FF-003553', NULL, 'Predicted protein', 190, NULL, NULL, 17933),
(17934, '1.10.8.10-FF-000148', NULL, 'Auxilin-like clathrin uncoating factor SWA2', 47, NULL, NULL, 17934),
(17935, '2.10.70.80-FF-000014', NULL, 'Sortilin', 59, NULL, NULL, 17935),
(17936, '2.20.25.10-FF-000006', NULL, 'Tenascin C', 29, NULL, NULL, 17936),
(17937, '3.40.50.300-FF-006279', NULL, 'Replication factor C subunit 1', 111, NULL, NULL, 17937),
(17938, '3.30.428.70-FF-000007', NULL, 'Predicted protein', 283, NULL, NULL, 17938),
(17939, '2.10.25.10-FF-000203', NULL, 'oncoprotein-induced transcript 3 protein', 39, NULL, NULL, 17939),
(17940, '3.40.50.1440-FF-000105', NULL, 'Polynucleotide adenylyltransferase family protein', 63, NULL, NULL, 17940),
(17941, '3.40.50.1220-FF-000006', NULL, '2-hydroxyacyl-CoA lyase 1', 160, NULL, NULL, 17941),
(17942, '2.60.40.1220-FF-000002', NULL, 'Internalin A', 82, NULL, NULL, 17942);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(17943, '3.30.70.2820-FF-000011', NULL, NULL, 81, NULL, NULL, 17943),
(17944, '1.20.1090.10-FF-000056', NULL, '3-dehydroquinate synthase', 183, NULL, NULL, 17944),
(17945, '1.10.287.380-FF-000032', NULL, 'Predicted protein', 72, NULL, NULL, 17945),
(17946, '2.60.40.60-FF-000919', NULL, 'Uncharacterized protein', 94, NULL, NULL, 17946),
(17947, '1.10.287.690-FF-000006', NULL, 'DNA polymerase', 59, NULL, NULL, 17947),
(17948, '2.40.160.10-FF-000077', NULL, 'Mitochondrial import receptor subunit TOM40 homolog 1-like Protein', 127, NULL, NULL, 17948),
(17949, '1.20.1250.20-FF-002101', NULL, 'Uncharacterized protein', 241, NULL, NULL, 17949),
(17950, '3.40.50.300-FF-008044', NULL, 'Uncharacterized protein', 131, NULL, NULL, 17950),
(17951, '1.10.287.3990-FF-000003', NULL, '26S proteasome non-ATPase regulatory subunit 4 homolog', 87, NULL, NULL, 17951),
(17952, '3.40.140.10-FF-000151', NULL, 'Uncharacterized protein', 191, NULL, NULL, 17952),
(17953, '3.30.1490.40-FF-000013', NULL, NULL, 65, NULL, NULL, 17953),
(17954, '3.80.10.10-FF-001029', NULL, 'Blast:Chaoptin', 168, NULL, NULL, 17954),
(17955, '2.60.120.10-FF-000233', NULL, 'AraC family transcriptional regulator', 76, NULL, NULL, 17955),
(17956, '3.90.930.40-FF-000001', NULL, 'ribosomal oxygenase 1 isoform X1', 149, NULL, NULL, 17956),
(17957, '3.40.50.300-FF-007768', NULL, 'Predicted protein', 66, NULL, NULL, 17957),
(17958, '1.25.40.20-FF-000238', NULL, 'Unplaced genomic scaffold supercont1.20, whole genome shotgun sequence', 215, NULL, NULL, 17958),
(17959, '3.40.140.10-FF-000095', NULL, 'COP9 signalosome complex subunit 5', 251, NULL, NULL, 17959),
(17960, '3.40.50.300-FF-005638', NULL, 'Uncharacterized protein', 235, NULL, NULL, 17960),
(17961, '1.10.630.10-FF-000023', NULL, 'Cytochrome P450 family protein', 469, NULL, NULL, 17961),
(17962, '3.30.70.890-FF-000015', NULL, 'Diphosphomevalonate decarboxylase', 189, NULL, NULL, 17962),
(17963, '2.60.220.50-FF-000106', NULL, 'Uncharacterized protein', 134, NULL, NULL, 17963),
(17964, '3.40.50.720-FF-000357', NULL, 'Methionine adenosyltransferase 2 subunit beta', 300, NULL, NULL, 17964),
(17965, '3.40.50.2000-FF-000111', NULL, 'Monogalactosyldiacylglycerol synthase 3, chloroplastic', 172, NULL, NULL, 17965),
(17966, '2.130.10.10-FF-002114', NULL, 'Os03g0151700 protein', 198, NULL, NULL, 17966),
(17967, '2.40.50.140-FF-000086', NULL, 'Cold shock domain-containing protein C2', 107, NULL, NULL, 17967),
(17968, '3.40.30.10-FF-000695', NULL, 'Thiol:disulfide interchange protein DsbD', 124, NULL, NULL, 17968),
(17969, '1.10.472.130-FF-000082', NULL, 'Predicted protein', 158, NULL, NULL, 17969),
(17970, '1.20.120.1900-FF-000021', NULL, 'Spindle pole body component', 300, NULL, NULL, 17970),
(17971, '1.20.1640.10-FF-000110', NULL, NULL, 198, NULL, NULL, 17971),
(17972, '2.40.33.10-FF-000007', NULL, 'Pyruvate kinase 2', 111, NULL, NULL, 17972),
(17973, '3.40.50.300-FF-001423', NULL, 'Ras family GTPase', 173, NULL, NULL, 17973),
(17974, '1.10.630.10-FF-000551', NULL, 'Putative cytochrome P450 superfamily protein', 338, NULL, NULL, 17974),
(17975, '3.30.300.30-FF-000161', NULL, 'Uncharacterized protein', 88, NULL, NULL, 17975),
(17976, '3.40.50.720-FF-001993', NULL, 'Short chain alcohol dehydrogenase, putative', 238, NULL, NULL, 17976),
(17977, '2.130.10.10-FF-000877', NULL, 'POC1 centriolar protein homolog A', 104, NULL, NULL, 17977),
(17978, '3.30.1360.120-FF-000045', NULL, 'Glycine cleavage T protein-like', 93, NULL, NULL, 17978),
(17979, '3.40.220.10-FF-000005', NULL, 'cytosol aminopeptidase', 167, NULL, NULL, 17979),
(17980, '3.40.50.150-FF-001209', NULL, NULL, 69, NULL, NULL, 17980),
(17981, '2.30.180.10-FF-000069', NULL, 'AGAP004426-PA', 157, NULL, NULL, 17981),
(17982, '2.170.150.20-FF-000032', NULL, 'Uncharacterized protein', 69, NULL, NULL, 17982),
(17983, '2.60.40.10-FF-002698', NULL, 'High Incidence of Males (Increased X chromosome loss)', 92, NULL, NULL, 17983),
(17984, '3.80.10.10-FF-001176', NULL, 'Uncharacterized protein', 166, NULL, NULL, 17984),
(17985, '3.40.190.10-FF-000715', NULL, 'Sll0064 protein', 96, NULL, NULL, 17985); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(17986, '3.30.70.920-FF-000007', NULL, 'AsnC family transcriptional regulator', 93, NULL, NULL, 17986),
(17987, '2.60.40.10-FF-003715', NULL, NULL, 90, NULL, NULL, 17987),
(17988, '2.30.30.100-FF-000022', NULL, 'U6 snRNA-associated Sm-like protein LSm8', 94, NULL, NULL, 17988),
(17989, '1.25.40.10-FF-001629', NULL, 'Pentatricopeptide repeat domain-containing protein 3, mitochondrial', 79, NULL, NULL, 17989),
(17990, '3.30.160.60-FF-006037', NULL, NULL, 22, NULL, NULL, 17990),
(17991, '2.10.25.10-FF-000147', NULL, 'Disintegrin and metalloproteinase domain-containing protein 11', 40, NULL, NULL, 17991),
(17992, '2.30.29.30-FF-000228', NULL, 'ran-binding protein 3-like isoform X2', 137, NULL, NULL, 17992),
(17993, '3.30.30.30-FF-000078', NULL, 'Heat shock protein 4b', 11, NULL, NULL, 17993),
(17994, '1.20.1070.10-FF-001746', NULL, 'Uncharacterized protein', 82, NULL, NULL, 17994),
(17995, '3.30.70.20-FF-000139', NULL, NULL, 73, NULL, NULL, 17995),
(17996, '1.10.287.770-FF-000019', NULL, 'Blast:Pickpocket protein 28', 61, NULL, NULL, 17996),
(17997, '2.60.40.10-FF-000192', NULL, 'Myomesin 1', 118, NULL, NULL, 17997),
(17998, '3.90.640.60-FF-000001', NULL, 'Chromatin remodeling complex subunit (Arp9), putative', 123, NULL, NULL, 17998),
(17999, '2.60.40.10-FF-000568', NULL, 'Leptin receptor', 91, NULL, NULL, 17999),
(18000, '1.10.510.10-FF-001913', NULL, 'Serine/threonine-protein kinase, putative (AFU_orthologue AFUA_6G02242)', 220, NULL, NULL, 18000),
(18001, '1.10.10.60-FF-000361', NULL, 'ESX homeobox 1', 68, NULL, NULL, 18001),
(18002, '2.30.29.30-FF-000431', NULL, 'Unplaced genomic scaffold supercont1.6, whole genome shotgun sequence', 116, NULL, NULL, 18002),
(18003, '3.30.300.30-FF-000014', NULL, 'acyl-CoA synthetase family member 4', 96, NULL, NULL, 18003),
(18004, '1.10.287.110-FF-000468', NULL, 'Uncharacterized protein', 112, NULL, NULL, 18004),
(18005, '1.10.510.10-FF-004263', NULL, NULL, 187, NULL, NULL, 18005),
(18006, '3.90.550.10-FF-000384', NULL, 'Galactosyl transferase paralog', 198, NULL, NULL, 18006),
(18007, '3.40.50.11380-FF-000006', NULL, NULL, 19, NULL, NULL, 18007),
(18008, '3.40.50.720-FF-001318', NULL, 'Long-chain acyl-[acyl-carrier-protein] reductase', 128, NULL, NULL, 18008),
(18009, '3.40.720.10-FF-000206', NULL, 'GPI ethanolamine phosphate transferase 2', 294, NULL, NULL, 18009),
(18010, '3.40.50.620-FF-000097', NULL, 'valine--tRNA ligase, mitochondrial', 229, NULL, NULL, 18010),
(18011, '3.30.450.20-FF-000432', NULL, 'Aryl-hydrocarbon receptor repressor a', 156, NULL, NULL, 18011),
(18012, '3.30.40.10-FF-001590', NULL, 'Histone-lysine N-methyltransferase', 45, NULL, NULL, 18012),
(18013, '2.130.10.10-FF-000405', NULL, 'rho guanine nucleotide exchange factor 10-like protein isoform X1', 296, NULL, NULL, 18013),
(18014, '1.10.472.10-FF-000531', NULL, 'cyclin-A2-1', 88, NULL, NULL, 18014),
(18015, '1.10.510.10-FF-001857', NULL, 'Interleukin-1 receptor-associated kinase 3', 107, NULL, NULL, 18015),
(18016, '3.40.50.300-FF-008191', NULL, 'Dynein, axonemal, heavy chain 5', 77, NULL, NULL, 18016),
(18017, '3.40.190.10-FF-000862', NULL, 'Uncharacterized protein', 37, NULL, NULL, 18017),
(18018, '1.10.150.240-FF-000047', NULL, 'BnaAnng05460D protein', 85, NULL, NULL, 18018),
(18019, '3.30.710.10-FF-000197', NULL, 'Root phototropism protein 3', 114, NULL, NULL, 18019),
(18020, '3.40.50.880-FF-000091', NULL, 'Aminodeoxychorismate synthase', 215, NULL, NULL, 18020),
(18021, '1.20.58.1070-FF-000011', NULL, 'Gem-associated protein 2', 170, NULL, NULL, 18021),
(18022, '3.90.1170.40-FF-000020', NULL, 'Molybdopterin biosynthesis MoaE protein', 108, NULL, NULL, 18022),
(18023, '3.40.50.10190-FF-000195', NULL, 'DNA damage response protein Mdb1', 105, NULL, NULL, 18023),
(18024, '3.10.129.110-FF-000023', NULL, 'Asperfuranone polyketide synthase afoG', 325, NULL, NULL, 18024),
(18025, '1.20.1560.10-FF-000429', NULL, 'ATP-binding cassette alpha-factor transporter', 624, NULL, NULL, 18025),
(18026, '2.60.40.10-FF-004463', NULL, NULL, 104, NULL, NULL, 18026),
(18027, '1.25.40.610-FF-000006', NULL, 'latrophilin Cirl isoform X2', 96, NULL, NULL, 18027);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(18028, '2.20.25.80-FF-000010', NULL, 'Putative WRKY transcription factor 69', 82, NULL, NULL, 18028),
(18029, '3.30.160.60-FF-005076', NULL, NULL, 23, NULL, NULL, 18029),
(18030, '3.30.160.60-FF-002350', NULL, 'CG10321', 69, NULL, NULL, 18030),
(18031, '1.20.1280.130-FF-000003', NULL, 'Vacuolar protein sorting-associated protein 54', 95, NULL, NULL, 18031),
(18032, '2.120.10.30-FF-000316', NULL, 'SMP-30/Gluconolaconase/LRE-like region, putative', 171, NULL, NULL, 18032),
(18033, '3.60.15.10-FF-000081', NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', 277, NULL, NULL, 18033),
(18034, '3.80.10.10-FF-002665', NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', 170, NULL, NULL, 18034),
(18035, '3.50.50.60-FF-001071', NULL, 'Mitochondrial tRNA translation optimization 1', 111, NULL, NULL, 18035),
(18036, '3.30.420.210-FF-000015', NULL, 'Predicted protein', 60, NULL, NULL, 18036),
(18037, '3.40.50.2000-FF-000583', NULL, 'Beta-1,6-galactofuranosyltransferase WbbI', 157, NULL, NULL, 18037),
(18038, '3.10.530.10-FF-000002', NULL, NULL, 68, NULL, NULL, 18038),
(18039, '1.25.40.10-FF-000668', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 78, NULL, NULL, 18039),
(18040, '2.40.70.10-FF-000475', NULL, NULL, 157, NULL, NULL, 18040),
(18041, '3.30.160.60-FF-004295', NULL, NULL, 28, NULL, NULL, 18041),
(18042, '2.130.10.10-FF-004587', NULL, 'Predicted protein', 207, NULL, NULL, 18042),
(18043, '3.40.190.10-FF-000659', NULL, 'Oligopeptide-binding protein AppA', 130, NULL, NULL, 18043),
(18044, '3.50.50.60-FF-000290', NULL, 'Lysine-specific histone demethylase 1, putative', 160, NULL, NULL, 18044),
(18045, '3.10.450.10-FF-000001', NULL, 'Cystatin-A', 98, NULL, NULL, 18045),
(18046, '1.10.340.30-FF-000023', NULL, 'A/G specific adenine glycosylase', 112, NULL, NULL, 18046),
(18047, '2.80.10.50-FF-000015', NULL, 'Fascin', 121, NULL, NULL, 18047),
(18048, '1.25.10.10-FF-001392', NULL, 'Condensin complex subunit 1', 186, NULL, NULL, 18048),
(18049, '1.20.120.550-FF-000002', NULL, 'Microsomal glutathione S-transferase 1', 149, NULL, NULL, 18049),
(18050, '2.60.40.60-FF-001139', NULL, 'Flamingo-like protein celsr2', 30, NULL, NULL, 18050),
(18051, '2.130.10.120-FF-000011', NULL, 'Oligopeptidase B', 345, NULL, NULL, 18051),
(18052, '3.40.50.410-FF-000236', NULL, 'von Willebrand factor type A domain containing protein, putative', 182, NULL, NULL, 18052),
(18053, '3.30.565.10-FF-000387', NULL, 'DNA topoisomerase/DNA mismatch repair family protein, transducer domain protein', 220, NULL, NULL, 18053),
(18054, '1.10.4160.10-FF-000003', NULL, 'Cytosine permease', 416, NULL, NULL, 18054),
(18055, '3.90.1150.10-FF-000061', NULL, 'dTDP-4-amino-4,6-dideoxygalactose transaminase', 127, NULL, NULL, 18055),
(18056, '1.20.120.720-FF-000042', NULL, 'Myosin XXI', 136, NULL, NULL, 18056),
(18057, '1.10.10.10-FF-002026', NULL, 'Uncharacterized protein', 106, NULL, NULL, 18057),
(18058, '3.30.450.190-FF-000009', NULL, 'Ras-related GTP-binding protein A', 123, NULL, NULL, 18058),
(18059, '3.20.20.150-FF-000022', NULL, 'D-psicose 3-epimerase', 291, NULL, NULL, 18059),
(18060, '2.130.10.10-FF-004767', NULL, 'Uncharacterized protein', 156, NULL, NULL, 18060),
(18061, '3.40.50.300-FF-005262', NULL, 'Uncharacterized protein', 185, NULL, NULL, 18061),
(18062, '3.30.70.330-FF-000691', NULL, 'Serine/arginine-rich splicing factor 12', 104, NULL, NULL, 18062),
(18063, '3.30.230.70-FF-000150', NULL, 'Uncharacterized protein', 88, NULL, NULL, 18063),
(18064, '2.120.10.30-FF-000501', NULL, 'ABC transporter permease protein', 217, NULL, NULL, 18064),
(18065, '2.40.150.20-FF-000017', NULL, 'S60 ribosomal protein L23', 136, NULL, NULL, 18065),
(18066, '3.90.190.10-FF-000160', NULL, 'GM15704', 372, NULL, NULL, 18066),
(18067, '2.40.50.730-FF-000021', NULL, 'DNA polymerase', 56, NULL, NULL, 18067),
(18068, '1.10.10.10-FF-000604', NULL, 'Caffeic acid 3-O-methyltransferase', 110, NULL, NULL, 18068),
(18069, '2.60.40.2440-FF-000008', NULL, 'Type-1 protein phosphatase regulatory subunit', 142, NULL, NULL, 18069);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(18070, '1.10.238.10-FF-000976', NULL, 'Uncharacterized protein', 70, NULL, NULL, 18070),
(18071, '1.10.10.60-FF-000922', NULL, NULL, 81, NULL, NULL, 18071),
(18072, '3.50.50.60-FF-000143', NULL, 'FAD-dependent oxidoreductase domain-containing protein 2', 133, NULL, NULL, 18072),
(18073, '1.10.3380.30-FF-000031', NULL, 'ATP-dependent DNA helicase Hel308', 225, NULL, NULL, 18073),
(18074, '1.20.140.100-FF-000017', NULL, 'Dynein heavy chain, putative', 160, NULL, NULL, 18074),
(18075, '2.60.40.60-FF-000543', NULL, 'Cadherin 17, LI cadherin (liver-intestine)', 103, NULL, NULL, 18075),
(18076, '1.10.510.10-FF-000896', NULL, 'CMGC/DYRK protein kinase', 230, NULL, NULL, 18076),
(18077, '3.30.1640.10-FF-000090', NULL, 'DNA helicase', 106, NULL, NULL, 18077),
(18078, '1.25.40.470-FF-000037', NULL, 'Intraflagellar transport protein 122 homolog', 195, NULL, NULL, 18078),
(18079, '3.40.50.300-FF-005970', NULL, 'Uncharacterized protein', 57, NULL, NULL, 18079),
(18080, '3.30.160.60-FF-004148', NULL, NULL, 55, NULL, NULL, 18080),
(18081, '1.10.1130.10-FF-000006', NULL, 'C-type polyheme cytochrome OmcB', 117, NULL, NULL, 18081),
(18082, '3.40.50.150-FF-001541', NULL, NULL, 92, NULL, NULL, 18082),
(18083, '3.90.1070.20-FF-000006', NULL, 'DNA-directed RNA polymerase subunit beta', 84, NULL, NULL, 18083),
(18084, '3.40.50.300-FF-004149', NULL, 'Predicted protein', 286, NULL, NULL, 18084),
(18085, '1.10.287.70-FF-000394', NULL, 'Uncharacterized protein', 148, NULL, NULL, 18085),
(18086, '1.10.418.10-FF-000125', NULL, 'Uncharacterized protein', 71, NULL, NULL, 18086),
(18087, '3.30.70.330-FF-000016', NULL, 'CUGBP Elav-like family member 1 isoform 2', 107, NULL, NULL, 18087),
(18088, '3.40.190.10-FF-000098', NULL, 'LysR family transcriptional regulator', 105, NULL, NULL, 18088),
(18089, '3.40.50.150-FF-000613', NULL, 'L-isoaspartate O-methyltransferase domain-containing protein', 219, NULL, NULL, 18089),
(18090, '3.40.50.300-FF-004334', NULL, 'Iron(III) ABC transporter, ATP-binding protein', 257, NULL, NULL, 18090),
(18091, '3.40.50.720-FF-002302', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 148, NULL, NULL, 18091),
(18092, '3.60.21.50-FF-000011', NULL, 'DNA polymerase delta subunit 2', 267, NULL, NULL, 18092),
(18093, '2.60.120.290-FF-000223', NULL, 'Uncharacterized protein', 113, NULL, NULL, 18093),
(18094, '3.40.640.10-FF-000352', NULL, 'DegT/DnrJ/EryC1/StrS aminotransferase', 266, NULL, NULL, 18094),
(18095, '1.20.1720.10-FF-000111', NULL, NULL, 126, NULL, NULL, 18095),
(18096, '3.20.20.190-FF-000039', NULL, 'Phosphoinositide phospholipase C', 319, NULL, NULL, 18096),
(18097, '1.10.510.10-FF-000929', NULL, 'Non-specific serine/threonine protein kinase', 342, NULL, NULL, 18097),
(18098, '1.10.472.10-FF-000003', NULL, 'G1/S-specific cyclin-D2', 113, NULL, NULL, 18098),
(18099, '2.130.10.10-FF-000372', NULL, 'Peroxisomal biogenesis factor 7', 307, NULL, NULL, 18099),
(18100, '1.10.150.510-FF-000004', NULL, 'Receptor activity modifying protein 1', 95, NULL, NULL, 18100),
(18101, '2.10.25.10-FF-001783', NULL, 'Matrilin 3a', 32, NULL, NULL, 18101),
(18102, '1.20.210.10-FF-000011', NULL, 'Cytochrome c oxidase subunit I', 496, NULL, NULL, 18102),
(18103, '3.40.50.300-FF-000591', NULL, 'Cystic fibrosis transmembrane conductance regulator', 249, NULL, NULL, 18103),
(18104, '3.80.10.10-FF-001361', NULL, '2mit, isoform A', 100, NULL, NULL, 18104),
(18105, '1.20.1070.10-FF-000201', NULL, 'Bradykinin receptor B2', 309, NULL, NULL, 18105),
(18106, '3.10.110.10-FF-000127', NULL, 'Component of the ESCRT-I complex', 161, NULL, NULL, 18106),
(18107, '1.10.3210.10-FF-000035', NULL, 'HD family hydrolase', 186, NULL, NULL, 18107),
(18108, '3.30.160.60-FF-004856', NULL, NULL, 81, NULL, NULL, 18108),
(18109, '3.30.70.100-FF-000149', NULL, NULL, 94, NULL, NULL, 18109),
(18110, '3.30.160.150-FF-000004', NULL, 'LPS-assembly lipoprotein LptE', 148, NULL, NULL, 18110),
(18111, '1.10.8.50-FF-000025', NULL, '30S ribosomal protein S13', 78, NULL, NULL, 18111),
(18112, '3.40.50.300-FF-004857', NULL, 'YALI0D23881p', 218, NULL, NULL, 18112);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(18113, '2.130.10.10-FF-005604', NULL, 'Uncharacterized protein', 190, NULL, NULL, 18113),
(18114, '1.10.4080.10-FF-000002', NULL, 'ADP-ribosylarginine hydrolase isoform X1', 353, NULL, NULL, 18114),
(18115, '3.30.200.20-FF-002533', NULL, 'Os12g0149700 protein', 29, NULL, NULL, 18115),
(18116, '3.40.50.2300-FF-000083', NULL, 'Two-component response regulator', 119, NULL, NULL, 18116),
(18117, '1.20.1080.10-FF-000027', NULL, 'MIP aquaporin', 257, NULL, NULL, 18117),
(18118, '1.20.900.10-FF-000042', NULL, 'uncharacterized protein LOC108093793 isoform X3', 241, NULL, NULL, 18118),
(18119, '3.30.70.330-FF-001000', NULL, 'Polyadenylate-binding protein', 82, NULL, NULL, 18119),
(18120, '1.25.40.180-FF-000130', NULL, 'Eukaryotic translation initiation factor', 250, NULL, NULL, 18120),
(18121, '1.20.5.110-FF-000158', NULL, 'Syntaxin, putative', 67, NULL, NULL, 18121),
(18122, '3.40.50.2300-FF-000459', NULL, 'Probable two-component response regulator', 80, NULL, NULL, 18122),
(18123, '3.30.60.60-FF-000010', NULL, 'Histone acetyltransferase', 55, NULL, NULL, 18123),
(18124, '2.60.40.10-FF-004643', NULL, NULL, 85, NULL, NULL, 18124),
(18125, '3.90.70.80-FF-000031', NULL, 'OTU family cysteine protease', 179, NULL, NULL, 18125),
(18126, '3.90.640.80-FF-000007', NULL, 'Poly [ADP-ribose] polymerase', 82, NULL, NULL, 18126),
(18127, '3.10.310.50-FF-000003', NULL, 'UPF0603 protein At1g54780, chloroplastic', 153, NULL, NULL, 18127),
(18128, '1.20.120.420-FF-000014', NULL, 'Methylthioribose-1-phosphate isomerase', 142, NULL, NULL, 18128),
(18129, '3.40.350.10-FF-000009', NULL, 'Xaa-Pro aminopeptidase', 173, NULL, NULL, 18129),
(18130, '2.130.10.10-FF-001333', NULL, 'Vacuolar sorting protein', 318, NULL, NULL, 18130),
(18131, '1.25.40.10-FF-001596', NULL, 'Mitochondrial RNA binding complex 1 subunit, putative', 182, NULL, NULL, 18131),
(18132, '2.30.30.140-FF-000039', NULL, 'Histone acetyltransferase', 128, NULL, NULL, 18132),
(18133, '1.10.287.730-FF-000002', NULL, 'Fmu (Sun) domain-containing protein', 26, NULL, NULL, 18133),
(18134, '2.130.10.10-FF-003659', NULL, 'Uncharacterized protein', 145, NULL, NULL, 18134),
(18135, '3.30.40.10-FF-002219', NULL, 'Predicted protein', 123, NULL, NULL, 18135),
(18136, '3.80.10.10-FF-001737', NULL, 'SNRPA1 isoform 9', 71, NULL, NULL, 18136),
(18137, '3.50.50.60-FF-000519', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 34, NULL, NULL, 18137),
(18138, '1.20.920.40-FF-000001', NULL, 'RNA-induced transcriptional silencing complex protein tas3', 124, NULL, NULL, 18138),
(18139, '1.10.238.10-FF-000268', NULL, 'Centrin 2', 77, NULL, NULL, 18139),
(18140, '1.10.1050.10-FF-000005', NULL, '30S ribosomal protein S4', 107, NULL, NULL, 18140),
(18141, '1.10.150.240-FF-000103', NULL, 'Phosphoglycolate phosphatase', 66, NULL, NULL, 18141),
(18142, '1.20.1250.20-FF-001084', NULL, 'Uncharacterized MFS-type transporter C330.07c', 408, NULL, NULL, 18142),
(18143, '3.40.50.150-FF-000580', NULL, 'Class I SAM-dependent methyltransferase', 150, NULL, NULL, 18143),
(18144, '1.25.10.10-FF-000464', NULL, 'TORTIFOLIA1-like protein 3 isoform A', 357, NULL, NULL, 18144),
(18145, '1.25.10.10-FF-000279', NULL, 'Importin beta, putative', 872, NULL, NULL, 18145),
(18146, '2.130.10.10-FF-000933', NULL, 'Vacuolar protein sorting-associated protein 41', 247, NULL, NULL, 18146),
(18147, '3.30.200.20-FF-000588', NULL, 'CTD kinase subunit alpha', 93, NULL, NULL, 18147),
(18148, '3.40.50.1820-FF-001675', NULL, 'Uncharacterized protein', 246, NULL, NULL, 18148),
(18149, '3.10.110.10-FF-000274', NULL, 'Uncharacterized protein', 132, NULL, NULL, 18149),
(18150, '1.20.870.10-FF-000044', NULL, 'Uncharacterized protein', 256, NULL, NULL, 18150),
(18151, '3.40.50.300-FF-000439', NULL, 'ATP-dependent RNA helicase HrpA', 168, NULL, NULL, 18151),
(18152, '3.80.10.10-FF-002137', NULL, 'Leucine-rich repeat-containing 51', 142, NULL, NULL, 18152),
(18153, '3.90.550.10-FF-000417', NULL, 'Uncharacterized protein', 306, NULL, NULL, 18153),
(18154, '3.90.740.10-FF-000067', NULL, 'Uncharacterized protein', 87, NULL, NULL, 18154);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(18155, '3.30.160.60-FF-000438', NULL, 'Zinc finger transcription factor', 26, NULL, NULL, 18155),
(18156, '3.40.50.12280-FF-000001', NULL, 'NADH-quinone oxidoreductase subunit B 2', 161, NULL, NULL, 18156),
(18157, '3.20.20.300-FF-000033', NULL, 'Beta-glucosidase', 359, NULL, NULL, 18157),
(18158, '2.130.10.10-FF-004059', NULL, 'Semaphorin 4A', 211, NULL, NULL, 18158),
(18159, '3.40.50.1010-FF-000089', NULL, 'exosome complex exonuclease RRP44 isoform X2', 47, NULL, NULL, 18159),
(18160, '1.25.40.10-FF-000409', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 105, NULL, NULL, 18160),
(18161, '3.30.70.330-FF-002545', NULL, NULL, 40, NULL, NULL, 18161),
(18162, '3.40.50.1000-FF-000148', NULL, 'Haloacid dehalogenase superfamily protein', 147, NULL, NULL, 18162),
(18163, '4.10.400.10-FF-000275', NULL, 'GM17661', 36, NULL, NULL, 18163),
(18164, '1.20.1250.20-FF-001645', NULL, 'Transporter, MFS family protein', 482, NULL, NULL, 18164),
(18165, '3.30.70.330-FF-001505', NULL, NULL, 87, NULL, NULL, 18165),
(18166, '2.130.10.10-FF-004907', NULL, 'Protein HIRA', 110, NULL, NULL, 18166),
(18167, '2.30.29.30-FF-000936', NULL, 'Uncharacterized protein', 133, NULL, NULL, 18167),
(18168, '2.40.30.170-FF-000006', NULL, 'Multidrug resistance protein MdtA', 74, NULL, NULL, 18168),
(18169, '3.30.160.60-FF-001074', NULL, 'zinc finger protein 317', 28, NULL, NULL, 18169),
(18170, '2.60.40.10-FF-005340', NULL, NULL, 73, NULL, NULL, 18170),
(18171, '1.10.600.10-FF-000111', NULL, 'Uncharacterized protein', 279, NULL, NULL, 18171),
(18172, '3.30.70.100-FF-000144', NULL, NULL, 66, NULL, NULL, 18172),
(18173, '3.30.300.180-FF-000018', NULL, 'Chromosomal replication initiator protein DnaA', 103, NULL, NULL, 18173),
(18174, '1.10.10.60-FF-000714', NULL, 'Sigma-54 dependent transcriptional regulator', 72, NULL, NULL, 18174),
(18175, '1.10.150.20-FF-000039', NULL, 'Polymerase (DNA directed) kappa', 60, NULL, NULL, 18175),
(18176, '2.70.98.10-FF-000088', NULL, 'Aldose 1-epimerase', 348, NULL, NULL, 18176),
(18177, '3.40.50.720-FF-001577', NULL, 'Short-chain dehydrogenase/reductase family member NovK', 236, NULL, NULL, 18177),
(18178, '2.30.30.230-FF-000010', NULL, 'Fumarylacetoacetase', 152, NULL, NULL, 18178),
(18179, '3.40.50.300-FF-002625', NULL, 'p-loop containing nucleoside triphosphate hydrolases superfamily protein', 193, NULL, NULL, 18179),
(18180, '3.20.20.80-FF-000008', NULL, 'Glucan endo-1,3-beta-glucosidase 5', 327, NULL, NULL, 18180),
(18181, '1.25.40.660-FF-000004', NULL, 'Vacuolar protein sorting-associated protein 35', 321, NULL, NULL, 18181),
(18182, '1.25.40.10-FF-000848', NULL, 'transmembrane and TPR repeat-containing protein 2', 72, NULL, NULL, 18182),
(18183, '1.20.272.10-FF-000025', NULL, 'DNA polymerase III subunit gamma/tau', 117, NULL, NULL, 18183),
(18184, '3.40.47.10-FF-000110', NULL, 'Fatty acid synthase subunit alpha', 170, NULL, NULL, 18184),
(18185, '1.10.640.10-FF-000057', NULL, 'Oxidase/peroxidase, putative', 325, NULL, NULL, 18185),
(18186, '3.40.50.300-FF-006858', NULL, 'Sulfotransferase', 257, NULL, NULL, 18186),
(18187, '3.90.1290.10-FF-000076', NULL, 'Microtubule-actin crosslinking factor 1', 100, NULL, NULL, 18187),
(18188, '1.20.810.10-FF-000012', NULL, 'Cytochrome b/b6 domain protein', 424, NULL, NULL, 18188),
(18189, '3.40.190.290-FF-000027', NULL, 'LysR family transcriptional regulator', 205, NULL, NULL, 18189),
(18190, '3.30.200.20-FF-000801', NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At2g02780', 101, NULL, NULL, 18190),
(18191, '1.10.560.10-FF-000056', NULL, 'T-complex protein 1 beta subunit putative', 233, NULL, NULL, 18191),
(18192, '1.10.580.10-FF-000018', NULL, 'Citrate synthase 2', 204, NULL, NULL, 18192),
(18193, '2.60.40.10-FF-000068', NULL, 'receptor-type tyrosine-protein phosphatase delta isoform X1', 93, NULL, NULL, 18193),
(18194, '3.40.50.1390-FF-000006', NULL, 'Resolvase family site-specific recombinase', 139, NULL, NULL, 18194),
(18195, '3.30.540.10-FF-000009', NULL, 'Fructose-1,6-bisphosphatase', 201, NULL, NULL, 18195);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(18196, '2.60.40.4100-FF-000006', NULL, 'beta-tectorin', 149, NULL, NULL, 18196),
(18197, '2.60.120.680-FF-000014', NULL, 'CRE-CGR-1 protein', 95, NULL, NULL, 18197),
(18198, '3.30.230.10-FF-000300', NULL, 'Predicted protein', 117, NULL, NULL, 18198),
(18199, '3.30.300.130-FF-000015', NULL, 'NifU-like protein, putative', 85, NULL, NULL, 18199),
(18200, '1.10.510.10-FF-000396', NULL, 'Serine/threonine-protein kinase 16', 203, NULL, NULL, 18200),
(18201, '3.90.226.10-FF-000058', NULL, 'Enoyl-CoA hydratase/isomerase family protein', 219, NULL, NULL, 18201),
(18202, '3.30.160.60-FF-000517', NULL, 'Zinc finger protein 24 isoform X1', 25, NULL, NULL, 18202),
(18203, '3.30.160.60-FF-004851', NULL, NULL, 33, NULL, NULL, 18203),
(18204, '1.10.472.170-FF-000020', NULL, 'Predicted protein', 178, NULL, NULL, 18204),
(18205, '1.20.1280.20-FF-000012', NULL, 'GM25599', 84, NULL, NULL, 18205),
(18206, '3.30.460.10-FF-000008', NULL, 'Ribosomal silencing factor RsfS', 113, NULL, NULL, 18206),
(18207, '3.60.110.10-FF-000105', NULL, NULL, 50, NULL, NULL, 18207),
(18208, '3.40.1410.10-FF-000008', NULL, 'Transcriptional regulator, GntR family', 153, NULL, NULL, 18208),
(18209, '1.25.40.20-FF-000789', NULL, 'Protein 21.1', 132, NULL, NULL, 18209),
(18210, '3.40.1050.10-FF-000025', NULL, 'Carbonic anhydrase', 199, NULL, NULL, 18210),
(18211, '3.80.10.10-FF-000012', NULL, 'Leucine rich repeat containing 4', 310, NULL, NULL, 18211),
(18212, '2.170.270.10-FF-000150', NULL, 'PR/SET domain 13', 136, NULL, NULL, 18212),
(18213, '2.10.25.10-FF-001423', NULL, 'Cdh-4', 113, NULL, NULL, 18213),
(18214, '2.10.25.10-FF-000855', NULL, 'delta-like protein C', 30, NULL, NULL, 18214),
(18215, '2.130.10.10-FF-002119', NULL, 'Serine/threonine-protein kinase/endoribonuclease ire-1', 274, NULL, NULL, 18215),
(18216, '3.30.70.330-FF-001556', NULL, NULL, 94, NULL, NULL, 18216),
(18217, '1.20.1070.10-FF-000460', NULL, 'Predicted protein', 299, NULL, NULL, 18217),
(18218, '3.100.10.10-FF-000026', NULL, '60S ribosomal protein L18', 136, NULL, NULL, 18218),
(18219, '1.20.58.60-FF-000083', NULL, 'Spectrin beta chain', 255, NULL, NULL, 18219),
(18220, '3.30.200.20-FF-000060', NULL, 'Serine/threonine-protein kinase isoform 1', 88, NULL, NULL, 18220),
(18221, '3.90.190.10-FF-000401', NULL, 'Cell division cycle 14A', 67, NULL, NULL, 18221),
(18222, '3.40.50.2000-FF-001128', NULL, 'Uncharacterized protein', 111, NULL, NULL, 18222),
(18223, '3.10.110.10-FF-000122', NULL, 'Ubiquitin-fold modifier-conjugating enzyme 1', 160, NULL, NULL, 18223),
(18224, '1.25.40.10-FF-002877', NULL, 'Predicted protein', 245, NULL, NULL, 18224),
(18225, '3.40.850.10-FF-000446', NULL, 'Uncharacterized protein', 107, NULL, NULL, 18225),
(18226, '1.10.1600.10-FF-000031', NULL, 'Predicted protein', 124, NULL, NULL, 18226),
(18227, '1.20.1060.20-FF-000001', NULL, 'Structural maintenance of chromosomes 1A', 81, NULL, NULL, 18227),
(18228, '3.40.50.300-FF-006419', NULL, 'Uncharacterized protein', 130, NULL, NULL, 18228),
(18229, '2.160.20.10-FF-000186', NULL, 'Uncharacterized protein', 186, NULL, NULL, 18229),
(18230, '2.30.29.30-FF-000987', NULL, 'YALI0C14828p', 146, NULL, NULL, 18230),
(18231, '3.40.50.10800-FF-000001', NULL, 'Quinolinate synthase A', 90, NULL, NULL, 18231),
(18232, '3.30.40.10-FF-001270', NULL, 'AGAP006402-PA', 72, NULL, NULL, 18232),
(18233, '2.60.40.60-FF-000622', NULL, 'Uncharacterized protein', 66, NULL, NULL, 18233),
(18234, '3.30.160.60-FF-005840', NULL, NULL, 36, NULL, NULL, 18234),
(18235, '3.30.70.270-FF-000116', NULL, 'Sensory box/GGDEF family protein', 168, NULL, NULL, 18235),
(18236, '3.60.20.30-FF-000014', NULL, NULL, 119, NULL, NULL, 18236),
(18237, '2.40.10.10-FF-000590', NULL, NULL, 37, NULL, NULL, 18237),
(18238, '3.50.50.60-FF-000351', NULL, 'Glutamate synthase, small subunit', 155, NULL, NULL, 18238),
(18239, '2.10.25.10-FF-000063', NULL, 'Slit guidance ligand 2', 43, NULL, NULL, 18239),
(18240, '3.30.559.10-FF-000215', NULL, 'Non-ribosomal peptide synthetase OfaA', 193, NULL, NULL, 18240),
(18241, '3.40.605.10-FF-000130', NULL, 'Delta-1-pyrroline-5-carboxylate synthase B', 139, NULL, NULL, 18241);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(18242, '1.25.40.20-FF-000738', NULL, 'Transient receptor potential cation channel subfamily A member 1', 198, NULL, NULL, 18242),
(18243, '1.10.8.60-FF-000562', NULL, 'CDC48/VCP homolog, AAA superfamily', 84, NULL, NULL, 18243),
(18244, '2.130.10.10-FF-000725', NULL, 'Nuclear pore complex subunit', 351, NULL, NULL, 18244),
(18245, '2.40.10.350-FF-000006', NULL, 'Rod shape-determining protein MreC', 71, NULL, NULL, 18245),
(18246, '3.60.10.10-FF-000182', NULL, 'DNA-(Apurinic or apyrimidinic site) lyase chloroplastic', 91, NULL, NULL, 18246),
(18247, '3.40.50.150-FF-000372', NULL, 'tRNA (guanine-N(7)-)-methyltransferase', 211, NULL, NULL, 18247),
(18248, '1.25.10.10-FF-000380', NULL, 'DNA-dependent protein kinase catalytic subunit', 382, NULL, NULL, 18248),
(18249, '1.20.910.10-FF-000008', NULL, 'Heme oxygenase', 250, NULL, NULL, 18249),
(18250, '3.30.1640.10-FF-000095', NULL, 'DNA helicase', 108, NULL, NULL, 18250),
(18251, '3.20.20.60-FF-000053', NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', 271, NULL, NULL, 18251),
(18252, '3.40.50.2300-FF-000611', NULL, 'Uncharacterized protein', 38, NULL, NULL, 18252),
(18253, '3.80.10.10-FF-002249', NULL, 'F-box/LRR-repeat protein 18', 120, NULL, NULL, 18253),
(18254, '1.20.1070.10-FF-001870', NULL, 'Uncharacterized protein', 346, NULL, NULL, 18254),
(18255, '3.30.160.60-FF-004800', NULL, NULL, 33, NULL, NULL, 18255),
(18256, '3.30.200.20-FF-001257', NULL, 'AGAP002515-PA', 85, NULL, NULL, 18256),
(18257, '3.20.20.70-FF-000735', NULL, NULL, 83, NULL, NULL, 18257),
(18258, '3.80.10.10-FF-003677', NULL, 'Uncharacterized protein', 207, NULL, NULL, 18258),
(18259, '1.10.10.10-FF-000109', NULL, 'DNA-binding transcriptional regulator KdgR', 76, NULL, NULL, 18259),
(18260, '3.60.21.10-FF-000319', NULL, 'Serine/threonine-protein phosphatase', 368, NULL, NULL, 18260),
(18261, '1.10.472.10-FF-000470', NULL, 'Transcription initiation factor IIB 1', 85, NULL, NULL, 18261),
(18262, '2.60.40.10-FF-000017', NULL, 'Down syndrome cell adhesion molecule b', 95, NULL, NULL, 18262),
(18263, '3.30.160.60-FF-001978', NULL, 'Zinc finger protein 619', 28, NULL, NULL, 18263),
(18264, '3.40.50.300-FF-006807', NULL, 'Minichromosome maintenance 8 homologous recombination repair factor', 50, NULL, NULL, 18264),
(18265, '2.40.70.10-FF-000059', NULL, 'Napsin A aspartic peptidase', 67, NULL, NULL, 18265),
(18266, '3.40.1380.20-FF-000047', NULL, 'Pyruvate kinase', 126, NULL, NULL, 18266),
(18267, '3.40.50.1820-FF-001754', NULL, 'Uncharacterized protein', 343, NULL, NULL, 18267),
(18268, '1.10.486.10-FF-000001', NULL, 'DNA helicase', 157, NULL, NULL, 18268),
(18269, '3.90.15.10-FF-000006', NULL, 'Topoisomerase I', 190, NULL, NULL, 18269),
(18270, '2.60.450.20-FF-000019', NULL, 'Uncharacterized protein', 105, NULL, NULL, 18270),
(18271, '3.40.50.300-FF-005610', NULL, 'Dynein heavy chain family protein', 310, NULL, NULL, 18271),
(18272, '3.40.50.1980-FF-000121', NULL, 'Iron(III) ABC transporter, solute-binding protein', 174, NULL, NULL, 18272),
(18273, '3.30.230.10-FF-000351', NULL, 'Uncharacterized protein', 200, NULL, NULL, 18273),
(18274, '2.40.50.140-FF-001098', NULL, NULL, 91, NULL, NULL, 18274),
(18275, '1.10.630.10-FF-000343', NULL, 'Benzoate 4-monooxygenase cytochrome P450', 277, NULL, NULL, 18275),
(18276, '1.50.40.10-FF-000368', NULL, 'Carnitine/acylcarnitine translocase', 225, NULL, NULL, 18276),
(18277, '3.40.190.290-FF-000078', NULL, 'LysR family transcriptional regulator', 206, NULL, NULL, 18277),
(18278, '3.30.200.20-FF-000852', NULL, 'Os01g0927500 protein', 83, NULL, NULL, 18278),
(18279, '3.80.10.10-FF-003626', NULL, 'Follicle-stimulating hormone receptor', 227, NULL, NULL, 18279),
(18280, '1.10.510.10-FF-001352', NULL, 'Protein kinase domain containing protein', 285, NULL, NULL, 18280),
(18281, '1.25.40.40-FF-000003', NULL, 'Cytochrome c oxidase subunit 5A, mitochondrial', 110, NULL, NULL, 18281),
(18282, '1.20.1070.10-FF-001769', NULL, 'Predicted protein', 56, NULL, NULL, 18282),
(18283, '3.20.20.70-FF-000331', NULL, 'Dihydroorotate dehydrogenase (quinone)', 362, NULL, NULL, 18283); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(18284, '3.30.70.330-FF-000196', NULL, 'Poly(A)-specific ribonuclease PARN', 91, NULL, NULL, 18284),
(18285, '3.30.160.60-FF-003491', NULL, 'Zinc finger protein 672', 28, NULL, NULL, 18285),
(18286, '1.10.287.390-FF-000001', NULL, 'CesT family type III secretion system chaperone', 37, NULL, NULL, 18286),
(18287, '3.40.50.300-FF-006066', NULL, 'Predicted protein', 188, NULL, NULL, 18287),
(18288, '3.30.800.10-FF-000029', NULL, NULL, 143, NULL, NULL, 18288),
(18289, '1.10.287.110-FF-000237', NULL, 'DnaJ domain containing protein, putative', 137, NULL, NULL, 18289),
(18290, '3.40.390.10-FF-000315', NULL, NULL, 166, NULL, NULL, 18290),
(18291, '1.10.260.170-FF-000005', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', 124, NULL, NULL, 18291),
(18292, '3.80.10.10-FF-000804', NULL, 'Receptor-like protein 44', 118, NULL, NULL, 18292),
(18293, '2.30.30.40-FF-000538', NULL, 'SH3 domain-containing protein', 68, NULL, NULL, 18293),
(18294, '3.10.129.10-FF-000209', NULL, 'Blr5584 protein', 130, NULL, NULL, 18294),
(18295, '3.40.50.300-FF-001283', NULL, 'Eukaryotic translation elongation factor 1 alpha 1', 99, NULL, NULL, 18295),
(18296, '2.40.50.140-FF-000642', NULL, 'Uncharacterized protein', 116, NULL, NULL, 18296),
(18297, '3.20.20.70-FF-000382', NULL, 'Thiazole tautomerase', 205, NULL, NULL, 18297),
(18298, '2.30.30.1190-FF-000016', NULL, 'Uncharacterized protein', 52, NULL, NULL, 18298),
(18299, '3.70.10.10-FF-000041', NULL, 'DNA repair protein rad9', 286, NULL, NULL, 18299),
(18300, '2.40.50.140-FF-000530', NULL, 'RNA guanylyltransferase, putative', 125, NULL, NULL, 18300),
(18301, '3.40.50.2300-FF-001179', NULL, NULL, 63, NULL, NULL, 18301),
(18302, '3.40.30.10-FF-000307', NULL, 'Thioredoxin-like protein 1, putative', 147, NULL, NULL, 18302),
(18303, '1.25.10.10-FF-002145', NULL, 'Condensin complex subunit capg-1', 538, NULL, NULL, 18303),
(18304, '3.30.40.10-FF-001674', NULL, 'TNF receptor-associated factor 1', 80, NULL, NULL, 18304),
(18305, '3.30.450.40-FF-000207', NULL, 'Stage II sporulation E family protein', 164, NULL, NULL, 18305),
(18306, '1.25.10.10-FF-002257', NULL, 'HEAT repeat family protein', 360, NULL, NULL, 18306),
(18307, '2.60.120.260-FF-000563', NULL, 'Uncharacterized protein', 45, NULL, NULL, 18307),
(18308, '3.10.100.10-FF-000296', NULL, NULL, 138, NULL, NULL, 18308),
(18309, '2.10.10.10-FF-000001', NULL, 'Fibronectin 1a isoform 1', 58, NULL, NULL, 18309),
(18310, '3.40.50.2000-FF-000139', NULL, 'Alpha-1,4 glucan phosphorylase', 456, NULL, NULL, 18310),
(18311, '3.40.50.300-FF-002204', NULL, 'Uncharacterized protein, isoform C', 221, NULL, NULL, 18311),
(18312, '2.60.120.970-FF-000096', NULL, 'Dauer larva development regulatory growth factor daf-7', 166, NULL, NULL, 18312),
(18313, '3.40.33.10-FF-000140', NULL, 'Uncharacterized protein', 151, NULL, NULL, 18313),
(18314, '2.60.40.10-FF-003002', NULL, 'Vasorin a', 86, NULL, NULL, 18314),
(18315, '2.40.50.90-FF-000161', NULL, 'Chromosome 3 open reading frame 33', 70, NULL, NULL, 18315),
(18316, '2.30.29.240-FF-000011', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 58, NULL, NULL, 18316),
(18317, '4.10.280.10-FF-000186', NULL, 'Transcriptional regulator of yeast form adherence 6', 99, NULL, NULL, 18317),
(18318, '1.20.1070.10-FF-001718', NULL, 'Predicted protein', 100, NULL, NULL, 18318),
(18319, '1.25.10.10-FF-002196', NULL, 'Uncharacterized protein C1105.01', 442, NULL, NULL, 18319),
(18320, '1.20.1440.150-FF-000001', NULL, NULL, 124, NULL, NULL, 18320),
(18321, '3.30.70.1230-FF-000017', NULL, 'Adenylate cyclase type 10', 187, NULL, NULL, 18321),
(18322, '3.40.850.10-FF-000334', NULL, 'Kinesin-like protein', 338, NULL, NULL, 18322),
(18323, '3.90.70.10-FF-000139', NULL, 'Dipeptidyl aminopeptidase 1', 370, NULL, NULL, 18323),
(18324, '1.20.1510.10-FF-000005', NULL, 'Putative Cation diffusion facilitator 1', 194, NULL, NULL, 18324),
(18325, '2.10.25.10-FF-000967', NULL, 'Netrin G2', 62, NULL, NULL, 18325),
(18326, '1.10.510.10-FF-004499', NULL, NULL, 230, NULL, NULL, 18326),
(18327, '2.60.120.260-FF-000624', NULL, 'Uncharacterized protein', 127, NULL, NULL, 18327);
INSERT INTO "PUBLIC"."MODEL" VALUES
(18328, '1.10.10.10-FF-002077', NULL, 'EAP30 subunit of ELL complex, putative', 69, NULL, NULL, 18328),
(18329, '2.130.10.10-FF-004536', NULL, 'Uncharacterized protein', 225, NULL, NULL, 18329),
(18330, '3.40.50.2300-FF-000662', NULL, 'Sensor histidine kinase, PAS domain-containing', 138, NULL, NULL, 18330),
(18331, '2.40.70.10-FF-000008', NULL, 'Cathepsin D', 133, NULL, NULL, 18331),
(18332, '3.40.30.10-FF-000728', NULL, 'Thioredoxin-dependent peroxide reductase, putative', 197, NULL, NULL, 18332),
(18333, '3.40.50.1220-FF-000034', NULL, 'NAD-dependent histone deacetylase HST3', 162, NULL, NULL, 18333),
(18334, '3.40.50.1000-FF-000199', NULL, 'Nuclear envelope morphology', 194, NULL, NULL, 18334),
(18335, '3.40.50.150-FF-000321', NULL, 'Protein arginine N-methyltransferase', 174, NULL, NULL, 18335),
(18336, '3.80.10.10-FF-004115', NULL, 'Uncharacterized protein', 117, NULL, NULL, 18336),
(18337, '3.40.50.1980-FF-000088', NULL, 'Uncharacterized ABC transporter substrate-binding lipoprotein YvrC', 129, NULL, NULL, 18337),
(18338, '2.60.420.10-FF-000014', NULL, 'Uncharacterized protein', 78, NULL, NULL, 18338),
(18339, '1.25.10.10-FF-002206', NULL, 'Uncharacterized protein', 434, NULL, NULL, 18339),
(18340, '3.10.100.10-FF-000245', NULL, NULL, 184, NULL, NULL, 18340),
(18341, '3.40.50.1820-FF-001703', NULL, '1H-3-hydroxy-4-oxoquinoline 2,4-dioxygenase', 178, NULL, NULL, 18341),
(18342, '3.30.428.10-FF-000012', NULL, 'HIT domain protein', 130, NULL, NULL, 18342),
(18343, '1.50.10.20-FF-000044', NULL, 'Lupeol synthase', 176, NULL, NULL, 18343),
(18344, '1.20.1740.10-FF-000202', NULL, 'Predicted protein', 171, NULL, NULL, 18344),
(18345, '3.30.50.10-FF-000039', NULL, 'Siderophore transcription factor SreA', 56, NULL, NULL, 18345),
(18346, '3.40.50.1820-FF-000798', NULL, 'Prolyl oligopeptidase family protein', 102, NULL, NULL, 18346),
(18347, '1.10.510.10-FF-002262', NULL, 'Mitosis inhibitor protein kinase mik1', 252, NULL, NULL, 18347),
(18348, '1.20.1070.10-FF-000021', NULL, 'Corticotropin releasing factor receptor 2', 288, NULL, NULL, 18348),
(18349, '1.10.8.10-FF-000120', NULL, 'Uncharacterized protein, isoform A', 54, NULL, NULL, 18349),
(18350, '3.30.310.80-FF-000041', NULL, 'Serine/threonine-protein kinase Chk1', 132, NULL, NULL, 18350),
(18351, '1.10.418.10-FF-000209', NULL, 'EB1-like C-terminal motif containing protein, putative', 122, NULL, NULL, 18351),
(18352, '3.40.50.2300-FF-000723', NULL, NULL, 83, NULL, NULL, 18352),
(18353, '2.30.29.30-FF-000195', NULL, 'Unconventional myosin-X', 119, NULL, NULL, 18353),
(18354, '3.40.50.720-FF-001138', NULL, 'Ubiquitin-activating enzyme E1, putative', 204, NULL, NULL, 18354),
(18355, '2.160.10.10-FF-000050', NULL, 'eIF2B-gamma protein', 112, NULL, NULL, 18355),
(18356, '3.30.40.10-FF-000213', NULL, 'Breast cancer type 1 susceptibility protein homolog', 112, NULL, NULL, 18356),
(18357, '3.10.129.10-FF-000148', NULL, 'Thioesterase family protein', 138, NULL, NULL, 18357),
(18358, '1.20.1050.40-FF-000001', NULL, 'Thimet oligopeptidase 1', 143, NULL, NULL, 18358),
(18359, '2.60.40.60-FF-001027', NULL, 'Uncharacterized protein', 110, NULL, NULL, 18359),
(18360, '3.30.470.20-FF-000170', NULL, 'Predicted protein', 161, NULL, NULL, 18360),
(18361, '2.60.40.10-FF-004351', NULL, NULL, 110, NULL, NULL, 18361),
(18362, '2.40.50.140-FF-000581', NULL, 'Ribosomal protein L8', 86, NULL, NULL, 18362),
(18363, '2.60.34.10-FF-000076', NULL, 'Predicted protein', 157, NULL, NULL, 18363),
(18364, '1.10.1420.10-FF-000045', NULL, 'DNA mismatch repair protein Msh6', 22, NULL, NULL, 18364),
(18365, '3.30.200.20-FF-001369', NULL, 'Membrane-associated tyrosine- and threonine-specific cdc2-inhibitory kinase wee-1.3', 105, NULL, NULL, 18365),
(18366, '1.10.268.10-FF-000040', NULL, NULL, 63, NULL, NULL, 18366),
(18367, '3.30.160.60-FF-001866', NULL, 'Zinc finger protein 628', 46, NULL, NULL, 18367),
(18368, '3.40.50.1110-FF-000001', NULL, 'Multifunctional acyl-CoA thioesterase I', 183, NULL, NULL, 18368),
(18369, '2.160.20.10-FF-000135', NULL, 'Pectinesterase', 74, NULL, NULL, 18369); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(18370, '3.30.420.40-FF-000610', NULL, 'Glucokinase regulator family protein, putative', 196, NULL, NULL, 18370),
(18371, '2.60.40.1910-FF-000029', NULL, NULL, 91, NULL, NULL, 18371),
(18372, '3.40.630.10-FF-000435', NULL, 'Uncharacterized protein', 246, NULL, NULL, 18372),
(18373, '1.10.10.750-FF-000024', NULL, 'TBC1 domain family member 12', 63, NULL, NULL, 18373),
(18374, '1.10.10.60-FF-001119', NULL, NULL, 64, NULL, NULL, 18374),
(18375, '2.10.109.10-FF-000072', NULL, 'Signal peptidase I', 128, NULL, NULL, 18375),
(18376, '3.40.50.12620-FF-000002', NULL, 'Uncharacterized protein', 135, NULL, NULL, 18376),
(18377, '1.10.510.10-FF-003622', NULL, NULL, 195, NULL, NULL, 18377),
(18378, '3.30.428.10-FF-000063', NULL, 'Uncharacterized protein', 124, NULL, NULL, 18378),
(18379, '2.60.120.10-FF-000469', NULL, 'Mannose-6-phosphate isomerase 1', 136, NULL, NULL, 18379),
(18380, '3.40.47.10-FF-000031', NULL, 'Sterigmatocystin biosynthesis polyketide synthase', 444, NULL, NULL, 18380),
(18381, '3.20.20.80-FF-000660', NULL, 'Uncharacterized protein', 56, NULL, NULL, 18381),
(18382, '1.25.10.10-FF-002645', NULL, 'Uncharacterized protein', 113, NULL, NULL, 18382),
(18383, '3.30.70.330-FF-003001', NULL, NULL, 83, NULL, NULL, 18383),
(18384, '1.10.1140.10-FF-000012', NULL, 'V-type proton ATPase catalytic subunit A', 40, NULL, NULL, 18384),
(18385, '1.10.10.10-FF-000048', NULL, 'Pyruvate dehydrogenase complex transcriptional repressor', 75, NULL, NULL, 18385),
(18386, '3.40.50.300-FF-005110', NULL, 'Putative DNA-dependent ATPase', 258, NULL, NULL, 18386),
(18387, '3.50.50.60-FF-000430', NULL, 'Farnesylcysteine lyase', 316, NULL, NULL, 18387),
(18388, '3.40.50.10190-FF-000251', NULL, 'PIS (Pax-2, IA-1/6, Smad-2 interacting protein) homolog', 98, NULL, NULL, 18388),
(18389, '3.30.70.2510-FF-000002', NULL, 'tRNA pseudouridine(54/55) synthase', 133, NULL, NULL, 18389),
(18390, '3.40.50.1820-FF-001254', NULL, 'Lipase, putative', 313, NULL, NULL, 18390),
(18391, '2.60.40.10-FF-000961', NULL, 'Tyrosine-protein kinase receptor', 126, NULL, NULL, 18391),
(18392, '3.40.50.300-FF-004542', NULL, 'Deoxycytidylate deaminase-related protein', 214, NULL, NULL, 18392),
(18393, '3.30.1370.10-FF-000231', NULL, 'Uncharacterized protein', 95, NULL, NULL, 18393),
(18394, '3.40.50.150-FF-001310', NULL, NULL, 211, NULL, NULL, 18394),
(18395, '1.10.472.80-FF-000119', NULL, 'TBC domain containing protein', 142, NULL, NULL, 18395),
(18396, '1.10.3720.10-FF-000006', NULL, 'Glutamate/aspartate ABC transporter, permease protein GltK', 219, NULL, NULL, 18396),
(18397, '2.60.120.920-FF-000103', NULL, 'Predicted protein', 127, NULL, NULL, 18397),
(18398, '3.30.2350.10-FF-000022', NULL, 'RNA pseudouridine synthase', 206, NULL, NULL, 18398),
(18399, '1.20.210.10-FF-000034', NULL, 'Cytochrome c oxidase subunit I', 475, NULL, NULL, 18399),
(18400, '1.20.1440.170-FF-000007', NULL, 'Uncharacterized protein', 115, NULL, NULL, 18400),
(18401, '3.40.50.150-FF-001602', NULL, NULL, 259, NULL, NULL, 18401),
(18402, '3.30.2310.10-FF-000008', NULL, 'Methyltransferase, YaeB family', 82, NULL, NULL, 18402),
(18403, '2.30.230.10-FF-000006', NULL, 'Uncharacterized protein, isoform B', 252, NULL, NULL, 18403),
(18404, '3.40.50.1240-FF-000192', NULL, 'Uncharacterized protein', 394, NULL, NULL, 18404),
(18405, '3.90.190.10-FF-000513', NULL, 'Uncharacterized protein', 135, NULL, NULL, 18405),
(18406, '3.10.50.40-FF-000156', NULL, 'Peptidylprolyl isomerase', 45, NULL, NULL, 18406),
(18407, '2.130.10.10-FF-005104', NULL, 'Uncharacterized protein', 249, NULL, NULL, 18407),
(18408, '2.120.10.30-FF-000468', NULL, 'Uncharacterized protein LRP2', 66, NULL, NULL, 18408),
(18409, '3.40.850.10-FF-000093', NULL, 'CENP-meta, isoform C', 348, NULL, NULL, 18409),
(18410, '3.40.50.150-FF-000293', NULL, 'N-methyltransferase 1', 251, NULL, NULL, 18410),
(18411, '3.30.420.40-FF-001066', NULL, 'Uncharacterized protein', 59, NULL, NULL, 18411),
(18412, '3.50.30.30-FF-000032', NULL, 'Vacuolar-sorting receptor 1', 166, NULL, NULL, 18412),
(18413, '3.40.50.11030-FF-000008', NULL, 'Sua5/YciO/YrdC/YwlC family protein, variant', 162, NULL, NULL, 18413);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(18414, '1.25.10.10-FF-000751', NULL, 'IMportin Beta family', 852, NULL, NULL, 18414),
(18415, '1.10.472.10-FF-000391', NULL, 'Predicted protein', 68, NULL, NULL, 18415),
(18416, '2.120.10.80-FF-000281', NULL, 'Uncharacterized protein', 115, NULL, NULL, 18416),
(18417, '3.80.10.10-FF-003710', NULL, 'F-box protein At3g58530', 154, NULL, NULL, 18417),
(18418, '1.10.630.10-FF-000843', NULL, 'Uncharacterized protein', 175, NULL, NULL, 18418),
(18419, '3.10.450.40-FF-000044', NULL, NULL, 142, NULL, NULL, 18419),
(18420, '1.20.120.1750-FF-000015', NULL, 'E3 ubiquitin-protein ligase RNF31 isoform X2', 93, NULL, NULL, 18420),
(18421, '2.20.70.10-FF-000257', NULL, 'Uncharacterized protein', 44, NULL, NULL, 18421),
(18422, '2.30.130.10-FF-000010', NULL, 'Probable tRNA pseudouridine synthase B', 123, NULL, NULL, 18422),
(18423, '1.10.150.900-FF-000003', NULL, 'N-fatty-acyl-amino acid synthase/hydrolase PM20D1', 83, NULL, NULL, 18423),
(18424, '1.20.1250.20-FF-001584', NULL, 'Uncharacterized protein', 331, NULL, NULL, 18424),
(18425, '3.40.50.670-FF-000027', NULL, 'Uncharacterized protein', 63, NULL, NULL, 18425),
(18426, '3.10.130.10-FF-000005', NULL, 'Ribonuclease-like 3', 123, NULL, NULL, 18426),
(18427, '2.40.10.10-FF-000522', NULL, NULL, 21, NULL, NULL, 18427),
(18428, '1.10.730.10-FF-000227', NULL, 'Methionine--tRNA ligase', 169, NULL, NULL, 18428),
(18429, '1.25.40.550-FF-000022', NULL, 'Uncharacterized protein', 181, NULL, NULL, 18429),
(18430, '3.30.1140.60-FF-000004', NULL, 'F-actin-capping protein subunit alpha', 103, NULL, NULL, 18430),
(18431, '1.10.238.10-FF-000263', NULL, 'plastin-1 isoform X2', 94, NULL, NULL, 18431),
(18432, '2.60.40.1480-FF-000001', NULL, 'Coatomer subunit gamma', 157, NULL, NULL, 18432),
(18433, '1.20.1250.20-FF-001292', NULL, 'Os01g0960900 protein', 230, NULL, NULL, 18433),
(18434, '3.20.20.150-FF-000027', NULL, 'Putative hexulose-6-phosphate isomerase SgbU', 285, NULL, NULL, 18434),
(18435, '1.10.10.10-FF-000099', NULL, 'Two-component system response regulator TorR', 111, NULL, NULL, 18435),
(18436, '2.120.10.80-FF-000230', NULL, 'Predicted protein', 284, NULL, NULL, 18436),
(18437, '2.60.40.10-FF-004851', NULL, NULL, 111, NULL, NULL, 18437),
(18438, '3.30.160.60-FF-000017', NULL, 'zinc finger protein 62 homolog', 28, NULL, NULL, 18438),
(18439, '3.30.420.40-FF-001015', NULL, 'Protein CBG13232', 51, NULL, NULL, 18439),
(18440, '1.20.1070.10-FF-001802', NULL, 'Uncharacterized protein', 358, NULL, NULL, 18440),
(18441, '3.30.9.10-FF-000129', NULL, 'FAD-dependent oxidoreductase', 142, NULL, NULL, 18441),
(18442, '3.40.720.10-FF-000381', NULL, 'Phosphopentomutase', 262, NULL, NULL, 18442),
(18443, '3.10.105.10-FF-000093', NULL, 'Extracellular solute-binding protein family 5', 229, NULL, NULL, 18443),
(18444, '3.40.640.10-FF-000380', NULL, 'Probable glycine dehydrogenase (decarboxylating) subunit 2', 257, NULL, NULL, 18444),
(18445, '3.80.10.10-FF-000400', NULL, 'Nuclear pore complex protein NUP107', 159, NULL, NULL, 18445),
(18446, '1.25.10.10-FF-002937', NULL, 'Uncharacterized protein', 87, NULL, NULL, 18446),
(18447, '3.40.50.1980-FF-000037', NULL, 'Iron ABC transporter substrate-binding protein', 159, NULL, NULL, 18447),
(18448, '3.40.50.1820-FF-000686', NULL, 'Possible esterase LipW', 257, NULL, NULL, 18448),
(18449, '1.20.90.10-FF-000007', NULL, 'Acidic phospholipase A2', 127, NULL, NULL, 18449),
(18450, '2.130.10.10-FF-003547', NULL, 'Uncharacterized protein', 187, NULL, NULL, 18450),
(18451, '2.130.10.10-FF-002642', NULL, 'Semaphorin 3C', 248, NULL, NULL, 18451),
(18452, '1.10.287.10-FF-000011', NULL, '30S ribosomal protein S15, chloroplastic', 88, NULL, NULL, 18452),
(18453, '1.10.472.10-FF-000239', NULL, 'Cyclin-D6-1', 77, NULL, NULL, 18453),
(18454, '3.30.1360.120-FF-000073', NULL, 'Sarcosine dehydrogenase', 203, NULL, NULL, 18454),
(18455, '2.40.10.170-FF-000025', NULL, 'ATP synthase subunit beta', 75, NULL, NULL, 18455),
(18456, '2.40.50.40-FF-000011', NULL, 'chromodomain-helicase-DNA-binding protein 4 isoform X2', 72, NULL, NULL, 18456),
(18457, '1.10.10.580-FF-000012', NULL, 'Uncharacterized protein', 79, NULL, NULL, 18457);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(18458, '1.20.1070.10-FF-001269', NULL, 'Uncharacterized protein', 173, NULL, NULL, 18458),
(18459, '3.40.50.2300-FF-000223', NULL, 'Trehalose operon transcriptional repressor', 119, NULL, NULL, 18459),
(18460, '3.70.10.10-FF-000092', NULL, 'Checkpoint protein', 275, NULL, NULL, 18460),
(18461, '1.20.58.60-FF-000015', NULL, 'triple functional domain protein-like', 148, NULL, NULL, 18461),
(18462, '1.10.1220.10-FF-000013', NULL, 'Putative antitoxin VapB10', 39, NULL, NULL, 18462),
(18463, '3.40.1400.10-FF-000002', NULL, 'Ribose-5-phosphate isomerase B', 159, NULL, NULL, 18463),
(18464, '3.30.40.10-FF-000713', NULL, 'Ubiquitin carboxyl-terminal hydrolase 8', 127, NULL, NULL, 18464),
(18465, '2.130.10.10-FF-004036', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit', 219, NULL, NULL, 18465),
(18466, '3.30.160.40-FF-000011', NULL, 'GD13613', 111, NULL, NULL, 18466),
(18467, '1.10.287.1490-FF-000045', NULL, 'LOC557176 protein', 44, NULL, NULL, 18467),
(18468, '3.30.2350.10-FF-000073', NULL, 'Uncharacterized protein', 210, NULL, NULL, 18468),
(18469, '1.25.10.10-FF-003213', NULL, 'GTP binding protein 2', 274, NULL, NULL, 18469),
(18470, '3.40.1450.10-FF-000005', NULL, 'Predicted protein', 34, NULL, NULL, 18470),
(18471, '1.10.418.50-FF-000002', NULL, 'Kinesin-like protein', 135, NULL, NULL, 18471),
(18472, '1.20.120.1750-FF-000066', NULL, 'RBR-type E3 ubiquitin transferase', 334, NULL, NULL, 18472),
(18473, '2.170.130.10-FF-000056', NULL, NULL, 124, NULL, NULL, 18473),
(18474, '3.30.160.60-FF-006245', NULL, NULL, 48, NULL, NULL, 18474),
(18475, '3.30.930.10-FF-000421', NULL, 'Lysine--tRNA ligase', 375, NULL, NULL, 18475),
(18476, '2.60.120.260-FF-000271', NULL, 'DNA repair protein XRCC1', 59, NULL, NULL, 18476),
(18477, '1.25.40.10-FF-004794', NULL, 'Uncharacterized protein', 173, NULL, NULL, 18477),
(18478, '1.10.238.10-FF-000212', NULL, 'Mitochondrial Rho GTPase', 191, NULL, NULL, 18478),
(18479, '2.60.120.200-FF-000360', NULL, 'Galectin', 164, NULL, NULL, 18479),
(18480, '1.25.10.10-FF-002549', NULL, 'Uncharacterized protein', 178, NULL, NULL, 18480),
(18481, '1.10.630.10-FF-000051', NULL, 'Cytochrome P450 monooxygenase (Fum15)', 486, NULL, NULL, 18481),
(18482, '2.20.70.30-FF-000004', NULL, 'Nascent polypeptide-associated complex subunit beta', 53, NULL, NULL, 18482),
(18483, '1.20.1310.10-FF-000006', NULL, 'Cullin 3', 130, NULL, NULL, 18483),
(18484, '3.40.50.300-FF-005498', NULL, 'Uncharacterized protein', 184, NULL, NULL, 18484),
(18485, '4.10.710.10-FF-000001', NULL, 'Genome polyprotein', 44, NULL, NULL, 18485),
(18486, '2.60.40.10-FF-000809', NULL, 'Sallimus, isoform Q', 113, NULL, NULL, 18486),
(18487, '2.60.200.30-FF-000009', NULL, 'Poly(P)/ATP NAD kinase', 140, NULL, NULL, 18487),
(18488, '3.50.4.10-FF-000012', NULL, 'Apical membrane antigen 1', 68, NULL, NULL, 18488),
(18489, '3.30.70.3490-FF-000066', NULL, NULL, 136, NULL, NULL, 18489),
(18490, '3.30.360.10-FF-000124', NULL, 'Inositol-3-phosphate synthase isozyme 1', 58, NULL, NULL, 18490),
(18491, '1.10.10.160-FF-000061', NULL, 'Uncharacterized protein', 84, NULL, NULL, 18491),
(18492, '1.10.10.10-FF-001116', NULL, 'LysR family transcriptional regulator', 93, NULL, NULL, 18492),
(18493, '1.25.40.20-FF-001306', NULL, 'Uncharacterized protein', 150, NULL, NULL, 18493),
(18494, '3.40.50.150-FF-001653', NULL, NULL, 211, NULL, NULL, 18494),
(18495, '2.60.200.10-FF-000003', NULL, 'Interferon regulatory factor 5', 237, NULL, NULL, 18495),
(18496, '3.80.10.10-FF-001709', NULL, 'Uncharacterized protein', 266, NULL, NULL, 18496),
(18497, '1.10.760.10-FF-000004', NULL, 'Cytochrome c peroxidase', 149, NULL, NULL, 18497),
(18498, '3.40.50.1240-FF-000141', NULL, NULL, 212, NULL, NULL, 18498),
(18499, '1.10.150.60-FF-000023', NULL, 'CRE-LET-526 protein', 125, NULL, NULL, 18499),
(18500, '2.60.40.10-FF-002838', NULL, 'Protein tyrosine phosphatase, receptor-type, Z polypeptide 1a', 101, NULL, NULL, 18500),
(18501, '1.25.40.10-FF-003041', NULL, 'Os07g0436600 protein', 92, NULL, NULL, 18501),
(18502, '3.40.640.10-FF-000228', NULL, 'Aspartate aminotransferase', 195, NULL, NULL, 18502);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(18503, '3.30.450.380-FF-000004', NULL, 'Type II secretion system protein E', 182, NULL, NULL, 18503),
(18504, '1.10.533.10-FF-000140', NULL, 'Death domain-containing membrane protein NRADD', 97, NULL, NULL, 18504),
(18505, '1.10.150.80-FF-000029', NULL, 'ATP-dependent DNA helicase RecQ', 82, NULL, NULL, 18505),
(18506, '3.30.70.330-FF-000128', NULL, 'Nuclear cap-binding protein subunit 2', 147, NULL, NULL, 18506),
(18507, '3.30.160.60-FF-003423', NULL, NULL, 32, NULL, NULL, 18507),
(18508, '1.20.5.340-FF-000053', NULL, 'Tpm1p', 66, NULL, NULL, 18508),
(18509, '3.40.50.300-FF-003109', NULL, 'Replication factor C large subunit, putative', 162, NULL, NULL, 18509),
(18510, '1.25.50.20-FF-000003', NULL, 'Leucyl-cystinyl aminopeptidase', 323, NULL, NULL, 18510),
(18511, '3.40.605.10-FF-000079', NULL, 'Predicted protein', 257, NULL, NULL, 18511),
(18512, '1.20.1310.10-FF-000057', NULL, 'Cullin-4', 103, NULL, NULL, 18512),
(18513, '1.20.5.4130-FF-000002', NULL, 'Disease resistance protein RPP8', 108, NULL, NULL, 18513),
(18514, '2.60.40.150-FF-000245', NULL, 'Copine VIII', 114, NULL, NULL, 18514),
(18515, '3.10.310.10-FF-000042', NULL, '4-oxalomesaconate tautomerase', 154, NULL, NULL, 18515),
(18516, '3.30.160.60-FF-002934', NULL, 'Zinc finger protein 513', 25, NULL, NULL, 18516),
(18517, '1.20.5.110-FF-000282', NULL, 'AER438Cp', 62, NULL, NULL, 18517),
(18518, '1.10.150.80-FF-000001', NULL, 'Putative exosome component 10', 96, NULL, NULL, 18518),
(18519, '2.130.10.10-FF-004828', NULL, 'Uncharacterized protein', 136, NULL, NULL, 18519),
(18520, '3.40.50.1360-FF-000059', NULL, 'Glucosamine-6-phosphate isomerase', 203, NULL, NULL, 18520),
(18521, '3.90.79.10-FF-000288', NULL, 'Uncharacterized protein', 26, NULL, NULL, 18521),
(18522, '3.40.50.300-FF-004621', NULL, 'Transcription regulatory protein SNF2', 254, NULL, NULL, 18522),
(18523, '3.30.310.130-FF-000028', NULL, 'Uncharacterized protein', 74, NULL, NULL, 18523),
(18524, '1.20.1050.90-FF-000004', NULL, 'DNA replication and repair protein RecF', 196, NULL, NULL, 18524),
(18525, '3.30.160.60-FF-006296', NULL, NULL, 37, NULL, NULL, 18525),
(18526, '3.30.565.10-FF-000420', NULL, 'Two component system histidine kinase', 174, NULL, NULL, 18526),
(18527, '1.10.8.60-FF-000062', NULL, 'Origin recognition complex subunit 1', 85, NULL, NULL, 18527),
(18528, '3.10.20.90-FF-000478', NULL, 'Protein LAX PANICLE 2', 89, NULL, NULL, 18528),
(18529, '1.10.510.10-FF-001705', NULL, 'IQ calmodulin-binding motif family protein', 216, NULL, NULL, 18529),
(18530, '3.30.40.10-FF-002130', NULL, 'General transcription and DNA repair factor IIH', 85, NULL, NULL, 18530),
(18531, '1.25.40.10-FF-004451', NULL, 'Putative pentatricopeptide repeat-containing protein At3g08820', 114, NULL, NULL, 18531),
(18532, '2.130.10.10-FF-004087', NULL, 'Major facilitator superfamily protein', 200, NULL, NULL, 18532),
(18533, '3.30.200.20-FF-002246', NULL, 'Uncharacterized protein', 29, NULL, NULL, 18533),
(18534, '3.90.226.10-FF-000119', NULL, 'Probable enoyl-CoA hydratase echA7', 186, NULL, NULL, 18534),
(18535, '2.130.10.10-FF-003598', NULL, 'Predicted protein', 116, NULL, NULL, 18535),
(18536, '3.30.200.20-FF-001757', NULL, 'Uncharacterized protein', 93, NULL, NULL, 18536),
(18537, '3.80.10.10-FF-001861', NULL, 'Ribonuclease inhibitor-like protein', 135, NULL, NULL, 18537),
(18538, '1.25.40.10-FF-002765', NULL, 'Sel1 repeat family protein', 175, NULL, NULL, 18538),
(18539, '3.30.160.60-FF-001574', NULL, 'Zinc finger protein 366', 53, NULL, NULL, 18539),
(18540, '3.80.10.10-FF-000451', NULL, 'EIN3-binding F-box protein 1', 119, NULL, NULL, 18540),
(18541, '4.10.1240.10-FF-000080', NULL, 'Uncharacterized protein', 45, NULL, NULL, 18541),
(18542, '3.30.40.10-FF-001382', NULL, 'Ring finger domain containing protein, putative', 72, NULL, NULL, 18542),
(18543, '1.25.40.10-FF-003254', NULL, 'Pentatricopeptide repeat-containing protein', 165, NULL, NULL, 18543),
(18544, '1.10.760.10-FF-000055', NULL, 'PQQ-dependent dehydrogenase, methanol/ethanol family', 103, NULL, NULL, 18544),
(18545, '1.20.5.4770-FF-000019', NULL, 'Uncharacterized protein', 99, NULL, NULL, 18545);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(18546, '1.10.10.1050-FF-000002', NULL, 'mRNA-decapping enzyme subunit 2', 84, NULL, NULL, 18546),
(18547, '1.10.3720.10-FF-000057', NULL, 'Putative glycerol-3-phosphate ABC transporter, permease protein', 262, NULL, NULL, 18547),
(18548, '3.40.50.300-FF-003261', NULL, '3''-5'' exonuclease DinG', 250, NULL, NULL, 18548),
(18549, '1.20.930.10-FF-000010', NULL, 'elongin-A isoform X1', 91, NULL, NULL, 18549),
(18550, '2.60.40.1120-FF-000039', NULL, 'Silver, isoform N', 85, NULL, NULL, 18550),
(18551, '2.60.40.60-FF-000122', NULL, 'Cadherin-related family member 1', 90, NULL, NULL, 18551),
(18552, '3.20.20.150-FF-000078', NULL, 'Uncharacterized protein', 269, NULL, NULL, 18552),
(18553, '3.15.10.10-FF-000016', NULL, 'Uncharacterized protein', 118, NULL, NULL, 18553),
(18554, '3.40.50.2000-FF-000791', NULL, 'Glycosyltransferase family 1 protein', 30, NULL, NULL, 18554),
(18555, '3.40.50.720-FF-001526', NULL, 'YALI0A02046p', 289, NULL, NULL, 18555),
(18556, '1.10.560.10-FF-000135', NULL, 'T-complex polypeptide 1', 36, NULL, NULL, 18556),
(18557, '3.55.40.20-FF-000002', NULL, 'Superoxide dismutase', 117, NULL, NULL, 18557),
(18558, '3.40.850.10-FF-000042', NULL, 'Kinesin family member 14', 370, NULL, NULL, 18558),
(18559, '1.10.510.10-FF-000345', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', 205, NULL, NULL, 18559),
(18560, '2.30.29.30-FF-001072', NULL, 'Uncharacterized protein', 71, NULL, NULL, 18560),
(18561, '3.40.50.720-FF-002015', NULL, 'Uncharacterized protein', 214, NULL, NULL, 18561),
(18562, '2.80.10.50-FF-000223', NULL, 'Uncharacterized protein', 82, NULL, NULL, 18562),
(18563, '3.30.160.60-FF-003783', NULL, NULL, 26, NULL, NULL, 18563),
(18564, '2.130.10.10-FF-004615', NULL, 'WD repeat-containing protein 52-like Protein', 200, NULL, NULL, 18564),
(18565, '2.30.29.30-FF-000644', NULL, 'Phosphatidylinositol transfer protein 2', 109, NULL, NULL, 18565),
(18566, '3.30.1730.10-FF-000001', NULL, 'AMP nucleosidase', 172, NULL, NULL, 18566),
(18567, '3.20.20.70-FF-000831', NULL, NULL, 134, NULL, NULL, 18567),
(18568, '1.20.58.70-FF-000001', NULL, 'Syntaxin 3', 131, NULL, NULL, 18568),
(18569, '2.30.30.100-FF-000134', NULL, 'Probable U6 snRNA-associated Sm-like protein LSm2', 96, NULL, NULL, 18569),
(18570, '3.10.290.10-FF-000106', NULL, 'Putative ribosomal protein S4 (RPS4A) family protein', 66, NULL, NULL, 18570),
(18571, '3.40.50.720-FF-000245', NULL, 'Short chain dehydrogenase, putative', 271, NULL, NULL, 18571),
(18572, '1.20.1080.10-FF-000078', NULL, 'Uncharacterized protein', 249, NULL, NULL, 18572),
(18573, '2.60.40.10-FF-005632', NULL, NULL, 96, NULL, NULL, 18573),
(18574, '2.10.70.10-FF-000038', NULL, 'Complement component receptor type 1', 62, NULL, NULL, 18574),
(18575, '2.10.90.10-FF-000101', NULL, 'Glycoprotein hormone alpha 2', 64, NULL, NULL, 18575),
(18576, '1.10.238.10-FF-000824', NULL, 'Uncharacterized protein', 55, NULL, NULL, 18576),
(18577, '1.25.10.10-FF-002757', NULL, 'Uncharacterized protein', 1102, NULL, NULL, 18577),
(18578, '1.10.730.20-FF-000005', NULL, 'Mitochondrial isoleucyl-tRNA synthetase', 287, NULL, NULL, 18578),
(18579, '3.30.70.330-FF-001213', NULL, 'heterogeneous nuclear ribonucleoprotein M isoform X2', 82, NULL, NULL, 18579),
(18580, '1.10.510.10-FF-003510', NULL, NULL, 251, NULL, NULL, 18580),
(18581, '2.60.40.10-FF-003502', NULL, NULL, 116, NULL, NULL, 18581),
(18582, '2.60.40.10-FF-000309', NULL, 'Fibronectin type III domain containing 3B', 113, NULL, NULL, 18582),
(18583, '3.40.50.2000-FF-000223', NULL, 'Glycosyltransferase', 185, NULL, NULL, 18583),
(18584, '1.10.1040.10-FF-000027', NULL, 'L-carnitine dehydrogenase', 122, NULL, NULL, 18584),
(18585, '1.25.40.10-FF-000117', NULL, 'Crooked neck pre-mRNA-splicing factor 1', 180, NULL, NULL, 18585),
(18586, '4.10.60.10-FF-000201', NULL, 'DNA topoisomerase', 57, NULL, NULL, 18586),
(18587, '3.30.160.60-FF-000809', NULL, 'Zinc finger and BTB domain-containing 48', 27, NULL, NULL, 18587),
(18588, '1.10.287.130-FF-000070', NULL, 'Histidine kinase sensor protein', 105, NULL, NULL, 18588);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(18589, '3.90.1860.10-FF-000013', NULL, 'Putative RctB family protein', 257, NULL, NULL, 18589),
(18590, '3.30.200.20-FF-002538', NULL, NULL, 118, NULL, NULL, 18590),
(18591, '3.10.20.90-FF-000978', NULL, 'Uncharacterized protein', 99, NULL, NULL, 18591),
(18592, '3.30.200.20-FF-000408', NULL, 'Serine/threonine-protein kinase RIM15', 84, NULL, NULL, 18592),
(18593, '2.40.30.10-FF-000293', NULL, '3-dehydro-bile acid delta(4,6)-reductase', 98, NULL, NULL, 18593),
(18594, '2.30.110.10-FF-000059', NULL, 'Hypthetical protein SCD63.18c', 139, NULL, NULL, 18594),
(18595, '3.30.160.60-FF-000910', NULL, 'Uncharacterized protein', 29, NULL, NULL, 18595),
(18596, '3.30.450.60-FF-000040', NULL, 'Signal recognition particle receptor alpha subunit', 112, NULL, NULL, 18596),
(18597, '3.40.50.300-FF-006127', NULL, 'ATP-dependent DEAD/H RNA helicase, putative', 172, NULL, NULL, 18597),
(18598, '3.40.50.1240-FF-000080', NULL, 'Alpha-ribazole-5`-phosphate phosphatase CobC', 197, NULL, NULL, 18598),
(18599, '2.120.10.30-FF-000052', NULL, 'Soluble aldose sugar dehydrogenase', 352, NULL, NULL, 18599),
(18600, '3.30.1330.30-FF-000111', NULL, 'Protein pelota homolog', 100, NULL, NULL, 18600),
(18601, '1.25.40.700-FF-000005', NULL, 'Uncharacterized protein', 137, NULL, NULL, 18601),
(18602, '3.30.930.10-FF-000264', NULL, 'Alanine--tRNA ligase, cytoplasmic', 252, NULL, NULL, 18602),
(18603, '1.20.1250.20-FF-001353', NULL, 'Sodium:galactoside symporter family protein', 202, NULL, NULL, 18603),
(18604, '4.10.1060.10-FF-000043', NULL, 'Mitochondrial RNA binding complex 1 subunit', 38, NULL, NULL, 18604),
(18605, '3.40.50.300-FF-002917', NULL, 'Mitochondrial ribosomal small subunit component', 158, NULL, NULL, 18605),
(18606, '4.10.410.10-FF-000068', NULL, 'Serine protease inhibitor, putative', 60, NULL, NULL, 18606),
(18607, '1.10.1410.40-FF-000003', NULL, 'Mitochondrial dynamics protein MID51', 132, NULL, NULL, 18607),
(18608, '2.60.120.10-FF-000020', NULL, 'Cyclic nucleotide-gated channel beta 3', 136, NULL, NULL, 18608),
(18609, '2.60.40.60-FF-000330', NULL, 'CaDHerin family', 109, NULL, NULL, 18609),
(18610, '3.40.50.10240-FF-000030', NULL, 'Thiamine pyrophosphokinase', 177, NULL, NULL, 18610),
(18611, '2.40.100.10-FF-000129', NULL, 'Uncharacterized protein', 51, NULL, NULL, 18611),
(18612, '3.90.980.20-FF-000003', NULL, 'Putative PHD finger protein 1', 158, NULL, NULL, 18612),
(18613, '1.10.287.110-FF-000316', NULL, 'Chaperone protein DNAJ, putative', 106, NULL, NULL, 18613),
(18614, '4.10.280.10-FF-000006', NULL, 'Neurogenic differentiation factor', 60, NULL, NULL, 18614),
(18615, '1.20.5.30-FF-000007', NULL, NULL, 28, NULL, NULL, 18615),
(18616, '2.40.30.10-FF-000405', NULL, 'Uncharacterized protein', 58, NULL, NULL, 18616),
(18617, '3.80.10.10-FF-003098', NULL, 'Predicted protein', 115, NULL, NULL, 18617),
(18618, '3.40.120.10-FF-000065', NULL, 'Phosphoglucosamine mutase', 92, NULL, NULL, 18618),
(18619, '3.90.930.12-FF-000028', NULL, NULL, 87, NULL, NULL, 18619),
(18620, '3.30.1370.240-FF-000004', NULL, 'Phenylalanine-tRNA ligase, alpha subunit', 84, NULL, NULL, 18620),
(18621, '3.40.1190.20-FF-000004', NULL, 'Inosine-guanosine kinase', 346, NULL, NULL, 18621),
(18622, '3.30.70.360-FF-000031', NULL, 'Acetylornithine deacetylase', 117, NULL, NULL, 18622),
(18623, '2.30.29.30-FF-000015', NULL, 'Rho guanine nucleotide exchange factor 9', 152, NULL, NULL, 18623),
(18624, '1.25.40.20-FF-000177', NULL, 'Transient receptor potential cation channel subfamily V member 6', 228, NULL, NULL, 18624),
(18625, '3.30.420.110-FF-000024', NULL, 'DNA mismatch repair protein MSH4', 153, NULL, NULL, 18625),
(18626, '1.20.1250.20-FF-002360', NULL, 'Predicted protein', 70, NULL, NULL, 18626),
(18627, '1.10.3120.10-FF-000028', NULL, NULL, 165, NULL, NULL, 18627),
(18628, '2.80.10.50-FF-000274', NULL, 'Glucosylceramidase', 93, NULL, NULL, 18628),
(18629, '3.40.50.1820-FF-001815', NULL, 'Uncharacterized protein', 107, NULL, NULL, 18629),
(18630, '2.60.40.150-FF-000425', NULL, 'Predicted protein', 123, NULL, NULL, 18630),
(18631, '3.40.50.300-FF-002176', NULL, 'Similar to cation ABC transporter', 230, NULL, NULL, 18631);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(18632, '3.40.50.300-FF-006515', NULL, 'Predicted protein', 112, NULL, NULL, 18632),
(18633, '2.40.50.1000-FF-000019', NULL, 'Uncharacterized protein', 72, NULL, NULL, 18633),
(18634, '1.25.40.20-FF-000497', NULL, 'Receptor-interacting serine/threonine-protein kinase 4', 51, NULL, NULL, 18634),
(18635, '3.90.25.10-FF-000012', NULL, 'Nitrogen metabolite repression regulator NmrA', 109, NULL, NULL, 18635),
(18636, '2.130.10.10-FF-000664', NULL, 'Autophagy-related 18a, isoform A', 283, NULL, NULL, 18636),
(18637, '1.20.990.10-FF-000047', NULL, 'Uncharacterized protein', 145, NULL, NULL, 18637),
(18638, '3.30.1520.10-FF-000176', NULL, 'Uncharacterized protein', 109, NULL, NULL, 18638),
(18639, '2.120.10.30-FF-000529', NULL, 'Uncharacterized protein', 144, NULL, NULL, 18639),
(18640, '1.25.40.10-FF-002265', NULL, 'Dynein binding protein, putative', 246, NULL, NULL, 18640),
(18641, '3.40.50.150-FF-000664', NULL, 'Protein arginine methyltransferase 3', 62, NULL, NULL, 18641),
(18642, '3.50.50.60-FF-001099', NULL, 'Baeyer-Villiger monooxygenase', 241, NULL, NULL, 18642),
(18643, '1.20.5.10-FF-000001', NULL, 'thrombospondin-3 isoform X2', 44, NULL, NULL, 18643),
(18644, '1.10.510.10-FF-000845', NULL, 'Probable bifunctional tRNA threonylcarbamoyladenosine biosynthesis protein', 134, NULL, NULL, 18644),
(18645, '3.20.110.10-FF-000018', NULL, 'Mannosidase, alpha, class 2A, member 1', 240, NULL, NULL, 18645),
(18646, '1.10.455.10-FF-000042', NULL, 'Uncharacterized protein', 39, NULL, NULL, 18646),
(18647, '3.30.1370.10-FF-000170', NULL, 'Vigilin 1', 102, NULL, NULL, 18647),
(18648, '3.40.950.10-FF-000038', NULL, NULL, 121, NULL, NULL, 18648),
(18649, '1.10.238.10-FF-000184', NULL, 'cell growth regulator with EF hand domain protein 1', 73, NULL, NULL, 18649),
(18650, '2.40.50.140-FF-000081', NULL, 'Exoribonuclease 2', 87, NULL, NULL, 18650),
(18651, '1.25.40.180-FF-000282', NULL, NULL, 158, NULL, NULL, 18651),
(18652, '3.30.200.20-FF-000352', NULL, 'Mitogen-activated protein kinase kinase kinase kinase 4', 67, NULL, NULL, 18652),
(18653, '3.30.110.20-FF-000002', NULL, 'Ribonuclease P protein subunit p20', 113, NULL, NULL, 18653),
(18654, '1.25.40.20-FF-001014', NULL, 'Uncharacterized protein', 38, NULL, NULL, 18654),
(18655, '1.10.510.10-FF-002993', NULL, NULL, 169, NULL, NULL, 18655),
(18656, '2.60.40.10-FF-002546', NULL, 'Beta-galactosidase', 105, NULL, NULL, 18656),
(18657, '3.40.50.10260-FF-000036', NULL, 'Uncharacterized protein', 186, NULL, NULL, 18657),
(18658, '3.30.160.60-FF-003991', NULL, NULL, 51, NULL, NULL, 18658),
(18659, '3.30.70.590-FF-000015', NULL, 'Predicted protein', 83, NULL, NULL, 18659),
(18660, '1.10.357.40-FF-000003', NULL, 'Protein CBG02959', 215, NULL, NULL, 18660),
(18661, '1.10.10.60-FF-000102', NULL, 'Aristaless related homeobox', 66, NULL, NULL, 18661),
(18662, '1.10.150.20-FF-000011', NULL, 'exonuclease 1', 74, NULL, NULL, 18662),
(18663, '1.20.120.1900-FF-000049', NULL, 'Spindle pole body component', 236, NULL, NULL, 18663),
(18664, '2.40.50.150-FF-000027', NULL, 'DNA-directed RNA polymerase subunit beta', 133, NULL, NULL, 18664),
(18665, '1.10.1300.10-FF-000014', NULL, 'Phosphodiesterase', 358, NULL, NULL, 18665),
(18666, '2.60.40.10-FF-004694', NULL, NULL, 95, NULL, NULL, 18666),
(18667, '3.40.50.720-FF-001869', NULL, 'Actin regulatory protein, putative', 43, NULL, NULL, 18667),
(18668, '1.25.40.10-FF-002585', NULL, 'Pentatricopeptide repeat-containing protein At1g22830', 161, NULL, NULL, 18668),
(18669, '3.30.740.10-FF-000030', NULL, NULL, 55, NULL, NULL, 18669),
(18670, '1.10.287.690-FF-000001', NULL, 'DNA polymerase', 53, NULL, NULL, 18670),
(18671, '3.30.710.10-FF-000202', NULL, 'Predicted protein', 161, NULL, NULL, 18671),
(18672, '2.30.29.30-FF-001364', NULL, 'Phosphoinositide phospholipase C', 128, NULL, NULL, 18672),
(18673, '3.90.1520.10-FF-000022', NULL, 'Uncharacterized protein', 132, NULL, NULL, 18673),
(18674, '1.20.120.350-FF-000094', NULL, 'Voltage-dependent P/Q-type calcium channel subunit alpha', 94, NULL, NULL, 18674),
(18675, '2.60.40.3710-FF-000007', NULL, 'L,D-transpeptidase 4', 83, NULL, NULL, 18675);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(18676, '3.90.550.10-FF-000709', NULL, 'Uncharacterized protein', 274, NULL, NULL, 18676),
(18677, '3.30.160.60-FF-005789', NULL, NULL, 27, NULL, NULL, 18677),
(18678, '2.40.70.10-FF-000470', NULL, NULL, 215, NULL, NULL, 18678),
(18679, '2.60.40.10-FF-004912', NULL, NULL, 94, NULL, NULL, 18679),
(18680, '1.10.3720.10-FF-000237', NULL, 'Blr1679 protein', 103, NULL, NULL, 18680),
(18681, '2.130.10.10-FF-001102', NULL, 'Nitrous-oxide reductase', 460, NULL, NULL, 18681),
(18682, '2.60.40.10-FF-000517', NULL, 'Carcinoembryonic antigen-related cell adhesion molecule 1', 84, NULL, NULL, 18682),
(18683, '2.130.10.10-FF-004879', NULL, 'Uncharacterized protein', 119, NULL, NULL, 18683),
(18684, '2.10.25.10-FF-000142', NULL, 'Crumbs cell polarity complex component 2', 38, NULL, NULL, 18684),
(18685, '3.60.15.10-FF-000086', NULL, 'Ribonuclease Z', 315, NULL, NULL, 18685),
(18686, '1.10.510.10-FF-003830', NULL, NULL, 111, NULL, NULL, 18686),
(18687, '2.30.280.10-FF-000009', NULL, NULL, 198, NULL, NULL, 18687),
(18688, '3.30.900.10-FF-000032', NULL, 'Him-Three Paralog', 253, NULL, NULL, 18688),
(18689, '3.30.200.20-FF-000740', NULL, 'Putative S-receptor kinase', 95, NULL, NULL, 18689),
(18690, '3.30.430.20-FF-000009', NULL, 'Cysteine-rich receptor-like protein kinase 28', 101, NULL, NULL, 18690),
(18691, '3.30.160.60-FF-003715', NULL, NULL, 72, NULL, NULL, 18691),
(18692, '3.30.160.70-FF-000003', NULL, 'Methylated-DNA--protein-cysteine S-methyltransferase', 83, NULL, NULL, 18692),
(18693, '1.25.40.10-FF-004682', NULL, 'Pentatricopeptide repeat-containing protein', 106, NULL, NULL, 18693),
(18694, '3.90.780.10-FF-000013', NULL, 'Trifunctional nucleotide phosphoesterase protein YfkN', 224, NULL, NULL, 18694),
(18695, '3.10.450.10-FF-000052', NULL, 'Cysteine proteinase inhibitor', 93, NULL, NULL, 18695),
(18696, '3.40.50.10190-FF-000043', NULL, 'PAX interacting protein 1', 90, NULL, NULL, 18696),
(18697, '1.10.287.70-FF-000214', NULL, 'Voltage-dependent L-type calcium channel subunit alpha-1S', 124, NULL, NULL, 18697),
(18698, '2.60.40.10-FF-002726', NULL, 'Uncharacterized protein', 99, NULL, NULL, 18698),
(18699, '2.130.10.10-FF-004328', NULL, 'Uncharacterized protein', 103, NULL, NULL, 18699),
(18700, '1.50.10.20-FF-000105', NULL, 'Meiotically up-regulated gene 191 protein', 302, NULL, NULL, 18700),
(18701, '2.40.30.130-FF-000040', NULL, 'Cytoplasm protein, putative', 119, NULL, NULL, 18701),
(18702, '2.30.310.10-FF-000007', NULL, 'Protein CBG11722', 151, NULL, NULL, 18702),
(18703, '1.10.472.130-FF-000087', NULL, 'Cytoplasmic dynein heavy chain, putative', 33, NULL, NULL, 18703),
(18704, '2.60.15.10-FF-000004', NULL, 'ATP synthase subunit delta, mitochondrial', 102, NULL, NULL, 18704),
(18705, '2.60.120.380-FF-000014', NULL, 'Putative calpain-like cysteine peptidase', 143, NULL, NULL, 18705),
(18706, '3.60.10.10-FF-000002', NULL, 'CCR4-NOT transcription complex subunit 6 like', 390, NULL, NULL, 18706),
(18707, '3.40.50.10190-FF-000200', NULL, 'DNA ligase 4', 112, NULL, NULL, 18707),
(18708, '3.60.10.10-FF-000114', NULL, 'Sphingomyelin phosphodiesterase 5', 316, NULL, NULL, 18708),
(18709, '3.40.50.300-FF-001395', NULL, 'Structural maintenance of chromosomes protein', 204, NULL, NULL, 18709),
(18710, '2.30.30.140-FF-000298', NULL, 'Uncharacterized protein', 77, NULL, NULL, 18710),
(18711, '3.40.50.300-FF-008275', NULL, 'Uncharacterized protein', 39, NULL, NULL, 18711),
(18712, '2.60.120.620-FF-000075', NULL, 'Predicted protein', 210, NULL, NULL, 18712),
(18713, '3.30.40.10-FF-001562', NULL, 'Uncharacterized protein', 137, NULL, NULL, 18713),
(18714, '2.60.40.60-FF-000914', NULL, 'Uncharacterized protein', 101, NULL, NULL, 18714),
(18715, '2.130.10.10-FF-006009', NULL, 'WD repeat domain 90', 231, NULL, NULL, 18715),
(18716, '2.60.40.150-FF-000037', NULL, 'dysferlin isoform X2', 125, NULL, NULL, 18716),
(18717, '2.70.98.10-FF-000116', NULL, 'Uncharacterized protein', 239, NULL, NULL, 18717),
(18718, '1.10.1240.60-FF-000001', NULL, 'Regulator of G-protein signaling 6', 103, NULL, NULL, 18718),
(18719, '1.10.167.10-FF-000013', NULL, 'sorting nexin-25 isoform X1', 134, NULL, NULL, 18719);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(18720, '2.30.29.30-FF-000291', NULL, 'insulin receptor substrate 2', 108, NULL, NULL, 18720),
(18721, '1.20.1250.20-FF-002152', NULL, 'Os09g0452300 protein', 198, NULL, NULL, 18721),
(18722, '3.40.50.720-FF-001234', NULL, 'C-terminal-binding protein 1', 195, NULL, NULL, 18722),
(18723, '1.10.10.10-FF-000609', NULL, 'Transcriptional regulator, MarR family', 136, NULL, NULL, 18723),
(18724, '3.40.190.170-FF-000008', NULL, 'C4-dicarboxylate ABC transporter substrate-binding protein', 305, NULL, NULL, 18724),
(18725, '1.10.8.720-FF-000040', NULL, 'Dynein alpha chain, flagellar outer arm', 187, NULL, NULL, 18725),
(18726, '3.30.465.10-FF-000031', NULL, 'FAD binding domain protein', 121, NULL, NULL, 18726),
(18727, '1.25.40.20-FF-000289', NULL, 'Ankyrin repeat domain 33', 167, NULL, NULL, 18727),
(18728, '3.40.1280.10-FF-000126', NULL, 'SPOUT domain-containing methyltransferase 1', 50, NULL, NULL, 18728),
(18729, '3.90.1150.10-FF-000206', NULL, 'Aspartate aminotransferase', 65, NULL, NULL, 18729),
(18730, '2.130.10.10-FF-002850', NULL, 'Regulator of COP-II vesicle coat', 346, NULL, NULL, 18730),
(18731, '2.30.42.10-FF-000034', NULL, 'Glutamate receptor interacting protein 1', 96, NULL, NULL, 18731),
(18732, '2.60.40.10-FF-002142', NULL, 'Immunoglobulin heavy variable 3-38 (non-functional)', 119, NULL, NULL, 18732),
(18733, '3.40.50.1000-FF-000209', NULL, 'Guanylyl cyclase', 196, NULL, NULL, 18733),
(18734, '2.60.40.150-FF-000537', NULL, 'E3 ubiquitin ligase, putative', 140, NULL, NULL, 18734),
(18735, '3.40.47.10-FF-000082', NULL, 'GD13606', 204, NULL, NULL, 18735),
(18736, '4.10.260.10-FF-000011', NULL, 'Guanine nucleotide-binding protein subunit gamma', 68, NULL, NULL, 18736),
(18737, '1.20.50.20-FF-000002', NULL, 'DNA primase', 60, NULL, NULL, 18737),
(18738, '3.40.190.10-FF-000710', NULL, 'Molybdate ABC transporter, periplasmic molybdate-binding protein', 105, NULL, NULL, 18738),
(18739, '4.10.49.10-FF-000006', NULL, NULL, 43, NULL, NULL, 18739),
(18740, '2.120.10.80-FF-000342', NULL, 'tRNA wybutosine-synthesizing protein 4', 308, NULL, NULL, 18740),
(18741, '3.40.525.10-FF-000045', NULL, 'Phosphatidylinositol transfer protein 3', 274, NULL, NULL, 18741),
(18742, '2.30.180.10-FF-000064', NULL, 'Uncharacterized protein', 151, NULL, NULL, 18742),
(18743, '3.40.50.300-FF-000855', NULL, 'Guanylate kinase', 116, NULL, NULL, 18743),
(18744, '3.40.50.300-FF-000731', NULL, 'Fanconi anemia group J protein homolog', 223, NULL, NULL, 18744),
(18745, '1.20.1560.10-FF-000008', NULL, 'Lipid A export ATP-binding/permease protein MsbA', 330, NULL, NULL, 18745),
(18746, '1.10.20.10-FF-000285', NULL, NULL, 72, NULL, NULL, 18746),
(18747, '1.10.3430.10-FF-000018', NULL, 'Rhesus-like glycoprotein B', 422, NULL, NULL, 18747),
(18748, '3.90.1070.20-FF-000001', NULL, 'DNA-directed RNA polymerase subunit beta', 83, NULL, NULL, 18748),
(18749, '3.30.43.10-FF-000023', NULL, 'Indole-3-acetaldehyde oxidase', 60, NULL, NULL, 18749),
(18750, '1.20.1250.20-FF-000004', NULL, 'vesicular glutamate transporter 2 isoform X1', 199, NULL, NULL, 18750),
(18751, '1.10.287.4070-FF-000016', NULL, 'U4/U6-U5 snRNP complex subunit', 149, NULL, NULL, 18751),
(18752, '3.40.50.2300-FF-000111', NULL, 'Guanylate cyclase', 165, NULL, NULL, 18752),
(18753, '1.10.510.10-FF-000637', NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 64', 166, NULL, NULL, 18753),
(18754, '3.40.50.620-FF-000092', NULL, 'Isoleucine--tRNA ligase', 368, NULL, NULL, 18754),
(18755, '3.40.50.460-FF-000021', NULL, '6-phosphofructokinase type C-like', 69, NULL, NULL, 18755),
(18756, '3.30.200.20-FF-000240', NULL, 'Serine/threonine-protein kinase Nek7', 68, NULL, NULL, 18756),
(18757, '3.50.50.60-FF-001211', NULL, 'Uncharacterized protein', 353, NULL, NULL, 18757),
(18758, '2.40.10.10-FF-000022', NULL, 'Genome polyprotein', 112, NULL, NULL, 18758),
(18759, '1.10.10.10-FF-001560', NULL, 'Uncharacterized protein', 73, NULL, NULL, 18759),
(18760, '1.20.5.1160-FF-000004', NULL, 'Enah/Vasp-like, isoform CRA_a', 42, NULL, NULL, 18760),
(18761, '3.30.70.330-FF-000696', NULL, 'RNA-binding protein, putative', 95, NULL, NULL, 18761);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(18762, '3.80.10.10-FF-004054', NULL, 'Putative pre-mRNA-splicing factor ATP-dependent RNA helicase DEAH9', 136, NULL, NULL, 18762),
(18763, '3.40.50.150-FF-000872', NULL, NULL, 119, NULL, NULL, 18763),
(18764, '3.30.420.60-FF-000004', NULL, 'Protein DOM34 homolog', 134, NULL, NULL, 18764),
(18765, '3.40.50.300-FF-004593', NULL, 'Disease resistance protein (TIR-NBS class)', 161, NULL, NULL, 18765),
(18766, '2.40.160.110-FF-000019', NULL, 'LAMP family protein lmp-1', 201, NULL, NULL, 18766),
(18767, '3.30.160.60-FF-002355', NULL, 'Zinc finger protein 623', 27, NULL, NULL, 18767),
(18768, '3.10.20.870-FF-000026', NULL, NULL, 66, NULL, NULL, 18768),
(18769, '3.30.230.10-FF-000290', NULL, 'Mismatch repair endonuclease pms1', 149, NULL, NULL, 18769),
(18770, '3.30.1360.200-FF-000007', NULL, 'Protein translocase subunit SecD', 139, NULL, NULL, 18770),
(18771, '3.90.70.10-FF-000499', NULL, 'Ubiquitin specific peptidase 50', 331, NULL, NULL, 18771),
(18772, '1.25.40.10-FF-002473', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 100, NULL, NULL, 18772),
(18773, '3.40.1000.50-FF-000011', NULL, 'Maf1 regulator protein', 202, NULL, NULL, 18773),
(18774, '3.40.50.1100-FF-000240', NULL, 'Uncharacterized protein', 49, NULL, NULL, 18774),
(18775, '4.10.400.10-FF-000163', NULL, 'Complement factor I', 40, NULL, NULL, 18775),
(18776, '3.30.70.600-FF-000024', NULL, '40S ribosomal protein S20', 60, NULL, NULL, 18776),
(18777, '3.30.160.60-FF-001006', NULL, 'Uncharacterized protein', 28, NULL, NULL, 18777),
(18778, '3.40.80.10-FF-000018', NULL, 'Peptidoglycan-recognition protein LF', 140, NULL, NULL, 18778),
(18779, '1.10.30.10-FF-000111', NULL, 'Protein CBG16744', 84, NULL, NULL, 18779),
(18780, '3.10.110.10-FF-000043', NULL, 'ubiquitin-conjugating enzyme E2 J1', 183, NULL, NULL, 18780),
(18781, '1.20.1060.10-FF-000015', NULL, 'Uncharacterized protein', 147, NULL, NULL, 18781),
(18782, '1.20.1070.10-FF-000813', NULL, 'Uncharacterized protein', 303, NULL, NULL, 18782),
(18783, '3.40.50.300-FF-001075', NULL, 'ATP dependent RNA helicase, putative', 188, NULL, NULL, 18783),
(18784, '1.10.1450.10-FF-000114', NULL, 'Tetraspanin', 125, NULL, NULL, 18784),
(18785, '3.40.50.300-FF-005402', NULL, 'Predicted protein', 131, NULL, NULL, 18785),
(18786, '4.10.240.10-FF-000009', NULL, 'C6 transcription factor (Gal4)', 94, NULL, NULL, 18786),
(18787, '1.10.238.10-FF-000420', NULL, 'Ferric reductase/NADPH oxidase', 153, NULL, NULL, 18787),
(18788, '3.40.50.2300-FF-001128', NULL, NULL, 28, NULL, NULL, 18788),
(18789, '1.10.246.60-FF-000009', NULL, NULL, 75, NULL, NULL, 18789),
(18790, '1.25.40.10-FF-002085', NULL, 'Pentatricopeptide repeat-containing protein At2g41720', 180, NULL, NULL, 18790),
(18791, '1.20.1110.10-FF-000076', NULL, 'Calcium-transporting ATPase', 19, NULL, NULL, 18791),
(18792, '3.30.342.10-FF-000015', NULL, 'DNA polymerase', 151, NULL, NULL, 18792),
(18793, '1.10.287.110-FF-000029', NULL, 'DnaJ homolog subfamily C member 10', 93, NULL, NULL, 18793),
(18794, '3.30.1610.10-FF-000003', NULL, 'Nucleoporin SONB, putative', 155, NULL, NULL, 18794),
(18795, '1.10.630.10-FF-000500', NULL, 'Predicted protein', 450, NULL, NULL, 18795),
(18796, '3.40.50.300-FF-008483', NULL, 'Uncharacterized protein', 183, NULL, NULL, 18796),
(18797, '2.60.40.10-FF-001821', NULL, 'Beta-galactosidase, putative', 118, NULL, NULL, 18797),
(18798, '2.60.40.60-FF-000094', NULL, 'protocadherin gamma-C4 isoform X2', 106, NULL, NULL, 18798),
(18799, '2.60.40.10-FF-003895', NULL, NULL, 81, NULL, NULL, 18799),
(18800, '1.10.510.10-FF-000284', NULL, 'Putative receptor-like serine/threonine-protein kinase', 213, NULL, NULL, 18800),
(18801, '1.10.8.710-FF-000003', NULL, 'Dynein axonemal heavy chain 5', 108, NULL, NULL, 18801),
(18802, '2.30.42.10-FF-000158', NULL, 'PDZ domain containing 8 (Predicted)', 108, NULL, NULL, 18802),
(18803, '3.40.50.2000-FF-000347', NULL, 'Glycosyl transferase, putative', 182, NULL, NULL, 18803),
(18804, '1.10.8.10-FF-000300', NULL, 'Defective in cullin neddylation protein', 72, NULL, NULL, 18804),
(18805, '3.80.10.10-FF-003598', NULL, 'Uncharacterized protein', 275, NULL, NULL, 18805);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(18806, '2.20.130.20-FF-000004', NULL, 'PZP, alpha-2-macroglobulin like', 80, NULL, NULL, 18806),
(18807, '1.10.510.10-FF-003330', NULL, NULL, 56, NULL, NULL, 18807),
(18808, '1.10.510.10-FF-001301', NULL, 'NIMA-related kinase 4', 199, NULL, NULL, 18808),
(18809, '3.30.230.70-FF-000178', NULL, 'Uncharacterized protein', 42, NULL, NULL, 18809),
(18810, '1.25.40.20-FF-000677', NULL, 'Uncharacterized protein, isoform B', 269, NULL, NULL, 18810),
(18811, '1.25.40.10-FF-000056', NULL, 'Tetratricopeptide repeat domain 28', 135, NULL, NULL, 18811),
(18812, '3.30.710.10-FF-000489', NULL, 'Uncharacterized protein', 67, NULL, NULL, 18812),
(18813, '2.10.70.80-FF-000019', NULL, 'Sortilin', 50, NULL, NULL, 18813),
(18814, '2.110.10.10-FF-000035', NULL, 'Hypothetical_protein_-_conserved', 161, NULL, NULL, 18814),
(18815, '2.70.130.10-FF-000029', NULL, 'uncharacterized protein LOC100184158', 141, NULL, NULL, 18815),
(18816, '3.40.50.720-FF-001026', NULL, 'Gfo/Idh/MocA family oxidoreductase', 133, NULL, NULL, 18816),
(18817, '3.30.40.10-FF-001882', NULL, 'E3 ubiquitin-protein ligase complex slx8-rfp subunit slx8', 113, NULL, NULL, 18817),
(18818, '1.10.720.40-FF-000005', NULL, 'Emerin', 34, NULL, NULL, 18818),
(18819, '3.30.160.60-FF-004772', NULL, NULL, 79, NULL, NULL, 18819),
(18820, '1.20.140.150-FF-000066', NULL, 'Claudin', 192, NULL, NULL, 18820),
(18821, '1.10.238.260-FF-000003', NULL, '2-isopropylmalate synthase 1 chloroplastic', 114, NULL, NULL, 18821),
(18822, '3.40.390.10-FF-000287', NULL, NULL, 103, NULL, NULL, 18822),
(18823, '3.90.70.10-FF-000583', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 298, NULL, NULL, 18823),
(18824, '1.20.1260.10-FF-000064', NULL, 'Ferritin', 132, NULL, NULL, 18824),
(18825, '2.40.10.10-FF-000230', NULL, 'Serine protease 53', 88, NULL, NULL, 18825),
(18826, '3.40.20.10-FF-000110', NULL, 'Scinderin like a', 119, NULL, NULL, 18826),
(18827, '3.30.160.60-FF-006088', NULL, NULL, 26, NULL, NULL, 18827),
(18828, '4.10.280.10-FF-000074', NULL, 'Transcription factor ORG2', 86, NULL, NULL, 18828),
(18829, '2.10.25.10-FF-000759', NULL, 'Neurogenic locus notch homolog protein 3', 44, NULL, NULL, 18829),
(18830, '1.25.10.10-FF-001740', NULL, 'Uncharacterized protein', 173, NULL, NULL, 18830),
(18831, '6.10.140.2220-FF-000039', NULL, 'Uncharacterized protein, isoform B', 51, NULL, NULL, 18831),
(18832, '3.90.230.10-FF-000068', NULL, NULL, 70, NULL, NULL, 18832),
(18833, '3.80.10.10-FF-001468', NULL, 'Connectin, isoform B', 174, NULL, NULL, 18833),
(18834, '1.20.5.190-FF-000047', NULL, 'Myosin-VIIa', 50, NULL, NULL, 18834),
(18835, '3.30.200.20-FF-002038', NULL, 'Inhibitor of nuclear factor kappa-B kinase epsilon subunit homolog 1', 90, NULL, NULL, 18835),
(18836, '2.10.25.10-FF-001491', NULL, 'Uncharacterized protein', 36, NULL, NULL, 18836),
(18837, '3.40.640.10-FF-000060', NULL, 'Serine hydroxymethyltransferase', 176, NULL, NULL, 18837),
(18838, '2.130.10.10-FF-002350', NULL, 'Putative WD-repeat family protein', 194, NULL, NULL, 18838),
(18839, '3.40.190.10-FF-000367', NULL, 'Serotransferrin', 153, NULL, NULL, 18839),
(18840, '3.30.1520.10-FF-000108', NULL, 'Sorting nexin 7', 134, NULL, NULL, 18840),
(18841, '2.60.40.10-FF-004171', NULL, NULL, 87, NULL, NULL, 18841),
(18842, '3.80.10.10-FF-000243', NULL, 'NLR family CARD domain containing 3', 110, NULL, NULL, 18842),
(18843, '3.40.50.2000-FF-000291', NULL, 'Glycosyltransferase', 132, NULL, NULL, 18843),
(18844, '2.40.30.300-FF-000001', NULL, 'Mtr4 exosome RNA helicase', 121, NULL, NULL, 18844),
(18845, '3.40.1110.10-FF-000468', NULL, NULL, 86, NULL, NULL, 18845),
(18846, '2.30.29.30-FF-001184', NULL, 'YL1 nuclear protein Cterminal domain-containing protein', 112, NULL, NULL, 18846),
(18847, '1.10.10.60-FF-000653', NULL, 'GARP-like protein 2', 64, NULL, NULL, 18847),
(18848, '2.60.40.10-FF-003266', NULL, 'GM10182', 104, NULL, NULL, 18848),
(18849, '2.30.29.30-FF-000083', NULL, 'Pleckstrin homology domain-containing family A member 5', 116, NULL, NULL, 18849),
(18850, '3.30.70.270-FF-000088', NULL, 'GGDEF family protein', 173, NULL, NULL, 18850);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(18851, '1.10.486.10-FF-000029', NULL, 'PROBABLE ATP-DEPENDENT DNA HELICASE', 177, NULL, NULL, 18851),
(18852, '3.40.50.1000-FF-000709', NULL, NULL, 101, NULL, NULL, 18852),
(18853, '2.40.20.10-FF-000056', NULL, 'Uncharacterized protein', 119, NULL, NULL, 18853),
(18854, '3.40.50.300-FF-001979', NULL, '6-phosphofructo-2-kinase/fructose-2,6-bisphosphatase', 216, NULL, NULL, 18854),
(18855, '3.40.50.12780-FF-000117', NULL, 'Acyl-CoA synthetase medium chain family member 5', 165, NULL, NULL, 18855),
(18856, '3.10.250.10-FF-000109', NULL, NULL, 103, NULL, NULL, 18856),
(18857, '1.20.1560.10-FF-000216', NULL, 'HAlF transporter (PGP related)', 272, NULL, NULL, 18857),
(18858, '3.30.420.10-FF-000742', NULL, NULL, 152, NULL, NULL, 18858),
(18859, '2.160.20.10-FF-000247', NULL, 'Os04g0513301 protein', 107, NULL, NULL, 18859),
(18860, '3.40.50.720-FF-001369', NULL, 'UDP-galactopyranose mutase Glf', 103, NULL, NULL, 18860),
(18861, '1.25.10.10-FF-002437', NULL, 'Uncharacterized protein', 239, NULL, NULL, 18861),
(18862, '1.10.418.40-FF-000016', NULL, 'Uncharacterized protein', 237, NULL, NULL, 18862),
(18863, '2.60.40.10-FF-000461', NULL, 'Sortilin related receptor 1', 91, NULL, NULL, 18863),
(18864, '3.30.1240.10-FF-000014', NULL, 'Cof-type HAD-IIB family hydrolase', 107, NULL, NULL, 18864),
(18865, '3.30.428.70-FF-000002', NULL, 'Uncharacterized protein', 347, NULL, NULL, 18865),
(18866, '1.20.58.2220-FF-000064', NULL, 'Formin-C', 387, NULL, NULL, 18866),
(18867, '2.60.40.1170-FF-000032', NULL, 'AP-1 complex subunit mu-1', 102, NULL, NULL, 18867),
(18868, '3.30.2130.30-FF-000017', NULL, 'Predicted protein', 93, NULL, NULL, 18868),
(18869, '2.60.40.60-FF-001111', NULL, 'Novel protein similar to human procadherin 15 (PCDH15)', 63, NULL, NULL, 18869),
(18870, '3.50.50.60-FF-000582', NULL, 'Probable lysine-specific histone demethylase 1', 129, NULL, NULL, 18870),
(18871, '2.70.170.10-FF-000094', NULL, 'Uncharacterized protein', 162, NULL, NULL, 18871),
(18872, '1.25.40.990-FF-000047', NULL, 'Protein xmas-2-like Protein', 292, NULL, NULL, 18872),
(18873, '1.25.40.10-FF-000617', NULL, 'UTP6, small subunit processome component', 195, NULL, NULL, 18873),
(18874, '1.20.120.350-FF-000206', NULL, NULL, 114, NULL, NULL, 18874),
(18875, '3.40.50.1820-FF-001462', NULL, 'Uncharacterized protein', 179, NULL, NULL, 18875),
(18876, '1.10.3650.10-FF-000001', NULL, 'Respiratory nitrate reductase subunit beta', 74, NULL, NULL, 18876),
(18877, '2.130.10.130-FF-000008', NULL, 'Integrin subunit alpha 2', 296, NULL, NULL, 18877),
(18878, '2.60.40.10-FF-002485', NULL, 'AGAP004902-PA-like protein', 101, NULL, NULL, 18878),
(18879, '3.40.190.10-FF-000631', NULL, 'Transcriptional regulator, LysR family', 108, NULL, NULL, 18879),
(18880, '2.60.40.10-FF-005132', NULL, NULL, 96, NULL, NULL, 18880),
(18881, '3.30.260.10-FF-000027', NULL, 'T-complex protein 1 subunit theta-like 2', 103, NULL, NULL, 18881),
(18882, '1.10.760.10-FF-000116', NULL, 'Diheme cytochrome c SoxD', 137, NULL, NULL, 18882),
(18883, '1.25.40.10-FF-000399', NULL, 'TPR-repeat-containing chaperone protein DNAJ', 116, NULL, NULL, 18883),
(18884, '3.40.850.10-FF-000103', NULL, 'Kinesin-like protein KIN-14A', 385, NULL, NULL, 18884),
(18885, '1.10.20.10-FF-000217', NULL, NULL, 141, NULL, NULL, 18885),
(18886, '1.10.418.20-FF-000010', NULL, 'sentrin-specific protease 6 isoform X2', 43, NULL, NULL, 18886),
(18887, '3.30.360.10-FF-000012', NULL, 'Aspartate-semialdehyde dehydrogenase', 216, NULL, NULL, 18887),
(18888, '1.10.630.10-FF-000635', NULL, 'Uncharacterized protein', 225, NULL, NULL, 18888),
(18889, '1.25.40.10-FF-003102', NULL, 'Uncharacterized protein', 88, NULL, NULL, 18889),
(18890, '1.25.10.10-FF-000228', NULL, 'armadillo repeat-containing protein 6 isoform X1', 189, NULL, NULL, 18890),
(18891, '3.40.30.10-FF-000015', NULL, 'NADH-quinone oxidoreductase subunit E', 83, NULL, NULL, 18891),
(18892, '3.30.200.20-FF-001818', NULL, NULL, 63, NULL, NULL, 18892),
(18893, '1.20.1250.20-FF-000448', NULL, 'Major facilitator superfamily domain containing 4B', 189, NULL, NULL, 18893);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(18894, '3.10.450.50-FF-000081', NULL, 'calcium/calmodulin-dependent protein kinase type II delta chain', 137, NULL, NULL, 18894),
(18895, '3.30.160.60-FF-002434', NULL, 'Zinc finger protein 1168', 28, NULL, NULL, 18895),
(18896, '3.40.630.30-FF-000621', NULL, 'Long-chain N-acyl amino acid synthase', 185, NULL, NULL, 18896),
(18897, '2.60.40.2380-FF-000001', NULL, '7TM diverse intracellular signaling', 138, NULL, NULL, 18897),
(18898, '1.20.1270.60-FF-000091', NULL, 'Sorting nexin 1', 223, NULL, NULL, 18898),
(18899, '1.10.3470.10-FF-000015', NULL, 'Zinc ABC transporter permease', 230, NULL, NULL, 18899),
(18900, '3.20.100.10-FF-000012', NULL, 'Uncharacterized protein', 215, NULL, NULL, 18900),
(18901, '3.40.50.150-FF-001102', NULL, NULL, 147, NULL, NULL, 18901),
(18902, '3.90.1030.20-FF-000004', NULL, 'DNA polymerase delta subunit 3', 143, NULL, NULL, 18902),
(18903, '1.25.40.10-FF-002826', NULL, 'Os02g0680500 protein', 145, NULL, NULL, 18903),
(18904, '3.90.1180.10-FF-000034', NULL, NULL, 111, NULL, NULL, 18904),
(18905, '2.130.10.110-FF-000002', NULL, 'Clathrin heavy chain', 377, NULL, NULL, 18905),
(18906, '1.10.10.60-FF-000389', NULL, 'Transcriptional regulator, AraC family', 42, NULL, NULL, 18906),
(18907, '3.40.50.300-FF-008140', NULL, 'Probable serine/threonine-protein kinase roco5', 98, NULL, NULL, 18907),
(18908, '1.10.238.10-FF-000763', NULL, 'N-terminal EF-hand calcium binding protein 2', 58, NULL, NULL, 18908),
(18909, '1.10.10.440-FF-000083', NULL, 'Uncharacterized protein', 73, NULL, NULL, 18909),
(18910, '3.30.160.60-FF-005868', NULL, NULL, 51, NULL, NULL, 18910),
(18911, '1.20.1540.10-FF-000041', NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', 235, NULL, NULL, 18911),
(18912, '1.20.1240.10-FF-000001', NULL, 'Photosystem I reaction center subunit XI', 164, NULL, NULL, 18912),
(18913, '3.40.50.300-FF-006307', NULL, 'Uncharacterized protein', 151, NULL, NULL, 18913),
(18914, '3.40.140.20-FF-000013', NULL, NULL, 64, NULL, NULL, 18914),
(18915, '2.30.40.10-FF-000108', NULL, 'Uncharacterized protein', 52, NULL, NULL, 18915),
(18916, '1.10.238.10-FF-001201', NULL, 'Uncharacterized protein', 77, NULL, NULL, 18916),
(18917, '3.90.550.10-FF-000204', NULL, 'Hyaluronan synthase 1', 243, NULL, NULL, 18917),
(18918, '1.20.5.340-FF-000114', NULL, 'Uncharacterized protein', 90, NULL, NULL, 18918),
(18919, '1.20.1070.10-FF-000252', NULL, 'Adhesion G protein-coupled receptor D2', 280, NULL, NULL, 18919),
(18920, '2.40.30.10-FF-000473', NULL, 'Uncharacterized protein', 59, NULL, NULL, 18920),
(18921, '2.60.120.260-FF-000332', NULL, 'Uncharacterized protein', 145, NULL, NULL, 18921),
(18922, '1.20.1250.20-FF-001696', NULL, 'Predicted protein', 239, NULL, NULL, 18922),
(18923, '2.40.70.10-FF-000391', NULL, 'Uncharacterized protein', 255, NULL, NULL, 18923),
(18924, '1.25.40.1030-FF-000045', NULL, 'Uncharacterized protein', 265, NULL, NULL, 18924),
(18925, '3.60.21.10-FF-000471', NULL, 'Serine/threonine-protein phosphatase', 63, NULL, NULL, 18925),
(18926, '2.40.50.140-FF-000822', NULL, NULL, 108, NULL, NULL, 18926),
(18927, '3.90.1150.10-FF-000274', NULL, 'Predicted protein', 114, NULL, NULL, 18927),
(18928, '2.60.260.20-FF-000128', NULL, 'AGAP005908-PA', 52, NULL, NULL, 18928),
(18929, '3.30.70.890-FF-000066', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 124, NULL, NULL, 18929),
(18930, '2.130.10.10-FF-002530', NULL, 'Uncharacterized protein', 227, NULL, NULL, 18930),
(18931, '2.60.120.330-FF-000191', NULL, 'Uncharacterized protein', 175, NULL, NULL, 18931),
(18932, '3.90.105.10-FF-000024', NULL, 'Molybdenum cofactor synthesis protein cinnamon', 40, NULL, NULL, 18932),
(18933, '3.10.20.90-FF-000854', NULL, 'Nuclear protein localization protein 4', 78, NULL, NULL, 18933),
(18934, '3.20.20.60-FF-000002', NULL, 'Pyruvate kinase', 240, NULL, NULL, 18934),
(18935, '1.10.510.10-FF-002493', NULL, NULL, 118, NULL, NULL, 18935),
(18936, '2.130.10.10-FF-005964', NULL, 'Predicted protein', 243, NULL, NULL, 18936),
(18937, '2.60.34.10-FF-000008', NULL, 'Stromal 70 kDa heat shock-related protein', 126, NULL, NULL, 18937);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(18938, '3.60.21.10-FF-000139', NULL, 'SA0140 protein', 302, NULL, NULL, 18938),
(18939, '3.30.420.40-FF-000902', NULL, 'Uncharacterized protein', 89, NULL, NULL, 18939),
(18940, '2.40.70.10-FF-000239', NULL, 'Related to aspartyl proteinase SAP3', 205, NULL, NULL, 18940),
(18941, '3.30.160.60-FF-006306', NULL, NULL, 30, NULL, NULL, 18941),
(18942, '3.30.160.60-FF-000225', NULL, 'zinc finger and BTB domain-containing protein 17 isoform X2', 28, NULL, NULL, 18942),
(18943, '1.20.5.170-FF-000221', NULL, 'Transcription factor AP-1', 39, NULL, NULL, 18943),
(18944, '3.40.390.10-FF-000023', NULL, 'Matrix metalloproteinase-14 preproprotein', 179, NULL, NULL, 18944),
(18945, '3.30.230.70-FF-000054', NULL, 'Exosome complex component RRP46', 210, NULL, NULL, 18945),
(18946, '1.25.10.10-FF-001476', NULL, 'HEAT repeat protein', 294, NULL, NULL, 18946),
(18947, '3.50.50.60-FF-000879', NULL, 'Salicylate hydroxylase, putative (AFU_orthologue AFUA_8G06050)', 363, NULL, NULL, 18947),
(18948, '1.20.1280.50-FF-000116', NULL, 'SCF ubiquitin ligase complex subunit', 107, NULL, NULL, 18948),
(18949, '3.60.15.10-FF-000165', NULL, 'Uncharacterized protein', 29, NULL, NULL, 18949),
(18950, '3.30.200.20-FF-000560', NULL, 'Receptor like protein kinase S.2', 117, NULL, NULL, 18950),
(18951, '3.10.380.10-FF-000001', NULL, 'Colicin-E3', 98, NULL, NULL, 18951),
(18952, '2.60.40.10-FF-000129', NULL, 'CLUMA_CG018772, isoform A', 110, NULL, NULL, 18952),
(18953, '3.40.30.10-FF-000279', NULL, 'Thioredoxin-like protein 1', 120, NULL, NULL, 18953),
(18954, '1.25.40.20-FF-001514', NULL, 'Uncharacterized protein', 96, NULL, NULL, 18954),
(18955, '3.20.20.190-FF-000011', NULL, 'Glycerophosphodiester phosphodiesterase GDPDL3', 303, NULL, NULL, 18955),
(18956, '3.30.40.10-FF-000505', NULL, 'NEP1-interacting protein-like 1', 86, NULL, NULL, 18956),
(18957, '3.40.50.300-FF-001636', NULL, 'Ribosome-releasing factor 2, mitochondrial', 304, NULL, NULL, 18957),
(18958, '3.30.70.330-FF-001477', NULL, 'FOG-1 protein', 112, NULL, NULL, 18958),
(18959, '3.40.50.2300-FF-000431', NULL, 'Sensor histidine kinase', 127, NULL, NULL, 18959),
(18960, '2.60.40.420-FF-000141', NULL, 'Spore coat protein A', 181, NULL, NULL, 18960),
(18961, '2.30.39.10-FF-000015', NULL, 'Serpin family G member 1', 182, NULL, NULL, 18961),
(18962, '2.30.30.30-FF-000029', NULL, 'Transcription elongation factor SPT5', 52, NULL, NULL, 18962),
(18963, '2.130.10.10-FF-000321', NULL, 'DDB1- and CUL4-associated factor 10', 183, NULL, NULL, 18963),
(18964, '3.80.10.10-FF-003334', NULL, 'Si:dkey-286j17.4', 123, NULL, NULL, 18964),
(18965, '3.20.20.80-FF-000160', NULL, 'Probable beta-glucosidase btgE', 139, NULL, NULL, 18965),
(18966, '3.20.20.70-FF-000623', NULL, NULL, 297, NULL, NULL, 18966),
(18967, '3.30.70.330-FF-002837', NULL, NULL, 174, NULL, NULL, 18967),
(18968, '3.40.630.40-FF-000006', NULL, 'Amidase', 189, NULL, NULL, 18968),
(18969, '2.30.30.40-FF-000089', NULL, 'SH3 domain-containing kinase-binding protein 1', 67, NULL, NULL, 18969),
(18970, '1.20.58.760-FF-000004', NULL, 'paraplegin isoform X1', 186, NULL, NULL, 18970),
(18971, '1.10.10.60-FF-000310', NULL, 'MYB transcription factor', 75, NULL, NULL, 18971),
(18972, '3.40.250.10-FF-000125', NULL, 'Uncharacterized protein', 100, NULL, NULL, 18972),
(18973, '3.30.830.10-FF-000200', NULL, 'Metalloprotease, insulinase family', 239, NULL, NULL, 18973),
(18974, '1.10.10.10-FF-000840', NULL, 'Cul3p', 90, NULL, NULL, 18974),
(18975, '1.20.1070.10-FF-001477', NULL, 'Opsin (Rh7-like sensitive)', 208, NULL, NULL, 18975),
(18976, '3.40.309.10-FF-000054', NULL, 'Carnitine dehydratase', 191, NULL, NULL, 18976),
(18977, '1.10.238.10-FF-000532', NULL, 'CALB1 isoform 1', 87, NULL, NULL, 18977),
(18978, '2.40.160.10-FF-000009', NULL, 'Mitochondrial import receptor subunit TOM40', 297, NULL, NULL, 18978),
(18979, '1.20.1560.10-FF-000896', NULL, 'Os04g0481700 protein', 254, NULL, NULL, 18979),
(18980, '3.80.10.10-FF-004402', NULL, 'Uncharacterized protein', 102, NULL, NULL, 18980),
(18981, '2.20.110.10-FF-000056', NULL, NULL, 57, NULL, NULL, 18981);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(18982, '2.130.10.10-FF-003811', NULL, 'Uncharacterized protein', 308, NULL, NULL, 18982),
(18983, '2.60.40.10-FF-005868', NULL, NULL, 92, NULL, NULL, 18983),
(18984, '1.10.4160.10-FF-000031', NULL, 'NCS1 nucleoside transporter family', 456, NULL, NULL, 18984),
(18985, '2.60.40.10-FF-005924', NULL, NULL, 106, NULL, NULL, 18985),
(18986, '2.10.25.10-FF-000698', NULL, 'Blast:Prolow-density lipoprotein receptor-related protein 1', 44, NULL, NULL, 18986),
(18987, '1.25.40.10-FF-003602', NULL, 'Uncharacterized protein', 130, NULL, NULL, 18987),
(18988, '1.10.287.550-FF-000021', NULL, 'Predicted protein', 57, NULL, NULL, 18988),
(18989, '3.40.50.300-FF-005234', NULL, 'Uncharacterized protein', 200, NULL, NULL, 18989),
(18990, '3.10.580.10-FF-000089', NULL, 'Chloride channel protein', 124, NULL, NULL, 18990),
(18991, '2.30.30.40-FF-000307', NULL, 'Predicted protein', 74, NULL, NULL, 18991),
(18992, '1.20.1560.10-FF-000952', NULL, 'Uncharacterized protein', 41, NULL, NULL, 18992),
(18993, '1.20.1250.10-FF-000119', NULL, NULL, 147, NULL, NULL, 18993),
(18994, '1.20.1720.10-FF-000083', NULL, NULL, 228, NULL, NULL, 18994),
(18995, '1.10.238.10-FF-000476', NULL, 'Polcalcin Jun o 2', 80, NULL, NULL, 18995),
(18996, '1.20.1050.10-FF-000290', NULL, 'Uncharacterized protein', 55, NULL, NULL, 18996),
(18997, '1.20.140.150-FF-000089', NULL, 'Uncharacterized protein', 164, NULL, NULL, 18997),
(18998, '3.30.160.60-FF-002703', NULL, 'Zinc finger protein 790', 91, NULL, NULL, 18998),
(18999, '1.25.40.10-FF-004114', NULL, 'Uncharacterized protein', 135, NULL, NULL, 18999),
(19000, '2.60.40.1730-FF-000003', NULL, 'Transcription initiation factor TFIID subunit 2', 228, NULL, NULL, 19000),
(19001, '2.30.29.30-FF-000352', NULL, 'FACT complex subunit SSRP1', 110, NULL, NULL, 19001),
(19002, '3.30.590.10-FF-000052', NULL, 'Predicted protein', 178, NULL, NULL, 19002),
(19003, '1.20.1310.10-FF-000214', NULL, NULL, 86, NULL, NULL, 19003),
(19004, '3.40.50.970-FF-000230', NULL, 'Uncharacterized protein', 112, NULL, NULL, 19004),
(19005, '3.80.10.10-FF-003834', NULL, 'F-box and leucine rich repeat protein 14', 59, NULL, NULL, 19005),
(19006, '3.60.40.10-FF-000122', NULL, 'Adenylate cyclase (ATP pyrophosphate-lyase), putative', 275, NULL, NULL, 19006),
(19007, '3.40.50.970-FF-000174', NULL, 'Predicted protein', 198, NULL, NULL, 19007),
(19008, '3.30.160.60-FF-003215', NULL, 'Transcriptional regulator, putative', 29, NULL, NULL, 19008),
(19009, '1.25.40.10-FF-000792', NULL, 'tetratricopeptide repeat protein 28', 159, NULL, NULL, 19009),
(19010, '3.30.1050.10-FF-000027', NULL, 'Alkyl/aryl-sulfatase BDS1', 129, NULL, NULL, 19010),
(19011, '1.25.40.10-FF-004058', NULL, 'Glr1376 protein', 144, NULL, NULL, 19011),
(19012, '1.20.80.10-FF-000024', NULL, 'acyl-CoA-binding domain-containing protein 4 isoform X1', 109, NULL, NULL, 19012),
(19013, '2.60.120.200-FF-000005', NULL, 'neurexin-1 isoform X1', 195, NULL, NULL, 19013),
(19014, '1.10.10.10-FF-001801', NULL, 'Selenocysteine-specific translation elongation factor', 59, NULL, NULL, 19014),
(19015, '3.30.40.10-FF-000426', NULL, 'DMA1p Ubiquitin-protein ligase (E3)', 77, NULL, NULL, 19015),
(19016, '2.120.10.30-FF-000288', NULL, 'E3 ubiquitin-protein ligase TRIM71', 95, NULL, NULL, 19016),
(19017, '1.10.10.10-FF-001796', NULL, 'Uncharacterized protein', 39, NULL, NULL, 19017),
(19018, '1.10.238.10-FF-001044', NULL, 'Uncharacterized protein', 43, NULL, NULL, 19018),
(19019, '1.10.10.820-FF-000017', NULL, 'Myosin C', 38, NULL, NULL, 19019),
(19020, '2.130.10.10-FF-004323', NULL, 'Uncharacterized protein', 106, NULL, NULL, 19020),
(19021, '3.40.50.2000-FF-000459', NULL, 'Protein CBR-UGT-59', 173, NULL, NULL, 19021),
(19022, '1.25.40.10-FF-003546', NULL, 'Uncharacterized protein', 438, NULL, NULL, 19022),
(19023, '3.40.50.1820-FF-001523', NULL, 'Uncharacterized protein', 147, NULL, NULL, 19023),
(19024, '3.40.50.150-FF-000085', NULL, 'Anamorsin homolog', 173, NULL, NULL, 19024),
(19025, '2.10.25.10-FF-000703', NULL, 'Delta/notch like EGF repeat containing', 42, NULL, NULL, 19025),
(19026, '1.25.10.10-FF-000964', NULL, 'Apoptosis inhibitory protein', 119, NULL, NULL, 19026);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(19027, '1.10.287.110-FF-000024', NULL, 'DnaJ (Hsp40) homolog, subfamily C, member 2', 113, NULL, NULL, 19027),
(19028, '3.30.457.60-FF-000015', NULL, 'Uncharacterized protein', 82, NULL, NULL, 19028),
(19029, '2.30.29.30-FF-000307', NULL, 'Beta-1-syntrophin isoform 1', 131, NULL, NULL, 19029),
(19030, '2.60.40.10-FF-002198', NULL, 'Immunoglobulin heavy variable 5-2', 101, NULL, NULL, 19030),
(19031, '3.40.50.11840-FF-000021', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', 39, NULL, NULL, 19031),
(19032, '3.10.20.90-FF-000298', NULL, 'BAG family molecular chaperone regulator 1', 72, NULL, NULL, 19032),
(19033, '1.10.510.10-FF-001981', NULL, 'Kinase, NEK', 222, NULL, NULL, 19033),
(19034, '3.30.70.1450-FF-000004', NULL, 'Putative transport protein YidE', 77, NULL, NULL, 19034),
(19035, '3.40.30.10-FF-000690', NULL, 'Protein disulfide-isomerase-like Protein', 132, NULL, NULL, 19035),
(19036, '3.40.50.720-FF-000060', NULL, 'Malic enzyme', 300, NULL, NULL, 19036),
(19037, '2.60.40.10-FF-002254', NULL, 'Uncharacterized protein', 101, NULL, NULL, 19037),
(19038, '3.10.20.90-FF-000354', NULL, 'Homocysteine-responsive endoplasmic reticulum-resident ubiquitin-like domain member 2 protein', 47, NULL, NULL, 19038),
(19039, '3.30.70.1230-FF-000225', NULL, 'AGAP012805-PA', 48, NULL, NULL, 19039),
(19040, '3.40.630.150-FF-000025', NULL, 'Uncharacterized protein', 107, NULL, NULL, 19040),
(19041, '3.40.630.30-FF-000385', NULL, 'N-acetyltransferase, putative', 136, NULL, NULL, 19041),
(19042, '3.40.50.1970-FF-000023', NULL, '3-dehydroquinate synthase', 177, NULL, NULL, 19042),
(19043, '3.90.780.10-FF-000036', NULL, '5'' nucleotidase family protein', 198, NULL, NULL, 19043),
(19044, '1.25.10.10-FF-002414', NULL, 'Uncharacterized protein', 252, NULL, NULL, 19044),
(19045, '2.120.10.30-FF-000237', NULL, 'Uncharacterized protein', 127, NULL, NULL, 19045),
(19046, '3.30.160.60-FF-005520', NULL, NULL, 36, NULL, NULL, 19046),
(19047, '3.40.50.2000-FF-000408', NULL, 'Glycosyltransferase family 1 protein', 160, NULL, NULL, 19047),
(19048, '3.40.50.740-FF-000048', NULL, 'NADPH-Fe(3+) oxidoreductase subunit alpha', 235, NULL, NULL, 19048),
(19049, '3.30.519.10-FF-000038', NULL, NULL, 141, NULL, NULL, 19049),
(19050, '3.30.420.40-FF-000285', NULL, 'Pantothenate kinase, putative', 149, NULL, NULL, 19050),
(19051, '3.90.640.10-FF-000150', NULL, 'Actin', 55, NULL, NULL, 19051),
(19052, '2.130.10.10-FF-003070', NULL, 'WD repeat-containing protein 46 isoform 1', 127, NULL, NULL, 19052),
(19053, '3.90.550.50-FF-000025', NULL, 'Hexosyltransferase', 224, NULL, NULL, 19053),
(19054, '3.30.160.20-FF-000180', NULL, 'Predicted protein', 85, NULL, NULL, 19054),
(19055, '3.40.50.1820-FF-001467', NULL, 'Uncharacterized protein', 178, NULL, NULL, 19055),
(19056, '2.60.40.150-FF-000717', NULL, 'Uncharacterized protein', 131, NULL, NULL, 19056),
(19057, '1.20.1280.50-FF-000167', NULL, 'F-box domain protein (AFU_orthologue AFUA_3G00440)', 78, NULL, NULL, 19057),
(19058, '1.10.8.460-FF-000001', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 65, NULL, NULL, 19058),
(19059, '3.40.50.1820-FF-000181', NULL, 'valacyclovir hydrolase isoform X2', 253, NULL, NULL, 19059),
(19060, '2.60.40.10-FF-005183', NULL, NULL, 93, NULL, NULL, 19060),
(19061, '3.40.50.2300-FF-000454', NULL, 'Putative chemotaxis protein CheV', 140, NULL, NULL, 19061),
(19062, '1.20.5.1200-FF-000005', NULL, 'Alpha-tocopherol transfer protein-like protein', 39, NULL, NULL, 19062),
(19063, '2.120.10.30-FF-000344', NULL, 'Uncharacterized protein', 138, NULL, NULL, 19063),
(19064, '2.40.160.10-FF-000072', NULL, 'Predicted protein', 330, NULL, NULL, 19064),
(19065, '3.40.50.2000-FF-000515', NULL, 'Glycosyl transferase', 169, NULL, NULL, 19065),
(19066, '1.20.5.1160-FF-000027', NULL, 'Lamin, isoform B', 87, NULL, NULL, 19066),
(19067, '3.40.50.1440-FF-000100', NULL, 'Iota_tubulin,putative', 346, NULL, NULL, 19067),
(19068, '3.30.160.60-FF-002698', NULL, 'Zinc finger protein 985', 29, NULL, NULL, 19068),
(19069, '3.30.160.60-FF-003159', NULL, 'FI06716p', 48, NULL, NULL, 19069);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(19070, '3.80.10.10-FF-001529', NULL, 'Slit guidance ligand 1', 175, NULL, NULL, 19070),
(19071, '1.20.1250.20-FF-000504', NULL, 'Similar to MFS multidrug transporter', 215, NULL, NULL, 19071),
(19072, '3.30.465.10-FF-000036', NULL, 'Putative FAD-linked oxidoreductase', 220, NULL, NULL, 19072),
(19073, '1.20.1640.10-FF-000082', NULL, 'Protein patched', 199, NULL, NULL, 19073),
(19074, '3.40.630.10-FF-000227', NULL, 'Uncharacterized protein', 76, NULL, NULL, 19074),
(19075, '1.20.1740.10-FF-000090', NULL, 'Solute carrier family 12 member 7', 369, NULL, NULL, 19075),
(19076, '2.130.10.10-FF-000956', NULL, 'CPSF (Cleavage and polyadenylation specific factor)', 292, NULL, NULL, 19076),
(19077, '2.130.10.10-FF-004267', NULL, 'Uncharacterized protein', 134, NULL, NULL, 19077),
(19078, '3.90.1140.10-FF-000037', NULL, 'DUF455 domain-containing protein', 128, NULL, NULL, 19078),
(19079, '1.10.565.10-FF-000039', NULL, 'Nuclear receptor subfamily 1, group D, member 4b', 257, NULL, NULL, 19079),
(19080, '2.60.200.20-FF-000124', NULL, 'Protein kinase, putative', 112, NULL, NULL, 19080),
(19081, '3.30.230.130-FF-000043', NULL, 'Cullin-4', 177, NULL, NULL, 19081),
(19082, '3.90.550.10-FF-000209', NULL, 'Unplaced genomic scaffold supercont1.20, whole genome shotgun sequence', 219, NULL, NULL, 19082),
(19083, '3.30.1010.10-FF-000025', NULL, 'PIKK family atypical protein kinase', 155, NULL, NULL, 19083),
(19084, '3.30.200.20-FF-001577', NULL, NULL, 45, NULL, NULL, 19084),
(19085, '1.10.287.70-FF-000551', NULL, 'Probable cyclic nucleotide-gated ion channel 12', 245, NULL, NULL, 19085),
(19086, '3.40.50.300-FF-002468', NULL, 'Suppressor of ascus dominance 3', 164, NULL, NULL, 19086),
(19087, '2.130.10.10-FF-005784', NULL, 'Transducin family protein / WD-40 repeat family protein', 101, NULL, NULL, 19087),
(19088, '3.90.660.10-FF-000089', NULL, NULL, 99, NULL, NULL, 19088),
(19089, '3.30.60.60-FF-000015', NULL, 'Histone acetyltransferase', 61, NULL, NULL, 19089),
(19090, '3.30.710.10-FF-000438', NULL, 'Uncharacterized protein', 180, NULL, NULL, 19090),
(19091, '1.10.510.10-FF-003886', NULL, NULL, 89, NULL, NULL, 19091),
(19092, '1.10.150.20-FF-000303', NULL, 'Uncharacterized protein', 68, NULL, NULL, 19092),
(19093, '3.40.109.10-FF-000050', NULL, 'Nitroreductase NfnB', 230, NULL, NULL, 19093),
(19094, '1.25.40.10-FF-001129', NULL, 'RNA polymerase-associated protein CTR9, putative', 364, NULL, NULL, 19094),
(19095, '1.10.12.10-FF-000002', NULL, '1,4-dihydroxy-2-naphthoyl-CoA synthase', 37, NULL, NULL, 19095),
(19096, '3.30.1330.10-FF-000009', NULL, 'Probable phosphoribosylformylglycinamidine synthase', 206, NULL, NULL, 19096),
(19097, '3.30.70.1450-FF-000055', NULL, 'Uncharacterized protein', 72, NULL, NULL, 19097),
(19098, '1.10.10.10-FF-001060', NULL, 'Cullin family protein', 59, NULL, NULL, 19098),
(19099, '2.30.42.10-FF-000219', NULL, 'Uncharacterized protein, isoform C', 103, NULL, NULL, 19099),
(19100, '3.30.70.330-FF-001713', NULL, NULL, 125, NULL, NULL, 19100),
(19101, '3.20.20.140-FF-000485', NULL, '2-amino-3-carboxymuconate-6-semialdehyde decarboxylase', 56, NULL, NULL, 19101),
(19102, '3.30.870.10-FF-000034', NULL, 'Phospholipase', 169, NULL, NULL, 19102),
(19103, '1.10.510.10-FF-004050', NULL, NULL, 54, NULL, NULL, 19103),
(19104, '3.40.50.620-FF-000653', NULL, 'Predicted protein', 107, NULL, NULL, 19104),
(19105, '3.50.50.60-FF-000986', NULL, 'Flavin-containing monooxygenase', 64, NULL, NULL, 19105),
(19106, '2.130.10.10-FF-001338', NULL, 'U3 small nucleolar RNA-associated protein 5', 266, NULL, NULL, 19106),
(19107, '3.40.50.720-FF-000857', NULL, 'Ubiquitin-activating enzyme', 198, NULL, NULL, 19107),
(19108, '3.30.70.330-FF-001769', NULL, NULL, 140, NULL, NULL, 19108),
(19109, '3.30.160.60-FF-006065', NULL, NULL, 60, NULL, NULL, 19109),
(19110, '1.25.40.10-FF-004906', NULL, 'Putative pentatricopeptide repeat family protein', 75, NULL, NULL, 19110),
(19111, '1.20.200.10-FF-000033', NULL, 'Predicted protein', 128, NULL, NULL, 19111),
(19112, '3.40.50.1440-FF-000044', NULL, 'Tubulin alpha chain', 353, NULL, NULL, 19112);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(19113, '3.30.70.1660-FF-000005', NULL, 'Peptide chain release factor 1', 137, NULL, NULL, 19113),
(19114, '3.30.70.330-FF-002169', NULL, NULL, 86, NULL, NULL, 19114),
(19115, '1.10.12.10-FF-000058', NULL, 'Uncharacterized protein', 31, NULL, NULL, 19115),
(19116, '3.40.50.300-FF-002417', NULL, 'Methyl coenzyme M reductase system component A2', 255, NULL, NULL, 19116),
(19117, '1.20.1420.30-FF-000049', NULL, 'Ca(2+)/H(+) antiporter', 246, NULL, NULL, 19117),
(19118, '2.40.50.180-FF-000019', NULL, 'Scaffold protein CheW associated with MCPs of class 44H', 65, NULL, NULL, 19118),
(19119, '2.160.20.10-FF-000011', NULL, 'F-box only protein 11', 146, NULL, NULL, 19119),
(19120, '3.20.20.100-FF-000108', NULL, 'Chromosome 21, whole genome shotgun sequence', 298, NULL, NULL, 19120),
(19121, '1.25.40.10-FF-004007', NULL, 'Uncharacterized protein', 204, NULL, NULL, 19121),
(19122, '3.80.10.10-FF-003093', NULL, 'Lipid-anchored plasma membrane glycoprotein 130', 119, NULL, NULL, 19122),
(19123, '3.30.70.920-FF-000002', NULL, 'Transcriptional regulator AsnC', 84, NULL, NULL, 19123),
(19124, '1.20.1090.10-FF-000028', NULL, 'Iron-containing alcohol dehydrogenase', 197, NULL, NULL, 19124),
(19125, '3.80.10.10-FF-002878', NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase At5g58150', 57, NULL, NULL, 19125),
(19126, '3.40.50.1000-FF-000884', NULL, NULL, 128, NULL, NULL, 19126),
(19127, '3.30.160.60-FF-000793', NULL, 'C2H2 finger domain protein FlbC', 39, NULL, NULL, 19127),
(19128, '1.10.10.60-FF-000990', NULL, NULL, 110, NULL, NULL, 19128),
(19129, '3.30.1140.32-FF-000003', NULL, '30S ribosomal protein S3, chloroplastic', 100, NULL, NULL, 19129),
(19130, '3.40.50.720-FF-002370', NULL, 'Uncharacterized protein', 35, NULL, NULL, 19130),
(19131, '1.20.1280.50-FF-000223', NULL, 'Putative F-box/LRR-repeat protein At5g25860', 50, NULL, NULL, 19131),
(19132, '3.40.50.1820-FF-000006', NULL, 'NDRG family member 3', 291, NULL, NULL, 19132),
(19133, '1.10.150.110-FF-000036', NULL, 'Polymerase (DNA directed), mu', 45, NULL, NULL, 19133),
(19134, '3.40.350.10-FF-000077', NULL, 'Dimethlysulfonioproprionate lyase DddP', 207, NULL, NULL, 19134),
(19135, '3.40.630.10-FF-000059', NULL, 'Glutamate carboxypeptidase 2', 314, NULL, NULL, 19135),
(19136, '3.20.20.80-FF-000328', NULL, 'Hydrolase', 319, NULL, NULL, 19136),
(19137, '3.90.660.10-FF-000033', NULL, 'Protein anon-37Cs', 227, NULL, NULL, 19137),
(19138, '1.20.5.170-FF-000041', NULL, 'Cyclic AMP-dependent transcription factor ATF-6 beta', 55, NULL, NULL, 19138),
(19139, '1.20.1250.20-FF-002365', NULL, 'Uncharacterized protein', 386, NULL, NULL, 19139),
(19140, '3.40.50.300-FF-008252', NULL, 'Uncharacterized protein', 52, NULL, NULL, 19140),
(19141, '3.10.20.70-FF-000028', NULL, 'Glutamine synthetase', 105, NULL, NULL, 19141),
(19142, '2.10.50.10-FF-000104', NULL, 'TvbS1', 38, NULL, NULL, 19142),
(19143, '3.75.10.10-FF-000025', NULL, NULL, 143, NULL, NULL, 19143),
(19144, '1.20.120.1320-FF-000004', NULL, 'Aspartokinase', 97, NULL, NULL, 19144),
(19145, '3.30.160.60-FF-005576', NULL, NULL, 40, NULL, NULL, 19145),
(19146, '1.10.3210.10-FF-000030', NULL, 'Deoxynucleoside triphosphate triphosphohydrolase SAMHD1 homolog', 309, NULL, NULL, 19146),
(19147, '3.40.50.300-FF-005341', NULL, 'Predicted protein', 184, NULL, NULL, 19147),
(19148, '1.20.58.60-FF-000291', NULL, 'Dystonin', 113, NULL, NULL, 19148),
(19149, '3.30.70.270-FF-000324', NULL, NULL, 140, NULL, NULL, 19149),
(19150, '3.30.505.10-FF-000203', NULL, NULL, 97, NULL, NULL, 19150),
(19151, '2.60.40.10-FF-005975', NULL, NULL, 101, NULL, NULL, 19151),
(19152, '3.30.300.210-FF-000005', NULL, 'Spore germination protein GerLC', 154, NULL, NULL, 19152),
(19153, '3.40.50.2030-FF-000002', NULL, 'Hydroxylamine reductase', 142, NULL, NULL, 19153),
(19154, '3.30.70.1230-FF-000169', NULL, 'Adenylyl cyclase class-3/4/guanylyl cyclase', 196, NULL, NULL, 19154),
(19155, '2.60.40.3500-FF-000006', NULL, 'N-acetylmuramoyl-L-alanine amidase AmiC', 116, NULL, NULL, 19155),
(19156, '2.60.200.20-FF-000175', NULL, 'Kinesin family member 16B', 39, NULL, NULL, 19156);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(19157, '3.40.30.20-FF-000001', NULL, '3-hydroxybenzoate 4-monooxygenase', 225, NULL, NULL, 19157),
(19158, '3.30.465.10-FF-000087', NULL, 'Alkyl-dihydroxyacetone phosphate synthase', 117, NULL, NULL, 19158),
(19159, '3.40.50.150-FF-001389', NULL, NULL, 172, NULL, NULL, 19159),
(19160, '3.90.180.10-FF-000007', NULL, 'Alcohol dehydrogenase 6', 220, NULL, NULL, 19160),
(19161, '3.40.50.300-FF-006627', NULL, 'Predicted protein', 92, NULL, NULL, 19161),
(19162, '3.30.63.20-FF-000004', NULL, 'Uncharacterized protein', 88, NULL, NULL, 19162),
(19163, '2.40.50.140-FF-001255', NULL, NULL, 58, NULL, NULL, 19163),
(19164, '2.60.40.1520-FF-000002', NULL, 'Larval serum protein 2', 261, NULL, NULL, 19164),
(19165, '3.80.10.10-FF-003042', NULL, 'Uncharacterized protein', 159, NULL, NULL, 19165),
(19166, '3.30.40.10-FF-002287', NULL, 'Ring finger protein 14', 43, NULL, NULL, 19166),
(19167, '1.20.1250.20-FF-001016', NULL, 'Solute carrier family 16 member 2', 408, NULL, NULL, 19167),
(19168, '1.20.1050.10-FF-000138', NULL, 'Glutathione S-transferase like protein', 119, NULL, NULL, 19168),
(19169, '1.10.10.10-FF-001745', NULL, 'Vacuolar-sorting protein SNF8', 68, NULL, NULL, 19169),
(19170, '3.60.10.10-FF-000390', NULL, 'Predicted protein', 119, NULL, NULL, 19170),
(19171, '3.80.10.10-FF-001417', NULL, 'Flagellar Member 4', 124, NULL, NULL, 19171),
(19172, '1.10.287.130-FF-000131', NULL, 'Sensor histidine kinase', 63, NULL, NULL, 19172),
(19173, '3.40.50.300-FF-000670', NULL, 'Putative ATP-dependent RNA helicase DHX36', 166, NULL, NULL, 19173),
(19174, '3.10.180.10-FF-000053', NULL, 'Lactoylglutathione lyase', 168, NULL, NULL, 19174),
(19175, '2.60.120.260-FF-000091', NULL, 'DUF642 family protein', 159, NULL, NULL, 19175),
(19176, '3.40.50.1010-FF-000269', NULL, NULL, 143, NULL, NULL, 19176),
(19177, '3.80.10.10-FF-000220', NULL, 'Adenylate cyclase AcyA', 118, NULL, NULL, 19177),
(19178, '3.40.1280.10-FF-000065', NULL, 'Ribosomal RNA small subunit methyltransferase E', 179, NULL, NULL, 19178),
(19179, '3.40.50.300-FF-002356', NULL, 'U3 small nucleolar RNA-associated protein 25', 322, NULL, NULL, 19179),
(19180, '2.130.10.10-FF-005672', NULL, 'Eukaryotic initiation factor', 162, NULL, NULL, 19180),
(19181, '3.40.1260.20-FF-000004', NULL, 'Ribonuclease G', 88, NULL, NULL, 19181),
(19182, '3.90.740.10-FF-000039', NULL, 'Isoleucine--tRNA ligase', 147, NULL, NULL, 19182),
(19183, '3.40.50.300-FF-004834', NULL, 'Mitochondrial Rho GTPase', 93, NULL, NULL, 19183),
(19184, '1.20.58.70-FF-000113', NULL, 'Uncharacterized protein', 128, NULL, NULL, 19184),
(19185, '3.90.70.10-FF-000476', NULL, 'Uncharacterized protein', 303, NULL, NULL, 19185),
(19186, '3.10.110.10-FF-000279', NULL, 'Uncharacterized protein', 125, NULL, NULL, 19186),
(19187, '2.40.100.10-FF-000068', NULL, 'Peptidyl-prolyl cis-trans isomerase D', 177, NULL, NULL, 19187),
(19188, '3.30.750.24-FF-000033', NULL, 'STAS domain protein', 104, NULL, NULL, 19188),
(19189, '2.130.10.10-FF-000164', NULL, 'Kinesin family member 21A', 131, NULL, NULL, 19189),
(19190, '3.40.50.10470-FF-000037', NULL, 'Eukaryotic translation initiation factor 2B, subunit 2 beta', 54, NULL, NULL, 19190),
(19191, '3.10.110.10-FF-000335', NULL, 'Ubiquitin-conjugating enzyme 15', 153, NULL, NULL, 19191),
(19192, '2.60.40.420-FF-000080', NULL, 'Cation transporter E1-E2 family ATPase', 99, NULL, NULL, 19192),
(19193, '3.30.70.330-FF-000483', NULL, 'Cytoplasmic polyadenylation element-binding protein 2', 94, NULL, NULL, 19193),
(19194, '3.40.50.12110-FF-000001', NULL, 'Spore photoproduct lyase', 113, NULL, NULL, 19194),
(19195, '3.10.580.10-FF-000033', NULL, 'Nuclear protein SNF4', 179, NULL, NULL, 19195),
(19196, '3.30.2310.20-FF-000017', NULL, 'Toxin-antitoxin system toxin component RelE family', 98, NULL, NULL, 19196),
(19197, '3.30.559.10-FF-000035', NULL, 'Phenolic glucoside malonyltransferase 1', 213, NULL, NULL, 19197),
(19198, '3.90.70.10-FF-000768', NULL, 'Uncharacterized protein', 73, NULL, NULL, 19198),
(19199, '3.40.50.12580-FF-000001', NULL, 'Glycosyl transferase', 174, NULL, NULL, 19199);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(19200, '3.80.10.10-FF-004458', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 96, NULL, NULL, 19200),
(19201, '1.10.510.10-FF-002470', NULL, NULL, 83, NULL, NULL, 19201),
(19202, '1.10.3470.10-FF-000060', NULL, 'Iron ABC transporter, permease', 217, NULL, NULL, 19202),
(19203, '2.40.100.10-FF-000124', NULL, 'Peptidyl-prolyl cis-trans isomerase CYP95 isoform B', 115, NULL, NULL, 19203),
(19204, '1.10.1670.10-FF-000041', NULL, NULL, 43, NULL, NULL, 19204),
(19205, '1.10.10.2330-FF-000010', NULL, NULL, 62, NULL, NULL, 19205),
(19206, '3.30.2160.10-FF-000075', NULL, 'E3 ubiquitin-protein ligase', 11, NULL, NULL, 19206),
(19207, '1.20.1540.10-FF-000046', NULL, 'Rhomboid family protein', 196, NULL, NULL, 19207),
(19208, '2.60.40.60-FF-000335', NULL, 'CaDHerin family', 106, NULL, NULL, 19208),
(19209, '3.60.21.50-FF-000016', NULL, 'Novel protein similar to human DNA directed polymerase delta 2, regulatory subunit (50kD) (POLD2)', 109, NULL, NULL, 19209),
(19210, '1.20.1080.10-FF-000022', NULL, 'MIP aquaporin', 250, NULL, NULL, 19210),
(19211, '2.10.50.10-FF-000099', NULL, 'Zgc:163064 protein', 45, NULL, NULL, 19211),
(19212, '3.30.420.40-FF-000262', NULL, 'Heat shock protein 110, putative', 152, NULL, NULL, 19212),
(19213, '3.40.50.300-FF-000563', NULL, 'Guanine nucleotide-binding protein alpha subunit', 162, NULL, NULL, 19213),
(19214, '3.90.79.10-FF-000075', NULL, 'Uncharacterized protein, isoform A', 193, NULL, NULL, 19214),
(19215, '3.90.70.10-FF-000824', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 173, NULL, NULL, 19215),
(19216, '3.90.930.12-FF-000005', NULL, '60S ribosomal protein L9', 83, NULL, NULL, 19216),
(19217, '3.40.50.720-FF-002307', NULL, 'Uncharacterized protein', 142, NULL, NULL, 19217),
(19218, '3.90.79.10-FF-000131', NULL, 'MutT/nudix family protein', 125, NULL, NULL, 19218),
(19219, '3.60.40.10-FF-000234', NULL, 'Uncharacterized protein', 324, NULL, NULL, 19219),
(19220, '1.10.220.150-FF-000042', NULL, 'Uncharacterized protein', 130, NULL, NULL, 19220),
(19221, '3.40.50.2030-FF-000007', NULL, 'Hydroxylamine reductase', 145, NULL, NULL, 19221),
(19222, '2.60.40.60-FF-000279', NULL, 'Protocadherin-16, putative', 103, NULL, NULL, 19222),
(19223, '3.30.110.10-FF-000016', NULL, 'Predicted protein', 98, NULL, NULL, 19223),
(19224, '3.30.40.10-FF-002051', NULL, 'Uncharacterized protein', 92, NULL, NULL, 19224),
(19225, '2.10.25.10-FF-001136', NULL, 'Predicted protein', 42, NULL, NULL, 19225),
(19226, '1.10.230.10-FF-000026', NULL, 'Citrate synthase-related protein DDB_G0287281', 108, NULL, NULL, 19226),
(19227, '2.40.50.100-FF-000074', NULL, 'Glycine cleavage system H protein', 142, NULL, NULL, 19227),
(19228, '3.30.870.10-FF-000039', NULL, 'Probable tyrosyl-DNA phosphodiesterase', 237, NULL, NULL, 19228),
(19229, '3.90.190.10-FF-000165', NULL, 'Formin-like protein', 183, NULL, NULL, 19229),
(19230, '1.10.8.270-FF-000039', NULL, 'Cell division control protein 16', 47, NULL, NULL, 19230),
(19231, '3.30.519.10-FF-000033', NULL, NULL, 207, NULL, NULL, 19231),
(19232, '3.30.200.160-FF-000001', NULL, 'General transcription factor IIIC subunit 5', 117, NULL, NULL, 19232),
(19233, '3.40.50.150-FF-000933', NULL, NULL, 116, NULL, NULL, 19233),
(19234, '3.40.50.1970-FF-000028', NULL, 'Iron-containing alcohol dehydrogenase', 183, NULL, NULL, 19234),
(19235, '3.30.40.10-FF-002343', NULL, 'Predicted protein', 91, NULL, NULL, 19235),
(19236, '2.60.40.10-FF-004519', NULL, NULL, 86, NULL, NULL, 19236),
(19237, '3.40.190.10-FF-000075', NULL, 'glutamate receptor ionotropic, kainate 4', 61, NULL, NULL, 19237),
(19238, '2.170.300.10-FF-000092', NULL, 'Uncharacterized protein', 72, NULL, NULL, 19238),
(19239, '1.10.400.10-FF-000011', NULL, 'Guanine nucleotide-binding protein alpha-1 subunit', 120, NULL, NULL, 19239),
(19240, '1.20.120.420-FF-000019', NULL, 'Translation initiation factor eIF-2B subunit delta', 96, NULL, NULL, 19240),
(19241, '4.10.60.10-FF-000140', NULL, 'Uncharacterized protein', 65, NULL, NULL, 19241),
(19242, '3.80.10.10-FF-002081', NULL, 'Predicted protein', 126, NULL, NULL, 19242);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(19243, '1.25.10.10-FF-001976', NULL, 'SNF2 superfamily chromatin remodeling protein', 483, NULL, NULL, 19243),
(19244, '1.10.510.10-FF-000924', NULL, 'Cell division protein kinase (Ctk1), putative', 217, NULL, NULL, 19244),
(19245, '1.20.1290.10-FF-000009', NULL, 'Alkyl hydroperoxide reductase AhpD', 115, NULL, NULL, 19245),
(19246, '3.30.420.10-FF-000686', NULL, NULL, 269, NULL, NULL, 19246),
(19247, '3.90.1150.10-FF-000381', NULL, 'Uncharacterized protein', 74, NULL, NULL, 19247),
(19248, '3.40.30.10-FF-000515', NULL, 'Peroxiredoxin (Alkyl hydroperoxide reductase subunit C)', 158, NULL, NULL, 19248),
(19249, '2.60.200.60-FF-000001', NULL, 'Putative phospholipase', 96, NULL, NULL, 19249),
(19250, '3.30.70.270-FF-000329', NULL, NULL, 129, NULL, NULL, 19250),
(19251, '3.40.630.170-FF-000008', NULL, 'Glycylpeptide N-tetradecanoyltransferase 1', 67, NULL, NULL, 19251),
(19252, '2.60.40.60-FF-000386', NULL, 'Protocadherin 12', 143, NULL, NULL, 19252),
(19253, '3.40.50.300-FF-002412', NULL, 'Predicted kinase', 177, NULL, NULL, 19253),
(19254, '3.10.129.10-FF-000092', NULL, 'Putative 4-hydroxybenzoyl-CoA thioesterase', 142, NULL, NULL, 19254),
(19255, '2.70.150.10-FF-000036', NULL, 'Phospholipid-transporting ATPase', 136, NULL, NULL, 19255),
(19256, '3.30.70.80-FF-000022', NULL, 'Uncharacterized protein', 70, NULL, NULL, 19256),
(19257, '3.40.50.880-FF-000129', NULL, 'Protein DJ-1-like C isoform B', 81, NULL, NULL, 19257),
(19258, '1.20.144.10-FF-000099', NULL, 'LOC100158576 protein', 249, NULL, NULL, 19258),
(19259, '1.10.510.10-FF-004235', NULL, NULL, 307, NULL, NULL, 19259),
(19260, '2.60.40.1220-FF-000007', NULL, 'Copper resistance domain-containing protein', 103, NULL, NULL, 19260),
(19261, '3.40.50.720-FF-001346', NULL, 'Oxidoreductase', 234, NULL, NULL, 19261),
(19262, '1.20.120.720-FF-000065', NULL, 'Uncharacterized protein', 132, NULL, NULL, 19262),
(19263, '3.40.50.11610-FF-000025', NULL, NULL, 150, NULL, NULL, 19263),
(19264, '3.30.200.20-FF-000184', NULL, 'Receptor protein-tyrosine kinase', 95, NULL, NULL, 19264),
(19265, '1.20.58.60-FF-000695', NULL, 'Uncharacterized protein', 112, NULL, NULL, 19265),
(19266, '2.20.100.10-FF-000050', NULL, 'Thrombospondin type 1 domain containing 7B', 56, NULL, NULL, 19266),
(19267, '3.40.30.10-FF-001072', NULL, 'Uncharacterized protein', 152, NULL, NULL, 19267),
(19268, '3.40.50.150-FF-000585', NULL, 'Ribosomal RNA small subunit methyltransferase G', 228, NULL, NULL, 19268),
(19269, '1.20.58.760-FF-000009', NULL, 'Translation initiation factor 3 subunit I', 152, NULL, NULL, 19269),
(19270, '1.25.10.10-FF-001420', NULL, 'HEAT repeat protein (DRIM), putative', 294, NULL, NULL, 19270),
(19271, '1.10.472.10-FF-000008', NULL, 'Transcription initiation factor IIB', 106, NULL, NULL, 19271),
(19272, '2.40.128.180-FF-000014', NULL, NULL, 82, NULL, NULL, 19272),
(19273, '1.20.870.10-FF-000049', NULL, 'Ras guanine nucleotide exchange factor E', 136, NULL, NULL, 19273),
(19274, '1.10.472.10-FF-000683', NULL, 'Uncharacterized protein', 171, NULL, NULL, 19274),
(19275, '1.20.58.480-FF-000015', NULL, 'Indoleamine 2,3-dioxygenase beta type', 284, NULL, NULL, 19275),
(19276, '2.130.10.10-FF-003255', NULL, 'Uncharacterized protein', 416, NULL, NULL, 19276),
(19277, '3.40.50.11720-FF-000002', NULL, '3-deoxy-D-manno-octulosonic acid transferase', 169, NULL, NULL, 19277),
(19278, '3.40.190.10-FF-000182', NULL, 'Prephenate dehydratase', 86, NULL, NULL, 19278),
(19279, '2.60.40.10-FF-003558', NULL, NULL, 104, NULL, NULL, 19279),
(19280, '1.20.1540.10-FF-000102', NULL, 'Rhomboid family protein', 186, NULL, NULL, 19280),
(19281, '2.130.10.10-FF-000849', NULL, 'WD repeat-containing protein 44', 318, NULL, NULL, 19281),
(19282, '3.30.390.10-FF-000008', NULL, 'L-talarate/galactarate dehydratase', 127, NULL, NULL, 19282),
(19283, '1.10.287.1010-FF-000003', NULL, 'Predicted protein', 32, NULL, NULL, 19283),
(19284, '2.30.42.10-FF-000214', NULL, 'Discs large MAGUK scaffold protein 5', 110, NULL, NULL, 19284),
(19285, '1.10.10.60-FF-000945', NULL, NULL, 71, NULL, NULL, 19285);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(19286, '3.10.180.10-FF-000008', NULL, '4-hydroxyphenylpyruvate dioxygenase', 164, NULL, NULL, 19286),
(19287, '3.30.2350.20-FF-000019', NULL, 'U2 snRNA/tRNA pseudouridine synthase, putative', 252, NULL, NULL, 19287),
(19288, '1.10.10.60-FF-000838', NULL, NULL, 67, NULL, NULL, 19288),
(19289, '2.130.10.10-FF-003867', NULL, 'Mediator of RNA polymerase II transcription subunit 16', 281, NULL, NULL, 19289),
(19290, '1.25.10.10-FF-001072', NULL, 'Uncharacterized protein', 218, NULL, NULL, 19290),
(19291, '1.20.120.980-FF-000041', NULL, 'Uncharacterized protein', 77, NULL, NULL, 19291),
(19292, '3.30.200.20-FF-000583', NULL, 'Polo', 89, NULL, NULL, 19292),
(19293, '1.10.8.100-FF-000034', NULL, 'rRNA adenine N(6)-methyltransferase', 41, NULL, NULL, 19293),
(19294, '1.20.140.90-FF-000012', NULL, 'Uncharacterized protein', 50, NULL, NULL, 19294),
(19295, '2.30.30.40-FF-000482', NULL, 'Uncharacterized protein', 59, NULL, NULL, 19295),
(19296, '1.10.20.10-FF-000262', NULL, NULL, 80, NULL, NULL, 19296),
(19297, '1.10.8.140-FF-000023', NULL, 'Uncharacterized protein', 62, NULL, NULL, 19297),
(19298, '3.30.420.40-FF-000841', NULL, 'Actin-related protein 2', 94, NULL, NULL, 19298),
(19299, '1.20.900.10-FF-000103', NULL, 'Meiotically up-regulated gene 10 protein', 201, NULL, NULL, 19299),
(19300, '3.10.20.30-FF-000090', NULL, NULL, 75, NULL, NULL, 19300),
(19301, '3.40.50.300-FF-008196', NULL, 'Uncharacterized protein', 76, NULL, NULL, 19301),
(19302, '2.70.150.10-FF-000087', NULL, 'Phospholipid-transporting P-type ATPase, putative', 153, NULL, NULL, 19302),
(19303, '2.60.40.10-FF-003159', NULL, 'Uncharacterized protein', 96, NULL, NULL, 19303),
(19304, '1.20.1420.30-FF-000105', NULL, 'Uncharacterized protein', 134, NULL, NULL, 19304),
(19305, '3.30.420.110-FF-000075', NULL, 'DNA mismatch repair protein MutS', 131, NULL, NULL, 19305),
(19306, '1.10.285.10-FF-000006', NULL, 'NADP-specific glutamate dehydrogenase', 44, NULL, NULL, 19306),
(19307, '1.10.1370.10-FF-000052', NULL, 'Uncharacterized protein', 69, NULL, NULL, 19307),
(19308, '2.60.40.10-FF-000629', NULL, 'Titin b', 96, NULL, NULL, 19308),
(19309, '3.20.20.140-FF-000081', NULL, 'RNase MRP subunit', 190, NULL, NULL, 19309),
(19310, '3.50.50.60-FF-000019', NULL, 'Alkyl hydroperoxide reductase subunit F', 173, NULL, NULL, 19310),
(19311, '1.20.1250.20-FF-001853', NULL, 'Uncharacterized protein', 247, NULL, NULL, 19311),
(19312, '3.90.1150.10-FF-000229', NULL, 'Aminotransferase', 129, NULL, NULL, 19312),
(19313, '2.60.40.10-FF-004620', NULL, NULL, 110, NULL, NULL, 19313),
(19314, '2.30.30.140-FF-000247', NULL, 'Uncharacterized protein', 57, NULL, NULL, 19314),
(19315, '3.50.50.60-FF-000694', NULL, 'Thiol-specific monooxygenase, putative', 331, NULL, NULL, 19315),
(19316, '3.40.50.150-FF-000080', NULL, 'tRNA U34 carboxymethyltransferase', 229, NULL, NULL, 19316),
(19317, '1.20.1250.20-FF-002073', NULL, 'Uncharacterized protein', 279, NULL, NULL, 19317),
(19318, '1.10.150.20-FF-000247', NULL, 'DNA polymerase theta', 144, NULL, NULL, 19318),
(19319, '3.40.50.300-FF-008544', NULL, 'DNA mismatch repair protein', 267, NULL, NULL, 19319),
(19320, '3.60.15.10-FF-000142', NULL, 'Chromosome 10, whole genome shotgun sequence', 255, NULL, NULL, 19320),
(19321, '3.30.70.330-FF-002337', NULL, NULL, 111, NULL, NULL, 19321),
(19322, '3.30.200.20-FF-002033', NULL, 'AGAP004112-PA', 91, NULL, NULL, 19322),
(19323, '1.10.10.350-FF-000005', NULL, 'Glutamate--tRNA ligase', 98, NULL, NULL, 19323),
(19324, '1.20.1110.10-FF-000233', NULL, 'Cation-transporting ATPase', 352, NULL, NULL, 19324),
(19325, '2.20.25.190-FF-000001', NULL, 'Transcription elongation factor 1 homolog', 68, NULL, NULL, 19325),
(19326, '2.60.40.1660-FF-000027', NULL, 'Predicted protein', 275, NULL, NULL, 19326),
(19327, '1.10.510.10-FF-002318', NULL, NULL, 215, NULL, NULL, 19327),
(19328, '3.40.50.720-FF-000913', NULL, 'UDP-glucose 4-epimerase', 180, NULL, NULL, 19328),
(19329, '1.10.1070.11-FF-000013', NULL, 'Phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit gamma', 196, NULL, NULL, 19329);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(19330, '1.10.8.720-FF-000045', NULL, 'Putative dynein heavy chain', 172, NULL, NULL, 19330),
(19331, '2.130.10.10-FF-000905', NULL, 'Unplaced genomic scaffold supercont1.13, whole genome shotgun sequence', 190, NULL, NULL, 19331),
(19332, '1.20.5.4090-FF-000001', NULL, 'leucine-rich repeat flightless-interacting protein 2 isoform X1', 94, NULL, NULL, 19332),
(19333, '1.10.150.50-FF-000138', NULL, 'E74-like factor 3 (ets domain transcription factor, epithelial-specific )', 71, NULL, NULL, 19333),
(19334, '1.20.5.110-FF-000006', NULL, 'Syntaxin 6', 64, NULL, NULL, 19334),
(19335, '3.40.50.10810-FF-000061', NULL, 'DNA repair protein rhp16', 96, NULL, NULL, 19335),
(19336, '1.25.40.10-FF-002641', NULL, 'Membrane anchored protein with DUF2133 domain', 173, NULL, NULL, 19336),
(19337, '3.40.1280.10-FF-000121', NULL, 'Uncharacterized protein', 119, NULL, NULL, 19337),
(19338, '1.10.530.10-FF-000015', NULL, 'Resuscitation-promoting factor RpfB', 81, NULL, NULL, 19338),
(19339, '1.10.555.10-FF-000218', NULL, NULL, 247, NULL, NULL, 19339),
(19340, '2.20.110.10-FF-000051', NULL, NULL, 50, NULL, NULL, 19340),
(19341, '2.120.10.80-FF-000050', NULL, 'Putative LOV domain-containing protein', 112, NULL, NULL, 19341),
(19342, '3.30.70.240-FF-000045', NULL, 'U5 snRNP GTPase', 123, NULL, NULL, 19342),
(19343, '2.60.40.10-FF-003507', NULL, NULL, 90, NULL, NULL, 19343),
(19344, '3.40.190.10-FF-000654', NULL, 'Peptide ABC transporter, periplasmic peptide-binding protein', 139, NULL, NULL, 19344),
(19345, '1.25.40.180-FF-000006', NULL, 'Basic leucine zipper and W2 domain-containing protein 1', 168, NULL, NULL, 19345),
(19346, '2.130.10.10-FF-005380', NULL, 'Uncharacterized protein', 157, NULL, NULL, 19346),
(19347, '2.10.25.10-FF-001659', NULL, 'Uncharacterized protein', 70, NULL, NULL, 19347),
(19348, '3.40.50.300-FF-004885', NULL, 'General secretion pathway protein E', 263, NULL, NULL, 19348),
(19349, '3.90.660.10-FF-000038', NULL, 'Polyamine oxidase', 259, NULL, NULL, 19349),
(19350, '3.40.50.300-FF-001052', NULL, 'Probable transmembrane GTPase FZO-like, chloroplastic', 195, NULL, NULL, 19350),
(19351, '3.50.7.10-FF-000086', NULL, NULL, 12, NULL, NULL, 19351),
(19352, '3.80.10.10-FF-002873', NULL, 'Uncharacterized protein', 144, NULL, NULL, 19352),
(19353, '1.20.1070.10-FF-002090', NULL, 'Uncharacterized protein', 399, NULL, NULL, 19353),
(19354, '3.30.565.10-FF-000544', NULL, 'Predicted protein', 127, NULL, NULL, 19354),
(19355, '1.20.1070.10-FF-001538', NULL, 'D(1A) dopamine receptor', 179, NULL, NULL, 19355),
(19356, '2.10.25.10-FF-000647', NULL, 'neurogenic locus notch homolog protein 4', 38, NULL, NULL, 19356),
(19357, '3.30.450.40-FF-000090', NULL, 'Putative transcriptional regulator', 65, NULL, NULL, 19357),
(19358, '3.30.40.10-FF-002394', NULL, 'Uncharacterized protein', 74, NULL, NULL, 19358),
(19359, '1.20.1250.20-FF-001308', NULL, 'Uncharacterized protein', 184, NULL, NULL, 19359),
(19360, '1.10.150.50-FF-000189', NULL, 'Caskin-1', 70, NULL, NULL, 19360),
(19361, '1.10.10.60-FF-000153', NULL, 'HTH-type transcriptional regulator EutR', 108, NULL, NULL, 19361),
(19362, '3.30.160.60-FF-005632', NULL, NULL, 29, NULL, NULL, 19362),
(19363, '1.10.555.10-FF-000269', NULL, NULL, 226, NULL, NULL, 19363),
(19364, '3.40.50.150-FF-000641', NULL, 'Putative tRNA m5C-methyltransferase', 291, NULL, NULL, 19364),
(19365, '3.40.190.10-FF-000131', NULL, 'LysR family transcriptional regulator', 91, NULL, NULL, 19365),
(19366, '1.10.510.10-FF-001144', NULL, 'CMGC protein kinase', 131, NULL, NULL, 19366),
(19367, '3.40.50.170-FF-000035', NULL, 'Methionyl-tRNA formyltransferase', 244, NULL, NULL, 19367),
(19368, '3.90.190.10-FF-000221', NULL, 'Dual specificity phosphatase-like protein', 172, NULL, NULL, 19368),
(19369, '3.40.50.150-FF-001041', NULL, NULL, 148, NULL, NULL, 19369),
(19370, '2.40.33.10-FF-000035', NULL, 'Pyruvate kinase', 90, NULL, NULL, 19370),
(19371, '1.10.510.10-FF-004055', NULL, NULL, 270, NULL, NULL, 19371),
(19372, '1.25.40.10-FF-002242', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 200, NULL, NULL, 19372);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(19373, '3.40.50.620-FF-000597', NULL, 'Tryptophan--tRNA ligase, mitochondrial', 248, NULL, NULL, 19373),
(19374, '3.30.160.60-FF-000961', NULL, 'Spalt like transcription factor 3', 33, NULL, NULL, 19374),
(19375, '1.25.40.10-FF-001753', NULL, 'GM24661', 187, NULL, NULL, 19375),
(19376, '3.40.50.300-FF-000962', NULL, 'digestive organ expansion factor homolog', 323, NULL, NULL, 19376),
(19377, '3.40.50.300-FF-004273', NULL, 'Prosalusin', 156, NULL, NULL, 19377),
(19378, '2.60.40.10-FF-004671', NULL, NULL, 96, NULL, NULL, 19378),
(19379, '3.30.160.60-FF-004272', NULL, NULL, 27, NULL, NULL, 19379),
(19380, '2.60.40.10-FF-005071', NULL, NULL, 100, NULL, NULL, 19380),
(19381, '1.10.510.10-FF-000868', NULL, 'Myosin light chain kinase, putative', 301, NULL, NULL, 19381),
(19382, '1.20.120.720-FF-000014', NULL, 'Unconventional myosin-X', 146, NULL, NULL, 19382),
(19383, '3.90.70.10-FF-000083', NULL, 'Uncharacterized protein, isoform B', 337, NULL, NULL, 19383),
(19384, '3.30.70.370-FF-000028', NULL, NULL, 76, NULL, NULL, 19384),
(19385, '3.40.1110.10-FF-000463', NULL, NULL, 120, NULL, NULL, 19385),
(19386, '3.40.50.2300-FF-001628', NULL, NULL, 274, NULL, NULL, 19386),
(19387, '3.40.190.10-FF-000867', NULL, 'Mutant transferrin', 26, NULL, NULL, 19387),
(19388, '2.60.40.60-FF-000858', NULL, 'Uncharacterized protein', 114, NULL, NULL, 19388),
(19389, '1.10.510.10-FF-003779', NULL, NULL, 134, NULL, NULL, 19389),
(19390, '2.40.20.10-FF-000079', NULL, 'Plasminogen activator, urokinase a', 100, NULL, NULL, 19390),
(19391, '3.30.160.60-FF-001361', NULL, 'Zinc finger protein 585A', 29, NULL, NULL, 19391),
(19392, '1.20.1540.10-FF-000097', NULL, 'Uncharacterized protein', 196, NULL, NULL, 19392),
(19393, '3.50.50.60-FF-000082', NULL, 'protein MTO1 homolog, mitochondrial isoform X1', 229, NULL, NULL, 19393),
(19394, '2.10.90.10-FF-000045', NULL, 'DAN domain BMP antagonist family member 5', 103, NULL, NULL, 19394),
(19395, '2.10.25.10-FF-001608', NULL, 'Putative WAK family receptor-like protein kinase', 87, NULL, NULL, 19395),
(19396, '1.20.1560.10-FF-000660', NULL, 'Os01g0534700 protein', 71, NULL, NULL, 19396),
(19397, '1.10.238.10-FF-000768', NULL, 'GM15947', 148, NULL, NULL, 19397),
(19398, '1.10.533.10-FF-000089', NULL, 'E3 ubiquitin-protein ligase TTC3', 95, NULL, NULL, 19398),
(19399, '3.40.50.1820-FF-000630', NULL, 'Coronamic acid synthetase, thioesterase component', 215, NULL, NULL, 19399),
(19400, '2.60.40.1180-FF-000181', NULL, 'Calpain-like cysteine peptidase, putative', 110, NULL, NULL, 19400),
(19401, '3.40.1110.10-FF-000412', NULL, NULL, 49, NULL, NULL, 19401),
(19402, '3.40.140.10-FF-000027', NULL, 'Sulfur carrier protein FdhD', 145, NULL, NULL, 19402),
(19403, '3.40.225.10-FF-000056', NULL, NULL, 110, NULL, NULL, 19403),
(19404, '1.25.40.10-FF-003838', NULL, 'Uncharacterized protein', 121, NULL, NULL, 19404),
(19405, '3.40.50.1580-FF-000069', NULL, 'Uncharacterized protein', 73, NULL, NULL, 19405),
(19406, '1.20.1070.10-FF-000701', NULL, 'Olfactory receptor family 10 subfamily J member 1', 175, NULL, NULL, 19406),
(19407, '2.60.120.200-FF-000680', NULL, 'Uncharacterized protein', 33, NULL, NULL, 19407),
(19408, '2.70.70.10-FF-000047', NULL, 'M23 family peptidase', 164, NULL, NULL, 19408),
(19409, '1.25.50.20-FF-000054', NULL, 'Uncharacterized protein', 79, NULL, NULL, 19409),
(19410, '2.130.10.10-FF-004559', NULL, 'Uncharacterized protein', 216, NULL, NULL, 19410),
(19411, '3.40.50.1820-FF-001175', NULL, 'Uncharacterized protein', 259, NULL, NULL, 19411),
(19412, '2.160.20.60-FF-000009', NULL, 'Ferredoxin-dependent glutamate synthase, chloroplastic', 141, NULL, NULL, 19412),
(19413, '3.30.450.20-FF-000168', NULL, 'Two-component sensor histidine kinase', 114, NULL, NULL, 19413),
(19414, '2.30.40.10-FF-000103', NULL, 'Uncharacterized protein', 54, NULL, NULL, 19414),
(19415, '3.90.120.10-FF-000003', NULL, 'DNA (cytosine-5)-methyltransferase 1', 175, NULL, NULL, 19415),
(19416, '1.20.58.1380-FF-000008', NULL, 'YALI0A03883p', 94, NULL, NULL, 19416),
(19417, '2.40.10.10-FF-000235', NULL, 'Atrial natriuretic peptide-converting enzyme', 222, NULL, NULL, 19417);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(19418, '1.25.70.10-FF-000052', NULL, 'mTERF2 protein', 292, NULL, NULL, 19418),
(19419, '3.30.450.20-FF-000224', NULL, 'Methyl-accepting chemotaxis protein', 108, NULL, NULL, 19419),
(19420, '3.40.50.12790-FF-000002', NULL, 'EscV/YscV/HrcV family type III secretion system export apparatus protein', 99, NULL, NULL, 19420),
(19421, '3.90.1410.10-FF-000036', NULL, '[Ribulose-bisphosphate-carboxylase]-lysine N-methyltransferase', 252, NULL, NULL, 19421),
(19422, '3.40.50.150-FF-001333', NULL, NULL, 200, NULL, NULL, 19422),
(19423, '2.60.120.330-FF-000196', NULL, 'Uncharacterized protein', 160, NULL, NULL, 19423),
(19424, '3.40.50.300-FF-003429', NULL, 'Vacuolar ATP synthase catalytic subunit A', 58, NULL, NULL, 19424),
(19425, '3.30.60.30-FF-000147', NULL, 'Proteinase inhibitor PSKP-1', 58, NULL, NULL, 19425),
(19426, '3.30.830.10-FF-000149', NULL, 'Insulinase family metalloprotease', 234, NULL, NULL, 19426),
(19427, '3.40.50.2300-FF-000162', NULL, 'Receptor-type adenylate cyclase GRESAG 4, putative', 148, NULL, NULL, 19427),
(19428, '3.30.160.60-FF-003608', NULL, 'Zinc finger and BTB domain-containing 32', 28, NULL, NULL, 19428),
(19429, '3.90.190.20-FF-000050', NULL, 'FolC bifunctional protein', 135, NULL, NULL, 19429),
(19430, '3.20.20.120-FF-000035', NULL, 'D-Ala-D/L-Ala epimerase', 237, NULL, NULL, 19430),
(19431, '3.40.50.150-FF-000821', NULL, 'rRNA methyltransferase 2, mitochondrial', 190, NULL, NULL, 19431),
(19432, '1.25.40.20-FF-001806', NULL, 'Uncharacterized protein', 164, NULL, NULL, 19432),
(19433, '3.90.1310.10-FF-000040', NULL, 'Penicillin-binding protein', 160, NULL, NULL, 19433),
(19434, '1.10.533.10-FF-000145', NULL, 'Uncharacterized protein', 89, NULL, NULL, 19434),
(19435, '2.60.40.150-FF-000268', NULL, 'RNA helicase, putative', 107, NULL, NULL, 19435),
(19436, '4.10.60.10-FF-000252', NULL, 'DNA topoisomerase', 47, NULL, NULL, 19436),
(19437, '3.40.50.1700-FF-000032', NULL, 'Beta-glucosidase', 176, NULL, NULL, 19437),
(19438, '1.20.120.1750-FF-000127', NULL, 'RBR-type E3 ubiquitin transferase', 93, NULL, NULL, 19438),
(19439, '2.60.40.640-FF-000072', NULL, 'Uncharacterized protein', 127, NULL, NULL, 19439),
(19440, '1.25.10.10-FF-003269', NULL, 'Predicted protein', 206, NULL, NULL, 19440),
(19441, '3.40.50.620-FF-000029', NULL, 'tRNA sulfurtransferase', 222, NULL, NULL, 19441),
(19442, '2.60.40.10-FF-000692', NULL, 'basement membrane-specific heparan sulfate proteoglycan core protein-like', 91, NULL, NULL, 19442),
(19443, '1.10.510.10-FF-001413', NULL, 'Predicted protein', 181, NULL, NULL, 19443),
(19444, '1.25.10.10-FF-001240', NULL, 'Crescerin-like protein che-12', 221, NULL, NULL, 19444),
(19445, '3.50.50.60-FF-000643', NULL, 'Rab escort protein 1', 25, NULL, NULL, 19445),
(19446, '2.60.220.50-FF-000174', NULL, 'Uncharacterized protein', 88, NULL, NULL, 19446),
(19447, '3.40.718.10-FF-000061', NULL, 'Isocitrate dehydrogenase', 222, NULL, NULL, 19447),
(19448, '2.60.40.1170-FF-000083', NULL, NULL, 153, NULL, NULL, 19448),
(19449, '1.10.150.220-FF-000013', NULL, NULL, 55, NULL, NULL, 19449),
(19450, '3.40.50.2000-FF-000116', NULL, 'Alpha-1,4 glucan phosphorylase', 66, NULL, NULL, 19450),
(19451, '1.25.40.10-FF-000224', NULL, 'DnaJ and TPR domain protein', 363, NULL, NULL, 19451),
(19452, '2.30.29.30-FF-000695', NULL, 'Serine/threonine protein kinase', 109, NULL, NULL, 19452),
(19453, '3.40.50.300-FF-003761', NULL, 'Uncharacterized protein', 106, NULL, NULL, 19453),
(19454, '1.25.10.10-FF-002706', NULL, 'Predicted protein', 52, NULL, NULL, 19454),
(19455, '1.20.1050.40-FF-000006', NULL, 'Peptidyl-dipeptidase', 113, NULL, NULL, 19455),
(19456, '1.10.1450.10-FF-000053', NULL, 'Tetraspanin', 114, NULL, NULL, 19456),
(19457, '1.10.275.30-FF-000006', NULL, 'General transcription and DNA repair factor IIH helicase subunit XPD', 75, NULL, NULL, 19457),
(19458, '1.20.5.340-FF-000002', NULL, 'Myosin heavy chain', 110, NULL, NULL, 19458),
(19459, '1.25.10.10-FF-000672', NULL, 'Condensin complex subunit 1', 404, NULL, NULL, 19459),
(19460, '3.20.20.70-FF-000674', NULL, NULL, 206, NULL, NULL, 19460);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(19461, '3.30.200.20-FF-001925', NULL, NULL, 98, NULL, NULL, 19461),
(19462, '1.20.5.4770-FF-000014', NULL, 'AN1-type zinc finger protein 3', 60, NULL, NULL, 19462),
(19463, '3.30.60.30-FF-000203', NULL, 'Uncharacterized protein', 72, NULL, NULL, 19463),
(19464, '3.30.830.10-FF-000205', NULL, 'Uncharacterized protein', 231, NULL, NULL, 19464),
(19465, '2.60.40.10-FF-001978', NULL, 'Uncharacterized protein, isoform B', 109, NULL, NULL, 19465),
(19466, '3.40.50.410-FF-000360', NULL, 'TFIIH 34kDa subunit', 58, NULL, NULL, 19466),
(19467, '3.30.530.20-FF-000169', NULL, 'Predicted protein', 122, NULL, NULL, 19467),
(19468, '3.90.75.20-FF-000001', NULL, 'H-N-H endonuclease F-TflII', 105, NULL, NULL, 19468),
(19469, '3.80.10.10-FF-000456', NULL, 'Ubiquitin-protein ligase', 367, NULL, NULL, 19469),
(19470, '3.40.140.10-FF-000072', NULL, 'Eukaryotic translation initiation factor 3 subunit H', 199, NULL, NULL, 19470),
(19471, '3.40.50.300-FF-001631', NULL, 'Shs1p', 297, NULL, NULL, 19471),
(19472, '3.30.565.10-FF-000072', NULL, 'Sensor histidine kinase GlrK', 156, NULL, NULL, 19472),
(19473, '3.90.730.10-FF-000033', NULL, 'Uncharacterized protein', 87, NULL, NULL, 19473),
(19474, '2.10.25.10-FF-001715', NULL, 'Uncharacterized protein', 40, NULL, NULL, 19474),
(19475, '1.10.2000.10-FF-000031', NULL, NULL, 115, NULL, NULL, 19475),
(19476, '3.80.10.10-FF-003385', NULL, 'Uncharacterized protein', 102, NULL, NULL, 19476),
(19477, '3.30.200.20-FF-001869', NULL, 'Ribosomal protein S6 kinase', 76, NULL, NULL, 19477),
(19478, '3.40.50.850-FF-000025', NULL, 'Uncharacterized protein', 189, NULL, NULL, 19478),
(19479, '1.10.510.10-FF-000688', NULL, 'RIM11p Protein kinase', 227, NULL, NULL, 19479),
(19480, '1.20.58.390-FF-000084', NULL, 'Glutamate-gated chloride channel subunit beta', 143, NULL, NULL, 19480),
(19481, '2.60.40.1910-FF-000006', NULL, 'Aminopeptidase', 96, NULL, NULL, 19481),
(19482, '3.40.850.10-FF-000154', NULL, 'Myosin XXI', 251, NULL, NULL, 19482),
(19483, '3.20.20.20-FF-000013', NULL, 'Dihydropteroate synthase', 282, NULL, NULL, 19483),
(19484, '3.40.1370.10-FF-000004', NULL, '50S ribosomal protein L4', 212, NULL, NULL, 19484),
(19485, '3.40.50.2000-FF-000807', NULL, 'Alpha-glucan phosphorylase 2, cytosolic', 495, NULL, NULL, 19485),
(19486, '3.30.70.3490-FF-000043', NULL, NULL, 92, NULL, NULL, 19486),
(19487, '2.60.40.10-FF-006088', NULL, NULL, 138, NULL, NULL, 19487),
(19488, '3.90.650.10-FF-000032', NULL, 'Phosphoribosylformylglycinamidine synthase', 165, NULL, NULL, 19488),
(19489, '2.130.10.10-FF-000433', NULL, 'WD repeat and FYVE domain-containing protein 1', 131, NULL, NULL, 19489),
(19490, '2.160.10.10-FF-000073', NULL, 'Putative nonribosomal peptide synthetase', 137, NULL, NULL, 19490),
(19491, '2.10.25.10-FF-000411', NULL, 'Crumbs cell polarity complex component 2', 41, NULL, NULL, 19491),
(19492, '3.10.50.40-FF-000077', NULL, 'Peptidylprolyl isomerase', 142, NULL, NULL, 19492),
(19493, '2.30.33.40-FF-000011', NULL, 'Heat shock protein family E (Hsp10) member 1', 47, NULL, NULL, 19493),
(19494, '3.40.50.300-FF-005902', NULL, 'GTPase mss1/trme, putative', 170, NULL, NULL, 19494),
(19495, '3.40.390.10-FF-000074', NULL, 'Metalloprotease', 156, NULL, NULL, 19495),
(19496, '3.30.420.390-FF-000001', NULL, 'DNA polymerase gamma, catalytic subunit', 96, NULL, NULL, 19496),
(19497, '2.130.10.10-FF-003362', NULL, 'Probable serine/threonine-protein kinase roco4', 202, NULL, NULL, 19497),
(19498, '2.60.40.10-FF-002777', NULL, 'Uncharacterized protein', 79, NULL, NULL, 19498),
(19499, '3.90.228.10-FF-000068', NULL, 'Poly [ADP-ribose] polymerase', 73, NULL, NULL, 19499),
(19500, '3.40.50.11210-FF-000006', NULL, 'GTPase-activating Rap/Ran-GAP domain-like protein 3 isoform X1', 191, NULL, NULL, 19500),
(19501, '1.10.10.60-FF-000422', NULL, 'Transcriptional regulator, Fis family', 76, NULL, NULL, 19501),
(19502, '3.30.200.20-FF-001072', NULL, 'Uncharacterized protein', 103, NULL, NULL, 19502),
(19503, '3.40.190.290-FF-000022', NULL, 'LysR family transcriptional regulator', 209, NULL, NULL, 19503),
(19504, '3.20.20.140-FF-000373', NULL, 'Uncharacterized protein', 215, NULL, NULL, 19504);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(19505, '3.30.450.20-FF-000511', NULL, 'ACR218Wp', 110, NULL, NULL, 19505),
(19506, '3.30.160.60-FF-006413', NULL, NULL, 28, NULL, NULL, 19506),
(19507, '1.20.930.40-FF-000035', NULL, 'Uncharacterized protein', 92, NULL, NULL, 19507),
(19508, '3.10.20.90-FF-000747', NULL, 'AT07671p', 100, NULL, NULL, 19508),
(19509, '1.10.510.10-FF-004286', NULL, NULL, 168, NULL, NULL, 19509),
(19510, '3.40.50.720-FF-000621', NULL, '3-ketoacyl-CoA reductase, putative', 251, NULL, NULL, 19510),
(19511, '3.50.50.60-FF-000930', NULL, 'Bis-gamma-glutamylcystine reductase', 198, NULL, NULL, 19511),
(19512, '3.40.50.300-FF-002069', NULL, 'Pre-mRNA splicing factor RNA helicase, putative', 147, NULL, NULL, 19512),
(19513, '2.60.40.10-FF-003215', NULL, NULL, 52, NULL, NULL, 19513),
(19514, '3.40.50.1100-FF-000291', NULL, 'Putative S-sulfocysteine synthase chloroplastic', 113, NULL, NULL, 19514),
(19515, '2.60.120.200-FF-000348', NULL, 'InTestinal NeureXin-like', 147, NULL, NULL, 19515),
(19516, '2.40.50.140-FF-000294', NULL, 'Single-stranded DNA-binding protein', 124, NULL, NULL, 19516),
(19517, '3.10.100.10-FF-000060', NULL, 'Lymphocyte antigen 75', 155, NULL, NULL, 19517),
(19518, '1.25.40.10-FF-001860', NULL, 'Protein FLUORESCENT IN BLUE LIGHT, chloroplastic', 119, NULL, NULL, 19518),
(19519, '1.20.5.1700-FF-000009', NULL, 'Homer homolog 2 (Drosophila)', 75, NULL, NULL, 19519),
(19520, '2.30.30.140-FF-000303', NULL, 'Uncharacterized protein', 74, NULL, NULL, 19520),
(19521, '1.10.8.10-FF-000305', NULL, 'UBX domain-containing protein 3', 39, NULL, NULL, 19521),
(19522, '3.40.50.300-FF-008488', NULL, 'Uncharacterized protein', 159, NULL, NULL, 19522),
(19523, '1.25.10.10-FF-001925', NULL, 'AGAP007143-PA', 326, NULL, NULL, 19523),
(19524, '1.20.120.1080-FF-000123', NULL, 'AGAP007953-PA', 113, NULL, NULL, 19524),
(19525, '3.40.50.300-FF-004093', NULL, 'CG41497', 233, NULL, NULL, 19525),
(19526, '3.40.50.300-FF-008432', NULL, 'ABC transporter, putative', 90, NULL, NULL, 19526),
(19527, '1.10.418.10-FF-000193', NULL, 'Girdin, putative', 95, NULL, NULL, 19527),
(19528, '3.40.390.10-FF-000130', NULL, 'Metalloendopeptidase', 246, NULL, NULL, 19528),
(19529, '3.40.50.720-FF-001970', NULL, 'Predicted protein', 354, NULL, NULL, 19529),
(19530, '1.25.40.10-FF-002534', NULL, 'Pentatricopeptide repeat-containing protein At3g16010', 68, NULL, NULL, 19530),
(19531, '1.10.630.10-FF-000231', NULL, 'Cytochrome P450', 269, NULL, NULL, 19531),
(19532, '3.90.70.10-FF-000875', NULL, 'Uncharacterized protein', 59, NULL, NULL, 19532),
(19533, '3.40.720.10-FF-000330', NULL, 'Uncharacterized protein', 124, NULL, NULL, 19533),
(19534, '3.40.50.300-FF-007976', NULL, 'Uncharacterized protein', 160, NULL, NULL, 19534),
(19535, '1.10.1300.10-FF-000065', NULL, 'Uncharacterized protein', 158, NULL, NULL, 19535),
(19536, '1.25.40.10-FF-000909', NULL, 'YDR161W-like protein', 193, NULL, NULL, 19536),
(19537, '3.30.200.20-FF-002325', NULL, 'Uncharacterized protein', 78, NULL, NULL, 19537),
(19538, '3.80.20.20-FF-000055', NULL, 'Receptor protein-tyrosine kinase', 169, NULL, NULL, 19538),
(19539, '1.25.40.20-FF-000446', NULL, 'Arginine N-methyltransferase 2', 115, NULL, NULL, 19539),
(19540, '3.40.850.10-FF-000210', NULL, 'Kinesin-like protein', 358, NULL, NULL, 19540),
(19541, '1.20.1560.10-FF-000553', NULL, 'ABC transporter permease', 311, NULL, NULL, 19541),
(19542, '3.40.50.720-FF-001077', NULL, 'GM12822', 275, NULL, NULL, 19542),
(19543, '2.30.29.30-FF-000751', NULL, 'Kinesin, putative', 130, NULL, NULL, 19543),
(19544, '3.40.1000.10-FF-000022', NULL, 'Photosystem II reaction center PsbP family protein', 160, NULL, NULL, 19544),
(19545, '3.30.70.330-FF-002045', NULL, NULL, 162, NULL, NULL, 19545),
(19546, '2.10.25.10-FF-000355', NULL, 'Wall-associated receptor kinase 3', 39, NULL, NULL, 19546),
(19547, '2.10.25.10-FF-001760', NULL, 'Uncharacterized protein', 36, NULL, NULL, 19547),
(19548, '3.30.160.60-FF-001810', NULL, 'General transcription factor IIIA', 31, NULL, NULL, 19548),
(19549, '3.40.190.10-FF-000923', NULL, 'Uncharacterized protein', 72, NULL, NULL, 19549);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(19550, '2.60.40.290-FF-000006', NULL, 'Chitinase B', 96, NULL, NULL, 19550),
(19551, '3.90.470.20-FF-000032', NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', 117, NULL, NULL, 19551),
(19552, '3.90.550.20-FF-000033', NULL, 'Predicted protein', 214, NULL, NULL, 19552),
(19553, '3.30.160.60-FF-005340', NULL, NULL, 91, NULL, NULL, 19553),
(19554, '3.30.70.3400-FF-000016', NULL, 'Protein translocase subunit SecD', 60, NULL, NULL, 19554),
(19555, '2.102.10.10-FF-000036', NULL, 'Cholesterol 7-desaturase', 137, NULL, NULL, 19555),
(19556, '3.30.70.330-FF-001320', NULL, 'RNA recognition motif domain containing protein', 108, NULL, NULL, 19556),
(19557, '2.40.30.170-FF-000029', NULL, 'Probable Resistance-Nodulation-Cell Division (RND) efflux membrane fusion protein', 79, NULL, NULL, 19557),
(19558, '1.10.1450.10-FF-000165', NULL, 'Uncharacterized protein', 61, NULL, NULL, 19558),
(19559, '1.25.40.10-FF-005171', NULL, 'E3 ubiquitin-protein ligase CHIP', 69, NULL, NULL, 19559),
(19560, '1.25.40.10-FF-000168', NULL, 'tetratricopeptide repeat protein 8 isoform X1', 174, NULL, NULL, 19560),
(19561, '3.10.20.90-FF-000186', NULL, 'RWP-RK domain-containing protein', 85, NULL, NULL, 19561),
(19562, '1.10.486.10-FF-000024', NULL, 'ATP-dependent DNA helicase UvrD2', 35, NULL, NULL, 19562),
(19563, '2.30.30.240-FF-000002', NULL, 'Ribosome maturation factor rimM', 97, NULL, NULL, 19563),
(19564, '3.40.1810.10-FF-000033', NULL, 'Agamous-like MADS-box protein AGL53', 98, NULL, NULL, 19564),
(19565, '3.30.70.260-FF-000091', NULL, 'Prephenate dehydratase', 77, NULL, NULL, 19565),
(19566, '3.40.50.720-FF-001818', NULL, '2-C-methyl-D-erythritol 4-phosphate cytidylyltransferase', 216, NULL, NULL, 19566),
(19567, '1.10.1320.10-FF-000009', NULL, 'DNA-directed RNA polymerase', 336, NULL, NULL, 19567),
(19568, '3.80.10.10-FF-003441', NULL, 'Uncharacterized protein', 57, NULL, NULL, 19568),
(19569, '3.30.200.20-FF-001813', NULL, 'LRR receptor-like serine/threonine-protein kinase GSO1', 82, NULL, NULL, 19569),
(19570, '1.10.2000.10-FF-000087', NULL, NULL, 127, NULL, NULL, 19570),
(19571, '3.30.420.40-FF-000734', NULL, 'Actin4-1', 112, NULL, NULL, 19571),
(19572, '2.60.40.10-FF-004963', NULL, NULL, 94, NULL, NULL, 19572),
(19573, '1.20.1000.10-FF-000011', NULL, 'Guanylate-binding family protein', 286, NULL, NULL, 19573),
(19574, '1.10.10.60-FF-000097', NULL, 'barH-like 2 homeobox protein-like', 77, NULL, NULL, 19574),
(19575, '1.10.520.40-FF-000001', NULL, 'CRISPR system Cascade subunit CasB', 160, NULL, NULL, 19575),
(19576, '3.40.1390.20-FF-000008', NULL, 'HPr kinase/phosphorylase', 133, NULL, NULL, 19576),
(19577, '1.10.510.10-FF-000576', NULL, 'Serine/threonine-protein kinase PLK4', 316, NULL, NULL, 19577),
(19578, '4.10.60.10-FF-000196', NULL, 'Cold shock domain protein 1', 30, NULL, NULL, 19578),
(19579, '2.130.10.10-FF-004379', NULL, 'Uncharacterized protein', 78, NULL, NULL, 19579),
(19580, '3.40.50.1910-FF-000033', NULL, 'Vacuolar protein sorting-associated protein 33B', 72, NULL, NULL, 19580),
(19581, '3.30.160.60-FF-002142', NULL, 'Zinc finger protein 567', 30, NULL, NULL, 19581),
(19582, '2.130.10.10-FF-000613', NULL, 'YKL121W-like protein', 327, NULL, NULL, 19582),
(19583, '1.20.1070.10-FF-001246', NULL, 'Latrophilin, putative', 124, NULL, NULL, 19583),
(19584, '3.90.550.50-FF-000137', NULL, 'Hexosyltransferase', 228, NULL, NULL, 19584),
(19585, '2.30.30.930-FF-000001', NULL, 'RNA polymerase-associated protein RapA', 60, NULL, NULL, 19585),
(19586, '2.10.25.10-FF-001428', NULL, 'Starry night', 50, NULL, NULL, 19586),
(19587, '3.30.1490.120-FF-000023', NULL, 'Os06g0168400 protein', 82, NULL, NULL, 19587),
(19588, '3.90.226.10-FF-000226', NULL, 'Enoyl-CoA hydratase/isomerase family, putative', 234, NULL, NULL, 19588),
(19589, '3.40.50.300-FF-001344', NULL, 'Related to ABC transporter', 219, NULL, NULL, 19589),
(19590, '1.10.3730.10-FF-000007', NULL, 'Pyrroline-5-carboxylate reductase', 102, NULL, NULL, 19590),
(19591, '4.10.240.30-FF-000010', NULL, 'Uncharacterized protein', 28, NULL, NULL, 19591);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(19592, '3.30.1370.10-FF-000175', NULL, 'Tudor and KH domain-containing protein homolog', 70, NULL, NULL, 19592),
(19593, '3.40.50.410-FF-000028', NULL, 'Midasin', 173, NULL, NULL, 19593),
(19594, '2.60.120.1000-FF-000037', NULL, 'Uncharacterized protein', 90, NULL, NULL, 19594),
(19595, '2.10.110.10-FF-000160', NULL, 'Signal transducer, putative', 103, NULL, NULL, 19595),
(19596, '3.20.110.10-FF-000013', NULL, 'Uncharacterized protein', 316, NULL, NULL, 19596),
(19597, '1.25.10.10-FF-001184', NULL, 'Condensin-2 complex subunit D3', 400, NULL, NULL, 19597),
(19598, '3.50.50.60-FF-000587', NULL, 'Guanosine nucleotide diphosphate dissociation inhibitor', 73, NULL, NULL, 19598),
(19599, '3.40.50.300-FF-004778', NULL, 'Dynein heavy chain', 144, NULL, NULL, 19599),
(19600, '2.10.50.10-FF-000155', NULL, 'Uncharacterized protein', 60, NULL, NULL, 19600),
(19601, '1.20.140.150-FF-000015', NULL, 'Claudin', 184, NULL, NULL, 19601),
(19602, '1.10.510.10-FF-002762', NULL, NULL, 228, NULL, NULL, 19602),
(19603, '1.10.1410.10-FF-000112', NULL, 'Caffeine Induced Death (S. pombe Cid) homolog', 207, NULL, NULL, 19603),
(19604, '3.40.630.10-FF-000458', NULL, 'Uncharacterized protein', 142, NULL, NULL, 19604),
(19605, '1.20.58.80-FF-000066', NULL, 'Sorting nexin 15', 76, NULL, NULL, 19605),
(19606, '3.30.70.580-FF-000029', NULL, 'tRNA pseudouridine synthase', 126, NULL, NULL, 19606),
(19607, '3.40.47.10-FF-000267', NULL, NULL, 143, NULL, NULL, 19607),
(19608, '1.20.1070.10-FF-000521', NULL, 'Putative octopamine/tyramine receptor', 254, NULL, NULL, 19608),
(19609, '3.40.50.1580-FF-000001', NULL, 'MTA/SAH nucleosidase family protein', 230, NULL, NULL, 19609),
(19610, '2.60.120.330-FF-000140', NULL, 'Oxidoreductase, 2OG-Fe(II) oxygenase family, putative (AFU_orthologue AFUA_5G12242)', 177, NULL, NULL, 19610),
(19611, '1.25.40.20-FF-000969', NULL, 'Uncharacterized protein', 261, NULL, NULL, 19611),
(19612, '3.40.50.300-FF-002704', NULL, 'Unplaced genomic scaffold supercont1.17, whole genome shotgun sequence', 240, NULL, NULL, 19612),
(19613, '1.10.238.10-FF-000712', NULL, 'EF hand family protein', 80, NULL, NULL, 19613),
(19614, '3.60.40.10-FF-000178', NULL, 'WGS project CABT00000000 data, contig 2.1', 141, NULL, NULL, 19614),
(19615, '3.40.50.1010-FF-000033', NULL, 'Blast:Protein SMG5', 166, NULL, NULL, 19615),
(19616, '2.30.29.70-FF-000004', NULL, 'Unplaced genomic scaffold supercont1.163, whole genome shotgun sequence', 114, NULL, NULL, 19616),
(19617, '3.40.50.1760-FF-000022', NULL, NULL, 143, NULL, NULL, 19617),
(19618, '1.20.58.60-FF-000060', NULL, 'dystonin isoform X2', 115, NULL, NULL, 19618),
(19619, '2.60.40.10-FF-001473', NULL, 'Jitterbug, isoform C', 93, NULL, NULL, 19619),
(19620, '1.10.510.10-FF-000632', NULL, 'leucine-rich repeat receptor-like protein kinase TDR', 208, NULL, NULL, 19620),
(19621, '3.30.70.270-FF-000037', NULL, 'Sensory box/GGDEF family protein', 165, NULL, NULL, 19621),
(19622, '3.30.40.10-FF-001831', NULL, 'Uncharacterized protein', 56, NULL, NULL, 19622),
(19623, '1.50.40.10-FF-000104', NULL, 'Iron transporter', 144, NULL, NULL, 19623),
(19624, '2.30.30.30-FF-000092', NULL, 'Transcription initiation factor SPT5, putative', 49, NULL, NULL, 19624),
(19625, '3.80.10.10-FF-003946', NULL, 'Uncharacterized protein', 228, NULL, NULL, 19625),
(19626, '3.40.30.10-FF-000807', NULL, 'Glutathione S-transferase', 78, NULL, NULL, 19626),
(19627, '3.40.50.300-FF-002648', NULL, 'bifunctional heparan sulfate N-deacetylase/N-sulfotransferase 4 isoform X2', 138, NULL, NULL, 19627),
(19628, '1.50.40.10-FF-000048', NULL, 'mitochondrial 2-oxodicarboxylate carrier isoform X2', 192, NULL, NULL, 19628),
(19629, '1.10.10.60-FF-000602', NULL, 'Chitin synthase', 63, NULL, NULL, 19629),
(19630, '3.30.420.40-FF-000554', NULL, 'Phosphotransferase', 160, NULL, NULL, 19630),
(19631, '2.30.42.10-FF-000506', NULL, NULL, 95, NULL, NULL, 19631),
(19632, '3.30.160.60-FF-003103', NULL, NULL, 32, NULL, NULL, 19632),
(19633, '1.25.40.10-FF-003658', NULL, 'Tetratricopeptide repeat protein 8', 141, NULL, NULL, 19633),
(19634, '2.60.120.620-FF-000070', NULL, 'Uncharacterized protein', 179, NULL, NULL, 19634);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(19635, '1.10.287.130-FF-000182', NULL, 'Histidine kinase sensor protein', 125, NULL, NULL, 19635),
(19636, '3.30.40.10-FF-000157', NULL, 'Lysine (K)-specific demethylase 5A', 42, NULL, NULL, 19636),
(19637, '1.10.287.70-FF-000107', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 152, NULL, NULL, 19637),
(19638, '3.30.200.40-FF-000010', NULL, 'Uncharacterized protein', 152, NULL, NULL, 19638),
(19639, '3.30.505.10-FF-000147', NULL, NULL, 145, NULL, NULL, 19639),
(19640, '3.40.50.1820-FF-000394', NULL, 'Alpha/beta fold hydrolase', 241, NULL, NULL, 19640),
(19641, '3.90.70.10-FF-000532', NULL, 'Ubiquitinyl hydrolase 1', 217, NULL, NULL, 19641),
(19642, '1.25.40.10-FF-004951', NULL, 'Uncharacterized protein', 170, NULL, NULL, 19642),
(19643, '2.60.120.260-FF-000040', NULL, 'Reelin', 150, NULL, NULL, 19643),
(19644, '3.40.50.300-FF-006015', NULL, 'Uncharacterized protein', 223, NULL, NULL, 19644),
(19645, '3.40.30.10-FF-001027', NULL, 'Thioredoxin-like 4B', 50, NULL, NULL, 19645),
(19646, '1.20.58.390-FF-000264', NULL, 'Glutamate-gated chloride channel, putative', 91, NULL, NULL, 19646),
(19647, '3.60.10.10-FF-000007', NULL, 'Deoxyribonuclease', 260, NULL, NULL, 19647),
(19648, '1.10.287.950-FF-000040', NULL, 'Methyl-accepting chemotaxis sensory transducer', 208, NULL, NULL, 19648),
(19649, '1.20.1270.60-FF-000107', NULL, 'Slit-Robo GAP homolog', 291, NULL, NULL, 19649),
(19650, '2.80.10.50-FF-000279', NULL, 'Cellulase containing protein', 83, NULL, NULL, 19650),
(19651, '3.40.50.1820-FF-001411', NULL, 'Uncharacterized protein', 205, NULL, NULL, 19651),
(19652, '3.90.1640.10-FF-000025', NULL, 'Putative exopolyphosphatase', 242, NULL, NULL, 19652),
(19653, '3.80.10.10-FF-001816', NULL, 'Leucine-rich repeat containing protein', 156, NULL, NULL, 19653),
(19654, '3.30.70.380-FF-000014', NULL, NULL, 81, NULL, NULL, 19654),
(19655, '1.20.58.60-FF-000307', NULL, 'Spectrin beta, non-erythrocytic 5', 211, NULL, NULL, 19655),
(19656, '2.60.120.650-FF-000174', NULL, 'Uncharacterized protein', 357, NULL, NULL, 19656),
(19657, '3.30.1370.50-FF-000007', NULL, 'Transcriptional repressor NF-X1', 79, NULL, NULL, 19657),
(19658, '1.20.1070.10-FF-001426', NULL, 'Predicted protein', 227, NULL, NULL, 19658),
(19659, '3.40.50.720-FF-001638', NULL, 'Uncharacterized protein', 321, NULL, NULL, 19659),
(19660, '1.10.30.10-FF-000162', NULL, 'HMG box-containing protein C19G7.04', 54, NULL, NULL, 19660),
(19661, '3.30.420.10-FF-000394', NULL, NULL, 60, NULL, NULL, 19661),
(19662, '2.60.470.10-FF-000012', NULL, 'Pickpocket 7', 195, NULL, NULL, 19662),
(19663, '2.30.110.10-FF-000003', NULL, 'UPF0306 protein YhbP', 139, NULL, NULL, 19663),
(19664, '1.20.920.10-FF-000161', NULL, 'SNF2-family ATP dependent chromatin remodeling factor snf21', 118, NULL, NULL, 19664),
(19665, '1.25.40.10-FF-000348', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 146, NULL, NULL, 19665),
(19666, '2.30.30.40-FF-000038', NULL, 'kalirin isoform X1', 72, NULL, NULL, 19666),
(19667, '2.40.30.10-FF-000181', NULL, 'Vibriobactin utilization protein ViuB', 127, NULL, NULL, 19667),
(19668, '3.80.10.10-FF-003603', NULL, 'Uncharacterized protein', 126, NULL, NULL, 19668),
(19669, '3.30.1360.180-FF-000012', NULL, 'Secreted ectonucleotide pyrophosphatase/phosphodiesterase, putative', 91, NULL, NULL, 19669),
(19670, '2.30.30.40-FF-000190', NULL, 'Tyrosine-protein kinase', 64, NULL, NULL, 19670),
(19671, '1.25.40.10-FF-004619', NULL, 'Uncharacterized protein', 158, NULL, NULL, 19671),
(19672, '3.80.10.10-FF-002985', NULL, 'Uncharacterized protein', 197, NULL, NULL, 19672),
(19673, '2.60.120.650-FF-000230', NULL, 'Predicted protein', 162, NULL, NULL, 19673),
(19674, '1.10.530.40-FF-000007', NULL, 'Peptidoglycan hydrolase gp36', 142, NULL, NULL, 19674),
(19675, '3.40.50.300-FF-007139', NULL, 'Uncharacterized protein', 178, NULL, NULL, 19675),
(19676, '3.30.70.20-FF-000083', NULL, NULL, 58, NULL, NULL, 19676),
(19677, '3.30.420.10-FF-000450', NULL, NULL, 188, NULL, NULL, 19677),
(19678, '2.60.34.10-FF-000071', NULL, 'Uncharacterized protein', 135, NULL, NULL, 19678);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(19679, '3.30.200.20-FF-002269', NULL, 'Uncharacterized protein', 112, NULL, NULL, 19679),
(19680, '3.40.50.150-FF-000877', NULL, 'Toxin biosynthesis regulatory protein AflJ, putative', 252, NULL, NULL, 19680),
(19681, '3.90.190.10-FF-000457', NULL, 'Protein-tyrosine-phosphatase', 203, NULL, NULL, 19681),
(19682, '3.40.50.1000-FF-000592', NULL, NULL, 143, NULL, NULL, 19682),
(19683, '3.40.50.300-FF-001687', NULL, 'Probable ATP-dependent DNA helicase', 110, NULL, NULL, 19683),
(19684, '3.30.497.10-FF-000082', NULL, 'Serine proteinase inhibitor, clade B, member 1', 216, NULL, NULL, 19684),
(19685, '3.80.10.10-FF-004166', NULL, 'Uncharacterized protein', 100, NULL, NULL, 19685),
(19686, '3.30.200.20-FF-000291', NULL, 'STE20-related kinase adapter protein beta isoform X1', 89, NULL, NULL, 19686),
(19687, '3.10.100.10-FF-000222', NULL, 'Uncharacterized protein', 146, NULL, NULL, 19687),
(19688, '3.30.1680.10-FF-000041', NULL, 'Semaphorin-5c', 50, NULL, NULL, 19688),
(19689, '3.40.50.620-FF-000361', NULL, 'Putative carbamoyl-phosphate synthase', 181, NULL, NULL, 19689),
(19690, '1.10.167.10-FF-000064', NULL, 'Uncharacterized protein', 140, NULL, NULL, 19690),
(19691, '1.25.40.20-FF-001245', NULL, 'Uncharacterized protein', 238, NULL, NULL, 19691),
(19692, '3.30.1310.10-FF-000014', NULL, 'Nucleoid-associated protein slr1847', 105, NULL, NULL, 19692),
(19693, '3.40.50.300-FF-006690', NULL, 'Uncharacterized protein', 81, NULL, NULL, 19693),
(19694, '3.10.20.90-FF-000803', NULL, 'Uncharacterized protein', 57, NULL, NULL, 19694),
(19695, '3.60.10.10-FF-000406', NULL, 'Type I inositol polyphosphate 5-phosphatase 2', 142, NULL, NULL, 19695),
(19696, '3.90.260.10-FF-000053', NULL, 'Uncharacterized protein', 108, NULL, NULL, 19696),
(19697, '3.30.1370.30-FF-000001', NULL, '40S ribosomal protein S15a', 69, NULL, NULL, 19697),
(19698, '3.30.1360.10-FF-000017', NULL, 'DNA-directed RNA polymerase I-like protein', 69, NULL, NULL, 19698),
(19699, '3.30.530.20-FF-000045', NULL, 'BnaA09g52170D protein', 167, NULL, NULL, 19699),
(19700, '1.20.140.10-FF-000039', NULL, 'Acyl-CoA dehydrogenase FadE14', 146, NULL, NULL, 19700),
(19701, '3.40.50.150-FF-001153', NULL, NULL, 113, NULL, NULL, 19701),
(19702, '3.90.180.10-FF-000052', NULL, 'Alcohol dehydrogenase, zinc-containing', 183, NULL, NULL, 19702),
(19703, '1.20.58.1120-FF-000021', NULL, 'Dynein heavy chain family protein', 144, NULL, NULL, 19703),
(19704, '3.30.420.40-FF-000498', NULL, 'DnaK-type molecular chaperone', 176, NULL, NULL, 19704),
(19705, '3.40.1090.10-FF-000022', NULL, 'Neuropathy target esterase sws', 167, NULL, NULL, 19705),
(19706, '2.60.40.10-FF-005688', NULL, NULL, 77, NULL, NULL, 19706),
(19707, '3.55.40.20-FF-000025', NULL, 'Bll8073 protein', 120, NULL, NULL, 19707),
(19708, '1.20.1310.10-FF-000001', NULL, 'Cullin 3', 121, NULL, NULL, 19708),
(19709, '1.25.40.10-FF-004390', NULL, 'Uncharacterized protein', 141, NULL, NULL, 19709),
(19710, '2.20.70.10-FF-000072', NULL, 'Rho GTPase activating protein 12b', 51, NULL, NULL, 19710),
(19711, '3.30.70.330-FF-001825', NULL, NULL, 152, NULL, NULL, 19711),
(19712, '2.60.40.1180-FF-000029', NULL, 'Alpha-mannosidase', 100, NULL, NULL, 19712),
(19713, '3.40.50.2300-FF-000903', NULL, NULL, 107, NULL, NULL, 19713),
(19714, '3.10.10.10-FF-000032', NULL, NULL, 73, NULL, NULL, 19714),
(19715, '3.40.50.360-FF-000030', NULL, 'ribosyldihydronicotinamide dehydrogenase [quinone]', 231, NULL, NULL, 19715),
(19716, '2.60.120.260-FF-000383', NULL, 'Disintegrin and metalloproteinase domain-containing protein 15', 40, NULL, NULL, 19716),
(19717, '1.25.40.10-FF-003990', NULL, 'Predicted protein', 215, NULL, NULL, 19717),
(19718, '1.10.510.10-FF-004342', NULL, NULL, 127, NULL, NULL, 19718),
(19719, '3.30.450.350-FF-000001', NULL, 'Histidine kinase 4', 216, NULL, NULL, 19719),
(19720, '2.20.70.10-FF-000234', NULL, 'Uncharacterized protein', 64, NULL, NULL, 19720),
(19721, '2.60.220.30-FF-000016', NULL, 'MET transcriptional regulator MACC1', 122, NULL, NULL, 19721),
(19722, '1.10.630.10-FF-000287', NULL, 'Cytochrome P-450 IIC5, putative', 147, NULL, NULL, 19722);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(19723, '3.40.50.620-FF-000541', NULL, 'tRNA glutamyl-Q(34) synthetase GluQRS', 299, NULL, NULL, 19723),
(19724, '1.10.3720.10-FF-000001', NULL, 'Glycine betaine ABC transporter, permease', 194, NULL, NULL, 19724),
(19725, '3.40.50.1820-FF-001810', NULL, 'Uncharacterized protein', 122, NULL, NULL, 19725),
(19726, '3.10.20.870-FF-000021', NULL, NULL, 77, NULL, NULL, 19726),
(19727, '3.40.50.300-FF-002980', NULL, 'ABC transporter C family member 9', 150, NULL, NULL, 19727),
(19728, '3.30.1380.10-FF-000001', NULL, 'Indian hedgehog', 168, NULL, NULL, 19728),
(19729, '1.50.40.10-FF-000380', NULL, 'Peroxisomal membrane protein PMP34', 92, NULL, NULL, 19729),
(19730, '3.40.50.12780-FF-000180', NULL, 'Uncharacterized protein', 261, NULL, NULL, 19730),
(19731, '3.30.870.10-FF-000146', NULL, 'Uncharacterized protein', 324, NULL, NULL, 19731),
(19732, '3.30.160.60-FF-002086', NULL, 'Uncharacterized protein', 29, NULL, NULL, 19732),
(19733, '1.20.1070.10-FF-001825', NULL, 'Opsin', 307, NULL, NULL, 19733),
(19734, '2.130.10.10-FF-002581', NULL, 'Uncharacterized protein', 49, NULL, NULL, 19734),
(19735, '3.30.230.10-FF-000183', NULL, 'UTP--glucose-1-phosphate uridylyltransferase-like protein', 203, NULL, NULL, 19735),
(19736, '1.10.10.10-FF-000492', NULL, 'Transcriptional regulator, AsnC family', 52, NULL, NULL, 19736),
(19737, '1.20.5.550-FF-000003', NULL, 'Bifunctional protein PutA', 51, NULL, NULL, 19737),
(19738, '3.30.70.330-FF-002225', NULL, NULL, 93, NULL, NULL, 19738),
(19739, '1.20.1250.20-FF-000235', NULL, 'Solute carrier family 43 (amino acid system L transporter), member 2b', 162, NULL, NULL, 19739),
(19740, '3.30.2410.10-FF-000016', NULL, 'E3 ubiquitin-protein ligase HACE1 isoform X1', 120, NULL, NULL, 19740),
(19741, '2.40.110.10-FF-000006', NULL, 'very long-chain specific acyl-CoA dehydrogenase, mitochondrial', 114, NULL, NULL, 19741),
(19742, '2.160.20.160-FF-000001', NULL, 'RTX toxin', 283, NULL, NULL, 19742),
(19743, '2.60.200.20-FF-000068', NULL, 'TIFA inhibitor', 102, NULL, NULL, 19743),
(19744, '2.60.40.50-FF-000001', NULL, 'Transcription attenuation protein MtrB', 74, NULL, NULL, 19744),
(19745, '3.40.850.10-FF-000098', NULL, 'Kinesin-like protein KIN-10C', 340, NULL, NULL, 19745),
(19746, '1.20.58.110-FF-000006', NULL, '30S ribosomal protein S20', 90, NULL, NULL, 19746),
(19747, '2.40.180.10-FF-000011', NULL, 'Lipoxygenase homology domain-containing protein 1', 136, NULL, NULL, 19747),
(19748, '3.10.310.10-FF-000047', NULL, 'Diaminopimelate epimerase', 123, NULL, NULL, 19748),
(19749, '3.40.50.720-FF-000801', NULL, 'Pyrroline-5-carboxylate reductase', 163, NULL, NULL, 19749),
(19750, '3.40.50.1820-FF-000118', NULL, 'Carboxypeptidase', 475, NULL, NULL, 19750),
(19751, '1.25.40.10-FF-000404', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 251, NULL, NULL, 19751),
(19752, '3.30.160.60-FF-006357', NULL, NULL, 42, NULL, NULL, 19752),
(19753, '1.20.1160.11-FF-000001', NULL, 'Paired amphipathic helix protein Sin3', 63, NULL, NULL, 19753),
(19754, '3.40.50.12650-FF-000045', NULL, 'Sterile alpha motif (SAM) domain-containing protein', 84, NULL, NULL, 19754),
(19755, '3.40.50.300-FF-006358', NULL, 'Gluconokinase', 141, NULL, NULL, 19755),
(19756, '3.30.360.10-FF-000063', NULL, 'Oxidoreductase family protein', 229, NULL, NULL, 19756),
(19757, '1.20.58.390-FF-000320', NULL, 'Glycine receptor alpha 4b subunit', 64, NULL, NULL, 19757),
(19758, '3.50.50.100-FF-000057', NULL, 'Uncharacterized protein', 223, NULL, NULL, 19758),
(19759, '1.25.10.10-FF-002488', NULL, 'Armadillo repeat-containing protein 10', 208, NULL, NULL, 19759),
(19760, '3.30.70.330-FF-000988', NULL, 'Developmentally regulated RNA-binding protein', 85, NULL, NULL, 19760),
(19761, '3.40.50.150-FF-001097', NULL, NULL, 191, NULL, NULL, 19761),
(19762, '3.40.50.720-FF-002190', NULL, 'Uncharacterized protein', 35, NULL, NULL, 19762),
(19763, '3.30.559.30-FF-000081', NULL, 'Non-ribosomal peptide synthetase', 221, NULL, NULL, 19763),
(19764, '3.10.20.90-FF-000242', NULL, 'Putative polycomb group RING finger protein 5', 111, NULL, NULL, 19764);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(19765, '3.30.70.330-FF-001264', NULL, 'tRNA selenocysteine 1 associated protein 1b', 105, NULL, NULL, 19765),
(19766, '1.10.10.10-FF-001453', NULL, 'Meiotic recombination protein Spo11', 68, NULL, NULL, 19766),
(19767, '3.40.50.150-FF-001838', NULL, NULL, 59, NULL, NULL, 19767),
(19768, '2.40.10.10-FF-000179', NULL, 'Genome polyprotein', 118, NULL, NULL, 19768),
(19769, '3.30.1520.10-FF-000171', NULL, 'Uncharacterized protein', 114, NULL, NULL, 19769),
(19770, '3.40.630.30-FF-000273', NULL, 'Os12g0561600 protein', 155, NULL, NULL, 19770),
(19771, '3.40.50.620-FF-000209', NULL, 'Electron transfer flavoprotein subunit alpha, mitochondrial', 97, NULL, NULL, 19771),
(19772, '2.40.50.140-FF-000350', NULL, '30S ribosomal protein S1', 85, NULL, NULL, 19772),
(19773, '3.30.310.10-FF-000060', NULL, 'Ribonuclease HIII', 70, NULL, NULL, 19773),
(19774, '3.30.160.60-FF-002647', NULL, 'Protein CBG05518', 29, NULL, NULL, 19774),
(19775, '3.40.50.1980-FF-000014', NULL, 'Ferrienterobactin-binding periplasmic protein FepB', 173, NULL, NULL, 19775),
(19776, '2.60.40.150-FF-000829', NULL, 'Uncharacterized protein', 128, NULL, NULL, 19776),
(19777, '3.50.50.60-FF-001368', NULL, 'Uncharacterized protein', 11, NULL, NULL, 19777),
(19778, '3.30.310.20-FF-000006', NULL, 'DNA methylation and regulatory protein Ada', 118, NULL, NULL, 19778),
(19779, '2.60.40.10-FF-002434', NULL, 'Titin homolog', 94, NULL, NULL, 19779),
(19780, '2.40.50.140-FF-000474', NULL, 'Lysine--tRNA ligase', 146, NULL, NULL, 19780),
(19781, '3.80.10.10-FF-000512', NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3', 160, NULL, NULL, 19781),
(19782, '3.30.70.1700-FF-000001', NULL, 'Phage minor tail protein', 131, NULL, NULL, 19782),
(19783, '1.25.40.10-FF-003097', NULL, 'YALI0A10296p', 110, NULL, NULL, 19783),
(19784, '3.40.50.1820-FF-000450', NULL, 'PAF acetylhydrolase family protein', 357, NULL, NULL, 19784),
(19785, '1.10.10.10-FF-001852', NULL, 'Topoisomerase-like enzyme1', 77, NULL, NULL, 19785),
(19786, '3.30.420.10-FF-000118', NULL, 'Poly(A)-specific ribonuclease PARN, putative', 156, NULL, NULL, 19786),
(19787, '3.30.40.10-FF-000718', NULL, 'RBR-type E3 ubiquitin transferase', 91, NULL, NULL, 19787),
(19788, '3.30.160.60-FF-003047', NULL, NULL, 27, NULL, NULL, 19788),
(19789, '3.40.33.10-FF-000089', NULL, 'Uncharacterized protein', 174, NULL, NULL, 19789),
(19790, '3.30.1460.10-FF-000002', NULL, 'Exoenzyme S synthesis protein C', 133, NULL, NULL, 19790),
(19791, '1.25.10.10-FF-001689', NULL, 'Vacuolar protein 14 C-terminal Fig4p binding, putative', 285, NULL, NULL, 19791),
(19792, '1.20.1070.10-FF-000465', NULL, 'Predicted protein', 312, NULL, NULL, 19792),
(19793, '2.30.42.10-FF-000326', NULL, 'Syntenin-1', 96, NULL, NULL, 19793),
(19794, '1.10.540.10-FF-000128', NULL, 'Acyl-CoA dehydrogenase', 117, NULL, NULL, 19794),
(19795, '3.30.200.20-FF-002089', NULL, 'Cyclin dependent kinase', 82, NULL, NULL, 19795),
(19796, '3.40.630.10-FF-000115', NULL, 'Nicalin-1', 285, NULL, NULL, 19796),
(19797, '3.40.50.1000-FF-000316', NULL, 'HAD family hydrolase', 192, NULL, NULL, 19797),
(19798, '1.25.10.10-FF-002089', NULL, 'U3 small nucleolar RNA-associated protein 10', 140, NULL, NULL, 19798),
(19799, '3.30.360.20-FF-000009', NULL, 'Uncharacterized protein', 102, NULL, NULL, 19799),
(19800, '3.20.20.100-FF-000153', NULL, 'Uncharacterized protein', 260, NULL, NULL, 19800),
(19801, '1.20.120.220-FF-000010', NULL, 'ATP synthase subunit a', 173, NULL, NULL, 19801),
(19802, '3.40.50.300-FF-006919', NULL, 'Lipoprotein-releasing system ATP-binding protein LolD', 233, NULL, NULL, 19802),
(19803, '1.10.268.10-FF-000028', NULL, NULL, 151, NULL, NULL, 19803),
(19804, '3.40.140.10-FF-000263', NULL, 'CMP/dCMP deaminase zinc-binding', 117, NULL, NULL, 19804),
(19805, '3.10.129.10-FF-000272', NULL, 'Acyl coenzyme A thioester hydrolase', 149, NULL, NULL, 19805),
(19806, '1.10.10.10-FF-000172', NULL, 'Arginine repressor', 64, NULL, NULL, 19806),
(19807, '2.40.70.10-FF-000554', NULL, NULL, 239, NULL, NULL, 19807),
(19808, '3.90.550.10-FF-000171', NULL, 'Glycosyl transferase family protein', 296, NULL, NULL, 19808);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(19809, '1.20.5.340-FF-000081', NULL, 'AGR282Wp', 99, NULL, NULL, 19809),
(19810, '2.60.40.60-FF-000515', NULL, 'Uncharacterized protein', 116, NULL, NULL, 19810),
(19811, '2.10.25.10-FF-001788', NULL, 'Uncharacterized protein', 31, NULL, NULL, 19811),
(19812, '2.60.15.10-FF-000009', NULL, 'ATP synthase F1 subcomplex epsilon subunit', 82, NULL, NULL, 19812),
(19813, '3.30.420.40-FF-000925', NULL, 'Uncharacterized protein', 127, NULL, NULL, 19813),
(19814, '1.20.58.60-FF-000190', NULL, 'Nesprin-1 isoform 1', 214, NULL, NULL, 19814),
(19815, '2.40.10.240-FF-000001', NULL, 'S-adenosylmethionine:tRNA ribosyltransferase-isomerase', 100, NULL, NULL, 19815),
(19816, '1.10.10.60-FF-001226', NULL, NULL, 60, NULL, NULL, 19816),
(19817, '3.30.70.330-FF-003057', NULL, NULL, 107, NULL, NULL, 19817),
(19818, '2.130.10.10-FF-002226', NULL, 'Uncharacterized WD repeat-containing protein C343.17c', 78, NULL, NULL, 19818),
(19819, '3.40.50.150-FF-000618', NULL, 'Putative mRNA capping methyltransferase', 300, NULL, NULL, 19819),
(19820, '3.40.190.10-FF-000311', NULL, 'Glycine/betaine ABC transporter substrate-binding protein', 152, NULL, NULL, 19820),
(19821, '3.80.10.10-FF-003250', NULL, 'Uncharacterized protein', 344, NULL, NULL, 19821),
(19822, '4.10.240.10-FF-000133', NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', 64, NULL, NULL, 19822),
(19823, '3.50.50.60-FF-000295', NULL, 'Amine oxidase', 74, NULL, NULL, 19823),
(19824, '1.10.3460.10-FF-000014', NULL, 'BnaA08g04420D protein', 124, NULL, NULL, 19824),
(19825, '2.60.120.620-FF-000047', NULL, 'Multifunctional procollagen lysine hydroxylase and glycosyltransferase', 172, NULL, NULL, 19825),
(19826, '1.10.510.10-FF-003206', NULL, NULL, 145, NULL, NULL, 19826),
(19827, '1.25.40.10-FF-005204', NULL, 'Predicted protein', 205, NULL, NULL, 19827),
(19828, '3.40.190.10-FF-000783', NULL, 'Similar to periplasmic dipeptide transport protein (Dipeptide-binding protein) (DBP)-putative secreted, membrane associated or paryphoplasmic protein', 50, NULL, NULL, 19828),
(19829, '1.20.1250.20-FF-001117', NULL, 'Putative allantoate permease of the major facilitator superfamily', 214, NULL, NULL, 19829),
(19830, '3.30.70.100-FF-000200', NULL, NULL, 107, NULL, NULL, 19830),
(19831, '1.20.1250.20-FF-000128', NULL, 'monocarboxylate transporter 12 isoform X1', 192, NULL, NULL, 19831),
(19832, '2.40.70.10-FF-000115', NULL, 'Lysosomal aspartic protease', 239, NULL, NULL, 19832),
(19833, '2.40.37.10-FF-000027', NULL, 'Antizyme inhibitor 1a', 13, NULL, NULL, 19833),
(19834, '3.30.160.60-FF-003316', NULL, 'Zinc finger protein 433', 24, NULL, NULL, 19834),
(19835, '2.130.10.10-FF-003171', NULL, 'Periodic tryptophan protein 2 homolog', 291, NULL, NULL, 19835),
(19836, '3.10.100.10-FF-000189', NULL, 'Uncharacterized protein', 152, NULL, NULL, 19836),
(19837, '1.10.10.2660-FF-000007', NULL, 'SUMO-activating enzyme subunit', 70, NULL, NULL, 19837),
(19838, '3.80.10.10-FF-002305', NULL, 'Centrosomal protein 78', 196, NULL, NULL, 19838),
(19839, '2.130.10.10-FF-002182', NULL, 'Predicted protein', 183, NULL, NULL, 19839),
(19840, '3.80.10.10-FF-002261', NULL, 'Leucine-rich repeat-containing protein ODA7', 105, NULL, NULL, 19840),
(19841, '1.10.20.130-FF-000003', NULL, 'Poly [ADP-ribose] polymerase', 74, NULL, NULL, 19841),
(19842, '2.10.25.10-FF-000170', NULL, 'thrombospondin-3 isoform X1', 49, NULL, NULL, 19842),
(19843, '3.30.540.10-FF-000054', NULL, 'Fructose-1,6-bisphosphatase 1-like Protein', 209, NULL, NULL, 19843),
(19844, '1.10.510.10-FF-002217', NULL, 'Predicted protein', 184, NULL, NULL, 19844),
(19845, '1.10.1300.10-FF-000093', NULL, 'Phosphodiesterase', 108, NULL, NULL, 19845),
(19846, '3.10.105.10-FF-000065', NULL, 'ABC transporter, oligopeptide-binding protein', 230, NULL, NULL, 19846),
(19847, '3.30.70.330-FF-002068', NULL, NULL, 86, NULL, NULL, 19847),
(19848, '3.30.70.330-FF-001449', NULL, 'RNA-binding_protein_38', 118, NULL, NULL, 19848),
(19849, '3.10.390.10-FF-000018', NULL, 'Nuclear autoantigen Sp-100', 60, NULL, NULL, 19849),
(19850, '1.20.120.1200-FF-000013', NULL, 'NADH-quinone oxidoreductase subunit J', 156, NULL, NULL, 19850);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(19851, '1.25.40.10-FF-001944', NULL, 'Pentatricopeptide repeat-containing protein At5g66520 family', 102, NULL, NULL, 19851),
(19852, '4.10.90.10-FF-000001', NULL, 'Genome polyprotein', 85, NULL, NULL, 19852),
(19853, '1.20.1730.10-FF-000061', NULL, 'Probable sodium/proline symporter (Proline permease)', 512, NULL, NULL, 19853),
(19854, '2.60.40.60-FF-000987', NULL, 'Protein CBR-CDH-12', 118, NULL, NULL, 19854),
(19855, '1.10.10.10-FF-001161', NULL, 'Leucine-rich repeat serine/threonine-protein kinase 2', 85, NULL, NULL, 19855),
(19856, '3.30.460.10-FF-000020', NULL, 'DNA polymerase lambda', 119, NULL, NULL, 19856),
(19857, '3.40.50.80-FF-000133', NULL, 'Methionine synthase reductase, mitochondrial-like protein', 194, NULL, NULL, 19857),
(19858, '1.10.238.10-FF-000639', NULL, 'Centrin, putative', 82, NULL, NULL, 19858),
(19859, '1.10.10.60-FF-000607', NULL, 'DNA-binding protein SATB1', 96, NULL, NULL, 19859),
(19860, '1.10.510.10-FF-000891', NULL, 'SK22 like MAPKK kinase, putative', 302, NULL, NULL, 19860),
(19861, '2.40.290.30-FF-000008', NULL, 'Uncharacterized protein', 163, NULL, NULL, 19861),
(19862, '3.30.830.10-FF-000301', NULL, 'Uncharacterized protein', 256, NULL, NULL, 19862),
(19863, '2.60.40.10-FF-000124', NULL, 'Myomesin 1', 95, NULL, NULL, 19863),
(19864, '3.30.160.60-FF-001029', NULL, 'PR domain containing 14', 76, NULL, NULL, 19864),
(19865, '1.10.1000.11-FF-000026', NULL, 'ArfGEF', 125, NULL, NULL, 19865),
(19866, '3.40.50.300-FF-005133', NULL, 'Signal recognition particle receptor beta subunit, putative', 242, NULL, NULL, 19866),
(19867, '1.20.58.390-FF-000180', NULL, 'Uncharacterized protein', 117, NULL, NULL, 19867),
(19868, '1.25.40.690-FF-000007', NULL, 'Nucleoporin NUP145', 92, NULL, NULL, 19868),
(19869, '2.60.40.10-FF-005767', NULL, NULL, 102, NULL, NULL, 19869),
(19870, '3.40.50.11030-FF-000003', NULL, 'Threonylcarbamoyl-AMP synthase', 158, NULL, NULL, 19870),
(19871, '1.10.287.110-FF-000344', NULL, 'Chaperone protein DNAJ, putative', 64, NULL, NULL, 19871),
(19872, '3.30.40.10-FF-000269', NULL, 'Transcription initiation factor IIE subunit alpha', 62, NULL, NULL, 19872),
(19873, '2.40.50.40-FF-000067', NULL, 'LytTR family transcriptional regulator', 70, NULL, NULL, 19873),
(19874, '1.20.1270.10-FF-000025', NULL, 'heat shock 70 kDa protein-like', 74, NULL, NULL, 19874),
(19875, '3.30.930.10-FF-000348', NULL, 'Aspartate--tRNA ligase chloroplastic/mitochondrial', 66, NULL, NULL, 19875),
(19876, '3.10.28.10-FF-000045', NULL, 'Vitamin B12-dependent ribonucleotide reductase', 88, NULL, NULL, 19876),
(19877, '3.20.20.80-FF-000115', NULL, 'Beta-galactosidase', 276, NULL, NULL, 19877),
(19878, '3.80.10.10-FF-001316', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 94, NULL, NULL, 19878),
(19879, '3.40.50.620-FF-000001', NULL, 'GMP synthase [glutamine-hydrolyzing]', 202, NULL, NULL, 19879),
(19880, '2.30.30.40-FF-000645', NULL, 'Myosin-1', 77, NULL, NULL, 19880),
(19881, '1.25.10.10-FF-001324', NULL, 'Exonuclease 3''-5'' domain-containing 3', 1150, NULL, NULL, 19881),
(19882, '3.40.50.2300-FF-001544', NULL, NULL, 43, NULL, NULL, 19882),
(19883, '3.40.50.300-FF-001108', NULL, 'DNA polymerase III subunit delta', 161, NULL, NULL, 19883),
(19884, '3.40.50.300-FF-006914', NULL, 'Uncharacterized protein', 236, NULL, NULL, 19884),
(19885, '2.40.10.10-FF-000106', NULL, 'Probable threonine protease PRSS50', 101, NULL, NULL, 19885),
(19886, '3.40.525.10-FF-000022', NULL, 'SEC14 cytosolic factor family protein', 179, NULL, NULL, 19886),
(19887, '3.30.1680.10-FF-000013', NULL, 'Semaphorin 4D', 56, NULL, NULL, 19887),
(19888, '1.25.40.10-FF-002450', NULL, 'Pentatricopeptide repeat-containing protein At1g05670, mitochondrial', 73, NULL, NULL, 19888),
(19889, '1.10.418.10-FF-000254', NULL, 'Uncharacterized protein', 87, NULL, NULL, 19889),
(19890, '2.40.10.10-FF-000095', NULL, 'Kallikrein related-peptidase 12', 118, NULL, NULL, 19890),
(19891, '3.40.50.2000-FF-000263', NULL, 'Glycogen synthase', 200, NULL, NULL, 19891),
(19892, '3.30.420.60-FF-000009', NULL, 'Protein pelota homolog', 138, NULL, NULL, 19892);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(19893, '1.10.10.10-FF-001953', NULL, 'Histone H1-II-1, putative', 80, NULL, NULL, 19893),
(19894, '3.40.1110.10-FF-000120', NULL, 'Phospholipid-transporting ATPase', 165, NULL, NULL, 19894),
(19895, '2.30.42.10-FF-000427', NULL, NULL, 72, NULL, NULL, 19895),
(19896, '2.40.290.10-FF-000002', NULL, 'Spen family transcriptional repressor', 168, NULL, NULL, 19896),
(19897, '1.10.10.1100-FF-000017', NULL, 'FAD/NAD(P)-binding oxidoreductase', 70, NULL, NULL, 19897),
(19898, '2.60.120.590-FF-000083', NULL, 'Uncharacterized protein', 114, NULL, NULL, 19898),
(19899, '2.30.30.40-FF-000162', NULL, 'MIA SH3 domain ER export factor 3', 99, NULL, NULL, 19899),
(19900, '3.40.50.800-FF-000050', NULL, 'Threonine--tRNA ligase, mitochondrial', 124, NULL, NULL, 19900),
(19901, '1.25.40.10-FF-004687', NULL, 'Anaphase-promoting complex subunit 3', 103, NULL, NULL, 19901),
(19902, '2.130.10.10-FF-000618', NULL, 'WD repeat-containing protein 75', 237, NULL, NULL, 19902),
(19903, '2.60.40.1170-FF-000037', NULL, 'AP-3 complex subunit mu, putative', 136, NULL, NULL, 19903),
(19904, '2.40.30.10-FF-000006', NULL, 'Elongation factor G', 116, NULL, NULL, 19904),
(19905, '1.10.510.10-FF-003162', NULL, NULL, 170, NULL, NULL, 19905),
(19906, '3.30.70.2760-FF-000004', NULL, 'HD domain containing protein', 122, NULL, NULL, 19906),
(19907, '2.30.30.100-FF-000218', NULL, 'Uncharacterized protein', 76, NULL, NULL, 19907),
(19908, '3.10.110.10-FF-000015', NULL, 'Ubiquitin-conjugating enzyme E2 N', 152, NULL, NULL, 19908),
(19909, '3.40.50.300-FF-004986', NULL, 'Heparan SulphoTransferase', 269, NULL, NULL, 19909),
(19910, '2.30.110.10-FF-000054', NULL, 'Uncharacterized protein', 132, NULL, NULL, 19910),
(19911, '3.60.130.20-FF-000002', NULL, 'Prolyl 3,4-dihydroxylase TPA1', 340, NULL, NULL, 19911),
(19912, '1.10.510.10-FF-000289', NULL, 'cyclin-dependent kinase 10 isoform X2', 223, NULL, NULL, 19912),
(19913, '1.10.510.10-FF-004504', NULL, NULL, 77, NULL, NULL, 19913),
(19914, '3.40.50.720-FF-000161', NULL, 'UDP-N-acetylmuramate--L-alanyl-gamma-D-glutamyl-meso-2,6-diaminoheptandioate ligase', 90, NULL, NULL, 19914),
(19915, '2.10.50.10-FF-000003', NULL, 'Tumor necrosis factor receptor superfamily member 19', 82, NULL, NULL, 19915),
(19916, '3.40.630.30-FF-000014', NULL, 'N-alpha-acetyltransferase 10 isoform X1', 179, NULL, NULL, 19916),
(19917, '1.25.40.70-FF-000074', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', 181, NULL, NULL, 19917),
(19918, '1.20.1250.20-FF-001909', NULL, 'Protein NUCLEAR FUSION DEFECTIVE 4', 235, NULL, NULL, 19918),
(19919, '2.60.40.1090-FF-000002', NULL, 'Fimbrial protein YadN', 168, NULL, NULL, 19919),
(19920, '1.20.58.2190-FF-000004', NULL, 'E3 ubiquitin-protein ligase RNF31', 179, NULL, NULL, 19920),
(19921, '2.30.42.10-FF-000057', NULL, 'multiple PDZ domain protein isoform X1', 97, NULL, NULL, 19921),
(19922, '2.10.25.10-FF-000962', NULL, 'Uncharacterized protein', 49, NULL, NULL, 19922),
(19923, '4.10.410.10-FF-000096', NULL, 'Uncharacterized protein', 68, NULL, NULL, 19923),
(19924, '3.40.50.960-FF-000002', NULL, '6,7-dimethyl-8-ribityllumazine synthase', 158, NULL, NULL, 19924),
(19925, '1.25.10.10-FF-000705', NULL, 'Pumilio domain-containing protein', 370, NULL, NULL, 19925),
(19926, '1.25.10.10-FF-003241', NULL, 'Cullin-associated NEDD8-dissociated protein 1', 242, NULL, NULL, 19926),
(19927, '3.30.760.10-FF-000065', NULL, 'Uncharacterized protein', 172, NULL, NULL, 19927),
(19928, '3.40.190.290-FF-000134', NULL, 'Uncharacterized HTH-type transcriptional regulator HI_1364', 197, NULL, NULL, 19928),
(19929, '1.25.40.10-FF-004378', NULL, 'Uncharacterized protein', 146, NULL, NULL, 19929),
(19930, '3.10.50.40-FF-000049', NULL, 'Peptidyl-prolyl cis-trans isomerase', 119, NULL, NULL, 19930),
(19931, '1.10.287.70-FF-000450', NULL, 'Voltage-dependent calcium channel subunit, putative', 127, NULL, NULL, 19931),
(19932, '3.40.50.1820-FF-000219', NULL, 'ECM18p protein', 306, NULL, NULL, 19932),
(19933, '3.30.200.20-FF-000392', NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', 106, NULL, NULL, 19933);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(19934, '3.10.20.90-FF-000894', NULL, 'Uncharacterized protein', 39, NULL, NULL, 19934),
(19935, '2.60.120.290-FF-000111', NULL, 'Suppressor of lurcher protein 1', 134, NULL, NULL, 19935),
(19936, '3.10.20.10-FF-000016', NULL, 'DNAation factor subunit alpha', 93, NULL, NULL, 19936),
(19937, '1.10.3260.10-FF-000033', NULL, 'Uncharacterized protein', 264, NULL, NULL, 19937),
(19938, '2.40.50.140-FF-000518', NULL, 'Putative Inner membrane protein', 61, NULL, NULL, 19938),
(19939, '3.20.20.70-FF-000258', NULL, 'Isopentenyl-diphosphate delta-isomerase', 368, NULL, NULL, 19939),
(19940, '3.30.70.250-FF-000003', NULL, 'Polyketide beta-ketoacyl synthase Pks3', 67, NULL, NULL, 19940),
(19941, '2.60.120.200-FF-000820', NULL, 'Uncharacterized protein', 149, NULL, NULL, 19941),
(19942, '2.30.30.40-FF-000515', NULL, 'Rho GTPase-activating protein 33', 44, NULL, NULL, 19942),
(19943, '2.60.40.10-FF-003530', NULL, NULL, 77, NULL, NULL, 19943),
(19944, '3.30.70.2120-FF-000003', NULL, 'Flagellin', 101, NULL, NULL, 19944),
(19945, '1.10.455.10-FF-000014', NULL, 'Ribosomal protein', 65, NULL, NULL, 19945),
(19946, '3.40.47.10-FF-000003', NULL, '3-ketoacyl-CoA thiolase', 158, NULL, NULL, 19946),
(19947, '3.30.413.10-FF-000023', NULL, '4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase (flavodoxin)', 98, NULL, NULL, 19947),
(19948, '3.30.1330.60-FF-000002', NULL, 'Peptidoglycan-associated lipoprotein', 129, NULL, NULL, 19948),
(19949, '3.10.20.90-FF-000585', NULL, 'DUF2407 ubiquitin-like domain containing protein', 123, NULL, NULL, 19949),
(19950, '3.30.310.80-FF-000013', NULL, 'Non-specific serine/threonine protein kinase', 106, NULL, NULL, 19950),
(19951, '1.20.910.10-FF-000020', NULL, 'Aminopyrimidine aminohydrolase', 222, NULL, NULL, 19951),
(19952, '3.40.50.300-FF-007050', NULL, 'Sulfotransferase', 198, NULL, NULL, 19952),
(19953, '3.40.50.300-FF-002732', NULL, 'Torsin family 4, member Ab', 195, NULL, NULL, 19953),
(19954, '3.30.70.270-FF-000009', NULL, 'Protein P', 84, NULL, NULL, 19954),
(19955, '1.25.40.10-FF-000516', NULL, 'Pentatricopeptide repeat-containing protein', 123, NULL, NULL, 19955),
(19956, '3.40.50.300-FF-004514', NULL, 'ABC transporter, ATP-binding protein', 303, NULL, NULL, 19956),
(19957, '1.20.1070.10-FF-000706', NULL, 'Neuropeptide Y receptor', 310, NULL, NULL, 19957),
(19958, '3.30.160.60-FF-002018', NULL, 'Zinc finger protein 556', 32, NULL, NULL, 19958),
(19959, '3.40.50.300-FF-005003', NULL, 'Uncharacterized protein', 94, NULL, NULL, 19959),
(19960, '1.20.58.70-FF-000080', NULL, 'Uncharacterized protein', 126, NULL, NULL, 19960),
(19961, '3.30.900.10-FF-000037', NULL, 'Uncharacterized protein', 244, NULL, NULL, 19961),
(19962, '1.20.144.10-FF-000031', NULL, 'PhosphoLipid PhosPhatase homolog', 264, NULL, NULL, 19962),
(19963, '3.30.70.330-FF-000640', NULL, 'UBP1-associated protein 2C', 117, NULL, NULL, 19963),
(19964, '1.25.10.10-FF-001796', NULL, 'Predicted protein', 1080, NULL, NULL, 19964),
(19965, '1.20.1250.20-FF-001752', NULL, 'Uncharacterized protein', 195, NULL, NULL, 19965),
(19966, '2.60.40.1120-FF-000085', NULL, 'Uncharacterized protein', 74, NULL, NULL, 19966),
(19967, '1.20.1070.10-FF-001342', NULL, 'Uncharacterized protein', 272, NULL, NULL, 19967),
(19968, '3.40.30.10-FF-000482', NULL, 'Protein disulfide-isomerase', 110, NULL, NULL, 19968),
(19969, '3.40.50.620-FF-000810', NULL, 'Predicted protein', 220, NULL, NULL, 19969),
(19970, '2.60.120.650-FF-000062', NULL, 'Probable inactive lysine-specific demethylase JMJ19', 347, NULL, NULL, 19970),
(19971, '1.20.58.60-FF-000543', NULL, 'Protein CBG15811', 237, NULL, NULL, 19971),
(19972, '3.90.226.10-FF-000165', NULL, 'Fatty acid oxidation complex alpha-subunit', 298, NULL, NULL, 19972),
(19973, '3.40.50.620-FF-000440', NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', 53, NULL, NULL, 19973),
(19974, '3.90.550.10-FF-000524', NULL, 'Glycosyl transferase family 2', 248, NULL, NULL, 19974),
(19975, '2.60.40.1390-FF-000002', NULL, 'PhoG like DNA-binding family protein', 245, NULL, NULL, 19975),
(19976, '1.10.760.10-FF-000009', NULL, 'Cytochrome bc1 complex cytochrome c subunit', 100, NULL, NULL, 19976);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(19977, '1.25.40.10-FF-001152', NULL, 'Os07g0244400 protein', 158, NULL, NULL, 19977),
(19978, '3.40.50.150-FF-001237', NULL, NULL, 115, NULL, NULL, 19978),
(19979, '3.40.50.1460-FF-000050', NULL, 'Phosphatidylinositol glycan', 280, NULL, NULL, 19979),
(19980, '1.10.238.10-FF-001145', NULL, 'WD repeat domain 66', 136, NULL, NULL, 19980),
(19981, '2.40.70.10-FF-000071', NULL, 'Aspartic proteinase PCS1', 179, NULL, NULL, 19981),
(19982, '3.30.1490.140-FF-000001', NULL, 'Amyloid beta (A4) protein b', 59, NULL, NULL, 19982),
(19983, '2.60.120.10-FF-000076', NULL, 'Mannose-6-phosphate isomerase', 82, NULL, NULL, 19983),
(19984, '3.40.50.10470-FF-000060', NULL, 'Uncharacterized protein', 205, NULL, NULL, 19984),
(19985, '3.40.50.300-FF-001743', NULL, 'Putative DEAD/DEAH box helicase', 199, NULL, NULL, 19985),
(19986, '3.10.310.40-FF-000011', NULL, 'Threonyl/alanyl tRNA synthetase SAD', 102, NULL, NULL, 19986),
(19987, '1.25.40.10-FF-003759', NULL, 'Uncharacterized protein', 165, NULL, NULL, 19987),
(19988, '3.30.530.20-FF-000129', NULL, 'Collagen type IV alpha-3-binding protein', 235, NULL, NULL, 19988),
(19989, '2.120.10.80-FF-000157', NULL, 'leucine-zipper-like transcriptional regulator 1 isoform X4', 103, NULL, NULL, 19989),
(19990, '3.30.70.660-FF-000036', NULL, 'tRNA pseudouridine synthase A', 173, NULL, NULL, 19990),
(19991, '3.30.160.60-FF-002327', NULL, 'Uncharacterized protein', 28, NULL, NULL, 19991),
(19992, '1.20.85.10-FF-000001', NULL, 'photosystem II D2 protein-like', 164, NULL, NULL, 19992),
(19993, '1.10.510.10-FF-000452', NULL, 'Tau tubulin kinase 2b', 146, NULL, NULL, 19993),
(19994, '1.20.1050.10-FF-000014', NULL, 'GSH-dependent disulfide bond oxidoreductase', 110, NULL, NULL, 19994),
(19995, '1.10.630.10-FF-000719', NULL, 'Predicted protein', 104, NULL, NULL, 19995),
(19996, '1.20.120.1900-FF-000026', NULL, 'Gamma-tubulin complex component', 304, NULL, NULL, 19996),
(19997, '2.30.130.40-FF-000013', NULL, 'Lon protease homolog, mitochondrial', 119, NULL, NULL, 19997),
(19998, '2.120.10.30-FF-000136', NULL, 'CRE-LIN-41 protein', 127, NULL, NULL, 19998),
(19999, '1.10.510.10-FF-000761', NULL, 'SRSF protein kinase 1', 119, NULL, NULL, 19999),
(20000, '2.20.100.10-FF-000134', NULL, 'Uncharacterized protein', 50, NULL, NULL, 20000),
(20001, '1.25.40.10-FF-003389', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 143, NULL, NULL, 20001),
(20002, '1.10.287.3990-FF-000008', NULL, 'Proteasome (Prosome, macropain) 26S subunit, non-ATPase, 4', 57, NULL, NULL, 20002),
(20003, '2.90.10.10-FF-000025', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', 124, NULL, NULL, 20003),
(20004, '3.30.1520.10-FF-000092', NULL, 'Sorting nexin-2', 147, NULL, NULL, 20004),
(20005, '3.40.50.300-FF-006094', NULL, 'AGAP009548-PA', 123, NULL, NULL, 20005),
(20006, '3.30.1520.10-FF-000103', NULL, 'Predicted protein', 91, NULL, NULL, 20006),
(20007, '1.10.640.10-FF-000001', NULL, 'Peroxidasin homolog', 603, NULL, NULL, 20007),
(20008, '2.130.10.10-FF-002665', NULL, 'WD repeat-containing protein 76', 46, NULL, NULL, 20008),
(20009, '3.10.330.10-FF-000009', NULL, 'Vesicular-fusion protein sec18', 102, NULL, NULL, 20009),
(20010, '2.30.29.150-FF-000012', NULL, 'FACT complex subunit SSRP1', 68, NULL, NULL, 20010),
(20011, '1.10.510.10-FF-002689', NULL, NULL, 181, NULL, NULL, 20011),
(20012, '3.30.70.360-FF-000036', NULL, 'Amidohydrolase amhX', 113, NULL, NULL, 20012),
(20013, '1.20.5.1300-FF-000013', NULL, 'Histidinol dehydrogenase', 48, NULL, NULL, 20013),
(20014, '3.40.33.10-FF-000196', NULL, 'Protein CBR-TAG-254', 78, NULL, NULL, 20014),
(20015, '3.30.160.60-FF-006189', NULL, NULL, 57, NULL, NULL, 20015),
(20016, '3.30.710.10-FF-000354', NULL, 'Uncharacterized protein', 170, NULL, NULL, 20016),
(20017, '2.40.30.330-FF-000004', NULL, 'mRNA cleavage and polyadenylation factor CLP1', 132, NULL, NULL, 20017),
(20018, '1.10.510.10-FF-002998', NULL, NULL, 167, NULL, NULL, 20018),
(20019, '2.20.70.110-FF-000001', NULL, 'Similar to Bacterial transferase hexapeptide', 35, NULL, NULL, 20019);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(20020, '3.50.40.10-FF-000004', NULL, 'Leucine rich repeat containing 47', 212, NULL, NULL, 20020),
(20021, '2.30.29.30-FF-000190', NULL, 'myosin phosphatase Rho-interacting protein isoform X2', 128, NULL, NULL, 20021),
(20022, '1.10.870.10-FF-000001', NULL, 'HLA class II histocompatibility antigen gamma chain', 75, NULL, NULL, 20022),
(20023, '2.60.40.1180-FF-000057', NULL, 'Sugar hydrolase, putative', 55, NULL, NULL, 20023),
(20024, '1.10.510.10-FF-004134', NULL, NULL, 79, NULL, NULL, 20024),
(20025, '3.10.20.90-FF-000085', NULL, 'Dual specificity mitogen-activated protein kinase kinase 5', 123, NULL, NULL, 20025),
(20026, '2.60.120.260-FF-000231', NULL, 'CocE/NonD family hydrolase', 165, NULL, NULL, 20026),
(20027, '1.10.246.60-FF-000021', NULL, NULL, 75, NULL, NULL, 20027),
(20028, '3.40.430.10-FF-000010', NULL, 'Dihydrofolate reductase', 123, NULL, NULL, 20028),
(20029, '4.10.260.10-FF-000016', NULL, 'Guanine nucleotide-binding protein (G protein), gamma 12a', 39, NULL, NULL, 20029),
(20030, '1.20.58.390-FF-000163', NULL, 'Acetylcholine receptor subunit alpha', 28, NULL, NULL, 20030),
(20031, '2.60.40.10-FF-000433', NULL, 'fibronectin isoform X5', 81, NULL, NULL, 20031),
(20032, '1.10.420.10-FF-000018', NULL, 'Related to beta-1, 3 exoglucanase', 107, NULL, NULL, 20032),
(20033, '3.20.20.80-FF-000132', NULL, 'Beta-galactosidase, putative', 335, NULL, NULL, 20033),
(20034, '3.40.50.11030-FF-000020', NULL, NULL, 133, NULL, NULL, 20034),
(20035, '3.30.160.60-FF-001973', NULL, 'replication initiator 1', 26, NULL, NULL, 20035),
(20036, '3.40.50.300-FF-003025', NULL, 'GTP-binding protein putative', 178, NULL, NULL, 20036),
(20037, '3.30.70.1230-FF-000192', NULL, 'Predicted protein', 149, NULL, NULL, 20037),
(20038, '2.130.10.10-FF-001737', NULL, 'Chromosome 1, whole genome shotgun sequence', 425, NULL, NULL, 20038),
(20039, '1.20.1560.10-FF-000244', NULL, 'ATP-binding cassette protein subfamily B, member 2, putative', 103, NULL, NULL, 20039),
(20040, '1.10.10.60-FF-000546', NULL, 'AraC family transcriptional regulator', 48, NULL, NULL, 20040),
(20041, '3.30.530.20-FF-000146', NULL, 'Uncharacterized protein', 199, NULL, NULL, 20041),
(20042, '3.40.50.1000-FF-000272', NULL, 'GM16616', 134, NULL, NULL, 20042),
(20043, '1.20.1050.10-FF-000031', NULL, 'Glutathione S-Transferase', 115, NULL, NULL, 20043),
(20044, '1.10.630.10-FF-000736', NULL, 'Cytochrome P450, family 3, subfamily c, polypeptide 1', 89, NULL, NULL, 20044),
(20045, '3.30.160.60-FF-001490', NULL, 'E3 ubiquitin-protein ligase TRIM50', 70, NULL, NULL, 20045),
(20046, '3.40.50.2020-FF-000010', NULL, 'Uridine-cytidine kinase', 219, NULL, NULL, 20046),
(20047, '3.40.1130.10-FF-000003', NULL, 'Putative glycerol-3-phosphate 1-O-acyltransferase', 259, NULL, NULL, 20047),
(20048, '3.40.190.10-FF-000002', NULL, 'Glutamine ABC transporter periplasmic protein', 124, NULL, NULL, 20048),
(20049, '3.40.850.10-FF-000002', NULL, 'Unconventional myosin IC', 257, NULL, NULL, 20049),
(20050, '2.60.120.330-FF-000084', NULL, 'Predicted protein', 217, NULL, NULL, 20050),
(20051, '2.40.10.10-FF-000123', NULL, 'Genome polyprotein', 110, NULL, NULL, 20051),
(20052, '3.30.200.20-FF-001201', NULL, 'serine/threonine-protein kinase D6PK-like', 81, NULL, NULL, 20052),
(20053, '3.40.50.300-FF-004194', NULL, 'DNA helicase', 126, NULL, NULL, 20053),
(20054, '3.40.1110.10-FF-000103', NULL, 'Sodium/potassium-transporting ATPase subunit alpha', 227, NULL, NULL, 20054),
(20055, '3.40.50.2000-FF-000246', NULL, 'ALG1, chitobiosyldiphosphodolichol beta-mannosyltransferase like', 118, NULL, NULL, 20055),
(20056, '3.40.50.150-FF-000748', NULL, 'MEthylTransferase Like', 189, NULL, NULL, 20056),
(20057, '1.20.970.10-FF-000012', NULL, 'Thymidine phosphorylase', 65, NULL, NULL, 20057),
(20058, '1.10.10.2360-FF-000007', NULL, 'Predicted protein', 43, NULL, NULL, 20058),
(20059, '2.10.25.10-FF-001479', NULL, 'low-density lipoprotein receptor 1', 39, NULL, NULL, 20059),
(20060, '1.25.40.820-FF-000002', NULL, 'RTR1p CTD phosphatase', 178, NULL, NULL, 20060),
(20061, '1.10.238.10-FF-000948', NULL, 'Uncharacterized protein', 93, NULL, NULL, 20061);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(20062, '1.10.8.60-FF-000197', NULL, 'Peroxisomal biogenesis factor 1', 68, NULL, NULL, 20062),
(20063, '2.40.160.60-FF-000002', NULL, 'Outer membrane protein', 418, NULL, NULL, 20063),
(20064, '1.10.1660.10-FF-000012', NULL, 'DNA-binding protein, excisionase family', 57, NULL, NULL, 20064),
(20065, '3.40.50.80-FF-000003', NULL, 'Nitric oxide synthase', 163, NULL, NULL, 20065),
(20066, '1.20.1070.10-FF-001325', NULL, 'Olfactory receptor C3', 295, NULL, NULL, 20066),
(20067, '3.40.630.10-FF-000267', NULL, 'Uncharacterized protein', 290, NULL, NULL, 20067),
(20068, '3.40.47.40-FF-000001', NULL, 'Stage V sporulation protein AD', 337, NULL, NULL, 20068),
(20069, '3.40.50.300-FF-000271', NULL, 'ATP-dependent Clp protease ATP-binding subunit ClpA', 195, NULL, NULL, 20069),
(20070, '3.30.450.20-FF-000404', NULL, 'Sensor histidine kinase, PAS, PAS and PAS domain-containing', 118, NULL, NULL, 20070),
(20071, '3.20.20.30-FF-000033', NULL, 'Alkanesulfonate monooxygenase', 341, NULL, NULL, 20071),
(20072, '3.90.226.10-FF-000035', NULL, 'ATP-dependent Clp protease proteolytic subunit', 196, NULL, NULL, 20072),
(20073, '1.10.340.70-FF-000030', NULL, 'Uncharacterized protein', 88, NULL, NULL, 20073),
(20074, '3.30.70.960-FF-000019', NULL, 'Serine protease H129', 103, NULL, NULL, 20074),
(20075, '2.160.20.10-FF-000112', NULL, 'Pectinesterase', 104, NULL, NULL, 20075),
(20076, '3.40.50.300-FF-005503', NULL, 'ATP-dependent RNA helicase A', 176, NULL, NULL, 20076),
(20077, '3.40.50.300-FF-004969', NULL, 'Uncharacterized protein', 101, NULL, NULL, 20077),
(20078, '1.10.357.50-FF-000028', NULL, 'Component of the exocyst complex', 111, NULL, NULL, 20078),
(20079, '2.120.10.80-FF-000027', NULL, 'Influenza virus NS1A-binding protein-like protein', 166, NULL, NULL, 20079),
(20080, '2.70.170.10-FF-000279', NULL, 'Uncharacterized protein', 76, NULL, NULL, 20080),
(20081, '3.60.21.10-FF-000443', NULL, 'Uncharacterized protein', 202, NULL, NULL, 20081),
(20082, '4.10.1240.10-FF-000068', NULL, 'Gastric inhibitory polypeptide receptor', 56, NULL, NULL, 20082),
(20083, '3.40.50.300-FF-008229', NULL, 'Uncharacterized protein', 61, NULL, NULL, 20083),
(20084, '3.40.50.300-FF-007403', NULL, 'Uncharacterized protein', 53, NULL, NULL, 20084),
(20085, '2.60.40.60-FF-000206', NULL, 'cadherin-23 isoform X1', 120, NULL, NULL, 20085),
(20086, '2.170.270.10-FF-000026', NULL, 'PR domain zinc finger protein 2', 154, NULL, NULL, 20086),
(20087, '1.25.10.10-FF-000352', NULL, 'Serine/threonine-protein phosphatase 4 regulatory subunit 1-like', 85, NULL, NULL, 20087),
(20088, '1.25.40.20-FF-000784', NULL, 'Ankyrin_repeats_(3_copies)/Ankyrin_repeats_(Many_ copies)/Ankyrin_repeat/DHHC_palmitoyltransferase_-_putative', 166, NULL, NULL, 20088),
(20089, '3.30.70.2460-FF-000004', NULL, 'Rad4-domain-containing protein', 73, NULL, NULL, 20089),
(20090, '3.90.1150.10-FF-000482', NULL, 'Kynureninase, putative', 79, NULL, NULL, 20090),
(20091, '2.130.10.10-FF-000557', NULL, 'WD repeat protein', 251, NULL, NULL, 20091),
(20092, '1.10.3460.10-FF-000031', NULL, 'Predicted protein', 134, NULL, NULL, 20092),
(20093, '3.30.590.50-FF-000018', NULL, 'Uncharacterized protein', 67, NULL, NULL, 20093),
(20094, '2.60.120.200-FF-000157', NULL, 'Beta-glucan synthesis-associated protein SKN1', 189, NULL, NULL, 20094),
(20095, '3.30.450.20-FF-000112', NULL, 'Taiman, isoform C', 132, NULL, NULL, 20095),
(20096, '3.80.10.10-FF-003233', NULL, 'Protein CBG25032', 193, NULL, NULL, 20096),
(20097, '3.30.760.10-FF-000048', NULL, 'Uncharacterized protein', 74, NULL, NULL, 20097),
(20098, '3.30.70.330-FF-000140', NULL, 'CUGBP Elav-like family member 4 isoform 3', 41, NULL, NULL, 20098),
(20099, '3.30.300.10-FF-000008', NULL, 'GMP synthase [glutamine-hydrolyzing]', 111, NULL, NULL, 20099),
(20100, '1.10.3730.20-FF-000044', NULL, 'Integral membrane protein', 114, NULL, NULL, 20100),
(20101, '3.40.50.920-FF-000001', NULL, 'Pyruvate dehydrogenase E1 beta subunit', 133, NULL, NULL, 20101),
(20102, '2.130.10.10-FF-004143', NULL, 'Block of proliferation protein, putative', 180, NULL, NULL, 20102);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(20103, '2.60.120.920-FF-000047', NULL, 'SPRY domain-containing protein 4', 178, NULL, NULL, 20103),
(20104, '3.40.640.10-FF-000195', NULL, 'ARO9p Aromatic aminotransferase II', 502, NULL, NULL, 20104),
(20105, '1.10.287.70-FF-000579', NULL, 'Uncharacterized protein', 133, NULL, NULL, 20105),
(20106, '2.60.40.10-FF-004356', NULL, NULL, 107, NULL, NULL, 20106),
(20107, '3.30.420.140-FF-000011', NULL, 'Transcription elongation factor spt6', 169, NULL, NULL, 20107),
(20108, '3.80.10.10-FF-001333', NULL, 'LRR receptor-like serine/threonine-protein kinase EFR', 116, NULL, NULL, 20108),
(20109, '1.10.510.10-FF-001380', NULL, 'Checkpoint kinase 2-like protein', 198, NULL, NULL, 20109),
(20110, '1.20.1070.10-FF-000044', NULL, 'Opsin, ultraviolet-sensitive', 334, NULL, NULL, 20110),
(20111, '3.40.50.12780-FF-000224', NULL, 'Uncharacterized protein', 349, NULL, NULL, 20111),
(20112, '2.10.25.10-FF-001007', NULL, 'GD14540', 66, NULL, NULL, 20112),
(20113, '2.30.29.30-FF-001369', NULL, 'Exocyst complex component exo84', 125, NULL, NULL, 20113),
(20114, '3.30.200.20-FF-001673', NULL, NULL, 80, NULL, NULL, 20114),
(20115, '1.10.1600.10-FF-000003', NULL, 'ATP-dependent DNA helicase 2 subunit KU70', 101, NULL, NULL, 20115),
(20116, '2.10.50.30-FF-000009', NULL, 'Vomeronasal 2, receptor 66', 78, NULL, NULL, 20116),
(20117, '3.30.40.10-FF-002214', NULL, 'Uncharacterized protein', 69, NULL, NULL, 20117),
(20118, '2.40.10.10-FF-000415', NULL, NULL, 69, NULL, NULL, 20118),
(20119, '1.20.140.20-FF-000003', NULL, '[Pyruvate dehydrogenase (Acetyl-transferring)] kinase, mitochondrial', 178, NULL, NULL, 20119),
(20120, '3.40.120.10-FF-000037', NULL, 'Pgm3p', 118, NULL, NULL, 20120),
(20121, '3.10.490.10-FF-000054', NULL, 'Gamma-glutamylcyclotransferase', 182, NULL, NULL, 20121),
(20122, '3.30.830.10-FF-000273', NULL, 'Insulin-degrading enzyme homolog', 231, NULL, NULL, 20122),
(20123, '1.20.1730.10-FF-000044', NULL, 'Urea transporter/permease, putative', 506, NULL, NULL, 20123),
(20124, '3.30.70.330-FF-002085', NULL, NULL, 75, NULL, NULL, 20124),
(20125, '2.130.10.10-FF-003963', NULL, 'Uncharacterized protein', 240, NULL, NULL, 20125),
(20126, '1.20.1250.20-FF-001089', NULL, 'Monocarboxylate transporter, putative', 414, NULL, NULL, 20126),
(20127, '3.40.850.10-FF-000339', NULL, 'Uncharacterized protein', 151, NULL, NULL, 20127),
(20128, '2.130.10.10-FF-002535', NULL, 'F-box and WD repeat domain containing 9', 88, NULL, NULL, 20128),
(20129, '3.40.30.10-FF-000835', NULL, 'Protein disulfide-isomerase', 81, NULL, NULL, 20129),
(20130, '3.30.70.330-FF-000623', NULL, 'Splicing factor 1', 75, NULL, NULL, 20130),
(20131, '1.25.10.10-FF-000835', NULL, 'Protein TPLATE', 409, NULL, NULL, 20131),
(20132, '3.30.160.60-FF-001046', NULL, 'Zinc finger and BTB domain containing 46', 27, NULL, NULL, 20132),
(20133, '1.20.58.60-FF-000560', NULL, 'Plectin', 114, NULL, NULL, 20133),
(20134, '1.10.940.10-FF-000029', NULL, 'Ribosomal RNA small subunit methyltransferase B', 140, NULL, NULL, 20134),
(20135, '3.20.190.10-FF-000001', NULL, 'Formamidopyrimidine-DNA glycosylase', 129, NULL, NULL, 20135),
(20136, '3.40.430.10-FF-000038', NULL, 'DHFR, dihydrofolate reductase, cytosolic form (Eurofung)', 167, NULL, NULL, 20136),
(20137, '1.10.238.10-FF-001128', NULL, 'Uncharacterized protein', 168, NULL, NULL, 20137),
(20138, '1.10.287.3440-FF-000001', NULL, 'Biosynthetic arginine decarboxylase', 54, NULL, NULL, 20138),
(20139, '3.40.50.12710-FF-000001', NULL, 'Protein arginine methyltransferase NDUFAF7', 388, NULL, NULL, 20139),
(20140, '3.30.2010.10-FF-000019', NULL, 'Peptidase family M48 family protein', 78, NULL, NULL, 20140),
(20141, '2.10.110.10-FF-000114', NULL, 'Apterous, isoform B', 103, NULL, NULL, 20141),
(20142, '2.130.10.10-FF-004891', NULL, 'IP10750p', 116, NULL, NULL, 20142),
(20143, '1.10.238.10-FF-000156', NULL, 'Actinin alpha 4', 79, NULL, NULL, 20143),
(20144, '3.40.50.1240-FF-000085', NULL, 'Multiple inositol polyphosphate phosphatase, putative', 376, NULL, NULL, 20144),
(20145, '3.70.10.10-FF-000029', NULL, 'DNA damage checkpoint control protein rad1', 271, NULL, NULL, 20145);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(20146, '3.80.10.10-FF-004059', NULL, 'Uncharacterized protein', 134, NULL, NULL, 20146),
(20147, '3.40.50.300-FF-003660', NULL, 'Regulator of telomere elongation helicase rtel1, putative', 270, NULL, NULL, 20147),
(20148, '3.10.20.90-FF-000877', NULL, 'Uncharacterized protein', 64, NULL, NULL, 20148),
(20149, '1.10.510.10-FF-000109', NULL, 'Ribosomal protein S6 kinase', 204, NULL, NULL, 20149),
(20150, '3.40.50.300-FF-006122', NULL, 'RAS, putative', 115, NULL, NULL, 20150),
(20151, '1.25.40.20-FF-001138', NULL, 'Protein shank', 157, NULL, NULL, 20151),
(20152, '3.40.390.30-FF-000006', NULL, 'Uncharacterized protein', 189, NULL, NULL, 20152),
(20153, '3.30.70.2850-FF-000031', NULL, 'Putative mediator of RNA polymerase II transcription subunit 12', 162, NULL, NULL, 20153),
(20154, '2.40.128.20-FF-000022', NULL, 'Outer membrane lipoprotein Blc', 160, NULL, NULL, 20154),
(20155, '2.60.120.970-FF-000101', NULL, 'Bone morphogenetic protein 2', 140, NULL, NULL, 20155),
(20156, '1.10.287.90-FF-000017', NULL, 'Cytochrome c oxidase subunit 2', 91, NULL, NULL, 20156),
(20157, '1.10.3730.20-FF-000027', NULL, 'Yeast Homolog UDP-Gal Transporter', 108, NULL, NULL, 20157),
(20158, '3.30.160.60-FF-002799', NULL, 'Zinc finger protein 737', 25, NULL, NULL, 20158),
(20159, '1.10.1670.10-FF-000069', NULL, NULL, 71, NULL, NULL, 20159),
(20160, '2.10.110.10-FF-000244', NULL, 'Uncharacterized protein, isoform C', 45, NULL, NULL, 20160),
(20161, '2.60.120.260-FF-000259', NULL, 'SUN domain-containing protein', 196, NULL, NULL, 20161),
(20162, '1.10.287.380-FF-000037', NULL, 'ABC transporter, ATP-binding protein, EF-3 family', 70, NULL, NULL, 20162),
(20163, '1.25.40.10-FF-000180', NULL, 'Related to UDP-N-acetylglucosaminyltransferase', 58, NULL, NULL, 20163),
(20164, '2.10.50.30-FF-000026', NULL, 'Uncharacterized protein', 82, NULL, NULL, 20164),
(20165, '2.60.40.10-FF-001613', NULL, 'Interleukin 12 receptor subunit beta 1', 95, NULL, NULL, 20165),
(20166, '1.20.1720.10-FF-000116', NULL, 'Uncharacterized protein', 412, NULL, NULL, 20166),
(20167, '1.10.510.10-FF-003515', NULL, NULL, 248, NULL, NULL, 20167),
(20168, '3.40.50.300-FF-000815', NULL, 'Dynein heavy chain 2, axonemal', 190, NULL, NULL, 20168),
(20169, '3.40.50.150-FF-000309', NULL, 'tRNA (guanine-N(7)-)-methyltransferase', 197, NULL, NULL, 20169),
(20170, '3.40.50.300-FF-006431', NULL, 'Septin 7b', 127, NULL, NULL, 20170),
(20171, '3.30.710.10-FF-000337', NULL, 'Mg2+ transporter protein, CorA-like protein', 142, NULL, NULL, 20171),
(20172, '2.10.50.10-FF-000020', NULL, 'Tumor necrosis factor receptor superfamily member 1A', 87, NULL, NULL, 20172),
(20173, '1.20.120.350-FF-000049', NULL, 'Sodium channel protein', 108, NULL, NULL, 20173),
(20174, '1.10.510.10-FF-002717', NULL, 'Uncharacterized protein', 351, NULL, NULL, 20174),
(20175, '3.40.50.300-FF-003997', NULL, 'GTP-binding nuclear protein Ran', 198, NULL, NULL, 20175),
(20176, '2.130.10.10-FF-004582', NULL, 'Ribosomal large subunit assembly and maintenance-related protein, putative', 209, NULL, NULL, 20176),
(20177, '2.60.40.10-FF-001052', NULL, 'Usherin', 123, NULL, NULL, 20177),
(20178, '2.60.120.260-FF-000568', NULL, 'Putative secreted beta-galactosidase', 12, NULL, NULL, 20178),
(20179, '1.10.510.10-FF-004151', NULL, NULL, 245, NULL, NULL, 20179),
(20180, '2.130.10.10-FF-002682', NULL, 'DDB1- and CUL4-associated factor 1 isoform X2', 340, NULL, NULL, 20180),
(20181, '2.60.40.60-FF-001134', NULL, 'Uncharacterized protein', 73, NULL, NULL, 20181),
(20182, '3.20.20.140-FF-000114', NULL, 'Hydrolase, TatD family', 256, NULL, NULL, 20182),
(20183, '3.40.50.300-FF-008359', NULL, 'Predicted protein', 58, NULL, NULL, 20183),
(20184, '3.10.100.10-FF-000413', NULL, NULL, 101, NULL, NULL, 20184),
(20185, '1.50.10.20-FF-000100', NULL, 'Mannan endo-1,6-alpha-mannosidase', 336, NULL, NULL, 20185),
(20186, '1.20.120.330-FF-000043', NULL, 'Uncharacterized protein', 149, NULL, NULL, 20186),
(20187, '1.10.520.10-FF-000054', NULL, 'Peroxidase', 162, NULL, NULL, 20187),
(20188, '1.50.40.10-FF-000571', NULL, 'Uncharacterized protein', 84, NULL, NULL, 20188);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(20189, '1.10.8.270-FF-000062', NULL, 'GTPase activating protein, conserved', 98, NULL, NULL, 20189),
(20190, '1.20.1560.10-FF-000261', NULL, 'ABC transporter, putative', 137, NULL, NULL, 20190),
(20191, '3.30.160.60-FF-005896', NULL, NULL, 70, NULL, NULL, 20191),
(20192, '2.40.20.10-FF-000051', NULL, 'Uncharacterized protein', 78, NULL, NULL, 20192),
(20193, '3.30.70.1070-FF-000019', NULL, 'Endolytic peptidoglycan transglycosylase RlpA', 72, NULL, NULL, 20193),
(20194, '3.30.420.40-FF-000133', NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', 185, NULL, NULL, 20194),
(20195, '2.30.29.30-FF-000088', NULL, 'Phosphoinositide phospholipase C', 130, NULL, NULL, 20195),
(20196, '2.10.25.10-FF-000299', NULL, 'Notch receptor 3', 37, NULL, NULL, 20196),
(20197, '2.60.120.330-FF-000067', NULL, 'Probable flavonol synthase 5', 291, NULL, NULL, 20197),
(20198, '3.40.50.300-FF-001451', NULL, 'Dynamin GTPase', 308, NULL, NULL, 20198),
(20199, '2.130.10.10-FF-005099', NULL, 'WD40 repeat-containing protein', 253, NULL, NULL, 20199),
(20200, '1.10.472.80-FF-000086', NULL, 'TBC1 domain family, member 25', 115, NULL, NULL, 20200),
(20201, '2.160.20.10-FF-000242', NULL, 'Pectinesterase', 174, NULL, NULL, 20201),
(20202, '3.40.50.300-FF-001760', NULL, 'ATP-dependent RNA helicase', 216, NULL, NULL, 20202),
(20203, '1.20.58.1030-FF-000027', NULL, 'Uncharacterized protein', 126, NULL, NULL, 20203),
(20204, '1.10.150.240-FF-000131', NULL, 'Protein CBG00583', 42, NULL, NULL, 20204),
(20205, '3.40.50.150-FF-001254', NULL, NULL, 145, NULL, NULL, 20205),
(20206, '1.10.8.10-FF-000013', NULL, 'Non-specific serine/threonine protein kinase', 45, NULL, NULL, 20206),
(20207, '3.40.50.1820-FF-001490', NULL, 'Uncharacterized protein', 165, NULL, NULL, 20207),
(20208, '2.130.10.10-FF-005071', NULL, 'Transducin/WD40 repeat-like superfamily protein', 269, NULL, NULL, 20208),
(20209, '2.60.120.1190-FF-000004', NULL, 'Discoidin domain receptor tyrosine kinase 1', 188, NULL, NULL, 20209),
(20210, '3.40.50.300-FF-003688', NULL, 'Dynein alpha chain, flagellar outer arm', 173, NULL, NULL, 20210),
(20211, '3.30.70.260-FF-000023', NULL, 'Aspartokinase', 73, NULL, NULL, 20211),
(20212, '3.40.50.300-FF-004177', NULL, 'DNA helicase INO80', 239, NULL, NULL, 20212),
(20213, '3.40.50.10260-FF-000013', NULL, 'NAD(P)H-hydrate epimerase', 228, NULL, NULL, 20213),
(20214, '3.30.260.10-FF-000055', NULL, 'T-complex protein 1 subunit eta', 123, NULL, NULL, 20214),
(20215, '1.10.10.10-FF-000508', NULL, 'Segregation and condensation protein B', 100, NULL, NULL, 20215),
(20216, '2.60.40.1690-FF-000002', NULL, 'Fusion glycoprotein F0', 64, NULL, NULL, 20216),
(20217, '2.60.40.10-FF-002439', NULL, 'Titin homolog', 93, NULL, NULL, 20217),
(20218, '2.60.120.10-FF-000637', NULL, 'Uncharacterized protein', 353, NULL, NULL, 20218),
(20219, '1.25.10.10-FF-000627', NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', 1214, NULL, NULL, 20219),
(20220, '2.60.40.10-FF-004047', NULL, NULL, 123, NULL, NULL, 20220),
(20221, '2.40.50.90-FF-000166', NULL, 'Uncharacterized protein', 144, NULL, NULL, 20221),
(20222, '3.40.50.300-FF-002277', NULL, 'Meiotic spindle formation protein mei-1', 188, NULL, NULL, 20222),
(20223, '3.30.420.10-FF-000719', NULL, NULL, 79, NULL, NULL, 20223),
(20224, '3.30.390.30-FF-000031', NULL, 'Glutathione reductase', 117, NULL, NULL, 20224),
(20225, '3.30.420.10-FF-000135', NULL, 'DNA polymerase', 252, NULL, NULL, 20225),
(20226, '1.10.20.10-FF-000009', NULL, 'Histone H2A', 128, NULL, NULL, 20226),
(20227, '2.60.40.420-FF-000242', NULL, 'Uncharacterized protein', 84, NULL, NULL, 20227),
(20228, '3.30.70.330-FF-000595', NULL, 'UBP1-associated protein 2C-like', 82, NULL, NULL, 20228),
(20229, '3.90.660.10-FF-000061', NULL, NULL, 40, NULL, NULL, 20229),
(20230, '3.20.20.70-FF-000819', NULL, NULL, 261, NULL, NULL, 20230),
(20231, '1.10.510.10-FF-000317', NULL, 'PTI1-like tyrosine-protein kinase At3g15890', 212, NULL, NULL, 20231),
(20232, '1.20.1510.10-FF-000078', NULL, NULL, 199, NULL, NULL, 20232);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(20233, '1.20.1070.10-FF-000061', NULL, 'Adenosine receptor A2', 302, NULL, NULL, 20233),
(20234, '4.10.800.10-FF-000036', NULL, 'Predicted protein', 66, NULL, NULL, 20234),
(20235, '1.20.1270.280-FF-000080', NULL, 'Dynein, axonemal, heavy chain 2', 47, NULL, NULL, 20235),
(20236, '3.90.1310.10-FF-000028', NULL, 'Stage V sporulation protein D', 183, NULL, NULL, 20236),
(20237, '3.30.160.60-FF-003979', NULL, NULL, 29, NULL, NULL, 20237),
(20238, '3.30.160.60-FF-005071', NULL, NULL, 32, NULL, NULL, 20238),
(20239, '2.10.10.100-FF-000005', NULL, NULL, 68, NULL, NULL, 20239),
(20240, '3.30.310.40-FF-000012', NULL, '8-oxoguanine DNA glycosylase', 66, NULL, NULL, 20240),
(20241, '2.130.10.10-FF-000765', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 3', 180, NULL, NULL, 20241),
(20242, '4.10.60.10-FF-000145', NULL, 'Uncharacterized protein', 45, NULL, NULL, 20242),
(20243, '2.70.160.11-FF-000083', NULL, 'E3 ubiquitin-protein ligase CCNB1IP1-like protein', 69, NULL, NULL, 20243),
(20244, '1.25.10.10-FF-000043', NULL, 'Unc-45 myosin chaperone B', 355, NULL, NULL, 20244),
(20245, '2.170.16.10-FF-000012', NULL, 'Replication factor C small subunit', 105, NULL, NULL, 20245),
(20246, '3.30.420.40-FF-000150', NULL, 'Actin-related protein 7', 155, NULL, NULL, 20246),
(20247, '1.10.510.10-FF-000744', NULL, 'Putative mitogen activated protein kinase', 204, NULL, NULL, 20247),
(20248, '2.30.42.10-FF-000618', NULL, NULL, 88, NULL, NULL, 20248),
(20249, '1.25.40.20-FF-000654', NULL, 'Uncharacterized protein', 99, NULL, NULL, 20249),
(20250, '2.10.25.10-FF-001024', NULL, 'Crumbs-like protein 2b', 43, NULL, NULL, 20250),
(20251, '1.20.5.170-FF-000018', NULL, 'AAA ATPase forming ring-shaped complexes', 44, NULL, NULL, 20251),
(20252, '6.20.10.30-FF-000014', NULL, 'DNA ligase', 36, NULL, NULL, 20252),
(20253, '2.160.10.10-FF-000022', NULL, 'Glucose-1-phosphate adenylyltransferase', 100, NULL, NULL, 20253),
(20254, '1.10.510.10-FF-000789', NULL, 'Mitogen-activated protein kinase', 215, NULL, NULL, 20254),
(20255, '3.30.505.10-FF-000259', NULL, NULL, 97, NULL, NULL, 20255),
(20256, '3.40.366.10-FF-000006', NULL, 'Fatty acid synthase beta subunit dehydratase', 196, NULL, NULL, 20256),
(20257, '3.30.200.20-FF-000936', NULL, 'Cyclin-dependent kinase A-1, putative', 88, NULL, NULL, 20257),
(20258, '1.20.5.430-FF-000001', NULL, 'Nuclear receptor corepressor 2 isoform 1', 42, NULL, NULL, 20258),
(20259, '3.30.780.10-FF-000050', NULL, 'Translation initiation factor sui1-like protein', 103, NULL, NULL, 20259),
(20260, '1.20.1250.20-FF-000263', NULL, 'Proton-coupled folate transporter isoform 1', 418, NULL, NULL, 20260),
(20261, '3.40.630.10-FF-000475', NULL, 'Uncharacterized protein', 319, NULL, NULL, 20261),
(20262, '2.10.25.10-FF-000035', NULL, 'Signal peptide, CUB domain and EGF-like domain-containing 2', 43, NULL, NULL, 20262),
(20263, '2.130.10.110-FF-000025', NULL, 'Clathrin heavy chain, putative', 143, NULL, NULL, 20263),
(20264, '1.20.1050.130-FF-000047', NULL, 'Uncharacterized protein', 98, NULL, NULL, 20264),
(20265, '2.30.29.30-FF-000116', NULL, 'Rho GTPase activating protein 26', 121, NULL, NULL, 20265),
(20266, '1.25.40.10-FF-004350', NULL, 'Peptidylprolyl isomerase', 174, NULL, NULL, 20266),
(20267, '3.30.930.10-FF-000320', NULL, 'Phenylalanine--tRNA ligase alpha subunit', 337, NULL, NULL, 20267),
(20268, '2.130.10.10-FF-003946', NULL, 'Predicted protein', 248, NULL, NULL, 20268),
(20269, '1.25.40.10-FF-003889', NULL, 'Uncharacterized protein', 79, NULL, NULL, 20269),
(20270, '3.30.160.60-FF-004452', NULL, NULL, 31, NULL, NULL, 20270),
(20271, '2.60.40.60-FF-000650', NULL, 'Uncharacterized protein', 123, NULL, NULL, 20271),
(20272, '1.10.238.10-FF-000717', NULL, 'Endocytic protein, putative', 116, NULL, NULL, 20272),
(20273, '3.40.50.720-FF-000352', NULL, '3-sulfolactaldehyde reductase', 162, NULL, NULL, 20273),
(20274, '3.10.20.90-FF-000646', NULL, 'Autophagy-related protein 8-like protein DDB_G0290491', 123, NULL, NULL, 20274),
(20275, '1.50.40.10-FF-000363', NULL, 'Solute carrier family 25 member 33', 159, NULL, NULL, 20275);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(20276, '2.30.30.100-FF-000027', NULL, 'U6 snRNA-associated Sm-like protein LSm8', 94, NULL, NULL, 20276),
(20277, '1.10.10.60-FF-001035', NULL, NULL, 82, NULL, NULL, 20277),
(20278, '1.10.510.10-FF-002026', NULL, 'Serine/threonine-protein kinase pink-1, mitochondrial', 242, NULL, NULL, 20278),
(20279, '3.60.110.10-FF-000021', NULL, 'Nit3p', 291, NULL, NULL, 20279),
(20280, '1.25.40.20-FF-000553', NULL, 'Protein HOS4', 209, NULL, NULL, 20280),
(20281, '3.30.70.330-FF-000168', NULL, 'RNA binding motif protein 46', 75, NULL, NULL, 20281),
(20282, '3.40.390.10-FF-000231', NULL, NULL, 104, NULL, NULL, 20282),
(20283, '3.30.559.10-FF-000030', NULL, 'Carnitine O-palmitoyltransferase 2', 205, NULL, NULL, 20283),
(20284, '3.40.50.1820-FF-001282', NULL, 'Predicted protein', 289, NULL, NULL, 20284),
(20285, '3.30.70.2850-FF-000014', NULL, 'DNA-directed RNA polymerase subunit', 156, NULL, NULL, 20285),
(20286, '3.30.200.20-FF-002162', NULL, 'Non-specific serine/threonine protein kinase', 64, NULL, NULL, 20286),
(20287, '1.10.1220.170-FF-000001', NULL, 'Antitoxin', 53, NULL, NULL, 20287),
(20288, '2.60.40.10-FF-002350', NULL, 'Immunoglobulin heavy variable 1-4', 90, NULL, NULL, 20288),
(20289, '2.10.110.10-FF-000261', NULL, 'Putative lim domain binding protein ldb1/nli/clim', 84, NULL, NULL, 20289),
(20290, '3.40.630.30-FF-000677', NULL, 'Diamine acetyltransferase', 144, NULL, NULL, 20290),
(20291, '2.60.40.10-FF-001260', NULL, 'Sodium channel subunit beta-4', 131, NULL, NULL, 20291),
(20292, '1.10.472.10-FF-000424', NULL, 'CYCLIN D71', 71, NULL, NULL, 20292),
(20293, '3.30.160.60-FF-000753', NULL, 'zinc finger protein 236 isoform X2', 58, NULL, NULL, 20293),
(20294, '3.30.70.330-FF-001112', NULL, 'U1 small nuclear ribonucleoprotein usp102', 105, NULL, NULL, 20294),
(20295, '1.10.40.30-FF-000022', NULL, 'Adenylosuccinate lyase', 77, NULL, NULL, 20295),
(20296, '1.20.1080.10-FF-000090', NULL, 'Uncharacterized protein', 97, NULL, NULL, 20296),
(20297, '1.10.10.980-FF-000003', NULL, 'CST complex subunit STN1', 102, NULL, NULL, 20297),
(20298, '3.40.50.10990-FF-000007', NULL, '3,4-dihydroxy-2-butanone 4-phosphate synthase', 152, NULL, NULL, 20298),
(20299, '1.20.1270.60-FF-000124', NULL, 'Endophilin-A homolog', 245, NULL, NULL, 20299),
(20300, '3.90.1290.10-FF-000048', NULL, 'Uncharacterized protein', 96, NULL, NULL, 20300),
(20301, '2.10.220.10-FF-000134', NULL, 'Proprotein convertase subtilisin/kexin type 5', 63, NULL, NULL, 20301),
(20302, '2.60.120.10-FF-000593', NULL, 'AGAP000467-PA', 105, NULL, NULL, 20302),
(20303, '1.20.120.1370-FF-000002', NULL, 'Regulator of sigma D', 153, NULL, NULL, 20303),
(20304, '1.10.287.110-FF-000209', NULL, 'Expressed protein', 109, NULL, NULL, 20304),
(20305, '2.40.170.20-FF-000075', NULL, 'SusC/RagA family TonB-linked outer membrane protein', 589, NULL, NULL, 20305),
(20306, '3.40.50.1220-FF-000118', NULL, 'Uncharacterized protein', 187, NULL, NULL, 20306),
(20307, '1.25.40.10-FF-000764', NULL, 'Putative pentatricopeptide repeat-containing protein', 232, NULL, NULL, 20307),
(20308, '3.30.160.60-FF-001473', NULL, NULL, 29, NULL, NULL, 20308),
(20309, '3.30.70.330-FF-002629', NULL, NULL, 125, NULL, NULL, 20309),
(20310, '3.40.50.2000-FF-000015', NULL, 'Bifunctional UDP-N-acetylglucosamine 2-epimerase/N-acetylmannosamine kinase', 198, NULL, NULL, 20310),
(20311, '2.60.120.10-FF-000385', NULL, 'Cruciferin 3', 128, NULL, NULL, 20311),
(20312, '3.40.50.20-FF-000031', NULL, 'D-alanine--D-alanine ligase', 97, NULL, NULL, 20312),
(20313, '3.80.10.10-FF-000035', NULL, 'Tyrosine-protein kinase receptor', 165, NULL, NULL, 20313),
(20314, '2.60.40.10-FF-005784', NULL, NULL, 92, NULL, NULL, 20314),
(20315, '3.60.20.30-FF-000019', NULL, NULL, 123, NULL, NULL, 20315),
(20316, '2.130.10.10-FF-004935', NULL, 'Uncharacterized protein', 104, NULL, NULL, 20316),
(20317, '3.40.50.1440-FF-000156', NULL, 'Tubulin', 386, NULL, NULL, 20317),
(20318, '3.40.50.880-FF-000028', NULL, 'Imidazole glycerol phosphate synthase subunit HisH', 207, NULL, NULL, 20318),
(20319, '1.20.1250.20-FF-001561', NULL, 'MFS alpha-glucoside transporter, putative (AFU_orthologue AFUA_5G00500)', 394, NULL, NULL, 20319);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(20320, '2.40.30.10-FF-000450', NULL, 'Protein CBG00492', 55, NULL, NULL, 20320),
(20321, '3.40.50.300-FF-005150', NULL, 'ADP-ribosylation factor', 233, NULL, NULL, 20321),
(20322, '1.20.1050.10-FF-000262', NULL, 'Glutathione S-transferase, putative', 132, NULL, NULL, 20322),
(20323, '4.10.400.10-FF-000359', NULL, 'Uncharacterized protein', 44, NULL, NULL, 20323),
(20324, '3.30.457.50-FF-000001', NULL, 'Probable kinetochore protein spc25', 101, NULL, NULL, 20324),
(20325, '3.60.40.10-FF-000026', NULL, 'probable protein phosphatase 2C 52', 312, NULL, NULL, 20325),
(20326, '2.130.10.10-FF-004351', NULL, 'Uncharacterized protein', 94, NULL, NULL, 20326),
(20327, '1.10.10.60-FF-000754', NULL, 'RCOR (REST CO-Repressor) homolog', 71, NULL, NULL, 20327),
(20328, '1.25.40.10-FF-001489', NULL, 'Pentatricopeptide repeat-containing protein CRP1, chloroplastic', 106, NULL, NULL, 20328),
(20329, '2.60.40.10-FF-000641', NULL, 'Intercellular adhesion molecule 1', 90, NULL, NULL, 20329),
(20330, '3.30.160.60-FF-002198', NULL, 'Zinc finger protein 114', 27, NULL, NULL, 20330),
(20331, '1.10.1410.10-FF-000084', NULL, 'Uncharacterized protein', 172, NULL, NULL, 20331),
(20332, '1.25.10.10-FF-001341', NULL, 'ARM repeat superfamily protein', 358, NULL, NULL, 20332),
(20333, '2.20.20.10-FF-000006', NULL, 'U-actitoxin-Bcs2a', 41, NULL, NULL, 20333),
(20334, '3.40.50.2300-FF-001527', NULL, NULL, 82, NULL, NULL, 20334),
(20335, '1.10.520.10-FF-000037', NULL, 'Cationic peroxidase 2', 77, NULL, NULL, 20335),
(20336, '2.20.25.10-FF-000057', NULL, 'Organic hydroperoxide resistance protein', 48, NULL, NULL, 20336),
(20337, '3.20.20.60-FF-000137', NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', 273, NULL, NULL, 20337),
(20338, '3.30.930.10-FF-000365', NULL, 'Uncharacterized protein', 51, NULL, NULL, 20338),
(20339, '1.25.40.10-FF-000455', NULL, 'Cell cycle inhibitor Nif1, putative', 185, NULL, NULL, 20339),
(20340, '4.10.860.120-FF-000006', NULL, 'DNA-directed RNA polymerase subunit', 125, NULL, NULL, 20340),
(20341, '1.10.1420.10-FF-000169', NULL, 'Putative MSH5, mismatch repair ATPase', 209, NULL, NULL, 20341),
(20342, '2.40.50.140-FF-000182', NULL, '30S ribosomal protein S1', 90, NULL, NULL, 20342),
(20343, '3.40.50.300-FF-003008', NULL, 'Origin recognition complex subunit 1', 185, NULL, NULL, 20343),
(20344, '3.50.50.60-FF-001475', NULL, 'Uncharacterized protein', 61, NULL, NULL, 20344),
(20345, '2.60.40.10-FF-002703', NULL, 'GD26007', 78, NULL, NULL, 20345),
(20346, '3.30.200.20-FF-000728', NULL, 'Putative Raf proto-oncogene serine/threonine-protein kinase', 94, NULL, NULL, 20346),
(20347, '1.10.472.10-FF-000115', NULL, 'Os02g0607400 protein', 100, NULL, NULL, 20347),
(20348, '3.90.1170.50-FF-000017', NULL, 'Predicted protein', 93, NULL, NULL, 20348),
(20349, '1.25.40.20-FF-001273', NULL, 'Ankyrin repeat-containing protein P1E11.10', 189, NULL, NULL, 20349),
(20350, '1.10.10.10-FF-001936', NULL, 'Winged-helix DNA-binding transcription factor family protein', 88, NULL, NULL, 20350),
(20351, '3.90.1150.210-FF-000018', NULL, 'F-actin-capping protein subunit alpha', 136, NULL, NULL, 20351),
(20352, '1.10.540.10-FF-000145', NULL, 'Acyl-coenzyme A oxidase', 99, NULL, NULL, 20352),
(20353, '3.40.50.150-FF-000720', NULL, 'Nop2 (NOP2)/SUN domain family member', 220, NULL, NULL, 20353),
(20354, '3.30.2230.10-FF-000002', NULL, 'Ubiquitinyl hydrolase 1', 113, NULL, NULL, 20354),
(20355, '1.10.10.60-FF-000046', NULL, 'SIX homeobox 3', 65, NULL, NULL, 20355),
(20356, '3.30.200.20-FF-001656', NULL, 'Serine/threonine protein kinase', 86, NULL, NULL, 20356),
(20357, '1.20.120.560-FF-000011', NULL, 'Enhancer of Glp-One (Glp-1)', 146, NULL, NULL, 20357),
(20358, '2.130.10.10-FF-005863', NULL, 'Uncharacterized protein', 312, NULL, NULL, 20358),
(20359, '3.20.20.70-FF-000567', NULL, 'GTP 3'',8-cyclase', 326, NULL, NULL, 20359),
(20360, '3.30.390.110-FF-000004', NULL, 'Large subunit ribosomal protein L28e', 125, NULL, NULL, 20360),
(20361, '2.130.10.10-FF-000057', NULL, 'Activating molecule in BECN1-regulated autophagy protein 1 isoform X1', 177, NULL, NULL, 20361);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(20362, '2.60.40.10-FF-005312', NULL, NULL, 79, NULL, NULL, 20362),
(20363, '3.65.10.10-FF-000036', NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', 205, NULL, NULL, 20363),
(20364, '2.130.10.10-FF-004660', NULL, 'Ribosome biogenesis protein WDR12 homolog', 188, NULL, NULL, 20364),
(20365, '1.25.40.990-FF-000024', NULL, 'GM24869', 294, NULL, NULL, 20365),
(20366, '2.30.29.30-FF-000543', NULL, 'Unplaced genomic scaffold supercont2.1, whole genome shotgun sequence', 125, NULL, NULL, 20366),
(20367, '3.40.190.290-FF-000073', NULL, 'LysR family transcriptional regulator', 204, NULL, NULL, 20367),
(20368, '3.30.380.10-FF-000002', NULL, 'Capsid protein', 133, NULL, NULL, 20368),
(20369, '1.20.120.1240-FF-000014', NULL, 'Dynamin 2b', 237, NULL, NULL, 20369),
(20370, '3.10.310.20-FF-000033', NULL, NULL, 47, NULL, NULL, 20370),
(20371, '1.25.40.10-FF-004507', NULL, 'Uncharacterized protein', 237, NULL, NULL, 20371),
(20372, '3.40.50.300-FF-008437', NULL, 'ABC transporter, putative', 81, NULL, NULL, 20372),
(20373, '3.30.160.60-FF-000545', NULL, 'Uncharacterized protein', 29, NULL, NULL, 20373),
(20374, '3.30.160.60-FF-005216', NULL, NULL, 50, NULL, NULL, 20374),
(20375, '3.40.1490.10-FF-000007', NULL, 'Uncharacterized protein', 112, NULL, NULL, 20375),
(20376, '3.10.200.10-FF-000005', NULL, 'receptor-type tyrosine-protein phosphatase gamma isoform X1', 265, NULL, NULL, 20376),
(20377, '3.40.1160.10-FF-000022', NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase', 297, NULL, NULL, 20377),
(20378, '3.90.70.10-FF-000375', NULL, 'AGAP003875-PA', 134, NULL, NULL, 20378),
(20379, '1.10.287.70-FF-000787', NULL, 'Uncharacterized protein', 207, NULL, NULL, 20379),
(20380, '3.30.10.20-FF-000006', NULL, 'Serine/threonine-protein kinase StkP', 69, NULL, NULL, 20380),
(20381, '2.60.40.10-FF-005003', NULL, NULL, 106, NULL, NULL, 20381),
(20382, '1.50.10.20-FF-000072', NULL, 'Uncharacterized protein', 304, NULL, NULL, 20382),
(20383, '3.40.50.300-FF-007611', NULL, 'Uncharacterized protein', 155, NULL, NULL, 20383),
(20384, '1.25.40.10-FF-000663', NULL, 'Uncharacterized protein', 125, NULL, NULL, 20384),
(20385, '1.20.120.980-FF-000018', NULL, 'Putative serine protease K12H4.7', 157, NULL, NULL, 20385),
(20386, '3.40.50.1000-FF-000547', NULL, NULL, 196, NULL, NULL, 20386),
(20387, '1.10.1070.11-FF-000081', NULL, 'Phosphatidylinositol kinase domain protein, putative', 173, NULL, NULL, 20387),
(20388, '3.30.160.60-FF-000854', NULL, 'zinc finger and BTB domain-containing protein 20 isoform X1', 35, NULL, NULL, 20388),
(20389, '3.40.50.2300-FF-000908', NULL, NULL, 194, NULL, NULL, 20389),
(20390, '3.90.640.10-FF-000262', NULL, 'Heat shock protein 70D', 81, NULL, NULL, 20390),
(20391, '3.40.1000.30-FF-000005', NULL, 'Probable proteasome inhibitor', 165, NULL, NULL, 20391),
(20392, '1.25.40.90-FF-000052', NULL, 'BnaC05g37120D protein', 139, NULL, NULL, 20392),
(20393, '1.10.357.70-FF-000006', NULL, 'Exocyst complex component 3 like 4', 165, NULL, NULL, 20393),
(20394, '2.40.50.40-FF-000112', NULL, 'Uncharacterized protein', 57, NULL, NULL, 20394),
(20395, '2.60.40.10-FF-005576', NULL, NULL, 102, NULL, NULL, 20395),
(20396, '1.25.40.10-FF-000972', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 90, NULL, NULL, 20396),
(20397, '3.40.50.1010-FF-000084', NULL, 'Ribonuclease VapC', 123, NULL, NULL, 20397),
(20398, '1.10.510.10-FF-001037', NULL, 'SRSF protein kinase 2', 189, NULL, NULL, 20398),
(20399, '2.10.25.140-FF-000005', NULL, 'Delta-like protein', 49, NULL, NULL, 20399),
(20400, '2.40.160.10-FF-000049', NULL, 'Uncharacterized protein', 281, NULL, NULL, 20400),
(20401, '1.10.3370.10-FF-000024', NULL, 'SecY protein transport family protein', 84, NULL, NULL, 20401),
(20402, '2.60.40.10-FF-003058', NULL, 'Limbic system-associated membrane protein', 89, NULL, NULL, 20402),
(20403, '2.40.50.140-FF-000243', NULL, 'Elongation factor P', 63, NULL, NULL, 20403),
(20404, '2.60.120.650-FF-000123', NULL, 'Lysine-specific demethylase 8', 241, NULL, NULL, 20404),
(20405, '3.30.160.60-FF-005525', NULL, NULL, 22, NULL, NULL, 20405);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(20406, '1.20.140.10-FF-000146', NULL, 'Uncharacterized protein', 129, NULL, NULL, 20406),
(20407, '2.170.120.40-FF-000002', NULL, 'YbbR-like protein', 87, NULL, NULL, 20407),
(20408, '1.10.3210.10-FF-000131', NULL, 'Uncharacterized protein', 160, NULL, NULL, 20408),
(20409, '3.30.1460.20-FF-000022', NULL, 'Arp2/3 complex 34 kDa subunit', 67, NULL, NULL, 20409),
(20410, '3.30.870.10-FF-000186', NULL, 'Uncharacterized protein', 130, NULL, NULL, 20410),
(20411, '1.20.1070.10-FF-001797', NULL, 'Uncharacterized protein', 318, NULL, NULL, 20411),
(20412, '3.40.50.80-FF-000150', NULL, 'Cytochrome b5 reductase 4', 143, NULL, NULL, 20412),
(20413, '3.40.50.1820-FF-001838', NULL, 'Acylamino-acid-releasing enzyme', 80, NULL, NULL, 20413),
(20414, '2.20.70.10-FF-000156', NULL, 'Uncharacterized protein', 38, NULL, NULL, 20414),
(20415, '1.20.1720.10-FF-000015', NULL, 'Quinolone resistance protein NorB', 237, NULL, NULL, 20415),
(20416, '1.25.10.10-FF-002061', NULL, 'Condensin-2 complex subunit D3', 182, NULL, NULL, 20416),
(20417, '1.10.30.10-FF-000055', NULL, 'High mobility group B protein 15', 96, NULL, NULL, 20417),
(20418, '2.60.40.150-FF-000138', NULL, 'Fer-1-like family member 6', 139, NULL, NULL, 20418),
(20419, '3.90.70.10-FF-000184', NULL, 'Cysteine protease', 395, NULL, NULL, 20419),
(20420, '3.40.50.720-FF-000705', NULL, 'Pyrroline-5-carboxylate reductase', 161, NULL, NULL, 20420),
(20421, '1.10.486.10-FF-000041', NULL, 'RecBCD enzyme subunit RecB', 143, NULL, NULL, 20421),
(20422, '3.80.10.10-FF-004514', NULL, 'Putative inactive leucine-rich repeat receptor-like protein kinase', 85, NULL, NULL, 20422),
(20423, '3.30.70.330-FF-000831', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 146, NULL, NULL, 20423),
(20424, '2.40.70.10-FF-000424', NULL, NULL, 147, NULL, NULL, 20424),
(20425, '1.20.5.130-FF-000001', NULL, 'Bacteriocin hiracin-JM79', 41, NULL, NULL, 20425),
(20426, '1.20.1300.10-FF-000023', NULL, 'Cytochrome b560 subunit of succinate dehydrogenase', 142, NULL, NULL, 20426),
(20427, '1.10.555.10-FF-000078', NULL, 'RhoGAP domain containing protein', 207, NULL, NULL, 20427),
(20428, '3.30.465.10-FF-000008', NULL, 'Berberine bridge enzyme-like 15', 202, NULL, NULL, 20428),
(20429, '3.30.70.330-FF-001921', NULL, NULL, 221, NULL, NULL, 20429),
(20430, '2.120.10.30-FF-000367', NULL, 'Uncharacterized protein', 79, NULL, NULL, 20430),
(20431, '2.60.40.2860-FF-000022', NULL, '6-cysteine protein', 141, NULL, NULL, 20431),
(20432, '3.40.930.10-FF-000048', NULL, NULL, 179, NULL, NULL, 20432),
(20433, '3.40.50.1100-FF-000228', NULL, 'Predicted protein', 81, NULL, NULL, 20433),
(20434, '3.80.10.10-FF-002614', NULL, 'Uncharacterized protein', 223, NULL, NULL, 20434),
(20435, '3.40.630.10-FF-000166', NULL, 'Carboxypeptidase T, putative', 301, NULL, NULL, 20435),
(20436, '3.40.50.1000-FF-000608', NULL, NULL, 157, NULL, NULL, 20436),
(20437, '3.40.50.150-FF-001445', NULL, NULL, 142, NULL, NULL, 20437),
(20438, '3.10.20.90-FF-000910', NULL, 'Ubiquitin D', 82, NULL, NULL, 20438),
(20439, '2.60.40.10-FF-003322', NULL, 'Titin homolog', 87, NULL, NULL, 20439),
(20440, '2.130.10.10-FF-004008', NULL, 'Uncharacterized protein', 226, NULL, NULL, 20440),
(20441, '2.60.34.10-FF-000020', NULL, 'Heat shock SSE1', 152, NULL, NULL, 20441),
(20442, '3.40.50.2300-FF-000807', NULL, NULL, 85, NULL, NULL, 20442),
(20443, '3.90.20.20-FF-000021', NULL, 'GrpE protein homolog', 115, NULL, NULL, 20443),
(20444, '3.40.640.10-FF-000301', NULL, '4-aminobutyrate aminotransferase', 268, NULL, NULL, 20444),
(20445, '2.60.40.10-FF-002911', NULL, 'Titin homolog', 106, NULL, NULL, 20445),
(20446, '3.40.50.300-FF-003216', NULL, 'DNA mismatch repair protein', 114, NULL, NULL, 20446),
(20447, '2.20.100.10-FF-000151', NULL, 'SPONdin (Extracellular matrix glycoprotein) family', 59, NULL, NULL, 20447),
(20448, '1.10.1450.10-FF-000058', NULL, 'Tetraspanin', 82, NULL, NULL, 20448),
(20449, '3.90.920.10-FF-000008', NULL, 'DNA primase', 402, NULL, NULL, 20449),
(20450, '1.10.533.10-FF-000033', NULL, 'p53-induced death domain-containing protein 1 isoform X1', 100, NULL, NULL, 20450);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(20451, '1.25.40.20-FF-001481', NULL, 'Si:ch211-209a2.2', 94, NULL, NULL, 20451),
(20452, '3.30.70.270-FF-000144', NULL, 'Uncharacterized protein', 104, NULL, NULL, 20452),
(20453, '2.40.50.100-FF-000181', NULL, 'RND efflux system, membrane fusion protein CmeA', 55, NULL, NULL, 20453),
(20454, '3.40.50.300-FF-000799', NULL, 'ras-related protein Rab-24 isoform X1', 177, NULL, NULL, 20454),
(20455, '2.10.60.10-FF-000077', NULL, 'Serine/threonine-protein kinase receptor', 57, NULL, NULL, 20455),
(20456, '2.60.40.4370-FF-000014', NULL, NULL, 100, NULL, NULL, 20456),
(20457, '2.60.40.10-FF-000916', NULL, 'Receptor-type tyrosine-protein phosphatase beta', 83, NULL, NULL, 20457),
(20458, '3.40.50.300-FF-000607', NULL, 'chromodomain-helicase-DNA-binding protein 1-like isoform X1', 220, NULL, NULL, 20458),
(20459, '3.40.50.620-FF-000310', NULL, 'Adenine nucleotide alpha hydrolases-like superfamily protein', 160, NULL, NULL, 20459),
(20460, '3.30.160.60-FF-005424', NULL, NULL, 37, NULL, NULL, 20460),
(20461, '3.40.140.70-FF-000011', NULL, 'Uncharacterized protein', 103, NULL, NULL, 20461),
(20462, '3.30.160.60-FF-006144', NULL, NULL, 30, NULL, NULL, 20462),
(20463, '3.20.20.140-FF-000322', NULL, 'Dihydroorotase, putative', 227, NULL, NULL, 20463),
(20464, '2.40.50.140-FF-000035', NULL, '30S ribosomal protein S1', 83, NULL, NULL, 20464),
(20465, '1.25.40.10-FF-004715', NULL, 'Uncharacterized protein', 322, NULL, NULL, 20465),
(20466, '3.10.290.10-FF-000073', NULL, 'Uncharacterized protein', 59, NULL, NULL, 20466),
(20467, '2.30.30.30-FF-000041', NULL, '40S ribosomal protein S4', 71, NULL, NULL, 20467),
(20468, '3.40.850.10-FF-000250', NULL, 'Predicted protein', 341, NULL, NULL, 20468),
(20469, '2.40.70.10-FF-000571', NULL, NULL, 201, NULL, NULL, 20469),
(20470, '3.40.50.300-FF-003789', NULL, 'DNA replication licensing factor MCM3', 148, NULL, NULL, 20470),
(20471, '3.40.50.150-FF-000265', NULL, 'rRNA adenine N(6)-methyltransferase', 207, NULL, NULL, 20471),
(20472, '2.40.50.700-FF-000001', NULL, 'Exosome complex exonuclease exoribonuclease (Rrp44)', 75, NULL, NULL, 20472),
(20473, '3.40.50.1820-FF-001591', NULL, 'Uncharacterized protein', 89, NULL, NULL, 20473),
(20474, '3.90.870.20-FF-000001', NULL, 'Decarbamoylnovobiocin carbamoyltransferase', 206, NULL, NULL, 20474),
(20475, '1.20.58.60-FF-000751', NULL, 'ACF7 protein', 65, NULL, NULL, 20475),
(20476, '2.60.40.10-FF-005076', NULL, NULL, 100, NULL, NULL, 20476),
(20477, '3.40.190.10-FF-000766', NULL, 'Predicted protein', 300, NULL, NULL, 20477),
(20478, '2.40.10.10-FF-000550', NULL, NULL, 78, NULL, NULL, 20478),
(20479, '2.60.40.10-FF-004811', NULL, NULL, 115, NULL, NULL, 20479),
(20480, '3.40.50.800-FF-000078', NULL, 'Threonine--tRNA ligase 2, cytoplasmic', 29, NULL, NULL, 20480),
(20481, '2.60.120.10-FF-000284', NULL, 'Cyclic nucleotide-gated potassium channel mll3241', 135, NULL, NULL, 20481),
(20482, '2.130.10.10-FF-000309', NULL, 'WD repeat domain 11', 235, NULL, NULL, 20482),
(20483, '1.20.1170.10-FF-000006', NULL, 'Uncharacterized protein', 268, NULL, NULL, 20483),
(20484, '3.30.60.20-FF-000161', NULL, 'SH3 and cysteine rich domain', 34, NULL, NULL, 20484),
(20485, '3.40.50.10810-FF-000206', NULL, 'Predicted protein', 137, NULL, NULL, 20485),
(20486, '3.30.1370.120-FF-000013', NULL, 'Type II secretion system protein', 72, NULL, NULL, 20486),
(20487, '1.10.418.10-FF-000176', NULL, 'Predicted protein', 110, NULL, NULL, 20487),
(20488, '2.60.40.60-FF-000195', NULL, 'Cadherin 16', 114, NULL, NULL, 20488),
(20489, '3.90.550.50-FF-000188', NULL, 'Predicted protein', 211, NULL, NULL, 20489),
(20490, '1.50.10.130-FF-000009', NULL, 'Terpenoid synthase 26', 201, NULL, NULL, 20490),
(20491, '3.10.20.10-FF-000033', NULL, 'DNA fragmentation factor, 40kDa, beta polypeptide (caspase-activated DNase)', 87, NULL, NULL, 20491),
(20492, '3.30.70.980-FF-000014', NULL, 'Probable transcriptional regulatory protein VV2_1184', 81, NULL, NULL, 20492),
(20493, '1.10.472.130-FF-000031', NULL, 'AGAP011441-PA', 162, NULL, NULL, 20493),
(20494, '3.40.50.1000-FF-000755', NULL, NULL, 43, NULL, NULL, 20494);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(20495, '3.30.70.330-FF-002540', NULL, NULL, 44, NULL, NULL, 20495),
(20496, '1.20.1070.10-FF-001134', NULL, 'Si:dkey-165a24.9', 301, NULL, NULL, 20496),
(20497, '1.10.720.30-FF-000013', NULL, 'SAP domain-containing ribonucleoprotein', 54, NULL, NULL, 20497),
(20498, '3.90.550.10-FF-000732', NULL, 'N-acetylgalactosaminyl transferase, putative', 251, NULL, NULL, 20498),
(20499, '3.40.50.10330-FF-000012', NULL, 'Diacylglycerol kinase', 126, NULL, NULL, 20499),
(20500, '3.10.450.700-FF-000010', NULL, 'Uncharacterized protein', 50, NULL, NULL, 20500),
(20501, '3.40.50.1240-FF-000113', NULL, '6-phosphofructo-2-kinase/fructose-2,6-biphosphatase 3', 87, NULL, NULL, 20501),
(20502, '3.40.50.300-FF-004385', NULL, 'Rab_A23 protein', 205, NULL, NULL, 20502),
(20503, '3.30.160.60-FF-005997', NULL, NULL, 44, NULL, NULL, 20503),
(20504, '4.10.60.10-FF-000084', NULL, 'Zinc knuckle domain protein (Byr3), putative', 57, NULL, NULL, 20504),
(20505, '3.40.630.30-FF-000222', NULL, 'Putative acetyltransferase', 170, NULL, NULL, 20505),
(20506, '2.130.10.10-FF-002873', NULL, 'WD repeat-containing protein 90', 312, NULL, NULL, 20506),
(20507, '3.30.160.60-FF-004805', NULL, NULL, 28, NULL, NULL, 20507),
(20508, '3.30.30.30-FF-000027', NULL, 'Heat shock protein, putative', 76, NULL, NULL, 20508),
(20509, '3.10.20.90-FF-000455', NULL, 'Phosphatidylinositol 4-kinase gamma 4', 79, NULL, NULL, 20509),
(20510, '3.30.70.580-FF-000001', NULL, 'tRNA pseudouridine synthase A', 105, NULL, NULL, 20510),
(20511, '3.80.10.10-FF-001125', NULL, 'Inactive leucine-rich repeat receptor-like protein kinase isoform B', 72, NULL, NULL, 20511),
(20512, '3.30.420.100-FF-000010', NULL, 'F14B2.25/F14B2.25', 115, NULL, NULL, 20512),
(20513, '3.30.40.10-FF-001697', NULL, 'Predicted protein', 68, NULL, NULL, 20513),
(20514, '3.30.710.10-FF-000146', NULL, 'Potassium voltage-gated channel subfamily A member 3', 123, NULL, NULL, 20514),
(20515, '3.30.160.60-FF-000192', NULL, 'Mds1 and evi1 complex locus protein', 27, NULL, NULL, 20515),
(20516, '1.10.560.10-FF-000163', NULL, 'Uncharacterized protein', 50, NULL, NULL, 20516),
(20517, '3.40.720.10-FF-000257', NULL, 'Uncharacterized protein', 66, NULL, NULL, 20517),
(20518, '3.30.420.40-FF-000717', NULL, 'SWI/SNF and RSC complexes subunit arp42', 28, NULL, NULL, 20518),
(20519, '3.10.129.10-FF-000064', NULL, 'Acyl-CoA thioester hydrolase, YbgC/YbaW family', 137, NULL, NULL, 20519),
(20520, '1.25.40.180-FF-000181', NULL, 'mRNA cap-binding protein', 262, NULL, NULL, 20520),
(20521, '2.70.170.10-FF-000150', NULL, 'CHRNA7-FAM7A fusion protein', 129, NULL, NULL, 20521),
(20522, '2.60.220.50-FF-000090', NULL, 'Adhesion G-protein coupled receptor D1', 165, NULL, NULL, 20522),
(20523, '3.90.550.10-FF-000069', NULL, 'Glycosyltransferase 8 domain-containing protein 1', 285, NULL, NULL, 20523),
(20524, '2.60.40.1660-FF-000004', NULL, 'sodium/potassium-transporting ATPase subunit beta-2', 300, NULL, NULL, 20524),
(20525, '3.30.50.10-FF-000034', NULL, 'CLUMA_CG002674, isoform A', 87, NULL, NULL, 20525),
(20526, '3.80.10.10-FF-001788', NULL, 'Uncharacterized protein', 120, NULL, NULL, 20526),
(20527, '3.30.1520.10-FF-000075', NULL, 'Mdm1p', 127, NULL, NULL, 20527),
(20528, '3.90.340.10-FF-000014', NULL, 'Uncharacterized protein', 39, NULL, NULL, 20528),
(20529, '3.10.100.10-FF-000205', NULL, NULL, 143, NULL, NULL, 20529),
(20530, '3.40.50.1380-FF-000014', NULL, 'Carbamoyl-phosphate synthase (glutamine-hydrolyzing)', 139, NULL, NULL, 20530),
(20531, '2.120.10.30-FF-000153', NULL, 'Receptor Mediated Endocytosis', 328, NULL, NULL, 20531),
(20532, '3.40.50.410-FF-000287', NULL, 'KU70 protein', 228, NULL, NULL, 20532),
(20533, '3.30.40.10-FF-000769', NULL, 'RBR-type E3 ubiquitin transferase', 94, NULL, NULL, 20533),
(20534, '1.20.1540.10-FF-000018', NULL, 'RHOMBOID-like protein 12, mitochondrial', 205, NULL, NULL, 20534),
(20535, '2.60.40.10-FF-000096', NULL, 'filamin-C isoform X2', 98, NULL, NULL, 20535),
(20536, '2.60.40.150-FF-000240', NULL, 'BnaA03g50900D protein', 121, NULL, NULL, 20536),
(20537, '4.10.640.10-FF-000034', NULL, 'YALI0E30371p', 64, NULL, NULL, 20537);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(20538, '3.40.190.10-FF-000103', NULL, 'Glutamate receptor', 120, NULL, NULL, 20538),
(20539, '3.30.160.60-FF-004952', NULL, NULL, 24, NULL, NULL, 20539),
(20540, '3.40.630.30-FF-000486', NULL, 'GCN5-related N-acetyltransferase', 150, NULL, NULL, 20540),
(20541, '2.160.20.10-FF-000303', NULL, 'Predicted protein', 185, NULL, NULL, 20541),
(20542, '2.60.60.30-FF-000002', NULL, 'Stress response protein SCP2', 175, NULL, NULL, 20542),
(20543, '3.30.1370.10-FF-000158', NULL, 'Drosophila dodeca-satellite protein 1', 77, NULL, NULL, 20543),
(20544, '3.90.226.10-FF-000243', NULL, 'ClpP/crotonase-like domain-containing protein', 221, NULL, NULL, 20544),
(20545, '1.20.1250.20-FF-000471', NULL, 'Monocarboxylate transporter, putative', 180, NULL, NULL, 20545),
(20546, '3.30.70.330-FF-002438', NULL, NULL, 87, NULL, NULL, 20546),
(20547, '3.40.50.720-FF-001678', NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase NAD-binding', 100, NULL, NULL, 20547),
(20548, '3.90.1150.220-FF-000010', NULL, 'Putative non-structural maintenance of chromosomes element 1', 84, NULL, NULL, 20548),
(20549, '3.30.450.20-FF-000084', NULL, 'Sensor histidine kinase CitA', 134, NULL, NULL, 20549),
(20550, '4.10.75.10-FF-000005', NULL, 'WAP four-disulfide core domain protein 12', 49, NULL, NULL, 20550),
(20551, '1.10.1320.10-FF-000004', NULL, 'DNA-directed RNA polymerase', 367, NULL, NULL, 20551),
(20552, '3.40.190.10-FF-000811', NULL, 'Uncharacterized protein', 90, NULL, NULL, 20552),
(20553, '1.25.40.20-FF-000862', NULL, 'Ankyrin 2, isoform X', 103, NULL, NULL, 20553),
(20554, '3.90.1150.10-FF-000010', NULL, 'Alanine aminotransferase 2', 173, NULL, NULL, 20554),
(20555, '2.30.30.100-FF-000235', NULL, 'U6 snRNA-associated Sm-like protein LSm1', 104, NULL, NULL, 20555),
(20556, '1.10.510.10-FF-000008', NULL, 'Non-specific serine/threonine protein kinase', 204, NULL, NULL, 20556),
(20557, '3.30.365.10-FF-000040', NULL, 'Glyceraldehyde dehydrogenase large chain', 148, NULL, NULL, 20557),
(20558, '3.30.460.80-FF-000012', NULL, 'Os12g0422971 protein', 70, NULL, NULL, 20558),
(20559, '1.25.10.10-FF-000936', NULL, 'Importin beta11', 1025, NULL, NULL, 20559),
(20560, '1.25.10.10-FF-002622', NULL, 'Uncharacterized protein', 130, NULL, NULL, 20560),
(20561, '1.10.630.10-FF-000236', NULL, 'Uncharacterized protein', 190, NULL, NULL, 20561),
(20562, '1.10.357.90-FF-000001', NULL, 'Telomerase reverse transcriptase', 173, NULL, NULL, 20562),
(20563, '3.40.50.720-FF-000144', NULL, 'Malate dehydrogenase [NADP]', 156, NULL, NULL, 20563),
(20564, '2.130.10.10-FF-001237', NULL, 'Topless-related protein 2', 154, NULL, NULL, 20564),
(20565, '2.70.150.10-FF-000148', NULL, 'Phospholipid-transporting ATPase', 167, NULL, NULL, 20565),
(20566, '1.10.3720.10-FF-000214', NULL, 'Binding-protein-dependent transport systems inner membrane component', 266, NULL, NULL, 20566),
(20567, '1.10.1160.10-FF-000002', NULL, 'Glutamate--tRNA ligase', 83, NULL, NULL, 20567),
(20568, '1.10.8.60-FF-000298', NULL, 'ATPase, AAA family', 69, NULL, NULL, 20568),
(20569, '2.60.260.20-FF-000004', NULL, 'Molecular chaperone DnaJ', 109, NULL, NULL, 20569),
(20570, '3.30.160.60-FF-004244', NULL, NULL, 55, NULL, NULL, 20570),
(20571, '1.20.140.150-FF-000122', NULL, 'Pickel, isoform D', 110, NULL, NULL, 20571),
(20572, '3.90.1440.10-FF-000009', NULL, 'Si:dkey-187j14.8', 72, NULL, NULL, 20572),
(20573, '1.20.20.10-FF-000020', NULL, 'ATP synthase subunit 9, mitochondrial', 76, NULL, NULL, 20573),
(20574, '3.50.50.60-FF-000615', NULL, 'Prenylcysteine oxidase/farnesylcysteine lyase', 367, NULL, NULL, 20574),
(20575, '1.20.5.190-FF-000103', NULL, NULL, 42, NULL, NULL, 20575),
(20576, '3.30.2130.30-FF-000040', NULL, 'Probable tRNA sulfurtransferase', 185, NULL, NULL, 20576),
(20577, '1.10.287.1490-FF-000040', NULL, 'ABC transporter ATP-binding protein', 107, NULL, NULL, 20577),
(20578, '1.10.472.10-FF-000216', NULL, 'TFIIB zinc-binding protein', 109, NULL, NULL, 20578),
(20579, '2.80.10.50-FF-000066', NULL, 'Interleukin-18', 165, NULL, NULL, 20579),
(20580, '2.60.40.10-FF-003631', NULL, NULL, 112, NULL, NULL, 20580);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(20581, '3.90.470.10-FF-000018', NULL, '60S ribosomal protein L17, putative', 175, NULL, NULL, 20581),
(20582, '1.20.1410.10-FF-000014', NULL, 'ENTH domain containing protein', 192, NULL, NULL, 20582),
(20583, '1.10.10.10-FF-000964', NULL, 'Phosphate regulon transcriptional regulatory protein PhoB', 103, NULL, NULL, 20583),
(20584, '2.60.120.200-FF-000365', NULL, 'Zonadhesin', 161, NULL, NULL, 20584),
(20585, '3.40.50.150-FF-000826', NULL, 'Methyltransferase, putative', 221, NULL, NULL, 20585),
(20586, '3.90.190.10-FF-000406', NULL, 'Uncharacterized protein', 186, NULL, NULL, 20586),
(20587, '3.30.1490.110-FF-000003', NULL, 'Cell division protein FtsA', 75, NULL, NULL, 20587),
(20588, '1.20.58.1080-FF-000020', NULL, 'AGAP012862-PA', 102, NULL, NULL, 20588),
(20589, '3.30.40.10-FF-002006', NULL, 'AGAP003561-PA', 50, NULL, NULL, 20589),
(20590, '3.10.105.10-FF-000048', NULL, 'Nickel ABC transporter, nickel/metallophore periplasmic binding protein', 227, NULL, NULL, 20590),
(20591, '1.20.272.10-FF-000070', NULL, NULL, 64, NULL, NULL, 20591),
(20592, '1.20.1250.20-FF-001297', NULL, 'Chromosome 19, whole genome shotgun sequence', 502, NULL, NULL, 20592),
(20593, '3.40.630.10-FF-000019', NULL, 'Aminoacylase 1', 192, NULL, NULL, 20593),
(20594, '3.30.200.20-FF-000375', NULL, 'Cell division related protein kinase 2', 85, NULL, NULL, 20594),
(20595, '1.20.120.1220-FF-000019', NULL, NULL, 136, NULL, NULL, 20595),
(20596, '3.40.50.200-FF-000095', NULL, 'Uncharacterized protein', 127, NULL, NULL, 20596),
(20597, '3.40.50.2300-FF-000246', NULL, 'Atrial natriuretic peptide receptor 3', 111, NULL, NULL, 20597),
(20598, '2.60.40.150-FF-000801', NULL, 'Extended synaptotagmin-like protein 2a', 55, NULL, NULL, 20598),
(20599, '2.60.40.3430-FF-000002', NULL, 'Uncharacterized protein', 86, NULL, NULL, 20599),
(20600, '3.30.200.20-FF-002370', NULL, 'Uncharacterized protein', 76, NULL, NULL, 20600),
(20601, '3.30.200.20-FF-002061', NULL, 'Probable serine/threonine-protein kinase clkA', 86, NULL, NULL, 20601),
(20602, '3.60.21.60-FF-000008', NULL, 'DNA polymerase alpha subunit B', 120, NULL, NULL, 20602),
(20603, '1.10.510.10-FF-000683', NULL, 'Protein kinase and PP2C-like domain-containing protein', 325, NULL, NULL, 20603),
(20604, '2.60.40.60-FF-000307', NULL, 'Zgc:123181', 108, NULL, NULL, 20604),
(20605, '3.60.40.10-FF-000127', NULL, 'Probable protein phosphatase DDB_G0279461', 259, NULL, NULL, 20605),
(20606, '1.20.120.1630-FF-000024', NULL, 'Phosphatidylethanolamine N-methyltransferase', 166, NULL, NULL, 20606),
(20607, '3.30.40.10-FF-002315', NULL, 'Predicted protein', 106, NULL, NULL, 20607),
(20608, '2.60.120.200-FF-000056', NULL, 'Laminin subunit alpha 3', 203, NULL, NULL, 20608),
(20609, '2.130.10.10-FF-003755', NULL, 'Uncharacterized protein', 325, NULL, NULL, 20609),
(20610, '2.60.40.10-FF-004148', NULL, NULL, 89, NULL, NULL, 20610),
(20611, '3.50.50.60-FF-000306', NULL, 'Glutathione reductase', 119, NULL, NULL, 20611),
(20612, '1.20.58.60-FF-000088', NULL, 'microtubule-actin cross-linking factor 1 isoform X2', 109, NULL, NULL, 20612),
(20613, '1.10.10.10-FF-000655', NULL, 'Type 2 DNA topoisomerase 6 subunit A', 145, NULL, NULL, 20613),
(20614, '3.40.30.10-FF-000583', NULL, 'Thioredoxin', 61, NULL, NULL, 20614),
(20615, '1.25.10.10-FF-000913', NULL, 'GM10891', 525, NULL, NULL, 20615),
(20616, '1.20.58.480-FF-000010', NULL, 'Indoleamine 2,3-dioxygenase 1', 264, NULL, NULL, 20616),
(20617, '3.40.50.10090-FF-000024', NULL, 'Uroporphyrinogen-III synthase chloroplastic', 126, NULL, NULL, 20617),
(20618, '3.30.565.10-FF-000521', NULL, 'Histidine kinase', 66, NULL, NULL, 20618),
(20619, '3.40.50.300-FF-001007', NULL, 'putative pre-mRNA-splicing factor ATP-dependent RNA helicase DHX32', 222, NULL, NULL, 20619),
(20620, '3.30.565.10-FF-000527', NULL, 'Two-component sensor histidine kinase', 159, NULL, NULL, 20620),
(20621, '1.10.8.270-FF-000163', NULL, 'Growth hormone-regulated TBC protein, putative', 86, NULL, NULL, 20621),
(20622, '1.25.40.1040-FF-000031', NULL, 'YALI0B11836p', 346, NULL, NULL, 20622),
(20623, '3.40.50.880-FF-000068', NULL, 'Anthranilate synthase component II', 187, NULL, NULL, 20623);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(20624, '3.30.750.24-FF-000089', NULL, 'Putative sulfate transporter', 137, NULL, NULL, 20624),
(20625, '3.30.200.20-FF-000167', NULL, 'Putative inactive tyrosine-protein kinase 7', 116, NULL, NULL, 20625),
(20626, '1.25.10.10-FF-002521', NULL, 'Uncharacterized protein', 192, NULL, NULL, 20626),
(20627, '1.10.630.10-FF-000135', NULL, 'Cytochrome P450 family 26 subfamily C member 1', 168, NULL, NULL, 20627),
(20628, '1.10.940.10-FF-000001', NULL, 'Transcription antitermination factor NusB', 138, NULL, NULL, 20628),
(20629, '1.10.287.550-FF-000009', NULL, 'Uncharacterized protein', 57, NULL, NULL, 20629),
(20630, '2.20.70.10-FF-000026', NULL, 'E3 ubiquitin-protein ligase', 37, NULL, NULL, 20630),
(20631, '3.30.200.20-FF-000161', NULL, 'PX domain-containing protein kinase-like protein isoform X2', 19, NULL, NULL, 20631),
(20632, '3.40.50.300-FF-002480', NULL, 'Dicer-like protein 2', 228, NULL, NULL, 20632),
(20633, '3.40.50.300-FF-006330', NULL, 'Uncharacterized protein', 75, NULL, NULL, 20633),
(20634, '3.20.20.70-FF-000483', NULL, NULL, 187, NULL, NULL, 20634),
(20635, '3.30.160.60-FF-003171', NULL, NULL, 30, NULL, NULL, 20635),
(20636, '2.40.160.10-FF-000021', NULL, 'Mitochondrial Protein Translocase (MPT) Family', 209, NULL, NULL, 20636),
(20637, '3.30.497.10-FF-000014', NULL, 'Serpin family E member 3', 212, NULL, NULL, 20637),
(20638, '1.20.1250.20-FF-000499', NULL, 'MFS transporter', 407, NULL, NULL, 20638),
(20639, '3.30.420.40-FF-000341', NULL, 'Carbohydrate kinase', 236, NULL, NULL, 20639),
(20640, '2.60.40.10-FF-004250', NULL, NULL, 99, NULL, NULL, 20640),
(20641, '3.20.20.70-FF-000011', NULL, 'Biotin synthase', 312, NULL, NULL, 20641),
(20642, '1.10.510.10-FF-000992', NULL, 'Mitogen-activated protein kinase kinase kinase nsy-1', 192, NULL, NULL, 20642),
(20643, '3.10.20.90-FF-000793', NULL, 'Ubiquitin-like superfamily protein', 105, NULL, NULL, 20643),
(20644, '3.20.20.220-FF-000048', NULL, 'Proline dehydrogenase', 184, NULL, NULL, 20644),
(20645, '2.30.42.10-FF-000282', NULL, 'Varicose, isoform C', 90, NULL, NULL, 20645),
(20646, '3.50.50.60-FF-000250', NULL, 'NAD(P)H-dependent glutamate synthase, putative', 150, NULL, NULL, 20646),
(20647, '1.20.58.390-FF-000269', NULL, 'Zinc activated ion channel', 84, NULL, NULL, 20647),
(20648, '3.40.50.2300-FF-000347', NULL, 'Hybrid sensor histidine kinase/response regulator', 140, NULL, NULL, 20648),
(20649, '3.40.50.300-FF-001535', NULL, 'Interferon induced protein 44', 194, NULL, NULL, 20649),
(20650, '2.60.40.10-FF-002586', NULL, 'Complement C4', 102, NULL, NULL, 20650),
(20651, '2.130.10.10-FF-002081', NULL, 'WD_domain_-_G-beta_repeat_-_putative', 301, NULL, NULL, 20651),
(20652, '3.40.50.300-FF-007948', NULL, 'Uncharacterized protein', 169, NULL, NULL, 20652),
(20653, '3.40.50.150-FF-000517', NULL, 'YJR129C-like protein', 243, NULL, NULL, 20653),
(20654, '3.90.190.10-FF-000300', NULL, 'DnaJ heat shock protein family (Hsp40) member C6', 59, NULL, NULL, 20654),
(20655, '1.10.10.60-FF-000181', NULL, 'HTH-type transcriptional activator RhaS', 105, NULL, NULL, 20655),
(20656, '1.25.10.10-FF-001425', NULL, 'WGS project CABT00000000 data, contig 2.36', 232, NULL, NULL, 20656),
(20657, '3.40.309.10-FF-000110', NULL, 'Uncharacterized protein', 125, NULL, NULL, 20657),
(20658, '1.10.287.850-FF-000004', NULL, 'PE family protein', 98, NULL, NULL, 20658),
(20659, '1.25.40.1010-FF-000016', NULL, 'Tetratricopeptide repeat (TPR)-containing protein', 110, NULL, NULL, 20659),
(20660, '3.60.20.10-FF-000160', NULL, NULL, 111, NULL, NULL, 20660),
(20661, '1.20.1070.10-FF-001926', NULL, 'Uncharacterized protein', 280, NULL, NULL, 20661),
(20662, '3.40.50.300-FF-006223', NULL, 'GTP-binding elongation factor', 186, NULL, NULL, 20662),
(20663, '3.10.129.10-FF-000171', NULL, 'PaaI family thioesterase', 138, NULL, NULL, 20663),
(20664, '2.40.100.10-FF-000045', NULL, 'Peptidyl-prolyl cis-trans isomerase D', 180, NULL, NULL, 20664),
(20665, '3.40.50.1820-FF-001855', NULL, 'Putative phospholipase', 304, NULL, NULL, 20665),
(20666, '1.10.8.1310-FF-000007', NULL, 'Uncharacterized protein', 166, NULL, NULL, 20666);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(20667, '1.25.40.10-FF-003653', NULL, 'NRDE-2, necessary for RNA interference, domain containing', 276, NULL, NULL, 20667),
(20668, '3.30.830.10-FF-000195', NULL, 'Uncharacterized protein', 255, NULL, NULL, 20668),
(20669, '3.40.50.2000-FF-000038', NULL, 'UDP-GlucuronosylTransferase', 174, NULL, NULL, 20669),
(20670, '1.20.1250.20-FF-001808', NULL, 'Major facilitator superfamily MFS_1', 165, NULL, NULL, 20670),
(20671, '2.20.70.10-FF-000133', NULL, 'TransCription Elongation Regulator homolog', 54, NULL, NULL, 20671),
(20672, '2.130.10.10-FF-004374', NULL, 'Predicted protein', 83, NULL, NULL, 20672),
(20673, '1.20.58.60-FF-000335', NULL, 'SMAll', 104, NULL, NULL, 20673),
(20674, '3.40.50.150-FF-001029', NULL, 'Erythromycin 3''''-O-methyltransferase', 284, NULL, NULL, 20674),
(20675, '1.25.10.10-FF-002044', NULL, 'Importin subunit alpha-1', 85, NULL, NULL, 20675),
(20676, '1.20.1300.10-FF-000040', NULL, 'Succinate dehydrogenase, putative', 93, NULL, NULL, 20676),
(20677, '3.30.1640.30-FF-000005', NULL, 'Serine protease easter', 66, NULL, NULL, 20677),
(20678, '2.70.160.11-FF-000010', NULL, 'Protein arginine N-methyltransferase', 178, NULL, NULL, 20678),
(20679, '1.10.3210.10-FF-000086', NULL, 'HD domain-containing protein 2-like Protein', 140, NULL, NULL, 20679),
(20680, '1.10.530.10-FF-000083', NULL, 'Transglycosylase', 124, NULL, NULL, 20680),
(20681, '3.40.50.150-FF-000956', NULL, 'Crg1p', 287, NULL, NULL, 20681),
(20682, '3.10.20.90-FF-000686', NULL, 'Ubiquitin-60S ribosomal protein L40', 79, NULL, NULL, 20682),
(20683, '1.10.8.370-FF-000002', NULL, 'Polyprotein 1a', 86, NULL, NULL, 20683),
(20684, '2.60.130.10-FF-000003', NULL, 'Catechol 1,2-dioxygenase', 308, NULL, NULL, 20684),
(20685, '2.30.30.40-FF-000414', NULL, 'Predicted protein', 64, NULL, NULL, 20685),
(20686, '3.90.740.10-FF-000016', NULL, 'Isoleucine--tRNA ligase', 134, NULL, NULL, 20686),
(20687, '1.25.10.10-FF-001908', NULL, 'Arm repeat-containing protein-like protein', 207, NULL, NULL, 20687),
(20688, '2.40.170.20-FF-000103', NULL, 'SusC homolog', 569, NULL, NULL, 20688),
(20689, '3.80.10.10-FF-002406', NULL, 'PH domain and leucine rich repeat protein phosphatase 2', 116, NULL, NULL, 20689),
(20690, '2.60.120.260-FF-000462', NULL, 'Acetylxylan esterase / glucomannan deacetylase', 129, NULL, NULL, 20690),
(20691, '1.10.1420.10-FF-000146', NULL, 'Putative MSH3, mismatch repair ATPase', 178, NULL, NULL, 20691),
(20692, '1.25.40.180-FF-000310', NULL, NULL, 278, NULL, NULL, 20692),
(20693, '2.60.120.330-FF-000168', NULL, 'Uncharacterized protein', 322, NULL, NULL, 20693),
(20694, '1.10.10.10-FF-000863', NULL, 'Cholera toxin transcriptional activator', 106, NULL, NULL, 20694),
(20695, '1.10.3080.10-FF-000069', NULL, 'Chloride channel protein', 171, NULL, NULL, 20695),
(20696, '3.40.50.300-FF-004278', NULL, 'Sulfotransferase', 162, NULL, NULL, 20696),
(20697, '3.50.50.60-FF-000407', NULL, 'Nitrite reductase NiiA', 132, NULL, NULL, 20697),
(20698, '1.20.1250.20-FF-000027', NULL, 'Sialic acid transporter NanT', 193, NULL, NULL, 20698),
(20699, '3.80.10.10-FF-002160', NULL, 'Leucine-rich repeat protein (LRRP), putative', 240, NULL, NULL, 20699),
(20700, '3.80.10.10-FF-003339', NULL, 'Uncharacterized protein', 121, NULL, NULL, 20700),
(20701, '3.20.20.80-FF-000379', NULL, 'DUF4434 domain-containing protein', 318, NULL, NULL, 20701),
(20702, '3.40.50.2300-FF-000824', NULL, NULL, 143, NULL, NULL, 20702),
(20703, '3.30.200.20-FF-000700', NULL, 'Discoidin domain receptor, isoform F', 109, NULL, NULL, 20703),
(20704, '2.20.100.10-FF-000235', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs gon-1', 51, NULL, NULL, 20704),
(20705, '1.25.40.180-FF-000001', NULL, 'Eukaryotic translation initiation factor 4 gamma, 3, putative', 243, NULL, NULL, 20705),
(20706, '1.10.510.10-FF-000553', NULL, 'Tyrosine-protein kinase', 242, NULL, NULL, 20706),
(20707, '1.25.40.20-FF-000418', NULL, 'KiDINs220 (Vertebrate scaffold protein) homolog', 264, NULL, NULL, 20707),
(20708, '2.40.50.140-FF-000373', NULL, '30S ribosomal protein S17', 79, NULL, NULL, 20708);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(20709, '1.25.40.10-FF-001360', NULL, 'Pentatricopeptide (PPR) repeat-containing protein-like', 234, NULL, NULL, 20709),
(20710, '3.20.20.140-FF-000013', NULL, 'Allantoinase', 322, NULL, NULL, 20710),
(20711, '3.10.450.50-FF-000069', NULL, 'Predicted protein', 73, NULL, NULL, 20711),
(20712, '3.10.196.10-FF-000005', NULL, 'Probable methionine synthase', 233, NULL, NULL, 20712),
(20713, '1.25.40.10-FF-001253', NULL, 'TPR domain protein', 94, NULL, NULL, 20713),
(20714, '2.130.10.10-FF-002766', NULL, 'Chromatin assembly factor 1 subunit B, putative', 239, NULL, NULL, 20714),
(20715, '3.30.565.10-FF-000044', NULL, 'Phytochrome', 167, NULL, NULL, 20715),
(20716, '3.30.160.20-FF-000073', NULL, 'Double-stranded RNA-binding protein Staufen homolog', 84, NULL, NULL, 20716),
(20717, '1.10.510.10-FF-000660', NULL, 'Mitogen-activated protein kinase 5', 216, NULL, NULL, 20717),
(20718, '2.160.20.10-FF-000343', NULL, 'Uncharacterized protein', 260, NULL, NULL, 20718),
(20719, '2.40.50.140-FF-000266', NULL, 'rRNA biogenesis protein rrp5', 96, NULL, NULL, 20719),
(20720, '1.20.1070.10-FF-001550', NULL, 'Zg07', 175, NULL, NULL, 20720),
(20721, '3.40.470.10-FF-000029', NULL, 'Uracil-DNA glycosylase', 264, NULL, NULL, 20721),
(20722, '1.10.8.10-FF-000221', NULL, 'Holliday junction ATP-dependent DNA helicase RuvA', 64, NULL, NULL, 20722),
(20723, '1.25.10.10-FF-001897', NULL, 'Uncharacterized protein', 254, NULL, NULL, 20723),
(20724, '3.40.50.1000-FF-000524', NULL, NULL, 166, NULL, NULL, 20724),
(20725, '3.40.980.10-FF-000006', NULL, 'Molybdenum cofactor biosynthesis protein B', 167, NULL, NULL, 20725),
(20726, '3.30.70.330-FF-002293', NULL, NULL, 65, NULL, NULL, 20726),
(20727, '1.10.10.10-FF-000424', NULL, 'Pur operon repressor', 73, NULL, NULL, 20727),
(20728, '1.20.144.10-FF-000132', NULL, 'Uncharacterized protein', 114, NULL, NULL, 20728),
(20729, '2.60.490.10-FF-000024', NULL, 'p2X purinoceptor 5', 51, NULL, NULL, 20729),
(20730, '3.40.50.300-FF-008128', NULL, 'Lon protease homolog, mitochondrial', 105, NULL, NULL, 20730),
(20731, '1.10.1510.30-FF-000007', NULL, 'Uncharacterized protein', 45, NULL, NULL, 20731),
(20732, '3.20.20.80-FF-000340', NULL, 'Glycosyl hydrolase family 17 protein', 320, NULL, NULL, 20732),
(20733, '2.40.240.130-FF-000010', NULL, 'Axin-1', 83, NULL, NULL, 20733),
(20734, '3.20.20.80-FF-000688', NULL, 'Putative glycosyl hydrolase', 314, NULL, NULL, 20734),
(20735, '3.30.300.30-FF-000065', NULL, 'Phenyloxazoline synthase MbtB', 100, NULL, NULL, 20735),
(20736, '2.40.10.10-FF-000331', NULL, NULL, 123, NULL, NULL, 20736),
(20737, '1.25.40.20-FF-000098', NULL, 'Oxysterol-binding protein', 85, NULL, NULL, 20737),
(20738, '2.40.70.10-FF-000346', NULL, NULL, 157, NULL, NULL, 20738),
(20739, '3.80.10.10-FF-000271', NULL, 'F-box/LRR-repeat protein 20 isoform X1', 76, NULL, NULL, 20739),
(20740, '1.10.533.10-FF-000117', NULL, 'Uncharacterized protein', 113, NULL, NULL, 20740),
(20741, '3.40.140.10-FF-000055', NULL, 'COP9 signalosome complex subunit 6', 206, NULL, NULL, 20741),
(20742, '3.40.50.150-FF-001338', NULL, NULL, 196, NULL, NULL, 20742),
(20743, '3.40.50.300-FF-004880', NULL, 'DEAH-box helicase 35', 125, NULL, NULL, 20743),
(20744, '1.20.58.1780-FF-000016', NULL, 'YALI0E02706p', 297, NULL, NULL, 20744),
(20745, '3.90.1420.10-FF-000019', NULL, 'Histone-lysine N-methyltransferase setd3', 160, NULL, NULL, 20745),
(20746, '3.40.640.10-FF-000520', NULL, 'Uncharacterized protein', 142, NULL, NULL, 20746),
(20747, '1.10.357.10-FF-000011', NULL, 'Transcriptional regulator, TetR family', 199, NULL, NULL, 20747),
(20748, '3.40.190.10-FF-000575', NULL, 'Prephenate dehydratase-like', 51, NULL, NULL, 20748),
(20749, '2.30.170.40-FF-000004', NULL, '50S ribosomal protein L28', 73, NULL, NULL, 20749),
(20750, '1.20.5.730-FF-000001', NULL, 'rho-associated protein kinase 2', 72, NULL, NULL, 20750),
(20751, '2.120.10.80-FF-000365', NULL, 'Predicted protein', 248, NULL, NULL, 20751),
(20752, '3.40.5.10-FF-000014', NULL, 'Uncharacterized protein', 62, NULL, NULL, 20752),
(20753, '1.10.10.60-FF-000506', NULL, 'NK6 homeobox 1', 47, NULL, NULL, 20753);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(20754, '3.80.10.10-FF-002053', NULL, 'Predicted protein', 164, NULL, NULL, 20754),
(20755, '3.40.50.2000-FF-000690', NULL, 'Mannosyl transferase', 186, NULL, NULL, 20755),
(20756, '3.40.50.720-FF-001425', NULL, 'Polyketide synthase', 516, NULL, NULL, 20756),
(20757, '3.30.160.60-FF-000298', NULL, 'zinc finger protein 280D isoform X1', 61, NULL, NULL, 20757),
(20758, '3.10.110.10-FF-000381', NULL, 'Uncharacterized protein', 152, NULL, NULL, 20758),
(20759, '2.40.50.100-FF-000046', NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase', 93, NULL, NULL, 20759),
(20760, '3.50.50.60-FF-001020', NULL, 'Dihydropyrimidine dehydrogenase [NADP(+)]', 136, NULL, NULL, 20760),
(20761, '2.130.10.10-FF-001462', NULL, 'COMPASS-like H3K4 histone methylase component WDR5B', 128, NULL, NULL, 20761),
(20762, '3.30.420.40-FF-000234', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', 114, NULL, NULL, 20762),
(20763, '1.25.40.10-FF-001736', NULL, 'lysine-specific demethylase 6A isoform X1', 103, NULL, NULL, 20763),
(20764, '1.10.10.790-FF-000036', NULL, NULL, 144, NULL, NULL, 20764),
(20765, '3.40.50.2000-FF-000162', NULL, 'Beta-1,4-mannosyltransferase (Alg1), putative', 188, NULL, NULL, 20765),
(20766, '3.80.10.10-FF-003941', NULL, 'Os01g0515300 protein', 81, NULL, NULL, 20766),
(20767, '3.40.50.880-FF-000175', NULL, 'AGAP000705-PA', 209, NULL, NULL, 20767),
(20768, '3.40.190.10-FF-000210', NULL, 'Glutamate receptor ionotropic, kainate 1', 153, NULL, NULL, 20768),
(20769, '3.30.160.60-FF-001282', NULL, 'Zinc finger and BTB domain-containing protein 41', 34, NULL, NULL, 20769),
(20770, '2.40.100.10-FF-000152', NULL, 'Peptidyl-prolyl cis-trans isomerase', 160, NULL, NULL, 20770),
(20771, '1.25.40.10-FF-002664', NULL, 'Uncharacterized protein', 197, NULL, NULL, 20771),
(20772, '2.40.170.20-FF-000092', NULL, 'Transporter, outer membrane receptor (OMR) family', 724, NULL, NULL, 20772),
(20773, '1.10.287.40-FF-000008', NULL, 'Serine-tRNA ligase', 111, NULL, NULL, 20773),
(20774, '2.60.40.60-FF-000779', NULL, 'Uncharacterized protein', 104, NULL, NULL, 20774),
(20775, '1.20.58.1080-FF-000008', NULL, 'Putative RNA helicase (Putative mitochondrial)', 112, NULL, NULL, 20775),
(20776, '2.40.100.10-FF-000175', NULL, 'Peptidyl-prolyl cis-trans isomerase', 71, NULL, NULL, 20776),
(20777, '2.30.180.10-FF-000092', NULL, 'Fasciclin-1 fasciclin i fas i fcn', 159, NULL, NULL, 20777),
(20778, '3.30.160.60-FF-000309', NULL, 'zinc finger X-chromosomal protein-like', 29, NULL, NULL, 20778),
(20779, '1.25.10.10-FF-001532', NULL, 'AP-1 complex subunit gamma', 404, NULL, NULL, 20779),
(20780, '3.90.700.10-FF-000014', NULL, 'Uncharacterized protein', 73, NULL, NULL, 20780),
(20781, '1.10.287.1490-FF-000146', NULL, 'Uncharacterized protein', 170, NULL, NULL, 20781),
(20782, '2.130.10.10-FF-003862', NULL, 'AGAP004756-PA', 282, NULL, NULL, 20782),
(20783, '2.60.40.10-FF-000332', NULL, 'neuronal cell adhesion molecule isoform X2', 111, NULL, NULL, 20783),
(20784, '3.40.50.40-FF-000014', NULL, NULL, 112, NULL, NULL, 20784),
(20785, '3.40.50.300-FF-005711', NULL, 'Exodeoxyribonuclease V gamma chain', 168, NULL, NULL, 20785),
(20786, '3.90.550.10-FF-000272', NULL, 'Dolichol-P-glucose synthetase', 148, NULL, NULL, 20786),
(20787, '2.10.70.10-FF-000111', NULL, 'Coagulation factor XIII B chain', 63, NULL, NULL, 20787),
(20788, '1.20.140.180-FF-000002', NULL, 'Dermonecrotic toxin', 143, NULL, NULL, 20788),
(20789, '3.40.50.300-FF-007639', NULL, 'Putative ATP dependent DEAD-box helicase', 140, NULL, NULL, 20789),
(20790, '1.10.238.10-FF-000847', NULL, 'uncharacterized protein LOC100175312 isoform X1', 74, NULL, NULL, 20790),
(20791, '2.70.150.10-FF-000160', NULL, 'Sarcoplasmic/endoplasmic reticulum calcium ATPase 1', 171, NULL, NULL, 20791),
(20792, '2.60.40.10-FF-004603', NULL, NULL, 96, NULL, NULL, 20792),
(20793, '3.40.50.300-FF-001316', NULL, 'Nitric oxide associated 1 A', 172, NULL, NULL, 20793),
(20794, '1.10.510.10-FF-003061', NULL, NULL, 206, NULL, NULL, 20794),
(20795, '3.30.40.10-FF-001798', NULL, 'Predicted protein', 110, NULL, NULL, 20795);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(20796, '3.30.60.90-FF-000030', NULL, 'Transcriptional adapter', 55, NULL, NULL, 20796),
(20797, '1.20.1560.10-FF-000036', NULL, 'ATP-binding cassette sub-family D member 3', 352, NULL, NULL, 20797),
(20798, '1.20.120.1760-FF-000052', NULL, NULL, 117, NULL, NULL, 20798),
(20799, '3.80.10.10-FF-001541', NULL, 'Uncharacterized protein', 80, NULL, NULL, 20799),
(20800, '3.30.450.20-FF-000320', NULL, 'Methyl-accepting chemotaxis protein', 85, NULL, NULL, 20800),
(20801, '2.130.10.10-FF-000517', NULL, 'WD repeat-containing protein 43', 56, NULL, NULL, 20801),
(20802, '3.40.50.300-FF-000916', NULL, 'ABC transporter B family member 9', 252, NULL, NULL, 20802),
(20803, '3.40.50.720-FF-000806', NULL, '3-oxoacyl-[acyl-carrier-protein] reductase FabG', 241, NULL, NULL, 20803),
(20804, '1.10.472.10-FF-000571', NULL, 'Uncharacterized protein', 57, NULL, NULL, 20804),
(20805, '3.80.30.20-FF-000016', NULL, 'Oxygen-independent coproporphyrinogen III oxidase', 218, NULL, NULL, 20805),
(20806, '3.80.10.10-FF-002030', NULL, 'Predicted protein', 208, NULL, NULL, 20806),
(20807, '2.60.40.60-FF-000414', NULL, 'Dachsous, isoform B', 105, NULL, NULL, 20807),
(20808, '2.30.40.10-FF-000120', NULL, 'Predicted protein', 94, NULL, NULL, 20808),
(20809, '2.60.40.640-FF-000044', NULL, 'Aly1p', 155, NULL, NULL, 20809),
(20810, '1.10.287.20-FF-000002', NULL, 'Cytochrome b-c1 complex subunit 6', 76, NULL, NULL, 20810),
(20811, '3.30.530.20-FF-000040', NULL, 'MLP-like protein 329', 151, NULL, NULL, 20811),
(20812, '3.40.50.300-FF-008584', NULL, '26S proteasome regulatory subunit, putative', 188, NULL, NULL, 20812),
(20813, '3.40.50.1910-FF-000005', NULL, 'vacuolar protein sorting-associated protein 33A isoform X1', 247, NULL, NULL, 20813),
(20814, '3.30.200.20-FF-001465', NULL, 'U-box domain-containing protein 57', 92, NULL, NULL, 20814),
(20815, '2.40.10.10-FF-000207', NULL, 'Lysyl endopeptidase', 104, NULL, NULL, 20815),
(20816, '2.130.10.10-FF-001838', NULL, 'WD repeat containing protein 48', 64, NULL, NULL, 20816),
(20817, '3.30.505.10-FF-000068', NULL, 'ras and Rab interactor 1', 97, NULL, NULL, 20817),
(20818, '3.40.50.300-FF-002171', NULL, 'Dynein heavy chain', 125, NULL, NULL, 20818),
(20819, '2.60.40.10-FF-006065', NULL, NULL, 97, NULL, NULL, 20819),
(20820, '3.40.50.2300-FF-001336', NULL, NULL, 74, NULL, NULL, 20820),
(20821, '1.10.150.130-FF-000019', NULL, 'Site-specific recombinase, phage integrase family', 113, NULL, NULL, 20821),
(20822, '2.10.110.10-FF-000345', NULL, 'Uncharacterized protein', 197, NULL, NULL, 20822),
(20823, '3.30.160.60-FF-001254', NULL, 'Zinc finger protein 564', 29, NULL, NULL, 20823),
(20824, '1.10.220.30-FF-000003', NULL, 'Flagellar motor switch protein FliG', 82, NULL, NULL, 20824),
(20825, '3.90.1530.10-FF-000011', NULL, 'Sulfiredoxin chloroplastic/mitochondrial', 55, NULL, NULL, 20825),
(20826, '3.40.50.2000-FF-000471', NULL, 'UDP-N-acetylglucosamine transferase subunit ALG14-like protein', 89, NULL, NULL, 20826),
(20827, '3.30.420.270-FF-000027', NULL, 'Biopolymer transport protein ExbD/TolR', 77, NULL, NULL, 20827),
(20828, '2.10.25.10-FF-001215', NULL, 'Integrin beta', 49, NULL, NULL, 20828),
(20829, '1.20.1070.10-FF-000145', NULL, 'Oxytocin receptor', 361, NULL, NULL, 20829),
(20830, '1.25.40.20-FF-001037', NULL, 'Espin like', 103, NULL, NULL, 20830),
(20831, '3.40.50.150-FF-000164', NULL, 'Methyltransferase NSUN5, putative', 226, NULL, NULL, 20831),
(20832, '3.30.50.10-FF-000135', NULL, 'Nuclear receptor subfamily 4 group A member 1', 36, NULL, NULL, 20832),
(20833, '1.25.40.20-FF-000637', NULL, 'Uncharacterized protein', 111, NULL, NULL, 20833),
(20834, '3.60.15.10-FF-000058', NULL, 'DNA repair metallo-beta-lactamase-domain-containing protein', 179, NULL, NULL, 20834),
(20835, '1.10.287.70-FF-000478', NULL, 'Uncharacterized protein', 140, NULL, NULL, 20835),
(20836, '3.40.50.300-FF-006678', NULL, 'Uncharacterized protein', 83, NULL, NULL, 20836),
(20837, '3.40.50.1820-FF-001602', NULL, 'Uncharacterized protein', 80, NULL, NULL, 20837),
(20838, '3.30.2350.20-FF-000031', NULL, 'tRNA pseudouridine synthase, putative', 227, NULL, NULL, 20838);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(20839, '3.30.1370.240-FF-000009', NULL, 'Phenylalanine--tRNA ligase alpha subunit', 85, NULL, NULL, 20839),
(20840, '2.70.130.10-FF-000158', NULL, NULL, 117, NULL, NULL, 20840),
(20841, '1.10.730.10-FF-000064', NULL, 'Probable arginine--tRNA ligase, cytoplasmic', 132, NULL, NULL, 20841),
(20842, '1.25.10.10-FF-002297', NULL, 'Uncharacterized protein', 324, NULL, NULL, 20842),
(20843, '1.20.58.60-FF-000644', NULL, 'Uncharacterized protein', 216, NULL, NULL, 20843),
(20844, '1.25.40.10-FF-003962', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 353, NULL, NULL, 20844),
(20845, '2.60.120.200-FF-000612', NULL, 'Uncharacterized protein', 149, NULL, NULL, 20845),
(20846, '3.40.50.2300-FF-000038', NULL, 'Galactose ABC transporter substrate-binding protein', 146, NULL, NULL, 20846),
(20847, '1.10.101.10-FF-000013', NULL, 'N-acetylmuramoyl-L-alanine amidase', 80, NULL, NULL, 20847),
(20848, '2.60.40.10-FF-005992', NULL, NULL, 113, NULL, NULL, 20848),
(20849, '3.40.50.1440-FF-000072', NULL, 'Tubulin, alpha 8-like 4', 91, NULL, NULL, 20849),
(20850, '3.40.50.970-FF-000095', NULL, 'Sulfopyruvate decarboxylase subunit beta', 170, NULL, NULL, 20850),
(20851, '2.60.260.20-FF-000105', NULL, 'AT19485p', 89, NULL, NULL, 20851),
(20852, '1.20.58.1470-FF-000002', NULL, 'Alpha-ketoglutarate-dependent dioxygenase FTO', 134, NULL, NULL, 20852),
(20853, '3.90.550.10-FF-000277', NULL, 'Glycosyltransferase-like protein, family 2', 285, NULL, NULL, 20853),
(20854, '1.10.490.10-FF-000056', NULL, 'Globin-coupled histidine kinase', 155, NULL, NULL, 20854),
(20855, '1.10.1420.10-FF-000129', NULL, 'DNA mismatch repair protein MSH4', 131, NULL, NULL, 20855),
(20856, '2.40.50.90-FF-000060', NULL, 'Tudor domain-containing protein 6', 95, NULL, NULL, 20856),
(20857, '3.80.10.10-FF-001996', NULL, 'Leucine-rich repeat receptor-like protein kinase PEPR1', 144, NULL, NULL, 20857),
(20858, '1.20.1250.20-FF-001191', NULL, 'Multidrug MFS transporter', 193, NULL, NULL, 20858),
(20859, '2.60.40.10-FF-002333', NULL, 'Myotactin form A', 116, NULL, NULL, 20859),
(20860, '2.30.29.30-FF-001268', NULL, 'Roco6, ROCO family protein', 101, NULL, NULL, 20860),
(20861, '3.40.50.360-FF-000002', NULL, 'Flavodoxin', 174, NULL, NULL, 20861),
(20862, '3.30.200.20-FF-001100', NULL, 'G protein-coupled receptor kinase', 64, NULL, NULL, 20862),
(20863, '1.20.58.60-FF-000116', NULL, 'Microtubule-actin cross-linking factor 1', 238, NULL, NULL, 20863),
(20864, '3.30.40.10-FF-000314', NULL, 'E3 ubiquitin-protein ligase TRIM32', 89, NULL, NULL, 20864),
(20865, '3.30.420.40-FF-000689', NULL, 'Carbohydrate kinase, FGGY family', 254, NULL, NULL, 20865),
(20866, '1.25.40.10-FF-002669', NULL, 'Uncharacterized protein', 112, NULL, NULL, 20866),
(20867, '1.20.1560.10-FF-000345', NULL, 'ATP-binding cassette protein subfamily C, member 8', 330, NULL, NULL, 20867),
(20868, '3.40.5.10-FF-000019', NULL, 'Ribosomal protein L9', 42, NULL, NULL, 20868),
(20869, '3.30.40.10-FF-001489', NULL, 'Uncharacterized protein', 80, NULL, NULL, 20869),
(20870, '3.20.20.70-FF-000466', NULL, NULL, 62, NULL, NULL, 20870),
(20871, '1.10.10.10-FF-001728', NULL, 'Phosphate regulon transcriptional regulatory protein', 108, NULL, NULL, 20871),
(20872, '2.120.10.30-FF-000361', NULL, 'Predicted protein', 56, NULL, NULL, 20872),
(20873, '2.120.10.30-FF-000176', NULL, 'Uncharacterized protein', 93, NULL, NULL, 20873),
(20874, '3.20.20.120-FF-000030', NULL, 'L-Lys-D/L-Arg epimerase', 241, NULL, NULL, 20874),
(20875, '3.30.559.70-FF-000002', NULL, 'Carnitine O-acetyltransferase', 315, NULL, NULL, 20875),
(20876, '1.25.10.10-FF-002830', NULL, 'Maestro heat-like repeat-containing protein family member 2B', 187, NULL, NULL, 20876),
(20877, '2.130.10.10-FF-000512', NULL, 'WD-40 repeat-containing protein MSI1', 419, NULL, NULL, 20877),
(20878, '1.25.40.20-FF-001582', NULL, 'Uncharacterized protein', 147, NULL, NULL, 20878),
(20879, '3.40.50.300-FF-001788', NULL, 'Axonemal dynein heavy chain', 125, NULL, NULL, 20879),
(20880, '3.40.50.1460-FF-000078', NULL, 'Uncharacterized protein', 153, NULL, NULL, 20880);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(20881, '2.60.120.1040-FF-000010', NULL, 'Zinc-finger protein zpr1', 143, NULL, NULL, 20881),
(20882, '3.90.1480.20-FF-000015', NULL, 'Lactosylceramide alpha-2,3-sialyltransferase', 298, NULL, NULL, 20882),
(20883, '1.10.12.10-FF-000007', NULL, 'Enoyl-CoA hydratase', 59, NULL, NULL, 20883),
(20884, '3.10.450.10-FF-000080', NULL, 'Antihemorrhagic factor BJ46a', 106, NULL, NULL, 20884),
(20885, '1.10.3720.10-FF-000097', NULL, 'Phosphate transport system permease protein', 276, NULL, NULL, 20885),
(20886, '3.30.40.10-FF-000842', NULL, 'E3 ubiquitin-protein ligase RMA1H1', 100, NULL, NULL, 20886),
(20887, '3.40.718.10-FF-000066', NULL, 'Isocitrate dehydrogenase [NADP]', 408, NULL, NULL, 20887),
(20888, '3.30.200.20-FF-002426', NULL, 'Uncharacterized protein', 79, NULL, NULL, 20888),
(20889, '1.10.287.70-FF-000006', NULL, 'Sodium channel protein', 142, NULL, NULL, 20889),
(20890, '1.10.3290.10-FF-000006', NULL, 'Protein adenylyltransferase and cysteine protease IbpA', 299, NULL, NULL, 20890),
(20891, '1.10.10.60-FF-000501', NULL, 'Unplaced genomic scaffold supercont1.172, whole genome shotgun sequence', 95, NULL, NULL, 20891),
(20892, '3.30.160.60-FF-000293', NULL, 'zinc finger protein 385B isoform X3', 46, NULL, NULL, 20892),
(20893, '2.60.40.10-FF-002810', NULL, 'Insulin-like growth factor 1 receptor', 105, NULL, NULL, 20893),
(20894, '3.30.450.20-FF-000292', NULL, 'Response regulator', 125, NULL, NULL, 20894),
(20895, '1.25.40.20-FF-001054', NULL, 'Poly [ADP-ribose] polymerase', 142, NULL, NULL, 20895),
(20896, '2.130.10.130-FF-000036', NULL, NULL, 206, NULL, NULL, 20896),
(20897, '2.60.40.60-FF-001050', NULL, 'Protocadherin fat, putative', 85, NULL, NULL, 20897),
(20898, '1.10.30.10-FF-000190', NULL, 'Predicted protein', 87, NULL, NULL, 20898),
(20899, '3.40.430.10-FF-000055', NULL, 'Bifunctional dihydrofolate reductase-thymidylate synthase 2', 160, NULL, NULL, 20899),
(20900, '3.30.465.10-FF-000115', NULL, 'Predicted protein', 68, NULL, NULL, 20900),
(20901, '1.20.1250.20-FF-002180', NULL, 'Uncharacterized protein', 170, NULL, NULL, 20901),
(20902, '3.20.20.80-FF-000795', NULL, 'Predicted protein', 167, NULL, NULL, 20902),
(20903, '3.40.1260.10-FF-000007', NULL, 'Sulfur relay protein TusB', 91, NULL, NULL, 20903),
(20904, '1.25.40.20-FF-000109', NULL, 'Kinase D-interacting substrate of 220 kDa', 101, NULL, NULL, 20904),
(20905, '3.40.1190.20-FF-000072', NULL, 'AT09463p', 316, NULL, NULL, 20905),
(20906, '3.40.50.1000-FF-000417', NULL, 'Haloacid dehalogenase', 223, NULL, NULL, 20906),
(20907, '1.25.40.10-FF-004581', NULL, 'Predicted protein', 180, NULL, NULL, 20907),
(20908, '1.40.20.10-FF-000002', NULL, 'Adenylate cyclase', 231, NULL, NULL, 20908),
(20909, '3.40.50.300-FF-007151', NULL, 'Uncharacterized protein', 176, NULL, NULL, 20909),
(20910, '1.10.443.10-FF-000009', NULL, 'Prophage DLP12 integrase', 182, NULL, NULL, 20910),
(20911, '3.90.640.10-FF-000071', NULL, 'Actin-related protein 7', 141, NULL, NULL, 20911),
(20912, '3.80.10.10-FF-004323', NULL, 'Toll-like receptor 4b, duplicate b', 404, NULL, NULL, 20912),
(20913, '3.40.50.12160-FF-000038', NULL, 'Uncharacterized protein', 104, NULL, NULL, 20913),
(20914, '3.30.1010.10-FF-000093', NULL, 'Phosphatidylinositol 3 and 4-kinase-like protein', 93, NULL, NULL, 20914),
(20915, '4.10.51.10-FF-000001', NULL, 'Cytochrome c oxidase subunit 7B, mitochondrial', 56, NULL, NULL, 20915),
(20916, '1.25.40.10-FF-000871', NULL, 'Pentatricopeptide repeat-containing protein', 105, NULL, NULL, 20916),
(20917, '1.25.40.540-FF-000013', NULL, 'TOR signaling pathway regulator', 237, NULL, NULL, 20917),
(20918, '2.40.110.10-FF-000001', NULL, 'Acyl-CoA dehydrogenase, mitochondrial', 113, NULL, NULL, 20918),
(20919, '3.40.1090.10-FF-000050', NULL, 'Patanin-like phospholipase domain-containing protein', 78, NULL, NULL, 20919),
(20920, '3.10.580.10-FF-000084', NULL, 'Domain_of_uncharacterized_function_DUF21', 149, NULL, NULL, 20920),
(20921, '1.20.5.710-FF-000006', NULL, '39S ribosomal protein L12, mitochondrial', 62, NULL, NULL, 20921),
(20922, '1.25.40.20-FF-001402', NULL, 'Uncharacterized protein', 151, NULL, NULL, 20922);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(20923, '2.30.42.10-FF-000321', NULL, 'MAGI family member, X-linked b', 96, NULL, NULL, 20923),
(20924, '3.40.50.10900-FF-000014', NULL, 'Putative enzyme (ATP-grasp superfamily)', 269, NULL, NULL, 20924),
(20925, '3.30.450.40-FF-000298', NULL, 'Glr3986 protein', 182, NULL, NULL, 20925),
(20926, '2.60.40.150-FF-000329', NULL, 'SyNapTotagmin', 147, NULL, NULL, 20926),
(20927, '4.10.800.10-FF-000013', NULL, 'Thyroglobulin', 71, NULL, NULL, 20927),
(20928, '1.10.10.10-FF-001245', NULL, 'Histone acetyltransferase', 74, NULL, NULL, 20928),
(20929, '1.10.287.3160-FF-000001', NULL, 'Thymopoietin isoform alpha', 179, NULL, NULL, 20929),
(20930, '1.20.1250.20-FF-000572', NULL, 'Unplaced genomic scaffold supercont1.204, whole genome shotgun sequence', 205, NULL, NULL, 20930),
(20931, '3.80.10.10-FF-000136', NULL, 'leucine-rich melanocyte differentiation-associated protein isoform X1', 160, NULL, NULL, 20931),
(20932, '3.40.50.620-FF-000546', NULL, 'Arginosuccinate synthase', 278, NULL, NULL, 20932),
(20933, '3.30.559.30-FF-000086', NULL, 'Nonribosomal peptide synthase nlsA', 138, NULL, NULL, 20933),
(20934, '1.20.58.1380-FF-000003', NULL, 'Nuclear pore complex subunit Nup133, putative', 96, NULL, NULL, 20934),
(20935, '3.30.200.20-FF-002084', NULL, 'Uncharacterized protein', 82, NULL, NULL, 20935),
(20936, '3.40.50.150-FF-000849', NULL, NULL, 144, NULL, NULL, 20936),
(20937, '2.60.40.150-FF-000785', NULL, 'Uncharacterized protein', 94, NULL, NULL, 20937),
(20938, '3.30.70.1630-FF-000002', NULL, 'Aminomethyltransferase', 75, NULL, NULL, 20938),
(20939, '3.60.15.10-FF-000277', NULL, 'Uncharacterized protein', 161, NULL, NULL, 20939),
(20940, '3.30.1330.10-FF-000021', NULL, 'Phosphoribosylformylglycinamidine synthase subunit PurL', 178, NULL, NULL, 20940),
(20941, '2.130.10.10-FF-002457', NULL, 'Cleavage and polyadenylation specific factor 1', 66, NULL, NULL, 20941),
(20942, '1.10.533.10-FF-000224', NULL, 'Importin subunit alpha-7', 93, NULL, NULL, 20942),
(20943, '3.30.200.20-FF-000476', NULL, 'Probable L-type lectin-domain containing receptor kinase S.5', 90, NULL, NULL, 20943),
(20944, '1.10.287.570-FF-000004', NULL, 'probable boron transporter 2', 43, NULL, NULL, 20944),
(20945, '2.60.120.10-FF-000177', NULL, 'Cyclic nucleotide-binding protein', 129, NULL, NULL, 20945),
(20946, '2.60.40.150-FF-000824', NULL, 'Uncharacterized protein PYUK71.03c', 126, NULL, NULL, 20946),
(20947, '1.10.238.10-FF-000408', NULL, 'Serine/threonine-protein phosphatase', 138, NULL, NULL, 20947),
(20948, '1.10.238.10-FF-000611', NULL, 'Cell division control protein Cdc31, putative', 85, NULL, NULL, 20948),
(20949, '3.40.30.10-FF-000274', NULL, 'PRDX1 isoform 3', 83, NULL, NULL, 20949),
(20950, '3.30.160.60-FF-003390', NULL, 'Zinc finger Y-chromosomal protein-like Protein', 64, NULL, NULL, 20950),
(20951, '1.25.10.10-FF-000604', NULL, 'armadillo repeat-containing protein 4 isoform X2', 146, NULL, NULL, 20951),
(20952, '3.40.50.720-FF-000121', NULL, 'Prostaglandin reductase 2', 176, NULL, NULL, 20952),
(20953, '2.60.40.10-FF-001630', NULL, 'titin isoform X1', 102, NULL, NULL, 20953),
(20954, '3.80.10.10-FF-000613', NULL, 'Leucine-rich repeat protein 11', 145, NULL, NULL, 20954),
(20955, '1.10.510.10-FF-002897', NULL, 'Probable serine/threonine-protein kinase fhkE', 263, NULL, NULL, 20955),
(20956, '3.40.50.300-FF-006206', NULL, 'Uncharacterized protein', 177, NULL, NULL, 20956),
(20957, '1.10.275.20-FF-000014', NULL, NULL, 72, NULL, NULL, 20957),
(20958, '3.30.70.330-FF-001820', NULL, NULL, 107, NULL, NULL, 20958),
(20959, '3.30.230.10-FF-000082', NULL, 'Ribonuclease P protein component', 112, NULL, NULL, 20959),
(20960, '1.10.730.10-FF-000171', NULL, 'Methionine--tRNA ligase', 150, NULL, NULL, 20960),
(20961, '3.30.40.10-FF-001803', NULL, 'Ubiquitinyl hydrolase 1', 120, NULL, NULL, 20961),
(20962, '3.30.160.60-FF-002243', NULL, 'zinc finger protein 646', 28, NULL, NULL, 20962),
(20963, '1.20.1310.10-FF-000097', NULL, 'Cullin family protein', 135, NULL, NULL, 20963),
(20964, '1.10.287.1490-FF-000141', NULL, 'Uncharacterized protein', 178, NULL, NULL, 20964);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(20965, '3.30.565.10-FF-000151', NULL, 'Sensor histidine kinase', 152, NULL, NULL, 20965),
(20966, '2.60.40.60-FF-000431', NULL, 'Cadherin EGF LAG seven-pass G-type receptor', 105, NULL, NULL, 20966),
(20967, '2.130.10.10-FF-001046', NULL, 'WD repeat-containing protein 18', 87, NULL, NULL, 20967),
(20968, '3.90.1580.10-FF-000031', NULL, 'Uncharacterized protein', 225, NULL, NULL, 20968),
(20969, '1.20.1160.11-FF-000024', NULL, NULL, 61, NULL, NULL, 20969),
(20970, '2.130.10.10-FF-005969', NULL, 'phosphoinositide 3-kinase regulatory subunit 4', 240, NULL, NULL, 20970),
(20971, '3.40.1360.10-FF-000043', NULL, 'DNA primase', 123, NULL, NULL, 20971),
(20972, '1.20.1530.20-FF-000054', NULL, 'Uncharacterized protein', 406, NULL, NULL, 20972),
(20973, '3.30.750.70-FF-000003', NULL, 'Succinate CoA transferase', 95, NULL, NULL, 20973),
(20974, '3.30.565.10-FF-000499', NULL, 'Heat shock protein 90-5 chloroplastic', 133, NULL, NULL, 20974),
(20975, '1.20.5.170-FF-000120', NULL, 'CREB Homolog', 53, NULL, NULL, 20975),
(20976, '2.60.450.10-FF-000022', NULL, 'Lipopolysaccharide export system protein LptC', 146, NULL, NULL, 20976),
(20977, '2.30.29.30-FF-000796', NULL, 'Oxysterol-binding protein related protein', 95, NULL, NULL, 20977),
(20978, '3.10.50.10-FF-000052', NULL, 'Uncharacterized protein', 54, NULL, NULL, 20978),
(20979, '3.30.470.160-FF-000015', NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta mitochondrial', 119, NULL, NULL, 20979),
(20980, '3.30.1330.40-FF-000041', NULL, 'Translation initiation inhibitor UK114/IBM1, putative', 77, NULL, NULL, 20980),
(20981, '4.10.60.10-FF-000191', NULL, 'Replication protein A subunit', 45, NULL, NULL, 20981),
(20982, '1.20.1270.50-FF-000003', NULL, 'Alpha-mannosidase', 57, NULL, NULL, 20982),
(20983, '3.30.70.330-FF-001365', NULL, 'RNA recognition motif domain containing protein', 152, NULL, NULL, 20983),
(20984, '3.40.50.1110-FF-000102', NULL, 'Lipase', 210, NULL, NULL, 20984),
(20985, '1.10.238.10-FF-000864', NULL, 'Uncharacterized protein', 119, NULL, NULL, 20985),
(20986, '3.30.420.40-FF-000711', NULL, 'Predicted protein', 134, NULL, NULL, 20986),
(20987, '1.10.287.940-FF-000003', NULL, 'P2X purinoceptor', 35, NULL, NULL, 20987),
(20988, '2.60.40.3180-FF-000011', NULL, 'AGAP011436-PA', 95, NULL, NULL, 20988),
(20989, '3.30.10.20-FF-000023', NULL, NULL, 54, NULL, NULL, 20989),
(20990, '2.60.200.20-FF-000192', NULL, 'ABC transporter', 114, NULL, NULL, 20990),
(20991, '3.40.50.1000-FF-000833', NULL, NULL, 80, NULL, NULL, 20991),
(20992, '3.40.50.1010-FF-000185', NULL, NULL, 208, NULL, NULL, 20992),
(20993, '1.20.1070.10-FF-001241', NULL, 'Putative frizzled receptor 3', 334, NULL, NULL, 20993),
(20994, '3.30.70.270-FF-000245', NULL, NULL, 49, NULL, NULL, 20994),
(20995, '3.40.50.1820-FF-000113', NULL, 'Putative hydrolase RBBP9', 185, NULL, NULL, 20995),
(20996, '3.30.470.30-FF-000088', NULL, 'DNA ligase', 226, NULL, NULL, 20996),
(20997, '3.30.200.110-FF-000003', NULL, 'Inositol-pentakisphosphate 2-kinase', 122, NULL, NULL, 20997),
(20998, '2.60.40.420-FF-000017', NULL, 'ephrin-A1', 132, NULL, NULL, 20998),
(20999, '2.170.140.10-FF-000017', NULL, 'Chitinase 6, isoform F', 65, NULL, NULL, 20999),
(21000, '2.40.70.10-FF-000216', NULL, 'Uncharacterized protein', 120, NULL, NULL, 21000),
(21001, '1.20.1250.20-FF-000044', NULL, 'Hexose transporter Hxt3p', 473, NULL, NULL, 21001),
(21002, '3.30.160.60-FF-004036', NULL, NULL, 37, NULL, NULL, 21002),
(21003, '3.30.420.220-FF-000001', NULL, 'Pre-mRNA processing ribonucleoprotein, binding domain protein', 107, NULL, NULL, 21003),
(21004, '2.110.10.10-FF-000030', NULL, 'Uncharacterized protein', 77, NULL, NULL, 21004),
(21005, '3.30.230.70-FF-000077', NULL, 'Eukaryotic exosome, 3''-5'' exoribonuclease subunit MTR3', 234, NULL, NULL, 21005),
(21006, '3.50.50.60-FF-000031', NULL, 'Oxygen-dependent choline dehydrogenase', 242, NULL, NULL, 21006),
(21007, '3.40.1230.10-FF-000022', NULL, 'Uncharacterized protein', 61, NULL, NULL, 21007),
(21008, '3.40.50.1820-FF-000074', NULL, 'Abhydrolase domain containing 16A', 219, NULL, NULL, 21008);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(21009, '3.30.505.10-FF-000175', NULL, NULL, 120, NULL, NULL, 21009),
(21010, '3.90.1410.10-FF-000064', NULL, 'Uncharacterized protein', 145, NULL, NULL, 21010),
(21011, '3.90.320.10-FF-000007', NULL, 'Recombinase RecB', 191, NULL, NULL, 21011),
(21012, '3.40.50.10490-FF-000144', NULL, NULL, 48, NULL, NULL, 21012),
(21013, '2.40.10.10-FF-000679', NULL, NULL, 77, NULL, NULL, 21013),
(21014, '3.40.50.1820-FF-000422', NULL, 'Probable epoxide hydrolase ephC', 291, NULL, NULL, 21014),
(21015, '3.90.1110.10-FF-000024', NULL, 'DNA-directed RNA polymerase subunit 2', 191, NULL, NULL, 21015),
(21016, '3.40.50.720-FF-002414', NULL, 'Nucleoside-diphosphate-sugar epimerase family protein (AFU_orthologue AFUA_6G11740)', 79, NULL, NULL, 21016),
(21017, '3.30.2350.20-FF-000059', NULL, NULL, 163, NULL, NULL, 21017),
(21018, '2.70.70.10-FF-000075', NULL, 'Glr0834 protein', 132, NULL, NULL, 21018),
(21019, '3.20.140.10-FF-000026', NULL, 'Nicotinate phosphoribosyltransferase', 157, NULL, NULL, 21019),
(21020, '1.25.10.10-FF-003477', NULL, 'eIF-2-alpha kinase activator GCN1', 137, NULL, NULL, 21020),
(21021, '3.40.50.620-FF-000237', NULL, 'Putative Valyl-tRNA synthetase', 228, NULL, NULL, 21021),
(21022, '1.25.40.10-FF-004142', NULL, 'Mitochondrial group I intron splicing factor CCM1', 116, NULL, NULL, 21022),
(21023, '3.80.10.10-FF-000052', NULL, 'Leucine rich repeat containing 6', 174, NULL, NULL, 21023),
(21024, '3.30.870.10-FF-000085', NULL, 'Cardiolipin synthase', 175, NULL, NULL, 21024),
(21025, '3.40.1190.20-FF-000105', NULL, 'Uncharacterized protein, isoform A', 295, NULL, NULL, 21025),
(21026, '1.20.1050.10-FF-000059', NULL, 'Putative cell wall organization protein/glutathione transferase', 115, NULL, NULL, 21026),
(21027, '1.10.246.220-FF-000003', NULL, 'TRF-like 3', 100, NULL, NULL, 21027),
(21028, '1.20.140.140-FF-000001', NULL, 'Calcium release-activated calcium modulator 1', 206, NULL, NULL, 21028),
(21029, '1.20.1070.10-FF-000622', NULL, 'Predicted protein', 332, NULL, NULL, 21029),
(21030, '3.90.79.10-FF-000024', NULL, 'ADP-ribose pyrophosphatase', 175, NULL, NULL, 21030),
(21031, '1.25.10.10-FF-002858', NULL, 'Uncharacterized protein', 166, NULL, NULL, 21031),
(21032, '1.50.40.10-FF-000599', NULL, 'Uncharacterized protein', 119, NULL, NULL, 21032),
(21033, '3.30.360.10-FF-000091', NULL, 'Aspartate kinase', 149, NULL, NULL, 21033),
(21034, '2.60.120.650-FF-000146', NULL, 'Uncharacterized protein', 201, NULL, NULL, 21034),
(21035, '2.60.40.10-FF-005683', NULL, NULL, 81, NULL, NULL, 21035),
(21036, '2.60.120.650-FF-000022', NULL, 'tRNA wybutosine-synthesizing protein 5', 262, NULL, NULL, 21036),
(21037, '1.25.40.10-FF-000432', NULL, 'coatomer subunit epsilon isoform X3', 177, NULL, NULL, 21037),
(21038, '3.40.1060.10-FF-000003', NULL, 'Aconitate hydratase', 111, NULL, NULL, 21038),
(21039, '2.30.29.30-FF-001285', NULL, 'Sterol 3-beta-glucosyltransferase', 91, NULL, NULL, 21039),
(21040, '3.20.20.60-FF-000154', NULL, 'Pyruvate kinase', 230, NULL, NULL, 21040),
(21041, '1.20.1070.10-FF-000280', NULL, 'probable G-protein coupled receptor 135', 319, NULL, NULL, 21041),
(21042, '3.10.129.10-FF-000041', NULL, 'Cof-type HAD-IIB family hydrolase', 141, NULL, NULL, 21042),
(21043, '1.10.510.10-FF-001969', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 1', 195, NULL, NULL, 21043),
(21044, '1.50.10.10-FF-000052', NULL, 'Alpha-L-rhamnosidase B, putative', 367, NULL, NULL, 21044),
(21045, '1.20.120.520-FF-000010', NULL, 'Nitroreductase family deazaflavin-dependent oxidoreductase', 148, NULL, NULL, 21045),
(21046, '3.20.20.100-FF-000125', NULL, 'Galactose dehydrogenase', 92, NULL, NULL, 21046),
(21047, '1.25.40.10-FF-004923', NULL, 'Predicted protein', 62, NULL, NULL, 21047),
(21048, '3.30.559.10-FF-000114', NULL, 'Transferase family protein', 197, NULL, NULL, 21048),
(21049, '2.40.30.10-FF-000186', NULL, 'Mycobactin utilization protein ViuB', 127, NULL, NULL, 21049),
(21050, '3.40.1500.10-FF-000015', NULL, 'Coproporphyrinogen-III oxidase 2, chloroplastic', 188, NULL, NULL, 21050),
(21051, '3.40.50.300-FF-008331', NULL, 'Uncharacterized protein', 239, NULL, NULL, 21051);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(21052, '3.30.40.10-FF-000533', NULL, 'E3 ubiquitin-protein ligase TRIM36', 115, NULL, NULL, 21052),
(21053, '3.40.50.1820-FF-000293', NULL, 'Carboxylic ester hydrolase', 503, NULL, NULL, 21053),
(21054, '1.25.40.10-FF-000741', NULL, 'Pentatricopeptide repeat-containing protein At2g25580', 102, NULL, NULL, 21054),
(21055, '1.20.140.40-FF-000014', NULL, 'Pectinesterase', 163, NULL, NULL, 21055),
(21056, '3.30.160.60-FF-002462', NULL, 'Zinc finger protein 611', 23, NULL, NULL, 21056),
(21057, '1.20.140.160-FF-000007', NULL, 'RNA polymerase sigma factor RpoH', 153, NULL, NULL, 21057),
(21058, '3.60.15.10-FF-000193', NULL, 'Flavo-diiron protein FprA1', 249, NULL, NULL, 21058),
(21059, '3.40.50.1370-FF-000040', NULL, 'Aspartate carbamoyltransferase', 168, NULL, NULL, 21059),
(21060, '3.40.50.20-FF-000019', NULL, 'Carbamoyl phosphate synthetase II', 114, NULL, NULL, 21060),
(21061, '3.30.40.10-FF-000494', NULL, 'Acyl-CoA N-acyltransferase with RING/FYVE/PHD-type zinc finger domain', 78, NULL, NULL, 21061),
(21062, '1.25.40.20-FF-000093', NULL, 'ankyrin repeat domain-containing protein 2', 88, NULL, NULL, 21062),
(21063, '3.30.40.10-FF-000185', NULL, 'RING finger protein nhl-1', 81, NULL, NULL, 21063),
(21064, '3.30.450.20-FF-000668', NULL, 'Blue-light receptor phototropin 2', 107, NULL, NULL, 21064),
(21065, '3.30.160.60-FF-002771', NULL, 'Zinc finger protein 593', 64, NULL, NULL, 21065),
(21066, '1.25.40.10-FF-005103', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 121, NULL, NULL, 21066),
(21067, '3.30.1120.30-FF-000005', NULL, 'Serine/threonine-protein kinase', 98, NULL, NULL, 21067),
(21068, '3.40.640.10-FF-000065', NULL, 'Serine hydroxymethyltransferase', 75, NULL, NULL, 21068),
(21069, '1.10.10.10-FF-000317', NULL, 'IclR family transcriptional regulator', 80, NULL, NULL, 21069),
(21070, '1.25.40.10-FF-000556', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 69, NULL, NULL, 21070),
(21071, '1.20.5.190-FF-000092', NULL, 'CAMTA (CAlModulin-binding Transcriptional activator)', 50, NULL, NULL, 21071),
(21072, '1.10.565.10-FF-000112', NULL, 'Uncharacterized protein', 208, NULL, NULL, 21072),
(21073, '4.10.60.10-FF-000061', NULL, 'X16 splicing factor, isoform B', 54, NULL, NULL, 21073),
(21074, '2.70.40.10-FF-000028', NULL, 'Uncharacterized protein', 57, NULL, NULL, 21074),
(21075, '4.10.860.10-FF-000028', NULL, NULL, 49, NULL, NULL, 21075),
(21076, '1.25.40.10-FF-004614', NULL, 'Uncharacterized protein', 161, NULL, NULL, 21076),
(21077, '3.40.50.12780-FF-000005', NULL, 'Solute carrier family 27 member 6', 429, NULL, NULL, 21077),
(21078, '3.30.40.10-FF-000078', NULL, 'E3 ubiquitin-protein ligase MYCBP2 isoform X1', 76, NULL, NULL, 21078),
(21079, '3.10.20.90-FF-000539', NULL, 'Uncharacterized protein', 118, NULL, NULL, 21079),
(21080, '3.90.180.10-FF-000024', NULL, 'Glutathione-independent formaldehyde dehydrogenase', 201, NULL, NULL, 21080),
(21081, '3.90.1150.10-FF-000257', NULL, 'Adenosylmethionine-8-amino-7-oxononanoate transaminase', 148, NULL, NULL, 21081),
(21082, '2.60.40.790-FF-000201', NULL, NULL, 66, NULL, NULL, 21082),
(21083, '3.60.21.10-FF-000134', NULL, 'UDP-sugar hydrolase, putative', 235, NULL, NULL, 21083),
(21084, '3.40.50.300-FF-001187', NULL, 'ATP-dependent helicase/nuclease subunit A', 286, NULL, NULL, 21084),
(21085, '1.20.1110.10-FF-000188', NULL, NULL, 162, NULL, NULL, 21085),
(21086, '2.60.40.10-FF-002934', NULL, 'Titin homolog', 97, NULL, NULL, 21086),
(21087, '3.30.160.60-FF-003507', NULL, 'Zinc finger protein 226-like Protein', 63, NULL, NULL, 21087),
(21088, '3.40.850.10-FF-000255', NULL, 'Kinesin-like protein', 348, NULL, NULL, 21088),
(21089, '3.10.100.10-FF-000430', NULL, NULL, 81, NULL, NULL, 21089),
(21090, '1.20.5.1040-FF-000002', NULL, 'Sensor histidine kinase QseC', 58, NULL, NULL, 21090),
(21091, '3.50.50.60-FF-001104', NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', 212, NULL, NULL, 21091),
(21092, '3.30.230.10-FF-000008', NULL, 'DNA topoisomerase 2', 125, NULL, NULL, 21092),
(21093, '3.30.70.1050-FF-000008', NULL, 'Trigger factor', 115, NULL, NULL, 21093);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(21094, '1.10.10.650-FF-000005', NULL, 'Transcription elongation factor SPT6', 157, NULL, NULL, 21094),
(21095, '3.30.1250.10-FF-000003', NULL, NULL, 111, NULL, NULL, 21095),
(21096, '3.30.70.920-FF-000030', NULL, 'AsnC family transcriptional regulator', 85, NULL, NULL, 21096),
(21097, '3.30.830.10-FF-000048', NULL, 'Mitochondrial processing peptidase alpha subunit', 225, NULL, NULL, 21097),
(21098, '2.40.160.210-FF-000010', NULL, 'AP005220 putative acyl-CoA thiolesterase', 346, NULL, NULL, 21098),
(21099, '3.40.630.10-FF-000036', NULL, 'Carboxypeptidase Q', 251, NULL, NULL, 21099),
(21100, '1.50.10.130-FF-000026', NULL, NULL, 133, NULL, NULL, 21100),
(21101, '1.20.1050.80-FF-000018', NULL, 'Uncharacterized protein', 126, NULL, NULL, 21101),
(21102, '3.30.1390.20-FF-000022', NULL, 'Ribosome biogenesis protein RLP7', 201, NULL, NULL, 21102),
(21103, '3.40.50.1820-FF-001708', NULL, 'Uncharacterized conserved protein UCP031088 alpha/beta hydrolase', 164, NULL, NULL, 21103),
(21104, '3.30.1330.20-FF-000046', NULL, 'Tubulin gamma chain', 119, NULL, NULL, 21104),
(21105, '1.10.274.100-FF-000023', NULL, 'DNA-directed RNA polymerase subunit', 160, NULL, NULL, 21105),
(21106, '2.30.130.40-FF-000030', NULL, 'Predicted protein', 99, NULL, NULL, 21106),
(21107, '3.90.1800.10-FF-000004', NULL, 'DNA-directed RNA polymerase subunit beta', 118, NULL, NULL, 21107),
(21108, '1.25.40.10-FF-002214', NULL, 'Mitochondrial fission 1 protein', 143, NULL, NULL, 21108),
(21109, '1.10.287.130-FF-000114', NULL, 'Sensor histidine kinase RegB', 79, NULL, NULL, 21109),
(21110, '1.20.1280.50-FF-000195', NULL, 'Ubiquitin-conjugating enzyme, putative', 94, NULL, NULL, 21110),
(21111, '3.30.70.1030-FF-000002', NULL, 'Chlorite dismutase', 115, NULL, NULL, 21111),
(21112, '3.90.215.10-FF-000010', NULL, 'Uncharacterized protein, isoform B', 219, NULL, NULL, 21112),
(21113, '3.40.50.150-FF-000181', NULL, 'tRNA (Adenine(58)-N(1))-methyltransferase, mitochondrial isoform X4', 263, NULL, NULL, 21113),
(21114, '3.80.10.10-FF-003486', NULL, 'Uncharacterized protein', 203, NULL, NULL, 21114),
(21115, '3.10.20.70-FF-000005', NULL, 'Glutamine synthetase', 105, NULL, NULL, 21115),
(21116, '2.60.40.10-FF-001405', NULL, 'Uncharacterized protein, isoform A', 99, NULL, NULL, 21116),
(21117, '1.10.1030.10-FF-000010', NULL, 'Carbamoyl-phosphate synthase large chain', 147, NULL, NULL, 21117),
(21118, '3.15.10.20-FF-000002', NULL, 'Activator of Hsp90 ATPase', 153, NULL, NULL, 21118),
(21119, '3.40.50.720-FF-002375', NULL, 'Zinc-type alcohol dehydrogenase-like protein C2E1P3.01', 191, NULL, NULL, 21119),
(21120, '3.40.50.2300-FF-000802', NULL, 'Glutamate receptor', 162, NULL, NULL, 21120),
(21121, '1.20.120.20-FF-000018', NULL, 'Plant Late Embryo Abundant (LEA) related', 90, NULL, NULL, 21121),
(21122, '3.30.50.10-FF-000118', NULL, 'Uncharacterized protein', 92, NULL, NULL, 21122),
(21123, '1.25.40.20-FF-000076', NULL, 'Fem-1 homolog c (C.elegans)', 133, NULL, NULL, 21123),
(21124, '3.90.230.10-FF-000040', NULL, 'Proliferation-associated 2G4, b', 201, NULL, NULL, 21124),
(21125, '3.30.160.60-FF-006149', NULL, NULL, 34, NULL, NULL, 21125),
(21126, '2.20.70.10-FF-000280', NULL, 'Uncharacterized protein', 56, NULL, NULL, 21126),
(21127, '2.60.40.790-FF-000190', NULL, NULL, 94, NULL, NULL, 21127),
(21128, '3.40.50.300-FF-006459', NULL, 'Putative ABC transporter ATP-binding protein MG303', 279, NULL, NULL, 21128),
(21129, '2.20.70.10-FF-000173', NULL, 'S-adenosyl-L-methionine-dependent methyltransferase superfamily protein', 45, NULL, NULL, 21129),
(21130, '3.30.160.60-FF-006060', NULL, NULL, 18, NULL, NULL, 21130),
(21131, '3.40.980.10-FF-000023', NULL, 'Molybdenum cofactor biosynthesis protein', 146, NULL, NULL, 21131),
(21132, '3.40.50.300-FF-000568', NULL, 'Putative Ras-related protein Rab-12', 186, NULL, NULL, 21132),
(21133, '3.30.420.10-FF-000618', NULL, NULL, 175, NULL, NULL, 21133),
(21134, '1.20.1250.20-FF-001988', NULL, 'Uncharacterized protein', 389, NULL, NULL, 21134),
(21135, '2.40.30.330-FF-000021', NULL, 'Uncharacterized protein', 92, NULL, NULL, 21135);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(21136, '3.40.1360.10-FF-000026', NULL, 'Meiotic recombination protein spo-11', 215, NULL, NULL, 21136),
(21137, '2.60.120.200-FF-000051', NULL, 'L-type lectin-domain containing receptor kinase V.9', 244, NULL, NULL, 21137),
(21138, '1.10.510.10-FF-004387', NULL, NULL, 92, NULL, NULL, 21138),
(21139, '2.60.120.260-FF-000484', NULL, 'Uncharacterized protein C4D7.07c', 203, NULL, NULL, 21139),
(21140, '3.40.50.300-FF-003441', NULL, 'ESX-4 secretion system protein EccC4', 237, NULL, NULL, 21140),
(21141, '2.60.120.10-FF-000738', NULL, 'Uncharacterized protein', 122, NULL, NULL, 21141),
(21142, '2.40.50.140-FF-000934', NULL, NULL, 88, NULL, NULL, 21142),
(21143, '2.40.33.10-FF-000030', NULL, 'Pyruvate kinase', 86, NULL, NULL, 21143),
(21144, '2.30.30.170-FF-000003', NULL, 'N-acetylmuramoyl-L-alanine amidase', 75, NULL, NULL, 21144),
(21145, '3.30.70.1450-FF-000050', NULL, 'Trk system potassium uptake protein trkA', 89, NULL, NULL, 21145),
(21146, '2.130.10.10-FF-005172', NULL, 'U3 small nucleolar RNA-associated protein 4 homolog isoform 1', 127, NULL, NULL, 21146),
(21147, '2.60.40.10-FF-004587', NULL, NULL, 113, NULL, NULL, 21147),
(21148, '1.10.510.10-FF-003881', NULL, NULL, 90, NULL, NULL, 21148),
(21149, '3.30.70.330-FF-002202', NULL, NULL, 107, NULL, NULL, 21149),
(21150, '3.30.870.10-FF-000169', NULL, 'Uncharacterized protein', 293, NULL, NULL, 21150),
(21151, '1.25.40.10-FF-003198', NULL, 'Os05g0581300 protein', 91, NULL, NULL, 21151),
(21152, '2.170.300.10-FF-000024', NULL, 'N-acetylglucosamine-1-phosphodiester alpha-N-acetylglucosaminidase', 77, NULL, NULL, 21152),
(21153, '2.60.40.150-FF-000369', NULL, 'Phorbol ester/diacylglycerol-binding protein unc-13', 131, NULL, NULL, 21153),
(21154, '1.10.1200.10-FF-000130', NULL, 'Nonribosomal peptide synthetase easA', 73, NULL, NULL, 21154),
(21155, '3.60.21.10-FF-000027', NULL, 'Purple acid phosphatase', 294, NULL, NULL, 21155),
(21156, '3.30.470.20-FF-000175', NULL, 'Uncharacterized protein MJ0776', 118, NULL, NULL, 21156),
(21157, '3.90.70.10-FF-000611', NULL, 'Ubiquitin-specific peptidase 28', 159, NULL, NULL, 21157),
(21158, '3.40.50.12430-FF-000007', NULL, 'Folliculin', 122, NULL, NULL, 21158),
(21159, '3.90.226.10-FF-000018', NULL, 'Fatty acid oxidation complex subunit alpha', 312, NULL, NULL, 21159),
(21160, '3.50.50.60-FF-000486', NULL, 'Ferredoxin--NADP reductase', 176, NULL, NULL, 21160),
(21161, '2.60.120.380-FF-000065', NULL, 'Calpain-like cysteine peptidase, putative', 138, NULL, NULL, 21161),
(21162, '3.40.50.2300-FF-000010', NULL, 'Glutamate ionotropic receptor kainate type subunit 1', 164, NULL, NULL, 21162),
(21163, '3.30.70.120-FF-000015', NULL, 'Nitrogen regulatory protein P-II homolog', 135, NULL, NULL, 21163),
(21164, '1.20.1050.60-FF-000012', NULL, 'Predicted protein', 46, NULL, NULL, 21164),
(21165, '3.30.1230.20-FF-000005', NULL, '40S ribosomal protein S21', 84, NULL, NULL, 21165),
(21166, '3.30.9.10-FF-000236', NULL, 'Uncharacterized protein', 59, NULL, NULL, 21166),
(21167, '3.40.50.300-FF-007712', NULL, 'Uncharacterized protein', 97, NULL, NULL, 21167),
(21168, '3.30.60.30-FF-000046', NULL, 'Complement component C6', 80, NULL, NULL, 21168),
(21169, '1.10.10.10-FF-001352', NULL, 'Crp/Fnr family transcriptional regulator', 72, NULL, NULL, 21169),
(21170, '3.30.70.20-FF-000015', NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase', 96, NULL, NULL, 21170),
(21171, '3.40.50.720-FF-000722', NULL, 'Phosphoglycerate dehydrogenase, putative', 195, NULL, NULL, 21171),
(21172, '1.10.238.10-FF-000291', NULL, 'Calcium-dependent protein kinase SK5', 96, NULL, NULL, 21172),
(21173, '1.10.472.10-FF-000655', NULL, 'Predicted protein', 101, NULL, NULL, 21173),
(21174, '3.30.200.20-FF-000245', NULL, 'Integrin-linked protein kinase', 88, NULL, NULL, 21174),
(21175, '1.25.40.150-FF-000003', NULL, 'V-type proton ATPase subunit H', 118, NULL, NULL, 21175),
(21176, '1.10.555.10-FF-000050', NULL, 'GTPase-activating protein', 268, NULL, NULL, 21176),
(21177, '3.30.70.2740-FF-000009', NULL, 'FAD linked oxidase, C-terminal domain protein', 86, NULL, NULL, 21177);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(21178, '1.25.10.10-FF-002066', NULL, 'Uncharacterized protein', 310, NULL, NULL, 21178),
(21179, '3.30.465.10-FF-000132', NULL, 'Uncharacterized protein', 175, NULL, NULL, 21179),
(21180, '3.90.470.10-FF-000035', NULL, '50S ribosomal protein L22', 119, NULL, NULL, 21180),
(21181, '1.25.40.180-FF-000107', NULL, 'Protein CBG19247', 236, NULL, NULL, 21181),
(21182, '3.30.70.330-FF-001893', NULL, NULL, 85, NULL, NULL, 21182),
(21183, '1.25.10.10-FF-003005', NULL, 'Uncharacterized protein', 344, NULL, NULL, 21183),
(21184, '3.30.230.120-FF-000006', NULL, 'L-fucose kinase isoform X2', 226, NULL, NULL, 21184),
(21185, '3.30.40.10-FF-001461', NULL, 'Uncharacterized protein', 58, NULL, NULL, 21185),
(21186, '1.25.40.10-FF-000325', NULL, 'Pentatricopeptide repeat-containing protein At4g14820', 235, NULL, NULL, 21186),
(21187, '1.25.10.10-FF-002605', NULL, 'Uncharacterized protein', 144, NULL, NULL, 21187),
(21188, '3.30.160.60-FF-004351', NULL, NULL, 75, NULL, NULL, 21188),
(21189, '3.80.10.10-FF-004430', NULL, 'Uncharacterized protein', 237, NULL, NULL, 21189),
(21190, '1.10.10.60-FF-001142', NULL, NULL, 58, NULL, NULL, 21190),
(21191, '3.40.390.10-FF-000006', NULL, 'Thimet oligopeptidase 1', 151, NULL, NULL, 21191),
(21192, '3.90.70.10-FF-000504', NULL, 'Uncharacterized protein', 318, NULL, NULL, 21192),
(21193, '3.40.50.300-FF-002968', NULL, 'ABC-F type ribosomal protection protein', 210, NULL, NULL, 21193),
(21194, '3.30.950.10-FF-000012', NULL, 'Uroporphyrinogen-III C-methyltransferase', 137, NULL, NULL, 21194),
(21195, '3.40.50.1820-FF-000894', NULL, 'FAM172 family protein homolog', 163, NULL, NULL, 21195),
(21196, '3.30.230.70-FF-000094', NULL, 'YALI0B14905p', 322, NULL, NULL, 21196),
(21197, '2.40.30.300-FF-000006', NULL, 'Uncharacterized protein', 137, NULL, NULL, 21197),
(21198, '2.10.220.10-FF-000027', NULL, 'Tyrosine-protein kinase receptor', 67, NULL, NULL, 21198),
(21199, '2.30.30.210-FF-000015', NULL, 'Ribonuclease P protein component 1', 109, NULL, NULL, 21199),
(21200, '4.10.640.40-FF-000004', NULL, 'Cytoplasmic polyadenylation element-binding protein 3', 59, NULL, NULL, 21200),
(21201, '2.60.40.10-FF-001153', NULL, 'Sallimus, isoform P', 90, NULL, NULL, 21201),
(21202, '4.10.60.10-FF-000044', NULL, 'Putative universal minicircle sequence binding protein', 29, NULL, NULL, 21202),
(21203, '3.30.230.10-FF-000227', NULL, 'DNA mismatch repair protein MutL', 126, NULL, NULL, 21203),
(21204, '3.40.50.1370-FF-000023', NULL, 'Ornithine carbamoyltransferase', 135, NULL, NULL, 21204),
(21205, '1.10.20.10-FF-000234', NULL, NULL, 127, NULL, NULL, 21205),
(21206, '3.40.640.10-FF-000329', NULL, 'Glutamate decarboxylase 1b', 84, NULL, NULL, 21206),
(21207, '3.30.559.10-FF-000131', NULL, 'Nonribosomal peptide synthase, putative', 176, NULL, NULL, 21207),
(21208, '1.10.287.820-FF-000006', NULL, 'Amiloride-sensitive sodium channel subunit beta-2', 91, NULL, NULL, 21208),
(21209, '3.40.50.300-FF-003132', NULL, 'Uncharacterized protein, isoform B', 204, NULL, NULL, 21209),
(21210, '2.60.40.150-FF-000476', NULL, 'E3 ubiquitin-protein ligase', 135, NULL, NULL, 21210),
(21211, '3.10.20.90-FF-000871', NULL, 'Uncharacterized protein', 68, NULL, NULL, 21211),
(21212, '3.40.50.2300-FF-000263', NULL, 'Two-component system response regulator', 121, NULL, NULL, 21212),
(21213, '2.40.10.10-FF-000078', NULL, 'Serine protease H137', 128, NULL, NULL, 21213),
(21214, '3.80.10.10-FF-000580', NULL, 'Adenylate cyclase AcyA', 264, NULL, NULL, 21214),
(21215, '3.90.70.10-FF-000870', NULL, 'AGR370Wp', 68, NULL, NULL, 21215),
(21216, '2.120.10.30-FF-000283', NULL, 'NHL repeat containing E3 ubiquitin protein ligase 1', 112, NULL, NULL, 21216),
(21217, '1.20.1280.50-FF-000088', NULL, 'Cell division control protein 4', 109, NULL, NULL, 21217),
(21218, '1.10.287.1490-FF-000124', NULL, 'Uncharacterized protein', 149, NULL, NULL, 21218),
(21219, '2.60.40.10-FF-004839', NULL, NULL, 115, NULL, NULL, 21219),
(21220, '3.60.10.10-FF-000215', NULL, 'Inositol polyphosphate-5-phosphatase, 40kDa, gene 2', 382, NULL, NULL, 21220),
(21221, '3.90.1640.10-FF-000002', NULL, 'Cyclic-di-AMP phosphodiesterase', 219, NULL, NULL, 21221);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(21222, '3.20.20.30-FF-000010', NULL, 'LLM class F420-dependent oxidoreductase', 342, NULL, NULL, 21222),
(21223, '1.20.5.170-FF-000226', NULL, 'SNF2-family ATP dependent chromatin remodeling factor snf21', 75, NULL, NULL, 21223),
(21224, '2.40.50.140-FF-000827', NULL, NULL, 103, NULL, NULL, 21224),
(21225, '2.10.109.10-FF-000044', NULL, 'Signal peptidase I', 114, NULL, NULL, 21225),
(21226, '3.30.710.10-FF-000253', NULL, 'BTB/POZ domain-containing protein At5g66560', 136, NULL, NULL, 21226),
(21227, '1.20.120.1080-FF-000022', NULL, 'DExH-box ATP-dependent RNA helicase DExH7 chloroplastic', 103, NULL, NULL, 21227),
(21228, '3.80.10.10-FF-003811', NULL, 'CPN2 protein', 82, NULL, NULL, 21228),
(21229, '3.40.50.11080-FF-000001', NULL, 'DNA repair and telomere maintenance protein nbs1', 107, NULL, NULL, 21229),
(21230, '2.120.10.30-FF-000592', NULL, 'Uncharacterized protein', 103, NULL, NULL, 21230),
(21231, '3.30.70.330-FF-003130', NULL, NULL, 91, NULL, NULL, 21231),
(21232, '2.40.70.10-FF-000531', NULL, NULL, 205, NULL, NULL, 21232),
(21233, '2.70.150.10-FF-000188', NULL, 'Putative calcium-transporting atpase sarcoplasmic/endoplasmic reticulum type', 136, NULL, NULL, 21233),
(21234, '3.10.20.770-FF-000002', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', 315, NULL, NULL, 21234),
(21235, '1.10.10.10-FF-000733', NULL, 'Unplaced genomic scaffold supercont2.3, whole genome shotgun sequence', 96, NULL, NULL, 21235),
(21236, '3.30.70.330-FF-001904', NULL, NULL, 75, NULL, NULL, 21236),
(21237, '3.30.70.270-FF-000228', NULL, NULL, 162, NULL, NULL, 21237),
(21238, '3.40.50.300-FF-006987', NULL, 'Protein P9', 214, NULL, NULL, 21238),
(21239, '2.60.220.50-FF-000073', NULL, 'Adhesion G protein-coupled receptor G1', 153, NULL, NULL, 21239),
(21240, '2.170.120.12-FF-000029', NULL, 'Uncharacterized protein', 133, NULL, NULL, 21240),
(21241, '3.40.50.300-FF-002513', NULL, 'ATP-dependent dethiobiotin synthetase BioD', 212, NULL, NULL, 21241),
(21242, '3.30.70.330-FF-001584', NULL, 'Predicted protein', 171, NULL, NULL, 21242),
(21243, '3.30.1010.10-FF-000109', NULL, 'PIKK family atypical protein kinase', 142, NULL, NULL, 21243),
(21244, '3.40.50.300-FF-004205', NULL, 'ATP-dependent helicase hrpA', 186, NULL, NULL, 21244),
(21245, '1.10.510.10-FF-002661', NULL, NULL, 126, NULL, NULL, 21245),
(21246, '2.60.40.10-FF-001714', NULL, 'Echinoid, isoform C', 88, NULL, NULL, 21246),
(21247, '3.40.50.300-FF-005239', NULL, 'Cell division control protein', 196, NULL, NULL, 21247),
(21248, '3.40.30.10-FF-001128', NULL, 'Glutathione S-transferase, putative', 77, NULL, NULL, 21248),
(21249, '3.30.160.60-FF-004019', NULL, NULL, 27, NULL, NULL, 21249),
(21250, '3.40.640.10-FF-000296', NULL, 'Hercynylcysteine sulfoxide lyase', 263, NULL, NULL, 21250),
(21251, '3.40.190.80-FF-000079', NULL, 'Probable inorganic polyphosphate/ATP-NAD kinase (Poly(P)/ATP NAD kinase)', 120, NULL, NULL, 21251),
(21252, '2.170.140.10-FF-000034', NULL, 'GM24482', 61, NULL, NULL, 21252),
(21253, '1.20.1250.40-FF-000038', NULL, 'Uncharacterized protein', 57, NULL, NULL, 21253),
(21254, '1.25.40.10-FF-002686', NULL, 'Uncharacterized protein', 153, NULL, NULL, 21254),
(21255, '2.130.10.10-FF-003154', NULL, 'Vacuolar protein sorting-associated protein 41-like protein', 234, NULL, NULL, 21255),
(21256, '1.10.8.710-FF-000031', NULL, NULL, 56, NULL, NULL, 21256),
(21257, '3.40.640.10-FF-000172', NULL, 'Pyridoxal phosphate-dependent aminotransferase', 245, NULL, NULL, 21257),
(21258, '1.10.560.10-FF-000028', NULL, 'T-complex protein 1 subunit gamma', 231, NULL, NULL, 21258),
(21259, '3.40.50.790-FF-000029', NULL, 'Ribosomal protein L1', 103, NULL, NULL, 21259),
(21260, '1.10.1620.20-FF-000007', NULL, 'ATP synthase subunit epsilon, mitochondrial', 61, NULL, NULL, 21260),
(21261, '1.10.238.10-FF-000072', NULL, 'Hippocalcin-like protein 1', 93, NULL, NULL, 21261),
(21262, '3.40.50.2000-FF-000510', NULL, 'Glycosyltransferase', 246, NULL, NULL, 21262),
(21263, '1.10.10.1940-FF-000016', NULL, NULL, 44, NULL, NULL, 21263),
(21264, '3.20.20.10-FF-000055', NULL, 'Diaminopimelate decarboxylase', 243, NULL, NULL, 21264);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(21265, '2.60.40.10-FF-002569', NULL, 'Pyruvate dehydrogenase E1 component subunit alpha', 128, NULL, NULL, 21265),
(21266, '3.30.450.20-FF-000067', NULL, 'PAS domain S-box protein', 106, NULL, NULL, 21266),
(21267, '3.30.160.60-FF-002693', NULL, 'PR domain zinc finger protein 1-like', 23, NULL, NULL, 21267),
(21268, '3.80.10.10-FF-001232', NULL, 'F-box/LRR-repeat protein', 158, NULL, NULL, 21268),
(21269, '1.20.1740.10-FF-000106', NULL, 'Methionine transporter, putative (Eurofung)', 493, NULL, NULL, 21269),
(21270, '2.180.10.10-FF-000004', NULL, 'Teneurin transmembrane protein 3', 246, NULL, NULL, 21270),
(21271, '4.10.400.10-FF-000270', NULL, 'LDL receptor repeat-containing protein egg-2', 43, NULL, NULL, 21271),
(21272, '1.10.287.3240-FF-000014', NULL, 'V-type ATP synthase subunit D', 201, NULL, NULL, 21272),
(21273, '3.50.50.60-FF-000722', NULL, 'Worm AIF (Apoptosis inducing factor) Homolog', 153, NULL, NULL, 21273),
(21274, '1.10.10.980-FF-000008', NULL, 'Uncharacterized protein', 100, NULL, NULL, 21274),
(21275, '1.10.10.60-FF-000490', NULL, 'Transcription activator snf2l1, putative', 83, NULL, NULL, 21275),
(21276, '1.10.890.20-FF-000005', NULL, NULL, 50, NULL, NULL, 21276),
(21277, '1.10.150.20-FF-000219', NULL, 'UvrABC system protein C', 59, NULL, NULL, 21277),
(21278, '3.40.50.10240-FF-000013', NULL, 'Thiamin pyrophosphokinase, catalytic domain containing protein', 218, NULL, NULL, 21278),
(21279, '2.60.40.2030-FF-000026', NULL, 'Adhesion G protein-coupled receptor V1', 147, NULL, NULL, 21279),
(21280, '2.40.30.10-FF-000422', NULL, 'Uncharacterized protein', 44, NULL, NULL, 21280),
(21281, '1.25.40.10-FF-002580', NULL, 'pentatricopeptide repeat-containing protein At4g13650 isoform X1', 102, NULL, NULL, 21281),
(21282, '4.10.280.10-FF-000023', NULL, 'MAX isoform 13', 79, NULL, NULL, 21282),
(21283, '1.20.930.40-FF-000007', NULL, 'Uncharacterized protein', 137, NULL, NULL, 21283),
(21284, '3.30.160.60-FF-004727', NULL, NULL, 87, NULL, NULL, 21284),
(21285, '3.90.230.10-FF-000017', NULL, 'Ectoine hydrolase', 238, NULL, NULL, 21285),
(21286, '1.10.510.10-FF-002818', NULL, NULL, 142, NULL, NULL, 21286),
(21287, '3.50.4.10-FF-000040', NULL, NULL, 71, NULL, NULL, 21287),
(21288, '3.30.365.10-FF-000079', NULL, 'Caffeine dehydrogenase subunit alpha', 172, NULL, NULL, 21288),
(21289, '1.20.5.2480-FF-000001', NULL, 'Reticulon', 75, NULL, NULL, 21289),
(21290, '2.60.120.280-FF-000001', NULL, 'Arabinose operon regulatory protein', 164, NULL, NULL, 21290),
(21291, '3.90.190.20-FF-000073', NULL, 'Folylpolyglutamate synthase', 153, NULL, NULL, 21291),
(21292, '3.30.450.20-FF-000303', NULL, 'Sensory transduction histidine kinase', 119, NULL, NULL, 21292),
(21293, '1.20.950.20-FF-000014', NULL, 'Cytochrome B561', 87, NULL, NULL, 21293),
(21294, '1.10.8.60-FF-000303', NULL, 'Cell division cycle 48C', 85, NULL, NULL, 21294),
(21295, '3.40.50.300-FF-000259', NULL, 'UvrABC system protein A', 188, NULL, NULL, 21295),
(21296, '3.30.200.20-FF-001572', NULL, 'Protein CBG00227', 92, NULL, NULL, 21296),
(21297, '3.30.70.3270-FF-000005', NULL, 'Formate hydrogenlyase complex iron-sulfur subunit', 118, NULL, NULL, 21297),
(21298, '1.10.1200.10-FF-000057', NULL, 'Peptide synthetase nrp', 81, NULL, NULL, 21298),
(21299, '3.40.50.10540-FF-000002', NULL, 'Formyl-CoA:oxalate CoA-transferase', 308, NULL, NULL, 21299),
(21300, '1.10.472.10-FF-000346', NULL, 'Putative mitotic cyclin', 60, NULL, NULL, 21300),
(21301, '3.40.50.2000-FF-000055', NULL, 'Glycosyltransferase', 264, NULL, NULL, 21301),
(21302, '1.20.1560.10-FF-000828', NULL, 'ATP-binding cassette, sub-family B (MDR/TAP), member 4', 20, NULL, NULL, 21302),
(21303, '2.10.110.10-FF-000221', NULL, 'Rho-GTPase-activating protein, putative', 79, NULL, NULL, 21303),
(21304, '1.25.40.10-FF-002433', NULL, 'Pentatricopeptide repeat-containing protein', 93, NULL, NULL, 21304),
(21305, '3.40.50.1100-FF-000083', NULL, 'Cysteine synthase/cystathionine beta-synthase', 101, NULL, NULL, 21305),
(21306, '1.20.58.160-FF-000004', NULL, 'TOM1-like protein 2', 91, NULL, NULL, 21306);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(21307, '1.10.1090.10-FF-000002', NULL, 'Cytochrome b-c1 complex subunit 7', 111, NULL, NULL, 21307),
(21308, '3.20.180.20-FF-000048', NULL, 'Predicted protein', 103, NULL, NULL, 21308),
(21309, '3.40.720.10-FF-000010', NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase family member 1', 409, NULL, NULL, 21309),
(21310, '2.10.110.10-FF-000036', NULL, 'LIM domain-containing protein 1', 58, NULL, NULL, 21310),
(21311, '1.20.930.20-FF-000001', NULL, 'E3 ubiquitin-protein ligase CBL', 130, NULL, NULL, 21311),
(21312, '3.40.630.30-FF-000593', NULL, 'Uncharacterized protein', 85, NULL, NULL, 21312),
(21313, '3.30.1370.10-FF-000130', NULL, 'YLL032C-like protein', 91, NULL, NULL, 21313),
(21314, '3.40.50.10260-FF-000019', NULL, 'Multifunctional fusion protein', 212, NULL, NULL, 21314),
(21315, '3.30.70.330-FF-002854', NULL, NULL, 135, NULL, NULL, 21315),
(21316, '3.30.1370.210-FF-000012', NULL, 'Zinc finger CCCH domain-containing protein 28', 67, NULL, NULL, 21316),
(21317, '2.30.39.10-FF-000066', NULL, 'Serpin 42Dc, isoform A', 154, NULL, NULL, 21317),
(21318, '3.10.20.90-FF-000562', NULL, 'Polyubiquitin 8', 81, NULL, NULL, 21318),
(21319, '1.20.1250.20-FF-002045', NULL, 'Uncharacterized membrane protein YNR062C', 316, NULL, NULL, 21319),
(21320, '3.40.47.10-FF-000222', NULL, NULL, 130, NULL, NULL, 21320),
(21321, '2.40.30.10-FF-000080', NULL, 'Selenocysteine-specific translation elongation factor', 87, NULL, NULL, 21321),
(21322, '3.30.160.60-FF-001602', NULL, 'Zinc finger protein 490', 28, NULL, NULL, 21322),
(21323, '1.10.10.10-FF-000880', NULL, 'Uncharacterized protein', 120, NULL, NULL, 21323),
(21324, '3.50.50.60-FF-001470', NULL, 'Uncharacterized protein', 62, NULL, NULL, 21324),
(21325, '2.60.200.20-FF-000203', NULL, 'Probable serine/threonine-protein kinase fhkD', 149, NULL, NULL, 21325),
(21326, '1.10.510.10-FF-003987', NULL, NULL, 98, NULL, NULL, 21326),
(21327, '3.30.420.40-FF-000942', NULL, 'Heat shock protein 70D', 62, NULL, NULL, 21327),
(21328, '1.10.287.110-FF-000092', NULL, 'Type II HSP40 co-chaperone', 88, NULL, NULL, 21328),
(21329, '3.30.420.10-FF-000130', NULL, 'CAF1 family ribonuclease containing protein', 278, NULL, NULL, 21329),
(21330, '3.40.50.300-FF-004733', NULL, 'Elongation factor 1-alpha (EF-1-alpha)', 122, NULL, NULL, 21330),
(21331, '1.25.40.10-FF-001961', NULL, 'Uncharacterized protein', 78, NULL, NULL, 21331),
(21332, '2.70.170.10-FF-000043', NULL, 'Gamma-aminobutyric acid receptor alpha-like', 213, NULL, NULL, 21332),
(21333, '3.30.160.60-FF-004480', NULL, NULL, 44, NULL, NULL, 21333),
(21334, '3.65.10.10-FF-000031', NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', 192, NULL, NULL, 21334),
(21335, '1.10.630.10-FF-000152', NULL, 'Cytochrome P450 711A1', 492, NULL, NULL, 21335),
(21336, '3.10.400.10-FF-000009', NULL, NULL, 189, NULL, NULL, 21336),
(21337, '1.10.3460.10-FF-000037', NULL, 'Os01g0589800 protein', 62, NULL, NULL, 21337),
(21338, '1.10.10.520-FF-000017', NULL, 'Uncharacterized protein', 53, NULL, NULL, 21338),
(21339, '3.80.10.10-FF-001917', NULL, 'Pkd1', 64, NULL, NULL, 21339),
(21340, '3.30.390.30-FF-000014', NULL, 'Glutathione reductase', 121, NULL, NULL, 21340),
(21341, '3.60.40.10-FF-000043', NULL, 'Probable protein phosphatase 2C 40', 377, NULL, NULL, 21341),
(21342, '2.130.10.10-FF-001153', NULL, 'Protein will die slowly-like protein', 67, NULL, NULL, 21342),
(21343, '3.40.250.10-FF-000176', NULL, 'Uncharacterized protein', 168, NULL, NULL, 21343),
(21344, '3.40.50.720-FF-000014', NULL, 'C-terminal-binding protein 1 isoform 2', 107, NULL, NULL, 21344),
(21345, '3.30.70.60-FF-000016', NULL, 'Apicoplast ribosomal protein S6', 102, NULL, NULL, 21345),
(21346, '1.20.58.390-FF-000308', NULL, 'Protein CBR-ACR-3', 124, NULL, NULL, 21346),
(21347, '1.25.10.10-FF-002752', NULL, 'Uncharacterized protein', 666, NULL, NULL, 21347),
(21348, '3.30.780.10-FF-000055', NULL, 'Translation machinery-associated protein 22', 124, NULL, NULL, 21348),
(21349, '3.40.50.410-FF-000040', NULL, '60 kDa SS-A/Ro ribonucleoprotein isoform X1', 156, NULL, NULL, 21349);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(21350, '1.20.1640.10-FF-000054', NULL, 'Protein CBR-NCR-1', 222, NULL, NULL, 21350),
(21351, '2.60.120.1440-FF-000006', NULL, 'Sigma factor regulator, VreR', 123, NULL, NULL, 21351),
(21352, '3.90.190.10-FF-000322', NULL, 'Predicted protein', 154, NULL, NULL, 21352),
(21353, '3.40.50.1820-FF-001147', NULL, 'Uncharacterized protein', 96, NULL, NULL, 21353),
(21354, '3.10.450.50-FF-000041', NULL, 'Nuclear transport factor 2 family export factor 2, putative', 131, NULL, NULL, 21354),
(21355, '2.60.40.10-FF-004278', NULL, NULL, 99, NULL, NULL, 21355),
(21356, '3.30.379.10-FF-000021', NULL, NULL, 130, NULL, NULL, 21356),
(21357, '1.10.1420.10-FF-000040', NULL, 'Mismatch repair ATPase', 220, NULL, NULL, 21357),
(21358, '3.20.20.70-FF-000230', NULL, 'Putative dihydrouridine synthase family protein', 258, NULL, NULL, 21358),
(21359, '1.20.1050.10-FF-000037', NULL, 'Glutathione S-transferase family protein', 150, NULL, NULL, 21359),
(21360, '1.20.1270.10-FF-000042', NULL, 'Chaperone protein DnaK', 83, NULL, NULL, 21360),
(21361, '3.40.1800.20-FF-000041', NULL, NULL, 72, NULL, NULL, 21361),
(21362, '3.40.50.300-FF-001552', NULL, 'Mismatch repair ATPase (MutS family)', 215, NULL, NULL, 21362),
(21363, '3.30.200.20-FF-000953', NULL, 'Si:ch211-220i18.4', 90, NULL, NULL, 21363),
(21364, '2.60.120.10-FF-000632', NULL, 'Chromosome 1, whole genome shotgun sequence', 377, NULL, NULL, 21364),
(21365, '3.30.160.60-FF-000984', NULL, 'zinc finger protein 205 isoform X1', 32, NULL, NULL, 21365),
(21366, '3.80.10.10-FF-001760', NULL, 'Tehao, isoform A', 104, NULL, NULL, 21366),
(21367, '1.10.1370.10-FF-000024', NULL, 'Uncharacterized protein', 378, NULL, NULL, 21367),
(21368, '2.40.10.230-FF-000009', NULL, 'Uncharacterized protein', 116, NULL, NULL, 21368),
(21369, '3.40.50.300-FF-000462', NULL, 'Vitamin B12 import ATP-binding protein BtuD', 248, NULL, NULL, 21369),
(21370, '2.130.10.10-FF-005880', NULL, 'Uncharacterized protein', 301, NULL, NULL, 21370),
(21371, '2.130.10.10-FF-004790', NULL, 'Ribosome biogenesis protein WDR12 homolog', 150, NULL, NULL, 21371),
(21372, '3.40.50.300-FF-003896', NULL, 'Sodium ABC transporter ATP-binding protein', 244, NULL, NULL, 21372),
(21373, '3.30.160.20-FF-000112', NULL, 'Ribonuclease 3-like protein 3', 69, NULL, NULL, 21373),
(21374, '6.10.140.2220-FF-000011', NULL, 'Tudor domain containing 1', 47, NULL, NULL, 21374),
(21375, '2.40.40.20-FF-000055', NULL, 'Vesicular-fusion protein nsf, putative', 83, NULL, NULL, 21375),
(21376, '3.90.70.10-FF-000291', NULL, 'Deubiquitylating with USP/UBP and OTU domains', 283, NULL, NULL, 21376),
(21377, '1.10.238.10-FF-001252', NULL, 'Uncharacterized protein', 71, NULL, NULL, 21377),
(21378, '3.30.1330.120-FF-000005', NULL, 'Catabolic enzyme', 134, NULL, NULL, 21378),
(21379, '3.60.110.10-FF-000004', NULL, 'Carbon-nitrogen hydrolase', 257, NULL, NULL, 21379),
(21380, '3.40.50.80-FF-000234', NULL, 'NADH--cytochrome b5 reductase 1', 103, NULL, NULL, 21380),
(21381, '3.30.160.60-FF-005441', NULL, NULL, 51, NULL, NULL, 21381),
(21382, '3.40.50.80-FF-000110', NULL, 'Respiratory burst oxidase', 118, NULL, NULL, 21382),
(21383, '3.10.450.40-FF-000049', NULL, NULL, 89, NULL, NULL, 21383),
(21384, '2.40.50.90-FF-000082', NULL, 'Staphylococcal nuclease domain-containing protein', 122, NULL, NULL, 21384),
(21385, '3.90.70.10-FF-000268', NULL, 'Cysteine protease 19', 305, NULL, NULL, 21385),
(21386, '2.60.40.10-FF-000225', NULL, 'Myosin-binding protein C, cardiac-type', 97, NULL, NULL, 21386),
(21387, '3.40.850.10-FF-000233', NULL, 'Kinesin-like protein', 403, NULL, NULL, 21387),
(21388, '1.20.1510.10-FF-000050', NULL, 'Cation efflux family protein', 196, NULL, NULL, 21388),
(21389, '3.10.290.10-FF-000090', NULL, '30S ribosomal protein S4, chloroplastic', 64, NULL, NULL, 21389),
(21390, '2.130.10.10-FF-000192', NULL, 'Katanin p80 WD40 repeat-containing subunit B1 homolog', 139, NULL, NULL, 21390),
(21391, '2.30.29.30-FF-000560', NULL, 'Sterol 3-beta-glucosyltransferase', 107, NULL, NULL, 21391),
(21392, '1.10.510.10-FF-002442', NULL, 'Uncharacterized protein', 261, NULL, NULL, 21392);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(21393, '3.90.550.10-FF-000199', NULL, 'Molybdenum cofactor guanylyltransferase', 189, NULL, NULL, 21393),
(21394, '1.10.3090.10-FF-000025', NULL, 'Uncharacterized protein', 208, NULL, NULL, 21394),
(21395, '3.40.50.2300-FF-000791', NULL, NULL, 118, NULL, NULL, 21395),
(21396, '3.40.630.170-FF-000003', NULL, 'Glycylpeptide N-tetradecanoyltransferase', 388, NULL, NULL, 21396),
(21397, '1.20.1560.10-FF-000452', NULL, 'Bacterial MDR-like protein', 339, NULL, NULL, 21397),
(21398, '1.10.240.10-FF-000009', NULL, 'Tryptophan-tRNA ligase', 116, NULL, NULL, 21398),
(21399, '3.30.70.660-FF-000019', NULL, 'tRNA pseudouridine synthase', 165, NULL, NULL, 21399),
(21400, '3.40.50.2300-FF-000116', NULL, 'HTH-type transcriptional repressor CytR', 130, NULL, NULL, 21400),
(21401, '2.130.10.10-FF-000534', NULL, 'Xyloglucanase Xgh74A', 410, NULL, NULL, 21401),
(21402, '3.30.470.20-FF-000102', NULL, 'Tubulin glycylase 3B', 220, NULL, NULL, 21402),
(21403, '3.40.50.300-FF-000838', NULL, 'ABC multidrug transporter (Eurofung)', 252, NULL, NULL, 21403),
(21404, '2.60.40.60-FF-000178', NULL, 'Protocadherin Fat 2', 98, NULL, NULL, 21404),
(21405, '3.90.380.10-FF-000005', NULL, 'Rieske 2Fe-2S family protein', 258, NULL, NULL, 21405),
(21406, '3.40.50.2300-FF-000482', NULL, 'Glutamate receptor 1', 148, NULL, NULL, 21406),
(21407, '3.30.160.60-FF-000770', NULL, 'zinc finger protein 16', 28, NULL, NULL, 21407),
(21408, '3.30.40.10-FF-002186', NULL, 'Predicted protein', 80, NULL, NULL, 21408),
(21409, '3.30.40.10-FF-001567', NULL, 'U-box domain containing protein, putative', 96, NULL, NULL, 21409),
(21410, '1.20.120.140-FF-000020', NULL, 'Signal recognition particle receptor FtsY', 83, NULL, NULL, 21410),
(21411, '3.40.50.300-FF-008567', NULL, 'Uncharacterized protein', 135, NULL, NULL, 21411),
(21412, '3.10.180.10-FF-000109', NULL, 'Uncharacterized protein', 126, NULL, NULL, 21412),
(21413, '1.10.510.10-FF-001514', NULL, 'Kinase, STE STE20', 315, NULL, NULL, 21413),
(21414, '1.10.3120.10-FF-000023', NULL, NULL, 208, NULL, NULL, 21414),
(21415, '1.10.357.70-FF-000023', NULL, 'Exocyst complex component Sec6, putative', 199, NULL, NULL, 21415),
(21416, '3.30.43.10-FF-000006', NULL, 'UDP-N-acetylenolpyruvoylglucosamine reductase', 89, NULL, NULL, 21416),
(21417, '2.120.10.80-FF-000235', NULL, 'Uncharacterized protein', 195, NULL, NULL, 21417),
(21418, '1.10.510.10-FF-002133', NULL, NULL, 107, NULL, NULL, 21418),
(21419, '2.130.10.10-FF-005205', NULL, 'Uncharacterized WD repeat-containing protein C343.04c', 99, NULL, NULL, 21419),
(21420, '1.10.238.10-FF-001229', NULL, 'Uncharacterized protein', 106, NULL, NULL, 21420),
(21421, '3.30.519.10-FF-000010', NULL, 'Rab proteins geranylgeranyltransferase component A', 171, NULL, NULL, 21421),
(21422, '3.30.40.10-FF-001258', NULL, 'Uncharacterized protein', 70, NULL, NULL, 21422),
(21423, '3.40.1110.10-FF-000311', NULL, NULL, 127, NULL, NULL, 21423),
(21424, '3.40.50.1220-FF-000135', NULL, 'Sirtuin 7', 79, NULL, NULL, 21424),
(21425, '1.10.8.10-FF-000204', NULL, 'Ubiquitin associated and SH3 domain containing Bb', 28, NULL, NULL, 21425),
(21426, '3.40.50.11050-FF-000003', NULL, 'TcdA protein', 156, NULL, NULL, 21426),
(21427, '2.60.40.10-FF-003283', NULL, 'Mcam protein', 107, NULL, NULL, 21427),
(21428, '3.40.50.720-FF-001902', NULL, 'Predicted protein', 164, NULL, NULL, 21428),
(21429, '1.20.120.350-FF-000077', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 62, NULL, NULL, 21429),
(21430, '2.40.50.90-FF-000205', NULL, 'Probable ATP-dependent RNA helicase spindle-E', 111, NULL, NULL, 21430),
(21431, '3.30.70.330-FF-000724', NULL, 'Putative RNA-binding protein', 111, NULL, NULL, 21431),
(21432, '3.40.190.10-FF-000682', NULL, 'Uncharacterized protein', 103, NULL, NULL, 21432),
(21433, '3.50.50.60-FF-000851', NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', 239, NULL, NULL, 21433),
(21434, '3.30.200.20-FF-001881', NULL, 'Predicted protein', 137, NULL, NULL, 21434),
(21435, '1.10.10.60-FF-000523', NULL, 'Homeobox protein egl-5', 79, NULL, NULL, 21435),
(21436, '2.60.40.60-FF-000886', NULL, 'Predicted protein', 75, NULL, NULL, 21436);
INSERT INTO "PUBLIC"."MODEL" VALUES
(21437, '3.90.940.20-FF-000001', NULL, 'DNA-directed RNA polymerases I, II, and III subunit RPABC1', 76, NULL, NULL, 21437),
(21438, '1.25.40.470-FF-000060', NULL, 'Intraflagellar transport protein 172', 177, NULL, NULL, 21438),
(21439, '3.10.110.10-FF-000150', NULL, 'Ubiquitin-conjugating enzyme E2-17 kDa', 154, NULL, NULL, 21439),
(21440, '1.10.510.10-FF-000188', NULL, 'CaM kinase-like vesicle-associated, like', 224, NULL, NULL, 21440),
(21441, '3.40.140.10-FF-000280', NULL, 'Uncharacterized protein', 58, NULL, NULL, 21441),
(21442, '3.80.10.10-FF-002721', NULL, 'Predicted protein', 80, NULL, NULL, 21442),
(21443, '1.20.1250.20-FF-001792', NULL, 'Uncharacterized protein', 177, NULL, NULL, 21443),
(21444, '3.40.50.2000-FF-000240', NULL, 'Alpha-1,2-mannosyltransferase (Alg2)', 207, NULL, NULL, 21444),
(21445, '1.10.1410.10-FF-000067', NULL, 'Uncharacterized protein', 108, NULL, NULL, 21445),
(21446, '3.90.120.10-FF-000026', NULL, 'DNA (cytosine-5)-methyltransferase', 124, NULL, NULL, 21446),
(21447, '3.90.1150.10-FF-000038', NULL, '1-aminocyclopropane-1-carboxylate synthase 2', 139, NULL, NULL, 21447),
(21448, '1.20.1070.10-FF-000600', NULL, 'Retinal G-protein-coupled receptor', 275, NULL, NULL, 21448),
(21449, '1.10.10.60-FF-000737', NULL, 'Homeobox protein DBX1', 83, NULL, NULL, 21449),
(21450, '3.60.20.10-FF-000244', NULL, NULL, 66, NULL, NULL, 21450),
(21451, '3.40.50.2000-FF-000616', NULL, 'Slr1063 protein', 185, NULL, NULL, 21451),
(21452, '1.10.510.10-FF-001481', NULL, 'Serine/threonine protein kinase MARK2, putative', 295, NULL, NULL, 21452),
(21453, '2.120.10.80-FF-000382', NULL, 'Predicted protein', 130, NULL, NULL, 21453),
(21454, '3.90.132.10-FF-000019', NULL, 'Uncharacterized protein', 127, NULL, NULL, 21454),
(21455, '3.60.20.40-FF-000039', NULL, 'Uncharacterized protein', 194, NULL, NULL, 21455),
(21456, '3.40.50.720-FF-001650', NULL, 'YALI0B21692p', 301, NULL, NULL, 21456),
(21457, '3.40.50.1820-FF-001366', NULL, 'Predicted protein', 228, NULL, NULL, 21457),
(21458, '1.10.510.10-FF-001172', NULL, 'Cytoplasmic export protein', 143, NULL, NULL, 21458),
(21459, '2.30.30.940-FF-000015', NULL, 'ATP-dependent DNA helicase', 74, NULL, NULL, 21459),
(21460, '1.25.10.10-FF-001116', NULL, 'Coatomer subunit gamma', 289, NULL, NULL, 21460),
(21461, '2.10.25.10-FF-001108', NULL, 'C-type LECtin', 39, NULL, NULL, 21461),
(21462, '3.40.50.970-FF-000106', NULL, 'Pyruvate:ferredoxin (Flavodoxin) oxidoreductase', 383, NULL, NULL, 21462),
(21463, '1.20.1250.20-FF-001336', NULL, 'Uncharacterized protein', 401, NULL, NULL, 21463),
(21464, '2.130.10.10-FF-000748', NULL, 'U3 snoRNA-associated small subunit rRNA processing protein, putative', 346, NULL, NULL, 21464),
(21465, '2.40.10.10-FF-000314', NULL, 'elastase-1 isoform X1', 247, NULL, NULL, 21465),
(21466, '1.25.10.10-FF-000588', NULL, 'exportin-5 isoform X2', 1153, NULL, NULL, 21466),
(21467, '3.30.70.330-FF-000415', NULL, 'Flowering time control protein FPA', 83, NULL, NULL, 21467),
(21468, '3.50.7.10-FF-000058', NULL, NULL, 55, NULL, NULL, 21468),
(21469, '2.10.25.10-FF-001816', NULL, 'Uncharacterized protein', 43, NULL, NULL, 21469),
(21470, '1.10.1370.30-FF-000035', NULL, 'Angiotensin-converting enzyme', 139, NULL, NULL, 21470),
(21471, '3.40.50.10140-FF-000062', NULL, 'Predicted protein', 177, NULL, NULL, 21471),
(21472, '3.30.450.40-FF-000062', NULL, 'Adenylate/guanylate cyclase catalytic domain protein', 180, NULL, NULL, 21472),
(21473, '3.40.50.2300-FF-001443', NULL, NULL, 71, NULL, NULL, 21473),
(21474, '3.30.70.330-FF-000600', NULL, 'Uncharacterized protein, isoform A', 81, NULL, NULL, 21474),
(21475, '2.130.10.10-FF-004244', NULL, 'Uncharacterized protein', 140, NULL, NULL, 21475),
(21476, '2.60.40.10-FF-003659', NULL, NULL, 88, NULL, NULL, 21476),
(21477, '3.40.50.720-FF-001341', NULL, '3-oxoacyl-[acyl-carrier protein] reductase', 246, NULL, NULL, 21477),
(21478, '3.40.50.450-FF-000057', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit alpha 2', 42, NULL, NULL, 21478),
(21479, '2.60.40.10-FF-004834', NULL, NULL, 73, NULL, NULL, 21479);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(21480, '3.30.590.50-FF-000013', NULL, 'Glutamate-cysteine ligase', 95, NULL, NULL, 21480),
(21481, '1.20.120.850-FF-000002', NULL, 'DNA repair and recombination protein RAD54-like', 99, NULL, NULL, 21481),
(21482, '3.90.1170.10-FF-000028', NULL, 'Ribosomal protein L16', 175, NULL, NULL, 21482),
(21483, '3.50.50.60-FF-000834', NULL, 'YALI0D21076p', 296, NULL, NULL, 21483),
(21484, '3.80.10.10-FF-001209', NULL, 'Hypothetical_protein_-_conserved', 162, NULL, NULL, 21484),
(21485, '2.130.10.10-FF-005413', NULL, 'Adipose protein', 283, NULL, NULL, 21485),
(21486, '3.65.10.10-FF-000014', NULL, 'UDP-N-acetylglucosamine 1-carboxyvinyltransferase', 206, NULL, NULL, 21486),
(21487, '3.40.50.10380-FF-000010', NULL, 'NADP-dependent malic enzyme', 254, NULL, NULL, 21487),
(21488, '1.20.1250.20-FF-000605', NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', 205, NULL, NULL, 21488),
(21489, '2.60.40.10-FF-001057', NULL, 'PKHD1 like 1', 93, NULL, NULL, 21489),
(21490, '2.60.40.150-FF-000554', NULL, 'Uncharacterized protein', 89, NULL, NULL, 21490),
(21491, '1.50.10.10-FF-000187', NULL, 'alpha-1,2-Mannosidase', 309, NULL, NULL, 21491),
(21492, '3.90.1150.10-FF-000015', NULL, 'Alanine aminotransferase AlaC', 123, NULL, NULL, 21492),
(21493, '2.30.180.10-FF-000193', NULL, NULL, 126, NULL, NULL, 21493),
(21494, '1.10.132.60-FF-000043', NULL, 'DNA polymerase', 95, NULL, NULL, 21494),
(21495, '3.20.20.30-FF-000038', NULL, 'Alkanal monooxygenase beta chain', 229, NULL, NULL, 21495),
(21496, '3.40.50.1100-FF-000195', NULL, 'Uncharacterized protein', 47, NULL, NULL, 21496),
(21497, '3.40.50.2000-FF-000370', NULL, 'GM19574', 176, NULL, NULL, 21497),
(21498, '4.10.1240.10-FF-000063', NULL, 'Contactin-6', 59, NULL, NULL, 21498),
(21499, '3.40.50.1820-FF-000326', NULL, 'Putative esterase', 298, NULL, NULL, 21499),
(21500, '3.40.850.10-FF-000025', NULL, 'kinesin-like protein KIF27 isoform X1', 357, NULL, NULL, 21500),
(21501, '3.90.550.50-FF-000177', NULL, 'Uncharacterized protein', 247, NULL, NULL, 21501),
(21502, '3.30.160.60-FF-005891', NULL, NULL, 81, NULL, NULL, 21502),
(21503, '3.30.70.890-FF-000083', NULL, 'Uncharacterized protein', 33, NULL, NULL, 21503),
(21504, '1.20.1280.290-FF-000039', NULL, 'Integral membrane protein', 97, NULL, NULL, 21504),
(21505, '3.30.200.20-FF-001206', NULL, 'Os07g0301500 protein', 110, NULL, NULL, 21505),
(21506, '3.40.50.620-FF-000333', NULL, 'Nicotinamide mononucleotide adenylyltransferase', 231, NULL, NULL, 21506),
(21507, '1.25.40.10-FF-002456', NULL, 'Pentatricopeptide repeat-containing protein', 155, NULL, NULL, 21507),
(21508, '2.70.130.10-FF-000052', NULL, NULL, 48, NULL, NULL, 21508),
(21509, '3.40.50.720-FF-001998', NULL, 'Uncharacterized protein', 233, NULL, NULL, 21509),
(21510, '3.40.50.80-FF-000026', NULL, 'Putative respiratory burst oxidase', 194, NULL, NULL, 21510),
(21511, '1.25.40.10-FF-005311', NULL, 'Penicillin-binding protein activator LpoA', 124, NULL, NULL, 21511),
(21512, '3.30.160.60-FF-000085', NULL, 'Snail zinc finger protein', 24, NULL, NULL, 21512),
(21513, '2.130.10.10-FF-006032', NULL, 'Predicted protein', 305, NULL, NULL, 21513),
(21514, '3.40.50.720-FF-001094', NULL, 'NAD(P)-binding protein', 167, NULL, NULL, 21514),
(21515, '3.40.190.10-FF-000890', NULL, 'Fe(III)-induced transcriptional regulator IfcR', 86, NULL, NULL, 21515),
(21516, '3.90.470.10-FF-000012', NULL, '60S ribosomal protein L17', 179, NULL, NULL, 21516),
(21517, '3.40.50.1780-FF-000033', NULL, 'Uncharacterized protein', 97, NULL, NULL, 21517),
(21518, '1.25.10.10-FF-002628', NULL, 'Uncharacterized protein', 128, NULL, NULL, 21518),
(21519, '1.25.10.10-FF-003134', NULL, 'Serine/threonine-protein kinase TOR', 121, NULL, NULL, 21519),
(21520, '1.20.1070.10-FF-000830', NULL, 'Uncharacterized protein', 306, NULL, NULL, 21520),
(21521, '3.40.930.10-FF-000059', NULL, NULL, 277, NULL, NULL, 21521),
(21522, '3.10.330.10-FF-000003', NULL, 'vesicle-fusing ATPase isoform X1', 112, NULL, NULL, 21522),
(21523, '3.30.40.10-FF-002079', NULL, 'E3 ubiquitin-protein ligase RNF13', 86, NULL, NULL, 21523);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(21524, '2.40.70.10-FF-000447', NULL, NULL, 64, NULL, NULL, 21524),
(21525, '1.10.472.10-FF-000082', NULL, 'retinoblastoma-like protein 1 isoform X1', 107, NULL, NULL, 21525),
(21526, '3.40.50.1820-FF-001271', NULL, 'Protein phosphatase methylesterase 1', 301, NULL, NULL, 21526),
(21527, '3.30.70.330-FF-000516', NULL, 'RNA-binding motif protein 15B', 77, NULL, NULL, 21527),
(21528, '1.20.272.10-FF-000076', NULL, NULL, 123, NULL, NULL, 21528),
(21529, '3.40.640.10-FF-000312', NULL, 'Pyridoxal phosphate-dependent aminotransferase', 275, NULL, NULL, 21529),
(21530, '3.30.530.20-FF-000141', NULL, 'Predicted protein', 212, NULL, NULL, 21530),
(21531, '2.30.42.10-FF-000534', NULL, NULL, 109, NULL, NULL, 21531),
(21532, '2.60.40.10-FF-003878', NULL, NULL, 96, NULL, NULL, 21532),
(21533, '3.30.160.60-FF-004249', NULL, NULL, 19, NULL, NULL, 21533),
(21534, '3.40.50.300-FF-007847', NULL, 'Uncharacterized protein', 226, NULL, NULL, 21534),
(21535, '1.10.287.70-FF-000231', NULL, 'Glutamate receptor ionotropic, kainate 2-like', 33, NULL, NULL, 21535),
(21536, '3.30.780.10-FF-000072', NULL, 'Uncharacterized protein', 136, NULL, NULL, 21536),
(21537, '2.40.30.10-FF-000113', NULL, 'Translation initiation factor IF-2, putative', 133, NULL, NULL, 21537),
(21538, '1.10.287.1080-FF-000012', NULL, 'MazG nucleotide pyrophosphohydrolase', 116, NULL, NULL, 21538),
(21539, '3.30.200.20-FF-002297', NULL, 'Uncharacterized protein', 20, NULL, NULL, 21539),
(21540, '2.60.120.620-FF-000154', NULL, 'Prolyl 4-hydroxylase alpha subunit, putative', 208, NULL, NULL, 21540),
(21541, '3.30.2090.10-FF-000002', NULL, 'Efflux pump membrane transporter', 89, NULL, NULL, 21541),
(21542, '1.20.1250.20-FF-001224', NULL, 'Protein NRT1/ PTR FAMILY 5.10', 530, NULL, NULL, 21542),
(21543, '3.30.420.40-FF-000818', NULL, 'Major heat shock 70 kDa protein Ab-like Protein', 197, NULL, NULL, 21543),
(21544, '1.25.40.20-FF-001615', NULL, 'Asparaginase', 101, NULL, NULL, 21544),
(21545, '1.20.1250.40-FF-000033', NULL, 'Uncharacterized protein', 122, NULL, NULL, 21545),
(21546, '1.25.40.540-FF-000002', NULL, 'PP2A regulatory subunit TAP46', 223, NULL, NULL, 21546),
(21547, '3.30.160.60-FF-003070', NULL, 'Uncharacterized protein, isoform A', 22, NULL, NULL, 21547),
(21548, '3.40.630.10-FF-000486', NULL, 'Uncharacterized protein', 93, NULL, NULL, 21548),
(21549, '2.60.40.420-FF-000220', NULL, 'Coagulation factor V', 93, NULL, NULL, 21549),
(21550, '1.10.340.70-FF-000035', NULL, 'Uncharacterized protein', 58, NULL, NULL, 21550),
(21551, '3.30.360.10-FF-000080', NULL, '4-hydroxy-tetrahydrodipicolinate reductase', 96, NULL, NULL, 21551),
(21552, '2.10.70.10-FF-000010', NULL, 'Seizure related 6 homolog like', 60, NULL, NULL, 21552),
(21553, '1.10.287.470-FF-000087', NULL, 'Multidrug resistance efflux pump, RND family, membrane fusion protein EmrA', 70, NULL, NULL, 21553),
(21554, '2.60.120.560-FF-000012', NULL, 'Levanase (2,6-beta-D-fructofuranosidase)', 149, NULL, NULL, 21554),
(21555, '2.130.10.10-FF-004475', NULL, 'Striatin, calmodulin-binding protein 3', 61, NULL, NULL, 21555),
(21556, '2.40.50.140-FF-000951', NULL, NULL, 66, NULL, NULL, 21556),
(21557, '1.10.10.10-FF-000548', NULL, 'Cyclic di-GMP phosphodiesterase yahA', 65, NULL, NULL, 21557),
(21558, '3.20.20.70-FF-000691', NULL, NULL, 175, NULL, NULL, 21558),
(21559, '1.20.1080.10-FF-000106', NULL, 'Uncharacterized protein', 157, NULL, NULL, 21559),
(21560, '3.30.200.20-FF-001892', NULL, 'Predicted protein', 102, NULL, NULL, 21560),
(21561, '1.10.238.10-FF-000280', NULL, 'Calcium-binding EF hand family protein', 92, NULL, NULL, 21561),
(21562, '3.30.70.960-FF-000014', NULL, 'Transmembrane protease serine 11G', 108, NULL, NULL, 21562),
(21563, '1.10.510.10-FF-000784', NULL, 'Os07g0534300 protein', 203, NULL, NULL, 21563),
(21564, '1.10.10.10-FF-001588', NULL, 'Putative O-methyltransferase 2', 96, NULL, NULL, 21564),
(21565, '3.40.50.300-FF-006650', NULL, 'Uncharacterized protein', 88, NULL, NULL, 21565),
(21566, '3.10.290.10-FF-000078', NULL, 'Uncharacterized RNA pseudouridine synthase Caur_0901', 65, NULL, NULL, 21566);
INSERT INTO "PUBLIC"."MODEL" VALUES
(21567, '1.10.150.240-FF-000024', NULL, 'HAD family hydrolase', 63, NULL, NULL, 21567),
(21568, '3.40.50.720-FF-002403', NULL, 'Uncharacterized protein', 77, NULL, NULL, 21568),
(21569, '1.20.120.1630-FF-000013', NULL, 'Lamin-B receptor-like Protein', 201, NULL, NULL, 21569),
(21570, '3.30.420.10-FF-000585', NULL, NULL, 213, NULL, NULL, 21570),
(21571, '3.40.50.11380-FF-000001', NULL, 'UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase 110 kDa subunit', 184, NULL, NULL, 21571),
(21572, '3.30.1370.10-FF-000147', NULL, 'FUBP1 isoform 1', 35, NULL, NULL, 21572),
(21573, '2.60.34.10-FF-000025', NULL, 'Heat shock 70 kDa protein 16', 153, NULL, NULL, 21573),
(21574, '2.40.50.120-FF-000052', NULL, 'Tissue inhibitor of metalloproteinase, putative', 78, NULL, NULL, 21574),
(21575, '1.10.10.60-FF-000282', NULL, 'Tigger transposable element derived 5', 58, NULL, NULL, 21575),
(21576, '2.40.110.10-FF-000074', NULL, 'Acyl-coenzyme A oxidase', 135, NULL, NULL, 21576),
(21577, '1.25.40.90-FF-000074', NULL, 'Uncharacterized protein', 133, NULL, NULL, 21577),
(21578, '1.10.510.10-FF-001273', NULL, 'Protein kinase domain containing protein', 278, NULL, NULL, 21578),
(21579, '3.40.50.720-FF-000149', NULL, '15-hydroxyprostaglandin dehydrogenase [NAD(+)]', 258, NULL, NULL, 21579),
(21580, '2.30.42.10-FF-000181', NULL, 'Putative serine protease HTRA3', 102, NULL, NULL, 21580),
(21581, '3.50.50.60-FF-001239', NULL, 'Uncharacterized protein', 190, NULL, NULL, 21581),
(21582, '1.20.58.390-FF-000168', NULL, 'Cholinergic receptor nicotinic beta 1 subunit', 84, NULL, NULL, 21582),
(21583, '3.90.1310.10-FF-000017', NULL, 'Penicillin-binding protein 2', 205, NULL, NULL, 21583),
(21584, '1.10.510.10-FF-004139', NULL, NULL, 74, NULL, NULL, 21584),
(21585, '2.60.40.10-FF-004042', NULL, NULL, 97, NULL, NULL, 21585),
(21586, '3.40.50.150-FF-000725', NULL, 'Glutathione S-transferase, C-terminal domain-containing', 115, NULL, NULL, 21586),
(21587, '1.25.40.10-FF-001837', NULL, 'ERAD-associated E3 ubiquitin-protein ligase component HRD3A', 94, NULL, NULL, 21587),
(21588, '3.30.160.60-FF-001506', NULL, 'Zinc finger protein', 29, NULL, NULL, 21588),
(21589, '3.90.190.10-FF-000081', NULL, 'Tyrosine phosphatase type IVA', 167, NULL, NULL, 21589),
(21590, '1.10.357.50-FF-000023', NULL, 'Exocyst complex component 3', 171, NULL, NULL, 21590),
(21591, '1.25.10.10-FF-001105', NULL, 'Protein CBR-RME-8, isoform b', 204, NULL, NULL, 21591),
(21592, '3.30.40.10-FF-000634', NULL, 'Peroxisome assembly protein 12', 55, NULL, NULL, 21592),
(21593, '1.20.1070.10-FF-001218', NULL, 'Predicted protein', 163, NULL, NULL, 21593),
(21594, '1.25.10.10-FF-001217', NULL, 'Protein CELLULOSE SYNTHASE INTERACTIVE 1', 185, NULL, NULL, 21594),
(21595, '2.130.10.10-FF-000304', NULL, 'Uncharacterized protein, isoform C', 147, NULL, NULL, 21595),
(21596, '1.10.10.10-FF-000969', NULL, 'Probable transcriptional regulator', 85, NULL, NULL, 21596),
(21597, '2.60.120.200-FF-000601', NULL, 'Uncharacterized protein', 156, NULL, NULL, 21597),
(21598, '3.40.50.300-FF-005026', NULL, 'Uncharacterized protein', 185, NULL, NULL, 21598),
(21599, '2.20.28.10-FF-000007', NULL, 'DNA helicase MCM8 isoform X1', 52, NULL, NULL, 21599),
(21600, '3.90.550.10-FF-000064', NULL, 'Glycosyltransferases', 243, NULL, NULL, 21600),
(21601, '2.30.30.100-FF-000230', NULL, 'Uncharacterized protein', 50, NULL, NULL, 21601),
(21602, '3.90.79.10-FF-000159', NULL, 'Uncharacterized protein', 148, NULL, NULL, 21602),
(21603, '3.30.310.50-FF-000026', NULL, 'Phosphoglucosamine mutase', 90, NULL, NULL, 21603),
(21604, '3.10.310.20-FF-000011', NULL, 'DHH phosphoesterase', 151, NULL, NULL, 21604),
(21605, '2.130.10.10-FF-004115', NULL, 'Uncharacterized protein', 189, NULL, NULL, 21605),
(21606, '1.20.58.390-FF-000056', NULL, '5-hydroxytryptamine receptor 3B', 114, NULL, NULL, 21606),
(21607, '1.10.20.40-FF-000001', NULL, 'Diaphanous related formin 2', 53, NULL, NULL, 21607),
(21608, '2.60.40.150-FF-000133', NULL, 'Pre-mRNA splicing helicase, putative', 120, NULL, NULL, 21608),
(21609, '3.50.50.60-FF-000042', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 58, NULL, NULL, 21609);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(21610, '2.60.120.260-FF-000254', NULL, 'Furin putative serine protease', 132, NULL, NULL, 21610),
(21611, '3.90.70.10-FF-000509', NULL, 'Uncharacterized protein', 125, NULL, NULL, 21611),
(21612, '1.10.486.10-FF-000052', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 184, NULL, NULL, 21612),
(21613, '3.10.680.10-FF-000001', NULL, 'Photosystem II CP47 reaction center protein', 173, NULL, NULL, 21613),
(21614, '2.130.10.10-FF-000293', NULL, 'WD repeat and FYVE domain-containing protein 3', 282, NULL, NULL, 21614),
(21615, '1.25.40.10-FF-004373', NULL, 'Uncharacterized protein', 148, NULL, NULL, 21615),
(21616, '3.10.350.10-FF-000016', NULL, 'Immunoglobulin G-binding protein A', 69, NULL, NULL, 21616),
(21617, '2.60.40.1180-FF-000052', NULL, 'Uncharacterized glycosyl hydrolase YIR007W', 103, NULL, NULL, 21617),
(21618, '1.10.510.10-FF-000328', NULL, 'Cyclin-dependent kinase 20 isoform 2', 80, NULL, NULL, 21618),
(21619, '1.20.1080.10-FF-000095', NULL, 'Predicted protein', 238, NULL, NULL, 21619),
(21620, '2.70.70.10-FF-000064', NULL, 'PTS sugar transporter subunit IIA', 159, NULL, NULL, 21620),
(21621, '1.10.1070.20-FF-000004', NULL, 'Uncharacterized protein', 63, NULL, NULL, 21621),
(21622, '1.20.1280.50-FF-000190', NULL, 'Uncharacterized protein', 49, NULL, NULL, 21622),
(21623, '3.40.50.2300-FF-000139', NULL, 'Serine threonine protein kinase', 124, NULL, NULL, 21623),
(21624, '3.30.559.30-FF-000013', NULL, 'Phthiocerol/phthiodiolone dimycocerosyl transferase', 161, NULL, NULL, 21624),
(21625, '1.20.120.230-FF-000024', NULL, 'Vinculin, isoform B', 128, NULL, NULL, 21625),
(21626, '1.10.10.10-FF-001037', NULL, 'LysR family transcriptional regulator', 84, NULL, NULL, 21626),
(21627, '2.60.40.60-FF-000190', NULL, 'Protocadherin 12', 107, NULL, NULL, 21627),
(21628, '2.40.30.170-FF-000057', NULL, NULL, 126, NULL, NULL, 21628),
(21629, '4.10.60.10-FF-000168', NULL, 'Uncharacterized protein', 44, NULL, NULL, 21629),
(21630, '2.60.40.10-FF-003406', NULL, NULL, 75, NULL, NULL, 21630),
(21631, '1.20.58.340-FF-000086', NULL, 'Metal ion transporter', 122, NULL, NULL, 21631),
(21632, '1.10.20.10-FF-000346', NULL, NULL, 97, NULL, NULL, 21632),
(21633, '2.60.40.10-FF-003311', NULL, 'Neural cell adhesion molecule 3', 97, NULL, NULL, 21633),
(21634, '2.60.40.10-FF-002917', NULL, 'Probable beta-D-xylosidase 7', 141, NULL, NULL, 21634),
(21635, '1.50.10.160-FF-000001', NULL, 'Ent-copalyl diphosphate synthase', 213, NULL, NULL, 21635),
(21636, '3.30.1330.60-FF-000030', NULL, 'Outer membrane porin F', 124, NULL, NULL, 21636),
(21637, '3.90.650.10-FF-000009', NULL, 'Phosphoribosylformylglycinamidine synthase subunit PurL', 179, NULL, NULL, 21637),
(21638, '1.20.140.40-FF-000003', NULL, 'Invertase/pectin methylesterase inhibitor family protein', 151, NULL, NULL, 21638),
(21639, '3.90.1410.10-FF-000053', NULL, 'Rubisco small subunit small subunit n-methyltransferase', 293, NULL, NULL, 21639),
(21640, '3.40.50.150-FF-001361', NULL, NULL, 286, NULL, NULL, 21640),
(21641, '2.30.30.40-FF-000381', NULL, 'NCK (Non-Catalytic region of tyrosine Kinase) adaptor protein family', 84, NULL, NULL, 21641),
(21642, '3.40.50.1000-FF-000732', NULL, NULL, 74, NULL, NULL, 21642),
(21643, '3.30.200.20-FF-001678', NULL, 'Protein kinase superfamily protein', 79, NULL, NULL, 21643),
(21644, '4.10.860.10-FF-000017', NULL, 'UvrABC system protein C', 40, NULL, NULL, 21644),
(21645, '2.20.25.350-FF-000004', NULL, 'Putative eukaryotic translation initiation factor 5', 43, NULL, NULL, 21645),
(21646, '2.60.40.420-FF-000006', NULL, 'Cell division protein FtsP', 125, NULL, NULL, 21646),
(21647, '2.170.120.12-FF-000001', NULL, 'DNA-directed RNA polymerase subunit alpha', 122, NULL, NULL, 21647),
(21648, '3.40.50.2000-FF-000723', NULL, 'ADP-heptose--lipopolysaccharide heptosyltransferase, putative', 143, NULL, NULL, 21648),
(21649, '3.10.20.10-FF-000010', NULL, '60S ribosomal protein L18a', 68, NULL, NULL, 21649),
(21650, '3.30.200.20-FF-000268', NULL, 'probable receptor-like serine/threonine-protein kinase At5g57670', 106, NULL, NULL, 21650);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(21651, '3.10.20.30-FF-000016', NULL, 'Developmentally-regulated GTP-binding protein 2', 77, NULL, NULL, 21651),
(21652, '1.25.40.990-FF-000002', NULL, 'Leukocyte receptor cluster member 8 homolog', 230, NULL, NULL, 21652),
(21653, '2.60.40.2070-FF-000010', NULL, 'Heat shock protein E', 89, NULL, NULL, 21653),
(21654, '3.30.160.60-FF-002451', NULL, 'Zinc finger and SCAN domain containing 26', 60, NULL, NULL, 21654),
(21655, '3.90.70.10-FF-000723', NULL, 'Uncharacterized protein', 186, NULL, NULL, 21655),
(21656, '1.20.58.860-FF-000017', NULL, 'Ubiquitin carboxyl-terminal hydrolase isozyme L5', 100, NULL, NULL, 21656),
(21657, '1.25.40.10-FF-005199', NULL, 'Uncharacterized protein', 212, NULL, NULL, 21657),
(21658, '2.40.50.140-FF-000058', NULL, 'Transcription termination/antitermination protein NusA', 69, NULL, NULL, 21658),
(21659, '3.30.2350.20-FF-000042', NULL, NULL, 183, NULL, NULL, 21659),
(21660, '3.30.830.10-FF-000296', NULL, 'Uncharacterized protein', 62, NULL, NULL, 21660),
(21661, '2.30.130.110-FF-000004', NULL, 'Altronate hydrolase', 83, NULL, NULL, 21661),
(21662, '1.10.510.10-FF-004370', NULL, NULL, 104, NULL, NULL, 21662),
(21663, '3.30.70.3290-FF-000011', NULL, '6-deoxyerythronolide-B synthase EryA2, modules 3 and 4', 123, NULL, NULL, 21663),
(21664, '3.90.290.10-FF-000026', NULL, 'Fibrillin-1', 61, NULL, NULL, 21664),
(21665, '3.10.330.20-FF-000023', NULL, 'Predicted protein', 64, NULL, NULL, 21665),
(21666, '1.20.1070.10-FF-001561', NULL, 'Odorant receptor, family C, subfamily 104, member 2', 170, NULL, NULL, 21666),
(21667, '3.90.1440.10-FF-000004', NULL, 'Protein translocase subunit SecA', 122, NULL, NULL, 21667),
(21668, '3.40.50.720-FF-001217', NULL, 'Probable NADH2 dehydrogenase (Ubiquinone) 40K chain', 216, NULL, NULL, 21668),
(21669, '2.40.10.10-FF-000651', NULL, NULL, 116, NULL, NULL, 21669),
(21670, '3.100.10.10-FF-000009', NULL, '50S ribosomal protein L15, chloroplastic', 78, NULL, NULL, 21670),
(21671, '3.40.50.720-FF-001447', NULL, 'Methylenetetrahydrofolate dehydrogenase', 148, NULL, NULL, 21671),
(21672, '3.20.20.140-FF-000221', NULL, 'Uncharacterized protein', 490, NULL, NULL, 21672),
(21673, '3.50.80.10-FF-000006', NULL, 'D-aminoacyl-tRNA deacylase', 164, NULL, NULL, 21673),
(21674, '3.10.350.10-FF-000033', NULL, 'Putative membrane bound murein transglycosylase', 49, NULL, NULL, 21674),
(21675, '3.30.160.60-FF-004379', NULL, NULL, 46, NULL, NULL, 21675),
(21676, '2.30.30.490-FF-000060', NULL, 'Origin recognition complex subunit 1', 165, NULL, NULL, 21676),
(21677, '3.20.140.10-FF-000037', NULL, 'NAPRTase', 159, NULL, NULL, 21677),
(21678, '2.60.40.10-FF-000085', NULL, 'Myosin-binding protein C, slow type', 92, NULL, NULL, 21678),
(21679, '3.40.920.10-FF-000019', NULL, NULL, 177, NULL, NULL, 21679),
(21680, '1.25.40.10-FF-000769', NULL, 'Pre-mRNA-processing factor 6', 93, NULL, NULL, 21680),
(21681, '2.40.50.140-FF-000142', NULL, 'sn-glycerol-3-phosphate import ATP-binding protein UgpC', 45, NULL, NULL, 21681),
(21682, '2.120.10.80-FF-000134', NULL, 'Kelch domain-containing protein, putative', 209, NULL, NULL, 21682),
(21683, '3.40.50.150-FF-001018', NULL, NULL, 194, NULL, NULL, 21683),
(21684, '1.20.930.60-FF-000013', NULL, 'Uncharacterized protein', 122, NULL, NULL, 21684),
(21685, '3.30.70.20-FF-000010', NULL, 'Respiratory nitrate reductase beta subunit', 86, NULL, NULL, 21685),
(21686, '3.30.70.330-FF-002433', NULL, NULL, 88, NULL, NULL, 21686),
(21687, '1.10.455.10-FF-000019', NULL, 'Uncharacterized protein', 66, NULL, NULL, 21687),
(21688, '2.130.10.10-FF-000742', NULL, 'WD repeat domain 90', 231, NULL, NULL, 21688),
(21689, '1.10.510.10-FF-001722', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase B120', 126, NULL, NULL, 21689),
(21690, '2.60.40.10-FF-003423', NULL, NULL, 107, NULL, NULL, 21690),
(21691, '1.10.8.60-FF-000545', NULL, 'Origin recognition complex subunit 1', 108, NULL, NULL, 21691),
(21692, '2.10.25.10-FF-000046', NULL, 'Latent-transforming growth factor beta-binding protein 1 isoform x2', 44, NULL, NULL, 21692),
(21693, '3.40.190.10-FF-000238', NULL, 'ABC transporter, periplasmic substrate-binding protein', 99, NULL, NULL, 21693);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(21694, '3.40.50.2000-FF-000482', NULL, 'Glucosyltransferase', 228, NULL, NULL, 21694),
(21695, '3.40.50.11350-FF-000003', NULL, 'GDP-fucose protein O-fucosyltransferase', 159, NULL, NULL, 21695),
(21696, '3.30.40.10-FF-001253', NULL, 'RING/U-box superfamily protein', 75, NULL, NULL, 21696),
(21697, '2.60.40.150-FF-000684', NULL, 'Phosphoinositide phospholipase C', 161, NULL, NULL, 21697),
(21698, '3.40.50.300-FF-000698', NULL, 'Leucine-rich repeat serine/threonine-protein kinase 1', 114, NULL, NULL, 21698),
(21699, '3.60.10.10-FF-000210', NULL, 'DNA-(apurinic or apyrimidinic site) lyase', 134, NULL, NULL, 21699),
(21700, '3.40.50.2300-FF-001549', NULL, NULL, 27, NULL, NULL, 21700),
(21701, '3.40.640.10-FF-000537', NULL, 'Uncharacterized protein', 44, NULL, NULL, 21701),
(21702, '3.40.50.20-FF-000036', NULL, 'Aspartate carbamoyltransferase catalytic subunit', 141, NULL, NULL, 21702),
(21703, '3.10.28.10-FF-000022', NULL, 'Intron-encoded DNA endonuclease I-AniI', 126, NULL, NULL, 21703),
(21704, '2.60.40.10-FF-004704', NULL, NULL, 98, NULL, NULL, 21704),
(21705, '1.25.40.10-FF-002326', NULL, 'Tetratricopeptide repeat domain 8', 66, NULL, NULL, 21705),
(21706, '3.10.310.10-FF-000019', NULL, 'Proline racemase', 154, NULL, NULL, 21706),
(21707, '2.130.10.10-FF-004924', NULL, 'Uncharacterized protein', 106, NULL, NULL, 21707),
(21708, '2.40.160.50-FF-000038', NULL, 'Uncharacterized protein', 334, NULL, NULL, 21708),
(21709, '3.80.10.10-FF-000372', NULL, 'X-ray radiation resistance associated 1', 191, NULL, NULL, 21709),
(21710, '4.10.950.10-FF-000007', NULL, NULL, 64, NULL, NULL, 21710),
(21711, '1.10.472.10-FF-000110', NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', 24, NULL, NULL, 21711),
(21712, '3.30.160.60-FF-000197', NULL, 'Zinc finger protein 606', 28, NULL, NULL, 21712),
(21713, '2.40.160.210-FF-000015', NULL, 'Protein CBG22797', 283, NULL, NULL, 21713),
(21714, '3.40.50.720-FF-001886', NULL, 'Ketol-acid reductoisomerase chloroplastic', 119, NULL, NULL, 21714),
(21715, '3.30.470.30-FF-000060', NULL, 'mRNA-capping enzyme', 51, NULL, NULL, 21715),
(21716, '1.25.40.10-FF-000539', NULL, 'Uncharacterized protein', 387, NULL, NULL, 21716),
(21717, '3.40.1650.10-FF-000003', NULL, 'D-ribose pyranase', 121, NULL, NULL, 21717),
(21718, '3.40.30.10-FF-000616', NULL, 'Protein disulfide isomerase-like 1-2', 58, NULL, NULL, 21718),
(21719, '3.30.160.60-FF-003732', NULL, NULL, 31, NULL, NULL, 21719),
(21720, '1.20.144.10-FF-000003', NULL, 'Dolichyldiphosphatase 1', 106, NULL, NULL, 21720),
(21721, '3.40.140.10-FF-000286', NULL, 'Cytidine deaminase 3', 44, NULL, NULL, 21721),
(21722, '3.40.50.300-FF-007055', NULL, 'Uncharacterized protein', 197, NULL, NULL, 21722),
(21723, '1.10.150.20-FF-000118', NULL, 'flap endonuclease GEN-like 2 isoform X1', 56, NULL, NULL, 21723),
(21724, '3.40.50.1000-FF-000069', NULL, 'HAD-superfamily subfamily IIA hydrolase', 162, NULL, NULL, 21724),
(21725, '3.30.1370.50-FF-000035', NULL, 'RNA-binding post-transcriptional regulator cip2', 66, NULL, NULL, 21725),
(21726, '1.20.120.20-FF-000013', NULL, 'Zeo1p', 110, NULL, NULL, 21726),
(21727, '3.20.20.70-FF-000814', NULL, NULL, 330, NULL, NULL, 21727),
(21728, '1.25.10.10-FF-000700', NULL, 'Serine/threonine-protein kinase TOR', 233, NULL, NULL, 21728),
(21729, '3.40.50.720-FF-002162', NULL, 'Uncharacterized protein', 77, NULL, NULL, 21729),
(21730, '1.10.4160.10-FF-000008', NULL, 'Allantoin permease', 457, NULL, NULL, 21730),
(21731, '2.150.10.10-FF-000011', NULL, 'Os03g0788300 protein', 139, NULL, NULL, 21731),
(21732, '3.40.50.1010-FF-000168', NULL, NULL, 146, NULL, NULL, 21732),
(21733, '1.25.40.90-FF-000057', NULL, 'Uncharacterized protein', 127, NULL, NULL, 21733),
(21734, '2.60.120.260-FF-000124', NULL, 'Anaphase promoting complex subunit 10 (APC10)', 196, NULL, NULL, 21734),
(21735, '3.30.70.330-FF-000179', NULL, 'APOBEC1 complementation factor isoform X1', 75, NULL, NULL, 21735),
(21736, '3.40.50.720-FF-002066', NULL, 'Os05g0203400 protein', 157, NULL, NULL, 21736),
(21737, '3.30.190.20-FF-000041', NULL, 'Uncharacterized protein', 73, NULL, NULL, 21737);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(21738, '3.90.70.10-FF-000639', NULL, 'Deubiquitylating with USP/UBP and OTU domains', 110, NULL, NULL, 21738),
(21739, '1.10.10.60-FF-000731', NULL, 'Nkx1-1', 68, NULL, NULL, 21739),
(21740, '2.40.37.10-FF-000022', NULL, 'Alanine racemase', 141, NULL, NULL, 21740),
(21741, '3.40.50.300-FF-006779', NULL, 'Uncharacterized protein', 59, NULL, NULL, 21741),
(21742, '3.40.1110.10-FF-000098', NULL, 'Cation-transporting ATPase', 162, NULL, NULL, 21742),
(21743, '3.40.50.300-FF-003210', NULL, 'RNA helicase aquarius', 145, NULL, NULL, 21743),
(21744, '3.30.40.10-FF-002107', NULL, 'Uncharacterized protein', 58, NULL, NULL, 21744),
(21745, '3.40.50.410-FF-000051', NULL, 'Collagen type XXVIII alpha 1 chain', 199, NULL, NULL, 21745),
(21746, '3.60.20.40-FF-000034', NULL, 'Uncharacterized protein', 129, NULL, NULL, 21746),
(21747, '1.20.920.30-FF-000060', NULL, 'Uncharacterized protein', 145, NULL, NULL, 21747),
(21748, '2.60.120.920-FF-000154', NULL, 'Si:dkey-156k2.4', 180, NULL, NULL, 21748),
(21749, '3.40.50.970-FF-000207', NULL, 'Pyruvate ferredoxin oxidoreductase B', 273, NULL, NULL, 21749),
(21750, '3.80.10.10-FF-003126', NULL, 'Uncharacterized protein', 81, NULL, NULL, 21750),
(21751, '3.40.1690.20-FF-000020', NULL, 'Predicted protein', 109, NULL, NULL, 21751),
(21752, '1.10.10.10-FF-000632', NULL, 'Vacuolar-sorting protein SNF8', 84, NULL, NULL, 21752),
(21753, '3.30.160.60-FF-006166', NULL, NULL, 76, NULL, NULL, 21753),
(21754, '1.25.40.10-FF-001388', NULL, 'Pentatricopeptide repeat-containing protein', 117, NULL, NULL, 21754),
(21755, '2.60.120.200-FF-000264', NULL, 'Laminin-like protein epi-1', 167, NULL, NULL, 21755),
(21756, '1.25.40.20-FF-000429', NULL, 'Oxysterol-binding protein, putative', 83, NULL, NULL, 21756),
(21757, '1.25.10.10-FF-003117', NULL, 'Uncharacterized protein', 211, NULL, NULL, 21757),
(21758, '1.10.555.10-FF-000185', NULL, NULL, 138, NULL, NULL, 21758),
(21759, '3.40.50.1000-FF-000620', NULL, NULL, 56, NULL, NULL, 21759),
(21760, '1.10.472.170-FF-000003', NULL, 'Transcription initiation factor IIB', 163, NULL, NULL, 21760),
(21761, '2.60.40.1120-FF-000062', NULL, 'Uncharacterized protein', 75, NULL, NULL, 21761),
(21762, '1.10.510.10-FF-002684', NULL, NULL, 136, NULL, NULL, 21762),
(21763, '3.80.10.10-FF-003918', NULL, 'Uncharacterized protein', 106, NULL, NULL, 21763),
(21764, '1.10.10.10-FF-002094', NULL, 'Uncharacterized protein', 57, NULL, NULL, 21764),
(21765, '2.40.50.140-FF-000721', NULL, NULL, 69, NULL, NULL, 21765),
(21766, '3.40.50.300-FF-007398', NULL, 'Uncharacterized protein', 98, NULL, NULL, 21766),
(21767, '1.10.238.10-FF-000392', NULL, 'Uncharacterized protein', 70, NULL, NULL, 21767),
(21768, '3.40.50.2300-FF-001651', NULL, NULL, 215, NULL, NULL, 21768),
(21769, '3.40.30.10-FF-001235', NULL, 'Uncharacterized protein', 104, NULL, NULL, 21769),
(21770, '1.50.10.150-FF-000009', NULL, 'C4-dicarboxylate ABC transporter', 313, NULL, NULL, 21770),
(21771, '3.40.50.1240-FF-000220', NULL, NULL, 90, NULL, NULL, 21771),
(21772, '2.30.42.10-FF-000051', NULL, 'Multiple PDZ domain protein isoform X1', 115, NULL, NULL, 21772),
(21773, '1.25.40.10-FF-003866', NULL, 'Uncharacterized protein', 102, NULL, NULL, 21773),
(21774, '1.20.1250.10-FF-000035', NULL, 'Interleukin-27 subunit alpha', 195, NULL, NULL, 21774),
(21775, '1.10.390.20-FF-000001', NULL, 'Microbial collagenase', 138, NULL, NULL, 21775),
(21776, '1.10.510.10-FF-003190', NULL, NULL, 152, NULL, NULL, 21776),
(21777, '3.90.226.10-FF-000142', NULL, 'Carbamoyl-phosphate synthase L chain, ATP-binding', 234, NULL, NULL, 21777),
(21778, '3.30.160.60-FF-005317', NULL, NULL, 78, NULL, NULL, 21778),
(21779, '3.30.1010.10-FF-000126', NULL, 'Uncharacterized protein', 54, NULL, NULL, 21779),
(21780, '3.10.150.10-FF-000017', NULL, 'DNA polymerase III subunit beta', 182, NULL, NULL, 21780),
(21781, '1.10.540.10-FF-000156', NULL, 'Uncharacterized protein', 86, NULL, NULL, 21781),
(21782, '1.50.10.20-FF-000061', NULL, 'Transcobalamin II', 291, NULL, NULL, 21782),
(21783, '3.10.330.40-FF-000001', NULL, '2-dehydro-3-deoxy-D-arabinonate dehydratase', 70, NULL, NULL, 21783);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(21784, '3.20.180.20-FF-000037', NULL, 'Dynein heavy chain, cytoplasmic', 96, NULL, NULL, 21784),
(21785, '3.40.30.10-FF-000487', NULL, 'NADH-ubiquinone oxidoreductase subunit, putative', 92, NULL, NULL, 21785),
(21786, '3.40.50.1000-FF-000648', NULL, NULL, 162, NULL, NULL, 21786),
(21787, '2.40.320.10-FF-000011', NULL, 'Mediator of RNA polymerase II transcription subunit 18', 205, NULL, NULL, 21787),
(21788, '1.50.10.130-FF-000003', NULL, 'Ent-cassa-12,15-diene synthase', 209, NULL, NULL, 21788),
(21789, '3.40.50.1380-FF-000037', NULL, 'Uncharacterized protein', 48, NULL, NULL, 21789),
(21790, '2.30.30.490-FF-000088', NULL, 'Uncharacterized protein', 136, NULL, NULL, 21790),
(21791, '3.40.50.300-FF-005138', NULL, 'ABC transporter, ATP-binding protein', 238, NULL, NULL, 21791),
(21792, '1.20.910.10-FF-000025', NULL, 'Aminopyrimidine aminohydrolase', 214, NULL, NULL, 21792),
(21793, '3.40.50.300-FF-001215', NULL, 'ATP-dependent DNA helicase', 197, NULL, NULL, 21793),
(21794, '3.30.1370.120-FF-000002', NULL, 'General secretion pathway protein D', 79, NULL, NULL, 21794),
(21795, '1.10.10.10-FF-001700', NULL, 'Helix-turn-helix transcriptional regulator with aminotransferase domain, GntR family', 97, NULL, NULL, 21795),
(21796, '1.20.1560.10-FF-000025', NULL, 'ABC transporter B family member 9', 23, NULL, NULL, 21796),
(21797, '3.80.10.10-FF-002300', NULL, 'Leucine-rich repeat protein (LRRP), putative', 204, NULL, NULL, 21797),
(21798, '3.40.50.1360-FF-000031', NULL, '6-phosphogluconolactonase', 232, NULL, NULL, 21798),
(21799, '1.20.1560.10-FF-000688', NULL, 'ABC transporter', 344, NULL, NULL, 21799),
(21800, '2.30.29.30-FF-000436', NULL, 'CLNS1A isoform 4', 68, NULL, NULL, 21800),
(21801, '2.60.40.10-FF-000989', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', 110, NULL, NULL, 21801),
(21802, '3.40.50.2300-FF-000240', NULL, 'Ethylene receptor', 126, NULL, NULL, 21802),
(21803, '1.10.238.10-FF-001140', NULL, 'Uncharacterized protein', 147, NULL, NULL, 21803),
(21804, '3.40.50.2300-FF-000370', NULL, 'L-arabinose-binding periplasmic protein', 155, NULL, NULL, 21804),
(21805, '2.20.28.30-FF-000002', NULL, 'DNA-directed RNA polymerases II, IV and V subunit 12', 52, NULL, NULL, 21805),
(21806, '3.40.50.1100-FF-000223', NULL, 'Uncharacterized protein', 19, NULL, NULL, 21806),
(21807, '1.10.506.10-FF-000094', NULL, 'Uncharacterized protein', 91, NULL, NULL, 21807),
(21808, '3.90.70.10-FF-000740', NULL, 'Uncharacterized protein', 147, NULL, NULL, 21808),
(21809, '3.40.525.10-FF-000028', NULL, 'GH16843p', 221, NULL, NULL, 21809),
(21810, '3.60.40.10-FF-000251', NULL, 'Uncharacterized protein', 225, NULL, NULL, 21810),
(21811, '1.20.1510.10-FF-000073', NULL, NULL, 199, NULL, NULL, 21811),
(21812, '3.30.390.50-FF-000014', NULL, 'Nicotinate dehydrogenase FAD-subunit', 118, NULL, NULL, 21812),
(21813, '1.10.10.750-FF-000041', NULL, 'AaceriADR213Cp', 45, NULL, NULL, 21813),
(21814, '3.90.1750.10-FF-000095', NULL, 'Predicted protein', 140, NULL, NULL, 21814),
(21815, '3.30.420.10-FF-000242', NULL, 'Ribonuclease HII', 194, NULL, NULL, 21815),
(21816, '2.10.109.10-FF-000055', NULL, 'Mitochondrial inner membrane protease subunit', 123, NULL, NULL, 21816),
(21817, '3.30.450.20-FF-000640', NULL, 'Glr3986 protein', 133, NULL, NULL, 21817),
(21818, '2.30.29.30-FF-000223', NULL, 'Pleckstrin', 111, NULL, NULL, 21818),
(21819, '3.90.79.10-FF-000260', NULL, 'Pre-mRNA cleavage factor I 25 kDa subunit putative', 128, NULL, NULL, 21819),
(21820, '3.40.710.10-FF-000195', NULL, 'Penicillin-binding protein 2', 186, NULL, NULL, 21820),
(21821, '1.10.287.3550-FF-000006', NULL, 'Stromal interaction molecule 2', 38, NULL, NULL, 21821),
(21822, '3.40.630.30-FF-000121', NULL, 'Acetyltransferase, GNAT family', 91, NULL, NULL, 21822),
(21823, '1.25.40.70-FF-000079', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', 133, NULL, NULL, 21823),
(21824, '2.30.30.550-FF-000016', NULL, NULL, 55, NULL, NULL, 21824),
(21825, '1.10.510.10-FF-002341', NULL, 'Predicted protein', 248, NULL, NULL, 21825);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(21826, '1.20.930.40-FF-000018', NULL, 'Uncharacterized protein', 150, NULL, NULL, 21826),
(21827, '2.60.40.10-FF-005323', NULL, NULL, 77, NULL, NULL, 21827),
(21828, '2.130.10.10-FF-000872', NULL, 'WD repeat domain 37', 204, NULL, NULL, 21828),
(21829, '3.40.50.300-FF-007959', NULL, 'Uncharacterized protein', 166, NULL, NULL, 21829),
(21830, '3.40.50.300-FF-006083', NULL, 'Small GTP-binding protein, putative', 189, NULL, NULL, 21830),
(21831, '2.60.120.10-FF-000492', NULL, 'Homogentisate 1,2-dioxygenase', 85, NULL, NULL, 21831),
(21832, '2.130.10.10-FF-001361', NULL, 'WD repeat domain 55', 197, NULL, NULL, 21832),
(21833, '1.10.1370.10-FF-000029', NULL, 'Uncharacterized protein', 229, NULL, NULL, 21833),
(21834, '3.40.630.10-FF-000143', NULL, 'Zinc carboxypeptidase', 305, NULL, NULL, 21834),
(21835, '3.40.47.10-FF-000008', NULL, '3-hydroxy-3-methylglutaryl coenzyme A synthase', 455, NULL, NULL, 21835),
(21836, '2.120.10.30-FF-000029', NULL, 'LDL receptor related protein 4', 304, NULL, NULL, 21836),
(21837, '3.80.10.10-FF-001552', NULL, 'Calpain-like cysteine peptidase, putative', 157, NULL, NULL, 21837),
(21838, '1.10.560.10-FF-000039', NULL, 'Chaperonin containing TCP1 subunit 2', 189, NULL, NULL, 21838),
(21839, '1.10.287.660-FF-000037', NULL, 'Uncharacterized protein', 61, NULL, NULL, 21839),
(21840, '3.30.40.10-FF-000281', NULL, 'E3 ubiquitin-protein ligase SIS3', 79, NULL, NULL, 21840),
(21841, '1.10.287.70-FF-000798', NULL, 'Small conductance calcium-activated potassium channel protein 2', 122, NULL, NULL, 21841),
(21842, '3.30.160.20-FF-000213', NULL, 'Double-stranded RNA-specific editase Adar-like Protein', 90, NULL, NULL, 21842),
(21843, '2.60.40.640-FF-000055', NULL, 'Vacuolar sorting protein 26, putative', 173, NULL, NULL, 21843),
(21844, '2.20.100.10-FF-000027', NULL, 'Thrombospondin type 1 domain containing 7A', 50, NULL, NULL, 21844),
(21845, '2.120.10.30-FF-000389', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 289, NULL, NULL, 21845),
(21846, '3.40.640.10-FF-000200', NULL, 'Threonine aldolase', 249, NULL, NULL, 21846),
(21847, '1.10.630.10-FF-000360', NULL, 'Cytochrome P450, putative (Eurofung)', 464, NULL, NULL, 21847),
(21848, '3.10.450.700-FF-000015', NULL, 'Uncharacterized protein', 77, NULL, NULL, 21848),
(21849, '2.40.10.10-FF-000090', NULL, 'serine protease hepsin', 107, NULL, NULL, 21849),
(21850, '3.40.50.300-FF-004981', NULL, 'Guanylate-binding protein 1', 142, NULL, NULL, 21850),
(21851, '3.30.160.60-FF-000989', NULL, 'Spalt like transcription factor 4', 31, NULL, NULL, 21851),
(21852, '3.40.50.11370-FF-000009', NULL, 'Inositol-tetrakisphosphate 1-kinase', 127, NULL, NULL, 21852),
(21853, '2.40.30.10-FF-000534', NULL, 'Uncharacterized protein', 103, NULL, NULL, 21853),
(21854, '3.30.40.10-FF-001691', NULL, 'Predicted protein', 70, NULL, NULL, 21854),
(21855, '3.30.760.10-FF-000060', NULL, 'Uncharacterized protein', 201, NULL, NULL, 21855),
(21856, '3.40.140.10-FF-000156', NULL, 'Deoxycytidylate deaminase-related protein', 192, NULL, NULL, 21856),
(21857, '3.10.20.90-FF-000118', NULL, 'Phosphoinositide phospholipase C', 99, NULL, NULL, 21857),
(21858, '1.25.40.180-FF-000102', NULL, 'GM11217', 249, NULL, NULL, 21858),
(21859, '2.60.120.590-FF-000010', NULL, 'GRF zinc finger domain protein', 251, NULL, NULL, 21859),
(21860, '2.60.40.10-FF-000652', NULL, 'obscurin isoform X3', 96, NULL, NULL, 21860),
(21861, '1.10.287.4270-FF-000003', NULL, 'Serine/threonine-protein kinase 4', 43, NULL, NULL, 21861),
(21862, '1.10.418.10-FF-000277', NULL, 'Plastin 1', 108, NULL, NULL, 21862),
(21863, '1.25.40.10-FF-001045', NULL, 'Pentatricopeptide repeat-containing protein', 234, NULL, NULL, 21863),
(21864, '3.40.630.30-FF-000149', NULL, 'Aminoglycoside 2''-N-acetyltransferase AAC (AAC(2'')-IC)', 181, NULL, NULL, 21864),
(21865, '1.10.287.110-FF-000097', NULL, 'Chaperone protein dnaJ 16', 99, NULL, NULL, 21865),
(21866, '2.30.42.10-FF-000079', NULL, 'Whirlin a', 95, NULL, NULL, 21866),
(21867, '2.90.10.10-FF-000020', NULL, 'Serine/threonine-protein kinase', 134, NULL, NULL, 21867);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(21868, '3.30.1330.50-FF-000010', NULL, 'Uncharacterized protein', 94, NULL, NULL, 21868),
(21869, '2.60.200.20-FF-000220', NULL, 'Uncharacterized protein', 109, NULL, NULL, 21869),
(21870, '3.20.20.100-FF-000136', NULL, 'dTDP-4-keto-L-6-deoxy-hexose 2,3-reductase-putative a NADP-dependent oxidoreductase', 311, NULL, NULL, 21870),
(21871, '2.170.270.10-FF-000021', NULL, 'Histone-lysine N-methyltransferase', 165, NULL, NULL, 21871),
(21872, '1.20.58.2140-FF-000006', NULL, 'Putative RNA-binding protein of the translin family', 196, NULL, NULL, 21872),
(21873, '3.40.50.300-FF-000147', NULL, 'EH domain-containing protein 1', 225, NULL, NULL, 21873),
(21874, '2.10.25.10-FF-001552', NULL, 'Tyrosine-protein kinase receptor', 50, NULL, NULL, 21874),
(21875, '2.60.40.10-FF-003974', NULL, NULL, 129, NULL, NULL, 21875),
(21876, '3.30.420.40-FF-000138', NULL, 'Exopolyphosphatase 1', 122, NULL, NULL, 21876),
(21877, '3.40.50.150-FF-000276', NULL, 'Methyltransferase', 251, NULL, NULL, 21877),
(21878, '3.30.70.330-FF-001685', NULL, NULL, 82, NULL, NULL, 21878),
(21879, '3.40.532.10-FF-000033', NULL, NULL, 116, NULL, NULL, 21879),
(21880, '3.30.730.10-FF-000001', NULL, 'Ethylene-responsive transcription factor 2', 59, NULL, NULL, 21880),
(21881, '1.50.40.10-FF-000464', NULL, 'Uncharacterized protein', 84, NULL, NULL, 21881),
(21882, '1.20.120.1760-FF-000035', NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', 189, NULL, NULL, 21882),
(21883, '2.60.40.790-FF-000089', NULL, 'Co-chaperone p23', 156, NULL, NULL, 21883),
(21884, '2.70.150.10-FF-000295', NULL, 'ATPase phospholipid transporting 8B3', 119, NULL, NULL, 21884),
(21885, '3.90.640.10-FF-000054', NULL, 'Actin-like ATPase domain-containing protein', 78, NULL, NULL, 21885),
(21886, '3.40.50.300-FF-003340', NULL, 'Cell division control protein 42, putative', 164, NULL, NULL, 21886),
(21887, '1.20.58.1030-FF-000022', NULL, 'AGAP010835-PA', 127, NULL, NULL, 21887),
(21888, '1.25.10.70-FF-000010', NULL, 'Chromosome 21, whole genome shotgun sequence', 342, NULL, NULL, 21888),
(21889, '2.30.30.40-FF-000510', NULL, 'N-acetylmuramoyl-L-alanine amidase', 52, NULL, NULL, 21889),
(21890, '1.10.3210.10-FF-000007', NULL, 'GTP pyrophosphokinase', 172, NULL, NULL, 21890),
(21891, '3.30.70.2170-FF-000001', NULL, 'V-type ATP synthase subunit I', 53, NULL, NULL, 21891),
(21892, '1.10.10.60-FF-000962', NULL, NULL, 55, NULL, NULL, 21892),
(21893, '3.60.10.10-FF-000322', NULL, 'Uncharacterized protein', 267, NULL, NULL, 21893),
(21894, '3.60.10.10-FF-000423', NULL, 'Endonuclease/exonuclease/phosphatase-like protein', 112, NULL, NULL, 21894),
(21895, '3.40.50.1220-FF-000130', NULL, 'NAD-dependent deacetylase sir2B', 215, NULL, NULL, 21895),
(21896, '3.40.50.1820-FF-000669', NULL, 'GLIoTactin (Drosophila neuroligin-like) homolog', 591, NULL, NULL, 21896),
(21897, '1.20.1050.10-FF-000054', NULL, 'Methionine-tRNA ligase, beta subunit', 93, NULL, NULL, 21897),
(21898, '2.60.40.10-FF-004480', NULL, NULL, 92, NULL, NULL, 21898),
(21899, '2.70.40.10-FF-000011', NULL, 'dUTPase', 169, NULL, NULL, 21899),
(21900, '3.20.20.190-FF-000112', NULL, NULL, 88, NULL, NULL, 21900),
(21901, '3.30.310.80-FF-000024', NULL, 'Non-specific serine/threonine protein kinase', 128, NULL, NULL, 21901),
(21902, '1.25.40.10-FF-003411', NULL, 'Putative pentatricopeptide repeat-containing protein', 122, NULL, NULL, 21902),
(21903, '1.25.10.10-FF-003230', NULL, 'Serine/threonine-protein kinase TOR', 256, NULL, NULL, 21903),
(21904, '1.10.510.10-FF-000216', NULL, 'Tyrosine-protein kinase SYK', 185, NULL, NULL, 21904),
(21905, '3.30.450.30-FF-000076', NULL, 'Profilin', 119, NULL, NULL, 21905),
(21906, '3.30.870.10-FF-000062', NULL, 'Tyrosyl-DNA phosphodiesterase, putative', 214, NULL, NULL, 21906),
(21907, '2.60.120.290-FF-000116', NULL, 'Predicted protein', 116, NULL, NULL, 21907),
(21908, '2.60.120.580-FF-000001', NULL, 'Formamidase FmdS', 180, NULL, NULL, 21908),
(21909, '3.60.110.10-FF-000009', NULL, 'Beta-ureidopropionase 1', 383, NULL, NULL, 21909),
(21910, '3.30.70.2190-FF-000007', NULL, 'FAD-binding oxidoreductase', 110, NULL, NULL, 21910);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(21911, '3.30.200.20-FF-000509', NULL, 'Tyrosine-protein kinase receptor UFO', 111, NULL, NULL, 21911),
(21912, '2.130.10.10-FF-005655', NULL, 'Uncharacterized protein', 168, NULL, NULL, 21912),
(21913, '3.90.70.80-FF-000036', NULL, 'Zn-finger in Ran binding protein and others/OTU-like cysteine protease, putative', 172, NULL, NULL, 21913),
(21914, '3.40.390.10-FF-000219', NULL, NULL, 177, NULL, NULL, 21914),
(21915, '2.130.10.10-FF-004019', NULL, 'Uncharacterized protein', 223, NULL, NULL, 21915),
(21916, '1.20.5.460-FF-000004', NULL, 'Death-associated protein kinase 2', 28, NULL, NULL, 21916),
(21917, '2.120.10.30-FF-000491', NULL, 'Predicted protein', 253, NULL, NULL, 21917),
(21918, '3.30.160.60-FF-001849', NULL, 'Zinc finger CCCH domain-containing protein 3', 46, NULL, NULL, 21918),
(21919, '2.60.40.820-FF-000002', NULL, 'T-box transcription factor Brachyury', 190, NULL, NULL, 21919),
(21920, '1.20.1420.30-FF-000072', NULL, 'Na+/Ca+ antiporter, CaCA family', 221, NULL, NULL, 21920),
(21921, '1.25.10.10-FF-002280', NULL, 'Uncharacterized protein', 333, NULL, NULL, 21921),
(21922, '3.40.50.11320-FF-000011', NULL, 'Carboxypeptidase', 45, NULL, NULL, 21922),
(21923, '3.30.160.60-FF-004704', NULL, NULL, 37, NULL, NULL, 21923),
(21924, '1.20.1070.10-FF-001578', NULL, 'AGAP012698-PA', 160, NULL, NULL, 21924),
(21925, '3.30.420.40-FF-000239', NULL, 'Cell division protein FtsA', 159, NULL, NULL, 21925),
(21926, '2.40.320.10-FF-000028', NULL, 'CYTH domain-containing protein', 151, NULL, NULL, 21926),
(21927, '2.10.70.10-FF-000139', NULL, 'Blast:Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', 66, NULL, NULL, 21927),
(21928, '1.25.10.10-FF-000728', NULL, 'Blast:Integrator complex subunit 4', 177, NULL, NULL, 21928),
(21929, '3.30.870.10-FF-000163', NULL, 'Uncharacterized protein', 84, NULL, NULL, 21929),
(21930, '3.20.20.80-FF-000351', NULL, 'Glycosyl hydrolase family protein with chitinase insertion domain-containing protein', 187, NULL, NULL, 21930),
(21931, '3.40.50.11340-FF-000017', NULL, 'Predicted protein', 46, NULL, NULL, 21931),
(21932, '3.30.200.20-FF-002393', NULL, 'Uncharacterized protein', 134, NULL, NULL, 21932),
(21933, '3.40.720.10-FF-000122', NULL, 'Sulfatase 2a', 158, NULL, NULL, 21933),
(21934, '3.40.190.10-FF-000446', NULL, 'Molybdenum ABC transporter, periplasmic molybdenum-binding protein', 112, NULL, NULL, 21934),
(21935, '3.30.260.10-FF-000050', NULL, 'Mitochondrial chaperone TCM62', 36, NULL, NULL, 21935),
(21936, '2.60.40.10-FF-005211', NULL, NULL, 139, NULL, NULL, 21936),
(21937, '3.30.40.10-FF-001814', NULL, 'Uncharacterized protein', 92, NULL, NULL, 21937),
(21938, '1.10.472.80-FF-000187', NULL, NULL, 132, NULL, NULL, 21938),
(21939, '2.130.10.10-FF-005756', NULL, 'Uncharacterized protein', 116, NULL, NULL, 21939),
(21940, '2.60.40.10-FF-003070', NULL, 'Protein sax-3', 108, NULL, NULL, 21940),
(21941, '3.40.50.300-FF-002721', NULL, 'Calcium Channel, Beta subunit', 192, NULL, NULL, 21941),
(21942, '3.30.420.40-FF-000470', NULL, 'Heat shock protein 70 putative', 183, NULL, NULL, 21942),
(21943, '1.20.1250.20-FF-000948', NULL, 'Sugar phosphate permease', 201, NULL, NULL, 21943),
(21944, '2.30.130.40-FF-000036', NULL, 'Protein cereblon', 129, NULL, NULL, 21944),
(21945, '3.40.50.1240-FF-000124', NULL, 'Phosphoglycerate mutase family protein', 216, NULL, NULL, 21945),
(21946, '2.120.10.30-FF-000159', NULL, 'Nhl repeat-containing protein', 205, NULL, NULL, 21946),
(21947, '3.30.413.10-FF-000001', NULL, '4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase (flavodoxin)', 101, NULL, NULL, 21947),
(21948, '3.40.50.10810-FF-000089', NULL, 'DNA repair protein RAD5B', 240, NULL, NULL, 21948),
(21949, '1.20.1250.20-FF-001196', NULL, 'Signal transducer', 190, NULL, NULL, 21949),
(21950, '1.25.40.280-FF-000014', NULL, 'Rim20p', 337, NULL, NULL, 21950),
(21951, '3.30.160.60-FF-002563', NULL, 'Zinc finger protein 296', 24, NULL, NULL, 21951),
(21952, '3.20.20.80-FF-000137', NULL, 'inactive heparanase-2 isoform X3', 193, NULL, NULL, 21952),
(21953, '3.30.450.40-FF-000067', NULL, 'Phosphodiesterase', 187, NULL, NULL, 21953); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(21954, '3.30.420.510-FF-000015', NULL, 'Pantothenate kinase, putative', 143, NULL, NULL, 21954),
(21955, '3.50.40.10-FF-000009', NULL, 'Phenylalanine--tRNA ligase beta subunit', 213, NULL, NULL, 21955),
(21956, '3.40.50.2000-FF-000611', NULL, 'UDP-glucuronosyltransferase', 205, NULL, NULL, 21956),
(21957, '3.30.420.10-FF-000034', NULL, '3''-5'' exoribonuclease 1', 225, NULL, NULL, 21957),
(21958, '2.60.40.840-FF-000008', NULL, 'Arrestin beta 2', 126, NULL, NULL, 21958),
(21959, '3.40.50.2300-FF-001196', NULL, NULL, 208, NULL, NULL, 21959),
(21960, '3.50.50.60-FF-000379', NULL, 'Mercuric reductase', 121, NULL, NULL, 21960),
(21961, '1.10.3720.10-FF-000080', NULL, 'Amino acid ABC transporter, permease protein', 245, NULL, NULL, 21961),
(21962, '2.60.40.150-FF-000116', NULL, 'Phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit alpha', 162, NULL, NULL, 21962),
(21963, '3.30.160.60-FF-000326', NULL, 'Zinc finger protein 521', 86, NULL, NULL, 21963),
(21964, '2.130.10.10-FF-004132', NULL, 'Uncharacterized protein', 184, NULL, NULL, 21964),
(21965, '2.30.30.40-FF-000297', NULL, 'CheA signal transduction histidine kinase', 63, NULL, NULL, 21965),
(21966, '3.30.1330.90-FF-000022', NULL, 'D-3-phosphoglycerate dehydrogenase', 167, NULL, NULL, 21966),
(21967, '2.30.42.10-FF-000630', NULL, NULL, 73, NULL, NULL, 21967),
(21968, '1.25.40.10-FF-002905', NULL, 'Tetratricopeptide repeat domain 25', 194, NULL, NULL, 21968),
(21969, '3.90.550.10-FF-000305', NULL, 'Putative glycosyltransferase WbgO', 238, NULL, NULL, 21969),
(21970, '3.40.50.300-FF-004750', NULL, 'Uncharacterized protein', 164, NULL, NULL, 21970),
(21971, '1.20.1640.10-FF-000059', NULL, 'PaTched Related family', 208, NULL, NULL, 21971),
(21972, '2.60.120.1190-FF-000009', NULL, 'Tyrosine-protein kinase Abl-like Protein', 182, NULL, NULL, 21972),
(21973, '1.20.58.60-FF-000324', NULL, 'SMAll', 307, NULL, NULL, 21973),
(21974, '2.30.29.30-FF-000324', NULL, 'Phosphoinositide-dependent kinase 1, isoform F', 134, NULL, NULL, 21974),
(21975, '1.20.1250.20-FF-001567', NULL, 'MFS transporter, putative (AFU_orthologue AFUA_5G00430)', 387, NULL, NULL, 21975),
(21976, '3.40.630.10-FF-000374', NULL, 'Uncharacterized protein', 112, NULL, NULL, 21976),
(21977, '3.60.21.10-FF-000342', NULL, 'Alkaline phosphatase', 367, NULL, NULL, 21977),
(21978, '3.40.50.720-FF-001655', NULL, 'Enoyl-CoA hydratase', 186, NULL, NULL, 21978),
(21979, '2.130.10.10-FF-000080', NULL, 'WD repeat-containing protein 37', 135, NULL, NULL, 21979),
(21980, '1.20.1310.10-FF-000080', NULL, 'Cullin family protein', 109, NULL, NULL, 21980),
(21981, '1.20.1070.10-FF-000381', NULL, 'DOPamine receptor', 150, NULL, NULL, 21981),
(21982, '2.40.160.50-FF-000010', NULL, 'Heme utilization protein', 365, NULL, NULL, 21982),
(21983, '2.40.100.10-FF-000028', NULL, 'Peptidyl-prolyl cis-trans isomerase', 171, NULL, NULL, 21983),
(21984, '1.10.287.100-FF-000004', NULL, 'Uncharacterized protein', 53, NULL, NULL, 21984),
(21985, '1.10.540.10-FF-000044', NULL, 'Acyl-CoA dehydrogenase NM domain-like protein', 152, NULL, NULL, 21985),
(21986, '3.40.47.10-FF-000239', NULL, NULL, 54, NULL, NULL, 21986),
(21987, '1.25.40.20-FF-000761', NULL, 'RFXANK isoform 10', 115, NULL, NULL, 21987),
(21988, '3.30.70.330-FF-000275', NULL, 'oligouridylate-binding protein 1B-like isoform X2', 136, NULL, NULL, 21988),
(21989, '3.80.10.10-FF-004306', NULL, 'Uncharacterized protein', 216, NULL, NULL, 21989),
(21990, '3.30.70.330-FF-002641', NULL, NULL, 121, NULL, NULL, 21990),
(21991, '3.40.30.10-FF-001105', NULL, 'Uncharacterized protein', 48, NULL, NULL, 21991),
(21992, '2.40.70.10-FF-000104', NULL, 'Uncharacterized protein', 179, NULL, NULL, 21992),
(21993, '3.40.50.300-FF-000355', NULL, 'Heterogeneous nuclear ribonucleoprotein U-like 1, isoform CRA_a', 174, NULL, NULL, 21993),
(21994, '1.25.40.10-FF-002894', NULL, 'Uncharacterized protein', 211, NULL, NULL, 21994),
(21995, '1.10.8.270-FF-000085', NULL, 'Uncharacterized protein', 109, NULL, NULL, 21995),
(21996, '2.30.30.40-FF-000173', NULL, 'E3 ubiquitin-protein ligase SH3RF2 isoform X1', 65, NULL, NULL, 21996);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(21997, '3.30.70.270-FF-000133', NULL, 'Diguanylate cyclase (GGDEF) domain protein', 180, NULL, NULL, 21997),
(21998, '3.30.497.10-FF-000003', NULL, 'Serpin family F member 1', 207, NULL, NULL, 21998),
(21999, '3.90.190.10-FF-000305', NULL, 'Predicted protein', 291, NULL, NULL, 21999),
(22000, '2.130.10.10-FF-004227', NULL, 'Uncharacterized protein', 146, NULL, NULL, 22000),
(22001, '3.30.70.330-FF-001005', NULL, 'Uncharacterized protein', 96, NULL, NULL, 22001),
(22002, '3.30.230.10-FF-000328', NULL, 'Uncharacterized protein', 89, NULL, NULL, 22002),
(22003, '3.40.50.150-FF-001698', NULL, NULL, 83, NULL, NULL, 22003),
(22004, '3.30.230.130-FF-000015', NULL, 'Cullin-like protein', 98, NULL, NULL, 22004),
(22005, '3.20.180.20-FF-000020', NULL, 'Dynein heavy chain', 109, NULL, NULL, 22005),
(22006, '2.40.50.100-FF-000158', NULL, 'Ribosomal RNA processing protein 4', 73, NULL, NULL, 22006),
(22007, '3.40.1110.10-FF-000204', NULL, NULL, 67, NULL, NULL, 22007),
(22008, '2.40.30.10-FF-000085', NULL, 'Elongation factor Tu', 128, NULL, NULL, 22008),
(22009, '2.130.10.10-FF-000973', NULL, 'G-beta repeat protein, putative', 363, NULL, NULL, 22009),
(22010, '3.20.20.80-FF-000031', NULL, 'Glycogen debranching enzyme', 439, NULL, NULL, 22010),
(22011, '3.40.50.150-FF-001001', NULL, NULL, 208, NULL, NULL, 22011),
(22012, '1.25.40.20-FF-000885', NULL, 'Uncharacterized protein', 189, NULL, NULL, 22012),
(22013, '3.90.79.10-FF-000029', NULL, 'Mutator mutT protein', 151, NULL, NULL, 22013),
(22014, '2.160.20.10-FF-000326', NULL, 'Uncharacterized protein', 149, NULL, NULL, 22014),
(22015, '3.80.10.10-FF-001777', NULL, 'F-box/LRR-repeat protein 20-like Protein', 152, NULL, NULL, 22015),
(22016, '2.40.50.90-FF-000065', NULL, 'tudor and KH domain-containing protein', 128, NULL, NULL, 22016),
(22017, '2.30.29.30-FF-001055', NULL, 'Uncharacterized protein', 87, NULL, NULL, 22017),
(22018, '2.60.40.180-FF-000001', NULL, '5-hydroxyisourate hydrolase', 114, NULL, NULL, 22018),
(22019, '3.40.309.10-FF-000133', NULL, 'Aldehyde dehydrogenase3', 81, NULL, NULL, 22019),
(22020, '3.70.10.10-FF-000018', NULL, 'Checkpoint protein', 278, NULL, NULL, 22020),
(22021, '4.10.1030.10-FF-000007', NULL, 'Uncharacterized protein', 48, NULL, NULL, 22021),
(22022, '3.30.70.1230-FF-000197', NULL, 'Predicted protein', 84, NULL, NULL, 22022),
(22023, '3.40.50.720-FF-002274', NULL, 'D-2-hydroxy-acid dehydrogenase-like', 25, NULL, NULL, 22023),
(22024, '1.10.560.10-FF-000152', NULL, 'Uncharacterized protein', 138, NULL, NULL, 22024),
(22025, '3.30.429.10-FF-000003', NULL, 'D-dopachrome decarboxylase', 117, NULL, NULL, 22025),
(22026, '3.40.50.970-FF-000078', NULL, 'Sulfite reductase (NADPH) hemoprotein, beta-component', 246, NULL, NULL, 22026),
(22027, '3.30.565.10-FF-000280', NULL, 'Phosphate regulon, two-component sensor histidine kinase', 162, NULL, NULL, 22027),
(22028, '2.60.40.10-FF-000208', NULL, 'Butyrophilin subfamily 1 member A1', 122, NULL, NULL, 22028),
(22029, '3.10.20.310-FF-000027', NULL, 'Outer membrane protein assembly factor BamA', 82, NULL, NULL, 22029),
(22030, '3.30.50.10-FF-000011', NULL, 'Thyroid hormone receptor beta isoform', 99, NULL, NULL, 22030),
(22031, '1.25.40.10-FF-004131', NULL, 'Uncharacterized protein', 121, NULL, NULL, 22031),
(22032, '1.10.1660.10-FF-000018', NULL, 'Cu(I)-responsive transcriptional regulator', 125, NULL, NULL, 22032),
(22033, '2.130.10.10-FF-001810', NULL, 'Putative katanin', 126, NULL, NULL, 22033),
(22034, '2.60.120.1000-FF-000009', NULL, 'Axotactin, isoform B', 202, NULL, NULL, 22034),
(22035, '2.10.110.10-FF-000249', NULL, 'LIM domain transcription factor LMO4-like Protein', 77, NULL, NULL, 22035),
(22036, '2.60.120.260-FF-000012', NULL, 'F-box only protein 2', 184, NULL, NULL, 22036),
(22037, '2.40.70.10-FF-000559', NULL, NULL, 157, NULL, NULL, 22037),
(22038, '3.40.50.300-FF-002384', NULL, 'Endonuclease MutS2', 263, NULL, NULL, 22038),
(22039, '1.20.120.1900-FF-000004', NULL, 'gamma-tubulin complex component 6 isoform X1', 301, NULL, NULL, 22039),
(22040, '3.40.30.10-FF-000824', NULL, 'Glrx-3', 121, NULL, NULL, 22040);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(22041, '1.20.1270.60-FF-000023', NULL, 'Interacting with PRKCA', 209, NULL, NULL, 22041),
(22042, '3.40.50.300-FF-003002', NULL, 'Cytidylate kinase', 211, NULL, NULL, 22042),
(22043, '3.40.50.1820-FF-001383', NULL, 'NDRG family member 4', 221, NULL, NULL, 22043),
(22044, '3.40.50.300-FF-002608', NULL, 'Small GTP-binding protein, putative', 175, NULL, NULL, 22044),
(22045, '3.30.160.780-FF-000002', NULL, 'Envoplakin b', 112, NULL, NULL, 22045),
(22046, '3.80.10.10-FF-002272', NULL, 'Leucine-rich repeat-containing protein ODA7', 96, NULL, NULL, 22046),
(22047, '1.10.357.10-FF-000039', NULL, 'TetR family transcriptional regulator', 125, NULL, NULL, 22047),
(22048, '1.10.287.940-FF-000020', NULL, 'P2X purinoceptor', 30, NULL, NULL, 22048),
(22049, '3.10.100.10-FF-000306', NULL, NULL, 157, NULL, NULL, 22049),
(22050, '3.30.70.330-FF-000387', NULL, 'RNA binding motif protein 19', 101, NULL, NULL, 22050),
(22051, '3.30.1010.10-FF-000098', NULL, 'Uncharacterized protein', 141, NULL, NULL, 22051),
(22052, '3.40.50.1240-FF-000012', NULL, 'Phosphoglycerate mutase 1', 250, NULL, NULL, 22052),
(22053, '2.130.10.120-FF-000016', NULL, 'Dipeptidyl aminopeptidase BI', 348, NULL, NULL, 22053),
(22054, '2.60.40.10-FF-000197', NULL, 'Myomesin 1', 106, NULL, NULL, 22054),
(22055, '2.60.40.10-FF-003766', NULL, NULL, 61, NULL, NULL, 22055),
(22056, '1.10.510.10-FF-003982', NULL, NULL, 328, NULL, NULL, 22056),
(22057, '1.25.40.10-FF-001500', NULL, 'Pentatricopeptide repeat (PPR-like) superfamily protein', 75, NULL, NULL, 22057),
(22058, '1.25.40.10-FF-004934', NULL, 'RNA polymerase II transcription elongation factor (Ctr9), putative (AFU_orthologue AFUA_5G05870)', 207, NULL, NULL, 22058),
(22059, '1.10.3180.10-FF-000004', NULL, 'Os07g0272500 protein', 133, NULL, NULL, 22059),
(22060, '1.10.940.10-FF-000018', NULL, 'Transcription antitermination protein NusB', 142, NULL, NULL, 22060),
(22061, '1.10.8.60-FF-000539', NULL, 'Uncharacterized protein', 64, NULL, NULL, 22061),
(22062, '1.10.101.10-FF-000030', NULL, 'Lytic murein transglycosylase B', 59, NULL, NULL, 22062),
(22063, '1.20.80.10-FF-000052', NULL, 'Acyl-CoA-binding domain 3', 107, NULL, NULL, 22063),
(22064, '1.10.10.10-FF-000520', NULL, 'RNA polymerase sigma factor sigA-like', 52, NULL, NULL, 22064),
(22065, '1.20.930.80-FF-000019', NULL, 'Uncharacterized protein', 157, NULL, NULL, 22065),
(22066, '3.30.2010.10-FF-000008', NULL, 'Protease HtpX homolog', 91, NULL, NULL, 22066),
(22067, '3.90.1140.10-FF-000060', NULL, 'Uncharacterized protein', 67, NULL, NULL, 22067),
(22068, '3.30.160.60-FF-003182', NULL, 'Zinc finger protein 682', 34, NULL, NULL, 22068),
(22069, '3.30.160.60-FF-006374', NULL, NULL, 78, NULL, NULL, 22069),
(22070, '1.25.10.10-FF-000357', NULL, 'Kinesin-like protein', 277, NULL, NULL, 22070),
(22071, '1.20.5.110-FF-000265', NULL, 'Culmination specific protein 37D', 80, NULL, NULL, 22071),
(22072, '3.30.470.20-FF-000074', NULL, 'D-alanine--D-alanine ligase', 139, NULL, NULL, 22072),
(22073, '1.20.1070.10-FF-000049', NULL, 'G-protein coupled receptor 87', 307, NULL, NULL, 22073),
(22074, '1.10.510.10-FF-001964', NULL, 'Uncharacterized protein', 205, NULL, NULL, 22074),
(22075, '3.90.76.10-FF-000006', NULL, 'Monoacyl phosphatidylinositol tetramannoside-binding protein', 113, NULL, NULL, 22075),
(22076, '3.90.1150.10-FF-000145', NULL, 'Class V aminotransferase', 117, NULL, NULL, 22076),
(22077, '3.40.50.300-FF-006436', NULL, 'Predicted protein', 127, NULL, NULL, 22077),
(22078, '2.60.120.260-FF-000467', NULL, 'EPH receptor B4', 103, NULL, NULL, 22078),
(22079, '2.20.70.10-FF-000150', NULL, 'E3 ubiquitin-protein ligase hecw-1', 38, NULL, NULL, 22079),
(22080, '1.25.40.10-FF-000185', NULL, 'NRDE-2, necessary for RNA interference, domain-containing', 196, NULL, NULL, 22080),
(22081, '3.10.20.90-FF-000899', NULL, 'Uncharacterized protein', 132, NULL, NULL, 22081),
(22082, '3.30.70.330-FF-001909', NULL, NULL, 73, NULL, NULL, 22082),
(22083, '2.130.10.10-FF-004683', NULL, 'Uncharacterized protein', 180, NULL, NULL, 22083),
(22084, '3.10.20.90-FF-000669', NULL, 'Uncharacterized protein', 77, NULL, NULL, 22084);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(22085, '3.90.180.10-FF-000136', NULL, 'Alcohol dehydrogenase, putative (AFU_orthologue AFUA_2G04590)', 127, NULL, NULL, 22085),
(22086, '3.10.590.10-FF-000011', NULL, 'thymocyte nuclear protein 1 isoform X3', 116, NULL, NULL, 22086),
(22087, '1.10.275.40-FF-000020', NULL, 'Helicase, putative', 149, NULL, NULL, 22087),
(22088, '3.40.50.300-FF-008336', NULL, 'ATP-dependent DNA helicase', 76, NULL, NULL, 22088),
(22089, '1.20.1250.20-FF-001775', NULL, 'Major facilitator superfamily transporter', 187, NULL, NULL, 22089),
(22090, '1.20.1250.20-FF-002281', NULL, 'Uncharacterized protein', 88, NULL, NULL, 22090),
(22091, '1.10.3210.10-FF-000119', NULL, 'Uncharacterized protein', 68, NULL, NULL, 22091),
(22092, '1.10.390.10-FF-000094', NULL, 'Uncharacterized protein', 113, NULL, NULL, 22092),
(22093, '3.40.50.1820-FF-000214', NULL, 'Toxin biosynthesis protein, putative', 354, NULL, NULL, 22093),
(22094, '1.25.10.10-FF-002049', NULL, 'Translational activator GCN1', 297, NULL, NULL, 22094),
(22095, '3.40.50.10490-FF-000043', NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', 144, NULL, NULL, 22095),
(22096, '4.10.410.10-FF-000091', NULL, 'Serine protease inhibitor, putative', 79, NULL, NULL, 22096),
(22097, '2.130.10.10-FF-001602', NULL, 'Eukaryotic translation initiation factor 2A, putative', 193, NULL, NULL, 22097),
(22098, '3.40.50.620-FF-000445', NULL, 'Probable FAD synthase', 236, NULL, NULL, 22098),
(22099, '1.20.85.10-FF-000012', NULL, 'Uncharacterized protein', 86, NULL, NULL, 22099),
(22100, '3.40.1110.10-FF-000339', NULL, NULL, 156, NULL, NULL, 22100),
(22101, '2.40.50.140-FF-000390', NULL, 'Single-stranded DNA-binding protein', 111, NULL, NULL, 22101),
(22102, '3.80.10.10-FF-001569', NULL, 'Toll-9, isoform A', 252, NULL, NULL, 22102),
(22103, '3.30.540.10-FF-000077', NULL, 'Inositol-1-monophosphatase', 156, NULL, NULL, 22103),
(22104, '3.30.40.10-FF-001011', NULL, 'PINEAPPLE EYE', 120, NULL, NULL, 22104),
(22105, '1.10.287.90-FF-000006', NULL, 'Cytochrome c oxidase subunit 2', 91, NULL, NULL, 22105),
(22106, '1.10.287.130-FF-000002', NULL, 'Two-component osmosensing histidine kinase', 80, NULL, NULL, 22106),
(22107, '3.40.50.300-FF-000810', NULL, 'probable helicase senataxin', 205, NULL, NULL, 22107),
(22108, '1.10.1370.30-FF-000018', NULL, 'Angiotensin-converting enzyme', 250, NULL, NULL, 22108),
(22109, '2.40.180.10-FF-000039', NULL, 'Uncharacterized protein', 123, NULL, NULL, 22109),
(22110, '1.25.10.10-FF-003342', NULL, 'Uncharacterized protein', 228, NULL, NULL, 22110),
(22111, '3.30.70.2470-FF-000001', NULL, 'receptor-type tyrosine-protein phosphatase-like N isoform X1', 96, NULL, NULL, 22111),
(22112, '2.160.20.10-FF-000118', NULL, 'Pectinesterase', 319, NULL, NULL, 22112),
(22113, '3.40.190.290-FF-000050', NULL, 'LysR family transcriptional regulator', 191, NULL, NULL, 22113),
(22114, '1.20.1690.10-FF-000006', NULL, 'V-type proton ATPase subunit', 113, NULL, NULL, 22114),
(22115, '3.20.20.70-FF-000359', NULL, 'Radical SAM domain protein', 298, NULL, NULL, 22115),
(22116, '3.40.50.80-FF-000138', NULL, 'Metalloreductase Fre8', 175, NULL, NULL, 22116),
(22117, '1.20.140.10-FF-000011', NULL, 'Medium-chain specific acyl-CoA dehydrogenase, mitochondrial', 147, NULL, NULL, 22117),
(22118, '3.30.1330.60-FF-000024', NULL, 'Peptidoglycan-associated protein', 135, NULL, NULL, 22118),
(22119, '1.10.510.10-FF-003201', NULL, NULL, 146, NULL, NULL, 22119),
(22120, '1.10.1040.10-FF-000050', NULL, 'Probable 3-hydroxyisobutyrate dehydrogenase-like 1, mitochondrial', 130, NULL, NULL, 22120),
(22121, '2.30.29.30-FF-000335', NULL, 'Pleckstrin homology domain-containing family H member 2', 127, NULL, NULL, 22121),
(22122, '1.25.40.1040-FF-000014', NULL, 'N-alpha-acetyltransferase 15, NatA auxiliary subunit, putative', 195, NULL, NULL, 22122),
(22123, '3.20.20.300-FF-000084', NULL, NULL, 115, NULL, NULL, 22123),
(22124, '1.20.1250.20-FF-000252', NULL, 'Quinolone resistance protein NorB', 201, NULL, NULL, 22124),
(22125, '3.40.50.300-FF-006195', NULL, 'Uncharacterized protein', 80, NULL, NULL, 22125);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(22126, '1.20.1090.10-FF-000051', NULL, 'Uncharacterized protein', 103, NULL, NULL, 22126),
(22127, '3.40.50.620-FF-000788', NULL, 'Uncharacterized protein', 67, NULL, NULL, 22127),
(22128, '1.10.443.10-FF-000003', NULL, 'Type 1 fimbriae regulatory protein FimE', 190, NULL, NULL, 22128),
(22129, '3.40.50.2000-FF-000931', NULL, 'ADP-heptose--lipopolysaccharide heptosyltransferase, putative', 153, NULL, NULL, 22129),
(22130, '3.40.50.300-FF-000708', NULL, 'ATP-dependent RNA helicase DDX1', 202, NULL, NULL, 22130),
(22131, '1.20.1160.11-FF-000029', NULL, NULL, 34, NULL, NULL, 22131),
(22132, '1.10.10.10-FF-000177', NULL, 'Transcription initiation factor IIE subunit beta', 82, NULL, NULL, 22132),
(22133, '1.10.510.10-FF-002925', NULL, NULL, 154, NULL, NULL, 22133),
(22134, '3.40.630.10-FF-000031', NULL, 'cytosol aminopeptidase', 315, NULL, NULL, 22134),
(22135, '2.60.40.60-FF-000526', NULL, 'Dachsous cadherin-related 1a', 111, NULL, NULL, 22135),
(22136, '1.25.40.10-FF-000640', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 107, NULL, NULL, 22136),
(22137, '1.10.1170.10-FF-000054', NULL, 'Uncharacterized protein', 70, NULL, NULL, 22137),
(22138, '3.80.10.10-FF-001653', NULL, 'Receptor-like protein kinase HSL1', 112, NULL, NULL, 22138),
(22139, '2.60.40.420-FF-000118', NULL, 'Cupredoxin superfamily protein', 98, NULL, NULL, 22139),
(22140, '2.40.30.10-FF-000326', NULL, 'NADPH--cytochrome P450 reductase', 107, NULL, NULL, 22140),
(22141, '3.90.25.10-FF-000080', NULL, 'Uncharacterized protein', 99, NULL, NULL, 22141),
(22142, '3.30.40.10-FF-000393', NULL, 'CLUMA_CG014158, isoform A', 63, NULL, NULL, 22142),
(22143, '3.30.160.60-FF-003283', NULL, NULL, 30, NULL, NULL, 22143),
(22144, '2.130.10.10-FF-000984', NULL, 'WD repeat-containing protein 48 homolog', 249, NULL, NULL, 22144),
(22145, '1.10.10.60-FF-000973', NULL, NULL, 38, NULL, NULL, 22145),
(22146, '1.10.274.100-FF-000006', NULL, 'DNA-directed RNA polymerase subunit', 167, NULL, NULL, 22146),
(22147, '1.20.58.400-FF-000014', NULL, 'Uncharacterized protein', 95, NULL, NULL, 22147),
(22148, '2.120.10.30-FF-000597', NULL, 'Uncharacterized protein', 90, NULL, NULL, 22148),
(22149, '3.30.160.60-FF-000877', NULL, 'zinc finger protein 599', 26, NULL, NULL, 22149),
(22150, '3.90.1290.10-FF-000059', NULL, 'Uncharacterized protein', 209, NULL, NULL, 22150),
(22151, '3.30.40.10-FF-000073', NULL, 'myotubularin-related protein 4 isoform X2', 79, NULL, NULL, 22151),
(22152, '1.25.10.10-FF-000149', NULL, 'Serine/threonine-protein kinase ATR', 179, NULL, NULL, 22152),
(22153, '3.30.1640.10-FF-000027', NULL, 'DNA helicase', 121, NULL, NULL, 22153),
(22154, '1.20.1070.10-FF-001909', NULL, 'Predicted protein', 336, NULL, NULL, 22154),
(22155, '2.60.40.10-FF-000540', NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein', 92, NULL, NULL, 22155),
(22156, '1.10.287.70-FF-000686', NULL, 'Glutamate receptor ionotropic N-methyl D-aspartate 1 b', 82, NULL, NULL, 22156),
(22157, '1.25.40.180-FF-000214', NULL, NULL, 169, NULL, NULL, 22157),
(22158, '1.25.40.20-FF-001149', NULL, 'Predicted protein', 142, NULL, NULL, 22158),
(22159, '3.30.160.60-FF-001153', NULL, 'Uncharacterized protein', 29, NULL, NULL, 22159),
(22160, '3.30.70.20-FF-000111', NULL, NULL, 72, NULL, NULL, 22160),
(22161, '3.60.150.10-FF-000006', NULL, 'Chorismate synthase', 269, NULL, NULL, 22161),
(22162, '3.40.140.10-FF-000044', NULL, 'Apolipoprotein B mRNA editing enzyme catalytic subunit 3B', 187, NULL, NULL, 22162),
(22163, '2.40.160.10-FF-000026', NULL, 'Voltage-dependent anion-selective channel protein 2', 189, NULL, NULL, 22163),
(22164, '3.40.1000.10-FF-000005', NULL, 'Oxygen-evolving enhancer protein 2', 186, NULL, NULL, 22164),
(22165, '1.20.120.1750-FF-000144', NULL, 'RBR-type E3 ubiquitin transferase', 118, NULL, NULL, 22165),
(22166, '3.30.420.40-FF-000594', NULL, 'Heat shock protein 70 homolog LHS1, putative', 100, NULL, NULL, 22166),
(22167, '2.10.25.10-FF-000838', NULL, 'Latent transforming growth factor beta binding protein 3', 41, NULL, NULL, 22167);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(22168, '3.60.40.10-FF-000150', NULL, 'Uncharacterized protein', 103, NULL, NULL, 22168),
(22169, '3.30.70.2460-FF-000009', NULL, NULL, 75, NULL, NULL, 22169),
(22170, '2.30.30.30-FF-000052', NULL, '50S ribosomal protein L24', 106, NULL, NULL, 22170),
(22171, '3.75.10.10-FF-000042', NULL, NULL, 77, NULL, NULL, 22171),
(22172, '2.60.40.790-FF-000173', NULL, NULL, 133, NULL, NULL, 22172),
(22173, '1.10.1600.10-FF-000008', NULL, 'ATP-dependent DNA helicase II subunit 2', 98, NULL, NULL, 22173),
(22174, '1.20.1250.20-FF-000813', NULL, 'Solute carrier family 15 member 4', 530, NULL, NULL, 22174),
(22175, '2.10.25.10-FF-001468', NULL, 'Delta-like protein', 39, NULL, NULL, 22175),
(22176, '1.20.1560.10-FF-000800', NULL, 'AGAP004600-PA', 199, NULL, NULL, 22176),
(22177, '3.30.160.60-FF-005205', NULL, NULL, 28, NULL, NULL, 22177),
(22178, '3.40.50.300-FF-001327', NULL, 'DNA helicase', 335, NULL, NULL, 22178),
(22179, '1.25.40.10-FF-003754', NULL, 'Uncharacterized protein', 266, NULL, NULL, 22179),
(22180, '1.10.238.10-FF-000616', NULL, 'Fimbrin', 99, NULL, NULL, 22180),
(22181, '3.30.160.60-FF-004463', NULL, NULL, 31, NULL, NULL, 22181),
(22182, '3.40.50.150-FF-000973', NULL, 'Uncharacterized protein', 225, NULL, NULL, 22182),
(22183, '3.10.580.10-FF-000185', NULL, 'Predicted protein', 118, NULL, NULL, 22183),
(22184, '3.90.20.20-FF-000010', NULL, 'Protein GrpE', 102, NULL, NULL, 22184),
(22185, '1.25.10.10-FF-000251', NULL, 'AP-3 complex subunit delta', 579, NULL, NULL, 22185),
(22186, '2.130.10.10-FF-001945', NULL, 'GD25070', 333, NULL, NULL, 22186),
(22187, '3.40.50.720-FF-002515', NULL, 'Calcium-gated potassium channel MthK', 124, NULL, NULL, 22187),
(22188, '2.60.120.970-FF-000028', NULL, 'Inhibin subunit beta C', 233, NULL, NULL, 22188),
(22189, '1.10.1300.10-FF-000082', NULL, 'Uncharacterized protein', 341, NULL, NULL, 22189),
(22190, '1.20.58.830-FF-000025', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 140, NULL, NULL, 22190),
(22191, '1.10.40.30-FF-000011', NULL, 'Adenylosuccinate lyase', 66, NULL, NULL, 22191),
(22192, '3.90.70.10-FF-000398', NULL, 'Ubiquitin carboxyl-terminal hydrolase, putative', 226, NULL, NULL, 22192),
(22193, '3.40.50.300-FF-007156', NULL, 'ABC transporter family protein', 175, NULL, NULL, 22193),
(22194, '1.10.10.2660-FF-000018', NULL, 'Uncharacterized protein', 137, NULL, NULL, 22194),
(22195, '3.30.590.10-FF-000012', NULL, 'Glutamate-ammonia ligase', 324, NULL, NULL, 22195),
(22196, '3.40.50.12190-FF-000002', NULL, 'Uncharacterized protein', 160, NULL, NULL, 22196),
(22197, '2.160.10.10-FF-000033', NULL, 'Eukaryotic translation initiation factor 2B subunit epsilon', 125, NULL, NULL, 22197),
(22198, '3.90.80.10-FF-000016', NULL, 'Inorganic pyrophosphatase', 208, NULL, NULL, 22198),
(22199, '3.80.10.10-FF-003025', NULL, 'Predicted protein', 139, NULL, NULL, 22199),
(22200, '3.30.200.20-FF-000717', NULL, 'AGC protein kinase', 88, NULL, NULL, 22200),
(22201, '1.25.40.20-FF-001262', NULL, 'Zgc:113279', 206, NULL, NULL, 22201),
(22202, '1.20.1560.10-FF-000137', NULL, 'Putative ABC transporter, (TAP family)', 352, NULL, NULL, 22202),
(22203, '3.50.50.60-FF-000273', NULL, 'Gamma-glutamylputrescine oxidoreductase', 203, NULL, NULL, 22203),
(22204, '1.10.510.10-FF-000536', NULL, 'Cyclin-dependent kinase WEE1', 175, NULL, NULL, 22204),
(22205, '2.60.40.10-FF-006048', NULL, NULL, 79, NULL, NULL, 22205),
(22206, '2.60.40.60-FF-000982', NULL, 'Uncharacterized protein', 99, NULL, NULL, 22206),
(22207, '3.30.1680.10-FF-000024', NULL, 'semaphorin-2A isoform X1', 46, NULL, NULL, 22207),
(22208, '2.130.10.10-FF-002221', NULL, 'regulatory-associated protein of mTOR-like isoform X1', 166, NULL, NULL, 22208),
(22209, '1.20.120.350-FF-000173', NULL, NULL, 157, NULL, NULL, 22209),
(22210, '2.60.40.10-FF-005109', NULL, NULL, 125, NULL, NULL, 22210),
(22211, '3.40.50.10420-FF-000062', NULL, 'Predicted gene 29094', 89, NULL, NULL, 22211),
(22212, '2.60.34.10-FF-000031', NULL, 'Heat shock 70 kDa protein 14', 206, NULL, NULL, 22212),
(22213, '1.25.40.10-FF-004030', NULL, 'Uncharacterized protein', 184, NULL, NULL, 22213);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(22214, '2.10.25.10-FF-001344', NULL, 'Fibulin-1', 42, NULL, NULL, 22214),
(22215, '3.40.50.880-FF-000040', NULL, 'Gamma-glutamyl peptidase 5', 227, NULL, NULL, 22215),
(22216, '1.10.472.130-FF-000019', NULL, 'Dynein heavy chain at 36C', 179, NULL, NULL, 22216),
(22217, '1.10.510.10-FF-004027', NULL, NULL, 109, NULL, NULL, 22217),
(22218, '3.40.30.10-FF-000588', NULL, 'Uncharacterized protein', 78, NULL, NULL, 22218),
(22219, '3.30.46.10-FF-000001', NULL, 'Glycine N-methyltransferase', 83, NULL, NULL, 22219),
(22220, '2.30.40.10-FF-000131', NULL, 'Guanine deaminase', 120, NULL, NULL, 22220),
(22221, '2.60.40.10-FF-002794', NULL, 'Uncharacterized protein', 114, NULL, NULL, 22221),
(22222, '3.40.50.300-FF-002485', NULL, 'T0136454 isoform 2', 150, NULL, NULL, 22222),
(22223, '3.40.50.150-FF-001810', NULL, NULL, 111, NULL, NULL, 22223),
(22224, '3.80.10.10-FF-004183', NULL, 'Uncharacterized protein', 96, NULL, NULL, 22224),
(22225, '3.40.190.10-FF-000322', NULL, 'Porphobilinogen deaminase', 100, NULL, NULL, 22225),
(22226, '3.30.860.10-FF-000005', NULL, 'Putative ribosomal protein S19/S15', 49, NULL, NULL, 22226),
(22227, '2.10.25.10-FF-001687', NULL, 'Predicted protein', 66, NULL, NULL, 22227),
(22228, '3.60.21.10-FF-000448', NULL, 'Serine/threonine-protein phosphatase', 193, NULL, NULL, 22228),
(22229, '3.30.230.130-FF-000026', NULL, 'Cullin-1, putative', 145, NULL, NULL, 22229),
(22230, '1.20.1740.10-FF-000123', NULL, 'Uncharacterized protein', 220, NULL, NULL, 22230),
(22231, '1.20.144.10-FF-000115', NULL, 'AGAP008666-PA', 209, NULL, NULL, 22231),
(22232, '1.20.1070.10-FF-002062', NULL, 'G protein-coupled receptor 33', 87, NULL, NULL, 22232),
(22233, '1.25.10.10-FF-000812', NULL, '26S proteasome non-ATPase regulatory subunit', 446, NULL, NULL, 22233),
(22234, '3.40.50.1000-FF-000277', NULL, 'Bifunctional polynucleotide phosphatase/kinase', 73, NULL, NULL, 22234),
(22235, '1.25.10.10-FF-003022', NULL, 'Uncharacterized protein', 324, NULL, NULL, 22235),
(22236, '1.20.58.60-FF-000223', NULL, 'Alpha spectrin, isoform C', 146, NULL, NULL, 22236),
(22237, '2.60.40.10-FF-002338', NULL, 'Sensory AXon guidance', 84, NULL, NULL, 22237),
(22238, '1.20.5.110-FF-000130', NULL, 'VAMP (Vesicle Associated Membrane Protein) homolog', 100, NULL, NULL, 22238),
(22239, '1.20.1260.140-FF-000013', NULL, NULL, 98, NULL, NULL, 22239),
(22240, '2.60.120.40-FF-000045', NULL, 'Cytosolic endo-beta-N-acetylglucosaminidase', 51, NULL, NULL, 22240),
(22241, '3.10.129.10-FF-000283', NULL, 'Uncharacterized protein', 162, NULL, NULL, 22241),
(22242, '2.10.55.10-FF-000003', NULL, 'MSP-A1 surface protease homolog', 68, NULL, NULL, 22242),
(22243, '3.30.160.750-FF-000004', NULL, 'S-adenosylmethionine decarboxylase proenzyme', 65, NULL, NULL, 22243),
(22244, '3.30.70.330-FF-000960', NULL, 'SRA stem-loop-interacting RNA-binding protein, mitochondrial', 110, NULL, NULL, 22244),
(22245, '2.40.50.770-FF-000005', NULL, 'Rmi1p', 144, NULL, NULL, 22245),
(22246, '3.40.50.300-FF-000012', NULL, 'Transitional endoplasmic reticulum ATPase', 167, NULL, NULL, 22246),
(22247, '2.30.30.380-FF-000055', NULL, 'Ubiquitin thioesterase zranb1-B', 52, NULL, NULL, 22247),
(22248, '1.20.1250.20-FF-001432', NULL, 'MFS transporter, putative', 139, NULL, NULL, 22248),
(22249, '2.60.40.10-FF-000438', NULL, 'CD276 antigen', 120, NULL, NULL, 22249),
(22250, '3.40.33.10-FF-000185', NULL, 'Uncharacterized protein', 65, NULL, NULL, 22250),
(22251, '2.60.120.1020-FF-000004', NULL, 'Uncharacterized protein', 176, NULL, NULL, 22251),
(22252, '2.30.30.40-FF-000398', NULL, 'Hematopoietic cell-specific Lyn substrate 1', 69, NULL, NULL, 22252),
(22253, '1.20.1250.20-FF-000139', NULL, 'Solute carrier family 40 protein', 410, NULL, NULL, 22253),
(22254, '1.10.287.110-FF-000108', NULL, 'DnaJ protein, putative', 108, NULL, NULL, 22254),
(22255, '3.40.50.1820-FF-000877', NULL, 'Uncharacterized protein', 231, NULL, NULL, 22255),
(22256, '3.30.230.10-FF-000222', NULL, 'DNA repair protein RadA', 157, NULL, NULL, 22256),
(22257, '1.20.1070.10-FF-001786', NULL, 'Uncharacterized protein', 325, NULL, NULL, 22257);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(22258, '3.30.70.330-FF-000628', NULL, 'RNA binding protein', 95, NULL, NULL, 22258),
(22259, '3.30.70.330-FF-000067', NULL, 'regulator of nonsense transcripts 3A isoform X2', 90, NULL, NULL, 22259),
(22260, '3.30.200.20-FF-001212', NULL, 'TANK binding kinase 1', 59, NULL, NULL, 22260),
(22261, '2.60.120.290-FF-000010', NULL, 'Neuropilin', 123, NULL, NULL, 22261),
(22262, '3.90.830.10-FF-000001', NULL, 'syntaxin-binding protein 1 isoform X2', 114, NULL, NULL, 22262),
(22263, '2.130.10.30-FF-000170', NULL, NULL, 323, NULL, NULL, 22263),
(22264, '2.120.10.80-FF-000022', NULL, 'Attractin like 1', 179, NULL, NULL, 22264),
(22265, '3.90.950.10-FF-000044', NULL, 'Probable inosine/xanthosine triphosphatase', 169, NULL, NULL, 22265),
(22266, '1.10.287.70-FF-000343', NULL, 'Uncharacterized protein', 103, NULL, NULL, 22266),
(22267, '1.10.1220.190-FF-000001', NULL, 'Protein virC2', 121, NULL, NULL, 22267),
(22268, '3.80.10.10-FF-002749', NULL, 'F-box and leucine-rich repeat protein 3', 105, NULL, NULL, 22268),
(22269, '3.30.830.10-FF-000065', NULL, 'Unplaced genomic scaffold supercont2.12, whole genome shotgun sequence', 253, NULL, NULL, 22269),
(22270, '1.25.40.10-FF-000983', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 121, NULL, NULL, 22270),
(22271, '3.30.200.20-FF-002185', NULL, 'Uncharacterized protein', 56, NULL, NULL, 22271),
(22272, '2.60.120.260-FF-000023', NULL, 'Ephrin type-A receptor 2', 181, NULL, NULL, 22272),
(22273, '2.40.70.10-FF-000082', NULL, 'Plasmepsin X', 242, NULL, NULL, 22273),
(22274, '1.20.1600.10-FF-000063', NULL, 'Putative outer membrane heavy metal efflux protein', 386, NULL, NULL, 22274),
(22275, '2.40.50.140-FF-000513', NULL, 'Putative_tRNA_binding_domain_containing_protein_-_putative', 108, NULL, NULL, 22275),
(22276, '1.20.80.10-FF-000041', NULL, 'TaLiN', 110, NULL, NULL, 22276),
(22277, '2.130.10.10-FF-003047', NULL, 'Transcription factor, putative', 151, NULL, NULL, 22277),
(22278, '3.30.70.330-FF-002062', NULL, NULL, 88, NULL, NULL, 22278),
(22279, '3.90.550.10-FF-000513', NULL, 'Glycoside transferase family 2', 254, NULL, NULL, 22279),
(22280, '1.25.40.20-FF-001823', NULL, 'Uncharacterized protein', 154, NULL, NULL, 22280),
(22281, '3.30.1330.10-FF-000026', NULL, 'phosphoribosylformylglycinamidine synthase', 206, NULL, NULL, 22281),
(22282, '3.30.160.60-FF-000534', NULL, 'zinc finger protein 674', 27, NULL, NULL, 22282),
(22283, '2.30.42.10-FF-000422', NULL, NULL, 97, NULL, NULL, 22283),
(22284, '1.20.120.1910-FF-000018', NULL, 'Cysteine--tRNA ligase', 169, NULL, NULL, 22284),
(22285, '3.40.50.2000-FF-000268', NULL, 'Glycosyltransferase family 1 protein', 99, NULL, NULL, 22285),
(22286, '1.25.10.10-FF-001785', NULL, 'YALI0B20680p', 603, NULL, NULL, 22286),
(22287, '1.20.1070.10-FF-001662', NULL, 'Uncharacterized protein', 126, NULL, NULL, 22287),
(22288, '3.30.40.10-FF-001915', NULL, 'Predicted protein', 111, NULL, NULL, 22288),
(22289, '2.130.10.10-FF-004795', NULL, 'Suppressor of mec-8 and unc-52 protein homolog 1', 148, NULL, NULL, 22289),
(22290, '1.20.120.350-FF-000178', NULL, NULL, 109, NULL, NULL, 22290),
(22291, '3.30.160.60-FF-006397', NULL, NULL, 29, NULL, NULL, 22291),
(22292, '1.10.287.110-FF-000445', NULL, 'DnaJ heat shock protein family (Hsp40) member C9', 65, NULL, NULL, 22292),
(22293, '1.20.920.10-FF-000088', NULL, 'Tat-binding homolog 7', 126, NULL, NULL, 22293),
(22294, '3.40.50.720-FF-000481', NULL, 'Alcohol dehydrogenase, variant', 145, NULL, NULL, 22294),
(22295, '2.60.40.10-FF-004828', NULL, NULL, 85, NULL, NULL, 22295),
(22296, '3.80.10.10-FF-001097', NULL, 'Uncharacterized protein', 132, NULL, NULL, 22296),
(22297, '2.60.120.200-FF-000500', NULL, 'Agrin', 185, NULL, NULL, 22297),
(22298, '4.10.1240.10-FF-000057', NULL, 'Latrophilin-like protein LAT-2', 59, NULL, NULL, 22298),
(22299, '1.10.8.720-FF-000017', NULL, 'Dynein heavy chain, putative', 173, NULL, NULL, 22299),
(22300, '1.10.10.10-FF-000756', NULL, 'Z-DNA binding protein kinase', 58, NULL, NULL, 22300),
(22301, '1.25.10.10-FF-002960', NULL, 'Uncharacterized protein', 666, NULL, NULL, 22301);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(22302, '3.40.50.1820-FF-000427', NULL, 'YOR022C-like protein', 185, NULL, NULL, 22302),
(22303, '3.30.420.10-FF-000377', NULL, NULL, 160, NULL, NULL, 22303),
(22304, '1.10.287.70-FF-000130', NULL, 'Potassium calcium-activated channel subfamily U member 1', 217, NULL, NULL, 22304),
(22305, '3.40.50.300-FF-002047', NULL, 'AAA family ATPase, putative', 33, NULL, NULL, 22305),
(22306, '1.25.40.10-FF-004586', NULL, 'Uncharacterized protein', 174, NULL, NULL, 22306),
(22307, '1.10.510.10-FF-000559', NULL, 'Protein kinase domain containing protein', 184, NULL, NULL, 22307),
(22308, '2.60.40.150-FF-000560', NULL, 'Predicted protein', 164, NULL, NULL, 22308),
(22309, '3.30.40.10-FF-001466', NULL, 'Uncharacterized protein', 102, NULL, NULL, 22309),
(22310, '1.10.238.10-FF-000971', NULL, 'Uncharacterized protein', 80, NULL, NULL, 22310),
(22311, '3.40.640.10-FF-000413', NULL, 'Predicted protein', 98, NULL, NULL, 22311),
(22312, '3.10.100.10-FF-000088', NULL, 'Mannose-binding protein A', 149, NULL, NULL, 22312),
(22313, '2.30.30.560-FF-000002', NULL, 'Major vault protein-alpha', 59, NULL, NULL, 22313),
(22314, '3.20.20.70-FF-000578', NULL, NULL, 209, NULL, NULL, 22314),
(22315, '2.120.10.80-FF-000258', NULL, 'Predicted protein', 209, NULL, NULL, 22315),
(22316, '3.10.20.770-FF-000007', NULL, 'Phosphatidylinositol 3-kinase age-1', 302, NULL, NULL, 22316),
(22317, '1.10.472.130-FF-000014', NULL, 'Dynein beta chain, putative', 132, NULL, NULL, 22317),
(22318, '1.10.510.10-FF-003307', NULL, NULL, 78, NULL, NULL, 22318),
(22319, '3.30.160.60-FF-001607', NULL, 'zinc finger protein 568 isoform X2', 28, NULL, NULL, 22319),
(22320, '1.20.1250.20-FF-000021', NULL, 'Putative multidrug resistance protein MdtD', 204, NULL, NULL, 22320),
(22321, '3.40.50.12780-FF-000084', NULL, 'Anthranilate--CoA ligase', 385, NULL, NULL, 22321),
(22322, '1.20.1250.40-FF-000027', NULL, 'HRDC-like protein', 159, NULL, NULL, 22322),
(22323, '1.10.238.10-FF-000055', NULL, 'Intersectin-1 isoform 1', 109, NULL, NULL, 22323),
(22324, '1.10.287.820-FF-000001', NULL, 'acid-sensing ion channel 1 isoform X2', 84, NULL, NULL, 22324),
(22325, '1.20.58.150-FF-000012', NULL, NULL, 146, NULL, NULL, 22325),
(22326, '2.60.40.150-FF-000453', NULL, 'RPGR-interacting protein 1', 138, NULL, NULL, 22326),
(22327, '2.60.40.10-FF-001158', NULL, 'NPHS1, nephrin', 100, NULL, NULL, 22327),
(22328, '3.10.100.10-FF-000200', NULL, 'Uncharacterized protein', 140, NULL, NULL, 22328),
(22329, '1.10.20.10-FF-000245', NULL, NULL, 96, NULL, NULL, 22329),
(22330, '3.30.160.60-FF-002226', NULL, 'Zinc finger protein 764', 30, NULL, NULL, 22330),
(22331, '3.40.640.10-FF-000306', NULL, 'Uncharacterized protein', 227, NULL, NULL, 22331),
(22332, '4.10.240.10-FF-000032', NULL, 'Related to ARO80-positive transcription regulator of ARO9 and ARO10', 74, NULL, NULL, 22332),
(22333, '2.70.170.10-FF-000048', NULL, 'Cholinergic receptor nicotinic alpha 1 subunit', 75, NULL, NULL, 22333),
(22334, '1.25.40.10-FF-000308', NULL, 'Transmembrane and tetratricopeptide repeat-containing 1', 109, NULL, NULL, 22334),
(22335, '3.40.50.300-FF-002963', NULL, 'AGAP009622-PA-like protein', 41, NULL, NULL, 22335),
(22336, '1.10.287.690-FF-000029', NULL, 'Uncharacterized protein', 34, NULL, NULL, 22336),
(22337, '3.30.70.330-FF-002646', NULL, NULL, 120, NULL, NULL, 22337),
(22338, '1.20.1600.10-FF-000068', NULL, 'Uncharacterized protein', 109, NULL, NULL, 22338),
(22339, '3.40.1190.20-FF-000100', NULL, 'adenosine kinase', 266, NULL, NULL, 22339),
(22340, '1.20.1250.20-FF-001544', NULL, 'Uncharacterized protein', 421, NULL, NULL, 22340),
(22341, '2.130.10.10-FF-004800', NULL, 'Uncharacterized protein', 146, NULL, NULL, 22341),
(22342, '3.20.20.70-FF-000590', NULL, 'Acetyl-CoA carboxylase/pyruvate carboxylase fusion protein, putative', 571, NULL, NULL, 22342),
(22343, '2.130.10.10-FF-001029', NULL, 'APC/C activator protein CDH1', 308, NULL, NULL, 22343),
(22344, '1.10.1370.10-FF-000035', NULL, 'Uncharacterized protein', 379, NULL, NULL, 22344),
(22345, '1.10.30.10-FF-000066', NULL, 'High mobility group family', 92, NULL, NULL, 22345);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(22346, '1.20.120.1950-FF-000002', NULL, 'Programmed cell death protein 10 homolog', 209, NULL, NULL, 22346),
(22347, '3.30.40.10-FF-001359', NULL, 'Probable histone-lysine N-methyltransferase lin-59', 72, NULL, NULL, 22347),
(22348, '3.40.50.300-FF-001428', NULL, 'putative Ras-related protein Rab-42', 189, NULL, NULL, 22348),
(22349, '3.30.160.60-FF-002119', NULL, 'Endolytic murein transglycosylase', 33, NULL, NULL, 22349),
(22350, '1.25.40.10-FF-003967', NULL, 'Uncharacterized protein', 235, NULL, NULL, 22350),
(22351, '1.10.490.10-FF-000039', NULL, 'Globin-1', 146, NULL, NULL, 22351),
(22352, '1.25.40.10-FF-000320', NULL, 'CCR4-NOT transcription complex subunit 10', 128, NULL, NULL, 22352),
(22353, '2.30.30.1150-FF-000004', NULL, 'E3 ubiquitin-protein ligase UHRF1', 167, NULL, NULL, 22353),
(22354, '1.10.630.10-FF-000028', NULL, 'Cytochrome p450 51g1', 454, NULL, NULL, 22354),
(22355, '3.40.50.300-FF-008561', NULL, 'Uncharacterized protein', 164, NULL, NULL, 22355),
(22356, '3.30.40.10-FF-000180', NULL, 'Early endosome antigen 1', 68, NULL, NULL, 22356),
(22357, '3.40.50.2000-FF-000032', NULL, '3-deoxy-D-manno-octulosonic acid transferase', 187, NULL, NULL, 22357),
(22358, '1.50.40.10-FF-000121', NULL, 'Ornithine carrier protein AmcA/Ort1', 215, NULL, NULL, 22358),
(22359, '1.10.238.150-FF-000009', NULL, 'CYtoKinesis defect', 98, NULL, NULL, 22359),
(22360, '3.40.850.10-FF-000019', NULL, 'Kinesin-like protein KIN-5D', 379, NULL, NULL, 22360),
(22361, '4.10.640.10-FF-000017', NULL, 'Related to 30s ribosomal protein s18', 58, NULL, NULL, 22361),
(22362, '3.40.50.150-FF-001462', NULL, NULL, 138, NULL, NULL, 22362),
(22363, '1.10.472.10-FF-000559', NULL, 'Uncharacterized protein', 67, NULL, NULL, 22363),
(22364, '1.25.40.10-FF-003170', NULL, 'Pentatricopeptide repeat-containing protein', 111, NULL, NULL, 22364),
(22365, '1.25.40.10-FF-005098', NULL, 'Uncharacterized protein', 206, NULL, NULL, 22365),
(22366, '2.60.40.10-FF-004143', NULL, NULL, 90, NULL, NULL, 22366),
(22367, '3.30.379.10-FF-000010', NULL, 'Beta-N-acetylhexosaminidase', 125, NULL, NULL, 22367),
(22368, '3.30.559.30-FF-000114', NULL, 'Putative peptide synthetase', 215, NULL, NULL, 22368),
(22369, '1.25.40.240-FF-000013', NULL, NULL, 131, NULL, NULL, 22369),
(22370, '2.40.30.10-FF-000433', NULL, 'Elongation factor Tu mitochondrial', 94, NULL, NULL, 22370),
(22371, '1.25.10.10-FF-000487', NULL, 'Serine/threonine-protein kinase TOR', 124, NULL, NULL, 22371),
(22372, '2.60.40.10-FF-006060', NULL, NULL, 128, NULL, NULL, 22372),
(22373, '3.50.50.60-FF-000514', NULL, 'D-amino acid dehydrogenase', 144, NULL, NULL, 22373),
(22374, '1.10.390.10-FF-000099', NULL, 'Uncharacterized protein', 102, NULL, NULL, 22374),
(22375, '3.30.9.10-FF-000101', NULL, 'Putative sarcosine oxidase beta subunit', 156, NULL, NULL, 22375),
(22376, '2.60.120.230-FF-000020', NULL, NULL, 85, NULL, NULL, 22376),
(22377, '1.25.10.10-FF-001111', NULL, 'RING-type E3 ubiquitin transferase', 192, NULL, NULL, 22377),
(22378, '3.90.70.10-FF-000515', NULL, 'Uncharacterized protein', 173, NULL, NULL, 22378),
(22379, '3.30.160.60-FF-005211', NULL, NULL, 30, NULL, NULL, 22379),
(22380, '1.10.357.30-FF-000011', NULL, NULL, 177, NULL, NULL, 22380),
(22381, '3.40.50.10240-FF-000002', NULL, 'Thiamine pyrophosphokinase', 140, NULL, NULL, 22381),
(22382, '1.20.5.430-FF-000006', NULL, 'Heat shock factor binding 1 protein', 46, NULL, NULL, 22382),
(22383, '2.60.40.150-FF-000346', NULL, 'Extended synaptotagmin-like protein 2a', 147, NULL, NULL, 22383),
(22384, '2.30.40.10-FF-000125', NULL, 'Imidazolonepropionase', 84, NULL, NULL, 22384),
(22385, '1.20.1070.10-FF-000605', NULL, 'Melanin-concentrating hormone receptor 1', 324, NULL, NULL, 22385),
(22386, '1.10.720.60-FF-000016', NULL, 'Enolase-phosphatase E1', 90, NULL, NULL, 22386),
(22387, '3.50.7.10-FF-000069', NULL, NULL, 161, NULL, NULL, 22387),
(22388, '3.30.70.330-FF-002753', NULL, NULL, 88, NULL, NULL, 22388),
(22389, '3.30.70.260-FF-000012', NULL, 'Prephenate dehydratase', 91, NULL, NULL, 22389),
(22390, '3.30.40.10-FF-000050', NULL, 'E3 ubiquitin-protein ligase', 57, NULL, NULL, 22390);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(22391, '1.10.472.10-FF-000666', NULL, 'Cyclin D2, a', 79, NULL, NULL, 22391),
(22392, '2.60.120.10-FF-000733', NULL, 'Uncharacterized protein', 126, NULL, NULL, 22392),
(22393, '3.30.200.20-FF-002510', NULL, 'Receptor protein-tyrosine kinase', 114, NULL, NULL, 22393),
(22394, '1.20.1250.20-FF-001325', NULL, 'Predicted protein', 225, NULL, NULL, 22394),
(22395, '1.20.1250.20-FF-001437', NULL, 'MFS sugar transporter, putative (AFU_orthologue AFUA_3G02890)', 122, NULL, NULL, 22395),
(22396, '3.40.50.720-FF-001897', NULL, 'Pyrroline-5-carboxylate reductase', 178, NULL, NULL, 22396),
(22397, '1.20.5.2440-FF-000012', NULL, 'Uncharacterized protein', 66, NULL, NULL, 22397),
(22398, '3.30.1330.20-FF-000041', NULL, 'Tubulin alpha chain', 115, NULL, NULL, 22398),
(22399, '1.10.3290.10-FF-000001', NULL, 'adenosine monophosphate-protein transferase FICD', 253, NULL, NULL, 22399),
(22400, '1.20.5.190-FF-000120', NULL, NULL, 50, NULL, NULL, 22400),
(22401, '3.30.200.20-FF-001886', NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3', 95, NULL, NULL, 22401),
(22402, '2.80.10.50-FF-000083', NULL, 'Alpha-amylase/subtilisin inhibitor', 178, NULL, NULL, 22402),
(22403, '2.170.140.10-FF-000011', NULL, 'CSON009188 protein', 60, NULL, NULL, 22403),
(22404, '2.80.10.50-FF-000195', NULL, 'Uncharacterized protein', 89, NULL, NULL, 22404),
(22405, '3.40.50.620-FF-000125', NULL, 'Arginine--tRNA ligase', 358, NULL, NULL, 22405),
(22406, '1.10.533.10-FF-000241', NULL, 'Uncharacterized protein', 81, NULL, NULL, 22406),
(22407, '3.40.50.2020-FF-000145', NULL, 'Uncharacterized protein', 85, NULL, NULL, 22407),
(22408, '3.40.50.720-FF-001785', NULL, 'Putative 2-dehydropantoate 2-reductase', 168, NULL, NULL, 22408),
(22409, '1.25.10.10-FF-002853', NULL, 'Uncharacterized protein', 169, NULL, NULL, 22409),
(22410, '3.30.1370.10-FF-000153', NULL, 'KH domain containing protein, putative', 83, NULL, NULL, 22410),
(22411, '2.60.40.2070-FF-000004', NULL, 'Fimbrial biogenesis outer membrane usher protein', 84, NULL, NULL, 22411),
(22412, '1.20.58.1080-FF-000003', NULL, 'DExH-box ATP-dependent RNA helicase DExH16 mitochondrial', 106, NULL, NULL, 22412),
(22413, '3.80.10.10-FF-004082', NULL, 'Leucine-rich repeats and immunoglobulin-like domains 2', 125, NULL, NULL, 22413),
(22414, '3.30.60.30-FF-000063', NULL, 'Insulin-like growth factor-binding protein-like 1', 36, NULL, NULL, 22414),
(22415, '3.30.2350.20-FF-000036', NULL, 'tRNA pseudouridine synthase d domain-containing protein', 201, NULL, NULL, 22415),
(22416, '1.10.150.50-FF-000211', NULL, 'Predicted protein', 47, NULL, NULL, 22416),
(22417, '1.25.40.20-FF-001161', NULL, 'Ankyrin repeat, SAM and basic leucine zipper domain containing 1', 128, NULL, NULL, 22417),
(22418, '3.40.50.1820-FF-000534', NULL, 'Serine_hydrolase_(FSH1)/50S_ribosome-binding_GTPase/GTPase_of_uncharacterized_function_C-terminal_-_putative', 223, NULL, NULL, 22418),
(22419, '3.30.160.60-FF-003524', NULL, 'AGAP002041-PB', 73, NULL, NULL, 22419),
(22420, '3.30.70.330-FF-001348', NULL, 'Uncharacterized protein', 97, NULL, NULL, 22420),
(22421, '3.30.710.10-FF-000129', NULL, 'BTB/POZ domain-containing protein 8', 163, NULL, NULL, 22421),
(22422, '3.30.200.20-FF-001105', NULL, 'Serine/threonine-protein kinase, putative', 115, NULL, NULL, 22422),
(22423, '2.10.110.10-FF-000013', NULL, 'Four and a half LIM domains 1', 60, NULL, NULL, 22423),
(22424, '3.90.180.10-FF-000035', NULL, 'Multifunctional mycocerosic acid synthase', 166, NULL, NULL, 22424),
(22425, '1.25.40.20-FF-001031', NULL, 'Uncharacterized protein', 96, NULL, NULL, 22425),
(22426, '1.25.40.10-FF-002225', NULL, 'Alpha-snap', 268, NULL, NULL, 22426),
(22427, '2.60.120.260-FF-000248', NULL, 'Spindle pole body-associated protein sad1', 208, NULL, NULL, 22427),
(22428, '2.40.70.10-FF-000323', NULL, NULL, 176, NULL, NULL, 22428),
(22429, '3.30.470.20-FF-000203', NULL, 'Uncharacterized protein', 63, NULL, NULL, 22429),
(22430, '3.30.70.330-FF-000729', NULL, 'Blast:Polyadenylate-binding protein', 110, NULL, NULL, 22430),
(22431, '3.40.50.620-FF-000102', NULL, 'Choline-phosphate cytidylyltransferase 2', 236, NULL, NULL, 22431);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(22432, '3.40.390.10-FF-000091', NULL, 'Matrix metalloproteinase-16-like Protein', 252, NULL, NULL, 22432),
(22433, '3.40.630.40-FF-000023', NULL, 'N-acetylmuramoyl alanine amidase', 196, NULL, NULL, 22433),
(22434, '1.10.486.10-FF-000046', NULL, 'PCNA-interacting partner', 152, NULL, NULL, 22434),
(22435, '2.60.40.1180-FF-000046', NULL, 'Domain_of_uncharacterized_function_(DUF1935)_-_pu tative', 102, NULL, NULL, 22435),
(22436, '2.30.29.30-FF-000779', NULL, 'YALI0F15719p', 53, NULL, NULL, 22436),
(22437, '1.20.120.1750-FF-000167', NULL, 'RBR-type E3 ubiquitin transferase', 105, NULL, NULL, 22437),
(22438, '1.10.510.10-FF-004471', NULL, NULL, 332, NULL, NULL, 22438),
(22439, '3.40.30.10-FF-001100', NULL, 'Uncharacterized protein', 66, NULL, NULL, 22439),
(22440, '3.40.50.2300-FF-000015', NULL, 'Two-component response regulator UvrY', 208, NULL, NULL, 22440),
(22441, '3.40.50.300-FF-003901', NULL, 'Molybdopterin_guanine_dinucleotide_synthesis_protein_B_-_putative', 237, NULL, NULL, 22441),
(22442, '3.40.140.10-FF-000050', NULL, 'tRNA-specific adenosine deaminase', 151, NULL, NULL, 22442),
(22443, '1.10.287.990-FF-000006', NULL, 'Superoxide dismutase', 69, NULL, NULL, 22443),
(22444, '3.90.470.20-FF-000009', NULL, 'Phosphopantetheine-protein transferase domain protein', 108, NULL, NULL, 22444),
(22445, '3.80.10.10-FF-001108', NULL, 'Leucine rich repeat protein phosphatase 2c domain containing protein', 100, NULL, NULL, 22445),
(22446, '3.30.710.10-FF-000017', NULL, 'BTB/POZ domain-containing protein 10 isoform X1', 122, NULL, NULL, 22446),
(22447, '1.10.238.10-FF-000841', NULL, 'Mitochondrial calcium uptake 1', 126, NULL, NULL, 22447),
(22448, '3.40.50.80-FF-000239', NULL, 'Cytochrome b5 reductase 3', 36, NULL, NULL, 22448),
(22449, '1.20.930.20-FF-000024', NULL, 'Uncharacterized protein', 43, NULL, NULL, 22449),
(22450, '2.90.10.30-FF-000003', NULL, 'Os04g0303100 protein', 135, NULL, NULL, 22450),
(22451, '2.130.10.10-FF-004688', NULL, 'Cleavage and polyadenylation specificity factor-like protein, putative', 451, NULL, NULL, 22451),
(22452, '3.40.50.1000-FF-000856', NULL, NULL, 52, NULL, NULL, 22452),
(22453, '3.40.50.1820-FF-001046', NULL, 'Os01g0317500 protein', 69, NULL, NULL, 22453),
(22454, '1.10.287.520-FF-000006', NULL, 'Noggin-3', 60, NULL, NULL, 22454),
(22455, '1.20.1250.20-FF-002056', NULL, 'Os04g0464400 protein', 307, NULL, NULL, 22455),
(22456, '2.130.10.10-FF-003502', NULL, 'Peptidylprolyl isomerase domain and WD repeat-containing protein 1', 249, NULL, NULL, 22456),
(22457, '2.60.40.10-FF-002693', NULL, 'High Incidence of Males (Increased X chromosome loss)', 91, NULL, NULL, 22457),
(22458, '2.60.40.10-FF-003979', NULL, NULL, 128, NULL, NULL, 22458),
(22459, '1.10.287.130-FF-000103', NULL, 'Two-component sensor histidine kinase', 84, NULL, NULL, 22459),
(22460, '1.10.10.10-FF-000975', NULL, 'Putative casein kinase I', 54, NULL, NULL, 22460),
(22461, '3.40.850.10-FF-000238', NULL, 'Kinesin, putative', 214, NULL, NULL, 22461),
(22462, '3.90.320.10-FF-000024', NULL, 'ATP-dependent helicase/nuclease subunit A', 239, NULL, NULL, 22462),
(22463, '3.10.100.10-FF-000082', NULL, 'CD302 antigen isoform X2', 141, NULL, NULL, 22463),
(22464, '1.10.287.70-FF-000023', NULL, 'Voltage-dependent R-type calcium channel subunit alpha', 134, NULL, NULL, 22464),
(22465, '1.20.1300.10-FF-000028', NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', 130, NULL, NULL, 22465),
(22466, '1.25.10.10-FF-000599', NULL, 'Protein STU2', 240, NULL, NULL, 22466),
(22467, '1.25.40.280-FF-000019', NULL, 'Uncharacterized protein', 260, NULL, NULL, 22467),
(22468, '1.10.418.10-FF-000046', NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', 113, NULL, NULL, 22468),
(22469, '3.30.160.60-FF-005885', NULL, NULL, 85, NULL, NULL, 22469),
(22470, '2.130.10.10-FF-002327', NULL, 'WD repeat-containing protein 44', 77, NULL, NULL, 22470),
(22471, '2.170.270.10-FF-000127', NULL, 'Histone-lysine N-methyltransferase Clr4 (AFU_orthologue AFUA_1G11090)', 273, NULL, NULL, 22471),
(22472, '3.40.720.10-FF-000358', NULL, 'Predicted protein', 175, NULL, NULL, 22472);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(22473, '1.20.5.110-FF-000023', NULL, 'Syntaxin 3', 108, NULL, NULL, 22473),
(22474, '3.30.1330.40-FF-000024', NULL, 'Enamine deaminase RidA', 119, NULL, NULL, 22474),
(22475, '2.30.170.20-FF-000021', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 41, NULL, NULL, 22475),
(22476, '1.20.1420.30-FF-000077', NULL, 'Ca(2+)/H(+) antiporter', 153, NULL, NULL, 22476),
(22477, '3.60.10.10-FF-000081', NULL, 'Uncharacterized protein', 290, NULL, NULL, 22477),
(22478, '1.20.5.710-FF-000001', NULL, '50S ribosomal protein L7/L12', 49, NULL, NULL, 22478),
(22479, '1.10.1170.10-FF-000031', NULL, 'Apoptosis 2 inhibitor-like Protein', 104, NULL, NULL, 22479),
(22480, '2.40.170.20-FF-000098', NULL, 'Ligand-gated TonB-dependent outer membrane channel', 458, NULL, NULL, 22480),
(22481, '2.40.30.10-FF-000214', NULL, 'U5 snRNP-specific protein', 144, NULL, NULL, 22481),
(22482, '3.80.10.10-FF-003469', NULL, 'AT19096p', 218, NULL, NULL, 22482),
(22483, '1.10.730.10-FF-000194', NULL, 'Uncharacterized protein', 152, NULL, NULL, 22483),
(22484, '3.30.559.10-FF-000007', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 241, NULL, NULL, 22484),
(22485, '2.30.29.30-FF-001392', NULL, 'Uncharacterized protein', 88, NULL, NULL, 22485),
(22486, '3.40.1280.10-FF-000093', NULL, 'RNA methyltransferase, TrmH family protein', 116, NULL, NULL, 22486),
(22487, '3.30.450.40-FF-000303', NULL, 'Heat-inducible transcription repressor HrcA', 136, NULL, NULL, 22487),
(22488, '3.90.550.10-FF-000625', NULL, 'Molybdenum cofactor guanylyltransferase', 196, NULL, NULL, 22488),
(22489, '1.20.1070.10-FF-001555', NULL, 'Uncharacterized protein', 173, NULL, NULL, 22489),
(22490, '3.30.460.10-FF-000031', NULL, 'Topoisomerase family protein Trf4', 119, NULL, NULL, 22490),
(22491, '3.40.50.300-FF-002940', NULL, 'ABC transporter, ATP-binding protein', 203, NULL, NULL, 22491),
(22492, '3.30.70.20-FF-000004', NULL, '4Fe-4S ferredoxin', 83, NULL, NULL, 22492),
(22493, '3.10.20.90-FF-000663', NULL, 'Ubiquitin-like protein', 81, NULL, NULL, 22493),
(22494, '3.20.20.140-FF-000457', NULL, 'Guanine deaminase', 311, NULL, NULL, 22494),
(22495, '1.10.150.670-FF-000035', NULL, 'Crossover junction endonuclease MUS81-like Protein', 77, NULL, NULL, 22495),
(22496, '1.25.40.180-FF-000315', NULL, NULL, 257, NULL, NULL, 22496),
(22497, '2.10.25.10-FF-001682', NULL, 'Transmembrane cell adhesion receptor mua-3', 44, NULL, NULL, 22497),
(22498, '1.10.287.990-FF-000001', NULL, 'Superoxide dismutase', 64, NULL, NULL, 22498),
(22499, '1.10.510.10-FF-000429', NULL, 'SRSF protein kinase 3', 91, NULL, NULL, 22499),
(22500, '3.30.70.330-FF-000044', NULL, 'Putative ccr4-not transcription complex subunit 4', 81, NULL, NULL, 22500),
(22501, '1.10.287.1490-FF-000129', NULL, 'Kinase, NEK', 126, NULL, NULL, 22501),
(22502, '2.160.20.10-FF-000219', NULL, 'PolyMG-specific alginate lyase', 403, NULL, NULL, 22502),
(22503, '3.40.50.1820-FF-001832', NULL, 'Carboxylesterase, putative', 85, NULL, NULL, 22503),
(22504, '3.30.1840.10-FF-000003', NULL, 'Polyphosphate kinase', 183, NULL, NULL, 22504),
(22505, '1.20.1070.10-FF-002067', NULL, 'Novopsin-10', 73, NULL, NULL, 22505),
(22506, '3.40.1810.10-FF-000016', NULL, 'MADS-box transcription factor 16', 85, NULL, NULL, 22506),
(22507, '3.30.830.10-FF-000172', NULL, 'cytochrome b-c1 complex subunit 2, mitochondrial-like', 226, NULL, NULL, 22507),
(22508, '2.40.50.140-FF-001238', NULL, NULL, 32, NULL, NULL, 22508),
(22509, '1.20.5.1160-FF-000044', NULL, 'Glial fibrillary acidic protein', 52, NULL, NULL, 22509),
(22510, '1.20.140.100-FF-000012', NULL, 'Axonemal dynein heavy chain', 149, NULL, NULL, 22510),
(22511, '3.40.630.30-FF-000694', NULL, 'N-acetyl-transferase-like protein', 52, NULL, NULL, 22511),
(22512, '1.20.1280.50-FF-000184', NULL, 'F-box/LRR-repeat protein 4', 82, NULL, NULL, 22512),
(22513, '3.40.390.10-FF-000214', NULL, NULL, 235, NULL, NULL, 22513),
(22514, '3.40.50.2000-FF-000824', NULL, 'Trehalose-6-phosphate synthase/phosphatase', 172, NULL, NULL, 22514),
(22515, '3.20.80.10-FF-000036', NULL, 'Uncharacterized protein', 126, NULL, NULL, 22515);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(22516, '1.10.472.10-FF-000211', NULL, 'Cyclin domain containing protein', 114, NULL, NULL, 22516),
(22517, '3.40.50.10190-FF-000296', NULL, 'DNA topoisomerase 2-binding protein 1-A-like Protein', 100, NULL, NULL, 22517),
(22518, '3.40.50.150-FF-000512', NULL, 'Putative methyltransferase', 168, NULL, NULL, 22518),
(22519, '1.10.472.10-FF-000099', NULL, 'G1/S-specific cyclin-D3 isoform X3', 115, NULL, NULL, 22519),
(22520, '1.10.238.10-FF-000167', NULL, 'Protein S100-A10', 97, NULL, NULL, 22520),
(22521, '1.20.58.1880-FF-000035', NULL, 'REST corepressor spr-1', 126, NULL, NULL, 22521),
(22522, '2.80.10.50-FF-000206', NULL, 'Uncharacterized protein', 144, NULL, NULL, 22522),
(22523, '3.40.50.300-FF-004306', NULL, 'Small GTPase, putative', 205, NULL, NULL, 22523),
(22524, '3.40.50.1000-FF-000171', NULL, 'Nuclear lim interactor-interacting factor,putative', 167, NULL, NULL, 22524),
(22525, '1.20.1070.10-FF-001903', NULL, 'Uncharacterized protein', 287, NULL, NULL, 22525),
(22526, '3.30.160.60-FF-004143', NULL, NULL, 28, NULL, NULL, 22526),
(22527, '2.60.40.10-FF-003075', NULL, 'CD226 antigen (Predicted), isoform CRA_b', 108, NULL, NULL, 22527),
(22528, '1.20.120.350-FF-000066', NULL, 'Sodium channel protein', 125, NULL, NULL, 22528),
(22529, '3.40.50.150-FF-001024', NULL, NULL, 180, NULL, NULL, 22529),
(22530, '3.40.50.150-FF-000405', NULL, 'Carminomycin 4-O-methyltransferase DnrK', 167, NULL, NULL, 22530),
(22531, '3.40.50.300-FF-004649', NULL, 'Uncharacterized protein', 329, NULL, NULL, 22531),
(22532, '1.10.1200.10-FF-000158', NULL, 'Uncharacterized protein', 75, NULL, NULL, 22532),
(22533, '2.60.40.150-FF-000341', NULL, 'Tcb3p', 173, NULL, NULL, 22533),
(22534, '3.40.1690.20-FF-000014', NULL, 'Predicted protein', 120, NULL, NULL, 22534),
(22535, '3.30.40.10-FF-000977', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 115, NULL, NULL, 22535),
(22536, '2.60.40.10-FF-000091', NULL, 'Leucine-rich repeat and fibronectin type III domain-containing protein 1', 90, NULL, NULL, 22536),
(22537, '2.10.25.10-FF-001575', NULL, 'Uncharacterized protein', 40, NULL, NULL, 22537),
(22538, '2.40.50.140-FF-000619', NULL, 'Exosome complex exonuclease RRP44 A', 86, NULL, NULL, 22538),
(22539, '3.90.1150.10-FF-000246', NULL, 'Selenocysteine lyase', 11, NULL, NULL, 22539),
(22540, '2.130.10.10-FF-005200', NULL, 'Uncharacterized protein', 103, NULL, NULL, 22540),
(22541, '3.40.50.880-FF-000045', NULL, 'glutamine amidotransferase-like class 1 domain-containing protein 1 isoform X2', 206, NULL, NULL, 22541),
(22542, '3.30.160.60-FF-004828', NULL, NULL, 42, NULL, NULL, 22542),
(22543, '3.90.1170.20-FF-000014', NULL, 'Nicotinate-nucleotide pyrophosphorylase [carboxylating]', 114, NULL, NULL, 22543),
(22544, '1.20.1070.10-FF-002174', NULL, 'Uncharacterized protein', 117, NULL, NULL, 22544),
(22545, '3.30.1370.100-FF-000007', NULL, 'MUTL protein homolog 3', 112, NULL, NULL, 22545),
(22546, '3.30.160.60-FF-005104', NULL, NULL, 46, NULL, NULL, 22546),
(22547, '2.80.10.50-FF-000190', NULL, 'Uncharacterized protein', 124, NULL, NULL, 22547),
(22548, '2.70.150.10-FF-000272', NULL, 'Phospholipid-transporting ATPase', 189, NULL, NULL, 22548),
(22549, '3.40.47.10-FF-000138', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 2', 426, NULL, NULL, 22549),
(22550, '3.90.120.10-FF-000020', NULL, 'DNA (cytosine-5)-methyltransferase', 85, NULL, NULL, 22550),
(22551, '3.60.20.10-FF-000036', NULL, 'Proteasome subunit alpha type', 246, NULL, NULL, 22551),
(22552, '3.30.590.10-FF-000035', NULL, 'Glutamine synthetase', 401, NULL, NULL, 22552),
(22553, '3.40.50.1370-FF-000028', NULL, 'Putrescine carbamoyltransferase', 131, NULL, NULL, 22553),
(22554, '1.10.730.10-FF-000199', NULL, 'Predicted protein', 132, NULL, NULL, 22554),
(22555, '1.10.580.10-FF-000041', NULL, 'Citrate synthase', 128, NULL, NULL, 22555),
(22556, '3.40.50.1820-FF-001158', NULL, 'Uncharacterized protein', 157, NULL, NULL, 22556),
(22557, '1.20.1070.10-FF-001898', NULL, 'Vomeronasal type-1 receptor', 288, NULL, NULL, 22557),
(22558, '1.20.5.170-FF-000013', NULL, 'RUN and FYVE domain-containing 1', 48, NULL, NULL, 22558);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(22559, '1.10.287.70-FF-000242', NULL, 'Potassium voltage-gated channel subfamily A member 1', 110, NULL, NULL, 22559),
(22560, '3.40.50.300-FF-000939', NULL, 'Probable ATP-dependent RNA helicase DDX56', 220, NULL, NULL, 22560),
(22561, '3.40.50.300-FF-003345', NULL, 'Hydrolase, P-loop family', 147, NULL, NULL, 22561),
(22562, '2.40.10.10-FF-000319', NULL, 'AGAP011918-PA', 231, NULL, NULL, 22562),
(22563, '1.10.472.10-FF-000104', NULL, 'cyclin-T1-3 isoform X1', 151, NULL, NULL, 22563),
(22564, '1.10.720.60-FF-000011', NULL, 'enolase-phosphatase E1-like', 105, NULL, NULL, 22564),
(22565, '1.20.1110.10-FF-000216', NULL, NULL, 52, NULL, NULL, 22565),
(22566, '1.10.1370.30-FF-000030', NULL, 'Angiotensin-converting enzyme', 283, NULL, NULL, 22566),
(22567, '2.60.40.60-FF-000881', NULL, 'Uncharacterized protein', 70, NULL, NULL, 22567),
(22568, '3.40.50.2000-FF-001100', NULL, 'Uncharacterized protein', 47, NULL, NULL, 22568),
(22569, '3.40.120.10-FF-000048', NULL, 'Phosphoglucosamine mutase', 138, NULL, NULL, 22569),
(22570, '3.90.550.50-FF-000053', NULL, 'Hexosyltransferase', 226, NULL, NULL, 22570),
(22571, '3.40.50.10860-FF-000064', NULL, 'Methylenetetrahydrofolate dehydrogenase', 92, NULL, NULL, 22571),
(22572, '3.40.190.10-FF-000339', NULL, 'Spermidine-binding periplasmic protein SpuE', 132, NULL, NULL, 22572),
(22573, '3.10.600.10-FF-000007', NULL, 'Pyruvate carboxylase', 77, NULL, NULL, 22573),
(22574, '2.60.40.790-FF-000066', NULL, 'Predicted protein', 97, NULL, NULL, 22574),
(22575, '2.60.40.10-FF-004036', NULL, NULL, 123, NULL, NULL, 22575),
(22576, '2.30.130.10-FF-000038', NULL, 'Chromosome 1, whole genome shotgun sequence', 120, NULL, NULL, 22576),
(22577, '1.20.120.160-FF-000003', NULL, 'Aerobic respiration control sensor protein', 125, NULL, NULL, 22577),
(22578, '3.60.20.10-FF-000143', NULL, 'Glucosamine/fructose-6-phosphate aminotransferase, isomerizing', 239, NULL, NULL, 22578),
(22579, '1.25.40.10-FF-002681', NULL, 'Os12g0130900 protein', 162, NULL, NULL, 22579),
(22580, '2.40.180.10-FF-000033', NULL, 'Uncharacterized protein', 229, NULL, NULL, 22580),
(22581, '2.60.300.12-FF-000036', NULL, NULL, 108, NULL, NULL, 22581),
(22582, '1.50.40.10-FF-000469', NULL, 'Predicted protein', 67, NULL, NULL, 22582),
(22583, '3.40.50.300-FF-008016', NULL, 'Protein translocase subunit SECA1 chloroplastic', 142, NULL, NULL, 22583),
(22584, '1.10.510.10-FF-002902', NULL, NULL, 204, NULL, NULL, 22584),
(22585, '2.10.70.10-FF-000246', NULL, 'Putative eel-fucolectin tachylectin-4 pentaxrin-1 domain protein', 57, NULL, NULL, 22585),
(22586, '2.102.10.10-FF-000019', NULL, 'Rieske iron-sulfur protein', 159, NULL, NULL, 22586),
(22587, '3.90.226.10-FF-000266', NULL, 'Protein CBG25649', 111, NULL, NULL, 22587),
(22588, '1.10.150.530-FF-000010', NULL, 'Probable dual-specificity RNA methyltransferase RlmN', 72, NULL, NULL, 22588),
(22589, '3.10.110.10-FF-000251', NULL, 'RBR-type E3 ubiquitin transferase', 129, NULL, NULL, 22589),
(22590, '2.10.90.10-FF-000129', NULL, 'Uncharacterized protein', 98, NULL, NULL, 22590),
(22591, '3.30.160.60-FF-004699', NULL, NULL, 24, NULL, NULL, 22591),
(22592, '2.10.25.10-FF-001232', NULL, 'FI15785p1', 56, NULL, NULL, 22592),
(22593, '1.10.357.50-FF-000017', NULL, 'SEC6', 89, NULL, NULL, 22593),
(22594, '2.130.10.10-FF-000068', NULL, 'Pre-mRNA-splicing factor rse1, variant', 325, NULL, NULL, 22594),
(22595, '3.80.10.10-FF-002165', NULL, 'F-box protein', 218, NULL, NULL, 22595),
(22596, '4.10.400.10-FF-000371', NULL, 'Uncharacterized protein', 39, NULL, NULL, 22596),
(22597, '1.10.10.60-FF-001018', NULL, NULL, 71, NULL, NULL, 22597),
(22598, '1.10.510.10-FF-002009', NULL, 'CDK16 isoform 6', 146, NULL, NULL, 22598),
(22599, '3.90.70.10-FF-000392', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 130, NULL, NULL, 22599),
(22600, '1.10.472.10-FF-000554', NULL, 'Cyclin B2', 72, NULL, NULL, 22600),
(22601, '3.90.1150.10-FF-000465', NULL, 'Predicted protein', 129, NULL, NULL, 22601),
(22602, '3.60.130.10-FF-000011', NULL, 'Taurine catabolism dioxygenase TauD', 308, NULL, NULL, 22602);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(22603, '3.40.309.10-FF-000026', NULL, 'Aldehyde dehydrogenase 22A1', 196, NULL, NULL, 22603),
(22604, '3.40.50.300-FF-000467', NULL, 'ATP-binding cassette sub-family F member 2', 265, NULL, NULL, 22604),
(22605, '1.10.510.10-FF-003302', NULL, NULL, 81, NULL, NULL, 22605),
(22606, '2.170.8.10-FF-000016', NULL, 'Uncharacterized protein', 102, NULL, NULL, 22606),
(22607, '3.30.450.20-FF-000308', NULL, 'Sporulation-specific ATP-dependent proteinhistidine kinase', 108, NULL, NULL, 22607),
(22608, '3.80.10.10-FF-001889', NULL, 'Leucine rich repeat containing G protein-coupled receptor 6', 249, NULL, NULL, 22608),
(22609, '1.20.950.20-FF-000019', NULL, 'Ni/Fe-hydrogenase, b-type cytochrome subunit', 192, NULL, NULL, 22609),
(22610, '3.90.1280.20-FF-000011', NULL, NULL, 71, NULL, NULL, 22610),
(22611, '2.60.220.50-FF-000101', NULL, 'Adhesion G protein-coupled receptor G7, tandem duplicate 2', 66, NULL, NULL, 22611),
(22612, '3.30.1370.10-FF-000046', NULL, 'High density lipoprotein binding protein', 63, NULL, NULL, 22612),
(22613, '3.90.360.10-FF-000021', NULL, 'Predicted protein', 128, NULL, NULL, 22613),
(22614, '3.80.10.10-FF-002513', NULL, 'Leucine-rich repeat-containing G-protein coupled receptor 5-like Protein', 83, NULL, NULL, 22614),
(22615, '3.40.50.410-FF-000045', NULL, 'general transcription factor IIH subunit 3 isoform X1', 229, NULL, NULL, 22615),
(22616, '2.60.40.640-FF-000049', NULL, 'Arrestin domain-containing protein 15', 149, NULL, NULL, 22616),
(22617, '2.60.40.4270-FF-000001', NULL, 'Internalin A', 70, NULL, NULL, 22617),
(22618, '2.60.40.10-FF-001400', NULL, 'Titin a', 94, NULL, NULL, 22618),
(22619, '3.80.10.10-FF-001546', NULL, 'Cyclic nucleotide-binding domain protein (AFU_orthologue AFUA_2G03170)', 249, NULL, NULL, 22619),
(22620, '3.20.180.20-FF-000043', NULL, 'Si:dkey-11m19.5', 112, NULL, NULL, 22620),
(22621, '3.90.1100.10-FF-000063', NULL, 'Predicted protein', 130, NULL, NULL, 22621),
(22622, '2.40.100.10-FF-000040', NULL, 'Peptidyl-prolyl cis-trans isomerase B', 228, NULL, NULL, 22622),
(22623, '1.25.40.10-FF-002006', NULL, 'Uncharacterized protein', 103, NULL, NULL, 22623),
(22624, '3.30.390.50-FF-000020', NULL, 'Xanthine dehydrogenase', 117, NULL, NULL, 22624),
(22625, '3.40.50.2020-FF-000038', NULL, 'Hypoxanthine phosphoribosyltransferase', 225, NULL, NULL, 22625),
(22626, '1.20.144.10-FF-000138', NULL, 'Putative phosphatidate phosphatase-like Protein', 265, NULL, NULL, 22626),
(22627, '1.10.10.10-FF-000071', NULL, 'Forkhead box F1', 108, NULL, NULL, 22627),
(22628, '2.60.40.790-FF-000196', NULL, NULL, 74, NULL, NULL, 22628),
(22629, '3.40.50.150-FF-000057', NULL, 'O-methyltransferase ZRP4', 251, NULL, NULL, 22629),
(22630, '1.10.8.270-FF-000186', NULL, 'Uncharacterized protein', 126, NULL, NULL, 22630),
(22631, '2.40.30.10-FF-000321', NULL, 'tRNA-specific 2-thiouridylase MnmA 1', 83, NULL, NULL, 22631),
(22632, '3.40.47.10-FF-000014', NULL, 'Chalcone synthase 1', 151, NULL, NULL, 22632),
(22633, '1.10.1200.80-FF-000010', NULL, 'tRNA-dihydrouridine synthase', 66, NULL, NULL, 22633),
(22634, '2.60.210.10-FF-000055', NULL, NULL, 131, NULL, NULL, 22634),
(22635, '1.20.900.10-FF-000070', NULL, 'FERM domain (Protein4.1-ezrin-radixin-moesin) family', 214, NULL, NULL, 22635),
(22636, '1.10.287.370-FF-000040', NULL, 'PREFOLDIN 1', 112, NULL, NULL, 22636),
(22637, '2.10.109.10-FF-000049', NULL, 'Putative RulA protein', 111, NULL, NULL, 22637),
(22638, '3.40.50.300-FF-004525', NULL, 'WGS project CABT00000000 data, contig 2.23', 181, NULL, NULL, 22638),
(22639, '2.60.40.10-FF-000776', NULL, 'Platelet-derived growth factor receptor alpha', 104, NULL, NULL, 22639),
(22640, '3.40.50.1240-FF-000118', NULL, 'Uncharacterized protein', 224, NULL, NULL, 22640),
(22641, '1.10.20.10-FF-000026', NULL, 'Histone H2A', 130, NULL, NULL, 22641),
(22642, '2.10.25.10-FF-000271', NULL, 'Terribly reduced optic lobes, isoform B', 48, NULL, NULL, 22642),
(22643, '3.20.20.105-FF-000007', NULL, 'Queuine tRNA-ribosyltransferase accessory subunit 2', 400, NULL, NULL, 22643),
(22644, '2.60.40.1730-FF-000020', NULL, 'Transcription initiation factor TFIId 127kD subunit', 215, NULL, NULL, 22644);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(22645, '3.40.50.2300-FF-001319', NULL, NULL, 106, NULL, NULL, 22645),
(22646, '3.40.190.10-FF-000558', NULL, 'Transcriptional regulator, LysR family', 83, NULL, NULL, 22646),
(22647, '1.10.10.60-FF-000057', NULL, 'Short stature homeobox 2', 66, NULL, NULL, 22647),
(22648, '1.10.510.10-FF-001048', NULL, 'Serine/threonine-protein kinase PLK', 234, NULL, NULL, 22648),
(22649, '1.10.418.10-FF-000153', NULL, 'Sperm antigen with calponin homology and coiled-coil domains 1', 65, NULL, NULL, 22649),
(22650, '3.30.565.10-FF-000049', NULL, 'Two-component sensor histidine kinase', 157, NULL, NULL, 22650),
(22651, '3.40.50.970-FF-000191', NULL, 'Sulfite reductase [NADPH] subunit beta', 249, NULL, NULL, 22651),
(22652, '4.10.860.120-FF-000023', NULL, 'DNA-directed RNA polymerase subunit', 117, NULL, NULL, 22652),
(22653, '3.30.160.60-FF-000776', NULL, 'Zinc finger protein 639', 58, NULL, NULL, 22653),
(22654, '3.30.70.3250-FF-000022', NULL, NULL, 101, NULL, NULL, 22654),
(22655, '3.30.160.60-FF-005992', NULL, NULL, 89, NULL, NULL, 22655),
(22656, '3.40.50.720-FF-001892', NULL, 'Predicted protein', 143, NULL, NULL, 22656),
(22657, '3.30.200.20-FF-002409', NULL, 'Uncharacterized protein', 88, NULL, NULL, 22657),
(22658, '1.25.40.10-FF-004479', NULL, 'Uncharacterized protein', 102, NULL, NULL, 22658),
(22659, '2.30.36.70-FF-000009', NULL, 'AGAP008687-PA-like protein', 49, NULL, NULL, 22659),
(22660, '1.10.10.60-FF-000861', NULL, NULL, 85, NULL, NULL, 22660),
(22661, '3.40.50.150-FF-000950', NULL, NULL, 142, NULL, NULL, 22661),
(22662, '3.90.190.10-FF-000530', NULL, 'Receptor tyrosine phosphatase type r2b, putative', 200, NULL, NULL, 22662),
(22663, '3.30.160.60-FF-001265', NULL, 'Zinc finger protein 366', 54, NULL, NULL, 22663),
(22664, '3.30.930.10-FF-000112', NULL, 'Histidine-tRNA ligase', 354, NULL, NULL, 22664),
(22665, '1.10.510.10-FF-004364', NULL, NULL, 107, NULL, NULL, 22665),
(22666, '2.70.98.10-FF-000060', NULL, 'Glycoside hydrolase family 92 protein', 292, NULL, NULL, 22666),
(22667, '3.90.550.10-FF-000755', NULL, 'Predicted protein', 168, NULL, NULL, 22667),
(22668, '3.40.50.300-FF-000254', NULL, 'U5 small nuclear ribonucleoprotein helicase', 229, NULL, NULL, 22668),
(22669, '2.60.40.10-FF-004486', NULL, NULL, 114, NULL, NULL, 22669),
(22670, '3.30.200.20-FF-000037', NULL, 'Tyrosine-protein kinase', 88, NULL, NULL, 22670),
(22671, '3.40.50.1110-FF-000097', NULL, 'GD23360', 227, NULL, NULL, 22671),
(22672, '1.20.140.70-FF-000001', NULL, 'Oligoendopeptidase F', 156, NULL, NULL, 22672),
(22673, '1.25.40.10-FF-004928', NULL, 'Uncharacterized protein', 50, NULL, NULL, 22673),
(22674, '3.40.50.300-FF-005470', NULL, 'ATP-dependent RNA helicase DeaD', 222, NULL, NULL, 22674),
(22675, '2.60.120.200-FF-000152', NULL, 'Cell wall glucanase', 242, NULL, NULL, 22675),
(22676, '3.30.160.60-FF-006161', NULL, NULL, 84, NULL, NULL, 22676),
(22677, '1.20.58.340-FF-000081', NULL, 'Magnesium transporter MRS2-6, mitochondrial', 212, NULL, NULL, 22677),
(22678, '2.170.270.10-FF-000015', NULL, 'Zinc finger protein', 138, NULL, NULL, 22678),
(22679, '3.40.50.12160-FF-000027', NULL, 'RNA modification enzyme, MiaB family', 109, NULL, NULL, 22679),
(22680, '3.30.450.60-FF-000079', NULL, 'Zeta-coat protein, putative', 79, NULL, NULL, 22680),
(22681, '3.30.70.20-FF-000116', NULL, NULL, 72, NULL, NULL, 22681),
(22682, '2.130.10.10-FF-005649', NULL, 'Uncharacterized protein', 429, NULL, NULL, 22682),
(22683, '3.30.70.1070-FF-000014', NULL, 'Endolytic peptidoglycan transglycosylase RlpA', 77, NULL, NULL, 22683),
(22684, '3.40.50.1820-FF-000085', NULL, '2-hydroxy-6-oxononadienedioate/2-hydroxy-6-oxononatrienedioate hydrolase', 287, NULL, NULL, 22684),
(22685, '3.40.630.60-FF-000012', NULL, NULL, 116, NULL, NULL, 22685),
(22686, '3.40.190.10-FF-000108', NULL, 'melanotransferrin', 170, NULL, NULL, 22686),
(22687, '3.30.450.40-FF-000073', NULL, 'Stage II sporulation protein E', 158, NULL, NULL, 22687),
(22688, '2.90.10.10-FF-000014', NULL, 'Serine/threonine-protein kinase', 131, NULL, NULL, 22688),
(22689, '3.70.10.10-FF-000125', NULL, 'Uncharacterized protein', 85, NULL, NULL, 22689); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(22690, '1.10.357.90-FF-000006', NULL, 'Telomerase reverse transcriptase', 178, NULL, NULL, 22690),
(22691, '1.10.287.130-FF-000215', NULL, 'Sensory box histidine kinase', 75, NULL, NULL, 22691),
(22692, '3.10.100.10-FF-000436', NULL, NULL, 64, NULL, NULL, 22692),
(22693, '3.30.310.80-FF-000018', NULL, 'Serine/threonine-protein kinase grp', 129, NULL, NULL, 22693),
(22694, '2.40.50.100-FF-000057', NULL, 'Exosome complex component CSL4', 45, NULL, NULL, 22694),
(22695, '2.60.120.290-FF-000122', NULL, 'Uncharacterized protein', 118, NULL, NULL, 22695),
(22696, '3.20.20.80-FF-000244', NULL, 'O-Glycosyl hydrolases family 17 protein', 186, NULL, NULL, 22696),
(22697, '1.20.1560.10-FF-000132', NULL, 'ABC transporter B family member 5', 11, NULL, NULL, 22697),
(22698, '3.30.830.10-FF-000060', NULL, 'Putative mitochondrial processing peptidase alpha subunit', 243, NULL, NULL, 22698),
(22699, '2.60.40.60-FF-000751', NULL, 'Predicted protein', 107, NULL, NULL, 22699),
(22700, '3.10.129.10-FF-000069', NULL, '4-hydroxybenzoyl-CoA thioesterase', 132, NULL, NULL, 22700),
(22701, '2.60.40.150-FF-000796', NULL, 'Uncharacterized protein', 73, NULL, NULL, 22701),
(22702, '1.10.287.40-FF-000019', NULL, 'Uncharacterized protein', 118, NULL, NULL, 22702),
(22703, '3.40.50.2300-FF-000583', NULL, 'Gamma-glutamyltranspeptidase 1', 146, NULL, NULL, 22703),
(22704, '1.10.472.10-FF-000323', NULL, 'Uncharacterized protein', 74, NULL, NULL, 22704),
(22705, '3.40.50.12440-FF-000004', NULL, 'Anaerobic dimethyl sulfoxide reductase subunit A', 72, NULL, NULL, 22705),
(22706, '1.10.150.560-FF-000002', NULL, 'Major DNA-binding protein', 97, NULL, NULL, 22706),
(22707, '3.40.30.10-FF-000830', NULL, 'Protein disulfide-isomerase 5-2 isoform A', 136, NULL, NULL, 22707),
(22708, '1.10.3720.10-FF-000074', NULL, 'Glycerol-3-phosphate ABC transporter permease', 241, NULL, NULL, 22708),
(22709, '3.40.50.300-FF-004519', NULL, 'DEAD-box ATP-dependent RNA helicase 1', 200, NULL, NULL, 22709),
(22710, '3.40.50.200-FF-000100', NULL, 'Nucleobase-ascorbate transporter 12', 130, NULL, NULL, 22710),
(22711, '3.75.10.10-FF-000047', NULL, NULL, 240, NULL, NULL, 22711),
(22712, '2.60.40.1360-FF-000004', NULL, 'Alpha-mannosidase', 125, NULL, NULL, 22712),
(22713, '3.30.470.30-FF-000083', NULL, 'Putative DNA ligase 4', 39, NULL, NULL, 22713),
(22714, '3.40.50.1000-FF-000283', NULL, 'Phosphoserine phosphatase', 293, NULL, NULL, 22714),
(22715, '3.80.10.10-FF-000260', NULL, 'F-box/LRR-repeat protein 8', 318, NULL, NULL, 22715),
(22716, '2.60.40.10-FF-005104', NULL, NULL, 99, NULL, NULL, 22716),
(22717, '2.40.50.140-FF-000507', NULL, 'Os09g0560200 protein', 122, NULL, NULL, 22717),
(22718, '3.30.505.10-FF-000170', NULL, NULL, 73, NULL, NULL, 22718),
(22719, '1.10.150.120-FF-000005', NULL, 'Aldehyde dehydrogenase iron-sulfur subunit', 95, NULL, NULL, 22719),
(22720, '3.40.50.2300-FF-000690', NULL, 'Uncharacterized protein', 151, NULL, NULL, 22720),
(22721, '3.30.200.20-FF-001448', NULL, 'CAMK protein kinase', 101, NULL, NULL, 22721),
(22722, '3.40.1380.10-FF-000033', NULL, 'Uncharacterized protein', 123, NULL, NULL, 22722),
(22723, '1.10.3210.10-FF-000114', NULL, 'Uncharacterized protein', 135, NULL, NULL, 22723),
(22724, '1.10.10.60-FF-000529', NULL, 'upstream activation factor subunit spp27', 60, NULL, NULL, 22724),
(22725, '2.60.40.2860-FF-000027', NULL, 'Transmission-blocking target antigen s230', 148, NULL, NULL, 22725),
(22726, '3.30.160.60-FF-002794', NULL, 'Zinc finger protein 1060', 27, NULL, NULL, 22726),
(22727, '3.10.110.10-FF-000026', NULL, 'Ubiquitin-conjugating enzyme E2 variant', 139, NULL, NULL, 22727),
(22728, '1.20.58.1770-FF-000002', NULL, 'RILP-like protein 1 isoform X1', 89, NULL, NULL, 22728),
(22729, '2.60.120.290-FF-000015', NULL, 'Seizure protein 6 homolog isoform 2', 115, NULL, NULL, 22729),
(22730, '3.30.300.30-FF-000082', NULL, 'Putative long-chain-fatty-acid-CoA ligase', 119, NULL, NULL, 22730),
(22731, '3.30.2010.10-FF-000014', NULL, 'Peptidase M48 Ste24p', 90, NULL, NULL, 22731),
(22732, '2.40.30.330-FF-000009', NULL, 'Uncharacterized protein', 51, NULL, NULL, 22732);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(22733, '2.120.10.30-FF-000384', NULL, 'Vitellogenin receptor', 311, NULL, NULL, 22733),
(22734, '2.130.10.10-FF-000181', NULL, 'Proteasomal ATPase associated factor 1', 147, NULL, NULL, 22734),
(22735, '1.20.1050.10-FF-000161', NULL, 'Glutathione S-transferase, putative', 108, NULL, NULL, 22735),
(22736, '2.130.10.130-FF-000025', NULL, NULL, 185, NULL, NULL, 22736),
(22737, '1.10.510.10-FF-002453', NULL, NULL, 182, NULL, NULL, 22737),
(22738, '3.30.70.330-FF-002298', NULL, NULL, 95, NULL, NULL, 22738),
(22739, '3.90.70.10-FF-000167', NULL, 'Ubiquitin specific peptidase 18', 301, NULL, NULL, 22739),
(22740, '3.40.50.720-FF-001442', NULL, 'PKS-NRPS hybrid synthetase psoA', 329, NULL, NULL, 22740),
(22741, '2.60.40.10-FF-005997', NULL, NULL, 78, NULL, NULL, 22741),
(22742, '2.60.40.10-FF-001506', NULL, 'semaphorin-2A isoform X1', 90, NULL, NULL, 22742),
(22743, '3.40.50.150-FF-000169', NULL, 'Tellurite resistance methyltransferase TehB', 197, NULL, NULL, 22743),
(22744, '2.60.40.10-FF-000888', NULL, 'Roundabout guidance receptor 3', 109, NULL, NULL, 22744),
(22745, '3.30.420.40-FF-000245', NULL, 'Heat shock protein 70 putative', 92, NULL, NULL, 22745),
(22746, '2.10.25.10-FF-001451', NULL, 'Neurogenic locus notch homolog protein 1', 42, NULL, NULL, 22746),
(22747, '3.50.50.60-FF-000166', NULL, 'Squalene monooxygenase Erg1', 373, NULL, NULL, 22747),
(22748, '3.30.70.330-FF-001792', NULL, NULL, 124, NULL, NULL, 22748),
(22749, '1.10.506.10-FF-000105', NULL, 'Uncharacterized protein', 266, NULL, NULL, 22749),
(22750, '3.30.160.330-FF-000002', NULL, 'Protein E7', 52, NULL, NULL, 22750),
(22751, '2.70.40.10-FF-000005', NULL, 'dCTP deaminase, dUMP-forming', 186, NULL, NULL, 22751),
(22752, '3.50.50.60-FF-001003', NULL, 'Dihydropyrimidine dehydrogenase [NADP(+)]-like Protein', 215, NULL, NULL, 22752),
(22753, '1.20.1070.10-FF-001792', NULL, 'Predicted protein', 322, NULL, NULL, 22753),
(22754, '2.60.40.60-FF-000419', NULL, 'Uncharacterized protein', 109, NULL, NULL, 22754),
(22755, '1.10.10.200-FF-000011', NULL, 'Pol polyprotein', 53, NULL, NULL, 22755),
(22756, '3.30.519.10-FF-000016', NULL, 'RAB GDP-dissociation inhibitor, putative', 134, NULL, NULL, 22756),
(22757, '3.30.1010.10-FF-000103', NULL, 'UVSB', 188, NULL, NULL, 22757),
(22758, '1.10.3260.10-FF-000050', NULL, 'DNA ligase', 97, NULL, NULL, 22758),
(22759, '3.40.50.300-FF-008123', NULL, 'Cytoplasmic dynein heavy chain, putative', 106, NULL, NULL, 22759),
(22760, '3.50.50.60-FF-000059', NULL, 'polyamine oxidase 2', 208, NULL, NULL, 22760),
(22761, '3.30.50.10-FF-000112', NULL, 'GATA zinc finger domain-containing protein C1393.08', 65, NULL, NULL, 22761),
(22762, '3.30.160.60-FF-000646', NULL, 'Myeloid zinc finger 1', 28, NULL, NULL, 22762),
(22763, '1.20.58.1480-FF-000016', NULL, 'Lon protease homolog, mitochondrial', 88, NULL, NULL, 22763),
(22764, '3.30.565.10-FF-000179', NULL, 'Histidine kinase', 154, NULL, NULL, 22764),
(22765, '2.130.10.10-FF-004452', NULL, 'General transcription factor IIIC, polypeptide 2, beta', 347, NULL, NULL, 22765),
(22766, '2.40.30.170-FF-000052', NULL, NULL, 69, NULL, NULL, 22766),
(22767, '2.60.11.10-FF-000012', NULL, 'Uncharacterized protein', 99, NULL, NULL, 22767),
(22768, '3.40.50.620-FF-000670', NULL, 'Bifunctional riboflavin kinase/FMN adenylyltransferase', 146, NULL, NULL, 22768),
(22769, '2.40.10.340-FF-000014', NULL, 'Cell shape-determining protein MreC', 72, NULL, NULL, 22769),
(22770, '3.30.420.40-FF-001083', NULL, 'Phosphotransferase', 121, NULL, NULL, 22770),
(22771, '2.60.40.10-FF-003867', NULL, NULL, 84, NULL, NULL, 22771),
(22772, '3.40.710.10-FF-000189', NULL, 'Lpc53E1', 375, NULL, NULL, 22772),
(22773, '3.90.79.10-FF-000035', NULL, 'Uridine diphosphate glucose pyrophosphatase', 173, NULL, NULL, 22773),
(22774, '1.20.1310.10-FF-000074', NULL, 'Cullin-like protein', 111, NULL, NULL, 22774),
(22775, '3.60.21.10-FF-000454', NULL, '2`,3`-cyclic-nucleotide 2`-phosphodiesterase, putative', 296, NULL, NULL, 22775),
(22776, '1.20.1280.290-FF-000034', NULL, 'PQ loop repeat family protein', 106, NULL, NULL, 22776);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(22777, '2.30.30.40-FF-000167', NULL, 'SH3 and cysteine-rich domain-containing protein 3 isoform X1', 90, NULL, NULL, 22777),
(22778, '2.10.25.10-FF-000720', NULL, 'Multiple EGF like domains 9', 50, NULL, NULL, 22778),
(22779, '2.30.29.30-FF-000330', NULL, 'TBC1 (tre-2/USP6, BUB2, cdc16) domain family, member 1', 145, NULL, NULL, 22779),
(22780, '3.80.10.10-FF-000147', NULL, 'Erbin isoform X1', 114, NULL, NULL, 22780),
(22781, '3.40.50.880-FF-000152', NULL, '4-methyl-5-thiazole monophosphate biosynthesis enzyme', 185, NULL, NULL, 22781),
(22782, '3.30.160.60-FF-001158', NULL, 'zinc finger protein 22', 34, NULL, NULL, 22782),
(22783, '3.30.200.20-FF-001780', NULL, 'Serine/threonine protein kinase, putative', 79, NULL, NULL, 22783),
(22784, '3.40.50.300-FF-004756', NULL, 'CTP synthase', 80, NULL, NULL, 22784),
(22785, '2.60.120.1190-FF-000015', NULL, 'Uncharacterized protein', 178, NULL, NULL, 22785),
(22786, '3.40.50.720-FF-002061', NULL, 'Predicted protein', 164, NULL, NULL, 22786),
(22787, '3.40.50.2000-FF-000375', NULL, 'Glycosyltransferase WbpX', 157, NULL, NULL, 22787),
(22788, '3.30.160.60-FF-004935', NULL, NULL, 20, NULL, NULL, 22788),
(22789, '1.20.5.110-FF-000259', NULL, 'Synaptobrevin 2 isoform 1', 85, NULL, NULL, 22789),
(22790, '1.20.80.10-FF-000046', NULL, 'Protein CBG13772', 106, NULL, NULL, 22790),
(22791, '1.20.272.10-FF-000053', NULL, NULL, 96, NULL, NULL, 22791),
(22792, '3.40.50.620-FF-000338', NULL, 'Leucine--tRNA ligase, mitochondrial', 171, NULL, NULL, 22792),
(22793, '3.30.70.260-FF-000124', NULL, 'Prephenate dehydratase', 85, NULL, NULL, 22793),
(22794, '3.30.910.20-FF-000007', NULL, 'Cationic outer membrane protein', 144, NULL, NULL, 22794),
(22795, '3.10.129.10-FF-000176', NULL, 'Acyl-[acyl-carrier-protein] hydrolase', 128, NULL, NULL, 22795),
(22796, '1.10.10.60-FF-000170', NULL, 'Transcriptional adapter', 52, NULL, NULL, 22796),
(22797, '3.40.50.720-FF-000037', NULL, '3-oxoacyl-[acyl-carrier-protein] reductase FabG', 247, NULL, NULL, 22797),
(22798, '3.10.20.90-FF-000219', NULL, 'E3 ubiquitin-protein ligase RING1', 111, NULL, NULL, 22798),
(22799, '1.25.40.20-FF-001374', NULL, 'Predicted protein', 85, NULL, NULL, 22799),
(22800, '2.40.70.10-FF-000099', NULL, 'Putative aspartyl protease', 184, NULL, NULL, 22800),
(22801, '3.30.230.70-FF-000071', NULL, 'GM01970p', 206, NULL, NULL, 22801),
(22802, '1.25.40.10-FF-001949', NULL, 'Uncharacterized protein', 301, NULL, NULL, 22802),
(22803, '1.25.40.10-FF-002113', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 95, NULL, NULL, 22803),
(22804, '3.30.200.20-FF-000829', NULL, 'CAMK/CDPK protein kinase', 112, NULL, NULL, 22804),
(22805, '1.10.287.950-FF-000017', NULL, 'Methyl-accepting chemotaxis protein', 330, NULL, NULL, 22805),
(22806, '3.30.160.60-FF-003176', NULL, NULL, 31, NULL, NULL, 22806),
(22807, '1.25.10.10-FF-000363', NULL, 'Nuclear condensin complex subunit 3', 196, NULL, NULL, 22807),
(22808, '2.120.10.30-FF-000260', NULL, 'Uncharacterized protein', 139, NULL, NULL, 22808),
(22809, '1.10.510.10-FF-000997', NULL, 'Kinase, AGC NDR', 182, NULL, NULL, 22809),
(22810, '1.20.1740.10-FF-000230', NULL, 'Amino acid transporter', 421, NULL, NULL, 22810),
(22811, '3.30.40.10-FF-000522', NULL, 'RING-H2 finger protein ATL5', 75, NULL, NULL, 22811),
(22812, '3.40.190.10-FF-000215', NULL, 'Peptide ABC transporter substrate-binding protein', 124, NULL, NULL, 22812),
(22813, '3.90.550.10-FF-000176', NULL, 'Cellulose synthase-like protein B3', 157, NULL, NULL, 22813),
(22814, '3.80.10.10-FF-002401', NULL, 'Uncharacterized protein', 54, NULL, NULL, 22814),
(22815, '3.40.720.10-FF-000021', NULL, 'Galactosamine (N-acetyl)-6-sulfatase', 350, NULL, NULL, 22815),
(22816, '1.20.144.10-FF-000008', NULL, 'Phosphatidylglycerophosphatase B', 254, NULL, NULL, 22816),
(22817, '3.60.20.40-FF-000028', NULL, 'Uncharacterized protein', 197, NULL, NULL, 22817),
(22818, '3.40.630.10-FF-000244', NULL, 'Os03g0836800 protein', 142, NULL, NULL, 22818),
(22819, '1.20.1640.10-FF-000065', NULL, 'PaTched Related family', 205, NULL, NULL, 22819); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(22820, '1.10.640.10-FF-000080', NULL, 'Oxidase/peroxidase, putative', 247, NULL, NULL, 22820),
(22821, '3.80.10.10-FF-002058', NULL, 'Uncharacterized protein', 100, NULL, NULL, 22821),
(22822, '1.20.120.1920-FF-000004', NULL, 'GG24751', 77, NULL, NULL, 22822),
(22823, '3.10.20.90-FF-000770', NULL, 'Talin', 85, NULL, NULL, 22823),
(22824, '3.40.47.10-FF-000245', NULL, NULL, 244, NULL, NULL, 22824),
(22825, '3.80.10.10-FF-003817', NULL, 'Uncharacterized protein', 80, NULL, NULL, 22825),
(22826, '3.30.565.10-FF-000504', NULL, 'Uncharacterized protein', 116, NULL, NULL, 22826),
(22827, '4.10.400.10-FF-000146', NULL, 'Uncharacterized protein, isoform B', 41, NULL, NULL, 22827),
(22828, '3.30.260.10-FF-000044', NULL, 'T-complex protein 1 subunit gamma', 111, NULL, NULL, 22828),
(22829, '1.10.10.60-FF-001243', NULL, NULL, 44, NULL, NULL, 22829),
(22830, '3.30.200.20-FF-000144', NULL, 'Cyclin-dependent kinase 5', 84, NULL, NULL, 22830),
(22831, '3.30.590.10-FF-000029', NULL, 'Creatine kinase, mitochondrial 2b (sarcomeric)', 112, NULL, NULL, 22831),
(22832, '2.30.30.30-FF-000069', NULL, '30S ribosomal protein S4e', 67, NULL, NULL, 22832),
(22833, '3.90.1150.10-FF-000358', NULL, 'Perosamine synthetase', 121, NULL, NULL, 22833),
(22834, '3.80.10.10-FF-001783', NULL, 'Leucine-rich HEV glycoprotein', 175, NULL, NULL, 22834),
(22835, '3.10.20.90-FF-000438', NULL, 'Plexin-B1', 99, NULL, NULL, 22835),
(22836, '2.70.130.10-FF-000057', NULL, NULL, 86, NULL, NULL, 22836),
(22837, '3.40.50.10810-FF-000201', NULL, 'SNF2 family DNA-dependent ATPase', 167, NULL, NULL, 22837),
(22838, '1.20.1690.10-FF-000012', NULL, 'V-type proton ATPase subunit', 104, NULL, NULL, 22838),
(22839, '1.10.238.10-FF-000509', NULL, 'EF-hand calcium-binding protein', 49, NULL, NULL, 22839),
(22840, '2.60.34.10-FF-000048', NULL, 'Protein CBG02604', 184, NULL, NULL, 22840),
(22841, '1.25.10.10-FF-001892', NULL, 'U3 small nucleolar RNA-associated protein 20', 294, NULL, NULL, 22841),
(22842, '1.20.58.1020-FF-000013', NULL, 'Uncharacterized protein', 95, NULL, NULL, 22842),
(22843, '2.60.40.10-FF-003182', NULL, 'Insulin-like receptor', 87, NULL, NULL, 22843),
(22844, '2.130.10.30-FF-000063', NULL, 'GG11698', 331, NULL, NULL, 22844),
(22845, '3.30.420.80-FF-000010', NULL, '30S ribosomal protein S11', 124, NULL, NULL, 22845),
(22846, '3.30.30.10-FF-000004', NULL, 'Defensin-like protein CAL1', 47, NULL, NULL, 22846),
(22847, '1.20.1250.20-FF-000364', NULL, 'MFS general substrate transporter', 202, NULL, NULL, 22847),
(22848, '3.40.50.1820-FF-001607', NULL, 'Os06g0519700 protein', 73, NULL, NULL, 22848),
(22849, '1.10.1820.10-FF-000014', NULL, 'Casein kinase II subunit beta', 105, NULL, NULL, 22849),
(22850, '1.10.510.10-FF-001161', NULL, 'Os11g0601500 protein', 148, NULL, NULL, 22850),
(22851, '3.50.50.60-FF-000278', NULL, 'Polyamine oxidase 1', 237, NULL, NULL, 22851),
(22852, '3.20.20.70-FF-000022', NULL, '3-keto-L-gulonate-6-phosphate decarboxylase UlaD', 210, NULL, NULL, 22852),
(22853, '1.25.10.10-FF-000144', NULL, 'rap1 GTPase-GDP dissociation stimulator 1 isoform X1', 136, NULL, NULL, 22853),
(22854, '3.30.1640.10-FF-000022', NULL, 'DNA helicase', 113, NULL, NULL, 22854),
(22855, '1.20.58.1040-FF-000019', NULL, 'Beta-1, 3-glucanase-like protein', 88, NULL, NULL, 22855),
(22856, '3.30.930.10-FF-000005', NULL, 'Histidine--tRNA ligase', 323, NULL, NULL, 22856),
(22857, '1.10.510.10-FF-002234', NULL, NULL, 189, NULL, NULL, 22857),
(22858, '1.10.1420.10-FF-000141', NULL, 'DNA mismatch repair protein', 179, NULL, NULL, 22858),
(22859, '1.20.1110.10-FF-000093', NULL, 'Uncharacterized protein', 187, NULL, NULL, 22859),
(22860, '1.20.1720.10-FF-000010', NULL, 'Multidrug resistance protein MdtM', 379, NULL, NULL, 22860),
(22861, '3.30.40.10-FF-001808', NULL, 'Predicted protein', 72, NULL, NULL, 22861),
(22862, '3.40.50.720-FF-000930', NULL, 'Vibriobactin-specific 2,3-dihydro-2,3-dihydroxybenzoate dehydrogenase', 261, NULL, NULL, 22862),
(22863, '1.10.472.10-FF-000447', NULL, 'Cyclin G1', 150, NULL, NULL, 22863),
(22864, '3.40.50.10810-FF-000190', NULL, 'Excision repair cross-complementation group 6-like', 127, NULL, NULL, 22864);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(22865, '3.10.450.50-FF-000064', NULL, 'De-ubiquitination complex subunit, putative', 159, NULL, NULL, 22865),
(22866, '1.10.340.30-FF-000046', NULL, 'DNA-(Apurinic or apyrimidinic site) lyase', 119, NULL, NULL, 22866),
(22867, '2.60.40.10-FF-004379', NULL, NULL, 102, NULL, NULL, 22867),
(22868, '2.60.40.10-FF-004255', NULL, NULL, 133, NULL, NULL, 22868),
(22869, '2.10.25.10-FF-001119', NULL, 'Uncharacterized protein', 37, NULL, NULL, 22869),
(22870, '2.40.37.20-FF-000013', NULL, NULL, 143, NULL, NULL, 22870),
(22871, '1.10.580.10-FF-000035', NULL, 'Predicted protein', 58, NULL, NULL, 22871),
(22872, '3.30.200.20-FF-002292', NULL, 'Uncharacterized protein DR_0394', 98, NULL, NULL, 22872),
(22873, '1.10.8.270-FF-000079', NULL, 'Rab GTPase activating protein, putative', 101, NULL, NULL, 22873),
(22874, '3.40.109.10-FF-000027', NULL, 'Nitroreductase family protein', 180, NULL, NULL, 22874),
(22875, '3.40.50.720-FF-001661', NULL, 'Os02g0640600 protein', 68, NULL, NULL, 22875),
(22876, '3.40.630.30-FF-000469', NULL, 'GNAT family acetyltransferase', 162, NULL, NULL, 22876),
(22877, '3.40.50.300-FF-005363', NULL, 'Structural maintenance of chromosomes 3', 138, NULL, NULL, 22877),
(22878, '1.20.58.60-FF-000330', NULL, 'Uncharacterized protein, isoform D', 213, NULL, NULL, 22878),
(22879, '1.20.1560.10-FF-000929', NULL, 'Predicted protein', 58, NULL, NULL, 22879),
(22880, '2.160.20.10-FF-000320', NULL, 'Uncharacterized protein', 162, NULL, NULL, 22880),
(22881, '3.30.460.10-FF-000025', NULL, 'probable GTP diphosphokinase CRSH, chloroplastic', 154, NULL, NULL, 22881),
(22882, '1.10.20.140-FF-000023', NULL, NULL, 57, NULL, NULL, 22882),
(22883, '1.25.40.10-FF-000876', NULL, 'crooked neck-like protein 1', 105, NULL, NULL, 22883),
(22884, '3.30.70.330-FF-001573', NULL, NULL, 94, NULL, NULL, 22884),
(22885, '2.40.50.40-FF-000084', NULL, 'Interleukin-8', 67, NULL, NULL, 22885),
(22886, '1.50.40.10-FF-000576', NULL, 'Uncharacterized protein', 75, NULL, NULL, 22886),
(22887, '1.10.10.10-FF-001144', NULL, 'Molybdenum transport operon repressor MopA', 112, NULL, NULL, 22887),
(22888, '2.40.128.130-FF-000011', NULL, 'Uncharacterized protein', 317, NULL, NULL, 22888),
(22889, '3.30.2090.10-FF-000007', NULL, 'Efflux pump membrane transporter', 89, NULL, NULL, 22889),
(22890, '2.70.150.10-FF-000165', NULL, 'Phospholipid-transporting ATPase', 132, NULL, NULL, 22890),
(22891, '2.70.170.10-FF-000178', NULL, 'Glycine receptor alpha 2', 82, NULL, NULL, 22891),
(22892, '3.30.450.40-FF-000197', NULL, 'Polyketide synthase', 162, NULL, NULL, 22892),
(22893, '3.30.70.2000-FF-000001', NULL, 'Potassium channel tetramerization domain-containing 17', 57, NULL, NULL, 22893),
(22894, '1.25.40.990-FF-000007', NULL, 'SAC3 domain containing 1', 291, NULL, NULL, 22894),
(22895, '3.10.330.10-FF-000026', NULL, 'ATPase of the AAA+ class Posttranslational modification protein', 76, NULL, NULL, 22895),
(22896, '2.130.10.10-FF-001254', NULL, 'BnaC01g39200D protein', 308, NULL, NULL, 22896),
(22897, '2.60.40.10-FF-000669', NULL, 'Vascular endothelial growth factor receptor 2', 130, NULL, NULL, 22897),
(22898, '3.30.420.40-FF-000026', NULL, 'Heat shock protein 70', 197, NULL, NULL, 22898),
(22899, '1.20.120.1750-FF-000150', NULL, 'RBR-type E3 ubiquitin transferase', 241, NULL, NULL, 22899),
(22900, '1.10.10.10-FF-000868', NULL, 'ECF RNA polymerase sigma factor SigK', 93, NULL, NULL, 22900),
(22901, '1.25.70.10-FF-000029', NULL, 'Os05g0403600 protein', 232, NULL, NULL, 22901),
(22902, '3.20.20.70-FF-000707', NULL, NULL, 141, NULL, NULL, 22902),
(22903, '3.30.40.10-FF-000741', NULL, 'Uncharacterized protein, isoform A', 85, NULL, NULL, 22903),
(22904, '1.10.287.110-FF-000333', NULL, 'Mitochondrial import inner membrane translocase subunit TIM16', 82, NULL, NULL, 22904),
(22905, '3.10.310.20-FF-000016', NULL, NULL, 145, NULL, NULL, 22905),
(22906, '3.40.50.300-FF-003452', NULL, '26S protease regulatory subunit 7', 184, NULL, NULL, 22906),
(22907, '3.40.250.10-FF-000041', NULL, 'Sulfurtransferase', 145, NULL, NULL, 22907),
(22908, '1.25.40.10-FF-000191', NULL, 'Signal recognition particle subunit SRP72', 120, NULL, NULL, 22908);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(22909, '3.30.1460.50-FF-000019', NULL, 'Autophagy-related protein 3', 128, NULL, NULL, 22909),
(22910, '1.25.40.510-FF-000010', NULL, 'Nucleoporin GLE1', 278, NULL, NULL, 22910),
(22911, '2.30.30.40-FF-000622', NULL, 'Src kinase associated phosphoprotein 1', 41, NULL, NULL, 22911),
(22912, '3.30.160.60-FF-001501', NULL, 'Zinc finger protein 483', 28, NULL, NULL, 22912),
(22913, '1.10.287.90-FF-000012', NULL, 'Uncharacterized protein', 60, NULL, NULL, 22913),
(22914, '1.10.20.10-FF-000133', NULL, 'Dls1p', 81, NULL, NULL, 22914),
(22915, '2.60.40.10-FF-005216', NULL, NULL, 90, NULL, NULL, 22915),
(22916, '1.20.1050.10-FF-000267', NULL, 'Uncharacterized protein', 119, NULL, NULL, 22916),
(22917, '2.130.10.10-FF-000978', NULL, 'U3 small nucleolar RNA-associated protein 15 homolog', 171, NULL, NULL, 22917),
(22918, '2.70.70.10-FF-000070', NULL, 'Peptidase M23B', 127, NULL, NULL, 22918),
(22919, '3.60.15.10-FF-000182', NULL, 'Acylhomoserine lactonase', 294, NULL, NULL, 22919),
(22920, '1.20.120.1900-FF-000009', NULL, 'Gamma-tubulin complex component', 306, NULL, NULL, 22920),
(22921, '2.30.180.10-FF-000081', NULL, 'Fasciclin domain protein', 165, NULL, NULL, 22921),
(22922, '3.30.450.20-FF-000191', NULL, 'Two-component system sensor', 102, NULL, NULL, 22922),
(22923, '3.10.450.710-FF-000001', NULL, 'ABC transporter substrate-binding protein MlaC', 181, NULL, NULL, 22923),
(22924, '2.40.50.140-FF-000726', NULL, NULL, 64, NULL, NULL, 22924),
(22925, '3.40.50.2300-FF-000471', NULL, 'Uncharacterized protein', 173, NULL, NULL, 22925),
(22926, '3.30.1600.10-FF-000025', NULL, 'Sirtuin type 2', 130, NULL, NULL, 22926),
(22927, '3.40.1410.10-FF-000031', NULL, 'Probable chorismate pyruvate-lyase', 167, NULL, NULL, 22927),
(22928, '3.30.40.10-FF-001247', NULL, 'Histone-lysine N-methyltransferase', 45, NULL, NULL, 22928),
(22929, '2.60.40.10-FF-002563', NULL, 'Neural cell adhesion molecule L1', 103, NULL, NULL, 22929),
(22930, '1.10.8.60-FF-000202', NULL, 'Putative conserved atpase', 67, NULL, NULL, 22930),
(22931, '1.10.357.20-FF-000025', NULL, 'Chromosome 1, whole genome shotgun sequence', 202, NULL, NULL, 22931),
(22932, '2.60.200.20-FF-000091', NULL, 'Protein kinase, putative', 147, NULL, NULL, 22932),
(22933, '3.40.390.10-FF-000107', NULL, 'Extracellular metalloprotease 1', 220, NULL, NULL, 22933),
(22934, '3.30.160.60-FF-002338', NULL, 'Zinc finger, imprinted 1', 31, NULL, NULL, 22934),
(22935, '1.10.1170.10-FF-000048', NULL, 'baculoviral IAP repeat-containing protein 3', 105, NULL, NULL, 22935),
(22936, '3.40.50.1820-FF-000321', NULL, 'Lipase domain containing protein', 242, NULL, NULL, 22936),
(22937, '2.60.40.10-FF-005559', NULL, NULL, 114, NULL, NULL, 22937),
(22938, '3.30.60.30-FF-000170', NULL, 'Agr-1', 68, NULL, NULL, 22938),
(22939, '3.90.1750.10-FF-000106', NULL, 'E3 ubiquitin-protein ligase', 58, NULL, NULL, 22939),
(22940, '3.40.525.10-FF-000005', NULL, 'Tyrosine-protein phosphatase non-receptor type 9', 168, NULL, NULL, 22940),
(22941, '2.60.40.1180-FF-000158', NULL, 'Glycoside hydrolase superfamily', 98, NULL, NULL, 22941),
(22942, '3.40.630.20-FF-000028', NULL, 'Pyroglutamyl-peptidase I (C15 family)', 222, NULL, NULL, 22942),
(22943, '3.30.470.160-FF-000010', NULL, 'Kinase', 314, NULL, NULL, 22943),
(22944, '1.25.40.10-FF-003861', NULL, 'Uncharacterized protein', 106, NULL, NULL, 22944),
(22945, '3.20.20.100-FF-000024', NULL, 'Aryl-alcohol dehydrogenase', 344, NULL, NULL, 22945),
(22946, '2.40.50.150-FF-000044', NULL, 'DNA-directed RNA polymerase subunit beta', 117, NULL, NULL, 22946),
(22947, '3.30.160.60-FF-003631', NULL, NULL, 25, NULL, NULL, 22947),
(22948, '1.10.10.60-FF-000967', NULL, NULL, 57, NULL, NULL, 22948),
(22949, '2.130.10.10-FF-003738', NULL, 'Uncharacterized protein', 411, NULL, NULL, 22949),
(22950, '1.25.40.530-FF-000016', NULL, 'Myosin 10A, isoform C', 116, NULL, NULL, 22950),
(22951, '3.40.1090.10-FF-000151', NULL, 'Phospholipase A2', 69, NULL, NULL, 22951),
(22952, '1.10.530.10-FF-000088', NULL, 'Lysozyme like 4', 51, NULL, NULL, 22952),
(22953, '2.170.120.12-FF-000018', NULL, 'DNA-directed RNA polymerase RPB3', 133, NULL, NULL, 22953);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(22954, '3.30.70.330-FF-002192', NULL, NULL, 129, NULL, NULL, 22954),
(22955, '3.40.30.10-FF-000936', NULL, 'Predicted protein', 113, NULL, NULL, 22955),
(22956, '2.130.10.10-FF-002890', NULL, 'Uncharacterized protein', 204, NULL, NULL, 22956),
(22957, '3.40.30.10-FF-000594', NULL, 'GD16632', 124, NULL, NULL, 22957),
(22958, '3.30.160.60-FF-003974', NULL, NULL, 63, NULL, NULL, 22958),
(22959, '1.20.58.60-FF-000779', NULL, 'Spectrin repeat containing nuclear envelope protein 2', 226, NULL, NULL, 22959),
(22960, '1.10.565.10-FF-000011', NULL, 'Nuclear receptor subfamily 5, group A, member 2', 239, NULL, NULL, 22960),
(22961, '3.30.160.60-FF-006380', NULL, NULL, 29, NULL, NULL, 22961),
(22962, '1.10.10.10-FF-000525', NULL, 'Z-DNA binding protein 1', 72, NULL, NULL, 22962),
(22963, '1.10.132.130-FF-000005', NULL, NULL, 109, NULL, NULL, 22963),
(22964, '1.20.1530.20-FF-000077', NULL, 'Predicted protein', 263, NULL, NULL, 22964),
(22965, '1.10.10.10-FF-002105', NULL, 'Uncharacterized protein', 91, NULL, NULL, 22965),
(22966, '3.30.70.1230-FF-000085', NULL, 'Adenylate/guanylate cyclase domain-containing protein', 201, NULL, NULL, 22966),
(22967, '3.30.710.10-FF-000461', NULL, 'Uncharacterized protein', 125, NULL, NULL, 22967),
(22968, '3.40.50.1390-FF-000023', NULL, 'Sll0177 protein', 90, NULL, NULL, 22968),
(22969, '3.90.1170.50-FF-000012', NULL, 'Gad-3', 142, NULL, NULL, 22969),
(22970, '3.30.1330.10-FF-000032', NULL, 'Phosphoribosylformylglycinamidine synthase subunit PurL', 147, NULL, NULL, 22970),
(22971, '4.10.800.10-FF-000019', NULL, 'Proteoglycan Cow', 61, NULL, NULL, 22971),
(22972, '1.10.940.10-FF-000024', NULL, '16S rRNA (cytosine(967)-C(5))-methyltransferase', 129, NULL, NULL, 22972),
(22973, '2.30.29.30-FF-000329', NULL, 'alpha-1-syntrophin', 95, NULL, NULL, 22973),
(22974, '3.40.50.300-FF-004413', NULL, 'Putative Rho-related GTP-binding protein RhoU', 182, NULL, NULL, 22974),
(22975, '3.40.228.10-FF-000006', NULL, 'Formate dehydrogenase, alpha subunit, selenocysteine-containing', 294, NULL, NULL, 22975),
(22976, '1.10.10.10-FF-001829', NULL, 'Predicted protein', 98, NULL, NULL, 22976),
(22977, '2.60.40.420-FF-000225', NULL, 'Periplasmic cell division protein (SufI)', 193, NULL, NULL, 22977),
(22978, '3.40.50.300-FF-002272', NULL, 'protein PHOTOPERIOD-INDEPENDENT EARLY FLOWERING 1 isoform X1', 250, NULL, NULL, 22978),
(22979, '2.20.20.110-FF-000008', NULL, 'Uncharacterized protein', 50, NULL, NULL, 22979),
(22980, '3.40.50.10190-FF-000060', NULL, 'G1/S regulator NimO, putative', 81, NULL, NULL, 22980),
(22981, '3.30.160.20-FF-000101', NULL, 'Loquacious, isoform B', 83, NULL, NULL, 22981),
(22982, '3.30.70.1350-FF-000008', NULL, 'Metal tolerance protein C1', 91, NULL, NULL, 22982),
(22983, '2.10.110.10-FF-000137', NULL, 'Mechanosensory protein 3', 63, NULL, NULL, 22983),
(22984, '1.20.1610.10-FF-000018', NULL, 'Alpha-1,2-mannosidase family protein', 154, NULL, NULL, 22984),
(22985, '2.130.10.10-FF-002777', NULL, 'BUB3 mitotic checkpoint protein', 221, NULL, NULL, 22985),
(22986, '1.25.40.10-FF-003529', NULL, 'Uncharacterized protein', 136, NULL, NULL, 22986),
(22987, '3.30.70.1050-FF-000019', NULL, 'Chloroplast trigger factor', 134, NULL, NULL, 22987),
(22988, '3.40.30.10-FF-000032', NULL, 'Protein disulfide-isomerase A6 homolog', 120, NULL, NULL, 22988),
(22989, '3.90.760.10-FF-000001', NULL, 'Flavocytochrome C flavoprotein subunit', 71, NULL, NULL, 22989),
(22990, '3.30.40.10-FF-000286', NULL, 'TNF receptor-associated factor', 116, NULL, NULL, 22990),
(22991, '1.25.40.10-FF-004367', NULL, 'Uncharacterized protein', 261, NULL, NULL, 22991),
(22992, '3.80.10.10-FF-003019', NULL, 'Uncharacterized protein', 158, NULL, NULL, 22992),
(22993, '3.30.160.60-FF-002670', NULL, 'D19A', 89, NULL, NULL, 22993),
(22994, '1.25.40.10-FF-000533', NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', 223, NULL, NULL, 22994),
(22995, '3.30.310.10-FF-000037', NULL, 'Adaptin N terminal region family protein', 111, NULL, NULL, 22995),
(22996, '3.40.640.10-FF-000088', NULL, 'Bifunctional dethiobiotin synthetase/7,8-diamino-pelargonic acid aminotransferase', 333, NULL, NULL, 22996);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(22997, '1.25.40.10-FF-004822', NULL, 'Pentatricopeptide repeat-containing protein', 150, NULL, NULL, 22997),
(22998, '2.60.40.10-FF-005891', NULL, NULL, 95, NULL, NULL, 22998),
(22999, '2.170.300.10-FF-000013', NULL, 'Scavenger receptor class F, member 2', 108, NULL, NULL, 22999),
(23000, '3.40.50.12780-FF-000213', NULL, 'Uncharacterized protein', 87, NULL, NULL, 23000),
(23001, '1.10.510.10-FF-002577', NULL, NULL, 234, NULL, NULL, 23001),
(23002, '3.30.60.20-FF-000054', NULL, 'Diacylglycerol kinase', 66, NULL, NULL, 23002),
(23003, '2.130.10.10-FF-002215', NULL, 'Uncharacterized protein', 415, NULL, NULL, 23003),
(23004, '3.90.550.50-FF-000160', NULL, 'Uncharacterized protein', 243, NULL, NULL, 23004),
(23005, '1.20.1250.10-FF-000142', NULL, NULL, 33, NULL, NULL, 23005),
(23006, '2.60.40.10-FF-004598', NULL, NULL, 87, NULL, NULL, 23006),
(23007, '3.30.559.10-FF-000119', NULL, 'Carnitine O-octanoyltransferase', 79, NULL, NULL, 23007),
(23008, '1.20.1250.20-FF-000600', NULL, 'Blast:Putative inorganic phosphate cotransporter', 439, NULL, NULL, 23008),
(23009, '2.30.29.30-FF-001280', NULL, 'FERM domain-containing protein A', 96, NULL, NULL, 23009),
(23010, '3.80.10.10-FF-001440', NULL, 'F-box/LRR-repeat protein 10', 363, NULL, NULL, 23010),
(23011, '1.20.58.60-FF-000436', NULL, 'Spectrin beta non-erythrocytic 5', 305, NULL, NULL, 23011),
(23012, '2.60.120.650-FF-000045', NULL, 'F-box protein At1g78280', 254, NULL, NULL, 23012),
(23013, '3.40.50.300-FF-007162', NULL, 'RecA protein', 174, NULL, NULL, 23013),
(23014, '1.20.5.420-FF-000015', NULL, 'Protein CBR-SGT-1', 71, NULL, NULL, 23014),
(23015, '2.60.40.10-FF-002125', NULL, 'Netrin receptor UNC5D', 62, NULL, NULL, 23015),
(23016, '3.90.226.10-FF-000030', NULL, 'Acetyl-CoA carboxylase carboxyltransferase subunit', 267, NULL, NULL, 23016),
(23017, '3.30.750.24-FF-000117', NULL, 'Ssr1600 protein', 79, NULL, NULL, 23017),
(23018, '2.10.50.30-FF-000003', NULL, 'Vomeronasal 2, receptor 120', 79, NULL, NULL, 23018),
(23019, '1.10.3080.10-FF-000064', NULL, 'Uncharacterized protein', 243, NULL, NULL, 23019),
(23020, '3.40.30.10-FF-000375', NULL, 'YGR201C-like protein', 83, NULL, NULL, 23020),
(23021, '3.20.20.220-FF-000043', NULL, 'Proline dehydrogenase', 362, NULL, NULL, 23021),
(23022, '2.60.40.10-FF-001849', NULL, 'Sidekick, isoform B', 109, NULL, NULL, 23022),
(23023, '3.40.850.10-FF-000463', NULL, 'Kinesin-like protein', 371, NULL, NULL, 23023),
(23024, '3.40.50.1000-FF-000064', NULL, 'HAD hydrolase, family IA', 133, NULL, NULL, 23024),
(23025, '1.10.1600.10-FF-000014', NULL, 'Predicted protein', 94, NULL, NULL, 23025),
(23026, '3.10.20.360-FF-000008', NULL, NULL, 39, NULL, NULL, 23026),
(23027, '3.80.10.10-FF-003570', NULL, 'Uncharacterized protein', 145, NULL, NULL, 23027),
(23028, '2.30.30.40-FF-000061', NULL, 'Cytoplasmic protein', 62, NULL, NULL, 23028),
(23029, '1.20.120.230-FF-000047', NULL, 'Probable vinculin', 167, NULL, NULL, 23029),
(23030, '1.10.510.10-FF-003414', NULL, NULL, 295, NULL, NULL, 23030),
(23031, '2.10.110.10-FF-000356', NULL, 'Uncharacterized protein', 46, NULL, NULL, 23031),
(23032, '2.60.120.260-FF-000017', NULL, 'Laminin subunit alpha 2', 279, NULL, NULL, 23032),
(23033, '3.30.2160.10-FF-000002', NULL, 'Putative Ubiquitin-protein ligase E3C', 80, NULL, NULL, 23033),
(23034, '3.90.20.10-FF-000001', NULL, 'Hemagglutinin', 273, NULL, NULL, 23034),
(23035, '3.30.160.60-FF-000540', NULL, 'zinc finger protein 263 isoform X1', 28, NULL, NULL, 23035),
(23036, '3.30.1330.30-FF-000038', NULL, 'TrmH family tRNA/rRNA methyltransferase YacO', 72, NULL, NULL, 23036),
(23037, '3.30.200.20-FF-002398', NULL, 'Muscle-associated receptor tyrosine kinase', 93, NULL, NULL, 23037),
(23038, '4.10.60.10-FF-000067', NULL, 'Air2p', 51, NULL, NULL, 23038),
(23039, '1.10.630.10-FF-000596', NULL, 'Uncharacterized protein', 280, NULL, NULL, 23039),
(23040, '3.30.230.10-FF-000216', NULL, 'Uncharacterized protein', 205, NULL, NULL, 23040),
(23041, '1.25.40.10-FF-004243', NULL, 'Uncharacterized protein', 236, NULL, NULL, 23041),
(23042, '3.40.50.620-FF-000232', NULL, 'Isoleucine--tRNA ligase, putative', 175, NULL, NULL, 23042);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(23043, '2.30.30.40-FF-000403', NULL, 'Rho GTPase-activating protein 27,-like', 70, NULL, NULL, 23043),
(23044, '3.40.50.300-FF-006886', NULL, 'Probable ABC transporter ATP-binding protein p29', 244, NULL, NULL, 23044),
(23045, '2.60.120.200-FF-000713', NULL, 'Laminin subunit alpha 5', 178, NULL, NULL, 23045),
(23046, '3.40.50.300-FF-001996', NULL, 'DNA helicase MCM8, putative', 335, NULL, NULL, 23046),
(23047, '3.40.30.10-FF-001212', NULL, 'Uncharacterized protein', 43, NULL, NULL, 23047),
(23048, '2.40.70.10-FF-000211', NULL, 'Endopeptidase', 197, NULL, NULL, 23048),
(23049, '3.40.50.360-FF-000007', NULL, 'Drug activity modulator B', 193, NULL, NULL, 23049),
(23050, '1.20.1070.10-FF-001117', NULL, 'Predicted protein', 308, NULL, NULL, 23050),
(23051, '3.30.70.660-FF-000031', NULL, 'tRNA pseudouridine synthase A', 138, NULL, NULL, 23051),
(23052, '2.30.42.10-FF-000293', NULL, 'Inactivation-no-after-potential D protein', 111, NULL, NULL, 23052),
(23053, '3.30.497.10-FF-000115', NULL, 'SeRPin', 223, NULL, NULL, 23053),
(23054, '1.10.10.10-FF-000183', NULL, 'Cullin 3', 89, NULL, NULL, 23054),
(23055, '3.10.20.340-FF-000002', NULL, 'Arginine biosynthesis bifunctional protein ArgJ, mitochondrial', 139, NULL, NULL, 23055),
(23056, '1.20.58.70-FF-000097', NULL, 'Syntaxin 4-2', 203, NULL, NULL, 23056),
(23057, '2.130.10.10-FF-001597', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit', 250, NULL, NULL, 23057),
(23058, '3.30.420.40-FF-000369', NULL, 'WGS project CABT00000000 data, contig 2.85', 100, NULL, NULL, 23058),
(23059, '3.80.10.10-FF-003694', NULL, 'Si:ch211-213a13.2', 173, NULL, NULL, 23059),
(23060, '3.40.50.720-FF-002167', NULL, 'Fatty acyl-CoA reductase', 73, NULL, NULL, 23060),
(23061, '3.40.50.300-FF-006543', NULL, 'SD07888p', 107, NULL, NULL, 23061),
(23062, '1.25.40.20-FF-000992', NULL, 'Os05g0427600 protein', 171, NULL, NULL, 23062),
(23063, '2.60.120.1020-FF-000010', NULL, 'Uncharacterized protein', 160, NULL, NULL, 23063),
(23064, '1.20.5.190-FF-000007', NULL, 'Myosin-ib isoform 2', 49, NULL, NULL, 23064),
(23065, '3.30.70.330-FF-002410', NULL, NULL, 93, NULL, NULL, 23065),
(23066, '2.130.10.10-FF-005868', NULL, 'Putative CPSF-domain protein', 308, NULL, NULL, 23066),
(23067, '1.10.238.10-FF-000403', NULL, 'Troponin C, skeletal muscle', 65, NULL, NULL, 23067),
(23068, '2.60.260.20-FF-000100', NULL, 'DnaJ heat shock protein family (Hsp40) member A2b', 53, NULL, NULL, 23068),
(23069, '3.60.21.10-FF-000235', NULL, 'Metallophosphoesterase', 196, NULL, NULL, 23069),
(23070, '3.30.342.10-FF-000032', NULL, 'DNA polymerase', 167, NULL, NULL, 23070),
(23071, '3.30.460.90-FF-000009', NULL, 'Cyclic GMP-AMP synthase', 186, NULL, NULL, 23071),
(23072, '2.40.320.10-FF-000034', NULL, 'Mediator of RNA polymerase II transcription subunit 18', 266, NULL, NULL, 23072),
(23073, '3.30.40.10-FF-001702', NULL, 'Ubiquitin carboxyl-terminal hydrolase 33', 64, NULL, NULL, 23073),
(23074, '1.10.287.550-FF-000004', NULL, 'Arylsulfatase H', 59, NULL, NULL, 23074),
(23075, '3.80.10.10-FF-004531', NULL, 'Uncharacterized protein', 196, NULL, NULL, 23075),
(23076, '1.20.140.20-FF-000008', NULL, 'Probable [pyruvate dehydrogenase (acetyl-transferring)] kinase, mitochondrial', 165, NULL, NULL, 23076),
(23077, '1.10.730.10-FF-000087', NULL, 'probable arginine--tRNA ligase, cytoplasmic', 132, NULL, NULL, 23077),
(23078, '3.30.365.10-FF-000068', NULL, 'Uncharacterized protein', 14, NULL, NULL, 23078),
(23079, '1.20.920.20-FF-000074', NULL, 'Uncharacterized protein', 84, NULL, NULL, 23079),
(23080, '3.30.70.270-FF-000240', NULL, NULL, 168, NULL, NULL, 23080),
(23081, '1.10.510.10-FF-003757', NULL, NULL, 142, NULL, NULL, 23081),
(23082, '1.25.40.20-FF-001610', NULL, 'Uncharacterized protein', 106, NULL, NULL, 23082),
(23083, '2.40.160.10-FF-000032', NULL, 'Outer membrane porin', 363, NULL, NULL, 23083),
(23084, '3.20.20.80-FF-000587', NULL, 'Uncharacterized protein', 234, NULL, NULL, 23084),
(23085, '3.30.200.20-FF-000723', NULL, 'U-box domain-containing protein 51', 93, NULL, NULL, 23085),
(23086, '2.20.70.10-FF-000049', NULL, 'Transcription elongation regulator 1-like', 71, NULL, NULL, 23086);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(23087, '2.30.42.10-FF-000074', NULL, 'protein scribble homolog isoform X2', 101, NULL, NULL, 23087),
(23088, '3.60.15.10-FF-000069', NULL, 'ElaC ribonuclease Z 1', 205, NULL, NULL, 23088),
(23089, '3.40.50.1000-FF-000625', NULL, NULL, 148, NULL, NULL, 23089),
(23090, '2.20.25.10-FF-000074', NULL, 'DNA-directed RNA polymerase I subunit', 72, NULL, NULL, 23090),
(23091, '1.10.1040.10-FF-000044', NULL, 'Putative 3-hydroxyisobutyrate dehydrogenase', 125, NULL, NULL, 23091),
(23092, '2.60.40.150-FF-000577', NULL, 'Regulating synaptic membrane exocytosis protein 2', 135, NULL, NULL, 23092),
(23093, '3.40.50.300-FF-006667', NULL, 'Uncharacterized protein', 85, NULL, NULL, 23093),
(23094, '2.170.270.10-FF-000234', NULL, 'Uncharacterized protein', 78, NULL, NULL, 23094),
(23095, '3.40.50.300-FF-002833', NULL, 'Pleiotropic drug resistance protein 2', 147, NULL, NULL, 23095),
(23096, '1.20.5.170-FF-000125', NULL, 'LAS1-like, ribosome biogenesis factor', 67, NULL, NULL, 23096),
(23097, '2.30.42.10-FF-000635', NULL, NULL, 65, NULL, NULL, 23097),
(23098, '1.10.600.10-FF-000083', NULL, 'Squalene synthase HpnC', 272, NULL, NULL, 23098),
(23099, '2.40.50.140-FF-001002', NULL, NULL, 95, NULL, NULL, 23099),
(23100, '2.130.10.10-FF-002558', NULL, 'WD40-repeat-containing subunit of the 18S rRNA processing complex', 186, NULL, NULL, 23100),
(23101, '2.130.10.10-FF-002434', NULL, 'RaBConnectin related', 182, NULL, NULL, 23101),
(23102, '3.80.10.10-FF-000821', NULL, 'NB-ARC domain containing protein, expressed', 368, NULL, NULL, 23102),
(23103, '3.40.50.300-FF-003233', NULL, 'ATP-binding cassette sub-family C member 8', 260, NULL, NULL, 23103),
(23104, '3.10.20.770-FF-000013', NULL, 'Phosphatidylinositol 3-kinase 3', 284, NULL, NULL, 23104),
(23105, '2.40.50.140-FF-000165', NULL, 'Chaperone CsaA', 112, NULL, NULL, 23105),
(23106, '3.30.1490.20-FF-000086', NULL, 'Glutathione synthetase', 65, NULL, NULL, 23106),
(23107, '1.20.1070.10-FF-000156', NULL, 'Lutropin-choriogonadotropic hormone receptor', 286, NULL, NULL, 23107),
(23108, '3.40.50.300-FF-002491', NULL, 'Ras family gtpase', 173, NULL, NULL, 23108),
(23109, '3.30.40.10-FF-000409', NULL, 'probable E3 ubiquitin-protein ligase RNF183', 88, NULL, NULL, 23109),
(23110, '3.80.10.10-FF-003238', NULL, 'Uncharacterized protein', 349, NULL, NULL, 23110),
(23111, '3.40.50.2060-FF-000022', NULL, NULL, 56, NULL, NULL, 23111),
(23112, '1.10.8.710-FF-000020', NULL, NULL, 50, NULL, NULL, 23112),
(23113, '3.40.50.300-FF-007504', NULL, 'Predicted protein', 221, NULL, NULL, 23113),
(23114, '3.30.1680.10-FF-000018', NULL, 'semaphorin-4C-like isoform X2', 51, NULL, NULL, 23114),
(23115, '3.30.1370.50-FF-000030', NULL, 'Benign gonial cell neoplasm', 78, NULL, NULL, 23115),
(23116, '1.25.10.10-FF-002274', NULL, 'Uncharacterized protein', 337, NULL, NULL, 23116),
(23117, '3.65.10.10-FF-000019', NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', 37, NULL, NULL, 23117),
(23118, '3.90.70.10-FF-000403', NULL, 'Ubiquitinyl hydrolase 1', 155, NULL, NULL, 23118),
(23119, '3.40.50.790-FF-000018', NULL, '50S ribosomal protein L1, chloroplastic', 92, NULL, NULL, 23119),
(23120, '1.25.40.20-FF-000317', NULL, 'Ankyrin repeat domain-containing protein 26', 68, NULL, NULL, 23120),
(23121, '1.10.533.10-FF-000016', NULL, 'CASP8 and FADD-like apoptosis regulator', 90, NULL, NULL, 23121),
(23122, '4.10.410.10-FF-000085', NULL, 'Protein CBR-MEC-9', 66, NULL, NULL, 23122),
(23123, '3.30.413.10-FF-000006', NULL, '4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase (flavodoxin)', 98, NULL, NULL, 23123),
(23124, '1.10.150.20-FF-000051', NULL, 'Endonuclease, putative', 83, NULL, NULL, 23124),
(23125, '3.30.40.10-FF-001955', NULL, 'Uncharacterized protein', 66, NULL, NULL, 23125),
(23126, '4.10.1240.50-FF-000018', NULL, 'Uncharacterized protein', 45, NULL, NULL, 23126),
(23127, '1.10.287.110-FF-000395', NULL, 'Uncharacterized protein', 48, NULL, NULL, 23127),
(23128, '2.60.120.650-FF-000011', NULL, 'PHD finger protein 2', 286, NULL, NULL, 23128),
(23129, '3.30.450.150-FF-000008', NULL, 'Uncharacterized protein CaJ7.0438', 165, NULL, NULL, 23129);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(23130, '3.90.1110.10-FF-000013', NULL, 'DNA-directed RNA polymerase subunit beta', 171, NULL, NULL, 23130),
(23131, '3.40.1480.10-FF-000001', NULL, 'Glycerate kinase', 182, NULL, NULL, 23131),
(23132, '1.10.510.10-FF-002594', NULL, NULL, 189, NULL, NULL, 23132),
(23133, '1.20.1310.10-FF-000164', NULL, NULL, 108, NULL, NULL, 23133),
(23134, '3.30.710.10-FF-000242', NULL, 'Uncharacterized protein', 100, NULL, NULL, 23134),
(23135, '3.30.930.10-FF-000399', NULL, 'Uncharacterized protein', 120, NULL, NULL, 23135),
(23136, '1.25.40.10-FF-004636', NULL, 'Uncharacterized protein', 188, NULL, NULL, 23136),
(23137, '3.90.1600.10-FF-000034', NULL, 'DNA polymerase', 166, NULL, NULL, 23137),
(23138, '3.30.160.60-FF-004839', NULL, NULL, 93, NULL, NULL, 23138),
(23139, '1.10.20.10-FF-000239', NULL, NULL, 108, NULL, NULL, 23139),
(23140, '2.40.10.10-FF-000483', NULL, NULL, 235, NULL, NULL, 23140),
(23141, '3.30.420.40-FF-000863', NULL, 'Uncharacterized protein', 100, NULL, NULL, 23141),
(23142, '2.60.40.1400-FF-000011', NULL, 'Potassium inwardly-rectifying channel', 184, NULL, NULL, 23142),
(23143, '3.90.1530.10-FF-000005', NULL, 'Sulfiredoxin', 114, NULL, NULL, 23143),
(23144, '3.10.20.90-FF-000197', NULL, 'afadin isoform X1', 88, NULL, NULL, 23144),
(23145, '3.30.160.100-FF-000023', NULL, 'Ribosome hibernation promoting factor', 108, NULL, NULL, 23145),
(23146, '3.50.50.60-FF-001346', NULL, 'Uncharacterized protein', 102, NULL, NULL, 23146),
(23147, '2.60.40.2960-FF-000001', NULL, 'Type 2 DNA topoisomerase 6 subunit B', 98, NULL, NULL, 23147),
(23148, '1.25.40.630-FF-000001', NULL, 'Cleavage stimulation factor subunit 2', 78, NULL, NULL, 23148),
(23149, '2.60.40.150-FF-000498', NULL, 'Phosphatidylserine decarboxylase proenzyme 2', 158, NULL, NULL, 23149),
(23150, '4.10.1240.30-FF-000012', NULL, NULL, 81, NULL, NULL, 23150),
(23151, '1.20.5.110-FF-000349', NULL, 'Uncharacterized protein', 64, NULL, NULL, 23151),
(23152, '3.40.50.300-FF-006852', NULL, 'GPN-loop GTPase 2', 260, NULL, NULL, 23152),
(23153, '3.30.160.60-FF-001613', NULL, 'Zinc finger protein 446', 31, NULL, NULL, 23153),
(23154, '3.10.100.10-FF-000138', NULL, 'Uncharacterized protein', 132, NULL, NULL, 23154),
(23155, '3.30.160.60-FF-000624', NULL, 'zinc finger protein 697', 30, NULL, NULL, 23155),
(23156, '1.25.40.10-FF-000893', NULL, 'Pentatricopeptide repeat-containing protein', 181, NULL, NULL, 23156),
(23157, '1.10.472.10-FF-000458', NULL, 'Uncharacterized protein', 113, NULL, NULL, 23157),
(23158, '2.120.10.30-FF-000187', NULL, 'S9 family peptidase', 225, NULL, NULL, 23158),
(23159, '3.40.50.1820-FF-000433', NULL, 'Putative triglyceride lipase', 260, NULL, NULL, 23159),
(23160, '3.40.50.10190-FF-000178', NULL, 'Chromodomain-helicase-DNA-binding protein 1-like', 97, NULL, NULL, 23160),
(23161, '3.30.70.330-FF-000409', NULL, 'U11/U12 small nuclear ribonucleoprotein 65 kDa protein', 95, NULL, NULL, 23161),
(23162, '1.25.40.20-FF-000896', NULL, 'Ankyrin repeat family protein', 191, NULL, NULL, 23162),
(23163, '1.20.870.10-FF-000027', NULL, 'GD11282', 164, NULL, NULL, 23163),
(23164, '1.20.120.830-FF-000002', NULL, 'Neural cell expressed, developmentally down-regulated 9', 175, NULL, NULL, 23164),
(23165, '3.40.50.720-FF-002201', NULL, 'Uncharacterized protein', 314, NULL, NULL, 23165),
(23166, '3.10.20.90-FF-000843', NULL, 'Predicted protein', 124, NULL, NULL, 23166),
(23167, '1.20.58.390-FF-000275', NULL, 'Uncharacterized protein', 68, NULL, NULL, 23167),
(23168, '1.25.40.20-FF-001413', NULL, 'Exodeoxyribonuclease V', 133, NULL, NULL, 23168),
(23169, '1.20.58.60-FF-000329', NULL, 'SMAll', 99, NULL, NULL, 23169),
(23170, '1.10.510.10-FF-004246', NULL, NULL, 196, NULL, NULL, 23170),
(23171, '2.60.120.10-FF-000834', NULL, 'Transcriptional regulator AraC family', 72, NULL, NULL, 23171),
(23172, '2.40.70.10-FF-000492', NULL, NULL, 132, NULL, NULL, 23172),
(23173, '3.40.390.10-FF-000034', NULL, 'Sol narae, isoform C', 233, NULL, NULL, 23173),
(23174, '3.40.50.1820-FF-001861', NULL, 'Uncharacterized protein', 49, NULL, NULL, 23174),
(23175, '1.25.10.10-FF-003027', NULL, 'Uncharacterized protein', 320, NULL, NULL, 23175);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(23176, '1.10.1740.10-FF-000047', NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', 85, NULL, NULL, 23176),
(23177, '2.130.10.10-FF-004901', NULL, 'Cleavage and polyadenylation-specific factor 1', 112, NULL, NULL, 23177),
(23178, '1.10.510.10-FF-001020', NULL, 'Transmembrane ion channel', 178, NULL, NULL, 23178),
(23179, '2.30.30.40-FF-000257', NULL, 'Abl interactor 2', 49, NULL, NULL, 23179),
(23180, '1.20.1070.10-FF-001437', NULL, 'Uncharacterized protein', 223, NULL, NULL, 23180),
(23181, '3.90.1030.10-FF-000012', NULL, '50S ribosomal protein L17, putative', 114, NULL, NULL, 23181),
(23182, '3.30.750.24-FF-000139', NULL, 'AGAP001531-PA', 98, NULL, NULL, 23182),
(23183, '3.20.20.40-FF-000002', NULL, 'Glucanase', 417, NULL, NULL, 23183),
(23184, '2.60.120.10-FF-000508', NULL, 'cGMP-dependent protein kinase, isozyme 1-like Protein', 135, NULL, NULL, 23184),
(23185, '3.40.50.300-FF-008297', NULL, 'GTP binding protein 3, mitochondrial', 24, NULL, NULL, 23185),
(23186, '1.20.1280.290-FF-000051', NULL, 'Mannose-P-dolichol utilization defect 1 protein homolog', 87, NULL, NULL, 23186),
(23187, '3.10.129.10-FF-000221', NULL, 'Protein CBG14719', 153, NULL, NULL, 23187),
(23188, '2.130.10.10-FF-004694', NULL, 'Uncharacterized WD repeat-containing protein C26H5.03', 175, NULL, NULL, 23188),
(23189, '2.60.40.10-FF-001164', NULL, 'Uncharacterized protein, isoform F', 104, NULL, NULL, 23189),
(23190, '1.10.10.10-FF-000593', NULL, '40S ribosomal protein S19 protein', 158, NULL, NULL, 23190),
(23191, '1.25.10.10-FF-002364', NULL, 'Uncharacterized protein', 279, NULL, NULL, 23191),
(23192, '2.120.10.80-FF-000095', NULL, 'Actin-binding protein IPP', 159, NULL, NULL, 23192),
(23193, '1.10.1170.10-FF-000025', NULL, 'Baculoviral IAP repeat containing 7', 91, NULL, NULL, 23193),
(23194, '1.20.1560.10-FF-000795', NULL, 'Uncharacterized protein', 205, NULL, NULL, 23194),
(23195, '3.30.160.60-FF-002069', NULL, 'Uncharacterized protein', 29, NULL, NULL, 23195),
(23196, '3.30.559.70-FF-000019', NULL, 'GM16326', 318, NULL, NULL, 23196),
(23197, '3.40.50.880-FF-000225', NULL, 'Uncharacterized protein', 55, NULL, NULL, 23197),
(23198, '2.60.40.60-FF-001072', NULL, 'Uncharacterized protein', 41, NULL, NULL, 23198),
(23199, '2.170.120.30-FF-000016', NULL, 'Uncharacterized protein', 104, NULL, NULL, 23199),
(23200, '3.30.70.580-FF-000052', NULL, 'tRNA pseudouridine synthase A', 105, NULL, NULL, 23200),
(23201, '3.10.350.10-FF-000010', NULL, 'LysM and putative peptidoglycan-binding domain-containing protein 1', 75, NULL, NULL, 23201),
(23202, '3.30.70.270-FF-000110', NULL, 'DNApol-iota, isoform A', 128, NULL, NULL, 23202),
(23203, '3.30.1490.100-FF-000034', NULL, 'DNA polymerase IV', 112, NULL, NULL, 23203),
(23204, '3.40.190.10-FF-000406', NULL, 'Amino acid ABC transporter amino acid-binding portion', 115, NULL, NULL, 23204),
(23205, '1.25.10.10-FF-002038', NULL, 'Uncharacterized protein', 252, NULL, NULL, 23205),
(23206, '3.80.10.10-FF-001693', NULL, 'ELRR (Extracellular Leucine-Rich Repeat) ONly', 195, NULL, NULL, 23206),
(23207, '2.60.120.260-FF-000310', NULL, 'Endoprotease bli-4', 144, NULL, NULL, 23207),
(23208, '2.170.120.20-FF-000013', NULL, '50S ribosomal protein L25', 90, NULL, NULL, 23208),
(23209, '2.160.20.10-FF-000180', NULL, 'Uncharacterized protein', 94, NULL, NULL, 23209),
(23210, '3.40.50.720-FF-000110', NULL, 'Glyoxylate/hydroxypyruvate reductase A', 185, NULL, NULL, 23210),
(23211, '3.30.56.10-FF-000013', NULL, 'Phenylalanine--tRNA ligase beta subunit', 71, NULL, NULL, 23211),
(23212, '1.25.40.10-FF-001410', NULL, 'Hypothetical_protein_-_conserved', 103, NULL, NULL, 23212),
(23213, '2.60.40.770-FF-000004', NULL, 'Phosphatidylglycerol/phosphatidylinositol transfer protein', 126, NULL, NULL, 23213),
(23214, '2.130.10.10-FF-003120', NULL, 'Uncharacterized protein', 266, NULL, NULL, 23214),
(23215, '3.90.1100.10-FF-000041', NULL, 'DNA-directed RNA polymerase subunit beta', 191, NULL, NULL, 23215),
(23216, '3.30.450.30-FF-000036', NULL, 'GD11487', 102, NULL, NULL, 23216),
(23217, '1.10.3470.10-FF-000037', NULL, 'Putative iron ABC transporter, permease protein', 332, NULL, NULL, 23217);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(23218, '3.30.1520.10-FF-000041', NULL, 'Protein kinase activator Bem1', 144, NULL, NULL, 23218),
(23219, '2.40.70.10-FF-000166', NULL, 'Eukaryotic aspartyl protease family protein', 191, NULL, NULL, 23219),
(23220, '1.10.10.10-FF-000913', NULL, 'LysR family transcriptional regulator', 89, NULL, NULL, 23220),
(23221, '2.40.50.100-FF-000198', NULL, 'Uncharacterized protein', 52, NULL, NULL, 23221),
(23222, '2.60.40.10-FF-005233', NULL, NULL, 89, NULL, NULL, 23222),
(23223, '3.40.50.2300-FF-000504', NULL, 'Serine/threonine-protein kinase RIM15', 131, NULL, NULL, 23223),
(23224, '3.40.50.300-FF-008617', NULL, 'Uncharacterized protein', 247, NULL, NULL, 23224),
(23225, '2.60.40.10-FF-002592', NULL, 'Complement C4', 101, NULL, NULL, 23225),
(23226, '2.120.10.80-FF-000415', NULL, 'Kelch like ECH associated protein 1', 210, NULL, NULL, 23226),
(23227, '3.30.450.20-FF-000033', NULL, 'Nitrogen regulation protein NR(II)', 104, NULL, NULL, 23227),
(23228, '1.20.58.1480-FF-000027', NULL, 'Protein cereblon', 66, NULL, NULL, 23228),
(23229, '3.40.50.720-FF-001684', NULL, 'Glyoxylate/hydroxypyruvate reductase A', 82, NULL, NULL, 23229),
(23230, '3.30.450.40-FF-000039', NULL, 'IclR family transcriptional regulator', 176, NULL, NULL, 23230),
(23231, '3.40.50.150-FF-001142', NULL, NULL, 245, NULL, NULL, 23231),
(23232, '2.60.40.760-FF-000001', NULL, 'Expansin', 93, NULL, NULL, 23232),
(23233, '3.90.850.10-FF-000002', NULL, '2-hydroxyhepta-2,4-diene-1,7-dioate isomerase', 215, NULL, NULL, 23233),
(23234, '3.50.50.60-FF-000244', NULL, 'Renalase isoform 1', 148, NULL, NULL, 23234),
(23235, '2.30.30.210-FF-000010', NULL, 'Ribonuclease P protein subunit p29', 45, NULL, NULL, 23235),
(23236, '2.20.110.10-FF-000011', NULL, 'MORN repeat-containing protein 4', 76, NULL, NULL, 23236),
(23237, '1.10.1070.11-FF-000058', NULL, 'MTOR isoform 6', 139, NULL, NULL, 23237),
(23238, '3.40.50.1440-FF-000089', NULL, 'Tubulin, beta 6 class V', 78, NULL, NULL, 23238),
(23239, '1.10.1200.30-FF-000001', NULL, 'Gag polyprotein', 73, NULL, NULL, 23239),
(23240, '3.40.50.300-FF-007954', NULL, 'DNA helicase', 168, NULL, NULL, 23240),
(23241, '3.40.50.2300-FF-000184', NULL, 'Response regulator 3', 159, NULL, NULL, 23241),
(23242, '3.30.160.60-FF-002748', NULL, 'Uncharacterized protein', 27, NULL, NULL, 23242),
(23243, '3.10.100.10-FF-000290', NULL, NULL, 142, NULL, NULL, 23243),
(23244, '1.10.15.30-FF-000003', NULL, '50S ribosomal protein L30', 57, NULL, NULL, 23244),
(23245, '3.80.10.10-FF-002210', NULL, 'Leucine-rich transmembrane protein, putative', 225, NULL, NULL, 23245),
(23246, '3.40.50.300-FF-004609', NULL, 'ATP-dependent DNA helicase, putative', 96, NULL, NULL, 23246),
(23247, '3.30.420.40-FF-000537', NULL, 'Cell division protein FtsA', 156, NULL, NULL, 23247),
(23248, '3.40.50.720-FF-001419', NULL, 'ThiF family protein', 365, NULL, NULL, 23248),
(23249, '2.170.270.10-FF-000105', NULL, 'Uncharacterized protein', 178, NULL, NULL, 23249),
(23250, '3.40.50.300-FF-006526', NULL, 'ABC transporter, putative', 110, NULL, NULL, 23250),
(23251, '1.20.144.10-FF-000082', NULL, 'PAP2 superfamily protein', 230, NULL, NULL, 23251),
(23252, '2.70.70.10-FF-000069', NULL, 'Uncharacterized protein', 176, NULL, NULL, 23252),
(23253, '2.60.120.650-FF-000157', NULL, 'Predicted protein', 260, NULL, NULL, 23253),
(23254, '1.20.1070.10-FF-001763', NULL, 'Uncharacterized protein', 69, NULL, NULL, 23254),
(23255, '2.130.10.10-FF-002923', NULL, 'Uncharacterized protein', 326, NULL, NULL, 23255),
(23256, '3.30.70.330-FF-000735', NULL, 'Cytoplasmic protein, variant', 90, NULL, NULL, 23256),
(23257, '1.20.5.4010-FF-000005', NULL, 'Predicted protein', 83, NULL, NULL, 23257),
(23258, '1.20.1250.20-FF-000403', NULL, 'Fosmidomycin resistance protein', 184, NULL, NULL, 23258),
(23259, '1.25.40.10-FF-000567', NULL, 'Putative pentatricopeptide repeat-containing protein', 107, NULL, NULL, 23259),
(23260, '2.60.40.10-FF-004570', NULL, NULL, 100, NULL, NULL, 23260),
(23261, '1.10.287.40-FF-000014', NULL, 'Seryl-tRNA synthetase', 119, NULL, NULL, 23261),
(23262, '2.10.25.10-FF-001530', NULL, 'Netrin-G2', 90, NULL, NULL, 23262);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(23263, '3.30.40.10-FF-001629', NULL, 'DNA repair-related protein, putative', 56, NULL, NULL, 23263),
(23264, '2.10.25.10-FF-001058', NULL, 'Abnormal pharyngeal pumping eat-20', 37, NULL, NULL, 23264),
(23265, '1.10.274.100-FF-000028', NULL, 'DNA-directed RNA polymerase subunit', 153, NULL, NULL, 23265),
(23266, '2.60.40.10-FF-000175', NULL, 'Fibronectin type III domain containing 3A', 96, NULL, NULL, 23266),
(23267, '2.130.10.10-FF-005211', NULL, 'Uncharacterized protein', 87, NULL, NULL, 23267),
(23268, '3.40.50.1820-FF-000107', NULL, 'Palmitoyl-protein thioesterase 1', 284, NULL, NULL, 23268),
(23269, '4.10.60.10-FF-000241', NULL, 'Uncharacterized protein', 42, NULL, NULL, 23269),
(23270, '3.40.190.10-FF-000053', NULL, 'Membrane-bound lytic murein transglycosylase F', 128, NULL, NULL, 23270),
(23271, '1.10.238.10-FF-000870', NULL, 'Uncharacterized protein', 183, NULL, NULL, 23271),
(23272, '3.40.640.10-FF-000514', NULL, 'Uncharacterized protein', 25, NULL, NULL, 23272),
(23273, '1.20.1110.10-FF-000183', NULL, NULL, 192, NULL, NULL, 23273),
(23274, '2.130.10.10-FF-000832', NULL, 'striatin-3 isoform X1', 101, NULL, NULL, 23274),
(23275, '1.25.70.10-FF-000069', NULL, NULL, 201, NULL, NULL, 23275),
(23276, '1.10.510.10-FF-002268', NULL, NULL, 206, NULL, NULL, 23276),
(23277, '2.10.110.10-FF-000182', NULL, 'Putative actin-binding protein UNC-115', 104, NULL, NULL, 23277),
(23278, '1.25.40.240-FF-000007', NULL, 'ATP-dependent DNA helicase II subunit 2', 135, NULL, NULL, 23278),
(23279, '3.40.50.300-FF-008090', NULL, 'Uvrd / recb / pcra DNA helicase, putative', 114, NULL, NULL, 23279),
(23280, '1.10.10.60-FF-000821', NULL, 'Notochord homeobox', 86, NULL, NULL, 23280),
(23281, '1.10.1030.10-FF-000015', NULL, 'CPSase', 144, NULL, NULL, 23281),
(23282, '3.40.50.1580-FF-000052', NULL, 'S-methyl-5''-thioadenosine phosphorylase', 60, NULL, NULL, 23282),
(23283, '1.10.510.10-FF-000177', NULL, 'Mast/stem cell growth factor receptor', 200, NULL, NULL, 23283),
(23284, '2.40.50.90-FF-000200', NULL, 'Qin', 33, NULL, NULL, 23284),
(23285, '2.120.10.30-FF-000507', NULL, 'Uncharacterized protein', 205, NULL, NULL, 23285),
(23286, '2.60.40.10-FF-002945', NULL, 'Fibronectin_type_III_domain_containing_protein_-_putative', 106, NULL, NULL, 23286),
(23287, '1.10.730.10-FF-000042', NULL, 'Leucine--tRNA ligase, putative', 205, NULL, NULL, 23287),
(23288, '2.160.10.10-FF-000056', NULL, 'Serine O-acetyltransferase', 114, NULL, NULL, 23288),
(23289, '1.20.1250.20-FF-001538', NULL, 'Disrupted in renal carcinoma protein', 427, NULL, NULL, 23289),
(23290, '1.25.40.570-FF-000022', NULL, 'COP9 signalosome complex subunit 1', 348, NULL, NULL, 23290),
(23291, '3.30.420.110-FF-000064', NULL, 'DNA mismatch repair protein', 196, NULL, NULL, 23291),
(23292, '3.40.50.300-FF-004935', NULL, 'Small GTP-binding protein, putative', 195, NULL, NULL, 23292),
(23293, '2.60.40.60-FF-000936', NULL, 'Uncharacterized protein', 143, NULL, NULL, 23293),
(23294, '3.30.450.190-FF-000026', NULL, 'Chromosome 1, whole genome shotgun sequence', 51, NULL, NULL, 23294),
(23295, '1.25.40.990-FF-000058', NULL, 'Uncharacterized protein', 217, NULL, NULL, 23295),
(23296, '3.40.470.10-FF-000035', NULL, NULL, 194, NULL, NULL, 23296),
(23297, '3.70.10.10-FF-000108', NULL, 'Uncharacterized protein', 260, NULL, NULL, 23297),
(23298, '3.30.870.10-FF-000135', NULL, 'Uncharacterized protein', 169, NULL, NULL, 23298),
(23299, '3.40.190.10-FF-000732', NULL, 'AGAP011968-PA', 81, NULL, NULL, 23299),
(23300, '3.40.50.80-FF-000245', NULL, 'NADPH oxidase 5', 104, NULL, NULL, 23300),
(23301, '2.40.20.10-FF-000129', NULL, 'Uncharacterized protein', 108, NULL, NULL, 23301),
(23302, '2.10.25.10-FF-001737', NULL, 'Transmembrane cell adhesion receptor mua-3', 38, NULL, NULL, 23302),
(23303, '1.25.10.10-FF-002690', NULL, 'ARVCF delta catenin family member b', 71, NULL, NULL, 23303),
(23304, '2.60.40.10-FF-000854', NULL, 'Prostaglandin F2 receptor negative regulator', 115, NULL, NULL, 23304),
(23305, '1.25.10.10-FF-000386', NULL, '26S proteasome regulatory subunit RPN1', 433, NULL, NULL, 23305);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(23306, '1.10.100.10-FF-000011', NULL, 'Insulin-like peptide 2', 77, NULL, NULL, 23306),
(23307, '1.25.40.10-FF-004283', NULL, 'Uncharacterized protein', 206, NULL, NULL, 23307),
(23308, '3.40.50.150-FF-001788', NULL, NULL, 172, NULL, NULL, 23308),
(23309, '1.10.10.10-FF-000267', NULL, 'HTH-type transcriptional regulator DctR', 76, NULL, NULL, 23309),
(23310, '1.10.472.130-FF-000008', NULL, 'Dynein axonemal heavy chain 3', 175, NULL, NULL, 23310),
(23311, '3.30.160.60-FF-003530', NULL, NULL, 42, NULL, NULL, 23311),
(23312, '1.20.1460.20-FF-000003', NULL, 'V-type ATP synthase subunit I', 149, NULL, NULL, 23312),
(23313, '3.80.10.10-FF-003345', NULL, 'Uncharacterized protein', 120, NULL, NULL, 23313),
(23314, '2.60.40.150-FF-000818', NULL, 'Uncharacterized protein', 72, NULL, NULL, 23314),
(23315, '2.40.30.10-FF-000427', NULL, 'Uncharacterized protein', 110, NULL, NULL, 23315),
(23316, '1.10.3720.10-FF-000164', NULL, 'Thiamin ABC transporter transmembrane component', 241, NULL, NULL, 23316),
(23317, '3.30.200.20-FF-002078', NULL, 'Uncharacterized protein', 83, NULL, NULL, 23317),
(23318, '1.20.1070.10-FF-000302', NULL, 'G protein-coupled receptor 39', 353, NULL, NULL, 23318),
(23319, '3.20.20.80-FF-000053', NULL, 'Alpha-xylosidase YicI', 371, NULL, NULL, 23319),
(23320, '3.40.50.2300-FF-001639', NULL, NULL, 258, NULL, NULL, 23320),
(23321, '1.25.40.20-FF-000424', NULL, 'Caskin-1', 97, NULL, NULL, 23321),
(23322, '1.20.1280.50-FF-000066', NULL, 'F-box protein SNE', 115, NULL, NULL, 23322),
(23323, '3.40.50.1820-FF-001568', NULL, 'Uncharacterized protein', 112, NULL, NULL, 23323),
(23324, '2.40.128.330-FF-000003', NULL, 'Magnesium transporter MRS2 homolog, mitochondrial', 81, NULL, NULL, 23324),
(23325, '3.40.50.261-FF-000018', NULL, 'Acetyl coenzyme A synthetase (ADP forming), alpha domain-containing protein', 162, NULL, NULL, 23325),
(23326, '1.10.400.10-FF-000056', NULL, 'Uncharacterized protein', 127, NULL, NULL, 23326),
(23327, '1.25.40.10-FF-000421', NULL, 'Tetratricopeptide repeat domain 7B', 184, NULL, NULL, 23327),
(23328, '3.40.309.10-FF-000104', NULL, 'Aldehyde dehydrogenase, mitochondrial', 190, NULL, NULL, 23328),
(23329, '3.30.760.10-FF-000014', NULL, 'Eukaryotic translation initiation factor 4E-4', 194, NULL, NULL, 23329),
(23330, '2.60.120.200-FF-000106', NULL, 'Adhesion G-protein coupled receptor V1', 180, NULL, NULL, 23330),
(23331, '3.40.50.300-FF-002783', NULL, 'ATP-dependent RNA helicase DBP9', 223, NULL, NULL, 23331),
(23332, '3.10.450.50-FF-000092', NULL, 'Uncharacterized protein', 120, NULL, NULL, 23332),
(23333, '2.60.40.60-FF-000257', NULL, 'neural-cadherin isoform X11', 130, NULL, NULL, 23333),
(23334, '1.10.472.170-FF-000026', NULL, 'Uncharacterized protein', 153, NULL, NULL, 23334),
(23335, '3.30.160.60-FF-000950', NULL, 'Zinc finger protein 48', 28, NULL, NULL, 23335),
(23336, '1.25.40.10-FF-002512', NULL, 'PROBABLE TRANSCRIPTIONAL REGULATORY PROTEIN (LUXR-FAMILY)', 229, NULL, NULL, 23336),
(23337, '2.40.240.130-FF-000004', NULL, 'Axin, isoform B', 82, NULL, NULL, 23337),
(23338, '3.90.132.10-FF-000008', NULL, 'GP63-like', 120, NULL, NULL, 23338),
(23339, '3.30.200.20-FF-002139', NULL, 'Glycogen synthase kinase-3 alpha, putative', 70, NULL, NULL, 23339),
(23340, '1.10.472.110-FF-000002', NULL, 'Transcription factor TFIIB-like', 123, NULL, NULL, 23340),
(23341, '1.25.40.10-FF-002192', NULL, 'Transcriptional activator domain protein', 151, NULL, NULL, 23341),
(23342, '3.40.50.300-FF-004874', NULL, 'Uncharacterized protein', 153, NULL, NULL, 23342),
(23343, '2.60.40.10-FF-002327', NULL, 'Polymeric immunoglobulin receptor', 108, NULL, NULL, 23343),
(23344, '1.10.10.60-FF-000349', NULL, 'Transcription factor MYB39', 62, NULL, NULL, 23344),
(23345, '3.30.70.870-FF-000015', NULL, 'Translation elongation factor G', 73, NULL, NULL, 23345),
(23346, '1.20.58.60-FF-000122', NULL, 'dystonin isoform X1', 108, NULL, NULL, 23346),
(23347, '2.30.30.910-FF-000006', NULL, NULL, 28, NULL, NULL, 23347),
(23348, '3.90.550.10-FF-000283', NULL, 'UDP-glucose:glycoprotein glucosyltransferase, putative', 262, NULL, NULL, 23348);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(23349, '1.10.460.10-FF-000032', NULL, 'DNA topoisomerase', 91, NULL, NULL, 23349),
(23350, '2.60.120.200-FF-000606', NULL, 'Growth arrest-specific protein 6', 152, NULL, NULL, 23350),
(23351, '1.20.1070.10-FF-002073', NULL, 'Uncharacterized protein', 272, NULL, NULL, 23351),
(23352, '3.90.1150.10-FF-000431', NULL, 'Uncharacterized protein', 44, NULL, NULL, 23352),
(23353, '3.40.630.10-FF-000216', NULL, 'Vacuolar aminopeptidase, putative', 306, NULL, NULL, 23353),
(23354, '3.30.40.10-FF-001781', NULL, 'Uncharacterized protein', 77, NULL, NULL, 23354),
(23355, '1.10.3110.10-FF-000016', NULL, 'Protoporphyrinogen oxidase 1 chloroplastic', 126, NULL, NULL, 23355),
(23356, '2.130.10.10-FF-000686', NULL, 'WD repeat-containing protein 72', 280, NULL, NULL, 23356),
(23357, '3.40.50.720-FF-001745', NULL, 'Zinc-binding alcohol dehydrogenase family protein', 138, NULL, NULL, 23357),
(23358, '3.30.1050.10-FF-000050', NULL, 'Uncharacterized protein', 118, NULL, NULL, 23358),
(23359, '1.25.10.10-FF-000739', NULL, 'VAC14p Enzyme regulator', 153, NULL, NULL, 23359),
(23360, '1.20.144.10-FF-000110', NULL, 'Phosphatidate phosphatase PPAPDC1A-like Protein', 228, NULL, NULL, 23360),
(23361, '2.60.200.20-FF-000046', NULL, 'Putative ABC transporter ATP-binding protein', 100, NULL, NULL, 23361),
(23362, '3.10.10.10-FF-000010', NULL, 'Gag-Pol polyprotein', 92, NULL, NULL, 23362),
(23363, '3.30.160.60-FF-005767', NULL, NULL, 32, NULL, NULL, 23363),
(23364, '3.30.505.10-FF-000046', NULL, 'RAS p21 protein activator 1', 111, NULL, NULL, 23364),
(23365, '2.60.40.10-FF-002619', NULL, 'Isoamylase 2, chloroplastic', 129, NULL, NULL, 23365),
(23366, '2.70.170.10-FF-000228', NULL, 'Uncharacterized protein', 88, NULL, NULL, 23366),
(23367, '3.90.70.10-FF-000246', NULL, 'Cysteine protease putative', 353, NULL, NULL, 23367),
(23368, '3.90.550.10-FF-000575', NULL, 'Uncharacterized protein', 295, NULL, NULL, 23368),
(23369, '3.30.200.20-FF-002432', NULL, 'Uncharacterized protein', 77, NULL, NULL, 23369),
(23370, '2.60.40.420-FF-000130', NULL, 'SKU5 similar 16', 176, NULL, NULL, 23370),
(23371, '2.60.120.260-FF-000517', NULL, 'Beta-galactosidase', 157, NULL, NULL, 23371),
(23372, '3.40.50.11860-FF-000010', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', 108, NULL, NULL, 23372),
(23373, '3.30.1680.10-FF-000047', NULL, 'MET proto-oncogene, receptor tyrosine kinase', 48, NULL, NULL, 23373),
(23374, '2.60.40.10-FF-001956', NULL, 'Uncharacterized protein, isoform A', 111, NULL, NULL, 23374),
(23375, '3.40.50.150-FF-000978', NULL, NULL, 220, NULL, NULL, 23375),
(23376, '1.10.510.10-FF-003083', NULL, NULL, 200, NULL, NULL, 23376),
(23377, '3.30.230.70-FF-000043', NULL, 'Unplaced genomic scaffold supercont2.9, whole genome shotgun sequence', 242, NULL, NULL, 23377),
(23378, '3.40.50.1980-FF-000082', NULL, 'Possible binding-protein-dependent transport lipoprotein', 105, NULL, NULL, 23378),
(23379, '3.30.160.60-FF-003204', NULL, NULL, 29, NULL, NULL, 23379),
(23380, '2.60.40.10-FF-002799', NULL, 'Beta-glucosidase, putative', 135, NULL, NULL, 23380),
(23381, '1.10.472.10-FF-000284', NULL, 'Uncharacterized protein', 47, NULL, NULL, 23381),
(23382, '3.10.320.10-FF-000003', NULL, 'HLA class II histocompatibility antigen, DM alpha chain', 89, NULL, NULL, 23382),
(23383, '1.20.58.1780-FF-000027', NULL, 'Uncharacterized protein', 55, NULL, NULL, 23383),
(23384, '1.10.510.10-FF-002329', NULL, NULL, 206, NULL, NULL, 23384),
(23385, '1.10.3730.20-FF-000078', NULL, 'Uncharacterized protein', 135, NULL, NULL, 23385),
(23386, '2.60.220.50-FF-000005', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 2', 211, NULL, NULL, 23386),
(23387, '1.10.620.20-FF-000042', NULL, 'Ribonucleoside-diphosphate reductase subunit M2-like Protein', 331, NULL, NULL, 23387),
(23388, '3.40.50.300-FF-004256', NULL, 'SWI/SNF family DNA-dependent ATPase, putative', 205, NULL, NULL, 23388),
(23389, '3.30.160.60-FF-002541', NULL, 'Zinc finger protein 732', 25, NULL, NULL, 23389),
(23390, '2.40.30.10-FF-000366', NULL, 'NADPH--cytochrome P450 reductase', 54, NULL, NULL, 23390);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(23391, '3.40.50.150-FF-000686', NULL, 'Uncharacterized methyltransferase B4417_0689', 190, NULL, NULL, 23391),
(23392, '1.20.1070.10-FF-000274', NULL, 'Uncharacterized protein', 271, NULL, NULL, 23392),
(23393, '3.30.1060.10-FF-000022', NULL, NULL, 63, NULL, NULL, 23393),
(23394, '3.30.1370.240-FF-000015', NULL, 'Phenylalanine--tRNA ligase alpha subunit', 81, NULL, NULL, 23394),
(23395, '1.20.58.190-FF-000007', NULL, 'FI16517p1', 162, NULL, NULL, 23395),
(23396, '2.60.120.260-FF-000282', NULL, 'Putative secreted protein', 129, NULL, NULL, 23396),
(23397, '3.40.50.460-FF-000043', NULL, 'Os06g0151900 protein', 56, NULL, NULL, 23397),
(23398, '2.60.40.60-FF-001100', NULL, 'Uncharacterized protein', 84, NULL, NULL, 23398),
(23399, '3.40.800.10-FF-000016', NULL, 'Formimidoylglutamase', 313, NULL, NULL, 23399),
(23400, '1.10.10.60-FF-000675', NULL, 'Probable transcriptional regulator', 106, NULL, NULL, 23400),
(23401, '2.60.210.10-FF-000015', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 162, NULL, NULL, 23401),
(23402, '3.40.30.10-FF-000886', NULL, 'Uncharacterized protein', 54, NULL, NULL, 23402),
(23403, '3.80.10.10-FF-003845', NULL, 'PH domain and leucine-rich repeat protein phosphatase 1', 175, NULL, NULL, 23403),
(23404, '3.40.50.880-FF-000079', NULL, 'Gamma-glutamyl peptidase 1', 237, NULL, NULL, 23404),
(23405, '3.30.70.330-FF-002326', NULL, NULL, 114, NULL, NULL, 23405),
(23406, '3.40.50.720-FF-002408', NULL, 'dTDP-4-dehydro-6-deoxyglucose reductase', 203, NULL, NULL, 23406),
(23407, '1.20.1070.10-FF-001376', NULL, 'Uncharacterized protein', 255, NULL, NULL, 23407),
(23408, '1.20.58.220-FF-000005', NULL, 'Phosphate transporter', 210, NULL, NULL, 23408),
(23409, '3.90.1300.10-FF-000022', NULL, 'Indole acetamide hydrolase', 483, NULL, NULL, 23409),
(23410, '1.20.1440.130-FF-000001', NULL, 'Vitamin K epoxide reductase complex subunit 1-like 1', 162, NULL, NULL, 23410),
(23411, '1.25.40.20-FF-000924', NULL, 'Os02g0257950 protein', 257, NULL, NULL, 23411),
(23412, '1.10.510.10-FF-002947', NULL, NULL, 216, NULL, NULL, 23412),
(23413, '2.30.30.100-FF-000123', NULL, 'U6 snRNA-associated Sm-like protein LSm3, putative', 73, NULL, NULL, 23413),
(23414, '2.60.40.790-FF-000162', NULL, NULL, 98, NULL, NULL, 23414),
(23415, '3.40.50.1820-FF-001361', NULL, 'Uncharacterized protein', 234, NULL, NULL, 23415),
(23416, '3.30.70.330-FF-000089', NULL, 'RNA binding protein', 93, NULL, NULL, 23416),
(23417, '3.30.160.60-FF-006464', NULL, NULL, 28, NULL, NULL, 23417),
(23418, '2.70.40.10-FF-000034', NULL, 'Deoxyuridine 5''-triphosphate nucleotidohydrolase family protein', 157, NULL, NULL, 23418),
(23419, '3.30.200.20-FF-001004', NULL, 'Probable inactive leucine-rich repeat receptor-like protein kinase At1g66830', 110, NULL, NULL, 23419),
(23420, '1.25.40.10-FF-000921', NULL, 'Pentatricopeptide repeat-containing protein At5g48910', 125, NULL, NULL, 23420),
(23421, '2.130.10.10-FF-004840', NULL, 'Uncharacterized protein', 132, NULL, NULL, 23421),
(23422, '2.40.50.140-FF-000277', NULL, 'Transcription termination/antitermination protein NusA', 72, NULL, NULL, 23422),
(23423, '3.40.50.150-FF-001203', NULL, NULL, 194, NULL, NULL, 23423),
(23424, '1.20.120.790-FF-000029', NULL, 'Uncharacterized protein', 95, NULL, NULL, 23424),
(23425, '2.60.40.1120-FF-000051', NULL, 'Carboxypeptidase M', 103, NULL, NULL, 23425),
(23426, '3.80.10.10-FF-002182', NULL, 'Leucine-rich repeat protein (LRRP), putative', 70, NULL, NULL, 23426),
(23427, '1.10.510.10-FF-000823', NULL, 'Serine/threonine protein kinase', 147, NULL, NULL, 23427),
(23428, '1.20.1420.30-FF-000032', NULL, 'Ca2: Cation Antiporter (CaCA) Family', 162, NULL, NULL, 23428),
(23429, '3.40.800.20-FF-000019', NULL, 'histone deacetylase 8 isoform X3', 234, NULL, NULL, 23429),
(23430, '1.10.510.10-FF-004185', NULL, NULL, 219, NULL, NULL, 23430),
(23431, '3.80.20.20-FF-000033', NULL, 'Predicted protein', 100, NULL, NULL, 23431),
(23432, '3.40.50.360-FF-000131', NULL, 'NADPH-dependent azoreductase Azr', 194, NULL, NULL, 23432),
(23433, '2.30.30.70-FF-000007', NULL, 'Uncharacterized protein', 31, NULL, NULL, 23433);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(23434, '3.55.50.30-FF-000017', NULL, 'Probable transmembrane sensor', 75, NULL, NULL, 23434),
(23435, '2.30.29.30-FF-000037', NULL, 'Fermitin family homolog 2', 95, NULL, NULL, 23435),
(23436, '3.40.50.300-FF-002457', NULL, '26S proteasome regulatory subunit 8', 85, NULL, NULL, 23436),
(23437, '1.25.40.20-FF-001060', NULL, 'Mitogen activated protein kinase kinase kinase 3, MAPKKK3, MEKK3, putative', 93, NULL, NULL, 23437),
(23438, '3.40.50.2300-FF-000330', NULL, 'Sugar ABC transporter substrate-binding protein', 149, NULL, NULL, 23438),
(23439, '3.40.50.1000-FF-000513', NULL, 'Glucosyl-3-phosphoglycerate/mannosyl-3-phosphoglycerate phosphatase', 165, NULL, NULL, 23439),
(23440, '1.20.1270.420-FF-000009', NULL, 'Uncharacterized protein', 261, NULL, NULL, 23440),
(23441, '3.30.450.240-FF-000002', NULL, 'Uncharacterized protein', 135, NULL, NULL, 23441),
(23442, '2.60.200.10-FF-000043', NULL, 'Interferon regulatory factor 8', 139, NULL, NULL, 23442),
(23443, '1.25.40.180-FF-000321', NULL, NULL, 85, NULL, NULL, 23443),
(23444, '1.20.1050.10-FF-000065', NULL, 'Glutathione S-transferase 2', 113, NULL, NULL, 23444),
(23445, '1.10.10.10-FF-000767', NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', 111, NULL, NULL, 23445),
(23446, '2.40.100.10-FF-000023', NULL, 'Peptidyl-prolyl cis-trans isomerase', 166, NULL, NULL, 23446),
(23447, '3.40.30.10-FF-000914', NULL, 'RE05501p', 128, NULL, NULL, 23447),
(23448, '3.40.5.10-FF-000025', NULL, 'Uncharacterized protein', 50, NULL, NULL, 23448),
(23449, '3.10.110.10-FF-000375', NULL, 'Predicted protein', 109, NULL, NULL, 23449),
(23450, '2.60.40.10-FF-003081', NULL, 'Uncharacterized protein', 91, NULL, NULL, 23450),
(23451, '3.30.160.60-FF-004665', NULL, NULL, 35, NULL, NULL, 23451),
(23452, '3.90.70.10-FF-000572', NULL, 'Uncharacterized protein', 232, NULL, NULL, 23452),
(23453, '1.20.1250.20-FF-001185', NULL, 'Uncharacterized protein', 199, NULL, NULL, 23453),
(23454, '3.50.50.60-FF-000418', NULL, '2-octaprenyl-6-methoxyphenyl hydroxylase', 201, NULL, NULL, 23454),
(23455, '3.30.260.10-FF-000021', NULL, 'Chaperonin CPN60, mitochondrial', 92, NULL, NULL, 23455),
(23456, '3.20.20.450-FF-000005', NULL, 'Cyclic di-GMP regulator CdgR', 237, NULL, NULL, 23456),
(23457, '2.60.40.60-FF-000549', NULL, 'Protein CBG11506', 97, NULL, NULL, 23457),
(23458, '3.40.50.1860-FF-000012', NULL, 'Aspartate-glutamate racemase family', 118, NULL, NULL, 23458),
(23459, '3.30.565.10-FF-000381', NULL, 'Protein CBR-MORC-1', 164, NULL, NULL, 23459),
(23460, '1.10.274.30-FF-000032', NULL, 'Uncharacterized protein', 119, NULL, NULL, 23460),
(23461, '2.60.40.10-FF-004744', NULL, NULL, 110, NULL, NULL, 23461),
(23462, '3.90.1150.10-FF-000105', NULL, 'alanine--glyoxylate aminotransferase 2, mitochondrial isoform X3', 36, NULL, NULL, 23462),
(23463, '3.10.110.10-FF-000083', NULL, 'RBR-type E3 ubiquitin transferase', 156, NULL, NULL, 23463),
(23464, '3.90.228.20-FF-000003', NULL, 'Phosphoenolpyruvate carboxykinase [GTP]', 267, NULL, NULL, 23464),
(23465, '1.25.40.10-FF-000393', NULL, 'Pentatricopeptide repeat-containing protein At1g20230', 124, NULL, NULL, 23465),
(23466, '2.60.120.290-FF-000032', NULL, 'Suppressor of tumorigenicity 14 protein homolog', 114, NULL, NULL, 23466),
(23467, '3.40.350.10-FF-000060', NULL, 'AGAP004109-PA', 151, NULL, NULL, 23467),
(23468, '1.10.510.10-FF-002740', NULL, 'Adhesion G protein-coupled receptor G1', 288, NULL, NULL, 23468),
(23469, '3.10.20.90-FF-000517', NULL, 'Protein DNA-DAMAGE INDUCIBLE 1', 85, NULL, NULL, 23469),
(23470, '1.20.1070.10-FF-001937', NULL, 'Uncharacterized protein', 248, NULL, NULL, 23470),
(23471, '3.30.40.10-FF-001455', NULL, 'Uncharacterized protein', 82, NULL, NULL, 23471),
(23472, '3.30.300.30-FF-000115', NULL, 'Acyl-CoA synthetase medium chain family member 5', 64, NULL, NULL, 23472),
(23473, '1.25.40.10-FF-002219', NULL, 'Secretory immunoglobulin A-binding protein EsiB', 467, NULL, NULL, 23473),
(23474, '3.80.10.10-FF-000265', NULL, 'Leucine-rich repeat-containing protein 40', 94, NULL, NULL, 23474);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(23475, '3.40.50.2300-FF-000004', NULL, 'Glutamate receptor, ionotropic, AMPA 2', 152, NULL, NULL, 23475),
(23476, '3.40.50.300-FF-004582', NULL, 'SNF2 domain-containing protein', 188, NULL, NULL, 23476),
(23477, '3.30.50.10-FF-000146', NULL, 'GATA-type transcription factor', 71, NULL, NULL, 23477),
(23478, '3.40.50.2300-FF-001286', NULL, NULL, 159, NULL, NULL, 23478),
(23479, '2.60.40.10-FF-002771', NULL, 'Amalgam, isoform C', 89, NULL, NULL, 23479),
(23480, '3.90.1140.10-FF-000015', NULL, 'U6 snRNA phosphodiesterase', 218, NULL, NULL, 23480),
(23481, '3.90.1800.10-FF-000015', NULL, 'DNA-directed RNA polymerase subunit beta', 107, NULL, NULL, 23481),
(23482, '3.40.50.1240-FF-000208', NULL, NULL, 112, NULL, NULL, 23482),
(23483, '3.30.420.40-FF-000184', NULL, 'NuA4 histone acetyltransferase subunit', 155, NULL, NULL, 23483),
(23484, '3.30.160.60-FF-004339', NULL, NULL, 26, NULL, NULL, 23484),
(23485, '1.10.1370.30-FF-000013', NULL, 'Peptidase family M2', 219, NULL, NULL, 23485),
(23486, '1.10.600.10-FF-000004', NULL, 'Phytoene synthase chloroplastic', 284, NULL, NULL, 23486),
(23487, '1.10.260.90-FF-000001', NULL, 'Genome polyprotein', 96, NULL, NULL, 23487),
(23488, '3.90.550.50-FF-000036', NULL, 'Putative glycosyltransferase family 31 protein', 233, NULL, NULL, 23488),
(23489, '3.40.50.1910-FF-000016', NULL, 'SNARE docking complex subunit', 245, NULL, NULL, 23489),
(23490, '3.30.230.130-FF-000021', NULL, 'Cullin-like protein', 145, NULL, NULL, 23490),
(23491, '2.120.10.30-FF-000215', NULL, 'Si:dkey-237h12.3', 79, NULL, NULL, 23491),
(23492, '3.40.50.920-FF-000052', NULL, 'Predicted protein', 93, NULL, NULL, 23492),
(23493, '3.40.630.30-FF-000548', NULL, 'Uncharacterized protein', 139, NULL, NULL, 23493),
(23494, '3.40.47.10-FF-000071', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 3', 150, NULL, NULL, 23494),
(23495, '1.20.1560.10-FF-000210', NULL, 'ATP-binding cassette, sub-family B (MDR/TAP), member 9', 270, NULL, NULL, 23495),
(23496, '3.40.190.10-FF-000345', NULL, 'Glutamate receptor', 112, NULL, NULL, 23496),
(23497, '3.40.50.300-FF-008325', NULL, 'Uncharacterized protein', 334, NULL, NULL, 23497),
(23498, '1.25.40.20-FF-000396', NULL, 'serine/threonine-protein kinase TNNI3K isoform X3', 96, NULL, NULL, 23498),
(23499, '3.80.10.10-FF-003671', NULL, 'Uncharacterized protein', 220, NULL, NULL, 23499),
(23500, '3.10.400.20-FF-000012', NULL, 'Translation machinery-associated protein, putative', 176, NULL, NULL, 23500),
(23501, '4.10.520.10-FF-000003', NULL, 'Integration host factor subunit beta', 94, NULL, NULL, 23501),
(23502, '3.30.40.10-FF-000527', NULL, 'Neuralized E3 ubiquitin protein ligase 3', 65, NULL, NULL, 23502),
(23503, '3.10.20.90-FF-000697', NULL, 'Uncharacterized protein', 82, NULL, NULL, 23503),
(23504, '1.20.120.160-FF-000020', NULL, 'Histidine phosphotransferase-1, variant 1', 133, NULL, NULL, 23504),
(23505, '1.25.40.20-FF-000750', NULL, 'Ankyrin repeat domain 17', 100, NULL, NULL, 23505),
(23506, '1.10.510.10-FF-000531', NULL, 'Wee1-like protein kinase', 170, NULL, NULL, 23506),
(23507, '3.40.50.2000-FF-000212', NULL, 'Glycosyl transferase family 1', 221, NULL, NULL, 23507),
(23508, '3.40.33.10-FF-000067', NULL, 'Uncharacterized protein, isoform A', 237, NULL, NULL, 23508),
(23509, '3.40.50.300-FF-006173', NULL, 'Predicted protein', 114, NULL, NULL, 23509),
(23510, '3.40.190.10-FF-000906', NULL, 'Uncharacterized protein', 109, NULL, NULL, 23510),
(23511, '3.30.710.10-FF-000303', NULL, 'BTB/POZ and TAZ domain-containing protein 2', 96, NULL, NULL, 23511),
(23512, '3.40.532.10-FF-000022', NULL, NULL, 69, NULL, NULL, 23512),
(23513, '3.40.50.720-FF-001184', NULL, 'D-3-phosphoglycerate dehydrogenase', 118, NULL, NULL, 23513),
(23514, '3.30.160.60-FF-004486', NULL, NULL, 78, NULL, NULL, 23514),
(23515, '3.60.40.10-FF-000369', NULL, 'Putative protein phosphatase', 257, NULL, NULL, 23515),
(23516, '1.20.58.2220-FF-000019', NULL, 'Formin 1', 411, NULL, NULL, 23516),
(23517, '1.10.12.70-FF-000014', NULL, NULL, 64, NULL, NULL, 23517),
(23518, '1.10.720.50-FF-000002', NULL, 'DNA methyltransferase 3 alpha', 76, NULL, NULL, 23518);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(23519, '1.10.10.10-FF-000413', NULL, 'Ribokinase', 52, NULL, NULL, 23519),
(23520, '2.40.50.180-FF-000002', NULL, 'Chemotaxis protein CheW', 68, NULL, NULL, 23520),
(23521, '2.130.10.10-FF-004222', NULL, 'Uncharacterized protein', 147, NULL, NULL, 23521),
(23522, '3.40.50.300-FF-002811', NULL, 'ABC transporter, ATP-binding protein', 242, NULL, NULL, 23522),
(23523, '3.30.70.1450-FF-000044', NULL, 'Sulfur deprivation response regulator', 88, NULL, NULL, 23523),
(23524, '3.30.70.330-FF-002652', NULL, NULL, 120, NULL, NULL, 23524),
(23525, '3.40.50.1100-FF-000190', NULL, 'Threonine synthase', 139, NULL, NULL, 23525),
(23526, '3.30.70.330-FF-002034', NULL, NULL, 82, NULL, NULL, 23526),
(23527, '2.30.29.30-FF-001139', NULL, 'Uncharacterized protein', 117, NULL, NULL, 23527),
(23528, '3.40.1230.10-FF-000016', NULL, 'Uncharacterized protein', 132, NULL, NULL, 23528),
(23529, '1.10.720.60-FF-000005', NULL, 'Enolase-phosphatase E1', 88, NULL, NULL, 23529),
(23530, '3.40.50.300-FF-005071', NULL, 'Uncharacterized protein', 108, NULL, NULL, 23530),
(23531, '3.40.50.970-FF-000134', NULL, 'Pyruvate dehydrogenase E1 component subunit alpha', 354, NULL, NULL, 23531),
(23532, '1.20.1250.20-FF-000050', NULL, 'glucose-6-phosphate exchanger SLC37A2 isoform X1', 201, NULL, NULL, 23532),
(23533, '1.20.120.1900-FF-000094', NULL, 'Spindle pole body component', 104, NULL, NULL, 23533),
(23534, '2.60.120.40-FF-000023', NULL, 'tumor necrosis factor ligand superfamily member 8', 138, NULL, NULL, 23534),
(23535, '3.60.21.10-FF-000477', NULL, 'Serine/threonine-protein phosphatase', 260, NULL, NULL, 23535),
(23536, '3.10.20.90-FF-001006', NULL, 'Erythrocyte membrane protein band 4.1-like 5', 85, NULL, NULL, 23536),
(23537, '3.30.830.10-FF-000043', NULL, 'Protease 3', 231, NULL, NULL, 23537),
(23538, '3.40.1410.10-FF-000053', NULL, 'Transcriptional regulator, putative', 146, NULL, NULL, 23538),
(23539, '1.25.10.10-FF-002864', NULL, 'Uncharacterized protein', 162, NULL, NULL, 23539),
(23540, '1.10.630.10-FF-000478', NULL, 'Predicted protein', 477, NULL, NULL, 23540),
(23541, '1.10.1600.10-FF-000037', NULL, 'Inverted repeat-binding protein', 88, NULL, NULL, 23541),
(23542, '1.25.40.10-FF-002366', NULL, 'Pentatricopeptide repeat-containing protein At5g42450, mitochondrial', 103, NULL, NULL, 23542),
(23543, '2.40.50.140-FF-001120', NULL, NULL, 89, NULL, NULL, 23543),
(23544, '3.40.640.10-FF-000161', NULL, 'Unplaced genomic scaffold supercont1.20, whole genome shotgun sequence', 274, NULL, NULL, 23544),
(23545, '3.30.559.10-FF-000260', NULL, 'Pelargonidin 3-O-(6-caffeoylglucoside) 5-O-(6-O-malonylglucoside) 4''''''-malonyltransferase', 193, NULL, NULL, 23545),
(23546, '3.30.200.20-FF-001330', NULL, 'Kinase family protein', 63, NULL, NULL, 23546),
(23547, '2.130.10.10-FF-004429', NULL, 'Predicted protein', 357, NULL, NULL, 23547),
(23548, '2.40.10.10-FF-000157', NULL, 'GH18608p', 130, NULL, NULL, 23548),
(23549, '1.25.10.10-FF-000094', NULL, 'Serine/threonine-protein kinase mTOR', 396, NULL, NULL, 23549),
(23550, '2.130.10.10-FF-001788', NULL, 'WD repeat-containing protein 91', 201, NULL, NULL, 23550),
(23551, '3.40.50.300-FF-006791', NULL, 'Uncharacterized protein', 57, NULL, NULL, 23551),
(23552, '1.10.10.10-FF-001695', NULL, 'Regulatory protein ArsR', 105, NULL, NULL, 23552),
(23553, '1.20.1200.10-FF-000009', NULL, 'ATP/cobalamin adenosyltransferase', 149, NULL, NULL, 23553),
(23554, '2.10.110.10-FF-000210', NULL, 'Actin-binding LIM protein family, member 3', 64, NULL, NULL, 23554),
(23555, '3.80.10.10-FF-003519', NULL, 'Uncharacterized protein', 175, NULL, NULL, 23555),
(23556, '3.40.50.300-FF-000866', NULL, 'Molybdate ABC transporter ATP-binding protein ModF', 235, NULL, NULL, 23556),
(23557, '3.40.50.300-FF-003300', NULL, 'Dynamin GTPase, putative', 322, NULL, NULL, 23557),
(23558, '1.10.1670.10-FF-000018', NULL, 'Endonuclease III', 77, NULL, NULL, 23558),
(23559, '3.30.40.10-FF-002091', NULL, 'Putative E3 ubiquitin-protein ligase C36B7.05c', 88, NULL, NULL, 23559),
(23560, '1.20.1730.10-FF-000010', NULL, 'Solute carrier family 5 member 2', 530, NULL, NULL, 23560);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(23561, '2.60.40.150-FF-000644', NULL, 'Uncharacterized protein', 127, NULL, NULL, 23561),
(23562, '3.80.10.10-FF-004008', NULL, 'Autophagy-related protein', 150, NULL, NULL, 23562),
(23563, '3.30.43.10-FF-000034', NULL, 'Purine hydroxylase gamma subunit apoprotein', 53, NULL, NULL, 23563),
(23564, '2.130.10.10-FF-000506', NULL, 'Protein NEDD1', 168, NULL, NULL, 23564),
(23565, '2.130.10.10-FF-002277', NULL, 'WD domain containing protein', 245, NULL, NULL, 23565),
(23566, '2.170.270.10-FF-000077', NULL, 'protein msta', 116, NULL, NULL, 23566),
(23567, '3.40.50.2000-FF-000830', NULL, 'Cell wall alpha-1,3-glucan synthase mok12', 263, NULL, NULL, 23567),
(23568, '3.40.50.720-FF-000610', NULL, 'Quinate 5-dehydrogenase QutB', 159, NULL, NULL, 23568),
(23569, '3.40.50.10540-FF-000007', NULL, 'Cinnamoyl-CoA:phenyllactate CoA-transferase', 292, NULL, NULL, 23569),
(23570, '3.80.10.10-FF-001367', NULL, 'Leucine-rich repeat-containing protein 70', 131, NULL, NULL, 23570),
(23571, '3.30.40.10-FF-000320', NULL, 'E3 ubiquitin-protein ligase RNF103 isoform X1', 56, NULL, NULL, 23571),
(23572, '1.10.10.10-FF-001610', NULL, 'Uncharacterized protein', 106, NULL, NULL, 23572),
(23573, '3.90.1150.10-FF-000252', NULL, 'Aminotransferase', 102, NULL, NULL, 23573),
(23574, '3.30.420.10-FF-000669', NULL, NULL, 179, NULL, NULL, 23574),
(23575, '1.25.10.10-FF-001667', NULL, 'Cullin-associated NEDD8-dissociated protein 1', 325, NULL, NULL, 23575),
(23576, '2.170.260.40-FF-000001', NULL, '5''-3'' exoribonuclease 1', 184, NULL, NULL, 23576),
(23577, '3.90.550.10-FF-000457', NULL, 'Isoprenoid synthase domain-containing protein', 236, NULL, NULL, 23577),
(23578, '1.20.1070.10-FF-002191', NULL, 'Predicted protein', 64, NULL, NULL, 23578),
(23579, '3.10.20.90-FF-000489', NULL, 'band 4.1-like protein 3 isoform X1', 76, NULL, NULL, 23579),
(23580, '1.25.40.10-FF-002804', NULL, 'Signal recognition particle subunit SRP72', 323, NULL, NULL, 23580),
(23581, '1.20.1560.10-FF-000710', NULL, 'Uncharacterized protein', 303, NULL, NULL, 23581),
(23582, '1.20.120.20-FF-000024', NULL, 'YALI0F24409p', 95, NULL, NULL, 23582),
(23583, '1.10.10.10-FF-002066', NULL, 'Uncharacterized protein', 30, NULL, NULL, 23583),
(23584, '3.30.1360.10-FF-000034', NULL, 'DNA-directed RNA polymerase I and III 14 kDa polypeptide (AFU_orthologue AFUA_6G04610)', 113, NULL, NULL, 23584),
(23585, '3.80.10.10-FF-003492', NULL, 'Predicted protein', 200, NULL, NULL, 23585),
(23586, '2.130.10.10-FF-003997', NULL, 'Uncharacterized protein', 229, NULL, NULL, 23586),
(23587, '3.30.200.20-FF-002550', NULL, 'Uncharacterized protein', 83, NULL, NULL, 23587),
(23588, '2.120.10.30-FF-000541', NULL, 'Low density lipoprotein receptor-related protein 2', 85, NULL, NULL, 23588),
(23589, '2.60.120.650-FF-000191', NULL, 'Uncharacterized protein', 70, NULL, NULL, 23589),
(23590, '3.40.50.300-FF-004374', NULL, 'Ribosylnicotinamide kinase', 214, NULL, NULL, 23590),
(23591, '3.50.7.10-FF-000041', NULL, NULL, 159, NULL, NULL, 23591),
(23592, '3.30.505.10-FF-000164', NULL, NULL, 108, NULL, NULL, 23592),
(23593, '1.25.40.10-FF-002692', NULL, 'Small glutamine-rich tetratricopeptide repeat-containing protein 2', 146, NULL, NULL, 23593),
(23594, '1.10.150.240-FF-000064', NULL, 'Putative phosphoglycolate phosphatase', 68, NULL, NULL, 23594),
(23595, '2.60.40.3510-FF-000026', NULL, 'Delta-like protein', 169, NULL, NULL, 23595),
(23596, '2.40.160.210-FF-000004', NULL, 'Acyl-CoA thioesterase 2', 307, NULL, NULL, 23596),
(23597, '2.30.40.10-FF-000041', NULL, 'Imidazolonepropionase', 85, NULL, NULL, 23597),
(23598, '2.60.40.10-FF-000793', NULL, 'pikachurin isoform X1', 102, NULL, NULL, 23598),
(23599, '3.90.640.10-FF-000110', NULL, 'Chaperone protein DNAK, putative', 92, NULL, NULL, 23599),
(23600, '4.10.60.10-FF-000207', NULL, 'Branchpoint-bridging protein', 51, NULL, NULL, 23600),
(23601, '1.25.40.10-FF-002220', NULL, 'Uncharacterized protein', 295, NULL, NULL, 23601),
(23602, '3.40.50.2300-FF-000212', NULL, 'Stress response regulator/HFS transcription factor', 136, NULL, NULL, 23602),
(23603, '3.10.20.30-FF-000106', NULL, NULL, 61, NULL, NULL, 23603);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(23604, '2.40.160.200-FF-000001', NULL, 'LURP-one-like protein (DUF567)', 194, NULL, NULL, 23604),
(23605, '3.20.20.70-FF-000781', NULL, NULL, 76, NULL, NULL, 23605),
(23606, '3.40.50.300-FF-001237', NULL, 'Dynamin-related protein 4C', 285, NULL, NULL, 23606),
(23607, '3.30.70.20-FF-000066', NULL, 'Ferredoxin III', 45, NULL, NULL, 23607),
(23608, '3.30.40.10-FF-001663', NULL, 'Uncharacterized protein', 86, NULL, NULL, 23608),
(23609, '2.30.30.40-FF-000549', NULL, 'Discs, large homolog 4', 123, NULL, NULL, 23609),
(23610, '1.20.1070.10-FF-001729', NULL, 'Calcitonin receptor, putative', 94, NULL, NULL, 23610),
(23611, '3.40.50.10810-FF-000139', NULL, 'ATP-dependent helicase, putative', 291, NULL, NULL, 23611),
(23612, '2.130.10.10-FF-004076', NULL, 'Chromosome 8, whole genome shotgun sequence', 203, NULL, NULL, 23612),
(23613, '3.30.160.60-FF-003030', NULL, NULL, 33, NULL, NULL, 23613),
(23614, '3.50.50.60-FF-000536', NULL, 'Thioredoxin reductase GliT', 124, NULL, NULL, 23614),
(23615, '2.70.20.10-FF-000004', NULL, 'DNA topoisomerase', 68, NULL, NULL, 23615),
(23616, '3.80.10.10-FF-000939', NULL, 'LRR receptor-like serine/threonine-protein kinase GSO1', 163, NULL, NULL, 23616),
(23617, '3.90.640.90-FF-000027', NULL, 'Uncharacterized protein', 79, NULL, NULL, 23617),
(23618, '3.30.390.10-FF-000025', NULL, 'Uncharacterized protein', 75, NULL, NULL, 23618),
(23619, '3.50.50.60-FF-000065', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 113, NULL, NULL, 23619),
(23620, '1.10.510.10-FF-001312', NULL, 'Putative serine/threonine-protein kinase', 222, NULL, NULL, 23620),
(23621, '3.40.630.50-FF-000003', NULL, 'D-aminoacyl-tRNA deacylase', 192, NULL, NULL, 23621),
(23622, '3.30.60.20-FF-000094', NULL, 'Diacylglycerol kinase', 56, NULL, NULL, 23622),
(23623, '3.40.50.12780-FF-000011', NULL, 'Acetyl-coenzyme A synthetase 2-like, mitochondrial', 496, NULL, NULL, 23623),
(23624, '3.40.50.300-FF-005037', NULL, 'Uncharacterized protein', 181, NULL, NULL, 23624),
(23625, '2.40.100.10-FF-000141', NULL, 'Peptidyl-prolyl cis-trans isomerase', 182, NULL, NULL, 23625),
(23626, '2.130.10.10-FF-002895', NULL, 'Suppressor of mec-8 and unc-52 protein homolog 1', 186, NULL, NULL, 23626),
(23627, '1.20.58.530-FF-000008', NULL, 'unconventional myosin-VIIa', 152, NULL, NULL, 23627),
(23628, '3.30.200.20-FF-001976', NULL, 'Probable serine/threonine-protein kinase DDB_G0283301', 101, NULL, NULL, 23628),
(23629, '2.60.40.150-FF-000318', NULL, 'AGAP000124-PA', 120, NULL, NULL, 23629),
(23630, '1.10.3210.10-FF-000108', NULL, 'Uncharacterized protein', 87, NULL, NULL, 23630),
(23631, '3.30.9.10-FF-000287', NULL, 'Uncharacterized protein', 176, NULL, NULL, 23631),
(23632, '3.40.50.720-FF-001863', NULL, 'Uncharacterized protein', 184, NULL, NULL, 23632),
(23633, '2.60.200.20-FF-000164', NULL, 'nibrin isoform X1', 110, NULL, NULL, 23633),
(23634, '3.30.60.30-FF-000097', NULL, 'Solute carrier organic anion transporter family member', 55, NULL, NULL, 23634),
(23635, '2.60.120.260-FF-000490', NULL, 'Uncharacterized protein', 111, NULL, NULL, 23635),
(23636, '3.40.50.1580-FF-000018', NULL, '5''-methylthioadenosine/S-adenosylhomocysteine nucleosidase', 230, NULL, NULL, 23636),
(23637, '2.60.120.260-FF-000602', NULL, 'RING zinc finger-containing protein', 145, NULL, NULL, 23637),
(23638, '2.60.40.790-FF-000044', NULL, 'Co-chaperone p23', 115, NULL, NULL, 23638),
(23639, '3.30.2090.10-FF-000024', NULL, 'Transporter, AcrB/D/F family', 91, NULL, NULL, 23639),
(23640, '3.40.50.360-FF-000013', NULL, 'Glutathione-regulated potassium-efflux system ancillary protein KefG', 174, NULL, NULL, 23640),
(23641, '3.30.40.10-FF-000027', NULL, 'Pre-mRNA-processing factor 19, putative', 58, NULL, NULL, 23641),
(23642, '1.25.10.10-FF-002656', NULL, 'Uncharacterized protein', 104, NULL, NULL, 23642),
(23643, '3.40.30.10-FF-000768', NULL, 'Iodothyronine deiodinase', 170, NULL, NULL, 23643),
(23644, '3.40.50.1480-FF-000022', NULL, NULL, 130, NULL, NULL, 23644),
(23645, '2.60.40.1180-FF-000136', NULL, 'Uncharacterized protein', 120, NULL, NULL, 23645);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(23646, '1.20.200.10-FF-000022', NULL, 'Predicted protein', 106, NULL, NULL, 23646),
(23647, '3.40.50.300-FF-006465', NULL, 'Uncharacterized protein', 119, NULL, NULL, 23647),
(23648, '3.40.50.720-FF-001392', NULL, 'YALI0E20735p', 166, NULL, NULL, 23648),
(23649, '1.10.10.10-FF-000885', NULL, 'Histone acetyltransferase', 50, NULL, NULL, 23649),
(23650, '3.40.50.1440-FF-000061', NULL, 'Epsilon tubulin', 408, NULL, NULL, 23650),
(23651, '3.40.50.1240-FF-000181', NULL, NULL, 161, NULL, NULL, 23651),
(23652, '3.30.70.330-FF-002152', NULL, NULL, 99, NULL, NULL, 23652),
(23653, '2.60.40.10-FF-000736', NULL, 'Junctional adhesion molecule-like', 116, NULL, NULL, 23653),
(23654, '3.30.1640.10-FF-000016', NULL, 'DNA helicase', 89, NULL, NULL, 23654),
(23655, '2.70.240.20-FF-000001', NULL, 'Heat-labile hemolysin', 374, NULL, NULL, 23655),
(23656, '3.90.70.10-FF-000807', NULL, 'Uncharacterized protein', 314, NULL, NULL, 23656),
(23657, '3.60.10.10-FF-000221', NULL, 'Uncharacterized protein', 268, NULL, NULL, 23657),
(23658, '3.30.540.10-FF-000088', NULL, 'Nucleotidase 4F8, putative', 56, NULL, NULL, 23658),
(23659, '4.10.60.10-FF-000095', NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', 25, NULL, NULL, 23659),
(23660, '3.30.2160.10-FF-000053', NULL, 'Uncharacterized protein', 68, NULL, NULL, 23660),
(23661, '3.30.450.20-FF-000325', NULL, 'Period circadian protein homolog 1', 110, NULL, NULL, 23661),
(23662, '3.40.630.60-FF-000006', NULL, 'Ornithine decarboxylase antizyme', 104, NULL, NULL, 23662),
(23663, '3.30.230.10-FF-000014', NULL, 'DNA mismatch repair protein Mlh1', 127, NULL, NULL, 23663),
(23664, '3.40.50.720-FF-001919', NULL, 'Uncharacterized protein', 20, NULL, NULL, 23664),
(23665, '1.10.10.10-FF-000621', NULL, 'DEAD/DEAH box helicase, putative', 110, NULL, NULL, 23665),
(23666, '2.120.10.80-FF-000387', NULL, 'Tip elongation aberrant protein 1', 224, NULL, NULL, 23666),
(23667, '1.25.40.10-FF-004018', NULL, 'Uncharacterized protein', 195, NULL, NULL, 23667),
(23668, '3.40.640.10-FF-000127', NULL, 'Aromatic amino acid aminotransferase C56E4.03', 564, NULL, NULL, 23668),
(23669, '3.90.1410.10-FF-000143', NULL, 'Uncharacterized protein', 296, NULL, NULL, 23669),
(23670, '2.130.10.10-FF-003412', NULL, 'Peptidyl-prolyl cis-trans isomerase, putative (AFU_orthologue AFUA_1G01750)', 187, NULL, NULL, 23670),
(23671, '2.60.40.10-FF-002827', NULL, 'Semaphorin-2A', 60, NULL, NULL, 23671),
(23672, '3.30.200.20-FF-001122', NULL, 'Serine/threonine-protein kinase par-4', 95, NULL, NULL, 23672),
(23673, '3.40.190.80-FF-000085', NULL, 'Inositol monophosphatase family protein', 112, NULL, NULL, 23673),
(23674, '3.40.50.1000-FF-000485', NULL, 'GH05933p', 145, NULL, NULL, 23674),
(23675, '3.40.630.70-FF-000009', NULL, 'Hypothetical_protein_-_conserved', 200, NULL, NULL, 23675),
(23676, '1.10.10.10-FF-001402', NULL, 'Repressor protein c', 69, NULL, NULL, 23676),
(23677, '1.25.10.10-FF-001993', NULL, 'U3 small nucleolar RNA-associated protein 10', 215, NULL, NULL, 23677),
(23678, '3.80.10.10-FF-002064', NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', 253, NULL, NULL, 23678),
(23679, '2.130.10.10-FF-002631', NULL, 'Wdr36 protein', 81, NULL, NULL, 23679),
(23680, '3.40.850.10-FF-000261', NULL, 'Kinesin-6 like protein', 386, NULL, NULL, 23680),
(23681, '1.20.272.10-FF-000047', NULL, NULL, 87, NULL, NULL, 23681),
(23682, '3.40.50.300-FF-008589', NULL, 'Uncharacterized protein', 136, NULL, NULL, 23682),
(23683, '1.25.40.10-FF-000067', NULL, 'Cell division cycle protein 16 homolog', 494, NULL, NULL, 23683),
(23684, '1.10.287.130-FF-000108', NULL, 'Two-component sensor histidine kinase', 70, NULL, NULL, 23684),
(23685, '1.20.1560.10-FF-000031', NULL, 'ATP-binding cassette sub-family B member 9', 327, NULL, NULL, 23685),
(23686, '3.10.129.10-FF-000075', NULL, 'Thioesterase family protein, putaive', 144, NULL, NULL, 23686),
(23687, '2.60.40.10-FF-002119', NULL, 'Matrix remodeling associated 5', 102, NULL, NULL, 23687),
(23688, '1.25.10.10-FF-000947', NULL, 'Ubiquitin-binding TORC1 subunit', 330, NULL, NULL, 23688);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(23689, '2.20.70.10-FF-000122', NULL, 'Peptidyl-prolyl cis-trans isomerase', 49, NULL, NULL, 23689),
(23690, '1.20.1280.20-FF-000023', NULL, 'Uncharacterized protein', 95, NULL, NULL, 23690),
(23691, '2.70.150.10-FF-000137', NULL, 'Sarcoplasmic/endoplasmic reticulum calcium ATPase 2', 41, NULL, NULL, 23691),
(23692, '1.20.1250.20-FF-001685', NULL, 'Uncharacterized protein', 222, NULL, NULL, 23692),
(23693, '3.30.565.10-FF-000555', NULL, 'Coatomer subunit beta''-3', 37, NULL, NULL, 23693),
(23694, '3.30.160.60-FF-004873', NULL, NULL, 40, NULL, NULL, 23694),
(23695, '3.40.50.720-FF-002173', NULL, 'Os07g0674100 protein', 67, NULL, NULL, 23695),
(23696, '3.30.2130.10-FF-000017', NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase', 86, NULL, NULL, 23696),
(23697, '1.10.150.20-FF-000017', NULL, 'DNA excision repair protein ERCC-1', 84, NULL, NULL, 23697),
(23698, '3.30.200.20-FF-000195', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', 112, NULL, NULL, 23698),
(23699, '3.90.470.10-FF-000041', NULL, 'Uncharacterized protein', 140, NULL, NULL, 23699),
(23700, '3.40.50.12230-FF-000020', NULL, 'Methionyl-trna formyltransferase', 326, NULL, NULL, 23700),
(23701, '1.25.40.180-FF-000113', NULL, 'Uncharacterized protein', 214, NULL, NULL, 23701),
(23702, '3.40.50.300-FF-006408', NULL, 'RAB20, member RAS oncogene family', 132, NULL, NULL, 23702),
(23703, '3.40.50.720-FF-001599', NULL, 'Fatty acyl-CoA reductase', 174, NULL, NULL, 23703),
(23704, '2.70.150.10-FF-000019', NULL, 'Phospholipid-transporting ATPase', 134, NULL, NULL, 23704),
(23705, '1.10.472.10-FF-000604', NULL, 'Uncharacterized protein', 15, NULL, NULL, 23705),
(23706, '3.50.50.60-FF-000744', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 92, NULL, NULL, 23706),
(23707, '1.20.1560.10-FF-000502', NULL, 'Predicted protein', 310, NULL, NULL, 23707),
(23708, '6.20.50.160-FF-000002', NULL, 'Thioester-containing protein 2, isoform B', 60, NULL, NULL, 23708),
(23709, '3.30.160.60-FF-002687', NULL, 'Uncharacterized protein', 29, NULL, NULL, 23709),
(23710, '1.10.730.10-FF-000160', NULL, 'Methionine-tRNA ligase', 186, NULL, NULL, 23710),
(23711, '3.40.50.2300-FF-000476', NULL, 'Guanylate cyclase', 188, NULL, NULL, 23711),
(23712, '2.60.40.60-FF-000375', NULL, 'Protocadherin 12', 107, NULL, NULL, 23712),
(23713, '3.40.50.300-FF-001029', NULL, 'NLR family member X1', 225, NULL, NULL, 23713),
(23714, '1.10.30.10-FF-000089', NULL, 'high mobility group B protein 7 isoform X1', 77, NULL, NULL, 23714),
(23715, '2.60.40.2030-FF-000048', NULL, 'Adhesion G-protein coupled receptor V1', 105, NULL, NULL, 23715),
(23716, '1.10.8.270-FF-000141', NULL, 'Predicted protein', 105, NULL, NULL, 23716),
(23717, '3.20.100.10-FF-000001', NULL, 'mRNA-capping enzyme subunit beta', 311, NULL, NULL, 23717),
(23718, '2.60.120.260-FF-000309', NULL, 'M28 family peptidase', 144, NULL, NULL, 23718),
(23719, '3.30.40.10-FF-000292', NULL, 'RING-type E3 ubiquitin transferase', 77, NULL, NULL, 23719),
(23720, '1.10.3970.10-FF-000002', NULL, 'Putative RNA polymerase II transcription factor B subunit 1-1', 74, NULL, NULL, 23720),
(23721, '3.40.50.2000-FF-000504', NULL, 'Glycosyltransferase', 149, NULL, NULL, 23721),
(23722, '2.60.34.10-FF-000054', NULL, 'Heat shock protein family A (Hsp70) member 4', 64, NULL, NULL, 23722),
(23723, '3.10.100.10-FF-000172', NULL, 'macrophage mannose receptor 1 isoform X2', 146, NULL, NULL, 23723),
(23724, '1.25.10.10-FF-000239', NULL, 'RING-type E3 ubiquitin transferase', 166, NULL, NULL, 23724),
(23725, '2.120.10.80-FF-000180', NULL, 'Kelch motif family protein, expressed', 168, NULL, NULL, 23725),
(23726, '1.20.5.880-FF-000001', NULL, 'Photosystem II reaction center protein H', 64, NULL, NULL, 23726),
(23727, '3.30.420.40-FF-000419', NULL, 'Actin, putative', 109, NULL, NULL, 23727),
(23728, '3.40.190.10-FF-000171', NULL, 'Transcriptional regulator LysR family', 105, NULL, NULL, 23728),
(23729, '2.120.10.80-FF-000123', NULL, 'Uncharacterized protein, isoform B', 130, NULL, NULL, 23729),
(23730, '3.90.226.10-FF-000069', NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', 351, NULL, NULL, 23730);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(23731, '3.40.50.620-FF-000344', NULL, 'Isoleucine--tRNA ligase, cytoplasmic', 42, NULL, NULL, 23731),
(23732, '2.130.10.10-FF-005975', NULL, 'Uncharacterized protein', 235, NULL, NULL, 23732),
(23733, '2.170.140.10-FF-000040', NULL, 'peritrophin-1 isoform X1', 66, NULL, NULL, 23733),
(23734, '1.10.1820.10-FF-000020', NULL, 'Casein kinase II subunit beta', 104, NULL, NULL, 23734),
(23735, '2.30.30.210-FF-000009', NULL, 'Ribonuclease P protein subunit POP4', 117, NULL, NULL, 23735),
(23736, '3.10.350.10-FF-000038', NULL, 'Morphogenetic protein associated', 55, NULL, NULL, 23736),
(23737, '3.90.550.10-FF-000249', NULL, 'Procollagen-lysine,2-oxoglutarate 5-dioxygenase 2', 158, NULL, NULL, 23737),
(23738, '3.30.160.60-FF-000478', NULL, 'Zinc finger protein 133', 30, NULL, NULL, 23738),
(23739, '3.30.300.130-FF-000037', NULL, NULL, 80, NULL, NULL, 23739),
(23740, '1.10.287.1490-FF-000118', NULL, 'Viral A-type inclusion protein, putative', 157, NULL, NULL, 23740),
(23741, '3.80.10.10-FF-003963', NULL, 'Uncharacterized protein', 190, NULL, NULL, 23741),
(23742, '1.10.238.10-FF-000869', NULL, 'Uncharacterized protein', 63, NULL, NULL, 23742),
(23743, '3.40.20.10-FF-000088', NULL, 'Uncharacterized protein', 138, NULL, NULL, 23743),
(23744, '1.25.10.10-FF-002538', NULL, 'Predicted protein', 184, NULL, NULL, 23744),
(23745, '1.10.286.10-FF-000008', NULL, 'GTP cyclohydrolase I 1', 46, NULL, NULL, 23745),
(23746, '3.60.21.10-FF-000185', NULL, '5-nucleotidase', 258, NULL, NULL, 23746),
(23747, '3.30.830.10-FF-000335', NULL, 'Proteasome 26S subunit, ATPase 2', 117, NULL, NULL, 23747),
(23748, '1.10.238.10-FF-000605', NULL, 'EF hand family protein', 81, NULL, NULL, 23748),
(23749, '1.25.40.20-FF-001059', NULL, 'Predicted protein', 74, NULL, NULL, 23749),
(23750, '1.20.1070.10-FF-000948', NULL, 'Uncharacterized protein', 112, NULL, NULL, 23750),
(23751, '2.130.10.10-FF-003620', NULL, 'WD repeat-containing protein DDB_G0290555', 232, NULL, NULL, 23751),
(23752, '3.30.70.330-FF-002360', NULL, NULL, 105, NULL, NULL, 23752),
(23753, '2.60.120.200-FF-000045', NULL, 'Transmembrane agrin', 182, NULL, NULL, 23753),
(23754, '3.30.160.20-FF-000106', NULL, 'R2D2', 89, NULL, NULL, 23754),
(23755, '1.10.220.160-FF-000028', NULL, NULL, 94, NULL, NULL, 23755),
(23756, '3.10.28.10-FF-000011', NULL, 'Intron-encoded DNA endonuclease aI3', 153, NULL, NULL, 23756),
(23757, '3.90.930.12-FF-000022', NULL, NULL, 72, NULL, NULL, 23757),
(23758, '3.40.309.10-FF-000043', NULL, '10-formyltetrahydrofolate dehydrogenase', 192, NULL, NULL, 23758),
(23759, '1.10.246.130-FF-000027', NULL, NULL, 95, NULL, NULL, 23759),
(23760, '3.30.70.330-FF-002208', NULL, NULL, 105, NULL, NULL, 23760),
(23761, '3.40.50.300-FF-002665', NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', 141, NULL, NULL, 23761),
(23762, '1.10.220.150-FF-000025', NULL, 'GTPase-activating protein, putative', 148, NULL, NULL, 23762),
(23763, '3.40.1350.10-FF-000048', NULL, 'Heat shock 70 kDa protein cognate 4-like Protein', 107, NULL, NULL, 23763),
(23764, '2.30.30.30-FF-000075', NULL, 'Transcription termination/antitermination protein NusG', 61, NULL, NULL, 23764),
(23765, '3.30.40.10-FF-000235', NULL, 'E3 ubiquitin-protein ligase ZNRF1', 61, NULL, NULL, 23765),
(23766, '1.25.40.10-FF-003001', NULL, 'Os10g0442700 protein', 125, NULL, NULL, 23766),
(23767, '1.10.510.10-FF-002447', NULL, NULL, 265, NULL, NULL, 23767),
(23768, '3.30.497.10-FF-000155', NULL, 'Uncharacterized protein', 80, NULL, NULL, 23768),
(23769, '3.40.50.300-FF-001501', NULL, 'Chromatin remodeling factor18', 231, NULL, NULL, 23769),
(23770, '3.30.70.980-FF-000048', NULL, 'Predicted protein', 86, NULL, NULL, 23770),
(23771, '1.10.418.10-FF-000142', NULL, 'Neuron navigator 2', 84, NULL, NULL, 23771),
(23772, '2.60.40.10-FF-004418', NULL, NULL, 97, NULL, NULL, 23772),
(23773, '3.30.420.40-FF-000571', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', 191, NULL, NULL, 23773),
(23774, '3.40.640.10-FF-000335', NULL, 'Uncharacterized protein', 217, NULL, NULL, 23774),
(23775, '2.40.128.630-FF-000003', NULL, 'Cell surface protein', 74, NULL, NULL, 23775);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(23776, '3.30.40.10-FF-002326', NULL, 'Uncharacterized protein', 98, NULL, NULL, 23776),
(23777, '2.60.40.10-FF-004536', NULL, NULL, 92, NULL, NULL, 23777),
(23778, '3.30.1520.10-FF-000007', NULL, 'sorting nexin-14 isoform X1', 146, NULL, NULL, 23778),
(23779, '2.130.10.10-FF-004194', NULL, 'Uncharacterized protein', 159, NULL, NULL, 23779),
(23780, '3.30.200.20-FF-000307', NULL, 'pollen receptor-like kinase 1', 106, NULL, NULL, 23780),
(23781, '3.40.220.10-FF-000022', NULL, 'Blast:O-acetyl-ADP-ribose deacetylase 1', 141, NULL, NULL, 23781),
(23782, '3.40.50.300-FF-000574', NULL, '116 kDa U5 small nuclear ribonucleoprotein component', 186, NULL, NULL, 23782),
(23783, '3.30.890.10-FF-000018', NULL, 'Methyl-CpG-binding domain protein 4', 68, NULL, NULL, 23783),
(23784, '3.90.1640.10-FF-000008', NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', 247, NULL, NULL, 23784),
(23785, '3.80.10.10-FF-001193', NULL, 'Leucine-rich repeat receptor protein kinase EMS1', 57, NULL, NULL, 23785),
(23786, '3.30.1320.10-FF-000026', NULL, 'Predicted protein', 91, NULL, NULL, 23786),
(23787, '3.30.1600.10-FF-000008', NULL, 'NAD-dependent protein deacetylase sirtuin-1', 83, NULL, NULL, 23787),
(23788, '3.40.630.10-FF-000396', NULL, 'Uncharacterized protein (Fragment)', 16, NULL, NULL, 23788),
(23789, '1.10.10.2830-FF-000002', NULL, 'ParB-like protein', 131, NULL, NULL, 23789),
(23790, '1.20.5.320-FF-000002', NULL, '6-phosphogluconate dehydrogenase, decarboxylating', 48, NULL, NULL, 23790),
(23791, '1.10.10.2840-FF-000005', NULL, NULL, 128, NULL, NULL, 23791),
(23792, '3.30.160.60-FF-002833', NULL, 'GL12085', 28, NULL, NULL, 23792),
(23793, '3.10.110.10-FF-000049', NULL, 'RBR-type E3 ubiquitin transferase', 140, NULL, NULL, 23793),
(23794, '3.10.330.10-FF-000032', NULL, 'Ubiquitin fusion degradation protein, putative', 83, NULL, NULL, 23794),
(23795, '3.40.630.10-FF-000508', NULL, 'Protein CBG24539', 134, NULL, NULL, 23795),
(23796, '3.90.79.10-FF-000119', NULL, 'Pre-mRNA cleavage factor I 25 kDa subunit, putative', 198, NULL, NULL, 23796),
(23797, '1.20.58.860-FF-000023', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 68, NULL, NULL, 23797),
(23798, '3.30.565.10-FF-000347', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One component system)', 166, NULL, NULL, 23798),
(23799, '2.30.42.10-FF-000023', NULL, 'Glutamate receptor interacting protein 1', 95, NULL, NULL, 23799),
(23800, '3.40.390.10-FF-000152', NULL, NULL, 58, NULL, NULL, 23800),
(23801, '2.40.10.10-FF-000365', NULL, NULL, 80, NULL, NULL, 23801),
(23802, '3.40.50.10240-FF-000007', NULL, 'Thiamine pyrophosphokinase', 208, NULL, NULL, 23802),
(23803, '2.130.10.10-FF-005003', NULL, 'Probable cytosolic iron-sulfur protein assembly protein 1', 61, NULL, NULL, 23803),
(23804, '1.20.1250.20-FF-001477', NULL, 'Uncharacterized protein', 389, NULL, NULL, 23804),
(23805, '1.25.40.10-FF-002427', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 100, NULL, NULL, 23805),
(23806, '3.40.50.150-FF-000506', NULL, 'tRNA (guanine-N(7)-)-methyltransferase', 202, NULL, NULL, 23806),
(23807, '3.40.525.10-FF-000056', NULL, 'Protein tyrosine phosphatase, non-receptor type 9', 254, NULL, NULL, 23807),
(23808, '3.10.20.90-FF-000725', NULL, 'Polyubiquitin 8', 78, NULL, NULL, 23808),
(23809, '2.60.40.60-FF-000583', NULL, 'FAT atypical cadherin 1b', 105, NULL, NULL, 23809),
(23810, '1.20.58.60-FF-000886', NULL, 'Dystrophin isoform Dp116', 95, NULL, NULL, 23810),
(23811, '1.20.1250.20-FF-001831', NULL, 'Uncharacterized protein', 144, NULL, NULL, 23811),
(23812, '1.10.30.50-FF-000022', NULL, 'Gll1669 protein', 76, NULL, NULL, 23812),
(23813, '3.40.50.300-FF-000984', NULL, 'Chromosome partition protein Smc', 199, NULL, NULL, 23813),
(23814, '4.10.410.20-FF-000003', NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase family member 1', 47, NULL, NULL, 23814),
(23815, '3.90.190.10-FF-000120', NULL, 'MAP kinase phosphatase, putative', 154, NULL, NULL, 23815),
(23816, '3.80.10.10-FF-001754', NULL, 'Putative disease resistance protein At3g14460', 164, NULL, NULL, 23816);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(23817, '2.60.40.150-FF-000583', NULL, 'Phosphoinositide phospholipase C', 102, NULL, NULL, 23817),
(23818, '1.20.1560.10-FF-000002', NULL, 'ABC transporter C family member 5', 336, NULL, NULL, 23818),
(23819, '1.10.340.30-FF-000063', NULL, '8-oxoguanine DNA glycosylase, putative', 179, NULL, NULL, 23819),
(23820, '1.10.260.40-FF-000008', NULL, 'Fructose repressor (Catabolite repressor/activator)', 61, NULL, NULL, 23820),
(23821, '3.30.530.20-FF-000208', NULL, 'Uncharacterized protein', 240, NULL, NULL, 23821),
(23822, '1.25.10.10-FF-000447', NULL, 'RIC8 guanine nucleotide exchange factor A', 383, NULL, NULL, 23822),
(23823, '2.160.10.10-FF-000090', NULL, '2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-acetyltransferase', 162, NULL, NULL, 23823),
(23824, '1.20.120.1750-FF-000088', NULL, 'RBR-type E3 ubiquitin transferase', 128, NULL, NULL, 23824),
(23825, '3.90.226.10-FF-000277', NULL, 'Enoyl-CoA hydratase/isomerase', 255, NULL, NULL, 23825),
(23826, '1.10.1140.10-FF-000018', NULL, 'V-type proton ATPase catalytic subunit A', 86, NULL, NULL, 23826),
(23827, '3.30.200.20-FF-002140', NULL, 'Uncharacterized protein', 70, NULL, NULL, 23827),
(23828, '2.60.40.1510-FF-000044', NULL, 'Integrin beta', 115, NULL, NULL, 23828),
(23829, '3.40.50.2000-FF-000004', NULL, 'Sucrose synthase', 290, NULL, NULL, 23829),
(23830, '2.40.50.40-FF-000090', NULL, 'Viral macrophage inflammatory protein 2', 71, NULL, NULL, 23830),
(23831, '3.50.30.30-FF-000167', NULL, 'Probable aminopeptidase', 137, NULL, NULL, 23831),
(23832, '2.60.60.20-FF-000010', NULL, 'hepatic triacylglycerol lipase', 132, NULL, NULL, 23832),
(23833, '2.40.50.40-FF-000033', NULL, 'C-C motif chemokine 1', 71, NULL, NULL, 23833),
(23834, '3.90.1150.10-FF-000044', NULL, 'Low-specificity L-threonine aldolase', 89, NULL, NULL, 23834),
(23835, '2.60.40.640-FF-000050', NULL, 'Vacuolar sorting protein 26, putative', 166, NULL, NULL, 23835),
(23836, '3.40.50.720-FF-002116', NULL, 'Uncharacterized protein', 115, NULL, NULL, 23836),
(23837, '3.30.70.60-FF-000022', NULL, 'Mitochondrial Ribosomal Protein, Small', 131, NULL, NULL, 23837),
(23838, '1.10.490.160-FF-000003', NULL, 'Ryanodine receptor, isoform E', 104, NULL, NULL, 23838),
(23839, '1.10.4160.10-FF-000020', NULL, 'Putative cytosine permease', 425, NULL, NULL, 23839),
(23840, '3.10.129.10-FF-000193', NULL, 'Chromosome 1, whole genome shotgun sequence', 155, NULL, NULL, 23840),
(23841, '1.10.357.10-FF-000062', NULL, 'TetR family transcriptional regulator', 156, NULL, NULL, 23841),
(23842, '3.80.10.10-FF-003553', NULL, 'Uncharacterized protein', 152, NULL, NULL, 23842),
(23843, '3.40.1280.10-FF-000020', NULL, 'Ribosomal RNA small subunit methyltransferase E', 245, NULL, NULL, 23843),
(23844, '3.50.50.60-FF-000126', NULL, '3-(3-hydroxy-phenyl)propionate/3-hydroxycinnamic acid hydroxylase', 251, NULL, NULL, 23844),
(23845, '3.40.50.300-FF-004727', NULL, 'ATPase, putative', 165, NULL, NULL, 23845),
(23846, '3.30.1370.10-FF-000124', NULL, 'Scp160p', 81, NULL, NULL, 23846),
(23847, '1.10.3080.10-FF-000047', NULL, 'Sll0855 protein', 425, NULL, NULL, 23847),
(23848, '3.40.50.300-FF-001030', NULL, 'Dynamin-related protein 5A', 367, NULL, NULL, 23848),
(23849, '2.30.42.10-FF-000641', NULL, NULL, 51, NULL, NULL, 23849),
(23850, '1.20.1250.20-FF-000049', NULL, 'Solute carrier family 15 member 2', 397, NULL, NULL, 23850),
(23851, '1.25.40.20-FF-000632', NULL, 'Acyl-CoA-binding domain-containing protein 2', 123, NULL, NULL, 23851),
(23852, '3.30.160.60-FF-001405', NULL, 'Zinc finger protein 398', 28, NULL, NULL, 23852),
(23853, '3.40.47.10-FF-000216', NULL, NULL, 148, NULL, NULL, 23853),
(23854, '3.40.50.1000-FF-000367', NULL, 'Haloacid dehalogenase family hydrolase domain containing protein', 162, NULL, NULL, 23854),
(23855, '1.10.60.10-FF-000006', NULL, 'DtxR family iron (Metal) dependent repressor', 58, NULL, NULL, 23855),
(23856, '1.10.560.10-FF-000034', NULL, 'T-complex protein 1 subunit gamma', 155, NULL, NULL, 23856),
(23857, '1.10.287.10-FF-000033', NULL, 'Prolyl Amino-acyl tRNA Synthetase', 56, NULL, NULL, 23857);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(23858, '1.10.10.10-FF-000475', NULL, 'HTH-type transcriptional regulator mcbR', 70, NULL, NULL, 23858),
(23859, '3.30.1640.10-FF-000073', NULL, 'DNA replication licensing factor MCM7', 98, NULL, NULL, 23859),
(23860, '1.10.10.1070-FF-000002', NULL, 'Hermes transposase', 73, NULL, NULL, 23860),
(23861, '1.10.1300.10-FF-000025', NULL, 'Phosphodiesterase', 347, NULL, NULL, 23861),
(23862, '2.130.10.10-FF-002485', NULL, 'VPS10 homolog 2', 208, NULL, NULL, 23862),
(23863, '3.50.50.60-FF-000183', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 114, NULL, NULL, 23863),
(23864, '2.120.10.80-FF-000241', NULL, 'tRNA wybutosine-synthesizing protein 4', 315, NULL, NULL, 23864),
(23865, '1.20.120.230-FF-000064', NULL, 'Vinculin', 43, NULL, NULL, 23865),
(23866, '2.170.120.12-FF-000024', NULL, 'RNA polymerase Rpb3/RpoA insert domain-containing protein', 121, NULL, NULL, 23866),
(23867, '3.90.45.10-FF-000002', NULL, 'Peptide deformylase', 188, NULL, NULL, 23867),
(23868, '2.40.30.10-FF-000074', NULL, '50S ribosomal protein L3', 77, NULL, NULL, 23868),
(23869, '1.10.287.1080-FF-000001', NULL, 'Nucleoside triphosphate pyrophosphohydrolase', 123, NULL, NULL, 23869),
(23870, '3.80.10.10-FF-004216', NULL, 'Uncharacterized protein', 86, NULL, NULL, 23870),
(23871, '3.40.50.1820-FF-001097', NULL, 'Uncharacterized protein', 91, NULL, NULL, 23871),
(23872, '3.30.200.20-FF-000341', NULL, 'MAP kinase kinase PBS2', 101, NULL, NULL, 23872),
(23873, '3.30.1140.32-FF-000020', NULL, '40S ribosomal protein S3-3, putative', 138, NULL, NULL, 23873),
(23874, '4.10.860.10-FF-000023', NULL, NULL, 58, NULL, NULL, 23874),
(23875, '1.25.10.10-FF-002802', NULL, 'Uncharacterized protein', 196, NULL, NULL, 23875),
(23876, '3.30.230.10-FF-000132', NULL, 'MeValonate Kinase', 134, NULL, NULL, 23876),
(23877, '2.60.40.1080-FF-000016', NULL, 'Peptidase, S8/S53 family', 81, NULL, NULL, 23877),
(23878, '2.60.120.290-FF-000240', NULL, 'Uncharacterized protein', 54, NULL, NULL, 23878),
(23879, '3.30.70.330-FF-000090', NULL, 'RNA-binding protein 39 isoform X1', 114, NULL, NULL, 23879),
(23880, '3.10.310.10-FF-000064', NULL, 'Uncharacterized protein', 173, NULL, NULL, 23880),
(23881, '1.25.40.10-FF-004075', NULL, 'Uncharacterized protein', 159, NULL, NULL, 23881),
(23882, '2.10.25.10-FF-001092', NULL, 'Stabilin 2', 44, NULL, NULL, 23882),
(23883, '2.170.140.10-FF-000039', NULL, 'Mucin related 89F, isoform C', 70, NULL, NULL, 23883),
(23884, '2.60.40.10-FF-000675', NULL, 'Hemicentin 1', 99, NULL, NULL, 23884),
(23885, '2.40.50.100-FF-000052', NULL, 'DNA-directed RNA polymerase subunit', 76, NULL, NULL, 23885),
(23886, '3.30.70.330-FF-001955', NULL, NULL, 106, NULL, NULL, 23886),
(23887, '1.20.5.220-FF-000005', NULL, 'cytochrome b-c1 complex subunit 10', 53, NULL, NULL, 23887),
(23888, '2.130.10.10-FF-001203', NULL, 'F-box/WD repeat-containing protein 1A', 85, NULL, NULL, 23888),
(23889, '1.10.510.10-FF-002655', NULL, NULL, 76, NULL, NULL, 23889),
(23890, '1.20.930.40-FF-000013', NULL, 'putative N-acetylated-alpha-linked acidic dipeptidase isoform X3', 64, NULL, NULL, 23890),
(23891, '2.130.10.10-FF-001260', NULL, 'UTP9p Nucleolar protein', 377, NULL, NULL, 23891),
(23892, '3.40.50.300-FF-003800', NULL, 'Guanine nucleotide-binding protein G(k) subunit alpha', 211, NULL, NULL, 23892),
(23893, '1.10.470.10-FF-000004', NULL, 'Variant surface glycoprotein (VSG), putative', 144, NULL, NULL, 23893),
(23894, '1.25.40.930-FF-000001', NULL, 'Spindle checkpoint complex subunit', 121, NULL, NULL, 23894),
(23895, '3.90.79.10-FF-000209', NULL, 'A/G-specific adenine glycosylase', 153, NULL, NULL, 23895),
(23896, '1.20.1000.10-FF-000028', NULL, NULL, 104, NULL, NULL, 23896),
(23897, '1.10.340.30-FF-000006', NULL, 'N-glycosylase/DNA lyase isoform X2', 126, NULL, NULL, 23897),
(23898, '3.40.50.300-FF-004520', NULL, 'ABC transporter, ATP-binding protein', 197, NULL, NULL, 23898),
(23899, '1.25.40.20-FF-000278', NULL, 'espin-like protein', 73, NULL, NULL, 23899),
(23900, '1.25.10.10-FF-001875', NULL, 'Uncharacterized protein', 118, NULL, NULL, 23900);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(23901, '2.120.10.30-FF-000333', NULL, 'Uncharacterized protein', 171, NULL, NULL, 23901),
(23902, '3.80.10.10-FF-003199', NULL, 'AT02038p', 227, NULL, NULL, 23902),
(23903, '3.10.20.90-FF-000635', NULL, 'Autophagy-related protein 8', 120, NULL, NULL, 23903),
(23904, '1.10.510.10-FF-001520', NULL, 'Tyrosine-protein kinase Wsck', 204, NULL, NULL, 23904),
(23905, '3.90.70.10-FF-000454', NULL, 'Uncharacterized protein', 57, NULL, NULL, 23905),
(23906, '2.130.10.30-FF-000080', NULL, 'E3 ubiquitin-protein ligase rpm-1', 173, NULL, NULL, 23906),
(23907, '3.50.7.10-FF-000007', NULL, '1-phosphatidylinositol 3-phosphate 5-kinase isoform X1', 169, NULL, NULL, 23907),
(23908, '3.40.50.1000-FF-000721', NULL, NULL, 93, NULL, NULL, 23908),
(23909, '2.40.50.140-FF-000423', NULL, 'rRNA biogenesis protein RRP5', 106, NULL, NULL, 23909),
(23910, '3.30.450.20-FF-000207', NULL, 'Protein kinase', 97, NULL, NULL, 23910),
(23911, '1.10.510.10-FF-002094', NULL, NULL, 79, NULL, NULL, 23911),
(23912, '3.40.630.30-FF-000666', NULL, 'Predicted protein', 150, NULL, NULL, 23912),
(23913, '3.30.70.2760-FF-000010', NULL, NULL, 119, NULL, NULL, 23913),
(23914, '2.30.170.40-FF-000010', NULL, '50S ribosomal protein L28', 88, NULL, NULL, 23914),
(23915, '3.60.10.10-FF-000103', NULL, 'Type I inositol-1,4,5-trisphosphate 5-phosphatase CVP2', 369, NULL, NULL, 23915),
(23916, '3.90.550.50-FF-000154', NULL, 'Fringe-related-like', 65, NULL, NULL, 23916),
(23917, '2.30.42.10-FF-000080', NULL, 'Syntrophin gamma 1', 93, NULL, NULL, 23917),
(23918, '3.40.50.10140-FF-000011', NULL, 'single Ig IL-1-related receptor isoform X1', 159, NULL, NULL, 23918),
(23919, '2.10.25.10-FF-001822', NULL, 'Uncharacterized protein', 30, NULL, NULL, 23919),
(23920, '3.40.50.300-FF-006673', NULL, 'ADP ribosylation factor-like GTPase 6', 84, NULL, NULL, 23920),
(23921, '1.25.40.20-FF-001205', NULL, 'Predicted protein', 185, NULL, NULL, 23921),
(23922, '1.10.472.10-FF-000492', NULL, 'Cyclin A3, putative', 110, NULL, NULL, 23922),
(23923, '3.40.390.10-FF-000242', NULL, NULL, 54, NULL, NULL, 23923),
(23924, '1.10.20.10-FF-000240', NULL, NULL, 106, NULL, NULL, 23924),
(23925, '3.30.160.60-FF-005093', NULL, NULL, 35, NULL, NULL, 23925),
(23926, '2.40.70.10-FF-000458', NULL, NULL, 113, NULL, NULL, 23926),
(23927, '3.30.160.60-FF-004278', NULL, NULL, 28, NULL, NULL, 23927),
(23928, '2.40.37.10-FF-000050', NULL, NULL, 137, NULL, NULL, 23928),
(23929, '1.10.510.10-FF-001166', NULL, 'Protein kinase', 187, NULL, NULL, 23929),
(23930, '1.10.533.10-FF-000067', NULL, 'NLR family pyrin domain containing 2', 102, NULL, NULL, 23930),
(23931, '3.30.200.20-FF-000902', NULL, 'Non-specific serine/threonine protein kinase', 59, NULL, NULL, 23931),
(23932, '3.90.550.10-FF-000603', NULL, 'Probable beta-1,4 N-acetylgalactosaminyltransferase', 220, NULL, NULL, 23932),
(23933, '2.20.25.210-FF-000002', NULL, 'Genome polyprotein', 61, NULL, NULL, 23933),
(23934, '2.60.40.150-FF-000526', NULL, 'Uncharacterized protein', 156, NULL, NULL, 23934),
(23935, '2.160.20.10-FF-000028', NULL, 'Polygalacturonase QRT2', 384, NULL, NULL, 23935),
(23936, '1.20.150.30-FF-000001', NULL, 'Hydrolase', 117, NULL, NULL, 23936),
(23937, '3.40.50.880-FF-000017', NULL, 'Type 1 glutamine amidotransferase', 172, NULL, NULL, 23937),
(23938, '2.60.40.10-FF-000528', NULL, 'Neural cell adhesion molecule 2', 94, NULL, NULL, 23938),
(23939, '3.40.140.10-FF-000134', NULL, 'Riboflavin biosynthesis protein RibD', 147, NULL, NULL, 23939),
(23940, '2.40.50.140-FF-000069', NULL, 'Polyribonucleotide nucleotidyltransferase', 73, NULL, NULL, 23940),
(23941, '3.90.960.10-FF-000005', NULL, 'Putative prolyl-tRNA synthetase', 168, NULL, NULL, 23941),
(23942, '3.30.160.60-FF-003968', NULL, NULL, 26, NULL, NULL, 23942),
(23943, '3.20.110.10-FF-000030', NULL, 'Predicted protein', 215, NULL, NULL, 23943),
(23944, '3.40.50.300-FF-008117', NULL, 'Uncharacterized protein', 274, NULL, NULL, 23944),
(23945, '2.170.150.10-FF-000012', NULL, 'Translationally-controlled tumor protein, putative', 170, NULL, NULL, 23945),
(23946, '3.40.50.150-FF-000299', NULL, 'S-adenosyl-L-methionine-dependent methyltransferases superfamily protein', 240, NULL, NULL, 23946);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(23947, '3.30.70.141-FF-000016', NULL, 'Nucleoside diphosphate kinase, putative', 144, NULL, NULL, 23947),
(23948, '1.25.40.10-FF-001202', NULL, 'Pentatricopeptide repeat-containing protein', 106, NULL, NULL, 23948),
(23949, '3.30.830.10-FF-000189', NULL, 'Uncharacterized protein', 245, NULL, NULL, 23949),
(23950, '3.30.465.10-FF-000137', NULL, 'Uncharacterized protein', 53, NULL, NULL, 23950),
(23951, '3.30.70.1350-FF-000014', NULL, 'Cation efflux system protein', 91, NULL, NULL, 23951),
(23952, '3.30.70.330-FF-002770', NULL, NULL, 76, NULL, NULL, 23952),
(23953, '3.40.50.880-FF-000107', NULL, 'DJ-1/PfpI family protein', 192, NULL, NULL, 23953),
(23954, '1.10.510.10-FF-003111', NULL, NULL, 192, NULL, NULL, 23954),
(23955, '1.20.1050.10-FF-000273', NULL, 'Uncharacterized protein', 115, NULL, NULL, 23955),
(23956, '2.60.220.50-FF-000123', NULL, 'Predicted protein', 35, NULL, NULL, 23956),
(23957, '1.10.510.10-FF-004393', NULL, NULL, 88, NULL, NULL, 23957),
(23958, '1.10.1200.240-FF-000001', NULL, 'Ribosomal protein L19', 134, NULL, NULL, 23958),
(23959, '1.10.1420.10-FF-000091', NULL, 'DNA mismatch repair protein', 129, NULL, NULL, 23959),
(23960, '1.10.10.820-FF-000028', NULL, 'Chitin synthase 8', 58, NULL, NULL, 23960),
(23961, '3.40.50.80-FF-000071', NULL, 'Cell surface metalloreductase (FreA), putative', 174, NULL, NULL, 23961),
(23962, '2.60.120.10-FF-000716', NULL, 'Predicted protein', 284, NULL, NULL, 23962),
(23963, '3.40.50.2300-FF-000830', NULL, NULL, 124, NULL, NULL, 23963),
(23964, '2.130.10.10-FF-002395', NULL, 'Vacuolar protein sorting-associated protein 41 homolog', 269, NULL, NULL, 23964),
(23965, '3.30.70.1990-FF-000003', NULL, 'Amine oxidase', 85, NULL, NULL, 23965),
(23966, '1.25.40.10-FF-002484', NULL, 'AGAP000136-PA', 122, NULL, NULL, 23966),
(23967, '2.30.30.40-FF-000583', NULL, 'Protein CBR-DLG-1', 25, NULL, NULL, 23967),
(23968, '3.30.1360.120-FF-000028', NULL, 'Putative transferase caf17, mitochondrial', 296, NULL, NULL, 23968),
(23969, '2.40.10.10-FF-000275', NULL, NULL, 108, NULL, NULL, 23969),
(23970, '1.10.600.10-FF-000122', NULL, 'Os02g0572050 protein', 110, NULL, NULL, 23970),
(23971, '3.40.605.10-FF-000057', NULL, 'Succinate-semialdehyde dehydrogenase mitochondrial', 146, NULL, NULL, 23971),
(23972, '3.40.50.1240-FF-000147', NULL, NULL, 189, NULL, NULL, 23972),
(23973, '1.20.120.2010-FF-000003', NULL, 'Uncharacterized protein', 86, NULL, NULL, 23973),
(23974, '3.80.20.20-FF-000095', NULL, 'Predicted protein', 73, NULL, NULL, 23974),
(23975, '2.170.150.20-FF-000015', NULL, 'Protein CBG06233', 125, NULL, NULL, 23975),
(23976, '2.60.40.10-FF-005441', NULL, NULL, 119, NULL, NULL, 23976),
(23977, '3.40.50.1820-FF-001714', NULL, 'Predicted protein', 142, NULL, NULL, 23977),
(23978, '3.40.449.10-FF-000019', NULL, 'Predicted protein', 65, NULL, NULL, 23978),
(23979, '1.10.1200.260-FF-000007', NULL, 'Uncharacterized protein', 41, NULL, NULL, 23979),
(23980, '2.130.10.10-FF-004340', NULL, 'WD-repeat protein, putative', 99, NULL, NULL, 23980),
(23981, '2.60.200.10-FF-000009', NULL, 'interferon regulatory factor 9 isoform X1', 173, NULL, NULL, 23981),
(23982, '3.30.70.330-FF-000561', NULL, 'RNA-binding protein 34 isoform X2', 122, NULL, NULL, 23982),
(23983, '1.25.40.10-FF-000275', NULL, 'pentatricopeptide repeat-containing protein 1, mitochondrial isoform X2', 82, NULL, NULL, 23983),
(23984, '1.25.40.10-FF-000359', NULL, 'Intraflagellar transport protein 88 homolog', 264, NULL, NULL, 23984),
(23985, '3.10.110.10-FF-000167', NULL, 'Ubiquitin-conjugating enzyme E2 D3', 46, NULL, NULL, 23985),
(23986, '1.20.1250.20-FF-000611', NULL, 'Siderochrome-iron transporter MirC', 190, NULL, NULL, 23986),
(23987, '3.90.310.10-FF-000001', NULL, 'Envelope glycoprotein', 226, NULL, NULL, 23987),
(23988, '2.70.130.10-FF-000046', NULL, NULL, 153, NULL, NULL, 23988),
(23989, '1.10.10.1410-FF-000003', NULL, '60S acidic ribosomal protein P1 isoform X2', 24, NULL, NULL, 23989),
(23990, '2.60.40.60-FF-000465', NULL, 'Dachsous cadherin-related 1a', 105, NULL, NULL, 23990),
(23991, '1.10.10.1420-FF-000006', NULL, 'Chromatin licensing and DNA replication factor 1', 137, NULL, NULL, 23991);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(23992, '1.20.140.150-FF-000083', NULL, 'uncharacterized protein LOC100184513', 175, NULL, NULL, 23992),
(23993, '2.60.40.60-FF-000521', NULL, 'Protocadherin 20', 111, NULL, NULL, 23993),
(23994, '2.130.10.10-FF-000568', NULL, 'Cilia-and flagella-associated protein 52', 181, NULL, NULL, 23994),
(23995, '3.90.550.10-FF-000693', NULL, 'Uncharacterized protein', 58, NULL, NULL, 23995),
(23996, '3.40.50.720-FF-001627', NULL, 'SUMO-activating enzyme subunit 1', 336, NULL, NULL, 23996),
(23997, '3.30.1510.10-FF-000012', NULL, 'Formate-tetrahydrofolate ligase', 110, NULL, NULL, 23997),
(23998, '2.130.10.10-FF-002715', NULL, 'Uncharacterized protein', 312, NULL, NULL, 23998),
(23999, '3.30.70.330-FF-001399', NULL, 'Poly(A) binding protein, cytoplasmic 1-like', 48, NULL, NULL, 23999),
(24000, '3.40.50.1370-FF-000045', NULL, NULL, 131, NULL, NULL, 24000),
(24001, '2.60.40.60-FF-000993', NULL, 'Protein CBR-CDH-12', 98, NULL, NULL, 24001),
(24002, '3.40.190.10-FF-000261', NULL, 'Sulfate ABC transporter substrate-binding lipoprotein SubI', 147, NULL, NULL, 24002),
(24003, '3.40.50.300-FF-006908', NULL, 'Uncharacterized protein', 237, NULL, NULL, 24003),
(24004, '1.25.10.10-FF-000857', NULL, 'RING-type E3 ubiquitin transferase', 236, NULL, NULL, 24004),
(24005, '3.90.550.10-FF-000165', NULL, 'Nonspecific UDP-sugar pyrophosphorylase', 442, NULL, NULL, 24005),
(24006, '1.25.40.10-FF-001938', NULL, 'Pentatricopeptide repeat-containing protein', 124, NULL, NULL, 24006),
(24007, '3.40.350.10-FF-000026', NULL, 'Fra1p', 158, NULL, NULL, 24007),
(24008, '3.30.565.10-FF-000465', NULL, 'Uncharacterized protein', 217, NULL, NULL, 24008),
(24009, '3.65.10.10-FF-000008', NULL, 'Pentafunctional AROM polypeptide', 202, NULL, NULL, 24009),
(24010, '3.30.70.330-FF-001455', NULL, 'Predicted protein', 119, NULL, NULL, 24010),
(24011, '1.20.1070.10-FF-001971', NULL, 'Uncharacterized protein', 178, NULL, NULL, 24011),
(24012, '3.40.140.10-FF-000257', NULL, 'Uncharacterized protein', 124, NULL, NULL, 24012),
(24013, '2.60.120.1190-FF-000010', NULL, 'Ddr-2', 172, NULL, NULL, 24013),
(24014, '1.25.10.10-FF-000329', NULL, 'Splicing factor 3b, subunit 1', 216, NULL, NULL, 24014),
(24015, '3.40.50.2000-FF-000420', NULL, 'GD25117', 169, NULL, NULL, 24015),
(24016, '3.30.230.130-FF-000049', NULL, 'Cullin', 187, NULL, NULL, 24016),
(24017, '3.30.200.20-FF-000223', NULL, 'Mitogen-activated protein kinase 6', 105, NULL, NULL, 24017),
(24018, '1.10.418.10-FF-000260', NULL, 'Uncharacterized protein', 66, NULL, NULL, 24018),
(24019, '3.40.50.2300-FF-001494', NULL, NULL, 119, NULL, NULL, 24019),
(24020, '2.60.40.1760-FF-000006', NULL, 'Alpha-glucosidase 1', 278, NULL, NULL, 24020),
(24021, '1.25.40.20-FF-000839', NULL, '60 kDa lysophospholipase', 96, NULL, NULL, 24021),
(24022, '1.20.1250.20-FF-001067', NULL, 'Major facilitator superfamily citrate-proton symporter', 188, NULL, NULL, 24022),
(24023, '2.130.10.10-FF-000624', NULL, 'DENN domain and WD repeat-containing protein SCD1', 221, NULL, NULL, 24023),
(24024, '3.30.230.10-FF-000250', NULL, 'Diphosphomevalonate decarboxylase', 53, NULL, NULL, 24024),
(24025, '3.30.160.20-FF-000022', NULL, '28S ribosomal protein S5, mitochondrial', 68, NULL, NULL, 24025),
(24026, '2.60.40.420-FF-000012', NULL, 'Monocopper oxidase-like protein', 193, NULL, NULL, 24026),
(24027, '1.10.20.10-FF-000094', NULL, 'CCAAT-binding transcription factor, putative', 142, NULL, NULL, 24027),
(24028, '1.20.1250.20-FF-001595', NULL, 'Solute carrier organic anion transporter, putative', 269, NULL, NULL, 24028),
(24029, '2.10.25.10-FF-000220', NULL, 'pikachurin isoform X3', 41, NULL, NULL, 24029),
(24030, '3.30.200.20-FF-000751', NULL, 'Receptor protein serine/threonine kinase', 118, NULL, NULL, 24030),
(24031, '2.30.29.30-FF-000886', NULL, 'Putative surface protein bspA-like', 108, NULL, NULL, 24031),
(24032, '3.20.130.10-FF-000003', NULL, 'Fumarate hydratase class I', 189, NULL, NULL, 24032),
(24033, '2.60.40.10-FF-000646', NULL, 'Myosin binding protein C, fast type', 106, NULL, NULL, 24033),
(24034, '3.90.1010.10-FF-000011', NULL, 'Nitrogen fixation protein NifU', 135, NULL, NULL, 24034);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(24035, '1.25.40.10-FF-004491', NULL, 'Uncharacterized Sel1-like repeat-containing protein C1B3.10c', 238, NULL, NULL, 24035),
(24036, '1.20.1070.10-FF-000510', NULL, 'Uncharacterized protein', 291, NULL, NULL, 24036),
(24037, '1.10.10.60-FF-000557', NULL, 'Unplaced genomic scaffold supercont2.9, whole genome shotgun sequence', 65, NULL, NULL, 24037),
(24038, '1.10.10.60-FF-000759', NULL, NULL, 54, NULL, NULL, 24038),
(24039, '3.30.830.10-FF-000251', NULL, 'Uncharacterized protein', 168, NULL, NULL, 24039),
(24040, '2.60.40.1120-FF-000079', NULL, 'Uncharacterized protein', 56, NULL, NULL, 24040),
(24041, '1.20.58.80-FF-000077', NULL, 'Uncharacterized protein', 45, NULL, NULL, 24041),
(24042, '3.40.50.1100-FF-000189', NULL, 'Pyridoxal-phosphate dependent enzyme', 98, NULL, NULL, 24042),
(24043, '3.60.15.10-FF-000007', NULL, 'Metallo-beta-lactamase NDM-1', 243, NULL, NULL, 24043),
(24044, '2.160.20.10-FF-000236', NULL, 'Polygalacturonase', 216, NULL, NULL, 24044),
(24045, '3.40.50.720-FF-000374', NULL, '3-oxoacyl-(Acyl-carrier-protein) reductase', 259, NULL, NULL, 24045),
(24046, '1.20.1080.10-FF-000005', NULL, 'Aquaporin 3', 251, NULL, NULL, 24046),
(24047, '3.40.50.1000-FF-000777', NULL, NULL, 83, NULL, NULL, 24047),
(24048, '1.20.1070.10-FF-000190', NULL, 'Vasopressin V2 receptor', 337, NULL, NULL, 24048),
(24049, '3.30.160.60-FF-004750', NULL, NULL, 63, NULL, NULL, 24049),
(24050, '3.90.79.10-FF-000058', NULL, 'NUDIX domain protein', 174, NULL, NULL, 24050),
(24051, '3.30.530.20-FF-000091', NULL, 'Uncharacterized protein', 223, NULL, NULL, 24051),
(24052, '3.30.160.60-FF-000888', NULL, 'zinc finger and BTB domain-containing protein 41', 27, NULL, NULL, 24052),
(24053, '3.40.50.2000-FF-000622', NULL, 'Sll1528 protein', 170, NULL, NULL, 24053),
(24054, '3.50.30.10-FF-000009', NULL, 'Pyruvate, phosphate dikinase, chloroplastic', 127, NULL, NULL, 24054),
(24055, '2.60.40.10-FF-002535', NULL, 'Protein CBG19196', 98, NULL, NULL, 24055),
(24056, '2.40.10.10-FF-000426', NULL, NULL, 232, NULL, NULL, 24056),
(24057, '1.10.10.10-FF-000059', NULL, 'ETS translocation variant 3', 108, NULL, NULL, 24057),
(24058, '3.30.540.10-FF-000060', NULL, 'Fructose-1,6-bisphosphatase', 96, NULL, NULL, 24058),
(24059, '3.10.180.10-FF-000115', NULL, 'Putative 4-hydroxyphenylpyruvic acid dioxygenase', 175, NULL, NULL, 24059),
(24060, '3.40.50.970-FF-000218', NULL, 'Uncharacterized protein', 71, NULL, NULL, 24060),
(24061, '1.10.8.270-FF-000056', NULL, 'Plasma membrane ATPase', 112, NULL, NULL, 24061),
(24062, '3.30.70.330-FF-001781', NULL, NULL, 132, NULL, NULL, 24062),
(24063, '3.40.50.800-FF-000100', NULL, 'ATP phosphoribosyltransferase regulatory subunit', 92, NULL, NULL, 24063),
(24064, '3.30.70.1170-FF-000027', NULL, 'tRNA (cytosine(48)-C(5))-methyltransferase', 67, NULL, NULL, 24064),
(24065, '3.40.190.10-FF-000940', NULL, 'Predicted protein', 30, NULL, NULL, 24065),
(24066, '3.80.10.10-FF-001159', NULL, 'Fish-lips, isoform C', 136, NULL, NULL, 24066),
(24067, '2.120.10.30-FF-000451', NULL, 'Uncharacterized protein', 101, NULL, NULL, 24067),
(24068, '3.40.50.300-FF-003238', NULL, '6-phosphofructo-2-kinase/fructose-2, 6-biphosphatase 4', 68, NULL, NULL, 24068),
(24069, '1.10.418.10-FF-000108', NULL, 'Fimbrin, putative', 129, NULL, NULL, 24069),
(24070, '1.10.3120.10-FF-000017', NULL, 'Trigger factor', 209, NULL, NULL, 24070),
(24071, '3.40.1710.10-FF-000003', NULL, 'ABC transporter permease', 122, NULL, NULL, 24071),
(24072, '1.10.238.10-FF-001302', NULL, 'Uncharacterized protein', 57, NULL, NULL, 24072),
(24073, '1.20.120.1750-FF-000116', NULL, 'Probable E3 ubiquitin-protein ligase ARI14', 144, NULL, NULL, 24073),
(24074, '2.60.120.730-FF-000001', NULL, 'Major capsid protein P2', 141, NULL, NULL, 24074),
(24075, '1.25.40.10-FF-002720', NULL, 'YALI0C02453p', 658, NULL, NULL, 24075),
(24076, '2.60.40.2130-FF-000016', NULL, 'HL01082p', 75, NULL, NULL, 24076),
(24077, '3.40.50.300-FF-006588', NULL, 'Uncharacterized protein', 99, NULL, NULL, 24077),
(24078, '2.30.30.40-FF-000049', NULL, 'Voltage-dependent L-type calcium channel subunit beta-3', 156, NULL, NULL, 24078);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(24079, '2.60.120.740-FF-000004', NULL, 'Protein eva-1 homolog C', 109, NULL, NULL, 24079),
(24080, '3.90.550.10-FF-000367', NULL, 'Uncharacterized protein', 223, NULL, NULL, 24080),
(24081, '3.40.50.2300-FF-000066', NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase SSU72', 120, NULL, NULL, 24081),
(24082, '1.20.1050.130-FF-000013', NULL, 'Elongation factor 1-beta (Ef-1-beta), putative', 64, NULL, NULL, 24082),
(24083, '1.10.510.10-FF-000295', NULL, 'Serine/threonine-protein kinase AGC1-7', 126, NULL, NULL, 24083),
(24084, '3.90.1150.10-FF-000167', NULL, 'Glycine cleavage system P protein', 69, NULL, NULL, 24084),
(24085, '2.60.40.10-FF-004626', NULL, NULL, 79, NULL, NULL, 24085),
(24086, '1.25.40.20-FF-001621', NULL, 'Uncharacterized protein', 99, NULL, NULL, 24086),
(24087, '3.10.110.10-FF-000021', NULL, 'Putative ubiquitin-conjugating enzyme e2 k', 157, NULL, NULL, 24087),
(24088, '3.40.50.300-FF-004992', NULL, 'Uncharacterized protein', 256, NULL, NULL, 24088),
(24089, '2.70.170.10-FF-000262', NULL, 'Predicted protein', 152, NULL, NULL, 24089),
(24090, '2.60.260.20-FF-000139', NULL, 'DnaJ-like protein', 79, NULL, NULL, 24090),
(24091, '2.160.10.10-FF-000027', NULL, 'Translation initiation factor eIF-2B subunit epsilon', 83, NULL, NULL, 24091),
(24092, '2.60.200.20-FF-000080', NULL, 'Adenylate cyclase', 93, NULL, NULL, 24092),
(24093, '3.30.200.20-FF-000425', NULL, 'Putative calcium/calmodulin-dependent protein kinase', 103, NULL, NULL, 24093),
(24094, '3.30.160.390-FF-000003', NULL, 'Putative integrase', 95, NULL, NULL, 24094),
(24095, '2.60.40.10-FF-005115', NULL, NULL, 98, NULL, NULL, 24095),
(24096, '2.40.30.10-FF-000309', NULL, 'Predicted dual oxidase-D', 96, NULL, NULL, 24096),
(24097, '3.30.40.10-FF-002236', NULL, 'Predicted protein', 64, NULL, NULL, 24097),
(24098, '3.30.420.140-FF-000022', NULL, 'Putative pre-16S rRNA nuclease', 136, NULL, NULL, 24098),
(24099, '1.25.40.90-FF-000080', NULL, 'YALI0C14476p', 136, NULL, NULL, 24099),
(24100, '3.40.50.1240-FF-000091', NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', 391, NULL, NULL, 24100),
(24101, '3.30.70.330-FF-000151', NULL, 'matrin-3 isoform X1', 99, NULL, NULL, 24101),
(24102, '1.25.40.20-FF-000688', NULL, 'Ankyrin-like protein', 172, NULL, NULL, 24102),
(24103, '3.30.160.60-FF-002333', NULL, 'Zinc finger protein 668', 30, NULL, NULL, 24103),
(24104, '2.130.10.10-FF-000950', NULL, 'Phospholipase A-2-activating protein', 157, NULL, NULL, 24104),
(24105, '3.30.420.150-FF-000025', NULL, 'Golgi apyrase', 254, NULL, NULL, 24105),
(24106, '1.10.510.10-FF-002386', NULL, NULL, 87, NULL, NULL, 24106),
(24107, '3.30.470.20-FF-000208', NULL, 'Uncharacterized protein', 194, NULL, NULL, 24107),
(24108, '1.20.1640.10-FF-000088', NULL, 'Hopanoid biosynthesis associated RND transporter like protein HpnN', 198, NULL, NULL, 24108),
(24109, '1.25.40.10-FF-002074', NULL, 'Uncharacterized protein', 320, NULL, NULL, 24109),
(24110, '3.90.70.10-FF-000690', NULL, 'Clan CA, family C1, cathepsin L-like cysteine peptidase', 232, NULL, NULL, 24110),
(24111, '2.130.10.10-FF-002513', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', 294, NULL, NULL, 24111),
(24112, '2.30.30.650-FF-000001', NULL, 'V-type ATP synthase alpha chain', 49, NULL, NULL, 24112),
(24113, '1.10.10.1970-FF-000002', NULL, NULL, 52, NULL, NULL, 24113),
(24114, '3.40.30.10-FF-000476', NULL, 'Pyrimidodiazepine synthase', 91, NULL, NULL, 24114),
(24115, '3.30.720.10-FF-000006', NULL, 'Signal recognition particle 14kD protein, putative', 138, NULL, NULL, 24115),
(24116, '3.90.950.10-FF-000004', NULL, 'dTTP/UTP pyrophosphatase', 189, NULL, NULL, 24116),
(24117, '1.25.40.10-FF-000685', NULL, 'Putative pentatricopeptide repeat-containing protein', 95, NULL, NULL, 24117),
(24118, '2.30.30.30-FF-000046', NULL, 'Putative 60S ribosomal protein L6', 86, NULL, NULL, 24118),
(24119, '3.40.1580.10-FF-000003', NULL, 'Putative spore coat protein', 131, NULL, NULL, 24119),
(24120, '3.80.10.10-FF-001962', NULL, 'Phytosulfokine receptor 1', 282, NULL, NULL, 24120);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(24121, '1.10.472.10-FF-000076', NULL, 'RNA polymerase II holoenzyme cyclin-like subunit', 127, NULL, NULL, 24121),
(24122, '1.25.10.10-FF-002572', NULL, 'Uncharacterized protein', 164, NULL, NULL, 24122),
(24123, '3.90.70.10-FF-000162', NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', 420, NULL, NULL, 24123),
(24124, '3.90.550.10-FF-000491', NULL, 'UDP-glucose glycoprotein glucosyltransferase 2', 146, NULL, NULL, 24124),
(24125, '1.20.120.330-FF-000032', NULL, 'Uncharacterized protein', 118, NULL, NULL, 24125),
(24126, '1.10.238.10-FF-000162', NULL, 'Defective in cullin neddylation protein', 91, NULL, NULL, 24126),
(24127, '2.30.38.10-FF-000007', NULL, 'Peptide synthetase mbtE', 79, NULL, NULL, 24127),
(24128, '1.10.760.10-FF-000015', NULL, 'Cbb3-type cytochrome c oxidase subunit', 99, NULL, NULL, 24128),
(24129, '3.30.40.10-FF-001747', NULL, 'Uncharacterized protein', 91, NULL, NULL, 24129),
(24130, '1.20.1250.20-FF-001915', NULL, 'Uncharacterized protein', 229, NULL, NULL, 24130),
(24131, '1.20.58.70-FF-000074', NULL, 'Tlg2p', 226, NULL, NULL, 24131),
(24132, '2.30.29.30-FF-000301', NULL, 'Neurobeachin-like protein 2', 95, NULL, NULL, 24132),
(24133, '3.40.120.10-FF-000043', NULL, 'Putative phosphoglucomutase', 158, NULL, NULL, 24133),
(24134, '1.20.1070.10-FF-001494', NULL, 'Uncharacterized protein', 200, NULL, NULL, 24134),
(24135, '2.10.70.10-FF-000229', NULL, 'Uncharacterized protein', 65, NULL, NULL, 24135),
(24136, '3.30.160.60-FF-006346', NULL, NULL, 23, NULL, NULL, 24136),
(24137, '3.40.50.300-FF-004817', NULL, 'Uncharacterized protein', 164, NULL, NULL, 24137),
(24138, '2.60.40.790-FF-000128', NULL, NULL, 108, NULL, NULL, 24138),
(24139, '2.60.120.260-FF-000102', NULL, 'Rhamnogalacturonate lyase A', 172, NULL, NULL, 24139),
(24140, '2.40.50.730-FF-000004', NULL, 'DNA polymerase', 66, NULL, NULL, 24140),
(24141, '3.50.50.60-FF-000036', NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', 241, NULL, NULL, 24141),
(24142, '3.30.70.100-FF-000189', NULL, NULL, 63, NULL, NULL, 24142),
(24143, '2.60.120.200-FF-000163', NULL, 'Lectin, putative', 230, NULL, NULL, 24143),
(24144, '3.10.310.20-FF-000005', NULL, 'Manganese-dependent inorganic pyrophosphatase', 117, NULL, NULL, 24144),
(24145, '2.60.120.10-FF-000598', NULL, 'Uncharacterized protein', 88, NULL, NULL, 24145),
(24146, '3.30.70.660-FF-000042', NULL, 'tRNA pseudouridine synthase A', 137, NULL, NULL, 24146),
(24147, '1.20.1540.10-FF-000029', NULL, 'Rhomboid protease 2', 188, NULL, NULL, 24147),
(24148, '2.40.50.740-FF-000007', NULL, '30S ribosomal protein S4e', 53, NULL, NULL, 24148),
(24149, '3.40.47.10-FF-000306', NULL, 'Probable polyketide synthase 37', 488, NULL, NULL, 24149),
(24150, '3.20.20.60-FF-000098', NULL, 'Pyruvate kinase', 121, NULL, NULL, 24150),
(24151, '1.10.472.130-FF-000065', NULL, 'Dynein heavy chain 2', 160, NULL, NULL, 24151),
(24152, '3.90.226.10-FF-000159', NULL, 'Peroxisomal enoyl-coa hydratase, putative', 218, NULL, NULL, 24152),
(24153, '3.30.60.20-FF-000155', NULL, 'Uncharacterized protein', 57, NULL, NULL, 24153),
(24154, '1.20.58.830-FF-000008', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 170, NULL, NULL, 24154),
(24155, '3.80.10.10-FF-000501', NULL, 'GL19312', 112, NULL, NULL, 24155),
(24156, '3.10.28.10-FF-000039', NULL, 'Probable intron-encoded DNA endonuclease 1', 104, NULL, NULL, 24156),
(24157, '2.10.25.10-FF-000164', NULL, 'Attractin like 1', 37, NULL, NULL, 24157),
(24158, '3.10.20.90-FF-000961', NULL, 'Uncharacterized protein', 47, NULL, NULL, 24158),
(24159, '1.10.760.10-FF-000105', NULL, 'Uncharacterized protein', 144, NULL, NULL, 24159),
(24160, '3.30.519.10-FF-000050', NULL, NULL, 31, NULL, NULL, 24160),
(24161, '3.30.200.20-FF-002050', NULL, 'Serine/threonine-protein kinase srb10', 88, NULL, NULL, 24161),
(24162, '3.30.430.20-FF-000032', NULL, 'Putative DUF26-domain protein kinase family protein', 97, NULL, NULL, 24162),
(24163, '2.60.120.830-FF-000003', NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 13', 146, NULL, NULL, 24163),
(24164, '3.30.420.40-FF-000599', NULL, 'Actin-related protein 6', 65, NULL, NULL, 24164);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(24165, '2.130.10.10-FF-001411', NULL, 'Protein SOF1, putative', 107, NULL, NULL, 24165),
(24166, '3.40.50.300-FF-001440', NULL, 'ATPase, AAA family protein', 184, NULL, NULL, 24166),
(24167, '2.60.40.10-FF-005025', NULL, NULL, 104, NULL, NULL, 24167),
(24168, '3.30.60.30-FF-000158', NULL, 'Follistatin', 73, NULL, NULL, 24168),
(24169, '3.90.1310.10-FF-000023', NULL, 'Penicillin-binding protein 2X', 117, NULL, NULL, 24169),
(24170, '1.10.3720.10-FF-000046', NULL, 'Oligopeptide ABC transporter, permease', 207, NULL, NULL, 24170),
(24171, '1.10.287.1040-FF-000006', NULL, 'Exodeoxyribonuclease 7 small subunit', 75, NULL, NULL, 24171),
(24172, '1.10.630.10-FF-000040', NULL, 'Bifunctional cytochrome P450/NADPH--P450 reductase', 462, NULL, NULL, 24172),
(24173, '3.90.70.10-FF-000538', NULL, 'Ubiquitinyl hydrolase 1', 282, NULL, NULL, 24173),
(24174, '2.70.150.10-FF-000227', NULL, 'Uncharacterized protein', 30, NULL, NULL, 24174),
(24175, '3.40.570.10-FF-000014', NULL, 'Endonuclease G', 254, NULL, NULL, 24175),
(24176, '3.50.50.60-FF-000626', NULL, 'Glutathione reductase', 223, NULL, NULL, 24176),
(24177, '3.10.310.10-FF-000002', NULL, 'Diaminopimelate epimerase', 147, NULL, NULL, 24177),
(24178, '3.90.20.20-FF-000015', NULL, 'GrpE protein homolog', 107, NULL, NULL, 24178),
(24179, '3.80.10.10-FF-000181', NULL, 'amphoterin-induced protein 1 isoform X1', 253, NULL, NULL, 24179),
(24180, '3.30.70.1230-FF-000186', NULL, 'Mitogen-activated protein kinase-like protein', 163, NULL, NULL, 24180),
(24181, '2.60.120.650-FF-000073', NULL, 'Cupin_superfamily_protein/Cupin-like_domain_containing_protein_-_putative', 255, NULL, NULL, 24181),
(24182, '3.40.50.1780-FF-000022', NULL, 'Hydrogenase', 132, NULL, NULL, 24182),
(24183, '1.20.1310.10-FF-000046', NULL, 'CDC53p Cullin', 125, NULL, NULL, 24183),
(24184, '2.30.30.30-FF-000136', NULL, 'Transcription elongation factor SPT5', 56, NULL, NULL, 24184),
(24185, '2.30.30.40-FF-000139', NULL, 'Hematopoietic cell-specific Lyn substrate 1', 59, NULL, NULL, 24185),
(24186, '3.30.870.10-FF-000192', NULL, 'Uncharacterized protein', 80, NULL, NULL, 24186),
(24187, '3.30.260.10-FF-000049', NULL, 'T-complex protein 1 subunit eta', 68, NULL, NULL, 24187),
(24188, '2.60.200.20-FF-000282', NULL, 'Uncharacterized protein', 161, NULL, NULL, 24188),
(24189, '3.30.160.60-FF-000388', NULL, 'zinc finger protein 567', 26, NULL, NULL, 24189),
(24190, '3.30.40.10-FF-001837', NULL, 'Ubiquitinyl hydrolase 1', 87, NULL, NULL, 24190),
(24191, '2.40.110.10-FF-000052', NULL, 'Acyl-coenzyme A oxidase', 125, NULL, NULL, 24191),
(24192, '3.90.550.10-FF-000339', NULL, 'Molybdenum cofactor guanylyltransferase', 190, NULL, NULL, 24192),
(24193, '3.30.800.10-FF-000007', NULL, 'Putative 1-phosphatidylinositol-4-phosphate 5-kinase/ zinc ion binding family', 164, NULL, NULL, 24193),
(24194, '3.30.70.330-FF-002091', NULL, NULL, 57, NULL, NULL, 24194),
(24195, '3.30.460.80-FF-000001', NULL, 'NADH-quinone oxidoreductase subunit C/D', 152, NULL, NULL, 24195),
(24196, '1.10.8.270-FF-000051', NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', 108, NULL, NULL, 24196),
(24197, '2.30.30.40-FF-000375', NULL, 'Putative purine-binding chemotaxis protein Chew', 53, NULL, NULL, 24197),
(24198, '3.40.50.620-FF-000018', NULL, 'Methionyl-tRNA synthetase, cytoplasmic', 347, NULL, NULL, 24198),
(24199, '2.40.50.140-FF-000631', NULL, 'KARS isoform 7', 61, NULL, NULL, 24199),
(24200, '3.30.70.330-FF-001871', NULL, NULL, 102, NULL, NULL, 24200),
(24201, '1.25.40.10-FF-002630', NULL, 'Pentatricopeptide repeat-containing protein At4g31850, chloroplastic', 160, NULL, NULL, 24201),
(24202, '2.40.50.100-FF-000136', NULL, 'RND family efflux transporter, MFP subunit', 69, NULL, NULL, 24202),
(24203, '3.30.420.40-FF-000268', NULL, 'Rhamnulokinase', 246, NULL, NULL, 24203),
(24204, '1.20.5.620-FF-000002', NULL, 'ATP synthase subunit b', 61, NULL, NULL, 24204),
(24205, '3.80.10.10-FF-001283', NULL, 'Lysine (K)-specific demethylase 2B', 122, NULL, NULL, 24205),
(24206, '1.25.40.10-FF-000303', NULL, 'Probable UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SEC', 370, NULL, NULL, 24206);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(24207, '1.10.510.10-FF-004128', NULL, NULL, 93, NULL, NULL, 24207),
(24208, '2.40.10.10-FF-000421', NULL, NULL, 239, NULL, NULL, 24208),
(24209, '3.40.1190.20-FF-000021', NULL, 'Fructokinase-like 2, chloroplastic', 351, NULL, NULL, 24209),
(24210, '3.30.1150.10-FF-000018', NULL, NULL, 92, NULL, NULL, 24210),
(24211, '3.30.420.40-FF-000453', NULL, 'Actin, putative', 111, NULL, NULL, 24211),
(24212, '1.25.40.20-FF-000778', NULL, 'Ankyrin repeat domain 2 (stretch responsive muscle)', 86, NULL, NULL, 24212),
(24213, '3.90.25.10-FF-000001', NULL, 'UDP-glucose 4-epimerase GalE', 110, NULL, NULL, 24213),
(24214, '3.40.50.620-FF-000260', NULL, 'Ethanolamine-phosphate cytidylyltransferase', 150, NULL, NULL, 24214),
(24215, '3.30.300.320-FF-000004', NULL, 'Uncharacterized protein', 216, NULL, NULL, 24215),
(24216, '1.25.40.10-FF-000831', NULL, 'PPR repeat family, putative', 192, NULL, NULL, 24216),
(24217, '3.80.10.10-FF-003699', NULL, 'Uncharacterized protein', 170, NULL, NULL, 24217),
(24218, '1.10.510.10-FF-000385', NULL, 'serine/threonine-protein kinase Aurora-1', 176, NULL, NULL, 24218),
(24219, '1.20.120.1200-FF-000002', NULL, 'NAD(P)H-quinone oxidoreductase subunit 6, chloroplastic', 167, NULL, NULL, 24219),
(24220, '2.130.10.10-FF-002193', NULL, 'Neutral sphingomyelinase activation-associated factor', 160, NULL, NULL, 24220),
(24221, '1.25.10.10-FF-002156', NULL, 'Uncharacterized protein', 521, NULL, NULL, 24221),
(24222, '3.30.460.90-FF-000004', NULL, 'Mitochondrial elongation factor 2', 193, NULL, NULL, 24222),
(24223, '3.80.10.10-FF-001631', NULL, 'Uncharacterized protein', 357, NULL, NULL, 24223),
(24224, '3.40.50.880-FF-000141', NULL, 'Chromosome 9, whole genome shotgun sequence', 94, NULL, NULL, 24224),
(24225, '1.10.10.10-FF-000149', NULL, 'Multiple antibiotic resistance transcriptional regulator MarR', 138, NULL, NULL, 24225),
(24226, '3.40.50.10190-FF-000301', NULL, 'DNA ligase', 106, NULL, NULL, 24226),
(24227, '1.20.1310.20-FF-000049', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 207, NULL, NULL, 24227),
(24228, '3.30.710.10-FF-000360', NULL, 'Uncharacterized protein', 107, NULL, NULL, 24228),
(24229, '3.30.420.40-FF-000801', NULL, 'Actin-Related Proteins', 69, NULL, NULL, 24229),
(24230, '3.30.1010.10-FF-000042', NULL, 'PhosphoInositide Four Kinase (PI-4 Kinase)', 153, NULL, NULL, 24230),
(24231, '1.10.150.240-FF-000125', NULL, 'Phosphoglycolate phosphatase', 64, NULL, NULL, 24231),
(24232, '3.60.21.10-FF-000393', NULL, 'Serine/threonine-protein phosphatase', 336, NULL, NULL, 24232),
(24233, '2.30.29.30-FF-001375', NULL, 'Phosphoinositide phospholipase C', 124, NULL, NULL, 24233),
(24234, '3.30.160.60-FF-002187', NULL, 'RE1-silencing transcription factor', 31, NULL, NULL, 24234),
(24235, '1.20.58.810-FF-000002', NULL, 'Photosystem II D1 processing protein PSB27-H2, chloroplastic', 109, NULL, NULL, 24235),
(24236, '2.60.120.260-FF-000225', NULL, 'Laminin subunit beta-1', 136, NULL, NULL, 24236),
(24237, '2.60.40.150-FF-000734', NULL, 'Uncharacterized protein', 112, NULL, NULL, 24237),
(24238, '1.25.10.10-FF-002482', NULL, 'Sister chromatid cohesion protein pds5', 211, NULL, NULL, 24238),
(24239, '3.40.50.300-FF-002991', NULL, 'Helicase, putative', 222, NULL, NULL, 24239),
(24240, '1.20.5.340-FF-000098', NULL, 'rho-associated protein kinase 2 isoform X3', 154, NULL, NULL, 24240),
(24241, '1.25.10.10-FF-002774', NULL, 'Uncharacterized protein', 585, NULL, NULL, 24241),
(24242, '2.60.40.10-FF-003024', NULL, 'Beta-Mannosidase, isoform H', 111, NULL, NULL, 24242),
(24243, '3.90.70.10-FF-000717', NULL, 'Uncharacterized protein', 196, NULL, NULL, 24243),
(24244, '3.40.630.10-FF-000273', NULL, 'Carboxypeptidase SOL1', 213, NULL, NULL, 24244),
(24245, '2.30.30.140-FF-000112', NULL, 'SAGA-associated factor 29', 61, NULL, NULL, 24245),
(24246, '1.25.40.20-FF-000834', NULL, 'Kinase, NEK', 116, NULL, NULL, 24246),
(24247, '1.10.238.10-FF-000813', NULL, 'Uncharacterized protein', 91, NULL, NULL, 24247),
(24248, '2.60.120.260-FF-000046', NULL, 'Cullin 9', 144, NULL, NULL, 24248),
(24249, '3.80.10.10-FF-003755', NULL, 'Protein CBG20033', 122, NULL, NULL, 24249);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(24250, '3.40.50.720-FF-000520', NULL, 'NAD(P)(+) transhydrogenase (AB-specific), alpha subunit', 162, NULL, NULL, 24250),
(24251, '1.10.1070.11-FF-000143', NULL, 'Uncharacterized protein', 62, NULL, NULL, 24251),
(24252, '3.40.50.80-FF-000037', NULL, 'Metalloreductase, putative', 165, NULL, NULL, 24252),
(24253, '1.10.418.10-FF-000232', NULL, 'Microtubule-actin crosslinking factor 1', 89, NULL, NULL, 24253),
(24254, '2.40.50.140-FF-000013', NULL, '30S ribosomal protein S1', 82, NULL, NULL, 24254),
(24255, '2.10.25.10-FF-001529', NULL, 'Uncharacterized protein', 68, NULL, NULL, 24255),
(24256, '1.25.40.10-FF-001000', NULL, 'ER membrane protein complex subunit 2-A', 152, NULL, NULL, 24256),
(24257, '2.10.25.10-FF-001619', NULL, 'Integrin beta', 52, NULL, NULL, 24257),
(24258, '1.25.40.20-FF-001003', NULL, 'AT4g05040 protein', 101, NULL, NULL, 24258),
(24259, '3.40.50.2300-FF-000622', NULL, 'Guanylate cyclase', 151, NULL, NULL, 24259),
(24260, '2.60.40.10-FF-001282', NULL, 'carcinoembryonic antigen-related cell adhesion molecule 16', 109, NULL, NULL, 24260),
(24261, '3.90.70.10-FF-000864', NULL, 'Uncharacterized protein', 82, NULL, NULL, 24261),
(24262, '2.30.130.40-FF-000007', NULL, 'Lon protease homolog, mitochondrial', 129, NULL, NULL, 24262),
(24263, '3.40.630.30-FF-000464', NULL, 'N-acetyltransferase 9-like protein', 168, NULL, NULL, 24263),
(24264, '3.30.40.10-FF-000443', NULL, 'PHD finger protein 7 isoform 1', 83, NULL, NULL, 24264),
(24265, '1.25.40.10-FF-000775', NULL, 'Tetratricopeptide repeat domain 21A', 232, NULL, NULL, 24265),
(24266, '3.40.640.10-FF-000245', NULL, 'Kynureninase', 255, NULL, NULL, 24266),
(24267, '2.60.40.10-FF-002709', NULL, 'Predicted protein', 97, NULL, NULL, 24267),
(24268, '3.40.718.10-FF-000015', NULL, 'Phosphate butyryltransferase', 298, NULL, NULL, 24268),
(24269, '3.40.50.1820-FF-000551', NULL, 'Epoxide hydrolase EphA', 321, NULL, NULL, 24269),
(24270, '1.10.10.1420-FF-000001', NULL, 'Chromatin licensing and DNA replication factor 1', 138, NULL, NULL, 24270),
(24271, '3.10.100.10-FF-000407', NULL, NULL, 109, NULL, NULL, 24271),
(24272, '3.30.63.10-FF-000007', NULL, 'Membrane-associated guanylate kinase, WW and PDZ domain-containing 2', 53, NULL, NULL, 24272),
(24273, '1.10.1820.10-FF-000019', NULL, 'Casein kinase II subunit beta', 101, NULL, NULL, 24273),
(24274, '3.40.50.11660-FF-000040', NULL, NULL, 157, NULL, NULL, 24274),
(24275, '3.40.228.10-FF-000017', NULL, 'Acetylene hydratase', 201, NULL, NULL, 24275),
(24276, '3.30.70.330-FF-000527', NULL, 'RNA-binding protein', 118, NULL, NULL, 24276),
(24277, '1.10.10.60-FF-000383', NULL, 'box A-binding factor', 68, NULL, NULL, 24277),
(24278, '3.10.20.90-FF-000433', NULL, 'Autophagy-related protein', 129, NULL, NULL, 24278),
(24279, '3.40.50.300-FF-002749', NULL, 'Metal ABC transporter ATP-binding protein', 238, NULL, NULL, 24279),
(24280, '3.40.50.300-FF-005155', NULL, 'ABC-type transport system ATP-binding protein', 229, NULL, NULL, 24280),
(24281, '3.10.20.30-FF-000078', NULL, NULL, 91, NULL, NULL, 24281),
(24282, '1.20.5.340-FF-000070', NULL, 'CBN-UNC-54 protein', 123, NULL, NULL, 24282),
(24283, '2.130.10.10-FF-000394', NULL, 'Peptidylprolyl isomerase domain and WD repeat-containing protein 1', 168, NULL, NULL, 24283),
(24284, '3.40.50.20-FF-000042', NULL, 'RimK-related lysine biosynthesis protein', 104, NULL, NULL, 24284),
(24285, '3.40.50.1260-FF-000012', NULL, 'Phosphoglycerate kinase', 199, NULL, NULL, 24285),
(24286, '2.40.70.10-FF-000402', NULL, NULL, 76, NULL, NULL, 24286),
(24287, '1.25.40.10-FF-000157', NULL, 'protein TSS isoform X2', 132, NULL, NULL, 24287),
(24288, '1.20.1270.370-FF-000005', NULL, '3-hydroxyacyl-ACP dehydratase', 80, NULL, NULL, 24288),
(24289, '3.40.630.10-FF-000306', NULL, 'Uncharacterized protein', 296, NULL, NULL, 24289),
(24290, '2.170.270.10-FF-000167', NULL, 'Nuclear receptor binding SET domain protein 1b', 119, NULL, NULL, 24290),
(24291, '3.40.50.300-FF-006644', NULL, 'Uncharacterized protein', 89, NULL, NULL, 24291),
(24292, '3.30.1010.10-FF-000132', NULL, 'Uncharacterized protein', 161, NULL, NULL, 24292);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(24293, '2.130.10.10-FF-002805', NULL, 'Polycomb protein eed-A', 173, NULL, NULL, 24293),
(24294, '3.40.640.10-FF-000099', NULL, 'LL-diaminopimelate aminotransferase, chloroplastic', 256, NULL, NULL, 24294),
(24295, '3.40.50.300-FF-007280', NULL, 'Uncharacterized protein', 154, NULL, NULL, 24295),
(24296, '2.10.25.10-FF-000310', NULL, 'Delta-like protein', 37, NULL, NULL, 24296),
(24297, '3.30.710.10-FF-000034', NULL, 'RCC1 and BTB domain-containing protein 1 isoform X2', 152, NULL, NULL, 24297),
(24298, '3.20.20.300-FF-000011', NULL, 'Glycosyl hydrolase', 358, NULL, NULL, 24298),
(24299, '3.30.420.10-FF-000579', NULL, NULL, 221, NULL, NULL, 24299),
(24300, '2.40.30.10-FF-000282', NULL, 'Dual oxidase 2', 100, NULL, NULL, 24300),
(24301, '3.40.50.300-FF-001445', NULL, 'Chromatin-remodeling ATPase INO80', 98, NULL, NULL, 24301),
(24302, '3.40.50.300-FF-007100', NULL, 'Gluconokinase', 188, NULL, NULL, 24302),
(24303, '3.40.50.720-FF-002291', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 194, NULL, NULL, 24303),
(24304, '1.10.510.10-FF-001402', NULL, 'Mammalian ZAK kinase homolog', 233, NULL, NULL, 24304),
(24305, '1.20.1250.20-FF-001623', NULL, 'Uncharacterized protein', 132, NULL, NULL, 24305),
(24306, '3.90.1290.10-FF-000054', NULL, 'Uncharacterized protein', 167, NULL, NULL, 24306),
(24307, '3.40.390.10-FF-000118', NULL, 'Metalloendopeptidase', 244, NULL, NULL, 24307),
(24308, '3.40.1280.10-FF-000109', NULL, 'Uncharacterized protein', 110, NULL, NULL, 24308),
(24309, '3.40.50.11260-FF-000010', NULL, 'Endoplasmin, putative', 88, NULL, NULL, 24309),
(24310, '1.20.140.40-FF-000065', NULL, NULL, 150, NULL, NULL, 24310),
(24311, '1.20.910.10-FF-000031', NULL, 'Uncharacterized protein', 226, NULL, NULL, 24311),
(24312, '1.10.10.440-FF-000038', NULL, 'Uncharacterized protein, isoform B', 78, NULL, NULL, 24312),
(24313, '3.40.50.620-FF-000170', NULL, '7-cyano-7-deazaguanine synthase', 218, NULL, NULL, 24313),
(24314, '3.40.50.300-FF-002373', NULL, 'Vesicle-fusing ATPase, putative', 164, NULL, NULL, 24314),
(24315, '3.80.10.10-FF-003429', NULL, 'Uncharacterized protein', 68, NULL, NULL, 24315),
(24316, '2.80.10.50-FF-000178', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 121, NULL, NULL, 24316),
(24317, '3.10.490.10-FF-000048', NULL, 'Glr1397 protein', 135, NULL, NULL, 24317),
(24318, '3.30.420.40-FF-000655', NULL, 'Actin-related protein 4', 165, NULL, NULL, 24318),
(24319, '2.130.10.10-FF-001698', NULL, 'Small nucleolar ribonucleoprotein complex subunit, putative', 49, NULL, NULL, 24319),
(24320, '3.40.1050.10-FF-000036', NULL, 'Carbonic anhydrase', 69, NULL, NULL, 24320),
(24321, '3.40.50.10810-FF-000049', NULL, 'DNA helicase', 264, NULL, NULL, 24321),
(24322, '1.25.40.10-FF-004428', NULL, 'Uncharacterized protein', 123, NULL, NULL, 24322),
(24323, '1.10.287.70-FF-000500', NULL, 'Uncharacterized protein', 180, NULL, NULL, 24323),
(24324, '2.40.50.140-FF-000541', NULL, 'Telomere-binding protein subunit alpha', 153, NULL, NULL, 24324),
(24325, '3.30.160.60-FF-000416', NULL, 'zinc finger protein 879 isoform X1', 30, NULL, NULL, 24325),
(24326, '3.30.470.30-FF-000037', NULL, 'DNA ligase', 124, NULL, NULL, 24326),
(24327, '1.25.40.10-FF-000505', NULL, 'Pentatricopeptide repeat-containing protein', 75, NULL, NULL, 24327),
(24328, '2.30.42.10-FF-000231', NULL, 'ZO-1 (Zonula Occludens tight junctional protein) Ortholog', 58, NULL, NULL, 24328),
(24329, '3.90.550.50-FF-000093', NULL, 'GD23187', 169, NULL, NULL, 24329),
(24330, '3.40.50.1220-FF-000023', NULL, 'Electron transfer flavoprotein, alpha subunit', 129, NULL, NULL, 24330),
(24331, '3.30.420.40-FF-000127', NULL, 'actin-related protein 4', 59, NULL, NULL, 24331),
(24332, '2.60.120.1310-FF-000001', NULL, 'Uncharacterized protein', 113, NULL, NULL, 24332),
(24333, '3.10.20.230-FF-000020', NULL, 'Apicortin, putative', 92, NULL, NULL, 24333),
(24334, '1.10.510.10-FF-003965', NULL, NULL, 348, NULL, NULL, 24334),
(24335, '1.10.8.60-FF-000101', NULL, 'ATP-dependent zinc metalloprotease FTSH 12, chloroplastic', 72, NULL, NULL, 24335),
(24336, '3.30.559.10-FF-000024', NULL, 'Carnitine acetyltransferase', 261, NULL, NULL, 24336); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(24337, '2.30.30.40-FF-000465', NULL, 'Uncharacterized protein', 88, NULL, NULL, 24337),
(24338, '2.120.10.30-FF-000395', NULL, 'Vitellogenin receptor', 256, NULL, NULL, 24338),
(24339, '3.30.465.10-FF-000019', NULL, 'UDP-N-acetylenolpyruvoylglucosamine reductase', 126, NULL, NULL, 24339),
(24340, '3.40.50.720-FF-001829', NULL, 'NRPS-like enzyme, putative (JCVI)', 382, NULL, NULL, 24340),
(24341, '1.25.40.20-FF-000508', NULL, 'Ankyrin repeat domain 28, isoform CRA_c', 48, NULL, NULL, 24341),
(24342, '3.40.50.1820-FF-001653', NULL, 'Triacylglycerol lipase', 341, NULL, NULL, 24342),
(24343, '1.20.1070.10-FF-001292', NULL, 'Uncharacterized protein', 150, NULL, NULL, 24343),
(24344, '3.90.226.10-FF-000305', NULL, 'Uncharacterized protein', 114, NULL, NULL, 24344),
(24345, '2.160.20.10-FF-000146', NULL, 'Cell surface glycoprotein (S-layer protein)', 321, NULL, NULL, 24345),
(24346, '3.40.630.40-FF-000028', NULL, 'Cell wall hydrolase/autolysin', 189, NULL, NULL, 24346),
(24347, '3.30.230.10-FF-000340', NULL, 'Uncharacterized protein', 49, NULL, NULL, 24347),
(24348, '1.50.40.10-FF-000239', NULL, 'Mitochondrial carrier protein, putative', 151, NULL, NULL, 24348),
(24349, '3.30.870.10-FF-000051', NULL, 'Probable tyrosyl-DNA phosphodiesterase', 203, NULL, NULL, 24349),
(24350, '1.10.510.10-FF-002863', NULL, NULL, 210, NULL, NULL, 24350),
(24351, '2.60.40.150-FF-000083', NULL, 'Copine 4', 123, NULL, NULL, 24351),
(24352, '3.30.200.20-FF-000841', NULL, 'Checkpoint kinase 2-like protein', 91, NULL, NULL, 24352),
(24353, '3.40.50.1000-FF-000249', NULL, 'Phosphomannomutase', 53, NULL, NULL, 24353),
(24354, '1.10.10.10-FF-000677', NULL, 'DDRGK domain containing 1', 32, NULL, NULL, 24354),
(24355, '1.20.58.60-FF-000245', NULL, 'Uncharacterized protein, isoform D', 306, NULL, NULL, 24355),
(24356, '3.90.226.10-FF-000215', NULL, 'Uncharacterized protein', 93, NULL, NULL, 24356),
(24357, '1.10.640.10-FF-000012', NULL, 'Blast:Peroxidasin homolog', 317, NULL, NULL, 24357),
(24358, '3.40.50.12780-FF-000218', NULL, 'Uncharacterized protein', 159, NULL, NULL, 24358),
(24359, '3.40.50.2300-FF-000061', NULL, 'Amino acid ABC transporter substrate-binding protein', 192, NULL, NULL, 24359),
(24360, '2.60.40.10-FF-002861', NULL, 'Sialoadhesin', 105, NULL, NULL, 24360),
(24361, '2.130.10.10-FF-004930', NULL, 'Uncharacterized protein', 105, NULL, NULL, 24361),
(24362, '1.10.287.130-FF-000024', NULL, 'Sensor histidine kinase/response regulator', 88, NULL, NULL, 24362),
(24363, '3.40.50.1000-FF-000159', NULL, 'TFIIF-stimulated CTD phosphatase', 160, NULL, NULL, 24363),
(24364, '3.40.50.11960-FF-000006', NULL, 'Increased recombination centers protein 6', 171, NULL, NULL, 24364),
(24365, '1.25.10.10-FF-002246', NULL, 'Uncharacterized protein', 374, NULL, NULL, 24365),
(24366, '3.40.50.10990-FF-000002', NULL, 'GTP cyclohydrolase-2', 174, NULL, NULL, 24366),
(24367, '2.10.50.30-FF-000032', NULL, 'Metabotropic glutamate receptor', 74, NULL, NULL, 24367),
(24368, '1.10.3430.10-FF-000029', NULL, 'Ammonium tramsporter, putative', 421, NULL, NULL, 24368),
(24369, '1.10.150.170-FF-000020', NULL, NULL, 117, NULL, NULL, 24369),
(24370, '2.130.10.10-FF-003204', NULL, 'Katanin p80 WD40 repeat-containing subunit B1', 88, NULL, NULL, 24370),
(24371, '3.40.50.1000-FF-000867', NULL, NULL, 21, NULL, NULL, 24371),
(24372, '3.40.50.11950-FF-000003', NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', 26, NULL, NULL, 24372),
(24373, '3.30.160.60-FF-002277', NULL, 'FLT3-interacting zinc finger 1', 76, NULL, NULL, 24373),
(24374, '3.30.470.20-FF-000124', NULL, 'Glutathione biosynthesis bifunctional protein GshAB', 143, NULL, NULL, 24374),
(24375, '3.90.550.50-FF-000183', NULL, 'Predicted protein', 227, NULL, NULL, 24375),
(24376, '3.40.50.300-FF-006734', NULL, 'Uncharacterized protein', 70, NULL, NULL, 24376),
(24377, '3.30.200.20-FF-000133', NULL, 'LOV domain-containing protein', 85, NULL, NULL, 24377),
(24378, '1.25.40.10-FF-004518', NULL, 'Uncharacterized protein', 81, NULL, NULL, 24378),
(24379, '3.30.40.10-FF-001545', NULL, 'TFIIE alpha subunit-domain-containing protein', 56, NULL, NULL, 24379);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(24380, '3.40.50.2300-FF-000712', NULL, 'Aliphatic amidase expression-regulating protein', 154, NULL, NULL, 24380),
(24381, '2.40.320.10-FF-000005', NULL, 'Thiamine-triphosphatase', 215, NULL, NULL, 24381),
(24382, '3.55.10.10-FF-000003', NULL, 'RNA helicase', 144, NULL, NULL, 24382),
(24383, '3.30.420.40-FF-000745', NULL, 'Actin, putative', 92, NULL, NULL, 24383),
(24384, '3.20.20.70-FF-000808', NULL, NULL, 114, NULL, NULL, 24384),
(24385, '4.10.640.10-FF-000012', NULL, '30S ribosomal protein S18', 71, NULL, NULL, 24385),
(24386, '2.30.42.10-FF-000141', NULL, 'Phosphatidylinositol-3,4,5-trisphosphate dependent Rac exchange factor 1', 76, NULL, NULL, 24386),
(24387, '3.40.50.1820-FF-000023', NULL, 'thymus-specific serine protease', 287, NULL, NULL, 24387),
(24388, '3.90.110.10-FF-000019', NULL, 'L-lactate dehydrogenase', 168, NULL, NULL, 24388),
(24389, '1.20.120.1760-FF-000029', NULL, 'CDP-alcohol phosphatidyltransferase protein', 193, NULL, NULL, 24389),
(24390, '2.60.40.10-FF-002389', NULL, 'Muscle M-line assembly protein unc-89', 94, NULL, NULL, 24390),
(24391, '3.90.1150.10-FF-000313', NULL, 'Uncharacterized aminotransferase C777.03c', 94, NULL, NULL, 24391),
(24392, '1.20.1530.20-FF-000088', NULL, 'Transporter, arsenite efflux pump ACR3 family', 312, NULL, NULL, 24392),
(24393, '3.40.50.300-FF-000097', NULL, 'Regulator of nonsense transcripts 1', 212, NULL, NULL, 24393),
(24394, '2.10.10.10-FF-000023', NULL, 'Uncharacterized protein', 57, NULL, NULL, 24394),
(24395, '1.20.1270.280-FF-000074', NULL, 'Dynein, axonemal, heavy chain 2', 91, NULL, NULL, 24395),
(24396, '2.70.70.10-FF-000041', NULL, 'Peptidase, M23/M37 family', 159, NULL, NULL, 24396),
(24397, '2.30.29.30-FF-000122', NULL, 'Actin filament associated protein 1', 127, NULL, NULL, 24397),
(24398, '1.10.287.110-FF-000159', NULL, 'Related to DnaJ protein', 87, NULL, NULL, 24398),
(24399, '3.10.100.10-FF-000380', NULL, NULL, 134, NULL, NULL, 24399),
(24400, '1.10.287.110-FF-000215', NULL, 'DnaJ domain protein', 125, NULL, NULL, 24400),
(24401, '2.60.40.10-FF-002445', NULL, NULL, 97, NULL, NULL, 24401),
(24402, '2.10.110.10-FF-000148', NULL, 'Protein CBR-ZYX-1', 71, NULL, NULL, 24402),
(24403, '3.40.1280.10-FF-000019', NULL, 'Putative tRNA/rRNA methyltransferase', 175, NULL, NULL, 24403),
(24404, '3.30.160.60-FF-004547', NULL, NULL, 73, NULL, NULL, 24404),
(24405, '3.30.450.40-FF-000129', NULL, 'Transcriptional regulator', 176, NULL, NULL, 24405),
(24406, '3.30.420.40-FF-000094', NULL, 'actin-like protein 7A', 109, NULL, NULL, 24406),
(24407, '1.20.120.1750-FF-000026', NULL, 'RANBP2-type and C3HC4-type zinc finger containing 1', 87, NULL, NULL, 24407),
(24408, '3.30.70.1390-FF-000003', NULL, 'Malignant fibrous histiocytoma-amplified sequence 1 homolog', 86, NULL, NULL, 24408),
(24409, '2.50.20.10-FF-000022', NULL, 'Sigma E factor regulatory protein RseB', 184, NULL, NULL, 24409),
(24410, '3.10.100.10-FF-000374', NULL, NULL, 140, NULL, NULL, 24410),
(24411, '2.40.70.10-FF-000256', NULL, NULL, 119, NULL, NULL, 24411),
(24412, '1.50.10.20-FF-000004', NULL, 'Geranylgeranyl transferase type-2 subunit beta', 330, NULL, NULL, 24412),
(24413, '2.10.25.10-FF-000512', NULL, 'Laminin subunit alpha 1', 58, NULL, NULL, 24413),
(24414, '1.25.10.10-FF-002807', NULL, 'Uncharacterized protein', 201, NULL, NULL, 24414),
(24415, '2.40.70.10-FF-000312', NULL, NULL, 179, NULL, NULL, 24415),
(24416, '3.40.366.10-FF-000012', NULL, 'Malonyl CoA-acyl carrier protein transacylase', 208, NULL, NULL, 24416),
(24417, '3.30.450.20-FF-000123', NULL, 'Dysfusion, isoform B', 162, NULL, NULL, 24417),
(24418, '1.25.40.530-FF-000027', NULL, NULL, 263, NULL, NULL, 24418),
(24419, '1.10.340.30-FF-000001', NULL, 'Endonuclease III', 112, NULL, NULL, 24419),
(24420, '1.50.10.10-FF-000001', NULL, 'probable alkaline/neutral invertase B', 404, NULL, NULL, 24420),
(24421, '2.60.40.60-FF-000813', NULL, 'Predicted protein', 106, NULL, NULL, 24421),
(24422, '4.10.60.10-FF-000151', NULL, 'RecQ helicase-like 4', 54, NULL, NULL, 24422),
(24423, '1.20.1070.10-FF-001640', NULL, 'Uncharacterized protein', 137, NULL, NULL, 24423);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(24424, '2.120.10.30-FF-000007', NULL, 'Putative tripartite motif-containing protein 2', 196, NULL, NULL, 24424),
(24425, '3.80.10.10-FF-000411', NULL, 'Leucine-rich repeat-containing protein 7', 110, NULL, NULL, 24425),
(24426, '3.60.15.10-FF-000187', NULL, 'Uncharacterized protein', 197, NULL, NULL, 24426),
(24427, '3.40.1370.10-FF-000049', NULL, 'Uncharacterized protein', 74, NULL, NULL, 24427),
(24428, '1.10.357.10-FF-000090', NULL, 'Putative transcriptional regulator', 133, NULL, NULL, 24428),
(24429, '2.30.30.40-FF-000611', NULL, 'Predicted protein', 55, NULL, NULL, 24429),
(24430, '3.10.129.10-FF-000131', NULL, 'YBL095W-like protein', 176, NULL, NULL, 24430),
(24431, '2.40.30.10-FF-000192', NULL, 'Sulfate adenylyltransferase subunit 1', 93, NULL, NULL, 24431),
(24432, '1.20.1510.10-FF-000084', NULL, NULL, 143, NULL, NULL, 24432),
(24433, '2.30.42.10-FF-000085', NULL, 'Phosphatidylinositol-3,4,5-trisphosphate dependent Rac exchange factor 2', 80, NULL, NULL, 24433),
(24434, '1.25.40.10-FF-003939', NULL, 'Uncharacterized protein', 277, NULL, NULL, 24434),
(24435, '2.130.10.10-FF-002367', NULL, 'DDB1-and CUL4-associated factor 11 homolog', 148, NULL, NULL, 24435),
(24436, '1.25.50.20-FF-000099', NULL, 'Predicted protein', 169, NULL, NULL, 24436),
(24437, '2.40.50.140-FF-000395', NULL, 'Replication protein A3', 114, NULL, NULL, 24437),
(24438, '2.40.100.10-FF-000079', NULL, 'Peptidyl-prolyl cis-trans isomerase', 171, NULL, NULL, 24438),
(24439, '1.20.1250.20-FF-000898', NULL, 'Proton-dependent oligopeptide transporter, POT family', 227, NULL, NULL, 24439),
(24440, '3.40.190.290-FF-000123', NULL, 'LysR family transcriptional regulator', 197, NULL, NULL, 24440),
(24441, '3.30.428.10-FF-000052', NULL, 'Histidine triad (HIT) protein', 134, NULL, NULL, 24441),
(24442, '3.40.50.880-FF-000197', NULL, 'Predicted protein', 135, NULL, NULL, 24442),
(24443, '3.90.980.20-FF-000009', NULL, 'Polycomblike, isoform B', 154, NULL, NULL, 24443),
(24444, '3.40.225.10-FF-000011', NULL, 'Uncharacterized protein, isoform B', 256, NULL, NULL, 24444),
(24445, '3.30.1120.160-FF-000003', NULL, 'GTPase-activating Rap/Ran-GAP domain-like protein 3', 96, NULL, NULL, 24445),
(24446, '3.30.300.20-FF-000079', NULL, 'Gtp-binding protein', 125, NULL, NULL, 24446),
(24447, '1.20.120.1750-FF-000083', NULL, 'RBR-type E3 ubiquitin transferase', 72, NULL, NULL, 24447),
(24448, '1.10.287.70-FF-000028', NULL, 'potassium voltage-gated channel subfamily D member 3', 110, NULL, NULL, 24448),
(24449, '3.30.70.370-FF-000022', NULL, 'DNA polymerase nu', 60, NULL, NULL, 24449),
(24450, '1.10.238.10-FF-000667', NULL, 'probable calcium-binding protein CML41', 70, NULL, NULL, 24450),
(24451, '1.10.287.70-FF-000793', NULL, 'Uncharacterized protein', 154, NULL, NULL, 24451),
(24452, '2.120.10.10-FF-000001', NULL, 'Neuraminidase', 397, NULL, NULL, 24452),
(24453, '3.40.190.290-FF-000067', NULL, 'LysR family transcriptional regulator', 211, NULL, NULL, 24453),
(24454, '1.10.260.50-FF-000006', NULL, NULL, 46, NULL, NULL, 24454),
(24455, '3.40.50.2000-FF-000274', NULL, 'Glycosyltransferase', 253, NULL, NULL, 24455),
(24456, '2.70.98.10-FF-000009', NULL, 'Putative aldose-1-epimerase', 287, NULL, NULL, 24456),
(24457, '1.20.120.1760-FF-000086', NULL, NULL, 108, NULL, NULL, 24457),
(24458, '3.90.980.10-FF-000006', NULL, 'DNA primase', 149, NULL, NULL, 24458),
(24459, '3.30.160.60-FF-000860', NULL, 'zinc finger protein SNAI2', 29, NULL, NULL, 24459),
(24460, '2.170.130.10-FF-000011', NULL, 'TonB-dependent siderophore receptor', 134, NULL, NULL, 24460),
(24461, '3.40.50.280-FF-000017', NULL, 'Corrinoid protein', 137, NULL, NULL, 24461),
(24462, '1.10.260.40-FF-000003', NULL, 'DNA-binding protein SATB', 79, NULL, NULL, 24462),
(24463, '2.60.40.630-FF-000018', NULL, 'Uncharacterized protein', 88, NULL, NULL, 24463),
(24464, '2.130.10.10-FF-000714', NULL, 'Transducin/WD40 repeat-like superfamily protein', 256, NULL, NULL, 24464),
(24465, '3.30.210.10-FF-000007', NULL, 'DNA polymerase', 101, NULL, NULL, 24465),
(24466, '3.30.200.20-FF-000515', NULL, 'Inactive serine/threonine-protein kinase', 101, NULL, NULL, 24466);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(24467, '1.25.10.10-FF-001026', NULL, 'GM17740', 283, NULL, NULL, 24467),
(24468, '3.30.2350.10-FF-000005', NULL, 'Pseudouridine synthase', 208, NULL, NULL, 24468),
(24469, '1.10.10.60-FF-000760', NULL, 'Mu phage middle operon regulator Mor', 56, NULL, NULL, 24469),
(24470, '1.10.420.10-FF-000029', NULL, 'Peroxidase', 141, NULL, NULL, 24470),
(24471, '2.30.29.30-FF-001049', NULL, 'Uncharacterized PH domain-containing protein C19A8.02', 115, NULL, NULL, 24471),
(24472, '3.90.260.10-FF-000064', NULL, 'Uncharacterized protein', 205, NULL, NULL, 24472),
(24473, '3.40.50.2000-FF-000330', NULL, 'UDP-N-acetylglucosamine transferase subunit ALG14, putative', 183, NULL, NULL, 24473),
(24474, '3.30.310.40-FF-000006', NULL, 'AER127Cp', 97, NULL, NULL, 24474),
(24475, '2.60.40.640-FF-000078', NULL, 'Uncharacterized protein', 149, NULL, NULL, 24475),
(24476, '2.40.10.10-FF-000191', NULL, 'GM21018', 247, NULL, NULL, 24476),
(24477, '1.25.40.10-FF-002158', NULL, 'Pentatricopeptide repeat-containing protein', 115, NULL, NULL, 24477),
(24478, '1.20.5.170-FF-000024', NULL, 'VHS domain-containing protein', 41, NULL, NULL, 24478),
(24479, '3.30.2350.20-FF-000008', NULL, 'tRNA pseudouridine synthase D', 154, NULL, NULL, 24479),
(24480, '2.60.40.10-FF-000259', NULL, 'Host cell factor 1 (Predicted)', 125, NULL, NULL, 24480),
(24481, '3.10.100.10-FF-000048', NULL, 'Multiplexin collagen isoform Ap3', 179, NULL, NULL, 24481),
(24482, '2.60.40.10-FF-000298', NULL, 'Nectin cell adhesion molecule 3', 94, NULL, NULL, 24482),
(24483, '1.50.40.10-FF-000565', NULL, 'Mitochondrial carrier protein-like protein', 108, NULL, NULL, 24483),
(24484, '3.30.310.50-FF-000009', NULL, 'Probable phosphoglucosamine mutase', 86, NULL, NULL, 24484),
(24485, '2.130.10.10-FF-000771', NULL, 'Elongator acetyltransferase complex subunit 2', 165, NULL, NULL, 24485),
(24486, '2.20.90.10-FF-000005', NULL, 'Vitellogenin 5', 69, NULL, NULL, 24486),
(24487, '2.130.10.10-FF-000478', NULL, 'WD repeat and HMG-box DNA binding protein 1', 119, NULL, NULL, 24487),
(24488, '2.20.70.10-FF-000004', NULL, 'dystrophin isoform X1', 38, NULL, NULL, 24488),
(24489, '2.30.30.380-FF-000038', NULL, 'Protein transport protein SEC23', 60, NULL, NULL, 24489),
(24490, '3.30.2350.20-FF-000065', NULL, NULL, 228, NULL, NULL, 24490),
(24491, '2.30.36.70-FF-000021', NULL, 'AGAP004488-PA', 40, NULL, NULL, 24491),
(24492, '2.170.270.10-FF-000223', NULL, 'Uncharacterized protein', 106, NULL, NULL, 24492),
(24493, '2.130.10.10-FF-005857', NULL, 'Probable Methylamine utilization protein mauG', 319, NULL, NULL, 24493),
(24494, '1.25.40.10-FF-000449', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 107, NULL, NULL, 24494),
(24495, '2.40.10.10-FF-000567', NULL, NULL, 67, NULL, NULL, 24495),
(24496, '1.20.1070.10-FF-001527', NULL, 'Uncharacterized protein', 187, NULL, NULL, 24496),
(24497, '2.60.40.3180-FF-000005', NULL, 'EBF transcription factor 2', 177, NULL, NULL, 24497),
(24498, '3.40.1190.20-FF-000111', NULL, 'Ribokinase', 314, NULL, NULL, 24498),
(24499, '3.10.440.10-FF-000006', NULL, 'Ribosomal protein L31e, putative', 109, NULL, NULL, 24499),
(24500, '1.10.510.10-FF-000059', NULL, 'Casein kinase II subunit alpha', 212, NULL, NULL, 24500),
(24501, '3.40.1090.10-FF-000067', NULL, 'Lysophospholipase', 174, NULL, NULL, 24501),
(24502, '3.30.2350.10-FF-000062', NULL, 'Uncharacterized protein', 152, NULL, NULL, 24502),
(24503, '2.40.160.10-FF-000055', NULL, 'Uncharacterized protein', 306, NULL, NULL, 24503),
(24504, '3.40.50.300-FF-006818', NULL, 'Uncharacterized protein', 38, NULL, NULL, 24504),
(24505, '3.20.20.70-FF-000573', NULL, 'Peroxisomal (S)-2-hydroxy-acid oxidase GLO1', 253, NULL, NULL, 24505),
(24506, '3.40.50.300-FF-004172', NULL, 'Guanylate-binding protein family member 6', 101, NULL, NULL, 24506),
(24507, '3.30.420.40-FF-000829', NULL, 'ARP5 actin related protein 5 homolog', 103, NULL, NULL, 24507),
(24508, '3.40.50.150-FF-001052', NULL, NULL, 76, NULL, NULL, 24508),
(24509, '3.40.50.720-FF-001537', NULL, 'Trans-2-enoyl-CoA reductase [NADH]', 397, NULL, NULL, 24509);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(24510, '3.30.70.330-FF-000853', NULL, 'U1 70K', 124, NULL, NULL, 24510),
(24511, '3.20.20.70-FF-000140', NULL, 'Fructose-bisphosphate aldolase', 354, NULL, NULL, 24511),
(24512, '3.30.1520.10-FF-000125', NULL, 'AER438Cp', 125, NULL, NULL, 24512),
(24513, '2.70.160.11-FF-000032', NULL, 'Arginine N-methyltransferase 1, putative', 167, NULL, NULL, 24513),
(24514, '3.30.200.20-FF-001768', NULL, 'Integrin-linked protein kinase', 86, NULL, NULL, 24514),
(24515, '3.40.50.300-FF-002547', NULL, 'Pre-mRNA-processing ATP-dependent RNA helicase PRP5', 265, NULL, NULL, 24515),
(24516, '2.40.170.20-FF-000069', NULL, 'SusC homolog', 634, NULL, NULL, 24516),
(24517, '3.20.20.80-FF-000143', NULL, 'Pullulanase, type I', 424, NULL, NULL, 24517),
(24518, '3.40.50.150-FF-001703', NULL, NULL, 76, NULL, NULL, 24518),
(24519, '2.10.25.10-FF-001294', NULL, 'AGAP003506-PA', 61, NULL, NULL, 24519),
(24520, '2.30.240.10-FF-000001', NULL, 'At1g56580/F25P12_18', 143, NULL, NULL, 24520),
(24521, '2.60.40.2070-FF-000009', NULL, 'Outer membrane usher protein SfmD', 82, NULL, NULL, 24521),
(24522, '2.60.40.150-FF-000588', NULL, 'Plant synaptotagmin: integral membrane double C2 domain protein', 98, NULL, NULL, 24522),
(24523, '3.30.559.30-FF-000092', NULL, 'Plipastatin synthase subunit B', 275, NULL, NULL, 24523),
(24524, '1.20.1250.20-FF-000521', NULL, 'YJR124C-like protein', 395, NULL, NULL, 24524),
(24525, '2.60.40.10-FF-006043', NULL, NULL, 60, NULL, NULL, 24525),
(24526, '3.10.20.90-FF-000809', NULL, 'Uncharacterized protein', 133, NULL, NULL, 24526),
(24527, '3.90.226.10-FF-000131', NULL, 'Enoyl-CoA hydratase', 260, NULL, NULL, 24527),
(24528, '1.20.1510.10-FF-000027', NULL, 'Zinc transporter ttm-1', 218, NULL, NULL, 24528),
(24529, '1.20.58.760-FF-000021', NULL, 'Cell division protein FstH', 148, NULL, NULL, 24529),
(24530, '2.60.120.10-FF-000688', NULL, 'Uncharacterized protein', 75, NULL, NULL, 24530),
(24531, '2.130.10.10-FF-004514', NULL, 'Uncharacterized protein', 234, NULL, NULL, 24531),
(24532, '1.20.920.10-FF-000003', NULL, 'Bromodomain-containing protein 2', 124, NULL, NULL, 24532),
(24533, '3.40.30.10-FF-000706', NULL, 'Glutathione S-transferase, putative', 60, NULL, NULL, 24533),
(24534, '1.20.920.20-FF-000006', NULL, 'Dynein, axonemal, heavy chain 6', 351, NULL, NULL, 24534),
(24535, '3.40.50.300-FF-006257', NULL, 'Chromodomain helicase DNA-binding protein 3', 130, NULL, NULL, 24535),
(24536, '3.40.800.10-FF-000050', NULL, NULL, 120, NULL, NULL, 24536),
(24537, '1.25.40.10-FF-003737', NULL, 'Uncharacterized protein', 106, NULL, NULL, 24537),
(24538, '3.30.160.60-FF-006256', NULL, NULL, 81, NULL, NULL, 24538),
(24539, '1.25.40.390-FF-000002', NULL, 'SusD-like protein BACOVA_02651', 519, NULL, NULL, 24539),
(24540, '1.20.1070.10-FF-001584', NULL, 'MAS-related 7-transmembrane protein', 157, NULL, NULL, 24540),
(24541, '2.120.10.80-FF-000179', NULL, 'kelch repeat and BTB domain-containing protein 13', 265, NULL, NULL, 24541),
(24542, '2.60.40.10-FF-005879', NULL, NULL, 40, NULL, NULL, 24542),
(24543, '2.60.120.260-FF-000372', NULL, 'Predicted protein', 57, NULL, NULL, 24543),
(24544, '2.60.40.640-FF-000134', NULL, 'Uncharacterized protein', 130, NULL, NULL, 24544),
(24545, '3.40.800.20-FF-000053', NULL, 'Uncharacterized protein', 292, NULL, NULL, 24545),
(24546, '3.40.50.720-FF-001594', NULL, 'Uncharacterized protein', 189, NULL, NULL, 24546),
(24547, '1.25.40.10-FF-004721', NULL, 'Uncharacterized protein', 88, NULL, NULL, 24547),
(24548, '1.10.238.150-FF-000004', NULL, 'Blast:Disheveled-associated activator of morphogenesis 1', 121, NULL, NULL, 24548),
(24549, '2.60.40.10-FF-004098', NULL, NULL, 94, NULL, NULL, 24549),
(24550, '3.30.720.200-FF-000001', NULL, 'Glycine--tRNA ligase 2', 68, NULL, NULL, 24550),
(24551, '1.10.10.60-FF-000467', NULL, 'Os03g0412900 protein', 66, NULL, NULL, 24551),
(24552, '2.30.30.40-FF-000196', NULL, 'Chemotaxis protein CheV', 52, NULL, NULL, 24552),
(24553, '3.30.720.210-FF-000004', NULL, 'ATP-dependent zinc metalloprotease FtsH', 78, NULL, NULL, 24553),
(24554, '1.20.920.30-FF-000009', NULL, 'Dynein heavy chain 9', 209, NULL, NULL, 24554);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(24555, '3.10.330.10-FF-000037', NULL, 'Predicted protein', 110, NULL, NULL, 24555),
(24556, '3.30.559.70-FF-000053', NULL, 'Carnitine acyltransferase, putative', 140, NULL, NULL, 24556),
(24557, '2.70.170.10-FF-000077', NULL, 'Acetylcholine-gated chloride channel subunit acc-3', 218, NULL, NULL, 24557),
(24558, '3.40.50.300-FF-003154', NULL, 'Serine/threonine-protein phosphatase', 167, NULL, NULL, 24558),
(24559, '3.80.10.10-FF-004211', NULL, 'Uncharacterized protein', 87, NULL, NULL, 24559),
(24560, '3.30.1540.20-FF-000017', NULL, 'MutL-like protein 3', 77, NULL, NULL, 24560),
(24561, '1.20.58.60-FF-000301', NULL, 'Spectrin beta, non-erythrocytic 5', 106, NULL, NULL, 24561),
(24562, '2.160.10.10-FF-000117', NULL, 'Predicted protein', 66, NULL, NULL, 24562),
(24563, '3.40.930.10-FF-000054', NULL, NULL, 94, NULL, NULL, 24563),
(24564, '3.80.10.10-FF-003227', NULL, 'AGAP009026-PA', 201, NULL, NULL, 24564),
(24565, '1.20.120.230-FF-000002', NULL, 'Talin 2', 130, NULL, NULL, 24565),
(24566, '1.25.40.10-FF-004344', NULL, 'Uncharacterized protein', 162, NULL, NULL, 24566),
(24567, '1.10.20.10-FF-000324', NULL, NULL, 123, NULL, NULL, 24567),
(24568, '2.60.34.10-FF-000115', NULL, 'DnaK protein', 135, NULL, NULL, 24568),
(24569, '2.30.42.10-FF-000315', NULL, 'AGAP011205-PA', 91, NULL, NULL, 24569),
(24570, '2.130.10.10-FF-002569', NULL, 'Intraflagellar transport 122', 65, NULL, NULL, 24570),
(24571, '3.30.160.60-FF-000708', NULL, 'Sal-like protein 1', 23, NULL, NULL, 24571),
(24572, '3.40.850.10-FF-000053', NULL, 'Kinesin family', 377, NULL, NULL, 24572),
(24573, '1.20.1250.20-FF-002174', NULL, 'Uncharacterized protein', 175, NULL, NULL, 24573),
(24574, '3.80.10.10-FF-003284', NULL, 'Uncharacterized protein', 120, NULL, NULL, 24574),
(24575, '2.40.30.10-FF-000456', NULL, 'Cytochrome b5 reductase 4-like Protein', 104, NULL, NULL, 24575),
(24576, '1.10.238.10-FF-000780', NULL, 'CALUmenin (Calcium-binding protein) homolog', 58, NULL, NULL, 24576),
(24577, '3.30.160.60-FF-005003', NULL, NULL, 32, NULL, NULL, 24577),
(24578, '1.10.472.10-FF-000166', NULL, 'Unplaced genomic scaffold supercont1.8, whole genome shotgun sequence', 170, NULL, NULL, 24578),
(24579, '1.10.10.10-FF-001987', NULL, 'ISSpo6, transposase orf A', 50, NULL, NULL, 24579),
(24580, '3.40.50.620-FF-000462', NULL, 'Predicted protein', 56, NULL, NULL, 24580),
(24581, '1.10.238.10-FF-000723', NULL, 'Centrin, putative', 67, NULL, NULL, 24581),
(24582, '2.130.10.10-FF-002480', NULL, 'Uncharacterized protein', 283, NULL, NULL, 24582),
(24583, '3.30.1140.40-FF-000004', NULL, 'Putative dynein light chain', 105, NULL, NULL, 24583),
(24584, '3.60.15.10-FF-000243', NULL, 'Uncharacterized protein', 73, NULL, NULL, 24584),
(24585, '3.30.70.560-FF-000012', NULL, 'Folic acid synthesis protein FOL1', 151, NULL, NULL, 24585),
(24586, '1.10.30.10-FF-000061', NULL, 'High mobility group protein B3', 83, NULL, NULL, 24586),
(24587, '3.40.50.1000-FF-000693', NULL, NULL, 216, NULL, NULL, 24587),
(24588, '1.20.1540.10-FF-000001', NULL, 'Putative inactive rhomboid protein 1', 163, NULL, NULL, 24588),
(24589, '2.130.10.10-FF-002423', NULL, 'Uncharacterized protein', 302, NULL, NULL, 24589),
(24590, '3.30.40.10-FF-001129', NULL, 'Uncharacterized protein', 64, NULL, NULL, 24590),
(24591, '1.10.730.10-FF-000098', NULL, 'Leucine--tRNA ligase, mitochondrial', 22, NULL, NULL, 24591),
(24592, '3.90.70.10-FF-000780', NULL, 'Ubiquitin carboxyl-terminal hydrolase, putative', 448, NULL, NULL, 24592),
(24593, '2.40.50.770-FF-000022', NULL, 'Uncharacterized protein', 161, NULL, NULL, 24593),
(24594, '1.25.40.10-FF-002922', NULL, 'Uncharacterized protein', 168, NULL, NULL, 24594),
(24595, '2.10.25.10-FF-001440', NULL, 'Netrin-5', 71, NULL, NULL, 24595),
(24596, '2.60.40.10-FF-004952', NULL, NULL, 129, NULL, NULL, 24596),
(24597, '3.30.200.60-FF-000010', NULL, 'OTU deubiquitinase, ubiquitin aldehyde binding 2', 56, NULL, NULL, 24597),
(24598, '3.40.50.300-FF-004548', NULL, 'DNA helicase', 133, NULL, NULL, 24598),
(24599, '3.30.200.20-FF-000279', NULL, 'Calcium/calmodulin-dependent protein kinase type IV', 87, NULL, NULL, 24599);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(24600, '2.60.34.10-FF-000059', NULL, 'Heat shock 70kDa protein 4', 143, NULL, NULL, 24600),
(24601, '2.10.25.10-FF-001384', NULL, 'Uncharacterized protein', 41, NULL, NULL, 24601),
(24602, '3.30.260.10-FF-000105', NULL, NULL, 51, NULL, NULL, 24602),
(24603, '3.30.1890.10-FF-000001', NULL, 'ECA polysaccharide chain length modulation protein', 230, NULL, NULL, 24603),
(24604, '3.40.850.10-FF-000143', NULL, 'Unplaced genomic scaffold supercont2.12, whole genome shotgun sequence', 387, NULL, NULL, 24604),
(24605, '1.10.287.1490-FF-000091', NULL, 'Uncharacterized protein', 183, NULL, NULL, 24605),
(24606, '3.90.1200.10-FF-000020', NULL, 'Homoserine kinase', 210, NULL, NULL, 24606),
(24607, '3.40.50.2300-FF-001078', NULL, 'Predicted protein', 275, NULL, NULL, 24607),
(24608, '1.25.40.20-FF-001531', NULL, 'Kinase, NEK', 163, NULL, NULL, 24608),
(24609, '3.40.50.300-FF-004790', NULL, 'Uncharacterized protein', 185, NULL, NULL, 24609),
(24610, '3.30.50.10-FF-000180', NULL, 'Uncharacterized protein', 60, NULL, NULL, 24610),
(24611, '1.20.1530.20-FF-000032', NULL, 'Integral membrane transport protein', 372, NULL, NULL, 24611),
(24612, '2.60.40.150-FF-000442', NULL, 'YALI0A17985p', 142, NULL, NULL, 24612),
(24613, '3.40.30.10-FF-001257', NULL, 'Thioredoxin domain containing 5', 113, NULL, NULL, 24613),
(24614, '1.10.510.10-FF-002476', NULL, 'Serine/threonine-protein kinase ppk34', 352, NULL, NULL, 24614),
(24615, '1.10.472.10-FF-000402', NULL, 'Uncharacterized protein', 109, NULL, NULL, 24615),
(24616, '1.10.1450.10-FF-000064', NULL, 'Tetraspanin', 96, NULL, NULL, 24616),
(24617, '1.10.510.10-FF-002532', NULL, 'serine/threonine-protein kinase Nek3-like', 313, NULL, NULL, 24617),
(24618, '3.40.50.300-FF-008533', NULL, 'Uncharacterized protein', 150, NULL, NULL, 24618),
(24619, '1.10.20.10-FF-000268', NULL, NULL, 123, NULL, NULL, 24619),
(24620, '3.40.50.300-FF-000804', NULL, 'E3 ubiquitin-protein ligase RNF213', 157, NULL, NULL, 24620),
(24621, '1.25.40.10-FF-002719', NULL, 'Coatomer subunit epsilon', 299, NULL, NULL, 24621),
(24622, '3.30.70.330-FF-000235', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 100, NULL, NULL, 24622),
(24623, '1.10.510.10-FF-000677', NULL, 'Uncharacterized protein, isoform A', 177, NULL, NULL, 24623),
(24624, '2.60.260.20-FF-000055', NULL, 'Chaperone protein DnaJ', 112, NULL, NULL, 24624),
(24625, '3.40.50.300-FF-008590', NULL, 'Uncharacterized protein', 128, NULL, NULL, 24625),
(24626, '2.60.40.10-FF-004805', NULL, NULL, 75, NULL, NULL, 24626),
(24627, '3.40.47.10-FF-000037', NULL, '3-oxoacyl-ACP synthase III', 140, NULL, NULL, 24627),
(24628, '2.40.70.10-FF-000076', NULL, 'Uncharacterized protein', 135, NULL, NULL, 24628),
(24629, '1.10.10.10-FF-000823', NULL, 'Possible hydrolase', 64, NULL, NULL, 24629),
(24630, '3.30.160.60-FF-001057', NULL, 'zinc finger protein 358', 26, NULL, NULL, 24630),
(24631, '1.20.1070.10-FF-000420', NULL, 'OCTopamine Receptor (GPCR)', 319, NULL, NULL, 24631),
(24632, '3.80.10.10-FF-003901', NULL, 'AGAP011649-PA', 133, NULL, NULL, 24632),
(24633, '3.30.200.20-FF-001971', NULL, NULL, 102, NULL, NULL, 24633),
(24634, '1.20.1250.20-FF-001954', NULL, 'Chromosome 8, whole genome shotgun sequence', 434, NULL, NULL, 24634),
(24635, '3.40.50.960-FF-000013', NULL, '6,7-dimethyl-8-ribityllumazine synthase', 147, NULL, NULL, 24635),
(24636, '2.40.100.10-FF-000169', NULL, 'Uncharacterized protein', 67, NULL, NULL, 24636),
(24637, '3.30.450.40-FF-000096', NULL, 'IclR family transcriptional regulator', 157, NULL, NULL, 24637),
(24638, '2.60.40.1170-FF-000015', NULL, 'Coatomer subunit delta', 118, NULL, NULL, 24638),
(24639, '3.10.580.10-FF-000168', NULL, 'Chloride channel protein B', 72, NULL, NULL, 24639),
(24640, '1.10.238.10-FF-001033', NULL, 'Ustilago maydis induced12', 59, NULL, NULL, 24640),
(24641, '2.130.10.10-FF-000063', NULL, 'SEH1 like nucleoporin', 318, NULL, NULL, 24641),
(24642, '3.30.70.330-FF-000292', NULL, 'RNA-binding motif protein 45', 96, NULL, NULL, 24642),
(24643, '1.25.40.90-FF-000107', NULL, 'Uncharacterized protein', 86, NULL, NULL, 24643);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(24644, '1.20.120.1240-FF-000020', NULL, 'Dynamin 2', 203, NULL, NULL, 24644),
(24645, '1.10.510.10-FF-001082', NULL, 'Probable transmembrane serine/threonine-protein kinase I pknI', 170, NULL, NULL, 24645),
(24646, '3.30.40.10-FF-002242', NULL, 'Uncharacterized protein', 61, NULL, NULL, 24646),
(24647, '3.10.20.70-FF-000039', NULL, 'Uncharacterized protein', 115, NULL, NULL, 24647),
(24648, '3.40.50.300-FF-000658', NULL, 'ADP-ribosylation factor-like protein 4A', 188, NULL, NULL, 24648),
(24649, '3.90.650.10-FF-000021', NULL, 'selenide, water dikinase 1 isoform X3', 71, NULL, NULL, 24649),
(24650, '3.30.160.60-FF-001203', NULL, 'zinc finger protein 668', 31, NULL, NULL, 24650),
(24651, '3.30.700.10-FF-000005', NULL, 'MSHA major pilin subunit MshA', 141, NULL, NULL, 24651),
(24652, '3.90.76.10-FF-000057', NULL, 'Maltose ABC transporter, maltose binding protein', 113, NULL, NULL, 24652),
(24653, '2.120.10.80-FF-000269', NULL, 'F-box/kelch-repeat protein At2g44130', 212, NULL, NULL, 24653),
(24654, '3.90.110.10-FF-000020', NULL, '6-phospho-beta-glucosidase', 278, NULL, NULL, 24654),
(24655, '3.40.50.2000-FF-000184', NULL, 'Glycosyl transferase, group 1', 190, NULL, NULL, 24655),
(24656, '3.90.550.50-FF-000238', NULL, 'Beta-3-glucosyltransferase a', 214, NULL, NULL, 24656),
(24657, '3.30.230.70-FF-000127', NULL, 'Predicted protein', 208, NULL, NULL, 24657),
(24658, '2.60.40.10-FF-006099', NULL, NULL, 87, NULL, NULL, 24658),
(24659, '3.80.10.10-FF-001575', NULL, 'Putative dual specificity protein phosphatase', 186, NULL, NULL, 24659),
(24660, '3.30.40.10-FF-000112', NULL, 'RING finger protein 10', 91, NULL, NULL, 24660),
(24661, '3.30.160.60-FF-003002', NULL, 'zinc finger protein 853', 76, NULL, NULL, 24661),
(24662, '3.80.10.10-FF-001518', NULL, 'Insulin-like growth factor-binding protein complex acid labile subunit', 60, NULL, NULL, 24662),
(24663, '1.10.390.10-FF-000088', NULL, 'Aminopeptidase', 244, NULL, NULL, 24663),
(24664, '3.30.70.270-FF-000138', NULL, 'Pro-Pol polyprotein', 101, NULL, NULL, 24664),
(24665, '2.30.30.40-FF-000667', NULL, 'Uncharacterized protein', 64, NULL, NULL, 24665),
(24666, '2.130.10.10-FF-004278', NULL, 'Uncharacterized protein', 129, NULL, NULL, 24666),
(24667, '3.30.450.20-FF-000090', NULL, 'Uncharacterized protein, isoform B', 194, NULL, NULL, 24667),
(24668, '3.30.450.30-FF-000093', NULL, 'DNA-directed RNA polymerase subunit', 99, NULL, NULL, 24668),
(24669, '1.10.10.60-FF-000703', NULL, 'Putative SNF2 family helicase', 102, NULL, NULL, 24669),
(24670, '2.60.40.10-FF-003316', NULL, 'Receptor protein-tyrosine kinase', 103, NULL, NULL, 24670),
(24671, '3.40.50.300-FF-002603', NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 10, mitochondrial', 225, NULL, NULL, 24671),
(24672, '3.90.420.10-FF-000009', NULL, 'Uncharacterized protein', 188, NULL, NULL, 24672),
(24673, '3.30.300.130-FF-000032', NULL, NULL, 80, NULL, NULL, 24673),
(24674, '2.130.10.10-FF-003497', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 3', 262, NULL, NULL, 24674),
(24675, '2.10.25.10-FF-001327', NULL, 'Uncharacterized protein', 33, NULL, NULL, 24675),
(24676, '1.20.85.10-FF-000006', NULL, 'Photosynthetic reaction center subunit L', 172, NULL, NULL, 24676),
(24677, '3.40.50.300-FF-008443', NULL, 'Uncharacterized protein', 72, NULL, NULL, 24677),
(24678, '3.30.200.20-FF-001858', NULL, 'Uncharacterized protein', 101, NULL, NULL, 24678),
(24679, '2.60.40.60-FF-000291', NULL, 'Cadherin related family member 4', 102, NULL, NULL, 24679),
(24680, '1.25.40.10-FF-002809', NULL, 'Predicted protein', 268, NULL, NULL, 24680),
(24681, '3.30.590.20-FF-000009', NULL, 'Putative glutamate--cysteine ligase 2', 364, NULL, NULL, 24681),
(24682, '2.40.30.130-FF-000023', NULL, 'Alanyl-tRNA synthetase-related protein, putative', 113, NULL, NULL, 24682),
(24683, '2.60.40.2660-FF-000001', NULL, 'Ankyrin-3 isoform 2', 161, NULL, NULL, 24683),
(24684, '2.60.40.60-FF-000049', NULL, 'protocadherin-15 isoform X1', 98, NULL, NULL, 24684),
(24685, '1.25.40.10-FF-002304', NULL, 'Bardet-Biedl syndrome 4 protein homolog', 132, NULL, NULL, 24685);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(24686, '3.30.450.40-FF-000281', NULL, 'Phosphodiesterase', 105, NULL, NULL, 24686),
(24687, '2.60.40.60-FF-000667', NULL, 'Cadherin 16', 117, NULL, NULL, 24687),
(24688, '2.40.30.10-FF-000512', NULL, 'NADPH--cytochrome P450 reductase 2', 55, NULL, NULL, 24688),
(24689, '3.30.590.10-FF-000006', NULL, 'Arginine kinase 1', 254, NULL, NULL, 24689),
(24690, '3.30.160.60-FF-000186', NULL, 'Zinc finger protein 366', 28, NULL, NULL, 24690),
(24691, '2.10.25.10-FF-001474', NULL, 'Uncharacterized protein', 39, NULL, NULL, 24691),
(24692, '3.40.50.11610-FF-000014', NULL, 'Oxoglutarate (alpha-ketoglutarate) dehydrogenase b (lipoamide)', 159, NULL, NULL, 24692),
(24693, '3.10.20.90-FF-000287', NULL, 'Ubiquitin domain-containing protein DSK2,putative', 104, NULL, NULL, 24693),
(24694, '2.60.40.10-FF-004862', NULL, NULL, 84, NULL, NULL, 24694),
(24695, '2.60.40.10-FF-002299', NULL, 'AGAP003656-PA', 91, NULL, NULL, 24695),
(24696, '3.90.1150.10-FF-000223', NULL, 'Probable glycine dehydrogenase (decarboxylating) subunit 1', 101, NULL, NULL, 24696),
(24697, '1.10.10.60-FF-000052', NULL, 'Arginine-glutamic acid dipeptide (RE) repeats', 61, NULL, NULL, 24697),
(24698, '1.20.1250.20-FF-001393', NULL, 'Major facilitator superfamily transport protein', 190, NULL, NULL, 24698),
(24699, '3.30.565.10-FF-000263', NULL, 'YALI0C10032p', 170, NULL, NULL, 24699),
(24700, '1.25.10.10-FF-000773', NULL, 'AP complex subunit beta', 582, NULL, NULL, 24700),
(24701, '1.10.1450.10-FF-000154', NULL, 'Tetraspanin', 84, NULL, NULL, 24701),
(24702, '2.60.40.10-FF-000591', NULL, 'tyrosine-protein kinase receptor Tie-1 isoform X1', 91, NULL, NULL, 24702),
(24703, '3.40.190.10-FF-000463', NULL, 'sn-glycerol-3-phosphate ABC transporter substrate-binding lipoprotein UgpB', 406, NULL, NULL, 24703),
(24704, '1.10.3380.10-FF-000002', NULL, 'Activating signal cointegrator 1 complex subunit 3', 137, NULL, NULL, 24704),
(24705, '2.70.130.10-FF-000136', NULL, NULL, 131, NULL, NULL, 24705),
(24706, '2.10.110.10-FF-000002', NULL, 'LIM domain and actin-binding 1', 71, NULL, NULL, 24706),
(24707, '1.20.1600.10-FF-000057', NULL, 'Protein CyaE', 408, NULL, NULL, 24707),
(24708, '1.10.287.110-FF-000069', NULL, 'ER associated DnaJ chaperone', 129, NULL, NULL, 24708),
(24709, '2.130.10.10-FF-004929', NULL, 'Uncharacterized RWD, RING finger and WD repeat-containing protein C11E3.05', 105, NULL, NULL, 24709),
(24710, '1.20.930.10-FF-000032', NULL, 'Protein IWS1-like protein', 144, NULL, NULL, 24710),
(24711, '2.10.110.20-FF-000005', NULL, NULL, 59, NULL, NULL, 24711),
(24712, '3.30.160.60-FF-001170', NULL, 'GDNF inducible zinc finger protein 1', 28, NULL, NULL, 24712),
(24713, '3.40.640.10-FF-000043', NULL, 'Cystathionine gamma-lyase', 245, NULL, NULL, 24713),
(24714, '3.20.180.20-FF-000014', NULL, 'Putative dynein heavy chain', 96, NULL, NULL, 24714),
(24715, '3.80.10.10-FF-001485', NULL, 'Protein CBR-DMA-1', 163, NULL, NULL, 24715),
(24716, '2.40.30.270-FF-000014', NULL, 'DNA helicase HCS1', 104, NULL, NULL, 24716),
(24717, '3.40.50.980-FF-000019', NULL, 'Nonribosomal peptide synthase 2', 142, NULL, NULL, 24717),
(24718, '3.40.50.150-FF-000832', NULL, 'Betaine lipid synthase', 210, NULL, NULL, 24718),
(24719, '3.30.70.330-FF-000325', NULL, 'splicing regulator RBM11 isoform X1', 77, NULL, NULL, 24719),
(24720, '2.60.120.590-FF-000032', NULL, 'RNA demethylase ALKBH10B', 221, NULL, NULL, 24720),
(24721, '3.30.530.20-FF-000124', NULL, 'Uncharacterized protein', 126, NULL, NULL, 24721),
(24722, '1.20.58.1590-FF-000004', NULL, 'Uncharacterized protein', 156, NULL, NULL, 24722),
(24723, '3.40.50.970-FF-000016', NULL, 'Acetolactate synthase', 183, NULL, NULL, 24723),
(24724, '1.10.3460.10-FF-000003', NULL, 'Chlorophyll a-b binding protein, chloroplastic', 189, NULL, NULL, 24724),
(24725, '3.40.50.300-FF-001114', NULL, 'NLR family CARD domain containing 5', 220, NULL, NULL, 24725),
(24726, '3.40.50.300-FF-008387', NULL, 'DNA helicase', 198, NULL, NULL, 24726),
(24727, '3.30.160.60-FF-001113', NULL, 'Zinc finger and BTB domain containing 48', 31, NULL, NULL, 24727);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(24728, '2.60.40.10-FF-004334', NULL, NULL, 124, NULL, NULL, 24728),
(24729, '2.60.40.60-FF-000852', NULL, 'Uncharacterized protein', 73, NULL, NULL, 24729),
(24730, '3.30.1370.120-FF-000007', NULL, 'Type II secretion system protein D', 69, NULL, NULL, 24730),
(24731, '1.25.40.10-FF-002248', NULL, 'Uncharacterized protein', 260, NULL, NULL, 24731),
(24732, '3.10.290.10-FF-000067', NULL, 'Pseudouridine synthase', 62, NULL, NULL, 24732),
(24733, '1.20.5.1160-FF-000021', NULL, 'Coiled-coil domain-containing protein 61 isoform X1', 119, NULL, NULL, 24733),
(24734, '1.20.1250.20-FF-002320', NULL, 'Uncharacterized protein', 68, NULL, NULL, 24734),
(24735, '3.90.470.20-FF-000077', NULL, 'Aminoadipate-semialdehyde dehydrogenase-phosphopantetheinyl transferase', 108, NULL, NULL, 24735),
(24736, '3.30.160.60-FF-001023', NULL, 'MEFV, pyrin innate immunity regulator', 84, NULL, NULL, 24736),
(24737, '3.30.830.10-FF-000161', NULL, 'Zinc protease PQQL-like', 169, NULL, NULL, 24737),
(24738, '1.10.10.60-FF-000613', NULL, 'Probable transcriptional regulatory protein', 45, NULL, NULL, 24738),
(24739, '2.40.50.90-FF-000115', NULL, 'Tudor, isoform B', 87, NULL, NULL, 24739),
(24740, '1.20.1250.20-FF-002230', NULL, 'Predicted protein', 126, NULL, NULL, 24740),
(24741, '1.10.275.40-FF-000003', NULL, 'DNA repair helicase RAD3, putative', 46, NULL, NULL, 24741),
(24742, '3.80.10.10-FF-001428', NULL, 'Probable disease resistance protein At5g04720', 182, NULL, NULL, 24742),
(24743, '3.30.160.60-FF-000747', NULL, 'Probable lysine-specific demethylase ELF6', 30, NULL, NULL, 24743),
(24744, '3.90.1150.10-FF-000370', NULL, 'L-allo-threonine aldolase, stereospecific', 91, NULL, NULL, 24744),
(24745, '3.40.50.150-FF-000922', NULL, NULL, 222, NULL, NULL, 24745),
(24746, '1.20.144.10-FF-000109', NULL, 'Uncharacterized protein', 229, NULL, NULL, 24746),
(24747, '3.40.50.300-FF-000748', NULL, 'ras-related protein Rab-34 isoform X2', 183, NULL, NULL, 24747),
(24748, '1.10.20.10-FF-000178', NULL, 'Histone H2B', 112, NULL, NULL, 24748),
(24749, '3.90.550.10-FF-000726', NULL, 'Predicted protein', 376, NULL, NULL, 24749),
(24750, '2.130.10.10-FF-004368', NULL, 'Si:ch211-129c21.1', 85, NULL, NULL, 24750),
(24751, '2.120.10.80-FF-000325', NULL, 'Predicted protein', 149, NULL, NULL, 24751),
(24752, '2.60.40.1770-FF-000009', NULL, 'ephrin type-A receptor 4 isoform X1', 59, NULL, NULL, 24752),
(24753, '1.25.40.10-FF-001995', NULL, 'RNA polymerase-associated protein CTR9', 85, NULL, NULL, 24753),
(24754, '3.40.190.10-FF-000316', NULL, 'Transcriptional regulator LysR', 92, NULL, NULL, 24754),
(24755, '1.20.1300.10-FF-000017', NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', 128, NULL, NULL, 24755),
(24756, '3.30.40.10-FF-002152', NULL, 'Uncharacterized protein', 43, NULL, NULL, 24756),
(24757, '3.40.50.150-FF-000271', NULL, 'NOL1/NOP2/Sun family protein', 355, NULL, NULL, 24757),
(24758, '3.50.50.60-FF-000452', NULL, 'Dihydropyrimidine dehydrogenase [NADP(+)]', 147, NULL, NULL, 24758),
(24759, '3.40.50.720-FF-000048', NULL, '4-hydroxy-tetrahydrodipicolinate reductase', 155, NULL, NULL, 24759),
(24760, '2.60.40.10-FF-004244', NULL, NULL, 115, NULL, NULL, 24760),
(24761, '1.10.3380.20-FF-000005', NULL, 'DNA-directed DNA polymerase theta, putative', 124, NULL, NULL, 24761),
(24762, '3.40.50.2300-FF-000392', NULL, 'LppC family lipoprotein', 129, NULL, NULL, 24762),
(24763, '1.10.3380.30-FF-000008', NULL, 'Helicase with Zn-finger motif, putative', 227, NULL, NULL, 24763),
(24764, '3.30.1050.10-FF-000016', NULL, 'Uncharacterized N-acetyltransferase CLW02_3581', 97, NULL, NULL, 24764),
(24765, '3.30.50.10-FF-000028', NULL, 'Nuclear receptor subfamily 2, group E, member 3', 104, NULL, NULL, 24765),
(24766, '3.30.200.20-FF-002224', NULL, 'Mitogen-activated protein kinase, long flagella protein 4', 40, NULL, NULL, 24766),
(24767, '3.30.160.60-FF-001731', NULL, 'Crooked legs, isoform F', 25, NULL, NULL, 24767),
(24768, '1.10.472.10-FF-000312', NULL, 'AGAP006477-PA', 181, NULL, NULL, 24768),
(24769, '1.20.1050.20-FF-000006', NULL, 'Signal transducer and activator of transcription', 160, NULL, NULL, 24769);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(24770, '3.40.50.10420-FF-000056', NULL, '5-formyltetrahydrofolate cyclo-ligase', 186, NULL, NULL, 24770),
(24771, '3.30.565.10-FF-000078', NULL, 'Two-component sensor histidine kinase', 163, NULL, NULL, 24771),
(24772, '2.20.25.30-FF-000001', NULL, 'Ribosomal protein L37', 87, NULL, NULL, 24772),
(24773, '1.10.238.10-FF-000577', NULL, 'Putative calmodulin-related protein', 78, NULL, NULL, 24773),
(24774, '3.40.50.300-FF-004458', NULL, 'Uncharacterized protein', 283, NULL, NULL, 24774),
(24775, '3.40.50.1100-FF-000279', NULL, 'Uncharacterized protein', 52, NULL, NULL, 24775),
(24776, '3.30.160.60-FF-004457', NULL, NULL, 54, NULL, NULL, 24776),
(24777, '3.40.50.720-FF-000290', NULL, 'SDR family oxidoreductase', 248, NULL, NULL, 24777),
(24778, '3.40.50.1460-FF-000100', NULL, 'AGAP010826-PA', 159, NULL, NULL, 24778),
(24779, '1.10.510.10-FF-000587', NULL, 'Phosphoinositide-dependent kinase 1, isoform F', 125, NULL, NULL, 24779),
(24780, '3.30.70.1400-FF-000023', NULL, 'Sarcosine dehydrogenase', 110, NULL, NULL, 24780),
(24781, '1.20.1050.10-FF-000003', NULL, 'Glutathione S-transferase 2', 105, NULL, NULL, 24781),
(24782, '3.80.10.10-FF-000063', NULL, 'Lumican', 99, NULL, NULL, 24782),
(24783, '1.10.510.10-FF-002650', NULL, NULL, 70, NULL, NULL, 24783),
(24784, '2.40.160.120-FF-000039', NULL, 'Uncharacterized protein', 39, NULL, NULL, 24784),
(24785, '3.30.565.10-FF-000471', NULL, 'Sensory histidine protein kinase', 98, NULL, NULL, 24785),
(24786, '1.20.1250.20-FF-001707', NULL, 'Uncharacterized protein', 166, NULL, NULL, 24786),
(24787, '1.10.10.820-FF-000023', NULL, 'Class II myosin', 59, NULL, NULL, 24787),
(24788, '3.40.50.300-FF-004672', NULL, 'Peroxisomal biogenesis factor 6', 158, NULL, NULL, 24788),
(24789, '3.40.50.300-FF-000389', NULL, 'Small ribosomal subunit biogenesis GTPase RsgA', 173, NULL, NULL, 24789),
(24790, '2.60.40.10-FF-002097', NULL, 'CD160 antigen', 112, NULL, NULL, 24790),
(24791, '2.40.160.110-FF-000036', NULL, 'Uncharacterized protein', 184, NULL, NULL, 24791),
(24792, '3.30.70.1230-FF-000068', NULL, 'Putative ATPase', 192, NULL, NULL, 24792),
(24793, '1.10.1240.30-FF-000003', NULL, 'Circadian clock protein KaiA', 117, NULL, NULL, 24793),
(24794, '3.40.50.880-FF-000074', NULL, 'Transcriptional regulator ArgR', 199, NULL, NULL, 24794),
(24795, '1.25.40.10-FF-003496', NULL, 'Pentatricopeptide repeat-containing protein', 70, NULL, NULL, 24795),
(24796, '3.10.110.10-FF-000173', NULL, 'Ubiquitin conjugating enzyme', 160, NULL, NULL, 24796),
(24797, '1.20.120.1240-FF-000019', NULL, 'Dynamin 2', 150, NULL, NULL, 24797),
(24798, '1.10.4160.10-FF-000025', NULL, 'Putative purine-cytosine permease YxlA', 440, NULL, NULL, 24798),
(24799, '1.20.120.980-FF-000058', NULL, 'Uncharacterized protein', 20, NULL, NULL, 24799),
(24800, '1.20.1270.60-FF-000040', NULL, 'GEM-interacting protein isoform X1', 279, NULL, NULL, 24800),
(24801, '3.40.50.300-FF-006796', NULL, 'Uncharacterized protein', 55, NULL, NULL, 24801),
(24802, '3.40.50.1950-FF-000011', NULL, 'Flavin prenyltransferase UbiX', 187, NULL, NULL, 24802),
(24803, '2.40.50.1070-FF-000029', NULL, NULL, 135, NULL, NULL, 24803),
(24804, '3.40.30.10-FF-001201', NULL, 'Uncharacterized protein', 71, NULL, NULL, 24804),
(24805, '1.10.472.10-FF-000514', NULL, 'Uncharacterized protein', 98, NULL, NULL, 24805),
(24806, '3.40.50.720-FF-002083', NULL, 'Fatty acyl-CoA reductase', 141, NULL, NULL, 24806),
(24807, '3.40.47.10-FF-000161', NULL, 'Putative polyketide beta-ketoacyl synthase 2', 258, NULL, NULL, 24807),
(24808, '1.25.40.10-FF-004108', NULL, 'Uncharacterized protein', 139, NULL, NULL, 24808),
(24809, '2.40.50.1060-FF-000026', NULL, 'Uncharacterized protein', 145, NULL, NULL, 24809),
(24810, '4.10.520.10-FF-000008', NULL, 'Integration host factor subunit beta', 93, NULL, NULL, 24810),
(24811, '3.40.50.1970-FF-000017', NULL, '3-dehydroquinate synthase', 160, NULL, NULL, 24811),
(24812, '3.40.50.970-FF-000224', NULL, 'Pyruvate dehydrogenase E1 alpha 1 subunit', 190, NULL, NULL, 24812),
(24813, '3.10.20.90-FF-000692', NULL, 'NSFL1 cofactor p47', 114, NULL, NULL, 24813);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(24814, '1.20.58.400-FF-000031', NULL, 'Uncharacterized protein', 96, NULL, NULL, 24814),
(24815, '3.90.70.10-FF-000370', NULL, 'Cytoskeleton-associated protein', 135, NULL, NULL, 24815),
(24816, '3.90.1140.10-FF-000043', NULL, 'A-kinase anchor protein 7, putative', 132, NULL, NULL, 24816),
(24817, '3.40.50.12390-FF-000012', NULL, 'XRN 5''-3'' exonuclease N-terminus, putative', 181, NULL, NULL, 24817),
(24818, '3.90.70.200-FF-000003', NULL, 'RNA polymerase-associated protein RTF1', 133, NULL, NULL, 24818),
(24819, '3.40.309.10-FF-000048', NULL, 'NADP-dependent glyceraldehyde-3-phosphate dehydrogenase', 192, NULL, NULL, 24819),
(24820, '1.20.920.30-FF-000043', NULL, 'Dynein heavy chain, cytoplasmic', 189, NULL, NULL, 24820),
(24821, '2.130.10.30-FF-000102', NULL, NULL, 235, NULL, NULL, 24821),
(24822, '3.30.420.40-FF-000335', NULL, 'Ectonucleoside triphosphate diphosphohydrolase 3', 12, NULL, NULL, 24822),
(24823, '3.10.196.10-FF-000011', NULL, 'Methionine synthase', 238, NULL, NULL, 24823),
(24824, '1.10.1420.10-FF-000096', NULL, 'MutS homolog, putative', 230, NULL, NULL, 24824),
(24825, '3.80.10.10-FF-003840', NULL, 'Uncharacterized protein', 46, NULL, NULL, 24825),
(24826, '3.40.50.200-FF-000185', NULL, 'Uncharacterized protein', 131, NULL, NULL, 24826),
(24827, '3.30.519.10-FF-000044', NULL, NULL, 104, NULL, NULL, 24827),
(24828, '3.20.190.10-FF-000006', NULL, 'Formamidopyrimidine-DNA glycosylase', 133, NULL, NULL, 24828),
(24829, '1.10.560.10-FF-000118', NULL, 'Predicted protein', 246, NULL, NULL, 24829),
(24830, '3.40.50.1440-FF-000145', NULL, 'Protein DML1', 329, NULL, NULL, 24830),
(24831, '3.30.230.70-FF-000048', NULL, 'Exosome complex component RRP43', 394, NULL, NULL, 24831),
(24832, '2.60.40.60-FF-000459', NULL, 'Protein dachsous-like Protein', 94, NULL, NULL, 24832),
(24833, '1.10.418.10-FF-000198', NULL, 'Uncharacterized protein', 132, NULL, NULL, 24833),
(24834, '2.60.40.10-FF-004188', NULL, NULL, 113, NULL, NULL, 24834),
(24835, '2.60.210.10-FF-000010', NULL, 'TNF receptor-associated factor', 159, NULL, NULL, 24835),
(24836, '3.40.50.2000-FF-000509', NULL, 'Glycosyltransferase', 247, NULL, NULL, 24836),
(24837, '2.60.40.10-FF-005874', NULL, NULL, 124, NULL, NULL, 24837),
(24838, '3.40.50.10050-FF-000012', NULL, 'AAEL009241-PA', 28, NULL, NULL, 24838),
(24839, '1.10.1240.40-FF-000006', NULL, 'ENT domain containing protein, expressed', 79, NULL, NULL, 24839),
(24840, '3.40.630.10-FF-000340', NULL, 'Uncharacterized protein', 346, NULL, NULL, 24840),
(24841, '2.120.10.30-FF-000338', NULL, 'Peptidase S9 prolyl oligopeptidase active site domain protein', 157, NULL, NULL, 24841),
(24842, '2.20.70.10-FF-000127', NULL, 'Pre-mRNA-processing protein 40A', 47, NULL, NULL, 24842),
(24843, '3.40.50.300-FF-002581', NULL, 'Guanylate-binding protein 4', 275, NULL, NULL, 24843),
(24844, '3.90.1010.10-FF-000005', NULL, 'Iron-sulfur cluster assembly protein', 141, NULL, NULL, 24844),
(24845, '3.40.50.300-FF-007313', NULL, 'Uncharacterized protein', 147, NULL, NULL, 24845),
(24846, '2.60.40.2030-FF-000043', NULL, 'Adhesion G-protein coupled receptor V1', 101, NULL, NULL, 24846),
(24847, '3.90.226.10-FF-000221', NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', 346, NULL, NULL, 24847),
(24848, '3.40.50.720-FF-000380', NULL, 'Acetyltransferase, GNAT family', 122, NULL, NULL, 24848),
(24849, '2.60.120.260-FF-000512', NULL, 'Beta-galactosidase 17', 130, NULL, NULL, 24849),
(24850, '1.25.40.20-FF-000952', NULL, 'Ankyrin repeat domain-containing protein 13C', 117, NULL, NULL, 24850),
(24851, '1.20.120.520-FF-000004', NULL, 'F-box/LRR-repeat protein 5 isoform X1', 105, NULL, NULL, 24851),
(24852, '3.40.50.720-FF-000054', NULL, 'Enoyl-[acyl-carrier-protein] reductase [NADH]', 262, NULL, NULL, 24852),
(24853, '3.40.630.10-FF-000391', NULL, 'Uncharacterized protein', 46, NULL, NULL, 24853),
(24854, '1.20.58.120-FF-000003', NULL, 'BAG family molecular chaperone regulator 5', 87, NULL, NULL, 24854),
(24855, '2.130.10.10-FF-004424', NULL, 'Protein DSE1', 359, NULL, NULL, 24855),
(24856, '2.10.25.10-FF-001209', NULL, 'Predicted protein', 53, NULL, NULL, 24856);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(24857, '3.90.226.10-FF-000007', NULL, 'Methylcrotonoyl-CoA carboxylase subunit beta', 271, NULL, NULL, 24857),
(24858, '1.20.920.20-FF-000040', NULL, 'Cytoplasmic dynein heavy chain, putative', 260, NULL, NULL, 24858),
(24859, '3.30.160.60-FF-003209', NULL, 'Zinc finger protein 658B', 32, NULL, NULL, 24859),
(24860, '3.40.50.300-FF-000338', NULL, 'GPN-loop GTPase 2', 260, NULL, NULL, 24860),
(24861, '3.90.950.10-FF-000010', NULL, 'Nucleoside triphosphate pyrophosphatase', 187, NULL, NULL, 24861),
(24862, '3.40.1110.10-FF-000013', NULL, 'Calcium-transporting ATPase', 199, NULL, NULL, 24862),
(24863, '3.30.70.330-FF-000033', NULL, 'heterogeneous nuclear ribonucleoprotein M isoform X1', 77, NULL, NULL, 24863),
(24864, '3.30.470.20-FF-000040', NULL, 'Carnosine synthase 1', 273, NULL, NULL, 24864),
(24865, '2.40.128.680-FF-000001', NULL, 'Ribonuclease H2 subunit C', 132, NULL, NULL, 24865),
(24866, '1.10.357.10-FF-000005', NULL, 'TetR family transcriptional regulator', 213, NULL, NULL, 24866),
(24867, '3.40.50.1820-FF-000231', NULL, 'Chromosome 1, whole genome shotgun sequence', 297, NULL, NULL, 24867),
(24868, '3.30.9.10-FF-000197', NULL, 'D-amino acid dehydrogenase small subunit', 151, NULL, NULL, 24868),
(24869, '1.10.510.10-FF-000407', NULL, 'Non-specific serine/threonine protein kinase', 184, NULL, NULL, 24869),
(24870, '3.40.190.10-FF-000204', NULL, 'Phosphate ABC transporter substrate-binding protein', 132, NULL, NULL, 24870),
(24871, '3.30.1140.40-FF-000009', NULL, 'GM25527', 99, NULL, NULL, 24871),
(24872, '3.30.40.10-FF-000325', NULL, 'RING finger protein 122', 47, NULL, NULL, 24872),
(24873, '3.90.550.10-FF-000159', NULL, 'Unplaced genomic scaffold supercont1.48, whole genome shotgun sequence', 138, NULL, NULL, 24873),
(24874, '1.10.640.10-FF-000006', NULL, 'Double oxidase: two peroxidase domains', 585, NULL, NULL, 24874),
(24875, '3.40.50.10490-FF-000060', NULL, 'Glucose-6-phosphate isomerase', 340, NULL, NULL, 24875),
(24876, '3.30.160.60-FF-000568', NULL, 'zinc finger protein 90 homolog', 27, NULL, NULL, 24876),
(24877, '1.20.1250.20-FF-000173', NULL, 'Hexuronate transporter', 211, NULL, NULL, 24877),
(24878, '2.60.40.60-FF-000408', NULL, 'Cadherin 3', 106, NULL, NULL, 24878),
(24879, '3.90.550.10-FF-000547', NULL, 'Uncharacterized protein', 182, NULL, NULL, 24879),
(24880, '1.10.357.20-FF-000008', NULL, 'Solute carrier family 41 member 1, putative', 179, NULL, NULL, 24880),
(24881, '3.30.230.70-FF-000099', NULL, 'Exosome complex exonuclease', 249, NULL, NULL, 24881),
(24882, '3.40.50.880-FF-000023', NULL, 'Imidazole glycerol phosphate synthase subunit HisH', 211, NULL, NULL, 24882),
(24883, '2.60.200.20-FF-000074', NULL, 'Protein serine-threonine kinase', 131, NULL, NULL, 24883),
(24884, '1.10.506.10-FF-000077', NULL, 'Uncharacterized protein', 189, NULL, NULL, 24884),
(24885, '2.70.98.10-FF-000037', NULL, 'LG27/30-like gene', 273, NULL, NULL, 24885),
(24886, '2.30.29.30-FF-000453', NULL, 'Uncharacterized protein, isoform D', 147, NULL, NULL, 24886),
(24887, '3.40.640.10-FF-000458', NULL, 'Uncharacterized protein', 209, NULL, NULL, 24887),
(24888, '3.30.470.30-FF-000043', NULL, 'DNA ligase', 145, NULL, NULL, 24888),
(24889, '3.30.70.330-FF-002124', NULL, NULL, 105, NULL, NULL, 24889),
(24890, '2.20.25.420-FF-000003', NULL, 'zinc finger protein ZPR1', 51, NULL, NULL, 24890),
(24891, '3.40.50.10810-FF-000167', NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily-related, putative', 283, NULL, NULL, 24891),
(24892, '2.60.40.10-FF-005969', NULL, NULL, 106, NULL, NULL, 24892),
(24893, '1.20.120.530-FF-000007', NULL, 'DNA-binding transcriptional regulator CsiR', 145, NULL, NULL, 24893),
(24894, '2.70.170.10-FF-000256', NULL, 'Uncharacterized protein', 193, NULL, NULL, 24894),
(24895, '2.60.120.40-FF-000028', NULL, 'Multimerin 2', 131, NULL, NULL, 24895),
(24896, '3.90.550.10-FF-000373', NULL, 'Predicted protein', 213, NULL, NULL, 24896),
(24897, '3.40.5.10-FF-000020', NULL, 'Plastid ribosomal protein L9', 63, NULL, NULL, 24897),
(24898, '3.90.550.10-FF-000485', NULL, 'Ceramide glucosyltransferase', 184, NULL, NULL, 24898);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(24899, '3.30.450.330-FF-000001', NULL, 'Peptidoglycan D,D-transpeptidase FtsI', 129, NULL, NULL, 24899),
(24900, '3.40.190.10-FF-000581', NULL, 'Oligopeptide ABC transporter periplasmic oligopeptide-binding protein OppA', 216, NULL, NULL, 24900),
(24901, '3.30.565.10-FF-000319', NULL, 'Two-component system sensor histidine kinase', 156, NULL, NULL, 24901),
(24902, '2.60.40.10-FF-001315', NULL, 'Hemicentin 1', 93, NULL, NULL, 24902),
(24903, '1.10.510.10-FF-002324', NULL, NULL, 208, NULL, NULL, 24903),
(24904, '1.25.40.10-FF-005002', NULL, 'Uncharacterized protein', 125, NULL, NULL, 24904),
(24905, '3.90.660.20-FF-000024', NULL, 'Os04g0490000 protein', 26, NULL, NULL, 24905),
(24906, '3.30.70.1450-FF-000049', NULL, 'Transporter, divalent anion:sodium symporter family', 84, NULL, NULL, 24906),
(24907, '1.25.40.990-FF-000053', NULL, 'Predicted protein', 196, NULL, NULL, 24907),
(24908, '2.90.10.10-FF-000048', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase SD1-1', 131, NULL, NULL, 24908),
(24909, '2.70.150.10-FF-000261', NULL, 'Putative phospholipid-transporting ATPase C821.13c', 158, NULL, NULL, 24909),
(24910, '2.30.42.10-FF-000225', NULL, 'AHNAK2 isoform 1', 107, NULL, NULL, 24910),
(24911, '3.30.1360.10-FF-000062', NULL, 'RNApolymerase 14 kDa subunit', 99, NULL, NULL, 24911),
(24912, '1.10.510.10-FF-004448', NULL, NULL, 40, NULL, NULL, 24912),
(24913, '2.20.70.10-FF-000178', NULL, 'Histone-lysine N-methyltransferase', 31, NULL, NULL, 24913),
(24914, '2.60.120.200-FF-000230', NULL, 'Agrin', 168, NULL, NULL, 24914),
(24915, '3.30.420.40-FF-000661', NULL, 'Actin-related protein 3', 32, NULL, NULL, 24915),
(24916, '3.40.630.10-FF-000014', NULL, 'Cytosolic non-specific dipeptidase', 264, NULL, NULL, 24916),
(24917, '1.50.40.10-FF-000498', NULL, 'Uncharacterized mitochondrial carrier C1604.04', 267, NULL, NULL, 24917),
(24918, '2.40.10.10-FF-000685', NULL, NULL, 49, NULL, NULL, 24918),
(24919, '3.30.70.340-FF-000036', NULL, NULL, 92, NULL, NULL, 24919),
(24920, '3.30.50.10-FF-000202', NULL, 'E78 nuclear receptor', 48, NULL, NULL, 24920),
(24921, '3.30.450.40-FF-000163', NULL, 'PAS/PAC sensor-containing diguanylate cyclase/phosphodiesterase', 177, NULL, NULL, 24921),
(24922, '1.25.40.10-FF-004434', NULL, 'Anaphase-promoting complex subunit 8', 122, NULL, NULL, 24922),
(24923, '1.10.340.30-FF-000068', NULL, 'Endonuclease III homolog', 74, NULL, NULL, 24923),
(24924, '3.40.228.10-FF-000023', NULL, 'Oxidoreductase', 215, NULL, NULL, 24924),
(24925, '1.10.10.10-FF-001897', NULL, 'Uncharacterized protein', 118, NULL, NULL, 24925),
(24926, '3.60.15.10-FF-000215', NULL, 'Uncharacterized protein', 352, NULL, NULL, 24926),
(24927, '3.40.50.300-FF-003244', NULL, 'Si:dkey-120c6.5', 206, NULL, NULL, 24927),
(24928, '3.30.160.20-FF-000230', NULL, 'Double-strand-specific pac1 ribonuclease', 78, NULL, NULL, 24928),
(24929, '2.60.40.10-FF-004446', NULL, NULL, 115, NULL, NULL, 24929),
(24930, '1.25.40.730-FF-000003', NULL, 'Clathrin heavy chain', 97, NULL, NULL, 24930),
(24931, '1.10.472.10-FF-000256', NULL, 'Cyclin A3, putative', 124, NULL, NULL, 24931),
(24932, '3.30.160.60-FF-002546', NULL, 'Uncharacterized protein, isoform B', 78, NULL, NULL, 24932),
(24933, '3.80.10.10-FF-001423', NULL, 'Leucine rich repeat containing 39', 242, NULL, NULL, 24933),
(24934, '2.10.25.10-FF-000012', NULL, 'Delta-like protein', 38, NULL, NULL, 24934),
(24935, '2.60.200.20-FF-000169', NULL, 'Serine phosphatase RsbU, regulator of sigma subunit', 103, NULL, NULL, 24935),
(24936, '3.40.1230.10-FF-000011', NULL, 'Uncharacterized protein', 171, NULL, NULL, 24936),
(24937, '3.40.50.300-FF-004379', NULL, 'Dethiobiotin synthase', 209, NULL, NULL, 24937),
(24938, '3.20.20.70-FF-000786', NULL, NULL, 64, NULL, NULL, 24938),
(24939, '3.40.50.1240-FF-000203', NULL, NULL, 61, NULL, NULL, 24939),
(24940, '3.20.20.300-FF-000050', NULL, 'Beta-n-acetylglucosaminidase, putative', 352, NULL, NULL, 24940),
(24941, '3.40.50.1820-FF-001692', NULL, 'Uncharacterized protein', 198, NULL, NULL, 24941),
(24942, '1.25.40.90-FF-000023', NULL, 'polyadenylation and cleavage factor homolog 4', 129, NULL, NULL, 24942);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(24943, '2.130.10.10-FF-003064', NULL, 'WD repeat-containing protein 55', 132, NULL, NULL, 24943),
(24944, '1.10.555.10-FF-000168', NULL, NULL, 128, NULL, NULL, 24944),
(24945, '2.10.25.10-FF-000597', NULL, 'Delta/notch-like EGF repeat containing', 38, NULL, NULL, 24945),
(24946, '3.40.50.720-FF-001189', NULL, 'Uncharacterized protein', 164, NULL, NULL, 24946),
(24947, '3.30.710.10-FF-000040', NULL, 'RCC1 and BTB domain-containing protein 2 isoform X1', 111, NULL, NULL, 24947),
(24948, '2.60.120.200-FF-000281', NULL, 'Uncharacterized protein, isoform B', 163, NULL, NULL, 24948),
(24949, '3.40.50.300-FF-000664', NULL, 'Uncharacterized protein, isoform B', 171, NULL, NULL, 24949),
(24950, '3.30.70.100-FF-000195', NULL, NULL, 112, NULL, NULL, 24950),
(24951, '1.10.10.10-FF-000391', NULL, 'Central glycolytic genes regulator', 73, NULL, NULL, 24951),
(24952, '1.10.150.20-FF-000202', NULL, 'Nucleotide excision repair protein', 56, NULL, NULL, 24952),
(24953, '2.60.40.1180-FF-000198', NULL, 'Uncharacterized protein', 80, NULL, NULL, 24953),
(24954, '3.40.50.720-FF-002032', NULL, 'Uncharacterized protein', 192, NULL, NULL, 24954),
(24955, '2.60.40.820-FF-000036', NULL, 'transcription factor protein', 195, NULL, NULL, 24955),
(24956, '3.40.30.10-FF-001252', NULL, 'Predicted protein', 150, NULL, NULL, 24956),
(24957, '3.40.630.10-FF-000065', NULL, 'Transferrin receptor 1b', 277, NULL, NULL, 24957),
(24958, '2.40.50.90-FF-000031', NULL, 'Tudor domain-containing protein 6', 78, NULL, NULL, 24958),
(24959, '3.40.50.300-FF-002755', NULL, 'ATP-dependent dethiobiotin synthetase BioD', 199, NULL, NULL, 24959),
(24960, '3.50.50.60-FF-000188', NULL, 'Prenylcysteine oxidase 1 like', 38, NULL, NULL, 24960),
(24961, '3.90.180.10-FF-000153', NULL, 'Putative oxidoreductase', 160, NULL, NULL, 24961),
(24962, '2.130.10.10-FF-002075', NULL, '57.7 kDa trp-asp repeats containing protein, putative', 111, NULL, NULL, 24962),
(24963, '3.50.50.60-FF-000413', NULL, 'Phytoene desaturase (lycopene-forming)', 121, NULL, NULL, 24963),
(24964, '1.10.238.10-FF-000375', NULL, 'EF-hand domain-containing family member C2', 157, NULL, NULL, 24964),
(24965, '1.10.150.50-FF-000003', NULL, 'liprin-alpha-2 isoform X1', 135, NULL, NULL, 24965),
(24966, '2.30.18.10-FF-000006', NULL, 'Transcription factor TFIIA complex subunit Toa1', 58, NULL, NULL, 24966),
(24967, '3.20.20.80-FF-000789', NULL, 'Glucosidase, alpha; acid (Pompe disease, glycogen storage disease type II)', 186, NULL, NULL, 24967),
(24968, '3.30.70.330-FF-002450', NULL, NULL, 85, NULL, NULL, 24968),
(24969, '3.30.497.10-FF-000183', NULL, 'Serpin-Z1', 105, NULL, NULL, 24969),
(24970, '3.40.30.10-FF-000358', NULL, 'Protein disulfide-isomerase', 122, NULL, NULL, 24970),
(24971, '1.10.150.60-FF-000006', NULL, 'AT-rich interactive domain-containing protein 3A', 125, NULL, NULL, 24971),
(24972, '1.20.1070.10-FF-001932', NULL, 'Uncharacterized protein', 267, NULL, NULL, 24972),
(24973, '3.40.50.150-FF-000776', NULL, 'Methyltransferase like 15', 89, NULL, NULL, 24973),
(24974, '3.40.190.10-FF-000081', NULL, 'HTH-type transcriptional regulator LeuO', 98, NULL, NULL, 24974),
(24975, '3.30.1370.10-FF-000001', NULL, 'Polyribonucleotide nucleotidyltransferase', 69, NULL, NULL, 24975),
(24976, '3.30.70.330-FF-000084', NULL, 'Serine/arginine-rich splicing factor 11 isoform 1', 79, NULL, NULL, 24976),
(24977, '3.30.160.60-FF-002597', NULL, 'Zinc finger protein 263', 30, NULL, NULL, 24977),
(24978, '3.40.50.1370-FF-000051', NULL, NULL, 65, NULL, NULL, 24978),
(24979, '1.20.1310.30-FF-000001', NULL, 'Exocyst complex component EXO70', 168, NULL, NULL, 24979),
(24980, '3.30.420.150-FF-000019', NULL, 'Nucleoside triphosphate diphosphohydrolase', 270, NULL, NULL, 24980),
(24981, '3.30.420.40-FF-000386', NULL, 'Actin, putative', 159, NULL, NULL, 24981),
(24982, '3.40.50.2000-FF-000414', NULL, 'Autotransporter strand-loop-strand O-heptosyltransferase', 182, NULL, NULL, 24982),
(24983, '3.10.20.70-FF-000034', NULL, 'Glutamine synthetase III', 96, NULL, NULL, 24983),
(24984, '3.30.70.330-FF-000145', NULL, 'Putative RNP domain-containing protein', 82, NULL, NULL, 24984);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(24985, '3.40.50.10810-FF-000229', NULL, 'Type III restriction enzyme, res subunit family protein', 263, NULL, NULL, 24985),
(24986, '2.130.10.10-FF-004166', NULL, 'Uncharacterized protein', 169, NULL, NULL, 24986),
(24987, '1.25.40.820-FF-000030', NULL, 'Uncharacterized protein', 182, NULL, NULL, 24987),
(24988, '1.25.40.10-FF-004159', NULL, 'Uncharacterized protein', 105, NULL, NULL, 24988),
(24989, '1.20.1560.10-FF-000154', NULL, 'HAlF transporter (PGP related)', 270, NULL, NULL, 24989),
(24990, '3.30.160.60-FF-001411', NULL, 'insulinoma-associated protein 2', 93, NULL, NULL, 24990),
(24991, '3.30.780.10-FF-000021', NULL, 'Density-regulated protein related to translation initiation factor 1', 85, NULL, NULL, 24991),
(24992, '1.10.510.10-FF-000733', NULL, 'serine/threonine-protein kinase 16 isoform X2', 85, NULL, NULL, 24992),
(24993, '3.40.1090.10-FF-000134', NULL, 'Probable triacylglycerol lipase C1450.16c', 102, NULL, NULL, 24993),
(24994, '3.10.20.90-FF-000399', NULL, 'Ubiquitin-like domain-containing CTD phosphatase 1', 81, NULL, NULL, 24994),
(24995, '3.30.420.140-FF-000016', NULL, 'Transcription elongation factor spt6', 175, NULL, NULL, 24995),
(24996, '1.10.420.10-FF-000063', NULL, 'Uncharacterized protein', 141, NULL, NULL, 24996),
(24997, '2.40.10.10-FF-000634', NULL, NULL, 254, NULL, NULL, 24997),
(24998, '1.10.510.10-FF-002824', NULL, NULL, 119, NULL, NULL, 24998),
(24999, '3.30.60.60-FF-000021', NULL, 'K(lysine) acetyltransferase 7a', 42, NULL, NULL, 24999),
(25000, '1.25.40.10-FF-004013', NULL, 'Regulator of microtubule dynamics protein 2', 335, NULL, NULL, 25000),
(25001, '3.30.200.20-FF-000638', NULL, 'serine/threonine-protein kinase-like protein ACR4', 112, NULL, NULL, 25001),
(25002, '1.25.40.20-FF-001183', NULL, 'Ion channel NompC', 106, NULL, NULL, 25002),
(25003, '1.20.1250.20-FF-001533', NULL, 'D-xylose-proton symporter', 444, NULL, NULL, 25003),
(25004, '3.40.50.300-FF-004604', NULL, 'Superfamily I DNA and/or RNA helicase', 114, NULL, NULL, 25004),
(25005, '3.40.630.10-FF-000452', NULL, 'Carboxypeptidase A', 160, NULL, NULL, 25005),
(25006, '2.40.30.170-FF-000074', NULL, NULL, 75, NULL, NULL, 25006),
(25007, '3.10.20.90-FF-000427', NULL, 'Putative Polyubiquitin-C', 65, NULL, NULL, 25007),
(25008, '1.10.1820.10-FF-000025', NULL, 'Casein kinase II subunit beta', 96, NULL, NULL, 25008),
(25009, '2.130.10.10-FF-000158', NULL, 'Kinesin family member 21A', 132, NULL, NULL, 25009),
(25010, '1.20.120.430-FF-000028', NULL, 'tRNA modification GTPase trmE', 95, NULL, NULL, 25010),
(25011, '3.90.1150.10-FF-000375', NULL, 'Ornithine aminotransferase', 47, NULL, NULL, 25011),
(25012, '2.40.170.20-FF-000070', NULL, 'TonB-dependent receptor', 655, NULL, NULL, 25012),
(25013, '3.40.50.1820-FF-000017', NULL, 'Abhydrolase domain containing 8', 260, NULL, NULL, 25013),
(25014, '3.90.550.10-FF-000047', NULL, 'Glucans biosynthesis glucosyltransferase H', 232, NULL, NULL, 25014),
(25015, '3.30.160.60-FF-000394', NULL, 'Zinc finger protein 836', 28, NULL, NULL, 25015),
(25016, '4.10.80.160-FF-000001', NULL, 'Nonsense-mediated mRNA decay factor (Upf2)', 31, NULL, NULL, 25016),
(25017, '2.40.50.90-FF-000110', NULL, 'Transcription factor, Tudor domain, putative', 94, NULL, NULL, 25017),
(25018, '2.60.120.650-FF-000067', NULL, 'Uncharacterized protein, isoform A', 292, NULL, NULL, 25018),
(25019, '3.40.50.1780-FF-000016', NULL, 'Iron hydrogenase, putative', 123, NULL, NULL, 25019),
(25020, '1.10.8.1080-FF-000005', NULL, 'Predicted protein', 80, NULL, NULL, 25020),
(25021, '3.30.70.330-FF-000533', NULL, 'Chromosome 16, whole genome shotgun sequence', 75, NULL, NULL, 25021),
(25022, '1.20.144.10-FF-000054', NULL, 'Related to AUR1-inositol phosphorylceramide synthase', 100, NULL, NULL, 25022),
(25023, '3.10.110.10-FF-000285', NULL, 'Ubiquitin-conjugating enzyme E2 J1-like Protein', 183, NULL, NULL, 25023),
(25024, '3.30.420.40-FF-000509', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', 145, NULL, NULL, 25024),
(25025, '2.30.180.10-FF-000176', NULL, NULL, 141, NULL, NULL, 25025),
(25026, '3.40.630.30-FF-000458', NULL, 'Alpha-tubulin N-acetyltransferase', 179, NULL, NULL, 25026);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(25027, '3.30.450.30-FF-000008', NULL, 'Profilin', 138, NULL, NULL, 25027),
(25028, '3.40.50.980-FF-000053', NULL, 'Enniatin synthase', 95, NULL, NULL, 25028),
(25029, '3.30.420.40-FF-000739', NULL, 'Actin5-3 (Actin-related protein 1-3)', 109, NULL, NULL, 25029),
(25030, '3.40.50.620-FF-000024', NULL, 'Tryptophan--tRNA ligase', 211, NULL, NULL, 25030),
(25031, '3.30.2160.10-FF-000081', NULL, 'Uncharacterized protein', 99, NULL, NULL, 25031),
(25032, '2.40.70.10-FF-000138', NULL, 'Aspartic protease 3', 217, NULL, NULL, 25032),
(25033, '3.90.1410.10-FF-000148', NULL, 'Predicted protein', 364, NULL, NULL, 25033),
(25034, '3.40.190.10-FF-000176', NULL, 'Ionotropic receptor 25a', 37, NULL, NULL, 25034),
(25035, '3.40.50.720-FF-000115', NULL, '3-oxoacyl-[acyl-carrier-protein] reductase FabG', 246, NULL, NULL, 25035),
(25036, '4.10.640.10-FF-000006', NULL, '30S ribosomal protein S18', 78, NULL, NULL, 25036),
(25037, '3.40.50.620-FF-000203', NULL, 'Leucine--tRNA ligase, putative', 65, NULL, NULL, 25037),
(25038, '3.90.70.10-FF-000774', NULL, 'Uncharacterized protein', 54, NULL, NULL, 25038),
(25039, '2.40.30.10-FF-000517', NULL, 'Uncharacterized protein', 114, NULL, NULL, 25039),
(25040, '3.90.70.10-FF-000482', NULL, 'AGAP000269-PA', 382, NULL, NULL, 25040),
(25041, '3.40.140.10-FF-000139', NULL, 'Cytidine deaminase-like protein', 170, NULL, NULL, 25041),
(25042, '1.10.533.10-FF-000218', NULL, 'Ankyrin-3', 96, NULL, NULL, 25042),
(25043, '3.40.50.2300-FF-000274', NULL, 'Low molecular weight phosphotyrosine protein phosphatase', 157, NULL, NULL, 25043),
(25044, '2.60.40.10-FF-003957', NULL, NULL, 104, NULL, NULL, 25044),
(25045, '3.90.550.10-FF-000098', NULL, 'xyloside xylosyltransferase 1', 280, NULL, NULL, 25045),
(25046, '3.30.160.60-FF-000629', NULL, 'zinc finger protein 333 isoform X1', 28, NULL, NULL, 25046),
(25047, '3.30.70.330-FF-001668', NULL, NULL, 72, NULL, NULL, 25047),
(25048, '3.30.160.60-FF-004963', NULL, NULL, 70, NULL, NULL, 25048),
(25049, '2.20.25.160-FF-000003', NULL, 'Probable aspartoacylase', 46, NULL, NULL, 25049),
(25050, '3.40.50.970-FF-000050', NULL, '2-hydroxyacyl-CoA lyase', 182, NULL, NULL, 25050),
(25051, '3.40.190.10-FF-000530', NULL, 'Phosphate-binding protein PstS 1', 125, NULL, NULL, 25051),
(25052, '3.30.260.10-FF-000111', NULL, NULL, 25, NULL, NULL, 25052),
(25053, '3.40.30.10-FF-000796', NULL, 'Sulfhydryl oxidase', 179, NULL, NULL, 25053),
(25054, '1.20.1730.10-FF-000100', NULL, 'Uncharacterized protein', 245, NULL, NULL, 25054),
(25055, '1.10.1330.10-FF-000004', NULL, 'Alkaline phosphatase', 60, NULL, NULL, 25055),
(25056, '3.40.50.300-FF-002693', NULL, 'Predicted protein', 219, NULL, NULL, 25056),
(25057, '3.30.565.10-FF-000550', NULL, 'Uncharacterized protein', 113, NULL, NULL, 25057),
(25058, '3.40.190.10-FF-000822', NULL, 'Uncharacterized protein', 56, NULL, NULL, 25058),
(25059, '3.30.110.110-FF-000005', NULL, 'Double-strand break repair protein MRE11', 113, NULL, NULL, 25059),
(25060, '2.130.10.10-FF-004492', NULL, 'Uncharacterized protein', 98, NULL, NULL, 25060),
(25061, '2.10.109.10-FF-000021', NULL, 'Signal peptidase I', 114, NULL, NULL, 25061),
(25062, '3.60.21.10-FF-000387', NULL, 'Uncharacterized protein', 69, NULL, NULL, 25062),
(25063, '3.30.70.330-FF-001994', NULL, NULL, 183, NULL, NULL, 25063),
(25064, '1.10.10.60-FF-000439', NULL, 'Cramped chromatin regulator homolog 1', 78, NULL, NULL, 25064),
(25065, '3.30.420.10-FF-000500', NULL, NULL, 64, NULL, NULL, 25065),
(25066, '2.40.30.170-FF-000023', NULL, 'HAE1 family efflux pump MFP component', 69, NULL, NULL, 25066),
(25067, '3.40.1260.10-FF-000013', NULL, 'Intracellular sulfur oxidation protein DsrH', 101, NULL, NULL, 25067),
(25068, '3.80.10.10-FF-003609', NULL, 'Uncharacterized protein', 197, NULL, NULL, 25068),
(25069, '1.10.472.30-FF-000003', NULL, 'Transcription elongation factor S-II', 108, NULL, NULL, 25069),
(25070, '3.40.50.300-FF-004879', NULL, 'Putative ATP-dependent RNA helicase rha-2', 142, NULL, NULL, 25070),
(25071, '3.40.50.11610-FF-000019', NULL, 'Alpha-ketoglutarate dehydrogenase E1', 153, NULL, NULL, 25071);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(25072, '2.130.10.10-FF-002187', NULL, 'DDB1 and CUL4 associated factor 11', 128, NULL, NULL, 25072),
(25073, '4.10.400.10-FF-000354', NULL, 'SCO-spondin', 28, NULL, NULL, 25073),
(25074, '1.10.510.10-FF-004241', NULL, NULL, 200, NULL, NULL, 25074),
(25075, '3.30.70.330-FF-002562', NULL, NULL, 147, NULL, NULL, 25075),
(25076, '1.10.510.10-FF-003959', NULL, NULL, 49, NULL, NULL, 25076),
(25077, '3.30.160.60-FF-002193', NULL, 'Unplaced genomic scaffold supercont1.32, whole genome shotgun sequence', 34, NULL, NULL, 25077),
(25078, '3.30.70.1350-FF-000019', NULL, 'Cation diffusion facilitator family transporter', 81, NULL, NULL, 25078),
(25079, '1.10.150.120-FF-000022', NULL, NULL, 99, NULL, NULL, 25079),
(25080, '1.10.510.10-FF-000475', NULL, 'Calcium-dependent protein kinase 5', 194, NULL, NULL, 25080),
(25081, '2.40.10.10-FF-000067', NULL, 'Complement C1s subcomponent', 134, NULL, NULL, 25081),
(25082, '2.60.40.4100-FF-000023', NULL, 'Uncharacterized protein', 121, NULL, NULL, 25082),
(25083, '2.60.40.150-FF-000728', NULL, 'Phosphoinositide phospholipase C', 114, NULL, NULL, 25083),
(25084, '1.10.132.60-FF-000026', NULL, 'DNA polymerase', 59, NULL, NULL, 25084),
(25085, '4.10.1000.10-FF-000101', NULL, 'Uncharacterized protein', 63, NULL, NULL, 25085),
(25086, '3.30.450.20-FF-000005', NULL, 'Hypoxia-inducible factor 1 subunit alpha', 143, NULL, NULL, 25086),
(25087, '3.40.50.2000-FF-000302', NULL, 'Glycosyltransferase', 242, NULL, NULL, 25087),
(25088, '3.30.870.10-FF-000045', NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', 232, NULL, NULL, 25088),
(25089, '3.30.160.60-FF-003440', NULL, 'Zinc finger protein 749', 24, NULL, NULL, 25089),
(25090, '3.30.40.10-FF-000151', NULL, 'Zinc finger family protein', 83, NULL, NULL, 25090),
(25091, '3.90.1150.10-FF-000083', NULL, 'O-acetylhomoserine sulfhydrylase', 146, NULL, NULL, 25091),
(25092, '2.120.10.30-FF-000131', NULL, 'NHL repeat containing E3 ubiquitin protein ligase 1', 145, NULL, NULL, 25092),
(25093, '3.40.50.300-FF-001232', NULL, 'Erythrocyte membrane-associated antigen, putative', 213, NULL, NULL, 25093),
(25094, '1.10.10.60-FF-000198', NULL, 'MYB transcription factor', 48, NULL, NULL, 25094),
(25095, '1.20.920.10-FF-000211', NULL, 'Uncharacterized protein', 106, NULL, NULL, 25095),
(25096, '1.10.8.60-FF-000011', NULL, 'ATP-dependent Clp protease ATP-binding subunit', 86, NULL, NULL, 25096),
(25097, '1.10.490.10-FF-000011', NULL, 'Nitric oxide dioxygenase (Pi-NOD1)', 155, NULL, NULL, 25097),
(25098, '3.40.50.620-FF-000254', NULL, 'Probable nicotinate-nucleotide adenylyltransferase', 201, NULL, NULL, 25098),
(25099, '3.10.20.90-FF-000753', NULL, 'Phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit alpha-like protein', 147, NULL, NULL, 25099),
(25100, '3.30.70.330-FF-000207', NULL, 'RNA-binding region (RNP1, RRM)-containing 3', 94, NULL, NULL, 25100),
(25101, '2.60.120.200-FF-000522', NULL, 'Emp46p', 215, NULL, NULL, 25101),
(25102, '2.60.40.10-FF-004800', NULL, NULL, 108, NULL, NULL, 25102),
(25103, '2.60.120.260-FF-000607', NULL, 'Uncharacterized protein', 143, NULL, NULL, 25103),
(25104, '1.10.150.20-FF-000253', NULL, 'YALI0C01573p', 61, NULL, NULL, 25104),
(25105, '1.10.287.110-FF-000193', NULL, 'Chaperone protein DNAJ, putative', 67, NULL, NULL, 25105),
(25106, '2.10.25.10-FF-001586', NULL, 'Uncharacterized protein', 39, NULL, NULL, 25106),
(25107, '3.90.550.10-FF-000659', NULL, 'Uncharacterized protein', 124, NULL, NULL, 25107),
(25108, '3.30.710.10-FF-000270', NULL, 'S-phase kinase-associated protein 1', 163, NULL, NULL, 25108),
(25109, '2.40.70.10-FF-000582', NULL, NULL, 83, NULL, NULL, 25109),
(25110, '3.30.160.60-FF-000068', NULL, 'GLI family zinc finger 3', 33, NULL, NULL, 25110),
(25111, '3.40.50.1820-FF-001866', NULL, 'Uncharacterized protein', 481, NULL, NULL, 25111),
(25112, '2.60.40.60-FF-000785', NULL, 'Pcdhgb1 protein', 100, NULL, NULL, 25112),
(25113, '3.90.70.10-FF-000156', NULL, 'UBP6p Ubiquitin-specific protease', 319, NULL, NULL, 25113),
(25114, '2.60.40.1510-FF-000016', NULL, 'Integrin subunit alpha 1', 140, NULL, NULL, 25114);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(25115, '2.40.70.10-FF-000290', NULL, NULL, 119, NULL, NULL, 25115),
(25116, '3.40.50.300-FF-002367', NULL, 'Putative DNA helicase', 248, NULL, NULL, 25116),
(25117, '3.10.20.30-FF-000084', NULL, NULL, 18, NULL, NULL, 25117),
(25118, '1.10.8.60-FF-000399', NULL, 'Uncharacterized protein', 58, NULL, NULL, 25118),
(25119, '3.30.160.60-FF-005969', NULL, NULL, 72, NULL, NULL, 25119),
(25120, '2.60.120.1540-FF-000019', NULL, 'Uncharacterized protein', 109, NULL, NULL, 25120),
(25121, '2.10.25.10-FF-000304', NULL, 'Integrin beta', 39, NULL, NULL, 25121),
(25122, '3.10.100.10-FF-000228', NULL, 'Lymphocyte antigen 75', 142, NULL, NULL, 25122),
(25123, '3.40.50.300-FF-000956', NULL, 'Midasin', 210, NULL, NULL, 25123),
(25124, '3.30.565.10-FF-000145', NULL, 'Two-component sensor histidine kinase', 144, NULL, NULL, 25124),
(25125, '3.30.470.20-FF-000214', NULL, 'Glutathione synthetase', 105, NULL, NULL, 25125),
(25126, '1.10.20.10-FF-000329', NULL, NULL, 121, NULL, NULL, 25126),
(25127, '3.30.160.60-FF-000955', NULL, 'Zinc finger and SCAN domain-containing protein 21', 30, NULL, NULL, 25127),
(25128, '3.90.640.10-FF-000200', NULL, 'Uncharacterized protein', 36, NULL, NULL, 25128),
(25129, '1.20.1070.10-FF-000004', NULL, 'Olfactory receptor', 290, NULL, NULL, 25129),
(25130, '1.10.510.10-FF-001290', NULL, 'Protein kinase domain containing protein', 282, NULL, NULL, 25130),
(25131, '2.60.40.2880-FF-000005', NULL, 'Probable transport accessory protein MmpS2', 89, NULL, NULL, 25131),
(25132, '3.30.470.20-FF-000091', NULL, 'D-alanine--D-alanine ligase', 151, NULL, NULL, 25132),
(25133, '1.25.40.10-FF-003203', NULL, 'Pentatricopeptide repeat-containing protein', 88, NULL, NULL, 25133),
(25134, '1.20.1280.50-FF-000268', NULL, 'Uncharacterized protein', 46, NULL, NULL, 25134),
(25135, '2.30.29.30-FF-000127', NULL, 'Neuronal guanine nucleotide exchange factor', 124, NULL, NULL, 25135),
(25136, '2.30.30.40-FF-000252', NULL, 'HECT domain and RCC1 family domain containing protein', 76, NULL, NULL, 25136),
(25137, '3.90.1150.210-FF-000030', NULL, 'F-actin-capping protein subunit beta', 55, NULL, NULL, 25137),
(25138, '1.20.1050.10-FF-000121', NULL, 'Glutathione S-transferase parC, putative, expressed', 37, NULL, NULL, 25138),
(25139, '3.40.50.2000-FF-000740', NULL, 'UDP-glucose iridoid glucosyltransferase-like isoform X1', 250, NULL, NULL, 25139),
(25140, '3.30.450.150-FF-000003', NULL, 'UPF0303 protein YPTS_2661', 156, NULL, NULL, 25140),
(25141, '3.40.366.10-FF-000017', NULL, 'Non-reducing polyketide synthase aptA', 190, NULL, NULL, 25141),
(25142, '3.40.50.1000-FF-000491', NULL, NULL, 92, NULL, NULL, 25142),
(25143, '3.30.470.30-FF-000094', NULL, 'Uncharacterized protein', 249, NULL, NULL, 25143),
(25144, '1.10.418.60-FF-000022', NULL, 'Uncharacterized protein', 154, NULL, NULL, 25144),
(25145, '1.10.287.70-FF-000152', NULL, 'Small conductance calcium-activated potassium channel protein 2', 48, NULL, NULL, 25145),
(25146, '1.10.10.60-FF-000147', NULL, 'GS homeobox 2', 91, NULL, NULL, 25146),
(25147, '3.30.450.20-FF-000331', NULL, 'Hybrid signal transduction histidine', 89, NULL, NULL, 25147),
(25148, '3.40.50.300-FF-006296', NULL, 'DEAD/DEAH box helicase domain protein', 218, NULL, NULL, 25148),
(25149, '1.20.58.1880-FF-000001', NULL, 'REST corepressor 1', 133, NULL, NULL, 25149),
(25150, '3.40.50.300-FF-000776', NULL, 'Guanylate kinase 2', 194, NULL, NULL, 25150),
(25151, '2.60.120.650-FF-000016', NULL, 'Lysine-specific demethylase isoform A', 350, NULL, NULL, 25151),
(25152, '1.25.40.10-FF-002714', NULL, 'Uncharacterized protein', 54, NULL, NULL, 25152),
(25153, '3.30.420.40-FF-000835', NULL, 'Phosphotransferase', 19, NULL, NULL, 25153),
(25154, '3.30.565.10-FF-000196', NULL, 'Sensory box sensor histidine kinase', 159, NULL, NULL, 25154),
(25155, '1.20.58.1930-FF-000005', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 233, NULL, NULL, 25155),
(25156, '3.30.505.10-FF-000248', NULL, NULL, 56, NULL, NULL, 25156),
(25157, '3.30.1380.10-FF-000007', NULL, 'Sonic hedgehog', 110, NULL, NULL, 25157),
(25158, '1.25.40.10-FF-003996', NULL, 'Uncharacterized protein', 210, NULL, NULL, 25158); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(25159, '3.30.420.110-FF-000069', NULL, 'Predicted protein', 143, NULL, NULL, 25159),
(25160, '2.40.10.10-FF-000393', NULL, 'LP05421p', 200, NULL, NULL, 25160),
(25161, '2.60.40.10-FF-003114', NULL, 'Plexin B, isoform B', 140, NULL, NULL, 25161),
(25162, '1.20.120.80-FF-000019', NULL, 'Cytochrome C oxidase subunit I /III', 185, NULL, NULL, 25162),
(25163, '2.170.130.10-FF-000005', NULL, 'Ferrienterobactin outer membrane receptor', 145, NULL, NULL, 25163),
(25164, '3.90.290.10-FF-000009', NULL, 'Fibrillin 2', 70, NULL, NULL, 25164),
(25165, '3.30.1370.50-FF-000001', NULL, 'R3H domain-containing protein 2 isoform 1', 124, NULL, NULL, 25165),
(25166, '1.20.58.2050-FF-000002', NULL, 'DNA replication complex GINS protein PSF3 isoform X2', 54, NULL, NULL, 25166),
(25167, '3.90.470.20-FF-000049', NULL, 'Probable phosphopantetheinyltransferase', 88, NULL, NULL, 25167),
(25168, '3.30.70.2760-FF-000009', NULL, NULL, 107, NULL, NULL, 25168),
(25169, '2.60.40.60-FF-000734', NULL, 'Cadherin-4', 112, NULL, NULL, 25169),
(25170, '2.160.20.10-FF-000056', NULL, 'Pectin lyase-like superfamily protein', 376, NULL, NULL, 25170),
(25171, '1.10.287.1490-FF-000096', NULL, 'Uncharacterized protein', 186, NULL, NULL, 25171),
(25172, '1.10.10.60-FF-001041', NULL, NULL, 75, NULL, NULL, 25172),
(25173, '2.130.10.10-FF-005498', NULL, 'WD repeat domain 90', 111, NULL, NULL, 25173),
(25174, '3.80.10.10-FF-003761', NULL, 'Uncharacterized protein', 117, NULL, NULL, 25174),
(25175, '3.40.50.880-FF-000135', NULL, 'Imidazole glycerol phosphate synthase subunit HisH', 212, NULL, NULL, 25175),
(25176, '3.30.1370.60-FF-000004', NULL, 'Ureidoglycolate dehydrogenase', 239, NULL, NULL, 25176),
(25177, '1.10.10.60-FF-000765', NULL, NULL, 51, NULL, NULL, 25177),
(25178, '1.25.40.20-FF-000840', NULL, 'Oxysterol-binding protein', 88, NULL, NULL, 25178),
(25179, '1.10.1900.10-FF-000026', NULL, 'Chromosome 8, whole genome shotgun sequence', 55, NULL, NULL, 25179),
(25180, '2.120.10.30-FF-000182', NULL, 'DPP6 amino-terminal domain protein', 176, NULL, NULL, 25180),
(25181, '3.40.50.300-FF-002985', NULL, 'ClpB protein', 195, NULL, NULL, 25181),
(25182, '3.10.120.10-FF-000050', NULL, 'Putative nitrate reductase', 92, NULL, NULL, 25182),
(25183, '1.20.120.1350-FF-000002', NULL, 'Zinc finger CCCH domain-containing protein 46', 73, NULL, NULL, 25183),
(25184, '3.40.50.300-FF-005161', NULL, 'ABC transporter ATP-binding protein', 225, NULL, NULL, 25184),
(25185, '4.10.60.10-FF-000089', NULL, 'RNA-binding protein lark', 35, NULL, NULL, 25185),
(25186, '3.40.50.720-FF-000166', NULL, 'Glutathione-independent formaldehyde dehydrogenase', 167, NULL, NULL, 25186),
(25187, '1.10.238.10-FF-000549', NULL, 'Calpain 12', 158, NULL, NULL, 25187),
(25188, '1.10.3480.10-FF-000004', NULL, 'Nitrate reductase molybdenum cofactor assembly chaperone', 164, NULL, NULL, 25188),
(25189, '3.30.70.330-FF-001022', NULL, 'Uncharacterized protein, isoform C', 88, NULL, NULL, 25189),
(25190, '1.20.272.10-FF-000042', NULL, 'DNA polymerase III subunit gamma/tau', 120, NULL, NULL, 25190),
(25191, '2.30.30.40-FF-000555', NULL, 'Putative truncated guanine nucleotide exchange factor YLL017W', 99, NULL, NULL, 25191),
(25192, '1.10.238.10-FF-001038', NULL, 'Uncharacterized protein', 107, NULL, NULL, 25192),
(25193, '3.40.190.10-FF-000255', NULL, 'GLutamate Receptor family (AMPA)', 118, NULL, NULL, 25193),
(25194, '2.130.10.10-FF-000776', NULL, 'mRNA export factor', 361, NULL, NULL, 25194),
(25195, '1.25.10.10-FF-001234', NULL, 'Serine/threonine-protein kinase TOR', 170, NULL, NULL, 25195),
(25196, '3.40.50.150-FF-000708', NULL, 'Os06g0322400 protein', 65, NULL, NULL, 25196),
(25197, '2.40.50.140-FF-000193', NULL, 'Exosome complex exonuclease RRP44 homolog A', 85, NULL, NULL, 25197),
(25198, '3.40.50.300-FF-006521', NULL, 'Uncharacterized protein', 111, NULL, NULL, 25198),
(25199, '1.20.140.40-FF-000071', NULL, NULL, 158, NULL, NULL, 25199),
(25200, '3.90.1600.10-FF-000062', NULL, 'DNA polymerase', 113, NULL, NULL, 25200),
(25201, '3.30.1370.70-FF-000007', NULL, NULL, 56, NULL, NULL, 25201);
INSERT INTO "PUBLIC"."MODEL" VALUES
(25202, '3.60.110.10-FF-000026', NULL, 'Blast:Omega-amidase NIT2', 277, NULL, NULL, 25202),
(25203, '1.10.150.240-FF-000092', NULL, 'Hydrolase haloacid dehalogenase family protein', 70, NULL, NULL, 25203),
(25204, '3.30.2170.10-FF-000019', NULL, NULL, 161, NULL, NULL, 25204),
(25205, '2.60.40.1660-FF-000033', NULL, 'ATPase Na+/K+-transporting subunit beta 3a', 80, NULL, NULL, 25205),
(25206, '2.170.130.20-FF-000008', NULL, 'YIL067C-like protein', 132, NULL, NULL, 25206),
(25207, '3.90.470.10-FF-000046', NULL, 'Uncharacterized protein', 101, NULL, NULL, 25207),
(25208, '3.40.50.80-FF-000043', NULL, 'NADH-cytochrome b5 reductase', 143, NULL, NULL, 25208),
(25209, '2.10.25.10-FF-001535', NULL, 'Delta-like protein', 35, NULL, NULL, 25209),
(25210, '2.130.10.10-FF-002928', NULL, 'Uncharacterized protein', 13, NULL, NULL, 25210),
(25211, '3.40.50.10810-FF-000055', NULL, 'Protein CHROMATIN REMODELING 24', 277, NULL, NULL, 25211),
(25212, '2.130.10.10-FF-001052', NULL, 'Mitochondrial division protein 1', 169, NULL, NULL, 25212),
(25213, '1.25.40.90-FF-000102', NULL, 'Regulation of nuclear pre-mRNA domain-containing 2b', 99, NULL, NULL, 25213),
(25214, '3.30.200.20-FF-000190', NULL, 'Putative cyclin-dependent kinase 7', 95, NULL, NULL, 25214),
(25215, '2.130.10.10-FF-000276', NULL, 'WD repeat-containing protein 91', 163, NULL, NULL, 25215),
(25216, '1.20.5.170-FF-000030', NULL, 'RUN and FYVE domain-containing protein 2 isoform X1', 49, NULL, NULL, 25216),
(25217, '1.10.340.70-FF-000001', NULL, 'Retrovirus-related Pol polyprotein from transposon gypsy-like Protein', 94, NULL, NULL, 25217),
(25218, '3.40.718.10-FF-000010', NULL, '4-hydroxythreonine-4-phosphate dehydrogenase', 328, NULL, NULL, 25218),
(25219, '1.20.1530.20-FF-000094', NULL, 'Uncharacterized protein', 280, NULL, NULL, 25219),
(25220, '2.60.40.10-FF-002940', NULL, 'Immunoglobulin domain-containing protein Y54G2A.25', 106, NULL, NULL, 25220),
(25221, '1.20.1510.10-FF-000090', NULL, NULL, 215, NULL, NULL, 25221),
(25222, '3.30.70.330-FF-000651', NULL, 'Poly(A) binding protein cytoplasmic 1 like', 90, NULL, NULL, 25222),
(25223, '3.90.1800.10-FF-000010', NULL, 'DNA-directed RNA polymerase subunit beta', 127, NULL, NULL, 25223),
(25224, '2.40.50.430-FF-000010', NULL, 'DNA polymerase delta subunit 2, putative', 127, NULL, NULL, 25224),
(25225, '1.25.40.10-FF-002309', NULL, 'Pre-mRNA splicing factor, putative', 112, NULL, NULL, 25225),
(25226, '2.60.40.60-FF-000173', NULL, 'Cadherin 23', 108, NULL, NULL, 25226),
(25227, '1.10.533.10-FF-000095', NULL, 'Predicted protein', 105, NULL, NULL, 25227),
(25228, '1.20.120.320-FF-000001', NULL, 'Pollen allergen Phl p 5b', 107, NULL, NULL, 25228),
(25229, '3.30.40.10-FF-000084', NULL, 'Zinc finger, FYVE domain-containing 9b', 88, NULL, NULL, 25229),
(25230, '1.25.10.10-FF-000571', NULL, 'cullin-associated NEDD8-dissociated protein 2 isoform X3', 74, NULL, NULL, 25230),
(25231, '3.40.50.300-FF-002816', NULL, 'Os03g0282700 protein', 80, NULL, NULL, 25231),
(25232, '3.90.79.10-FF-000243', NULL, 'Hydrolase, NUDIX family protein', 167, NULL, NULL, 25232),
(25233, '3.40.30.10-FF-000919', NULL, 'Uncharacterized protein', 126, NULL, NULL, 25233),
(25234, '3.40.50.2300-FF-000156', NULL, 'DNA-binding response regulator', 81, NULL, NULL, 25234),
(25235, '2.40.10.10-FF-000185', NULL, 'Protease Do-like 5, chloroplastic', 114, NULL, NULL, 25235),
(25236, '3.90.1410.10-FF-000087', NULL, 'Protein-lysine N-methyltransferase', 260, NULL, NULL, 25236),
(25237, '3.40.50.11210-FF-000012', NULL, 'AGAP007925-PA', 113, NULL, NULL, 25237),
(25238, '3.90.170.10-FF-000001', NULL, 'Adenylosuccinate synthetase', 163, NULL, NULL, 25238),
(25239, '3.90.70.10-FF-000662', NULL, 'Uncharacterized protein', 346, NULL, NULL, 25239),
(25240, '1.10.150.240-FF-000120', NULL, '2-phosphoglycolate phosphatase family', 67, NULL, NULL, 25240),
(25241, '2.10.110.10-FF-000154', NULL, 'LIM and senescent cell antigen-like-containing domain protein 1', 63, NULL, NULL, 25241),
(25242, '3.40.50.620-FF-000136', NULL, 'Probable phosphoadenosine phosphosulfate reductase', 250, NULL, NULL, 25242);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(25243, '3.30.420.40-FF-000627', NULL, 'Mitochondrion protein, putative', 47, NULL, NULL, 25243),
(25244, '1.10.3730.10-FF-000013', NULL, 'Uncharacterized protein', 113, NULL, NULL, 25244),
(25245, '3.90.70.10-FF-000605', NULL, 'Uncharacterized protein', 182, NULL, NULL, 25245),
(25246, '1.10.418.10-FF-000018', NULL, 'Neuron navigator 2', 119, NULL, NULL, 25246),
(25247, '3.10.170.10-FF-000002', NULL, 'Elastase', 152, NULL, NULL, 25247),
(25248, '2.70.150.10-FF-000194', NULL, 'Cadmium-transporting ATPase', 119, NULL, NULL, 25248),
(25249, '3.30.60.20-FF-000037', NULL, 'RAS guanyl releasing protein 4', 61, NULL, NULL, 25249),
(25250, '3.30.160.60-FF-000798', NULL, 'zinc finger protein 64 isoform X1', 23, NULL, NULL, 25250),
(25251, '3.50.4.10-FF-000057', NULL, NULL, 68, NULL, NULL, 25251),
(25252, '2.10.25.10-FF-001614', NULL, 'Uncharacterized protein', 53, NULL, NULL, 25252),
(25253, '1.25.40.10-FF-003788', NULL, 'Uncharacterized protein', 148, NULL, NULL, 25253),
(25254, '3.90.650.10-FF-000026', NULL, 'Phosphoribosylformylglycinamidine synthase subunit PurL', 167, NULL, NULL, 25254),
(25255, '3.40.225.10-FF-000050', NULL, NULL, 145, NULL, NULL, 25255),
(25256, '3.30.420.40-FF-000740', NULL, 'Actin family protein', 109, NULL, NULL, 25256),
(25257, '1.20.900.10-FF-000002', NULL, 'Rho guanine nucleotide exchange factor 9', 216, NULL, NULL, 25257),
(25258, '1.25.40.250-FF-000005', NULL, 'Eukaryotic translation initiation factor 3 subunit K', 118, NULL, NULL, 25258),
(25259, '2.30.29.30-FF-001263', NULL, 'pleckstrin homology domain-containing family A member 8 isoform X1', 103, NULL, NULL, 25259),
(25260, '2.130.10.10-FF-004716', NULL, 'Uncharacterized protein', 168, NULL, NULL, 25260),
(25261, '3.40.50.300-FF-004907', NULL, 'Uncharacterized protein', 221, NULL, NULL, 25261),
(25262, '1.25.40.10-FF-003945', NULL, 'Uncharacterized protein', 274, NULL, NULL, 25262),
(25263, '3.30.710.10-FF-000101', NULL, 'kelch-like protein 10 isoform X1', 121, NULL, NULL, 25263),
(25264, '1.20.1530.20-FF-000037', NULL, 'Sodium/hydrogen exchanger', 429, NULL, NULL, 25264),
(25265, '1.10.10.10-FF-000565', NULL, 'RNA polymerase sigma factor SigJ', 53, NULL, NULL, 25265),
(25266, '2.60.40.290-FF-000012', NULL, 'Endo-1,4-beta-xylanase A', 103, NULL, NULL, 25266),
(25267, '1.10.10.60-FF-000265', NULL, 'CASP8-associated protein 2 isoform X1', 69, NULL, NULL, 25267),
(25268, '2.120.10.80-FF-000067', NULL, 'N-acetylneuraminate epimerase', 191, NULL, NULL, 25268),
(25269, '3.30.70.330-FF-002096', NULL, NULL, 123, NULL, NULL, 25269),
(25270, '2.40.10.310-FF-000005', NULL, 'CMV 1a interacting protein 1', 71, NULL, NULL, 25270),
(25271, '1.10.730.10-FF-000047', NULL, 'Arginine-tRNA ligase', 127, NULL, NULL, 25271),
(25272, '1.25.40.240-FF-000002', NULL, 'ATP-dependent DNA helicase II subunit 2', 155, NULL, NULL, 25272),
(25273, '3.40.50.300-FF-002873', NULL, 'PROBABLE ATP-DEPENDENT DNA HELICASE', 107, NULL, NULL, 25273),
(25274, '3.30.830.10-FF-000099', NULL, 'Zn-dependent peptidase, putative', 230, NULL, NULL, 25274),
(25275, '2.60.40.150-FF-000650', NULL, 'Uncharacterized protein', 120, NULL, NULL, 25275),
(25276, '3.20.20.70-FF-000668', NULL, NULL, 218, NULL, NULL, 25276),
(25277, '3.40.50.300-FF-001350', NULL, 'Dynein heavy chain, putative', 167, NULL, NULL, 25277),
(25278, '1.10.3380.30-FF-000014', NULL, 'DExH-box ATP-dependent RNA helicase DExH11', 99, NULL, NULL, 25278),
(25279, '3.40.640.10-FF-000166', NULL, 'Cysteine desulfurase', 271, NULL, NULL, 25279),
(25280, '1.25.10.10-FF-002920', NULL, 'Uncharacterized protein', 106, NULL, NULL, 25280),
(25281, '2.60.40.10-FF-003440', NULL, 'Exo-alpha-sialidase', 104, NULL, NULL, 25281),
(25282, '3.90.440.10-FF-000005', NULL, 'Nitric oxide synthase, inducible', 103, NULL, NULL, 25282),
(25283, '2.10.110.10-FF-000204', NULL, 'LIM homeobox transcription factor 1, alpha', 73, NULL, NULL, 25283),
(25284, '1.10.20.10-FF-000116', NULL, 'Transcription initiation factor TFIID subunit 8', 57, NULL, NULL, 25284),
(25285, '3.30.1390.20-FF-000016', NULL, 'Putative 60S ribosomal protein L7', 73, NULL, NULL, 25285);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(25286, '1.10.10.10-FF-000941', NULL, 'XylR family transcriptional regulator', 65, NULL, NULL, 25286),
(25287, '3.40.850.10-FF-000204', NULL, 'Kinesin motor domain protein', 394, NULL, NULL, 25287),
(25288, '2.40.30.10-FF-000394', NULL, 'Elongation factor-like protein', 102, NULL, NULL, 25288),
(25289, '3.30.60.20-FF-000150', NULL, 'Diacylglycerol kinase', 62, NULL, NULL, 25289),
(25290, '1.10.3380.20-FF-000011', NULL, NULL, 177, NULL, NULL, 25290),
(25291, '1.25.40.10-FF-002635', NULL, 'Response regulator receiver and SARP domain protein', 152, NULL, NULL, 25291),
(25292, '3.80.10.10-FF-003435', NULL, 'Predicted protein', 64, NULL, NULL, 25292),
(25293, '4.10.60.10-FF-000038', NULL, 'CCHC-type zinc finger, nucleic acid-binding protein a', 26, NULL, NULL, 25293),
(25294, '3.30.60.30-FF-000153', NULL, 'Proteinase inhibitor type-2 CEVI57', 53, NULL, NULL, 25294),
(25295, '1.20.1270.280-FF-000068', NULL, 'Uncharacterized protein', 127, NULL, NULL, 25295),
(25296, '3.30.1390.10-FF-000013', NULL, '50S ribosomal protein L7/L12', 71, NULL, NULL, 25296),
(25297, '3.40.390.10-FF-000124', NULL, 'Archaemetzincin', 160, NULL, NULL, 25297),
(25298, '1.10.510.10-FF-002616', NULL, NULL, 124, NULL, NULL, 25298),
(25299, '3.20.20.100-FF-000041', NULL, 'D-arabinose 1-dehydrogenase', 310, NULL, NULL, 25299),
(25300, '3.10.20.10-FF-000044', NULL, 'Cell death-inducing DFFA-like effector a', 44, NULL, NULL, 25300),
(25301, '2.60.120.200-FF-000730', NULL, 'ABR243Wp', 221, NULL, NULL, 25301),
(25302, '2.40.10.10-FF-000573', NULL, NULL, 59, NULL, NULL, 25302),
(25303, '3.90.1750.10-FF-000078', NULL, 'Ubiquitin-protein ligase, putative', 202, NULL, NULL, 25303),
(25304, '3.40.50.720-FF-000615', NULL, '17-beta-hydroxysteroid dehydrogenase 13 isoform X2', 44, NULL, NULL, 25304),
(25305, '3.80.10.10-FF-001069', NULL, 'Disease resistance protein (TIR-NBS-LRR class)', 149, NULL, NULL, 25305),
(25306, '2.20.90.10-FF-000011', NULL, 'Uncharacterized protein', 169, NULL, NULL, 25306),
(25307, '3.90.1150.10-FF-000111', NULL, 'Transcriptional regulator, GntR family', 148, NULL, NULL, 25307),
(25308, '2.60.120.260-FF-000433', NULL, 'Glycoside hydrolase', 209, NULL, NULL, 25308),
(25309, '1.10.150.20-FF-000135', NULL, 'Mitochondrial DNA polymerase beta-PAK, putative', 86, NULL, NULL, 25309),
(25310, '2.60.40.60-FF-000493', NULL, 'Cadherin 17, LI cadherin (Liver-intestine)', 78, NULL, NULL, 25310),
(25311, '3.40.50.300-FF-003710', NULL, 'Uncharacterized protein', 198, NULL, NULL, 25311),
(25312, '3.40.1090.10-FF-000073', NULL, 'Patatin-like phospholipase domain-containing 6', 98, NULL, NULL, 25312),
(25313, '1.10.100.10-FF-000016', NULL, 'GM25185', 63, NULL, NULL, 25313),
(25314, '2.70.170.10-FF-000026', NULL, '5-hydroxytryptamine receptor 3C', 211, NULL, NULL, 25314),
(25315, '2.130.10.10-FF-000484', NULL, 'WD repeat domain, phosphoinositide interacting 2, isoform CRA_c', 255, NULL, NULL, 25315),
(25316, '2.70.170.10-FF-000138', NULL, 'Transmembrane ion channel', 221, NULL, NULL, 25316),
(25317, '1.10.8.10-FF-000199', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 38, NULL, NULL, 25317),
(25318, '1.20.1200.10-FF-000004', NULL, 'Cobalamin adenosyltransferase', 171, NULL, NULL, 25318),
(25319, '3.20.20.40-FF-000007', NULL, 'Glucanase', 136, NULL, NULL, 25319),
(25320, '2.130.10.10-FF-002693', NULL, 'YALI0A08646p', 328, NULL, NULL, 25320),
(25321, '2.20.70.10-FF-000066', NULL, 'Peptidyl-prolyl cis-trans isomerase', 54, NULL, NULL, 25321),
(25322, '1.25.40.10-FF-002540', NULL, 'Pentatricopeptide repeat-containing protein', 142, NULL, NULL, 25322),
(25323, '1.10.287.110-FF-000485', NULL, 'Uncharacterized protein', 105, NULL, NULL, 25323),
(25324, '3.30.1540.10-FF-000008', NULL, 'Cinnamoyl-CoA:phenyllactate CoA-transferase', 101, NULL, NULL, 25324),
(25325, '3.40.50.620-FF-000411', NULL, 'Tryptophan--tRNA ligase', 217, NULL, NULL, 25325),
(25326, '1.10.630.10-FF-000101', NULL, 'Uncharacterized protein', 467, NULL, NULL, 25326),
(25327, '4.10.240.30-FF-000004', NULL, 'tumor necrosis factor alpha-induced protein 3 isoform X2', 33, NULL, NULL, 25327);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(25328, '3.40.50.1000-FF-000665', NULL, NULL, 207, NULL, NULL, 25328),
(25329, '1.25.40.10-FF-000511', NULL, 'Pentatricopeptide repeat-containing protein', 216, NULL, NULL, 25329),
(25330, '3.10.100.10-FF-000054', NULL, 'C-type lectin domain family 11 member A', 145, NULL, NULL, 25330),
(25331, '1.10.510.10-FF-002599', NULL, NULL, 179, NULL, NULL, 25331),
(25332, '1.25.10.10-FF-000296', NULL, 'Related to transport protein USO1', 679, NULL, NULL, 25332),
(25333, '2.60.40.150-FF-000375', NULL, 'Phosphoinositide phospholipase C', 129, NULL, NULL, 25333),
(25334, '1.10.600.10-FF-000009', NULL, 'Geranylgeranyl pyrophosphate synthase', 300, NULL, NULL, 25334),
(25335, '3.30.70.120-FF-000021', NULL, NULL, 104, NULL, NULL, 25335),
(25336, '3.30.460.30-FF-000003', NULL, NULL, 137, NULL, NULL, 25336),
(25337, '1.20.120.350-FF-000274', NULL, NULL, 80, NULL, NULL, 25337),
(25338, '3.30.420.40-FF-000947', NULL, 'Uncharacterized protein', 17, NULL, NULL, 25338),
(25339, '2.130.10.10-FF-002575', NULL, 'WD repeat domain 82', 67, NULL, NULL, 25339),
(25340, '2.60.40.1170-FF-000077', NULL, NULL, 98, NULL, NULL, 25340),
(25341, '3.30.200.20-FF-000077', NULL, 'Putative Serine/threonine-protein kinase/endoribonuclease IRE1', 82, NULL, NULL, 25341),
(25342, '3.10.20.90-FF-000192', NULL, 'Rap guanine nucleotide exchange factor (GEF) 3', 93, NULL, NULL, 25342),
(25343, '1.25.40.10-FF-005120', NULL, 'TPR-repeat-containing chaperone protein DNAJ, putative', 112, NULL, NULL, 25343),
(25344, '1.10.150.50-FF-000088', NULL, 'Uncharacterized protein, isoform A', 85, NULL, NULL, 25344),
(25345, '1.50.40.10-FF-000559', NULL, 'Predicted protein', 123, NULL, NULL, 25345),
(25346, '2.10.25.10-FF-001709', NULL, 'Uncharacterized protein', 61, NULL, NULL, 25346),
(25347, '3.30.70.270-FF-000200', NULL, NULL, 107, NULL, NULL, 25347),
(25348, '1.10.287.110-FF-000428', NULL, 'Uncharacterized protein', 129, NULL, NULL, 25348),
(25349, '1.20.58.390-FF-000270', NULL, 'Uncharacterized protein', 82, NULL, NULL, 25349),
(25350, '1.10.15.30-FF-000008', NULL, 'Ribosomal protein, putative', 53, NULL, NULL, 25350),
(25351, '2.80.10.70-FF-000004', NULL, 'Predicted gene, 21778', 150, NULL, NULL, 25351),
(25352, '2.160.20.10-FF-000348', NULL, 'F-box protein 10', 230, NULL, NULL, 25352),
(25353, '3.30.40.210-FF-000002', NULL, 'Transcription elongation factor SPT4 homolog', 104, NULL, NULL, 25353),
(25354, '1.10.10.60-FF-000473', NULL, 'Transcriptional regulator, AraC family', 109, NULL, NULL, 25354),
(25355, '3.10.110.10-FF-000234', NULL, 'Probable ubiquitin-conjugating enzyme E2 C', 152, NULL, NULL, 25355),
(25356, '1.10.730.10-FF-000165', NULL, 'Isoleucine--tRNA ligase', 193, NULL, NULL, 25356),
(25357, '3.40.140.10-FF-000078', NULL, 'Cytidine/deoxycytidylate deaminase family protein', 144, NULL, NULL, 25357),
(25358, '3.40.30.10-FF-001134', NULL, 'Uncharacterized protein', 74, NULL, NULL, 25358),
(25359, '2.70.170.10-FF-000195', NULL, 'Uncharacterized protein', 188, NULL, NULL, 25359),
(25360, '1.20.1250.20-FF-001628', NULL, 'Uncharacterized protein', 113, NULL, NULL, 25360),
(25361, '2.40.50.140-FF-000125', NULL, 'exosome complex exonuclease RRP44 isoform X1', 83, NULL, NULL, 25361),
(25362, '3.20.20.220-FF-000026', NULL, 'Proline dehydrogenase 1', 285, NULL, NULL, 25362),
(25363, '3.40.50.2300-FF-000509', NULL, 'Uncharacterized protein', 251, NULL, NULL, 25363),
(25364, '1.10.238.10-FF-000993', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase 1', 65, NULL, NULL, 25364),
(25365, '3.10.450.50-FF-000035', NULL, 'Hypothetical_protein_-_conserved', 141, NULL, NULL, 25365),
(25366, '2.40.10.10-FF-000516', NULL, NULL, 48, NULL, NULL, 25366),
(25367, '1.10.1450.10-FF-000159', NULL, 'Tetraspanin', 79, NULL, NULL, 25367),
(25368, '2.60.120.260-FF-000158', NULL, 'Protein CBG16940', 174, NULL, NULL, 25368),
(25369, '2.60.40.720-FF-000006', NULL, 'CRE-RNT-1 protein', 136, NULL, NULL, 25369),
(25370, '1.10.400.10-FF-000028', NULL, 'Guanine nucleotide-binding protein alpha-5 subunit', 117, NULL, NULL, 25370),
(25371, '1.10.10.1020-FF-000004', NULL, 'RecBCD enzyme subunit RecD', 128, NULL, NULL, 25371);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(25372, '1.20.90.10-FF-000013', NULL, 'Phospholipase A2', 129, NULL, NULL, 25372),
(25373, '3.30.160.60-FF-005334', NULL, NULL, 71, NULL, NULL, 25373),
(25374, '3.30.1490.20-FF-000069', NULL, 'D-alanine--D-alanine ligase', 64, NULL, NULL, 25374),
(25375, '3.10.20.90-FF-000933', NULL, 'Predicted protein', 80, NULL, NULL, 25375),
(25376, '3.40.50.150-FF-001147', NULL, NULL, 206, NULL, NULL, 25376),
(25377, '1.10.630.10-FF-000798', NULL, 'Uncharacterized protein', 87, NULL, NULL, 25377),
(25378, '3.40.50.300-FF-007021', NULL, 'Uncharacterized protein MJECL10', 206, NULL, NULL, 25378),
(25379, '3.40.30.10-FF-000976', NULL, 'Predicted protein', 94, NULL, NULL, 25379),
(25380, '1.20.1050.60-FF-000006', NULL, 'Putative secreted protein', 86, NULL, NULL, 25380),
(25381, '2.130.10.10-FF-002636', NULL, 'Uncharacterized protein', 319, NULL, NULL, 25381),
(25382, '2.30.30.40-FF-000605', NULL, 'Uncharacterized protein', 56, NULL, NULL, 25382),
(25383, '3.40.50.261-FF-000046', NULL, 'Acetyl-CoA synthetase', 162, NULL, NULL, 25383),
(25384, '2.60.40.10-FF-006037', NULL, NULL, 101, NULL, NULL, 25384),
(25385, '3.20.20.30-FF-000004', NULL, 'F420-dependent glucose-6-phosphate dehydrogenase', 336, NULL, NULL, 25385),
(25386, '3.40.50.300-FF-004166', NULL, 'Zinc finger, NFX1-type-containing 1, gene 2', 219, NULL, NULL, 25386),
(25387, '3.40.50.1820-FF-000343', NULL, 'Uncharacterized protein', 217, NULL, NULL, 25387),
(25388, '3.90.260.10-FF-000058', NULL, 'DNA repair protein rhp42', 304, NULL, NULL, 25388),
(25389, '1.25.40.10-FF-000915', NULL, 'MAU2 chromatid cohesion factor homolog', 297, NULL, NULL, 25389),
(25390, '3.30.40.10-FF-001399', NULL, 'DNA-binding E3 ubiquitin-protein ligase', 107, NULL, NULL, 25390),
(25391, '1.25.40.10-FF-004226', NULL, 'Predicted protein', 264, NULL, NULL, 25391),
(25392, '1.20.1070.10-FF-001089', NULL, 'Prostaglandin E2 receptor EP3 subtype', 320, NULL, NULL, 25392),
(25393, '3.20.20.210-FF-000023', NULL, 'Uncharacterized protein', 214, NULL, NULL, 25393),
(25394, '3.80.10.10-FF-003839', NULL, 'Leucine rich repeat containing 8 VRAC subunit B', 47, NULL, NULL, 25394),
(25395, '3.90.70.10-FF-000869', NULL, 'Uncharacterized protein', 72, NULL, NULL, 25395),
(25396, '2.60.210.10-FF-000009', NULL, 'Meprin A subunit', 167, NULL, NULL, 25396),
(25397, '3.15.10.30-FF-000011', NULL, 'AGAP009383-PA', 210, NULL, NULL, 25397),
(25398, '1.25.40.20-FF-000918', NULL, 'Uncharacterized protein', 164, NULL, NULL, 25398),
(25399, '3.30.40.230-FF-000008', NULL, 'Glycine-tRNA ligase', 14, NULL, NULL, 25399),
(25400, '3.30.565.10-FF-000437', NULL, 'Two-component signal transduction', 156, NULL, NULL, 25400),
(25401, '3.40.50.300-FF-004784', NULL, 'Ribosome-releasing factor 2, mitochondrial', 24, NULL, NULL, 25401),
(25402, '2.130.10.10-FF-004727', NULL, 'Uncharacterized protein', 166, NULL, NULL, 25402),
(25403, '1.20.120.220-FF-000004', NULL, 'ATP synthase subunit a', 164, NULL, NULL, 25403),
(25404, '2.60.110.10-FF-000013', NULL, 'Pathogenesis-related thaumatin superfamily protein', 107, NULL, NULL, 25404),
(25405, '3.30.530.20-FF-000096', NULL, 'Cytoplasmic phosphatidylinositol transfer protein 1', 88, NULL, NULL, 25405),
(25406, '1.25.10.10-FF-003151', NULL, 'EXPOrtin (Nuclear export receptor)', 39, NULL, NULL, 25406),
(25407, '1.20.58.80-FF-000072', NULL, 'STAM-binding protein b', 94, NULL, NULL, 25407),
(25408, '1.20.1280.290-FF-000056', NULL, 'Sugar transporter SWEET1', 92, NULL, NULL, 25408),
(25409, '3.60.10.10-FF-000013', NULL, 'Phosphatidylinositol 4,5-bisphosphate 5-phosphatase A', 332, NULL, NULL, 25409),
(25410, '3.40.50.720-FF-000407', NULL, 'Oxidoreductase, putative', 154, NULL, NULL, 25410),
(25411, '1.20.1250.20-FF-000381', NULL, 'Siderophore iron transporter mirB', 189, NULL, NULL, 25411),
(25412, '2.60.40.60-FF-000285', NULL, 'Calsyntenin-1, isoform C', 100, NULL, NULL, 25412),
(25413, '3.40.47.10-FF-000273', NULL, NULL, 93, NULL, NULL, 25413),
(25414, '2.120.10.30-FF-000423', NULL, 'Low density lipoprotein receptor', 164, NULL, NULL, 25414),
(25415, '3.40.50.150-FF-001501', NULL, NULL, 114, NULL, NULL, 25415);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(25416, '1.20.5.170-FF-000142', NULL, 'CCR4-associated factor 4', 70, NULL, NULL, 25416),
(25417, '1.20.120.230-FF-000007', NULL, 'Catenin alpha 1', 217, NULL, NULL, 25417),
(25418, '3.30.1390.10-FF-000002', NULL, 'ATP-dependent Clp protease adapter protein ClpS', 105, NULL, NULL, 25418),
(25419, '1.10.730.10-FF-000126', NULL, 'Valine--tRNA ligase', 211, NULL, NULL, 25419),
(25420, '2.10.25.10-FF-001378', NULL, 'Growth arrest-specific 6', 39, NULL, NULL, 25420),
(25421, '3.40.50.720-FF-001689', NULL, 'Ifm3p', 67, NULL, NULL, 25421),
(25422, '3.30.1370.10-FF-000181', NULL, 'Tudor and KH domain-containing protein homolog', 88, NULL, NULL, 25422),
(25423, '2.130.10.10-FF-001501', NULL, 'Cleavage and polyadenylation specificity factor subunit, putative', 375, NULL, NULL, 25423),
(25424, '1.25.40.10-FF-001579', NULL, 'Pentatricopeptide repeat-containing protein', 123, NULL, NULL, 25424),
(25425, '2.30.42.10-FF-000551', NULL, NULL, 71, NULL, NULL, 25425),
(25426, '1.25.40.430-FF-000003', NULL, 'Checkpoint serine/threonine-protein kinase BUB1', 189, NULL, NULL, 25426),
(25427, '3.30.497.10-FF-000037', NULL, 'Serpin peptidase inhibitor 22', 194, NULL, NULL, 25427),
(25428, '3.90.550.50-FF-000244', NULL, 'Beta 3-glucosyltransferase', 142, NULL, NULL, 25428),
(25429, '2.120.10.80-FF-000331', NULL, 'Uncharacterized protein', 131, NULL, NULL, 25429),
(25430, '1.10.418.10-FF-000086', NULL, 'Fimbrin-like protein', 127, NULL, NULL, 25430),
(25431, '3.10.110.10-FF-000291', NULL, 'Uncharacterized protein', 110, NULL, NULL, 25431),
(25432, '3.40.1090.10-FF-000016', NULL, 'Patatin like phospholipase domain containing 1', 166, NULL, NULL, 25432),
(25433, '3.30.420.40-FF-000447', NULL, 'Heat shock protein 70kD, putative', 183, NULL, NULL, 25433),
(25434, '1.25.40.20-FF-000391', NULL, 'L-asparaginase 1', 96, NULL, NULL, 25434),
(25435, '1.20.1070.10-FF-001078', NULL, 'Somatostatin receptor type 4', 326, NULL, NULL, 25435),
(25436, '3.30.200.20-FF-000285', NULL, 'Putative inactive leucine-rich repeat receptor-like protein kinase', 110, NULL, NULL, 25436),
(25437, '3.40.50.300-FF-000456', NULL, 'Ras-related protein RABC1', 203, NULL, NULL, 25437),
(25438, '1.10.418.10-FF-000029', NULL, 'plectin isoform X2', 124, NULL, NULL, 25438),
(25439, '3.40.50.2000-FF-000061', NULL, 'UDP-glycosyltransferase 83A1', 186, NULL, NULL, 25439),
(25440, '1.10.1500.10-FF-000001', NULL, 'Glutaminase', 138, NULL, NULL, 25440),
(25441, '1.10.30.10-FF-000156', NULL, 'SRY-box 18', 69, NULL, NULL, 25441),
(25442, '3.30.1120.10-FF-000073', NULL, 'Uncharacterized protein', 84, NULL, NULL, 25442),
(25443, '3.90.1150.10-FF-000100', NULL, 'Cysteine desulfurase IscS', 118, NULL, NULL, 25443),
(25444, '3.40.190.10-FF-000137', NULL, 'Glutamate receptor', 60, NULL, NULL, 25444),
(25445, '1.20.5.190-FF-000148', NULL, NULL, 72, NULL, NULL, 25445),
(25446, '1.20.58.60-FF-000453', NULL, 'Spectrin beta, non-erythrocytic 5', 189, NULL, NULL, 25446),
(25447, '3.40.50.300-FF-005689', NULL, 'Dynein-1-beta heavy chain, flagellar inner arm I1 complex', 182, NULL, NULL, 25447),
(25448, '3.40.50.300-FF-008095', NULL, 'UPF1 regulator of nonsense transcripts homolog', 112, NULL, NULL, 25448),
(25449, '3.40.50.720-FF-002206', NULL, 'Uncharacterized oxidoreductase C736.13', 305, NULL, NULL, 25449),
(25450, '3.40.800.10-FF-000044', NULL, NULL, 265, NULL, NULL, 25450),
(25451, '3.40.800.20-FF-000047', NULL, 'Histone deacetylase 3', 171, NULL, NULL, 25451),
(25452, '3.40.30.10-FF-000858', NULL, 'Uncharacterized protein', 72, NULL, NULL, 25452),
(25453, '1.20.1070.10-FF-001432', NULL, 'Uncharacterized protein', 225, NULL, NULL, 25453),
(25454, '3.30.750.24-FF-000134', NULL, 'Anti-sigma factor antagonist', 109, NULL, NULL, 25454),
(25455, '3.30.160.60-FF-004334', NULL, NULL, 27, NULL, NULL, 25455),
(25456, '3.90.79.10-FF-000176', NULL, 'Uncharacterized protein', 161, NULL, NULL, 25456),
(25457, '3.80.10.10-FF-001923', NULL, 'Malignant fibrous histiocytoma-amplified sequence 1', 194, NULL, NULL, 25457),
(25458, '1.20.1420.20-FF-000001', NULL, 'Iron uptake system component EfeO', 247, NULL, NULL, 25458);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(25459, '3.30.110.30-FF-000016', NULL, 'Proline--tRNA ligase', 61, NULL, NULL, 25459),
(25460, '3.30.160.60-FF-002872', NULL, 'Trade embargo', 27, NULL, NULL, 25460),
(25461, '2.60.200.40-FF-000001', NULL, 'Diacylglycerol kinase', 172, NULL, NULL, 25461),
(25462, '2.40.180.10-FF-000005', NULL, 'lipoxygenase homology domain-containing protein 1', 126, NULL, NULL, 25462),
(25463, '3.30.160.60-FF-005126', NULL, NULL, 94, NULL, NULL, 25463),
(25464, '1.10.287.130-FF-000232', NULL, 'Globin-coupled histidine kinase', 76, NULL, NULL, 25464),
(25465, '2.40.10.10-FF-000308', NULL, 'Protease Do-like 5, chloroplastic', 123, NULL, NULL, 25465),
(25466, '2.60.34.10-FF-000121', NULL, 'Uncharacterized protein', 30, NULL, NULL, 25466),
(25467, '1.25.40.820-FF-000024', NULL, 'Uncharacterized protein', 172, NULL, NULL, 25467),
(25468, '1.10.472.10-FF-000306', NULL, 'Uncharacterized protein', 100, NULL, NULL, 25468),
(25469, '3.30.70.560-FF-000017', NULL, 'Uncharacterized protein', 153, NULL, NULL, 25469),
(25470, '2.10.110.10-FF-000272', NULL, 'LIM and senescent cell antigen-like-containing domain protein', 41, NULL, NULL, 25470),
(25471, '1.25.40.20-FF-001391', NULL, 'Uncharacterized protein', 56, NULL, NULL, 25471),
(25472, '2.60.40.150-FF-000493', NULL, 'Synaptotagmin-like 2a', 144, NULL, NULL, 25472),
(25473, '3.30.70.330-FF-002039', NULL, NULL, 122, NULL, NULL, 25473),
(25474, '3.80.30.20-FF-000011', NULL, 'Elongator complex', 160, NULL, NULL, 25474),
(25475, '2.20.70.10-FF-000009', NULL, 'E3 ubiquitin-protein ligase', 49, NULL, NULL, 25475),
(25476, '3.30.300.30-FF-000110', NULL, 'Non-ribosomal peptide synthetase', 83, NULL, NULL, 25476),
(25477, '1.20.1070.10-FF-000072', NULL, 'Cannabinoid receptor 1', 324, NULL, NULL, 25477),
(25478, '3.30.1390.20-FF-000005', NULL, '39S ribosomal protein L30, mitochondrial', 54, NULL, NULL, 25478),
(25479, '3.10.20.620-FF-000013', NULL, NULL, 103, NULL, NULL, 25479),
(25480, '2.60.40.150-FF-000436', NULL, 'Phosphatidylserine decarboxylase proenzyme 2', 170, NULL, NULL, 25480),
(25481, '3.40.50.300-FF-006583', NULL, 'Septin homolog spn7', 277, NULL, NULL, 25481),
(25482, '3.80.20.20-FF-000061', NULL, 'receptor tyrosine-protein kinase erbB-3 isoform X2', 126, NULL, NULL, 25482),
(25483, '3.30.200.60-FF-000004', NULL, 'Ubiquitin thiolesterase', 87, NULL, NULL, 25483),
(25484, '2.60.40.10-FF-000860', NULL, 'natural cytotoxicity triggering receptor 3', 115, NULL, NULL, 25484),
(25485, '3.30.70.920-FF-000047', NULL, 'Transcriptional regulator, AsnC family', 85, NULL, NULL, 25485),
(25486, '1.10.3210.10-FF-000075', NULL, 'Two-component signal transduction', 192, NULL, NULL, 25486),
(25487, '2.20.70.10-FF-000240', NULL, 'Peptidyl-prolyl cis-trans isomerase', 38, NULL, NULL, 25487),
(25488, '2.10.110.10-FF-000215', NULL, 'LIM domain-containing protein pin-2', 71, NULL, NULL, 25488),
(25489, '1.20.1420.30-FF-000004', NULL, 'Sodium/potassium/calcium exchanger 2 isoform 1', 137, NULL, NULL, 25489),
(25490, '3.30.2020.30-FF-000026', NULL, 'Uncharacterized protein', 122, NULL, NULL, 25490),
(25491, '1.25.40.10-FF-004726', NULL, 'Uncharacterized protein', 85, NULL, NULL, 25491),
(25492, '3.40.50.1820-FF-001804', NULL, 'Carboxylic ester hydrolase', 137, NULL, NULL, 25492),
(25493, '3.30.200.20-FF-000009', NULL, 'Glycogen synthase kinase-3 beta', 95, NULL, NULL, 25493),
(25494, '1.20.58.1780-FF-000022', NULL, 'Nuclear pore complex protein (NUP155), putative', 268, NULL, NULL, 25494),
(25495, '2.60.200.20-FF-000254', NULL, 'Uncharacterized protein', 95, NULL, NULL, 25495),
(25496, '3.20.20.100-FF-000102', NULL, 'Predicted protein', 321, NULL, NULL, 25496),
(25497, '1.20.58.570-FF-000003', NULL, NULL, 89, NULL, NULL, 25497),
(25498, '3.10.20.90-FF-000579', NULL, 'Autophagy-related protein', 118, NULL, NULL, 25498),
(25499, '3.40.50.11610-FF-000020', NULL, NULL, 24, NULL, NULL, 25499),
(25500, '3.30.1220.10-FF-000001', NULL, 'GTP-binding protein YjiA', 116, NULL, NULL, 25500),
(25501, '1.20.1070.10-FF-001819', NULL, 'Uncharacterized protein', 310, NULL, NULL, 25501),
(25502, '2.40.70.10-FF-000514', NULL, NULL, 84, NULL, NULL, 25502);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(25503, '2.60.40.10-FF-000585', NULL, 'mucosa-associated lymphoid tissue lymphoma translocation protein 1', 91, NULL, NULL, 25503),
(25504, '3.90.190.10-FF-000007', NULL, 'Receptor-type tyrosine-protein phosphatase alpha', 297, NULL, NULL, 25504),
(25505, '2.60.40.10-FF-001023', NULL, 'usherin', 102, NULL, NULL, 25505),
(25506, '2.60.40.60-FF-000673', NULL, 'Uncharacterized protein', 42, NULL, NULL, 25506),
(25507, '1.20.1250.20-FF-001741', NULL, 'Uncharacterized protein', 200, NULL, NULL, 25507),
(25508, '1.20.1070.10-FF-001639', NULL, 'Pyroglutamylated RFamide peptide receptor a', 137, NULL, NULL, 25508),
(25509, '1.20.1550.10-FF-000002', NULL, 'Protein-disulfide oxidoreductase DsbI', 174, NULL, NULL, 25509),
(25510, '1.10.287.110-FF-000075', NULL, 'Uncharacterized protein, isoform D', 125, NULL, NULL, 25510),
(25511, '3.40.50.80-FF-000104', NULL, 'BauF', 159, NULL, NULL, 25511),
(25512, '2.130.10.10-FF-001170', NULL, 'Chromatin assembly factor-I p50 subunit', 407, NULL, NULL, 25512),
(25513, '1.25.10.10-FF-002095', NULL, 'Uncharacterized protein', 256, NULL, NULL, 25513),
(25514, '3.50.50.60-FF-001498', NULL, 'Uncharacterized protein', 37, NULL, NULL, 25514),
(25515, '2.30.42.10-FF-000113', NULL, 'Membrane associated guanylate kinase, WW and PDZ domain containing 2', 88, NULL, NULL, 25515),
(25516, '3.50.50.60-FF-000800', NULL, 'Flavin-containing monooxygenase', 328, NULL, NULL, 25516),
(25517, '1.10.510.10-FF-004336', NULL, NULL, 134, NULL, NULL, 25517),
(25518, '3.40.50.300-FF-002255', NULL, 'ATP-dependent DNA helicase', 197, NULL, NULL, 25518),
(25519, '3.30.450.40-FF-000275', NULL, 'Uncharacterized protein', 162, NULL, NULL, 25519),
(25520, '3.30.565.10-FF-000257', NULL, 'Putative mismatch repair protein PMS1', 211, NULL, NULL, 25520),
(25521, '3.40.50.10860-FF-000042', NULL, 'Shikimate 5-dehydrogenase, putative', 113, NULL, NULL, 25521),
(25522, '3.30.9.10-FF-000079', NULL, 'Gamma-glutamylputrescine oxidoreductase', 152, NULL, NULL, 25522),
(25523, '2.60.40.10-FF-002440', NULL, 'Lymphocyte activation gene 3 protein', 80, NULL, NULL, 25523),
(25524, '3.40.50.10810-FF-000173', NULL, 'Uncharacterized protein, isoform E', 197, NULL, NULL, 25524),
(25525, '1.20.1250.20-FF-000105', NULL, 'proton myo-inositol cotransporter isoform X1', 125, NULL, NULL, 25525),
(25526, '3.60.15.10-FF-000041', NULL, 'Metallo-beta-lactamase domain protein', 189, NULL, NULL, 25526),
(25527, '3.30.200.20-FF-002437', NULL, 'MAP kinase-activated protein kinase 2', 70, NULL, NULL, 25527),
(25528, '1.10.1420.10-FF-000124', NULL, 'Uncharacterized protein', 150, NULL, NULL, 25528),
(25529, '3.30.565.10-FF-000027', NULL, 'MORC family CW-type zinc finger protein 2', 184, NULL, NULL, 25529),
(25530, '3.30.559.10-FF-000136', NULL, 'Protein ECERIFERUM 26-like', 187, NULL, NULL, 25530),
(25531, '3.30.360.10-FF-000057', NULL, 'Uncharacterized protein', 33, NULL, NULL, 25531),
(25532, '1.20.59.10-FF-000002', NULL, 'Chorismate mutase/prephenate dehydratase', 107, NULL, NULL, 25532),
(25533, '3.40.50.300-FF-003070', NULL, 'Ferrous iron transport protein B', 203, NULL, NULL, 25533),
(25534, '3.30.870.10-FF-000197', NULL, 'Uncharacterized protein', 122, NULL, NULL, 25534),
(25535, '3.40.30.10-FF-001173', NULL, 'Predicted protein', 84, NULL, NULL, 25535),
(25536, '3.30.1050.10-FF-000022', NULL, 'Alkyl sulfatase, putative', 121, NULL, NULL, 25536),
(25537, '2.40.70.10-FF-000172', NULL, 'ASpartyl Protease', 134, NULL, NULL, 25537),
(25538, '2.60.40.10-FF-001080', NULL, 'protein turtle isoform X10', 102, NULL, NULL, 25538),
(25539, '1.10.150.240-FF-000007', NULL, 'Sugar phosphatase YfbT', 63, NULL, NULL, 25539),
(25540, '3.90.226.10-FF-000333', NULL, 'Uncharacterized protein', 80, NULL, NULL, 25540),
(25541, '2.40.50.40-FF-000123', NULL, 'Predicted protein', 68, NULL, NULL, 25541),
(25542, '3.30.420.40-FF-000009', NULL, 'Heat shock protein 70', 92, NULL, NULL, 25542),
(25543, '1.10.238.10-FF-000925', NULL, 'Uncharacterized protein', 74, NULL, NULL, 25543),
(25544, '3.40.190.10-FF-000412', NULL, 'HTH-type transcriptional activator AmpR', 96, NULL, NULL, 25544);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(25545, '3.40.50.80-FF-000161', NULL, 'NADH-dependent ferredoxin:NADP+ oxidoreductase, beta subunit', 106, NULL, NULL, 25545),
(25546, '1.20.1080.10-FF-000123', NULL, 'Chromosome 8, whole genome shotgun sequence', 65, NULL, NULL, 25546),
(25547, '2.10.25.10-FF-001653', NULL, 'Protein crumbs-like Protein', 73, NULL, NULL, 25547),
(25548, '1.20.5.270-FF-000003', NULL, 'Cytochrome b-c1 complex subunit Rieske, mitochondrial', 56, NULL, NULL, 25548),
(25549, '2.60.40.60-FF-000616', NULL, 'Uncharacterized protein', 122, NULL, NULL, 25549),
(25550, '1.25.10.10-FF-000560', NULL, 'Importin 13, putative', 1008, NULL, NULL, 25550),
(25551, '3.30.470.10-FF-000003', NULL, 'Branched-chain-amino-acid aminotransferase', 178, NULL, NULL, 25551),
(25552, '1.10.287.70-FF-000034', NULL, 'Potassium voltage-gated channel subfamily B member', 111, NULL, NULL, 25552),
(25553, '1.25.40.20-FF-001115', NULL, 'Kinase, NEK', 227, NULL, NULL, 25553),
(25554, '1.25.10.10-FF-002712', NULL, 'Uncharacterized protein', 41, NULL, NULL, 25554),
(25555, '3.10.120.10-FF-000049', NULL, 'Chitin synthase-domain-containing protein', 69, NULL, NULL, 25555),
(25556, '3.40.30.10-FF-000678', NULL, 'Glutathione S-transferase P 1', 75, NULL, NULL, 25556),
(25557, '1.10.620.20-FF-000014', NULL, 'Uncharacterized protein', 298, NULL, NULL, 25557),
(25558, '3.30.1370.10-FF-000068', NULL, 'IGF-II mRNA-binding protein, isoform D', 75, NULL, NULL, 25558),
(25559, '3.30.470.20-FF-000006', NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', 137, NULL, NULL, 25559),
(25560, '2.60.210.10-FF-000077', NULL, NULL, 133, NULL, NULL, 25560),
(25561, '3.40.50.300-FF-008207', NULL, 'Uncharacterized protein', 72, NULL, NULL, 25561),
(25562, '1.10.10.60-FF-000883', NULL, NULL, 74, NULL, NULL, 25562),
(25563, '3.40.50.1100-FF-000066', NULL, 'L-serine dehydratase, putative', 217, NULL, NULL, 25563),
(25564, '3.30.70.330-FF-000319', NULL, 'Polyadenylate-binding protein RBP47B', 95, NULL, NULL, 25564),
(25565, '2.30.130.40-FF-000002', NULL, 'Cereblon, isoform CRA_c', 125, NULL, NULL, 25565),
(25566, '1.10.1170.10-FF-000020', NULL, 'Bir1p', 127, NULL, NULL, 25566),
(25567, '2.60.40.150-FF-000616', NULL, 'Synaptotagmin 1e', 149, NULL, NULL, 25567),
(25568, '2.40.110.10-FF-000057', NULL, 'Probable acyl-CoA dehydrogenase', 114, NULL, NULL, 25568),
(25569, '3.40.50.920-FF-000024', NULL, '1-deoxy-D-xylulose 5-phosphate synthase', 123, NULL, NULL, 25569),
(25570, '3.30.470.30-FF-000009', NULL, 'DNA ligase', 126, NULL, NULL, 25570),
(25571, '4.10.60.10-FF-000246', NULL, 'Alternative splicing factor SRp20/9G8, putative', 32, NULL, NULL, 25571),
(25572, '1.20.58.390-FF-000039', NULL, 'Ligand-Gated ion Channel', 139, NULL, NULL, 25572),
(25573, '2.130.10.10-FF-000894', NULL, 'Compass component swd2', 197, NULL, NULL, 25573),
(25574, '2.120.10.30-FF-000243', NULL, 'DPP6 amino-terminal domain protein', 232, NULL, NULL, 25574),
(25575, '3.30.530.20-FF-000175', NULL, 'Uncharacterized protein', 109, NULL, NULL, 25575),
(25576, '3.40.50.150-FF-000484', NULL, 'Uncharacterized protein', 232, NULL, NULL, 25576),
(25577, '3.30.450.20-FF-000117', NULL, 'Uncharacterized protein, isoform A', 174, NULL, NULL, 25577),
(25578, '3.80.10.10-FF-001698', NULL, 'F-box/LRR-repeat protein 4', 136, NULL, NULL, 25578),
(25579, '2.60.40.10-FF-002647', NULL, 'AGAP002949-PA', 93, NULL, NULL, 25579),
(25580, '3.30.530.20-FF-000118', NULL, 'Thebaine synthase 1', 153, NULL, NULL, 25580),
(25581, '1.10.472.10-FF-000582', NULL, 'Uncharacterized protein', 43, NULL, NULL, 25581),
(25582, '3.90.70.10-FF-000364', NULL, 'Dipeptidyl aminopeptidase 3', 208, NULL, NULL, 25582),
(25583, '1.10.287.110-FF-000417', NULL, 'DnaJ-like protein', 98, NULL, NULL, 25583),
(25584, '2.30.29.30-FF-000245', NULL, 'Ran-binding protein 1 b', 164, NULL, NULL, 25584),
(25585, '3.40.50.11660-FF-000006', NULL, 'Alpha-(1,3)-fucosyltransferase C', 201, NULL, NULL, 25585),
(25586, '1.10.400.10-FF-000017', NULL, 'Guanine nucleotide-binding protein (G protein), alpha 11a (Gq class)', 26, NULL, NULL, 25586),
(25587, '3.40.50.960-FF-000007', NULL, '6,7-dimethyl-8-ribityllumazine synthase', 163, NULL, NULL, 25587);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(25588, '2.10.25.10-FF-001322', NULL, 'Schwann cell-specific EGF-like repeat autocrine factor', 68, NULL, NULL, 25588),
(25589, '3.80.10.10-FF-000113', NULL, 'F-box/LRR-repeat protein 15 isoform X1', 261, NULL, NULL, 25589),
(25590, '2.40.30.170-FF-000012', NULL, 'Cation efflux system protein CusB', 98, NULL, NULL, 25590),
(25591, '1.20.58.60-FF-000240', NULL, 'Microtubule-actin cross-linking factor 1', 111, NULL, NULL, 25591),
(25592, '1.10.3460.10-FF-000008', NULL, 'Photosystem II 22 kDa protein, chloroplastic', 107, NULL, NULL, 25592),
(25593, '3.40.630.10-FF-000334', NULL, 'Uncharacterized protein', 237, NULL, NULL, 25593),
(25594, '3.40.50.1000-FF-000098', NULL, 'RNA polymerase II C-terminal domain phosphatase-like 3', 238, NULL, NULL, 25594),
(25595, '2.40.40.50-FF-000002', NULL, 'Ubiquitin fusion degradation protein 1', 124, NULL, NULL, 25595),
(25596, '1.10.472.10-FF-000520', NULL, 'Predicted protein', 96, NULL, NULL, 25596),
(25597, '2.40.30.180-FF-000015', NULL, 'Ubiquitin activating enzyme', 84, NULL, NULL, 25597),
(25598, '2.60.120.650-FF-000005', NULL, 'lysine-specific demethylase 2A isoform X1', 292, NULL, NULL, 25598),
(25599, '1.10.10.60-FF-000708', NULL, 'Uncharacterized protein', 57, NULL, NULL, 25599),
(25600, '2.60.40.10-FF-002209', NULL, 'Cell adhesion molecule L1-like b', 108, NULL, NULL, 25600),
(25601, '3.10.20.90-FF-000309', NULL, 'Autophagy-related protein', 119, NULL, NULL, 25601),
(25602, '3.60.20.10-FF-000053', NULL, 'Proteasome subunit beta', 215, NULL, NULL, 25602),
(25603, '1.20.5.520-FF-000005', NULL, 'Thymosin beta HOMOLOGUE', 39, NULL, NULL, 25603),
(25604, '3.40.630.10-FF-000278', NULL, 'Uncharacterized protein', 52, NULL, NULL, 25604),
(25605, '3.30.160.60-FF-004901', NULL, NULL, 24, NULL, NULL, 25605),
(25606, '2.40.50.140-FF-000743', NULL, 'AGAP007032-PA', 148, NULL, NULL, 25606),
(25607, '3.30.40.10-FF-001961', NULL, 'Uncharacterized protein', 64, NULL, NULL, 25607),
(25608, '3.80.10.10-FF-000057', NULL, 'Centrosomal protein of 78 kDa', 120, NULL, NULL, 25608),
(25609, '2.170.270.10-FF-000195', NULL, 'SET domain-containing protein 3', 147, NULL, NULL, 25609),
(25610, '3.30.1520.10-FF-000002', NULL, 'Sorting nexin 12', 140, NULL, NULL, 25610),
(25611, '3.90.226.10-FF-000064', NULL, 'Enoyl-CoA hydratase EchA20', 246, NULL, NULL, 25611),
(25612, '3.30.70.1890-FF-000001', NULL, NULL, 124, NULL, NULL, 25612),
(25613, '3.30.160.60-FF-004845', NULL, NULL, 52, NULL, NULL, 25613),
(25614, '1.25.10.10-FF-003033', NULL, 'Uncharacterized protein', 311, NULL, NULL, 25614),
(25615, '2.10.25.10-FF-001266', NULL, 'Uncharacterized protein', 52, NULL, NULL, 25615),
(25616, '3.40.50.300-FF-006813', NULL, 'Uncharacterized protein', 47, NULL, NULL, 25616),
(25617, '2.30.30.210-FF-000004', NULL, 'Ribonuclease P protein subunit', 115, NULL, NULL, 25617),
(25618, '3.30.70.330-FF-000297', NULL, 'RNA binding motif protein 19', 136, NULL, NULL, 25618),
(25619, '3.30.200.20-FF-002252', NULL, 'Uncharacterized protein', 18, NULL, NULL, 25619),
(25620, '3.40.30.10-FF-001139', NULL, 'Uncharacterized protein', 60, NULL, NULL, 25620),
(25621, '3.40.50.720-FF-001532', NULL, 'Acetoacetyl-CoA reductase', 280, NULL, NULL, 25621),
(25622, '2.30.36.70-FF-000026', NULL, 'Uncharacterized protein', 30, NULL, NULL, 25622),
(25623, '3.30.930.10-FF-000022', NULL, 'Phenylalanine--tRNA ligase beta subunit', 205, NULL, NULL, 25623),
(25624, '3.30.420.40-FF-000392', NULL, 'pantothenate kinase 3-like isoform X1', 89, NULL, NULL, 25624),
(25625, '3.80.10.10-FF-002204', NULL, 'DmMstProx', 121, NULL, NULL, 25625),
(25626, '3.30.559.70-FF-000025', NULL, 'carnitine O-palmitoyltransferase 1, liver isoform-like', 324, NULL, NULL, 25626),
(25627, '2.70.98.10-FF-000043', NULL, 'Putative conserved exported protein', 301, NULL, NULL, 25627),
(25628, '2.40.50.140-FF-001199', NULL, NULL, 174, NULL, NULL, 25628),
(25629, '3.40.47.10-FF-000211', NULL, NULL, 172, NULL, NULL, 25629),
(25630, '1.10.472.10-FF-000464', NULL, 'CCNB1 isoform 6', 65, NULL, NULL, 25630),
(25631, '3.40.1090.10-FF-000128', NULL, 'Uncharacterized protein', 131, NULL, NULL, 25631);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(25632, '3.30.160.60-FF-002754', NULL, 'Zinc finger protein 705A', 26, NULL, NULL, 25632),
(25633, '3.30.70.330-FF-002118', NULL, NULL, 110, NULL, NULL, 25633),
(25634, '1.10.10.10-FF-001689', NULL, 'Heat shock transcription factor', 109, NULL, NULL, 25634),
(25635, '3.40.50.300-FF-003036', NULL, 'RAB30 isoform 15', 122, NULL, NULL, 25635),
(25636, '1.20.1250.20-FF-001746', NULL, 'Uncharacterized protein', 199, NULL, NULL, 25636),
(25637, '3.30.40.10-FF-000319', NULL, 'E3 ubiquitin-protein ligase RNF182', 87, NULL, NULL, 25637),
(25638, '3.40.50.300-FF-004722', NULL, 'ATP-binding cassette, sub-family A (ABC1), member 4b', 188, NULL, NULL, 25638),
(25639, '1.25.40.10-FF-004165', NULL, 'Uncharacterized protein', 103, NULL, NULL, 25639),
(25640, '3.10.450.580-FF-000018', NULL, 'Mediator of RNA polymerase II transcription subunit 6', 128, NULL, NULL, 25640),
(25641, '3.30.70.330-FF-002444', NULL, NULL, 155, NULL, NULL, 25641),
(25642, '1.10.10.10-FF-000273', NULL, 'DNA-binding response regulator RprY', 105, NULL, NULL, 25642),
(25643, '2.130.10.10-FF-004430', NULL, 'WD repeat protein, putative', 357, NULL, NULL, 25643),
(25644, '3.30.70.330-FF-001876', NULL, NULL, 100, NULL, NULL, 25644),
(25645, '3.10.110.10-FF-000116', NULL, 'ubiquitin-conjugating enzyme E2 G1', 99, NULL, NULL, 25645),
(25646, '2.130.10.10-FF-002069', NULL, 'Related to transcription factor SPT8', 130, NULL, NULL, 25646),
(25647, '3.80.10.10-FF-003727', NULL, 'AGAP007451-PA', 139, NULL, NULL, 25647),
(25648, '3.30.160.60-FF-001175', NULL, 'Zinc finger, C2H2 type', 28, NULL, NULL, 25648),
(25649, '3.60.21.10-FF-000269', NULL, 'Serine/threonine-protein phosphatase with EF-hands', 351, NULL, NULL, 25649),
(25650, '3.90.920.10-FF-000025', NULL, 'DNA primase small subunit PriS', 312, NULL, NULL, 25650),
(25651, '1.10.510.10-FF-001014', NULL, 'AGC protein kinase', 92, NULL, NULL, 25651),
(25652, '1.25.10.10-FF-002358', NULL, 'Uncharacterized protein', 282, NULL, NULL, 25652),
(25653, '1.20.1050.10-FF-000008', NULL, 'Glutathione S-transferase theta-1', 160, NULL, NULL, 25653),
(25654, '2.40.10.10-FF-000628', NULL, NULL, 236, NULL, NULL, 25654),
(25655, '1.25.10.10-FF-000234', NULL, 'Golgin candidate 6', 663, NULL, NULL, 25655),
(25656, '1.10.238.100-FF-000006', NULL, 'Fluconazole resistance protein 3', 88, NULL, NULL, 25656),
(25657, '3.100.10.10-FF-000032', NULL, NULL, 69, NULL, NULL, 25657),
(25658, '2.60.40.820-FF-000042', NULL, 'Protein CBG26077', 148, NULL, NULL, 25658),
(25659, '3.30.70.270-FF-000262', NULL, NULL, 113, NULL, NULL, 25659),
(25660, '1.20.1560.10-FF-000789', NULL, 'ABC transporter, putative', 228, NULL, NULL, 25660),
(25661, '1.20.58.1190-FF-000002', NULL, 'Toxin A', 85, NULL, NULL, 25661),
(25662, '3.40.50.1000-FF-000047', NULL, 'Sodium P-type ATPase', 163, NULL, NULL, 25662),
(25663, '3.80.10.10-FF-001636', NULL, 'Insulin like growth factor binding protein acid labile subunit', 135, NULL, NULL, 25663),
(25664, '3.30.160.60-FF-003322', NULL, NULL, 29, NULL, NULL, 25664),
(25665, '2.40.50.40-FF-000117', NULL, 'Heterochromatin protein 1e', 78, NULL, NULL, 25665),
(25666, '2.40.50.140-FF-000636', NULL, 'Minichromosome maintenance complex component 4', 56, NULL, NULL, 25666),
(25667, '3.40.50.300-FF-002575', NULL, 'NFX1-type zinc finger-containing protein 1', 137, NULL, NULL, 25667),
(25668, '3.50.50.60-FF-000205', NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', 253, NULL, NULL, 25668),
(25669, '1.20.1050.10-FF-000183', NULL, 'Glutathione S-transferase P 1', 118, NULL, NULL, 25669),
(25670, '3.30.230.10-FF-000345', NULL, 'Uncharacterized protein', 29, NULL, NULL, 25670),
(25671, '2.40.50.910-FF-000002', NULL, 'ESX-5 secretion system ATPase EccB5', 80, NULL, NULL, 25671),
(25672, '3.30.70.330-FF-000353', NULL, 'PPARG coactivator 1 beta', 93, NULL, NULL, 25672),
(25673, '1.20.1070.10-FF-000015', NULL, 'Olfactory receptor', 290, NULL, NULL, 25673),
(25674, '4.10.280.30-FF-000001', NULL, 'breakpoint cluster region protein isoform X2', 72, NULL, NULL, 25674),
(25675, '1.10.150.60-FF-000012', NULL, 'Blast:Protein Jumonji', 117, NULL, NULL, 25675);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(25676, '3.40.47.10-FF-000155', NULL, NULL, 197, NULL, NULL, 25676),
(25677, '2.60.40.10-FF-004452', NULL, NULL, 109, NULL, NULL, 25677),
(25678, '2.10.220.10-FF-000095', NULL, 'Proprotein convertase subtilisin/kexin type 6', 49, NULL, NULL, 25678),
(25679, '3.40.50.1000-FF-000154', NULL, 'Trehalose-6-phosphate synthase 10', 129, NULL, NULL, 25679),
(25680, '2.60.40.4100-FF-000012', NULL, 'Uncharacterized protein, isoform A', 138, NULL, NULL, 25680),
(25681, '1.10.600.10-FF-000010', NULL, 'Squalene synthase HpnD', 288, NULL, NULL, 25681),
(25682, '3.30.160.60-FF-001231', NULL, 'Zinc finger protein 574', 32, NULL, NULL, 25682),
(25683, '1.10.510.10-FF-004398', NULL, NULL, 86, NULL, NULL, 25683),
(25684, '3.30.470.20-FF-000001', NULL, 'Carbamoyl-phosphate synthase large chain', 280, NULL, NULL, 25684),
(25685, '1.25.40.10-FF-000803', NULL, 'Tetratricopeptide repeat domain 21A', 231, NULL, NULL, 25685),
(25686, '3.60.15.10-FF-000209', NULL, 'Artemis-related DNA-crosslink repair exonuclease', 39, NULL, NULL, 25686),
(25687, '2.70.98.10-FF-000094', NULL, 'NDH-dependent cyclic electron flow 1', 251, NULL, NULL, 25687),
(25688, '3.30.60.230-FF-000001', NULL, 'Nucleoid-associated protein Lsr2', 61, NULL, NULL, 25688),
(25689, '1.10.510.10-FF-003105', NULL, NULL, 195, NULL, NULL, 25689),
(25690, '1.10.238.10-FF-000369', NULL, 'Probable calcium-binding mitochondrial carrier CBG00135', 81, NULL, NULL, 25690),
(25691, '1.25.40.10-FF-004221', NULL, 'Pentatricopeptide repeat-containing protein PET309, mitochondrial', 406, NULL, NULL, 25691),
(25692, '3.90.1600.10-FF-000028', NULL, 'DNA polymerase', 169, NULL, NULL, 25692),
(25693, '3.30.420.110-FF-000070', NULL, 'DNA mismatch repair protein', 131, NULL, NULL, 25693),
(25694, '3.40.50.300-FF-004666', NULL, 'AAA ATPase central domain protein', 162, NULL, NULL, 25694),
(25695, '3.10.450.50-FF-000030', NULL, 'Conidial pigment biosynthesis scytalone dehydratase Arp1', 160, NULL, NULL, 25695),
(25696, '1.10.238.10-FF-001100', NULL, 'Serine/threonine-protein phosphatase with EF-hands', 64, NULL, NULL, 25696),
(25697, '1.20.1070.10-FF-001589', NULL, 'Odorant receptor S51', 155, NULL, NULL, 25697),
(25698, '1.20.1070.10-FF-001645', NULL, 'Uncharacterized protein', 137, NULL, NULL, 25698),
(25699, '2.30.30.30-FF-000108', NULL, '50S ribosomal protein L24', 129, NULL, NULL, 25699),
(25700, '3.30.160.60-FF-006195', NULL, NULL, 93, NULL, NULL, 25700),
(25701, '1.25.40.10-FF-004844', NULL, 'Uncharacterized protein', 139, NULL, NULL, 25701),
(25702, '2.40.10.10-FF-000691', NULL, NULL, 28, NULL, NULL, 25702),
(25703, '1.10.418.40-FF-000010', NULL, 'Uncharacterized protein', 165, NULL, NULL, 25703),
(25704, '3.60.21.10-FF-000218', NULL, 'Serine/threonine-protein phosphatase', 355, NULL, NULL, 25704),
(25705, '3.20.20.100-FF-000046', NULL, 'Aldo-keto reductase family 1, member B10 (aldose reductase)', 119, NULL, NULL, 25705),
(25706, '3.30.70.330-FF-001657', NULL, NULL, 119, NULL, NULL, 25706),
(25707, '2.60.40.10-FF-000293', NULL, 'Tenascin C', 90, NULL, NULL, 25707),
(25708, '1.10.418.60-FF-000016', NULL, 'Nuf2 family-domain-containing protein', 161, NULL, NULL, 25708),
(25709, '3.30.505.10-FF-000198', NULL, NULL, 117, NULL, NULL, 25709),
(25710, '3.90.1800.10-FF-000009', NULL, 'DNA-directed RNA polymerase subunit beta', 123, NULL, NULL, 25710),
(25711, '2.130.10.10-FF-002917', NULL, 'Bromodomain and WD repeat domain-containing 3', 195, NULL, NULL, 25711),
(25712, '3.30.160.60-FF-006251', NULL, NULL, 50, NULL, NULL, 25712),
(25713, '1.25.40.10-FF-004900', NULL, 'Putative pentatricopeptide repeat-containing protein At3g47840', 87, NULL, NULL, 25713),
(25714, '2.60.40.10-FF-003103', NULL, 'Immunoglobulin domain-containing protein Y54G2A.25', 104, NULL, NULL, 25714),
(25715, '3.40.50.1820-FF-001574', NULL, 'Cutinase', 106, NULL, NULL, 25715),
(25716, '2.70.150.10-FF-000255', NULL, 'Uncharacterized protein', 48, NULL, NULL, 25716),
(25717, '3.90.70.10-FF-000038', NULL, 'Calpain-type cysteine protease DEK1', 130, NULL, NULL, 25717),
(25718, '3.30.1010.10-FF-000070', NULL, 'phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit alpha-like', 146, NULL, NULL, 25718);
INSERT INTO "PUBLIC"."MODEL" VALUES
(25719, '3.30.505.10-FF-000254', NULL, NULL, 45, NULL, NULL, 25719),
(25720, '1.10.274.30-FF-000026', NULL, 'Uncharacterized protein', 255, NULL, NULL, 25720),
(25721, '2.130.10.10-FF-005739', NULL, 'AT07759p', 126, NULL, NULL, 25721),
(25722, '2.60.480.10-FF-000001', NULL, 'Stage V sporulation protein AA', 97, NULL, NULL, 25722),
(25723, '1.25.10.10-FF-000178', NULL, 'hsp70-binding protein 1 isoform X1', 272, NULL, NULL, 25723),
(25724, '1.25.40.10-FF-000573', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 228, NULL, NULL, 25724),
(25725, '3.60.90.10-FF-000001', NULL, 'S-adenosylmethionine decarboxylase proenzyme', 154, NULL, NULL, 25725),
(25726, '1.25.40.20-FF-000576', NULL, 'ankyrin repeat and SAM domain-containing protein 6 isoform X3', 168, NULL, NULL, 25726),
(25727, '1.10.472.10-FF-000138', NULL, 'Transcription initiation factor IIB, putative', 95, NULL, NULL, 25727),
(25728, '3.40.50.300-FF-003362', NULL, 'RNA-directed RNA polymerase', 160, NULL, NULL, 25728),
(25729, '1.10.1380.10-FF-000007', NULL, 'Blast:Membrane metallo-endopeptidase-like 1', 359, NULL, NULL, 25729),
(25730, '3.40.50.1820-FF-000225', NULL, 'Os07g0687100 protein', 210, NULL, NULL, 25730),
(25731, '3.30.200.20-FF-002145', NULL, 'Uncharacterized protein', 69, NULL, NULL, 25731),
(25732, '1.10.510.10-FF-002537', NULL, 'Serine/threonine-protein kinase PDIK1L', 305, NULL, NULL, 25732),
(25733, '3.30.70.920-FF-000053', NULL, 'Transcriptional regulator, AsnC family', 95, NULL, NULL, 25733),
(25734, '2.60.120.200-FF-000112', NULL, 'L-type lectin-domain containing receptor kinase V.9', 243, NULL, NULL, 25734),
(25735, '3.40.50.300-FF-007521', NULL, 'Uncharacterized protein', 211, NULL, NULL, 25735),
(25736, '3.40.50.2060-FF-000005', NULL, 'vacuolar protein sorting-associated protein 33B isoform X1', 134, NULL, NULL, 25736),
(25737, '3.90.79.10-FF-000182', NULL, 'Isopentenyl-diphosphate delta-isomerase, type 1', 202, NULL, NULL, 25737),
(25738, '2.40.70.10-FF-000284', NULL, NULL, 128, NULL, NULL, 25738),
(25739, '2.60.40.790-FF-000156', NULL, NULL, 71, NULL, NULL, 25739),
(25740, '4.10.91.10-FF-000003', NULL, 'Cytochrome c oxidase subunit 7A2a', 41, NULL, NULL, 25740),
(25741, '2.20.70.10-FF-000184', NULL, 'E3 ubiquitin-protein ligase', 34, NULL, NULL, 25741),
(25742, '3.40.50.720-FF-002240', NULL, 'Uncharacterized protein', 87, NULL, NULL, 25742),
(25743, '3.40.50.2000-FF-001078', NULL, 'Glycosyltransferase', 144, NULL, NULL, 25743),
(25744, '3.30.230.70-FF-000009', NULL, 'Exosome complex component RRP42', 287, NULL, NULL, 25744),
(25745, '1.10.238.10-FF-001151', NULL, 'Uncharacterized protein', 125, NULL, NULL, 25745),
(25746, '1.10.3720.10-FF-000170', NULL, 'ABC transporter permease protein', 222, NULL, NULL, 25746),
(25747, '3.40.109.10-FF-000005', NULL, 'NAD(P)H nitroreductase', 183, NULL, NULL, 25747),
(25748, '1.20.1050.10-FF-000301', NULL, 'Uncharacterized protein', 51, NULL, NULL, 25748),
(25749, '2.130.10.10-FF-004542', NULL, 'Chromosome 7, whole genome shotgun sequence', 349, NULL, NULL, 25749),
(25750, '3.20.190.10-FF-000012', NULL, 'Formamidopyrimidine-DNA glycosylase', 144, NULL, NULL, 25750),
(25751, '3.90.226.10-FF-000283', NULL, 'Predicted protein', 400, NULL, NULL, 25751),
(25752, '3.30.310.40-FF-000001', NULL, 'N-glycosylase/DNA lyase isoform X2', 90, NULL, NULL, 25752),
(25753, '3.30.70.330-FF-002332', NULL, NULL, 112, NULL, NULL, 25753),
(25754, '3.30.310.50-FF-000004', NULL, 'Alpha-D-glucose phosphate-specific phosphoglucomutase', 104, NULL, NULL, 25754),
(25755, '3.40.640.10-FF-000048', NULL, 'tyrosine aminotransferase', 245, NULL, NULL, 25755),
(25756, '1.20.120.1750-FF-000021', NULL, 'RBR-type E3 ubiquitin transferase', 126, NULL, NULL, 25756),
(25757, '1.10.10.10-FF-000385', NULL, 'Poly-beta-hydroxybutyrate-responsive repressor', 108, NULL, NULL, 25757),
(25758, '3.90.180.10-FF-000001', NULL, 'S-(hydroxymethyl)glutathione dehydrogenase', 220, NULL, NULL, 25758),
(25759, '3.80.10.10-FF-000006', NULL, 'Tropomodulin 2', 167, NULL, NULL, 25759),
(25760, '3.40.50.300-FF-004941', NULL, 'Si:dkeyp-9d4.2', 241, NULL, NULL, 25760);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(25761, '3.40.50.300-FF-008089', NULL, 'Replication factor C small subunit', 114, NULL, NULL, 25761),
(25762, '3.90.226.10-FF-000013', NULL, 'Acetyl-coenzyme A carboxylase carboxyl transferase subunit beta', 260, NULL, NULL, 25762),
(25763, '2.30.29.240-FF-000005', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 219, NULL, NULL, 25763),
(25764, '3.40.50.2300-FF-000510', NULL, 'Probable sensor/response regulator hybrid', 125, NULL, NULL, 25764),
(25765, '3.40.50.1440-FF-000095', NULL, 'Cell division protein FtsZ', 307, NULL, NULL, 25765),
(25766, '3.10.129.10-FF-000215', NULL, '4-hydroxybenzoyl-CoA thioesterase', 125, NULL, NULL, 25766),
(25767, '2.10.220.10-FF-000218', NULL, 'Uncharacterized protein', 46, NULL, NULL, 25767),
(25768, '2.130.10.10-FF-000271', NULL, 'cilia- and flagella-associated protein 57', 296, NULL, NULL, 25768),
(25769, '2.120.10.70-FF-000002', NULL, 'Uncharacterized protein', 252, NULL, NULL, 25769),
(25770, '3.40.50.12780-FF-000016', NULL, 'Phenylacetate-coenzyme A ligase', 329, NULL, NULL, 25770),
(25771, '2.120.10.30-FF-000069', NULL, 'Blast:Prolow-density lipoprotein receptor-related protein 1', 330, NULL, NULL, 25771),
(25772, '2.120.10.80-FF-000005', NULL, 'Putative LOV domain-containing protein', 206, NULL, NULL, 25772),
(25773, '3.90.1600.10-FF-000073', NULL, 'Uncharacterized protein', 45, NULL, NULL, 25773),
(25774, '1.20.1720.10-FF-000032', NULL, 'Putative multidrug transporter', 244, NULL, NULL, 25774),
(25775, '1.20.1050.10-FF-000071', NULL, 'Omega-class glutathione transferase', 164, NULL, NULL, 25775),
(25776, '1.10.510.10-FF-003431', NULL, NULL, 286, NULL, NULL, 25776),
(25777, '3.30.70.330-FF-000027', NULL, 'Heterogeneous nuclear ribonucleoprotein q isoform', 99, NULL, NULL, 25777),
(25778, '2.60.120.430-FF-000001', NULL, 'Receptor-like protein kinase FERONIA', 183, NULL, NULL, 25778),
(25779, '3.80.10.10-FF-003497', NULL, 'Leucine rich repeat containing 40', 314, NULL, NULL, 25779),
(25780, '2.30.29.230-FF-000002', NULL, 'TBC1 domain family member 16 isoform X2', 76, NULL, NULL, 25780),
(25781, '3.30.160.60-FF-002479', NULL, 'Si:ch211-216l23.1', 59, NULL, NULL, 25781),
(25782, '1.10.3260.10-FF-000027', NULL, 'DNA ligase', 132, NULL, NULL, 25782),
(25783, '2.30.42.10-FF-000433', NULL, NULL, 108, NULL, NULL, 25783),
(25784, '3.40.50.1000-FF-000480', NULL, NULL, 105, NULL, NULL, 25784),
(25785, '3.30.200.20-FF-002196', NULL, 'Mitogen-activated protein kinase', 51, NULL, NULL, 25785),
(25786, '3.30.590.20-FF-000004', NULL, 'Putative glutamate--cysteine ligase 2', 368, NULL, NULL, 25786),
(25787, '2.30.30.40-FF-000544', NULL, 'Uncharacterized protein', 65, NULL, NULL, 25787),
(25788, '3.30.230.70-FF-000161', NULL, 'Exosome non-catalytic core subunit', 291, NULL, NULL, 25788),
(25789, '3.40.630.10-FF-000008', NULL, 'Endoplasmic reticulum metallopeptidase 1', 298, NULL, NULL, 25789),
(25790, '2.60.40.10-FF-002939', NULL, 'Protein sevenless', 116, NULL, NULL, 25790),
(25791, '2.60.40.10-FF-004564', NULL, NULL, 103, NULL, NULL, 25791),
(25792, '2.30.30.40-FF-000263', NULL, 'SH3 domain-containing protein 21', 60, NULL, NULL, 25792),
(25793, '1.10.238.10-FF-000257', NULL, 'Calmodulin', 49, NULL, NULL, 25793),
(25794, '3.30.420.40-FF-000329', NULL, 'ROK family transcriptional regulator', 38, NULL, NULL, 25794),
(25795, '3.40.462.20-FF-000002', NULL, 'Possible oxidoreductase', 202, NULL, NULL, 25795),
(25796, '3.40.50.720-FF-001476', NULL, 'Pyrroline-5-carboxylate reductase', 187, NULL, NULL, 25796),
(25797, '3.30.590.10-FF-000001', NULL, 'Glutamine synthetase', 353, NULL, NULL, 25797),
(25798, '3.90.640.10-FF-000020', NULL, 'Actin-related protein 8', 104, NULL, NULL, 25798),
(25799, '2.60.40.10-FF-002384', NULL, 'Stretchin-Mlck, isoform S', 98, NULL, NULL, 25799),
(25800, '3.10.100.10-FF-000402', NULL, NULL, 114, NULL, NULL, 25800),
(25801, '1.20.920.30-FF-000037', NULL, 'Dynein, axonemal, heavy chain 14', 136, NULL, NULL, 25801),
(25802, '1.25.40.20-FF-001407', NULL, 'CAMTA family protein', 126, NULL, NULL, 25802),
(25803, '3.30.1010.10-FF-000137', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', 152, NULL, NULL, 25803);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(25804, '1.20.1310.10-FF-000170', NULL, NULL, 132, NULL, NULL, 25804),
(25805, '1.10.10.10-FF-000054', NULL, 'Two-component system response regulator ArcA', 110, NULL, NULL, 25805),
(25806, '3.90.190.10-FF-000114', NULL, 'Tyrosine-protein phosphatase', 303, NULL, NULL, 25806),
(25807, '2.30.160.11-FF-000002', NULL, 'Methuselah-like 8, isoform B', 59, NULL, NULL, 25807),
(25808, '3.30.160.60-FF-004957', NULL, NULL, 41, NULL, NULL, 25808),
(25809, '3.30.160.60-FF-004671', NULL, NULL, 58, NULL, NULL, 25809),
(25810, '2.40.170.20-FF-000064', NULL, 'TonB-dependent outer membrane receptor', 551, NULL, NULL, 25810),
(25811, '3.40.630.10-FF-000222', NULL, 'Protein CBG05160', 88, NULL, NULL, 25811),
(25812, '2.60.120.10-FF-000475', NULL, 'Cysteine dioxygenase', 199, NULL, NULL, 25812),
(25813, '1.25.10.10-FF-000745', NULL, 'Chromosome 7, whole genome shotgun sequence', 222, NULL, NULL, 25813),
(25814, '2.30.29.30-FF-000240', NULL, 'Myotubularin-related protein 9', 96, NULL, NULL, 25814),
(25815, '3.60.110.10-FF-000032', NULL, 'Glutamine-dependent NAD(+) synthetase', 309, NULL, NULL, 25815),
(25816, '1.10.1410.10-FF-000062', NULL, 'Uncharacterized protein', 101, NULL, NULL, 25816),
(25817, '3.40.50.300-FF-001119', NULL, 'Iron-sulfur cluster carrier protein', 255, NULL, NULL, 25817),
(25818, '1.20.144.10-FF-000104', NULL, 'Uncharacterized protein', 240, NULL, NULL, 25818),
(25819, '1.25.10.10-FF-000801', NULL, 'Putative tubulin folding cofactor D', 181, NULL, NULL, 25819),
(25820, '3.40.50.720-FF-002021', NULL, 'Uncharacterized protein', 206, NULL, NULL, 25820),
(25821, '3.30.70.270-FF-000043', NULL, 'Diguanylate cyclase (GGDEF) domain protein', 181, NULL, NULL, 25821),
(25822, '1.20.144.10-FF-000048', NULL, 'Chromosome 12, whole genome shotgun sequence', 107, NULL, NULL, 25822),
(25823, '1.10.10.60-FF-000260', NULL, 'Fis family transcriptional regulator', 72, NULL, NULL, 25823),
(25824, '3.40.50.300-FF-004492', NULL, 'Cobalt ABC transporter ATP-binding protein', 248, NULL, NULL, 25824),
(25825, '2.30.38.10-FF-000002', NULL, 'Enterobactin synthase component F', 78, NULL, NULL, 25825),
(25826, '1.20.1070.10-FF-001319', NULL, 'LOC561989 protein', 229, NULL, NULL, 25826),
(25827, '1.25.10.10-FF-001021', NULL, 'Exportin T, putative', 497, NULL, NULL, 25827),
(25828, '3.40.50.2300-FF-000324', NULL, 'Histidine kinase', 130, NULL, NULL, 25828),
(25829, '1.10.238.10-FF-000662', NULL, 'RE52086p', 91, NULL, NULL, 25829),
(25830, '1.10.510.10-FF-001200', NULL, 'Serine/threonine protein kinase', 187, NULL, NULL, 25830),
(25831, '2.60.40.10-FF-001523', NULL, 'Uncharacterized protein, isoform A', 100, NULL, NULL, 25831),
(25832, '3.40.50.300-FF-007302', NULL, 'Uncharacterized protein', 150, NULL, NULL, 25832),
(25833, '3.80.10.10-FF-000001', NULL, 'SLIT and NTRK-like family, member 1', 241, NULL, NULL, 25833),
(25834, '3.40.50.2300-FF-000268', NULL, 'Low molecular weight protein-tyrosine-phosphatase PtpA', 153, NULL, NULL, 25834),
(25835, '3.40.50.1820-FF-000500', NULL, 'Esterase/lipase/thioesterase family protein', 266, NULL, NULL, 25835),
(25836, '3.30.160.60-FF-002535', NULL, 'zinc finger protein Xfin', 26, NULL, NULL, 25836),
(25837, '1.10.560.10-FF-000129', NULL, 'Uncharacterized protein', 61, NULL, NULL, 25837),
(25838, '1.10.418.10-FF-000136', NULL, 'Uncharacterized protein', 118, NULL, NULL, 25838),
(25839, '1.20.58.390-FF-000157', NULL, 'Ionotropic GABA receptor subunit UNC-49C', 145, NULL, NULL, 25839),
(25840, '2.60.40.10-FF-004177', NULL, NULL, 113, NULL, NULL, 25840),
(25841, '3.30.40.10-FF-001775', NULL, 'Predicted protein', 63, NULL, NULL, 25841),
(25842, '3.30.2350.10-FF-000067', NULL, 'Pseudouridine synthase', 228, NULL, NULL, 25842),
(25843, '3.30.70.120-FF-000026', NULL, NULL, 66, NULL, NULL, 25843),
(25844, '2.120.10.30-FF-000125', NULL, 'Sugar lactone lactonase YvrE', 286, NULL, NULL, 25844),
(25845, '3.40.190.10-FF-000468', NULL, 'Putative Dipeptide ABC transporter, periplasmic dipeptide-binding protein', 87, NULL, NULL, 25845),
(25846, '3.40.50.720-FF-001751', NULL, 'Uncharacterized protein', 143, NULL, NULL, 25846); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(25847, '3.30.60.20-FF-000032', NULL, 'rho guanine nucleotide exchange factor 2 isoform X2', 76, NULL, NULL, 25847),
(25848, '3.40.50.300-FF-003031', NULL, 'ATP-dependent 26S proteasome regulatory subunit', 161, NULL, NULL, 25848),
(25849, '3.40.50.1820-FF-001299', NULL, 'Glr0885 protein', 276, NULL, NULL, 25849),
(25850, '1.10.533.10-FF-000275', NULL, 'Uncharacterized protein', 96, NULL, NULL, 25850),
(25851, '3.40.50.300-FF-005104', NULL, 'Rad51, putative', 265, NULL, NULL, 25851),
(25852, '3.90.132.10-FF-000014', NULL, 'GP63-like', 117, NULL, NULL, 25852),
(25853, '1.10.150.240-FF-000002', NULL, 'Fructose-1-phosphate/6-phosphogluconate phosphatase', 72, NULL, NULL, 25853),
(25854, '3.30.70.3250-FF-000005', NULL, 'Ribonuclease P/MRP protein subunit POP5', 116, NULL, NULL, 25854),
(25855, '3.50.50.60-FF-000424', NULL, 'Protoporphyrinogen oxidase', 139, NULL, NULL, 25855),
(25856, '2.60.40.10-FF-004126', NULL, NULL, 92, NULL, NULL, 25856),
(25857, '3.30.230.10-FF-000019', NULL, 'Lon protease homolog 2, peroxisomal', 192, NULL, NULL, 25857),
(25858, '3.30.160.60-FF-003092', NULL, 'Si:dkey-14o6.4', 31, NULL, NULL, 25858),
(25859, '3.30.830.10-FF-000037', NULL, 'Presequence protease 1', 250, NULL, NULL, 25859),
(25860, '1.20.1250.20-FF-001179', NULL, 'Uncharacterized protein', 204, NULL, NULL, 25860),
(25861, '2.130.10.10-FF-004435', NULL, 'Actin-related protein 2/3 complex subunit', 356, NULL, NULL, 25861),
(25862, '1.10.1380.10-FF-000002', NULL, 'Membrane metalloendopeptidase', 374, NULL, NULL, 25862),
(25863, '3.20.20.140-FF-000030', NULL, 'Dipeptidase', 370, NULL, NULL, 25863),
(25864, '1.20.1220.12-FF-000002', NULL, 'Malate synthase G', 138, NULL, NULL, 25864),
(25865, '3.30.428.10-FF-000057', NULL, 'Uncharacterized protein', 153, NULL, NULL, 25865),
(25866, '2.60.210.10-FF-000072', NULL, NULL, 219, NULL, NULL, 25866),
(25867, '2.40.10.10-FF-000073', NULL, 'Trypsin alpha', 99, NULL, NULL, 25867),
(25868, '3.30.160.60-FF-000686', NULL, 'Zinc finger protein 236 isoform 1', 36, NULL, NULL, 25868),
(25869, '3.30.40.10-FF-000207', NULL, 'RING-H2 finger protein ATL46-like', 73, NULL, NULL, 25869),
(25870, '3.10.450.50-FF-000086', NULL, 'Uncharacterized protein', 201, NULL, NULL, 25870),
(25871, '3.40.50.1100-FF-000184', NULL, 'Predicted protein', 110, NULL, NULL, 25871),
(25872, '3.30.70.260-FF-000040', NULL, 'Glycine cleavage system transcriptional regulator', 85, NULL, NULL, 25872),
(25873, '2.40.160.110-FF-000025', NULL, 'AGAP001624-PA', 140, NULL, NULL, 25873),
(25874, '3.20.20.150-FF-000033', NULL, 'Protein arginine N-methyltransferase', 337, NULL, NULL, 25874),
(25875, '2.160.20.10-FF-000062', NULL, 'Uncharacterized protein', 278, NULL, NULL, 25875),
(25876, '2.60.40.60-FF-000728', NULL, 'Si:dkey-22o22.2', 96, NULL, NULL, 25876),
(25877, '3.40.1000.50-FF-000017', NULL, 'Uncharacterized protein', 162, NULL, NULL, 25877),
(25878, '3.40.190.10-FF-000816', NULL, 'Uncharacterized protein', 28, NULL, NULL, 25878),
(25879, '3.90.70.10-FF-000369', NULL, 'Deubiquitylating with USP/UBP and OTU domains', 146, NULL, NULL, 25879),
(25880, '3.30.830.10-FF-000329', NULL, 'Pitrilysin metallepetidase 1 (Predicted)', 42, NULL, NULL, 25880),
(25881, '1.25.40.10-FF-002186', NULL, 'Pentatricopeptide repeat-containing protein At3g18110, chloroplastic', 107, NULL, NULL, 25881),
(25882, '1.10.400.10-FF-000062', NULL, 'Protein spalten', 124, NULL, NULL, 25882),
(25883, '3.30.200.20-FF-002471', NULL, 'Uncharacterized protein', 49, NULL, NULL, 25883),
(25884, '3.40.50.970-FF-000044', NULL, 'Putative acetolactate synthase IlvG', 203, NULL, NULL, 25884),
(25885, '3.40.50.980-FF-000047', NULL, '4-chlorobenzoate--CoA ligase', 174, NULL, NULL, 25885),
(25886, '3.30.1360.200-FF-000013', NULL, 'Protein translocase subunit SecD', 168, NULL, NULL, 25886),
(25887, '1.25.10.10-FF-002600', NULL, 'Uncharacterized protein', 149, NULL, NULL, 25887),
(25888, '3.40.50.11900-FF-000005', NULL, '3-hydroxyacyl-ACP dehydratase', 147, NULL, NULL, 25888),
(25889, '2.60.210.10-FF-000021', NULL, 'Tumor necrosis factor receptor-associated factor 2', 170, NULL, NULL, 25889);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(25890, '3.20.20.80-FF-000261', NULL, '4-alpha-glucanotransferase DPE2', 209, NULL, NULL, 25890),
(25891, '3.30.499.10-FF-000047', NULL, NULL, 108, NULL, NULL, 25891),
(25892, '3.80.10.10-FF-002423', NULL, 'Receptor like protein 45', 294, NULL, NULL, 25892),
(25893, '3.40.50.150-FF-001260', NULL, 'Putative ribosomal RNA methyltransferase NOP2-like Protein', 367, NULL, NULL, 25893),
(25894, '1.10.510.10-FF-000525', NULL, 'SRSF protein kinase 2', 122, NULL, NULL, 25894),
(25895, '2.40.50.140-FF-000305', NULL, 'Uncharacterized protein', 136, NULL, NULL, 25895),
(25896, '3.30.40.10-FF-001668', NULL, 'E3 ubiquitin-protein ligase CBL', 84, NULL, NULL, 25896),
(25897, '3.30.70.850-FF-000003', NULL, 'neuroendocrine convertase 2 isoform X1', 87, NULL, NULL, 25897),
(25898, '3.90.1150.210-FF-000024', NULL, 'Chromosome 1, whole genome shotgun sequence', 148, NULL, NULL, 25898),
(25899, '2.60.220.50-FF-000011', NULL, 'adhesion G protein-coupled receptor A3', 173, NULL, NULL, 25899),
(25900, '3.30.160.60-FF-000742', NULL, 'Uncharacterized protein', 29, NULL, NULL, 25900),
(25901, '3.40.1000.30-FF-000011', NULL, 'Uncharacterized protein', 157, NULL, NULL, 25901),
(25902, '1.20.1110.10-FF-000177', NULL, NULL, 241, NULL, NULL, 25902),
(25903, '3.90.550.10-FF-000721', NULL, 'Glycoside transferase family 2', 259, NULL, NULL, 25903),
(25904, '3.30.70.860-FF-000006', NULL, 'DUF406 domain-containing protein', 100, NULL, NULL, 25904),
(25905, '3.40.190.10-FF-000524', NULL, 'Putative glutamate receptor ionotropic kainate 5', 113, NULL, NULL, 25905),
(25906, '2.60.40.3210-FF-000026', NULL, 'Zona pellucida glycoprotein 3a', 82, NULL, NULL, 25906),
(25907, '1.20.1280.50-FF-000274', NULL, 'F-box/TPR repeat protein pof3', 96, NULL, NULL, 25907),
(25908, '3.60.21.10-FF-000095', NULL, 'RNA lariat debranching enzyme', 195, NULL, NULL, 25908),
(25909, '3.80.10.10-FF-002530', NULL, 'Tubulin folding cofactor E', 125, NULL, NULL, 25909),
(25910, '3.40.50.150-FF-000984', NULL, 'Malonyl-[acyl-carrier protein] O-methyltransferase', 217, NULL, NULL, 25910),
(25911, '1.10.10.10-FF-000447', NULL, 'RNA polymerase sigma factor SigF', 53, NULL, NULL, 25911),
(25912, '3.40.50.10310-FF-000017', NULL, 'Creatininase', 230, NULL, NULL, 25912),
(25913, '3.30.70.330-FF-002270', NULL, NULL, 136, NULL, NULL, 25913),
(25914, '3.30.70.870-FF-000009', NULL, 'Translation elongation factor G', 79, NULL, NULL, 25914),
(25915, '1.10.287.1480-FF-000003', NULL, '28S ribosomal protein S14, mitochondrial-like', 91, NULL, NULL, 25915),
(25916, '2.60.40.1760-FF-000001', NULL, 'Maltase-glucoamylase, intestinal', 234, NULL, NULL, 25916),
(25917, '2.130.10.10-FF-004761', NULL, 'Uncharacterized protein', 157, NULL, NULL, 25917),
(25918, '3.30.70.141-FF-000011', NULL, 'Nucleoside diphosphate kinase', 43, NULL, NULL, 25918),
(25919, '1.10.510.10-FF-004454', NULL, NULL, 287, NULL, NULL, 25919),
(25920, '3.50.4.10-FF-000006', NULL, 'Hepatocyte growth factor', 98, NULL, NULL, 25920),
(25921, '3.30.160.60-FF-004519', NULL, NULL, 50, NULL, NULL, 25921),
(25922, '1.10.287.110-FF-000187', NULL, 'DPH4-like protein', 89, NULL, NULL, 25922),
(25923, '3.30.50.10-FF-000152', NULL, 'GATA zinc finger family protein', 71, NULL, NULL, 25923),
(25924, '1.20.1250.20-FF-001797', NULL, 'Permease, putative', 175, NULL, NULL, 25924),
(25925, '2.60.40.60-FF-000791', NULL, 'Uncharacterized protein', 114, NULL, NULL, 25925),
(25926, '2.40.70.10-FF-000576', NULL, NULL, 66, NULL, NULL, 25926),
(25927, '3.55.50.30-FF-000023', NULL, 'Ferrioxamine B receptor', 102, NULL, NULL, 25927),
(25928, '2.60.260.20-FF-000027', NULL, 'Chaperone protein dnaJ GFA2, mitochondrial', 70, NULL, NULL, 25928),
(25929, '2.70.150.10-FF-000143', NULL, 'Calcium-transporting ATPase', 171, NULL, NULL, 25929),
(25930, '1.10.510.10-FF-000469', NULL, 'Serine/threonine-protein kinase 32B', 193, NULL, NULL, 25930),
(25931, '1.10.510.10-FF-000183', NULL, 'Serine/threonine-protein kinase hal4', 292, NULL, NULL, 25931),
(25932, '1.10.10.10-FF-000380', NULL, 'Transcription factor SKN7', 110, NULL, NULL, 25932),
(25933, '1.10.10.1460-FF-000001', NULL, 'DNA replication regulator Sld2', 51, NULL, NULL, 25933);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(25934, '2.60.40.10-FF-000815', NULL, 'Mast/stem cell growth factor receptor', 116, NULL, NULL, 25934),
(25935, '2.60.40.10-FF-005020', NULL, NULL, 104, NULL, NULL, 25935),
(25936, '1.25.40.10-FF-002372', NULL, 'Putative pentatricopeptide repeat-containing protein At3g15200', 95, NULL, NULL, 25936),
(25937, '2.60.40.10-FF-004738', NULL, NULL, 90, NULL, NULL, 25937),
(25938, '3.40.50.670-FF-000016', NULL, 'DNA topoisomerase (ATP-hydrolyzing)', 244, NULL, NULL, 25938),
(25939, '3.40.50.1820-FF-001029', NULL, 'Uncharacterized protein', 167, NULL, NULL, 25939),
(25940, '3.40.50.300-FF-008382', NULL, 'Uncharacterized protein', 227, NULL, NULL, 25940),
(25941, '1.20.58.1030-FF-000033', NULL, 'Predicted protein', 142, NULL, NULL, 25941),
(25942, '3.30.200.20-FF-002319', NULL, 'Uncharacterized protein', 61, NULL, NULL, 25942),
(25943, '1.25.10.10-FF-000127', NULL, 'rap1 GTPase-GDP dissociation stimulator 1 isoform X1', 154, NULL, NULL, 25943),
(25944, '2.60.40.1450-FF-000003', NULL, 'Related to J kappa-recombination signal binding protein', 205, NULL, NULL, 25944),
(25945, '2.60.40.10-FF-004396', NULL, NULL, 92, NULL, NULL, 25945),
(25946, '1.25.70.10-FF-000007', NULL, 'Mitochondrial transcription termination factor 1', 102, NULL, NULL, 25946),
(25947, '3.90.730.10-FF-000027', NULL, 'Ribonuclease 2', 115, NULL, NULL, 25947),
(25948, '3.40.50.1000-FF-000603', NULL, NULL, 99, NULL, NULL, 25948),
(25949, '1.20.920.20-FF-000001', NULL, 'dynein heavy chain 2, axonemal', 348, NULL, NULL, 25949),
(25950, '3.30.565.10-FF-000139', NULL, 'DNA mismatch repair protein (Mlh3), putative', 227, NULL, NULL, 25950),
(25951, '2.60.40.1460-FF-000006', NULL, 'Integrin subunit alpha 11', 144, NULL, NULL, 25951),
(25952, '3.90.25.70-FF-000002', NULL, 'Fatty acid synthase', 94, NULL, NULL, 25952),
(25953, '2.60.40.790-FF-000049', NULL, 'Increased DNA methylation 3', 105, NULL, NULL, 25953),
(25954, '1.25.40.10-FF-002927', NULL, 'RE67794p', 164, NULL, NULL, 25954),
(25955, '3.90.79.10-FF-000294', NULL, 'Adenine DNA glycosylase', 132, NULL, NULL, 25955),
(25956, '3.30.450.40-FF-000157', NULL, 'Histidine kinase osmosensor and regulator, putative', 168, NULL, NULL, 25956),
(25957, '3.90.550.10-FF-000665', NULL, 'Predicted protein', 114, NULL, NULL, 25957),
(25958, '3.40.50.150-FF-000366', NULL, 'Chemotaxis protein methyltransferase', 202, NULL, NULL, 25958),
(25959, '1.20.58.670-FF-000027', NULL, NULL, 130, NULL, NULL, 25959),
(25960, '1.10.274.100-FF-000034', NULL, 'DNA-directed RNA polymerase subunit', 41, NULL, NULL, 25960),
(25961, '3.40.190.290-FF-000128', NULL, 'Transcriptional regulator of L-lactate utilization LldR', 203, NULL, NULL, 25961),
(25962, '3.30.40.10-FF-002124', NULL, 'Uncharacterized protein', 89, NULL, NULL, 25962),
(25963, '1.10.472.10-FF-000245', NULL, 'Hypothetical_protein_-_conserved', 106, NULL, NULL, 25963),
(25964, '2.40.50.140-FF-000187', NULL, 'Replication protein A 14 kDa subunit', 121, NULL, NULL, 25964),
(25965, '1.10.10.10-FF-000503', NULL, 'Cullin-1', 84, NULL, NULL, 25965),
(25966, '3.30.830.10-FF-000256', NULL, 'Uncharacterized protein', 114, NULL, NULL, 25966),
(25967, '2.60.40.10-FF-003108', NULL, 'Sialic-acid binding protein-4', 82, NULL, NULL, 25967),
(25968, '2.40.100.10-FF-000017', NULL, 'Peptidyl-prolyl cis-trans isomerase', 176, NULL, NULL, 25968),
(25969, '3.40.50.2300-FF-000217', NULL, 'Piwi like RNA-mediated gene silencing 4', 127, NULL, NULL, 25969),
(25970, '4.10.400.10-FF-000348', NULL, 'Uncharacterized protein', 46, NULL, NULL, 25970),
(25971, '2.130.10.10-FF-004834', NULL, 'Uncharacterized protein', 134, NULL, NULL, 25971),
(25972, '2.60.40.10-FF-001304', NULL, 'Receptor protein-tyrosine kinase', 95, NULL, NULL, 25972),
(25973, '3.40.1310.30-FF-000001', NULL, 'Replication protein RepB', 136, NULL, NULL, 25973),
(25974, '2.40.30.130-FF-000028', NULL, 'Alanine--tRNA ligase', 99, NULL, NULL, 25974),
(25975, '3.40.140.10-FF-000252', NULL, 'Putative deoxycytidylate deaminase-like Protein', 143, NULL, NULL, 25975),
(25976, '3.30.200.20-FF-001763', NULL, 'Inactive serine/threonine-protein kinase VRK3', 42, NULL, NULL, 25976);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(25977, '2.60.120.20-FF-000011', NULL, 'Genome polyprotein', 232, NULL, NULL, 25977),
(25978, '3.40.50.300-FF-004615', NULL, 'Xeroderma pigmentosum D', 63, NULL, NULL, 25978),
(25979, '3.40.50.150-FF-000147', NULL, 'Caffeoyl-CoA O-methyltransferase 1', 233, NULL, NULL, 25979),
(25980, '2.60.120.40-FF-000017', NULL, 'Tumor necrosis factor ligand superfamily member 6', 152, NULL, NULL, 25980),
(25981, '3.40.50.2000-FF-000122', NULL, 'Glycosyltransferase', 184, NULL, NULL, 25981),
(25982, '3.40.50.720-FF-000172', NULL, 'Bifunctional 3-dehydroquinate dehydratase/shikimate dehydrogenase, chloroplastic', 180, NULL, NULL, 25982),
(25983, '2.60.40.60-FF-001010', NULL, 'Uncharacterized protein', 102, NULL, NULL, 25983),
(25984, '1.20.1250.20-FF-002202', NULL, 'Predicted protein', 145, NULL, NULL, 25984),
(25985, '1.10.490.10-FF-000005', NULL, 'Cytoglobin', 171, NULL, NULL, 25985),
(25986, '3.40.47.10-FF-000104', NULL, 'Bisdemethoxycurcumin synthase', 158, NULL, NULL, 25986),
(25987, '3.30.160.60-FF-004396', NULL, NULL, 84, NULL, NULL, 25987),
(25988, '2.130.10.10-FF-000719', NULL, 'WD repeat-containing protein 6', 195, NULL, NULL, 25988),
(25989, '2.60.40.2130-FF-000011', NULL, 'Uncharacterized protein', 116, NULL, NULL, 25989),
(25990, '3.40.50.2000-FF-000392', NULL, '2-deoxystreptamine N-acetyl-D-glucosaminyltransferase', 182, NULL, NULL, 25990),
(25991, '2.130.10.10-FF-004216', NULL, 'Uncharacterized protein', 151, NULL, NULL, 25991),
(25992, '3.30.200.20-FF-000346', NULL, 'PAS domain-containing serine/threonine-protein kinase', 111, NULL, NULL, 25992),
(25993, '1.10.1370.30-FF-000007', NULL, 'Dipeptidyl carboxypeptidase', 257, NULL, NULL, 25993),
(25994, '1.10.1070.11-FF-000064', NULL, 'PIKK family atypical protein kinase', 204, NULL, NULL, 25994),
(25995, '2.30.250.10-FF-000002', NULL, 'Aspartyl aminopeptidase', 149, NULL, NULL, 25995),
(25996, '3.30.160.60-FF-003210', NULL, 'GM26384', 40, NULL, NULL, 25996),
(25997, '2.40.50.40-FF-000005', NULL, 'chromodomain-helicase-DNA-binding protein 8 isoform X4', 61, NULL, NULL, 25997),
(25998, '3.70.10.10-FF-000086', NULL, 'DNA repair protein rad9, putative', 194, NULL, NULL, 25998),
(25999, '2.130.10.10-FF-000563', NULL, 'DDB1-and CUL4-associated factor 10', 162, NULL, NULL, 25999),
(26000, '3.30.40.10-FF-001449', NULL, 'Uncharacterized protein', 80, NULL, NULL, 26000),
(26001, '3.40.50.1440-FF-000151', NULL, 'Protein dml1', 281, NULL, NULL, 26001),
(26002, '3.40.50.150-FF-000765', NULL, 'tRNA (guanine(37)-N1)-methyltransferase', 241, NULL, NULL, 26002),
(26003, '3.40.50.1820-FF-001248', NULL, 'Uncharacterized protein', 545, NULL, NULL, 26003),
(26004, '3.40.50.2020-FF-000128', NULL, 'Uracil phosphoribosyltransferase-domain-containing protein', 225, NULL, NULL, 26004),
(26005, '1.10.10.60-FF-000552', NULL, 'LIM homeobox transcription factor 1 beta', 67, NULL, NULL, 26005),
(26006, '2.130.10.10-FF-004486', NULL, 'Predicted protein', 231, NULL, NULL, 26006),
(26007, '3.40.50.880-FF-000192', NULL, 'Uncharacterized protein', 134, NULL, NULL, 26007),
(26008, '1.10.510.10-FF-004179', NULL, NULL, 151, NULL, NULL, 26008),
(26009, '3.40.50.10130-FF-000059', NULL, 'Predicted protein', 206, NULL, NULL, 26009),
(26010, '2.10.25.10-FF-001592', NULL, 'Uncharacterized protein', 71, NULL, NULL, 26010),
(26011, '1.10.150.60-FF-000017', NULL, 'ARID/BRIGHT domain protein (SWI1), putative', 124, NULL, NULL, 26011),
(26012, '1.10.1370.10-FF-000001', NULL, 'Thimet oligopeptidase 1', 360, NULL, NULL, 26012),
(26013, '1.25.10.10-FF-002651', NULL, 'Uncharacterized protein', 107, NULL, NULL, 26013),
(26014, '3.30.70.20-FF-000038', NULL, 'Adenylylsulfate reductase subunit beta', 67, NULL, NULL, 26014),
(26015, '1.10.420.10-FF-000024', NULL, 'L-ascorbate peroxidase 2 cytosolic', 94, NULL, NULL, 26015),
(26016, '1.20.1070.10-FF-000010', NULL, 'Olfactory receptor', 289, NULL, NULL, 26016),
(26017, '2.60.40.10-FF-000467', NULL, 'Myomesin 1', 103, NULL, NULL, 26017),
(26018, '3.10.20.90-FF-000079', NULL, 'Putative FERM domain-containing protein 6', 97, NULL, NULL, 26018),
(26019, '1.20.120.1240-FF-000025', NULL, 'Dynamin-related protein 1E', 260, NULL, NULL, 26019);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(26020, '3.40.50.11960-FF-000001', NULL, 'alpha- and gamma-adaptin-binding protein p34 isoform X1', 171, NULL, NULL, 26020),
(26021, '3.90.79.10-FF-000237', NULL, 'Hydrolase, NUDIX family protein', 192, NULL, NULL, 26021),
(26022, '2.40.50.140-FF-000018', NULL, '30S ribosomal protein S1', 85, NULL, NULL, 26022),
(26023, '1.20.1250.20-FF-001415', NULL, 'Major facilitator superfamily MFS_1', 181, NULL, NULL, 26023),
(26024, '3.40.50.300-FF-007072', NULL, 'Uncharacterized protein', 193, NULL, NULL, 26024),
(26025, '2.40.50.430-FF-000004', NULL, 'Related to HYS2-DNA-directed DNA polymerase delta, 55 KD subunit', 131, NULL, NULL, 26025),
(26026, '3.30.40.10-FF-002231', NULL, 'Histone-lysine N-methyltransferase', 65, NULL, NULL, 26026),
(26027, '3.40.50.300-FF-004380', NULL, 'Rab_C52 protein', 205, NULL, NULL, 26027),
(26028, '3.30.160.60-FF-005121', NULL, NULL, 31, NULL, NULL, 26028),
(26029, '2.80.10.50-FF-000173', NULL, 'Predicted protein', 123, NULL, NULL, 26029),
(26030, '2.60.260.20-FF-000173', NULL, 'Dnaj-like protein subfamily B member 1-like protein', 74, NULL, NULL, 26030),
(26031, '3.40.50.11660-FF-000012', NULL, 'Uncharacterized protein', 219, NULL, NULL, 26031),
(26032, '1.10.150.240-FF-000058', NULL, 'Trehalose-6-phosphate phosphatase OtsB', 88, NULL, NULL, 26032),
(26033, '3.30.200.20-FF-002544', NULL, 'Uncharacterized protein', 12, NULL, NULL, 26033),
(26034, '1.20.1250.20-FF-001359', NULL, 'Uncharacterized protein', 288, NULL, NULL, 26034),
(26035, '3.30.70.330-FF-000645', NULL, 'Polyadenylate-binding protein', 135, NULL, NULL, 26035),
(26036, '1.20.120.20-FF-000030', NULL, 'Kinesin-like protein', 155, NULL, NULL, 26036),
(26037, '1.10.10.10-FF-002072', NULL, 'Transcriptional activator of tryptophan biosynthesis TrpI', 91, NULL, NULL, 26037),
(26038, '1.10.510.10-FF-002942', NULL, NULL, 200, NULL, NULL, 26038),
(26039, '2.130.10.10-FF-004609', NULL, 'Uncharacterized protein', 202, NULL, NULL, 26039),
(26040, '1.10.1200.270-FF-000038', NULL, 'Predicted protein', 12, NULL, NULL, 26040),
(26041, '3.90.70.10-FF-000656', NULL, 'PAN2-like protein', 78, NULL, NULL, 26041),
(26042, '2.10.50.30-FF-000037', NULL, 'Si:ch1073-155h21.1', 58, NULL, NULL, 26042),
(26043, '3.40.50.150-FF-000771', NULL, NULL, 49, NULL, NULL, 26043),
(26044, '3.30.70.330-FF-000701', NULL, 'Putative RNA-binding protein', 90, NULL, NULL, 26044),
(26045, '3.30.200.20-FF-001982', NULL, 'Uncharacterized protein', 99, NULL, NULL, 26045),
(26046, '1.10.10.10-FF-000891', NULL, 'DeoR/GlpR transcriptional regulator', 57, NULL, NULL, 26046),
(26047, '3.30.70.60-FF-000027', NULL, 'Predicted protein', 98, NULL, NULL, 26047),
(26048, '1.25.40.10-FF-001697', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 128, NULL, NULL, 26048),
(26049, '1.10.418.10-FF-000024', NULL, 'Hook homolog 3 (Drosophila)', 155, NULL, NULL, 26049),
(26050, '3.40.50.720-FF-001925', NULL, 'Ornithine cyclodeaminase (ArcB)', 151, NULL, NULL, 26050),
(26051, '2.120.10.80-FF-000393', NULL, 'Klhl4 protein', 183, NULL, NULL, 26051),
(26052, '2.30.180.10-FF-000058', NULL, 'Tyrosine-protein kinase', 143, NULL, NULL, 26052),
(26053, '2.60.40.60-FF-000167', NULL, 'Cadherin 16', 113, NULL, NULL, 26053),
(26054, '1.10.510.10-FF-001306', NULL, 'Leucine-rich repeat receptor-like protein kinase TDR', 187, NULL, NULL, 26054),
(26055, '3.40.50.300-FF-008595', NULL, 'AGAP012537-PA', 96, NULL, NULL, 26055),
(26056, '3.80.10.10-FF-003109', NULL, 'Os08g0191300 protein', 105, NULL, NULL, 26056),
(26057, '3.30.40.10-FF-000090', NULL, 'Mex-3 RNA-binding family member C', 69, NULL, NULL, 26057),
(26058, '3.90.25.10-FF-000006', NULL, 'GDP-mannose 3,5-epimerase 1', 124, NULL, NULL, 26058),
(26059, '3.40.50.1820-FF-001809', NULL, 'Uncharacterized protein', 123, NULL, NULL, 26059),
(26060, '2.60.40.10-FF-000742', NULL, 'neural cell adhesion molecule L1-like protein isoform X2', 93, NULL, NULL, 26060),
(26061, '3.40.50.300-FF-002867', NULL, 'Serine/threonine-protein kinase PknK', 150, NULL, NULL, 26061),
(26062, '1.10.3710.10-FF-000006', NULL, 'MgsA AAA+ ATPase family protein', 98, NULL, NULL, 26062);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(26063, '1.20.1250.20-FF-002022', NULL, 'Uncharacterized protein', 358, NULL, NULL, 26063),
(26064, '1.20.120.330-FF-000037', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 156, NULL, NULL, 26064),
(26065, '3.30.420.100-FF-000027', NULL, 'Uncharacterized protein', 163, NULL, NULL, 26065),
(26066, '3.40.50.10860-FF-000047', NULL, 'Shikimate dehydrogenase', 100, NULL, NULL, 26066),
(26067, '1.10.510.10-FF-000851', NULL, 'Serine/threonine protein kinase', 237, NULL, NULL, 26067),
(26068, '2.40.30.10-FF-000304', NULL, 'Putative translation elongation/initiation factor family protein', 50, NULL, NULL, 26068),
(26069, '3.30.200.20-FF-000397', NULL, 'Serine/threonine-protein kinase LATS1 isoform 1', 11, NULL, NULL, 26069),
(26070, '3.40.50.920-FF-000018', NULL, 'Pyruvate dehydrogenase E1 component', 182, NULL, NULL, 26070),
(26071, '3.80.10.10-FF-001928', NULL, 'Uncharacterized protein', 166, NULL, NULL, 26071),
(26072, '1.25.40.10-FF-001062', NULL, 'Pentatricopeptide repeat-containing protein', 106, NULL, NULL, 26072),
(26073, '6.20.370.150-FF-000001', NULL, 'N-acetylmuramoyl-L-alanine amidase', 27, NULL, NULL, 26073),
(26074, '1.10.3630.10-FF-000005', NULL, 'Uncharacterized protein', 87, NULL, NULL, 26074),
(26075, '1.20.1080.10-FF-000128', NULL, 'Aquaporin PIP1-6', 82, NULL, NULL, 26075),
(26076, '2.40.330.10-FF-000006', NULL, 'B3 domain-containing transcription repressor VAL1', 128, NULL, NULL, 26076),
(26077, '1.10.238.10-FF-000818', NULL, 'Calmodulin-like protein', 80, NULL, NULL, 26077),
(26078, '3.10.350.10-FF-000100', NULL, 'Lipoprotein NlpD', 62, NULL, NULL, 26078),
(26079, '3.40.50.10540-FF-000013', NULL, 'Uncharacterized protein', 218, NULL, NULL, 26079),
(26080, '2.60.120.260-FF-000220', NULL, 'E3 ubiquitin-protein ligase HERC2', 140, NULL, NULL, 26080),
(26081, '2.30.30.100-FF-000033', NULL, 'Trailer hitch, isoform C', 83, NULL, NULL, 26081),
(26082, '2.60.260.20-FF-000134', NULL, 'Chaperone protein DNAj, putative', 105, NULL, NULL, 26082),
(26083, '2.60.40.10-FF-000416', NULL, 'Sortilin related receptor 1', 96, NULL, NULL, 26083),
(26084, '3.90.550.10-FF-000608', NULL, 'Uncharacterized protein', 217, NULL, NULL, 26084),
(26085, '1.25.40.10-FF-004513', NULL, 'Uncharacterized protein', 87, NULL, NULL, 26085),
(26086, '2.60.40.1260-FF-000008', NULL, 'Lamin tail domain-containing protein 1', 213, NULL, NULL, 26086),
(26087, '2.60.120.260-FF-000164', NULL, 'Stage II sporulation protein E', 134, NULL, NULL, 26087),
(26088, '3.40.50.300-FF-008269', NULL, 'Uncharacterized protein', 42, NULL, NULL, 26088),
(26089, '2.130.10.10-FF-001001', NULL, 'Nup133', 427, NULL, NULL, 26089),
(26090, '3.90.1150.10-FF-000162', NULL, 'Serine hydroxymethyltransferase', 151, NULL, NULL, 26090),
(26091, '3.40.50.2300-FF-001634', NULL, NULL, 267, NULL, NULL, 26091),
(26092, '3.30.40.10-FF-000033', NULL, 'Polycomb group RING finger protein 3', 104, NULL, NULL, 26092),
(26093, '3.40.50.300-FF-002923', NULL, 'Structural maintenance of chromosomes protein', 168, NULL, NULL, 26093),
(26094, '2.120.10.80-FF-000117', NULL, 'Negative regulator of sporulation MDS3', 243, NULL, NULL, 26094),
(26095, '4.10.260.20-FF-000002', NULL, 'Periplasmic [Fe] hydrogenase 1', 75, NULL, NULL, 26095),
(26096, '2.40.70.10-FF-000407', NULL, 'Aspartic peptidase domain-containing protein', 252, NULL, NULL, 26096),
(26097, '3.30.160.60-FF-000916', NULL, 'Zinc finger protein 668', 28, NULL, NULL, 26097),
(26098, '2.30.29.30-FF-000801', NULL, 'Tyrosine-protein kinase', 175, NULL, NULL, 26098),
(26099, '1.10.510.10-FF-002829', NULL, NULL, 110, NULL, NULL, 26099),
(26100, '2.130.10.10-FF-004722', NULL, 'Uncharacterized protein', 167, NULL, NULL, 26100),
(26101, '3.30.70.2760-FF-000015', NULL, NULL, 50, NULL, NULL, 26101),
(26102, '1.10.10.2590-FF-000003', NULL, 'BEN domain-containing protein 5 isoform X1', 122, NULL, NULL, 26102),
(26103, '3.30.497.10-FF-000149', NULL, 'Serine (or cysteine) peptidase inhibitor, clade B, member 9c', 88, NULL, NULL, 26103),
(26104, '3.80.10.10-FF-004003', NULL, 'Zgc:77346', 150, NULL, NULL, 26104);
INSERT INTO "PUBLIC"."MODEL" VALUES
(26105, '3.30.2090.10-FF-000030', NULL, 'Heavy metal efflux pump permease component CzcA family', 89, NULL, NULL, 26105),
(26106, '3.40.50.720-FF-002532', NULL, 'Uncharacterized protein', 92, NULL, NULL, 26106),
(26107, '3.40.50.300-FF-008319', NULL, 'NLR family, CARD domain-containing 3-like', 248, NULL, NULL, 26107),
(26108, '3.40.50.150-FF-000714', NULL, 'Defense against restriction protein B', 213, NULL, NULL, 26108),
(26109, '1.20.140.40-FF-000037', NULL, 'Pectinesterase', 119, NULL, NULL, 26109),
(26110, '3.60.15.10-FF-000092', NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', 49, NULL, NULL, 26110),
(26111, '3.30.1370.10-FF-000063', NULL, 'A-kinase anchor protein 1, mitochondrial', 74, NULL, NULL, 26111),
(26112, '3.30.40.10-FF-001337', NULL, 'PHD transcription factor', 74, NULL, NULL, 26112),
(26113, '1.10.3430.10-FF-000063', NULL, 'Uncharacterized protein', 97, NULL, NULL, 26113),
(26114, '2.40.30.10-FF-000248', NULL, 'G1 to S phase transition protein 1, putative', 122, NULL, NULL, 26114),
(26115, '2.60.120.260-FF-000107', NULL, 'Beta-galactosidase', 129, NULL, NULL, 26115),
(26116, '3.30.40.10-FF-002118', NULL, 'Uncharacterized protein', 101, NULL, NULL, 26116),
(26117, '3.10.20.90-FF-000927', NULL, 'Uncharacterized protein', 81, NULL, NULL, 26117),
(26118, '1.25.40.20-FF-001121', NULL, 'Kinase, NEK-frag', 200, NULL, NULL, 26118),
(26119, '3.30.160.60-FF-005008', NULL, NULL, 75, NULL, NULL, 26119),
(26120, '3.40.50.300-FF-000782', NULL, 'Putative ABC transporter ATP-binding component', 223, NULL, NULL, 26120),
(26121, '3.30.160.60-FF-001523', NULL, 'Zinc finger and BTB domain containing 12', 57, NULL, NULL, 26121),
(26122, '3.90.190.20-FF-000005', NULL, 'Dihydrofolate synthase/folylpolyglutamate synthase', 129, NULL, NULL, 26122),
(26123, '3.40.50.80-FF-000155', NULL, 'NADH-cytochrome b5 reductase', 155, NULL, NULL, 26123),
(26124, '2.60.40.10-FF-001310', NULL, 'HERV-H LTR-associating 2', 107, NULL, NULL, 26124),
(26125, '3.50.7.10-FF-000092', NULL, NULL, 96, NULL, NULL, 26125),
(26126, '1.25.10.10-FF-000565', NULL, 'Importin beta-like', 1008, NULL, NULL, 26126),
(26127, '2.60.40.1250-FF-000005', NULL, 'Thiol:disulfide interchange protein DsbD', 124, NULL, NULL, 26127),
(26128, '3.30.1370.10-FF-000006', NULL, 'Ribonuclease Y', 96, NULL, NULL, 26128),
(26129, '1.10.510.10-FF-000795', NULL, 'CAMK/CAMKL protein kinase', 380, NULL, NULL, 26129),
(26130, '1.10.1420.10-FF-000118', NULL, 'DNA mismatch repair protein MSH3', 183, NULL, NULL, 26130),
(26131, '2.40.50.140-FF-000131', NULL, 'Eukaryotic translation initiation factor 1A', 144, NULL, NULL, 26131),
(26132, '1.10.510.10-FF-000738', NULL, 'Cdc2-related protein kinase 1', 247, NULL, NULL, 26132),
(26133, '2.40.30.10-FF-000287', NULL, 'RPL3 isoform 5', 99, NULL, NULL, 26133),
(26134, '3.90.190.10-FF-000002', NULL, 'receptor-type tyrosine-protein phosphatase delta isoform X2', 290, NULL, NULL, 26134),
(26135, '3.50.7.10-FF-000035', NULL, 'Uncharacterized protein', 155, NULL, NULL, 26135),
(26136, '3.10.120.10-FF-000055', NULL, 'Predicted protein', 128, NULL, NULL, 26136),
(26137, '3.40.50.720-FF-000402', NULL, 'NAD-dependent dihydrogenase, Gfo/Idh/MocA family', 157, NULL, NULL, 26137),
(26138, '1.10.238.10-FF-000931', NULL, 'Uncharacterized protein', 46, NULL, NULL, 26138),
(26139, '1.25.10.10-FF-001869', NULL, 'Anaphase-promoting complex subunit 1', 150, NULL, NULL, 26139),
(26140, '1.10.287.110-FF-000479', NULL, 'Uncharacterized protein', 73, NULL, NULL, 26140),
(26141, '2.130.10.10-FF-006015', NULL, 'Uncharacterized protein', 175, NULL, NULL, 26141),
(26142, '1.10.287.110-FF-000367', NULL, 'DnaJ-like protein subfamily C member 3', 112, NULL, NULL, 26142),
(26143, '3.50.50.60-FF-000750', NULL, 'Dihydropyrimidine dehydrogenase', 202, NULL, NULL, 26143),
(26144, '3.30.110.30-FF-000011', NULL, 'Proline--tRNA ligase', 77, NULL, NULL, 26144),
(26145, '1.25.40.20-FF-001008', NULL, 'Trpv6 protein', 75, NULL, NULL, 26145),
(26146, '1.10.220.10-FF-000076', NULL, 'AGAP012930-PA', 53, NULL, NULL, 26146),
(26147, '3.40.50.2000-FF-000009', NULL, 'Sterol 3-beta-glucosyltransferase UGT80A2', 170, NULL, NULL, 26147);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(26148, '1.10.20.10-FF-000099', NULL, 'nuclear transcription factor Y subunit beta', 118, NULL, NULL, 26148),
(26149, '1.10.530.10-FF-000066', NULL, 'Probable endopeptidase YddH', 144, NULL, NULL, 26149),
(26150, '2.30.29.30-FF-001370', NULL, 'Predicted protein', 125, NULL, NULL, 26150),
(26151, '2.60.40.10-FF-002597', NULL, 'Muscle M-line assembly protein unc-89', 98, NULL, NULL, 26151),
(26152, '1.10.3430.10-FF-000024', NULL, 'Putative ammonium transporter 4 member 1', 229, NULL, NULL, 26152),
(26153, '3.30.160.60-FF-004227', NULL, NULL, 26, NULL, NULL, 26153),
(26154, '1.25.40.690-FF-000002', NULL, 'Nuclear pore complex protein NUP96', 92, NULL, NULL, 26154),
(26155, '1.20.58.2050-FF-000007', NULL, 'DNA replication complex GINS protein PSF3', 175, NULL, NULL, 26155),
(26156, '2.40.70.10-FF-000464', NULL, NULL, 175, NULL, NULL, 26156),
(26157, '3.40.50.300-FF-008376', NULL, 'Predicted protein', 123, NULL, NULL, 26157),
(26158, '3.40.50.150-FF-000658', NULL, 'Anamorsin', 196, NULL, NULL, 26158),
(26159, '2.60.40.1460-FF-000012', NULL, 'Integrin alpha ina-1', 168, NULL, NULL, 26159),
(26160, '3.80.10.10-FF-001075', NULL, 'Leucine rich repeat containing 8 VRAC subunit Db', 69, NULL, NULL, 26160),
(26161, '3.80.10.10-FF-001187', NULL, 'Acid labile subunit', 199, NULL, NULL, 26161),
(26162, '2.20.100.10-FF-000044', NULL, 'Thrombospondin type 1 domain containing 4', 57, NULL, NULL, 26162),
(26163, '2.130.10.10-FF-002687', NULL, 'Wdr-12', 337, NULL, NULL, 26163),
(26164, '1.10.472.10-FF-000071', NULL, 'cyclin-related protein FAM58A isoform X1', 123, NULL, NULL, 26164),
(26165, '3.20.20.210-FF-000017', NULL, 'Uroporphyrinogen decarboxylase', 353, NULL, NULL, 26165),
(26166, '1.10.287.70-FF-000669', NULL, 'Uncharacterized protein', 114, NULL, NULL, 26166),
(26167, '3.30.160.60-FF-005975', NULL, NULL, 62, NULL, NULL, 26167),
(26168, '1.25.40.10-FF-002422', NULL, 'Pentatricopeptide repeat-containing protein', 131, NULL, NULL, 26168),
(26169, '3.10.450.10-FF-000046', NULL, 'AGAP002879-PA', 110, NULL, NULL, 26169),
(26170, '1.25.40.10-FF-004496', NULL, 'Uncharacterized protein', 96, NULL, NULL, 26170),
(26171, '1.10.10.60-FF-000259', NULL, 'MYB transcription factor', 67, NULL, NULL, 26171),
(26172, '3.40.50.150-FF-000439', NULL, 'Anamorsin homolog', 150, NULL, NULL, 26172),
(26173, '3.90.550.10-FF-000715', NULL, 'Putative polyprenol phosphate mannosyl transferase 1 (Ppm1)', 264, NULL, NULL, 26173),
(26174, '1.20.1250.10-FF-000052', NULL, 'Interleukin-3', 122, NULL, NULL, 26174),
(26175, '2.30.30.140-FF-000197', NULL, 'Uncharacterized protein', 85, NULL, NULL, 26175),
(26176, '3.20.140.10-FF-000003', NULL, 'Nicotinate phosphoribosyltransferase', 291, NULL, NULL, 26176),
(26177, '1.25.40.180-FF-000231', NULL, NULL, 244, NULL, NULL, 26177),
(26178, '3.90.290.10-FF-000004', NULL, 'latent-transforming growth factor beta-binding protein 1 isoform X1', 72, NULL, NULL, 26178),
(26179, '3.40.50.300-FF-005796', NULL, 'DNA replication licensing factor, MCM2/3/5 family', 62, NULL, NULL, 26179),
(26180, '2.120.10.80-FF-000336', NULL, 'Novel protein', 122, NULL, NULL, 26180),
(26181, '2.70.170.10-FF-000144', NULL, 'Transmembrane ion channel', 225, NULL, NULL, 26181),
(26182, '1.20.1250.20-FF-000055', NULL, 'Facilitated trehalose transporter Tret1-2 homolog', 441, NULL, NULL, 26182),
(26183, '1.10.10.10-FF-000672', NULL, 'Iron dependent repressor', 70, NULL, NULL, 26183),
(26184, '3.40.50.80-FF-000211', NULL, 'Iron-chelator utilization protein, putative', 113, NULL, NULL, 26184),
(26185, '1.10.238.10-FF-000875', NULL, 'Uncharacterized protein', 179, NULL, NULL, 26185),
(26186, '1.10.10.10-FF-000615', NULL, 'Transcriptional regulator, AsnC family', 51, NULL, NULL, 26186),
(26187, '1.20.1250.20-FF-001691', NULL, 'Esterase-6-like Protein', 245, NULL, NULL, 26187),
(26188, '2.60.40.10-FF-000523', NULL, 'obscurin isoform X4', 92, NULL, NULL, 26188),
(26189, '3.40.50.300-FF-004048', NULL, 'Circularly permutated Ras protein 1', 59, NULL, NULL, 26189),
(26190, '2.60.40.10-FF-001130', NULL, 'tyrosine-protein phosphatase Lar isoform X3', 99, NULL, NULL, 26190);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(26191, '3.40.50.2000-FF-000066', NULL, 'UDP-glucuronosyltransferase 1-1', 193, NULL, NULL, 26191),
(26192, '3.40.140.10-FF-000196', NULL, 'Predicted protein', 167, NULL, NULL, 26192),
(26193, '2.40.40.10-FF-000018', NULL, NULL, 197, NULL, NULL, 26193),
(26194, '2.60.40.60-FF-000908', NULL, 'Protocadherin 20', 105, NULL, NULL, 26194),
(26195, '3.30.1390.10-FF-000007', NULL, '50S ribosomal protein L12, apicoplast', 73, NULL, NULL, 26195),
(26196, '1.25.10.10-FF-000852', NULL, 'Importin alpha re-exporter, putative', 843, NULL, NULL, 26196),
(26197, '1.25.40.630-FF-000006', NULL, 'Cleavage and termination factor 1', 93, NULL, NULL, 26197),
(26198, '3.40.190.10-FF-000704', NULL, 'Periplasmic substrate binding protein family 1', 176, NULL, NULL, 26198),
(26199, '3.10.20.10-FF-000038', NULL, 'Cell death-inducing DFFA-like effector c', 113, NULL, NULL, 26199),
(26200, '1.25.40.20-FF-001065', NULL, 'Poly [ADP-ribose] polymerase', 275, NULL, NULL, 26200),
(26201, '3.10.350.10-FF-000044', NULL, 'Peptidase, M23 family', 51, NULL, NULL, 26201),
(26202, '1.25.10.10-FF-002544', NULL, 'Uncharacterized protein', 180, NULL, NULL, 26202),
(26203, '1.20.1300.10-FF-000006', NULL, 'Succinate dehydrogenase cytochrome b560 subunit, mitochondrial', 108, NULL, NULL, 26203),
(26204, '1.20.1070.10-FF-002140', NULL, 'Predicted protein', 214, NULL, NULL, 26204),
(26205, '3.30.450.70-FF-000031', NULL, NULL, 142, NULL, NULL, 26205),
(26206, '3.10.110.10-FF-000228', NULL, 'Ubiquitin-conjugating enzyme E2, putative', 174, NULL, NULL, 26206),
(26207, '2.10.25.10-FF-001827', NULL, 'Uncharacterized protein', 37, NULL, NULL, 26207),
(26208, '2.60.60.30-FF-000007', NULL, 'General stress protein 16U', 158, NULL, NULL, 26208),
(26209, '3.40.50.150-FF-000591', NULL, 'Methyltransferase', 105, NULL, NULL, 26209),
(26210, '1.10.472.130-FF-000093', NULL, 'Cytoplasmic dynein heavy chain-like protein', 150, NULL, NULL, 26210),
(26211, '3.30.160.60-FF-002209', NULL, NULL, 28, NULL, NULL, 26211),
(26212, '3.30.360.50-FF-000007', NULL, 'Uncharacterized protein', 37, NULL, NULL, 26212),
(26213, '3.40.50.2300-FF-001578', NULL, NULL, 146, NULL, NULL, 26213),
(26214, '1.20.120.530-FF-000002', NULL, 'GntR family transcriptional regulator', 135, NULL, NULL, 26214),
(26215, '3.40.640.10-FF-000453', NULL, 'Uncharacterized protein', 240, NULL, NULL, 26215),
(26216, '3.90.1150.10-FF-000049', NULL, 'Alanine-glyoxylate aminotransferase 1', 90, NULL, NULL, 26216),
(26217, '3.20.80.10-FF-000019', NULL, 'Uncharacterized protein', 201, NULL, NULL, 26217),
(26218, '3.30.360.30-FF-000001', NULL, 'Homospermidine synthase', 290, NULL, NULL, 26218),
(26219, '1.20.120.350-FF-000156', NULL, NULL, 142, NULL, NULL, 26219),
(26220, '1.10.472.10-FF-000632', NULL, 'Uncharacterized protein', 121, NULL, NULL, 26220),
(26221, '3.30.160.60-FF-006470', NULL, NULL, 49, NULL, NULL, 26221),
(26222, '1.25.10.10-FF-000453', NULL, 'Uncharacterized protein', 232, NULL, NULL, 26222),
(26223, '3.30.60.20-FF-000088', NULL, 'Protein kinase C', 38, NULL, NULL, 26223),
(26224, '2.120.10.30-FF-000417', NULL, 'Uncharacterized protein', 180, NULL, NULL, 26224),
(26225, '3.90.1100.10-FF-000046', NULL, 'DNA-directed RNA polymerase subunit beta', 123, NULL, NULL, 26225),
(26226, '3.30.200.20-FF-000453', NULL, 'Calcium/calmodulin-dependent protein kinase type 1G', 95, NULL, NULL, 26226),
(26227, '2.60.40.150-FF-000324', NULL, 'Rab-3-interacting molecule unc-10', 137, NULL, NULL, 26227),
(26228, '3.40.50.1820-FF-001355', NULL, 'Esterase/lipase/thioesterase family protein', 238, NULL, NULL, 26228),
(26229, '3.30.710.10-FF-000039', NULL, 'Zinc finger and BTB domain containing 20', 122, NULL, NULL, 26229),
(26230, '3.40.50.300-FF-006414', NULL, 'Uncharacterized protein', 131, NULL, NULL, 26230),
(26231, '1.10.150.20-FF-000141', NULL, 'Holliday junction ATP-dependent DNA helicase RuvA', 69, NULL, NULL, 26231),
(26232, '1.10.10.60-FF-000591', NULL, 'Transcriptional regulator, AraC/XylS family', 53, NULL, NULL, 26232),
(26233, '3.40.20.10-FF-000003', NULL, 'Protein transport protein SEC23', 105, NULL, NULL, 26233);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(26234, '1.25.40.10-FF-002079', NULL, 'GD12338', 134, NULL, NULL, 26234),
(26235, '1.10.3210.10-FF-000081', NULL, 'Uncharacterized protein', 203, NULL, NULL, 26235),
(26236, '1.20.120.420-FF-000025', NULL, 'Uncharacterized protein', 154, NULL, NULL, 26236),
(26237, '3.90.79.10-FF-000125', NULL, 'Probable nudix hydrolase C6G9.05', 175, NULL, NULL, 26237),
(26238, '3.60.130.10-FF-000033', NULL, 'Uncharacterized protein', 342, NULL, NULL, 26238),
(26239, '1.10.1410.10-FF-000056', NULL, 'Speckle targeted PIP5K1A-regulated poly(A) polymerase', 12, NULL, NULL, 26239),
(26240, '1.10.506.10-FF-000072', NULL, 'Plexin B3', 227, NULL, NULL, 26240),
(26241, '3.30.559.10-FF-000029', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 222, NULL, NULL, 26241),
(26242, '1.10.238.10-FF-000656', NULL, 'Dynein light chain', 65, NULL, NULL, 26242),
(26243, '1.25.40.20-FF-000683', NULL, 'Uncharacterized protein', 102, NULL, NULL, 26243),
(26244, '3.20.20.220-FF-000077', NULL, 'Proline dehydrogenase', 145, NULL, NULL, 26244),
(26245, '1.10.533.10-FF-000269', NULL, 'Uncharacterized protein', 100, NULL, NULL, 26245),
(26246, '1.10.510.10-FF-000918', NULL, 'Kinase, Wnk', 187, NULL, NULL, 26246),
(26247, '2.10.110.10-FF-000266', NULL, 'Insulin gene enhancer protein ISL-1', 122, NULL, NULL, 26247),
(26248, '1.25.40.10-FF-000680', NULL, 'Pre-mRNA-splicing factor SYF1', 127, NULL, NULL, 26248),
(26249, '1.10.472.10-FF-000290', NULL, 'Uncharacterized protein', 78, NULL, NULL, 26249),
(26250, '4.10.60.10-FF-000033', NULL, 'Glycine-rich RNA-binding protein RZ1C', 39, NULL, NULL, 26250),
(26251, '2.60.40.1510-FF-000050', NULL, 'Integrin beta', 106, NULL, NULL, 26251),
(26252, '2.60.40.150-FF-000088', NULL, 'multiple C2 and transmembrane domain-containing protein 2 isoform X2', 133, NULL, NULL, 26252),
(26253, '3.40.50.1480-FF-000027', NULL, NULL, 62, NULL, NULL, 26253),
(26254, '2.40.240.20-FF-000002', NULL, 'Ribosomal RNA small subunit methyltransferase E', 67, NULL, NULL, 26254),
(26255, '2.30.30.40-FF-000437', NULL, 'Chromosome 16, whole genome shotgun sequence', 60, NULL, NULL, 26255),
(26256, '1.10.470.10-FF-000010', NULL, 'Variant surface glycoprotein (VSG, atypical), putative', 152, NULL, NULL, 26256),
(26257, '2.130.10.10-FF-002305', NULL, 'Pwp1p', 365, NULL, NULL, 26257),
(26258, '3.90.320.10-FF-000041', NULL, 'Sll1582 protein', 206, NULL, NULL, 26258),
(26259, '3.30.430.20-FF-000004', NULL, 'Receptor-like serine-threonine protein kinase', 103, NULL, NULL, 26259),
(26260, '2.120.10.30-FF-000075', NULL, 'S9 family peptidase', 239, NULL, NULL, 26260),
(26261, '3.40.50.12780-FF-000123', NULL, 'Nonribosomal peptide synthetase fmqC', 397, NULL, NULL, 26261),
(26262, '1.10.287.3700-FF-000006', NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', 85, NULL, NULL, 26262),
(26263, '2.40.10.10-FF-000359', NULL, NULL, 83, NULL, NULL, 26263),
(26264, '1.10.472.10-FF-000576', NULL, 'Cyclin D, copy B-like protein', 51, NULL, NULL, 26264),
(26265, '2.170.140.10-FF-000045', NULL, 'GD12760', 66, NULL, NULL, 26265),
(26266, '3.10.129.10-FF-000142', NULL, 'Acyl-CoA thioesterase', 134, NULL, NULL, 26266),
(26267, '1.25.40.20-FF-001301', NULL, 'Uncharacterized protein', 155, NULL, NULL, 26267),
(26268, '1.20.5.580-FF-000001', NULL, 'Complexin 2', 63, NULL, NULL, 26268),
(26269, '3.40.50.720-FF-002313', NULL, 'Putative 2-hydroxyacid dehydrogenase C1773.17c', 132, NULL, NULL, 26269),
(26270, '3.80.10.10-FF-004222', NULL, 'Uncharacterized protein', 82, NULL, NULL, 26270),
(26271, '3.30.1370.170-FF-000005', NULL, 'Erythronate-4-phosphate dehydrogenase', 80, NULL, NULL, 26271),
(26272, '2.40.70.10-FF-000245', NULL, 'Nuclear receptor interacting protein 2', 121, NULL, NULL, 26272),
(26273, '3.80.30.20-FF-000005', NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase', 238, NULL, NULL, 26273),
(26274, '3.30.160.60-FF-002827', NULL, 'Uncharacterized protein, isoform A', 58, NULL, NULL, 26274),
(26275, '1.10.238.10-FF-000370', NULL, 'Mitochondrial substrate carrier family protein', 96, NULL, NULL, 26275);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(26276, '1.25.40.10-FF-004277', NULL, 'TPR Domain containing protein', 210, NULL, NULL, 26276),
(26277, '2.10.25.10-FF-001086', NULL, 'SCO-spondin', 52, NULL, NULL, 26277),
(26278, '3.30.750.24-FF-000027', NULL, 'Solute carrier family 26 member 10', 142, NULL, NULL, 26278),
(26279, '3.50.50.60-FF-000531', NULL, 'Flavoprotein monooxygenase, putative', 254, NULL, NULL, 26279),
(26280, '1.10.8.870-FF-000017', NULL, 'Glycerol-3-phosphate dehydrogenase', 69, NULL, NULL, 26280),
(26281, '3.30.420.40-FF-000099', NULL, 'Heat shock 70 kDa protein 13', 39, NULL, NULL, 26281),
(26282, '2.60.40.1930-FF-000001', NULL, 'CD109 isoform 3', 100, NULL, NULL, 26282),
(26283, '3.30.160.60-FF-004626', NULL, NULL, 25, NULL, NULL, 26283),
(26284, '3.40.1280.10-FF-000014', NULL, 'Predicted protein', 163, NULL, NULL, 26284),
(26285, '3.30.465.10-FF-000143', NULL, 'Predicted protein', 201, NULL, NULL, 26285),
(26286, '3.10.250.10-FF-000059', NULL, 'Uncharacterized protein', 110, NULL, NULL, 26286),
(26287, '2.60.40.1940-FF-000004', NULL, 'Alpha-2-macroglobulin like 1', 121, NULL, NULL, 26287),
(26288, '2.60.40.10-FF-002378', NULL, 'Stretchin-Mlck, isoform T', 102, NULL, NULL, 26288),
(26289, '3.10.490.10-FF-000043', NULL, 'Gamma-glutamylcyclotransferase', 183, NULL, NULL, 26289),
(26290, '1.50.40.10-FF-000447', NULL, 'Os11g0423800 protein', 137, NULL, NULL, 26290),
(26291, '3.30.160.890-FF-000001', NULL, 'Genome polyprotein', 70, NULL, NULL, 26291),
(26292, '3.30.160.60-FF-006138', NULL, NULL, 69, NULL, NULL, 26292),
(26293, '3.10.129.10-FF-000103', NULL, 'WGS project CABT00000000 data, contig 2.1', 119, NULL, NULL, 26293),
(26294, '3.15.10.30-FF-000016', NULL, NULL, 123, NULL, NULL, 26294),
(26295, '2.30.29.170-FF-000012', NULL, 'EF-Hand domain-Containing protein 1 homolog', 125, NULL, NULL, 26295),
(26296, '3.40.50.300-FF-006291', NULL, 'Uncharacterized protein', 206, NULL, NULL, 26296),
(26297, '1.20.1050.60-FF-000001', NULL, 'Putative alpha-1,2-mannosidase', 95, NULL, NULL, 26297),
(26298, '1.20.1440.180-FF-000004', NULL, 'Protein kinase, putative', 129, NULL, NULL, 26298),
(26299, '2.10.110.10-FF-000322', NULL, 'Paxillin-B', 58, NULL, NULL, 26299),
(26300, '1.10.630.10-FF-000686', NULL, 'Uncharacterized protein', 153, NULL, NULL, 26300),
(26301, '3.30.420.580-FF-000013', NULL, 'Actin-related protein 8', 85, NULL, NULL, 26301),
(26302, '1.20.5.320-FF-000007', NULL, 'Collagen type XIII alpha 1 chain', 50, NULL, NULL, 26302),
(26303, '1.10.510.10-FF-000290', NULL, 'LRR receptor-like serine/threonine-protein kinase ERECTA', 202, NULL, NULL, 26303),
(26304, '1.10.260.30-FF-000011', NULL, 'SRP54-type protein, putative', 136, NULL, NULL, 26304),
(26305, '3.30.160.60-FF-002428', NULL, 'Uncharacterized protein', 28, NULL, NULL, 26305),
(26306, '1.10.260.40-FF-000014', NULL, 'Cytoskeleton protein RodZ', 107, NULL, NULL, 26306),
(26307, '1.20.5.190-FF-000154', NULL, NULL, 35, NULL, NULL, 26307),
(26308, '3.30.200.20-FF-000633', NULL, 'Protein kinase, putative', 83, NULL, NULL, 26308),
(26309, '1.25.40.10-FF-002478', NULL, 'GM21091', 236, NULL, NULL, 26309),
(26310, '3.40.640.10-FF-000273', NULL, 'Aminotransferase, putative', 244, NULL, NULL, 26310),
(26311, '1.10.238.10-FF-000038', NULL, 'EH domain-containing protein 3', 103, NULL, NULL, 26311),
(26312, '3.30.160.60-FF-002485', NULL, 'Potential zinc finger protein', 26, NULL, NULL, 26312),
(26313, '3.40.50.2000-FF-000010', NULL, 'Alpha,alpha-trehalose-phosphate synthase', 214, NULL, NULL, 26313),
(26314, '2.40.37.10-FF-000044', NULL, 'Ornithine decarboxylase', 141, NULL, NULL, 26314),
(26315, '1.20.5.170-FF-000035', NULL, 'TNF receptor-associated factor', 66, NULL, NULL, 26315),
(26316, '2.60.120.10-FF-000767', NULL, 'Uncharacterized protein', 55, NULL, NULL, 26316),
(26317, '1.20.1070.10-FF-001084', NULL, 'Octopamine receptor beta-2R', 323, NULL, NULL, 26317),
(26318, '2.60.410.10-FF-000002', NULL, 'D-alanyl-D-alanine carboxypeptidase dacD', 91, NULL, NULL, 26318),
(26319, '2.20.100.10-FF-000100', NULL, 'Sporozoite surface protein 2', 47, NULL, NULL, 26319),
(26320, '1.20.58.60-FF-000801', NULL, 'Uncharacterized protein', 205, NULL, NULL, 26320);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(26321, '3.40.50.1000-FF-000659', NULL, NULL, 132, NULL, NULL, 26321),
(26322, '2.30.42.10-FF-000107', NULL, '26S proteasome non-ATPase regulatory subunit 9', 99, NULL, NULL, 26322),
(26323, '3.60.15.10-FF-000035', NULL, 'Phosphonate metabolism protein PhnP', 251, NULL, NULL, 26323),
(26324, '3.30.210.10-FF-000018', NULL, 'Polymerase (DNA directed), mu', 112, NULL, NULL, 26324),
(26325, '1.10.1420.10-FF-000175', NULL, 'Uncharacterized protein', 143, NULL, NULL, 26325),
(26326, '1.20.1070.10-FF-000122', NULL, 'Gastrin-releasing peptide receptor', 356, NULL, NULL, 26326),
(26327, '2.40.370.10-FF-000003', NULL, 'Kievitone hydratase', 131, NULL, NULL, 26327),
(26328, '1.20.1440.170-FF-000001', NULL, 'Translation machinery-associated 16 homolog', 122, NULL, NULL, 26328),
(26329, '2.70.170.10-FF-000088', NULL, 'Ligand-Gated ion Channel', 200, NULL, NULL, 26329),
(26330, '3.30.710.10-FF-000152', NULL, 'Predicted protein', 112, NULL, NULL, 26330),
(26331, '2.40.70.10-FF-000520', NULL, NULL, 58, NULL, NULL, 26331),
(26332, '2.70.150.10-FF-000199', NULL, 'Phospholipid-transporting ATPase', 135, NULL, NULL, 26332),
(26333, '2.60.120.200-FF-000404', NULL, 'ALK tyrosine kinase receptor homolog scd-2', 177, NULL, NULL, 26333),
(26334, '1.10.10.10-FF-001110', NULL, 'DNA-binding transcriptional regulator, MarR family', 114, NULL, NULL, 26334),
(26335, '1.20.1200.10-FF-000010', NULL, 'Metabolism of cobalamin associated B', 118, NULL, NULL, 26335),
(26336, '1.25.40.10-FF-004552', NULL, 'Chromosome 1, whole genome shotgun sequence', 220, NULL, NULL, 26336),
(26337, '3.30.70.330-FF-001949', NULL, NULL, 161, NULL, NULL, 26337),
(26338, '2.20.25.420-FF-000008', NULL, 'Zinc-finger protein zpr1', 52, NULL, NULL, 26338),
(26339, '3.30.420.40-FF-000953', NULL, 'AGR099Cp', 60, NULL, NULL, 26339),
(26340, '1.10.10.10-FF-001054', NULL, 'GM24041', 78, NULL, NULL, 26340),
(26341, '3.30.200.20-FF-000015', NULL, 'Somatic embryogenesis receptor kinase 1', 108, NULL, NULL, 26341),
(26342, '1.20.1070.10-FF-002101', NULL, 'Predicted protein', 346, NULL, NULL, 26342),
(26343, '3.40.50.300-FF-002249', NULL, 'ATP-dependent RNA helicase DDX27', 176, NULL, NULL, 26343),
(26344, '1.25.40.10-FF-000281', NULL, 'Spermatogenesis associated 16', 145, NULL, NULL, 26344),
(26345, '3.40.50.1820-FF-000051', NULL, '(S)-hydroxynitrile lyase', 259, NULL, NULL, 26345),
(26346, '1.10.10.10-FF-000834', NULL, 'AsnC family transcriptional regulator', 49, NULL, NULL, 26346),
(26347, '1.10.287.110-FF-000423', NULL, 'Uncharacterized protein', 93, NULL, NULL, 26347),
(26348, '2.60.320.30-FF-000001', NULL, 'Tail fiber protein', 90, NULL, NULL, 26348),
(26349, '2.60.200.20-FF-000248', NULL, 'Uncharacterized protein', 121, NULL, NULL, 26349),
(26350, '3.30.70.330-FF-001663', NULL, NULL, 116, NULL, NULL, 26350),
(26351, '2.115.10.20-FF-000022', NULL, 'Uncharacterized protein', 158, NULL, NULL, 26351),
(26352, '1.25.40.10-FF-000623', NULL, 'Tetratricopeptide repeat protein 30 homolog', 185, NULL, NULL, 26352),
(26353, '2.60.40.10-FF-002653', NULL, 'AGAP012059-PA', 106, NULL, NULL, 26353),
(26354, '3.40.50.300-FF-006178', NULL, 'Guanine nucleotide-binding protein G(s) subunit alpha isoforms short', 241, NULL, NULL, 26354),
(26355, '2.170.270.10-FF-000049', NULL, 'Histone-lysine N-methyltransferase, putative', 146, NULL, NULL, 26355),
(26356, '3.40.50.1000-FF-000715', NULL, NULL, 96, NULL, NULL, 26356),
(26357, '2.60.120.620-FF-000137', NULL, 'Uncharacterized protein', 238, NULL, NULL, 26357),
(26358, '3.10.100.10-FF-000166', NULL, 'Mannose receptor, C type 1b', 143, NULL, NULL, 26358),
(26359, '1.20.200.10-FF-000027', NULL, 'Argininosuccinate lyase', 202, NULL, NULL, 26359),
(26360, '1.10.600.10-FF-000116', NULL, 'Decaprenyl-diphosphate synthase subunit 2', 205, NULL, NULL, 26360),
(26361, '1.20.1090.10-FF-000011', NULL, 'Putative oxidoreductase', 201, NULL, NULL, 26361),
(26362, '3.40.50.2300-FF-001398', NULL, NULL, 151, NULL, NULL, 26362),
(26363, '1.10.620.20-FF-000008', NULL, 'Ribonucleoside-diphosphate reductase', 307, NULL, NULL, 26363),
(26364, '2.60.40.420-FF-000135', NULL, 'Laccase', 203, NULL, NULL, 26364);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(26365, '3.30.230.10-FF-000401', NULL, 'Ribosome-releasing factor 2, mitochondrial', 71, NULL, NULL, 26365),
(26366, '2.40.50.140-FF-000075', NULL, '26S protease regulatory subunit 7', 127, NULL, NULL, 26366),
(26367, '3.30.420.10-FF-000051', NULL, 'DNA polymerase I', 254, NULL, NULL, 26367),
(26368, '3.40.50.620-FF-000703', NULL, 'Electron transfer flavoprotein beta subunit', 244, NULL, NULL, 26368),
(26369, '1.20.1420.30-FF-000094', NULL, 'Uncharacterized protein', 234, NULL, NULL, 26369),
(26370, '1.10.10.580-FF-000018', NULL, 'AaceriAEL007Wp', 82, NULL, NULL, 26370),
(26371, '3.40.50.1000-FF-000772', NULL, NULL, 102, NULL, NULL, 26371),
(26372, '3.10.100.10-FF-000346', NULL, NULL, 149, NULL, NULL, 26372),
(26373, '2.60.120.10-FF-000368', NULL, 'Crp/Fnr family transcriptional regulator', 136, NULL, NULL, 26373),
(26374, '1.25.40.20-FF-000284', NULL, 'Lysophospholipase, putative', 123, NULL, NULL, 26374),
(26375, '3.40.50.150-FF-000478', NULL, 'YBR271W-like protein', 219, NULL, NULL, 26375),
(26376, '1.20.1070.10-FF-000066', NULL, 'Dopamine receptor D3', 273, NULL, NULL, 26376),
(26377, '1.10.1270.20-FF-000002', NULL, 'tRNA (guanine-N(1)-)-methyltransferase', 85, NULL, NULL, 26377),
(26378, '2.130.10.130-FF-000059', NULL, NULL, 87, NULL, NULL, 26378),
(26379, '3.90.550.50-FF-000031', NULL, 'Uncharacterized protein', 207, NULL, NULL, 26379),
(26380, '3.10.105.10-FF-000099', NULL, 'ABC-type transport system, periplasmic component, involved in antimicrobial peptide resistance', 219, NULL, NULL, 26380),
(26381, '1.10.357.10-FF-000056', NULL, 'Transcriptional regulator, TetR family', 198, NULL, NULL, 26381),
(26382, '2.40.160.10-FF-000066', NULL, 'Uncharacterized protein', 157, NULL, NULL, 26382),
(26383, '2.60.40.10-FF-002833', NULL, 'High Incidence of Males (Increased X chromosome loss)', 94, NULL, NULL, 26383),
(26384, '2.30.230.10-FF-000001', NULL, 'Microsomal triglyceride transfer protein large subunit', 246, NULL, NULL, 26384),
(26385, '3.40.30.10-FF-000684', NULL, 'Chloride intracellular channel exl-1', 95, NULL, NULL, 26385),
(26386, '1.10.10.10-FF-000559', NULL, 'Transcriptional regulator, IclR family', 72, NULL, NULL, 26386),
(26387, '2.60.40.10-FF-000798', NULL, 'Plexin B2', 88, NULL, NULL, 26387),
(26388, '3.30.70.1010-FF-000002', NULL, 'Eukaryotic translation elongation factor 1 gamma, putative', 151, NULL, NULL, 26388),
(26389, '3.60.21.10-FF-000325', NULL, 'Uncharacterized protein', 276, NULL, NULL, 26389),
(26390, '2.60.450.20-FF-000002', NULL, 'Spindle assembly abnormal 4', 186, NULL, NULL, 26390),
(26391, '3.20.100.10-FF-000006', NULL, 'mRNA capping enzyme, putative', 215, NULL, NULL, 26391),
(26392, '1.20.20.10-FF-000014', NULL, 'ATP synthase subunit 9, mitochondrial', 76, NULL, NULL, 26392),
(26393, '3.30.70.330-FF-002500', NULL, NULL, 73, NULL, NULL, 26393),
(26394, '3.30.1490.100-FF-000028', NULL, 'DNA polymerase IV', 112, NULL, NULL, 26394),
(26395, '4.10.320.10-FF-000016', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 52, NULL, NULL, 26395),
(26396, '2.30.29.30-FF-001257', NULL, 'AGC family protein kinase', 105, NULL, NULL, 26396),
(26397, '2.60.40.10-FF-001074', NULL, 'Tyrosine-protein kinase receptor', 103, NULL, NULL, 26397),
(26398, '4.10.60.10-FF-000090', NULL, 'Gag polyprotein', 61, NULL, NULL, 26398),
(26399, '2.130.10.10-FF-002249', NULL, 'Cleavage and polyadenylation specificity factor subunit 1', 147, NULL, NULL, 26399),
(26400, '1.10.10.570-FF-000015', NULL, 'Uncharacterized protein', 98, NULL, NULL, 26400),
(26401, '1.25.40.10-FF-000062', NULL, 'Signal recognition particle subunit SRP72', 154, NULL, NULL, 26401),
(26402, '3.30.70.870-FF-000054', NULL, 'Elongation factor Tu GTP-binding domain-containing 2', 43, NULL, NULL, 26402),
(26403, '2.60.40.10-FF-002092', NULL, 'Titin homolog', 98, NULL, NULL, 26403),
(26404, '3.30.230.10-FF-000126', NULL, 'Galactokinase', 178, NULL, NULL, 26404),
(26405, '3.90.70.10-FF-000712', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 201, NULL, NULL, 26405);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(26406, '2.60.40.150-FF-000762', NULL, 'Uncharacterized protein', 130, NULL, NULL, 26406),
(26407, '3.40.50.620-FF-000142', NULL, 'Universal stress protein A-like protein', 175, NULL, NULL, 26407),
(26408, '1.25.40.20-FF-000626', NULL, 'Uncharacterized protein', 99, NULL, NULL, 26408),
(26409, '2.40.30.10-FF-000068', NULL, 'Elongation factor Tu', 95, NULL, NULL, 26409),
(26410, '1.25.10.10-FF-002982', NULL, 'Uncharacterized protein', 383, NULL, NULL, 26410),
(26411, '2.60.40.2610-FF-000003', NULL, 'Outer membrane usher protein FasD', 90, NULL, NULL, 26411),
(26412, '3.30.40.10-FF-000651', NULL, 'Lysine-specific demethylase 5D', 103, NULL, NULL, 26412),
(26413, '2.40.50.140-FF-000417', NULL, '30S small subunit ribosomal protein S17', 83, NULL, NULL, 26413),
(26414, '3.40.50.1980-FF-000138', NULL, 'ABC-type Fe3+-siderophores transport system, periplasmic component, putative', 120, NULL, NULL, 26414),
(26415, '3.30.559.10-FF-000142', NULL, 'Uncharacterized protein', 150, NULL, NULL, 26415),
(26416, '3.80.10.10-FF-003547', NULL, 'Uncharacterized protein', 158, NULL, NULL, 26416),
(26417, '1.10.510.10-FF-003324', NULL, NULL, 65, NULL, NULL, 26417),
(26418, '2.30.180.10-FF-000171', NULL, NULL, 98, NULL, NULL, 26418),
(26419, '1.10.132.60-FF-000021', NULL, 'DNA polymerase alpha subunit one', 90, NULL, NULL, 26419),
(26420, '3.90.1750.10-FF-000073', NULL, 'Uncharacterized protein', 92, NULL, NULL, 26420),
(26421, '3.30.1540.20-FF-000006', NULL, 'PMS1 homolog 2, mismatch repair system component', 94, NULL, NULL, 26421),
(26422, '1.10.510.10-FF-002088', NULL, 'Protein_kinase_-_putative', 170, NULL, NULL, 26422),
(26423, '2.130.10.10-FF-002743', NULL, 'Predicted protein', 273, NULL, NULL, 26423),
(26424, '3.40.630.30-FF-000672', NULL, 'Acetyltransferase, putative', 146, NULL, NULL, 26424),
(26425, '1.20.58.60-FF-000127', NULL, 'microtubule-actin cross-linking factor 1 isoform X9', 119, NULL, NULL, 26425),
(26426, '3.40.50.1000-FF-000373', NULL, 'Phospholipid-transporting ATPase', 186, NULL, NULL, 26426),
(26427, '3.40.390.10-FF-000236', NULL, NULL, 77, NULL, NULL, 26427),
(26428, '1.10.1200.150-FF-000002', NULL, 'Transcriptional regulator CtsR', 81, NULL, NULL, 26428),
(26429, '3.30.1540.10-FF-000003', NULL, 'CoA-transferase family protein', 92, NULL, NULL, 26429),
(26430, '2.30.30.40-FF-000370', NULL, 'Plenty of SH3s', 73, NULL, NULL, 26430),
(26431, '3.30.750.24-FF-000140', NULL, 'Solute carrier family 26 member 6', 154, NULL, NULL, 26431),
(26432, '3.10.20.90-FF-000641', NULL, 'Autophagy-related protein', 121, NULL, NULL, 26432),
(26433, '1.20.1250.20-FF-000111', NULL, 'Solute carrier family 37 member 4', 199, NULL, NULL, 26433),
(26434, '1.10.1520.10-FF-000103', NULL, 'Uncharacterized protein', 133, NULL, NULL, 26434),
(26435, '2.60.120.260-FF-000405', NULL, 'Pesticidal crystal protein Cry5Ba', 156, NULL, NULL, 26435),
(26436, '3.90.70.10-FF-000358', NULL, 'Calcium-dependent cysteine protease, putative', 95, NULL, NULL, 26436),
(26437, '3.30.500.40-FF-000004', NULL, 'AGAP004049-PA', 153, NULL, NULL, 26437),
(26438, '3.40.630.10-FF-000284', NULL, 'Glutaminyl cyclase, putative', 145, NULL, NULL, 26438),
(26439, '1.20.120.1240-FF-000031', NULL, 'Dynamin GTPase, putative', 211, NULL, NULL, 26439),
(26440, '2.10.25.10-FF-001316', NULL, 'AGAP003873-PA', 39, NULL, NULL, 26440),
(26441, '3.60.21.10-FF-000426', NULL, 'Predicted protein', 262, NULL, NULL, 26441),
(26442, '3.40.50.300-FF-006268', NULL, 'Uncharacterized protein', 317, NULL, NULL, 26442),
(26443, '2.110.10.10-FF-000058', NULL, 'Matrix metallopeptidase 28', 191, NULL, NULL, 26443),
(26444, '3.40.30.10-FF-001145', NULL, 'F18O14.31', 51, NULL, NULL, 26444),
(26445, '3.40.50.300-FF-007420', NULL, 'Uncharacterized protein', 76, NULL, NULL, 26445),
(26446, '3.40.630.10-FF-000328', NULL, 'Glutamate carboxypeptidase, putative', 245, NULL, NULL, 26446),
(26447, '3.30.70.330-FF-002601', NULL, NULL, 133, NULL, NULL, 26447),
(26448, '3.40.50.300-FF-002569', NULL, 'Uncharacterized protein', 280, NULL, NULL, 26448),
(26449, '1.20.1250.20-FF-001589', NULL, 'Protein NRT1/ PTR FAMILY 5.11', 526, NULL, NULL, 26449);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(26450, '2.130.10.10-FF-000574', NULL, 'Transducin beta like 2', 191, NULL, NULL, 26450),
(26451, '2.130.10.10-FF-004273', NULL, 'Protein CBR-THOC-3.1', 130, NULL, NULL, 26451),
(26452, '1.25.40.790-FF-000021', NULL, 'Uncharacterized protein', 237, NULL, NULL, 26452),
(26453, '3.40.50.720-FF-001633', NULL, 'Fatty acyl-CoA reductase', 328, NULL, NULL, 26453),
(26454, '3.40.50.880-FF-000130', NULL, 'CTP synthase', 80, NULL, NULL, 26454),
(26455, '2.60.40.10-FF-000607', NULL, 'Leukemia inhibitory factor receptor', 110, NULL, NULL, 26455),
(26456, '2.60.40.10-FF-001113', NULL, 'Sallimus, isoform P', 96, NULL, NULL, 26456),
(26457, '1.20.20.10-FF-000003', NULL, 'Atp synthase f complex subunit mitochondrial', 72, NULL, NULL, 26457),
(26458, '2.60.40.10-FF-004295', NULL, NULL, 112, NULL, NULL, 26458),
(26459, '1.20.58.760-FF-000032', NULL, 'AAA ATPase central domain protein', 183, NULL, NULL, 26459),
(26460, '3.60.15.10-FF-000013', NULL, 'Persulfide dioxygenase ETHE1, mitochondrial', 230, NULL, NULL, 26460),
(26461, '1.10.510.10-FF-000609', NULL, 'Inactive LRR receptor-like serine/threonine-protein kinase BIR2', 222, NULL, NULL, 26461),
(26462, '2.40.30.10-FF-000478', NULL, 'Translation initiation factor IF-2, mitochondrial', 48, NULL, NULL, 26462),
(26463, '3.30.230.70-FF-000155', NULL, 'Uncharacterized protein', 69, NULL, NULL, 26463),
(26464, '2.60.40.420-FF-000051', NULL, 'Coagulation factor VIII', 143, NULL, NULL, 26464),
(26465, '3.40.50.300-FF-008522', NULL, 'Type II secretion system protein', 129, NULL, NULL, 26465),
(26466, '1.25.40.10-FF-002607', NULL, 'Pentatricopeptide repeat-containing protein At3g18970', 93, NULL, NULL, 26466),
(26467, '3.10.450.50-FF-000024', NULL, 'CMGC/MAPK protein kinase', 117, NULL, NULL, 26467),
(26468, '3.40.50.300-FF-000445', NULL, 'Phosphate acetyltransferase', 210, NULL, NULL, 26468),
(26469, '2.60.40.10-FF-004339', NULL, NULL, 171, NULL, NULL, 26469),
(26470, '3.90.226.10-FF-000209', NULL, 'Carboxyl-terminal protease', 158, NULL, NULL, 26470),
(26471, '3.40.640.10-FF-000256', NULL, 'NTD biosynthesis operon protein NtdA', 309, NULL, NULL, 26471),
(26472, '1.25.40.10-FF-004215', NULL, 'LOC100125120 protein', 55, NULL, NULL, 26472),
(26473, '1.25.10.10-FF-000335', NULL, 'cilia- and flagella-associated protein 69 isoform X1', 477, NULL, NULL, 26473),
(26474, '3.30.200.20-FF-002353', NULL, 'Boron transporter 4', 46, NULL, NULL, 26474),
(26475, '3.10.450.40-FF-000021', NULL, 'Amine oxidase', 103, NULL, NULL, 26475),
(26476, '2.120.10.80-FF-000320', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit', 162, NULL, NULL, 26476),
(26477, '1.20.1550.10-FF-000007', NULL, 'Disulfide bond formation protein B 1', 167, NULL, NULL, 26477),
(26478, '2.40.10.10-FF-000578', NULL, NULL, 52, NULL, NULL, 26478),
(26479, '3.30.565.40-FF-000002', NULL, 'Immunogenic protein MPT64', 118, NULL, NULL, 26479),
(26480, '3.40.1090.10-FF-000078', NULL, 'Patatin', 133, NULL, NULL, 26480),
(26481, '3.30.1370.10-FF-000192', NULL, 'KH domain-containing protein', 151, NULL, NULL, 26481),
(26482, '3.30.420.40-FF-000442', NULL, 'Pantothenate kinase 1', 121, NULL, NULL, 26482),
(26483, '3.40.50.720-FF-000531', NULL, 'NAD/FAD dependent dehydrogenase, putative', 255, NULL, NULL, 26483),
(26484, '1.10.472.10-FF-000037', NULL, 'Cyclin-A2', 130, NULL, NULL, 26484),
(26485, '1.20.140.150-FF-000044', NULL, 'Uncharacterized protein, isoform A', 177, NULL, NULL, 26485),
(26486, '3.50.50.60-FF-001397', NULL, 'Uncharacterized protein', 182, NULL, NULL, 26486),
(26487, '2.40.110.10-FF-000029', NULL, 'Acyl-CoA dehydrogenase', 121, NULL, NULL, 26487),
(26488, '3.40.50.150-FF-000574', NULL, 'Eukaryotic initiation factor 3, gamma subunit, putative', 193, NULL, NULL, 26488),
(26489, '1.25.40.10-FF-004541', NULL, 'Os02g0833050 protein', 233, NULL, NULL, 26489),
(26490, '2.60.40.10-FF-000596', NULL, 'Vascular endothelial growth factor receptor 2', 98, NULL, NULL, 26490),
(26491, '3.80.10.10-FF-000214', NULL, 'EIN3-binding F-box protein 1', 198, NULL, NULL, 26491),
(26492, '2.60.40.150-FF-000077', NULL, 'rab11 family-interacting protein 1 isoform X1', 138, NULL, NULL, 26492);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(26493, '2.60.40.3090-FF-000001', NULL, 'PHP domain-containing protein', 79, NULL, NULL, 26493),
(26494, '3.30.450.40-FF-000270', NULL, 'PAS sensor protein', 169, NULL, NULL, 26494),
(26495, '3.90.1750.10-FF-000067', NULL, 'Uncharacterized protein', 166, NULL, NULL, 26495),
(26496, '2.10.25.10-FF-000799', NULL, 'AGAP009716-PA', 39, NULL, NULL, 26496),
(26497, '3.30.160.60-FF-004744', NULL, NULL, 26, NULL, NULL, 26497),
(26498, '3.30.160.60-FF-005250', NULL, NULL, 29, NULL, NULL, 26498),
(26499, '2.60.120.650-FF-000106', NULL, 'Transcription factor jumonji (JmjC) domain-containing protein', 318, NULL, NULL, 26499),
(26500, '3.40.850.10-FF-000502', NULL, 'Uncharacterized protein', 209, NULL, NULL, 26500),
(26501, '2.30.29.30-FF-000251', NULL, 'Syntrophin beta 2', 91, NULL, NULL, 26501),
(26502, '1.10.150.20-FF-000146', NULL, 'DNaJ domain (Prokaryotic heat shock protein)', 57, NULL, NULL, 26502),
(26503, '3.30.200.20-FF-001847', NULL, 'Uncharacterized protein', 65, NULL, NULL, 26503),
(26504, '1.10.472.80-FF-000277', NULL, NULL, 184, NULL, NULL, 26504),
(26505, '1.10.472.10-FF-000363', NULL, 'Brf1-like TBP-binding domain-domain-containing protein', 90, NULL, NULL, 26505),
(26506, '1.25.10.10-FF-000970', NULL, 'ARM REPEAT PROTEIN INTERACTING WITH ABF2', 389, NULL, NULL, 26506),
(26507, '3.40.50.300-FF-004823', NULL, 'Helicase', 248, NULL, NULL, 26507),
(26508, '1.10.1380.10-FF-000013', NULL, 'neprilysin', 405, NULL, NULL, 26508),
(26509, '3.30.40.10-FF-002040', NULL, 'Uncharacterized protein', 97, NULL, NULL, 26509),
(26510, '1.25.40.10-FF-002933', NULL, 'Peptidylprolyl isomerase', 127, NULL, NULL, 26510),
(26511, '1.25.40.10-FF-000472', NULL, 'Putative pentatricopeptide repeat-containing protein', 97, NULL, NULL, 26511),
(26512, '3.30.160.60-FF-001181', NULL, 'Zinc finger protein 311', 28, NULL, NULL, 26512),
(26513, '3.40.50.300-FF-003042', NULL, 'Hemin import ATP-binding protein HmuV', 258, NULL, NULL, 26513),
(26514, '1.25.40.10-FF-000842', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 253, NULL, NULL, 26514),
(26515, '1.25.40.10-FF-002080', NULL, 'Protein PHOX4', 129, NULL, NULL, 26515),
(26516, '2.30.180.10-FF-000148', NULL, NULL, 55, NULL, NULL, 26516),
(26517, '2.40.50.1000-FF-000008', NULL, '40S ribosomal protein S11', 158, NULL, NULL, 26517),
(26518, '3.80.10.10-FF-003396', NULL, 'F-box and leucine rich repeat protein 14', 96, NULL, NULL, 26518),
(26519, '3.90.1180.10-FF-000012', NULL, '50S ribosomal protein L13', 142, NULL, NULL, 26519),
(26520, '1.10.287.130-FF-000030', NULL, 'Putative histidine kinase 5', 78, NULL, NULL, 26520),
(26521, '3.90.1150.10-FF-000510', NULL, 'Cysteine desulfurase', 99, NULL, NULL, 26521),
(26522, '2.130.10.10-FF-004317', NULL, 'Uncharacterized protein', 108, NULL, NULL, 26522),
(26523, '1.25.40.20-FF-000475', NULL, 'Uncharacterized protein', 97, NULL, NULL, 26523),
(26524, '1.10.472.130-FF-000059', NULL, 'Dynein heavy chain 9', 175, NULL, NULL, 26524),
(26525, '2.130.10.10-FF-002709', NULL, 'IP11840p', 318, NULL, NULL, 26525),
(26526, '2.120.10.30-FF-000092', NULL, 'GD20529', 411, NULL, NULL, 26526),
(26527, '3.80.10.10-FF-001479', NULL, 'Lutropin-choriogonadotropic hormone receptor', 332, NULL, NULL, 26527),
(26528, '3.10.20.90-FF-000938', NULL, 'PH domain-containing protein DDB_G0287875', 78, NULL, NULL, 26528),
(26529, '2.40.50.140-FF-000209', NULL, 'Replication protein A1, small', 107, NULL, NULL, 26529),
(26530, '1.25.40.20-FF-000845', NULL, 'Glycerophosphocholine phosphodiesterase GDE1', 209, NULL, NULL, 26530),
(26531, '3.30.70.141-FF-000022', NULL, 'Thioredoxin domain-containing protein 3', 137, NULL, NULL, 26531),
(26532, '3.30.40.10-FF-001860', NULL, 'Uncharacterized protein', 79, NULL, NULL, 26532),
(26533, '3.40.50.1000-FF-000581', NULL, NULL, 109, NULL, NULL, 26533),
(26534, '1.25.40.10-FF-000163', NULL, 'Transcriptional corepressor Cyc8', 131, NULL, NULL, 26534),
(26535, '3.30.40.10-FF-000432', NULL, 'E3 ubiquitin-protein ligase Hakai', 56, NULL, NULL, 26535),
(26536, '2.40.30.270-FF-000008', NULL, 'Unplaced genomic scaffold supercont2.3, whole genome shotgun sequence', 118, NULL, NULL, 26536);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(26537, '1.10.10.60-FF-000237', NULL, 'zinc fingers and homeoboxes protein 1', 59, NULL, NULL, 26537),
(26538, '1.25.10.10-FF-000661', NULL, 'Cell differentiation family, Rcd1-like containing protein', 272, NULL, NULL, 26538),
(26539, '1.25.40.420-FF-000005', NULL, 'BTB/POZ domain-containing protein 9', 95, NULL, NULL, 26539),
(26540, '2.70.150.10-FF-000249', NULL, 'Putative calcium-transporting ATPase 13 plasma membrane-type', 82, NULL, NULL, 26540),
(26541, '1.10.510.10-FF-002852', NULL, NULL, 248, NULL, NULL, 26541),
(26542, '3.90.1150.10-FF-000173', NULL, 'Glutamate-1-semialdehyde 2,1-aminomutase', 162, NULL, NULL, 26542),
(26543, '3.20.20.100-FF-000052', NULL, '2,5-diketo-D-gluconic acid reductase A', 273, NULL, NULL, 26543),
(26544, '3.40.50.1440-FF-000038', NULL, 'Tubulin epsilon chain', 397, NULL, NULL, 26544),
(26545, '3.10.20.90-FF-000629', NULL, 'Uncharacterized protein', 88, NULL, NULL, 26545),
(26546, '2.10.25.10-FF-001642', NULL, 'Aggrecan b', 75, NULL, NULL, 26546),
(26547, '3.40.50.300-FF-006594', NULL, 'Uncharacterized protein', 98, NULL, NULL, 26547),
(26548, '1.10.533.10-FF-000179', NULL, 'Uncharacterized protein', 103, NULL, NULL, 26548),
(26549, '4.10.870.10-FF-000001', NULL, 'Cellulose 1,4-beta-cellobiosidase', 65, NULL, NULL, 26549),
(26550, '3.10.20.230-FF-000014', NULL, 'Doublecortin domain containing 1', 91, NULL, NULL, 26550),
(26551, '3.30.200.20-FF-000419', NULL, 'Putative receptor-like protein kinase', 99, NULL, NULL, 26551),
(26552, '2.60.40.60-FF-000841', NULL, 'Uncharacterized protein', 76, NULL, NULL, 26552),
(26553, '3.40.50.300-FF-002199', NULL, 'Putative dynein heavy chain', 332, NULL, NULL, 26553),
(26554, '2.60.40.10-FF-000287', NULL, 'Prolactin receptor', 101, NULL, NULL, 26554),
(26555, '1.50.40.10-FF-000554', NULL, 'Solute carrier family 25 member 17', 130, NULL, NULL, 26555),
(26556, '3.40.30.10-FF-000791', NULL, 'Phosphoadenosine phosphosulfate reductase', 73, NULL, NULL, 26556),
(26557, '2.60.40.150-FF-000723', NULL, 'Uncharacterized protein', 121, NULL, NULL, 26557),
(26558, '1.20.120.330-FF-000026', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 132, NULL, NULL, 26558),
(26559, '3.30.565.10-FF-000089', NULL, 'Histidine kinase', 150, NULL, NULL, 26559),
(26560, '1.25.40.430-FF-000008', NULL, 'Unplaced genomic scaffold supercont1.188, whole genome shotgun sequence', 200, NULL, NULL, 26560),
(26561, '2.10.90.10-FF-000079', NULL, 'Uncharacterized protein', 119, NULL, NULL, 26561),
(26562, '2.60.120.260-FF-000085', NULL, 'probable allantoicase', 198, NULL, NULL, 26562),
(26563, '1.10.340.30-FF-000012', NULL, 'N-glycosylase/DNA lyase', 124, NULL, NULL, 26563),
(26564, '2.10.110.10-FF-000070', NULL, 'Four and a half LIM domains 3', 65, NULL, NULL, 26564),
(26565, '3.40.50.200-FF-000078', NULL, 'Uncharacterized protein', 138, NULL, NULL, 26565),
(26566, '3.40.190.10-FF-000148', NULL, 'ABC transporter substrate-binding protein', 186, NULL, NULL, 26566),
(26567, '1.20.1070.10-FF-001179', NULL, 'G-protein coupled receptor 126', 283, NULL, NULL, 26567),
(26568, '1.20.58.1030-FF-000044', NULL, 'DNA replication complex GINS protein SLD5', 83, NULL, NULL, 26568),
(26569, '2.120.10.30-FF-000445', NULL, 'Uncharacterized protein', 113, NULL, NULL, 26569),
(26570, '3.60.21.10-FF-000089', NULL, 'Vacuolar protein sorting-associated protein 29', 172, NULL, NULL, 26570),
(26571, '3.40.50.670-FF-000022', NULL, 'DNA gyrase subunit B', 220, NULL, NULL, 26571),
(26572, '3.80.10.10-FF-000799', NULL, 'Probable disease resistance protein At5g63020', 201, NULL, NULL, 26572),
(26573, '1.10.2020.20-FF-000012', NULL, NULL, 113, NULL, NULL, 26573),
(26574, '3.40.50.300-FF-006605', NULL, 'Midasin AAA ATPase 1', 96, NULL, NULL, 26574),
(26575, '2.10.220.10-FF-000089', NULL, 'Furin 2', 60, NULL, NULL, 26575),
(26576, '3.40.1210.10-FF-000004', NULL, '5''-nucleotidase SurE', 264, NULL, NULL, 26576),
(26577, '1.20.140.40-FF-000059', NULL, NULL, 133, NULL, NULL, 26577),
(26578, '3.30.60.10-FF-000006', NULL, 'Agglutinin isolectin 1', 41, NULL, NULL, 26578);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(26579, '1.25.40.10-FF-002287', NULL, 'Uncharacterized protein', 122, NULL, NULL, 26579),
(26580, '2.130.10.10-FF-000265', NULL, 'periodic tryptophan protein 2 homolog', 195, NULL, NULL, 26580),
(26581, '1.20.1530.20-FF-000099', NULL, 'Uncharacterized protein', 190, NULL, NULL, 26581),
(26582, '2.60.120.10-FF-000576', NULL, 'CRP-like cAMP-activated global transcriptional regulator', 145, NULL, NULL, 26582),
(26583, '1.20.1250.20-FF-001382', NULL, 'MFS general substrate transporter', 192, NULL, NULL, 26583),
(26584, '3.30.565.10-FF-000252', NULL, 'Two-component system sensor histidine kinase', 148, NULL, NULL, 26584),
(26585, '3.40.390.10-FF-000129', NULL, 'A disintegrin-like and metallopeptidase (reprolysin type) with thrombospondin type 1 motif, 6', 51, NULL, NULL, 26585),
(26586, '3.30.260.10-FF-000072', NULL, NULL, 92, NULL, NULL, 26586),
(26587, '1.10.730.10-FF-000137', NULL, 'Uncharacterized protein', 12, NULL, NULL, 26587),
(26588, '3.40.50.300-FF-008185', NULL, 'Uncharacterized protein', 81, NULL, NULL, 26588),
(26589, '3.20.20.70-FF-000758', NULL, NULL, 59, NULL, NULL, 26589),
(26590, '2.20.130.20-FF-000009', NULL, 'CD109 molecule', 68, NULL, NULL, 26590),
(26591, '3.30.160.60-FF-006352', NULL, NULL, 53, NULL, NULL, 26591),
(26592, '3.30.160.60-FF-004418', NULL, NULL, 27, NULL, NULL, 26592),
(26593, '3.30.230.130-FF-000088', NULL, 'Chromosome 8, whole genome shotgun sequence', 171, NULL, NULL, 26593),
(26594, '3.10.110.10-FF-000324', NULL, 'Chromosome 1, whole genome shotgun sequence', 159, NULL, NULL, 26594),
(26595, '1.10.1410.40-FF-000008', NULL, 'Inositol 1,4,5-trisphosphate receptor-interacting protein', 116, NULL, NULL, 26595),
(26596, '2.60.40.10-FF-003030', NULL, 'Interferon gamma receptor 2', 103, NULL, NULL, 26596),
(26597, '3.30.160.60-FF-003007', NULL, 'Zgc:174563 protein', 26, NULL, NULL, 26597),
(26598, '1.10.510.10-FF-000598', NULL, 'Serine/threonine protein kinase', 189, NULL, NULL, 26598),
(26599, '3.30.1740.10-FF-000001', NULL, 'DNA ligase', 96, NULL, NULL, 26599),
(26600, '2.30.38.10-FF-000013', NULL, 'Enniatin synthase', 79, NULL, NULL, 26600),
(26601, '3.30.60.20-FF-000009', NULL, 'Diacylglycerol kinase', 33, NULL, NULL, 26601),
(26602, '1.20.1070.10-FF-001488', NULL, 'Vomeronasal type-1 receptor', 203, NULL, NULL, 26602),
(26603, '1.10.10.60-FF-000563', NULL, 'Putative myb transcription factor', 50, NULL, NULL, 26603),
(26604, '2.60.40.10-FF-002541', NULL, 'Wrapper/Rega-1/Klingon homolog', 95, NULL, NULL, 26604),
(26605, '4.10.1000.10-FF-000011', NULL, 'Zinc finger CCCH domain-containing protein 11', 75, NULL, NULL, 26605),
(26606, '3.40.50.720-FF-000222', NULL, 'Glucose-6-phosphate 1-dehydrogenase', 175, NULL, NULL, 26606),
(26607, '1.10.3380.30-FF-000019', NULL, 'RNA helicase, superfamily II', 241, NULL, NULL, 26607),
(26608, '3.30.450.80-FF-000006', NULL, 'Transcriptional regulator, LuxR family', 163, NULL, NULL, 26608),
(26609, '3.40.50.11660-FF-000017', NULL, 'Alpha-(1,3)-fucosyltransferase', 209, NULL, NULL, 26609),
(26610, '1.10.510.10-FF-003032', NULL, NULL, 221, NULL, NULL, 26610),
(26611, '1.25.40.90-FF-000113', NULL, 'Uncharacterized protein', 60, NULL, NULL, 26611),
(26612, '3.30.1740.20-FF-000004', NULL, '30S ribosomal protein S26e', 95, NULL, NULL, 26612),
(26613, '3.40.50.1820-FF-000012', NULL, 'Lipase', 374, NULL, NULL, 26613),
(26614, '3.30.160.60-FF-004098', NULL, NULL, 34, NULL, NULL, 26614),
(26615, '3.50.50.60-FF-000132', NULL, 'Amine oxidase [flavin-containing] B', 182, NULL, NULL, 26615),
(26616, '3.90.550.50-FF-000233', NULL, 'RE01689p', 98, NULL, NULL, 26616),
(26617, '1.10.10.10-FF-000481', NULL, 'Transcriptional regulator, GntR family', 67, NULL, NULL, 26617),
(26618, '3.30.70.1390-FF-000014', NULL, 'Predicted protein', 92, NULL, NULL, 26618),
(26619, '3.40.50.2300-FF-000072', NULL, 'Gamma-aminobutyric acid type B receptor subunit 2', 207, NULL, NULL, 26619),
(26620, '1.25.40.10-FF-003698', NULL, 'Pentatricopeptide repeat-containing protein At4g01030, mitochondrial', 100, NULL, NULL, 26620),
(26621, '2.60.40.10-FF-002850', NULL, 'Coiled-coil domain-containing protein 141', 47, NULL, NULL, 26621);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(26622, '3.90.70.10-FF-000684', NULL, 'Uncharacterized protein', 249, NULL, NULL, 26622),
(26623, '3.30.1360.120-FF-000096', NULL, 'Predicted protein', 163, NULL, NULL, 26623),
(26624, '3.30.497.10-FF-000059', NULL, 'Putative serpin A13', 105, NULL, NULL, 26624),
(26625, '2.170.130.10-FF-000016', NULL, 'Outer membrane receptor for ferrienterochelin and colicins', 131, NULL, NULL, 26625),
(26626, '3.30.450.70-FF-000003', NULL, 'Trafficking particle complex subunit 4', 132, NULL, NULL, 26626),
(26627, '2.40.30.10-FF-000271', NULL, 'Probable oxidoreductase', 40, NULL, NULL, 26627),
(26628, '3.40.50.150-FF-001400', NULL, NULL, 166, NULL, NULL, 26628),
(26629, '3.30.70.270-FF-000161', NULL, 'Transposon Tf2-9 polyprotein-like Protein', 81, NULL, NULL, 26629),
(26630, '3.60.10.10-FF-000024', NULL, 'Tyrosyl-DNA phosphodiesterase 2', 253, NULL, NULL, 26630),
(26631, '3.40.50.150-FF-000911', NULL, NULL, 138, NULL, NULL, 26631),
(26632, '3.40.50.720-FF-001942', NULL, 'Uncharacterized protein', 271, NULL, NULL, 26632),
(26633, '1.10.3380.20-FF-000016', NULL, NULL, 106, NULL, NULL, 26633),
(26634, '3.30.310.210-FF-000007', NULL, 'Ribonuclease Y', 129, NULL, NULL, 26634),
(26635, '2.40.70.10-FF-000380', NULL, NULL, 194, NULL, NULL, 26635),
(26636, '1.10.150.20-FF-000163', NULL, 'DNA-directed RNA polymerase', 234, NULL, NULL, 26636),
(26637, '3.30.160.60-FF-004435', NULL, NULL, 27, NULL, NULL, 26637),
(26638, '3.30.160.60-FF-006335', NULL, NULL, 31, NULL, NULL, 26638),
(26639, '3.90.740.10-FF-000045', NULL, 'Leucine--tRNA ligase', 233, NULL, NULL, 26639),
(26640, '3.40.50.1820-FF-001782', NULL, 'Uncharacterized protein', 176, NULL, NULL, 26640),
(26641, '3.30.450.40-FF-000253', NULL, 'Uncharacterized protein', 121, NULL, NULL, 26641),
(26642, '3.90.226.10-FF-000182', NULL, 'Enoyl-CoA hydratase domain-containing protein 3, mitochondrial', 199, NULL, NULL, 26642),
(26643, '1.25.40.10-FF-004524', NULL, 'Hsp70/Hsp90 organizing protein', 73, NULL, NULL, 26643),
(26644, '3.60.40.20-FF-000001', NULL, 'Adenosine monophosphate-protein hydrolase SidD', 317, NULL, NULL, 26644),
(26645, '3.30.160.60-FF-005233', NULL, NULL, 21, NULL, NULL, 26645),
(26646, '2.60.40.150-FF-000386', NULL, 'Phosphatidylserine decarboxylase', 142, NULL, NULL, 26646),
(26647, '3.40.640.10-FF-000239', NULL, 'Cystathionine beta lyase', 252, NULL, NULL, 26647),
(26648, '2.40.100.10-FF-000074', NULL, 'Peptidyl-prolyl cis-trans isomerase', 165, NULL, NULL, 26648),
(26649, '3.30.230.130-FF-000072', NULL, 'Uncharacterized protein', 161, NULL, NULL, 26649),
(26650, '3.90.1150.10-FF-000201', NULL, 'Glycine dehydrogenase (decarboxylating)', 139, NULL, NULL, 26650),
(26651, '1.20.120.720-FF-000020', NULL, 'Myosin XVI', 134, NULL, NULL, 26651),
(26652, '1.10.1520.10-FF-000002', NULL, 'Drosha ribonuclease III', 155, NULL, NULL, 26652),
(26653, '1.10.510.10-FF-000582', NULL, 'Serine/threonine-protein kinase GRIK1 isoform A', 170, NULL, NULL, 26653),
(26654, '1.10.8.60-FF-000489', NULL, 'Uncharacterized protein', 57, NULL, NULL, 26654),
(26655, '3.30.420.40-FF-000751', NULL, 'Uncharacterized protein', 77, NULL, NULL, 26655),
(26656, '1.20.1070.10-FF-000999', NULL, 'Uncharacterized protein', 309, NULL, NULL, 26656),
(26657, '3.30.60.20-FF-000026', NULL, 'Thymidine kinase', 53, NULL, NULL, 26657),
(26658, '3.40.50.300-FF-004486', NULL, 'Putative ATP-dependent DEAD/H RNA helicase', 259, NULL, NULL, 26658),
(26659, '3.40.50.300-FF-001125', NULL, 'Genome polyprotein', 151, NULL, NULL, 26659),
(26660, '3.40.50.300-FF-006740', NULL, 'Uncharacterized protein', 69, NULL, NULL, 26660),
(26661, '3.40.50.1000-FF-000564', NULL, NULL, 113, NULL, NULL, 26661),
(26662, '1.10.20.10-FF-000083', NULL, 'nuclear transcription factor Y subunit gamma isoform X4', 51, NULL, NULL, 26662),
(26663, '3.30.60.30-FF-000029', NULL, 'Serine peptidase inhibitor, Kazal type 5', 59, NULL, NULL, 26663),
(26664, '3.30.450.70-FF-000020', NULL, 'TRapp subunit', 174, NULL, NULL, 26664),
(26665, '1.25.40.10-FF-000825', NULL, 'Molecular co-chaperone STI1', 140, NULL, NULL, 26665),
(26666, '3.30.200.20-FF-000762', NULL, 'Related to calmodulin-dependent protein kinase', 82, NULL, NULL, 26666);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(26667, '1.25.40.20-FF-000828', NULL, 'Uncharacterized protein', 120, NULL, NULL, 26667),
(26668, '2.30.42.10-FF-000220', NULL, 'uncharacterized protein LOC108099354 isoform X6', 110, NULL, NULL, 26668),
(26669, '1.25.40.20-FF-000492', NULL, 'YTH domain-containing 2', 201, NULL, NULL, 26669),
(26670, '1.20.1540.10-FF-000052', NULL, 'Peptidase, S54 family', 207, NULL, NULL, 26670),
(26671, '1.10.20.10-FF-000318', NULL, NULL, 130, NULL, NULL, 26671),
(26672, '1.10.8.720-FF-000079', NULL, 'Uncharacterized protein', 70, NULL, NULL, 26672),
(26673, '3.10.20.90-FF-000955', NULL, 'FERM, ARH/RhoGEF and pleckstrin domain protein 2', 60, NULL, NULL, 26673),
(26674, '3.30.230.10-FF-000261', NULL, 'Uncharacterized protein', 126, NULL, NULL, 26674),
(26675, '2.40.30.10-FF-000169', NULL, '50S ribosomal protein L3', 78, NULL, NULL, 26675),
(26676, '2.30.42.10-FF-000444', NULL, NULL, 81, NULL, NULL, 26676),
(26677, '3.30.160.60-FF-000736', NULL, 'Zinc finger protein 423', 28, NULL, NULL, 26677),
(26678, '3.30.70.120-FF-000032', NULL, NULL, 104, NULL, NULL, 26678),
(26679, '1.10.3380.30-FF-000036', NULL, 'ATP-dependent DNA helicase Hel308', 231, NULL, NULL, 26679),
(26680, '2.120.10.30-FF-000119', NULL, 'LDL receptor protein 1, isoform G', 334, NULL, NULL, 26680),
(26681, '2.60.200.20-FF-000276', NULL, 'Uncharacterized protein', 106, NULL, NULL, 26681),
(26682, '2.40.170.20-FF-000058', NULL, 'TonB-dependent siderophore receptor', 599, NULL, NULL, 26682),
(26683, '1.10.287.110-FF-000283', NULL, 'Chaperone protein DnaJ', 108, NULL, NULL, 26683),
(26684, '2.60.40.2810-FF-000001', NULL, 'RTX toxins and related Ca2+-binding protein', 98, NULL, NULL, 26684),
(26685, '3.80.10.10-FF-002131', NULL, '3C420', 156, NULL, NULL, 26685),
(26686, '1.10.760.10-FF-000111', NULL, 'Monoheme cytochrome c Shp', 108, NULL, NULL, 26686),
(26687, '2.70.70.10-FF-000018', NULL, 'Peptidase, M23 family', 129, NULL, NULL, 26687),
(26688, '3.30.40.10-FF-000095', NULL, 'Histone-lysine N-methyltransferase 2C', 110, NULL, NULL, 26688),
(26689, '3.40.190.10-FF-000620', NULL, 'Taurine ABC transporter, periplasmic taurine-binding protein', 100, NULL, NULL, 26689),
(26690, '2.10.25.10-FF-001625', NULL, 'Uncharacterized protein', 50, NULL, NULL, 26690),
(26691, '3.40.140.10-FF-000246', NULL, 'Protein CBG02246', 151, NULL, NULL, 26691),
(26692, '1.10.238.10-FF-000465', NULL, 'Zinc_finger_-_C3HC4_type_(RING_finger)/Ring_finger_domain/zinc-RING_finger_domain/EF-hand_domain_pair/EF-hand_domain/EF_hand/Secreted_protein_acidic_and_rich_in_cys teine_Ca_binding_region_containing_...', 82, NULL, NULL, 26692),
(26693, '1.10.10.10-FF-000155', NULL, 'Acetate operon repressor IclR', 77, NULL, NULL, 26693),
(26694, '2.40.50.90-FF-000003', NULL, 'Staphylococcal nuclease domain-containing protein', 154, NULL, NULL, 26694),
(26695, '1.20.120.1750-FF-000105', NULL, 'RBR-type E3 ubiquitin transferase', 199, NULL, NULL, 26695),
(26696, '2.30.42.10-FF-000118', NULL, 'Uncharacterized protein, isoform Z', 96, NULL, NULL, 26696),
(26697, '2.30.30.10-FF-000001', NULL, 'POL polyprotein', 58, NULL, NULL, 26697),
(26698, '3.40.50.620-FF-000147', NULL, 'Cholinephosphate cytidylyltransferase', 216, NULL, NULL, 26698),
(26699, '2.60.40.10-FF-002748', NULL, 'Uncharacterized protein', 98, NULL, NULL, 26699),
(26700, '2.60.40.60-FF-000824', NULL, 'Uncharacterized protein', 108, NULL, NULL, 26700),
(26701, '3.40.50.720-FF-001616', NULL, 'Hydroxysteroid 17-beta dehydrogenase 3', 112, NULL, NULL, 26701),
(26702, '1.10.510.10-FF-003223', NULL, NULL, 133, NULL, NULL, 26702),
(26703, '2.70.220.10-FF-000002', NULL, 'Phosphatidylglycerol/phosphatidylinositol transfer protein', 60, NULL, NULL, 26703),
(26704, '3.40.30.10-FF-001162', NULL, 'Uncharacterized protein', 173, NULL, NULL, 26704),
(26705, '2.60.40.60-FF-000678', NULL, 'Predicted protein', 105, NULL, NULL, 26705),
(26706, '1.10.1420.10-FF-000186', NULL, 'MutS family protein. putative', 155, NULL, NULL, 26706),
(26707, '3.60.120.10-FF-000010', NULL, 'Salicylate synthase', 450, NULL, NULL, 26707),
(26708, '3.40.50.150-FF-000927', NULL, NULL, 200, NULL, NULL, 26708);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(26709, '2.60.40.10-FF-004648', NULL, NULL, 104, NULL, NULL, 26709),
(26710, '3.30.1010.10-FF-000036', NULL, 'Serine/threonine-protein kinase ATR', 121, NULL, NULL, 26710),
(26711, '3.30.200.20-FF-002336', NULL, NULL, 69, NULL, NULL, 26711),
(26712, '2.30.30.40-FF-000471', NULL, 'ACR266Wp', 70, NULL, NULL, 26712),
(26713, '2.30.30.40-FF-000336', NULL, 'SH3 domain-containing protein 1', 86, NULL, NULL, 26713),
(26714, '3.80.10.10-FF-001625', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 104, NULL, NULL, 26714),
(26715, '3.30.160.60-FF-003333', NULL, NULL, 40, NULL, NULL, 26715),
(26716, '3.30.160.60-FF-000692', NULL, 'Zinc finger and BTB domain containing 24', 25, NULL, NULL, 26716),
(26717, '2.160.10.10-FF-000005', NULL, 'UDP-3-O-(3-hydroxymyristoyl)glucosamine N-acyltransferase', 210, NULL, NULL, 26717),
(26718, '1.25.10.10-FF-001150', NULL, 'Importin subunit alpha', 421, NULL, NULL, 26718),
(26719, '3.30.160.60-FF-004761', NULL, NULL, 87, NULL, NULL, 26719),
(26720, '1.25.40.10-FF-002624', NULL, 'Uncharacterized protein', 137, NULL, NULL, 26720),
(26721, '1.10.1000.11-FF-000009', NULL, 'IQ motif and SEC7 domain-containing protein', 116, NULL, NULL, 26721),
(26722, '3.30.200.20-FF-002027', NULL, 'Predicted protein', 91, NULL, NULL, 26722),
(26723, '3.10.430.100-FF-000005', NULL, '50S ribosomal protein L9', 87, NULL, NULL, 26723),
(26724, '1.10.950.10-FF-000002', NULL, 'Dematin isoform X2', 78, NULL, NULL, 26724),
(26725, '2.60.40.60-FF-001004', NULL, 'Uncharacterized protein', 108, NULL, NULL, 26725),
(26726, '3.30.70.330-FF-002910', NULL, NULL, 12, NULL, NULL, 26726),
(26727, '1.20.1250.20-FF-000280', NULL, 'MFS transporter', 180, NULL, NULL, 26727),
(26728, '2.130.10.30-FF-000012', NULL, 'probable E3 ubiquitin-protein ligase HERC3 isoform X1', 288, NULL, NULL, 26728),
(26729, '3.40.190.10-FF-000474', NULL, 'Oligopeptide ABC transporter substrate-binding protein', 123, NULL, NULL, 26729),
(26730, '1.10.730.10-FF-000154', NULL, 'Leucine--tRNA ligase', 170, NULL, NULL, 26730),
(26731, '2.60.120.10-FF-000559', NULL, 'Mannose-6-phosphate isomerase', 231, NULL, NULL, 26731),
(26732, '2.60.40.10-FF-002187', NULL, 'Titin homolog', 98, NULL, NULL, 26732),
(26733, '2.130.10.10-FF-000248', NULL, 'Chromatin assembly factor 1 subunit B', 109, NULL, NULL, 26733),
(26734, '1.20.1250.20-FF-001617', NULL, 'Uncharacterized protein', 156, NULL, NULL, 26734),
(26735, '2.170.270.10-FF-000173', NULL, 'PR domain containing 11', 102, NULL, NULL, 26735),
(26736, '1.20.1420.30-FF-000111', NULL, 'Uncharacterized protein', 208, NULL, NULL, 26736),
(26737, '2.30.30.100-FF-000044', NULL, 'Probable U6 snRNA-associated Sm-like protein LSm6', 74, NULL, NULL, 26737),
(26738, '1.20.120.1750-FF-000122', NULL, 'RBR-type E3 ubiquitin transferase', 115, NULL, NULL, 26738),
(26739, '3.40.50.300-FF-008538', NULL, 'Uncharacterized protein', 49, NULL, NULL, 26739),
(26740, '3.30.465.10-FF-000042', NULL, 'D-arabinono-1,4-lactone oxidase', 119, NULL, NULL, 26740),
(26741, '3.40.50.720-FF-001487', NULL, 'UDP-galactopyranose mutase', 104, NULL, NULL, 26741),
(26742, '2.20.70.10-FF-000190', NULL, 'Uncharacterized protein', 49, NULL, NULL, 26742),
(26743, '1.10.472.10-FF-000716', NULL, 'Retinoblastoma-like 2', 181, NULL, NULL, 26743),
(26744, '1.25.10.10-FF-002561', NULL, 'Calcium-binding protein 39-like', 170, NULL, NULL, 26744),
(26745, '3.40.50.720-FF-000205', NULL, 'Succinate--CoA ligase [ADP-forming] subunit alpha', 122, NULL, NULL, 26745),
(26746, '3.20.20.300-FF-000005', NULL, 'Periplasmic beta-glucosidase', 345, NULL, NULL, 26746),
(26747, '2.60.120.200-FF-000174', NULL, 'MAM domain containing 2', 178, NULL, NULL, 26747),
(26748, '1.20.1280.20-FF-000017', NULL, 'Co-chaperone Hsc20 family protein', 87, NULL, NULL, 26748),
(26749, '1.10.10.10-FF-000716', NULL, '40S ribosomal protein S19', 170, NULL, NULL, 26749),
(26750, '3.90.170.10-FF-000006', NULL, 'Adenylosuccinate synthetase', 145, NULL, NULL, 26750),
(26751, '1.25.40.10-FF-004850', NULL, 'Uncharacterized protein', 240, NULL, NULL, 26751);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(26752, '3.80.10.10-FF-003087', NULL, 'F-box protein family, AtFBL12, putative', 328, NULL, NULL, 26752),
(26753, '2.130.10.10-FF-000911', NULL, 'Putative Rab GTPase-binding protein', 231, NULL, NULL, 26753),
(26754, '1.20.120.620-FF-000006', NULL, 'Sensor histidine kinase KdpD', 107, NULL, NULL, 26754),
(26755, '1.25.40.10-FF-002950', NULL, 'U4/U6-U5 snRNP complex subunit', 137, NULL, NULL, 26755),
(26756, '1.10.1070.11-FF-000137', NULL, 'Uncharacterized protein', 120, NULL, NULL, 26756),
(26757, '1.10.472.10-FF-000407', NULL, 'YALI0C10516p', 105, NULL, NULL, 26757),
(26758, '2.130.10.10-FF-001400', NULL, 'CCR4-associated factor 4', 169, NULL, NULL, 26758),
(26759, '1.10.10.2590-FF-000008', NULL, 'Phospholipase a2 protein, putative', 111, NULL, NULL, 26759),
(26760, '1.25.40.10-FF-002063', NULL, 'Hsp70-interacting protein', 59, NULL, NULL, 26760),
(26761, '2.120.10.80-FF-000174', NULL, 'F-box/kelch-repeat protein At5g42360', 111, NULL, NULL, 26761),
(26762, '2.60.40.10-FF-004665', NULL, NULL, 101, NULL, NULL, 26762),
(26763, '1.10.10.710-FF-000001', NULL, 'DNA damage-inducible protein YebG', 71, NULL, NULL, 26763),
(26764, '1.20.120.610-FF-000003', NULL, 'V-type proton ATPase proteolipid subunit', 152, NULL, NULL, 26764),
(26765, '2.40.50.140-FF-000226', NULL, 'Uncharacterized protein, isoform A', 65, NULL, NULL, 26765),
(26766, '3.90.1320.10-FF-000001', NULL, 'Putative carboxyl-terminal proteinase', 120, NULL, NULL, 26766),
(26767, '3.30.200.20-FF-000436', NULL, 'Methylthioribose kinase', 111, NULL, NULL, 26767),
(26768, '3.90.550.50-FF-000216', NULL, 'Hexosyltransferase', 147, NULL, NULL, 26768),
(26769, '3.40.50.300-FF-004795', NULL, 'Rcorf28', 167, NULL, NULL, 26769),
(26770, '3.40.50.2020-FF-000095', NULL, 'Ribose-phosphate pyrophosphokinase, putative', 147, NULL, NULL, 26770),
(26771, '1.10.10.720-FF-000004', NULL, 'Leucine--tRNA ligase', 54, NULL, NULL, 26771),
(26772, '3.40.50.1820-FF-001338', NULL, 'Putative hydrolase', 250, NULL, NULL, 26772),
(26773, '3.40.50.720-FF-000514', NULL, 'Oxidoreductase, putative', 171, NULL, NULL, 26773),
(26774, '1.20.1270.280-FF-000063', NULL, 'Predicted protein', 151, NULL, NULL, 26774),
(26775, '2.60.120.740-FF-000015', NULL, 'Predicted protein', 98, NULL, NULL, 26775),
(26776, '2.30.30.30-FF-000007', NULL, 'Eukaryotic translation initiation factor 5A', 85, NULL, NULL, 26776),
(26777, '3.10.110.10-FF-000296', NULL, 'Uncharacterized protein', 106, NULL, NULL, 26777),
(26778, '1.25.10.10-FF-002252', NULL, 'Synembryn-like Protein', 369, NULL, NULL, 26778),
(26779, '3.40.350.10-FF-000037', NULL, 'Aminopeptidase, putative', 136, NULL, NULL, 26779),
(26780, '1.10.3130.10-FF-000012', NULL, 'Serine acetyltransferase', 160, NULL, NULL, 26780),
(26781, '3.30.70.330-FF-001758', NULL, NULL, 117, NULL, NULL, 26781),
(26782, '1.20.58.60-FF-000251', NULL, 'Spectrin repeat containing nuclear envelope protein 1', 206, NULL, NULL, 26782),
(26783, '1.10.246.60-FF-000004', NULL, 'Eukaryotic translation initiation factor 3 subunit J', 76, NULL, NULL, 26783),
(26784, '3.80.10.10-FF-001951', NULL, 'Receptor kinase-like protein Xa21', 166, NULL, NULL, 26784),
(26785, '3.40.50.1820-FF-000236', NULL, 'Alpha/beta hydrolase family protein', 367, NULL, NULL, 26785),
(26786, '2.60.40.150-FF-000740', NULL, 'Uncharacterized protein', 101, NULL, NULL, 26786),
(26787, '3.40.50.1000-FF-000255', NULL, 'Protein CBG02038', 197, NULL, NULL, 26787),
(26788, '3.30.40.10-FF-001758', NULL, 'Inhibitor of growth protein', 56, NULL, NULL, 26788),
(26789, '1.20.1250.20-FF-001926', NULL, 'Uncharacterized protein', 218, NULL, NULL, 26789),
(26790, '3.40.50.2300-FF-000307', NULL, 'Receptor-like histidine kinase BpdS', 146, NULL, NULL, 26790),
(26791, '1.20.1070.10-FF-001634', NULL, 'Uncharacterized protein', 140, NULL, NULL, 26791),
(26792, '3.90.1150.10-FF-000408', NULL, '5-aminolevulinate synthase', 96, NULL, NULL, 26792),
(26793, '3.40.50.1820-FF-001647', NULL, 'Uncharacterized protein', 391, NULL, NULL, 26793),
(26794, '3.40.50.300-FF-005897', NULL, 'ATPase, putative', 40, NULL, NULL, 26794);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(26795, '3.40.718.10-FF-000021', NULL, 'Isocitrate dehydrogenase 3 (NAD(+)) alpha', 87, NULL, NULL, 26795),
(26796, '2.40.50.140-FF-000535', NULL, 'Asparaginyl-tRNA synthetase, mitochondrial', 108, NULL, NULL, 26796),
(26797, '1.10.238.10-FF-000791', NULL, 'Uncharacterized protein', 165, NULL, NULL, 26797),
(26798, '3.60.160.10-FF-000001', NULL, 'Altered inheritance of mitochondria protein 24, mitochondrial', 225, NULL, NULL, 26798),
(26799, '3.30.200.20-FF-000745', NULL, 'Phytosulfokine receptor 2', 115, NULL, NULL, 26799),
(26800, '1.25.40.20-FF-001290', NULL, 'Uncharacterized protein', 168, NULL, NULL, 26800),
(26801, '2.60.40.150-FF-000431', NULL, 'Uncharacterized protein', 115, NULL, NULL, 26801),
(26802, '3.30.40.10-FF-001197', NULL, 'Ring finger domain containing protein', 60, NULL, NULL, 26802),
(26803, '3.40.50.2300-FF-000616', NULL, 'Histidine kinase', 128, NULL, NULL, 26803),
(26804, '1.10.10.60-FF-000900', NULL, NULL, 86, NULL, NULL, 26804),
(26805, '1.20.1070.10-FF-000223', NULL, 'Thyrotropin receptor', 275, NULL, NULL, 26805),
(26806, '1.10.3260.10-FF-000016', NULL, 'DNA ligase', 272, NULL, NULL, 26806),
(26807, '2.60.40.2220-FF-000004', NULL, 'Alpha-mannosidase', 76, NULL, NULL, 26807),
(26808, '3.90.480.10-FF-000007', NULL, 'Nitrite/sulfite reductase domain protein', 120, NULL, NULL, 26808),
(26809, '2.40.70.10-FF-000054', NULL, 'retrotransposon-derived protein PEG10 isoform 1', 136, NULL, NULL, 26809),
(26810, '1.20.1250.20-FF-002106', NULL, 'Uncharacterized protein', 239, NULL, NULL, 26810),
(26811, '3.30.70.330-FF-002247', NULL, NULL, 81, NULL, NULL, 26811),
(26812, '3.30.230.10-FF-000244', NULL, 'Galactose kinase', 210, NULL, NULL, 26812),
(26813, '2.120.10.30-FF-000428', NULL, 'Alpha-galactosidase', 145, NULL, NULL, 26813),
(26814, '1.10.472.80-FF-000001', NULL, 'TBC1 domain family member 22B', 136, NULL, NULL, 26814),
(26815, '3.40.50.11260-FF-000004', NULL, 'Heat shock protein 75 mitochondrial', 91, NULL, NULL, 26815),
(26816, '1.25.10.10-FF-002459', NULL, 'Cytoplasm protein, putative', 221, NULL, NULL, 26816),
(26817, '6.10.140.2190-FF-000002', NULL, NULL, 37, NULL, NULL, 26817),
(26818, '3.40.1770.10-FF-000006', NULL, 'Urocanate hydratase', 317, NULL, NULL, 26818),
(26819, '2.30.29.30-FF-000060', NULL, 'Diacylglycerol kinase', 126, NULL, NULL, 26819),
(26820, '3.30.160.60-FF-000719', NULL, 'Zinc finger protein 507', 50, NULL, NULL, 26820),
(26821, '1.20.140.150-FF-000061', NULL, 'CLaudin-like in Caenorhabditis', 171, NULL, NULL, 26821),
(26822, '2.40.30.10-FF-000495', NULL, 'Selenocysteine-specific elongation factor', 114, NULL, NULL, 26822),
(26823, '3.90.550.50-FF-000087', NULL, 'beta-1,3-N-acetylglucosaminyltransferase lunatic fringe', 267, NULL, NULL, 26823),
(26824, '3.30.160.60-FF-001208', NULL, 'Zinc finger protein 142', 30, NULL, NULL, 26824),
(26825, '3.40.50.10890-FF-000011', NULL, 'Cleavage and polyadenylation specificity factor subunit 2', 194, NULL, NULL, 26825),
(26826, '3.40.50.300-FF-005520', NULL, 'Protein-tyrosine sulfotransferase', 123, NULL, NULL, 26826),
(26827, '3.90.79.10-FF-000187', NULL, 'NUDIX hydrolase, conserved', 188, NULL, NULL, 26827),
(26828, '3.40.190.10-FF-000603', NULL, 'Chorismate mutase/prephenate dehydratase', 77, NULL, NULL, 26828),
(26829, '1.20.1080.10-FF-000134', NULL, 'Uncharacterized protein', 106, NULL, NULL, 26829),
(26830, '3.30.428.10-FF-000001', NULL, 'Galactose-1-phosphate uridylyltransferase', 175, NULL, NULL, 26830),
(26831, '2.40.70.10-FF-000262', NULL, 'Uncharacterized protein', 202, NULL, NULL, 26831),
(26832, '3.40.50.720-FF-001279', NULL, 'NAD(P) transhydrogenase subunit alpha, putative', 182, NULL, NULL, 26832),
(26833, '2.60.120.200-FF-000202', NULL, 'Laminin subunit alpha 5', 167, NULL, NULL, 26833),
(26834, '3.30.720.10-FF-000017', NULL, 'Uncharacterized protein', 115, NULL, NULL, 26834),
(26835, '3.30.565.10-FF-000235', NULL, 'Sensor histidine kinase DesK', 128, NULL, NULL, 26835),
(26836, '2.160.20.10-FF-000051', NULL, 'PKHD1, fibrocystin/polyductin', 275, NULL, NULL, 26836),
(26837, '2.60.40.10-FF-002395', NULL, 'Down syndrome cell adhesion molecule 1, isoform BY', 100, NULL, NULL, 26837);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(26838, '2.60.40.10-FF-006094', NULL, NULL, 76, NULL, NULL, 26838),
(26839, '3.80.10.10-FF-001934', NULL, 'Receptor-like protein kinase HSL1', 72, NULL, NULL, 26839),
(26840, '3.40.850.10-FF-000311', NULL, 'Motor domain of KIF13B', 160, NULL, NULL, 26840),
(26841, '3.40.50.10810-FF-000044', NULL, 'Chromatin remodeling factor18', 275, NULL, NULL, 26841),
(26842, '1.10.238.10-FF-000774', NULL, 'Related to secretory protein SSP120', 90, NULL, NULL, 26842),
(26843, '3.30.70.60-FF-000033', NULL, 'Uncharacterized protein', 112, NULL, NULL, 26843),
(26844, '3.10.690.10-FF-000002', NULL, 'Bifunctional nuclease 1', 135, NULL, NULL, 26844),
(26845, '2.60.40.10-FF-003013', NULL, '2 (Zwei) IG domain protein', 96, NULL, NULL, 26845),
(26846, '2.60.40.60-FF-000807', NULL, 'Uncharacterized protein', 73, NULL, NULL, 26846),
(26847, '3.30.70.330-FF-000123', NULL, 'Pre-mRNA splicing factor (Srp1)', 90, NULL, NULL, 26847),
(26848, '3.30.40.10-FF-000140', NULL, 'E3 ubiquitin-protein ligase Hakai isoform X2', 59, NULL, NULL, 26848),
(26849, '2.60.40.640-FF-000027', NULL, 'VPS26 endosomal protein sorting factor C', 93, NULL, NULL, 26849),
(26850, '3.30.1330.200-FF-000001', NULL, 'Probable chemoreceptor glutamine deamidase CheD', 158, NULL, NULL, 26850),
(26851, '2.30.30.40-FF-000454', NULL, 'Uncharacterized protein', 65, NULL, NULL, 26851),
(26852, '2.40.10.10-FF-000286', NULL, 'Si:ch211-212d10.1 protein', 76, NULL, NULL, 26852),
(26853, '1.20.1070.10-FF-000105', NULL, 'Glucagon like peptide 1 receptor', 309, NULL, NULL, 26853),
(26854, '3.40.50.720-FF-001824', NULL, 'Uncharacterized protein', 163, NULL, NULL, 26854),
(26855, '1.20.1070.10-FF-000206', NULL, 'Probable G-protein coupled receptor 171', 295, NULL, NULL, 26855),
(26856, '2.130.10.10-FF-002518', NULL, 'Histidine kinase/response regulator hybrid protein', 287, NULL, NULL, 26856),
(26857, '2.130.10.10-FF-002474', NULL, 'Uncharacterized protein', 78, NULL, NULL, 26857),
(26858, '1.25.40.10-FF-005013', NULL, 'Uncharacterized protein', 115, NULL, NULL, 26858),
(26859, '1.25.10.10-FF-001133', NULL, 'Hectd1 protein', 153, NULL, NULL, 26859),
(26860, '3.50.50.60-FF-000115', NULL, 'Salicylate hydroxylase, putative', 380, NULL, NULL, 26860),
(26861, '1.10.472.10-FF-000172', NULL, 'Protein CBG05210', 85, NULL, NULL, 26861),
(26862, '2.70.170.10-FF-000251', NULL, 'Soluble acetylcholine receptor', 225, NULL, NULL, 26862),
(26863, '3.30.450.20-FF-000230', NULL, 'Methyl-accepting chemotaxis protein', 172, NULL, NULL, 26863),
(26864, '1.20.1050.10-FF-000205', NULL, 'AaceriAFL032Cp', 120, NULL, NULL, 26864),
(26865, '3.40.47.10-FF-000284', NULL, NULL, 72, NULL, NULL, 26865),
(26866, '1.25.40.20-FF-001216', NULL, 'Uncharacterized protein', 68, NULL, NULL, 26866),
(26867, '1.10.10.10-FF-000464', NULL, 'LysR family transcriptional regulator', 88, NULL, NULL, 26867),
(26868, '3.40.50.2300-FF-000055', NULL, 'Gamma-aminobutyric acid type B receptor subunit 1', 221, NULL, NULL, 26868),
(26869, '3.80.10.10-FF-001288', NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', 141, NULL, NULL, 26869),
(26870, '2.60.40.60-FF-000706', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1', 102, NULL, NULL, 26870),
(26871, '3.30.470.20-FF-000130', NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', 64, NULL, NULL, 26871),
(26872, '2.80.10.50-FF-000167', NULL, 'Uncharacterized protein', 193, NULL, NULL, 26872),
(26873, '3.30.160.60-FF-002299', NULL, 'Krueppel factor 15', 41, NULL, NULL, 26873),
(26874, '3.30.2310.10-FF-000003', NULL, 'Uncharacterized protein, isoform A', 81, NULL, NULL, 26874),
(26875, '2.10.90.10-FF-000096', NULL, 'Uncharacterized protein', 91, NULL, NULL, 26875),
(26876, '1.20.58.80-FF-000049', NULL, 'Predicted protein', 113, NULL, NULL, 26876),
(26877, '2.60.120.260-FF-000170', NULL, 'Glucuronidase beta', 119, NULL, NULL, 26877),
(26878, '1.10.8.1290-FF-000006', NULL, NULL, 91, NULL, NULL, 26878),
(26879, '3.10.20.90-FF-000394', NULL, 'Ubiquitin-like protein MDY2', 84, NULL, NULL, 26879),
(26880, '2.60.120.260-FF-000540', NULL, 'Predicted protein', 75, NULL, NULL, 26880);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(26881, '1.20.120.1750-FF-000077', NULL, 'RBR-type E3 ubiquitin transferase', 109, NULL, NULL, 26881),
(26882, '3.10.50.10-FF-000023', NULL, 'Chitinase, variant', 78, NULL, NULL, 26882),
(26883, '2.10.25.10-FF-001597', NULL, 'Uncharacterized protein', 32, NULL, NULL, 26883),
(26884, '1.25.40.720-FF-000005', NULL, 'Telomere length regulation protein TEL2', 165, NULL, NULL, 26884),
(26885, '1.10.533.10-FF-000196', NULL, 'Apoptosis-associated speck-like protein containing a CARD', 85, NULL, NULL, 26885),
(26886, '1.20.142.10-FF-000015', NULL, 'Poly [ADP-ribose] polymerase', 148, NULL, NULL, 26886),
(26887, '3.90.740.10-FF-000062', NULL, 'Isoleucine--tRNA ligase, cytoplasmic-like', 208, NULL, NULL, 26887),
(26888, '1.20.58.60-FF-000043', NULL, 'Spectrin alpha chain, non-erythrocytic 1', 110, NULL, NULL, 26888),
(26889, '1.10.8.270-FF-000028', NULL, 'TBC domain containing protein', 131, NULL, NULL, 26889),
(26890, '3.30.470.30-FF-000032', NULL, 'Mitochondrial DNA ligase, putative', 240, NULL, NULL, 26890),
(26891, '3.40.50.720-FF-002330', NULL, 'Glyoxylate/hydroxypyruvate reductase, putative', 118, NULL, NULL, 26891),
(26892, '2.160.10.10-FF-000123', NULL, 'Serine acetyltransferase', 161, NULL, NULL, 26892),
(26893, '2.60.40.10-FF-004441', NULL, NULL, 70, NULL, NULL, 26893),
(26894, '3.30.710.10-FF-000045', NULL, 'zinc finger and BTB domain-containing protein 10', 142, NULL, NULL, 26894),
(26895, '1.25.40.10-FF-004395', NULL, 'Uncharacterized protein', 139, NULL, NULL, 26895),
(26896, '1.25.40.430-FF-000025', NULL, 'BUB1 mitotic checkpoint serine/threonine kinase Bb', 151, NULL, NULL, 26896),
(26897, '1.10.418.10-FF-000119', NULL, 'Fimbrin-like protein 2-like', 41, NULL, NULL, 26897),
(26898, '2.60.120.260-FF-000214', NULL, 'Uncharacterized protein', 117, NULL, NULL, 26898),
(26899, '2.10.25.10-FF-001081', NULL, 'Predicted protein', 41, NULL, NULL, 26899),
(26900, '1.20.1050.130-FF-000002', NULL, 'aminoacyl tRNA synthase complex-interacting multifunctional protein 2 isoform X2', 201, NULL, NULL, 26900),
(26901, '3.40.225.10-FF-000005', NULL, 'L-fuculose phosphate aldolase', 214, NULL, NULL, 26901),
(26902, '1.20.58.70-FF-000046', NULL, 'CRE-SYN-16 protein', 122, NULL, NULL, 26902),
(26903, '3.30.230.10-FF-000053', NULL, 'DNA repair protein radA isogeny', 170, NULL, NULL, 26903),
(26904, '1.20.1250.20-FF-001398', NULL, 'Monocarboxylate transporter-like protein', 189, NULL, NULL, 26904),
(26905, '3.40.190.290-FF-000117', NULL, 'LysR family transcriptional regulator', 204, NULL, NULL, 26905),
(26906, '3.40.190.10-FF-000502', NULL, 'Putative oligopeptide-binding lipoprotein', 283, NULL, NULL, 26906),
(26907, '3.40.50.12780-FF-000050', NULL, 'Acyl-CoA synthetase', 457, NULL, NULL, 26907),
(26908, '3.30.1010.10-FF-000053', NULL, 'DNA-dependent protein kinase catalytic subunit', 154, NULL, NULL, 26908),
(26909, '1.20.1070.10-FF-001842', NULL, 'Uncharacterized protein', 301, NULL, NULL, 26909),
(26910, '1.20.120.910-FF-000003', NULL, 'TraR/DksA family transcriptional regulator', 72, NULL, NULL, 26910),
(26911, '3.40.50.1100-FF-000167', NULL, 'SH3 domain protein (Cyk3), putative (AFU_orthologue AFUA_5G03400)', 20, NULL, NULL, 26911),
(26912, '1.10.357.10-FF-000084', NULL, 'Uncharacterized protein', 83, NULL, NULL, 26912),
(26913, '3.30.1120.120-FF-000003', NULL, 'Uncharacterized protein', 65, NULL, NULL, 26913),
(26914, '3.30.70.330-FF-000022', NULL, 'APOBEC1 complementation factor isoform X1', 83, NULL, NULL, 26914),
(26915, '6.10.250.3330-FF-000001', NULL, 'Secreted effector protein EspF(U)', 47, NULL, NULL, 26915),
(26916, '3.10.129.10-FF-000125', NULL, 'Acyl-ACP thioesterase, FatA', 236, NULL, NULL, 26916),
(26917, '3.40.228.10-FF-000028', NULL, 'Formylmethanofuran dehydrogenase, subunit B', 102, NULL, NULL, 26917),
(26918, '1.10.1420.10-FF-000068', NULL, 'Putative mismatch repair protein MSH8', 205, NULL, NULL, 26918),
(26919, '3.40.50.1000-FF-000446', NULL, 'Trehalose-6-phosphate synthase', 120, NULL, NULL, 26919),
(26920, '3.30.70.330-FF-000538', NULL, 'Nuclear cap-binding protein subunit 2', 135, NULL, NULL, 26920);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(26921, '1.20.1560.10-FF-000070', NULL, 'Multidrug ABC transporter ATP-binding protein', 328, NULL, NULL, 26921),
(26922, '1.10.1130.10-FF-000012', NULL, 'Octaheme tetrathionate reductase Otr', 137, NULL, NULL, 26922),
(26923, '1.20.1250.20-FF-001409', NULL, 'Putative multidrug resistance protein', 185, NULL, NULL, 26923),
(26924, '3.30.160.60-FF-001416', NULL, 'PR domain zinc finger protein 12', 53, NULL, NULL, 26924),
(26925, '2.60.40.10-FF-002496', NULL, 'Uncharacterized protein', 62, NULL, NULL, 26925),
(26926, '1.25.10.10-FF-002813', NULL, 'Uncharacterized protein', 527, NULL, NULL, 26926),
(26927, '1.10.510.10-FF-004117', NULL, NULL, 106, NULL, NULL, 26927),
(26928, '1.10.8.950-FF-000002', NULL, 'Polymerase cofactor VP35', 70, NULL, NULL, 26928),
(26929, '3.30.160.60-FF-000383', NULL, 'Uncharacterized protein', 28, NULL, NULL, 26929),
(26930, '3.30.160.60-FF-002844', NULL, NULL, 28, NULL, NULL, 26930),
(26931, '1.25.40.10-FF-000707', NULL, 'Chitin synthase regulatory factor 3', 182, NULL, NULL, 26931),
(26932, '1.25.40.10-FF-004406', NULL, 'Predicted protein', 134, NULL, NULL, 26932),
(26933, '1.25.10.10-FF-000526', NULL, 'Serine/threonine-protein kinase TOR', 113, NULL, NULL, 26933),
(26934, '3.80.10.10-FF-003542', NULL, 'Uncharacterized protein', 160, NULL, NULL, 26934),
(26935, '1.10.287.110-FF-000266', NULL, 'DnaJ like protein, putative', 87, NULL, NULL, 26935),
(26936, '3.90.190.20-FF-000044', NULL, 'Tetrahydrofolate synthase', 130, NULL, NULL, 26936),
(26937, '3.40.50.1780-FF-000011', NULL, 'Nuclear prelamin A recognition factor', 96, NULL, NULL, 26937),
(26938, '2.70.150.10-FF-000250', NULL, 'Cation-transporting ATPase', 73, NULL, NULL, 26938),
(26939, '2.60.40.640-FF-000128', NULL, 'Uncharacterized protein', 47, NULL, NULL, 26939),
(26940, '2.40.50.90-FF-000121', NULL, 'Uncharacterized protein', 184, NULL, NULL, 26940),
(26941, '1.20.1080.10-FF-000033', NULL, 'Probable nitrite transporter', 264, NULL, NULL, 26941),
(26942, '3.90.550.10-FF-000362', NULL, 'Cytidylyltransferase domain protein', 223, NULL, NULL, 26942),
(26943, '2.130.10.10-FF-005599', NULL, 'TBC1 domain family member 31-like Protein', 193, NULL, NULL, 26943),
(26944, '3.40.50.300-FF-000299', NULL, 'ABC transporter ATP-binding protein/permease', 247, NULL, NULL, 26944),
(26945, '1.10.510.10-FF-002734', NULL, 'Uncharacterized protein', 285, NULL, NULL, 26945),
(26946, '2.60.40.10-FF-004750', NULL, NULL, 107, NULL, NULL, 26946),
(26947, '2.40.30.110-FF-000011', NULL, 'Aminomethyltransferase', 83, NULL, NULL, 26947),
(26948, '2.10.70.10-FF-000196', NULL, 'Uncharacterized protein', 65, NULL, NULL, 26948),
(26949, '3.40.50.150-FF-001046', NULL, NULL, 119, NULL, NULL, 26949),
(26950, '1.20.272.40-FF-000011', NULL, 'ATP-dependent RNA helicase SUV3, mitochondrial', 68, NULL, NULL, 26950),
(26951, '1.20.58.1280-FF-000006', NULL, 'DNA repair protein REV1', 98, NULL, NULL, 26951),
(26952, '2.40.30.130-FF-000017', NULL, 'Alanine--tRNA ligase', 100, NULL, NULL, 26952),
(26953, '1.10.510.10-FF-003240', NULL, NULL, 119, NULL, NULL, 26953),
(26954, '1.10.1450.10-FF-000160', NULL, 'Tetraspanin', 76, NULL, NULL, 26954),
(26955, '2.20.80.10-FF-000027', NULL, 'Vitellogenin 3', 40, NULL, NULL, 26955),
(26956, '3.80.10.10-FF-001597', NULL, 'Leucine-rich repeat receptor-like protein kinase', 71, NULL, NULL, 26956),
(26957, '3.10.300.10-FF-000007', NULL, 'DNA-3-methyladenine glycosylase family protein', 107, NULL, NULL, 26957),
(26958, '3.40.50.1000-FF-000238', NULL, 'BnaA03g18060D protein', 139, NULL, NULL, 26958),
(26959, '3.30.70.330-FF-000331', NULL, 'RNA binding motif protein 26', 61, NULL, NULL, 26959),
(26960, '1.20.5.190-FF-000176', NULL, NULL, 41, NULL, NULL, 26960),
(26961, '3.90.1150.10-FF-000055', NULL, 'Cysteine desulfurase CsdA', 110, NULL, NULL, 26961),
(26962, '1.10.645.10-FF-000006', NULL, 'NADH-quinone oxidoreductase subunit D', 361, NULL, NULL, 26962),
(26963, '2.40.50.690-FF-000026', NULL, 'RNB-like protein', 111, NULL, NULL, 26963),
(26964, '3.90.550.10-FF-000671', NULL, 'Uncharacterized protein', 107, NULL, NULL, 26964);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(26965, '1.20.1070.10-FF-001297', NULL, 'Uncharacterized protein', 299, NULL, NULL, 26965),
(26966, '3.40.50.300-FF-005312', NULL, 'RAS-like, family 12', 167, NULL, NULL, 26966),
(26967, '2.30.30.40-FF-000662', NULL, 'Glycoprotein 6-alpha-L-fucosyltransferase, putative', 66, NULL, NULL, 26967),
(26968, '2.30.30.40-FF-000353', NULL, 'Neutrophil cytosol factor 2', 58, NULL, NULL, 26968),
(26969, '3.30.720.210-FF-000010', NULL, 'ATP-dependent zinc metalloprotease FtsH', 82, NULL, NULL, 26969),
(26970, '3.80.10.10-FF-003278', NULL, 'Uncharacterized protein', 152, NULL, NULL, 26970),
(26971, '1.25.40.10-FF-001798', NULL, 'At5g02130', 195, NULL, NULL, 26971),
(26972, '2.60.40.10-FF-000950', NULL, 'Intercellular adhesion molecule 5', 88, NULL, NULL, 26972),
(26973, '3.50.70.10-FF-000006', NULL, 'Chalcone-flavonone isomerase family protein', 106, NULL, NULL, 26973),
(26974, '1.20.1070.10-FF-001960', NULL, 'Olfactory receptor', 198, NULL, NULL, 26974),
(26975, '3.30.1490.40-FF-000018', NULL, NULL, 73, NULL, NULL, 26975),
(26976, '1.20.1090.10-FF-000005', NULL, 'Alcohol dehydrogenase YqhD', 204, NULL, NULL, 26976),
(26977, '3.30.160.60-FF-004289', NULL, NULL, 66, NULL, NULL, 26977),
(26978, '2.70.98.10-FF-000015', NULL, 'Aldose 1-epimerase, putative', 328, NULL, NULL, 26978),
(26979, '3.30.70.1990-FF-000014', NULL, NULL, 77, NULL, NULL, 26979),
(26980, '1.25.40.480-FF-000001', NULL, 'Bystin (51.6 kD)-like', 218, NULL, NULL, 26980),
(26981, '2.40.37.10-FF-000061', NULL, NULL, 124, NULL, NULL, 26981),
(26982, '3.40.50.300-FF-008494', NULL, 'Uncharacterized protein', 73, NULL, NULL, 26982),
(26983, '2.130.10.10-FF-002726', NULL, 'Uncharacterized protein', 302, NULL, NULL, 26983),
(26984, '1.20.920.30-FF-000015', NULL, 'Dynein heavy chain-like protein', 196, NULL, NULL, 26984),
(26985, '2.60.40.10-FF-003221', NULL, 'Si:ch73-296e2.3', 98, NULL, NULL, 26985),
(26986, '1.10.1240.40-FF-000001', NULL, 'BRCA2-interacting transcriptional repressor EMSY isoform X1', 133, NULL, NULL, 26986),
(26987, '3.40.1440.10-FF-000004', NULL, 'UV-repair endonuclease Cho', 96, NULL, NULL, 26987),
(26988, '1.20.920.20-FF-000012', NULL, 'Dynein heavy chain, putative', 358, NULL, NULL, 26988),
(26989, '1.20.58.1100-FF-000009', NULL, 'Predicted protein', 167, NULL, NULL, 26989),
(26990, '3.40.50.11260-FF-000021', NULL, 'Uncharacterized protein', 106, NULL, NULL, 26990),
(26991, '1.10.8.10-FF-000030', NULL, 'E3 ubiquitin-protein ligase CBL', 56, NULL, NULL, 26991),
(26992, '3.40.50.1000-FF-000710', NULL, NULL, 100, NULL, NULL, 26992),
(26993, '3.40.190.290-FF-000016', NULL, 'Nitrogen assimilation regulatory protein nac', 204, NULL, NULL, 26993),
(26994, '1.25.40.10-FF-005289', NULL, 'Pentatricopeptide repeat (PPR) superfamily protein', 140, NULL, NULL, 26994),
(26995, '3.30.497.10-FF-000060', NULL, 'Serpin peptidase inhibitor, clade B (ovalbumin), member 1', 48, NULL, NULL, 26995),
(26996, '3.30.420.40-FF-000296', NULL, 'Glucokinase', 105, NULL, NULL, 26996),
(26997, '1.25.40.10-FF-000354', NULL, 'UBA domain-containing protein 7', 145, NULL, NULL, 26997),
(26998, '1.20.1250.20-FF-002123', NULL, 'Solute carrier organic anion transporter family member', 216, NULL, NULL, 26998),
(26999, '3.30.70.330-FF-000432', NULL, 'Splicing factor 3B subunit 6', 104, NULL, NULL, 26999),
(27000, '1.25.10.10-FF-001032', NULL, 'WGS project CABT00000000 data, contig 2.8', 189, NULL, NULL, 27000),
(27001, '1.20.1070.10-FF-001533', NULL, 'Uncharacterized protein', 182, NULL, NULL, 27001),
(27002, '3.10.490.10-FF-000037', NULL, 'Gamma-glutamyl cyclotransferase', 138, NULL, NULL, 27002),
(27003, '1.10.418.10-FF-000237', NULL, 'Actinin alpha 1', 57, NULL, NULL, 27003),
(27004, '3.30.40.10-FF-001859', NULL, 'Uncharacterized protein', 80, NULL, NULL, 27004),
(27005, '2.130.10.10-FF-004508', NULL, 'Pre-rRNA-processing protein crb3/ipi3', 237, NULL, NULL, 27005),
(27006, '1.25.40.730-FF-000008', NULL, 'Clathrin heavy chain', 97, NULL, NULL, 27006),
(27007, '3.40.350.10-FF-000054', NULL, 'Aminopeptidase P', 140, NULL, NULL, 27007),
(27008, '3.40.50.2000-FF-000324', NULL, 'Glycosyltransferase', 260, NULL, NULL, 27008);
INSERT INTO "PUBLIC"."MODEL" VALUES
(27009, '3.30.450.40-FF-000236', NULL, 'Sensor diguanylate cyclase, GAF domain-containing', 176, NULL, NULL, 27009),
(27010, '3.90.79.10-FF-000086', NULL, 'Cleavage and polyadenylation specificity factor subunit 5', 240, NULL, NULL, 27010),
(27011, '1.10.510.10-FF-004325', NULL, NULL, 143, NULL, NULL, 27011),
(27012, '3.60.21.10-FF-000409', NULL, 'Serine/threonine-protein phosphatase', 291, NULL, NULL, 27012),
(27013, '1.20.940.10-FF-000010', NULL, 'Protein transport protein SEC31 B', 102, NULL, NULL, 27013),
(27014, '2.40.10.10-FF-000606', NULL, NULL, 152, NULL, NULL, 27014),
(27015, '1.20.58.1590-FF-000009', NULL, 'Uncharacterized protein', 168, NULL, NULL, 27015),
(27016, '3.30.590.10-FF-000057', NULL, 'Uncharacterized protein', 84, NULL, NULL, 27016),
(27017, '3.30.70.330-FF-000802', NULL, 'Enhancer binding protein-1, putative', 110, NULL, NULL, 27017),
(27018, '4.10.400.10-FF-000298', NULL, 'Uncharacterized protein', 35, NULL, NULL, 27018),
(27019, '3.40.50.880-FF-000085', NULL, 'DJ-1 family protein', 182, NULL, NULL, 27019),
(27020, '2.60.120.10-FF-000694', NULL, 'Uncharacterized protein', 60, NULL, NULL, 27020),
(27021, '3.90.640.10-FF-000205', NULL, 'Protein CBG03751', 83, NULL, NULL, 27021),
(27022, '2.20.70.10-FF-000217', NULL, 'Histone-lysine N-methyltransferase', 58, NULL, NULL, 27022),
(27023, '3.30.1540.20-FF-000023', NULL, NULL, 73, NULL, NULL, 27023),
(27024, '1.20.1510.10-FF-000033', NULL, 'Unplaced genomic scaffold supercont1.9, whole genome shotgun sequence', 162, NULL, NULL, 27024),
(27025, '2.60.120.260-FF-000276', NULL, 'Beta-mannosidase', 180, NULL, NULL, 27025),
(27026, '3.30.2350.10-FF-000011', NULL, 'tRNA pseudouridine synthase B', 235, NULL, NULL, 27026),
(27027, '3.90.1100.10-FF-000018', NULL, 'DNA-directed RNA polymerase subunit beta', 136, NULL, NULL, 27027),
(27028, '1.10.420.10-FF-000035', NULL, 'Predicted protein', 34, NULL, NULL, 27028),
(27029, '3.40.50.1240-FF-000068', NULL, 'Putative 2-carboxy-D-arabinitol-1-phosphatase isoform A', 206, NULL, NULL, 27029),
(27030, '3.30.2350.20-FF-000014', NULL, 'tRNA pseudouridine synthase D (TruD)', 192, NULL, NULL, 27030),
(27031, '3.90.550.50-FF-000115', NULL, 'Hexosyltransferase', 171, NULL, NULL, 27031),
(27032, '3.40.50.2000-FF-000072', NULL, 'Glycosyl transferase', 163, NULL, NULL, 27032),
(27033, '3.40.1090.10-FF-000106', NULL, 'Uncharacterized protein', 100, NULL, NULL, 27033),
(27034, '1.20.58.670-FF-000022', NULL, NULL, 129, NULL, NULL, 27034),
(27035, '3.40.190.10-FF-000266', NULL, 'Glutamate receptor', 118, NULL, NULL, 27035),
(27036, '3.60.15.10-FF-000030', NULL, 'Metallo-beta-lactamase family protein', 251, NULL, NULL, 27036),
(27037, '1.20.58.760-FF-000015', NULL, 'ATP-dependent zinc metalloprotease FtsH 3', 198, NULL, NULL, 27037),
(27038, '2.40.50.140-FF-000552', NULL, 'Cold shock domain containing C2', 54, NULL, NULL, 27038),
(27039, '1.10.600.10-FF-000133', NULL, 'Terpenoid synthases superfamily protein', 69, NULL, NULL, 27039),
(27040, '3.30.70.3040-FF-000004', NULL, 'Cell division protein FtsX', 114, NULL, NULL, 27040),
(27041, '2.20.25.80-FF-000004', NULL, 'WRKY transcription factor 65', 78, NULL, NULL, 27041),
(27042, '2.20.25.90-FF-000007', NULL, 'Assimilatory nitrate reductase', 56, NULL, NULL, 27042),
(27043, '2.40.330.10-FF-000012', NULL, NULL, 102, NULL, NULL, 27043),
(27044, '2.10.50.30-FF-000043', NULL, 'Uncharacterized protein', 79, NULL, NULL, 27044),
(27045, '3.80.20.20-FF-000027', NULL, 'Receptor protein-tyrosine kinase', 166, NULL, NULL, 27045),
(27046, '1.10.533.10-FF-000308', NULL, 'Retinoic acid-inducible protein Ia', 58, NULL, NULL, 27046),
(27047, '3.30.70.3030-FF-000001', NULL, 'Nucleolar protein 6', 133, NULL, NULL, 27047),
(27048, '3.20.20.70-FF-000449', NULL, 'N-(5''-phosphoribosyl)anthranilate isomerase', 202, NULL, NULL, 27048),
(27049, '2.40.10.10-FF-000595', NULL, NULL, 20, NULL, NULL, 27049),
(27050, '3.40.50.620-FF-000501', NULL, 'Diphthine--ammonia ligase', 111, NULL, NULL, 27050),
(27051, '2.120.10.80-FF-000218', NULL, 'LD20420p', 142, NULL, NULL, 27051),
(27052, '2.130.10.10-FF-000456', NULL, 'aladin isoform X3', 227, NULL, NULL, 27052);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(27053, '1.20.144.10-FF-000059', NULL, 'Phospholipid phosphatase 2b', 271, NULL, NULL, 27053),
(27054, '1.10.533.10-FF-000297', NULL, 'Predicted protein', 75, NULL, NULL, 27054),
(27055, '3.30.160.60-FF-003125', NULL, 'Putative zinc finger protein 66', 21, NULL, NULL, 27055),
(27056, '2.40.110.10-FF-000046', NULL, 'Acyl-CoA dehydrogenase', 99, NULL, NULL, 27056),
(27057, '3.80.10.10-FF-000405', NULL, 'Plant intracellular Ras-group-related LRR protein 4', 309, NULL, NULL, 27057),
(27058, '1.20.5.4770-FF-000008', NULL, 'Zinc finger A20 and AN1 domain-containing stress-associated protein 1', 62, NULL, NULL, 27058),
(27059, '2.60.120.340-FF-000002', NULL, 'Nucleophosmin/nucleoplasmin 3', 126, NULL, NULL, 27059),
(27060, '1.25.40.10-FF-002416', NULL, 'Pentatricopeptide repeat-containing protein', 140, NULL, NULL, 27060),
(27061, '2.60.120.200-FF-000320', NULL, 'Collagen alpha-1(IX) chain', 218, NULL, NULL, 27061),
(27062, '1.10.510.10-FF-004426', NULL, NULL, 61, NULL, NULL, 27062),
(27063, '2.10.25.10-FF-001390', NULL, 'Vasorin', 76, NULL, NULL, 27063),
(27064, '1.20.58.60-FF-000352', NULL, 'SMAll', 101, NULL, NULL, 27064),
(27065, '2.30.30.30-FF-000142', NULL, 'E3 ubiquitin-protein ligase UHRF2', 54, NULL, NULL, 27065),
(27066, '3.30.200.20-FF-001864', NULL, 'Uncharacterized protein', 61, NULL, NULL, 27066),
(27067, '3.30.1520.10-FF-000120', NULL, 'Uncharacterized protein', 146, NULL, NULL, 27067),
(27068, '1.10.238.10-FF-000364', NULL, 'Calmodulin, putative', 66, NULL, NULL, 27068),
(27069, '2.40.10.10-FF-000707', NULL, NULL, 38, NULL, NULL, 27069),
(27070, '2.160.20.10-FF-000157', NULL, 'Cell surface protein', 133, NULL, NULL, 27070),
(27071, '2.60.260.20-FF-000061', NULL, 'Scj1p', 69, NULL, NULL, 27071),
(27072, '3.40.30.10-FF-000757', NULL, 'Uncharacterized protein', 96, NULL, NULL, 27072),
(27073, '3.40.30.10-FF-001263', NULL, 'Uncharacterized protein', 102, NULL, NULL, 27073),
(27074, '1.10.506.10-FF-000066', NULL, 'Uncharacterized protein', 130, NULL, NULL, 27074),
(27075, '3.40.50.10810-FF-000162', NULL, 'Putative snf2 family dna-dependent atpase domain-containing protein', 262, NULL, NULL, 27075),
(27076, '1.20.1310.10-FF-000052', NULL, 'Anaphase-promoting complex subunit 2', 122, NULL, NULL, 27076),
(27077, '3.60.70.12-FF-000002', NULL, 'Arginine biosynthesis bifunctional protein ArgJ, mitochondrial', 195, NULL, NULL, 27077),
(27078, '3.40.190.10-FF-000709', NULL, 'Sugar ABC transporter, periplasmic sugar-binding protein', 213, NULL, NULL, 27078),
(27079, '3.80.10.10-FF-003424', NULL, 'Predicted protein', 72, NULL, NULL, 27079),
(27080, '1.10.10.10-FF-000346', NULL, 'PadR family transcriptional regulator', 89, NULL, NULL, 27080),
(27081, '3.10.450.350-FF-000011', NULL, 'Cell wall endopeptidase family M23/M37', 104, NULL, NULL, 27081),
(27082, '2.130.10.10-FF-002827', NULL, 'Suppressor of mec-8 and unc-52 protein-like 1', 111, NULL, NULL, 27082),
(27083, '3.80.10.10-FF-001524', NULL, 'Leucine Rich Repeat family protein, expressed', 98, NULL, NULL, 27083),
(27084, '3.40.50.150-FF-000883', NULL, 'Outer capsid protein lambda-2', 230, NULL, NULL, 27084),
(27085, '3.40.50.2000-FF-000633', NULL, 'Os10g0332300 protein', 88, NULL, NULL, 27085),
(27086, '1.10.472.130-FF-000076', NULL, 'Uncharacterized protein', 148, NULL, NULL, 27086),
(27087, '1.20.5.370-FF-000022', NULL, NULL, 43, NULL, NULL, 27087),
(27088, '1.25.40.780-FF-000001', NULL, 'TIR domain-containing adapter molecule 1', 153, NULL, NULL, 27088),
(27089, '3.90.420.10-FF-000015', NULL, 'Uncharacterized protein', 153, NULL, NULL, 27089),
(27090, '2.40.70.10-FF-000469', NULL, NULL, 163, NULL, NULL, 27090),
(27091, '3.30.70.330-FF-000229', NULL, 'Squamous cell carcinoma antigen recognized by T-cells 3', 119, NULL, NULL, 27091),
(27092, '3.30.497.10-FF-000076', NULL, 'Angiotensinogen', 209, NULL, NULL, 27092),
(27093, '2.30.30.40-FF-000145', NULL, 'Tyrosine-protein kinase', 74, NULL, NULL, 27093),
(27094, '3.40.50.300-FF-002654', NULL, 'Cytoplasmic dynein 2 heavy chain 1', 171, NULL, NULL, 27094),
(27095, '1.10.510.10-FF-002526', NULL, NULL, 209, NULL, NULL, 27095);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(27096, '3.40.50.300-FF-005211', NULL, 'Adenylate kinase, putative', 209, NULL, NULL, 27096),
(27097, '1.25.40.10-FF-000146', NULL, 'Clathrin-coated vesiclec protein (Bud7)', 192, NULL, NULL, 27097),
(27098, '1.10.10.60-FF-000254', NULL, 'transcription repressor MYB5-like', 67, NULL, NULL, 27098),
(27099, '1.10.287.1490-FF-000085', NULL, 'DNA repair ATPase', 148, NULL, NULL, 27099),
(27100, '2.40.100.10-FF-000118', NULL, 'Peptidyl-prolyl cis-trans isomerase', 171, NULL, NULL, 27100),
(27101, '3.30.505.10-FF-000097', NULL, 'Tyrosine-protein kinase', 111, NULL, NULL, 27101),
(27102, '3.90.1420.10-FF-000048', NULL, 'Uncharacterized protein', 129, NULL, NULL, 27102),
(27103, '3.90.70.200-FF-000008', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 135, NULL, NULL, 27103),
(27104, '2.60.120.650-FF-000224', NULL, 'Bifunctional arginine demethylase and lysyl-hydroxylase psr-1', 179, NULL, NULL, 27104),
(27105, '3.90.1640.10-FF-000031', NULL, 'Uncharacterized protein', 109, NULL, NULL, 27105),
(27106, '3.30.160.60-FF-001107', NULL, 'POZ-, AT hook-, and zinc finger-containing protein 1 isoform X1', 57, NULL, NULL, 27106),
(27107, '3.30.2170.10-FF-000014', NULL, NULL, 231, NULL, NULL, 27107),
(27108, '3.40.570.10-FF-000020', NULL, 'Uncharacterized protein', 321, NULL, NULL, 27108),
(27109, '3.30.160.60-FF-002962', NULL, 'Zinc finger domain-containing protein', 29, NULL, NULL, 27109),
(27110, '3.30.200.20-FF-000228', NULL, 'Serine/threonine-protein kinase BIK1', 119, NULL, NULL, 27110),
(27111, '3.40.50.720-FF-001588', NULL, 'Uncharacterized protein', 224, NULL, NULL, 27111),
(27112, '3.10.20.230-FF-000031', NULL, 'Doublecortin like kinase 2', 61, NULL, NULL, 27112),
(27113, '2.130.10.10-FF-004626', NULL, 'Uncharacterized protein', 198, NULL, NULL, 27113),
(27114, '3.40.50.300-FF-006285', NULL, 'Elongation factor G, mitochondrial', 290, NULL, NULL, 27114),
(27115, '1.10.10.60-FF-000355', NULL, 'Transcription factor MYB124', 57, NULL, NULL, 27115),
(27116, '3.40.50.1820-FF-001681', NULL, 'Uncharacterized protein', 232, NULL, NULL, 27116),
(27117, '3.40.50.300-FF-007111', NULL, 'Small GTP-binding protein, putative', 186, NULL, NULL, 27117),
(27118, '3.30.70.330-FF-001966', NULL, NULL, 121, NULL, NULL, 27118),
(27119, '1.10.10.10-FF-000817', NULL, 'Transcriptional regulator, GntR family', 67, NULL, NULL, 27119),
(27120, '2.60.120.1540-FF-000008', NULL, 'Complement C5', 115, NULL, NULL, 27120),
(27121, '2.60.40.150-FF-000195', NULL, 'Synapse defective Rho GTPase homolog 2', 133, NULL, NULL, 27121),
(27122, '1.20.1070.10-FF-000414', NULL, 'Cholecystokinin A receptor', 348, NULL, NULL, 27122),
(27123, '3.90.550.10-FF-000480', NULL, 'Uncharacterized protein', 205, NULL, NULL, 27123),
(27124, '3.40.50.300-FF-001260', NULL, 'Putative ABC transporter ATP-binding component', 231, NULL, NULL, 27124),
(27125, '1.20.1250.20-FF-001960', NULL, 'Uncharacterized protein', 424, NULL, NULL, 27125),
(27126, '2.60.120.650-FF-000180', NULL, 'Uncharacterized protein', 114, NULL, NULL, 27126),
(27127, '1.10.10.410-FF-000001', NULL, 'Aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase subunit B', 62, NULL, NULL, 27127),
(27128, '3.40.50.300-FF-008393', NULL, 'Uncharacterized protein', 190, NULL, NULL, 27128),
(27129, '2.130.10.10-FF-000927', NULL, 'Transcription factor (SPT8), putative', 272, NULL, NULL, 27129),
(27130, '1.20.870.10-FF-000050', NULL, 'Uncharacterized protein', 114, NULL, NULL, 27130),
(27131, '3.30.200.20-FF-001965', NULL, 'Mitosis inhibitor protein kinase mik1', 103, NULL, NULL, 27131),
(27132, '3.40.850.10-FF-000047', NULL, 'Kinesin family protein', 380, NULL, NULL, 27132),
(27133, '1.10.3720.10-FF-000052', NULL, 'Sulfonate ABC transporter permease', 197, NULL, NULL, 27133),
(27134, '3.10.129.10-FF-000007', NULL, 'Thioesterase family protein', 152, NULL, NULL, 27134),
(27135, '3.40.50.1980-FF-000144', NULL, 'Periplasmic binding protein', 173, NULL, NULL, 27135),
(27136, '4.10.1170.10-FF-000006', NULL, 'Uncharacterized protein', 30, NULL, NULL, 27136),
(27137, '1.20.1250.20-FF-001718', NULL, 'Uncharacterized protein', 194, NULL, NULL, 27137);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(27138, '3.40.50.300-FF-000754', NULL, 'Guanine nucleotide-binding protein subunit alpha-13', 162, NULL, NULL, 27138),
(27139, '2.60.120.260-FF-000068', NULL, 'Adipocyte enhancer-binding protein 1', 171, NULL, NULL, 27139),
(27140, '3.60.15.10-FF-000131', NULL, 'Zn-dependent hydrolases, including glyoxylases', 198, NULL, NULL, 27140),
(27141, '3.40.50.300-FF-003160', NULL, 'Initiator protein NS1', 217, NULL, NULL, 27141),
(27142, '3.40.50.970-FF-000022', NULL, '2-oxoglutarate ferredoxin oxidoreductase alpha subunit', 200, NULL, NULL, 27142),
(27143, '4.10.60.10-FF-000027', NULL, 'serine/arginine-rich splicing factor 7 isoform X1', 64, NULL, NULL, 27143),
(27144, '3.30.1640.10-FF-000084', NULL, 'DNA helicase', 78, NULL, NULL, 27144),
(27145, '3.30.2410.10-FF-000067', NULL, 'Uncharacterized protein', 119, NULL, NULL, 27145),
(27146, '1.10.472.10-FF-000054', NULL, 'origin recognition complex subunit 6', 94, NULL, NULL, 27146),
(27147, '2.130.10.10-FF-002165', NULL, 'Suppressor of organelle fusion 2', 350, NULL, NULL, 27147),
(27148, '2.10.25.10-FF-001288', NULL, 'Uncharacterized protein', 49, NULL, NULL, 27148),
(27149, '3.40.50.80-FF-000048', NULL, 'Ferric reduction oxidase 5', 115, NULL, NULL, 27149),
(27150, '3.40.50.2300-FF-000408', NULL, 'Two-component response regulator', 138, NULL, NULL, 27150),
(27151, '1.50.40.10-FF-000099', NULL, 'Mitochondrial carrier protein', 279, NULL, NULL, 27151),
(27152, '2.120.10.80-FF-000319', NULL, 'Uncharacterized protein', 165, NULL, NULL, 27152),
(27153, '3.40.50.300-FF-008084', NULL, 'Uncharacterized protein', 115, NULL, NULL, 27153),
(27154, '3.40.50.1240-FF-000170', NULL, NULL, 269, NULL, NULL, 27154),
(27155, '1.10.8.60-FF-000388', NULL, 'Uncharacterized protein', 84, NULL, NULL, 27155),
(27156, '1.20.120.20-FF-000035', NULL, 'Reticulon-like protein', 87, NULL, NULL, 27156),
(27157, '3.30.70.1290-FF-000001', NULL, 'REP-associated tyrosine transposase', 163, NULL, NULL, 27157),
(27158, '1.20.5.190-FF-000058', NULL, 'IQ motif containing B1', 52, NULL, NULL, 27158),
(27159, '3.10.20.90-FF-000293', NULL, 'Tyrosine-protein phosphatase', 89, NULL, NULL, 27159),
(27160, '3.10.350.10-FF-000061', NULL, 'Uncharacterized protein', 55, NULL, NULL, 27160),
(27161, '1.20.120.720-FF-000036', NULL, 'Unconventional myosin ID', 107, NULL, NULL, 27161),
(27162, '3.10.100.10-FF-000352', NULL, NULL, 98, NULL, NULL, 27162),
(27163, '1.10.10.60-FF-000916', NULL, NULL, 51, NULL, NULL, 27163),
(27164, '1.10.220.160-FF-000017', NULL, 'GH11294p', 87, NULL, NULL, 27164),
(27165, '3.40.47.10-FF-000183', NULL, '3-oxoacyl-(Acyl-carrier-protein) synthase III, putative', 338, NULL, NULL, 27165),
(27166, '3.30.70.330-FF-002231', NULL, NULL, 128, NULL, NULL, 27166),
(27167, '3.40.630.10-FF-000430', NULL, 'Clan MH, family M28, aminopeptidase S-like metallopeptidase', 280, NULL, NULL, 27167),
(27168, '3.30.40.10-FF-000106', NULL, 'Histone-lysine N-methyltransferase', 46, NULL, NULL, 27168),
(27169, '3.40.50.300-FF-002906', NULL, 'Chromosome segregation in meiosis protein 2', 213, NULL, NULL, 27169),
(27170, '3.30.200.20-FF-000537', NULL, 'Non-specific serine/threonine protein kinase', 99, NULL, NULL, 27170),
(27171, '3.40.50.300-FF-006706', NULL, 'Uncharacterized protein', 77, NULL, NULL, 27171),
(27172, '2.40.50.140-FF-000344', NULL, 'Replication protein A subunit', 209, NULL, NULL, 27172),
(27173, '1.10.132.70-FF-000018', NULL, 'Telomerase reverse transcriptase', 223, NULL, NULL, 27173),
(27174, '1.10.167.10-FF-000058', NULL, 'G protein-coupled receptor kinase', 79, NULL, NULL, 27174),
(27175, '2.40.30.10-FF-000506', NULL, 'Uncharacterized protein', 92, NULL, NULL, 27175),
(27176, '3.20.20.80-FF-000502', NULL, 'Glycoside hydrolase family 17 protein', 147, NULL, NULL, 27176),
(27177, '3.30.710.10-FF-000500', NULL, 'Uncharacterized protein', 128, NULL, NULL, 27177),
(27178, '3.40.50.300-FF-004694', NULL, 'Probable mitochondrial Rho GTPase gemA', 96, NULL, NULL, 27178),
(27179, '3.30.300.130-FF-000026', NULL, NULL, 33, NULL, NULL, 27179),
(27180, '1.20.920.10-FF-000110', NULL, 'RSC complex subunit', 158, NULL, NULL, 27180);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(27181, '3.40.50.170-FF-000012', NULL, 'Phosphoribosylglycinamide formyltransferase', 181, NULL, NULL, 27181),
(27182, '3.40.50.970-FF-000229', NULL, 'Transketolase, putative', 134, NULL, NULL, 27182),
(27183, '1.25.70.10-FF-000092', NULL, NULL, 91, NULL, NULL, 27183),
(27184, '3.40.50.300-FF-004806', NULL, 'GTP-binding protein 2', 233, NULL, NULL, 27184),
(27185, '3.30.70.1170-FF-000016', NULL, 'Nop2 (NOP2)/SUN domain family member', 88, NULL, NULL, 27185),
(27186, '1.10.760.10-FF-000083', NULL, 'Cytochrome c peroxidase', 209, NULL, NULL, 27186),
(27187, '3.50.50.60-FF-001189', NULL, 'Uncharacterized protein', 67, NULL, NULL, 27187),
(27188, '2.60.40.10-FF-004547', NULL, NULL, 82, NULL, NULL, 27188),
(27189, '3.30.420.40-FF-000408', NULL, 'Heat shock protein 70, putative', 129, NULL, NULL, 27189),
(27190, '1.25.40.10-FF-001899', NULL, 'Protein F54C1.5/ TPR repeat family', 106, NULL, NULL, 27190),
(27191, '2.30.180.10-FF-000165', NULL, NULL, 160, NULL, NULL, 27191),
(27192, '3.30.1370.10-FF-000203', NULL, 'Uncharacterized protein', 74, NULL, NULL, 27192),
(27193, '2.120.10.80-FF-000112', NULL, 'Uncharacterized protein, isoform B', 293, NULL, NULL, 27193),
(27194, '1.10.132.60-FF-000015', NULL, 'DNA polymerase', 152, NULL, NULL, 27194),
(27195, '3.40.50.1100-FF-000285', NULL, 'Uncharacterized protein', 30, NULL, NULL, 27195),
(27196, '1.10.220.30-FF-000020', NULL, 'Flagellar motor switch protein FliG', 75, NULL, NULL, 27196),
(27197, '3.40.50.1820-FF-001439', NULL, 'Uncharacterized protein', 190, NULL, NULL, 27197),
(27198, '1.20.1050.10-FF-000306', NULL, 'Uncharacterized protein', 26, NULL, NULL, 27198),
(27199, '2.130.10.10-FF-004065', NULL, 'Uncharacterized protein', 206, NULL, NULL, 27199),
(27200, '2.130.10.10-FF-000720', NULL, 'Dynein assembly factor with WDR repeat domains 1', 82, NULL, NULL, 27200),
(27201, '3.90.110.10-FF-000014', NULL, 'Malate dehydrogenase', 178, NULL, NULL, 27201),
(27202, '2.10.110.10-FF-000305', NULL, 'Predicted protein', 42, NULL, NULL, 27202),
(27203, '1.25.10.10-FF-002460', NULL, 'Predicted protein', 221, NULL, NULL, 27203),
(27204, '3.90.79.10-FF-000232', NULL, 'Uncharacterized protein', 79, NULL, NULL, 27204),
(27205, '3.30.530.20-FF-000085', NULL, 'Cyclase', 142, NULL, NULL, 27205),
(27206, '3.40.50.300-FF-003879', NULL, 'Tuzin, putative', 116, NULL, NULL, 27206),
(27207, '1.10.260.40-FF-000031', NULL, 'DNA-binding transcriptional repressor EbgR', 63, NULL, NULL, 27207),
(27208, '2.60.260.20-FF-000151', NULL, 'AGAP006578-PA', 80, NULL, NULL, 27208),
(27209, '3.30.420.40-FF-000650', NULL, 'Actin-related protein 5', 16, NULL, NULL, 27209),
(27210, '3.30.200.20-FF-002218', NULL, 'Uncharacterized protein', 41, NULL, NULL, 27210),
(27211, '3.30.750.24-FF-000044', NULL, 'Sulfate permease family protein', 121, NULL, NULL, 27211),
(27212, '3.30.1360.10-FF-000023', NULL, 'DNA-directed RNA polymerase II subunit RPB11', 118, NULL, NULL, 27212),
(27213, '1.10.510.10-FF-002835', NULL, 'Predicted protein', 289, NULL, NULL, 27213),
(27214, '2.60.40.10-FF-002086', NULL, 'Tyrosine-protein kinase-like otk', 92, NULL, NULL, 27214),
(27215, '3.80.10.10-FF-003733', NULL, 'Uncharacterized protein', 133, NULL, NULL, 27215),
(27216, '1.25.40.180-FF-000124', NULL, 'Protein CBG18870', 281, NULL, NULL, 27216),
(27217, '1.10.238.10-FF-000673', NULL, 'Uncharacterized protein', 64, NULL, NULL, 27217),
(27218, '2.170.130.10-FF-000033', NULL, 'Heme transport protein HutA', 128, NULL, NULL, 27218),
(27219, '3.10.110.10-FF-000178', NULL, 'Tumor Susceptibility Gene homolog', 145, NULL, NULL, 27219),
(27220, '1.10.510.10-FF-000935', NULL, 'Exported serine/threonine protein kinase', 145, NULL, NULL, 27220),
(27221, '3.30.1520.10-FF-000018', NULL, 'Non-specific serine/threonine protein kinase', 119, NULL, NULL, 27221),
(27222, '2.130.10.30-FF-000113', NULL, NULL, 86, NULL, NULL, 27222),
(27223, '1.10.10.10-FF-000907', NULL, 'Probable transcriptional regulatory protein', 119, NULL, NULL, 27223),
(27224, '3.30.300.30-FF-000020', NULL, 'Long-chain fatty acid transporter', 101, NULL, NULL, 27224);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(27225, '2.60.120.260-FF-000422', NULL, 'Xaa-Pro aminopeptidase P', 118, NULL, NULL, 27225),
(27226, '2.60.40.1110-FF-000008', NULL, '1,4-alpha-glucan branching enzyme', 98, NULL, NULL, 27226),
(27227, '3.30.70.980-FF-000059', NULL, 'Probable transcriptional regulatory protein C8D2.12c', 74, NULL, NULL, 27227),
(27228, '3.30.160.60-FF-004862', NULL, NULL, 37, NULL, NULL, 27228),
(27229, '3.30.9.10-FF-000298', NULL, 'Uncharacterized protein', 12, NULL, NULL, 27229),
(27230, '3.90.1340.10-FF-000002', NULL, NULL, 54, NULL, NULL, 27230),
(27231, '3.30.750.160-FF-000001', NULL, 'Nudix hydrolase 20, chloroplastic', 106, NULL, NULL, 27231),
(27232, '3.30.1330.30-FF-000089', NULL, 'Ribosomal protein L7a', 183, NULL, NULL, 27232),
(27233, '1.10.510.10-FF-000374', NULL, 'Putative cyclin-dependent kinase E-1', 240, NULL, NULL, 27233),
(27234, '1.10.510.10-FF-000626', NULL, 'probable L-type lectin-domain containing receptor kinase S.5', 210, NULL, NULL, 27234),
(27235, '2.40.50.100-FF-000029', NULL, 'propionyl-CoA carboxylase alpha chain, mitochondrial', 65, NULL, NULL, 27235),
(27236, '3.30.70.330-FF-002129', NULL, NULL, 104, NULL, NULL, 27236),
(27237, '3.30.890.10-FF-000029', NULL, 'Methyl-CpG-binding domain-containing protein 7', 104, NULL, NULL, 27237),
(27238, '3.50.7.10-FF-000030', NULL, '60 kDa chaperonin GROEL', 180, NULL, NULL, 27238),
(27239, '1.25.10.10-FF-000318', NULL, 'Serine/threonine-protein phosphatase 2A regulatory subunit A gamma isoform', 577, NULL, NULL, 27239),
(27240, '3.10.100.10-FF-000043', NULL, 'lymphocyte antigen 75 precursor', 136, NULL, NULL, 27240),
(27241, '3.30.700.10-FF-000011', NULL, 'Type 4 pili biogenesis protein (Prepilin-like protein)', 121, NULL, NULL, 27241),
(27242, '2.10.110.10-FF-000053', NULL, 'Actin-binding LIM protein family, member 2', 62, NULL, NULL, 27242),
(27243, '2.60.40.10-FF-004856', NULL, NULL, 67, NULL, NULL, 27243),
(27244, '3.90.280.10-FF-000026', NULL, NULL, 74, NULL, NULL, 27244),
(27245, '3.40.630.10-FF-000076', NULL, 'Carboxypeptidase B2', 225, NULL, NULL, 27245),
(27246, '1.20.1070.10-FF-002005', NULL, 'Uncharacterized protein', 141, NULL, NULL, 27246),
(27247, '3.80.10.10-FF-001833', NULL, 'Insulin-like growth factor-binding protein complex acid labile subunit', 141, NULL, NULL, 27247),
(27248, '1.10.220.150-FF-000014', NULL, 'ADP-ribosylation factor GTPase-activating protein', 133, NULL, NULL, 27248),
(27249, '3.40.50.620-FF-000046', NULL, 'tRNA-cytidine(32) 2-sulfurtransferase', 263, NULL, NULL, 27249),
(27250, '3.30.200.20-FF-000318', NULL, 'C-type lectin receptor-like tyrosine-protein kinase', 99, NULL, NULL, 27250),
(27251, '2.60.40.10-FF-001422', NULL, 'T-cell surface glycoprotein CD3 epsilon chain', 96, NULL, NULL, 27251),
(27252, '3.40.50.12390-FF-000006', NULL, 'Putative 5''-3'' exonuclease XRNC', 222, NULL, NULL, 27252),
(27253, '3.30.430.20-FF-000021', NULL, 'Protein kinase domain containing protein, expressed', 107, NULL, NULL, 27253),
(27254, '3.30.160.60-FF-004553', NULL, NULL, 28, NULL, NULL, 27254),
(27255, '3.30.1490.190-FF-000010', NULL, 'Cation uptake regulator', 58, NULL, NULL, 27255),
(27256, '3.30.750.24-FF-000145', NULL, 'Pendrin', 137, NULL, NULL, 27256),
(27257, '3.40.390.10-FF-000028', NULL, 'Zinc metalloproteinase', 252, NULL, NULL, 27257),
(27258, '3.30.300.180-FF-000024', NULL, 'Chromosomal replication initiator protein DnaA', 80, NULL, NULL, 27258),
(27259, '3.90.79.10-FF-000007', NULL, 'NUDIX hydrolase YfcD', 180, NULL, NULL, 27259),
(27260, '2.40.160.110-FF-000042', NULL, 'Uncharacterized protein', 130, NULL, NULL, 27260),
(27261, '1.20.1310.10-FF-000158', NULL, NULL, 57, NULL, NULL, 27261),
(27262, '2.60.40.1120-FF-000028', NULL, 'CarboxyPeptidase D family', 89, NULL, NULL, 27262),
(27263, '1.10.10.60-FF-000664', NULL, 'Myb-related protein 306', 48, NULL, NULL, 27263),
(27264, '1.20.1070.10-FF-001387', NULL, 'Uncharacterized protein', 246, NULL, NULL, 27264),
(27265, '3.60.40.10-FF-000060', NULL, 'Protein phosphatase 2c', 319, NULL, NULL, 27265),
(27266, '1.25.40.340-FF-000015', NULL, NULL, 64, NULL, NULL, 27266); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(27267, '3.30.70.330-FF-001983', NULL, NULL, 104, NULL, NULL, 27267),
(27268, '3.30.1060.10-FF-000011', NULL, 'Peptide methionine sulfoxide reductase MsrA', 174, NULL, NULL, 27268),
(27269, '3.30.1680.10-FF-000070', NULL, 'Uncharacterized protein', 46, NULL, NULL, 27269),
(27270, '1.20.272.10-FF-000019', NULL, 'Protein STICHEL-like 1 isoform C', 114, NULL, NULL, 27270),
(27271, '1.20.1640.10-FF-000037', NULL, 'Protein-export membrane protein SecF', 196, NULL, NULL, 27271),
(27272, '3.90.70.10-FF-000903', NULL, 'Ubiquitinyl hydrolase 1', 274, NULL, NULL, 27272),
(27273, '1.20.1250.20-FF-002207', NULL, 'Uncharacterized protein', 142, NULL, NULL, 27273),
(27274, '1.10.10.60-FF-000136', NULL, 'Transcriptional regulator, AraC family', 112, NULL, NULL, 27274),
(27275, '3.90.550.50-FF-000132', NULL, 'Hexosyltransferase', 240, NULL, NULL, 27275),
(27276, '2.40.50.40-FF-000022', NULL, 'M-phase phosphoprotein 8', 62, NULL, NULL, 27276),
(27277, '3.40.800.10-FF-000027', NULL, 'Arginase', 311, NULL, NULL, 27277),
(27278, '2.60.210.10-FF-000004', NULL, 'E3 ubiquitin-protein ligase SINAT5-like', 133, NULL, NULL, 27278),
(27279, '2.40.10.10-FF-000477', NULL, NULL, 107, NULL, NULL, 27279),
(27280, '3.80.10.10-FF-004340', NULL, 'Uncharacterized protein', 190, NULL, NULL, 27280),
(27281, '3.90.1100.10-FF-000035', NULL, 'DNA-directed RNA polymerase subunit 2', 174, NULL, NULL, 27281),
(27282, '3.40.395.10-FF-000017', NULL, 'Protease', 204, NULL, NULL, 27282),
(27283, '3.30.160.60-FF-000618', NULL, 'zinc finger protein 341 isoform X1', 26, NULL, NULL, 27283),
(27284, '1.25.40.330-FF-000012', NULL, 'Adenylyl cyclase-associated protein', 98, NULL, NULL, 27284),
(27285, '1.10.510.10-FF-002644', NULL, 'Probable serine/threonine-protein kinase fhkC', 379, NULL, NULL, 27285),
(27286, '3.60.15.10-FF-000114', NULL, 'Protein CBG11581', 224, NULL, NULL, 27286),
(27287, '3.30.200.20-FF-000644', NULL, 'Suppressor of npr1-1 constitutive 4', 106, NULL, NULL, 27287),
(27288, '2.60.40.150-FF-000515', NULL, 'Uncharacterized protein', 135, NULL, NULL, 27288),
(27289, '1.10.287.2620-FF-000002', NULL, 'Dynein heavy chain 2, axonemal', 66, NULL, NULL, 27289),
(27290, '1.10.472.10-FF-000508', NULL, 'Uncharacterized protein', 102, NULL, NULL, 27290),
(27291, '3.30.1490.100-FF-000040', NULL, 'Predicted protein', 91, NULL, NULL, 27291),
(27292, '1.10.238.230-FF-000005', NULL, 'Serine/threonine-protein phosphatase 2A regulatory subunit B'''' subunit alpha', 101, NULL, NULL, 27292),
(27293, '3.40.50.150-FF-000473', NULL, 'RNA-directed RNA polymerase L', 199, NULL, NULL, 27293),
(27294, '3.40.47.10-FF-000060', NULL, 'Acetyl-CoA acyltransferase 1', 276, NULL, NULL, 27294),
(27295, '1.25.40.10-FF-002506', NULL, 'DUF3868 domain-containing protein', 110, NULL, NULL, 27295),
(27296, '1.10.1300.10-FF-000036', NULL, 'Phosphodiesterase', 320, NULL, NULL, 27296),
(27297, '3.80.10.10-FF-001743', NULL, 'GD14405', 237, NULL, NULL, 27297),
(27298, '3.30.70.1400-FF-000001', NULL, 'Aminomethyltransferase', 90, NULL, NULL, 27298),
(27299, '1.10.510.10-FF-000508', NULL, 'Mitogen-activated protein kinase', 45, NULL, NULL, 27299),
(27300, '2.60.40.1400-FF-000005', NULL, 'G protein-activated inward rectifier potassium channel 2', 180, NULL, NULL, 27300),
(27301, '4.10.520.10-FF-000014', NULL, 'DNA-binding protein HU', 94, NULL, NULL, 27301),
(27302, '3.10.110.10-FF-000223', NULL, 'Uncharacterized protein', 144, NULL, NULL, 27302),
(27303, '3.10.110.10-FF-000072', NULL, 'Ubiquitin-conjugating enzyme E2 W', 151, NULL, NULL, 27303),
(27304, '1.10.220.10-FF-000071', NULL, 'Uncharacterized protein', 66, NULL, NULL, 27304),
(27305, '3.40.50.720-FF-000104', NULL, 'Shikimate dehydrogenase (NADP(+))', 143, NULL, NULL, 27305),
(27306, '2.60.40.770-FF-000010', NULL, 'Uncharacterized protein', 127, NULL, NULL, 27306),
(27307, '3.40.525.10-FF-000067', NULL, 'Putative Rho GTPase-activating protein C1565.02c', 149, NULL, NULL, 27307),
(27308, '1.10.510.10-FF-000497', NULL, 'Phosphoinositide 3-kinase regulatory subunit', 302, NULL, NULL, 27308),
(27309, '3.90.226.10-FF-000108', NULL, 'Acetyl-coenzyme A carboxylase carboxyl transferase subunit beta', 255, NULL, NULL, 27309);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(27310, '3.80.20.20-FF-000044', NULL, 'GPI-anchored cell wall protein Pst1, putative (AFU_orthologue AFUA_6G10290)', 142, NULL, NULL, 27310),
(27311, '2.130.10.10-FF-003699', NULL, 'Uncharacterized protein', 364, NULL, NULL, 27311),
(27312, '1.10.472.10-FF-000615', NULL, 'Uncharacterized protein', 160, NULL, NULL, 27312),
(27313, '3.30.160.60-FF-006453', NULL, NULL, 40, NULL, NULL, 27313),
(27314, '1.10.287.1270-FF-000002', NULL, 'G protein-coupled receptor kinase', 74, NULL, NULL, 27314),
(27315, '3.90.550.10-FF-000586', NULL, 'Glycosyltransferase', 238, NULL, NULL, 27315),
(27316, '1.20.1530.20-FF-000009', NULL, 'Arsenite transporter, ACR3 family', 339, NULL, NULL, 27316),
(27317, '2.70.130.10-FF-000097', NULL, NULL, 152, NULL, NULL, 27317),
(27318, '1.10.238.10-FF-000583', NULL, 'Sodium/calcium exchanger NCL', 94, NULL, NULL, 27318),
(27319, '3.40.50.720-FF-000430', NULL, '17-beta-hydroxysteroid dehydrogenase 13 isoform X2', 171, NULL, NULL, 27319),
(27320, '2.60.40.10-FF-001012', NULL, 'Embigin', 97, NULL, NULL, 27320),
(27321, '1.20.1280.290-FF-000101', NULL, 'YALI0C15345p', 145, NULL, NULL, 27321),
(27322, '1.20.1250.20-FF-002314', NULL, 'Uncharacterized protein', 253, NULL, NULL, 27322),
(27323, '3.10.100.10-FF-000251', NULL, NULL, 141, NULL, NULL, 27323),
(27324, '2.30.18.10-FF-000012', NULL, 'Septin and tuftelin-interacting protein 1 homolog 1', 47, NULL, NULL, 27324),
(27325, '3.40.630.10-FF-000429', NULL, 'Carboxypeptidase A6', 280, NULL, NULL, 27325),
(27326, '1.10.510.10-FF-002751', NULL, NULL, 223, NULL, NULL, 27326),
(27327, '3.40.50.1440-FF-000139', NULL, 'Uncharacterized protein', 80, NULL, NULL, 27327),
(27328, '2.60.40.60-FF-000942', NULL, 'Uncharacterized protein', 62, NULL, NULL, 27328),
(27329, '2.30.110.10-FF-000099', NULL, 'Flavin-dependent trigonelline monooxygenase, reductase component', 164, NULL, NULL, 27329),
(27330, '1.20.1250.20-FF-001174', NULL, 'Major facilitator superfamily protein', 209, NULL, NULL, 27330),
(27331, '1.20.1070.10-FF-002106', NULL, 'Uncharacterized protein', 150, NULL, NULL, 27331),
(27332, '3.30.40.10-FF-002129', NULL, 'General transcription and DNA repair factor IIH', 85, NULL, NULL, 27332),
(27333, '3.40.50.300-FF-006369', NULL, 'Ras homolog family member F, filopodia associated', 138, NULL, NULL, 27333),
(27334, '2.60.34.10-FF-000082', NULL, 'Heat shock 70 kDa protein 14', 111, NULL, NULL, 27334),
(27335, '2.130.10.10-FF-002620', NULL, 'WD repeat-containing protein 92 homolog', 348, NULL, NULL, 27335),
(27336, '2.130.10.10-FF-002283', NULL, 'Putative vacuolar assembly protein vps41', 218, NULL, NULL, 27336),
(27337, '1.10.1670.10-FF-000024', NULL, 'Endonuclease III homolog', 72, NULL, NULL, 27337),
(27338, '3.90.70.10-FF-000892', NULL, 'Ubiquitinyl hydrolase 1', 414, NULL, NULL, 27338),
(27339, '2.40.50.140-FF-000120', NULL, 'Probable DNA helicase MCM9', 107, NULL, NULL, 27339),
(27340, '3.40.50.200-FF-000179', NULL, 'PapA protein', 315, NULL, NULL, 27340),
(27341, '2.60.40.10-FF-002642', NULL, 'Chaperone CupA5', 90, NULL, NULL, 27341),
(27342, '3.30.160.60-FF-004199', NULL, NULL, 54, NULL, NULL, 27342),
(27343, '3.10.120.10-FF-000044', NULL, 'AAL078Wp', 88, NULL, NULL, 27343),
(27344, '1.10.238.10-FF-000920', NULL, 'EF-hand calcium-binding domain-containing protein 6-like', 79, NULL, NULL, 27344),
(27345, '1.10.3720.10-FF-000158', NULL, 'ABC transporter permease', 218, NULL, NULL, 27345),
(27346, '1.25.40.10-FF-001989', NULL, 'Os06g0493800 protein', 100, NULL, NULL, 27346),
(27347, '2.30.29.30-FF-000026', NULL, 'Arf-GAP with coiled-coil, ANK repeat and PH domain-containing protein 2', 114, NULL, NULL, 27347),
(27348, '3.40.50.300-FF-002098', NULL, 'Lsa family ABC-F type ribosomal protection protein', 222, NULL, NULL, 27348),
(27349, '1.25.40.10-FF-003597', NULL, 'Conserved WD40 and TPR repeat-containing protein, putative', 146, NULL, NULL, 27349),
(27350, '3.30.420.40-FF-000178', NULL, 'Heat shock 70 kDa protein', 95, NULL, NULL, 27350),
(27351, '3.30.40.10-FF-000005', NULL, 'zinc finger protein isoform X1', 120, NULL, NULL, 27351),
(27352, '2.60.200.10-FF-000032', NULL, 'Interferon regulatory factor 4', 208, NULL, NULL, 27352);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(27353, '3.30.300.30-FF-000121', NULL, 'L-prolyl-AMP Ligase PltF', 101, NULL, NULL, 27353),
(27354, '1.10.490.20-FF-000003', NULL, 'C-phycocyanin alpha chain', 162, NULL, NULL, 27354),
(27355, '3.40.50.300-FF-006167', NULL, 'Heparan sulfate 2-O-sulfotransferase, putative', 103, NULL, NULL, 27355),
(27356, '2.10.25.10-FF-001743', NULL, 'Uncharacterized protein', 38, NULL, NULL, 27356),
(27357, '3.50.50.60-FF-000194', NULL, 'Cilia and flagella associated protein 61', 155, NULL, NULL, 27357),
(27358, '2.130.10.10-FF-000675', NULL, 'Intraflagellar transport 140', 151, NULL, NULL, 27358),
(27359, '2.60.40.1170-FF-000094', NULL, NULL, 113, NULL, NULL, 27359),
(27360, '3.40.50.720-FF-001734', NULL, 'Homoserine dehydrogenase', 175, NULL, NULL, 27360),
(27361, '2.40.30.10-FF-000063', NULL, 'Cytochrome b5 reductase 4', 105, NULL, NULL, 27361),
(27362, '2.60.40.10-FF-000697', NULL, 'titin isoform X1', 99, NULL, NULL, 27362),
(27363, '2.10.25.10-FF-001524', NULL, 'Uncharacterized protein', 50, NULL, NULL, 27363),
(27364, '3.80.10.10-FF-003632', NULL, 'Predicted protein', 170, NULL, NULL, 27364),
(27365, '3.40.850.10-FF-000401', NULL, 'Kinesin-like protein', 270, NULL, NULL, 27365),
(27366, '3.30.200.20-FF-000970', NULL, 'CMGC family protein kinase', 93, NULL, NULL, 27366),
(27367, '3.50.50.60-FF-000087', NULL, 'oxidative stress-induced growth inhibitor 2 isoform X2', 278, NULL, NULL, 27367),
(27368, '3.30.450.30-FF-000042', NULL, 'Dynein-associated protein, putative', 109, NULL, NULL, 27368),
(27369, '3.40.50.2300-FF-000190', NULL, 'Glutamate receptor, metabotropic', 286, NULL, NULL, 27369),
(27370, '3.30.43.10-FF-000045', NULL, 'D-2-hydroxyglutarate dehydrogenase, mitochondrial', 102, NULL, NULL, 27370),
(27371, '2.130.10.10-FF-000366', NULL, 'DDB1-and CUL4-associated factor homolog 1', 327, NULL, NULL, 27371),
(27372, '2.60.40.10-FF-001321', NULL, 'Cilia and flagella associated protein 221', 102, NULL, NULL, 27372),
(27373, '1.20.58.70-FF-000029', NULL, 'Syntaxin, Qa-SNARE family', 232, NULL, NULL, 27373),
(27374, '3.40.50.920-FF-000029', NULL, 'Xylulose-5-phosphate/fructose-6-phosphate phosphoketolase', 184, NULL, NULL, 27374),
(27375, '3.20.110.10-FF-000041', NULL, 'Alpha-mannosidase', 166, NULL, NULL, 27375),
(27376, '1.10.10.10-FF-000610', NULL, 'LexA repressor', 69, NULL, NULL, 27376),
(27377, '3.30.760.10-FF-000020', NULL, 'Eukaryotic translation initiation factor 4E, putative', 186, NULL, NULL, 27377),
(27378, '1.10.357.10-FF-000067', NULL, 'Transcriptional regulatory protein', 204, NULL, NULL, 27378),
(27379, '3.40.50.2000-FF-000201', NULL, 'UDP-glucuronosyltransferase', 173, NULL, NULL, 27379),
(27380, '3.40.50.1240-FF-000158', NULL, NULL, 198, NULL, NULL, 27380),
(27381, '1.25.70.10-FF-000075', NULL, NULL, 187, NULL, NULL, 27381),
(27382, '3.30.160.60-FF-005025', NULL, NULL, 76, NULL, NULL, 27382),
(27383, '2.160.20.10-FF-000141', NULL, 'Cell surface protein', 248, NULL, NULL, 27383),
(27384, '3.40.50.300-FF-008314', NULL, 'RecBCD enzyme subunit RecB', 253, NULL, NULL, 27384),
(27385, '2.130.10.10-FF-002390', NULL, 'Striatin Pro11', 305, NULL, NULL, 27385),
(27386, '3.40.50.10860-FF-000036', NULL, 'Uncharacterized protein', 51, NULL, NULL, 27386),
(27387, '3.30.420.40-FF-000543', NULL, 'Actin, putative', 109, NULL, NULL, 27387),
(27388, '3.30.40.10-FF-001096', NULL, 'RBR-type E3 ubiquitin transferase', 88, NULL, NULL, 27388),
(27389, '3.60.15.10-FF-000221', NULL, 'Uncharacterized protein', 119, NULL, NULL, 27389),
(27390, '1.20.1420.30-FF-000026', NULL, 'Vacuolar calcium ion transporter', 155, NULL, NULL, 27390),
(27391, '3.40.50.970-FF-000123', NULL, 'Putative acetolactate synthase large subunit', 182, NULL, NULL, 27391),
(27392, '2.10.25.10-FF-000113', NULL, 'Cadherin, EGF LAG seven-pass G-type receptor 3', 44, NULL, NULL, 27392),
(27393, '3.80.10.10-FF-004121', NULL, 'NLR family CARD domain containing 3', 114, NULL, NULL, 27393),
(27394, '3.30.720.10-FF-000001', NULL, 'Signal recognition particle 9 kDa protein', 81, NULL, NULL, 27394),
(27395, '1.10.340.30-FF-000074', NULL, 'Uncharacterized protein', 158, NULL, NULL, 27395);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(27396, '3.10.20.90-FF-001017', NULL, 'Uncharacterized protein', 41, NULL, NULL, 27396),
(27397, '1.10.510.10-FF-002425', NULL, NULL, 154, NULL, NULL, 27397),
(27398, '3.40.50.620-FF-000063', NULL, 'Isoleucine--tRNA ligase', 436, NULL, NULL, 27398),
(27399, '2.60.40.10-FF-000388', NULL, 'TEK receptor tyrosine kinase', 92, NULL, NULL, 27399),
(27400, '3.40.50.150-FF-000782', NULL, NULL, 67, NULL, NULL, 27400),
(27401, '3.30.1380.20-FF-000049', NULL, 'Predicted protein', 107, NULL, NULL, 27401),
(27402, '1.25.40.20-FF-001200', NULL, 'Uncharacterized protein', 60, NULL, NULL, 27402),
(27403, '2.60.40.10-FF-000708', NULL, 'Hemicentin 1', 103, NULL, NULL, 27403),
(27404, '2.60.40.10-FF-000169', NULL, '1,4-alpha-glucan branching enzyme GlgB', 119, NULL, NULL, 27404),
(27405, '3.80.10.10-FF-001850', NULL, 'Si:dkeyp-5g9.1', 210, NULL, NULL, 27405),
(27406, '1.10.238.10-FF-000690', NULL, 'EF-hand calcium-binding domain 6', 77, NULL, NULL, 27406),
(27407, '3.30.450.40-FF-000045', NULL, 'Heat-inducible transcription repressor HrcA', 131, NULL, NULL, 27407),
(27408, '3.30.160.60-FF-000944', NULL, 'zinc finger protein 232 isoform X1', 30, NULL, NULL, 27408),
(27409, '2.30.42.10-FF-000012', NULL, 'Membrane associated guanylate kinase, WW and PDZ domain containing 1', 108, NULL, NULL, 27409),
(27410, '3.40.50.1980-FF-000059', NULL, 'ABC transporter, periplasmic substrate-binding protein', 158, NULL, NULL, 27410),
(27411, '2.120.10.80-FF-000409', NULL, 'Kelch repeat protein', 211, NULL, NULL, 27411),
(27412, '1.10.1900.40-FF-000001', NULL, 'Erythrocyte membrane protein 1', 72, NULL, NULL, 27412),
(27413, '1.20.1560.10-FF-000160', NULL, 'ABC transporter B family member 2', 197, NULL, NULL, 27413),
(27414, '2.20.110.10-FF-000005', NULL, 'Histone-lysine N-methyltransferase SETD7', 134, NULL, NULL, 27414),
(27415, '1.10.10.60-FF-000445', NULL, 'Transcription factor MYB96', 89, NULL, NULL, 27415),
(27416, '3.30.70.20-FF-000055', NULL, 'Trichloroethene reductive dehalogenase', 64, NULL, NULL, 27416),
(27417, '3.40.50.300-FF-004571', NULL, 'Putative adenylate cyclase', 208, NULL, NULL, 27417),
(27418, '2.30.30.750-FF-000003', NULL, 'Putative 5''-3'' exonuclease', 91, NULL, NULL, 27418),
(27419, '1.10.730.10-FF-000019', NULL, 'Valine--tRNA ligase, mitochondrial', 226, NULL, NULL, 27419),
(27420, '1.10.8.270-FF-000118', NULL, 'TBC domain containing protein', 110, NULL, NULL, 27420),
(27421, '1.20.1390.10-FF-000017', NULL, 'Receptor-like protein kinase 4', 73, NULL, NULL, 27421),
(27422, '3.30.160.290-FF-000001', NULL, 'V(D)J recombination-activating protein 2', 33, NULL, NULL, 27422),
(27423, '2.130.10.10-FF-000147', NULL, 'U4/U6 small nuclear ribonucleoprotein Prp4', 160, NULL, NULL, 27423),
(27424, '3.10.20.30-FF-000073', NULL, 'Fumarate reductase iron-sulfur subunit', 97, NULL, NULL, 27424),
(27425, '2.30.30.30-FF-000097', NULL, 'Transcription initiation factor SPT5, putative', 66, NULL, NULL, 27425),
(27426, '3.80.10.10-FF-001378', NULL, 'Receptor-like protein kinase HAIKU2', 241, NULL, NULL, 27426),
(27427, '3.30.420.110-FF-000058', NULL, 'DNA mismatch repair protein MutS 2', 135, NULL, NULL, 27427),
(27428, '3.40.50.300-FF-000546', NULL, 'Transcription-repair-coupling factor', 240, NULL, NULL, 27428),
(27429, '3.40.120.10-FF-000099', NULL, 'Phosphoglucomutase/phosphomannomutase alpha/beta/alpha domain I', 133, NULL, NULL, 27429),
(27430, '3.30.160.60-FF-002384', NULL, 'zinc finger protein 423', 92, NULL, NULL, 27430),
(27431, '3.90.1030.20-FF-000009', NULL, NULL, 137, NULL, NULL, 27431),
(27432, '1.25.40.20-FF-000946', NULL, 'SRP, putative', 129, NULL, NULL, 27432),
(27433, '1.10.10.470-FF-000002', NULL, 'Maltooligosyl trehalose synthase', 99, NULL, NULL, 27433),
(27434, '1.10.287.110-FF-000182', NULL, 'dnaJ homolog subfamily C member 28', 95, NULL, NULL, 27434),
(27435, '3.60.140.10-FF-000011', NULL, 'Polyphenol oxidase', 268, NULL, NULL, 27435),
(27436, '1.25.40.10-FF-002725', NULL, 'Uncharacterized protein', 286, NULL, NULL, 27436),
(27437, '3.40.630.10-FF-000183', NULL, 'Uncharacterized protein', 291, NULL, NULL, 27437);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(27438, '2.60.40.10-FF-004194', NULL, NULL, 83, NULL, NULL, 27438),
(27439, '3.40.50.1820-FF-000130', NULL, 'Carboxypeptidase', 281, NULL, NULL, 27439),
(27440, '3.30.40.10-FF-000331', NULL, 'Bifunctional apoptosis regulator', 101, NULL, NULL, 27440),
(27441, '2.120.10.30-FF-000193', NULL, 'Lipophorin receptor, putative', 216, NULL, NULL, 27441),
(27442, '2.160.10.10-FF-000078', NULL, 'Homolog of p25 of dynactin (Eurofung)', 171, NULL, NULL, 27442),
(27443, '2.130.10.10-FF-004418', NULL, 'Autophagy-related protein 18f', 440, NULL, NULL, 27443),
(27444, '1.10.760.10-FF-000066', NULL, 'Nicotinate dehydrogenase subunit B', 133, NULL, NULL, 27444),
(27445, '3.40.640.10-FF-000481', NULL, 'Uncharacterized protein', 68, NULL, NULL, 27445),
(27446, '3.40.50.2000-FF-000190', NULL, 'Uncharacterized protein', 186, NULL, NULL, 27446),
(27447, '1.10.150.20-FF-000045', NULL, 'DNA polymerase V subunit', 58, NULL, NULL, 27447),
(27448, '3.30.70.330-FF-000241', NULL, 'Serine/threonine-protein kinase Kist isoform 1', 101, NULL, NULL, 27448),
(27449, '2.130.10.10-FF-000826', NULL, 'DDB1- and CUL4-associated factor 13', 106, NULL, NULL, 27449),
(27450, '1.10.510.10-FF-002970', NULL, NULL, 92, NULL, NULL, 27450),
(27451, '1.10.10.60-FF-000815', NULL, 'NK3 homeobox 3', 101, NULL, NULL, 27451),
(27452, '3.40.50.1240-FF-000186', NULL, NULL, 118, NULL, NULL, 27452),
(27453, '2.60.40.60-FF-000723', NULL, 'Cdh-4', 98, NULL, NULL, 27453),
(27454, '1.10.472.10-FF-000262', NULL, 'Transcription factor IIIB 70 kDa subunit BRF', 100, NULL, NULL, 27454),
(27455, '2.40.10.10-FF-000168', NULL, 'Genome polyprotein', 103, NULL, NULL, 27455),
(27456, '3.10.10.10-FF-000004', NULL, 'Uncharacterized protein', 111, NULL, NULL, 27456),
(27457, '2.60.40.10-FF-001231', NULL, 'Immunoglobulin-like and fibronectin type III domain containing 1', 107, NULL, NULL, 27457),
(27458, '3.40.120.10-FF-000094', NULL, 'Phosphoacetylglucosamine mutase', 146, NULL, NULL, 27458),
(27459, '3.40.50.300-FF-007010', NULL, 'ATP-binding cassette sub-family c putative', 208, NULL, NULL, 27459),
(27460, '1.10.3720.10-FF-000153', NULL, 'ABC transporter permease', 203, NULL, NULL, 27460),
(27461, '2.170.270.10-FF-000083', NULL, 'PR/SET domain 2', 106, NULL, NULL, 27461),
(27462, '3.20.70.20-FF-000010', NULL, 'Ribonucleoside-diphosphate reductase', 676, NULL, NULL, 27462),
(27463, '3.40.50.720-FF-001739', NULL, 'Uncharacterized protein', 44, NULL, NULL, 27463),
(27464, '3.90.980.20-FF-000032', NULL, NULL, 91, NULL, NULL, 27464),
(27465, '1.10.460.10-FF-000026', NULL, 'DNA topoisomerase 3', 169, NULL, NULL, 27465),
(27466, '3.90.550.10-FF-000581', NULL, 'Predicted protein', 250, NULL, NULL, 27466),
(27467, '2.60.40.10-FF-002277', NULL, 'Plexin A', 145, NULL, NULL, 27467),
(27468, '3.40.50.1970-FF-000040', NULL, 'Alcohol dehydrogenase', 198, NULL, NULL, 27468),
(27469, '3.90.400.10-FF-000008', NULL, 'Oligo-1,6-glucosidase', 70, NULL, NULL, 27469),
(27470, '2.40.30.10-FF-000372', NULL, 'Ferredoxin:NADP oxidoreductase, beta subunit', 92, NULL, NULL, 27470),
(27471, '1.25.40.10-FF-000247', NULL, 'Vacuolar protein sorting-associated protein 41 homolog', 194, NULL, NULL, 27471),
(27472, '3.40.50.300-FF-006386', NULL, 'Uncharacterized protein', 135, NULL, NULL, 27472),
(27473, '4.10.60.10-FF-000128', NULL, 'DEAD-box ATP-dependent RNA helicase 3, chloroplastic isoform A', 50, NULL, NULL, 27473),
(27474, '1.20.1070.10-FF-001617', NULL, 'Uncharacterized protein', 144, NULL, NULL, 27474),
(27475, '1.20.120.1880-FF-000020', NULL, 'Uncharacterized protein', 234, NULL, NULL, 27475),
(27476, '2.60.40.10-FF-002625', NULL, 'Protein NDNF', 106, NULL, NULL, 27476),
(27477, '3.10.120.10-FF-000027', NULL, 'TAX-2', 81, NULL, NULL, 27477),
(27478, '3.30.160.60-FF-001310', NULL, 'zinc finger protein 664', 32, NULL, NULL, 27478),
(27479, '2.10.25.10-FF-001187', NULL, 'NeuReXin related', 38, NULL, NULL, 27479),
(27480, '3.80.10.10-FF-003648', NULL, 'Uncharacterized protein', 309, NULL, NULL, 27480),
(27481, '3.30.40.10-FF-000550', NULL, 'Nitric oxide synthase-interacting protein', 58, NULL, NULL, 27481);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(27482, '1.25.40.20-FF-000727', NULL, 'Related to Lysophospholipase', 165, NULL, NULL, 27482),
(27483, '3.40.50.11860-FF-000004', NULL, 'Diphthamide biosynthesis protein 2, putative', 103, NULL, NULL, 27483),
(27484, '3.40.50.300-FF-002805', NULL, 'PEX1p AAA-peroxin', 172, NULL, NULL, 27484),
(27485, '3.90.70.40-FF-000007', NULL, 'Josephin-like protein', 123, NULL, NULL, 27485),
(27486, '1.10.8.270-FF-000146', NULL, 'GTPase activating protein, putative', 105, NULL, NULL, 27486),
(27487, '3.40.50.1980-FF-000043', NULL, 'ABC transporter substrate-binding protein-iron transport', 140, NULL, NULL, 27487),
(27488, '3.60.21.10-FF-000297', NULL, 'Serine/threonine-protein phosphatase', 365, NULL, NULL, 27488),
(27489, '2.60.34.10-FF-000109', NULL, 'DnaK protein', 123, NULL, NULL, 27489),
(27490, '3.30.450.20-FF-000011', NULL, 'Hybrid signal transduction histidine kinase', 120, NULL, NULL, 27490),
(27491, '3.40.50.2300-FF-001499', NULL, NULL, 188, NULL, NULL, 27491),
(27492, '3.90.70.30-FF-000004', NULL, 'Phytochelatin synthase-like protein', 228, NULL, NULL, 27492),
(27493, '1.25.40.10-FF-000724', NULL, 'Putative pentatricopeptide repeat-containing protein', 109, NULL, NULL, 27493),
(27494, '3.40.50.720-FF-001397', NULL, 'Os12g0102100 protein', 27, NULL, NULL, 27494),
(27495, '1.20.1280.290-FF-000062', NULL, 'L-cystine transporter, putative', 100, NULL, NULL, 27495),
(27496, '1.10.510.10-FF-002953', NULL, NULL, 215, NULL, NULL, 27496),
(27497, '1.10.510.10-FF-002279', NULL, NULL, 200, NULL, NULL, 27497),
(27498, '3.40.30.10-FF-000892', NULL, 'Queuine tRNA-ribosyltransferase accessory subunit 2', 131, NULL, NULL, 27498),
(27499, '3.40.1280.10-FF-000042', NULL, 'Ribosomal RNA small subunit methyltransferase Nep1', 219, NULL, NULL, 27499),
(27500, '1.20.5.5270-FF-000001', NULL, 'Lon protease homolog, mitochondrial', 49, NULL, NULL, 27500),
(27501, '3.90.470.10-FF-000052', NULL, 'Uncharacterized protein', 174, NULL, NULL, 27501),
(27502, '3.40.30.10-FF-000566', NULL, 'Uncharacterized protein', 99, NULL, NULL, 27502),
(27503, '1.25.10.10-FF-003050', NULL, 'Uncharacterized protein', 279, NULL, NULL, 27503),
(27504, '1.10.150.240-FF-000069', NULL, 'Haloacid dehalogenase-like hydrolase domain-containing protein Sgpp', 69, NULL, NULL, 27504),
(27505, '3.40.50.1580-FF-000046', NULL, 'Purine nucleoside phosphorylase', 181, NULL, NULL, 27505),
(27506, '3.30.565.10-FF-000218', NULL, 'C4-dicarboxylate transport sensor protein', 150, NULL, NULL, 27506),
(27507, '3.50.50.60-FF-000901', NULL, 'Uncharacterized protein', 98, NULL, NULL, 27507),
(27508, '3.40.390.10-FF-000045', NULL, 'Metalloendopeptidase', 225, NULL, NULL, 27508),
(27509, '3.30.565.10-FF-000460', NULL, 'Probable two-component sensor', 150, NULL, NULL, 27509),
(27510, '2.130.10.10-FF-002934', NULL, 'Uncharacterized WD repeat-containing protein C126.01c', 184, NULL, NULL, 27510),
(27511, '2.40.50.140-FF-000760', NULL, NULL, 57, NULL, NULL, 27511),
(27512, '2.60.120.260-FF-000630', NULL, 'Putative sugar hydrolase', 118, NULL, NULL, 27512),
(27513, '3.40.50.620-FF-000602', NULL, 'Tryptophanyl-tRNA synthetase', 226, NULL, NULL, 27513),
(27514, '1.10.472.10-FF-000481', NULL, 'Cyclin, putative', 134, NULL, NULL, 27514),
(27515, '2.60.40.10-FF-002951', NULL, 'Uncharacterized protein, isoform D', 99, NULL, NULL, 27515),
(27516, '1.20.1250.20-FF-001590', NULL, 'MFS alpha-glucoside transporter, putative', 314, NULL, NULL, 27516),
(27517, '3.80.10.10-FF-003851', NULL, 'Leucine Rich Repeat family protein', 241, NULL, NULL, 27517),
(27518, '1.10.150.20-FF-000040', NULL, 'DNA repair endonuclease XPF isoform X2', 84, NULL, NULL, 27518),
(27519, '1.10.533.10-FF-000078', NULL, 'Probable ATP-dependent RNA helicase DDX58', 94, NULL, NULL, 27519),
(27520, '1.10.150.20-FF-000264', NULL, 'ERCC (DNA excision repair protein) homolog', 64, NULL, NULL, 27520),
(27521, '3.30.160.60-FF-006458', NULL, NULL, 29, NULL, NULL, 27521),
(27522, '1.10.238.10-FF-000903', NULL, 'Rhomboid-related protein 2', 107, NULL, NULL, 27522),
(27523, '3.30.43.10-FF-000028', NULL, 'FAD binding domain protein', 79, NULL, NULL, 27523);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(27524, '3.30.500.10-FF-000018', NULL, NULL, 93, NULL, NULL, 27524),
(27525, '3.40.50.150-FF-000692', NULL, 'Methyltransferase tpcM', 263, NULL, NULL, 27525),
(27526, '1.10.510.10-FF-000727', NULL, 'Serine/threonine-protein kinase PLK', 190, NULL, NULL, 27526),
(27527, '1.25.40.20-FF-001110', NULL, 'Ankyrin, isoform B', 37, NULL, NULL, 27527),
(27528, '4.10.1000.10-FF-000112', NULL, 'Predicted protein', 69, NULL, NULL, 27528),
(27529, '1.25.40.10-FF-004086', NULL, 'Uncharacterized protein', 156, NULL, NULL, 27529),
(27530, '3.40.50.2300-FF-000280', NULL, 'Response regulator receiver domain-containing protein', 142, NULL, NULL, 27530),
(27531, '1.25.10.10-FF-000419', NULL, 'Coatomer subunit gamma', 134, NULL, NULL, 27531),
(27532, '3.30.200.20-FF-000661', NULL, 'Serine-threonine protein kinase plant-type', 96, NULL, NULL, 27532),
(27533, '1.20.58.60-FF-000026', NULL, 'Spectrin alpha chain, non-erythrocytic 1', 107, NULL, NULL, 27533),
(27534, '3.30.230.10-FF-000160', NULL, 'Elongation factor G2-like protein', 75, NULL, NULL, 27534),
(27535, '2.40.10.10-FF-000696', NULL, NULL, 144, NULL, NULL, 27535),
(27536, '1.25.10.10-FF-002027', NULL, 'Uncharacterized protein', 426, NULL, NULL, 27536),
(27537, '1.20.1070.10-FF-001724', NULL, 'Neuropeptide Y receptor Y8a', 99, NULL, NULL, 27537),
(27538, '3.50.50.60-FF-000340', NULL, 'Succinate dehydrogenase [ubiquinone] flavoprotein subunit, mitochondrial', 94, NULL, NULL, 27538),
(27539, '3.40.50.261-FF-000041', NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta, mitochondrial', 69, NULL, NULL, 27539),
(27540, '1.20.1050.10-FF-000076', NULL, 'Probable glutathione S-transferase gst-36', 115, NULL, NULL, 27540),
(27541, '3.30.420.40-FF-000217', NULL, '2-hydroxyisocaproyl-CoA dehydratase activator', 141, NULL, NULL, 27541),
(27542, '2.130.10.10-FF-002592', NULL, 'Uncharacterized protein', 171, NULL, NULL, 27542),
(27543, '1.20.58.60-FF-000161', NULL, 'Short stop, isoform K', 103, NULL, NULL, 27543),
(27544, '3.30.870.10-FF-000141', NULL, 'Cardiolipin synthase B', 68, NULL, NULL, 27544),
(27545, '3.80.10.10-FF-004031', NULL, 'Uncharacterized protein', 145, NULL, NULL, 27545),
(27546, '1.20.1050.10-FF-000115', NULL, 'CaDmium Responsive', 102, NULL, NULL, 27546),
(27547, '2.60.40.1180-FF-000097', NULL, 'Alpha-galactosidase 3', 98, NULL, NULL, 27547),
(27548, '3.40.50.720-FF-002105', NULL, 'Uncharacterized protein', 124, NULL, NULL, 27548),
(27549, '1.20.1480.30-FF-000002', NULL, 'Kinesin, putative', 84, NULL, NULL, 27549),
(27550, '3.40.50.300-FF-006476', NULL, 'Uncharacterized protein', 117, NULL, NULL, 27550),
(27551, '2.40.20.10-FF-000118', NULL, 'Plasminogen activator, urokinase a', 69, NULL, NULL, 27551),
(27552, '3.30.1540.20-FF-000040', NULL, NULL, 40, NULL, NULL, 27552),
(27553, '2.30.26.10-FF-000002', NULL, 'Dihydroorotate dehydrogenase', 73, NULL, NULL, 27553),
(27554, '1.20.5.340-FF-000047', NULL, 'Myosin heavy chain', 80, NULL, NULL, 27554),
(27555, '2.60.40.820-FF-000047', NULL, 'T-box transcription factor Tbx4', 87, NULL, NULL, 27555),
(27556, '1.10.1300.10-FF-000020', NULL, 'Phosphodiesterase', 325, NULL, NULL, 27556),
(27557, '2.20.70.10-FF-000116', NULL, 'Transcription elongation regulator 1', 73, NULL, NULL, 27557),
(27558, '3.20.20.70-FF-000859', NULL, NULL, 49, NULL, NULL, 27558),
(27559, '2.170.300.10-FF-000041', NULL, 'Tyrosine protein kinase receptor tie-1, putative', 108, NULL, NULL, 27559),
(27560, '1.20.960.20-FF-000003', NULL, 'Genome polyprotein', 86, NULL, NULL, 27560),
(27561, '1.20.960.30-FF-000006', NULL, 'WD repeat protein (AFU_orthologue AFUA_6G12600)', 53, NULL, NULL, 27561),
(27562, '3.40.1090.10-FF-000123', NULL, 'Uncharacterized protein', 195, NULL, NULL, 27562),
(27563, '3.90.1600.10-FF-000056', NULL, 'DNA polymerase', 165, NULL, NULL, 27563),
(27564, '2.30.30.60-FF-000010', NULL, 'Uncharacterized protein', 51, NULL, NULL, 27564),
(27565, '3.80.10.10-FF-004014', NULL, 'Ras guanine nucleotide exchange factor V', 148, NULL, NULL, 27565),
(27566, '3.40.640.10-FF-000464', NULL, 'Uncharacterized protein', 172, NULL, NULL, 27566);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(27567, '1.10.274.10-FF-000003', NULL, 'PTS-dependent dihydroxyacetone kinase, DhaM subunit', 124, NULL, NULL, 27567),
(27568, '3.30.70.850-FF-000020', NULL, 'Uncharacterized protein', 93, NULL, NULL, 27568),
(27569, '3.10.20.90-FF-000832', NULL, 'Uncharacterized protein', 96, NULL, NULL, 27569),
(27570, '3.10.129.10-FF-000108', NULL, 'Acyl dehydratase', 147, NULL, NULL, 27570),
(27571, '2.130.10.10-FF-002625', NULL, 'DDB1 and CUL4 associated factor 12', 166, NULL, NULL, 27571),
(27572, '2.40.160.10-FF-000004', NULL, 'Por1 mitochondrial outer membrane porin', 284, NULL, NULL, 27572),
(27573, '1.10.510.10-FF-000817', NULL, 'Serine/threonine-protein kinase ATG1', 354, NULL, NULL, 27573),
(27574, '1.20.90.10-FF-000024', NULL, NULL, 115, NULL, NULL, 27574),
(27575, '4.10.60.10-FF-000218', NULL, 'Uncharacterized protein', 31, NULL, NULL, 27575),
(27576, '3.10.100.10-FF-000161', NULL, 'Sperm receptor for egg jelly', 132, NULL, NULL, 27576),
(27577, '3.40.710.10-FF-000110', NULL, 'Putative D-alanyl-D-alanine carboxypeptidase', 285, NULL, NULL, 27577),
(27578, '3.20.20.140-FF-000199', NULL, 'Xaa-Pro dipeptidase', 302, NULL, NULL, 27578),
(27579, '1.20.1310.10-FF-000153', NULL, NULL, 113, NULL, NULL, 27579),
(27580, '2.60.40.150-FF-000638', NULL, 'Uncharacterized protein', 132, NULL, NULL, 27580),
(27581, '3.30.160.60-FF-003108', NULL, 'Zinc finger protein 646', 30, NULL, NULL, 27581),
(27582, '3.90.470.20-FF-000055', NULL, '4''-phosphopantetheinyl transferase superfamily', 157, NULL, NULL, 27582),
(27583, '3.40.640.10-FF-000155', NULL, 'Related to GLY1-L-threonine aldolase, low-specific', 245, NULL, NULL, 27583),
(27584, '3.30.160.60-FF-001001', NULL, 'RE1-silencing transcription factor B', 28, NULL, NULL, 27584),
(27585, '3.30.56.10-FF-000024', NULL, 'Phenylalanine--tRNA ligase beta subunit', 62, NULL, NULL, 27585),
(27586, '1.20.1070.10-FF-000313', NULL, 'Uncharacterized protein', 315, NULL, NULL, 27586),
(27587, '3.30.70.870-FF-000026', NULL, 'Elongation factor G', 73, NULL, NULL, 27587),
(27588, '3.40.50.970-FF-000128', NULL, 'Putative 2-oxoglutarate dehydrogenase subunit', 365, NULL, NULL, 27588),
(27589, '1.20.1250.20-FF-000206', NULL, 'Major facilitator superfamily domain containing 12', 201, NULL, NULL, 27589),
(27590, '3.30.160.60-FF-002861', NULL, NULL, 28, NULL, NULL, 27590),
(27591, '3.30.70.580-FF-000063', NULL, 'tRNA pseudouridine synthase', 107, NULL, NULL, 27591),
(27592, '3.30.160.60-FF-002619', NULL, 'ZFP57 zinc finger protein', 28, NULL, NULL, 27592),
(27593, '3.90.1300.10-FF-000016', NULL, 'Vitamin D3 hydroxylase-associated protein', 424, NULL, NULL, 27593),
(27594, '1.20.5.190-FF-000159', NULL, NULL, 50, NULL, NULL, 27594),
(27595, '3.30.70.330-FF-002040', NULL, NULL, 161, NULL, NULL, 27595),
(27596, '3.30.70.1590-FF-000001', NULL, 'Myosin heavy chain', 69, NULL, NULL, 27596),
(27597, '1.10.238.10-FF-000555', NULL, 'Phosphoinositide phospholipase C', 95, NULL, NULL, 27597),
(27598, '3.40.30.10-FF-000908', NULL, 'Thioredoxin superfamily protein', 133, NULL, NULL, 27598),
(27599, '2.40.70.10-FF-000363', NULL, NULL, 126, NULL, NULL, 27599),
(27600, '3.10.20.90-FF-001012', NULL, 'Uncharacterized protein', 57, NULL, NULL, 27600),
(27601, '3.40.50.720-FF-001178', NULL, 'UDP-glucuronic acid decarboxylase 4', 103, NULL, NULL, 27601),
(27602, '3.90.79.10-FF-000114', NULL, 'ADP-ribose pyrophosphatase', 202, NULL, NULL, 27602),
(27603, '3.10.20.90-FF-000484', NULL, 'E3 ubiquitin-protein ligase parkin', 91, NULL, NULL, 27603),
(27604, '3.40.50.920-FF-000046', NULL, 'YALI0D11176p', 150, NULL, NULL, 27604),
(27605, '2.60.40.10-FF-002316', NULL, 'AGAP004825-PA', 107, NULL, NULL, 27605),
(27606, '2.30.30.40-FF-000246', NULL, 'RIMS-binding protein 3A-like', 65, NULL, NULL, 27606),
(27607, '3.80.10.10-FF-001715', NULL, 'Kekkon5, isoform A', 81, NULL, NULL, 27607),
(27608, '1.10.274.30-FF-000009', NULL, 'Protein CBG13703', 167, NULL, NULL, 27608),
(27609, '1.25.40.10-FF-000808', NULL, 'Pentatricopeptide repeat-containing protein At4g32430, mitochondrial', 104, NULL, NULL, 27609),
(27610, '3.40.640.10-FF-000374', NULL, 'Uncharacterized protein', 151, NULL, NULL, 27610);
INSERT INTO "PUBLIC"."MODEL" VALUES
(27611, '1.10.565.10-FF-000197', NULL, 'Uncharacterized protein', 83, NULL, NULL, 27611),
(27612, '3.40.50.300-FF-003603', NULL, 'Putative Transposon transposition helper protein C', 173, NULL, NULL, 27612),
(27613, '2.60.200.10-FF-000037', NULL, 'Uncharacterized protein, isoform B', 138, NULL, NULL, 27613),
(27614, '3.30.420.40-FF-000397', NULL, 'Putative fimbrial assembly protein PilM', 112, NULL, NULL, 27614),
(27615, '2.30.180.10-FF-000047', NULL, 'Fasciclin-like protein', 144, NULL, NULL, 27615),
(27616, '3.30.420.40-FF-001021', NULL, 'Glucokinase regulator family protein, putative (AFU_orthologue AFUA_1G17490)', 47, NULL, NULL, 27616),
(27617, '2.10.110.10-FF-000171', NULL, 'Actin-binding LIM protein family member 2', 96, NULL, NULL, 27617),
(27618, '3.40.50.2300-FF-001589', NULL, NULL, 132, NULL, NULL, 27618),
(27619, '3.40.50.10810-FF-000268', NULL, 'Uncharacterized protein', 248, NULL, NULL, 27619),
(27620, '3.30.70.3490-FF-000009', NULL, 'Oxysterol-binding protein', 134, NULL, NULL, 27620),
(27621, '3.30.760.10-FF-000003', NULL, 'Eukaryotic translation initiation factor 4E', 186, NULL, NULL, 27621),
(27622, '1.10.620.20-FF-000036', NULL, 'Uncharacterized protein', 153, NULL, NULL, 27622),
(27623, '3.90.1800.10-FF-000021', NULL, 'DNA-directed RNA polymerase subunit beta', 88, NULL, NULL, 27623),
(27624, '2.130.10.10-FF-002064', NULL, 'Uncharacterized protein', 324, NULL, NULL, 27624),
(27625, '3.40.50.300-FF-002463', NULL, 'Small nuclear ribonucleoprotein component-like protein', 210, NULL, NULL, 27625),
(27626, '1.20.1420.30-FF-000009', NULL, 'sodium/potassium/calcium exchanger 5 isoform X2', 194, NULL, NULL, 27626),
(27627, '3.90.260.10-FF-000019', NULL, 'Xeroderma pigmentosum, complementation group C', 157, NULL, NULL, 27627),
(27628, '2.130.10.10-FF-002373', NULL, 'Related to UTP7-nucleolar protein, component of the small subunit processome', 121, NULL, NULL, 27628),
(27629, '3.20.20.210-FF-000012', NULL, 'Uroporphyrinogen decarboxylase', 359, NULL, NULL, 27629),
(27630, '2.10.25.10-FF-001496', NULL, 'Predicted protein', 35, NULL, NULL, 27630),
(27631, '3.40.50.300-FF-002772', NULL, 'ATP-dependent DEAD/H RNA helicase, putative', 174, NULL, NULL, 27631),
(27632, '3.30.40.10-FF-000224', NULL, 'E3 ubiquitin-protein ligase TRAF7 isoform X1', 98, NULL, NULL, 27632),
(27633, '1.20.1070.10-FF-001943', NULL, 'Uncharacterized protein', 230, NULL, NULL, 27633),
(27634, '3.30.70.1230-FF-000276', NULL, 'Predicted protein', 86, NULL, NULL, 27634),
(27635, '3.40.50.300-FF-006695', NULL, 'Predicted protein', 80, NULL, NULL, 27635),
(27636, '3.30.70.330-FF-000095', NULL, 'Putative Nucleoporin NUP53', 75, NULL, NULL, 27636),
(27637, '1.20.120.1440-FF-000001', NULL, 'Thymine dioxygenase JBP1', 170, NULL, NULL, 27637),
(27638, '3.40.50.880-FF-000231', NULL, 'Catalase', 196, NULL, NULL, 27638),
(27639, '2.60.120.260-FF-000169', NULL, 'CocE/NonD family hydrolase', 171, NULL, NULL, 27639),
(27640, '3.30.70.1350-FF-000042', NULL, NULL, 79, NULL, NULL, 27640),
(27641, '3.20.20.80-FF-000778', NULL, 'Uncharacterized protein', 242, NULL, NULL, 27641),
(27642, '3.30.70.20-FF-000072', NULL, '2-oxoglutarate:acceptor oxidoreductase', 42, NULL, NULL, 27642),
(27643, '3.40.50.2000-FF-000217', NULL, 'Trehalose-phosphatase, variant 1', 201, NULL, NULL, 27643),
(27644, '2.30.30.30-FF-000024', NULL, 'Transcription elongation factor SPT5', 50, NULL, NULL, 27644),
(27645, '3.40.50.300-FF-008168', NULL, 'Predicted protein', 86, NULL, NULL, 27645),
(27646, '3.20.20.70-FF-000775', NULL, NULL, 95, NULL, NULL, 27646),
(27647, '2.130.10.10-FF-002951', NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', 286, NULL, NULL, 27647),
(27648, '2.30.42.10-FF-000135', NULL, 'LIM domain only 7', 90, NULL, NULL, 27648),
(27649, '3.30.300.80-FF-000001', NULL, 'Site-specific recombinase Flp', 105, NULL, NULL, 27649),
(27650, '2.60.200.20-FF-000170', NULL, 'Kinesin-like protein KIF13A', 102, NULL, NULL, 27650),
(27651, '3.30.160.60-FF-000276', NULL, 'zinc finger protein 385A isoform X3', 56, NULL, NULL, 27651);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(27652, '3.40.50.2300-FF-000206', NULL, 'Two-component response regulator-like APRR2', 127, NULL, NULL, 27652),
(27653, '3.40.50.300-FF-001243', NULL, 'Nucleolar protein 9', 202, NULL, NULL, 27653),
(27654, '1.25.40.10-FF-002742', NULL, 'AaceriACR173Wp', 223, NULL, NULL, 27654),
(27655, '3.80.10.10-FF-002013', NULL, 'Slit homolog 1b (Drosophila)', 110, NULL, NULL, 27655),
(27656, '2.120.10.30-FF-000535', NULL, 'Uncharacterized protein', 120, NULL, NULL, 27656),
(27657, '3.90.640.10-FF-000104', NULL, 'Heat shock protein 70, putative', 86, NULL, NULL, 27657),
(27658, '2.60.40.790-FF-000151', NULL, NULL, 88, NULL, NULL, 27658),
(27659, '3.80.10.10-FF-001395', NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', 188, NULL, NULL, 27659),
(27660, '3.50.50.60-FF-000542', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 104, NULL, NULL, 27660),
(27661, '3.30.160.60-FF-003024', NULL, 'Zinc finger protein 699', 29, NULL, NULL, 27661),
(27662, '3.30.160.60-FF-002945', NULL, 'LD32088p', 32, NULL, NULL, 27662),
(27663, '3.10.129.10-FF-000024', NULL, 'Acyl-CoA hydrolase', 159, NULL, NULL, 27663),
(27664, '2.130.10.10-FF-004497', NULL, 'Uncharacterized protein', 242, NULL, NULL, 27664),
(27665, '3.30.300.90-FF-000004', NULL, 'SufE-like protein, chloroplastic', 95, NULL, NULL, 27665),
(27666, '3.30.1360.10-FF-000028', NULL, 'DNA-directed RNA polymerase II subunit, putative', 68, NULL, NULL, 27666),
(27667, '3.90.1410.10-FF-000137', NULL, 'Uncharacterized protein', 260, NULL, NULL, 27667),
(27668, '1.25.40.10-FF-004288', NULL, 'Uncharacterized protein', 202, NULL, NULL, 27668),
(27669, '3.30.70.1350-FF-000036', NULL, NULL, 102, NULL, NULL, 27669),
(27670, '3.40.50.150-FF-000809', NULL, 'Probable 18S rRNA (guanine-N(7))-methyltransferase', 150, NULL, NULL, 27670),
(27671, '3.40.50.1820-FF-001237', NULL, 'Periplasmic siderophore cleavage esterase IroE family', 331, NULL, NULL, 27671),
(27672, '1.10.150.240-FF-000070', NULL, 'Phosphorylated carbohydrates phosphatase TM_1254', 67, NULL, NULL, 27672),
(27673, '3.40.50.300-FF-004368', NULL, 'Lipoprotein release ATP-binding component', 224, NULL, NULL, 27673),
(27674, '3.40.190.10-FF-000064', NULL, 'Prephenate dehydratase', 91, NULL, NULL, 27674),
(27675, '3.40.50.10260-FF-000042', NULL, 'Enhancer of mRNA-decapping protein 3', 261, NULL, NULL, 27675),
(27676, '3.30.50.10-FF-000157', NULL, 'Uncharacterized protein', 106, NULL, NULL, 27676),
(27677, '3.30.1330.10-FF-000004', NULL, 'Phosphoribosylformylglycinamidine synthase subunit PurL', 150, NULL, NULL, 27677),
(27678, '3.40.1810.10-FF-000078', NULL, NULL, 60, NULL, NULL, 27678),
(27679, '3.40.50.150-FF-001271', NULL, NULL, 228, NULL, NULL, 27679),
(27680, '1.10.533.10-FF-000207', NULL, 'Predicted protein', 105, NULL, NULL, 27680),
(27681, '1.25.40.10-FF-002271', NULL, 'TPR_repeat/Tetratricopeptide_repeat_-_putative', 201, NULL, NULL, 27681),
(27682, '3.30.497.10-FF-000161', NULL, 'Uncharacterized protein', 52, NULL, NULL, 27682),
(27683, '3.40.50.1480-FF-000016', NULL, 'Adenosylhomocysteinase', 132, NULL, NULL, 27683),
(27684, '3.20.20.450-FF-000027', NULL, NULL, 238, NULL, NULL, 27684),
(27685, '2.60.40.10-FF-000843', NULL, 'Plexin D1', 127, NULL, NULL, 27685),
(27686, '2.30.30.40-FF-000561', NULL, 'Variant SH3 domain containing protein', 58, NULL, NULL, 27686),
(27687, '1.10.220.150-FF-000031', NULL, 'ARF GTPase activating protein, putative', 142, NULL, NULL, 27687),
(27688, '3.30.420.40-FF-000088', NULL, 'Glucokinase', 171, NULL, NULL, 27688),
(27689, '3.40.50.980-FF-000042', NULL, 'NRPS-like enzyme, putative', 93, NULL, NULL, 27689),
(27690, '1.10.3720.10-FF-000136', NULL, 'ABC transporter permease protein', 217, NULL, NULL, 27690),
(27691, '3.40.50.1470-FF-000013', NULL, 'Uncharacterized protein', 170, NULL, NULL, 27691),
(27692, '2.170.150.10-FF-000006', NULL, 'Histamine-releasing factor', 171, NULL, NULL, 27692),
(27693, '3.40.1280.10-FF-000025', NULL, 'Mitochondrial rRNA methyltransferase 1', 187, NULL, NULL, 27693),
(27694, '2.70.70.10-FF-000002', NULL, 'Murein DD-endopeptidase MepM', 129, NULL, NULL, 27694);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(27695, '2.70.170.10-FF-000239', NULL, 'Predicted protein', 222, NULL, NULL, 27695),
(27696, '3.30.890.10-FF-000024', NULL, 'Methyl-CpG-binding domain-containing protein 3', 78, NULL, NULL, 27696),
(27697, '2.60.40.60-FF-000796', NULL, 'Uncharacterized protein', 102, NULL, NULL, 27697),
(27698, '3.40.50.1820-FF-001765', NULL, 'Uncharacterized protein', 223, NULL, NULL, 27698),
(27699, '2.60.120.200-FF-000303', NULL, 'Outer capsid protein VP4', 162, NULL, NULL, 27699),
(27700, '2.170.150.20-FF-000009', NULL, 'Peptide-methionine (R)-S-oxide reductase', 140, NULL, NULL, 27700),
(27701, '1.20.1250.20-FF-001516', NULL, 'Uncharacterized protein', 286, NULL, NULL, 27701),
(27702, '1.10.30.10-FF-000038', NULL, 'High mobility group box 4', 78, NULL, NULL, 27702),
(27703, '3.40.190.10-FF-000592', NULL, 'Prephenate dehydratase', 99, NULL, NULL, 27703),
(27704, '2.80.10.50-FF-000268', NULL, 'Uncharacterized protein', 118, NULL, NULL, 27704),
(27705, '2.60.40.790-FF-000038', NULL, 'BMA-HSP-25, isoform c', 91, NULL, NULL, 27705),
(27706, '1.10.10.1330-FF-000002', NULL, 'RNA polymerase factor sigma-54', 70, NULL, NULL, 27706),
(27707, '1.20.120.720-FF-000019', NULL, 'myosin-VIIa isoform X2', 144, NULL, NULL, 27707),
(27708, '3.40.50.1580-FF-000024', NULL, 'Purine nucleoside phosphorylase', 273, NULL, NULL, 27708),
(27709, '1.10.20.10-FF-000291', NULL, NULL, 69, NULL, NULL, 27709),
(27710, '3.30.70.1660-FF-000028', NULL, 'peptide chain release factor 1-like, mitochondrial', 94, NULL, NULL, 27710),
(27711, '3.30.70.330-FF-001848', NULL, NULL, 113, NULL, NULL, 27711),
(27712, '3.30.200.20-FF-000554', NULL, 'CMGC/CDK/CDK7 protein kinase', 85, NULL, NULL, 27712),
(27713, '1.10.10.10-FF-000571', NULL, 'IclR family transcriptional regulator', 70, NULL, NULL, 27713),
(27714, '2.60.40.3690-FF-000001', NULL, 'Major fimbrium subunit FimA type-4', 202, NULL, NULL, 27714),
(27715, '2.10.70.10-FF-000089', NULL, 'Beta-2-glycoprotein 1', 60, NULL, NULL, 27715),
(27716, '3.80.10.10-FF-000304', NULL, 'Tubulin-specific chaperone cofactor E-like', 103, NULL, NULL, 27716),
(27717, '2.30.29.30-FF-000161', NULL, 'Rho GTPase activating protein 42', 114, NULL, NULL, 27717),
(27718, '1.20.200.10-FF-000016', NULL, 'Adenylosuccinate lyase', 269, NULL, NULL, 27718),
(27719, '2.130.10.10-FF-002844', NULL, 'Uncharacterized protein', 353, NULL, NULL, 27719),
(27720, '1.10.510.10-FF-003116', NULL, NULL, 191, NULL, NULL, 27720),
(27721, '2.40.50.140-FF-000451', NULL, 'Sugar ABC transporter ATP-binding protein', 45, NULL, NULL, 27721),
(27722, '3.90.70.10-FF-000561', NULL, 'Calcium-dependent cysteine protease, putative', 100, NULL, NULL, 27722),
(27723, '3.40.50.1000-FF-000816', NULL, NULL, 111, NULL, NULL, 27723),
(27724, '1.10.510.10-FF-002296', NULL, NULL, 214, NULL, NULL, 27724),
(27725, '3.40.50.620-FF-000041', NULL, 'Electron transfer flavoprotein alpha subunit', 185, NULL, NULL, 27725),
(27726, '2.40.10.10-FF-000387', NULL, NULL, 72, NULL, NULL, 27726),
(27727, '2.10.25.10-FF-000080', NULL, 'Neurogenic locus notch 1', 37, NULL, NULL, 27727),
(27728, '1.20.1070.10-FF-000307', NULL, 'G-protein coupled bile acid receptor 1', 284, NULL, NULL, 27728),
(27729, '3.10.180.10-FF-000019', NULL, '4-hydroxyphenylpyruvate dioxygenase', 66, NULL, NULL, 27729),
(27730, '3.40.30.10-FF-000982', NULL, 'Protein disulfide isomerase family A, member 3', 90, NULL, NULL, 27730),
(27731, '1.20.58.610-FF-000004', NULL, 'Hsp90 co-chaperone Cdc37', 125, NULL, NULL, 27731),
(27732, '3.55.50.30-FF-000028', NULL, 'DUF4974 domain-containing protein', 75, NULL, NULL, 27732),
(27733, '2.60.40.10-FF-003120', NULL, 'AGAP003610-PA', 106, NULL, NULL, 27733),
(27734, '3.30.40.10-FF-001657', NULL, 'Uncharacterized protein', 101, NULL, NULL, 27734),
(27735, '2.60.34.10-FF-000003', NULL, 'Molecular chaperone DnaK', 126, NULL, NULL, 27735),
(27736, '3.30.160.60-FF-002417', NULL, 'Serendipity locus protein H-1', 27, NULL, NULL, 27736),
(27737, '1.10.510.10-FF-002189', NULL, 'Probable inactive serine/threonine-protein kinase DDB_G0280855', 227, NULL, NULL, 27737),
(27738, '2.130.10.10-FF-004082', NULL, 'Flagellar associated protein', 201, NULL, NULL, 27738);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(27739, '3.10.28.10-FF-000062', NULL, 'Laglidadg endonuclease', 137, NULL, NULL, 27739),
(27740, '1.10.510.10-FF-002509', NULL, NULL, 189, NULL, NULL, 27740),
(27741, '3.40.50.1000-FF-000339', NULL, 'Haloacid dehalogenase-like hydrolase (HAD) superfamily protein', 235, NULL, NULL, 27741),
(27742, '3.30.200.20-FF-002443', NULL, 'Uncharacterized protein', 66, NULL, NULL, 27742),
(27743, '3.30.420.40-FF-000633', NULL, 'Endoplasmic reticulum chaperone BiP', 32, NULL, NULL, 27743),
(27744, '3.30.413.10-FF-000040', NULL, 'Sulfite reductase [ferredoxin], chloroplastic', 86, NULL, NULL, 27744),
(27745, '3.40.50.300-FF-006622', NULL, 'Uncharacterized protein', 93, NULL, NULL, 27745),
(27746, '3.10.450.50-FF-000108', NULL, 'Zgc:153681', 85, NULL, NULL, 27746),
(27747, '1.20.1070.10-FF-001308', NULL, 'Uncharacterized protein', 230, NULL, NULL, 27747),
(27748, '1.10.10.10-FF-000262', NULL, 'DNA-directed RNA polymerase III subunit RPC3', 88, NULL, NULL, 27748),
(27749, '3.40.30.10-FF-000875', NULL, 'Calsequestrin', 38, NULL, NULL, 27749),
(27750, '3.50.30.50-FF-000010', NULL, 'Putative cyclase', 214, NULL, NULL, 27750),
(27751, '2.60.200.20-FF-000259', NULL, 'Uncharacterized protein', 82, NULL, NULL, 27751),
(27752, '1.10.1320.10-FF-000021', NULL, 'DNA-directed RNA polymerase', 234, NULL, NULL, 27752),
(27753, '2.60.40.1110-FF-000003', NULL, 'Phosphatidylinositol 3,4,5-trisphosphate 3-phosphatase and dual-specificity protein phosphatase PTEN', 166, NULL, NULL, 27753),
(27754, '2.60.40.60-FF-000381', NULL, 'Protocadherin 15', 107, NULL, NULL, 27754),
(27755, '3.30.750.24-FF-000061', NULL, 'Sigma factor regulatory protein', 97, NULL, NULL, 27755),
(27756, '3.30.70.870-FF-000043', NULL, 'Ribosome-releasing factor 2, mitochondrial', 75, NULL, NULL, 27756),
(27757, '3.30.1490.100-FF-000039', NULL, 'DNA polymerase IV', 101, NULL, NULL, 27757),
(27758, '2.60.120.260-FF-000315', NULL, 'Beta-galactosidase', 201, NULL, NULL, 27758),
(27759, '4.10.49.10-FF-000001', NULL, 'Cytochrome c oxidase subunit 7C', 46, NULL, NULL, 27759),
(27760, '1.10.238.200-FF-000019', NULL, 'Defective in cullin neddylation protein', 100, NULL, NULL, 27760),
(27761, '2.60.220.50-FF-000016', NULL, 'Adhesion G protein-coupled receptor B1', 183, NULL, NULL, 27761),
(27762, '3.40.30.10-FF-000673', NULL, 'Adaptive-response sensory-kinase SasA', 89, NULL, NULL, 27762),
(27763, '3.30.70.330-FF-002455', NULL, NULL, 85, NULL, NULL, 27763),
(27764, '3.90.70.10-FF-000448', NULL, 'Cysteine peptidase, Clan CA, family C2, putative', 131, NULL, NULL, 27764),
(27765, '1.10.238.10-FF-000448', NULL, 'Serine/threonine-protein phosphatase with EF-hands', 122, NULL, NULL, 27765),
(27766, '3.30.565.10-FF-000443', NULL, 'Histidine kinase dimerisation and phosphoacceptor region', 138, NULL, NULL, 27766),
(27767, '1.20.120.1900-FF-000055', NULL, 'Spindle pole body component', 287, NULL, NULL, 27767),
(27768, '3.30.70.1840-FF-000003', NULL, 'Spike glycoprotein', 154, NULL, NULL, 27768),
(27769, '2.30.30.40-FF-000229', NULL, 'Tyrosine-protein kinase', 70, NULL, NULL, 27769),
(27770, '3.90.1140.10-FF-000009', NULL, 'RNA 2'',3''-cyclic phosphodiesterase', 185, NULL, NULL, 27770),
(27771, '3.30.200.20-FF-000083', NULL, 'Putative receptor-like protein kinase', 94, NULL, NULL, 27771),
(27772, '3.40.50.300-FF-000877', NULL, 'RNA helicase', 224, NULL, NULL, 27772),
(27773, '1.10.1670.10-FF-000007', NULL, 'DNA-3-methyladenine glycosylase 2', 52, NULL, NULL, 27773),
(27774, '3.40.50.300-FF-002570', NULL, 'ATP-dependent helicase/nuclease subunit A', 192, NULL, NULL, 27774),
(27775, '2.60.40.10-FF-002732', NULL, 'Chitinase', 92, NULL, NULL, 27775),
(27776, '3.30.70.890-FF-000049', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 132, NULL, NULL, 27776),
(27777, '3.30.1370.10-FF-000220', NULL, 'LD29992p', 54, NULL, NULL, 27777),
(27778, '3.10.450.580-FF-000007', NULL, 'Mediator of RNA polymerase II transcription subunit 6', 132, NULL, NULL, 27778),
(27779, '3.90.1030.20-FF-000010', NULL, NULL, 143, NULL, NULL, 27779),
(27780, '1.10.510.10-FF-000952', NULL, 'cyclin-dependent kinase 20 isoform X4', 93, NULL, NULL, 27780);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(27781, '3.80.10.10-FF-001608', NULL, 'Leucine-rich repeat receptor-like serine/threonine/tyrosine-protein kinase SOBIR1', 82, NULL, NULL, 27781),
(27782, '2.60.200.10-FF-000054', NULL, 'Uncharacterized protein', 91, NULL, NULL, 27782),
(27783, '3.90.70.10-FF-000813', NULL, 'Uncharacterized protein', 308, NULL, NULL, 27783),
(27784, '1.10.620.20-FF-000019', NULL, 'Putative acyl-[acyl-carrier-protein] desaturase DesA2', 275, NULL, NULL, 27784),
(27785, '3.30.559.30-FF-000069', NULL, 'N-(5-amino-5-carboxypentanoyl)-L-cysteinyl-D-valine synthase', 241, NULL, NULL, 27785),
(27786, '3.30.40.10-FF-002023', NULL, 'CCR4-NOT transcription complex, subunit 4a', 31, NULL, NULL, 27786),
(27787, '3.40.50.300-FF-002659', NULL, 'Rad5p', 192, NULL, NULL, 27787),
(27788, '3.30.2160.10-FF-000047', NULL, 'E3 ubiquitin-protein ligase HERC2', 78, NULL, NULL, 27788),
(27789, '3.30.70.330-FF-002146', NULL, NULL, 91, NULL, NULL, 27789),
(27790, '3.30.40.10-FF-000241', NULL, 'E3 SUMO-protein ligase SIZ2', 115, NULL, NULL, 27790),
(27791, '1.10.238.10-FF-000139', NULL, 'Peflin isoform 1', 176, NULL, NULL, 27791),
(27792, '2.60.200.20-FF-000057', NULL, 'Forkhead box K2', 96, NULL, NULL, 27792),
(27793, '1.10.510.10-FF-002498', NULL, 'Serine/threonine-protein kinase stk11 homolog', 317, NULL, NULL, 27793),
(27794, '1.10.1740.100-FF-000002', NULL, 'Histone-lysine N-methyltransferase', 101, NULL, NULL, 27794),
(27795, '3.40.50.1000-FF-000671', NULL, NULL, 228, NULL, NULL, 27795),
(27796, '3.40.525.10-FF-000051', NULL, 'Ras GTPase activating protein', 124, NULL, NULL, 27796),
(27797, '2.130.10.10-FF-002148', NULL, 'Uncharacterized protein, isoform B', 71, NULL, NULL, 27797),
(27798, '2.40.70.10-FF-000037', NULL, 'Renin', 159, NULL, NULL, 27798),
(27799, '3.30.1120.30-FF-000022', NULL, 'Serine/threonine-protein kinase PLK', 93, NULL, NULL, 27799),
(27800, '3.30.70.2610-FF-000010', NULL, 'General transcription factor IIH subunit 4', 28, NULL, NULL, 27800),
(27801, '1.20.1260.10-FF-000013', NULL, '2-nonaprenyl-3-methyl-6-methoxy-1,4-benzoquinol hydroxylase', 143, NULL, NULL, 27801),
(27802, '1.20.1070.10-FF-002022', NULL, 'Uncharacterized protein', 127, NULL, NULL, 27802),
(27803, '1.10.400.10-FF-000034', NULL, 'Guanine nucleotide binding protein (G protein), alpha 13b', 16, NULL, NULL, 27803),
(27804, '3.80.10.10-FF-003317', NULL, 'Uncharacterized protein', 163, NULL, NULL, 27804),
(27805, '3.40.50.880-FF-000214', NULL, 'Uncharacterized protein MG029', 180, NULL, NULL, 27805),
(27806, '3.30.60.30-FF-000248', NULL, 'Uncharacterized protein', 44, NULL, NULL, 27806),
(27807, '3.50.50.60-FF-000323', NULL, 'FAD dependent oxidoreductase', 204, NULL, NULL, 27807),
(27808, '1.10.3810.10-FF-000002', NULL, 'Penicillin-binding protein 1B', 184, NULL, NULL, 27808),
(27809, '1.25.40.10-FF-004631', NULL, 'Si:ch73-68b22.2', 107, NULL, NULL, 27809),
(27810, '2.170.270.10-FF-000190', NULL, 'Predicted protein', 189, NULL, NULL, 27810),
(27811, '1.25.40.10-FF-004069', NULL, 'Uncharacterized protein', 93, NULL, NULL, 27811),
(27812, '2.40.70.10-FF-000508', NULL, NULL, 93, NULL, NULL, 27812),
(27813, '3.40.30.10-FF-001061', NULL, 'AER413Cp', 166, NULL, NULL, 27813),
(27814, '2.30.42.10-FF-000028', NULL, 'PDZ domain containing ring finger 4', 90, NULL, NULL, 27814),
(27815, '3.30.160.60-FF-004328', NULL, NULL, 56, NULL, NULL, 27815),
(27816, '3.30.1520.10-FF-000013', NULL, 'Putative Sorting nexin 3', 134, NULL, NULL, 27816),
(27817, '3.40.47.10-FF-000076', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 3', 182, NULL, NULL, 27817),
(27818, '3.30.40.10-FF-001770', NULL, 'Uncharacterized protein', 104, NULL, NULL, 27818),
(27819, '1.10.10.10-FF-000239', NULL, 'heterochromatin protein 1-binding protein 3 isoform X1', 85, NULL, NULL, 27819),
(27820, '2.40.50.140-FF-000119', NULL, 'Protection of telomeres 1 homolog', 143, NULL, NULL, 27820),
(27821, '3.30.565.10-FF-000134', NULL, 'Two-component sensor histidine kinase', 169, NULL, NULL, 27821),
(27822, '2.130.10.10-FF-001063', NULL, 'VPS15 protein kinase', 277, NULL, NULL, 27822),
(27823, '2.60.40.10-FF-000478', NULL, 'Protein tyrosine phosphatase, receptor type Q', 94, NULL, NULL, 27823);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(27824, '3.40.50.720-FF-002122', NULL, 'Uncharacterized protein', 112, NULL, NULL, 27824),
(27825, '1.20.5.190-FF-000075', NULL, 'Neuromodulin', 87, NULL, NULL, 27825),
(27826, '3.30.420.40-FF-000852', NULL, 'Uncharacterized protein', 150, NULL, NULL, 27826),
(27827, '3.30.710.10-FF-000163', NULL, 'BTB/POZ domain-containing protein', 158, NULL, NULL, 27827),
(27828, '3.30.160.60-FF-004660', NULL, NULL, 40, NULL, NULL, 27828),
(27829, '2.60.40.150-FF-000167', NULL, 'Multiple C2 domains, transmembrane 2a', 125, NULL, NULL, 27829),
(27830, '3.40.630.10-FF-000093', NULL, 'Peptide hydrolase', 249, NULL, NULL, 27830),
(27831, '3.30.1120.10-FF-000067', NULL, 'Predicted protein', 83, NULL, NULL, 27831),
(27832, '1.10.510.10-FF-004443', NULL, NULL, 47, NULL, NULL, 27832),
(27833, '3.40.630.30-FF-000099', NULL, 'probable acetyltransferase NATA1-like', 199, NULL, NULL, 27833),
(27834, '3.40.630.10-FF-000413', NULL, 'Uncharacterized protein', 306, NULL, NULL, 27834),
(27835, '1.25.40.10-FF-000382', NULL, 'Pentatricopeptide repeat-containing protein', 164, NULL, NULL, 27835),
(27836, '1.25.10.10-FF-002662', NULL, 'Os03g0261950 protein', 100, NULL, NULL, 27836),
(27837, '1.20.1250.20-FF-000100', NULL, 'MFS sugar transporter, putative', 461, NULL, NULL, 27837),
(27838, '3.10.20.90-FF-000068', NULL, 'Ubiquitin carboxyl-terminal hydrolase 32', 82, NULL, NULL, 27838),
(27839, '3.10.490.10-FF-000009', NULL, 'Putative gamma-glutamylcyclotransferase', 157, NULL, NULL, 27839),
(27840, '3.50.50.60-FF-000014', NULL, 'Dihydrolipoyl dehydrogenase', 122, NULL, NULL, 27840),
(27841, '3.30.470.20-FF-000231', NULL, 'Uncharacterized protein', 98, NULL, NULL, 27841),
(27842, '1.25.40.20-FF-000385', NULL, 'Probable 26S proteasome regulatory subunit p28', 228, NULL, NULL, 27842),
(27843, '1.10.510.10-FF-000391', NULL, 'Hormonally up-regulated neu tumor-associated kinase', 355, NULL, NULL, 27843),
(27844, '1.10.1170.10-FF-000003', NULL, 'E3 ubiquitin-protein ligase XIAP', 110, NULL, NULL, 27844),
(27845, '1.10.600.10-FF-000015', NULL, 'Solanesyl diphosphate synthase 3, chloroplastic/mitochondrial', 338, NULL, NULL, 27845),
(27846, '3.10.50.40-FF-000139', NULL, 'Peptidylprolyl isomerase', 89, NULL, NULL, 27846),
(27847, '2.60.40.10-FF-004749', NULL, NULL, 108, NULL, NULL, 27847),
(27848, '2.60.40.420-FF-000034', NULL, 'Cupredoxin superfamily protein', 109, NULL, NULL, 27848),
(27849, '3.40.50.300-FF-006841', NULL, 'DNA replication and repair protein RecF', 339, NULL, NULL, 27849),
(27850, '2.80.10.50-FF-000049', NULL, 'Interleukin-1 alpha', 160, NULL, NULL, 27850),
(27851, '3.10.100.10-FF-000267', NULL, NULL, 145, NULL, NULL, 27851),
(27852, '2.60.40.4060-FF-000011', NULL, 'Uncharacterized protein', 141, NULL, NULL, 27852),
(27853, '1.10.10.10-FF-000790', NULL, 'Eukaryotic translation initiation factor 3 subunit K', 83, NULL, NULL, 27853),
(27854, '2.40.50.1060-FF-000009', NULL, 'DNA-directed RNA polymerase I subunit', 169, NULL, NULL, 27854),
(27855, '3.40.50.300-FF-004913', NULL, 'Uncharacterized protein', 222, NULL, NULL, 27855),
(27856, '1.20.58.390-FF-000146', NULL, 'Uncharacterized protein', 146, NULL, NULL, 27856),
(27857, '3.30.530.20-FF-000068', NULL, 'Pleckstrin homology (PH) and lipid-binding START domains-containing protein', 198, NULL, NULL, 27857),
(27858, '1.25.10.10-FF-002914', NULL, 'Uncharacterized protein', 116, NULL, NULL, 27858),
(27859, '1.20.1070.10-FF-000330', NULL, 'Alpha 2B adrenergic receptor', 74, NULL, NULL, 27859),
(27860, '3.40.50.720-FF-002431', NULL, 'Predicted protein', 240, NULL, NULL, 27860),
(27861, '1.10.3470.10-FF-000032', NULL, 'ABC transporter ATP-binding protein', 244, NULL, NULL, 27861),
(27862, '1.10.560.10-FF-000085', NULL, 'T-complex protein 1 subunit gamma', 187, NULL, NULL, 27862),
(27863, '3.10.20.90-FF-000719', NULL, 'Predicted protein', 83, NULL, NULL, 27863),
(27864, '1.20.5.1940-FF-000002', NULL, 'Signal transducing adapter molecule 1', 77, NULL, NULL, 27864),
(27865, '1.25.70.10-FF-000097', NULL, NULL, 70, NULL, NULL, 27865),
(27866, '1.25.40.10-FF-002377', NULL, 'TPR domain protein', 80, NULL, NULL, 27866);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(27867, '3.40.50.1980-FF-000060', NULL, 'Iron complex transport system substrate-binding protein', 100, NULL, NULL, 27867),
(27868, '3.30.160.60-FF-002636', NULL, 'Zinc finger protein 480', 23, NULL, NULL, 27868),
(27869, '3.80.10.10-FF-002699', NULL, 'Leucine-rich repeat protein kinase family protein', 66, NULL, NULL, 27869),
(27870, '1.10.10.410-FF-000006', NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit B, mitochondrial', 60, NULL, NULL, 27870),
(27871, '3.10.10.10-FF-000021', NULL, 'Pol93p', 110, NULL, NULL, 27871),
(27872, '3.40.50.970-FF-000145', NULL, 'Uncharacterized protein', 106, NULL, NULL, 27872),
(27873, '1.20.1250.20-FF-001483', NULL, 'Uncharacterized protein', 500, NULL, NULL, 27873),
(27874, '3.30.565.10-FF-000353', NULL, 'Two-component sensor histidine kinase', 156, NULL, NULL, 27874),
(27875, '2.60.40.1510-FF-000038', NULL, 'Integrin beta', 46, NULL, NULL, 27875),
(27876, '1.25.10.10-FF-002353', NULL, 'Uncharacterized protein', 285, NULL, NULL, 27876),
(27877, '1.25.40.470-FF-000003', NULL, 'intraflagellar transport protein 122 homolog', 157, NULL, NULL, 27877),
(27878, '2.10.25.10-FF-001726', NULL, 'Integrin beta', 58, NULL, NULL, 27878),
(27879, '3.10.20.90-FF-000377', NULL, 'FERM domain (Protein4.1-ezrin-radixin-moesin) family', 83, NULL, NULL, 27879),
(27880, '1.25.40.480-FF-000006', NULL, 'Bystin, putative', 180, NULL, NULL, 27880),
(27881, '3.30.56.10-FF-000002', NULL, 'Phenylalanine--tRNA ligase beta subunit', 74, NULL, NULL, 27881),
(27882, '2.130.10.10-FF-003929', NULL, 'Uncharacterized protein', 259, NULL, NULL, 27882),
(27883, '3.40.50.720-FF-000413', NULL, 'Trans-acting enoyl reductase', 164, NULL, NULL, 27883),
(27884, '1.10.238.10-FF-001162', NULL, 'Uncharacterized protein', 105, NULL, NULL, 27884),
(27885, '2.60.40.60-FF-000577', NULL, 'Cadherin 4', 46, NULL, NULL, 27885),
(27886, '1.20.1250.20-FF-001825', NULL, 'Slc2A8 protein, putative', 151, NULL, NULL, 27886),
(27887, '2.130.10.10-FF-004391', NULL, 'Uncharacterized protein', 64, NULL, NULL, 27887),
(27888, '4.10.520.10-FF-000031', NULL, NULL, 91, NULL, NULL, 27888),
(27889, '1.10.287.70-FF-000051', NULL, 'Sodium channel 1', 148, NULL, NULL, 27889),
(27890, '1.10.1300.10-FF-000019', NULL, 'Phosphodiesterase', 332, NULL, NULL, 27890),
(27891, '3.40.50.720-FF-000071', NULL, '2-hydroxy-3-oxopropionate reductase', 165, NULL, NULL, 27891),
(27892, '3.40.190.10-FF-000373', NULL, 'Membrane-bound lytic murein transglycosylase F', 108, NULL, NULL, 27892),
(27893, '3.30.830.10-FF-000228', NULL, 'Insulin-degrading enzyme-like 1 peroxisomal', 135, NULL, NULL, 27893),
(27894, '3.30.230.70-FF-000037', NULL, 'Polyribonucleotide nucleotidyltransferase', 316, NULL, NULL, 27894),
(27895, '2.160.10.10-FF-000084', NULL, 'Nucleotide-diphospho-sugar transferase', 120, NULL, NULL, 27895),
(27896, '1.10.10.60-FF-001052', NULL, NULL, 58, NULL, NULL, 27896),
(27897, '3.30.470.30-FF-000015', NULL, 'Mrna capping enzyme', 228, NULL, NULL, 27897),
(27898, '3.90.1310.10-FF-000045', NULL, 'Penicillin-binding protein', 20, NULL, NULL, 27898),
(27899, '2.120.10.30-FF-000226', NULL, 'Uncharacterized protein', 233, NULL, NULL, 27899),
(27900, '2.70.98.20-FF-000035', NULL, 'Amine oxidase', 106, NULL, NULL, 27900),
(27901, '3.40.50.300-FF-002878', NULL, 'RAs-related GTP-binding protein A', 190, NULL, NULL, 27901),
(27902, '3.40.50.300-FF-006931', NULL, 'Uncharacterized protein', 230, NULL, NULL, 27902),
(27903, '2.130.10.10-FF-000804', NULL, 'WD repeat and SOCS box-containing 1, isoform CRA_b', 132, NULL, NULL, 27903),
(27904, '3.30.160.60-FF-000585', NULL, 'zinc finger protein 784', 28, NULL, NULL, 27904),
(27905, '1.20.1560.10-FF-000053', NULL, 'Multidrug ABC transporter ATP-binding protein', 315, NULL, NULL, 27905),
(27906, '3.40.50.300-FF-004587', NULL, 'Dynein heavy chain, cytoplasmic', 172, NULL, NULL, 27906),
(27907, '1.10.3210.10-FF-000069', NULL, 'Blr1456 protein', 174, NULL, NULL, 27907),
(27908, '3.30.200.20-FF-000335', NULL, 'Serine/threonine-protein kinase MHK', 83, NULL, NULL, 27908),
(27909, '2.40.160.120-FF-000062', NULL, 'Oxysterol-binding protein', 163, NULL, NULL, 27909);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(27910, '3.40.50.1820-FF-001546', NULL, 'Ndrg family member 3b', 128, NULL, NULL, 27910),
(27911, '3.30.40.10-FF-000022', NULL, 'E3 ubiquitin-protein ligase RING1-like', 86, NULL, NULL, 27911),
(27912, '2.130.10.10-FF-004188', NULL, 'Secreted chemorepellent semaphorin 3F', 160, NULL, NULL, 27912),
(27913, '2.60.120.200-FF-000073', NULL, 'Galectin', 150, NULL, NULL, 27913),
(27914, '3.10.20.90-FF-000848', NULL, 'Predicted protein', 83, NULL, NULL, 27914),
(27915, '2.130.10.10-FF-002479', NULL, 'Intraflagellar transport protein 140 homolog', 174, NULL, NULL, 27915),
(27916, '3.90.70.10-FF-000667', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 302, NULL, NULL, 27916),
(27917, '3.10.110.10-FF-000094', NULL, 'Probable ubiquitin-conjugating enzyme E2 23', 262, NULL, NULL, 27917),
(27918, '3.90.1150.10-FF-000190', NULL, 'Putative serine--glyoxylate aminotransferase', 105, NULL, NULL, 27918),
(27919, '3.30.450.40-FF-000152', NULL, 'IclR family transcriptional regulator', 168, NULL, NULL, 27919),
(27920, '2.60.40.1460-FF-000001', NULL, 'Integrin, alpha V', 159, NULL, NULL, 27920),
(27921, '2.30.30.100-FF-000151', NULL, 'U6 snRNA-associated Sm-like protein LSm7', 63, NULL, NULL, 27921),
(27922, '3.30.40.10-FF-001966', NULL, 'E3 ubiquitin-protein ligase ORTHRUS 2', 105, NULL, NULL, 27922),
(27923, '3.30.160.60-FF-006436', NULL, NULL, 87, NULL, NULL, 27923),
(27924, '3.30.160.60-FF-002726', NULL, 'Unplaced genomic scaffold supercont1.21, whole genome shotgun sequence', 77, NULL, NULL, 27924),
(27925, '1.25.10.10-FF-000644', NULL, 'Patatin', 186, NULL, NULL, 27925),
(27926, '1.10.150.380-FF-000004', NULL, 'Aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase subunit B', 59, NULL, NULL, 27926),
(27927, '1.10.405.10-FF-000039', NULL, 'AGAP012773-PA', 57, NULL, NULL, 27927),
(27928, '2.60.40.1910-FF-000035', NULL, NULL, 97, NULL, NULL, 27928),
(27929, '3.90.226.10-FF-000327', NULL, 'Uncharacterized protein', 161, NULL, NULL, 27929),
(27930, '2.70.170.10-FF-000133', NULL, 'Predicted protein', 167, NULL, NULL, 27930),
(27931, '3.40.50.2300-FF-000173', NULL, 'Two-component transcriptional regulator, winged helix family', 86, NULL, NULL, 27931),
(27932, '2.160.20.10-FF-000034', NULL, 'PKHD1, fibrocystin/polyductin', 275, NULL, NULL, 27932),
(27933, '3.40.50.300-FF-004677', NULL, 'Nucleic acid helicase, putative', 177, NULL, NULL, 27933),
(27934, '3.40.50.300-FF-000861', NULL, 'Fanconi anemia, complementation group M', 196, NULL, NULL, 27934),
(27935, '3.40.50.720-FF-002212', NULL, 'Uncharacterized protein', 362, NULL, NULL, 27935),
(27936, '3.40.395.10-FF-000034', NULL, 'Predicted protein', 176, NULL, NULL, 27936),
(27937, '3.30.50.10-FF-000051', NULL, 'Nuclear receptor subfamily 1 group I member 3', 73, NULL, NULL, 27937),
(27938, '1.25.10.10-FF-000554', NULL, 'Exportin-7', 222, NULL, NULL, 27938),
(27939, '1.10.150.370-FF-000001', NULL, 'Protein her-1', 93, NULL, NULL, 27939),
(27940, '2.60.420.10-FF-000020', NULL, 'Predicted protein', 53, NULL, NULL, 27940),
(27941, '1.10.1870.10-FF-000011', NULL, 'Saccharopine dehydrogenase', 100, NULL, NULL, 27941),
(27942, '3.30.200.20-FF-002134', NULL, 'Uncharacterized protein', 71, NULL, NULL, 27942),
(27943, '2.70.98.10-FF-000122', NULL, 'Uncharacterized protein', 102, NULL, NULL, 27943),
(27944, '1.20.920.30-FF-000032', NULL, 'Dynein heavy chain, cytosolic, putative', 189, NULL, NULL, 27944),
(27945, '3.30.420.40-FF-000324', NULL, 'Putative actin-like protein', 75, NULL, NULL, 27945),
(27946, '3.50.50.60-FF-000233', NULL, 'Trypanothione reductase', 226, NULL, NULL, 27946),
(27947, '3.40.50.1820-FF-001456', NULL, 'Uncharacterized protein', 182, NULL, NULL, 27947),
(27948, '1.20.1050.10-FF-000222', NULL, 'Glutathione S-transferase', 107, NULL, NULL, 27948),
(27949, '2.20.130.20-FF-000010', NULL, 'Thioester-containing protein 6', 75, NULL, NULL, 27949),
(27950, '3.30.1370.10-FF-000074', NULL, 'Small subunit rRNA processing KH domain protein, putative', 97, NULL, NULL, 27950),
(27951, '2.60.40.150-FF-000532', NULL, 'rab11 family-interacting protein 1 isoform X2', 151, NULL, NULL, 27951); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(27952, '3.40.50.2300-FF-000515', NULL, 'glutamate receptor 1 isoform X3', 21, NULL, NULL, 27952),
(27953, '3.30.470.20-FF-000012', NULL, 'Pyruvate carboxylase', 463, NULL, NULL, 27953),
(27954, '1.10.510.10-FF-004078', NULL, NULL, 174, NULL, NULL, 27954),
(27955, '3.90.226.10-FF-000075', NULL, 'ATP-dependent Clp protease proteolytic subunit', 190, NULL, NULL, 27955),
(27956, '1.25.10.10-FF-000099', NULL, 'Deoxyhypusine hydroxylase', 142, NULL, NULL, 27956),
(27957, '1.20.120.350-FF-000257', NULL, NULL, 153, NULL, NULL, 27957),
(27958, '3.40.225.10-FF-000033', NULL, NULL, 220, NULL, NULL, 27958),
(27959, '3.40.47.10-FF-000166', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase, KASII', 285, NULL, NULL, 27959),
(27960, '3.40.50.150-FF-000703', NULL, 'Anamorsin', 103, NULL, NULL, 27960),
(27961, '2.30.250.10-FF-000007', NULL, 'Clan MH, family M18, aspartyl aminopeptidase-like metallopeptidase', 132, NULL, NULL, 27961),
(27962, '3.30.565.10-FF-000549', NULL, 'Uncharacterized protein', 118, NULL, NULL, 27962),
(27963, '3.40.50.150-FF-000557', NULL, 'Polyamine aminopropyltransferase', 250, NULL, NULL, 27963),
(27964, '3.30.160.60-FF-000927', NULL, 'Zinc finger and BTB domain-containing protein 49', 28, NULL, NULL, 27964),
(27965, '1.25.10.10-FF-002443', NULL, 'Predicted protein', 234, NULL, NULL, 27965),
(27966, '2.130.10.10-FF-004733', NULL, 'UBP9-binding protein bun107', 164, NULL, NULL, 27966),
(27967, '1.10.150.390-FF-000007', NULL, 'DNA-directed RNA polymerase subunit', 46, NULL, NULL, 27967),
(27968, '3.90.550.10-FF-000255', NULL, 'PROBABLE GLYCOSYLTRANSFERASE', 216, NULL, NULL, 27968),
(27969, '3.100.10.10-FF-000043', NULL, NULL, 81, NULL, NULL, 27969),
(27970, '1.20.1250.20-FF-001735', NULL, 'Uncharacterized protein', 301, NULL, NULL, 27970),
(27971, '1.20.1000.10-FF-000034', NULL, NULL, 277, NULL, NULL, 27971),
(27972, '2.160.20.70-FF-000046', NULL, 'Adenylyl cyclase-associated protein', 94, NULL, NULL, 27972),
(27973, '3.30.200.20-FF-001948', NULL, 'Uncharacterized protein', 107, NULL, NULL, 27973),
(27974, '1.20.144.10-FF-000076', NULL, 'Uncharacterized protein', 273, NULL, NULL, 27974),
(27975, '2.60.120.310-FF-000027', NULL, 'Uncharacterized protein', 115, NULL, NULL, 27975),
(27976, '1.25.40.10-FF-000269', NULL, 'Crooked neck pre-mRNA-splicing factor 1', 153, NULL, NULL, 27976),
(27977, '1.25.40.10-FF-002832', NULL, 'Tetratricopeptide repeat protein 17', 139, NULL, NULL, 27977),
(27978, '2.130.10.10-FF-004643', NULL, 'F-box and WD domain protein, putative', 192, NULL, NULL, 27978),
(27979, '3.30.160.60-FF-006127', NULL, NULL, 34, NULL, NULL, 27979),
(27980, '2.40.10.10-FF-000623', NULL, NULL, 246, NULL, NULL, 27980),
(27981, '3.30.830.10-FF-000138', NULL, 'Core subunit of the ubiquinol-cytochrome-c reductase complex, mitochondrial, putative', 192, NULL, NULL, 27981),
(27982, '2.30.29.30-FF-000032', NULL, 'Non-specific serine/threonine protein kinase', 119, NULL, NULL, 27982),
(27983, '3.40.50.300-FF-000529', NULL, 'helicase SRCAP isoform X1', 258, NULL, NULL, 27983),
(27984, '3.30.160.60-FF-001332', NULL, 'zinc finger protein 197 isoform X1', 27, NULL, NULL, 27984),
(27985, '1.10.10.60-FF-000580', NULL, 'Reproductive homeobox on X chromosome 11', 69, NULL, NULL, 27985),
(27986, '2.60.40.60-FF-001105', NULL, 'Uncharacterized protein', 100, NULL, NULL, 27986),
(27987, '3.40.50.150-FF-000248', NULL, 'Uncharacterized protein', 151, NULL, NULL, 27987),
(27988, '3.90.190.10-FF-000013', NULL, 'receptor-type tyrosine-protein phosphatase zeta isoform X1', 285, NULL, NULL, 27988),
(27989, '3.10.110.10-FF-000307', NULL, 'Uncharacterized protein', 79, NULL, NULL, 27989),
(27990, '3.50.50.60-FF-000429', NULL, 'FAD-dependent monooxygenase nscC', 389, NULL, NULL, 27990),
(27991, '2.60.40.60-FF-000487', NULL, 'Cadherin 17, LI cadherin (liver-intestine)', 104, NULL, NULL, 27991),
(27992, '1.10.10.60-FF-000338', NULL, 'Homeobox protein Nkx-3.1', 77, NULL, NULL, 27992),
(27993, '1.10.420.10-FF-000052', NULL, 'Uncharacterized protein', 24, NULL, NULL, 27993),
(27994, '3.30.740.10-FF-000002', NULL, 'Dynein light chain', 95, NULL, NULL, 27994); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(27995, '2.120.10.80-FF-000292', NULL, 'Uncharacterized protein', 221, NULL, NULL, 27995),
(27996, '3.40.190.10-FF-000283', NULL, 'Blast:Probable glutamate receptor', 114, NULL, NULL, 27996),
(27997, '3.40.50.300-FF-000771', NULL, 'DNA mismatch repair protein', 251, NULL, NULL, 27997),
(27998, '3.90.190.20-FF-000016', NULL, 'UDP-N-acetylmuramate--L-alanine ligase', 157, NULL, NULL, 27998),
(27999, '1.10.1070.11-FF-000036', NULL, 'Phosphatidylinositol-4,5-bisphosphate 3-kinase catalytic subunit, putative', 173, NULL, NULL, 27999),
(28000, '1.20.120.310-FF-000003', NULL, 'Sulfhydryl oxidase', 124, NULL, NULL, 28000),
(28001, '3.30.160.60-FF-000837', NULL, 'E3 SUMO-protein ligase EGR2 isoform X1', 42, NULL, NULL, 28001),
(28002, '3.30.1640.10-FF-000067', NULL, 'DNA helicase', 73, NULL, NULL, 28002),
(28003, '1.20.120.330-FF-000009', NULL, 'Sacsin molecular chaperone', 141, NULL, NULL, 28003),
(28004, '2.130.10.10-FF-000681', NULL, 'Cleavage and polyadenylation specificity factor (CPSF) A subunit protein', 381, NULL, NULL, 28004),
(28005, '3.40.50.720-FF-001740', NULL, 'Adenosylhomocysteinase', 159, NULL, NULL, 28005),
(28006, '3.90.550.10-FF-000564', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 109, NULL, NULL, 28006),
(28007, '1.25.40.10-FF-002490', NULL, 'Pentatricopeptide repeat-containing protein At3g58590', 100, NULL, NULL, 28007),
(28008, '3.30.160.60-FF-005132', NULL, NULL, 27, NULL, NULL, 28008),
(28009, '3.40.50.10810-FF-000246', NULL, 'Uncharacterized protein', 130, NULL, NULL, 28009),
(28010, '3.40.50.720-FF-000323', NULL, 'Estradiol 17-beta-dehydrogenase 1', 283, NULL, NULL, 28010),
(28011, '1.10.510.10-FF-001205', NULL, 'SR protein kinase, isoform D', 83, NULL, NULL, 28011),
(28012, '1.20.1080.10-FF-000050', NULL, 'Formate transporter 1', 264, NULL, NULL, 28012),
(28013, '1.25.10.10-FF-000189', NULL, 'SCY1-like pseudokinase 2', 276, NULL, NULL, 28013),
(28014, '3.40.50.2300-FF-000425', NULL, 'Metabotropic glutamate receptor 7', 284, NULL, NULL, 28014),
(28015, '2.40.10.10-FF-000281', NULL, 'Uncharacterized protein', 84, NULL, NULL, 28015),
(28016, '2.120.10.80-FF-000073', NULL, 'Kelch domain-containing protein 1', 173, NULL, NULL, 28016),
(28017, '3.40.50.720-FF-001717', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 281, NULL, NULL, 28017),
(28018, '3.50.30.50-FF-000009', NULL, 'Isatin hydrolase', 263, NULL, NULL, 28018),
(28019, '3.30.200.20-FF-000189', NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', 90, NULL, NULL, 28019),
(28020, '1.10.287.1490-FF-000068', NULL, 'Uncharacterized protein', 180, NULL, NULL, 28020),
(28021, '2.10.25.10-FF-000889', NULL, 'Hemolectin', 73, NULL, NULL, 28021),
(28022, '2.10.25.10-FF-001507', NULL, 'Predicted protein', 54, NULL, NULL, 28022),
(28023, '1.25.40.10-FF-000578', NULL, 'Pentatricopeptide repeat-containing protein', 99, NULL, NULL, 28023),
(28024, '1.10.150.20-FF-000062', NULL, 'DNA polymerase IV', 49, NULL, NULL, 28024),
(28025, '2.130.10.10-FF-004952', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit trm82', 97, NULL, NULL, 28025),
(28026, '3.90.70.10-FF-000577', NULL, 'Uncharacterized protein', 344, NULL, NULL, 28026),
(28027, '2.60.210.10-FF-000083', NULL, NULL, 55, NULL, NULL, 28027),
(28028, '2.60.40.10-FF-000624', NULL, 'HEPACAM family member 2 isoform X1', 87, NULL, NULL, 28028),
(28029, '3.40.366.10-FF-000051', NULL, 'Polyketide synthase, putative (JCVI)', 309, NULL, NULL, 28029),
(28030, '1.10.510.10-FF-004297', NULL, NULL, 160, NULL, NULL, 28030),
(28031, '3.20.110.10-FF-000024', NULL, 'Alpha-mannosidase E', 86, NULL, NULL, 28031),
(28032, '3.10.450.10-FF-000035', NULL, 'Cysteine proteinase inhibitor 1', 94, NULL, NULL, 28032),
(28033, '2.10.25.10-FF-001417', NULL, 'uncharacterized protein LOC100177824', 45, NULL, NULL, 28033),
(28034, '3.40.50.720-FF-001408', NULL, 'UDP-galactose-4-epimerase, isoform CRA_b', 156, NULL, NULL, 28034),
(28035, '3.40.140.10-FF-000128', NULL, 'Eukaryotic translation initiation factor 3 subunit F', 176, NULL, NULL, 28035),
(28036, '3.90.1150.10-FF-000280', NULL, 'Class III aminotransferase', 49, NULL, NULL, 28036);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(28037, '2.130.10.10-FF-000591', NULL, 'Echinoderm microtubule-associated protein-like CG42247', 278, NULL, NULL, 28037),
(28038, '3.90.1180.10-FF-000028', NULL, NULL, 149, NULL, NULL, 28038),
(28039, '3.30.60.20-FF-000099', NULL, 'Diacylglycerol kinase', 58, NULL, NULL, 28039),
(28040, '1.20.5.370-FF-000005', NULL, 'Myosin heavy chain, isoform I', 45, NULL, NULL, 28040),
(28041, '2.130.10.10-FF-000349', NULL, 'Dynein axonemal intermediate chain 1', 220, NULL, NULL, 28041),
(28042, '3.80.10.10-FF-002322', NULL, 'Outer arm dynein light chain 1 protein', 140, NULL, NULL, 28042),
(28043, '3.30.540.10-FF-000037', NULL, 'Fructose-1,6-bisphosphatase 1', 199, NULL, NULL, 28043),
(28044, '1.25.40.430-FF-000020', NULL, 'Predicted protein', 177, NULL, NULL, 28044),
(28045, '1.25.40.10-FF-002181', NULL, 'Putative pentatricopeptide repeat-containing protein isoform A', 130, NULL, NULL, 28045),
(28046, '2.70.98.10-FF-000032', NULL, 'Putative alpha-1,2-mannosidase', 276, NULL, NULL, 28046),
(28047, '1.20.1440.120-FF-000003', NULL, 'DNA repair protein RecO', 166, NULL, NULL, 28047),
(28048, '3.30.70.330-FF-000106', NULL, 'Splicing factor 3b, subunit 6', 80, NULL, NULL, 28048),
(28049, '1.20.1440.130-FF-000006', NULL, 'Vitamin K epoxide reductase family, putative', 143, NULL, NULL, 28049),
(28050, '1.10.418.10-FF-000092', NULL, 'Fimbrin, putative', 133, NULL, NULL, 28050),
(28051, '2.60.40.10-FF-000933', NULL, 'Mucosal addressin cell adhesion molecule 1', 118, NULL, NULL, 28051),
(28052, '3.30.200.20-FF-001639', NULL, NULL, 90, NULL, NULL, 28052),
(28053, '2.60.40.60-FF-000268', NULL, 'Cadherin related family member 4', 108, NULL, NULL, 28053),
(28054, '3.40.50.300-FF-000990', NULL, 'ras-related protein Rab-15 isoform X1', 201, NULL, NULL, 28054),
(28055, '1.25.40.10-FF-002523', NULL, 'DENN domain-containing protein 4B', 152, NULL, NULL, 28055),
(28056, '3.40.50.410-FF-000202', NULL, 'ATP-dependent DNA helicase II subunit 1', 233, NULL, NULL, 28056),
(28057, '3.30.40.10-FF-001876', NULL, 'Uncharacterized protein', 76, NULL, NULL, 28057),
(28058, '3.30.160.60-FF-001080', NULL, 'Zinc finger and SCAN domain containing 10', 27, NULL, NULL, 28058),
(28059, '2.60.40.770-FF-000009', NULL, 'LP08842p', 127, NULL, NULL, 28059),
(28060, '3.40.50.2000-FF-000307', NULL, 'Glycosyltransferase', 244, NULL, NULL, 28060),
(28061, '3.30.160.60-FF-005042', NULL, NULL, 27, NULL, NULL, 28061),
(28062, '2.10.25.10-FF-001165', NULL, 'AGAP007850-PA', 47, NULL, NULL, 28062),
(28063, '3.10.180.10-FF-000042', NULL, '27 kDa antigen Cfp30B', 137, NULL, NULL, 28063),
(28064, '1.10.510.10-FF-001115', NULL, 'Serine/threonine kinase like domain containing 1', 192, NULL, NULL, 28064),
(28065, '1.10.10.60-FF-000029', NULL, 'Homeobox protein Hox-D4', 87, NULL, NULL, 28065),
(28066, '3.40.50.300-FF-001024', NULL, 'GTPase Era, mitochondrial isoform 1', 184, NULL, NULL, 28066),
(28067, '3.30.60.290-FF-000002', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 59, NULL, NULL, 28067),
(28068, '1.10.8.100-FF-000011', NULL, 'Ribosomal RNA small subunit methyltransferase A', 82, NULL, NULL, 28068),
(28069, '1.10.287.2250-FF-000015', NULL, 'Uncharacterized protein', 62, NULL, NULL, 28069),
(28070, '3.40.190.290-FF-000090', NULL, 'LysR family transcriptional regulator', 200, NULL, NULL, 28070),
(28071, '1.25.10.10-FF-000863', NULL, 'cilia- and flagella-associated protein 69 isoform X2', 194, NULL, NULL, 28071),
(28072, '3.30.70.330-FF-001977', NULL, NULL, 146, NULL, NULL, 28072),
(28073, '2.130.10.10-FF-002721', NULL, 'WD repeat domain phosphoinositide-interacting protein 4', 307, NULL, NULL, 28073),
(28074, '3.90.1100.10-FF-000029', NULL, 'DNA-directed RNA polymerase subunit beta', 183, NULL, NULL, 28074),
(28075, '2.60.40.10-FF-000489', NULL, 'collagen alpha-1(XII) chain isoform X1', 96, NULL, NULL, 28075),
(28076, '3.90.470.20-FF-000066', NULL, '4''-phosphopantetheinyl transferase PfaE', 49, NULL, NULL, 28076),
(28077, '2.40.30.10-FF-000490', NULL, 'Uncharacterized protein', 32, NULL, NULL, 28077),
(28078, '1.25.40.10-FF-000365', NULL, 'Pentatricopeptide repeat domain-containing protein 3, mitochondrial', 167, NULL, NULL, 28078);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(28079, '3.30.70.2660-FF-000002', NULL, 'BH0337 protein', 222, NULL, NULL, 28079),
(28080, '3.30.559.30-FF-000064', NULL, 'Linear gramicidin synthase subunit B', 267, NULL, NULL, 28080),
(28081, '3.10.490.10-FF-000026', NULL, 'Gamma-glutamylcyclotransferase', 119, NULL, NULL, 28081),
(28082, '2.60.40.10-FF-004772', NULL, NULL, 94, NULL, NULL, 28082),
(28083, '2.130.10.10-FF-005947', NULL, 'Uncharacterized protein', 252, NULL, NULL, 28083),
(28084, '3.30.750.24-FF-000151', NULL, 'Uncharacterized protein', 130, NULL, NULL, 28084),
(28085, '3.90.1640.10-FF-000036', NULL, 'Mutant prune', 124, NULL, NULL, 28085),
(28086, '3.30.1020.10-FF-000003', NULL, 'Peroxiredoxin protein', 64, NULL, NULL, 28086),
(28087, '3.80.10.10-FF-003289', NULL, 'Uncharacterized protein', 100, NULL, NULL, 28087),
(28088, '2.120.10.80-FF-000308', NULL, 'Uncharacterized protein', 181, NULL, NULL, 28088),
(28089, '3.30.479.30-FF-000012', NULL, 'Protein HflK', 134, NULL, NULL, 28089),
(28090, '2.120.10.80-FF-000213', NULL, 'TatD related DNase', 128, NULL, NULL, 28090),
(28091, '3.30.200.20-FF-000217', NULL, 'probable LRR receptor-like serine/threonine-protein kinase At1g53430', 107, NULL, NULL, 28091),
(28092, '1.25.40.20-FF-000368', NULL, 'Palmitoyltransferase', 102, NULL, NULL, 28092),
(28093, '3.40.50.620-FF-000271', NULL, 'Methionine--tRNA ligase', 336, NULL, NULL, 28093),
(28094, '1.10.10.10-FF-000711', NULL, 'ArsR family transcriptional regulator', 85, NULL, NULL, 28094),
(28095, '3.40.50.2300-FF-001488', NULL, NULL, 131, NULL, NULL, 28095),
(28096, '3.40.640.10-FF-000363', NULL, 'Pyridoxal phosphate-dependent aminotransferase', 367, NULL, NULL, 28096),
(28097, '3.80.10.10-FF-003194', NULL, 'Uncharacterized protein', 229, NULL, NULL, 28097),
(28098, '3.30.160.60-FF-002176', NULL, 'zinc finger protein 236 isoform X7', 31, NULL, NULL, 28098),
(28099, '1.25.40.10-FF-002394', NULL, 'Protein CBG11979', 164, NULL, NULL, 28099),
(28100, '2.40.50.140-FF-000221', NULL, 'DNA-directed RNA polymerase III subunit', 117, NULL, NULL, 28100),
(28101, '3.20.20.220-FF-000009', NULL, 'Methylenetetrahydrofolate reductase', 297, NULL, NULL, 28101),
(28102, '3.90.770.10-FF-000007', NULL, 'Uncharacterized protein', 145, NULL, NULL, 28102),
(28103, '1.10.167.10-FF-000047', NULL, 'Regulator of G-protein signaling rgs-5', 135, NULL, NULL, 28103),
(28104, '3.90.1150.10-FF-000066', NULL, 'Putative cystathionine beta-lyase', 136, NULL, NULL, 28104),
(28105, '1.25.40.790-FF-000009', NULL, 'CCR4-NOT transcriptional complex subunit', 295, NULL, NULL, 28105),
(28106, '3.10.20.90-FF-000736', NULL, 'Uncharacterized protein', 45, NULL, NULL, 28106),
(28107, '1.25.40.330-FF-000006', NULL, 'Adenylyl cyclase-associated protein', 183, NULL, NULL, 28107),
(28108, '1.20.890.10-FF-000034', NULL, 'Uncharacterized protein', 43, NULL, NULL, 28108),
(28109, '3.30.40.10-FF-002028', NULL, 'Uncharacterized protein', 101, NULL, NULL, 28109),
(28110, '2.40.240.20-FF-000013', NULL, NULL, 69, NULL, NULL, 28110),
(28111, '1.10.10.60-FF-000670', NULL, 'Helicase putative', 78, NULL, NULL, 28111),
(28112, '3.40.50.300-FF-006280', NULL, 'Replication factor C subunit 4', 65, NULL, NULL, 28112),
(28113, '3.30.2350.10-FF-000090', NULL, 'TruB pseudouridine (psi) synthase family member 1', 101, NULL, NULL, 28113),
(28114, '1.10.286.10-FF-000003', NULL, 'GTP cyclohydrolase 1', 59, NULL, NULL, 28114),
(28115, '3.30.70.120-FF-000037', NULL, NULL, 102, NULL, NULL, 28115),
(28116, '2.40.50.140-FF-000900', NULL, NULL, 107, NULL, NULL, 28116),
(28117, '1.10.510.10-FF-002745', NULL, 'Uncharacterized protein', 211, NULL, NULL, 28117),
(28118, '2.130.10.10-FF-004750', NULL, 'Uncharacterized protein', 159, NULL, NULL, 28118),
(28119, '1.10.3430.10-FF-000035', NULL, 'Ammonium transporter', 446, NULL, NULL, 28119),
(28120, '3.20.20.210-FF-000006', NULL, 'Uroporphyrinogen decarboxylase', 350, NULL, NULL, 28120),
(28121, '3.40.50.880-FF-000118', NULL, 'GMP synthase [glutamine-hydrolyzing] isoform X4', 112, NULL, NULL, 28121),
(28122, '3.40.50.12780-FF-000134', NULL, 'ATP-dependent acyl-CoA ligase', 403, NULL, NULL, 28122);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(28123, '1.25.40.340-FF-000009', NULL, NULL, 94, NULL, NULL, 28123),
(28124, '3.40.50.300-FF-007898', NULL, 'Putative glutamine amidotransferase-like protein MJ0138', 190, NULL, NULL, 28124),
(28125, '3.40.140.10-FF-000218', NULL, 'Uncharacterized protein', 188, NULL, NULL, 28125),
(28126, '1.25.40.10-FF-004743', NULL, 'Pentatricopeptide repeat-containing protein At5g15340, mitochondrial', 74, NULL, NULL, 28126),
(28127, '3.30.830.10-FF-000245', NULL, 'Ubiquinol-cytochrome c reductase core protein 2a', 204, NULL, NULL, 28127),
(28128, '3.40.1090.10-FF-000090', NULL, 'Uncharacterized protein', 85, NULL, NULL, 28128),
(28129, '2.60.120.10-FF-000778', NULL, 'Uncharacterized protein', 161, NULL, NULL, 28129),
(28130, '1.10.287.110-FF-000288', NULL, 'Co-chaperone, HscB-like protein', 111, NULL, NULL, 28130),
(28131, '2.20.25.90-FF-000002', NULL, 'NADH-quinone oxidoreductase', 53, NULL, NULL, 28131),
(28132, '3.90.70.10-FF-000465', NULL, 'Cathepsin B, putative', 68, NULL, NULL, 28132),
(28133, '3.90.79.10-FF-000108', NULL, 'Adenine DNA glycosylase', 110, NULL, NULL, 28133),
(28134, '2.10.110.10-FF-000300', NULL, 'Uncharacterized protein', 81, NULL, NULL, 28134),
(28135, '3.30.70.3490-FF-000015', NULL, 'Oxysterol-binding protein', 68, NULL, NULL, 28135),
(28136, '1.10.510.10-FF-004095', NULL, NULL, 143, NULL, NULL, 28136),
(28137, '2.60.120.310-FF-000016', NULL, 'Dopamine beta hydroxylase', 79, NULL, NULL, 28137),
(28138, '3.30.430.20-FF-000026', NULL, 'Cysteine-rich receptor-like protein kinase 5', 102, NULL, NULL, 28138),
(28139, '1.20.1110.10-FF-000059', NULL, 'Plasma membrane ATPase', 271, NULL, NULL, 28139),
(28140, '1.10.20.10-FF-000088', NULL, 'Histone H3-like centromeric protein CSE4', 148, NULL, NULL, 28140),
(28141, '3.40.1440.60-FF-000002', NULL, 'Primosome assembly protein PriA', 124, NULL, NULL, 28141),
(28142, '2.20.70.10-FF-000083', NULL, 'pre-mRNA-processing factor 40 homolog A isoform X3', 41, NULL, NULL, 28142),
(28143, '1.10.8.720-FF-000074', NULL, 'Uncharacterized protein', 118, NULL, NULL, 28143),
(28144, '3.40.50.300-FF-008415', NULL, 'Midasin AAA ATPase 1', 133, NULL, NULL, 28144),
(28145, '3.40.50.12650-FF-000028', NULL, 'Uncharacterized protein', 39, NULL, NULL, 28145),
(28146, '1.10.1420.10-FF-000107', NULL, 'DNA mismatch repair protein MutS', 140, NULL, NULL, 28146),
(28147, '1.10.472.10-FF-000609', NULL, 'Uncharacterized protein', 140, NULL, NULL, 28147),
(28148, '3.30.160.60-FF-000938', NULL, 'Zinc finger protein 691', 28, NULL, NULL, 28148),
(28149, '1.25.40.10-FF-003220', NULL, 'Protein O-mannosyl-transferase TMTC3', 68, NULL, NULL, 28149),
(28150, '1.25.40.10-FF-000270', NULL, 'Outer membrane protein assembly factor BamD', 182, NULL, NULL, 28150),
(28151, '3.80.10.10-FF-002103', NULL, 'Uncharacterized protein', 401, NULL, NULL, 28151),
(28152, '3.60.15.10-FF-000120', NULL, 'Beta lactamase like protein', 258, NULL, NULL, 28152),
(28153, '3.30.2160.10-FF-000064', NULL, 'Predicted protein', 47, NULL, NULL, 28153),
(28154, '3.40.350.10-FF-000032', NULL, 'Xaa-pro aminopeptidase, putative', 133, NULL, NULL, 28154),
(28155, '3.40.50.2300-FF-000291', NULL, 'Two-component response regulator ORR4', 212, NULL, NULL, 28155),
(28156, '1.20.5.190-FF-000165', NULL, NULL, 49, NULL, NULL, 28156),
(28157, '2.60.120.260-FF-000192', NULL, 'Cell wall-associated protein', 165, NULL, NULL, 28157),
(28158, '3.40.190.10-FF-000513', NULL, 'Transferrin', 182, NULL, NULL, 28158),
(28159, '3.90.1150.10-FF-000403', NULL, 'Sphingosine phosphate lyase, putative', 31, NULL, NULL, 28159),
(28160, '1.10.10.10-FF-000806', NULL, 'Unplaced genomic scaffold supercont1.172, whole genome shotgun sequence', 111, NULL, NULL, 28160),
(28161, '2.130.10.10-FF-002496', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', 145, NULL, NULL, 28161),
(28162, '1.25.40.180-FF-000040', NULL, 'Nuclear cap-binding protein subunit 1', 265, NULL, NULL, 28162),
(28163, '2.40.10.10-FF-000376', NULL, NULL, 99, NULL, NULL, 28163),
(28164, '2.10.109.10-FF-000004', NULL, 'Signal peptidase I', 122, NULL, NULL, 28164);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(28165, '3.40.30.10-FF-000779', NULL, 'Uncharacterized protein', 141, NULL, NULL, 28165),
(28166, '2.60.40.10-FF-004093', NULL, NULL, 94, NULL, NULL, 28166),
(28167, '2.60.40.60-FF-000717', NULL, 'Cadherin-4', 99, NULL, NULL, 28167),
(28168, '1.10.238.10-FF-000684', NULL, 'Phosphoinositide phospholipase C', 96, NULL, NULL, 28168),
(28169, '1.25.40.10-FF-003928', NULL, 'Uncharacterized protein', 290, NULL, NULL, 28169),
(28170, '3.90.1150.170-FF-000006', NULL, 'Glutamate decarboxylase 1b', 89, NULL, NULL, 28170),
(28171, '4.10.320.10-FF-000027', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 41, NULL, NULL, 28171),
(28172, '1.20.1080.10-FF-000044', NULL, 'Formate/nitrite transporter family protein', 261, NULL, NULL, 28172),
(28173, '2.30.29.30-FF-001246', NULL, 'Predicted protein', 111, NULL, NULL, 28173),
(28174, '2.60.260.20-FF-000145', NULL, 'Uncharacterized protein', 93, NULL, NULL, 28174),
(28175, '3.30.1360.70-FF-000035', NULL, NULL, 103, NULL, NULL, 28175),
(28176, '1.10.10.1320-FF-000010', NULL, 'Glr1765 protein', 70, NULL, NULL, 28176),
(28177, '1.20.120.920-FF-000001', NULL, 'CRISPR-associated endonuclease Cas1', 240, NULL, NULL, 28177),
(28178, '2.60.120.260-FF-000203', NULL, 'Beta-galactosidase', 88, NULL, NULL, 28178),
(28179, '3.30.160.60-FF-002855', NULL, 'Zinc finger protein 705A', 23, NULL, NULL, 28179),
(28180, '1.10.290.10-FF-000013', NULL, 'Uncharacterized protein', 95, NULL, NULL, 28180),
(28181, '2.70.70.10-FF-000013', NULL, 'Peptidase family M23', 171, NULL, NULL, 28181),
(28182, '3.80.10.10-FF-004020', NULL, 'Uncharacterized protein', 147, NULL, NULL, 28182),
(28183, '3.50.50.60-FF-000093', NULL, 'Amine oxidase', 145, NULL, NULL, 28183),
(28184, '1.10.10.2740-FF-000003', NULL, 'Transcription elongation factor SPT6', 118, NULL, NULL, 28184),
(28185, '2.20.28.10-FF-000058', NULL, 'DNA helicase', 66, NULL, NULL, 28185),
(28186, '2.10.110.10-FF-000058', NULL, 'Rho GTPase activator Lrg11', 56, NULL, NULL, 28186),
(28187, '2.30.29.30-FF-000144', NULL, 'Ras GTPase-activating protein 2 isoform 3', 146, NULL, NULL, 28187),
(28188, '3.40.640.10-FF-000149', NULL, 'Histidinol-phosphate aminotransferase', 222, NULL, NULL, 28188),
(28189, '3.80.10.10-FF-001844', NULL, 'Leucine Rich Repeat family protein', 158, NULL, NULL, 28189),
(28190, '1.25.40.10-FF-004322', NULL, 'MAU2 chromatid cohesion factor homolog', 172, NULL, NULL, 28190),
(28191, '3.30.160.60-FF-005031', NULL, NULL, 24, NULL, NULL, 28191),
(28192, '3.30.160.60-FF-004637', NULL, NULL, 27, NULL, NULL, 28192),
(28193, '3.30.200.20-FF-000543', NULL, 'Putative leucine-rich repeat receptor-like serine/threonine-protein kinase', 96, NULL, NULL, 28193),
(28194, '1.10.579.10-FF-000015', NULL, 'Predicted protein', 48, NULL, NULL, 28194),
(28195, '3.80.10.10-FF-001939', NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase isoform B', 154, NULL, NULL, 28195),
(28196, '2.60.40.690-FF-000008', NULL, 'Thioester-containing protein 6', 153, NULL, NULL, 28196),
(28197, '3.40.50.2300-FF-000302', NULL, 'Si:ch211-203b20.7', 159, NULL, NULL, 28197),
(28198, '3.30.230.10-FF-000042', NULL, 'Translation elongation factor G', 146, NULL, NULL, 28198),
(28199, '3.30.530.20-FF-000192', NULL, 'Phosphatidylinositol transfer protein cytoplasmic 1b', 59, NULL, NULL, 28199),
(28200, '1.10.510.10-FF-000828', NULL, 'Serine/threonine-protein kinase CBK1', 214, NULL, NULL, 28200),
(28201, '4.10.60.10-FF-000117', NULL, 'CCHC-type zinc finger protein CG3800', 48, NULL, NULL, 28201),
(28202, '3.30.200.20-FF-000431', NULL, 'serine/threonine-protein kinase 32C isoform X3', 70, NULL, NULL, 28202),
(28203, '4.10.60.10-FF-000229', NULL, 'Uncharacterized protein', 29, NULL, NULL, 28203),
(28204, '3.40.190.10-FF-000608', NULL, 'Phosphate-binding protein PstS 1', 139, NULL, NULL, 28204),
(28205, '3.40.50.150-FF-000681', NULL, 'tRNA (guanine-N(7)-)-methyltransferase', 211, NULL, NULL, 28205),
(28206, '3.20.110.10-FF-000035', NULL, 'Lysosomal alpha-mannosidase, putative', 59, NULL, NULL, 28206),
(28207, '2.130.10.10-FF-000793', NULL, 'Chromatin assembly factor 1 subunit, putative', 259, NULL, NULL, 28207);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(28208, '1.10.1040.30-FF-000005', NULL, 'Adenosinetriphosphatase', 112, NULL, NULL, 28208),
(28209, '3.40.30.10-FF-001038', NULL, 'Glutathione peroxidase', 195, NULL, NULL, 28209),
(28210, '3.40.50.1000-FF-000783', NULL, NULL, 66, NULL, NULL, 28210),
(28211, '3.30.60.20-FF-000133', NULL, 'Chromosome 10, whole genome shotgun sequence', 75, NULL, NULL, 28211),
(28212, '2.60.40.60-FF-000690', NULL, 'Cdh-4', 104, NULL, NULL, 28212),
(28213, '3.40.390.10-FF-000253', NULL, NULL, 293, NULL, NULL, 28213),
(28214, '3.30.2020.30-FF-000009', NULL, 'Predicted protein', 92, NULL, NULL, 28214),
(28215, '2.60.40.10-FF-002417', NULL, 'Protein sidekick homolog', 107, NULL, NULL, 28215),
(28216, '2.60.120.740-FF-000010', NULL, 'Uncharacterized protein', 113, NULL, NULL, 28216),
(28217, '1.10.760.10-FF-000072', NULL, 'Diheme cytochrome c SoxE', 76, NULL, NULL, 28217),
(28218, '3.90.226.10-FF-000316', NULL, 'Uncharacterized protein', 74, NULL, NULL, 28218),
(28219, '3.90.1150.160-FF-000003', NULL, 'Glutamate decarboxylase', 105, NULL, NULL, 28219),
(28220, '3.40.50.300-FF-001153', NULL, 'RecBCD enzyme subunit RecC', 205, NULL, NULL, 28220),
(28221, '2.10.25.10-FF-001518', NULL, 'Uncharacterized protein', 58, NULL, NULL, 28221),
(28222, '1.10.287.110-FF-000176', NULL, 'Protein CBR-DNJ-11', 86, NULL, NULL, 28222),
(28223, '3.40.50.300-FF-006375', NULL, 'GPN-loop GTPase', 137, NULL, NULL, 28223),
(28224, '1.20.5.340-FF-000036', NULL, 'Myosin heavy chain', 109, NULL, NULL, 28224),
(28225, '2.60.260.20-FF-000050', NULL, 'Chaperone protein DNAj, putative', 108, NULL, NULL, 28225),
(28226, '1.25.10.10-FF-002566', NULL, 'Uncharacterized protein', 169, NULL, NULL, 28226),
(28227, '3.30.420.40-FF-000970', NULL, 'Uncharacterized protein', 44, NULL, NULL, 28227),
(28228, '3.30.160.60-FF-006228', NULL, NULL, 31, NULL, NULL, 28228),
(28229, '3.30.160.60-FF-004542', NULL, NULL, 26, NULL, NULL, 28229),
(28230, '1.20.1070.10-FF-002112', NULL, 'Uncharacterized protein', 96, NULL, NULL, 28230),
(28231, '1.20.120.620-FF-000001', NULL, 'Two-component sensor histidine kinase KdpD', 106, NULL, NULL, 28231),
(28232, '2.60.40.10-FF-001220', NULL, 'PKHD1 like 1', 82, NULL, NULL, 28232),
(28233, '1.10.150.240-FF-000075', NULL, 'HAD superfamily hydrolase', 66, NULL, NULL, 28233),
(28234, '2.70.98.50-FF-000004', NULL, 'Glycoside hydrolase family 95', 89, NULL, NULL, 28234),
(28235, '3.40.50.720-FF-000312', NULL, '(+)-neomenthol dehydrogenase', 294, NULL, NULL, 28235),
(28236, '3.30.740.10-FF-000007', NULL, 'Dynein light chain', 91, NULL, NULL, 28236),
(28237, '3.30.450.40-FF-000258', NULL, 'Probable transcriptional regulator', 174, NULL, NULL, 28237),
(28238, '3.30.420.40-FF-000077', NULL, 'Glucokinase', 130, NULL, NULL, 28238),
(28239, '3.40.50.150-FF-000467', NULL, 'RNA binding protein', 214, NULL, NULL, 28239),
(28240, '1.20.5.320-FF-000030', NULL, 'Uncharacterized protein', 43, NULL, NULL, 28240),
(28241, '2.30.30.70-FF-000002', NULL, '60S ribosomal protein L21', 99, NULL, NULL, 28241),
(28242, '2.10.25.10-FF-000321', NULL, 'Protein delta homolog 1', 38, NULL, NULL, 28242),
(28243, '3.40.50.1000-FF-000569', NULL, NULL, 43, NULL, NULL, 28243),
(28244, '3.40.50.300-FF-000973', NULL, 'Multidrug resistance-associated protein 4', 259, NULL, NULL, 28244),
(28245, '1.25.40.10-FF-004529', NULL, 'Pentatricopeptide repeat-containing protein At1g61870, mitochondrial', 68, NULL, NULL, 28245),
(28246, '1.25.40.10-FF-002068', NULL, 'AGAP001968-PB', 218, NULL, NULL, 28246),
(28247, '3.40.1110.10-FF-000289', NULL, NULL, 83, NULL, NULL, 28247),
(28248, '1.10.510.10-FF-002419', NULL, NULL, 164, NULL, NULL, 28248),
(28249, '2.70.98.60-FF-000007', NULL, 'Alpha-galactosidase Mel36A', 313, NULL, NULL, 28249),
(28250, '1.25.40.10-FF-000691', NULL, 'Pentatricopeptide repeat-containing protein', 116, NULL, NULL, 28250),
(28251, '3.30.160.60-FF-000826', NULL, 'Zinc finger protein 570', 29, NULL, NULL, 28251),
(28252, '1.10.510.10-FF-001222', NULL, 'Serine/threonine-protein kinase ppk25', 264, NULL, NULL, 28252),
(28253, '2.30.42.10-FF-000130', NULL, 'PDZ and LIM domain 2 (mystique)', 88, NULL, NULL, 28253);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(28254, '2.130.10.10-FF-002384', NULL, 'WD repeat protein 2, putative', 265, NULL, NULL, 28254),
(28255, '3.30.70.330-FF-000454', NULL, 'RNA-binding protein 15B', 73, NULL, NULL, 28255),
(28256, '1.25.40.10-FF-001888', NULL, 'U3 small nucleolar RNA-associated protein 6', 246, NULL, NULL, 28256),
(28257, '3.30.420.40-FF-000756', NULL, 'ARP1 actin related protein 1 homolog B', 94, NULL, NULL, 28257),
(28258, '3.40.366.10-FF-000034', NULL, 'Polyketide synthase module', 153, NULL, NULL, 28258),
(28259, '3.40.50.1000-FF-000362', NULL, 'Acid phosphatase', 252, NULL, NULL, 28259),
(28260, '1.10.10.10-FF-000918', NULL, 'OmpR subfamily', 105, NULL, NULL, 28260),
(28261, '2.60.40.10-FF-001006', NULL, 'Interleukin 20 receptor subunit beta', 104, NULL, NULL, 28261),
(28262, '4.10.60.10-FF-000022', NULL, 'Serine/arginine-rich splicing factor RS2Z32', 43, NULL, NULL, 28262),
(28263, '2.40.10.10-FF-000264', NULL, 'Trypsin precursor', 80, NULL, NULL, 28263),
(28264, '2.130.10.10-FF-001895', NULL, 'Cirhin-like Protein', 193, NULL, NULL, 28264),
(28265, '2.60.40.10-FF-000826', NULL, 'Melanocyte protein PMEL', 80, NULL, NULL, 28265),
(28266, '2.40.50.140-FF-000428', NULL, 'Mitochondrial Ribosomal Protein, Large', 101, NULL, NULL, 28266),
(28267, '3.30.70.330-FF-002236', NULL, NULL, 105, NULL, NULL, 28267),
(28268, '3.30.559.10-FF-000153', NULL, 'Putative peptide synthetase', 164, NULL, NULL, 28268),
(28269, '1.20.58.1970-FF-000005', NULL, 'COG4_transport_protein_-_putative', 167, NULL, NULL, 28269),
(28270, '1.20.1250.20-FF-002213', NULL, 'Predicted protein', 137, NULL, NULL, 28270),
(28271, '3.30.230.10-FF-000137', NULL, 'Ria1p', 186, NULL, NULL, 28271),
(28272, '1.25.40.20-FF-000694', NULL, 'Ankyrin repeat domain 55', 198, NULL, NULL, 28272),
(28273, '2.70.98.40-FF-000001', NULL, 'Family 65 glycosyl hydrolase', 267, NULL, NULL, 28273),
(28274, '3.40.50.300-FF-000759', NULL, 'probable ATP-dependent RNA helicase DDX52', 172, NULL, NULL, 28274),
(28275, '2.130.10.10-FF-004845', NULL, 'Uncharacterized protein', 130, NULL, NULL, 28275),
(28276, '1.20.200.10-FF-000011', NULL, 'Argininosuccinate lyase', 202, NULL, NULL, 28276),
(28277, '1.10.220.10-FF-000048', NULL, 'Annexin D5', 71, NULL, NULL, 28277),
(28278, '3.90.780.10-FF-000047', NULL, 'Predicted protein', 193, NULL, NULL, 28278),
(28279, '3.10.50.10-FF-000012', NULL, 'Chitinase 17', 76, NULL, NULL, 28279),
(28280, '3.40.50.300-FF-006728', NULL, 'Zgc:158828', 71, NULL, NULL, 28280),
(28281, '2.20.70.10-FF-000206', NULL, 'Uncharacterized protein', 40, NULL, NULL, 28281),
(28282, '1.25.40.10-FF-004760', NULL, 'Os10g0477200 protein', 59, NULL, NULL, 28282),
(28283, '2.170.150.10-FF-000023', NULL, 'Uncharacterized protein', 162, NULL, NULL, 28283),
(28284, '1.20.1510.10-FF-000022', NULL, 'Cation transporter, putative', 205, NULL, NULL, 28284),
(28285, '2.170.150.20-FF-000026', NULL, 'Uncharacterized protein', 70, NULL, NULL, 28285),
(28286, '1.10.287.1490-FF-000079', NULL, 'Uncharacterized protein', 168, NULL, NULL, 28286),
(28287, '3.40.50.2000-FF-000105', NULL, 'Alpha-1,4 glucan phosphorylase', 429, NULL, NULL, 28287),
(28288, '2.30.22.10-FF-000016', NULL, 'GrpE protein homolog', 58, NULL, NULL, 28288),
(28289, '3.10.110.10-FF-000105', NULL, 'ubiquitin-conjugating enzyme E2 H isoform X3', 90, NULL, NULL, 28289),
(28290, '2.60.40.10-FF-000377', NULL, 'Protein tyrosine kinase 7 (inactive)', 88, NULL, NULL, 28290),
(28291, '3.30.450.70-FF-000008', NULL, 'Trafficking protein particle complex 2 like', 68, NULL, NULL, 28291),
(28292, '6.20.250.70-FF-000001', NULL, 'DNA-directed RNA polymerase I subunit RPA34', 113, NULL, NULL, 28292),
(28293, '1.25.40.10-FF-000477', NULL, 'gamma-soluble NSF attachment protein', 273, NULL, NULL, 28293),
(28294, '2.60.120.260-FF-000175', NULL, 'Sad1 / UNC family protein', 138, NULL, NULL, 28294),
(28295, '3.80.10.10-FF-001277', NULL, 'Tubulin-specific chaperone, putative (AFU_orthologue AFUA_4G11870)', 97, NULL, NULL, 28295),
(28296, '3.30.160.60-FF-004093', NULL, NULL, 24, NULL, NULL, 28296),
(28297, '3.30.70.3490-FF-000032', NULL, 'Oxysterol-binding protein', 130, NULL, NULL, 28297);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(28298, '3.20.20.360-FF-000006', NULL, 'Uncharacterized protein', 238, NULL, NULL, 28298),
(28299, '3.30.200.20-FF-002229', NULL, 'Uncharacterized protein', 38, NULL, NULL, 28299),
(28300, '3.40.50.300-FF-007004', NULL, 'Uncharacterized protein', 209, NULL, NULL, 28300),
(28301, '3.30.890.10-FF-000007', NULL, 'Methyl-CpG-binding domain protein 1b', 77, NULL, NULL, 28301),
(28302, '2.130.10.10-FF-002058', NULL, 'WD repeat-containing protein 13 isoform X1', 150, NULL, NULL, 28302),
(28303, '3.30.200.20-FF-000329', NULL, 'PAS domain-containing protein tyrosine kinase', 85, NULL, NULL, 28303),
(28304, '1.20.1560.10-FF-000300', NULL, 'Putative MRP-like ABC transporter', 143, NULL, NULL, 28304),
(28305, '1.25.40.10-FF-002282', NULL, 'Methyltransferase small domain', 118, NULL, NULL, 28305),
(28306, '2.60.40.10-FF-005031', NULL, NULL, 104, NULL, NULL, 28306),
(28307, '1.20.140.40-FF-000054', NULL, NULL, 159, NULL, NULL, 28307),
(28308, '2.60.40.10-FF-000731', NULL, 'Lysosomal beta glucosidase', 124, NULL, NULL, 28308),
(28309, '3.30.40.10-FF-001539', NULL, 'Uncharacterized protein', 63, NULL, NULL, 28309),
(28310, '3.90.550.50-FF-000109', NULL, 'Uncharacterized protein', 137, NULL, NULL, 28310),
(28311, '3.30.70.2970-FF-000005', NULL, 'Interleukin-1 receptor-associated kinase 1-binding protein 1', 100, NULL, NULL, 28311),
(28312, '1.10.10.60-FF-000782', NULL, NULL, 75, NULL, NULL, 28312),
(28313, '1.20.1070.10-FF-001853', NULL, 'Uncharacterized protein', 297, NULL, NULL, 28313),
(28314, '3.40.50.720-FF-001509', NULL, 'Uncharacterized protein', 242, NULL, NULL, 28314),
(28315, '2.130.10.10-FF-003210', NULL, 'BnaCnng65990D protein', 61, NULL, NULL, 28315),
(28316, '3.40.640.10-FF-000251', NULL, 'Soluble hydrogenase, small subunit', 242, NULL, NULL, 28316),
(28317, '3.40.50.880-FF-000006', NULL, 'Carbamoyl-phosphate synthase 1, mitochondrial', 207, NULL, NULL, 28317),
(28318, '1.25.40.180-FF-000023', NULL, 'regulator of nonsense transcripts 2 isoform X1', 248, NULL, NULL, 28318),
(28319, '1.25.10.10-FF-002780', NULL, 'STE family protein kinase', 217, NULL, NULL, 28319),
(28320, '3.40.50.720-FF-001268', NULL, '2-hydroxy-3-oxopropionate reductase', 174, NULL, NULL, 28320),
(28321, '2.60.200.20-FF-000153', NULL, 'Uncharacterized protein', 101, NULL, NULL, 28321),
(28322, '2.60.260.20-FF-000162', NULL, 'DnaJ protein homolog xdj1', 71, NULL, NULL, 28322),
(28323, '1.10.150.20-FF-000270', NULL, 'Predicted protein', 47, NULL, NULL, 28323),
(28324, '1.10.510.10-FF-002633', NULL, 'Protein kinase, putative', 384, NULL, NULL, 28324),
(28325, '1.10.238.10-FF-000807', NULL, 'AaceriAER419Wp', 170, NULL, NULL, 28325),
(28326, '1.10.287.1260-FF-000010', NULL, 'Mechanosensitive ion channel domain-containing protein', 105, NULL, NULL, 28326),
(28327, '1.25.40.10-FF-002731', NULL, 'Gamma SNAP', 276, NULL, NULL, 28327),
(28328, '2.40.50.120-FF-000001', NULL, 'Netrin 1', 135, NULL, NULL, 28328),
(28329, '3.40.50.300-FF-004363', NULL, 'Bacitracin ABC transporter ATP-binding protein', 227, NULL, NULL, 28329),
(28330, '3.30.70.20-FF-000061', NULL, 'CoB--CoM heterodisulfide reductase subunit A', 74, NULL, NULL, 28330),
(28331, '2.40.50.140-FF-000007', NULL, '40S ribosomal protein S23', 119, NULL, NULL, 28331),
(28332, '2.60.40.150-FF-000279', NULL, 'Protein kinase C', 121, NULL, NULL, 28332),
(28333, '1.20.1070.10-FF-000100', NULL, 'alpha-2B adrenergic receptor', 122, NULL, NULL, 28333),
(28334, '2.60.40.60-FF-000476', NULL, 'cadherin-89D', 105, NULL, NULL, 28334),
(28335, '3.90.640.10-FF-000121', NULL, 'Actin-like ATPase domain-containing protein', 63, NULL, NULL, 28335),
(28336, '2.60.40.10-FF-004755', NULL, NULL, 100, NULL, NULL, 28336),
(28337, '2.170.260.40-FF-000006', NULL, '5''-3'' exoribonuclease A', 170, NULL, NULL, 28337),
(28338, '2.40.70.10-FF-000273', NULL, 'GD19154', 152, NULL, NULL, 28338),
(28339, '3.30.1360.10-FF-000045', NULL, 'RNA polymerase I, and III, AC40 subunit', 154, NULL, NULL, 28339),
(28340, '1.25.40.10-FF-000718', NULL, 'Pentatricopeptide repeat-containing protein', 118, NULL, NULL, 28340),
(28341, '3.40.190.290-FF-000095', NULL, 'Transcriptional regulatory protein', 196, NULL, NULL, 28341);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(28342, '3.10.20.30-FF-000067', NULL, 'Terephthalate 1,2-dioxygenase, reductase component 2', 93, NULL, NULL, 28342),
(28343, '1.20.1250.20-FF-002090', NULL, 'RE57622p', 263, NULL, NULL, 28343),
(28344, '1.10.472.10-FF-000161', NULL, 'CTD kinase beta subunit', 140, NULL, NULL, 28344),
(28345, '2.40.330.10-FF-000017', NULL, NULL, 118, NULL, NULL, 28345),
(28346, '2.70.150.10-FF-000126', NULL, 'ATPase phospholipid transporting 8A1', 63, NULL, NULL, 28346),
(28347, '1.10.8.500-FF-000007', NULL, 'PAS domain-containing sensor histidine kinase', 52, NULL, NULL, 28347),
(28348, '1.10.533.10-FF-000174', NULL, 'Caspase 9', 52, NULL, NULL, 28348),
(28349, '3.10.100.10-FF-000357', NULL, NULL, 71, NULL, NULL, 28349),
(28350, '2.60.40.4310-FF-000002', NULL, 'Togavirin', 56, NULL, NULL, 28350),
(28351, '3.90.1600.10-FF-000039', NULL, 'DNA polymerase', 207, NULL, NULL, 28351),
(28352, '1.10.510.10-FF-001110', NULL, 'AGC family protein kinase', 186, NULL, NULL, 28352),
(28353, '2.40.30.10-FF-000276', NULL, 'HSP70 subfamily B suppressor 1', 107, NULL, NULL, 28353),
(28354, '3.30.720.10-FF-000012', NULL, 'Unplaced genomic scaffold supercont2.12, whole genome shotgun sequence', 130, NULL, NULL, 28354),
(28355, '2.130.10.10-FF-001310', NULL, 'kinesin-like protein KIF21A isoform X2', 105, NULL, NULL, 28355),
(28356, '3.40.50.1100-FF-000274', NULL, 'Uncharacterized protein', 141, NULL, NULL, 28356),
(28357, '2.60.40.10-FF-002855', NULL, 'Glycoprotein E', 177, NULL, NULL, 28357),
(28358, '3.50.50.60-FF-000660', NULL, 'Uncharacterized protein', 94, NULL, NULL, 28358),
(28359, '3.10.129.10-FF-000114', NULL, 'Acyl-CoA thioester hydrolase', 132, NULL, NULL, 28359),
(28360, '3.90.550.10-FF-000682', NULL, 'Galactosylgalactosylxylosylprotein 3-beta-glucuronosyltransferase', 81, NULL, NULL, 28360),
(28361, '1.10.246.10-FF-000006', NULL, 'Extracellular matrix protein 1', 90, NULL, NULL, 28361),
(28362, '2.10.25.10-FF-001277', NULL, 'Notch 3', 40, NULL, NULL, 28362),
(28363, '1.10.510.10-FF-000379', NULL, 'serine/threonine-protein kinase greatwall isoform X1', 97, NULL, NULL, 28363),
(28364, '1.20.1310.10-FF-000136', NULL, NULL, 115, NULL, NULL, 28364),
(28365, '3.40.50.1440-FF-000128', NULL, 'Uncharacterized protein', 182, NULL, NULL, 28365),
(28366, '3.30.70.330-FF-001539', NULL, 'RNA binding protein, putative', 189, NULL, NULL, 28366),
(28367, '3.40.850.10-FF-000300', NULL, 'Kinesin-like protein', 422, NULL, NULL, 28367),
(28368, '3.30.70.60-FF-000044', NULL, 'Os12g0563200 protein', 79, NULL, NULL, 28368),
(28369, '3.40.50.300-FF-000647', NULL, 'Methylmalonic aciduria type A homolog, mitochondrial', 215, NULL, NULL, 28369),
(28370, '3.40.630.10-FF-000323', NULL, 'AGAP008372-PA', 84, NULL, NULL, 28370),
(28371, '1.10.510.10-FF-002392', NULL, 'Protein kinase, putative', 311, NULL, NULL, 28371),
(28372, '1.10.3430.10-FF-000052', NULL, 'Uncharacterized protein', 271, NULL, NULL, 28372),
(28373, '1.20.58.70-FF-000035', NULL, 'Syntaxin-like protein', 212, NULL, NULL, 28373),
(28374, '2.60.40.820-FF-000053', NULL, 'Uncharacterized protein', 136, NULL, NULL, 28374),
(28375, '1.10.150.80-FF-000052', NULL, 'Uncharacterized protein', 83, NULL, NULL, 28375),
(28376, '3.40.47.10-FF-000059', NULL, 'Beta-ketoacyl-acyl-carrier-protein synthase II', 439, NULL, NULL, 28376),
(28377, '2.60.40.150-FF-000296', NULL, 'Non-specific serine/threonine protein kinase', 171, NULL, NULL, 28377),
(28378, '3.30.70.580-FF-000057', NULL, 'tRNA pseudouridine synthase', 85, NULL, NULL, 28378),
(28379, '3.40.50.2000-FF-000077', NULL, 'Sucrose-phosphate synthase 2', 277, NULL, NULL, 28379),
(28380, '1.10.400.10-FF-000051', NULL, 'ADP ribosylation factor', 125, NULL, NULL, 28380),
(28381, '1.10.10.60-FF-000456', NULL, 'ISVch4 transposase, OrfA', 83, NULL, NULL, 28381),
(28382, '2.60.120.10-FF-000795', NULL, 'Uncharacterized protein', 139, NULL, NULL, 28382),
(28383, '2.40.10.170-FF-000008', NULL, 'Transcriptional regulator, CarD', 65, NULL, NULL, 28383),
(28384, '2.30.30.40-FF-000459', NULL, 'SH3 and SYLF domain containing 1', 71, NULL, NULL, 28384),
(28385, '1.10.510.10-FF-004218', NULL, NULL, 210, NULL, NULL, 28385);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(28386, '3.60.40.10-FF-000200', NULL, 'Predicted protein', 336, NULL, NULL, 28386),
(28387, '2.40.50.90-FF-000014', NULL, 'tudor domain-containing protein 7 isoform X1', 96, NULL, NULL, 28387),
(28388, '3.10.20.90-FF-000169', NULL, 'Sequestosome 1', 102, NULL, NULL, 28388),
(28389, '3.80.10.10-FF-003738', NULL, 'AGAP000340-PA', 131, NULL, NULL, 28389),
(28390, '1.10.8.1290-FF-000001', NULL, 'Glutamine--tRNA ligase', 113, NULL, NULL, 28390),
(28391, '3.30.160.60-FF-002625', NULL, 'zinc finger protein 75A-like isoform X1', 26, NULL, NULL, 28391),
(28392, '2.130.10.10-FF-004519', NULL, 'Dmx like 1', 231, NULL, NULL, 28392),
(28393, '2.60.40.1730-FF-000099', NULL, NULL, 116, NULL, NULL, 28393),
(28394, '2.130.10.10-FF-004183', NULL, 'Uncharacterized protein', 163, NULL, NULL, 28394),
(28395, '3.30.1540.20-FF-000034', NULL, NULL, 77, NULL, NULL, 28395),
(28396, '1.25.10.10-FF-000649', NULL, 'CLIP-associated protein', 225, NULL, NULL, 28396),
(28397, '1.20.90.10-FF-000030', NULL, NULL, 137, NULL, NULL, 28397),
(28398, '1.25.10.10-FF-002903', NULL, 'Uncharacterized protein', 479, NULL, NULL, 28398),
(28399, '3.30.497.10-FF-000071', NULL, 'Protein CBG00799', 230, NULL, NULL, 28399),
(28400, '1.25.40.20-FF-000817', NULL, 'ankyrin repeat-containing protein ITN1-like', 105, NULL, NULL, 28400),
(28401, '3.80.10.10-FF-000321', NULL, 'T-complex-associated testis-expressed protein 1', 101, NULL, NULL, 28401),
(28402, '3.50.50.60-FF-000334', NULL, 'Ferredoxin reductase', 124, NULL, NULL, 28402),
(28403, '1.10.533.10-FF-000191', NULL, 'V-FLIP', 90, NULL, NULL, 28403),
(28404, '2.40.30.10-FF-000259', NULL, 'Protein Translation Initiation Factor 2 (IF-2)', 133, NULL, NULL, 28404),
(28405, '3.30.40.10-FF-000230', NULL, 'RBR-type E3 ubiquitin transferase', 87, NULL, NULL, 28405),
(28406, '1.10.418.10-FF-000226', NULL, 'p-loop nucleoside triphosphate hydrolase superfamily protein with CH (Calponin Homology) domain', 146, NULL, NULL, 28406),
(28407, '3.30.70.330-FF-000437', NULL, 'Polyadenylate-binding protein RBP45C', 134, NULL, NULL, 28407),
(28408, '3.40.390.10-FF-000141', NULL, 'Zinc metalloproteinase nas-24', 228, NULL, NULL, 28408),
(28409, '1.10.472.10-FF-000368', NULL, 'Cyclin N-terminal domain-containing protein 1', 137, NULL, NULL, 28409),
(28410, '3.40.50.2000-FF-000431', NULL, 'UDP-glycosyltransferase 90A1', 99, NULL, NULL, 28410),
(28411, '3.30.160.60-FF-002838', NULL, 'Probable E3 ubiquitin-protein ligase TRIM8', 76, NULL, NULL, 28411),
(28412, '3.30.230.70-FF-000032', NULL, 'Polyribonucleotide nucleotidyltransferase 1', 327, NULL, NULL, 28412),
(28413, '2.160.20.10-FF-000152', NULL, 'Uncharacterized protein', 169, NULL, NULL, 28413),
(28414, '2.60.34.10-FF-000093', NULL, 'Uncharacterized protein', 186, NULL, NULL, 28414),
(28415, '1.20.5.190-FF-000182', NULL, NULL, 79, NULL, NULL, 28415),
(28416, '1.20.1250.20-FF-001275', NULL, 'MFS transporter, putative', 205, NULL, NULL, 28416),
(28417, '3.40.50.300-FF-004930', NULL, 'Predicted protein', 189, NULL, NULL, 28417),
(28418, '1.20.1070.10-FF-001286', NULL, 'Olfactory receptor', 209, NULL, NULL, 28418),
(28419, '2.60.40.10-FF-002529', NULL, 'Unc-40 protein', 104, NULL, NULL, 28419),
(28420, '3.40.630.10-FF-000194', NULL, 'Probable M18 family aminopeptidase 1', 294, NULL, NULL, 28420),
(28421, '3.40.1090.10-FF-000117', NULL, 'Lysophospholipase', 290, NULL, NULL, 28421),
(28422, '1.20.58.60-FF-000032', NULL, 'Kalirin RhoGEF kinase b', 108, NULL, NULL, 28422),
(28423, '2.130.10.10-FF-004396', NULL, 'Uncharacterized protein', 58, NULL, NULL, 28423),
(28424, '2.60.40.1910-FF-000046', NULL, NULL, 81, NULL, NULL, 28424),
(28425, '3.40.50.300-FF-006824', NULL, 'Elongation factor 2', 35, NULL, NULL, 28425),
(28426, '2.60.40.2030-FF-000060', NULL, 'Adhesion G-protein coupled receptor V1', 131, NULL, NULL, 28426),
(28427, '2.70.170.10-FF-000009', NULL, 'Neuronal acetylcholine receptor subunit alpha-7', 209, NULL, NULL, 28427),
(28428, '3.90.550.10-FF-000356', NULL, 'Glycosyl transferase family 2', 221, NULL, NULL, 28428),
(28429, '3.30.565.10-FF-000454', NULL, 'Ethylene receptor 2', 188, NULL, NULL, 28429);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(28430, '3.30.428.10-FF-000080', NULL, 'Predicted protein', 80, NULL, NULL, 28430),
(28431, '1.10.220.10-FF-000065', NULL, 'Annexin', 49, NULL, NULL, 28431),
(28432, '1.10.10.160-FF-000010', NULL, 'ATP-dependent DNA helicase Rep', 78, NULL, NULL, 28432),
(28433, '1.25.40.770-FF-000003', NULL, 'Transcription initiation factor TFIID complex subunit', 209, NULL, NULL, 28433),
(28434, '1.10.530.10-FF-000049', NULL, 'At1g16290', 140, NULL, NULL, 28434),
(28435, '2.130.10.10-FF-000467', NULL, 'WD repeat domain 18', 162, NULL, NULL, 28435),
(28436, '3.30.450.30-FF-000031', NULL, 'Uncharacterized protein', 137, NULL, NULL, 28436),
(28437, '2.90.10.10-FF-000065', NULL, 'Uncharacterized protein', 49, NULL, NULL, 28437),
(28438, '3.40.50.150-FF-000804', NULL, 'Putative methyltransferase NSUN7', 240, NULL, NULL, 28438),
(28439, '1.10.10.10-FF-000683', NULL, 'MarR family transcriptional regulator', 136, NULL, NULL, 28439),
(28440, '3.30.420.40-FF-000532', NULL, 'Hsp70 protein/TPR repeat/Tetratricopeptide repeat, putative', 186, NULL, NULL, 28440),
(28441, '2.60.120.200-FF-000213', NULL, 'Galectin', 140, NULL, NULL, 28441),
(28442, '1.10.287.1970-FF-000009', NULL, 'Alanine aminotransferase5', 35, NULL, NULL, 28442),
(28443, '3.40.50.720-FF-002324', NULL, 'NADPH-dependent pterin aldehyde reductase', 121, NULL, NULL, 28443),
(28444, '1.25.10.10-FF-000442', NULL, 'Coatomer beta subunit', 414, NULL, NULL, 28444),
(28445, '2.130.10.10-FF-002619', NULL, 'Coronin', 165, NULL, NULL, 28445),
(28446, '2.10.110.10-FF-000075', NULL, 'Actin-binding lim protein 1', 61, NULL, NULL, 28446),
(28447, '1.25.40.10-FF-004305', NULL, 'Uncharacterized protein', 190, NULL, NULL, 28447),
(28448, '3.30.160.60-FF-003114', NULL, 'Uncharacterized protein', 28, NULL, NULL, 28448),
(28449, '3.80.10.10-FF-003177', NULL, 'Uncharacterized protein', 254, NULL, NULL, 28449),
(28450, '3.90.550.50-FF-000126', NULL, 'Uncharacterized protein', 180, NULL, NULL, 28450),
(28451, '3.40.50.300-FF-002676', NULL, 'ATP-dependent DEAH-box RNA helicase, putative', 174, NULL, NULL, 28451),
(28452, '3.30.60.20-FF-000116', NULL, 'Diacylglycerol kinase', 51, NULL, NULL, 28452),
(28453, '3.60.15.10-FF-000232', NULL, 'Arylsulfatase', 251, NULL, NULL, 28453),
(28454, '3.50.50.60-FF-000121', NULL, 'Pyridine nucleotide-disulfide oxidoreductase YkgC', 177, NULL, NULL, 28454),
(28455, '3.30.900.20-FF-000001', NULL, 'MAD2L1 binding protein', 240, NULL, NULL, 28455),
(28456, '1.25.40.10-FF-002405', NULL, 'Pentatricopeptide repeat-containing protein', 138, NULL, NULL, 28456),
(28457, '3.90.70.10-FF-000791', NULL, 'Uncharacterized protein', 401, NULL, NULL, 28457),
(28458, '3.60.10.10-FF-000131', NULL, 'RGD1565316 protein', 308, NULL, NULL, 28458),
(28459, '1.10.10.10-FF-000470', NULL, 'Response regulator receiver domain protein', 100, NULL, NULL, 28459),
(28460, '3.40.1350.80-FF-000001', NULL, 'Type-2 restriction enzyme AplI', 165, NULL, NULL, 28460),
(28461, '3.40.50.720-FF-001835', NULL, 'Methylenetetrahydrofolate dehydrogenase (NADP+-dependent) 1-like', 111, NULL, NULL, 28461),
(28462, '1.25.40.90-FF-000006', NULL, 'Clathrin interactor 1', 149, NULL, NULL, 28462),
(28463, '1.10.8.270-FF-000129', NULL, 'Uncharacterized protein', 110, NULL, NULL, 28463),
(28464, '2.40.50.690-FF-000037', NULL, 'Uncharacterized protein', 119, NULL, NULL, 28464),
(28465, '3.30.70.100-FF-000178', NULL, NULL, 62, NULL, NULL, 28465),
(28466, '3.20.20.70-FF-000769', NULL, NULL, 328, NULL, NULL, 28466),
(28467, '3.30.200.20-FF-002555', NULL, 'Uncharacterized protein', 78, NULL, NULL, 28467),
(28468, '3.30.200.20-FF-000094', NULL, 'Serine/threonine-protein kinase receptor', 91, NULL, NULL, 28468),
(28469, '2.60.40.10-FF-004429', NULL, NULL, 92, NULL, NULL, 28469),
(28470, '3.40.50.720-FF-002111', NULL, 'Uncharacterized protein', 119, NULL, NULL, 28470),
(28471, '3.40.50.300-FF-008292', NULL, 'GTP-binding protein-related', 29, NULL, NULL, 28471),
(28472, '3.30.870.10-FF-000124', NULL, 'Uncharacterized protein', 105, NULL, NULL, 28472),
(28473, '3.90.1420.10-FF-000059', NULL, 'Uncharacterized protein', 165, NULL, NULL, 28473);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(28474, '3.80.10.10-FF-001389', NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g63430', 175, NULL, NULL, 28474),
(28475, '3.40.1280.10-FF-000031', NULL, 'RNA methyltransferase, putative', 264, NULL, NULL, 28475),
(28476, '2.60.120.260-FF-000641', NULL, 'Uncharacterized protein', 104, NULL, NULL, 28476),
(28477, '1.20.1250.20-FF-001937', NULL, 'Solute carrier family 43 member 3a', 465, NULL, NULL, 28477),
(28478, '3.30.160.60-FF-002951', NULL, 'Sal-like protein 3', 26, NULL, NULL, 28478),
(28479, '3.80.10.10-FF-002007', NULL, 'Toll-like protein', 232, NULL, NULL, 28479),
(28480, '3.30.360.10-FF-000046', NULL, 'Glucose-6-phosphate 1-dehydrogenase', 297, NULL, NULL, 28480),
(28481, '2.130.10.10-FF-005121', NULL, 'Predicted protein', 99, NULL, NULL, 28481),
(28482, '2.60.40.4060-FF-000005', NULL, 'GD10853', 150, NULL, NULL, 28482),
(28483, '3.40.50.300-FF-008174', NULL, 'HBS1-like translational GTPase', 85, NULL, NULL, 28483),
(28484, '1.10.1900.10-FF-000009', NULL, 'Polyadenylate-binding protein', 87, NULL, NULL, 28484),
(28485, '3.40.50.720-FF-000183', NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase, chloroplastic', 155, NULL, NULL, 28485),
(28486, '3.40.30.10-FF-000881', NULL, 'Dolichyl-diphosphooligosaccharide--protein glycosyltransferase subunit 3', 156, NULL, NULL, 28486),
(28487, '3.30.1380.20-FF-000044', NULL, 'Sigma-54-dependent Fis family transcriptional regulator', 161, NULL, NULL, 28487),
(28488, '1.10.238.10-FF-000246', NULL, 'Uncharacterized protein, isoform C', 114, NULL, NULL, 28488),
(28489, '2.30.30.30-FF-000018', NULL, 'Transcription elongation factor SPT5', 50, NULL, NULL, 28489),
(28490, '3.20.20.150-FF-000044', NULL, 'Protein arginine N-methyltransferase', 303, NULL, NULL, 28490),
(28491, '2.10.220.10-FF-000179', NULL, 'AGAP002915-PA', 71, NULL, NULL, 28491),
(28492, '1.25.40.990-FF-000069', NULL, 'Predicted protein', 302, NULL, NULL, 28492),
(28493, '1.25.40.20-FF-000609', NULL, 'Calmodulin-binding transcription activator 4', 154, NULL, NULL, 28493),
(28494, '1.10.287.2250-FF-000009', NULL, 'Cysteine peptidase A (CPA)', 74, NULL, NULL, 28494),
(28495, '2.130.10.10-FF-000916', NULL, 'VIP3', 317, NULL, NULL, 28495),
(28496, '3.30.200.20-FF-002117', NULL, 'Uncharacterized protein', 76, NULL, NULL, 28496),
(28497, '2.60.40.150-FF-000745', NULL, 'Uncharacterized protein', 94, NULL, NULL, 28497),
(28498, '1.20.1250.20-FF-000414', NULL, 'Folate transporter 1', 206, NULL, NULL, 28498),
(28499, '3.10.180.10-FF-000025', NULL, '4-hydroxyphenylpyruvate dioxygenase', 194, NULL, NULL, 28499),
(28500, '3.40.50.2300-FF-000740', NULL, 'Two-component response regulator', 125, NULL, NULL, 28500),
(28501, '3.30.160.60-FF-006099', NULL, NULL, 61, NULL, NULL, 28501),
(28502, '3.30.50.10-FF-000056', NULL, 'Peroxisome proliferator-activated receptor gamma', 76, NULL, NULL, 28502),
(28503, '1.20.1250.20-FF-000313', NULL, 'MFS quinate transporter', 486, NULL, NULL, 28503),
(28504, '3.60.21.10-FF-000078', NULL, 'Vacuolar protein sorting-associated protein 29', 48, NULL, NULL, 28504),
(28505, '3.40.50.300-FF-004475', NULL, 'ATP-dependent DNA helicase RRM3', 112, NULL, NULL, 28505),
(28506, '3.90.110.10-FF-000025', NULL, NULL, 166, NULL, NULL, 28506),
(28507, '3.40.50.300-FF-006616', NULL, 'Polymerase (DNA directed), theta', 94, NULL, NULL, 28507),
(28508, '3.30.300.30-FF-000031', NULL, 'Acyl-CoA synthetase family member 3', 105, NULL, NULL, 28508),
(28509, '3.40.50.1820-FF-001658', NULL, 'Serine carboxypeptidase-like 19', 130, NULL, NULL, 28509),
(28510, '2.50.20.10-FF-000016', NULL, 'Outer-membrane lipoprotein carrier protein', 183, NULL, NULL, 28510),
(28511, '3.50.50.60-FF-000008', NULL, 'Soluble pyridine nucleotide transhydrogenase', 115, NULL, NULL, 28511),
(28512, '1.20.1070.10-FF-001741', NULL, 'Uncharacterized protein', 86, NULL, NULL, 28512),
(28513, '3.70.10.10-FF-000075', NULL, 'Cell cycle checkpoint control protein', 267, NULL, NULL, 28513),
(28514, '1.20.1250.20-FF-001842', NULL, 'Monocarboxylate transporter 1 homologue', 137, NULL, NULL, 28514),
(28515, '1.10.1410.10-FF-000039', NULL, 'RNA polymerase II, putative', 184, NULL, NULL, 28515);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(28516, '3.30.60.60-FF-000004', NULL, 'Histone acetyltransferase', 61, NULL, NULL, 28516),
(28517, '2.70.50.50-FF-000001', NULL, 'Chitin-binding protein', 169, NULL, NULL, 28517),
(28518, '2.120.10.30-FF-000114', NULL, 'Low-density lipoprotein receptor-related protein', 338, NULL, NULL, 28518),
(28519, '3.20.20.300-FF-000016', NULL, 'Exported beta-glucosidase', 298, NULL, NULL, 28519),
(28520, '3.30.70.1230-FF-000259', NULL, 'Putative regulatory protein', 163, NULL, NULL, 28520),
(28521, '3.20.20.80-FF-000401', NULL, 'Acidic endochitinase', 184, NULL, NULL, 28521),
(28522, '3.30.70.330-FF-002253', NULL, NULL, 132, NULL, NULL, 28522),
(28523, '3.30.160.60-FF-004654', NULL, NULL, 34, NULL, NULL, 28523),
(28524, '1.25.10.10-FF-002336', NULL, 'Uncharacterized protein', 293, NULL, NULL, 28524),
(28525, '3.40.50.300-FF-001136', NULL, 'Putative ADP-ribosylation factor family protein', 113, NULL, NULL, 28525),
(28526, '2.60.40.60-FF-000594', NULL, 'Predicted protein', 105, NULL, NULL, 28526),
(28527, '2.40.30.270-FF-000019', NULL, 'Putative DNA helicase', 106, NULL, NULL, 28527),
(28528, '3.90.660.10-FF-000004', NULL, 'spermine oxidase isoform X2', 131, NULL, NULL, 28528),
(28529, '3.30.565.10-FF-000336', NULL, 'Sensor histidine kinase', 151, NULL, NULL, 28529),
(28530, '3.10.10.10-FF-000015', NULL, NULL, 121, NULL, NULL, 28530),
(28531, '1.10.3130.10-FF-000006', NULL, 'Serine O-acetyltransferase', 158, NULL, NULL, 28531),
(28532, '2.60.40.10-FF-000938', NULL, 'Terribly reduced optic lobes, isoform AH', 101, NULL, NULL, 28532),
(28533, '1.20.5.190-FF-000069', NULL, 'Blast:Protein abnormal spindle', 52, NULL, NULL, 28533),
(28534, '3.40.50.720-FF-000200', NULL, 'Aspartate-semialdehyde dehydrogenase', 166, NULL, NULL, 28534),
(28535, '2.60.40.10-FF-002294', NULL, 'Immunoglobulin-like and fibronectin type III domain-containing 1, tandem duplicate 3', 102, NULL, NULL, 28535),
(28536, '2.30.30.30-FF-000131', NULL, '60S ribosomal protein L2, mitochondrial', 77, NULL, NULL, 28536),
(28537, '1.10.10.60-FF-000905', NULL, NULL, 61, NULL, NULL, 28537),
(28538, '2.30.42.10-FF-000242', NULL, 'LIM domain kinase 1', 97, NULL, NULL, 28538),
(28539, '3.90.660.20-FF-000007', NULL, 'Protoporphyrinogen oxidase', 204, NULL, NULL, 28539),
(28540, '2.60.120.200-FF-000101', NULL, 'basement membrane-specific heparan sulfate proteoglycan core protein-like', 195, NULL, NULL, 28540),
(28541, '1.25.40.10-FF-004193', NULL, 'Uncharacterized protein', 278, NULL, NULL, 28541),
(28542, '1.10.510.10-FF-000166', NULL, 'SNF-related serine/threonine-protein kinase', 349, NULL, NULL, 28542),
(28543, '1.20.144.10-FF-000071', NULL, 'GM22449', 274, NULL, NULL, 28543),
(28544, '2.60.40.380-FF-000005', NULL, 'Purple acid phosphatase', 108, NULL, NULL, 28544),
(28545, '2.60.40.1510-FF-000033', NULL, 'Integrin beta', 87, NULL, NULL, 28545),
(28546, '1.25.40.20-FF-001323', NULL, 'VMS1 homolog C1827.04', 136, NULL, NULL, 28546),
(28547, '2.120.10.30-FF-000209', NULL, 'LDL receptor protein 1, isoform F', 335, NULL, NULL, 28547),
(28548, '3.30.200.20-FF-001499', NULL, 'Uncharacterized protein', 78, NULL, NULL, 28548),
(28549, '1.10.10.60-FF-000810', NULL, NULL, 55, NULL, NULL, 28549),
(28550, '3.10.129.10-FF-000018', NULL, 'ComA operon protein', 126, NULL, NULL, 28550),
(28551, '3.30.420.40-FF-000526', NULL, 'Heat shock protein 70, putative', 94, NULL, NULL, 28551),
(28552, '3.40.50.150-FF-000916', NULL, NULL, 149, NULL, NULL, 28552),
(28553, '1.50.10.20-FF-000010', NULL, 'Complement C4-A', 325, NULL, NULL, 28553),
(28554, '3.40.30.10-FF-001055', NULL, 'Thyroxine 5''-deiodinase', 177, NULL, NULL, 28554),
(28555, '2.60.40.4070-FF-000008', NULL, 'Basal-body rod modification protein FlgD', 86, NULL, NULL, 28555),
(28556, '2.130.10.10-FF-000821', NULL, 'Chromatin assembly factor 1 protein WD40 domain,putative', 422, NULL, NULL, 28556),
(28557, '3.40.50.980-FF-000036', NULL, 'Nonribosomal peptide synthase, putative (JCVI)', 138, NULL, NULL, 28557),
(28558, '3.40.50.1820-FF-000135', NULL, 'Esterase lipC', 277, NULL, NULL, 28558),
(28559, '3.40.190.10-FF-000058', NULL, 'Thiosulfate ABC transporter, substrate-binding protein', 149, NULL, NULL, 28559);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(28560, '1.20.58.390-FF-000247', NULL, 'Uncharacterized protein', 119, NULL, NULL, 28560),
(28561, '2.60.120.200-FF-000090', NULL, 'Crumbs cell polarity complex component 1', 167, NULL, NULL, 28561),
(28562, '3.40.50.300-FF-005998', NULL, 'uncharacterized protein LOC100176493', 240, NULL, NULL, 28562),
(28563, '2.60.34.10-FF-000110', NULL, 'Uncharacterized protein', 83, NULL, NULL, 28563),
(28564, '3.90.1150.10-FF-000307', NULL, 'Uncharacterized protein', 165, NULL, NULL, 28564),
(28565, '3.40.50.970-FF-000033', NULL, 'Transketolase isoform 1', 297, NULL, NULL, 28565),
(28566, '1.10.472.10-FF-000374', NULL, 'Cyclin-D5-1', 71, NULL, NULL, 28566),
(28567, '4.10.400.10-FF-000197', NULL, 'Sortilin-related receptor', 36, NULL, NULL, 28567),
(28568, '3.40.50.1820-FF-001563', NULL, 'Uncharacterized protein', 116, NULL, NULL, 28568),
(28569, '3.90.226.10-FF-000204', NULL, 'Enoyl-CoA hydratase', 205, NULL, NULL, 28569),
(28570, '3.30.40.10-FF-001871', NULL, 'Uncharacterized protein', 77, NULL, NULL, 28570),
(28571, '3.40.190.10-FF-000401', NULL, 'GLutamate Receptor family (AMPA)', 127, NULL, NULL, 28571),
(28572, '3.10.110.10-FF-000077', NULL, 'Ubiquitin conjugating enzyme E2', 152, NULL, NULL, 28572),
(28573, '3.40.50.80-FF-000060', NULL, 'Cupric reductase', 174, NULL, NULL, 28573),
(28574, '3.30.40.10-FF-001983', NULL, 'Uncharacterized protein', 59, NULL, NULL, 28574),
(28575, '2.60.40.60-FF-000605', NULL, 'Fat-like cadherin-related tumor suppressor homolog', 107, NULL, NULL, 28575),
(28576, '3.90.1150.10-FF-000515', NULL, 'Uncharacterized protein', 102, NULL, NULL, 28576),
(28577, '4.10.1110.10-FF-000008', NULL, 'YOR052C-like protein', 88, NULL, NULL, 28577),
(28578, '1.10.150.80-FF-000046', NULL, 'ATP-dependent DNA helicase hus2/rqh1', 87, NULL, NULL, 28578),
(28579, '3.40.30.10-FF-000549', NULL, 'Uncharacterized protein', 56, NULL, NULL, 28579),
(28580, '1.25.40.20-FF-000823', NULL, 'Kinase, NEK', 86, NULL, NULL, 28580),
(28581, '2.60.40.10-FF-001091', NULL, 'Pre T-cell antigen receptor alpha', 114, NULL, NULL, 28581),
(28582, '1.10.238.10-FF-000572', NULL, 'RAB11 family interacting protein 3 (class II)', 169, NULL, NULL, 28582),
(28583, '3.80.10.10-FF-003744', NULL, 'ELRR (Extracellular Leucine-Rich Repeat) ONly', 129, NULL, NULL, 28583),
(28584, '3.40.140.10-FF-000235', NULL, 'tRNA-specific adenosine deaminase, putative', 166, NULL, NULL, 28584),
(28585, '1.20.5.1500-FF-000011', NULL, 'TSPY like 1', 108, NULL, NULL, 28585),
(28586, '2.60.40.420-FF-000040', NULL, 'Azurin', 128, NULL, NULL, 28586),
(28587, '3.30.70.870-FF-000037', NULL, 'Uncharacterized protein', 77, NULL, NULL, 28587),
(28588, '3.80.10.10-FF-001732', NULL, 'Hypothetical_protein_-_conserved', 143, NULL, NULL, 28588),
(28589, '3.80.10.10-FF-002215', NULL, 'Uncharacterized protein', 263, NULL, NULL, 28589),
(28590, '3.30.750.24-FF-000055', NULL, 'Anti-sigma B factor antagonist', 94, NULL, NULL, 28590),
(28591, '3.30.420.40-FF-001032', NULL, 'Uncharacterized protein', 32, NULL, NULL, 28591),
(28592, '3.10.100.10-FF-000149', NULL, NULL, 144, NULL, NULL, 28592),
(28593, '1.20.1070.10-FF-001409', NULL, 'Uncharacterized protein', 233, NULL, NULL, 28593),
(28594, '3.40.50.10810-FF-000252', NULL, 'Predicted protein', 120, NULL, NULL, 28594),
(28595, '3.30.500.10-FF-000035', NULL, NULL, 88, NULL, NULL, 28595),
(28596, '2.130.10.10-FF-002266', NULL, 'Uncharacterized protein', 308, NULL, NULL, 28596),
(28597, '3.30.160.60-FF-001220', NULL, 'ZFP28 zinc finger protein', 28, NULL, NULL, 28597),
(28598, '3.30.160.60-FF-004749', NULL, NULL, 24, NULL, NULL, 28598),
(28599, '3.40.50.2300-FF-000532', NULL, 'PTS system fructose-specific IIBC component', 103, NULL, NULL, 28599),
(28600, '3.10.450.50-FF-000013', NULL, 'mRNA export factor mex67', 193, NULL, NULL, 28600),
(28601, '3.40.50.150-FF-000563', NULL, 'Ribosomal RNA methyltransferase-like protein', 203, NULL, NULL, 28601),
(28602, '3.40.50.2300-FF-000420', NULL, 'Transcriptional regulator', 118, NULL, NULL, 28602),
(28603, '2.30.42.10-FF-000343', NULL, 'GD20482', 96, NULL, NULL, 28603),
(28604, '3.40.50.150-FF-001170', NULL, NULL, 189, NULL, NULL, 28604);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(28605, '3.10.450.40-FF-000010', NULL, 'Amine oxidase', 121, NULL, NULL, 28605),
(28606, '1.10.150.630-FF-000001', NULL, 'Type III secretion protein', 86, NULL, NULL, 28606),
(28607, '2.130.10.10-FF-000708', NULL, 'U3 small nucleolar RNA-associated protein 15 homolog', 282, NULL, NULL, 28607),
(28608, '3.40.50.1980-FF-000054', NULL, 'Nitrogenase molybdenum-iron protein beta chain', 106, NULL, NULL, 28608),
(28609, '3.40.50.300-FF-002446', NULL, 'Katanin p60 ATPase-containing subunit A1', 188, NULL, NULL, 28609),
(28610, '3.30.420.40-FF-000195', NULL, 'Phosphotransferase', 207, NULL, NULL, 28610),
(28611, '3.80.10.10-FF-002120', NULL, 'Protein CBG11130', 153, NULL, NULL, 28611),
(28612, '3.90.1180.10-FF-000023', NULL, NULL, 145, NULL, NULL, 28612),
(28613, '2.130.10.10-FF-004284', NULL, 'Uncharacterized protein', 127, NULL, NULL, 28613),
(28614, '3.30.160.590-FF-000001', NULL, 'microprocessor complex subunit DGCR8', 34, NULL, NULL, 28614),
(28615, '3.30.1490.100-FF-000045', NULL, 'DNA polymerase IV', 112, NULL, NULL, 28615),
(28616, '1.25.40.10-FF-000820', NULL, 'Gamma-soluble NSF attachment protein', 291, NULL, NULL, 28616),
(28617, '1.20.58.60-FF-000144', NULL, 'Dystonin', 215, NULL, NULL, 28617),
(28618, '3.90.1150.10-FF-000420', NULL, 'Predicted protein', 100, NULL, NULL, 28618),
(28619, '3.40.50.300-FF-006936', NULL, 'Sulfotransferase', 317, NULL, NULL, 28619),
(28620, '1.10.1420.10-FF-000192', NULL, 'Uncharacterized protein', 43, NULL, NULL, 28620),
(28621, '1.20.1070.10-FF-001398', NULL, 'Uncharacterized protein', 240, NULL, NULL, 28621),
(28622, '3.90.1600.10-FF-000045', NULL, 'DNA polymerase epsilon catalytic subunit A', 51, NULL, NULL, 28622),
(28623, '2.120.10.30-FF-000322', NULL, 'Flagellum-adhesion glycoprotein, putative', 67, NULL, NULL, 28623),
(28624, '2.10.25.10-FF-001182', NULL, 'Megalin, isoform A', 43, NULL, NULL, 28624),
(28625, '2.40.50.90-FF-000008', NULL, 'Tudor and KH domain-containing protein', 113, NULL, NULL, 28625),
(28626, '3.90.226.10-FF-000092', NULL, 'Malonate decarboxylase, beta subunit', 241, NULL, NULL, 28626),
(28627, '3.40.50.1970-FF-000051', NULL, NULL, 192, NULL, NULL, 28627),
(28628, '1.10.510.10-FF-003122', NULL, NULL, 188, NULL, NULL, 28628),
(28629, '3.40.50.300-FF-001041', NULL, 'Origin of replication complex subunit 4', 175, NULL, NULL, 28629),
(28630, '2.120.10.80-FF-000185', NULL, 'F-box protein family, AtFBX13-like protein', 252, NULL, NULL, 28630),
(28631, '1.10.10.10-FF-000357', NULL, 'Caffeic acid 3-O-methyltransferase', 114, NULL, NULL, 28631),
(28632, '3.50.30.40-FF-000001', NULL, 'Regulator of ribonuclease activity A', 161, NULL, NULL, 28632),
(28633, '1.20.120.720-FF-000025', NULL, 'Myosin-A', 114, NULL, NULL, 28633),
(28634, '1.20.120.1240-FF-000042', NULL, 'Dynamin GTPase, putative', 266, NULL, NULL, 28634),
(28635, '2.60.120.650-FF-000090', NULL, 'Mitochondrial carrier protein', 262, NULL, NULL, 28635),
(28636, '3.30.70.330-FF-000550', NULL, 'Nuclear localization sequence binding protein', 136, NULL, NULL, 28636),
(28637, '2.60.40.10-FF-001102', NULL, 'tyrosine-protein phosphatase Lar isoform X3', 102, NULL, NULL, 28637),
(28638, '3.40.50.720-FF-001498', NULL, 'Oxidoreductase, short chain dehydrogenase/reductase family', 251, NULL, NULL, 28638),
(28639, '1.25.10.10-FF-000880', NULL, 'Serine/threonine-protein kinase TOR', 312, NULL, NULL, 28639),
(28640, '2.115.10.20-FF-000005', NULL, 'Arabinan endo-1,5-alpha-L-arabinosidase', 306, NULL, NULL, 28640),
(28641, '3.90.550.10-FF-000676', NULL, 'Uncharacterized protein', 94, NULL, NULL, 28641),
(28642, '1.25.10.10-FF-002448', NULL, 'Uncharacterized protein', 229, NULL, NULL, 28642),
(28643, '2.60.200.20-FF-000265', NULL, 'Uncharacterized protein', 48, NULL, NULL, 28643),
(28644, '3.50.30.50-FF-000004', NULL, 'Cyclase family protein', 222, NULL, NULL, 28644),
(28645, '3.40.630.10-FF-000317', NULL, 'Predicted protein', 62, NULL, NULL, 28645),
(28646, '2.40.100.10-FF-000085', NULL, 'Peptidyl-prolyl cis-trans isomerase', 129, NULL, NULL, 28646),
(28647, '2.170.270.10-FF-000184', NULL, 'Histone-lysine N-methyltransferase', 258, NULL, NULL, 28647);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(28648, '3.30.160.60-FF-001315', NULL, 'C2H2 transcription factor Swi5', 45, NULL, NULL, 28648),
(28649, '3.40.190.10-FF-000390', NULL, 'LysR family transcriptional regulator', 97, NULL, NULL, 28649),
(28650, '3.30.565.10-FF-000128', NULL, 'Sensor histidine kinase', 133, NULL, NULL, 28650),
(28651, '3.30.160.60-FF-000697', NULL, 'Recombination activating gene 1', 30, NULL, NULL, 28651),
(28652, '3.90.550.50-FF-000098', NULL, 'Predicted protein', 250, NULL, NULL, 28652),
(28653, '3.30.1520.10-FF-000131', NULL, 'Uncharacterized protein', 119, NULL, NULL, 28653),
(28654, '2.60.250.10-FF-000001', NULL, 'Early 35 kDa protein', 298, NULL, NULL, 28654),
(28655, '3.60.15.10-FF-000119', NULL, 'DNA internalization-related competence protein ComEC/Rec2', 266, NULL, NULL, 28655),
(28656, '3.40.50.300-FF-008527', NULL, 'Atp-dependent RNA helicase', 186, NULL, NULL, 28656),
(28657, '2.40.70.10-FF-000161', NULL, 'YALI0B06303p', 126, NULL, NULL, 28657),
(28658, '3.40.50.1820-FF-000034', NULL, 'NDRG2 isoform 1', 283, NULL, NULL, 28658),
(28659, '3.30.230.70-FF-000133', NULL, 'Uncharacterized protein', 193, NULL, NULL, 28659),
(28660, '1.25.40.10-FF-000606', NULL, 'Putative pentatricopeptide repeat-containing protein', 77, NULL, NULL, 28660),
(28661, '1.20.120.730-FF-000028', NULL, 'Protein transport protein SEC23', 78, NULL, NULL, 28661),
(28662, '2.170.270.10-FF-000066', NULL, 'Histone-lysine N-methyltransferase', 276, NULL, NULL, 28662),
(28663, '3.30.1890.10-FF-000006', NULL, 'O-antigen chain length determinant', 156, NULL, NULL, 28663),
(28664, '1.20.900.10-FF-000120', NULL, 'Rho guanine nucleotide exchange factor 37', 195, NULL, NULL, 28664),
(28665, '1.25.40.10-FF-002164', NULL, 'Putative pentatricopeptide repeat-containing protein', 90, NULL, NULL, 28665),
(28666, '3.30.160.400-FF-000001', NULL, NULL, 97, NULL, NULL, 28666),
(28667, '2.120.10.80-FF-000090', NULL, 'Leucine-zipper transcriptional regulator 1', 191, NULL, NULL, 28667),
(28668, '1.10.1070.11-FF-000053', NULL, 'Serine/threonine-protein kinase ATM', 206, NULL, NULL, 28668),
(28669, '1.10.8.60-FF-000596', NULL, 'Cell division control protein', 79, NULL, NULL, 28669),
(28670, '3.30.160.100-FF-000001', NULL, 'Ribosome hibernation promoting factor', 95, NULL, NULL, 28670),
(28671, '2.10.25.10-FF-001389', NULL, 'Latent transforming growth factor beta binding protein 4', 39, NULL, NULL, 28671),
(28672, '1.10.950.10-FF-000007', NULL, 'Villin like', 60, NULL, NULL, 28672),
(28673, '1.10.510.10-FF-000946', NULL, 'Probable serine/threonine-protein kinase DDB_G0284251', 333, NULL, NULL, 28673),
(28674, '1.20.1070.10-FF-002016', NULL, 'Uncharacterized protein', 134, NULL, NULL, 28674),
(28675, '3.90.70.10-FF-000353', NULL, 'Uncharacterized protein', 346, NULL, NULL, 28675),
(28676, '3.30.1370.10-FF-000214', NULL, 'Uncharacterized protein', 103, NULL, NULL, 28676),
(28677, '3.40.1390.30-FF-000011', NULL, 'Putative GTP cyclohydrolase 1 type 2, NIF3 family', 142, NULL, NULL, 28677),
(28678, '3.30.470.20-FF-000017', NULL, 'Phosphoenolpyruvate synthase', 164, NULL, NULL, 28678),
(28679, '2.120.10.30-FF-000097', NULL, 'Megalin, isoform A', 313, NULL, NULL, 28679),
(28680, '1.25.40.20-FF-000598', NULL, 'Uncharacterized protein', 195, NULL, NULL, 28680),
(28681, '2.60.200.10-FF-000048', NULL, 'Dwarfin sma-4', 185, NULL, NULL, 28681),
(28682, '2.160.20.10-FF-000039', NULL, 'F-box only protein 11', 184, NULL, NULL, 28682),
(28683, '3.90.226.10-FF-000187', NULL, 'Propionyl-CoA carboxylase carboxyltransferase component', 267, NULL, NULL, 28683),
(28684, '3.40.30.10-FF-000667', NULL, 'Protein disulfide isomerase PDI1', 141, NULL, NULL, 28684),
(28685, '3.30.70.330-FF-001747', NULL, NULL, 70, NULL, NULL, 28685),
(28686, '3.40.190.10-FF-000721', NULL, 'Transporter substrate-binding domain-containing protein', 96, NULL, NULL, 28686),
(28687, '1.20.1530.20-FF-000026', NULL, 'Sodium/bile acid symporter family protein', 311, NULL, NULL, 28687),
(28688, '3.40.30.10-FF-000987', NULL, 'Uncharacterized protein', 86, NULL, NULL, 28688),
(28689, '3.40.190.290-FF-000106', NULL, 'Transcriptional regulatory protein', 205, NULL, NULL, 28689);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(28690, '1.20.142.10-FF-000004', NULL, 'Poly [ADP-ribose] polymerase', 143, NULL, NULL, 28690),
(28691, '3.30.40.10-FF-000016', NULL, 'Inhibitor of growth protein', 58, NULL, NULL, 28691),
(28692, '2.60.40.10-FF-004660', NULL, NULL, 102, NULL, NULL, 28692),
(28693, '3.30.70.1660-FF-000045', NULL, 'Uncharacterized protein', 31, NULL, NULL, 28693),
(28694, '3.30.70.330-FF-001865', NULL, NULL, 105, NULL, NULL, 28694),
(28695, '3.40.50.1000-FF-000811', NULL, NULL, 127, NULL, NULL, 28695),
(28696, '2.60.40.60-FF-000925', NULL, 'Cadherin 13', 59, NULL, NULL, 28696),
(28697, '2.10.25.10-FF-001732', NULL, 'Uncharacterized protein', 58, NULL, NULL, 28697),
(28698, '3.10.100.10-FF-000262', NULL, NULL, 141, NULL, NULL, 28698),
(28699, '1.20.920.30-FF-000026', NULL, 'Dynein heavy chain', 210, NULL, NULL, 28699),
(28700, '3.30.160.60-FF-002288', NULL, 'Zinc finger protein 700', 28, NULL, NULL, 28700),
(28701, '3.40.50.11530-FF-000018', NULL, 'Uncharacterized protein', 124, NULL, NULL, 28701),
(28702, '1.20.920.20-FF-000023', NULL, 'Putative mitotubule-associated protein Gb4', 232, NULL, NULL, 28702),
(28703, '3.40.640.10-FF-000150', NULL, 'Cystathionine beta-lyase', 226, NULL, NULL, 28703),
(28704, '1.10.132.10-FF-000017', NULL, NULL, 78, NULL, NULL, 28704),
(28705, '3.40.50.1220-FF-000051', NULL, 'Pyruvate decarboxylase, putative', 153, NULL, NULL, 28705),
(28706, '2.40.70.10-FF-000368', NULL, NULL, 209, NULL, NULL, 28706),
(28707, '3.90.730.10-FF-000016', NULL, 'Ribonuclease T2,-like', 226, NULL, NULL, 28707),
(28708, '3.10.180.10-FF-000036', NULL, 'Glyoxalase-like domain protein', 141, NULL, NULL, 28708),
(28709, '1.10.600.10-FF-000032', NULL, 'Syn-copalyl diphosphate synthase', 94, NULL, NULL, 28709),
(28710, '3.20.20.300-FF-000027', NULL, 'Glycosyl hydrolase, putative', 339, NULL, NULL, 28710),
(28711, '1.10.1410.40-FF-000014', NULL, 'Cyclic GMP-AMP synthase', 125, NULL, NULL, 28711),
(28712, '3.40.50.2000-FF-000532', NULL, 'Uncharacterized protein', 176, NULL, NULL, 28712),
(28713, '2.40.50.140-FF-000434', NULL, 'Methionyl-tRNA synthetase putative', 167, NULL, NULL, 28713),
(28714, '2.60.40.770-FF-000015', NULL, 'Putative phosphatidylglycerol/phosphatidylinositol transfer protein isoform A', 122, NULL, NULL, 28714),
(28715, '2.30.30.40-FF-000673', NULL, 'Uncharacterized protein', 62, NULL, NULL, 28715),
(28716, '3.40.50.150-FF-000355', NULL, 'Methyltransferase like 8', 116, NULL, NULL, 28716),
(28717, '1.10.287.2920-FF-000002', NULL, 'Mediator of RNA polymerase II transcription subunit 15', 80, NULL, NULL, 28717),
(28718, '2.40.50.140-FF-000333', NULL, 'DNA-directed RNA polymerase III subunit RPC8', 106, NULL, NULL, 28718),
(28719, '1.10.357.150-FF-000013', NULL, 'Predicted protein', 215, NULL, NULL, 28719),
(28720, '2.130.10.10-FF-000585', NULL, 'WD repeat domain 60', 212, NULL, NULL, 28720),
(28721, '3.40.50.300-FF-003502', NULL, 'DNA mismatch repair protein mutS, putative', 247, NULL, NULL, 28721),
(28722, '3.10.20.90-FF-001001', NULL, 'Uncharacterized protein', 85, NULL, NULL, 28722),
(28723, '3.30.710.10-FF-000410', NULL, 'Uncharacterized protein', 154, NULL, NULL, 28723),
(28724, '3.30.505.50-FF-000007', NULL, 'Ribosome hibernation promoting factor', 46, NULL, NULL, 28724),
(28725, '2.20.70.10-FF-000111', NULL, 'E3 ubiquitin-protein ligase', 34, NULL, NULL, 28725),
(28726, '3.40.50.11210-FF-000023', NULL, NULL, 99, NULL, NULL, 28726),
(28727, '3.10.20.90-FF-000624', NULL, 'Ubiquitin-40S ribosomal protein S27a', 80, NULL, NULL, 28727),
(28728, '3.40.630.30-FF-000655', NULL, 'Uncharacterized protein', 157, NULL, NULL, 28728),
(28729, '3.10.110.10-FF-000088', NULL, 'Ubiquitin-conjugating enzyme E2', 153, NULL, NULL, 28729),
(28730, '1.10.357.140-FF-000010', NULL, 'Protoheme IX farnesyltransferase', 158, NULL, NULL, 28730),
(28731, '3.40.50.1240-FF-000057', NULL, '6-phosphofructo-2-kinase/fructose-2, 6-biphosphatase, putative', 215, NULL, NULL, 28731),
(28732, '3.30.70.330-FF-002141', NULL, NULL, 144, NULL, NULL, 28732),
(28733, '2.60.120.200-FF-000421', NULL, 'Bb-cadherin', 201, NULL, NULL, 28733);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(28734, '3.50.7.10-FF-000018', NULL, 'T-complex protein 1 subunit delta', 171, NULL, NULL, 28734),
(28735, '2.60.40.10-FF-000618', NULL, 'sushi, nidogen and EGF-like domain-containing protein 1 isoform X2', 99, NULL, NULL, 28735),
(28736, '3.40.50.300-FF-005301', NULL, 'Ras-related protein Rap-1b', 171, NULL, NULL, 28736),
(28737, '3.90.550.10-FF-000238', NULL, 'Probable N-acetylgalactosaminyltransferase 8', 381, NULL, NULL, 28737),
(28738, '3.30.160.60-FF-000489', NULL, 'Zinc finger protein Gfi-1', 24, NULL, NULL, 28738),
(28739, '3.40.50.2300-FF-000077', NULL, 'Chemotaxis response regulator', 127, NULL, NULL, 28739),
(28740, '3.40.50.12240-FF-000012', NULL, 'ATP synthase subunit beta chloroplastic', 181, NULL, NULL, 28740),
(28741, '2.110.10.10-FF-000069', NULL, 'Uncharacterized protein', 120, NULL, NULL, 28741),
(28742, '3.30.70.330-FF-002242', NULL, NULL, 110, NULL, NULL, 28742),
(28743, '3.30.160.60-FF-000259', NULL, 'Zinc finger and BTB domain containing 7C', 26, NULL, NULL, 28743),
(28744, '2.60.40.10-FF-000276', NULL, 'peroxidasin homolog', 93, NULL, NULL, 28744),
(28745, '3.90.550.10-FF-000468', NULL, 'Ceramide glucosyltransferase', 222, NULL, NULL, 28745),
(28746, '2.160.20.70-FF-000029', NULL, 'Tubulin binding cofactor C, putative', 142, NULL, NULL, 28746),
(28747, '1.20.1070.10-FF-001948', NULL, 'Protein CBR-SRV-22', 211, NULL, NULL, 28747),
(28748, '1.10.287.110-FF-000384', NULL, 'Uncharacterized protein', 83, NULL, NULL, 28748),
(28749, '2.40.160.110-FF-000053', NULL, 'Uncharacterized protein', 80, NULL, NULL, 28749),
(28750, '3.30.710.10-FF-000511', NULL, 'Potassium voltage-gated channel subfamily A member 3', 63, NULL, NULL, 28750),
(28751, '2.60.40.1170-FF-000009', NULL, 'AP-3 complex subunit mu-1-like protein', 110, NULL, NULL, 28751),
(28752, '1.25.40.10-FF-004417', NULL, 'Uncharacterized protein', 130, NULL, NULL, 28752),
(28753, '1.25.40.10-FF-003799', NULL, 'Uncharacterized protein', 143, NULL, NULL, 28753),
(28754, '3.40.1710.10-FF-000008', NULL, 'ABC transporter G family member 20', 143, NULL, NULL, 28754),
(28755, '3.40.50.1000-FF-000457', NULL, 'Haloacid dehalogenase-like hydrolase domain-containing 5', 70, NULL, NULL, 28755),
(28756, '3.10.110.10-FF-000190', NULL, 'Ubiquitin-conjugating enzyme E2-28.4 kDa', 176, NULL, NULL, 28756),
(28757, '2.40.10.10-FF-000494', NULL, NULL, 138, NULL, NULL, 28757),
(28758, '3.30.450.40-FF-000146', NULL, 'Stage II sporulation protein E', 173, NULL, NULL, 28758),
(28759, '1.25.10.10-FF-000650', NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', 276, NULL, NULL, 28759),
(28760, '3.90.190.10-FF-000030', NULL, 'Tyrosine-protein phosphatase non-receptor type', 292, NULL, NULL, 28760),
(28761, '3.90.1800.10-FF-000026', NULL, 'DNA-directed RNA polymerase subunit beta', 111, NULL, NULL, 28761),
(28762, '3.30.160.60-FF-004188', NULL, NULL, 30, NULL, NULL, 28762),
(28763, '2.40.160.120-FF-000056', NULL, 'Oxysterol-binding protein', 129, NULL, NULL, 28763),
(28764, '3.40.630.10-FF-000295', NULL, 'Putative carboxypeptidase PM20D1', 199, NULL, NULL, 28764),
(28765, '1.25.40.10-FF-002517', NULL, 'Protein NCA1', 181, NULL, NULL, 28765),
(28766, '3.90.190.20-FF-000033', NULL, 'Folylpolyglutamate synthase', 170, NULL, NULL, 28766),
(28767, '1.10.20.10-FF-000184', NULL, NULL, 86, NULL, NULL, 28767),
(28768, '2.60.40.10-FF-004328', NULL, NULL, 85, NULL, NULL, 28768),
(28769, '2.60.40.1150-FF-000003', NULL, 'AP complex subunit beta', 115, NULL, NULL, 28769),
(28770, '2.60.260.20-FF-000049', NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', 110, NULL, NULL, 28770),
(28771, '3.10.450.10-FF-000029', NULL, 'Fetuin B', 116, NULL, NULL, 28771),
(28772, '1.20.1250.20-FF-002005', NULL, 'Uncharacterized protein', 377, NULL, NULL, 28772),
(28773, '3.90.1410.10-FF-000019', NULL, 'N-lysine methyltransferase', 268, NULL, NULL, 28773),
(28774, '3.40.190.10-FF-000047', NULL, 'Amino acid ABC transporter substrate-binding protein', 148, NULL, NULL, 28774),
(28775, '3.90.1140.10-FF-000026', NULL, 'U6 snRNA phosphodiesterase', 203, NULL, NULL, 28775);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(28776, '3.30.160.60-FF-002389', NULL, 'Zinc finger protein 236 variant', 25, NULL, NULL, 28776),
(28777, '3.30.70.330-FF-000342', NULL, 'Eukaryotic translation initiation factor 3 subunit G', 118, NULL, NULL, 28777),
(28778, '3.40.50.620-FF-000400', NULL, 'Isoleucine--tRNA ligase, mitochondrial', 281, NULL, NULL, 28778),
(28779, '3.40.1480.10-FF-000012', NULL, 'Glycerate kinase', 159, NULL, NULL, 28779),
(28780, '3.40.50.300-FF-002884', NULL, 'ATP-dependent DNA helicase', 66, NULL, NULL, 28780),
(28781, '1.10.238.10-FF-000892', NULL, 'Dual oxidase 1', 160, NULL, NULL, 28781),
(28782, '3.40.50.10810-FF-000263', NULL, 'Predicted protein', 260, NULL, NULL, 28782),
(28783, '2.130.10.10-FF-004637', NULL, 'Uncharacterized protein', 194, NULL, NULL, 28783),
(28784, '2.130.10.10-FF-000355', NULL, 'WD repeat-containing protein 81 isoform X1', 163, NULL, NULL, 28784),
(28785, '3.40.50.720-FF-000306', NULL, 'Alpha-aminoadipic semialdehyde synthase, mitochondrial', 216, NULL, NULL, 28785),
(28786, '3.20.20.70-FF-000657', NULL, NULL, 231, NULL, NULL, 28786),
(28787, '3.40.1050.10-FF-000008', NULL, 'Carbonic anhydrase', 206, NULL, NULL, 28787),
(28788, '3.30.70.980-FF-000071', NULL, 'Uncharacterized protein', 48, NULL, NULL, 28788),
(28789, '1.10.1420.10-FF-000079', NULL, 'DNA mismatch repair protein MutS', 125, NULL, NULL, 28789),
(28790, '2.40.50.140-FF-000092', NULL, 'Transcription termination/antitermination protein NusA', 64, NULL, NULL, 28790),
(28791, '1.10.1670.10-FF-000013', NULL, '8-oxoguanine DNA glycosylase', 17, NULL, NULL, 28791),
(28792, '1.10.8.270-FF-000017', NULL, 'TBC1 domain family member 16', 118, NULL, NULL, 28792),
(28793, '1.10.357.10-FF-000073', NULL, 'Transcriptional regulator tetR/acrR family', 142, NULL, NULL, 28793),
(28794, '3.90.1010.10-FF-000022', NULL, 'SUF system NifU family Fe-S cluster assembly protein', 127, NULL, NULL, 28794),
(28795, '1.20.272.10-FF-000008', NULL, 'DNA polymerase III, delta subunit', 130, NULL, NULL, 28795),
(28796, '1.10.510.10-FF-001430', NULL, 'phosphorylase b kinase gamma catalytic chain, skeletal muscle/heart isoform', 190, NULL, NULL, 28796),
(28797, '3.40.50.300-FF-002564', NULL, 'Iron ABC transporter ATP-binding protein/permease IrtB', 250, NULL, NULL, 28797),
(28798, '3.30.1520.10-FF-000030', NULL, 'Sorting nexin-3, variant', 121, NULL, NULL, 28798),
(28799, '2.60.40.10-FF-002176', NULL, 'Twitchin', 90, NULL, NULL, 28799),
(28800, '3.30.559.70-FF-000047', NULL, 'Uncharacterized protein', 210, NULL, NULL, 28800),
(28801, '2.160.10.10-FF-000112', NULL, 'Uncharacterized protein', 127, NULL, NULL, 28801),
(28802, '2.60.40.10-FF-004317', NULL, NULL, 126, NULL, NULL, 28802),
(28803, '3.40.50.300-FF-001602', NULL, 'Cell division cycle protein-like protein', 186, NULL, NULL, 28803),
(28804, '3.30.40.10-FF-001298', NULL, 'Major immediate early protein', 143, NULL, NULL, 28804),
(28805, '3.30.450.20-FF-000140', NULL, 'Cyclic-di-AMP phosphodiesterase', 103, NULL, NULL, 28805),
(28806, '1.10.10.60-FF-000574', NULL, 'Homeobox protein CHOX-CAD2', 62, NULL, NULL, 28806),
(28807, '1.10.30.10-FF-000145', NULL, 'Uncharacterized protein', 83, NULL, NULL, 28807),
(28808, '1.10.10.60-FF-000344', NULL, 'Transcription factor MYB44', 47, NULL, NULL, 28808),
(28809, '2.40.100.10-FF-000096', NULL, 'Peptidyl-prolyl cis-trans isomerase', 183, NULL, NULL, 28809),
(28810, '3.40.630.10-FF-000418', NULL, 'Predicted protein', 297, NULL, NULL, 28810),
(28811, '3.30.160.60-FF-004643', NULL, NULL, 71, NULL, NULL, 28811),
(28812, '3.90.79.10-FF-000097', NULL, 'MutT/nudix family protein', 207, NULL, NULL, 28812),
(28813, '3.40.50.300-FF-004464', NULL, 'bile salt export pump-like isoform X1', 12, NULL, NULL, 28813),
(28814, '3.40.50.300-FF-003047', NULL, 'Septin, putative', 278, NULL, NULL, 28814),
(28815, '2.20.110.10-FF-000022', NULL, 'MORN repeat, putative', 51, NULL, NULL, 28815),
(28816, '1.10.730.10-FF-000036', NULL, 'Isoleucine--tRNA ligase', 191, NULL, NULL, 28816),
(28817, '3.30.40.10-FF-001753', NULL, 'Tripartite motif containing 69 protein', 94, NULL, NULL, 28817);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(28818, '1.10.10.10-FF-000256', NULL, 'DNA-directed RNA polymerase III subunit RPC3', 100, NULL, NULL, 28818),
(28819, '1.25.10.10-FF-000537', NULL, 'Uncharacterized protein', 144, NULL, NULL, 28819),
(28820, '3.40.640.10-FF-000037', NULL, 'dTDP-4-amino-4,6-dideoxygalactose transaminase', 249, NULL, NULL, 28820),
(28821, '3.30.1680.10-FF-000069', NULL, 'Integrin beta', 46, NULL, NULL, 28821),
(28822, '2.120.10.80-FF-000421', NULL, 'Predicted protein', 196, NULL, NULL, 28822),
(28823, '2.60.120.10-FF-000683', NULL, 'Uncharacterized protein', 85, NULL, NULL, 28823),
(28824, '2.130.10.10-FF-004407', NULL, 'Uncharacterized protein', 372, NULL, NULL, 28824),
(28825, '2.40.30.10-FF-000164', NULL, 'Elongation factor 2', 119, NULL, NULL, 28825),
(28826, '1.25.40.20-FF-001082', NULL, 'Peroxisomal NADH pyrophosphatase NUDT12', 115, NULL, NULL, 28826),
(28827, '3.30.70.330-FF-002803', NULL, NULL, 95, NULL, NULL, 28827),
(28828, '2.130.10.10-FF-003789', NULL, 'Uncharacterized protein', 314, NULL, NULL, 28828),
(28829, '2.60.40.150-FF-000184', NULL, 'Translocation protein SEC63', 118, NULL, NULL, 28829),
(28830, '3.30.160.60-FF-002743', NULL, 'Uncharacterized protein', 29, NULL, NULL, 28830),
(28831, '2.60.120.650-FF-000213', NULL, 'Uncharacterized protein', 62, NULL, NULL, 28831),
(28832, '3.30.497.10-FF-000166', NULL, 'Serpin peptidase inhibitor 28', 41, NULL, NULL, 28832),
(28833, '2.130.10.10-FF-002507', NULL, 'Syntaxin-binding protein 5', 375, NULL, NULL, 28833),
(28834, '2.120.10.30-FF-000198', NULL, 'Sortilin-related receptor, L(DLR class) A repeats containing', 97, NULL, NULL, 28834),
(28835, '3.40.1800.30-FF-000004', NULL, 'SAP30 like', 68, NULL, NULL, 28835),
(28836, '1.10.238.10-FF-000454', NULL, 'Pef1p', 175, NULL, NULL, 28836),
(28837, '1.25.40.20-FF-000929', NULL, 'Putative ankyrin repeat and zinc finger domain protein', 200, NULL, NULL, 28837),
(28838, '3.10.20.90-FF-000944', NULL, 'Uncharacterized protein', 72, NULL, NULL, 28838),
(28839, '1.20.1440.80-FF-000008', NULL, 'Gap junction gamma-3 protein', 224, NULL, NULL, 28839),
(28840, '2.60.40.10-FF-002956', NULL, 'Sortilin-related receptor, L(DLR class) A repeats containing', 80, NULL, NULL, 28840),
(28841, '3.10.450.50-FF-000114', NULL, 'Uncharacterized protein', 127, NULL, NULL, 28841),
(28842, '1.20.870.10-FF-000038', NULL, 'Ras guanine nucleotide exchange factor D', 133, NULL, NULL, 28842),
(28843, '2.40.30.270-FF-000020', NULL, 'Uncharacterized protein', 143, NULL, NULL, 28843),
(28844, '1.25.40.20-FF-001424', NULL, 'Uncharacterized protein', 180, NULL, NULL, 28844),
(28845, '2.130.10.10-FF-004295', NULL, 'Uncharacterized protein', 122, NULL, NULL, 28845),
(28846, '3.30.1370.10-FF-000091', NULL, 'Putative exosome complex exonuclease Rrp40', 104, NULL, NULL, 28846),
(28847, '3.80.10.10-FF-001491', NULL, 'Leucine-rich repeat (LRR) family protein', 164, NULL, NULL, 28847),
(28848, '3.30.780.10-FF-000004', NULL, 'density-regulated protein-like', 84, NULL, NULL, 28848),
(28849, '3.40.50.1580-FF-000041', NULL, 'Uncharacterized protein', 273, NULL, NULL, 28849),
(28850, '1.20.5.190-FF-000070', NULL, 'Myosin', 51, NULL, NULL, 28850),
(28851, '1.10.510.10-FF-000716', NULL, 'Protein kinase byr2-like', 177, NULL, NULL, 28851),
(28852, '1.10.420.10-FF-000046', NULL, 'Uncharacterized protein', 47, NULL, NULL, 28852),
(28853, '2.60.40.150-FF-000307', NULL, 'Copine-E', 129, NULL, NULL, 28853),
(28854, '3.50.50.60-FF-000216', NULL, 'Cilia and flagella associated protein 61', 144, NULL, NULL, 28854),
(28855, '3.40.50.1820-FF-001669', NULL, 'Sortilin', 266, NULL, NULL, 28855),
(28856, '3.40.50.150-FF-000793', NULL, 'FACT complex subunit SPT16', 202, NULL, NULL, 28856),
(28857, '1.10.510.10-FF-000593', NULL, 'Uncharacterized protein', 283, NULL, NULL, 28857),
(28858, '3.30.230.70-FF-000144', NULL, 'Uncharacterized protein', 114, NULL, NULL, 28858),
(28859, '3.40.225.10-FF-000016', NULL, 'Possible L-fuculose phosphate aldolase fucA', 202, NULL, NULL, 28859),
(28860, '3.40.190.10-FF-000160', NULL, 'GLutamate Receptor family (AMPA)', 38, NULL, NULL, 28860);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(28861, '2.10.220.10-FF-000078', NULL, 'Receptor protein-tyrosine kinase', 69, NULL, NULL, 28861),
(28862, '1.20.1250.20-FF-001387', NULL, 'AGAP012419-PA', 191, NULL, NULL, 28862),
(28863, '3.40.1090.10-FF-000005', NULL, 'Patatin', 390, NULL, NULL, 28863),
(28864, '1.10.3110.10-FF-000011', NULL, 'Protoporphyrinogen oxidase', 86, NULL, NULL, 28864),
(28865, '3.60.15.10-FF-000018', NULL, 'DNA cross-link repair 1C', 186, NULL, NULL, 28865),
(28866, '2.40.10.10-FF-000617', NULL, NULL, 105, NULL, NULL, 28866),
(28867, '3.30.230.130-FF-000083', NULL, 'Uncharacterized protein', 161, NULL, NULL, 28867),
(28868, '3.30.200.20-FF-002460', NULL, 'Serine/threonine-protein kinase receptor', 55, NULL, NULL, 28868),
(28869, '3.90.226.10-FF-000081', NULL, 'Enoyl-CoA hydratase/isomerase', 221, NULL, NULL, 28869),
(28870, '3.40.50.1820-FF-001771', NULL, 'Uncharacterized protein', 202, NULL, NULL, 28870),
(28871, '1.20.120.1900-FF-000072', NULL, 'Spindle pole body component', 294, NULL, NULL, 28871),
(28872, '2.70.170.10-FF-000127', NULL, 'Uncharacterized protein', 233, NULL, NULL, 28872),
(28873, '2.60.120.260-FF-000080', NULL, 'Netrin 3', 256, NULL, NULL, 28873),
(28874, '3.80.10.10-FF-003643', NULL, 'Os08g0203400 protein', 105, NULL, NULL, 28874),
(28875, '1.20.1560.10-FF-000879', NULL, 'Uncharacterized protein', 460, NULL, NULL, 28875),
(28876, '3.40.50.1440-FF-000027', NULL, 'Tubulin gamma chain', 270, NULL, NULL, 28876),
(28877, '2.60.40.60-FF-000364', NULL, 'Fat-like cadherin-related tumor suppressor homolog', 120, NULL, NULL, 28877),
(28878, '3.30.60.50-FF-000001', NULL, '2,3-diketo-L-gulonate reductase', 43, NULL, NULL, 28878),
(28879, '2.10.50.30-FF-000054', NULL, 'Uncharacterized protein', 35, NULL, NULL, 28879),
(28880, '1.20.1070.10-FF-001168', NULL, 'Prostaglandin E2 receptor EP3 subtype', 369, NULL, NULL, 28880),
(28881, '2.20.70.10-FF-000195', NULL, 'Pasha/DGCR8', 55, NULL, NULL, 28881),
(28882, '2.60.40.10-FF-003232', NULL, 'Erythropoietin receptor', 103, NULL, NULL, 28882),
(28883, '2.120.10.30-FF-000552', NULL, 'Uncharacterized protein', 84, NULL, NULL, 28883),
(28884, '3.30.70.270-FF-000054', NULL, 'Putative DNA polymerase kappa', 100, NULL, NULL, 28884),
(28885, '1.10.510.10-FF-003021', NULL, NULL, 229, NULL, NULL, 28885),
(28886, '2.70.150.10-FF-000238', NULL, 'Uncharacterized protein', 112, NULL, NULL, 28886),
(28887, '2.40.70.10-FF-000481', NULL, NULL, 152, NULL, NULL, 28887),
(28888, '1.10.150.20-FF-000056', NULL, 'Meiotic recombination protein DMC1', 68, NULL, NULL, 28888),
(28889, '1.25.40.990-FF-000070', NULL, 'Uncharacterized protein', 106, NULL, NULL, 28889),
(28890, '1.10.533.10-FF-000286', NULL, 'Uncharacterized protein', 92, NULL, NULL, 28890),
(28891, '2.10.25.10-FF-001069', NULL, 'Uncharacterized protein', 56, NULL, NULL, 28891),
(28892, '3.40.50.150-FF-001411', NULL, NULL, 162, NULL, NULL, 28892),
(28893, '3.80.20.20-FF-000038', NULL, 'Tyrosine-protein kinase receptor', 52, NULL, NULL, 28893),
(28894, '1.10.472.10-FF-000273', NULL, 'RE32990p', 173, NULL, NULL, 28894),
(28895, '1.20.1250.20-FF-000072', NULL, 'Muropeptide transporter AmpG', 193, NULL, NULL, 28895),
(28896, '3.40.50.720-FF-001953', NULL, 'Very-long-chain 3-oxoacyl-CoA reductase', 261, NULL, NULL, 28896),
(28897, '1.20.1050.10-FF-000216', NULL, 'Glutathione S-transferase', 113, NULL, NULL, 28897),
(28898, '1.25.40.10-FF-003012', NULL, 'Pentatricopeptide repeat-containing protein At5g46580, chloroplastic', 116, NULL, NULL, 28898),
(28899, '3.30.420.40-FF-000318', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 149, NULL, NULL, 28899),
(28900, '3.90.70.10-FF-000673', NULL, 'Uncharacterized protein', 278, NULL, NULL, 28900),
(28901, '3.10.129.10-FF-000226', NULL, 'Cytosolic acyl coenzyme A thioester hydrolase', 158, NULL, NULL, 28901),
(28902, '3.30.160.100-FF-000012', NULL, 'Ribosomal subunit interface protein', 101, NULL, NULL, 28902),
(28903, '2.40.128.330-FF-000014', NULL, 'Mitochondrial CorA family metal ion transporter (Eurofung)', 76, NULL, NULL, 28903),
(28904, '2.160.20.10-FF-000270', NULL, 'Putative beta-1,3 exoglucanase', 339, NULL, NULL, 28904);
INSERT INTO "PUBLIC"."MODEL" VALUES
(28905, '1.25.40.10-FF-000926', NULL, 'Anaphase-promoting complex subunit CDC23', 124, NULL, NULL, 28905),
(28906, '3.30.200.20-FF-002128', NULL, 'Uncharacterized protein', 72, NULL, NULL, 28906),
(28907, '3.40.50.10860-FF-000019', NULL, 'Quinate pathway repressor protein QutR', 107, NULL, NULL, 28907),
(28908, '1.10.540.10-FF-000089', NULL, 'Acyl-coenzyme A oxidase', 114, NULL, NULL, 28908),
(28909, '1.25.10.10-FF-002128', NULL, 'Coatomer subunit gamma', 201, NULL, NULL, 28909),
(28910, '3.30.70.3030-FF-000012', NULL, 'Nucleolar protein 6', 139, NULL, NULL, 28910),
(28911, '1.20.1260.10-FF-000030', NULL, 'Ferritin', 216, NULL, NULL, 28911),
(28912, '3.40.395.10-FF-000028', NULL, 'Uncharacterized protein', 128, NULL, NULL, 28912),
(28913, '3.90.70.200-FF-000020', NULL, 'YALI0D01892p', 129, NULL, NULL, 28913),
(28914, '3.10.110.10-FF-000313', NULL, 'Uncharacterized protein', 70, NULL, NULL, 28914),
(28915, '1.20.120.1050-FF-000002', NULL, 'Nuclear pore complex subunit', 167, NULL, NULL, 28915),
(28916, '1.10.510.10-FF-002184', NULL, 'Serine/threonine-protein kinase, putative', 237, NULL, NULL, 28916),
(28917, '3.90.175.10-FF-000006', NULL, 'Exotoxin A', 207, NULL, NULL, 28917),
(28918, '1.10.1450.10-FF-000148', NULL, 'Uncharacterized protein', 121, NULL, NULL, 28918),
(28919, '3.90.550.10-FF-000570', NULL, 'Predicted protein', 32, NULL, NULL, 28919),
(28920, '1.25.40.10-FF-004294', NULL, 'Pentatricopeptide repeat-containing protein At1g31790', 199, NULL, NULL, 28920),
(28921, '3.40.850.10-FF-000412', NULL, 'Uncharacterized protein', 246, NULL, NULL, 28921),
(28922, '3.20.190.10-FF-000023', NULL, 'Uncharacterized protein', 162, NULL, NULL, 28922),
(28923, '3.30.160.60-FF-000591', NULL, 'Zinc finger protein 536', 64, NULL, NULL, 28923),
(28924, '1.20.120.330-FF-000015', NULL, 'Lincosamide nucleotidyltransferase', 130, NULL, NULL, 28924),
(28925, '2.60.40.10-FF-000495', NULL, 'Periplasmic beta-glucosidase', 124, NULL, NULL, 28925),
(28926, '1.25.40.10-FF-004642', NULL, 'Uncharacterized protein', 125, NULL, NULL, 28926),
(28927, '3.40.50.300-FF-006274', NULL, 'Mitochondrial Rho GTPase', 126, NULL, NULL, 28927),
(28928, '3.30.70.330-FF-002023', NULL, NULL, 138, NULL, NULL, 28928),
(28929, '1.10.10.10-FF-000694', NULL, 'DNA-directed RNA polymerase III subunit RPC3', 89, NULL, NULL, 28929),
(28930, '2.130.10.10-FF-004851', NULL, 'Uncharacterized protein', 129, NULL, NULL, 28930),
(28931, '3.40.190.10-FF-000833', NULL, 'Putative nitrate transporter', 130, NULL, NULL, 28931),
(28932, '1.25.10.10-FF-001959', NULL, 'YALI0D22520p', 238, NULL, NULL, 28932),
(28933, '3.40.50.300-FF-008398', NULL, 'Uncharacterized protein', 179, NULL, NULL, 28933),
(28934, '2.40.30.10-FF-000484', NULL, 'NADH-cytochrome b5 reductase', 42, NULL, NULL, 28934),
(28935, '3.40.50.150-FF-000568', NULL, 'Leucine carboxyl methyltransferase 1', 327, NULL, NULL, 28935),
(28936, '3.10.20.90-FF-000837', NULL, 'Uncharacterized protein', 91, NULL, NULL, 28936),
(28937, '2.60.120.260-FF-000293', NULL, 'Beta-galactosidase', 91, NULL, NULL, 28937),
(28938, '1.20.1730.10-FF-000111', NULL, 'Uncharacterized protein', 171, NULL, NULL, 28938),
(28939, '2.120.10.80-FF-000196', NULL, 'Kelch repeat-containing protein', 70, NULL, NULL, 28939),
(28940, '3.40.640.10-FF-000357', NULL, 'Pyridoxal phosphate (PLP)-dependent transferases superfamily protein', 197, NULL, NULL, 28940),
(28941, '3.40.390.10-FF-000040', NULL, 'Metalloendopeptidase', 230, NULL, NULL, 28941),
(28942, '1.10.287.110-FF-000389', NULL, 'DNAJ heat shock family protein', 74, NULL, NULL, 28942),
(28943, '1.20.1070.10-FF-002011', NULL, 'G-protein-linked acetylcholine receptor gar-2A, putative', 139, NULL, NULL, 28943),
(28944, '2.130.10.10-FF-003221', NULL, 'Flagellar associated protein', 310, NULL, NULL, 28944),
(28945, '1.10.10.10-FF-000812', NULL, 'MarR family transcriptional regulator', 139, NULL, NULL, 28945),
(28946, '2.130.10.10-FF-000580', NULL, 'Guanine nucleotide-binding protein subunit beta', 370, NULL, NULL, 28946),
(28947, '3.30.230.10-FF-000143', NULL, 'Ribonuclease P protein component', 137, NULL, NULL, 28947);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(28948, '3.40.50.300-FF-007797', NULL, 'Uncharacterized protein', 45, NULL, NULL, 28948),
(28949, '1.10.630.10-FF-000669', NULL, 'Cytochrome P450, putative', 180, NULL, NULL, 28949),
(28950, '3.40.850.10-FF-000064', NULL, 'Kinesin-like protein', 367, NULL, NULL, 28950),
(28951, '1.10.1420.10-FF-000197', NULL, 'Uncharacterized protein', 118, NULL, NULL, 28951),
(28952, '3.40.50.1000-FF-000575', NULL, NULL, 123, NULL, NULL, 28952),
(28953, '1.20.58.760-FF-000026', NULL, 'ATP-dependent zinc metalloprotease FtsH', 196, NULL, NULL, 28953),
(28954, '1.20.5.190-FF-000171', NULL, NULL, 46, NULL, NULL, 28954),
(28955, '1.10.1420.10-FF-000208', NULL, 'Uncharacterized protein', 174, NULL, NULL, 28955),
(28956, '1.25.40.10-FF-002495', NULL, 'Pentatricopeptide repeat-containing protein At1g62720', 71, NULL, NULL, 28956),
(28957, '3.30.70.1560-FF-000009', NULL, 'Pseudouridine synthase', 85, NULL, NULL, 28957),
(28958, '3.60.10.10-FF-000030', NULL, 'DNA-(apurinic or apyrimidinic site) lyase', 311, NULL, NULL, 28958),
(28959, '1.10.510.10-FF-004196', NULL, NULL, 226, NULL, NULL, 28959),
(28960, '2.60.120.10-FF-000784', NULL, 'Uncharacterized protein', 153, NULL, NULL, 28960),
(28961, '1.25.40.10-FF-001894', NULL, 'Peroxisomal biogenesis factor 5', 124, NULL, NULL, 28961),
(28962, '2.130.10.10-FF-000473', NULL, 'Phosphoinositide 3-kinase regulatory subunit 4', 185, NULL, NULL, 28962),
(28963, '1.25.10.10-FF-000436', NULL, 'Cullin binding protein CanA', 1215, NULL, NULL, 28963),
(28964, '3.30.920.20-FF-000002', NULL, 'dystonin isoform X1', 101, NULL, NULL, 28964),
(28965, '2.60.40.10-FF-002737', NULL, 'Receptor-type tyrosine-protein phosphatase beta', 109, NULL, NULL, 28965),
(28966, '1.20.1260.60-FF-000011', NULL, 'Regulator of Vps4 activity in the MVB pathway protein', 158, NULL, NULL, 28966),
(28967, '3.30.70.3490-FF-000021', NULL, 'Unplaced genomic scaffold supercont1.13, whole genome shotgun sequence', 84, NULL, NULL, 28967),
(28968, '2.60.40.1860-FF-000008', NULL, 'Peptidylarginine deiminase type III', 119, NULL, NULL, 28968),
(28969, '3.30.559.30-FF-000058', NULL, 'Plipastatin synthase subunit A', 270, NULL, NULL, 28969),
(28970, '3.40.50.300-FF-000872', NULL, 'Twitching motility protein PilT', 244, NULL, NULL, 28970),
(28971, '2.30.29.30-FF-001347', NULL, 'Predicted protein', 140, NULL, NULL, 28971),
(28972, '1.10.510.10-FF-000941', NULL, 'Guanylate cyclase', 318, NULL, NULL, 28972),
(28973, '3.40.50.880-FF-000219', NULL, 'Predicted protein', 139, NULL, NULL, 28973),
(28974, '1.10.10.1760-FF-000001', NULL, '60S ribosomal protein L36', 106, NULL, NULL, 28974),
(28975, '3.90.980.20-FF-000037', NULL, NULL, 157, NULL, NULL, 28975),
(28976, '1.10.100.10-FF-000005', NULL, 'Insulin, isoform 2', 61, NULL, NULL, 28976),
(28977, '1.10.10.1770-FF-000004', NULL, 'Ycf53-like protein', 79, NULL, NULL, 28977),
(28978, '2.130.10.10-FF-004744', NULL, 'Uncharacterized protein', 161, NULL, NULL, 28978),
(28979, '2.60.40.10-FF-001214', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', 92, NULL, NULL, 28979),
(28980, '3.30.70.270-FF-000060', NULL, 'Diguanylate cyclase', 172, NULL, NULL, 28980),
(28981, '1.10.220.10-FF-000059', NULL, 'Annexin', 80, NULL, NULL, 28981),
(28982, '3.30.750.24-FF-000050', NULL, 'Anti-sigma F factor antagonist', 106, NULL, NULL, 28982),
(28983, '2.60.40.1850-FF-000005', NULL, 'Sortase B protein-sorting domain-containing protein', 152, NULL, NULL, 28983),
(28984, '3.10.110.10-FF-000318', NULL, 'Uncharacterized protein', 54, NULL, NULL, 28984),
(28985, '3.40.50.300-FF-006381', NULL, 'Uncharacterized protein', 280, NULL, NULL, 28985),
(28986, '3.30.40.10-FF-002360', NULL, 'Ubiquitinyl hydrolase 1', 126, NULL, NULL, 28986),
(28987, '1.20.58.900-FF-000001', NULL, 'RUN and FYVE domain containing 2', 178, NULL, NULL, 28987),
(28988, '1.10.418.10-FF-000097', NULL, 'Microtubule-associated protein EB1', 127, NULL, NULL, 28988),
(28989, '2.60.40.1840-FF-000002', NULL, 'Aminopeptidase N', 101, NULL, NULL, 28989),
(28990, '3.30.559.10-FF-000052', NULL, 'Nonribosomal peptide synthase SidE', 179, NULL, NULL, 28990);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(28991, '3.90.70.10-FF-000785', NULL, 'Uncharacterized protein', 346, NULL, NULL, 28991),
(28992, '1.10.1450.10-FF-000143', NULL, 'Tetraspanin', 92, NULL, NULL, 28992),
(28993, '1.10.3430.10-FF-000041', NULL, 'Rh blood group antigen', 93, NULL, NULL, 28993),
(28994, '1.10.730.10-FF-000143', NULL, 'Arginine--tRNA ligase', 124, NULL, NULL, 28994),
(28995, '1.25.40.10-FF-001787', NULL, 'Os01g0959600 protein', 103, NULL, NULL, 28995),
(28996, '2.10.110.10-FF-000283', NULL, 'Predicted protein', 58, NULL, NULL, 28996),
(28997, '3.90.550.50-FF-000227', NULL, 'Uncharacterized protein F37A4.3', 125, NULL, NULL, 28997),
(28998, '3.90.1150.10-FF-000072', NULL, 'Serine hydroxymethyltransferase', 153, NULL, NULL, 28998),
(28999, '4.10.60.10-FF-000016', NULL, 'Cellular nucleic acid-binding protein', 49, NULL, NULL, 28999),
(29000, '1.20.1250.20-FF-002112', NULL, 'Fucosyltransferase, putative', 230, NULL, NULL, 29000),
(29001, '3.10.100.10-FF-000037', NULL, 'C-type lectin domain family 18 member A-like', 140, NULL, NULL, 29001),
(29002, '1.10.533.10-FF-000292', NULL, 'Predicted protein', 87, NULL, NULL, 29002),
(29003, '3.40.50.170-FF-000001', NULL, 'Formyltetrahydrofolate deformylase', 197, NULL, NULL, 29003),
(29004, '3.30.70.120-FF-000043', NULL, NULL, 73, NULL, NULL, 29004),
(29005, '1.20.890.10-FF-000028', NULL, 'AGAP008525-PA', 45, NULL, NULL, 29005),
(29006, '3.30.479.30-FF-000006', NULL, 'SPFH/Band 7/PHB domain protein', 133, NULL, NULL, 29006),
(29007, '3.30.200.20-FF-002454', NULL, 'Uncharacterized protein', 57, NULL, NULL, 29007),
(29008, '3.30.60.10-FF-000012', NULL, NULL, 69, NULL, NULL, 29008),
(29009, '3.30.160.60-FF-003120', NULL, 'GM04789p', 29, NULL, NULL, 29009),
(29010, '1.20.58.1290-FF-000004', NULL, 'CarD-like protein', 98, NULL, NULL, 29010),
(29011, '3.80.10.10-FF-001838', NULL, 'Hypothetical_protein_-_conserved', 118, NULL, NULL, 29011),
(29012, '3.90.470.20-FF-000072', NULL, 'L-aminoadipate-semialdehyde dehydrogenase-phosphopantetheinyl transferase', 114, NULL, NULL, 29012),
(29013, '2.60.40.10-FF-001107', NULL, 'Defective proboscis extension response', 94, NULL, NULL, 29013),
(29014, '3.40.30.10-FF-001044', NULL, 'Iodothyronine deiodinase', 188, NULL, NULL, 29014),
(29015, '4.10.60.10-FF-000123', NULL, 'Cellular nucleic acid binding protein 2', 26, NULL, NULL, 29015),
(29016, '2.130.10.10-FF-001996', NULL, 'Connector of kinase to AP-1, isoform A', 180, NULL, NULL, 29016),
(29017, '3.10.100.10-FF-000144', NULL, 'RE45003p', 154, NULL, NULL, 29017),
(29018, '1.10.533.10-FF-000185', NULL, 'Uncharacterized protein', 93, NULL, NULL, 29018),
(29019, '2.60.40.150-FF-000397', NULL, 'C2 domain-containing protein', 136, NULL, NULL, 29019),
(29020, '1.20.58.1280-FF-000001', NULL, 'DNA repair protein REV1', 100, NULL, NULL, 29020),
(29021, '3.30.200.20-FF-002347', NULL, 'Uncharacterized protein', 52, NULL, NULL, 29021),
(29022, '1.25.10.10-FF-002667', NULL, 'Predicted protein', 92, NULL, NULL, 29022),
(29023, '1.20.920.60-FF-000001', NULL, 'Cytoplasmic dynein 1 heavy chain 1', 211, NULL, NULL, 29023),
(29024, '3.90.1150.10-FF-000291', NULL, 'Aminotransferase, class V family protein', 115, NULL, NULL, 29024),
(29025, '2.70.70.10-FF-000007', NULL, 'Stage IV sporulation protein FA', 129, NULL, NULL, 29025),
(29026, '3.40.50.1580-FF-000029', NULL, 'S-methyl-5''-thioadenosine phosphorylase', 233, NULL, NULL, 29026),
(29027, '1.25.10.10-FF-000543', NULL, 'Armadillo repeat only 2', 171, NULL, NULL, 29027),
(29028, '3.40.50.300-FF-007212', NULL, 'Gluconokinase', 165, NULL, NULL, 29028),
(29029, '1.10.238.10-FF-000908', NULL, 'Putative calmodulin-related protein', 97, NULL, NULL, 29029),
(29030, '1.10.510.10-FF-002846', NULL, 'Protein kinase, putative', 332, NULL, NULL, 29030),
(29031, '1.25.40.10-FF-002169', NULL, 'TPR Domain containing protein', 116, NULL, NULL, 29031),
(29032, '3.90.226.10-FF-000322', NULL, 'E3 ubiquitin-protein ligase HOS1', 199, NULL, NULL, 29032),
(29033, '3.30.1360.70-FF-000029', NULL, NULL, 109, NULL, NULL, 29033),
(29034, '2.130.10.10-FF-002378', NULL, 'WD domain, G-beta repeat, putative', 71, NULL, NULL, 29034);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(29035, '3.90.70.10-FF-000566', NULL, 'Uncharacterized protein', 166, NULL, NULL, 29035),
(29036, '3.40.225.10-FF-000022', NULL, 'Probable bifunctional methylthioribulose-1-phosphate dehydratase/enolase-phosphatase E1', 96, NULL, NULL, 29036),
(29037, '1.10.472.10-FF-000722', NULL, 'Uncharacterized protein', 112, NULL, NULL, 29037),
(29038, '3.30.200.20-FF-000330', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase At4g03230', 111, NULL, NULL, 29038),
(29039, '3.10.129.10-FF-000120', NULL, 'Fox2p', 154, NULL, NULL, 29039),
(29040, '2.130.10.10-FF-001889', NULL, 'Small nucleolar ribonucleoprotein complex subunit, putative (AFU_orthologue AFUA_4G07540)', 100, NULL, NULL, 29040),
(29041, '3.90.70.40-FF-000002', NULL, 'josephin-1 isoform X2', 134, NULL, NULL, 29041),
(29042, '3.30.530.20-FF-000186', NULL, 'Uncharacterized protein', 89, NULL, NULL, 29042),
(29043, '1.10.238.10-FF-000678', NULL, 'Uncharacterized protein', 52, NULL, NULL, 29043),
(29044, '2.60.120.920-FF-000199', NULL, 'Uncharacterized protein', 68, NULL, NULL, 29044),
(29045, '3.40.50.2300-FF-000201', NULL, 'Histidine kinase 5', 156, NULL, NULL, 29045),
(29046, '4.10.1040.10-FF-000002', NULL, 'Putative transcription factor MAB-23', 49, NULL, NULL, 29046),
(29047, '2.130.10.10-FF-003002', NULL, 'YALI0E00506p', 189, NULL, NULL, 29047),
(29048, '3.30.1360.10-FF-000039', NULL, 'DNA-directed RNA polymerase subunit alpha', 32, NULL, NULL, 29048),
(29049, '3.40.50.150-FF-000894', NULL, NULL, 32, NULL, NULL, 29049),
(29050, '3.40.50.920-FF-000041', NULL, 'Transketolase', 138, NULL, NULL, 29050),
(29051, '3.30.497.10-FF-000065', NULL, 'Serine (or cysteine) peptidase inhibitor, clade B, member 6e', 214, NULL, NULL, 29051),
(29052, '3.30.450.20-FF-000134', NULL, 'Fis family transcriptional regulator', 106, NULL, NULL, 29052),
(29053, '1.10.132.50-FF-000001', NULL, 'V-type proton ATPase subunit', 102, NULL, NULL, 29053),
(29054, '3.40.50.300-FF-003401', NULL, 'Protein CBR-CNT-2', 185, NULL, NULL, 29054),
(29055, '3.30.420.40-FF-000083', NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', 147, NULL, NULL, 29055),
(29056, '2.40.30.10-FF-000265', NULL, 'NADH-cytochrome b5 reductase-like', 57, NULL, NULL, 29056),
(29057, '3.50.7.10-FF-000013', NULL, 'T-complex protein 1 subunit zeta', 168, NULL, NULL, 29057),
(29058, '3.10.580.20-FF-000002', NULL, 'Chloride channel protein', 87, NULL, NULL, 29058),
(29059, '1.20.5.320-FF-000024', NULL, 'MBL', 48, NULL, NULL, 29059),
(29060, '2.30.42.10-FF-000124', NULL, 'DEP domain-containing mTOR-interacting protein isoform X1', 87, NULL, NULL, 29060),
(29061, '3.40.50.1000-FF-000356', NULL, 'Phospholipid-transporting P-type ATPase, putative', 164, NULL, NULL, 29061),
(29062, '3.40.850.10-FF-000171', NULL, 'Chromosome-associated kinesin KIF4A, putative', 308, NULL, NULL, 29062),
(29063, '3.30.930.10-FF-000298', NULL, 'Phenylalanine--tRNA ligase beta subunit', 198, NULL, NULL, 29063),
(29064, '1.25.40.10-FF-004535', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 58, NULL, NULL, 29064),
(29065, '3.90.260.10-FF-000036', NULL, 'Transglutaminase 5,-like', 110, NULL, NULL, 29065),
(29066, '3.40.50.80-FF-000172', NULL, 'Uncharacterized protein', 132, NULL, NULL, 29066),
(29067, '3.30.160.60-FF-000832', NULL, 'sal-like protein 2 isoform X2', 75, NULL, NULL, 29067),
(29068, '1.25.40.10-FF-004316', NULL, 'Uncharacterized protein', 177, NULL, NULL, 29068),
(29069, '3.20.20.100-FF-000170', NULL, 'Oxidoreductase, aldo/keto reductase family protein', 175, NULL, NULL, 29069),
(29070, '3.40.366.10-FF-000040', NULL, 'Malonyl CoA-acyl carrier protein transacylase', 207, NULL, NULL, 29070),
(29071, '3.30.740.10-FF-000013', NULL, 'Dynein light chain', 98, NULL, NULL, 29071),
(29072, '3.90.190.20-FF-000027', NULL, 'Folylpolyglutamate synthetase', 146, NULL, NULL, 29072),
(29073, '3.40.50.300-FF-008179', NULL, 'Os11g0707100 protein', 82, NULL, NULL, 29073),
(29074, '3.40.1620.70-FF-000002', NULL, 'Collagen alpha 1 (XV) chain', 43, NULL, NULL, 29074),
(29075, '1.25.10.10-FF-000762', NULL, 'HEAT repeat domain containing protein', 514, NULL, NULL, 29075);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(29076, '1.20.190.40-FF-000006', NULL, 'Major DNA-binding protein', 128, NULL, NULL, 29076),
(29077, '3.30.70.580-FF-000046', NULL, 'tRNA pseudouridine synthase', 120, NULL, NULL, 29077),
(29078, '2.130.10.10-FF-004632', NULL, 'Os12g0129400 protein', 195, NULL, NULL, 29078),
(29079, '3.90.1380.10-FF-000004', NULL, 'Threonine synthase like 2', 55, NULL, NULL, 29079),
(29080, '3.30.40.10-FF-001652', NULL, 'DNA repair protein RAD5A', 60, NULL, NULL, 29080),
(29081, '2.60.260.20-FF-000044', NULL, 'DnaJ protein, putative', 96, NULL, NULL, 29081),
(29082, '3.30.40.10-FF-000117', NULL, 'Probable E3 ubiquitin-protein ligase makorin-1', 108, NULL, NULL, 29082),
(29083, '2.60.40.10-FF-004873', NULL, NULL, 144, NULL, NULL, 29083),
(29084, '3.90.1150.10-FF-000302', NULL, 'Kynureninase', 125, NULL, NULL, 29084),
(29085, '1.20.5.3790-FF-000001', NULL, 'Cellulose synthase operon protein D', 44, NULL, NULL, 29085),
(29086, '3.40.50.300-FF-006493', NULL, 'Os11g0490800 protein', 114, NULL, NULL, 29086),
(29087, '3.40.50.300-FF-008409', NULL, 'ATP-dependent DEAD/H RNA helicase, putative', 157, NULL, NULL, 29087),
(29088, '2.20.130.20-FF-000015', NULL, 'Thiolester containing protein 2', 86, NULL, NULL, 29088),
(29089, '3.90.1480.20-FF-000066', NULL, 'Alpha-2,3-sialyltransferase', 144, NULL, NULL, 29089),
(29090, '1.20.120.1880-FF-000003', NULL, 'nuclear pore complex protein Nup155', 220, NULL, NULL, 29090),
(29091, '1.25.40.10-FF-000264', NULL, 'Tetratricopeptide repeat protein 9A', 167, NULL, NULL, 29091),
(29092, '1.10.510.10-FF-002291', NULL, NULL, 80, NULL, NULL, 29092),
(29093, '2.40.10.10-FF-000382', NULL, NULL, 97, NULL, NULL, 29093),
(29094, '3.30.870.10-FF-000129', NULL, 'Tyrosyl-DNA Phosphodiesterase (Tdp1), putative', 213, NULL, NULL, 29094),
(29095, '2.40.50.140-FF-000215', NULL, 'Exosome complex component RRP40, putative', 78, NULL, NULL, 29095),
(29096, '1.10.510.10-FF-000615', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase', 203, NULL, NULL, 29096),
(29097, '3.60.120.10-FF-000004', NULL, 'Aminodeoxychorismate synthase, component I', 452, NULL, NULL, 29097),
(29098, '1.20.1250.20-FF-002000', NULL, 'Sucrose transport protein, putative', 381, NULL, NULL, 29098),
(29099, '1.10.150.240-FF-000081', NULL, 'Protein CBG24156', 70, NULL, NULL, 29099),
(29100, '3.40.190.10-FF-000614', NULL, 'ATP phosphoribosyltransferase', 119, NULL, NULL, 29100),
(29101, '2.170.140.10-FF-000062', NULL, 'Chitinase', 61, NULL, NULL, 29101),
(29102, '3.30.420.40-FF-000638', NULL, 'Carbamoyltransferase', 106, NULL, NULL, 29102),
(29103, '2.130.10.10-FF-002608', NULL, 'Uncharacterized protein', 321, NULL, NULL, 29103),
(29104, '3.30.160.60-FF-002849', NULL, 'Si:dkey-16b10.2', 28, NULL, NULL, 29104),
(29105, '3.30.70.3330-FF-000001', NULL, 'Fatty acid synthase subunit beta dehydratase', 128, NULL, NULL, 29105),
(29106, '1.10.290.10-FF-000007', NULL, 'DNA topoisomerase 1', 90, NULL, NULL, 29106),
(29107, '2.120.10.80-FF-000314', NULL, 'Mei4-dependent protein 6', 174, NULL, NULL, 29107),
(29108, '3.30.70.3340-FF-000004', NULL, 'Anaerobic sulfite reductase subunit C', 83, NULL, NULL, 29108),
(29109, '2.60.40.630-FF-000013', NULL, 'Signal transducer and activator of transcription', 93, NULL, NULL, 29109),
(29110, '3.30.56.10-FF-000007', NULL, 'Phenylalanine--tRNA ligase beta subunit', 89, NULL, NULL, 29110),
(29111, '4.10.60.10-FF-000235', NULL, 'Uncharacterized protein', 53, NULL, NULL, 29111),
(29112, '1.10.10.10-FF-000705', NULL, 'Hypothetical_protein', 91, NULL, NULL, 29112),
(29113, '3.40.50.12780-FF-000140', NULL, 'Acetyl-CoA synthetase (Acetate-CoA ligase) amino-end (AcsA-4)', 267, NULL, NULL, 29113),
(29114, '2.60.40.150-FF-000285', NULL, 'C2 domain-containing protein', 147, NULL, NULL, 29114),
(29115, '1.20.1000.10-FF-000039', NULL, NULL, 237, NULL, NULL, 29115),
(29116, '1.10.10.1320-FF-000004', NULL, 'Transcriptional activator ChrR', 107, NULL, NULL, 29116),
(29117, '2.40.70.10-FF-000374', NULL, NULL, 199, NULL, NULL, 29117),
(29118, '3.30.830.10-FF-000239', NULL, 'Predicted protein', 220, NULL, NULL, 29118);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(29119, '3.10.100.10-FF-000363', NULL, NULL, 152, NULL, NULL, 29119),
(29120, '2.70.170.10-FF-000234', NULL, 'Uncharacterized protein', 79, NULL, NULL, 29120),
(29121, '2.10.110.10-FF-000064', NULL, 'Four and a half LIM domains protein 3', 64, NULL, NULL, 29121),
(29122, '1.50.10.20-FF-000015', NULL, 'Terpene cyclase/mutase family member', 233, NULL, NULL, 29122),
(29123, '1.25.40.20-FF-000267', NULL, 'Ankyrin repeat and SOCS box containing 14', 197, NULL, NULL, 29123),
(29124, '1.20.140.40-FF-000060', NULL, NULL, 114, NULL, NULL, 29124),
(29125, '2.60.40.10-FF-001799', NULL, 'Platelet and endothelial cell adhesion molecule 1', 96, NULL, NULL, 29125),
(29126, '3.80.10.10-FF-003188', NULL, 'Toll-like receptor 9', 236, NULL, NULL, 29126),
(29127, '3.80.10.10-FF-002002', NULL, 'Leucine-rich receptor-like protein kinase family protein', 59, NULL, NULL, 29127),
(29128, '1.20.190.50-FF-000009', NULL, 'Nuclear pore complex protein', 256, NULL, NULL, 29128),
(29129, '3.30.60.20-FF-000127', NULL, 'Uncharacterized protein', 63, NULL, NULL, 29129),
(29130, '3.30.40.10-FF-002141', NULL, 'RBR-type E3 ubiquitin transferase', 78, NULL, NULL, 29130),
(29131, '1.10.3130.10-FF-000001', NULL, 'Acetyltransferase', 142, NULL, NULL, 29131),
(29132, '3.40.50.150-FF-000349', NULL, 'Methyltransferase domain containing protein', 205, NULL, NULL, 29132),
(29133, '3.30.70.330-FF-002702', NULL, NULL, 164, NULL, NULL, 29133),
(29134, '1.10.20.10-FF-000189', NULL, 'Uncharacterized protein', 87, NULL, NULL, 29134),
(29135, '2.40.20.10-FF-000096', NULL, 'Uncharacterized protein', 151, NULL, NULL, 29135),
(29136, '2.40.50.40-FF-000134', NULL, 'Predicted protein', 55, NULL, NULL, 29136),
(29137, '1.10.287.110-FF-000277', NULL, 'Fe-S protein assembly co-chaperone HscB', 135, NULL, NULL, 29137),
(29138, '2.170.130.10-FF-000022', NULL, 'Ligand-gated channel', 124, NULL, NULL, 29138),
(29139, '1.20.1070.10-FF-001847', NULL, 'Uncharacterized protein', 299, NULL, NULL, 29139),
(29140, '3.90.550.10-FF-000569', NULL, 'Uncharacterized protein', 38, NULL, NULL, 29140),
(29141, '2.60.120.260-FF-000523', NULL, 'Uncharacterized protein', 118, NULL, NULL, 29141),
(29142, '3.40.50.300-FF-008286', NULL, 'Uncharacterized protein', 31, NULL, NULL, 29142),
(29143, '1.20.1250.20-FF-002331', NULL, 'Uncharacterized protein', 163, NULL, NULL, 29143),
(29144, '2.30.30.360-FF-000004', NULL, 'Chick atrial myosin heavy chain', 48, NULL, NULL, 29144),
(29145, '1.25.10.10-FF-000981', NULL, 'ARM repeat superfamily protein', 168, NULL, NULL, 29145),
(29146, '3.30.450.70-FF-000014', NULL, 'Trafficking protein particle complex subunit 4', 145, NULL, NULL, 29146),
(29147, '3.40.50.1820-FF-001776', NULL, 'Uncharacterized protein', 189, NULL, NULL, 29147),
(29148, '2.170.150.10-FF-000017', NULL, 'Chromosome 1, whole genome shotgun sequence', 193, NULL, NULL, 29148),
(29149, '1.20.1510.10-FF-000016', NULL, 'Zinc transporter ZitB', 200, NULL, NULL, 29149),
(29150, '2.120.10.80-FF-000084', NULL, 'Leucine carboxyl methyltransferase 2', 234, NULL, NULL, 29150),
(29151, '3.30.160.60-FF-004429', NULL, NULL, 35, NULL, NULL, 29151),
(29152, '3.10.50.10-FF-000006', NULL, 'Chitobiase, di-N-acetyl-', 75, NULL, NULL, 29152),
(29153, '1.25.40.10-FF-004530', NULL, 'General transcriptional corepressor ssn6', 65, NULL, NULL, 29153),
(29154, '1.10.1740.100-FF-000007', NULL, 'Histone-lysine N-methyltransferase', 112, NULL, NULL, 29154),
(29155, '2.20.70.10-FF-000212', NULL, 'Membrane-associated guanylate kinase, WW and PDZ domain-containing 3b', 19, NULL, NULL, 29155),
(29156, '3.80.10.10-FF-001619', NULL, 'SCF E3 ubiquitin ligase complex F-box protein grrA', 112, NULL, NULL, 29156),
(29157, '3.40.1370.10-FF-000038', NULL, '50S ribosomal protein L4', 209, NULL, NULL, 29157),
(29158, '3.40.50.1440-FF-000134', NULL, 'Uncharacterized protein', 139, NULL, NULL, 29158),
(29159, '2.60.120.260-FF-000181', NULL, 'Neuroendocrine convertase 2', 135, NULL, NULL, 29159),
(29160, '2.130.10.10-FF-001304', NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', 77, NULL, NULL, 29160);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(29161, '3.90.780.10-FF-000053', NULL, 'Uncharacterized protein', 86, NULL, NULL, 29161),
(29162, '1.20.1070.10-FF-002123', NULL, 'Uncharacterized protein', 289, NULL, NULL, 29162),
(29163, '2.60.40.10-FF-000383', NULL, 'CD166 antigen isoform X1', 106, NULL, NULL, 29163),
(29164, '1.10.1070.11-FF-000047', NULL, 'Serine/threonine-protein kinase ATR', 188, NULL, NULL, 29164),
(29165, '1.25.40.10-FF-002618', NULL, 'Hsc70-interacting protein (Hip), putative', 170, NULL, NULL, 29165),
(29166, '1.20.1110.10-FF-000267', NULL, NULL, 110, NULL, NULL, 29166),
(29167, '3.30.160.60-FF-001540', NULL, 'zinc finger protein 483 isoform X2', 28, NULL, NULL, 29167),
(29168, '3.90.660.20-FF-000002', NULL, 'Protoporphyrinogen oxidase', 212, NULL, NULL, 29168),
(29169, '1.10.2020.20-FF-000001', NULL, 'Proteasomal ubiquitin receptor ADRM1', 121, NULL, NULL, 29169),
(29170, '1.10.3430.10-FF-000046', NULL, 'Uncharacterized protein', 425, NULL, NULL, 29170),
(29171, '1.10.30.50-FF-000016', NULL, 'Uncharacterized protein', 88, NULL, NULL, 29171),
(29172, '3.30.43.10-FF-000040', NULL, 'L-gulonolactone oxidase 2', 74, NULL, NULL, 29172),
(29173, '3.10.28.10-FF-000067', NULL, 'Cytochrome b mRNA maturase bI3', 117, NULL, NULL, 29173),
(29174, '2.130.10.10-FF-000692', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 201, NULL, NULL, 29174),
(29175, '2.30.29.30-FF-000043', NULL, 'FERM domain-containing protein 5', 93, NULL, NULL, 29175),
(29176, '3.30.70.3490-FF-000026', NULL, 'Oxysterol binding protein', 104, NULL, NULL, 29176),
(29177, '2.60.40.150-FF-000627', NULL, 'Synaptotagmin 1e', 141, NULL, NULL, 29177),
(29178, '2.30.30.40-FF-000572', NULL, 'Variant SH3 domain containing protein', 87, NULL, NULL, 29178),
(29179, '1.20.1070.10-FF-001499', NULL, 'Uncharacterized protein', 199, NULL, NULL, 29179),
(29180, '3.40.50.11810-FF-000001', NULL, 'H(2):CoB-CoM heterodisulfide,ferredoxin reductase subunit B', 131, NULL, NULL, 29180),
(29181, '3.40.1810.10-FF-000067', NULL, NULL, 37, NULL, NULL, 29181),
(29182, '1.10.238.10-FF-000459', NULL, 'Probable calcium-binding protein CML16', 96, NULL, NULL, 29182),
(29183, '4.10.1240.30-FF-000001', NULL, 'Integrin beta', 85, NULL, NULL, 29183),
(29184, '3.40.50.300-FF-001361', NULL, 'AAA family ATPase', 185, NULL, NULL, 29184),
(29185, '1.20.1250.20-FF-001730', NULL, 'Uncharacterized protein', 204, NULL, NULL, 29185),
(29186, '1.10.472.10-FF-000503', NULL, 'Uncharacterized protein', 104, NULL, NULL, 29186),
(29187, '3.80.10.10-FF-003525', NULL, 'Uncharacterized protein', 171, NULL, NULL, 29187),
(29188, '2.60.40.10-FF-004654', NULL, NULL, 97, NULL, NULL, 29188),
(29189, '2.60.40.60-FF-000818', NULL, 'Cad74A isoform A family protein', 72, NULL, NULL, 29189),
(29190, '2.50.20.10-FF-000011', NULL, 'Outer-membrane lipoprotein LolB', 178, NULL, NULL, 29190),
(29191, '3.30.70.80-FF-000056', NULL, 'Subtilisin-like serine protease', 93, NULL, NULL, 29191),
(29192, '3.40.50.300-FF-004705', NULL, 'Cell division protein, putative', 269, NULL, NULL, 29192),
(29193, '1.20.1440.90-FF-000006', NULL, 'Phosphoenolpyruvate carboxylase', 127, NULL, NULL, 29193),
(29194, '3.30.200.20-FF-000088', NULL, 'Casein kinase II subunit alpha', 91, NULL, NULL, 29194),
(29195, '4.10.60.10-FF-000230', NULL, 'Uncharacterized protein', 55, NULL, NULL, 29195),
(29196, '3.40.50.2000-FF-000206', NULL, 'Trehalose-6-phosphate synthase', 218, NULL, NULL, 29196),
(29197, '2.60.40.10-FF-004761', NULL, NULL, 98, NULL, NULL, 29197),
(29198, '1.10.238.10-FF-000785', NULL, 'Uncharacterized protein', 70, NULL, NULL, 29198),
(29199, '1.10.10.60-FF-000681', NULL, 'NifA/NtrC family transcriptional regulator', 64, NULL, NULL, 29199),
(29200, '2.60.260.20-FF-000156', NULL, 'DnaJ-related protein spj1', 86, NULL, NULL, 29200),
(29201, '1.10.510.10-FF-002627', NULL, NULL, 79, NULL, NULL, 29201),
(29202, '3.40.50.1000-FF-000570', NULL, NULL, 211, NULL, NULL, 29202),
(29203, '3.30.200.20-FF-002561', NULL, 'AGC protein kinase', 49, NULL, NULL, 29203),
(29204, '3.30.70.330-FF-000662', NULL, 'Polyadenylated RNA binding protein', 96, NULL, NULL, 29204);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(29205, '3.40.350.10-FF-000043', NULL, 'GM24054', 152, NULL, NULL, 29205),
(29206, '1.25.10.10-FF-000874', NULL, 'Kinesin, putative', 275, NULL, NULL, 29206),
(29207, '3.30.540.10-FF-000032', NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', 204, NULL, NULL, 29207),
(29208, '4.10.1240.50-FF-000007', NULL, 'Z-linked MIER family member 3', 58, NULL, NULL, 29208),
(29209, '2.60.40.10-FF-000832', NULL, 'Platelet-derived growth factor receptor alpha', 118, NULL, NULL, 29209),
(29210, '3.40.50.300-FF-004357', NULL, 'Septum site-determining protein MinD', 232, NULL, NULL, 29210),
(29211, '1.25.40.10-FF-002276', NULL, 'Pentatricopeptide repeat-containing protein At1g26460, mitochondrial', 159, NULL, NULL, 29211),
(29212, '1.10.10.10-FF-002055', NULL, 'Two component signal transduction system controlling the osmosenstive K+ channel response regulator KdpE', 108, NULL, NULL, 29212),
(29213, '2.120.10.80-FF-000426', NULL, 'Serine/threonine-protein phosphatase BSL1 homolog', 243, NULL, NULL, 29213),
(29214, '2.120.10.80-FF-000191', NULL, 'Leucine zipper like transcription regulator 1', 155, NULL, NULL, 29214),
(29215, '2.20.25.30-FF-000006', NULL, 'Ribosomal protein L37', 88, NULL, NULL, 29215),
(29216, '3.30.1370.10-FF-000102', NULL, 'Cleavage and polyadenylation specificity factor subunit 4', 100, NULL, NULL, 29216),
(29217, '1.25.40.20-FF-000486', NULL, 'Ankyrin repeat family protein', 265, NULL, NULL, 29217),
(29218, '1.10.10.10-FF-001779', NULL, 'Vacuolar-sorting protein SNF8', 32, NULL, NULL, 29218),
(29219, '3.40.50.410-FF-000101', NULL, 'General transcription factor IIH subunit, putative', 234, NULL, NULL, 29219),
(29220, '3.40.50.720-FF-001841', NULL, 'Putative malate dehydrogenase 1B', 77, NULL, NULL, 29220),
(29221, '3.40.50.1000-FF-000794', NULL, NULL, 166, NULL, NULL, 29221),
(29222, '2.40.70.10-FF-000048', NULL, 'Napsin A aspartic peptidase', 184, NULL, NULL, 29222),
(29223, '3.80.10.10-FF-002221', NULL, 'Leucine Rich Repeat family protein', 118, NULL, NULL, 29223),
(29224, '2.60.120.200-FF-000207', NULL, 'Cadherin-related tumor suppressor', 184, NULL, NULL, 29224),
(29225, '3.80.10.10-FF-001390', NULL, 'Probable leucine-rich repeat receptor-like protein kinase At1g35710', 104, NULL, NULL, 29225),
(29226, '3.30.1740.20-FF-000010', NULL, '40S ribosomal protein S26', 93, NULL, NULL, 29226),
(29227, '2.60.40.10-FF-000490', NULL, 'Signal-regulatory protein beta 1', 103, NULL, NULL, 29227),
(29228, '3.80.10.10-FF-003183', NULL, 'Toll-like receptor 9', 243, NULL, NULL, 29228),
(29229, '1.10.510.10-FF-001323', NULL, 'PK3', 206, NULL, NULL, 29229),
(29230, '1.10.150.60-FF-000040', NULL, NULL, 110, NULL, NULL, 29230),
(29231, '1.10.510.10-FF-000834', NULL, 'SRSF protein kinase 2', 203, NULL, NULL, 29231),
(29232, '2.20.70.10-FF-000094', NULL, 'transcriptional coactivator YAP1 isoform X1', 31, NULL, NULL, 29232),
(29233, '2.60.40.10-FF-000725', NULL, 'Platelet-derived growth factor receptor alpha', 96, NULL, NULL, 29233),
(29234, '3.40.640.10-FF-000138', NULL, 'Histidinol-phosphate aminotransferase', 221, NULL, NULL, 29234),
(29235, '2.60.40.10-FF-003131', NULL, 'Striated muscle-enriched protein kinase a', 102, NULL, NULL, 29235),
(29236, '1.25.40.10-FF-000483', NULL, 'Transcription factor 25', 310, NULL, NULL, 29236),
(29237, '2.130.10.10-FF-004306', NULL, 'Defective in DNA methylation-9 protein', 114, NULL, NULL, 29237),
(29238, '1.20.200.10-FF-000005', NULL, 'Adenylosuccinate lyase', 225, NULL, NULL, 29238),
(29239, '1.10.238.10-FF-001061', NULL, 'EF hand family protein', 82, NULL, NULL, 29239),
(29240, '3.30.830.10-FF-000127', NULL, 'Clan ME, family M16, insulinase-like metallopeptidase', 254, NULL, NULL, 29240),
(29241, '3.80.10.10-FF-001945', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 296, NULL, NULL, 29241),
(29242, '3.30.40.10-FF-002253', NULL, 'Uncharacterized protein', 57, NULL, NULL, 29242),
(29243, '3.30.70.330-FF-002028', NULL, NULL, 48, NULL, NULL, 29243),
(29244, '1.10.20.10-FF-000077', NULL, 'Histone H3 variant', 130, NULL, NULL, 29244);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(29245, '1.10.3380.30-FF-000042', NULL, 'Uncharacterized protein', 105, NULL, NULL, 29245),
(29246, '3.40.50.880-FF-000096', NULL, 'Class I glutamine amidotransferase-like protein', 206, NULL, NULL, 29246),
(29247, '2.60.40.10-FF-004980', NULL, NULL, 109, NULL, NULL, 29247),
(29248, '1.20.1250.20-FF-000999', NULL, 'Solute carrier organic anion transporter family member', 268, NULL, NULL, 29248),
(29249, '1.10.1450.10-FF-000036', NULL, 'Tetraspanin', 80, NULL, NULL, 29249),
(29250, '2.40.50.90-FF-000020', NULL, 'A-kinase anchor protein 1, mitochondrial', 109, NULL, NULL, 29250),
(29251, '1.10.3170.10-FF-000003', NULL, 'RecBCD enzyme subunit RecB', 26, NULL, NULL, 29251),
(29252, '3.40.1770.10-FF-000012', NULL, 'Urocanate hydratase, putative', 94, NULL, NULL, 29252),
(29253, '3.40.50.2000-FF-000083', NULL, 'UDP-glycosyltransferase TURAN isoform X1', 196, NULL, NULL, 29253),
(29254, '3.40.50.300-FF-004924', NULL, 'Uncharacterized protein', 160, NULL, NULL, 29254),
(29255, '2.80.10.50-FF-000257', NULL, 'Predicted protein', 259, NULL, NULL, 29255),
(29256, '1.10.8.270-FF-000135', NULL, 'Uncharacterized protein', 126, NULL, NULL, 29256),
(29257, '3.30.160.60-FF-001214', NULL, 'Zinc finger with KRAB and SCAN domains 4', 33, NULL, NULL, 29257),
(29258, '3.30.70.330-FF-000443', NULL, 'RNA-binding protein, putative', 86, NULL, NULL, 29258),
(29259, '1.10.400.10-FF-000045', NULL, 'G-protein subunit alpha 7', 119, NULL, NULL, 29259),
(29260, '3.40.50.2000-FF-000425', NULL, 'Trehalose-6-phosphate synthase3', 262, NULL, NULL, 29260),
(29261, '2.60.40.150-FF-000408', NULL, 'Uncharacterized protein', 147, NULL, NULL, 29261),
(29262, '1.25.50.20-FF-000088', NULL, 'Uncharacterized protein', 292, NULL, NULL, 29262),
(29263, '1.20.140.150-FF-000055', NULL, 'CLaudin-like in Caenorhabditis', 208, NULL, NULL, 29263),
(29264, '3.30.200.20-FF-002342', NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 12', 61, NULL, NULL, 29264),
(29265, '1.20.1250.20-FF-001269', NULL, 'MFS transporter (Hol1), putative', 262, NULL, NULL, 29265),
(29266, '3.40.47.10-FF-000065', NULL, 'Acetyl-CoA acyltransferase 1', 75, NULL, NULL, 29266),
(29267, '1.10.10.10-FF-000138', NULL, 'Rrf2 family transcriptional regulator', 141, NULL, NULL, 29267),
(29268, '3.40.50.300-FF-005200', NULL, 'LOC795887 protein', 211, NULL, NULL, 29268),
(29269, '2.30.30.100-FF-000050', NULL, 'Small nuclear ribonucleoprotein Sm D1', 92, NULL, NULL, 29269),
(29270, '3.40.50.1170-FF-000013', NULL, 'Uncharacterized protein', 125, NULL, NULL, 29270),
(29271, '3.40.50.1480-FF-000011', NULL, 'Adenosylhomocysteinase', 312, NULL, NULL, 29271),
(29272, '3.40.50.150-FF-000675', NULL, 'Aklanonic acid methyltransferase DnrC', 218, NULL, NULL, 29272),
(29273, '3.40.50.300-FF-000653', NULL, 'Aliphatic sulfonates import ATP-binding protein SsuB', 233, NULL, NULL, 29273),
(29274, '3.30.450.20-FF-000022', NULL, 'circadian locomoter output cycles protein kaput', 144, NULL, NULL, 29274),
(29275, '2.130.10.10-FF-004177', NULL, 'Uncharacterized protein', 165, NULL, NULL, 29275),
(29276, '3.90.480.10-FF-000013', NULL, 'CobG', 65, NULL, NULL, 29276),
(29277, '3.30.1540.20-FF-000028', NULL, NULL, 74, NULL, NULL, 29277),
(29278, '2.160.10.10-FF-000095', NULL, 'Nucleotidyl transferase, putative', 103, NULL, NULL, 29278),
(29279, '1.10.510.10-FF-004089', NULL, NULL, 159, NULL, NULL, 29279),
(29280, '1.10.510.10-FF-000492', NULL, 'Mitogen-activated protein kinase', 108, NULL, NULL, 29280),
(29281, '2.60.40.10-FF-004435', NULL, NULL, 88, NULL, NULL, 29281),
(29282, '3.40.190.10-FF-000507', NULL, 'Peptide transport periplasmic protein sapA', 92, NULL, NULL, 29282),
(29283, '3.40.50.1820-FF-001557', NULL, 'Uncharacterized protein', 121, NULL, NULL, 29283),
(29284, '2.60.40.10-FF-004087', NULL, NULL, 94, NULL, NULL, 29284),
(29285, '1.25.40.90-FF-000012', NULL, 'Huntingtin interacting protein 1-related', 128, NULL, NULL, 29285),
(29286, '3.50.50.60-FF-000328', NULL, 'Probable monoxygenase', 182, NULL, NULL, 29286),
(29287, '3.40.50.261-FF-000029', NULL, 'Succinyl-CoA synthase subunit beta', 179, NULL, NULL, 29287);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(29288, '1.20.1250.20-FF-001488', NULL, 'Uncharacterized protein', 414, NULL, NULL, 29288),
(29289, '2.120.10.30-FF-000434', NULL, 'Uncharacterized protein', 133, NULL, NULL, 29289),
(29290, '3.40.50.720-FF-001493', NULL, 'Ketimine reductase mu-crystallin', 162, NULL, NULL, 29290),
(29291, '3.40.50.300-FF-004576', NULL, 'DNA helicase', 198, NULL, NULL, 29291),
(29292, '1.20.1440.80-FF-000003', NULL, 'Gap junction protein', 249, NULL, NULL, 29292),
(29293, '1.25.10.10-FF-000655', NULL, 'RING-type E3 ubiquitin transferase', 145, NULL, NULL, 29293),
(29294, '2.30.29.30-FF-000150', NULL, 'Adaptin ear-binding coat-associated protein', 123, NULL, NULL, 29294),
(29295, '3.90.190.10-FF-000131', NULL, 'Dual specificity protein phosphatase, putative', 158, NULL, NULL, 29295),
(29296, '2.40.10.10-FF-000505', NULL, NULL, 86, NULL, NULL, 29296),
(29297, '1.10.10.60-FF-000462', NULL, 'ISPsy4, transposase', 45, NULL, NULL, 29297),
(29298, '2.60.120.260-FF-000304', NULL, 'Beta-galactosidase', 196, NULL, NULL, 29298),
(29299, '3.90.70.10-FF-000459', NULL, 'Uncharacterized protein', 250, NULL, NULL, 29299),
(29300, '2.60.40.60-FF-000482', NULL, 'cadherin-89D', 128, NULL, NULL, 29300),
(29301, '3.30.479.30-FF-000001', NULL, 'Prohibitin 2', 135, NULL, NULL, 29301),
(29302, '3.30.750.24-FF-000162', NULL, 'Uncharacterized protein', 109, NULL, NULL, 29302),
(29303, '3.30.70.330-FF-000230', NULL, 'RNA-binding motif protein 25', 114, NULL, NULL, 29303),
(29304, '3.30.70.60-FF-000050', NULL, 'Uncharacterized protein', 97, NULL, NULL, 29304),
(29305, '3.30.2160.10-FF-000058', NULL, 'Uncharacterized protein', 71, NULL, NULL, 29305),
(29306, '3.30.160.60-FF-000377', NULL, 'zinc finger protein 362 isoform X4', 31, NULL, NULL, 29306),
(29307, '3.40.50.300-FF-001142', NULL, 'RecBCD enzyme subunit RecB', 256, NULL, NULL, 29307),
(29308, '2.40.100.10-FF-000107', NULL, 'Peptidyl-prolyl cis-trans isomerase', 97, NULL, NULL, 29308),
(29309, '3.30.565.10-FF-000448', NULL, 'AGAP006961-PA', 86, NULL, NULL, 29309),
(29310, '2.10.70.10-FF-000297', NULL, 'Uncharacterized protein', 44, NULL, NULL, 29310),
(29311, '2.10.25.10-FF-001283', NULL, 'AGAP002157-PA', 53, NULL, NULL, 29311),
(29312, '3.40.190.290-FF-000005', NULL, 'HTH-type transcriptional activator AllS', 176, NULL, NULL, 29312),
(29313, '3.10.20.90-FF-000388', NULL, 'E3 ubiquitin-protein ligase MYLIP-A', 81, NULL, NULL, 29313),
(29314, '3.30.720.50-FF-000001', NULL, 'E3 ubiquitin-protein ligase TRIP12 isoform X1', 88, NULL, NULL, 29314),
(29315, '1.10.472.10-FF-000155', NULL, 'TFIIK subunit', 93, NULL, NULL, 29315),
(29316, '1.10.10.10-FF-001998', NULL, 'Uncharacterized protein', 138, NULL, NULL, 29316),
(29317, '3.40.50.1240-FF-000175', NULL, NULL, 210, NULL, NULL, 29317),
(29318, '3.30.230.70-FF-000026', NULL, 'Polyribonucleotide nucleotidyltransferase', 229, NULL, NULL, 29318),
(29319, '2.40.70.10-FF-000267', NULL, 'Aspartic peptidase domain-containing protein', 170, NULL, NULL, 29319),
(29320, '3.30.160.60-FF-004087', NULL, NULL, 30, NULL, NULL, 29320),
(29321, '3.40.30.10-FF-001049', NULL, 'Iodothyronine deiodinase', 182, NULL, NULL, 29321),
(29322, '3.30.450.20-FF-000241', NULL, 'Uncharacterized protein', 107, NULL, NULL, 29322),
(29323, '3.40.50.2020-FF-000089', NULL, 'Adenine phosphoribosyltransferase 2', 179, NULL, NULL, 29323),
(29324, '2.120.10.80-FF-000207', NULL, 'cDNA FLJ40400 fis, clone TESTI2037103', 133, NULL, NULL, 29324),
(29325, '3.40.50.150-FF-000456', NULL, 'Ribosomal RNA small subunit methyltransferase A', 181, NULL, NULL, 29325),
(29326, '1.10.1320.10-FF-000026', NULL, 'Uncharacterized protein', 59, NULL, NULL, 29326),
(29327, '1.10.20.10-FF-000296', NULL, NULL, 63, NULL, NULL, 29327),
(29328, '3.40.190.10-FF-000159', NULL, 'PBP superfamily domain protein', 124, NULL, NULL, 29328),
(29329, '3.40.50.300-FF-006830', NULL, 'Uncharacterized protein', 270, NULL, NULL, 29329),
(29330, '1.10.3470.10-FF-000043', NULL, 'Iron ABC transporter', 327, NULL, NULL, 29330),
(29331, '3.30.1050.10-FF-000044', NULL, 'Uncharacterized protein', 121, NULL, NULL, 29331);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(29332, '1.10.560.10-FF-000096', NULL, 'McKusick-Kaufman syndrome', 261, NULL, NULL, 29332),
(29333, '3.30.40.10-FF-002034', NULL, 'Uncharacterized protein', 98, NULL, NULL, 29333),
(29334, '3.30.559.70-FF-000042', NULL, 'AGAP002329-PA', 320, NULL, NULL, 29334),
(29335, '1.10.8.500-FF-000013', NULL, 'Two-component sensor histidine kinase', 50, NULL, NULL, 29335),
(29336, '2.30.230.10-FF-000023', NULL, 'Uncharacterized protein', 177, NULL, NULL, 29336),
(29337, '1.25.40.10-FF-002057', NULL, 'Transcription factor EMB1444', 65, NULL, NULL, 29337),
(29338, '3.30.160.60-FF-004980', NULL, NULL, 72, NULL, NULL, 29338),
(29339, '1.10.510.10-FF-002408', NULL, NULL, 217, NULL, NULL, 29339),
(29340, '2.130.10.10-FF-004525', NULL, 'Chromosome 12, whole genome shotgun sequence', 229, NULL, NULL, 29340),
(29341, '3.30.450.40-FF-000247', NULL, 'Phosphodiesterase', 98, NULL, NULL, 29341),
(29342, '2.60.40.790-FF-000139', NULL, NULL, 131, NULL, NULL, 29342),
(29343, '2.130.10.10-FF-005014', NULL, 'Uncharacterized protein', 27, NULL, NULL, 29343),
(29344, '2.10.25.10-FF-001631', NULL, 'FEEL-1', 49, NULL, NULL, 29344),
(29345, '2.30.18.10-FF-000017', NULL, 'Transcription initiation factor IIA subunit 2', 56, NULL, NULL, 29345),
(29346, '3.20.20.150-FF-000050', NULL, 'Hydroxypyruvate isomerase', 259, NULL, NULL, 29346),
(29347, '1.20.1420.30-FF-000021', NULL, 'Vacuolar calcium ion transporter', 148, NULL, NULL, 29347),
(29348, '3.90.1420.10-FF-000065', NULL, 'Uncharacterized protein', 162, NULL, NULL, 29348),
(29349, '3.70.10.10-FF-000069', NULL, 'Uncharacterized protein', 90, NULL, NULL, 29349),
(29350, '3.30.1360.10-FF-000040', NULL, 'DNA-directed RNA polymerase subunit alpha', 77, NULL, NULL, 29350),
(29351, '1.25.10.10-FF-002235', NULL, 'USO1 vesicle transport factor', 384, NULL, NULL, 29351),
(29352, '2.10.220.10-FF-000185', NULL, 'Uncharacterized protein', 65, NULL, NULL, 29352),
(29353, '3.40.50.970-FF-000027', NULL, '2-hydroxyacyl-CoA lyase 1', 215, NULL, NULL, 29353),
(29354, '3.10.20.90-FF-000495', NULL, 'Ubiquitin family protein', 85, NULL, NULL, 29354),
(29355, '3.10.20.580-FF-000001', NULL, 'Ribonuclease J', 107, NULL, NULL, 29355),
(29356, '1.20.1070.10-FF-001735', NULL, 'LOPB11', 90, NULL, NULL, 29356),
(29357, '2.160.20.10-FF-000045', NULL, 'Pectin methylesterase family protein', 325, NULL, NULL, 29357),
(29358, '3.30.1380.20-FF-000038', NULL, 'Uncharacterized protein', 163, NULL, NULL, 29358),
(29359, '3.90.1300.10-FF-000011', NULL, 'Putative amidase', 519, NULL, NULL, 29359),
(29360, '1.20.1250.20-FF-001943', NULL, 'Uncharacterized protein', 453, NULL, NULL, 29360),
(29361, '3.90.660.10-FF-000111', NULL, NULL, 80, NULL, NULL, 29361),
(29362, '3.10.20.590-FF-000004', NULL, 'Leucine--tRNA ligase, mitochondrial', 78, NULL, NULL, 29362),
(29363, '1.20.120.360-FF-000001', NULL, 'Axin interactor, dorsalization-associated protein', 117, NULL, NULL, 29363),
(29364, '3.40.50.10890-FF-000005', NULL, 'Cleavage and polyadenylation specificity factor subunit 3-II', 181, NULL, NULL, 29364),
(29365, '2.60.200.20-FF-000158', NULL, 'Kinesin-related protein 1', 64, NULL, NULL, 29365),
(29366, '3.20.20.80-FF-000300', NULL, 'Glycosyl hydrolase family 25', 205, NULL, NULL, 29366),
(29367, '3.90.550.10-FF-000463', NULL, 'Glycosyltransferase involved in cell wall biogenesis', 229, NULL, NULL, 29367),
(29368, '3.40.50.1820-FF-001664', NULL, 'Non-ribosomal peptide synthetase OfaC', 276, NULL, NULL, 29368),
(29369, '1.10.3720.10-FF-000035', NULL, 'Nickel ABC transporter permease subunit NikB', 214, NULL, NULL, 29369),
(29370, '1.25.10.10-FF-000088', NULL, 'Splicing factor 3b, subunit 1', 245, NULL, NULL, 29370),
(29371, '2.60.40.60-FF-000695', NULL, 'Predicted protein', 103, NULL, NULL, 29371),
(29372, '3.50.50.60-FF-000109', NULL, 'Glutathione reductase', 118, NULL, NULL, 29372),
(29373, '1.10.510.10-FF-003015', NULL, NULL, 159, NULL, NULL, 29373),
(29374, '3.40.50.10810-FF-000038', NULL, 'Protein CHROMATIN REMODELING 19 isoform A', 279, NULL, NULL, 29374),
(29375, '3.80.10.10-FF-001507', NULL, 'F-box domain protein', 97, NULL, NULL, 29375); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(29376, '3.40.50.2300-FF-000633', NULL, 'Glutamate receptor 2', 196, NULL, NULL, 29376),
(29377, '1.25.40.10-FF-000713', NULL, 'Pentatricopeptide repeat-containing protein', 170, NULL, NULL, 29377),
(29378, '1.20.58.60-FF-000037', NULL, 'Spectrin alpha chain non-erythrocytic 1', 105, NULL, NULL, 29378),
(29379, '3.30.160.60-FF-002518', NULL, 'Zinc finger protein 14', 42, NULL, NULL, 29379),
(29380, '3.40.50.1820-FF-000141', NULL, 'Uncharacterized protein, isoform A', 232, NULL, NULL, 29380),
(29381, '2.30.30.40-FF-000460', NULL, 'SH3 domain protein, conserved', 70, NULL, NULL, 29381),
(29382, '3.40.50.10810-FF-000145', NULL, 'SWI/SNF related, matrix associated, actin dependent regulator of chromatin, subfamily a like 1', 101, NULL, NULL, 29382),
(29383, '3.30.70.330-FF-000117', NULL, 'Nuclear and cytoplasmic polyadenylated RNA-binding protein', 93, NULL, NULL, 29383),
(29384, '1.20.1070.10-FF-000212', NULL, 'Prostaglandin E2 receptor EP2 subtype', 338, NULL, NULL, 29384),
(29385, '3.30.450.200-FF-000018', NULL, NULL, 138, NULL, NULL, 29385),
(29386, '3.40.190.10-FF-000491', NULL, 'Transcriptional regulator, LysR family', 88, NULL, NULL, 29386),
(29387, '3.30.160.60-FF-004648', NULL, NULL, 89, NULL, NULL, 29387),
(29388, '1.25.40.20-FF-000716', NULL, 'Uncharacterized protein', 81, NULL, NULL, 29388),
(29389, '2.130.10.10-FF-000809', NULL, 'Autophagy-related protein 16', 301, NULL, NULL, 29389),
(29390, '1.10.3210.10-FF-000058', NULL, 'Guanosine-5''-triphosphate,3''-diphosphate pyrophosphatase', 192, NULL, NULL, 29390),
(29391, '3.40.50.300-FF-002339', NULL, 'Pre-mRNA-splicing helicase BRR2, putative', 174, NULL, NULL, 29391),
(29392, '3.30.70.330-FF-000224', NULL, 'Nuclear and cytoplasmic polyadenylated RNA-binding protein', 93, NULL, NULL, 29392),
(29393, '3.90.640.10-FF-000003', NULL, 'Molecular chaperone DnaK', 88, NULL, NULL, 29393),
(29394, '3.30.160.60-FF-001321', NULL, 'Zinc finger protein 652', 22, NULL, NULL, 29394),
(29395, '1.20.120.720-FF-000031', NULL, 'Uncharacterized protein, isoform B', 176, NULL, NULL, 29395),
(29396, '1.20.1280.50-FF-000257', NULL, 'Uncharacterized protein', 59, NULL, NULL, 29396),
(29397, '2.60.40.10-FF-004542', NULL, NULL, 87, NULL, NULL, 29397),
(29398, '3.40.50.300-FF-008067', NULL, 'Uncharacterized protein', 123, NULL, NULL, 29398),
(29399, '3.40.50.1240-FF-000169', NULL, NULL, 295, NULL, NULL, 29399),
(29400, '3.80.10.10-FF-003637', NULL, 'Leucine rich repeat and fibronectin type III domain containing 3', 95, NULL, NULL, 29400),
(29401, '3.40.50.300-FF-000198', NULL, 'Activating signal cointegrator 1 complex subunit', 228, NULL, NULL, 29401),
(29402, '1.20.144.10-FF-000065', NULL, 'Chromosome 1, whole genome shotgun sequence', 115, NULL, NULL, 29402),
(29403, '3.40.630.10-FF-000205', NULL, 'Probable TolB protein', 285, NULL, NULL, 29403),
(29404, '3.40.970.40-FF-000003', NULL, 'Fibronectin-binding protein-like protein A', 37, NULL, NULL, 29404),
(29405, '3.40.50.1820-FF-000028', NULL, 'S9 family peptidase', 256, NULL, NULL, 29405),
(29406, '1.20.1250.20-FF-001836', NULL, 'Uncharacterized protein', 141, NULL, NULL, 29406),
(29407, '2.120.10.30-FF-000440', NULL, 'Uncharacterized protein', 119, NULL, NULL, 29407),
(29408, '3.40.50.720-FF-001386', NULL, 'Uncharacterized protein', 126, NULL, NULL, 29408),
(29409, '1.10.238.10-FF-000347', NULL, 'Uncharacterized protein', 69, NULL, NULL, 29409),
(29410, '2.170.270.10-FF-000072', NULL, 'SET (Trithorax/polycomb) domain containing', 101, NULL, NULL, 29410),
(29411, '3.90.1150.10-FF-000414', NULL, 'Ornithine aminotransferase', 56, NULL, NULL, 29411),
(29412, '3.40.50.300-FF-002671', NULL, 'DNA helicase', 160, NULL, NULL, 29412),
(29413, '1.25.40.720-FF-000011', NULL, 'Telomere length regulation protein clk-2', 145, NULL, NULL, 29413),
(29414, '2.130.10.10-FF-005020', NULL, 'Cilia- and flagella-associated protein 251', 312, NULL, NULL, 29414),
(29415, '3.30.260.10-FF-000100', NULL, NULL, 114, NULL, NULL, 29415),
(29416, '2.10.25.10-FF-001395', NULL, 'Uncharacterized protein', 45, NULL, NULL, 29416),
(29417, '2.60.40.150-FF-000739', NULL, 'Predicted protein', 103, NULL, NULL, 29417);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(29418, '3.90.226.10-FF-000193', NULL, 'Protein CBG12007', 230, NULL, NULL, 29418),
(29419, '3.10.10.10-FF-000009', NULL, 'Protein P', 39, NULL, NULL, 29419),
(29420, '3.30.870.10-FF-000017', NULL, 'Phospholipase', 192, NULL, NULL, 29420),
(29421, '1.10.10.10-FF-001886', NULL, 'Methionine aminopeptidase 2', 11, NULL, NULL, 29421),
(29422, '2.60.120.650-FF-000084', NULL, 'Uncharacterized protein', 358, NULL, NULL, 29422),
(29423, '3.30.420.40-FF-000189', NULL, 'Actin-related protein 4', 77, NULL, NULL, 29423),
(29424, '3.30.450.30-FF-000025', NULL, 'Dynein light chain roadblock', 125, NULL, NULL, 29424),
(29425, '3.40.47.10-FF-000290', NULL, NULL, 251, NULL, NULL, 29425),
(29426, '1.10.506.10-FF-000049', NULL, 'Uncharacterized protein', 208, NULL, NULL, 29426),
(29427, '3.90.1490.10-FF-000007', NULL, 'ATP-binding protein, putative', 96, NULL, NULL, 29427),
(29428, '3.30.160.60-FF-004974', NULL, NULL, 60, NULL, NULL, 29428),
(29429, '2.40.100.10-FF-000091', NULL, 'Peptidyl-prolyl cis-trans isomerase', 60, NULL, NULL, 29429),
(29430, '3.40.190.10-FF-000165', NULL, 'Ferric iron ABC transporter, iron-binding protein', 142, NULL, NULL, 29430),
(29431, '1.10.220.150-FF-000019', NULL, 'ADP-ribosylation factor GTPase-activating protein AGD1', 162, NULL, NULL, 29431),
(29432, '1.10.230.10-FF-000009', NULL, 'Citrate synthase', 116, NULL, NULL, 29432),
(29433, '3.40.50.970-FF-000140', NULL, 'Pyruvate oxidase', 190, NULL, NULL, 29433),
(29434, '2.130.10.10-FF-002272', NULL, 'YALI0B21054p', 271, NULL, NULL, 29434),
(29435, '1.20.1050.10-FF-000104', NULL, 'Glutathione S-transferase (Eurofung)', 162, NULL, NULL, 29435),
(29436, '3.40.50.1970-FF-000045', NULL, 'Aldehyde-alcohol dehydrogenase', 194, NULL, NULL, 29436),
(29437, '1.25.40.730-FF-000014', NULL, 'Clathrin heavy chain', 97, NULL, NULL, 29437),
(29438, '1.10.472.10-FF-000267', NULL, 'Cyclin family protein', 113, NULL, NULL, 29438),
(29439, '3.40.630.10-FF-000188', NULL, 'Nicalin', 276, NULL, NULL, 29439),
(29440, '2.30.30.40-FF-000347', NULL, 'SH3 and cysteine rich domain', 64, NULL, NULL, 29440),
(29441, '1.20.150.20-FF-000003', NULL, 'ATP synthase subunit alpha', 89, NULL, NULL, 29441),
(29442, '3.30.200.20-FF-002016', NULL, 'Tyrosine-protein kinase Src64B-like Protein', 93, NULL, NULL, 29442),
(29443, '3.40.50.300-FF-006942', NULL, 'Uncharacterized protein', 228, NULL, NULL, 29443),
(29444, '1.25.40.20-FF-000699', NULL, 'Expressed protein', 105, NULL, NULL, 29444),
(29445, '1.20.1540.10-FF-000063', NULL, 'Rhomboid family intramembrane serine protease', 189, NULL, NULL, 29445),
(29446, '3.40.50.300-FF-004812', NULL, 'Translation initiation factor IF-2 subunit gamma', 197, NULL, NULL, 29446),
(29447, '3.30.700.10-FF-000016', NULL, 'Fimbrial protein', 147, NULL, NULL, 29447),
(29448, '3.30.565.10-FF-000229', NULL, 'Histidine phosphotransferase', 137, NULL, NULL, 29448),
(29449, '3.30.50.10-FF-000062', NULL, 'Related to gata transcription factor', 57, NULL, NULL, 29449),
(29450, '3.80.10.10-FF-002114', NULL, 'F-box and leucine-rich repeat protein 12', 322, NULL, NULL, 29450),
(29451, '1.20.1050.10-FF-000211', NULL, 'Predicted protein', 52, NULL, NULL, 29451),
(29452, '3.30.450.40-FF-000028', NULL, 'PAS domain S-box', 150, NULL, NULL, 29452),
(29453, '3.90.110.10-FF-000031', NULL, NULL, 168, NULL, NULL, 29453),
(29454, '3.40.140.10-FF-000229', NULL, 'C6.1A, putative', 168, NULL, NULL, 29454),
(29455, '3.30.200.20-FF-002123', NULL, 'Uncharacterized protein', 74, NULL, NULL, 29455),
(29456, '2.60.40.60-FF-000369', NULL, 'putative protocadherin beta-18', 117, NULL, NULL, 29456),
(29457, '2.40.70.10-FF-000155', NULL, 'Eukaryotic aspartyl protease family protein', 201, NULL, NULL, 29457),
(29458, '3.40.50.720-FF-000082', NULL, 'Erythronate-4-phosphate dehydrogenase', 110, NULL, NULL, 29458),
(29459, '4.10.1310.10-FF-000001', NULL, 'Dinoflagellate luciferase', 83, NULL, NULL, 29459),
(29460, '2.60.120.970-FF-000079', NULL, 'Bone morphogenetic protein, putative', 235, NULL, NULL, 29460),
(29461, '3.40.50.720-FF-002223', NULL, '15-hydroxyprostaglandin dehydrogenase, putative', 105, NULL, NULL, 29461);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(29462, '3.40.47.10-FF-000301', NULL, NULL, 32, NULL, NULL, 29462),
(29463, '3.30.160.60-FF-004755', NULL, NULL, 49, NULL, NULL, 29463),
(29464, '3.10.110.10-FF-000195', NULL, 'GD23095', 151, NULL, NULL, 29464),
(29465, '3.30.56.70-FF-000003', NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', 57, NULL, NULL, 29465),
(29466, '3.40.50.300-FF-001035', NULL, 'ABC transporter ATP-binding protein YojI', 231, NULL, NULL, 29466),
(29467, '1.20.140.150-FF-000049', NULL, 'GH17940', 245, NULL, NULL, 29467),
(29468, '1.10.472.10-FF-000610', NULL, 'Uncharacterized protein', 140, NULL, NULL, 29468),
(29469, '4.10.1110.10-FF-000014', NULL, 'Rhomboid family protease', 47, NULL, NULL, 29469),
(29470, '3.30.40.10-FF-001865', NULL, 'E3 SUMO-protein ligase nse2', 79, NULL, NULL, 29470),
(29471, '2.60.40.2030-FF-000054', NULL, 'Adhesion G-protein coupled receptor V1', 125, NULL, NULL, 29471),
(29472, '1.10.10.60-FF-000568', NULL, 'Pathogenesis-related homeodomain protein', 72, NULL, NULL, 29472),
(29473, '2.60.40.10-FF-002069', NULL, 'roundabout homolog 1 isoform X4', 48, NULL, NULL, 29473),
(29474, '3.60.21.10-FF-000398', NULL, 'Serine/threonine-protein phosphatase', 439, NULL, NULL, 29474),
(29475, '2.60.120.650-FF-000101', NULL, 'Uncharacterized protein', 116, NULL, NULL, 29475),
(29476, '1.10.472.10-FF-000380', NULL, 'Cyclin, N-terminal domain containing protein', 92, NULL, NULL, 29476),
(29477, '3.30.160.60-FF-000596', NULL, 'zinc finger protein 10 isoform X1', 28, NULL, NULL, 29477),
(29478, '1.10.950.10-FF-000013', NULL, 'Uncharacterized protein', 73, NULL, NULL, 29478),
(29479, '3.90.1150.10-FF-000521', NULL, 'Golgin candidate 2', 65, NULL, NULL, 29479),
(29480, '3.30.565.10-FF-000561', NULL, 'Sensory histidine protein kinase', 164, NULL, NULL, 29480),
(29481, '1.10.620.20-FF-000031', NULL, 'Uncharacterized protein', 109, NULL, NULL, 29481),
(29482, '2.20.25.30-FF-000012', NULL, 'Uncharacterized protein', 68, NULL, NULL, 29482),
(29483, '1.10.238.10-FF-000566', NULL, 'Probable calcium-binding protein CML21', 105, NULL, NULL, 29483),
(29484, '3.50.50.60-FF-000222', NULL, 'N,N-dimethylglycine oxidase', 207, NULL, NULL, 29484),
(29485, '1.10.640.10-FF-000023', NULL, 'Uncharacterized protein', 407, NULL, NULL, 29485),
(29486, '3.40.50.2300-FF-000414', NULL, 'LppC family lipoprotein', 181, NULL, NULL, 29486),
(29487, '2.130.10.10-FF-004289', NULL, 'Uncharacterized protein', 126, NULL, NULL, 29487),
(29488, '2.120.10.30-FF-000327', NULL, 'Predicted protein', 150, NULL, NULL, 29488),
(29489, '3.30.470.20-FF-000023', NULL, 'Biotin carboxylase', 135, NULL, NULL, 29489),
(29490, '3.30.470.30-FF-000026', NULL, 'DNA ligase', 238, NULL, NULL, 29490),
(29491, '3.30.1010.10-FF-000047', NULL, 'Phosphatidylinositol-4,5-bisphosphate 3-kinase catalytic subunit, putative', 153, NULL, NULL, 29491),
(29492, '3.40.190.10-FF-000272', NULL, 'Transferrin', 174, NULL, NULL, 29492),
(29493, '3.40.190.10-FF-000384', NULL, 'Transcriptional regulator, LysR family', 115, NULL, NULL, 29493),
(29494, '3.30.160.60-FF-001102', NULL, 'Transcription factor IIIA', 29, NULL, NULL, 29494),
(29495, '3.30.1370.10-FF-000208', NULL, 'KRR1 small subunit processome component homolog-like protein', 53, NULL, NULL, 29495),
(29496, '2.40.30.270-FF-000025', NULL, 'DNA polymerase alpha-associated DNA helicase A', 114, NULL, NULL, 29496),
(29497, '3.40.309.10-FF-000071', NULL, 'Uncharacterized protein', 89, NULL, NULL, 29497),
(29498, '3.30.1640.10-FF-000078', NULL, 'DNA replication licensing factor MCM7', 94, NULL, NULL, 29498),
(29499, '3.40.800.10-FF-000022', NULL, 'Putative agmatinase', 289, NULL, NULL, 29499),
(29500, '3.90.70.10-FF-000347', NULL, 'IgG-degrading protease', 88, NULL, NULL, 29500),
(29501, '3.30.565.10-FF-000342', NULL, 'Hybrid sensor histidine kinase/response regulator', 163, NULL, NULL, 29501),
(29502, '3.80.10.10-FF-001496', NULL, 'Leucine rich repeats and IQ motif containing 1', 174, NULL, NULL, 29502),
(29503, '2.10.25.10-FF-001406', NULL, 'Uromodulin-like 1', 42, NULL, NULL, 29503),
(29504, '3.40.50.720-FF-002004', NULL, 'Inactive hydroxysteroid dehydrogenase-like protein 1', 227, NULL, NULL, 29504);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(29505, '3.90.740.10-FF-000056', NULL, 'Isoleucine--tRNA ligase, cytoplasmic', 185, NULL, NULL, 29505),
(29506, '3.30.160.60-FF-002850', NULL, 'Zinc finger protein 462', 76, NULL, NULL, 29506),
(29507, '1.10.287.110-FF-000058', NULL, 'Chaperone protein dnaJ GFA2, mitochondrial', 114, NULL, NULL, 29507),
(29508, '2.60.200.20-FF-000271', NULL, 'FHA domain containing protein', 149, NULL, NULL, 29508),
(29509, '1.10.420.10-FF-000041', NULL, 'Uncharacterized protein', 122, NULL, NULL, 29509),
(29510, '3.30.1490.190-FF-000021', NULL, 'Fur family transcriptional regulator, ferric uptake regulator', 57, NULL, NULL, 29510),
(29511, '3.90.1600.10-FF-000051', NULL, 'Uncharacterized protein', 99, NULL, NULL, 29511),
(29512, '1.20.1250.20-FF-001724', NULL, 'AGAP000046-PA', 207, NULL, NULL, 29512),
(29513, '2.60.40.1510-FF-000027', NULL, 'Integrin alpha ina-1', 144, NULL, NULL, 29513),
(29514, '3.30.160.60-FF-001091', NULL, 'Zinc finger protein 615', 26, NULL, NULL, 29514),
(29515, '2.130.10.10-FF-004290', NULL, 'Uncharacterized protein', 126, NULL, NULL, 29515),
(29516, '3.10.110.10-FF-000206', NULL, 'Ubiquitin-conjugating enzyme E2 G1', 149, NULL, NULL, 29516),
(29517, '3.10.450.30-FF-000001', NULL, 'Ribonuclease mitogillin', 149, NULL, NULL, 29517),
(29518, '1.20.1070.10-FF-001954', NULL, 'Probable muscarinic acetylcholine receptor gar-1', 206, NULL, NULL, 29518),
(29519, '3.60.21.10-FF-000179', NULL, 'Serine/threonine protein phosphatase type 5, putative', 324, NULL, NULL, 29519),
(29520, '2.40.160.110-FF-000047', NULL, 'Uncharacterized protein', 163, NULL, NULL, 29520),
(29521, '1.10.472.10-FF-000048', NULL, 'Retinoblastoma-like 2, isoform CRA_a', 108, NULL, NULL, 29521),
(29522, '1.10.150.780-FF-000012', NULL, 'Probable vacuolar protein sorting-associated protein 16 homolog', 96, NULL, NULL, 29522),
(29523, '3.90.79.10-FF-000092', NULL, 'Probable conserved membrane protein', 147, NULL, NULL, 29523),
(29524, '3.20.20.300-FF-000022', NULL, 'Beta-glucosidase', 368, NULL, NULL, 29524),
(29525, '3.40.50.300-FF-006723', NULL, 'Uncharacterized protein', 72, NULL, NULL, 29525),
(29526, '3.30.70.330-FF-002354', NULL, NULL, 106, NULL, NULL, 29526),
(29527, '1.10.10.10-FF-000363', NULL, 'Vacuolar protein sorting-associated protein', 79, NULL, NULL, 29527),
(29528, '3.10.180.10-FF-000031', NULL, 'Lactoylglutathione lyase', 183, NULL, NULL, 29528),
(29529, '2.60.40.10-FF-000944', NULL, 'Ciliary neurotrophic factor receptor subunit alpha', 78, NULL, NULL, 29529),
(29530, '3.40.50.300-FF-004469', NULL, 'Putative RNA helicase SDE3', 282, NULL, NULL, 29530),
(29531, '3.30.2170.10-FF-000008', NULL, 'Endonuclease V', 222, NULL, NULL, 29531),
(29532, '1.10.510.10-FF-001104', NULL, 'Unplaced genomic scaffold supercont1.234, whole genome shotgun sequence', 302, NULL, NULL, 29532),
(29533, '3.40.50.1100-FF-000268', NULL, 'Cysteine synthase', 102, NULL, NULL, 29533),
(29534, '3.30.200.20-FF-002235', NULL, 'Uncharacterized protein', 35, NULL, NULL, 29534),
(29535, '2.120.10.30-FF-000108', NULL, 'NHL domain-containing protein', 108, NULL, NULL, 29535),
(29536, '3.30.540.10-FF-000026', NULL, 'Myo-inositol-1(Or 4)-monophosphatase', 219, NULL, NULL, 29536),
(29537, '3.30.160.60-FF-000484', NULL, 'zinc finger protein 827 isoform X1', 80, NULL, NULL, 29537),
(29538, '2.10.25.10-FF-001176', NULL, 'AGAP003873-PA', 49, NULL, NULL, 29538),
(29539, '3.50.50.60-FF-000441', NULL, 'Putative GMC-type oxidoreductase', 111, NULL, NULL, 29539),
(29540, '3.80.10.10-FF-001726', NULL, 'Uncharacterized protein', 106, NULL, NULL, 29540),
(29541, '3.10.450.50-FF-000007', NULL, 'Nuclear transport factor 2', 127, NULL, NULL, 29541),
(29542, '1.25.40.10-FF-004187', NULL, 'Uncharacterized protein', 81, NULL, NULL, 29542),
(29543, '2.60.40.60-FF-000588', NULL, 'Cadherin-related family member 3', 109, NULL, NULL, 29543),
(29544, '3.30.160.60-FF-004194', NULL, NULL, 78, NULL, NULL, 29544),
(29545, '1.25.40.10-FF-002843', NULL, 'Uncharacterized protein', 123, NULL, NULL, 29545),
(29546, '2.110.10.10-FF-000075', NULL, 'Uncharacterized protein', 97, NULL, NULL, 29546);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(29547, '3.90.1180.10-FF-000017', NULL, 'Os03g0755700 protein', 88, NULL, NULL, 29547),
(29548, '1.10.510.10-FF-000267', NULL, 'probable LRR receptor-like serine/threonine-protein kinase IRK', 205, NULL, NULL, 29548),
(29549, '2.130.10.10-FF-000922', NULL, 'Os11g0132700 protein', 110, NULL, NULL, 29549),
(29550, '3.90.70.10-FF-000908', NULL, 'Ubiquitinyl hydrolase 1', 207, NULL, NULL, 29550),
(29551, '3.40.30.10-FF-001156', NULL, 'Uncharacterized protein', 106, NULL, NULL, 29551),
(29552, '3.40.1090.10-FF-000095', NULL, 'Patatin', 74, NULL, NULL, 29552),
(29553, '2.60.40.10-FF-002288', NULL, 'Carcinoembryonic antigen-related cell adhesion molecule 5', 94, NULL, NULL, 29553),
(29554, '3.10.450.40-FF-000004', NULL, 'Amine oxidase', 144, NULL, NULL, 29554),
(29555, '1.10.10.60-FF-000911', NULL, NULL, 51, NULL, NULL, 29555),
(29556, '3.30.420.40-FF-000425', NULL, 'Actin-related protein 8', 175, NULL, NULL, 29556),
(29557, '3.80.10.10-FF-003750', NULL, 'Leucine rich repeat containing 8 VRAC subunit B', 124, NULL, NULL, 29557),
(29558, '3.30.70.330-FF-001859', NULL, NULL, 107, NULL, NULL, 29558),
(29559, '1.10.287.1130-FF-000005', NULL, 'Cytochrome c oxidase assembly protein subunit 17', 70, NULL, NULL, 29559),
(29560, '1.10.274.20-FF-000001', NULL, 'Phenylalanine ammonia-lyase', 122, NULL, NULL, 29560),
(29561, '3.30.710.10-FF-000404', NULL, 'Rho related BTB domain containing 3', 134, NULL, NULL, 29561),
(29562, '2.60.40.1180-FF-000119', NULL, 'Glucosidase, putative', 98, NULL, NULL, 29562),
(29563, '2.30.42.10-FF-000017', NULL, 'Amyloid beta A4 protein-binding family A member 1', 94, NULL, NULL, 29563),
(29564, '1.10.10.460-FF-000004', NULL, 'Ribonuclease', 42, NULL, NULL, 29564),
(29565, '1.20.58.1220-FF-000011', NULL, 'Exocyst complex component 8', 102, NULL, NULL, 29565),
(29566, '3.30.710.10-FF-000062', NULL, 'potassium voltage-gated channel subfamily C member 4 isoform X2', 129, NULL, NULL, 29566),
(29567, '3.40.190.290-FF-000112', NULL, 'Transcriptional regulatory protein', 206, NULL, NULL, 29567),
(29568, '1.20.920.20-FF-000017', NULL, 'Cytoplasmic dynein heavy chain 2', 144, NULL, NULL, 29568),
(29569, '1.20.120.1750-FF-000094', NULL, 'RBR-type E3 ubiquitin transferase', 56, NULL, NULL, 29569),
(29570, '3.40.30.10-FF-000993', NULL, 'Thioredoxin-like protein HCF164 chloroplastic', 80, NULL, NULL, 29570),
(29571, '3.30.70.330-FF-002135', NULL, NULL, 153, NULL, NULL, 29571),
(29572, '2.130.10.10-FF-002491', NULL, 'Intraflagellar Transport Protein 122', 172, NULL, NULL, 29572),
(29573, '2.130.10.10-FF-000703', NULL, 'Cilia- and flagella-associated protein 43', 174, NULL, NULL, 29573),
(29574, '2.60.40.770-FF-000021', NULL, 'Lymphocyte antigen 86', 144, NULL, NULL, 29574),
(29575, '1.10.10.10-FF-000924', NULL, 'DNA-binding response regulator', 110, NULL, NULL, 29575),
(29576, '3.40.50.300-FF-002890', NULL, 'Protein CBG08006', 164, NULL, NULL, 29576),
(29577, '3.40.50.1000-FF-000463', NULL, NULL, 125, NULL, NULL, 29577),
(29578, '3.30.70.980-FF-000065', NULL, 'Uncharacterized protein', 46, NULL, NULL, 29578),
(29579, '2.60.40.10-FF-002524', NULL, 'Interleukin 1 receptor-like 1 (ST2L)', 95, NULL, NULL, 29579),
(29580, '3.30.70.330-FF-000336', NULL, 'Zinc finger protein 638', 85, NULL, NULL, 29580),
(29581, '2.60.40.150-FF-000291', NULL, 'Phosphoinositide phospholipase C', 144, NULL, NULL, 29581),
(29582, '1.10.510.10-FF-002178', NULL, 'Uncharacterized protein', 181, NULL, NULL, 29582),
(29583, '2.60.40.150-FF-000633', NULL, 'Uncharacterized protein', 136, NULL, NULL, 29583),
(29584, '2.60.40.630-FF-000007', NULL, 'Signal transducer and activator of transcription 3', 107, NULL, NULL, 29584),
(29585, '3.40.525.10-FF-000062', NULL, 'Uncharacterized protein', 240, NULL, NULL, 29585),
(29586, '1.10.1420.10-FF-000085', NULL, 'MutS protein homolog 4', 127, NULL, NULL, 29586),
(29587, '3.60.15.10-FF-000125', NULL, 'N-acyl-phosphatidylethanolamine-hydrolyzing phospholipase D', 312, NULL, NULL, 29587),
(29588, '3.80.10.10-FF-003418', NULL, 'Uncharacterized protein', 80, NULL, NULL, 29588),
(29589, '3.40.50.10810-FF-000257', NULL, 'Uncharacterized protein', 55, NULL, NULL, 29589);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(29590, '1.20.1250.20-FF-000201', NULL, 'Shikimate transporter', 189, NULL, NULL, 29590),
(29591, '3.90.550.50-FF-000008', NULL, 'Beta-1,3-glucosyltransferase', 226, NULL, NULL, 29591),
(29592, '1.20.120.1900-FF-000066', NULL, 'Gamma-tubulin complex component', 309, NULL, NULL, 29592),
(29593, '3.90.70.200-FF-000014', NULL, 'Uncharacterized protein', 129, NULL, NULL, 29593),
(29594, '3.30.465.10-FF-000053', NULL, 'D-lactate dehydrogenase (Cytochrome), putative', 206, NULL, NULL, 29594),
(29595, '2.130.10.10-FF-002833', NULL, 'Ribosome biogenesis protein WDR12 homolog', 367, NULL, NULL, 29595),
(29596, '1.10.10.10-FF-001200', NULL, 'Putative transcriptional regulator', 119, NULL, NULL, 29596),
(29597, '3.80.10.10-FF-000422', NULL, 'S-phase kinase associated protein 2', 134, NULL, NULL, 29597),
(29598, '3.30.420.110-FF-000053', NULL, 'DNA mismatch repair protein', 163, NULL, NULL, 29598),
(29599, '3.40.50.300-FF-007105', NULL, 'Sulfotransferase', 187, NULL, NULL, 29599),
(29600, '1.20.142.10-FF-000010', NULL, 'Poly [ADP-ribose] polymerase', 149, NULL, NULL, 29600),
(29601, '3.30.160.60-FF-004536', NULL, NULL, 62, NULL, NULL, 29601),
(29602, '1.10.1300.10-FF-000031', NULL, '3'',5''-cyclic nucleotide phosphodiesterase, putative', 309, NULL, NULL, 29602),
(29603, '1.20.120.330-FF-000021', NULL, 'ARF GTPase-activating protein GIT2', 129, NULL, NULL, 29603),
(29604, '1.25.40.10-FF-004423', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 127, NULL, NULL, 29604),
(29605, '2.130.10.10-FF-000579', NULL, 'Os05g0230600 protein', 309, NULL, NULL, 29605),
(29606, '1.25.10.10-FF-002454', NULL, 'Uncharacterized protein', 226, NULL, NULL, 29606),
(29607, '1.10.1040.10-FF-000100', NULL, 'Uncharacterized protein', 124, NULL, NULL, 29607),
(29608, '3.80.10.10-FF-000080', NULL, 'F-box/LRR-repeat protein 20 isoform X1', 214, NULL, NULL, 29608),
(29609, '1.25.40.330-FF-000001', NULL, 'Adenylyl cyclase-associated protein', 170, NULL, NULL, 29609),
(29610, '3.40.367.20-FF-000011', NULL, 'Phosphotransferase', 299, NULL, NULL, 29610),
(29611, '2.60.120.260-FF-000416', NULL, 'Beta-galactosidase', 137, NULL, NULL, 29611),
(29612, '1.10.10.10-FF-000469', NULL, 'RpiR family transcriptional regulator', 82, NULL, NULL, 29612),
(29613, '1.25.40.990-FF-000064', NULL, '26S proteasome non-ATPase regulatory subunit 8 homolog A', 128, NULL, NULL, 29613),
(29614, '2.20.70.10-FF-000105', NULL, 'Pre-mRNA-processing factor 40, putative', 54, NULL, NULL, 29614),
(29615, '3.40.50.300-FF-006829', NULL, 'AGL338Wp', 270, NULL, NULL, 29615),
(29616, '3.10.20.90-FF-000618', NULL, 'Uncharacterized protein', 98, NULL, NULL, 29616),
(29617, '1.10.10.820-FF-000034', NULL, 'IP10818p', 62, NULL, NULL, 29617),
(29618, '3.40.50.300-FF-006049', NULL, 'ATP-dependent DNA helicase', 206, NULL, NULL, 29618),
(29619, '2.40.50.140-FF-000327', NULL, 'Replication protein A1, large subunit', 109, NULL, NULL, 29619),
(29620, '3.40.50.1820-FF-001445', NULL, 'Carboxylic ester hydrolase', 187, NULL, NULL, 29620),
(29621, '3.30.40.10-FF-001646', NULL, 'Uncharacterized protein', 72, NULL, NULL, 29621),
(29622, '1.10.510.10-FF-004319', NULL, NULL, 146, NULL, NULL, 29622),
(29623, '1.25.40.340-FF-000004', NULL, 'Unplaced genomic scaffold supercont1.18, whole genome shotgun sequence', 208, NULL, NULL, 29623),
(29624, '3.30.160.100-FF-000006', NULL, 'Ribosome-binding factor PSRP1, chloroplastic', 103, NULL, NULL, 29624),
(29625, '1.10.287.110-FF-000390', NULL, 'Uncharacterized protein', 72, NULL, NULL, 29625),
(29626, '2.40.50.140-FF-000440', NULL, '26S protease regulatory subunit 7', 153, NULL, NULL, 29626),
(29627, '1.10.357.150-FF-000007', NULL, 'Uncharacterized protein', 204, NULL, NULL, 29627),
(29628, '3.40.50.12240-FF-000006', NULL, 'ATP synthase subunit beta', 344, NULL, NULL, 29628),
(29629, '2.170.270.10-FF-000178', NULL, 'PR/SET domain 8', 92, NULL, NULL, 29629),
(29630, '3.40.50.300-FF-002777', NULL, 'YALI0C20265p', 238, NULL, NULL, 29630),
(29631, '3.30.300.130-FF-000043', NULL, NULL, 56, NULL, NULL, 29631),
(29632, '3.10.20.90-FF-000276', NULL, '40S ribosomal protein S30', 74, NULL, NULL, 29632);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(29633, '3.40.50.10700-FF-000005', NULL, 'D-aminoacyl-tRNA deacylase', 82, NULL, NULL, 29633),
(29634, '3.30.40.10-FF-000123', NULL, 'E3 ubiquitin-protein ligase TRIM33', 72, NULL, NULL, 29634),
(29635, '3.30.505.10-FF-000237', NULL, NULL, 77, NULL, NULL, 29635),
(29636, '1.10.10.2010-FF-000009', NULL, NULL, 50, NULL, NULL, 29636),
(29637, '2.40.10.10-FF-000269', NULL, 'IP10114p', 247, NULL, NULL, 29637),
(29638, '2.10.25.10-FF-000102', NULL, 'Protein kinase C-binding protein NELL2', 33, NULL, NULL, 29638),
(29639, '3.40.630.30-FF-000649', NULL, 'Uncharacterized protein', 163, NULL, NULL, 29639),
(29640, '3.40.50.1240-FF-000063', NULL, '3-phytase B', 157, NULL, NULL, 29640),
(29641, '1.25.40.20-FF-001430', NULL, 'Uncharacterized protein', 171, NULL, NULL, 29641),
(29642, '3.30.420.40-FF-000644', NULL, 'Phosphotransferase', 87, NULL, NULL, 29642),
(29643, '1.25.40.10-FF-000590', NULL, 'Ubiquitin-protein ligase, putative', 475, NULL, NULL, 29643),
(29644, '3.30.70.1660-FF-000039', NULL, 'Uncharacterized protein', 171, NULL, NULL, 29644),
(29645, '1.10.10.10-FF-000582', NULL, 'ATP-dependent DNA helicase Q-like 4A', 112, NULL, NULL, 29645),
(29646, '3.90.79.10-FF-000215', NULL, 'Nudix hydrolase 1', 56, NULL, NULL, 29646),
(29647, '3.40.50.12230-FF-000003', NULL, 'methionyl-tRNA formyltransferase, mitochondrial', 308, NULL, NULL, 29647),
(29648, '2.60.120.200-FF-000314', NULL, 'Adhesion G-protein coupled receptor D1', 168, NULL, NULL, 29648),
(29649, '1.10.3020.20-FF-000001', NULL, 'Hydrolase, CocE/NonD family', 50, NULL, NULL, 29649),
(29650, '3.40.50.300-FF-003053', NULL, 'Ras family protein', 113, NULL, NULL, 29650),
(29651, '1.10.1410.40-FF-000020', NULL, 'Zinc finger RNA-binding protein 2', 67, NULL, NULL, 29651),
(29652, '2.60.40.60-FF-000931', NULL, 'Uncharacterized protein', 43, NULL, NULL, 29652),
(29653, '3.40.50.1000-FF-000805', NULL, NULL, 218, NULL, NULL, 29653),
(29654, '2.60.40.10-FF-002962', NULL, 'Plexin A2', 95, NULL, NULL, 29654),
(29655, '3.40.50.300-FF-006487', NULL, 'Heparan sulfate 2-O-sulfotransferase 1b', 115, NULL, NULL, 29655),
(29656, '3.30.230.70-FF-000138', NULL, 'Uncharacterized protein', 150, NULL, NULL, 29656),
(29657, '2.60.40.790-FF-000027', NULL, 'integrin beta-1-binding protein 2 isoform X1', 104, NULL, NULL, 29657),
(29658, '2.60.40.3390-FF-000001', NULL, 'Dolichyl-monophosphooligosaccharide--protein glycotransferase AglB', 113, NULL, NULL, 29658),
(29659, '3.40.50.1580-FF-000035', NULL, '5-methylthioadenosine nucleosidase, S-adenosylhomocysteine nucleosidase', 253, NULL, NULL, 29659),
(29660, '3.30.160.60-FF-003013', NULL, 'Zinc finger protein 329', 25, NULL, NULL, 29660),
(29661, '3.80.10.10-FF-003076', NULL, 'Uncharacterized protein', 132, NULL, NULL, 29661),
(29662, '2.130.10.10-FF-004413', NULL, 'Uncharacterized protein', 443, NULL, NULL, 29662),
(29663, '2.60.40.150-FF-000178', NULL, 'Bitesize, isoform D', 142, NULL, NULL, 29663),
(29664, '1.25.40.10-FF-000039', NULL, 'Pre-mRNA processing factor 6', 81, NULL, NULL, 29664),
(29665, '1.20.58.60-FF-000150', NULL, 'dystrophin, isoforms A/C/F/G/H isoform X5', 107, NULL, NULL, 29665),
(29666, '2.60.120.650-FF-000207', NULL, 'Uncharacterized protein', 125, NULL, NULL, 29666),
(29667, '3.40.630.10-FF-000082', NULL, 'Nicalin', 269, NULL, NULL, 29667),
(29668, '2.60.40.10-FF-005958', NULL, NULL, 87, NULL, NULL, 29668),
(29669, '3.40.630.10-FF-000424', NULL, 'Uncharacterized protein', 291, NULL, NULL, 29669),
(29670, '3.80.10.10-FF-000203', NULL, 'Relaxin family peptide receptor 1', 165, NULL, NULL, 29670),
(29671, '1.25.10.10-FF-002673', NULL, 'AGAP012049-PA', 86, NULL, NULL, 29671),
(29672, '2.40.50.140-FF-000108', NULL, '30S ribosomal protein S17', 83, NULL, NULL, 29672),
(29673, '3.80.10.10-FF-003856', NULL, 'Leucine-rich repeat protein (LRRP), putative', 141, NULL, NULL, 29673),
(29674, '2.60.40.10-FF-004199', NULL, NULL, 81, NULL, NULL, 29674),
(29675, '1.10.220.150-FF-000020', NULL, 'ADP ribosylation factor GTPase activating protein 1', 75, NULL, NULL, 29675),
(29676, '3.40.50.720-FF-001947', NULL, '3-oxoacyl-[acyl-carrier protein] reductase', 266, NULL, NULL, 29676);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(29677, '3.30.160.60-FF-002737', NULL, 'AGAP008430-PA', 30, NULL, NULL, 29677),
(29678, '3.30.230.10-FF-000036', NULL, 'DNA mismatch repair endonuclease MutL', 118, NULL, NULL, 29678),
(29679, '2.60.120.10-FF-000677', NULL, 'Uncharacterized protein', 92, NULL, NULL, 29679),
(29680, '1.25.40.20-FF-000593', NULL, 'Transient receptor potential cation channel subfamily A member 1b', 225, NULL, NULL, 29680),
(29681, '3.60.21.10-FF-000292', NULL, 'Serine/threonine protein phosphatase, putative', 179, NULL, NULL, 29681),
(29682, '3.40.50.12780-FF-000033', NULL, 'Long-chain fatty acid--CoA ligase', 430, NULL, NULL, 29682),
(29683, '3.30.1490.100-FF-000051', NULL, 'Uncharacterized protein', 43, NULL, NULL, 29683),
(29684, '3.10.20.90-FF-000950', NULL, 'Uncharacterized protein', 68, NULL, NULL, 29684),
(29685, '1.20.1070.10-FF-000431', NULL, 'NeuroPeptide Receptor family', 333, NULL, NULL, 29685),
(29686, '1.25.40.20-FF-001211', NULL, 'Uncharacterized protein', 156, NULL, NULL, 29686),
(29687, '3.10.129.10-FF-000232', NULL, 'Acyl-[acyl-carrier-protein] hydrolase', 162, NULL, NULL, 29687),
(29688, '1.20.5.190-FF-000064', NULL, 'Myosin 2', 49, NULL, NULL, 29688),
(29689, '2.40.30.10-FF-000158', NULL, 'Elongation factor like GTPase 1', 152, NULL, NULL, 29689),
(29690, '3.40.50.1820-FF-000360', NULL, 'Unplaced genomic scaffold supercont1.23, whole genome shotgun sequence', 236, NULL, NULL, 29690),
(29691, '3.40.50.1980-FF-000048', NULL, 'Manganese ABC transporter substrate-binding lipoprotein', 126, NULL, NULL, 29691),
(29692, '3.30.160.60-FF-002395', NULL, 'Enhancer binding protein', 27, NULL, NULL, 29692),
(29693, '2.30.38.10-FF-000018', NULL, 'Peptide synthetase', 79, NULL, NULL, 29693),
(29694, '2.60.34.10-FF-000104', NULL, 'Heat shock protein', 155, NULL, NULL, 29694),
(29695, '3.30.497.10-FF-000172', NULL, 'Serpin peptidase inhibitor 6', 203, NULL, NULL, 29695),
(29696, '3.30.500.10-FF-000029', NULL, 'CD1-2 antigen', 186, NULL, NULL, 29696),
(29697, '3.30.1520.10-FF-000024', NULL, 'Neutrophil cytosol factor 4', 143, NULL, NULL, 29697),
(29698, '2.160.10.10-FF-000106', NULL, 'Uncharacterized protein', 108, NULL, NULL, 29698),
(29699, '3.40.50.620-FF-000052', NULL, 'Sulfate adenylyltransferase', 200, NULL, NULL, 29699),
(29700, '3.30.200.20-FF-000324', NULL, 'Serine/threonine-protein kinase Kist isoform 1', 90, NULL, NULL, 29700),
(29701, '3.90.70.10-FF-000802', NULL, 'Uncharacterized protein', 321, NULL, NULL, 29701),
(29702, '3.30.40.10-FF-000342', NULL, 'Histone deacetylase 6', 108, NULL, NULL, 29702),
(29703, '2.40.30.10-FF-000377', NULL, 'Ribosome-releasing factor 2, mitochondrial', 108, NULL, NULL, 29703),
(29704, '3.40.50.300-FF-002558', NULL, 'ATP-dependent DNA helicase HrpA', 172, NULL, NULL, 29704),
(29705, '3.30.2080.10-FF-000001', NULL, 'Alpha-1,2-mannosidase subfamily', 152, NULL, NULL, 29705),
(29706, '3.30.70.330-FF-001298', NULL, 'Uncharacterized protein', 66, NULL, NULL, 29706),
(29707, '1.25.40.20-FF-000935', NULL, 'Uncharacterized protein', 150, NULL, NULL, 29707),
(29708, '1.10.540.10-FF-000095', NULL, 'Uncharacterized protein', 60, NULL, NULL, 29708),
(29709, '3.40.50.150-FF-001063', NULL, NULL, 257, NULL, NULL, 29709),
(29710, '2.130.10.10-FF-002159', NULL, 'Intraflagellar transport 122', 140, NULL, NULL, 29710),
(29711, '2.60.120.260-FF-000074', NULL, 'Sad1 and UNC84 domain-containing 3', 195, NULL, NULL, 29711),
(29712, '3.30.70.330-FF-001972', NULL, NULL, 79, NULL, NULL, 29712),
(29713, '3.30.420.140-FF-000033', NULL, 'Transcription elongation factor spt6', 159, NULL, NULL, 29713),
(29714, '1.25.40.10-FF-000932', NULL, 'Pentatricopeptide repeat-containing protein', 92, NULL, NULL, 29714),
(29715, '2.160.20.10-FF-000264', NULL, 'Os11g0659700 protein', 97, NULL, NULL, 29715),
(29716, '2.120.10.30-FF-000546', NULL, 'Uncharacterized protein', 54, NULL, NULL, 29716),
(29717, '1.10.460.10-FF-000037', NULL, 'DNA topoisomerase', 83, NULL, NULL, 29717),
(29718, '1.10.238.10-FF-000802', NULL, 'Defective in cullin neddylation protein', 64, NULL, NULL, 29718),
(29719, '2.30.42.10-FF-000236', NULL, 'uncharacterized protein LOC108093793 isoform X3', 94, NULL, NULL, 29719);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(29720, '2.60.40.1120-FF-000017', NULL, 'Rhamnogalacturonate lyase A', 85, NULL, NULL, 29720),
(29721, '3.30.300.330-FF-000002', NULL, 'Alkyldihydroxyacetonephosphate synthase AgpS', 105, NULL, NULL, 29721),
(29722, '3.40.30.10-FF-001050', NULL, 'Uncharacterized protein', 181, NULL, NULL, 29722),
(29723, '1.20.1070.10-FF-001516', NULL, 'Predicted protein', 193, NULL, NULL, 29723),
(29724, '1.10.3110.10-FF-000005', NULL, 'Protoporphyrinogen oxidase', 94, NULL, NULL, 29724),
(29725, '2.60.40.1110-FF-000014', NULL, 'Phosphatidylinositol 3,4,5-trisphosphate 3-phosphatase and dual-specificity protein phosphatase daf-18', 142, NULL, NULL, 29725),
(29726, '1.10.150.320-FF-000003', NULL, 'Photosystem II complex extrinsic proteinprecursor U', 87, NULL, NULL, 29726),
(29727, '3.40.30.10-FF-000774', NULL, 'Bacterioferritin comigrating protein', 151, NULL, NULL, 29727),
(29728, '3.30.530.20-FF-000079', NULL, 'START domain containing protein', 200, NULL, NULL, 29728),
(29729, '1.20.1310.10-FF-000035', NULL, 'Ubiquitin ligase subunit CulD, putative', 133, NULL, NULL, 29729),
(29730, '2.30.30.30-FF-000125', NULL, '50S ribosomal protein L24, chloroplastic', 76, NULL, NULL, 29730),
(29731, '3.30.60.30-FF-000237', NULL, 'Predicted protein', 49, NULL, NULL, 29731),
(29732, '1.25.40.10-FF-004081', NULL, 'Uncharacterized protein', 157, NULL, NULL, 29732),
(29733, '1.20.1250.20-FF-000420', NULL, 'Siderophore transporter', 197, NULL, NULL, 29733),
(29734, '1.10.510.10-FF-002739', NULL, NULL, 92, NULL, NULL, 29734),
(29735, '1.10.760.10-FF-000077', NULL, 'Membrane-bound dehydrogenase domain protein', 111, NULL, NULL, 29735),
(29736, '3.40.50.150-FF-000787', NULL, 'Generic methyltransferase, putative', 162, NULL, NULL, 29736),
(29737, '3.10.310.10-FF-000070', NULL, 'Predicted protein', 110, NULL, NULL, 29737),
(29738, '1.25.70.10-FF-000086', NULL, NULL, 145, NULL, NULL, 29738),
(29739, '1.50.10.20-FF-000122', NULL, 'Uncharacterized protein', 101, NULL, NULL, 29739),
(29740, '1.10.510.10-FF-002397', NULL, 'Serine/threonine protein kinase-35', 231, NULL, NULL, 29740),
(29741, '2.40.10.10-FF-000488', NULL, NULL, 190, NULL, NULL, 29741),
(29742, '1.20.58.670-FF-000005', NULL, 'RINT-1 family protein', 131, NULL, NULL, 29742),
(29743, '3.40.50.1000-FF-000682', NULL, NULL, 157, NULL, NULL, 29743),
(29744, '3.30.780.10-FF-000010', NULL, 'Protein translation factor SUI1', 110, NULL, NULL, 29744),
(29745, '3.10.100.10-FF-000256', NULL, NULL, 95, NULL, NULL, 29745),
(29746, '3.80.10.10-FF-004132', NULL, 'Probable serine/threonine-protein kinase roco5', 111, NULL, NULL, 29746),
(29747, '3.30.230.130-FF-000077', NULL, 'Cullin family protein', 151, NULL, NULL, 29747),
(29748, '3.30.160.60-FF-003232', NULL, 'Zinc finger domain containing protein', 55, NULL, NULL, 29748),
(29749, '3.80.10.10-FF-003295', NULL, 'Uncharacterized protein', 265, NULL, NULL, 29749),
(29750, '2.60.40.10-FF-002743', NULL, 'Beta-N-acetylhexosaminidase', 64, NULL, NULL, 29750),
(29751, '3.20.20.60-FF-000087', NULL, 'Isocitrate lyase AceAa', 309, NULL, NULL, 29751),
(29752, '3.40.1440.10-FF-000021', NULL, NULL, 85, NULL, NULL, 29752),
(29753, '3.30.160.60-FF-002956', NULL, NULL, 29, NULL, NULL, 29753),
(29754, '3.10.129.10-FF-000013', NULL, 'Peroxisomal multifunctional enzyme type 2', 133, NULL, NULL, 29754),
(29755, '1.10.30.10-FF-000139', NULL, 'Polybromo-1', 59, NULL, NULL, 29755),
(29756, '1.10.510.10-FF-000722', NULL, 'Protein kinase family protein / WD-40 repeat family protein', 326, NULL, NULL, 29756),
(29757, '1.25.40.10-FF-000371', NULL, 'coatomer subunit epsilon isoform X3', 62, NULL, NULL, 29757),
(29758, '2.30.30.40-FF-000128', NULL, 'Peroxisomal membrane protein (Pex13)', 78, NULL, NULL, 29758),
(29759, '4.10.110.20-FF-000003', NULL, 'Variant surface glycoprotein (VSG), putative', 76, NULL, NULL, 29759),
(29760, '3.30.750.24-FF-000095', NULL, 'Uncharacterized protein', 140, NULL, NULL, 29760),
(29761, '1.25.40.10-FF-004592', NULL, 'Putative pentatricopeptide repeat-containing protein At1g74400', 171, NULL, NULL, 29761),
(29762, '1.20.5.990-FF-000017', NULL, 'TNFAIP3 interacting protein 1', 62, NULL, NULL, 29762);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(29763, '3.30.160.60-FF-006447', NULL, NULL, 76, NULL, NULL, 29763),
(29764, '1.20.1180.10-FF-000001', NULL, 'Acyl-[acyl-carrier-protein]--UDP-N-acetylglucosamine O-acyltransferase', 66, NULL, NULL, 29764),
(29765, '2.60.120.10-FF-000351', NULL, 'Putatve signal peptide protein', 121, NULL, NULL, 29765),
(29766, '1.25.40.1040-FF-000025', NULL, 'N-acetyltransferase B complex (NatB) non catalytic subunit, putative', 296, NULL, NULL, 29766),
(29767, '3.40.50.450-FF-000023', NULL, 'DNA processing protein DprA', 282, NULL, NULL, 29767),
(29768, '3.80.10.10-FF-003828', NULL, 'Si:ch211-191d15.2', 71, NULL, NULL, 29768),
(29769, '1.25.40.10-FF-004120', NULL, 'Uncharacterized protein', 129, NULL, NULL, 29769),
(29770, '1.10.442.10-FF-000001', NULL, 'Cytochrome c oxidase subunit 4 isoform 1', 141, NULL, NULL, 29770),
(29771, '3.40.50.10090-FF-000018', NULL, 'Transcriptional regulator, putative', 142, NULL, NULL, 29771),
(29772, '3.30.559.10-FF-000097', NULL, 'Nonribosomal peptide synthase, putative', 185, NULL, NULL, 29772),
(29773, '3.40.309.10-FF-000060', NULL, 'Probable aldehyde dehydrogenase', 198, NULL, NULL, 29773),
(29774, '3.40.50.10330-FF-000046', NULL, 'Diacylglycerol kinase', 91, NULL, NULL, 29774),
(29775, '3.40.800.10-FF-000033', NULL, 'Agmatinase', 280, NULL, NULL, 29775),
(29776, '3.40.30.10-FF-000577', NULL, 'Protein disulfide-isomerase', 103, NULL, NULL, 29776),
(29777, '2.10.70.10-FF-000280', NULL, 'Uncharacterized protein', 75, NULL, NULL, 29777),
(29778, '3.30.160.60-FF-003693', NULL, NULL, 29, NULL, NULL, 29778),
(29779, '1.10.238.10-FF-001050', NULL, 'Calcium-binding protein 2', 100, NULL, NULL, 29779),
(29780, '2.160.20.10-FF-000337', NULL, 'Uncharacterized protein', 312, NULL, NULL, 29780),
(29781, '1.20.1250.20-FF-000066', NULL, 'Uncharacterized MFS-type transporter YcaD', 175, NULL, NULL, 29781),
(29782, '1.10.630.10-FF-000141', NULL, 'Pulcherriminic acid synthase', 406, NULL, NULL, 29782),
(29783, '2.40.160.10-FF-000015', NULL, 'Mitochondrial import receptor subunit tom40', 285, NULL, NULL, 29783),
(29784, '2.30.29.30-FF-000346', NULL, 'Pleckstrin homology domain-containing family H member 2', 101, NULL, NULL, 29784),
(29785, '3.20.20.70-FF-000533', NULL, NULL, 243, NULL, NULL, 29785),
(29786, '3.30.160.20-FF-000123', NULL, 'Glycosyl hydrolase family protein', 87, NULL, NULL, 29786),
(29787, '3.30.200.20-FF-000650', NULL, 'PTI1-like tyrosine-protein kinase 3', 98, NULL, NULL, 29787),
(29788, '1.25.40.320-FF-000009', NULL, 'Uncharacterized protein', 83, NULL, NULL, 29788),
(29789, '2.130.10.10-FF-003749', NULL, 'Uncharacterized protein', 408, NULL, NULL, 29789),
(29790, '3.20.20.140-FF-000339', NULL, 'Glr3518 protein', 163, NULL, NULL, 29790),
(29791, '1.25.10.10-FF-001419', NULL, 'Hypothetical nuclear condensin complex subunit 3 (Eurofung)', 295, NULL, NULL, 29791),
(29792, '3.40.50.300-FF-001485', NULL, 'LPS ABC transporter, ATP-binding protein', 235, NULL, NULL, 29792),
(29793, '3.40.50.1820-FF-000916', NULL, 'Carboxylic ester hydrolase', 503, NULL, NULL, 29793),
(29794, '3.40.50.150-FF-000995', NULL, NULL, 209, NULL, NULL, 29794),
(29795, '2.30.42.10-FF-000332', NULL, 'Leucine-rich repeat-containing protein', 103, NULL, NULL, 29795),
(29796, '3.40.50.300-FF-002474', NULL, 'SWI/SNF chromatin-remodeling complex subunit snf22', 228, NULL, NULL, 29796),
(29797, '3.30.40.10-FF-001000', NULL, 'Protein CBG07411', 115, NULL, NULL, 29797),
(29798, '3.40.50.410-FF-000118', NULL, 'Collagen type VI alpha 6 chain', 187, NULL, NULL, 29798),
(29799, '2.60.120.320-FF-000013', NULL, 'Thiamine pyrophosphokinase', 118, NULL, NULL, 29799),
(29800, '3.30.565.10-FF-000038', NULL, 'Sensor-like histidine kinase', 146, NULL, NULL, 29800),
(29801, '2.60.120.340-FF-000019', NULL, 'Mitotic apparatus protein p62', 118, NULL, NULL, 29801),
(29802, '1.10.20.10-FF-000195', NULL, NULL, 77, NULL, NULL, 29802),
(29803, '3.30.70.330-FF-000398', NULL, 'Polyadenylate-binding protein', 73, NULL, NULL, 29803),
(29804, '1.10.10.10-FF-001739', NULL, 'ATP-dependent DNA helicase', 93, NULL, NULL, 29804),
(29805, '1.10.510.10-FF-000986', NULL, 'Protein tyrosine kinase 2aa', 101, NULL, NULL, 29805);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(29806, '3.90.320.10-FF-000018', NULL, 'RecBCD enzyme subunit RecB', 327, NULL, NULL, 29806),
(29807, '1.50.40.10-FF-000166', NULL, 'Mitochondrial Carrier (MC) Family', 287, NULL, NULL, 29807),
(29808, '2.60.40.10-FF-001647', NULL, 'Uncharacterized protein, isoform C', 102, NULL, NULL, 29808),
(29809, '2.170.140.10-FF-000056', NULL, 'Carbohydrate-binding protein', 63, NULL, NULL, 29809),
(29810, '1.20.1070.10-FF-002056', NULL, 'Uncharacterized protein', 95, NULL, NULL, 29810),
(29811, '3.40.50.2300-FF-001010', NULL, NULL, 103, NULL, NULL, 29811),
(29812, '1.10.10.2210-FF-000007', NULL, 'Telomerase reverse transcriptase', 79, NULL, NULL, 29812),
(29813, '2.130.10.10-FF-000523', NULL, 'Transcriptional modulator', 436, NULL, NULL, 29813),
(29814, '1.20.1740.10-FF-000084', NULL, 'Amino acid permease', 439, NULL, NULL, 29814),
(29815, '2.40.100.10-FF-000006', NULL, 'Peptidyl-prolyl cis-trans isomerase', 166, NULL, NULL, 29815),
(29816, '3.10.580.10-FF-000095', NULL, 'Formate transporter 1', 101, NULL, NULL, 29816),
(29817, '3.90.400.10-FF-000019', NULL, 'Uncharacterized protein', 70, NULL, NULL, 29817),
(29818, '1.10.287.550-FF-000015', NULL, 'Uncharacterized protein', 59, NULL, NULL, 29818),
(29819, '1.25.40.120-FF-000073', NULL, 'Farnesyltransferase, CAAX box, alpha', 109, NULL, NULL, 29819),
(29820, '3.30.1640.30-FF-000011', NULL, NULL, 61, NULL, NULL, 29820),
(29821, '2.102.10.10-FF-000002', NULL, 'Nitrite reductase [NAD(P)H] small subunit', 108, NULL, NULL, 29821),
(29822, '2.40.50.250-FF-000001', NULL, 'GTP-binding protein TypA', 90, NULL, NULL, 29822),
(29823, '1.20.920.10-FF-000043', NULL, 'Transcription initiation factor TFIID subunit 1', 150, NULL, NULL, 29823),
(29824, '3.10.20.90-FF-000208', NULL, 'Small ubiquitin-related modifier', 79, NULL, NULL, 29824),
(29825, '1.10.530.10-FF-000077', NULL, 'Uncharacterized protein', 84, NULL, NULL, 29825),
(29826, '2.10.25.10-FF-001221', NULL, 'Predicted protein', 36, NULL, NULL, 29826),
(29827, '2.10.25.10-FF-001693', NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing 1', 43, NULL, NULL, 29827),
(29828, '1.20.5.110-FF-000192', NULL, 'SNAP receptor', 105, NULL, NULL, 29828),
(29829, '3.40.1160.10-FF-000056', NULL, 'Kinase, putative', 256, NULL, NULL, 29829),
(29830, '1.25.10.10-FF-001858', NULL, 'BRCA1-associated ATM activator 1', 185, NULL, NULL, 29830),
(29831, '1.20.1070.10-FF-001600', NULL, 'Taste receptor type 2', 152, NULL, NULL, 29831),
(29832, '3.20.20.110-FF-000004', NULL, 'Ribulose bisphosphate carboxylase', 303, NULL, NULL, 29832),
(29833, '3.40.50.300-FF-006689', NULL, 'Uncharacterized protein', 81, NULL, NULL, 29833),
(29834, '3.40.630.30-FF-000239', NULL, 'Acetyltransferase, GNAT family protein', 165, NULL, NULL, 29834),
(29835, '3.40.50.2300-FF-000021', NULL, 'Two-component system response regulator KdpE', 80, NULL, NULL, 29835),
(29836, '1.20.1250.20-FF-001022', NULL, 'Os07g0131250 protein', 218, NULL, NULL, 29836),
(29837, '3.80.10.10-FF-002839', NULL, 'Uncharacterized protein', 115, NULL, NULL, 29837),
(29838, '3.40.50.300-FF-006217', NULL, 'Eukaryotic Elongation Factor, SelenoCysteine-tRNA-specific', 111, NULL, NULL, 29838),
(29839, '3.30.40.10-FF-001472', NULL, 'Uncharacterized protein', 78, NULL, NULL, 29839),
(29840, '2.70.98.30-FF-000004', NULL, 'Alpha-mannosidase', 266, NULL, NULL, 29840),
(29841, '3.40.720.10-FF-000032', NULL, 'Choline sulfatase', 453, NULL, NULL, 29841),
(29842, '3.40.50.2300-FF-000493', NULL, 'PTS system mannitol-specific transporter subunit EIIBC', 104, NULL, NULL, 29842),
(29843, '1.20.1250.20-FF-001494', NULL, 'Uncharacterized protein', 435, NULL, NULL, 29843),
(29844, '2.10.110.10-FF-000339', NULL, 'LIM and SH3 domain protein 1', 30, NULL, NULL, 29844),
(29845, '1.20.58.60-FF-000285', NULL, 'Spectrin repeat containing nuclear envelope protein 1', 283, NULL, NULL, 29845),
(29846, '2.40.50.140-FF-001249', NULL, NULL, 81, NULL, NULL, 29846),
(29847, '3.30.499.10-FF-000007', NULL, '3-isopropylmalate dehydratase large subunit', 140, NULL, NULL, 29847),
(29848, '2.40.240.10-FF-000016', NULL, '50S ribosomal protein L25', 108, NULL, NULL, 29848);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(29849, '2.60.40.1280-FF-000003', NULL, 'Sag1p', 156, NULL, NULL, 29849),
(29850, '3.80.10.10-FF-000602', NULL, 'F-box domain containing protein, expressed', 278, NULL, NULL, 29850),
(29851, '2.10.25.10-FF-000265', NULL, 'Dumpy, isoform P', 44, NULL, NULL, 29851),
(29852, '3.40.50.150-FF-001512', NULL, NULL, 110, NULL, NULL, 29852),
(29853, '3.30.160.60-FF-005019', NULL, NULL, 58, NULL, NULL, 29853),
(29854, '1.10.340.30-FF-000080', NULL, 'DNA-3-methyladenine glycosylase II, putative', 105, NULL, NULL, 29854),
(29855, '3.40.1800.20-FF-000030', NULL, NULL, 76, NULL, NULL, 29855),
(29856, '3.30.160.60-FF-002232', NULL, 'Uncharacterized protein, isoform A', 75, NULL, NULL, 29856),
(29857, '1.10.287.370-FF-000085', NULL, 'Probable prefoldin subunit 1', 110, NULL, NULL, 29857),
(29858, '3.40.50.1010-FF-000207', NULL, NULL, 74, NULL, NULL, 29858),
(29859, '3.30.230.70-FF-000060', NULL, 'Ribosomal RNA processing protein 45', 295, NULL, NULL, 29859),
(29860, '3.30.70.240-FF-000051', NULL, 'U5 small nuclear ribonucleoprotein component, putative', 122, NULL, NULL, 29860),
(29861, '3.30.230.130-FF-000004', NULL, 'Cullin 5', 173, NULL, NULL, 29861),
(29862, '2.60.40.10-FF-003625', NULL, NULL, 98, NULL, NULL, 29862),
(29863, '3.30.70.260-FF-000057', NULL, 'Methionine import ATP-binding protein MetN', 97, NULL, NULL, 29863),
(29864, '3.80.30.20-FF-000022', NULL, '(Dimethylallyl)adenosine tRNA methylthiotransferase', 232, NULL, NULL, 29864),
(29865, '1.10.10.60-FF-000984', NULL, NULL, 90, NULL, NULL, 29865),
(29866, '3.40.50.10900-FF-000003', NULL, 'Proteasome assembly chaperone 2', 85, NULL, NULL, 29866),
(29867, '2.40.30.10-FF-000383', NULL, 'Translation elongation factor G', 113, NULL, NULL, 29867),
(29868, '3.30.160.60-FF-004210', NULL, NULL, 24, NULL, NULL, 29868),
(29869, '2.60.40.60-FF-000892', NULL, 'Uncharacterized protein', 115, NULL, NULL, 29869),
(29870, '3.30.300.30-FF-000071', NULL, 'Anthranilate--CoA ligase', 115, NULL, NULL, 29870),
(29871, '3.40.50.10190-FF-000341', NULL, 'Uncharacterized protein', 24, NULL, NULL, 29871),
(29872, '3.40.50.300-FF-002002', NULL, 'GTP-binding nuclear protein', 215, NULL, NULL, 29872),
(29873, '3.40.50.620-FF-000535', NULL, 'Uncharacterized protein', 53, NULL, NULL, 29873),
(29874, '3.90.550.10-FF-000266', NULL, 'AT31631p', 255, NULL, NULL, 29874),
(29875, '1.10.510.10-FF-000514', NULL, 'Putative receptor-like protein kinase', 208, NULL, NULL, 29875),
(29876, '4.10.520.10-FF-000020', NULL, 'Probable DNA-binding protein HU', 95, NULL, NULL, 29876),
(29877, '3.30.70.330-FF-001354', NULL, 'Uncharacterized protein', 85, NULL, NULL, 29877),
(29878, '1.20.5.320-FF-000018', NULL, '6-phosphogluconate dehydrogenase, decarboxylating', 38, NULL, NULL, 29878),
(29879, '3.90.190.10-FF-000283', NULL, 'Protein-tyrosine-phosphatase', 154, NULL, NULL, 29879),
(29880, '1.20.930.20-FF-000018', NULL, 'Cysteine-rich receptor-like protein kinase 8', 110, NULL, NULL, 29880),
(29881, '2.60.260.20-FF-000038', NULL, 'DnaJ heat shock protein family (Hsp40) member B4', 97, NULL, NULL, 29881),
(29882, '2.70.150.10-FF-000154', NULL, 'Phospholipid-transporting ATPase', 147, NULL, NULL, 29882),
(29883, '2.130.10.10-FF-000995', NULL, 'WD repeat domain 27', 234, NULL, NULL, 29883),
(29884, '3.30.365.10-FF-000057', NULL, 'Uncharacterized protein', 52, NULL, NULL, 29884),
(29885, '3.20.20.140-FF-000491', NULL, 'Error-prone DNA polymerase', 277, NULL, NULL, 29885),
(29886, '1.10.390.40-FF-000001', NULL, NULL, 76, NULL, NULL, 29886),
(29887, '1.20.58.80-FF-000032', NULL, 'Os02g0159900 protein', 70, NULL, NULL, 29887),
(29888, '1.10.1040.10-FF-000117', NULL, 'Predicted protein', 103, NULL, NULL, 29888),
(29889, '3.40.50.300-FF-008134', NULL, 'Predicted protein', 103, NULL, NULL, 29889),
(29890, '3.40.50.300-FF-007206', NULL, 'Uncharacterized protein', 166, NULL, NULL, 29890),
(29891, '1.20.1440.90-FF-000017', NULL, NULL, 134, NULL, NULL, 29891),
(29892, '1.10.10.60-FF-000512', NULL, 'Pyruvate carboxylase, mitochondrial', 47, NULL, NULL, 29892),
(29893, '3.40.250.10-FF-000187', NULL, 'Thiosulfate sulfurtransferase', 143, NULL, NULL, 29893);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(29894, '1.25.40.10-FF-001247', NULL, 'TPR repeat/Tetratricopeptide repeat', 134, NULL, NULL, 29894),
(29895, '1.20.1260.140-FF-000002', NULL, 'Alternative oxidase', 269, NULL, NULL, 29895),
(29896, '3.30.1330.10-FF-000015', NULL, 'Hydrogenase expression/formation protein HypE', 155, NULL, NULL, 29896),
(29897, '2.60.490.10-FF-000018', NULL, 'Uncharacterized protein', 118, NULL, NULL, 29897),
(29898, '1.25.10.10-FF-002847', NULL, 'Uncharacterized protein', 512, NULL, NULL, 29898),
(29899, '3.30.70.2570-FF-000003', NULL, NULL, 45, NULL, NULL, 29899),
(29900, '3.40.50.970-FF-000117', NULL, 'Transketolase', 234, NULL, NULL, 29900),
(29901, '3.40.50.1470-FF-000002', NULL, 'Putative aminoacyl-tRNA hydrolase', 187, NULL, NULL, 29901),
(29902, '2.60.40.10-FF-005542', NULL, NULL, 39, NULL, NULL, 29902),
(29903, '3.40.50.300-FF-000057', NULL, 'GTPase Der', 161, NULL, NULL, 29903),
(29904, '3.90.550.50-FF-000019', NULL, 'Hexosyltransferase', 270, NULL, NULL, 29904),
(29905, '3.30.830.10-FF-000026', NULL, 'Cytochrome b-c1 complex subunit 2, mitochondrial', 204, NULL, NULL, 29905),
(29906, '3.30.200.20-FF-001459', NULL, 'Probable serine/threonine-protein kinase ifkB', 119, NULL, NULL, 29906),
(29907, '3.30.160.60-FF-001276', NULL, 'zinc finger protein 425', 28, NULL, NULL, 29907),
(29908, '2.60.120.20-FF-000028', NULL, 'Genome polyprotein', 239, NULL, NULL, 29908),
(29909, '1.10.720.60-FF-000022', NULL, 'Uncharacterized protein', 56, NULL, NULL, 29909),
(29910, '3.40.50.10480-FF-000012', NULL, 'U3 small nucleolar ribonucleoprotein protein IMP4, putative', 183, NULL, NULL, 29910),
(29911, '3.50.50.60-FF-000992', NULL, 'Neither inactivation nor afterpotential protein G', 226, NULL, NULL, 29911),
(29912, '2.20.100.10-FF-000229', NULL, 'Putative semaphorin', 69, NULL, NULL, 29912),
(29913, '1.20.1070.10-FF-000139', NULL, 'RPE-retinal G protein-coupled receptor isoform X1', 283, NULL, NULL, 29913),
(29914, '1.10.287.70-FF-000545', NULL, 'Cytochrome c oxidase subunit 3', 69, NULL, NULL, 29914),
(29915, '3.40.190.10-FF-000569', NULL, 'Hydroxymethylbilane synthase (Porphobilinogen deaminase)', 60, NULL, NULL, 29915),
(29916, '3.30.40.10-FF-000483', NULL, 'E3 ubiquitin-protein ligase SINAT3', 104, NULL, NULL, 29916),
(29917, '3.10.129.10-FF-000058', NULL, 'Sterigmatocystin biosynthesis fatty acid synthase subunit beta', 281, NULL, NULL, 29917),
(29918, '2.20.25.10-FF-000124', NULL, 'Predicted protein', 123, NULL, NULL, 29918),
(29919, '3.40.50.1820-FF-001052', NULL, 'Retinoid-inducible serine carboxypeptidase', 422, NULL, NULL, 29919),
(29920, '1.10.720.30-FF-000007', NULL, 'X-ray repair cross complementing 6', 51, NULL, NULL, 29920),
(29921, '3.40.1360.10-FF-000037', NULL, 'Twinkle homolog protein, chloroplastic/mitochondrial', 143, NULL, NULL, 29921),
(29922, '3.30.390.30-FF-000048', NULL, 'Apoptosis-inducing factor 1, mitochondrial', 97, NULL, NULL, 29922),
(29923, '1.20.1560.10-FF-000839', NULL, 'Uncharacterized protein', 337, NULL, NULL, 29923),
(29924, '1.25.40.20-FF-000115', NULL, 'Ankyrin repeat and BTB/POZ domain-containing protein 1', 98, NULL, NULL, 29924),
(29925, '1.10.260.100-FF-000035', NULL, 'Stress-induced phosphoprotein 1', 42, NULL, NULL, 29925),
(29926, '1.10.238.10-FF-000914', NULL, 'EF-hand calcium-binding domain-containing protein 6-like', 82, NULL, NULL, 29926),
(29927, '1.10.287.130-FF-000125', NULL, 'Signal transduction histidine kinase', 94, NULL, NULL, 29927),
(29928, '1.10.10.10-FF-000430', NULL, 'Transcription factor E2F4', 41, NULL, NULL, 29928),
(29929, '1.20.1070.10-FF-001067', NULL, 'G-protein coupled receptor GRL101-like protein', 365, NULL, NULL, 29929),
(29930, '1.25.40.180-FF-000304', NULL, NULL, 73, NULL, NULL, 29930),
(29931, '3.40.50.720-FF-000739', NULL, '2-dehydropantoate 2-reductase', 187, NULL, NULL, 29931),
(29932, '3.10.120.10-FF-000038', NULL, 'Nitrate reductase', 87, NULL, NULL, 29932),
(29933, '1.10.510.10-FF-003892', NULL, NULL, 87, NULL, NULL, 29933),
(29934, '3.80.10.10-FF-003036', NULL, 'Uncharacterized protein', 165, NULL, NULL, 29934),
(29935, '3.40.50.300-FF-003463', NULL, 'DNA helicase', 341, NULL, NULL, 29935);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(29936, '3.40.50.11840-FF-000015', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', 86, NULL, NULL, 29936),
(29937, '1.25.40.10-FF-000258', NULL, 'DnaJ domain containing protein', 330, NULL, NULL, 29937),
(29938, '1.10.565.10-FF-000101', NULL, 'Nuclear Hormone Receptor family', 253, NULL, NULL, 29938),
(29939, '3.40.50.300-FF-007145', NULL, 'Mitochondrial escape protein 2', 176, NULL, NULL, 29939),
(29940, '1.20.120.1080-FF-000056', NULL, 'probable ATP-dependent RNA helicase DHX34', 145, NULL, NULL, 29940),
(29941, '1.20.120.1760-FF-000046', NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', 184, NULL, NULL, 29941),
(29942, '1.25.10.10-FF-003336', NULL, 'Ecm29p', 256, NULL, NULL, 29942),
(29943, '3.30.160.60-FF-005458', NULL, NULL, 33, NULL, NULL, 29943),
(29944, '2.60.40.60-FF-000420', NULL, 'Cadherin 74A, isoform A', 107, NULL, NULL, 29944),
(29945, '2.170.300.10-FF-000058', NULL, 'Uncharacterized protein', 104, NULL, NULL, 29945),
(29946, '3.40.50.510-FF-000002', NULL, 'PTS-dependent dihydroxyacetone kinase, DhaM subunit', 132, NULL, NULL, 29946),
(29947, '3.60.130.10-FF-000050', NULL, 'Butyrobetaine (gamma), 2-oxoglutarate dioxygenase (gamma-butyrobetaine hydroxylase) 1', 182, NULL, NULL, 29947),
(29948, '1.20.1250.20-FF-000858', NULL, 'Uncharacterized protein', 216, NULL, NULL, 29948),
(29949, '3.10.20.280-FF-000001', NULL, 'Protein RnfH', 85, NULL, NULL, 29949),
(29950, '3.30.200.20-FF-001959', NULL, 'CMGC family protein kinase', 105, NULL, NULL, 29950),
(29951, '1.10.287.110-FF-000406', NULL, 'DnaJ homolog subfamily C member 11 homolog', 107, NULL, NULL, 29951),
(29952, '3.40.50.720-FF-002364', NULL, 'Uncharacterized protein', 136, NULL, NULL, 29952),
(29953, '3.30.70.20-FF-000049', NULL, '4Fe-4S dicluster domain-containing protein', 70, NULL, NULL, 29953),
(29954, '2.120.10.30-FF-000350', NULL, 'Peptidylglycine alpha-amidating monooxygenase', 187, NULL, NULL, 29954),
(29955, '2.60.40.10-FF-005981', NULL, NULL, 96, NULL, NULL, 29955),
(29956, '2.30.29.30-FF-000785', NULL, 'Syntrophin alpha 1', 49, NULL, NULL, 29956),
(29957, '3.40.50.2000-FF-000993', NULL, 'Os05g0527600 protein', 48, NULL, NULL, 29957),
(29958, '3.40.50.720-FF-001728', NULL, 'Homoserine dehydrogenase', 163, NULL, NULL, 29958),
(29959, '3.30.1050.10-FF-000033', NULL, 'Os01g0357200 protein', 88, NULL, NULL, 29959),
(29960, '1.10.287.110-FF-000086', NULL, 'Chaperone protein dnaJ 10', 83, NULL, NULL, 29960),
(29961, '2.60.40.10-FF-002636', NULL, '2 (Zwei) IG domain protein', 100, NULL, NULL, 29961),
(29962, '1.10.3200.20-FF-000009', NULL, NULL, 167, NULL, NULL, 29962),
(29963, '3.30.160.60-FF-000787', NULL, 'Zinc finger protein 784', 28, NULL, NULL, 29963),
(29964, '3.40.50.300-FF-001838', NULL, 'Protein GCN20', 279, NULL, NULL, 29964),
(29965, '1.20.1070.10-FF-001128', NULL, 'Vomeronasal type-1 receptor', 303, NULL, NULL, 29965),
(29966, '1.25.10.10-FF-000610', NULL, 'Exportin 1', 1019, NULL, NULL, 29966),
(29967, '1.20.58.150-FF-000006', NULL, 'putative clathrin assembly protein At5g35200', 153, NULL, NULL, 29967),
(29968, '2.60.120.10-FF-000790', NULL, 'Cyclic nucleotide-binding domain containing protein', 141, NULL, NULL, 29968),
(29969, '2.30.30.40-FF-000420', NULL, 'Predicted protein', 68, NULL, NULL, 29969),
(29970, '3.30.200.20-FF-002448', NULL, 'Tyrosine-protein kinase', 60, NULL, NULL, 29970),
(29971, '1.25.40.10-FF-002203', NULL, 'Uncharacterized protein OSJNBa0026C08.24', 128, NULL, NULL, 29971),
(29972, '3.40.50.1820-FF-001113', NULL, 'Uncharacterized protein, isoform C', 134, NULL, NULL, 29972),
(29973, '3.40.50.920-FF-000035', NULL, 'Putative 2-ketoglutarate ferredoxin oxidoreductase (Alpha)', 116, NULL, NULL, 29973),
(29974, '3.30.470.10-FF-000043', NULL, 'Branched-chain amino-acid transaminase, putative (Eurofung)', 71, NULL, NULL, 29974),
(29975, '3.40.50.410-FF-000270', NULL, 'DNA binding protein', 114, NULL, NULL, 29975),
(29976, '2.130.10.10-FF-003396', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 209, NULL, NULL, 29976),
(29977, '3.30.930.10-FF-000123', NULL, 'Lysine--tRNA ligase', 372, NULL, NULL, 29977);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(29978, '3.10.50.40-FF-000015', NULL, 'Peptidyl-prolyl cis-trans isomerase', 99, NULL, NULL, 29978),
(29979, '3.40.50.2300-FF-001269', NULL, NULL, 199, NULL, NULL, 29979),
(29980, '1.10.510.10-FF-001183', NULL, 'CAMK/CAMKL protein kinase', 204, NULL, NULL, 29980),
(29981, '3.30.9.10-FF-000039', NULL, 'Glycerol-3-phosphate dehydrogenase', 161, NULL, NULL, 29981),
(29982, '1.10.510.10-FF-001503', NULL, 'Protein kinase domain containing protein', 281, NULL, NULL, 29982),
(29983, '1.25.40.10-FF-000730', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 101, NULL, NULL, 29983),
(29984, '2.130.10.10-FF-004205', NULL, 'Plexin B1b', 156, NULL, NULL, 29984),
(29985, '1.20.1270.60-FF-000293', NULL, 'Uncharacterized protein', 153, NULL, NULL, 29985),
(29986, '3.30.160.60-FF-003221', NULL, NULL, 28, NULL, NULL, 29986),
(29987, '1.20.1070.10-FF-000291', NULL, 'Predicted protein', 290, NULL, NULL, 29987),
(29988, '3.30.40.10-FF-000544', NULL, 'FYVE, RhoGEF and PH domain containing 3', 80, NULL, NULL, 29988),
(29989, '1.20.1070.10-FF-000611', NULL, 'NMUR (NeuroMedin U Receptor) homolog', 360, NULL, NULL, 29989),
(29990, '1.10.10.800-FF-000005', NULL, 'Alpha/beta superfamily hydrolase, putative (AFU_orthologue AFUA_2G16580)', 58, NULL, NULL, 29990),
(29991, '3.40.50.11610-FF-000031', NULL, NULL, 180, NULL, NULL, 29991),
(29992, '2.40.50.550-FF-000001', NULL, 'Tetratricopeptide repeat domain 5', 158, NULL, NULL, 29992),
(29993, '3.40.50.970-FF-000089', NULL, 'Putative indole-3-pyruvate decarboxylase', 178, NULL, NULL, 29993),
(29994, '1.20.1560.10-FF-000778', NULL, 'Uncharacterized protein', 290, NULL, NULL, 29994),
(29995, '1.10.132.20-FF-000020', NULL, 'Putative ribosomal recycling factor, mitochondrial', 93, NULL, NULL, 29995),
(29996, '1.20.58.60-FF-000638', NULL, 'Uncharacterized protein', 286, NULL, NULL, 29996),
(29997, '2.60.40.10-FF-003125', NULL, NULL, 106, NULL, NULL, 29997),
(29998, '1.20.900.10-FF-000013', NULL, 'FYVE, RhoGEF and PH domain-containing protein 4', 209, NULL, NULL, 29998),
(29999, '1.20.5.1430-FF-000018', NULL, 'EB1-like C-terminal motif containing protein, putative', 61, NULL, NULL, 29999),
(30000, '1.10.8.1310-FF-000018', NULL, 'Uncharacterized protein', 122, NULL, NULL, 30000),
(30001, '1.10.287.1490-FF-000135', NULL, 'Uncharacterized protein', 40, NULL, NULL, 30001),
(30002, '3.40.50.300-FF-000557', NULL, 'Genome polyprotein', 149, NULL, NULL, 30002),
(30003, '3.60.20.10-FF-000177', NULL, NULL, 128, NULL, NULL, 30003),
(30004, '3.30.40.10-FF-000983', NULL, 'Uncharacterized protein', 112, NULL, NULL, 30004),
(30005, '1.10.3720.10-FF-000147', NULL, 'Phosphate ABC transporter permease', 266, NULL, NULL, 30005),
(30006, '1.10.287.3240-FF-000008', NULL, 'V-type H+-transporting ATPase subunit D', 212, NULL, NULL, 30006),
(30007, '1.10.533.10-FF-000230', NULL, 'Putative BOI-related E3 ubiquitin-protein ligase 3', 131, NULL, NULL, 30007),
(30008, '3.40.50.150-FF-000170', NULL, 'Probable methyltransferase PMT6', 187, NULL, NULL, 30008),
(30009, '1.10.10.10-FF-001678', NULL, 'SirR/DtxR family transcription regulator Idr1', 125, NULL, NULL, 30009),
(30010, '1.10.510.10-FF-003920', NULL, NULL, 75, NULL, NULL, 30010),
(30011, '1.10.238.10-FF-000414', NULL, 'CAMK/CDPK protein kinase', 87, NULL, NULL, 30011),
(30012, '3.30.160.60-FF-005519', NULL, NULL, 28, NULL, NULL, 30012),
(30013, '2.60.40.10-FF-000719', NULL, 'nephrin isoform X1', 99, NULL, NULL, 30013),
(30014, '3.60.10.10-FF-000384', NULL, 'Uncharacterized protein', 72, NULL, NULL, 30014),
(30015, '3.20.20.190-FF-000073', NULL, 'WGS project CABT00000000 data, contig 2.28', 251, NULL, NULL, 30015),
(30016, '2.40.50.140-FF-001188', NULL, NULL, 130, NULL, NULL, 30016),
(30017, '1.10.1420.10-FF-000135', NULL, 'Uncharacterized protein', 66, NULL, NULL, 30017),
(30018, '1.25.10.10-FF-001066', NULL, 'Exportin-4', 326, NULL, NULL, 30018),
(30019, '3.40.50.300-FF-000849', NULL, 'ATP-dependent RNA helicase DBP5', 229, NULL, NULL, 30019),
(30020, '1.25.40.20-FF-001104', NULL, 'Ankyrin repeat protein', 59, NULL, NULL, 30020);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(30021, '2.130.10.10-FF-001451', NULL, 'Autophagy-related protein 18g', 222, NULL, NULL, 30021),
(30022, '1.25.40.10-FF-002675', NULL, 'Coatomer subunit epsilon-1', 100, NULL, NULL, 30022),
(30023, '3.40.1190.20-FF-000066', NULL, 'PfkB-type carbohydrate kinase family protein', 333, NULL, NULL, 30023),
(30024, '1.10.8.270-FF-000096', NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', 105, NULL, NULL, 30024),
(30025, '1.10.10.60-FF-000012', NULL, 'Metastasis-associated 1 family, member 3', 65, NULL, NULL, 30025),
(30026, '3.20.20.80-FF-000362', NULL, 'Putative 4-alpha-glucanotransferase / amylo-1,6-glucosidase (Glycogen-debranching enzyme)', 282, NULL, NULL, 30026),
(30027, '1.25.40.10-FF-005081', NULL, 'Uncharacterized protein', 91, NULL, NULL, 30027),
(30028, '2.60.40.10-FF-003564', NULL, NULL, 118, NULL, NULL, 30028),
(30029, '1.10.287.70-FF-000045', NULL, 'Glutamate receptor, ionotropic, delta 2', 149, NULL, NULL, 30029),
(30030, '3.40.1500.10-FF-000009', NULL, 'Coproporphyrinogen-III oxidase', 307, NULL, NULL, 30030),
(30031, '2.60.120.200-FF-000562', NULL, 'Galectin', 34, NULL, NULL, 30031),
(30032, '3.80.10.10-FF-004464', NULL, 'Uncharacterized protein', 295, NULL, NULL, 30032),
(30033, '2.60.120.260-FF-000001', NULL, 'Ephrin type-A receptor 7', 178, NULL, NULL, 30033),
(30034, '1.10.472.10-FF-000149', NULL, 'Histone-lysine N-methyltransferase', 142, NULL, NULL, 30034),
(30035, '3.10.490.20-FF-000006', NULL, 'Dynein axonemal heavy chain 10', 141, NULL, NULL, 30035),
(30036, '3.40.50.150-FF-000462', NULL, 'Methyltransferase-like protein 13', 237, NULL, NULL, 30036),
(30037, '3.30.565.10-FF-000538', NULL, 'Two component signal transduction system histidine kinase with CHASE and PAS sensory domains', 155, NULL, NULL, 30037),
(30038, '2.130.10.10-FF-005666', NULL, 'Glr0823 protein', 163, NULL, NULL, 30038),
(30039, '2.60.40.10-FF-002136', NULL, 'Blast:CD109 antigen', 122, NULL, NULL, 30039),
(30040, '2.130.10.10-FF-002940', NULL, 'Uncharacterized protein', 294, NULL, NULL, 30040),
(30041, '3.40.1000.10-FF-000016', NULL, 'PsbP domain-containing protein 3, chloroplastic', 169, NULL, NULL, 30041),
(30042, '3.30.160.60-FF-000287', NULL, 'PR domain zinc finger protein 10', 27, NULL, NULL, 30042),
(30043, '1.25.40.20-FF-000087', NULL, 'Ankyrin repeat domain-containing protein 27', 197, NULL, NULL, 30043),
(30044, '1.10.510.10-FF-002431', NULL, NULL, 137, NULL, NULL, 30044),
(30045, '3.30.465.10-FF-000093', NULL, 'FAD-linked oxidoreductase afoF', 214, NULL, NULL, 30045),
(30046, '3.30.200.20-FF-000178', NULL, 'serine/threonine-protein kinase PBS1-like', 107, NULL, NULL, 30046),
(30047, '3.80.10.10-FF-000282', NULL, 'Nucleotide-binding oligomerization domain-containing protein 1', 93, NULL, NULL, 30047),
(30048, '3.50.30.30-FF-000122', NULL, 'Uncharacterized protein', 50, NULL, NULL, 30048),
(30049, '1.10.10.10-FF-001239', NULL, 'Cullin family protein', 69, NULL, NULL, 30049),
(30050, '3.90.1170.20-FF-000008', NULL, 'Probable nicotinate-nucleotide pyrophosphorylase [carboxylating]', 127, NULL, NULL, 30050),
(30051, '3.30.40.10-FF-001500', NULL, 'Ubiquitin-protein ligase', 76, NULL, NULL, 30051),
(30052, '3.40.50.150-FF-000023', NULL, 'Ribosomal RNA small subunit methyltransferase A', 206, NULL, NULL, 30052),
(30053, '2.60.120.1040-FF-000004', NULL, 'Zinc finger protein ZPR1', 138, NULL, NULL, 30053),
(30054, '3.90.640.10-FF-000065', NULL, 'Heat shock protein', 84, NULL, NULL, 30054),
(30055, '3.30.420.40-FF-000700', NULL, 'Carbohydrate kinase FGGY', 238, NULL, NULL, 30055),
(30056, '1.20.1310.10-FF-000147', NULL, NULL, 109, NULL, NULL, 30056),
(30057, '2.130.10.30-FF-000029', NULL, 'Secretion-regulating guanine nucleotide exchange factor', 244, NULL, NULL, 30057),
(30058, '1.25.40.10-FF-001186', NULL, 'OSJNBa0006B20.8 protein', 86, NULL, NULL, 30058),
(30059, '3.30.50.10-FF-000129', NULL, 'Nuclear receptor, putative', 68, NULL, NULL, 30059),
(30060, '1.10.520.10-FF-000020', NULL, 'Peroxisomal ascorbate peroxidase', 112, NULL, NULL, 30060),
(30061, '3.30.540.30-FF-000026', NULL, 'Uncharacterized protein', 95, NULL, NULL, 30061);
INSERT INTO "PUBLIC"."MODEL" VALUES
(30062, '3.10.110.10-FF-000212', NULL, 'Ubiquitin E2 (Conjugating enzyme) variant', 160, NULL, NULL, 30062),
(30063, '3.20.20.70-FF-000180', NULL, 'Epimerase', 229, NULL, NULL, 30063),
(30064, '1.10.510.10-FF-000486', NULL, 'E3 ubiquitin-protein ligase KEG', 213, NULL, NULL, 30064),
(30065, '3.90.190.10-FF-000311', NULL, 'Protein CBG15664', 142, NULL, NULL, 30065),
(30066, '2.50.20.10-FF-000005', NULL, 'Outer membrane lipoprotein carrier protein LolA', 201, NULL, NULL, 30066),
(30067, '1.20.1420.10-FF-000037', NULL, NULL, 150, NULL, NULL, 30067),
(30068, '1.20.1110.10-FF-000227', NULL, 'Sodium/potassium-transporting ATPase subunit alpha', 407, NULL, NULL, 30068),
(30069, '1.25.40.20-FF-001576', NULL, 'Ankyrin repeat family protein', 172, NULL, NULL, 30069),
(30070, '3.40.50.1820-FF-000416', NULL, 'Carboxypeptidase', 421, NULL, NULL, 30070),
(30071, '1.20.1070.10-FF-002117', NULL, 'Predicted protein', 189, NULL, NULL, 30071),
(30072, '1.10.472.80-FF-000209', NULL, NULL, 128, NULL, NULL, 30072),
(30073, '3.10.100.10-FF-000155', NULL, 'Serum lectin isoform 1', 147, NULL, NULL, 30073),
(30074, '3.40.50.170-FF-000029', NULL, 'Phosphoribosylglycinamide formyltransferase', 203, NULL, NULL, 30074),
(30075, '1.10.287.70-FF-000192', NULL, 'Glutamate receptor, ionotropic kainate', 130, NULL, NULL, 30075),
(30076, '2.115.10.20-FF-000011', NULL, 'Glycosyl hydrolases family 32 superfamily', 390, NULL, NULL, 30076),
(30077, '3.80.10.10-FF-000574', NULL, 'Jetlag, isoform A', 161, NULL, NULL, 30077),
(30078, '1.10.510.10-FF-001003', NULL, 'STE/STE20 protein kinase', 310, NULL, NULL, 30078),
(30079, '1.10.1040.50-FF-000022', NULL, NULL, 83, NULL, NULL, 30079),
(30080, '1.10.150.780-FF-000006', NULL, 'Probable vacuolar protein sorting-associated protein 16 homolog', 100, NULL, NULL, 30080),
(30081, '3.30.750.24-FF-000156', NULL, 'Uncharacterized protein', 115, NULL, NULL, 30081),
(30082, '3.40.50.1460-FF-000084', NULL, 'Uncharacterized protein', 226, NULL, NULL, 30082),
(30083, '3.90.1110.10-FF-000030', NULL, NULL, 38, NULL, NULL, 30083),
(30084, '2.130.10.10-FF-000170', NULL, 'lethal(2) giant larvae protein homolog 2 isoform X2', 102, NULL, NULL, 30084),
(30085, '3.20.20.70-FF-000472', NULL, 'N,N''-diacetyllegionaminic acid synthase', 264, NULL, NULL, 30085),
(30086, '3.30.565.10-FF-000510', NULL, 'Two-component sensor histidine kinase', 159, NULL, NULL, 30086),
(30087, '3.90.190.10-FF-000603', NULL, 'Protein tyrosine phosphatase 69D, drome, putative', 176, NULL, NULL, 30087),
(30088, '1.25.40.10-FF-003956', NULL, 'Uncharacterized protein', 256, NULL, NULL, 30088),
(30089, '3.30.70.330-FF-002343', NULL, NULL, 166, NULL, NULL, 30089),
(30090, '1.25.10.10-FF-001919', NULL, 'Serine/threonine-protein kinase TOR', 275, NULL, NULL, 30090),
(30091, '3.30.420.110-FF-000081', NULL, 'Uncharacterized protein', 128, NULL, NULL, 30091),
(30092, '2.10.220.10-FF-000201', NULL, 'Proprotein convertase subtilisin/kexin type 5', 60, NULL, NULL, 30092),
(30093, '3.40.30.10-FF-000605', NULL, 'Glutaredoxin', 101, NULL, NULL, 30093),
(30094, '1.20.120.810-FF-000007', NULL, 'Vinculin', 183, NULL, NULL, 30094),
(30095, '1.25.40.420-FF-000073', NULL, 'Uncharacterized protein', 83, NULL, NULL, 30095),
(30096, '3.40.250.10-FF-000007', NULL, 'Thiosulfate sulfurtransferase GlpE', 108, NULL, NULL, 30096),
(30097, '1.10.10.60-FF-000804', NULL, NULL, 70, NULL, NULL, 30097),
(30098, '3.90.660.10-FF-000095', NULL, NULL, 114, NULL, NULL, 30098),
(30099, '3.30.559.70-FF-000036', NULL, 'Uncharacterized protein', 65, NULL, NULL, 30099),
(30100, '3.40.640.10-FF-000470', NULL, 'Uncharacterized protein', 112, NULL, NULL, 30100),
(30101, '3.90.70.10-FF-000881', NULL, 'Uncharacterized protein', 297, NULL, NULL, 30101),
(30102, '3.90.700.10-FF-000003', NULL, 'Fumarate reductase flavoprotein subunit', 130, NULL, NULL, 30102),
(30103, '3.30.460.50-FF-000003', NULL, 'RNA polymerase I', 113, NULL, NULL, 30103),
(30104, '3.30.160.270-FF-000012', NULL, 'Putative 2-isopropylmalate synthase', 118, NULL, NULL, 30104),
(30105, '3.90.1580.10-FF-000025', NULL, 'Uncharacterized protein', 284, NULL, NULL, 30105);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(30106, '1.10.472.10-FF-000121', NULL, 'Transcription factor IIIB', 101, NULL, NULL, 30106),
(30107, '3.40.50.1000-FF-000530', NULL, NULL, 98, NULL, NULL, 30107),
(30108, '3.30.40.10-FF-000191', NULL, 'Chromodomain helicase DNA binding protein 3', 61, NULL, NULL, 30108),
(30109, '1.20.1280.50-FF-000049', NULL, 'F-box protein 41', 31, NULL, NULL, 30109),
(30110, '2.60.40.10-FF-005250', NULL, NULL, 88, NULL, NULL, 30110),
(30111, '1.25.40.10-FF-003164', NULL, 'Pentatricopeptide repeat-containing protein', 114, NULL, NULL, 30111),
(30112, '2.80.10.50-FF-000133', NULL, 'Uncharacterized protein', 61, NULL, NULL, 30112),
(30113, '3.40.50.2300-FF-001510', NULL, NULL, 97, NULL, NULL, 30113),
(30114, '3.40.5.10-FF-000008', NULL, '50S ribosomal protein L9', 52, NULL, NULL, 30114),
(30115, '3.10.100.10-FF-000447', NULL, NULL, 157, NULL, NULL, 30115),
(30116, '3.30.70.3250-FF-000016', NULL, NULL, 129, NULL, NULL, 30116),
(30117, '3.40.50.20-FF-000025', NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', 110, NULL, NULL, 30117),
(30118, '3.30.710.10-FF-000079', NULL, 'Kelch-like family, member 42', 156, NULL, NULL, 30118),
(30119, '2.130.10.10-FF-005374', NULL, 'Uncharacterized protein', 163, NULL, NULL, 30119),
(30120, '1.10.510.10-FF-001975', NULL, NULL, 68, NULL, NULL, 30120),
(30121, '3.40.50.300-FF-005380', NULL, 'ATP binding cassette subfamily B member 4', 18, NULL, NULL, 30121),
(30122, '3.30.70.100-FF-000003', NULL, 'Protein NipSnap homolog 2', 105, NULL, NULL, 30122),
(30123, '1.20.1250.20-FF-001314', NULL, 'Uncharacterized protein', 142, NULL, NULL, 30123),
(30124, '3.30.70.330-FF-001707', NULL, NULL, 138, NULL, NULL, 30124),
(30125, '3.40.50.300-FF-004891', NULL, 'Si:dkey-120c6.5', 220, NULL, NULL, 30125),
(30126, '2.40.170.20-FF-000081', NULL, 'SusC/RagA family TonB-linked outer membrane protein', 637, NULL, NULL, 30126),
(30127, '1.20.5.710-FF-000012', NULL, 'CG5012', 58, NULL, NULL, 30127),
(30128, '2.80.10.50-FF-000280', NULL, 'Cellulase containing protein', 72, NULL, NULL, 30128),
(30129, '1.10.1410.10-FF-000045', NULL, 'poly(A) RNA polymerase, mitochondrial', 188, NULL, NULL, 30129),
(30130, '2.10.10.20-FF-000009', NULL, 'Chitin-binding protein', 45, NULL, NULL, 30130),
(30131, '3.30.420.10-FF-000332', NULL, 'DNA polymerase', 342, NULL, NULL, 30131),
(30132, '3.80.10.10-FF-002108', NULL, 'Uncharacterized protein', 157, NULL, NULL, 30132),
(30133, '1.20.1260.10-FF-000002', NULL, 'Ferritin, mitochondrial', 179, NULL, NULL, 30133),
(30134, '2.60.40.60-FF-000392', NULL, 'Cadherin 2', 90, NULL, NULL, 30134),
(30135, '3.40.630.10-FF-000233', NULL, 'Uncharacterized protein', 81, NULL, NULL, 30135),
(30136, '2.130.10.10-FF-003688', NULL, 'F-box/WD repeat-containing protein mec-15', 210, NULL, NULL, 30136),
(30137, '2.60.40.150-FF-000335', NULL, 'No pollen', 136, NULL, NULL, 30137),
(30138, '2.10.25.10-FF-001193', NULL, 'Laminin subunit gamma 1', 53, NULL, NULL, 30138),
(30139, '3.60.10.10-FF-000092', NULL, 'Type I inositol polyphosphate 5-phosphatase 5', 143, NULL, NULL, 30139),
(30140, '3.40.50.2000-FF-001010', NULL, 'Uncharacterized protein', 191, NULL, NULL, 30140),
(30141, '2.130.10.10-FF-004738', NULL, 'Uncharacterized protein', 163, NULL, NULL, 30141),
(30142, '2.60.40.10-FF-001208', NULL, 'Hibris, isoform B', 97, NULL, NULL, 30142),
(30143, '3.40.50.1260-FF-000057', NULL, 'Phosphoglycerate kinase', 38, NULL, NULL, 30143),
(30144, '3.30.505.10-FF-000181', NULL, NULL, 109, NULL, NULL, 30144),
(30145, '3.40.120.10-FF-000003', NULL, 'Phosphoglucosamine mutase', 107, NULL, NULL, 30145),
(30146, '3.40.50.300-FF-004711', NULL, 'Uncharacterized protein', 160, NULL, NULL, 30146),
(30147, '2.130.10.10-FF-001479', NULL, 'BnaA02g13180D protein', 190, NULL, NULL, 30147),
(30148, '3.30.40.10-FF-000836', NULL, 'RING-H2 finger protein ATL40', 85, NULL, NULL, 30148),
(30149, '1.25.40.180-FF-000276', NULL, NULL, 172, NULL, NULL, 30149),
(30150, '3.30.505.10-FF-000029', NULL, 'Suppressor of cytokine signaling 7', 179, NULL, NULL, 30150),
(30151, '3.80.10.10-FF-001058', NULL, 'Protein phosphatase 1 regulatory subunit SDS22', 108, NULL, NULL, 30151);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(30152, '3.30.160.60-FF-004710', NULL, NULL, 27, NULL, NULL, 30152),
(30153, '1.20.5.110-FF-000012', NULL, 'Mitofusin 2', 62, NULL, NULL, 30153),
(30154, '3.30.70.120-FF-000009', NULL, 'ATP phosphoribosyltransferase', 72, NULL, NULL, 30154),
(30155, '3.90.79.10-FF-000018', NULL, '39S ribosomal protein L46, mitochondrial', 137, NULL, NULL, 30155),
(30156, '3.40.50.2000-FF-000521', NULL, 'Scopoletin glucosyltransferase', 51, NULL, NULL, 30156),
(30157, '1.20.80.10-FF-000063', NULL, 'Predicted protein', 107, NULL, NULL, 30157),
(30158, '2.130.10.10-FF-000815', NULL, 'Aladin WD repeat nucleoporin', 230, NULL, NULL, 30158),
(30159, '3.40.50.1820-FF-000596', NULL, 'Putative lipase domain protein', 258, NULL, NULL, 30159),
(30160, '1.20.1270.60-FF-000321', NULL, 'Ubp4-interactor sfp47', 129, NULL, NULL, 30160),
(30161, '2.60.40.10-FF-002928', NULL, 'Contactin 2', 96, NULL, NULL, 30161),
(30162, '1.10.418.10-FF-000007', NULL, 'Microtubule-associated protein, RP/EB family, member 2', 130, NULL, NULL, 30162),
(30163, '3.50.50.60-FF-001037', NULL, 'Leucine zipper like transcription regulator 1', 67, NULL, NULL, 30163),
(30164, '3.40.47.10-FF-000200', NULL, NULL, 208, NULL, NULL, 30164),
(30165, '3.90.70.40-FF-000013', NULL, 'JOSephin Domain protein', 156, NULL, NULL, 30165),
(30166, '2.30.30.140-FF-000157', NULL, 'Histone-lysine N-methyltransferase', 103, NULL, NULL, 30166),
(30167, '1.25.40.280-FF-000008', NULL, 'Unplaced genomic scaffold supercont1.16, whole genome shotgun sequence', 423, NULL, NULL, 30167),
(30168, '1.20.1250.20-FF-000566', NULL, 'Uncharacterized protein', 83, NULL, NULL, 30168),
(30169, '3.20.20.70-FF-000033', NULL, 'Pyruvate carboxylase', 518, NULL, NULL, 30169),
(30170, '3.30.70.270-FF-000239', NULL, NULL, 181, NULL, NULL, 30170),
(30171, '3.80.10.10-FF-004317', NULL, 'Toll-like receptor 13', 206, NULL, NULL, 30171),
(30172, '3.30.1010.10-FF-000087', NULL, 'Serine/threonine-protein kinase MEC1', 165, NULL, NULL, 30172),
(30173, '3.40.50.300-FF-002502', NULL, 'Protein TRIGALACTOSYLDIACYLGLYCEROL 3, chloroplastic', 265, NULL, NULL, 30173),
(30174, '1.10.10.10-FF-001386', NULL, 'Forkhead transcription factor required for pathogenic development', 109, NULL, NULL, 30174),
(30175, '1.10.238.10-FF-000122', NULL, 'Centrin 3', 80, NULL, NULL, 30175),
(30176, '3.40.50.40-FF-000003', NULL, 'L-asparaginase 2', 118, NULL, NULL, 30176),
(30177, '1.25.10.10-FF-001358', NULL, 'Exportin-T', 1003, NULL, NULL, 30177),
(30178, '1.25.10.10-FF-003044', NULL, 'Uncharacterized protein', 290, NULL, NULL, 30178),
(30179, '1.10.565.10-FF-000073', NULL, 'Retinoic acid receptor beta', 244, NULL, NULL, 30179),
(30180, '3.30.1490.180-FF-000001', NULL, 'DNA-directed RNA polymerase subunit', 60, NULL, NULL, 30180),
(30181, '1.25.40.860-FF-000002', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 127, NULL, NULL, 30181),
(30182, '3.40.50.300-FF-005228', NULL, '50S ribosome-binding GTPase, putative', 202, NULL, NULL, 30182),
(30183, '3.30.160.60-FF-001304', NULL, 'Zinc finger protein 366', 31, NULL, NULL, 30183),
(30184, '1.10.3590.10-FF-000001', NULL, 'acid-sensing ion channel 1 isoform X2', 77, NULL, NULL, 30184),
(30185, '3.10.20.90-FF-000360', NULL, 'Auxin-responsive protein', 103, NULL, NULL, 30185),
(30186, '3.40.630.30-FF-000391', NULL, 'Histone acetyltransferase ESA1', 12, NULL, NULL, 30186),
(30187, '2.60.40.10-FF-006026', NULL, NULL, 86, NULL, NULL, 30187),
(30188, '3.40.50.2000-FF-001038', NULL, 'Uncharacterized protein', 166, NULL, NULL, 30188),
(30189, '1.10.437.10-FF-000051', NULL, 'Uncharacterized protein', 118, NULL, NULL, 30189),
(30190, '3.40.30.10-FF-000869', NULL, 'Uncharacterized protein', 101, NULL, NULL, 30190),
(30191, '3.40.140.10-FF-000033', NULL, 'AMSH-like protease sst2', 198, NULL, NULL, 30191),
(30192, '1.10.287.2250-FF-000021', NULL, 'Uncharacterized protein', 85, NULL, NULL, 30192),
(30193, '3.40.50.720-FF-002425', NULL, 'Uncharacterized protein', 80, NULL, NULL, 30193),
(30194, '3.30.160.60-FF-006155', NULL, NULL, 69, NULL, NULL, 30194),
(30195, '2.60.40.10-FF-001355', NULL, 'Down syndrome cell adhesion molecule-like protein Dscam2', 109, NULL, NULL, 30195);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(30196, '2.60.220.50-FF-000168', NULL, 'Uncharacterized protein', 125, NULL, NULL, 30196),
(30197, '3.10.129.10-FF-000030', NULL, 'Acyl-CoA thioesterase', 127, NULL, NULL, 30197),
(30198, '1.25.10.10-FF-003275', NULL, 'Elongation factor 3 (Eurofung)', 197, NULL, NULL, 30198),
(30199, '3.30.60.30-FF-000052', NULL, 'Agrin', 50, NULL, NULL, 30199),
(30200, '1.25.40.10-FF-004884', NULL, 'Os01g0390600 protein', 101, NULL, NULL, 30200),
(30201, '1.20.1050.80-FF-000024', NULL, 'Uncharacterized protein', 152, NULL, NULL, 30201),
(30202, '1.20.1420.30-FF-000015', NULL, 'sodium/potassium/calcium exchanger 5 isoform X2', 127, NULL, NULL, 30202),
(30203, '3.30.160.60-FF-003513', NULL, NULL, 63, NULL, NULL, 30203),
(30204, '1.20.1070.10-FF-000639', NULL, 'Uncharacterized protein', 301, NULL, NULL, 30204),
(30205, '3.40.50.10190-FF-000369', NULL, 'Uncharacterized protein', 101, NULL, NULL, 30205),
(30206, '3.90.1300.10-FF-000005', NULL, 'Fatty-acid amide hydrolase 2', 476, NULL, NULL, 30206),
(30207, '2.30.39.10-FF-000133', NULL, 'Serpin peptidase inhibitor clade I neuroserpin member 1', 92, NULL, NULL, 30207),
(30208, '2.170.9.10-FF-000001', NULL, 'Hexon protein', 204, NULL, NULL, 30208),
(30209, '3.60.21.10-FF-000140', NULL, 'LPXTG cell wall anchor domain-containing protein', 291, NULL, NULL, 30209),
(30210, '3.40.50.2300-FF-001302', NULL, NULL, 127, NULL, NULL, 30210),
(30211, '2.130.10.10-FF-003457', NULL, 'Neutral sphingomyelinase activation-associated factor', 97, NULL, NULL, 30211),
(30212, '3.30.200.110-FF-000014', NULL, NULL, 132, NULL, NULL, 30212),
(30213, '3.30.420.40-FF-000728', NULL, 'Actin-related protein 2', 172, NULL, NULL, 30213),
(30214, '2.70.50.30-FF-000001', NULL, 'Rho GDP-dissociation inhibitor 1', 181, NULL, NULL, 30214),
(30215, '3.40.250.10-FF-000215', NULL, 'TBC domain-containing protein kinase-like protein', 92, NULL, NULL, 30215),
(30216, '2.170.300.10-FF-000030', NULL, 'Multiple epidermal growth factor-like domains protein 6', 127, NULL, NULL, 30216),
(30217, '3.90.132.10-FF-000025', NULL, 'GP63-like', 133, NULL, NULL, 30217),
(30218, '3.40.50.2000-FF-000813', NULL, 'Trehalose-phosphatase', 190, NULL, NULL, 30218),
(30219, '2.30.30.30-FF-000030', NULL, '60S ribosomal protein L14', 85, NULL, NULL, 30219),
(30220, '3.40.50.150-FF-000231', NULL, 'mRNA cap guanine-N7 methyltransferase', 328, NULL, NULL, 30220),
(30221, '3.40.50.300-FF-007706', NULL, 'Uncharacterized protein', 101, NULL, NULL, 30221),
(30222, '3.90.245.10-FF-000040', NULL, 'Uridine nucleosidase 1', 97, NULL, NULL, 30222),
(30223, '2.40.70.10-FF-000357', NULL, NULL, 133, NULL, NULL, 30223),
(30224, '3.40.50.10130-FF-000019', NULL, '(Xeroderma Pigmentosum group F) DNA repair gene homolog', 146, NULL, NULL, 30224),
(30225, '3.80.10.10-FF-000310', NULL, 'leucine-rich repeat-containing protein 23', 123, NULL, NULL, 30225),
(30226, '3.50.50.60-FF-000492', NULL, 'Aklavinone 12-hydroxylase RdmE', 204, NULL, NULL, 30226),
(30227, '3.40.980.10-FF-000017', NULL, 'Molybdopterin molybdenumtransferase', 176, NULL, NULL, 30227),
(30228, '2.130.10.10-FF-005166', NULL, 'Uncharacterized protein', 132, NULL, NULL, 30228),
(30229, '3.30.720.90-FF-000002', NULL, '60S ribosomal proteins L38', 69, NULL, NULL, 30229),
(30230, '2.30.30.30-FF-000119', NULL, '60S ribosomal protein L14', 84, NULL, NULL, 30230),
(30231, '3.30.160.60-FF-002996', NULL, 'Uncharacterized protein', 82, NULL, NULL, 30231),
(30232, '3.55.50.30-FF-000034', NULL, 'Putative anti-sigma factor', 77, NULL, NULL, 30232),
(30233, '1.25.10.10-FF-001566', NULL, 'Uncharacterized protein', 382, NULL, NULL, 30233),
(30234, '1.10.3210.10-FF-000064', NULL, 'HDIG domain protein', 181, NULL, NULL, 30234),
(30235, '2.30.29.30-FF-000493', NULL, 'AGC/AKT protein kinase', 103, NULL, NULL, 30235),
(30236, '3.20.20.105-FF-000013', NULL, 'Uncharacterized protein', 287, NULL, NULL, 30236),
(30237, '1.20.5.170-FF-000131', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 74, NULL, NULL, 30237),
(30238, '3.40.50.720-FF-001436', NULL, 'Aspartate kinase', 156, NULL, NULL, 30238);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(30239, '1.20.1250.20-FF-001786', NULL, 'Major facilitator superfamily multidrug transporter mdr3', 181, NULL, NULL, 30239),
(30240, '3.40.50.300-FF-001338', NULL, 'Type VII secretion protein EccC', 322, NULL, NULL, 30240),
(30241, '3.30.70.330-FF-001646', NULL, NULL, 88, NULL, NULL, 30241),
(30242, '1.20.1070.10-FF-001628', NULL, 'Uncharacterized protein', 141, NULL, NULL, 30242),
(30243, '3.40.50.300-FF-003963', NULL, 'Recombination factor protein RarA', 147, NULL, NULL, 30243),
(30244, '1.20.5.110-FF-000220', NULL, 'Vesicle-associated membrane protein 9', 83, NULL, NULL, 30244),
(30245, '1.10.506.10-FF-000055', NULL, 'Ras GTPase-activating-like protein, IQGAP family member, putative', 393, NULL, NULL, 30245),
(30246, '2.130.10.10-FF-000231', NULL, 'Anaphase-promoting complex subunit 4', 115, NULL, NULL, 30246),
(30247, '3.40.718.10-FF-000055', NULL, 'Uncharacterized protein', 428, NULL, NULL, 30247),
(30248, '2.30.40.10-FF-000142', NULL, 'Amidohydrolase domain protein', 42, NULL, NULL, 30248),
(30249, '1.10.150.220-FF-000007', NULL, NULL, 55, NULL, NULL, 30249),
(30250, '3.40.50.1820-FF-001613', NULL, 'Uncharacterized protein', 64, NULL, NULL, 30250),
(30251, '3.30.70.330-FF-001062', NULL, 'Polyadenylate-binding protein', 47, NULL, NULL, 30251),
(30252, '1.20.120.350-FF-000055', NULL, 'Two pore calcium channel protein 1', 133, NULL, NULL, 30252),
(30253, '3.30.420.10-FF-000624', NULL, NULL, 170, NULL, NULL, 30253),
(30254, '3.30.160.60-FF-001804', NULL, 'E4F transcription factor 1', 27, NULL, NULL, 30254),
(30255, '3.40.50.300-FF-008073', NULL, 'Dynein heavy chain 3', 120, NULL, NULL, 30255),
(30256, '1.25.40.20-FF-001604', NULL, 'Predicted protein', 109, NULL, NULL, 30256),
(30257, '3.30.1330.40-FF-000058', NULL, 'Uncharacterized protein', 77, NULL, NULL, 30257),
(30258, '3.50.30.20-FF-000001', NULL, 'Carbamoyl-phosphate synthase small chain', 150, NULL, NULL, 30258),
(30259, '3.80.10.10-FF-004525', NULL, 'Fbxl18 protein', 271, NULL, NULL, 30259),
(30260, '1.10.510.10-FF-001683', NULL, 'Protein kinase domain containing protein expressed', 194, NULL, NULL, 30260),
(30261, '2.170.130.30-FF-000005', NULL, NULL, 104, NULL, NULL, 30261),
(30262, '1.25.40.10-FF-000230', NULL, 'Clustered mitochondria protein homolog', 281, NULL, NULL, 30262),
(30263, '1.25.10.10-FF-001830', NULL, 'Predicted protein', 254, NULL, NULL, 30263),
(30264, '3.40.1390.20-FF-000014', NULL, 'Inorganic pyrophosphatase', 116, NULL, NULL, 30264),
(30265, '3.90.550.10-FF-000558', NULL, 'Uncharacterized protein', 188, NULL, NULL, 30265),
(30266, '1.10.8.60-FF-000264', NULL, '26S protease regulatory subunit 7', 72, NULL, NULL, 30266),
(30267, '3.30.1330.20-FF-000052', NULL, 'FtsZ', 68, NULL, NULL, 30267),
(30268, '1.10.150.200-FF-000001', NULL, 'Malto-oligosyltrehalose synthase', 107, NULL, NULL, 30268),
(30269, '3.40.50.2300-FF-000785', NULL, NULL, 119, NULL, NULL, 30269),
(30270, '3.40.630.30-FF-000211', NULL, 'Histone acetyltransferase Elp3 homolog', 153, NULL, NULL, 30270),
(30271, '1.20.1250.20-FF-000358', NULL, 'MFS transporter', 185, NULL, NULL, 30271),
(30272, '3.40.1810.10-FF-000027', NULL, 'Os01g0213300 protein', 68, NULL, NULL, 30272),
(30273, '3.30.70.330-FF-000218', NULL, 'RNA-binding motif protein, X-linked 2', 107, NULL, NULL, 30273),
(30274, '3.30.470.20-FF-000225', NULL, 'Glutathione synthetase', 114, NULL, NULL, 30274),
(30275, '1.10.10.10-FF-001711', NULL, 'Arginine repressor', 68, NULL, NULL, 30275),
(30276, '2.40.128.700-FF-000002', NULL, 'Fatty acid synthase beta subunit aflB', 112, NULL, NULL, 30276),
(30277, '1.20.1560.10-FF-000547', NULL, 'ABC transporter atnG', 329, NULL, NULL, 30277),
(30278, '1.25.10.10-FF-000138', NULL, 'Putative HEAT repeat-containing protein 5B', 446, NULL, NULL, 30278),
(30279, '1.10.150.120-FF-000011', NULL, '(2Fe-2S)-binding domain-containing protein', 81, NULL, NULL, 30279),
(30280, '1.20.5.370-FF-000011', NULL, 'DNA repair protein XRCC4 isoform X2', 94, NULL, NULL, 30280),
(30281, '1.10.600.10-FF-000021', NULL, 'Farnesyl pyrophosphate synthase', 343, NULL, NULL, 30281),
(30282, '2.60.40.10-FF-003917', NULL, NULL, 109, NULL, NULL, 30282);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(30283, '1.20.58.1380-FF-000014', NULL, 'Uncharacterized protein', 107, NULL, NULL, 30283),
(30284, '3.50.50.60-FF-000020', NULL, 'D-amino acid dehydrogenase', 60, NULL, NULL, 30284),
(30285, '3.40.50.1110-FF-000063', NULL, 'SGNH hydrolase', 218, NULL, NULL, 30285),
(30286, '3.40.50.300-FF-001193', NULL, 'Rab family, other', 184, NULL, NULL, 30286),
(30287, '3.30.160.60-FF-002524', NULL, 'Zinc finger protein 705F', 28, NULL, NULL, 30287),
(30288, '1.25.40.120-FF-000101', NULL, 'Uncharacterized protein', 97, NULL, NULL, 30288),
(30289, '3.40.720.10-FF-000324', NULL, 'Uncharacterized protein', 143, NULL, NULL, 30289),
(30290, '3.30.40.10-FF-001764', NULL, 'E3 ubiquitin-protein ligase RNF43', 68, NULL, NULL, 30290),
(30291, '1.50.10.10-FF-000046', NULL, 'Cellobionic acid phosphorylase', 387, NULL, NULL, 30291),
(30292, '2.90.10.10-FF-000059', NULL, 'Uncharacterized protein', 91, NULL, NULL, 30292),
(30293, '1.10.510.10-FF-004437', NULL, NULL, 55, NULL, NULL, 30293),
(30294, '1.10.510.10-FF-003009', NULL, NULL, 210, NULL, NULL, 30294),
(30295, '3.90.550.50-FF-000199', NULL, 'Uncharacterized protein', 187, NULL, NULL, 30295),
(30296, '3.80.10.10-FF-002491', NULL, 'Toll-like receptor 13', 125, NULL, NULL, 30296),
(30297, '1.20.58.60-FF-000577', NULL, 'Uncharacterized protein', 240, NULL, NULL, 30297),
(30298, '1.20.1250.20-FF-002303', NULL, 'Uncharacterized protein', 471, NULL, NULL, 30298),
(30299, '1.20.1070.10-FF-000791', NULL, 'Olfactory receptor', 290, NULL, NULL, 30299),
(30300, '3.30.70.2610-FF-000004', NULL, 'General transcription factor IIH subunit 4', 80, NULL, NULL, 30300),
(30301, '2.60.120.200-FF-000354', NULL, 'Galectin', 143, NULL, NULL, 30301),
(30302, '2.30.29.30-FF-001010', NULL, 'Motor AXon guidance', 119, NULL, NULL, 30302),
(30303, '1.20.120.1080-FF-000117', NULL, 'Uncharacterized protein', 130, NULL, NULL, 30303),
(30304, '3.40.50.1010-FF-000179', NULL, NULL, 159, NULL, NULL, 30304),
(30305, '3.40.50.720-FF-002217', NULL, 'Uncharacterized protein', 115, NULL, NULL, 30305),
(30306, '3.30.70.330-FF-002051', NULL, NULL, 95, NULL, NULL, 30306),
(30307, '1.10.3080.10-FF-000002', NULL, 'Chloride channel 2c', 484, NULL, NULL, 30307),
(30308, '1.20.1280.120-FF-000005', NULL, 'Uncharacterized protein', 81, NULL, NULL, 30308),
(30309, '1.20.1740.10-FF-000112', NULL, 'Large neutral amino acids transporter small subunit 1', 227, NULL, NULL, 30309),
(30310, '1.10.555.10-FF-000044', NULL, 'Rho-gtpase-activating protein 8', 212, NULL, NULL, 30310),
(30311, '2.60.40.10-FF-002075', NULL, 'Jitterbug, isoform N', 95, NULL, NULL, 30311),
(30312, '3.90.1200.10-FF-000060', NULL, 'Hydroxylysine kinase', 226, NULL, NULL, 30312),
(30313, '1.20.58.1120-FF-000015', NULL, 'Dynein heavy chain, putative', 145, NULL, NULL, 30313),
(30314, '4.10.140.10-FF-000002', NULL, 'Coagulation factor II (thrombin)', 61, NULL, NULL, 30314),
(30315, '3.30.1120.30-FF-000016', NULL, 'Serine/threonine-protein kinase PLK', 123, NULL, NULL, 30315),
(30316, '3.20.20.10-FF-000061', NULL, 'Pyridoxal phosphate homeostasis protein', 245, NULL, NULL, 30316),
(30317, '3.30.950.10-FF-000006', NULL, 'Multifunctional uroporphyrin-III C-methyltransferase/precorrin-2 oxidase/ferrochelatase', 127, NULL, NULL, 30317),
(30318, '2.60.40.10-FF-004261', NULL, NULL, 111, NULL, NULL, 30318),
(30319, '3.30.9.10-FF-000011', NULL, 'pyruvate dehydrogenase phosphatase regulatory subunit, mitochondrial', 162, NULL, NULL, 30319),
(30320, '3.40.50.10140-FF-000079', NULL, 'Uncharacterized protein', 148, NULL, NULL, 30320),
(30321, '3.40.50.11180-FF-000003', NULL, 'Transcription-repair-coupling factor', 49, NULL, NULL, 30321),
(30322, '3.40.50.150-FF-001479', NULL, NULL, 127, NULL, NULL, 30322),
(30323, '2.40.290.10-FF-000019', NULL, 'ATP-dependent DNA helicase 2 subunit 2', 199, NULL, NULL, 30323),
(30324, '3.30.450.30-FF-000019', NULL, 'Profilin', 127, NULL, NULL, 30324),
(30325, '2.60.120.380-FF-000071', NULL, 'Uncharacterized protein', 105, NULL, NULL, 30325),
(30326, '3.30.559.10-FF-000125', NULL, 'Carnitine palmitoyltransferase 1C', 195, NULL, NULL, 30326);
INSERT INTO "PUBLIC"."MODEL" VALUES
(30327, '1.10.1200.10-FF-000124', NULL, 'Uncharacterized protein', 78, NULL, NULL, 30327),
(30328, '3.80.10.10-FF-002339', NULL, 'Predicted protein', 103, NULL, NULL, 30328),
(30329, '3.30.40.10-FF-002017', NULL, 'Uncharacterized protein', 43, NULL, NULL, 30329),
(30330, '2.60.40.10-FF-003333', NULL, 'Uncharacterized loc548369', 120, NULL, NULL, 30330),
(30331, '3.40.50.850-FF-000019', NULL, 'Alpha/beta-hydrolase-like protein', 202, NULL, NULL, 30331),
(30332, '1.20.1270.10-FF-000059', NULL, 'Chaperone protein DnaK', 83, NULL, NULL, 30332),
(30333, '2.40.30.180-FF-000004', NULL, 'Ubiquitin activating enzyme, E1 family, putative', 109, NULL, NULL, 30333),
(30334, '3.40.50.1820-FF-000888', NULL, 'Phospholipase', 218, NULL, NULL, 30334),
(30335, '3.40.50.1000-FF-000822', NULL, NULL, 97, NULL, NULL, 30335),
(30336, '1.10.565.10-FF-000129', NULL, 'Nuclear receptor', 118, NULL, NULL, 30336),
(30337, '1.10.10.200-FF-000005', NULL, 'POL polyprotein', 53, NULL, NULL, 30337),
(30338, '2.60.40.420-FF-000028', NULL, 'Ceruloplasmin', 202, NULL, NULL, 30338),
(30339, '3.40.50.300-FF-002974', NULL, 'DNA helicase', 154, NULL, NULL, 30339),
(30340, '3.90.1750.10-FF-000033', NULL, 'E3 ubiquitin-protein ligase hecd-1', 195, NULL, NULL, 30340),
(30341, '2.60.40.60-FF-000009', NULL, 'Cadherin 24', 104, NULL, NULL, 30341),
(30342, '3.30.200.20-FF-000150', NULL, 'serine/threonine-protein kinase BRI1-like 2', 115, NULL, NULL, 30342),
(30343, '3.20.20.80-FF-000570', NULL, 'Uncharacterized protein', 320, NULL, NULL, 30343),
(30344, '3.20.20.20-FF-000007', NULL, 'Methionine synthase', 295, NULL, NULL, 30344),
(30345, '3.20.20.140-FF-000311', NULL, 'Guanine deaminase', 310, NULL, NULL, 30345),
(30346, '3.60.40.10-FF-000301', NULL, 'Alanine aminotransferase 2 mitochondrial', 90, NULL, NULL, 30346),
(30347, '3.30.70.20-FF-000021', NULL, 'MauM/NapG family ferredoxin-type protein', 77, NULL, NULL, 30347),
(30348, '3.30.70.2740-FF-000015', NULL, 'FAD-dependent oxidoreductase (GlcD/DLD_GlcF/GlpC domain fusion protein)', 82, NULL, NULL, 30348),
(30349, '1.20.1560.10-FF-000811', NULL, 'Uncharacterized protein', 145, NULL, NULL, 30349),
(30350, '2.70.130.10-FF-000063', NULL, NULL, 140, NULL, NULL, 30350),
(30351, '1.10.260.60-FF-000003', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', 29, NULL, NULL, 30351),
(30352, '1.10.238.10-FF-000353', NULL, 'Probable calcium-binding protein CML31', 78, NULL, NULL, 30352),
(30353, '3.30.200.20-FF-001931', NULL, NULL, 116, NULL, NULL, 30353),
(30354, '2.130.10.10-FF-005402', NULL, 'Poc1', 144, NULL, NULL, 30354),
(30355, '3.90.215.10-FF-000004', NULL, 'microfibril-associated glycoprotein 4', 225, NULL, NULL, 30355),
(30356, '2.60.40.10-FF-004845', NULL, NULL, 102, NULL, NULL, 30356),
(30357, '1.20.58.480-FF-000021', NULL, 'Tryptophan 2,3-dioxygenase, putative', 46, NULL, NULL, 30357),
(30358, '2.40.10.340-FF-000008', NULL, 'Rod shape-determining protein MreC', 68, NULL, NULL, 30358),
(30359, '3.40.50.300-FF-006717', NULL, 'Uncharacterized protein', 74, NULL, NULL, 30359),
(30360, '2.130.10.10-FF-000023', NULL, 'Bromodomain and WD repeat domain containing 1', 241, NULL, NULL, 30360),
(30361, '2.60.200.20-FF-000001', NULL, 'Kinesin family member 1B', 116, NULL, NULL, 30361),
(30362, '3.30.1370.100-FF-000041', NULL, 'DNA mismatch repair protein MutL', 29, NULL, NULL, 30362),
(30363, '3.90.550.10-FF-000766', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 337, NULL, NULL, 30363),
(30364, '1.20.5.190-FF-000081', NULL, 'Myosin-like protein XIF', 50, NULL, NULL, 30364),
(30365, '3.40.50.10490-FF-000133', NULL, NULL, 65, NULL, NULL, 30365),
(30366, '4.10.60.10-FF-000050', NULL, 'Unplaced genomic scaffold supercont2.10, whole genome shotgun sequence', 30, NULL, NULL, 30366),
(30367, '3.30.70.330-FF-003124', NULL, NULL, 117, NULL, NULL, 30367),
(30368, '1.25.40.10-FF-001394', NULL, 'Pentatricopeptide repeat-containing protein At3g28660', 124, NULL, NULL, 30368),
(30369, '3.30.160.60-FF-003249', NULL, 'Zinc finger protein 407', 29, NULL, NULL, 30369),
(30370, '1.10.3730.20-FF-000010', NULL, 'EamA family transporter', 104, NULL, NULL, 30370);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(30371, '1.10.8.60-FF-000472', NULL, 'Uncharacterized protein', 75, NULL, NULL, 30371),
(30372, '1.25.40.10-FF-003456', NULL, 'Pentatricopeptide repeat-containing protein', 117, NULL, NULL, 30372),
(30373, '1.10.510.10-FF-000694', NULL, 'Kinase non-catalytic C-lobe domain containing 1', 178, NULL, NULL, 30373),
(30374, '1.20.1730.10-FF-000078', NULL, 'Uncharacterized protein', 86, NULL, NULL, 30374),
(30375, '3.40.50.720-FF-001700', NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase NAD-binding', 190, NULL, NULL, 30375),
(30376, '1.10.472.10-FF-000593', NULL, 'Uncharacterized protein', 26, NULL, NULL, 30376),
(30377, '2.40.30.270-FF-000031', NULL, 'Protein CBG12210', 102, NULL, NULL, 30377),
(30378, '3.40.50.1700-FF-000026', NULL, 'uncharacterized protein LOC100182860 isoform X3', 240, NULL, NULL, 30378),
(30379, '3.40.50.410-FF-000298', NULL, 'Ubiquitin-conjugating enzyme family protein', 176, NULL, NULL, 30379),
(30380, '1.10.620.20-FF-000025', NULL, 'Ribonucleotide reductase small subunit Suc22', 323, NULL, NULL, 30380),
(30381, '3.40.50.620-FF-000035', NULL, 'methionine--tRNA ligase, mitochondrial', 219, NULL, NULL, 30381),
(30382, '3.40.50.1820-FF-000624', NULL, 'LIPaSe related', 220, NULL, NULL, 30382),
(30383, '3.40.50.2300-FF-000993', NULL, NULL, 80, NULL, NULL, 30383),
(30384, '1.20.1250.20-FF-001994', NULL, 'Solute carrier protein', 383, NULL, NULL, 30384),
(30385, '1.20.1070.10-FF-001100', NULL, 'Opsin', 314, NULL, NULL, 30385),
(30386, '3.40.50.720-FF-000891', NULL, '(R)-specific carbonyl reductase', 130, NULL, NULL, 30386),
(30387, '1.25.40.20-FF-001368', NULL, 'Uncharacterized protein', 89, NULL, NULL, 30387),
(30388, '1.20.58.60-FF-000785', NULL, 'Uncharacterized protein', 219, NULL, NULL, 30388),
(30389, '2.60.40.10-FF-004109', NULL, NULL, 93, NULL, NULL, 30389),
(30390, '3.40.50.150-FF-000815', NULL, NULL, 84, NULL, NULL, 30390),
(30391, '2.130.10.30-FF-000181', NULL, NULL, 230, NULL, NULL, 30391),
(30392, '2.40.30.20-FF-000032', NULL, 'Riboflavin synthase alpha chain', 93, NULL, NULL, 30392),
(30393, '2.120.10.30-FF-000378', NULL, 'Uncharacterized protein', 319, NULL, NULL, 30393),
(30394, '2.60.40.10-FF-005750', NULL, NULL, 102, NULL, NULL, 30394),
(30395, '3.10.310.20-FF-000022', NULL, NULL, 120, NULL, NULL, 30395),
(30396, '3.40.50.300-FF-000265', NULL, 'DNA replication and repair protein RecF', 148, NULL, NULL, 30396),
(30397, '1.10.1370.10-FF-000018', NULL, 'Peptidyl-dipeptidase', 370, NULL, NULL, 30397),
(30398, '3.60.40.10-FF-000240', NULL, 'Uncharacterized protein', 242, NULL, NULL, 30398),
(30399, '1.10.540.10-FF-000134', NULL, 'Uncharacterized protein', 81, NULL, NULL, 30399),
(30400, '2.30.29.30-FF-001274', NULL, 'Rho-associated protein kinase let-502', 98, NULL, NULL, 30400),
(30401, '3.30.70.380-FF-000008', NULL, NULL, 87, NULL, NULL, 30401),
(30402, '3.30.40.10-FF-000691', NULL, 'Origin recognition complex subunit 1', 68, NULL, NULL, 30402),
(30403, '1.20.120.350-FF-000116', NULL, 'pH-gated potassium channel KcsA', 106, NULL, NULL, 30403),
(30404, '3.40.50.2000-FF-000049', NULL, 'Alpha-1,4 glucan phosphorylase', 406, NULL, NULL, 30404),
(30405, '2.70.98.10-FF-000026', NULL, 'Beta-galactosidase (Eurofung)', 301, NULL, NULL, 30405),
(30406, '2.130.10.10-FF-004385', NULL, 'Uncharacterized protein', 73, NULL, NULL, 30406),
(30407, '3.80.10.10-FF-004172', NULL, 'Uncharacterized protein', 99, NULL, NULL, 30407),
(30408, '1.10.10.500-FF-000005', NULL, NULL, 135, NULL, NULL, 30408),
(30409, '1.20.1250.20-FF-002039', NULL, 'Uncharacterized protein', 324, NULL, NULL, 30409),
(30410, '3.30.300.30-FF-000099', NULL, 'Nonribosomal peptide synthase, putative', 126, NULL, NULL, 30410),
(30411, '1.25.40.990-FF-000013', NULL, 'Uncharacterized protein', 261, NULL, NULL, 30411),
(30412, '1.10.1410.10-FF-000106', NULL, 'Uncharacterized protein', 160, NULL, NULL, 30412),
(30413, '1.25.40.10-FF-003664', NULL, 'Putative DUF947 domain containing family protein', 80, NULL, NULL, 30413),
(30414, '3.30.1370.10-FF-000080', NULL, 'RNA binding protein', 76, NULL, NULL, 30414),
(30415, '1.10.510.10-FF-001475', NULL, 'Protein kinase, putative', 238, NULL, NULL, 30415);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(30416, '2.30.180.10-FF-000131', NULL, NULL, 117, NULL, NULL, 30416),
(30417, '1.20.58.670-FF-000011', NULL, 'RAD50-interacting protein', 124, NULL, NULL, 30417),
(30418, '3.40.50.200-FF-000061', NULL, 'Secreted subtilisin-like protease', 371, NULL, NULL, 30418),
(30419, '6.10.140.2220-FF-000005', NULL, 'Histone-lysine N-methyltransferase SMYD1 isoform 1', 48, NULL, NULL, 30419),
(30420, '3.40.1350.60-FF-000001', NULL, 'Sugar fermentation stimulation protein A', 154, NULL, NULL, 30420),
(30421, '2.60.40.10-FF-000630', NULL, 'Plexin D1', 88, NULL, NULL, 30421),
(30422, '3.40.395.10-FF-000040', NULL, 'Uncharacterized protein', 154, NULL, NULL, 30422),
(30423, '3.40.50.1000-FF-000322', NULL, 'HAD-superfamily hydrolase, subfamily IA, variant 3', 114, NULL, NULL, 30423),
(30424, '3.90.260.10-FF-000047', NULL, 'Uncharacterized protein', 184, NULL, NULL, 30424),
(30425, '1.20.1560.10-FF-000194', NULL, 'Uncharacterized protein', 341, NULL, NULL, 30425),
(30426, '3.30.450.40-FF-000056', NULL, 'IclR family transcriptional regulator', 184, NULL, NULL, 30426),
(30427, '1.10.10.10-FF-000930', NULL, 'DNA replication protein DnaD', 125, NULL, NULL, 30427),
(30428, '3.30.780.10-FF-000061', NULL, 'Uncharacterized protein', 107, NULL, NULL, 30428),
(30429, '1.25.40.480-FF-000012', NULL, 'Uncharacterized protein', 69, NULL, NULL, 30429),
(30430, '3.40.50.300-FF-001546', NULL, 'RNase L inhibitor homolog', 261, NULL, NULL, 30430),
(30431, '3.40.50.300-FF-005700', NULL, 'Predicted protein', 297, NULL, NULL, 30431),
(30432, '1.10.287.70-FF-000776', NULL, 'Uncharacterized protein', 107, NULL, NULL, 30432),
(30433, '3.40.47.10-FF-000172', NULL, NULL, 154, NULL, NULL, 30433),
(30434, '3.30.420.10-FF-000124', NULL, 'Plastid replication-repair enzyme', 321, NULL, NULL, 30434),
(30435, '3.40.50.2300-FF-000521', NULL, 'Guanylate cyclase', 177, NULL, NULL, 30435),
(30436, '3.40.1110.10-FF-000053', NULL, 'Cation-transporting ATPase, E1-E2 family', 185, NULL, NULL, 30436),
(30437, '2.60.120.260-FF-000618', NULL, 'Predicted protein', 136, NULL, NULL, 30437),
(30438, '2.40.50.1060-FF-000015', NULL, 'Predicted protein', 71, NULL, NULL, 30438),
(30439, '1.10.238.10-FF-000706', NULL, 'Uncharacterized protein', 86, NULL, NULL, 30439),
(30440, '3.40.50.300-FF-004683', NULL, 'Guanine nucleotide binding protein, alpha activating activity polypeptide O', 185, NULL, NULL, 30440),
(30441, '3.30.1380.20-FF-000055', NULL, 'Uncharacterized protein', 204, NULL, NULL, 30441),
(30442, '2.30.170.20-FF-000015', NULL, 'Uncharacterized protein', 42, NULL, NULL, 30442),
(30443, '3.40.50.1220-FF-000096', NULL, 'Electron transfer flavoprotein alpha subunit', 132, NULL, NULL, 30443),
(30444, '2.40.10.10-FF-000320', NULL, 'KLKBL4 protein', 231, NULL, NULL, 30444),
(30445, '2.70.170.10-FF-000037', NULL, 'zinc-activated ligand-gated ion channel', 181, NULL, NULL, 30445),
(30446, '3.40.50.11990-FF-000009', NULL, 'Uncharacterized protein', 133, NULL, NULL, 30446),
(30447, '3.30.390.30-FF-000020', NULL, 'Lipoamide dehydrogenase', 142, NULL, NULL, 30447),
(30448, '3.65.10.10-FF-000025', NULL, 'Putative 3-phosphoshikimate 1-carboxyvinyltransferase', 176, NULL, NULL, 30448),
(30449, '3.90.70.10-FF-000145', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 342, NULL, NULL, 30449),
(30450, '1.20.91.20-FF-000001', NULL, 'Complement C3', 80, NULL, NULL, 30450),
(30451, '3.40.50.12760-FF-000016', NULL, 'Uncharacterized protein', 404, NULL, NULL, 30451),
(30452, '2.60.40.420-FF-000231', NULL, 'Copper resistance protein A', 162, NULL, NULL, 30452),
(30453, '1.10.1450.10-FF-000171', NULL, 'Tetraspanin', 53, NULL, NULL, 30453),
(30454, '3.20.20.100-FF-000147', NULL, 'Predicted protein', 269, NULL, NULL, 30454),
(30455, '2.60.40.10-FF-001708', NULL, 'Uncharacterized protein, isoform C', 99, NULL, NULL, 30455),
(30456, '4.10.240.10-FF-000066', NULL, 'Transcription factor kojR', 62, NULL, NULL, 30456),
(30457, '1.25.40.60-FF-000020', NULL, NULL, 121, NULL, NULL, 30457),
(30458, '3.40.50.300-FF-004211', NULL, 'Ras-related protein RabV', 198, NULL, NULL, 30458);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(30459, '3.30.2450.30-FF-000002', NULL, 'purine-rich element-binding protein gamma isoform X2', 195, NULL, NULL, 30459),
(30460, '3.40.1260.20-FF-000010', NULL, 'Ribonuclease E', 108, NULL, NULL, 30460),
(30461, '1.20.1250.40-FF-000044', NULL, 'Uncharacterized protein', 117, NULL, NULL, 30461),
(30462, '3.30.160.60-FF-000315', NULL, 'Zinc finger and BTB domain-containing protein 20', 28, NULL, NULL, 30462),
(30463, '3.30.70.1230-FF-000079', NULL, 'Soluble guanylate cyclase gcy-31', 190, NULL, NULL, 30463),
(30464, '3.60.15.30-FF-000002', NULL, 'Uncharacterized protein', 237, NULL, NULL, 30464),
(30465, '3.30.160.60-FF-000579', NULL, 'Zinc finger protein 354B', 26, NULL, NULL, 30465),
(30466, '3.40.50.1820-FF-000124', NULL, 'Probable 1-acylglycerol-3-phosphate O-acyltransferase', 291, NULL, NULL, 30466),
(30467, '3.40.50.300-FF-007645', NULL, 'DNA repair protein', 138, NULL, NULL, 30467),
(30468, '3.40.50.1820-FF-000388', NULL, 'Alpha/beta family hydrolase', 292, NULL, NULL, 30468),
(30469, '2.60.40.10-FF-002428', NULL, 'Immunoglobulin heavy constant delta', 109, NULL, NULL, 30469),
(30470, '1.25.40.20-FF-001868', NULL, 'GASZ', 129, NULL, NULL, 30470),
(30471, '1.20.1110.10-FF-000166', NULL, NULL, 90, NULL, NULL, 30471),
(30472, '4.10.720.10-FF-000001', NULL, 'Zinc finger, FYVE domain-containing 9a', 40, NULL, NULL, 30472),
(30473, '3.40.50.10190-FF-000110', NULL, 'Regulator of Ty1 transposition', 103, NULL, NULL, 30473),
(30474, '4.10.800.10-FF-000002', NULL, 'Insulin-like growth factor-binding protein 2', 80, NULL, NULL, 30474),
(30475, '2.60.120.970-FF-000118', NULL, 'Uncharacterized protein', 72, NULL, NULL, 30475),
(30476, '1.10.8.10-FF-000210', NULL, 'Sequestosome-1', 43, NULL, NULL, 30476),
(30477, '3.30.1490.20-FF-000092', NULL, 'Predicted protein', 50, NULL, NULL, 30477),
(30478, '1.20.1070.10-FF-000083', NULL, 'Melanopsin 1', 319, NULL, NULL, 30478),
(30479, '3.40.50.12650-FF-000039', NULL, 'Predicted protein', 94, NULL, NULL, 30479),
(30480, '1.20.58.390-FF-000258', NULL, 'Uncharacterized protein', 99, NULL, NULL, 30480),
(30481, '2.40.110.10-FF-000012', NULL, 'Acyl-CoA dehydrogenase', 125, NULL, NULL, 30481),
(30482, '3.30.200.20-FF-001431', NULL, 'Uncharacterized protein', 97, NULL, NULL, 30482),
(30483, '1.10.357.20-FF-000019', NULL, 'Chromosome 1, whole genome shotgun sequence', 104, NULL, NULL, 30483),
(30484, '3.40.390.10-FF-000309', NULL, NULL, 120, NULL, NULL, 30484),
(30485, '3.30.230.70-FF-000088', NULL, 'Putative exosome complex exonuclease RRP42', 287, NULL, NULL, 30485),
(30486, '1.20.1270.60-FF-000113', NULL, 'Atg20p', 171, NULL, NULL, 30486),
(30487, '3.30.160.20-FF-000062', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 2', 75, NULL, NULL, 30487),
(30488, '3.40.309.10-FF-000088', NULL, 'Uncharacterized protein', 151, NULL, NULL, 30488),
(30489, '3.30.160.60-FF-005958', NULL, NULL, 90, NULL, NULL, 30489),
(30490, '3.60.20.40-FF-000045', NULL, 'Uncharacterized protein', 50, NULL, NULL, 30490),
(30491, '3.30.40.10-FF-000336', NULL, 'Histone-lysine N-methyltransferase', 56, NULL, NULL, 30491),
(30492, '3.50.50.60-FF-000845', NULL, 'NAD(P)/FAD-dependent oxidoreductase', 91, NULL, NULL, 30492),
(30493, '3.30.160.60-FF-002001', NULL, 'Zinc finger protein 445', 34, NULL, NULL, 30493),
(30494, '1.10.1200.10-FF-000063', NULL, 'Acyl carrier protein', 83, NULL, NULL, 30494),
(30495, '3.90.1310.10-FF-000039', NULL, 'Beta-lactamase', 131, NULL, NULL, 30495),
(30496, '3.40.50.1170-FF-000002', NULL, 'L-asparaginase 1', 208, NULL, NULL, 30496),
(30497, '1.25.10.10-FF-002347', NULL, 'Uncharacterized protein', 287, NULL, NULL, 30497),
(30498, '3.30.559.30-FF-000075', NULL, 'Nonribosomal peptide synthase Pes1 (Eurofung)', 238, NULL, NULL, 30498),
(30499, '2.40.50.140-FF-000732', NULL, NULL, 144, NULL, NULL, 30499),
(30500, '3.40.50.300-FF-004008', NULL, 'Putative DEAD/DEAH box helicase', 207, NULL, NULL, 30500),
(30501, '3.40.50.12780-FF-000174', NULL, 'Uncharacterized protein', 357, NULL, NULL, 30501),
(30502, '1.10.510.10-FF-000194', NULL, 'Casein kinase I isoform delta', 331, NULL, NULL, 30502);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(30503, '3.40.50.720-FF-001083', NULL, 'Bile acid 7-dehydroxylase 1/3', 247, NULL, NULL, 30503),
(30504, '2.10.70.10-FF-000128', NULL, 'Uncharacterized protein, isoform A', 58, NULL, NULL, 30504),
(30505, '1.10.510.10-FF-003420', NULL, NULL, 291, NULL, NULL, 30505),
(30506, '2.40.40.10-FF-000001', NULL, 'Expansin', 139, NULL, NULL, 30506),
(30507, '3.40.50.1000-FF-000058', NULL, 'Phosphatase yihX', 113, NULL, NULL, 30507),
(30508, '1.20.1720.10-FF-000049', NULL, 'Multidrug resistance protein B', 245, NULL, NULL, 30508),
(30509, '3.20.10.10-FF-000032', NULL, 'Branched-chain amino acid aminotransferase lateral transfer candidate', 193, NULL, NULL, 30509),
(30510, '3.30.870.10-FF-000152', NULL, 'Uncharacterized protein', 178, NULL, NULL, 30510),
(30511, '3.40.50.80-FF-000228', NULL, 'Putative respiratory burst oxidase homolog protein I', 156, NULL, NULL, 30511),
(30512, '3.40.190.290-FF-000084', NULL, 'LysR family transcriptional regulator (Chromosome initiation inhibitor)', 218, NULL, NULL, 30512),
(30513, '2.130.10.10-FF-003721', NULL, 'Predicted protein', 341, NULL, NULL, 30513),
(30514, '1.25.40.560-FF-000002', NULL, 'Ubiquitin thioesterase trabid', 95, NULL, NULL, 30514),
(30515, '1.10.10.60-FF-000220', NULL, 'DEK domain-containing chromatin associated protein', 65, NULL, NULL, 30515),
(30516, '2.60.40.10-FF-001147', NULL, 'phosphatidylinositol phosphatase PTPRQ isoform X3', 93, NULL, NULL, 30516),
(30517, '1.20.1250.20-FF-002191', NULL, 'Uncharacterized protein', 155, NULL, NULL, 30517),
(30518, '3.30.450.200-FF-000001', NULL, 'DENN domain-containing protein 2A isoform X1', 155, NULL, NULL, 30518),
(30519, '1.25.40.10-FF-004384', NULL, 'Uncharacterized protein', 143, NULL, NULL, 30519),
(30520, '1.10.3520.10-FF-000019', NULL, 'glycolipid transfer protein isoform X2', 145, NULL, NULL, 30520),
(30521, '3.40.50.12780-FF-000027', NULL, 'AASDH isoform 4', 437, NULL, NULL, 30521),
(30522, '3.30.420.40-FF-000228', NULL, 'Probable butyrate kinase', 154, NULL, NULL, 30522),
(30523, '1.20.1070.10-FF-000903', NULL, 'Adhesion G protein-coupled receptor E1', 255, NULL, NULL, 30523),
(30524, '2.60.40.2240-FF-000010', NULL, 'Uncharacterized protein', 64, NULL, NULL, 30524),
(30525, '1.25.40.70-FF-000080', NULL, 'Uncharacterized protein', 115, NULL, NULL, 30525),
(30526, '2.30.30.280-FF-000002', NULL, 'tRNA (5-methylaminomethyl-2-thiouridylate)-methyltransferase', 61, NULL, NULL, 30526),
(30527, '3.40.50.2000-FF-000313', NULL, 'Glycosyltransferase family 1 protein', 184, NULL, NULL, 30527),
(30528, '2.170.260.10-FF-000003', NULL, 'Piwi-like RNA-mediated gene silencing 2', 123, NULL, NULL, 30528),
(30529, '3.40.50.2300-FF-001038', NULL, NULL, 42, NULL, NULL, 30529),
(30530, '2.30.29.30-FF-000554', NULL, 'Uncharacterized protein, isoform B', 148, NULL, NULL, 30530),
(30531, '3.90.180.10-FF-000046', NULL, '2-enoyl thioester reductase', 132, NULL, NULL, 30531),
(30532, '3.60.10.10-FF-000412', NULL, 'Endonuclease/Exonuclease/phosphatase family protein', 268, NULL, NULL, 30532),
(30533, '3.30.200.20-FF-002095', NULL, NULL, 81, NULL, NULL, 30533),
(30534, '2.130.10.10-FF-001512', NULL, 'CPSF_A_subunit_region_containing_protein_-_putative', 410, NULL, NULL, 30534),
(30535, '2.60.40.1670-FF-000030', NULL, NULL, 152, NULL, NULL, 30535),
(30536, '4.10.400.10-FF-000073', NULL, 'Low-density lipoprotein receptor-related protein 1B', 44, NULL, NULL, 30536),
(30537, '2.40.70.10-FF-000149', NULL, 'Uncharacterized protein', 191, NULL, NULL, 30537),
(30538, '2.60.40.10-FF-001855', NULL, 'Hemicentin 2', 96, NULL, NULL, 30538),
(30539, '3.30.230.10-FF-000177', NULL, 'DNA topoisomerase 2', 121, NULL, NULL, 30539),
(30540, '1.10.10.790-FF-000047', NULL, NULL, 27, NULL, NULL, 30540),
(30541, '2.40.50.140-FF-000468', NULL, 'Ribonuclease R', 86, NULL, NULL, 30541),
(30542, '3.30.70.260-FF-000118', NULL, 'D-3-phosphoglycerate dehydrogenase', 83, NULL, NULL, 30542),
(30543, '3.40.30.10-FF-000369', NULL, 'GPX5 isoform 2', 67, NULL, NULL, 30543),
(30544, '3.20.20.220-FF-000037', NULL, 'Proline dehydrogenase', 464, NULL, NULL, 30544);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(30545, '2.10.60.10-FF-000043', NULL, 'GML isoform 2', 85, NULL, NULL, 30545),
(30546, '1.25.40.430-FF-000014', NULL, 'Protein CBR-SAN-1', 189, NULL, NULL, 30546),
(30547, '1.10.2000.10-FF-000025', NULL, 'Tyrosine-protein kinase receptor', 119, NULL, NULL, 30547),
(30548, '3.20.20.190-FF-000101', NULL, 'Uncharacterized protein', 317, NULL, NULL, 30548),
(30549, '3.40.50.300-FF-008426', NULL, 'Uncharacterized protein', 109, NULL, NULL, 30549),
(30550, '3.30.200.20-FF-001167', NULL, 'Kinase, CDC7', 96, NULL, NULL, 30550),
(30551, '3.30.70.270-FF-000178', NULL, NULL, 59, NULL, NULL, 30551),
(30552, '2.60.40.10-FF-000219', NULL, 'Down syndrome cell adhesion molecule homolog', 91, NULL, NULL, 30552),
(30553, '1.25.40.10-FF-002175', NULL, 'Pentatricopeptide repeat-containing protein DOT4, chloroplastic', 135, NULL, NULL, 30553),
(30554, '1.10.287.70-FF-000253', NULL, 'Blast:Glutamate receptor', 145, NULL, NULL, 30554),
(30555, '3.60.20.10-FF-000238', NULL, NULL, 77, NULL, NULL, 30555),
(30556, '3.30.70.330-FF-002927', NULL, NULL, 165, NULL, NULL, 30556),
(30557, '1.20.1250.20-FF-001522', NULL, 'Os12g0240875 protein', 140, NULL, NULL, 30557),
(30558, '1.25.10.10-FF-000902', NULL, 'HEAT repeat-containing protein 5B', 209, NULL, NULL, 30558),
(30559, '2.130.10.10-FF-002440', NULL, 'Subunit of the mRNA cleavage and polyadenylation factor, putative', 365, NULL, NULL, 30559),
(30560, '1.10.30.10-FF-000021', NULL, 'nucleolar transcription factor 1 isoform X1', 107, NULL, NULL, 30560),
(30561, '2.60.120.200-FF-000707', NULL, 'Uncharacterized protein', 184, NULL, NULL, 30561),
(30562, '2.60.120.560-FF-000001', NULL, 'galactocerebrosidase precursor', 200, NULL, NULL, 30562),
(30563, '3.90.180.10-FF-000193', NULL, 'Uncharacterized protein', 28, NULL, NULL, 30563),
(30564, '3.20.20.70-FF-000680', NULL, NULL, 198, NULL, NULL, 30564),
(30565, '3.30.70.330-FF-000870', NULL, 'Serine/arginine-rich splicing factor 4', 86, NULL, NULL, 30565),
(30566, '3.40.20.10-FF-000020', NULL, 'protein flightless-1 homolog isoform X1', 123, NULL, NULL, 30566),
(30567, '1.10.472.150-FF-000003', NULL, 'Uncharacterized protein', 125, NULL, NULL, 30567),
(30568, '2.30.39.10-FF-000072', NULL, 'Serpin peptidase inhibitor, clade H (Heat shock protein 47), member 1, (Collagen binding protein 1)', 147, NULL, NULL, 30568),
(30569, '3.80.10.10-FF-002991', NULL, 'Si:ch211-180f4.1', 128, NULL, NULL, 30569),
(30570, '3.30.930.10-FF-000354', NULL, 'Histidyl-tRNA synthetase, putative', 333, NULL, NULL, 30570),
(30571, '3.40.390.10-FF-000197', NULL, NULL, 256, NULL, NULL, 30571),
(30572, '3.10.20.30-FF-000005', NULL, 'Threonine--tRNA ligase', 64, NULL, NULL, 30572),
(30573, '2.170.270.10-FF-000240', NULL, 'SET and MYND domain-containing protein DDB_G0288495', 31, NULL, NULL, 30573),
(30574, '3.80.10.10-FF-000074', NULL, 'Leucine-rich repeat neuronal protein 1', 126, NULL, NULL, 30574),
(30575, '1.20.1640.10-FF-000048', NULL, 'protein patched homolog 1 isoform X2', 200, NULL, NULL, 30575),
(30576, '1.25.40.10-FF-004945', NULL, 'Uncharacterized protein', 179, NULL, NULL, 30576),
(30577, '1.10.1580.10-FF-000028', NULL, 'Predicted protein', 94, NULL, NULL, 30577),
(30578, '2.130.10.10-FF-005874', NULL, 'Protein CBG14967', 305, NULL, NULL, 30578),
(30579, '1.10.10.10-FF-001447', NULL, 'Uncharacterized protein', 65, NULL, NULL, 30579),
(30580, '3.30.70.330-FF-000718', NULL, 'Pre-mRNA-splicing factor CWC2', 99, NULL, NULL, 30580),
(30581, '3.60.21.10-FF-000229', NULL, 'Protein CBG06090', 221, NULL, NULL, 30581),
(30582, '3.40.50.300-FF-003755', NULL, 'Im:7158730 protein', 188, NULL, NULL, 30582),
(30583, '3.90.640.10-FF-000273', NULL, 'Actin-like protein 3, putative', 99, NULL, NULL, 30583),
(30584, '1.10.472.10-FF-000649', NULL, 'Cyclin, N-terminal domain containing protein', 109, NULL, NULL, 30584),
(30585, '3.30.1490.480-FF-000001', NULL, 'Endolytic murein transglycosylase', 72, NULL, NULL, 30585),
(30586, '3.30.530.20-FF-000051', NULL, 'Os08g0374000 protein', 149, NULL, NULL, 30586),
(30587, '1.20.1110.10-FF-000019', NULL, 'Probable cation-transporting P-type ATPase', 357, NULL, NULL, 30587);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(30588, '3.40.850.10-FF-000536', NULL, 'Kinesin-like protein', 334, NULL, NULL, 30588),
(30589, '1.20.120.350-FF-000263', NULL, NULL, 120, NULL, NULL, 30589),
(30590, '1.10.287.110-FF-000350', NULL, 'DnaJ domain containing protein', 92, NULL, NULL, 30590),
(30591, '3.80.10.10-FF-000782', NULL, 'Si:ch211-196h16.4', 172, NULL, NULL, 30591),
(30592, '2.60.120.330-FF-000134', NULL, 'Uncharacterized protein', 327, NULL, NULL, 30592),
(30593, '3.30.160.60-FF-003193', NULL, NULL, 27, NULL, NULL, 30593),
(30594, '1.10.357.70-FF-000017', NULL, 'Uncharacterized protein', 175, NULL, NULL, 30594),
(30595, '3.40.50.1820-FF-001405', NULL, 'GPI inositol-deacylase', 210, NULL, NULL, 30595),
(30596, '3.40.50.300-FF-001693', NULL, 'tRNA dimethylallyltransferase', 256, NULL, NULL, 30596),
(30597, '1.10.860.10-FF-000006', NULL, 'DNA primase', 143, NULL, NULL, 30597),
(30598, '2.30.42.10-FF-000596', NULL, NULL, 103, NULL, NULL, 30598),
(30599, '1.10.510.10-FF-001211', NULL, 'AGAP004008-PA', 140, NULL, NULL, 30599),
(30600, '3.60.15.10-FF-000108', NULL, 'Cleavage and polyadenylation specificity factor subunit 2', 90, NULL, NULL, 30600),
(30601, '1.25.40.20-FF-000587', NULL, 'RBR-type E3 ubiquitin transferase', 101, NULL, NULL, 30601),
(30602, '3.30.40.10-FF-001264', NULL, 'F2H15.19 protein', 61, NULL, NULL, 30602),
(30603, '4.10.1000.10-FF-000028', NULL, 'Zinc finger nuclease 2', 78, NULL, NULL, 30603),
(30604, '3.40.50.150-FF-001720', NULL, NULL, 186, NULL, NULL, 30604),
(30605, '3.20.20.140-FF-000047', NULL, 'PHP domain-containing protein', 244, NULL, NULL, 30605),
(30606, '3.90.1410.10-FF-000042', NULL, 'Hypothetical_protein_-_conserved', 313, NULL, NULL, 30606),
(30607, '3.40.30.10-FF-000105', NULL, 'protein disulfide-isomerase A5 isoform X2', 128, NULL, NULL, 30607),
(30608, '3.30.40.10-FF-001972', NULL, 'Uncharacterized protein', 62, NULL, NULL, 30608),
(30609, '1.20.1560.10-FF-000047', NULL, 'NHLP family bacteriocin export ABC transporter peptidase/permease/ATPase', 304, NULL, NULL, 30609),
(30610, '2.60.120.10-FF-000407', NULL, 'ABC-type multidrug transport system, ATPase and permease component', 133, NULL, NULL, 30610),
(30611, '1.10.10.10-FF-000222', NULL, 'Transcriptional regulatory protein RcsA', 96, NULL, NULL, 30611),
(30612, '1.20.1070.10-FF-000875', NULL, 'Frizzled A', 349, NULL, NULL, 30612),
(30613, '1.10.510.10-FF-002700', NULL, NULL, 116, NULL, NULL, 30613),
(30614, '3.10.490.10-FF-000032', NULL, 'Gamma-glutamylcyclotransferase', 191, NULL, NULL, 30614),
(30615, '3.40.50.1820-FF-000860', NULL, 'Uncharacterized protein', 296, NULL, NULL, 30615),
(30616, '1.20.1160.20-FF-000003', NULL, 'Whirlin a', 77, NULL, NULL, 30616),
(30617, '1.10.10.2670-FF-000010', NULL, 'WGS project CABT00000000 data, contig 2.6', 87, NULL, NULL, 30617),
(30618, '3.40.50.1010-FF-000095', NULL, 'DNA polymerase I', 171, NULL, NULL, 30618),
(30619, '2.60.40.10-FF-001063', NULL, 'Programmed cell death ligand 1', 119, NULL, NULL, 30619),
(30620, '2.10.109.10-FF-000010', NULL, 'Mitochondrial inner membrane protease subunit', 129, NULL, NULL, 30620),
(30621, '3.30.590.50-FF-000007', NULL, 'Glutamate--cysteine ligase', 87, NULL, NULL, 30621),
(30622, '3.90.470.10-FF-000057', NULL, 'Uncharacterized protein', 75, NULL, NULL, 30622),
(30623, '3.40.1010.10-FF-000017', NULL, 'Ribosomal RNA small subunit methyltransferase I', 111, NULL, NULL, 30623),
(30624, '1.10.580.10-FF-000024', NULL, 'Citrate synthase', 198, NULL, NULL, 30624),
(30625, '3.40.50.1820-FF-000332', NULL, 'Lysin B', 179, NULL, NULL, 30625),
(30626, '1.10.1660.10-FF-000001', NULL, 'Cu(I)-responsive transcriptional regulator', 111, NULL, NULL, 30626),
(30627, '1.10.287.3290-FF-000001', NULL, 'Dsl1p', 101, NULL, NULL, 30627),
(30628, '3.40.640.10-FF-000262', NULL, 'Ornithine aminotransferase', 100, NULL, NULL, 30628),
(30629, '1.25.40.10-FF-004209', NULL, 'Uncharacterized protein', 64, NULL, NULL, 30629),
(30630, '3.90.190.10-FF-000339', NULL, 'Predicted protein', 187, NULL, NULL, 30630),
(30631, '2.30.29.210-FF-000002', NULL, 'FACT complex subunit SPT16', 124, NULL, NULL, 30631);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(30632, '2.130.10.10-FF-001720', NULL, 'Topless-related protein 1', 194, NULL, NULL, 30632),
(30633, '2.60.40.10-FF-005278', NULL, NULL, 84, NULL, NULL, 30633),
(30634, '3.40.710.10-FF-000003', NULL, 'Peptidoglycan D,D-transpeptidase FtsI', 181, NULL, NULL, 30634),
(30635, '3.30.70.270-FF-000155', NULL, NULL, 104, NULL, NULL, 30635),
(30636, '1.10.287.70-FF-000753', NULL, 'Uncharacterized protein', 74, NULL, NULL, 30636),
(30637, '3.40.50.1010-FF-000151', NULL, NULL, 152, NULL, NULL, 30637),
(30638, '1.10.600.10-FF-000105', NULL, 'Tsukubadiene synthase', 332, NULL, NULL, 30638),
(30639, '1.20.5.5160-FF-000007', NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', 67, NULL, NULL, 30639),
(30640, '3.10.580.10-FF-000207', NULL, 'Uncharacterized protein', 113, NULL, NULL, 30640),
(30641, '2.30.30.230-FF-000004', NULL, 'Fumarylacetoacetase', 103, NULL, NULL, 30641),
(30642, '1.10.10.60-FF-000720', NULL, 'NK1 homeobox 2', 93, NULL, NULL, 30642),
(30643, '1.25.40.10-FF-001455', NULL, 'Putative intraflagellar transport protein B2', 132, NULL, NULL, 30643),
(30644, '3.50.50.60-FF-000289', NULL, 'Probable lysine-specific histone demethylase 1', 62, NULL, NULL, 30644),
(30645, '1.20.1070.10-FF-000347', NULL, 'Vomeronasal type-1 receptor', 294, NULL, NULL, 30645),
(30646, '1.20.5.510-FF-000008', NULL, 'Ubiquinol-cytochrome c reductase iron-sulfur subunit', 41, NULL, NULL, 30646),
(30647, '1.10.8.60-FF-000556', NULL, 'Uncharacterized protein', 50, NULL, NULL, 30647),
(30648, '3.40.50.620-FF-000799', NULL, 'Uncharacterized protein', 123, NULL, NULL, 30648),
(30649, '3.40.50.300-FF-005172', NULL, 'Uncharacterized protein', 221, NULL, NULL, 30649),
(30650, '2.60.120.330-FF-000073', NULL, 'Uncharacterized protein', 304, NULL, NULL, 30650),
(30651, '2.40.10.10-FF-000112', NULL, 'Mannan-binding lectin serine protease 1', 109, NULL, NULL, 30651),
(30652, '1.10.10.60-FF-001232', NULL, NULL, 76, NULL, NULL, 30652),
(30653, '2.130.10.10-FF-004946', NULL, 'Uncharacterized protein', 99, NULL, NULL, 30653),
(30654, '3.30.710.10-FF-000287', NULL, 'Zinc finger and BTB domain-containing 21', 45, NULL, NULL, 30654),
(30655, '3.40.50.720-FF-001200', NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', 259, NULL, NULL, 30655),
(30656, '2.130.10.10-FF-003660', NULL, 'WD repeat protein, putative', 287, NULL, NULL, 30656),
(30657, '1.25.40.10-FF-002883', NULL, 'Os08g0511000 protein', 229, NULL, NULL, 30657),
(30658, '1.10.510.10-FF-001711', NULL, 'Uncharacterized protein', 312, NULL, NULL, 30658),
(30659, '1.10.8.60-FF-000028', NULL, 'Replication factor C subunit 5', 63, NULL, NULL, 30659),
(30660, '3.30.70.3030-FF-000006', NULL, 'Nucleolar protein 6', 123, NULL, NULL, 30660),
(30661, '1.10.1200.220-FF-000001', NULL, 'Os06g0322300 protein', 97, NULL, NULL, 30661),
(30662, '1.10.510.10-FF-002695', NULL, NULL, 144, NULL, NULL, 30662),
(30663, '3.30.710.10-FF-000343', NULL, 'Potassium channel tetramerisation domain-containing 17', 49, NULL, NULL, 30663),
(30664, '2.40.30.170-FF-000063', NULL, NULL, 67, NULL, NULL, 30664),
(30665, '1.20.1270.60-FF-000085', NULL, 'Predicted protein', 200, NULL, NULL, 30665),
(30666, '1.25.40.10-FF-002411', NULL, 'pentatricopeptide repeat-containing protein At1g71420', 129, NULL, NULL, 30666),
(30667, '1.10.246.60-FF-000010', NULL, NULL, 78, NULL, NULL, 30667),
(30668, '2.30.30.40-FF-000212', NULL, 'NADPH oxidase activator 1', 61, NULL, NULL, 30668),
(30669, '1.25.40.10-FF-004737', NULL, 'Chromosome 1, whole genome shotgun sequence', 77, NULL, NULL, 30669),
(30670, '2.10.25.10-FF-000849', NULL, 'Thrombospondin, isoform A', 39, NULL, NULL, 30670),
(30671, '3.40.50.720-FF-001144', NULL, 'Uroporphyrinogen-III C-methyltransferase', 150, NULL, NULL, 30671),
(30672, '3.30.40.10-FF-000275', NULL, '43 kDa receptor-associated protein of the synapse', 48, NULL, NULL, 30672),
(30673, '1.10.10.160-FF-000004', NULL, 'DNA helicase', 88, NULL, NULL, 30673),
(30674, '1.10.287.110-FF-000294', NULL, 'Predicted protein', 109, NULL, NULL, 30674),
(30675, '2.120.10.30-FF-000142', NULL, 'NHL repeat containing E3 ubiquitin protein ligase 1', 144, NULL, NULL, 30675);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(30676, '3.90.1290.10-FF-000037', NULL, 'VAB-10A protein', 152, NULL, NULL, 30676),
(30677, '2.60.40.10-FF-005773', NULL, NULL, 100, NULL, NULL, 30677),
(30678, '3.90.1750.10-FF-000117', NULL, 'Uncharacterized protein', 175, NULL, NULL, 30678),
(30679, '1.10.150.20-FF-000096', NULL, 'Putative DNA polymerase kappa', 56, NULL, NULL, 30679),
(30680, '1.10.520.10-FF-000048', NULL, 'Peroxidase family protein', 77, NULL, NULL, 30680),
(30681, '2.20.28.10-FF-000013', NULL, 'DNA replication licensing factor MCM4, putative', 61, NULL, NULL, 30681),
(30682, '1.10.510.10-FF-001391', NULL, 'Serine/threonine-protein kinase PknK', 189, NULL, NULL, 30682),
(30683, '2.130.10.30-FF-000001', NULL, 'LOW QUALITY PROTEIN: probable E3 ubiquitin-protein ligase HERC1', 365, NULL, NULL, 30683),
(30684, '3.40.50.300-FF-000821', NULL, 'DNA excision repair protein ERCC-6-like 2 isoform X1', 321, NULL, NULL, 30684),
(30685, '1.20.1560.10-FF-000255', NULL, 'Uncharacterized protein', 314, NULL, NULL, 30685),
(30686, '3.30.230.80-FF-000006', NULL, 'endoplasmin homolog', 194, NULL, NULL, 30686),
(30687, '3.30.160.60-FF-001512', NULL, 'Zinc finger protein 496', 31, NULL, NULL, 30687),
(30688, '1.10.287.90-FF-000023', NULL, 'Ubiquinol oxidase subunit 2', 85, NULL, NULL, 30688),
(30689, '1.10.630.10-FF-000725', NULL, 'Uncharacterized protein', 100, NULL, NULL, 30689),
(30690, '1.25.40.10-FF-000522', NULL, 'Protein adenylyltransferase Fic', 102, NULL, NULL, 30690),
(30691, '1.10.3460.10-FF-000020', NULL, 'Photosystem II subunit PsbS1', 51, NULL, NULL, 30691),
(30692, '1.10.600.10-FF-000049', NULL, 'Geranylgeranyl pyrophosphate synthetase', 297, NULL, NULL, 30692),
(30693, '3.40.50.410-FF-000062', NULL, 'Uncharacterized protein, isoform C', 180, NULL, NULL, 30693),
(30694, '1.10.260.40-FF-000025', NULL, 'Cro/Cl family transcriptional regulator', 74, NULL, NULL, 30694),
(30695, '2.60.40.10-FF-001591', NULL, 'Mesh, isoform E', 83, NULL, NULL, 30695),
(30696, '3.30.420.40-FF-000964', NULL, 'Uncharacterized protein', 51, NULL, NULL, 30696),
(30697, '2.40.37.10-FF-000033', NULL, 'Ornithine decarboxylase', 110, NULL, NULL, 30697),
(30698, '3.80.10.10-FF-003300', NULL, 'Uncharacterized protein', 101, NULL, NULL, 30698),
(30699, '3.10.20.90-FF-000888', NULL, 'Uncharacterized protein', 56, NULL, NULL, 30699),
(30700, '1.20.1070.10-FF-000403', NULL, 'Predicted protein', 327, NULL, NULL, 30700),
(30701, '3.40.50.1390-FF-000012', NULL, 'Site-specific recombinase', 135, NULL, NULL, 30701),
(30702, '1.10.238.10-FF-001139', NULL, 'N-terminal EF-hand calcium-binding protein 2', 148, NULL, NULL, 30702),
(30703, '3.30.40.10-FF-000752', NULL, 'Blast:Histone-lysine N-methyltransferase 2C', 49, NULL, NULL, 30703),
(30704, '3.50.50.60-FF-001245', NULL, 'Putative ubiquinone biosynthesis monooxygenase COQ6-like Protein', 168, NULL, NULL, 30704),
(30705, '2.40.10.10-FF-000056', NULL, 'Kallikrein related peptidase 11', 80, NULL, NULL, 30705),
(30706, '3.40.50.300-FF-005436', NULL, 'Uncharacterized protein', 239, NULL, NULL, 30706),
(30707, '2.60.120.650-FF-000056', NULL, 'Jumonji domain containing 5', 292, NULL, NULL, 30707),
(30708, '3.40.33.10-FF-000027', NULL, 'Cysteine-rich venom protein kaouthin-1', 167, NULL, NULL, 30708),
(30709, '2.10.70.10-FF-000072', NULL, 'CUB and Sushi multiple domains 3', 59, NULL, NULL, 30709),
(30710, '3.10.290.10-FF-000084', NULL, 'Tyrosine--tRNA ligase', 117, NULL, NULL, 30710),
(30711, '3.40.30.10-FF-000785', NULL, 'Predicted protein', 68, NULL, NULL, 30711),
(30712, '3.10.250.10-FF-000014', NULL, 'Lysyl oxidase homolog 2', 111, NULL, NULL, 30712),
(30713, '1.10.10.750-FF-000030', NULL, 'TBC domain containing protein', 54, NULL, NULL, 30713),
(30714, '2.30.30.100-FF-000224', NULL, 'U6 snRNA-associated Sm-like protein LSm2', 58, NULL, NULL, 30714),
(30715, '1.10.287.1490-FF-000051', NULL, 'Viral A-type inclusion protein, putative', 144, NULL, NULL, 30715),
(30716, '2.60.40.10-FF-001439', NULL, 'Uncharacterized protein, isoform B', 112, NULL, NULL, 30716),
(30717, '3.40.50.2000-FF-000257', NULL, 'Glycosyltransferase', 181, NULL, NULL, 30717);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(30718, '1.25.40.570-FF-000067', NULL, 'Uncharacterized protein', 76, NULL, NULL, 30718),
(30719, '3.40.50.300-FF-004508', NULL, 'UBQ, helicase-c and DEAD-like helicase domain-containing protein', 222, NULL, NULL, 30719),
(30720, '3.40.50.1100-FF-000026', NULL, 'Threonine synthase', 193, NULL, NULL, 30720),
(30721, '2.30.40.10-FF-000081', NULL, 'Ethylammeline chlorohydrolase', 92, NULL, NULL, 30721),
(30722, '1.25.10.10-FF-001627', NULL, 'Beta-catenin-like protein 1', 490, NULL, NULL, 30722),
(30723, '1.25.40.10-FF-003400', NULL, 'PPR repeat family, putative', 130, NULL, NULL, 30723),
(30724, '1.10.287.1050-FF-000003', NULL, 'DNA-binding protein', 81, NULL, NULL, 30724),
(30725, '1.25.10.10-FF-002263', NULL, 'Uncharacterized protein', 349, NULL, NULL, 30725),
(30726, '3.40.630.30-FF-000008', NULL, 'Acetyltransferase, GNAT family', 167, NULL, NULL, 30726),
(30727, '2.10.25.10-FF-000496', NULL, 'Crumbs, isoform D', 40, NULL, NULL, 30727),
(30728, '3.40.50.300-FF-001277', NULL, 'Elongation factor 1 alpha-like protein', 237, NULL, NULL, 30728),
(30729, '3.40.50.2300-FF-000605', NULL, 'Sensory transduction histidine kinase', 131, NULL, NULL, 30729),
(30730, '2.130.10.10-FF-004593', NULL, 'Uncharacterized protein', 206, NULL, NULL, 30730),
(30731, '3.80.10.10-FF-000810', NULL, 'Leucine rich repeat containing 15', 97, NULL, NULL, 30731),
(30732, '3.80.10.10-FF-001322', NULL, 'Receptor protein-tyrosine kinase CEPR1', 235, NULL, NULL, 30732),
(30733, '2.130.10.10-FF-000731', NULL, 'Echinoderm microtubule-associated 2 isoform x3', 12, NULL, NULL, 30733),
(30734, '1.25.40.10-FF-000994', NULL, 'Histone demethylase UTY', 134, NULL, NULL, 30734),
(30735, '2.40.128.20-FF-000039', NULL, 'UPF0678 fatty acid-binding protein-like protein At1g79260', 153, NULL, NULL, 30735),
(30736, '1.10.555.10-FF-000191', NULL, NULL, 201, NULL, NULL, 30736),
(30737, '1.25.40.20-FF-001312', NULL, 'Uncharacterized protein', 142, NULL, NULL, 30737),
(30738, '2.60.40.10-FF-002844', NULL, 'Transcriptional regulator, AraC/XylS family', 116, NULL, NULL, 30738),
(30739, '2.60.40.2300-FF-000017', NULL, 'Predicted protein', 141, NULL, NULL, 30739),
(30740, '3.80.10.10-FF-004233', NULL, 'Uncharacterized protein', 79, NULL, NULL, 30740),
(30741, '3.30.70.60-FF-000038', NULL, '30S ribosomal protein S6', 100, NULL, NULL, 30741),
(30742, '3.40.50.2300-FF-001241', NULL, NULL, 78, NULL, NULL, 30742),
(30743, '3.90.70.10-FF-000701', NULL, 'Ubiquitin specific protease, putative', 218, NULL, NULL, 30743),
(30744, '3.40.50.300-FF-000765', NULL, 'Sulfotransferase', 304, NULL, NULL, 30744),
(30745, '2.40.50.140-FF-001160', NULL, NULL, 82, NULL, NULL, 30745),
(30746, '2.30.29.30-FF-000993', NULL, 'Subunit of ESCRT-II complex', 136, NULL, NULL, 30746),
(30747, '3.40.720.10-FF-000263', NULL, 'Predicted protein', 389, NULL, NULL, 30747),
(30748, '1.10.555.10-FF-000067', NULL, 'Rho GTPase-activating protein conundrum', 265, NULL, NULL, 30748),
(30749, '1.20.1250.20-FF-000297', NULL, 'Solute carrier family 22 member 18', 390, NULL, NULL, 30749),
(30750, '3.30.160.60-FF-001984', NULL, 'Uncharacterized protein', 28, NULL, NULL, 30750),
(30751, '1.10.3380.30-FF-000025', NULL, 'ATP-dependent DNA helicase Hel308', 213, NULL, NULL, 30751),
(30752, '4.10.410.60-FF-000004', NULL, 'Related to 50S ribosomal protein L35', 68, NULL, NULL, 30752),
(30753, '3.30.565.10-FF-000246', NULL, 'Heat Shock Protein', 224, NULL, NULL, 30753),
(30754, '3.30.200.20-FF-001370', NULL, 'Unc-51-like kinase 1', 53, NULL, NULL, 30754),
(30755, '3.40.50.12710-FF-000018', NULL, 'Protein arginine methyltransferase NDUFAF7', 378, NULL, NULL, 30755),
(30756, '3.40.50.150-FF-000254', NULL, 'Ribosomal RNA-processing protein 8', 193, NULL, NULL, 30756),
(30757, '1.20.1050.10-FF-000020', NULL, 'Glutathione S-transferase P 1', 108, NULL, NULL, 30757),
(30758, '3.30.1520.10-FF-000086', NULL, 'Sorting nexin-4', 152, NULL, NULL, 30758),
(30759, '3.90.170.10-FF-000012', NULL, 'Adenylosuccinate synthetase', 122, NULL, NULL, 30759),
(30760, '1.25.40.20-FF-001840', NULL, 'Uncharacterized protein', 144, NULL, NULL, 30760);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(30761, '2.60.40.150-FF-000190', NULL, 'ADP-ribosylation factor GTPase-activating protein AGD12', 159, NULL, NULL, 30761),
(30762, '2.60.40.3210-FF-000009', NULL, 'CUB and zona pellucida-like domain-containing protein 1', 116, NULL, NULL, 30762),
(30763, '2.130.10.10-FF-002968', NULL, 'Katanin p80 WD40 repeat-containing subunit B1 homolog', 222, NULL, NULL, 30763),
(30764, '3.50.50.60-FF-001301', NULL, 'Thioredoxin reductase 2', 160, NULL, NULL, 30764),
(30765, '3.40.850.10-FF-000452', NULL, 'Kinesin family member 6', 83, NULL, NULL, 30765),
(30766, '1.25.40.10-FF-003395', NULL, 'PPR repeat family, putative', 136, NULL, NULL, 30766),
(30767, '2.40.50.90-FF-000155', NULL, 'Uncharacterized protein', 127, NULL, NULL, 30767),
(30768, '3.40.430.10-FF-000021', NULL, 'Riboflavin biosynthesis protein RibD', 191, NULL, NULL, 30768),
(30769, '1.20.1250.20-FF-000830', NULL, 'MFS general substrate transporter', 389, NULL, NULL, 30769),
(30770, '2.40.10.170-FF-000019', NULL, 'Transcription-repair-coupling factor', 59, NULL, NULL, 30770),
(30771, '3.30.450.40-FF-000264', NULL, 'Chromosome 21, whole genome shotgun sequence', 42, NULL, NULL, 30771),
(30772, '2.60.40.60-FF-000684', NULL, 'Protocadherin fat, putative', 104, NULL, NULL, 30772),
(30773, '3.30.413.10-FF-000017', NULL, 'Nitrite reductase large subunit', 157, NULL, NULL, 30773),
(30774, '1.20.5.110-FF-000304', NULL, 'Uncharacterized protein', 64, NULL, NULL, 30774),
(30775, '1.10.287.770-FF-000025', NULL, 'Pickpocket 5, isoform B', 64, NULL, NULL, 30775),
(30776, '3.30.70.330-FF-001562', NULL, 'Protein CBR-EXC-7', 137, NULL, NULL, 30776),
(30777, '3.80.10.10-FF-000338', NULL, 'protein scribble homolog isoform X12', 270, NULL, NULL, 30777),
(30778, '3.40.190.10-FF-000480', NULL, 'Putative ABC transporter substrate-binding protein', 153, NULL, NULL, 30778),
(30779, '3.40.605.10-FF-000017', NULL, 'Bifunctional protein PutA', 263, NULL, NULL, 30779),
(30780, '3.40.50.300-FF-006897', NULL, 'Elongator complex protein 6 homolog', 241, NULL, NULL, 30780),
(30781, '1.10.10.10-FF-001155', NULL, 'Transcriptional adapter', 63, NULL, NULL, 30781),
(30782, '3.30.190.20-FF-000007', NULL, '54S ribosomal protein L1, mitochondrial', 108, NULL, NULL, 30782),
(30783, '3.30.160.60-FF-000079', NULL, 'Spalt-like transcription factor 3', 25, NULL, NULL, 30783),
(30784, '1.10.1200.270-FF-000027', NULL, 'Uncharacterized protein', 70, NULL, NULL, 30784),
(30785, '1.20.58.1610-FF-000010', NULL, 'NADH-quinone oxidoreductase subunit', 127, NULL, NULL, 30785),
(30786, '3.60.40.10-FF-000329', NULL, 'Predicted protein', 168, NULL, NULL, 30786),
(30787, '4.10.280.10-FF-000192', NULL, 'Transcription factor bHLH109', 69, NULL, NULL, 30787),
(30788, '2.130.10.10-FF-005458', NULL, 'Transducin (beta)-like 3', 183, NULL, NULL, 30788),
(30789, '3.40.50.620-FF-000804', NULL, 'Uncharacterized protein', 89, NULL, NULL, 30789),
(30790, '3.40.50.10260-FF-000002', NULL, 'NAD(P)H-hydrate epimerase', 233, NULL, NULL, 30790),
(30791, '2.10.25.10-FF-000473', NULL, 'Delta-like protein', 39, NULL, NULL, 30791),
(30792, '3.30.420.10-FF-000096', NULL, 'Uncharacterized exonuclease domain-containing protein At3g15140', 219, NULL, NULL, 30792),
(30793, '3.30.40.10-FF-001680', NULL, 'Histone-lysine N-methyltransferase', 74, NULL, NULL, 30793),
(30794, '2.130.10.10-FF-005082', NULL, 'Intermediate dynein chain, putative', 265, NULL, NULL, 30794),
(30795, '3.40.50.2300-FF-000285', NULL, 'Putative sensor histidine kinase/response regulator', 133, NULL, NULL, 30795),
(30796, '1.20.1250.20-FF-001286', NULL, 'MFS permease', 202, NULL, NULL, 30796),
(30797, '3.30.200.20-FF-000386', NULL, 'Fibrillarin, putative', 55, NULL, NULL, 30797),
(30798, '3.80.10.10-FF-000490', NULL, 'Leucine rich repeat containing 1', 103, NULL, NULL, 30798),
(30799, '3.30.70.1230-FF-000023', NULL, 'Guanylate cyclase', 222, NULL, NULL, 30799),
(30800, '1.20.1250.20-FF-001230', NULL, 'Solute carrier family 45 member 3', 434, NULL, NULL, 30800),
(30801, '1.10.1040.30-FF-000011', NULL, 'Atpase-like protein', 108, NULL, NULL, 30801),
(30802, '3.40.1110.10-FF-000114', NULL, 'H /K ATPase alpha subunit, putative', 224, NULL, NULL, 30802);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(30803, '1.20.910.10-FF-000014', NULL, 'Heme oxygenase 2, putative', 261, NULL, NULL, 30803),
(30804, '3.30.450.20-FF-000106', NULL, 'Potassium voltage-gated channel subfamily H member 1', 120, NULL, NULL, 30804),
(30805, '3.30.1680.10-FF-000007', NULL, 'semaphorin-6A isoform X1', 66, NULL, NULL, 30805),
(30806, '1.10.8.10-FF-000002', NULL, 'UV excision repair protein RAD23 homolog', 48, NULL, NULL, 30806),
(30807, '3.30.160.60-FF-002024', NULL, 'Tripartite motif containing 10', 43, NULL, NULL, 30807),
(30808, '3.40.1280.30-FF-000014', NULL, 'tRNA methyltransferase 10B', 201, NULL, NULL, 30808),
(30809, '3.40.50.300-FF-002210', NULL, 'Sugar ABC transporter ATP-binding protein', 222, NULL, NULL, 30809),
(30810, '1.10.3730.20-FF-000038', NULL, 'Integral membrane protein', 102, NULL, NULL, 30810),
(30811, '2.60.40.10-FF-005334', NULL, NULL, 74, NULL, NULL, 30811),
(30812, '2.30.29.30-FF-000138', NULL, 'Ventricular zone-expressed PH domain-containing protein-like 1', 129, NULL, NULL, 30812),
(30813, '1.10.375.10-FF-000007', NULL, 'Gag polyprotein', 164, NULL, NULL, 30813),
(30814, '1.10.472.80-FF-000097', NULL, 'Growth hormone-regulated TBC protein 6', 146, NULL, NULL, 30814),
(30815, '1.20.1560.10-FF-000250', NULL, 'ATP binding transporter 1', 323, NULL, NULL, 30815),
(30816, '2.60.120.10-FF-000143', NULL, 'Cyclic nucleotide-binding domain protein', 123, NULL, NULL, 30816),
(30817, '1.25.10.10-FF-000638', NULL, 'Zyg eleven-related protein 1', 401, NULL, NULL, 30817),
(30818, '1.10.455.10-FF-000008', NULL, '40S ribosomal protein S5, putative', 195, NULL, NULL, 30818),
(30819, '2.130.10.10-FF-000787', NULL, 'sperm-associated antigen 16 protein', 166, NULL, NULL, 30819),
(30820, '3.40.50.720-FF-000155', NULL, 'Adenosylhomocysteinase', 172, NULL, NULL, 30820),
(30821, '3.90.550.10-FF-000058', NULL, 'Exostosin-like glycosyltransferase 2', 269, NULL, NULL, 30821),
(30822, '2.130.10.10-FF-001187', NULL, 'Chromatin assembly factor-1 p105 subunit', 292, NULL, NULL, 30822),
(30823, '3.20.20.70-FF-000264', NULL, 'Pyridoxine 5''-phosphate synthase', 262, NULL, NULL, 30823),
(30824, '3.30.390.50-FF-000003', NULL, 'Aldehyde oxidase1', 113, NULL, NULL, 30824),
(30825, '2.40.50.40-FF-000073', NULL, 'Chemokine (C-C motif) ligand 39, duplicate 2', 62, NULL, NULL, 30825),
(30826, '3.40.50.300-FF-001810', NULL, 'Cytoplasmic dynein 2 heavy chain 1', 165, NULL, NULL, 30826),
(30827, '1.10.10.60-FF-001176', NULL, NULL, 37, NULL, NULL, 30827),
(30828, '1.10.630.10-FF-000410', NULL, 'cytochrome P450 2C31', 478, NULL, NULL, 30828),
(30829, '2.60.120.200-FF-000270', NULL, 'Legume-like lectin family protein', 204, NULL, NULL, 30829),
(30830, '1.10.560.10-FF-000141', NULL, 'Uncharacterized protein', 85, NULL, NULL, 30830),
(30831, '3.90.470.10-FF-000001', NULL, '50S ribosomal protein L22', 110, NULL, NULL, 30831),
(30832, '1.25.10.10-FF-002639', NULL, 'Uncharacterized protein', 120, NULL, NULL, 30832),
(30833, '2.60.40.1180-FF-000063', NULL, 'Adenylyl-sulfate kinase', 96, NULL, NULL, 30833),
(30834, '3.40.50.11030-FF-000014', NULL, NULL, 112, NULL, NULL, 30834),
(30835, '2.60.40.10-FF-000899', NULL, 'Tissue factor', 218, NULL, NULL, 30835),
(30836, '3.10.20.90-FF-000091', NULL, 'Splicing factor 3A subunit 1', 112, NULL, NULL, 30836),
(30837, '3.40.50.300-FF-003694', NULL, 'Dynein heavy chain', 150, NULL, NULL, 30837),
(30838, '2.10.109.10-FF-000066', NULL, 'LexA repressor', 126, NULL, NULL, 30838),
(30839, '3.40.50.150-FF-001743', NULL, NULL, 250, NULL, NULL, 30839),
(30840, '1.20.1070.10-FF-001331', NULL, 'Uncharacterized protein', 249, NULL, NULL, 30840),
(30841, '1.10.533.10-FF-000027', NULL, 'Interleukin-1 receptor-associated kinase 1 (Predicted)', 88, NULL, NULL, 30841),
(30842, '3.40.50.300-FF-003019', NULL, 'Elongation factor 1-alpha, putative', 242, NULL, NULL, 30842),
(30843, '3.10.50.40-FF-000162', NULL, 'Peptidylprolyl isomerase', 86, NULL, NULL, 30843),
(30844, '2.60.40.10-FF-003856', NULL, NULL, 57, NULL, NULL, 30844),
(30845, '3.30.300.30-FF-000155', NULL, 'Siderophore peptide synthetase fer3', 134, NULL, NULL, 30845);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(30846, '2.60.120.40-FF-000006', NULL, 'complement C1q tumor necrosis factor-related protein 3 isoform X2', 132, NULL, NULL, 30846),
(30847, '3.20.20.80-FF-000598', NULL, 'Uncharacterized protein', 195, NULL, NULL, 30847),
(30848, '3.20.20.80-FF-000654', NULL, 'Uncharacterized protein', 71, NULL, NULL, 30848),
(30849, '3.30.420.10-FF-000601', NULL, NULL, 188, NULL, NULL, 30849),
(30850, '2.60.11.10-FF-000001', NULL, 'Cytochrome c oxidase subunit 5B, mitochondrial', 98, NULL, NULL, 30850),
(30851, '2.40.10.10-FF-000589', NULL, NULL, 39, NULL, NULL, 30851),
(30852, '2.130.10.10-FF-004969', NULL, 'ASTRA-associated protein 1', 86, NULL, NULL, 30852),
(30853, '3.30.1360.170-FF-000009', NULL, 'Cation efflux system protein', 214, NULL, NULL, 30853),
(30854, '3.40.50.1000-FF-000614', NULL, NULL, 100, NULL, NULL, 30854),
(30855, '3.40.50.10050-FF-000001', NULL, 'Translation initiation factor IF-2', 107, NULL, NULL, 30855),
(30856, '3.30.760.10-FF-000054', NULL, 'Uncharacterized protein', 93, NULL, NULL, 30856),
(30857, '4.10.280.10-FF-000220', NULL, 'Achaete-scute family bHLH transcription factor 4', 35, NULL, NULL, 30857),
(30858, '1.25.40.10-FF-002383', NULL, 'Os02g0226900 protein', 72, NULL, NULL, 30858),
(30859, '3.30.450.20-FF-000578', NULL, 'Uncharacterized protein', 71, NULL, NULL, 30859),
(30860, '3.30.200.20-FF-001375', NULL, 'Uncharacterized protein', 49, NULL, NULL, 30860),
(30861, '2.40.10.10-FF-000117', NULL, 'Protein Z, vitamin K-dependent plasma glycoprotein', 121, NULL, NULL, 30861),
(30862, '3.20.20.60-FF-000120', NULL, 'Uncharacterized protein', 52, NULL, NULL, 30862),
(30863, '3.40.50.150-FF-001687', NULL, NULL, 114, NULL, NULL, 30863),
(30864, '3.40.190.80-FF-000045', NULL, 'Inositol monophosphatase family protein', 129, NULL, NULL, 30864),
(30865, '2.60.40.640-FF-000010', NULL, 'Vacuolar protein sorting-associated protein 26', 165, NULL, NULL, 30865),
(30866, '3.30.70.330-FF-002904', NULL, NULL, 45, NULL, NULL, 30866),
(30867, '3.50.50.80-FF-000003', NULL, 'Ubiquitin-activating enzyme E1 2', 119, NULL, NULL, 30867),
(30868, '1.20.5.170-FF-000187', NULL, 'Transcription factor fos-1', 68, NULL, NULL, 30868),
(30869, '3.40.50.1820-FF-001260', NULL, 'Homoserine O-acetyltransferase', 311, NULL, NULL, 30869),
(30870, '1.20.1270.130-FF-000001', NULL, 'Invasion plasmid antigen IpaH', 81, NULL, NULL, 30870),
(30871, '2.60.120.920-FF-000160', NULL, 'Predicted protein', 147, NULL, NULL, 30871),
(30872, '1.10.287.380-FF-000026', NULL, 'Valine--tRNA ligase', 73, NULL, NULL, 30872),
(30873, '1.20.1250.20-FF-000302', NULL, 'MFS siderochrome iron transporter MirB', 236, NULL, NULL, 30873),
(30874, '3.40.50.720-FF-002448', NULL, 'ADR079Cp', 199, NULL, NULL, 30874),
(30875, '3.90.1410.10-FF-000098', NULL, 'Uncharacterized protein', 258, NULL, NULL, 30875),
(30876, '3.40.50.300-FF-007729', NULL, 'Protein KTI12 homolog', 89, NULL, NULL, 30876),
(30877, '3.40.50.150-FF-001248', NULL, NULL, 215, NULL, NULL, 30877),
(30878, '2.60.40.10-FF-000427', NULL, 'Nectin cell adhesion molecule 1', 99, NULL, NULL, 30878),
(30879, '3.20.14.10-FF-000001', NULL, 'L-fucose isomerase', 251, NULL, NULL, 30879),
(30880, '2.60.120.290-FF-000077', NULL, 'Metalloendopeptidase', 110, NULL, NULL, 30880),
(30881, '1.10.1100.10-FF-000004', NULL, 'Transcription initiation factor TFIID subunit 1', 54, NULL, NULL, 30881),
(30882, '2.30.29.30-FF-000577', NULL, 'WGS project CABT00000000 data, contig 2.21', 124, NULL, NULL, 30882),
(30883, '3.30.1120.10-FF-000033', NULL, 'DUF229 domain-containing protein', 67, NULL, NULL, 30883),
(30884, '3.40.50.720-FF-002156', NULL, 'Fatty acyl-CoA reductase', 81, NULL, NULL, 30884),
(30885, '2.10.25.10-FF-001305', NULL, 'Crumbs-like protein 2b', 37, NULL, NULL, 30885),
(30886, '3.30.70.330-FF-000926', NULL, 'Ribonucleoprotein, PTB-binding 1', 92, NULL, NULL, 30886),
(30887, '3.90.550.10-FF-000002', NULL, 'UTP--glucose-1-phosphate uridylyltransferase', 362, NULL, NULL, 30887),
(30888, '2.40.50.90-FF-000099', NULL, 'Tudor domain containing protein', 122, NULL, NULL, 30888),
(30889, '3.30.160.60-FF-000023', NULL, 'zinc finger protein 37 homolog', 29, NULL, NULL, 30889); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(30890, '3.30.50.10-FF-000101', NULL, 'nuclear receptor isoform X1', 107, NULL, NULL, 30890),
(30891, '2.60.40.60-FF-000212', NULL, 'Cadherin 17', 103, NULL, NULL, 30891),
(30892, '3.40.190.10-FF-000300', NULL, 'C4-dicarboxylate ABC transporter substrate-binding protein', 142, NULL, NULL, 30892),
(30893, '1.20.120.1750-FF-000009', NULL, 'E3 ubiquitin-protein ligase parkin', 73, NULL, NULL, 30893),
(30894, '1.10.10.1100-FF-000006', NULL, '2Fe-2S iron-sulfur cluster-binding domain protein', 54, NULL, NULL, 30894),
(30895, '2.60.40.60-FF-000504', NULL, 'Uncharacterized protein', 106, NULL, NULL, 30895),
(30896, '2.60.40.60-FF-000156', NULL, 'cadherin-23 isoform X1', 112, NULL, NULL, 30896),
(30897, '2.60.120.10-FF-000582', NULL, 'Crp/Fnr family transcriptional regulator', 138, NULL, NULL, 30897),
(30898, '3.30.1120.30-FF-000039', NULL, 'Serine/threonine-protein kinase PLK', 68, NULL, NULL, 30898),
(30899, '3.30.450.20-FF-000634', NULL, 'Two component system histidine kinase', 101, NULL, NULL, 30899),
(30900, '1.20.140.40-FF-000048', NULL, 'Uncharacterized protein', 171, NULL, NULL, 30900),
(30901, '3.10.20.320-FF-000002', NULL, 'Sucrose-6-phosphate hydrolase', 79, NULL, NULL, 30901),
(30902, '3.40.50.300-FF-003547', NULL, 'Si:ch211-243j20.2', 102, NULL, NULL, 30902),
(30903, '1.10.287.1260-FF-000004', NULL, 'Transporter, small conductance mechanosensitive ion channel family', 143, NULL, NULL, 30903),
(30904, '3.40.50.300-FF-007061', NULL, 'Uncharacterized protein', 195, NULL, NULL, 30904),
(30905, '4.10.1240.10-FF-000074', NULL, 'Calcitonin receptor, putative', 67, NULL, NULL, 30905),
(30906, '3.50.50.60-FF-001273', NULL, 'Predicted protein', 74, NULL, NULL, 30906),
(30907, '3.30.420.40-FF-001072', NULL, 'Uncharacterized protein', 162, NULL, NULL, 30907),
(30908, '2.60.120.470-FF-000007', NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', 162, NULL, NULL, 30908),
(30909, '1.25.40.10-FF-002759', NULL, 'Tetratricopeptide repeat protein 19, mitochondrial', 186, NULL, NULL, 30909),
(30910, '1.25.40.20-FF-000351', NULL, 'E3 ubiquitin-protein ligase KEG', 134, NULL, NULL, 30910),
(30911, '3.30.70.2850-FF-000025', NULL, 'DNA-directed RNA polymerase subunit', 218, NULL, NULL, 30911),
(30912, '3.20.20.80-FF-000126', NULL, 'Glucosylceramidase', 375, NULL, NULL, 30912),
(30913, '2.60.120.380-FF-000008', NULL, 'Calpain 7', 133, NULL, NULL, 30913),
(30914, '3.40.50.300-FF-007353', NULL, 'Uncharacterized protein', 22, NULL, NULL, 30914),
(30915, '1.25.40.10-FF-005137', NULL, 'Uncharacterized protein', 100, NULL, NULL, 30915),
(30916, '3.30.160.60-FF-001192', NULL, 'ZXD family zinc finger C', 28, NULL, NULL, 30916),
(30917, '1.10.510.10-FF-003948', NULL, NULL, 57, NULL, NULL, 30917),
(30918, '1.25.40.20-FF-000379', NULL, 'Ankyrin repeat-containing protein At5g02620', 177, NULL, NULL, 30918),
(30919, '3.40.50.11350-FF-000048', NULL, 'Uncharacterized protein', 122, NULL, NULL, 30919),
(30920, '3.30.1360.150-FF-000003', NULL, 'Alkaline phosphatase PafA', 117, NULL, NULL, 30920),
(30921, '3.30.160.60-FF-004441', NULL, NULL, 27, NULL, NULL, 30921),
(30922, '1.20.1510.10-FF-000067', NULL, NULL, 204, NULL, NULL, 30922),
(30923, '1.20.58.60-FF-000554', NULL, 'Uncharacterized protein', 166, NULL, NULL, 30923),
(30924, '2.140.10.20-FF-000003', NULL, 'Cytochrome cd1 nitrite reductase', 373, NULL, NULL, 30924),
(30925, '1.25.40.10-FF-003872', NULL, 'Uncharacterized protein', 97, NULL, NULL, 30925),
(30926, '2.30.30.100-FF-000168', NULL, 'Protein CBG22276', 90, NULL, NULL, 30926),
(30927, '1.20.58.2190-FF-000010', NULL, 'Glycosyl hydrolase-like protein', 100, NULL, NULL, 30927),
(30928, '1.10.510.10-FF-003656', NULL, NULL, 182, NULL, NULL, 30928),
(30929, '2.60.120.860-FF-000001', NULL, 'Distal tail protein', 104, NULL, NULL, 30929),
(30930, '2.60.120.10-FF-000435', NULL, 'Mannose-6-phosphate isomerase, class I', 76, NULL, NULL, 30930),
(30931, '3.30.360.10-FF-000130', NULL, 'Uncharacterized protein', 56, NULL, NULL, 30931),
(30932, '1.10.8.10-FF-000007', NULL, 'Ubiquilin 1', 52, NULL, NULL, 30932);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(30933, '3.40.50.720-FF-000211', NULL, '3-hydroxybutyrate dehydrogenase type 2', 245, NULL, NULL, 30933),
(30934, '3.30.2010.10-FF-000025', NULL, 'Uncharacterized protein', 81, NULL, NULL, 30934),
(30935, '1.10.340.70-FF-000041', NULL, 'Uncharacterized protein', 87, NULL, NULL, 30935),
(30936, '3.40.30.10-FF-000313', NULL, 'Thioredoxin H9', 137, NULL, NULL, 30936),
(30937, '1.25.10.10-FF-003191', NULL, 'Serine/threonine-protein kinase TOR', 303, NULL, NULL, 30937),
(30938, '1.20.1280.290-FF-000096', NULL, 'Bidirectional sugar transporter SWEET', 73, NULL, NULL, 30938),
(30939, '3.30.260.10-FF-000089', NULL, NULL, 104, NULL, NULL, 30939),
(30940, '3.30.160.60-FF-006239', NULL, NULL, 60, NULL, NULL, 30940),
(30941, '3.30.930.10-FF-000415', NULL, 'Lysine--tRNA ligase, mitochondrial', 352, NULL, NULL, 30941),
(30942, '3.40.30.10-FF-000493', NULL, 'Sulfhydryl oxidase', 124, NULL, NULL, 30942),
(30943, '3.40.50.1820-FF-001344', NULL, 'Protein CBR-DPF-7', 246, NULL, NULL, 30943),
(30944, '2.60.40.10-FF-002900', NULL, 'Immunoglobulin superfamily, member 3', 113, NULL, NULL, 30944),
(30945, '1.10.238.200-FF-000025', NULL, 'Defective in cullin neddylation protein', 103, NULL, NULL, 30945),
(30946, '2.30.29.30-FF-001066', NULL, 'Rho GTPase-activating protein 20b', 165, NULL, NULL, 30946),
(30947, '3.40.30.10-FF-000841', NULL, 'Uncharacterized protein', 125, NULL, NULL, 30947),
(30948, '3.30.980.10-FF-000042', NULL, 'Uncharacterized protein', 45, NULL, NULL, 30948),
(30949, '3.40.50.300-FF-002682', NULL, 'Regulator of nonsense transcripts 1', 212, NULL, NULL, 30949),
(30950, '1.50.40.10-FF-000082', NULL, 'Mitochondrial succinate-fumarate transporter 1', 291, NULL, NULL, 30950),
(30951, '1.25.40.10-FF-001450', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 151, NULL, NULL, 30951),
(30952, '2.60.120.200-FF-000646', NULL, 'Uncharacterized protein', 109, NULL, NULL, 30952),
(30953, '3.20.20.70-FF-000741', NULL, NULL, 75, NULL, NULL, 30953),
(30954, '2.60.40.10-FF-003480', NULL, NULL, 97, NULL, NULL, 30954),
(30955, '2.120.10.30-FF-000086', NULL, 'NHL repeat-containing protein 2', 60, NULL, NULL, 30955),
(30956, '3.40.50.1820-FF-000708', NULL, 'Protein CBG13010', 62, NULL, NULL, 30956),
(30957, '2.40.10.10-FF-000084', NULL, 'Serine protease easter', 120, NULL, NULL, 30957),
(30958, '3.40.50.300-FF-001754', NULL, 'DNA replication licensing factor', 326, NULL, NULL, 30958),
(30959, '3.40.50.2000-FF-000785', NULL, 'Glycosyltransferase', 142, NULL, NULL, 30959),
(30960, '3.90.1410.10-FF-000103', NULL, 'Uncharacterized protein', 312, NULL, NULL, 30960),
(30961, '2.60.120.620-FF-000036', NULL, 'Prolyl 3-hydroxylase sudestada1', 221, NULL, NULL, 30961),
(30962, '3.30.160.60-FF-002496', NULL, 'Uncharacterized protein, isoform B', 36, NULL, NULL, 30962),
(30963, '3.40.850.10-FF-000036', NULL, 'Kinesin-like protein', 382, NULL, NULL, 30963),
(30964, '2.60.40.10-FF-002552', NULL, 'Myotactin form B', 107, NULL, NULL, 30964),
(30965, '1.10.10.10-FF-001947', NULL, 'Histone H1, sperm', 82, NULL, NULL, 30965),
(30966, '3.90.850.10-FF-000042', NULL, NULL, 104, NULL, NULL, 30966),
(30967, '1.10.630.10-FF-000697', NULL, 'Uncharacterized protein', 139, NULL, NULL, 30967),
(30968, '2.30.42.10-FF-000540', NULL, NULL, 54, NULL, NULL, 30968),
(30969, '3.20.20.140-FF-000108', NULL, 'Predicted metal-dependent hydrolase, TIM-barrel fold', 325, NULL, NULL, 30969),
(30970, '2.10.25.10-FF-000001', NULL, 'Tenascin C', 29, NULL, NULL, 30970),
(30971, '1.10.940.10-FF-000035', NULL, 'Sun protein, putative', 124, NULL, NULL, 30971),
(30972, '1.10.238.20-FF-000035', NULL, 'GEO02492p1', 110, NULL, NULL, 30972),
(30973, '4.10.372.10-FF-000001', NULL, 'Lipoxygenase', 91, NULL, NULL, 30973),
(30974, '3.30.160.60-FF-001568', NULL, 'Zinc finger X-linked protein ZXDB', 30, NULL, NULL, 30974),
(30975, '1.10.3720.10-FF-000063', NULL, 'Phosphate transport system permease protein', 270, NULL, NULL, 30975),
(30976, '2.60.40.10-FF-004789', NULL, NULL, 110, NULL, NULL, 30976),
(30977, '3.80.10.10-FF-001030', NULL, 'Acid labile subunit', 147, NULL, NULL, 30977); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(30978, '1.25.40.10-FF-000466', NULL, 'Putative TPR repeat-containing protein', 101, NULL, NULL, 30978),
(30979, '2.60.120.650-FF-000112', NULL, 'Uncharacterized protein', 223, NULL, NULL, 30979),
(30980, '3.40.50.300-FF-001569', NULL, 'ABC multidrug transporter (Eurofung)', 239, NULL, NULL, 30980),
(30981, '3.30.900.10-FF-000026', NULL, 'Mitotic spindle checkpoint protein (Mad2), putative', 132, NULL, NULL, 30981),
(30982, '3.40.50.2300-FF-000313', NULL, 'Ssu72 CTD phosphatase, isoform B', 122, NULL, NULL, 30982),
(30983, '3.10.28.10-FF-000056', NULL, 'DNA gyrase subunit A', 169, NULL, NULL, 30983),
(30984, '1.10.287.110-FF-000322', NULL, 'DnaJ-like protein', 94, NULL, NULL, 30984),
(30985, '2.40.70.10-FF-000060', NULL, 'Aspartic-type endopeptidase ctsD', 154, NULL, NULL, 30985),
(30986, '1.10.630.10-FF-000169', NULL, 'Epi-isozizaene 5-monooxygenase/(E)-beta-farnesene synthase', 440, NULL, NULL, 30986),
(30987, '2.60.120.10-FF-000087', NULL, 'Cyclic nucleotide-binding domain protein', 122, NULL, NULL, 30987),
(30988, '3.40.930.10-FF-000037', NULL, 'Anion exchange protein', 311, NULL, NULL, 30988),
(30989, '3.40.50.300-FF-006425', NULL, 'Uncharacterized protein', 128, NULL, NULL, 30989),
(30990, '2.40.50.140-FF-000940', NULL, NULL, 82, NULL, NULL, 30990),
(30991, '1.10.1000.11-FF-000032', NULL, 'IQ motif and Sec7 domain 3a', 80, NULL, NULL, 30991),
(30992, '1.20.58.390-FF-000202', NULL, 'Transmembrane ion channel', 110, NULL, NULL, 30992),
(30993, '3.40.50.720-FF-002072', NULL, 'Uncharacterized protein', 150, NULL, NULL, 30993),
(30994, '3.30.70.960-FF-000025', NULL, 'Suppressor of tumorigenicity 14 protein homolog', 100, NULL, NULL, 30994),
(30995, '1.20.1310.10-FF-000063', NULL, 'CDC53p Cullin', 129, NULL, NULL, 30995),
(30996, '3.30.1360.10-FF-000051', NULL, 'Small RNA polymerase', 83, NULL, NULL, 30996),
(30997, '3.90.870.40-FF-000001', NULL, 'Carbamoyltransferase', 42, NULL, NULL, 30997),
(30998, '2.30.30.620-FF-000003', NULL, 'Major vault protein-like protein', 75, NULL, NULL, 30998),
(30999, '3.30.160.60-FF-000107', NULL, 'Zinc finger protein 521', 55, NULL, NULL, 30999),
(31000, '1.25.40.70-FF-000085', NULL, 'Uncharacterized protein', 82, NULL, NULL, 31000),
(31001, '2.60.40.4370-FF-000003', NULL, 'General transcription factor 3C polypeptide, putative', 104, NULL, NULL, 31001),
(31002, '2.160.10.10-FF-000011', NULL, 'Bifunctional protein GlmU', 229, NULL, NULL, 31002),
(31003, '3.40.1090.10-FF-000084', NULL, 'Lysophospholipase', 147, NULL, NULL, 31003),
(31004, '1.10.510.10-FF-003509', NULL, NULL, 251, NULL, NULL, 31004),
(31005, '3.30.460.10-FF-000014', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 174, NULL, NULL, 31005),
(31006, '2.130.10.10-FF-002676', NULL, 'Uncharacterized protein', 300, NULL, NULL, 31006),
(31007, '3.20.20.80-FF-000093', NULL, '1,4-alpha-glucan-branching enzyme 3, chloroplastic/amyloplastic', 404, NULL, NULL, 31007),
(31008, '2.30.30.40-FF-000156', NULL, 'FYN-binding protein-like isoform X1', 83, NULL, NULL, 31008),
(31009, '2.70.170.10-FF-000245', NULL, 'Cholinergic receptor, nicotinic, beta 2', 165, NULL, NULL, 31009),
(31010, '2.40.50.140-FF-000968', NULL, NULL, 61, NULL, NULL, 31010),
(31011, '3.40.50.300-FF-007437', NULL, 'Uncharacterized protein', 255, NULL, NULL, 31011),
(31012, '3.30.420.140-FF-000005', NULL, 'Putative pre-16S rRNA nuclease', 142, NULL, NULL, 31012),
(31013, '3.30.9.10-FF-000242', NULL, 'FAD-dependent oxidoreductase family protein', 36, NULL, NULL, 31013),
(31014, '3.30.200.20-FF-000442', NULL, 'Serine/threonine/tyrosine kinase 1', 111, NULL, NULL, 31014),
(31015, '3.30.70.100-FF-000150', NULL, NULL, 76, NULL, NULL, 31015),
(31016, '3.40.50.620-FF-000327', NULL, 'Phr1p', 183, NULL, NULL, 31016),
(31017, '2.30.30.490-FF-000003', NULL, 'protein polybromo-1 isoform X3', 254, NULL, NULL, 31017),
(31018, '3.30.40.10-FF-001236', NULL, 'Histone-lysine N-methyltransferase', 66, NULL, NULL, 31018),
(31019, '2.40.50.140-FF-000232', NULL, 'Single-stranded DNA-binding protein', 114, NULL, NULL, 31019);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(31020, '3.30.420.40-FF-000436', NULL, 'Protein CBG07033', 93, NULL, NULL, 31020),
(31021, '2.60.120.920-FF-000013', NULL, 'ATP-dependent RNA helicase DDX1', 169, NULL, NULL, 31021),
(31022, '2.60.40.10-FF-001916', NULL, 'Roughest, isoform B', 86, NULL, NULL, 31022),
(31023, '3.30.160.60-FF-004002', NULL, NULL, 33, NULL, NULL, 31023),
(31024, '1.10.1200.10-FF-000040', NULL, 'Acyl carrier protein', 91, NULL, NULL, 31024),
(31025, '3.40.50.1000-FF-000558', NULL, NULL, 134, NULL, NULL, 31025),
(31026, '3.30.497.10-FF-000048', NULL, 'Sodium/hydrogen exchanger 2', 95, NULL, NULL, 31026),
(31027, '1.10.472.80-FF-000125', NULL, 'Rab GTPase activating protein, putative', 123, NULL, NULL, 31027),
(31028, '2.60.40.10-FF-005626', NULL, NULL, 97, NULL, NULL, 31028),
(31029, '1.20.120.620-FF-000012', NULL, 'Two component signal transduction system controlling the osmosenstive K+ channel histidine kinase KdpD', 102, NULL, NULL, 31029),
(31030, '2.130.10.10-FF-003513', NULL, 'WD repeat domain 90', 253, NULL, NULL, 31030),
(31031, '3.40.1170.20-FF-000003', NULL, 'tRNA-splicing endonuclease', 88, NULL, NULL, 31031),
(31032, '1.10.287.1130-FF-000016', NULL, 'Cx9C motif-containing protein 4, mitochondrial', 61, NULL, NULL, 31032),
(31033, '2.60.120.260-FF-000265', NULL, 'Predicted protein', 134, NULL, NULL, 31033),
(31034, '1.20.58.60-FF-000369', NULL, 'Dystrophin-1', 118, NULL, NULL, 31034),
(31035, '3.90.190.10-FF-000491', NULL, 'Predicted protein', 159, NULL, NULL, 31035),
(31036, '3.30.450.380-FF-000010', NULL, NULL, 170, NULL, NULL, 31036),
(31037, '1.10.8.60-FF-000500', NULL, '26S proteasome regulatory particle chain RPT6-like protein', 81, NULL, NULL, 31037),
(31038, '2.30.110.10-FF-000065', NULL, 'Ferric-chelate reductase (NAD(P)H)', 169, NULL, NULL, 31038),
(31039, '1.20.5.300-FF-000007', NULL, 'Phosphoprotein', 64, NULL, NULL, 31039),
(31040, '3.30.70.330-FF-001146', NULL, 'Uncharacterized protein, isoform C', 57, NULL, NULL, 31040),
(31041, '1.25.40.690-FF-000013', NULL, 'Nuclear pore complex protein nup98, putative', 92, NULL, NULL, 31041),
(31042, '1.25.10.10-FF-002555', NULL, 'Proteasome, putative', 174, NULL, NULL, 31042),
(31043, '2.20.70.10-FF-000167', NULL, 'E3 ubiquitin-protein ligase', 27, NULL, NULL, 31043),
(31044, '3.30.1490.220-FF-000002', NULL, 'Inositol-tetrakisphosphate 1-kinase', 100, NULL, NULL, 31044),
(31045, '1.10.287.470-FF-000053', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 74, NULL, NULL, 31045),
(31046, '3.30.160.60-FF-003985', NULL, NULL, 28, NULL, NULL, 31046),
(31047, '1.10.10.10-FF-000458', NULL, 'E2F-like (Mammalian transcription factor)', 72, NULL, NULL, 31047),
(31048, '1.10.1040.10-FF-000033', NULL, 'PAM1p protein', 134, NULL, NULL, 31048),
(31049, '1.10.750.20-FF-000006', NULL, 'neuralized-like protein 2 isoform X1', 37, NULL, NULL, 31049),
(31050, '3.20.20.100-FF-000086', NULL, 'Putative sterigmatocystin biosynthesis dehydrogenase stcV', 297, NULL, NULL, 31050),
(31051, '2.30.29.170-FF-000001', NULL, 'EF-hand domain containing 1', 144, NULL, NULL, 31051),
(31052, '2.10.50.10-FF-000037', NULL, 'Uncharacterized protein, isoform A', 59, NULL, NULL, 31052),
(31053, '1.50.40.10-FF-000458', NULL, 'Ucp4A, isoform C', 93, NULL, NULL, 31053),
(31054, '1.20.1080.10-FF-000084', NULL, 'Uncharacterized protein', 268, NULL, NULL, 31054),
(31055, '1.20.5.460-FF-000010', NULL, 'TIM-barrel enzyme family protein', 23, NULL, NULL, 31055),
(31056, '1.25.40.10-FF-001163', NULL, 'Pentatricopeptide repeat protein2263', 134, NULL, NULL, 31056),
(31057, '3.90.79.10-FF-000193', NULL, 'ADP ribose hydrolase, putative (MutT/nudix family protein)', 168, NULL, NULL, 31057),
(31058, '3.60.40.10-FF-000296', NULL, 'Uncharacterized protein', 168, NULL, NULL, 31058),
(31059, '1.10.238.10-FF-001286', NULL, 'Uncharacterized protein', 43, NULL, NULL, 31059),
(31060, '1.20.1050.130-FF-000053', NULL, 'Uncharacterized protein', 170, NULL, NULL, 31060),
(31061, '3.90.190.10-FF-000047', NULL, 'Paladin isoform A', 243, NULL, NULL, 31061),
(31062, '3.40.1690.20-FF-000003', NULL, 'Mitochondrial inner membrane AAA protease Yta12, putative', 105, NULL, NULL, 31062);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(31063, '1.10.510.10-FF-003392', NULL, NULL, 310, NULL, NULL, 31063),
(31064, '1.10.10.10-FF-000514', NULL, 'RNA polymerase sigma factor sigE, chloroplastic/mitochondrial', 78, NULL, NULL, 31064),
(31065, '2.40.50.120-FF-000018', NULL, 'netrin-3 isoform X2', 142, NULL, NULL, 31065),
(31066, '3.40.50.620-FF-000619', NULL, 'Chromosome 16, whole genome shotgun sequence', 164, NULL, NULL, 31066),
(31067, '3.30.160.60-FF-003457', NULL, 'Ras-responsive element-binding protein', 111, NULL, NULL, 31067),
(31068, '1.20.1070.10-FF-000111', NULL, 'Adhesion G protein-coupled receptor A2', 279, NULL, NULL, 31068),
(31069, '3.80.10.10-FF-003536', NULL, 'Uncharacterized protein', 164, NULL, NULL, 31069),
(31070, '1.10.238.10-FF-000830', NULL, 'calmodulin-related protein-like isoform X1', 90, NULL, NULL, 31070),
(31071, '2.160.20.70-FF-000012', NULL, 'Cyclase-associated protein, putative', 161, NULL, NULL, 31071),
(31072, '3.10.290.70-FF-000023', NULL, NULL, 131, NULL, NULL, 31072),
(31073, '3.40.5.60-FF-000006', NULL, 'DNA replication complex GINS protein SLD5', 56, NULL, NULL, 31073),
(31074, '3.60.21.10-FF-000084', NULL, 'Serine/threonine-protein phosphatase 2', 215, NULL, NULL, 31074),
(31075, '2.60.40.10-FF-001883', NULL, 'Cilia- and flagella-associated protein 74', 101, NULL, NULL, 31075),
(31076, '2.60.40.2170-FF-000017', NULL, 'Receptor tyrosine kinase-like protein', 75, NULL, NULL, 31076),
(31077, '1.20.1070.10-FF-000583', NULL, 'Olfactory receptor', 290, NULL, NULL, 31077),
(31078, '2.30.30.40-FF-000504', NULL, 'Dynamin-binding protein', 56, NULL, NULL, 31078),
(31079, '3.80.10.10-FF-004048', NULL, 'Uncharacterized protein', 138, NULL, NULL, 31079),
(31080, '2.20.200.10-FF-000001', NULL, 'Multidrug resistance outer membrane protein MdtP', 92, NULL, NULL, 31080),
(31081, '2.40.50.100-FF-000012', NULL, 'DNA-directed RNA polymerase subunit beta', 65, NULL, NULL, 31081),
(31082, '3.40.640.10-FF-000498', NULL, 'Predicted protein', 258, NULL, NULL, 31082),
(31083, '1.20.1070.10-FF-000055', NULL, 'Taste receptor type 2', 303, NULL, NULL, 31083),
(31084, '2.40.50.150-FF-000033', NULL, 'DNA-directed RNA polymerase subunit beta', 94, NULL, NULL, 31084),
(31085, '3.10.200.10-FF-000011', NULL, 'Protein tyrosine phosphatase receptor type Z1b', 269, NULL, NULL, 31085),
(31086, '3.30.420.510-FF-000021', NULL, 'Predicted protein', 147, NULL, NULL, 31086),
(31087, '3.30.420.10-FF-000129', NULL, 'Exosome complex exonuclease RRP6', 310, NULL, NULL, 31087),
(31088, '3.30.2410.10-FF-000050', NULL, 'E3 ubiquitin-protein ligase etc-1', 114, NULL, NULL, 31088),
(31089, '3.30.420.40-FF-000200', NULL, 'L-xylulose/3-keto-L-gulonate kinase', 238, NULL, NULL, 31089),
(31090, '2.60.40.420-FF-000236', NULL, 'Ceruloplasmin', 279, NULL, NULL, 31090),
(31091, '2.10.25.10-FF-001018', NULL, 'Protein cueball-like Protein', 28, NULL, NULL, 31091),
(31092, '3.40.50.300-FF-002238', NULL, 'Midasin', 174, NULL, NULL, 31092),
(31093, '3.40.50.1110-FF-000119', NULL, 'Phospholipase B1, membrane-associated', 245, NULL, NULL, 31093),
(31094, '3.30.160.60-FF-001799', NULL, 'Uncharacterized protein', 28, NULL, NULL, 31094),
(31095, '3.10.120.10-FF-000010', NULL, 'Delta-6 fatty acyl desaturase', 92, NULL, NULL, 31095),
(31096, '3.40.50.11990-FF-000004', NULL, 'Potential RNA Pol II elongation accessory factor', 184, NULL, NULL, 31096),
(31097, '2.30.42.10-FF-000624', NULL, NULL, 78, NULL, NULL, 31097),
(31098, '3.90.660.20-FF-000013', NULL, 'Blr3003 protein', 97, NULL, NULL, 31098),
(31099, '1.25.40.20-FF-000615', NULL, 'Uncharacterized protein', 138, NULL, NULL, 31099),
(31100, '1.20.58.670-FF-000016', NULL, NULL, 167, NULL, NULL, 31100),
(31101, '1.10.10.60-FF-001029', NULL, NULL, 56, NULL, NULL, 31101),
(31102, '2.120.10.80-FF-000016', NULL, 'Kelch domain-containing protein 3', 174, NULL, NULL, 31102),
(31103, '3.50.30.30-FF-000094', NULL, 'Uncharacterized protein', 105, NULL, NULL, 31103),
(31104, '3.40.50.300-FF-002766', NULL, 'Uncharacterized protein', 16, NULL, NULL, 31104),
(31105, '3.20.20.70-FF-000825', NULL, NULL, 156, NULL, NULL, 31105);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(31106, '2.60.40.1090-FF-000036', NULL, 'Frimbrial protein', 157, NULL, NULL, 31106),
(31107, '3.40.50.1820-FF-000040', NULL, 'SPG21, maspardin', 263, NULL, NULL, 31107),
(31108, '3.40.50.10880-FF-000008', NULL, 'YMR027W-like protein', 135, NULL, NULL, 31108),
(31109, '3.30.710.10-FF-000051', NULL, 'myoneurin isoform X1', 145, NULL, NULL, 31109),
(31110, '3.10.20.90-FF-000124', NULL, 'amyloid beta A4 precursor protein-binding family B member 1-interacting protein-like', 118, NULL, NULL, 31110),
(31111, '2.20.70.10-FF-000223', NULL, 'E3 ubiquitin-protein ligase', 44, NULL, NULL, 31111),
(31112, '3.30.930.10-FF-000270', NULL, 'Histidine--tRNA ligase', 336, NULL, NULL, 31112),
(31113, '1.25.40.430-FF-000019', NULL, 'YALI0B23166p', 186, NULL, NULL, 31113),
(31114, '3.30.160.60-FF-005222', NULL, NULL, 38, NULL, NULL, 31114),
(31115, '1.10.220.10-FF-000031', NULL, 'AGAP012930-PA', 47, NULL, NULL, 31115),
(31116, '3.40.50.300-FF-006509', NULL, 'Uncharacterized protein', 112, NULL, NULL, 31116),
(31117, '3.10.290.20-FF-000002', NULL, 'SUMO-activating enzyme subunit 2', 147, NULL, NULL, 31117),
(31118, '2.60.40.150-FF-000419', NULL, 'Copine i-like protein', 122, NULL, NULL, 31118),
(31119, '1.10.1410.10-FF-000101', NULL, 'Uncharacterized protein', 14, NULL, NULL, 31119),
(31120, '3.40.630.10-FF-000469', NULL, 'Uncharacterized protein', 73, NULL, NULL, 31120),
(31121, '3.30.160.60-FF-005694', NULL, NULL, 64, NULL, NULL, 31121),
(31122, '2.60.40.10-FF-003064', NULL, 'Myotactin form B', 92, NULL, NULL, 31122),
(31123, '1.10.1520.10-FF-000019', NULL, 'Ribonuclease III family protein', 130, NULL, NULL, 31123),
(31124, '3.40.630.30-FF-000155', NULL, 'GNAT family acetyltransferase', 150, NULL, NULL, 31124),
(31125, '2.130.10.10-FF-003952', NULL, 'EMC Endoplasmic Membrane protein Complex (Yeast EMC) homolog', 244, NULL, NULL, 31125),
(31126, '2.10.220.10-FF-000084', NULL, 'Uncharacterized protein', 67, NULL, NULL, 31126),
(31127, '3.90.190.10-FF-000575', NULL, 'Tyrosine protein phosphatase', 285, NULL, NULL, 31127),
(31128, '1.10.220.30-FF-000037', NULL, 'Flagellar motor switch protein FliG', 86, NULL, NULL, 31128),
(31129, '2.30.180.10-FF-000159', NULL, NULL, 118, NULL, NULL, 31129),
(31130, '2.40.10.10-FF-000404', NULL, NULL, 107, NULL, NULL, 31130),
(31131, '3.10.20.90-FF-000596', NULL, 'Afadin-like Protein', 86, NULL, NULL, 31131),
(31132, '3.30.9.10-FF-000186', NULL, 'Protein CBG18666', 53, NULL, NULL, 31132),
(31133, '1.10.510.10-FF-000222', NULL, 'casein kinase 1-like protein HD16', 352, NULL, NULL, 31133),
(31134, '3.40.50.1240-FF-000074', NULL, 'Phosphoglycerate mutase family protein', 321, NULL, NULL, 31134),
(31135, '3.40.50.300-FF-002390', NULL, 'ATPase family AAA domain-containing protein', 195, NULL, NULL, 31135),
(31136, '3.40.50.620-FF-000243', NULL, 'Cryptochrome-1', 174, NULL, NULL, 31136),
(31137, '3.30.40.10-FF-000567', NULL, 'Regulating synaptic membrane exocytosis 1', 110, NULL, NULL, 31137),
(31138, '2.130.10.10-FF-001804', NULL, 'Probable cytosolic iron-sulfur protein assembly protein 1', 179, NULL, NULL, 31138),
(31139, '1.25.40.10-FF-003248', NULL, 'Uncharacterized protein CaJ7.0066', 175, NULL, NULL, 31139),
(31140, '3.30.930.10-FF-000359', NULL, 'Uncharacterized protein', 226, NULL, NULL, 31140),
(31141, '3.40.50.12350-FF-000011', NULL, 'Eyes absent homolog', 255, NULL, NULL, 31141),
(31142, '1.25.40.10-FF-000814', NULL, 'Cell division cycle protein 16, putative', 484, NULL, NULL, 31142),
(31143, '2.30.180.10-FF-000070', NULL, 'Os02g0308800 protein', 165, NULL, NULL, 31143),
(31144, '3.30.505.10-FF-000265', NULL, NULL, 53, NULL, NULL, 31144),
(31145, '1.25.10.10-FF-001335', NULL, 'Plakophilin 1', 446, NULL, NULL, 31145),
(31146, '3.40.50.2000-FF-000021', NULL, 'UDP-glucuronosyltransferase', 170, NULL, NULL, 31146),
(31147, '2.80.10.50-FF-000072', NULL, 'Thisbe, isoform B', 130, NULL, NULL, 31147),
(31148, '3.30.450.60-FF-000034', NULL, 'AP-3 complex subunit mu', 153, NULL, NULL, 31148),
(31149, '2.30.30.490-FF-000094', NULL, 'Uncharacterized protein', 50, NULL, NULL, 31149),
(31150, '2.10.110.10-FF-000311', NULL, 'Chromosome 21, whole genome shotgun sequence', 93, NULL, NULL, 31150);
INSERT INTO "PUBLIC"."MODEL" VALUES
(31151, '3.40.710.10-FF-000150', NULL, 'Stage V sporulation protein D', 194, NULL, NULL, 31151),
(31152, '3.90.1440.10-FF-000015', NULL, 'Predicted protein', 99, NULL, NULL, 31152),
(31153, '4.10.400.10-FF-000101', NULL, 'Low-density lipoprotein receptor-related protein 1B', 40, NULL, NULL, 31153),
(31154, '3.40.190.10-FF-000805', NULL, 'Ligand-gated ionic channel, putative', 121, NULL, NULL, 31154),
(31155, '1.20.1270.60-FF-000118', NULL, 'Unplaced genomic scaffold supercont1.83, whole genome shotgun sequence', 223, NULL, NULL, 31155),
(31156, '2.40.50.40-FF-000106', NULL, 'Chromo domain-containing protein cec-3', 81, NULL, NULL, 31156),
(31157, '2.30.29.30-FF-001358', NULL, 'Uncharacterized protein', 132, NULL, NULL, 31157),
(31158, '3.90.1520.10-FF-000016', NULL, 'Gcy-37', 118, NULL, NULL, 31158),
(31159, '3.40.50.10320-FF-000009', NULL, 'Uncharacterized protein', 228, NULL, NULL, 31159),
(31160, '3.30.70.330-FF-002635', NULL, NULL, 124, NULL, NULL, 31160),
(31161, '1.10.540.10-FF-000050', NULL, 'Acyl-CoA dehydrogenase FadE33', 115, NULL, NULL, 31161),
(31162, '1.20.59.10-FF-000019', NULL, 'Chorismate mutase', 88, NULL, NULL, 31162),
(31163, '3.30.500.10-FF-000041', NULL, NULL, 117, NULL, NULL, 31163),
(31164, '3.40.140.10-FF-000241', NULL, 'Uncharacterized protein', 155, NULL, NULL, 31164),
(31165, '2.60.120.10-FF-000379', NULL, 'Probable mannose-6-phosphate isomerase', 82, NULL, NULL, 31165),
(31166, '2.160.20.10-FF-000253', NULL, 'Pectinesterase', 81, NULL, NULL, 31166),
(31167, '2.40.50.140-FF-000176', NULL, 'DNA repair protein RecO', 82, NULL, NULL, 31167),
(31168, '3.30.70.330-FF-001415', NULL, 'Organelle RRM domain-containing protein 6, chloroplastic', 107, NULL, NULL, 31168),
(31169, '1.25.10.10-FF-003483', NULL, 'U-box domain-containing protein 8', 102, NULL, NULL, 31169),
(31170, '3.40.50.1100-FF-000173', NULL, 'Pyridoxal-5''-phosphate-dependent enzyme family protein', 86, NULL, NULL, 31170),
(31171, '3.30.2290.10-FF-000017', NULL, 'Peptidase U62 modulator of DNA gyrase', 226, NULL, NULL, 31171),
(31172, '3.40.30.10-FF-000021', NULL, 'Chloride intracellular channel 4', 104, NULL, NULL, 31172),
(31173, '1.10.510.10-FF-003712', NULL, NULL, 160, NULL, NULL, 31173),
(31174, '3.40.50.620-FF-000771', NULL, 'Uncharacterized protein', 115, NULL, NULL, 31174),
(31175, '3.40.50.720-FF-000503', NULL, '6-phosphogluconate dehydrogenase, decarboxylating', 179, NULL, NULL, 31175),
(31176, '1.20.1050.10-FF-000256', NULL, 'Ganglioside-induced differentiation-associated protein 1, 2 gdap, putative', 138, NULL, NULL, 31176),
(31177, '1.20.58.60-FF-000846', NULL, 'Predicted protein', 141, NULL, NULL, 31177),
(31178, '3.40.50.790-FF-000007', NULL, 'Ribosomal protein L1p/L10e family', 105, NULL, NULL, 31178),
(31179, '2.130.10.10-FF-002171', NULL, 'Elongator complex protein 2', 140, NULL, NULL, 31179),
(31180, '3.40.630.30-FF-000683', NULL, 'Putative acyl-CoA N-acyltransferase (NAT) family protein', 91, NULL, NULL, 31180),
(31181, '3.40.50.880-FF-000034', NULL, 'carbamoyl-phosphate synthase small chain, chloroplastic', 223, NULL, NULL, 31181),
(31182, '3.40.50.300-FF-007914', NULL, 'Predicted protein', 183, NULL, NULL, 31182),
(31183, '1.25.40.10-FF-002467', NULL, 'Starch-binding outer membrane lipoprotein SusD', 177, NULL, NULL, 31183),
(31184, '2.130.10.10-FF-001748', NULL, 'Similarity to pre-mRNA splicing factor', 327, NULL, NULL, 31184),
(31185, '3.30.160.60-FF-005930', NULL, NULL, 28, NULL, NULL, 31185),
(31186, '3.40.50.2020-FF-000027', NULL, 'Xanthine phosphoribosyltransferase', 186, NULL, NULL, 31186),
(31187, '3.40.50.10300-FF-000003', NULL, 'phosphopantothenate--cysteine ligase', 291, NULL, NULL, 31187),
(31188, '1.10.132.60-FF-000009', NULL, 'DNA polymerase epsilon, catalytic subunit A', 140, NULL, NULL, 31188),
(31189, '1.25.40.10-FF-004092', NULL, 'Uncharacterized protein', 152, NULL, NULL, 31189),
(31190, '1.25.40.10-FF-000758', NULL, 'Tetratricopeptide repeat protein', 105, NULL, NULL, 31190),
(31191, '3.10.100.10-FF-000211', NULL, 'Immune-related, lectin-like receptor 4', 194, NULL, NULL, 31191);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(31192, '1.10.10.250-FF-000026', NULL, 'Uncharacterized protein', 28, NULL, NULL, 31192),
(31193, '3.30.479.30-FF-000046', NULL, 'Predicted protein', 111, NULL, NULL, 31193),
(31194, '4.10.260.10-FF-000005', NULL, 'regulator of G-protein signaling 9 isoform X1', 54, NULL, NULL, 31194),
(31195, '2.40.70.10-FF-000565', NULL, NULL, 85, NULL, NULL, 31195),
(31196, '3.30.1370.140-FF-000002', NULL, 'Putative hydrogenase expression/formation protein', 86, NULL, NULL, 31196),
(31197, '3.30.160.60-FF-000551', NULL, 'zinc finger protein 197 isoform X1', 29, NULL, NULL, 31197),
(31198, '2.60.40.10-FF-005481', NULL, NULL, 101, NULL, NULL, 31198),
(31199, '2.60.40.10-FF-003772', NULL, NULL, 104, NULL, NULL, 31199),
(31200, '3.40.50.2000-FF-000493', NULL, 'Glycosyl transferase family 1', 181, NULL, NULL, 31200),
(31201, '3.40.50.720-FF-001228', NULL, 'Cinnamoyl CoA reductase1', 65, NULL, NULL, 31201),
(31202, '3.30.200.20-FF-002387', NULL, 'Uncharacterized protein', 102, NULL, NULL, 31202),
(31203, '1.10.533.10-FF-000314', NULL, 'Uncharacterized protein', 33, NULL, NULL, 31203),
(31204, '1.25.40.10-FF-003580', NULL, 'Phox4', 173, NULL, NULL, 31204),
(31205, '2.10.110.10-FF-000255', NULL, 'Paxillin', 68, NULL, NULL, 31205),
(31206, '3.90.1150.10-FF-000476', NULL, 'Glutamine--scyllo-inositol transaminase', 100, NULL, NULL, 31206),
(31207, '3.40.50.10330-FF-000107', NULL, 'Inorganic polyphosphate/ATP-NAD kinase', 94, NULL, NULL, 31207),
(31208, '3.30.420.10-FF-000416', NULL, NULL, 172, NULL, NULL, 31208),
(31209, '3.40.50.1820-FF-001821', NULL, 'Triacylglycerol lipase, putative', 98, NULL, NULL, 31209),
(31210, '1.20.920.10-FF-000127', NULL, 'PolyBRoMo domain containing', 119, NULL, NULL, 31210),
(31211, '3.80.10.10-FF-000102', NULL, 'nischarin isoform X1', 97, NULL, NULL, 31211),
(31212, '3.40.920.10-FF-000008', NULL, 'Pyruvate-flavoredoxin oxidoreductase', 202, NULL, NULL, 31212),
(31213, '3.40.50.300-FF-001985', NULL, 'Chromosome 9, whole genome shotgun sequence', 181, NULL, NULL, 31213),
(31214, '1.20.1070.10-FF-001836', NULL, 'Predicted protein', 304, NULL, NULL, 31214),
(31215, '2.60.40.150-FF-000043', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', 139, NULL, NULL, 31215),
(31216, '1.20.58.2010-FF-000001', NULL, 'Rop guanine nucleotide exchange factor 14', 138, NULL, NULL, 31216),
(31217, '2.60.120.200-FF-000415', NULL, 'Uncharacterized protein', 155, NULL, NULL, 31217),
(31218, '2.60.40.10-FF-001624', NULL, 'titin isoform X1', 89, NULL, NULL, 31218),
(31219, '2.60.110.10-FF-000030', NULL, 'Osmotin', 40, NULL, NULL, 31219),
(31220, '1.20.1730.10-FF-000050', NULL, 'Uncharacterized protein', 89, NULL, NULL, 31220),
(31221, '6.20.10.30-FF-000008', NULL, 'DNA ligase', 37, NULL, NULL, 31221),
(31222, '1.25.40.20-FF-000295', NULL, 'Espin like', 152, NULL, NULL, 31222),
(31223, '2.30.310.10-FF-000013', NULL, NULL, 137, NULL, NULL, 31223),
(31224, '3.30.565.10-FF-000010', NULL, 'Sensor histidine kinase RcsC', 167, NULL, NULL, 31224),
(31225, '3.10.20.90-FF-000652', NULL, 'Autophagy-related protein', 112, NULL, NULL, 31225),
(31226, '1.20.120.1240-FF-000036', NULL, 'WGS project CABT00000000 data, contig 2.29', 210, NULL, NULL, 31226),
(31227, '3.40.1440.10-FF-000010', NULL, 'Excinuclease ABC subunit C', 93, NULL, NULL, 31227),
(31228, '3.30.420.10-FF-000040', NULL, 'Exonuclease family protein', 179, NULL, NULL, 31228),
(31229, '3.40.50.10860-FF-000002', NULL, 'Glutamate dehydrogenase', 136, NULL, NULL, 31229),
(31230, '2.130.10.10-FF-002732', NULL, 'WD repeat-containing protein DWA2', 295, NULL, NULL, 31230),
(31231, '3.40.50.300-FF-001462', NULL, 'Small GTP-binding protein, putative', 191, NULL, NULL, 31231),
(31232, '3.40.190.170-FF-000014', NULL, 'TRAP dicarboxylate transporter, DctP subunit, putative', 307, NULL, NULL, 31232),
(31233, '1.20.58.80-FF-000055', NULL, 'Regulator of free ubiquitin chains 1', 136, NULL, NULL, 31233),
(31234, '1.10.287.130-FF-000064', NULL, 'Sensor histidine kinase', 66, NULL, NULL, 31234),
(31235, '1.10.540.10-FF-000139', NULL, 'Glutaryl-CoA dehydrogenase isoform a', 64, NULL, NULL, 31235);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(31236, '4.10.410.10-FF-000074', NULL, 'Serine protease inhibitor, putative', 60, NULL, NULL, 31236),
(31237, '3.10.20.770-FF-000024', NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', 97, NULL, NULL, 31237),
(31238, '2.20.25.10-FF-000063', NULL, 'Positive transcription elongation factor, putative', 62, NULL, NULL, 31238),
(31239, '3.40.30.10-FF-000077', NULL, 'Protein disulfide-isomerase', 112, NULL, NULL, 31239),
(31240, '2.20.25.20-FF-000009', NULL, 'Casein kinase II subunit beta', 75, NULL, NULL, 31240),
(31241, '3.40.50.200-FF-000145', NULL, 'Proprotein convertase subtilisin/kexin type 6', 61, NULL, NULL, 31241),
(31242, '2.170.16.10-FF-000006', NULL, 'UPF0051 protein Mb1496', 137, NULL, NULL, 31242),
(31243, '1.50.10.20-FF-000111', NULL, 'Uncharacterized protein', 244, NULL, NULL, 31243),
(31244, '3.40.50.300-FF-007881', NULL, 'Uncharacterized protein', 197, NULL, NULL, 31244),
(31245, '1.10.20.10-FF-000015', NULL, 'Transcription initiation factor TFIID subunit 4B', 48, NULL, NULL, 31245),
(31246, '1.20.58.60-FF-000138', NULL, 'Alpha-actinin, sarcomeric', 106, NULL, NULL, 31246),
(31247, '2.60.40.1230-FF-000005', NULL, 'AP-1 complex subunit gamma', 118, NULL, NULL, 31247),
(31248, '3.40.390.10-FF-000225', NULL, NULL, 138, NULL, NULL, 31248),
(31249, '1.50.10.10-FF-000069', NULL, 'spermatogenesis-associated protein 20', 178, NULL, NULL, 31249),
(31250, '1.10.405.10-FF-000005', NULL, 'Amine oxidase [flavin-containing]', 93, NULL, NULL, 31250),
(31251, '3.30.420.40-FF-000144', NULL, 'Molecular chaperone HscC', 165, NULL, NULL, 31251),
(31252, '2.30.30.40-FF-000448', NULL, 'PACSIN3 isoform 8', 44, NULL, NULL, 31252),
(31253, '3.40.430.10-FF-000049', NULL, 'Riboflavin biosynthesis protein RibD', 217, NULL, NULL, 31253),
(31254, '3.40.50.800-FF-000084', NULL, 'Histidine--tRNA ligase', 97, NULL, NULL, 31254),
(31255, '3.40.50.300-FF-006133', NULL, 'SNF2 family DNA-dependent ATPase', 71, NULL, NULL, 31255),
(31256, '3.30.200.20-FF-000734', NULL, 'protein kinase DC1', 96, NULL, NULL, 31256),
(31257, '2.60.40.150-FF-000751', NULL, 'Uncharacterized protein', 77, NULL, NULL, 31257),
(31258, '3.40.50.1980-FF-000003', NULL, 'Iron ABC transporter substrate-binding protein', 109, NULL, NULL, 31258),
(31259, '4.10.860.120-FF-000012', NULL, 'DNA-directed RNA polymerase subunit', 128, NULL, NULL, 31259),
(31260, '2.40.50.140-FF-001013', NULL, NULL, 84, NULL, NULL, 31260),
(31261, '2.30.29.30-FF-000846', NULL, 'RanBP1 domain containing protein', 134, NULL, NULL, 31261),
(31262, '1.10.510.10-FF-002728', NULL, NULL, 204, NULL, NULL, 31262),
(31263, '3.40.50.1440-FF-000162', NULL, 'Uncharacterized protein', 115, NULL, NULL, 31263),
(31264, '3.40.720.10-FF-000116', NULL, 'GPI ethanolamine phosphate transferase 3 isoform X1', 181, NULL, NULL, 31264),
(31265, '1.10.10.60-FF-000776', NULL, NULL, 99, NULL, NULL, 31265),
(31266, '2.10.90.10-FF-000163', NULL, 'Growth differential factor 9', 56, NULL, NULL, 31266),
(31267, '3.40.50.80-FF-000200', NULL, 'Uncharacterized protein', 203, NULL, NULL, 31267),
(31268, '1.10.238.10-FF-000886', NULL, 'TBC1 domain family member 9', 169, NULL, NULL, 31268),
(31269, '1.10.486.10-FF-000035', NULL, 'ATP-dependent DNA helicase', 182, NULL, NULL, 31269),
(31270, '1.10.3210.10-FF-000125', NULL, 'Uncharacterized protein', 292, NULL, NULL, 31270),
(31271, '1.10.10.60-FF-000304', NULL, 'Visual system homeobox', 65, NULL, NULL, 31271),
(31272, '3.40.50.80-FF-000144', NULL, 'Predicted protein', 104, NULL, NULL, 31272),
(31273, '1.20.1560.10-FF-000542', NULL, 'Uncharacterized protein', 334, NULL, NULL, 31273),
(31274, '3.30.342.10-FF-000021', NULL, 'DNA polymerase', 174, NULL, NULL, 31274),
(31275, '3.40.50.300-FF-003986', NULL, 'P-loop containing nucleoside triphosphate hydrolases superfamily protein', 332, NULL, NULL, 31275),
(31276, '1.20.120.1910-FF-000024', NULL, 'Cysteine--tRNA ligase', 164, NULL, NULL, 31276),
(31277, '3.40.80.10-FF-000024', NULL, 'N-acetylmuramoyl-L-alanine amidase', 137, NULL, NULL, 31277),
(31278, '2.60.40.10-FF-000135', NULL, 'Titin a', 100, NULL, NULL, 31278);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(31279, '1.50.40.10-FF-000402', NULL, 'Uncharacterized protein', 236, NULL, NULL, 31279),
(31280, '1.10.800.10-FF-000002', NULL, 'Tyrosine 3-monooxygenase', 341, NULL, NULL, 31280),
(31281, '1.20.1560.10-FF-000486', NULL, 'ATP-binding protein syrD-ATP binding protein of ABC-type transporter', 302, NULL, NULL, 31281),
(31282, '1.10.238.10-FF-000358', NULL, 'CAMK/CDPK protein kinase', 200, NULL, NULL, 31282),
(31283, '2.20.25.90-FF-000013', NULL, 'Molybdopterin cofactor oxido-reductase', 66, NULL, NULL, 31283),
(31284, '3.40.50.300-FF-005880', NULL, 'Uncharacterized protein', 164, NULL, NULL, 31284),
(31285, '1.10.287.70-FF-000337', NULL, 'Ionotropic receptor 31a, isoform C', 159, NULL, NULL, 31285),
(31286, '1.10.10.60-FF-000248', NULL, 'Gastrulation brain homeobox 2', 89, NULL, NULL, 31286),
(31287, '3.30.200.20-FF-001083', NULL, 'Protein kinase, putative', 97, NULL, NULL, 31287),
(31288, '1.10.510.10-FF-001239', NULL, 'Predicted protein', 280, NULL, NULL, 31288),
(31289, '3.40.50.10810-FF-000212', NULL, 'Uncharacterized protein', 97, NULL, NULL, 31289),
(31290, '2.30.230.10-FF-000012', NULL, 'Putative Vitellogenin-1', 259, NULL, NULL, 31290),
(31291, '2.60.40.2840-FF-000010', NULL, 'Putative inositol-145-triphosphate 5-phosphatase synaptojanin inp51/inp52/inp53 family', 82, NULL, NULL, 31291),
(31292, '1.20.1560.10-FF-000339', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 345, NULL, NULL, 31292),
(31293, '3.30.1640.10-FF-000033', NULL, 'DNA helicase', 103, NULL, NULL, 31293),
(31294, '3.20.20.190-FF-000129', NULL, NULL, 152, NULL, NULL, 31294),
(31295, '1.20.1110.10-FF-000082', NULL, NULL, 19, NULL, NULL, 31295),
(31296, '2.20.100.10-FF-000145', NULL, 'SPONdin (Extracellular matrix glycoprotein) family', 50, NULL, NULL, 31296),
(31297, '2.30.39.10-FF-000009', NULL, 'Glia-derived nexin isoform 2', 120, NULL, NULL, 31297),
(31298, '3.30.450.20-FF-000342', NULL, 'Hybrid sensor histidine kinase/response regulator', 143, NULL, NULL, 31298),
(31299, '3.30.65.10-FF-000006', NULL, 'DNA topoisomerase 1', 44, NULL, NULL, 31299),
(31300, '1.10.8.10-FF-000238', NULL, 'Ubiquitin-like protein 7', 40, NULL, NULL, 31300),
(31301, '3.90.25.10-FF-000074', NULL, 'NmrA-like family domain-containing protein 1', 72, NULL, NULL, 31301),
(31302, '1.10.287.70-FF-000484', NULL, 'Uncharacterized protein', 267, NULL, NULL, 31302),
(31303, '2.60.120.200-FF-000359', NULL, 'Hydroxyproline O-galactosyltransferase GALT6', 94, NULL, NULL, 31303),
(31304, '1.10.510.10-FF-001767', NULL, 'Tyrosine-protein kinase', 150, NULL, NULL, 31304),
(31305, '1.10.472.10-FF-000060', NULL, 'D6-type cyclin', 118, NULL, NULL, 31305),
(31306, '3.40.50.150-FF-001451', NULL, NULL, 140, NULL, NULL, 31306),
(31307, '3.40.50.720-FF-001936', NULL, 'Uncharacterized protein', 360, NULL, NULL, 31307),
(31308, '3.30.1110.10-FF-000004', NULL, 'Adenosine kinase-like protein', 65, NULL, NULL, 31308),
(31309, '3.40.50.1240-FF-000107', NULL, 'Phytase', 438, NULL, NULL, 31309),
(31310, '4.10.60.10-FF-000078', NULL, 'Unplaced genomic scaffold supercont2.10, whole genome shotgun sequence', 40, NULL, NULL, 31310),
(31311, '3.90.70.10-FF-000381', NULL, 'Uncharacterized protein', 321, NULL, NULL, 31311),
(31312, '3.60.130.10-FF-000078', NULL, 'Gamma-butyrobetaine hydroxylase, putative', 278, NULL, NULL, 31312),
(31313, '3.90.550.10-FF-000530', NULL, 'Nucleotidyl transferase, putative', 159, NULL, NULL, 31313),
(31314, '3.90.1230.10-FF-000005', NULL, NULL, 35, NULL, NULL, 31314),
(31315, '1.20.1410.10-FF-000008', NULL, 'Huntingtin interacting protein 1', 117, NULL, NULL, 31315),
(31316, '3.90.1150.10-FF-000004', NULL, '2-amino-3-ketobutyrate coenzyme A ligase', 107, NULL, NULL, 31316),
(31317, '3.10.110.10-FF-000184', NULL, 'Uncharacterized protein', 137, NULL, NULL, 31317),
(31318, '3.10.20.10-FF-000027', NULL, '60S ribosomal protein L18a', 72, NULL, NULL, 31318),
(31319, '3.30.160.60-FF-003277', NULL, 'Zgc:171551', 84, NULL, NULL, 31319),
(31320, '2.130.10.10-FF-004677', NULL, 'Chromosome 12, whole genome shotgun sequence', 181, NULL, NULL, 31320);
INSERT INTO "PUBLIC"."MODEL" VALUES
(31321, '4.10.400.10-FF-000157', NULL, 'LDL receptor related protein 2', 43, NULL, NULL, 31321),
(31322, '2.90.10.10-FF-000003', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', 128, NULL, NULL, 31322),
(31323, '2.30.29.30-FF-000285', NULL, 'regulator of G-protein signaling 3 isoform X1', 140, NULL, NULL, 31323),
(31324, '2.10.25.10-FF-000821', NULL, 'Neurogenic locus notch-like protein 1', 38, NULL, NULL, 31324),
(31325, '3.40.1110.10-FF-000401', NULL, NULL, 81, NULL, NULL, 31325),
(31326, '3.80.10.10-FF-002811', NULL, 'Si:ch73-168d20.1', 173, NULL, NULL, 31326),
(31327, '2.170.270.10-FF-000004', NULL, 'Histone-lysine N-methyltransferase', 158, NULL, NULL, 31327),
(31328, '3.40.50.12160-FF-000016', NULL, 'RNA modification enzyme, MiaB family', 121, NULL, NULL, 31328),
(31329, '2.60.220.30-FF-000005', NULL, 'Ankyrin-2 isoform 2', 82, NULL, NULL, 31329),
(31330, '2.30.30.90-FF-000002', NULL, 'Iron-dependent repressor IdeR', 80, NULL, NULL, 31330),
(31331, '3.40.20.10-FF-000104', NULL, 'Gelsolin, isoform J', 91, NULL, NULL, 31331),
(31332, '3.30.70.1230-FF-000107', NULL, 'Guanylate cyclase', 173, NULL, NULL, 31332),
(31333, '1.20.140.80-FF-000009', NULL, 'Transcription factor E2F/dimerisation partner (TDP) family protein', 140, NULL, NULL, 31333),
(31334, '1.20.120.560-FF-000005', NULL, 'Bro1p', 177, NULL, NULL, 31334),
(31335, '2.30.39.10-FF-000156', NULL, 'Uncharacterized protein', 105, NULL, NULL, 31335),
(31336, '2.10.50.30-FF-000048', NULL, 'Uncharacterized protein', 57, NULL, NULL, 31336),
(31337, '3.40.190.10-FF-000772', NULL, 'Os06g0190000 protein', 121, NULL, NULL, 31337),
(31338, '3.30.300.20-FF-000011', NULL, 'Single-stranded DNA-binding protein', 82, NULL, NULL, 31338),
(31339, '2.130.10.10-FF-000315', NULL, 'Vacuolar protein sorting-associated protein 11 homolog', 269, NULL, NULL, 31339),
(31340, '1.20.1250.20-FF-000774', NULL, 'Major facilitator superfamily MFS_1', 211, NULL, NULL, 31340),
(31341, '3.30.70.330-FF-000634', NULL, 'Related to glycine-rich RNA-binding protein', 99, NULL, NULL, 31341),
(31342, '3.40.140.20-FF-000007', NULL, 'Bifunctional purine biosynthesis protein PurH', 151, NULL, NULL, 31342),
(31343, '1.20.5.340-FF-000120', NULL, 'Rho-associated kinase, putative', 157, NULL, NULL, 31343),
(31344, '2.130.10.10-FF-000259', NULL, 'DDB1- and CUL4-associated factor 11 isoform X1', 109, NULL, NULL, 31344),
(31345, '2.60.120.10-FF-000290', NULL, 'Cyclic nucleotide-binding domain containing protein, putative', 148, NULL, NULL, 31345),
(31346, '2.30.30.380-FF-000061', NULL, 'TGF-beta activated kinase 1 (MAP3K7) binding protein 3', 46, NULL, NULL, 31346),
(31347, '3.50.7.10-FF-000024', NULL, 'Mitochondrial chaperone TCM62', 129, NULL, NULL, 31347),
(31348, '3.10.105.10-FF-000054', NULL, 'Peptide ABC transporter permease protein', 220, NULL, NULL, 31348),
(31349, '3.30.559.30-FF-000103', NULL, 'Glycine-AMP ligase', 78, NULL, NULL, 31349),
(31350, '3.90.79.10-FF-000226', NULL, 'Uncharacterized protein', 117, NULL, NULL, 31350),
(31351, '3.80.10.10-FF-000866', NULL, 'Leucine-rich repeat-containing protein 19', 147, NULL, NULL, 31351),
(31352, '3.30.310.80-FF-000007', NULL, 'Serine/threonine-protein kinase Chk1 isoform 1', 126, NULL, NULL, 31352),
(31353, '2.130.10.10-FF-002204', NULL, 'Os01g0238900 protein', 83, NULL, NULL, 31353),
(31354, '2.170.220.10-FF-000001', NULL, 'methionine--tRNA ligase, mitochondrial', 117, NULL, NULL, 31354),
(31355, '3.40.366.10-FF-000028', NULL, 'Malonyl CoA-acyl carrier protein transacylase', 214, NULL, NULL, 31355),
(31356, '3.30.60.90-FF-000024', NULL, 'Unplaced genomic scaffold supercont2.17, whole genome shotgun sequence', 45, NULL, NULL, 31356),
(31357, '3.40.50.10810-FF-000156', NULL, 'Uncharacterized protein', 49, NULL, NULL, 31357),
(31358, '3.30.70.890-FF-000072', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 115, NULL, NULL, 31358),
(31359, '2.130.10.10-FF-003188', NULL, 'Flagellar associated protein', 341, NULL, NULL, 31359),
(31360, '1.25.40.10-FF-002091', NULL, 'Pentatricopeptide repeat-containing protein At4g08210', 134, NULL, NULL, 31360);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(31361, '3.30.160.60-FF-004238', NULL, NULL, 23, NULL, NULL, 31361),
(31362, '3.60.15.10-FF-000024', NULL, 'Zinc phosphodiesterase ELAC protein 2', 239, NULL, NULL, 31362),
(31363, '1.20.58.1080-FF-000014', NULL, 'ATP-dependent RNA helicase SUPV3L1, mitochondrial', 108, NULL, NULL, 31363),
(31364, '3.80.10.10-FF-002608', NULL, 'Receptor kinase-like protein', 65, NULL, NULL, 31364),
(31365, '1.10.1040.10-FF-000089', NULL, 'Uncharacterized protein', 138, NULL, NULL, 31365),
(31366, '2.60.120.290-FF-000133', NULL, 'Uncharacterized protein', 103, NULL, NULL, 31366),
(31367, '3.40.50.410-FF-000293', NULL, 'Predicted protein', 189, NULL, NULL, 31367),
(31368, '2.30.40.10-FF-000114', NULL, '5-methylthioadenosine/S-adenosylhomocysteine deaminase', 99, NULL, NULL, 31368),
(31369, '3.30.1490.180-FF-000024', NULL, 'DNA-directed RNA polymerase subunit', 74, NULL, NULL, 31369),
(31370, '4.10.375.10-FF-000002', NULL, 'Lipoxygenase', 99, NULL, NULL, 31370),
(31371, '2.30.31.10-FF-000020', NULL, 'Uncharacterized protein', 64, NULL, NULL, 31371),
(31372, '3.40.50.1820-FF-000096', NULL, 'Carboxypeptidase vitellogenic-like', 418, NULL, NULL, 31372),
(31373, '2.40.30.110-FF-000028', NULL, NULL, 83, NULL, NULL, 31373),
(31374, '3.90.1170.50-FF-000023', NULL, 'Uncharacterized protein', 46, NULL, NULL, 31374),
(31375, '1.10.10.10-FF-002083', NULL, 'Spo11-like protein', 67, NULL, NULL, 31375),
(31376, '3.30.70.330-FF-003040', NULL, NULL, 127, NULL, NULL, 31376),
(31377, '2.60.40.2860-FF-000016', NULL, 'Transmission-blocking target antigen s230', 147, NULL, NULL, 31377),
(31378, '3.40.50.300-FF-003839', NULL, 'Rab GTPase', 214, NULL, NULL, 31378),
(31379, '3.30.70.330-FF-002579', NULL, NULL, 140, NULL, NULL, 31379),
(31380, '3.80.10.10-FF-001119', NULL, 'mRNA export factor mex67, putative', 175, NULL, NULL, 31380),
(31381, '3.30.160.60-FF-005727', NULL, NULL, 32, NULL, NULL, 31381),
(31382, '2.130.10.10-FF-001951', NULL, 'WD_domain_-_G-beta_repeat_-_putative', 322, NULL, NULL, 31382),
(31383, '3.40.50.300-FF-008078', NULL, 'Uncharacterized protein', 117, NULL, NULL, 31383),
(31384, '3.40.50.720-FF-000447', NULL, 'NADP dependent oxidoreductase domain containing 1', 155, NULL, NULL, 31384),
(31385, '3.40.50.300-FF-000349', NULL, 'Rho GTPase-activating protein 5', 244, NULL, NULL, 31385),
(31386, '2.30.29.30-FF-001302', NULL, 'Uncharacterized protein', 80, NULL, NULL, 31386),
(31387, '1.25.40.20-FF-001076', NULL, 'Poly [ADP-ribose] polymerase', 124, NULL, NULL, 31387),
(31388, '2.30.30.830-FF-000004', NULL, 'Type II secretion system protein C', 67, NULL, NULL, 31388),
(31389, '3.90.1070.10-FF-000003', NULL, '5-amino-6-(5-phospho-D-ribitylamino)uracil phosphatase YcsE', 79, NULL, NULL, 31389),
(31390, '3.30.110.110-FF-000016', NULL, 'Double-strand break repair protein', 108, NULL, NULL, 31390),
(31391, '1.10.246.10-FF-000017', NULL, 'Serum albumin 1 protein', 78, NULL, NULL, 31391),
(31392, '2.130.10.130-FF-000014', NULL, 'Integrin alpha FG-GAP repeat containing 1', 158, NULL, NULL, 31392),
(31393, '3.80.10.10-FF-002047', NULL, 'Leucine-rich repeat receptor-like protein kinase PXC1', 166, NULL, NULL, 31393),
(31394, '1.20.1250.20-FF-000589', NULL, 'Unplaced genomic scaffold supercont1.136, whole genome shotgun sequence', 177, NULL, NULL, 31394),
(31395, '3.40.50.720-FF-000975', NULL, 'GM20055', 295, NULL, NULL, 31395),
(31396, '1.25.40.10-FF-001539', NULL, 'AGAP002648-PA', 157, NULL, NULL, 31396),
(31397, '3.50.50.60-FF-000576', NULL, 'Smox protein', 66, NULL, NULL, 31397),
(31398, '2.30.30.1020-FF-000005', NULL, 'Regena, isoform C', 190, NULL, NULL, 31398),
(31399, '3.40.50.10190-FF-000138', NULL, 'AGAP002760-PA', 92, NULL, NULL, 31399),
(31400, '3.30.200.20-FF-001662', NULL, 'Serine/threonine-protein kinase Nek4', 85, NULL, NULL, 31400),
(31401, '2.60.40.10-FF-004025', NULL, NULL, 98, NULL, NULL, 31401),
(31402, '1.20.1050.10-FF-000312', NULL, 'Predicted protein', 123, NULL, NULL, 31402),
(31403, '1.10.472.130-FF-000025', NULL, 'Dynein heavy chain, putative', 115, NULL, NULL, 31403),
(31404, '3.40.50.300-FF-005728', NULL, 'Protein SMAX1-LIKE 2', 158, NULL, NULL, 31404);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(31405, '2.60.120.970-FF-000034', NULL, 'inhibin beta B chain', 147, NULL, NULL, 31405),
(31406, '3.10.450.50-FF-000075', NULL, 'Uncharacterized protein', 126, NULL, NULL, 31406),
(31407, '1.20.120.1630-FF-000030', NULL, 'Predicted protein', 195, NULL, NULL, 31407),
(31408, '2.70.50.30-FF-000029', NULL, NULL, 128, NULL, NULL, 31408),
(31409, '3.30.70.340-FF-000019', NULL, NULL, 98, NULL, NULL, 31409),
(31410, '3.30.40.10-FF-002309', NULL, 'Uncharacterized protein', 113, NULL, NULL, 31410),
(31411, '3.80.10.10-FF-001827', NULL, 'F-box and leucine-rich repeat protein 17', 93, NULL, NULL, 31411),
(31412, '3.50.50.60-FF-000609', NULL, 'Bacteriochlorophyll synthase', 385, NULL, NULL, 31412),
(31413, '1.10.220.150-FF-000008', NULL, 'ADP-ribosylation factor GTPase activating protein 1', 126, NULL, NULL, 31413),
(31414, '3.30.430.20-FF-000015', NULL, 'Cysteine-rich receptor-like protein kinase 3', 101, NULL, NULL, 31414),
(31415, '3.20.20.190-FF-000096', NULL, 'Phospholipase D LiSicTox-betaID1', 278, NULL, NULL, 31415),
(31416, '3.60.90.10-FF-000012', NULL, 'S-adenosylmethionine decarboxylase proenzyme', 118, NULL, NULL, 31416),
(31417, '3.40.1190.10-FF-000029', NULL, 'Folylpolyglutamate synthase', 137, NULL, NULL, 31417),
(31418, '3.40.50.410-FF-000326', NULL, 'TFIIH P34', 195, NULL, NULL, 31418),
(31419, '3.90.1100.10-FF-000001', NULL, 'DNA-directed RNA polymerase subunit beta', 202, NULL, NULL, 31419),
(31420, '3.40.50.720-FF-001431', NULL, '6-deoxyerythronolide-B synthase EryA2, modules 3 and 4', 463, NULL, NULL, 31420),
(31421, '3.30.70.330-FF-002399', NULL, NULL, 95, NULL, NULL, 31421),
(31422, '3.60.21.60-FF-000014', NULL, 'DNA polymerase alpha subunit B', 198, NULL, NULL, 31422),
(31423, '3.40.50.2300-FF-001533', NULL, NULL, 70, NULL, NULL, 31423),
(31424, '1.20.1250.20-FF-002011', NULL, 'Os04g0691400 protein', 371, NULL, NULL, 31424),
(31425, '2.130.10.10-FF-001243', NULL, 'Anaphase-promoting complex subunit 4', 216, NULL, NULL, 31425),
(31426, '1.25.40.10-FF-001686', NULL, 'pentatricopeptide repeat-containing protein At4g30700', 101, NULL, NULL, 31426),
(31427, '1.20.5.110-FF-000248', NULL, 'Syntaxin 10-1', 100, NULL, NULL, 31427),
(31428, '3.40.50.200-FF-000089', NULL, 'Subtilisin-like serine protease', 347, NULL, NULL, 31428),
(31429, '1.10.3210.10-FF-000092', NULL, 'Cyclic di-GMP phosphodiesterase PA4108', 293, NULL, NULL, 31429),
(31430, '3.80.10.10-FF-002755', NULL, 'Si:ch211-156p11.1', 129, NULL, NULL, 31430),
(31431, '2.30.29.30-FF-000902', NULL, 'Uncharacterized protein', 88, NULL, NULL, 31431),
(31432, '3.40.140.10-FF-000061', NULL, 'DRAP deaminase', 151, NULL, NULL, 31432),
(31433, '3.30.1240.10-FF-000008', NULL, 'HAD family phosphatase', 114, NULL, NULL, 31433),
(31434, '3.30.200.20-FF-000678', NULL, 'Tyrosine kinase receptor', 112, NULL, NULL, 31434),
(31435, '1.10.150.20-FF-000152', NULL, 'UvrABC system protein C', 47, NULL, NULL, 31435),
(31436, '2.10.220.10-FF-000140', NULL, 'Proprotein convertase subtilisin/kexin type 5', 59, NULL, NULL, 31436),
(31437, '1.25.10.10-FF-001482', NULL, 'RING-type E3 ubiquitin transferase', 366, NULL, NULL, 31437),
(31438, '1.10.287.110-FF-000378', NULL, 'Dnaj-like protein subfamily B member 1-like protein', 117, NULL, NULL, 31438),
(31439, '3.30.70.20-FF-000105', NULL, NULL, 70, NULL, NULL, 31439),
(31440, '2.60.40.10-FF-000282', NULL, 'peroxidasin homolog', 92, NULL, NULL, 31440),
(31441, '3.40.20.10-FF-000048', NULL, 'Putative gmf family protein', 140, NULL, NULL, 31441),
(31442, '1.10.472.10-FF-000621', NULL, 'Putative cyclin B, copy D', 128, NULL, NULL, 31442),
(31443, '2.30.29.70-FF-000015', NULL, 'Uncharacterized protein', 71, NULL, NULL, 31443),
(31444, '4.10.650.10-FF-000001', NULL, 'Copper binding metallothionein', 53, NULL, NULL, 31444),
(31445, '2.60.40.60-FF-000976', NULL, 'Uncharacterized protein', 112, NULL, NULL, 31445),
(31446, '1.20.920.50-FF-000004', NULL, 'MCG17492, isoform CRA_b', 82, NULL, NULL, 31446),
(31447, '2.30.30.140-FF-000096', NULL, 'Tudor domain containing 6', 91, NULL, NULL, 31447),
(31448, '1.10.1740.10-FF-000002', NULL, 'RNA polymerase sigma factor FliA', 83, NULL, NULL, 31448);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(31449, '2.40.30.10-FF-000203', NULL, 'Ribosome-releasing factor 2, mitochondrial', 117, NULL, NULL, 31449),
(31450, '3.30.160.60-FF-005166', NULL, NULL, 89, NULL, NULL, 31450),
(31451, '3.50.50.60-FF-000761', NULL, 'Alcohol dehydrogenase', 61, NULL, NULL, 31451),
(31452, '3.40.50.300-FF-004391', NULL, 'ABC transporter, ATP-binding protein', 199, NULL, NULL, 31452),
(31453, '3.40.1110.10-FF-000345', NULL, NULL, 76, NULL, NULL, 31453),
(31454, '2.60.40.10-FF-004553', NULL, NULL, 111, NULL, NULL, 31454),
(31455, '4.10.780.10-FF-000005', NULL, 'Pyruvate-ferredoxin oxidoreductase', 40, NULL, NULL, 31455),
(31456, '1.25.40.180-FF-000220', NULL, NULL, 148, NULL, NULL, 31456),
(31457, '3.40.50.2300-FF-000549', NULL, 'Phosphoglycerate transport system transcriptional regulatory protein PgtA', 131, NULL, NULL, 31457),
(31458, '3.30.160.60-FF-002440', NULL, 'ZNF484 isoform 2', 28, NULL, NULL, 31458),
(31459, '1.10.510.10-FF-000278', NULL, 'serine/threonine-protein kinase greatwall isoform X1', 118, NULL, NULL, 31459),
(31460, '3.40.50.1370-FF-000062', NULL, NULL, 35, NULL, NULL, 31460),
(31461, '3.30.1370.10-FF-000164', NULL, 'Protein CBG07980', 77, NULL, NULL, 31461),
(31462, '3.40.50.150-FF-000523', NULL, 'DNA (cytosine-5)-methyltransferase CMT2', 106, NULL, NULL, 31462),
(31463, '3.30.1010.10-FF-000148', NULL, 'Uncharacterized protein', 107, NULL, NULL, 31463),
(31464, '3.90.190.10-FF-000103', NULL, 'dual specificity protein phosphatase CDC14A isoform X1', 96, NULL, NULL, 31464),
(31465, '3.30.160.60-FF-005874', NULL, NULL, 47, NULL, NULL, 31465),
(31466, '3.30.160.20-FF-000146', NULL, 'Uncharacterized protein', 65, NULL, NULL, 31466),
(31467, '1.10.630.10-FF-000641', NULL, 'Cytochrome P450', 217, NULL, NULL, 31467),
(31468, '3.40.630.10-FF-000289', NULL, 'Probable M18 family aminopeptidase 1', 269, NULL, NULL, 31468),
(31469, '2.10.25.10-FF-000057', NULL, 'protocadherin Fat 1 isoform X2', 41, NULL, NULL, 31469),
(31470, '1.20.1640.10-FF-000020', NULL, 'Transmembrane transport protein MmpL10', 202, NULL, NULL, 31470),
(31471, '1.25.40.20-FF-001784', NULL, 'Pho81p', 179, NULL, NULL, 31471),
(31472, '1.10.510.10-FF-002223', NULL, NULL, 204, NULL, NULL, 31472),
(31473, '3.30.160.60-FF-000495', NULL, 'zinc finger protein 668', 31, NULL, NULL, 31473),
(31474, '1.10.8.60-FF-000180', NULL, 'Sigma-54 dependent transcriptional regulator', 78, NULL, NULL, 31474),
(31475, '1.20.1720.10-FF-000021', NULL, 'Drug resistance transporter, EmrB/QacA subfamily', 207, NULL, NULL, 31475),
(31476, '3.80.10.10-FF-001794', NULL, 'Rasgrp4 protein', 168, NULL, NULL, 31476),
(31477, '1.25.40.20-FF-001599', NULL, 'GH09064p', 112, NULL, NULL, 31477),
(31478, '2.60.60.20-FF-000050', NULL, NULL, 135, NULL, NULL, 31478),
(31479, '2.10.25.10-FF-000765', NULL, 'neural-cadherin-like isoform X2', 43, NULL, NULL, 31479),
(31480, '3.30.160.60-FF-006150', NULL, NULL, 24, NULL, NULL, 31480),
(31481, '3.10.350.10-FF-000055', NULL, 'Muramidase', 70, NULL, NULL, 31481),
(31482, '1.20.970.30-FF-000001', NULL, 'Eukaryotic translation initiation factor subunit eIF-4F, putative', 70, NULL, NULL, 31482),
(31483, '3.90.550.10-FF-000474', NULL, 'Protein O-linked-mannose beta-1,2-N-acetylglucosaminyltransferase 1', 215, NULL, NULL, 31483),
(31484, '1.10.238.110-FF-000003', NULL, 'Diacylglycerol kinase', 104, NULL, NULL, 31484),
(31485, '1.20.1720.10-FF-000077', NULL, 'Drug resistance transporter EmrB/QacA subfamily', 267, NULL, NULL, 31485),
(31486, '3.40.50.740-FF-000009', NULL, 'Formate dehydrogenase N subunit alpha, selenocysteine-containing', 226, NULL, NULL, 31486),
(31487, '2.130.10.10-FF-000046', NULL, 'WD repeat-containing protein 62 isoform 1', 287, NULL, NULL, 31487),
(31488, '2.60.40.10-FF-005918', NULL, NULL, 111, NULL, NULL, 31488),
(31489, '3.10.110.10-FF-000217', NULL, 'Uncharacterized protein', 159, NULL, NULL, 31489),
(31490, '1.20.1250.20-FF-000561', NULL, 'YJL163C-like protein', 432, NULL, NULL, 31490),
(31491, '1.50.40.10-FF-000222', NULL, 'Mitochondrial glycine transporter', 124, NULL, NULL, 31491),
(31492, '2.130.10.10-FF-003805', NULL, 'Uncharacterized protein', 309, NULL, NULL, 31492);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(31493, '3.60.40.10-FF-000116', NULL, 'Uncharacterized protein, isoform B', 259, NULL, NULL, 31493),
(31494, '3.40.50.150-FF-000046', NULL, 'Ribosomal RNA large subunit methyltransferase G', 195, NULL, NULL, 31494),
(31495, '3.40.50.300-FF-004716', NULL, 'Methylenetetrahydrofolate dehydrogenase (NADP+-dependent) 1, methenyltetrahydrofolate cyclohydrolase, formyltetrahydrofolate synthetase', 93, NULL, NULL, 31495),
(31496, '3.30.590.10-FF-000046', NULL, 'Uncharacterized protein', 110, NULL, NULL, 31496),
(31497, '1.10.510.10-FF-000019', NULL, 'Ephrin type-A receptor 5', 200, NULL, NULL, 31497),
(31498, '3.40.30.10-FF-000633', NULL, 'Uncharacterized protein', 68, NULL, NULL, 31498),
(31499, '3.40.50.2300-FF-001393', NULL, NULL, 84, NULL, NULL, 31499),
(31500, '1.20.5.500-FF-000011', NULL, NULL, 73, NULL, NULL, 31500),
(31501, '2.40.30.30-FF-000006', NULL, 'Riboflavin kinase / FAD synthase family protein, putative', 146, NULL, NULL, 31501),
(31502, '2.10.25.10-FF-000760', NULL, 'Delta-like 1', 37, NULL, NULL, 31502),
(31503, '3.40.50.20-FF-000053', NULL, 'D-alanine--D-alanine ligase', 128, NULL, NULL, 31503),
(31504, '2.60.40.740-FF-000001', NULL, 'Major cell-surface adhesin PAc', 147, NULL, NULL, 31504),
(31505, '1.25.10.10-FF-002471', NULL, 'Uncharacterized protein', 215, NULL, NULL, 31505),
(31506, '3.40.30.10-FF-001089', NULL, 'Thioredoxin reductase 1', 104, NULL, NULL, 31506),
(31507, '3.20.10.10-FF-000060', NULL, 'Uncharacterized protein HI_1169', 109, NULL, NULL, 31507),
(31508, '3.30.160.20-FF-000067', NULL, '40S ribosomal protein S2', 108, NULL, NULL, 31508),
(31509, '3.40.50.2000-FF-000465', NULL, 'UDP-glycosyltransferase 73D1', 12, NULL, NULL, 31509),
(31510, '3.90.70.10-FF-000414', NULL, 'Clan CA, family C1, cathepsin L-like cysteine peptidase', 189, NULL, NULL, 31510),
(31511, '2.60.120.260-FF-000349', NULL, 'Uncharacterized protein', 96, NULL, NULL, 31511),
(31512, '4.10.400.10-FF-000337', NULL, 'Uncharacterized protein', 37, NULL, NULL, 31512),
(31513, '2.40.30.180-FF-000009', NULL, 'Predicted protein', 82, NULL, NULL, 31513),
(31514, '3.30.160.60-FF-003165', NULL, 'zinc finger protein 485', 29, NULL, NULL, 31514),
(31515, '3.90.550.10-FF-000710', NULL, 'UDP-N-acetylglucosamine pyrophosphorylase 1 like 1', 415, NULL, NULL, 31515),
(31516, '3.30.1120.30-FF-000011', NULL, 'Serine/threonine-protein kinase', 102, NULL, NULL, 31516),
(31517, '3.20.20.70-FF-000005', NULL, 'Phospho-2-dehydro-3-deoxyheptonate aldolase', 356, NULL, NULL, 31517),
(31518, '3.30.950.10-FF-000029', NULL, 'Uroporphyrin-iii C-methyltransferase', 108, NULL, NULL, 31518),
(31519, '1.25.40.650-FF-000001', NULL, 'Penicillin-binding protein activator LpoA', 109, NULL, NULL, 31519),
(31520, '3.60.20.40-FF-000017', NULL, 'GM13229', 195, NULL, NULL, 31520),
(31521, '3.90.70.10-FF-000886', NULL, 'Uncharacterized protein', 246, NULL, NULL, 31521),
(31522, '1.25.40.10-FF-000786', NULL, 'TPR-repeat-containing chaperone protein DNAJ', 129, NULL, NULL, 31522),
(31523, '3.50.50.60-FF-000929', NULL, 'Putative pyridine nucleotide-disulfide oxidoreductase', 202, NULL, NULL, 31523),
(31524, '1.10.1070.11-FF-000070', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', 143, NULL, NULL, 31524),
(31525, '3.40.50.720-FF-000003', NULL, 'S-(hydroxymethyl)glutathione dehydrogenase', 139, NULL, NULL, 31525),
(31526, '3.90.79.10-FF-000013', NULL, 'Uncharacterized Nudix hydrolase NudL', 180, NULL, NULL, 31526),
(31527, '2.60.120.10-FF-000295', NULL, 'Transcriptional regulator, AraC family', 84, NULL, NULL, 31527),
(31528, '3.40.50.300-FF-001962', NULL, 'ATP-dependent protease La', 175, NULL, NULL, 31528),
(31529, '1.25.10.10-FF-001914', NULL, 'Disheveled associated activator of morphogenesis, putative', 194, NULL, NULL, 31529),
(31530, '3.80.10.10-FF-004441', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 313, NULL, NULL, 31530),
(31531, '3.30.2160.10-FF-000013', NULL, 'E3 ubiquitin-protein ligase TRIP12 isoform X1', 104, NULL, NULL, 31531),
(31532, '1.25.40.20-FF-001520', NULL, 'Kinase, NEK-frag', 241, NULL, NULL, 31532);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(31533, '2.70.150.10-FF-000098', NULL, 'Cation-transporting ATPase', 159, NULL, NULL, 31533),
(31534, '3.40.50.1380-FF-000003', NULL, 'Bifunctional purine biosynthesis protein', 193, NULL, NULL, 31534),
(31535, '1.20.1250.20-FF-002308', NULL, 'Uncharacterized protein', 172, NULL, NULL, 31535),
(31536, '2.70.130.10-FF-000147', NULL, NULL, 160, NULL, NULL, 31536),
(31537, '1.10.472.100-FF-000005', NULL, NULL, 103, NULL, NULL, 31537),
(31538, '2.60.40.10-FF-002108', NULL, '1,4-alpha-glucan branching enzyme', 107, NULL, NULL, 31538),
(31539, '2.60.40.10-FF-000394', NULL, 'Down syndrome cell adhesion molecule, isoform J', 92, NULL, NULL, 31539),
(31540, '3.30.160.60-FF-005514', NULL, NULL, 29, NULL, NULL, 31540),
(31541, '1.10.1670.10-FF-000030', NULL, 'A/G-specific adenine glycosylase, putative', 71, NULL, NULL, 31541),
(31542, '1.10.10.60-FF-000035', NULL, 'paired box protein Pax-3 isoform X2', 64, NULL, NULL, 31542),
(31543, '2.40.170.20-FF-000053', NULL, 'Outer membrane cobalamin receptor protein', 630, NULL, NULL, 31543),
(31544, '1.20.1720.10-FF-000026', NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', 194, NULL, NULL, 31544),
(31545, '3.80.10.10-FF-000158', NULL, 'Leucine rich repeat containing 75A', 140, NULL, NULL, 31545),
(31546, '3.40.50.150-FF-001035', NULL, NULL, 163, NULL, NULL, 31546),
(31547, '1.10.3380.10-FF-000019', NULL, 'Protein translocation complex componenet (Npl1), putative', 122, NULL, NULL, 31547),
(31548, '3.30.70.1230-FF-000231', NULL, 'Predicted protein', 200, NULL, NULL, 31548),
(31549, '1.25.40.210-FF-000004', NULL, 'Telomeric repeat-binding factor', 60, NULL, NULL, 31549),
(31550, '4.10.280.10-FF-000248', NULL, 'Predicted protein', 83, NULL, NULL, 31550),
(31551, '2.60.40.10-FF-004929', NULL, NULL, 113, NULL, NULL, 31551),
(31552, '2.120.10.30-FF-000294', NULL, 'Low density lipoprotein receptor-related protein 6', 322, NULL, NULL, 31552),
(31553, '3.30.200.20-FF-002151', NULL, 'Uncharacterized protein', 68, NULL, NULL, 31553),
(31554, '3.40.50.40-FF-000008', NULL, 'Probable L-asparaginase', 118, NULL, NULL, 31554),
(31555, '2.40.10.340-FF-000003', NULL, 'Cell shape-determining protein MreC', 70, NULL, NULL, 31555),
(31556, '3.40.50.800-FF-000089', NULL, 'Proline--tRNA ligase', 122, NULL, NULL, 31556),
(31557, '1.20.1560.10-FF-000042', NULL, 'Antigen peptide transporter 2', 331, NULL, NULL, 31557),
(31558, '1.20.1640.10-FF-000043', NULL, 'Protein CBR-PTC-3', 201, NULL, NULL, 31558),
(31559, '3.40.50.1000-FF-000474', NULL, 'Mannosylfructose-phosphate phosphatase', 167, NULL, NULL, 31559),
(31560, '3.40.50.2000-FF-001033', NULL, 'UDP-glucuronosyltransferase', 169, NULL, NULL, 31560),
(31561, '2.40.50.140-FF-000316', NULL, 'Transcription termination factor Rho', 118, NULL, NULL, 31561),
(31562, '3.20.20.70-FF-000056', NULL, 'hydroxyacid oxidase 2', 361, NULL, NULL, 31562),
(31563, '1.10.287.70-FF-000601', NULL, 'Predicted protein', 115, NULL, NULL, 31563),
(31564, '3.80.10.10-FF-001586', NULL, 'RNI-like superfamily protein', 77, NULL, NULL, 31564),
(31565, '3.40.50.300-FF-000501', NULL, 'DNA replication licensing factor MCM7', 341, NULL, NULL, 31565),
(31566, '2.10.220.10-FF-000145', NULL, 'Proprotein convertase subtilisin/kexin type 5', 52, NULL, NULL, 31566),
(31567, '3.10.580.10-FF-000151', NULL, 'Metal transporter cnnm-5', 210, NULL, NULL, 31567),
(31568, '3.30.1460.50-FF-000008', NULL, 'Autophagy-related 10, isoform B', 161, NULL, NULL, 31568),
(31569, '1.10.8.50-FF-000019', NULL, 'Unplaced genomic scaffold supercont1.232, whole genome shotgun sequence', 139, NULL, NULL, 31569),
(31570, '1.25.40.10-FF-001303', NULL, 'Pentatricopeptide repeat-containing protein At5g46460, mitochondrial', 103, NULL, NULL, 31570),
(31571, '2.130.10.10-FF-002816', NULL, 'Uncharacterized protein', 152, NULL, NULL, 31571),
(31572, '1.20.1740.10-FF-000140', NULL, 'Uncharacterized protein', 216, NULL, NULL, 31572),
(31573, '3.40.630.10-FF-000177', NULL, 'Aminoacylase 1', 181, NULL, NULL, 31573),
(31574, '3.40.47.10-FF-000205', NULL, NULL, 204, NULL, NULL, 31574);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(31575, '2.40.460.10-FF-000004', NULL, 'Uncharacterized protein', 62, NULL, NULL, 31575),
(31576, '3.20.20.80-FF-000738', NULL, 'Uncharacterized protein', 85, NULL, NULL, 31576),
(31577, '1.10.565.10-FF-000096', NULL, 'Uncharacterized protein', 184, NULL, NULL, 31577),
(31578, '3.30.160.60-FF-004946', NULL, NULL, 30, NULL, NULL, 31578),
(31579, '3.30.420.10-FF-000276', NULL, 'DNA polymerase I', 168, NULL, NULL, 31579),
(31580, '3.40.50.1440-FF-000050', NULL, 'Zeta tubulin, putative', 318, NULL, NULL, 31580),
(31581, '2.60.40.1180-FF-000147', NULL, 'Alpha-galactosidase', 97, NULL, NULL, 31581),
(31582, '3.30.450.40-FF-000051', NULL, 'ABC1 family protein C21C3.03', 156, NULL, NULL, 31582),
(31583, '1.10.287.130-FF-000069', NULL, 'Probable histidine kinase 1', 101, NULL, NULL, 31583),
(31584, '2.170.300.10-FF-000035', NULL, 'Uncharacterized protein', 59, NULL, NULL, 31584),
(31585, '3.30.70.1660-FF-000011', NULL, 'Peptide chain release factor 1-like, mitochondrial', 111, NULL, NULL, 31585),
(31586, '3.40.50.300-FF-000113', NULL, 'Preprotein translocase subunit SecA', 207, NULL, NULL, 31586),
(31587, '3.40.50.360-FF-000024', NULL, 'NADPH--cytochrome P450 reductase', 180, NULL, NULL, 31587),
(31588, '1.25.40.10-FF-004968', NULL, 'Uncharacterized protein', 154, NULL, NULL, 31588),
(31589, '3.30.160.60-FF-006071', NULL, NULL, 28, NULL, NULL, 31589),
(31590, '3.40.1280.10-FF-000059', NULL, 'tRNA/rRNA methyltransferase (SpoU)', 171, NULL, NULL, 31590),
(31591, '3.30.160.60-FF-003957', NULL, 'Putative zinc finger protein C09F5.3', 99, NULL, NULL, 31591),
(31592, '3.30.70.330-FF-002287', NULL, NULL, 83, NULL, NULL, 31592),
(31593, '2.130.10.10-FF-002024', NULL, 'Cilia- and flagella-associated protein 251', 278, NULL, NULL, 31593),
(31594, '3.30.830.10-FF-000150', NULL, 'Metalloenzyme, LuxS/M16 peptidase-like protein', 232, NULL, NULL, 31594),
(31595, '1.20.1070.10-FF-001191', NULL, 'Uncharacterized protein', 233, NULL, NULL, 31595),
(31596, '3.20.20.80-FF-000334', NULL, 'Amino acid Transporter GlycoProtein subunit', 268, NULL, NULL, 31596),
(31597, '3.30.870.10-FF-000096', NULL, 'Uncharacterized protein', 266, NULL, NULL, 31597),
(31598, '1.10.8.60-FF-000287', NULL, 'ATPase family associated with various cellular activities (AAA), putative', 83, NULL, NULL, 31598),
(31599, '3.40.710.10-FF-000178', NULL, 'Conserved protein', 343, NULL, NULL, 31599),
(31600, '1.20.1250.20-FF-002359', NULL, 'Predicted protein', 87, NULL, NULL, 31600),
(31601, '2.60.40.790-FF-000055', NULL, 'HSP90 associated co-chaperone', 116, NULL, NULL, 31601),
(31602, '3.40.50.720-FF-000863', NULL, '3-oxoacyl-[acyl-carrier-protein] reductase chloroplastic', 176, NULL, NULL, 31602),
(31603, '3.30.1310.10-FF-000008', NULL, 'ESX-1 secretion-associated protein EspL', 106, NULL, NULL, 31603),
(31604, '1.10.1200.120-FF-000010', NULL, 'Large-conductance mechanosensitive channel', 125, NULL, NULL, 31604),
(31605, '3.40.390.10-FF-000192', NULL, 'Metalloendopeptidase', 238, NULL, NULL, 31605),
(31606, '3.30.160.60-FF-000731', NULL, 'Zinc finger protein 292', 86, NULL, NULL, 31606),
(31607, '1.10.390.10-FF-000110', NULL, 'Uncharacterized protein', 165, NULL, NULL, 31607),
(31608, '3.60.10.10-FF-000356', NULL, 'DNA-(apurinic or apyrimidinic site) lyase', 148, NULL, NULL, 31608),
(31609, '3.40.50.300-FF-000552', NULL, 'GPN-loop GTPase 3', 262, NULL, NULL, 31609),
(31610, '3.40.50.10130-FF-000014', NULL, 'CCAAT-box DNA binding protein subunit B', 146, NULL, NULL, 31610),
(31611, '3.80.10.10-FF-002524', NULL, 'Uncharacterized protein', 244, NULL, NULL, 31611),
(31612, '2.60.40.640-FF-000038', NULL, 'Arrestin-related trafficking adapter 10', 201, NULL, NULL, 31612),
(31613, '3.80.10.10-FF-001535', NULL, 'Disease resistance protein RRS1B', 168, NULL, NULL, 31613),
(31614, '3.40.50.300-FF-007701', NULL, 'Os04g0582600 protein', 103, NULL, NULL, 31614),
(31615, '2.130.10.30-FF-000153', NULL, NULL, 173, NULL, NULL, 31615),
(31616, '1.20.1270.60-FF-000265', NULL, 'Uncharacterized protein', 138, NULL, NULL, 31616),
(31617, '1.25.10.10-FF-000054', NULL, 'General vesicular transport factor p115', 614, NULL, NULL, 31617);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(31618, '3.40.50.720-FF-001852', NULL, '6-phosphogluconate dehydrogenase, decarboxylating', 88, NULL, NULL, 31618),
(31619, '3.30.200.20-FF-001583', NULL, 'Uncharacterized protein', 79, NULL, NULL, 31619),
(31620, '1.10.8.60-FF-000236', NULL, 'ATPase, AAA family protein', 121, NULL, NULL, 31620),
(31621, '3.60.21.10-FF-000224', NULL, 'Serine/threonine-protein phosphatase', 343, NULL, NULL, 31621),
(31622, '1.10.8.60-FF-000348', NULL, 'GM25904', 97, NULL, NULL, 31622),
(31623, '3.30.420.10-FF-000629', NULL, NULL, 164, NULL, NULL, 31623),
(31624, '3.20.20.80-FF-000385', NULL, 'Uncharacterized protein', 186, NULL, NULL, 31624),
(31625, '2.60.40.1940-FF-000010', NULL, 'Complement 4B (Chido blood group)', 132, NULL, NULL, 31625),
(31626, '2.10.220.10-FF-000224', NULL, 'Predicted protein', 106, NULL, NULL, 31626),
(31627, '3.30.300.30-FF-000008', NULL, '2,3-dihydroxybenzoate-AMP ligase', 104, NULL, NULL, 31627),
(31628, '3.30.70.150-FF-000001', NULL, 'Ribulose bisphosphate carboxylase large chain', 139, NULL, NULL, 31628),
(31629, '3.40.50.720-FF-001352', NULL, 'OSJNBa0069D17.10 protein', 96, NULL, NULL, 31629),
(31630, '3.30.70.80-FF-000016', NULL, 'Uncharacterized protein', 68, NULL, NULL, 31630),
(31631, '3.30.450.40-FF-000112', NULL, 'Heat-inducible transcription repressor HrcA', 130, NULL, NULL, 31631),
(31632, '2.170.300.10-FF-000086', NULL, 'Cell death abnormality protein 1', 106, NULL, NULL, 31632),
(31633, '3.60.110.10-FF-000043', NULL, 'Glutamine-dependent NAD(+) synthetase', 275, NULL, NULL, 31633),
(31634, '3.30.160.60-FF-005582', NULL, NULL, 80, NULL, NULL, 31634),
(31635, '3.30.710.10-FF-000495', NULL, 'BTB/POZ domain-containing protein 2', 160, NULL, NULL, 31635),
(31636, '2.130.10.10-FF-005790', NULL, 'Transcription initiation factor TFIID subunit 5', 96, NULL, NULL, 31636),
(31637, '2.60.40.10-FF-002260', NULL, 'ephrin type-A receptor 6 isoform X1', 119, NULL, NULL, 31637),
(31638, '1.20.5.1200-FF-000011', NULL, 'GM13560', 29, NULL, NULL, 31638),
(31639, '2.40.50.1000-FF-000020', NULL, 'Si:dkey-159f12.2', 53, NULL, NULL, 31639),
(31640, '1.25.40.10-FF-005053', NULL, 'Tetratricopeptide repeat domain 21B', 112, NULL, NULL, 31640),
(31641, '3.10.10.10-FF-000049', NULL, NULL, 136, NULL, NULL, 31641),
(31642, '3.30.200.20-FF-000122', NULL, 'cyclin-dependent kinase 8 isoform X1', 99, NULL, NULL, 31642),
(31643, '1.10.287.110-FF-000030', NULL, 'DnaJ homolog subfamily C GRV2', 54, NULL, NULL, 31643),
(31644, '3.30.160.60-FF-002760', NULL, 'Zinc finger protein 785', 26, NULL, NULL, 31644),
(31645, '2.10.70.10-FF-000105', NULL, 'Sushi domain containing 2', 63, NULL, NULL, 31645),
(31646, '2.60.40.10-FF-001771', NULL, 'Cytokine receptor common subunit beta', 107, NULL, NULL, 31646),
(31647, '3.40.640.10-FF-000054', NULL, 'Serine--glyoxylate aminotransferase', 249, NULL, NULL, 31647),
(31648, '2.60.120.200-FF-000067', NULL, 'Thrombospondin 2', 207, NULL, NULL, 31648),
(31649, '3.30.70.260-FF-000034', NULL, 'Acetolactate synthase small subunit', 80, NULL, NULL, 31649),
(31650, '2.40.50.140-FF-000737', NULL, NULL, 44, NULL, NULL, 31650),
(31651, '1.10.20.10-FF-000200', NULL, NULL, 117, NULL, NULL, 31651),
(31652, '3.40.50.1000-FF-000878', NULL, NULL, 178, NULL, NULL, 31652),
(31653, '2.60.40.150-FF-000779', NULL, 'Uncharacterized protein', 101, NULL, NULL, 31653),
(31654, '1.10.510.10-FF-003004', NULL, NULL, 134, NULL, NULL, 31654),
(31655, '3.40.50.10420-FF-000045', NULL, 'Uncharacterized protein', 131, NULL, NULL, 31655),
(31656, '1.50.10.10-FF-000041', NULL, 'Non-lysosomal glucosylceramidase', 227, NULL, NULL, 31656),
(31657, '3.40.50.300-FF-000613', NULL, 'C-1-tetrahydrofolate synthase, cytoplasmic isoform X2', 190, NULL, NULL, 31657),
(31658, '2.10.230.10-FF-000022', NULL, 'Uncharacterized protein', 63, NULL, NULL, 31658),
(31659, '3.40.50.1000-FF-000053', NULL, 'TIGR01457 family HAD hydrolase', 96, NULL, NULL, 31659),
(31660, '2.60.40.10-FF-003620', NULL, NULL, 81, NULL, NULL, 31660),
(31661, '1.25.40.10-FF-001742', NULL, 'DNA-directed RNA polymerase', 155, NULL, NULL, 31661),
(31662, '2.30.42.10-FF-000276', NULL, 'General secretion pathway protein C', 104, NULL, NULL, 31662);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(31663, '1.10.8.1310-FF-000013', NULL, 'Gyp8p', 196, NULL, NULL, 31663),
(31664, '1.10.750.20-FF-000001', NULL, 'Ankyrin repeat and SOCS box containing 1', 37, NULL, NULL, 31664),
(31665, '3.40.1280.10-FF-000008', NULL, 'Group 3 RNA methyltransferase TrmH', 170, NULL, NULL, 31665),
(31666, '1.20.1050.10-FF-000284', NULL, 'Uncharacterized protein', 138, NULL, NULL, 31666),
(31667, '1.20.58.240-FF-000005', NULL, 'Signal transducer and activator of transcription', 109, NULL, NULL, 31667),
(31668, '3.80.10.10-FF-004520', NULL, 'Uncharacterized protein', 345, NULL, NULL, 31668),
(31669, '3.40.50.980-FF-000002', NULL, 'Enterobactin synthetase component F', 172, NULL, NULL, 31669),
(31670, '2.60.40.10-FF-005986', NULL, NULL, 128, NULL, NULL, 31670),
(31671, '3.60.20.10-FF-000233', NULL, NULL, 100, NULL, NULL, 31671),
(31672, '2.60.40.10-FF-005806', NULL, NULL, 71, NULL, NULL, 31672),
(31673, '2.40.170.20-FF-000114', NULL, 'SusC homolog', 607, NULL, NULL, 31673),
(31674, '1.10.3370.10-FF-000013', NULL, 'Protein translocase subunit SecY', 463, NULL, NULL, 31674),
(31675, '2.10.70.10-FF-000156', NULL, 'Interleukin-2 receptor subunit alpha', 43, NULL, NULL, 31675),
(31676, '3.40.50.300-FF-006392', NULL, 'Predicted protein', 135, NULL, NULL, 31676),
(31677, '3.80.10.10-FF-002075', NULL, 'Leucine-rich repeat-containing 24', 90, NULL, NULL, 31677),
(31678, '2.130.10.10-FF-003873', NULL, 'Predicted protein', 280, NULL, NULL, 31678),
(31679, '2.10.50.10-FF-000161', NULL, 'Predicted protein', 54, NULL, NULL, 31679),
(31680, '1.20.120.720-FF-000008', NULL, 'Unconventional myosin-VIIa', 145, NULL, NULL, 31680),
(31681, '1.10.8.100-FF-000028', NULL, 'rRNA adenine N(6)-methyltransferase', 64, NULL, NULL, 31681),
(31682, '2.130.10.130-FF-000042', NULL, NULL, 71, NULL, NULL, 31682),
(31683, '1.10.287.70-FF-000540', NULL, 'YALI0E03234p', 195, NULL, NULL, 31683),
(31684, '3.90.190.10-FF-000159', NULL, 'Dual specificity protein phosphatase lip-1', 151, NULL, NULL, 31684),
(31685, '3.40.50.880-FF-000186', NULL, 'Uncharacterized protein', 93, NULL, NULL, 31685),
(31686, '2.130.10.10-FF-004441', NULL, 'Uncharacterized protein', 353, NULL, NULL, 31686),
(31687, '3.40.109.10-FF-000016', NULL, 'NAD(P)H nitroreductase', 169, NULL, NULL, 31687),
(31688, '3.90.960.10-FF-000016', NULL, 'Prolyl-tRNA synthetase, putative', 148, NULL, NULL, 31688),
(31689, '1.10.8.270-FF-000101', NULL, 'Uncharacterized protein', 90, NULL, NULL, 31689),
(31690, '2.40.128.180-FF-000008', NULL, NULL, 61, NULL, NULL, 31690),
(31691, '3.30.40.10-FF-002337', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit, putative', 95, NULL, NULL, 31691),
(31692, '3.40.50.12780-FF-000022', NULL, 'Acyl-CoA synthetase', 445, NULL, NULL, 31692),
(31693, '3.30.1130.10-FF-000011', NULL, 'Dihydroneopterin aldolase domain protein', 89, NULL, NULL, 31693),
(31694, '1.25.40.1010-FF-000005', NULL, 'N-terminal acetyltransferase A complex subunit NAT1', 226, NULL, NULL, 31694),
(31695, '1.20.1070.10-FF-000167', NULL, 'probable G-protein coupled receptor 174', 306, NULL, NULL, 31695),
(31696, '1.10.10.440-FF-000049', NULL, 'TransCription Elongation Regulator homolog', 73, NULL, NULL, 31696),
(31697, '1.25.40.10-FF-004176', NULL, 'Tetratricopeptide repeat protein, putative', 91, NULL, NULL, 31697),
(31698, '1.10.472.10-FF-000677', NULL, 'Uncharacterized protein', 266, NULL, NULL, 31698),
(31699, '1.10.275.20-FF-000008', NULL, NULL, 99, NULL, NULL, 31699),
(31700, '2.70.160.11-FF-000021', NULL, 'Coactivator-associated arginine methyltransferase 1', 184, NULL, NULL, 31700),
(31701, '1.20.58.390-FF-000022', NULL, 'Nicotinic acetylcholine receptor subunit alpha4', 78, NULL, NULL, 31701),
(31702, '3.50.50.60-FF-000076', NULL, 'Sarcosine dehydrogenase, mitochondrial', 219, NULL, NULL, 31702),
(31703, '3.30.420.40-FF-000223', NULL, 'Type III pantothenate kinase', 181, NULL, NULL, 31703),
(31704, '2.60.220.50-FF-000112', NULL, 'Uncharacterized protein', 104, NULL, NULL, 31704),
(31705, '3.90.930.12-FF-000011', NULL, 'Unplaced genomic scaffold supercont1.199, whole genome shotgun sequence', 117, NULL, NULL, 31705);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(31706, '1.10.565.10-FF-000106', NULL, 'Uncharacterized protein', 115, NULL, NULL, 31706),
(31707, '2.60.40.1730-FF-000065', NULL, NULL, 204, NULL, NULL, 31707),
(31708, '3.20.20.70-FF-000117', NULL, 'molybdenum cofactor biosynthesis protein 1', 327, NULL, NULL, 31708),
(31709, '3.30.2350.20-FF-000025', NULL, 'tRNA pseudouridine synthase TruD, putative', 226, NULL, NULL, 31709),
(31710, '3.30.40.10-FF-000488', NULL, 'E3 ubiquitin-protein ligase RNF213', 101, NULL, NULL, 31710),
(31711, '3.40.50.300-FF-008106', NULL, 'Uncharacterized protein', 109, NULL, NULL, 31711),
(31712, '1.20.1250.40-FF-000016', NULL, 'Uncharacterized protein', 114, NULL, NULL, 31712),
(31713, '3.30.160.60-FF-000343', NULL, 'C2H2 transcription factor (AmdX)', 31, NULL, NULL, 31713),
(31714, '3.30.70.2520-FF-000005', NULL, 'L-gulonolactone oxidase, putative', 96, NULL, NULL, 31714),
(31715, '4.10.1000.10-FF-000152', NULL, 'Zinc finger CCCH-type-containing 10', 81, NULL, NULL, 31715),
(31716, '2.60.490.10-FF-000013', NULL, 'Uncharacterized protein', 91, NULL, NULL, 31716),
(31717, '3.30.390.10-FF-000014', NULL, 'D(-)-tartrate dehydratase', 129, NULL, NULL, 31717),
(31718, '1.25.40.20-FF-001632', NULL, 'Predicted protein', 96, NULL, NULL, 31718),
(31719, '1.20.1460.10-FF-000006', NULL, 'V-type proton ATPase subunit C', 184, NULL, NULL, 31719),
(31720, '2.60.40.1490-FF-000004', NULL, 'Anti-silencing function 1B histone chaperone', 74, NULL, NULL, 31720),
(31721, '3.30.160.60-FF-001248', NULL, 'zinc finger protein 333 isoform X2', 31, NULL, NULL, 31721),
(31722, '2.20.25.240-FF-000005', NULL, 'Uncharacterized protein, isoform A', 67, NULL, NULL, 31722),
(31723, '1.10.8.270-FF-000152', NULL, 'Uncharacterized protein', 137, NULL, NULL, 31723),
(31724, '1.10.287.110-FF-000142', NULL, 'DnaJ-like subfamily B member 13', 98, NULL, NULL, 31724),
(31725, '1.20.1070.10-FF-000908', NULL, 'Uncharacterized protein', 151, NULL, NULL, 31725),
(31726, '3.20.20.100-FF-000119', NULL, 'Uncharacterized protein', 185, NULL, NULL, 31726),
(31727, '1.20.120.1760-FF-000018', NULL, 'CDP-alcohol phosphatidyltransferase family protein', 190, NULL, NULL, 31727),
(31728, '3.90.190.10-FF-000108', NULL, 'Tyrosine-protein phosphatase', 288, NULL, NULL, 31728),
(31729, '3.30.70.2360-FF-000002', NULL, 'Endoribonuclease antitoxin GhoS', 90, NULL, NULL, 31729),
(31730, '3.40.50.300-FF-006341', NULL, 'Uncharacterized protein', 231, NULL, NULL, 31730),
(31731, '3.30.2350.20-FF-000076', NULL, NULL, 64, NULL, NULL, 31731),
(31732, '1.25.10.10-FF-001414', NULL, 'Exportin T (TRNA exportin)-like protein', 680, NULL, NULL, 31732),
(31733, '3.50.50.60-FF-000817', NULL, 'Prenylcysteine lyase, putative (AFU_orthologue AFUA_3G09330)', 158, NULL, NULL, 31733),
(31734, '1.20.1250.20-FF-000622', NULL, 'Mch2p', 188, NULL, NULL, 31734),
(31735, '3.30.160.60-FF-001299', NULL, 'CLUMA_CG020620, isoform A', 24, NULL, NULL, 31735),
(31736, '3.30.1010.10-FF-000143', NULL, 'Uncharacterized protein', 134, NULL, NULL, 31736),
(31737, '1.10.565.10-FF-000157', NULL, 'Nuclear Hormone Receptor family', 220, NULL, NULL, 31737),
(31738, '2.70.70.10-FF-000030', NULL, 'Possible peptidase', 145, NULL, NULL, 31738),
(31739, '3.40.50.1820-FF-000068', NULL, 'Lipid droplet associated hydrolase', 304, NULL, NULL, 31739),
(31740, '3.30.70.330-FF-001382', NULL, 'RNA recognition motif domain containing protein', 95, NULL, NULL, 31740),
(31741, '1.25.40.20-FF-001924', NULL, 'Multiple ankyrin repeats single kh domain protein, putative', 188, NULL, NULL, 31741),
(31742, '1.10.510.10-FF-002083', NULL, 'Mitogen-activated protein kinase 10', 146, NULL, NULL, 31742),
(31743, '1.25.10.10-FF-001982', NULL, 'Uncharacterized protein', 136, NULL, NULL, 31743),
(31744, '1.10.3450.40-FF-000011', NULL, NULL, 208, NULL, NULL, 31744),
(31745, '3.40.850.10-FF-000272', NULL, 'kinesin-like protein 2', 329, NULL, NULL, 31745),
(31746, '3.40.50.150-FF-001395', NULL, NULL, 283, NULL, NULL, 31746),
(31747, '3.40.50.1970-FF-000034', NULL, 'Phosphoribosylaminoimidazole carboxylase family protein / AIR carboxylase family protein', 86, NULL, NULL, 31747);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(31748, '3.90.132.10-FF-000020', NULL, 'Major surface protease gp63, putative', 123, NULL, NULL, 31748),
(31749, '3.10.129.10-FF-000086', NULL, 'Acyl-CoA thioester hydrolase, YbgC/YbaW family', 138, NULL, NULL, 31749),
(31750, '3.90.1480.20-FF-000021', NULL, 'Uncharacterized protein', 294, NULL, NULL, 31750),
(31751, '1.20.1250.20-FF-000010', NULL, 'Probable glucarate transporter', 204, NULL, NULL, 31751),
(31752, '2.60.40.640-FF-000089', NULL, 'Arrestin (Or S-antigen), N-terminal domain protein (AFU_orthologue AFUA_5G12530)', 211, NULL, NULL, 31752),
(31753, '2.40.100.10-FF-000130', NULL, 'Peptidyl-prolyl cis-trans isomerase', 155, NULL, NULL, 31753),
(31754, '3.20.20.140-FF-000024', NULL, 'Urease', 365, NULL, NULL, 31754),
(31755, '1.10.418.60-FF-000005', NULL, 'Kinetochore protein NUF2', 176, NULL, NULL, 31755),
(31756, '3.40.50.1100-FF-000178', NULL, 'Threonine dehydratase, putative', 200, NULL, NULL, 31756),
(31757, '2.130.10.10-FF-001395', NULL, 'Damaged DNA binding protein', 281, NULL, NULL, 31757),
(31758, '4.10.60.10-FF-000134', NULL, 'Cellular nucleic acid-binding protein', 21, NULL, NULL, 31758),
(31759, '3.30.310.10-FF-000026', NULL, 'AP complex subunit beta', 116, NULL, NULL, 31759),
(31760, '3.90.660.10-FF-000100', NULL, NULL, 79, NULL, NULL, 31760),
(31761, '3.30.559.10-FF-000041', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 285, NULL, NULL, 31761),
(31762, '3.20.180.20-FF-000003', NULL, 'Dynein heavy chain 12, axonemal', 97, NULL, NULL, 31762),
(31763, '3.30.450.20-FF-000286', NULL, 'Methyl-accepting chemotaxis protein', 108, NULL, NULL, 31763),
(31764, '1.20.1440.200-FF-000005', NULL, 'Vacuolar protein sorting-associated protein 28 homolog', 93, NULL, NULL, 31764),
(31765, '3.30.70.330-FF-001770', NULL, NULL, 164, NULL, NULL, 31765),
(31766, '1.10.10.850-FF-000003', NULL, NULL, 59, NULL, NULL, 31766),
(31767, '3.30.40.10-FF-001056', NULL, 'E3 ubiquitin-protein ligase ATL23', 82, NULL, NULL, 31767),
(31768, '3.30.930.10-FF-000146', NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', 339, NULL, NULL, 31768),
(31769, '2.60.40.3500-FF-000012', NULL, NULL, 117, NULL, NULL, 31769),
(31770, '1.10.730.10-FF-000210', NULL, 'Valine--tRNA ligase', 191, NULL, NULL, 31770),
(31771, '3.30.519.10-FF-000027', NULL, NULL, 180, NULL, NULL, 31771),
(31772, '2.30.42.10-FF-000388', NULL, NULL, 72, NULL, NULL, 31772),
(31773, '3.40.1190.20-FF-000122', NULL, 'Adenosine kinase', 275, NULL, NULL, 31773),
(31774, '1.10.510.10-FF-003425', NULL, NULL, 289, NULL, NULL, 31774),
(31775, '3.40.50.10490-FF-000138', NULL, NULL, 144, NULL, NULL, 31775),
(31776, '2.60.450.10-FF-000016', NULL, 'Lipopolysaccharide export system protein LptA', 133, NULL, NULL, 31776),
(31777, '2.70.98.30-FF-000032', NULL, 'Uncharacterized protein', 48, NULL, NULL, 31777),
(31778, '1.20.1050.10-FF-000172', NULL, 'Glutathione S-transferase', 134, NULL, NULL, 31778),
(31779, '3.30.200.20-FF-000526', NULL, 'Kinase family protein', 96, NULL, NULL, 31779),
(31780, '3.30.230.10-FF-000025', NULL, '30S ribosomal protein S9', 129, NULL, NULL, 31780),
(31781, '1.20.1070.10-FF-001595', NULL, 'Uncharacterized protein', 153, NULL, NULL, 31781),
(31782, '1.10.10.10-FF-000374', NULL, 'Two-component transcriptional regulator, winged helix family', 109, NULL, NULL, 31782),
(31783, '1.20.1310.20-FF-000009', NULL, 'Antigen 332, DBL-like protein', 154, NULL, NULL, 31783),
(31784, '3.40.50.360-FF-000092', NULL, 'S-adenosyl-L-methionine-dependent tRNA 4-demethylwyosine synthase', 188, NULL, NULL, 31784),
(31785, '3.40.50.300-FF-003778', NULL, 'Dynein, axonemal, heavy chain 11', 92, NULL, NULL, 31785),
(31786, '2.60.120.430-FF-000018', NULL, 'Putative esterase (Lipoprotein)', 161, NULL, NULL, 31786),
(31787, '1.25.40.120-FF-000096', NULL, 'Uncharacterized protein', 154, NULL, NULL, 31787),
(31788, '3.30.450.60-FF-000039', NULL, 'Signal recognition particle receptor like protein, putative', 137, NULL, NULL, 31788),
(31789, '3.90.180.10-FF-000170', NULL, 'Uncharacterized protein', 55, NULL, NULL, 31789);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(31790, '3.80.10.10-FF-002816', NULL, 'Uncharacterized protein', 285, NULL, NULL, 31790),
(31791, '1.10.287.70-FF-000489', NULL, 'Uncharacterized protein', 147, NULL, NULL, 31791),
(31792, '2.60.200.20-FF-000006', NULL, 'Afadin, adherens junction formation factor', 131, NULL, NULL, 31792),
(31793, '3.20.20.140-FF-000075', NULL, 'Phosphonate metabolism protein PhnM', 268, NULL, NULL, 31793),
(31794, '1.10.150.50-FF-000020', NULL, 'Tumor protein 63 (p63)', 69, NULL, NULL, 31794),
(31795, '1.10.630.10-FF-000517', NULL, 'Uncharacterized protein', 412, NULL, NULL, 31795),
(31796, '3.40.50.300-FF-002007', NULL, 'ABC transporter ATP-binding protein', 216, NULL, NULL, 31796),
(31797, '2.30.170.20-FF-000010', NULL, 'LSU ribosomal protein L24E', 62, NULL, NULL, 31797),
(31798, '2.60.40.10-FF-000343', NULL, 'inactive tyrosine-protein kinase 7', 96, NULL, NULL, 31798),
(31799, '3.90.1410.10-FF-000070', NULL, 'YALI0F30327p', 251, NULL, NULL, 31799),
(31800, '3.80.10.10-FF-004380', NULL, 'Toll-like protein', 365, NULL, NULL, 31800),
(31801, '1.10.472.10-FF-000065', NULL, 'G1/S-specific cyclin Cln1', 121, NULL, NULL, 31801),
(31802, '1.10.10.60-FF-001092', NULL, NULL, 72, NULL, NULL, 31802),
(31803, '2.60.40.10-FF-005065', NULL, NULL, 101, NULL, NULL, 31803),
(31804, '3.40.50.10810-FF-000004', NULL, 'probable global transcription activator SNF2L2 isoform X1', 219, NULL, NULL, 31804),
(31805, '1.20.140.40-FF-000020', NULL, 'Pectinesterase', 141, NULL, NULL, 31805),
(31806, '3.10.580.10-FF-000090', NULL, 'Magnesium transporter MgtE', 126, NULL, NULL, 31806),
(31807, '3.40.250.10-FF-000243', NULL, 'Uncharacterized protein', 147, NULL, NULL, 31807),
(31808, '1.25.40.20-FF-001020', NULL, 'Kinase, NEK', 102, NULL, NULL, 31808),
(31809, '2.60.40.420-FF-000023', NULL, 'Monocopper oxidase-like protein SKU5', 125, NULL, NULL, 31809),
(31810, '3.30.70.1230-FF-000282', NULL, 'Uncharacterized protein', 40, NULL, NULL, 31810),
(31811, '3.40.50.300-FF-004267', NULL, 'Os02g0497500 protein', 198, NULL, NULL, 31811),
(31812, '3.20.20.70-FF-000505', NULL, NULL, 235, NULL, NULL, 31812),
(31813, '3.30.70.260-FF-000113', NULL, '(P)ppGpp synthetase', 80, NULL, NULL, 31813),
(31814, '3.90.70.130-FF-000004', NULL, 'Ufm1-specific protease 1', 211, NULL, NULL, 31814),
(31815, '1.10.490.160-FF-000014', NULL, NULL, 55, NULL, NULL, 31815),
(31816, '1.10.150.50-FF-000200', NULL, 'Uncharacterized protein', 69, NULL, NULL, 31816),
(31817, '2.40.33.10-FF-000041', NULL, 'Uncharacterized protein', 52, NULL, NULL, 31817),
(31818, '3.40.50.300-FF-007089', NULL, 'Uncharacterized protein', 190, NULL, NULL, 31818),
(31819, '1.10.530.10-FF-000072', NULL, 'Endochitinase EP3', 75, NULL, NULL, 31819),
(31820, '3.40.50.1820-FF-001580', NULL, 'Uncharacterized protein', 100, NULL, NULL, 31820),
(31821, '1.25.40.410-FF-000008', NULL, 'Tb-292 membrane associated protein', 169, NULL, NULL, 31821),
(31822, '3.90.550.10-FF-000322', NULL, 'Alpha-1,6-mannosyl-glycoprotein beta-1,2-N-acetylglucosaminyltransferase', 198, NULL, NULL, 31822),
(31823, '1.10.287.130-FF-000148', NULL, 'Two-component sensor EnvZ', 64, NULL, NULL, 31823),
(31824, '3.80.10.10-FF-000630', NULL, 'Unplaced genomic scaffold supercont2.23, whole genome shotgun sequence', 249, NULL, NULL, 31824),
(31825, '3.30.450.370-FF-000001', NULL, 'Secretion system protein E', 129, NULL, NULL, 31825),
(31826, '3.30.870.10-FF-000028', NULL, 'Tyrosyl-DNA phosphodiesterase 1', 198, NULL, NULL, 31826),
(31827, '4.10.470.20-FF-000001', NULL, 'N-acetylglucosamine-1-phosphotransferase subunits alpha/beta', 61, NULL, NULL, 31827),
(31828, '3.80.10.10-FF-002867', NULL, 'Uncharacterized protein', 91, NULL, NULL, 31828),
(31829, '1.20.1250.20-FF-000914', NULL, 'Myo-inositol/proton symporter (MIT)', 445, NULL, NULL, 31829),
(31830, '3.30.70.590-FF-000009', NULL, 'Poly(A) polymerase, putative', 186, NULL, NULL, 31830),
(31831, '1.20.1070.10-FF-001544', NULL, 'Adrenergic receptor alpha 2a', 177, NULL, NULL, 31831),
(31832, '1.10.3290.10-FF-000012', NULL, 'Cell filamentation protein Fic', 196, NULL, NULL, 31832),
(31833, '1.10.30.10-FF-000044', NULL, 'High mobility group B1', 88, NULL, NULL, 31833);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(31834, '3.40.30.10-FF-000280', NULL, 'Grx4 family monothiol glutaredoxin', 94, NULL, NULL, 31834),
(31835, '1.25.40.10-FF-004917', NULL, 'Uncharacterized protein', 70, NULL, NULL, 31835),
(31836, '2.60.40.2130-FF-000005', NULL, 'Spondin-1', 197, NULL, NULL, 31836),
(31837, '2.130.10.10-FF-000107', NULL, 'Vacuolar protein sorting-associated protein 41 homolog', 257, NULL, NULL, 31837),
(31838, '1.10.150.910-FF-000006', NULL, 'UV-damaged DNA binding protein, putative', 87, NULL, NULL, 31838),
(31839, '2.130.10.10-FF-005722', NULL, 'TBC1 domain family member 31-like Protein', 138, NULL, NULL, 31839),
(31840, '3.10.20.30-FF-000033', NULL, 'Phenol hydroxylase component', 97, NULL, NULL, 31840),
(31841, '1.10.510.10-FF-002987', NULL, 'AGC family protein kinase', 277, NULL, NULL, 31841),
(31842, '1.10.287.2720-FF-000010', NULL, 'Predicted protein', 64, NULL, NULL, 31842),
(31843, '2.170.270.10-FF-000212', NULL, 'Uncharacterized protein', 145, NULL, NULL, 31843),
(31844, '2.30.42.10-FF-000208', NULL, 'tax1-binding protein 3 isoform X2', 45, NULL, NULL, 31844),
(31845, '1.20.1070.10-FF-002084', NULL, 'Uncharacterized protein', 298, NULL, NULL, 31845),
(31846, '3.30.160.60-FF-005014', NULL, NULL, 32, NULL, NULL, 31846),
(31847, '2.10.220.10-FF-000196', NULL, 'Proprotein convertase subtilisin/kexin type 5', 62, NULL, NULL, 31847),
(31848, '3.20.20.70-FF-000556', NULL, 'Glutamate synthase, iron-sulfur cluster-binding subunit, putative', 368, NULL, NULL, 31848),
(31849, '3.30.40.10-FF-001848', NULL, 'Uncharacterized protein', 82, NULL, NULL, 31849),
(31850, '2.130.10.10-FF-002412', NULL, 'Uncharacterized protein', 124, NULL, NULL, 31850),
(31851, '1.10.530.10-FF-000021', NULL, 'Chitinase', 165, NULL, NULL, 31851),
(31852, '3.90.920.10-FF-000019', NULL, 'DNA primase small subunit putative', 189, NULL, NULL, 31852),
(31853, '1.20.58.530-FF-000019', NULL, 'Myosin-A', 184, NULL, NULL, 31853),
(31854, '3.40.50.720-FF-002420', NULL, 'Uncharacterized protein', 183, NULL, NULL, 31854),
(31855, '1.10.10.10-FF-001734', NULL, 'Winged-helix phosphate transcriptional response regulator', 97, NULL, NULL, 31855),
(31856, '3.20.20.10-FF-000066', NULL, 'Ornithine decarboxylase', 158, NULL, NULL, 31856),
(31857, '1.20.1050.80-FF-000001', NULL, 'GTPase-activating protein and VPS9 domain-containing protein 1 isoform X1', 144, NULL, NULL, 31857),
(31858, '1.20.58.60-FF-000341', NULL, 'Trio, isoform A', 145, NULL, NULL, 31858),
(31859, '1.10.1200.10-FF-000068', NULL, 'Acyl carrier protein', 82, NULL, NULL, 31859),
(31860, '2.30.42.10-FF-000568', NULL, NULL, 95, NULL, NULL, 31860),
(31861, '3.40.50.300-FF-000905', NULL, 'Heme ABC transporter ATP-binding protein', 229, NULL, NULL, 31861),
(31862, '3.40.50.300-FF-004216', NULL, 'Dynein heavy chain 6, axonemal', 45, NULL, NULL, 31862),
(31863, '3.30.497.10-FF-000020', NULL, 'Angiotensinogen preproprotein', 220, NULL, NULL, 31863),
(31864, '3.50.50.60-FF-000637', NULL, 'Oxidoreductase, FAD dependent', 153, NULL, NULL, 31864),
(31865, '1.20.1250.20-FF-002067', NULL, 'Uncharacterized protein', 284, NULL, NULL, 31865),
(31866, '2.60.40.10-FF-001703', NULL, 'Zinc-alpha-2-glycoprotein', 90, NULL, NULL, 31866),
(31867, '2.60.40.10-FF-005014', NULL, NULL, 105, NULL, NULL, 31867),
(31868, '3.90.1310.10-FF-000034', NULL, 'Cell division protein FtsI [Peptidoglycan synthetase]', 165, NULL, NULL, 31868),
(31869, '3.40.50.300-FF-004003', NULL, 'GD15502', 241, NULL, NULL, 31869),
(31870, '2.60.120.330-FF-000106', NULL, 'Fe/2-OG dependent oxidoreductase', 337, NULL, NULL, 31870),
(31871, '2.70.160.11-FF-000072', NULL, 'Shk1 kinase-binding protein (Skb1), putative', 172, NULL, NULL, 31871),
(31872, '2.140.10.30-FF-000012', NULL, 'Dipeptidyl-peptidase 8-like serine peptidase', 519, NULL, NULL, 31872),
(31873, '3.30.160.60-FF-002529', NULL, 'B-cell CLL/lymphoma 6 member B protein', 27, NULL, NULL, 31873),
(31874, '3.50.50.60-FF-000025', NULL, 'Dihydrolipoyl dehydrogenase', 125, NULL, NULL, 31874),
(31875, '3.80.10.10-FF-002603', NULL, 'Leucine rich repeats and calponin homology domain containing 4', 66, NULL, NULL, 31875);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(31876, '1.25.10.10-FF-000958', NULL, 'AP-3 complex subunit delta, putative', 154, NULL, NULL, 31876),
(31877, '3.40.50.720-FF-001060', NULL, 'Potassium transporter peripheral membrane component', 139, NULL, NULL, 31877),
(31878, '1.25.10.10-FF-000133', NULL, 'DnaJ heat shock protein family (Hsp40) member C13', 190, NULL, NULL, 31878),
(31879, '3.40.50.300-FF-003727', NULL, 'ATP-dependent helicase hrpA', 179, NULL, NULL, 31879),
(31880, '2.40.160.10-FF-000010', NULL, 'Mitochondrial import receptor subunit TOM40-1', 284, NULL, NULL, 31880),
(31881, '1.10.510.10-FF-002936', NULL, NULL, 228, NULL, NULL, 31881),
(31882, '1.20.58.1080-FF-000019', NULL, 'Uncharacterized protein', 67, NULL, NULL, 31882),
(31883, '3.40.50.300-FF-008218', NULL, 'Uncharacterized protein', 65, NULL, NULL, 31883),
(31884, '3.90.1150.10-FF-000263', NULL, 'PLP-dependent transferase', 172, NULL, NULL, 31884),
(31885, '3.50.50.100-FF-000040', NULL, 'Uncharacterized protein', 395, NULL, NULL, 31885),
(31886, '2.20.28.200-FF-000012', NULL, 'Uncharacterized protein', 40, NULL, NULL, 31886),
(31887, '2.30.30.100-FF-000084', NULL, 'U6 snRNA-associated Sm-like protein LSm8', 90, NULL, NULL, 31887),
(31888, '3.40.50.720-FF-002369', NULL, 'Uncharacterized protein', 35, NULL, NULL, 31888),
(31889, '2.40.50.140-FF-000024', NULL, 'Lysine--tRNA ligase', 142, NULL, NULL, 31889),
(31890, '3.40.50.720-FF-001291', NULL, 'Short-chain alcohol dehydrogenase', 253, NULL, NULL, 31890),
(31891, '1.25.10.10-FF-003331', NULL, 'Dynein axonemal assembly factor 5', 283, NULL, NULL, 31891),
(31892, '1.10.1060.10-FF-000028', NULL, 'CoB--CoM heterodisulfide reductase 2 iron-sulfur subunit D', 105, NULL, NULL, 31892),
(31893, '1.10.510.10-FF-000750', NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', 316, NULL, NULL, 31893),
(31894, '2.60.40.10-FF-001411', NULL, 'Protein tyrosine phosphatase, receptor type B', 89, NULL, NULL, 31894),
(31895, '2.60.40.1390-FF-000013', NULL, 'Uncharacterized protein', 109, NULL, NULL, 31895),
(31896, '3.30.40.10-FF-002225', NULL, 'Uncharacterized protein', 123, NULL, NULL, 31896),
(31897, '1.10.375.10-FF-000002', NULL, 'Uncharacterized protein', 115, NULL, NULL, 31897),
(31898, '3.90.226.10-FF-000288', NULL, 'ATP-dependent Clp protease proteolytic subunit', 194, NULL, NULL, 31898),
(31899, '3.30.2450.30-FF-000007', NULL, 'Uncharacterized protein', 39, NULL, NULL, 31899),
(31900, '2.10.90.10-FF-000039', NULL, 'growth/differentiation factor 15', 110, NULL, NULL, 31900),
(31901, '3.40.120.10-FF-000026', NULL, 'GlcNAc phosphomutase', 110, NULL, NULL, 31901),
(31902, '3.30.160.60-FF-000282', NULL, 'Zinc finger, matrin-type 2', 44, NULL, NULL, 31902),
(31903, '3.90.20.20-FF-000032', NULL, 'GrpE protein homolog', 115, NULL, NULL, 31903),
(31904, '2.160.10.10-FF-000067', NULL, 'Transferase hexapeptide repeat protein', 132, NULL, NULL, 31904),
(31905, '2.60.40.10-FF-003541', NULL, NULL, 105, NULL, NULL, 31905),
(31906, '2.60.40.150-FF-000330', NULL, 'uncharacterized protein LOC108095502 isoform X2', 146, NULL, NULL, 31906),
(31907, '3.20.20.70-FF-000348', NULL, 'Possible methyltransferase (Methylase)', 217, NULL, NULL, 31907),
(31908, '3.40.50.150-FF-000759', NULL, 'Methylase', 185, NULL, NULL, 31908),
(31909, '1.10.418.20-FF-000021', NULL, 'Uncharacterized protein', 48, NULL, NULL, 31909),
(31910, '1.25.40.820-FF-000013', NULL, 'Uncharacterized protein', 180, NULL, NULL, 31910),
(31911, '3.40.50.410-FF-000354', NULL, 'Uncharacterized protein', 83, NULL, NULL, 31911),
(31912, '3.30.930.10-FF-000207', NULL, 'Histidine--tRNA ligase', 380, NULL, NULL, 31912),
(31913, '2.130.10.10-FF-001956', NULL, 'WD-40 repeat protein family', 310, NULL, NULL, 31913),
(31914, '3.80.10.10-FF-001878', NULL, 'Tubulin-specific chaperone, putative (AFU_orthologue AFUA_4G11870)', 76, NULL, NULL, 31914),
(31915, '2.80.10.50-FF-000217', NULL, 'Fibroblast growth factor', 34, NULL, NULL, 31915),
(31916, '3.40.1190.10-FF-000001', NULL, 'UDP-N-acetylmuramate--L-alanine ligase', 217, NULL, NULL, 31916),
(31917, '3.90.45.10-FF-000013', NULL, 'Peptide deformylase', 164, NULL, NULL, 31917);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(31918, '1.10.555.10-FF-000252', NULL, NULL, 127, NULL, NULL, 31918),
(31919, '3.40.50.1000-FF-000502', NULL, NULL, 44, NULL, NULL, 31919),
(31920, '6.10.140.2220-FF-000028', NULL, 'MYND zinc finger (ZnF) domain-like protein', 55, NULL, NULL, 31920),
(31921, '1.25.40.10-FF-003900', NULL, 'Uncharacterized protein', 69, NULL, NULL, 31921),
(31922, '1.20.58.390-FF-000090', NULL, 'Ligand-Gated ion Channel', 118, NULL, NULL, 31922),
(31923, '1.20.58.900-FF-000035', NULL, 'Uncharacterized protein', 174, NULL, NULL, 31923),
(31924, '1.10.510.10-FF-004061', NULL, NULL, 211, NULL, NULL, 31924),
(31925, '1.20.58.80-FF-000004', NULL, 'Vacuolar protein sorting-associated protein 4', 73, NULL, NULL, 31925),
(31926, '3.30.470.20-FF-000169', NULL, 'Predicted protein', 170, NULL, NULL, 31926),
(31927, '1.20.1070.10-FF-001252', NULL, 'Uncharacterized protein', 96, NULL, NULL, 31927),
(31928, '3.90.70.10-FF-000706', NULL, 'Uncharacterized protein', 210, NULL, NULL, 31928),
(31929, '1.20.58.2190-FF-000015', NULL, 'Uncharacterized protein', 86, NULL, NULL, 31929),
(31930, '2.60.40.60-FF-000217', NULL, 'Cadherin 5', 101, NULL, NULL, 31930),
(31931, '3.20.20.140-FF-000103', NULL, 'Histidinol-phosphatase', 262, NULL, NULL, 31931),
(31932, '2.40.128.20-FF-000011', NULL, 'Apolipoprotein M', 169, NULL, NULL, 31932),
(31933, '3.30.160.60-FF-004497', NULL, NULL, 28, NULL, NULL, 31933),
(31934, '3.40.50.1820-FF-000568', NULL, 'Carboxylic ester hydrolase', 513, NULL, NULL, 31934),
(31935, '1.20.1300.20-FF-000003', NULL, 'Ubiquitin thiolesterase (OtuB1), putative', 154, NULL, NULL, 31935),
(31936, '3.10.350.10-FF-000050', NULL, 'Motility protein FimV', 76, NULL, NULL, 31936),
(31937, '3.30.70.2280-FF-000012', NULL, 'Uncharacterized protein', 44, NULL, NULL, 31937),
(31938, '3.90.640.10-FF-000149', NULL, 'Actin-like protein, putative', 88, NULL, NULL, 31938),
(31939, '2.30.40.10-FF-000086', NULL, 'Adenosine deaminase', 84, NULL, NULL, 31939),
(31940, '3.30.70.580-FF-000012', NULL, 'tRNA pseudouridine synthase', 131, NULL, NULL, 31940),
(31941, '3.40.50.300-FF-003811', NULL, 'Splicing endonuclease positive effector sen1, putative', 375, NULL, NULL, 31941),
(31942, '1.20.120.1750-FF-000133', NULL, 'RBR-type E3 ubiquitin transferase', 78, NULL, NULL, 31942),
(31943, '1.25.40.10-FF-000174', NULL, '26S proteasome non-ATPase regulatory subunit 3', 185, NULL, NULL, 31943),
(31944, '1.20.5.4770-FF-000020', NULL, 'Zinc finger A20 and AN1 domain-containing stress-associated protein 10', 57, NULL, NULL, 31944),
(31945, '1.20.5.110-FF-000164', NULL, 'Syntaxin-72, putative', 104, NULL, NULL, 31945),
(31946, '3.30.420.10-FF-000568', NULL, NULL, 35, NULL, NULL, 31946),
(31947, '1.25.40.710-FF-000008', NULL, 'Uncharacterized protein', 247, NULL, NULL, 31947),
(31948, '1.10.472.10-FF-000705', NULL, 'WNK lysine deficient protein kinase 4', 92, NULL, NULL, 31948),
(31949, '3.30.890.10-FF-000030', NULL, 'Methyl-CpG-binding domain-containing protein 7', 102, NULL, NULL, 31949),
(31950, '3.30.70.2820-FF-000005', NULL, 'DNA polymerase', 98, NULL, NULL, 31950),
(31951, '2.60.40.10-FF-000686', NULL, 'Cytotoxic T-lymphocyte protein 4', 128, NULL, NULL, 31951),
(31952, '3.40.50.10480-FF-000017', NULL, 'Uncharacterized protein', 127, NULL, NULL, 31952),
(31953, '2.10.70.10-FF-000095', NULL, 'Zona pellucida sperm-binding protein 3 receptor', 66, NULL, NULL, 31953),
(31954, '1.25.10.10-FF-001190', NULL, 'Condensin-2 complex subunit D3', 374, NULL, NULL, 31954),
(31955, '1.20.1250.20-FF-000802', NULL, 'Putative permease of the major facilitator superfamily, AmpG-like protein', 188, NULL, NULL, 31955),
(31956, '3.90.180.10-FF-000069', NULL, 'Putative NADP-dependent alcohol dehydrogenase', 48, NULL, NULL, 31956),
(31957, '2.130.10.10-FF-005610', NULL, 'Transducin family protein / WD-40 repeat family protein', 188, NULL, NULL, 31957),
(31958, '1.25.40.180-FF-000332', NULL, NULL, 190, NULL, NULL, 31958),
(31959, '1.20.58.100-FF-000008', NULL, 'Succinate dehydrogenase flavoprotein subunit', 114, NULL, NULL, 31959),
(31960, '1.20.120.1150-FF-000009', NULL, 'Serine/threonine-protein phosphatase 2A activator', 111, NULL, NULL, 31960);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(31961, '2.60.40.10-FF-000422', NULL, 'Mast/stem cell growth factor receptor', 108, NULL, NULL, 31961),
(31962, '1.10.510.10-FF-002779', NULL, 'Uncharacterized protein', 360, NULL, NULL, 31962),
(31963, '3.30.1370.230-FF-000001', NULL, 'Stn1p', 96, NULL, NULL, 31963),
(31964, '1.10.1450.10-FF-000047', NULL, 'Tetraspanin 66A, isoform E', 72, NULL, NULL, 31964),
(31965, '2.60.120.330-FF-000157', NULL, 'Uncharacterized protein', 201, NULL, NULL, 31965),
(31966, '3.40.50.1860-FF-000001', NULL, 'Glutamate racemase', 113, NULL, NULL, 31966),
(31967, '3.90.550.10-FF-000614', NULL, 'Glycosyltransferase, putative', 214, NULL, NULL, 31967),
(31968, '3.40.50.300-FF-001670', NULL, 'Dynamin family protein', 235, NULL, NULL, 31968),
(31969, '3.40.50.1000-FF-000766', NULL, NULL, 125, NULL, NULL, 31969),
(31970, '3.40.50.300-FF-008550', NULL, 'Uncharacterized protein', 89, NULL, NULL, 31970),
(31971, '3.30.1330.10-FF-000010', NULL, 'Phosphoribosylformylglycinamidine synthase', 207, NULL, NULL, 31971),
(31972, '1.20.1260.10-FF-000007', NULL, 'DNA protection during starvation protein 2', 145, NULL, NULL, 31972),
(31973, '1.10.455.10-FF-000003', NULL, '40S ribosomal protein S5', 202, NULL, NULL, 31973),
(31974, '3.30.450.20-FF-000218', NULL, 'Sensor kinase citA', 133, NULL, NULL, 31974),
(31975, '1.10.238.10-FF-000881', NULL, 'Zinc finger, C3HC4 type (RING finger)/EF-hand domain pair, putative', 72, NULL, NULL, 31975),
(31976, '1.10.555.10-FF-000100', NULL, 'Inositol polyphosphate 5-phosphatase, putative', 142, NULL, NULL, 31976),
(31977, '3.30.1370.10-FF-000113', NULL, 'P-element somatic inhibitor, isoform A', 82, NULL, NULL, 31977),
(31978, '3.90.1740.10-FF-000004', NULL, '2'',3''-cyclic nucleotide 3'' phosphodiesterase', 221, NULL, NULL, 31978),
(31979, '1.20.5.20-FF-000004', NULL, 'Apolipoprotein A-IV b, tandem duplicate 1', 35, NULL, NULL, 31979),
(31980, '1.25.40.10-FF-002208', NULL, 'Putative signal recognition particle protein', 163, NULL, NULL, 31980),
(31981, '2.130.10.10-FF-005222', NULL, 'Uncharacterized protein', 74, NULL, NULL, 31981),
(31982, '2.120.10.30-FF-000586', NULL, 'Uncharacterized protein', 133, NULL, NULL, 31982),
(31983, '3.10.20.230-FF-000003', NULL, 'Neuronal migration protein doublecortin', 91, NULL, NULL, 31983),
(31984, '3.30.110.30-FF-000005', NULL, 'Proline--tRNA ligase', 74, NULL, NULL, 31984),
(31985, '2.130.10.10-FF-003081', NULL, 'DNA damage-binding protein CMR1', 103, NULL, NULL, 31985),
(31986, '1.20.1270.340-FF-000002', NULL, NULL, 100, NULL, NULL, 31986),
(31987, '2.170.120.12-FF-000035', NULL, 'Uncharacterized protein', 13, NULL, NULL, 31987),
(31988, '1.20.1420.10-FF-000009', NULL, 'Talin rod domain containing 1', 146, NULL, NULL, 31988),
(31989, '2.60.120.260-FF-000057', NULL, 'Reelin', 158, NULL, NULL, 31989),
(31990, '2.60.40.10-FF-004637', NULL, NULL, 97, NULL, NULL, 31990),
(31991, '3.40.50.150-FF-001327', NULL, NULL, 202, NULL, NULL, 31991),
(31992, '3.20.20.140-FF-000255', NULL, 'Uncharacterized protein', 233, NULL, NULL, 31992),
(31993, '3.20.20.80-FF-000834', NULL, 'Uncharacterized protein', 44, NULL, NULL, 31993),
(31994, '1.25.40.860-FF-000025', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 74, NULL, NULL, 31994),
(31995, '3.40.50.2000-FF-000757', NULL, 'PslF', 185, NULL, NULL, 31995),
(31996, '1.25.40.20-FF-001071', NULL, 'Si:ch73-193i2.2', 124, NULL, NULL, 31996),
(31997, '1.20.1060.10-FF-000026', NULL, 'Uncharacterized protein', 119, NULL, NULL, 31997),
(31998, '1.10.238.10-FF-000145', NULL, 'Phosphoinositide phospholipase C', 50, NULL, NULL, 31998),
(31999, '2.60.120.260-FF-000321', NULL, 'Bgal-1', 74, NULL, NULL, 31999),
(32000, '2.60.40.10-FF-003209', NULL, 'MSP_(Major_sperm_protein )_domain_containing_protein_-_putative', 170, NULL, NULL, 32000),
(32001, '3.40.50.300-FF-000001', NULL, 'ATP-dependent zinc metalloprotease FtsH', 183, NULL, NULL, 32001),
(32002, '1.10.1370.10-FF-000046', NULL, 'Uncharacterized protein', 119, NULL, NULL, 32002),
(32003, '3.90.76.10-FF-000040', NULL, 'ABC transporter substrate-binding protein', 142, NULL, NULL, 32003);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(32004, '3.40.50.300-FF-006184', NULL, 'Uncharacterized protein', 177, NULL, NULL, 32004),
(32005, '2.10.109.10-FF-000038', NULL, 'Inner Mitochondrial Membrane Protease', 129, NULL, NULL, 32005),
(32006, '3.40.190.10-FF-000917', NULL, 'Gll0431 protein', 88, NULL, NULL, 32006),
(32007, '2.60.40.10-FF-003277', NULL, 'Limbic system-associated membrane protein', 101, NULL, NULL, 32007),
(32008, '3.40.50.10310-FF-000012', NULL, '2-amino-5-formylamino-6-ribosylaminopyrimidin-4(3H)-one 5''-monophosphate deformylase', 216, NULL, NULL, 32008),
(32009, '1.20.1720.10-FF-000105', NULL, NULL, 106, NULL, NULL, 32009),
(32010, '3.20.20.80-FF-000446', NULL, 'Beta-galactosidase 5', 178, NULL, NULL, 32010),
(32011, '2.10.25.10-FF-001698', NULL, 'Uncharacterized protein', 42, NULL, NULL, 32011),
(32012, '3.40.50.300-FF-006420', NULL, 'Uncharacterized protein', 129, NULL, NULL, 32012),
(32013, '1.20.1250.20-FF-002247', NULL, 'Solute carrier family 43 member 1a', 111, NULL, NULL, 32013),
(32014, '3.40.50.2300-FF-000965', NULL, NULL, 135, NULL, NULL, 32014),
(32015, '2.60.60.20-FF-000055', NULL, NULL, 60, NULL, NULL, 32015),
(32016, '1.10.10.10-FF-000666', NULL, 'MarR family protein', 144, NULL, NULL, 32016),
(32017, '2.40.37.10-FF-000038', NULL, 'Uncharacterized protein', 138, NULL, NULL, 32017),
(32018, '3.40.50.1820-FF-001872', NULL, 'OpdE downstream ORF 2, putative', 82, NULL, NULL, 32018),
(32019, '3.40.50.410-FF-000034', NULL, 'calcium-activated chloride channel regulator 1', 173, NULL, NULL, 32019),
(32020, '3.50.50.60-FF-001306', NULL, 'Uncharacterized protein', 111, NULL, NULL, 32020),
(32021, '1.10.1320.10-FF-000015', NULL, 'DNA-dependent RNA polymerase', 341, NULL, NULL, 32021),
(32022, '3.30.70.1180-FF-000013', NULL, 'V-type proton ATPase subunit C', 36, NULL, NULL, 32022),
(32023, '3.30.160.60-FF-001748', NULL, 'General transcription factor IIIA', 22, NULL, NULL, 32023),
(32024, '3.30.40.10-FF-001505', NULL, 'Putative e3 ubiquitin-protein ligase msl2 isoform x3', 113, NULL, NULL, 32024),
(32025, '3.90.830.10-FF-000012', NULL, 'Vacuolar protein sorting 33', 105, NULL, NULL, 32025),
(32026, '1.10.3470.10-FF-000026', NULL, 'ABC-type Fe3+-siderophore transport system, permease component', 323, NULL, NULL, 32026),
(32027, '3.30.200.20-FF-001807', NULL, 'Tyrosine-protein kinase RYK', 128, NULL, NULL, 32027),
(32028, '1.10.1670.10-FF-000058', NULL, NULL, 42, NULL, NULL, 32028),
(32029, '1.10.287.70-FF-000568', NULL, 'Predicted protein', 132, NULL, NULL, 32029),
(32030, '3.40.50.12780-FF-000230', NULL, 'Uncharacterized protein', 199, NULL, NULL, 32030),
(32031, '3.40.50.1910-FF-000027', NULL, 'Vacuolar protein sorting-associated protein 45,putative', 180, NULL, NULL, 32031),
(32032, '1.20.58.60-FF-000633', NULL, 'Spectrin repeat-containing, nuclear envelope 1b', 213, NULL, NULL, 32032),
(32033, '3.30.559.30-FF-000131', NULL, 'Nonribosomal peptide synthetase easA', 247, NULL, NULL, 32033),
(32034, '1.50.10.10-FF-000102', NULL, 'Mannosyl-oligosaccharide 1,2-alpha-mannosidase MNS2', 94, NULL, NULL, 32034),
(32035, '1.20.1070.10-FF-001887', NULL, 'Uncharacterized protein', 290, NULL, NULL, 32035),
(32036, '3.40.50.2300-FF-000841', NULL, 'Uncharacterized protein', 253, NULL, NULL, 32036),
(32037, '3.40.30.10-FF-000572', NULL, 'Uncharacterized protein', 114, NULL, NULL, 32037),
(32038, '3.40.720.10-FF-000268', NULL, 'Extracellular sulfatase SULF-1 homolog-like Protein', 437, NULL, NULL, 32038),
(32039, '1.20.120.1130-FF-000003', NULL, 'Vacuolar protein sorting-associated protein 28 homolog', 95, NULL, NULL, 32039),
(32040, '1.10.472.10-FF-000469', NULL, 'Transcription initiation factor IIB 5', 86, NULL, NULL, 32040),
(32041, '1.10.287.160-FF-000016', NULL, 'Protein kinase N1a', 47, NULL, NULL, 32041),
(32042, '1.10.167.10-FF-000070', NULL, 'Uncharacterized protein', 137, NULL, NULL, 32042),
(32043, '3.90.550.50-FF-000143', NULL, 'Uncharacterized protein', 200, NULL, NULL, 32043),
(32044, '3.90.1170.20-FF-000003', NULL, 'Nicotinate-nucleotide pyrophosphorylase [carboxylating]', 121, NULL, NULL, 32044),
(32045, '2.130.10.10-FF-005430', NULL, 'Uncharacterized protein', 226, NULL, NULL, 32045);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(32046, '1.20.1270.60-FF-000169', NULL, 'Rgd3p', 141, NULL, NULL, 32046),
(32047, '1.10.1040.10-FF-000084', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)], cytoplasmic', 157, NULL, NULL, 32047),
(32048, '3.30.830.10-FF-000211', NULL, 'Metalloprotease, insulinase family', 207, NULL, NULL, 32048),
(32049, '1.25.40.10-FF-004625', NULL, 'Uncharacterized protein', 131, NULL, NULL, 32049),
(32050, '2.40.160.120-FF-000022', NULL, 'Oxysterol Binding protein (OSBP) Related', 174, NULL, NULL, 32050),
(32051, '1.10.287.370-FF-000080', NULL, 'Uncharacterized protein', 124, NULL, NULL, 32051),
(32052, '3.80.10.10-FF-003323', NULL, 'NLR family CARD domain-containing 8', 192, NULL, NULL, 32052),
(32053, '3.30.70.330-FF-001590', NULL, NULL, 107, NULL, NULL, 32053),
(32054, '1.10.274.30-FF-000021', NULL, 'Uncharacterized protein', 172, NULL, NULL, 32054),
(32055, '1.10.10.10-FF-001503', NULL, 'DNR protein', 81, NULL, NULL, 32055),
(32056, '2.60.120.370-FF-000011', NULL, NULL, 151, NULL, NULL, 32056),
(32057, '3.40.50.620-FF-000299', NULL, 'Sensor histidine kinase KdpD', 129, NULL, NULL, 32057),
(32058, '3.40.30.10-FF-001010', NULL, 'Uncharacterized protein', 62, NULL, NULL, 32058),
(32059, '3.30.70.330-FF-001438', NULL, 'RNA-binding protein fox-1 homolog 2', 86, NULL, NULL, 32059),
(32060, '2.70.150.10-FF-000070', NULL, 'Cation-transporting ATPase', 171, NULL, NULL, 32060),
(32061, '3.40.850.10-FF-000480', NULL, 'Kinesin motor domaincontaining protein', 348, NULL, NULL, 32061),
(32062, '3.40.50.300-FF-003435', NULL, 'Dynein heavy chain 6, axonemal', 214, NULL, NULL, 32062),
(32063, '3.30.559.10-FF-000092', NULL, 'Protein ECERIFERUM 26-like', 199, NULL, NULL, 32063),
(32064, '2.70.170.10-FF-000301', NULL, 'Uncharacterized protein', 124, NULL, NULL, 32064),
(32065, '2.30.180.10-FF-000007', NULL, 'Transforming growth factor-beta-induced protein ig-h3', 131, NULL, NULL, 32065),
(32066, '2.30.29.30-FF-001307', NULL, 'Uncharacterized protein', 76, NULL, NULL, 32066),
(32067, '3.30.800.10-FF-000030', NULL, NULL, 135, NULL, NULL, 32067),
(32068, '3.40.50.300-FF-003699', NULL, 'Spastin', 109, NULL, NULL, 32068),
(32069, '1.25.40.20-FF-001812', NULL, 'SH3 and multiple ankyrin repeat domains 3', 160, NULL, NULL, 32069),
(32070, '1.10.510.10-FF-002195', NULL, NULL, 105, NULL, NULL, 32070),
(32071, '1.10.510.10-FF-003217', NULL, NULL, 137, NULL, NULL, 32071),
(32072, '3.50.50.60-FF-000317', NULL, 'Apoptosis inducing factor, isoform C', 179, NULL, NULL, 32072),
(32073, '3.30.479.20-FF-000037', NULL, 'Elongation factor Ts', 80, NULL, NULL, 32073),
(32074, '3.30.160.60-FF-001624', NULL, 'Zinc finger protein 354C', 26, NULL, NULL, 32074),
(32075, '3.30.530.20-FF-000107', NULL, 'Coenzyme Q-binding protein, mitochondrial, putative', 144, NULL, NULL, 32075),
(32076, '3.10.450.120-FF-000004', NULL, 'RNA-binding protein, containing PUA domain', 78, NULL, NULL, 32076),
(32077, '1.10.510.10-FF-001531', NULL, 'Related to CBK1-Serine/threonine protein kinase involved in cell wall biosynthesis', 31, NULL, NULL, 32077),
(32078, '3.30.450.20-FF-000494', NULL, 'PAS sensor protein', 123, NULL, NULL, 32078),
(32079, '2.130.10.10-FF-001799', NULL, 'Eukaryotic translation initiation factor 2A', 189, NULL, NULL, 32079),
(32080, '1.20.1250.20-FF-000061', NULL, 'MFS sugar transporter', 467, NULL, NULL, 32080),
(32081, '4.10.240.10-FF-000122', NULL, 'Chromosome 1, whole genome shotgun sequence', 75, NULL, NULL, 32081),
(32082, '2.10.25.10-FF-000349', NULL, 'Latent transforming growth factor beta binding protein 3', 42, NULL, NULL, 32082),
(32083, '1.10.630.10-FF-000225', NULL, 'Cytochrome P450', 441, NULL, NULL, 32083),
(32084, '2.60.40.10-FF-000051', NULL, 'Uncharacterized protein, isoform J', 95, NULL, NULL, 32084),
(32085, '3.40.50.2000-FF-000965', NULL, 'Lipopolysaccharide core biosynthesis mannosyltransferase', 96, NULL, NULL, 32085),
(32086, '1.25.10.10-FF-002875', NULL, 'HEAT repeat family protein', 153, NULL, NULL, 32086),
(32087, '3.30.230.10-FF-000233', NULL, '40S ribosomal protein S2, putative', 22, NULL, NULL, 32087),
(32088, '1.10.20.10-FF-000228', NULL, NULL, 69, NULL, NULL, 32088); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(32089, '3.50.50.60-FF-000868', NULL, 'Monooxygenase, FAD-binding', 415, NULL, NULL, 32089),
(32090, '2.40.70.10-FF-000413', NULL, NULL, 103, NULL, NULL, 32090),
(32091, '3.30.160.60-FF-004233', NULL, NULL, 44, NULL, NULL, 32091),
(32092, '1.20.1280.50-FF-000105', NULL, 'Transport inhibitor response 1-like protein Os05g0150500', 41, NULL, NULL, 32092),
(32093, '1.10.287.70-FF-000197', NULL, 'Glutamate receptor, ionotropic, delta 1', 108, NULL, NULL, 32093),
(32094, '3.30.1360.210-FF-000010', NULL, 'LSU ribosomal protein L22E', 115, NULL, NULL, 32094),
(32095, '3.20.20.140-FF-000367', NULL, 'Alkylphosphonate utilization protein PhnM', 235, NULL, NULL, 32095),
(32096, '1.20.1250.20-FF-001819', NULL, 'Uncharacterized protein', 155, NULL, NULL, 32096),
(32097, '4.10.280.10-FF-000017', NULL, 'Transcription factor bHLH66', 66, NULL, NULL, 32097),
(32098, '1.10.630.10-FF-000017', NULL, 'cytochrome P450 2U1 isoform X1', 469, NULL, NULL, 32098),
(32099, '3.30.70.890-FF-000009', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase, chloroplastic', 101, NULL, NULL, 32099),
(32100, '3.40.50.300-FF-002710', NULL, 'DNA repair helicase putative', 34, NULL, NULL, 32100),
(32101, '1.50.40.10-FF-000110', NULL, 'Solute carrier family 25 member 3', 202, NULL, NULL, 32101),
(32102, '1.20.1560.10-FF-000834', NULL, 'ABC transporter multi-drug efflux transporter-like protein', 626, NULL, NULL, 32102),
(32103, '2.30.30.30-FF-000086', NULL, 'Transcription elongation factor SPT5', 67, NULL, NULL, 32103),
(32104, '3.80.10.10-FF-003952', NULL, 'Uncharacterized protein', 66, NULL, NULL, 32104),
(32105, '3.40.50.300-FF-000321', NULL, 'Thymidylate kinase', 211, NULL, NULL, 32105),
(32106, '3.30.365.10-FF-000085', NULL, 'Uncharacterized protein', 82, NULL, NULL, 32106),
(32107, '3.40.1360.10-FF-000009', NULL, 'Meiotic recombination protein SPO11-2', 220, NULL, NULL, 32107),
(32108, '3.60.40.10-FF-000184', NULL, 'Predicted protein', 274, NULL, NULL, 32108),
(32109, '1.10.287.210-FF-000003', NULL, 'Envelope glycoprotein', 74, NULL, NULL, 32109),
(32110, '1.10.260.40-FF-000020', NULL, 'Trifunctional nicotinamide-nucleotide adenylyltransferase/ribosylnicotinamide kinase/transcriptional regulator NadR', 56, NULL, NULL, 32110),
(32111, '3.40.50.300-FF-006684', NULL, 'Uncharacterized protein', 81, NULL, NULL, 32111),
(32112, '3.40.1800.20-FF-000035', NULL, NULL, 77, NULL, NULL, 32112),
(32113, '3.40.140.10-FF-000089', NULL, 'Eukaryotic translation initiation factor 3 subunit F', 194, NULL, NULL, 32113),
(32114, '1.10.10.10-FF-000402', NULL, 'Trehalose operon transcriptional repressor', 70, NULL, NULL, 32114),
(32115, '3.40.50.2000-FF-000577', NULL, 'GalNAc-alpha-(1->4)-GalNAc-alpha-(1->3)-diNAcBac-PP-undecaprenol alpha-1,4-N-acetyl-D-galactosaminyltransferase', 165, NULL, NULL, 32115),
(32116, '2.60.40.10-FF-005694', NULL, NULL, 121, NULL, NULL, 32116),
(32117, '1.20.5.320-FF-000013', NULL, 'Collagen alpha-1(XVII) chain', 40, NULL, NULL, 32117),
(32118, '3.40.220.10-FF-000011', NULL, 'Leucine aminopeptidase 2, chloroplastic', 199, NULL, NULL, 32118),
(32119, '2.60.120.200-FF-000798', NULL, 'Uncharacterized protein', 255, NULL, NULL, 32119),
(32120, '3.30.70.3250-FF-000011', NULL, NULL, 70, NULL, NULL, 32120),
(32121, '3.30.1490.40-FF-000007', NULL, 'GYF domain-containing protein', 79, NULL, NULL, 32121),
(32122, '3.60.21.10-FF-000196', NULL, 'Acid sphingomyelinase, putative', 297, NULL, NULL, 32122),
(32123, '1.25.40.10-FF-003720', NULL, 'Uncharacterized protein', 109, NULL, NULL, 32123),
(32124, '1.10.150.50-FF-000172', NULL, 'E74 like ETS transcription factor 3', 70, NULL, NULL, 32124),
(32125, '3.40.50.1820-FF-001349', NULL, 'Uncharacterized protein', 243, NULL, NULL, 32125),
(32126, '1.20.1070.10-FF-000459', NULL, 'Olfactory receptor', 190, NULL, NULL, 32126),
(32127, '1.10.260.100-FF-000030', NULL, 'AGAP009119-PA', 52, NULL, NULL, 32127),
(32128, '2.60.40.1530-FF-000005', NULL, 'Integrin, alpha 9', 200, NULL, NULL, 32128),
(32129, '2.60.40.10-FF-002760', NULL, 'Glycoprotein UL18', 92, NULL, NULL, 32129),
(32130, '2.40.40.20-FF-000061', NULL, 'ATPase, AAA family protein', 86, NULL, NULL, 32130);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(32131, '3.40.50.300-FF-006925', NULL, 'Uncharacterized protein', 232, NULL, NULL, 32131),
(32132, '2.60.120.330-FF-000078', NULL, 'Clavaminate synthase-like protein', 340, NULL, NULL, 32132),
(32133, '3.80.10.10-FF-002316', NULL, 'Uncharacterized protein', 162, NULL, NULL, 32133),
(32134, '1.25.40.10-FF-000674', NULL, 'Protein TONSOKU', 318, NULL, NULL, 32134),
(32135, '1.20.1640.10-FF-000104', NULL, NULL, 193, NULL, NULL, 32135),
(32136, '3.40.50.410-FF-000242', NULL, 'integrator complex subunit 14', 148, NULL, NULL, 32136),
(32137, '2.20.130.10-FF-000001', NULL, 'dTDP-3-amino-3,4,6-trideoxy-alpha-D-glucopyranose', 59, NULL, NULL, 32137),
(32138, '3.40.50.720-FF-001644', NULL, 'Uncharacterized protein', 313, NULL, NULL, 32138),
(32139, '3.30.70.100-FF-000026', NULL, 'ATPase copper transporting alpha', 84, NULL, NULL, 32139),
(32140, '2.30.40.10-FF-000165', NULL, 'Uncharacterized protein', 78, NULL, NULL, 32140),
(32141, '1.20.1440.180-FF-000010', NULL, 'Probable serine/threonine-protein kinase ireA', 131, NULL, NULL, 32141),
(32142, '3.40.50.1460-FF-000140', NULL, 'Uncharacterized protein', 152, NULL, NULL, 32142),
(32143, '2.40.30.10-FF-000416', NULL, 'Uncharacterized protein', 96, NULL, NULL, 32143),
(32144, '1.20.5.110-FF-000040', NULL, 'SNAP25 homologous protein SNAP33', 68, NULL, NULL, 32144),
(32145, '1.20.58.390-FF-000314', NULL, 'Uncharacterized protein', 159, NULL, NULL, 32145),
(32146, '3.30.50.10-FF-000045', NULL, 'Transcription factor elt-7', 62, NULL, NULL, 32146),
(32147, '3.40.50.790-FF-000035', NULL, 'Predicted protein', 97, NULL, NULL, 32147),
(32148, '3.10.129.110-FF-000017', NULL, 'Lovastatin diketide synthase LovF', 322, NULL, NULL, 32148),
(32149, '3.30.70.330-FF-001090', NULL, 'Si:ch73-190f9.4', 194, NULL, NULL, 32149),
(32150, '3.40.50.300-FF-005060', NULL, 'Miro-like protein, putative', 139, NULL, NULL, 32150),
(32151, '3.40.50.300-FF-007201', NULL, 'Shikimate kinase', 168, NULL, NULL, 32151),
(32152, '1.10.8.720-FF-000006', NULL, 'cytoplasmic dynein 2 heavy chain 1', 168, NULL, NULL, 32152),
(32153, '3.90.1110.10-FF-000002', NULL, 'DNA-directed RNA polymerase subunit beta', 172, NULL, NULL, 32153),
(32154, '1.25.10.10-FF-003252', NULL, 'Serine/threonine-protein kinase TOR', 227, NULL, NULL, 32154),
(32155, '2.60.40.10-FF-004901', NULL, NULL, 60, NULL, NULL, 32155),
(32156, '3.40.50.300-FF-003935', NULL, 'Rad17 protein', 183, NULL, NULL, 32156),
(32157, '3.90.1580.10-FF-000020', NULL, 'Probable serine/threonine-protein kinase pknB', 272, NULL, NULL, 32157),
(32158, '1.25.40.10-FF-004889', NULL, 'Uncharacterized protein', 98, NULL, NULL, 32158),
(32159, '1.10.510.10-FF-003717', NULL, NULL, 157, NULL, NULL, 32159),
(32160, '1.25.40.180-FF-000068', NULL, 'Eukaryotic translation initiation factor 4 gamma 1-like Protein', 239, NULL, NULL, 32160),
(32161, '3.90.660.10-FF-000072', NULL, NULL, 160, NULL, NULL, 32161),
(32162, '3.40.50.300-FF-001018', NULL, 'Rab family GTPase', 201, NULL, NULL, 32162),
(32163, '1.20.1070.10-FF-001752', NULL, 'Olfactory receptor 1507', 78, NULL, NULL, 32163),
(32164, '3.40.30.10-FF-000072', NULL, 'Phosducin like', 134, NULL, NULL, 32164),
(32165, '3.30.70.3170-FF-000003', NULL, 'Galactokinase family protein', 55, NULL, NULL, 32165),
(32166, '2.10.25.10-FF-000529', NULL, 'Eyes shut homolog', 36, NULL, NULL, 32166),
(32167, '1.25.10.10-FF-001122', NULL, 'Coatomer subunit beta-1', 385, NULL, NULL, 32167),
(32168, '2.130.10.10-FF-000607', NULL, 'Autophagy related 16 like 1', 155, NULL, NULL, 32168),
(32169, '1.25.40.10-FF-005165', NULL, 'Predicted protein', 275, NULL, NULL, 32169),
(32170, '3.40.630.10-FF-000109', NULL, 'Putative membrane protein', 276, NULL, NULL, 32170),
(32171, '3.30.70.330-FF-003068', NULL, NULL, 103, NULL, NULL, 32171),
(32172, '3.90.1100.10-FF-000052', NULL, 'Os03g0646800 protein', 131, NULL, NULL, 32172),
(32173, '3.30.9.10-FF-000034', NULL, 'Fructosyl amino acid oxidasesarcosine oxidase', 188, NULL, NULL, 32173),
(32174, '2.130.10.10-FF-005346', NULL, 'Uncharacterized protein', 180, NULL, NULL, 32174),
(32175, '1.10.720.30-FF-000002', NULL, 'Myocardin related transcription factor A', 69, NULL, NULL, 32175);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(32176, '2.170.16.10-FF-000001', NULL, 'Indian hedgehog', 149, NULL, NULL, 32176),
(32177, '2.10.25.10-FF-000681', NULL, 'Multiple epidermal growth factor-like domains 8', 29, NULL, NULL, 32177),
(32178, '3.30.1490.430-FF-000003', NULL, 'Uncharacterized protein', 68, NULL, NULL, 32178),
(32179, '3.40.50.1820-FF-000444', NULL, 'Putative serine esterase Rv1835c', 114, NULL, NULL, 32179),
(32180, '1.20.1250.20-FF-001342', NULL, 'GD11715', 207, NULL, NULL, 32180),
(32181, '3.30.70.1820-FF-000014', NULL, NULL, 96, NULL, NULL, 32181),
(32182, '3.30.70.260-FF-000085', NULL, 'ACT domain-containing protein', 77, NULL, NULL, 32182),
(32183, '2.60.40.10-FF-005418', NULL, NULL, 79, NULL, NULL, 32183),
(32184, '3.40.50.1700-FF-000049', NULL, 'Glycosyl hydrolase family protein', 101, NULL, NULL, 32184),
(32185, '1.25.40.20-FF-000290', NULL, 'C2H2 finger and ankyrin domain-containing protein', 100, NULL, NULL, 32185),
(32186, '1.20.1250.20-FF-001078', NULL, 'Solute carrier family 15 (oligopeptide transporter), member 4', 390, NULL, NULL, 32186),
(32187, '1.10.10.570-FF-000009', NULL, 'Vacuolar protein-sorting-associated protein', 97, NULL, NULL, 32187),
(32188, '3.30.160.60-FF-000500', NULL, 'Tripartite motif-containing 46, isoform CRA_c', 45, NULL, NULL, 32188),
(32189, '1.10.238.270-FF-000006', NULL, 'Odorant-binding protein 50b', 163, NULL, NULL, 32189),
(32190, '3.40.50.150-FF-000607', NULL, 'Arginine N-methyltransferase, type I', 160, NULL, NULL, 32190),
(32191, '3.50.50.60-FF-000525', NULL, 'D-Amino acid dehydrogenase', 96, NULL, NULL, 32191),
(32192, '2.30.30.940-FF-000009', NULL, 'ATP-dependent RecD-like DNA helicase', 69, NULL, NULL, 32192),
(32193, '3.20.20.70-FF-000269', NULL, 'Putative 2-dehydro-3-deoxy-D-gluconate aldolase YagE', 298, NULL, NULL, 32193),
(32194, '2.60.120.590-FF-000072', NULL, 'Uncharacterized protein', 122, NULL, NULL, 32194),
(32195, '3.40.50.2300-FF-001185', NULL, NULL, 44, NULL, NULL, 32195),
(32196, '2.80.10.50-FF-000285', NULL, 'Uncharacterized protein', 198, NULL, NULL, 32196),
(32197, '3.30.40.10-FF-001444', NULL, 'Uncharacterized protein', 99, NULL, NULL, 32197),
(32198, '3.40.640.10-FF-000003', NULL, 'Cysteine desulfurase IscS', 246, NULL, NULL, 32198),
(32199, '3.40.1110.10-FF-000429', NULL, NULL, 220, NULL, NULL, 32199),
(32200, '2.60.120.200-FF-000410', NULL, 'Thrombospondin 3', 113, NULL, NULL, 32200),
(32201, '1.25.40.20-FF-000059', NULL, 'E3 ubiquitin-protein ligase MIB1 isoform X1', 134, NULL, NULL, 32201),
(32202, '3.40.367.20-FF-000051', NULL, 'Hexokinase 2', 66, NULL, NULL, 32202),
(32203, '3.30.1520.10-FF-000165', NULL, 'Uncharacterized protein', 135, NULL, NULL, 32203),
(32204, '4.10.1240.10-FF-000046', NULL, 'Diuretic hormone receptor precursor, putative', 69, NULL, NULL, 32204),
(32205, '3.40.720.10-FF-000004', NULL, 'Arylsulfatase E', 368, NULL, NULL, 32205),
(32206, '3.40.50.720-FF-000683', NULL, 'Probable short-chain dehydrogenase', 251, NULL, NULL, 32206),
(32207, '3.30.470.10-FF-000048', NULL, 'Branched-chain-amino-acid aminotransferase', 99, NULL, NULL, 32207),
(32208, '1.25.10.10-FF-000846', NULL, 'Armadillo repeat-containing X-linked protein 3', 153, NULL, NULL, 32208),
(32209, '3.40.1190.20-FF-000061', NULL, 'Fructokinase', 295, NULL, NULL, 32209),
(32210, '3.90.1030.10-FF-000001', NULL, '50S ribosomal protein L17', 116, NULL, NULL, 32210),
(32211, '3.20.20.80-FF-000626', NULL, 'Uncharacterized protein', 132, NULL, NULL, 32211),
(32212, '3.30.160.60-FF-006363', NULL, NULL, 34, NULL, NULL, 32212),
(32213, '3.90.740.10-FF-000073', NULL, 'ATP binding / aminoacyl-tRNA ligase/ nucleotide binding protein', 92, NULL, NULL, 32213),
(32214, '3.30.360.20-FF-000015', NULL, NULL, 107, NULL, NULL, 32214),
(32215, '1.10.287.1490-FF-000107', NULL, 'COP1-interactive protein 1', 161, NULL, NULL, 32215),
(32216, '2.40.50.140-FF-000288', NULL, 'Transcription elongation factor SPT6', 82, NULL, NULL, 32216),
(32217, '1.10.510.10-FF-000227', NULL, 'Serine/threonine-protein kinase', 205, NULL, NULL, 32217),
(32218, '3.90.640.10-FF-000088', NULL, 'Actin-related protein 8', 153, NULL, NULL, 32218);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(32219, '2.60.200.40-FF-000012', NULL, 'Diacylglycerol kinase', 166, NULL, NULL, 32219),
(32220, '2.60.40.10-FF-001203', NULL, 'Tenascin N', 61, NULL, NULL, 32220),
(32221, '2.130.10.10-FF-001456', NULL, 'Pre-rRNA-processing protein IPI3, putative', 159, NULL, NULL, 32221),
(32222, '2.60.40.10-FF-000927', NULL, 'Plexin D1', 138, NULL, NULL, 32222),
(32223, '3.90.228.10-FF-000006', NULL, 'Poly [ADP-ribose] polymerase', 118, NULL, NULL, 32223),
(32224, '3.90.550.10-FF-000261', NULL, 'GLYcosylation related', 237, NULL, NULL, 32224),
(32225, '3.30.70.330-FF-001831', NULL, NULL, 157, NULL, NULL, 32225),
(32226, '1.25.40.20-FF-001571', NULL, 'Ankyrin repeat family protein', 54, NULL, NULL, 32226),
(32227, '1.10.630.10-FF-000293', NULL, 'Uncharacterized protein', 144, NULL, NULL, 32227),
(32228, '2.60.40.1180-FF-000035', NULL, 'Glucosylceramidase 3', 68, NULL, NULL, 32228),
(32229, '3.80.10.10-FF-004492', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 95, NULL, NULL, 32229),
(32230, '1.10.510.10-FF-002436', NULL, NULL, 132, NULL, NULL, 32230),
(32231, '1.10.3090.10-FF-000031', NULL, 'Uncharacterized protein', 321, NULL, NULL, 32231),
(32232, '3.30.160.60-FF-000843', NULL, 'Potential zinc finger protein', 29, NULL, NULL, 32232),
(32233, '1.20.1280.50-FF-000173', NULL, 'F-box protein At2g02240', 48, NULL, NULL, 32233),
(32234, '3.40.1350.10-FF-000003', NULL, 'tRNA-splicing endonuclease subunit Sen15 isoform X2', 116, NULL, NULL, 32234),
(32235, '2.130.10.120-FF-000005', NULL, 'Prolyl endopeptidase like', 32, NULL, NULL, 32235),
(32236, '3.40.50.10490-FF-000077', NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', 145, NULL, NULL, 32236),
(32237, '2.60.40.200-FF-000013', NULL, 'Superoxide dismutase [Cu-Zn]', 154, NULL, NULL, 32237),
(32238, '2.80.10.50-FF-000009', NULL, 'Ryanodine receptor 1 (skeletal)', 181, NULL, NULL, 32238),
(32239, '3.40.50.620-FF-000479', NULL, 'Uncharacterized protein', 59, NULL, NULL, 32239),
(32240, '2.30.30.40-FF-000364', NULL, 'AMPHiphysin homolog', 69, NULL, NULL, 32240),
(32241, '3.30.2410.10-FF-000022', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 112, NULL, NULL, 32241),
(32242, '1.10.472.80-FF-000153', NULL, 'Uncharacterized protein', 165, NULL, NULL, 32242),
(32243, '3.40.50.300-FF-004155', NULL, 'WHiTe (Drosophila) related ABC transporter', 245, NULL, NULL, 32243),
(32244, '3.40.50.10140-FF-000056', NULL, 'Uncharacterized protein', 144, NULL, NULL, 32244),
(32245, '3.40.50.1240-FF-000023', NULL, 'Periplasmic glucose-1-phosphatase', 229, NULL, NULL, 32245),
(32246, '3.30.160.60-FF-004154', NULL, NULL, 22, NULL, NULL, 32246),
(32247, '3.40.50.10470-FF-000071', NULL, 'Uncharacterized protein', 165, NULL, NULL, 32247),
(32248, '3.30.70.330-FF-002219', NULL, NULL, 123, NULL, NULL, 32248),
(32249, '2.30.29.170-FF-000006', NULL, 'EF-hand domain-containing family member C2', 127, NULL, NULL, 32249),
(32250, '3.40.50.1260-FF-000029', NULL, 'Phosphoglycerate kinase', 73, NULL, NULL, 32250),
(32251, '3.30.460.10-FF-000042', NULL, 'DNA polymerase', 123, NULL, NULL, 32251),
(32252, '3.30.1360.40-FF-000003', NULL, 'DNA topoisomerase 2', 103, NULL, NULL, 32252),
(32253, '1.20.1440.130-FF-000012', NULL, 'AGAP000543-PA', 169, NULL, NULL, 32253),
(32254, '3.30.200.20-FF-001875', NULL, 'Calcium/calmodulin-dependent protein kinase type II', 107, NULL, NULL, 32254),
(32255, '3.30.540.10-FF-000043', NULL, 'Putative inositol monophosphatase', 158, NULL, NULL, 32255),
(32256, '3.30.450.20-FF-000573', NULL, 'Uncharacterized protein', 99, NULL, NULL, 32256),
(32257, '3.30.565.10-FF-000302', NULL, 'GAF sensor signal transduction histidine kinase', 156, NULL, NULL, 32257),
(32258, '3.40.630.10-FF-000385', NULL, 'Uncharacterized protein', 70, NULL, NULL, 32258),
(32259, '2.40.50.200-FF-000003', NULL, 'Stress-induced protein YgiW', 102, NULL, NULL, 32259),
(32260, '3.40.140.10-FF-000010', NULL, 'AMSH-like protease isoform X1', 177, NULL, NULL, 32260),
(32261, '3.30.70.330-FF-001270', NULL, 'Predicted protein', 95, NULL, NULL, 32261);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(32262, '1.25.40.10-FF-005345', NULL, 'Uncharacterized protein', 155, NULL, NULL, 32262),
(32263, '1.10.8.270-FF-000040', NULL, 'GTPase-activating protein, putative', 100, NULL, NULL, 32263),
(32264, '2.40.10.10-FF-000584', NULL, NULL, 42, NULL, NULL, 32264),
(32265, '3.40.630.30-FF-000267', NULL, 'GNAT family N-acetyltransferase', 171, NULL, NULL, 32265),
(32266, '2.60.120.10-FF-000374', NULL, 'AraC family transcriptional regulator', 54, NULL, NULL, 32266),
(32267, '1.10.10.2170-FF-000001', NULL, 'Telomeric repeat-binding factor 2-interacting protein 1', 43, NULL, NULL, 32267),
(32268, '2.10.25.10-FF-001777', NULL, 'Uromodulin', 33, NULL, NULL, 32268),
(32269, '3.40.630.30-FF-000003', NULL, 'Elongator complex protein 3', 155, NULL, NULL, 32269),
(32270, '3.40.50.300-FF-007589', NULL, 'Uncharacterized protein', 175, NULL, NULL, 32270),
(32271, '2.30.29.30-FF-000369', NULL, 'Oxysterol binding protein', 95, NULL, NULL, 32271),
(32272, '4.10.400.10-FF-000106', NULL, 'Uncharacterized protein, isoform D', 40, NULL, NULL, 32272),
(32273, '3.90.70.80-FF-000025', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 185, NULL, NULL, 32273),
(32274, '3.30.40.10-FF-000988', NULL, 'RING/U-box superfamily protein', 83, NULL, NULL, 32274),
(32275, '2.170.140.10-FF-000051', NULL, 'Mucin 68E', 62, NULL, NULL, 32275),
(32276, '1.25.40.90-FF-000091', NULL, 'Cids-2', 135, NULL, NULL, 32276),
(32277, '3.10.20.90-FF-000236', NULL, 'Ubiquitin carboxyl-terminal hydrolase 7, variant', 100, NULL, NULL, 32277),
(32278, '3.10.110.10-FF-000004', NULL, 'Ubiquitin-conjugating enzyme E2 A', 151, NULL, NULL, 32278),
(32279, '1.20.140.10-FF-000101', NULL, 'Medium-chain acyl-CoA dehydrogenase, putative', 65, NULL, NULL, 32279),
(32280, '2.30.30.100-FF-000145', NULL, 'SnRNP Sm-like protein, putative', 77, NULL, NULL, 32280),
(32281, '3.40.850.10-FF-000160', NULL, 'Predicted protein', 342, NULL, NULL, 32281),
(32282, '3.40.190.10-FF-000013', NULL, 'Lipoprotein', 122, NULL, NULL, 32282),
(32283, '1.25.40.1040-FF-000048', NULL, 'Uncharacterized protein', 69, NULL, NULL, 32283),
(32284, '2.60.120.290-FF-000217', NULL, 'Uncharacterized protein', 114, NULL, NULL, 32284),
(32285, '1.25.40.10-FF-000410', NULL, 'Pre-mRNA-splicing factor prp1', 72, NULL, NULL, 32285),
(32286, '3.40.50.300-FF-003194', NULL, 'ATP-dependent RNA helicase', 172, NULL, NULL, 32286),
(32287, '3.30.310.80-FF-000058', NULL, '5''-AMP-activated protein kinase catalytic subunit alpha-1', 66, NULL, NULL, 32287),
(32288, '3.40.250.10-FF-000182', NULL, 'Uncharacterized protein', 134, NULL, NULL, 32288),
(32289, '2.30.30.40-FF-000100', NULL, 'SH3 domain-containing YSC84-like protein 1', 67, NULL, NULL, 32289),
(32290, '1.25.40.10-FF-001511', NULL, 'OSJNBa0060P14.4 protein', 94, NULL, NULL, 32290),
(32291, '3.90.1640.10-FF-000019', NULL, 'Manganese-dependent inorganic pyrophosphatase', 103, NULL, NULL, 32291),
(32292, '3.80.10.10-FF-001182', NULL, 'Si:dkey-121n8.7', 138, NULL, NULL, 32292),
(32293, '3.40.720.10-FF-000347', NULL, 'Uncharacterized protein', 63, NULL, NULL, 32293),
(32294, '1.50.10.20-FF-000083', NULL, 'Rab geranylgeranyltransferase subunit beta', 47, NULL, NULL, 32294),
(32295, '3.40.50.300-FF-002530', NULL, 'ABC transporter A family member 5', 250, NULL, NULL, 32295),
(32296, '3.30.160.60-FF-001692', NULL, 'Transcriptional activator/repressor GIS1', 31, NULL, NULL, 32296),
(32297, '1.10.418.10-FF-000131', NULL, 'Dystrophin-1', 118, NULL, NULL, 32297),
(32298, '1.10.1200.50-FF-000001', NULL, NULL, 76, NULL, NULL, 32298),
(32299, '3.40.50.300-FF-005964', NULL, 'ATP-dependent DNA helicase, RecQ family', 172, NULL, NULL, 32299),
(32300, '3.40.30.10-FF-000813', NULL, 'Pyrimidodiazepine synthase', 101, NULL, NULL, 32300),
(32301, '2.60.40.10-FF-000186', NULL, 'Hemicentin 1', 92, NULL, NULL, 32301),
(32302, '1.50.40.10-FF-000453', NULL, 'Uncharacterized protein', 113, NULL, NULL, 32302),
(32303, '3.30.420.10-FF-000388', NULL, NULL, 131, NULL, NULL, 32303),
(32304, '1.20.920.10-FF-000099', NULL, 'Chromatin remodeling-related protein, putative', 117, NULL, NULL, 32304);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(32305, '1.25.40.180-FF-000248', NULL, NULL, 85, NULL, NULL, 32305),
(32306, '3.30.505.10-FF-000153', NULL, NULL, 100, NULL, NULL, 32306),
(32307, '3.30.1490.20-FF-000001', NULL, 'Carbamoyl-phosphate synthase large chain', 70, NULL, NULL, 32307),
(32308, '1.20.1270.10-FF-000115', NULL, 'ADR128Cp', 97, NULL, NULL, 32308),
(32309, '1.20.120.980-FF-000007', NULL, 'Predicted protein', 154, NULL, NULL, 32309),
(32310, '2.60.120.650-FF-000168', NULL, 'Uncharacterized protein', 188, NULL, NULL, 32310),
(32311, '1.10.730.10-FF-000002', NULL, 'Leucine--tRNA ligase', 204, NULL, NULL, 32311),
(32312, '3.40.640.10-FF-000346', NULL, 'Uncharacterized protein', 277, NULL, NULL, 32312),
(32313, '3.30.70.330-FF-003063', NULL, NULL, 105, NULL, NULL, 32313),
(32314, '3.90.226.10-FF-000120', NULL, 'Putative acetyl-coenzyme A carboxylase carboxyl transferase subunit beta', 222, NULL, NULL, 32314),
(32315, '4.10.240.10-FF-000127', NULL, 'Uncharacterized protein', 69, NULL, NULL, 32315),
(32316, '1.20.1270.60-FF-000034', NULL, 'DCC-interacting protein 13-alpha isoform X2', 263, NULL, NULL, 32316),
(32317, '4.10.400.10-FF-000281', NULL, 'complement component C9', 40, NULL, NULL, 32317),
(32318, '3.40.50.300-FF-007358', NULL, 'Uncharacterized protein', 152, NULL, NULL, 32318),
(32319, '3.90.1150.10-FF-000499', NULL, 'Aminotransferase, conjectural', 18, NULL, NULL, 32319),
(32320, '3.40.50.300-FF-007414', NULL, 'Uncharacterized protein', 26, NULL, NULL, 32320),
(32321, '3.10.129.10-FF-000266', NULL, 'AAL038Wp', 194, NULL, NULL, 32321),
(32322, '1.10.510.10-FF-003212', NULL, NULL, 142, NULL, NULL, 32322),
(32323, '1.20.120.1900-FF-000083', NULL, 'Gamma-tubulin complex component', 188, NULL, NULL, 32323),
(32324, '2.60.20.10-FF-000016', NULL, 'Uncharacterized protein', 87, NULL, NULL, 32324),
(32325, '1.10.560.10-FF-000017', NULL, 'T-complex protein 1 subunit eta', 118, NULL, NULL, 32325),
(32326, '3.40.50.12780-FF-000179', NULL, 'Uncharacterized protein', 267, NULL, NULL, 32326),
(32327, '2.60.40.60-FF-000509', NULL, 'Protein CBR-CDH-12', 100, NULL, NULL, 32327),
(32328, '3.80.10.10-FF-002199', NULL, 'Si:ch211-191a16.2', 129, NULL, NULL, 32328),
(32329, '2.60.120.680-FF-000008', NULL, 'PATELLIN 2', 96, NULL, NULL, 32329),
(32330, '1.25.10.10-FF-002999', NULL, 'Uncharacterized protein', 353, NULL, NULL, 32330),
(32331, '1.10.268.10-FF-000034', NULL, NULL, 157, NULL, NULL, 32331),
(32332, '3.30.200.20-FF-001307', NULL, 'Differentiation inhibitory kinase', 100, NULL, NULL, 32332),
(32333, '1.10.8.470-FF-000004', NULL, 'Redox-regulated ATPase YchF', 89, NULL, NULL, 32333),
(32334, '1.25.40.20-FF-000851', NULL, 'Protein CBG23394', 185, NULL, NULL, 32334),
(32335, '3.30.200.20-FF-000739', NULL, 'Serine/threonine protein kinase VPS15', 33, NULL, NULL, 32335),
(32336, '3.40.20.10-FF-000127', NULL, 'YALI0E33693p', 116, NULL, NULL, 32336),
(32337, '3.30.230.10-FF-000238', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 149, NULL, NULL, 32337),
(32338, '1.10.287.2610-FF-000005', NULL, 'Uncharacterized protein', 199, NULL, NULL, 32338),
(32339, '3.30.160.60-FF-001068', NULL, 'Zinc finger and BTB domain-containing 48', 28, NULL, NULL, 32339),
(32340, '2.60.40.10-FF-004289', NULL, NULL, 116, NULL, NULL, 32340),
(32341, '3.30.160.60-FF-004789', NULL, NULL, 42, NULL, NULL, 32341),
(32342, '3.40.50.300-FF-003143', NULL, '6-phosphofructo-2-kinase/fructose-2, 6-biphosphatase, putative', 216, NULL, NULL, 32342),
(32343, '2.60.40.10-FF-004345', NULL, NULL, 115, NULL, NULL, 32343),
(32344, '3.10.100.10-FF-000239', NULL, NULL, 124, NULL, NULL, 32344),
(32345, '2.60.40.10-FF-003777', NULL, NULL, 96, NULL, NULL, 32345),
(32346, '2.40.70.10-FF-000065', NULL, 'Eukaryotic aspartyl protease family protein', 172, NULL, NULL, 32346),
(32347, '3.40.50.10350-FF-000001', NULL, 'Glycerate kinase 2', 127, NULL, NULL, 32347),
(32348, '2.130.10.10-FF-002232', NULL, 'Uncharacterized protein', 477, NULL, NULL, 32348),
(32349, '3.30.420.40-FF-001004', NULL, 'Uncharacterized protein', 70, NULL, NULL, 32349),
(32350, '3.40.50.12780-FF-000235', NULL, 'Uncharacterized protein', 121, NULL, NULL, 32350);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(32351, '1.20.1110.10-FF-000014', NULL, 'Calcium-transporting ATPase', 252, NULL, NULL, 32351),
(32352, '3.80.10.10-FF-002255', NULL, 'Uncharacterized protein', 111, NULL, NULL, 32352),
(32353, '3.40.50.150-FF-001664', NULL, NULL, 95, NULL, NULL, 32353),
(32354, '1.20.810.10-FF-000006', NULL, 'Cytochrome b', 374, NULL, NULL, 32354),
(32355, '1.10.510.10-FF-003156', NULL, NULL, 174, NULL, NULL, 32355),
(32356, '3.40.50.1000-FF-000210', NULL, 'Phospholipid-transporting ATPase', 188, NULL, NULL, 32356),
(32357, '2.60.40.10-FF-000978', NULL, 'coagulation factor XIII A chain', 185, NULL, NULL, 32357),
(32358, '2.130.10.10-FF-005902', NULL, 'Uncharacterized protein', 282, NULL, NULL, 32358),
(32359, '3.30.1560.10-FF-000004', NULL, 'Uncharacterized protein', 48, NULL, NULL, 32359),
(32360, '3.30.559.10-FF-000209', NULL, 'Carnitine O-octanoyltransferase', 197, NULL, NULL, 32360),
(32361, '2.60.40.1120-FF-000040', NULL, 'Carboxypeptidase Z', 36, NULL, NULL, 32361),
(32362, '1.20.58.60-FF-000818', NULL, 'Uncharacterized protein', 184, NULL, NULL, 32362),
(32363, '3.60.21.10-FF-000432', NULL, 'Uncharacterized protein', 244, NULL, NULL, 32363),
(32364, '3.40.50.300-FF-000344', NULL, 'Ras-related protein Rab-14', 194, NULL, NULL, 32364),
(32365, '1.10.540.10-FF-000111', NULL, 'Acyl-coenzyme A oxidase', 121, NULL, NULL, 32365),
(32366, '3.40.30.10-FF-001246', NULL, 'Putative protein disulfide-isomerase C1F5.02', 129, NULL, NULL, 32366),
(32367, '3.30.1680.10-FF-000058', NULL, 'Uncharacterized protein', 47, NULL, NULL, 32367),
(32368, '3.40.190.10-FF-000249', NULL, 'Amino acid ABC transporter, amino acid-binding protein/permease protein', 95, NULL, NULL, 32368),
(32369, '2.30.30.670-FF-000001', NULL, 'Fibronectin-binding protein', 102, NULL, NULL, 32369),
(32370, '3.40.50.720-FF-002184', NULL, 'Uncharacterized protein', 55, NULL, NULL, 32370),
(32371, '3.30.70.330-FF-003012', NULL, NULL, 78, NULL, NULL, 32371),
(32372, '3.40.50.200-FF-000140', NULL, 'Probable subtilase-type serine protease DR_A0283', 348, NULL, NULL, 32372),
(32373, '3.40.630.10-FF-000441', NULL, 'Uncharacterized protein', 221, NULL, NULL, 32373),
(32374, '2.60.40.150-FF-000599', NULL, 'Neural precursor cell expressed, developmentally down-regulated 4, E3 ubiquitin protein ligase', 82, NULL, NULL, 32374),
(32375, '2.60.40.10-FF-003092', NULL, 'Protein-tyrosine-phosphatase', 88, NULL, NULL, 32375),
(32376, '1.20.1280.20-FF-000006', NULL, 'DnaJ domain protein', 87, NULL, NULL, 32376),
(32377, '1.20.5.170-FF-000159', NULL, 'Serologically defined colon cancer antigen', 121, NULL, NULL, 32377),
(32378, '3.40.50.300-FF-004559', NULL, 'Predicted protein', 60, NULL, NULL, 32378),
(32379, '3.30.2130.10-FF-000028', NULL, 'Uncharacterized protein', 56, NULL, NULL, 32379),
(32380, '1.10.3820.10-FF-000003', NULL, 'Cytochrome c-type protein', 159, NULL, NULL, 32380),
(32381, '1.20.58.60-FF-000869', NULL, 'Uncharacterized protein', 120, NULL, NULL, 32381),
(32382, '3.10.20.710-FF-000001', NULL, 'DNA-binding protein SATB', 103, NULL, NULL, 32382),
(32383, '1.20.58.60-FF-000133', NULL, 'nesprin-2 isoform X2', 115, NULL, NULL, 32383),
(32384, '3.30.1480.10-FF-000003', NULL, 'Transcription termination/antitermination protein NusA', 127, NULL, NULL, 32384),
(32385, '3.40.1350.10-FF-000008', NULL, 'tRNA-splicing endonuclease subunit Sen34', 93, NULL, NULL, 32385),
(32386, '2.60.120.380-FF-000076', NULL, 'Calpain-like protein, putative', 145, NULL, NULL, 32386),
(32387, '1.10.10.60-FF-000771', NULL, NULL, 67, NULL, NULL, 32387),
(32388, '3.40.47.10-FF-000048', NULL, '3-oxoacyl-Acyl-carrier-protein synthase III', 307, NULL, NULL, 32388),
(32389, '3.30.500.10-FF-000046', NULL, NULL, 131, NULL, NULL, 32389),
(32390, '3.30.9.10-FF-000247', NULL, 'Uncharacterized protein', 16, NULL, NULL, 32390),
(32391, '3.40.50.1000-FF-000261', NULL, 'HAD family hydrolase', 147, NULL, NULL, 32391),
(32392, '3.40.50.150-FF-001619', NULL, NULL, 247, NULL, NULL, 32392),
(32393, '3.30.420.10-FF-000045', NULL, '3''-5'' exonuclease DinG', 172, NULL, NULL, 32393),
(32394, '3.40.630.30-FF-000503', NULL, 'Spore associated protein, sapd', 158, NULL, NULL, 32394);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(32395, '1.10.472.80-FF-000102', NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', 147, NULL, NULL, 32395),
(32396, '1.25.40.20-FF-000795', NULL, 'Lethal (2) 35Be', 79, NULL, NULL, 32396),
(32397, '3.40.1050.10-FF-000019', NULL, 'Carbonic anhydrase', 171, NULL, NULL, 32397),
(32398, '1.10.260.170-FF-000011', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', 154, NULL, NULL, 32398),
(32399, '3.20.20.80-FF-000098', NULL, 'Beta-galactosidase', 320, NULL, NULL, 32399),
(32400, '1.10.3080.10-FF-000030', NULL, 'Chloride channel protein', 509, NULL, NULL, 32400),
(32401, '2.130.10.10-FF-002176', NULL, 'Hybrid sensor histidine kinase/response regulator', 312, NULL, NULL, 32401),
(32402, '1.25.40.10-FF-002023', NULL, 'Os01g0913400 protein', 72, NULL, NULL, 32402),
(32403, '3.40.50.1220-FF-000040', NULL, '3D-(3,5/4)-trihydroxycyclohexane-1,2-dione hydrolase', 171, NULL, NULL, 32403),
(32404, '3.40.50.720-FF-002077', NULL, 'Uncharacterized protein', 145, NULL, NULL, 32404),
(32405, '1.10.472.10-FF-000413', NULL, 'Cyclin domain-containing protein', 99, NULL, NULL, 32405),
(32406, '3.30.70.330-FF-002551', NULL, NULL, 28, NULL, NULL, 32406),
(32407, '2.60.40.10-FF-000074', NULL, 'Recombining binding protein suppressor of hairless, putative', 94, NULL, NULL, 32407),
(32408, '3.60.10.10-FF-000232', NULL, 'Inositol 5-phosphatase 4', 375, NULL, NULL, 32408),
(32409, '1.10.3520.10-FF-000014', NULL, 'Putative Glycolipid transfer protein', 179, NULL, NULL, 32409),
(32410, '1.10.540.10-FF-000055', NULL, 'FMNH2-dependent monooxygenase', 118, NULL, NULL, 32410),
(32411, '1.25.10.10-FF-000341', NULL, 'RING-type E3 ubiquitin transferase', 103, NULL, NULL, 32411),
(32412, '3.30.540.10-FF-000099', NULL, 'Uncharacterized protein', 98, NULL, NULL, 32412),
(32413, '3.40.605.10-FF-000080', NULL, 'CoA-acylating methylmalonate-semialdehyde dehydrogenase', 249, NULL, NULL, 32413),
(32414, '1.10.10.10-FF-000166', NULL, '40S ribosomal protein S25', 84, NULL, NULL, 32414),
(32415, '3.40.50.300-FF-006072', NULL, 'Uncharacterized protein', 208, NULL, NULL, 32415),
(32416, '1.50.40.10-FF-000374', NULL, 'Mitochondrial folate carrier protein Flx1', 123, NULL, NULL, 32416),
(32417, '2.160.20.10-FF-000129', NULL, 'GD20755', 87, NULL, NULL, 32417),
(32418, '2.130.10.10-FF-004997', NULL, 'Uncharacterized protein', 66, NULL, NULL, 32418),
(32419, '2.60.120.260-FF-000557', NULL, 'Putative secreted beta-galactosidase', 48, NULL, NULL, 32419),
(32420, '1.20.1410.10-FF-000003', NULL, 'Transmembrane protein 98', 161, NULL, NULL, 32420),
(32421, '2.30.110.10-FF-000060', NULL, 'PPOX class F420-dependent enzyme', 124, NULL, NULL, 32421),
(32422, '1.20.120.350-FF-000032', NULL, 'Sodium leak channel non-selective protein', 117, NULL, NULL, 32422),
(32423, '3.90.190.10-FF-000570', NULL, 'Uncharacterized protein', 39, NULL, NULL, 32423),
(32424, '3.30.310.130-FF-000017', NULL, 'Uncharacterized protein', 98, NULL, NULL, 32424),
(32425, '3.30.200.40-FF-000009', NULL, 'Uncharacterized protein', 98, NULL, NULL, 32425),
(32426, '1.25.40.10-FF-004440', NULL, 'Uncharacterized protein', 245, NULL, NULL, 32426),
(32427, '3.40.50.1240-FF-000102', NULL, 'PE-PGRS family protein PE_PGRS11', 96, NULL, NULL, 32427),
(32428, '1.10.287.10-FF-000050', NULL, 'Predicted protein', 52, NULL, NULL, 32428),
(32429, '3.40.50.300-FF-003250', NULL, 'Midasin', 173, NULL, NULL, 32429),
(32430, '1.10.238.10-FF-000206', NULL, 'Calcium dependent mitochondrial carrier protein', 163, NULL, NULL, 32430),
(32431, '3.10.310.10-FF-000053', NULL, 'Diaminopimelate epimerase', 155, NULL, NULL, 32431),
(32432, '1.10.10.10-FF-001526', NULL, 'Cullin 1, putative', 101, NULL, NULL, 32432),
(32433, '3.10.20.230-FF-000008', NULL, 'retinitis pigmentosa 1-like 1 protein', 97, NULL, NULL, 32433),
(32434, '2.60.120.590-FF-000077', NULL, 'Uncharacterized protein', 223, NULL, NULL, 32434),
(32435, '3.40.50.1220-FF-000091', NULL, 'Branched-chain alpha-ketoacid decarboxylase', 163, NULL, NULL, 32435),
(32436, '1.10.1040.10-FF-000061', NULL, '3-hydroxyacyl-CoA dehydrogenase', 89, NULL, NULL, 32436);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(32437, '3.90.70.10-FF-000206', NULL, 'Uncharacterized protein', 389, NULL, NULL, 32437),
(32438, '2.130.10.10-FF-003429', NULL, 'YALI0E33774p', 161, NULL, NULL, 32438),
(32439, '1.20.1250.20-FF-000274', NULL, 'Solute carrier family 43 member 1', 471, NULL, NULL, 32439),
(32440, '1.10.533.10-FF-000090', NULL, 'Caspase recruitment domain family member 8', 118, NULL, NULL, 32440),
(32441, '2.60.120.10-FF-000019', NULL, 'rap guanine nucleotide exchange factor 6 isoform X1', 127, NULL, NULL, 32441),
(32442, '1.10.1420.10-FF-000051', NULL, 'Msh4p', 185, NULL, NULL, 32442),
(32443, '1.10.472.10-FF-000357', NULL, 'Uncharacterized protein', 131, NULL, NULL, 32443),
(32444, '3.40.630.30-FF-000447', NULL, 'Orf14', 339, NULL, NULL, 32444),
(32445, '2.30.29.30-FF-000077', NULL, 'Arf-GAP with GTPase, ANK repeat and PH domain-containing protein 1', 79, NULL, NULL, 32445),
(32446, '3.30.470.20-FF-000164', NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', 218, NULL, NULL, 32446),
(32447, '3.30.160.60-FF-003485', NULL, 'Zgc:174574', 23, NULL, NULL, 32447),
(32448, '3.30.40.10-FF-001320', NULL, 'Zinc finger domain containing protein', 104, NULL, NULL, 32448),
(32449, '3.40.1310.20-FF-000003', NULL, 'Rep protein', 112, NULL, NULL, 32449),
(32450, '2.40.50.150-FF-000010', NULL, 'DNA-directed RNA polymerase subunit beta', 129, NULL, NULL, 32450),
(32451, '2.40.128.20-FF-000016', NULL, 'Metal-binding protein ZinT', 193, NULL, NULL, 32451),
(32452, '2.30.42.10-FF-000652', NULL, NULL, 128, NULL, NULL, 32452),
(32453, '3.20.20.70-FF-000325', NULL, 'Radical SAM domain protein', 339, NULL, NULL, 32453),
(32454, '3.40.50.200-FF-000084', NULL, 'Serine protease', 351, NULL, NULL, 32454),
(32455, '3.80.10.10-FF-000861', NULL, 'Disease resistance protein (CC-NBS-LRR class) family', 169, NULL, NULL, 32455),
(32456, '3.90.150.10-FF-000005', NULL, 'Variant surface glycoprotein (VSG), putative', 193, NULL, NULL, 32456),
(32457, '2.120.10.30-FF-000018', NULL, 'Low-density lipoprotein receptor-related protein 1', 337, NULL, NULL, 32457),
(32458, '3.90.230.10-FF-000006', NULL, 'Xaa-Pro dipeptidase', 283, NULL, NULL, 32458),
(32459, '3.40.630.30-FF-000559', NULL, 'Uncharacterized protein', 126, NULL, NULL, 32459),
(32460, '3.30.70.330-FF-000078', NULL, 'serine/arginine-rich splicing factor 7 isoform X1', 80, NULL, NULL, 32460),
(32461, '3.30.160.60-FF-003373', NULL, 'Zinc finger protein 296', 42, NULL, NULL, 32461),
(32462, '3.30.70.1350-FF-000025', NULL, 'Cation-efflux pump FieF protein', 76, NULL, NULL, 32462),
(32463, '3.30.230.10-FF-000289', NULL, 'MutL DNA mismatch repair protein', 148, NULL, NULL, 32463),
(32464, '3.10.20.90-FF-000416', NULL, 'UBX domain protein 11', 114, NULL, NULL, 32464),
(32465, '1.10.1520.10-FF-000047', NULL, 'RNase III, putative', 157, NULL, NULL, 32465),
(32466, '2.60.120.970-FF-000039', NULL, 'Protein screw', 237, NULL, NULL, 32466),
(32467, '3.10.20.90-FF-000528', NULL, 'Auxin-responsive protein', 68, NULL, NULL, 32467),
(32468, '3.60.10.10-FF-000176', NULL, 'Protein angel homolog 1-like Protein', 343, NULL, NULL, 32468),
(32469, '3.90.70.10-FF-000257', NULL, 'Uncharacterized protein', 301, NULL, NULL, 32469),
(32470, '3.10.150.10-FF-000006', NULL, 'Proliferating cell nuclear antigen', 96, NULL, NULL, 32470),
(32471, '2.60.120.260-FF-000506', NULL, 'Uncharacterized protein', 73, NULL, NULL, 32471),
(32472, '3.30.2020.30-FF-000032', NULL, 'Trimethyllysine dioxygenase, putative', 69, NULL, NULL, 32472),
(32473, '3.40.50.2300-FF-000780', NULL, NULL, 132, NULL, NULL, 32473),
(32474, '2.60.420.10-FF-000008', NULL, 'Cellobionic acid phosphorylase', 77, NULL, NULL, 32474),
(32475, '2.60.120.10-FF-000082', NULL, 'Mannose-6-phosphate isomerase, class I', 230, NULL, NULL, 32475),
(32476, '4.10.280.50-FF-000001', NULL, 'Glutamate decarboxylase', 63, NULL, NULL, 32476),
(32477, '1.20.1330.10-FF-000002', NULL, 'Flagellin', 182, NULL, NULL, 32477),
(32478, '2.10.25.10-FF-001485', NULL, 'Cadherin, EGF LAG seven-pass G-type receptor 3', 38, NULL, NULL, 32478),
(32479, '4.10.240.10-FF-000178', NULL, 'Zcf32p', 87, NULL, NULL, 32479);
INSERT INTO "PUBLIC"."MODEL" VALUES
(32480, '2.60.40.3510-FF-000009', NULL, 'Delta-like protein', 59, NULL, NULL, 32480),
(32481, '3.55.40.20-FF-000019', NULL, 'Superoxide dismutase [Fe]', 120, NULL, NULL, 32481),
(32482, '2.60.40.10-FF-003833', NULL, NULL, 103, NULL, NULL, 32482),
(32483, '2.30.130.10-FF-000004', NULL, 'tRNA pseudouridine synthase B', 65, NULL, NULL, 32483),
(32484, '1.20.58.60-FF-000077', NULL, 'dystonin isoform X1', 110, NULL, NULL, 32484),
(32485, '3.30.260.10-FF-000066', NULL, NULL, 103, NULL, NULL, 32485),
(32486, '3.80.10.10-FF-002311', NULL, 'Uncharacterized protein', 169, NULL, NULL, 32486),
(32487, '3.40.50.10580-FF-000008', NULL, 'V-type ATP synthase subunit F', 98, NULL, NULL, 32487),
(32488, '2.60.120.290-FF-000049', NULL, 'Uncharacterized protein, isoform B', 114, NULL, NULL, 32488),
(32489, '3.90.1150.10-FF-000448', NULL, 'Kynureninase', 148, NULL, NULL, 32489),
(32490, '3.90.550.10-FF-000502', NULL, 'Chromosome 10, whole genome shotgun sequence', 269, NULL, NULL, 32490),
(32491, '3.30.160.60-FF-003434', NULL, 'Zinc finger protein 206', 37, NULL, NULL, 32491),
(32492, '3.40.50.300-FF-006009', NULL, 'UVRD/Rep like helicase', 93, NULL, NULL, 32492),
(32493, '3.30.160.60-FF-000523', NULL, 'Zinc finger protein WIP2', 83, NULL, NULL, 32493),
(32494, '2.40.128.80-FF-000006', NULL, 'Cathepsin C', 120, NULL, NULL, 32494),
(32495, '2.60.120.590-FF-000021', NULL, '2OG-Fe(II) oxygenase superfamily, putative', 210, NULL, NULL, 32495),
(32496, '2.20.25.10-FF-000091', NULL, 'DNA-directed RNA polymerase subunit', 68, NULL, NULL, 32496),
(32497, '3.30.470.20-FF-000113', NULL, 'Glutathione synthetase', 30, NULL, NULL, 32497),
(32498, '2.40.50.140-FF-000524', NULL, '30S ribosomal protein S1', 79, NULL, NULL, 32498),
(32499, '1.10.20.10-FF-000043', NULL, 'Histone H2B', 121, NULL, NULL, 32499),
(32500, '1.20.272.10-FF-000031', NULL, 'replication factor C subunit 2', 93, NULL, NULL, 32500),
(32501, '1.25.10.10-FF-002139', NULL, 'Uncharacterized protein', 561, NULL, NULL, 32501),
(32502, '3.40.630.30-FF-000508', NULL, 'Histone acetyltransferase', 107, NULL, NULL, 32502),
(32503, '1.20.120.140-FF-000031', NULL, 'Cell division protein FtsY homolog chloroplastic', 54, NULL, NULL, 32503),
(32504, '3.40.50.150-FF-000203', NULL, 'Alkylated DNA repair protein alkB 8', 218, NULL, NULL, 32504),
(32505, '1.20.120.160-FF-000037', NULL, 'Histidine-containing phosphotransfer protein 5', 62, NULL, NULL, 32505),
(32506, '1.10.287.70-FF-000332', NULL, 'TWiK family of potassium channels protein 12', 308, NULL, NULL, 32506),
(32507, '3.20.90.10-FF-000008', NULL, NULL, 221, NULL, NULL, 32507),
(32508, '3.30.50.10-FF-000096', NULL, 'Uncharacterized protein', 44, NULL, NULL, 32508),
(32509, '1.10.472.10-FF-000301', NULL, 'Cyclin G-like protein', 122, NULL, NULL, 32509),
(32510, '2.40.128.20-FF-000067', NULL, 'Api5 protein', 49, NULL, NULL, 32510),
(32511, '3.40.190.10-FF-000305', NULL, 'D-methionine-binding lipoprotein MetQ', 106, NULL, NULL, 32511),
(32512, '3.40.532.10-FF-000011', NULL, 'Deubiquinating/deneddylating enzyme', 233, NULL, NULL, 32512),
(32513, '3.40.1230.10-FF-000005', NULL, 'NADH dehydrogenase [ubiquinone]alpha subcomplex assembly factor', 140, NULL, NULL, 32513),
(32514, '1.10.150.80-FF-000012', NULL, 'Exosome complex exonuclease RRP6', 82, NULL, NULL, 32514),
(32515, '1.10.510.10-FF-000306', NULL, 'Serine/threonine protein kinase', 177, NULL, NULL, 32515),
(32516, '2.40.30.10-FF-000175', NULL, 'Elongation factor G, mitochondrial', 130, NULL, NULL, 32516),
(32517, '1.25.60.10-FF-000001', NULL, 'Magnesium transporter MgtE', 127, NULL, NULL, 32517),
(32518, '3.30.160.60-FF-001809', NULL, 'dnaJ homolog subfamily C member 21 isoform X1', 57, NULL, NULL, 32518),
(32519, '3.30.420.10-FF-000068', NULL, 'Exonuclease domain-containing protein 1', 223, NULL, NULL, 32519),
(32520, '2.40.50.90-FF-000104', NULL, 'Tudor domain containing protein', 142, NULL, NULL, 32520),
(32521, '3.60.21.10-FF-000488', NULL, 'Protein CBG23770', 136, NULL, NULL, 32521),
(32522, '2.30.29.30-FF-000526', NULL, 'Rho GTPase-activating protein', 122, NULL, NULL, 32522);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(32523, '3.30.70.330-FF-002899', NULL, NULL, 49, NULL, NULL, 32523),
(32524, '3.30.230.80-FF-000001', NULL, 'Heat shock protein 90 alpha', 169, NULL, NULL, 32524),
(32525, '1.20.120.1630-FF-000035', NULL, '3-oxo-5-alpha-steroid 4-dehydrogenase family protein', 152, NULL, NULL, 32525),
(32526, '3.30.1370.10-FF-000169', NULL, 'Protein CBR-NUO-2', 70, NULL, NULL, 32526),
(32527, '1.10.238.10-FF-001218', NULL, 'Putative calmodulin', 149, NULL, NULL, 32527),
(32528, '3.40.50.1000-FF-000266', NULL, 'PROBABLE PHOSPHATASE', 99, NULL, NULL, 32528),
(32529, '3.30.260.10-FF-000061', NULL, NULL, 19, NULL, NULL, 32529),
(32530, '1.10.8.60-FF-000005', NULL, '26S protease regulatory subunit 7', 72, NULL, NULL, 32530),
(32531, '2.60.120.10-FF-000531', NULL, 'MBL fold metallo-hydrolase', 121, NULL, NULL, 32531),
(32532, '3.40.50.10140-FF-000051', NULL, 'Uncharacterized protein', 173, NULL, NULL, 32532),
(32533, '3.40.50.620-FF-000248', NULL, 'Nicotinate (Nicotinamide) nucleotide adenylyltransferase', 204, NULL, NULL, 32533),
(32534, '3.30.200.20-FF-001139', NULL, 'Protein kinase-like', 76, NULL, NULL, 32534),
(32535, '3.90.226.10-FF-000176', NULL, 'Glycine hydroxymethyltransferase', 105, NULL, NULL, 32535),
(32536, '3.30.70.330-FF-002955', NULL, NULL, 105, NULL, NULL, 32536),
(32537, '1.25.10.10-FF-000689', NULL, 'HECT ubiquitin protein ligase family protein KAK', 308, NULL, NULL, 32537),
(32538, '1.20.1250.20-FF-001527', NULL, 'Uncharacterized protein', 459, NULL, NULL, 32538),
(32539, '1.25.40.20-FF-001284', NULL, 'Uncharacterized protein', 174, NULL, NULL, 32539),
(32540, '1.10.10.60-FF-001108', NULL, NULL, 66, NULL, NULL, 32540),
(32541, '2.30.29.30-FF-000818', NULL, 'Ankyrin repeat-containing protein kinase A', 111, NULL, NULL, 32541),
(32542, '3.90.226.10-FF-000232', NULL, 'Uncharacterized protein', 180, NULL, NULL, 32542),
(32543, '3.30.160.60-FF-001012', NULL, 'Zinc finger protein 236', 82, NULL, NULL, 32543),
(32544, '3.30.200.20-FF-001870', NULL, 'Serine/threonine-protein kinase RIO3', 106, NULL, NULL, 32544),
(32545, '2.20.28.10-FF-000018', NULL, 'Rubrerythrin', 45, NULL, NULL, 32545),
(32546, '2.60.40.3960-FF-000003', NULL, 'VeA-like protein', 144, NULL, NULL, 32546),
(32547, '3.30.200.40-FF-000004', NULL, 'mRNA decapping hydrolase, putative', 109, NULL, NULL, 32547),
(32548, '3.60.21.60-FF-000019', NULL, 'DNA polymerase alpha subunit B', 107, NULL, NULL, 32548),
(32549, '1.25.40.10-FF-003080', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 180, NULL, NULL, 32549),
(32550, '2.40.10.10-FF-000409', NULL, NULL, 58, NULL, NULL, 32550),
(32551, '3.40.50.2020-FF-000004', NULL, 'Adenine phosphoribosyltransferase', 176, NULL, NULL, 32551),
(32552, '4.10.410.10-FF-000006', NULL, 'Serine peptidase inhibitor, Kunitz type 1', 63, NULL, NULL, 32552),
(32553, '3.40.50.261-FF-000001', NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta', 148, NULL, NULL, 32553),
(32554, '2.60.120.10-FF-000823', NULL, 'Uncharacterized protein', 72, NULL, NULL, 32554),
(32555, '3.90.80.10-FF-000027', NULL, 'Inorganic pyrophosphatase', 251, NULL, NULL, 32555),
(32556, '3.40.50.300-FF-002979', NULL, 'Chromosome 16, whole genome shotgun sequence', 254, NULL, NULL, 32556),
(32557, '1.10.630.10-FF-000793', NULL, 'Uncharacterized protein', 104, NULL, NULL, 32557),
(32558, '2.130.10.10-FF-001743', NULL, 'Protein RIC1 like', 382, NULL, NULL, 32558),
(32559, '2.130.10.10-FF-005054', NULL, 'Uncharacterized protein', 279, NULL, NULL, 32559),
(32560, '1.25.10.10-FF-001690', NULL, 'Nucleotide exchange factor SIL1', 283, NULL, NULL, 32560),
(32561, '3.40.1190.10-FF-000024', NULL, 'Folylpolyglutamate synthase', 296, NULL, NULL, 32561),
(32562, '3.90.70.10-FF-000201', NULL, 'Unplaced genomic scaffold supercont1.208, whole genome shotgun sequence', 385, NULL, NULL, 32562),
(32563, '1.10.150.20-FF-000028', NULL, 'activating signal cointegrator 1 complex subunit 3', 54, NULL, NULL, 32563),
(32564, '3.30.70.1730-FF-000055', NULL, 'mRNA turnover protein 4 mrt4, putative', 57, NULL, NULL, 32564),
(32565, '1.20.810.10-FF-000001', NULL, 'Cytochrome b6', 215, NULL, NULL, 32565);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(32566, '3.90.1750.20-FF-000002', NULL, 'Putative integrase [Bacteriophage A118]', 124, NULL, NULL, 32566),
(32567, '3.30.1390.30-FF-000002', NULL, 'Penicillin-binding protein 2', 80, NULL, NULL, 32567),
(32568, '3.40.33.10-FF-000106', NULL, 'GM23776', 226, NULL, NULL, 32568),
(32569, '1.20.272.10-FF-000087', NULL, NULL, 100, NULL, NULL, 32569),
(32570, '1.10.10.10-FF-000110', NULL, 'DNA-binding response regulator RegX3', 106, NULL, NULL, 32570),
(32571, '1.25.10.10-FF-000397', NULL, 'sterile alpha and TIR motif-containing protein 1', 307, NULL, NULL, 32571),
(32572, '3.40.50.300-FF-003255', NULL, 'Pilus assembly protein CpaE', 238, NULL, NULL, 32572),
(32573, '3.90.15.10-FF-000017', NULL, 'Protease Do-like 2 chloroplastic', 61, NULL, NULL, 32573),
(32574, '2.10.110.10-FF-000159', NULL, 'Lrg1p', 80, NULL, NULL, 32574),
(32575, '3.30.110.20-FF-000019', NULL, 'Ribonuclease P/MRP protein subunit', 148, NULL, NULL, 32575),
(32576, '1.25.40.10-FF-001478', NULL, 'Os01g0263600 protein', 102, NULL, NULL, 32576),
(32577, '1.20.5.110-FF-000225', NULL, 'Uncharacterized protein', 108, NULL, NULL, 32577),
(32578, '2.40.30.10-FF-000231', NULL, '(methionine synthase) reductase', 70, NULL, NULL, 32578),
(32579, '2.30.29.70-FF-000010', NULL, 'Uncharacterized protein', 110, NULL, NULL, 32579),
(32580, '2.40.10.240-FF-000012', NULL, NULL, 101, NULL, NULL, 32580),
(32581, '2.60.40.1180-FF-000012', NULL, '4F2 cell-surface antigen heavy chain', 91, NULL, NULL, 32581),
(32582, '1.20.1250.20-FF-001634', NULL, 'Sucrose transport protein SUC4', 101, NULL, NULL, 32582),
(32583, '2.30.42.10-FF-000096', NULL, 'PDZ domain-containing protein 11', 96, NULL, NULL, 32583),
(32584, '3.30.160.60-FF-005290', NULL, NULL, 79, NULL, NULL, 32584),
(32585, '3.60.21.10-FF-000437', NULL, 'Uncharacterized protein', 232, NULL, NULL, 32585),
(32586, '1.10.3090.10-FF-000036', NULL, 'Uncharacterized protein', 139, NULL, NULL, 32586),
(32587, '3.20.20.80-FF-000603', NULL, 'Heparanase-like protein 3', 187, NULL, NULL, 32587),
(32588, '3.30.260.10-FF-000010', NULL, 'T-complex protein 1 subunit gamma', 109, NULL, NULL, 32588),
(32589, '3.30.420.40-FF-001009', NULL, 'Uncharacterized protein', 62, NULL, NULL, 32589),
(32590, '1.10.238.10-FF-001263', NULL, 'Phosphatidylserine decarboxylase proenzyme 3', 57, NULL, NULL, 32590),
(32591, '3.40.630.10-FF-000497', NULL, 'Uncharacterized protein', 107, NULL, NULL, 32591),
(32592, '1.20.1270.60-FF-000057', NULL, 'Rho guanine nucleotide exchange factor 37', 214, NULL, NULL, 32592),
(32593, '3.10.450.40-FF-000038', NULL, NULL, 91, NULL, NULL, 32593),
(32594, '2.170.270.10-FF-000032', NULL, 'PR domain containing 14', 158, NULL, NULL, 32594),
(32595, '3.40.50.720-FF-000508', NULL, 'UDP-glucose 4-epimerase', 201, NULL, NULL, 32595),
(32596, '2.10.25.10-FF-001541', NULL, 'Predicted protein', 44, NULL, NULL, 32596),
(32597, '3.40.50.150-FF-000315', NULL, 'Methyltransferase protein 9', 181, NULL, NULL, 32597),
(32598, '3.30.300.180-FF-000007', NULL, 'Chromosomal replication initiator protein DnaA', 99, NULL, NULL, 32598),
(32599, '3.30.110.110-FF-000011', NULL, 'Double-strand break repair protein', 89, NULL, NULL, 32599),
(32600, '1.25.10.10-FF-000402', NULL, 'Related to importin beta-2 subunit (Transportin)', 560, NULL, NULL, 32600),
(32601, '2.60.40.150-FF-000251', NULL, 'Protein kinase C', 123, NULL, NULL, 32601),
(32602, '2.60.40.10-FF-005357', NULL, NULL, 66, NULL, NULL, 32602),
(32603, '2.40.10.10-FF-000180', NULL, 'IP09419p', 102, NULL, NULL, 32603),
(32604, '3.40.850.10-FF-000328', NULL, 'Kinesin-like protein', 405, NULL, NULL, 32604),
(32605, '3.15.10.10-FF-000022', NULL, 'Phospholipid transfer protein', 83, NULL, NULL, 32605),
(32606, '3.40.1110.10-FF-000137', NULL, 'Heavy metal translocatin', 84, NULL, NULL, 32606),
(32607, '2.90.10.10-FF-000031', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase LECRK1', 129, NULL, NULL, 32607),
(32608, '3.20.20.450-FF-000016', NULL, 'Bifunctional diguanylate cyclase/phosphodiesterase', 257, NULL, NULL, 32608),
(32609, '1.20.272.10-FF-000036', NULL, 'replication factor C familiy protein', 98, NULL, NULL, 32609);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(32610, '2.60.120.290-FF-000105', NULL, 'Uncharacterized protein, isoform A', 120, NULL, NULL, 32610),
(32611, '1.20.1160.20-FF-000008', NULL, 'whirlin isoform X8', 80, NULL, NULL, 32611),
(32612, '3.30.310.80-FF-000035', NULL, 'Non-specific serine/threonine protein kinase', 97, NULL, NULL, 32612),
(32613, '3.40.50.300-FF-005048', NULL, 'Predicted protein', 82, NULL, NULL, 32613),
(32614, '3.40.50.1820-FF-000629', NULL, 'WGS project CABT00000000 data, contig 2.92', 218, NULL, NULL, 32614),
(32615, '2.130.10.10-FF-000782', NULL, 'Autophagy-related protein 18h', 436, NULL, NULL, 32615),
(32616, '2.130.10.10-FF-004093', NULL, 'Protein HIRA', 198, NULL, NULL, 32616),
(32617, '3.80.10.10-FF-001799', NULL, 'DNA-damage repair/toleration 100', 114, NULL, NULL, 32617),
(32618, '1.20.1250.20-FF-001235', NULL, 'Uncharacterized protein', 339, NULL, NULL, 32618),
(32619, '2.30.30.140-FF-000073', NULL, 'ATP-dependent RNA helicase TDRD9', 69, NULL, NULL, 32619),
(32620, '2.40.50.140-FF-000529', NULL, 'Cell division control protein 21', 105, NULL, NULL, 32620),
(32621, '3.30.300.160-FF-000001', NULL, 'Bacteriophage N4 adsorption protein B', 77, NULL, NULL, 32621),
(32622, '1.10.418.10-FF-000243', NULL, 'Uncharacterized protein', 116, NULL, NULL, 32622),
(32623, '3.50.50.60-FF-000368', NULL, 'Probable flavin-containing monoamine oxidase aofH', 181, NULL, NULL, 32623),
(32624, '3.30.1120.90-FF-000006', NULL, 'Nucleosome assembly protein', 146, NULL, NULL, 32624),
(32625, '3.30.420.610-FF-000017', NULL, 'Tudor domain-containing protein 5', 70, NULL, NULL, 32625),
(32626, '2.30.29.30-FF-000133', NULL, 'myosin phosphatase Rho-interacting protein isoform X1', 105, NULL, NULL, 32626),
(32627, '3.30.160.60-FF-005851', NULL, NULL, 72, NULL, NULL, 32627),
(32628, '3.40.50.300-FF-003199', NULL, 'ATPase family associated with various cellular activities (AAA), putative', 163, NULL, NULL, 32628),
(32629, '2.10.25.10-FF-000973', NULL, 'Transmembrane cell adhesion receptor mua-3', 46, NULL, NULL, 32629),
(32630, '2.60.40.60-FF-001061', NULL, 'Uncharacterized protein', 69, NULL, NULL, 32630),
(32631, '1.10.510.10-FF-002200', NULL, 'Predicted protein', 270, NULL, NULL, 32631),
(32632, '3.40.50.2020-FF-000055', NULL, 'Ribose-phosphate pyrophosphokinase', 142, NULL, NULL, 32632),
(32633, '2.130.10.10-FF-000490', NULL, 'Kinesin family member 21B', 149, NULL, NULL, 32633),
(32634, '2.30.29.30-FF-000869', NULL, 'Bud site selection protein 4 homolog', 126, NULL, NULL, 32634),
(32635, '3.30.1680.10-FF-000002', NULL, 'Integrin beta', 60, NULL, NULL, 32635),
(32636, '1.50.40.10-FF-000430', NULL, 'Mitoferrin-like Protein', 179, NULL, NULL, 32636),
(32637, '1.25.40.10-FF-001534', NULL, 'Os01g0913400 protein', 220, NULL, NULL, 32637),
(32638, '1.10.10.60-FF-001260', NULL, NULL, 61, NULL, NULL, 32638),
(32639, '3.70.10.10-FF-000035', NULL, 'Cell cycle checkpoint control protein', 258, NULL, NULL, 32639),
(32640, '2.40.40.20-FF-000066', NULL, 'DNA-directed RNA polymerase subunit', 66, NULL, NULL, 32640),
(32641, '1.20.120.350-FF-000268', NULL, NULL, 102, NULL, NULL, 32641),
(32642, '2.130.10.10-FF-005161', NULL, 'Uncharacterized protein', 137, NULL, NULL, 32642),
(32643, '2.30.30.40-FF-000600', NULL, 'Uncharacterized protein', 58, NULL, NULL, 32643),
(32644, '3.40.33.10-FF-000090', NULL, 'Uncharacterized protein', 174, NULL, NULL, 32644),
(32645, '3.10.110.10-FF-000009', NULL, 'Ubiquitin-conjugating enzyme E2 R2', 181, NULL, NULL, 32645),
(32646, '2.30.29.170-FF-000029', NULL, NULL, 79, NULL, NULL, 32646),
(32647, '3.80.10.10-FF-001243', NULL, 'Si:dkey-286j17.4', 170, NULL, NULL, 32647),
(32648, '3.30.160.60-FF-003777', NULL, NULL, 28, NULL, NULL, 32648),
(32649, '1.25.40.10-FF-005188', NULL, 'Uncharacterized protein', 235, NULL, NULL, 32649),
(32650, '3.40.50.300-FF-005560', NULL, 'Snf2 family helicase', 240, NULL, NULL, 32650),
(32651, '3.90.230.10-FF-000051', NULL, NULL, 232, NULL, NULL, 32651),
(32652, '2.60.120.260-FF-000613', NULL, 'Uncharacterized protein', 138, NULL, NULL, 32652),
(32653, '3.90.640.90-FF-000010', NULL, 'BTG family member 2', 126, NULL, NULL, 32653);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(32654, '4.10.400.10-FF-000129', NULL, 'Complement factor I', 32, NULL, NULL, 32654),
(32655, '1.25.40.10-FF-002708', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 100, NULL, NULL, 32655),
(32656, '3.20.20.150-FF-000084', NULL, 'Uncharacterized protein', 91, NULL, NULL, 32656),
(32657, '1.10.510.10-FF-001762', NULL, 'Protein kinase superfamily protein', 195, NULL, NULL, 32657),
(32658, '3.80.10.10-FF-003216', NULL, 'Uncharacterized protein', 209, NULL, NULL, 32658),
(32659, '3.30.1640.10-FF-000005', NULL, 'DNA helicase', 100, NULL, NULL, 32659),
(32660, '2.10.25.10-FF-000181', NULL, 'Delta-like protein', 36, NULL, NULL, 32660),
(32661, '2.60.120.680-FF-000003', NULL, 'SEC14-like lipid binding 1', 117, NULL, NULL, 32661),
(32662, '3.40.1370.10-FF-000010', NULL, '50S ribosomal protein L4', 205, NULL, NULL, 32662),
(32663, '2.60.300.12-FF-000019', NULL, 'Iron-sulfur assembly protein 1, putative', 140, NULL, NULL, 32663),
(32664, '3.20.20.80-FF-000042', NULL, 'Klotho', 463, NULL, NULL, 32664),
(32665, '1.10.10.10-FF-000722', NULL, 'Topoisomerase, putative', 88, NULL, NULL, 32665),
(32666, '1.10.418.10-FF-000187', NULL, 'Uncharacterized protein', 114, NULL, NULL, 32666),
(32667, '1.10.287.70-FF-000276', NULL, 'Ion transport protein', 151, NULL, NULL, 32667),
(32668, '1.20.1560.10-FF-000334', NULL, 'ABC transporter B family member 2', 139, NULL, NULL, 32668),
(32669, '1.20.5.750-FF-000001', NULL, 'Moricin', 42, NULL, NULL, 32669),
(32670, '2.60.40.2030-FF-000037', NULL, 'Adhesion G protein-coupled receptor V1', 124, NULL, NULL, 32670),
(32671, '1.10.472.80-FF-000176', NULL, NULL, 60, NULL, NULL, 32671),
(32672, '2.70.170.10-FF-000032', NULL, 'Uncharacterized protein, isoform B', 217, NULL, NULL, 32672),
(32673, '2.30.29.30-FF-000925', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', 62, NULL, NULL, 32673),
(32674, '3.30.450.20-FF-000550', NULL, 'Nitrogen regulation protein ntrY', 117, NULL, NULL, 32674),
(32675, '4.10.280.10-FF-000124', NULL, 'transcription factor AP-4 isoform X3', 60, NULL, NULL, 32675),
(32676, '3.40.20.10-FF-000172', NULL, 'Actin-depolymerizing factor 1, isoforms a/b', 156, NULL, NULL, 32676),
(32677, '3.30.460.10-FF-000065', NULL, 'DNA polymerase mu', 76, NULL, NULL, 32677),
(32678, '1.20.5.120-FF-000009', NULL, NULL, 49, NULL, NULL, 32678),
(32679, '2.130.10.10-FF-004885', NULL, 'Uncharacterized protein', 118, NULL, NULL, 32679),
(32680, '3.30.710.10-FF-000264', NULL, 'BTB domain-containing protein', 115, NULL, NULL, 32680),
(32681, '3.60.20.30-FF-000008', NULL, 'N-terminal nucleophile aminohydrolase', 165, NULL, NULL, 32681),
(32682, '3.30.70.360-FF-000025', NULL, 'Peptidase M20', 171, NULL, NULL, 32682),
(32683, '1.10.8.60-FF-000056', NULL, 'Katanin p60 ATPase-containing subunit A-like 2', 89, NULL, NULL, 32683),
(32684, '2.60.40.10-FF-000130', NULL, 'Hemicentin 1', 94, NULL, NULL, 32684),
(32685, '3.30.160.60-FF-004738', NULL, NULL, 28, NULL, NULL, 32685),
(32686, '1.25.10.10-FF-001706', NULL, 'Uncharacterized protein', 246, NULL, NULL, 32686),
(32687, '1.25.40.170-FF-000003', NULL, 'Sterile alpha motif domain-containing 4A', 111, NULL, NULL, 32687),
(32688, '1.10.10.10-FF-000161', NULL, 'Cullin 1', 64, NULL, NULL, 32688),
(32689, '3.30.70.330-FF-002556', NULL, NULL, 192, NULL, NULL, 32689),
(32690, '1.25.40.190-FF-000009', NULL, NULL, 137, NULL, NULL, 32690),
(32691, '3.90.70.10-FF-000549', NULL, 'Uncharacterized protein', 142, NULL, NULL, 32691),
(32692, '1.10.1740.10-FF-000030', NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', 83, NULL, NULL, 32692),
(32693, '3.10.130.10-FF-000011', NULL, 'Ribonuclease A family member k6', 109, NULL, NULL, 32693),
(32694, '3.30.160.60-FF-001517', NULL, 'zinc finger protein 333 isoform X2', 28, NULL, NULL, 32694),
(32695, '1.20.5.110-FF-000276', NULL, 'Uncharacterized protein', 54, NULL, NULL, 32695),
(32696, '3.40.50.300-FF-001518', NULL, 'Leucine-rich repeat kinase, isoform C', 112, NULL, NULL, 32696),
(32697, '2.40.50.140-FF-001081', NULL, NULL, 84, NULL, NULL, 32697),
(32698, '2.60.40.10-FF-004401', NULL, NULL, 125, NULL, NULL, 32698);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(32699, '3.40.640.10-FF-000503', NULL, 'Uncharacterized protein', 84, NULL, NULL, 32699),
(32700, '1.10.510.10-FF-002251', NULL, NULL, 213, NULL, NULL, 32700),
(32701, '3.30.2230.10-FF-000013', NULL, 'Ubiquitin carboxyl-terminal hydrolase cyk-3', 122, NULL, NULL, 32701),
(32702, '1.25.40.20-FF-001756', NULL, 'Homeobox protein Wariai', 197, NULL, NULL, 32702),
(32703, '1.20.5.100-FF-000003', NULL, 'Cytochrome c1, heme protein, mitochondrial', 45, NULL, NULL, 32703),
(32704, '1.10.8.60-FF-000528', NULL, 'Origin recognition complex subunit 1', 97, NULL, NULL, 32704),
(32705, '2.130.10.10-FF-001119', NULL, 'Polyadenylation factor I', 84, NULL, NULL, 32705),
(32706, '3.90.1150.10-FF-000504', NULL, 'Serine--pyruvate aminotransferase', 98, NULL, NULL, 32706),
(32707, '3.30.70.330-FF-000134', NULL, 'Nuclear and cytoplasmic polyadenylated rna-binding pub1', 100, NULL, NULL, 32707),
(32708, '1.10.20.10-FF-000335', NULL, NULL, 110, NULL, NULL, 32708),
(32709, '3.30.160.60-FF-002316', NULL, 'Zinc finger protein 114', 37, NULL, NULL, 32709),
(32710, '1.10.8.10-FF-000070', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 55, NULL, NULL, 32710),
(32711, '1.25.10.10-FF-000346', NULL, 'RING-type E3 ubiquitin transferase', 185, NULL, NULL, 32711),
(32712, '3.40.50.2000-FF-000734', NULL, '7-deoxyloganetic acid glucosyltransferase', 265, NULL, NULL, 32712),
(32713, '2.60.120.290-FF-000156', NULL, 'Kinesin-like protein', 118, NULL, NULL, 32713),
(32714, '3.40.800.20-FF-000042', NULL, 'Histone deacetylase-like protein HDO2', 375, NULL, NULL, 32714),
(32715, '3.40.50.2300-FF-001162', NULL, NULL, 184, NULL, NULL, 32715),
(32716, '2.10.25.10-FF-000029', NULL, 'neurexin-1 isoform X1', 41, NULL, NULL, 32716),
(32717, '3.30.160.60-FF-001916', NULL, 'Zinc finger protein 621', 28, NULL, NULL, 32717),
(32718, '3.30.200.20-FF-001291', NULL, 'Spore coat protein CotS', 88, NULL, NULL, 32718),
(32719, '2.40.30.170-FF-000068', NULL, NULL, 68, NULL, NULL, 32719),
(32720, '3.30.470.20-FF-000220', NULL, 'Uncharacterized protein', 34, NULL, NULL, 32720),
(32721, '2.130.10.10-FF-005846', NULL, 'Uncharacterized protein', 337, NULL, NULL, 32721),
(32722, '2.120.10.80-FF-000168', NULL, 'Kelch repeat-containing protein At3g27220', 243, NULL, NULL, 32722),
(32723, '2.60.120.200-FF-000298', NULL, 'Sialidase', 189, NULL, NULL, 32723),
(32724, '4.10.1240.10-FF-000023', NULL, 'Uncharacterized protein, isoform B', 98, NULL, NULL, 32724),
(32725, '3.40.366.10-FF-000023', NULL, 'Sterigmatocystin biosynthesis polyketide synthase', 166, NULL, NULL, 32725),
(32726, '2.130.10.10-FF-005110', NULL, 'Uncharacterized protein', 244, NULL, NULL, 32726),
(32727, '3.30.160.60-FF-005227', NULL, NULL, 31, NULL, NULL, 32727),
(32728, '1.10.486.10-FF-000063', NULL, 'UVRD/Rep like helicase', 203, NULL, NULL, 32728),
(32729, '3.40.50.2300-FF-000673', NULL, 'Uncharacterized protein', 317, NULL, NULL, 32729),
(32730, '3.40.1110.10-FF-000406', NULL, NULL, 69, NULL, NULL, 32730),
(32731, '3.40.50.720-FF-000571', NULL, 'Hydroxysteroid 17-beta dehydrogenase 11', 78, NULL, NULL, 32731),
(32732, '1.20.1250.20-FF-001578', NULL, 'Solute carrier organic anion transporter family member', 359, NULL, NULL, 32732),
(32733, '3.40.570.10-FF-000003', NULL, 'Nuclease EXOG, mitochondrial', 239, NULL, NULL, 32733),
(32734, '1.10.510.10-FF-003504', NULL, NULL, 255, NULL, NULL, 32734),
(32735, '2.40.128.270-FF-000002', NULL, 'Heat shock protein HslJ', 104, NULL, NULL, 32735),
(32736, '2.10.70.10-FF-000044', NULL, 'Complement component receptor type 1', 63, NULL, NULL, 32736),
(32737, '3.10.290.10-FF-000056', NULL, 'Hemolysin (Tly)', 58, NULL, NULL, 32737),
(32738, '1.20.58.60-FF-000526', NULL, 'Uncharacterized protein', 317, NULL, NULL, 32738),
(32739, '2.60.120.10-FF-000587', NULL, 'Transcriptional regulator LdrP', 110, NULL, NULL, 32739),
(32740, '1.20.1250.20-FF-000797', NULL, 'Uncharacterized protein, isoform A', 269, NULL, NULL, 32740),
(32741, '3.30.70.660-FF-000053', NULL, 'tRNA pseudouridine synthase', 140, NULL, NULL, 32741),
(32742, '2.60.120.10-FF-000643', NULL, 'Uncharacterized protein', 159, NULL, NULL, 32742);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(32743, '3.40.30.10-FF-000341', NULL, 'Glutathione S-transferase T1', 82, NULL, NULL, 32743),
(32744, '1.20.58.1370-FF-000005', NULL, NULL, 74, NULL, NULL, 32744),
(32745, '1.10.510.10-FF-003448', NULL, NULL, 277, NULL, NULL, 32745),
(32746, '1.10.10.60-FF-000372', NULL, 'Homeobox B3', 76, NULL, NULL, 32746),
(32747, '2.30.30.100-FF-000140', NULL, 'Probable U6 snRNA-associated Sm-like protein LSm4', 83, NULL, NULL, 32747),
(32748, '3.40.50.720-FF-000239', NULL, 'monofunctional C1-tetrahydrofolate synthase, mitochondrial isoform X1', 100, NULL, NULL, 32748),
(32749, '1.10.150.240-FF-000114', NULL, 'Protein containing Haloacid dehalogenase-like hydrolase domain protein', 69, NULL, NULL, 32749),
(32750, '1.20.58.390-FF-000045', NULL, 'neuronal acetylcholine receptor subunit alpha-10', 64, NULL, NULL, 32750),
(32751, '1.20.58.90-FF-000001', NULL, 'ralA-binding protein 1', 66, NULL, NULL, 32751),
(32752, '3.40.718.10-FF-000004', NULL, '3-isopropylmalate dehydrogenase', 364, NULL, NULL, 32752),
(32753, '1.25.40.10-FF-002259', NULL, 'TPR repeat', 132, NULL, NULL, 32753),
(32754, '3.30.70.330-FF-002787', NULL, NULL, 52, NULL, NULL, 32754),
(32755, '1.20.1070.10-FF-001207', NULL, 'Zgc:85942 protein', 94, NULL, NULL, 32755),
(32756, '1.20.1270.60-FF-000326', NULL, 'SH3-domain GRB2-like 3b', 60, NULL, NULL, 32756),
(32757, '3.30.70.330-FF-002843', NULL, NULL, 84, NULL, NULL, 32757),
(32758, '1.10.8.10-FF-000362', NULL, 'Uncharacterized protein', 65, NULL, NULL, 32758),
(32759, '1.20.1250.20-FF-000853', NULL, 'SLC (SoLute Carrier) homolog', 212, NULL, NULL, 32759),
(32760, '3.40.50.150-FF-001372', NULL, NULL, 178, NULL, NULL, 32760),
(32761, '2.30.39.10-FF-000077', NULL, 'Serpin 42De, isoform B', 147, NULL, NULL, 32761),
(32762, '3.10.100.10-FF-000003', NULL, 'Versican core protein', 127, NULL, NULL, 32762),
(32763, '1.25.40.10-FF-004389', NULL, 'Uncharacterized protein', 141, NULL, NULL, 32763),
(32764, '2.60.120.920-FF-000165', NULL, 'Uncharacterized protein', 124, NULL, NULL, 32764),
(32765, '1.10.390.10-FF-000077', NULL, 'Uncharacterized protein', 156, NULL, NULL, 32765),
(32766, '3.30.70.330-FF-001207', NULL, 'Polyadenylate-binding protein', 99, NULL, NULL, 32766),
(32767, '2.130.10.10-FF-002468', NULL, 'Plexin D1', 126, NULL, NULL, 32767),
(32768, '3.40.50.410-FF-000303', NULL, 'Uncharacterized protein', 159, NULL, NULL, 32768),
(32769, '3.30.60.20-FF-000144', NULL, 'Uncharacterized protein', 41, NULL, NULL, 32769),
(32770, '2.30.140.10-FF-000005', NULL, 'Spermine synthase', 56, NULL, NULL, 32770),
(32771, '2.30.30.190-FF-000003', NULL, 'dynactin subunit 1 isoform X1', 94, NULL, NULL, 32771),
(32772, '1.10.150.50-FF-000195', NULL, 'GA repeat binding protein alpha homolog isoform X1', 82, NULL, NULL, 32772),
(32773, '3.80.10.10-FF-001350', NULL, 'Uncharacterized protein', 150, NULL, NULL, 32773),
(32774, '1.10.510.10-FF-001363', NULL, 'Protein CBG06575', 327, NULL, NULL, 32774),
(32775, '3.90.1860.10-FF-000007', NULL, 'tRNA-splicing ligase RtcB', 405, NULL, NULL, 32775),
(32776, '2.10.110.10-FF-000047', NULL, 'lipoma-preferred partner isoform X1', 59, NULL, NULL, 32776),
(32777, '3.40.190.10-FF-000980', NULL, 'Chorismate mutase/prephenate dehydratase (P-protein)', 60, NULL, NULL, 32777),
(32778, '3.90.100.10-FF-000002', NULL, 'Biodegradative arginine decarboxylase', 125, NULL, NULL, 32778),
(32779, '3.30.1330.30-FF-000061', NULL, '40S ribosomal protein S12', 89, NULL, NULL, 32779),
(32780, '3.30.43.10-FF-000017', NULL, 'D-arabinono-1,4-lactone oxidase', 72, NULL, NULL, 32780),
(32781, '3.40.50.2300-FF-000105', NULL, 'Low molecular weight phosphotyrosine protein', 157, NULL, NULL, 32781),
(32782, '3.30.160.60-FF-000231', NULL, 'PLAG1 like zinc finger 2', 60, NULL, NULL, 32782),
(32783, '2.60.40.640-FF-000033', NULL, 'Down syndrome critical region protein 3', 136, NULL, NULL, 32783),
(32784, '2.10.70.10-FF-000100', NULL, 'SR-CI', 57, NULL, NULL, 32784),
(32785, '3.40.50.2000-FF-000173', NULL, 'Processive diacylglycerol beta-glucosyltransferase', 158, NULL, NULL, 32785),
(32786, '3.80.10.10-FF-002547', NULL, 'Transmembrane receptors / ATP binding protein', 154, NULL, NULL, 32786);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(32787, '1.10.533.10-FF-000106', NULL, 'Unc-5, isoform B', 104, NULL, NULL, 32787),
(32788, '1.25.50.20-FF-000060', NULL, 'Aminopeptidase', 129, NULL, NULL, 32788),
(32789, '3.90.1150.10-FF-000212', NULL, 'BnaC07g16420D protein', 162, NULL, NULL, 32789),
(32790, '2.60.40.10-FF-004053', NULL, NULL, 97, NULL, NULL, 32790),
(32791, '3.20.20.80-FF-000677', NULL, 'Predicted protein', 339, NULL, NULL, 32791),
(32792, '1.10.730.10-FF-000053', NULL, 'Leucine--tRNA ligase', 27, NULL, NULL, 32792),
(32793, '2.60.40.60-FF-000280', NULL, 'AGAP007203-PA-like protein', 114, NULL, NULL, 32793),
(32794, '2.40.30.10-FF-000411', NULL, 'Nitric oxide synthase, inducible', 28, NULL, NULL, 32794),
(32795, '2.60.120.200-FF-000623', NULL, 'Uncharacterized protein', 138, NULL, NULL, 32795),
(32796, '3.40.50.2300-FF-000049', NULL, 'Fructose repressor FruR', 180, NULL, NULL, 32796),
(32797, '1.10.275.20-FF-000003', NULL, 'Carnitine acetyl transferase', 94, NULL, NULL, 32797),
(32798, '3.30.160.60-FF-004502', NULL, NULL, 22, NULL, NULL, 32798),
(32799, '3.30.160.60-FF-002029', NULL, 'Zinc finger protein 287', 42, NULL, NULL, 32799),
(32800, '2.60.120.200-FF-000567', NULL, 'Uncharacterized protein', 174, NULL, NULL, 32800),
(32801, '3.90.105.10-FF-000030', NULL, 'Molybdopterin molybdenumtransferase', 42, NULL, NULL, 32801),
(32802, '1.10.167.10-FF-000007', NULL, 'sorting nexin-13 isoform X1', 149, NULL, NULL, 32802),
(32803, '3.40.190.10-FF-000648', NULL, 'Probable porphobilinogen deaminase', 101, NULL, NULL, 32803),
(32804, '3.40.50.10240-FF-000024', NULL, 'Thiamine pyrophosphokinase', 178, NULL, NULL, 32804),
(32805, '3.30.710.10-FF-000371', NULL, 'Predicted protein', 134, NULL, NULL, 32805),
(32806, '3.20.20.140-FF-000098', NULL, 'Error-prone DNA polymerase', 249, NULL, NULL, 32806),
(32807, '1.20.1560.10-FF-000603', NULL, 'Uncharacterized protein', 236, NULL, NULL, 32807),
(32808, '2.20.100.10-FF-000224', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs gon-1', 57, NULL, NULL, 32808),
(32809, '2.30.42.10-FF-000040', NULL, 'partitioning defective 3 homolog isoform X2', 98, NULL, NULL, 32809),
(32810, '1.25.40.180-FF-000012', NULL, 'Ccr4-Not transcription complex subunit', 245, NULL, NULL, 32810),
(32811, '2.130.10.10-FF-000383', NULL, 'Syntaxin-binding protein 5 isoform b', 125, NULL, NULL, 32811),
(32812, '2.60.40.10-FF-003384', NULL, NULL, 97, NULL, NULL, 32812),
(32813, '3.40.525.10-FF-000039', NULL, 'AT1G30690 protein', 275, NULL, NULL, 32813),
(32814, '2.20.100.10-FF-000168', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs gon-1', 61, NULL, NULL, 32814),
(32815, '3.40.50.720-FF-002476', NULL, 'Uncharacterized protein', 255, NULL, NULL, 32815),
(32816, '1.10.10.10-FF-002015', NULL, 'Uncharacterized protein', 149, NULL, NULL, 32816),
(32817, '2.160.10.10-FF-000016', NULL, 'Bifunctional protein GlmU', 189, NULL, NULL, 32817),
(32818, '1.25.40.10-FF-001747', NULL, 'DNA-directed RNA polymerase', 143, NULL, NULL, 32818),
(32819, '3.40.50.11350-FF-000020', NULL, 'Protein O-fucosyltransferase 2', 119, NULL, NULL, 32819),
(32820, '3.10.50.40-FF-000038', NULL, 'Peptidylprolyl isomerase', 119, NULL, NULL, 32820),
(32821, '2.30.30.40-FF-000656', NULL, 'Discs large MAGUK scaffold protein 4', 68, NULL, NULL, 32821),
(32822, '4.10.1060.10-FF-000037', NULL, 'Zn-finger in Ran binding protein and others, putative', 39, NULL, NULL, 32822),
(32823, '1.25.40.10-FF-002315', NULL, 'Cell division cycle protein 27 homolog', 104, NULL, NULL, 32823),
(32824, '1.10.287.600-FF-000025', NULL, 'Tubulin beta chain', 40, NULL, NULL, 32824),
(32825, '2.130.10.10-FF-002524', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 3', 244, NULL, NULL, 32825),
(32826, '2.60.40.10-FF-001939', NULL, 'Jitterbug, isoform F', 86, NULL, NULL, 32826),
(32827, '2.70.160.11-FF-000077', NULL, 'AGAP010203-PA', 161, NULL, NULL, 32827),
(32828, '1.10.10.790-FF-000019', NULL, 'Uncharacterized protein', 56, NULL, NULL, 32828),
(32829, '3.40.30.10-FF-000285', NULL, 'Glutathione S-transferase family protein', 80, NULL, NULL, 32829);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(32830, '2.130.10.10-FF-004598', NULL, 'Uncharacterized protein', 205, NULL, NULL, 32830),
(32831, '2.60.40.420-FF-000079', NULL, 'Laccase 1', 204, NULL, NULL, 32831),
(32832, '3.40.50.1820-FF-001136', NULL, 'Lipoxygenase-like protein', 171, NULL, NULL, 32832),
(32833, '3.40.50.2300-FF-001409', NULL, NULL, 94, NULL, NULL, 32833),
(32834, '1.20.5.190-FF-000030', NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', 48, NULL, NULL, 32834),
(32835, '1.25.10.10-FF-002763', NULL, 'Intracellular protein transport protein uso1', 600, NULL, NULL, 32835),
(32836, '3.80.10.10-FF-001294', NULL, 'PH domain and leucine rich repeat protein phosphatase 1', 94, NULL, NULL, 32836),
(32837, '3.40.50.12550-FF-000015', NULL, 'ThiF family protein', 65, NULL, NULL, 32837),
(32838, '1.10.8.140-FF-000017', NULL, 'DNA-binding TFAR19-related protein', 80, NULL, NULL, 32838),
(32839, '2.30.29.30-FF-000638', NULL, 'Arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 3', 100, NULL, NULL, 32839),
(32840, '3.90.940.40-FF-000001', NULL, 'Protein CHLORORESPIRATORY REDUCTION 7 chloroplastic', 73, NULL, NULL, 32840),
(32841, '3.50.50.60-FF-001149', NULL, 'Flavin-containing monooxygenase', 74, NULL, NULL, 32841),
(32842, '3.40.50.300-FF-005852', NULL, 'DNA helicase', 190, NULL, NULL, 32842),
(32843, '1.20.5.350-FF-000005', NULL, 'Troponin I 1', 167, NULL, NULL, 32843),
(32844, '3.30.70.890-FF-000004', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 119, NULL, NULL, 32844),
(32845, '3.30.200.20-FF-001015', NULL, 'Putative serine/threonine-protein kinase', 104, NULL, NULL, 32845),
(32846, '3.30.40.10-FF-002068', NULL, 'Uncharacterized RING finger protein C2A9.04c', 126, NULL, NULL, 32846),
(32847, '2.130.10.10-FF-001164', NULL, 'Transducin/WD40 repeat-like superfamily protein', 150, NULL, NULL, 32847),
(32848, '1.20.5.710-FF-000017', NULL, 'Uncharacterized protein', 59, NULL, NULL, 32848),
(32849, '3.30.830.10-FF-000262', NULL, 'Ubiquinol-cytochrome c reductase core protein 2a', 54, NULL, NULL, 32849),
(32850, '1.25.40.10-FF-004676', NULL, 'Chromosome 1, whole genome shotgun sequence', 109, NULL, NULL, 32850),
(32851, '1.25.40.20-FF-001863', NULL, 'Uncharacterized protein', 131, NULL, NULL, 32851),
(32852, '2.40.20.10-FF-000062', NULL, 'plasminogen-like', 106, NULL, NULL, 32852),
(32853, '3.30.1240.10-FF-000076', NULL, 'Predicted protein', 144, NULL, NULL, 32853),
(32854, '3.40.50.300-FF-005672', NULL, 'Peroxisomal ATPase PEX1', 191, NULL, NULL, 32854),
(32855, '3.40.190.10-FF-000693', NULL, 'Sll0064 protein', 138, NULL, NULL, 32855),
(32856, '3.30.40.10-FF-000831', NULL, 'RING-type E3 ubiquitin transferase', 99, NULL, NULL, 32856),
(32857, '2.130.10.10-FF-005397', NULL, 'Uncharacterized protein', 147, NULL, NULL, 32857),
(32858, '3.30.160.60-FF-003721', NULL, NULL, 26, NULL, NULL, 32858),
(32859, '1.50.10.10-FF-000097', NULL, 'alpha-1,2-Mannosidase', 276, NULL, NULL, 32859),
(32860, '2.60.40.60-FF-000897', NULL, 'Uncharacterized protein', 105, NULL, NULL, 32860),
(32861, '2.130.10.10-FF-005453', NULL, 'Heterotrimeric G protein beta subunit 1', 195, NULL, NULL, 32861),
(32862, '3.30.450.20-FF-000281', NULL, 'Cyclic-di-AMP phosphodiesterase', 121, NULL, NULL, 32862),
(32863, '2.30.29.30-FF-000970', NULL, 'Uncharacterized protein', 104, NULL, NULL, 32863),
(32864, '1.10.510.10-FF-000519', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', 210, NULL, NULL, 32864),
(32865, '4.10.75.10-FF-000011', NULL, 'Predicted protein', 47, NULL, NULL, 32865),
(32866, '3.10.105.10-FF-000031', NULL, 'Dipeptide ABC transporter, periplasmic dipeptide-binding protein, putative', 222, NULL, NULL, 32866),
(32867, '3.30.565.10-FF-000033', NULL, 'DNA mismatch repair protein Mlh1', 221, NULL, NULL, 32867),
(32868, '3.40.50.720-FF-000391', NULL, 'Fatty acyl-CoA reductase', 328, NULL, NULL, 32868),
(32869, '3.40.1390.10-FF-000005', NULL, 'UDP-N-acetylmuramoyl-L-alanyl-D-glutamate--2,6-diaminopimelate ligase', 91, NULL, NULL, 32869),
(32870, '3.40.50.1010-FF-000090', NULL, 'Nin one binding protein-like protein', 128, NULL, NULL, 32870);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(32871, '3.40.50.2300-FF-000381', NULL, 'Rgd1566381', 301, NULL, NULL, 32871),
(32872, '1.10.1220.10-FF-000007', NULL, 'Addiction module antitoxin, RelB/DinJ family', 79, NULL, NULL, 32872),
(32873, '2.120.10.80-FF-000224', NULL, 'kelch domain-containing protein 3 isoform X3', 65, NULL, NULL, 32873),
(32874, '1.20.5.1160-FF-000010', NULL, 'neurofilament heavy polypeptide', 118, NULL, NULL, 32874),
(32875, '1.10.630.10-FF-000809', NULL, 'Uncharacterized protein', 304, NULL, NULL, 32875),
(32876, '1.10.510.10-FF-002144', NULL, 'MRLK6', 200, NULL, NULL, 32876),
(32877, '1.10.3370.10-FF-000018', NULL, 'Os09g0512000 protein', 458, NULL, NULL, 32877),
(32878, '1.10.20.10-FF-000279', NULL, NULL, 74, NULL, NULL, 32878),
(32879, '3.30.160.60-FF-005806', NULL, NULL, 30, NULL, NULL, 32879),
(32880, '1.10.1300.10-FF-000008', NULL, 'Phosphodiesterase', 373, NULL, NULL, 32880),
(32881, '3.40.1500.10-FF-000004', NULL, 'Coproporphyrinogen III oxidase, mitochondrial', 369, NULL, NULL, 32881),
(32882, '3.40.395.10-FF-000045', NULL, 'Predicted protein', 235, NULL, NULL, 32882),
(32883, '3.40.50.1820-FF-000337', NULL, 'Carboxylic ester hydrolase', 546, NULL, NULL, 32883),
(32884, '1.10.510.10-FF-001470', NULL, 'Os04g0517700 protein', 194, NULL, NULL, 32884),
(32885, '4.10.280.10-FF-000012', NULL, 'hairy/enhancer-of-split related with YRPW motif protein 1', 65, NULL, NULL, 32885),
(32886, '3.40.50.300-FF-003486', NULL, 'Major sperm protein', 99, NULL, NULL, 32886),
(32887, '3.40.50.10990-FF-000013', NULL, 'GTP cyclohydrolase II', 166, NULL, NULL, 32887),
(32888, '2.60.40.10-FF-000635', NULL, 'Titin b', 102, NULL, NULL, 32888),
(32889, '2.130.10.10-FF-003249', NULL, 'WD repeat-containing protein 44 isoform A', 213, NULL, NULL, 32889),
(32890, '3.90.550.10-FF-000154', NULL, '3-deoxy-manno-octulosonate cytidylyltransferase', 249, NULL, NULL, 32890),
(32891, '1.20.5.110-FF-000332', NULL, 'Uncharacterized protein', 74, NULL, NULL, 32891),
(32892, '4.10.280.10-FF-000068', NULL, 'factor in the germline alpha', 68, NULL, NULL, 32892),
(32893, '3.30.160.60-FF-000051', NULL, 'zinc finger protein 585A', 29, NULL, NULL, 32893),
(32894, '3.40.80.10-FF-000001', NULL, 'Peptidoglycan recognition protein 1', 171, NULL, NULL, 32894),
(32895, '3.40.50.300-FF-000052', NULL, 'V-type proton ATPase catalytic subunit A', 294, NULL, NULL, 32895),
(32896, '3.40.50.150-FF-000990', NULL, NULL, 213, NULL, NULL, 32896),
(32897, '3.30.160.60-FF-000175', NULL, 'Mds1 and evi1 complex locus protein', 25, NULL, NULL, 32897),
(32898, '3.30.2350.20-FF-000020', NULL, 'tRNA pseudouridine synthase D', 36, NULL, NULL, 32898),
(32899, '1.25.40.10-FF-002591', NULL, 'Pentatricopeptide repeat-containing protein At1g15510, chloroplastic', 88, NULL, NULL, 32899),
(32900, '1.10.555.10-FF-000095', NULL, 'RhoGAP domain containing protein', 255, NULL, NULL, 32900),
(32901, '1.20.140.150-FF-000072', NULL, 'STarGazin (Mammalian calcium channel) homolog', 229, NULL, NULL, 32901),
(32902, '3.30.160.60-FF-004446', NULL, NULL, 27, NULL, NULL, 32902),
(32903, '1.25.40.10-FF-003951', NULL, 'rRNA biogenesis protein RRP5', 362, NULL, NULL, 32903),
(32904, '3.40.50.300-FF-007757', NULL, 'Uncharacterized protein', 73, NULL, NULL, 32904),
(32905, '3.50.50.60-FF-001481', NULL, 'Glutathione reductase', 55, NULL, NULL, 32905),
(32906, '2.40.10.10-FF-000292', NULL, NULL, 136, NULL, NULL, 32906),
(32907, '3.30.70.1400-FF-000012', NULL, 'Glycine cleavage T protein', 85, NULL, NULL, 32907),
(32908, '3.30.70.270-FF-000094', NULL, 'GGDEF family protein', 171, NULL, NULL, 32908),
(32909, '3.90.550.10-FF-000030', NULL, 'Glucose-1-phosphate adenylyltransferase', 315, NULL, NULL, 32909),
(32910, '3.50.50.60-FF-001329', NULL, 'Uncharacterized protein', 121, NULL, NULL, 32910),
(32911, '2.40.30.10-FF-000523', NULL, 'Translation elongation factor G, putative', 134, NULL, NULL, 32911),
(32912, '1.25.40.10-FF-001803', NULL, 'Os12g0289800 protein', 95, NULL, NULL, 32912),
(32913, '1.10.8.60-FF-000112', NULL, 'Smallminded, isoform A', 83, NULL, NULL, 32913),
(32914, '3.40.50.10090-FF-000013', NULL, 'Uroporphyrinogen-III synthase (UroS), putative', 113, NULL, NULL, 32914);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(32915, '3.40.50.150-FF-000602', NULL, 'Ribosomal RNA small subunit methyltransferase H', 182, NULL, NULL, 32915),
(32916, '2.60.40.10-FF-004233', NULL, NULL, 112, NULL, NULL, 32916),
(32917, '1.50.40.10-FF-000161', NULL, 'Calcium-binding mitochondrial carrier protein SCaMC-1', 330, NULL, NULL, 32917),
(32918, '3.60.10.10-FF-000120', NULL, 'Inositol-polyphosphate 5-phosphatase, putative', 366, NULL, NULL, 32918),
(32919, '3.40.50.2300-FF-001454', NULL, NULL, 129, NULL, NULL, 32919),
(32920, '1.20.1560.10-FF-000278', NULL, 'ABC transporter, ATP-binding protein', 311, NULL, NULL, 32920),
(32921, '3.40.50.410-FF-000085', NULL, 'Circumsporozoite-and TRAP-related protein', 217, NULL, NULL, 32921),
(32922, '1.20.910.10-FF-000042', NULL, 'AGAP012890-PA', 118, NULL, NULL, 32922),
(32923, '3.90.550.50-FF-000194', NULL, 'Hexosyltransferase', 198, NULL, NULL, 32923),
(32924, '3.30.40.10-FF-001556', NULL, 'Uncharacterized protein', 44, NULL, NULL, 32924),
(32925, '2.60.40.10-FF-005306', NULL, NULL, 80, NULL, NULL, 32925),
(32926, '1.25.40.10-FF-005114', NULL, 'Putative helicase with zinc finger domain-like Protein', 114, NULL, NULL, 32926),
(32927, '3.30.70.330-FF-000426', NULL, 'Serine/arginine-rich splicing factor 2a', 97, NULL, NULL, 32927),
(32928, '3.40.50.720-FF-000059', NULL, 'L-threonine 3-dehydrogenase', 134, NULL, NULL, 32928),
(32929, '1.25.40.10-FF-001927', NULL, 'Pentatricopeptide repeat domain 1', 186, NULL, NULL, 32929),
(32930, '2.130.10.10-FF-004941', NULL, 'Uncharacterized protein', 101, NULL, NULL, 32930),
(32931, '1.10.510.10-FF-004229', NULL, NULL, 355, NULL, NULL, 32931),
(32932, '3.20.100.30-FF-000001', NULL, 'Vacuolar transporter chaperone 4', 295, NULL, NULL, 32932),
(32933, '2.10.110.10-FF-000103', NULL, 'LIM homeobox transcription factor 1-beta', 68, NULL, NULL, 32933),
(32934, '3.90.190.10-FF-000171', NULL, 'Uncharacterized protein', 234, NULL, NULL, 32934),
(32935, '1.25.10.10-FF-001127', NULL, 'Protein CBG03866', 244, NULL, NULL, 32935),
(32936, '2.70.130.10-FF-000035', NULL, 'Autophagy protein Atg27, putative', 201, NULL, NULL, 32936),
(32937, '1.20.1530.20-FF-000043', NULL, 'Arsenite efflux pump', 329, NULL, NULL, 32937),
(32938, '3.40.50.300-FF-001069', NULL, 'ATP-binding cassette, sub-family G (WHITE), member 5', 231, NULL, NULL, 32938),
(32939, '1.20.140.10-FF-000096', NULL, 'Uncharacterized protein', 103, NULL, NULL, 32939),
(32940, '3.40.470.10-FF-000018', NULL, 'G/U mismatch-specific DNA glycosylase', 170, NULL, NULL, 32940),
(32941, '1.20.58.70-FF-000063', NULL, 'Syntaxin', 72, NULL, NULL, 32941),
(32942, '3.30.70.330-FF-002663', NULL, NULL, 118, NULL, NULL, 32942),
(32943, '1.10.246.60-FF-000015', NULL, NULL, 80, NULL, NULL, 32943),
(32944, '3.40.630.30-FF-000216', NULL, 'Alpha-tubulin N-acetyltransferase', 177, NULL, NULL, 32944),
(32945, '3.40.50.1000-FF-000030', NULL, 'HAD-IIA family hydrolase', 123, NULL, NULL, 32945),
(32946, '3.40.30.10-FF-000465', NULL, 'Glutaredoxin', 100, NULL, NULL, 32946),
(32947, '2.30.30.100-FF-000196', NULL, 'enhancer of mRNA-decapping protein 3-like', 83, NULL, NULL, 32947),
(32948, '3.80.10.10-FF-003660', NULL, 'Uncharacterized protein', 92, NULL, NULL, 32948),
(32949, '3.40.30.10-FF-000521', NULL, 'Thioredoxin family protein', 112, NULL, NULL, 32949),
(32950, '3.30.70.370-FF-000011', NULL, 'DNA polymerase I', 99, NULL, NULL, 32950),
(32951, '2.130.10.10-FF-003581', NULL, 'Lethal(2) giant larvae protein-like Protein', 255, NULL, NULL, 32951),
(32952, '3.90.550.50-FF-000250', NULL, 'Os03g0803900 protein', 154, NULL, NULL, 32952),
(32953, '1.10.30.10-FF-000049', NULL, 'Related to NHP6B-nonhistone chromosomal protein', 95, NULL, NULL, 32953),
(32954, '3.80.10.10-FF-002367', NULL, 'Predicted protein', 160, NULL, NULL, 32954),
(32955, '3.40.1340.10-FF-000002', NULL, 'DNA-directed RNA polymerases I, II, and III subunit RPABC1', 139, NULL, NULL, 32955),
(32956, '3.40.720.10-FF-000055', NULL, 'Sulfatase', 392, NULL, NULL, 32956),
(32957, '1.10.30.10-FF-000105', NULL, 'High mobility group (HMG) DNA binding protein, putative', 99, NULL, NULL, 32957);
INSERT INTO "PUBLIC"."MODEL" VALUES
(32958, '3.30.40.10-FF-000196', NULL, 'PHD finger protein 20 (Predicted)', 66, NULL, NULL, 32958),
(32959, '3.30.1520.10-FF-000114', NULL, 'Bud emergence protein, putative', 144, NULL, NULL, 32959),
(32960, '2.30.42.10-FF-000545', NULL, NULL, 95, NULL, NULL, 32960),
(32961, '1.20.1740.10-FF-000264', NULL, 'Uncharacterized protein', 103, NULL, NULL, 32961),
(32962, '3.30.160.20-FF-000011', NULL, 'double-stranded RNA-specific editase 1 isoform X1', 71, NULL, NULL, 32962),
(32963, '2.40.30.10-FF-000124', NULL, 'Elongation factor Tu', 54, NULL, NULL, 32963),
(32964, '3.30.1230.20-FF-000016', NULL, 'Uncharacterized protein', 70, NULL, NULL, 32964),
(32965, '3.40.50.1100-FF-000234', NULL, 'Uncharacterized protein', 58, NULL, NULL, 32965),
(32966, '2.60.40.10-FF-003272', NULL, NULL, 86, NULL, NULL, 32966),
(32967, '3.40.50.300-FF-002362', NULL, 'ATP-binding cassette transporter, putative', 246, NULL, NULL, 32967),
(32968, '1.25.40.10-FF-000966', NULL, 'Os12g0289800 protein', 85, NULL, NULL, 32968),
(32969, '1.20.58.390-FF-000207', NULL, 'Cholinergic receptor nicotinic delta subunit', 118, NULL, NULL, 32969),
(32970, '1.10.510.10-FF-003268', NULL, NULL, 109, NULL, NULL, 32970),
(32971, '3.80.10.10-FF-001530', NULL, 'Adhesion G protein-coupled receptor A2', 79, NULL, NULL, 32971),
(32972, '1.20.1600.10-FF-000046', NULL, 'Outer membrane protein-like protein', 307, NULL, NULL, 32972),
(32973, '1.20.1640.10-FF-000099', NULL, NULL, 206, NULL, NULL, 32973),
(32974, '1.20.140.10-FF-000152', NULL, 'Uncharacterized protein', 132, NULL, NULL, 32974),
(32975, '2.60.40.10-FF-001759', NULL, 'Hemicentin 2', 92, NULL, NULL, 32975),
(32976, '3.40.50.2000-FF-000285', NULL, 'Digalactosyldiacylglycerol synthase 1, chloroplastic', 71, NULL, NULL, 32976),
(32977, '1.25.40.10-FF-003372', NULL, 'Pentatricopeptide repeat-containing protein', 57, NULL, NULL, 32977),
(32978, '2.20.70.10-FF-000015', NULL, 'Transcription elongation regulator 1 (CA150)', 65, NULL, NULL, 32978),
(32979, '2.60.40.10-FF-001416', NULL, 'Usherin', 103, NULL, NULL, 32979),
(32980, '3.30.70.1230-FF-000051', NULL, 'Soluble guanylate cyclase 88E', 188, NULL, NULL, 32980),
(32981, '3.40.50.300-FF-004503', NULL, 'Uncharacterized protein', 370, NULL, NULL, 32981),
(32982, '2.60.40.790-FF-000212', NULL, NULL, 41, NULL, NULL, 32982),
(32983, '2.60.200.20-FF-000181', NULL, 'Uncharacterized protein', 130, NULL, NULL, 32983),
(32984, '1.10.238.20-FF-000030', NULL, 'IP02370p', 106, NULL, NULL, 32984),
(32985, '3.60.21.10-FF-000201', NULL, 'ATPAP14/PAP14', 278, NULL, NULL, 32985),
(32986, '2.40.70.10-FF-000301', NULL, NULL, 189, NULL, NULL, 32986),
(32987, '3.40.390.10-FF-000017', NULL, 'Disintegrin and metalloproteinase domain-containing protein 17', 255, NULL, NULL, 32987),
(32988, '2.130.10.10-FF-005958', NULL, 'Peptidyl-prolyl cis-trans isomerase, cyclophilin-type', 246, NULL, NULL, 32988),
(32989, '3.40.50.150-FF-000259', NULL, 'Protein-L-isoaspartate O-methyltransferase', 231, NULL, NULL, 32989),
(32990, '2.130.10.10-FF-003828', NULL, 'Sec13-related protein', 300, NULL, NULL, 32990),
(32991, '3.40.50.300-FF-006633', NULL, 'Uncharacterized protein', 91, NULL, NULL, 32991),
(32992, '1.10.12.10-FF-000041', NULL, 'Enoyl CoA hydratase', 57, NULL, NULL, 32992),
(32993, '3.30.200.20-FF-000234', NULL, 'Proto-oncogene tyrosine-protein kinase receptor Ret', 119, NULL, NULL, 32993),
(32994, '1.20.1560.10-FF-000098', NULL, 'Probable ATP-binding/permease fusion ABC transporter', 324, NULL, NULL, 32994),
(32995, '1.20.1510.10-FF-000095', NULL, NULL, 199, NULL, NULL, 32995),
(32996, '1.10.580.10-FF-000001', NULL, 'Citrate synthase', 300, NULL, NULL, 32996),
(32997, '3.20.20.140-FF-000316', NULL, 'N-acetylglucosamine-6-phosphate deacetylase (NagA)', 272, NULL, NULL, 32997),
(32998, '1.25.40.10-FF-001242', NULL, 'PeRoXisome assembly factor', 296, NULL, NULL, 32998),
(32999, '2.60.260.20-FF-000010', NULL, 'Curved DNA-binding protein', 77, NULL, NULL, 32999),
(33000, '3.40.50.720-FF-001296', NULL, 'Alcohol dehydrogenase, zinc-containing', 134, NULL, NULL, 33000),
(33001, '3.30.710.10-FF-000219', NULL, 'BTB domain containing 1', 55, NULL, NULL, 33001);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(33002, '2.110.10.10-FF-000041', NULL, 'Zinc MetalloProtease', 193, NULL, NULL, 33002),
(33003, '2.30.30.30-FF-000035', NULL, 'Transcription termination/antitermination protein NusG', 59, NULL, NULL, 33003),
(33004, '2.60.40.1970-FF-000002', NULL, 'YEATS domain-containing protein 4', 141, NULL, NULL, 33004),
(33005, '3.90.1180.10-FF-000040', NULL, NULL, 76, NULL, NULL, 33005),
(33006, '3.10.20.90-FF-000860', NULL, 'Autophagy-related protein', 76, NULL, NULL, 33006),
(33007, '2.60.40.150-FF-000543', NULL, 'Phosphoinositide phospholipase C', 127, NULL, NULL, 33007),
(33008, '3.30.40.10-FF-001213', NULL, 'Chromosome 8, whole genome shotgun sequence', 69, NULL, NULL, 33008),
(33009, '3.30.1520.10-FF-000058', NULL, 'VPS9 domain protein, putative', 110, NULL, NULL, 33009),
(33010, '1.25.10.10-FF-000110', NULL, 'synembryn-B isoform X1', 291, NULL, NULL, 33010),
(33011, '1.20.1310.20-FF-000004', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 202, NULL, NULL, 33011),
(33012, '2.60.40.10-FF-005126', NULL, NULL, 97, NULL, NULL, 33012),
(33013, '3.80.10.10-FF-004109', NULL, 'Predicted protein', 118, NULL, NULL, 33013),
(33014, '4.10.410.10-FF-000051', NULL, 'CBN-SPON-1 protein', 59, NULL, NULL, 33014),
(33015, '1.10.20.10-FF-000223', NULL, NULL, 177, NULL, NULL, 33015),
(33016, '2.20.25.10-FF-000040', NULL, 'Putative DNA-direcetd RNA polymerase II, subunit 9', 51, NULL, NULL, 33016),
(33017, '2.130.10.10-FF-001687', NULL, 'WD repeat domain 66', 317, NULL, NULL, 33017),
(33018, '2.30.30.40-FF-000151', NULL, 'Tyrosine-protein kinase', 82, NULL, NULL, 33018),
(33019, '2.60.40.4370-FF-000008', NULL, NULL, 94, NULL, NULL, 33019),
(33020, '2.30.29.30-FF-001038', NULL, 'Uncharacterized protein', 123, NULL, NULL, 33020),
(33021, '3.90.1150.10-FF-000268', NULL, 'UDP4amino4deoxyLarabinoseoxoglutarate aminotransferase EC 261', 121, NULL, NULL, 33021),
(33022, '3.40.50.720-FF-001695', NULL, 'Uncharacterized protein', 25, NULL, NULL, 33022),
(33023, '1.10.287.70-FF-000725', NULL, 'Uncharacterized protein', 238, NULL, NULL, 33023),
(33024, '2.60.34.10-FF-000014', NULL, 'Chaperone protein DnaK HSP70', 184, NULL, NULL, 33024),
(33025, '3.60.21.10-FF-000145', NULL, 'Serine/threonine-protein phosphatase', 317, NULL, NULL, 33025),
(33026, '1.20.58.60-FF-000346', NULL, 'SMAll', 114, NULL, NULL, 33026),
(33027, '1.10.10.60-FF-001153', NULL, NULL, 53, NULL, NULL, 33027),
(33028, '1.10.8.10-FF-000182', NULL, 'Protoporphyrinogen oxidase (HemK)', 80, NULL, NULL, 33028),
(33029, '2.60.40.10-FF-005649', NULL, NULL, 91, NULL, NULL, 33029),
(33030, '3.40.50.300-FF-003704', NULL, 'Recombinase RecB', 206, NULL, NULL, 33030),
(33031, '1.25.40.1030-FF-000051', NULL, 'Uncharacterized protein', 166, NULL, NULL, 33031),
(33032, '3.40.50.1820-FF-000736', NULL, 'Triacylglycerol lipase-like 1', 292, NULL, NULL, 33032),
(33033, '2.40.50.140-FF-001036', NULL, NULL, 140, NULL, NULL, 33033),
(33034, '1.10.287.110-FF-000081', NULL, 'Chaperone DnaJ', 123, NULL, NULL, 33034),
(33035, '2.60.40.10-FF-000579', NULL, 'Fibronectin 1', 94, NULL, NULL, 33035),
(33036, '2.130.10.10-FF-003305', NULL, 'Uncharacterized protein', 134, NULL, NULL, 33036),
(33037, '1.10.10.10-FF-001178', NULL, 'Uncharacterized protein', 108, NULL, NULL, 33037),
(33038, '1.20.58.2220-FF-000070', NULL, 'Uncharacterized protein', 96, NULL, NULL, 33038),
(33039, '1.10.10.10-FF-000778', NULL, 'Meiotic recombination protein SPO11-1', 138, NULL, NULL, 33039),
(33040, '3.30.160.60-FF-003665', NULL, NULL, 27, NULL, NULL, 33040),
(33041, '1.25.40.10-FF-004732', NULL, 'Uncharacterized protein', 81, NULL, NULL, 33041),
(33042, '3.30.360.10-FF-000006', NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase', 172, NULL, NULL, 33042),
(33043, '2.30.29.30-FF-001190', NULL, 'Uncharacterized protein', 98, NULL, NULL, 33043),
(33044, '1.20.920.10-FF-000104', NULL, 'Bromodomain containing protein', 131, NULL, NULL, 33044),
(33045, '3.40.50.1980-FF-000071', NULL, 'Iron complex transport system substrate-binding protein', 153, NULL, NULL, 33045),
(33046, '3.30.420.10-FF-000337', NULL, NULL, 98, NULL, NULL, 33046);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(33047, '1.10.220.30-FF-000014', NULL, 'Flagellar motor switch protein FliG', 139, NULL, NULL, 33047),
(33048, '2.60.120.200-FF-000062', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 2', 180, NULL, NULL, 33048),
(33049, '2.60.40.1170-FF-000026', NULL, 'AP-1 complex subunit mu, putative', 159, NULL, NULL, 33049),
(33050, '3.40.50.620-FF-000827', NULL, 'Tryptophan--tRNA ligase', 207, NULL, NULL, 33050),
(33051, '3.30.1380.20-FF-000004', NULL, 'Trafficking protein particle complex subunit 6B', 158, NULL, NULL, 33051),
(33052, '3.40.50.10190-FF-000217', NULL, 'Nibrin', 107, NULL, NULL, 33052),
(33053, '1.25.40.180-FF-000299', NULL, NULL, 91, NULL, NULL, 33053),
(33054, '1.20.58.100-FF-000003', NULL, 'Succinate dehydrogenase flavoprotein subunit', 117, NULL, NULL, 33054),
(33055, '3.20.20.10-FF-000010', NULL, 'Antizyme inhibitor 1', 229, NULL, NULL, 33055),
(33056, '3.80.10.10-FF-003328', NULL, 'AGAP006408-PA', 368, NULL, NULL, 33056),
(33057, '3.40.250.10-FF-000131', NULL, 'Serine/threonine/tyrosine-interacting-like 1', 118, NULL, NULL, 33057),
(33058, '3.20.20.80-FF-000154', NULL, 'Uncharacterized protein', 227, NULL, NULL, 33058),
(33059, '3.30.70.980-FF-000031', NULL, 'Probable transcriptional regulatory protein ARJ17_01235', 72, NULL, NULL, 33059),
(33060, '3.40.50.300-FF-007937', NULL, 'Uncharacterized protein', 172, NULL, NULL, 33060),
(33061, '1.25.40.20-FF-000407', NULL, 'Ankyrin repeat and SOCS box containing 14', 143, NULL, NULL, 33061),
(33062, '2.40.40.20-FF-000010', NULL, 'Anaerobic dimethyl sulfoxide reductase subunit A', 145, NULL, NULL, 33062),
(33063, '2.40.50.100-FF-000035', NULL, 'Auxiliary transport protein, membrane fusion protein family', 76, NULL, NULL, 33063),
(33064, '3.40.50.300-FF-008213', NULL, 'Uncharacterized protein', 68, NULL, NULL, 33064),
(33065, '3.20.20.70-FF-000617', NULL, NULL, 99, NULL, NULL, 33065),
(33066, '1.10.10.10-FF-000958', NULL, 'ATP-dependent DEAD/H DNA helicase recQ, putative', 208, NULL, NULL, 33066),
(33067, '2.20.28.230-FF-000004', NULL, 'Interleukin-2 receptor subunit alpha', 58, NULL, NULL, 33067),
(33068, '2.60.120.620-FF-000013', NULL, 'Prolyl 4-hydroxylase subunit alpha 3', 190, NULL, NULL, 33068),
(33069, '3.40.190.80-FF-000068', NULL, 'Inositol monophosphatase family protein', 118, NULL, NULL, 33069),
(33070, '1.10.287.70-FF-000040', NULL, 'Sodium channel protein', 149, NULL, NULL, 33070),
(33071, '2.60.40.420-FF-000259', NULL, 'Early nodulin-55-1', 71, NULL, NULL, 33071),
(33072, '3.30.559.30-FF-000024', NULL, 'Nonribosomal peptide synthase sidE', 249, NULL, NULL, 33072),
(33073, '1.10.1200.10-FF-000012', NULL, 'Acyl carrier protein', 79, NULL, NULL, 33073),
(33074, '3.40.50.150-FF-001771', NULL, NULL, 204, NULL, NULL, 33074),
(33075, '2.60.40.150-FF-000487', NULL, 'Uncharacterized protein', 137, NULL, NULL, 33075),
(33076, '1.20.920.10-FF-000048', NULL, 'RSC complex subunit (RSC1), putative', 124, NULL, NULL, 33076),
(33077, '1.10.510.10-FF-003780', NULL, NULL, 134, NULL, NULL, 33077),
(33078, '1.10.510.10-FF-002487', NULL, 'RE68077p', 297, NULL, NULL, 33078),
(33079, '3.30.40.10-FF-001612', NULL, 'DNA repair protein rad8', 117, NULL, NULL, 33079),
(33080, '1.25.40.20-FF-000227', NULL, 'Kinase D-interacting substrate 220a', 77, NULL, NULL, 33080),
(33081, '1.25.40.820-FF-000018', NULL, 'Putative RNA polymerase II subunit B1 CTD phosphatase RPAP2-like protein', 73, NULL, NULL, 33081),
(33082, '1.10.10.10-FF-001234', NULL, 'Response regulator SaeR', 98, NULL, NULL, 33082),
(33083, '2.40.110.10-FF-000063', NULL, 'Acyl-CoA dehydrogenase, putative', 99, NULL, NULL, 33083),
(33084, '3.30.9.10-FF-000303', NULL, 'Amino acid deaminase, putative', 123, NULL, NULL, 33084),
(33085, '1.10.1170.10-FF-000014', NULL, 'IAP-like protein p27', 115, NULL, NULL, 33085),
(33086, '2.170.150.80-FF-000033', NULL, 'NAC domain containing protein 65', 52, NULL, NULL, 33086),
(33087, '3.40.50.1820-FF-000175', NULL, 'Hydrolase-like protein family', 163, NULL, NULL, 33087),
(33088, '3.90.550.10-FF-000210', NULL, 'Mycofactocin biosynthesis glycosyltransferase MftF', 216, NULL, NULL, 33088);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(33089, '3.30.365.10-FF-000034', NULL, 'Xanthine dehydrogenase', 63, NULL, NULL, 33089),
(33090, '3.40.140.70-FF-000005', NULL, 'Autophagy protein apg7, putative', 121, NULL, NULL, 33090),
(33091, '1.20.990.10-FF-000053', NULL, 'Uncharacterized protein', 63, NULL, NULL, 33091),
(33092, '3.60.10.10-FF-000064', NULL, 'Uncharacterized protein, isoform B', 361, NULL, NULL, 33092),
(33093, '3.40.950.10-FF-000044', NULL, NULL, 36, NULL, NULL, 33093),
(33094, '3.30.750.44-FF-000022', NULL, NULL, 81, NULL, NULL, 33094),
(33095, '1.20.5.170-FF-000215', NULL, 'Putative nucleoporin Nup54-like Protein', 43, NULL, NULL, 33095),
(33096, '3.30.70.270-FF-000150', NULL, 'DNA polymerase eta', 176, NULL, NULL, 33096),
(33097, '3.40.1190.20-FF-000010', NULL, 'Ribokinase', 308, NULL, NULL, 33097),
(33098, '2.20.70.10-FF-000291', NULL, 'Uncharacterized protein', 63, NULL, NULL, 33098),
(33099, '3.30.1460.20-FF-000005', NULL, 'Arp2/3 complex 34 kDa subunit', 129, NULL, NULL, 33099),
(33100, '3.90.640.10-FF-000037', NULL, 'Heat shock 70 kDa protein 13', 52, NULL, NULL, 33100),
(33101, '1.20.1250.20-FF-000510', NULL, 'Siderophore iron transporter mirC', 241, NULL, NULL, 33101),
(33102, '3.40.50.300-FF-006577', NULL, 'Sulfotransferase', 100, NULL, NULL, 33102),
(33103, '3.30.70.330-FF-001882', NULL, NULL, 92, NULL, NULL, 33103),
(33104, '1.10.510.10-FF-000014', NULL, 'Non-specific serine/threonine protein kinase', 203, NULL, NULL, 33104),
(33105, '2.40.50.140-FF-000816', NULL, NULL, 120, NULL, NULL, 33105),
(33106, '2.40.70.10-FF-000121', NULL, 'Eukaryotic aspartyl protease family protein', 181, NULL, NULL, 33106),
(33107, '2.60.40.60-FF-000004', NULL, 'Protocadherin 1 gamma 2', 108, NULL, NULL, 33107),
(33108, '3.80.10.10-FF-000170', NULL, 'amphoterin-induced protein 2 isoform X1', 253, NULL, NULL, 33108),
(33109, '3.40.50.1460-FF-000089', NULL, 'Uncharacterized protein', 211, NULL, NULL, 33109),
(33110, '1.10.565.10-FF-000045', NULL, 'Nuclear Hormone Receptor family', 227, NULL, NULL, 33110),
(33111, '3.90.1480.20-FF-000026', NULL, 'Uncharacterized protein', 290, NULL, NULL, 33111),
(33112, '1.10.10.2330-FF-000009', NULL, 'Phenylalanyl-tRNA synthetase alpha subunit, putative', 55, NULL, NULL, 33112),
(33113, '2.40.30.10-FF-000467', NULL, 'Uncharacterized protein', 79, NULL, NULL, 33113),
(33114, '3.30.70.1710-FF-000004', NULL, 'Ethanolamine utilization microcompartment protein EutL', 111, NULL, NULL, 33114),
(33115, '1.10.10.10-FF-001919', NULL, 'Uncharacterized protein', 98, NULL, NULL, 33115),
(33116, '1.10.287.3240-FF-000003', NULL, 'V-type proton ATPase subunit D', 198, NULL, NULL, 33116),
(33117, '1.20.1070.10-FF-000408', NULL, 'Olfactory receptor 59', 166, NULL, NULL, 33117),
(33118, '3.40.50.300-FF-002182', NULL, 'Bifunctional polynucleotide phosphatase/kinase', 190, NULL, NULL, 33118),
(33119, '1.20.1260.10-FF-000058', NULL, 'Ferritin', 164, NULL, NULL, 33119),
(33120, '1.20.120.230-FF-000013', NULL, 'Vinculin b', 117, NULL, NULL, 33120),
(33121, '2.60.120.470-FF-000002', NULL, 'PITH domain-containing protein 1', 163, NULL, NULL, 33121),
(33122, '3.30.40.10-FF-000775', NULL, 'Tripartite motif-containing protein 40', 56, NULL, NULL, 33122),
(33123, '3.30.160.60-FF-003541', NULL, NULL, 27, NULL, NULL, 33123),
(33124, '3.30.420.40-FF-000279', NULL, 'Actin-like protein, putative', 150, NULL, NULL, 33124),
(33125, '1.25.40.10-FF-004333', NULL, 'Uncharacterized protein', 311, NULL, NULL, 33125),
(33126, '3.30.310.10-FF-000003', NULL, 'AP complex subunit beta', 116, NULL, NULL, 33126),
(33127, '2.60.120.200-FF-000803', NULL, 'OSJNBa0027H06.10 protein', 124, NULL, NULL, 33127),
(33128, '3.30.60.30-FF-000080', NULL, 'Follistatin, isoform B', 45, NULL, NULL, 33128),
(33129, '3.40.50.300-FF-003542', NULL, 'DNA repair protein rhp57', 280, NULL, NULL, 33129),
(33130, '3.90.110.10-FF-000008', NULL, '6-phospho-beta-glucosidase', 272, NULL, NULL, 33130),
(33131, '3.40.50.300-FF-006976', NULL, 'GTP-binding nuclear protein', 218, NULL, NULL, 33131),
(33132, '1.10.238.10-FF-000482', NULL, 'CALmodulin related genes', 86, NULL, NULL, 33132);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(33133, '3.30.1370.100-FF-000018', NULL, 'DNA mismatch repair protein MutL', 96, NULL, NULL, 33133),
(33134, '1.20.120.1530-FF-000011', NULL, 'Methyl-accepting chemotaxis protein', 141, NULL, NULL, 33134),
(33135, '3.30.160.60-FF-005879', NULL, NULL, 39, NULL, NULL, 33135),
(33136, '1.20.900.10-FF-000081', NULL, 'Protein ECT2', 137, NULL, NULL, 33136),
(33137, '2.40.20.10-FF-000034', NULL, 'Plasminogen', 100, NULL, NULL, 33137),
(33138, '2.30.30.380-FF-000066', NULL, 'CaLPain family', 41, NULL, NULL, 33138),
(33139, '1.20.58.60-FF-000234', NULL, 'microtubule-actin cross-linking factor 1 isoform X6', 154, NULL, NULL, 33139),
(33140, '2.60.40.10-FF-003193', NULL, 'Beta-glucosidase', 119, NULL, NULL, 33140),
(33141, '2.20.110.10-FF-000062', NULL, NULL, 60, NULL, NULL, 33141),
(33142, '3.40.50.1370-FF-000039', NULL, 'Aspartate carbamoyltransferase', 154, NULL, NULL, 33142),
(33143, '3.30.420.10-FF-000383', NULL, NULL, 100, NULL, NULL, 33143),
(33144, '1.10.10.60-FF-000080', NULL, 'Zinc finger homeobox protein 2', 62, NULL, NULL, 33144),
(33145, '3.40.50.2300-FF-000925', NULL, NULL, 49, NULL, NULL, 33145),
(33146, '3.65.10.20-FF-000011', NULL, '18S rRNA biogenesis protein RCL1', 237, NULL, NULL, 33146),
(33147, '1.20.120.350-FF-000184', NULL, NULL, 127, NULL, NULL, 33147),
(33148, '1.10.439.20-FF-000002', NULL, 'Phospholipase B-like', 117, NULL, NULL, 33148),
(33149, '3.10.20.310-FF-000016', NULL, 'Outer membrane OMP85 family protein', 80, NULL, NULL, 33149),
(33150, '2.130.10.10-FF-000102', NULL, 'Actin-interacting protein 1', 323, NULL, NULL, 33150),
(33151, '1.20.920.10-FF-000094', NULL, 'Unplaced genomic scaffold supercont1.83, whole genome shotgun sequence', 104, NULL, NULL, 33151),
(33152, '3.30.160.60-FF-004261', NULL, NULL, 27, NULL, NULL, 33152),
(33153, '3.40.20.10-FF-000071', NULL, 'Unplaced genomic scaffold supercont1.257, whole genome shotgun sequence', 133, NULL, NULL, 33153),
(33154, '2.40.30.130-FF-000051', NULL, 'Uncharacterized protein', 113, NULL, NULL, 33154),
(33155, '3.30.1010.10-FF-000019', NULL, 'Serine/threonine-protein kinase Tel1', 160, NULL, NULL, 33155),
(33156, '1.10.20.140-FF-000006', NULL, 'tRNA dimethylallyltransferase', 63, NULL, NULL, 33156),
(33157, '1.10.287.70-FF-000596', NULL, 'Uncharacterized protein', 88, NULL, NULL, 33157),
(33158, '3.20.20.70-FF-000112', NULL, 'Fructose-bisphosphate aldolase Fba', 342, NULL, NULL, 33158),
(33159, '3.30.390.150-FF-000005', NULL, 'Gastrokine-3', 95, NULL, NULL, 33159),
(33160, '3.80.10.10-FF-001642', NULL, 'Leucine-rich repeat receptor-like protein kinase TDR', 241, NULL, NULL, 33160),
(33161, '3.40.630.30-FF-000340', NULL, 'Acyl-CoA N-acyltransferases (NAT) superfamily protein', 145, NULL, NULL, 33161),
(33162, '1.10.20.10-FF-000144', NULL, 'Conserved protein', 90, NULL, NULL, 33162),
(33163, '3.40.50.300-FF-002053', NULL, 'ABC transporter ATP-binding protein', 259, NULL, NULL, 33163),
(33164, '1.10.590.10-FF-000002', NULL, 'Chorismate mutase', 257, NULL, NULL, 33164),
(33165, '2.60.40.10-FF-002687', NULL, 'HEMCAM', 68, NULL, NULL, 33165),
(33166, '3.40.50.150-FF-001563', NULL, NULL, 74, NULL, NULL, 33166),
(33167, '2.130.10.10-FF-001563', NULL, 'Kinesin protein KIF21B', 140, NULL, NULL, 33167),
(33168, '3.40.30.10-FF-000156', NULL, 'Glutathione S-transferase 1', 83, NULL, NULL, 33168),
(33169, '3.40.50.1820-FF-001473', NULL, 'Uncharacterized protein', 174, NULL, NULL, 33169),
(33170, '3.30.160.60-FF-003272', NULL, 'gastrula zinc finger protein XlCGF67.1-like', 31, NULL, NULL, 33170),
(33171, '1.10.287.110-FF-000018', NULL, 'DnaJ (Hsp40) homolog, subfamily C, member 7', 105, NULL, NULL, 33171),
(33172, '3.40.50.300-FF-000006', NULL, 'DNA-binding transcriptional regulator NtrC', 177, NULL, NULL, 33172),
(33173, '1.10.1370.10-FF-000041', NULL, 'Uncharacterized protein', 153, NULL, NULL, 33173),
(33174, '3.20.20.10-FF-000038', NULL, 'Pyridoxal phosphate homeostasis protein', 238, NULL, NULL, 33174),
(33175, '3.40.50.300-FF-005812', NULL, 'Beethoven', 250, NULL, NULL, 33175),
(33176, '3.30.160.60-FF-002653', NULL, 'C2H2 transcription factor protein', 32, NULL, NULL, 33176);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(33177, '3.40.47.10-FF-000149', NULL, '3-hydroxy-3-methylglutaryl coenzyme A synthase', 356, NULL, NULL, 33177),
(33178, '3.40.50.300-FF-001434', NULL, 'Structural maintenance of chromosomes protein 5', 220, NULL, NULL, 33178),
(33179, '1.10.630.10-FF-000562', NULL, 'Uncharacterized protein', 329, NULL, NULL, 33179),
(33180, '3.10.180.10-FF-000098', NULL, 'Uncharacterized protein', 133, NULL, NULL, 33180),
(33181, '3.30.200.20-FF-001690', NULL, 'Putative serine threonine-protein kinase WNK2-like protein', 68, NULL, NULL, 33181),
(33182, '2.130.10.10-FF-004789', NULL, 'Protein CBR-GAD-1', 150, NULL, NULL, 33182),
(33183, '1.20.1250.10-FF-000125', NULL, NULL, 125, NULL, NULL, 33183),
(33184, '2.60.210.10-FF-000049', NULL, NULL, 139, NULL, NULL, 33184),
(33185, '3.30.70.330-FF-002394', NULL, NULL, 96, NULL, NULL, 33185),
(33186, '2.130.10.10-FF-000091', NULL, 'mitogen-activated protein kinase-binding protein 1 isoform X1', 108, NULL, NULL, 33186),
(33187, '3.20.20.140-FF-000440', NULL, 'Polymerase/histidinol phosphatase-like', 104, NULL, NULL, 33187),
(33188, '3.10.580.10-FF-000044', NULL, 'Chloride channel protein', 90, NULL, NULL, 33188),
(33189, '3.50.50.60-FF-000941', NULL, 'Amine oxidase', 140, NULL, NULL, 33189),
(33190, '3.60.40.10-FF-000161', NULL, 'Putative Ser/Thr phosphatase 2C', 333, NULL, NULL, 33190),
(33191, '1.10.510.10-FF-003841', NULL, NULL, 107, NULL, NULL, 33191),
(33192, '3.40.390.10-FF-000085', NULL, 'Zinc metalloproteinase', 230, NULL, NULL, 33192),
(33193, '1.20.1250.20-FF-002062', NULL, 'Uncharacterized protein', 296, NULL, NULL, 33193),
(33194, '3.40.50.300-FF-005279', NULL, 'Predicted protein', 178, NULL, NULL, 33194),
(33195, '2.60.120.200-FF-000011', NULL, 'Probable calnexin', 228, NULL, NULL, 33195),
(33196, '2.60.110.10-FF-000002', NULL, 'Thaumatin-like protein 1a', 219, NULL, NULL, 33196),
(33197, '3.30.160.60-FF-003642', NULL, 'Uncharacterized protein, isoform A', 82, NULL, NULL, 33197),
(33198, '2.130.10.30-FF-000097', NULL, NULL, 184, NULL, NULL, 33198),
(33199, '3.40.1080.10-FF-000004', NULL, 'Acetyl-CoA hydrolase', 172, NULL, NULL, 33199),
(33200, '3.60.15.10-FF-000159', NULL, 'Rhodanese domain protein / beta-lactamase domain protein', 238, NULL, NULL, 33200),
(33201, '3.30.70.1450-FF-000010', NULL, 'Trk system potassium transporter TrkA', 87, NULL, NULL, 33201),
(33202, '3.30.70.1230-FF-000175', NULL, 'Protein kinase, putative', 184, NULL, NULL, 33202),
(33203, '2.60.120.290-FF-000257', NULL, 'Cubilin-like Protein', 107, NULL, NULL, 33203),
(33204, '1.10.150.50-FF-000205', NULL, 'Uncharacterized protein', 83, NULL, NULL, 33204),
(33205, '3.40.50.11040-FF-000006', NULL, 'RNA cytidine acetyltransferase', 204, NULL, NULL, 33205),
(33206, '1.20.1070.10-FF-001016', NULL, 'Uncharacterized protein', 336, NULL, NULL, 33206),
(33207, '3.30.60.30-FF-000181', NULL, 'Agrin', 54, NULL, NULL, 33207),
(33208, '3.30.160.60-FF-001708', NULL, 'Zinc finger protein 251', 29, NULL, NULL, 33208),
(33209, '1.25.40.20-FF-001508', NULL, 'Uncharacterized protein', 203, NULL, NULL, 33209),
(33210, '3.30.1150.10-FF-000029', NULL, NULL, 219, NULL, NULL, 33210),
(33211, '1.10.287.70-FF-000124', NULL, 'Cyclic nucleotide-gated channel 6', 262, NULL, NULL, 33211),
(33212, '1.20.1540.10-FF-000035', NULL, 'RHOMBOID-like protein', 205, NULL, NULL, 33212),
(33213, '1.10.510.10-FF-001071', NULL, 'NIMA related kinase 11', 228, NULL, NULL, 33213),
(33214, '2.40.30.20-FF-000009', NULL, 'V-type proton ATPase catalytic subunit A', 77, NULL, NULL, 33214),
(33215, '3.40.50.2300-FF-001061', NULL, NULL, 122, NULL, NULL, 33215),
(33216, '1.20.1070.10-FF-000499', NULL, 'Vomeronasal type-1 receptor', 290, NULL, NULL, 33216),
(33217, '1.10.150.40-FF-000006', NULL, 'Barrier-to-autointegration factor-like protein', 82, NULL, NULL, 33217),
(33218, '3.40.50.12780-FF-000078', NULL, 'Acyl protein synthase/acyl-CoA reductase RfbN', 343, NULL, NULL, 33218),
(33219, '4.10.400.10-FF-000005', NULL, 'low-density lipoprotein receptor-related protein 1B', 41, NULL, NULL, 33219),
(33220, '2.130.10.10-FF-005745', NULL, 'Uncharacterized protein', 123, NULL, NULL, 33220);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(33221, '2.60.40.10-FF-002215', NULL, 'Interleukin 6 signal transducer', 61, NULL, NULL, 33221),
(33222, '3.40.109.10-FF-000011', NULL, 'Nitroreductase family protein', 201, NULL, NULL, 33222),
(33223, '3.30.450.20-FF-000421', NULL, 'Sensor histidine kinase, PAS domain-containing', 138, NULL, NULL, 33223),
(33224, '1.20.1720.10-FF-000133', NULL, NULL, 90, NULL, NULL, 33224),
(33225, '2.60.40.10-FF-004502', NULL, NULL, 101, NULL, NULL, 33225),
(33226, '3.40.50.300-FF-007257', NULL, 'Uncharacterized protein', 158, NULL, NULL, 33226),
(33227, '3.40.50.300-FF-001097', NULL, 'ATP-dependent DNA helicase', 198, NULL, NULL, 33227),
(33228, '3.40.50.2000-FF-000942', NULL, 'Uncharacterized protein', 130, NULL, NULL, 33228),
(33229, '1.25.40.10-FF-000207', NULL, 'Small glutamine-rich tetratricopeptide repeat-containing protein', 164, NULL, NULL, 33229),
(33230, '2.60.470.10-FF-000023', NULL, 'Pickpocket 12', 199, NULL, NULL, 33230),
(33231, '3.30.70.370-FF-000039', NULL, NULL, 42, NULL, NULL, 33231),
(33232, '3.30.70.330-FF-001775', NULL, NULL, 75, NULL, NULL, 33232),
(33233, '3.30.30.120-FF-000001', NULL, 'Diapause-specific peptide', 41, NULL, NULL, 33233),
(33234, '1.10.510.10-FF-003532', NULL, NULL, 355, NULL, NULL, 33234),
(33235, '1.10.565.10-FF-000152', NULL, 'Uncharacterized protein', 236, NULL, NULL, 33235),
(33236, '3.30.870.10-FF-000040', NULL, 'Envelope phospholipase F13', 153, NULL, NULL, 33236),
(33237, '3.60.20.10-FF-000261', NULL, NULL, 160, NULL, NULL, 33237),
(33238, '3.40.630.20-FF-000011', NULL, 'Pyroglutamyl-peptidase 1-like protein', 130, NULL, NULL, 33238),
(33239, '1.25.10.10-FF-001807', NULL, 'Uncharacterized protein', 268, NULL, NULL, 33239),
(33240, '1.50.10.150-FF-000021', NULL, 'Os01g0360801 protein', 110, NULL, NULL, 33240),
(33241, '3.30.505.10-FF-000260', NULL, NULL, 95, NULL, NULL, 33241),
(33242, '1.10.510.10-FF-001924', NULL, 'leucine-rich repeat receptor-like tyrosine-protein kinase PXC3', 194, NULL, NULL, 33242),
(33243, '2.40.30.10-FF-000332', NULL, 'Uncharacterized protein', 90, NULL, NULL, 33243),
(33244, '3.40.630.40-FF-000017', NULL, 'N-acetylmuramoyl-L-alanine amidase CwlD', 207, NULL, NULL, 33244),
(33245, '3.40.50.720-FF-001779', NULL, '2-dehydropantoate 2-reductase', 176, NULL, NULL, 33245),
(33246, '3.30.300.30-FF-000003', NULL, 'DIP2 disco-interacting protein 2 homolog A', 120, NULL, NULL, 33246),
(33247, '1.20.1070.10-FF-001651', NULL, 'Uncharacterized protein', 132, NULL, NULL, 33247),
(33248, '3.50.50.60-FF-000632', NULL, 'Glycine/D-amino acid oxidase', 193, NULL, NULL, 33248),
(33249, '3.40.50.2020-FF-000139', NULL, 'Ribose-phosphate pyrophosphokinase', 128, NULL, NULL, 33249),
(33250, '3.30.420.40-FF-000116', NULL, 'Pantothenate kinase family protein', 148, NULL, NULL, 33250),
(33251, '1.10.10.10-FF-000981', NULL, 'HTH-type transcriptional regulator Cmr', 69, NULL, NULL, 33251),
(33252, '3.60.10.10-FF-000333', NULL, 'Probable secreted protein', 234, NULL, NULL, 33252),
(33253, '3.20.20.140-FF-000131', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 289, NULL, NULL, 33253),
(33254, '1.10.287.1060-FF-000012', NULL, 'Vacuolar sorting protein SNF7', 79, NULL, NULL, 33254),
(33255, '1.20.58.2180-FF-000001', NULL, 'Iron(III) ABC transporter, solute-binding protein', 64, NULL, NULL, 33255),
(33256, '1.10.10.10-FF-001470', NULL, 'Ferric uptake regulator, Fur family', 85, NULL, NULL, 33256),
(33257, '2.30.40.10-FF-000119', NULL, 'Bll5494 protein', 95, NULL, NULL, 33257),
(33258, '1.20.5.110-FF-000141', NULL, 'CRE-SYN-13 protein', 105, NULL, NULL, 33258),
(33259, '3.30.160.60-FF-005087', NULL, NULL, 25, NULL, NULL, 33259),
(33260, '1.25.40.10-FF-001618', NULL, 'Stress-induced-phosphoprotein 1', 123, NULL, NULL, 33260),
(33261, '3.80.10.10-FF-004076', NULL, 'Uncharacterized protein', 127, NULL, NULL, 33261),
(33262, '3.30.70.260-FF-000006', NULL, '(P)ppGpp synthase/hydrolase SpoT', 80, NULL, NULL, 33262),
(33263, '3.30.390.60-FF-000012', NULL, 'Heat-inducible transcription repressor HrcA', 103, NULL, NULL, 33263),
(33264, '1.20.1050.20-FF-000017', NULL, NULL, 118, NULL, NULL, 33264);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(33265, '3.30.200.20-FF-002044', NULL, NULL, 89, NULL, NULL, 33265),
(33266, '1.10.220.150-FF-000059', NULL, 'Centaurin gamma, putative', 80, NULL, NULL, 33266),
(33267, '1.25.70.10-FF-000018', NULL, 'Transcription termination factor MTEF18, mitochondrial', 130, NULL, NULL, 33267),
(33268, '2.120.10.80-FF-000011', NULL, 'Kelch like family member 12', 301, NULL, NULL, 33268),
(33269, '4.10.1000.10-FF-000157', NULL, 'Predicted protein', 69, NULL, NULL, 33269),
(33270, '1.20.140.100-FF-000023', NULL, 'Dynein heavy chain', 164, NULL, NULL, 33270),
(33271, '1.20.58.830-FF-000031', NULL, 'Duffy binding-like merozoite surface protein', 138, NULL, NULL, 33271),
(33272, '3.40.50.1820-FF-001164', NULL, 'Acyl-CoA thioesterase 16', 146, NULL, NULL, 33272),
(33273, '3.50.7.10-FF-000075', NULL, NULL, 79, NULL, NULL, 33273),
(33274, '1.20.1270.60-FF-000242', NULL, 'Uncharacterized protein', 80, NULL, NULL, 33274),
(33275, '2.40.50.140-FF-000491', NULL, 'S1 RNA-binding domain-containing protein', 90, NULL, NULL, 33275),
(33276, '1.20.1250.20-FF-000807', NULL, 'MFS family major facilitator transporter', 226, NULL, NULL, 33276),
(33277, '2.30.30.140-FF-000236', NULL, 'Tudor domain-containing protein 7', 71, NULL, NULL, 33277),
(33278, '1.10.10.1290-FF-000001', NULL, 'DELLA protein GAI', 66, NULL, NULL, 33278),
(33279, '2.130.10.10-FF-003980', NULL, 'Uncharacterized protein', 234, NULL, NULL, 33279),
(33280, '3.40.50.2300-FF-001218', NULL, NULL, 182, NULL, NULL, 33280),
(33281, '3.40.50.720-FF-001324', NULL, 'NAD dependent epimerase/dehydratase family', 280, NULL, NULL, 33281),
(33282, '3.40.190.10-FF-000457', NULL, 'LysR family transcriptional regulator', 102, NULL, NULL, 33282),
(33283, '4.10.410.10-FF-000107', NULL, 'Predicted protein', 48, NULL, NULL, 33283),
(33284, '3.30.200.20-FF-002499', NULL, 'Uncharacterized protein', 12, NULL, NULL, 33284),
(33285, '2.40.340.10-FF-000001', NULL, 'Molybdopterin molybdenumtransferase', 81, NULL, NULL, 33285),
(33286, '2.10.90.10-FF-000112', NULL, 'Uncharacterized protein', 110, NULL, NULL, 33286),
(33287, '3.30.160.60-FF-004570', NULL, NULL, 45, NULL, NULL, 33287),
(33288, '2.80.10.50-FF-000212', NULL, 'Interleukin-1 alpha', 94, NULL, NULL, 33288),
(33289, '1.20.1250.20-FF-001898', NULL, 'Uncharacterized protein', 68, NULL, NULL, 33289),
(33290, '1.25.10.10-FF-001650', NULL, 'Cilia and flagella associated protein 69', 391, NULL, NULL, 33290),
(33291, '3.30.40.10-FF-001904', NULL, 'Uncharacterized protein', 73, NULL, NULL, 33291),
(33292, '2.60.40.10-FF-001276', NULL, 'Usherin', 87, NULL, NULL, 33292),
(33293, '2.60.40.10-FF-000450', NULL, 'Neural cell adhesion molecule 2', 98, NULL, NULL, 33293),
(33294, '2.130.10.10-FF-005306', NULL, 'Uncharacterized protein', 212, NULL, NULL, 33294),
(33295, '3.20.80.10-FF-000047', NULL, 'Heme-binding-like protein chloroplastic', 69, NULL, NULL, 33295),
(33296, '3.40.50.620-FF-000586', NULL, 'Uncharacterized protein', 138, NULL, NULL, 33296),
(33297, '1.20.120.1910-FF-000029', NULL, 'Cysteinyl-tRNA synthetase', 188, NULL, NULL, 33297),
(33298, '3.40.250.10-FF-000136', NULL, 'Probable rhodanese domain-containing dual specificity protein phosphatase', 155, NULL, NULL, 33298),
(33299, '1.25.40.20-FF-000519', NULL, 'Phosphate metabolism-related protein', 160, NULL, NULL, 33299),
(33300, '1.25.40.20-FF-001155', NULL, 'Predicted protein', 140, NULL, NULL, 33300),
(33301, '3.40.50.300-FF-006105', NULL, 'Dynamin 2', 91, NULL, NULL, 33301),
(33302, '2.40.50.140-FF-001137', NULL, NULL, 86, NULL, NULL, 33302),
(33303, '3.40.33.10-FF-000207', NULL, 'Protein CBR-SCL-22', 60, NULL, NULL, 33303),
(33304, '1.25.10.10-FF-000026', NULL, '26S proteasome non-ATPase regulatory subunit 2', 434, NULL, NULL, 33304),
(33305, '4.10.1000.10-FF-000096', NULL, 'Zinc finger protein, putative', 30, NULL, NULL, 33305),
(33306, '3.40.50.2060-FF-000011', NULL, 'SLY1 protein', 143, NULL, NULL, 33306),
(33307, '1.10.10.650-FF-000022', NULL, 'Transcription elongation factor spt6', 55, NULL, NULL, 33307),
(33308, '3.40.50.720-FF-000368', NULL, 'Pyrroline-5-carboxylate reductase', 166, NULL, NULL, 33308);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(33309, '3.10.20.90-FF-000129', NULL, 'E3 ubiquitin-protein ligase MYLIP isoform X1', 79, NULL, NULL, 33309),
(33310, '1.10.238.10-FF-000965', NULL, 'Os04g0681500 protein', 74, NULL, NULL, 33310),
(33311, '3.40.250.10-FF-000075', NULL, 'Rhodanese-like protein', 118, NULL, NULL, 33311),
(33312, '3.30.250.20-FF-000001', NULL, 'Uncharacterized protein', 75, NULL, NULL, 33312),
(33313, '2.60.40.10-FF-005121', NULL, NULL, 97, NULL, NULL, 33313),
(33314, '2.40.50.770-FF-000016', NULL, 'Uncharacterized protein', 164, NULL, NULL, 33314),
(33315, '1.10.510.10-FF-002543', NULL, 'Protein kinase, putative', 298, NULL, NULL, 33315),
(33316, '1.10.10.60-FF-000872', NULL, NULL, 54, NULL, NULL, 33316),
(33317, '1.20.1250.20-FF-001443', NULL, 'MFS sugar transporte, putative', 84, NULL, NULL, 33317),
(33318, '1.20.58.80-FF-000083', NULL, 'Predicted protein', 142, NULL, NULL, 33318),
(33319, '2.60.220.50-FF-000191', NULL, 'Uncharacterized protein', 193, NULL, NULL, 33319),
(33320, '3.30.230.10-FF-000418', NULL, 'DNA mismatch repair protein MutL', 107, NULL, NULL, 33320),
(33321, '3.40.50.1820-FF-000528', NULL, 'Uncharacterized protein', 145, NULL, NULL, 33321),
(33322, '3.30.420.10-FF-000253', NULL, 'Os01g0566000 protein', 172, NULL, NULL, 33322),
(33323, '2.130.10.10-FF-000883', NULL, 'Putative acyl-activating enzyme 19', 189, NULL, NULL, 33323),
(33324, '1.10.510.10-FF-000082', NULL, 'Shaggy-related protein kinase kappa', 249, NULL, NULL, 33324),
(33325, '2.130.10.10-FF-005615', NULL, 'Uncharacterized protein', 186, NULL, NULL, 33325),
(33326, '3.30.160.60-FF-006043', NULL, NULL, 52, NULL, NULL, 33326),
(33327, '3.30.30.170-FF-000005', NULL, 'Translation initiation factor 2 beta subunit putative', 138, NULL, NULL, 33327),
(33328, '3.30.70.270-FF-000335', NULL, NULL, 168, NULL, NULL, 33328),
(33329, '3.40.50.1820-FF-000984', NULL, 'Alpha/beta hydrolase family, putative', 253, NULL, NULL, 33329),
(33330, '3.50.30.30-FF-000173', NULL, 'Uncharacterized protein', 116, NULL, NULL, 33330),
(33331, '1.20.1080.10-FF-000016', NULL, 'Aquaporin', 223, NULL, NULL, 33331),
(33332, '1.20.1740.10-FF-000016', NULL, 'Inner membrane transporter YhaO', 406, NULL, NULL, 33332),
(33333, '3.90.79.10-FF-000069', NULL, 'Mitochondrial ribosomal protein L46,putative', 135, NULL, NULL, 33333),
(33334, '3.40.50.2000-FF-001089', NULL, 'Glycosyltransferase', 93, NULL, NULL, 33334),
(33335, '2.10.70.10-FF-000212', NULL, 'Complement component receptor 1-like protein', 62, NULL, NULL, 33335),
(33336, '1.20.1420.30-FF-000083', NULL, 'Uncharacterized protein', 128, NULL, NULL, 33336),
(33337, '3.40.50.300-FF-004840', NULL, 'Uncharacterized protein', 250, NULL, NULL, 33337),
(33338, '3.40.1380.10-FF-000016', NULL, 'ATP synthase gamma chain', 222, NULL, NULL, 33338),
(33339, '1.25.10.10-FF-003095', NULL, 'Dynein assembly factor 5, axonemal', 223, NULL, NULL, 33339),
(33340, '3.40.50.2300-FF-001561', NULL, NULL, 13, NULL, NULL, 33340),
(33341, '1.25.10.10-FF-001307', NULL, 'Uncharacterized protein', 85, NULL, NULL, 33341),
(33342, '3.40.30.10-FF-000173', NULL, 'Mitochondrial 54S ribosomal protein', 137, NULL, NULL, 33342),
(33343, '1.25.40.10-FF-004232', NULL, 'Uncharacterized protein', 251, NULL, NULL, 33343),
(33344, '2.30.29.30-FF-000234', NULL, 'Pleckstrin homology (PH) domain-containing protein', 117, NULL, NULL, 33344),
(33345, '2.130.10.10-FF-003637', NULL, 'F-box/WD repeat-containing protein pof11', 212, NULL, NULL, 33345),
(33346, '3.90.190.10-FF-000215', NULL, 'Tyrosine/serine protein phosphatase, putative (AFU_orthologue AFUA_6G06650)', 223, NULL, NULL, 33346),
(33347, '3.40.30.10-FF-000509', NULL, 'Glutathione S-transferase alpha 2', 55, NULL, NULL, 33347),
(33348, '1.25.40.500-FF-000007', NULL, 'TAF (TBP-associated transcription factor) family', 136, NULL, NULL, 33348),
(33349, '2.40.30.320-FF-000001', NULL, 'Bride of doubletime', 124, NULL, NULL, 33349),
(33350, '2.30.30.490-FF-000099', NULL, 'DNA (cytosine-5)-methyltransferase', 206, NULL, NULL, 33350),
(33351, '3.30.1330.30-FF-000122', NULL, 'Uncharacterized protein', 96, NULL, NULL, 33351);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(33352, '1.10.8.270-FF-000045', NULL, 'GTPase-activating protein GYP5', 123, NULL, NULL, 33352),
(33353, '3.40.50.10470-FF-000043', NULL, 'Methylthioribose-1-phosphate isomerase', 172, NULL, NULL, 33353),
(33354, '3.10.110.10-FF-000341', NULL, 'Uncharacterized protein', 152, NULL, NULL, 33354),
(33355, '3.30.70.1430-FF-000015', NULL, 'Probable Resistance-Nodulation-Cell Division (RND) efflux transporter', 99, NULL, NULL, 33355),
(33356, '3.40.50.10860-FF-000070', NULL, 'Pentafunctional AROM polypeptide', 95, NULL, NULL, 33356),
(33357, '1.20.58.530-FF-000031', NULL, 'neither inactivation nor afterpotential protein C', 163, NULL, NULL, 33357),
(33358, '3.40.50.1820-FF-000545', NULL, 'Protein phosphatase methylesterase 1', 260, NULL, NULL, 33358),
(33359, '3.60.15.10-FF-000176', NULL, 'Beta-lactamase domain protein', 202, NULL, NULL, 33359),
(33360, '3.30.160.20-FF-000191', NULL, 'Uncharacterized protein', 72, NULL, NULL, 33360),
(33361, '3.40.50.1260-FF-000006', NULL, 'Phosphoglycerate kinase', 176, NULL, NULL, 33361),
(33362, '3.30.40.10-FF-001112', NULL, 'CG1909, isoform A', 72, NULL, NULL, 33362),
(33363, '3.20.20.20-FF-000030', NULL, 'Carbon-monoxide dehydrogenase delta subunit', 299, NULL, NULL, 33363),
(33364, '2.60.40.10-FF-005458', NULL, NULL, 106, NULL, NULL, 33364),
(33365, '3.40.50.300-FF-005149', NULL, 'Uncharacterized protein', 233, NULL, NULL, 33365),
(33366, '3.40.50.1010-FF-000275', NULL, NULL, 100, NULL, NULL, 33366),
(33367, '3.40.630.30-FF-000470', NULL, 'N-acetyltransferase, GNAT family', 161, NULL, NULL, 33367),
(33368, '1.20.1070.10-FF-002168', NULL, 'Predicted protein', 124, NULL, NULL, 33368),
(33369, '1.10.510.10-FF-000435', NULL, 'Nik-related protein kinase', 207, NULL, NULL, 33369),
(33370, '1.25.40.10-FF-000781', NULL, 'Pentatricopeptide repeat-containing protein', 108, NULL, NULL, 33370),
(33371, '3.30.1180.20-FF-000006', NULL, 'Uncharacterized protein', 185, NULL, NULL, 33371),
(33372, '2.60.40.10-FF-002232', NULL, 'Intercellular adhesion molecule 3', 78, NULL, NULL, 33372),
(33373, '3.40.50.300-FF-005588', NULL, 'NLR family CARD domain containing 5', 107, NULL, NULL, 33373),
(33374, '1.10.530.10-FF-000009', NULL, 'Lysozyme', 158, NULL, NULL, 33374),
(33375, '1.25.40.120-FF-000005', NULL, 'Protein prenyltransferase alpha subunit repeat containing 1', 208, NULL, NULL, 33375),
(33376, '3.30.1510.10-FF-000001', NULL, 'Formate--tetrahydrofolate ligase', 119, NULL, NULL, 33376),
(33377, '3.60.21.10-FF-000117', NULL, 'Ser/Thr protein phosphatase family protein', 272, NULL, NULL, 33377),
(33378, '3.30.70.2450-FF-000001', NULL, '3-(3-hydroxy-phenyl)propionate/3-hydroxycinnamic acid hydroxylase', 82, NULL, NULL, 33378),
(33379, '1.10.287.70-FF-000096', NULL, 'polycystic kidney disease 2-like 2 protein isoform X2', 192, NULL, NULL, 33379),
(33380, '1.10.3720.10-FF-000198', NULL, 'Riboflavin transport system permease protein RibX', 203, NULL, NULL, 33380),
(33381, '3.40.50.2300-FF-000942', NULL, NULL, 167, NULL, NULL, 33381),
(33382, '2.130.10.10-FF-003480', NULL, 'Intraflagellar transport protein 172', 308, NULL, NULL, 33382),
(33383, '2.70.160.11-FF-000009', NULL, 'protein arginine N-methyltransferase 6', 185, NULL, NULL, 33383),
(33384, '3.40.50.720-FF-000840', NULL, 'Zinc-binding dehydrogenase family oxidoreductase', 166, NULL, NULL, 33384),
(33385, '1.10.238.10-FF-000173', NULL, 'uncharacterized TPR repeat-containing protein At1g05150-like', 81, NULL, NULL, 33385),
(33386, '2.40.30.130-FF-000034', NULL, 'Uncharacterized protein', 105, NULL, NULL, 33386),
(33387, '3.30.1490.10-FF-000004', NULL, 'Mitochondrial ribosomal protein S8', 58, NULL, NULL, 33387),
(33388, '1.20.120.1080-FF-000140', NULL, 'Chromosome 1, whole genome shotgun sequence', 124, NULL, NULL, 33388),
(33389, '2.40.30.10-FF-000315', NULL, 'Ribosome-releasing factor 2, mitochondrial', 129, NULL, NULL, 33389),
(33390, '3.10.50.40-FF-000066', NULL, 'Peptidylprolyl isomerase', 135, NULL, NULL, 33390),
(33391, '1.10.455.10-FF-000031', NULL, '40S ribosomal protein S5', 47, NULL, NULL, 33391),
(33392, '2.130.10.10-FF-001580', NULL, 'Mitotic checkpoint protein bub-3', 336, NULL, NULL, 33392);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(33393, '1.10.287.370-FF-000017', NULL, 'Prefoldin, alpha subunit', 133, NULL, NULL, 33393),
(33394, '1.20.58.830-FF-000014', NULL, 'Antigen 332, DBL-like protein', 103, NULL, NULL, 33394),
(33395, '1.10.10.10-FF-001818', NULL, 'Uncharacterized protein', 98, NULL, NULL, 33395),
(33396, '3.40.50.150-FF-000411', NULL, 'Mrm2p', 222, NULL, NULL, 33396),
(33397, '3.30.2180.10-FF-000003', NULL, 'BnaC04g32790D protein', 64, NULL, NULL, 33397),
(33398, '3.90.360.10-FF-000015', NULL, 'Chl-1', 127, NULL, NULL, 33398),
(33399, '2.60.40.10-FF-004132', NULL, NULL, 91, NULL, NULL, 33399),
(33400, '3.40.50.150-FF-001580', NULL, NULL, 50, NULL, NULL, 33400),
(33401, '1.10.510.10-FF-001615', NULL, 'Serine/threonine-protein kinase TAO2', 208, NULL, NULL, 33401),
(33402, '2.30.180.10-FF-000002', NULL, 'periostin isoform X1', 123, NULL, NULL, 33402),
(33403, '3.40.720.10-FF-000111', NULL, 'Predicted protein', 114, NULL, NULL, 33403),
(33404, '3.10.105.10-FF-000082', NULL, 'ABC transporter, binding protein', 254, NULL, NULL, 33404),
(33405, '1.20.1280.50-FF-000178', NULL, 'Predicted protein', 92, NULL, NULL, 33405),
(33406, '3.40.50.300-FF-002070', NULL, 'Uridine kinase', 215, NULL, NULL, 33406),
(33407, '3.40.50.410-FF-000186', NULL, 'Uncharacterized protein', 189, NULL, NULL, 33407),
(33408, '3.30.420.10-FF-000692', NULL, NULL, 267, NULL, NULL, 33408),
(33409, '1.10.10.60-FF-000063', NULL, 'SIX homeobox 2', 53, NULL, NULL, 33409),
(33410, '1.20.140.100-FF-000006', NULL, 'dynein heavy chain 2, axonemal', 151, NULL, NULL, 33410),
(33411, '3.40.50.300-FF-006768', NULL, 'DNA repair DEAD helicase RAD3/XP-D subfamily protein', 62, NULL, NULL, 33411),
(33412, '1.50.40.10-FF-000245', NULL, 'Mitochondrial RNA-splicing protein, putative', 195, NULL, NULL, 33412),
(33413, '1.25.10.10-FF-001015', NULL, 'Anaphase-promoting complex subunit 1', 184, NULL, NULL, 33413),
(33414, '1.10.1520.10-FF-000087', NULL, 'Endoribonuclease Dicer-like protein 1', 163, NULL, NULL, 33414),
(33415, '1.10.287.130-FF-000204', NULL, 'Sensor histidine kinase', 78, NULL, NULL, 33415),
(33416, '3.40.50.720-FF-002285', NULL, 'Uncharacterized protein', 218, NULL, NULL, 33416),
(33417, '3.30.190.20-FF-000030', NULL, 'Uncharacterized protein', 109, NULL, NULL, 33417),
(33418, '2.130.10.10-FF-000074', NULL, 'Angio-associated migratory cell protein-like protein', 339, NULL, NULL, 33418),
(33419, '3.40.50.300-FF-007274', NULL, 'Vasa protein isoform, putative', 155, NULL, NULL, 33419),
(33420, '3.80.10.10-FF-002159', NULL, 'F-box/LRR-repeat protein 15', 242, NULL, NULL, 33420),
(33421, '1.10.510.10-FF-004460', NULL, NULL, 282, NULL, NULL, 33421),
(33422, '2.130.10.10-FF-002991', NULL, 'Dynein intermediate chain 2, ciliary-related protein', 199, NULL, NULL, 33422),
(33423, '2.60.40.10-FF-001259', NULL, 'Immunoglobulin heavy variable 13-2', 105, NULL, NULL, 33423),
(33424, '3.30.200.20-FF-000127', NULL, 'Putative dual specificity tyrosine-phosphorylation-regulated kinase 2', 106, NULL, NULL, 33424),
(33425, '1.25.40.10-FF-001135', NULL, 'Pentatricopeptide repeat-containing protein', 100, NULL, NULL, 33425),
(33426, '3.40.1280.10-FF-000115', NULL, 'tRNA (guanosine(18)-2''-O)-methyltransferase', 211, NULL, NULL, 33426),
(33427, '4.10.95.10-FF-000006', NULL, 'Uncharacterized protein', 86, NULL, NULL, 33427),
(33428, '1.25.40.180-FF-000225', NULL, NULL, 164, NULL, NULL, 33428),
(33429, '3.30.70.20-FF-000100', NULL, NULL, 72, NULL, NULL, 33429),
(33430, '3.30.710.10-FF-000028', NULL, 'POZ-, AT hook-, and zinc finger-containing protein 1 isoform X4', 151, NULL, NULL, 33430),
(33431, '1.10.565.10-FF-000022', NULL, 'Nuclear receptor subfamily 2 group E member 3', 235, NULL, NULL, 33431),
(33432, '1.10.357.30-FF-000005', NULL, 'Exocyst complex component SEC15', 176, NULL, NULL, 33432),
(33433, '1.10.472.10-FF-000200', NULL, 'Predicted protein', 78, NULL, NULL, 33433),
(33434, '3.40.50.300-FF-008022', NULL, 'Multidrug resistance protein, putative', 140, NULL, NULL, 33434),
(33435, '3.30.1460.50-FF-000020', NULL, 'Uncharacterized protein', 172, NULL, NULL, 33435),
(33436, '3.30.70.80-FF-000011', NULL, 'Vacuolar protease B', 96, NULL, NULL, 33436);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(33437, '2.130.10.10-FF-005323', NULL, 'Uncharacterized protein', 197, NULL, NULL, 33437),
(33438, '1.20.144.10-FF-000014', NULL, 'Phospholipid phosphatase-related protein type 3', 185, NULL, NULL, 33438),
(33439, '3.40.50.410-FF-000169', NULL, 'Collagen type VI alpha 3 chain', 201, NULL, NULL, 33439),
(33440, '2.40.50.100-FF-000147', NULL, 'Sll0180 protein', 34, NULL, NULL, 33440),
(33441, '3.10.100.10-FF-000104', NULL, 'CoLlagen with Endostatin domain', 180, NULL, NULL, 33441),
(33442, '1.20.58.400-FF-000003', NULL, 'Vesicle transport through interaction with t-SNAREs homolog 1B', 96, NULL, NULL, 33442),
(33443, '2.30.30.140-FF-000106', NULL, 'Histone acetyltransferase', 64, NULL, NULL, 33443),
(33444, '2.20.100.10-FF-000117', NULL, 'Spondin-1', 58, NULL, NULL, 33444),
(33445, '3.90.70.10-FF-000521', NULL, 'Flagellar associated protein', 158, NULL, NULL, 33445),
(33446, '1.10.510.10-FF-001054', NULL, 'Serine/threonine-protein kinase 4', 115, NULL, NULL, 33446),
(33447, '1.25.40.20-FF-000183', NULL, 'ankyrin repeat domain-containing protein 1', 98, NULL, NULL, 33447),
(33448, '3.90.640.10-FF-000161', NULL, 'Actin-related protein 8', 135, NULL, NULL, 33448),
(33449, '1.25.40.10-FF-002579', NULL, 'UTP6 small subunit processome component', 141, NULL, NULL, 33449),
(33450, '3.40.366.30-FF-000001', NULL, 'Cupin superfamily protein family', 169, NULL, NULL, 33450),
(33451, '1.20.930.60-FF-000002', NULL, 'Protein-glutamate O-methyltransferase C1393.13', 120, NULL, NULL, 33451),
(33452, '1.20.81.10-FF-000003', NULL, 'Alpha-2-macroglobulin receptor-associated protein', 108, NULL, NULL, 33452),
(33453, '2.60.40.10-FF-000107', NULL, 'Myosin, light chain kinase a', 93, NULL, NULL, 33453),
(33454, '2.40.10.10-FF-000432', NULL, NULL, 134, NULL, NULL, 33454),
(33455, '3.60.20.10-FF-000126', NULL, 'Proteasome subunit alpha type', 214, NULL, NULL, 33455),
(33456, '3.40.120.10-FF-000054', NULL, 'Phosphoacetylglucosamine mutase', 93, NULL, NULL, 33456),
(33457, '3.40.50.970-FF-000185', NULL, 'Uncharacterized protein', 88, NULL, NULL, 33457),
(33458, '3.80.10.10-FF-001007', NULL, 'Si:dkey-32e6.6', 285, NULL, NULL, 33458),
(33459, '1.10.510.10-FF-002560', NULL, 'AaceriABR088Cp', 265, NULL, NULL, 33459),
(33460, '1.10.287.370-FF-000034', NULL, 'GM15993', 146, NULL, NULL, 33460),
(33461, '3.40.50.300-FF-003351', NULL, 'Structural maintenance of chromosomes protein', 197, NULL, NULL, 33461),
(33462, '3.40.50.10190-FF-000262', NULL, 'Chromatin-binding protein', 134, NULL, NULL, 33462),
(33463, '1.10.8.480-FF-000018', NULL, 'rRNA adenine N(6)-methyltransferase', 75, NULL, NULL, 33463),
(33464, '3.40.1690.20-FF-000008', NULL, 'Yta12p', 97, NULL, NULL, 33464),
(33465, '3.20.20.100-FF-000035', NULL, 'Aldehyde reductase, putative', 350, NULL, NULL, 33465),
(33466, '1.20.1070.10-FF-000370', NULL, 'Neuropeptide receptor 15', 330, NULL, NULL, 33466),
(33467, '3.40.50.1440-FF-000055', NULL, 'Protein ACCUMULATION AND REPLICATION OF CHLOROPLASTS 3', 252, NULL, NULL, 33467),
(33468, '1.20.1560.10-FF-000727', NULL, 'Uncharacterized protein', 224, NULL, NULL, 33468),
(33469, '3.80.10.10-FF-004413', NULL, 'Receptor like protein 21', 72, NULL, NULL, 33469),
(33470, '3.40.630.30-FF-000031', NULL, 'Glucosamine 6-phosphate N-acetyltransferase', 161, NULL, NULL, 33470),
(33471, '2.60.120.200-FF-000483', NULL, 'Neurexin-1', 52, NULL, NULL, 33471),
(33472, '1.10.10.440-FF-000061', NULL, 'Uncharacterized protein', 75, NULL, NULL, 33472),
(33473, '1.20.1270.60-FF-000225', NULL, 'YALI0F19778p', 247, NULL, NULL, 33473),
(33474, '3.90.660.10-FF-000044', NULL, 'Peroxisomal n1-acetyl-spermine/spermidine oxidase', 221, NULL, NULL, 33474),
(33475, '1.10.8.10-FF-000098', NULL, 'ATP-dependent protease ATPase subunit HslU', 16, NULL, NULL, 33475),
(33476, '3.40.250.10-FF-000058', NULL, 'MercaptoPyruvate SulfurTransferase homolog', 167, NULL, NULL, 33476),
(33477, '2.60.40.10-FF-004002', NULL, NULL, 100, NULL, NULL, 33477),
(33478, '3.90.1200.10-FF-000037', NULL, 'Choline kinase', 244, NULL, NULL, 33478),
(33479, '2.60.120.1180-FF-000001', NULL, 'VP16', 155, NULL, NULL, 33479);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(33480, '3.40.50.300-FF-001917', NULL, 'Guanine nucleotide-binding protein alpha-13 subunit', 185, NULL, NULL, 33480),
(33481, '1.10.287.1040-FF-000017', NULL, 'Exodeoxyribonuclease 7 small subunit', 73, NULL, NULL, 33481),
(33482, '3.30.1370.10-FF-000012', NULL, 'Mex-3 RNA-binding family member D', 77, NULL, NULL, 33482),
(33483, '1.20.900.10-FF-000064', NULL, 'Muscle M-line assembly protein unc-89', 198, NULL, NULL, 33483),
(33484, '3.40.50.410-FF-000039', NULL, 'VWFA and cache domain-containing protein 1', 195, NULL, NULL, 33484),
(33485, '1.10.110.10-FF-000017', NULL, '2S seed storage protein 3', 116, NULL, NULL, 33485),
(33486, '3.30.70.250-FF-000020', NULL, NULL, 58, NULL, NULL, 33486),
(33487, '1.10.510.10-FF-003971', NULL, NULL, 340, NULL, NULL, 33487),
(33488, '1.10.8.10-FF-000322', NULL, 'Predicted protein', 54, NULL, NULL, 33488),
(33489, '2.60.40.10-FF-003204', NULL, 'Babos, isoform A', 104, NULL, NULL, 33489),
(33490, '3.90.70.10-FF-000858', NULL, 'Ubiquitin carboxyl-terminal hydrolase 30', 98, NULL, NULL, 33490),
(33491, '3.40.50.300-FF-002715', NULL, 'Pilus assembly protein', 244, NULL, NULL, 33491),
(33492, '3.40.50.300-FF-002406', NULL, 'Uncharacterized protein', 214, NULL, NULL, 33492),
(33493, '3.40.50.720-FF-001796', NULL, 'Uncharacterized protein', 116, NULL, NULL, 33493),
(33494, '3.30.160.60-FF-004126', NULL, NULL, 30, NULL, NULL, 33494),
(33495, '2.60.40.10-FF-003513', NULL, NULL, 87, NULL, NULL, 33495),
(33496, '3.90.70.10-FF-000830', NULL, 'Uncharacterized protein', 162, NULL, NULL, 33496),
(33497, '3.30.70.270-FF-000026', NULL, 'Transposon Ty3-G Gag-Pol polyprotein', 91, NULL, NULL, 33497),
(33498, '1.50.40.10-FF-000115', NULL, 'Mitochondrial arginine transporter BAC2', 292, NULL, NULL, 33498),
(33499, '2.80.10.50-FF-000184', NULL, 'Fascin', 125, NULL, NULL, 33499),
(33500, '1.20.1560.10-FF-000570', NULL, 'HAlF transporter (PGP related)', 282, NULL, NULL, 33500),
(33501, '3.90.1150.10-FF-000156', NULL, 'Possible aminotransferase', 119, NULL, NULL, 33501),
(33502, '3.30.70.1230-FF-000219', NULL, 'Uncharacterized protein', 79, NULL, NULL, 33502),
(33503, '1.20.1070.10-FF-001196', NULL, 'Uncharacterized protein', 99, NULL, NULL, 33503),
(33504, '2.40.50.140-FF-000844', NULL, NULL, 65, NULL, NULL, 33504),
(33505, '3.10.110.10-FF-000032', NULL, 'probable ubiquitin-conjugating enzyme E2 16', 149, NULL, NULL, 33505),
(33506, '1.10.8.60-FF-000404', NULL, 'Spastin', 84, NULL, NULL, 33506),
(33507, '3.30.310.50-FF-000015', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 86, NULL, NULL, 33507),
(33508, '2.30.29.30-FF-001162', NULL, 'Division mal foutue 1 protein', 104, NULL, NULL, 33508),
(33509, '3.30.70.2150-FF-000001', NULL, 'GlcNAc-binding protein A', 108, NULL, NULL, 33509),
(33510, '2.60.120.260-FF-000585', NULL, 'Uncharacterized protein', 161, NULL, NULL, 33510),
(33511, '3.30.360.10-FF-000102', NULL, 'Similar to Oxidoreductase family', 185, NULL, NULL, 33511),
(33512, '1.20.58.1070-FF-000028', NULL, 'Uncharacterized protein', 154, NULL, NULL, 33512),
(33513, '2.10.70.60-FF-000002', NULL, 'Putative phospholipase B-like 2', 68, NULL, NULL, 33513),
(33514, '2.10.70.80-FF-000008', NULL, 'VPS10 homolog 2', 51, NULL, NULL, 33514),
(33515, '3.80.10.10-FF-002968', NULL, 'Uncharacterized protein', 121, NULL, NULL, 33515),
(33516, '3.30.450.60-FF-000085', NULL, 'Signal recognition particle receptor subunit alpha homolog', 129, NULL, NULL, 33516),
(33517, '1.20.5.490-FF-000013', NULL, 'Uncharacterized protein', 45, NULL, NULL, 33517),
(33518, '3.10.50.10-FF-000068', NULL, 'Class V chitinase, putative', 31, NULL, NULL, 33518),
(33519, '1.10.555.10-FF-000196', NULL, NULL, 153, NULL, NULL, 33519),
(33520, '3.30.70.1070-FF-000020', NULL, 'Peptidoglycan L,D-transpeptidase lipoprotein, YkuD family, SPOR domain-containing', 72, NULL, NULL, 33520),
(33521, '2.130.10.10-FF-003036', NULL, 'Coatomer beta'' subunit', 153, NULL, NULL, 33521),
(33522, '1.10.510.10-FF-004016', NULL, NULL, 125, NULL, NULL, 33522),
(33523, '2.170.270.10-FF-000009', NULL, 'SET domain-containing protein 5', 253, NULL, NULL, 33523);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(33524, '3.50.30.30-FF-000043', NULL, 'E3 ubiquitin-protein ligase RNF130', 42, NULL, NULL, 33524),
(33525, '1.20.1560.10-FF-000126', NULL, 'Putative ABC transporter B family member 8', 346, NULL, NULL, 33525),
(33526, '2.60.40.2160-FF-000008', NULL, NULL, 181, NULL, NULL, 33526),
(33527, '1.10.287.130-FF-000221', NULL, 'Two-component system sensor histidine kinase', 117, NULL, NULL, 33527),
(33528, '3.30.430.20-FF-000066', NULL, 'Uncharacterized protein', 106, NULL, NULL, 33528),
(33529, '2.60.420.10-FF-000003', NULL, 'Protein-glucosylgalactosylhydroxylysine glucosidase', 81, NULL, NULL, 33529),
(33530, '1.10.1420.10-FF-000023', NULL, 'DNA mismatch repair protein', 229, NULL, NULL, 33530),
(33531, '3.90.190.10-FF-000524', NULL, 'Predicted protein', 111, NULL, NULL, 33531),
(33532, '1.20.5.440-FF-000004', NULL, 'Stomatal closure-related actin-binding protein', 52, NULL, NULL, 33532),
(33533, '3.30.420.280-FF-000002', NULL, 'Terminase large subunit', 194, NULL, NULL, 33533),
(33534, '2.30.30.40-FF-000499', NULL, 'BAR domaincontaining protein', 60, NULL, NULL, 33534),
(33535, '3.30.70.560-FF-000006', NULL, 'Folic acid synthesis protein fol1', 207, NULL, NULL, 33535),
(33536, '2.60.40.200-FF-000036', NULL, 'Superoxide dismutase [cu-zn], putative', 46, NULL, NULL, 33536),
(33537, '1.20.1090.10-FF-000062', NULL, 'Uncharacterized protein', 212, NULL, NULL, 33537),
(33538, '3.40.50.1100-FF-000122', NULL, 'Cysteine synthase', 186, NULL, NULL, 33538),
(33539, '3.40.50.1000-FF-000390', NULL, 'Phosphoserine phosphatase (SerB)', 214, NULL, NULL, 33539),
(33540, '2.130.10.10-FF-002417', NULL, 'Uncharacterized protein', 90, NULL, NULL, 33540),
(33541, '2.10.25.10-FF-000506', NULL, 'Adhesion G protein-coupled receptor E1', 40, NULL, NULL, 33541),
(33542, '1.20.1560.10-FF-000699', NULL, 'ABC transporter related', 335, NULL, NULL, 33542),
(33543, '3.30.200.20-FF-001555', NULL, 'Serine/threonine-protein kinase mos', 134, NULL, NULL, 33543),
(33544, '3.30.310.10-FF-000054', NULL, 'TATA-box-binding protein', 60, NULL, NULL, 33544),
(33545, '3.30.1370.10-FF-000057', NULL, 'High density lipoprotein binding protein', 72, NULL, NULL, 33545),
(33546, '3.30.70.330-FF-001803', NULL, NULL, 151, NULL, NULL, 33546),
(33547, '3.40.50.300-FF-007066', NULL, 'Uncharacterized protein', 194, NULL, NULL, 33547),
(33548, '3.40.50.620-FF-000664', NULL, 'Valyl-tRNA synthetase 2, mitochondrial', 160, NULL, NULL, 33548),
(33549, '3.20.20.80-FF-000250', NULL, 'Probable di-N-acetylchitobiase 1', 208, NULL, NULL, 33549),
(33550, '3.30.40.10-FF-000623', NULL, 'Uncharacterized protein, isoform A', 82, NULL, NULL, 33550),
(33551, '2.20.28.230-FF-000009', NULL, NULL, 56, NULL, NULL, 33551),
(33552, '1.20.58.1020-FF-000007', NULL, 'DNA replication complex GINS protein PSF2', 111, NULL, NULL, 33552),
(33553, '1.10.1060.10-FF-000040', NULL, NULL, 131, NULL, NULL, 33553),
(33554, '3.40.850.10-FF-000356', NULL, 'Uncharacterized protein', 87, NULL, NULL, 33554),
(33555, '2.10.25.10-FF-001125', NULL, 'Delta-like protein', 37, NULL, NULL, 33555),
(33556, '3.90.260.10-FF-000070', NULL, 'Chromosome 15, whole genome shotgun sequence', 158, NULL, NULL, 33556),
(33557, '2.60.120.260-FF-000113', NULL, 'Conserved transmembrane protein', 134, NULL, NULL, 33557),
(33558, '3.90.70.10-FF-000066', NULL, 'Ubiquitin carboxyl-terminal hydrolase 37', 199, NULL, NULL, 33558),
(33559, '1.20.1110.10-FF-000087', NULL, 'Na+\K+ ATPase alpha subunit, putative', 149, NULL, NULL, 33559),
(33560, '1.20.1070.10-FF-000162', NULL, 'Muscarinic acetylcholine receptor', 306, NULL, NULL, 33560),
(33561, '2.60.120.290-FF-000009', NULL, 'Metalloendopeptidase', 116, NULL, NULL, 33561),
(33562, '1.10.1450.10-FF-000103', NULL, 'Tetraspanin', 111, NULL, NULL, 33562),
(33563, '3.40.50.300-FF-004531', NULL, 'F10O3.15 protein', 112, NULL, NULL, 33563),
(33564, '1.25.40.10-FF-003743', NULL, 'Uncharacterized protein', 172, NULL, NULL, 33564),
(33565, '3.30.360.10-FF-000001', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', 166, NULL, NULL, 33565),
(33566, '1.10.10.10-FF-000407', NULL, 'IclR family transcriptional regulator', 75, NULL, NULL, 33566);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(33567, '3.50.50.60-FF-000969', NULL, 'Uncharacterized protein', 84, NULL, NULL, 33567),
(33568, '3.10.330.10-FF-000043', NULL, 'Uncharacterized protein', 86, NULL, NULL, 33568),
(33569, '1.20.120.1380-FF-000005', NULL, 'Flagellar biosynthesis regulator FlhF', 50, NULL, NULL, 33569),
(33570, '3.30.420.80-FF-000004', NULL, '30S ribosomal protein S11', 129, NULL, NULL, 33570),
(33571, '1.10.510.10-FF-003869', NULL, NULL, 95, NULL, NULL, 33571),
(33572, '3.30.40.10-FF-000724', NULL, 'RING-H2 finger protein ATL56', 73, NULL, NULL, 33572),
(33573, '2.130.10.10-FF-001271', NULL, 'Probable U3 small nucleolar RNA-associated protein 7', 152, NULL, NULL, 33573),
(33574, '3.30.830.10-FF-000155', NULL, 'Metalloenzyme, LuxS/M16 peptidase-like protein', 212, NULL, NULL, 33574),
(33575, '3.80.10.10-FF-000506', NULL, 'F-box/LRR-repeat protein 16 isoform X2', 101, NULL, NULL, 33575),
(33576, '3.30.160.60-FF-004598', NULL, NULL, 28, NULL, NULL, 33576),
(33577, '2.10.25.10-FF-000361', NULL, 'von Willebrand factor C and EGF domain-containing protein', 41, NULL, NULL, 33577),
(33578, '3.40.1110.10-FF-000457', NULL, NULL, 129, NULL, NULL, 33578),
(33579, '3.30.530.20-FF-000130', NULL, 'Uncharacterized protein', 148, NULL, NULL, 33579),
(33580, '3.30.160.60-FF-000899', NULL, 'zinc finger protein 558 isoform X2', 28, NULL, NULL, 33580),
(33581, '1.10.630.10-FF-000270', NULL, 'Fatty acid alpha hydroxylase', 414, NULL, NULL, 33581),
(33582, '3.10.280.10-FF-000027', NULL, 'Uncharacterized protein At2g39790, mitochondrial', 182, NULL, NULL, 33582),
(33583, '1.20.120.160-FF-000014', NULL, 'Chemotaxis protein CheA', 140, NULL, NULL, 33583),
(33584, '3.40.640.10-FF-000447', NULL, 'Uncharacterized protein', 50, NULL, NULL, 33584),
(33585, '3.40.50.12780-FF-000106', NULL, 'Putative fatty-acid--CoA ligase fadD11', 213, NULL, NULL, 33585),
(33586, '1.20.1560.10-FF-000227', NULL, 'ABC transporter ATP-binding protein', 33, NULL, NULL, 33586),
(33587, '1.10.1050.10-FF-000011', NULL, '37S ribosomal protein S4-like, mitochondrial', 58, NULL, NULL, 33587),
(33588, '3.80.10.10-FF-003115', NULL, 'Tropomodulin, putative', 96, NULL, NULL, 33588),
(33589, '3.40.50.10860-FF-000053', NULL, 'Shikimate dehydrogenase (NADP(+))', 118, NULL, NULL, 33589),
(33590, '2.10.50.40-FF-000001', NULL, 'Protein DBF4 homolog A', 19, NULL, NULL, 33590),
(33591, '1.20.1280.50-FF-000206', NULL, 'Uncharacterized protein', 61, NULL, NULL, 33591),
(33592, '3.80.10.10-FF-004205', NULL, 'Immunoglobulin superfamily, member 10', 88, NULL, NULL, 33592),
(33593, '3.40.50.300-FF-008230', NULL, 'Uncharacterized protein', 60, NULL, NULL, 33593),
(33594, '1.25.10.10-FF-002870', NULL, 'Uncharacterized protein', 155, NULL, NULL, 33594),
(33595, '3.30.457.60-FF-000004', NULL, 'Mitotic spindle checkpoint protein MAD1', 87, NULL, NULL, 33595),
(33596, '3.30.160.60-FF-005115', NULL, NULL, 27, NULL, NULL, 33596),
(33597, '2.60.40.10-FF-004957', NULL, NULL, 88, NULL, NULL, 33597),
(33598, '1.10.10.2120-FF-000003', NULL, 'Predicted protein', 52, NULL, NULL, 33598),
(33599, '1.10.12.10-FF-000024', NULL, 'Putative enoyl-CoA hydratase ECHA1', 58, NULL, NULL, 33599),
(33600, '3.40.47.10-FF-000020', NULL, 'Putative trifunctional enzyme subunit beta mitochondrial', 427, NULL, NULL, 33600),
(33601, '1.10.418.10-FF-000030', NULL, 'Related to alpha-actinin', 119, NULL, NULL, 33601),
(33602, '3.40.50.150-FF-000383', NULL, 'Leucine carboxyl methyltransferase 2', 334, NULL, NULL, 33602),
(33603, '1.10.287.10-FF-000022', NULL, 'Glycine--tRNA ligase', 51, NULL, NULL, 33603),
(33604, '3.70.10.10-FF-000131', NULL, 'Checkpoint protein', 288, NULL, NULL, 33604),
(33605, '1.10.10.990-FF-000006', NULL, 'RecBCD enzyme subunit RecC', 80, NULL, NULL, 33605),
(33606, '1.10.510.10-FF-000418', NULL, 'PTEN induced kinase 1', 246, NULL, NULL, 33606),
(33607, '3.40.50.1820-FF-000192', NULL, 'Caffeoylshikimate esterase', 298, NULL, NULL, 33607),
(33608, '3.30.70.330-FF-001258', NULL, 'RNA recognition motif domain containing protein', 140, NULL, NULL, 33608),
(33609, '3.90.1150.10-FF-000364', NULL, 'Erythromycin biosynthesis sensory transduction protein eryC1', 118, NULL, NULL, 33609);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(33610, '3.40.50.10980-FF-000004', NULL, 'LD44438p', 48, NULL, NULL, 33610),
(33611, '1.25.10.10-FF-003123', NULL, 'Predicted protein', 207, NULL, NULL, 33611),
(33612, '3.40.50.720-FF-001015', NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase family protein', 98, NULL, NULL, 33612),
(33613, '3.40.50.740-FF-000037', NULL, 'NADH-quinone oxidoreductase', 249, NULL, NULL, 33613),
(33614, '3.40.50.150-FF-000074', NULL, 'Cyclopropane-fatty-acyl-phospholipid synthase family protein', 268, NULL, NULL, 33614),
(33615, '3.10.110.10-FF-000133', NULL, 'Putative ubiquitin-conjugating enzyme E2 38', 282, NULL, NULL, 33615),
(33616, '4.10.1250.10-FF-000007', NULL, 'Uncharacterized protein', 36, NULL, NULL, 33616),
(33617, '2.60.40.10-FF-005430', NULL, NULL, 98, NULL, NULL, 33617),
(33618, '3.90.79.10-FF-000041', NULL, 'Dihydroneopterin triphosphate pyrophosphatase', 150, NULL, NULL, 33618),
(33619, '3.30.70.330-FF-000847', NULL, 'Os05g0223300 protein', 98, NULL, NULL, 33619),
(33620, '3.30.160.60-FF-003833', NULL, NULL, 31, NULL, NULL, 33620),
(33621, '3.30.40.10-FF-001343', NULL, 'PHD finger family', 84, NULL, NULL, 33621),
(33622, '1.20.1740.10-FF-000224', NULL, 'Uncharacterized protein', 449, NULL, NULL, 33622),
(33623, '1.10.238.10-FF-000510', NULL, 'Protein CBG14543', 73, NULL, NULL, 33623),
(33624, '3.30.160.60-FF-001164', NULL, 'C2H2 finger domain protein, putative', 34, NULL, NULL, 33624),
(33625, '1.25.40.10-FF-002107', NULL, 'Uncharacterized protein, isoform C', 140, NULL, NULL, 33625),
(33626, '3.80.10.10-FF-003688', NULL, 'Probable disease resistance protein At5g45510', 185, NULL, NULL, 33626),
(33627, '3.30.160.60-FF-002136', NULL, 'Zinc finger protein 721', 28, NULL, NULL, 33627),
(33628, '3.30.930.10-FF-000011', NULL, 'Alanine--tRNA ligase, cytoplasmic', 252, NULL, NULL, 33628),
(33629, '3.60.21.10-FF-000460', NULL, 'Uncharacterized protein', 152, NULL, NULL, 33629),
(33630, '3.90.190.10-FF-000199', NULL, 'Dual specificity protein phosphatase, putative', 149, NULL, NULL, 33630),
(33631, '2.170.270.10-FF-000217', NULL, 'Predicted protein', 138, NULL, NULL, 33631),
(33632, '3.80.10.10-FF-000153', NULL, 'centriolin isoform X1', 99, NULL, NULL, 33632),
(33633, '2.130.10.10-FF-004817', NULL, 'WD repeat-containing protein JIP5', 138, NULL, NULL, 33633),
(33634, '3.30.70.330-FF-002995', NULL, NULL, 85, NULL, NULL, 33634),
(33635, '2.60.40.150-FF-000594', NULL, 'Uncharacterized protein', 111, NULL, NULL, 33635),
(33636, '3.40.50.12780-FF-000207', NULL, 'Probable auxin-responsive-like protein', 255, NULL, NULL, 33636),
(33637, '3.80.10.10-FF-003379', NULL, 'Uncharacterized protein', 265, NULL, NULL, 33637),
(33638, '3.40.50.2000-FF-000280', NULL, 'ADP-heptose:LPS heptosyltransferase', 175, NULL, NULL, 33638),
(33639, '1.10.580.10-FF-000029', NULL, 'Citrate synthase family protein', 85, NULL, NULL, 33639),
(33640, '3.40.850.10-FF-000148', NULL, 'Predicted protein', 171, NULL, NULL, 33640),
(33641, '3.30.200.20-FF-001347', NULL, 'Receptor protein serine/threonine kinase', 100, NULL, NULL, 33641),
(33642, '1.10.10.10-FF-001835', NULL, 'Uncharacterized protein', 93, NULL, NULL, 33642),
(33643, '3.40.50.80-FF-000149', NULL, 'NADPH-dependent diflavin oxidoreductase 1', 155, NULL, NULL, 33643),
(33644, '3.40.50.200-FF-000196', NULL, 'Uncharacterized protein', 93, NULL, NULL, 33644),
(33645, '3.40.850.10-FF-000457', NULL, 'Predicted protein', 61, NULL, NULL, 33645),
(33646, '3.40.605.10-FF-000141', NULL, 'Uncharacterized protein', 106, NULL, NULL, 33646),
(33647, '3.40.50.300-FF-005357', NULL, 'Preprotein translocase subunit SecA', 199, NULL, NULL, 33647),
(33648, '3.30.200.20-FF-001190', NULL, 'Interleukin-1 receptor-associated kinase 4', 103, NULL, NULL, 33648),
(33649, '1.10.1600.10-FF-000020', NULL, 'Potential Ku DNA binding protein subunit', 97, NULL, NULL, 33649),
(33650, '3.30.10.10-FF-000003', NULL, 'Serine protease inhibitor, potato inhibitor I-type family protein', 70, NULL, NULL, 33650),
(33651, '3.40.50.620-FF-000456', NULL, 'Probable tRNA sulfurtransferase', 192, NULL, NULL, 33651),
(33652, '1.25.40.180-FF-000080', NULL, 'Chromosome 9, whole genome shotgun sequence', 232, NULL, NULL, 33652);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(33653, '3.40.50.1820-FF-000776', NULL, 'Endo-1,4-beta-xylanase Z', 270, NULL, NULL, 33653),
(33654, '1.10.287.130-FF-000013', NULL, 'Sensor histidine kinase PhoQ', 110, NULL, NULL, 33654),
(33655, '3.40.50.12780-FF-000095', NULL, 'Acyl-activating enzyme 15', 319, NULL, NULL, 33655),
(33656, '1.20.1070.10-FF-000971', NULL, 'Predicted protein', 180, NULL, NULL, 33656),
(33657, '1.20.1280.290-FF-000028', NULL, 'Vacuolar membrane protein, putative', 97, NULL, NULL, 33657),
(33658, '2.60.120.200-FF-000466', NULL, 'Uncharacterized protein', 164, NULL, NULL, 33658),
(33659, '3.30.160.60-FF-001063', NULL, 'zinc finger protein 746 isoform X1', 28, NULL, NULL, 33659),
(33660, '3.40.30.10-FF-000234', NULL, 'Thioredoxin-like 4, chloroplastic', 137, NULL, NULL, 33660),
(33661, '3.30.70.141-FF-000005', NULL, 'Nucleoside diphosphate kinase', 153, NULL, NULL, 33661),
(33662, '3.40.640.10-FF-000402', NULL, 'Uncharacterized aminotransferase C1771.03c', 278, NULL, NULL, 33662),
(33663, '2.40.40.20-FF-000015', NULL, 'spermatogenesis-associated protein 5 isoform X2', 90, NULL, NULL, 33663),
(33664, '3.40.50.2000-FF-000381', NULL, 'Alpha,alpha-trehalose-phosphate synthase [UDP-forming], putative', 273, NULL, NULL, 33664),
(33665, '3.40.50.720-FF-001116', NULL, '2-hydroxyacid dehydrogenase family protein', 121, NULL, NULL, 33665),
(33666, '3.90.1170.40-FF-000014', NULL, 'Molybdopterin synthase catalytic subunit', 135, NULL, NULL, 33666),
(33667, '1.25.40.10-FF-001270', NULL, 'Protein NPG1', 296, NULL, NULL, 33667),
(33668, '2.60.40.10-FF-005885', NULL, NULL, 110, NULL, NULL, 33668),
(33669, '1.10.10.10-FF-001127', NULL, 'DNA-binding response regulator', 111, NULL, NULL, 33669),
(33670, '1.10.238.10-FF-000201', NULL, 'Spectrin alpha chain, erythrocytic 1', 68, NULL, NULL, 33670),
(33671, '3.30.260.10-FF-000038', NULL, 'Thermosome subunit', 107, NULL, NULL, 33671),
(33672, '2.160.20.10-FF-000096', NULL, 'Exopolygalacturonase clone GBGE184', 372, NULL, NULL, 33672),
(33673, '3.30.160.60-FF-003772', NULL, NULL, 26, NULL, NULL, 33673),
(33674, '4.10.400.10-FF-000152', NULL, 'Transmembrane protease serine 2', 37, NULL, NULL, 33674),
(33675, '2.130.10.10-FF-005554', NULL, 'Protein CBG03541', 221, NULL, NULL, 33675),
(33676, '2.10.25.10-FF-001333', NULL, 'Predicted protein', 40, NULL, NULL, 33676),
(33677, '2.60.40.10-FF-003176', NULL, 'Tenascin C', 90, NULL, NULL, 33677),
(33678, '2.60.120.200-FF-000511', NULL, 'Bacillopeptidase F', 176, NULL, NULL, 33678),
(33679, '3.30.110.120-FF-000002', NULL, 'Acylphosphatase', 55, NULL, NULL, 33679),
(33680, '2.40.50.140-FF-000389', NULL, 'RIM1p ssDNA-binding protein', 121, NULL, NULL, 33680),
(33681, '3.90.180.10-FF-000125', NULL, 'Putative mannitol dehydrogenase', 67, NULL, NULL, 33681),
(33682, '3.80.10.10-FF-003587', NULL, 'Uncharacterized protein', 134, NULL, NULL, 33682),
(33683, '3.40.50.300-FF-006869', NULL, 'Uncharacterized protein', 253, NULL, NULL, 33683),
(33684, '4.10.240.10-FF-000150', NULL, 'Uncharacterized protein', 73, NULL, NULL, 33684),
(33685, '3.40.50.1000-FF-000081', NULL, 'Haloacid dehalogenase like hydrolase domain containing 5', 159, NULL, NULL, 33685),
(33686, '2.130.10.10-FF-002209', NULL, 'Uncharacterized protein', 83, NULL, NULL, 33686),
(33687, '1.10.565.10-FF-000005', NULL, 'Nuclear orphan receptor ROR-beta', 260, NULL, NULL, 33687),
(33688, '1.25.40.10-FF-004041', NULL, 'Os05g0418500 protein', 177, NULL, NULL, 33688),
(33689, '2.30.29.30-FF-000689', NULL, 'RIKEN cDNA 1700003H04 gene', 117, NULL, NULL, 33689),
(33690, '3.80.10.10-FF-000714', NULL, 'Si:ch211-149a19.3', 121, NULL, NULL, 33690),
(33691, '3.30.230.10-FF-000109', NULL, 'DNA topoisomerase 2', 127, NULL, NULL, 33691),
(33692, '3.20.20.70-FF-000612', NULL, 'tRNA-dihydrouridine synthase', 269, NULL, NULL, 33692),
(33693, '2.10.70.10-FF-000257', NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', 64, NULL, NULL, 33693),
(33694, '1.20.5.1190-FF-000013', NULL, 'Sodium channel protein', 33, NULL, NULL, 33694),
(33695, '2.120.10.80-FF-000275', NULL, 'Predicted protein', 334, NULL, NULL, 33695);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(33696, '1.20.58.100-FF-000020', NULL, NULL, 92, NULL, NULL, 33696),
(33697, '3.40.50.1000-FF-000401', NULL, 'HAD-IIB family hydrolase', 172, NULL, NULL, 33697),
(33698, '3.30.160.60-FF-001372', NULL, 'zinc finger protein 333 isoform X1', 28, NULL, NULL, 33698),
(33699, '3.30.70.330-FF-000639', NULL, 'Trivet, isoform F', 135, NULL, NULL, 33699),
(33700, '1.10.510.10-FF-001716', NULL, 'Serine/threonine-protein kinase PLK', 177, NULL, NULL, 33700),
(33701, '3.30.9.10-FF-000135', NULL, 'Conserved within P. aerophilum', 131, NULL, NULL, 33701),
(33702, '1.10.510.10-FF-001407', NULL, 'Guanylate cyclase', 311, NULL, NULL, 33702),
(33703, '3.40.33.10-FF-000050', NULL, 'Venom allergen-like protein', 195, NULL, NULL, 33703),
(33704, '1.10.10.350-FF-000022', NULL, 'Glutamate--tRNA ligase 2', 97, NULL, NULL, 33704),
(33705, '2.40.50.140-FF-000709', NULL, 'GD14384', 175, NULL, NULL, 33705),
(33706, '2.30.42.10-FF-000091', NULL, 'disks large homolog 1 isoform X8', 99, NULL, NULL, 33706),
(33707, '3.90.470.20-FF-000010', NULL, 'L-aminoadipate-semialdehyde dehydrogenase-phosphopantetheinyl transferase', 102, NULL, NULL, 33707),
(33708, '1.10.238.10-FF-001027', NULL, 'Uncharacterized protein', 63, NULL, NULL, 33708),
(33709, '3.30.230.10-FF-000098', NULL, 'Elongation factor G, mitochondrial', 137, NULL, NULL, 33709),
(33710, '1.20.1070.10-FF-000515', NULL, 'CholecystoKinin Receptor homolog', 354, NULL, NULL, 33710),
(33711, '3.30.70.330-FF-001466', NULL, 'Uncharacterized protein (Fragment)', 145, NULL, NULL, 33711),
(33712, '3.10.580.10-FF-000174', NULL, 'Voltage-gated chloride channel', 124, NULL, NULL, 33712),
(33713, '4.10.280.10-FF-000164', NULL, 'Putative dna-binding protein inhibitor', 61, NULL, NULL, 33713),
(33714, '6.10.250.3260-FF-000002', NULL, '60S ribosomal protein L21', 60, NULL, NULL, 33714),
(33715, '3.80.10.10-FF-000462', NULL, 'centrosomal protein of 97 kDa isoform X2', 161, NULL, NULL, 33715),
(33716, '3.60.60.10-FF-000027', NULL, 'Predicted protein', 55, NULL, NULL, 33716),
(33717, '1.10.30.10-FF-000100', NULL, 'Sex-determining region Y protein', 52, NULL, NULL, 33717),
(33718, '2.70.150.10-FF-000042', NULL, 'Plasma membrane ATPase', 84, NULL, NULL, 33718),
(33719, '3.30.160.60-FF-005981', NULL, NULL, 91, NULL, NULL, 33719),
(33720, '3.60.21.10-FF-000252', NULL, 'Protein phosphatase 2B, putative', 80, NULL, NULL, 33720),
(33721, '1.10.287.110-FF-000327', NULL, 'Uncharacterized protein', 89, NULL, NULL, 33721),
(33722, '3.80.10.10-FF-002862', NULL, 'P-granule-associated novel protein 1', 122, NULL, NULL, 33722),
(33723, '2.60.40.60-FF-000869', NULL, 'Uncharacterized protein', 102, NULL, NULL, 33723),
(33724, '2.60.210.10-FF-000066', NULL, NULL, 47, NULL, NULL, 33724),
(33725, '2.60.40.150-FF-000094', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', 162, NULL, NULL, 33725),
(33726, '3.20.20.70-FF-000713', NULL, NULL, 126, NULL, NULL, 33726),
(33727, '1.10.287.690-FF-000012', NULL, 'DNA polymerase', 47, NULL, NULL, 33727),
(33728, '3.30.2090.10-FF-000013', NULL, 'Probable RND efflux transporter', 89, NULL, NULL, 33728),
(33729, '1.25.40.10-FF-004816', NULL, 'Tetratricopeptide repeat domain 21A', 357, NULL, NULL, 33729),
(33730, '3.40.190.10-FF-000665', NULL, 'Prephenate dehydratase', 85, NULL, NULL, 33730),
(33731, '3.90.1420.10-FF-000003', NULL, 'Rubisco methyltransferase family protein', 151, NULL, NULL, 33731),
(33732, '2.130.10.30-FF-000158', NULL, NULL, 142, NULL, NULL, 33732),
(33733, '2.130.10.10-FF-002108', NULL, 'F6N15.8 protein', 87, NULL, NULL, 33733),
(33734, '3.80.10.10-FF-003896', NULL, 'Os12g0273900 protein', 284, NULL, NULL, 33734),
(33735, '3.30.160.60-FF-000444', NULL, 'Zinc finger protein 335', 31, NULL, NULL, 33735),
(33736, '3.20.110.10-FF-000007', NULL, 'Alpha-mannosidase', 382, NULL, NULL, 33736),
(33737, '3.30.160.60-FF-003625', NULL, 'AGAP002702-PA-like protein', 22, NULL, NULL, 33737),
(33738, '3.80.10.10-FF-000962', NULL, 'RE09158p', 207, NULL, NULL, 33738),
(33739, '2.40.33.10-FF-000013', NULL, 'Uncharacterized protein, isoform A', 105, NULL, NULL, 33739);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(33740, '3.30.200.20-FF-001908', NULL, NULL, 90, NULL, NULL, 33740),
(33741, '3.40.50.720-FF-002493', NULL, 'Uncharacterized protein', 158, NULL, NULL, 33741),
(33742, '3.40.50.410-FF-000377', NULL, 'Calcium voltage-gated channel auxiliary subunit alpha2delta 3', 99, NULL, NULL, 33742),
(33743, '1.25.40.10-FF-002916', NULL, 'Pellicle/biofilm biosynthesis protein PelB', 326, NULL, NULL, 33743),
(33744, '1.25.10.10-FF-000161', NULL, 'serine/threonine-protein phosphatase 4 regulatory subunit 1', 311, NULL, NULL, 33744),
(33745, '2.170.300.10-FF-000007', NULL, 'multiple epidermal growth factor-like domains protein 10', 116, NULL, NULL, 33745),
(33746, '2.10.25.10-FF-001434', NULL, 'Multiple epidermal growth factor-like domains protein 8', 76, NULL, NULL, 33746),
(33747, '3.30.60.30-FF-000164', NULL, 'Agrin-like Protein', 46, NULL, NULL, 33747),
(33748, '3.40.140.10-FF-000145', NULL, 'Probable inactive cytidine deaminase 4', 140, NULL, NULL, 33748),
(33749, '3.30.70.330-FF-001567', NULL, NULL, 73, NULL, NULL, 33749),
(33750, '2.60.34.10-FF-000065', NULL, 'DnaK protein', 166, NULL, NULL, 33750),
(33751, '1.20.1070.10-FF-000471', NULL, 'Vomeronasal type-1 receptor', 285, NULL, NULL, 33751),
(33752, '3.60.130.10-FF-000027', NULL, 'L-lysine 4-hydroxylase', 330, NULL, NULL, 33752),
(33753, '3.30.1600.10-FF-000019', NULL, 'NAD-dependent protein deacetylase', 102, NULL, NULL, 33753),
(33754, '3.30.160.60-FF-001725', NULL, 'Zinc finger protein 808', 26, NULL, NULL, 33754),
(33755, '3.30.460.10-FF-000019', NULL, 'tRNA nucleotidyltransferase cca2', 168, NULL, NULL, 33755),
(33756, '3.30.470.20-FF-000192', NULL, 'Uncharacterized protein', 21, NULL, NULL, 33756),
(33757, '2.130.10.10-FF-000411', NULL, 'U4/U6 small nuclear ribonucleoprotein Prp4', 162, NULL, NULL, 33757),
(33758, '3.40.50.720-FF-001987', NULL, 'Predicted protein', 244, NULL, NULL, 33758),
(33759, '3.40.50.300-FF-001889', NULL, 'DNA replication helicase/nuclease 2', 161, NULL, NULL, 33759),
(33760, '3.40.50.2300-FF-001426', NULL, NULL, 25, NULL, NULL, 33760),
(33761, '1.10.10.10-FF-001627', NULL, 'Transcriptional regulator, marR family, putative', 144, NULL, NULL, 33761),
(33762, '3.80.10.10-FF-000815', NULL, 'serine/threonine-protein kinase BRI1-like 2', 112, NULL, NULL, 33762),
(33763, '3.30.70.330-FF-000286', NULL, 'Putative pre-mRNA branch site protein p14', 108, NULL, NULL, 33763),
(33764, '2.30.42.10-FF-000309', NULL, 'Pro-apoptotic serine protease NMA111', 94, NULL, NULL, 33764),
(33765, '1.10.630.10-FF-000692', NULL, 'Os06g0204100 protein', 146, NULL, NULL, 33765),
(33766, '2.130.10.10-FF-002783', NULL, 'WD repeat domain 44', 214, NULL, NULL, 33766),
(33767, '3.30.420.210-FF-000009', NULL, 'Unplaced genomic scaffold supercont2.17, whole genome shotgun sequence', 64, NULL, NULL, 33767),
(33768, '3.40.30.10-FF-000026', NULL, 'Glutaredoxin 2', 106, NULL, NULL, 33768),
(33769, '3.40.1180.10-FF-000040', NULL, 'Uncharacterized protein', 111, NULL, NULL, 33769),
(33770, '2.30.29.30-FF-000998', NULL, 'Uncharacterized protein', 130, NULL, NULL, 33770),
(33771, '3.40.50.720-FF-000498', NULL, 'Uncharacterized protein, isoform A', 265, NULL, NULL, 33771),
(33772, '2.40.30.30-FF-000001', NULL, 'Riboflavin biosynthesis protein', 125, NULL, NULL, 33772),
(33773, '3.40.1690.10-FF-000017', NULL, 'Flagellar biosynthetic protein FlhB', 140, NULL, NULL, 33773),
(33774, '2.30.29.30-FF-000897', NULL, 'Dynamin 2', 116, NULL, NULL, 33774),
(33775, '1.50.10.140-FF-000001', NULL, 'Cyclic beta-1,2-glucan synthase', 153, NULL, NULL, 33775),
(33776, '1.10.510.10-FF-001863', NULL, 'TUBE', 146, NULL, NULL, 33776),
(33777, '1.25.10.10-FF-001442', NULL, 'Uncharacterized protein', 33, NULL, NULL, 33777),
(33778, '3.40.1670.10-FF-000004', NULL, 'Ferulic acid decarboxylase 1', 128, NULL, NULL, 33778),
(33779, '1.20.1070.10-FF-001696', NULL, 'Predicted protein', 110, NULL, NULL, 33779),
(33780, '3.40.630.10-FF-000121', NULL, 'GPI transamidase component (GAA1), putative', 251, NULL, NULL, 33780),
(33781, '1.20.1560.10-FF-000935', NULL, 'Uncharacterized protein', 631, NULL, NULL, 33781);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(33782, '2.60.40.10-FF-003985', NULL, NULL, 101, NULL, NULL, 33782),
(33783, '2.40.50.150-FF-000038', NULL, 'Predicted protein', 27, NULL, NULL, 33783),
(33784, '2.30.30.40-FF-000044', NULL, 'E3 ubiquitin-protein ligase MIB2, putative', 77, NULL, NULL, 33784),
(33785, '4.10.410.10-FF-000079', NULL, 'Trypsin inhibitor, putative', 56, NULL, NULL, 33785),
(33786, '1.20.58.390-FF-000062', NULL, 'Neurotransmitter-gated ion-channel transmembrane region', 119, NULL, NULL, 33786),
(33787, '3.40.33.10-FF-000151', NULL, 'Uncharacterized protein', 135, NULL, NULL, 33787),
(33788, '1.20.120.1770-FF-000015', NULL, 'Uncharacterized protein', 187, NULL, NULL, 33788),
(33789, '3.40.50.150-FF-001355', NULL, NULL, 189, NULL, NULL, 33789),
(33790, '3.30.460.10-FF-000166', NULL, 'Predicted protein', 134, NULL, NULL, 33790),
(33791, '3.30.1370.110-FF-000010', NULL, 'Unplaced genomic scaffold supercont2.20, whole genome shotgun sequence', 96, NULL, NULL, 33791),
(33792, '1.10.565.10-FF-000213', NULL, 'Protein CBG13679', 186, NULL, NULL, 33792),
(33793, '3.50.50.60-FF-001121', NULL, 'Uncharacterized protein', 140, NULL, NULL, 33793),
(33794, '2.30.29.30-FF-000425', NULL, 'mRNA-decapping enzyme 1B', 127, NULL, NULL, 33794),
(33795, '1.25.10.10-FF-002976', NULL, 'Predicted protein', 401, NULL, NULL, 33795),
(33796, '1.10.260.40-FF-000099', NULL, 'Predicted transcriptional regulator, XRE family', 73, NULL, NULL, 33796),
(33797, '3.40.50.2300-FF-000717', NULL, 'TMAO reductase system periplasmic protein TorT', 134, NULL, NULL, 33797),
(33798, '3.30.1360.120-FF-000051', NULL, 'Sarcosine oxidase, gamma subunit', 96, NULL, NULL, 33798),
(33799, '1.25.70.10-FF-000035', NULL, 'Protein CBG19300', 290, NULL, NULL, 33799),
(33800, '3.30.200.20-FF-001246', NULL, 'Large tumor suppressor kinase 1', 123, NULL, NULL, 33800),
(33801, '1.10.20.10-FF-000127', NULL, 'Bip2 protein', 88, NULL, NULL, 33801),
(33802, '4.10.280.10-FF-000063', NULL, 'transcription factor HES-7 isoform X1', 68, NULL, NULL, 33802),
(33803, '1.10.510.10-FF-003763', NULL, NULL, 139, NULL, NULL, 33803),
(33804, '3.30.160.60-FF-001939', NULL, 'Zinc finger protein 551', 28, NULL, NULL, 33804),
(33805, '3.30.1330.30-FF-000044', NULL, 'Apicoplast RNA methyltransferase, putative', 89, NULL, NULL, 33805),
(33806, '2.60.120.260-FF-000377', NULL, 'Uncharacterized protein', 59, NULL, NULL, 33806),
(33807, '1.10.10.10-FF-000301', NULL, 'Homoprotocatechuate degradation operon regulator HpaR', 134, NULL, NULL, 33807),
(33808, '3.50.50.60-FF-001430', NULL, 'Predicted protein', 115, NULL, NULL, 33808),
(33809, '2.130.10.10-FF-003536', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', 307, NULL, NULL, 33809),
(33810, '1.10.150.240-FF-000030', NULL, 'HAD hydrolase, family IA, variant 3', 70, NULL, NULL, 33810),
(33811, '3.40.1380.20-FF-000053', NULL, 'Pyruvate kinase', 136, NULL, NULL, 33811),
(33812, '3.40.50.1820-FF-001748', NULL, 'Uncharacterized protein', 51, NULL, NULL, 33812),
(33813, '2.10.50.10-FF-000149', NULL, 'Tumor necrosis factor receptor superfamily member 10B', 40, NULL, NULL, 33813),
(33814, '1.20.58.60-FF-000442', NULL, 'Spectrin repeat containing, nuclear envelope 1a', 151, NULL, NULL, 33814),
(33815, '3.40.50.11340-FF-000006', NULL, 'Galactoside 2-alpha-L-fucosyltransferase-like', 54, NULL, NULL, 33815),
(33816, '2.60.40.10-FF-001068', NULL, 'interleukin-12 receptor subunit beta-2 isoform X1', 108, NULL, NULL, 33816),
(33817, '2.130.10.10-FF-002311', NULL, 'GD12443', 153, NULL, NULL, 33817),
(33818, '3.40.50.300-FF-001417', NULL, 'DNA replication licensing factor MCM8', 335, NULL, NULL, 33818),
(33819, '3.30.420.110-FF-000013', NULL, 'DNA mismatch repair protein', 168, NULL, NULL, 33819),
(33820, '1.20.1070.10-FF-000723', NULL, 'Uncharacterized protein', 141, NULL, NULL, 33820),
(33821, '3.40.50.360-FF-000148', NULL, 'Oxygen-independent protoporphyrinogen oxidase HemG', 109, NULL, NULL, 33821),
(33822, '1.25.10.10-FF-002151', NULL, 'Uncharacterized protein', 527, NULL, NULL, 33822),
(33823, '2.130.10.10-FF-003845', NULL, 'Uncharacterized protein', 290, NULL, NULL, 33823);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(33824, '3.30.70.330-FF-002747', NULL, NULL, 90, NULL, NULL, 33824),
(33825, '1.10.472.10-FF-000672', NULL, 'Uncharacterized protein', 59, NULL, NULL, 33825),
(33826, '3.90.550.10-FF-000423', NULL, 'Procollagen-lysine,2-oxoglutarate 5-dioxygenase 2', 147, NULL, NULL, 33826),
(33827, '1.50.10.160-FF-000012', NULL, 'Ent-copalyl diphosphate synthase', 212, NULL, NULL, 33827),
(33828, '1.20.1250.20-FF-000937', NULL, 'Putative inorganic phosphate cotransporter-like Protein', 184, NULL, NULL, 33828),
(33829, '2.10.25.10-FF-000714', NULL, 'Delta/notch like EGF repeat containing', 41, NULL, NULL, 33829),
(33830, '3.40.1190.20-FF-000223', NULL, NULL, 85, NULL, NULL, 33830),
(33831, '1.10.3080.10-FF-000070', NULL, 'Uncharacterized protein', 169, NULL, NULL, 33831),
(33832, '1.10.10.60-FF-000400', NULL, 'Orthopedia, isoform H', 61, NULL, NULL, 33832),
(33833, '1.20.1250.20-FF-002371', NULL, 'Uncharacterized protein', 292, NULL, NULL, 33833),
(33834, '1.25.10.10-FF-001751', NULL, 'Transportin, putative', 117, NULL, NULL, 33834),
(33835, '3.30.420.510-FF-000026', NULL, 'Uncharacterized protein', 131, NULL, NULL, 33835),
(33836, '3.90.1260.10-FF-000001', NULL, 'Argininosuccinate synthase', 210, NULL, NULL, 33836),
(33837, '1.10.268.20-FF-000003', NULL, 'Dynamin family/50S ribosome-binding GTPase, putative', 148, NULL, NULL, 33837),
(33838, '1.20.120.290-FF-000008', NULL, 'Calcium ion binding protein', 117, NULL, NULL, 33838),
(33839, '1.10.287.260-FF-000001', NULL, 'DNA-directed RNA polymerase', 85, NULL, NULL, 33839),
(33840, '1.20.1640.10-FF-000071', NULL, 'Patched-related protein 9', 195, NULL, NULL, 33840),
(33841, '3.30.450.20-FF-000393', NULL, 'Methyl-accepting chemotaxis protein', 129, NULL, NULL, 33841),
(33842, '2.60.40.10-FF-001731', NULL, 'Sperm acrosome associated 6', 95, NULL, NULL, 33842),
(33843, '2.60.40.420-FF-000208', NULL, 'Ceruloplasmin', 176, NULL, NULL, 33843),
(33844, '1.20.5.420-FF-000009', NULL, 'protein HOMOLOG OF MAMMALIAN LYST-INTERACTING PROTEIN 5-like', 39, NULL, NULL, 33844),
(33845, '3.30.70.590-FF-000004', NULL, 'Poly(A) polymerase gamma', 120, NULL, NULL, 33845),
(33846, '1.10.30.10-FF-000201', NULL, 'Uncharacterized protein', 85, NULL, NULL, 33846),
(33847, '1.10.8.60-FF-000343', NULL, 'Peroxisome assembly protein Pex1p', 95, NULL, NULL, 33847),
(33848, '3.30.40.10-FF-000415', NULL, 'E3 ubiquitin-protein ligase RNF181', 67, NULL, NULL, 33848),
(33849, '3.30.760.10-FF-000082', NULL, 'Uncharacterized protein', 153, NULL, NULL, 33849),
(33850, '2.60.40.420-FF-000096', NULL, 'Multicopper oxidase', 193, NULL, NULL, 33850),
(33851, '1.20.1250.20-FF-000162', NULL, 'disrupted in renal carcinoma protein 2', 418, NULL, NULL, 33851),
(33852, '1.10.238.10-FF-000982', NULL, 'Calcium-binding mitochondrial carrier protein', 106, NULL, NULL, 33852),
(33853, '2.10.25.10-FF-000405', NULL, 'Laminin subunit alpha 5', 41, NULL, NULL, 33853),
(33854, '2.10.110.10-FF-000362', NULL, 'Uncharacterized protein', 56, NULL, NULL, 33854),
(33855, '3.80.10.10-FF-001434', NULL, 'Toll receptor', 116, NULL, NULL, 33855),
(33856, '3.30.1490.120-FF-000006', NULL, 'DNA-directed RNA polymerase', 82, NULL, NULL, 33856),
(33857, '3.30.450.30-FF-000087', NULL, 'Uncharacterized protein', 67, NULL, NULL, 33857),
(33858, '1.10.1040.10-FF-000038', NULL, 'Probable 2-dehydropantoate 2-reductase', 139, NULL, NULL, 33858),
(33859, '2.40.128.180-FF-000003', NULL, 'Uncharacterized protein, isoform C', 84, NULL, NULL, 33859),
(33860, '1.10.238.10-FF-000274', NULL, 'Follistatin-like 1b', 79, NULL, NULL, 33860),
(33861, '3.40.50.300-FF-002131', NULL, 'Uncharacterized ATP-dependent helicase C05C10.2', 198, NULL, NULL, 33861),
(33862, '1.20.5.190-FF-000013', NULL, 'unconventional myosin-IXa isoform X2', 50, NULL, NULL, 33862),
(33863, '2.120.10.30-FF-000619', NULL, 'Uncharacterized protein', 40, NULL, NULL, 33863),
(33864, '4.10.400.10-FF-000253', NULL, 'Modular serine protease', 45, NULL, NULL, 33864),
(33865, '1.20.5.400-FF-000003', NULL, 'Capsid assembly scaffolding protein', 86, NULL, NULL, 33865),
(33866, '3.40.20.10-FF-000099', NULL, 'Putative G-actin binding protein', 135, NULL, NULL, 33866);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(33867, '3.30.70.1730-FF-000032', NULL, '60S acidic ribosomal protein P0', 122, NULL, NULL, 33867),
(33868, '1.20.1250.20-FF-001090', NULL, 'Si:ch211-190o6.3', 227, NULL, NULL, 33868),
(33869, '1.25.10.10-FF-000470', NULL, 'Vacuolar protein 8', 391, NULL, NULL, 33869),
(33870, '3.40.50.11380-FF-000012', NULL, NULL, 35, NULL, NULL, 33870),
(33871, '1.25.40.70-FF-000057', NULL, 'Uncharacterized protein', 197, NULL, NULL, 33871),
(33872, '3.20.20.80-FF-000811', NULL, '1,4-alpha-glucan branching enzyme, putative', 110, NULL, NULL, 33872),
(33873, '3.30.800.10-FF-000018', NULL, 'Phosphatidylinositol-4-phosphate-5-kinase-likep ro tein', 157, NULL, NULL, 33873),
(33874, '1.25.10.10-FF-002370', NULL, 'Cell differentiation, Rcd1-like protein', 277, NULL, NULL, 33874),
(33875, '3.40.50.10380-FF-000021', NULL, 'GH17657p', 255, NULL, NULL, 33875),
(33876, '1.10.3270.10-FF-000005', NULL, '3-hydroxy-3-methylglutaryl coenzyme A reductase', 30, NULL, NULL, 33876),
(33877, '3.30.710.10-FF-000455', NULL, 'Uncharacterized protein', 135, NULL, NULL, 33877),
(33878, '3.40.50.300-FF-000136', NULL, 'Replication factor C subunit 5', 187, NULL, NULL, 33878),
(33879, '3.30.420.40-FF-001077', NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase', 143, NULL, NULL, 33879),
(33880, '1.10.287.1150-FF-000022', NULL, '2-oxoglutarate dehydrogenase E1 component', 79, NULL, NULL, 33880),
(33881, '3.30.70.1620-FF-000005', NULL, 'Structural maintenance of chromosomes 2', 79, NULL, NULL, 33881),
(33882, '3.30.70.330-FF-002186', NULL, NULL, 64, NULL, NULL, 33882),
(33883, '3.30.70.260-FF-000141', NULL, 'D-3-phosphoglycerate dehydrogenase', 79, NULL, NULL, 33883),
(33884, '1.25.40.10-FF-005221', NULL, 'Nonsense-mediated mRNA decay protein', 193, NULL, NULL, 33884),
(33885, '3.70.10.10-FF-000030', NULL, 'Beta sliding clamp', 186, NULL, NULL, 33885),
(33886, '2.60.120.620-FF-000064', NULL, 'Prolyl 4-hydroxylase alpha subunit', 211, NULL, NULL, 33886),
(33887, '3.30.200.20-FF-002527', NULL, NULL, 77, NULL, NULL, 33887),
(33888, '1.25.40.10-FF-003535', NULL, 'Uncharacterized protein', 201, NULL, NULL, 33888),
(33889, '3.30.160.60-FF-002344', NULL, 'Zinc finger protein 333', 24, NULL, NULL, 33889),
(33890, '3.30.420.40-FF-000251', NULL, 'Putative actin-related protein', 67, NULL, NULL, 33890),
(33891, '3.80.10.10-FF-004093', NULL, 'Uncharacterized protein', 122, NULL, NULL, 33891),
(33892, '3.40.50.150-FF-000310', NULL, 'Arginine N-methyltransferase 2', 228, NULL, NULL, 33892),
(33893, '3.40.50.1980-FF-000099', NULL, 'Iron ABC transporter substrate-binding protein', 166, NULL, NULL, 33893),
(33894, '3.40.50.1390-FF-000017', NULL, 'Putative resolvase', 144, NULL, NULL, 33894),
(33895, '3.40.50.620-FF-000355', NULL, 'Cysteinyl-tRNA synthetase, putative', 270, NULL, NULL, 33895),
(33896, '3.30.200.20-FF-000627', NULL, 'Non-specific serine/threonine protein kinase', 93, NULL, NULL, 33896),
(33897, '1.25.40.20-FF-001172', NULL, 'Ankyrin repeat family protein', 34, NULL, NULL, 33897),
(33898, '3.30.160.60-FF-002092', NULL, 'Protein SHOOT GRAVITROPISM 5', 78, NULL, NULL, 33898),
(33899, '1.25.40.10-FF-001635', NULL, 'Lethal (2) k14710, isoform A', 176, NULL, NULL, 33899),
(33900, '2.10.25.10-FF-000153', NULL, 'MUC5B isoform 1', 57, NULL, NULL, 33900),
(33901, '3.90.1750.10-FF-000112', NULL, 'Uncharacterized protein', 32, NULL, NULL, 33901),
(33902, '3.30.420.40-FF-000560', NULL, 'Actin-related protein 8', 77, NULL, NULL, 33902),
(33903, '2.60.40.1670-FF-000007', NULL, 'Protein transport protein SEC23', 162, NULL, NULL, 33903),
(33904, '1.10.510.10-FF-001599', NULL, 'Kinase, STE STE20', 203, NULL, NULL, 33904),
(33905, '2.10.70.10-FF-000151', NULL, 'Complement receptor type 2', 59, NULL, NULL, 33905),
(33906, '3.10.330.20-FF-000001', NULL, 'tRNA (adenine(58)-N(1))-methyltransferase TrmI', 66, NULL, NULL, 33906),
(33907, '3.20.20.140-FF-000232', NULL, 'AMP deaminase', 334, NULL, NULL, 33907),
(33908, '1.20.58.390-FF-000281', NULL, 'Uncharacterized protein', 60, NULL, NULL, 33908),
(33909, '3.30.70.330-FF-002894', NULL, NULL, 56, NULL, NULL, 33909);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(33910, '3.60.21.50-FF-000005', NULL, 'DNA polymerase delta subunit', 275, NULL, NULL, 33910),
(33911, '3.40.710.10-FF-000077', NULL, 'Peptidoglycan D,D-transpeptidase FtsI', 183, NULL, NULL, 33911),
(33912, '1.25.40.10-FF-003844', NULL, 'Uncharacterized protein', 314, NULL, NULL, 33912),
(33913, '2.10.25.10-FF-000861', NULL, 'Nimrod A, isoform E', 68, NULL, NULL, 33913),
(33914, '1.10.150.20-FF-000101', NULL, 'Transcription termination/antitermination protein NusA', 59, NULL, NULL, 33914),
(33915, '3.40.50.620-FF-000911', NULL, 'Uncharacterized protein', 43, NULL, NULL, 33915),
(33916, '3.30.200.20-FF-001802', NULL, 'Kinase, NEK', 89, NULL, NULL, 33916),
(33917, '3.60.10.10-FF-000069', NULL, 'Endonuclease', 248, NULL, NULL, 33917),
(33918, '3.30.70.1230-FF-000074', NULL, 'Guanylate cyclase', 222, NULL, NULL, 33918),
(33919, '3.80.20.20-FF-000100', NULL, 'Predicted protein', 211, NULL, NULL, 33919),
(33920, '1.25.40.10-FF-001399', NULL, 'Pentatricopeptide repeat-containing protein', 189, NULL, NULL, 33920),
(33921, '3.40.1050.10-FF-000031', NULL, 'Carbonic anhydrase', 154, NULL, NULL, 33921),
(33922, '3.30.40.10-FF-001949', NULL, 'Uncharacterized protein', 67, NULL, NULL, 33922),
(33923, '3.30.70.330-FF-002539', NULL, NULL, 44, NULL, NULL, 33923),
(33924, '1.20.5.110-FF-000355', NULL, 'Predicted protein', 67, NULL, NULL, 33924),
(33925, '3.30.160.60-FF-005295', NULL, NULL, 40, NULL, NULL, 33925),
(33926, '1.20.920.10-FF-000200', NULL, 'Uncharacterized protein', 128, NULL, NULL, 33926),
(33927, '3.40.1090.10-FF-000033', NULL, 'Neuropathy target esterase sws', 71, NULL, NULL, 33927),
(33928, '1.20.1610.10-FF-000007', NULL, 'Glycoside hydrolase family 92 protein', 137, NULL, NULL, 33928),
(33929, '1.10.1280.10-FF-000011', NULL, 'Tyrosinase', 426, NULL, NULL, 33929),
(33930, '1.20.58.190-FF-000018', NULL, NULL, 140, NULL, NULL, 33930),
(33931, '2.70.170.10-FF-000060', NULL, 'Nicotinic acetylcholine receptor subunit alpha4', 115, NULL, NULL, 33931),
(33932, '3.20.20.80-FF-000486', NULL, 'Maltase A2', 60, NULL, NULL, 33932),
(33933, '3.30.70.100-FF-000094', NULL, 'Heavy metal-transporting ATPase', 80, NULL, NULL, 33933),
(33934, '1.25.40.10-FF-000887', NULL, 'Pentatricopeptide repeat-containing protein', 132, NULL, NULL, 33934),
(33935, '1.10.8.60-FF-000079', NULL, 'Cell division cycle protein 48 homologue', 92, NULL, NULL, 33935),
(33936, '1.25.40.20-FF-001363', NULL, 'Uncharacterized protein', 95, NULL, NULL, 33936),
(33937, '1.10.10.10-FF-001262', NULL, 'Werner syndrome', 126, NULL, NULL, 33937),
(33938, '2.20.100.10-FF-000033', NULL, 'Isthmin 1', 64, NULL, NULL, 33938),
(33939, '2.60.120.200-FF-000382', NULL, 'LP03809p', 179, NULL, NULL, 33939),
(33940, '2.130.10.10-FF-001136', NULL, 'Unplaced genomic scaffold supercont1.188, whole genome shotgun sequence', 346, NULL, NULL, 33940),
(33941, '3.80.10.10-FF-004284', NULL, 'Uncharacterized protein', 246, NULL, NULL, 33941),
(33942, '1.10.287.70-FF-000225', NULL, 'Likely calcium channel', 138, NULL, NULL, 33942),
(33943, '2.60.40.10-FF-000551', NULL, 'Protogenin A', 106, NULL, NULL, 33943),
(33944, '1.10.472.140-FF-000011', NULL, 'Retinoblastoma-like protein A', 163, NULL, NULL, 33944),
(33945, '1.10.510.10-FF-002588', NULL, 'Serine/threonine-protein kinase VRK1', 354, NULL, NULL, 33945),
(33946, '1.25.40.10-FF-000415', NULL, 'Pentatricopeptide repeat-containing protein', 159, NULL, NULL, 33946),
(33947, '2.40.10.10-FF-000533', NULL, NULL, 95, NULL, NULL, 33947),
(33948, '2.40.160.20-FF-000024', NULL, 'Outer membrane protein', 184, NULL, NULL, 33948),
(33949, '1.10.287.3240-FF-000031', NULL, 'V-type proton ATPase subunit D', 119, NULL, NULL, 33949),
(33950, '2.40.290.10-FF-000047', NULL, 'KU70 protein', 117, NULL, NULL, 33950),
(33951, '2.40.10.10-FF-000005', NULL, 'Serine protease 37', 98, NULL, NULL, 33951),
(33952, '1.20.120.530-FF-000013', NULL, 'GntR family transcriptional regulator', 144, NULL, NULL, 33952),
(33953, '3.30.160.60-FF-005790', NULL, NULL, 27, NULL, NULL, 33953),
(33954, '3.40.190.10-FF-000356', NULL, 'Extracellular solute-binding protein family 5', 27, NULL, NULL, 33954);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(33955, '4.10.280.10-FF-000147', NULL, 'Transcription factor AP-4 (activating enhancer binding protein 4)', 50, NULL, NULL, 33955),
(33956, '3.60.20.30-FF-000020', NULL, NULL, 113, NULL, NULL, 33956),
(33957, '3.30.450.150-FF-000014', NULL, 'Chromosome 1, whole genome shotgun sequence', 171, NULL, NULL, 33957),
(33958, '2.60.40.10-FF-004238', NULL, NULL, 41, NULL, NULL, 33958),
(33959, '3.40.50.1820-FF-001372', NULL, 'Lysophospholipase-like protein 1', 225, NULL, NULL, 33959),
(33960, '1.25.40.10-FF-005305', NULL, 'Adenylyl cyclase class-3/4/guanylyl cyclase', 301, NULL, NULL, 33960),
(33961, '1.20.120.550-FF-000019', NULL, 'Predicted protein', 143, NULL, NULL, 33961),
(33962, '1.20.1280.50-FF-000072', NULL, 'Os08g0230300 protein', 86, NULL, NULL, 33962),
(33963, '1.10.3860.10-FF-000005', NULL, 'Amino acid transporter', 455, NULL, NULL, 33963),
(33964, '3.40.50.1010-FF-000044', NULL, 'DNA repair endonuclease', 134, NULL, NULL, 33964),
(33965, '2.40.40.20-FF-000038', NULL, 'Biotin sulfoxide reductas2', 155, NULL, NULL, 33965),
(33966, '3.40.50.10380-FF-000004', NULL, 'Malic enzyme', 255, NULL, NULL, 33966),
(33967, '2.130.10.30-FF-000052', NULL, 'RCC1 domain containing 1', 107, NULL, NULL, 33967),
(33968, '1.20.930.40-FF-000024', NULL, 'YALI0A20416p', 151, NULL, NULL, 33968),
(33969, '4.10.970.10-FF-000003', NULL, 'ATP-dependent DNA helicase II subunit 1', 65, NULL, NULL, 33969),
(33970, '1.10.3500.10-FF-000007', NULL, 'Transcription elongation factor spt6', 299, NULL, NULL, 33970),
(33971, '2.40.10.10-FF-000640', NULL, NULL, 179, NULL, NULL, 33971),
(33972, '1.10.720.180-FF-000001', NULL, 'Decaheme cytochrome c MtrF', 50, NULL, NULL, 33972),
(33973, '3.30.160.60-FF-003856', NULL, NULL, 28, NULL, NULL, 33973),
(33974, '2.130.10.10-FF-005514', NULL, 'Uncharacterized protein', 76, NULL, NULL, 33974),
(33975, '3.40.1090.10-FF-000140', NULL, 'Uncharacterized protein', 83, NULL, NULL, 33975),
(33976, '3.30.1240.10-FF-000059', NULL, 'HAD family hydrolase', 103, NULL, NULL, 33976),
(33977, '3.40.50.720-FF-000576', NULL, 'N-acetyl-gamma-glutamyl-phosphate reductase', 150, NULL, NULL, 33977),
(33978, '3.50.4.10-FF-000023', NULL, 'Uncharacterized protein', 77, NULL, NULL, 33978),
(33979, '1.10.10.60-FF-001125', NULL, NULL, 63, NULL, NULL, 33979),
(33980, '3.40.50.790-FF-000030', NULL, 'Ribosomal L1 domain-containing protein CG13096-like Protein', 96, NULL, NULL, 33980),
(33981, '1.10.3090.10-FF-000008', NULL, 'Polynucleotide adenylyltransferase family protein', 222, NULL, NULL, 33981),
(33982, '3.90.640.10-FF-000189', NULL, 'Molecular chaperone DnaK', 81, NULL, NULL, 33982),
(33983, '2.60.40.10-FF-001484', NULL, 'ADAMTS like 3', 84, NULL, NULL, 33983),
(33984, '1.10.8.10-FF-000114', NULL, 'Vps9p', 54, NULL, NULL, 33984),
(33985, '3.30.200.20-FF-001791', NULL, 'Predicted protein', 115, NULL, NULL, 33985),
(33986, '1.20.1250.10-FF-000024', NULL, 'Interleukin-23 subunit alpha', 171, NULL, NULL, 33986),
(33987, '2.60.120.10-FF-000828', NULL, 'Uncharacterized protein', 196, NULL, NULL, 33987),
(33988, '3.30.70.330-FF-002978', NULL, NULL, 143, NULL, NULL, 33988),
(33989, '2.30.30.380-FF-000021', NULL, 'Protein transport protein SEC23', 53, NULL, NULL, 33989),
(33990, '3.90.76.10-FF-000017', NULL, 'Oligopeptide ABC transporter, periplasmic oligopeptide-binding protein', 147, NULL, NULL, 33990),
(33991, '3.80.10.10-FF-000698', NULL, 'Mimecan', 67, NULL, NULL, 33991),
(33992, '3.40.50.300-FF-004076', NULL, 'AGAP009622-PA', 138, NULL, NULL, 33992),
(33993, '3.30.160.60-FF-002552', NULL, 'Uncharacterized protein', 29, NULL, NULL, 33993),
(33994, '3.40.50.300-FF-005913', NULL, 'ABC multidrug transporter, putative', 245, NULL, NULL, 33994),
(33995, '3.30.420.40-FF-000487', NULL, 'Actin-like protein 2', 109, NULL, NULL, 33995),
(33996, '3.20.20.70-FF-000376', NULL, 'Fructose-bisphosphate aldolase, class II', 280, NULL, NULL, 33996),
(33997, '3.30.200.20-FF-000846', NULL, 'Ribosomal protein S6 kinase', 78, NULL, NULL, 33997),
(33998, '1.25.40.20-FF-001256', NULL, 'Uncharacterized protein', 219, NULL, NULL, 33998);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(33999, '2.60.40.10-FF-002788', NULL, 'Tyrosine-protein kinase receptor', 67, NULL, NULL, 33999),
(34000, '3.40.710.10-FF-000054', NULL, 'Penicillin-binding protein, transpeptidase domain protein', 373, NULL, NULL, 34000),
(34001, '2.130.10.10-FF-001619', NULL, 'WD repeat-containing protein 74-like Protein', 142, NULL, NULL, 34001),
(34002, '1.20.1560.10-FF-000362', NULL, 'Uncharacterized protein', 315, NULL, NULL, 34002),
(34003, '2.60.40.420-FF-000107', NULL, 'YDR506C-like protein', 183, NULL, NULL, 34003),
(34004, '3.30.70.270-FF-000099', NULL, 'DNA polymerase IV', 92, NULL, NULL, 34004),
(34005, '1.10.287.70-FF-000697', NULL, 'Uncharacterized protein', 76, NULL, NULL, 34005),
(34006, '2.30.42.10-FF-000175', NULL, 'FERM and PDZ domain containing 2', 113, NULL, NULL, 34006),
(34007, '2.60.120.200-FF-000275', NULL, 'Putative unspecified product', 115, NULL, NULL, 34007),
(34008, '3.80.10.10-FF-004177', NULL, 'Uncharacterized protein (Fragment)', 98, NULL, NULL, 34008),
(34009, '3.40.50.11610-FF-000008', NULL, '2-oxoglutarate dehydrogenase, mitochondrial isoform X4', 157, NULL, NULL, 34009),
(34010, '3.10.400.20-FF-000029', NULL, 'Translation machinery-associated protein 20', 151, NULL, NULL, 34010),
(34011, '2.130.10.10-FF-005407', NULL, 'Predicted protein', 300, NULL, NULL, 34011),
(34012, '2.170.130.10-FF-000078', NULL, NULL, 119, NULL, NULL, 34012),
(34013, '3.60.40.10-FF-000392', NULL, 'Uncharacterized protein', 227, NULL, NULL, 34013),
(34014, '2.170.270.10-FF-000111', NULL, 'Probable histone-lysine N-methyltransferase lin-59', 247, NULL, NULL, 34014),
(34015, '2.30.39.10-FF-000049', NULL, 'Serpin 100A', 176, NULL, NULL, 34015),
(34016, '2.60.120.10-FF-000031', NULL, '1,2-dihydroxy-3-keto-5-methylthiopentene dioxygenase', 178, NULL, NULL, 34016),
(34017, '2.10.109.10-FF-000061', NULL, 'Signal peptidase I', 144, NULL, NULL, 34017),
(34018, '2.110.10.10-FF-000013', NULL, 'Hemopexin', 219, NULL, NULL, 34018),
(34019, '3.20.20.150-FF-000016', NULL, 'Protein arginine N-methyltransferase', 292, NULL, NULL, 34019),
(34020, '1.10.1140.10-FF-000001', NULL, 'ATP synthase subunit beta', 120, NULL, NULL, 34020),
(34021, '3.30.1370.10-FF-000248', NULL, 'Hdlbp protein', 41, NULL, NULL, 34021),
(34022, '3.80.10.10-FF-000389', NULL, 'NLR family pyrin domain containing 6', 171, NULL, NULL, 34022),
(34023, '1.20.120.350-FF-000083', NULL, 'Sodium channel protein', 109, NULL, NULL, 34023),
(34024, '1.10.630.10-FF-000618', NULL, 'Cyp2c65 protein', 250, NULL, NULL, 34024),
(34025, '1.20.1250.20-FF-001651', NULL, 'Major facilitator superfamily domain-containing protein', 200, NULL, NULL, 34025),
(34026, '1.10.30.10-FF-000173', NULL, 'Chromosome 1, whole genome shotgun sequence', 89, NULL, NULL, 34026),
(34027, '1.10.357.140-FF-000050', NULL, 'Predicted protein', 164, NULL, NULL, 34027),
(34028, '3.30.300.20-FF-000062', NULL, 'Ribosome-binding factor A', 115, NULL, NULL, 34028),
(34029, '3.40.50.300-FF-000237', NULL, 'replication factor C subunit 4', 171, NULL, NULL, 34029),
(34030, '3.30.230.30-FF-000003', NULL, 'Uncharacterized protein', 128, NULL, NULL, 34030),
(34031, '3.30.360.10-FF-000074', NULL, 'Dihydrodipicolinate reductase, C-terminus family protein, expressed', 105, NULL, NULL, 34031),
(34032, '2.60.120.650-FF-000163', NULL, 'Chromosome 7, whole genome shotgun sequence', 233, NULL, NULL, 34032),
(34033, '3.40.50.720-FF-001195', NULL, 'Carbonyl reductase/20beta-hydroxysteroid dehydrogenase A', 275, NULL, NULL, 34033),
(34034, '3.90.105.20-FF-000022', NULL, 'Protein CBG02262', 16, NULL, NULL, 34034),
(34035, '1.10.150.510-FF-000010', NULL, 'Receptor activity modifying protein 2', 64, NULL, NULL, 34035),
(34036, '3.90.79.10-FF-000277', NULL, 'UDP-glucose pyrophosphatase, putative', 75, NULL, NULL, 34036),
(34037, '1.10.238.10-FF-001246', NULL, 'Uncharacterized protein', 84, NULL, NULL, 34037),
(34038, '1.20.140.10-FF-000106', NULL, 'Acyl-CoA dehydrogenase', 145, NULL, NULL, 34038),
(34039, '1.25.40.20-FF-001739', NULL, 'Serine/threonine-protein kinase TNNI3K', 214, NULL, NULL, 34039),
(34040, '1.20.5.100-FF-000026', NULL, 'Integrin beta', 74, NULL, NULL, 34040);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(34041, '3.40.605.10-FF-000068', NULL, 'Delta-1-pyrroline-5-carboxylate synthase', 161, NULL, NULL, 34041),
(34042, '3.40.50.2020-FF-000050', NULL, 'Related to XPT1-xanthine phosphoribosyl transferase', 212, NULL, NULL, 34042),
(34043, '3.30.160.60-FF-001933', NULL, 'Zinc finger protein 870', 31, NULL, NULL, 34043),
(34044, '1.10.8.60-FF-000449', NULL, 'ATP-dependent protease ATPase subunit HslU', 105, NULL, NULL, 34044),
(34045, '3.40.50.300-FF-006532', NULL, 'Predicted protein', 109, NULL, NULL, 34045),
(34046, '3.20.20.70-FF-000685', NULL, NULL, 192, NULL, NULL, 34046),
(34047, '3.80.10.10-FF-000922', NULL, 'Leucine-rich repeat receptor-like protein kinase PEPR1', 153, NULL, NULL, 34047),
(34048, '1.10.357.20-FF-000014', NULL, 'Magnesium transporter MgtE', 178, NULL, NULL, 34048),
(34049, '1.25.40.10-FF-003760', NULL, 'Uncharacterized protein', 165, NULL, NULL, 34049),
(34050, '2.30.180.10-FF-000103', NULL, NULL, 137, NULL, NULL, 34050),
(34051, '3.90.190.10-FF-000446', NULL, 'Protein tyrosine phosphatase 3', 269, NULL, NULL, 34051),
(34052, '2.60.120.200-FF-000702', NULL, 'Uncharacterized protein', 186, NULL, NULL, 34052),
(34053, '3.40.630.30-FF-000571', NULL, 'Uncharacterized protein', 109, NULL, NULL, 34053),
(34054, '3.30.70.330-FF-000741', NULL, '60S ribosomal protein L23A', 120, NULL, NULL, 34054),
(34055, '2.170.120.20-FF-000007', NULL, '50S ribosomal protein L25', 98, NULL, NULL, 34055),
(34056, '3.40.50.720-FF-002521', NULL, 'Prephenate dehydrogenase [NADP(+)]', 108, NULL, NULL, 34056),
(34057, '3.40.50.300-FF-002261', NULL, 'DNA repair helicase RAD3, putative', 64, NULL, NULL, 34057),
(34058, '3.40.33.10-FF-000078', NULL, 'Antigen 5/SCP domain-containing protein, putative', 199, NULL, NULL, 34058),
(34059, '3.40.50.2300-FF-001117', NULL, NULL, 102, NULL, NULL, 34059),
(34060, '1.10.630.10-FF-000461', NULL, 'Uncharacterized protein', 189, NULL, NULL, 34060),
(34061, '3.30.420.580-FF-000002', NULL, 'Actin-related protein 8', 258, NULL, NULL, 34061),
(34062, '3.50.50.60-FF-000396', NULL, 'Halogenase', 396, NULL, NULL, 34062),
(34063, '2.30.40.10-FF-000030', NULL, 'Putative amidohydrolase ytcJ', 16, NULL, NULL, 34063),
(34064, '3.40.50.300-FF-001861', NULL, 'Midasin', 127, NULL, NULL, 34064),
(34065, '1.10.760.10-FF-000010', NULL, 'Predicted thiol oxidoreductase', 158, NULL, NULL, 34065),
(34066, '1.20.1270.60-FF-000141', NULL, 'WGS project CABT00000000 data, contig 2.6', 216, NULL, NULL, 34066),
(34067, '1.10.287.110-FF-000119', NULL, 'TPR-repeat-containing chaperone protein DNAJ, putative', 110, NULL, NULL, 34067),
(34068, '3.30.70.3540-FF-000002', NULL, 'ORF1a polyprotein', 97, NULL, NULL, 34068),
(34069, '3.40.50.300-FF-001226', NULL, 'ATP-dependent DNA helicase PIF1', 235, NULL, NULL, 34069),
(34070, '3.30.40.10-FF-000168', NULL, 'E3 ubiquitin-protein ligase TRIM9 isoform X1', 70, NULL, NULL, 34070),
(34071, '3.40.50.2300-FF-001645', NULL, NULL, 245, NULL, NULL, 34071),
(34072, '1.20.120.1630-FF-000007', NULL, 'Protein-S-isoprenylcysteine O-methyltransferase', 183, NULL, NULL, 34072),
(34073, '1.10.10.1500-FF-000002', NULL, 'ribosomal oxygenase 2 isoform X1', 63, NULL, NULL, 34073),
(34074, '2.60.40.10-FF-002479', NULL, 'Protein tyrosine phosphatase, receptor type C', 92, NULL, NULL, 34074),
(34075, '1.10.40.30-FF-000005', NULL, 'Adenylosuccinate lyase', 75, NULL, NULL, 34075),
(34076, '2.60.120.620-FF-000148', NULL, 'Os03g0166200 protein', 59, NULL, NULL, 34076),
(34077, '3.30.160.60-FF-005306', NULL, NULL, 27, NULL, NULL, 34077),
(34078, '3.70.10.10-FF-000114', NULL, 'DNA polymerase sliding clamp', 242, NULL, NULL, 34078),
(34079, '2.60.40.10-FF-003884', NULL, NULL, 144, NULL, NULL, 34079),
(34080, '1.10.238.10-FF-000381', NULL, 'Dead deah box rna helicase', 101, NULL, NULL, 34080),
(34081, '3.30.300.130-FF-000009', NULL, 'Iron-sulfur cluster carrier protein', 92, NULL, NULL, 34081),
(34082, '1.20.1250.20-FF-002270', NULL, 'Predicted protein', 97, NULL, NULL, 34082),
(34083, '3.40.190.10-FF-000884', NULL, 'Glutamate receptor, putative', 81, NULL, NULL, 34083),
(34084, '1.25.10.10-FF-001678', NULL, 'Armadillo-type protein', 1032, NULL, NULL, 34084);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(34085, '1.20.58.340-FF-000064', NULL, 'Cation transporter, putative', 69, NULL, NULL, 34085),
(34086, '3.40.30.10-FF-000364', NULL, 'Glutathione peroxidase', 153, NULL, NULL, 34086),
(34087, '3.30.310.50-FF-000032', NULL, 'Predicted protein', 80, NULL, NULL, 34087),
(34088, '3.40.50.1220-FF-000028', NULL, 'Acetolactate synthase, catabolic', 175, NULL, NULL, 34088),
(34089, '3.30.70.330-FF-002848', NULL, NULL, 83, NULL, NULL, 34089),
(34090, '1.25.40.10-FF-002815', NULL, 'NPGR2', 160, NULL, NULL, 34090),
(34091, '3.30.1600.10-FF-000036', NULL, 'NAD-dependent deacetylase sir2E', 115, NULL, NULL, 34091),
(34092, '1.10.506.10-FF-000083', NULL, 'Uncharacterized protein', 149, NULL, NULL, 34092),
(34093, '1.25.40.10-FF-001034', NULL, 'Intraflagellar transport 88 homolog', 163, NULL, NULL, 34093),
(34094, '1.10.150.120-FF-000016', NULL, NULL, 137, NULL, NULL, 34094),
(34095, '3.20.10.10-FF-000009', NULL, 'Branched-chain-amino-acid aminotransferase', 173, NULL, NULL, 34095),
(34096, '2.120.10.10-FF-000035', NULL, 'Uncharacterized protein', 105, NULL, NULL, 34096),
(34097, '3.40.50.2000-FF-000841', NULL, 'Glycogen [starch] synthase', 55, NULL, NULL, 34097),
(34098, '3.30.565.10-FF-000370', NULL, 'Sensor histidine kinase, HAMP and PAS domain-containing', 158, NULL, NULL, 34098),
(34099, '3.30.1240.10-FF-000053', NULL, 'HAD family phosphatase', 128, NULL, NULL, 34099),
(34100, '3.90.1750.10-FF-000005', NULL, 'E3 ubiquitin-protein ligase', 223, NULL, NULL, 34100),
(34101, '1.20.5.420-FF-000026', NULL, 'Ribonuclease P protein component 4', 57, NULL, NULL, 34101),
(34102, '1.10.510.10-FF-000334', NULL, 'Serine/threonine-protein kinase STE11', 278, NULL, NULL, 34102),
(34103, '3.40.640.10-FF-000211', NULL, 'Serine hydroxymethyltransferase mitochondrial-like', 133, NULL, NULL, 34103),
(34104, '3.30.1360.120-FF-000039', NULL, 'Uncharacterized protein, isoform A', 293, NULL, NULL, 34104),
(34105, '1.10.630.10-FF-000837', NULL, 'Uncharacterized protein', 89, NULL, NULL, 34105),
(34106, '3.40.50.10810-FF-000105', NULL, 'DNA repair protein, putative', 258, NULL, NULL, 34106),
(34107, '1.10.510.10-FF-002116', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 151, NULL, NULL, 34107),
(34108, '3.30.2350.10-FF-000039', NULL, 'Ribosomal large subunit pseudouridine synthase, RluD subfamily protein', 203, NULL, NULL, 34108),
(34109, '1.20.1250.20-FF-000246', NULL, 'Cell-surface thiamine transporter 2', 411, NULL, NULL, 34109),
(34110, '3.80.10.10-FF-001687', NULL, 'Uncharacterized protein', 92, NULL, NULL, 34110),
(34111, '3.30.2140.20-FF-000015', NULL, 'Arylamine N-acetyltransferase 1', 288, NULL, NULL, 34111),
(34112, '1.10.260.40-FF-000076', NULL, 'Peptidase M23', 66, NULL, NULL, 34112),
(34113, '3.30.200.20-FF-001010', NULL, 'eIF-2 alpha kinase', 110, NULL, NULL, 34113),
(34114, '2.130.10.10-FF-004109', NULL, 'Uncharacterized protein', 192, NULL, NULL, 34114),
(34115, '2.60.120.40-FF-000034', NULL, 'C1qB', 134, NULL, NULL, 34115),
(34116, '3.30.780.10-FF-000049', NULL, 'Translation initiation factor SUI1 family protein', 111, NULL, NULL, 34116),
(34117, '3.30.40.10-FF-000640', NULL, 'DNA repair protein Nse1, putative', 55, NULL, NULL, 34117),
(34118, '3.30.300.110-FF-000003', NULL, 'tRNA wybutosine-synthesizing protein 2/3/4', 89, NULL, NULL, 34118),
(34119, '3.30.1490.20-FF-000097', NULL, 'Uncharacterized protein', 80, NULL, NULL, 34119),
(34120, '3.30.930.10-FF-000247', NULL, 'Phenylalanyl-tRNA synthetase, putative', 225, NULL, NULL, 34120),
(34121, '1.25.10.10-FF-001223', NULL, 'Serine/threonine-protein kinase ATR', 265, NULL, NULL, 34121),
(34122, '3.90.1110.10-FF-000007', NULL, 'DNA-directed RNA polymerase subunit beta', 174, NULL, NULL, 34122),
(34123, '1.10.287.70-FF-000702', NULL, 'Uncharacterized protein', 224, NULL, NULL, 34123),
(34124, '1.20.210.10-FF-000028', NULL, 'Putative COX1/OXI3 intron 1 protein', 165, NULL, NULL, 34124),
(34125, '1.20.5.170-FF-000136', NULL, 'Proto-oncogene c-Fos', 68, NULL, NULL, 34125),
(34126, '1.10.1030.10-FF-000009', NULL, 'Carbamoyl-phosphate synthase large chain', 136, NULL, NULL, 34126);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(34127, '3.40.50.1360-FF-000048', NULL, 'Glucosamine-6-phosphate isomerase NAGB', 229, NULL, NULL, 34127),
(34128, '3.40.630.10-FF-000492', NULL, 'Clan MH, family M18, aspartyl aminopeptidase-like metallopeptidase', 274, NULL, NULL, 34128),
(34129, '3.30.70.240-FF-000028', NULL, 'Translation factor GUF1 homolog, mitochondrial', 123, NULL, NULL, 34129),
(34130, '3.20.20.105-FF-000018', NULL, 'Queuine tRNA-ribosyltransferase accessory subunit 2', 170, NULL, NULL, 34130),
(34131, '3.50.80.10-FF-000012', NULL, 'D-tyrosyl-tRNA deacylase 2 (putative)', 167, NULL, NULL, 34131),
(34132, '1.50.40.10-FF-000346', NULL, 'Mitochondrial substrate carrier family protein W', 202, NULL, NULL, 34132),
(34133, '3.30.160.60-FF-003873', NULL, NULL, 33, NULL, NULL, 34133),
(34134, '1.25.40.10-FF-005322', NULL, 'Pentatricopeptide repeat-containing protein At3g23020', 112, NULL, NULL, 34134),
(34135, '3.30.505.10-FF-000052', NULL, 'Ras and Rab interactor 2', 105, NULL, NULL, 34135),
(34136, '1.20.1250.20-FF-000729', NULL, 'MFS multidrug transporter, putative', 179, NULL, NULL, 34136),
(34137, '1.10.510.10-FF-003280', NULL, NULL, 99, NULL, NULL, 34137),
(34138, '2.130.10.10-FF-006043', NULL, 'Uncharacterized protein', 286, NULL, NULL, 34138),
(34139, '2.60.40.10-FF-001175', NULL, 'Putative collagen alpha-1vii chain', 84, NULL, NULL, 34139),
(34140, '1.25.40.10-FF-001826', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 136, NULL, NULL, 34140),
(34141, '1.25.40.10-FF-001051', NULL, 'Pentatricopeptide repeat-containing protein', 116, NULL, NULL, 34141),
(34142, '3.40.50.720-FF-002499', NULL, 'Uncharacterized protein', 146, NULL, NULL, 34142),
(34143, '3.40.630.150-FF-000008', NULL, 'malonyl-CoA decarboxylase, mitochondrial', 268, NULL, NULL, 34143),
(34144, '3.90.290.10-FF-000032', NULL, 'Uncharacterized protein', 69, NULL, NULL, 34144),
(34145, '3.40.50.10490-FF-000037', NULL, 'Glucose-6-phosphate isomerase', 297, NULL, NULL, 34145),
(34146, '3.30.200.210-FF-000005', NULL, 'NADH-quinone oxidoreductase', 104, NULL, NULL, 34146),
(34147, '1.10.510.10-FF-003077', NULL, NULL, 202, NULL, NULL, 34147),
(34148, '3.30.230.10-FF-000317', NULL, 'XO lethal protein 1', 147, NULL, NULL, 34148),
(34149, '2.40.160.50-FF-000044', NULL, 'Predicted protein', 121, NULL, NULL, 34149),
(34150, '3.20.20.80-FF-000710', NULL, 'Lactase, gene 1', 188, NULL, NULL, 34150),
(34151, '3.30.420.10-FF-000489', NULL, NULL, 107, NULL, NULL, 34151),
(34152, '3.90.550.10-FF-000053', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 378, NULL, NULL, 34152),
(34153, '3.30.200.20-FF-000818', NULL, 'Uncharacterized protein', 107, NULL, NULL, 34153),
(34154, '1.10.8.60-FF-000444', NULL, 'ATPase, AAA family', 64, NULL, NULL, 34154),
(34155, '2.130.10.10-FF-002120', NULL, 'Serine/threonine kinase IREI', 246, NULL, NULL, 34155),
(34156, '3.30.70.330-FF-000185', NULL, 'Probable RNA-binding protein 18', 97, NULL, NULL, 34156),
(34157, '2.30.30.490-FF-000054', NULL, 'Origin recognition complex subunit 1', 223, NULL, NULL, 34157),
(34158, '3.40.190.80-FF-000096', NULL, 'Putative inositol monophosphatase 3-like Protein', 84, NULL, NULL, 34158),
(34159, '3.40.50.1100-FF-000077', NULL, 'Cysteine synthase', 101, NULL, NULL, 34159),
(34160, '3.30.9.10-FF-000219', NULL, 'Uncharacterized protein', 62, NULL, NULL, 34160),
(34161, '1.10.760.10-FF-000049', NULL, 'Uncharacterized protein', 122, NULL, NULL, 34161),
(34162, '1.25.40.20-FF-000435', NULL, 'YCR051W-like protein', 188, NULL, NULL, 34162),
(34163, '3.30.420.10-FF-000017', NULL, 'POL polyprotein', 159, NULL, NULL, 34163),
(34164, '1.10.10.10-FF-000773', NULL, 'Related to RPC82-RNA polymerase III subunit C82', 89, NULL, NULL, 34164),
(34165, '1.10.472.80-FF-000069', NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', 136, NULL, NULL, 34165),
(34166, '4.10.400.10-FF-000360', NULL, 'Low-density lipoprotein RecePtor related', 44, NULL, NULL, 34166),
(34167, '3.40.930.10-FF-000060', NULL, NULL, 273, NULL, NULL, 34167),
(34168, '3.30.420.40-FF-000796', NULL, 'Actin like 6B', 154, NULL, NULL, 34168),
(34169, '3.30.930.10-FF-000090', NULL, 'Lipoyltransferase and lipoate-protein ligase, putative', 263, NULL, NULL, 34169);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(34170, '3.40.850.10-FF-000379', NULL, 'Kinesin motor protein-like protein', 318, NULL, NULL, 34170),
(34171, '2.170.120.20-FF-000002', NULL, '50S ribosomal protein L25', 78, NULL, NULL, 34171),
(34172, '3.40.50.1000-FF-000507', NULL, NULL, 125, NULL, NULL, 34172),
(34173, '1.20.58.2220-FF-000042', NULL, 'Formin-I', 418, NULL, NULL, 34173),
(34174, '3.50.50.60-FF-000716', NULL, 'Phytoene dehydrogenase', 435, NULL, NULL, 34174),
(34175, '3.60.10.10-FF-000199', NULL, 'Os06g0264900 protein', 234, NULL, NULL, 34175),
(34176, '2.20.100.10-FF-000252', NULL, 'Predicted protein', 47, NULL, NULL, 34176),
(34177, '3.40.50.150-FF-001794', NULL, NULL, 157, NULL, NULL, 34177),
(34178, '3.40.50.10090-FF-000041', NULL, 'Uroporphyrinogen-III C-methyltransferase', 103, NULL, NULL, 34178),
(34179, '1.25.10.10-FF-000262', NULL, 'HEAT repeat-containing protein 5B', 450, NULL, NULL, 34179),
(34180, '2.60.120.10-FF-000519', NULL, 'Tetrameric potassium-selective cyclic nucleotide gated channel', 137, NULL, NULL, 34180),
(34181, '1.20.5.4770-FF-000025', NULL, 'Uncharacterized protein', 61, NULL, NULL, 34181),
(34182, '1.10.40.60-FF-000003', NULL, 'Type II secretion system protein K', 70, NULL, NULL, 34182),
(34183, '3.90.1860.10-FF-000002', NULL, 'RNA-splicing ligase RtcB', 396, NULL, NULL, 34183),
(34184, '2.40.50.140-FF-000283', NULL, 'Hypothetical membrane protein, conserved', 75, NULL, NULL, 34184),
(34185, '2.60.40.60-FF-000105', NULL, 'Protocadherin 17', 105, NULL, NULL, 34185),
(34186, '3.30.565.10-FF-000061', NULL, 'PAS sensor protein', 126, NULL, NULL, 34186),
(34187, '1.10.10.1890-FF-000001', NULL, 'Spindle and kinetochore-associated protein 1', 123, NULL, NULL, 34187),
(34188, '3.30.70.330-FF-001674', NULL, NULL, 116, NULL, NULL, 34188),
(34189, '1.10.10.10-FF-001043', NULL, 'Probable disease resistance protein At4g33300', 87, NULL, NULL, 34189),
(34190, '1.20.1050.90-FF-000010', NULL, 'DNA replication and repair protein RecF', 178, NULL, NULL, 34190),
(34191, '3.20.20.70-FF-000792', NULL, NULL, 47, NULL, NULL, 34191),
(34192, '2.60.40.1120-FF-000045', NULL, 'Bacillopeptidase', 74, NULL, NULL, 34192),
(34193, '1.25.40.550-FF-000016', NULL, 'A1 cistron-splicing factor aar2', 208, NULL, NULL, 34193),
(34194, '3.80.10.10-FF-003795', NULL, 'Uncharacterized protein', 93, NULL, NULL, 34194),
(34195, '3.90.105.10-FF-000002', NULL, 'Molybdopterin molybdenumtransferase', 55, NULL, NULL, 34195),
(34196, '1.10.150.810-FF-000010', NULL, 'Uncharacterized protein', 89, NULL, NULL, 34196),
(34197, '3.40.630.30-FF-000115', NULL, 'RNA cytidine acetyltransferase', 125, NULL, NULL, 34197),
(34198, '3.40.50.300-FF-008005', NULL, 'Uncharacterized protein', 148, NULL, NULL, 34198),
(34199, '3.40.532.10-FF-000016', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 232, NULL, NULL, 34199),
(34200, '1.10.640.10-FF-000102', NULL, 'Uncharacterized protein', 151, NULL, NULL, 34200),
(34201, '1.10.240.10-FF-000010', NULL, 'Tryptophan-tRNA ligase, putative', 127, NULL, NULL, 34201),
(34202, '3.30.420.10-FF-000152', NULL, 'DNA polymerase III polC-type', 178, NULL, NULL, 34202),
(34203, '3.40.190.10-FF-000912', NULL, 'Uncharacterized protein', 97, NULL, NULL, 34203),
(34204, '1.20.5.700-FF-000003', NULL, 'Dermcidin', 35, NULL, NULL, 34204),
(34205, '1.20.58.60-FF-000189', NULL, 'Uncharacterized protein, isoform B', 116, NULL, NULL, 34205),
(34206, '3.60.10.10-FF-000108', NULL, 'AP endonuclease', 366, NULL, NULL, 34206),
(34207, '3.30.160.60-FF-000635', NULL, 'zinc finger protein 250 isoform X2', 28, NULL, NULL, 34207),
(34208, '3.30.1330.20-FF-000024', NULL, 'Tubulin gamma chain', 109, NULL, NULL, 34208),
(34209, '1.10.540.10-FF-000027', NULL, 'Putative acyl-CoA dehydrogenase', 127, NULL, NULL, 34209),
(34210, '2.120.10.30-FF-000518', NULL, 'Uncharacterized protein', 182, NULL, NULL, 34210),
(34211, '3.40.50.300-FF-007965', NULL, 'Si:dkey-11m19.5', 165, NULL, NULL, 34211),
(34212, '3.90.1410.10-FF-000154', NULL, 'Chromosome 9, whole genome shotgun sequence', 125, NULL, NULL, 34212),
(34213, '3.10.20.90-FF-000540', NULL, 'NFATC2-interacting protein', 78, NULL, NULL, 34213);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(34214, '2.30.30.210-FF-000021', NULL, 'Probable ribonuclease P protein subunit 1', 101, NULL, NULL, 34214),
(34215, '1.10.275.10-FF-000011', NULL, 'Argininosuccinate lyase', 129, NULL, NULL, 34215),
(34216, '3.30.40.10-FF-001152', NULL, 'Uncharacterized protein', 74, NULL, NULL, 34216),
(34217, '3.90.1410.10-FF-000047', NULL, 'Uncharacterized protein', 149, NULL, NULL, 34217),
(34218, '3.90.226.10-FF-000125', NULL, 'Enoyl-CoA hydratase/isomerase family protein', 198, NULL, NULL, 34218),
(34219, '3.30.160.60-FF-004345', NULL, NULL, 81, NULL, NULL, 34219),
(34220, '1.10.510.10-FF-002335', NULL, NULL, 204, NULL, NULL, 34220),
(34221, '3.40.50.720-FF-002504', NULL, 'ThiF family protein', 143, NULL, NULL, 34221),
(34222, '2.60.40.150-FF-000678', NULL, 'Protein kinase C', 113, NULL, NULL, 34222),
(34223, '1.10.287.560-FF-000001', NULL, 'Histidine kinase chemotaxis protein CheA', 64, NULL, NULL, 34223),
(34224, '2.70.70.10-FF-000058', NULL, 'PTS system, glucose subfamily, IIA component', 153, NULL, NULL, 34224),
(34225, '2.120.10.90-FF-000002', NULL, 'DNA gyrase subunit A', 310, NULL, NULL, 34225),
(34226, '1.25.40.10-FF-000106', NULL, 'Intraflagellar transport 88 homolog (Chlamydomonas)', 329, NULL, NULL, 34226),
(34227, '1.10.246.90-FF-000018', NULL, 'SnoRNA binding domain containing protein', 130, NULL, NULL, 34227),
(34228, '1.20.920.10-FF-000172', NULL, 'YALI0D23287p', 138, NULL, NULL, 34228),
(34229, '3.40.630.10-FF-000020', NULL, 'Carboxypeptidase D', 299, NULL, NULL, 34229),
(34230, '2.60.120.290-FF-000026', NULL, 'Procollagen C-endopeptidase enhancer 2', 123, NULL, NULL, 34230),
(34231, '1.20.1250.20-FF-000701', NULL, 'Phosphate transporter, putative', 428, NULL, NULL, 34231),
(34232, '3.40.50.720-FF-002049', NULL, 'Anthocyanidin reductase', 176, NULL, NULL, 34232),
(34233, '1.20.58.60-FF-000318', NULL, 'Spectrin beta, non-erythrocytic 5', 105, NULL, NULL, 34233),
(34234, '3.40.720.10-FF-000009', NULL, 'Phosphoglycerol transferase I', 296, NULL, NULL, 34234),
(34235, '1.10.287.470-FF-000093', NULL, 'Putative heavy metal efflux system protein', 67, NULL, NULL, 34235),
(34236, '3.10.20.90-FF-000337', NULL, 'Caspar, isoform A', 76, NULL, NULL, 34236),
(34237, '3.40.630.30-FF-000368', NULL, 'N-acetyltransferase 5', 200, NULL, NULL, 34237),
(34238, '1.20.120.1320-FF-000021', NULL, NULL, 93, NULL, NULL, 34238),
(34239, '3.40.50.1000-FF-000182', NULL, 'Copper-exporting P-type ATPase B', 150, NULL, NULL, 34239),
(34240, '2.160.20.10-FF-000197', NULL, 'Os11g0659700 protein', 252, NULL, NULL, 34240),
(34241, '2.60.40.640-FF-000061', NULL, 'Vacuolar protein sorting 26, putative', 175, NULL, NULL, 34241),
(34242, '2.60.120.380-FF-000059', NULL, 'Cysteine peptidase, Clan CA, family C2, putative', 151, NULL, NULL, 34242),
(34243, '3.30.559.10-FF-000237', NULL, 'Predicted protein', 156, NULL, NULL, 34243),
(34244, '3.30.450.20-FF-000449', NULL, 'Predicted protein', 55, NULL, NULL, 34244),
(34245, '3.30.470.20-FF-000085', NULL, 'glutathione synthetase isoform X3', 15, NULL, NULL, 34245),
(34246, '1.10.220.10-FF-000008', NULL, 'Annexin', 82, NULL, NULL, 34246),
(34247, '1.20.1270.60-FF-000006', NULL, 'SLIT-ROBO Rho GTPase-activating protein 1 isoform 2', 316, NULL, NULL, 34247),
(34248, '3.40.50.1240-FF-000214', NULL, NULL, 71, NULL, NULL, 34248),
(34249, '2.60.40.10-FF-005227', NULL, NULL, 89, NULL, NULL, 34249),
(34250, '1.20.1250.10-FF-000041', NULL, 'Growth hormone d20', 216, NULL, NULL, 34250),
(34251, '3.30.160.60-FF-000074', NULL, 'Tripartite motif containing 66', 49, NULL, NULL, 34251),
(34252, '3.40.1190.20-FF-000229', NULL, NULL, 196, NULL, NULL, 34252),
(34253, '1.10.630.10-FF-000045', NULL, 'Cytochrome P450 85A1', 439, NULL, NULL, 34253),
(34254, '3.40.250.10-FF-000030', NULL, 'Inner membrane protein YgaP', 105, NULL, NULL, 34254),
(34255, '1.10.287.950-FF-000006', NULL, 'Methyl-accepting chemotaxis protein signaling domain protein', 317, NULL, NULL, 34255),
(34256, '1.25.40.10-FF-003288', NULL, 'Pentatricopeptide repeat-containing protein', 129, NULL, NULL, 34256),
(34257, '3.60.20.40-FF-000040', NULL, 'Uncharacterized protein', 193, NULL, NULL, 34257);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(34258, '1.20.990.10-FF-000030', NULL, 'Sulfite reductase [NADPH] flavoprotein alpha-component', 107, NULL, NULL, 34258),
(34259, '1.50.10.20-FF-000055', NULL, 'Baccharis oxide synthase', 222, NULL, NULL, 34259),
(34260, '1.10.167.10-FF-000002', NULL, 'Regulator of G-protein signaling 6 isoform 9', 149, NULL, NULL, 34260),
(34261, '2.30.42.10-FF-000192', NULL, 'Uncharacterized protein, isoform J', 94, NULL, NULL, 34261),
(34262, '1.25.40.10-FF-002888', NULL, 'CCR4-NOT transcription complex subunit, putative', 227, NULL, NULL, 34262),
(34263, '2.60.40.10-FF-002895', NULL, '5-AMP-activated protein kinase, beta-1 subunit', 92, NULL, NULL, 34263),
(34264, '3.40.50.200-FF-000016', NULL, 'Proprotein convertase subtilisin/kexin type 9', 294, NULL, NULL, 34264),
(34265, '1.20.58.60-FF-000009', NULL, 'dystonin isoform X1', 233, NULL, NULL, 34265),
(34266, '1.50.10.10-FF-000209', NULL, 'AGAP008547-PA', 175, NULL, NULL, 34266),
(34267, '3.40.50.300-FF-002154', NULL, 'Putative GTPase Era', 91, NULL, NULL, 34267),
(34268, '4.10.1000.10-FF-000056', NULL, 'Uncharacterized protein', 37, NULL, NULL, 34268),
(34269, '1.20.1500.20-FF-000007', NULL, NULL, 93, NULL, NULL, 34269),
(34270, '4.10.800.20-FF-000016', NULL, 'Os05g0349200 protein', 46, NULL, NULL, 34270),
(34271, '3.40.720.10-FF-000375', NULL, 'Uncharacterized protein', 324, NULL, NULL, 34271),
(34272, '2.130.10.10-FF-001355', NULL, 'Eukaryotic translation initiation factor 2A', 142, NULL, NULL, 34272),
(34273, '1.10.443.20-FF-000001', NULL, 'Centromere binding factor CBF3 subunit', 356, NULL, NULL, 34273),
(34274, '3.40.720.10-FF-000156', NULL, 'Arylsulfatase', 466, NULL, NULL, 34274),
(34275, '3.40.50.200-FF-000201', NULL, 'Uncharacterized protein', 326, NULL, NULL, 34275),
(34276, '3.40.50.300-FF-006785', NULL, 'Uncharacterized protein', 58, NULL, NULL, 34276),
(34277, '1.10.560.10-FF-000045', NULL, 'T-complex protein 1 subunit eta', 113, NULL, NULL, 34277),
(34278, '3.60.40.10-FF-000245', NULL, 'Uncharacterized protein', 130, NULL, NULL, 34278),
(34279, '3.40.30.10-FF-000257', NULL, '39S ribosomal protein L43', 154, NULL, NULL, 34279),
(34280, '2.60.40.60-FF-000740', NULL, 'Predicted protein', 109, NULL, NULL, 34280),
(34281, '3.40.850.10-FF-000564', NULL, 'Uncharacterized protein', 31, NULL, NULL, 34281),
(34282, '3.30.2350.10-FF-000056', NULL, 'tRNA pseudouridine synthase B', 230, NULL, NULL, 34282),
(34283, '1.50.40.10-FF-000262', NULL, 'Mitochondrial substrate carrier protein', 195, NULL, NULL, 34283),
(34284, '2.60.40.10-FF-001967', NULL, 'Sialic acid binding Ig like lectin 6', 127, NULL, NULL, 34284),
(34285, '3.30.420.230-FF-000004', NULL, 'Spliceosomal protein PrP8, U6-snRNA interacting domain', 143, NULL, NULL, 34285),
(34286, '1.10.630.10-FF-000354', NULL, 'Cytochrome P450 67', 474, NULL, NULL, 34286),
(34287, '3.60.21.10-FF-000353', NULL, 'Purple acid phosphatase 19', 194, NULL, NULL, 34287),
(34288, '4.10.400.10-FF-000230', NULL, 'Low-density lipoprotein RecePtor related', 40, NULL, NULL, 34288),
(34289, '2.40.50.120-FF-000041', NULL, 'Uncharacterized protein', 129, NULL, NULL, 34289),
(34290, '1.25.40.10-FF-000090', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 227, NULL, NULL, 34290),
(34291, '1.25.10.10-FF-003140', NULL, 'Aminopeptidase', 107, NULL, NULL, 34291),
(34292, '3.90.70.80-FF-000053', NULL, 'Putative bifunctional UDP-N-acetylglucosamine transferase and deubiquitinase ALG13-like Protein', 149, NULL, NULL, 34292),
(34293, '2.170.270.10-FF-000116', NULL, 'Prdm2 protein', 153, NULL, NULL, 34293),
(34294, '3.40.50.360-FF-000125', NULL, 'Neuronal nitric oxide synthase', 101, NULL, NULL, 34294),
(34295, '3.30.310.130-FF-000034', NULL, 'SUMO-specific peptidase 6a', 25, NULL, NULL, 34295),
(34296, '1.20.5.170-FF-000243', NULL, 'Transcription factor VBP', 59, NULL, NULL, 34296),
(34297, '3.10.20.740-FF-000004', NULL, 'NADH-quinone oxidoreductase', 123, NULL, NULL, 34297),
(34298, '2.130.10.10-FF-000203', NULL, 'WD repeat domain 1', 272, NULL, NULL, 34298),
(34299, '1.20.1420.30-FF-000066', NULL, 'Na/Ca eXchangers', 140, NULL, NULL, 34299);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(34300, '1.20.1070.10-FF-000398', NULL, 'FSHR (Mammalian follicle stimulating hormone receptor) homolog', 278, NULL, NULL, 34300),
(34301, '3.90.79.20-FF-000027', NULL, 'Hydrolase, NUDIX family protein', 134, NULL, NULL, 34301),
(34302, '3.30.70.330-FF-000494', NULL, '28 kDa ribonucleoprotein, chloroplastic', 80, NULL, NULL, 34302),
(34303, '2.130.10.10-FF-003300', NULL, 'Uncharacterized protein', 189, NULL, NULL, 34303),
(34304, '2.60.120.260-FF-000478', NULL, 'Uncharacterized protein', 159, NULL, NULL, 34304),
(34305, '3.20.20.80-FF-000469', NULL, 'Glycoside hydrolase family 35', 356, NULL, NULL, 34305),
(34306, '1.20.1740.10-FF-000241', NULL, 'Membrane transporter', 365, NULL, NULL, 34306),
(34307, '1.50.40.10-FF-000481', NULL, 'Uncharacterized protein', 280, NULL, NULL, 34307),
(34308, '1.10.460.10-FF-000009', NULL, 'DNA topoisomerase', 160, NULL, NULL, 34308),
(34309, '1.10.10.750-FF-000035', NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', 44, NULL, NULL, 34309),
(34310, '3.40.50.10490-FF-000054', NULL, 'Sugar isomerase, AgaS family', 204, NULL, NULL, 34310),
(34311, '3.90.290.10-FF-000015', NULL, 'Latent transforming growth factor beta binding protein 3', 74, NULL, NULL, 34311),
(34312, '1.10.533.10-FF-000134', NULL, 'Netrin receptor unc-5', 99, NULL, NULL, 34312),
(34313, '2.40.50.140-FF-000592', NULL, 'Single-stranded DNA-binding protein', 97, NULL, NULL, 34313),
(34314, '3.40.50.1910-FF-000022', NULL, 'Protein transport Sec1b', 124, NULL, NULL, 34314),
(34315, '3.40.50.720-FF-001088', NULL, 'NAD(P)-binding protein', 241, NULL, NULL, 34315),
(34316, '3.30.160.60-FF-002928', NULL, 'Related to C2H2-type zinc finger protein', 27, NULL, NULL, 34316),
(34317, '1.20.140.50-FF-000017', NULL, 'Uncharacterized protein', 46, NULL, NULL, 34317),
(34318, '3.30.160.60-FF-003417', NULL, 'GD16884', 29, NULL, NULL, 34318),
(34319, '1.25.10.10-FF-001195', NULL, 'Transportin 2', 156, NULL, NULL, 34319),
(34320, '2.60.120.10-FF-000036', NULL, 'Homogentisate 1,2-dioxygenase', 133, NULL, NULL, 34320),
(34321, '1.25.40.20-FF-000744', NULL, 'Si:dkey-9i23.14', 91, NULL, NULL, 34321),
(34322, '1.20.1560.10-FF-000598', NULL, 'Uncharacterized protein', 375, NULL, NULL, 34322),
(34323, '2.40.70.10-FF-000306', NULL, NULL, 236, NULL, NULL, 34323),
(34324, '3.20.20.70-FF-000157', NULL, 'Orotidine 5''-phosphate decarboxylase', 271, NULL, NULL, 34324),
(34325, '3.40.50.1820-FF-000759', NULL, 'GD18190', 311, NULL, NULL, 34325),
(34326, '3.30.70.1320-FF-000005', NULL, 'Putative cation efflux system protein CusA', 99, NULL, NULL, 34326),
(34327, '2.70.98.110-FF-000010', NULL, 'Uncharacterized protein', 339, NULL, NULL, 34327),
(34328, '1.20.1250.20-FF-000353', NULL, 'Solute carrier organic anion transporter family member', 215, NULL, NULL, 34328),
(34329, '3.30.160.60-FF-003726', NULL, NULL, 26, NULL, NULL, 34329),
(34330, '2.130.10.10-FF-006026', NULL, 'Centriole proteome protein 16', 131, NULL, NULL, 34330),
(34331, '3.30.70.330-FF-000746', NULL, 'Glycine-rich RNA-binding protein RZ1A', 121, NULL, NULL, 34331),
(34332, '3.80.10.10-FF-004104', NULL, 'Adenylate cyclase', 119, NULL, NULL, 34332),
(34333, '1.20.1070.10-FF-000931', NULL, 'Uncharacterized protein', 313, NULL, NULL, 34333),
(34334, '1.10.10.10-FF-001571', NULL, 'Uncharacterized HTH-type transcriptional regulator SCO4628', 76, NULL, NULL, 34334),
(34335, '3.30.70.1730-FF-000038', NULL, 'Uncharacterized protein', 84, NULL, NULL, 34335),
(34336, '1.20.1280.290-FF-000045', NULL, 'PQ loop repeat protein', 96, NULL, NULL, 34336),
(34337, '1.20.140.150-FF-000004', NULL, 'Voltage-dependent calcium channel gamma-4 subunit', 217, NULL, NULL, 34337),
(34338, '2.60.40.10-FF-002007', NULL, 'Eph receptor A2 a', 102, NULL, NULL, 34338),
(34339, '3.40.50.300-FF-003912', NULL, 'ABC_transporter_-_putative', 213, NULL, NULL, 34339),
(34340, '3.90.1720.10-FF-000020', NULL, 'Inositol-1,4,5-trisphosphate 5-phosphatase', 176, NULL, NULL, 34340),
(34341, '1.20.1440.340-FF-000013', NULL, 'Predicted protein', 127, NULL, NULL, 34341),
(34342, '3.90.180.10-FF-000018', NULL, 'NAD(P)-dependent alcohol dehydrogenase', 170, NULL, NULL, 34342);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(34343, '1.20.1410.10-FF-000031', NULL, 'Uncharacterized protein', 154, NULL, NULL, 34343),
(34344, '2.60.40.10-FF-000315', NULL, 'Down syndrome cell adhesion molecule like 1', 97, NULL, NULL, 34344),
(34345, '3.60.40.10-FF-000352', NULL, 'Uncharacterized protein', 326, NULL, NULL, 34345),
(34346, '3.90.550.10-FF-000507', NULL, 'Nucleotide-diphospho-sugar transferase', 259, NULL, NULL, 34346),
(34347, '1.10.238.10-FF-000302', NULL, 'Probable calcium-binding protein CML46', 96, NULL, NULL, 34347),
(34348, '3.15.10.30-FF-000005', NULL, 'Blast:Protein takeout', 219, NULL, NULL, 34348),
(34349, '1.10.3210.30-FF-000007', NULL, 'CRISPR-associated helicase Cas3', 280, NULL, NULL, 34349),
(34350, '1.25.40.10-FF-000073', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 102, NULL, NULL, 34350),
(34351, '3.30.70.330-FF-001691', NULL, NULL, 36, NULL, NULL, 34351),
(34352, '3.10.20.30-FF-000112', NULL, NULL, 56, NULL, NULL, 34352),
(34353, '1.25.40.20-FF-001711', NULL, 'Uncharacterized protein', 51, NULL, NULL, 34353),
(34354, '1.10.10.10-FF-002116', NULL, 'Selenocysteine-specific elongation factor', 57, NULL, NULL, 34354),
(34355, '2.60.40.3500-FF-000017', NULL, NULL, 115, NULL, NULL, 34355),
(34356, '2.30.30.100-FF-000128', NULL, 'U6 snRNA-associated Sm-like protein LSm3p', 83, NULL, NULL, 34356),
(34357, '3.30.710.10-FF-000472', NULL, 'SKP1-like protein 1A', 103, NULL, NULL, 34357),
(34358, '3.40.50.300-FF-000153', NULL, 'Dynein axonemal heavy chain 1', 126, NULL, NULL, 34358),
(34359, '3.40.30.10-FF-000925', NULL, 'Iodothyronine deiodinase', 123, NULL, NULL, 34359),
(34360, '3.40.50.12470-FF-000013', NULL, '2-oxoglutarate dehydrogenase E1 component', 220, NULL, NULL, 34360),
(34361, '3.30.1370.50-FF-000018', NULL, 'LD33178p', 70, NULL, NULL, 34361),
(34362, '3.30.40.10-FF-001713', NULL, 'E3 ubiquitin-protein ligase WAV3', 59, NULL, NULL, 34362),
(34363, '2.60.40.10-FF-001299', NULL, 'Programmed cell death 1', 103, NULL, NULL, 34363),
(34364, '3.40.50.360-FF-000108', NULL, 'Possible NAD(P)H dehydrogenase (Quinone)', 177, NULL, NULL, 34364),
(34365, '1.10.3210.10-FF-000013', NULL, 'Ribonuclease Y', 181, NULL, NULL, 34365),
(34366, '1.10.10.10-FF-001026', NULL, 'Bloom syndrome protein', 112, NULL, NULL, 34366),
(34367, '2.30.110.10-FF-000014', NULL, 'Pyridoxine/pyridoxamine 5''-phosphate oxidase', 210, NULL, NULL, 34367),
(34368, '1.10.10.10-FF-001604', NULL, 'ETS class transcription factor', 139, NULL, NULL, 34368),
(34369, '3.30.160.60-FF-001855', NULL, 'Uncharacterized protein, isoform B', 32, NULL, NULL, 34369),
(34370, '1.10.10.60-FF-000956', NULL, NULL, 62, NULL, NULL, 34370),
(34371, '2.130.10.10-FF-005661', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 165, NULL, NULL, 34371),
(34372, '1.20.58.1340-FF-000002', NULL, 'Envelope glycoprotein H', 167, NULL, NULL, 34372),
(34373, '3.20.20.100-FF-000142', NULL, 'Uncharacterized protein', 330, NULL, NULL, 34373),
(34374, '3.30.160.60-FF-002889', NULL, NULL, 27, NULL, NULL, 34374),
(34375, '3.40.50.2300-FF-000678', NULL, 'Guanylate cyclase', 175, NULL, NULL, 34375),
(34376, '1.25.40.10-FF-004940', NULL, 'Uncharacterized protein', 192, NULL, NULL, 34376),
(34377, '3.80.10.10-FF-000361', NULL, 'LRR receptor-like serine/threonine-protein kinase ERL1', 75, NULL, NULL, 34377),
(34378, '2.60.40.10-FF-003968', NULL, NULL, 103, NULL, NULL, 34378),
(34379, '2.30.130.10-FF-000027', NULL, '60S ribosome subunit biogenesis protein NIP7 homolog', 80, NULL, NULL, 34379),
(34380, '1.20.140.10-FF-000028', NULL, 'Acyl-CoA dehydrogenase FadE34', 140, NULL, NULL, 34380),
(34381, '3.30.1330.30-FF-000049', NULL, '23S rRNA (guanosine-2''-O-)-methyltransferase RlmB', 77, NULL, NULL, 34381),
(34382, '2.30.29.30-FF-000650', NULL, 'Miro family protein', 99, NULL, NULL, 34382),
(34383, '3.30.160.380-FF-000017', NULL, NULL, 96, NULL, NULL, 34383),
(34384, '3.40.50.1000-FF-000873', NULL, NULL, 13, NULL, NULL, 34384),
(34385, '2.60.40.150-FF-000695', NULL, 'Predicted protein', 156, NULL, NULL, 34385),
(34386, '3.20.20.80-FF-000339', NULL, 'Chondroitin proteoglycan 1', 125, NULL, NULL, 34386);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(34387, '3.10.20.80-FF-000008', NULL, 'Translation initiation factor IF-3', 77, NULL, NULL, 34387),
(34388, '1.10.287.130-FF-000120', NULL, 'RteA, two-component system histidine kinase, with response regulator receiver domain', 74, NULL, NULL, 34388),
(34389, '1.10.287.70-FF-000360', NULL, 'Potassium two pore domain channel subfamily K member 6', 110, NULL, NULL, 34389),
(34390, '3.40.50.2000-FF-000706', NULL, 'Uncharacterized protein', 173, NULL, NULL, 34390),
(34391, '1.25.40.10-FF-003304', NULL, 'Pentatricopeptide repeat-containing protein At1g53600, mitochondrial', 218, NULL, NULL, 34391),
(34392, '2.130.10.10-FF-005059', NULL, 'U3 small nucleolar RNA-associated protein 17', 275, NULL, NULL, 34392),
(34393, '2.40.50.140-FF-000608', NULL, 'DNA-directed RNA polymerase III subunit RPC8', 138, NULL, NULL, 34393),
(34394, '1.10.510.10-FF-001262', NULL, 'Uncharacterized protein', 385, NULL, NULL, 34394),
(34395, '2.60.40.10-FF-005205', NULL, NULL, 91, NULL, NULL, 34395),
(34396, '1.10.555.10-FF-000207', NULL, NULL, 84, NULL, NULL, 34396),
(34397, '3.40.850.10-FF-000249', NULL, 'Kif3a protein', 199, NULL, NULL, 34397),
(34398, '1.10.150.240-FF-000013', NULL, 'Glycerol-3-phosphate phosphatase (GppA)', 61, NULL, NULL, 34398),
(34399, '3.40.710.10-FF-000094', NULL, 'Penicillin-binding protein 2B (PBP-2B)', 194, NULL, NULL, 34399),
(34400, '3.30.420.10-FF-000236', NULL, 'Protein piwi', 235, NULL, NULL, 34400),
(34401, '1.20.1560.10-FF-000704', NULL, 'Predicted protein', 324, NULL, NULL, 34401),
(34402, '3.40.50.300-FF-006077', NULL, 'ABC transporter C family member 10', 153, NULL, NULL, 34402),
(34403, '3.30.40.10-FF-002332', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 96, NULL, NULL, 34403),
(34404, '3.40.605.10-FF-000040', NULL, 'Alpha-aminoadipic semialdehyde dehydrogenase', 188, NULL, NULL, 34404),
(34405, '3.40.50.1240-FF-000130', NULL, 'Histidine phosphatase superfamily', 253, NULL, NULL, 34405),
(34406, '3.40.50.11340-FF-000023', NULL, 'Uncharacterized protein', 111, NULL, NULL, 34406),
(34407, '3.30.160.360-FF-000011', NULL, 'Histone-lysine N-methyltransferase', 137, NULL, NULL, 34407),
(34408, '1.20.58.60-FF-000425', NULL, 'SMAll', 117, NULL, NULL, 34408),
(34409, '1.10.510.10-FF-002352', NULL, 'Protein kinase, putative', 320, NULL, NULL, 34409),
(34410, '3.30.1520.10-FF-000182', NULL, 'Predicted protein', 93, NULL, NULL, 34410),
(34411, '1.10.720.30-FF-000030', NULL, 'Uncharacterized protein', 43, NULL, NULL, 34411),
(34412, '3.20.20.190-FF-000005', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 319, NULL, NULL, 34412),
(34413, '2.70.170.10-FF-000189', NULL, 'Uncharacterized protein', 209, NULL, NULL, 34413),
(34414, '3.30.40.10-FF-001820', NULL, 'Uncharacterized protein', 65, NULL, NULL, 34414),
(34415, '1.25.10.10-FF-003224', NULL, 'Serine/threonine-protein kinase TOR', 262, NULL, NULL, 34415),
(34416, '3.40.30.10-FF-000818', NULL, 'Glutathione S-transferase', 83, NULL, NULL, 34416),
(34417, '3.40.1180.10-FF-000023', NULL, 'Dehydrodolichyl diphosphate synthase 8', 247, NULL, NULL, 34417),
(34418, '3.30.465.10-FF-000025', NULL, 'FAD-binding oxidoreductase', 120, NULL, NULL, 34418),
(34419, '2.60.120.820-FF-000017', NULL, 'RING zinc finger-containing protein', 164, NULL, NULL, 34419),
(34420, '3.50.30.30-FF-000150', NULL, 'Uncharacterized protein', 129, NULL, NULL, 34420),
(34421, '1.25.40.10-FF-004833', NULL, 'Uncharacterized protein', 144, NULL, NULL, 34421),
(34422, '3.20.90.10-FF-000003', NULL, 'Tubby-like F-box protein', 292, NULL, NULL, 34422),
(34423, '2.60.120.10-FF-000486', NULL, 'Lysine-specific demethylase 8', 272, NULL, NULL, 34423),
(34424, '3.30.1240.10-FF-000031', NULL, 'Sugar phosphatase YidA', 108, NULL, NULL, 34424),
(34425, '2.60.200.20-FF-000113', NULL, 'Checkpoint kinase 2-like protein', 116, NULL, NULL, 34425),
(34426, '3.30.160.60-FF-000219', NULL, 'Zinc finger protein 276', 30, NULL, NULL, 34426),
(34427, '3.30.390.10-FF-000019', NULL, 'Mandelate racemase/muconate lactonizing protein', 119, NULL, NULL, 34427),
(34428, '3.40.50.1820-FF-000675', NULL, 'Alpha/beta hydrolase', 292, NULL, NULL, 34428); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(34429, '1.10.630.10-FF-000276', NULL, 'Cytochrome P450 family 1 subfamily A member 1', 200, NULL, NULL, 34429),
(34430, '2.60.40.10-FF-005677', NULL, NULL, 83, NULL, NULL, 34430),
(34431, '3.10.310.10-FF-000036', NULL, 'Uncharacterized protein', 169, NULL, NULL, 34431),
(34432, '3.30.470.20-FF-000068', NULL, 'Tubulin-tyrosine ligase', 222, NULL, NULL, 34432),
(34433, '1.20.1320.30-FF-000007', NULL, NULL, 20, NULL, NULL, 34433),
(34434, '3.20.20.140-FF-000468', NULL, 'N-substituted formamide deformylase', 310, NULL, NULL, 34434),
(34435, '3.80.10.10-FF-003008', NULL, 'Uncharacterized protein', 229, NULL, NULL, 34435),
(34436, '3.40.50.150-FF-000866', NULL, NULL, 66, NULL, NULL, 34436),
(34437, '2.40.128.20-FF-000062', NULL, 'Apolipoprotein D', 100, NULL, NULL, 34437),
(34438, '2.10.25.10-FF-000945', NULL, 'Signal peptide, CUB domain, EGF-like 2', 42, NULL, NULL, 34438),
(34439, '3.30.60.20-FF-000043', NULL, 'Diacylglycerol kinase', 50, NULL, NULL, 34439),
(34440, '3.30.200.20-FF-000498', NULL, 'Serine/threonine-protein kinase KIN28', 88, NULL, NULL, 34440),
(34441, '3.30.230.10-FF-000334', NULL, 'Mevalonate kinase', 68, NULL, NULL, 34441),
(34442, '2.60.40.200-FF-000030', NULL, 'Uncharacterized protein', 143, NULL, NULL, 34442),
(34443, '2.130.10.10-FF-004025', NULL, 'Uncharacterized protein', 222, NULL, NULL, 34443),
(34444, '3.10.28.10-FF-000005', NULL, 'Pentatricopeptide repeat-containing protein At2g15820, chloroplastic', 100, NULL, NULL, 34444),
(34445, '3.30.160.60-FF-003081', NULL, NULL, 63, NULL, NULL, 34445),
(34446, '3.50.50.60-FF-000738', NULL, 'FAD dependent oxidoreductase', 202, NULL, NULL, 34446),
(34447, '1.10.8.60-FF-000427', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 65, NULL, NULL, 34447),
(34448, '3.30.505.10-FF-000158', NULL, NULL, 68, NULL, NULL, 34448),
(34449, '3.80.10.10-FF-001451', NULL, 'AGAP010218-PA', 127, NULL, NULL, 34449),
(34450, '3.90.70.10-FF-000757', NULL, 'Bleomycin hydrolase', 101, NULL, NULL, 34450),
(34451, '2.30.30.180-FF-000006', NULL, 'Ribosome maturation factor RimP', 61, NULL, NULL, 34451),
(34452, '3.30.1370.30-FF-000012', NULL, 'Ribosomal protein S8', 84, NULL, NULL, 34452),
(34453, '1.20.1070.10-FF-001095', NULL, 'Uncharacterized protein', 316, NULL, NULL, 34453),
(34454, '3.20.20.300-FF-000067', NULL, NULL, 205, NULL, NULL, 34454),
(34455, '2.60.40.10-FF-005194', NULL, NULL, 92, NULL, NULL, 34455),
(34456, '2.60.40.150-FF-000223', NULL, 'Synaptotagmin alpha, isoform A', 135, NULL, NULL, 34456),
(34457, '4.10.1000.10-FF-000073', NULL, 'Hypothetical_protein_-_conserved', 74, NULL, NULL, 34457),
(34458, '3.40.250.10-FF-000052', NULL, 'Rhodanese like protein, putative', 140, NULL, NULL, 34458),
(34459, '2.30.29.30-FF-000318', NULL, 'insulin receptor substrate 4', 124, NULL, NULL, 34459),
(34460, '3.40.50.300-FF-004424', NULL, 'Cell cycle checkpoint protein', 175, NULL, NULL, 34460),
(34461, '1.20.1070.10-FF-002185', NULL, 'Uncharacterized protein', 90, NULL, NULL, 34461),
(34462, '2.60.40.1670-FF-000002', NULL, 'SEC24 homolog B, COPII coat complex component', 137, NULL, NULL, 34462),
(34463, '1.20.1260.140-FF-000007', NULL, NULL, 170, NULL, NULL, 34463),
(34464, '2.70.170.10-FF-000296', NULL, 'Protein CBG26995', 152, NULL, NULL, 34464),
(34465, '3.60.10.10-FF-000417', NULL, 'Uncharacterized protein', 155, NULL, NULL, 34465),
(34466, '1.10.10.10-FF-001498', NULL, 'Transcriptional adapter', 66, NULL, NULL, 34466),
(34467, '3.40.50.300-FF-003334', NULL, 'Ras family gtpase', 176, NULL, NULL, 34467),
(34468, '1.25.10.10-FF-000245', NULL, 'Beta-catenin-like protein 1 isoform A', 483, NULL, NULL, 34468),
(34469, '3.40.50.620-FF-000895', NULL, 'Uncharacterized protein', 85, NULL, NULL, 34469),
(34470, '3.30.420.10-FF-000461', NULL, 'DNA polymerase alpha subunit one', 261, NULL, NULL, 34470),
(34471, '3.30.70.270-FF-000251', NULL, NULL, 107, NULL, NULL, 34471),
(34472, '3.40.50.1820-FF-001400', NULL, 'Uncharacterized hydrolase C9G1.08c', 211, NULL, NULL, 34472),
(34473, '1.10.510.10-FF-003768', NULL, NULL, 139, NULL, NULL, 34473);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(34474, '3.90.1640.20-FF-000005', NULL, 'Uncharacterized protein', 212, NULL, NULL, 34474),
(34475, '1.20.5.110-FF-000271', NULL, 'Qb+c-SNARE protein, SNAP25-family', 78, NULL, NULL, 34475),
(34476, '3.20.20.60-FF-000019', NULL, 'CoA ester lyase', 279, NULL, NULL, 34476),
(34477, '4.10.640.30-FF-000001', NULL, 'DNA damage-binding protein 2 isoform X1', 85, NULL, NULL, 34477),
(34478, '1.25.10.10-FF-000953', NULL, 'Protein phosphatase 2A regulatory subunit A, putative', 330, NULL, NULL, 34478),
(34479, '3.90.1750.10-FF-000084', NULL, 'Uncharacterized protein', 170, NULL, NULL, 34479),
(34480, '1.10.1450.10-FF-000098', NULL, 'Tetraspanin', 100, NULL, NULL, 34480),
(34481, '1.25.10.10-FF-001987', NULL, 'Putative pumilio/PUF RNA binding protein 7', 113, NULL, NULL, 34481),
(34482, '1.20.1270.220-FF-000005', NULL, 'Transcription initiation factor TFIID subunit 14', 68, NULL, NULL, 34482),
(34483, '1.10.1270.10-FF-000005', NULL, 'Trp operon repressor homolog', 99, NULL, NULL, 34483),
(34484, '1.10.287.810-FF-000003', NULL, 'Mitochondrial import inner membrane translocase subunit TIM8', 63, NULL, NULL, 34484),
(34485, '1.20.1250.20-FF-001679', NULL, 'Predicted protein', 128, NULL, NULL, 34485),
(34486, '2.60.120.10-FF-000267', NULL, 'Uncharacterized protein', 169, NULL, NULL, 34486),
(34487, '4.10.240.10-FF-000173', NULL, 'Zcf6p', 61, NULL, NULL, 34487),
(34488, '3.40.50.1360-FF-000020', NULL, 'Glucose-6-phosphate dehydrogenase', 304, NULL, NULL, 34488),
(34489, '1.10.10.10-FF-000082', NULL, 'forkhead box protein B2', 104, NULL, NULL, 34489),
(34490, '1.25.40.20-FF-000328', NULL, 'BTB/POZ domain-containing protein', 125, NULL, NULL, 34490),
(34491, '3.10.400.20-FF-000001', NULL, 'Malignant T-cell-amplified sequence 1', 181, NULL, NULL, 34491),
(34492, '3.30.1680.10-FF-000030', NULL, 'Sema domain, immunoglobulin domain (Ig), transmembrane domain (TM) and short cytoplasmic domain, (semaphorin) 4Aa', 75, NULL, NULL, 34492),
(34493, '3.80.10.10-FF-000737', NULL, 'Predicted protein', 208, NULL, NULL, 34493),
(34494, '3.30.497.10-FF-000104', NULL, 'Serpin family E member 3', 128, NULL, NULL, 34494),
(34495, '1.10.630.10-FF-000585', NULL, 'Uncharacterized protein', 297, NULL, NULL, 34495),
(34496, '2.60.40.60-FF-001049', NULL, 'Uncharacterized protein', 92, NULL, NULL, 34496),
(34497, '3.30.1600.10-FF-000014', NULL, 'NAD-dependent histone deacetylase SIR2', 109, NULL, NULL, 34497),
(34498, '1.25.40.10-FF-003052', NULL, 'Activator of C kinase protein 1', 76, NULL, NULL, 34498),
(34499, '2.130.10.10-FF-002788', NULL, 'WD-40 repeat protein family', 211, NULL, NULL, 34499),
(34500, '2.130.10.10-FF-001586', NULL, 'protein CYPRO4', 314, NULL, NULL, 34500),
(34501, '3.40.50.10190-FF-000161', NULL, 'DNA ligase', 97, NULL, NULL, 34501),
(34502, '1.10.287.70-FF-000141', NULL, 'Polycystin family receptor for egg jelly', 124, NULL, NULL, 34502),
(34503, '3.90.550.50-FF-000042', NULL, 'Hexosyltransferase', 245, NULL, NULL, 34503),
(34504, '2.40.270.10-FF-000012', NULL, 'DNA-directed RNA polymerase subunit beta', 71, NULL, NULL, 34504),
(34505, '2.60.120.260-FF-000006', NULL, 'Proprotein convertase subtilisin/kexin type 5', 143, NULL, NULL, 34505),
(34506, '3.40.50.410-FF-000146', NULL, 'ATP-dependent DNA helicase II subunit 2', 196, NULL, NULL, 34506),
(34507, '1.20.58.1120-FF-000066', NULL, NULL, 153, NULL, NULL, 34507),
(34508, '1.20.1250.20-FF-001207', NULL, 'Glucose/mannose transporter GlcP', 180, NULL, NULL, 34508),
(34509, '3.40.1410.10-FF-000042', NULL, 'GntR family transcriptional regulator', 160, NULL, NULL, 34509),
(34510, '3.90.810.10-FF-000005', NULL, 'Non-specific serine/threonine protein kinase', 74, NULL, NULL, 34510),
(34511, '1.25.40.10-FF-002995', NULL, 'Uncharacterized protein', 129, NULL, NULL, 34511),
(34512, '2.30.30.40-FF-000072', NULL, 'Unconventional Myosin IB', 66, NULL, NULL, 34512),
(34513, '3.10.20.90-FF-000231', NULL, 'Ubiquitin C-terminal hydrolase', 106, NULL, NULL, 34513),
(34514, '1.20.120.230-FF-000058', NULL, 'Uncharacterized protein', 103, NULL, NULL, 34514),
(34515, '2.60.40.10-FF-002024', NULL, 'Sperm-specific class P protein 19', 109, NULL, NULL, 34515);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(34516, '3.90.850.10-FF-000019', NULL, 'Fumarylacetoacetate hydrolase', 218, NULL, NULL, 34516),
(34517, '1.25.10.10-FF-002499', NULL, 'Uncharacterized protein', 202, NULL, NULL, 34517),
(34518, '3.20.20.220-FF-000032', NULL, 'Proline dehydrogenase', 191, NULL, NULL, 34518),
(34519, '1.10.287.110-FF-000434', NULL, 'Uncharacterized protein', 79, NULL, NULL, 34519),
(34520, '1.10.8.610-FF-000001', NULL, 'Siroheme synthase', 69, NULL, NULL, 34520),
(34521, '3.60.21.10-FF-000336', NULL, 'Purple acid phosphatase 3', 178, NULL, NULL, 34521),
(34522, '3.40.50.300-FF-007297', NULL, 'Nuclear GTPase, germinal center-associated, tandem duplicate 1', 151, NULL, NULL, 34522),
(34523, '1.10.510.10-FF-000643', NULL, 'serine/threonine-protein kinase Nek10 isoform X1', 195, NULL, NULL, 34523),
(34524, '3.40.630.30-FF-000262', NULL, 'Protein N-acetyltransferase, RimJ/RimL family', 200, NULL, NULL, 34524),
(34525, '1.20.5.340-FF-000064', NULL, 'Protein CBR-LET-75', 122, NULL, NULL, 34525),
(34526, '3.60.130.10-FF-000022', NULL, 'Uncharacterized protein', 275, NULL, NULL, 34526),
(34527, '1.20.1070.10-FF-001460', NULL, 'RE03009p', 216, NULL, NULL, 34527),
(34528, '3.30.200.20-FF-000026', NULL, 'Tyrosine-protein kinase receptor', 108, NULL, NULL, 34528),
(34529, '3.40.50.720-FF-002268', NULL, 'Uncharacterized protein', 43, NULL, NULL, 34529),
(34530, '1.20.1250.20-FF-002298', NULL, 'Uncharacterized protein', 495, NULL, NULL, 34530),
(34531, '1.20.1250.20-FF-000954', NULL, 'MFS transporter', 190, NULL, NULL, 34531),
(34532, '2.60.40.60-FF-000324', NULL, 'FlaMIngo (Cadherin plus 7TM domain) homolog', 108, NULL, NULL, 34532),
(34533, '3.80.10.10-FF-002176', NULL, 'F-box/LRR-repeat protein At3g62440', 343, NULL, NULL, 34533),
(34534, '3.30.365.10-FF-000080', NULL, 'Uncharacterized protein', 83, NULL, NULL, 34534),
(34535, '3.10.20.310-FF-000033', NULL, 'Hemolysin activator-related protein', 51, NULL, NULL, 34535),
(34536, '1.10.8.720-FF-000034', NULL, 'Dynein heavy chain', 58, NULL, NULL, 34536),
(34537, '2.60.40.420-FF-000091', NULL, 'Copper-containing nitrite reductase', 334, NULL, NULL, 34537),
(34538, '3.30.40.10-FF-000387', NULL, 'RING finger protein 26', 77, NULL, NULL, 34538),
(34539, '3.30.160.60-FF-002237', NULL, 'Uncharacterized protein', 29, NULL, NULL, 34539),
(34540, '3.90.1420.10-FF-000020', NULL, 'Uncharacterized protein', 163, NULL, NULL, 34540),
(34541, '2.40.50.90-FF-000059', NULL, 'Ribonuclease', 147, NULL, NULL, 34541),
(34542, '3.10.129.10-FF-000081', NULL, 'Acyl-CoA thioester hydrolase, YbgC/YbaW family', 130, NULL, NULL, 34542),
(34543, '1.10.132.60-FF-000032', NULL, 'DNA polymerase', 81, NULL, NULL, 34543),
(34544, '3.30.450.20-FF-000319', NULL, 'Hypoxia-inducible factor 1 subunit alpha,-like', 65, NULL, NULL, 34544),
(34545, '3.10.20.620-FF-000007', NULL, 'Autophagy protein 5', 104, NULL, NULL, 34545),
(34546, '1.10.600.10-FF-000072', NULL, 'Phytoene synthase chloroplastic', 56, NULL, NULL, 34546),
(34547, '2.20.100.10-FF-000016', NULL, 'ADAMTS-like 3 isoform 1', 54, NULL, NULL, 34547),
(34548, '3.40.50.300-FF-007173', NULL, 'Uncharacterized protein', 173, NULL, NULL, 34548),
(34549, '1.20.58.400-FF-000020', NULL, 'Uncharacterized protein', 96, NULL, NULL, 34549),
(34550, '3.30.40.10-FF-001005', NULL, 'TNF receptor-associated factor 6', 63, NULL, NULL, 34550),
(34551, '2.130.10.10-FF-003406', NULL, 'YALI0C15653p', 196, NULL, NULL, 34551),
(34552, '1.25.10.10-FF-002971', NULL, 'Exportin 1', 644, NULL, NULL, 34552),
(34553, '3.30.70.330-FF-000269', NULL, 'Probable rna-binding protein 23 isoform', 93, NULL, NULL, 34553),
(34554, '2.60.40.10-FF-000079', NULL, 'Filamin-B isoform C', 103, NULL, NULL, 34554),
(34555, '3.30.2410.10-FF-000005', NULL, 'E3 ubiquitin-protein ligase TRIP12 isoform X1', 120, NULL, NULL, 34555),
(34556, '3.40.50.10190-FF-000318', NULL, 'Uncharacterized protein', 91, NULL, NULL, 34556),
(34557, '2.30.180.10-FF-000182', NULL, NULL, 142, NULL, NULL, 34557),
(34558, '3.40.50.2300-FF-001297', NULL, NULL, 133, NULL, NULL, 34558),
(34559, '3.40.190.10-FF-000120', NULL, 'Transcriptional regulator, LysR family', 100, NULL, NULL, 34559); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(34560, '1.20.1070.10-FF-000476', NULL, 'Protein CBR-GNRR-6', 326, NULL, NULL, 34560),
(34561, '1.25.40.10-FF-003613', NULL, 'Pentatricopeptide repeat-containing protein At3g23020', 108, NULL, NULL, 34561),
(34562, '3.30.230.130-FF-000009', NULL, 'Cullin 9', 144, NULL, NULL, 34562),
(34563, '2.130.10.10-FF-001372', NULL, 'U3 snoRNP protein', 284, NULL, NULL, 34563),
(34564, '2.60.40.60-FF-000072', NULL, 'Protocadherin 1', 113, NULL, NULL, 34564),
(34565, '3.90.1620.10-FF-000001', NULL, 'Penton protein', 292, NULL, NULL, 34565),
(34566, '1.10.506.10-FF-000004', NULL, 'IQ motif containing GTPase activating protein 1', 387, NULL, NULL, 34566),
(34567, '3.40.50.300-FF-002822', NULL, 'ABC transporter C family member 7', 268, NULL, NULL, 34567),
(34568, '1.50.40.10-FF-000037', NULL, 'Solute carrier family 25 member 29', 282, NULL, NULL, 34568),
(34569, '1.10.3080.10-FF-000053', NULL, 'Chloride channel protein', 336, NULL, NULL, 34569),
(34570, '1.10.10.10-FF-000879', NULL, 'Predicted protein', 75, NULL, NULL, 34570),
(34571, '2.60.120.920-FF-000120', NULL, 'Si:ch211-42i6.2', 181, NULL, NULL, 34571),
(34572, '2.60.40.10-FF-000787', NULL, 'ephrin type-B receptor 4', 90, NULL, NULL, 34572),
(34573, '3.50.50.60-FF-001357', NULL, 'Flavin-containing monooxygenase', 91, NULL, NULL, 34573),
(34574, '2.10.25.10-FF-000260', NULL, 'Notch receptor 4', 43, NULL, NULL, 34574),
(34575, '3.40.50.150-FF-001119', NULL, NULL, 202, NULL, NULL, 34575),
(34576, '3.30.70.330-FF-000977', NULL, 'Uncharacterized protein', 97, NULL, NULL, 34576),
(34577, '1.10.10.1540-FF-000003', NULL, 'Uncharacterized protein, isoform B', 87, NULL, NULL, 34577),
(34578, '2.60.40.60-FF-000633', NULL, 'Uncharacterized protein', 93, NULL, NULL, 34578),
(34579, '3.40.50.150-FF-000158', NULL, 'tRNA (guanine-N(7)-)-methyltransferase', 203, NULL, NULL, 34579),
(34580, '3.80.10.10-FF-000467', NULL, 'Cyclic nucleotide-binding domain protein', 76, NULL, NULL, 34580),
(34581, '2.80.10.50-FF-000105', NULL, 'Actin cross-linking protein, putative (DUF569)', 118, NULL, NULL, 34581),
(34582, '1.10.510.10-FF-001970', NULL, NULL, 94, NULL, NULL, 34582),
(34583, '3.40.50.1110-FF-000086', NULL, 'Uncharacterized protein', 86, NULL, NULL, 34583),
(34584, '3.40.50.300-FF-004059', NULL, 'Pentafunctional AROM polypeptide', 185, NULL, NULL, 34584),
(34585, '3.40.1110.10-FF-000002', NULL, 'Calcium-transporting ATPase', 160, NULL, NULL, 34585),
(34586, '3.30.40.10-FF-002096', NULL, 'Uncharacterized protein', 79, NULL, NULL, 34586),
(34587, '1.10.890.10-FF-000002', NULL, 'Acid stress chaperone HdeB', 79, NULL, NULL, 34587),
(34588, '2.40.70.10-FF-000200', NULL, 'Uncharacterized protein', 150, NULL, NULL, 34588),
(34589, '3.90.940.10-FF-000009', NULL, 'DNA-directed RNA polymerases I', 145, NULL, NULL, 34589),
(34590, '3.30.1490.20-FF-000108', NULL, 'Uncharacterized protein', 56, NULL, NULL, 34590),
(34591, '3.40.50.300-FF-005352', NULL, 'Exodeoxyribonuclease V, gamma subunit', 164, NULL, NULL, 34591),
(34592, '3.30.565.10-FF-000297', NULL, 'Two-component hybrid sensor and regulator', 149, NULL, NULL, 34592),
(34593, '2.130.10.10-FF-005970', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 240, NULL, NULL, 34593),
(34594, '1.10.150.50-FF-000127', NULL, 'Predicted protein', 60, NULL, NULL, 34594),
(34595, '2.60.120.10-FF-000722', NULL, 'Uncharacterized protein', 136, NULL, NULL, 34595),
(34596, '1.20.58.150-FF-000001', NULL, 'phosphatidylinositol-binding clathrin assembly protein-like isoform X1', 154, NULL, NULL, 34596),
(34597, '1.25.40.20-FF-001817', NULL, 'Uncharacterized protein', 159, NULL, NULL, 34597),
(34598, '1.10.150.110-FF-000025', NULL, 'Crossover junction endonuclease MUS81', 71, NULL, NULL, 34598),
(34599, '3.30.160.20-FF-000202', NULL, 'Peptide chain release factor PrfB3, chloroplastic', 91, NULL, NULL, 34599),
(34600, '1.10.1750.10-FF-000008', NULL, 'Chromosomal replication initiator protein DnaA 1', 106, NULL, NULL, 34600),
(34601, '3.30.300.30-FF-000104', NULL, 'Fatty acyl-AMP ligase', 129, NULL, NULL, 34601),
(34602, '2.20.25.630-FF-000004', NULL, 'Poly [ADP-ribose] polymerase', 63, NULL, NULL, 34602);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(34603, '3.20.20.140-FF-000215', NULL, 'Putative imidazolonepropionase', 156, NULL, NULL, 34603),
(34604, '3.90.950.10-FF-000038', NULL, 'dTTP/UTP pyrophosphatase', 187, NULL, NULL, 34604),
(34605, '3.40.50.1820-FF-001057', NULL, 'Uncharacterized protein', 375, NULL, NULL, 34605),
(34606, '2.30.30.140-FF-000314', NULL, 'Uncharacterized protein', 62, NULL, NULL, 34606),
(34607, '2.10.220.10-FF-000117', NULL, 'Proprotein convertase subtilisin/kexin type', 99, NULL, NULL, 34607),
(34608, '3.40.309.10-FF-000037', NULL, 'Aldehyde dehydrogenase', 210, NULL, NULL, 34608),
(34609, '2.60.120.290-FF-000004', NULL, 'Metalloendopeptidase', 114, NULL, NULL, 34609),
(34610, '3.50.50.60-FF-000177', NULL, 'Lysine-specific histone demethylase Aof2', 139, NULL, NULL, 34610),
(34611, '2.60.40.420-FF-000124', NULL, 'Laccase-10-like Protein', 214, NULL, NULL, 34611),
(34612, '1.50.10.10-FF-000198', NULL, 'alpha-1,2-Mannosidase', 220, NULL, NULL, 34612),
(34613, '2.40.10.10-FF-000224', NULL, 'Protease, serine 51', 195, NULL, NULL, 34613),
(34614, '3.40.50.2000-FF-000925', NULL, 'UDP-glucuronosyltransferase', 158, NULL, NULL, 34614),
(34615, '1.20.1060.10-FF-000009', NULL, 'DNA-directed DNA polymerase, putative', 105, NULL, NULL, 34615),
(34616, '1.20.80.10-FF-000035', NULL, 'Inactive tyrosine-protein kinase kin-32', 124, NULL, NULL, 34616),
(34617, '3.40.50.300-FF-007482', NULL, 'RNA helicase', 235, NULL, NULL, 34617),
(34618, '2.10.25.10-FF-000636', NULL, 'Uncharacterized protein', 36, NULL, NULL, 34618),
(34619, '2.60.120.330-FF-000185', NULL, 'Uncharacterized protein', 190, NULL, NULL, 34619),
(34620, '3.30.750.24-FF-000128', NULL, 'Sodium-independent sulfate anion transporter', 112, NULL, NULL, 34620),
(34621, '2.130.10.10-FF-005638', NULL, 'Predicted protein', 176, NULL, NULL, 34621),
(34622, '1.20.1260.10-FF-000070', NULL, 'Uncharacterized protein', 50, NULL, NULL, 34622),
(34623, '3.30.70.1070-FF-000003', NULL, 'Endolytic peptidoglycan transglycosylase RlpA', 79, NULL, NULL, 34623),
(34624, '3.30.70.330-FF-002764', NULL, NULL, 79, NULL, NULL, 34624),
(34625, '1.20.1560.10-FF-000671', NULL, 'Uncharacterized protein', 37, NULL, NULL, 34625),
(34626, '3.20.20.140-FF-000362', NULL, 'Uncharacterized protein', 264, NULL, NULL, 34626),
(34627, '1.10.238.10-FF-000757', NULL, 'EF-hand calcium-binding domain 6', 77, NULL, NULL, 34627),
(34628, '3.40.50.300-FF-006313', NULL, 'CTP synthase', 95, NULL, NULL, 34628),
(34629, '3.40.50.300-FF-005695', NULL, 'ATP-dependent DNA helicase Dna2', 179, NULL, NULL, 34629),
(34630, '1.10.167.10-FF-000075', NULL, 'Axin-like protein pry-1', 135, NULL, NULL, 34630),
(34631, '3.40.50.2300-FF-000948', NULL, NULL, 137, NULL, NULL, 34631),
(34632, '2.60.40.10-FF-000006', NULL, 'Uncharacterized protein, isoform F', 98, NULL, NULL, 34632),
(34633, '3.40.50.720-FF-001560', NULL, 'Estradiol 17-beta-dehydrogenase', 250, NULL, NULL, 34633),
(34634, '1.20.5.110-FF-000124', NULL, 'SNARE protein, putative', 63, NULL, NULL, 34634),
(34635, '3.40.50.720-FF-000470', NULL, 'NAD-dependent epimerase/dehydratase family protein', 307, NULL, NULL, 34635),
(34636, '2.130.10.10-FF-001928', NULL, 'Autophagy-related protein 18', 327, NULL, NULL, 34636),
(34637, '3.30.460.10-FF-000126', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 247, NULL, NULL, 34637),
(34638, '1.10.10.1180-FF-000007', NULL, 'Man1-Src1p-carboxy-terminal domain protein', 97, NULL, NULL, 34638),
(34639, '1.25.10.10-FF-000498', NULL, 'testis-expressed sequence 10 protein', 277, NULL, NULL, 34639),
(34640, '3.40.830.10-FF-000001', NULL, '2,3-dihydroxyphenylpropionate/2,3-dihydroxicinnamic acid 1,2-dioxygenase', 269, NULL, NULL, 34640),
(34641, '2.60.15.10-FF-000026', NULL, 'ATP synthase epsilon chain', 87, NULL, NULL, 34641),
(34642, '1.20.1270.250-FF-000003', NULL, 'Inhibitor of nuclear factor kappa B kinase subunit beta', 115, NULL, NULL, 34642),
(34643, '3.40.50.300-FF-003587', NULL, 'ADP-ribosylation factor-like protein 13B', 205, NULL, NULL, 34643),
(34644, '2.60.40.180-FF-000018', NULL, '5-hydroxyisourate hydrolase', 107, NULL, NULL, 34644);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(34645, '3.40.50.150-FF-000490', NULL, 'putative methyltransferase NSUN6 isoform X1', 246, NULL, NULL, 34645),
(34646, '3.30.230.130-FF-000032', NULL, 'Anaphase-promoting complex subunit 2', 151, NULL, NULL, 34646),
(34647, '3.10.20.90-FF-000995', NULL, 'Plant UBX domain-containing protein 6', 87, NULL, NULL, 34647),
(34648, '2.30.330.10-FF-000008', NULL, 'Flagellar motor switch protein FliN', 87, NULL, NULL, 34648),
(34649, '3.90.190.10-FF-000070', NULL, 'Receptor-type tyrosine-protein phosphatase kappa', 299, NULL, NULL, 34649),
(34650, '1.25.40.10-FF-001719', NULL, 'Sgt1p', 163, NULL, NULL, 34650),
(34651, '2.40.10.220-FF-000006', NULL, 'Cellulose synthase catalytic subunit', 111, NULL, NULL, 34651),
(34652, '1.10.3470.10-FF-000009', NULL, 'Fe(3+) dicitrate transport system permease fecC', 329, NULL, NULL, 34652),
(34653, '3.40.50.2300-FF-000572', NULL, 'Chemotaxis protein CheY', 123, NULL, NULL, 34653),
(34654, '3.40.50.620-FF-000439', NULL, 'Glutamine-dependent NAD(+) synthetase', 270, NULL, NULL, 34654),
(34655, '3.30.40.10-FF-001348', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 107, NULL, NULL, 34655),
(34656, '3.30.160.60-FF-002108', NULL, 'Zinc finger and SCAN domain containing 20', 73, NULL, NULL, 34656),
(34657, '2.20.70.10-FF-000279', NULL, 'Uncharacterized protein', 60, NULL, NULL, 34657),
(34658, '3.40.50.2300-FF-001662', NULL, NULL, 182, NULL, NULL, 34658),
(34659, '3.90.70.10-FF-000049', NULL, 'ubiquitin carboxyl-terminal hydrolase 48', 334, NULL, NULL, 34659),
(34660, '3.20.20.80-FF-000233', NULL, 'Probable glucan endo-1,3-beta-glucosidase eglC', 123, NULL, NULL, 34660),
(34661, '3.10.110.10-FF-000240', NULL, 'Uncharacterized protein', 127, NULL, NULL, 34661),
(34662, '3.40.50.720-FF-000267', NULL, 'Hydroxysteroid 17-beta dehydrogenase 4', 44, NULL, NULL, 34662),
(34663, '2.60.120.200-FF-000691', NULL, 'Predicted protein', 200, NULL, NULL, 34663),
(34664, '3.40.50.2300-FF-000369', NULL, 'Vomeronasal 2, receptor 88', 218, NULL, NULL, 34664),
(34665, '2.60.40.1730-FF-000121', NULL, NULL, 55, NULL, NULL, 34665),
(34666, '3.40.50.300-FF-007858', NULL, 'Peroxisome biogenesis factor 1', 211, NULL, NULL, 34666),
(34667, '2.10.70.10-FF-000021', NULL, 'fibronectin isoform X1', 39, NULL, NULL, 34667),
(34668, '3.40.50.300-FF-005604', NULL, 'Predicted protein', 299, NULL, NULL, 34668),
(34669, '3.30.420.80-FF-000021', NULL, '30S ribosomal protein S11, chloroplastic', 128, NULL, NULL, 34669),
(34670, '2.10.25.10-FF-001350', NULL, 'Predicted protein', 47, NULL, NULL, 34670),
(34671, '3.90.1150.10-FF-000347', NULL, 'Cysteine desulfhydrase', 136, NULL, NULL, 34671),
(34672, '1.20.1560.10-FF-000918', NULL, 'Uncharacterized protein', 97, NULL, NULL, 34672),
(34673, '2.40.37.20-FF-000002', NULL, 'D-serine dehydratase', 131, NULL, NULL, 34673),
(34674, '3.75.10.10-FF-000036', NULL, NULL, 152, NULL, NULL, 34674),
(34675, '3.40.50.300-FF-006004', NULL, 'Katanin p60 ATPase-containing subunit A-like 2', 35, NULL, NULL, 34675),
(34676, '3.50.50.100-FF-000012', NULL, 'Type II NADH:ubiquinone oxidoreductase', 392, NULL, NULL, 34676),
(34677, '3.60.20.10-FF-000025', NULL, 'Proteasome subunit alpha type', 232, NULL, NULL, 34677),
(34678, '3.40.960.10-FF-000005', NULL, 'Cullin, a subunit of E3 ubiquitin ligase', 105, NULL, NULL, 34678),
(34679, '3.30.160.60-FF-000528', NULL, 'zinc finger protein 668', 26, NULL, NULL, 34679),
(34680, '3.30.70.2750-FF-000001', NULL, 'V-type ATP synthase subunit I', 71, NULL, NULL, 34680),
(34681, '2.130.10.30-FF-000074', NULL, 'Regulator of chromosome condensation, putative', 206, NULL, NULL, 34681),
(34682, '2.60.260.20-FF-000089', NULL, 'DnaJ homolog subfamily B member 1', 57, NULL, NULL, 34682),
(34683, '3.30.428.10-FF-000029', NULL, 'Unplaced genomic scaffold supercont2.5, whole genome shotgun sequence', 225, NULL, NULL, 34683),
(34684, '1.10.1420.10-FF-000130', NULL, 'Dna mismatch repair protein', 94, NULL, NULL, 34684),
(34685, '1.10.287.130-FF-000193', NULL, 'Sensory transduction histidine kinase', 57, NULL, NULL, 34685),
(34686, '1.10.150.20-FF-000129', NULL, 'DNA polymerase IV', 62, NULL, NULL, 34686);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(34687, '2.130.10.10-FF-005329', NULL, 'AGL196Cp', 192, NULL, NULL, 34687),
(34688, '3.90.80.10-FF-000022', NULL, 'Predicted protein', 162, NULL, NULL, 34688),
(34689, '3.40.50.300-FF-001333', NULL, 'FA complementation group M', 180, NULL, NULL, 34689),
(34690, '2.130.10.10-FF-000967', NULL, 'Bardet-Biedl syndrome 2 protein homolog', 317, NULL, NULL, 34690),
(34691, '1.10.10.2210-FF-000002', NULL, 'Telomerase reverse transcriptase', 37, NULL, NULL, 34691),
(34692, '2.30.29.30-FF-000009', NULL, 'Cytohesin 1', 125, NULL, NULL, 34692),
(34693, '3.40.50.11060-FF-000006', NULL, 'Predicted protein', 122, NULL, NULL, 34693),
(34694, '3.30.1370.240-FF-000010', NULL, 'Alpha subunit of phenylalanyl-tRNA synthetase', 94, NULL, NULL, 34694),
(34695, '1.25.40.570-FF-000011', NULL, 'COP9 signalosome complex subunit 2', 376, NULL, NULL, 34695),
(34696, '3.40.50.300-FF-000714', NULL, 'cell cycle checkpoint protein RAD17 isoform X1', 184, NULL, NULL, 34696),
(34697, '3.80.10.10-FF-003031', NULL, 'F-box protein FBW2', 128, NULL, NULL, 34697),
(34698, '3.80.10.10-FF-002412', NULL, 'Uncharacterized protein', 122, NULL, NULL, 34698),
(34699, '3.30.160.60-FF-000894', NULL, 'Uncharacterized protein, isoform C', 77, NULL, NULL, 34699),
(34700, '2.30.30.140-FF-000129', NULL, 'NuA4 complex subunit EAF3 homolog', 95, NULL, NULL, 34700),
(34701, '2.30.30.140-FF-000005', NULL, 'Putative lysine-specific demethylase 4a', 61, NULL, NULL, 34701),
(34702, '1.10.640.10-FF-000091', NULL, 'Dual oxidase 2', 394, NULL, NULL, 34702),
(34703, '2.130.10.10-FF-004334', NULL, 'Uncharacterized protein', 99, NULL, NULL, 34703),
(34704, '2.60.40.10-FF-003749', NULL, NULL, 108, NULL, NULL, 34704),
(34705, '3.40.1000.10-FF-000011', NULL, 'Lipoprotein LpqN', 145, NULL, NULL, 34705),
(34706, '3.40.140.10-FF-000038', NULL, 'tRNA-specific adenosine deaminase', 149, NULL, NULL, 34706),
(34707, '1.20.930.10-FF-000009', NULL, 'Hepatoma-derived growth factor-related protein 2', 80, NULL, NULL, 34707),
(34708, '2.60.120.40-FF-000051', NULL, 'collagen alpha-1(X) chain-like', 133, NULL, NULL, 34708),
(34709, '3.30.160.60-FF-005907', NULL, NULL, 56, NULL, NULL, 34709),
(34710, '1.10.8.60-FF-000213', NULL, 'AAA family ATPase, CDC48 subfamily', 100, NULL, NULL, 34710),
(34711, '3.30.830.10-FF-000071', NULL, 'Cytochrome b-c1 complex subunit 2, mitochondrial', 135, NULL, NULL, 34711),
(34712, '3.30.420.40-FF-000015', NULL, 'Hexokinase 1', 168, NULL, NULL, 34712),
(34713, '1.25.40.10-FF-004597', NULL, 'TPR Domain containing protein', 168, NULL, NULL, 34713),
(34714, '3.80.10.10-FF-003340', NULL, 'Uncharacterized protein', 121, NULL, NULL, 34714),
(34715, '1.25.10.10-FF-001206', NULL, 'Exportin T (TRNA exportin)-like protein', 317, NULL, NULL, 34715),
(34716, '3.10.580.10-FF-000191', NULL, 'Uncharacterized protein', 130, NULL, NULL, 34716),
(34717, '1.20.1250.20-FF-001426', NULL, 'MFS general substrate transporter', 167, NULL, NULL, 34717),
(34718, '2.60.120.590-FF-000009', NULL, 'Alpha-ketoglutarate-dependent dioxygenase alkB homolog 7, mitochondrial', 194, NULL, NULL, 34718),
(34719, '3.80.10.10-FF-002940', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 74, NULL, NULL, 34719),
(34720, '2.130.10.10-FF-000658', NULL, 'Eukaryotic translation initiation factor 3 subunit I', 333, NULL, NULL, 34720),
(34721, '3.40.50.300-FF-001642', NULL, 'Multidrug ABC transporter ATP-binding protein', 263, NULL, NULL, 34721),
(34722, '2.60.40.10-FF-005913', NULL, NULL, 49, NULL, NULL, 34722),
(34723, '1.20.1080.10-FF-000117', NULL, 'AQuaPorin or aquaglyceroporin related', 99, NULL, NULL, 34723),
(34724, '3.30.450.50-FF-000065', NULL, 'Uncharacterized protein', 87, NULL, NULL, 34724),
(34725, '3.30.70.360-FF-000053', NULL, 'Hydrolase, ama/hipO/hyuC family', 108, NULL, NULL, 34725),
(34726, '1.10.510.10-FF-001947', NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase At5g58150', 197, NULL, NULL, 34726),
(34727, '3.40.50.300-FF-004767', NULL, 'Uncharacterized protein', 43, NULL, NULL, 34727),
(34728, '1.10.10.60-FF-000271', NULL, 'Homeobox protein MSX-2', 77, NULL, NULL, 34728); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(34729, '3.80.10.10-FF-001086', NULL, 'P53-induced death domain protein 1', 258, NULL, NULL, 34729),
(34730, '1.10.10.60-FF-000647', NULL, 'One cut domain family member', 74, NULL, NULL, 34730),
(34731, '2.60.40.10-FF-000534', NULL, 'Tenascin N', 84, NULL, NULL, 34731),
(34732, '2.10.90.10-FF-000034', NULL, 'Interleukin 17B', 127, NULL, NULL, 34732),
(34733, '3.30.450.20-FF-000522', NULL, 'Protein kinase, putative', 72, NULL, NULL, 34733),
(34734, '1.10.132.30-FF-000034', NULL, 'DNA-directed RNA polymerase subunit', 114, NULL, NULL, 34734),
(34735, '1.25.40.1030-FF-000039', NULL, 'Uncharacterized protein', 122, NULL, NULL, 34735),
(34736, '1.20.58.1710-FF-000001', NULL, 'Mediator of RNA polymerase II transcription subunit 8', 66, NULL, NULL, 34736),
(34737, '2.130.10.10-FF-000990', NULL, 'GG12984', 85, NULL, NULL, 34737),
(34738, '3.40.47.10-FF-000256', NULL, NULL, 317, NULL, NULL, 34738),
(34739, '3.30.160.60-FF-001147', NULL, 'Sp6 transcription factor', 34, NULL, NULL, 34739),
(34740, '3.40.50.300-FF-000372', NULL, 'Adenylate kinase isoenzyme 6 homolog', 174, NULL, NULL, 34740),
(34741, '1.20.120.350-FF-000167', NULL, NULL, 86, NULL, NULL, 34741),
(34742, '3.30.200.20-FF-001116', NULL, 'Mitogen-activated protein kinase 3', 116, NULL, NULL, 34742),
(34743, '1.25.40.10-FF-002124', NULL, 'Os07g0635800 protein', 97, NULL, NULL, 34743),
(34744, '2.120.10.30-FF-000030', NULL, 'Nidogen 1', 267, NULL, NULL, 34744),
(34745, '3.40.50.300-FF-003098', NULL, 'ATP-binding protein SCC61A06c', 167, NULL, NULL, 34745),
(34746, '1.10.220.60-FF-000001', NULL, 'golgin subfamily A member 4', 58, NULL, NULL, 34746),
(34747, '1.20.1110.10-FF-000115', NULL, 'Uncharacterized protein', 270, NULL, NULL, 34747),
(34748, '3.80.10.10-FF-002631', NULL, 'Uncharacterized protein', 163, NULL, NULL, 34748),
(34749, '3.80.10.10-FF-002070', NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', 250, NULL, NULL, 34749),
(34750, '1.10.1300.10-FF-000076', NULL, 'Uncharacterized protein', 49, NULL, NULL, 34750),
(34751, '1.20.1560.10-FF-000143', NULL, 'ATP-binding Cassette (ABC) Superfamily', 317, NULL, NULL, 34751),
(34752, '3.10.129.10-FF-000187', NULL, 'Probable acyl-coenzyme a thioester hydrolase', 153, NULL, NULL, 34752),
(34753, '3.40.50.300-FF-000681', NULL, 'probable ATP-dependent RNA helicase DDX47', 219, NULL, NULL, 34753),
(34754, '3.30.300.150-FF-000004', NULL, 'DNA polymerase III subunit gamma/tau', 112, NULL, NULL, 34754),
(34755, '1.10.418.10-FF-000035', NULL, 'girdin isoform X1', 162, NULL, NULL, 34755),
(34756, '3.40.50.2020-FF-000156', NULL, 'Uncharacterized protein', 119, NULL, NULL, 34756),
(34757, '3.30.465.10-FF-000098', NULL, 'Aspergillus niger contig An11c0010, genomic contig', 30, NULL, NULL, 34757),
(34758, '3.30.450.20-FF-000213', NULL, 'VWFA and cache domain-containing protein', 36, NULL, NULL, 34758),
(34759, '3.30.70.330-FF-003017', NULL, NULL, 71, NULL, NULL, 34759),
(34760, '3.30.540.10-FF-000094', NULL, 'Erlin-2', 55, NULL, NULL, 34760),
(34761, '1.10.10.2660-FF-000024', NULL, 'SUMO-activating enzyme subunit', 215, NULL, NULL, 34761),
(34762, '3.40.50.300-FF-005043', NULL, 'Si:dkey-23k10.5', 230, NULL, NULL, 34762),
(34763, '3.30.160.60-FF-005750', NULL, NULL, 76, NULL, NULL, 34763),
(34764, '1.10.2000.10-FF-000076', NULL, NULL, 159, NULL, NULL, 34764),
(34765, '3.40.50.300-FF-008477', NULL, 'Predicted protein', 216, NULL, NULL, 34765),
(34766, '1.10.510.10-FF-001823', NULL, 'Protein kinase, putative', 253, NULL, NULL, 34766),
(34767, '3.40.1110.10-FF-000221', NULL, 'Phospholipid-transporting ATPase', 148, NULL, NULL, 34767),
(34768, '1.10.340.30-FF-000057', NULL, '3-methyladenine DNA glycosylase', 109, NULL, NULL, 34768),
(34769, '1.10.510.10-FF-001638', NULL, 'Protein kinase, putative', 285, NULL, NULL, 34769),
(34770, '1.10.150.670-FF-000024', NULL, 'Uncharacterized protein', 77, NULL, NULL, 34770),
(34771, '3.40.190.290-FF-000033', NULL, 'LysR family transcriptional regulator', 204, NULL, NULL, 34771),
(34772, '3.40.50.2000-FF-000364', NULL, 'UDP-glucose:(Heptosyl) LPS alpha 1,3-glucosyltransferase WaaG', 166, NULL, NULL, 34772);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(34773, '1.25.10.10-FF-001881', NULL, 'ARM repeat superfamily protein', 388, NULL, NULL, 34773),
(34774, '2.40.100.10-FF-000135', NULL, 'Peptidyl-prolyl cis-trans isomerase', 184, NULL, NULL, 34774),
(34775, '2.130.10.10-FF-000282', NULL, 'Syntaxin binding protein 5 like', 177, NULL, NULL, 34775),
(34776, '2.30.29.30-FF-000341', NULL, 'dynamin-3 isoform X1', 118, NULL, NULL, 34776),
(34777, '3.30.310.80-FF-000030', NULL, 'Probable serine/threonine-protein kinase MARK-B', 112, NULL, NULL, 34777),
(34778, '1.25.10.10-FF-001431', NULL, 'Putative tubulin-specific chaperone d', 204, NULL, NULL, 34778),
(34779, '3.40.50.300-FF-006324', NULL, 'Uncharacterized protein', 271, NULL, NULL, 34779),
(34780, '1.20.900.10-FF-000087', NULL, 'FERM, ARH/RhoGEF and pleckstrin domain protein 2', 209, NULL, NULL, 34780),
(34781, '1.25.40.470-FF-000071', NULL, 'Uncharacterized protein', 146, NULL, NULL, 34781),
(34782, '1.10.510.10-FF-001059', NULL, 'Male germ cell associated kinase', 164, NULL, NULL, 34782),
(34783, '1.25.40.1030-FF-000028', NULL, 'Predicted protein', 199, NULL, NULL, 34783),
(34784, '2.40.10.220-FF-000001', NULL, 'Cellulose synthase catalytic subunit [UDP-forming]', 107, NULL, NULL, 34784),
(34785, '2.70.150.10-FF-000047', NULL, 'Phospholipid-transporting ATPase', 139, NULL, NULL, 34785),
(34786, '3.30.70.330-FF-001461', NULL, 'DnaJ homolog subfamily C member 17', 98, NULL, NULL, 34786),
(34787, '3.40.50.10090-FF-000030', NULL, 'Uroporphyrinogen-III synthase', 142, NULL, NULL, 34787),
(34788, '1.10.8.10-FF-000215', NULL, 'hemK methyltransferase family member 1 isoform X1', 81, NULL, NULL, 34788),
(34789, '2.40.180.10-FF-000022', NULL, 'CatA, catalase', 501, NULL, NULL, 34789),
(34790, '3.40.50.300-FF-003570', NULL, 'Isoniazid inductible gene protein IniA', 233, NULL, NULL, 34790),
(34791, '4.10.640.10-FF-000023', NULL, 'Mitochondrial Ribosomal Protein, Small', 61, NULL, NULL, 34791),
(34792, '1.20.1440.340-FF-000002', NULL, 'Galactokinase', 151, NULL, NULL, 34792),
(34793, '2.60.40.10-FF-003199', NULL, 'Uncharacterized protein', 118, NULL, NULL, 34793),
(34794, '3.30.40.10-FF-000859', NULL, 'Histone-lysine N-methyltransferase', 59, NULL, NULL, 34794),
(34795, '3.40.50.12780-FF-000090', NULL, 'Long-chain-fatty-acid--CoA ligase FadD15', 401, NULL, NULL, 34795),
(34796, '3.10.20.310-FF-000010', NULL, 'sorting and assembly machinery component 50 homolog', 94, NULL, NULL, 34796),
(34797, '1.25.40.180-FF-000091', NULL, 'Eukaryotic translation initiation factor 5', 180, NULL, NULL, 34797),
(34798, '1.10.510.10-FF-001610', NULL, 'Uncharacterized protein', 314, NULL, NULL, 34798),
(34799, '3.65.10.20-FF-000017', NULL, 'RNA cyclase-like protein', 41, NULL, NULL, 34799),
(34800, '3.40.50.2300-FF-001437', NULL, NULL, 82, NULL, NULL, 34800),
(34801, '3.30.40.10-FF-001365', NULL, 'Uncharacterized protein', 67, NULL, NULL, 34801),
(34802, '3.40.30.10-FF-000049', NULL, 'Glutathione peroxidase', 175, NULL, NULL, 34802),
(34803, '2.130.10.10-FF-000630', NULL, 'Ribosome assembly protein SQT1', 373, NULL, NULL, 34803),
(34804, '3.30.379.10-FF-000004', NULL, 'Beta-hexosaminidase', 186, NULL, NULL, 34804),
(34805, '3.40.720.10-FF-000364', NULL, 'Uncharacterized protein', 168, NULL, NULL, 34805),
(34806, '3.40.50.300-FF-001541', NULL, 'Dynein heavy chain', 194, NULL, NULL, 34806),
(34807, '1.10.510.10-FF-001498', NULL, 'Serine/threonine-protein kinase PLK', 252, NULL, NULL, 34807),
(34808, '2.60.40.10-FF-005435', NULL, NULL, 92, NULL, NULL, 34808),
(34809, '3.30.160.60-FF-002125', NULL, 'zinc finger protein 33B-like', 28, NULL, NULL, 34809),
(34810, '3.30.559.30-FF-000108', NULL, 'Uncharacterized protein', 238, NULL, NULL, 34810),
(34811, '1.25.10.10-FF-002954', NULL, 'Uncharacterized protein', 449, NULL, NULL, 34811),
(34812, '3.40.50.300-FF-000922', NULL, 'DEAD/DEAH box helicase', 198, NULL, NULL, 34812),
(34813, '1.20.58.450-FF-000001', NULL, 'SPI-1 type III secretion system effector inositol phosphate phosphatase SopB', 124, NULL, NULL, 34813),
(34814, '1.10.472.10-FF-000565', NULL, 'Cyclin, N-terminal domain containing protein', 62, NULL, NULL, 34814);
INSERT INTO "PUBLIC"."MODEL" VALUES
(34815, '3.40.1190.20-FF-000089', NULL, 'ketohexokinase isoform X1', 111, NULL, NULL, 34815),
(34816, '1.25.40.10-FF-003057', NULL, 'RNA polymerase III transcription factor, putative', 235, NULL, NULL, 34816),
(34817, '3.40.50.2000-FF-000948', NULL, 'Glycosyltransferase', 117, NULL, NULL, 34817),
(34818, '3.40.1190.20-FF-000201', NULL, NULL, 176, NULL, NULL, 34818),
(34819, '2.130.10.10-FF-001035', NULL, 'Putative WD repeat protein', 222, NULL, NULL, 34819),
(34820, '3.30.750.24-FF-000100', NULL, 'Uncharacterized protein', 114, NULL, NULL, 34820),
(34821, '2.60.120.200-FF-000489', NULL, 'Predicted protein', 204, NULL, NULL, 34821),
(34822, '3.90.470.20-FF-000015', NULL, '4-phosphopantetheinyl transferase', 80, NULL, NULL, 34822),
(34823, '3.40.50.880-FF-000169', NULL, 'Predicted protein', 240, NULL, NULL, 34823),
(34824, '3.40.50.1260-FF-000001', NULL, 'Phosphoglycerate kinase', 212, NULL, NULL, 34824),
(34825, '1.10.630.10-FF-000034', NULL, 'Cholesterol 7-alpha-monooxygenase', 482, NULL, NULL, 34825),
(34826, '1.10.10.10-FF-001363', NULL, 'DNA repair protein, putative', 97, NULL, NULL, 34826),
(34827, '2.130.10.10-FF-003856', NULL, 'Uncharacterized protein', 285, NULL, NULL, 34827),
(34828, '3.60.40.10-FF-000167', NULL, 'Protein phosphatase 2C', 280, NULL, NULL, 34828),
(34829, '1.10.2000.10-FF-000053', NULL, NULL, 138, NULL, NULL, 34829),
(34830, '2.10.70.10-FF-000235', NULL, 'Uncharacterized protein', 62, NULL, NULL, 34830),
(34831, '3.90.700.10-FF-000008', NULL, 'Conserved hypothetical flavoprotein', 124, NULL, NULL, 34831),
(34832, '3.60.20.10-FF-000154', NULL, 'Acyl-homoserine lactone acylase QuiP', 317, NULL, NULL, 34832),
(34833, '3.30.160.60-FF-005986', NULL, NULL, 54, NULL, NULL, 34833),
(34834, '3.30.479.20-FF-000060', NULL, 'Elongation factor Ts, mitochondrial', 132, NULL, NULL, 34834),
(34835, '2.10.25.10-FF-000158', NULL, 'proheparin-binding EGF-like growth factor', 49, NULL, NULL, 34835),
(34836, '3.50.30.30-FF-000178', NULL, 'Os01g0795400 protein', 24, NULL, NULL, 34836),
(34837, '3.10.330.20-FF-000006', NULL, 'tRNA (adenine(58)-N(1))-methyltransferase', 63, NULL, NULL, 34837),
(34838, '3.20.20.20-FF-000035', NULL, 'Dihydropteroate synthase', 267, NULL, NULL, 34838),
(34839, '3.90.320.10-FF-000030', NULL, 'CRISPR-associated exonuclease Cas4', 202, NULL, NULL, 34839),
(34840, '3.40.30.10-FF-000150', NULL, 'Protein disulfide-isomerase', 105, NULL, NULL, 34840),
(34841, '3.80.20.20-FF-000089', NULL, 'Uncharacterized protein', 96, NULL, NULL, 34841),
(34842, '3.40.1190.20-FF-000190', NULL, NULL, 275, NULL, NULL, 34842),
(34843, '3.10.110.10-FF-000268', NULL, 'Ubiquitin protein ligase, putative', 147, NULL, NULL, 34843),
(34844, '3.30.390.120-FF-000002', NULL, 'Rubredoxin-NAD(+) reductase', 64, NULL, NULL, 34844),
(34845, '1.25.40.10-FF-001612', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 224, NULL, NULL, 34845),
(34846, '3.30.200.20-FF-000594', NULL, 'Putative serine/threonine-protein kinase', 94, NULL, NULL, 34846),
(34847, '1.10.510.10-FF-002015', NULL, 'Uncharacterized protein', 208, NULL, NULL, 34847),
(34848, '1.10.238.10-FF-000049', NULL, 'Respiratory burst oxidase homolog A', 117, NULL, NULL, 34848),
(34849, '2.130.10.10-FF-003373', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 225, NULL, NULL, 34849),
(34850, '3.30.230.10-FF-000093', NULL, '40S ribosomal protein S16', 149, NULL, NULL, 34850),
(34851, '1.10.20.10-FF-000251', NULL, NULL, 66, NULL, NULL, 34851),
(34852, '3.30.200.20-FF-001111', NULL, 'Protein kinase, putative', 19, NULL, NULL, 34852),
(34853, '3.90.1280.20-FF-000005', NULL, 'Magnesium and cobalt transporter', 66, NULL, NULL, 34853),
(34854, '3.40.50.1100-FF-000206', NULL, 'Cysteine synthase, putative', 17, NULL, NULL, 34854),
(34855, '3.30.450.20-FF-000314', NULL, 'Two-component hybrid sensor and regulator', 120, NULL, NULL, 34855),
(34856, '3.50.50.60-FF-001014', NULL, 'Pyridine nucleotide-disulphide oxidoreductase family protein', 174, NULL, NULL, 34856),
(34857, '1.25.50.20-FF-000020', NULL, 'Aminopeptidase-like protein AC3.5', 331, NULL, NULL, 34857);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(34858, '1.10.287.110-FF-000451', NULL, 'Uncharacterized protein', 139, NULL, NULL, 34858),
(34859, '1.10.472.130-FF-000020', NULL, 'Dynein heavy chain, putative', 156, NULL, NULL, 34859),
(34860, '1.10.533.10-FF-000235', NULL, 'Uncharacterized protein', 150, NULL, NULL, 34860),
(34861, '2.20.25.10-FF-000068', NULL, 'Trm112p family protein', 124, NULL, NULL, 34861),
(34862, '2.60.40.1760-FF-000012', NULL, 'Alpha-glucosidase', 148, NULL, NULL, 34862),
(34863, '3.30.2130.30-FF-000034', NULL, 'Putative RNA methylase', 178, NULL, NULL, 34863),
(34864, '3.30.70.330-FF-002871', NULL, NULL, 73, NULL, NULL, 34864),
(34865, '1.20.950.20-FF-000025', NULL, 'Cytochrome b', 70, NULL, NULL, 34865),
(34866, '2.70.170.10-FF-000161', NULL, 'Transmembrane ion channel', 147, NULL, NULL, 34866),
(34867, '2.10.25.10-FF-000372', NULL, 'protein crumbs homolog 2', 42, NULL, NULL, 34867),
(34868, '1.20.58.60-FF-000762', NULL, 'Uncharacterized protein', 256, NULL, NULL, 34868),
(34869, '3.30.160.60-FF-000422', NULL, 'Zinc finger and BTB domain containing 37', 28, NULL, NULL, 34869),
(34870, '3.40.1110.10-FF-000452', NULL, NULL, 138, NULL, NULL, 34870),
(34871, '2.60.40.150-FF-000228', NULL, 'Blast:Protein kibra', 124, NULL, NULL, 34871),
(34872, '3.40.50.1220-FF-000129', NULL, 'Uncharacterized protein', 158, NULL, NULL, 34872),
(34873, '1.10.287.1040-FF-000012', NULL, 'Exodeoxyribonuclease 7 small subunit', 72, NULL, NULL, 34873),
(34874, '2.60.120.10-FF-000727', NULL, 'Uncharacterized protein', 134, NULL, NULL, 34874),
(34875, '1.20.1070.10-FF-001123', NULL, 'Neuropeptide receptor 15', 353, NULL, NULL, 34875),
(34876, '1.20.5.110-FF-000147', NULL, 'EhSyntaxin H, putative', 75, NULL, NULL, 34876),
(34877, '1.10.1510.30-FF-000013', NULL, 'Probable tRNA pseudouridine synthase D 1', 87, NULL, NULL, 34877),
(34878, '3.40.50.150-FF-001827', NULL, NULL, 73, NULL, NULL, 34878),
(34879, '1.20.1250.20-FF-000931', NULL, 'Sugar transport protein 3', 480, NULL, NULL, 34879),
(34880, '1.20.5.190-FF-000114', NULL, NULL, 52, NULL, NULL, 34880),
(34881, '2.40.10.10-FF-000213', NULL, 'Si:dkey-33m11.7', 64, NULL, NULL, 34881),
(34882, '3.40.630.10-FF-000126', NULL, 'Succinyl-diaminopimelate desuccinylase', 189, NULL, NULL, 34882),
(34883, '1.10.1200.10-FF-000147', NULL, 'Polyketide synthase RzxF', 82, NULL, NULL, 34883),
(34884, '2.60.40.10-FF-004137', NULL, NULL, 115, NULL, NULL, 34884),
(34885, '3.40.50.1820-FF-000652', NULL, 'CocE/NonD family hydrolase', 136, NULL, NULL, 34885),
(34886, '3.40.50.300-FF-003339', NULL, 'Shikimate kinase', 168, NULL, NULL, 34886),
(34887, '3.30.70.330-FF-001247', NULL, 'Cleavage stimulation factor subunit 2 tau variant', 72, NULL, NULL, 34887),
(34888, '2.60.120.330-FF-000174', NULL, 'Uncharacterized protein', 247, NULL, NULL, 34888),
(34889, '2.40.10.10-FF-000325', NULL, NULL, 84, NULL, NULL, 34889),
(34890, '1.25.40.10-FF-002782', NULL, 'Uncharacterized protein', 160, NULL, NULL, 34890),
(34891, '3.20.20.80-FF-000694', NULL, 'Sucrose isomerase', 307, NULL, NULL, 34891),
(34892, '1.10.287.70-FF-000017', NULL, 'ryanodine receptor isoform X2', 134, NULL, NULL, 34892),
(34893, '1.20.58.530-FF-000036', NULL, NULL, 186, NULL, NULL, 34893),
(34894, '3.40.1110.10-FF-000322', NULL, NULL, 205, NULL, NULL, 34894),
(34895, '2.60.120.200-FF-000590', NULL, 'Uncharacterized protein', 161, NULL, NULL, 34895),
(34896, '2.40.30.10-FF-000208', NULL, 'Putative selenocysteine-specific elongation factor', 88, NULL, NULL, 34896),
(34897, '3.90.25.10-FF-000097', NULL, 'Uncharacterized protein', 107, NULL, NULL, 34897),
(34898, '3.40.50.2300-FF-000818', NULL, NULL, 147, NULL, NULL, 34898),
(34899, '1.25.10.10-FF-001094', NULL, 'RING-type E3 ubiquitin transferase', 310, NULL, NULL, 34899),
(34900, '3.40.140.100-FF-000017', NULL, 'Ubiquitin-like modifier-activating enzyme ATG7', 131, NULL, NULL, 34900),
(34901, '3.20.20.140-FF-000007', NULL, 'Imidazolonepropionase', 297, NULL, NULL, 34901),
(34902, '1.10.418.10-FF-000052', NULL, 'Growth arrest specific 2', 159, NULL, NULL, 34902),
(34903, '3.30.310.10-FF-000043', NULL, 'Uncharacterized protein', 112, NULL, NULL, 34903);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(34904, '1.20.5.110-FF-000017', NULL, 'BRICK1, SCAR/WAVE actin-nucleating complex subunit', 68, NULL, NULL, 34904),
(34905, '3.40.50.10810-FF-000072', NULL, 'Bifunctional helicase and thymine dioxygenase JBP2', 245, NULL, NULL, 34905),
(34906, '3.90.1720.10-FF-000037', NULL, 'Lecithin retinol acetyltransferase', 77, NULL, NULL, 34906),
(34907, '1.20.5.490-FF-000002', NULL, 'TSC22 domain family, member 1', 46, NULL, NULL, 34907),
(34908, '1.20.1110.10-FF-000222', NULL, NULL, 31, NULL, NULL, 34908),
(34909, '3.50.50.60-FF-000497', NULL, 'FAD dependent oxidoreductase superfamily', 169, NULL, NULL, 34909),
(34910, '1.10.510.10-FF-003408', NULL, NULL, 297, NULL, NULL, 34910),
(34911, '1.20.5.190-FF-000002', NULL, 'Major outer membrane lipoprotein', 56, NULL, NULL, 34911),
(34912, '2.130.10.10-FF-002333', NULL, 'THO complex 3 G protein beta subunit', 185, NULL, NULL, 34912),
(34913, '3.50.50.60-FF-000508', NULL, 'Rab proteins geranylgeranyltransferase component A', 125, NULL, NULL, 34913),
(34914, '1.25.40.20-FF-000643', NULL, 'Serine/threonine-protein kinase NEK', 92, NULL, NULL, 34914),
(34915, '1.20.1250.20-FF-001319', NULL, 'Monocarboxylate transporter, putative', 192, NULL, NULL, 34915),
(34916, '3.40.50.10190-FF-000285', NULL, 'DNA ligase 4', 110, NULL, NULL, 34916),
(34917, '2.60.120.10-FF-000615', NULL, 'Uncharacterized protein', 161, NULL, NULL, 34917),
(34918, '3.30.160.60-FF-005082', NULL, NULL, 81, NULL, NULL, 34918),
(34919, '3.40.50.720-FF-000812', NULL, '3-oxoacyl-[acyl-carrier-protein] reductase', 271, NULL, NULL, 34919),
(34920, '3.40.50.150-FF-001456', NULL, NULL, 139, NULL, NULL, 34920),
(34921, '1.10.10.60-FF-001024', NULL, NULL, 61, NULL, NULL, 34921),
(34922, '2.170.120.40-FF-000013', NULL, 'YbbR-like domain-containing protein', 81, NULL, NULL, 34922),
(34923, '3.90.190.10-FF-000547', NULL, 'Uncharacterized protein', 133, NULL, NULL, 34923),
(34924, '1.20.1300.10-FF-000034', NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', 114, NULL, NULL, 34924),
(34925, '1.10.287.1490-FF-000028', NULL, 'Dynamin associated protein 160, isoform A', 175, NULL, NULL, 34925),
(34926, '1.25.10.10-FF-002050', NULL, 'Uncharacterized protein', 288, NULL, NULL, 34926),
(34927, '3.40.50.300-FF-005705', NULL, 'Uncharacterized protein', 174, NULL, NULL, 34927),
(34928, '3.30.200.20-FF-001903', NULL, 'Serine/threonine protein kinase, putative', 50, NULL, NULL, 34928),
(34929, '1.10.287.10-FF-000027', NULL, 'SSU ribosomal protein, mitochondrial, putative', 85, NULL, NULL, 34929),
(34930, '4.10.240.10-FF-000026', NULL, 'C6 transcription factor (AmyR)', 54, NULL, NULL, 34930),
(34931, '3.80.10.10-FF-003935', NULL, 'Uncharacterized protein', 91, NULL, NULL, 34931),
(34932, '3.10.50.10-FF-000063', NULL, 'Uncharacterized protein', 56, NULL, NULL, 34932),
(34933, '3.30.710.10-FF-000135', NULL, 'Kelch-like family member 34', 152, NULL, NULL, 34933),
(34934, '1.10.287.3510-FF-000005', NULL, 'Hydrogenase 4, membrane subunit', 90, NULL, NULL, 34934),
(34935, '3.50.50.100-FF-000017', NULL, 'Sulfide-quinone reductase', 411, NULL, NULL, 34935),
(34936, '3.30.70.330-FF-001814', NULL, NULL, 90, NULL, NULL, 34936),
(34937, '1.25.10.10-FF-003460', NULL, 'GCN (Yeast General Control Nondrepressible) homolog', 234, NULL, NULL, 34937),
(34938, '3.40.50.1820-FF-001849', NULL, 'Uncharacterized protein', 68, NULL, NULL, 34938),
(34939, '3.30.160.60-FF-003648', NULL, 'Zinc finger protein STAR3', 91, NULL, NULL, 34939),
(34940, '4.10.280.10-FF-000040', NULL, 'MAX gene-associated protein isoform X1', 88, NULL, NULL, 34940),
(34941, '3.30.1330.30-FF-000145', NULL, 'Uncharacterized protein', 53, NULL, NULL, 34941),
(34942, '3.80.10.10-FF-001114', NULL, 'Tollo', 72, NULL, NULL, 34942),
(34943, '2.60.40.1080-FF-000022', NULL, 'Surface layer protein', 95, NULL, NULL, 34943),
(34944, '3.40.50.300-FF-003795', NULL, 'ATP-dependent DNA helicase CHL1', 70, NULL, NULL, 34944),
(34945, '3.30.200.20-FF-000947', NULL, 'GNAT family N-acetyltransferase', 90, NULL, NULL, 34945),
(34946, '1.10.510.10-FF-004353', NULL, NULL, 119, NULL, NULL, 34946);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(34947, '1.10.510.10-FF-000879', NULL, 'TKL protein kinase', 187, NULL, NULL, 34947),
(34948, '1.10.10.790-FF-000042', NULL, NULL, 58, NULL, NULL, 34948),
(34949, '1.25.40.10-FF-002231', NULL, 'Separin, putative', 190, NULL, NULL, 34949),
(34950, '2.80.10.50-FF-000077', NULL, 'Alpha-galactosidase A', 109, NULL, NULL, 34950),
(34951, '3.20.20.70-FF-000477', NULL, 'Alpha-galactosidase', 289, NULL, NULL, 34951),
(34952, '2.60.40.10-FF-004497', NULL, NULL, 46, NULL, NULL, 34952),
(34953, '3.30.160.60-FF-004137', NULL, NULL, 18, NULL, NULL, 34953),
(34954, '1.10.533.10-FF-000123', NULL, 'Nerve growth factor receptor b', 101, NULL, NULL, 34954),
(34955, '3.30.40.10-FF-000729', NULL, 'Mitochondrial ubiquitin ligase activator of nfkb 1-A', 82, NULL, NULL, 34955),
(34956, '1.10.10.10-FF-001493', NULL, 'Probable HTH-type transcriptional regulator ArcR', 73, NULL, NULL, 34956),
(34957, '3.40.50.2300-FF-001084', NULL, 'Uncharacterized protein', 286, NULL, NULL, 34957),
(34958, '3.30.420.40-FF-000240', NULL, 'Phosphotransferase', 137, NULL, NULL, 34958),
(34959, '3.40.50.300-FF-004284', NULL, 'Uncharacterized protein', 166, NULL, NULL, 34959),
(34960, '3.40.630.30-FF-000604', NULL, 'Uncharacterized protein', 66, NULL, NULL, 34960),
(34961, '1.20.1560.10-FF-000463', NULL, 'ABC transporter ATP-binding protein', 330, NULL, NULL, 34961),
(34962, '1.10.490.10-FF-000045', NULL, 'Flavohemoprotein', 78, NULL, NULL, 34962),
(34963, '1.25.40.10-FF-003428', NULL, 'Predicted protein', 124, NULL, NULL, 34963),
(34964, '2.70.160.11-FF-000004', NULL, 'Protein arginine N-methyltransferase 7', 193, NULL, NULL, 34964),
(34965, '1.25.40.1010-FF-000022', NULL, 'Uncharacterized protein', 97, NULL, NULL, 34965),
(34966, '1.25.40.10-FF-004468', NULL, 'Uncharacterized protein', 107, NULL, NULL, 34966),
(34967, '3.30.160.60-FF-001720', NULL, 'Si:dkey-7i4.21', 27, NULL, NULL, 34967),
(34968, '1.10.510.10-FF-003313', NULL, NULL, 73, NULL, NULL, 34968),
(34969, '2.20.70.10-FF-000032', NULL, 'WW domain containing oxidoreductase', 44, NULL, NULL, 34969),
(34970, '4.10.400.10-FF-000028', NULL, 'prolow-density lipoprotein receptor-related protein 1', 35, NULL, NULL, 34970),
(34971, '3.50.50.60-FF-001453', NULL, 'Exocyst complex component EXO84B', 79, NULL, NULL, 34971),
(34972, '3.20.20.140-FF-000463', NULL, 'Urease', 177, NULL, NULL, 34972),
(34973, '3.40.50.150-FF-000630', NULL, 'RfbT protein', 195, NULL, NULL, 34973),
(34974, '1.20.140.50-FF-000006', NULL, 'Putative PalA, pH signal transduction protein', 184, NULL, NULL, 34974),
(34975, '2.130.10.10-FF-004020', NULL, 'Uncharacterized WD repeat-containing protein C12G12.01c', 222, NULL, NULL, 34975),
(34976, '3.40.50.720-FF-002392', NULL, 'Crystallin, zeta (quinone reductase)', 90, NULL, NULL, 34976),
(34977, '1.10.472.10-FF-000205', NULL, 'Cyclin-C', 140, NULL, NULL, 34977),
(34978, '3.30.565.10-FF-000403', NULL, 'Phosphate regulon sensor protein', 153, NULL, NULL, 34978),
(34979, '3.40.1380.20-FF-000013', NULL, 'Pyruvate kinase', 142, NULL, NULL, 34979),
(34980, '1.10.510.10-FF-000087', NULL, 'Mitogen-activated protein kinase kinase kinase 12', 214, NULL, NULL, 34980),
(34981, '2.70.130.10-FF-000164', NULL, NULL, 90, NULL, NULL, 34981),
(34982, '3.40.1160.10-FF-000033', NULL, 'Aspartate kinase domain protein', 188, NULL, NULL, 34982),
(34983, '1.10.730.10-FF-000070', NULL, 'Arginine-tRNA ligase, putative', 126, NULL, NULL, 34983),
(34984, '2.60.40.10-FF-003069', NULL, 'Protein sax-3', 112, NULL, NULL, 34984),
(34985, '2.170.270.10-FF-000133', NULL, 'Uncharacterized protein', 77, NULL, NULL, 34985),
(34986, '2.60.200.20-FF-000102', NULL, 'Meiosis-specific serine/threonine protein kinase MEK1, putative', 104, NULL, NULL, 34986),
(34987, '3.40.50.300-FF-006212', NULL, 'Uncharacterized protein', 195, NULL, NULL, 34987),
(34988, '1.25.10.10-FF-001543', NULL, 'Uncharacterized protein', 1166, NULL, NULL, 34988),
(34989, '3.40.1810.10-FF-000022', NULL, 'MIKC MADS-domain protein PpMADS3', 82, NULL, NULL, 34989),
(34990, '3.30.70.1730-FF-000010', NULL, '50S ribosomal protein L10', 133, NULL, NULL, 34990);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(34991, '1.25.40.180-FF-000309', NULL, NULL, 307, NULL, NULL, 34991),
(34992, '1.25.40.20-FF-001048', NULL, 'NePHronoPhthisis (Human kidney disease) homolog', 155, NULL, NULL, 34992),
(34993, '3.30.200.20-FF-000043', NULL, 'Wall-associated receptor kinase 2', 106, NULL, NULL, 34993),
(34994, '3.90.20.20-FF-000009', NULL, 'GrpE protein homolog', 110, NULL, NULL, 34994),
(34995, '3.90.70.10-FF-000302', NULL, 'Cysteine protease, putative', 305, NULL, NULL, 34995),
(34996, '3.90.550.10-FF-000631', NULL, 'Os02g0664200 protein', 188, NULL, NULL, 34996),
(34997, '3.30.40.10-FF-000308', NULL, 'E3 ubiquitin-protein ligase DZIP3 isoform X1', 64, NULL, NULL, 34997),
(34998, '3.30.800.10-FF-000013', NULL, 'AGAP005216-PA', 167, NULL, NULL, 34998),
(34999, '1.10.150.670-FF-000029', NULL, 'Crossover junction endonuclease eme1', 84, NULL, NULL, 34999),
(35000, '2.10.25.10-FF-000400', NULL, 'Crumbs cell polarity complex component 1', 39, NULL, NULL, 35000),
(35001, '1.10.1370.30-FF-000024', NULL, 'Angiotensin-converting enzyme', 133, NULL, NULL, 35001),
(35002, '2.30.29.30-FF-000762', NULL, 'Nuclear pore complex protein Nup50', 257, NULL, NULL, 35002),
(35003, '1.10.150.50-FF-000228', NULL, 'Uncharacterized protein', 49, NULL, NULL, 35003),
(35004, '2.60.40.10-FF-001720', NULL, 'Receptor protein-tyrosine kinase', 89, NULL, NULL, 35004),
(35005, '3.40.50.2000-FF-000818', NULL, 'Uncharacterized protein', 169, NULL, NULL, 35005),
(35006, '1.10.238.10-FF-000066', NULL, 'Troponin C, slow skeletal and cardiac muscles', 89, NULL, NULL, 35006),
(35007, '1.20.58.1120-FF-000043', NULL, NULL, 146, NULL, NULL, 35007),
(35008, '1.10.8.10-FF-000103', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 47, NULL, NULL, 35008),
(35009, '3.30.70.330-FF-000050', NULL, 'heterogeneous nuclear ribonucleoprotein M isoform X2', 78, NULL, NULL, 35009),
(35010, '1.20.1250.20-FF-000482', NULL, 'Thi73p', 203, NULL, NULL, 35010),
(35011, '3.40.50.2300-FF-001325', NULL, NULL, 92, NULL, NULL, 35011),
(35012, '3.90.640.10-FF-000172', NULL, 'Uncharacterized protein', 88, NULL, NULL, 35012),
(35013, '2.30.30.140-FF-000213', NULL, 'Uncharacterized protein', 94, NULL, NULL, 35013),
(35014, '1.20.5.170-FF-000007', NULL, 'hepatic leukemia factor isoform X2', 77, NULL, NULL, 35014),
(35015, '2.130.10.10-FF-005189', NULL, 'WD40 repeat-containing protein smu1', 116, NULL, NULL, 35015),
(35016, '3.40.50.300-FF-000029', NULL, 'Elongation factor G', 293, NULL, NULL, 35016),
(35017, '1.10.10.60-FF-000405', NULL, 'AraC family transcriptional regulator', 51, NULL, NULL, 35017),
(35018, '1.10.390.10-FF-000009', NULL, 'Leukotriene A(4) hydrolase', 158, NULL, NULL, 35018),
(35019, '1.10.287.70-FF-000591', NULL, 'Uncharacterized protein', 137, NULL, NULL, 35019),
(35020, '2.60.40.60-FF-000768', NULL, 'Uncharacterized protein', 116, NULL, NULL, 35020),
(35021, '1.20.1050.130-FF-000058', NULL, 'Uncharacterized protein', 63, NULL, NULL, 35021),
(35022, '1.25.10.10-FF-001886', NULL, 'Uncharacterized protein', 335, NULL, NULL, 35022),
(35023, '2.130.10.10-FF-005290', NULL, 'Uncharacterized protein', 223, NULL, NULL, 35023),
(35024, '2.10.25.10-FF-001569', NULL, 'Laminin, gamma 2', 52, NULL, NULL, 35024),
(35025, '3.40.50.1000-FF-000165', NULL, 'HAD superfamily phosphatase', 147, NULL, NULL, 35025),
(35026, '3.30.160.60-FF-002097', NULL, 'paternally-expressed gene 3 protein isoform X1', 32, NULL, NULL, 35026),
(35027, '1.10.12.10-FF-000013', NULL, 'Enoyl-CoA delta isomerase 2, mitochondrial', 52, NULL, NULL, 35027),
(35028, '4.10.10.10-FF-000002', NULL, 'Metallothionein', 40, NULL, NULL, 35028),
(35029, '2.60.40.1730-FF-000014', NULL, 'Aminopeptidase 2', 215, NULL, NULL, 35029),
(35030, '3.90.180.10-FF-000041', NULL, 'Uncharacterized protein, isoform B', 193, NULL, NULL, 35030),
(35031, '3.40.50.150-FF-000063', NULL, 'Ribosomal RNA small subunit methyltransferase C', 158, NULL, NULL, 35031),
(35032, '3.40.1500.10-FF-000021', NULL, 'Oxygen-dependent coproporphyrinogen-III oxidase', 310, NULL, NULL, 35032),
(35033, '3.40.30.10-FF-000712', NULL, 'Uncharacterized protein', 74, NULL, NULL, 35033); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(35034, '3.30.70.100-FF-000127', NULL, NULL, 78, NULL, NULL, 35034),
(35035, '1.25.40.10-FF-003849', NULL, 'Uncharacterized protein', 115, NULL, NULL, 35035),
(35036, '1.20.1070.10-FF-000616', NULL, 'Predicted protein', 283, NULL, NULL, 35036),
(35037, '3.40.50.300-FF-002030', NULL, 'ATP-binding cassette sub-family C member 11 isoform X2', 98, NULL, NULL, 35037),
(35038, '3.40.50.300-FF-008241', NULL, 'Uncharacterized protein', 269, NULL, NULL, 35038),
(35039, '4.10.400.10-FF-000258', NULL, 'LDL receptor-like repeat', 42, NULL, NULL, 35039),
(35040, '3.80.10.10-FF-001226', NULL, 'Protein Cep78 homolog', 123, NULL, NULL, 35040),
(35041, '3.30.1330.40-FF-000018', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 131, NULL, NULL, 35041),
(35042, '3.30.565.10-FF-000162', NULL, 'Histidine kinase sensor protein', 142, NULL, NULL, 35042),
(35043, '4.10.860.120-FF-000017', NULL, 'DNA-directed RNA polymerase subunit', 125, NULL, NULL, 35043),
(35044, '2.60.120.970-FF-000011', NULL, 'Growth/differentiation factor 5', 201, NULL, NULL, 35044),
(35045, '2.60.40.10-FF-000326', NULL, 'Myosin-binding protein C, cardiac-type', 99, NULL, NULL, 35045),
(35046, '1.20.58.1880-FF-000029', NULL, 'Uncharacterized protein', 130, NULL, NULL, 35046),
(35047, '3.80.10.10-FF-002171', NULL, 'U2 small nuclear ribonucleoprotein 40K', 192, NULL, NULL, 35047),
(35048, '3.30.420.40-FF-000352', NULL, 'Luminal-binding protein 2', 194, NULL, NULL, 35048),
(35049, '3.30.460.90-FF-000010', NULL, 'Cyclic GMP-AMP synthase', 127, NULL, NULL, 35049),
(35050, '3.60.10.10-FF-000339', NULL, 'Predicted protein', 213, NULL, NULL, 35050),
(35051, '3.10.170.20-FF-000022', NULL, NULL, 160, NULL, NULL, 35051),
(35052, '3.40.1110.10-FF-000081', NULL, 'Cation transporting P-ATPase', 235, NULL, NULL, 35052),
(35053, '1.10.760.10-FF-000021', NULL, 'Cytochrome c6, chloroplastic', 105, NULL, NULL, 35053),
(35054, '3.10.280.10-FF-000038', NULL, 'Predicted protein', 186, NULL, NULL, 35054),
(35055, '2.40.50.140-FF-000625', NULL, 'GM17599', 153, NULL, NULL, 35055),
(35056, '2.40.50.700-FF-000012', NULL, NULL, 86, NULL, NULL, 35056),
(35057, '1.10.10.350-FF-000045', NULL, NULL, 97, NULL, NULL, 35057),
(35058, '2.40.240.100-FF-000001', NULL, 'Glutamate--tRNA ligase', 62, NULL, NULL, 35058),
(35059, '3.90.1150.10-FF-000471', NULL, 'Transcriptional regulator (DegT/DnrJ/Eryc1 family)', 113, NULL, NULL, 35059),
(35060, '3.30.9.10-FF-000112', NULL, 'NAD dehydrogenase, putative', 166, NULL, NULL, 35060),
(35061, '3.30.160.60-FF-001832', NULL, 'basic leucine zipper 61-like', 58, NULL, NULL, 35061),
(35062, '1.10.472.10-FF-000548', NULL, 'Uncharacterized protein', 76, NULL, NULL, 35062),
(35063, '3.80.10.10-FF-001895', NULL, 'Ubiquitin-like_domain_containing_protein_-_putative', 157, NULL, NULL, 35063),
(35064, '3.40.50.300-FF-008578', NULL, 'Thymidine kinase', 90, NULL, NULL, 35064),
(35065, '3.40.50.1820-FF-000309', NULL, 'Alpha/beta hydrolase, putative', 262, NULL, NULL, 35065),
(35066, '3.40.50.620-FF-000350', NULL, 'NH(3)-dependent NAD(+) synthetase', 265, NULL, NULL, 35066),
(35067, '1.20.1560.10-FF-000351', NULL, 'Os03g0181675 protein', 276, NULL, NULL, 35067),
(35068, '1.20.5.1160-FF-000038', NULL, 'Non-neuronal cytoplasmic intermediate filament protein B', 75, NULL, NULL, 35068),
(35069, '2.10.70.10-FF-000252', NULL, 'Extracellular matrix protein FRAS1', 36, NULL, NULL, 35069),
(35070, '2.60.120.260-FF-000580', NULL, 'Netrin g1a', 170, NULL, NULL, 35070),
(35071, '1.25.40.10-FF-000202', NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', 204, NULL, NULL, 35071),
(35072, '2.60.40.10-FF-001271', NULL, 'MPL proto-oncogene, thrombopoietin receptor', 101, NULL, NULL, 35072),
(35073, '3.90.79.10-FF-000030', NULL, 'Nudix hydrolase 13 mitochondrial', 160, NULL, NULL, 35073),
(35074, '3.90.550.10-FF-000401', NULL, '3-deoxy-manno-octulosonate cytidylyltransferase', 243, NULL, NULL, 35074),
(35075, '3.30.710.10-FF-000247', NULL, 'Maternal gene required for meiosis, isoform F', 129, NULL, NULL, 35075),
(35076, '1.25.10.10-FF-002162', NULL, 'Uncharacterized protein', 509, NULL, NULL, 35076);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(35077, '3.40.50.2000-FF-000156', NULL, 'GDP-Man:Man(3)GlcNAc(2)-PP-Dol alpha-1,2-mannosyltransferase', 182, NULL, NULL, 35077),
(35078, '2.40.50.730-FF-000010', NULL, 'DNA polymerase', 72, NULL, NULL, 35078),
(35079, '3.20.80.10-FF-000042', NULL, 'Uncharacterized protein', 62, NULL, NULL, 35079),
(35080, '1.20.58.390-FF-000073', NULL, 'Neuronal acetylcholine receptor subunit alpha-9-II', 122, NULL, NULL, 35080),
(35081, '1.25.40.10-FF-004125', NULL, 'Uncharacterized protein', 125, NULL, NULL, 35081),
(35082, '3.40.50.2020-FF-000151', NULL, 'Upp protein', 148, NULL, NULL, 35082),
(35083, '1.20.1250.20-FF-000038', NULL, 'Sialic acid transporter NanT', 208, NULL, NULL, 35083),
(35084, '1.20.1560.10-FF-000912', NULL, 'Uncharacterized protein', 142, NULL, NULL, 35084),
(35085, '3.40.50.1220-FF-000017', NULL, 'NAD-dependent histone deacetylase SIR2', 137, NULL, NULL, 35085),
(35086, '4.10.240.10-FF-000043', NULL, 'Regulatory protein CAT8', 63, NULL, NULL, 35086),
(35087, '3.40.850.10-FF-000351', NULL, 'Uncharacterized protein', 114, NULL, NULL, 35087),
(35088, '2.130.10.10-FF-000416', NULL, 'WD repeat-containing protein 13 isoform X1', 101, NULL, NULL, 35088),
(35089, '1.25.40.10-FF-004608', NULL, 'Putative pentatricopeptide repeat-containing protein At1g28020', 164, NULL, NULL, 35089),
(35090, '3.40.980.10-FF-000012', NULL, 'Molybdopterin molybdenumtransferase', 144, NULL, NULL, 35090),
(35091, '1.25.40.550-FF-000005', NULL, 'Protein AAR2 homolog', 165, NULL, NULL, 35091),
(35092, '3.90.1290.10-FF-000060', NULL, 'Uncharacterized protein', 158, NULL, NULL, 35092),
(35093, '3.80.10.10-FF-000607', NULL, 'F-box/LRR-repeat protein 17 isoform X3', 96, NULL, NULL, 35093),
(35094, '3.60.130.10-FF-000005', NULL, 'TfdA family taurine dioxygenase', 313, NULL, NULL, 35094),
(35095, '3.40.50.300-FF-000473', NULL, 'Vacuolar sorting-associated 1 protein', 317, NULL, NULL, 35095),
(35096, '1.25.70.10-FF-000030', NULL, 'Transcription termination factor MTERF15 mitochondrial', 219, NULL, NULL, 35096),
(35097, '2.60.40.10-FF-002243', NULL, 'High Incidence of Males (Increased X chromosome loss)', 86, NULL, NULL, 35097),
(35098, '1.20.58.60-FF-000678', NULL, 'Alpha-actinin-like protein 1', 125, NULL, NULL, 35098),
(35099, '2.10.90.10-FF-000135', NULL, 'MUC5B', 103, NULL, NULL, 35099),
(35100, '3.40.190.10-FF-000221', NULL, 'Amino acid ABC transporter periplasmic protein', 96, NULL, NULL, 35100),
(35101, '3.10.580.10-FF-000067', NULL, 'Chloride channel protein', 73, NULL, NULL, 35101),
(35102, '3.30.1330.40-FF-000035', NULL, 'Chorismate mutase AroH', 127, NULL, NULL, 35102),
(35103, '2.10.25.10-FF-001226', NULL, 'Uncharacterized protein', 35, NULL, NULL, 35103),
(35104, '4.10.60.10-FF-000185', NULL, 'Glycine-rich RNA-binding protein RZ1A', 43, NULL, NULL, 35104),
(35105, '3.40.50.300-FF-007622', NULL, 'Uncharacterized protein', 148, NULL, NULL, 35105),
(35106, '1.10.1670.10-FF-000081', NULL, NULL, 44, NULL, NULL, 35106),
(35107, '1.10.287.110-FF-000013', NULL, 'Curved DNA-binding protein', 112, NULL, NULL, 35107),
(35108, '1.10.287.70-FF-000129', NULL, 'Two pore calcium channel protein 1', 157, NULL, NULL, 35108),
(35109, '2.60.120.170-FF-000002', NULL, 'Outer capsid protein P8', 157, NULL, NULL, 35109),
(35110, '3.90.320.10-FF-000013', NULL, 'Exonuclease V chloroplastic', 238, NULL, NULL, 35110),
(35111, '3.40.50.300-FF-001878', NULL, 'Pantothenate kinase', 306, NULL, NULL, 35111),
(35112, '1.20.1070.10-FF-000959', NULL, 'Uncharacterized protein', 166, NULL, NULL, 35112),
(35113, '3.50.50.60-FF-000385', NULL, 'FMO1p Flavin-containing monooxygenase', 110, NULL, NULL, 35113),
(35114, '3.30.160.60-FF-000652', NULL, 'Zinc finger protein 516', 29, NULL, NULL, 35114),
(35115, '2.60.120.920-FF-000137', NULL, 'Uncharacterized protein', 179, NULL, NULL, 35115),
(35116, '3.40.30.10-FF-000133', NULL, 'Endoplasmic reticulum resident protein 29', 127, NULL, NULL, 35116),
(35117, '3.40.50.2300-FF-000706', NULL, 'Glutamate receptor', 126, NULL, NULL, 35117),
(35118, '3.90.1150.210-FF-000007', NULL, 'F-actin-capping protein subunit beta', 182, NULL, NULL, 35118);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(35119, '3.10.100.10-FF-000099', NULL, 'Putative adhesin', 103, NULL, NULL, 35119),
(35120, '3.30.2140.10-FF-000001', NULL, 'Arylamine N-acetyltransferase', 150, NULL, NULL, 35120),
(35121, '1.25.40.20-FF-000531', NULL, 'ATP-dependent RNA helicase YTHDC2', 106, NULL, NULL, 35121),
(35122, '3.80.10.10-FF-004071', NULL, 'Leucine-rich transmembrane protein, putative', 130, NULL, NULL, 35122),
(35123, '3.80.10.10-FF-003452', NULL, 'Uncharacterized protein', 246, NULL, NULL, 35123),
(35124, '2.30.36.70-FF-000015', NULL, 'Actin-like ATPase domain-containing protein', 35, NULL, NULL, 35124),
(35125, '3.30.420.60-FF-000021', NULL, 'Os04g0659900 protein', 49, NULL, NULL, 35125),
(35126, '2.60.40.60-FF-000425', NULL, 'Protocadherin-15', 119, NULL, NULL, 35126),
(35127, '1.25.40.10-FF-004485', NULL, 'Pentatricopeptide repeat-containing protein At1g07590, mitochondrial', 101, NULL, NULL, 35127),
(35128, '3.30.160.60-FF-005194', NULL, NULL, 47, NULL, NULL, 35128),
(35129, '1.20.58.870-FF-000003', NULL, 'DNA helicase', 122, NULL, NULL, 35129),
(35130, '3.20.20.80-FF-000817', NULL, 'Alpha-amylase SusG', 92, NULL, NULL, 35130),
(35131, '3.30.1640.30-FF-000016', NULL, NULL, 65, NULL, NULL, 35131),
(35132, '3.40.50.1370-FF-000034', NULL, 'Ornithine carbamoyltransferase', 129, NULL, NULL, 35132),
(35133, '3.10.600.10-FF-000013', NULL, 'Pyruvate carboxylase', 62, NULL, NULL, 35133),
(35134, '1.20.1530.20-FF-000060', NULL, 'sodium/bile acid cotransporter 7', 324, NULL, NULL, 35134),
(35135, '2.60.40.60-FF-001044', NULL, 'Uncharacterized protein', 96, NULL, NULL, 35135),
(35136, '2.30.42.10-FF-000517', NULL, NULL, 77, NULL, NULL, 35136),
(35137, '3.60.15.10-FF-000283', NULL, 'Uncharacterized protein', 71, NULL, NULL, 35137),
(35138, '3.40.50.150-FF-001344', NULL, NULL, 193, NULL, NULL, 35138),
(35139, '2.170.300.10-FF-000018', NULL, 'angiopoietin-1 receptor isoform X2', 95, NULL, NULL, 35139),
(35140, '3.40.50.300-FF-000130', NULL, 'Chromodomain-helicase-DNA-binding protein 2 isoform 1', 228, NULL, NULL, 35140),
(35141, '3.30.300.30-FF-000076', NULL, 'ATP-dependent serine activating enzyme', 118, NULL, NULL, 35141),
(35142, '3.80.10.10-FF-002963', NULL, 'Uncharacterized protein', 65, NULL, NULL, 35142),
(35143, '1.20.1250.20-FF-001550', NULL, 'Uncharacterized protein', 416, NULL, NULL, 35143),
(35144, '3.40.50.300-FF-002058', NULL, 'Sulfate adenylyltransferase', 206, NULL, NULL, 35144),
(35145, '2.30.29.30-FF-001381', NULL, 'Uncharacterized protein R02F2.2-like Protein', 194, NULL, NULL, 35145),
(35146, '3.20.20.60-FF-000148', NULL, 'Uncharacterized protein', 119, NULL, NULL, 35146),
(35147, '3.30.450.40-FF-000180', NULL, 'IclR family transcriptional regulator', 175, NULL, NULL, 35147),
(35148, '3.30.70.330-FF-000842', NULL, 'Pumilio domain-containing protein c', 89, NULL, NULL, 35148),
(35149, '1.10.238.10-FF-000521', NULL, 'Calexcitin-2', 182, NULL, NULL, 35149),
(35150, '2.60.120.230-FF-000014', NULL, NULL, 118, NULL, NULL, 35150),
(35151, '1.10.1200.10-FF-000164', NULL, 'Uncharacterized protein', 65, NULL, NULL, 35151),
(35152, '1.10.1060.10-FF-000045', NULL, NULL, 81, NULL, NULL, 35152),
(35153, '3.80.10.10-FF-000046', NULL, 'Toll-like receptor 2', 565, NULL, NULL, 35153),
(35154, '3.40.190.10-FF-000564', NULL, 'LysR family transcriptional regulator', 97, NULL, NULL, 35154),
(35155, '3.30.870.10-FF-000079', NULL, 'Phospholipase D family protein', 148, NULL, NULL, 35155),
(35156, '1.20.1250.20-FF-002376', NULL, 'Uncharacterized protein', 216, NULL, NULL, 35156),
(35157, '3.30.559.10-FF-000018', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 224, NULL, NULL, 35157),
(35158, '3.50.30.30-FF-000066', NULL, 'Signal peptide peptidase-like protein', 137, NULL, NULL, 35158),
(35159, '1.10.10.10-FF-000065', NULL, 'Interferon regulatory factor', 113, NULL, NULL, 35159),
(35160, '3.30.390.60-FF-000017', NULL, 'Heat-inducible transcription repressor HrcA', 101, NULL, NULL, 35160),
(35161, '2.60.40.790-FF-000072', NULL, 'Small heat shock protein HSP16.5', 144, NULL, NULL, 35161);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(35162, '1.20.1070.10-FF-002180', NULL, 'Uncharacterized protein', 101, NULL, NULL, 35162),
(35163, '2.130.10.10-FF-002103', NULL, 'CPSF A subunit region protein, putative', 335, NULL, NULL, 35163),
(35164, '1.20.140.150-FF-000100', NULL, 'Uncharacterized protein', 203, NULL, NULL, 35164),
(35165, '2.40.270.10-FF-000029', NULL, NULL, 57, NULL, NULL, 35165),
(35166, '1.25.40.950-FF-000001', NULL, 'Arf-GAP with SH3 domain, ANK repeat and PH domain-containing protein 1', 71, NULL, NULL, 35166),
(35167, '3.80.10.10-FF-002507', NULL, 'Uncharacterized protein', 206, NULL, NULL, 35167),
(35168, '2.60.120.380-FF-000031', NULL, 'Protein kinase, putative', 143, NULL, NULL, 35168),
(35169, '3.30.70.330-FF-001359', NULL, 'Uncharacterized protein B13D15.200', 131, NULL, NULL, 35169),
(35170, '2.40.50.140-FF-001244', NULL, NULL, 123, NULL, NULL, 35170),
(35171, '2.130.10.10-FF-002316', NULL, 'Serine/threonine-protein kinase PRP4', 216, NULL, NULL, 35171),
(35172, '2.30.29.30-FF-000892', NULL, 'Uncharacterized protein', 91, NULL, NULL, 35172),
(35173, '3.30.60.90-FF-000047', NULL, 'ZZ-type zinc finger-containing protein P35G2.11c', 61, NULL, NULL, 35173),
(35174, '3.30.200.20-FF-001454', NULL, 'Uncharacterized protein', 121, NULL, NULL, 35174),
(35175, '3.10.20.90-FF-000787', NULL, 'Inhibitor of nuclear factor kappa-B kinase subunit beta-like Protein', 78, NULL, NULL, 35175),
(35176, '2.130.10.10-FF-001827', NULL, 'UTP4, small subunit processome component', 182, NULL, NULL, 35176),
(35177, '2.60.470.10-FF-000028', NULL, 'Amiloride-sensitive sodium channel subunit beta', 136, NULL, NULL, 35177),
(35178, '1.20.1050.10-FF-000149', NULL, 'Glutathione S-transferase, putative', 80, NULL, NULL, 35178),
(35179, '1.10.10.10-FF-000986', NULL, 'NBS-LRR class disease resistance protein', 90, NULL, NULL, 35179),
(35180, '2.60.15.10-FF-000021', NULL, 'ATP synthase epsilon chain', 129, NULL, NULL, 35180),
(35181, '2.60.40.2310-FF-000003', NULL, 'Subtilisin-like protease SBT4.1', 135, NULL, NULL, 35181),
(35182, '3.10.100.10-FF-000071', NULL, 'NKG2-A/NKG2-B type II integral membrane protein', 120, NULL, NULL, 35182),
(35183, '1.10.8.60-FF-000219', NULL, 'Cell division control protein', 86, NULL, NULL, 35183),
(35184, '3.50.50.60-FF-000946', NULL, 'Uncharacterized protein', 218, NULL, NULL, 35184),
(35185, '1.20.1070.10-FF-001235', NULL, 'Frizzled class receptor 8', 225, NULL, NULL, 35185),
(35186, '3.30.420.10-FF-000708', NULL, NULL, 265, NULL, NULL, 35186),
(35187, '3.30.10.20-FF-000017', NULL, 'Serine/threonine-protein kinase PrkC', 69, NULL, NULL, 35187),
(35188, '3.40.50.300-FF-004312', NULL, 'Elongator complex protein 4', 136, NULL, NULL, 35188),
(35189, '1.25.10.10-FF-000037', NULL, 'CCR4-NOT transcription complex subunit 9', 272, NULL, NULL, 35189),
(35190, '3.40.50.720-FF-000475', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 272, NULL, NULL, 35190),
(35191, '1.10.238.10-FF-000858', NULL, 'Uncharacterized protein', 132, NULL, NULL, 35191),
(35192, '2.10.110.30-FF-000002', NULL, 'Putative e3 ubiquitin-protein ligase ubr3', 70, NULL, NULL, 35192),
(35193, '1.10.630.10-FF-000826', NULL, 'Uncharacterized protein', 221, NULL, NULL, 35193),
(35194, '2.102.10.10-FF-000025', NULL, 'Vanillate O-demethylase, oxygenase subunit', 126, NULL, NULL, 35194),
(35195, '3.30.70.330-FF-001331', NULL, 'RNA-binding protein fox-1 homolog 2', 123, NULL, NULL, 35195),
(35196, '3.30.2010.30-FF-000003', NULL, 'aminopeptidase O isoform X1', 93, NULL, NULL, 35196),
(35197, '1.20.58.60-FF-000650', NULL, 'Uncharacterized protein', 179, NULL, NULL, 35197),
(35198, '2.130.10.10-FF-003289', NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', 313, NULL, NULL, 35198),
(35199, '3.30.70.20-FF-000122', NULL, NULL, 73, NULL, NULL, 35199),
(35200, '3.40.50.720-FF-001335', NULL, 'NAD(P)-dependent oxidoreductase', 253, NULL, NULL, 35200),
(35201, '1.20.120.1750-FF-000032', NULL, 'RBR-type E3 ubiquitin transferase', 76, NULL, NULL, 35201),
(35202, '2.20.70.10-FF-000274', NULL, 'RNA binding protein', 31, NULL, NULL, 35202),
(35203, '3.30.160.60-FF-005643', NULL, NULL, 35, NULL, NULL, 35203);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(35204, '1.10.510.10-FF-001840', NULL, 'Cdc2-related protein kinase 5', 135, NULL, NULL, 35204),
(35205, '2.30.30.140-FF-000101', NULL, 'DNA/RNA-binding protein KIN17', 53, NULL, NULL, 35205),
(35206, '3.30.465.10-FF-000126', NULL, 'Uncharacterized protein', 32, NULL, NULL, 35206),
(35207, '3.30.710.10-FF-000478', NULL, 'Uncharacterized protein', 97, NULL, NULL, 35207),
(35208, '1.10.287.130-FF-000209', NULL, 'Integral membrane sensor signal transduction histidine kinase', 62, NULL, NULL, 35208),
(35209, '3.40.33.10-FF-000174', NULL, 'Uncharacterized protein', 90, NULL, NULL, 35209),
(35210, '1.20.5.470-FF-000007', NULL, 'Argininosuccinate synthase', 37, NULL, NULL, 35210),
(35211, '1.20.5.3960-FF-000001', NULL, 'Anti-sigma-E factor RseA', 22, NULL, NULL, 35211),
(35212, '3.30.460.10-FF-000143', NULL, 'Ribosomal silencing factor RsfS', 110, NULL, NULL, 35212),
(35213, '2.120.10.30-FF-000485', NULL, 'Uncharacterized protein', 289, NULL, NULL, 35213),
(35214, '1.10.472.80-FF-000092', NULL, 'TBC1 domain family member 15 isoform B', 85, NULL, NULL, 35214),
(35215, '1.10.287.110-FF-000221', NULL, 'Protein CBR-DNJ-18', 80, NULL, NULL, 35215),
(35216, '1.20.58.2130-FF-000003', NULL, 'DNA replication regulator SLD3', 86, NULL, NULL, 35216),
(35217, '1.10.10.440-FF-000072', NULL, 'Uncharacterized protein', 60, NULL, NULL, 35217),
(35218, '2.40.50.140-FF-001114', NULL, NULL, 74, NULL, NULL, 35218),
(35219, '3.40.50.10810-FF-000100', NULL, 'SNF2 family protein', 245, NULL, NULL, 35219),
(35220, '3.40.640.10-FF-000071', NULL, 'Kynurenine/alpha-aminoadipate aminotransferase, mitochondrial', 426, NULL, NULL, 35220),
(35221, '3.40.50.300-FF-005464', NULL, 'DNA replication and repair protein RecF', 226, NULL, NULL, 35221),
(35222, '2.40.50.140-FF-000496', NULL, 'Conserved hypothetical alanine,valine and glycine rich protein', 77, NULL, NULL, 35222),
(35223, '3.30.1330.60-FF-000013', NULL, 'Flagellar motor protein MotD', 179, NULL, NULL, 35223),
(35224, '3.40.50.620-FF-000563', NULL, 'Predicted protein', 205, NULL, NULL, 35224),
(35225, '1.10.3260.10-FF-000044', NULL, 'Uncharacterized protein', 193, NULL, NULL, 35225),
(35226, '1.20.1250.20-FF-001887', NULL, 'Uncharacterized protein', 88, NULL, NULL, 35226),
(35227, '3.30.70.980-FF-000003', NULL, 'Probable transcriptional regulatory protein YeeN', 82, NULL, NULL, 35227),
(35228, '1.20.58.340-FF-000069', NULL, 'Magnesium transport protein CorA', 58, NULL, NULL, 35228),
(35229, '3.40.50.300-FF-006993', NULL, 'Uncharacterized protein', 212, NULL, NULL, 35229),
(35230, '2.10.60.10-FF-000066', NULL, 'Receptor protein serine/threonine kinase', 98, NULL, NULL, 35230),
(35231, '3.80.10.10-FF-000838', NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g53440', 165, NULL, NULL, 35231),
(35232, '3.30.40.10-FF-001135', NULL, 'SNF2 domain-containing protein / helicase domain-containing protein / zinc finger protein-like protein', 60, NULL, NULL, 35232),
(35233, '3.80.10.10-FF-004099', NULL, 'Uncharacterized protein', 120, NULL, NULL, 35233),
(35234, '3.30.450.20-FF-000073', NULL, 'Putative Sensor histidine kinase', 131, NULL, NULL, 35234),
(35235, '1.10.287.70-FF-000461', NULL, 'Calcium-activated potassium channel subunit alpha-1', 116, NULL, NULL, 35235),
(35236, '2.60.120.590-FF-000004', NULL, 'DNA oxidative demethylase ALKBH2', 203, NULL, NULL, 35236),
(35237, '2.60.40.10-FF-002451', NULL, 'PLeXin', 97, NULL, NULL, 35237),
(35238, '2.60.40.10-FF-001832', NULL, 'Interleukin-12 subunit beta', 102, NULL, NULL, 35238),
(35239, '1.20.1110.10-FF-000194', NULL, NULL, 134, NULL, NULL, 35239),
(35240, '1.20.5.170-FF-000119', NULL, 'ATF (cAMP-dependent transcription factor) family', 65, NULL, NULL, 35240),
(35241, '1.20.5.450-FF-000001', NULL, 'radixin isoform X2', 50, NULL, NULL, 35241),
(35242, '3.40.50.150-FF-001799', NULL, NULL, 136, NULL, NULL, 35242),
(35243, '3.30.70.260-FF-000017', NULL, 'Aspartokinase', 75, NULL, NULL, 35243),
(35244, '3.40.1700.10-FF-000002', NULL, 'Diadenylate cyclase', 169, NULL, NULL, 35244),
(35245, '3.60.21.10-FF-000128', NULL, 'Purple acid phosphatase', 263, NULL, NULL, 35245);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(35246, '1.25.10.10-FF-000150', NULL, 'Nipped-B protein', 473, NULL, NULL, 35246),
(35247, '2.60.120.200-FF-000146', NULL, 'Axotactin, isoform B', 160, NULL, NULL, 35247),
(35248, '3.30.70.1070-FF-000008', NULL, 'Sporulation related domain protein', 78, NULL, NULL, 35248),
(35249, '3.10.250.10-FF-000087', NULL, NULL, 98, NULL, NULL, 35249),
(35250, '2.10.25.10-FF-000613', NULL, 'Delta-like protein', 36, NULL, NULL, 35250),
(35251, '1.20.1050.10-FF-000155', NULL, 'Putative glutathione S-transferase C460.02c', 130, NULL, NULL, 35251),
(35252, '1.25.40.10-FF-003299', NULL, 'Pentatricopeptide repeat-containing protein At1g18485', 131, NULL, NULL, 35252),
(35253, '4.10.400.10-FF-000045', NULL, 'Low-density lipoprotein receptor-related protein 2', 42, NULL, NULL, 35253),
(35254, '2.10.10.10-FF-000017', NULL, 'Predicted protein', 33, NULL, NULL, 35254),
(35255, '3.90.660.10-FF-000049', NULL, NULL, 19, NULL, NULL, 35255),
(35256, '1.20.120.1760-FF-000041', NULL, 'Aminoalcoholphosphotransferase, putative', 207, NULL, NULL, 35256),
(35257, '3.90.70.10-FF-000173', NULL, 'Aminopeptidase C', 391, NULL, NULL, 35257),
(35258, '3.40.50.300-FF-001086', NULL, 'GTP-binding protein GTR2', 180, NULL, NULL, 35258),
(35259, '3.40.350.10-FF-000099', NULL, 'Uncharacterized protein', 171, NULL, NULL, 35259),
(35260, '1.10.238.10-FF-001235', NULL, 'Uncharacterized protein', 103, NULL, NULL, 35260),
(35261, '3.40.109.10-FF-000033', NULL, 'NAD(P)H-flavin oxidoreductase', 183, NULL, NULL, 35261),
(35262, '3.40.50.1820-FF-000995', NULL, 'Uncharacterized protein', 238, NULL, NULL, 35262),
(35263, '1.10.287.1060-FF-000017', NULL, 'Alpha-(1,6)-fucosyltransferase', 69, NULL, NULL, 35263),
(35264, '1.10.1820.10-FF-000008', NULL, 'Casein kinase II subunit beta', 98, NULL, NULL, 35264),
(35265, '2.60.40.830-FF-000005', NULL, 'Uncharacterized protein', 32, NULL, NULL, 35265),
(35266, '1.20.1740.10-FF-000005', NULL, 'Solute carrier family 12 member 1', 454, NULL, NULL, 35266),
(35267, '3.60.20.10-FF-000250', NULL, NULL, 189, NULL, NULL, 35267),
(35268, '3.30.428.10-FF-000046', NULL, 'Uncharacterized protein, isoform A', 96, NULL, NULL, 35268),
(35269, '2.40.50.120-FF-000069', NULL, 'Uncharacterized protein', 67, NULL, NULL, 35269),
(35270, '3.30.300.290-FF-000001', NULL, 'Probable phosphatase', 93, NULL, NULL, 35270),
(35271, '3.30.70.330-FF-001702', NULL, NULL, 93, NULL, NULL, 35271),
(35272, '3.60.150.10-FF-000017', NULL, 'Chorismate synthase', 204, NULL, NULL, 35272),
(35273, '3.40.50.300-FF-000260', NULL, 'Cell division control 10', 294, NULL, NULL, 35273),
(35274, '3.40.50.300-FF-002401', NULL, 'ABC transporter ATP-binding protein', 232, NULL, NULL, 35274),
(35275, '2.10.110.20-FF-000011', NULL, NULL, 85, NULL, NULL, 35275),
(35276, '1.10.287.1490-FF-000130', NULL, 'Viral A-type inclusion protein, putative', 122, NULL, NULL, 35276),
(35277, '3.40.630.30-FF-000475', NULL, 'Uncharacterized protein', 158, NULL, NULL, 35277),
(35278, '1.10.8.60-FF-000320', NULL, 'ATP-dependent Clp protease subunit, heat shock protein 100 (HSP100), putative', 100, NULL, NULL, 35278),
(35279, '3.30.200.20-FF-000835', NULL, 'CMGC/CDK/CRK7 protein kinase', 66, NULL, NULL, 35279),
(35280, '3.40.1360.10-FF-000032', NULL, 'DNA primase', 125, NULL, NULL, 35280),
(35281, '3.30.40.10-FF-000179', NULL, 'TNF receptor-associated factor', 111, NULL, NULL, 35281),
(35282, '2.10.50.10-FF-000138', NULL, 'Tumor necrosis factor receptor superfamily, member 11b', 46, NULL, NULL, 35282),
(35283, '3.10.20.90-FF-000444', NULL, 'Protein CBG19533', 83, NULL, NULL, 35283),
(35284, '3.30.1330.80-FF-000019', NULL, 'Uncharacterized protein', 147, NULL, NULL, 35284),
(35285, '3.40.50.300-FF-003227', NULL, 'ATPase component BioM of energizing module of biotin ECF transporter', 246, NULL, NULL, 35285),
(35286, '1.10.1030.10-FF-000004', NULL, 'Carbamoyl-phosphate synthase (glutamine-hydrolyzing)', 151, NULL, NULL, 35286),
(35287, '2.170.140.10-FF-000028', NULL, 'mucin-2 isoform X2', 63, NULL, NULL, 35287),
(35288, '2.40.50.140-FF-000597', NULL, 'tRNA-binding domain protein', 111, NULL, NULL, 35288);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(35289, '3.80.10.10-FF-002384', NULL, 'Insulin like growth factor binding protein acid labile subunit', 114, NULL, NULL, 35289),
(35290, '2.40.70.10-FF-000205', NULL, 'Acid protease', 176, NULL, NULL, 35290),
(35291, '3.30.160.60-FF-004025', NULL, 'Hindsight transcription factor-like protein', 74, NULL, NULL, 35291),
(35292, '3.40.250.10-FF-000159', NULL, 'Lon-8', 142, NULL, NULL, 35292),
(35293, '2.40.50.100-FF-000063', NULL, 'Exosome complex component RRP4', 58, NULL, NULL, 35293),
(35294, '3.30.342.10-FF-000026', NULL, 'DNA polymerase catalytic subunit', 142, NULL, NULL, 35294),
(35295, '1.10.274.100-FF-000017', NULL, 'DNA-directed RNA polymerase subunit', 192, NULL, NULL, 35295),
(35296, '3.30.56.130-FF-000001', NULL, 'Transcriptional regulator CtsR', 71, NULL, NULL, 35296),
(35297, '3.80.10.10-FF-000254', NULL, 'nucleotide-binding oligomerization domain-containing protein 1', 185, NULL, NULL, 35297),
(35298, '3.50.50.60-FF-001110', NULL, 'Chromosome 19, whole genome shotgun sequence', 178, NULL, NULL, 35298),
(35299, '3.20.20.70-FF-000134', NULL, '7,8-didemethyl-8-hydroxy-5-deazariboflavin synthase', 355, NULL, NULL, 35299),
(35300, '1.20.930.10-FF-000026', NULL, 'Alginate regulatory protein AlgR3, putative', 67, NULL, NULL, 35300),
(35301, '2.60.120.10-FF-000166', NULL, 'blood vessel epicardial substance isoform X1', 135, NULL, NULL, 35301),
(35302, '3.60.21.10-FF-000241', NULL, 'Acid sphingomyelinase-like phosphodiesterase 3b', 300, NULL, NULL, 35302),
(35303, '1.10.510.10-FF-001508', NULL, 'STK24 isoform 7', 104, NULL, NULL, 35303),
(35304, '3.30.160.60-FF-006262', NULL, NULL, 61, NULL, NULL, 35304),
(35305, '3.90.190.10-FF-000098', NULL, 'Protein-tryrosine phosphatase', 288, NULL, NULL, 35305),
(35306, '3.30.160.60-FF-003294', NULL, 'Zinc finger protein 1001', 29, NULL, NULL, 35306),
(35307, '3.90.740.10-FF-000005', NULL, 'Valine--tRNA ligase, mitochondrial', 141, NULL, NULL, 35307),
(35308, '1.10.287.3810-FF-000005', NULL, 'Tryptophan 2,3-dioxygenase', 51, NULL, NULL, 35308),
(35309, '2.60.40.10-FF-002237', NULL, 'Protein tyrosine phosphatase 4E, isoform A', 76, NULL, NULL, 35309),
(35310, '3.40.50.2000-FF-000369', NULL, 'UDP-GlucuronosylTransferase', 172, NULL, NULL, 35310),
(35311, '3.10.129.10-FF-000182', NULL, '4-hydroxybenzoyl-CoA thioesterase', 130, NULL, NULL, 35311),
(35312, '3.60.10.10-FF-000209', NULL, 'YALI0A17578p', 348, NULL, NULL, 35312),
(35313, '1.10.287.110-FF-000007', NULL, 'DnaJ (Hsp40) homolog, subfamily C, member 13', 67, NULL, NULL, 35313),
(35314, '3.30.70.260-FF-000130', NULL, 'D-3-phosphoglycerate dehydrogenase', 86, NULL, NULL, 35314),
(35315, '1.20.1070.10-FF-000263', NULL, 'G-protein coupled receptor GRL101-like protein', 310, NULL, NULL, 35315),
(35316, '3.30.200.20-FF-001774', NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', 88, NULL, NULL, 35316),
(35317, '1.10.510.10-FF-000430', NULL, 'Protein kinase superfamily protein', 210, NULL, NULL, 35317),
(35318, '3.30.230.120-FF-000012', NULL, 'L-fucose kinase', 367, NULL, NULL, 35318),
(35319, '2.40.50.140-FF-000833', NULL, NULL, 163, NULL, NULL, 35319),
(35320, '3.30.70.1230-FF-000214', NULL, 'Uncharacterized protein', 107, NULL, NULL, 35320),
(35321, '3.30.70.100-FF-000110', NULL, NULL, 78, NULL, NULL, 35321),
(35322, '2.30.30.380-FF-000044', NULL, 'RanBP-type and C3HC4-type zinc finger containing 1', 64, NULL, NULL, 35322),
(35323, '1.10.287.810-FF-000009', NULL, 'Mitochondrial import inner membrane translocase subunit TIM10, putative', 68, NULL, NULL, 35323),
(35324, '3.10.440.10-FF-000012', NULL, '50S ribosomal protein L31e', 89, NULL, NULL, 35324),
(35325, '3.20.20.10-FF-000049', NULL, 'Ornithine decarboxylase, putative', 229, NULL, NULL, 35325),
(35326, '1.10.565.10-FF-000028', NULL, 'Nuclear receptor subfamily 0 group B member 2', 205, NULL, NULL, 35326),
(35327, '2.40.160.60-FF-000013', NULL, NULL, 308, NULL, NULL, 35327),
(35328, '4.10.1250.10-FF-000001', NULL, 'Aminomethyltransferase', 44, NULL, NULL, 35328),
(35329, '1.20.1070.10-FF-000847', NULL, 'Vomeronasal type-1 receptor', 289, NULL, NULL, 35329); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(35330, '3.40.50.300-FF-006892', NULL, 'MxD protein', 244, NULL, NULL, 35330),
(35331, '1.10.10.10-FF-001812', NULL, 'Nitrogen regulator, putative', 78, NULL, NULL, 35331),
(35332, '3.50.50.60-FF-000284', NULL, 'Chromosome 15, whole genome shotgun sequence', 216, NULL, NULL, 35332),
(35333, '3.30.40.10-FF-000516', NULL, 'ESTs AU075348(C11252)', 68, NULL, NULL, 35333),
(35334, '3.30.160.60-FF-001591', NULL, 'DAZ interacting zinc finger protein 1', 35, NULL, NULL, 35334),
(35335, '3.40.91.60-FF-000002', NULL, 'RNA-directed RNA polymerase L', 181, NULL, NULL, 35335),
(35336, '1.10.510.10-FF-001155', NULL, 'Protein kinase, putative', 222, NULL, NULL, 35336),
(35337, '1.25.40.10-FF-000882', NULL, 'Putative pentatricopeptide repeat-containing protein', 131, NULL, NULL, 35337),
(35338, '1.20.1260.10-FF-000075', NULL, 'Ferritin', 177, NULL, NULL, 35338),
(35339, '1.10.20.140-FF-000017', NULL, NULL, 72, NULL, NULL, 35339),
(35340, '3.60.20.10-FF-000137', NULL, 'Proteasome subunit alpha type', 130, NULL, NULL, 35340),
(35341, '3.30.70.330-FF-001910', NULL, NULL, 72, NULL, NULL, 35341),
(35342, '1.10.510.10-FF-003184', NULL, NULL, 153, NULL, NULL, 35342),
(35343, '3.40.50.720-FF-001543', NULL, 'Uncharacterized protein', 261, NULL, NULL, 35343),
(35344, '3.40.50.720-FF-000924', NULL, 'GDP-mannose 4,6 dehydratase', 243, NULL, NULL, 35344),
(35345, '1.25.10.10-FF-002611', NULL, 'Uncharacterized protein', 138, NULL, NULL, 35345),
(35346, '1.20.1310.10-FF-000203', NULL, NULL, 110, NULL, NULL, 35346),
(35347, '1.20.120.890-FF-000003', NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', 112, NULL, NULL, 35347),
(35348, '3.90.470.10-FF-000029', NULL, '60S ribosomal protein L17', 67, NULL, NULL, 35348),
(35349, '1.20.1270.10-FF-000036', NULL, 'Chaperone protein DnaK', 82, NULL, NULL, 35349),
(35350, '1.10.287.370-FF-000057', NULL, 'Uncharacterized protein', 124, NULL, NULL, 35350),
(35351, '2.30.30.1160-FF-000002', NULL, 'YALI0A11869p', 131, NULL, NULL, 35351),
(35352, '3.30.160.60-FF-002788', NULL, 'tRNA dimethylallyltransferase', 54, NULL, NULL, 35352),
(35353, '1.10.150.20-FF-000236', NULL, 'DNA transformation protein tfoX', 90, NULL, NULL, 35353),
(35354, '2.130.10.10-FF-000175', NULL, 'Phospholipase A-2-activating protein', 314, NULL, NULL, 35354),
(35355, '2.130.10.10-FF-003744', NULL, 'U3 snoRNP-associated protein, putative', 331, NULL, NULL, 35355),
(35356, '1.20.120.1910-FF-000007', NULL, 'Cysteine--tRNA ligase', 164, NULL, NULL, 35356),
(35357, '3.40.50.720-FF-000716', NULL, 'Probable short-chain type dehydrogenase/reductase', 247, NULL, NULL, 35357),
(35358, '3.30.70.100-FF-000099', NULL, 'Predicted protein', 67, NULL, NULL, 35358),
(35359, '3.30.10.30-FF-000003', NULL, 'Dual specificity tyrosine-phosphorylation-regulated kinase mbk-2', 66, NULL, NULL, 35359),
(35360, '3.30.54.20-FF-000006', NULL, 'Tryptophan-tRNA ligase', 45, NULL, NULL, 35360),
(35361, '1.10.238.150-FF-000010', NULL, 'Formin-E', 87, NULL, NULL, 35361),
(35362, '3.60.20.10-FF-000042', NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', 257, NULL, NULL, 35362),
(35363, '2.30.36.90-FF-000004', NULL, NULL, 13, NULL, NULL, 35363),
(35364, '3.90.230.10-FF-000034', NULL, 'Chromatin-specific transcription elongation factor, putative', 149, NULL, NULL, 35364),
(35365, '2.130.10.30-FF-000057', NULL, 'RCC1-like G exchanging factor-like protein', 181, NULL, NULL, 35365),
(35366, '3.30.30.10-FF-000010', NULL, 'AGAP004632-PA', 40, NULL, NULL, 35366),
(35367, '1.20.1250.20-FF-000370', NULL, 'Nicotinic acid permease', 200, NULL, NULL, 35367),
(35368, '3.30.30.30-FF-000016', NULL, 'Heat shock protein 110', 76, NULL, NULL, 35368),
(35369, '2.160.20.10-FF-000202', NULL, 'Pectin lyase-like superfamily protein', 285, NULL, NULL, 35369),
(35370, '1.10.10.60-FF-001237', NULL, NULL, 49, NULL, NULL, 35370),
(35371, '1.25.10.10-FF-001774', NULL, 'YALI0B18480p', 874, NULL, NULL, 35371),
(35372, '3.40.50.620-FF-000900', NULL, 'Uncharacterized protein', 69, NULL, NULL, 35372),
(35373, '3.90.550.10-FF-000182', NULL, 'dTDP-RHA:A-D-GlcNAc-diphosphoryl polyprenolA-3-L-rhamnosyl transferase', 245, NULL, NULL, 35373); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(35374, '1.10.3210.10-FF-000120', NULL, 'Uncharacterized protein', 64, NULL, NULL, 35374),
(35375, '1.25.40.20-FF-001492', NULL, 'S-acyltransferase', 77, NULL, NULL, 35375),
(35376, '1.25.40.10-FF-001955', NULL, 'GM14977', 127, NULL, NULL, 35376),
(35377, '3.90.70.10-FF-000510', NULL, 'Ubiquitin specific peptidase 40', 83, NULL, NULL, 35377),
(35378, '2.130.10.130-FF-000019', NULL, 'Integrin alpha pat-2', 451, NULL, NULL, 35378),
(35379, '3.40.50.1820-FF-000091', NULL, 'Gastric triacylglycerol lipase', 391, NULL, NULL, 35379),
(35380, '1.10.287.950-FF-000023', NULL, 'Methyl-accepting chemotaxis protein', 237, NULL, NULL, 35380),
(35381, '3.30.470.30-FF-000077', NULL, 'mRNA-capping enzyme', 122, NULL, NULL, 35381),
(35382, '1.25.40.20-FF-000082', NULL, 'Inversin', 148, NULL, NULL, 35382),
(35383, '1.20.120.140-FF-000003', NULL, 'Signal recognition particle 54 kDa protein', 107, NULL, NULL, 35383),
(35384, '3.20.20.80-FF-000238', NULL, 'Klotho beta', 130, NULL, NULL, 35384),
(35385, '3.40.50.2300-FF-000257', NULL, 'glutamate receptor 1', 21, NULL, NULL, 35385),
(35386, '1.25.40.20-FF-001503', NULL, 'Uncharacterized protein', 39, NULL, NULL, 35386),
(35387, '1.10.10.10-FF-001251', NULL, 'Transcriptional regulator', 77, NULL, NULL, 35387),
(35388, '3.10.129.10-FF-000294', NULL, 'Polyketide synthase', 157, NULL, NULL, 35388),
(35389, '1.10.10.60-FF-000164', NULL, 'Arabinose operon transcriptional regulator', 42, NULL, NULL, 35389),
(35390, '3.80.10.10-FF-004424', NULL, 'Uncharacterized protein', 125, NULL, NULL, 35390),
(35391, '3.30.830.10-FF-000054', NULL, 'Falcilysin', 244, NULL, NULL, 35391),
(35392, '1.20.120.1920-FF-000010', NULL, 'Uncharacterized protein', 100, NULL, NULL, 35392),
(35393, '3.30.200.20-FF-001223', NULL, 'Predicted protein', 128, NULL, NULL, 35393),
(35394, '2.60.120.290-FF-000021', NULL, 'Low-density lipoprotein receptor-related protein 12', 115, NULL, NULL, 35394),
(35395, '3.90.190.10-FF-000210', NULL, 'Receptor-type tyrosine-protein phosphatase delta isoform x2', 139, NULL, NULL, 35395),
(35396, '3.40.50.10950-FF-000001', NULL, 'Phosphate acetyltransferase', 156, NULL, NULL, 35396),
(35397, '3.30.160.60-FF-003406', NULL, NULL, 60, NULL, NULL, 35397),
(35398, '2.40.30.330-FF-000015', NULL, 'mRNA cleavage and polyadenylation factor CLP1', 130, NULL, NULL, 35398),
(35399, '2.40.33.10-FF-000024', NULL, 'Plastidial pyruvate kinase 4, chloroplastic', 74, NULL, NULL, 35399),
(35400, '3.40.50.300-FF-003126', NULL, 'ATP-dependent helicase', 243, NULL, NULL, 35400),
(35401, '3.30.1370.100-FF-000013', NULL, 'DNA mismatch repair protein mutL, putative', 97, NULL, NULL, 35401),
(35402, '2.150.10.10-FF-000005', NULL, 'Adhesin', 141, NULL, NULL, 35402),
(35403, '3.40.50.720-FF-000363', NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase', 192, NULL, NULL, 35403),
(35404, '2.130.10.10-FF-005531', NULL, 'WD-40 repeat-containing protein', 371, NULL, NULL, 35404),
(35405, '1.25.10.10-FF-002403', NULL, 'Importin beta-like SAD2-like protein', 256, NULL, NULL, 35405),
(35406, '1.10.510.10-FF-004140', NULL, NULL, 73, NULL, NULL, 35406),
(35407, '1.10.3720.10-FF-000203', NULL, 'Glutathione transport system permease protein GsiC', 242, NULL, NULL, 35407),
(35408, '2.30.30.100-FF-000016', NULL, 'Small nuclear ribonucleoprotein Sm D1', 83, NULL, NULL, 35408),
(35409, '2.40.128.130-FF-000005', NULL, 'Polymorphic outer membrane protein', 306, NULL, NULL, 35409),
(35410, '1.10.1450.10-FF-000070', NULL, 'Tetraspanin', 83, NULL, NULL, 35410),
(35411, '3.70.10.10-FF-000007', NULL, 'Gp45 sliding clamp DNA polymerase', 228, NULL, NULL, 35411),
(35412, '2.130.10.10-FF-005301', NULL, 'WD40-repeat protein', 216, NULL, NULL, 35412),
(35413, '3.40.250.10-FF-000035', NULL, 'Thiosulfate sulfurtransferase', 148, NULL, NULL, 35413),
(35414, '3.90.1200.10-FF-000014', NULL, 'Ethanolamine kinase', 265, NULL, NULL, 35414),
(35415, '1.10.510.10-FF-003864', NULL, NULL, 98, NULL, NULL, 35415),
(35416, '1.25.40.10-FF-002574', NULL, 'Pentatricopeptide repeat-containing protein', 131, NULL, NULL, 35416),
(35417, '3.30.420.40-FF-000695', NULL, 'Glycerol kinase', 245, NULL, NULL, 35417);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(35418, '1.25.40.10-FF-001820', NULL, 'Protein CBG09345', 314, NULL, NULL, 35418),
(35419, '2.60.40.60-FF-001145', NULL, 'Uncharacterized protein', 79, NULL, NULL, 35419),
(35420, '2.40.50.40-FF-000078', NULL, 'C-C motif chemokine 23-like isoform X1', 69, NULL, NULL, 35420),
(35421, '1.10.10.10-FF-001150', NULL, 'Cullin 4B', 61, NULL, NULL, 35421),
(35422, '2.10.25.10-FF-000288', NULL, 'Astrotactin 2', 58, NULL, NULL, 35422),
(35423, '1.20.1280.170-FF-000003', NULL, 'Exocyst subunit Exo70 family protein', 544, NULL, NULL, 35423),
(35424, '2.60.40.10-FF-004946', NULL, NULL, 108, NULL, NULL, 35424),
(35425, '3.40.50.200-FF-000117', NULL, 'Uncharacterized protein', 68, NULL, NULL, 35425),
(35426, '3.40.50.2060-FF-000016', NULL, 'Sec1/munc18-like (SM) proteins superfamily', 137, NULL, NULL, 35426),
(35427, '1.25.40.660-FF-000021', NULL, 'Vacuolar protein sorting-associated protein 35', 328, NULL, NULL, 35427),
(35428, '3.30.70.2190-FF-000018', NULL, 'Uncharacterized protein', 47, NULL, NULL, 35428),
(35429, '1.20.1640.10-FF-000060', NULL, 'Resistance-Nodulation-cell Division (RND) efflux transporter', 210, NULL, NULL, 35429),
(35430, '1.10.630.10-FF-000601', NULL, 'Uncharacterized protein', 273, NULL, NULL, 35430),
(35431, '1.10.287.3240-FF-000020', NULL, 'V-type H+-transporting ATPase subunit D', 215, NULL, NULL, 35431),
(35432, '2.130.10.10-FF-003160', NULL, 'Uncharacterized protein', 125, NULL, NULL, 35432),
(35433, '2.60.120.1440-FF-000012', NULL, 'Probable transmembrane sensor', 130, NULL, NULL, 35433),
(35434, '3.40.50.300-FF-005835', NULL, 'Uncharacterized protein', 255, NULL, NULL, 35434),
(35435, '3.30.1460.50-FF-000025', NULL, 'Autophagy related 10', 142, NULL, NULL, 35435),
(35436, '3.40.850.10-FF-000137', NULL, 'Kinesin-like protein', 360, NULL, NULL, 35436),
(35437, '3.40.50.300-FF-004407', NULL, 'Small guanosine triphosphatase, Ras-related family', 184, NULL, NULL, 35437),
(35438, '3.30.160.60-FF-001383', NULL, 'Zinc finger protein 212', 40, NULL, NULL, 35438),
(35439, '3.10.180.10-FF-000093', NULL, 'Uncharacterized protein', 43, NULL, NULL, 35439),
(35440, '1.10.630.10-FF-000489', NULL, 'Cytochrome P450, putative', 467, NULL, NULL, 35440),
(35441, '2.40.290.10-FF-000042', NULL, 'DNA binding protein', 86, NULL, NULL, 35441),
(35442, '3.30.420.10-FF-000259', NULL, 'Polymerase (DNA directed), theta', 256, NULL, NULL, 35442),
(35443, '3.60.40.10-FF-000037', NULL, 'Protein phosphatase, Mg2+/Mn2+-dependent, 1M', 338, NULL, NULL, 35443),
(35444, '3.40.50.10190-FF-000054', NULL, 'DNA ligase', 91, NULL, NULL, 35444),
(35445, '3.60.15.10-FF-000075', NULL, 'Ribonuclease Z', 288, NULL, NULL, 35445),
(35446, '1.10.10.1590-FF-000006', NULL, 'Formate dehydrogenase, beta subunit', 69, NULL, NULL, 35446),
(35447, '2.60.120.380-FF-000048', NULL, 'Calpain-9', 150, NULL, NULL, 35447),
(35448, '1.25.40.20-FF-000188', NULL, 'NF-kappa-B inhibitor zeta isoform X2', 56, NULL, NULL, 35448),
(35449, '1.25.40.1030-FF-000011', NULL, 'SEC31 homolog B, COPII coat complex component', 404, NULL, NULL, 35449),
(35450, '1.50.40.10-FF-000582', NULL, 'Uncharacterized protein', 61, NULL, NULL, 35450),
(35451, '3.40.50.10190-FF-000189', NULL, 'Cell cycle checkpoint protein, putative', 96, NULL, NULL, 35451),
(35452, '3.40.50.2300-FF-000920', NULL, NULL, 126, NULL, NULL, 35452),
(35453, '2.130.10.10-FF-001147', NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', 387, NULL, NULL, 35453),
(35454, '1.20.58.1070-FF-000005', NULL, 'Spliceosome protein-like protein', 197, NULL, NULL, 35454),
(35455, '1.10.287.470-FF-000070', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 74, NULL, NULL, 35455),
(35456, '2.60.40.1180-FF-000164', NULL, 'Alpha-L-arabinofuranosidase C', 118, NULL, NULL, 35456),
(35457, '1.10.443.20-FF-000006', NULL, 'AEL245Wp', 130, NULL, NULL, 35457),
(35458, '2.30.40.10-FF-000018', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 54, NULL, NULL, 35458),
(35459, '3.30.420.110-FF-000002', NULL, 'DNA mismatch repair protein', 169, NULL, NULL, 35459),
(35460, '1.25.40.10-FF-001146', NULL, 'Os03g0795200 protein', 88, NULL, NULL, 35460);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(35461, '1.20.5.1300-FF-000007', NULL, 'Histidinol dehydrogenase', 56, NULL, NULL, 35461),
(35462, '1.20.920.20-FF-000068', NULL, 'Uncharacterized protein', 207, NULL, NULL, 35462),
(35463, '3.30.70.270-FF-000234', NULL, NULL, 180, NULL, NULL, 35463),
(35464, '2.40.160.20-FF-000029', NULL, 'Uncharacterized protein', 172, NULL, NULL, 35464),
(35465, '3.40.50.10330-FF-000023', NULL, 'diacylglycerol kinase', 147, NULL, NULL, 35465),
(35466, '3.40.30.10-FF-000942', NULL, 'Uncharacterized protein', 111, NULL, NULL, 35466),
(35467, '3.30.420.40-FF-000936', NULL, 'Predicted protein', 85, NULL, NULL, 35467),
(35468, '3.40.50.970-FF-000196', NULL, 'Probable 2-oxoglutarate dehydrogenase E1 component DHKTD1, mitochondrial', 133, NULL, NULL, 35468),
(35469, '3.30.720.150-FF-000003', NULL, 'UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase', 134, NULL, NULL, 35469),
(35470, '2.60.40.10-FF-003518', NULL, NULL, 86, NULL, NULL, 35470),
(35471, '3.10.20.80-FF-000003', NULL, 'Translation initiation factor IF-3', 66, NULL, NULL, 35471),
(35472, '3.90.650.10-FF-000015', NULL, 'Hydrogenase expression/formation protein HypE', 178, NULL, NULL, 35472),
(35473, '3.30.40.10-FF-002192', NULL, 'Predicted protein', 77, NULL, NULL, 35473),
(35474, '3.30.470.160-FF-000004', NULL, 'Inositol polyphosphate multikinase alpha', 246, NULL, NULL, 35474),
(35475, '2.130.10.10-FF-002884', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit wdr4', 238, NULL, NULL, 35475),
(35476, '1.20.120.850-FF-000019', NULL, 'DNA repair and recombination protein RAD54B, putative', 92, NULL, NULL, 35476),
(35477, '3.90.550.10-FF-000390', NULL, 'Hexosyltransferase', 269, NULL, NULL, 35477),
(35478, '1.10.10.10-FF-002111', NULL, 'Two-component response regulator', 101, NULL, NULL, 35478),
(35479, '2.60.120.260-FF-000366', NULL, 'Uncharacterized protein', 164, NULL, NULL, 35479),
(35480, '1.10.287.80-FF-000003', NULL, 'ATP synthase gamma chain, chloroplastic', 68, NULL, NULL, 35480),
(35481, '3.30.160.60-FF-003980', NULL, NULL, 29, NULL, NULL, 35481),
(35482, '1.20.1250.20-FF-002168', NULL, 'Predicted protein', 180, NULL, NULL, 35482),
(35483, '1.10.8.10-FF-000345', NULL, 'Predicted protein', 22, NULL, NULL, 35483),
(35484, '1.10.3210.30-FF-000002', NULL, 'CRISPR-associated helicase Cas3', 215, NULL, NULL, 35484),
(35485, '1.10.1620.20-FF-000013', NULL, 'Uncharacterized protein', 57, NULL, NULL, 35485),
(35486, '2.120.10.80-FF-000376', NULL, 'Uncharacterized protein', 152, NULL, NULL, 35486),
(35487, '3.30.390.80-FF-000006', NULL, 'DNA repair RAD52-like protein 1, mitochondrial', 125, NULL, NULL, 35487),
(35488, '3.40.50.300-FF-007830', NULL, 'ABC transporter', 265, NULL, NULL, 35488),
(35489, '1.10.640.10-FF-000074', NULL, 'Alpha-dioxygenase 1', 73, NULL, NULL, 35489),
(35490, '3.30.200.20-FF-001566', NULL, 'Uncharacterized protein', 98, NULL, NULL, 35490),
(35491, '3.40.50.300-FF-002507', NULL, 'Isoniazid inductible gene protein IniC', 233, NULL, NULL, 35491),
(35492, '3.90.380.10-FF-000022', NULL, NULL, 197, NULL, NULL, 35492),
(35493, '2.120.10.30-FF-000277', NULL, 'Nhl-3', 196, NULL, NULL, 35493),
(35494, '3.30.1600.10-FF-000031', NULL, 'Predicted protein', 108, NULL, NULL, 35494),
(35495, '3.40.525.10-FF-000011', NULL, 'SEC14 cytosolic factor', 213, NULL, NULL, 35495),
(35496, '2.60.40.60-FF-000184', NULL, 'neural-cadherin isoform X12', 113, NULL, NULL, 35496),
(35497, '1.10.10.10-FF-000874', NULL, 'EAP30/Vps36 family, putative', 81, NULL, NULL, 35497),
(35498, '1.10.3080.10-FF-000058', NULL, 'Eukaryotic translation initiation factor 3 subunit E', 85, NULL, NULL, 35498),
(35499, '2.60.40.10-FF-005222', NULL, NULL, 90, NULL, NULL, 35499),
(35500, '1.25.40.510-FF-000004', NULL, 'Putative RNA export mediator Gle1', 315, NULL, NULL, 35500),
(35501, '2.130.10.10-FF-003401', NULL, 'Histidine kinase/response regulator hybrid protein', 203, NULL, NULL, 35501),
(35502, '3.20.20.120-FF-000018', NULL, 'D(-)-tartrate dehydratase', 260, NULL, NULL, 35502),
(35503, '2.30.42.10-FF-000068', NULL, 'Na(+)/H(+) exchange regulatory cofactor NHE-RF', 95, NULL, NULL, 35503);
INSERT INTO "PUBLIC"."MODEL" VALUES
(35504, '3.30.160.60-FF-005435', NULL, NULL, 80, NULL, NULL, 35504),
(35505, '3.30.420.40-FF-000032', NULL, 'Cell division protein FtsA', 161, NULL, NULL, 35505),
(35506, '1.20.1560.10-FF-000593', NULL, 'Uncharacterized protein', 70, NULL, NULL, 35506),
(35507, '3.40.50.2300-FF-000465', NULL, 'DNA-binding response regulator', 119, NULL, NULL, 35507),
(35508, '2.30.29.30-FF-000678', NULL, 'tensin', 152, NULL, NULL, 35508),
(35509, '3.30.420.10-FF-000697', NULL, NULL, 118, NULL, NULL, 35509),
(35510, '3.90.70.10-FF-000274', NULL, 'Related to calpain', 142, NULL, NULL, 35510),
(35511, '3.30.70.660-FF-000025', NULL, 'tRNA pseudouridine synthase', 186, NULL, NULL, 35511),
(35512, '2.30.30.40-FF-000055', NULL, 'rho GTPase-activating protein 26 isoform X1', 66, NULL, NULL, 35512),
(35513, '1.20.120.980-FF-000030', NULL, 'Lysosomal Pro-X carboxypeptidase', 150, NULL, NULL, 35513),
(35514, '3.40.30.10-FF-000381', NULL, 'UBX domain-containing protein', 112, NULL, NULL, 35514),
(35515, '1.20.120.140-FF-000014', NULL, 'Srp101p', 109, NULL, NULL, 35515),
(35516, '2.40.50.90-FF-000076', NULL, 'Nuclease domain containing protein', 144, NULL, NULL, 35516),
(35517, '1.25.40.10-FF-000101', NULL, 'Dual specificity protein kinase TTK', 161, NULL, NULL, 35517),
(35518, '2.10.25.10-FF-001114', NULL, 'Uncharacterized protein', 32, NULL, NULL, 35518),
(35519, '1.20.1270.60-FF-000248', NULL, 'Chromosome 16, whole genome shotgun sequence', 258, NULL, NULL, 35519),
(35520, '2.130.10.10-FF-004121', NULL, 'Uncharacterized protein', 188, NULL, NULL, 35520),
(35521, '2.60.40.10-FF-002131', NULL, 'Sallimus, isoform P', 102, NULL, NULL, 35521),
(35522, '3.30.200.20-FF-000251', NULL, 'Macrophage stimulating 1 receptor', 104, NULL, NULL, 35522),
(35523, '3.90.226.10-FF-000024', NULL, 'Delta3,5-delta2,4-dienoyl-CoA isomerase', 216, NULL, NULL, 35523),
(35524, '3.30.160.60-FF-003305', NULL, 'myeloid zinc finger 1', 25, NULL, NULL, 35524),
(35525, '3.40.50.300-FF-005256', NULL, 'Uncharacterized protein', 187, NULL, NULL, 35525),
(35526, '3.40.50.300-FF-007510', NULL, 'Uncharacterized protein', 218, NULL, NULL, 35526),
(35527, '1.10.1370.40-FF-000010', NULL, 'Oligopeptidase A family protein', 130, NULL, NULL, 35527),
(35528, '3.30.70.330-FF-003147', NULL, NULL, 147, NULL, NULL, 35528),
(35529, '2.20.100.10-FF-000241', NULL, 'Thrombospondin type 1 domaincontaining protein', 52, NULL, NULL, 35529),
(35530, '3.30.160.60-FF-005559', NULL, NULL, 69, NULL, NULL, 35530),
(35531, '3.10.50.40-FF-000055', NULL, 'Peptidylprolyl isomerase', 144, NULL, NULL, 35531),
(35532, '3.40.50.1820-FF-001153', NULL, 'ENC6 protein', 294, NULL, NULL, 35532),
(35533, '1.20.970.10-FF-000023', NULL, 'Anthranilate phosphoribosyltransferase', 79, NULL, NULL, 35533),
(35534, '3.90.190.10-FF-000316', NULL, 'Dual specificity phosphatase 22b', 90, NULL, NULL, 35534),
(35535, '1.10.600.10-FF-000077', NULL, 'Uncharacterized protein', 92, NULL, NULL, 35535),
(35536, '3.30.413.10-FF-000012', NULL, '4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase (flavodoxin)', 118, NULL, NULL, 35536),
(35537, '1.50.10.10-FF-000170', NULL, 'Uncharacterized protein', 425, NULL, NULL, 35537),
(35538, '3.40.50.1000-FF-000070', NULL, 'HAD hydrolase, family IA', 195, NULL, NULL, 35538),
(35539, '2.60.40.10-FF-001512', NULL, 'Premelanosome protein a', 81, NULL, NULL, 35539),
(35540, '3.30.40.10-FF-001573', NULL, 'Uncharacterized protein', 131, NULL, NULL, 35540),
(35541, '3.30.590.20-FF-000015', NULL, 'Putative glutamate--cysteine ligase 2', 366, NULL, NULL, 35541),
(35542, '3.10.200.10-FF-000016', NULL, NULL, 145, NULL, NULL, 35542),
(35543, '3.40.190.10-FF-000676', NULL, 'Uncharacterized solute-binding protein VNG_1595C', 23, NULL, NULL, 35543),
(35544, '1.10.10.60-FF-001136', NULL, NULL, 60, NULL, NULL, 35544),
(35545, '3.30.760.10-FF-000059', NULL, 'Uncharacterized protein', 209, NULL, NULL, 35545),
(35546, '3.20.20.60-FF-000036', NULL, 'ATP/GTP-binding protein', 110, NULL, NULL, 35546),
(35547, '1.25.10.10-FF-002746', NULL, 'Predicted protein', 738, NULL, NULL, 35547),
(35548, '1.20.58.2170-FF-000004', NULL, NULL, 119, NULL, NULL, 35548);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(35549, '3.40.720.10-FF-000133', NULL, 'GPI ethanolamine phosphate transferase 2-like Protein', 273, NULL, NULL, 35549),
(35550, '2.10.70.10-FF-000004', NULL, 'Fibronectin 1', 49, NULL, NULL, 35550),
(35551, '2.20.110.10-FF-000067', NULL, NULL, 50, NULL, NULL, 35551),
(35552, '3.40.50.1820-FF-000753', NULL, 'Alpha/beta fold hydrolase', 353, NULL, NULL, 35552),
(35553, '3.30.70.2450-FF-000006', NULL, 'Monooxygenase, putative (AFU_orthologue AFUA_7G06960)', 124, NULL, NULL, 35553),
(35554, '2.30.42.10-FF-000629', NULL, NULL, 74, NULL, NULL, 35554),
(35555, '3.30.160.60-FF-004929', NULL, NULL, 29, NULL, NULL, 35555),
(35556, '3.40.50.10470-FF-000048', NULL, 'Translation initiation factor EIF-2B subunit 1', 190, NULL, NULL, 35556),
(35557, '3.40.30.10-FF-000504', NULL, 'Protein disulfide-isomerase', 114, NULL, NULL, 35557),
(35558, '1.25.40.10-FF-004693', NULL, 'Uncharacterized protein', 101, NULL, NULL, 35558),
(35559, '3.30.70.330-FF-002528', NULL, NULL, 57, NULL, NULL, 35559),
(35560, '3.30.565.10-FF-000050', NULL, 'Histidine kinase 4', 178, NULL, NULL, 35560),
(35561, '1.10.630.10-FF-000146', NULL, 'Os06g0641800 protein', 95, NULL, NULL, 35561),
(35562, '2.60.11.10-FF-000006', NULL, 'Cytochrome c oxidase subunit Vb', 95, NULL, NULL, 35562),
(35563, '1.20.1070.10-FF-000504', NULL, 'Predicted protein', 304, NULL, NULL, 35563),
(35564, '1.20.120.420-FF-000008', NULL, 'Methylthioribose-1-phosphate isomerase', 149, NULL, NULL, 35564),
(35565, '1.20.1250.20-FF-000690', NULL, 'Uncharacterized protein, isoform D', 221, NULL, NULL, 35565),
(35566, '3.30.160.60-FF-005778', NULL, NULL, 58, NULL, NULL, 35566),
(35567, '3.40.50.740-FF-000026', NULL, 'NADH-quinone oxidoreductase', 61, NULL, NULL, 35567),
(35568, '1.10.1410.10-FF-000073', NULL, 'MUTator', 118, NULL, NULL, 35568),
(35569, '3.40.50.150-FF-000175', NULL, 'Chemotaxis methyltransferase CheR', 200, NULL, NULL, 35569),
(35570, '1.10.10.920-FF-000002', NULL, 'Coproporphyrinogen-III oxidase', 93, NULL, NULL, 35570),
(35571, '1.10.10.60-FF-000299', NULL, 'Empty spiracles homeobox 3', 101, NULL, NULL, 35571),
(35572, '1.10.287.550-FF-000010', NULL, 'Uncharacterized protein', 56, NULL, NULL, 35572),
(35573, '3.40.50.720-FF-000020', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', 159, NULL, NULL, 35573),
(35574, '1.20.1250.10-FF-000136', NULL, NULL, 77, NULL, NULL, 35574),
(35575, '3.30.930.10-FF-000230', NULL, 'eIF-2-alpha kinase GCN2 isoform X1', 347, NULL, NULL, 35575),
(35576, '2.60.40.10-FF-005565', NULL, NULL, 110, NULL, NULL, 35576),
(35577, '2.60.40.10-FF-001170', NULL, 'Sema domain, immunoglobulin domain (Ig), short basic domain, secreted, (Semaphorin) 3F', 83, NULL, NULL, 35577),
(35578, '3.30.9.20-FF-000003', NULL, 'SibG', 133, NULL, NULL, 35578),
(35579, '1.20.58.70-FF-000102', NULL, 'Uncharacterized protein', 132, NULL, NULL, 35579),
(35580, '1.25.40.20-FF-000986', NULL, 'Uncharacterized protein', 92, NULL, NULL, 35580),
(35581, '1.20.1610.10-FF-000024', NULL, 'Uncharacterized protein', 146, NULL, NULL, 35581),
(35582, '1.10.10.10-FF-000531', NULL, 'Heat shock transcription factor 5', 122, NULL, NULL, 35582),
(35583, '3.40.50.410-FF-000163', NULL, 'Integrin beta', 71, NULL, NULL, 35583),
(35584, '2.40.30.10-FF-000107', NULL, 'Related to translation elongation factor HBS1', 113, NULL, NULL, 35584),
(35585, '1.10.510.10-FF-003285', NULL, NULL, 97, NULL, NULL, 35585),
(35586, '2.60.40.10-FF-000894', NULL, 'cell adhesion molecule 3 isoform X1', 97, NULL, NULL, 35586),
(35587, '3.40.630.30-FF-000576', NULL, 'Im:6904045', 100, NULL, NULL, 35587),
(35588, '3.30.70.920-FF-000013', NULL, 'AsnC family transcriptional regulator', 92, NULL, NULL, 35588),
(35589, '3.30.70.940-FF-000019', NULL, 'Transcription termination/antitermination protein NusG', 125, NULL, NULL, 35589),
(35590, '3.30.450.20-FF-000426', NULL, 'Two-component system sensor histidine kinase', 132, NULL, NULL, 35590),
(35591, '1.10.10.650-FF-000011', NULL, 'Transcription elongation factor SPT6', 174, NULL, NULL, 35591),
(35592, '3.40.50.2300-FF-000122', NULL, 'Extracellular calcium-sensing receptor', 319, NULL, NULL, 35592);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(35593, '3.30.1330.20-FF-000029', NULL, 'Tubulin gamma chain', 102, NULL, NULL, 35593),
(35594, '1.25.10.10-FF-003229', NULL, 'Uncharacterized protein', 257, NULL, NULL, 35594),
(35595, '1.20.120.1900-FF-000015', NULL, 'Gamma-tubulin complex component', 258, NULL, NULL, 35595),
(35596, '3.90.230.10-FF-000023', NULL, 'Methionine aminopeptidase 1c, putative', 197, NULL, NULL, 35596),
(35597, '3.40.1380.10-FF-000027', NULL, 'ATP synthase gamma chain', 217, NULL, NULL, 35597),
(35598, '3.90.79.10-FF-000142', NULL, 'Phosphohydrolase (MUTT/NUDIX family protein)', 168, NULL, NULL, 35598),
(35599, '3.40.1410.10-FF-000025', NULL, 'GntR family transcriptional regulator', 165, NULL, NULL, 35599),
(35600, '1.10.1520.10-FF-000064', NULL, '39S ribosomal protein L44, mitochondrial', 160, NULL, NULL, 35600),
(35601, '3.30.160.60-FF-006054', NULL, NULL, 53, NULL, NULL, 35601),
(35602, '3.40.50.10930-FF-000006', NULL, 'Exodeoxyribonuclease V, gamma subunit', 127, NULL, NULL, 35602),
(35603, '3.10.20.90-FF-000545', NULL, 'Predicted protein', 93, NULL, NULL, 35603),
(35604, '3.80.10.10-FF-000597', NULL, 'F-box/LRR-repeat protein 17', 278, NULL, NULL, 35604),
(35605, '3.80.10.10-FF-002283', NULL, 'Uncharacterized protein', 74, NULL, NULL, 35605),
(35606, '3.30.70.1230-FF-000091', NULL, 'Guanylate cyclase', 119, NULL, NULL, 35606),
(35607, '2.30.180.10-FF-000075', NULL, 'Stabilin 2', 149, NULL, NULL, 35607),
(35608, '1.10.510.10-FF-002127', NULL, 'Probable serine/threonine-protein kinase pats1', 213, NULL, NULL, 35608),
(35609, '3.40.50.1460-FF-000061', NULL, 'Caspase 8b', 255, NULL, NULL, 35609),
(35610, '1.10.3860.10-FF-000022', NULL, 'Proton/sodium glutamate symporter', 394, NULL, NULL, 35610),
(35611, '2.40.70.10-FF-000548', NULL, NULL, 182, NULL, NULL, 35611),
(35612, '1.20.1070.10-FF-001443', NULL, 'Uncharacterized protein', 222, NULL, NULL, 35612),
(35613, '1.25.40.10-FF-001950', NULL, 'Pentatricopeptide repeat domain 1', 187, NULL, NULL, 35613),
(35614, '1.25.40.1030-FF-000034', NULL, 'Protein transport protein SEC31', 350, NULL, NULL, 35614),
(35615, '1.10.510.10-FF-004252', NULL, NULL, 193, NULL, NULL, 35615),
(35616, '2.70.150.10-FF-000053', NULL, 'Silver exporting P-type ATPase', 117, NULL, NULL, 35616),
(35617, '3.30.160.60-FF-003749', NULL, NULL, 30, NULL, NULL, 35617),
(35618, '3.50.50.60-FF-001352', NULL, 'AER292Cp', 108, NULL, NULL, 35618),
(35619, '1.20.1250.20-FF-002163', NULL, 'Uncharacterized protein', 185, NULL, NULL, 35619),
(35620, '3.30.530.20-FF-000028', NULL, 'Phosphatidylinositol transfer protein 5', 263, NULL, NULL, 35620),
(35621, '2.30.30.140-FF-000337', NULL, 'RE66405p', 57, NULL, NULL, 35621),
(35622, '2.10.25.10-FF-001794', NULL, 'Uncharacterized protein', 28, NULL, NULL, 35622),
(35623, '1.25.40.180-FF-000085', NULL, 'Eukaryotic translation initiation factor 4G2, isoform A', 257, NULL, NULL, 35623),
(35624, '1.25.40.10-FF-005210', NULL, 'Uncharacterized protein', 202, NULL, NULL, 35624),
(35625, '1.20.120.550-FF-000013', NULL, 'Predicted protein', 148, NULL, NULL, 35625),
(35626, '1.20.1610.10-FF-000001', NULL, 'Putative alpha-1,2-mannosidase', 159, NULL, NULL, 35626),
(35627, '3.30.160.60-FF-000995', NULL, 'zinc finger protein 668', 27, NULL, NULL, 35627),
(35628, '1.25.40.10-FF-003063', NULL, 'Uncharacterized protein', 217, NULL, NULL, 35628),
(35629, '3.50.50.60-FF-000840', NULL, 'Putative flavoprotein monooxygenase', 67, NULL, NULL, 35629),
(35630, '3.30.710.10-FF-000236', NULL, 'Transcription regulator protein BACH2', 74, NULL, NULL, 35630),
(35631, '3.40.50.2300-FF-001538', NULL, NULL, 62, NULL, NULL, 35631),
(35632, '1.25.40.20-FF-000323', NULL, 'Ankyrin repeat domain-containing protein 2', 153, NULL, NULL, 35632),
(35633, '3.30.479.20-FF-000054', NULL, 'Elongation factor Ts', 91, NULL, NULL, 35633),
(35634, '1.50.10.10-FF-000193', NULL, 'Gll2460 protein', 265, NULL, NULL, 35634),
(35635, '3.80.10.10-FF-003244', NULL, 'F-box/LRR-repeat protein 15', 180, NULL, NULL, 35635),
(35636, '1.20.120.230-FF-000030', NULL, 'TaLiN', 128, NULL, NULL, 35636),
(35637, '3.40.50.460-FF-000032', NULL, 'Uncharacterized protein', 87, NULL, NULL, 35637);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(35638, '1.10.8.710-FF-000014', NULL, 'Si:dkey-11m19.5', 122, NULL, NULL, 35638),
(35639, '1.20.1270.10-FF-000031', NULL, 'Cytosolic heat shock protein 70', 73, NULL, NULL, 35639),
(35640, '4.10.1120.10-FF-000003', NULL, 'Phosphodiesterase 6G', 59, NULL, NULL, 35640),
(35641, '1.20.1250.20-FF-001218', NULL, 'Alpha-ketoglutarate permease (KgtP)', 215, NULL, NULL, 35641),
(35642, '3.40.50.300-FF-003564', NULL, 'Branched-chain amino acid ABC transporter, ATP-binding protein', 247, NULL, NULL, 35642),
(35643, '3.40.50.10190-FF-000184', NULL, 'DNA ligase', 118, NULL, NULL, 35643),
(35644, '2.130.10.10-FF-003272', NULL, 'Uncharacterized protein', 171, NULL, NULL, 35644),
(35645, '3.40.50.150-FF-000624', NULL, 'Protein-lysine N-methyltransferase EFM4', 224, NULL, NULL, 35645),
(35646, '3.80.10.10-FF-003351', NULL, 'Uncharacterized protein', 115, NULL, NULL, 35646),
(35647, '3.40.50.300-FF-004183', NULL, 'Spastin', 77, NULL, NULL, 35647),
(35648, '1.10.287.70-FF-000708', NULL, 'Uncharacterized protein', 170, NULL, NULL, 35648),
(35649, '3.40.50.150-FF-001136', NULL, NULL, 49, NULL, NULL, 35649),
(35650, '3.40.190.10-FF-000777', NULL, 'Extracellular solute-binding protein family 5', 283, NULL, NULL, 35650),
(35651, '3.65.10.10-FF-000020', NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', 189, NULL, NULL, 35651),
(35652, '2.60.15.10-FF-000015', NULL, 'ATP synthase epsilon chain', 123, NULL, NULL, 35652),
(35653, '3.40.50.300-FF-003671', NULL, 'Uncharacterized GTP-binding protein VNG_1111G', 152, NULL, NULL, 35653),
(35654, '3.30.160.60-FF-004362', NULL, NULL, 85, NULL, NULL, 35654),
(35655, '1.25.40.20-FF-000430', NULL, 'ankyrin repeat and KH domain-containing protein 1 isoform X2', 98, NULL, NULL, 35655),
(35656, '2.20.100.10-FF-000140', NULL, 'Zinc metalloproteinase', 68, NULL, NULL, 35656),
(35657, '3.80.10.10-FF-002732', NULL, 'Predicted protein', 132, NULL, NULL, 35657),
(35658, '1.10.150.50-FF-000104', NULL, 'Uncharacterized protein, isoform B', 94, NULL, NULL, 35658),
(35659, '1.10.10.250-FF-000003', NULL, 'Mitochondrial ribosomal protein L11', 74, NULL, NULL, 35659),
(35660, '3.80.10.10-FF-001215', NULL, 'Uncharacterized protein', 140, NULL, NULL, 35660),
(35661, '3.40.50.10190-FF-000077', NULL, 'Chitin biosynthesis protein CHS5', 130, NULL, NULL, 35661),
(35662, '1.10.238.20-FF-000058', NULL, 'AGAP006278-PA', 125, NULL, NULL, 35662),
(35663, '3.40.140.10-FF-000162', NULL, 'Apolipoprotein B mRNA editing enzyme catalytic subunit 3B', 98, NULL, NULL, 35663),
(35664, '2.60.40.150-FF-000127', NULL, 'copine-9 isoform X2', 135, NULL, NULL, 35664),
(35665, '3.90.550.10-FF-000070', NULL, 'Hyaluronan synthase 3', 234, NULL, NULL, 35665),
(35666, '3.20.20.80-FF-000593', NULL, 'Uncharacterized protein', 202, NULL, NULL, 35666),
(35667, '1.10.10.10-FF-000649', NULL, 'Cyclic nucleotide-binding domain protein', 77, NULL, NULL, 35667),
(35668, '2.60.120.10-FF-000514', NULL, 'HlyB family protein', 148, NULL, NULL, 35668),
(35669, '1.25.10.10-FF-003128', NULL, 'Uncharacterized protein', 203, NULL, NULL, 35669),
(35670, '1.10.510.10-FF-004145', NULL, NULL, 46, NULL, NULL, 35670),
(35671, '1.20.1250.20-FF-000706', NULL, 'Transporter, major facilitator family protein', 433, NULL, NULL, 35671),
(35672, '1.20.1070.10-FF-001336', NULL, 'Uncharacterized protein', 277, NULL, NULL, 35672),
(35673, '3.30.160.60-FF-000091', NULL, 'Putative Krueppel-like factor 12', 23, NULL, NULL, 35673),
(35674, '2.40.50.140-FF-000159', NULL, 'rRNA biogenesis protein rrp5', 80, NULL, NULL, 35674),
(35675, '3.40.50.300-FF-005599', NULL, 'Dynein axonemal heavy chain 14', 172, NULL, NULL, 35675),
(35676, '2.40.160.50-FF-000027', NULL, 'Uncharacterized protein', 321, NULL, NULL, 35676),
(35677, '3.80.10.10-FF-003929', NULL, 'Uncharacterized protein', 95, NULL, NULL, 35677),
(35678, '1.10.287.3510-FF-000011', NULL, 'NADH-ubiquinone oxidoreductase chain 4L', 83, NULL, NULL, 35678),
(35679, '3.30.1370.210-FF-000023', NULL, 'Poly (ADP-ribose) polymerase family, member 12', 58, NULL, NULL, 35679),
(35680, '1.10.533.10-FF-000022', NULL, 'B-cell lymphoma/leukemia 10', 115, NULL, NULL, 35680);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(35681, '1.25.40.10-FF-001843', NULL, 'AfsR family transcriptional regulator', 130, NULL, NULL, 35681),
(35682, '1.20.120.1960-FF-000005', NULL, 'Sulfhydryl oxidase', 104, NULL, NULL, 35682),
(35683, '3.30.1120.10-FF-000005', NULL, 'Arylsulfatase A', 83, NULL, NULL, 35683),
(35684, '2.60.120.920-FF-000036', NULL, 'Tripartite motif-containing protein 35', 197, NULL, NULL, 35684),
(35685, '1.20.1740.10-FF-000247', NULL, 'Uncharacterized protein', 326, NULL, NULL, 35685),
(35686, '3.40.50.1000-FF-000631', NULL, NULL, 124, NULL, NULL, 35686),
(35687, '3.30.559.30-FF-000007', NULL, 'Trehalose-2-sulfate acyltransferase papA2', 209, NULL, NULL, 35687),
(35688, '1.20.1730.10-FF-000055', NULL, 'Predicted protein', 522, NULL, NULL, 35688),
(35689, '3.90.870.10-FF-000009', NULL, 'Threonylcarbamoyl-AMP synthase, putative', 211, NULL, NULL, 35689),
(35690, '2.60.40.10-FF-003412', NULL, NULL, 103, NULL, NULL, 35690),
(35691, '3.30.70.330-FF-000499', NULL, 'Polyadenylate-binding protein', 109, NULL, NULL, 35691),
(35692, '3.30.70.330-FF-001123', NULL, 'tRNA selenocysteine 1-associated protein', 78, NULL, NULL, 35692),
(35693, '3.10.20.620-FF-000002', NULL, 'Autophagy protein 5', 105, NULL, NULL, 35693),
(35694, '2.60.40.10-FF-003305', NULL, 'NCAM (Neural cell adhesion molecule) homolog', 81, NULL, NULL, 35694),
(35695, '2.30.30.570-FF-000005', NULL, 'Uncharacterized protein', 54, NULL, NULL, 35695),
(35696, '3.30.497.10-FF-000121', NULL, 'Male accessory gland protein', 209, NULL, NULL, 35696),
(35697, '4.10.280.10-FF-000141', NULL, 'Basic helix-loop-helix (BHLH) DNA-binding superfamily protein', 79, NULL, NULL, 35697),
(35698, '2.40.110.10-FF-000080', NULL, 'Acyl-coenzyme A oxidase', 134, NULL, NULL, 35698),
(35699, '2.60.120.920-FF-000143', NULL, 'Protein CBR-SPSB-2', 117, NULL, NULL, 35699),
(35700, '1.10.238.20-FF-000052', NULL, 'AGAP002190-PA', 110, NULL, NULL, 35700),
(35701, '3.40.50.10470-FF-000054', NULL, 'Uncharacterized protein', 200, NULL, NULL, 35701),
(35702, '3.10.310.40-FF-000005', NULL, 'Alanine--tRNA ligase', 114, NULL, NULL, 35702),
(35703, '1.20.990.10-FF-000036', NULL, 'NADPH-cytochrome P450 reductase', 131, NULL, NULL, 35703),
(35704, '3.30.750.44-FF-000005', NULL, 'Retinol-binding protein 3', 81, NULL, NULL, 35704),
(35705, '1.10.10.10-FF-001594', NULL, 'O-methyltransferase family protein', 79, NULL, NULL, 35705),
(35706, '1.10.287.40-FF-000020', NULL, 'Serine-tRNA ligase', 115, NULL, NULL, 35706),
(35707, '3.40.630.10-FF-000132', NULL, 'Carboxypeptidase A1', 308, NULL, NULL, 35707),
(35708, '1.25.10.10-FF-000711', NULL, 'Hypothetical_protein_-_conserved', 1041, NULL, NULL, 35708),
(35709, '3.10.20.90-FF-000101', NULL, 'FAS-associated factor 2 isoform X2', 82, NULL, NULL, 35709),
(35710, '1.25.40.90-FF-000068', NULL, 'At4g31200', 137, NULL, NULL, 35710),
(35711, '2.130.10.10-FF-003957', NULL, 'Uncharacterized protein', 242, NULL, NULL, 35711),
(35712, '2.60.120.330-FF-000180', NULL, 'Uncharacterized protein', 213, NULL, NULL, 35712),
(35713, '2.60.40.10-FF-005666', NULL, NULL, 86, NULL, NULL, 35713),
(35714, '3.40.630.30-FF-000132', NULL, 'N-acetyltransferase 9-like protein', 166, NULL, NULL, 35714),
(35715, '1.25.40.70-FF-000068', NULL, 'Uncharacterized protein', 121, NULL, NULL, 35715),
(35716, '3.60.40.10-FF-000268', NULL, 'Protein phosphatase type 2c', 282, NULL, NULL, 35716),
(35717, '3.30.70.360-FF-000042', NULL, 'N-acyl-L-amino acid amidohydrolase, putative', 116, NULL, NULL, 35717),
(35718, '2.10.25.10-FF-001120', NULL, 'Laminin alpha 1', 46, NULL, NULL, 35718),
(35719, '3.40.50.300-FF-004868', NULL, 'RecBCD enzyme subunit RecC', 166, NULL, NULL, 35719),
(35720, '2.60.40.150-FF-000234', NULL, 'Translocation protein sec63', 125, NULL, NULL, 35720),
(35721, '3.40.630.30-FF-000138', NULL, 'N-acetyltransferase subunit ARD1', 166, NULL, NULL, 35721),
(35722, '2.40.50.140-FF-000945', NULL, NULL, 79, NULL, NULL, 35722),
(35723, '1.20.5.100-FF-000020', NULL, 'Cytochrome b', 35, NULL, NULL, 35723),
(35724, '3.80.10.10-FF-004548', NULL, 'Uncharacterized protein', 354, NULL, NULL, 35724);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(35725, '3.90.105.10-FF-000007', NULL, 'Molybdopterin molybdenumtransferase', 54, NULL, NULL, 35725),
(35726, '2.130.10.10-FF-000310', NULL, 'Coronin', 344, NULL, NULL, 35726),
(35727, '3.10.20.90-FF-000107', NULL, 'protein DDI1 homolog 2 isoform X1', 94, NULL, NULL, 35727),
(35728, '2.30.30.40-FF-000639', NULL, 'Tyrosine-protein kinase', 81, NULL, NULL, 35728),
(35729, '3.40.50.1820-FF-001265', NULL, 'Uncharacterized protein', 305, NULL, NULL, 35729),
(35730, '3.30.160.60-FF-003064', NULL, 'Zinc finger putative Transcription Factor family', 23, NULL, NULL, 35730),
(35731, '3.30.160.60-FF-002445', NULL, 'IKAROS family zinc finger 1', 44, NULL, NULL, 35731),
(35732, '3.30.60.20-FF-000060', NULL, 'Diacylglycerol kinase', 62, NULL, NULL, 35732),
(35733, '3.30.1390.20-FF-000033', NULL, '50S ribosomal protein L30', 58, NULL, NULL, 35733),
(35734, '3.40.50.150-FF-001243', NULL, NULL, 74, NULL, NULL, 35734),
(35735, '1.10.287.660-FF-000020', NULL, 'Predicted protein', 76, NULL, NULL, 35735),
(35736, '2.30.30.490-FF-000077', NULL, 'Uncharacterized protein', 126, NULL, NULL, 35736),
(35737, '1.10.20.10-FF-000352', NULL, NULL, 93, NULL, NULL, 35737),
(35738, '2.40.50.120-FF-000046', NULL, 'Complement component 4A (Rodgers blood group)', 156, NULL, NULL, 35738),
(35739, '1.25.40.550-FF-000011', NULL, 'Protein AAR2-like protein', 191, NULL, NULL, 35739),
(35740, '3.10.20.90-FF-000096', NULL, 'Ubiquitin thioesterase OTU1', 84, NULL, NULL, 35740),
(35741, '1.10.510.10-FF-000885', NULL, 'Uncharacterized protein', 352, NULL, NULL, 35741),
(35742, '3.40.630.30-FF-000020', NULL, 'Alpha-tubulin N-acetyltransferase 1', 140, NULL, NULL, 35742),
(35743, '3.40.50.300-FF-002266', NULL, '26S protease regulatory subunit 6B', 180, NULL, NULL, 35743),
(35744, '2.60.120.560-FF-000006', NULL, 'LCCL domain-containing protein', 168, NULL, NULL, 35744),
(35745, '3.30.530.20-FF-000135', NULL, 'Uncharacterized protein', 81, NULL, NULL, 35745),
(35746, '2.130.10.10-FF-004469', NULL, 'Uncharacterized protein', 196, NULL, NULL, 35746),
(35747, '3.30.40.10-FF-002197', NULL, 'E3 ubiquitin-protein ligase UHRF2 isoform X1', 75, NULL, NULL, 35747),
(35748, '1.20.5.440-FF-000009', NULL, '3-mercaptopropionate dioxygenase', 45, NULL, NULL, 35748),
(35749, '3.40.50.2000-FF-000717', NULL, 'Zeaxanthin glucosyltransferase', 157, NULL, NULL, 35749),
(35750, '1.25.40.180-FF-000192', NULL, 'Pre-mRNA-splicing factor CWC22', 290, NULL, NULL, 35750),
(35751, '3.40.50.300-FF-004290', NULL, 'ABC transporter G family member 24', 250, NULL, NULL, 35751),
(35752, '1.20.1080.10-FF-000089', NULL, 'Aquaporin-like protein', 82, NULL, NULL, 35752),
(35753, '3.40.1110.10-FF-000446', NULL, NULL, 160, NULL, NULL, 35753),
(35754, '1.20.1070.10-FF-000824', NULL, 'G-protein coupled receptor', 329, NULL, NULL, 35754),
(35755, '3.80.10.10-FF-000366', NULL, 'leucine-rich repeat-containing protein 23', 159, NULL, NULL, 35755),
(35756, '2.30.29.30-FF-000661', NULL, 'PH domain containing protein', 117, NULL, NULL, 35756),
(35757, '3.30.70.330-FF-001808', NULL, NULL, 62, NULL, NULL, 35757),
(35758, '1.25.40.10-FF-003855', NULL, 'Tetratricopeptide repeat domain 37', 111, NULL, NULL, 35758),
(35759, '3.40.50.300-FF-005487', NULL, 'TFIIH basal transcription factor complex helicase subunit', 200, NULL, NULL, 35759),
(35760, '3.10.330.20-FF-000012', NULL, 'tRNA (adenine(58)-N(1))-methyltransferase', 78, NULL, NULL, 35760),
(35761, '2.40.50.90-FF-000183', NULL, 'Tudor domain-containing protein 7', 81, NULL, NULL, 35761),
(35762, '2.60.40.1170-FF-000043', NULL, 'FCH domain only protein 1', 25, NULL, NULL, 35762),
(35763, '1.20.1560.10-FF-000587', NULL, 'Predicted protein', 305, NULL, NULL, 35763),
(35764, '1.10.275.10-FF-000034', NULL, NULL, 49, NULL, NULL, 35764),
(35765, '3.40.470.10-FF-000041', NULL, NULL, 91, NULL, NULL, 35765),
(35766, '3.30.70.330-FF-002972', NULL, NULL, 98, NULL, NULL, 35766),
(35767, '1.20.58.60-FF-000661', NULL, 'Uncharacterized protein', 97, NULL, NULL, 35767),
(35768, '1.20.58.390-FF-000174', NULL, 'Nicotinic acetylcholine receptor subunit', 66, NULL, NULL, 35768);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(35769, '6.20.240.60-FF-000003', NULL, 'Ion channel', 36, NULL, NULL, 35769),
(35770, '2.30.42.10-FF-000528', NULL, NULL, 56, NULL, NULL, 35770),
(35771, '3.40.720.10-FF-000240', NULL, 'Arylsulfatase H', 278, NULL, NULL, 35771),
(35772, '1.20.930.10-FF-000021', NULL, 'IWS1-like protein', 145, NULL, NULL, 35772),
(35773, '2.30.29.30-FF-001403', NULL, 'LD45876p', 144, NULL, NULL, 35773),
(35774, '1.25.40.20-FF-001716', NULL, 'Uncharacterized protein', 47, NULL, NULL, 35774),
(35775, '1.20.1070.10-FF-001224', NULL, 'Uncharacterized protein', 102, NULL, NULL, 35775),
(35776, '3.30.40.10-FF-002208', NULL, 'Uncharacterized protein', 71, NULL, NULL, 35776),
(35777, '2.60.40.420-FF-000219', NULL, 'Ac2-120', 101, NULL, NULL, 35777),
(35778, '1.20.990.10-FF-000013', NULL, 'NADPH-dependent diflavin oxidoreductase 1', 137, NULL, NULL, 35778),
(35779, '2.60.120.620-FF-000053', NULL, 'Oxidoreductase domain-containing protein', 217, NULL, NULL, 35779),
(35780, '2.60.40.10-FF-003524', NULL, NULL, 82, NULL, NULL, 35780),
(35781, '3.40.50.10490-FF-000161', NULL, NULL, 219, NULL, NULL, 35781),
(35782, '3.40.50.300-FF-007853', NULL, 'Uncharacterized protein', 217, NULL, NULL, 35782),
(35783, '3.30.760.10-FF-000071', NULL, 'Uncharacterized protein', 232, NULL, NULL, 35783),
(35784, '2.40.160.210-FF-000021', NULL, 'Predicted protein', 90, NULL, NULL, 35784),
(35785, '1.10.340.70-FF-000029', NULL, 'Uncharacterized protein', 92, NULL, NULL, 35785),
(35786, '3.30.160.60-FF-000214', NULL, 'replication initiator 1 isoform X1', 28, NULL, NULL, 35786),
(35787, '1.10.287.130-FF-000092', NULL, 'Response regulator receiver domain protein', 86, NULL, NULL, 35787),
(35788, '4.10.1060.10-FF-000060', NULL, 'Calcium-dependent cysteine protease, putative', 41, NULL, NULL, 35788),
(35789, '3.30.420.10-FF-000591', NULL, NULL, 204, NULL, NULL, 35789),
(35790, '3.40.50.300-FF-007049', NULL, 'Predicted protein', 301, NULL, NULL, 35790),
(35791, '1.10.10.2660-FF-000013', NULL, 'SUMO-activating enzyme subunit', 50, NULL, NULL, 35791),
(35792, '3.90.190.10-FF-000075', NULL, 'Phosphoglucan phosphatase LSF2, chloroplastic', 208, NULL, NULL, 35792),
(35793, '3.30.342.10-FF-000049', NULL, 'DNA polymerase', 140, NULL, NULL, 35793),
(35794, '2.30.30.490-FF-000071', NULL, 'Uncharacterized protein', 178, NULL, NULL, 35794),
(35795, '2.60.120.260-FF-000130', NULL, 'Discoidin domain-containing receptor 2', 173, NULL, NULL, 35795),
(35796, '1.10.510.10-FF-003740', NULL, NULL, 149, NULL, NULL, 35796),
(35797, '3.30.70.890-FF-000077', NULL, 'Predicted protein', 109, NULL, NULL, 35797),
(35798, '1.10.1300.10-FF-000087', NULL, 'Phosphodiesterase', 211, NULL, NULL, 35798),
(35799, '3.30.1330.30-FF-000021', NULL, 'rRNA methyltransferase 1, mitochondrial', 86, NULL, NULL, 35799),
(35800, '3.10.105.10-FF-000059', NULL, 'Substrate-binding protein', 223, NULL, NULL, 35800),
(35801, '3.40.50.300-FF-006318', NULL, 'RecBCD enzyme subunit RecC', 142, NULL, NULL, 35801),
(35802, '3.40.50.720-FF-000599', NULL, 'Uncharacterized oxidoreductase C663.06c', 250, NULL, NULL, 35802),
(35803, '3.30.2070.10-FF-000006', NULL, 'Molybdopterin-binding iron-sulfur cluster-binding oxidoreductase MopB-3', 57, NULL, NULL, 35803),
(35804, '3.30.460.20-FF-000034', NULL, 'Magnesium transport protein CorA', 130, NULL, NULL, 35804),
(35805, '2.130.10.10-FF-001248', NULL, 'WD repeat domain 78', 341, NULL, NULL, 35805),
(35806, '1.10.10.10-FF-000290', NULL, 'General transcription factor IIF subunit 1', 82, NULL, NULL, 35806),
(35807, '3.40.390.10-FF-000096', NULL, 'Os10g0558125 protein', 211, NULL, NULL, 35807),
(35808, '3.30.930.10-FF-000331', NULL, 'Uncharacterized protein', 136, NULL, NULL, 35808),
(35809, '3.40.50.720-FF-001223', NULL, 'SUMO activating enzyme', 341, NULL, NULL, 35809),
(35810, '3.40.50.1820-FF-000197', NULL, 'Alpha/beta hydrolase', 306, NULL, NULL, 35810),
(35811, '1.25.40.10-FF-001039', NULL, 'Anaphase-promoting complex subunit CDC23', 85, NULL, NULL, 35811),
(35812, '2.30.29.240-FF-000022', NULL, 'Phospholipase C beta-4', 116, NULL, NULL, 35812),
(35813, '2.130.10.10-FF-005537', NULL, 'WD repeat-containing protein PCN', 259, NULL, NULL, 35813);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(35814, '3.30.70.330-FF-002427', NULL, NULL, 156, NULL, NULL, 35814),
(35815, '3.20.20.100-FF-000018', NULL, 'Glycerol dehydrogenase Gcy1', 290, NULL, NULL, 35815),
(35816, '2.70.130.10-FF-000170', NULL, NULL, 71, NULL, NULL, 35816),
(35817, '2.40.30.330-FF-000010', NULL, 'mRNA cleavage and polyadenylation factor CLP1', 98, NULL, NULL, 35817),
(35818, '1.20.58.100-FF-000025', NULL, NULL, 117, NULL, NULL, 35818),
(35819, '3.90.1440.10-FF-000010', NULL, 'Preprotein translocase subunit SecA', 133, NULL, NULL, 35819),
(35820, '3.10.350.10-FF-000027', NULL, 'LysM peptidoglycan-binding domain-containing protein', 64, NULL, NULL, 35820),
(35821, '3.30.1240.10-FF-000036', NULL, 'Cof-type HAD-IIB family hydrolase', 100, NULL, NULL, 35821),
(35822, '3.40.50.300-FF-001647', NULL, 'Extra-large guanine nucleotide-binding protein 1', 219, NULL, NULL, 35822),
(35823, '3.40.50.300-FF-005936', NULL, 'Putative pre-mRNA-splicing factor ATP-dependent RNA helicase PRP1', 83, NULL, NULL, 35823),
(35824, '1.10.510.10-FF-000093', NULL, 'Hepatocyte growth factor receptor', 193, NULL, NULL, 35824),
(35825, '3.30.160.60-FF-001484', NULL, 'Uncharacterized protein, isoform B', 63, NULL, NULL, 35825),
(35826, '3.30.710.10-FF-000348', NULL, 'BTB (POZ) domain-containing 3a', 80, NULL, NULL, 35826),
(35827, '2.60.40.10-FF-004362', NULL, NULL, 101, NULL, NULL, 35827),
(35828, '3.50.50.60-FF-000952', NULL, 'Slr0734 protein', 207, NULL, NULL, 35828),
(35829, '4.10.970.10-FF-000008', NULL, 'Putative KU70 protein', 67, NULL, NULL, 35829),
(35830, '2.60.120.920-FF-000148', NULL, 'Uncharacterized protein', 175, NULL, NULL, 35830),
(35831, '3.100.10.10-FF-000015', NULL, '60S ribosomal protein L27A/L29', 88, NULL, NULL, 35831),
(35832, '3.30.1160.10-FF-000002', NULL, 'Cyanate hydratase', 67, NULL, NULL, 35832),
(35833, '1.25.40.10-FF-002332', NULL, 'general transcription factor 3C polypeptide 3', 304, NULL, NULL, 35833),
(35834, '3.30.450.20-FF-000185', NULL, 'Sensory transduction histidine kinase', 130, NULL, NULL, 35834),
(35835, '3.40.50.1010-FF-000174', NULL, NULL, 201, NULL, NULL, 35835),
(35836, '3.30.450.20-FF-000527', NULL, 'Guanylate cyclase', 139, NULL, NULL, 35836),
(35837, '3.30.70.330-FF-002079', NULL, NULL, 78, NULL, NULL, 35837),
(35838, '3.30.160.20-FF-000090', NULL, 'ATP-dependent RNA helicase A isoform X2', 50, NULL, NULL, 35838),
(35839, '2.10.25.10-FF-000389', NULL, 'slit homolog 1 protein', 40, NULL, NULL, 35839),
(35840, '1.20.1560.10-FF-000238', NULL, 'Multidrug resistance-associated protein, putative', 337, NULL, NULL, 35840),
(35841, '2.60.120.200-FF-000258', NULL, 'Uncharacterized protein, isoform B', 151, NULL, NULL, 35841),
(35842, '3.40.710.10-FF-000071', NULL, 'Probable D-alanyl-D-alanine carboxypeptidase dacB2', 269, NULL, NULL, 35842),
(35843, '2.130.10.10-FF-002541', NULL, 'Sensor histidine kinase TodS', 329, NULL, NULL, 35843),
(35844, '1.25.50.20-FF-000037', NULL, 'Aminopeptidase', 110, NULL, NULL, 35844),
(35845, '3.30.200.20-FF-001667', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 1', 116, NULL, NULL, 35845),
(35846, '1.10.8.60-FF-000551', NULL, 'Uncharacterized protein', 60, NULL, NULL, 35846),
(35847, '2.10.25.10-FF-001013', NULL, 'Predicted protein', 38, NULL, NULL, 35847),
(35848, '3.40.50.620-FF-000687', NULL, 'tRNA(Ile)-lysidine synthase MesJ', 314, NULL, NULL, 35848),
(35849, '2.60.40.1090-FF-000013', NULL, 'FimI fimbrial protein', 151, NULL, NULL, 35849),
(35850, '3.90.780.10-FF-000002', NULL, 'Bifunctional 2'',3''-cyclic-nucleotide 2''-phosphodiesterase/3''-nucleotidase', 232, NULL, NULL, 35850),
(35851, '3.80.10.10-FF-002620', NULL, 'Phosphatase, putative', 191, NULL, NULL, 35851),
(35852, '2.40.270.10-FF-000035', NULL, NULL, 122, NULL, NULL, 35852),
(35853, '1.10.3860.10-FF-000028', NULL, 'Neutral Amino Acid (Glutamate) Transporter', 395, NULL, NULL, 35853),
(35854, '3.60.40.10-FF-000375', NULL, 'Uncharacterized protein', 93, NULL, NULL, 35854),
(35855, '3.80.10.10-FF-003132', NULL, 'Uncharacterized protein', 71, NULL, NULL, 35855),
(35856, '1.25.40.20-FF-000300', NULL, 'S-acyltransferase', 131, NULL, NULL, 35856);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(35857, '1.20.58.1040-FF-000002', NULL, 'Glucan endo-1,3-beta-glucosidase 8', 98, NULL, NULL, 35857),
(35858, '1.20.120.1240-FF-000008', NULL, 'dynamin-3 isoform X1', 201, NULL, NULL, 35858),
(35859, '3.90.1150.10-FF-000139', NULL, 'Glycine cleavage system P protein', 134, NULL, NULL, 35859),
(35860, '3.40.50.720-FF-000947', NULL, 'C-terminal binding protein AN', 95, NULL, NULL, 35860),
(35861, '3.80.10.10-FF-001327', NULL, 'Os08g0459100 protein', 330, NULL, NULL, 35861),
(35862, '1.10.10.350-FF-000039', NULL, NULL, 104, NULL, NULL, 35862),
(35863, '4.10.70.10-FF-000005', NULL, 'Zinc metalloproteinase/disintegrin', 69, NULL, NULL, 35863),
(35864, '3.30.420.10-FF-000596', NULL, NULL, 196, NULL, NULL, 35864),
(35865, '3.40.50.10380-FF-000027', NULL, 'NAD-dependent malic enzyme', 252, NULL, NULL, 35865),
(35866, '3.40.1690.10-FF-000011', NULL, 'Flagellar biosynthetic protein FlhB', 138, NULL, NULL, 35866),
(35867, '1.25.10.10-FF-002504', NULL, 'USO1 vesicle transport factor', 201, NULL, NULL, 35867),
(35868, '1.20.120.20-FF-000007', NULL, 'Apolipoprotein A-IV a', 132, NULL, NULL, 35868),
(35869, '3.20.20.140-FF-000120', NULL, 'Amidohydrolase', 308, NULL, NULL, 35869),
(35870, '3.10.20.600-FF-000007', NULL, 'NAD-reducing hydrogenase subunit HoxF', 95, NULL, NULL, 35870),
(35871, '1.20.58.1060-FF-000008', NULL, 'Uncharacterized protein', 55, NULL, NULL, 35871),
(35872, '1.10.238.10-FF-000515', NULL, 'ITSN (Intersectin) family', 107, NULL, NULL, 35872),
(35873, '2.130.10.10-FF-004918', NULL, 'Predicted protein', 108, NULL, NULL, 35873),
(35874, '3.40.50.1360-FF-000025', NULL, '6-phosphogluconolactonase', 233, NULL, NULL, 35874),
(35875, '3.90.1170.10-FF-000011', NULL, 'Mitochondrial ribosomal protein L16, putative', 169, NULL, NULL, 35875),
(35876, '3.40.50.300-FF-005251', NULL, 'YALI0C14168p', 189, NULL, NULL, 35876),
(35877, '1.10.287.110-FF-000226', NULL, 'Uncharacterized protein', 61, NULL, NULL, 35877),
(35878, '3.40.50.460-FF-000037', NULL, 'Uncharacterized protein', 80, NULL, NULL, 35878),
(35879, '3.40.50.720-FF-000604', NULL, 'Oxidoreductase, short-chain dehydrogenase family, putative', 294, NULL, NULL, 35879),
(35880, '3.30.160.60-FF-005666', NULL, NULL, 28, NULL, NULL, 35880),
(35881, '1.10.510.10-FF-003521', NULL, NULL, 244, NULL, NULL, 35881),
(35882, '1.10.287.470-FF-000076', NULL, 'Acriflavin resistance periplasmic protein', 60, NULL, NULL, 35882),
(35883, '2.40.20.10-FF-000045', NULL, 'Uncharacterized protein', 92, NULL, NULL, 35883),
(35884, '1.20.1720.10-FF-000122', NULL, NULL, 269, NULL, NULL, 35884),
(35885, '3.30.200.20-FF-001324', NULL, 'Protein kinase, putative', 103, NULL, NULL, 35885),
(35886, '3.30.450.60-FF-000062', NULL, 'AP-4 complex subunit sigma isoform A', 113, NULL, NULL, 35886),
(35887, '2.130.10.10-FF-004576', NULL, 'GATOR complex protein MIOS', 210, NULL, NULL, 35887),
(35888, '3.20.20.70-FF-000820', NULL, NULL, 253, NULL, NULL, 35888),
(35889, '3.40.50.300-FF-004975', NULL, 'ABC transporter family protein', 262, NULL, NULL, 35889),
(35890, '1.10.8.60-FF-000096', NULL, 'sigma-54-dependent Fis family transcriptional regulator', 81, NULL, NULL, 35890),
(35891, '1.25.40.20-FF-001380', NULL, 'Uncharacterized protein', 78, NULL, NULL, 35891),
(35892, '3.60.10.10-FF-000204', NULL, 'Endonuclease/Exonuclease/phosphatase family protein', 310, NULL, NULL, 35892),
(35893, '3.40.50.10680-FF-000004', NULL, '2-phospho-L-lactate transferase', 144, NULL, NULL, 35893),
(35894, '2.60.120.1020-FF-000009', NULL, 'Uncharacterized protein', 180, NULL, NULL, 35894),
(35895, '1.10.510.10-FF-002228', NULL, 'Uncharacterized protein', 271, NULL, NULL, 35895),
(35896, '2.60.40.10-FF-000995', NULL, 'prostaglandin F2 receptor negative regulator', 123, NULL, NULL, 35896),
(35897, '2.120.10.30-FF-000035', NULL, 'Low-density lipoprotein receptor-related protein 2', 303, NULL, NULL, 35897),
(35898, '2.30.29.30-FF-000094', NULL, 'Rho guanine nucleotide exchange factor 7', 126, NULL, NULL, 35898),
(35899, '1.20.1070.10-FF-000268', NULL, 'Putative olfactory receptor 2I1', 289, NULL, NULL, 35899);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(35900, '3.40.30.10-FF-001229', NULL, 'Uncharacterized protein', 113, NULL, NULL, 35900),
(35901, '1.10.268.10-FF-000006', NULL, 'DNA topoisomerase 2', 170, NULL, NULL, 35901),
(35902, '2.40.30.10-FF-000102', NULL, 'Translation elongation factor Tu', 93, NULL, NULL, 35902),
(35903, '3.40.720.10-FF-000139', NULL, 'Galactosamine (N-acetyl)-6-sulfatase', 196, NULL, NULL, 35903),
(35904, '2.10.25.10-FF-000052', NULL, 'low-density lipoprotein receptor isoform X1', 52, NULL, NULL, 35904),
(35905, '3.30.160.60-FF-005773', NULL, NULL, 30, NULL, NULL, 35905),
(35906, '1.25.40.10-FF-003636', NULL, 'Tetratricopeptide repeat protein 21B', 130, NULL, NULL, 35906),
(35907, '1.10.3730.20-FF-000033', NULL, 'Drug/metabolite transporter permease', 138, NULL, NULL, 35907),
(35908, '3.20.140.10-FF-000043', NULL, 'Uncharacterized protein', 95, NULL, NULL, 35908),
(35909, '2.10.50.10-FF-000014', NULL, 'Tumor necrosis factor receptor superfamily member 11B', 53, NULL, NULL, 35909),
(35910, '2.10.90.10-FF-000011', NULL, 'Glycoprotein hormones alpha chain', 92, NULL, NULL, 35910),
(35911, '2.10.25.10-FF-000956', NULL, 'Wall-associated receptor kinase 3', 32, NULL, NULL, 35911),
(35912, '1.20.1560.10-FF-000694', NULL, 'Uncharacterized protein', 383, NULL, NULL, 35912),
(35913, '3.10.110.10-FF-000369', NULL, 'Uncharacterized protein', 227, NULL, NULL, 35913),
(35914, '3.80.10.10-FF-000259', NULL, 'Leucine-rich repeat-containing protein 10', 101, NULL, NULL, 35914),
(35915, '3.60.40.10-FF-000032', NULL, 'Protein phosphatase, Mg2+/Mn2+-dependent, 1F', 268, NULL, NULL, 35915),
(35916, '1.10.238.10-FF-001134', NULL, 'Uncharacterized protein', 157, NULL, NULL, 35916),
(35917, '3.10.150.10-FF-000023', NULL, 'Beta sliding clamp', 122, NULL, NULL, 35917),
(35918, '3.80.10.10-FF-003800', NULL, 'Uncharacterized protein', 90, NULL, NULL, 35918),
(35919, '1.25.40.10-FF-003512', NULL, 'Uncharacterized protein', 239, NULL, NULL, 35919),
(35920, '2.60.40.150-FF-000122', NULL, 'E3 ubiquitin-protein ligase', 140, NULL, NULL, 35920),
(35921, '1.10.630.10-FF-000832', NULL, 'Uncharacterized protein', 223, NULL, NULL, 35921),
(35922, '3.40.430.10-FF-000044', NULL, 'Chromosome 8, whole genome shotgun sequence', 200, NULL, NULL, 35922),
(35923, '3.40.50.150-FF-000731', NULL, 'Polyamine aminopropyltransferase', 229, NULL, NULL, 35923),
(35924, '1.20.1560.10-FF-000019', NULL, 'Cystic fibrosis transmembrane conductance regulator', 351, NULL, NULL, 35924),
(35925, '3.30.420.60-FF-000015', NULL, 'Uncharacterized protein', 143, NULL, NULL, 35925),
(35926, '2.60.40.60-FF-000077', NULL, 'Protocadherin-11 X-linked', 101, NULL, NULL, 35926),
(35927, '1.10.630.10-FF-000484', NULL, 'Uncharacterized protein', 472, NULL, NULL, 35927),
(35928, '4.10.60.10-FF-000179', NULL, 'Predicted protein', 45, NULL, NULL, 35928),
(35929, '3.30.40.10-FF-002085', NULL, 'Putative RING zinc finger protein; 84572-85321', 85, NULL, NULL, 35929),
(35930, '3.30.200.20-FF-000493', NULL, 'Cyclin-dependent kinase 8', 56, NULL, NULL, 35930),
(35931, '1.20.58.390-FF-000067', NULL, 'Glycine receptor subunit alpha-2', 134, NULL, NULL, 35931),
(35932, '1.10.260.40-FF-000093', NULL, 'Pou4f2', 59, NULL, NULL, 35932),
(35933, '3.30.530.20-FF-000023', NULL, 'Acyl-CoA thioesterase 12', 248, NULL, NULL, 35933),
(35934, '1.10.510.10-FF-000778', NULL, 'Kinase family protein', 283, NULL, NULL, 35934),
(35935, '3.30.1520.10-FF-000193', NULL, 'Uncharacterized protein', 60, NULL, NULL, 35935),
(35936, '1.20.1070.10-FF-001229', NULL, 'Uncharacterized protein', 153, NULL, NULL, 35936),
(35937, '2.10.110.10-FF-000120', NULL, 'Insulin gene enhancer protein ISL-2', 62, NULL, NULL, 35937),
(35938, '1.10.1070.11-FF-000098', NULL, 'PIKK family atypical protein kinase', 183, NULL, NULL, 35938),
(35939, '1.25.40.20-FF-001609', NULL, 'Predicted protein', 107, NULL, NULL, 35939),
(35940, '1.10.472.10-FF-000430', NULL, 'Cyclin G1', 25, NULL, NULL, 35940),
(35941, '3.30.160.20-FF-000207', NULL, 'Uncharacterized protein', 76, NULL, NULL, 35941),
(35942, '1.10.400.10-FF-000096', NULL, 'Uncharacterized protein', 119, NULL, NULL, 35942);
INSERT INTO "PUBLIC"."MODEL" VALUES
(35943, '2.10.220.10-FF-000016', NULL, 'Receptor tyrosine-protein kinase erbB-3', 106, NULL, NULL, 35943),
(35944, '1.10.510.10-FF-001267', NULL, 'Uncharacterized protein', 341, NULL, NULL, 35944),
(35945, '3.40.50.300-FF-001884', NULL, 'Elongation factor 3 related protein', 267, NULL, NULL, 35945),
(35946, '3.30.1370.50-FF-000029', NULL, 'FI18001p1', 80, NULL, NULL, 35946),
(35947, '3.30.780.10-FF-000066', NULL, 'Uncharacterized protein', 75, NULL, NULL, 35947),
(35948, '1.10.12.70-FF-000008', NULL, 'Serine/threonine protein kinase MST4, putative', 63, NULL, NULL, 35948),
(35949, '2.30.30.1190-FF-000005', NULL, 'Zinc finger CCCH domain-containing protein 37', 49, NULL, NULL, 35949),
(35950, '3.20.20.140-FF-000238', NULL, 'Ethylammeline chlorohydrolase', 314, NULL, NULL, 35950),
(35951, '3.30.70.1450-FF-000038', NULL, 'Predicted protein', 74, NULL, NULL, 35951),
(35952, '3.30.160.60-FF-003069', NULL, 'Uncharacterized protein', 33, NULL, NULL, 35952),
(35953, '2.30.30.100-FF-000117', NULL, 'U6 snRNA-associated Sm-like protein LSm5p', 85, NULL, NULL, 35953),
(35954, '2.10.10.10-FF-000012', NULL, 'Lymphocyte antigen 75', 60, NULL, NULL, 35954),
(35955, '2.10.70.10-FF-000027', NULL, 'Fibronectin 1', 42, NULL, NULL, 35955),
(35956, '3.30.160.60-FF-002900', NULL, 'Zinc finger protein 20', 25, NULL, NULL, 35956),
(35957, '2.10.25.10-FF-000737', NULL, 'Fat-like cadherin-related tumor suppressor homolog', 40, NULL, NULL, 35957),
(35958, '1.20.58.190-FF-000013', NULL, NULL, 143, NULL, NULL, 35958),
(35959, '3.50.50.60-FF-000733', NULL, 'FAD-dependent pyridine nucleotide-disulphide oxidoreductase', 56, NULL, NULL, 35959),
(35960, '1.10.10.10-FF-001599', NULL, 'Caffeic acid 3-O-methyltransferase', 106, NULL, NULL, 35960),
(35961, '3.10.400.20-FF-000006', NULL, 'Translation machinery-associated protein 20', 191, NULL, NULL, 35961),
(35962, '3.30.950.10-FF-000001', NULL, 'Siroheme synthase', 134, NULL, NULL, 35962),
(35963, '1.10.555.10-FF-000179', NULL, NULL, 83, NULL, NULL, 35963),
(35964, '1.25.10.10-FF-001330', NULL, 'Coatomer subunit beta', 493, NULL, NULL, 35964),
(35965, '2.30.30.110-FF-000002', NULL, 'Toxin MazF5', 102, NULL, NULL, 35965),
(35966, '2.30.29.30-FF-000217', NULL, 'Rho GTPase activating protein 20', 104, NULL, NULL, 35966),
(35967, '1.10.150.50-FF-000099', NULL, 'EPH receptor B2', 50, NULL, NULL, 35967),
(35968, '3.50.50.60-FF-000391', NULL, 'Pyridine nucleotide-disulfide oxidoreductase, putative', 100, NULL, NULL, 35968),
(35969, '2.130.10.10-FF-003165', NULL, 'Uncharacterized protein', 245, NULL, NULL, 35969),
(35970, '3.40.50.720-FF-000262', NULL, '3 beta-hydroxysteroid dehydrogenase type 7 isoform X1', 364, NULL, NULL, 35970),
(35971, '2.120.10.80-FF-000140', NULL, 'Uncharacterized protein, isoform C', 229, NULL, NULL, 35971),
(35972, '3.20.20.120-FF-000013', NULL, 'Mandelate racemase/muconate lactonizing enzyme family protein', 244, NULL, NULL, 35972),
(35973, '1.10.1070.11-FF-000103', NULL, 'Putative phosphatidylinositol kinase', 204, NULL, NULL, 35973),
(35974, '1.10.630.10-FF-000702', NULL, 'Uncharacterized protein', 125, NULL, NULL, 35974),
(35975, '2.130.10.10-FF-002889', NULL, 'Uncharacterized protein', 147, NULL, NULL, 35975),
(35976, '3.40.50.2300-FF-000364', NULL, 'Uncharacterized protein', 130, NULL, NULL, 35976),
(35977, '3.50.50.60-FF-001222', NULL, 'Uncharacterized protein', 257, NULL, NULL, 35977),
(35978, '1.25.40.90-FF-000063', NULL, 'Putative clathrin coat assembly protein', 157, NULL, NULL, 35978),
(35979, '2.60.40.60-FF-001038', NULL, 'Uncharacterized protein', 115, NULL, NULL, 35979),
(35980, '3.40.50.150-FF-001350', NULL, NULL, 192, NULL, NULL, 35980),
(35981, '1.10.287.70-FF-000585', NULL, 'RE56935p', 46, NULL, NULL, 35981),
(35982, '3.40.50.1100-FF-000094', NULL, 'Cysteine synthase protein', 128, NULL, NULL, 35982),
(35983, '1.20.1250.20-FF-000257', NULL, 'monocarboxylate transporter 7 isoform X1', 392, NULL, NULL, 35983),
(35984, '2.130.10.10-FF-001703', NULL, 'Semaphorin 4e', 474, NULL, NULL, 35984),
(35985, '3.40.50.2300-FF-001201', NULL, NULL, 101, NULL, NULL, 35985);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(35986, '3.40.350.10-FF-000094', NULL, 'Glr3482 protein', 158, NULL, NULL, 35986),
(35987, '2.30.40.10-FF-000013', NULL, 'Isoaspartyl dipeptidase', 100, NULL, NULL, 35987),
(35988, '1.10.1670.10-FF-000075', NULL, NULL, 16, NULL, NULL, 35988),
(35989, '2.60.40.10-FF-003417', NULL, NULL, 111, NULL, NULL, 35989),
(35990, '1.20.58.340-FF-000075', NULL, 'Uncharacterized protein', 76, NULL, NULL, 35990),
(35991, '3.90.540.10-FF-000001', NULL, 'Colicin-E9', 134, NULL, NULL, 35991),
(35992, '3.10.450.10-FF-000063', NULL, 'Si:ch211-284e20.8', 108, NULL, NULL, 35992),
(35993, '3.40.50.300-FF-001209', NULL, 'ABC transporter, ATP-binding protein', 231, NULL, NULL, 35993),
(35994, '2.60.40.10-FF-004710', NULL, NULL, 87, NULL, NULL, 35994),
(35995, '3.40.50.300-FF-008235', NULL, 'GTP binding protein 3, mitochondrial', 57, NULL, NULL, 35995),
(35996, '1.10.287.380-FF-000043', NULL, 'Valine--tRNA ligase', 69, NULL, NULL, 35996),
(35997, '1.10.640.10-FF-000097', NULL, 'Uncharacterized protein', 259, NULL, NULL, 35997),
(35998, '1.10.287.40-FF-000025', NULL, 'Serine--tRNA ligase', 49, NULL, NULL, 35998),
(35999, '3.40.50.2300-FF-000577', NULL, 'GLutamate Receptor family (AMPA)', 146, NULL, NULL, 35999),
(36000, '3.30.160.60-FF-005323', NULL, NULL, 76, NULL, NULL, 36000),
(36001, '3.30.559.30-FF-000002', NULL, 'Nonribosomal peptide synthase Pes1', 271, NULL, NULL, 36001),
(36002, '3.40.50.300-FF-003918', NULL, 'Adenylate kinase, putative', 211, NULL, NULL, 36002),
(36003, '1.20.1070.10-FF-001679', NULL, 'Si:dkey-42l23.1', 117, NULL, NULL, 36003),
(36004, '3.70.10.10-FF-000119', NULL, 'Uncharacterized protein', 174, NULL, NULL, 36004),
(36005, '3.40.50.1820-FF-001720', NULL, 'Serine carboxypeptidase-like 33', 126, NULL, NULL, 36005),
(36006, '2.60.40.10-FF-003980', NULL, NULL, 103, NULL, NULL, 36006),
(36007, '1.10.510.10-FF-004488', NULL, NULL, 240, NULL, NULL, 36007),
(36008, '3.10.620.10-FF-000003', NULL, 'WDYHV motif containing 1', 57, NULL, NULL, 36008),
(36009, '2.70.150.10-FF-000289', NULL, 'Phospholipid-transporting ATPase', 110, NULL, NULL, 36009),
(36010, '3.90.660.10-FF-000055', NULL, NULL, 105, NULL, NULL, 36010),
(36011, '2.30.130.10-FF-000021', NULL, 'Glutamate 5-kinase', 92, NULL, NULL, 36011),
(36012, '1.10.287.1490-FF-000023', NULL, 'WD repeat-containing protein 65', 120, NULL, NULL, 36012),
(36013, '2.160.20.10-FF-000101', NULL, 'Glycoside hydrolase family 55 protein', 368, NULL, NULL, 36013),
(36014, '3.90.70.80-FF-000042', NULL, 'OTU-like cysteine protease, putative', 127, NULL, NULL, 36014),
(36015, '3.10.620.30-FF-000009', NULL, 'Peptide-N4-(N-acetyl-beta-glucosaminyl)asparagine amidase', 154, NULL, NULL, 36015),
(36016, '1.10.357.70-FF-000012', NULL, 'Exocyst complex component 3', 178, NULL, NULL, 36016),
(36017, '3.40.50.720-FF-001329', NULL, 'L-2,3-butanediol dehydrogenase', 258, NULL, NULL, 36017),
(36018, '2.60.200.20-FF-000214', NULL, 'Uncharacterized protein', 119, NULL, NULL, 36018),
(36019, '2.20.70.10-FF-000268', NULL, 'Rho GTPase-activating protein 27', 38, NULL, NULL, 36019),
(36020, '3.30.70.2850-FF-000020', NULL, 'DNA-directed RNA polymerase I 190 kDa polypeptide-related protein', 186, NULL, NULL, 36020),
(36021, '3.30.450.20-FF-000657', NULL, 'Sensory transduction histidine kinase', 115, NULL, NULL, 36021),
(36022, '1.10.510.10-FF-003976', NULL, NULL, 331, NULL, NULL, 36022),
(36023, '2.60.120.10-FF-000059', NULL, 'jmjC domain-containing protein 7', 312, NULL, NULL, 36023),
(36024, '3.15.10.10-FF-000005', NULL, 'BPI fold containing family B member 2', 158, NULL, NULL, 36024),
(36025, '3.40.50.150-FF-000282', NULL, 'Carnosine N-methyltransferase', 229, NULL, NULL, 36025),
(36026, '3.30.460.10-FF-000149', NULL, 'DNA polymerase sigma-like protein', 139, NULL, NULL, 36026),
(36027, '2.70.20.10-FF-000010', NULL, 'DNA topoisomerase I', 128, NULL, NULL, 36027),
(36028, '3.40.50.720-FF-000823', NULL, 'Undecaprenyl-phosphate glucose phosphotransferase', 120, NULL, NULL, 36028),
(36029, '3.20.20.190-FF-000106', NULL, NULL, 128, NULL, NULL, 36029),
(36030, '2.130.10.10-FF-004126', NULL, 'Uncharacterized protein', 186, NULL, NULL, 36030);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(36031, '4.10.1000.10-FF-000079', NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', 29, NULL, NULL, 36031),
(36032, '3.30.1330.90-FF-000016', NULL, 'D-3-phosphoglycerate dehydrogenase', 134, NULL, NULL, 36032),
(36033, '2.130.10.10-FF-000866', NULL, 'Nucleolar protein 10', 183, NULL, NULL, 36033),
(36034, '3.30.1360.120-FF-000056', NULL, 'Aminomethyltransferase', 152, NULL, NULL, 36034),
(36035, '1.20.1050.10-FF-000048', NULL, 'Glutathione S-transferase', 122, NULL, NULL, 36035),
(36036, '2.60.40.10-FF-005093', NULL, NULL, 99, NULL, NULL, 36036),
(36037, '3.40.630.30-FF-000582', NULL, 'Uncharacterized protein', 94, NULL, NULL, 36037),
(36038, '3.40.50.300-FF-001777', NULL, 'Os10g0117800 protein', 158, NULL, NULL, 36038),
(36039, '1.10.510.10-FF-000323', NULL, 'TP53-regulating kinase, putative', 120, NULL, NULL, 36039),
(36040, '2.90.10.10-FF-000008', NULL, 'Serine/threonine-protein kinase', 119, NULL, NULL, 36040),
(36041, '3.30.470.20-FF-000080', NULL, 'Glutathione synthetase', 53, NULL, NULL, 36041),
(36042, '4.10.860.20-FF-000003', NULL, 'rabenosyn-5 isoform X1', 59, NULL, NULL, 36042),
(36043, '1.10.1520.10-FF-000070', NULL, 'Uncharacterized protein', 195, NULL, NULL, 36043),
(36044, '3.10.20.90-FF-000551', NULL, 'Auxin-responsive protein', 103, NULL, NULL, 36044),
(36045, '3.30.160.60-FF-001271', NULL, 'Zinc finger protein 282', 28, NULL, NULL, 36045),
(36046, '1.10.150.110-FF-000002', NULL, 'DNA polymerase beta', 91, NULL, NULL, 36046),
(36047, '2.130.10.10-FF-001378', NULL, 'FI05482p', 90, NULL, NULL, 36047),
(36048, '2.60.40.3510-FF-000032', NULL, 'Delta-like protein', 71, NULL, NULL, 36048),
(36049, '1.10.40.30-FF-000016', NULL, 'Aspartate ammonium lyase', 58, NULL, NULL, 36049),
(36050, '1.10.150.130-FF-000008', NULL, 'Site-specific recombinase IntI4', 94, NULL, NULL, 36050),
(36051, '1.25.40.10-FF-002787', NULL, 'Os01g0600400 protein', 132, NULL, NULL, 36051),
(36052, '1.10.630.10-FF-000377', NULL, '1,8-cineole 2-endo-monooxygenase', 398, NULL, NULL, 36052),
(36053, '1.10.10.60-FF-000855', NULL, NULL, 57, NULL, NULL, 36053),
(36054, '1.25.40.800-FF-000007', NULL, 'Cdc39p', 230, NULL, NULL, 36054),
(36055, '3.10.450.700-FF-000009', NULL, 'Pur alpha Like Protein', 73, NULL, NULL, 36055),
(36056, '3.40.50.1010-FF-000286', NULL, NULL, 234, NULL, NULL, 36056),
(36057, '3.90.640.10-FF-000060', NULL, 'Actin-related protein 5', 78, NULL, NULL, 36057),
(36058, '3.40.1380.20-FF-000036', NULL, 'Pyruvate kinase', 123, NULL, NULL, 36058),
(36059, '1.10.8.60-FF-000421', NULL, 'Werner helicase interacting protein, putative (Fragment)', 96, NULL, NULL, 36059),
(36060, '3.30.390.30-FF-000025', NULL, 'Glutathione-disulfide reductase', 112, NULL, NULL, 36060),
(36061, '2.40.340.10-FF-000029', NULL, NULL, 63, NULL, NULL, 36061),
(36062, '1.50.40.10-FF-000470', NULL, 'Uncharacterized protein', 63, NULL, NULL, 36062),
(36063, '3.30.720.150-FF-000008', NULL, 'Predicted protein', 89, NULL, NULL, 36063),
(36064, '2.60.40.10-FF-002344', NULL, 'KETtiN (Drosophila actin-binding) homolog', 96, NULL, NULL, 36064),
(36065, '3.30.10.20-FF-000012', NULL, 'Serine/threonine-protein kinase StkP', 70, NULL, NULL, 36065),
(36066, '1.10.101.10-FF-000024', NULL, 'Murein L,D-transpeptidase', 78, NULL, NULL, 36066),
(36067, '1.20.120.1900-FF-000010', NULL, 'Gamma-tubulin complex component', 326, NULL, NULL, 36067),
(36068, '1.10.540.10-FF-000151', NULL, 'Uncharacterized protein', 41, NULL, NULL, 36068),
(36069, '3.90.230.10-FF-000028', NULL, 'Methionine aminopeptidase', 256, NULL, NULL, 36069),
(36070, '1.20.58.2220-FF-000047', NULL, 'Formin-like protein 12', 298, NULL, NULL, 36070),
(36071, '1.10.238.160-FF-000001', NULL, 'Response regulator inhibitor for tor operon', 58, NULL, NULL, 36071),
(36072, '3.40.50.2300-FF-001089', NULL, 'Uncharacterized protein', 302, NULL, NULL, 36072),
(36073, '1.20.144.10-FF-000121', NULL, 'Uncharacterized protein', 192, NULL, NULL, 36073),
(36074, '3.30.160.60-FF-001956', NULL, 'ZFP37 zinc finger protein', 28, NULL, NULL, 36074),
(36075, '3.30.160.60-FF-005542', NULL, NULL, 40, NULL, NULL, 36075);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(36076, '2.40.50.90-FF-000071', NULL, 'tudor domain-containing protein 6 isoform X1', 63, NULL, NULL, 36076),
(36077, '1.20.120.1630-FF-000018', NULL, 'Protein-S-isoprenylcysteine O-methyltransferase', 192, NULL, NULL, 36077),
(36078, '3.40.50.300-FF-000248', NULL, 'Mitochondrial Rho GTPase', 102, NULL, NULL, 36078),
(36079, '3.30.160.60-FF-003412', NULL, 'LD29879p', 70, NULL, NULL, 36079),
(36080, '3.40.33.10-FF-000073', NULL, 'IP19912p', 146, NULL, NULL, 36080),
(36081, '1.10.10.10-FF-001942', NULL, 'Transcription factor E', 85, NULL, NULL, 36081),
(36082, '3.30.70.2190-FF-000013', NULL, 'FAD-binding oxidoreductase', 117, NULL, NULL, 36082),
(36083, '3.30.160.60-FF-006048', NULL, NULL, 50, NULL, NULL, 36083),
(36084, '3.40.50.150-FF-001804', NULL, NULL, 121, NULL, NULL, 36084),
(36085, '2.40.10.10-FF-000668', NULL, NULL, 50, NULL, NULL, 36085),
(36086, '3.40.50.2000-FF-000594', NULL, 'GDP-Man:Man(3)GlcNAc(2)-PP-Dol alpha-1,2-mannosyltransferase', 212, NULL, NULL, 36086),
(36087, '3.40.50.300-FF-000580', NULL, 'uronyl 2-sulfotransferase', 273, NULL, NULL, 36087),
(36088, '1.25.40.20-FF-001267', NULL, 'Uncharacterized protein', 315, NULL, NULL, 36088),
(36089, '3.40.50.1980-FF-000104', NULL, 'Nitrogenase MoFe cofactor biosynthesis protein NifN', 124, NULL, NULL, 36089),
(36090, '3.40.50.1820-FF-000989', NULL, 'AaceriACR149Cp', 248, NULL, NULL, 36090),
(36091, '2.130.10.10-FF-003614', NULL, 'Transducin beta-like protein 3', 88, NULL, NULL, 36091),
(36092, '2.40.30.10-FF-000091', NULL, 'NADPH oxidase (NoxA), putative', 93, NULL, NULL, 36092),
(36093, '2.40.10.350-FF-000017', NULL, 'Glr4400 protein', 74, NULL, NULL, 36093),
(36094, '3.20.20.70-FF-000241', NULL, 'Orotidine 5''-phosphate decarboxylase', 323, NULL, NULL, 36094),
(36095, '2.40.50.140-FF-001221', NULL, NULL, 67, NULL, NULL, 36095),
(36096, '2.130.10.120-FF-000022', NULL, 'Uncharacterized protein', 119, NULL, NULL, 36096),
(36097, '1.25.40.10-FF-001495', NULL, 'Pentatricopeptide repeat-containing protein At3g13880', 153, NULL, NULL, 36097),
(36098, '1.25.40.10-FF-000657', NULL, 'U3 small nucleolar RNA-associated protein 6', 178, NULL, NULL, 36098),
(36099, '3.30.70.240-FF-000023', NULL, 'Sdo1p', 78, NULL, NULL, 36099),
(36100, '1.25.40.10-FF-003405', NULL, 'Pentatricopeptide repeat-containing protein', 127, NULL, NULL, 36100),
(36101, '1.10.220.150-FF-000076', NULL, 'Uncharacterized protein', 79, NULL, NULL, 36101),
(36102, '3.40.50.800-FF-000061', NULL, 'Threonyl-tRNA synthetase editing domain protein', 113, NULL, NULL, 36102),
(36103, '1.10.510.10-FF-001739', NULL, 'CMGC family protein kinase', 258, NULL, NULL, 36103),
(36104, '1.20.1250.20-FF-001893', NULL, 'Uncharacterized protein', 74, NULL, NULL, 36104),
(36105, '3.30.70.270-FF-000127', NULL, 'CRISPR-associated protein cas10/csm1, subtype III-a/mtube', 166, NULL, NULL, 36105),
(36106, '1.10.2010.10-FF-000003', NULL, 'Protein CBG26136', 66, NULL, NULL, 36106),
(36107, '3.40.50.360-FF-000120', NULL, 'NADPH--cytochrome p450 reductase, putative', 193, NULL, NULL, 36107),
(36108, '1.20.910.10-FF-000019', NULL, 'Aminopyrimidine aminohydrolase', 217, NULL, NULL, 36108),
(36109, '3.30.200.20-FF-000942', NULL, 'Non-specific serine/threonine protein kinase', 37, NULL, NULL, 36109),
(36110, '3.10.310.70-FF-000003', NULL, 'Amidohydrolase family protein', 120, NULL, NULL, 36110),
(36111, '2.30.30.100-FF-000229', NULL, 'Small nuclear ribonucleoprotein Sm D2', 50, NULL, NULL, 36111),
(36112, '3.30.70.1730-FF-000015', NULL, 'Mrpl11p', 141, NULL, NULL, 36112),
(36113, '3.80.10.10-FF-004312', NULL, 'Cyclic GMP-binding protein C', 212, NULL, NULL, 36113),
(36114, '1.10.10.440-FF-000066', NULL, 'YALI0C19404p', 54, NULL, NULL, 36114),
(36115, '3.30.420.10-FF-000141', NULL, 'Ribonuclease H', 136, NULL, NULL, 36115),
(36116, '1.10.510.10-FF-001846', NULL, 'Protein kinase superfamily protein', 105, NULL, NULL, 36116),
(36117, '3.40.50.720-FF-002280', NULL, 'Uncharacterized protein', 243, NULL, NULL, 36117),
(36118, '1.25.10.10-FF-001673', NULL, 'Uncharacterized protein', 312, NULL, NULL, 36118),
(36119, '1.20.120.140-FF-000008', NULL, 'Signal recognition particle receptor FtsY', 98, NULL, NULL, 36119);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(36120, '3.90.1420.10-FF-000008', NULL, 'SET domain containing 4', 140, NULL, NULL, 36120),
(36121, '2.30.29.30-FF-000442', NULL, 'Target of rapamycin complex 2 subunit AVO1', 89, NULL, NULL, 36121),
(36122, '4.10.400.10-FF-000365', NULL, 'Uncharacterized protein', 42, NULL, NULL, 36122),
(36123, '1.20.1250.10-FF-000029', NULL, 'Interleukin-13', 113, NULL, NULL, 36123),
(36124, '3.60.20.30-FF-000025', NULL, NULL, 67, NULL, NULL, 36124),
(36125, '3.30.70.1230-FF-000208', NULL, 'Guanylate cyclase', 149, NULL, NULL, 36125),
(36126, '1.10.10.1590-FF-000001', NULL, 'NADH-quinone oxidoreductase subunit E', 74, NULL, NULL, 36126),
(36127, '3.40.630.10-FF-000368', NULL, 'Si:ch1073-459j12.1', 123, NULL, NULL, 36127),
(36128, '2.60.120.10-FF-000391', NULL, 'Glucose-6-phosphate isomerase', 190, NULL, NULL, 36128),
(36129, '3.30.70.100-FF-000104', NULL, 'Uncharacterized protein', 116, NULL, NULL, 36129),
(36130, '3.60.40.10-FF-000144', NULL, 'Protein phosphatase, putative', 254, NULL, NULL, 36130),
(36131, '2.110.10.10-FF-000018', NULL, 'Matrix metallopeptidase 25b', 199, NULL, NULL, 36131),
(36132, '1.10.520.10-FF-000043', NULL, 'Predicted protein', 161, NULL, NULL, 36132),
(36133, '3.40.50.300-FF-004632', NULL, 'Toxin secretion ABC transporter ATP-binding protein', 209, NULL, NULL, 36133),
(36134, '1.10.10.60-FF-000748', NULL, 'Nucleolar protein', 75, NULL, NULL, 36134),
(36135, '3.40.50.300-FF-005144', NULL, 'Os02g0107900 protein', 235, NULL, NULL, 36135),
(36136, '2.60.40.1730-FF-000037', NULL, 'Aminopeptidase-like protein AC3.5', 195, NULL, NULL, 36136),
(36137, '1.20.140.150-FF-000105', NULL, 'Uncharacterized protein', 175, NULL, NULL, 36137),
(36138, '2.130.10.10-FF-004233', NULL, 'Uncharacterized protein', 144, NULL, NULL, 36138),
(36139, '3.90.70.10-FF-000280', NULL, 'Type I secretion system permease/ATPase', 124, NULL, NULL, 36139),
(36140, '1.25.40.10-FF-001371', NULL, 'Pentatricopeptide repeat-containing protein', 105, NULL, NULL, 36140),
(36141, '1.10.287.70-FF-000692', NULL, 'Uncharacterized protein', 68, NULL, NULL, 36141),
(36142, '1.20.1310.10-FF-000198', NULL, NULL, 70, NULL, NULL, 36142),
(36143, '2.40.100.10-FF-000034', NULL, 'Peptidyl-prolyl isomerase CWC27 protein', 191, NULL, NULL, 36143),
(36144, '2.130.10.10-FF-005981', NULL, 'Uncharacterized protein', 233, NULL, NULL, 36144),
(36145, '3.40.47.10-FF-000121', NULL, 'Beta-ketoacyl-ACP synthase II', 419, NULL, NULL, 36145),
(36146, '3.40.1110.10-FF-000210', NULL, 'Chromosome 1, whole genome shotgun sequence', 147, NULL, NULL, 36146),
(36147, '1.10.10.10-FF-000306', NULL, 'ATP-dependent DNA helicase', 109, NULL, NULL, 36147),
(36148, '1.20.1250.20-FF-001095', NULL, 'MFS transporter', 455, NULL, NULL, 36148),
(36149, '3.40.50.2000-FF-000605', NULL, 'Granule-bound starch synthase 1 chloroplastic/amyloplastic', 80, NULL, NULL, 36149),
(36150, '2.60.120.200-FF-000039', NULL, 'Collagen XV alpha 1 chain', 213, NULL, NULL, 36150),
(36151, '1.10.510.10-FF-000542', NULL, 'Tyrosine-protein kinase Abl', 211, NULL, NULL, 36151),
(36152, '2.60.120.1000-FF-000015', NULL, 'Fibrillar collagen', 241, NULL, NULL, 36152),
(36153, '3.80.10.10-FF-004418', NULL, 'Uncharacterized protein', 157, NULL, NULL, 36153),
(36154, '2.40.33.10-FF-000018', NULL, 'Pyruvate kinase', 110, NULL, NULL, 36154),
(36155, '3.20.20.60-FF-000143', NULL, 'Uncharacterized protein', 207, NULL, NULL, 36155),
(36156, '2.10.220.10-FF-000128', NULL, 'Proprotein convertase subtilisin/kexin type 5', 71, NULL, NULL, 36156),
(36157, '2.130.10.10-FF-005762', NULL, 'Glr0823 protein', 111, NULL, NULL, 36157),
(36158, '2.60.40.840-FF-000014', NULL, 'Uncharacterized protein', 120, NULL, NULL, 36158),
(36159, '3.90.190.10-FF-000204', NULL, 'Dual specificity protein phosphatase Mpk3', 155, NULL, NULL, 36159),
(36160, '1.10.10.2230-FF-000002', NULL, NULL, 94, NULL, NULL, 36160),
(36161, '1.20.120.980-FF-000024', NULL, 'Uncharacterized protein', 133, NULL, NULL, 36161),
(36162, '1.10.287.940-FF-000014', NULL, 'P2X purinoceptor 4', 22, NULL, NULL, 36162),
(36163, '3.30.70.330-FF-000393', NULL, 'Methenyltetrahydrofolate synthetase domain containing', 85, NULL, NULL, 36163);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(36164, '2.70.98.10-FF-000077', NULL, 'Beta-galactosidase', 314, NULL, NULL, 36164),
(36165, '1.20.58.420-FF-000003', NULL, 'ATLastiN (Endoplasmic reticulum GTPase) related', 108, NULL, NULL, 36165),
(36166, '2.40.20.10-FF-000039', NULL, 'Metalloendopeptidase', 86, NULL, NULL, 36166),
(36167, '3.40.50.2000-FF-001117', NULL, 'Uncharacterized protein', 193, NULL, NULL, 36167),
(36168, '2.60.120.330-FF-000050', NULL, 'Gibberellin 2-beta-dioxygenase 7', 299, NULL, NULL, 36168),
(36169, '3.40.50.150-FF-000967', NULL, NULL, 163, NULL, NULL, 36169),
(36170, '2.10.25.10-FF-000844', NULL, 'Neurocan b', 38, NULL, NULL, 36170),
(36171, '1.25.10.10-FF-000829', NULL, 'Uncharacterized protein', 421, NULL, NULL, 36171),
(36172, '1.20.1740.10-FF-000011', NULL, 'Arginine/agmatine antiporter', 431, NULL, NULL, 36172),
(36173, '2.30.29.30-FF-001061', NULL, 'Switching B cell complex subunit SWAP70', 78, NULL, NULL, 36173),
(36174, '2.60.40.10-FF-000214', NULL, 'titin isoform X1', 89, NULL, NULL, 36174),
(36175, '3.90.550.10-FF-000406', NULL, 'Putative glycosyltransferase EpsE', 200, NULL, NULL, 36175),
(36176, '1.25.40.180-FF-000208', NULL, NULL, 168, NULL, NULL, 36176),
(36177, '2.170.130.10-FF-000073', NULL, NULL, 132, NULL, NULL, 36177),
(36178, '1.20.120.1910-FF-000001', NULL, 'Cysteine--tRNA ligase', 159, NULL, NULL, 36178),
(36179, '2.60.40.150-FF-000015', NULL, 'dedicator of cytokinesis protein 9 isoform X1', 189, NULL, NULL, 36179),
(36180, '3.60.110.10-FF-000015', NULL, 'Apolipoprotein N-acyltransferase', 268, NULL, NULL, 36180),
(36181, '3.30.160.60-FF-005430', NULL, NULL, 34, NULL, NULL, 36181),
(36182, '3.30.190.20-FF-000035', NULL, 'Ribosomal protein', 49, NULL, NULL, 36182),
(36183, '2.130.10.10-FF-002996', NULL, 'Uncharacterized protein', 195, NULL, NULL, 36183),
(36184, '3.40.50.1220-FF-000124', NULL, 'Sir2-type regulatory transcription factor silent information regulator protein', 137, NULL, NULL, 36184),
(36185, '1.10.10.1800-FF-000002', NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', 99, NULL, NULL, 36185),
(36186, '3.30.160.60-FF-000427', NULL, 'Zinc finger with KRAB and SCAN domains 7', 28, NULL, NULL, 36186),
(36187, '3.40.1190.20-FF-000206', NULL, NULL, 110, NULL, NULL, 36187),
(36188, '3.40.20.10-FF-000094', NULL, 'Actin-binding protein, cofilin/tropomyosin family protein', 143, NULL, NULL, 36188),
(36189, '2.130.10.10-FF-000759', NULL, 'WD repeat-containing protein 6', 237, NULL, NULL, 36189),
(36190, '3.40.50.450-FF-000046', NULL, 'ATP-dependent 6-phosphofructokinase', 91, NULL, NULL, 36190),
(36191, '3.40.50.970-FF-000084', NULL, 'Probable 2-ketoarginine decarboxylase AruI', 181, NULL, NULL, 36191),
(36192, '3.40.50.300-FF-001092', NULL, 'ATP-binding cassette sub-family F member 2', 104, NULL, NULL, 36192),
(36193, '1.10.238.10-FF-001241', NULL, 'Uncharacterized protein', 89, NULL, NULL, 36193),
(36194, '1.20.120.1220-FF-000002', NULL, 'Leader peptidase (Prepilin peptidase)/N-methyltransferase', 147, NULL, NULL, 36194),
(36195, '3.90.190.10-FF-000423', NULL, 'Uncharacterized protein', 84, NULL, NULL, 36195),
(36196, '3.30.420.510-FF-000009', NULL, 'PaNtothenate Kinase', 135, NULL, NULL, 36196),
(36197, '1.10.560.10-FF-000146', NULL, 'Uncharacterized protein', 25, NULL, NULL, 36197),
(36198, '1.20.58.1030-FF-000016', NULL, 'Partner of sld5, putative', 45, NULL, NULL, 36198),
(36199, '3.20.20.80-FF-000025', NULL, 'Alpha-L-arabinofuranosidase 1', 307, NULL, NULL, 36199),
(36200, '2.40.50.100-FF-000164', NULL, 'Uncharacterized protein', 92, NULL, NULL, 36200),
(36201, '3.80.10.10-FF-002390', NULL, 'F-box/LRR-repeat protein 20', 355, NULL, NULL, 36201),
(36202, '2.60.40.10-FF-003648', NULL, NULL, 98, NULL, NULL, 36202),
(36203, '1.25.40.20-FF-000879', NULL, 'Kinase, NEK', 149, NULL, NULL, 36203),
(36204, '3.40.250.10-FF-000260', NULL, 'Tyrosine-protein phosphatase 1', 145, NULL, NULL, 36204),
(36205, '3.40.50.300-FF-008342', NULL, 'Dynein axonemal heavy chain 10', 202, NULL, NULL, 36205),
(36206, '3.40.50.300-FF-000361', NULL, 'Multidrug ABC transporter ATP-binding protein', 236, NULL, NULL, 36206);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(36207, '1.20.1050.90-FF-000015', NULL, NULL, 189, NULL, NULL, 36207),
(36208, '3.30.450.20-FF-000533', NULL, 'Predicted protein', 43, NULL, NULL, 36208),
(36209, '1.10.287.70-FF-000236', NULL, 'Uncharacterized protein', 110, NULL, NULL, 36209),
(36210, '1.10.472.80-FF-000193', NULL, NULL, 124, NULL, NULL, 36210),
(36211, '3.90.76.10-FF-000012', NULL, 'Peptide ABC transporter substrate-binding protein', 126, NULL, NULL, 36211),
(36212, '3.30.70.330-FF-001011', NULL, 'Serine/arginine-rich SC35-like splicing factor SCL30 isoform A', 143, NULL, NULL, 36212),
(36213, '3.30.200.20-FF-000599', NULL, 'Cyclin-dependent kinase 2', 84, NULL, NULL, 36213),
(36214, '3.30.457.30-FF-000001', NULL, 'Fancl, isoform B', 90, NULL, NULL, 36214),
(36215, '3.40.50.300-FF-005829', NULL, 'ABC transporter D family member 3', 278, NULL, NULL, 36215),
(36216, '3.30.565.10-FF-000398', NULL, 'Two component signal transduction system histidine kinase', 138, NULL, NULL, 36216),
(36217, '1.10.4160.10-FF-000014', NULL, 'Putative permease', 466, NULL, NULL, 36217),
(36218, '3.90.1460.10-FF-000005', NULL, 'general transcription factor II-I repeat domain-containing protein 1', 112, NULL, NULL, 36218),
(36219, '3.30.900.10-FF-000054', NULL, 'Uncharacterized protein', 245, NULL, NULL, 36219),
(36220, '3.90.640.10-FF-000166', NULL, 'Uncharacterized protein', 46, NULL, NULL, 36220),
(36221, '2.60.120.260-FF-000473', NULL, 'Uncharacterized protein', 186, NULL, NULL, 36221),
(36222, '3.30.160.60-FF-000208', NULL, 'zinc finger protein Gfi-1b', 26, NULL, NULL, 36222),
(36223, '3.90.180.10-FF-000142', NULL, 'Uncharacterized protein', 216, NULL, NULL, 36223),
(36224, '3.40.1280.10-FF-000087', NULL, 'SPOUT domain-containing methyltransferase 1', 163, NULL, NULL, 36224),
(36225, '3.50.40.10-FF-000010', NULL, 'Predicted protein', 138, NULL, NULL, 36225),
(36226, '1.25.10.10-FF-001779', NULL, 'Predicted protein', 784, NULL, NULL, 36226),
(36227, '2.60.40.3120-FF-000004', NULL, 'Metallo-peptidase, Clan MC, Family M14', 114, NULL, NULL, 36227),
(36228, '2.40.70.10-FF-000430', NULL, NULL, 130, NULL, NULL, 36228),
(36229, '1.20.1720.10-FF-000009', NULL, 'MFS multidrug transporter', 206, NULL, NULL, 36229),
(36230, '2.60.40.820-FF-000019', NULL, 'Uncharacterized protein', 186, NULL, NULL, 36230),
(36231, '1.20.120.1080-FF-000033', NULL, 'RBR-type E3 ubiquitin transferase', 107, NULL, NULL, 36231),
(36232, '3.30.460.20-FF-000028', NULL, 'CorA family metal ion transporter (Eurofung)', 154, NULL, NULL, 36232),
(36233, '1.25.40.20-FF-000194', NULL, 'short transient receptor potential channel 1 isoform X2', 154, NULL, NULL, 36233),
(36234, '3.40.50.620-FF-000451', NULL, 'Cysteine-tRNA ligase-like protein', 151, NULL, NULL, 36234),
(36235, '2.60.120.290-FF-000234', NULL, 'Uncharacterized protein', 76, NULL, NULL, 36235),
(36236, '3.40.50.2300-FF-000813', NULL, NULL, 67, NULL, NULL, 36236),
(36237, '1.10.630.10-FF-000253', NULL, 'Cytochrome P450 hydroxylase', 235, NULL, NULL, 36237),
(36238, '1.25.10.10-FF-002055', NULL, 'Uncharacterized protein', 278, NULL, NULL, 36238),
(36239, '2.60.40.10-FF-001962', NULL, 'Uncharacterized protein, isoform A', 120, NULL, NULL, 36239),
(36240, '1.25.40.20-FF-000536', NULL, 'Ankyrin-3 isoform E', 213, NULL, NULL, 36240),
(36241, '3.40.50.11060-FF-000017', NULL, 'Predicted protein', 53, NULL, NULL, 36241),
(36242, '3.40.50.720-FF-000711', NULL, 'Unplaced genomic scaffold supercont2.2, whole genome shotgun sequence', 170, NULL, NULL, 36242),
(36243, '1.20.1250.20-FF-001999', NULL, 'Uncharacterized protein', 381, NULL, NULL, 36243),
(36244, '3.40.50.300-FF-002159', NULL, 'Possible transposase', 167, NULL, NULL, 36244),
(36245, '3.40.605.10-FF-000063', NULL, 'Succinate-semialdehyde dehydrogenase, mitochondrial', 296, NULL, NULL, 36245),
(36246, '1.25.40.10-FF-002568', NULL, 'Putative UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SEC', 64, NULL, NULL, 36246),
(36247, '1.25.40.10-FF-003187', NULL, 'Uncharacterized protein', 97, NULL, NULL, 36247),
(36248, '3.10.180.10-FF-000087', NULL, '4-hydroxyphenylpyruvate dioxygenase', 158, NULL, NULL, 36248);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(36249, '3.20.20.300-FF-000078', NULL, NULL, 309, NULL, NULL, 36249),
(36250, '1.25.10.20-FF-000023', NULL, 'Uncharacterized protein', 138, NULL, NULL, 36250),
(36251, '3.40.50.300-FF-001653', NULL, 'Transcriptional regulator RtcR', 190, NULL, NULL, 36251),
(36252, '2.40.50.140-FF-000384', NULL, 'Aspartate--tRNA ligase', 141, NULL, NULL, 36252),
(36253, '3.40.50.1000-FF-000749', NULL, NULL, 120, NULL, NULL, 36253),
(36254, '3.40.630.30-FF-000363', NULL, 'Acetyltransferase, GNAT family', 103, NULL, NULL, 36254),
(36255, '1.10.150.510-FF-000015', NULL, 'Receptor (G protein-coupled) activity modifying protein 2', 90, NULL, NULL, 36255),
(36256, '2.130.10.10-FF-004014', NULL, 'Uncharacterized protein', 224, NULL, NULL, 36256),
(36257, '3.40.50.1110-FF-000080', NULL, 'Slr1119 protein', 211, NULL, NULL, 36257),
(36258, '1.10.8.10-FF-000339', NULL, 'Heat shock protein 70 (HSP70)-interacting protein, putative', 37, NULL, NULL, 36258),
(36259, '3.90.470.40-FF-000004', NULL, 'DNA damage-inducible transcript 4 protein', 146, NULL, NULL, 36259),
(36260, '2.30.30.40-FF-000280', NULL, 'Dreadlocks, isoform A', 77, NULL, NULL, 36260),
(36261, '3.30.750.80-FF-000001', NULL, 'Ribosomal RNA large subunit methyltransferase K/L', 92, NULL, NULL, 36261),
(36262, '3.40.50.300-FF-004071', NULL, 'HPr kinase/phosphorylase', 158, NULL, NULL, 36262),
(36263, '1.10.357.10-FF-000022', NULL, 'Transcriptional regulator NfxB', 180, NULL, NULL, 36263),
(36264, '1.50.10.20-FF-000066', NULL, 'Geranylgeranyl transferase type-1 subunit beta', 355, NULL, NULL, 36264),
(36265, '3.40.630.10-FF-000025', NULL, 'aspartoacylase', 238, NULL, NULL, 36265),
(36266, '3.30.2030.20-FF-000001', NULL, 'Putative lipoprotein LppB', 181, NULL, NULL, 36266),
(36267, '3.10.100.10-FF-000312', NULL, NULL, 148, NULL, NULL, 36267),
(36268, '1.20.58.400-FF-000008', NULL, 'Vesicle transport v-SNARE 13', 97, NULL, NULL, 36268),
(36269, '3.40.850.10-FF-000244', NULL, 'Kinesin-like protein', 370, NULL, NULL, 36269),
(36270, '3.90.1290.10-FF-000065', NULL, 'Uncharacterized protein', 186, NULL, NULL, 36270),
(36271, '1.10.1420.10-FF-000028', NULL, 'DNA mismatch repair protein', 132, NULL, NULL, 36271),
(36272, '2.40.50.140-FF-000041', NULL, 'Replication protein A subunit', 109, NULL, NULL, 36272),
(36273, '1.20.930.60-FF-000007', NULL, 'GM15669', 119, NULL, NULL, 36273),
(36274, '4.10.400.10-FF-000022', NULL, 'LDL receptor related protein 1', 40, NULL, NULL, 36274),
(36275, '1.20.1250.20-FF-001106', NULL, 'MFS transporter', 404, NULL, NULL, 36275),
(36276, '3.60.21.10-FF-000016', NULL, 'Putative metallophosphoesterase', 264, NULL, NULL, 36276),
(36277, '1.20.58.60-FF-000217', NULL, 'Synaptic nuclear envelope 2', 225, NULL, NULL, 36277),
(36278, '2.40.160.20-FF-000035', NULL, 'Major outer membrane protein OMP-1A', 182, NULL, NULL, 36278),
(36279, '3.30.200.20-FF-002179', NULL, 'Uncharacterized protein', 58, NULL, NULL, 36279),
(36280, '3.30.70.330-FF-001915', NULL, NULL, 61, NULL, NULL, 36280),
(36281, '1.25.40.10-FF-005328', NULL, 'Tetratricopeptide repeat protein 37', 191, NULL, NULL, 36281),
(36282, '2.30.30.380-FF-000049', NULL, 'AGAP001986-PA-like protein', 34, NULL, NULL, 36282),
(36283, '3.30.559.10-FF-000232', NULL, 'Tryptophan N-acetyltransferase ivoA', 167, NULL, NULL, 36283),
(36284, '1.10.560.10-FF-000040', NULL, 'Bardet-Biedl syndrome 10 protein', 105, NULL, NULL, 36284),
(36285, '3.30.70.330-FF-000954', NULL, 'ESF1 isoform 1', 205, NULL, NULL, 36285),
(36286, '1.20.1270.60-FF-000017', NULL, 'endophilin-B2 isoform X1', 231, NULL, NULL, 36286),
(36287, '2.60.120.200-FF-000371', NULL, 'Drosophila CRumBs homolog', 166, NULL, NULL, 36287),
(36288, '2.60.40.60-FF-000532', NULL, 'Protein CBR-CDH-12', 98, NULL, NULL, 36288),
(36289, '3.50.50.100-FF-000023', NULL, 'Apoptosis-inducing factor, mitochondrion-associated, 2', 361, NULL, NULL, 36289),
(36290, '3.40.50.620-FF-000794', NULL, 'Uncharacterized protein', 45, NULL, NULL, 36290),
(36291, '3.30.1330.40-FF-000030', NULL, 'Enamine deaminase RidA, house cleaning of reactive enamine intermediates, YjgF/YER057c/UK114 family', 115, NULL, NULL, 36291);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(36292, '1.10.510.10-FF-002919', NULL, 'Protein kinase, putative', 269, NULL, NULL, 36292),
(36293, '1.20.1410.10-FF-000020', NULL, 'Uncharacterized protein', 187, NULL, NULL, 36293),
(36294, '1.10.220.10-FF-000003', NULL, 'Annexin', 76, NULL, NULL, 36294),
(36295, '1.10.10.10-FF-001487', NULL, 'Eukaryotic translation initiation factor 3 subunit K', 95, NULL, NULL, 36295),
(36296, '3.30.70.330-FF-001230', NULL, 'CCR4-NOT core complex subunit Not4, putative (AFU_orthologue AFUA_6G08820)', 74, NULL, NULL, 36296),
(36297, '3.40.50.300-FF-007381', NULL, 'Uncharacterized protein', 316, NULL, NULL, 36297),
(36298, '2.40.128.590-FF-000002', NULL, 'Phycocyanobilin lyase CpcT', 207, NULL, NULL, 36298),
(36299, '2.130.10.10-FF-003053', NULL, 'FI12409p', 143, NULL, NULL, 36299),
(36300, '3.10.590.10-FF-000005', NULL, 'Os03g0676100 protein', 152, NULL, NULL, 36300),
(36301, '1.20.1250.20-FF-000145', NULL, 'Chromaffin granule amine transporter', 386, NULL, NULL, 36301),
(36302, '3.50.50.60-FF-001458', NULL, 'Uncharacterized protein', 75, NULL, NULL, 36302),
(36303, '3.30.60.30-FF-000057', NULL, 'Follistatin, isoform B', 77, NULL, NULL, 36303),
(36304, '2.170.16.10-FF-000029', NULL, 'DNA polymerase', 169, NULL, NULL, 36304),
(36305, '3.90.70.10-FF-000622', NULL, 'Uncharacterized protein', 135, NULL, NULL, 36305),
(36306, '3.20.20.70-FF-000365', NULL, 'Nicotinate phosphoribosyltransferase', 101, NULL, NULL, 36306),
(36307, '3.40.50.300-FF-002614', NULL, 'Origin recognition complex subunit Orc5, putative', 171, NULL, NULL, 36307),
(36308, '3.40.50.1240-FF-000006', NULL, '6-phosphofructo-2-kinase/fructose-2, 6-bisphosphatase', 196, NULL, NULL, 36308),
(36309, '3.40.50.620-FF-000119', NULL, 'Putative valine--tRNA ligase-like', 309, NULL, NULL, 36309),
(36310, '2.60.120.380-FF-000054', NULL, 'Cysteine peptidase, Clan CA, family C2, putative', 134, NULL, NULL, 36310),
(36311, '2.130.10.10-FF-001939', NULL, 'Predicted protein', 232, NULL, NULL, 36311),
(36312, '1.50.40.10-FF-000014', NULL, 'mitochondrial coenzyme A transporter SLC25A42', 291, NULL, NULL, 36312),
(36313, '1.20.1250.20-FF-002275', NULL, 'Sugar transporter, putative', 95, NULL, NULL, 36313),
(36314, '3.60.10.10-FF-000193', NULL, 'Endonuclease/exonuclease/phosphatase family protein', 309, NULL, NULL, 36314),
(36315, '1.20.1070.10-FF-000954', NULL, 'Uncharacterized protein', 318, NULL, NULL, 36315),
(36316, '3.30.930.10-FF-000224', NULL, 'Glycine--tRNA ligase', 281, NULL, NULL, 36316),
(36317, '3.40.50.1380-FF-000020', NULL, 'Carbamoyl-phosphate synthase large chain', 139, NULL, NULL, 36317),
(36318, '3.30.160.60-FF-001377', NULL, 'Zinc finger protein 585A', 28, NULL, NULL, 36318),
(36319, '3.30.160.60-FF-003518', NULL, NULL, 30, NULL, NULL, 36319),
(36320, '2.130.10.10-FF-005183', NULL, 'U4/U6-U5 snRNP complex subunit', 122, NULL, NULL, 36320),
(36321, '2.60.40.10-FF-002001', NULL, 'Unc-89 protein', 89, NULL, NULL, 36321),
(36322, '1.20.5.2440-FF-000006', NULL, 'Uncharacterized protein, isoform C', 71, NULL, NULL, 36322),
(36323, '3.30.40.10-FF-001921', NULL, 'Predicted protein', 71, NULL, NULL, 36323),
(36324, '2.10.50.10-FF-000121', NULL, 'Tumor necrosis factor receptor superfamily, member 1a', 62, NULL, NULL, 36324),
(36325, '3.10.580.10-FF-000179', NULL, 'Os03g0674300 protein', 111, NULL, NULL, 36325),
(36326, '2.60.40.60-FF-000313', NULL, 'Tyrosine kinase receptor Cad96Ca', 105, NULL, NULL, 36326),
(36327, '2.60.40.10-FF-001383', NULL, 'Bent, isoform I', 98, NULL, NULL, 36327),
(36328, '2.60.40.3170-FF-000008', NULL, 'Uncharacterized protein', 128, NULL, NULL, 36328),
(36329, '4.10.240.10-FF-000049', NULL, 'C6 finger domain protein, putative', 78, NULL, NULL, 36329),
(36330, '1.50.40.10-FF-000138', NULL, 'Mitochondrial phosphate carrier protein 3', 131, NULL, NULL, 36330),
(36331, '3.10.170.20-FF-000027', NULL, NULL, 131, NULL, NULL, 36331),
(36332, '1.20.1440.300-FF-000001', NULL, 'RNA-directed RNA polymerase L', 75, NULL, NULL, 36332),
(36333, '3.30.160.60-FF-004811', NULL, NULL, 61, NULL, NULL, 36333),
(36334, '1.25.10.10-FF-003359', NULL, 'Uncharacterized protein', 574, NULL, NULL, 36334);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(36335, '1.25.10.10-FF-003235', NULL, 'Uncharacterized protein', 249, NULL, NULL, 36335),
(36336, '3.40.30.10-FF-000717', NULL, 'Glutathione S-transferase, putative', 89, NULL, NULL, 36336),
(36337, '3.60.150.10-FF-000012', NULL, 'Chorismate synthase', 352, NULL, NULL, 36337),
(36338, '2.60.220.50-FF-000084', NULL, 'Predicted protein', 183, NULL, NULL, 36338),
(36339, '3.40.50.720-FF-002509', NULL, 'Predicted protein', 130, NULL, NULL, 36339),
(36340, '3.30.450.20-FF-000078', NULL, 'Sensor histidine kinase', 114, NULL, NULL, 36340),
(36341, '2.60.120.620-FF-000160', NULL, 'Uncharacterized protein', 158, NULL, NULL, 36341),
(36342, '3.40.50.1000-FF-000406', NULL, 'HAD superfamily hydrolase, putative', 140, NULL, NULL, 36342),
(36343, '1.20.58.60-FF-000094', NULL, 'dystonin isoform X2', 223, NULL, NULL, 36343),
(36344, '3.40.50.1820-FF-000540', NULL, 'Carboxypeptidase', 138, NULL, NULL, 36344),
(36345, '2.130.10.10-FF-002092', NULL, 'Transducin/WD40 repeat-like superfamily protein', 113, NULL, NULL, 36345),
(36346, '3.30.40.10-FF-001028', NULL, 'RING-type E3 ubiquitin transferase', 101, NULL, NULL, 36346),
(36347, '1.10.455.10-FF-000020', NULL, '30S ribosomal protein S7', 199, NULL, NULL, 36347),
(36348, '3.10.250.10-FF-000082', NULL, NULL, 117, NULL, NULL, 36348),
(36349, '1.10.238.10-FF-000622', NULL, 'Follistatin-like 5', 121, NULL, NULL, 36349),
(36350, '1.25.10.10-FF-002959', NULL, 'Uncharacterized protein', 441, NULL, NULL, 36350),
(36351, '1.20.1070.10-FF-000375', NULL, '5-hydroxytryptamine (serotonin) receptor 1Fa', 306, NULL, NULL, 36351),
(36352, '1.10.510.10-FF-002796', NULL, 'Kinase, NEK', 350, NULL, NULL, 36352),
(36353, '3.30.40.10-FF-000628', NULL, 'Ubiquitin E3 ligase ICP0', 60, NULL, NULL, 36353),
(36354, '1.20.1260.10-FF-000081', NULL, 'Ferritin/ribonucleotide reductase-like family protein', 58, NULL, NULL, 36354),
(36355, '2.60.40.10-FF-006054', NULL, NULL, 110, NULL, NULL, 36355),
(36356, '3.40.33.10-FF-000179', NULL, 'Uncharacterized protein', 81, NULL, NULL, 36356),
(36357, '3.30.420.40-FF-000588', NULL, 'Protein CBR-STC-1', 53, NULL, NULL, 36357),
(36358, '3.30.420.10-FF-000028', NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', 203, NULL, NULL, 36358),
(36359, '3.30.1330.20-FF-000035', NULL, 'Tubulin-like protein CetZ', 136, NULL, NULL, 36359),
(36360, '2.30.42.10-FF-000416', NULL, NULL, 106, NULL, NULL, 36360),
(36361, '1.10.540.10-FF-000038', NULL, 'Acyl-CoA dehydrogenase', 117, NULL, NULL, 36361),
(36362, '3.30.9.10-FF-000118', NULL, 'FAD-dependent oxidoreductase', 148, NULL, NULL, 36362),
(36363, '1.20.1270.60-FF-000130', NULL, 'Variant sh3 domain containing protein', 290, NULL, NULL, 36363),
(36364, '3.40.50.150-FF-001586', NULL, NULL, 41, NULL, NULL, 36364),
(36365, '1.10.510.10-FF-003072', NULL, NULL, 249, NULL, NULL, 36365),
(36366, '4.10.800.20-FF-000011', NULL, 'AMP deaminase, putative', 90, NULL, NULL, 36366),
(36367, '3.40.50.1010-FF-000067', NULL, 'DNA repair endonuclease', 137, NULL, NULL, 36367),
(36368, '3.30.70.980-FF-000008', NULL, 'Translational activator of cytochrome c oxidase 1', 86, NULL, NULL, 36368),
(36369, '1.10.510.10-FF-003291', NULL, NULL, 91, NULL, NULL, 36369),
(36370, '1.20.920.30-FF-000077', NULL, 'Uncharacterized protein', 209, NULL, NULL, 36370),
(36371, '2.60.40.10-FF-005778', NULL, NULL, 102, NULL, NULL, 36371),
(36372, '1.20.930.80-FF-000002', NULL, 'DNA primase large subunit', 241, NULL, NULL, 36372),
(36373, '1.10.3370.10-FF-000041', NULL, 'Uncharacterized protein', 197, NULL, NULL, 36373),
(36374, '3.40.190.80-FF-000091', NULL, 'Inositol-1-monophosphatase', 91, NULL, NULL, 36374),
(36375, '3.30.70.330-FF-002534', NULL, NULL, 49, NULL, NULL, 36375),
(36376, '1.25.40.10-FF-004709', NULL, 'Uncharacterized protein', 95, NULL, NULL, 36376),
(36377, '2.30.29.30-FF-001167', NULL, 'AGAP010456-PA', 98, NULL, NULL, 36377),
(36378, '3.40.50.1820-FF-000883', NULL, 'Phospholipase', 294, NULL, NULL, 36378),
(36379, '3.30.420.10-FF-000360', NULL, NULL, 131, NULL, NULL, 36379),
(36380, '3.30.160.60-FF-003850', NULL, NULL, 29, NULL, NULL, 36380);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(36381, '1.20.920.10-FF-000071', NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', 114, NULL, NULL, 36381),
(36382, '1.20.1740.10-FF-000117', NULL, 'General amino-acid permease GAP1', 463, NULL, NULL, 36382),
(36383, '3.30.160.60-FF-004250', NULL, NULL, 31, NULL, NULL, 36383),
(36384, '1.10.30.10-FF-000072', NULL, 'FACT complex subunit SSRP1', 97, NULL, NULL, 36384),
(36385, '3.40.50.300-FF-001198', NULL, 'GTPase HflX', 172, NULL, NULL, 36385),
(36386, '1.20.140.10-FF-000129', NULL, 'Uncharacterized protein', 59, NULL, NULL, 36386),
(36387, '1.10.287.540-FF-000001', NULL, 'Type IV pilus assembly protein PilO', 36, NULL, NULL, 36387),
(36388, '2.20.110.10-FF-000073', NULL, NULL, 50, NULL, NULL, 36388),
(36389, '2.10.25.10-FF-000501', NULL, 'Crumbs 2, cell polarity complex component', 40, NULL, NULL, 36389),
(36390, '1.10.287.110-FF-000114', NULL, 'SEC63 isoform 5', 96, NULL, NULL, 36390),
(36391, '3.30.420.10-FF-000484', NULL, NULL, 132, NULL, NULL, 36391),
(36392, '3.30.40.10-FF-000960', NULL, 'Uncharacterized protein', 65, NULL, NULL, 36392),
(36393, '3.90.70.10-FF-000061', NULL, 'Ubiquitinyl hydrolase 1', 236, NULL, NULL, 36393),
(36394, '3.40.50.1820-FF-001501', NULL, 'Uncharacterized protein', 160, NULL, NULL, 36394),
(36395, '1.10.510.10-FF-003633', NULL, NULL, 192, NULL, NULL, 36395),
(36396, '3.20.20.80-FF-000463', NULL, 'Spr1p', 397, NULL, NULL, 36396),
(36397, '3.40.50.740-FF-000032', NULL, 'NADH-ubiquinone oxidoreductase 75 kDa subunit', 119, NULL, NULL, 36397),
(36398, '3.40.50.12470-FF-000002', NULL, '2-oxoglutarate dehydrogenase E1 component', 222, NULL, NULL, 36398),
(36399, '3.30.40.10-FF-001360', NULL, 'PHD finger protein 12', 67, NULL, NULL, 36399),
(36400, '3.30.1520.10-FF-000081', NULL, 'Sorting NeXin', 138, NULL, NULL, 36400),
(36401, '3.40.50.300-FF-007960', NULL, 'Dynein heavy chain family protein', 166, NULL, NULL, 36401),
(36402, '1.20.140.10-FF-000005', NULL, 'Acyl-coenzyme A oxidase', 174, NULL, NULL, 36402),
(36403, '3.80.10.10-FF-000945', NULL, 'Putative leucine-rich repeat protein', 189, NULL, NULL, 36403),
(36404, '1.10.510.10-FF-004033', NULL, NULL, 100, NULL, NULL, 36404),
(36405, '2.30.110.10-FF-000037', NULL, 'F420H(2)-dependent quinone reductase Rv1261c', 141, NULL, NULL, 36405),
(36406, '1.10.238.10-FF-000061', NULL, 'Sodium channel protein', 116, NULL, NULL, 36406),
(36407, '1.25.10.10-FF-002398', NULL, 'Uncharacterized protein', 258, NULL, NULL, 36407),
(36408, '2.40.290.10-FF-000036', NULL, 'AaceriAFR443Cp', 199, NULL, NULL, 36408),
(36409, '1.20.1280.50-FF-000077', NULL, 'EIN3-binding F-box protein 1', 50, NULL, NULL, 36409),
(36410, '3.30.40.10-FF-000067', NULL, 'Ubiquitinyl hydrolase 1', 100, NULL, NULL, 36410),
(36411, '3.100.10.20-FF-000001', NULL, 'CRISPR-associated endonuclease Cas1', 96, NULL, NULL, 36411),
(36412, '3.60.10.10-FF-000316', NULL, 'Uncharacterized protein', 283, NULL, NULL, 36412),
(36413, '3.10.20.90-FF-000332', NULL, 'Ubiquitin-40S ribosomal protein S27a', 79, NULL, NULL, 36413),
(36414, '1.25.10.10-FF-003016', NULL, 'Uncharacterized protein', 331, NULL, NULL, 36414),
(36415, '3.30.860.10-FF-000011', NULL, 'Predicted protein', 44, NULL, NULL, 36415),
(36416, '1.20.58.60-FF-000892', NULL, 'Microtubule actin crosslinking factor 1a', 144, NULL, NULL, 36416),
(36417, '1.25.40.10-FF-004024', NULL, 'Uncharacterized protein', 188, NULL, NULL, 36417),
(36418, '3.90.20.20-FF-000004', NULL, 'GrpE protein homolog', 115, NULL, NULL, 36418),
(36419, '1.20.1090.10-FF-000045', NULL, '3-dehydroquinate synthase', 190, NULL, NULL, 36419),
(36420, '3.30.420.270-FF-000016', NULL, 'Tol-Pal system protein TolR', 80, NULL, NULL, 36420),
(36421, '3.40.50.1100-FF-000105', NULL, '1-aminocyclopropane-1-carboxylate deaminase', 105, NULL, NULL, 36421),
(36422, '2.60.120.10-FF-000278', NULL, 'Mannose-6-phosphate isomerase', 201, NULL, NULL, 36422),
(36423, '3.10.50.40-FF-000061', NULL, 'FK506-binding protein 1', 120, NULL, NULL, 36423),
(36424, '1.25.40.10-FF-003748', NULL, 'Tetratricopeptide repeat protein 21 homolog', 188, NULL, NULL, 36424);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(36425, '1.25.40.1040-FF-000020', NULL, 'Tetratricopeptide repeat-containing protein', 489, NULL, NULL, 36425),
(36426, '1.25.40.10-FF-000314', NULL, 'rRNA biogenesis protein RRP5', 105, NULL, NULL, 36426),
(36427, '3.40.50.1820-FF-000208', NULL, 'Adenosine deaminase CECR1-A', 279, NULL, NULL, 36427),
(36428, '1.20.58.830-FF-000019', NULL, 'Merozoite surface protein duffy binding ligand 2', 136, NULL, NULL, 36428),
(36429, '1.20.920.10-FF-000195', NULL, 'Uncharacterized protein', 135, NULL, NULL, 36429),
(36430, '1.10.8.720-FF-000023', NULL, 'Dynein heavy chain', 212, NULL, NULL, 36430),
(36431, '3.30.505.10-FF-000057', NULL, 'Signal transducer and activator of transcription', 108, NULL, NULL, 36431),
(36432, '3.40.50.300-FF-002957', NULL, 'Mitochondrial RNA helicase, putative', 156, NULL, NULL, 36432),
(36433, '1.50.40.10-FF-000357', NULL, 'Mitochondrial carrier protein, putative', 298, NULL, NULL, 36433),
(36434, '3.20.20.70-FF-000584', NULL, NULL, 108, NULL, NULL, 36434),
(36435, '3.40.850.10-FF-000553', NULL, 'Uncharacterized protein', 135, NULL, NULL, 36435),
(36436, '1.10.730.10-FF-000188', NULL, 'Leucine--tRNA ligase subunit beta', 261, NULL, NULL, 36436),
(36437, '2.130.10.10-FF-000040', NULL, 'echinoderm microtubule-associated protein-like 6 isoform X1', 307, NULL, NULL, 36437),
(36438, '2.60.40.150-FF-000026', NULL, 'dysferlin isoform X2', 144, NULL, NULL, 36438),
(36439, '2.70.170.10-FF-000054', NULL, 'Ligand-Gated ion Channel', 209, NULL, NULL, 36439),
(36440, '3.20.20.80-FF-000492', NULL, 'Uncharacterized protein', 188, NULL, NULL, 36440),
(36441, '2.60.40.10-FF-002153', NULL, 'Lachesin', 96, NULL, NULL, 36441),
(36442, '3.30.70.1230-FF-000124', NULL, 'Adenylate/guanylate cyclase', 194, NULL, NULL, 36442),
(36443, '3.40.50.740-FF-000003', NULL, 'Biotin sulfoxide reductase 2', 220, NULL, NULL, 36443),
(36444, '3.40.50.150-FF-000040', NULL, 'Putative ribosomal RNA methyltransferase 1', 191, NULL, NULL, 36444),
(36445, '2.40.160.180-FF-000006', NULL, 'Porin', 377, NULL, NULL, 36445),
(36446, '3.30.559.30-FF-000120', NULL, 'Uncharacterized protein', 163, NULL, NULL, 36446),
(36447, '1.25.40.10-FF-002984', NULL, 'Os03g0369700 protein', 147, NULL, NULL, 36447),
(36448, '1.10.8.60-FF-000129', NULL, 'Chromosomal replication initiator protein DnaA', 70, NULL, NULL, 36448),
(36449, '1.25.40.20-FF-001885', NULL, 'Protein 21.1', 62, NULL, NULL, 36449),
(36450, '2.130.10.30-FF-000046', NULL, 'Uncharacterized protein, isoform C', 131, NULL, NULL, 36450),
(36451, '3.40.50.1820-FF-001422', NULL, 'Putative lipase YDL109C', 199, NULL, NULL, 36451),
(36452, '3.30.540.30-FF-000009', NULL, 'Dipeptidyl peptidase 3', 94, NULL, NULL, 36452),
(36453, '1.10.510.10-FF-000031', NULL, 'Mitogen-activated protein kinase kinase kinase kinase', 302, NULL, NULL, 36453),
(36454, '3.60.10.10-FF-000075', NULL, 'Sphingomyelin phosphodiesterase, putative', 117, NULL, NULL, 36454),
(36455, '2.40.10.10-FF-000011', NULL, 'Coagulation factor X', 151, NULL, NULL, 36455),
(36456, '3.90.550.10-FF-000749', NULL, 'Uncharacterized protein', 52, NULL, NULL, 36456),
(36457, '2.60.40.10-FF-003255', NULL, NULL, 114, NULL, NULL, 36457),
(36458, '3.30.530.20-FF-000034', NULL, 'Crossveinless c, isoform A', 186, NULL, NULL, 36458),
(36459, '1.10.520.20-FF-000006', NULL, 'ATP synthase subunit delta', 105, NULL, NULL, 36459),
(36460, '3.40.1000.10-FF-000033', NULL, 'Uncharacterized protein', 90, NULL, NULL, 36460),
(36461, '3.40.30.10-FF-000094', NULL, 'Glutathione S-transferase domain protein', 133, NULL, NULL, 36461),
(36462, '3.40.50.300-FF-003093', NULL, 'ADP-ribosylation factor-like protein 5', 171, NULL, NULL, 36462),
(36463, '3.40.50.300-FF-004082', NULL, 'Peroxisomal biogenesis factor 6', 96, NULL, NULL, 36463),
(36464, '2.60.120.1440-FF-000017', NULL, 'Transmembrane sensor', 138, NULL, NULL, 36464),
(36465, '1.10.630.10-FF-000624', NULL, 'Os05g0415900 protein', 234, NULL, NULL, 36465),
(36466, '1.10.287.70-FF-000175', NULL, 'small conductance calcium-activated potassium channel protein 1', 68, NULL, NULL, 36466),
(36467, '1.10.520.10-FF-000003', NULL, 'Cytosolic ascorbate peroxidase', 120, NULL, NULL, 36467);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(36468, '2.130.10.10-FF-001142', NULL, 'Elongator complex protein 2', 251, NULL, NULL, 36468),
(36469, '3.40.50.2300-FF-000976', NULL, NULL, 176, NULL, NULL, 36469),
(36470, '3.40.190.10-FF-000199', NULL, 'Sensor histidine kinase/response regulator EvgS', 95, NULL, NULL, 36470),
(36471, '1.20.1070.10-FF-000448', NULL, 'G-protein coupled receptor homolog US28', 296, NULL, NULL, 36471),
(36472, '1.20.1250.20-FF-000549', NULL, 'Inner membrane protein YbjJ', 184, NULL, NULL, 36472),
(36473, '2.40.30.160-FF-000009', NULL, 'Putative transferase CAF17, mitochondrial', 119, NULL, NULL, 36473),
(36474, '3.80.10.10-FF-002682', NULL, 'Phytosulfokine receptor 1', 101, NULL, NULL, 36474),
(36475, '1.10.510.10-FF-003257', NULL, NULL, 112, NULL, NULL, 36475),
(36476, '3.40.30.10-FF-001196', NULL, 'Uncharacterized protein', 84, NULL, NULL, 36476),
(36477, '1.25.10.10-FF-001375', NULL, 'Armadillo-type protein', 1147, NULL, NULL, 36477),
(36478, '1.20.58.480-FF-000004', NULL, 'Indoleamine 2,3-dioxygenase subfamily', 300, NULL, NULL, 36478),
(36479, '3.90.640.10-FF-000195', NULL, 'Uncharacterized protein', 121, NULL, NULL, 36479),
(36480, '3.30.300.160-FF-000018', NULL, 'PilB/PulE/GspE family ATPase', 78, NULL, NULL, 36480),
(36481, '1.10.238.10-FF-000105', NULL, 'Actinin, alpha 1', 48, NULL, NULL, 36481),
(36482, '2.10.25.10-FF-000748', NULL, 'Vitamin K-dependent protein S', 46, NULL, NULL, 36482),
(36483, '3.40.50.790-FF-000024', NULL, 'Mitochondrial ribosomal protein L1', 95, NULL, NULL, 36483),
(36484, '3.30.342.10-FF-000004', NULL, 'DNA polymerase epsilon catalytic subunit', 144, NULL, NULL, 36484),
(36485, '3.20.70.20-FF-000027', NULL, 'Ribonucleoside-diphosphate reductase large subunit-like protein', 648, NULL, NULL, 36485),
(36486, '1.20.58.60-FF-000655', NULL, 'Uncharacterized protein', 132, NULL, NULL, 36486),
(36487, '1.25.40.10-FF-003973', NULL, 'Outer membrane protein assembly factor BamD', 227, NULL, NULL, 36487),
(36488, '2.60.120.260-FF-000456', NULL, 'Uncharacterized protein', 149, NULL, NULL, 36488),
(36489, '1.10.510.10-FF-002801', NULL, NULL, 189, NULL, NULL, 36489),
(36490, '3.30.60.270-FF-000013', NULL, 'Sortilin', 97, NULL, NULL, 36490),
(36491, '2.30.30.1150-FF-000010', NULL, 'E3 ubiquitin-protein ligase UHRF1-like Protein', 163, NULL, NULL, 36491),
(36492, '2.30.29.30-FF-001291', NULL, 'Oxysterol-binding protein', 89, NULL, NULL, 36492),
(36493, '1.10.10.60-FF-001277', NULL, NULL, 71, NULL, NULL, 36493),
(36494, '1.10.10.60-FF-001131', NULL, NULL, 63, NULL, NULL, 36494),
(36495, '1.10.287.1490-FF-000152', NULL, 'Uncharacterized protein', 164, NULL, NULL, 36495),
(36496, '3.30.70.600-FF-000013', NULL, 'Mitochondrial Ribosomal Protein, Large', 102, NULL, NULL, 36496),
(36497, '1.25.40.10-FF-003501', NULL, 'NADPH oxidase activator 1', 194, NULL, NULL, 36497),
(36498, '1.20.120.350-FF-000133', NULL, 'cation channel sperm-associated protein 2-like', 122, NULL, NULL, 36498),
(36499, '1.20.5.650-FF-000016', NULL, NULL, 49, NULL, NULL, 36499),
(36500, '2.30.30.380-FF-000015', NULL, 'RBR-type E3 ubiquitin transferase', 32, NULL, NULL, 36500),
(36501, '3.40.50.2000-FF-000358', NULL, 'ADP-heptose--LPS heptosyltransferase', 177, NULL, NULL, 36501),
(36502, '3.40.50.300-FF-005863', NULL, 'Putative RNA helicase armi-like Protein', 178, NULL, NULL, 36502),
(36503, '1.25.40.10-FF-003647', NULL, 'Uncharacterized protein', 221, NULL, NULL, 36503),
(36504, '3.30.160.720-FF-000001', NULL, 'Nuclease SbcCD subunit D', 64, NULL, NULL, 36504),
(36505, '3.40.250.10-FF-000024', NULL, 'Sulfurtransferase', 136, NULL, NULL, 36505),
(36506, '3.30.559.10-FF-000108', NULL, 'O-acetyltransferase, putative', 269, NULL, NULL, 36506),
(36507, '3.40.50.1010-FF-000050', NULL, 'RNA-binding protein NOB1, putative', 146, NULL, NULL, 36507),
(36508, '3.40.50.620-FF-000698', NULL, 'Uncharacterized protein', 355, NULL, NULL, 36508),
(36509, '1.20.1050.10-FF-000239', NULL, 'Rho-class glutathione S-transferase', 74, NULL, NULL, 36509),
(36510, '1.10.10.140-FF-000010', NULL, 'Uncharacterized protein', 97, NULL, NULL, 36510),
(36511, '4.10.470.10-FF-000004', NULL, 'Ribosome-inactivating protein lychnin', 62, NULL, NULL, 36511);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(36512, '3.40.50.2020-FF-000044', NULL, 'Pur operon repressor', 198, NULL, NULL, 36512),
(36513, '2.10.220.10-FF-000038', NULL, 'Fraser extracellular matrix complex subunit 1', 95, NULL, NULL, 36513),
(36514, '2.60.40.10-FF-005379', NULL, NULL, 58, NULL, NULL, 36514),
(36515, '3.60.21.10-FF-000038', NULL, 'Probable inactive purple acid phosphatase 29', 310, NULL, NULL, 36515),
(36516, '3.40.50.10190-FF-000032', NULL, 'DNA ligase', 87, NULL, NULL, 36516),
(36517, '4.10.470.20-FF-000007', NULL, NULL, 74, NULL, NULL, 36517),
(36518, '3.30.160.60-FF-002602', NULL, 'Uncharacterized protein', 30, NULL, NULL, 36518),
(36519, '3.30.1600.10-FF-000042', NULL, 'Class IV sirtuin', 33, NULL, NULL, 36519),
(36520, '3.80.10.10-FF-002356', NULL, 'F-box and leucine-rich repeat protein 13', 94, NULL, NULL, 36520),
(36521, '3.40.1190.20-FF-000083', NULL, 'ADP-dependent (S)-NAD(P)H-hydrate dehydratase', 272, NULL, NULL, 36521),
(36522, '2.130.10.10-FF-005357', NULL, 'Uncharacterized protein', 175, NULL, NULL, 36522),
(36523, '3.30.200.20-FF-000487', NULL, 'Serine/threonine protein kinase, putative', 97, NULL, NULL, 36523),
(36524, '3.40.50.1010-FF-000196', NULL, NULL, 223, NULL, NULL, 36524),
(36525, '1.10.1200.10-FF-000141', NULL, 'Fatty acid synthase', 64, NULL, NULL, 36525),
(36526, '2.130.10.10-FF-003266', NULL, 'Putative WD-repeat family protein', 184, NULL, NULL, 36526),
(36527, '2.60.120.200-FF-000545', NULL, 'Predicted protein', 250, NULL, NULL, 36527),
(36528, '3.80.10.10-FF-004447', NULL, 'LRR receptor-like serine/threonine-protein kinase EFR', 114, NULL, NULL, 36528),
(36529, '2.40.70.10-FF-000020', NULL, 'Aspartic proteinase-like protein 2', 204, NULL, NULL, 36529),
(36530, '3.40.30.10-FF-000740', NULL, 'Uncharacterized protein', 123, NULL, NULL, 36530),
(36531, '1.20.140.10-FF-000112', NULL, 'Acyl-coenzyme A oxidase', 163, NULL, NULL, 36531),
(36532, '2.60.40.10-FF-005672', NULL, NULL, 84, NULL, NULL, 36532),
(36533, '1.20.1250.20-FF-001331', NULL, 'Uncharacterized protein', 115, NULL, NULL, 36533),
(36534, '1.20.5.170-FF-000114', NULL, 'Tropomyosin', 86, NULL, NULL, 36534),
(36535, '3.80.10.10-FF-000439', NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', 100, NULL, NULL, 36535),
(36536, '1.10.510.10-FF-001812', NULL, 'cAMP-dependent protein kinase catalytic subunit, putative', 123, NULL, NULL, 36536),
(36537, '1.20.1160.11-FF-000018', NULL, NULL, 71, NULL, NULL, 36537),
(36538, '3.90.105.10-FF-000013', NULL, 'Molybdopterin molybdenumtransferase', 51, NULL, NULL, 36538),
(36539, '1.10.2000.10-FF-000008', NULL, 'Frizzled receptor 4', 125, NULL, NULL, 36539),
(36540, '3.30.460.10-FF-000115', NULL, 'Os01g0702900 protein', 53, NULL, NULL, 36540),
(36541, '2.10.25.10-FF-000602', NULL, 'Notch receptor protein', 40, NULL, NULL, 36541),
(36542, '3.30.160.60-FF-005149', NULL, NULL, 56, NULL, NULL, 36542),
(36543, '1.10.8.60-FF-000281', NULL, 'Cell division cycle 48C', 107, NULL, NULL, 36543),
(36544, '2.60.40.150-FF-000352', NULL, 'Uncharacterized protein', 143, NULL, NULL, 36544),
(36545, '1.25.40.180-FF-000293', NULL, NULL, 114, NULL, NULL, 36545),
(36546, '1.10.287.610-FF-000011', NULL, 'DNA ligase', 67, NULL, NULL, 36546),
(36547, '3.30.160.60-FF-003058', NULL, NULL, 30, NULL, NULL, 36547),
(36548, '2.40.30.10-FF-000220', NULL, 'Elongation factor 2, putative', 141, NULL, NULL, 36548),
(36549, '1.10.472.80-FF-000226', NULL, NULL, 116, NULL, NULL, 36549),
(36550, '2.10.60.10-FF-000026', NULL, 'Secreted Ly-6/uPAR domain-containing protein 2', 76, NULL, NULL, 36550),
(36551, '2.60.40.10-FF-001810', NULL, 'T cell receptor delta constant', 84, NULL, NULL, 36551),
(36552, '2.20.100.10-FF-000185', NULL, 'AGAP012813-PA', 57, NULL, NULL, 36552),
(36553, '3.40.50.300-FF-003772', NULL, 'Structural maintenance of chromosomes protein 6A', 251, NULL, NULL, 36553),
(36554, '3.30.810.10-FF-000013', NULL, 'Uncharacterized protein', 138, NULL, NULL, 36554),
(36555, '3.30.930.10-FF-000253', NULL, 'Uncharacterized protein', 222, NULL, NULL, 36555),
(36556, '3.10.20.90-FF-000989', NULL, 'Uncharacterized protein', 91, NULL, NULL, 36556);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(36557, '3.30.565.10-FF-000201', NULL, 'Sensor histidine kinase/response regulator, putative (AFU_orthologue AFUA_4G01020)', 182, NULL, NULL, 36557),
(36558, '3.90.105.20-FF-000016', NULL, 'Ribosome assembly factor mrt4', 77, NULL, NULL, 36558),
(36559, '1.10.287.130-FF-000255', NULL, 'Two-component hybrid sensor and regulator', 79, NULL, NULL, 36559),
(36560, '3.40.50.620-FF-000226', NULL, 'Tyrosine--tRNA ligase', 283, NULL, NULL, 36560),
(36561, '4.10.1060.10-FF-000054', NULL, 'Zn-finger (Ran-binding)-3 isoform X1', 35, NULL, NULL, 36561),
(36562, '4.10.1000.10-FF-000045', NULL, 'Zinc finger, CCCH-type', 39, NULL, NULL, 36562),
(36563, '3.30.420.270-FF-000033', NULL, 'Probable biopolymer transport ExbD protein', 69, NULL, NULL, 36563),
(36564, '2.120.10.30-FF-000041', NULL, 'adipocyte plasma membrane-associated protein', 331, NULL, NULL, 36564),
(36565, '3.40.50.1820-FF-000579', NULL, 'Carboxypeptidase', 259, NULL, NULL, 36565),
(36566, '1.20.1270.60-FF-000304', NULL, 'Uncharacterized protein', 102, NULL, NULL, 36566),
(36567, '3.30.1520.10-FF-000187', NULL, 'Nischarin-like Protein', 83, NULL, NULL, 36567),
(36568, '2.30.30.140-FF-000174', NULL, 'GD18427', 92, NULL, NULL, 36568),
(36569, '1.20.1310.20-FF-000021', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 248, NULL, NULL, 36569),
(36570, '2.30.30.40-FF-000111', NULL, 'Rho guanine nucleotide exchange factor (GEF) 5', 64, NULL, NULL, 36570),
(36571, '1.25.40.10-FF-001556', NULL, 'Uncharacterized protein', 103, NULL, NULL, 36571),
(36572, '2.60.40.640-FF-000111', NULL, 'Uncharacterized protein', 97, NULL, NULL, 36572),
(36573, '1.10.3380.10-FF-000064', NULL, 'Os02g0617500 protein', 84, NULL, NULL, 36573),
(36574, '3.30.450.60-FF-000051', NULL, 'AP-3 complex subunit mu', 142, NULL, NULL, 36574),
(36575, '3.30.160.60-FF-005621', NULL, NULL, 88, NULL, NULL, 36575),
(36576, '1.10.565.10-FF-000090', NULL, 'AGAP000819-PA', 233, NULL, NULL, 36576),
(36577, '1.10.150.20-FF-000197', NULL, 'AGAP007361-PA', 59, NULL, NULL, 36577),
(36578, '3.20.10.10-FF-000015', NULL, 'Branched-chain amino acid aminotransferase', 160, NULL, NULL, 36578),
(36579, '2.60.40.200-FF-000002', NULL, 'Superoxide dismutase [Cu-Zn]', 156, NULL, NULL, 36579),
(36580, '3.30.160.60-FF-004047', NULL, NULL, 30, NULL, NULL, 36580),
(36581, '3.40.630.30-FF-000109', NULL, 'Acetyltransferase, GNAT family', 139, NULL, NULL, 36581),
(36582, '3.40.50.10810-FF-000111', NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', 253, NULL, NULL, 36582),
(36583, '1.25.40.20-FF-001559', NULL, 'Espin like', 100, NULL, NULL, 36583),
(36584, '3.30.310.10-FF-000020', NULL, 'AP complex subunit beta', 115, NULL, NULL, 36584),
(36585, '1.10.10.10-FF-000121', NULL, 'ETS translocation variant 5', 129, NULL, NULL, 36585),
(36586, '1.25.40.420-FF-000056', NULL, 'Eor-1', 78, NULL, NULL, 36586),
(36587, '2.30.30.100-FF-000095', NULL, 'U6 snRNA-associated Sm-like protein LSm8', 91, NULL, NULL, 36587),
(36588, '2.60.40.4330-FF-000002', NULL, 'Kinesin-like protein', 122, NULL, NULL, 36588),
(36589, '3.40.50.720-FF-000582', NULL, 'Dehydrogenase/reductase 7B', 91, NULL, NULL, 36589),
(36590, '3.20.20.370-FF-000020', NULL, 'Uncharacterized protein', 254, NULL, NULL, 36590),
(36591, '1.20.140.10-FF-000051', NULL, 'Acyl-CoA dehydrogenase FadE34', 139, NULL, NULL, 36591),
(36592, '1.20.1080.10-FF-000067', NULL, 'Nitrite transporter NirC', 254, NULL, NULL, 36592),
(36593, '2.60.40.10-FF-001490', NULL, 'Interleukin-4 receptor subunit alpha', 111, NULL, NULL, 36593),
(36594, '3.40.190.10-FF-000878', NULL, 'Uncharacterized protein', 139, NULL, NULL, 36594),
(36595, '4.10.400.10-FF-000056', NULL, 'Terribly reduced optic lobes, isoform AM', 39, NULL, NULL, 36595),
(36596, '1.10.101.10-FF-000002', NULL, 'Matrix metalloproteinase-14 preproprotein', 63, NULL, NULL, 36596),
(36597, '3.30.1360.40-FF-000048', NULL, 'Uncharacterized protein', 79, NULL, NULL, 36597),
(36598, '1.10.510.10-FF-003903', NULL, NULL, 83, NULL, NULL, 36598),
(36599, '1.10.10.10-FF-001902', NULL, 'Gll0305 protein', 116, NULL, NULL, 36599);
INSERT INTO "PUBLIC"."MODEL" VALUES
(36600, '3.30.450.20-FF-000472', NULL, 'Two-component hybrid sensor and regulator', 110, NULL, NULL, 36600),
(36601, '3.30.9.10-FF-000202', NULL, 'sarcosine dehydrogenase, mitochondrial-like isoform X1', 158, NULL, NULL, 36601),
(36602, '3.30.70.330-FF-002826', NULL, NULL, 89, NULL, NULL, 36602),
(36603, '1.10.510.10-FF-003583', NULL, NULL, 213, NULL, NULL, 36603),
(36604, '1.10.3060.10-FF-000017', NULL, 'Protein translocase subunit SecA 1', 83, NULL, NULL, 36604),
(36605, '3.40.50.2000-FF-000684', NULL, 'Predicted protein', 191, NULL, NULL, 36605),
(36606, '3.40.50.720-FF-000902', NULL, 'Siroheme synthase component enzyme', 113, NULL, NULL, 36606),
(36607, '3.30.2410.10-FF-000033', NULL, 'Predicted protein', 119, NULL, NULL, 36607),
(36608, '3.50.50.60-FF-001172', NULL, 'Probable electron transfer flavoprotein-ubiquinone oxidoreductase, mitochondrial', 244, NULL, NULL, 36608),
(36609, '1.20.1540.10-FF-000086', NULL, 'Uncharacterized protein', 231, NULL, NULL, 36609),
(36610, '3.90.180.10-FF-000029', NULL, 'Mitochondrial enoyl reductase', 135, NULL, NULL, 36610),
(36611, '3.20.20.80-FF-000199', NULL, 'Glycoside hydrolase', 332, NULL, NULL, 36611),
(36612, '3.30.70.330-FF-001224', NULL, 'RNA-binding domain-containing protein', 191, NULL, NULL, 36612),
(36613, '1.10.150.850-FF-000005', NULL, 'Uncharacterized protein', 75, NULL, NULL, 36613),
(36614, '3.30.40.10-FF-000174', NULL, 'E3 ubiquitin-protein ligase MSL2', 116, NULL, NULL, 36614),
(36615, '3.30.450.20-FF-000679', NULL, 'Predicted protein', 150, NULL, NULL, 36615),
(36616, '1.25.40.10-FF-002658', NULL, 'Coatomer subunit epsilon-2', 158, NULL, NULL, 36616),
(36617, '2.170.260.10-FF-000020', NULL, 'Endoribonuclease Dicer-like', 115, NULL, NULL, 36617),
(36618, '3.20.20.220-FF-000054', NULL, 'Proline dehydrogenase', 294, NULL, NULL, 36618),
(36619, '3.90.79.20-FF-000010', NULL, 'MutT/nudix family protein', 137, NULL, NULL, 36619),
(36620, '2.60.40.420-FF-000276', NULL, 'Uncharacterized protein', 231, NULL, NULL, 36620),
(36621, '2.60.40.10-FF-000236', NULL, 'Sidekick cell adhesion molecule 2', 90, NULL, NULL, 36621),
(36622, '1.50.40.10-FF-000503', NULL, 'Uncharacterized protein', 257, NULL, NULL, 36622),
(36623, '1.10.10.160-FF-000049', NULL, 'UvrD/REP helicase family protein', 83, NULL, NULL, 36623),
(36624, '2.60.40.10-FF-003581', NULL, NULL, 123, NULL, NULL, 36624),
(36625, '3.30.60.30-FF-000130', NULL, 'Predicted protein', 37, NULL, NULL, 36625),
(36626, '3.20.20.140-FF-000182', NULL, 'Amidohydrolase', 134, NULL, NULL, 36626),
(36627, '2.60.120.290-FF-000206', NULL, 'AGAP011910-PA', 122, NULL, NULL, 36627),
(36628, '3.40.50.20-FF-000008', NULL, 'Synapsin III', 111, NULL, NULL, 36628),
(36629, '2.60.40.10-FF-004070', NULL, NULL, 120, NULL, NULL, 36629),
(36630, '3.50.50.60-FF-000683', NULL, 'Uncharacterized protein', 178, NULL, NULL, 36630),
(36631, '3.30.160.60-FF-005828', NULL, NULL, 16, NULL, NULL, 36631),
(36632, '1.10.510.10-FF-001958', NULL, 'Kinase', 257, NULL, NULL, 36632),
(36633, '3.40.50.300-FF-001529', NULL, 'Peroxisome biosynthesis protein-like protein (PAS1/Peroxin-1)', 192, NULL, NULL, 36633),
(36634, '1.25.50.20-FF-000043', NULL, 'GD16024', 325, NULL, NULL, 36634),
(36635, '1.10.30.10-FF-000004', NULL, 'Transcription factor SOX-10', 79, NULL, NULL, 36635),
(36636, '1.25.40.120-FF-000056', NULL, 'Predicted protein', 234, NULL, NULL, 36636),
(36637, '3.30.420.10-FF-000495', NULL, NULL, 137, NULL, NULL, 36637),
(36638, '2.40.50.90-FF-000054', NULL, 'Nuclease domain containing protein', 128, NULL, NULL, 36638),
(36639, '3.30.420.10-FF-000315', NULL, NULL, 102, NULL, NULL, 36639),
(36640, '1.20.920.10-FF-000026', NULL, 'Histone-lysine N-methyltransferase', 108, NULL, NULL, 36640),
(36641, '2.10.25.10-FF-001676', NULL, 'Fibrillin-1, putative', 44, NULL, NULL, 36641),
(36642, '3.40.1110.10-FF-000480', NULL, NULL, 138, NULL, NULL, 36642),
(36643, '2.40.50.140-FF-000923', NULL, NULL, 150, NULL, NULL, 36643),
(36644, '1.20.1270.280-FF-000012', NULL, 'Dynein heavy chain-like protein', 181, NULL, NULL, 36644),
(36645, '2.130.10.10-FF-000214', NULL, 'WD repeat-containing protein 74', 145, NULL, NULL, 36645);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(36646, '3.40.718.10-FF-000072', NULL, 'Uncharacterized protein', 166, NULL, NULL, 36646),
(36647, '3.40.350.10-FF-000088', NULL, 'Aminopeptidase P AmpP', 143, NULL, NULL, 36647),
(36648, '3.90.550.10-FF-000103', NULL, 'Bacteriophage N4 adsorption protein B', 228, NULL, NULL, 36648),
(36649, '1.20.5.350-FF-000016', NULL, NULL, 54, NULL, NULL, 36649),
(36650, '1.20.120.350-FF-000072', NULL, 'Voltage-dependent T-type calcium channel subunit alpha', 125, NULL, NULL, 36650),
(36651, '3.40.390.10-FF-000208', NULL, NULL, 119, NULL, NULL, 36651),
(36652, '3.30.160.60-FF-002102', NULL, 'Zinc finger protein 33A', 29, NULL, NULL, 36652),
(36653, '1.10.287.160-FF-000005', NULL, 'Tyrosine-protein kinase', 93, NULL, NULL, 36653),
(36654, '3.30.200.20-FF-001622', NULL, 'Protein kinase', 121, NULL, NULL, 36654),
(36655, '3.80.10.10-FF-002856', NULL, 'RNI-like superfamily protein', 197, NULL, NULL, 36655),
(36656, '3.30.420.10-FF-000023', NULL, 'epithelial splicing regulatory protein 1 isoform X1', 196, NULL, NULL, 36656),
(36657, '1.10.8.10-FF-000047', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 51, NULL, NULL, 36657),
(36658, '1.10.510.10-FF-001666', NULL, 'Serine/threonine protein kinase', 217, NULL, NULL, 36658),
(36659, '3.40.190.10-FF-000671', NULL, 'Uncharacterized protein', 100, NULL, NULL, 36659),
(36660, '3.30.70.1180-FF-000002', NULL, 'V-type proton ATPase subunit C', 58, NULL, NULL, 36660),
(36661, '1.20.1250.20-FF-001005', NULL, 'Uncharacterized MFS-type transporter MT1289', 191, NULL, NULL, 36661),
(36662, '1.10.20.10-FF-000032', NULL, 'dr1-associated corepressor isoform X1', 75, NULL, NULL, 36662),
(36663, '3.40.50.1700-FF-000043', NULL, 'Predicted protein', 188, NULL, NULL, 36663),
(36664, '1.10.630.10-FF-000450', NULL, 'Os10g0171300 protein', 324, NULL, NULL, 36664),
(36665, '3.90.1720.10-FF-000014', NULL, 'Peptidoglycan endopeptidase LytF', 114, NULL, NULL, 36665),
(36666, '1.10.287.370-FF-000068', NULL, 'Prefoldin subunit 3', 56, NULL, NULL, 36666),
(36667, '3.40.50.1010-FF-000224', NULL, NULL, 102, NULL, NULL, 36667),
(36668, '1.20.120.160-FF-000048', NULL, 'Histidine containing phosphotransfer protein', 110, NULL, NULL, 36668),
(36669, '1.20.1560.10-FF-000295', NULL, 'MDR-like ABC transporter', 196, NULL, NULL, 36669),
(36670, '3.30.160.20-FF-000253', NULL, 'Uncharacterized protein', 48, NULL, NULL, 36670),
(36671, '1.20.1280.50-FF-000127', NULL, 'Uncharacterized protein', 102, NULL, NULL, 36671),
(36672, '1.25.40.10-FF-003473', NULL, 'Pentatricopeptide repeat-containing protein At4g33170', 96, NULL, NULL, 36672),
(36673, '2.40.50.140-FF-000569', NULL, 'WGS project CABT00000000 data, contig 2.17', 158, NULL, NULL, 36673),
(36674, '3.40.30.10-FF-000268', NULL, 'Thioredoxin domain-containing protein 17', 139, NULL, NULL, 36674),
(36675, '3.40.50.10190-FF-000239', NULL, 'Auxin-responsive protein', 48, NULL, NULL, 36675),
(36676, '3.30.160.60-FF-003384', NULL, 'Zinc finger protein 236', 80, NULL, NULL, 36676),
(36677, '2.10.25.10-FF-000574', NULL, 'laminin subunit alpha-1 isoform X1', 42, NULL, NULL, 36677),
(36678, '2.40.440.10-FF-000014', NULL, 'Enhanced entry protein', 129, NULL, NULL, 36678),
(36679, '3.40.50.620-FF-000198', NULL, 'GMP synthase (Glutamine-hydrolyzing) domain-containing protein', 205, NULL, NULL, 36679),
(36680, '3.40.50.620-FF-000552', NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', 355, NULL, NULL, 36680),
(36681, '3.60.10.10-FF-000249', NULL, 'Endonuclease/Exonuclease/phosphatase family, putative', 266, NULL, NULL, 36681),
(36682, '3.40.1350.100-FF-000005', NULL, 'Apicoplast TIC22 protein', 89, NULL, NULL, 36682),
(36683, '3.40.50.1000-FF-000221', NULL, 'Phospholipid-transporting ATPase', 196, NULL, NULL, 36683),
(36684, '3.40.50.200-FF-000162', NULL, 'Predicted protein', 172, NULL, NULL, 36684),
(36685, '1.20.58.60-FF-000594', NULL, 'Dystrophin', 193, NULL, NULL, 36685),
(36686, '1.10.10.440-FF-000010', NULL, 'Transcription elongation regulator 1 (CA150)', 78, NULL, NULL, 36686),
(36687, '2.60.40.60-FF-000875', NULL, 'E-cadherin-like protein', 106, NULL, NULL, 36687);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(36688, '3.40.720.10-FF-000341', NULL, 'Uncharacterized protein', 85, NULL, NULL, 36688),
(36689, '3.30.70.330-FF-001724', NULL, NULL, 98, NULL, NULL, 36689),
(36690, '2.10.50.10-FF-000054', NULL, 'UPF0577 protein KIAA1324 homolog', 71, NULL, NULL, 36690),
(36691, '3.30.720.170-FF-000003', NULL, 'Perilipin', 32, NULL, NULL, 36691),
(36692, '2.60.40.10-FF-005851', NULL, NULL, 100, NULL, NULL, 36692),
(36693, '2.130.10.10-FF-001349', NULL, 'AGAP002088-PA-like protein', 168, NULL, NULL, 36693),
(36694, '2.130.10.10-FF-004868', NULL, 'Uncharacterized protein', 122, NULL, NULL, 36694),
(36695, '2.60.40.10-FF-001338', NULL, 'MILR1 isoform 7', 88, NULL, NULL, 36695),
(36696, '1.10.533.10-FF-000128', NULL, 'Uncharacterized protein', 89, NULL, NULL, 36696),
(36697, '2.10.70.10-FF-000263', NULL, 'Pappalysin 2', 48, NULL, NULL, 36697),
(36698, '2.30.29.30-FF-000655', NULL, 'FERM domain (Protein4.1-ezrin-radixin-moesin) family', 101, NULL, NULL, 36698),
(36699, '3.40.50.300-FF-000220', NULL, 'ATP-dependent protease ATPase subunit HslU', 114, NULL, NULL, 36699),
(36700, '3.40.50.720-FF-000256', NULL, 'Trk system potassium transporter TrkA', 135, NULL, NULL, 36700),
(36701, '3.40.50.10900-FF-000020', NULL, 'Uncharacterized protein', 75, NULL, NULL, 36701),
(36702, '4.10.1130.20-FF-000001', NULL, 'Cysteine and histidine-rich domain-containing protein 1', 68, NULL, NULL, 36702),
(36703, '2.60.120.10-FF-000042', NULL, 'Hypoxia-inducible factor 1-alpha inhibitor', 298, NULL, NULL, 36703),
(36704, '1.20.58.770-FF-000001', NULL, 'Surface layer (S-layer) glycoprotein', 63, NULL, NULL, 36704),
(36705, '2.30.39.10-FF-000116', NULL, 'Serpin family I member 2', 101, NULL, NULL, 36705),
(36706, '3.40.50.300-FF-008151', NULL, 'Uncharacterized protein', 94, NULL, NULL, 36706),
(36707, '2.60.120.10-FF-000660', NULL, 'Uncharacterized protein', 127, NULL, NULL, 36707),
(36708, '3.90.660.10-FF-000078', NULL, NULL, 191, NULL, NULL, 36708),
(36709, '1.25.10.10-FF-002510', NULL, 'Predicted protein', 199, NULL, NULL, 36709),
(36710, '2.40.170.20-FF-000007', NULL, 'Ferric aerobactin receptor', 575, NULL, NULL, 36710),
(36711, '1.20.990.10-FF-000007', NULL, 'Methionine synthase reductase', 134, NULL, NULL, 36711),
(36712, '1.10.630.10-FF-000124', NULL, 'Cytochrome P450', 459, NULL, NULL, 36712),
(36713, '3.40.50.300-FF-000074', NULL, 'Multidrug resistance-associated protein 5 isoform 1', 251, NULL, NULL, 36713),
(36714, '3.40.50.880-FF-000051', NULL, 'Glutathione-independent glyoxalase HSP31', 237, NULL, NULL, 36714),
(36715, '3.30.980.10-FF-000025', NULL, 'Alanyl-tRNA editing protein AlaX-M', 147, NULL, NULL, 36715),
(36716, '1.25.40.10-FF-002012', NULL, 'Uncharacterized protein', 167, NULL, NULL, 36716),
(36717, '3.40.50.10930-FF-000001', NULL, 'RecBCD enzyme subunit RecC', 141, NULL, NULL, 36717),
(36718, '3.30.40.10-FF-001163', NULL, 'Uncharacterized protein', 53, NULL, NULL, 36718),
(36719, '2.30.30.490-FF-000048', NULL, 'DNA methyltransferase Dim-2', 128, NULL, NULL, 36719),
(36720, '2.30.42.10-FF-000495', NULL, NULL, 65, NULL, NULL, 36720),
(36721, '3.30.565.10-FF-000055', NULL, 'Two-component sensor histidine kinase', 153, NULL, NULL, 36721),
(36722, '2.60.120.340-FF-000036', NULL, 'Nucleophosmin/nucleoplasmin, 3', 49, NULL, NULL, 36722),
(36723, '1.10.8.720-FF-000028', NULL, 'Dynein heavy chain', 188, NULL, NULL, 36723),
(36724, '3.90.245.10-FF-000023', NULL, 'Inosine-uridine nucleoside N-ribohydrolase', 318, NULL, NULL, 36724),
(36725, '2.80.10.50-FF-000150', NULL, 'Otogelin', 150, NULL, NULL, 36725),
(36726, '3.20.20.80-FF-000699', NULL, 'Predicted protein', 322, NULL, NULL, 36726),
(36727, '1.50.40.10-FF-000149', NULL, 'Mitochondrial Carrier (MC) Family', 147, NULL, NULL, 36727),
(36728, '3.30.450.20-FF-000179', NULL, 'PAS domain-containing sensor histidine kinase', 130, NULL, NULL, 36728),
(36729, '3.40.1160.10-FF-000073', NULL, 'Delta-1-pyrroline-5-carboxylate synthase', 271, NULL, NULL, 36729),
(36730, '3.40.50.11260-FF-000038', NULL, 'Uncharacterized protein', 28, NULL, NULL, 36730),
(36731, '3.40.50.300-FF-001794', NULL, 'Eukaryotic translation initiation factor 2 subunit 3, variant', 207, NULL, NULL, 36731);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(36732, '3.40.630.150-FF-000014', NULL, 'Predicted protein', 295, NULL, NULL, 36732),
(36733, '2.60.40.10-FF-005407', NULL, NULL, 41, NULL, NULL, 36733),
(36734, '2.60.120.330-FF-000033', NULL, 'Clavaminate synthase-like protein', 321, NULL, NULL, 36734),
(36735, '3.40.50.150-FF-001288', NULL, NULL, 219, NULL, NULL, 36735),
(36736, '1.20.5.340-FF-000013', NULL, 'Myosin heavy chain', 116, NULL, NULL, 36736),
(36737, '3.30.70.330-FF-000909', NULL, 'Putative U2 snRNP component IST3', 112, NULL, NULL, 36737),
(36738, '3.30.710.10-FF-000388', NULL, 'Predicted protein', 126, NULL, NULL, 36738),
(36739, '2.130.10.10-FF-005683', NULL, 'Uncharacterized protein', 160, NULL, NULL, 36739),
(36740, '3.90.1150.10-FF-000459', NULL, 'Aminotransferase, classes I and II', 125, NULL, NULL, 36740),
(36741, '3.40.720.10-FF-000015', NULL, 'GPI ethanolamine phosphate transferase 1', 319, NULL, NULL, 36741),
(36742, '1.50.10.10-FF-000029', NULL, 'Family 65 glycosyl hydrolase', 360, NULL, NULL, 36742),
(36743, '1.20.1250.20-FF-000875', NULL, 'Uncharacterized protein', 208, NULL, NULL, 36743),
(36744, '3.40.50.300-FF-003946', NULL, 'Uncharacterized protein', 166, NULL, NULL, 36744),
(36745, '3.40.30.10-FF-001111', NULL, 'Uncharacterized protein', 20, NULL, NULL, 36745),
(36746, '1.10.4020.10-FF-000010', NULL, 'Uncharacterized protein', 52, NULL, NULL, 36746),
(36747, '1.20.1250.20-FF-001977', NULL, 'Transmembrane transporter, major facilitator family', 396, NULL, NULL, 36747),
(36748, '2.40.50.140-FF-000895', NULL, NULL, 83, NULL, NULL, 36748),
(36749, '3.40.50.10490-FF-000150', NULL, NULL, 161, NULL, NULL, 36749),
(36750, '3.40.50.2300-FF-000358', NULL, 'Two-component system response regulator VanR', 127, NULL, NULL, 36750),
(36751, '3.30.420.10-FF-000641', NULL, NULL, 146, NULL, NULL, 36751),
(36752, '1.10.1520.10-FF-000036', NULL, 'Ribonuclease 3-like protein 3', 182, NULL, NULL, 36752),
(36753, '3.80.10.10-FF-001900', NULL, 'FI21465p1', 139, NULL, NULL, 36753),
(36754, '1.20.1730.10-FF-000095', NULL, 'SGLT-1', 320, NULL, NULL, 36754),
(36755, '1.10.1790.20-FF-000002', NULL, 'DNA-directed RNA polymerase subunit beta''''', 138, NULL, NULL, 36755),
(36756, '2.30.42.10-FF-000169', NULL, 'FERM and PDZ domain containing 3', 92, NULL, NULL, 36756),
(36757, '1.20.120.1320-FF-000015', NULL, NULL, 86, NULL, NULL, 36757),
(36758, '1.10.472.80-FF-000052', NULL, 'Putative TBC domain protein', 127, NULL, NULL, 36758),
(36759, '1.10.287.130-FF-000081', NULL, 'Hybrid sensor histidine kinase/response regulator', 97, NULL, NULL, 36759),
(36760, '3.40.720.10-FF-000369', NULL, 'Os03g0852800 protein', 76, NULL, NULL, 36760),
(36761, '3.40.1110.10-FF-000154', NULL, 'Putative P-type ATPase', 258, NULL, NULL, 36761),
(36762, '3.10.20.90-FF-000051', NULL, 'Unconventional myosin-VIIa', 98, NULL, NULL, 36762),
(36763, '3.30.70.270-FF-000077', NULL, 'DNA polymerase IV', 135, NULL, NULL, 36763),
(36764, '3.40.630.30-FF-000082', NULL, 'Acetyltransferase, GNAT family', 155, NULL, NULL, 36764),
(36765, '2.30.40.10-FF-000007', NULL, 'Dihydroorotase', 63, NULL, NULL, 36765),
(36766, '2.70.130.10-FF-000080', NULL, NULL, 149, NULL, NULL, 36766),
(36767, '3.20.20.70-FF-000163', NULL, 'Transaldolase B', 331, NULL, NULL, 36767),
(36768, '3.30.200.20-FF-000779', NULL, 'Os09g0251100 protein', 103, NULL, NULL, 36768),
(36769, '3.40.1800.20-FF-000013', NULL, 'AGAP011758-PA', 75, NULL, NULL, 36769),
(36770, '3.10.20.410-FF-000012', NULL, 'Heat shock protein E', 131, NULL, NULL, 36770),
(36771, '3.30.230.10-FF-000278', NULL, 'Uncharacterized protein', 128, NULL, NULL, 36771),
(36772, '1.10.1040.50-FF-000005', NULL, 'Probable 3-hydroxyacyl-CoA dehydrogenase', 210, NULL, NULL, 36772),
(36773, '2.10.25.10-FF-000248', NULL, 'pikachurin isoform X3', 34, NULL, NULL, 36773),
(36774, '3.30.930.10-FF-000106', NULL, 'Serine--tRNA ligase, mitochondrial', 144, NULL, NULL, 36774),
(36775, '1.10.8.60-FF-000455', NULL, 'Uncharacterized protein', 125, NULL, NULL, 36775),
(36776, '3.30.9.10-FF-000056', NULL, 'Glycerol-3-phosphate dehydrogenase', 167, NULL, NULL, 36776);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(36777, '1.10.390.10-FF-000116', NULL, 'Uncharacterized protein', 141, NULL, NULL, 36777),
(36778, '3.30.70.260-FF-000074', NULL, 'Os10g0523700 protein', 120, NULL, NULL, 36778),
(36779, '3.30.40.10-FF-002298', NULL, 'Probable ubiquitin carboxyl-terminal hydrolase 7', 117, NULL, NULL, 36779),
(36780, '1.20.1440.340-FF-000007', NULL, 'Ribosomal protein S5 domain 2-type protein', 141, NULL, NULL, 36780),
(36781, '3.30.470.10-FF-000026', NULL, 'Branched-chain-amino-acid aminotransferase', 181, NULL, NULL, 36781),
(36782, '3.40.50.1820-FF-000287', NULL, 'Steryl ester hydrolase, putative', 254, NULL, NULL, 36782),
(36783, '2.10.250.10-FF-000012', NULL, 'Uncharacterized protein', 101, NULL, NULL, 36783),
(36784, '3.40.605.10-FF-000118', NULL, 'Succinate semialdehyde dehydrogenase, putative', 251, NULL, NULL, 36784),
(36785, '3.40.50.300-FF-001176', NULL, 'Adenylate kinase isoenzyme 5', 198, NULL, NULL, 36785),
(36786, '3.30.1610.10-FF-000014', NULL, 'Uncharacterized protein', 142, NULL, NULL, 36786),
(36787, '4.10.240.10-FF-000167', NULL, 'Negative regulator of pleiotropic drug resistance STB5', 88, NULL, NULL, 36787),
(36788, '2.60.200.30-FF-000021', NULL, 'NADH kinase, variant 3', 147, NULL, NULL, 36788),
(36789, '1.10.510.10-FF-004100', NULL, NULL, 131, NULL, NULL, 36789),
(36790, '3.90.190.10-FF-000620', NULL, 'Protein-tyrosine-phosphatase', 66, NULL, NULL, 36790),
(36791, '1.10.510.10-FF-003611', NULL, NULL, 199, NULL, NULL, 36791),
(36792, '2.30.29.30-FF-000829', NULL, 'TBC1 domain family member 9', 110, NULL, NULL, 36792),
(36793, '3.20.20.140-FF-000474', NULL, 'Predicted protein', 155, NULL, NULL, 36793),
(36794, '1.10.10.10-FF-001077', NULL, 'Os01g0753300 protein', 102, NULL, NULL, 36794),
(36795, '1.50.40.10-FF-000475', NULL, 'Predicted protein', 291, NULL, NULL, 36795),
(36796, '2.130.10.10-FF-003912', NULL, 'AGAP008550-PA', 265, NULL, NULL, 36796),
(36797, '3.20.20.140-FF-000210', NULL, 'Deoxyribonuclease tatD', 354, NULL, NULL, 36797),
(36798, '3.40.50.300-FF-005537', NULL, 'At1g03030', 62, NULL, NULL, 36798),
(36799, '3.30.420.40-FF-000037', NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase', 141, NULL, NULL, 36799),
(36800, '1.25.40.10-FF-004575', NULL, 'Uncharacterized protein', 287, NULL, NULL, 36800),
(36801, '1.10.238.10-FF-000431', NULL, 'Serine/threonine-protein phosphatase', 177, NULL, NULL, 36801),
(36802, '3.30.1370.210-FF-000001', NULL, 'Muscleblind-like 2 isoform 1', 83, NULL, NULL, 36802),
(36803, '3.10.580.10-FF-000106', NULL, 'Putative manganese-dependent inorganic pyrophosphatase', 110, NULL, NULL, 36803),
(36804, '2.130.10.10-FF-001760', NULL, 'Uncharacterized protein', 182, NULL, NULL, 36804),
(36805, '1.25.10.60-FF-000001', NULL, 'Rad61p', 371, NULL, NULL, 36805),
(36806, '2.60.40.10-FF-003873', NULL, NULL, 88, NULL, NULL, 36806),
(36807, '3.20.20.190-FF-000090', NULL, 'Phosphoinositide phospholipase C', 210, NULL, NULL, 36807),
(36808, '3.30.2320.80-FF-000002', NULL, 'Hydrogenase maturation factor HypA', 117, NULL, NULL, 36808),
(36809, '1.10.1420.10-FF-000152', NULL, 'MutS domain III family protein', 120, NULL, NULL, 36809),
(36810, '3.40.50.410-FF-000135', NULL, 'Alpha-protein kinase vwkA', 137, NULL, NULL, 36810),
(36811, '3.40.720.10-FF-000162', NULL, 'Predicted protein', 141, NULL, NULL, 36811),
(36812, '1.25.10.70-FF-000004', NULL, 'Uncharacterized protein', 329, NULL, NULL, 36812),
(36813, '3.40.50.2000-FF-000858', NULL, 'Glycogen synthase 1', 208, NULL, NULL, 36813),
(36814, '2.60.40.10-FF-001664', NULL, 'Hemicentin 2', 94, NULL, NULL, 36814),
(36815, '2.60.40.60-FF-000083', NULL, 'Desmoglein 1', 118, NULL, NULL, 36815),
(36816, '1.25.10.10-FF-001049', NULL, 'HEAT repeat-containing protein 5A', 611, NULL, NULL, 36816),
(36817, '1.10.287.70-FF-000528', NULL, 'Ion transport 2 domain protein', 90, NULL, NULL, 36817),
(36818, '3.30.1780.10-FF-000026', NULL, 'Uncharacterized protein', 28, NULL, NULL, 36818),
(36819, '1.20.1260.100-FF-000001', NULL, 'translocator protein 2', 156, NULL, NULL, 36819),
(36820, '1.20.1270.60-FF-000012', NULL, 'Sorting nexin 2', 223, NULL, NULL, 36820);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(36821, '2.10.25.10-FF-000395', NULL, 'Dumpy, isoform P', 33, NULL, NULL, 36821),
(36822, '2.170.300.10-FF-000075', NULL, 'Uncharacterized protein', 135, NULL, NULL, 36822),
(36823, '3.80.10.10-FF-003053', NULL, 'Predicted protein', 150, NULL, NULL, 36823),
(36824, '3.10.490.20-FF-000023', NULL, 'Dynein heavy chain', 149, NULL, NULL, 36824),
(36825, '1.10.510.10-FF-003875', NULL, NULL, 92, NULL, NULL, 36825),
(36826, '1.20.1260.110-FF-000004', NULL, 'DNA integrity scanning protein DisA', 145, NULL, NULL, 36826),
(36827, '1.20.120.1240-FF-000082', NULL, 'Predicted protein', 219, NULL, NULL, 36827),
(36828, '1.25.40.20-FF-000132', NULL, 'M-phase phosphoprotein 8 isoform X1', 177, NULL, NULL, 36828),
(36829, '2.30.29.30-FF-001111', NULL, 'Uncharacterized protein', 138, NULL, NULL, 36829),
(36830, '3.40.50.12160-FF-000033', NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase', 130, NULL, NULL, 36830),
(36831, '1.20.5.490-FF-000007', NULL, 'Nuclear pore complex protein Nup54', 64, NULL, NULL, 36831),
(36832, '3.40.630.30-FF-000048', NULL, 'Glucosamine 6-phosphate N-acetyltransferase', 157, NULL, NULL, 36832),
(36833, '2.30.110.10-FF-000020', NULL, 'PNPO isoform 11', 213, NULL, NULL, 36833),
(36834, '3.30.160.60-FF-005593', NULL, NULL, 30, NULL, NULL, 36834),
(36835, '1.20.58.60-FF-000476', NULL, 'Uncharacterized protein, isoform B', 106, NULL, NULL, 36835),
(36836, '3.30.1370.50-FF-000024', NULL, 'Fgr44p', 149, NULL, NULL, 36836),
(36837, '3.40.50.1440-FF-000004', NULL, 'Tubulin alpha chain', 268, NULL, NULL, 36837),
(36838, '1.10.10.10-FF-001548', NULL, 'Apaf-1/CED-4-related caspase activator Dapaf-1S', 81, NULL, NULL, 36838),
(36839, '1.20.1250.20-FF-000903', NULL, 'Solute carrier family 22 member 13', 396, NULL, NULL, 36839),
(36840, '3.40.120.10-FF-000020', NULL, 'Phosphoglucosamine mutase', 89, NULL, NULL, 36840),
(36841, '1.25.10.10-FF-003319', NULL, 'Serine/threonine-protein kinase TOR', 145, NULL, NULL, 36841),
(36842, '3.30.1330.40-FF-000013', NULL, 'Chorismate mutase', 119, NULL, NULL, 36842),
(36843, '2.130.10.10-FF-000332', NULL, 'glutamate-rich WD repeat-containing protein 1', 398, NULL, NULL, 36843),
(36844, '3.50.30.30-FF-000105', NULL, 'Putative N-acetylated-alpha-linked acidic dipeptidase', 38, NULL, NULL, 36844),
(36845, '3.10.20.90-FF-000017', NULL, 'partitioning defective 3 homolog isoform X2', 83, NULL, NULL, 36845),
(36846, '3.30.1740.10-FF-000018', NULL, 'Poly [ADP-ribose] polymerase', 110, NULL, NULL, 36846),
(36847, '3.40.50.1450-FF-000007', NULL, 'Hydrogenase maturation protease', 137, NULL, NULL, 36847),
(36848, '3.55.40.10-FF-000005', NULL, 'Type 4 fimbrial biogenesis protein FimT', 130, NULL, NULL, 36848),
(36849, '3.30.1330.30-FF-000010', NULL, 'tRNA/rRNA methyltransferase', 81, NULL, NULL, 36849),
(36850, '3.40.720.10-FF-000223', NULL, 'Probable sulfatase atsG', 351, NULL, NULL, 36850),
(36851, '1.25.50.20-FF-000104', NULL, 'GH14075p', 106, NULL, NULL, 36851),
(36852, '3.40.50.2000-FF-000712', NULL, 'Mannosyl transferase', 167, NULL, NULL, 36852),
(36853, '3.40.1110.10-FF-000362', NULL, NULL, 110, NULL, NULL, 36853),
(36854, '2.60.40.1390-FF-000019', NULL, 'Uncharacterized protein', 244, NULL, NULL, 36854),
(36855, '1.20.1070.10-FF-001145', NULL, 'growth hormone secretagogue receptor type 1-like isoform X1', 348, NULL, NULL, 36855),
(36856, '3.30.60.90-FF-000007', NULL, 'Next to BRCA1 gene 1 protein', 52, NULL, NULL, 36856),
(36857, '3.40.50.1820-FF-001130', NULL, 'Uncharacterized protein', 135, NULL, NULL, 36857),
(36858, '1.10.1200.10-FF-000169', NULL, 'Predicted protein', 44, NULL, NULL, 36858),
(36859, '3.50.50.60-FF-001054', NULL, 'Sulfide quinone oxidoreductase', 75, NULL, NULL, 36859),
(36860, '2.40.50.100-FF-000113', NULL, 'Membrane fusion protein (MFP) family protein', 32, NULL, NULL, 36860),
(36861, '3.40.190.10-FF-000114', NULL, 'Amino acid ABC transporter substrate-binding protein', 96, NULL, NULL, 36861),
(36862, '3.90.190.10-FF-000474', NULL, 'Uncharacterized protein', 309, NULL, NULL, 36862),
(36863, '3.40.50.410-FF-000253', NULL, 'ANTXR cell adhesion molecule 1d', 95, NULL, NULL, 36863);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(36864, '2.130.10.10-FF-005065', NULL, 'Uncharacterized protein', 272, NULL, NULL, 36864),
(36865, '3.40.1280.30-FF-000031', NULL, 'Uncharacterized protein', 200, NULL, NULL, 36865),
(36866, '3.30.70.1730-FF-000066', NULL, 'Uncharacterized protein', 50, NULL, NULL, 36866),
(36867, '3.40.50.300-FF-003385', NULL, 'tRNA dimethylallyltransferase', 132, NULL, NULL, 36867),
(36868, '3.40.50.300-FF-003328', NULL, 'ISMt2 transposase B', 186, NULL, NULL, 36868),
(36869, '3.10.50.40-FF-000032', NULL, 'Peptidylprolyl isomerase', 127, NULL, NULL, 36869),
(36870, '1.20.1270.60-FF-000276', NULL, 'Dip13 beta, putative', 51, NULL, NULL, 36870),
(36871, '2.60.120.430-FF-000029', NULL, 'F-box only protein 2', 147, NULL, NULL, 36871),
(36872, '1.10.10.160-FF-000050', NULL, 'DNA helicase', 102, NULL, NULL, 36872),
(36873, '1.25.40.20-FF-001705', NULL, 'Predicted protein', 57, NULL, NULL, 36873),
(36874, '1.10.150.50-FF-000239', NULL, 'Uncharacterized protein', 63, NULL, NULL, 36874),
(36875, '1.25.40.10-FF-001702', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 161, NULL, NULL, 36875),
(36876, '3.30.465.10-FF-000076', NULL, 'FAD linked oxidase domain protein', 218, NULL, NULL, 36876),
(36877, '3.80.10.10-FF-001400', NULL, 'KEKKON4', 117, NULL, NULL, 36877),
(36878, '3.40.50.1820-FF-000079', NULL, 'Abhydrolase domain-containing 3', 294, NULL, NULL, 36878),
(36879, '3.30.160.60-FF-003558', NULL, NULL, 29, NULL, NULL, 36879),
(36880, '3.40.50.300-FF-000102', NULL, 'RNA helicase, activating signal cointegrator 1', 213, NULL, NULL, 36880),
(36881, '3.10.350.10-FF-000095', NULL, 'Uncharacterized protein', 42, NULL, NULL, 36881),
(36882, '2.10.90.10-FF-000146', NULL, 'Uncharacterized protein', 106, NULL, NULL, 36882),
(36883, '1.10.287.470-FF-000008', NULL, 'HlyD family efflux transporter periplasmic adaptor subunit', 32, NULL, NULL, 36883),
(36884, '3.10.290.10-FF-000005', NULL, '40S ribosomal protein S9', 58, NULL, NULL, 36884),
(36885, '1.20.1270.60-FF-000219', NULL, 'Uncharacterized protein', 227, NULL, NULL, 36885),
(36886, '3.30.365.10-FF-000074', NULL, 'AGAP006220-PA', 95, NULL, NULL, 36886),
(36887, '3.30.160.60-FF-001259', NULL, 'Zinc finger protein 697', 26, NULL, NULL, 36887),
(36888, '1.10.730.10-FF-000103', NULL, 'GM25865', 204, NULL, NULL, 36888),
(36889, '1.10.10.60-FF-000849', NULL, NULL, 58, NULL, NULL, 36889),
(36890, '2.130.10.130-FF-000031', NULL, 'Phosphatidylinositol-glycan-specific phospholipase D', 260, NULL, NULL, 36890),
(36891, '2.60.40.10-FF-001456', NULL, 'CD101 molecule', 117, NULL, NULL, 36891),
(36892, '2.30.30.140-FF-000202', NULL, 'Tudor, isoform B', 53, NULL, NULL, 36892),
(36893, '3.40.80.10-FF-000007', NULL, 'N-acetylmuramoyl-L-alanine amidase XlyA', 155, NULL, NULL, 36893),
(36894, '3.20.20.80-FF-000727', NULL, 'Uncharacterized protein', 130, NULL, NULL, 36894),
(36895, '2.60.120.820-FF-000023', NULL, 'Predicted protein', 71, NULL, NULL, 36895),
(36896, '3.20.20.140-FF-000002', NULL, 'AMP deaminase', 437, NULL, NULL, 36896),
(36897, '3.10.290.20-FF-000008', NULL, 'SUMO-activating enzyme subunit', 158, NULL, NULL, 36897),
(36898, '3.40.50.300-FF-004317', NULL, 'Predicted protein', 129, NULL, NULL, 36898),
(36899, '1.20.58.2220-FF-000053', NULL, 'FMN2 protein, putative', 146, NULL, NULL, 36899),
(36900, '2.40.270.10-FF-000006', NULL, 'DNA-directed RNA polymerase subunit beta', 84, NULL, NULL, 36900),
(36901, '3.30.240.40-FF-000001', NULL, 'Protein E6', 72, NULL, NULL, 36901),
(36902, '3.20.20.70-FF-000724', NULL, NULL, 103, NULL, NULL, 36902),
(36903, '3.40.50.1100-FF-000217', NULL, 'Uncharacterized protein', 64, NULL, NULL, 36903),
(36904, '3.20.20.190-FF-000056', NULL, 'Ankyrin repeat protein nuc-2', 285, NULL, NULL, 36904),
(36905, '3.80.10.10-FF-000883', NULL, 'RAN GTPase-activating protein 2', 286, NULL, NULL, 36905),
(36906, '3.40.190.80-FF-000028', NULL, 'Fructose-1,6-bisphosphatase class 1', 126, NULL, NULL, 36906),
(36907, '3.10.20.70-FF-000011', NULL, 'Glutamine synthetase', 112, NULL, NULL, 36907),
(36908, '3.40.605.10-FF-000091', NULL, 'Uncharacterized protein', 35, NULL, NULL, 36908);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(36909, '1.10.287.70-FF-000562', NULL, 'Uncharacterized protein', 84, NULL, NULL, 36909),
(36910, '3.30.160.60-FF-001793', NULL, 'Blast:Protein drumstick', 27, NULL, NULL, 36910),
(36911, '3.40.50.150-FF-001434', NULL, NULL, 149, NULL, NULL, 36911),
(36912, '3.30.460.10-FF-000087', NULL, 'Poly(A) RNA polymerase, mitochondrial', 133, NULL, NULL, 36912),
(36913, '3.60.10.10-FF-000367', NULL, 'Uncharacterized protein', 117, NULL, NULL, 36913),
(36914, '2.30.42.10-FF-000523', NULL, NULL, 66, NULL, NULL, 36914),
(36915, '2.60.40.1360-FF-000010', NULL, 'Lysosomal alpha-mannosidase', 127, NULL, NULL, 36915),
(36916, '3.40.710.10-FF-000043', NULL, 'Penicillin-binding protein 2A', 355, NULL, NULL, 36916),
(36917, '3.20.20.140-FF-000148', NULL, 'D-hydantoinase, putative', 366, NULL, NULL, 36917),
(36918, '2.60.40.10-FF-005087', NULL, NULL, 100, NULL, NULL, 36918),
(36919, '2.30.29.30-FF-000268', NULL, 'Rho guanine nucleotide exchange factor 17', 123, NULL, NULL, 36919),
(36920, '3.40.630.10-FF-000042', NULL, 'Peptide hydrolase', 290, NULL, NULL, 36920),
(36921, '3.40.910.10-FF-000024', NULL, 'Uncharacterized protein', 253, NULL, NULL, 36921),
(36922, '2.60.120.10-FF-000216', NULL, 'Crp/Fnr family transcriptional regulator', 133, NULL, NULL, 36922),
(36923, '1.20.1560.10-FF-000856', NULL, 'Uncharacterized protein', 329, NULL, NULL, 36923),
(36924, '3.40.50.360-FF-000070', NULL, 'Bifunctional sulfite reductase [NADPH] flavoprotein alpha-component/iron-uptake factor', 171, NULL, NULL, 36924),
(36925, '3.30.1360.120-FF-000062', NULL, 'Uncharacterized protein', 197, NULL, NULL, 36925),
(36926, '3.40.50.360-FF-000159', NULL, 'Uncharacterized protein', 68, NULL, NULL, 36926),
(36927, '3.40.50.2300-FF-001139', NULL, NULL, 94, NULL, NULL, 36927),
(36928, '3.10.20.80-FF-000014', NULL, 'Uncharacterized protein', 60, NULL, NULL, 36928),
(36929, '1.25.40.10-FF-004783', NULL, 'Paf1 complex component', 184, NULL, NULL, 36929),
(36930, '2.60.40.10-FF-003547', NULL, NULL, 96, NULL, NULL, 36930),
(36931, '1.25.40.10-FF-003355', NULL, 'Pentatricopeptide repeat-containing protein At3g13880', 75, NULL, NULL, 36931),
(36932, '3.40.630.10-FF-000250', NULL, 'Peptidase M20 domain-containing protein 2', 220, NULL, NULL, 36932),
(36933, '3.10.20.90-FF-000225', NULL, 'Auxin-responsive protein', 117, NULL, NULL, 36933),
(36934, '3.40.50.720-FF-002055', NULL, 'Hydroxysteroid (17-beta) dehydrogenase 14', 172, NULL, NULL, 36934),
(36935, '1.20.5.170-FF-000232', NULL, 'Predicted protein', 72, NULL, NULL, 36935),
(36936, '1.10.3090.10-FF-000019', NULL, 'YALI0D03267p', 162, NULL, NULL, 36936),
(36937, '1.10.510.10-FF-001992', NULL, 'Kinase, NEK', 208, NULL, NULL, 36937),
(36938, '3.30.160.60-FF-000006', NULL, 'Zinc finger protein 184 (Kruppel-like)', 28, NULL, NULL, 36938),
(36939, '2.10.25.10-FF-000782', NULL, 'Milk fat globule-EGF factor 8 protein', 51, NULL, NULL, 36939),
(36940, '1.20.120.850-FF-000042', NULL, 'Uncharacterized protein', 31, NULL, NULL, 36940),
(36941, '3.30.160.60-FF-000124', NULL, 'IKAROS family zinc finger 4', 27, NULL, NULL, 36941),
(36942, '1.20.58.390-FF-000303', NULL, 'Uncharacterized protein', 74, NULL, NULL, 36942),
(36943, '3.30.40.10-FF-002383', NULL, 'TNF receptor-associated factor', 60, NULL, NULL, 36943),
(36944, '2.110.10.10-FF-000024', NULL, 'Matrix metalloproteinase-16-like Protein', 200, NULL, NULL, 36944),
(36945, '2.40.50.100-FF-000170', NULL, 'Exosome complex component Rrp4', 64, NULL, NULL, 36945),
(36946, '3.40.50.300-FF-007454', NULL, 'Uncharacterized protein', 245, NULL, NULL, 36946),
(36947, '2.70.98.30-FF-000021', NULL, 'Predicted protein', 250, NULL, NULL, 36947),
(36948, '3.40.630.30-FF-000256', NULL, 'Putative lysine N-acyltransferase C17G9.06c', 197, NULL, NULL, 36948),
(36949, '3.30.420.10-FF-000287', NULL, 'DNA polymerase III subunit epsilon', 193, NULL, NULL, 36949),
(36950, '1.10.150.20-FF-000079', NULL, 'Putative DNA repair endonuclease', 73, NULL, NULL, 36950),
(36951, '3.40.50.300-FF-004110', NULL, 'DNA2/NAM7 helicase, putative', 195, NULL, NULL, 36951),
(36952, '3.10.450.40-FF-000055', NULL, NULL, 123, NULL, NULL, 36952);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(36953, '3.10.450.50-FF-000058', NULL, 'Aromatic-ring-hydroxylating dioxygenase subunit beta', 167, NULL, NULL, 36953),
(36954, '1.25.40.10-FF-005300', NULL, 'Outer membrane lipoprotein LppC', 131, NULL, NULL, 36954),
(36955, '3.60.40.10-FF-000138', NULL, '5-azacytidine resistance protein azr1', 127, NULL, NULL, 36955),
(36956, '1.20.58.60-FF-000268', NULL, 'Microtubule-actin cross-linking factor 1', 110, NULL, NULL, 36956),
(36957, '3.20.20.80-FF-000019', NULL, 'glycoprotein endo-alpha-1,2-mannosidase', 355, NULL, NULL, 36957),
(36958, '3.30.110.10-FF-000005', NULL, 'Translation initiation factor 3 (IF-3) family protein', 92, NULL, NULL, 36958),
(36959, '3.40.1170.10-FF-000045', NULL, 'DNA mismatch repair protein', 51, NULL, NULL, 36959),
(36960, '2.60.120.920-FF-000114', NULL, 'Si:ch211-76m11.5', 177, NULL, NULL, 36960),
(36961, '3.40.50.150-FF-000540', NULL, 'Protein N-terminal and lysine N-methyltransferase EFM7', 228, NULL, NULL, 36961),
(36962, '1.10.472.130-FF-000042', NULL, 'Dynein heavy chain', 183, NULL, NULL, 36962),
(36963, '3.30.200.20-FF-002286', NULL, 'Uncharacterized protein', 105, NULL, NULL, 36963),
(36964, '2.20.100.10-FF-000067', NULL, 'Hemicentin 1', 55, NULL, NULL, 36964),
(36965, '3.80.10.10-FF-002648', NULL, 'Leucine rich repeat containing 40, isoform CRA_a', 133, NULL, NULL, 36965),
(36966, '1.20.1070.10-FF-000802', NULL, 'Predicted protein', 313, NULL, NULL, 36966),
(36967, '3.20.20.70-FF-000016', NULL, 'Triosephosphate isomerase', 251, NULL, NULL, 36967),
(36968, '3.40.50.300-FF-005245', NULL, 'AGAP005161-PA', 194, NULL, NULL, 36968),
(36969, '3.40.50.10190-FF-000324', NULL, 'Uncharacterized protein', 82, NULL, NULL, 36969),
(36970, '1.10.238.10-FF-001179', NULL, 'Uncharacterized protein', 90, NULL, NULL, 36970),
(36971, '1.20.1640.10-FF-000003', NULL, 'protein patched homolog 1', 215, NULL, NULL, 36971),
(36972, '3.40.50.300-FF-007336', NULL, 'Predicted protein', 143, NULL, NULL, 36972),
(36973, '1.20.1070.10-FF-000482', NULL, 'NeuroPeptide Receptor family', 357, NULL, NULL, 36973),
(36974, '1.20.1250.20-FF-000960', NULL, 'Major facilitator superfamily MFS_1', 188, NULL, NULL, 36974),
(36975, '1.10.8.60-FF-000163', NULL, 'AAA family ATPase', 122, NULL, NULL, 36975),
(36976, '3.40.190.10-FF-000699', NULL, 'Orphan ABC-type transport system substrate-binding component', 126, NULL, NULL, 36976),
(36977, '3.20.20.300-FF-000073', NULL, NULL, 364, NULL, NULL, 36977),
(36978, '2.60.120.650-FF-000039', NULL, 'JmjC domain-containing protein 8', 230, NULL, NULL, 36978),
(36979, '3.20.20.70-FF-000078', NULL, 'Fatty acid synthase beta subunit dehydratase', 289, NULL, NULL, 36979),
(36980, '3.30.70.330-FF-001371', NULL, 'AGAP013051-PA', 78, NULL, NULL, 36980),
(36981, '1.20.1720.10-FF-000004', NULL, 'EmrB/QacA family drug resistance transporter', 209, NULL, NULL, 36981),
(36982, '3.20.20.60-FF-000013', NULL, 'Citrate lyase beta subunit', 308, NULL, NULL, 36982),
(36983, '3.80.10.10-FF-004481', NULL, 'Predicted protein', 133, NULL, NULL, 36983),
(36984, '3.40.50.720-FF-000464', NULL, 'Lysine-ketoglutarate reductase/saccharopine dehydrogenase', 171, NULL, NULL, 36984),
(36985, '3.30.160.60-FF-006110', NULL, NULL, 51, NULL, NULL, 36985),
(36986, '2.40.40.20-FF-000049', NULL, 'Acetylene hydratase', 161, NULL, NULL, 36986),
(36987, '1.10.10.60-FF-000321', NULL, 'Small nuclear RNA-activating complex, polypeptide 4', 56, NULL, NULL, 36987),
(36988, '3.80.10.10-FF-001136', NULL, 'Probable inactive receptor kinase At3g08680', 41, NULL, NULL, 36988),
(36989, '1.10.245.10-FF-000009', NULL, 'Uncharacterized protein, isoform A', 84, NULL, NULL, 36989),
(36990, '2.40.20.10-FF-000101', NULL, 'Uncharacterized protein', 95, NULL, NULL, 36990),
(36991, '3.60.20.10-FF-000194', NULL, NULL, 230, NULL, NULL, 36991),
(36992, '6.10.250.3450-FF-000003', NULL, 'Uncharacterized protein', 33, NULL, NULL, 36992),
(36993, '1.50.40.10-FF-000183', NULL, 'Protein CBG09342', 294, NULL, NULL, 36993),
(36994, '1.25.10.10-FF-002072', NULL, 'Predicted protein', 154, NULL, NULL, 36994),
(36995, '2.130.10.10-FF-003766', NULL, 'Uncharacterized protein', 321, NULL, NULL, 36995);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(36996, '3.20.200.10-FF-000003', NULL, 'alpha-protein kinase 3', 108, NULL, NULL, 36996),
(36997, '3.90.360.10-FF-000009', NULL, 'Histone AcetylTransferase', 124, NULL, NULL, 36997),
(36998, '3.60.40.10-FF-000195', NULL, 'Putative regulatory protein', 222, NULL, NULL, 36998),
(36999, '2.60.40.60-FF-000318', NULL, 'Dachsous cadherin-related 2', 124, NULL, NULL, 36999),
(37000, '3.90.340.10-FF-000003', NULL, 'Nitric oxide synthase oxygenase', 128, NULL, NULL, 37000),
(37001, '2.60.200.40-FF-000057', NULL, 'Diacylglycerol kinase', 176, NULL, NULL, 37001),
(37002, '3.40.50.1820-FF-000933', NULL, 'Uncharacterized protein', 350, NULL, NULL, 37002),
(37003, '3.40.1190.10-FF-000046', NULL, NULL, 51, NULL, NULL, 37003),
(37004, '3.30.1440.10-FF-000006', NULL, 'Uncharacterized protein', 191, NULL, NULL, 37004),
(37005, '1.10.472.10-FF-000020', NULL, 'CDK5 and ABL1 enzyme substrate 1', 142, NULL, NULL, 37005),
(37006, '3.40.50.1820-FF-000315', NULL, 'Probable carboxylesterase 18', 332, NULL, NULL, 37006),
(37007, '3.40.50.2300-FF-000684', NULL, 'Uncharacterized protein', 129, NULL, NULL, 37007),
(37008, '2.30.30.180-FF-000012', NULL, 'Ribosome maturation factor RimP', 67, NULL, NULL, 37008),
(37009, '1.20.140.150-FF-000111', NULL, 'Uncharacterized protein', 156, NULL, NULL, 37009),
(37010, '3.40.50.410-FF-000309', NULL, 'Uncharacterized protein', 141, NULL, NULL, 37010),
(37011, '1.10.510.10-FF-002301', NULL, 'Uncharacterized protein', 239, NULL, NULL, 37011),
(37012, '3.90.870.10-FF-000032', NULL, 'Uncharacterized protein', 74, NULL, NULL, 37012),
(37013, '3.30.505.10-FF-000107', NULL, 'Transcription elongation factor SPT6', 102, NULL, NULL, 37013),
(37014, '3.30.160.60-FF-001905', NULL, 'zinc finger protein 558 isoform X1', 37, NULL, NULL, 37014),
(37015, '2.130.10.10-FF-005711', NULL, 'Uncharacterized protein', 415, NULL, NULL, 37015),
(37016, '3.30.920.10-FF-000016', NULL, 'Uncharacterized protein', 111, NULL, NULL, 37016),
(37017, '1.25.40.10-FF-003147', NULL, 'Uncharacterized protein', 123, NULL, NULL, 37017),
(37018, '3.40.1190.20-FF-000049', NULL, 'Phosphomethylpyrimidine kinase', 281, NULL, NULL, 37018),
(37019, '3.30.1240.10-FF-000025', NULL, 'Cof family protein', 111, NULL, NULL, 37019),
(37020, '1.20.1740.10-FF-000067', NULL, 'Transmembrane domain transporter', 401, NULL, NULL, 37020),
(37021, '1.10.287.2620-FF-000019', NULL, 'Uncharacterized protein', 66, NULL, NULL, 37021),
(37022, '1.10.287.110-FF-000041', NULL, 'Chaperone protein DNAj, putative', 98, NULL, NULL, 37022),
(37023, '3.30.450.50-FF-000014', NULL, 'vesicle-associated membrane protein 727', 136, NULL, NULL, 37023),
(37024, '3.40.50.2000-FF-001139', NULL, 'Uncharacterized protein', 12, NULL, NULL, 37024),
(37025, '1.10.10.10-FF-001138', NULL, 'Serine/threonine protein kinase', 87, NULL, NULL, 37025),
(37026, '1.10.8.50-FF-000008', NULL, 'Nei-like DNA glycosylase 3', 138, NULL, NULL, 37026),
(37027, '2.60.40.60-FF-000111', NULL, 'Cadherin-related family member 1', 115, NULL, NULL, 37027),
(37028, '1.20.5.110-FF-000175', NULL, 'Syntaxin-related protein, putative', 106, NULL, NULL, 37028),
(37029, '3.30.160.60-FF-001198', NULL, 'zinc finger protein 629 isoform X2', 31, NULL, NULL, 37029),
(37030, '1.20.5.170-FF-000086', NULL, 'Transcription factor VIP1', 72, NULL, NULL, 37030),
(37031, '3.30.1490.20-FF-000046', NULL, 'Probable alpha-L-glutamate ligase', 65, NULL, NULL, 37031),
(37032, '3.30.930.10-FF-000045', NULL, 'lipoyltransferase 1, mitochondrial', 244, NULL, NULL, 37032),
(37033, '3.50.50.60-FF-001464', NULL, '3-oxo-5-alpha-steroid 4-dehydrogenase', 223, NULL, NULL, 37033),
(37034, '3.80.10.10-FF-000473', NULL, 'EIN3-binding F-box protein 1', 191, NULL, NULL, 37034),
(37035, '1.10.287.130-FF-000047', NULL, 'Two-component sensor histidine kinase', 64, NULL, NULL, 37035),
(37036, '1.20.1250.20-FF-000667', NULL, 'monocarboxylate transporter 2-like', 193, NULL, NULL, 37036),
(37037, '2.60.40.10-FF-001809', NULL, 'Neuromusculin, isoform E', 119, NULL, NULL, 37037),
(37038, '3.20.20.70-FF-000371', NULL, 'Putative 2-keto-3-deoxy-L-galactonate aldolase', 314, NULL, NULL, 37038);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(37039, '4.10.240.10-FF-000021', NULL, 'RSC complex subunit', 42, NULL, NULL, 37039),
(37040, '4.10.900.10-FF-000021', NULL, 'AGAP007216-PA', 90, NULL, NULL, 37040),
(37041, '3.40.50.300-FF-004109', NULL, 'Deletions Of G-rich DNA', 89, NULL, NULL, 37041),
(37042, '3.90.260.10-FF-000002', NULL, 'Erythrocyte membrane protein band 4.2', 319, NULL, NULL, 37042),
(37043, '1.10.167.10-FF-000024', NULL, 'A-kinase anchor protein 10, mitochondrial', 125, NULL, NULL, 37043),
(37044, '3.30.450.40-FF-000011', NULL, 'Phosphodiesterase', 182, NULL, NULL, 37044),
(37045, '3.90.190.10-FF-000592', NULL, 'Protein tyrosine phosphatase, receptor type, A', 53, NULL, NULL, 37045),
(37046, '1.20.1270.60-FF-000158', NULL, 'Bridging integrator 2', 96, NULL, NULL, 37046),
(37047, '1.10.246.230-FF-000001', NULL, 'Gamma-glutamyltransferase', 82, NULL, NULL, 37047),
(37048, '3.90.1480.20-FF-000009', NULL, 'alpha-N-acetylgalactosaminide alpha-2,6-sialyltransferase 6 isoform X2', 263, NULL, NULL, 37048),
(37049, '3.40.50.1460-FF-000128', NULL, 'Caspase, apoptotic cysteine protease, putative', 122, NULL, NULL, 37049),
(37050, '3.30.160.60-FF-005183', NULL, NULL, 43, NULL, NULL, 37050),
(37051, '2.130.10.10-FF-005475', NULL, 'Uncharacterized protein', 312, NULL, NULL, 37051),
(37052, '1.20.58.760-FF-000049', NULL, 'Uncharacterized protein', 102, NULL, NULL, 37052),
(37053, '1.25.40.10-FF-001764', NULL, 'Pentatricopeptide repeat-containing protein At3g16010', 70, NULL, NULL, 37053),
(37054, '2.60.40.10-FF-003608', NULL, NULL, 126, NULL, NULL, 37054),
(37055, '4.10.1240.10-FF-000001', NULL, 'Adhesion G protein-coupled receptor L2', 59, NULL, NULL, 37055),
(37056, '3.20.20.70-FF-000224', NULL, '3-keto-5-aminohexanoate cleavage enzyme', 293, NULL, NULL, 37056),
(37057, '3.30.160.60-FF-000978', NULL, 'Zinc finger protein 770', 30, NULL, NULL, 37057),
(37058, '1.25.40.20-FF-000542', NULL, 'Uncharacterized protein, isoform F', 69, NULL, NULL, 37058),
(37059, '3.20.20.80-FF-000227', NULL, 'Glycogen debranching enzyme', 171, NULL, NULL, 37059),
(37060, '3.30.40.10-FF-000735', NULL, 'RBR-type E3 ubiquitin transferase', 82, NULL, NULL, 37060),
(37061, '3.40.50.1820-FF-000787', NULL, 'Lysophospholipase-like 1', 227, NULL, NULL, 37061),
(37062, '3.10.260.10-FF-000003', NULL, 'Ascospore maturation 1 protein', 126, NULL, NULL, 37062),
(37063, '3.10.25.10-FF-000004', NULL, 'Methionyl-tRNA formyltransferase', 101, NULL, NULL, 37063),
(37064, '1.10.260.40-FF-000065', NULL, 'Antitoxin HigA', 77, NULL, NULL, 37064),
(37065, '3.40.50.300-FF-002165', NULL, 'Manganese/iron ABC transporter ATP-binding protein', 238, NULL, NULL, 37065),
(37066, '3.30.300.30-FF-000054', NULL, 'Acyl-CoA synthetase (AMP-forming)/AMP-acid ligase II', 96, NULL, NULL, 37066),
(37067, '1.10.510.10-FF-002037', NULL, 'CAMK family protein kinase', 331, NULL, NULL, 37067),
(37068, '3.30.70.3270-FF-000011', NULL, 'NADH-quinone oxidoreductase subunit I', 150, NULL, NULL, 37068),
(37069, '1.10.510.10-FF-002240', NULL, NULL, 183, NULL, NULL, 37069),
(37070, '1.25.40.20-FF-001767', NULL, 'Ankyrin repeat, PH and SEC7 domain containing protein secG', 189, NULL, NULL, 37070),
(37071, '1.25.40.10-FF-003765', NULL, 'Uncharacterized protein', 162, NULL, NULL, 37071),
(37072, '3.30.40.10-FF-000792', NULL, 'Os01g0766200 protein', 82, NULL, NULL, 37072),
(37073, '3.40.50.2300-FF-001611', NULL, NULL, 48, NULL, NULL, 37073),
(37074, '3.30.360.10-FF-000023', NULL, 'Inositol 2-dehydrogenase', 131, NULL, NULL, 37074),
(37075, '3.40.50.2300-FF-001140', NULL, NULL, 139, NULL, NULL, 37075),
(37076, '2.70.150.10-FF-000171', NULL, 'Uncharacterized protein', 183, NULL, NULL, 37076),
(37077, '3.30.450.60-FF-000017', NULL, 'SNARE-like superfamily protein', 142, NULL, NULL, 37077),
(37078, '1.20.1090.10-FF-000039', NULL, '3-dehydroquinate synthase', 200, NULL, NULL, 37078),
(37079, '3.30.70.330-FF-003080', NULL, NULL, 144, NULL, NULL, 37079),
(37080, '3.40.50.300-FF-000366', NULL, 'GTPase, IMAP family member 2', 221, NULL, NULL, 37080),
(37081, '3.20.20.80-FF-000845', NULL, 'Uncharacterized protein', 252, NULL, NULL, 37081);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(37082, '2.10.90.10-FF-000028', NULL, 'Left-right determination factor', 102, NULL, NULL, 37082),
(37083, '3.40.50.450-FF-000006', NULL, 'ATP-dependent 6-phosphofructokinase', 183, NULL, NULL, 37083),
(37084, '3.40.50.620-FF-000844', NULL, 'ASparagiNe Synthetase', 110, NULL, NULL, 37084),
(37085, '2.20.50.20-FF-000011', NULL, 'Uncharacterized protein', 84, NULL, NULL, 37085),
(37086, '3.30.750.24-FF-000078', NULL, 'Glutaminase', 126, NULL, NULL, 37086),
(37087, '2.120.10.10-FF-000029', NULL, 'Sialidase NEU1.3; Uncharacterized protein', 354, NULL, NULL, 37087),
(37088, '3.10.250.10-FF-000031', NULL, 'RIKEN cDNA 5830411N06, isoform CRA_a', 105, NULL, NULL, 37088),
(37089, '2.30.29.30-FF-001173', NULL, 'Protein CBR-DYC-1', 91, NULL, NULL, 37089),
(37090, '3.40.1610.10-FF-000001', NULL, 'Hydantoinase, putative', 222, NULL, NULL, 37090),
(37091, '3.40.50.300-FF-003593', NULL, 'Os10g0208200 protein', 191, NULL, NULL, 37091),
(37092, '1.10.510.10-FF-003465', NULL, NULL, 272, NULL, NULL, 37092),
(37093, '1.10.1060.10-FF-000017', NULL, 'Putative succinate dehydrogenase', 143, NULL, NULL, 37093),
(37094, '3.20.20.70-FF-000842', NULL, NULL, 89, NULL, NULL, 37094),
(37095, '1.10.10.10-FF-000003', NULL, 'Paired box protein Pax-6', 64, NULL, NULL, 37095),
(37096, '1.20.1410.10-FF-000048', NULL, 'Hip1r protein', 77, NULL, NULL, 37096),
(37097, '2.60.120.200-FF-000399', NULL, 'Galectin', 131, NULL, NULL, 37097),
(37098, '1.20.140.50-FF-000012', NULL, 'K7_Rim20p', 41, NULL, NULL, 37098),
(37099, '1.10.10.10-FF-001195', NULL, 'ISPsy9, transposase OrfA', 58, NULL, NULL, 37099),
(37100, '2.30.30.1020-FF-000022', NULL, 'Uncharacterized protein', 168, NULL, NULL, 37100),
(37101, '1.10.510.10-FF-003375', NULL, NULL, 325, NULL, NULL, 37101),
(37102, '3.10.620.30-FF-000026', NULL, 'Uncharacterized protein', 103, NULL, NULL, 37102),
(37103, '3.40.630.30-FF-000609', NULL, 'Os02g0694201 protein', 59, NULL, NULL, 37103),
(37104, '3.30.70.330-FF-001432', NULL, 'Os12g0606300 protein', 100, NULL, NULL, 37104),
(37105, '3.30.70.330-FF-002618', NULL, NULL, 128, NULL, NULL, 37105),
(37106, '3.10.580.10-FF-000140', NULL, 'Chloride channel protein', 131, NULL, NULL, 37106),
(37107, '1.20.58.60-FF-000829', NULL, 'Microtubule-actin crosslinking factor 1', 170, NULL, NULL, 37107),
(37108, '3.30.300.20-FF-000051', NULL, 'GTPase Der', 90, NULL, NULL, 37108),
(37109, '2.170.130.10-FF-000067', NULL, NULL, 141, NULL, NULL, 37109),
(37110, '3.40.50.300-FF-005745', NULL, 'Katanin p60 ATPase-containing subunit A1', 144, NULL, NULL, 37110),
(37111, '1.10.10.790-FF-000002', NULL, 'Splicing factor 3A subunit 1', 72, NULL, NULL, 37111),
(37112, '1.10.472.80-FF-000198', NULL, NULL, 149, NULL, NULL, 37112),
(37113, '3.30.70.330-FF-002860', NULL, NULL, 79, NULL, NULL, 37113),
(37114, '3.20.20.140-FF-000209', NULL, 'Allantoinase', 261, NULL, NULL, 37114),
(37115, '3.40.50.2020-FF-000162', NULL, 'Ribose-phosphat pyrophosphokinase', 152, NULL, NULL, 37115),
(37116, '3.40.50.2020-FF-000105', NULL, 'Uncharacterized protein', 57, NULL, NULL, 37116),
(37117, '2.130.10.10-FF-000540', NULL, 'Dmx like 1', 196, NULL, NULL, 37117),
(37118, '3.30.559.10-FF-000226', NULL, 'Putative peptide synthase', 176, NULL, NULL, 37118),
(37119, '2.60.120.330-FF-000179', NULL, 'Uncharacterized protein', 215, NULL, NULL, 37119),
(37120, '3.90.380.10-FF-000011', NULL, 'Cholesterol 7-desaturase', 212, NULL, NULL, 37120),
(37121, '2.60.120.620-FF-000030', NULL, 'Proline HYdroxylase', 192, NULL, NULL, 37121),
(37122, '1.10.510.10-FF-000969', NULL, 'CAMK family protein kinase', 325, NULL, NULL, 37122),
(37123, '1.10.390.10-FF-000060', NULL, 'GD16024', 247, NULL, NULL, 37123),
(37124, '1.10.150.110-FF-000019', NULL, 'Lmo1231 protein', 86, NULL, NULL, 37124),
(37125, '1.20.1070.10-FF-002039', NULL, 'Protein CBR-GNRR-8', 115, NULL, NULL, 37125),
(37126, '1.25.10.10-FF-001257', NULL, 'ARM repeat superfamily protein', 175, NULL, NULL, 37126),
(37127, '1.10.287.310-FF-000011', NULL, 'Ribosomal protein', 46, NULL, NULL, 37127),
(37128, '2.60.40.10-FF-002361', NULL, 'Titin homolog', 91, NULL, NULL, 37128);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(37129, '3.80.10.10-FF-004273', NULL, 'Uncharacterized protein', 53, NULL, NULL, 37129),
(37130, '3.40.50.10630-FF-000001', NULL, 'PUA domain containing protein', 161, NULL, NULL, 37130),
(37131, '3.60.21.60-FF-000031', NULL, 'Uncharacterized protein', 203, NULL, NULL, 37131),
(37132, '1.10.8.60-FF-000573', NULL, 'Bromodomain protein', 60, NULL, NULL, 37132),
(37133, '2.10.25.10-FF-000187', NULL, 'nephronectin isoform X1', 44, NULL, NULL, 37133),
(37134, '1.25.40.20-FF-001913', NULL, 'Ankyrin-repeat protein, putative', 116, NULL, NULL, 37134),
(37135, '2.130.10.10-FF-005565', NULL, 'Uncharacterized protein', 214, NULL, NULL, 37135),
(37136, '2.40.30.170-FF-000046', NULL, NULL, 68, NULL, NULL, 37136),
(37137, '3.30.450.40-FF-000101', NULL, 'Sigma-54 dependent transcriptional regulator', 174, NULL, NULL, 37137),
(37138, '1.25.40.120-FF-000090', NULL, 'Predicted protein', 245, NULL, NULL, 37138),
(37139, '2.20.25.240-FF-000016', NULL, 'Uncharacterized protein', 79, NULL, NULL, 37139),
(37140, '2.60.40.150-FF-000060', NULL, 'Phosphoinositide phospholipase C', 134, NULL, NULL, 37140),
(37141, '3.30.1910.20-FF-000001', NULL, 'asparagine--tRNA ligase, cytoplasmic', 76, NULL, NULL, 37141),
(37142, '2.30.42.10-FF-000287', NULL, 'Serine protease', 103, NULL, NULL, 37142),
(37143, '3.90.660.10-FF-000139', NULL, NULL, 236, NULL, NULL, 37143),
(37144, '1.20.120.1080-FF-000073', NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase PRP16', 159, NULL, NULL, 37144),
(37145, '3.30.420.10-FF-000523', NULL, NULL, 112, NULL, NULL, 37145),
(37146, '1.10.3370.10-FF-000035', NULL, 'Os12g0625966 protein', 257, NULL, NULL, 37146),
(37147, '2.60.40.10-FF-003047', NULL, 'Uncharacterized protein, isoform A', 91, NULL, NULL, 37147),
(37148, '3.20.20.80-FF-000284', NULL, 'Glycogen debranching enzyme', 120, NULL, NULL, 37148),
(37149, '3.50.50.60-FF-001200', NULL, 'Similar to monooxygenase', 488, NULL, NULL, 37149),
(37150, '1.20.1250.20-FF-000757', NULL, 'YDL199C-like protein', 461, NULL, NULL, 37150),
(37151, '3.30.420.10-FF-000169', NULL, 'Snipper, isoform E', 224, NULL, NULL, 37151),
(37152, '2.10.50.10-FF-000115', NULL, 'Tumor necrosis factor receptor superfamily member 6', 38, NULL, NULL, 37152),
(37153, '3.30.499.10-FF-000024', NULL, '2-methylisocitrate dehydratase, Fe/S-dependent', 234, NULL, NULL, 37153),
(37154, '3.30.200.20-FF-001830', NULL, 'Uncharacterized protein', 119, NULL, NULL, 37154),
(37155, '1.50.10.10-FF-000147', NULL, 'alpha-1,2-Mannosidase', 474, NULL, NULL, 37155),
(37156, '3.10.170.20-FF-000033', NULL, NULL, 168, NULL, NULL, 37156),
(37157, '3.40.50.300-FF-001855', NULL, 'Dynein axonemal heavy chain 10', 225, NULL, NULL, 37157),
(37158, '3.30.160.60-FF-002310', NULL, 'Rna polymerase ii transcription factor', 28, NULL, NULL, 37158),
(37159, '3.40.50.200-FF-000128', NULL, 'Predicted protein', 153, NULL, NULL, 37159),
(37160, '2.170.16.10-FF-000046', NULL, 'Replication factor C small subunit', 109, NULL, NULL, 37160),
(37161, '3.10.105.10-FF-000014', NULL, 'ABC transporter substrate-binding protein', 210, NULL, NULL, 37161),
(37162, '1.10.840.10-FF-000050', NULL, 'Uncharacterized protein', 105, NULL, NULL, 37162),
(37163, '3.90.1170.40-FF-000003', NULL, 'Molybdopterin converting factor subunit 2', 143, NULL, NULL, 37163),
(37164, '3.40.50.300-FF-002311', NULL, 'Intraflagellar transport protein 22', 209, NULL, NULL, 37164),
(37165, '3.90.1170.50-FF-000006', NULL, 'Carbon monoxide dehydrogenase large chain', 138, NULL, NULL, 37165),
(37166, '2.40.50.140-FF-000777', NULL, NULL, 89, NULL, NULL, 37166),
(37167, '3.20.20.70-FF-000281', NULL, 'Probable dihydrodipicolinate synthetase', 292, NULL, NULL, 37167),
(37168, '3.40.50.10490-FF-000032', NULL, 'RpiR family transcriptional regulator', 184, NULL, NULL, 37168),
(37169, '2.20.25.10-FF-000080', NULL, 'DNA-directed RNA polymerase subunit', 73, NULL, NULL, 37169),
(37170, '3.90.70.10-FF-000100', NULL, 'Cathepsin W', 328, NULL, NULL, 37170),
(37171, '3.40.50.460-FF-000009', NULL, 'ATP-dependent 6-phosphofructokinase', 122, NULL, NULL, 37171),
(37172, '1.25.40.10-FF-001910', NULL, 'RNA polymerase III transcription factor TFIIIC subunit (Tfc4), putative', 166, NULL, NULL, 37172);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(37173, '1.10.287.450-FF-000002', NULL, 'adenomatous polyposis coli protein 2', 122, NULL, NULL, 37173),
(37174, '2.30.29.30-FF-000863', NULL, 'Family with sequence similarity 43 member B', 139, NULL, NULL, 37174),
(37175, '1.10.287.460-FF-000005', NULL, 'Peptidyl-prolyl cis-trans isomerase', 91, NULL, NULL, 37175),
(37176, '1.25.10.10-FF-001167', NULL, 'Hypothetical_protein_-_conserved', 228, NULL, NULL, 37176),
(37177, '1.25.10.10-FF-001521', NULL, 'AaceriAEL256Cp', 220, NULL, NULL, 37177),
(37178, '3.90.650.10-FF-000049', NULL, 'Uncharacterized protein', 193, NULL, NULL, 37178),
(37179, '2.60.40.10-FF-005817', NULL, NULL, 58, NULL, NULL, 37179),
(37180, '2.60.200.20-FF-000107', NULL, 'FHA domain-containing protein', 92, NULL, NULL, 37180),
(37181, '2.70.160.11-FF-000094', NULL, 'Protein arginine N-methyltransferase', 175, NULL, NULL, 37181),
(37182, '3.30.70.330-FF-003023', NULL, NULL, 62, NULL, NULL, 37182),
(37183, '3.30.160.60-FF-003704', NULL, NULL, 52, NULL, NULL, 37183),
(37184, '3.40.50.300-FF-005655', NULL, 'Protein strawberry notch-like protein 1', 211, NULL, NULL, 37184),
(37185, '3.40.1180.10-FF-000017', NULL, 'Alkyl transferase', 242, NULL, NULL, 37185),
(37186, '3.20.20.140-FF-000356', NULL, 'Uncharacterized protein', 295, NULL, NULL, 37186),
(37187, '3.30.950.30-FF-000001', NULL, 'Schlafen family member 14', 131, NULL, NULL, 37187),
(37188, '2.10.50.10-FF-000172', NULL, 'Predicted protein', 68, NULL, NULL, 37188),
(37189, '1.10.238.10-FF-001325', NULL, 'Uncharacterized protein', 117, NULL, NULL, 37189),
(37190, '3.90.70.10-FF-000307', NULL, 'Ubiquitin carboxyl-terminal hydrolase domain containing protein', 199, NULL, NULL, 37190),
(37191, '3.40.50.1980-FF-000110', NULL, 'ABC-type transport system periplasmic substrate-binding protein', 131, NULL, NULL, 37191),
(37192, '2.60.40.2700-FF-000002', NULL, '187-kDa microtubule-associated protein AIR9', 85, NULL, NULL, 37192),
(37193, '2.40.10.230-FF-000015', NULL, 'H/ACA ribonucleoprotein complex subunit', 61, NULL, NULL, 37193),
(37194, '1.20.58.70-FF-000012', NULL, 'diablo homolog, mitochondrial isoform X1', 184, NULL, NULL, 37194),
(37195, '2.60.40.10-FF-005907', NULL, NULL, 63, NULL, NULL, 37195),
(37196, '1.20.58.90-FF-000018', NULL, 'Tubulin-specific chaperone A', 114, NULL, NULL, 37196),
(37197, '2.60.120.10-FF-000626', NULL, 'Uncharacterized protein', 153, NULL, NULL, 37197),
(37198, '3.90.1150.10-FF-000398', NULL, 'Uncharacterized protein', 151, NULL, NULL, 37198),
(37199, '3.40.50.1000-FF-000013', NULL, 'Carboxy-terminal domain RNA polymerase II polypeptide A small', 185, NULL, NULL, 37199),
(37200, '3.10.250.10-FF-000121', NULL, NULL, 61, NULL, NULL, 37200),
(37201, '1.10.150.650-FF-000012', NULL, 'PHP domain protein', 74, NULL, NULL, 37201),
(37202, '3.40.50.300-FF-001294', NULL, 'Caspase recruitment domain family member 14', 190, NULL, NULL, 37202),
(37203, '3.40.367.20-FF-000039', NULL, 'Phosphotransferase', 137, NULL, NULL, 37203),
(37204, '2.20.60.10-FF-000003', NULL, 'Uncharacterized protein', 36, NULL, NULL, 37204),
(37205, '3.40.50.300-FF-007807', NULL, 'Uncharacterized protein', 35, NULL, NULL, 37205),
(37206, '1.25.40.800-FF-000013', NULL, 'Uncharacterized protein', 220, NULL, NULL, 37206),
(37207, '3.40.30.10-FF-000414', NULL, 'Thioredoxin-like reductase Rv2466c', 207, NULL, NULL, 37207),
(37208, '3.30.200.20-FF-001476', NULL, 'DNA-binding SARP family transcriptional activator', 37, NULL, NULL, 37208),
(37209, '2.130.10.10-FF-002131', NULL, 'LD10780p', 102, NULL, NULL, 37209),
(37210, '4.10.240.10-FF-000228', NULL, 'Uncharacterized transcriptional regulatory protein C320.03', 81, NULL, NULL, 37210),
(37211, '1.20.58.80-FF-000015', NULL, 'Calpain 7', 70, NULL, NULL, 37211),
(37212, '1.10.1420.10-FF-000034', NULL, 'DNA mismatch repair protein msh2', 198, NULL, NULL, 37212),
(37213, '3.40.630.30-FF-000402', NULL, 'O-GlcNAcase like', 96, NULL, NULL, 37213),
(37214, '2.30.30.140-FF-000320', NULL, 'Protein lin-61', 145, NULL, NULL, 37214),
(37215, '3.40.50.1010-FF-000016', NULL, 'Flap endonuclease 1', 224, NULL, NULL, 37215);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(37216, '3.40.720.10-FF-000280', NULL, 'AGAP003222-PA', 309, NULL, NULL, 37216),
(37217, '3.30.160.60-FF-005913', NULL, NULL, 34, NULL, NULL, 37217),
(37218, '3.40.50.300-FF-003446', NULL, 'Type I restriction-modification system restriction subunit R', 248, NULL, NULL, 37218),
(37219, '3.50.50.60-FF-001407', NULL, 'Predicted protein', 147, NULL, NULL, 37219),
(37220, '1.20.1250.20-FF-000196', NULL, 'MFS toxin efflux pump (AflT)', 232, NULL, NULL, 37220),
(37221, '3.40.33.10-FF-000128', NULL, 'Cysteine-rich secretory protein-buccal gland secretion, putative', 192, NULL, NULL, 37221),
(37222, '3.40.50.1100-FF-000251', NULL, 'Uncharacterized protein', 16, NULL, NULL, 37222),
(37223, '3.30.470.20-FF-000063', NULL, 'beta-citrylglutamate synthase B isoform X2', 106, NULL, NULL, 37223),
(37224, '1.20.1740.10-FF-000213', NULL, 'Uncharacterized protein', 117, NULL, NULL, 37224),
(37225, '2.60.120.10-FF-000008', NULL, 'Rap guanine nucleotide exchange factor (GEF) 2', 174, NULL, NULL, 37225),
(37226, '3.40.1080.10-FF-000010', NULL, 'Succinate CoA transferase', 167, NULL, NULL, 37226),
(37227, '3.40.50.2000-FF-000976', NULL, 'Uncharacterized protein', 81, NULL, NULL, 37227),
(37228, '2.40.10.10-FF-000218', NULL, 'Serine protease nudel', 23, NULL, NULL, 37228),
(37229, '1.10.8.10-FF-000255', NULL, 'Zinc finger protein', 63, NULL, NULL, 37229),
(37230, '3.40.50.300-FF-007600', NULL, 'Uncharacterized protein', 163, NULL, NULL, 37230),
(37231, '3.40.50.2000-FF-000919', NULL, 'Mannosyltransferase, putative', 161, NULL, NULL, 37231),
(37232, '1.10.10.10-FF-001756', NULL, 'Uncharacterized protein', 73, NULL, NULL, 37232),
(37233, '3.30.160.60-FF-001759', NULL, 'Crooked legs, isoform F', 28, NULL, NULL, 37233),
(37234, '1.10.510.10-FF-001784', NULL, 'Fibroblast growth factor receptor 2', 123, NULL, NULL, 37234),
(37235, '1.10.260.100-FF-000018', NULL, 'Small glutamine-rich tetratricopeptide repeat protein', 54, NULL, NULL, 37235),
(37236, '1.20.1250.20-FF-001123', NULL, 'Multidrug resistance protein B', 244, NULL, NULL, 37236),
(37237, '3.40.1160.10-FF-000011', NULL, 'N-acetyl-gamma-glutamyl-phosphate reductase, variant', 302, NULL, NULL, 37237),
(37238, '3.90.25.10-FF-000057', NULL, 'CipA protein', 78, NULL, NULL, 37238),
(37239, '3.30.200.160-FF-000018', NULL, 'Uncharacterized protein', 64, NULL, NULL, 37239),
(37240, '1.25.10.10-FF-001728', NULL, 'Os06g0244700 protein', 201, NULL, NULL, 37240),
(37241, '3.40.50.720-FF-001245', NULL, 'Dehydrogenase, putative', 132, NULL, NULL, 37241),
(37242, '3.40.50.300-FF-000720', NULL, 'Guanine nucleotide-binding protein G(k) subunit alpha', 211, NULL, NULL, 37242),
(37243, '1.10.20.10-FF-000150', NULL, 'DR1 (One) transcription factor family', 152, NULL, NULL, 37243),
(37244, '3.40.850.10-FF-000227', NULL, 'Kinesin heavy chain, putative', 294, NULL, NULL, 37244),
(37245, '3.40.50.2300-FF-001347', NULL, NULL, 64, NULL, NULL, 37245),
(37246, '1.20.1250.20-FF-002348', NULL, 'Uncharacterized protein', 186, NULL, NULL, 37246),
(37247, '3.40.50.720-FF-002139', NULL, 'Uncharacterized protein', 96, NULL, NULL, 37247),
(37248, '3.40.50.300-FF-005806', NULL, 'Zinc finger Ran-binding domain-containing protein 3', 261, NULL, NULL, 37248),
(37249, '3.90.550.10-FF-000221', NULL, 'Glycosyltransferase family protein 47', 270, NULL, NULL, 37249),
(37250, '1.10.8.60-FF-000073', NULL, 'ORC1-type DNA replication protein', 95, NULL, NULL, 37250),
(37251, '2.60.60.20-FF-000033', NULL, 'Inactive pancreatic lipase-related protein 1-like Protein', 135, NULL, NULL, 37251),
(37252, '2.40.150.20-FF-000001', NULL, '50S ribosomal protein L14', 122, NULL, NULL, 37252),
(37253, '3.30.70.330-FF-000943', NULL, 'Multiple RNA-binding domain-containing protein 1', 130, NULL, NULL, 37253),
(37254, '3.90.1150.10-FF-000021', NULL, 'Kynurenine--oxoglutarate transaminase 3', 139, NULL, NULL, 37254),
(37255, '2.102.10.10-FF-000047', NULL, 'Assimilatory nitrite reductase [NAD(P)H] small subunit', 104, NULL, NULL, 37255),
(37256, '3.40.20.10-FF-000065', NULL, 'Quail, isoform C', 98, NULL, NULL, 37256),
(37257, '3.30.160.60-FF-000040', NULL, 'RB associated KRAB zinc finger', 28, NULL, NULL, 37257);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(37258, '3.40.1190.20-FF-000139', NULL, 'Bifunctional protein HldE', 316, NULL, NULL, 37258),
(37259, '3.10.105.10-FF-000071', NULL, 'Peptide ABC transporter substrate-binding protein', 246, NULL, NULL, 37259),
(37260, '3.30.200.20-FF-001740', NULL, 'Fructosamine kinase', 92, NULL, NULL, 37260),
(37261, '3.30.420.40-FF-000919', NULL, 'DnaK protein', 212, NULL, NULL, 37261),
(37262, '3.30.450.20-FF-000415', NULL, 'Sensor histidine kinase, HAMP and PAS domain-containing', 124, NULL, NULL, 37262),
(37263, '1.10.560.10-FF-000011', NULL, '60 kDa heat shock protein, mitochondrial', 243, NULL, NULL, 37263),
(37264, '1.10.20.140-FF-000012', NULL, 'LD10347p', 58, NULL, NULL, 37264),
(37265, '3.30.70.1130-FF-000009', NULL, 'Eukaryotic translation initiation factor 2 subunit alpha', 73, NULL, NULL, 37265),
(37266, '3.30.40.10-FF-000909', NULL, 'E3 ubiquitin-protein ligase SP1', 59, NULL, NULL, 37266),
(37267, '1.20.1260.10-FF-000047', NULL, 'Ferritin', 90, NULL, NULL, 37267),
(37268, '4.10.240.10-FF-000083', NULL, 'C6 transcription factor, putative', 64, NULL, NULL, 37268),
(37269, '3.40.720.10-FF-000370', NULL, 'PhosphatidylInositol Glycan anchor biosynthesis class N homolog', 72, NULL, NULL, 37269),
(37270, '1.20.5.110-FF-000293', NULL, 'Uncharacterized protein', 95, NULL, NULL, 37270),
(37271, '3.50.50.60-FF-001290', NULL, 'Uncharacterized protein', 189, NULL, NULL, 37271),
(37272, '3.30.70.330-FF-003107', NULL, NULL, 84, NULL, NULL, 37272),
(37273, '3.30.1120.30-FF-000056', NULL, 'Uncharacterized protein', 15, NULL, NULL, 37273),
(37274, '2.130.10.10-FF-002659', NULL, 'Uncharacterized protein', 134, NULL, NULL, 37274),
(37275, '1.25.40.180-FF-000203', NULL, NULL, 85, NULL, NULL, 37275),
(37276, '1.20.120.1510-FF-000005', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 109, NULL, NULL, 37276),
(37277, '2.20.100.10-FF-000128', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs adt-2', 52, NULL, NULL, 37277),
(37278, '1.10.287.70-FF-000646', NULL, 'Uncharacterized protein', 176, NULL, NULL, 37278),
(37279, '2.40.50.140-FF-000687', NULL, NULL, 86, NULL, NULL, 37279),
(37280, '3.80.10.10-FF-000703', NULL, 'Leucine-rich repeat protein', 82, NULL, NULL, 37280),
(37281, '1.10.510.10-FF-001548', NULL, 'Cyclin-dependent kinase 4 homolog', 212, NULL, NULL, 37281),
(37282, '1.50.10.20-FF-000089', NULL, 'Terpene cyclase/mutase family member', 57, NULL, NULL, 37282),
(37283, '1.20.1250.10-FF-000075', NULL, 'Uncharacterized protein', 174, NULL, NULL, 37283),
(37284, '3.40.50.1010-FF-000106', NULL, 'Toxin FitB', 143, NULL, NULL, 37284),
(37285, '3.30.160.60-FF-004255', NULL, NULL, 33, NULL, NULL, 37285),
(37286, '3.40.50.300-FF-001384', NULL, 'Midasin', 172, NULL, NULL, 37286),
(37287, '2.80.10.50-FF-000032', NULL, 'macrophage mannose receptor 1', 135, NULL, NULL, 37287),
(37288, '2.20.20.10-FF-000001', NULL, 'Crotamine', 42, NULL, NULL, 37288),
(37289, '1.10.4020.10-FF-000009', NULL, 'Uncharacterized protein', 95, NULL, NULL, 37289),
(37290, '2.60.120.380-FF-000025', NULL, 'Subtilisin-like serine protease', 100, NULL, NULL, 37290),
(37291, '1.50.10.10-FF-000086', NULL, 'Glucanase', 510, NULL, NULL, 37291),
(37292, '3.50.50.60-FF-000828', NULL, 'Squalene epoxidase', 115, NULL, NULL, 37292),
(37293, '1.10.287.70-FF-000118', NULL, 'Calcium channel subunit Cch1', 143, NULL, NULL, 37293),
(37294, '2.60.40.10-FF-000500', NULL, 'limbic system-associated membrane protein isoform X1', 98, NULL, NULL, 37294),
(37295, '3.40.50.12780-FF-000191', NULL, 'Uncharacterized protein', 124, NULL, NULL, 37295),
(37296, '3.40.50.300-FF-007370', NULL, 'Protein CBG22156', 99, NULL, NULL, 37296),
(37297, '3.30.1120.10-FF-000050', NULL, 'Uncharacterized protein', 74, NULL, NULL, 37297),
(37298, '1.10.150.670-FF-000018', NULL, 'Crossover junction endonuclease EME1-like Protein', 66, NULL, NULL, 37298),
(37299, '2.60.40.10-FF-000444', NULL, 'Collagen alpha-1(XIV) chain isoform X2', 90, NULL, NULL, 37299),
(37300, '3.50.50.60-FF-000891', NULL, 'Uncharacterized protein', 201, NULL, NULL, 37300);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(37301, '3.40.50.1820-FF-000815', NULL, 'Uncharacterized protein', 211, NULL, NULL, 37301),
(37302, '3.30.160.60-FF-004896', NULL, NULL, 34, NULL, NULL, 37302),
(37303, '3.20.20.80-FF-000435', NULL, 'Chitinase, putative', 125, NULL, NULL, 37303),
(37304, '1.10.8.140-FF-000006', NULL, 'programmed cell death protein 5-like', 117, NULL, NULL, 37304),
(37305, '1.20.1070.10-FF-000982', NULL, 'Predicted protein', 313, NULL, NULL, 37305),
(37306, '3.60.60.10-FF-000022', NULL, 'Predicted protein', 229, NULL, NULL, 37306),
(37307, '3.40.50.300-FF-005329', NULL, 'Unc-53', 149, NULL, NULL, 37307),
(37308, '1.10.287.1390-FF-000004', NULL, NULL, 56, NULL, NULL, 37308),
(37309, '1.10.132.70-FF-000001', NULL, 'Telomerase reverse transcriptase', 272, NULL, NULL, 37309),
(37310, '3.40.1170.60-FF-000037', NULL, NULL, 52, NULL, NULL, 37310),
(37311, '3.40.50.80-FF-000127', NULL, 'Uncharacterized protein', 203, NULL, NULL, 37311),
(37312, '1.10.238.10-FF-000959', NULL, 'Calcineurin B subunit, putative', 171, NULL, NULL, 37312),
(37313, '1.10.510.10-FF-003791', NULL, NULL, 128, NULL, NULL, 37313),
(37314, '3.40.50.10330-FF-000001', NULL, 'Diacylglycerol kinase', 131, NULL, NULL, 37314),
(37315, '3.30.450.20-FF-000264', NULL, 'Methyl-accepting chemotaxis protein', 169, NULL, NULL, 37315),
(37316, '2.60.40.10-FF-001602', NULL, 'Receptor protein-tyrosine kinase', 98, NULL, NULL, 37316),
(37317, '3.40.50.300-FF-005127', NULL, 'Predicted protein', 245, NULL, NULL, 37317),
(37318, '2.40.50.1020-FF-000014', NULL, 'Accessory gene regulator A', 103, NULL, NULL, 37318),
(37319, '3.30.420.40-FF-001055', NULL, 'Putative glycerol kinase 5', 100, NULL, NULL, 37319),
(37320, '1.20.58.1120-FF-000032', NULL, 'Dynein, axonemal, heavy chain 6', 99, NULL, NULL, 37320),
(37321, '3.40.50.1820-FF-000697', NULL, 'Possible secreted protease', 154, NULL, NULL, 37321),
(37322, '1.20.1250.10-FF-000131', NULL, NULL, 105, NULL, NULL, 37322),
(37323, '2.60.120.970-FF-000051', NULL, 'Growth differentiation factor 7', 207, NULL, NULL, 37323),
(37324, '3.20.80.10-FF-000053', NULL, 'Uncharacterized protein', 158, NULL, NULL, 37324),
(37325, '3.30.200.20-FF-001061', NULL, 'Nuclear receptor-binding protein 2', 74, NULL, NULL, 37325),
(37326, '1.20.120.350-FF-000190', NULL, NULL, 88, NULL, NULL, 37326),
(37327, '3.30.200.20-FF-001684', NULL, 'Kae1-associated serine/threonine protein kinase', 71, NULL, NULL, 37327),
(37328, '3.40.30.10-FF-000004', NULL, 'Spliceosomal protein DIB1', 141, NULL, NULL, 37328),
(37329, '3.80.10.10-FF-001013', NULL, 'Receptor-like protein CLAVATA2', 251, NULL, NULL, 37329),
(37330, '1.20.5.50-FF-000002', NULL, 'Fibrinogen beta chain', 144, NULL, NULL, 37330),
(37331, '3.40.50.2000-FF-000892', NULL, 'Uncharacterized protein', 176, NULL, NULL, 37331),
(37332, '1.25.40.10-FF-002130', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 116, NULL, NULL, 37332),
(37333, '1.10.510.10-FF-001604', NULL, 'Serine/threonine-protein kinase', 168, NULL, NULL, 37333),
(37334, '1.25.10.10-FF-002948', NULL, 'Importin beta, nuclear transport factor, putative', 52, NULL, NULL, 37334),
(37335, '2.60.220.30-FF-000027', NULL, 'Unc-5 netrin receptor B', 120, NULL, NULL, 37335),
(37336, '3.40.50.720-FF-002465', NULL, 'Alcohol dehydrogenase-like 3', 111, NULL, NULL, 37336),
(37337, '3.30.1140.60-FF-000015', NULL, 'F-actin-capping protein subunit alpha', 112, NULL, NULL, 37337),
(37338, '2.130.10.10-FF-001726', NULL, 'Uncharacterized protein', 195, NULL, NULL, 37338),
(37339, '1.10.420.10-FF-000001', NULL, 'Peroxidase', 142, NULL, NULL, 37339),
(37340, '2.60.40.420-FF-000214', NULL, 'Uncharacterized protein', 128, NULL, NULL, 37340),
(37341, '3.40.50.11060-FF-000012', NULL, 'GTPase HflX', 90, NULL, NULL, 37341),
(37342, '3.30.900.10-FF-000043', NULL, 'Uncharacterized protein', 85, NULL, NULL, 37342),
(37343, '1.10.510.10-FF-001930', NULL, NULL, 48, NULL, NULL, 37343),
(37344, '3.10.20.30-FF-000022', NULL, 'Succinate dehydrogenase iron-sulfur subunit', 109, NULL, NULL, 37344),
(37345, '2.60.40.3210-FF-000003', NULL, 'Glycoprotein 2', 118, NULL, NULL, 37345); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(37346, '3.40.390.10-FF-000298', NULL, NULL, 67, NULL, NULL, 37346),
(37347, '3.30.70.330-FF-001253', NULL, 'Interferon-induced 35 kDa protein homolog', 65, NULL, NULL, 37347),
(37348, '1.10.10.10-FF-001464', NULL, 'DNA-binding response regulator', 103, NULL, NULL, 37348),
(37349, '2.130.10.10-FF-005621', NULL, 'Uncharacterized protein', 183, NULL, NULL, 37349),
(37350, '1.25.40.10-FF-000213', NULL, 'Tetratricopeptide repeat domain 36', 150, NULL, NULL, 37350),
(37351, '2.30.29.30-FF-000684', NULL, 'SH2B adaptor protein 3', 69, NULL, NULL, 37351),
(37352, '3.80.10.10-FF-002890', NULL, 'Si:ch211-209n20.3', 148, NULL, NULL, 37352),
(37353, '3.40.140.10-FF-000111', NULL, 'Histone H2A deubiquitinase MYSM1', 151, NULL, NULL, 37353),
(37354, '3.50.30.30-FF-000021', NULL, 'N-acetylated alpha-linked acidic dipeptidase-like 1', 228, NULL, NULL, 37354),
(37355, '3.40.50.410-FF-000343', NULL, 'Uncharacterized protein', 119, NULL, NULL, 37355),
(37356, '3.30.420.110-FF-000007', NULL, 'DNA mismatch repair protein MutS', 128, NULL, NULL, 37356),
(37357, '1.10.287.10-FF-000056', NULL, 'Predicted protein', 36, NULL, NULL, 37357),
(37358, '3.30.720.50-FF-000024', NULL, NULL, 33, NULL, NULL, 37358),
(37359, '3.30.1330.90-FF-000011', NULL, 'L-serine ammonia-lyase', 53, NULL, NULL, 37359),
(37360, '3.80.10.10-FF-003137', NULL, 'Uncharacterized protein', 60, NULL, NULL, 37360),
(37361, '3.30.60.30-FF-000012', NULL, 'SPARC-related modular calcium binding protein 1', 43, NULL, NULL, 37361),
(37362, '3.30.70.960-FF-000008', NULL, 'Transmembrane protease serine', 104, NULL, NULL, 37362),
(37363, '1.25.40.20-FF-000216', NULL, 'Ankyrin repeat and KH domain-containing 1', 73, NULL, NULL, 37363),
(37364, '2.130.10.10-FF-000422', NULL, 'BCAS3 microtubule-associated cell migration factor', 392, NULL, NULL, 37364),
(37365, '2.60.120.200-FF-000814', NULL, 'Calreticulin family protein', 109, NULL, NULL, 37365),
(37366, '3.60.21.10-FF-000100', NULL, 'Vacuolar protein sorting-associated protein 29', 188, NULL, NULL, 37366),
(37367, '3.30.160.60-FF-000242', NULL, 'Endolytic murein transglycosylase', 36, NULL, NULL, 37367),
(37368, '1.25.40.10-FF-005356', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 163, NULL, NULL, 37368),
(37369, '1.20.120.1780-FF-000007', NULL, 'Uncharacterized protein', 137, NULL, NULL, 37369),
(37370, '3.40.50.410-FF-000219', NULL, 'ABL030Wp', 179, NULL, NULL, 37370),
(37371, '3.40.50.1460-FF-000044', NULL, 'Caspase, apoptotic cysteine protease, putative', 135, NULL, NULL, 37371),
(37372, '2.170.11.10-FF-000001', NULL, 'DNA topoisomerase I', 138, NULL, NULL, 37372),
(37373, '2.30.29.150-FF-000006', NULL, 'Transcription factor-like protein', 151, NULL, NULL, 37373),
(37374, '2.130.10.10-FF-001350', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit', 258, NULL, NULL, 37374),
(37375, '3.60.120.10-FF-000027', NULL, 'ICS1', 268, NULL, NULL, 37375),
(37376, '1.25.40.450-FF-000014', NULL, 'Nuclear pore complex protein nup155, putative', 171, NULL, NULL, 37376),
(37377, '1.25.50.20-FF-000014', NULL, 'Aminopeptidase', 339, NULL, NULL, 37377),
(37378, '2.70.20.60-FF-000002', NULL, 'Matrix protein', 165, NULL, NULL, 37378),
(37379, '2.30.30.140-FF-000056', NULL, 'DNA/RNA-binding protein kin17-like', 54, NULL, NULL, 37379),
(37380, '1.20.5.110-FF-000118', NULL, 'Bet1 SNARE 1-2', 63, NULL, NULL, 37380),
(37381, '1.25.10.10-FF-001318', NULL, 'Protein CBG13183', 173, NULL, NULL, 37381),
(37382, '1.10.510.10-FF-000300', NULL, 'Calmodulin-binding receptor-like cytoplasmic kinase 3', 210, NULL, NULL, 37382),
(37383, '1.10.630.10-FF-000416', NULL, 'Cytochrome P-450 IIC4, putative', 228, NULL, NULL, 37383),
(37384, '1.10.472.80-FF-000108', NULL, 'TBC domain containing protein', 127, NULL, NULL, 37384),
(37385, '3.40.50.2000-FF-000566', NULL, 'Glycosyltransferase', 198, NULL, NULL, 37385),
(37386, '1.10.510.10-FF-004038', NULL, NULL, 93, NULL, NULL, 37386),
(37387, '2.60.40.10-FF-001748', NULL, 'Jitterbug, isoform M', 90, NULL, NULL, 37387),
(37388, '3.40.1110.10-FF-000423', NULL, NULL, 14, NULL, NULL, 37388);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(37389, '3.40.50.360-FF-000069', NULL, 'Flavodoxin', 185, NULL, NULL, 37389),
(37390, '2.120.10.30-FF-000569', NULL, 'Uncharacterized protein', 221, NULL, NULL, 37390),
(37391, '2.30.110.10-FF-000048', NULL, 'Flavin reductase domain protein, FMN-binding', 148, NULL, NULL, 37391),
(37392, '3.30.460.10-FF-000177', NULL, 'Uncharacterized protein', 63, NULL, NULL, 37392),
(37393, '3.30.70.940-FF-000002', NULL, 'Transcription termination/antitermination protein NusG', 111, NULL, NULL, 37393),
(37394, '1.20.1560.10-FF-000738', NULL, 'Uncharacterized protein', 170, NULL, NULL, 37394),
(37395, '2.60.40.420-FF-000158', NULL, 'Uncharacterized protein', 128, NULL, NULL, 37395),
(37396, '3.10.180.20-FF-000005', NULL, NULL, 80, NULL, NULL, 37396),
(37397, '3.30.70.330-FF-000617', NULL, 'Puf family protein', 101, NULL, NULL, 37397),
(37398, '1.25.40.10-FF-002776', NULL, 'YALI0E17303p', 422, NULL, NULL, 37398),
(37399, '3.40.250.10-FF-000142', NULL, 'Putative thiosulfate sulfurtransferase', 140, NULL, NULL, 37399),
(37400, '1.20.1560.10-FF-000087', NULL, 'p-GlycoProtein related', 311, NULL, NULL, 37400),
(37401, '3.90.640.10-FF-000138', NULL, 'AGAP004488-PA', 48, NULL, NULL, 37401),
(37402, '1.20.58.60-FF-000537', NULL, 'Nesprin-2', 227, NULL, NULL, 37402),
(37403, '6.10.140.2220-FF-000051', NULL, 'GD11242', 51, NULL, NULL, 37403),
(37404, '1.25.40.10-FF-001085', NULL, 'Uncharacterized protein', 116, NULL, NULL, 37404),
(37405, '1.25.10.10-FF-002302', NULL, 'Uncharacterized protein (Fragment)', 321, NULL, NULL, 37405),
(37406, '1.10.238.10-FF-001269', NULL, 'Uncharacterized protein', 46, NULL, NULL, 37406),
(37407, '3.40.30.10-FF-000330', NULL, 'Heat shock protein DnaJ homologue Pfj2', 115, NULL, NULL, 37407),
(37408, '1.25.10.10-FF-003084', NULL, 'Uncharacterized protein', 234, NULL, NULL, 37408),
(37409, '3.20.20.80-FF-000761', NULL, 'Uncharacterized protein', 136, NULL, NULL, 37409),
(37410, '3.40.50.300-FF-006111', NULL, 'ATP-dependent DNA helicase', 124, NULL, NULL, 37410),
(37411, '3.40.50.2300-FF-001550', NULL, NULL, 26, NULL, NULL, 37411),
(37412, '3.30.160.190-FF-000005', NULL, 'NADH dehydrogenase [ubiquinone] iron-sulfur protein 4, mitochondrial', 80, NULL, NULL, 37412),
(37413, '1.20.1740.10-FF-000185', NULL, 'Uncharacterized protein', 148, NULL, NULL, 37413),
(37414, '3.30.160.60-FF-006200', NULL, NULL, 44, NULL, NULL, 37414),
(37415, '2.60.40.10-FF-005643', NULL, NULL, 93, NULL, NULL, 37415),
(37416, '2.60.40.10-FF-001372', NULL, 'Ig heavy chain V region M603', 120, NULL, NULL, 37416),
(37417, '3.30.2130.30-FF-000028', NULL, 'Thiamine biosynthesis protein ThiI, putative', 184, NULL, NULL, 37417),
(37418, '2.60.40.1180-FF-000170', NULL, 'Glycoside hydrolase family 95', 140, NULL, NULL, 37418),
(37419, '3.40.50.1000-FF-000305', NULL, 'D-glycero-alpha-D-manno-heptose-1,7-bisphosphate 7-phosphatase', 163, NULL, NULL, 37419),
(37420, '2.60.40.3510-FF-000003', NULL, 'Delta-like protein', 148, NULL, NULL, 37420),
(37421, '2.80.10.50-FF-000234', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 126, NULL, NULL, 37421),
(37422, '2.30.29.90-FF-000010', NULL, 'Uncharacterized protein', 112, NULL, NULL, 37422),
(37423, '1.20.1050.130-FF-000036', NULL, 'Uncharacterized protein', 138, NULL, NULL, 37423),
(37424, '3.10.580.10-FF-000050', NULL, 'Chloride channel protein', 145, NULL, NULL, 37424),
(37425, '2.10.220.10-FF-000100', NULL, 'Receptor protein-tyrosine kinase', 94, NULL, NULL, 37425),
(37426, '3.20.20.190-FF-000146', NULL, NULL, 75, NULL, NULL, 37426),
(37427, '3.30.70.980-FF-000020', NULL, 'Probable transcriptional regulatory protein CWS35_11355', 92, NULL, NULL, 37427),
(37428, '1.25.40.10-FF-004867', NULL, 'Diguanylate cyclase (GGDEF) domain protein', 253, NULL, NULL, 37428),
(37429, '2.60.40.10-FF-000118', NULL, 'filamin-C isoform X2', 98, NULL, NULL, 37429),
(37430, '1.10.555.10-FF-000230', NULL, NULL, 200, NULL, NULL, 37430),
(37431, '3.30.30.30-FF-000038', NULL, 'Heat shock protein 70 homolog LHS1, putative', 57, NULL, NULL, 37431),
(37432, '2.60.120.10-FF-000452', NULL, 'Mannose-6-phosphate isomerase', 102, NULL, NULL, 37432); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(37433, '2.60.40.10-FF-003463', NULL, NULL, 100, NULL, NULL, 37433),
(37434, '2.40.50.140-FF-000485', NULL, 'nuclease-sensitive element-binding protein 1 isoform X2', 61, NULL, NULL, 37434),
(37435, '3.30.1640.10-FF-000050', NULL, 'Minichromosome maintenance protein MCM', 103, NULL, NULL, 37435),
(37436, '3.40.250.10-FF-000232', NULL, 'Sulfurtransferase', 133, NULL, NULL, 37436),
(37437, '2.30.140.10-FF-000022', NULL, 'Spermidine synthase', 22, NULL, NULL, 37437),
(37438, '3.30.200.20-FF-000695', NULL, 'Uncharacterized protein', 98, NULL, NULL, 37438),
(37439, '3.40.1350.10-FF-000020', NULL, 'Fanconi-associated nuclease', 75, NULL, NULL, 37439),
(37440, '1.25.40.20-FF-001677', NULL, 'Stress-activated protein kinase alpha', 79, NULL, NULL, 37440),
(37441, '3.30.160.60-FF-003619', NULL, 'Zinc finger protein 588, isoform CRA_d', 29, NULL, NULL, 37441),
(37442, '2.130.10.10-FF-005149', NULL, 'Uncharacterized protein', 143, NULL, NULL, 37442),
(37443, '2.10.60.10-FF-000083', NULL, 'Receptor protein serine/threonine kinase', 88, NULL, NULL, 37443),
(37444, '3.40.50.2300-FF-000566', NULL, 'Glutamate receptor', 190, NULL, NULL, 37444),
(37445, '4.10.410.10-FF-000113', NULL, 'Salivary protein KUN-5, putative', 62, NULL, NULL, 37445),
(37446, '3.80.10.10-FF-000647', NULL, 'Leucine-rich repeat-containing 29', 196, NULL, NULL, 37446),
(37447, '3.90.1410.10-FF-000120', NULL, 'Uncharacterized protein', 173, NULL, NULL, 37447),
(37448, '3.50.30.30-FF-000077', NULL, 'Serin endopeptidase', 111, NULL, NULL, 37448),
(37449, '3.40.50.300-FF-007572', NULL, 'Uncharacterized protein', 182, NULL, NULL, 37449),
(37450, '4.10.280.10-FF-000203', NULL, 'Uncharacterized protein', 34, NULL, NULL, 37450),
(37451, '1.25.10.10-FF-000211', NULL, 'Anaphase-promoting complex subunit 1', 267, NULL, NULL, 37451),
(37452, '2.60.120.330-FF-000241', NULL, 'Uncharacterized protein', 189, NULL, NULL, 37452),
(37453, '1.10.8.480-FF-000001', NULL, 'rRNA adenine N(6)-methyltransferase', 98, NULL, NULL, 37453),
(37454, '3.30.420.10-FF-000107', NULL, 'Poly(A) ribonuclease POP2', 288, NULL, NULL, 37454),
(37455, '1.20.1280.50-FF-000009', NULL, 'F-box only protein 10', 86, NULL, NULL, 37455),
(37456, '4.10.400.10-FF-000174', NULL, 'Low-density lipoprotein receptor-related protein', 39, NULL, NULL, 37456),
(37457, '1.10.630.10-FF-000186', NULL, 'Cytochrome P450, putative (Eurofung)', 474, NULL, NULL, 37457),
(37458, '3.30.40.10-FF-001371', NULL, 'Predicted protein', 86, NULL, NULL, 37458),
(37459, '2.120.10.80-FF-000033', NULL, 'Multiple epidermal growth factor-like domains 8', 162, NULL, NULL, 37459),
(37460, '1.20.970.10-FF-000006', NULL, 'Anthranilate phosphoribosyltransferase', 71, NULL, NULL, 37460),
(37461, '3.40.50.300-FF-001586', NULL, 'Small GTP-binding protein, putative', 194, NULL, NULL, 37461),
(37462, '3.30.70.100-FF-000043', NULL, 'Copper-transporting ATPase 2', 72, NULL, NULL, 37462),
(37463, '3.30.230.10-FF-000194', NULL, 'Predicted protein', 147, NULL, NULL, 37463),
(37464, '2.130.10.10-FF-003643', NULL, 'Uncharacterized protein', 77, NULL, NULL, 37464),
(37465, '2.130.10.10-FF-005767', NULL, 'Uncharacterized protein', 108, NULL, NULL, 37465),
(37466, '1.25.10.10-FF-001313', NULL, 'Protein SIEL', 94, NULL, NULL, 37466),
(37467, '3.40.50.300-FF-006442', NULL, 'Uncharacterized protein', 125, NULL, NULL, 37467),
(37468, '3.40.920.10-FF-000025', NULL, NULL, 197, NULL, NULL, 37468),
(37469, '3.30.70.1230-FF-000242', NULL, 'Predicted protein', 106, NULL, NULL, 37469),
(37470, '3.30.70.590-FF-000026', NULL, 'Uncharacterized protein', 104, NULL, NULL, 37470),
(37471, '3.30.40.10-FF-001601', NULL, 'RING finger protein 151', 61, NULL, NULL, 37471),
(37472, '3.30.70.141-FF-000039', NULL, 'Nucleoside diphosphate kinase B', 151, NULL, NULL, 37472),
(37473, '3.60.21.10-FF-000302', NULL, 'Serine/threonine-protein phosphatase', 314, NULL, NULL, 37473),
(37474, '3.30.70.330-FF-000999', NULL, 'Polypyrimidine tract binding protein, putative', 114, NULL, NULL, 37474),
(37475, '1.20.1310.10-FF-000102', NULL, 'Cullin family, putative', 98, NULL, NULL, 37475);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(37476, '3.30.70.1730-FF-000004', NULL, 'Ribosome assembly factor mrt4', 110, NULL, NULL, 37476),
(37477, '3.30.1460.20-FF-000016', NULL, 'Arp2/3 complex 34 kDa subunit', 154, NULL, NULL, 37477),
(37478, '2.130.10.10-FF-003148', NULL, 'Intraflagellar transport protein 122', 171, NULL, NULL, 37478),
(37479, '3.40.640.10-FF-000189', NULL, 'Glycine dehydrogenase (decarboxylating)', 68, NULL, NULL, 37479),
(37480, '3.30.160.60-FF-001967', NULL, 'Ras-responsive element-binding protein', 27, NULL, NULL, 37480),
(37481, '2.130.10.10-FF-003351', NULL, 'Uncharacterized protein', 271, NULL, NULL, 37481),
(37482, '3.30.860.10-FF-000016', NULL, '26S proteasome non-ATPase regulatory subunit 14-like protein', 53, NULL, NULL, 37482),
(37483, '3.30.40.10-FF-000258', NULL, 'Vacuolar protein sorting-associated protein 11 homolog', 90, NULL, NULL, 37483),
(37484, '3.30.750.44-FF-000033', NULL, NULL, 15, NULL, NULL, 37484),
(37485, '1.10.287.700-FF-000004', NULL, 'Late embryogenesis abundant protein (LEA) family protein', 95, NULL, NULL, 37485),
(37486, '2.130.10.10-FF-001496', NULL, 'WD domain, G-beta repeat-containing protein', 113, NULL, NULL, 37486),
(37487, '1.25.40.10-FF-003086', NULL, 'Pentatricopeptide repeat-containing protein', 171, NULL, NULL, 37487),
(37488, '1.10.1520.10-FF-000093', NULL, 'Endoribonuclease Dicer-like', 147, NULL, NULL, 37488),
(37489, '2.60.40.10-FF-005317', NULL, NULL, 112, NULL, NULL, 37489),
(37490, '3.40.50.720-FF-002555', NULL, 'Predicted protein', 59, NULL, NULL, 37490),
(37491, '3.40.50.10190-FF-000116', NULL, 'Nibrin', 91, NULL, NULL, 37491),
(37492, '2.20.28.10-FF-000030', NULL, 'DNA helicase', 59, NULL, NULL, 37492),
(37493, '1.10.510.10-FF-001374', NULL, 'PH-protein kinase domain containing protein', 175, NULL, NULL, 37493),
(37494, '3.30.70.1720-FF-000001', NULL, 'Bifunctional hemolysin/adenylate cyclase', 138, NULL, NULL, 37494),
(37495, '2.60.40.1230-FF-000022', NULL, 'AP-1 complex subunit gamma', 115, NULL, NULL, 37495),
(37496, '2.40.37.10-FF-000016', NULL, 'Carboxynorspermidine/carboxyspermidine decarboxylase', 132, NULL, NULL, 37496),
(37497, '3.60.10.10-FF-000311', NULL, 'Predicted protein', 294, NULL, NULL, 37497),
(37498, '3.30.60.30-FF-000214', NULL, 'Uncharacterized protein', 64, NULL, NULL, 37498),
(37499, '2.130.10.10-FF-003295', NULL, 'Serine/threonine-protein kinase/endoribonuclease IRE2', 202, NULL, NULL, 37499),
(37500, '3.40.630.30-FF-000520', NULL, 'Uncharacterized protein', 214, NULL, NULL, 37500),
(37501, '2.60.120.620-FF-000114', NULL, 'Uncharacterized protein', 167, NULL, NULL, 37501),
(37502, '3.30.1330.30-FF-000072', NULL, '60S ribosomal protein L7A-2, putative', 192, NULL, NULL, 37502),
(37503, '3.10.280.10-FF-000010', NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', 210, NULL, NULL, 37503),
(37504, '1.10.840.10-FF-000016', NULL, 'RASGEF1A isoform 5', 276, NULL, NULL, 37504),
(37505, '1.10.565.10-FF-000056', NULL, 'Nuclear hormone receptor family member nhr-49', 277, NULL, NULL, 37505),
(37506, '1.10.455.10-FF-000025', NULL, 'Uncharacterized protein', 110, NULL, NULL, 37506),
(37507, '1.10.10.10-FF-002004', NULL, 'Uncharacterized protein', 127, NULL, NULL, 37507),
(37508, '1.10.10.60-FF-001159', NULL, NULL, 51, NULL, NULL, 37508),
(37509, '2.60.120.970-FF-000112', NULL, 'Anti-dorsalizing morphogenetic protein, putative', 109, NULL, NULL, 37509),
(37510, '3.20.20.190-FF-000174', NULL, NULL, 52, NULL, NULL, 37510),
(37511, '3.40.50.300-FF-005099', NULL, 'GTP-binding protein A', 267, NULL, NULL, 37511),
(37512, '1.10.1200.10-FF-000170', NULL, 'Uncharacterized protein', 42, NULL, NULL, 37512),
(37513, '3.20.20.100-FF-000069', NULL, 'Protein CBG12061', 165, NULL, NULL, 37513),
(37514, '1.10.630.10-FF-000096', NULL, 'Cytochrome P450 3A4', 486, NULL, NULL, 37514),
(37515, '3.60.20.10-FF-000132', NULL, 'Asparagine synthase', 181, NULL, NULL, 37515),
(37516, '4.10.400.10-FF-000264', NULL, 'LDL receptor-like repeat', 48, NULL, NULL, 37516),
(37517, '1.20.1070.10-FF-000656', NULL, 'neuropeptide FF receptor 2', 310, NULL, NULL, 37517);
INSERT INTO "PUBLIC"."MODEL" VALUES
(37518, '1.50.40.10-FF-000391', NULL, 'Uncharacterized protein', 147, NULL, NULL, 37518),
(37519, '1.25.10.10-FF-001936', NULL, 'E3 ubiquitin-protein ligase UPL1', 419, NULL, NULL, 37519),
(37520, '1.20.120.1080-FF-000134', NULL, 'Uncharacterized protein', 156, NULL, NULL, 37520),
(37521, '1.10.10.60-FF-000411', NULL, 'Transcription factor TRY', 62, NULL, NULL, 37521),
(37522, '1.20.1070.10-FF-000712', NULL, 'Uncharacterized protein', 299, NULL, NULL, 37522),
(37523, '3.40.30.10-FF-000622', NULL, 'Protein disulfide isomerase', 113, NULL, NULL, 37523),
(37524, '1.10.268.10-FF-000017', NULL, 'DNA topoisomerase 2', 172, NULL, NULL, 37524),
(37525, '3.40.50.1010-FF-000078', NULL, 'Ribonuclease VapC', 115, NULL, NULL, 37525),
(37526, '2.60.40.10-FF-001046', NULL, 'Immunoglobulin superfamily member 10', 92, NULL, NULL, 37526),
(37527, '1.10.3720.10-FF-000102', NULL, 'Oligopeptide ABC transporter permease OppC', 209, NULL, NULL, 37527),
(37528, '1.10.340.70-FF-000024', NULL, 'OSJNBa0059D20.8 protein', 79, NULL, NULL, 37528),
(37529, '3.90.1580.10-FF-000008', NULL, 'Predicted protein', 312, NULL, NULL, 37529),
(37530, '2.30.40.10-FF-000064', NULL, 'Formylmethanofuran dehydrogenase subunit A', 97, NULL, NULL, 37530),
(37531, '1.20.1070.10-FF-000566', NULL, 'Uncharacterized protein', 254, NULL, NULL, 37531),
(37532, '3.40.630.30-FF-000610', NULL, 'Elongator complex protein 3', 57, NULL, NULL, 37532),
(37533, '3.20.19.10-FF-000006', NULL, 'Aconitate hydratase 1', 235, NULL, NULL, 37533),
(37534, '1.10.510.10-FF-003173', NULL, NULL, 163, NULL, NULL, 37534),
(37535, '3.30.160.60-FF-001349', NULL, 'Uncharacterized protein', 29, NULL, NULL, 37535),
(37536, '2.60.220.50-FF-000185', NULL, 'Uncharacterized protein', 47, NULL, NULL, 37536),
(37537, '3.40.50.1100-FF-000043', NULL, 'Cysteine synthase, chloroplastic/chromoplastic', 103, NULL, NULL, 37537),
(37538, '2.20.110.10-FF-000039', NULL, 'Protein ACCUMULATION AND REPLICATION OF CHLOROPLASTS 3', 61, NULL, NULL, 37538),
(37539, '1.10.287.70-FF-000444', NULL, 'Potassium voltage-gated channel, KQT-like subfamily, member 4', 80, NULL, NULL, 37539),
(37540, '3.20.20.20-FF-000024', NULL, 'Tetrahydromethanopterin S-methyltransferase subunit H', 186, NULL, NULL, 37540),
(37541, '2.60.40.420-FF-000068', NULL, 'coagulation factor V isoform X1', 144, NULL, NULL, 37541),
(37542, '2.60.40.10-FF-000028', NULL, 'Neuronal cell adhesion molecule', 102, NULL, NULL, 37542),
(37543, '2.30.30.40-FF-000521', NULL, 'phosphatidylinositol 3-kinase regulatory subunit gamma', 76, NULL, NULL, 37543),
(37544, '3.40.50.2300-FF-001555', NULL, NULL, 21, NULL, NULL, 37544),
(37545, '3.30.2320.20-FF-000001', NULL, 'Leucine--tRNA ligase', 84, NULL, NULL, 37545),
(37546, '3.30.2320.30-FF-000004', NULL, 'Putative ATP synthase', 126, NULL, NULL, 37546),
(37547, '3.40.850.10-FF-000289', NULL, 'Predicted protein', 60, NULL, NULL, 37547),
(37548, '3.20.20.10-FF-000021', NULL, 'Pyridoxal phosphate homeostasis protein', 241, NULL, NULL, 37548),
(37549, '3.40.50.10490-FF-000088', NULL, 'Glucokinase regulator', 110, NULL, NULL, 37549),
(37550, '3.20.20.30-FF-000027', NULL, '5,10-methylenetetrahydromethanopterin reductase', 321, NULL, NULL, 37550),
(37551, '3.40.50.410-FF-000371', NULL, '60 kDa SS-A/Ro ribonucleoprotein homolog', 192, NULL, NULL, 37551),
(37552, '1.20.58.60-FF-000684', NULL, 'Uncharacterized protein', 114, NULL, NULL, 37552),
(37553, '1.20.120.1770-FF-000004', NULL, 'CYB561A3 isoform 10', 97, NULL, NULL, 37553),
(37554, '1.20.1070.10-FF-000364', NULL, 'Frizzled receptor 4', 350, NULL, NULL, 37554),
(37555, '3.40.50.2000-FF-000476', NULL, 'Glycosyltransferase', 241, NULL, NULL, 37555),
(37556, '3.40.50.300-FF-000512', NULL, 'Rac-like GTP-binding protein 3', 199, NULL, NULL, 37556),
(37557, '2.30.30.870-FF-000005', NULL, 'Protein DOM34 homolog', 140, NULL, NULL, 37557),
(37558, '1.20.900.10-FF-000058', NULL, 'Uncharacterized protein, isoform A', 201, NULL, NULL, 37558),
(37559, '3.30.710.10-FF-000450', NULL, 'SKp1 Related (Ubiquitin ligase complex component)', 144, NULL, NULL, 37559);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(37560, '2.60.40.10-FF-005464', NULL, NULL, 104, NULL, NULL, 37560),
(37561, '3.40.50.1820-FF-001506', NULL, 'Protein CBG10315', 156, NULL, NULL, 37561),
(37562, '3.40.850.10-FF-000435', NULL, 'Uncharacterized protein', 143, NULL, NULL, 37562),
(37563, '3.90.660.10-FF-000050', NULL, 'Polyamine oxidase, putative', 223, NULL, NULL, 37563),
(37564, '3.90.1750.10-FF-000050', NULL, 'E3 ubiquitin-protein ligase hecd-1', 31, NULL, NULL, 37564),
(37565, '1.20.120.1760-FF-000001', NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', 177, NULL, NULL, 37565),
(37566, '3.40.50.1370-FF-000017', NULL, 'Ornithine carbamoyltransferase', 141, NULL, NULL, 37566),
(37567, '3.40.50.720-FF-001453', NULL, 'Uncharacterized protein', 53, NULL, NULL, 37567),
(37568, '3.30.70.80-FF-000005', NULL, 'Proteinase inhibitor I2B', 72, NULL, NULL, 37568),
(37569, '3.40.50.300-FF-007044', NULL, 'Small GTP-binding protein, putative', 199, NULL, NULL, 37569),
(37570, '3.40.50.10090-FF-000058', NULL, 'Uncharacterized protein', 82, NULL, NULL, 37570),
(37571, '1.25.40.180-FF-000057', NULL, 'Initiation Factor 4G (eIF4G) family', 244, NULL, NULL, 37571),
(37572, '1.10.565.10-FF-000202', NULL, 'Uncharacterized protein', 182, NULL, NULL, 37572),
(37573, '3.40.50.10330-FF-000124', NULL, 'Diacylglycerol kinase', 126, NULL, NULL, 37573),
(37574, '2.40.50.40-FF-000056', NULL, 'Heterochromatin protein 1c', 68, NULL, NULL, 37574),
(37575, '3.30.160.60-FF-002979', NULL, 'LD21421p', 27, NULL, NULL, 37575),
(37576, '3.30.190.20-FF-000024', NULL, '50S ribosomal protein L1', 108, NULL, NULL, 37576),
(37577, '1.50.10.160-FF-000018', NULL, 'Os12g0491500 protein', 54, NULL, NULL, 37577),
(37578, '1.10.720.30-FF-000081', NULL, 'Uncharacterized protein', 56, NULL, NULL, 37578),
(37579, '1.10.565.10-FF-000146', NULL, 'Uncharacterized protein', 261, NULL, NULL, 37579),
(37580, '2.60.40.10-FF-001607', NULL, 'Leukocyte immune-type receptor TS32.15 L2.5a', 91, NULL, NULL, 37580),
(37581, '1.20.144.10-FF-000020', NULL, 'phospholipid phosphatase 6', 84, NULL, NULL, 37581),
(37582, '3.20.20.140-FF-000417', NULL, '5-methylthioadenosine/S-adenosylhomocysteine deaminase', 74, NULL, NULL, 37582),
(37583, '1.25.40.20-FF-000042', NULL, 'caskin-2 isoform X2', 114, NULL, NULL, 37583),
(37584, '1.10.510.10-FF-002678', NULL, 'Probable serine/threonine-protein kinase PLK', 248, NULL, NULL, 37584),
(37585, '1.10.10.10-FF-001638', NULL, 'AGAP008638-PA', 85, NULL, NULL, 37585),
(37586, '3.40.850.10-FF-000345', NULL, 'Kinesin-like protein KIN-7N', 166, NULL, NULL, 37586),
(37587, '1.20.1270.60-FF-000192', NULL, 'YALI0D07524p', 234, NULL, NULL, 37587),
(37588, '3.30.390.110-FF-000010', NULL, '60S ribosomal protein L28-2', 59, NULL, NULL, 37588),
(37589, '3.90.550.20-FF-000022', NULL, 'Uncharacterized protein', 227, NULL, NULL, 37589),
(37590, '1.20.1560.10-FF-000564', NULL, 'Multidrug resistance protein 1, 2, 3', 342, NULL, NULL, 37590),
(37591, '2.40.290.10-FF-000013', NULL, 'ATP-dependent DNA helicase II subunit 2', 195, NULL, NULL, 37591),
(37592, '3.30.70.330-FF-000797', NULL, 'Nonsense-mediated mRNA decay protein Upf3, putative', 81, NULL, NULL, 37592),
(37593, '1.50.10.150-FF-000015', NULL, 'Putative malic acid transport protein', 355, NULL, NULL, 37593),
(37594, '3.40.50.1110-FF-000046', NULL, 'Protein CBG23371', 294, NULL, NULL, 37594),
(37595, '3.90.190.10-FF-000558', NULL, 'Dual-specificity protein phosphatase, putative', 97, NULL, NULL, 37595),
(37596, '3.10.105.10-FF-000076', NULL, 'ABC transporter substrate-binding protein', 214, NULL, NULL, 37596),
(37597, '3.40.50.300-FF-000602', NULL, 'Serine protein kinase PrkA', 254, NULL, NULL, 37597),
(37598, '3.80.10.10-FF-000973', NULL, 'Tubulin-specific chaperone E', 108, NULL, NULL, 37598),
(37599, '3.30.450.20-FF-000269', NULL, 'Two-component sensor kinase', 101, NULL, NULL, 37599),
(37600, '1.20.58.530-FF-000042', NULL, NULL, 20, NULL, NULL, 37600),
(37601, '2.40.30.70-FF-000013', NULL, 'tRNA methyltransferase O', 84, NULL, NULL, 37601),
(37602, '3.40.50.1400-FF-000009', NULL, 'Ferrochelatase', 155, NULL, NULL, 37602);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(37603, '1.25.10.20-FF-000012', NULL, 'Hemelipoglyco-carrier protein CP3', 326, NULL, NULL, 37603),
(37604, '1.20.58.60-FF-000740', NULL, 'Uncharacterized protein', 261, NULL, NULL, 37604),
(37605, '3.40.50.300-FF-006116', NULL, 'ATP-dependent DNA helicase', 187, NULL, NULL, 37605),
(37606, '1.10.8.10-FF-000316', NULL, 'DNA (cytosine-5)-methyltransferase DRM1', 60, NULL, NULL, 37606),
(37607, '3.40.50.740-FF-000060', NULL, 'NADH-quinone oxidoreductase', 61, NULL, NULL, 37607),
(37608, '2.60.120.10-FF-000126', NULL, 'Cyclic nucleotide-binding domain protein', 114, NULL, NULL, 37608),
(37609, '3.30.160.60-FF-003912', NULL, NULL, 31, NULL, NULL, 37609),
(37610, '3.30.40.10-FF-000584', NULL, 'Ubiquitinyl hydrolase 1', 122, NULL, NULL, 37610),
(37611, '1.20.5.110-FF-000321', NULL, 'Synaptosomal-associated protein 25', 40, NULL, NULL, 37611),
(37612, '3.30.160.20-FF-000168', NULL, 'Ribonuclease III', 82, NULL, NULL, 37612),
(37613, '3.20.20.70-FF-000432', NULL, 'tRNA-dihydrouridine(20) synthase [NAD(P)+]-like', 151, NULL, NULL, 37613),
(37614, '3.40.1280.10-FF-000082', NULL, 'TrmH family tRNA/rRNA methyltransferase YacO', 170, NULL, NULL, 37614),
(37615, '1.20.1270.220-FF-000011', NULL, 'SWR1 complex bromodomain subunit bdf1', 74, NULL, NULL, 37615),
(37616, '3.40.50.1820-FF-000641', NULL, 'Carboxylic ester hydrolase', 129, NULL, NULL, 37616),
(37617, '3.30.160.60-FF-004401', NULL, NULL, 28, NULL, NULL, 37617),
(37618, '2.60.40.10-FF-003171', NULL, 'LOC100005699 protein', 92, NULL, NULL, 37618),
(37619, '2.60.40.10-FF-001574', NULL, 'Blast:Putative epidermal cell surface receptor', 101, NULL, NULL, 37619),
(37620, '1.25.10.10-FF-003258', NULL, 'Predicted protein', 215, NULL, NULL, 37620),
(37621, '1.10.3810.10-FF-000019', NULL, 'Penicillin-binding protein 1C', 192, NULL, NULL, 37621),
(37622, '3.10.290.60-FF-000003', NULL, 'Ubiquitin-like modifier activating enzyme 6', 91, NULL, NULL, 37622),
(37623, '3.30.160.60-FF-003822', NULL, NULL, 29, NULL, NULL, 37623),
(37624, '3.10.290.70-FF-000006', NULL, '40S ribosomal protein S8', 91, NULL, NULL, 37624),
(37625, '3.40.30.10-FF-000532', NULL, 'Uncharacterized protein T09A5.5', 146, NULL, NULL, 37625),
(37626, '4.10.280.110-FF-000006', NULL, 'U4/U6 small nuclear ribonucleoprotein Prp4', 76, NULL, NULL, 37626),
(37627, '1.20.1070.10-FF-001022', NULL, 'Uncharacterized protein', 309, NULL, NULL, 37627),
(37628, '2.10.50.10-FF-000144', NULL, 'Uncharacterized protein', 56, NULL, NULL, 37628),
(37629, '4.10.400.10-FF-000320', NULL, 'uncharacterized protein LOC100180965 isoform X1', 45, NULL, NULL, 37629),
(37630, '1.10.630.10-FF-000388', NULL, 'Os04g0480600 protein', 221, NULL, NULL, 37630),
(37631, '3.30.160.60-FF-006172', NULL, NULL, 68, NULL, NULL, 37631),
(37632, '2.60.120.260-FF-000664', NULL, 'Predicted protein', 223, NULL, NULL, 37632),
(37633, '3.40.50.620-FF-000636', NULL, 'Tyrosine--tRNA ligase', 151, NULL, NULL, 37633),
(37634, '1.10.10.60-FF-001069', NULL, NULL, 54, NULL, NULL, 37634),
(37635, '2.20.25.530-FF-000013', NULL, 'Chromosome 1, whole genome shotgun sequence', 78, NULL, NULL, 37635),
(37636, '3.90.470.20-FF-000021', NULL, 'L-aminoadipate-semialdehyde dehydrogenase-phosphopantetheinyl transferase', 97, NULL, NULL, 37636),
(37637, '1.20.58.60-FF-000863', NULL, 'Predicted protein', 125, NULL, NULL, 37637),
(37638, '3.40.50.150-FF-001557', NULL, NULL, 76, NULL, NULL, 37638),
(37639, '2.60.120.10-FF-000396', NULL, 'cAMP-binding protein-catabolite gene activator and regulatory subunit of cAMP-dependent protein kinase', 121, NULL, NULL, 37639),
(37640, '3.30.479.20-FF-000026', NULL, 'Elongation factor Ts, mitochondrial', 115, NULL, NULL, 37640),
(37641, '2.60.120.260-FF-000574', NULL, 'Predicted protein', 190, NULL, NULL, 37641),
(37642, '2.40.128.20-FF-000056', NULL, 'Uncharacterized protein', 155, NULL, NULL, 37642),
(37643, '3.20.20.70-FF-000342', NULL, 'tRNA-dihydrouridine synthase', 237, NULL, NULL, 37643),
(37644, '3.40.50.1100-FF-000133', NULL, 'Serine racemase', 136, NULL, NULL, 37644),
(37645, '3.30.160.60-FF-001877', NULL, 'Zinc finger protein 236', 28, NULL, NULL, 37645);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(37646, '3.90.190.10-FF-000182', NULL, 'Protein-tyrosine-phosphatase', 287, NULL, NULL, 37646),
(37647, '3.50.50.60-FF-000598', NULL, 'FAD-dependent oxidoreductase', 189, NULL, NULL, 37647),
(37648, '1.20.1070.10-FF-000038', NULL, 'Muscarinic acetylcholine receptor', 227, NULL, NULL, 37648),
(37649, '3.40.190.80-FF-000062', NULL, 'Inositol polyphosphate 1-phosphatase, putative', 126, NULL, NULL, 37649),
(37650, '2.60.40.10-FF-005587', NULL, NULL, 36, NULL, NULL, 37650),
(37651, '3.30.470.20-FF-000181', NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', 138, NULL, NULL, 37651),
(37652, '1.10.510.10-FF-000441', NULL, 'Serine/threonine protein kinase', 308, NULL, NULL, 37652),
(37653, '3.30.230.10-FF-000368', NULL, 'Lon protease homolog 1 mitochondrial', 91, NULL, NULL, 37653),
(37654, '3.80.10.10-FF-004065', NULL, 'Uncharacterized protein', 132, NULL, NULL, 37654),
(37655, '3.30.479.30-FF-000029', NULL, 'Band 7 protein', 154, NULL, NULL, 37655),
(37656, '1.10.1200.10-FF-000107', NULL, 'Ferricrocin synthetase (Nonribosomal peptide siderophore synthase ) (Eurofung)', 89, NULL, NULL, 37656),
(37657, '2.30.42.10-FF-000607', NULL, NULL, 96, NULL, NULL, 37657),
(37658, '1.10.287.4070-FF-000027', NULL, 'Uncharacterized protein', 50, NULL, NULL, 37658),
(37659, '2.20.100.10-FF-000123', NULL, 'SCO-spondin', 67, NULL, NULL, 37659),
(37660, '3.30.160.60-FF-004311', NULL, NULL, 72, NULL, NULL, 37660),
(37661, '1.25.40.10-FF-003563', NULL, 'Reduced mechanoreceptor potential A', 243, NULL, NULL, 37661),
(37662, '3.40.50.1010-FF-000134', NULL, 'Phosphate starvation protein PhoH', 139, NULL, NULL, 37662),
(37663, '3.30.390.80-FF-000001', NULL, 'DNA repair protein RAD52 homolog', 148, NULL, NULL, 37663),
(37664, '2.60.40.1930-FF-000024', NULL, 'Alpha-2-macroglobulin-like', 106, NULL, NULL, 37664),
(37665, '2.130.10.10-FF-002985', NULL, 'YALI0B17798p', 202, NULL, NULL, 37665),
(37666, '1.25.40.10-FF-001141', NULL, 'Tetratricopeptide repeat protein 30A', 213, NULL, NULL, 37666),
(37667, '2.60.120.200-FF-000337', NULL, 'Galectin', 144, NULL, NULL, 37667),
(37668, '3.60.10.10-FF-000159', NULL, 'Putative neutral sphingomyelinase', 293, NULL, NULL, 37668),
(37669, '3.40.50.1000-FF-000131', NULL, 'HAD superfamily hydrolase, putative', 138, NULL, NULL, 37669),
(37670, '2.30.110.10-FF-000104', NULL, 'Cellular repressor of E1A stimulated genes 1', 113, NULL, NULL, 37670),
(37671, '2.10.110.10-FF-000238', NULL, 'Predicted protein', 64, NULL, NULL, 37671),
(37672, '3.20.20.80-FF-000345', NULL, 'Secreted alpha-amylase', 188, NULL, NULL, 37672),
(37673, '3.40.50.1110-FF-000136', NULL, 'Similar to acyl-CoA thioesterase I', 208, NULL, NULL, 37673),
(37674, '1.10.510.10-FF-003818', NULL, NULL, 115, NULL, NULL, 37674),
(37675, '3.40.50.300-FF-007746', NULL, 'Uncharacterized protein', 78, NULL, NULL, 37675),
(37676, '1.20.1070.10-FF-000892', NULL, 'Uncharacterized protein', 261, NULL, NULL, 37676),
(37677, '1.10.1040.10-FF-000016', NULL, 'Glyoxylate/succinic semialdehyde reductase 2', 125, NULL, NULL, 37677),
(37678, '2.40.50.140-FF-000659', NULL, NULL, 83, NULL, NULL, 37678),
(37679, '1.10.10.540-FF-000006', NULL, 'Unplaced genomic scaffold supercont2.19, whole genome shotgun sequence', 49, NULL, NULL, 37679),
(37680, '3.90.70.10-FF-000072', NULL, 'Cysteine proteinase', 132, NULL, NULL, 37680),
(37681, '3.90.640.10-FF-000048', NULL, 'Heat shock protein 110', 90, NULL, NULL, 37681),
(37682, '2.30.29.30-FF-000594', NULL, 'YLR072Wp protein', 107, NULL, NULL, 37682),
(37683, '2.40.50.90-FF-000172', NULL, 'Uncharacterized protein', 170, NULL, NULL, 37683),
(37684, '2.60.120.200-FF-000668', NULL, 'Clade XVII lectin receptor kinase', 70, NULL, NULL, 37684),
(37685, '3.30.160.60-FF-002895', NULL, NULL, 28, NULL, NULL, 37685),
(37686, '3.80.10.10-FF-002974', NULL, 'Uncharacterized protein', 101, NULL, NULL, 37686),
(37687, '3.40.50.300-FF-003862', NULL, 'U3 small nucleolar RNA-associated protein 25', 208, NULL, NULL, 37687),
(37688, '3.30.160.60-FF-004603', NULL, NULL, 56, NULL, NULL, 37688),
(37689, '1.10.510.10-FF-004010', NULL, NULL, 139, NULL, NULL, 37689); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(37690, '3.80.10.10-FF-002502', NULL, 'Leucine-rich repeat kinase 2', 188, NULL, NULL, 37690),
(37691, '2.130.10.110-FF-000019', NULL, 'Uncharacterized protein', 102, NULL, NULL, 37691),
(37692, '3.40.50.720-FF-002381', NULL, 'Predicted protein', 155, NULL, NULL, 37692),
(37693, '3.40.50.300-FF-006026', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', 141, NULL, NULL, 37693),
(37694, '3.30.310.10-FF-000048', NULL, 'AP-1 complex subunit beta', 121, NULL, NULL, 37694),
(37695, '1.20.1110.10-FF-000244', NULL, 'Sodium/potassium-transporting ATPase subunit alpha', 408, NULL, NULL, 37695),
(37696, '1.25.10.10-FF-001083', NULL, 'Dynein assembly factor 5, axonemal', 233, NULL, NULL, 37696),
(37697, '2.10.25.10-FF-000456', NULL, 'Neurogenic locus notch homolog protein 4', 37, NULL, NULL, 37697),
(37698, '1.20.1070.10-FF-001201', NULL, 'Predicted protein', 128, NULL, NULL, 37698),
(37699, '3.40.50.300-FF-007662', NULL, 'SMC domain protein', 126, NULL, NULL, 37699),
(37700, '3.80.10.10-FF-002446', NULL, 'Receptor like protein 1', 101, NULL, NULL, 37700),
(37701, '3.20.20.80-FF-000289', NULL, 'Beta-mannosidase Man2', 341, NULL, NULL, 37701),
(37702, '1.10.472.10-FF-000222', NULL, 'Retinoblastoma family protein', 183, NULL, NULL, 37702),
(37703, '1.10.287.130-FF-000171', NULL, 'Integral membrane sensor signal transduction histidine kinase', 83, NULL, NULL, 37703),
(37704, '1.25.40.570-FF-000045', NULL, 'YALI0D25102p', 347, NULL, NULL, 37704),
(37705, '3.20.20.70-FF-000286', NULL, 'Alpha-galactosidase', 289, NULL, NULL, 37705),
(37706, '2.60.40.10-FF-001933', NULL, 'Blast:Contactin', 92, NULL, NULL, 37706),
(37707, '3.40.50.300-FF-001676', NULL, 'DExH-box ATP-dependent RNA helicase DExH7 chloroplastic', 232, NULL, NULL, 37707),
(37708, '3.40.50.150-FF-001378', NULL, NULL, 176, NULL, NULL, 37708),
(37709, '3.30.160.60-FF-000332', NULL, 'E3 ubiquitin-protein ligase TRIM37 isoform X1', 45, NULL, NULL, 37709),
(37710, '3.30.450.20-FF-000180', NULL, 'Phosphoglycerate kinase', 101, NULL, NULL, 37710),
(37711, '3.30.70.330-FF-001163', NULL, 'RNA recognition motif domain containing protein', 125, NULL, NULL, 37711),
(37712, '3.30.420.10-FF-000725', NULL, NULL, 65, NULL, NULL, 37712),
(37713, '3.30.70.2850-FF-000008', NULL, 'DNA-directed RNA polymerase subunit', 205, NULL, NULL, 37713),
(37714, '1.20.1560.10-FF-000233', NULL, 'Uncharacterized protein', 354, NULL, NULL, 37714),
(37715, '3.30.70.330-FF-002742', NULL, NULL, 93, NULL, NULL, 37715),
(37716, '1.20.1250.20-FF-000752', NULL, 'MFS transporter, putative', 406, NULL, NULL, 37716),
(37717, '3.30.70.2840-FF-000005', NULL, 'NS5 protein', 62, NULL, NULL, 37717),
(37718, '1.10.10.350-FF-000016', NULL, 'Glutamate--tRNA ligase', 110, NULL, NULL, 37718),
(37719, '3.40.50.620-FF-000726', NULL, 'Electron transfer flavoprotein, beta subunit, putative', 200, NULL, NULL, 37719),
(37720, '1.20.120.790-FF-000001', NULL, 'Heat shock protein 90 alpha', 151, NULL, NULL, 37720),
(37721, '3.40.50.150-FF-001849', NULL, NULL, 289, NULL, NULL, 37721),
(37722, '3.40.50.300-FF-007128', NULL, 'Uncharacterized protein', 182, NULL, NULL, 37722),
(37723, '3.40.50.720-FF-000666', NULL, 'Probable oxidoreductase EphD', 250, NULL, NULL, 37723),
(37724, '3.20.20.80-FF-000671', NULL, 'Glucosylceramidase, putative', 368, NULL, NULL, 37724),
(37725, '1.25.10.10-FF-003174', NULL, 'PIKK family atypical protein kinase', 328, NULL, NULL, 37725),
(37726, '1.10.510.10-FF-003403', NULL, NULL, 301, NULL, NULL, 37726),
(37727, '1.20.1280.290-FF-000079', NULL, 'Os09g0258700 protein', 80, NULL, NULL, 37727),
(37728, '3.40.190.10-FF-000968', NULL, 'Extracellular solute-binding protein, family 5', 230, NULL, NULL, 37728),
(37729, '3.30.40.10-FF-000730', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 69, NULL, NULL, 37729),
(37730, '3.40.50.300-FF-005571', NULL, 'Uncharacterized protein', 171, NULL, NULL, 37730),
(37731, '3.70.10.10-FF-000024', NULL, 'Uncharacterized protein', 302, NULL, NULL, 37731),
(37732, '1.10.1200.10-FF-000080', NULL, 'Peptidyl carrier protein PltL', 88, NULL, NULL, 37732);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(37733, '3.30.70.330-FF-002888', NULL, NULL, 59, NULL, NULL, 37733),
(37734, '1.10.3370.10-FF-000030', NULL, 'Protein translocase subunit SecY', 444, NULL, NULL, 37734),
(37735, '3.30.300.30-FF-000138', NULL, 'Nonribosomal peptide synthetase 8', 128, NULL, NULL, 37735),
(37736, '3.40.50.300-FF-007605', NULL, 'Uncharacterized protein', 159, NULL, NULL, 37736),
(37737, '3.40.50.1820-FF-000725', NULL, 'Carboxylic ester hydrolase', 236, NULL, NULL, 37737),
(37738, '3.20.20.140-FF-000092', NULL, 'Formylmethanofuran dehydrogenase subunit A', 28, NULL, NULL, 37738),
(37739, '2.60.40.10-FF-004154', NULL, NULL, 89, NULL, NULL, 37739),
(37740, '1.10.510.10-FF-003549', NULL, NULL, 230, NULL, NULL, 37740),
(37741, '1.10.287.370-FF-000006', NULL, 'prefoldin subunit 1', 115, NULL, NULL, 37741),
(37742, '2.130.10.10-FF-004986', NULL, 'Uncharacterized protein', 77, NULL, NULL, 37742),
(37743, '4.10.400.10-FF-000090', NULL, 'neuropilin and tolloid-like protein 2 isoform X1', 45, NULL, NULL, 37743),
(37744, '2.60.120.200-FF-000253', NULL, 'FlaMIngo (Cadherin plus 7TM domain) homolog', 188, NULL, NULL, 37744),
(37745, '2.10.70.10-FF-000145', NULL, 'Pappalysin 2', 61, NULL, NULL, 37745),
(37746, '3.80.10.10-FF-004155', NULL, 'Protein phosphatase 2C, putative', 104, NULL, NULL, 37746),
(37747, '1.25.40.10-FF-000977', NULL, 'MAU2 chromatid cohesion factor homolog', 138, NULL, NULL, 37747),
(37748, '1.20.1560.10-FF-000177', NULL, 'Iron ABC transporter ATP-binding protein/permease IrtA', 312, NULL, NULL, 37748),
(37749, '3.30.40.10-FF-000617', NULL, 'Peroxin 10', 110, NULL, NULL, 37749),
(37750, '1.10.630.10-FF-000803', NULL, 'Uncharacterized protein', 63, NULL, NULL, 37750),
(37751, '1.20.140.90-FF-000001', NULL, 'Malonyl-CoA decarboxylase, mitochondrial', 159, NULL, NULL, 37751),
(37752, '1.10.510.10-FF-001458', NULL, 'Protein kinase domain containing protein', 239, NULL, NULL, 37752),
(37753, '3.30.760.10-FF-000037', NULL, 'Translation initiation factor eIF-4e-like protein', 164, NULL, NULL, 37753),
(37754, '1.10.1520.10-FF-000126', NULL, 'RNase3 domain containing protein', 160, NULL, NULL, 37754),
(37755, '3.30.200.20-FF-001392', NULL, 'Kinase, PEK', 106, NULL, NULL, 37755),
(37756, '3.30.300.10-FF-000019', NULL, 'S-adenosylmethionine synthase', 107, NULL, NULL, 37756),
(37757, '2.120.10.30-FF-000479', NULL, 'Diisopropyl-fluorophosphatase', 314, NULL, NULL, 37757),
(37758, '1.20.1250.20-FF-000465', NULL, 'Carboxylic acid transporter protein homolog', 207, NULL, NULL, 37758),
(37759, '1.25.40.20-FF-000660', NULL, 'Uncharacterized protein', 123, NULL, NULL, 37759),
(37760, '3.30.450.20-FF-000595', NULL, 'Sensor histidine kinase, PAS and PAS domain-containing', 129, NULL, NULL, 37760),
(37761, '3.30.70.330-FF-001308', NULL, 'Uncharacterized protein', 122, NULL, NULL, 37761),
(37762, '1.10.533.10-FF-000100', NULL, 'NLR family pyrin domain containing 11', 93, NULL, NULL, 37762),
(37763, '2.30.30.190-FF-000048', NULL, NULL, 82, NULL, NULL, 37763),
(37764, '2.40.10.10-FF-000134', NULL, 'Uncharacterized protein, isoform B', 138, NULL, NULL, 37764),
(37765, '3.30.40.10-FF-000674', NULL, 'HRD1p Ubiquitin-protein ligase', 92, NULL, NULL, 37765),
(37766, '1.20.1740.10-FF-000275', NULL, 'Predicted protein', 81, NULL, NULL, 37766),
(37767, '1.10.287.380-FF-000009', NULL, 'Valine--tRNA ligase', 65, NULL, NULL, 37767),
(37768, '1.10.510.10-FF-003347', NULL, NULL, 239, NULL, NULL, 37768),
(37769, '3.40.50.300-FF-002283', NULL, 'p-GlycoProtein related', 249, NULL, NULL, 37769),
(37770, '3.30.450.20-FF-000556', NULL, 'Putative histidine kinase (PhoR1)', 138, NULL, NULL, 37770),
(37771, '3.30.200.20-FF-001353', NULL, 'AGC family protein kinase', 104, NULL, NULL, 37771),
(37772, '3.30.1520.10-FF-000069', NULL, 'YPT35p Endosomal protein', 147, NULL, NULL, 37772),
(37773, '1.10.1410.10-FF-000090', NULL, 'MUTator', 187, NULL, NULL, 37773),
(37774, '1.10.150.910-FF-000017', NULL, 'UV-damaged DNA binding complex subunit 1 protein', 55, NULL, NULL, 37774),
(37775, '1.20.1740.10-FF-000218', NULL, 'Uncharacterized protein', 79, NULL, NULL, 37775); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(37776, '3.30.420.380-FF-000004', NULL, 'Type II secretion system protein L', 160, NULL, NULL, 37776),
(37777, '3.10.20.90-FF-000343', NULL, 'Zinc metalloproteinase, putative', 88, NULL, NULL, 37777),
(37778, '3.40.1020.10-FF-000006', NULL, 'Threonine dehydratase', 182, NULL, NULL, 37778),
(37779, '3.30.70.270-FF-000195', NULL, NULL, 166, NULL, NULL, 37779),
(37780, '3.30.160.60-FF-005385', NULL, NULL, 26, NULL, NULL, 37780),
(37781, '1.20.920.10-FF-000060', NULL, 'PH-interacting protein isoform X3', 126, NULL, NULL, 37781),
(37782, '3.80.10.10-FF-000029', NULL, 'Transport inhibitor response 1', 530, NULL, NULL, 37782),
(37783, '2.40.70.10-FF-000110', NULL, 'Yps7p', 192, NULL, NULL, 37783),
(37784, '1.10.8.1160-FF-000001', NULL, 'Uncharacterized protein', 99, NULL, NULL, 37784),
(37785, '1.20.920.20-FF-000063', NULL, 'Uncharacterized protein', 270, NULL, NULL, 37785),
(37786, '3.40.1500.20-FF-000001', NULL, 'Red chlorophyll catabolite reductase, chloroplastic', 270, NULL, NULL, 37786),
(37787, '1.25.40.10-FF-003029', NULL, 'Pentatricopeptide repeat protein PPR868-14 isoform 1', 104, NULL, NULL, 37787),
(37788, '1.25.10.10-FF-001459', NULL, 'Protein kinase family protein / WD-40 repeat family protein', 179, NULL, NULL, 37788),
(37789, '3.90.550.10-FF-000311', NULL, 'Cellulose synthase-like protein H2', 164, NULL, NULL, 37789),
(37790, '3.40.50.300-FF-002081', NULL, 'Small GTPase EhRabX6, putative', 195, NULL, NULL, 37790),
(37791, '3.40.50.1820-FF-001512', NULL, 'Uncharacterized protein', 151, NULL, NULL, 37791),
(37792, '3.30.420.370-FF-000001', NULL, 'Type II secretion system protein L', 68, NULL, NULL, 37792),
(37793, '3.30.70.1230-FF-000096', NULL, 'Guanylate cyclase', 179, NULL, NULL, 37793),
(37794, '3.40.850.10-FF-000519', NULL, 'Predicted protein', 114, NULL, NULL, 37794),
(37795, '1.25.40.1040-FF-000065', NULL, 'Uncharacterized protein', 78, NULL, NULL, 37795),
(37796, '2.60.40.10-FF-005790', NULL, NULL, 87, NULL, NULL, 37796),
(37797, '1.10.530.10-FF-000004', NULL, 'Membrane-bound lytic murein transglycosylase D', 154, NULL, NULL, 37797),
(37798, '1.20.1600.10-FF-000001', NULL, 'TolC outer membrane channel', 426, NULL, NULL, 37798),
(37799, '3.40.50.10490-FF-000094', NULL, NULL, 78, NULL, NULL, 37799),
(37800, '4.10.280.10-FF-000113', NULL, 'Transcription factor ILI1', 73, NULL, NULL, 37800),
(37801, '1.10.8.10-FF-000081', NULL, 'GTPase activating protein for Arf', 50, NULL, NULL, 37801),
(37802, '3.30.40.10-FF-001281', NULL, 'Uncharacterized protein', 67, NULL, NULL, 37802),
(37803, '3.30.70.330-FF-001106', NULL, 'Nuclear acid binding protein, putative', 91, NULL, NULL, 37803),
(37804, '3.30.40.10-FF-000819', NULL, 'RING finger protein nhl-1', 114, NULL, NULL, 37804),
(37805, '3.40.50.300-FF-001619', NULL, 'ATP-dependent DNA helicase PIF1', 82, NULL, NULL, 37805),
(37806, '2.60.120.330-FF-000151', NULL, 'Os08g0249900 protein', 96, NULL, NULL, 37806),
(37807, '1.10.1200.10-FF-000023', NULL, 'Acyl carrier protein', 77, NULL, NULL, 37807),
(37808, '2.60.40.10-FF-001990', NULL, 'Muscle M-line assembly protein unc-89', 106, NULL, NULL, 37808),
(37809, '3.30.70.100-FF-000133', NULL, NULL, 69, NULL, NULL, 37809),
(37810, '3.30.1490.20-FF-000018', NULL, 'Biotin carboxylase', 71, NULL, NULL, 37810),
(37811, '3.80.10.10-FF-002917', NULL, 'Uncharacterized protein', 79, NULL, NULL, 37811),
(37812, '2.60.98.10-FF-000004', NULL, 'Structural polyprotein', 65, NULL, NULL, 37812),
(37813, '1.25.10.10-FF-000301', NULL, 'Heat shock transcription factor 2 binding protein', 240, NULL, NULL, 37813),
(37814, '2.40.50.140-FF-000715', NULL, NULL, 83, NULL, NULL, 37814),
(37815, '3.20.20.70-FF-000606', NULL, NULL, 161, NULL, NULL, 37815),
(37816, '1.10.510.10-FF-000115', NULL, 'Dual specificity mitogen-activated protein kinase kinase 1', 244, NULL, NULL, 37816),
(37817, '2.30.39.10-FF-000032', NULL, 'Uteroferrin-associated basic protein 2', 148, NULL, NULL, 37817),
(37818, '3.40.50.2000-FF-001055', NULL, 'Uncharacterized protein', 111, NULL, NULL, 37818),
(37819, '1.50.10.10-FF-000232', NULL, 'N-acylglucosamine 2-epimerase', 147, NULL, NULL, 37819);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(37820, '1.10.630.10-FF-000747', NULL, 'Uncharacterized protein', 75, NULL, NULL, 37820),
(37821, '3.90.190.10-FF-000266', NULL, 'Predicted protein', 216, NULL, NULL, 37821),
(37822, '3.40.630.30-FF-000317', NULL, 'AGAP000132-PA', 99, NULL, NULL, 37822),
(37823, '1.10.437.10-FF-000034', NULL, 'Predicted protein', 127, NULL, NULL, 37823),
(37824, '3.20.20.80-FF-000609', NULL, 'Uncharacterized protein', 165, NULL, NULL, 37824),
(37825, '3.30.160.60-FF-003766', NULL, 'Histone-lysine N-methyltransferase PRDM9', 28, NULL, NULL, 37825),
(37826, '3.40.1350.150-FF-000003', NULL, NULL, 156, NULL, NULL, 37826),
(37827, '3.80.10.10-FF-000557', NULL, 'Toll-6', 160, NULL, NULL, 37827),
(37828, '3.40.630.30-FF-000374', NULL, 'N-terminal acetyltransferase complex subunit, putative', 174, NULL, NULL, 37828),
(37829, '3.40.50.1000-FF-000075', NULL, 'Cation-transporting ATPase', 192, NULL, NULL, 37829),
(37830, '3.10.250.10-FF-000093', NULL, NULL, 104, NULL, NULL, 37830),
(37831, '3.10.580.10-FF-000078', NULL, 'HlyC/CorC family transporter', 155, NULL, NULL, 37831),
(37832, '1.10.10.10-FF-001279', NULL, 'Protein CBR-ELK-2', 119, NULL, NULL, 37832),
(37833, '3.30.160.60-FF-003620', NULL, NULL, 28, NULL, NULL, 37833),
(37834, '2.30.30.100-FF-000185', NULL, 'Sm protein', 70, NULL, NULL, 37834),
(37835, '2.60.40.1180-FF-000080', NULL, '1,4-alpha-glucan-branching enzyme', 100, NULL, NULL, 37835),
(37836, '2.60.120.10-FF-000542', NULL, 'Cyclic nucleotide-binding protein-like protein', 141, NULL, NULL, 37836),
(37837, '3.40.50.150-FF-001760', NULL, NULL, 228, NULL, NULL, 37837),
(37838, '3.30.930.10-FF-000432', NULL, 'Uncharacterized protein', 118, NULL, NULL, 37838),
(37839, '3.40.50.300-FF-005947', NULL, 'Putative ATP-dependent RNA helicase DHX40', 152, NULL, NULL, 37839),
(37840, '2.10.70.10-FF-000201', NULL, 'Predicted protein', 60, NULL, NULL, 37840),
(37841, '3.80.10.10-FF-004357', NULL, 'Leucine rich repeats and calponin homology domain containing 4', 176, NULL, NULL, 37841),
(37842, '2.40.40.20-FF-000021', NULL, 'Cell division cycle protein 48 homologue', 98, NULL, NULL, 37842),
(37843, '2.60.120.200-FF-000781', NULL, 'Galectin', 148, NULL, NULL, 37843),
(37844, '3.90.360.10-FF-000010', NULL, 'Histone acetyltransferase, type b catalytic subunit', 18, NULL, NULL, 37844),
(37845, '3.90.226.10-FF-000041', NULL, 'Propionyl-CoA carboxylase subunit beta', 261, NULL, NULL, 37845),
(37846, '1.10.357.120-FF-000004', NULL, 'DNA-directed RNA polymerase subunit', 124, NULL, NULL, 37846),
(37847, '3.30.160.60-FF-003676', NULL, 'Protein suppressor of hairy wing', 27, NULL, NULL, 37847),
(37848, '3.40.30.10-FF-000240', NULL, 'TPR repeat-containing thioredoxin TDX', 133, NULL, NULL, 37848),
(37849, '1.20.920.10-FF-000149', NULL, 'Uncharacterized protein', 112, NULL, NULL, 37849),
(37850, '1.20.120.350-FF-000223', NULL, NULL, 150, NULL, NULL, 37850),
(37851, '3.90.70.10-FF-000015', NULL, 'Ubiquitin specific peptidase 10', 400, NULL, NULL, 37851),
(37852, '1.10.150.50-FF-000150', NULL, 'SAM_domain_(Sterile_alpha_motif)_-_putative', 77, NULL, NULL, 37852),
(37853, '3.90.228.10-FF-000023', NULL, 'mRNA, clone: RTFL01-11-B23', 206, NULL, NULL, 37853),
(37854, '2.60.98.20-FF-000007', NULL, 'Flagellar hook protein FlgE', 144, NULL, NULL, 37854),
(37855, '3.20.20.70-FF-000516', NULL, 'Triosephosphate isomerase', 291, NULL, NULL, 37855),
(37856, '1.10.357.110-FF-000001', NULL, 'vacuolar protein sorting-associated protein 53 homolog', 151, NULL, NULL, 37856),
(37857, '1.10.10.10-FF-001133', NULL, 'Fork-head transcriptional regulator FHL1', 94, NULL, NULL, 37857),
(37858, '2.60.40.10-FF-005733', NULL, NULL, 111, NULL, NULL, 37858),
(37859, '2.60.120.200-FF-000629', NULL, 'Uncharacterized protein', 129, NULL, NULL, 37859),
(37860, '2.30.29.30-FF-000537', NULL, 'Inorganic pyrophosphatase, putative', 117, NULL, NULL, 37860),
(37861, '3.40.1120.10-FF-000008', NULL, NULL, 111, NULL, NULL, 37861),
(37862, '3.40.850.10-FF-000199', NULL, 'Kinesin-like protein', 364, NULL, NULL, 37862),
(37863, '3.90.190.10-FF-000356', NULL, 'Tyrosine-protein phosphatase 3', 289, NULL, NULL, 37863);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(37864, '1.25.40.10-FF-001433', NULL, 'Os10g0501200 protein', 168, NULL, NULL, 37864),
(37865, '3.20.20.330-FF-000031', NULL, 'Uncharacterized protein', 267, NULL, NULL, 37865),
(37866, '3.30.70.330-FF-002944', NULL, NULL, 111, NULL, NULL, 37866),
(37867, '1.25.40.660-FF-000015', NULL, 'Vacuolar protein sorting-associated protein 35', 379, NULL, NULL, 37867),
(37868, '1.10.238.10-FF-000015', NULL, 'Calcium-dependent protein kinase 1', 176, NULL, NULL, 37868),
(37869, '1.10.3500.10-FF-000030', NULL, 'Glycine rich protein', 210, NULL, NULL, 37869),
(37870, '3.20.20.80-FF-000519', NULL, 'Predicted protein', 335, NULL, NULL, 37870),
(37871, '3.60.40.10-FF-000077', NULL, 'Protein phosphatase 1A', 225, NULL, NULL, 37871),
(37872, '1.10.10.10-FF-001841', NULL, 'Histone acetyltransferase', 86, NULL, NULL, 37872),
(37873, '3.30.420.10-FF-000438', NULL, NULL, 110, NULL, NULL, 37873),
(37874, '3.10.250.10-FF-000036', NULL, 'CD163 molecule like 1', 109, NULL, NULL, 37874),
(37875, '3.30.160.60-FF-001585', NULL, 'Zinc finger protein 329', 26, NULL, NULL, 37875),
(37876, '1.20.1560.10-FF-000648', NULL, 'Uncharacterized protein', 134, NULL, NULL, 37876),
(37877, '2.130.10.10-FF-005391', NULL, 'WD repeat-containing protein 27', 153, NULL, NULL, 37877),
(37878, '3.40.30.10-FF-000386', NULL, '54S ribosomal protein L51', 128, NULL, NULL, 37878),
(37879, '3.40.50.150-FF-000068', NULL, 'Ribosomal RNA-processing protein 8', 162, NULL, NULL, 37879),
(37880, '2.60.260.20-FF-000111', NULL, 'Cobalamin ABC transporter permease', 92, NULL, NULL, 37880),
(37881, '1.10.238.20-FF-000018', NULL, 'General odorant-binding protein 1', 142, NULL, NULL, 37881),
(37882, '1.10.246.140-FF-000002', NULL, 'Enhancer of yellow 2 transcription factor', 92, NULL, NULL, 37882),
(37883, '1.10.287.2900-FF-000013', NULL, 'Coiled-coil-helix-coiled-coil-helix domain-containing 4b', 54, NULL, NULL, 37883),
(37884, '1.20.1250.20-FF-001769', NULL, 'Uncharacterized protein', 187, NULL, NULL, 37884),
(37885, '3.30.70.270-FF-000285', NULL, NULL, 93, NULL, NULL, 37885),
(37886, '3.30.160.60-FF-005475', NULL, NULL, 28, NULL, NULL, 37886),
(37887, '1.50.40.10-FF-000060', NULL, 'Mitochondrial carnitine carrier', 193, NULL, NULL, 37887),
(37888, '1.25.10.10-FF-001605', NULL, 'Uncharacterized protein', 602, NULL, NULL, 37888),
(37889, '3.40.1550.10-FF-000001', NULL, 'Flagellar motor switch protein FliM', 187, NULL, NULL, 37889),
(37890, '3.30.160.60-FF-000096', NULL, 'Zinc finger and BTB domain-containing protein 18 isoform 1', 26, NULL, NULL, 37890),
(37891, '3.30.1680.30-FF-000002', NULL, 'Variant surface glycoprotein (VSG, atypical), putative', 42, NULL, NULL, 37891),
(37892, '3.60.21.10-FF-000246', NULL, 'Serine/threonine-protein phosphatase', 195, NULL, NULL, 37892),
(37893, '1.25.10.10-FF-001791', NULL, 'AP-3 complex subunit beta', 587, NULL, NULL, 37893),
(37894, '1.10.287.950-FF-000028', NULL, 'Methyl-accepting chemotaxis protein', 328, NULL, NULL, 37894),
(37895, '3.40.1550.20-FF-000004', NULL, 'Transcriptional regulator MraZ', 138, NULL, NULL, 37895),
(37896, '3.30.505.10-FF-000102', NULL, 'Tyrosine-protein kinase', 108, NULL, NULL, 37896),
(37897, '1.20.58.340-FF-000013', NULL, 'Magnesium transporter MRS2-11, chloroplastic', 183, NULL, NULL, 37897),
(37898, '3.20.20.120-FF-000024', NULL, '2-oxoglutarate decarboxylase/ hydro-lyase/ magnesium ion binding protein', 240, NULL, NULL, 37898),
(37899, '1.10.8.60-FF-000247', NULL, 'Flagellar regulatory protein C', 79, NULL, NULL, 37899),
(37900, '3.40.50.720-FF-001161', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', 168, NULL, NULL, 37900),
(37901, '2.60.40.10-FF-005172', NULL, NULL, 94, NULL, NULL, 37901),
(37902, '1.10.472.80-FF-000260', NULL, NULL, 141, NULL, NULL, 37902),
(37903, '3.40.50.1820-FF-000495', NULL, 'Carboxylic ester hydrolase', 296, NULL, NULL, 37903),
(37904, '3.40.33.10-FF-000044', NULL, 'SCP-Like extracellular protein', 192, NULL, NULL, 37904),
(37905, '3.30.160.60-FF-001675', NULL, 'Zinc finger protein 329', 32, NULL, NULL, 37905),
(37906, '1.10.1070.11-FF-000002', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', 201, NULL, NULL, 37906);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(37907, '3.10.450.700-FF-000004', NULL, 'Transcriptional activator protein Pur-alpha', 76, NULL, NULL, 37907),
(37908, '1.10.472.80-FF-000018', NULL, 'TBC1 domain family member 2B', 146, NULL, NULL, 37908),
(37909, '4.10.280.10-FF-000170', NULL, 'Putative myc-like protein MYCLP1', 80, NULL, NULL, 37909),
(37910, '1.20.58.1020-FF-000002', NULL, 'DNA replication complex GINS protein', 124, NULL, NULL, 37910),
(37911, '1.25.10.10-FF-000155', NULL, 'Protein MOR1', 252, NULL, NULL, 37911),
(37912, '3.90.190.10-FF-000412', NULL, 'Uncharacterized protein', 106, NULL, NULL, 37912),
(37913, '2.130.10.10-FF-005239', NULL, 'Chromatin modification-related protein rik1', 315, NULL, NULL, 37913),
(37914, '1.20.1160.20-FF-000020', NULL, 'Regulator of telomere elongation helicase 1 homolog', 99, NULL, NULL, 37914),
(37915, '3.30.710.10-FF-000449', NULL, 'Predicted protein', 149, NULL, NULL, 37915),
(37916, '3.30.200.20-FF-001914', NULL, 'Dual specificity protein kinase zak2', 87, NULL, NULL, 37916),
(37917, '1.25.70.10-FF-000041', NULL, 'Transcription termination factor family protein', 163, NULL, NULL, 37917),
(37918, '3.40.50.2300-FF-000914', NULL, NULL, 166, NULL, NULL, 37918),
(37919, '3.80.10.10-FF-002266', NULL, 'Promastigote surface antigen protein PSA', 263, NULL, NULL, 37919),
(37920, '2.130.10.30-FF-000164', NULL, NULL, 111, NULL, NULL, 37920),
(37921, '3.40.50.150-FF-001850', NULL, NULL, 31, NULL, NULL, 37921),
(37922, '1.10.287.1490-FF-000034', NULL, 'Synaptonemal complex protein ZIP1', 170, NULL, NULL, 37922),
(37923, '3.40.1410.10-FF-000019', NULL, 'Transcriptional regulator, GntR family', 154, NULL, NULL, 37923),
(37924, '3.60.40.10-FF-000133', NULL, 'Protein serine/threonine phosphatase 2C', 270, NULL, NULL, 37924),
(37925, '1.10.10.10-FF-000205', NULL, 'IclR family transcriptional regulator', 75, NULL, NULL, 37925),
(37926, '3.20.20.140-FF-000272', NULL, 'Adenosine deaminase, putative', 155, NULL, NULL, 37926),
(37927, '1.25.40.850-FF-000005', NULL, 'Vacuolar protein sorting 33B', 89, NULL, NULL, 37927),
(37928, '3.40.50.720-FF-001122', NULL, 'Adenylyltransferase and sulfurtransferase uba4', 287, NULL, NULL, 37928),
(37929, '1.50.40.10-FF-000003', NULL, 'Putative calcium-binding mitochondrial carrier protein scamc-2', 286, NULL, NULL, 37929),
(37930, '2.60.40.10-FF-003991', NULL, NULL, 100, NULL, NULL, 37930),
(37931, '3.30.70.240-FF-000034', NULL, 'Predicted protein', 121, NULL, NULL, 37931),
(37932, '1.25.40.1030-FF-000005', NULL, 'Protein transport protein sec16', 425, NULL, NULL, 37932),
(37933, '1.20.1560.10-FF-000941', NULL, 'Uncharacterized protein', 323, NULL, NULL, 37933),
(37934, '3.40.50.720-FF-000846', NULL, 'Quinone oxidoreductase', 131, NULL, NULL, 37934),
(37935, '1.10.150.50-FF-000037', NULL, 'sphingomyelin synthase-related protein 1 isoform X1', 73, NULL, NULL, 37935),
(37936, '3.30.2230.10-FF-000019', NULL, 'Ubiquitinyl hydrolase 1', 115, NULL, NULL, 37936),
(37937, '3.40.33.10-FF-000191', NULL, 'Uncharacterized protein', 116, NULL, NULL, 37937),
(37938, '3.20.20.60-FF-000042', NULL, 'Pyruvate kinase', 249, NULL, NULL, 37938),
(37939, '3.40.50.2300-FF-001263', NULL, NULL, 130, NULL, NULL, 37939),
(37940, '3.30.40.100-FF-000003', NULL, 'MORC family CW-type zinc finger 3', 58, NULL, NULL, 37940),
(37941, '4.10.95.10-FF-000001', NULL, 'Cytochrome c oxidase subunit 6A, mitochondrial', 87, NULL, NULL, 37941),
(37942, '1.25.10.10-FF-001644', NULL, '26S proteasome non-ATPase regulatory subunit 1', 440, NULL, NULL, 37942),
(37943, '1.25.40.1040-FF-000008', NULL, 'Cleavage stimulation factor subunit 3', 534, NULL, NULL, 37943),
(37944, '1.25.40.840-FF-000002', NULL, 'Ccr4-Not transcription complex subunit (NOT1)', 171, NULL, NULL, 37944),
(37945, '2.130.10.10-FF-001552', NULL, 'Uncharacterized protein', 106, NULL, NULL, 37945),
(37946, '3.40.50.2300-FF-001224', NULL, NULL, 85, NULL, NULL, 37946),
(37947, '2.30.30.140-FF-000258', NULL, 'SAGA-associated factor 29', 61, NULL, NULL, 37947),
(37948, '3.40.50.10140-FF-000039', NULL, 'Putative serine/threonine-protein kinase pats1', 139, NULL, NULL, 37948);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(37949, '1.10.287.70-FF-000736', NULL, 'Uncharacterized protein', 112, NULL, NULL, 37949),
(37950, '2.30.34.10-FF-000004', NULL, 'GP63, leishmanolysin', 105, NULL, NULL, 37950),
(37951, '1.10.472.80-FF-000170', NULL, NULL, 90, NULL, NULL, 37951),
(37952, '3.50.50.60-FF-001323', NULL, 'Predicted protein', 151, NULL, NULL, 37952),
(37953, '2.60.40.10-FF-003373', NULL, 'Lymphocyte activating 3', 88, NULL, NULL, 37953),
(37954, '3.50.50.60-FF-001138', NULL, 'Uncharacterized protein', 102, NULL, NULL, 37954),
(37955, '3.40.50.10140-FF-000096', NULL, 'Uncharacterized protein', 171, NULL, NULL, 37955),
(37956, '3.40.50.10130-FF-000036', NULL, 'Uncharacterized protein', 192, NULL, NULL, 37956),
(37957, '2.60.120.620-FF-000058', NULL, 'Predicted protein', 174, NULL, NULL, 37957),
(37958, '1.10.287.70-FF-000085', NULL, 'Transient receptor potential cation channel subfamily V member 3', 128, NULL, NULL, 37958),
(37959, '2.130.10.10-FF-003682', NULL, 'Uncharacterized protein', 150, NULL, NULL, 37959),
(37960, '3.50.50.60-FF-001380', NULL, 'Uncharacterized protein', 141, NULL, NULL, 37960),
(37961, '3.30.160.60-FF-005531', NULL, NULL, 71, NULL, NULL, 37961),
(37962, '3.40.309.10-FF-000127', NULL, 'Uncharacterized protein', 145, NULL, NULL, 37962),
(37963, '1.10.2000.10-FF-000042', NULL, NULL, 129, NULL, NULL, 37963),
(37964, '3.90.340.10-FF-000008', NULL, 'Nitric oxide synthase, inducible', 81, NULL, NULL, 37964),
(37965, '1.25.40.10-FF-002866', NULL, 'Sll0837 protein', 77, NULL, NULL, 37965),
(37966, '1.25.40.10-FF-005272', NULL, 'Uncharacterized protein', 150, NULL, NULL, 37966),
(37967, '2.60.40.60-FF-000234', NULL, 'Si:dkey-22o22.2', 107, NULL, NULL, 37967),
(37968, '1.10.10.880-FF-000001', NULL, 'Anti-sigma-E factor RseA', 66, NULL, NULL, 37968),
(37969, '3.30.70.260-FF-000192', NULL, 'Predicted protein', 88, NULL, NULL, 37969),
(37970, '1.25.40.70-FF-000006', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit gamma isoform', 200, NULL, NULL, 37970),
(37971, '2.40.160.110-FF-000002', NULL, 'lysosome-associated membrane glycoprotein 5 isoform X1', 192, NULL, NULL, 37971),
(37972, '2.40.160.120-FF-000005', NULL, 'Oxysterol-binding protein', 171, NULL, NULL, 37972),
(37973, '3.40.50.150-FF-000124', NULL, 'HEN methyltransferase 1', 248, NULL, NULL, 37973),
(37974, '3.40.50.1220-FF-000079', NULL, 'Probable electron transfer flavoprotein alpha subunit', 133, NULL, NULL, 37974),
(37975, '1.20.1070.10-FF-001999', NULL, 'Si:ch211-132e22.4', 144, NULL, NULL, 37975),
(37976, '1.20.5.110-FF-000091', NULL, 'Syntaxin, Qa-SNARE family', 105, NULL, NULL, 37976),
(37977, '1.25.40.60-FF-000003', NULL, 'Vacuolar protein sorting-associated protein 45', 123, NULL, NULL, 37977),
(37978, '3.30.1360.180-FF-000001', NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase family member 6', 111, NULL, NULL, 37978),
(37979, '2.130.10.10-FF-000006', NULL, 'Plexin A2', 471, NULL, NULL, 37979),
(37980, '3.30.70.3400-FF-000005', NULL, 'Protein translocase subunit SecD', 88, NULL, NULL, 37980),
(37981, '1.25.40.80-FF-000009', NULL, 'Deoxyribodipyrimidine photo-lyase, putative', 169, NULL, NULL, 37981),
(37982, '1.20.5.2950-FF-000007', NULL, 'Vacuolar ATP synthase subunit G', 105, NULL, NULL, 37982),
(37983, '3.30.160.60-FF-005565', NULL, NULL, 58, NULL, NULL, 37983),
(37984, '3.40.50.11740-FF-000002', NULL, 'Hydrogenase maturation factor', 120, NULL, NULL, 37984),
(37985, '3.40.50.720-FF-001009', NULL, 'HPGD isoform 12', 99, NULL, NULL, 37985),
(37986, '1.25.40.10-FF-005182', NULL, 'Uncharacterized protein', 28, NULL, NULL, 37986),
(37987, '3.30.200.20-FF-000369', NULL, 'G2-specific protein kinase NimA', 45, NULL, NULL, 37987),
(37988, '3.30.160.60-FF-001821', NULL, 'GH16297', 25, NULL, NULL, 37988),
(37989, '1.10.8.60-FF-000337', NULL, 'ORC1-type DNA replication protein 2', 83, NULL, NULL, 37989),
(37990, '3.90.190.10-FF-000502', NULL, 'Predicted protein', 146, NULL, NULL, 37990),
(37991, '3.50.50.60-FF-000918', NULL, 'Oxidoreductase, putative', 326, NULL, NULL, 37991),
(37992, '3.80.20.20-FF-000010', NULL, 'Receptor protein-tyrosine kinase', 185, NULL, NULL, 37992);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(37993, '3.30.1490.120-FF-000012', NULL, 'DNA-directed RNA polymerase II subunit, putative', 79, NULL, NULL, 37993),
(37994, '3.40.50.150-FF-000304', NULL, 'Methyltransferase/nucleic acid binding', 239, NULL, NULL, 37994),
(37995, '2.40.50.140-FF-001266', NULL, NULL, 131, NULL, NULL, 37995),
(37996, '3.30.70.1230-FF-000040', NULL, 'Ca(2+)/calmodulin-responsive adenylate cyclase', 201, NULL, NULL, 37996),
(37997, '3.40.50.12660-FF-000003', NULL, 'Metacaspase MCA2', 335, NULL, NULL, 37997),
(37998, '4.10.280.10-FF-000057', NULL, 'transcription factor-like 5 protein-like', 65, NULL, NULL, 37998),
(37999, '1.10.640.10-FF-000068', NULL, 'Uncharacterized protein', 171, NULL, NULL, 37999),
(38000, '3.40.50.2300-FF-000768', NULL, 'GLutamate Receptor family (AMPA)', 192, NULL, NULL, 38000),
(38001, '1.25.40.10-FF-001848', NULL, 'Chromosome 7, whole genome shotgun sequence', 235, NULL, NULL, 38001),
(38002, '3.30.1330.80-FF-000002', NULL, 'AT-hook motif nuclear-localized protein', 131, NULL, NULL, 38002),
(38003, '2.10.25.10-FF-000366', NULL, 'EGF-containing fibulin-like extracellular matrix protein 2', 67, NULL, NULL, 38003),
(38004, '3.40.50.1450-FF-000002', NULL, 'Hydrogenase 1 maturation protease', 160, NULL, NULL, 38004),
(38005, '3.30.160.60-FF-002041', NULL, 'Zinc finger protein 526', 31, NULL, NULL, 38005),
(38006, '3.30.200.20-FF-000897', NULL, 'Uncharacterized protein, isoform E', 94, NULL, NULL, 38006),
(38007, '2.120.10.80-FF-000359', NULL, 'Predicted protein', 270, NULL, NULL, 38007),
(38008, '3.40.33.10-FF-000005', NULL, 'Cysteine-rich secretory protein 2', 177, NULL, NULL, 38008),
(38009, '2.60.40.10-FF-003934', NULL, NULL, 106, NULL, NULL, 38009),
(38010, '2.30.29.30-FF-000740', NULL, 'Uncharacterized protein', 67, NULL, NULL, 38010),
(38011, '3.90.550.10-FF-000075', NULL, 'Probable UDP-N-acetylglucosamine pyrophosphorylase', 477, NULL, NULL, 38011),
(38012, '1.20.120.1380-FF-000011', NULL, 'Flagellar polar localization control system flagellar assembly determinant GTPase FlhF', 28, NULL, NULL, 38012),
(38013, '1.25.40.860-FF-000008', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 130, NULL, NULL, 38013),
(38014, '2.60.40.2100-FF-000002', NULL, 'Major fimbrium anchoring subunit FimB', 159, NULL, NULL, 38014),
(38015, '2.30.30.140-FF-000348', NULL, 'Chromatin modification-related protein EAF3', 104, NULL, NULL, 38015),
(38016, '3.30.160.60-FF-005418', NULL, NULL, 100, NULL, NULL, 38016),
(38017, '3.10.20.870-FF-000009', NULL, 'phospholipase A-2-activating protein', 78, NULL, NULL, 38017),
(38018, '3.10.129.10-FF-000277', NULL, 'Acyl-CoA thioesterase 11b', 73, NULL, NULL, 38018),
(38019, '2.130.10.10-FF-005913', NULL, 'Uncharacterized protein', 278, NULL, NULL, 38019),
(38020, '3.40.50.720-FF-000138', NULL, 'Short-chain dehydrogenase/reductase family 42E member 1', 353, NULL, NULL, 38020),
(38021, '2.60.20.10-FF-000027', NULL, NULL, 79, NULL, NULL, 38021),
(38022, '3.40.50.300-FF-005419', NULL, 'RNA helicase, putative', 200, NULL, NULL, 38022),
(38023, '3.40.50.300-FF-004025', NULL, 'RAB30 isoform 9', 31, NULL, NULL, 38023),
(38024, '3.40.1810.10-FF-000044', NULL, 'AGAMOUS-like 101', 90, NULL, NULL, 38024),
(38025, '3.30.1330.90-FF-000005', NULL, 'D-3-phosphoglycerate dehydrogenase', 134, NULL, NULL, 38025),
(38026, '1.10.630.10-FF-000242', NULL, 'Uncharacterized protein', 94, NULL, NULL, 38026),
(38027, '1.25.10.10-FF-002010', NULL, 'ARM repeat superfamily protein', 205, NULL, NULL, 38027),
(38028, '3.50.50.60-FF-000975', NULL, 'Uncharacterized protein', 139, NULL, NULL, 38028),
(38029, '1.20.120.1110-FF-000014', NULL, 'TAF4B RNA polymerase II, TATA box-binding protein (TBP)-associated factor', 61, NULL, NULL, 38029),
(38030, '3.60.40.10-FF-000223', NULL, 'Protein phosphatase 2C, putative', 300, NULL, NULL, 38030),
(38031, '3.40.50.300-FF-000282', NULL, 'Strawberry notch homolog 1 (Drosophila)', 206, NULL, NULL, 38031),
(38032, '3.15.20.10-FF-000005', NULL, 'BPI fold containing family C', 111, NULL, NULL, 38032),
(38033, '1.10.10.750-FF-000013', NULL, 'Similar to TBC domain protein', 62, NULL, NULL, 38033);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(38034, '1.20.1560.10-FF-000851', NULL, 'Uncharacterized protein', 286, NULL, NULL, 38034),
(38035, '1.10.555.10-FF-000027', NULL, 'RalA-binding protein 1', 198, NULL, NULL, 38035),
(38036, '2.10.70.10-FF-000055', NULL, 'Complement decay-accelerating factor, GPI-anchored', 62, NULL, NULL, 38036),
(38037, '3.90.76.10-FF-000023', NULL, 'Oligopeptide ABC transporter substrate-binding protein', 132, NULL, NULL, 38037),
(38038, '1.25.10.10-FF-002100', NULL, 'Uncharacterized protein', 391, NULL, NULL, 38038),
(38039, '1.20.1280.50-FF-000212', NULL, 'SCF E3 ubiquitin ligase complex F-box protein grrA', 39, NULL, NULL, 38039),
(38040, '2.130.10.10-FF-001642', NULL, 'WD domain, G-beta repeat-containing protein', 122, NULL, NULL, 38040),
(38041, '2.160.20.20-FF-000003', NULL, 'Possible enzyme', 235, NULL, NULL, 38041),
(38042, '3.30.160.60-FF-000129', NULL, 'Zinc finger protein 503', 31, NULL, NULL, 38042),
(38043, '3.30.160.60-FF-006402', NULL, NULL, 21, NULL, NULL, 38043),
(38044, '3.30.200.20-FF-000987', NULL, 'Os03g0335900 protein', 80, NULL, NULL, 38044),
(38045, '3.40.50.11500-FF-000037', NULL, NULL, 52, NULL, NULL, 38045),
(38046, '3.40.50.1820-FF-001799', NULL, 'Uncharacterized protein', 146, NULL, NULL, 38046),
(38047, '1.25.40.20-FF-001475', NULL, 'Ankyrin repeat-containing protein C6C3.08', 100, NULL, NULL, 38047),
(38048, '3.50.50.60-FF-000267', NULL, 'YOR356W-like protein', 266, NULL, NULL, 38048),
(38049, '3.40.1110.10-FF-000036', NULL, 'Copper-exporting P-type ATPase', 120, NULL, NULL, 38049),
(38050, '1.25.40.10-FF-001472', NULL, 'Paf1 complex protein', 177, NULL, NULL, 38050),
(38051, '1.10.555.10-FF-000084', NULL, 'WW domain-containing protein tag-325', 213, NULL, NULL, 38051),
(38052, '2.40.50.1020-FF-000008', NULL, 'LytR family transcriptional regulator', 110, NULL, NULL, 38052),
(38053, '1.10.630.10-FF-000332', NULL, 'Cytochrome P450, putative', 218, NULL, NULL, 38053),
(38054, '2.60.120.330-FF-000095', NULL, '1-aminocyclopropane-1-carboxylate oxidase 1, putative', 94, NULL, NULL, 38054),
(38055, '3.40.50.410-FF-000017', NULL, 'Anthrax toxin receptor 1', 182, NULL, NULL, 38055),
(38056, '2.60.120.1000-FF-000026', NULL, 'Uncharacterized protein', 214, NULL, NULL, 38056),
(38057, '3.40.50.300-FF-001732', NULL, 'tRNA threonylcarbamoyladenosine biosynthesis protein TsaE', 147, NULL, NULL, 38057),
(38058, '3.30.830.10-FF-000104', NULL, 'Metalloenzyme, LuxS/M16 peptidase-like protein', 216, NULL, NULL, 38058),
(38059, '1.25.40.10-FF-001287', NULL, 'Pre-mRNA-processing factor 6', 111, NULL, NULL, 38059),
(38060, '1.20.1270.10-FF-000076', NULL, 'Uncharacterized protein', 68, NULL, NULL, 38060),
(38061, '3.40.50.720-FF-000756', NULL, 'Fatty acyl-CoA reductase', 353, NULL, NULL, 38061),
(38062, '3.10.580.10-FF-000224', NULL, 'Chloride channel protein', 91, NULL, NULL, 38062),
(38063, '3.40.250.10-FF-000086', NULL, 'Thiosulfate sulfurtransferase', 157, NULL, NULL, 38063),
(38064, '3.40.50.150-FF-000214', NULL, 'Probable tRNA methyltransferase 9B', 97, NULL, NULL, 38064),
(38065, '3.40.50.2300-FF-000858', NULL, NULL, 67, NULL, NULL, 38065),
(38066, '3.30.160.60-FF-002131', NULL, 'Zinc finger protein 112', 24, NULL, NULL, 38066),
(38067, '1.20.1270.10-FF-000019', NULL, 'Heat shock 70 kDa protein 1-like', 101, NULL, NULL, 38067),
(38068, '3.30.70.330-FF-002798', NULL, NULL, 149, NULL, NULL, 38068),
(38069, '1.20.5.990-FF-000011', NULL, 'AGAP005933-PA', 97, NULL, NULL, 38069),
(38070, '3.30.70.330-FF-003113', NULL, NULL, 71, NULL, NULL, 38070),
(38071, '1.20.1070.10-FF-000925', NULL, 'Uncharacterized protein', 304, NULL, NULL, 38071),
(38072, '2.10.25.10-FF-000804', NULL, 'Fibrillin-1', 39, NULL, NULL, 38072),
(38073, '2.40.170.20-FF-000002', NULL, 'Colicin I TonB-dependent receptor', 546, NULL, NULL, 38073),
(38074, '4.10.240.10-FF-000077', NULL, 'Uncharacterized protein', 70, NULL, NULL, 38074),
(38075, '1.20.1560.10-FF-000946', NULL, 'Uncharacterized protein', 12, NULL, NULL, 38075),
(38076, '3.40.50.300-FF-007364', NULL, 'Uncharacterized protein', 48, NULL, NULL, 38076),
(38077, '3.90.1200.10-FF-000082', NULL, 'Uncharacterized protein DR_0394', 184, NULL, NULL, 38077);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(38078, '2.60.20.10-FF-000022', NULL, NULL, 90, NULL, NULL, 38078),
(38079, '2.130.10.10-FF-003761', NULL, 'Uncharacterized protein', 324, NULL, NULL, 38079),
(38080, '3.20.200.10-FF-000008', NULL, 'Elongation factor 2 kinase, putative', 108, NULL, NULL, 38080),
(38081, '1.25.40.10-FF-002017', NULL, 'Pentatricopeptide repeat-containing protein', 92, NULL, NULL, 38081),
(38082, '1.10.540.10-FF-000010', NULL, 'Medium-chain specific acyl-CoA dehydrogenase, mitochondrial', 127, NULL, NULL, 38082),
(38083, '3.10.450.240-FF-000023', NULL, 'Uncharacterized protein', 70, NULL, NULL, 38083),
(38084, '3.40.850.10-FF-000497', NULL, 'Uncharacterized protein', 49, NULL, NULL, 38084),
(38085, '1.10.287.70-FF-000652', NULL, 'Potassium channel, putative', 159, NULL, NULL, 38085),
(38086, '3.30.200.20-FF-000689', NULL, 'SCY1 protein kinase', 89, NULL, NULL, 38086),
(38087, '3.60.110.10-FF-000094', NULL, NULL, 53, NULL, NULL, 38087),
(38088, '1.10.10.10-FF-001751', NULL, 'Spo11 protein', 141, NULL, NULL, 38088),
(38089, '3.30.70.260-FF-000164', NULL, 'Amino acid-binding ACT domain regulatory protein', 83, NULL, NULL, 38089),
(38090, '1.10.3080.10-FF-000024', NULL, 'Voltage-gated chloride channel, putative', 497, NULL, NULL, 38090),
(38091, '1.10.10.10-FF-001846', NULL, 'Uncharacterized protein', 82, NULL, NULL, 38091),
(38092, '1.10.437.10-FF-000006', NULL, 'Apoptosis regulator Bcl-2', 198, NULL, NULL, 38092),
(38093, '1.10.1370.30-FF-000041', NULL, 'Angiotensin-converting enzyme', 210, NULL, NULL, 38093),
(38094, '3.30.450.20-FF-000409', NULL, 'Sensor histidine kinase, PAS, PAS and PAS domain-containing', 119, NULL, NULL, 38094),
(38095, '3.40.1110.10-FF-000064', NULL, 'Phospholipid-transporting ATPase', 149, NULL, NULL, 38095),
(38096, '3.30.9.10-FF-000146', NULL, 'FAD dependent oxidoreductase', 95, NULL, NULL, 38096),
(38097, '1.25.40.10-FF-003119', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 122, NULL, NULL, 38097),
(38098, '3.40.309.10-FF-000099', NULL, 'Aldehyde dehydrogenase', 196, NULL, NULL, 38098),
(38099, '3.30.980.10-FF-000020', NULL, 'Uridine cytidine kinase I, putative', 144, NULL, NULL, 38099),
(38100, '1.10.3080.10-FF-000075', NULL, 'Uncharacterized protein', 45, NULL, NULL, 38100),
(38101, '3.30.230.10-FF-000188', NULL, 'DNA topoisomerase (ATP-hydrolyzing)', 161, NULL, NULL, 38101),
(38102, '3.30.500.10-FF-000001', NULL, 'H-2 class I histocompatibility antigen, alpha chain', 182, NULL, NULL, 38102),
(38103, '3.10.400.20-FF-000035', NULL, 'Ligatin, putative', 174, NULL, NULL, 38103),
(38104, '3.40.50.1820-FF-000282', NULL, 'Putative beta-ketoadipate enol-lactone hydrolase', 269, NULL, NULL, 38104),
(38105, '3.30.1490.180-FF-000007', NULL, 'DNA-directed RNA polymerase subunit', 79, NULL, NULL, 38105),
(38106, '3.30.160.20-FF-000129', NULL, 'Uncharacterized protein', 90, NULL, NULL, 38106),
(38107, '1.20.58.60-FF-000178', NULL, 'Envoplakin a', 180, NULL, NULL, 38107),
(38108, '3.90.1150.10-FF-000454', NULL, 'Aminotransferase', 138, NULL, NULL, 38108),
(38109, '2.40.50.140-FF-001261', NULL, NULL, 45, NULL, NULL, 38109),
(38110, '1.25.40.20-FF-000901', NULL, 'Uncharacterized protein', 161, NULL, NULL, 38110),
(38111, '1.20.1280.50-FF-000122', NULL, 'Uncharacterized protein, isoform B', 52, NULL, NULL, 38111),
(38112, '1.20.1070.10-FF-000297', NULL, 'G-protein coupled receptor Mth', 289, NULL, NULL, 38112),
(38113, '3.40.20.10-FF-000026', NULL, 'Glia maturation factor', 139, NULL, NULL, 38113),
(38114, '3.30.1370.100-FF-000030', NULL, 'DNA mismatch repair protein MutL', 77, NULL, NULL, 38114),
(38115, '2.130.10.10-FF-001670', NULL, 'WD domain containing protein', 88, NULL, NULL, 38115),
(38116, '3.40.50.2300-FF-000448', NULL, 'Two-component response regulator ORR29', 131, NULL, NULL, 38116),
(38117, '3.40.50.1820-FF-000961', NULL, 'AB-hydrolase YheT, putative', 281, NULL, NULL, 38117),
(38118, '3.30.40.10-FF-000376', NULL, 'Putative E3 ubiquitin-protein ligase RHB1A', 69, NULL, NULL, 38118),
(38119, '3.80.10.10-FF-002154', NULL, 'Uncharacterized protein', 272, NULL, NULL, 38119);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(38120, '3.30.70.330-FF-000937', NULL, 'NOP4p Nucleolar protein', 157, NULL, NULL, 38120),
(38121, '2.60.200.40-FF-000029', NULL, 'ceramide kinase', 263, NULL, NULL, 38121),
(38122, '1.10.510.10-FF-003785', NULL, NULL, 132, NULL, NULL, 38122),
(38123, '3.60.130.10-FF-000056', NULL, 'Predicted protein', 159, NULL, NULL, 38123),
(38124, '1.50.40.10-FF-000273', NULL, 'Mitochondrial carrier protein', 287, NULL, NULL, 38124),
(38125, '2.130.10.10-FF-004896', NULL, 'Predicted protein', 114, NULL, NULL, 38125),
(38126, '1.10.10.10-FF-000323', NULL, 'HTH-type transcriptional regulator rpiR', 74, NULL, NULL, 38126),
(38127, '2.130.10.10-FF-003710', NULL, 'Uncharacterized protein', 149, NULL, NULL, 38127),
(38128, '1.10.400.20-FF-000003', NULL, 'Tagatose-6-phosphate kinase', 135, NULL, NULL, 38128),
(38129, '1.20.1070.10-FF-000976', NULL, 'Uncharacterized protein', 350, NULL, NULL, 38129),
(38130, '3.30.160.60-FF-003906', NULL, NULL, 29, NULL, NULL, 38130),
(38131, '3.80.10.10-FF-001052', NULL, 'Putative leucine-rich repeat protein', 118, NULL, NULL, 38131),
(38132, '1.20.1260.30-FF-000002', NULL, 'Possible type I restriction/modification system DNA methylase HsdM (M protein) (DNA methyltransferase)', 159, NULL, NULL, 38132),
(38133, '1.20.120.1910-FF-000041', NULL, 'Cysteine--tRNA ligase', 199, NULL, NULL, 38133),
(38134, '3.30.160.60-FF-006020', NULL, NULL, 31, NULL, NULL, 38134),
(38135, '1.20.1250.10-FF-000018', NULL, 'leukemia inhibitory factor', 180, NULL, NULL, 38135),
(38136, '3.90.740.10-FF-000022', NULL, 'Isoleucine--tRNA ligase', 170, NULL, NULL, 38136),
(38137, '3.40.50.300-FF-007459', NULL, 'Predicted protein', 243, NULL, NULL, 38137),
(38138, '3.30.40.10-FF-001039', NULL, 'Lysine-specific demethylase 5B', 60, NULL, NULL, 38138),
(38139, '2.60.40.10-FF-005823', NULL, NULL, 44, NULL, NULL, 38139),
(38140, '2.30.29.30-FF-001021', NULL, 'Arf guanine nucleotide exchange factor sec74', 134, NULL, NULL, 38140),
(38141, '3.90.190.10-FF-000176', NULL, 'Dual specificity protein phosphatase, putative', 162, NULL, NULL, 38141),
(38142, '3.30.70.2330-FF-000004', NULL, 'Uncharacterized protein', 78, NULL, NULL, 38142),
(38143, '2.60.120.10-FF-000244', NULL, 'Uncharacterized protein', 155, NULL, NULL, 38143),
(38144, '3.40.50.300-FF-000490', NULL, 'Katanin p60 ATPase-containing subunit A-like 2', 188, NULL, NULL, 38144),
(38145, '3.30.2140.20-FF-000021', NULL, 'Uncharacterized protein', 195, NULL, NULL, 38145),
(38146, '3.30.160.60-FF-003586', NULL, NULL, 23, NULL, NULL, 38146),
(38147, '1.20.1250.20-FF-002264', NULL, 'Uncharacterized protein', 101, NULL, NULL, 38147),
(38148, '2.40.50.140-FF-001210', NULL, NULL, 83, NULL, NULL, 38148),
(38149, '3.40.50.2300-FF-000774', NULL, 'Protein tyrosine phosphatase putative', 158, NULL, NULL, 38149),
(38150, '2.40.100.10-FF-000051', NULL, 'Peptidyl-prolyl cis-trans isomerase', 181, NULL, NULL, 38150),
(38151, '1.20.1070.10-FF-000246', NULL, 'Atypical chemokine receptor 2', 301, NULL, NULL, 38151),
(38152, '1.50.10.10-FF-000092', NULL, 'N-acyl-D-glucosamine 2-epimerase', 383, NULL, NULL, 38152),
(38153, '2.60.120.1000-FF-000032', NULL, 'Uncharacterized protein', 34, NULL, NULL, 38153),
(38154, '1.25.10.20-FF-000006', NULL, 'Putative Vitellogenin-1', 320, NULL, NULL, 38154),
(38155, '1.20.1280.50-FF-000217', NULL, 'Uncharacterized protein', 79, NULL, NULL, 38155),
(38156, '3.40.50.620-FF-000428', NULL, 'Deoxyribodipyrimidine photolyase', 148, NULL, NULL, 38156),
(38157, '3.40.50.1000-FF-000311', NULL, 'Trehalose 6-phosphate phosphatase', 82, NULL, NULL, 38157),
(38158, '3.40.50.12780-FF-000185', NULL, 'Uncharacterized protein', 91, NULL, NULL, 38158),
(38159, '3.30.160.60-FF-001462', NULL, 'Zinc finger protein 502, isoform CRA_a', 30, NULL, NULL, 38159),
(38160, '1.10.246.90-FF-000007', NULL, 'Pre mRNA splicing protein', 123, NULL, NULL, 38160),
(38161, '3.90.190.10-FF-000390', NULL, 'Kinase, Uni1', 180, NULL, NULL, 38161),
(38162, '1.25.10.10-FF-000003', NULL, 'Serine/threonine-protein phosphatase 2A 56 kDa regulatory subunit', 403, NULL, NULL, 38162),
(38163, '1.10.510.10-FF-003055', NULL, NULL, 209, NULL, NULL, 38163);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(38164, '1.10.238.10-FF-001089', NULL, 'Predicted protein', 72, NULL, NULL, 38164),
(38165, '3.40.50.2300-FF-001342', NULL, NULL, 71, NULL, NULL, 38165),
(38166, '1.25.10.30-FF-000009', NULL, NULL, 46, NULL, NULL, 38166),
(38167, '3.30.460.10-FF-000059', NULL, 'Non-canonical poly(A) RNA polymerase PAPD5', 58, NULL, NULL, 38167),
(38168, '3.40.50.1460-FF-000038', NULL, 'Uncharacterized protein', 283, NULL, NULL, 38168),
(38169, '3.30.505.10-FF-000023', NULL, 'Tyrosine-protein kinase', 101, NULL, NULL, 38169),
(38170, '1.10.1280.10-FF-000005', NULL, 'Tyrosinase related protein 1', 184, NULL, NULL, 38170),
(38171, '1.20.80.10-FF-000018', NULL, 'Kinesin-like calmodulin binding protein', 112, NULL, NULL, 38171),
(38172, '2.40.50.140-FF-000693', NULL, 'Predicted protein', 148, NULL, NULL, 38172),
(38173, '1.25.10.10-FF-001577', NULL, 'Uncharacterized protein', 142, NULL, NULL, 38173),
(38174, '1.10.287.410-FF-000013', NULL, 'Carboxypeptidase', 80, NULL, NULL, 38174),
(38175, '2.60.40.10-FF-003732', NULL, NULL, 127, NULL, NULL, 38175),
(38176, '3.40.50.300-FF-008027', NULL, 'Uncharacterized protein', 280, NULL, NULL, 38176),
(38177, '3.40.50.720-FF-000907', NULL, 'Probable myo-inositol 1-phosphate synthase (MIPS)', 365, NULL, NULL, 38177),
(38178, '2.60.120.1160-FF-000001', NULL, 'Uncharacterized protein', 238, NULL, NULL, 38178),
(38179, '3.30.40.10-FF-001899', NULL, 'Uncharacterized protein', 74, NULL, NULL, 38179),
(38180, '1.20.1070.10-FF-002163', NULL, 'Rhodopsin', 141, NULL, NULL, 38180),
(38181, '2.60.120.200-FF-000808', NULL, 'Lectin receptor kinase', 48, NULL, NULL, 38181),
(38182, '3.30.160.60-FF-005677', NULL, NULL, 26, NULL, NULL, 38182),
(38183, '3.40.50.1220-FF-000085', NULL, 'Probable 2-hydroxyacyl-CoA lyase 1', 183, NULL, NULL, 38183),
(38184, '3.30.450.20-FF-000623', NULL, 'Uncharacterized protein', 90, NULL, NULL, 38184),
(38185, '1.25.40.120-FF-000028', NULL, 'AGAP002731-PA', 159, NULL, NULL, 38185),
(38186, '3.30.300.20-FF-000056', NULL, 'Ribosomal protein S3', 88, NULL, NULL, 38186),
(38187, '3.30.2300.10-FF-000002', NULL, 'Uncharacterized protein', 81, NULL, NULL, 38187),
(38188, '3.40.50.150-FF-000416', NULL, 'Protein-L-isoaspartate O-methyltransferase', 207, NULL, NULL, 38188),
(38189, '2.130.10.10-FF-005155', NULL, 'Cilia- and flagella-associated protein 43', 140, NULL, NULL, 38189),
(38190, '3.30.710.10-FF-000444', NULL, 'Uncharacterized protein', 157, NULL, NULL, 38190),
(38191, '3.40.50.1110-FF-000052', NULL, 'Exported lipase/acylhydrolase', 233, NULL, NULL, 38191),
(38192, '3.80.10.10-FF-002480', NULL, 'Uncharacterized protein', 100, NULL, NULL, 38192),
(38193, '3.40.50.300-FF-001799', NULL, 'Rac2 family GTP-binding protein, putative', 187, NULL, NULL, 38193),
(38194, '1.25.40.20-FF-001683', NULL, 'Serine/threonine-protein kinase TNNI3K', 75, NULL, NULL, 38194),
(38195, '2.130.10.10-FF-001344', NULL, 'WD repeat-containing protein 91', 132, NULL, NULL, 38195),
(38196, '3.50.30.30-FF-000083', NULL, 'Subtilisin-like protease SBT2.4', 172, NULL, NULL, 38196),
(38197, '3.30.420.10-FF-000225', NULL, 'Os07g0112400 protein', 193, NULL, NULL, 38197),
(38198, '3.50.50.60-FF-001144', NULL, 'Uncharacterized protein', 82, NULL, NULL, 38198),
(38199, '3.30.830.10-FF-000020', NULL, 'Mitochondrial presequence protease', 264, NULL, NULL, 38199),
(38200, '3.40.190.80-FF-000023', NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', 132, NULL, NULL, 38200),
(38201, '2.30.42.10-FF-000490', NULL, NULL, 106, NULL, NULL, 38201),
(38202, '3.40.50.150-FF-001765', NULL, NULL, 332, NULL, NULL, 38202),
(38203, '1.10.287.110-FF-000125', NULL, 'HSP40/DnaJ peptide-binding protein', 79, NULL, NULL, 38203),
(38204, '3.30.300.30-FF-000059', NULL, 'YOR093C-like protein', 140, NULL, NULL, 38204),
(38205, '1.20.120.740-FF-000003', NULL, 'UPF0149 protein PLES_56191', 177, NULL, NULL, 38205),
(38206, '2.130.10.10-FF-005801', NULL, 'Plexin C1', 89, NULL, NULL, 38206),
(38207, '3.50.50.60-FF-001082', NULL, 'N-methylproline demethylase, putative', 129, NULL, NULL, 38207),
(38208, '3.20.20.190-FF-000028', NULL, 'Glycerophosphodiester phosphodiesterase domain-containing protein 5', 270, NULL, NULL, 38208); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(38209, '3.30.200.20-FF-001532', NULL, 'Putative lectin-like receptor protein kinase family protein', 92, NULL, NULL, 38209),
(38210, '1.20.1250.20-FF-000398', NULL, 'Monocarboxylate transporter 14', 201, NULL, NULL, 38210),
(38211, '3.30.1490.70-FF-000005', NULL, 'RNA-editing ligase 1, mitochondrial', 105, NULL, NULL, 38211),
(38212, '3.30.160.60-FF-001815', NULL, 'Zinc finger protein 425', 34, NULL, NULL, 38212),
(38213, '1.10.10.10-FF-000857', NULL, 'MarR family transcriptional regulator', 86, NULL, NULL, 38213),
(38214, '2.60.40.10-FF-005177', NULL, NULL, 93, NULL, NULL, 38214),
(38215, '2.60.40.10-FF-003457', NULL, NULL, 102, NULL, NULL, 38215),
(38216, '1.10.510.10-FF-001868', NULL, 'NACHT and Ankyrin domain protein', 319, NULL, NULL, 38216),
(38217, '3.40.50.150-FF-001518', NULL, NULL, 109, NULL, NULL, 38217),
(38218, '2.40.70.10-FF-000222', NULL, 'Aspartic proteinase NANA, chloroplast', 205, NULL, NULL, 38218),
(38219, '3.30.160.60-FF-004042', NULL, NULL, 29, NULL, NULL, 38219),
(38220, '3.30.200.20-FF-001471', NULL, 'Kinase, NEK', 56, NULL, NULL, 38220),
(38221, '2.30.140.10-FF-000016', NULL, 'Spermidine synthase isoform C', 58, NULL, NULL, 38221),
(38222, '1.20.120.160-FF-000043', NULL, 'Two-component phosphorelay mediator', 69, NULL, NULL, 38222),
(38223, '2.60.40.10-FF-000877', NULL, 'CLUMA_CG002357, isoform A', 87, NULL, NULL, 38223),
(38224, '3.30.505.10-FF-000074', NULL, 'Tyrosine-protein kinase', 109, NULL, NULL, 38224),
(38225, '3.40.50.300-FF-007690', NULL, 'Uncharacterized protein', 107, NULL, NULL, 38225),
(38226, '1.10.287.70-FF-000326', NULL, 'GG19677', 133, NULL, NULL, 38226),
(38227, '3.40.50.720-FF-001301', NULL, 'Pyrroline-5-carboxylate reductase', 163, NULL, NULL, 38227),
(38228, '1.10.20.10-FF-000037', NULL, 'Transcription initiation factor TFIID subunit 12', 78, NULL, NULL, 38228),
(38229, '1.20.1110.10-FF-000160', NULL, NULL, 144, NULL, NULL, 38229),
(38230, '1.25.40.10-FF-001028', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 106, NULL, NULL, 38230),
(38231, '1.10.1410.20-FF-000008', NULL, 'Uncharacterized protein', 50, NULL, NULL, 38231),
(38232, '1.10.3520.10-FF-000008', NULL, 'Glycolipid transfer protein 2', 215, NULL, NULL, 38232),
(38233, '1.25.10.10-FF-002420', NULL, 'Uncharacterized protein', 248, NULL, NULL, 38233),
(38234, '3.30.160.60-FF-004688', NULL, NULL, 75, NULL, NULL, 38234),
(38235, '1.20.1070.10-FF-000572', NULL, 'DOPamine receptor', 240, NULL, NULL, 38235),
(38236, '2.60.120.10-FF-000306', NULL, 'Homogentisate 1,2-dioxygenase', 82, NULL, NULL, 38236),
(38237, '1.10.357.140-FF-000044', NULL, 'Uncharacterized protein', 128, NULL, NULL, 38237),
(38238, '2.130.10.10-FF-005060', NULL, 'Uncharacterized protein', 274, NULL, NULL, 38238),
(38239, '3.70.10.10-FF-000136', NULL, 'Cell cycle checkpoint control protein', 274, NULL, NULL, 38239),
(38240, '1.25.10.10-FF-001526', NULL, 'Probable serine/threonine-protein kinase tsuA', 223, NULL, NULL, 38240),
(38241, '2.60.200.30-FF-000026', NULL, 'NAD kinase', 138, NULL, NULL, 38241),
(38242, '1.10.287.110-FF-000400', NULL, 'Predicted protein', 92, NULL, NULL, 38242),
(38243, '3.40.50.150-FF-001670', NULL, NULL, 254, NULL, NULL, 38243),
(38244, '1.10.10.60-FF-000939', NULL, NULL, 67, NULL, NULL, 38244),
(38245, '6.10.140.2220-FF-000045', NULL, 'AT24727p', 51, NULL, NULL, 38245),
(38246, '1.10.510.10-FF-001368', NULL, 'serine/threonine-protein kinase 38 isoform X3', 39, NULL, NULL, 38246),
(38247, '1.20.1740.10-FF-000191', NULL, 'Uncharacterized protein', 234, NULL, NULL, 38247),
(38248, '3.40.50.1000-FF-000423', NULL, 'Trehalose-6-phosphate synthase', 142, NULL, NULL, 38248),
(38249, '3.40.50.720-FF-000958', NULL, '6-hydroxycyclohex-1-ene-1-carbonyl-CoA dehydrogenase', 147, NULL, NULL, 38249),
(38250, '2.160.10.30-FF-000005', NULL, NULL, 65, NULL, NULL, 38250),
(38251, '1.10.3210.10-FF-000024', NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase-like protein', 377, NULL, NULL, 38251),
(38252, '1.25.40.10-FF-003271', NULL, 'Pentatricopeptide repeat-containing protein At1g74900, mitochondrial', 143, NULL, NULL, 38252);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(38253, '1.25.10.10-FF-003090', NULL, 'Uncharacterized protein', 225, NULL, NULL, 38253),
(38254, '1.20.1740.10-FF-000039', NULL, 'Neutral amino acid transporter (Eurofung)', 411, NULL, NULL, 38254),
(38255, '1.10.8.140-FF-000012', NULL, 'DNA-binding protein MSBR3_2977', 108, NULL, NULL, 38255),
(38256, '2.60.40.10-FF-001866', NULL, 'T cell receptor gamma variable 3', 116, NULL, NULL, 38256),
(38257, '3.40.50.300-FF-005335', NULL, 'Ras-related protein RABD1', 146, NULL, NULL, 38257),
(38258, '3.40.50.360-FF-000075', NULL, 'NADPH--cytochrome P450 reductase', 202, NULL, NULL, 38258),
(38259, '2.40.50.140-FF-000367', NULL, 'rRNA biogenesis protein RRP5, putative', 88, NULL, NULL, 38259),
(38260, '2.60.200.20-FF-000023', NULL, 'Solute carrier family 4 member 1 adaptor protein', 138, NULL, NULL, 38260),
(38261, '3.90.190.10-FF-000238', NULL, 'Uncharacterized protein', 199, NULL, NULL, 38261),
(38262, '1.10.8.60-FF-000511', NULL, 'AAA ATPase, putative', 55, NULL, NULL, 38262),
(38263, '3.30.930.10-FF-000084', NULL, 'Phenylalanine-tRNA ligase, beta subunit', 215, NULL, NULL, 38263),
(38264, '3.40.1190.10-FF-000018', NULL, 'Rma1p', 276, NULL, NULL, 38264),
(38265, '1.20.1560.10-FF-000093', NULL, 'Type I secretion system permease/ATPase', 309, NULL, NULL, 38265),
(38266, '3.60.10.10-FF-000305', NULL, 'Chromosome 7, whole genome shotgun sequence', 312, NULL, NULL, 38266),
(38267, '2.60.120.970-FF-000045', NULL, 'CET-1', 215, NULL, NULL, 38267),
(38268, '3.30.160.60-FF-005177', NULL, NULL, 45, NULL, NULL, 38268),
(38269, '1.20.58.60-FF-000824', NULL, 'Uncharacterized protein', 178, NULL, NULL, 38269),
(38270, '2.40.50.100-FF-000203', NULL, 'Exosome complex component csl4', 43, NULL, NULL, 38270),
(38271, '3.40.50.2300-FF-000499', NULL, 'Orn/Arg/Lys decarboxylase, putative', 116, NULL, NULL, 38271),
(38272, '2.60.40.10-FF-005082', NULL, NULL, 100, NULL, NULL, 38272),
(38273, '1.20.1110.10-FF-000008', NULL, 'Calcium-transporting ATPase', 187, NULL, NULL, 38273),
(38274, '2.130.10.10-FF-003435', NULL, 'Uncharacterized protein', 421, NULL, NULL, 38274),
(38275, '3.80.10.10-FF-002884', NULL, 'NLR family CARD domain-containing 9', 167, NULL, NULL, 38275),
(38276, '3.20.20.70-FF-000168', NULL, '3-hydroxy-5-phosphonooxypentane-2,4-dione thiolase', 293, NULL, NULL, 38276),
(38277, '3.40.50.1820-FF-000809', NULL, 'Uncharacterized protein', 291, NULL, NULL, 38277),
(38278, '3.10.280.10-FF-000004', NULL, 'Mitochondrial acidic protein MAM33, putative', 194, NULL, NULL, 38278),
(38279, '1.10.287.1150-FF-000011', NULL, '2-oxoglutarate dehydrogenase E1 component DHKTD1', 81, NULL, NULL, 38279),
(38280, '1.20.1070.10-FF-001061', NULL, 'putative gonadotropin-releasing hormone II receptor', 139, NULL, NULL, 38280),
(38281, '1.10.630.10-FF-000129', NULL, 'Benzoate 4-monooxygenase cytochrome P450', 459, NULL, NULL, 38281),
(38282, '3.30.40.10-FF-001314', NULL, 'Putative E3 ubiquitin-protein ligase XERICO', 69, NULL, NULL, 38282),
(38283, '1.10.510.10-FF-004044', NULL, NULL, 78, NULL, NULL, 38283),
(38284, '1.20.5.110-FF-000231', NULL, 'Vesicle transport v-SNARE protein, putative', 80, NULL, NULL, 38284),
(38285, '1.10.101.10-FF-000007', NULL, 'Carboxyl-terminal protease', 82, NULL, NULL, 38285),
(38286, '1.20.1020.10-FF-000001', NULL, 'E1A binding protein p300', 114, NULL, NULL, 38286),
(38287, '3.40.470.10-FF-000012', NULL, 'Type-5 uracil-DNA glycosylase', 221, NULL, NULL, 38287),
(38288, '1.20.1250.20-FF-000965', NULL, 'Multidrug efflux transporter', 181, NULL, NULL, 38288),
(38289, '3.10.20.90-FF-000141', NULL, 'Neutrophil cytosol factor 2', 82, NULL, NULL, 38289),
(38290, '1.10.510.10-FF-003908', NULL, NULL, 80, NULL, NULL, 38290),
(38291, '3.30.70.330-FF-002949', NULL, NULL, 109, NULL, NULL, 38291),
(38292, '1.20.120.1160-FF-000001', NULL, 'Minor nucleoprotein VP30', 155, NULL, NULL, 38292),
(38293, '1.10.10.2320-FF-000001', NULL, 'phenylalanine--tRNA ligase alpha subunit', 45, NULL, NULL, 38293),
(38294, '2.10.25.10-FF-000872', NULL, 'Versican b', 39, NULL, NULL, 38294),
(38295, '1.10.10.2330-FF-000004', NULL, 'Phenylalanine--tRNA ligase alpha subunit, cytoplasmic', 55, NULL, NULL, 38295);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(38296, '2.30.29.30-FF-000532', NULL, 'Sterol 3-beta-glucosyltransferase', 54, NULL, NULL, 38296),
(38297, '1.25.10.10-FF-003443', NULL, 'Uncharacterized protein', 243, NULL, NULL, 38297),
(38298, '2.30.30.870-FF-000011', NULL, NULL, 137, NULL, NULL, 38298),
(38299, '3.20.20.105-FF-000024', NULL, 'Uncharacterized protein', 73, NULL, NULL, 38299),
(38300, '3.30.710.10-FF-000118', NULL, 'Abrupt, isoform B', 142, NULL, NULL, 38300),
(38301, '3.30.420.10-FF-000551', NULL, NULL, 66, NULL, NULL, 38301),
(38302, '3.40.50.150-FF-001198', NULL, NULL, 85, NULL, NULL, 38302),
(38303, '3.30.750.44-FF-000027', NULL, NULL, 15, NULL, NULL, 38303),
(38304, '3.30.70.270-FF-000279', NULL, NULL, 108, NULL, NULL, 38304),
(38305, '1.10.1200.10-FF-000113', NULL, 'Peptide synthetase NRPS type II-PCP', 90, NULL, NULL, 38305),
(38306, '3.80.10.10-FF-000529', NULL, 'PH domain leucine-rich repeat-containing protein phosphatase 2', 169, NULL, NULL, 38306),
(38307, '1.10.800.10-FF-000008', NULL, 'Phenylalanine-4-hydroxylase', 266, NULL, NULL, 38307),
(38308, '2.130.10.10-FF-005773', NULL, 'Uncharacterized protein', 107, NULL, NULL, 38308),
(38309, '3.20.20.20-FF-000018', NULL, 'Corrinoid/iron-sulfur protein small subunit', 309, NULL, NULL, 38309),
(38310, '2.60.40.420-FF-000074', NULL, 'Blue copper binding protein-like', 107, NULL, NULL, 38310),
(38311, '3.40.50.2020-FF-000049', NULL, 'Putative uracil phosphoribosyltransferase urg2', 220, NULL, NULL, 38311),
(38312, '3.30.70.330-FF-001101', NULL, 'Peptidyl-prolyl cis-trans isomerase', 144, NULL, NULL, 38312),
(38313, '3.40.50.80-FF-000094', NULL, 'Bifunctional cytochrome P450/NADPH--P450 reductase', 190, NULL, NULL, 38313),
(38314, '3.40.366.10-FF-000068', NULL, 'Uncharacterized protein', 89, NULL, NULL, 38314),
(38315, '3.30.1330.30-FF-000066', NULL, 'Conserved protein', 83, NULL, NULL, 38315),
(38316, '3.30.230.10-FF-000076', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 159, NULL, NULL, 38316),
(38317, '3.30.1490.120-FF-000017', NULL, 'RNA polymerase subunit, putative', 101, NULL, NULL, 38317),
(38318, '3.40.50.720-FF-001801', NULL, 'Protein CLP1 homolog', 221, NULL, NULL, 38318),
(38319, '2.80.10.50-FF-000094', NULL, 'Cellulase containing protein, expressed', 124, NULL, NULL, 38319),
(38320, '3.30.200.20-FF-000577', NULL, 'Tyrosine kinase', 120, NULL, NULL, 38320),
(38321, '2.40.50.100-FF-000080', NULL, 'Spermidine/putrescine ABC transporter, ATP-binding protein', 87, NULL, NULL, 38321),
(38322, '2.30.29.30-FF-000178', NULL, 'DCC-interacting protein 13-alpha isoform X2', 159, NULL, NULL, 38322),
(38323, '3.30.1330.40-FF-000069', NULL, 'Uncharacterized protein', 74, NULL, NULL, 38323),
(38324, '1.25.40.10-FF-001528', NULL, 'pentatricopeptide repeat-containing protein At1g11290, chloroplastic', 238, NULL, NULL, 38324),
(38325, '3.90.1600.10-FF-000011', NULL, 'DNA-directed DNA polymerase', 243, NULL, NULL, 38325),
(38326, '2.130.10.10-FF-001844', NULL, 'Transducin family protein / WD-40 repeat family protein', 155, NULL, NULL, 38326),
(38327, '2.20.25.10-FF-000085', NULL, 'DNA-directed RNA polymerase subunit', 55, NULL, NULL, 38327),
(38328, '3.60.40.10-FF-000279', NULL, 'Sll1771 protein', 249, NULL, NULL, 38328),
(38329, '3.40.50.300-FF-001850', NULL, 'ATP-dependent helicase/nuclease subunit A', 137, NULL, NULL, 38329),
(38330, '3.30.1440.10-FF-000012', NULL, 'Uncharacterized protein', 80, NULL, NULL, 38330),
(38331, '3.20.20.10-FF-000015', NULL, 'Diaminopimelate decarboxylase', 259, NULL, NULL, 38331),
(38332, '1.20.1250.20-FF-001241', NULL, 'Solute carrier organic anion transporter family member', 372, NULL, NULL, 38332),
(38333, '3.30.930.10-FF-000376', NULL, 'Uncharacterized protein', 150, NULL, NULL, 38333),
(38334, '1.20.140.150-FF-000021', NULL, 'Transmembrane protein 114', 206, NULL, NULL, 38334),
(38335, '1.10.510.10-FF-001189', NULL, 'calcium/calmodulin-dependent protein kinase type IV isoform X2', 111, NULL, NULL, 38335),
(38336, '3.40.1110.10-FF-000238', NULL, NULL, 110, NULL, NULL, 38336),
(38337, '2.60.98.60-FF-000002', NULL, 'Protein CBR-EFF-1, isoform a', 120, NULL, NULL, 38337);
INSERT INTO "PUBLIC"."MODEL" VALUES
(38338, '2.60.120.10-FF-000183', NULL, 'Crp/Fnr family transcriptional regulator', 149, NULL, NULL, 38338),
(38339, '1.50.40.10-FF-000205', NULL, 'Uncharacterized mitochondrial carrier SCY_1795', 299, NULL, NULL, 38339),
(38340, '3.30.70.330-FF-000825', NULL, 'Pre-rRNA-processing protein ESF2', 170, NULL, NULL, 38340),
(38341, '3.40.50.720-FF-000458', NULL, 'Fatty acyl-CoA reductase', 355, NULL, NULL, 38341),
(38342, '3.40.50.300-FF-005773', NULL, 'Uncharacterized protein', 104, NULL, NULL, 38342),
(38343, '3.40.50.1100-FF-000127', NULL, 'L-threonine ammonia-lyase', 198, NULL, NULL, 38343),
(38344, '3.40.50.300-FF-000164', NULL, 'regulator of nonsense transcripts 1 homolog', 212, NULL, NULL, 38344),
(38345, '1.10.1080.10-FF-000024', NULL, 'Uncharacterized protein', 33, NULL, NULL, 38345),
(38346, '1.10.1740.10-FF-000024', NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', 87, NULL, NULL, 38346),
(38347, '3.40.50.620-FF-000642', NULL, 'Predicted protein', 246, NULL, NULL, 38347),
(38348, '1.20.1720.10-FF-000094', NULL, 'Uncharacterized protein', 261, NULL, NULL, 38348),
(38349, '3.30.300.10-FF-000020', NULL, 'S-adenosylmethionine synthase', 118, NULL, NULL, 38349),
(38350, '3.30.450.20-FF-000674', NULL, 'Nuclear receptor coactivator', 86, NULL, NULL, 38350),
(38351, '3.30.70.330-FF-000876', NULL, 'RNA splicing factor (Pad-1), putative', 139, NULL, NULL, 38351),
(38352, '1.10.300.10-FF-000015', NULL, 'Adenylosuccinate synthetase', 54, NULL, NULL, 38352),
(38353, '3.30.70.1730-FF-000061', NULL, 'Uncharacterized protein', 203, NULL, NULL, 38353),
(38354, '1.20.120.720-FF-000059', NULL, 'Myosin-M heavy chain', 164, NULL, NULL, 38354),
(38355, '2.60.120.10-FF-000418', NULL, 'Uncharacterized protein', 147, NULL, NULL, 38355),
(38356, '1.10.238.10-FF-001117', NULL, 'Uncharacterized protein', 43, NULL, NULL, 38356),
(38357, '1.10.1410.10-FF-000005', NULL, 'Nucleolar protein 6', 166, NULL, NULL, 38357),
(38358, '2.30.29.30-FF-000919', NULL, 'Uncharacterized protein', 112, NULL, NULL, 38358),
(38359, '3.30.160.60-FF-005918', NULL, NULL, 25, NULL, NULL, 38359),
(38360, '3.30.40.10-FF-000876', NULL, 'Anaphase promoting complex subunit 11', 64, NULL, NULL, 38360),
(38361, '3.40.50.300-FF-005447', NULL, 'DNA helicase', 246, NULL, NULL, 38361),
(38362, '3.30.360.10-FF-000107', NULL, 'Acetylglutamate kinase', 169, NULL, NULL, 38362),
(38363, '2.40.50.690-FF-000003', NULL, 'DIS3-like exonuclease 2', 106, NULL, NULL, 38363),
(38364, '1.20.120.1810-FF-000011', NULL, NULL, 192, NULL, NULL, 38364),
(38365, '3.40.50.410-FF-000079', NULL, 'Mg-protoporphyrin IX chelatase', 206, NULL, NULL, 38365),
(38366, '3.40.50.300-FF-006875', NULL, 'Sulfate transport ATP-binding protein cysA', 249, NULL, NULL, 38366),
(38367, '1.25.40.20-FF-000401', NULL, 'Glycerophosphocholine phosphodiesterase Gde1, putative', 191, NULL, NULL, 38367),
(38368, '3.40.1380.20-FF-000064', NULL, 'Pyruvate kinase', 122, NULL, NULL, 38368),
(38369, '2.40.50.140-FF-000479', NULL, '28S ribosomal protein S17, mitochondrial', 115, NULL, NULL, 38369),
(38370, '1.10.1200.10-FF-000017', NULL, 'Acyl carrier protein', 82, NULL, NULL, 38370),
(38371, '3.40.50.300-FF-001524', NULL, 'Si:dkey-126g1.7', 230, NULL, NULL, 38371),
(38372, '3.60.15.10-FF-000266', NULL, 'Uncharacterized protein', 113, NULL, NULL, 38372),
(38373, '3.30.40.10-FF-002388', NULL, 'Uncharacterized protein', 68, NULL, NULL, 38373),
(38374, '3.40.50.11350-FF-000037', NULL, 'Protein O-fucosyltransferase 2', 79, NULL, NULL, 38374),
(38375, '1.25.40.10-FF-001680', NULL, 'Pentatricopeptide repeat-containing protein At5g42310, chloroplastic', 169, NULL, NULL, 38375),
(38376, '3.30.160.60-FF-003148', NULL, 'Zinc finger 30C', 70, NULL, NULL, 38376),
(38377, '3.30.559.30-FF-000125', NULL, 'Non-ribosomal peptide synthetase OfaA', 259, NULL, NULL, 38377),
(38378, '2.40.30.190-FF-000001', NULL, 'Secreted protein ORF2', 141, NULL, NULL, 38378),
(38379, '3.90.1750.10-FF-000011', NULL, 'E3 ubiquitin-protein ligase UBR5 isoform X1', 92, NULL, NULL, 38379),
(38380, '2.20.28.10-FF-000024', NULL, 'rRNA maturation endonuclease Nob1', 37, NULL, NULL, 38380);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(38381, '2.60.40.10-FF-001580', NULL, 'Echinoid, isoform C', 118, NULL, NULL, 38381),
(38382, '3.40.630.30-FF-000172', NULL, 'GNAT family acetyltransferase', 197, NULL, NULL, 38382),
(38383, '3.90.360.10-FF-000004', NULL, 'Histone acetyltransferase type B catalytic subunit', 108, NULL, NULL, 38383),
(38384, '1.10.510.10-FF-001138', NULL, 'Fmp48p', 254, NULL, NULL, 38384),
(38385, '3.90.190.10-FF-000564', NULL, 'Uncharacterized protein', 78, NULL, NULL, 38385),
(38386, '1.20.1250.20-FF-000639', NULL, 'Unplaced genomic scaffold supercont1.38, whole genome shotgun sequence', 233, NULL, NULL, 38386),
(38387, '3.60.40.10-FF-000228', NULL, 'PH domain leucine-rich repeat protein phosphatase, isoform B', 121, NULL, NULL, 38387),
(38388, '3.30.450.20-FF-000382', NULL, 'Sensory transduction histidine kinase', 122, NULL, NULL, 38388),
(38389, '2.60.40.10-FF-003906', NULL, NULL, 104, NULL, NULL, 38389),
(38390, '3.40.1110.10-FF-000390', NULL, NULL, 117, NULL, NULL, 38390),
(38391, '1.10.3660.10-FF-000018', NULL, 'Prephenate dehydrogenase [NADP(+)]', 122, NULL, NULL, 38391),
(38392, '3.10.20.260-FF-000001', NULL, 'Putative NEDD8-activating enzyme E1 catalytic subunit-like', 56, NULL, NULL, 38392),
(38393, '3.90.280.10-FF-000003', NULL, 'phosphatidylethanolamine-binding protein 1', 187, NULL, NULL, 38393),
(38394, '3.30.70.330-FF-000584', NULL, 'Splicing factor CC1-like', 162, NULL, NULL, 38394),
(38395, '1.10.3200.20-FF-000021', NULL, NULL, 196, NULL, NULL, 38395),
(38396, '2.10.50.10-FF-000110', NULL, 'Predicted protein', 53, NULL, NULL, 38396),
(38397, '2.40.420.20-FF-000050', NULL, 'Acriflavin resistance periplasmic protein', 99, NULL, NULL, 38397),
(38398, '2.30.30.40-FF-000201', NULL, 'Myosin XVA', 101, NULL, NULL, 38398),
(38399, '1.10.630.10-FF-000394', NULL, 'Cytochrome P450 71D8', 130, NULL, NULL, 38399),
(38400, '3.40.50.12760-FF-000027', NULL, 'Uncharacterized protein', 134, NULL, NULL, 38400),
(38401, '3.40.630.190-FF-000003', NULL, 'Polyisoprenyl-teichoic acid--peptidoglycan teichoic acid transferase TagU', 262, NULL, NULL, 38401),
(38402, '3.30.70.1230-FF-000152', NULL, 'Uncharacterized protein', 95, NULL, NULL, 38402),
(38403, '3.40.50.1360-FF-000008', NULL, 'Transcriptional regulator, DeoR family', 160, NULL, NULL, 38403),
(38404, '3.10.50.10-FF-000046', NULL, 'Uncharacterized protein', 75, NULL, NULL, 38404),
(38405, '1.10.220.10-FF-000014', NULL, 'annexin D4', 73, NULL, NULL, 38405),
(38406, '2.160.20.20-FF-000008', NULL, 'Adhesin/invasin TibA autotransporter', 421, NULL, NULL, 38406),
(38407, '1.10.10.440-FF-000100', NULL, 'Uncharacterized protein', 45, NULL, NULL, 38407),
(38408, '2.30.110.10-FF-000110', NULL, 'Uncharacterized protein', 196, NULL, NULL, 38408),
(38409, '3.10.20.310-FF-000044', NULL, 'Hemolysin transporter protein ShlB', 51, NULL, NULL, 38409),
(38410, '1.25.40.10-FF-001079', NULL, 'Pentatricopeptide repeat-containing protein At2g17210', 215, NULL, NULL, 38410),
(38411, '1.10.220.20-FF-000017', NULL, 'Uncharacterized protein', 52, NULL, NULL, 38411),
(38412, '3.40.190.10-FF-000873', NULL, 'Glutamate receptor 1-like Protein', 134, NULL, NULL, 38412),
(38413, '3.40.50.300-FF-007038', NULL, 'Si:ch211-139n6.3', 201, NULL, NULL, 38413),
(38414, '1.25.40.10-FF-005070', NULL, 'Predicted protein', 197, NULL, NULL, 38414),
(38415, '3.30.160.60-FF-001703', NULL, 'Zinc finger protein, FOG family member 2', 30, NULL, NULL, 38415),
(38416, '2.60.40.10-FF-003165', NULL, 'Phosphoglucan, water dikinase, chloroplastic', 97, NULL, NULL, 38416),
(38417, '1.25.40.10-FF-001972', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform B', 158, NULL, NULL, 38417),
(38418, '1.10.10.540-FF-000012', NULL, 'UV excision repair protein RAD23-like protein B', 61, NULL, NULL, 38418),
(38419, '3.30.40.10-FF-001511', NULL, 'Putative ring finger protein', 74, NULL, NULL, 38419),
(38420, '2.130.10.10-FF-003261', NULL, 'Syntaxin-binding protein 5 isoform A', 377, NULL, NULL, 38420),
(38421, '3.30.200.20-FF-001420', NULL, 'Uncharacterized protein', 77, NULL, NULL, 38421),
(38422, '3.30.190.20-FF-000018', NULL, 'Ribosomal protein', 121, NULL, NULL, 38422);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(38423, '1.10.10.350-FF-000011', NULL, 'Glutamate--tRNA ligase 2', 90, NULL, NULL, 38423),
(38424, '3.80.10.10-FF-002654', NULL, 'LRR receptor-like serine/threonine-protein kinase RCH1', 109, NULL, NULL, 38424),
(38425, '1.25.10.10-FF-001285', NULL, 'HEAT repeat containing 1', 464, NULL, NULL, 38425),
(38426, '2.130.10.10-FF-002979', NULL, 'Uncharacterized protein', 211, NULL, NULL, 38426),
(38427, '3.60.10.10-FF-000165', NULL, 'DNase I-like protein', 278, NULL, NULL, 38427),
(38428, '4.10.280.10-FF-000169', NULL, 'FI24210p1', 97, NULL, NULL, 38428),
(38429, '1.20.1250.20-FF-000347', NULL, 'MFS transporter', 220, NULL, NULL, 38429),
(38430, '3.40.1180.10-FF-000012', NULL, 'Alkyl transferase', 83, NULL, NULL, 38430),
(38431, '1.25.40.20-FF-000222', NULL, 'Short transient receptor potential channel 2 homolog', 185, NULL, NULL, 38431),
(38432, '1.10.510.10-FF-002245', NULL, NULL, 157, NULL, NULL, 38432),
(38433, '2.60.120.380-FF-000082', NULL, 'Calpain-like protease palB', 134, NULL, NULL, 38433),
(38434, '2.60.40.10-FF-001754', NULL, 'Protein tyrosine phosphatase, receptor type B', 90, NULL, NULL, 38434),
(38435, '3.80.10.10-FF-003143', NULL, 'Protein CBG07183', 317, NULL, NULL, 38435),
(38436, '1.20.120.1770-FF-000010', NULL, 'DOMON domain-containing protein', 194, NULL, NULL, 38436),
(38437, '1.20.1560.10-FF-000379', NULL, 'Transporter associated with antigen presentation 2', 328, NULL, NULL, 38437),
(38438, '3.40.50.300-FF-007982', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 158, NULL, NULL, 38438),
(38439, '1.10.510.10-FF-002032', NULL, 'Predicted protein', 285, NULL, NULL, 38439),
(38440, '3.40.50.720-FF-002471', NULL, 'Malic enzyme', 285, NULL, NULL, 38440),
(38441, '3.40.50.1010-FF-000140', NULL, 'Protein CBG02516', 151, NULL, NULL, 38441),
(38442, '3.40.50.300-FF-007752', NULL, 'Heparan-sulfate 6-O-sulfotransferase', 75, NULL, NULL, 38442),
(38443, '3.40.440.10-FF-000005', NULL, 'Adenylosuccinate synthetase', 92, NULL, NULL, 38443),
(38444, '3.90.320.10-FF-000064', NULL, 'Predicted protein', 181, NULL, NULL, 38444),
(38445, '3.40.30.10-FF-000184', NULL, 'Protein disulfide-isomerase', 120, NULL, NULL, 38445),
(38446, '3.90.25.10-FF-000029', NULL, 'GalE family epimerase/dehydratase', 98, NULL, NULL, 38446),
(38447, '3.20.20.70-FF-000718', NULL, NULL, 116, NULL, NULL, 38447),
(38448, '3.80.10.10-FF-000916', NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g53440', 124, NULL, NULL, 38448),
(38449, '3.40.710.10-FF-000099', NULL, 'Membrane peptidoglycan carboxypeptidase', 383, NULL, NULL, 38449),
(38450, '3.90.640.90-FF-000004', NULL, 'FOG-3', 130, NULL, NULL, 38450),
(38451, '1.25.40.10-FF-003557', NULL, 'Uncharacterized protein', 261, NULL, NULL, 38451),
(38452, '3.30.1490.480-FF-000007', NULL, 'Endolytic murein transglycosylase', 71, NULL, NULL, 38452),
(38453, '1.10.510.10-FF-001756', NULL, 'Serine/threonine-protein kinase STE7 homolog', 257, NULL, NULL, 38453),
(38454, '3.30.200.20-FF-001706', NULL, 'Protein kinase, putative', 52, NULL, NULL, 38454),
(38455, '3.10.129.10-FF-000165', NULL, 'Thioesterase superfamily protein', 134, NULL, NULL, 38455),
(38456, '3.90.1420.10-FF-000025', NULL, 'N-lysine methyltransferase', 198, NULL, NULL, 38456),
(38457, '2.130.10.10-FF-005447', NULL, 'Transducin beta-like protein 3', 203, NULL, NULL, 38457),
(38458, '1.10.268.10-FF-000023', NULL, NULL, 89, NULL, NULL, 38458),
(38459, '1.10.287.70-FF-000438', NULL, 'Predicted protein', 243, NULL, NULL, 38459),
(38460, '1.10.285.10-FF-000012', NULL, 'NADP-specific glutamate dehydrogenase', 48, NULL, NULL, 38460),
(38461, '3.30.420.10-FF-000293', NULL, 'Protein CBG00653', 228, NULL, NULL, 38461),
(38462, '3.40.1280.10-FF-000076', NULL, 'Ribosomal RNA small subunit methyltransferase NEP1', 121, NULL, NULL, 38462),
(38463, '1.25.40.20-FF-001762', NULL, 'Poly [ADP-ribose] polymerase tankyrase', 321, NULL, NULL, 38463),
(38464, '3.30.160.60-FF-005626', NULL, NULL, 61, NULL, NULL, 38464),
(38465, '4.10.280.10-FF-000118', NULL, 'Transcription factor bHLH10', 74, NULL, NULL, 38465); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(38466, '3.30.70.330-FF-001640', NULL, NULL, 153, NULL, NULL, 38466),
(38467, '3.80.10.10-FF-004503', NULL, 'Os03g0717000 protein', 186, NULL, NULL, 38467),
(38468, '1.20.1070.10-FF-000746', NULL, 'Predicted protein', 309, NULL, NULL, 38468),
(38469, '1.10.1530.10-FF-000003', NULL, 'Malate/L-lactate dehydrogenase', 59, NULL, NULL, 38469),
(38470, '1.10.1390.10-FF-000008', NULL, NULL, 36, NULL, NULL, 38470),
(38471, '2.30.29.30-FF-000739', NULL, 'mRNA DeCAPping enzyme', 131, NULL, NULL, 38471),
(38472, '1.25.10.10-FF-001852', NULL, 'AGAP009004-PA', 197, NULL, NULL, 38472),
(38473, '1.10.533.10-FF-000044', NULL, 'Tumor necrosis factor receptor superfamily member 1A', 111, NULL, NULL, 38473),
(38474, '2.130.10.10-FF-002007', NULL, 'Protein SLOW WALKER 1', 163, NULL, NULL, 38474),
(38475, '1.10.287.470-FF-000036', NULL, 'RND family efflux transporter, MFP subunit', 74, NULL, NULL, 38475),
(38476, '3.40.50.1820-FF-000731', NULL, 'NDRG family member 4', 175, NULL, NULL, 38476),
(38477, '1.20.1740.10-FF-000269', NULL, 'Uncharacterized protein', 203, NULL, NULL, 38477),
(38478, '3.30.465.10-FF-000109', NULL, 'Lactate dehydrogenase D', 141, NULL, NULL, 38478),
(38479, '1.10.220.110-FF-000002', NULL, 'GDNF family receptor alpha 3', 105, NULL, NULL, 38479),
(38480, '3.30.300.70-FF-000009', NULL, 'Ribosome maturation factor RimP', 78, NULL, NULL, 38480),
(38481, '3.30.40.10-FF-000590', NULL, 'Putative RING zinc finger domain superfamily protein', 63, NULL, NULL, 38481),
(38482, '3.10.20.90-FF-000702', NULL, 'Autophagy protein 5', 91, NULL, NULL, 38482),
(38483, '2.40.10.10-FF-000342', NULL, NULL, 243, NULL, NULL, 38483),
(38484, '1.10.3430.10-FF-000001', NULL, 'Ammonium transporter Rh type C', 440, NULL, NULL, 38484),
(38485, '2.60.40.10-FF-003783', NULL, NULL, 105, NULL, NULL, 38485),
(38486, '2.40.50.120-FF-000035', NULL, 'Diacylglycerol kinase', 117, NULL, NULL, 38486),
(38487, '3.40.50.720-FF-000784', NULL, 'GDP-L-fucose synthase', 58, NULL, NULL, 38487),
(38488, '3.40.390.10-FF-000175', NULL, NULL, 129, NULL, NULL, 38488),
(38489, '1.10.340.70-FF-000018', NULL, 'Usp-48', 95, NULL, NULL, 38489),
(38490, '2.60.120.10-FF-000132', NULL, 'mannose-6-phosphate isomerase isoform X2', 15, NULL, NULL, 38490),
(38491, '1.25.10.10-FF-003168', NULL, 'Ubiquitin-protein ligase, putative', 342, NULL, NULL, 38491),
(38492, '3.40.710.10-FF-000048', NULL, 'Probable peptidoglycan D,D-transpeptidase PenA', 181, NULL, NULL, 38492),
(38493, '2.130.10.10-FF-003822', NULL, 'Katanin p80 WD40 repeat-containing subunit B1', 302, NULL, NULL, 38493),
(38494, '1.25.40.10-FF-001354', NULL, 'Pentatricopeptide repeat-containing protein', 94, NULL, NULL, 38494),
(38495, '3.40.50.2300-FF-000886', NULL, NULL, 118, NULL, NULL, 38495),
(38496, '3.90.70.10-FF-000431', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 339, NULL, NULL, 38496),
(38497, '3.40.50.10190-FF-000329', NULL, 'DNA-directed DNA/RNA polymerase mu', 63, NULL, NULL, 38497),
(38498, '3.30.450.20-FF-000056', NULL, 'aryl hydrocarbon receptor repressor', 168, NULL, NULL, 38498),
(38499, '2.40.30.70-FF-000007', NULL, 'Methyltransferase, YaeB/AF_0241 family protein', 150, NULL, NULL, 38499),
(38500, '3.40.50.1010-FF-000191', NULL, NULL, 101, NULL, NULL, 38500),
(38501, '3.40.630.30-FF-000430', NULL, 'Probable N-acetylglutamate synthase', 132, NULL, NULL, 38501),
(38502, '3.90.640.10-FF-000251', NULL, 'Uncharacterized protein', 97, NULL, NULL, 38502),
(38503, '1.20.1560.10-FF-000328', NULL, 'Lipid A export ATP-binding/permease protein MsbA', 337, NULL, NULL, 38503),
(38504, '1.20.58.1120-FF-000026', NULL, 'Dynein heavy chain, cytoplasmic', 156, NULL, NULL, 38504),
(38505, '1.10.510.10-FF-003167', NULL, NULL, 167, NULL, NULL, 38505),
(38506, '2.40.30.10-FF-000225', NULL, 'Probable translation initiation factor IF-2', 127, NULL, NULL, 38506),
(38507, '3.40.50.300-FF-007931', NULL, 'Uncharacterized protein', 173, NULL, NULL, 38507),
(38508, '3.30.200.20-FF-001145', NULL, 'Predicted protein', 91, NULL, NULL, 38508),
(38509, '3.40.1280.30-FF-000003', NULL, 'tRNA methyltransferase 10C, mitochondrial RNase P subunit', 196, NULL, NULL, 38509);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(38510, '3.90.650.10-FF-000077', NULL, 'Uncharacterized protein', 95, NULL, NULL, 38510),
(38511, '1.10.287.310-FF-000016', NULL, 'Ribosomal L29 family protein', 54, NULL, NULL, 38511),
(38512, '3.80.10.10-FF-000967', NULL, 'F-box/LRR-repeat protein 3 isoform A', 106, NULL, NULL, 38512),
(38513, '3.80.10.10-FF-004278', NULL, 'Uncharacterized protein', 258, NULL, NULL, 38513),
(38514, '1.25.40.10-FF-000865', NULL, 'Target for rapamycin', 204, NULL, NULL, 38514),
(38515, '3.40.1170.60-FF-000043', NULL, NULL, 58, NULL, NULL, 38515),
(38516, '1.10.8.10-FF-000283', NULL, 'AT5g12120/MXC9_8', 94, NULL, NULL, 38516),
(38517, '3.40.50.2300-FF-001016', NULL, NULL, 26, NULL, NULL, 38517),
(38518, '3.40.50.1820-FF-000635', NULL, 'Non-ribosomal peptide synthetase', 155, NULL, NULL, 38518),
(38519, '1.10.10.10-FF-002010', NULL, 'Uncharacterized protein', 115, NULL, NULL, 38519),
(38520, '1.20.1270.60-FF-000282', NULL, 'Uncharacterized protein', 210, NULL, NULL, 38520),
(38521, '3.40.850.10-FF-000558', NULL, 'Kinesin-like protein', 115, NULL, NULL, 38521),
(38522, '1.10.150.50-FF-000071', NULL, 'Caskin, isoform D', 71, NULL, NULL, 38522),
(38523, '1.25.40.20-FF-001357', NULL, 'Uncharacterized protein', 99, NULL, NULL, 38523),
(38524, '2.130.10.10-FF-001518', NULL, 'GD13102', 339, NULL, NULL, 38524),
(38525, '1.50.10.10-FF-000119', NULL, 'Glycogen debranching enzyme, putative', 232, NULL, NULL, 38525),
(38526, '1.20.5.190-FF-000131', NULL, NULL, 83, NULL, NULL, 38526),
(38527, '3.80.10.10-FF-003789', NULL, 'Predicted protein', 98, NULL, NULL, 38527),
(38528, '1.20.5.170-FF-000058', NULL, 'Intermediate filament protein B', 79, NULL, NULL, 38528),
(38529, '2.40.30.230-FF-000002', NULL, 'regulator of nonsense transcripts 1 homolog', 89, NULL, NULL, 38529),
(38530, '2.70.50.30-FF-000023', NULL, NULL, 132, NULL, NULL, 38530),
(38531, '2.60.120.10-FF-000744', NULL, 'Uncharacterized protein', 106, NULL, NULL, 38531),
(38532, '1.10.12.10-FF-000047', NULL, 'Enoyl-CoA hydratase', 60, NULL, NULL, 38532),
(38533, '2.60.40.10-FF-003378', NULL, 'Ig-like and fibronectin type-III domain-containing protein 2', 112, NULL, NULL, 38533),
(38534, '2.60.40.1730-FF-000048', NULL, 'YALI0C13904p', 230, NULL, NULL, 38534),
(38535, '1.20.1250.10-FF-000069', NULL, 'Interleukin-6', 176, NULL, NULL, 38535),
(38536, '3.30.2160.10-FF-000030', NULL, 'Ubiquitin ligase (E3)', 91, NULL, NULL, 38536),
(38537, '3.30.9.90-FF-000001', NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase', 199, NULL, NULL, 38537),
(38538, '2.60.40.10-FF-002889', NULL, 'Leptin receptor', 94, NULL, NULL, 38538),
(38539, '2.40.240.10-FF-000061', NULL, 'Uncharacterized protein', 115, NULL, NULL, 38539),
(38540, '3.80.10.10-FF-000349', NULL, 'Dynein assembly factor 1, axonemal', 146, NULL, NULL, 38540),
(38541, '1.10.506.10-FF-000010', NULL, 'Plexin B1', 240, NULL, NULL, 38541),
(38542, '1.25.40.70-FF-000034', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit gamma, putative', 220, NULL, NULL, 38542),
(38543, '1.20.1440.100-FF-000014', NULL, 'Putative phosphatase involved in 2-Alkyl-4-hydroxymethylfuran-3-carboxylic acid biosynthesis, MmfP', 79, NULL, NULL, 38543),
(38544, '1.20.1250.20-FF-000847', NULL, 'MFS gliotoxin efflux transporter GliA', 228, NULL, NULL, 38544),
(38545, '3.40.720.10-FF-000167', NULL, 'Arylsulfatase family member H', 238, NULL, NULL, 38545),
(38546, '1.20.1250.20-FF-000791', NULL, 'Uncharacterized transporter slc-17.2', 227, NULL, NULL, 38546),
(38547, '2.60.40.1930-FF-000018', NULL, 'Thioester-containing protein 4, isoform B', 91, NULL, NULL, 38547),
(38548, '3.80.10.10-FF-000355', NULL, 'Toll-like receptor Tollo', 127, NULL, NULL, 38548),
(38549, '3.30.428.30-FF-000001', NULL, 'CDP-diacylglycerol pyrophosphatase', 227, NULL, NULL, 38549),
(38550, '2.30.39.10-FF-000083', NULL, 'Serpin-2 precursor, putative', 98, NULL, NULL, 38550),
(38551, '3.40.630.30-FF-000104', NULL, 'Aerobactin siderophore biosynthesis protein', 226, NULL, NULL, 38551),
(38552, '1.20.58.60-FF-000532', NULL, 'Uncharacterized protein', 141, NULL, NULL, 38552);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(38553, '1.10.510.10-FF-000800', NULL, 'Serine/threonine protein kinase', 149, NULL, NULL, 38553),
(38554, '3.30.200.20-FF-002494', NULL, NULL, 19, NULL, NULL, 38554),
(38555, '3.30.160.60-FF-005705', NULL, NULL, 56, NULL, NULL, 38555),
(38556, '1.20.1560.10-FF-000654', NULL, 'Uncharacterized protein', 105, NULL, NULL, 38556),
(38557, '3.40.605.10-FF-000034', NULL, 'Aldehyde dehydrogenase family protein', 261, NULL, NULL, 38557),
(38558, '3.30.780.10-FF-000038', NULL, 'Protein translation factor SUI1 homolog', 85, NULL, NULL, 38558),
(38559, '2.40.50.140-FF-000985', NULL, NULL, 189, NULL, NULL, 38559),
(38560, '3.30.420.270-FF-000038', NULL, 'Uncharacterized protein', 65, NULL, NULL, 38560),
(38561, '2.30.30.40-FF-000021', NULL, 'Putative sam and sh3 domain-containing protein 1', 63, NULL, NULL, 38561),
(38562, '3.40.50.300-FF-004430', NULL, 'ABC transporter ATP-binding protein putative', 167, NULL, NULL, 38562),
(38563, '2.70.50.80-FF-000010', NULL, 'Uncharacterized protein', 120, NULL, NULL, 38563),
(38564, '3.60.40.10-FF-000346', NULL, 'Os04g0449400 protein', 97, NULL, NULL, 38564),
(38565, '2.180.10.10-FF-000010', NULL, 'Cell wall-associated protein', 489, NULL, NULL, 38565),
(38566, '3.40.50.12710-FF-000041', NULL, 'Protein arginine methyltransferase NDUFAF7', 130, NULL, NULL, 38566),
(38567, '3.40.50.10190-FF-000363', NULL, 'Uncharacterized protein', 52, NULL, NULL, 38567),
(38568, '3.30.160.60-FF-005059', NULL, NULL, 31, NULL, NULL, 38568),
(38569, '2.60.40.420-FF-000186', NULL, 'Predicted protein', 120, NULL, NULL, 38569),
(38570, '1.10.3730.20-FF-000055', NULL, 'Membrane protein, putative', 123, NULL, NULL, 38570),
(38571, '1.20.1540.10-FF-000119', NULL, 'Probable glpG protein', 214, NULL, NULL, 38571),
(38572, '2.60.40.1910-FF-000012', NULL, 'Aminopeptidase', 78, NULL, NULL, 38572),
(38573, '1.10.390.10-FF-000032', NULL, 'Aminopeptidase', 250, NULL, NULL, 38573),
(38574, '2.60.40.10-FF-004103', NULL, NULL, 118, NULL, NULL, 38574),
(38575, '2.60.120.920-FF-000171', NULL, 'Predicted protein', 96, NULL, NULL, 38575),
(38576, '2.130.10.10-FF-004992', NULL, 'Uncharacterized protein', 316, NULL, NULL, 38576),
(38577, '3.30.70.330-FF-001314', NULL, 'Ribosomal protein L23, putative', 131, NULL, NULL, 38577),
(38578, '2.60.120.200-FF-000247', NULL, 'Agrin', 176, NULL, NULL, 38578),
(38579, '3.40.50.300-FF-007656', NULL, 'Uncharacterized protein', 129, NULL, NULL, 38579),
(38580, '2.30.180.10-FF-000108', NULL, NULL, 169, NULL, NULL, 38580),
(38581, '3.50.30.30-FF-000144', NULL, 'Predicted protein', 102, NULL, NULL, 38581),
(38582, '3.30.497.10-FF-000099', NULL, 'Uncharacterized protein', 198, NULL, NULL, 38582),
(38583, '3.40.50.300-FF-005565', NULL, 'Uncharacterized protein', 242, NULL, NULL, 38583),
(38584, '4.10.320.30-FF-000005', NULL, 'Uncharacterized protein, isoform C', 25, NULL, NULL, 38584),
(38585, '3.20.20.140-FF-000480', NULL, 'Uncharacterized protein', 99, NULL, NULL, 38585),
(38586, '3.30.1360.70-FF-000001', NULL, 'Arginine--tRNA ligase', 106, NULL, NULL, 38586),
(38587, '1.25.10.10-FF-001818', NULL, 'Predicted protein', 148, NULL, NULL, 38587),
(38588, '3.60.40.10-FF-000307', NULL, 'Protein phosphatase 2C-related protein', 272, NULL, NULL, 38588),
(38589, '2.30.29.30-FF-000745', NULL, 'Phosphoinositide phospholipase C', 107, NULL, NULL, 38589),
(38590, '2.60.120.200-FF-000573', NULL, 'Uncharacterized protein', 101, NULL, NULL, 38590),
(38591, '2.10.50.10-FF-000082', NULL, 'Zinc finger domain LSD1 subclass family protein', 64, NULL, NULL, 38591),
(38592, '1.25.10.10-FF-003376', NULL, 'Uncharacterized protein', 152, NULL, NULL, 38592),
(38593, '1.20.120.1080-FF-000016', NULL, 'ATP-dependent RNA helicase A', 101, NULL, NULL, 38593),
(38594, '1.10.10.10-FF-002009', NULL, 'Vacuolar membrane-associated protein IML1', 117, NULL, NULL, 38594),
(38595, '2.60.40.10-FF-005531', NULL, NULL, 56, NULL, NULL, 38595),
(38596, '3.30.70.330-FF-002736', NULL, NULL, 95, NULL, NULL, 38596),
(38597, '1.10.510.10-FF-003493', NULL, NULL, 260, NULL, NULL, 38597),
(38598, '3.50.50.60-FF-000593', NULL, 'Uncharacterized protein', 149, NULL, NULL, 38598);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(38599, '3.30.420.40-FF-000043', NULL, 'glycerol kinase isoform X1', 258, NULL, NULL, 38599),
(38600, '2.80.10.50-FF-000122', NULL, 'Predicted protein', 178, NULL, NULL, 38600),
(38601, '2.60.120.10-FF-000750', NULL, 'Predicted protein', 95, NULL, NULL, 38601),
(38602, '3.40.30.10-FF-000392', NULL, 'Glutathione S-transferase pi 1', 18, NULL, NULL, 38602),
(38603, '3.40.50.720-FF-000672', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', 196, NULL, NULL, 38603),
(38604, '3.40.50.1820-FF-000523', NULL, 'Pimeloyl-[acyl-carrier protein] methyl ester esterase', 244, NULL, NULL, 38604),
(38605, '1.10.510.10-FF-001256', NULL, 'Cell division protein kinase 2 homolog', 201, NULL, NULL, 38605),
(38606, '2.40.50.140-FF-000928', NULL, NULL, 102, NULL, NULL, 38606),
(38607, '3.40.1110.10-FF-000305', NULL, NULL, 183, NULL, NULL, 38607),
(38608, '1.10.486.10-FF-000018', NULL, 'Helicase in mitochondria', 183, NULL, NULL, 38608),
(38609, '3.30.160.60-FF-005744', NULL, NULL, 38, NULL, NULL, 38609),
(38610, '1.20.1150.12-FF-000002', NULL, 'Disulfide isomerase TigA', 96, NULL, NULL, 38610),
(38611, '3.50.50.60-FF-001256', NULL, 'Uncharacterized protein', 112, NULL, NULL, 38611),
(38612, '1.25.50.20-FF-000048', NULL, 'Aminopeptidase', 316, NULL, NULL, 38612),
(38613, '3.40.50.410-FF-000197', NULL, 'Integrin beta', 70, NULL, NULL, 38613),
(38614, '3.30.420.10-FF-000731', NULL, NULL, 182, NULL, NULL, 38614),
(38615, '3.90.320.10-FF-000058', NULL, 'UvrD/REP helicase domain protein, putative', 156, NULL, NULL, 38615),
(38616, '3.50.50.60-FF-000688', NULL, 'NADH-dependent phenylglyoxylate dehydrogenase subunit epsilon', 125, NULL, NULL, 38616),
(38617, '3.80.10.10-FF-000681', NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', 160, NULL, NULL, 38617),
(38618, '3.40.50.2300-FF-001050', NULL, NULL, 140, NULL, NULL, 38618),
(38619, '3.30.70.330-FF-002793', NULL, NULL, 97, NULL, NULL, 38619),
(38620, '2.60.40.10-FF-002030', NULL, 'B-cell receptor CD22', 101, NULL, NULL, 38620),
(38621, '2.60.120.920-FF-000058', NULL, 'E3 ubiquitin-protein ligase TRIM69', 179, NULL, NULL, 38621),
(38622, '1.20.120.1070-FF-000013', NULL, 'Uncharacterized protein', 109, NULL, NULL, 38622),
(38623, '2.60.40.650-FF-000024', NULL, 'Uncharacterized protein', 65, NULL, NULL, 38623),
(38624, '3.80.10.10-FF-001344', NULL, 'Uncharacterized protein', 118, NULL, NULL, 38624),
(38625, '2.130.10.10-FF-001911', NULL, 'RaBConnectin related', 290, NULL, NULL, 38625),
(38626, '1.25.40.10-FF-001854', NULL, 'GD16292', 155, NULL, NULL, 38626),
(38627, '1.25.40.20-FF-001857', NULL, 'Uncharacterized protein', 135, NULL, NULL, 38627),
(38628, '1.10.10.10-FF-000031', NULL, 'Paired box protein Pax-7', 69, NULL, NULL, 38628),
(38629, '3.30.200.20-FF-001712', NULL, 'Ste20-like serine threonine-protein kinase', 34, NULL, NULL, 38629),
(38630, '1.20.1070.10-FF-000538', NULL, 'Vomeronasal type-1 receptor', 213, NULL, NULL, 38630),
(38631, '3.30.160.60-FF-003614', NULL, 'Serendipity beta, isoform B', 89, NULL, NULL, 38631),
(38632, '3.90.550.10-FF-000081', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 384, NULL, NULL, 38632),
(38633, '3.40.50.300-FF-000046', NULL, 'ATP-dependent DNA helicase', 190, NULL, NULL, 38633),
(38634, '2.60.120.10-FF-000536', NULL, '2-hydroxyethylphosphonate dioxygenase', 117, NULL, NULL, 38634),
(38635, '3.40.30.10-FF-000178', NULL, 'glutaredoxin domain-containing cysteine-rich protein 1', 107, NULL, NULL, 38635),
(38636, '1.10.555.10-FF-000089', NULL, 'Rho GTPase activating protein, putative', 207, NULL, NULL, 38636),
(38637, '1.10.10.10-FF-001228', NULL, 'Topoisomerase, putative', 109, NULL, NULL, 38637),
(38638, '3.30.160.60-FF-005391', NULL, NULL, 25, NULL, NULL, 38638),
(38639, '3.30.1120.10-FF-000016', NULL, 'Arylsulfatase A', 68, NULL, NULL, 38639),
(38640, '1.10.10.10-FF-001346', NULL, 'Vacuolar proteinsorting--associated protein, putative', 72, NULL, NULL, 38640),
(38641, '3.40.50.720-FF-000397', NULL, 'UDP-galactopyranose mutase', 142, NULL, NULL, 38641),
(38642, '1.25.10.10-FF-001465', NULL, 'Serine/threonine-protein kinase TOR', 444, NULL, NULL, 38642);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(38643, '3.30.710.10-FF-000326', NULL, 'SKN-1 Dependent Zygotic transcript', 152, NULL, NULL, 38643),
(38644, '1.10.8.10-FF-000075', NULL, 'Ubiquitin carboxyl-terminal hydrolase 24', 45, NULL, NULL, 38644),
(38645, '1.25.40.180-FF-000169', NULL, NULL, 195, NULL, NULL, 38645),
(38646, '3.40.50.1360-FF-000014', NULL, 'Ribose 5-phosphate isomerase', 134, NULL, NULL, 38646),
(38647, '3.30.420.10-FF-000343', NULL, 'Poly(A)-specific ribonuclease PARN', 230, NULL, NULL, 38647),
(38648, '3.30.40.10-FF-000943', NULL, 'V(D)J recombination-activating protein 1 isoform X2', 109, NULL, NULL, 38648),
(38649, '2.10.220.10-FF-000033', NULL, 'Proprotein convertase subtilisin/kexin type 5', 100, NULL, NULL, 38649),
(38650, '1.20.920.20-FF-000057', NULL, 'Predicted protein', 217, NULL, NULL, 38650),
(38651, '3.30.70.330-FF-001601', NULL, 'DAZ protein 1', 121, NULL, NULL, 38651),
(38652, '1.20.5.340-FF-000103', NULL, 'Uncharacterized protein', 115, NULL, NULL, 38652),
(38653, '3.40.50.150-FF-000130', NULL, 'Alkylated DNA repair protein alkB homolog 8', 213, NULL, NULL, 38653),
(38654, '3.80.10.10-FF-002704', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 49, NULL, NULL, 38654),
(38655, '3.40.50.10190-FF-000088', NULL, 'Chitin biosynthesis protein (Chs5), putative', 136, NULL, NULL, 38655),
(38656, '3.30.450.20-FF-000505', NULL, 'Histidine kinase', 118, NULL, NULL, 38656),
(38657, '3.60.20.10-FF-000019', NULL, 'Proteasome subunit alpha type', 241, NULL, NULL, 38657),
(38658, '3.10.390.10-FF-000007', NULL, 'Deformed epidermal autoregulatory factor 1', 94, NULL, NULL, 38658),
(38659, '2.130.10.10-FF-005267', NULL, 'Uncharacterized protein', 256, NULL, NULL, 38659),
(38660, '2.60.40.60-FF-000959', NULL, 'Uncharacterized protein', 92, NULL, NULL, 38660),
(38661, '1.25.40.10-FF-005244', NULL, 'Serine/threonine-protein kinase TOR', 168, NULL, NULL, 38661),
(38662, '1.20.920.10-FF-000054', NULL, 'Zinc finger MYND-type containing 11', 83, NULL, NULL, 38662),
(38663, '1.10.600.10-FF-000066', NULL, 'Presilphiperfolan-8-beta-ol synthase', 331, NULL, NULL, 38663),
(38664, '3.40.50.2300-FF-001403', NULL, NULL, 127, NULL, NULL, 38664),
(38665, '2.60.40.10-FF-004160', NULL, NULL, 89, NULL, NULL, 38665),
(38666, '3.30.70.330-FF-002950', NULL, NULL, 108, NULL, NULL, 38666),
(38667, '1.10.287.1240-FF-000004', NULL, 'Exodeoxyribonuclease I', 61, NULL, NULL, 38667),
(38668, '2.60.40.150-FF-000700', NULL, 'Uncharacterized protein', 148, NULL, NULL, 38668),
(38669, '3.40.50.10190-FF-000155', NULL, 'Os05g0486600 protein', 120, NULL, NULL, 38669),
(38670, '1.25.40.20-FF-000334', NULL, 'S-acyltransferase', 109, NULL, NULL, 38670),
(38671, '2.10.25.10-FF-000254', NULL, 'Pro-epidermal growth factor', 49, NULL, NULL, 38671),
(38672, '2.30.31.10-FF-000003', NULL, 'SUB1p Transcriptional coactivator', 67, NULL, NULL, 38672),
(38673, '3.20.20.80-FF-000547', NULL, 'Predicted protein', 342, NULL, NULL, 38673),
(38674, '3.40.1190.20-FF-000167', NULL, NULL, 130, NULL, NULL, 38674),
(38675, '1.10.8.10-FF-000311', NULL, 'Predicted protein', 61, NULL, NULL, 38675),
(38676, '1.25.40.10-FF-000331', NULL, 'dynein assembly factor 4, axonemal isoform X2', 96, NULL, NULL, 38676),
(38677, '1.20.58.830-FF-000036', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 136, NULL, NULL, 38677),
(38678, '3.30.420.610-FF-000011', NULL, 'tudor domain-containing protein 5 isoform X3', 72, NULL, NULL, 38678),
(38679, '2.102.10.10-FF-000042', NULL, 'Terephthalate 1,2-dioxygenase oxygenase large subunit', 130, NULL, NULL, 38679),
(38680, '3.40.50.10090-FF-000064', NULL, 'Uroporphyrin-III C-methyltransferase', 96, NULL, NULL, 38680),
(38681, '1.25.40.1040-FF-000003', NULL, 'N-terminal acetyltransferase A, auxiliary subunit', 496, NULL, NULL, 38681),
(38682, '1.20.120.350-FF-000105', NULL, 'CRE-KVS-1 protein', 175, NULL, NULL, 38682),
(38683, '3.40.50.720-FF-002583', NULL, 'Lysine-ketoglutarate reductase/saccharopine dehydrogenase bifunctional enzyme', 17, NULL, NULL, 38683),
(38684, '3.10.20.710-FF-000006', NULL, 'DNA-binding protein SATB', 67, NULL, NULL, 38684); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(38685, '3.40.50.10330-FF-000068', NULL, 'NAD kinase', 70, NULL, NULL, 38685),
(38686, '3.90.1200.10-FF-000048', NULL, 'Spore coat protein CotS', 234, NULL, NULL, 38686),
(38687, '3.40.50.2300-FF-001460', NULL, NULL, 239, NULL, NULL, 38687),
(38688, '2.40.20.10-FF-000011', NULL, 'Plasminogen', 93, NULL, NULL, 38688),
(38689, '3.40.50.10090-FF-000007', NULL, 'Uroporphyrinogen-III synthase', 105, NULL, NULL, 38689),
(38690, '1.10.510.10-FF-003555', NULL, NULL, 227, NULL, NULL, 38690),
(38691, '1.20.1160.20-FF-000014', NULL, 'Uncharacterized protein', 94, NULL, NULL, 38691),
(38692, '1.20.1070.10-FF-000690', NULL, 'Putative allatostatin B receptor', 352, NULL, NULL, 38692),
(38693, '1.10.10.60-FF-001215', NULL, NULL, 79, NULL, NULL, 38693),
(38694, '2.60.40.10-FF-001248', NULL, 'Matrix remodeling associated 5', 90, NULL, NULL, 38694),
(38695, '3.30.40.10-FF-000882', NULL, 'E3 ubiquitin-protein ligase RMA3', 122, NULL, NULL, 38695),
(38696, '3.30.540.30-FF-000004', NULL, 'Dipeptidyl peptidase 3', 94, NULL, NULL, 38696),
(38697, '1.20.120.350-FF-000217', NULL, NULL, 99, NULL, NULL, 38697),
(38698, '2.130.10.10-FF-004784', NULL, 'Uncharacterized protein', 151, NULL, NULL, 38698),
(38699, '1.20.58.60-FF-000419', NULL, 'Myosin light chain kinase, smooth muscle', 126, NULL, NULL, 38699),
(38700, '3.60.21.10-FF-000033', NULL, 'Tartrate-resistant acid phosphatase type 5', 305, NULL, NULL, 38700),
(38701, '2.60.220.50-FF-000067', NULL, 'Uncharacterized protein', 154, NULL, NULL, 38701),
(38702, '3.30.200.20-FF-001066', NULL, 'Receptor protein serine/threonine kinase', 78, NULL, NULL, 38702),
(38703, '1.50.40.10-FF-000155', NULL, 'Solute carrier family 25 member 4', 202, NULL, NULL, 38703),
(38704, '1.10.510.10-FF-003673', NULL, NULL, 174, NULL, NULL, 38704),
(38705, '2.40.50.1070-FF-000012', NULL, 'RNA m5u methyltransferase', 161, NULL, NULL, 38705),
(38706, '3.30.160.60-FF-005952', NULL, NULL, 35, NULL, NULL, 38706),
(38707, '1.20.5.110-FF-000326', NULL, 'Predicted protein', 104, NULL, NULL, 38707),
(38708, '1.10.287.920-FF-000008', NULL, 'Pheromone P-factor receptor', 81, NULL, NULL, 38708),
(38709, '2.10.25.10-FF-001243', NULL, 'Delta-like protein', 44, NULL, NULL, 38709),
(38710, '3.40.50.10070-FF-000001', NULL, 'Tol-Pal system protein TolB', 143, NULL, NULL, 38710),
(38711, '3.40.50.300-FF-005953', NULL, 'DNA mismatch repair protein MSH3', 243, NULL, NULL, 38711),
(38712, '1.10.10.10-FF-000211', NULL, 'Regulatory factor X, 6', 76, NULL, NULL, 38712),
(38713, '1.25.40.10-FF-002989', NULL, 'Pentatricopeptide repeat-containing protein At3g42630', 142, NULL, NULL, 38713),
(38714, '3.30.930.10-FF-000308', NULL, 'Seryl-tRNA synthetase, putative', 63, NULL, NULL, 38714),
(38715, '1.20.5.350-FF-000011', NULL, 'Troponin I body wall-embryo/larva muscle isoform', 128, NULL, NULL, 38715),
(38716, '2.30.30.490-FF-000043', NULL, 'Predicted protein', 132, NULL, NULL, 38716),
(38717, '3.40.50.300-FF-005801', NULL, 'DNA helicase RepD', 40, NULL, NULL, 38717),
(38718, '3.30.40.10-FF-000668', NULL, 'E3 ubiquitin-protein ligase', 50, NULL, NULL, 38718),
(38719, '1.20.1070.10-FF-000358', NULL, 'Olfactory receptor', 288, NULL, NULL, 38719),
(38720, '1.20.1250.20-FF-000459', NULL, 'Major facilitator superfamily domain containing 4A', 163, NULL, NULL, 38720),
(38721, '1.10.287.70-FF-000731', NULL, 'Uncharacterized protein', 119, NULL, NULL, 38721),
(38722, '3.30.70.330-FF-001039', NULL, 'Putative RNA-binding protein', 103, NULL, NULL, 38722),
(38723, '3.40.630.30-FF-000380', NULL, 'GNAT family N-acetyltransferase', 158, NULL, NULL, 38723),
(38724, '3.40.30.10-FF-000116', NULL, 'Thiol:disulfide interchange protein DsbD', 126, NULL, NULL, 38724),
(38725, '3.90.850.10-FF-000025', NULL, '5-oxo-1,2,5-tricarboxilic-3-penten aciddecarboxilase/isomer', 301, NULL, NULL, 38725),
(38726, '3.40.50.12780-FF-000073', NULL, 'Putative long-chain-fatty-acid--CoA ligase', 411, NULL, NULL, 38726),
(38727, '1.25.40.20-FF-000452', NULL, 'ankyrin repeat domain-containing protein 17 isoform X4', 123, NULL, NULL, 38727),
(38728, '1.10.510.10-FF-000121', NULL, 'Serine/threonine-protein kinase nrc-2', 197, NULL, NULL, 38728);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(38729, '1.10.437.10-FF-000040', NULL, 'Apoptosis regulator R11', 182, NULL, NULL, 38729),
(38730, '1.20.1280.50-FF-000094', NULL, 'F-box and leucine-rich repeat protein 18', 51, NULL, NULL, 38730),
(38731, '2.60.40.10-FF-001984', NULL, 'Hemicentin 2', 88, NULL, NULL, 38731),
(38732, '2.60.40.10-FF-005295', NULL, NULL, 82, NULL, NULL, 38732),
(38733, '1.25.40.20-FF-001649', NULL, 'NAD-dependent deacetylase sir2B', 252, NULL, NULL, 38733),
(38734, '1.10.510.10-FF-001464', NULL, 'Uncharacterized protein', 122, NULL, NULL, 38734),
(38735, '2.30.39.10-FF-000026', NULL, 'Serpin 38F, isoform A', 152, NULL, NULL, 38735),
(38736, '1.25.10.10-FF-001931', NULL, 'ELMO domain-containing protein A', 285, NULL, NULL, 38736),
(38737, '3.30.1520.10-FF-000064', NULL, 'Blast:Sorting nexin-16', 121, NULL, NULL, 38737),
(38738, '1.25.40.180-FF-000170', NULL, 'YALI0A13101p', 305, NULL, NULL, 38738),
(38739, '2.20.100.10-FF-000095', NULL, 'Circumsporozoite protein', 78, NULL, NULL, 38739),
(38740, '3.90.176.10-FF-000008', NULL, 'Lethal factor', 108, NULL, NULL, 38740),
(38741, '2.30.30.140-FF-000146', NULL, 'Ubiquitin like with PHD and ring finger domains 2', 85, NULL, NULL, 38741),
(38742, '3.30.40.10-FF-000825', NULL, 'Protein CBG07640', 69, NULL, NULL, 38742),
(38743, '1.25.10.10-FF-001408', NULL, 'Integrator complex subunit 4', 160, NULL, NULL, 38743),
(38744, '2.130.10.10-FF-001226', NULL, 'WD repeat-containing protein-like protein', 172, NULL, NULL, 38744),
(38745, '3.40.190.10-FF-000547', NULL, 'ABC transporter permease protein', 153, NULL, NULL, 38745),
(38746, '2.20.25.10-FF-000102', NULL, 'DNA-directed RNA polymerase subunit', 43, NULL, NULL, 38746),
(38747, '3.40.50.300-FF-002075', NULL, 'Probable RSR1-GTP-binding protein', 167, NULL, NULL, 38747),
(38748, '2.60.40.790-FF-000100', NULL, 'ATP binding protein', 72, NULL, NULL, 38748),
(38749, '1.20.1270.60-FF-000332', NULL, 'Predicted protein', 227, NULL, NULL, 38749),
(38750, '3.40.50.1820-FF-001074', NULL, 'Uncharacterized protein', 270, NULL, NULL, 38750),
(38751, '3.80.10.10-FF-002980', NULL, 'Uncharacterized protein', 97, NULL, NULL, 38751),
(38752, '1.25.40.10-FF-001646', NULL, 'Transcription factor tau subunit sfc4', 182, NULL, NULL, 38752),
(38753, '3.40.50.150-FF-000208', NULL, '2-methoxy-6-polyprenyl-1,4-benzoquinol methylase, mitochondrial', 228, NULL, NULL, 38753),
(38754, '2.60.40.10-FF-005520', NULL, NULL, 73, NULL, NULL, 38754),
(38755, '2.130.10.10-FF-000208', NULL, 'dmX-like protein 1 isoform X1', 236, NULL, NULL, 38755),
(38756, '3.40.50.300-FF-007246', NULL, 'Uncharacterized protein', 160, NULL, NULL, 38756),
(38757, '2.130.10.10-FF-001018', NULL, 'Transducin/WD40 repeat-like superfamily protein', 211, NULL, NULL, 38757),
(38758, '1.20.5.1190-FF-000002', NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily A member', 33, NULL, NULL, 38758),
(38759, '1.10.510.10-FF-003616', NULL, NULL, 197, NULL, NULL, 38759),
(38760, '1.10.2000.10-FF-000036', NULL, 'Frizzled-3', 125, NULL, NULL, 38760),
(38761, '2.60.40.10-FF-002029', NULL, 'Predicted protein', 78, NULL, NULL, 38761),
(38762, '3.30.200.20-FF-001920', NULL, 'Non-specific serine/threonine protein kinase', 62, NULL, NULL, 38762),
(38763, '3.30.410.40-FF-000003', NULL, '(R)-mandelonitrile lyase 2', 181, NULL, NULL, 38763),
(38764, '3.30.160.60-FF-005469', NULL, NULL, 65, NULL, NULL, 38764),
(38765, '3.40.50.720-FF-002549', NULL, 'Siroheme biosynthesis protein met8', 68, NULL, NULL, 38765),
(38766, '1.25.40.20-FF-000014', NULL, 'ankyrin repeat domain-containing protein 17 isoform X2', 64, NULL, NULL, 38766),
(38767, '1.20.1290.10-FF-000015', NULL, 'Uncharacterized protein C17D11.03c', 203, NULL, NULL, 38767),
(38768, '2.40.30.10-FF-000130', NULL, 'Bifunctional cytochrome P450/NADPH--P450 reductase', 105, NULL, NULL, 38768),
(38769, '3.30.2320.80-FF-000007', NULL, 'Hydrogenase maturation factor HypA', 112, NULL, NULL, 38769),
(38770, '1.20.1270.60-FF-000214', NULL, 'GRAF', 49, NULL, NULL, 38770),
(38771, '2.60.40.1730-FF-000115', NULL, NULL, 88, NULL, NULL, 38771);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(38772, '2.60.120.620-FF-000120', NULL, 'Predicted protein', 136, NULL, NULL, 38772),
(38773, '3.30.930.10-FF-000101', NULL, 'Lipoate-protein ligase A subunit 1', 257, NULL, NULL, 38773),
(38774, '3.30.1370.210-FF-000006', NULL, 'Zinc finger CCCH domain-containing protein 10', 46, NULL, NULL, 38774),
(38775, '1.25.40.10-FF-001293', NULL, 'Tetratricopeptide repeat-containing protein', 312, NULL, NULL, 38775),
(38776, '3.30.70.240-FF-000040', NULL, 'Elongation factor 2', 78, NULL, NULL, 38776),
(38777, '1.20.870.10-FF-000004', NULL, 'Ras-specific guanine nucleotide-releasing factor 1 isoform 2', 95, NULL, NULL, 38777),
(38778, '3.30.1470.10-FF-000003', NULL, 'Uncharacterized protein', 104, NULL, NULL, 38778),
(38779, '2.60.40.10-FF-003665', NULL, NULL, 106, NULL, NULL, 38779),
(38780, '3.40.50.300-FF-007544', NULL, 'Uncharacterized protein', 200, NULL, NULL, 38780),
(38781, '2.30.29.30-FF-000824', NULL, 'Ran-specific GTPase-activating protein', 146, NULL, NULL, 38781),
(38782, '2.30.30.380-FF-000010', NULL, 'MDM4 isoform 3', 44, NULL, NULL, 38782),
(38783, '3.40.50.720-FF-002263', NULL, 'Uncharacterized protein', 48, NULL, NULL, 38783),
(38784, '3.30.300.150-FF-000010', NULL, NULL, 119, NULL, NULL, 38784),
(38785, '1.10.10.1210-FF-000005', NULL, 'MAGE', 127, NULL, NULL, 38785),
(38786, '1.25.40.10-FF-001236', NULL, 'Pentatricopeptide repeat-containing protein At3g28660', 210, NULL, NULL, 38786),
(38787, '1.25.40.20-FF-001239', NULL, 'Uncharacterized protein', 254, NULL, NULL, 38787),
(38788, '3.40.1170.10-FF-000017', NULL, 'Mismatch repair protein', 147, NULL, NULL, 38788),
(38789, '1.25.40.10-FF-000011', NULL, 'lysine-specific demethylase 6A isoform X3', 192, NULL, NULL, 38789),
(38790, '1.20.950.20-FF-000008', NULL, 'Cytochrome B561', 84, NULL, NULL, 38790),
(38791, '1.10.555.10-FF-000090', NULL, 'T-cell activation Rho GTPase activating protein, putative', 205, NULL, NULL, 38791),
(38792, '1.10.520.10-FF-000065', NULL, 'Peroxidase', 55, NULL, NULL, 38792),
(38793, '3.30.40.10-FF-002293', NULL, 'Translation elongation factor EF1A/initiation factor IF2gamma family protein', 35, NULL, NULL, 38793),
(38794, '3.30.420.40-FF-000161', NULL, 'L-fuculokinase', 223, NULL, NULL, 38794),
(38795, '2.100.10.50-FF-000008', NULL, 'Predicted protein', 131, NULL, NULL, 38795),
(38796, '2.60.40.10-FF-001366', NULL, 'Nectin cell adhesion molecule 1a', 94, NULL, NULL, 38796),
(38797, '3.30.1300.30-FF-000008', NULL, 'General secretion pathway protein I', 85, NULL, NULL, 38797),
(38798, '3.40.50.300-FF-006021', NULL, 'Ras-like GTP-binding protein RhoL', 166, NULL, NULL, 38798),
(38799, '2.130.10.10-FF-003974', NULL, 'Uncharacterized protein', 236, NULL, NULL, 38799),
(38800, '1.20.1070.10-FF-000858', NULL, 'Uncharacterized protein', 263, NULL, NULL, 38800),
(38801, '1.10.238.20-FF-000024', NULL, 'Odorant-binding protein 56b', 112, NULL, NULL, 38801),
(38802, '1.10.10.1200-FF-000002', NULL, 'MAGE family member A11', 112, NULL, NULL, 38802),
(38803, '1.20.1740.10-FF-000157', NULL, 'YALI0B20064p', 473, NULL, NULL, 38803),
(38804, '3.40.50.1820-FF-000843', NULL, 'Predicted protein', 196, NULL, NULL, 38804),
(38805, '2.60.40.10-FF-005795', NULL, NULL, 83, NULL, NULL, 38805),
(38806, '2.130.10.10-FF-004250', NULL, 'Histone transcription regulator, putative', 139, NULL, NULL, 38806),
(38807, '2.30.300.10-FF-000001', NULL, 'Mu phage baseplate assembly protein GpP', 164, NULL, NULL, 38807),
(38808, '3.15.20.10-FF-000011', NULL, 'BPI fold containing family C, like', 268, NULL, NULL, 38808),
(38809, '3.20.20.140-FF-000266', NULL, 'Uncharacterized protein MJ0699', 68, NULL, NULL, 38809),
(38810, '3.30.40.10-FF-000589', NULL, 'RING/U-box superfamily protein', 80, NULL, NULL, 38810),
(38811, '3.75.10.10-FF-000019', NULL, 'Related to l-arginine:lysine amidinotransferase', 379, NULL, NULL, 38811),
(38812, '2.10.25.30-FF-000001', NULL, 'Tryptophan aminotransferase-related protein 1', 62, NULL, NULL, 38812),
(38813, '3.10.105.10-FF-000104', NULL, 'Peptide ABC transporter, peptide-binding protein', 248, NULL, NULL, 38813),
(38814, '2.100.10.30-FF-000002', NULL, 'Zymogen granule membrane protein 16', 140, NULL, NULL, 38814);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(38815, '3.60.20.10-FF-000076', NULL, 'Proteasome subunit beta', 209, NULL, NULL, 38815),
(38816, '1.10.510.10-FF-001817', NULL, 'Uncharacterized protein', 270, NULL, NULL, 38816),
(38817, '2.60.40.10-FF-006071', NULL, NULL, 93, NULL, NULL, 38817),
(38818, '3.30.70.2850-FF-000003', NULL, 'DNA-directed RNA polymerase subunit', 240, NULL, NULL, 38818),
(38819, '1.25.40.470-FF-000054', NULL, 'Protein CBR-IFTA-1', 209, NULL, NULL, 38819),
(38820, '4.10.1000.10-FF-000051', NULL, 'Cleavage and polyadenylation specificity factor 30 kDa subunit', 62, NULL, NULL, 38820),
(38821, '1.10.10.10-FF-001285', NULL, 'Bacterial regulatory, arsR family protein', 86, NULL, NULL, 38821),
(38822, '1.10.238.10-FF-000021', NULL, 'Mitochondrial Rho GTPase', 196, NULL, NULL, 38822),
(38823, '2.10.25.10-FF-001035', NULL, 'Crumbs', 39, NULL, NULL, 38823),
(38824, '1.10.506.10-FF-000009', NULL, 'GTPase-activating protein and VPS9 domain-containing protein 1 isoform X1', 362, NULL, NULL, 38824),
(38825, '3.40.33.10-FF-000095', NULL, 'Uncharacterized protein', 158, NULL, NULL, 38825),
(38826, '1.10.287.70-FF-000377', NULL, 'Potassium intermediate/small conductance calcium-activated channel, subfamily N, member 4', 233, NULL, NULL, 38826),
(38827, '3.80.10.10-FF-000563', NULL, 'Capricious, isoform D', 173, NULL, NULL, 38827),
(38828, '1.10.510.10-FF-002150', NULL, NULL, 125, NULL, NULL, 38828),
(38829, '1.25.40.20-FF-001469', NULL, 'Uncharacterized protein', 106, NULL, NULL, 38829),
(38830, '3.30.70.980-FF-000025', NULL, 'Probable transcriptional regulatory protein VCRC385_02559', 72, NULL, NULL, 38830),
(38831, '2.60.120.290-FF-000055', NULL, 'Dorsal-ventral patterning protein tolloid', 140, NULL, NULL, 38831),
(38832, '2.40.50.140-FF-001143', NULL, NULL, 158, NULL, NULL, 38832),
(38833, '3.30.1340.30-FF-000005', NULL, 'Putative signal peptide protein', 69, NULL, NULL, 38833),
(38834, '1.10.3450.20-FF-000005', NULL, 'Nuclear pore complex protein', 149, NULL, NULL, 38834),
(38835, '1.10.3210.10-FF-000018', NULL, 'Two-component system response regulator', 198, NULL, NULL, 38835),
(38836, '2.40.50.140-FF-000867', NULL, NULL, 113, NULL, NULL, 38836),
(38837, '3.80.10.10-FF-002772', NULL, 'Si:ch211-278p9.1', 135, NULL, NULL, 38837),
(38838, '2.40.50.140-FF-001182', NULL, NULL, 85, NULL, NULL, 38838),
(38839, '3.80.10.10-FF-002715', NULL, 'Putative leucine-rich repeat receptor-like serine/threonine-protein kinase', 102, NULL, NULL, 38839),
(38840, '2.80.10.50-FF-000111', NULL, 'Ryanodine receptor 2b (cardiac)', 178, NULL, NULL, 38840),
(38841, '3.90.640.10-FF-000043', NULL, 'AGAP008687-PA-like protein', 113, NULL, NULL, 38841),
(38842, '3.30.160.60-FF-003671', NULL, 'Zinc finger protein 527', 35, NULL, NULL, 38842),
(38843, '1.10.10.60-FF-001007', NULL, NULL, 53, NULL, NULL, 38843),
(38844, '1.10.238.10-FF-000100', NULL, 'Calmodulin 1', 50, NULL, NULL, 38844),
(38845, '3.40.190.10-FF-000755', NULL, 'Glutamate receptor 2.6', 72, NULL, NULL, 38845),
(38846, '2.60.220.30-FF-000022', NULL, 'Ankyrin-3', 134, NULL, NULL, 38846),
(38847, '1.10.240.10-FF-000015', NULL, 'Tryptophan--tRNA ligase, mitochondrial', 111, NULL, NULL, 38847),
(38848, '3.30.1380.20-FF-000010', NULL, 'Trafficking protein particle complex subunit', 175, NULL, NULL, 38848),
(38849, '1.25.10.10-FF-001695', NULL, 'ARM repeat superfamily protein', 271, NULL, NULL, 38849),
(38850, '1.20.58.60-FF-000796', NULL, 'Spectrin beta, non-erythrocytic 5', 209, NULL, NULL, 38850),
(38851, '3.40.50.1820-FF-000169', NULL, 'Yersiniabactin biosynthesis thioesterase YbtT', 237, NULL, NULL, 38851),
(38852, '3.50.30.30-FF-000133', NULL, 'Uncharacterized RING finger protein C57A7.09', 150, NULL, NULL, 38852),
(38853, '1.20.58.390-FF-000191', NULL, 'Predicted protein', 115, NULL, NULL, 38853),
(38854, '3.40.50.450-FF-000063', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit beta 2', 31, NULL, NULL, 38854),
(38855, '3.30.559.30-FF-000030', NULL, 'Hydroxamate-type ferrichrome siderophore peptide synthetase', 249, NULL, NULL, 38855),
(38856, '3.40.50.970-FF-000067', NULL, '2-hydroxyacyl-CoA lyase 1', 177, NULL, NULL, 38856);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(38857, '1.20.1730.10-FF-000033', NULL, 'Urea transporter or sodium transporter', 500, NULL, NULL, 38857),
(38858, '2.40.30.10-FF-000017', NULL, 'Eukaryotic peptide chain release factor GTP-binding subunit', 109, NULL, NULL, 38858),
(38859, '3.30.70.3400-FF-000011', NULL, 'Protein translocase subunit SecD', 83, NULL, NULL, 38859),
(38860, '1.10.1520.10-FF-000098', NULL, 'Predicted protein', 132, NULL, NULL, 38860),
(38861, '1.10.630.10-FF-000455', NULL, 'Uncharacterized protein', 285, NULL, NULL, 38861),
(38862, '3.30.1430.10-FF-000006', NULL, 'LSU ribosomal protein L3P', 122, NULL, NULL, 38862),
(38863, '3.30.160.60-FF-002254', NULL, 'Zinc finger protein 540', 38, NULL, NULL, 38863),
(38864, '3.60.10.10-FF-000277', NULL, 'Protein translocase subunit SECA1 chloroplastic', 144, NULL, NULL, 38864),
(38865, '1.10.3880.10-FF-000001', NULL, 'Probable Fe(2+)-trafficking protein', 91, NULL, NULL, 38865),
(38866, '2.30.30.140-FF-000135', NULL, 'Metal-response element-binding transcription factor', 68, NULL, NULL, 38866),
(38867, '3.80.10.10-FF-000849', NULL, 'F-box and leucine-rich repeat protein 6', 109, NULL, NULL, 38867),
(38868, '2.60.40.10-FF-000231', NULL, 'Sidekick cell adhesion molecule 2', 109, NULL, NULL, 38868),
(38869, '1.20.1070.10-FF-001353', NULL, 'Predicted protein', 333, NULL, NULL, 38869),
(38870, '1.10.510.10-FF-001874', NULL, 'Differentiation inhibitory kinase', 193, NULL, NULL, 38870),
(38871, '3.40.50.300-FF-007864', NULL, 'Uncharacterized protein', 210, NULL, NULL, 38871),
(38872, '1.20.1250.20-FF-000229', NULL, 'Major facilitator superfamily domain-containing protein 6', 195, NULL, NULL, 38872),
(38873, '2.130.10.10-FF-003356', NULL, 'Uncharacterized protein', 128, NULL, NULL, 38873),
(38874, '3.30.60.30-FF-000074', NULL, 'Serine protease inhibitor Kazal-type 5-like', 52, NULL, NULL, 38874),
(38875, '2.130.10.10-FF-001636', NULL, 'Putative small nucleolar ribonucleoprotein complex protein', 324, NULL, NULL, 38875),
(38876, '3.40.50.620-FF-000193', NULL, 'Cryptochrome 1', 159, NULL, NULL, 38876),
(38877, '1.10.287.70-FF-000091', NULL, 'Sodium channel protein', 134, NULL, NULL, 38877),
(38878, '3.40.50.1110-FF-000164', NULL, 'Alpha-galactosidase', 266, NULL, NULL, 38878),
(38879, '3.30.230.10-FF-000396', NULL, 'AFR031Cp', 173, NULL, NULL, 38879),
(38880, '3.30.200.20-FF-001302', NULL, 'interleukin-1 receptor-associated kinase 4', 112, NULL, NULL, 38880),
(38881, '2.20.100.10-FF-000218', NULL, 'kielin/chordin-like protein', 58, NULL, NULL, 38881),
(38882, '1.10.533.10-FF-000252', NULL, 'Uncharacterized protein', 95, NULL, NULL, 38882),
(38883, '1.20.1110.10-FF-000121', NULL, NULL, 75, NULL, NULL, 38883),
(38884, '1.25.40.10-FF-003445', NULL, 'Putative pentatricopeptide repeat-containing protein At1g13800', 147, NULL, NULL, 38884),
(38885, '1.20.1560.10-FF-000446', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 370, NULL, NULL, 38885),
(38886, '1.10.490.10-FF-000028', NULL, 'Adenylate cyclase-like protein', 142, NULL, NULL, 38886),
(38887, '2.10.25.10-FF-000243', NULL, 'Adhesion G protein-coupled receptor E1', 49, NULL, NULL, 38887),
(38888, '3.40.50.300-FF-003536', NULL, 'Rab_A63 protein', 200, NULL, NULL, 38888),
(38889, '3.40.50.800-FF-000044', NULL, 'Threonine--tRNA ligase', 104, NULL, NULL, 38889),
(38890, '3.30.160.60-FF-003878', NULL, NULL, 25, NULL, NULL, 38890),
(38891, '3.30.160.60-FF-003592', NULL, 'LD46263p', 59, NULL, NULL, 38891),
(38892, '3.50.50.60-FF-001374', NULL, 'LD25803p', 61, NULL, NULL, 38892),
(38893, '3.40.50.360-FF-000103', NULL, 'Glutathione-regulated potassium-efflux system ancillary protein KefG', 200, NULL, NULL, 38893),
(38894, '2.60.98.10-FF-000009', NULL, 'Structural polyprotein', 82, NULL, NULL, 38894),
(38895, '3.30.1460.20-FF-000011', NULL, 'Arp2/3 complex 34 kDa subunit', 130, NULL, NULL, 38895),
(38896, '3.40.50.10330-FF-000057', NULL, 'Inorganic polyphosphate/ATP-NAD kinase, putative', 97, NULL, NULL, 38896),
(38897, '1.10.10.60-FF-001283', NULL, NULL, 62, NULL, NULL, 38897),
(38898, '1.20.5.690-FF-000011', NULL, NULL, 43, NULL, NULL, 38898);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(38899, '1.10.287.370-FF-000012', NULL, 'Probable prefoldin subunit 5', 142, NULL, NULL, 38899),
(38900, '2.60.120.10-FF-000250', NULL, 'cGMP-dependent protein kinase, isozyme 2 forms cD4/T1/T3A/T3B-like Protein', 65, NULL, NULL, 38900),
(38901, '2.60.120.200-FF-000455', NULL, 'Laminin, alpha 3', 161, NULL, NULL, 38901),
(38902, '1.20.58.60-FF-000739', NULL, 'Uncharacterized protein', 92, NULL, NULL, 38902),
(38903, '3.40.50.1820-FF-001006', NULL, 'Serine peptidase, putative serine peptidase, Clan SC, Family S9D', 227, NULL, NULL, 38903),
(38904, '3.40.50.1100-FF-000009', NULL, 'Cysteine synthase', 194, NULL, NULL, 38904),
(38905, '2.130.10.10-FF-005508', NULL, 'Uncharacterized protein', 92, NULL, NULL, 38905),
(38906, '2.60.40.10-FF-001546', NULL, 'titin isoform X1', 86, NULL, NULL, 38906),
(38907, '3.60.60.10-FF-000016', NULL, 'Dipeptidase', 147, NULL, NULL, 38907),
(38908, '3.30.1300.10-FF-000002', NULL, 'Pantoate--beta-alanine ligase', 140, NULL, NULL, 38908),
(38909, '3.40.50.620-FF-000754', NULL, 'Uncharacterized protein', 138, NULL, NULL, 38909),
(38910, '1.10.510.10-FF-003993', NULL, NULL, 187, NULL, NULL, 38910),
(38911, '2.10.220.10-FF-000044', NULL, 'Proprotein convertase subtilisin/kexin type 5', 47, NULL, NULL, 38911),
(38912, '3.40.50.150-FF-001844', NULL, NULL, 47, NULL, NULL, 38912),
(38913, '3.30.40.10-FF-001606', NULL, 'Putative tumor necrosis factor receptor-associated factor 2', 108, NULL, NULL, 38913),
(38914, '3.80.10.10-FF-000288', NULL, 'LRR receptor-like serine/threonine-protein kinase EFR', 309, NULL, NULL, 38914),
(38915, '3.40.50.1000-FF-000103', NULL, 'Trehalose 6-phosphate phosphatase', 140, NULL, NULL, 38915),
(38916, '2.20.25.10-FF-000113', NULL, 'DNA-directed RNA polymerase subunit', 52, NULL, NULL, 38916),
(38917, '3.90.190.20-FF-000067', NULL, 'Predicted protein', 106, NULL, NULL, 38917),
(38918, '3.60.10.10-FF-000070', NULL, 'Type IV inositol polyphosphate 5-phosphatase 7', 132, NULL, NULL, 38918),
(38919, '2.30.29.230-FF-000019', NULL, 'TBC1 domain family member 16-like Protein', 96, NULL, NULL, 38919),
(38920, '2.60.220.50-FF-000180', NULL, 'Uncharacterized protein', 241, NULL, NULL, 38920),
(38921, '3.40.50.1820-FF-001063', NULL, 'Esterase-6-like Protein', 545, NULL, NULL, 38921),
(38922, '3.80.10.10-FF-002592', NULL, 'Transmembrane receptors / ATP binding protein', 81, NULL, NULL, 38922),
(38923, '2.130.10.10-FF-001294', NULL, 'Polyadenylation factor I', 85, NULL, NULL, 38923),
(38924, '3.40.50.150-FF-001226', NULL, NULL, 201, NULL, NULL, 38924),
(38925, '1.20.990.10-FF-000002', NULL, 'Nitric oxide synthase', 138, NULL, NULL, 38925),
(38926, '3.30.450.20-FF-000174', NULL, 'BHLH-PAS factor', 126, NULL, NULL, 38926),
(38927, '1.10.287.950-FF-000034', NULL, 'Methyl-accepting chemotaxis protein', 179, NULL, NULL, 38927),
(38928, '1.20.1740.10-FF-000270', NULL, 'Uncharacterized protein', 186, NULL, NULL, 38928),
(38929, '1.10.238.10-FF-000307', NULL, 'Follistatin like 4', 106, NULL, NULL, 38929),
(38930, '3.90.190.10-FF-000064', NULL, 'RNA/RNP complex-1-interacting phosphatase homolog', 190, NULL, NULL, 38930),
(38931, '1.25.10.10-FF-001077', NULL, 'WD domain, G-beta repeat/PFU (PLAA family ubiquitin binding), putative', 269, NULL, NULL, 38931),
(38932, '2.60.40.150-FF-000150', NULL, 'RAS protein activator like 1', 134, NULL, NULL, 38932),
(38933, '2.40.160.120-FF-000011', NULL, 'Oxysterol-binding protein-related protein 4C', 176, NULL, NULL, 38933),
(38934, '1.10.720.30-FF-000047', NULL, 'SAP domain containing protein', 65, NULL, NULL, 38934),
(38935, '1.25.10.10-FF-000503', NULL, 'AP-1 complex subunit gamma', 528, NULL, NULL, 38935),
(38936, '3.30.1360.220-FF-000002', NULL, 'Zinc finger FYVE domain-containing protein', 96, NULL, NULL, 38936),
(38937, '1.20.1250.60-FF-000005', NULL, 'Interferon lambda3', 102, NULL, NULL, 38937),
(38938, '2.60.40.10-FF-003940', NULL, NULL, 105, NULL, NULL, 38938),
(38939, '2.60.40.10-FF-005256', NULL, NULL, 87, NULL, NULL, 38939),
(38940, '3.90.1290.10-FF-000082', NULL, 'Dystonin', 69, NULL, NULL, 38940),
(38941, '3.30.70.330-FF-000376', NULL, 'Putative RNA binding protein', 88, NULL, NULL, 38941);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(38942, '3.40.1110.10-FF-000182', NULL, 'Phospholipid-transporting ATPase', 133, NULL, NULL, 38942),
(38943, '3.30.390.30-FF-000008', NULL, 'Glutathione reductase', 127, NULL, NULL, 38943),
(38944, '1.20.5.170-FF-000266', NULL, 'Uncharacterized protein', 138, NULL, NULL, 38944),
(38945, '2.10.25.10-FF-000754', NULL, 'Predicted protein', 38, NULL, NULL, 38945),
(38946, '3.60.21.10-FF-000370', NULL, 'Serine/threonine-protein phosphatase BSL3', 123, NULL, NULL, 38946),
(38947, '3.30.160.60-FF-005413', NULL, NULL, 41, NULL, NULL, 38947),
(38948, '3.40.47.10-FF-000099', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 3', 149, NULL, NULL, 38948),
(38949, '2.30.30.380-FF-000072', NULL, 'At2g27460', 67, NULL, NULL, 38949),
(38950, '3.10.580.10-FF-000145', NULL, 'Homoserine O-acetyltransferase', 121, NULL, NULL, 38950),
(38951, '3.30.160.60-FF-005357', NULL, NULL, 59, NULL, NULL, 38951),
(38952, '3.20.20.60-FF-000047', NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', 307, NULL, NULL, 38952),
(38953, '2.130.10.10-FF-005891', NULL, 'Probable serine/threonine-protein kinase pats1', 295, NULL, NULL, 38953),
(38954, '1.50.40.10-FF-000216', NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', 307, NULL, NULL, 38954),
(38955, '2.60.40.150-FF-000032', NULL, 'Double c2-like domain-containing', 164, NULL, NULL, 38955),
(38956, '2.30.29.30-FF-000296', NULL, 'Regulator of G protein signaling 12', 141, NULL, NULL, 38956),
(38957, '2.10.25.10-FF-000810', NULL, 'Delta-like 1 isoform B', 36, NULL, NULL, 38957),
(38958, '3.40.50.2000-FF-001027', NULL, 'UDP-N-acetylglucosamine transferase subunit ALG14 homolog-like Protein', 172, NULL, NULL, 38958),
(38959, '3.30.1370.100-FF-000024', NULL, 'DNA mismatch repair protein domain', 100, NULL, NULL, 38959),
(38960, '3.30.1370.110-FF-000027', NULL, 'Nucleolar protein', 90, NULL, NULL, 38960),
(38961, '1.25.40.10-FF-002990', NULL, 'Pentatricopeptide repeat-containing protein', 139, NULL, NULL, 38961),
(38962, '1.10.10.580-FF-000001', NULL, 'double-strand-break repair protein rad21 homolog', 69, NULL, NULL, 38962),
(38963, '3.20.20.70-FF-000106', NULL, 'Deoxyribose-phosphate aldolase', 268, NULL, NULL, 38963),
(38964, '3.80.10.10-FF-003778', NULL, 'Leucine-rich repeat neuronal protein 1-like Protein', 105, NULL, NULL, 38964),
(38965, '3.30.70.1230-FF-000118', NULL, 'Predicted protein', 126, NULL, NULL, 38965),
(38966, '3.90.79.20-FF-000004', NULL, 'NADH pyrophosphatase', 137, NULL, NULL, 38966),
(38967, '1.10.10.1890-FF-000006', NULL, 'Uncharacterized protein', 98, NULL, NULL, 38967),
(38968, '1.10.1070.11-FF-000120', NULL, 'Uncharacterized protein', 170, NULL, NULL, 38968),
(38969, '3.40.50.800-FF-000095', NULL, 'Polymerase (DNA directed), gamma 2, accessory subunit', 106, NULL, NULL, 38969),
(38970, '2.30.42.10-FF-000377', NULL, NULL, 94, NULL, NULL, 38970),
(38971, '3.40.50.300-FF-002524', NULL, 'Dicer-2', 178, NULL, NULL, 38971),
(38972, '2.60.40.10-FF-003726', NULL, NULL, 89, NULL, NULL, 38972),
(38973, '2.40.70.10-FF-000014', NULL, 'Aspartyl protease family protein 1', 166, NULL, NULL, 38973),
(38974, '3.20.20.80-FF-000109', NULL, 'Glucosylceramidase 3', 386, NULL, NULL, 38974),
(38975, '3.30.160.60-FF-003266', NULL, 'Uncharacterized protein', 47, NULL, NULL, 38975),
(38976, '1.10.540.10-FF-000004', NULL, 'Acyl-CoA dehydrogenase', 117, NULL, NULL, 38976),
(38977, '2.40.30.10-FF-000012', NULL, '60S ribosomal protein L3', 173, NULL, NULL, 38977),
(38978, '3.40.1010.10-FF-000011', NULL, 'Ribosomal RNA small subunit methyltransferase I', 122, NULL, NULL, 38978),
(38979, '3.40.50.300-FF-002631', NULL, 'Hypothetical alanine rich protein', 240, NULL, NULL, 38979),
(38980, '1.20.1250.20-FF-002258', NULL, 'Monocarboxylate transporter, putative', 104, NULL, NULL, 38980),
(38981, '2.130.10.10-FF-002125', NULL, 'Protein CBG01041', 147, NULL, NULL, 38981),
(38982, '2.40.30.20-FF-000015', NULL, 'Riboflavin synthase subunit alpha', 104, NULL, NULL, 38982),
(38983, '3.30.70.1430-FF-000004', NULL, 'Multidrug resistance protein MdtC', 94, NULL, NULL, 38983);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(38984, '3.20.10.10-FF-000054', NULL, 'Putative aminodeoxychorismate lyase', 137, NULL, NULL, 38984),
(38985, '3.90.70.10-FF-000420', NULL, 'Uncharacterized protein', 353, NULL, NULL, 38985),
(38986, '3.80.10.10-FF-004391', NULL, 'Predicted protein', 165, NULL, NULL, 38986),
(38987, '3.30.70.100-FF-000138', NULL, NULL, 77, NULL, NULL, 38987),
(38988, '3.40.30.10-FF-000627', NULL, 'Thiol:disulfide interchange protein DsbD', 128, NULL, NULL, 38988),
(38989, '3.30.70.270-FF-000217', NULL, NULL, 100, NULL, NULL, 38989),
(38990, '3.40.50.1980-FF-000020', NULL, 'Iron-uptake system-binding protein', 154, NULL, NULL, 38990),
(38991, '3.30.70.330-FF-001606', NULL, 'Transformer-2 sex-determining protein', 166, NULL, NULL, 38991),
(38992, '3.60.40.10-FF-000015', NULL, 'probable protein phosphatase 2C 60', 300, NULL, NULL, 38992),
(38993, '3.90.550.10-FF-000316', NULL, 'UDP-N-acetylglucosamine pyrophosphorylase putative', 401, NULL, NULL, 38993),
(38994, '3.90.70.10-FF-000313', NULL, 'ABC transporter, ATP-binding protein', 149, NULL, NULL, 38994),
(38995, '3.30.559.10-FF-000198', NULL, 'Uncharacterized protein', 260, NULL, NULL, 38995),
(38996, '3.30.1440.10-FF-000001', NULL, '50S ribosomal protein L5', 179, NULL, NULL, 38996),
(38997, '1.25.40.20-FF-001470', NULL, 'Ankyrin repeat domain 6', 106, NULL, NULL, 38997),
(38998, '1.50.40.10-FF-000267', NULL, 'Uncharacterized protein', 305, NULL, NULL, 38998),
(38999, '2.130.10.10-FF-003704', NULL, 'Cannonball', 169, NULL, NULL, 38999),
(39000, '1.50.40.10-FF-000323', NULL, 'GH22139p', 296, NULL, NULL, 39000),
(39001, '2.60.120.10-FF-000194', NULL, 'Rap guanine nucleotide exchange factor 4', 152, NULL, NULL, 39001),
(39002, '2.60.40.60-FF-001128', NULL, 'Uncharacterized protein', 104, NULL, NULL, 39002),
(39003, '3.40.50.150-FF-001726', NULL, NULL, 185, NULL, NULL, 39003),
(39004, '3.90.1290.10-FF-000031', NULL, 'AGAP011396-PA', 187, NULL, NULL, 39004),
(39005, '3.30.70.1440-FF-000007', NULL, 'Probable RND efflux transporter', 100, NULL, NULL, 39005),
(39006, '1.25.40.420-FF-000062', NULL, 'TD and POZ domain-containing protein 3-like Protein', 75, NULL, NULL, 39006),
(39007, '1.20.1230.10-FF-000017', NULL, 'Phosphoinositide phospholipase C', 248, NULL, NULL, 39007),
(39008, '3.30.40.10-FF-001045', NULL, 'RBR-type E3 ubiquitin transferase', 95, NULL, NULL, 39008),
(39009, '3.40.50.620-FF-000378', NULL, 'Deoxyribodipyrimidine photo-lyase', 166, NULL, NULL, 39009),
(39010, '3.30.70.260-FF-000107', NULL, 'Glycine cleavage system transcriptional antiactivator GcvR', 94, NULL, NULL, 39010),
(39011, '1.20.5.1430-FF-000001', NULL, 'microtubule-associated protein RP/EB family member 1', 82, NULL, NULL, 39011),
(39012, '3.20.20.220-FF-000060', NULL, 'Proline dehydrogenase', 273, NULL, NULL, 39012),
(39013, '2.60.40.1730-FF-000110', NULL, NULL, 119, NULL, NULL, 39013),
(39014, '3.40.50.1460-FF-000095', NULL, 'Caspase 16, apoptosis-related cysteine peptidase', 176, NULL, NULL, 39014),
(39015, '3.30.70.1220-FF-000008', NULL, 'Transcription factor IIH, putative', 70, NULL, NULL, 39015),
(39016, '1.10.640.10-FF-000063', NULL, 'Cyclooxygenase-1', 204, NULL, NULL, 39016),
(39017, '3.30.110.60-FF-000003', NULL, 'CRM-domain containing factor CFM3B, chloroplastic', 103, NULL, NULL, 39017),
(39018, '3.30.200.20-FF-002201', NULL, 'Predicted protein', 49, NULL, NULL, 39018),
(39019, '3.30.40.10-FF-000382', NULL, 'RING-type E3 ubiquitin transferase', 76, NULL, NULL, 39019),
(39020, '1.10.8.60-FF-000242', NULL, 'RuvB-like helicase', 82, NULL, NULL, 39020),
(39021, '1.10.560.10-FF-000062', NULL, 'Uncharacterized protein', 59, NULL, NULL, 39021),
(39022, '3.20.20.60-FF-000103', NULL, 'Uncharacterized protein', 43, NULL, NULL, 39022),
(39023, '3.40.50.620-FF-000485', NULL, 'Leucyl-tRNA synthetase 2, mitochondrial', 64, NULL, NULL, 39023),
(39024, '2.60.40.10-FF-005290', NULL, NULL, 113, NULL, NULL, 39024),
(39025, '3.30.160.60-FF-004160', NULL, NULL, 23, NULL, NULL, 39025),
(39026, '1.20.58.340-FF-000041', NULL, 'Related to MNR2-Manganese resistance protein', 133, NULL, NULL, 39026);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(39027, '3.60.110.10-FF-000088', NULL, NULL, 130, NULL, NULL, 39027),
(39028, '3.40.50.12360-FF-000003', NULL, 'Uncharacterized protein', 293, NULL, NULL, 39028),
(39029, '1.25.40.660-FF-000010', NULL, 'Vacuolar protein sorting 35, putative', 281, NULL, NULL, 39029),
(39030, '3.40.50.720-FF-000964', NULL, '2-dehydropantoate 2-reductase', 166, NULL, NULL, 39030),
(39031, '2.60.120.290-FF-000094', NULL, 'GM21018', 118, NULL, NULL, 39031),
(39032, '3.40.50.150-FF-000422', NULL, 'tRNA (adenine(58)-N(1))-methyltransferase', 244, NULL, NULL, 39032),
(39033, '3.30.300.150-FF-000009', NULL, NULL, 128, NULL, NULL, 39033),
(39034, '3.90.70.80-FF-000076', NULL, 'Uncharacterized protein', 138, NULL, NULL, 39034),
(39035, '3.40.1110.10-FF-000070', NULL, 'Phospholipid-transporting ATPase', 137, NULL, NULL, 39035),
(39036, '3.40.250.10-FF-000237', NULL, 'Zgc:162544 protein', 73, NULL, NULL, 39036),
(39037, '2.30.30.140-FF-000180', NULL, 'G-patch domain and KOW motifs-containing protein', 54, NULL, NULL, 39037),
(39038, '3.30.460.10-FF-000121', NULL, 'DNA-directed DNA/RNA polymerase mu', 147, NULL, NULL, 39038),
(39039, '1.10.287.110-FF-000243', NULL, 'AGAP009787-PA', 73, NULL, NULL, 39039),
(39040, '2.130.10.10-FF-002018', NULL, 'WD-repeat protein, putative', 111, NULL, NULL, 39040),
(39041, '1.25.10.10-FF-001583', NULL, 'Probable importin-7 homolog', 950, NULL, NULL, 39041),
(39042, '3.30.310.130-FF-000011', NULL, 'Ubiquitin-like protease 4', 126, NULL, NULL, 39042),
(39043, '3.30.870.10-FF-000202', NULL, 'Phospholipase', 138, NULL, NULL, 39043),
(39044, '3.40.50.1820-FF-001630', NULL, 'Carboxylic ester hydrolase', 458, NULL, NULL, 39044),
(39045, '1.10.1240.100-FF-000001', NULL, 'Polyketide synthase/nonribosomal peptide synthetase hybrid RzxA', 93, NULL, NULL, 39045),
(39046, '1.10.287.110-FF-000131', NULL, 'Ring-infected erythrocyte surface antigen', 81, NULL, NULL, 39046),
(39047, '3.30.800.10-FF-000035', NULL, NULL, 136, NULL, NULL, 39047),
(39048, '3.40.50.150-FF-000192', NULL, 'NOP2p rRNA m5C methyltransferase', 279, NULL, NULL, 39048),
(39049, '3.30.390.30-FF-000003', NULL, 'Glutathione reductase', 113, NULL, NULL, 39049),
(39050, '1.10.10.750-FF-000018', NULL, 'TBC domaincontaining protein', 46, NULL, NULL, 39050),
(39051, '3.30.420.10-FF-000231', NULL, 'DNA polymerase epsilon catalytic subunit', 200, NULL, NULL, 39051),
(39052, '1.10.10.160-FF-000055', NULL, 'DNA helicase', 75, NULL, NULL, 39052),
(39053, '1.25.40.180-FF-000349', NULL, NULL, 87, NULL, NULL, 39053),
(39054, '1.10.220.10-FF-000020', NULL, 'Annexin A10', 80, NULL, NULL, 39054),
(39055, '1.10.245.10-FF-000004', NULL, 'Upstream activation factor subunit', 89, NULL, NULL, 39055),
(39056, '1.20.5.170-FF-000108', NULL, 'SYNM isoform 4', 82, NULL, NULL, 39056),
(39057, '1.10.287.130-FF-000249', NULL, 'Two-component hybrid sensor and regulator', 87, NULL, NULL, 39057),
(39058, '3.40.50.300-FF-003828', NULL, 'Gtr1/RagA G protein Gtr1', 177, NULL, NULL, 39058),
(39059, '3.10.20.90-FF-000461', NULL, 'Phosphatidylinositol 3-kinase, putative', 177, NULL, NULL, 39059),
(39060, '3.30.70.330-FF-001191', NULL, 'RNA recognition motif domain containing protein', 98, NULL, NULL, 39060),
(39061, '1.25.10.10-FF-001813', NULL, 'Predicted protein', 301, NULL, NULL, 39061),
(39062, '2.30.29.30-FF-000189', NULL, 'Actin filament associated protein 1-like 1', 125, NULL, NULL, 39062),
(39063, '3.30.200.20-FF-001414', NULL, 'GD18431', 84, NULL, NULL, 39063),
(39064, '2.60.120.290-FF-000212', NULL, 'C-type LECtin', 129, NULL, NULL, 39064),
(39065, '1.10.357.70-FF-000034', NULL, 'Exocyst complex component 3-like 2b', 142, NULL, NULL, 39065),
(39066, '1.20.1270.60-FF-000271', NULL, 'Uncharacterized protein', 83, NULL, NULL, 39066),
(39067, '1.10.472.80-FF-000046', NULL, 'TBC domain-containing protein', 144, NULL, NULL, 39067),
(39068, '2.40.50.140-FF-001204', NULL, NULL, 91, NULL, NULL, 39068),
(39069, '3.40.50.300-FF-002305', NULL, 'Elongator subunit', 306, NULL, NULL, 39069),
(39070, '1.25.40.10-FF-003265', NULL, 'Pentatricopeptide repeat-containing protein isoform A', 150, NULL, NULL, 39070);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(39071, '1.10.287.10-FF-000005', NULL, 'ataxin-3 isoform X1', 45, NULL, NULL, 39071),
(39072, '3.40.50.2000-FF-000678', NULL, 'Glycosyltransferase', 197, NULL, NULL, 39072),
(39073, '1.20.120.1900-FF-000032', NULL, 'Spindle pole body component', 309, NULL, NULL, 39073),
(39074, '1.20.58.1610-FF-000016', NULL, NULL, 113, NULL, NULL, 39074),
(39075, '3.30.70.330-FF-002388', NULL, NULL, 98, NULL, NULL, 39075),
(39076, '1.10.287.70-FF-000383', NULL, 'Uncharacterized protein', 282, NULL, NULL, 39076),
(39077, '2.10.220.10-FF-000151', NULL, 'Proprotein convertase subtilisin/kexin type 5', 109, NULL, NULL, 39077),
(39078, '3.20.20.100-FF-000097', NULL, 'Uncharacterized protein', 373, NULL, NULL, 39078),
(39079, '3.40.1360.10-FF-000060', NULL, 'Meiotic recombination protein SPO11, putative', 232, NULL, NULL, 39079),
(39080, '1.20.140.10-FF-000045', NULL, 'Putative acyl-CoA dehydrogenase', 151, NULL, NULL, 39080),
(39081, '3.40.30.10-FF-000734', NULL, '39S ribosomal protein L43, mitochondrial', 135, NULL, NULL, 39081),
(39082, '3.30.360.10-FF-000113', NULL, 'Uncharacterized protein', 153, NULL, NULL, 39082),
(39083, '1.20.120.1910-FF-000035', NULL, 'Cysteine--tRNA ligase', 161, NULL, NULL, 39083),
(39084, '3.40.50.450-FF-000068', NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase', 188, NULL, NULL, 39084),
(39085, '3.30.420.10-FF-000282', NULL, 'Predicted protein', 222, NULL, NULL, 39085),
(39086, '3.60.21.10-FF-000151', NULL, 'Acid sphingomyelinase family phosphodiesterase', 285, NULL, NULL, 39086),
(39087, '3.10.580.10-FF-000196', NULL, 'Cystathionine beta synthase domain protein1', 92, NULL, NULL, 39087),
(39088, '1.10.357.140-FF-000038', NULL, 'Protoheme IX farnesyltransferase', 152, NULL, NULL, 39088),
(39089, '3.40.250.10-FF-000018', NULL, 'TBC domain-containing protein kinase-like protein', 110, NULL, NULL, 39089),
(39090, '3.10.20.90-FF-000410', NULL, 'Esc2p', 80, NULL, NULL, 39090),
(39091, '1.10.287.410-FF-000007', NULL, 'Carboxypeptidase', 68, NULL, NULL, 39091),
(39092, '3.40.50.300-FF-008033', NULL, 'Dicer-like protein', 136, NULL, NULL, 39092),
(39093, '2.30.29.30-FF-001083', NULL, 'Uncharacterized protein', 64, NULL, NULL, 39093),
(39094, '2.30.30.100-FF-000089', NULL, 'U6 snRNA-associated Sm-like protein LSm7, putative', 97, NULL, NULL, 39094),
(39095, '3.80.10.10-FF-002148', NULL, 'LRR receptor-like serine/threonine-protein kinase FEI 2', 68, NULL, NULL, 39095),
(39096, '3.30.40.10-FF-001157', NULL, 'Putative RING zinc finger domain superfamily protein', 87, NULL, NULL, 39096),
(39097, '1.10.1200.270-FF-000021', NULL, 'Os11g0260600 protein', 114, NULL, NULL, 39097),
(39098, '1.10.3080.10-FF-000081', NULL, 'Uncharacterized protein', 415, NULL, NULL, 39098),
(39099, '3.40.50.2300-FF-001055', NULL, NULL, 129, NULL, NULL, 39099),
(39100, '1.20.1250.20-FF-000460', NULL, 'MFS multidrug transporter, putative', 430, NULL, NULL, 39100),
(39101, '3.40.50.620-FF-000434', NULL, 'Cytidylyltransferase, putative', 261, NULL, NULL, 39101),
(39102, '3.30.40.10-FF-001101', NULL, 'Structure-specific endonuclease subunit slx1', 74, NULL, NULL, 39102),
(39103, '3.30.1360.170-FF-000003', NULL, 'Flavin-dependent thymidylate synthase', 207, NULL, NULL, 39103),
(39104, '3.40.50.300-FF-000400', NULL, 'DNA replication and repair protein RecF', 147, NULL, NULL, 39104),
(39105, '3.30.1360.180-FF-000006', NULL, 'Nucleotide phosphatase', 126, NULL, NULL, 39105),
(39106, '3.90.190.10-FF-000384', NULL, 'Si:ch1073-391i24.1', 130, NULL, NULL, 39106),
(39107, '3.40.710.10-FF-000009', NULL, 'Glutaminase', 146, NULL, NULL, 39107),
(39108, '3.30.70.260-FF-000158', NULL, 'Prephenate dehydratase-domain-containing protein', 92, NULL, NULL, 39108),
(39109, '3.40.630.30-FF-000441', NULL, 'Uncharacterized protein', 204, NULL, NULL, 39109),
(39110, '1.10.3380.10-FF-000070', NULL, 'Activating signal cointegrator 1 complex subunit 3', 52, NULL, NULL, 39110),
(39111, '2.130.10.10-FF-003648', NULL, 'Uncharacterized protein', 110, NULL, NULL, 39111),
(39112, '3.40.50.300-FF-005178', NULL, 'ATP-dependent dethiobiotin synthetase BioD', 220, NULL, NULL, 39112);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(39113, '3.40.390.10-FF-000186', NULL, NULL, 125, NULL, NULL, 39113),
(39114, '3.30.450.260-FF-000013', NULL, 'Uncharacterized protein', 60, NULL, NULL, 39114),
(39115, '2.130.10.10-FF-001557', NULL, 'Protein HIR', 113, NULL, NULL, 39115),
(39116, '3.40.850.10-FF-000547', NULL, 'Uncharacterized protein', 213, NULL, NULL, 39116),
(39117, '3.40.50.300-FF-003087', NULL, 'GTP-binding protein, Ras family protein', 182, NULL, NULL, 39117),
(39118, '2.60.120.200-FF-000753', NULL, 'Uncharacterized protein', 121, NULL, NULL, 39118),
(39119, '3.30.2460.20-FF-000011', NULL, 'Protein Wnt', 65, NULL, NULL, 39119),
(39120, '4.10.1000.10-FF-000039', NULL, 'Putative RNA helicase family protein', 68, NULL, NULL, 39120),
(39121, '1.10.510.10-FF-004510', NULL, NULL, 125, NULL, NULL, 39121),
(39122, '1.20.5.110-FF-000169', NULL, 'Snare-like domain protein', 86, NULL, NULL, 39122),
(39123, '1.10.472.80-FF-000232', NULL, NULL, 113, NULL, NULL, 39123),
(39124, '3.80.10.10-FF-004239', NULL, 'Uncharacterized protein', 76, NULL, NULL, 39124),
(39125, '2.130.10.10-FF-000001', NULL, 'transducin-like enhancer protein 3 isoform X1', 334, NULL, NULL, 39125),
(39126, '1.25.40.10-FF-004895', NULL, 'Pentatricopeptide repeat-containing protein At4g11690', 90, NULL, NULL, 39126),
(39127, '3.30.70.330-FF-001932', NULL, NULL, 142, NULL, NULL, 39127),
(39128, '1.10.287.160-FF-000011', NULL, 'catenin alpha-1 isoform X2', 45, NULL, NULL, 39128),
(39129, '3.30.70.1230-FF-000006', NULL, 'Adenylate cyclase', 215, NULL, NULL, 39129),
(39130, '2.10.25.10-FF-000580', NULL, 'Wing blister, isoform B', 66, NULL, NULL, 39130),
(39131, '3.40.720.10-FF-000049', NULL, 'Alkaline phosphatase', 311, NULL, NULL, 39131),
(39132, '2.10.70.10-FF-000206', NULL, 'Uncharacterized protein', 65, NULL, NULL, 39132),
(39133, '2.10.25.10-FF-000922', NULL, 'neurogenic locus notch homolog protein 3', 34, NULL, NULL, 39133),
(39134, '2.40.170.20-FF-000120', NULL, 'SusC homolog', 494, NULL, NULL, 39134),
(39135, '3.30.70.1220-FF-000003', NULL, 'General transcription and DNA repair factor IIH subunit TFB5', 68, NULL, NULL, 39135),
(39136, '3.30.70.330-FF-000819', NULL, 'Polyadenylate-binding protein', 111, NULL, NULL, 39136),
(39137, '3.40.366.10-FF-000074', NULL, 'Polyketide synthase', 239, NULL, NULL, 39137),
(39138, '2.10.25.10-FF-000866', NULL, 'Cubilin', 38, NULL, NULL, 39138),
(39139, '3.40.1110.10-FF-000244', NULL, 'Na/K ATPase alpha 1 subunit, putative', 211, NULL, NULL, 39139),
(39140, '2.60.40.150-FF-000200', NULL, 'Ras GTPase-activating protein 1', 123, NULL, NULL, 39140),
(39141, '1.10.287.70-FF-000770', NULL, 'Uncharacterized protein', 138, NULL, NULL, 39141),
(39142, '2.130.10.10-FF-000220', NULL, 'Actin-related protein 2/3 complex subunit', 363, NULL, NULL, 39142),
(39143, '1.20.1270.280-FF-000006', NULL, 'Dynein cytoplasmic 2 heavy chain 1', 171, NULL, NULL, 39143),
(39144, '2.30.29.30-FF-000184', NULL, 'Rho guanine nucleotide exchange factor (GEF) 25', 150, NULL, NULL, 39144),
(39145, '1.10.630.10-FF-000742', NULL, 'Uncharacterized protein', 84, NULL, NULL, 39145),
(39146, '1.10.532.10-FF-000014', NULL, 'Uncharacterized protein', 127, NULL, NULL, 39146),
(39147, '3.40.50.1220-FF-000107', NULL, 'Uncharacterized protein', 101, NULL, NULL, 39147),
(39148, '2.60.40.10-FF-005812', NULL, NULL, 65, NULL, NULL, 39148),
(39149, '3.40.720.10-FF-000105', NULL, 'Phosphatidylinositol glycan anchor biosynthesis, class G', 103, NULL, NULL, 39149),
(39150, '2.60.120.920-FF-000053', NULL, 'E3 ubiquitin-protein ligase RKP', 175, NULL, NULL, 39150),
(39151, '1.25.10.10-FF-003089', NULL, 'Condensin complex subunit 3-like Protein', 225, NULL, NULL, 39151),
(39152, '3.30.160.60-FF-003378', NULL, NULL, 30, NULL, NULL, 39152),
(39153, '1.20.58.390-FF-000213', NULL, 'Acr-19', 82, NULL, NULL, 39153),
(39154, '2.30.42.10-FF-000489', NULL, NULL, 113, NULL, NULL, 39154),
(39155, '3.40.430.10-FF-000004', NULL, 'Dihydrofolate reductase', 162, NULL, NULL, 39155),
(39156, '1.20.1730.10-FF-000038', NULL, 'Similar to sodium-glucose cotransporter-like 1', 518, NULL, NULL, 39156);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(39157, '1.20.930.10-FF-000004', NULL, 'Histone-lysine N-methyltransferase', 97, NULL, NULL, 39157),
(39158, '3.30.70.1430-FF-000009', NULL, 'Probable RND efflux transporter', 93, NULL, NULL, 39158),
(39159, '3.30.70.330-FF-001376', NULL, 'RNA-binding protein (RRM domain)', 101, NULL, NULL, 39159),
(39160, '2.30.30.140-FF-000028', NULL, 'polycomb protein SCMH1 isoform X1', 103, NULL, NULL, 39160),
(39161, '1.25.40.20-FF-001918', NULL, 'Ankyrin-repeat protein, putative', 157, NULL, NULL, 39161),
(39162, '3.30.980.10-FF-000031', NULL, 'Uncharacterized protein', 81, NULL, NULL, 39162),
(39163, '3.40.50.1820-FF-001304', NULL, 'Os03g0393066 protein', 272, NULL, NULL, 39163),
(39164, '1.20.1440.200-FF-000011', NULL, 'Predicted protein', 62, NULL, NULL, 39164),
(39165, '1.10.150.50-FF-000065', NULL, 'mitogen-activated protein kinase kinase kinase 20 isoform X1', 80, NULL, NULL, 39165),
(39166, '3.40.50.11500-FF-000009', NULL, 'Pinstripe, isoform A', 145, NULL, NULL, 39166),
(39167, '1.20.1110.10-FF-000126', NULL, NULL, 218, NULL, NULL, 39167),
(39168, '3.40.50.410-FF-000141', NULL, 'Matrilin-4', 62, NULL, NULL, 39168),
(39169, '2.130.10.10-FF-002013', NULL, 'rRNA-processing protein', 207, NULL, NULL, 39169),
(39170, '3.30.530.20-FF-000101', NULL, 'Polyadenylate-binding protein RBP45C', 87, NULL, NULL, 39170),
(39171, '3.40.50.1360-FF-000065', NULL, '6phosphogluconolactonase, putative', 93, NULL, NULL, 39171),
(39172, '3.10.20.90-FF-000135', NULL, 'UBX domain-containing protein 2B', 126, NULL, NULL, 39172),
(39173, '3.40.630.30-FF-000166', NULL, 'Alpha-tubulin N-acetyltransferase', 176, NULL, NULL, 39173),
(39174, '1.20.1060.20-FF-000012', NULL, 'Structural maintenance of chromosomes protein', 114, NULL, NULL, 39174),
(39175, '3.30.2290.10-FF-000028', NULL, 'Zinc-dependent protease, TldD/PmbA family', 204, NULL, NULL, 39175),
(39176, '2.60.220.50-FF-000062', NULL, 'Predicted protein', 171, NULL, NULL, 39176),
(39177, '3.40.50.300-FF-005453', NULL, 'ABC multidrug transporter (Eurofung)', 240, NULL, NULL, 39177),
(39178, '3.40.50.300-FF-000214', NULL, 'Mitofusin 2', 226, NULL, NULL, 39178),
(39179, '1.25.10.10-FF-000796', NULL, 'Arm repeat containing protein homolog-like', 77, NULL, NULL, 39179),
(39180, '3.50.50.60-FF-000823', NULL, 'Fructose dehydrogenase large subunit', 120, NULL, NULL, 39180),
(39181, '3.30.565.10-FF-000488', NULL, 'Predicted protein', 161, NULL, NULL, 39181),
(39182, '2.60.40.10-FF-005705', NULL, NULL, 56, NULL, NULL, 39182),
(39183, '3.30.160.60-FF-000337', NULL, 'Zinc finger and BTB domain containing 41', 30, NULL, NULL, 39183),
(39184, '3.40.50.10110-FF-000002', NULL, 'DNA polymerase III, chi subunit', 139, NULL, NULL, 39184),
(39185, '3.40.50.2000-FF-000971', NULL, 'Uncharacterized protein', 89, NULL, NULL, 39185),
(39186, '4.10.400.10-FF-000062', NULL, 'Terribly reduced optic lobes, isoform AI', 39, NULL, NULL, 39186),
(39187, '3.60.40.10-FF-000285', NULL, 'AGAP008536-PA', 131, NULL, NULL, 39187),
(39188, '1.25.40.10-FF-003821', NULL, 'Nuclear autoantigenic sperm protein-like Protein', 130, NULL, NULL, 39188),
(39189, '2.30.29.30-FF-001201', NULL, 'Uncharacterized protein', 58, NULL, NULL, 39189),
(39190, '3.30.450.20-FF-000680', NULL, 'Sensory transduction histidine kinase', 67, NULL, NULL, 39190),
(39191, '2.30.30.100-FF-000207', NULL, 'Uncharacterized protein', 90, NULL, NULL, 39191),
(39192, '3.30.200.20-FF-000925', NULL, 'Mitogen-activated protein kinase kinase kinase 15', 92, NULL, NULL, 39192),
(39193, '2.80.10.50-FF-000004', NULL, 'Fibroblast growth factor', 144, NULL, NULL, 39193),
(39194, '1.10.1040.50-FF-000011', NULL, 'Enoyl-CoA hydratase/Enoyl-CoA isomerase/3-hydroxyacyl-CoA dehydrogenase, putative', 124, NULL, NULL, 39194),
(39195, '3.70.10.10-FF-000142', NULL, 'Uncharacterized protein', 80, NULL, NULL, 39195),
(39196, '3.40.710.10-FF-000161', NULL, 'Penicillin-binding protein 1B McrB, putative', 427, NULL, NULL, 39196),
(39197, '3.40.50.720-FF-000790', NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', 195, NULL, NULL, 39197),
(39198, '1.25.40.10-FF-004569', NULL, 'Leucine-rich PPR motif-containing protein, mitochondrial', 192, NULL, NULL, 39198);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(39199, '1.10.1080.10-FF-000018', NULL, 'Uncharacterized protein', 33, NULL, NULL, 39199),
(39200, '1.20.1280.50-FF-000004', NULL, 'F-box/WD repeat-containing protein 7 isoform X1', 105, NULL, NULL, 39200),
(39201, '1.10.10.10-FF-001341', NULL, 'Eukaryotic translation initiation factor 3 subunit K', 92, NULL, NULL, 39201),
(39202, '1.25.40.10-FF-003327', NULL, 'Putative pentatricopeptide repeat-containing protein', 102, NULL, NULL, 39202),
(39203, '1.20.850.10-FF-000003', NULL, 'Hydroxylamine oxidoreductase', 222, NULL, NULL, 39203),
(39204, '1.20.1070.10-FF-001994', NULL, 'Olfactory receptor family 10 subfamily D member 3 (putative)', 151, NULL, NULL, 39204),
(39205, '2.60.200.20-FF-000231', NULL, 'Uncharacterized protein', 78, NULL, NULL, 39205),
(39206, '3.50.30.30-FF-000026', NULL, 'E3 ubiquitin-protein ligase RNF13', 135, NULL, NULL, 39206),
(39207, '2.130.10.10-FF-001850', NULL, 'Trp-asp repeats containing protein', 107, NULL, NULL, 39207),
(39208, '3.40.50.10130-FF-000008', NULL, 'DNA repair endonuclease, putative', 139, NULL, NULL, 39208),
(39209, '3.30.450.40-FF-000106', NULL, 'Transcriptional regulatory protein', 169, NULL, NULL, 39209),
(39210, '3.50.50.60-FF-000767', NULL, 'Glycine/D-amino acid oxidase (Deaminating)', 212, NULL, NULL, 39210),
(39211, '1.10.510.10-FF-001576', NULL, 'Protein kinase-like protein', 227, NULL, NULL, 39211),
(39212, '3.40.250.10-FF-000081', NULL, 'Arr2p', 126, NULL, NULL, 39212),
(39213, '3.90.190.10-FF-000507', NULL, 'Uncharacterized protein', 143, NULL, NULL, 39213),
(39214, '1.10.10.10-FF-001964', NULL, 'Uncharacterized protein', 72, NULL, NULL, 39214),
(39215, '3.30.160.20-FF-000247', NULL, 'A-to-I RNA editing regulator adr-1', 93, NULL, NULL, 39215),
(39216, '1.10.8.1120-FF-000006', NULL, 'Uncharacterized protein', 44, NULL, NULL, 39216),
(39217, '3.40.50.300-FF-001737', NULL, 'ATP-dependent RNA helicase, putative', 161, NULL, NULL, 39217),
(39218, '1.20.1250.20-FF-001128', NULL, 'Uncharacterized protein', 168, NULL, NULL, 39218),
(39219, '3.30.160.60-FF-004053', NULL, 'Zinc finger protein 462', 68, NULL, NULL, 39219),
(39220, '1.25.10.10-FF-000060', NULL, 'Serine/threonine-protein kinase mTOR', 222, NULL, NULL, 39220),
(39221, '3.30.530.20-FF-000152', NULL, 'Phosphatidylinositol transfer protein', 170, NULL, NULL, 39221),
(39222, '1.20.1270.10-FF-000014', NULL, 'Heat shock protein 70', 99, NULL, NULL, 39222),
(39223, '3.30.1400.10-FF-000004', NULL, 'Cell division protein ZipA', 131, NULL, NULL, 39223),
(39224, '3.30.160.60-FF-001580', NULL, 'zinc finger protein 483', 29, NULL, NULL, 39224),
(39225, '1.10.287.660-FF-000003', NULL, 'vacuolar protein sorting-associated protein 37B', 78, NULL, NULL, 39225),
(39226, '2.40.50.120-FF-000029', NULL, 'Complement C4', 157, NULL, NULL, 39226),
(39227, '1.20.1280.40-FF-000001', NULL, 'Hemolysin expression modulator Hha', 72, NULL, NULL, 39227),
(39228, '3.40.50.300-FF-003654', NULL, 'Uncharacterized protein', 152, NULL, NULL, 39228),
(39229, '3.30.40.10-FF-001106', NULL, 'Bifunctional apoptosis regulator', 102, NULL, NULL, 39229),
(39230, '3.10.110.20-FF-000001', NULL, 'E3 ubiquitin-protein ligase FANCL', 95, NULL, NULL, 39230),
(39231, '3.40.50.2300-FF-000892', NULL, NULL, 122, NULL, NULL, 39231),
(39232, '2.60.120.330-FF-000090', NULL, 'Gibberellin 20 oxidase 5', 328, NULL, NULL, 39232),
(39233, '1.10.220.60-FF-000006', NULL, 'GRIP and coiled-coil domain-containing protein 2', 61, NULL, NULL, 39233),
(39234, '1.20.58.60-FF-000296', NULL, 'centrosomal protein of 68 kDa', 111, NULL, NULL, 39234),
(39235, '1.10.150.910-FF-000012', NULL, 'DNA damage-binding protein 1', 95, NULL, NULL, 39235),
(39236, '1.20.1250.20-FF-002197', NULL, 'Uncharacterized protein', 151, NULL, NULL, 39236),
(39237, '1.20.1250.20-FF-000959', NULL, 'Similar to MFS multidrug transporter', 258, NULL, NULL, 39237),
(39238, '4.10.60.10-FF-000269', NULL, 'Uncharacterized protein', 53, NULL, NULL, 39238),
(39239, '1.10.630.10-FF-000337', NULL, 'Predicted protein', 199, NULL, NULL, 39239),
(39240, '3.50.50.60-FF-000475', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 158, NULL, NULL, 39240);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(39241, '1.25.10.10-FF-003437', NULL, 'Uncharacterized protein', 123, NULL, NULL, 39241),
(39242, '3.30.1320.10-FF-000003', NULL, '30S ribosomal protein S16, chloroplastic', 87, NULL, NULL, 39242),
(39243, '1.10.287.370-FF-000074', NULL, 'Uncharacterized protein', 98, NULL, NULL, 39243),
(39244, '1.20.1250.20-FF-002253', NULL, 'Uncharacterized protein', 107, NULL, NULL, 39244),
(39245, '3.40.1160.10-FF-000067', NULL, 'Glutamate 5-kinase', 192, NULL, NULL, 39245),
(39246, '3.30.1360.20-FF-000003', NULL, 'Transcriptional coactivator/pterin dehydratase', 100, NULL, NULL, 39246),
(39247, '3.10.20.310-FF-000038', NULL, 'Hemolysin activator protein', 88, NULL, NULL, 39247),
(39248, '2.60.200.30-FF-000015', NULL, 'NAD(H) kinase 3', 131, NULL, NULL, 39248),
(39249, '1.20.1320.30-FF-000002', NULL, 'Probable ATP-dependent RNA helicase DDX58', 139, NULL, NULL, 39249),
(39250, '2.60.200.40-FF-000018', NULL, 'Diacylglycerol kinase, putative', 105, NULL, NULL, 39250),
(39251, '3.80.10.10-FF-002822', NULL, 'Predicted protein', 97, NULL, NULL, 39251),
(39252, '3.40.50.11340-FF-000028', NULL, 'Predicted protein', 47, NULL, NULL, 39252),
(39253, '1.25.10.10-FF-001291', NULL, 'Uncharacterized protein', 209, NULL, NULL, 39253),
(39254, '1.25.40.10-FF-004788', NULL, 'Tetratricopeptide repeat domain 21B', 369, NULL, NULL, 39254),
(39255, '2.30.170.20-FF-000004', NULL, '60S ribosomal protein l24', 63, NULL, NULL, 39255),
(39256, '3.30.1450.10-FF-000007', NULL, 'Outer membrane protein assembly factor BamE', 79, NULL, NULL, 39256),
(39257, '3.30.450.40-FF-000213', NULL, 'Uncharacterized protein', 150, NULL, NULL, 39257),
(39258, '3.40.50.2000-FF-000920', NULL, 'Uncharacterized protein', 160, NULL, NULL, 39258),
(39259, '3.90.1420.10-FF-000031', NULL, 'Uncharacterized protein', 139, NULL, NULL, 39259),
(39260, '3.30.450.50-FF-000042', NULL, 'Vesicle transport protein', 67, NULL, NULL, 39260),
(39261, '1.20.1070.10-FF-002157', NULL, 'Uncharacterized protein', 150, NULL, NULL, 39261),
(39262, '2.60.40.790-FF-000105', NULL, 'NudC domain-containing 2', 83, NULL, NULL, 39262),
(39263, '3.40.50.300-FF-002013', NULL, 'GTP-binding protein HflX', 175, NULL, NULL, 39263),
(39264, '4.10.280.10-FF-000175', NULL, 'Inhibitor of DNA binding 1', 66, NULL, NULL, 39264),
(39265, '3.40.50.2000-FF-000864', NULL, 'Os06g0192100 protein', 200, NULL, NULL, 39265),
(39266, '3.40.50.300-FF-000107', NULL, 'Replication factor C subunit 4', 164, NULL, NULL, 39266),
(39267, '1.20.5.4820-FF-000001', NULL, 'Myosin heavy chain', 130, NULL, NULL, 39267),
(39268, '2.180.10.10-FF-000015', NULL, 'Cell wall-associated protein', 195, NULL, NULL, 39268),
(39269, '3.30.1360.40-FF-000009', NULL, 'DNA topoisomerase medium subunit', 104, NULL, NULL, 39269),
(39270, '3.40.50.720-FF-001127', NULL, 'NAD binding Rossmann fold oxidoreductase', 118, NULL, NULL, 39270),
(39271, '3.10.100.10-FF-000110', NULL, 'GM24217', 201, NULL, NULL, 39271),
(39272, '3.40.50.850-FF-000031', NULL, 'Uncharacterized protein', 212, NULL, NULL, 39272),
(39273, '3.30.450.20-FF-000617', NULL, 'Uncharacterized protein', 109, NULL, NULL, 39273),
(39274, '1.10.8.10-FF-000137', NULL, 'Doublesex, isoform E', 65, NULL, NULL, 39274),
(39275, '3.30.1360.30-FF-000006', NULL, 'Aspartyl-tRNA synthetase', 153, NULL, NULL, 39275),
(39276, '1.20.120.1080-FF-000011', NULL, 'DExH-box ATP-dependent RNA helicase DExH6', 106, NULL, NULL, 39276),
(39277, '3.30.450.60-FF-000045', NULL, 'Vesicle coat complex COPI, zeta subunit', 159, NULL, NULL, 39277),
(39278, '1.10.287.70-FF-000618', NULL, 'Potassium two pore domain channel subfamily K member 9', 241, NULL, NULL, 39278),
(39279, '2.40.10.480-FF-000011', NULL, 'Beta-alanine-activating enzyme', 65, NULL, NULL, 39279),
(39280, '1.20.1730.10-FF-000089', NULL, 'Uncharacterized protein', 398, NULL, NULL, 39280),
(39281, '1.10.287.70-FF-000495', NULL, 'Predicted protein', 232, NULL, NULL, 39281),
(39282, '3.80.10.10-FF-002474', NULL, 'Cell surface protein', 118, NULL, NULL, 39282),
(39283, '3.40.50.300-FF-003598', NULL, 'Small GTPase EhRabX1, putative', 177, NULL, NULL, 39283);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(39284, '2.60.40.60-FF-000116', NULL, 'Dachsous cadherin-related 2', 105, NULL, NULL, 39284),
(39285, '2.60.40.1730-FF-000054', NULL, 'Protein CBG09901', 222, NULL, NULL, 39285),
(39286, '3.90.810.10-FF-000028', NULL, 'Non-specific serine/threonine protein kinase', 78, NULL, NULL, 39286),
(39287, '1.10.3380.10-FF-000025', NULL, 'Uncharacterized protein', 135, NULL, NULL, 39287),
(39288, '2.130.10.10-FF-003199', NULL, 'Protein HIRA homolog', 101, NULL, NULL, 39288),
(39289, '2.40.270.10-FF-000001', NULL, 'DNA-directed RNA polymerase subunit beta', 226, NULL, NULL, 39289),
(39290, '2.10.25.10-FF-000428', NULL, 'Laminin subunit alpha 3', 48, NULL, NULL, 39290),
(39291, '1.10.3730.20-FF-000050', NULL, 'Multidrug resistance protein, SMR family', 117, NULL, NULL, 39291),
(39292, '1.10.287.130-FF-000075', NULL, 'Two-component sensor histidine kinase', 78, NULL, NULL, 39292),
(39293, '3.30.160.60-FF-005683', NULL, NULL, 25, NULL, NULL, 39293),
(39294, '3.40.50.620-FF-000872', NULL, 'ATP sulfurylase 1 chloroplastic', 131, NULL, NULL, 39294),
(39295, '3.20.80.10-FF-000002', NULL, 'Heme-binding protein 2', 180, NULL, NULL, 39295),
(39296, '1.25.40.10-FF-000859', NULL, 'Drug transmembrane transporters', 50, NULL, NULL, 39296),
(39297, '1.20.120.430-FF-000011', NULL, 'RE57978p', 171, NULL, NULL, 39297),
(39298, '3.30.300.20-FF-000017', NULL, 'GTP-binding protein ERG', 100, NULL, NULL, 39298),
(39299, '1.10.630.10-FF-000118', NULL, 'Cytochrome P450 family 3 subfamily A member 43', 233, NULL, NULL, 39299),
(39300, '3.40.50.300-FF-005627', NULL, 'Predicted protein', 137, NULL, NULL, 39300),
(39301, '2.60.490.10-FF-000007', NULL, 'P2X purinoceptor', 140, NULL, NULL, 39301),
(39302, '1.25.40.10-FF-001348', NULL, 'DNA-directed RNA polymerase, mitochondrial', 159, NULL, NULL, 39302),
(39303, '3.40.1380.20-FF-000058', NULL, 'Pyruvate kinase', 141, NULL, NULL, 39303),
(39304, '1.10.520.10-FF-000060', NULL, 'Peroxidase 12', 101, NULL, NULL, 39304),
(39305, '3.30.300.10-FF-000014', NULL, 'Burgundy, isoform B', 111, NULL, NULL, 39305),
(39306, '2.40.420.20-FF-000044', NULL, 'Efflux protein', 88, NULL, NULL, 39306),
(39307, '3.20.20.140-FF-000204', NULL, 'Adenine deaminase', 245, NULL, NULL, 39307),
(39308, '3.60.40.10-FF-000341', NULL, 'Uncharacterized protein', 125, NULL, NULL, 39308),
(39309, '3.30.160.60-FF-002810', NULL, 'Zinc finger protein 386 (Kruppel-like)', 27, NULL, NULL, 39309),
(39310, '2.10.50.10-FF-000048', NULL, 'Cysteine repeat modular protein 1', 62, NULL, NULL, 39310),
(39311, '1.50.40.10-FF-000211', NULL, 'Mitochondrial carrier protein, putative', 162, NULL, NULL, 39311),
(39312, '3.40.50.410-FF-000192', NULL, 'Integrin beta', 179, NULL, NULL, 39312),
(39313, '3.40.605.10-FF-000085', NULL, 'Uncharacterized protein', 62, NULL, NULL, 39313),
(39314, '2.120.10.30-FF-000400', NULL, 'Uncharacterized protein', 333, NULL, NULL, 39314),
(39315, '3.40.50.2300-FF-001229', NULL, NULL, 161, NULL, NULL, 39315),
(39316, '1.10.238.10-FF-001095', NULL, 'Uncharacterized protein', 69, NULL, NULL, 39316),
(39317, '2.60.40.10-FF-005413', NULL, NULL, 66, NULL, NULL, 39317),
(39318, '3.90.1200.10-FF-000043', NULL, 'Uncharacterized protein', 214, NULL, NULL, 39318),
(39319, '3.40.50.720-FF-000638', NULL, 'Succinate--CoA ligase [ADP-forming] subunit alpha, mitochondrial', 131, NULL, NULL, 39319),
(39320, '1.10.287.470-FF-000042', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 74, NULL, NULL, 39320),
(39321, '3.10.20.30-FF-000027', NULL, 'Succinate dehydrogenase [ubiquinone] iron-sulfur subunit, mitochondrial', 110, NULL, NULL, 39321),
(39322, '3.10.129.10-FF-000159', NULL, 'Uncharacterized protein', 146, NULL, NULL, 39322),
(39323, '2.20.80.10-FF-000010', NULL, 'Uncharacterized protein', 175, NULL, NULL, 39323),
(39324, '2.30.33.40-FF-000005', NULL, '20 kDa chaperonin, chloroplastic', 100, NULL, NULL, 39324),
(39325, '1.20.1250.20-FF-000908', NULL, 'Uncharacterized protein', 316, NULL, NULL, 39325),
(39326, '1.20.1560.10-FF-000733', NULL, 'p-glycoprotein-2, putative', 198, NULL, NULL, 39326),
(39327, '1.10.1580.10-FF-000006', NULL, 'Nuclear GTP-binding protein NUG1', 99, NULL, NULL, 39327);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(39328, '3.30.70.3000-FF-000003', NULL, 'tRNA(His) guanylyltransferase', 240, NULL, NULL, 39328),
(39329, '1.10.390.10-FF-000026', NULL, 'Aminopeptidase', 244, NULL, NULL, 39329),
(39330, '3.40.30.60-FF-000002', NULL, 'EscV/YscV/HrcV family type III secretion system export apparatus protein', 146, NULL, NULL, 39330),
(39331, '3.30.200.20-FF-000869', NULL, 'Predicted protein', 118, NULL, NULL, 39331),
(39332, '1.10.238.10-FF-000083', NULL, 'guanylyl cyclase-activating protein 1', 166, NULL, NULL, 39332),
(39333, '1.10.555.10-FF-000151', NULL, NULL, 255, NULL, NULL, 39333),
(39334, '3.30.200.20-FF-001358', NULL, NULL, 111, NULL, NULL, 39334),
(39335, '1.20.1560.10-FF-000385', NULL, 'ABC transporter ATP-binding protein', 322, NULL, NULL, 39335),
(39336, '2.60.120.560-FF-000023', NULL, 'Beta-fructofuranosidase, putative', 146, NULL, NULL, 39336),
(39337, '3.40.50.12710-FF-000035', NULL, 'Protein arginine methyltransferase NDUFAF7', 146, NULL, NULL, 39337),
(39338, '1.10.3730.30-FF-000002', NULL, 'Toxin B', 100, NULL, NULL, 39338),
(39339, '3.40.640.10-FF-000104', NULL, 'Alanine aminotransferase, putative', 248, NULL, NULL, 39339),
(39340, '2.40.50.140-FF-001148', NULL, NULL, 79, NULL, NULL, 39340),
(39341, '2.60.200.20-FF-000012', NULL, 'Nuclear inhibitor of protein phosphatase 1', 132, NULL, NULL, 39341),
(39342, '1.10.287.110-FF-000136', NULL, 'DnaJ domain-containing protein Psi', 147, NULL, NULL, 39342),
(39343, '3.40.50.2000-FF-001134', NULL, 'Uncharacterized protein', 68, NULL, NULL, 39343),
(39344, '1.25.40.10-FF-005064', NULL, 'Pentatricopeptide repeat-containing protein At2g04860', 102, NULL, NULL, 39344),
(39345, '1.10.8.60-FF-000461', NULL, 'Peroxisomal ATPase pex1', 124, NULL, NULL, 39345),
(39346, '3.40.50.300-FF-000158', NULL, 'Site-determining protein', 242, NULL, NULL, 39346),
(39347, '2.130.10.10-FF-003474', NULL, 'Protein kinase', 318, NULL, NULL, 39347),
(39348, '2.40.50.90-FF-000048', NULL, 'Nuclease domain-containing protein 1', 162, NULL, NULL, 39348),
(39349, '3.10.20.90-FF-000023', NULL, 'NEDD8 protein', 78, NULL, NULL, 39349),
(39350, '1.10.510.10-FF-002886', NULL, NULL, 81, NULL, NULL, 39350),
(39351, '1.10.1450.10-FF-000002', NULL, 'Retinal outer segment membrane protein 1', 136, NULL, NULL, 39351),
(39352, '2.60.40.10-FF-005582', NULL, NULL, 98, NULL, NULL, 39352),
(39353, '3.40.720.10-FF-000217', NULL, 'Arylsulfatase A', 397, NULL, NULL, 39353),
(39354, '1.25.40.860-FF-000019', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 108, NULL, NULL, 39354),
(39355, '1.25.50.20-FF-000110', NULL, 'Npepps protein', 61, NULL, NULL, 39355),
(39356, '3.40.50.12710-FF-000029', NULL, 'Uncharacterized protein', 320, NULL, NULL, 39356),
(39357, '2.30.30.100-FF-000090', NULL, 'SnRNP Sm-like protein', 77, NULL, NULL, 39357),
(39358, '3.40.50.1820-FF-000574', NULL, 'Carboxypeptidase', 241, NULL, NULL, 39358),
(39359, '2.60.40.420-FF-000192', NULL, 'Blue (Type 1) copper domain protein', 116, NULL, NULL, 39359),
(39360, '2.60.40.60-FF-000223', NULL, 'neural-cadherin isoform X10', 106, NULL, NULL, 39360),
(39361, '4.10.410.10-FF-000118', NULL, 'Uncharacterized protein', 41, NULL, NULL, 39361),
(39362, '1.25.40.70-FF-000040', NULL, 'Putative phosphatidylinositol 4-kinase alpha', 162, NULL, NULL, 39362),
(39363, '3.30.60.90-FF-000013', NULL, 'Transcriptional adapter', 56, NULL, NULL, 39363),
(39364, '1.20.58.390-FF-000101', NULL, 'Uncharacterized protein', 135, NULL, NULL, 39364),
(39365, '1.10.238.10-FF-000190', NULL, 'calcium-binding mitochondrial carrier protein SCaMC-3 isoform X2', 76, NULL, NULL, 39365),
(39366, '2.130.10.10-FF-001905', NULL, 'Protein phosphatase 2C, putative', 324, NULL, NULL, 39366),
(39367, '3.40.50.300-FF-004958', NULL, 'Uncharacterized protein', 247, NULL, NULL, 39367),
(39368, '3.90.25.10-FF-000063', NULL, 'Uncharacterized protein', 99, NULL, NULL, 39368),
(39369, '3.50.50.60-FF-001205', NULL, 'Geranylgeranyl reductase', 379, NULL, NULL, 39369),
(39370, '2.60.40.10-FF-003491', NULL, NULL, 94, NULL, NULL, 39370),
(39371, '3.30.160.60-FF-002361', NULL, 'Zinc finger protein 559', 28, NULL, NULL, 39371);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(39372, '3.40.50.1400-FF-000043', NULL, 'Predicted protein', 144, NULL, NULL, 39372),
(39373, '3.30.1330.20-FF-000001', NULL, 'Tubulin alpha chain', 115, NULL, NULL, 39373),
(39374, '3.30.1330.30-FF-000004', NULL, 'selenocysteine insertion sequence-binding protein 2', 100, NULL, NULL, 39374),
(39375, '3.30.200.20-FF-002488', NULL, 'Spermatocyte protein spe-8', 27, NULL, NULL, 39375),
(39376, '3.50.50.80-FF-000014', NULL, NULL, 51, NULL, NULL, 39376),
(39377, '3.40.50.1110-FF-000018', NULL, 'Lipase 1', 243, NULL, NULL, 39377),
(39378, '3.20.20.80-FF-000840', NULL, 'Class V chitinase, putative', 31, NULL, NULL, 39378),
(39379, '2.20.28.200-FF-000006', NULL, 'NAD-dependent protein deacetylase sirtuin-6 isoform 2', 36, NULL, NULL, 39379),
(39380, '3.30.1330.40-FF-000007', NULL, 'Reactive intermediate/imine deaminase', 134, NULL, NULL, 39380),
(39381, '1.10.555.10-FF-000145', NULL, NULL, 97, NULL, NULL, 39381),
(39382, '3.40.630.30-FF-000054', NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', 204, NULL, NULL, 39382),
(39383, '3.30.930.10-FF-000314', NULL, 'Phenylalanyl-tRNA synthetase, beta subunit family protein', 199, NULL, NULL, 39383),
(39384, '1.25.40.840-FF-000013', NULL, 'Predicted protein', 66, NULL, NULL, 39384),
(39385, '2.60.40.10-FF-001254', NULL, 'Cartilage intermediate layer protein 2', 95, NULL, NULL, 39385),
(39386, '3.40.50.620-FF-000086', NULL, 'Electron transfer flavoprotein subunit beta', 262, NULL, NULL, 39386),
(39387, '3.40.50.1400-FF-000004', NULL, 'Ferrochelatase', 174, NULL, NULL, 39387),
(39388, '1.25.40.90-FF-000046', NULL, 'LSB5p protein', 165, NULL, NULL, 39388),
(39389, '1.20.5.110-FF-000113', NULL, 't-SNARE domain-containing protein 1', 90, NULL, NULL, 39389),
(39390, '3.40.50.720-FF-000346', NULL, 'C-3 sterol dehydrogenase/C-4 decarboxylase', 355, NULL, NULL, 39390),
(39391, '3.80.10.10-FF-001985', NULL, 'Leucine-rich repeat protein (LRRP), putative', 168, NULL, NULL, 39391),
(39392, '3.40.50.1100-FF-000015', NULL, 'Cysteine synthase B', 107, NULL, NULL, 39392),
(39393, '3.30.160.60-FF-003884', NULL, 'GD10687', 53, NULL, NULL, 39393),
(39394, '3.40.1160.10-FF-000016', NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase', 191, NULL, NULL, 39394),
(39395, '3.30.70.660-FF-000008', NULL, 'tRNA pseudouridine synthase A', 135, NULL, NULL, 39395),
(39396, '4.10.420.10-FF-000001', NULL, 'Salt-mediated killer protoxin 1', 63, NULL, NULL, 39396),
(39397, '1.10.225.10-FF-000008', NULL, 'Pulmonary surfactant-associated protein B', 80, NULL, NULL, 39397),
(39398, '1.20.58.900-FF-000029', NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', 212, NULL, NULL, 39398),
(39399, '1.10.1040.10-FF-000078', NULL, 'YALI0D20438p', 141, NULL, NULL, 39399),
(39400, '1.25.40.10-FF-005351', NULL, 'Uncharacterized protein', 127, NULL, NULL, 39400),
(39401, '1.10.287.1150-FF-000016', NULL, 'Uncharacterized protein', 91, NULL, NULL, 39401),
(39402, '2.60.40.10-FF-005525', NULL, NULL, 62, NULL, NULL, 39402),
(39403, '3.90.180.10-FF-000119', NULL, 'Protein CBG06201', 165, NULL, NULL, 39403),
(39404, '1.20.5.1930-FF-000005', NULL, 'Two-component sensor histidine kinase', 61, NULL, NULL, 39404),
(39405, '3.40.720.10-FF-000274', NULL, 'Uncharacterized protein', 361, NULL, NULL, 39405),
(39406, '3.40.50.720-FF-001240', NULL, '4-carboxy-2-hydroxymuconate-6-semialdehyde dehydrogenase', 154, NULL, NULL, 39406),
(39407, '3.30.1240.10-FF-000019', NULL, 'Cof family hydrolase', 105, NULL, NULL, 39407),
(39408, '1.20.970.10-FF-000001', NULL, 'Thymidine phosphorylase', 102, NULL, NULL, 39408),
(39409, '2.10.90.10-FF-000152', NULL, 'Uncharacterized protein', 99, NULL, NULL, 39409),
(39410, '1.10.287.470-FF-000098', NULL, 'Sll0180 protein', 59, NULL, NULL, 39410),
(39411, '3.90.20.20-FF-000038', NULL, 'GrpE protein homolog', 121, NULL, NULL, 39411),
(39412, '3.40.50.410-FF-000247', NULL, 'General transcription and DNA repair factor IIH subunit TFB4', 241, NULL, NULL, 39412),
(39413, '3.40.930.10-FF-000031', NULL, 'Anion exchange protein', 128, NULL, NULL, 39413),
(39414, '3.30.780.10-FF-000044', NULL, '39S ribosomal protein L49, mitochondrial isoform X1', 91, NULL, NULL, 39414);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(39415, '1.20.58.830-FF-000042', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 142, NULL, NULL, 39415),
(39416, '3.40.1170.60-FF-000009', NULL, 'DNA polymerase IV', 56, NULL, NULL, 39416),
(39417, '3.30.40.10-FF-002175', NULL, 'Vacuolar segregation protein pep7', 82, NULL, NULL, 39417),
(39418, '2.60.120.330-FF-000207', NULL, 'Uncharacterized protein', 125, NULL, NULL, 39418),
(39419, '1.20.5.1190-FF-000007', NULL, 'Sodium channel protein', 31, NULL, NULL, 39419),
(39420, '2.20.25.10-FF-000107', NULL, 'Plant-specific TFIIB-related protein PTF2', 40, NULL, NULL, 39420),
(39421, '1.10.400.10-FF-000079', NULL, 'Uncharacterized protein', 105, NULL, NULL, 39421),
(39422, '1.20.5.110-FF-000057', NULL, 'SNARE complex subunit (Bet1), putative', 61, NULL, NULL, 39422),
(39423, '3.30.160.60-FF-001754', NULL, 'Uncharacterized protein', 27, NULL, NULL, 39423),
(39424, '3.40.50.1110-FF-000170', NULL, 'Transducin family protein / WD-40 repeat family protein', 144, NULL, NULL, 39424),
(39425, '3.30.160.60-FF-005065', NULL, NULL, 30, NULL, NULL, 39425),
(39426, '2.70.170.10-FF-000200', NULL, 'Uncharacterized protein', 172, NULL, NULL, 39426),
(39427, '3.30.40.10-FF-000994', NULL, 'SR-related CTD associated factor 11', 121, NULL, NULL, 39427),
(39428, '1.20.58.80-FF-000010', NULL, 'serine/threonine-protein kinase ULK3 isoform X1', 78, NULL, NULL, 39428),
(39429, '3.60.90.10-FF-000018', NULL, 'S-adenosylmethionine decarboxylase proenzyme', 341, NULL, NULL, 39429),
(39430, '1.25.40.180-FF-000175', NULL, NULL, 153, NULL, NULL, 39430),
(39431, '1.20.1070.10-FF-000684', NULL, 'G protein coupled receptor', 371, NULL, NULL, 39431),
(39432, '1.20.1300.10-FF-000051', NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', 36, NULL, NULL, 39432),
(39433, '1.10.8.430-FF-000003', NULL, 'Probable disease resistance protein At5g66910', 88, NULL, NULL, 39433),
(39434, '1.20.1560.10-FF-000497', NULL, 'ATP-binding cassette transporter, subfamily B, member 11, group MDR/PGP protein PpABCB11', 205, NULL, NULL, 39434),
(39435, '3.40.50.300-FF-004104', NULL, 'Zinc finger NFX1-type containing homolog', 203, NULL, NULL, 39435),
(39436, '2.130.10.10-FF-005560', NULL, 'Uncharacterized protein', 218, NULL, NULL, 39436),
(39437, '2.130.10.10-FF-005503', NULL, 'Predicted protein', 99, NULL, NULL, 39437),
(39438, '3.30.830.10-FF-000312', NULL, 'Uncharacterized protein', 210, NULL, NULL, 39438),
(39439, '2.60.60.20-FF-000061', NULL, NULL, 122, NULL, NULL, 39439),
(39440, '1.20.900.10-FF-000053', NULL, 'Rho guanyl nucleotide exchange factor, putative', 255, NULL, NULL, 39440),
(39441, '3.30.930.10-FF-000371', NULL, 'Uncharacterized protein', 248, NULL, NULL, 39441),
(39442, '1.20.120.850-FF-000036', NULL, 'Uncharacterized protein', 102, NULL, NULL, 39442),
(39443, '3.20.20.70-FF-000511', NULL, 'N-acetylneuraminate lyase', 299, NULL, NULL, 39443),
(39444, '3.90.76.10-FF-000034', NULL, 'ABC transporter substrate-binding protein', 122, NULL, NULL, 39444),
(39445, '3.30.160.60-FF-000118', NULL, 'Ataxin-7-like protein 3', 29, NULL, NULL, 39445),
(39446, '3.90.180.10-FF-000176', NULL, 'Uncharacterized protein', 22, NULL, NULL, 39446),
(39447, '3.80.10.10-FF-002710', NULL, 'Putative leucine-rich repeat protein kinase family protein', 116, NULL, NULL, 39447),
(39448, '2.60.120.1040-FF-000021', NULL, NULL, 140, NULL, NULL, 39448),
(39449, '3.30.160.60-FF-005795', NULL, NULL, 25, NULL, NULL, 39449),
(39450, '1.20.120.1110-FF-000003', NULL, 'Transcription initiation factor TFIID subunit 4', 112, NULL, NULL, 39450),
(39451, '2.130.10.10-FF-005273', NULL, 'Predicted protein', 250, NULL, NULL, 39451),
(39452, '3.40.50.2000-FF-000914', NULL, 'Mannosyltransferase B', 163, NULL, NULL, 39452),
(39453, '3.30.160.60-FF-003827', NULL, NULL, 33, NULL, NULL, 39453),
(39454, '3.30.2130.30-FF-000023', NULL, 'Uncharacterized protein', 180, NULL, NULL, 39454),
(39455, '3.80.10.10-FF-000675', NULL, 'F-box domain protein (AFU_orthologue AFUA_2G02860)', 175, NULL, NULL, 39455),
(39456, '1.10.510.10-FF-004162', NULL, NULL, 191, NULL, NULL, 39456);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(39457, '1.10.630.10-FF-000629', NULL, 'Cytochrome P450, putative', 228, NULL, NULL, 39457),
(39458, '1.20.80.40-FF-000004', NULL, 'Predicted protein', 71, NULL, NULL, 39458),
(39459, '3.80.10.10-FF-002766', NULL, 'Dynein light chain 1, axonemal', 104, NULL, NULL, 39459),
(39460, '3.90.640.10-FF-000256', NULL, 'Actin-like protein 4', 116, NULL, NULL, 39460),
(39461, '3.40.1190.20-FF-000173', NULL, 'Adenosine kinase 2-like protein', 249, NULL, NULL, 39461),
(39462, '2.60.120.380-FF-000020', NULL, 'Protein CBR-TRA-3', 150, NULL, NULL, 39462),
(39463, '3.90.176.10-FF-000014', NULL, 'NAD(P)(+)--arginine ADP-ribosyltransferase', 142, NULL, NULL, 39463),
(39464, '3.90.870.10-FF-000026', NULL, 'Sll1866 protein', 195, NULL, NULL, 39464),
(39465, '2.40.250.10-FF-000005', NULL, 'Core binding factor beta subunit isoform 10', 26, NULL, NULL, 39465),
(39466, '1.25.40.10-FF-003153', NULL, 'Pentatricopeptide repeat-containing protein At1g10910, chloroplastic', 121, NULL, NULL, 39466),
(39467, '1.10.555.10-FF-000106', NULL, 'Ecm25p', 178, NULL, NULL, 39467),
(39468, '3.40.50.300-FF-003648', NULL, 'ATP-dependent DNA helicase RecQ', 192, NULL, NULL, 39468),
(39469, '2.10.25.10-FF-000136', NULL, 'Neurogenic locus notch 1', 41, NULL, NULL, 39469),
(39470, '1.10.3550.10-FF-000004', NULL, NULL, 122, NULL, NULL, 39470),
(39471, '3.40.50.300-FF-001468', NULL, 'Probable RNA helicase SDE3', 144, NULL, NULL, 39471),
(39472, '2.60.120.330-FF-000027', NULL, 'Gibberellin 2-beta-dioxygenase', 325, NULL, NULL, 39472),
(39473, '2.40.160.20-FF-000001', NULL, 'Outer membrane protein W', 191, NULL, NULL, 39473),
(39474, '4.10.280.10-FF-000231', NULL, 'Uncharacterized bHLH domain-containing protein C3F10.12c', 67, NULL, NULL, 39474),
(39475, '2.130.10.10-FF-003087', NULL, 'Pre-rRNA-processing protein IPI3', 92, NULL, NULL, 39475),
(39476, '2.60.40.10-FF-004688', NULL, NULL, 111, NULL, NULL, 39476),
(39477, '1.10.150.50-FF-000026', NULL, 'ETS homologous factor isoform X1', 69, NULL, NULL, 39477),
(39478, '2.60.120.920-FF-000002', NULL, 'ryanodine receptor isoform X2', 197, NULL, NULL, 39478),
(39479, '2.60.120.230-FF-000003', NULL, 'Probable peptidyl-glycine alpha-amidating monooxygenase pamn-1', 151, NULL, NULL, 39479),
(39480, '3.30.559.10-FF-000086', NULL, 'Diacylglycerol O-acyltransferase', 164, NULL, NULL, 39480),
(39481, '1.10.472.10-FF-000014', NULL, 'cyclin-L1 isoform X1', 111, NULL, NULL, 39481),
(39482, '3.30.9.10-FF-000141', NULL, 'FAD-binding oxidoreductase', 150, NULL, NULL, 39482),
(39483, '3.40.20.10-FF-000060', NULL, 'Cofilin', 143, NULL, NULL, 39483),
(39484, '3.50.50.60-FF-001262', NULL, 'FAD-dependent oxidoreductase', 102, NULL, NULL, 39484),
(39485, '1.20.5.500-FF-000016', NULL, NULL, 48, NULL, NULL, 39485),
(39486, '1.20.5.110-FF-000170', NULL, 'Synaptosomal-associated protein', 28, NULL, NULL, 39486),
(39487, '2.40.10.10-FF-000016', NULL, 'Tryptase beta-2', 133, NULL, NULL, 39487),
(39488, '1.20.1560.10-FF-000441', NULL, 'ABC transporter B family member 9', 54, NULL, NULL, 39488),
(39489, '1.10.510.10-FF-001582', NULL, 'Uncharacterized protein', 174, NULL, NULL, 39489),
(39490, '3.40.30.10-FF-000122', NULL, 'Peroxiredoxin Q chloroplastic', 151, NULL, NULL, 39490),
(39491, '3.80.10.10-FF-001018', NULL, 'LRR receptor-like serine/threonine-protein kinase EFR', 72, NULL, NULL, 39491),
(39492, '1.20.58.60-FF-000689', NULL, 'Predicted protein', 113, NULL, NULL, 39492),
(39493, '2.30.29.30-FF-001313', NULL, 'Uncharacterized protein', 73, NULL, NULL, 39493),
(39494, '3.20.20.70-FF-000730', NULL, NULL, 94, NULL, NULL, 39494),
(39495, '2.130.10.10-FF-004778', NULL, 'WD40 repeat-containing protein', 153, NULL, NULL, 39495),
(39496, '1.10.630.10-FF-000068', NULL, 'Probable cytochrome P450 508A2', 465, NULL, NULL, 39496),
(39497, '3.30.1140.60-FF-000010', NULL, 'F-actin capping protein', 116, NULL, NULL, 39497),
(39498, '1.10.10.60-FF-000203', NULL, 'Nanog homeobox transcription factor', 70, NULL, NULL, 39498),
(39499, '2.40.150.20-FF-000006', NULL, '50S ribosomal protein HLP, mitochondrial-like', 120, NULL, NULL, 39499);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(39500, '1.20.1250.20-FF-002146', NULL, 'Uncharacterized protein', 198, NULL, NULL, 39500),
(39501, '3.30.70.100-FF-000071', NULL, 'Heavy metal P-type ATPase', 62, NULL, NULL, 39501),
(39502, '3.30.160.60-FF-001467', NULL, 'Zinc finger protein 397', 32, NULL, NULL, 39502),
(39503, '3.30.70.640-FF-000002', NULL, 'Molybdenum cofactor biosynthesis protein 1', 158, NULL, NULL, 39503),
(39504, '3.30.70.590-FF-000021', NULL, 'Uncharacterized protein', 71, NULL, NULL, 39504),
(39505, '1.10.10.10-FF-001397', NULL, 'Transcriptional regulator', 89, NULL, NULL, 39505),
(39506, '3.20.20.140-FF-000154', NULL, 'Amidohydrolase', 335, NULL, NULL, 39506),
(39507, '3.20.20.80-FF-000733', NULL, 'Uncharacterized protein', 89, NULL, NULL, 39507),
(39508, '1.25.40.990-FF-000030', NULL, 'Putative leucine permease transcriptional regulator protein', 331, NULL, NULL, 39508),
(39509, '1.20.1070.10-FF-000920', NULL, 'Uncharacterized protein', 138, NULL, NULL, 39509),
(39510, '2.130.10.10-FF-001962', NULL, 'Transducin/WD40 repeat-like superfamily protein', 274, NULL, NULL, 39510),
(39511, '3.40.50.10190-FF-000094', NULL, 'Regulatory subunit for Cdc7p protein kinase', 103, NULL, NULL, 39511),
(39512, '1.10.150.50-FF-000245', NULL, 'Uncharacterized protein', 55, NULL, NULL, 39512),
(39513, '1.20.5.790-FF-000002', NULL, 'Mediator of RNA polymerase II transcription subunit 8', 30, NULL, NULL, 39513),
(39514, '2.60.300.12-FF-000002', NULL, 'Iron-sulfur cluster insertion protein ErpA', 106, NULL, NULL, 39514),
(39515, '1.10.287.1890-FF-000002', NULL, 'SAM-dependent methyltransferase', 64, NULL, NULL, 39515),
(39516, '2.80.10.50-FF-000116', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 135, NULL, NULL, 39516),
(39517, '3.40.1110.10-FF-000356', NULL, NULL, 152, NULL, NULL, 39517),
(39518, '3.40.50.300-FF-004323', NULL, 'Ras family gtpase', 97, NULL, NULL, 39518),
(39519, '3.30.200.20-FF-001184', NULL, 'Methylthioribose kinase', 117, NULL, NULL, 39519),
(39520, '3.30.70.1180-FF-000007', NULL, 'V-type proton ATPase subunit C', 19, NULL, NULL, 39520),
(39521, '2.30.29.30-FF-000419', NULL, 'mRNA-decapping enzyme subunit 1', 134, NULL, NULL, 39521),
(39522, '1.25.40.10-FF-005238', NULL, 'Predicted protein', 171, NULL, NULL, 39522),
(39523, '1.10.1200.10-FF-000175', NULL, 'Acyl-CoA synthetase', 86, NULL, NULL, 39523),
(39524, '2.40.50.140-FF-000979', NULL, NULL, 105, NULL, NULL, 39524),
(39525, '2.60.40.10-FF-003339', NULL, 'NPHS1 adhesion molecule, nephrin', 90, NULL, NULL, 39525),
(39526, '1.20.1250.20-FF-000673', NULL, 'SLC (SoLute Carrier) homolog', 209, NULL, NULL, 39526),
(39527, '2.60.40.60-FF-000442', NULL, 'Cadherin 4, retinal', 96, NULL, NULL, 39527),
(39528, '1.20.120.1810-FF-000005', NULL, 'RNA polymerase sigma factor SigB', 102, NULL, NULL, 39528),
(39529, '3.30.450.20-FF-000348', NULL, 'Two component system histidine kinase', 126, NULL, NULL, 39529),
(39530, '3.40.120.10-FF-000071', NULL, 'Phosphoacetylglucosamine mutase', 130, NULL, NULL, 39530),
(39531, '3.40.630.30-FF-000110', NULL, 'Ribosomal-protein-serine acetyltransferase', 177, NULL, NULL, 39531),
(39532, '2.60.120.10-FF-000424', NULL, 'Uncharacterized protein', 186, NULL, NULL, 39532),
(39533, '3.40.50.10190-FF-000037', NULL, 'Mediator of DNA damage checkpoint protein 1', 98, NULL, NULL, 39533),
(39534, '2.10.25.10-FF-001030', NULL, 'Laminin-like protein epi-1', 43, NULL, NULL, 39534),
(39535, '3.30.710.10-FF-000096', NULL, 'Trithorax-like, isoform C', 144, NULL, NULL, 39535),
(39536, '2.60.40.10-FF-002035', NULL, 'Mesocentin', 100, NULL, NULL, 39536),
(39537, '3.40.50.300-FF-003980', NULL, 'Uncharacterized protein', 130, NULL, NULL, 39537),
(39538, '3.40.50.300-FF-007196', NULL, 'ABC transporter, putative', 168, NULL, NULL, 39538),
(39539, '1.10.720.30-FF-000053', NULL, 'AGAP005031-PA', 54, NULL, NULL, 39539),
(39540, '2.60.40.150-FF-000144', NULL, 'RAS p21 protein activator 3', 125, NULL, NULL, 39540),
(39541, '3.90.70.10-FF-000190', NULL, 'Ubiquitin carboxyl-terminal hydrolase 8', 343, NULL, NULL, 39541),
(39542, '1.25.40.10-FF-000005', NULL, 'Clathrin heavy chain', 154, NULL, NULL, 39542);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(39543, '2.30.29.30-FF-000476', NULL, 'Oxysterol-binding protein-related protein 2', 98, NULL, NULL, 39543),
(39544, '1.25.40.20-FF-000008', NULL, 'Apoptosis-stimulating of p53 protein 2 isoform 1', 225, NULL, NULL, 39544),
(39545, '1.20.1560.10-FF-000772', NULL, 'Uncharacterized protein', 306, NULL, NULL, 39545),
(39546, '1.20.5.170-FF-000092', NULL, 'Basic-leucine zipper transcription factor', 54, NULL, NULL, 39546),
(39547, '3.40.50.720-FF-002257', NULL, 'C-terminal-binding protein 1', 60, NULL, NULL, 39547),
(39548, '3.40.50.12610-FF-000005', NULL, 'Dolichyl-monophosphooligosaccharide--protein glycotransferase AglB', 192, NULL, NULL, 39548),
(39549, '3.40.1110.10-FF-000300', NULL, NULL, 224, NULL, NULL, 39549),
(39550, '3.80.10.10-FF-004508', NULL, 'Uncharacterized protein', 109, NULL, NULL, 39550),
(39551, '3.20.20.70-FF-000218', NULL, 'Ribulose-phosphate 3-epimerase', 210, NULL, NULL, 39551),
(39552, '3.30.470.10-FF-000054', NULL, 'Uncharacterized protein', 78, NULL, NULL, 39552),
(39553, '3.30.70.330-FF-001045', NULL, 'Uncharacterized protein, isoform B', 101, NULL, NULL, 39553),
(39554, '3.30.70.600-FF-000018', NULL, 'Ribosomal protein S10p/S20e', 101, NULL, NULL, 39554),
(39555, '3.40.50.300-FF-007252', NULL, 'Uncharacterized protein', 159, NULL, NULL, 39555),
(39556, '2.30.40.10-FF-000159', NULL, 'Imidazolonepropionase', 86, NULL, NULL, 39556),
(39557, '3.30.160.60-FF-000450', NULL, 'PR domain zinc finger protein 14', 29, NULL, NULL, 39557),
(39558, '3.40.600.10-FF-000001', NULL, 'DNA mismatch repair protein MutH', 229, NULL, NULL, 39558),
(39559, '2.30.39.10-FF-000021', NULL, 'Serpin family B member 9', 43, NULL, NULL, 39559),
(39560, '1.20.1070.10-FF-000807', NULL, 'Visual pigment-like receptor peropsin', 221, NULL, NULL, 39560),
(39561, '1.10.8.50-FF-000014', NULL, 'Type 2 DNA topoisomerase 6 subunit B', 78, NULL, NULL, 39561),
(39562, '3.80.10.10-FF-002709', NULL, 'Predicted protein', 117, NULL, NULL, 39562),
(39563, '3.60.21.50-FF-000022', NULL, 'Uncharacterized protein', 246, NULL, NULL, 39563),
(39564, '3.40.50.11000-FF-000005', NULL, 'Fe-S cluster assembly protein DRE2', 40, NULL, NULL, 39564),
(39565, '3.30.1490.20-FF-000052', NULL, 'Formate-dependent phosphoribosylglycinamide formyltransferase', 70, NULL, NULL, 39565),
(39566, '2.60.40.10-FF-003614', NULL, NULL, 92, NULL, NULL, 39566),
(39567, '2.60.40.10-FF-006020', NULL, NULL, 96, NULL, NULL, 39567),
(39568, '3.60.21.60-FF-000025', NULL, 'Uncharacterized protein', 69, NULL, NULL, 39568),
(39569, '1.10.565.10-FF-000207', NULL, 'Coup transcription factor, putative', 147, NULL, NULL, 39569),
(39570, '1.25.40.470-FF-000048', NULL, 'Uncharacterized protein', 210, NULL, NULL, 39570),
(39571, '1.10.10.60-FF-001097', NULL, NULL, 71, NULL, NULL, 39571),
(39572, '3.40.50.150-FF-001552', NULL, NULL, 81, NULL, NULL, 39572),
(39573, '1.20.120.1320-FF-000010', NULL, NULL, 94, NULL, NULL, 39573),
(39574, '2.60.40.2160-FF-000003', NULL, 'Interleukin 17 receptor A', 171, NULL, NULL, 39574),
(39575, '3.30.342.10-FF-000009', NULL, 'DNA polymerase', 167, NULL, NULL, 39575),
(39576, '1.20.1270.60-FF-000164', NULL, 'Putative Sip3 protein', 259, NULL, NULL, 39576),
(39577, '3.80.10.10-FF-000237', NULL, 'F-box only protein 39', 368, NULL, NULL, 39577),
(39578, '3.30.470.20-FF-000057', NULL, 'Carbamoyl-phosphate synthetase 2, aspartate transcarbamylase, and dihydroorotase', 107, NULL, NULL, 39578),
(39579, '3.90.190.10-FF-000058', NULL, 'myotubularin-related protein 14 isoform X2', 126, NULL, NULL, 39579),
(39580, '3.40.50.2020-FF-000111', NULL, 'Ribose-phosphate pyrophosphokinase', 146, NULL, NULL, 39580),
(39581, '1.25.10.10-FF-003106', NULL, 'Uncharacterized protein', 219, NULL, NULL, 39581),
(39582, '3.90.70.80-FF-000019', NULL, 'Cysteine proteinases superfamily protein', 177, NULL, NULL, 39582),
(39583, '3.30.1550.10-FF-000009', NULL, 'RPL12 isoform 4', 38, NULL, NULL, 39583),
(39584, '1.25.40.10-FF-003771', NULL, 'Sel1 repeat protein', 157, NULL, NULL, 39584),
(39585, '2.10.25.10-FF-000535', NULL, 'Si:dkey-237h12.3', 31, NULL, NULL, 39585);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(39586, '3.20.70.20-FF-000055', NULL, 'Predicted protein', 122, NULL, NULL, 39586),
(39587, '4.10.400.10-FF-000112', NULL, 'Low-density lipoprotein receptor-related protein 2', 36, NULL, NULL, 39587),
(39588, '3.40.50.300-FF-005739', NULL, 'Uncharacterized protein', 149, NULL, NULL, 39588),
(39589, '2.60.120.200-FF-000747', NULL, 'MAM domain-containing glycosylphosphatidylinositol anchor 2a', 139, NULL, NULL, 39589),
(39590, '3.40.1360.10-FF-000054', NULL, 'Topoisomerase', 139, NULL, NULL, 39590),
(39591, '3.30.460.10-FF-000172', NULL, 'DNA polymerase', 94, NULL, NULL, 39591),
(39592, '3.20.20.70-FF-000550', NULL, NULL, 201, NULL, NULL, 39592),
(39593, '3.40.50.450-FF-000012', NULL, 'LOG family protein YvdD', 190, NULL, NULL, 39593),
(39594, '1.25.40.10-FF-001641', NULL, 'Os12g0114400 protein', 100, NULL, NULL, 39594),
(39595, '2.60.40.10-FF-003671', NULL, NULL, 106, NULL, NULL, 39595),
(39596, '1.10.3450.40-FF-000017', NULL, NULL, 193, NULL, NULL, 39596),
(39597, '3.40.50.460-FF-000015', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit beta', 38, NULL, NULL, 39597),
(39598, '2.160.20.80-FF-000004', NULL, 'RNA-binding motif protein 6', 189, NULL, NULL, 39598),
(39599, '3.10.25.10-FF-000010', NULL, '10-formyltetrahydrofolate dehydrogenase', 103, NULL, NULL, 39599),
(39600, '2.60.40.1670-FF-000013', NULL, 'Protein transport protein SEC23', 51, NULL, NULL, 39600),
(39601, '1.20.1740.10-FF-000207', NULL, 'Uncharacterized protein', 146, NULL, NULL, 39601),
(39602, '3.30.70.330-FF-001084', NULL, '50S ribosomal protein L23', 86, NULL, NULL, 39602),
(39603, '1.20.1270.60-FF-000220', NULL, 'SH3 and F-BAR domain-containing protein DDB_G0274695', 288, NULL, NULL, 39603),
(39604, '2.60.40.1660-FF-000010', NULL, 'Sodium/potassium-transporting ATPase subunit beta-2-like Protein', 234, NULL, NULL, 39604),
(39605, '3.40.630.30-FF-000492', NULL, 'Acyl-CoA N-acyltransferase', 145, NULL, NULL, 39605),
(39606, '1.25.40.20-FF-000340', NULL, 'serine/threonine-protein kinase TNNI3K', 64, NULL, NULL, 39606),
(39607, '1.10.10.10-FF-001633', NULL, 'Uncharacterized protein', 92, NULL, NULL, 39607),
(39608, '1.20.1070.10-FF-001027', NULL, 'Uncharacterized protein', 120, NULL, NULL, 39608),
(39609, '2.60.40.10-FF-001872', NULL, 'lachesin', 118, NULL, NULL, 39609),
(39610, '2.40.50.1070-FF-000006', NULL, '23S rRNA (uracil(1939)-C(5))-methyltransferase RlmD', 142, NULL, NULL, 39610),
(39611, '3.80.10.10-FF-000855', NULL, 'Blast:Leucine-rich repeat-containing protein 4B', 120, NULL, NULL, 39611),
(39612, '3.30.160.60-FF-004103', NULL, NULL, 32, NULL, NULL, 39612),
(39613, '3.30.930.10-FF-000039', NULL, 'Threonyl-tRNA synthetase, mitochondrial', 311, NULL, NULL, 39613),
(39614, '1.10.10.10-FF-001672', NULL, 'Winged helix-turn-helix transcriptional regulator, Rrf2 family', 136, NULL, NULL, 39614),
(39615, '3.40.50.12780-FF-000067', NULL, 'Probable chain-fatty-acid-CoA ligase fadD13', 397, NULL, NULL, 39615),
(39616, '1.20.1280.50-FF-000043', NULL, 'F-box only protein 5', 96, NULL, NULL, 39616),
(39617, '3.40.50.1820-FF-001012', NULL, 'Cutinase', 216, NULL, NULL, 39617),
(39618, '1.50.10.10-FF-000153', NULL, 'Uncharacterized protein', 412, NULL, NULL, 39618),
(39619, '1.20.5.730-FF-000012', NULL, 'Rho-associated protein kinase 2', 72, NULL, NULL, 39619),
(39620, '2.160.20.70-FF-000001', NULL, 'Adenylyl cyclase-associated protein', 163, NULL, NULL, 39620),
(39621, '1.10.840.10-FF-000044', NULL, 'Phosphoinositide phospholipase C', 261, NULL, NULL, 39621),
(39622, '1.20.5.1230-FF-000003', NULL, NULL, 157, NULL, NULL, 39622),
(39623, '1.25.40.10-FF-003714', NULL, 'Uncharacterized protein', 90, NULL, NULL, 39623),
(39624, '1.10.260.40-FF-000071', NULL, 'One cut domain family member 2', 85, NULL, NULL, 39624),
(39625, '2.60.120.200-FF-000129', NULL, 'Vitamin K-dependent protein S', 202, NULL, NULL, 39625),
(39626, '3.40.50.300-FF-005397', NULL, 'Uncharacterized protein', 260, NULL, NULL, 39626),
(39627, '1.10.510.10-FF-000233', NULL, 'receptor tyrosine-protein kinase erbB-3', 190, NULL, NULL, 39627),
(39628, '3.40.50.300-FF-007538', NULL, 'Uncharacterized protein', 201, NULL, NULL, 39628);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(39629, '2.60.40.10-FF-001815', NULL, 'pregnancy zone protein-like', 87, NULL, NULL, 39629),
(39630, '3.20.20.80-FF-000553', NULL, 'Uncharacterized protein', 188, NULL, NULL, 39630),
(39631, '3.30.70.330-FF-000769', NULL, 'RNA-binding protein, putative', 105, NULL, NULL, 39631),
(39632, '3.30.40.10-FF-000937', NULL, 'E3 ubiquitin-protein ligase RZFP34', 52, NULL, NULL, 39632),
(39633, '1.10.510.10-FF-003667', NULL, NULL, 177, NULL, NULL, 39633),
(39634, '3.40.980.10-FF-000034', NULL, 'Molybdopterin molybdenumtransferase', 145, NULL, NULL, 39634),
(39635, '3.80.10.10-FF-003261', NULL, 'Uncharacterized protein', 168, NULL, NULL, 39635),
(39636, '3.40.50.1820-FF-000793', NULL, 'GPI inositol-deacylase', 215, NULL, NULL, 39636),
(39637, '3.40.50.10330-FF-000006', NULL, 'Diacylglycerol kinase', 125, NULL, NULL, 39637),
(39638, '2.40.400.10-FF-000001', NULL, 'FAD binding domain protein', 304, NULL, NULL, 39638),
(39639, '2.160.20.10-FF-000079', NULL, 'Probable GLUCAN ENDO-1, 3-BETA-GLUCOSIDASE BGN13.1', 375, NULL, NULL, 39639),
(39640, '2.60.120.260-FF-000669', NULL, 'AFR597Wp', 166, NULL, NULL, 39640),
(39641, '3.40.50.300-FF-005958', NULL, 'Chromosome 1, whole genome shotgun sequence', 221, NULL, NULL, 39641),
(39642, '3.90.1750.10-FF-000016', NULL, 'E3 ubiquitin-protein ligase UBR5 isoform X2', 119, NULL, NULL, 39642),
(39643, '3.30.420.10-FF-000175', NULL, 'RNA exonuclease 5', 165, NULL, NULL, 39643),
(39644, '3.30.30.30-FF-000033', NULL, 'HSP70-family chaperone protein, putative', 52, NULL, NULL, 39644),
(39645, '1.10.510.10-FF-003942', NULL, NULL, 61, NULL, NULL, 39645),
(39646, '3.30.505.10-FF-000080', NULL, 'Pi3K21B, isoform C', 118, NULL, NULL, 39646),
(39647, '1.20.920.10-FF-000228', NULL, 'PHD Zn finger-containing protein', 144, NULL, NULL, 39647),
(39648, '1.20.120.1760-FF-000063', NULL, NULL, 188, NULL, NULL, 39648),
(39649, '3.30.930.10-FF-000191', NULL, 'Bifunctional protein BirA: biotin operon repressor + biotin--[acetyl-CoA-carboxylase] synthetase', 218, NULL, NULL, 39649),
(39650, '1.10.8.10-FF-000249', NULL, 'Subunit of ESCRT-II complex', 61, NULL, NULL, 39650),
(39651, '1.25.40.20-FF-000160', NULL, 'KN motif and ankyrin repeat domain-containing protein 3', 248, NULL, NULL, 39651),
(39652, '2.130.10.10-FF-002867', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One component system)', 246, NULL, NULL, 39652),
(39653, '3.40.50.360-FF-000154', NULL, 'FMN-dependent NADH-azoreductase', 203, NULL, NULL, 39653),
(39654, '3.40.50.300-FF-006234', NULL, 'Uncharacterized protein', 261, NULL, NULL, 39654),
(39655, '3.80.10.10-FF-001131', NULL, 'Os04g0132500 protein', 155, NULL, NULL, 39655),
(39656, '3.30.1120.10-FF-000022', NULL, 'Arylsulfatase A', 66, NULL, NULL, 39656),
(39657, '1.20.120.1080-FF-000067', NULL, 'Dosage compensation regulator-like Protein', 100, NULL, NULL, 39657),
(39658, '2.130.10.10-FF-001288', NULL, 'TOMosyn synaptic protein', 123, NULL, NULL, 39658),
(39659, '1.10.590.10-FF-000007', NULL, 'Chorismate mutase1', 149, NULL, NULL, 39659),
(39660, '3.40.640.10-FF-000397', NULL, 'Uncharacterized protein', 46, NULL, NULL, 39660),
(39661, '1.25.40.10-FF-003439', NULL, 'Pentatricopeptide repeat-containing protein At1g62720', 42, NULL, NULL, 39661),
(39662, '1.20.1170.10-FF-000012', NULL, NULL, 267, NULL, NULL, 39662),
(39663, '3.40.50.300-FF-007813', NULL, 'Uncharacterized protein', 286, NULL, NULL, 39663),
(39664, '2.60.120.10-FF-000188', NULL, 'Transcriptional activator putative', 91, NULL, NULL, 39664),
(39665, '3.40.50.1010-FF-000252', NULL, NULL, 157, NULL, NULL, 39665),
(39666, '3.20.20.80-FF-000278', NULL, 'Glucan 1,6-alpha-glucosidase', 402, NULL, NULL, 39666),
(39667, '3.30.9.10-FF-000180', NULL, 'FAD-binding oxidoreductase', 154, NULL, NULL, 39667),
(39668, '3.60.10.10-FF-000283', NULL, 'Putative inositol polyphosphate phosphatase (Synaptogenin-like) family protein', 115, NULL, NULL, 39668),
(39669, '1.20.120.350-FF-000212', NULL, NULL, 113, NULL, NULL, 39669),
(39670, '3.30.499.10-FF-000030', NULL, 'Aconitate hydratase', 180, NULL, NULL, 39670);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(39671, '3.20.20.70-FF-000494', NULL, NULL, 150, NULL, NULL, 39671),
(39672, '3.40.30.10-FF-000408', NULL, 'Possible thioredoxin protein', 139, NULL, NULL, 39672),
(39673, '3.80.10.10-FF-000911', NULL, 'Protein lap4-like Protein', 180, NULL, NULL, 39673),
(39674, '3.30.420.40-FF-000897', NULL, 'Heat shock cognate 70 kDa protein 4', 90, NULL, NULL, 39674),
(39675, '3.40.50.80-FF-000099', NULL, 'NADPH-cytochrome P450 reductase', 144, NULL, NULL, 39675),
(39676, '3.40.50.10320-FF-000003', NULL, '1D-myo-inositol 2-acetamido-2-deoxy-alpha-D-glucopyranoside deacetylase', 303, NULL, NULL, 39676),
(39677, '1.10.240.10-FF-000021', NULL, 'Tyrosine--tRNA ligase', 43, NULL, NULL, 39677),
(39678, '1.10.238.10-FF-000313', NULL, 'Probable calcium-binding protein CML16', 153, NULL, NULL, 39678),
(39679, '1.20.58.60-FF-000745', NULL, 'Si:ch211-207i1.2', 260, NULL, NULL, 39679),
(39680, '3.30.420.10-FF-000517', NULL, NULL, 121, NULL, NULL, 39680),
(39681, '3.40.50.10190-FF-000150', NULL, 'DNA-directed DNA/RNA polymerase mu', 101, NULL, NULL, 39681),
(39682, '2.130.10.10-FF-005559', NULL, 'Uncharacterized protein', 219, NULL, NULL, 39682),
(39683, '1.10.510.10-FF-003723', NULL, NULL, 153, NULL, NULL, 39683),
(39684, '2.30.40.10-FF-000092', NULL, 'Cytosine deaminase', 78, NULL, NULL, 39684),
(39685, '3.20.20.80-FF-000497', NULL, 'Uncharacterized protein', 221, NULL, NULL, 39685),
(39686, '1.10.510.10-FF-003049', NULL, NULL, 211, NULL, NULL, 39686),
(39687, '3.30.70.330-FF-001483', NULL, NULL, 74, NULL, NULL, 39687),
(39688, '3.40.50.620-FF-000760', NULL, 'AGAP009543-PA', 129, NULL, NULL, 39688),
(39689, '1.10.3720.10-FF-000220', NULL, 'Proline/glycine betaine ABC superfamily ATP binding cassette transporter, membrane protein', 200, NULL, NULL, 39689),
(39690, '1.10.10.830-FF-000003', NULL, 'Isoleucine--tRNA ligase, chloroplastic/mitochondrial', 54, NULL, NULL, 39690),
(39691, '1.20.120.1770-FF-000009', NULL, 'Related to CYTOCHROME B561', 200, NULL, NULL, 39691),
(39692, '3.40.50.1260-FF-000035', NULL, 'Phosphoglycerate kinase', 126, NULL, NULL, 39692),
(39693, '3.10.250.10-FF-000115', NULL, NULL, 72, NULL, NULL, 39693),
(39694, '1.20.1070.10-FF-001140', NULL, 'Tachykinin-like peptides receptor 99D', 375, NULL, NULL, 39694),
(39695, '1.10.3450.20-FF-000011', NULL, 'Uncharacterized protein', 132, NULL, NULL, 39695),
(39696, '2.60.40.10-FF-001198', NULL, 'Beta-glucuronidase UidA', 96, NULL, NULL, 39696),
(39697, '3.40.50.300-FF-001288', NULL, 'Conjugal transfer protein TraB', 159, NULL, NULL, 39697),
(39698, '3.40.367.20-FF-000045', NULL, 'Phosphotransferase', 170, NULL, NULL, 39698),
(39699, '2.160.20.10-FF-000298', NULL, 'Uncharacterized protein', 149, NULL, NULL, 39699),
(39700, '3.20.20.80-FF-000839', NULL, 'Uncharacterized protein', 31, NULL, NULL, 39700),
(39701, '1.20.58.80-FF-000009', NULL, 'spartin isoform X1', 93, NULL, NULL, 39701),
(39702, '3.30.70.1430-FF-000010', NULL, 'RND multidrug efflux transporter', 93, NULL, NULL, 39702),
(39703, '3.30.420.10-FF-000736', NULL, NULL, 185, NULL, NULL, 39703),
(39704, '3.40.1380.20-FF-000002', NULL, 'Pyruvate kinase', 51, NULL, NULL, 39704),
(39705, '1.10.510.10-FF-003381', NULL, NULL, 321, NULL, NULL, 39705),
(39706, '3.40.50.10330-FF-000063', NULL, 'NAD kinase', 130, NULL, NULL, 39706),
(39707, '3.40.630.150-FF-000019', NULL, 'Malonyl-CoA decarboxylase, mitochondrial, putative', 124, NULL, NULL, 39707),
(39708, '3.60.130.10-FF-000090', NULL, 'Clavaminate synthase-like protein', 134, NULL, NULL, 39708),
(39709, '4.10.640.10-FF-000040', NULL, 'Uncharacterized protein', 42, NULL, NULL, 39709),
(39710, '1.10.135.10-FF-000001', NULL, 'Creatine kinase M-type', 102, NULL, NULL, 39710),
(39711, '2.60.40.10-FF-001692', NULL, 'Immunoglobulin superfamily containing leucine-rich repeat protein', 114, NULL, NULL, 39711),
(39712, '3.40.50.300-FF-007870', NULL, 'Uncharacterized protein', 207, NULL, NULL, 39712),
(39713, '1.10.540.10-FF-000061', NULL, 'Acyl-CoA dehydrogenase fadE3', 118, NULL, NULL, 39713),
(39714, '3.40.50.10470-FF-000020', NULL, 'Eukaryotic translation initiation factor 2b, subunit 2, putative', 199, NULL, NULL, 39714);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(39715, '3.40.50.300-FF-003941', NULL, 'Uncharacterized protein', 174, NULL, NULL, 39715),
(39716, '1.20.1070.10-FF-000864', NULL, 'Protein CBG03354', 228, NULL, NULL, 39716),
(39717, '3.30.160.60-FF-003940', NULL, NULL, 26, NULL, NULL, 39717),
(39718, '3.30.420.40-FF-000678', NULL, 'Glycerol kinase', 311, NULL, NULL, 39718),
(39719, '2.60.120.200-FF-000461', NULL, 'Deleted in malignant brain tumors 1 protein', 175, NULL, NULL, 39719),
(39720, '2.130.10.10-FF-001849', NULL, 'Telomerase protein component 1', 140, NULL, NULL, 39720),
(39721, '3.40.50.200-FF-000134', NULL, 'Glr3087 protein', 120, NULL, NULL, 39721),
(39722, '3.20.20.70-FF-000275', NULL, 'tRNA-dihydrouridine synthase', 235, NULL, NULL, 39722),
(39723, '3.40.50.10490-FF-000026', NULL, '28S ribosomal protein S2, mitochondrial', 196, NULL, NULL, 39723),
(39724, '3.40.50.800-FF-000038', NULL, 'Histidine--tRNA ligase', 93, NULL, NULL, 39724),
(39725, '3.40.630.30-FF-000615', NULL, 'N-alpha-acetyltransferase 40', 194, NULL, NULL, 39725),
(39726, '2.30.42.10-FF-000383', NULL, NULL, 106, NULL, NULL, 39726),
(39727, '3.40.50.150-FF-001496', NULL, NULL, 117, NULL, NULL, 39727),
(39728, '2.30.180.10-FF-000114', NULL, NULL, 207, NULL, NULL, 39728),
(39729, '3.40.50.1820-FF-000517', NULL, 'Lipase domain containing protein', 266, NULL, NULL, 39729),
(39730, '3.40.390.10-FF-000293', NULL, NULL, 77, NULL, NULL, 39730),
(39731, '3.30.40.10-FF-001051', NULL, 'SNF2 family helicase/ATPase', 118, NULL, NULL, 39731),
(39732, '2.60.40.10-FF-005469', NULL, NULL, 103, NULL, NULL, 39732),
(39733, '3.30.9.10-FF-000028', NULL, 'FAD dependent oxidoreductase', 157, NULL, NULL, 39733),
(39734, '1.10.418.70-FF-000002', NULL, 'Intraflagellar Transport Protein 81', 126, NULL, NULL, 39734),
(39735, '3.30.450.20-FF-000387', NULL, 'Sensor histidine kinase', 112, NULL, NULL, 39735),
(39736, '1.10.418.80-FF-000005', NULL, NULL, 47, NULL, NULL, 39736),
(39737, '3.30.70.330-FF-000589', NULL, 'RNA-binding protein-like', 137, NULL, NULL, 39737),
(39738, '1.10.246.90-FF-000013', NULL, 'Archaeal nucleolar protein homolog', 115, NULL, NULL, 39738),
(39739, '3.30.930.10-FF-000258', NULL, 'Uncharacterized protein', 213, NULL, NULL, 39739),
(39740, '1.10.10.140-FF-000004', NULL, 'Cytochrome c oxidase subunit', 78, NULL, NULL, 39740),
(39741, '1.20.1310.10-FF-000220', NULL, NULL, 69, NULL, NULL, 39741),
(39742, '1.10.506.10-FF-000015', NULL, 'Neurofibromin isoform 1', 94, NULL, NULL, 39742),
(39743, '4.10.110.10-FF-000011', NULL, 'Epi-1', 66, NULL, NULL, 39743),
(39744, '2.130.10.10-FF-003143', NULL, 'Intraflagellar transport particle protein IFT140', 214, NULL, NULL, 39744),
(39745, '3.30.2140.20-FF-000026', NULL, 'arylamine N-acetyltransferase, pineal gland isozyme NAT-3', 297, NULL, NULL, 39745),
(39746, '1.25.10.10-FF-003382', NULL, 'Uncharacterized protein', 145, NULL, NULL, 39746),
(39747, '3.40.50.150-FF-001439', NULL, NULL, 146, NULL, NULL, 39747),
(39748, '1.20.1070.10-FF-001701', NULL, 'Uncharacterized protein', 108, NULL, NULL, 39748),
(39749, '3.40.50.10490-FF-000083', NULL, 'Glucose-6-phosphate isomerase', 184, NULL, NULL, 39749),
(39750, '3.90.1750.20-FF-000019', NULL, NULL, 134, NULL, NULL, 39750),
(39751, '4.10.240.10-FF-000015', NULL, 'Nitrogen assimilation transcription factor nirA', 92, NULL, NULL, 39751),
(39752, '1.20.58.60-FF-000184', NULL, 'Coiled-coil domain containing 141', 94, NULL, NULL, 39752),
(39753, '3.40.30.10-FF-000066', NULL, 'FAS-associated factor 2 isoform X2', 153, NULL, NULL, 39753),
(39754, '3.30.70.330-FF-002101', NULL, NULL, 120, NULL, NULL, 39754),
(39755, '1.25.10.10-FF-003325', NULL, 'Serine/threonine-protein kinase TOR', 136, NULL, NULL, 39755),
(39756, '1.10.1060.10-FF-000023', NULL, 'FAD-linked oxidase', 126, NULL, NULL, 39756),
(39757, '2.30.30.40-FF-000313', NULL, 'SH3 domain protein', 61, NULL, NULL, 39757),
(39758, '3.40.30.10-FF-000009', NULL, 'Tumor suppressor candidate 3', 157, NULL, NULL, 39758),
(39759, '3.10.270.10-FF-000004', NULL, '2-oxo-4-hydroxy-4-carboxy--5-ureidoimidazoline (OHCU) decarboxylase', 322, NULL, NULL, 39759);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(39760, '1.25.40.10-FF-005160', NULL, 'Predicted protein', 276, NULL, NULL, 39760),
(39761, '1.10.238.20-FF-000013', NULL, 'Odorant-binding protein 56i, isoform B', 108, NULL, NULL, 39761),
(39762, '4.10.400.10-FF-000331', NULL, 'Uncharacterized protein', 47, NULL, NULL, 39762),
(39763, '2.70.150.10-FF-000103', NULL, 'Calcium-translocating P-type ATPase, SERCA-type', 128, NULL, NULL, 39763),
(39764, '1.10.8.10-FF-000159', NULL, 'Uncharacterized protein', 40, NULL, NULL, 39764),
(39765, '1.10.10.60-FF-001182', NULL, NULL, 33, NULL, NULL, 39765),
(39766, '3.40.50.2300-FF-000881', NULL, NULL, 128, NULL, NULL, 39766),
(39767, '1.20.1070.10-FF-000353', NULL, 'G-protein coupled receptor GRL101-like protein', 329, NULL, NULL, 39767),
(39768, '3.30.40.10-FF-000915', NULL, 'RING-type E3 ubiquitin transferase', 76, NULL, NULL, 39768),
(39769, '1.10.10.10-FF-001318', NULL, 'Uncharacterized protein', 73, NULL, NULL, 39769),
(39770, '3.30.420.10-FF-000427', NULL, NULL, 191, NULL, NULL, 39770),
(39771, '2.60.60.20-FF-000027', NULL, 'Protein CBR-LOV-1', 127, NULL, NULL, 39771),
(39772, '1.10.530.10-FF-000026', NULL, 'Lysozyme g', 185, NULL, NULL, 39772),
(39773, '1.20.1600.10-FF-000023', NULL, 'Outer membrane protein TolC', 394, NULL, NULL, 39773),
(39774, '1.10.10.10-FF-000216', NULL, 'DNA-binding response regulator', 103, NULL, NULL, 39774),
(39775, '1.20.1070.10-FF-000869', NULL, 'CholecystoKinin Receptor homolog', 137, NULL, NULL, 39775),
(39776, '3.90.550.10-FF-000215', NULL, 'D-alpha-D-mannose-1-phosphate guanylyltransferase ManB', 239, NULL, NULL, 39776),
(39777, '1.10.510.10-FF-001554', NULL, 'Kinase, NEK', 204, NULL, NULL, 39777),
(39778, '1.10.510.10-FF-003678', NULL, NULL, 172, NULL, NULL, 39778),
(39779, '3.40.50.300-FF-007903', NULL, 'Predicted protein', 188, NULL, NULL, 39779),
(39780, '1.10.600.10-FF-000055', NULL, 'Squalene synthase HpnC', 257, NULL, NULL, 39780),
(39781, '2.30.29.30-FF-000408', NULL, 'Pleckstrin (PH) domain containing family protein', 110, NULL, NULL, 39781),
(39782, '3.20.20.220-FF-000003', NULL, 'Methylenetetrahydrofolate reductase', 295, NULL, NULL, 39782),
(39783, '1.25.40.10-FF-003552', NULL, 'Pentatricopeptide repeat-containing protein At5g04810, chloroplastic', 71, NULL, NULL, 39783),
(39784, '3.30.160.60-FF-005407', NULL, NULL, 44, NULL, NULL, 39784),
(39785, '2.102.10.10-FF-000053', NULL, 'Predicted protein', 78, NULL, NULL, 39785),
(39786, '2.60.40.10-FF-005284', NULL, NULL, 83, NULL, NULL, 39786),
(39787, '3.90.850.10-FF-000053', NULL, NULL, 191, NULL, NULL, 39787),
(39788, '1.20.1280.50-FF-000015', NULL, 'F-box/WD repeat-containing protein 2 isoform X2', 90, NULL, NULL, 39788),
(39789, '1.50.10.10-FF-000243', NULL, 'Mannosyl-oligosaccharide glucosidase', 216, NULL, NULL, 39789),
(39790, '2.60.40.10-FF-003676', NULL, NULL, 87, NULL, NULL, 39790),
(39791, '1.10.510.10-FF-002060', NULL, 'SH3 domain-binding kinase family, member 3', 284, NULL, NULL, 39791),
(39792, '3.80.10.10-FF-000653', NULL, 'F-box/LRR-repeat protein 14', 171, NULL, NULL, 39792),
(39793, '3.30.479.10-FF-000012', NULL, '6-carboxy-5,6,7,8-tetrahydropterin synthase', 119, NULL, NULL, 39793),
(39794, '3.60.20.10-FF-000098', NULL, 'Proteasome subunit beta', 227, NULL, NULL, 39794),
(39795, '3.40.33.10-FF-000033', NULL, 'Protein lon-1', 199, NULL, NULL, 39795),
(39796, '3.30.160.60-FF-001664', NULL, 'Zinc finger protein 133', 31, NULL, NULL, 39796),
(39797, '2.60.40.60-FF-000032', NULL, 'FAT atypical cadherin 1', 98, NULL, NULL, 39797),
(39798, '1.10.238.220-FF-000014', NULL, NULL, 25, NULL, NULL, 39798),
(39799, '1.20.1560.10-FF-000418', NULL, 'ABC transporter HlyB/MsbA family', 312, NULL, NULL, 39799),
(39800, '3.20.20.140-FF-000277', NULL, 'Slr0619 protein', 336, NULL, NULL, 39800),
(39801, '3.40.50.720-FF-000970', NULL, 'Similar to surfactin synthetase', 379, NULL, NULL, 39801),
(39802, '3.40.50.10190-FF-000127', NULL, 'Mutagen-sensitive 101', 99, NULL, NULL, 39802),
(39803, '2.170.150.80-FF-000010', NULL, 'NAC domain-containing protein 67-like', 149, NULL, NULL, 39803),
(39804, '1.10.1240.10-FF-000003', NULL, '5-methyltetrahydrofolate--homocysteine methyltransferase', 94, NULL, NULL, 39804);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(39805, '3.30.479.20-FF-000015', NULL, 'Elongation factor Ts', 91, NULL, NULL, 39805),
(39806, '3.50.50.60-FF-000778', NULL, 'Fumarate reductase/succinate dehydrogenase flavoprotein domain protein', 282, NULL, NULL, 39806),
(39807, '1.25.40.180-FF-000046', NULL, 'Eukaryotic translation initiation factor 5', 151, NULL, NULL, 39807),
(39808, '2.30.29.30-FF-000397', NULL, 'Uncharacterized protein, isoform A', 127, NULL, NULL, 39808),
(39809, '3.30.559.10-FF-000159', NULL, 'Non-ribosomal peptide synthetase', 183, NULL, NULL, 39809),
(39810, '3.30.190.20-FF-000013', NULL, 'Ribosomal protein', 109, NULL, NULL, 39810),
(39811, '2.10.25.10-FF-000653', NULL, 'Putative Fibrillin-1', 42, NULL, NULL, 39811),
(39812, '2.40.50.1020-FF-000020', NULL, 'Putative two-component response regulator', 101, NULL, NULL, 39812),
(39813, '1.25.40.470-FF-000026', NULL, 'Intraflagellar transport protein 172 homolog', 129, NULL, NULL, 39813),
(39814, '3.40.50.720-FF-001150', NULL, '2-dehydropantoate 2-reductase', 174, NULL, NULL, 39814),
(39815, '3.30.70.330-FF-000786', NULL, 'Yme2p', 79, NULL, NULL, 39815),
(39816, '2.130.10.10-FF-005262', NULL, 'Uncharacterized protein', 260, NULL, NULL, 39816),
(39817, '3.30.70.100-FF-000037', NULL, 'NIPSNAP family protein', 114, NULL, NULL, 39817),
(39818, '3.40.50.150-FF-000091', NULL, 'tRNA 5-carboxymethoxyuridine methyltransferase', 254, NULL, NULL, 39818),
(39819, '3.80.10.10-FF-003879', NULL, 'Uncharacterized protein', 168, NULL, NULL, 39819),
(39820, '1.25.40.20-FF-001790', NULL, 'Predicted protein', 173, NULL, NULL, 39820),
(39821, '3.20.20.190-FF-000152', NULL, NULL, 237, NULL, NULL, 39821),
(39822, '1.50.40.10-FF-000071', NULL, 'probable ADP,ATP carrier protein At5g56450', 292, NULL, NULL, 39822),
(39823, '2.60.220.50-FF-000039', NULL, 'Adhesion G protein-coupled receptor G4b', 139, NULL, NULL, 39823),
(39824, '1.25.40.450-FF-000020', NULL, 'Uncharacterized protein', 117, NULL, NULL, 39824),
(39825, '3.40.30.10-FF-000526', NULL, 'AGAP012823-PA', 94, NULL, NULL, 39825),
(39826, '3.40.50.1360-FF-000003', NULL, 'Glucosamine-6-phosphate deaminase', 244, NULL, NULL, 39826),
(39827, '3.40.50.300-FF-005649', NULL, 'Guanylate kinase', 216, NULL, NULL, 39827),
(39828, '2.20.100.10-FF-000090', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 12', 58, NULL, NULL, 39828),
(39829, '2.130.10.10-FF-001193', NULL, 'DYnein Chain, light Intermediate', 169, NULL, NULL, 39829),
(39830, '2.130.10.10-FF-003654', NULL, 'Predicted protein', 134, NULL, NULL, 39830),
(39831, '1.10.510.10-FF-000126', NULL, 'Protein kinase C epsilon', 208, NULL, NULL, 39831),
(39832, '3.40.50.10090-FF-000069', NULL, 'Putative uroporphyrinogen III synthase', 102, NULL, NULL, 39832),
(39833, '3.30.710.10-FF-000293', NULL, 'Zinc finger and BTB domain-containing 7a', 153, NULL, NULL, 39833),
(39834, '3.90.320.10-FF-000069', NULL, 'Uncharacterized protein', 253, NULL, NULL, 39834),
(39835, '3.40.190.100-FF-000004', NULL, 'Probable glycine betaine-binding protein', 18, NULL, NULL, 39835),
(39836, '1.10.10.41-FF-000002', NULL, 'Topoisomerase I', 97, NULL, NULL, 39836),
(39837, '3.30.200.20-FF-001364', NULL, 'CMGC family protein kinase', 78, NULL, NULL, 39837),
(39838, '1.10.238.210-FF-000011', NULL, 'Glutaminase kidney isoform, mitochondrial', 82, NULL, NULL, 39838),
(39839, '3.40.50.1820-FF-001001', NULL, 'Alpha/beta hydrolase family, putative', 231, NULL, NULL, 39839),
(39840, '1.10.860.10-FF-000012', NULL, 'Replicative DNA helicase', 122, NULL, NULL, 39840),
(39841, '3.40.50.2000-FF-000572', NULL, 'Glycosyltransferase', 177, NULL, NULL, 39841),
(39842, '3.40.930.10-FF-000020', NULL, 'Anion exchange protein', 146, NULL, NULL, 39842),
(39843, '1.10.10.10-FF-001644', NULL, 'Uncharacterized protein', 83, NULL, NULL, 39843),
(39844, '3.40.50.300-FF-003188', NULL, 'ESX conserved componant EccC2', 246, NULL, NULL, 39844),
(39845, '1.25.10.10-FF-003078', NULL, 'Uncharacterized protein', 240, NULL, NULL, 39845),
(39846, '3.30.50.10-FF-000197', NULL, 'Uncharacterized protein', 57, NULL, NULL, 39846),
(39847, '3.40.50.10490-FF-000099', NULL, 'Transcriptional regulator RpiR family', 179, NULL, NULL, 39847);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(39848, '1.20.1250.20-FF-000454', NULL, 'Karmoisin, isoform B', 192, NULL, NULL, 39848),
(39849, '1.25.10.10-FF-002898', NULL, 'Uncharacterized protein', 137, NULL, NULL, 39849),
(39850, '2.60.40.10-FF-005930', NULL, NULL, 103, NULL, NULL, 39850),
(39851, '3.30.505.10-FF-000130', NULL, 'Spermatocyte protein spe-8', 107, NULL, NULL, 39851),
(39852, '3.40.50.970-FF-000168', NULL, 'Transketolase chloroplast putative', 48, NULL, NULL, 39852),
(39853, '3.40.50.150-FF-000102', NULL, 'tRNA (guanine(37)-N1)-methyltransferase', 208, NULL, NULL, 39853),
(39854, '1.10.238.10-FF-000010', NULL, 'Myosin regulatory light chain 2, atrial isoform', 68, NULL, NULL, 39854),
(39855, '3.60.110.10-FF-000049', NULL, 'Glutamine-dependent NAD(+) synthetase', 238, NULL, NULL, 39855),
(39856, '1.20.1260.10-FF-000053', NULL, 'Rho family-interacting cell polarization regulator 2', 51, NULL, NULL, 39856),
(39857, '2.30.40.10-FF-000075', NULL, 'Allantoinase', 113, NULL, NULL, 39857),
(39858, '2.30.29.30-FF-000734', NULL, 'Predicted protein', 109, NULL, NULL, 39858),
(39859, '1.20.5.170-FF-000209', NULL, 'cyclic nucleotide-gated channel rod photoreceptor subunit alpha-like isoform X1', 58, NULL, NULL, 39859),
(39860, '3.30.720.50-FF-000018', NULL, NULL, 86, NULL, NULL, 39860),
(39861, '1.25.40.10-FF-003922', NULL, 'Predicted protein', 293, NULL, NULL, 39861),
(39862, '1.20.1250.20-FF-000763', NULL, 'Organic cation/carnitine transporter 4', 408, NULL, NULL, 39862),
(39863, '3.30.160.60-FF-000236', NULL, 'zinc finger protein 143 isoform X1', 37, NULL, NULL, 39863),
(39864, '3.40.50.300-FF-003834', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 175, NULL, NULL, 39864),
(39865, '1.10.630.10-FF-000399', NULL, 'Cytochrome P450', 58, NULL, NULL, 39865),
(39866, '1.20.1560.10-FF-000744', NULL, 'Uncharacterized protein', 134, NULL, NULL, 39866),
(39867, '3.10.250.10-FF-000008', NULL, 'Lysyl oxidase homolog 2', 120, NULL, NULL, 39867),
(39868, '3.90.650.10-FF-000072', NULL, 'Uncharacterized protein', 87, NULL, NULL, 39868),
(39869, '3.40.720.10-FF-000083', NULL, 'Hydrolase of alkaline phosphatase superfamily', 275, NULL, NULL, 39869),
(39870, '3.90.660.10-FF-000027', NULL, 'Amine oxidase', 178, NULL, NULL, 39870),
(39871, '3.30.450.20-FF-000567', NULL, 'Putative methyl-accepting chemotaxis protein', 142, NULL, NULL, 39871),
(39872, '2.60.40.10-FF-006110', NULL, NULL, 110, NULL, NULL, 39872),
(39873, '3.40.850.10-FF-000295', NULL, 'Kinesin-like protein', 290, NULL, NULL, 39873),
(39874, '2.10.70.10-FF-000066', NULL, 'CUB and sushi domain-containing protein 3 isoform X1', 65, NULL, NULL, 39874),
(39875, '3.30.420.10-FF-000753', NULL, NULL, 63, NULL, NULL, 39875),
(39876, '3.90.640.10-FF-000144', NULL, 'Actin-like protein, putative', 78, NULL, NULL, 39876),
(39877, '1.10.10.2420-FF-000003', NULL, 'Glutamine--tRNA ligase', 40, NULL, NULL, 39877),
(39878, '1.10.390.10-FF-000037', NULL, 'TAF2 RNA polymerase II, TATA box binding (TBP)-associated factor, 150 kDa (TAF2), mRNA protein', 275, NULL, NULL, 39878),
(39879, '3.40.50.300-FF-007566', NULL, 'Predicted protein', 185, NULL, NULL, 39879),
(39880, '2.60.40.1180-FF-000203', NULL, 'Alpha-L-fucosidase', 69, NULL, NULL, 39880),
(39881, '3.30.2460.20-FF-000005', NULL, 'Protein Wnt', 61, NULL, NULL, 39881),
(39882, '3.40.1110.10-FF-000266', NULL, 'Phospholipid-transporting ATPase', 254, NULL, NULL, 39882),
(39883, '2.40.420.20-FF-000005', NULL, 'Efflux transporter, RND family, MFP subunit', 92, NULL, NULL, 39883),
(39884, '3.40.50.720-FF-002459', NULL, 'Shikimate dehydrogenase (NADP(+))', 136, NULL, NULL, 39884),
(39885, '3.30.40.10-FF-000595', NULL, 'MAG2p Cytoplasmic protein', 98, NULL, NULL, 39885),
(39886, '2.60.40.10-FF-001905', NULL, 'Muscle M-line assembly protein unc-89', 106, NULL, NULL, 39886),
(39887, '3.40.50.11500-FF-000032', NULL, NULL, 94, NULL, NULL, 39887),
(39888, '3.30.450.20-FF-000258', NULL, 'SIM bHLH transcription factor 2', 43, NULL, NULL, 39888),
(39889, '3.90.1210.10-FF-000009', NULL, NULL, 53, NULL, NULL, 39889),
(39890, '2.60.40.1730-FF-000060', NULL, NULL, 151, NULL, NULL, 39890);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(39891, '1.10.189.10-FF-000002', NULL, 'Pyruvate, phosphate dikinase', 59, NULL, NULL, 39891),
(39892, '3.40.50.300-FF-002423', NULL, 'Cobalt ABC transporter ATP-binding protein', 220, NULL, NULL, 39892),
(39893, '3.40.1350.10-FF-000014', NULL, 'tRNA intron endonuclease putative', 92, NULL, NULL, 39893),
(39894, '1.10.630.10-FF-000192', NULL, 'Cytochrome P450 monooxygenase, putative', 460, NULL, NULL, 39894),
(39895, '3.40.50.2000-FF-000779', NULL, 'Glycosyltransferase-like domain-containing protein 1', 156, NULL, NULL, 39895),
(39896, '3.40.449.10-FF-000002', NULL, 'Phosphoenolpyruvate carboxykinase [ATP]', 179, NULL, NULL, 39896),
(39897, '1.10.287.470-FF-000031', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 74, NULL, NULL, 39897),
(39898, '3.30.230.80-FF-000012', NULL, 'Cation-transporting ATPase, putative', 175, NULL, NULL, 39898),
(39899, '3.90.228.10-FF-000051', NULL, 'Poly [ADP-ribose] polymerase', 122, NULL, NULL, 39899),
(39900, '1.10.3720.10-FF-000113', NULL, 'ABC transporter permease', 195, NULL, NULL, 39900),
(39901, '3.30.160.60-FF-005733', NULL, NULL, 13, NULL, NULL, 39901),
(39902, '3.30.9.10-FF-000253', NULL, 'Uncharacterized protein', 162, NULL, NULL, 39902),
(39903, '4.10.1080.10-FF-000016', NULL, 'AAA ATPase containing von Willebrand factor type A (VWA) domain', 80, NULL, NULL, 39903),
(39904, '3.40.50.450-FF-000074', NULL, 'Uncharacterized protein', 190, NULL, NULL, 39904),
(39905, '2.30.29.30-FF-001240', NULL, 'Predicted protein', 113, NULL, NULL, 39905),
(39906, '2.60.120.780-FF-000016', NULL, 'Uncharacterized protein', 157, NULL, NULL, 39906),
(39907, '2.60.40.1730-FF-000104', NULL, NULL, 246, NULL, NULL, 39907),
(39908, '3.40.50.360-FF-000047', NULL, 'NADPH-cytochrome p450 reductase', 173, NULL, NULL, 39908),
(39909, '1.20.5.110-FF-000080', NULL, 'Synaptosomal-associated protein 47', 63, NULL, NULL, 39909),
(39910, '1.25.10.10-FF-001280', NULL, 'RING-type E3 ubiquitin transferase', 79, NULL, NULL, 39910),
(39911, '2.130.10.10-FF-002974', NULL, 'Dynein axonemal intermediate chain 2', 215, NULL, NULL, 39911),
(39912, '1.20.5.170-FF-000165', NULL, 'Pachytene arrest protein SAE3', 72, NULL, NULL, 39912),
(39913, '2.60.120.200-FF-000657', NULL, 'Uncharacterized protein', 90, NULL, NULL, 39913),
(39914, '3.30.1380.20-FF-000021', NULL, 'TRansport Protein Particle', 183, NULL, NULL, 39914),
(39915, '3.30.30.30-FF-000044', NULL, 'Uncharacterized protein', 76, NULL, NULL, 39915),
(39916, '1.20.1420.40-FF-000001', NULL, NULL, 166, NULL, NULL, 39916),
(39917, '1.10.10.10-FF-001009', NULL, 'MarR family transcriptional regulator', 137, NULL, NULL, 39917),
(39918, '3.30.70.270-FF-000318', NULL, NULL, 17, NULL, NULL, 39918),
(39919, '1.10.8.1220-FF-000014', NULL, 'Dynein heavy chain, putative', 94, NULL, NULL, 39919),
(39920, '2.30.30.40-FF-000206', NULL, 'GRB2-related adapter protein 2 isoform X1', 57, NULL, NULL, 39920),
(39921, '3.40.50.300-FF-003525', NULL, 'ATP-dependent DNA helicase', 171, NULL, NULL, 39921),
(39922, '2.60.220.30-FF-000033', NULL, 'Uncharacterized protein', 158, NULL, NULL, 39922),
(39923, '3.80.10.10-FF-000344', NULL, 'Dynein assembly factor 1, axonemal', 103, NULL, NULL, 39923),
(39924, '2.170.220.10-FF-000006', NULL, NULL, 90, NULL, NULL, 39924),
(39925, '2.30.39.10-FF-000004', NULL, 'Serpin peptidase inhibitor, clade H, member 1', 130, NULL, NULL, 39925),
(39926, '1.25.40.10-FF-001298', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 63, NULL, NULL, 39926),
(39927, '1.10.720.30-FF-000058', NULL, 'DSB repair complex subunit Ku70, putative', 36, NULL, NULL, 39927),
(39928, '1.20.1270.60-FF-000079', NULL, 'Transcription factor SipA3', 251, NULL, NULL, 39928),
(39929, '3.60.40.10-FF-000291', NULL, 'Protein phosphatase 2C 50', 328, NULL, NULL, 39929),
(39930, '3.30.160.60-FF-001990', NULL, NULL, 28, NULL, NULL, 39930),
(39931, '2.10.25.10-FF-000327', NULL, 'neurogenic locus notch homolog protein 4', 39, NULL, NULL, 39931),
(39932, '1.25.40.10-FF-001461', NULL, 'Crooked neck protein putative', 102, NULL, NULL, 39932),
(39933, '3.40.50.700-FF-000003', NULL, 'Ni/Fe hydrogenase, small subunit', 196, NULL, NULL, 39933); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(39934, '1.20.1110.10-FF-000132', NULL, NULL, 126, NULL, NULL, 39934),
(39935, '3.40.50.620-FF-000277', NULL, 'Tyrosyl-tRNA synthetase, putative', 300, NULL, NULL, 39935),
(39936, '2.10.80.10-FF-000005', NULL, 'Colipase', 95, NULL, NULL, 39936),
(39937, '1.10.1870.10-FF-000017', NULL, 'Lysine-ketoglutarate reductase, putative', 86, NULL, NULL, 39937),
(39938, '1.25.40.570-FF-000073', NULL, 'Uncharacterized protein', 189, NULL, NULL, 39938),
(39939, '3.30.160.60-FF-002170', NULL, 'Zinc finger protein 236', 27, NULL, NULL, 39939),
(39940, '3.30.310.10-FF-000071', NULL, 'Adaptor-related protein complex 2 subunit alpha 1', 55, NULL, NULL, 39940),
(39941, '2.60.120.470-FF-000013', NULL, NULL, 184, NULL, NULL, 39941),
(39942, '2.60.40.10-FF-002996', NULL, 'Bacterial Ig-like domain family protein', 93, NULL, NULL, 39942),
(39943, '3.80.10.10-FF-004385', NULL, 'Uncharacterized protein', 169, NULL, NULL, 39943),
(39944, '4.10.1220.10-FF-000005', NULL, 'Uncharacterized protein', 33, NULL, NULL, 39944),
(39945, '3.40.710.10-FF-000155', NULL, 'Penicillin-binding protein', 379, NULL, NULL, 39945),
(39946, '3.30.2020.30-FF-000003', NULL, 'trimethyllysine dioxygenase, mitochondrial isoform X1', 101, NULL, NULL, 39946),
(39947, '3.30.200.20-FF-001038', NULL, 'PH-protein kinase domain containing protein', 84, NULL, NULL, 39947),
(39948, '3.40.190.80-FF-000051', NULL, 'Inositol monophosphatase family protein', 99, NULL, NULL, 39948),
(39949, '3.60.20.10-FF-000109', NULL, 'Asparagine synthetase B', 184, NULL, NULL, 39949),
(39950, '3.40.50.1820-FF-000158', NULL, 'Thymus-specific serine protease', 187, NULL, NULL, 39950),
(39951, '1.20.1310.10-FF-000113', NULL, NULL, 110, NULL, NULL, 39951),
(39952, '3.40.50.620-FF-000647', NULL, 'Cysteine--tRNA ligase 1 cytoplasmic', 97, NULL, NULL, 39952),
(39953, '3.30.200.20-FF-000919', NULL, 'Uncharacterized protein', 94, NULL, NULL, 39953),
(39954, '1.25.40.20-FF-001464', NULL, 'Uncharacterized protein', 113, NULL, NULL, 39954),
(39955, '1.25.40.10-FF-003243', NULL, 'Uncharacterized protein', 180, NULL, NULL, 39955),
(39956, '2.30.30.1020-FF-000016', NULL, 'NOT-Like (Yeast CCR4/NOT complex component)', 146, NULL, NULL, 39956),
(39957, '3.30.200.20-FF-001408', NULL, 'Protein kinase, putative', 90, NULL, NULL, 39957),
(39958, '3.40.1190.20-FF-000145', NULL, 'Fructokinase', 315, NULL, NULL, 39958),
(39959, '3.10.580.10-FF-000027', NULL, 'Chloride channel protein', 114, NULL, NULL, 39959),
(39960, '1.20.58.60-FF-000408', NULL, 'Spectrin beta, non-erythrocytic 5', 243, NULL, NULL, 39960),
(39961, '3.40.190.10-FF-000957', NULL, 'Ionotropic receptor 7e', 108, NULL, NULL, 39961),
(39962, '3.90.1010.10-FF-000028', NULL, 'Uncharacterized protein', 45, NULL, NULL, 39962),
(39963, '3.20.20.80-FF-000424', NULL, 'Uncharacterized protein', 159, NULL, NULL, 39963),
(39964, '3.20.20.330-FF-000036', NULL, 'Predicted protein', 93, NULL, NULL, 39964),
(39965, '2.40.50.1020-FF-000003', NULL, 'DNA-binding response regulator', 112, NULL, NULL, 39965),
(39966, '3.30.70.1230-FF-000236', NULL, 'Uncharacterized protein', 185, NULL, NULL, 39966),
(39967, '2.60.40.60-FF-000341', NULL, 'FlaMIngo (Cadherin plus 7TM domain) homolog', 106, NULL, NULL, 39967),
(39968, '3.30.300.30-FF-000149', NULL, 'Phenylacetate-CoA ligase, putative', 91, NULL, NULL, 39968),
(39969, '2.130.10.10-FF-005245', NULL, 'CPSF A subunit region family protein', 299, NULL, NULL, 39969),
(39970, '3.90.1290.10-FF-000020', NULL, 'Short stop, isoform AA', 162, NULL, NULL, 39970),
(39971, '3.40.50.800-FF-000033', NULL, 'Histidine--tRNA ligase', 89, NULL, NULL, 39971),
(39972, '1.25.10.10-FF-002589', NULL, 'Integrator complex subunit, putative', 156, NULL, NULL, 39972),
(39973, '3.90.70.80-FF-000098', NULL, 'Uncharacterized protein', 138, NULL, NULL, 39973),
(39974, '1.25.10.10-FF-003387', NULL, 'AER049Wp', 142, NULL, NULL, 39974),
(39975, '3.60.90.10-FF-000029', NULL, 'Uncharacterized protein', 193, NULL, NULL, 39975),
(39976, '1.10.520.10-FF-000071', NULL, 'Peroxidase', 19, NULL, NULL, 39976),
(39977, '2.60.220.50-FF-000056', NULL, 'Uncharacterized protein', 108, NULL, NULL, 39977);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(39978, '2.10.25.10-FF-000344', NULL, 'FAT atypical cadherin 4', 43, NULL, NULL, 39978),
(39979, '3.40.50.1820-FF-001310', NULL, 'Uncharacterized protein', 265, NULL, NULL, 39979),
(39980, '3.20.20.70-FF-000421', NULL, 'Xenobiotic reductase B', 366, NULL, NULL, 39980),
(39981, '1.20.1270.10-FF-000008', NULL, '78 kDa glucose-regulated protein-like protein', 75, NULL, NULL, 39981),
(39982, '3.30.70.330-FF-000477', NULL, 'Heterogeneous nuclear ribonucleoprotein D', 118, NULL, NULL, 39982),
(39983, '3.40.50.1110-FF-000142', NULL, 'Uncharacterized protein', 185, NULL, NULL, 39983),
(39984, '1.25.40.10-FF-001770', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform A', 112, NULL, NULL, 39984),
(39985, '1.25.40.20-FF-001773', NULL, 'Uncharacterized protein', 188, NULL, NULL, 39985),
(39986, '3.40.50.1460-FF-000033', NULL, 'CASP8 and FADD like apoptosis regulator', 90, NULL, NULL, 39986),
(39987, '1.25.40.450-FF-000003', NULL, 'Nuclear pore complex protein NUP155', 160, NULL, NULL, 39987),
(39988, '2.30.33.40-FF-000022', NULL, 'Chloroplast protein Cpn21 in A-like protein', 90, NULL, NULL, 39988),
(39989, '3.30.70.330-FF-002377', NULL, NULL, 102, NULL, NULL, 39989),
(39990, '3.40.630.30-FF-000514', NULL, 'Pre-mRNA-splicing factor cwf24', 167, NULL, NULL, 39990),
(39991, '3.40.50.300-FF-001608', NULL, 'Cytidylate kinase', 229, NULL, NULL, 39991),
(39992, '3.50.50.60-FF-000469', NULL, 'FAD/NAD(P)-binding domain-containing protein', 385, NULL, NULL, 39992),
(39993, '3.40.930.10-FF-000003', NULL, 'PTS IIA-like nitrogen regulatory protein PtsN', 163, NULL, NULL, 39993),
(39994, '3.40.50.10730-FF-000008', NULL, 'Uncharacterized protein', 14, NULL, NULL, 39994),
(39995, '2.60.40.1230-FF-000016', NULL, 'ADP-ribosylation factor-binding protein GGA2', 141, NULL, NULL, 39995),
(39996, '1.20.990.10-FF-000058', NULL, 'Uncharacterized protein', 35, NULL, NULL, 39996),
(39997, '3.50.50.60-FF-001267', NULL, 'Flavin-containing monooxygenase', 86, NULL, NULL, 39997),
(39998, '1.20.1250.20-FF-000437', NULL, 'Blast:Monocarboxylate transporter 4', 189, NULL, NULL, 39998),
(39999, '3.40.50.720-FF-000661', NULL, 'dTDP-4-dehydrorhamnose reductase', 206, NULL, NULL, 39999),
(40000, '3.30.40.10-FF-001404', NULL, 'RBR-type E3 ubiquitin transferase', 87, NULL, NULL, 40000),
(40001, '1.20.890.10-FF-000011', NULL, 'tubulin polyglutamylase complex subunit 1', 45, NULL, NULL, 40001),
(40002, '2.60.90.20-FF-000001', NULL, 'Outer capsid protein sigma-1', 163, NULL, NULL, 40002),
(40003, '3.90.190.10-FF-000362', NULL, 'Uncharacterized protein', 340, NULL, NULL, 40003),
(40004, '3.20.20.80-FF-000648', NULL, 'Uncharacterized protein', 84, NULL, NULL, 40004),
(40005, '1.10.10.10-FF-001970', NULL, 'Uncharacterized protein', 68, NULL, NULL, 40005),
(40006, '1.25.10.10-FF-001487', NULL, 'Wings apart-like', 91, NULL, NULL, 40006),
(40007, '3.80.10.10-FF-002570', NULL, 'Uncharacterized protein', 120, NULL, NULL, 40007),
(40008, '3.20.20.100-FF-000209', NULL, 'Uncharacterized protein', 103, NULL, NULL, 40008),
(40009, '2.130.10.10-FF-003345', NULL, 'Uncharacterized protein', 133, NULL, NULL, 40009),
(40010, '3.30.70.330-FF-001275', NULL, 'U2 snRNP auxiliary factor large subunit, putative', 106, NULL, NULL, 40010),
(40011, '3.40.50.10710-FF-000002', NULL, 'Ribonuclease J 2', 151, NULL, NULL, 40011),
(40012, '3.40.50.150-FF-001737', NULL, NULL, 51, NULL, NULL, 40012),
(40013, '1.25.40.470-FF-000009', NULL, 'WD repeat-containing protein 19 isoform X1', 158, NULL, NULL, 40013),
(40014, '1.20.1260.10-FF-000036', NULL, 'Catalase, Mn-containing', 283, NULL, NULL, 40014),
(40015, '4.10.400.10-FF-000314', NULL, 'LDL receptor protein 1, isoform G', 46, NULL, NULL, 40015),
(40016, '3.30.930.10-FF-000202', NULL, 'Asparaginyl-tRNA synthetase 2', 333, NULL, NULL, 40016),
(40017, '3.60.40.10-FF-000335', NULL, 'Uncharacterized protein', 146, NULL, NULL, 40017),
(40018, '2.30.40.10-FF-000058', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 32, NULL, NULL, 40018),
(40019, '1.20.1070.10-FF-000662', NULL, 'Predicted protein', 303, NULL, NULL, 40019);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(40020, '3.30.1960.10-FF-000012', NULL, 'Methyltransferase TYW3, putative', 133, NULL, NULL, 40020),
(40021, '3.30.420.10-FF-000074', NULL, 'exonuclease mut-7 homolog isoform X2', 210, NULL, NULL, 40021),
(40022, '3.30.160.60-FF-003816', NULL, NULL, 35, NULL, NULL, 40022),
(40023, '1.10.10.10-FF-001335', NULL, '40S ribosomal protein S10', 97, NULL, NULL, 40023),
(40024, '1.20.1070.10-FF-001988', NULL, 'Uncharacterized protein', 158, NULL, NULL, 40024),
(40025, '3.30.70.330-FF-000932', NULL, 'Chromosome 1, whole genome shotgun sequence', 109, NULL, NULL, 40025),
(40026, '3.30.1360.210-FF-000004', NULL, '60S ribosomal protein L22', 118, NULL, NULL, 40026),
(40027, '2.60.120.290-FF-000083', NULL, 'Suppressor of lurcher protein 1', 122, NULL, NULL, 40027),
(40028, '3.30.450.20-FF-000584', NULL, 'Uncharacterized protein', 175, NULL, NULL, 40028),
(40029, '3.30.1360.70-FF-000012', NULL, 'Arginine-tRNA ligase, putative', 129, NULL, NULL, 40029),
(40030, '3.40.50.2000-FF-000881', NULL, 'Uncharacterized protein', 186, NULL, NULL, 40030),
(40031, '3.40.1110.10-FF-000283', NULL, NULL, 118, NULL, NULL, 40031),
(40032, '3.40.50.1010-FF-000128', NULL, 'Nucleic acid binding protein, putative', 202, NULL, NULL, 40032),
(40033, '3.30.1360.220-FF-000007', NULL, 'Zinc finger, FYVE domain-containing 9b', 126, NULL, NULL, 40033),
(40034, '1.10.472.80-FF-000131', NULL, 'Rab GTPase activating protein, putative', 125, NULL, NULL, 40034),
(40035, '4.10.240.10-FF-000116', NULL, 'C2H2 transcription factor, putative', 62, NULL, NULL, 40035),
(40036, '3.30.470.20-FF-000158', NULL, 'Glutathione synthetase, putative', 111, NULL, NULL, 40036),
(40037, '2.40.160.120-FF-000016', NULL, 'Oxysterol binding protein (Orp8), putative', 201, NULL, NULL, 40037),
(40038, '3.30.200.20-FF-001381', NULL, 'Uncharacterized protein', 108, NULL, NULL, 40038),
(40039, '1.20.1270.60-FF-000063', NULL, 'Rho GTPase activator', 314, NULL, NULL, 40039),
(40040, '3.40.640.10-FF-000110', NULL, 'Aminotransferase', 242, NULL, NULL, 40040),
(40041, '3.30.2130.30-FF-000006', NULL, 'Probable tRNA sulfurtransferase', 174, NULL, NULL, 40041),
(40042, '3.30.365.10-FF-000006', NULL, 'xanthine dehydrogenase/oxidase', 64, NULL, NULL, 40042),
(40043, '1.10.168.20-FF-000001', NULL, '40S ribosomal protein S8', 59, NULL, NULL, 40043),
(40044, '3.40.50.10490-FF-000127', NULL, NULL, 175, NULL, NULL, 40044),
(40045, '1.10.555.10-FF-000224', NULL, NULL, 150, NULL, NULL, 40045),
(40046, '2.60.40.10-FF-001922', NULL, 'KETtiN (Drosophila actin-binding) homolog', 108, NULL, NULL, 40046),
(40047, '3.40.30.10-FF-000217', NULL, 'Glutaredoxin-C5 chloroplastic', 110, NULL, NULL, 40047),
(40048, '2.60.40.10-FF-003693', NULL, NULL, 81, NULL, NULL, 40048),
(40049, '3.40.33.10-FF-000016', NULL, 'Golgi-associated plant pathogenesis-related protein 1', 147, NULL, NULL, 40049),
(40050, '4.10.80.70-FF-000001', NULL, NULL, 21, NULL, NULL, 40050),
(40051, '3.30.1490.180-FF-000035', NULL, 'DNA-directed RNA polymerase subunit', 12, NULL, NULL, 40051),
(40052, '3.30.160.60-FF-003255', NULL, NULL, 28, NULL, NULL, 40052),
(40053, '3.30.40.10-FF-000887', NULL, 'Unplaced genomic scaffold supercont2.7, whole genome shotgun sequence', 85, NULL, NULL, 40053),
(40054, '3.30.40.10-FF-000606', NULL, 'Ubiquitinyl hydrolase 1', 147, NULL, NULL, 40054),
(40055, '3.30.40.10-FF-000578', NULL, 'E3 ubiquitin-protein ligase CHFR', 77, NULL, NULL, 40055),
(40056, '1.20.1560.10-FF-000109', NULL, 'Alkaline protease secretion ATP-binding protein aprD', 305, NULL, NULL, 40056),
(40057, '3.30.160.60-FF-001647', NULL, 'Zinc finger protein 596', 27, NULL, NULL, 40057),
(40058, '3.30.160.60-FF-001338', NULL, 'Zinc finger and BTB domain-containing protein 49', 28, NULL, NULL, 40058),
(40059, '2.60.40.150-FF-000301', NULL, 'Tcb3p', 133, NULL, NULL, 40059),
(40060, '3.30.479.20-FF-000032', NULL, 'Elongation factor Ts', 84, NULL, NULL, 40060),
(40061, '3.20.20.70-FF-000319', NULL, 'Dihydroorotate dehydrogenase (quinone)', 351, NULL, NULL, 40061),
(40062, '3.40.50.450-FF-000091', NULL, 'Uncharacterized protein', 136, NULL, NULL, 40062);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(40063, '3.30.160.60-FF-005716', NULL, NULL, 40, NULL, NULL, 40063),
(40064, '3.40.390.10-FF-000259', NULL, NULL, 195, NULL, NULL, 40064),
(40065, '3.40.50.2300-FF-001235', NULL, NULL, 234, NULL, NULL, 40065),
(40066, '2.10.25.10-FF-001142', NULL, 'Dumpy, isoform V', 42, NULL, NULL, 40066),
(40067, '3.80.10.10-FF-000670', NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM1', 151, NULL, NULL, 40067),
(40068, '3.40.50.720-FF-001133', NULL, 'NADP-dependent alcohol dehydrogenase', 154, NULL, NULL, 40068),
(40069, '1.50.40.10-FF-000424', NULL, 'Putative envelope ADPATP carrier protein chloroplastic', 187, NULL, NULL, 40069),
(40070, '1.20.120.1080-FF-000005', NULL, 'ATP-dependent helicase HrpA', 99, NULL, NULL, 40070),
(40071, '2.60.40.790-FF-000111', NULL, 'Cysteine and histidine-rich domain-containing protein', 114, NULL, NULL, 40071),
(40072, '1.25.40.20-FF-000036', NULL, 'protein TANC2 isoform X2', 165, NULL, NULL, 40072),
(40073, '1.25.10.10-FF-001633', NULL, 'YALI0B03014p', 463, NULL, NULL, 40073),
(40074, '1.10.8.1220-FF-000031', NULL, NULL, 86, NULL, NULL, 40074),
(40075, '2.30.30.140-FF-000253', NULL, 'Uncharacterized protein', 28, NULL, NULL, 40075),
(40076, '2.10.25.10-FF-000670', NULL, 'Stabilin 2', 31, NULL, NULL, 40076),
(40077, '2.40.170.20-FF-000030', NULL, 'Outer membrane cobalamin receptor protein', 625, NULL, NULL, 40077),
(40078, '1.10.510.10-FF-003824', NULL, NULL, 113, NULL, NULL, 40078),
(40079, '3.90.180.10-FF-000108', NULL, 'Zinc-binding oxidoreductase, putative', 147, NULL, NULL, 40079),
(40080, '3.90.70.10-FF-000212', NULL, 'Cathepsin L-like protease', 315, NULL, NULL, 40080),
(40081, '2.60.40.10-FF-003822', NULL, NULL, 97, NULL, NULL, 40081),
(40082, '1.20.5.110-FF-000315', NULL, 'Uncharacterized protein', 49, NULL, NULL, 40082),
(40083, '2.60.120.10-FF-000429', NULL, 'Crp/Fnr family transcriptional regulator', 136, NULL, NULL, 40083),
(40084, '2.60.120.10-FF-000093', NULL, '3-hydroxyanthranilate 3,4-dioxygenase', 176, NULL, NULL, 40084),
(40085, '3.30.70.100-FF-000054', NULL, 'Acylphosphatase', 97, NULL, NULL, 40085),
(40086, '3.20.20.60-FF-000081', NULL, 'Pyruvate kinase', 231, NULL, NULL, 40086),
(40087, '1.10.720.30-FF-000075', NULL, 'Chromosome 1, whole genome shotgun sequence', 48, NULL, NULL, 40087),
(40088, '3.20.20.70-FF-000084', NULL, 'Ferredoxin-dependent glutamate synthase, chloroplastic', 419, NULL, NULL, 40088),
(40089, '3.50.50.60-FF-001312', NULL, 'Uncharacterized protein', 38, NULL, NULL, 40089),
(40090, '1.20.120.1070-FF-000002', NULL, 'Translation initiation factor eIF-2B subunit alpha', 106, NULL, NULL, 40090),
(40091, '1.10.8.720-FF-000051', NULL, 'Dynein-1-beta heavy chain, flagellar inner arm I1 complex', 154, NULL, NULL, 40091),
(40092, '1.20.120.1910-FF-000046', NULL, 'Cysteine--tRNA ligase', 166, NULL, NULL, 40092),
(40093, '3.20.20.80-FF-000750', NULL, 'Uncharacterized protein', 68, NULL, NULL, 40093),
(40094, '1.10.1420.10-FF-000101', NULL, 'DNA mismatch repair mutS protein', 186, NULL, NULL, 40094),
(40095, '1.10.10.10-FF-001661', NULL, 'Flocculation suppression protein (AFU_orthologue AFUA_4G04502)', 66, NULL, NULL, 40095),
(40096, '1.25.40.10-FF-005058', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 107, NULL, NULL, 40096),
(40097, '3.30.70.340-FF-000013', NULL, NULL, 90, NULL, NULL, 40097),
(40098, '3.40.50.2000-FF-000555', NULL, 'Glycosyltransferase', 241, NULL, NULL, 40098),
(40099, '3.30.310.230-FF-000002', NULL, 'Sigma factor-binding protein Crl', 127, NULL, NULL, 40099),
(40100, '1.10.555.10-FF-000241', NULL, NULL, 200, NULL, NULL, 40100),
(40101, '2.40.50.140-FF-001154', NULL, NULL, 107, NULL, NULL, 40101),
(40102, '3.30.160.60-FF-001355', NULL, 'zinc finger protein 334', 28, NULL, NULL, 40102),
(40103, '1.25.40.10-FF-001444', NULL, 'Pentatricopeptide repeat protein', 176, NULL, NULL, 40103),
(40104, '3.30.160.60-FF-002153', NULL, 'Zinc finger protein 30', 30, NULL, NULL, 40104),
(40105, '3.30.60.30-FF-000001', NULL, 'Serine peptidase inhibitor, Kazal type 5', 55, NULL, NULL, 40105);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(40106, '3.40.50.150-FF-001872', NULL, NULL, 171, NULL, NULL, 40106),
(40107, '3.30.457.60-FF-000021', NULL, 'Spindle assembly checkpoint component mad1', 76, NULL, NULL, 40107),
(40108, '3.30.200.20-FF-001055', NULL, 'Serine/threonine-protein kinase MRCK beta', 214, NULL, NULL, 40108),
(40109, '2.180.10.10-FF-000021', NULL, 'Teneurin transmembrane protein 2', 203, NULL, NULL, 40109),
(40110, '3.80.10.10-FF-004368', NULL, 'Uncharacterized protein', 173, NULL, NULL, 40110),
(40111, '3.60.40.10-FF-000318', NULL, 'Uncharacterized protein', 212, NULL, NULL, 40111),
(40112, '4.10.280.10-FF-000181', NULL, 'Hairy enhancer of split', 64, NULL, NULL, 40112),
(40113, '3.30.70.360-FF-000019', NULL, 'Allantoate deiminase', 132, NULL, NULL, 40113),
(40114, '2.60.40.10-FF-005593', NULL, NULL, 87, NULL, NULL, 40114),
(40115, '1.10.150.50-FF-000161', NULL, 'Mitogen-activated protein kinase kinase kinase', 85, NULL, NULL, 40115),
(40116, '1.25.40.20-FF-001447', NULL, 'Uncharacterized protein', 239, NULL, NULL, 40116),
(40117, '3.40.50.620-FF-000294', NULL, 'Phosphopantetheine adenylyltransferase, putative', 120, NULL, NULL, 40117),
(40118, '1.10.3810.10-FF-000025', NULL, 'Penicillin-binding protein 1C (PBP-1c)', 189, NULL, NULL, 40118),
(40119, '3.20.20.140-FF-000423', NULL, 'Uncharacterized protein', 50, NULL, NULL, 40119),
(40120, '3.20.20.80-FF-000441', NULL, 'Uncharacterized protein', 256, NULL, NULL, 40120),
(40121, '3.40.50.740-FF-000054', NULL, 'Bll5478 protein', 166, NULL, NULL, 40121),
(40122, '3.40.1190.20-FF-000162', NULL, 'Predicted protein', 337, NULL, NULL, 40122),
(40123, '2.60.40.10-FF-001568', NULL, 'Ribonuclease E/G-like protein, chloroplastic', 109, NULL, NULL, 40123),
(40124, '2.60.40.350-FF-000002', NULL, 'Structural polyprotein', 100, NULL, NULL, 40124),
(40125, '1.25.40.10-FF-003905', NULL, 'Uncharacterized protein', 62, NULL, NULL, 40125),
(40126, '3.30.160.60-FF-000253', NULL, 'Crooked legs, isoform H', 29, NULL, NULL, 40126),
(40127, '3.30.40.10-FF-000932', NULL, 'Uncharacterized protein', 70, NULL, NULL, 40127),
(40128, '3.40.720.10-FF-000318', NULL, 'Uncharacterized protein', 189, NULL, NULL, 40128),
(40129, '3.30.40.10-FF-001730', NULL, 'E3 ubiquitin-protein ligase PRT1', 113, NULL, NULL, 40129),
(40130, '1.10.3500.10-FF-000041', NULL, 'Uncharacterized protein', 54, NULL, NULL, 40130),
(40131, '2.160.20.80-FF-000026', NULL, NULL, 135, NULL, NULL, 40131),
(40132, '2.20.110.10-FF-000045', NULL, 'MORN repeat, putative', 47, NULL, NULL, 40132),
(40133, '3.90.550.10-FF-000232', NULL, 'Glycosyl transferase family 2', 219, NULL, NULL, 40133),
(40134, '1.20.1250.20-FF-001460', NULL, 'Myo-inositol/proton symporter (MIT)', 226, NULL, NULL, 40134),
(40135, '3.30.300.30-FF-000166', NULL, 'Putative non-ribosomal peptide synthase', 127, NULL, NULL, 40135),
(40136, '3.40.50.20-FF-000076', NULL, 'D-alanine--D-alanine ligase A', 129, NULL, NULL, 40136),
(40137, '3.30.1120.10-FF-000027', NULL, 'Arylsulfatase A', 77, NULL, NULL, 40137),
(40138, '3.40.720.10-FF-000066', NULL, 'Non-specific phospholipase C6', 178, NULL, NULL, 40138),
(40139, '1.25.40.20-FF-000345', NULL, 'Poly [ADP-ribose] polymerase', 103, NULL, NULL, 40139),
(40140, '1.25.10.10-FF-001942', NULL, 'Serine/threonine-protein kinase TOR', 332, NULL, NULL, 40140),
(40141, '1.20.120.350-FF-000021', NULL, 'Potassium voltage-gated channel subfamily A member 3', 170, NULL, NULL, 40141),
(40142, '2.40.10.480-FF-000005', NULL, 'Cell surface protein', 84, NULL, NULL, 40142),
(40143, '2.130.10.10-FF-003019', NULL, 'ATG16/SAP18/CVT11/APG16, putative', 167, NULL, NULL, 40143),
(40144, '1.10.860.10-FF-000028', NULL, 'DNA primase', 153, NULL, NULL, 40144),
(40145, '2.60.40.10-FF-004795', NULL, NULL, 90, NULL, NULL, 40145),
(40146, '3.40.50.300-FF-000506', NULL, 'transcriptional regulator ATRX isoform X1', 17, NULL, NULL, 40146),
(40147, '3.60.40.10-FF-000009', NULL, 'Blast:Protein phosphatase PTC7 homolog', 244, NULL, NULL, 40147),
(40148, '1.20.58.60-FF-000717', NULL, 'Uncharacterized protein', 109, NULL, NULL, 40148),
(40149, '3.40.50.1820-FF-001181', NULL, 'Clan SC, family S28, unassigned serine peptidase', 164, NULL, NULL, 40149);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(40150, '1.10.246.140-FF-000013', NULL, 'Transcription and mRNA export factor sus1', 91, NULL, NULL, 40150),
(40151, '2.130.10.10-FF-003328', NULL, 'Uncharacterized protein', 94, NULL, NULL, 40151),
(40152, '3.10.450.540-FF-000001', NULL, 'ORF13-like protein', 144, NULL, NULL, 40152),
(40153, '3.80.10.10-FF-001979', NULL, 'Matrix remodeling associated 5', 136, NULL, NULL, 40153),
(40154, '3.30.40.10-FF-001421', NULL, 'General transcription factor IIE subunit 1', 49, NULL, NULL, 40154),
(40155, '3.10.105.10-FF-000109', NULL, 'Amino acid ABC transporter, periplasmic amino acid-binding protein', 76, NULL, NULL, 40155),
(40156, '3.40.1350.10-FF-000031', NULL, 'tRNA-splicing endonuclease subunit Sen2, putative', 135, NULL, NULL, 40156),
(40157, '3.80.10.10-FF-002777', NULL, 'Uncharacterized protein', 200, NULL, NULL, 40157),
(40158, '3.30.160.20-FF-000174', NULL, 'Predicted protein', 71, NULL, NULL, 40158),
(40159, '3.90.228.10-FF-000034', NULL, 'Predicted protein', 164, NULL, NULL, 40159),
(40160, '3.80.10.10-FF-002468', NULL, 'Uncharacterized protein', 279, NULL, NULL, 40160),
(40161, '1.10.287.70-FF-000624', NULL, 'Predicted protein', 221, NULL, NULL, 40161),
(40162, '1.20.1250.10-FF-000108', NULL, NULL, 190, NULL, NULL, 40162),
(40163, '1.10.246.130-FF-000010', NULL, 'Gamma-glutamyltranspeptidase', 109, NULL, NULL, 40163),
(40164, '3.30.70.330-FF-001292', NULL, 'Nuclear transport factor 2 (NTF2) family protein with RNA binding (RRM-RBD-RNP motifs) domain-containing protein', 110, NULL, NULL, 40164),
(40165, '3.30.40.100-FF-000008', NULL, 'Methyl-CpG-binding domain-containing protein 2', 54, NULL, NULL, 40165),
(40166, '3.40.718.10-FF-000049', NULL, 'Isocitrate dehydrogenase 3 (NAD+) alpha', 133, NULL, NULL, 40166),
(40167, '3.90.850.10-FF-000036', NULL, '2-hydroxyhexa-2,4-dienoate hydratase', 263, NULL, NULL, 40167),
(40168, '3.30.160.60-FF-005380', NULL, NULL, 26, NULL, NULL, 40168),
(40169, '2.30.30.100-FF-000174', NULL, 'U2 small nuclear ribonucleoprotein 16.5K', 85, NULL, NULL, 40169),
(40170, '1.25.40.180-FF-000063', NULL, 'Unplaced genomic scaffold supercont1.20, whole genome shotgun sequence', 204, NULL, NULL, 40170),
(40171, '2.40.50.120-FF-000024', NULL, 'Putative metalloproteinase inhibitor tag-225', 132, NULL, NULL, 40171),
(40172, '2.60.120.10-FF-000121', NULL, 'HTH-type transcriptional regulator ArcR', 135, NULL, NULL, 40172),
(40173, '1.10.510.10-FF-003454', NULL, NULL, 276, NULL, NULL, 40173),
(40174, '1.25.40.10-FF-004878', NULL, 'Pentatricopeptide repeat-containing protein At1g62590', 105, NULL, NULL, 40174),
(40175, '3.80.10.10-FF-000299', NULL, 'Piriformospora indica-insensitive protein 2', 99, NULL, NULL, 40175),
(40176, '2.160.20.70-FF-000006', NULL, 'Adenylyl cyclase-associated protein', 161, NULL, NULL, 40176),
(40177, '2.160.20.80-FF-000009', NULL, 'NifU-like N-terminal domain protein', 113, NULL, NULL, 40177),
(40178, '2.30.29.30-FF-000588', NULL, 'SHC-transforming protein 4', 55, NULL, NULL, 40178),
(40179, '3.20.19.10-FF-000001', NULL, 'Aconitate hydratase', 235, NULL, NULL, 40179),
(40180, '3.30.300.20-FF-000028', NULL, 'GTPase Der', 90, NULL, NULL, 40180),
(40181, '3.30.420.10-FF-000091', NULL, 'Protein argonaute 3', 279, NULL, NULL, 40181),
(40182, '1.20.5.110-FF-000063', NULL, 'Synaptobrevin 1', 111, NULL, NULL, 40182),
(40183, '3.30.830.10-FF-000110', NULL, 'Peptidase, insulinase family', 230, NULL, NULL, 40183),
(40184, '3.30.30.30-FF-000061', NULL, 'Uncharacterized protein', 55, NULL, NULL, 40184),
(40185, '2.10.25.10-FF-000462', NULL, 'Adhesion G protein-coupled receptor E1', 50, NULL, NULL, 40185),
(40186, '2.10.70.10-FF-000050', NULL, 'sushi domain-containing protein 5', 62, NULL, NULL, 40186),
(40187, '3.40.50.10420-FF-000005', NULL, '5-formyltetrahydrofolate cyclo-ligase', 181, NULL, NULL, 40187),
(40188, '1.20.5.110-FF-000107', NULL, 'Vesicle-associated membrane protein 7B', 87, NULL, NULL, 40188),
(40189, '3.40.50.720-FF-000189', NULL, 'Bifunctional protein FolD', 132, NULL, NULL, 40189),
(40190, '3.30.300.10-FF-000025', NULL, 'S-adenosylmethionine synthase', 122, NULL, NULL, 40190);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(40191, '2.10.110.10-FF-000098', NULL, 'Uncoordinated 115a, isoform B', 60, NULL, NULL, 40191),
(40192, '2.60.40.10-FF-001361', NULL, 'T-cell surface glycoprotein CD3 delta chain', 77, NULL, NULL, 40192),
(40193, '3.60.21.60-FF-000042', NULL, 'DNA polymerase alpha subunit B', 113, NULL, NULL, 40193),
(40194, '3.30.200.20-FF-001510', NULL, 'Cell adhesion-like protein', 62, NULL, NULL, 40194),
(40195, '2.60.120.290-FF-000066', NULL, 'AGAP006059-PA', 150, NULL, NULL, 40195),
(40196, '1.10.533.10-FF-000151', NULL, 'Viral CASP8 and FADD-like apoptosis regulator', 90, NULL, NULL, 40196),
(40197, '3.30.200.20-FF-000892', NULL, 'Blast:Mitogen-activated protein kinase kinase kinase 7', 84, NULL, NULL, 40197),
(40198, '3.40.30.10-FF-000335', NULL, 'Glutaredoxin', 101, NULL, NULL, 40198),
(40199, '3.40.50.300-FF-001726', NULL, 'Multidrug resistance-associated protein 4', 262, NULL, NULL, 40199),
(40200, '3.10.250.10-FF-000042', NULL, 'Lysyl oxidase-like 2', 106, NULL, NULL, 40200),
(40201, '3.40.50.300-FF-003379', NULL, 'Regulator of nonsense transcripts putative', 192, NULL, NULL, 40201),
(40202, '1.25.10.10-FF-001178', NULL, 'Hypothetical_protein_-_conserved', 1128, NULL, NULL, 40202),
(40203, '3.10.50.40-FF-000083', NULL, 'Rhodanese-like/PpiC domain-containing protein 12, chloroplastic', 100, NULL, NULL, 40203),
(40204, '3.40.710.10-FF-000138', NULL, 'Putative penicillin-binding protein', 330, NULL, NULL, 40204),
(40205, '3.40.630.30-FF-000632', NULL, 'Uncharacterized protein', 179, NULL, NULL, 40205),
(40206, '3.10.120.10-FF-000004', NULL, 'Acyl-CoA desaturase', 83, NULL, NULL, 40206),
(40207, '1.20.1460.10-FF-000017', NULL, 'V-type proton ATPase subunit C', 169, NULL, NULL, 40207),
(40208, '3.40.50.1820-FF-000719', NULL, 'Serine carboxypeptidase 3', 61, NULL, NULL, 40208),
(40209, '3.90.190.10-FF-000053', NULL, 'Phosphatidylinositol 3,4,5-trisphosphate 3-phosphatase TPTE2', 198, NULL, NULL, 40209),
(40210, '2.130.10.10-FF-001855', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 236, NULL, NULL, 40210),
(40211, '3.90.228.10-FF-000017', NULL, 'Poly [ADP-ribose] polymerase', 212, NULL, NULL, 40211),
(40212, '3.40.50.2020-FF-000173', NULL, 'Uncharacterized protein', 75, NULL, NULL, 40212),
(40213, '2.60.40.10-FF-002979', NULL, 'Bacterial group 1 Ig-like protein', 105, NULL, NULL, 40213),
(40214, '2.10.80.10-FF-000022', NULL, 'Uncharacterized protein', 82, NULL, NULL, 40214),
(40215, '1.25.40.10-FF-003260', NULL, 'Uncharacterized protein', 157, NULL, NULL, 40215),
(40216, '3.40.50.200-FF-000050', NULL, 'Surface layer-associated STABLE protease, conjectural', 335, NULL, NULL, 40216),
(40217, '1.10.1900.10-FF-000003', NULL, 'Polyadenylate-binding protein', 83, NULL, NULL, 40217),
(40218, '1.10.630.10-FF-000427', NULL, 'Putative cytochrome P450 superfamily protein', 216, NULL, NULL, 40218),
(40219, '3.10.20.90-FF-000601', NULL, 'Nuclear protein localization protein 4, variant', 79, NULL, NULL, 40219),
(40220, '2.30.29.30-FF-001206', NULL, 'Collagen, type IV, alpha 3 (Goodpasture antigen)-binding protein b', 82, NULL, NULL, 40220),
(40221, '1.10.840.10-FF-000027', NULL, 'Ras family guanine nucleotide exchange factor', 293, NULL, NULL, 40221),
(40222, '2.30.30.1020-FF-000033', NULL, NULL, 144, NULL, NULL, 40222),
(40223, '3.40.390.10-FF-000276', NULL, NULL, 127, NULL, NULL, 40223),
(40224, '1.10.1900.20-FF-000006', NULL, 'Uncharacterized protein', 52, NULL, NULL, 40224),
(40225, '3.30.160.60-FF-005587', NULL, NULL, 32, NULL, NULL, 40225),
(40226, '2.60.120.200-FF-000674', NULL, 'Hexosyltransferase', 51, NULL, NULL, 40226),
(40227, '2.130.10.10-FF-001428', NULL, 'Autophagy-related protein 18', 277, NULL, NULL, 40227),
(40228, '3.40.30.10-FF-000291', NULL, 'DnaJ protein ERDJ3A', 114, NULL, NULL, 40228),
(40229, '2.40.50.400-FF-000001', NULL, 'SSB protein', 89, NULL, NULL, 40229),
(40230, '3.30.70.1230-FF-000253', NULL, 'Guanylate cyclase', 190, NULL, NULL, 40230),
(40231, '1.25.40.10-FF-004979', NULL, 'Pentatricopeptide repeat-containing protein103', 144, NULL, NULL, 40231),
(40232, '3.90.640.10-FF-000099', NULL, 'Heat shock protein 70 family protein', 43, NULL, NULL, 40232);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(40233, '1.10.405.10-FF-000011', NULL, 'Rab GDP dissociation inhibitor', 105, NULL, NULL, 40233),
(40234, '3.40.50.720-FF-000868', NULL, 'Cell-cell signaling protein C-factor', 235, NULL, NULL, 40234),
(40235, '3.30.160.60-FF-003934', NULL, NULL, 30, NULL, NULL, 40235),
(40236, '3.30.160.60-FF-005172', NULL, NULL, 39, NULL, NULL, 40236),
(40237, '3.90.70.10-FF-000021', NULL, 'Bleomycin hydrolase', 400, NULL, NULL, 40237),
(40238, '1.10.287.110-FF-000052', NULL, 'Chaperone protein DNAj, putative', 88, NULL, NULL, 40238),
(40239, '2.130.10.10-FF-005806', NULL, 'Uncharacterized protein', 399, NULL, NULL, 40239),
(40240, '1.25.40.10-FF-001118', NULL, 'Type IV pilus biogenesis/stability protein PilW', 208, NULL, NULL, 40240),
(40241, '1.10.287.130-FF-000058', NULL, 'Histidine phosphotransferase ChpT', 75, NULL, NULL, 40241),
(40242, '1.10.800.10-FF-000019', NULL, 'Tyrosine/tryptophan monooxygenase, putative', 88, NULL, NULL, 40242),
(40243, '2.30.29.30-FF-001105', NULL, 'Uncharacterized protein', 212, NULL, NULL, 40243),
(40244, '1.20.1250.20-FF-000746', NULL, 'MFS transporter', 175, NULL, NULL, 40244),
(40245, '3.20.20.70-FF-000404', NULL, 'Proline 2-methylase for pyrrolysine biosynthesis', 350, NULL, NULL, 40245),
(40246, '2.60.40.10-FF-005475', NULL, NULL, 101, NULL, NULL, 40246),
(40247, '3.10.20.90-FF-000500', NULL, 'bolA-like protein DDB_G0274169', 115, NULL, NULL, 40247),
(40248, '2.20.28.10-FF-000035', NULL, 'DNA replication licensing factor MCM7', 59, NULL, NULL, 40248),
(40249, '3.90.1470.20-FF-000003', NULL, 'Uncharacterized protein', 104, NULL, NULL, 40249),
(40250, '1.20.1280.50-FF-000150', NULL, 'F-box/kelch-repeat protein', 57, NULL, NULL, 40250),
(40251, '3.40.470.10-FF-000001', NULL, 'Uracil-DNA glycosylase', 223, NULL, NULL, 40251),
(40252, '1.10.1200.10-FF-000074', NULL, 'Aspergillus niger contig An11c0010, genomic contig', 71, NULL, NULL, 40252),
(40253, '3.30.160.60-FF-005688', NULL, NULL, 20, NULL, NULL, 40253),
(40254, '3.50.50.80-FF-000008', NULL, 'Ubiquitin-activating enzyme e1, putative', 119, NULL, NULL, 40254),
(40255, '2.30.180.10-FF-000120', NULL, NULL, 154, NULL, NULL, 40255),
(40256, '3.30.70.330-FF-002938', NULL, NULL, 113, NULL, NULL, 40256),
(40257, '3.30.1490.20-FF-000024', NULL, 'Ribosomal protein S6 modification enzyme', 67, NULL, NULL, 40257),
(40258, '1.10.150.50-FF-000144', NULL, 'GD15078', 72, NULL, NULL, 40258),
(40259, '3.40.50.300-FF-008600', NULL, 'AGAP003241-PA', 21, NULL, NULL, 40259),
(40260, '3.40.50.300-FF-002440', NULL, 'Drug efflux ABC transporter, ATP-binding/permease protein', 226, NULL, NULL, 40260),
(40261, '2.40.50.140-FF-001171', NULL, NULL, 50, NULL, NULL, 40261),
(40262, '3.40.630.30-FF-000531', NULL, 'Uncharacterized protein', 81, NULL, NULL, 40262),
(40263, '3.30.450.20-FF-000275', NULL, 'C4-dicarboxylate transport sensor protein', 139, NULL, NULL, 40263),
(40264, '2.130.10.10-FF-001754', NULL, 'Hypothetical_protein_-_conserved', 288, NULL, NULL, 40264),
(40265, '3.40.50.1100-FF-000021', NULL, 'D-serine dehydratase', 305, NULL, NULL, 40265),
(40266, '1.20.1270.60-FF-000181', NULL, 'Vacuolar protein sorting-associated protein 17', 218, NULL, NULL, 40266),
(40267, '3.90.1480.20-FF-000032', NULL, 'ST3 beta-galactoside alpha-2,3-sialyltransferase 6', 302, NULL, NULL, 40267),
(40268, '3.40.50.2000-FF-001061', NULL, 'Os07g0243000 protein', 103, NULL, NULL, 40268),
(40269, '1.10.630.10-FF-000753', NULL, 'Uncharacterized protein', 61, NULL, NULL, 40269),
(40270, '2.40.30.10-FF-000141', NULL, 'Sporozoite surface antigen MB2', 91, NULL, NULL, 40270),
(40271, '2.30.30.140-FF-000045', NULL, 'tudor domain-containing protein 7 isoform X1', 72, NULL, NULL, 40271),
(40272, '3.40.1620.10-FF-000007', NULL, 'Antitoxin', 41, NULL, NULL, 40272),
(40273, '2.60.40.10-FF-001776', NULL, 'Protein-tyrosine-phosphatase', 118, NULL, NULL, 40273),
(40274, '1.25.40.570-FF-000039', NULL, '26S proteasome regulatory complex component', 205, NULL, NULL, 40274),
(40275, '3.80.10.10-FF-001024', NULL, 'Si:ch211-11p18.6', 227, NULL, NULL, 40275),
(40276, '3.90.550.10-FF-000024', NULL, 'Hexosyltransferase', 261, NULL, NULL, 40276);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(40277, '3.90.550.20-FF-000027', NULL, 'Uncharacterized protein', 242, NULL, NULL, 40277),
(40278, '3.40.50.150-FF-001754', NULL, NULL, 154, NULL, NULL, 40278),
(40279, '1.10.510.10-FF-001099', NULL, 'PEK protein kinase', 183, NULL, NULL, 40279),
(40280, '3.30.160.60-FF-006205', NULL, NULL, 91, NULL, NULL, 40280),
(40281, '1.10.238.10-FF-001292', NULL, 'Uncharacterized protein', 79, NULL, NULL, 40281),
(40282, '2.40.10.10-FF-000241', NULL, 'Haptoglobin', 133, NULL, NULL, 40282),
(40283, '3.30.70.330-FF-002686', NULL, NULL, 160, NULL, NULL, 40283),
(40284, '3.40.50.11890-FF-000002', NULL, '(R)-2-hydroxyisocaproyl-CoA dehydratase beta subunit', 126, NULL, NULL, 40284),
(40285, '1.10.510.10-FF-003706', NULL, NULL, 163, NULL, NULL, 40285),
(40286, '3.60.110.10-FF-000066', NULL, 'Amidase', 302, NULL, NULL, 40286),
(40287, '3.30.70.330-FF-003091', NULL, NULL, 105, NULL, NULL, 40287),
(40288, '1.25.40.1040-FF-000059', NULL, 'Uncharacterized protein', 189, NULL, NULL, 40288),
(40289, '1.10.3500.10-FF-000024', NULL, 'Transcription elongation factor Spt6', 296, NULL, NULL, 40289),
(40290, '1.25.40.470-FF-000043', NULL, 'Intraflagellar transport protein 172, putative', 172, NULL, NULL, 40290),
(40291, '2.20.110.10-FF-000028', NULL, 'Phosphatidylinositol 4-phosphate 5-kinase', 58, NULL, NULL, 40291),
(40292, '3.40.50.20-FF-000093', NULL, 'Protein CBR-SNN-1', 69, NULL, NULL, 40292),
(40293, '1.10.150.650-FF-000001', NULL, 'PHP domain protein', 72, NULL, NULL, 40293),
(40294, '3.40.50.300-FF-005666', NULL, 'Peroxisome biogenesis factor 1, putative', 196, NULL, NULL, 40294),
(40295, '4.10.280.10-FF-000107', NULL, 'Basic helix-loop-helix transcription factor', 64, NULL, NULL, 40295),
(40296, '1.10.150.670-FF-000007', NULL, 'Crossover junction endonuclease EME1B', 98, NULL, NULL, 40296),
(40297, '3.40.800.20-FF-000002', NULL, 'Histone deacetylase', 387, NULL, NULL, 40297),
(40298, '1.10.287.70-FF-000079', NULL, 'Inositol 1,4,5-trisphosphate receptor type 3', 127, NULL, NULL, 40298),
(40299, '2.30.29.30-FF-000852', NULL, 'Uncharacterized protein', 64, NULL, NULL, 40299),
(40300, '3.40.1080.10-FF-000021', NULL, '4-hydroxybutyrate CoA transferase', 168, NULL, NULL, 40300),
(40301, '3.40.50.300-FF-001934', NULL, 'tRNA ligase', 201, NULL, NULL, 40301),
(40302, '2.60.40.10-FF-005828', NULL, NULL, 41, NULL, NULL, 40302),
(40303, '1.25.40.1030-FF-000056', NULL, 'Uncharacterized protein', 241, NULL, NULL, 40303),
(40304, '1.50.40.10-FF-000200', NULL, 'Mitochondrial carrier protein', 294, NULL, NULL, 40304),
(40305, '3.40.50.720-FF-000559', NULL, 'Pyrroline-5-carboxylate reductase', 95, NULL, NULL, 40305),
(40306, '1.20.1270.60-FF-000080', NULL, 'ADP-ribosylation factor GTPase-activating protein AGD3', 248, NULL, NULL, 40306),
(40307, '3.30.70.270-FF-000189', NULL, NULL, 113, NULL, NULL, 40307),
(40308, '3.40.30.10-FF-000543', NULL, 'Hematopoietic prostaglandin D synthase', 80, NULL, NULL, 40308),
(40309, '4.10.280.10-FF-000225', NULL, 'Uncharacterized protein', 80, NULL, NULL, 40309),
(40310, '2.60.40.1130-FF-000003', NULL, 'Protein CBG15026', 97, NULL, NULL, 40310),
(40311, '1.20.900.10-FF-000047', NULL, 'Uncharacterized protein, isoform A', 230, NULL, NULL, 40311),
(40312, '3.60.10.10-FF-000171', NULL, 'Endonuclease/exonuclease/phosphatase family protein-like', 271, NULL, NULL, 40312),
(40313, '3.40.50.1820-FF-000467', NULL, 'Lipase LipV', 256, NULL, NULL, 40313),
(40314, '2.30.42.10-FF-000366', NULL, 'SAM domaincontaining protein', 74, NULL, NULL, 40314),
(40315, '1.10.1300.10-FF-000059', NULL, 'Uncharacterized protein', 226, NULL, NULL, 40315),
(40316, '3.30.1490.180-FF-000018', NULL, 'DNA-directed RNA polymerase subunit', 22, NULL, NULL, 40316),
(40317, '2.20.25.10-FF-000012', NULL, 'Putative transcription factor IIIB 90 kDa subunit', 41, NULL, NULL, 40317),
(40318, '3.40.50.200-FF-000139', NULL, 'Uncharacterized protein', 88, NULL, NULL, 40318),
(40319, '2.60.40.10-FF-002602', NULL, 'Chitinase', 93, NULL, NULL, 40319),
(40320, '3.30.70.260-FF-000186', NULL, 'Uncharacterized protein', 42, NULL, NULL, 40320);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(40321, '1.20.1250.20-FF-001252', NULL, 'Major facilitator superfamily MFS_1', 432, NULL, NULL, 40321),
(40322, '1.20.58.60-FF-000852', NULL, 'Uncharacterized protein', 138, NULL, NULL, 40322),
(40323, '3.30.450.40-FF-000022', NULL, 'IclR family transcriptional regulator', 188, NULL, NULL, 40323),
(40324, '2.30.30.100-FF-000191', NULL, 'U6 snRNA-associated Sm-like protein LSm5', 45, NULL, NULL, 40324),
(40325, '2.40.40.20-FF-000072', NULL, 'AAA family ATPase, possible cell division control protein cdc48', 89, NULL, NULL, 40325),
(40326, '2.80.10.50-FF-000021', NULL, 'Ryanodine receptor, isoform F', 205, NULL, NULL, 40326),
(40327, '3.40.390.10-FF-000068', NULL, 'Predicted protein', 248, NULL, NULL, 40327),
(40328, '2.60.120.10-FF-000800', NULL, 'Cyclic nucleotide-binding', 130, NULL, NULL, 40328),
(40329, '2.20.25.20-FF-000015', NULL, 'RBR-type E3 ubiquitin transferase', 46, NULL, NULL, 40329),
(40330, '3.40.50.300-FF-007875', NULL, 'Uncharacterized protein', 204, NULL, NULL, 40330),
(40331, '3.30.930.10-FF-000056', NULL, 'Alanine--tRNA ligase', 250, NULL, NULL, 40331),
(40332, '3.30.565.10-FF-000004', NULL, 'DNA topoisomerase 2', 242, NULL, NULL, 40332),
(40333, '2.40.150.20-FF-000012', NULL, 'Uncharacterized protein', 125, NULL, NULL, 40333),
(40334, '3.30.450.60-FF-000028', NULL, 'Adaptor related protein complex 1 subunit sigma 3', 63, NULL, NULL, 40334),
(40335, '1.10.510.10-FF-003807', NULL, NULL, 119, NULL, NULL, 40335),
(40336, '3.30.420.10-FF-000192', NULL, 'AGO2, isoform E', 260, NULL, NULL, 40336),
(40337, '1.10.357.120-FF-000010', NULL, 'DNA-directed RNA polymerase subunit', 152, NULL, NULL, 40337),
(40338, '2.60.120.200-FF-000775', NULL, 'Chromosome 1, whole genome shotgun sequence', 281, NULL, NULL, 40338),
(40339, '1.10.405.20-FF-000014', NULL, NULL, 41, NULL, NULL, 40339),
(40340, '3.40.190.10-FF-000974', NULL, 'ABC-type peptide uptake system substrate-binding component SapA', 91, NULL, NULL, 40340),
(40341, '1.20.920.10-FF-000155', NULL, 'Transcription initiation factor TFIID subunit 1', 136, NULL, NULL, 40341),
(40342, '3.30.70.330-FF-003102', NULL, NULL, 138, NULL, NULL, 40342),
(40343, '1.20.1070.10-FF-000914', NULL, '5-hydroxytryptamine (serotonin) receptor 7c', 122, NULL, NULL, 40343),
(40344, '3.30.450.50-FF-000025', NULL, 'Vesicle-associated membrane protein, putative', 145, NULL, NULL, 40344),
(40345, '2.40.170.20-FF-000013', NULL, 'SusC/RagA family TonB-linked outer membrane protein', 647, NULL, NULL, 40345),
(40346, '3.30.160.60-FF-003890', NULL, NULL, 27, NULL, NULL, 40346),
(40347, '3.80.10.10-FF-002553', NULL, 'Guanylate kinase', 145, NULL, NULL, 40347),
(40348, '3.80.10.10-FF-002805', NULL, 'Uncharacterized protein', 153, NULL, NULL, 40348),
(40349, '3.30.70.1230-FF-000045', NULL, 'Phospholipid-transporting ATPase', 218, NULL, NULL, 40349),
(40350, '1.50.40.10-FF-000407', NULL, 'Uncharacterized protein', 227, NULL, NULL, 40350),
(40351, '1.10.287.70-FF-000641', NULL, 'Uncharacterized protein', 184, NULL, NULL, 40351),
(40352, '1.25.10.10-FF-003432', NULL, 'Splicing factor subunit, putative', 157, NULL, NULL, 40352),
(40353, '1.10.246.20-FF-000003', NULL, 'Mediator of RNA polymerase II transcription subunit 15a', 79, NULL, NULL, 40353),
(40354, '2.40.50.140-FF-000766', NULL, NULL, 38, NULL, NULL, 40354),
(40355, '3.40.630.30-FF-000323', NULL, 'Acetyltransferase', 201, NULL, NULL, 40355),
(40356, '1.25.10.20-FF-000001', NULL, 'microsomal triglyceride transfer protein large subunit', 304, NULL, NULL, 40356),
(40357, '1.20.1560.10-FF-000435', NULL, 'Uncharacterized protein', 119, NULL, NULL, 40357),
(40358, '3.40.50.12350-FF-000005', NULL, 'Eyes absent homolog', 132, NULL, NULL, 40358),
(40359, '1.20.1250.20-FF-001134', NULL, 'Multidrug resistance protein B', 201, NULL, NULL, 40359),
(40360, '2.40.10.10-FF-000140', NULL, 'CLIP-domain serine protease', 129, NULL, NULL, 40360),
(40361, '1.10.220.10-FF-000025', NULL, 'Annexin', 86, NULL, NULL, 40361),
(40362, '1.10.8.10-FF-000176', NULL, 'Ancient ubiquitous protein 1 homolog', 54, NULL, NULL, 40362),
(40363, '3.30.200.20-FF-001717', NULL, 'Uncharacterized protein', 114, NULL, NULL, 40363); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(40364, '3.40.50.300-FF-002232', NULL, 'ABC transporter, ATP-binding protein', 224, NULL, NULL, 40364),
(40365, '3.40.50.10330-FF-000113', NULL, 'Uncharacterized protein', 164, NULL, NULL, 40365),
(40366, '2.60.120.330-FF-000213', NULL, 'Uncharacterized protein', 93, NULL, NULL, 40366),
(40367, '3.40.50.150-FF-001546', NULL, NULL, 89, NULL, NULL, 40367),
(40368, '2.60.40.10-FF-005267', NULL, NULL, 86, NULL, NULL, 40368),
(40369, '3.20.20.70-FF-000292', NULL, 'Unplaced genomic scaffold supercont2.7, whole genome shotgun sequence', 273, NULL, NULL, 40369),
(40370, '3.40.50.300-FF-001625', NULL, 'tRNA dimethylallyltransferase isoform X2', 161, NULL, NULL, 40370),
(40371, '2.60.40.10-FF-005519', NULL, NULL, 74, NULL, NULL, 40371),
(40372, '3.30.1490.80-FF-000036', NULL, 'Uncharacterized protein', 16, NULL, NULL, 40372),
(40373, '1.10.20.10-FF-000161', NULL, 'Histone H3', 146, NULL, NULL, 40373),
(40374, '1.50.10.10-FF-000226', NULL, 'Uncharacterized protein', 251, NULL, NULL, 40374),
(40375, '3.40.50.2000-FF-000908', NULL, 'Probable heptosyl III transferase', 165, NULL, NULL, 40375),
(40376, '3.30.70.330-FF-001157', NULL, 'Sra (SRA) stem-Loop interacting Rna (RNA) binding Protein homolog', 84, NULL, NULL, 40376),
(40377, '3.30.40.10-FF-002169', NULL, 'Uncharacterized protein', 128, NULL, NULL, 40377),
(40378, '3.30.559.30-FF-000041', NULL, 'Nonribosomal peptide synthetase 13', 236, NULL, NULL, 40378),
(40379, '3.40.50.300-FF-007920', NULL, 'Uncharacterized protein', 176, NULL, NULL, 40379),
(40380, '3.90.190.10-FF-000569', NULL, 'Uncharacterized protein', 41, NULL, NULL, 40380),
(40381, '3.20.20.80-FF-000295', NULL, 'Alpha-glucosidase B', 202, NULL, NULL, 40381),
(40382, '1.20.58.340-FF-000007', NULL, 'Magnesium transporter MRS2 homolog, mitochondrial', 180, NULL, NULL, 40382),
(40383, '3.40.50.12660-FF-000008', NULL, 'Type I metacaspase', 331, NULL, NULL, 40383),
(40384, '2.60.40.10-FF-003794', NULL, NULL, 101, NULL, NULL, 40384),
(40385, '1.20.1110.10-FF-000250', NULL, NULL, 53, NULL, NULL, 40385),
(40386, '6.10.140.2220-FF-000073', NULL, 'Uncharacterized protein', 48, NULL, NULL, 40386),
(40387, '2.60.40.10-FF-003485', NULL, NULL, 95, NULL, NULL, 40387),
(40388, '3.40.50.150-FF-001855', NULL, NULL, 283, NULL, NULL, 40388),
(40389, '3.40.50.2300-FF-001027', NULL, NULL, 170, NULL, NULL, 40389),
(40390, '3.30.160.60-FF-001681', NULL, 'C2H2 transcription factor, putative', 29, NULL, NULL, 40390),
(40391, '2.60.120.10-FF-000328', NULL, 'Transcriptional regulator AraC/XylS family', 75, NULL, NULL, 40391),
(40392, '3.30.160.60-FF-005924', NULL, NULL, 32, NULL, NULL, 40392),
(40393, '3.30.160.60-FF-003463', NULL, 'Hypermethylated in cancer 2', 65, NULL, NULL, 40393),
(40394, '1.20.5.50-FF-000007', NULL, 'Cell division protein ZapA', 56, NULL, NULL, 40394),
(40395, '3.80.10.10-FF-002923', NULL, 'Predicted protein', 240, NULL, NULL, 40395),
(40396, '3.40.80.10-FF-000030', NULL, 'N-acetylmuramoyl-L-alanine amidase family 2', 206, NULL, NULL, 40396),
(40397, '2.10.90.10-FF-000051', NULL, 'Uncharacterized protein, isoform A', 112, NULL, NULL, 40397),
(40398, '3.40.50.12650-FF-000005', NULL, 'DNA repair metallo-beta-lactamase family protein', 146, NULL, NULL, 40398),
(40399, '1.10.238.10-FF-001084', NULL, 'Protein phosphatase 2 regulatory subunit B'''', alpha', 62, NULL, NULL, 40399),
(40400, '1.20.1050.10-FF-000099', NULL, 'Glutathione S-transferase family protein', 34, NULL, NULL, 40400),
(40401, '3.30.160.20-FF-000039', NULL, '30S ribosomal protein S5', 112, NULL, NULL, 40401),
(40402, '2.60.120.590-FF-000049', NULL, 'Uncharacterized protein', 218, NULL, NULL, 40402),
(40403, '3.20.20.70-FF-000303', NULL, 'Glutamate synthase, large subunit', 328, NULL, NULL, 40403),
(40404, '2.60.40.10-FF-001467', NULL, 'Osteoclast-associated immunoglobulin-like receptor', 91, NULL, NULL, 40404),
(40405, '2.60.40.1730-FF-000059', NULL, NULL, 193, NULL, NULL, 40405),
(40406, '3.40.50.1000-FF-000024', NULL, 'Phosphoglycolate phosphatase', 140, NULL, NULL, 40406),
(40407, '3.40.50.1010-FF-000027', NULL, '5''-3'' exonuclease family protein', 154, NULL, NULL, 40407);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(40408, '2.10.90.10-FF-000157', NULL, 'Otogelin', 88, NULL, NULL, 40408),
(40409, '1.10.132.30-FF-000017', NULL, 'Predicted protein', 78, NULL, NULL, 40409),
(40410, '1.50.40.10-FF-000054', NULL, 'Mitochondrial carrier', 156, NULL, NULL, 40410),
(40411, '2.60.40.10-FF-000141', NULL, 'Down syndrome cell adhesion molecule a', 99, NULL, NULL, 40411),
(40412, '3.40.50.2000-FF-000780', NULL, 'Solanidine glucosyltransferase', 139, NULL, NULL, 40412),
(40413, '3.30.160.60-FF-003581', NULL, NULL, 36, NULL, NULL, 40413),
(40414, '3.40.980.10-FF-000040', NULL, 'FAD synthase', 170, NULL, NULL, 40414),
(40415, '1.20.1070.10-FF-001033', NULL, 'Atypical chemokine receptor 2', 100, NULL, NULL, 40415),
(40416, '1.20.1250.10-FF-000007', NULL, 'Interferon gamma', 138, NULL, NULL, 40416),
(40417, '2.60.40.10-FF-003367', NULL, 'Uncharacterized protein', 110, NULL, NULL, 40417),
(40418, '3.30.160.60-FF-005481', NULL, NULL, 90, NULL, NULL, 40418),
(40419, '3.40.1370.10-FF-000032', NULL, '50S ribosomal protein L4', 220, NULL, NULL, 40419),
(40420, '1.10.10.10-FF-001436', NULL, 'Two-component response regulator', 98, NULL, NULL, 40420),
(40421, '1.25.40.10-FF-002141', NULL, 'Pre-mRNA-splicing factor CLF1', 264, NULL, NULL, 40421),
(40422, '3.40.50.300-FF-007774', NULL, 'Predicted protein', 59, NULL, NULL, 40422),
(40423, '3.60.20.10-FF-000227', NULL, NULL, 113, NULL, NULL, 40423),
(40424, '3.80.10.10-FF-002659', NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At3g47570', 67, NULL, NULL, 40424),
(40425, '2.60.40.10-FF-005166', NULL, NULL, 94, NULL, NULL, 40425),
(40426, '3.40.720.10-FF-000302', NULL, 'Uncharacterized protein', 226, NULL, NULL, 40426),
(40427, '3.40.50.10130-FF-000042', NULL, 'Uncharacterized protein', 59, NULL, NULL, 40427),
(40428, '3.40.50.10140-FF-000045', NULL, 'Uncharacterized protein', 139, NULL, NULL, 40428),
(40429, '3.40.50.300-FF-003317', NULL, 'Phage GTP-binding protein', 200, NULL, NULL, 40429),
(40430, '3.10.50.40-FF-000021', NULL, 'Peptidylprolyl isomerase', 102, NULL, NULL, 40430),
(40431, '3.40.50.150-FF-000220', NULL, 'CAMK protein kinase', 185, NULL, NULL, 40431),
(40432, '3.30.420.10-FF-000298', NULL, 'Argonaute protein wago-1', 273, NULL, NULL, 40432),
(40433, '1.25.10.10-FF-001841', NULL, 'Condensin-2 complex subunit', 147, NULL, NULL, 40433),
(40434, '1.10.132.20-FF-000014', NULL, 'Ribosome-recycling factor, mitochondrial', 97, NULL, NULL, 40434),
(40435, '4.10.365.10-FF-000001', NULL, 'Cyclin-dependent kinase inhibitor 1B', 84, NULL, NULL, 40435),
(40436, '1.10.287.70-FF-000287', NULL, 'Predicted protein', 120, NULL, NULL, 40436),
(40437, '1.25.10.10-FF-003196', NULL, 'Formin-F', 298, NULL, NULL, 40437),
(40438, '1.10.3080.10-FF-000013', NULL, 'Voltage-gated chloride channel (ClcA)', 404, NULL, NULL, 40438),
(40439, '1.10.532.10-FF-000008', NULL, 'Signal transducer and activator of transcription', 117, NULL, NULL, 40439),
(40440, '3.30.70.890-FF-000021', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 117, NULL, NULL, 40440),
(40441, '1.10.555.10-FF-000033', NULL, 'Rho GTPase activator (Lrg11)', 246, NULL, NULL, 40441),
(40442, '1.20.58.60-FF-000509', NULL, 'Spectrin beta chain', 214, NULL, NULL, 40442),
(40443, '2.140.10.30-FF-000017', NULL, 'Putative dipeptidyl aminopeptidase C14C4.15c', 435, NULL, NULL, 40443),
(40444, '3.40.20.10-FF-000054', NULL, 'Protein transport protein SEC23', 105, NULL, NULL, 40444),
(40445, '2.60.40.10-FF-000242', NULL, 'Inactive tyrosine-protein kinase transmembrane receptor ROR1', 95, NULL, NULL, 40445),
(40446, '3.20.20.140-FF-000070', NULL, 'Guanine deaminase', 324, NULL, NULL, 40446),
(40447, '3.30.420.10-FF-000444', NULL, 'Predicted protein', 224, NULL, NULL, 40447),
(40448, '3.80.10.10-FF-003997', NULL, 'Protein phosphatase 2C, putative', 153, NULL, NULL, 40448),
(40449, '2.130.10.10-FF-001900', NULL, 'DDB1- and CUL4-associated factor 13', 117, NULL, NULL, 40449),
(40450, '2.130.10.10-FF-003800', NULL, 'Uncharacterized protein', 311, NULL, NULL, 40450),
(40451, '3.40.50.2300-FF-000864', NULL, 'Uncharacterized protein', 261, NULL, NULL, 40451);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(40452, '2.10.25.10-FF-000771', NULL, 'Fat-like cadherin-related tumor suppressor homolog', 34, NULL, NULL, 40452),
(40453, '3.40.50.10190-FF-000099', NULL, 'DNA ligase', 86, NULL, NULL, 40453),
(40454, '3.30.160.60-FF-001872', NULL, 'Zinc finger protein', 28, NULL, NULL, 40454),
(40455, '2.60.60.20-FF-000044', NULL, NULL, 118, NULL, NULL, 40455),
(40456, '3.40.50.360-FF-000081', NULL, 'Glutathione-regulated potassium-efflux system ancillary protein KefG', 172, NULL, NULL, 40456),
(40457, '2.60.120.10-FF-000430', NULL, 'Cyclic nucleotide-binding domain protein', 131, NULL, NULL, 40457),
(40458, '3.10.100.10-FF-000397', NULL, NULL, 121, NULL, NULL, 40458),
(40459, '2.10.70.10-FF-000049', NULL, 'Complement C1s subcomponent', 69, NULL, NULL, 40459),
(40460, '1.10.510.10-FF-001907', NULL, 'Si:ch73-40a2.1', 182, NULL, NULL, 40460),
(40461, '2.60.40.10-FF-003721', NULL, NULL, 98, NULL, NULL, 40461),
(40462, '1.20.1720.10-FF-000072', NULL, 'Azole resistance protein, putative', 240, NULL, NULL, 40462),
(40463, '2.60.40.1930-FF-000029', NULL, 'Complement 4B (Chido blood group)', 120, NULL, NULL, 40463),
(40464, '2.60.40.1400-FF-000028', NULL, NULL, 150, NULL, NULL, 40464),
(40465, '3.30.930.10-FF-000174', NULL, 'ATP phosphoribosyltransferase regulatory subunit', 327, NULL, NULL, 40465),
(40466, '1.20.1270.60-FF-000287', NULL, 'Uncharacterized protein', 188, NULL, NULL, 40466),
(40467, '1.20.120.640-FF-000001', NULL, 'L-cysteine:1D-myo-inositol 2-amino-2-deoxy-alpha-D-glucopyranoside ligase', 83, NULL, NULL, 40467),
(40468, '3.40.1280.30-FF-000008', NULL, 'tRNA m(1)G methyltransferase, putative', 195, NULL, NULL, 40468),
(40469, '3.10.580.10-FF-000218', NULL, 'Chloride channel', 123, NULL, NULL, 40469),
(40470, '3.60.130.10-FF-000084', NULL, 'Uncharacterized protein', 118, NULL, NULL, 40470),
(40471, '1.20.1640.10-FF-000014', NULL, 'Protein translocase subunit SecD', 182, NULL, NULL, 40471),
(40472, '2.60.40.10-FF-005621', NULL, NULL, 99, NULL, NULL, 40472),
(40473, '3.30.160.60-FF-001782', NULL, 'Ras-responsive element-binding protein 1a', 41, NULL, NULL, 40473),
(40474, '1.10.3660.10-FF-000007', NULL, 'Prephenate dehydrogenase', 112, NULL, NULL, 40474),
(40475, '2.170.190.11-FF-000004', NULL, 'Molybdopterin molybdenumtransferase', 94, NULL, NULL, 40475),
(40476, '1.10.287.130-FF-000176', NULL, 'Development and carotenogenesis control-1 protein', 101, NULL, NULL, 40476),
(40477, '1.10.510.10-FF-001245', NULL, 'AGC/PDK1 protein kinase', 187, NULL, NULL, 40477),
(40478, '3.80.10.10-FF-000905', NULL, 'Receptor-like protein kinase 7', 250, NULL, NULL, 40478),
(40479, '3.30.160.60-FF-003479', NULL, 'Zinc finger protein 19', 32, NULL, NULL, 40479),
(40480, '2.60.120.920-FF-000182', NULL, 'Predicted protein', 165, NULL, NULL, 40480),
(40481, '3.30.60.30-FF-000107', NULL, 'Protein CBG17314', 53, NULL, NULL, 40481),
(40482, '2.30.30.490-FF-000009', NULL, 'DNA (cytosine-5)-methyltransferase', 181, NULL, NULL, 40482),
(40483, '2.10.25.10-FF-000198', NULL, 'latent-transforming growth factor beta-binding protein 1 isoform X1', 45, NULL, NULL, 40483),
(40484, '2.30.29.30-FF-000279', NULL, 'FYVE, RhoGEF and PH domain-containing protein 1', 106, NULL, NULL, 40484),
(40485, '3.40.190.80-FF-000017', NULL, 'Putative PAP-specific phosphatase, mitochondrial', 114, NULL, NULL, 40485),
(40486, '3.40.50.2300-FF-001370', NULL, NULL, 102, NULL, NULL, 40486),
(40487, '1.25.40.20-FF-000244', NULL, 'Ankyrin repeat-containing protein ITN1', 113, NULL, NULL, 40487),
(40488, '1.20.1560.10-FF-000536', NULL, 'ABC transporter, multidrug resistance associated protein', 344, NULL, NULL, 40488),
(40489, '1.10.10.440-FF-000105', NULL, 'Uncharacterized protein', 71, NULL, NULL, 40489),
(40490, '2.60.220.50-FF-000157', NULL, 'Uncharacterized protein', 289, NULL, NULL, 40490),
(40491, '2.60.40.10-FF-002041', NULL, 'AGAP005471-PA-like protein', 100, NULL, NULL, 40491),
(40492, '3.90.70.10-FF-000330', NULL, 'Papain family cysteine protease', 291, NULL, NULL, 40492),
(40493, '3.30.160.60-FF-000045', NULL, 'ZFP69 zinc finger protein B', 27, NULL, NULL, 40493);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(40494, '3.40.50.410-FF-000332', NULL, 'Sec24-related gene family, member C (S. cerevisiae)', 163, NULL, NULL, 40494),
(40495, '3.40.50.1760-FF-000016', NULL, NULL, 140, NULL, NULL, 40495),
(40496, '1.20.5.1130-FF-000001', NULL, 'Gap junction alpha-1', 36, NULL, NULL, 40496),
(40497, '3.30.70.100-FF-000155', NULL, NULL, 89, NULL, NULL, 40497),
(40498, '3.30.1340.10-FF-000010', NULL, 'Phosphotransferase system fructose-specific transporter subunit EI/HPr/EIIA', 88, NULL, NULL, 40498),
(40499, '3.40.605.10-FF-000023', NULL, 'Succinate-semialdehyde dehydrogenase (Eurofung)', 270, NULL, NULL, 40499),
(40500, '3.10.20.870-FF-000015', NULL, NULL, 87, NULL, NULL, 40500),
(40501, '2.40.20.10-FF-000112', NULL, 'Uncharacterized protein', 77, NULL, NULL, 40501),
(40502, '3.50.50.60-FF-000924', NULL, 'Rab proteins geranylgeranyltransferase component A', 155, NULL, NULL, 40502),
(40503, '3.90.1300.10-FF-000039', NULL, 'Uncharacterized protein', 86, NULL, NULL, 40503),
(40504, '3.40.50.300-FF-006240', NULL, 'Uncharacterized protein', 245, NULL, NULL, 40504),
(40505, '1.50.40.10-FF-000306', NULL, 'RE67391p', 153, NULL, NULL, 40505),
(40506, '3.40.50.720-FF-000453', NULL, '3-oxoacyl-[acyl-carrier protein] reductase', 254, NULL, NULL, 40506),
(40507, '1.25.10.10-FF-002313', NULL, 'AGAP000271-PA', 315, NULL, NULL, 40507),
(40508, '2.60.200.20-FF-000130', NULL, 'Plm2p', 91, NULL, NULL, 40508),
(40509, '1.10.1760.20-FF-000017', NULL, NULL, 182, NULL, NULL, 40509),
(40510, '3.40.50.720-FF-000969', NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', 173, NULL, NULL, 40510),
(40511, '1.20.1070.10-FF-000561', NULL, 'Protein CBG19271', 367, NULL, NULL, 40511),
(40512, '3.90.1750.10-FF-000022', NULL, 'probable E3 ubiquitin-protein ligase HECTD4 isoform X1', 163, NULL, NULL, 40512),
(40513, '3.40.50.300-FF-004340', NULL, 'ABC transporter ATP-binding protein', 250, NULL, NULL, 40513),
(40514, '3.30.70.330-FF-002585', NULL, NULL, 137, NULL, NULL, 40514),
(40515, '3.40.1810.10-FF-000050', NULL, 'AGAMOUS-like 15', 79, NULL, NULL, 40515),
(40516, '4.10.1060.10-FF-000015', NULL, 'Nuclear pore complex protein Nup153', 44, NULL, NULL, 40516),
(40517, '1.10.10.10-FF-002032', NULL, 'Uncharacterized protein', 97, NULL, NULL, 40517),
(40518, '3.30.70.330-FF-001303', NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', 90, NULL, NULL, 40518),
(40519, '1.25.40.10-FF-001017', NULL, 'Os12g0181900 protein', 263, NULL, NULL, 40519),
(40520, '2.130.10.10-FF-005907', NULL, 'PRP4 pre-mRNA-processing factor 4 homolog (yeast)', 281, NULL, NULL, 40520),
(40521, '1.25.10.10-FF-000104', NULL, 'HOPM interactor 7', 512, NULL, NULL, 40521),
(40522, '2.40.10.190-FF-000008', NULL, '60S ribosomal protein L35a-2', 60, NULL, NULL, 40522),
(40523, '3.30.460.10-FF-000109', NULL, 'Topoisomerase I-related protein', 111, NULL, NULL, 40523),
(40524, '1.10.540.10-FF-000100', NULL, 'L-prolyl-[peptidyl-carrier protein] dehydrogenase', 120, NULL, NULL, 40524),
(40525, '1.20.58.90-FF-000041', NULL, NULL, 73, NULL, NULL, 40525),
(40526, '3.90.530.10-FF-000006', NULL, NULL, 57, NULL, NULL, 40526),
(40527, '1.10.8.1120-FF-000001', NULL, 'Histone RNA hairpin-binding protein-like', 72, NULL, NULL, 40527),
(40528, '3.90.190.10-FF-000154', NULL, 'Protein CBG00285', 169, NULL, NULL, 40528),
(40529, '3.40.1110.10-FF-000249', NULL, NULL, 118, NULL, NULL, 40529),
(40530, '2.60.40.1530-FF-000016', NULL, 'Uncharacterized protein, isoform A', 169, NULL, NULL, 40530),
(40531, '3.40.1170.60-FF-000015', NULL, 'Polymerase (DNA directed) kappa', 34, NULL, NULL, 40531),
(40532, '3.30.559.10-FF-000193', NULL, 'Predicted protein', 162, NULL, NULL, 40532),
(40533, '3.40.50.150-FF-001193', NULL, 'Predicted protein', 337, NULL, NULL, 40533),
(40534, '3.40.50.720-FF-000762', NULL, 'PROBABLE SHORT-CHAIN TYPE DEHYDROGENASE', 253, NULL, NULL, 40534),
(40535, '1.10.287.70-FF-000433', NULL, 'Cytochrome c oxidase subunit 3', 67, NULL, NULL, 40535),
(40536, '3.40.250.10-FF-000092', NULL, 'MBL fold metallo-hydrolase', 95, NULL, NULL, 40536),
(40537, '2.40.50.140-FF-001272', NULL, NULL, 181, NULL, NULL, 40537); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(40538, '3.20.80.10-FF-000064', NULL, 'Uncharacterized protein', 84, NULL, NULL, 40538),
(40539, '1.20.1070.10-FF-000870', NULL, 'Cholecystokinin-like receptor at 17D1', 272, NULL, NULL, 40539),
(40540, '3.40.50.2300-FF-000555', NULL, 'Phosphodiesterase 8, isoform D', 139, NULL, NULL, 40540),
(40541, '3.90.1200.10-FF-000071', NULL, 'RE24176p', 144, NULL, NULL, 40541),
(40542, '3.30.50.10-FF-000079', NULL, 'Protein CBR-UNC-55, isoform a', 96, NULL, NULL, 40542),
(40543, '1.10.287.70-FF-000742', NULL, 'Uncharacterized protein', 98, NULL, NULL, 40543),
(40544, '1.25.40.10-FF-003226', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 59, NULL, NULL, 40544),
(40545, '1.10.506.10-FF-000021', NULL, 'Plexin C1', 419, NULL, NULL, 40545),
(40546, '3.30.70.330-FF-000994', NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', 112, NULL, NULL, 40546),
(40547, '2.130.10.10-FF-003137', NULL, 'BEACH domain-containing protein lvsD', 316, NULL, NULL, 40547),
(40548, '1.20.1740.10-FF-000180', NULL, 'Uncharacterized protein', 243, NULL, NULL, 40548),
(40549, '2.60.470.10-FF-000006', NULL, 'Acid-sensing ion channel 5', 237, NULL, NULL, 40549),
(40550, '3.30.160.60-FF-005379', NULL, NULL, 26, NULL, NULL, 40550),
(40551, '3.90.260.10-FF-000013', NULL, 'DNA repair protein RAD34', 342, NULL, NULL, 40551),
(40552, '3.30.160.60-FF-000135', NULL, 'Zinc finger protein 358', 29, NULL, NULL, 40552),
(40553, '3.80.10.10-FF-000198', NULL, 'Blast:Protein toll', 154, NULL, NULL, 40553),
(40554, '3.40.630.30-FF-000177', NULL, 'Putative acetyltransferase', 147, NULL, NULL, 40554),
(40555, '1.20.120.1080-FF-000106', NULL, 'Uncharacterized protein', 105, NULL, NULL, 40555),
(40556, '1.25.40.770-FF-000009', NULL, 'Transcription initiation factor tfiid, putative', 198, NULL, NULL, 40556),
(40557, '1.10.565.10-FF-000051', NULL, 'Blast:Protein tailless', 241, NULL, NULL, 40557),
(40558, '1.20.1250.20-FF-000780', NULL, 'Proton myo-inositol cotransporter', 137, NULL, NULL, 40558),
(40559, '3.40.140.10-FF-000100', NULL, 'DNA repair protein RadC', 125, NULL, NULL, 40559),
(40560, '1.25.10.10-FF-003286', NULL, 'Uncharacterized protein', 186, NULL, NULL, 40560),
(40561, '2.70.170.10-FF-000003', NULL, 'Putative gamma-aminobutyric acid receptor subunit gamma-2', 206, NULL, NULL, 40561),
(40562, '3.30.70.330-FF-001612', NULL, NULL, 96, NULL, NULL, 40562),
(40563, '3.30.200.20-FF-000993', NULL, 'Probable choline kinase 1', 69, NULL, NULL, 40563),
(40564, '1.20.1600.10-FF-000006', NULL, 'Type I secretion protein TolC', 398, NULL, NULL, 40564),
(40565, '1.10.225.10-FF-000014', NULL, 'Proactivator polypeptide-like 1', 80, NULL, NULL, 40565),
(40566, '2.60.40.60-FF-000240', NULL, 'Cadherin 16', 102, NULL, NULL, 40566),
(40567, '3.10.20.90-FF-000146', NULL, 'deubiquitinating protein VCIP135 isoform X1', 81, NULL, NULL, 40567),
(40568, '1.10.510.10-FF-000160', NULL, 'Casein kinase I 1', 334, NULL, NULL, 40568),
(40569, '1.25.40.610-FF-000012', NULL, 'Adhesion G protein-coupled receptor L3', 116, NULL, NULL, 40569),
(40570, '2.60.40.1180-FF-000220', NULL, 'Oligosaccharide 4-alpha-D-glucosyltransferase', 51, NULL, NULL, 40570),
(40571, '1.10.8.50-FF-000031', NULL, 'Mitochondrial ribosomal protein S13', 71, NULL, NULL, 40571),
(40572, '3.30.70.850-FF-000026', NULL, 'Proprotein convertase subtilisin/kexin type 5a', 74, NULL, NULL, 40572),
(40573, '2.130.10.10-FF-003446', NULL, 'Endonuclease/exonuclease/phosphatase', 136, NULL, NULL, 40573),
(40574, '2.130.10.10-FF-005700', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 149, NULL, NULL, 40574),
(40575, '1.20.58.60-FF-000397', NULL, 'AGAP007562-PA', 232, NULL, NULL, 40575),
(40576, '2.60.40.60-FF-000150', NULL, 'Dachsous cadherin-related 1', 102, NULL, NULL, 40576),
(40577, '3.90.190.10-FF-000463', NULL, 'Uncharacterized protein', 197, NULL, NULL, 40577),
(40578, '1.10.555.10-FF-000123', NULL, 'Rho GTPase activating protein putative', 207, NULL, NULL, 40578),
(40579, '3.40.50.10190-FF-000144', NULL, 'Protein CBR-HSR-9', 108, NULL, NULL, 40579),
(40580, '1.10.150.50-FF-000043', NULL, 'Sterile alpha and TIR motif-containing 1', 80, NULL, NULL, 40580);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(40581, '2.60.120.380-FF-000003', NULL, 'Calpain 5', 149, NULL, NULL, 40581),
(40582, '3.30.170.10-FF-000008', NULL, 'Cyclin-dependent kinases regulatory subunit', 69, NULL, NULL, 40582),
(40583, '2.40.30.10-FF-000040', NULL, 'Peptide chain release factor 3', 111, NULL, NULL, 40583),
(40584, '3.50.30.30-FF-000088', NULL, 'Peptidase', 226, NULL, NULL, 40584),
(40585, '2.130.10.10-FF-001546', NULL, 'Cilia and flagella associated protein 52', 305, NULL, NULL, 40585),
(40586, '1.25.50.20-FF-000082', NULL, 'Aminopeptidase', 173, NULL, NULL, 40586),
(40587, '3.30.200.20-FF-000684', NULL, 'Serine/threonine-protein kinase-like protein', 105, NULL, NULL, 40587),
(40588, '1.25.10.10-FF-002004', NULL, 'HEAT domain-containing protein', 224, NULL, NULL, 40588),
(40589, '3.40.50.300-FF-004031', NULL, 'Thiamine ABC transporter ATP-binding protein', 263, NULL, NULL, 40589),
(40590, '3.30.160.60-FF-002035', NULL, 'HKR1, GLI-Kruppel zinc finger family member', 26, NULL, NULL, 40590),
(40591, '1.10.8.60-FF-000034', NULL, 'Two-component system response regulator GlrR', 78, NULL, NULL, 40591),
(40592, '3.80.10.10-FF-002098', NULL, 'Calmodulin-binding protein CmbB', 255, NULL, NULL, 40592),
(40593, '1.20.58.390-FF-000224', NULL, 'Uncharacterized protein', 72, NULL, NULL, 40593),
(40594, '1.10.630.10-FF-000545', NULL, 'Uncharacterized protein', 351, NULL, NULL, 40594),
(40595, '1.25.40.10-FF-001326', NULL, 'Pentatricopeptide repeat-containing protein', 125, NULL, NULL, 40595),
(40596, '3.40.50.300-FF-007465', NULL, 'Uncharacterized protein', 318, NULL, NULL, 40596),
(40597, '4.10.410.10-FF-000124', NULL, 'Amyloid beta (A4) precursor protein a', 44, NULL, NULL, 40597),
(40598, '3.20.20.80-FF-000542', NULL, 'Predicted protein', 248, NULL, NULL, 40598),
(40599, '2.10.70.10-FF-000274', NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing 1', 62, NULL, NULL, 40599),
(40600, '2.170.190.11-FF-000021', NULL, 'Molybdopterin molybdenumtransferase', 93, NULL, NULL, 40600),
(40601, '3.30.70.330-FF-002495', NULL, NULL, 74, NULL, NULL, 40601),
(40602, '3.90.370.10-FF-000016', NULL, 'Uncharacterized protein', 32, NULL, NULL, 40602),
(40603, '3.40.190.10-FF-000839', NULL, 'Uncharacterized protein', 107, NULL, NULL, 40603),
(40604, '1.50.40.10-FF-000172', NULL, 'MC family mitochondrial carrier protein', 158, NULL, NULL, 40604),
(40605, '2.70.130.10-FF-000102', NULL, NULL, 149, NULL, NULL, 40605),
(40606, '1.25.40.20-FF-001891', NULL, 'Uncharacterized protein', 158, NULL, NULL, 40606),
(40607, '2.10.230.10-FF-000016', NULL, 'Os12g0619100 protein', 65, NULL, NULL, 40607),
(40608, '1.10.1220.10-FF-000002', NULL, 'Negative modulator of initiation of replication', 41, NULL, NULL, 40608),
(40609, '3.30.70.330-FF-000887', NULL, 'HnRNP A1 homolog', 83, NULL, NULL, 40609),
(40610, '2.60.120.260-FF-000299', NULL, 'Predicted protein', 133, NULL, NULL, 40610),
(40611, '3.40.50.300-FF-001479', NULL, 'ABC transporter G family member 10', 247, NULL, NULL, 40611),
(40612, '1.10.287.70-FF-000169', NULL, 'Glutamate receptor ionotropic, delta-2', 145, NULL, NULL, 40612),
(40613, '1.10.8.60-FF-000135', NULL, 'Replication factor C subunit 5, putative', 61, NULL, NULL, 40613),
(40614, '1.20.1250.20-FF-000555', NULL, 'MFS transporter, putative (AFU_orthologue AFUA_8G05090)', 382, NULL, NULL, 40614),
(40615, '3.30.300.160-FF-000024', NULL, 'Similar to type IV pilus assembly protein TapB', 75, NULL, NULL, 40615),
(40616, '2.60.120.330-FF-000022', NULL, 'Probable 2-oxoglutarate-dependent dioxygenase AOP1.2', 298, NULL, NULL, 40616),
(40617, '2.60.40.10-FF-000023', NULL, 'receptor-type tyrosine-protein phosphatase delta isoform X2', 99, NULL, NULL, 40617),
(40618, '3.40.30.10-FF-000111', NULL, 'Glutathione peroxidase', 171, NULL, NULL, 40618),
(40619, '3.30.230.70-FF-000110', NULL, 'Chromosome 1, whole genome shotgun sequence', 322, NULL, NULL, 40619),
(40620, '2.40.30.70-FF-000018', NULL, 'Uncharacterized protein', 140, NULL, NULL, 40620),
(40621, '1.10.10.830-FF-000014', NULL, 'Isoleucine-trna synthetase', 56, NULL, NULL, 40621);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(40622, '1.10.630.10-FF-000663', NULL, 'Cytochrome P450, putative', 186, NULL, NULL, 40622),
(40623, '1.25.40.180-FF-000147', NULL, 'Suppressor of glycerol defect protein, putative', 264, NULL, NULL, 40623),
(40624, '3.30.70.330-FF-001511', NULL, NULL, 77, NULL, NULL, 40624),
(40625, '1.10.287.950-FF-000051', NULL, 'Predicted protein', 151, NULL, NULL, 40625),
(40626, '3.30.200.20-FF-001263', NULL, 'Serine-threonine kinase Stk1', 127, NULL, NULL, 40626),
(40627, '2.40.10.10-FF-000050', NULL, 'mannan-binding lectin serine protease 1 isoform X1', 115, NULL, NULL, 40627),
(40628, '2.60.120.620-FF-000002', NULL, 'Prolyl 4-hydroxylase 4', 207, NULL, NULL, 40628),
(40629, '3.40.1110.10-FF-000165', NULL, 'Uncharacterized protein, isoform A', 217, NULL, NULL, 40629),
(40630, '1.10.150.50-FF-000060', NULL, 'Ankyrin repeat, SAM and basic leucine zipper domain-containing protein 1', 66, NULL, NULL, 40630),
(40631, '3.40.50.300-FF-004132', NULL, 'Mitochondrial GTPase, putative', 177, NULL, NULL, 40631),
(40632, '3.40.50.10190-FF-000228', NULL, 'Uncharacterized protein', 91, NULL, NULL, 40632),
(40633, '3.40.50.1820-FF-000383', NULL, 'endothelial lipase', 307, NULL, NULL, 40633),
(40634, '3.30.160.60-FF-001563', NULL, 'GDNF inducible zinc finger protein 1', 30, NULL, NULL, 40634),
(40635, '2.10.110.10-FF-000289', NULL, 'Uncharacterized protein', 46, NULL, NULL, 40635),
(40636, '3.30.9.10-FF-000152', NULL, 'YALI0E20735p', 181, NULL, NULL, 40636),
(40637, '3.90.640.10-FF-000245', NULL, 'Uncharacterized protein', 20, NULL, NULL, 40637),
(40638, '1.20.1270.10-FF-000082', NULL, 'Endoplasmic reticulum heat shock protein 70, putative', 72, NULL, NULL, 40638),
(40639, '3.30.450.20-FF-000466', NULL, 'Hypoxia-inducible factor 1-alpha', 94, NULL, NULL, 40639),
(40640, '2.160.20.10-FF-000287', NULL, 'Uncharacterized protein', 160, NULL, NULL, 40640),
(40641, '1.20.58.60-FF-000279', NULL, 'Calponin domain-containing protein', 121, NULL, NULL, 40641),
(40642, '1.10.510.10-FF-001655', NULL, 'Kinase, NEK', 165, NULL, NULL, 40642),
(40643, '2.60.120.10-FF-000345', NULL, 'Acireductone dioxygenase, putative', 121, NULL, NULL, 40643),
(40644, '1.25.40.20-FF-000261', NULL, 'Ankyrin repeat, SAM and basic leucine zipper domain-containing protein 1', 128, NULL, NULL, 40644),
(40645, '1.20.1560.10-FF-000519', NULL, 'ATP-binding cassette transporter, subfamily C, member 6, group MRP protein PpABCC6', 311, NULL, NULL, 40645),
(40646, '3.30.930.10-FF-000410', NULL, 'GlycyltRNA synthetase, putative', 66, NULL, NULL, 40646),
(40647, '1.20.120.850-FF-000047', NULL, 'AGL212Wp', 92, NULL, NULL, 40647),
(40648, '3.30.70.600-FF-000007', NULL, 'Ribosomal protein S10', 93, NULL, NULL, 40648),
(40649, '3.40.367.20-FF-000034', NULL, 'Phosphotransferase', 116, NULL, NULL, 40649),
(40650, '1.20.120.1240-FF-000076', NULL, 'Uncharacterized protein', 243, NULL, NULL, 40650),
(40651, '3.40.50.300-FF-003733', NULL, 'Uncharacterized protein', 165, NULL, NULL, 40651),
(40652, '2.10.25.10-FF-000905', NULL, 'Predicted protein', 40, NULL, NULL, 40652),
(40653, '3.30.420.10-FF-000528', NULL, NULL, 100, NULL, NULL, 40653),
(40654, '3.30.420.10-FF-000326', NULL, 'Mitochondrial resolvase Ydc2', 309, NULL, NULL, 40654),
(40655, '1.10.10.10-FF-001419', NULL, 'Putative transcriptional regulator', 88, NULL, NULL, 40655),
(40656, '2.70.170.10-FF-000211', NULL, 'Glutamate-gated chloride channel, putative', 154, NULL, NULL, 40656),
(40657, '2.70.150.10-FF-000204', NULL, 'Phospholipid-transporting ATPase', 165, NULL, NULL, 40657),
(40658, '1.10.8.10-FF-000058', NULL, 'Ubiquitin conjugating enzyme E2 K', 25, NULL, NULL, 40658),
(40659, '3.30.160.60-FF-005834', NULL, NULL, 26, NULL, NULL, 40659),
(40660, '1.10.10.10-FF-001099', NULL, 'MarR family transcriptional regulator', 160, NULL, NULL, 40660),
(40661, '3.30.930.10-FF-000292', NULL, 'Lysine--tRNA ligase', 295, NULL, NULL, 40661),
(40662, '3.40.1370.10-FF-000015', NULL, '50S ribosomal protein L4', 207, NULL, NULL, 40662),
(40663, '3.60.40.10-FF-000217', NULL, 'Probable protein phosphatase 2C F42G9.1', 134, NULL, NULL, 40663);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(40664, '1.20.920.10-FF-000037', NULL, 'ATPase family AAA domain-containing protein', 129, NULL, NULL, 40664),
(40665, '3.40.50.850-FF-000014', NULL, 'Maleamate amidohydrolase', 211, NULL, NULL, 40665),
(40666, '3.40.50.300-FF-007791', NULL, 'Ras-related protein Rab-6A', 48, NULL, NULL, 40666),
(40667, '1.20.1560.10-FF-000845', NULL, 'ATP-binding cassette transporter, subfamily B, member 2, group MDR/PGP protein PpABCB2', 401, NULL, NULL, 40667),
(40668, '3.30.70.3310-FF-000001', NULL, 'Neurogenic locus notch protein 2', 142, NULL, NULL, 40668),
(40669, '2.60.40.10-FF-001804', NULL, 'Titin, isoform CRA_a', 92, NULL, NULL, 40669),
(40670, '2.30.42.10-FF-000484', NULL, NULL, 59, NULL, NULL, 40670),
(40671, '2.70.160.11-FF-000049', NULL, 'Uncharacterized protein', 49, NULL, NULL, 40671),
(40672, '3.90.190.10-FF-000137', NULL, 'Protein tyrosine phosphatase, putative', 150, NULL, NULL, 40672),
(40673, '1.50.10.10-FF-000142', NULL, 'Non-lysosomal glucosylceramidase', 301, NULL, NULL, 40673),
(40674, '3.40.50.620-FF-000748', NULL, 'Uncharacterized protein', 148, NULL, NULL, 40674),
(40675, '3.40.33.10-FF-000134', NULL, 'Uncharacterized protein', 179, NULL, NULL, 40675),
(40676, '1.25.40.20-FF-001565', NULL, 'Ankyrin repeat family protein', 77, NULL, NULL, 40676),
(40677, '1.10.3060.10-FF-000023', NULL, 'Protein translocase subunit SECA1 chloroplastic', 80, NULL, NULL, 40677),
(40678, '1.50.10.20-FF-000038', NULL, 'Complement C4', 294, NULL, NULL, 40678),
(40679, '3.80.10.10-FF-004486', NULL, 'Uncharacterized protein', 111, NULL, NULL, 40679),
(40680, '3.60.20.10-FF-000008', NULL, 'Proteasome subunit beta type-4', 198, NULL, NULL, 40680),
(40681, '3.30.980.10-FF-000014', NULL, 'Alanyl-tRNA editing protein AlaX-M', 150, NULL, NULL, 40681),
(40682, '3.30.160.60-FF-000461', NULL, 'Zinc finger X-chromosomal protein-like protein', 27, NULL, NULL, 40682),
(40683, '2.130.10.10-FF-005037', NULL, 'Protein HIRA', 297, NULL, NULL, 40683),
(40684, '2.20.25.10-FF-000118', NULL, 'DNA-directed RNA polymerase subunit', 47, NULL, NULL, 40684),
(40685, '3.40.1170.10-FF-000034', NULL, 'MutS homolog 1B', 133, NULL, NULL, 40685),
(40686, '2.60.120.340-FF-000025', NULL, 'Uncharacterized protein', 116, NULL, NULL, 40686),
(40687, '2.60.40.10-FF-004879', NULL, NULL, 105, NULL, NULL, 40687),
(40688, '1.50.10.20-FF-000145', NULL, 'Terpene cyclase/mutase family member', 74, NULL, NULL, 40688),
(40689, '2.30.30.40-FF-000105', NULL, 'MAGUK p55 subfamily member 5', 131, NULL, NULL, 40689),
(40690, '1.25.40.10-FF-003451', NULL, 'Uncharacterized protein', 134, NULL, NULL, 40690),
(40691, '3.40.850.10-FF-000396', NULL, 'Kinesin-like protein', 285, NULL, NULL, 40691),
(40692, '1.20.1250.20-FF-000881', NULL, 'SoLute Carrier Family', 194, NULL, NULL, 40692),
(40693, '3.40.50.620-FF-000855', NULL, 'Uncharacterized protein', 220, NULL, NULL, 40693),
(40694, '3.10.290.20-FF-000019', NULL, 'SUMO-activating enzyme subunit', 98, NULL, NULL, 40694),
(40695, '2.60.120.430-FF-000024', NULL, 'Receptor protein kinase-like protein', 154, NULL, NULL, 40695),
(40696, '1.10.510.10-FF-003370', NULL, NULL, 195, NULL, NULL, 40696),
(40697, '3.30.2440.10-FF-000001', NULL, 'SPI-2 type III secretion system effector SseI', 105, NULL, NULL, 40697),
(40698, '1.20.1560.10-FF-000626', NULL, 'Uncharacterized protein', 268, NULL, NULL, 40698),
(40699, '3.10.290.10-FF-000016', NULL, 'Pseudouridine synthase', 67, NULL, NULL, 40699),
(40700, '1.10.1040.10-FF-000123', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', 75, NULL, NULL, 40700),
(40701, '3.40.1180.10-FF-000006', NULL, 'Alkyl transferase', 103, NULL, NULL, 40701),
(40702, '3.40.50.1260-FF-000046', NULL, 'Phosphoglycerate kinase', 59, NULL, NULL, 40702),
(40703, '1.50.10.10-FF-000035', NULL, 'LanC-like protein 2', 410, NULL, NULL, 40703),
(40704, '3.10.270.10-FF-000009', NULL, 'Uricase', 63, NULL, NULL, 40704),
(40705, '3.30.360.20-FF-000021', NULL, NULL, 108, NULL, NULL, 40705),
(40706, '3.30.40.10-FF-000707', NULL, 'RING finger protein', 122, NULL, NULL, 40706),
(40707, '1.10.287.70-FF-000539', NULL, 'Potassium channel, calcium-activated intermediate/small conductance subfamily N alpha, member 2', 26, NULL, NULL, 40707);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(40708, '3.10.20.410-FF-000006', NULL, 'Outer membrane usher protein PefC', 112, NULL, NULL, 40708),
(40709, '3.90.190.10-FF-000614', NULL, 'DnaJ heat shock protein family (Hsp40) member C6', 98, NULL, NULL, 40709),
(40710, '2.30.29.30-FF-001122', NULL, 'Uncharacterized protein', 128, NULL, NULL, 40710),
(40711, '1.10.8.60-FF-000505', NULL, 'Predicted protein', 64, NULL, NULL, 40711),
(40712, '3.90.70.80-FF-000008', NULL, 'OTU domain-containing protein 5', 153, NULL, NULL, 40712),
(40713, '2.40.440.10-FF-000003', NULL, 'L,D-transpeptidase YciB', 133, NULL, NULL, 40713),
(40714, '3.90.25.10-FF-000052', NULL, 'Uncharacterized protein', 105, NULL, NULL, 40714),
(40715, '3.30.160.60-FF-005615', NULL, NULL, 30, NULL, NULL, 40715),
(40716, '3.40.250.10-FF-000193', NULL, 'Adenylyltransferase and sulfurtransferase MOCS3 homolog', 141, NULL, NULL, 40716),
(40717, '1.20.58.930-FF-000004', NULL, 'Biosynthetic arginine decarboxylase', 92, NULL, NULL, 40717),
(40718, '2.60.40.10-FF-005059', NULL, NULL, 101, NULL, NULL, 40718),
(40719, '2.60.40.10-FF-003575', NULL, NULL, 95, NULL, NULL, 40719),
(40720, '3.30.450.20-FF-000157', NULL, 'Methyl-accepting chemotaxis protein', 155, NULL, NULL, 40720),
(40721, '3.30.40.10-FF-000696', NULL, 'RING zinc finger protein, putative', 71, NULL, NULL, 40721),
(40722, '2.60.40.1670-FF-000024', NULL, 'Protein transport protein SEC23', 154, NULL, NULL, 40722),
(40723, '3.40.50.620-FF-000529', NULL, 'Cytoplasmic tRNA 2-thiolation protein 1', 319, NULL, NULL, 40723),
(40724, '3.30.40.10-FF-002259', NULL, 'Histone-lysine N-methyltransferase', 56, NULL, NULL, 40724),
(40725, '3.40.50.2300-FF-000656', NULL, 'Response regulator SaeR', 131, NULL, NULL, 40725),
(40726, '3.30.1360.40-FF-000026', NULL, 'Allophanate hydrolase', 77, NULL, NULL, 40726),
(40727, '1.10.630.10-FF-000770', NULL, 'Cytochrome P450, putative', 188, NULL, NULL, 40727),
(40728, '3.40.1800.20-FF-000024', NULL, 'GG15664', 82, NULL, NULL, 40728),
(40729, '2.130.10.10-FF-001771', NULL, 'Coatomer alpha subunit', 346, NULL, NULL, 40729),
(40730, '3.30.40.10-FF-000477', NULL, 'General transcription and DNA repair factor IIH', 78, NULL, NULL, 40730),
(40731, '2.130.10.10-FF-004042', NULL, 'Predicted protein', 218, NULL, NULL, 40731),
(40732, '2.60.40.10-FF-001793', NULL, 'Immunoglobulin alpha Fc receptor', 95, NULL, NULL, 40732),
(40733, '3.40.50.300-FF-001816', NULL, '3''-5'' exonuclease DinG', 255, NULL, NULL, 40733),
(40734, '1.10.287.70-FF-000388', NULL, 'Uncharacterized protein', 312, NULL, NULL, 40734),
(40735, '3.20.20.70-FF-000213', NULL, '1-(5-phosphoribosyl)-5-[(5-phosphoribosylamino)methylideneamino] imidazole-4-carboxamide isomerase', 229, NULL, NULL, 40735),
(40736, '2.170.150.40-FF-000004', NULL, 'Related to decapping enzyme', 122, NULL, NULL, 40736),
(40737, '1.25.50.20-FF-000065', NULL, 'Peptidase family m1 protein, putative', 76, NULL, NULL, 40737),
(40738, '1.10.3200.20-FF-000015', NULL, NULL, 160, NULL, NULL, 40738),
(40739, '3.90.1780.10-FF-000001', NULL, 'Adhesin', 108, NULL, NULL, 40739),
(40740, '3.40.1380.20-FF-000070', NULL, 'Pyruvate kinase', 138, NULL, NULL, 40740),
(40741, '1.10.510.10-FF-001806', NULL, 'Uncharacterized protein', 352, NULL, NULL, 40741),
(40742, '3.30.70.260-FF-000063', NULL, 'ACT domain repeat 6', 78, NULL, NULL, 40742),
(40743, '3.40.50.300-FF-004441', NULL, 'Shikimate kinase', 157, NULL, NULL, 40743),
(40744, '1.25.40.70-FF-000012', NULL, 'phosphatidylinositol 3-kinase, root isoform', 211, NULL, NULL, 40744),
(40745, '3.30.2410.10-FF-000027', NULL, 'E3 ubiquitin-protein ligase HUWE1', 119, NULL, NULL, 40745),
(40746, '1.20.1250.20-FF-000336', NULL, 'MFS transporter', 202, NULL, NULL, 40746),
(40747, '1.20.58.60-FF-000498', NULL, 'Guanine nucleotide exchange factor UNC-73B', 233, NULL, NULL, 40747),
(40748, '2.130.10.10-FF-003553', NULL, 'Protein will die slowly-like Protein', 259, NULL, NULL, 40748),
(40749, '3.80.10.10-FF-003502', NULL, 'Uncharacterized protein', 188, NULL, NULL, 40749),
(40750, '1.10.1080.10-FF-000013', NULL, 'Glutathione synthetase', 75, NULL, NULL, 40750);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(40751, '3.80.10.10-FF-002362', NULL, 'P-granule-associated novel protein 1', 197, NULL, NULL, 40751),
(40752, '3.30.1490.20-FF-000041', NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta, mitochondrial', 98, NULL, NULL, 40752),
(40753, '3.10.250.10-FF-000126', NULL, NULL, 102, NULL, NULL, 40753),
(40754, '3.30.450.20-FF-000685', NULL, 'Regulatory-associated protein of TOR 1', 53, NULL, NULL, 40754),
(40755, '2.170.150.30-FF-000001', NULL, 'Probable ATP-dependent RNA helicase DDX58', 126, NULL, NULL, 40755),
(40756, '3.20.20.80-FF-000216', NULL, 'Beta-N-acetylhexosaminidase', 488, NULL, NULL, 40756),
(40757, '3.40.50.300-FF-007802', NULL, 'Predicted protein', 43, NULL, NULL, 40757),
(40758, '3.40.50.300-FF-003952', NULL, 'Carbohydrate sulfotransferase', 280, NULL, NULL, 40758),
(40759, '2.60.200.30-FF-000032', NULL, 'Predicted protein', 148, NULL, NULL, 40759),
(40760, '1.20.91.20-FF-000007', NULL, 'Complement 4B (Chido blood group)', 79, NULL, NULL, 40760),
(40761, '3.40.50.300-FF-000080', NULL, 'Ras-like GTPase Ras1', 175, NULL, NULL, 40761),
(40762, '3.20.20.380-FF-000017', NULL, 'Uncharacterized protein', 80, NULL, NULL, 40762),
(40763, '2.30.39.10-FF-000122', NULL, 'Serpin-2 precursor, putative', 53, NULL, NULL, 40763),
(40764, '3.30.160.270-FF-000001', NULL, '2-isopropylmalate synthase', 107, NULL, NULL, 40764),
(40765, '1.10.8.280-FF-000003', NULL, 'UvrABC system protein A', 119, NULL, NULL, 40765),
(40766, '3.30.710.10-FF-000399', NULL, 'Uncharacterized protein', 158, NULL, NULL, 40766),
(40767, '2.60.200.40-FF-000035', NULL, 'Diacylglycerol kinase', 74, NULL, NULL, 40767),
(40768, '1.10.1450.10-FF-000013', NULL, 'Tetraspanin', 94, NULL, NULL, 40768),
(40769, '3.40.50.11840-FF-000009', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 2', 90, NULL, NULL, 40769),
(40770, '2.60.120.200-FF-000539', NULL, 'sex hormone-binding globulin-like', 187, NULL, NULL, 40770),
(40771, '3.40.50.10180-FF-000006', NULL, 'Glycerate 2-kinase', 212, NULL, NULL, 40771),
(40772, '4.10.1060.10-FF-000032', NULL, 'Endonuclease/Exonuclease/phosphatase family protein, expressed', 41, NULL, NULL, 40772),
(40773, '1.25.40.20-FF-000800', NULL, 'Uncharacterized protein', 208, NULL, NULL, 40773),
(40774, '3.30.505.10-FF-000231', NULL, NULL, 88, NULL, NULL, 40774),
(40775, '1.10.10.10-FF-000115', NULL, 'HTH-type transcriptional regulator MalT', 64, NULL, NULL, 40775),
(40776, '1.25.10.10-FF-003314', NULL, 'Uncharacterized protein', 148, NULL, NULL, 40776),
(40777, '3.30.70.330-FF-000668', NULL, 'RNA-binding protein', 112, NULL, NULL, 40777),
(40778, '3.40.50.10190-FF-000009', NULL, 'DNA repair protein REV1', 96, NULL, NULL, 40778),
(40779, '2.30.29.30-FF-000633', NULL, 'PH-protein kinase domain containing protein', 104, NULL, NULL, 40779),
(40780, '1.20.1070.10-FF-000454', NULL, 'TYRAmine receptor', 271, NULL, NULL, 40780),
(40781, '3.40.50.1820-FF-000276', NULL, 'Acyl-protein thioesterase 1', 221, NULL, NULL, 40781),
(40782, '3.40.50.300-FF-005857', NULL, 'Uncharacterized protein', 231, NULL, NULL, 40782),
(40783, '3.40.605.10-FF-000107', NULL, 'Uncharacterized protein', 94, NULL, NULL, 40783),
(40784, '3.30.200.20-FF-001156', NULL, 'Uncharacterized protein', 99, NULL, NULL, 40784),
(40785, '3.40.50.1700-FF-000004', NULL, 'Periplasmic beta-glucosidase', 268, NULL, NULL, 40785),
(40786, '3.30.160.60-FF-004204', NULL, NULL, 24, NULL, NULL, 40786),
(40787, '1.10.287.600-FF-000002', NULL, 'Tubulin beta chain', 61, NULL, NULL, 40787),
(40788, '1.10.3380.10-FF-000042', NULL, 'Uncharacterized protein', 161, NULL, NULL, 40788),
(40789, '2.70.50.30-FF-000012', NULL, NULL, 60, NULL, NULL, 40789),
(40790, '3.40.50.1240-FF-000040', NULL, 'Phosphoglycerate mutase', 302, NULL, NULL, 40790),
(40791, '1.10.510.10-FF-001346', NULL, 'Uncharacterized protein', 71, NULL, NULL, 40791),
(40792, '3.30.559.10-FF-000277', NULL, 'Choline oacetyltransferase, putative', 62, NULL, NULL, 40792),
(40793, '3.30.160.60-FF-001439', NULL, 'Trithorax-like, isoform C', 54, NULL, NULL, 40793),
(40794, '3.40.50.11350-FF-000043', NULL, 'Uncharacterized protein', 82, NULL, NULL, 40794);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(40795, '1.25.10.10-FF-001369', NULL, 'Rho family-interacting cell polarization regulator 2', 144, NULL, NULL, 40795),
(40796, '1.20.1560.10-FF-000317', NULL, 'ABC transporter, ATP-binding protein', 323, NULL, NULL, 40796),
(40797, '1.10.287.370-FF-000079', NULL, 'Prefoldin subunit alpha', 126, NULL, NULL, 40797),
(40798, '1.20.1730.10-FF-000117', NULL, 'Uncharacterized protein', 88, NULL, NULL, 40798),
(40799, '2.40.240.10-FF-000022', NULL, '50S ribosomal protein L25', 96, NULL, NULL, 40799),
(40800, '3.60.10.10-FF-000362', NULL, 'Uncharacterized protein', 129, NULL, NULL, 40800),
(40801, '3.30.60.270-FF-000007', NULL, 'Sortilin', 78, NULL, NULL, 40801),
(40802, '2.30.29.30-FF-000942', NULL, 'G-protein subunit alpha 3', 119, NULL, NULL, 40802),
(40803, '3.40.50.80-FF-000178', NULL, 'Ferric-chelate reductase, putative', 190, NULL, NULL, 40803),
(40804, '1.10.510.10-FF-000025', NULL, 'Casein kinase I isoform gamma-1', 226, NULL, NULL, 40804),
(40805, '3.40.50.1820-FF-000585', NULL, 'CBN-PCP-5 protein', 294, NULL, NULL, 40805),
(40806, '1.10.287.610-FF-000005', NULL, 'DNA ligase', 64, NULL, NULL, 40806),
(40807, '1.10.575.10-FF-000023', NULL, 'Uncharacterized protein', 128, NULL, NULL, 40807),
(40808, '2.70.50.40-FF-000015', NULL, 'Phosphodiesterase 6D, cGMP-specific, rod, delta', 109, NULL, NULL, 40808),
(40809, '3.40.720.10-FF-000212', NULL, 'Choline sulfatase', 459, NULL, NULL, 40809),
(40810, '3.40.50.410-FF-000124', NULL, 'ATP-dependent DNA helicase II subunit 2', 151, NULL, NULL, 40810),
(40811, '3.40.50.300-FF-005548', NULL, 'ABC transporter', 275, NULL, NULL, 40811),
(40812, '4.10.400.10-FF-000213', NULL, 'Complement component C9', 36, NULL, NULL, 40812),
(40813, '3.30.60.160-FF-000002', NULL, 'Polyhomeotic-like protein 2 isoform 1', 47, NULL, NULL, 40813),
(40814, '2.60.120.200-FF-000556', NULL, 'Uncharacterized protein', 147, NULL, NULL, 40814),
(40815, '1.25.10.10-FF-003207', NULL, 'Protein CELLULOSE SYNTHASE INTERACTIVE 3', 279, NULL, NULL, 40815),
(40816, '3.40.30.10-FF-000751', NULL, 'Peroxiredoxin-2', 197, NULL, NULL, 40816),
(40817, '1.10.510.10-FF-003572', NULL, NULL, 217, NULL, NULL, 40817),
(40818, '1.20.1250.20-FF-002337', NULL, 'Uncharacterized protein', 108, NULL, NULL, 40818),
(40819, '1.20.58.60-FF-000588', NULL, 'Spectrin beta chain', 209, NULL, NULL, 40819),
(40820, '3.80.10.10-FF-004470', NULL, 'Uncharacterized protein', 47, NULL, NULL, 40820),
(40821, '1.20.1270.60-FF-000208', NULL, 'YALI0C03245p', 213, NULL, NULL, 40821),
(40822, '2.60.40.10-FF-003570', NULL, NULL, 100, NULL, NULL, 40822),
(40823, '3.40.50.300-FF-003750', NULL, 'Dynamin 1 like', 225, NULL, NULL, 40823),
(40824, '1.20.1250.20-FF-000971', NULL, 'WGS project CABT00000000 data, contig 2.10', 217, NULL, NULL, 40824),
(40825, '3.40.50.80-FF-000088', NULL, 'Ferric-chelate reductase, putative', 184, NULL, NULL, 40825),
(40826, '3.10.50.40-FF-000009', NULL, 'Peptidyl-prolyl cis-trans isomerase', 73, NULL, NULL, 40826),
(40827, '2.60.40.60-FF-001089', NULL, 'Uncharacterized protein', 119, NULL, NULL, 40827),
(40828, '3.40.50.1820-FF-000692', NULL, 'Probable thioesterase', 233, NULL, NULL, 40828),
(40829, '2.40.50.140-FF-000575', NULL, 'sn-glycerol-3-phosphate import ATP-binding protein UgpC', 65, NULL, NULL, 40829),
(40830, '2.30.29.30-FF-001324', NULL, 'Histonearginine N-methyltransferase', 65, NULL, NULL, 40830),
(40831, '2.60.40.10-FF-003912', NULL, NULL, 110, NULL, NULL, 40831),
(40832, '3.40.850.10-FF-000087', NULL, 'Kinesin-like protein', 364, NULL, NULL, 40832),
(40833, '3.40.140.10-FF-000201', NULL, 'Deoxycytidylate deaminase, putative (AFU_orthologue AFUA_2G06240)', 84, NULL, NULL, 40833),
(40834, '3.30.420.10-FF-000545', NULL, NULL, 72, NULL, NULL, 40834),
(40835, '1.10.287.4300-FF-000001', NULL, 'Stage III sporulation protein AH', 115, NULL, NULL, 40835),
(40836, '2.70.160.11-FF-000066', NULL, 'Ribosomal protein L11 methyltransferase (PrmA)', 179, NULL, NULL, 40836),
(40837, '3.20.20.70-FF-000174', NULL, 'Transaldolase type', 356, NULL, NULL, 40837),
(40838, '2.70.98.30-FF-000026', NULL, 'Alpha-mannosidase F', 312, NULL, NULL, 40838);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(40839, '4.10.240.10-FF-000206', NULL, 'Probable transcriptional repressor C1348.12', 70, NULL, NULL, 40839),
(40840, '1.50.10.10-FF-000125', NULL, 'Meiotically up-regulated gene 157 protein', 473, NULL, NULL, 40840),
(40841, '3.30.70.330-FF-000578', NULL, 'Peptidyl-prolyl cis-trans isomerase', 57, NULL, NULL, 40841),
(40842, '1.10.640.10-FF-000046', NULL, 'Peroxidase', 124, NULL, NULL, 40842),
(40843, '1.10.3370.10-FF-000007', NULL, 'Sec61 translocon alpha 2 subunit', 258, NULL, NULL, 40843),
(40844, '3.40.50.1820-FF-001107', NULL, 'Lipase family member K', 236, NULL, NULL, 40844),
(40845, '3.40.50.300-FF-001496', NULL, 'Translation factor GUF1 homolog, mitochondrial', 184, NULL, NULL, 40845),
(40846, '3.30.60.90-FF-000002', NULL, 'Dystrobrevin alpha', 61, NULL, NULL, 40846),
(40847, '3.30.420.10-FF-000309', NULL, 'Target of EGR1, exonuclease', 101, NULL, NULL, 40847),
(40848, '3.20.20.80-FF-000177', NULL, 'MANEAL isoform 4', 350, NULL, NULL, 40848),
(40849, '3.30.1740.10-FF-000029', NULL, 'Poly [ADP-ribose] polymerase', 61, NULL, NULL, 40849),
(40850, '3.30.70.330-FF-001202', NULL, 'RNA recognition motif domain containing protein', 93, NULL, NULL, 40850),
(40851, '1.20.1070.10-FF-000763', NULL, 'Uncharacterized protein', 285, NULL, NULL, 40851),
(40852, '1.10.287.70-FF-000534', NULL, 'Uncharacterized protein', 91, NULL, NULL, 40852),
(40853, '3.10.20.410-FF-000001', NULL, 'Fimbrial outer membrane usher protein', 121, NULL, NULL, 40853),
(40854, '3.90.245.10-FF-000017', NULL, 'Related to nucleoside hydrolase', 321, NULL, NULL, 40854),
(40855, '1.10.510.10-FF-000042', NULL, 'Non-specific serine/threonine protein kinase', 68, NULL, NULL, 40855),
(40856, '1.10.540.10-FF-000072', NULL, 'Acyl-coenzyme A oxidase', 115, NULL, NULL, 40856),
(40857, '2.130.10.10-FF-005716', NULL, 'Predicted protein', 140, NULL, NULL, 40857),
(40858, '1.10.30.10-FF-000010', NULL, 'Capicua transcriptional repressor b', 84, NULL, NULL, 40858),
(40859, '1.10.630.10-FF-000298', NULL, 'Cytochrome P450, family 2, subfamily C, polypeptide 8, gene 2', 472, NULL, NULL, 40859),
(40860, '2.130.10.10-FF-001299', NULL, 'Probable cytosolic iron-sulfur protein assembly protein CIAO1 homolog', 119, NULL, NULL, 40860),
(40861, '3.60.40.10-FF-000083', NULL, 'Stage II sporulation protein E', 249, NULL, NULL, 40861),
(40862, '1.20.5.170-FF-000283', NULL, 'Uncharacterized protein', 54, NULL, NULL, 40862),
(40863, '3.40.50.720-FF-002358', NULL, 'Uncharacterized protein', 96, NULL, NULL, 40863),
(40864, '1.25.10.10-FF-002212', NULL, 'Uncharacterized protein', 422, NULL, NULL, 40864),
(40865, '3.20.20.60-FF-000064', NULL, 'Pyruvate kinase', 178, NULL, NULL, 40865),
(40866, '2.20.25.240-FF-000011', NULL, 'Uncharacterized protein, isoform D', 98, NULL, NULL, 40866),
(40867, '3.20.20.70-FF-000522', NULL, 'Dihydroorotate dehydrogenase', 269, NULL, NULL, 40867),
(40868, '3.40.630.30-FF-000059', NULL, 'Putative acetyltransferase NSI', 137, NULL, NULL, 40868),
(40869, '1.10.1410.20-FF-000014', NULL, 'Uncharacterized protein', 39, NULL, NULL, 40869),
(40870, '2.40.50.140-FF-000682', NULL, NULL, 80, NULL, NULL, 40870),
(40871, '2.40.240.10-FF-000038', NULL, 'Putative glutaminyl-tRNA synthetase', 83, NULL, NULL, 40871),
(40872, '1.25.10.10-FF-001588', NULL, 'Adaptin N terminal region family protein', 289, NULL, NULL, 40872),
(40873, '1.20.1740.10-FF-000073', NULL, 'Y+L amino acid transporter', 447, NULL, NULL, 40873),
(40874, '3.40.50.1010-FF-000218', NULL, NULL, 130, NULL, NULL, 40874),
(40875, '3.20.20.70-FF-000067', NULL, 'tRNA-dihydrouridine(47) synthase [NAD(P)(+)]', 241, NULL, NULL, 40875),
(40876, '1.10.3720.10-FF-000012', NULL, 'Histidine ABC transporter permease HisM', 224, NULL, NULL, 40876),
(40877, '3.30.70.330-FF-002000', NULL, NULL, 87, NULL, NULL, 40877),
(40878, '2.10.50.10-FF-000060', NULL, 'Tumor necrosis factor receptor superfamily member 3', 31, NULL, NULL, 40878),
(40879, '3.40.50.300-FF-000170', NULL, 'Mitochondrial Rho GTPase', 169, NULL, NULL, 40879),
(40880, '3.30.160.60-FF-005278', NULL, NULL, 63, NULL, NULL, 40880),
(40881, '3.10.20.90-FF-000028', NULL, 'Talin 2', 86, NULL, NULL, 40881);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(40882, '2.60.40.640-FF-000100', NULL, 'Uncharacterized protein', 168, NULL, NULL, 40882),
(40883, '3.40.50.300-FF-003643', NULL, 'ATP-dependent DNA helicase', 223, NULL, NULL, 40883),
(40884, '3.40.50.1000-FF-000215', NULL, 'Trehalose 6-phosphate phosphatase', 135, NULL, NULL, 40884),
(40885, '3.40.50.150-FF-000017', NULL, 'probable 18S rRNA (Guanine-N(7))-methyltransferase', 206, NULL, NULL, 40885),
(40886, '2.60.40.10-FF-001658', NULL, 'Glycoside hydrolase family 2 protein', 109, NULL, NULL, 40886),
(40887, '1.10.1410.10-FF-000011', NULL, 'Poly(A) polymerase alpha', 129, NULL, NULL, 40887),
(40888, '3.20.20.80-FF-000525', NULL, 'Malto-oligosyltrehalose synthase', 199, NULL, NULL, 40888),
(40889, '3.40.1110.10-FF-000148', NULL, 'Phospholipid-transporting ATPase', 142, NULL, NULL, 40889),
(40890, '3.30.420.40-FF-000402', NULL, 'Actin-related protein 9', 82, NULL, NULL, 40890),
(40891, '3.40.50.150-FF-001647', NULL, 'tRNA (adenine(58)-N(1))-methyltransferase TrmI', 189, NULL, NULL, 40891),
(40892, '3.40.50.10190-FF-000245', NULL, 'Nucleomorphin', 97, NULL, NULL, 40892),
(40893, '2.10.60.10-FF-000032', NULL, 'TGF-beta receptor type-2', 110, NULL, NULL, 40893),
(40894, '3.90.190.10-FF-000272', NULL, 'Tyrosine-protein phosphatase 1', 286, NULL, NULL, 40894),
(40895, '1.25.40.10-FF-003035', NULL, 'Pentatricopeptide repeat-containing protein DOT4, chloroplastic', 98, NULL, NULL, 40895),
(40896, '3.20.20.140-FF-000159', NULL, 'Putative adenosine monophosphate deaminase', 243, NULL, NULL, 40896),
(40897, '3.40.50.300-FF-001844', NULL, 'Dynein heavy chain-like protein', 148, NULL, NULL, 40897),
(40898, '1.25.40.10-FF-001427', NULL, 'Small glutamine-rich tetratricopeptide repeat-containing protein', 176, NULL, NULL, 40898),
(40899, '1.20.190.10-FF-000003', NULL, 'Cry21a', 243, NULL, NULL, 40899),
(40900, '2.130.10.10-FF-005368', NULL, 'Uncharacterized protein', 169, NULL, NULL, 40900),
(40901, '2.40.50.100-FF-000102', NULL, 'KGD2p Dihydrolipoyl transsuccinylase', 106, NULL, NULL, 40901),
(40902, '3.40.50.1820-FF-000366', NULL, 'Phenyloxazoline synthase MbtB', 244, NULL, NULL, 40902),
(40903, '1.10.8.10-FF-000367', NULL, 'Uncharacterized protein', 77, NULL, NULL, 40903),
(40904, '1.10.630.10-FF-000444', NULL, 'Uncharacterized protein', 278, NULL, NULL, 40904),
(40905, '3.40.50.410-FF-000129', NULL, 'Probable E3 ubiquitin-protein ligase EDA40', 163, NULL, NULL, 40905),
(40906, '3.60.10.10-FF-000378', NULL, 'Uncharacterized protein', 87, NULL, NULL, 40906),
(40907, '3.80.10.10-FF-000428', NULL, 'Adenylate cyclase', 115, NULL, NULL, 40907),
(40908, '2.40.50.140-FF-000917', NULL, NULL, 109, NULL, NULL, 40908),
(40909, '3.90.640.10-FF-000228', NULL, 'Uncharacterized protein', 57, NULL, NULL, 40909),
(40910, '2.30.30.1020-FF-000050', NULL, NULL, 208, NULL, NULL, 40910),
(40911, '3.40.50.200-FF-000033', NULL, 'Uncharacterized protein', 277, NULL, NULL, 40911),
(40912, '3.30.420.10-FF-000219', NULL, 'Putative retroelement', 205, NULL, NULL, 40912),
(40913, '1.10.560.10-FF-000101', NULL, 'Uncharacterized protein', 79, NULL, NULL, 40913),
(40914, '2.30.42.10-FF-000591', NULL, NULL, 106, NULL, NULL, 40914),
(40915, '2.130.10.10-FF-001445', NULL, 'Protein TRANSPARENT TESTA GLABRA, putative', 310, NULL, NULL, 40915),
(40916, '1.25.40.120-FF-000062', NULL, 'Uncharacterized protein', 215, NULL, NULL, 40916),
(40917, '2.60.40.10-FF-005368', NULL, NULL, 61, NULL, NULL, 40917),
(40918, '3.30.9.10-FF-000062', NULL, 'Os07g0155100 protein', 170, NULL, NULL, 40918),
(40919, '3.40.50.300-FF-001698', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', 359, NULL, NULL, 40919),
(40920, '1.10.10.60-FF-001288', NULL, NULL, 52, NULL, NULL, 40920),
(40921, '1.25.40.20-FF-001672', NULL, 'Guard cell S-type anion channel SLAC1', 82, NULL, NULL, 40921),
(40922, '1.20.58.390-FF-000016', NULL, 'Putative acetylcholine receptor subunit alpha', 78, NULL, NULL, 40922),
(40923, '1.10.4020.10-FF-000004', NULL, 'Zinc finger and SCAN domain containing 4', 88, NULL, NULL, 40923),
(40924, '3.40.50.1000-FF-000108', NULL, 'Phospholipid-transporting ATPase', 205, NULL, NULL, 40924);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(40925, '1.20.1310.10-FF-000012', NULL, 'Cullin 2', 115, NULL, NULL, 40925),
(40926, '3.30.420.10-FF-000635', NULL, NULL, 156, NULL, NULL, 40926),
(40927, '3.30.70.330-FF-001421', NULL, 'RNA-binding protein LARK', 139, NULL, NULL, 40927),
(40928, '1.10.437.10-FF-000028', NULL, 'Uncharacterized protein', 171, NULL, NULL, 40928),
(40929, '1.20.1310.20-FF-000015', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 188, NULL, NULL, 40929),
(40930, '3.20.70.20-FF-000050', NULL, 'Glr3745 protein', 183, NULL, NULL, 40930),
(40931, '3.30.70.1970-FF-000003', NULL, 'RNA editing 3'' terminal uridylyl transferase 1', 93, NULL, NULL, 40931),
(40932, '3.60.21.10-FF-000044', NULL, 'acid sphingomyelinase-like phosphodiesterase 3a', 262, NULL, NULL, 40932),
(40933, '3.20.20.80-FF-000396', NULL, 'Oligo-1,6-glucosidase', 370, NULL, NULL, 40933),
(40934, '1.25.40.10-FF-003344', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 89, NULL, NULL, 40934),
(40935, '3.30.420.40-FF-000060', NULL, 'Bifunctional UDP-N-acetylglucosamine 2-epimerase/N-acetylmannosamine kinase', 155, NULL, NULL, 40935),
(40936, '3.40.50.300-FF-004222', NULL, 'Os02g0288700 protein', 257, NULL, NULL, 40936),
(40937, '1.20.1070.10-FF-000437', NULL, 'Predicted protein', 277, NULL, NULL, 40937),
(40938, '3.40.605.10-FF-000124', NULL, 'Gamma-glutamyl phosphate reductase-like protein', 163, NULL, NULL, 40938),
(40939, '3.30.559.10-FF-000075', NULL, 'Spermidine hydroxycinnamoyltransferase 2', 213, NULL, NULL, 40939),
(40940, '1.10.510.10-FF-000351', NULL, 'PAS domain-containing serine/threonine-protein kinase', 182, NULL, NULL, 40940),
(40941, '3.40.50.410-FF-000096', NULL, 'Integrin beta', 249, NULL, NULL, 40941),
(40942, '3.80.10.10-FF-000754', NULL, 'CCR4-NOT transcriptional complex subunit', 110, NULL, NULL, 40942),
(40943, '3.30.160.60-FF-000130', NULL, 'Spalt-like transcription factor 4', 29, NULL, NULL, 40943),
(40944, '3.10.20.310-FF-000050', NULL, 'Predicted protein', 80, NULL, NULL, 40944),
(40945, '1.10.246.190-FF-000005', NULL, 'Autophagy protein 5', 55, NULL, NULL, 40945),
(40946, '2.120.10.10-FF-000018', NULL, 'Uncharacterized protein', 345, NULL, NULL, 40946),
(40947, '3.40.50.300-FF-001389', NULL, 'ATP-dependent DNA helicase RecQ', 206, NULL, NULL, 40947),
(40948, '2.60.120.920-FF-000064', NULL, 'AGAP009295-PA-like protein', 184, NULL, NULL, 40948),
(40949, '1.20.1070.10-FF-000089', NULL, '5-hydroxytryptamine receptor 5A', 294, NULL, NULL, 40949),
(40950, '1.10.287.70-FF-000315', NULL, 'GM16780', 149, NULL, NULL, 40950),
(40951, '4.10.240.10-FF-000190', NULL, 'Hal9p', 98, NULL, NULL, 40951),
(40952, '3.20.20.70-FF-000393', NULL, 'WGS project CABT00000000 data, contig 2.5', 227, NULL, NULL, 40952),
(40953, '3.20.20.140-FF-000069', NULL, 'Adenosine deaminase', 333, NULL, NULL, 40953),
(40954, '3.40.950.10-FF-000021', NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', 154, NULL, NULL, 40954),
(40955, '1.10.1520.10-FF-000042', NULL, 'Ribonuclease 3', 181, NULL, NULL, 40955),
(40956, '1.20.58.390-FF-000106', NULL, 'ACHA7', 80, NULL, NULL, 40956),
(40957, '3.30.160.270-FF-000006', NULL, '2-isopropylmalate synthase', 178, NULL, NULL, 40957),
(40958, '3.20.20.10-FF-000072', NULL, 'Antizyme inhibitor 1a', 24, NULL, NULL, 40958),
(40959, '3.40.50.10190-FF-000335', NULL, 'Meiotically up-regulated gene 176 protein', 104, NULL, NULL, 40959),
(40960, '3.40.630.30-FF-000424', NULL, 'Uncharacterized protein', 164, NULL, NULL, 40960),
(40961, '1.20.1560.10-FF-000199', NULL, 'ABC transporter transmembrane region', 305, NULL, NULL, 40961),
(40962, '1.10.357.140-FF-000033', NULL, 'Protoheme IX farnesyltransferase', 147, NULL, NULL, 40962),
(40963, '2.30.30.40-FF-000122', NULL, 'intersectin-1 isoform X2', 64, NULL, NULL, 40963),
(40964, '2.60.120.330-FF-000112', NULL, 'Predicted protein', 307, NULL, NULL, 40964),
(40965, '3.30.710.10-FF-000394', NULL, 'AGAP008959-PA', 81, NULL, NULL, 40965),
(40966, '3.40.50.450-FF-000001', NULL, 'ATP-dependent 6-phosphofructokinase', 163, NULL, NULL, 40966),
(40967, '2.30.30.190-FF-000026', NULL, 'CYLinDromatosis (Human disease gene) homolog', 101, NULL, NULL, 40967);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(40968, '3.80.10.10-FF-000445', NULL, 'Oligodendrocyte myelin glycoprotein b', 180, NULL, NULL, 40968),
(40969, '1.20.1270.60-FF-000315', NULL, 'Uncharacterized protein', 253, NULL, NULL, 40969),
(40970, '3.10.250.10-FF-000143', NULL, NULL, 110, NULL, NULL, 40970),
(40971, '3.60.110.10-FF-000083', NULL, NULL, 170, NULL, NULL, 40971),
(40972, '1.10.510.10-FF-003605', NULL, NULL, 200, NULL, NULL, 40972),
(40973, '3.30.1670.10-FF-000001', NULL, '3-mercaptopyruvate sulfurtransferase', 68, NULL, NULL, 40973),
(40974, '3.30.160.60-FF-003480', NULL, 'zinc finger protein isoform X4', 28, NULL, NULL, 40974),
(40975, '1.10.510.10-FF-001801', NULL, 'Tyrosine kinase receptor, putative', 151, NULL, NULL, 40975),
(40976, '3.30.980.10-FF-000019', NULL, 'tRNA synthetases class II (A)/Threonyl and Alanyl tRNA synthetase second additional domain containing protein, putative', 195, NULL, NULL, 40976),
(40977, '3.30.710.10-FF-000085', NULL, 'Kelch-like family member 14', 145, NULL, NULL, 40977),
(40978, '3.30.460.10-FF-000104', NULL, 'Ribosomal silencing factor RsfS', 108, NULL, NULL, 40978),
(40979, '3.90.1290.10-FF-000003', NULL, 'microtubule-actin cross-linking factor 1 isoform X1', 187, NULL, NULL, 40979),
(40980, '1.20.58.90-FF-000046', NULL, NULL, 84, NULL, NULL, 40980),
(40981, '1.10.10.160-FF-000038', NULL, 'DNA helicase', 102, NULL, NULL, 40981),
(40982, '3.40.50.300-FF-007095', NULL, 'ADP-ribosylation factor family protein', 189, NULL, NULL, 40982),
(40983, '3.30.70.330-FF-001730', NULL, NULL, 145, NULL, NULL, 40983),
(40984, '3.40.390.10-FF-000169', NULL, NULL, 137, NULL, NULL, 40984),
(40985, '1.10.510.10-FF-004403', NULL, NULL, 85, NULL, NULL, 40985),
(40986, '1.20.1250.20-FF-000662', NULL, 'Thymidylate kinase', 201, NULL, NULL, 40986),
(40987, '3.40.30.10-FF-000190', NULL, 'Peroxiredoxin', 171, NULL, NULL, 40987),
(40988, '3.40.1110.10-FF-000058', NULL, 'Cation-transporting ATPase', 177, NULL, NULL, 40988),
(40989, '1.10.510.10-FF-003263', NULL, NULL, 110, NULL, NULL, 40989),
(40990, '3.30.930.10-FF-000382', NULL, 'Uncharacterized protein', 461, NULL, NULL, 40990),
(40991, '2.80.10.50-FF-000127', NULL, 'Fibroblast growth factor', 155, NULL, NULL, 40991),
(40992, '2.60.40.1970-FF-000007', NULL, 'Protein AF-9 homolog', 173, NULL, NULL, 40992),
(40993, '3.30.450.20-FF-000359', NULL, 'Two-component hybrid sensor and regulator', 118, NULL, NULL, 40993),
(40994, '3.40.50.10190-FF-000026', NULL, 'DNA ligase', 88, NULL, NULL, 40994),
(40995, '3.40.1110.10-FF-000367', NULL, NULL, 152, NULL, NULL, 40995),
(40996, '1.10.10.10-FF-001880', NULL, 'Uncharacterized protein', 47, NULL, NULL, 40996),
(40997, '2.130.10.10-FF-001664', NULL, 'suppressor of mec-8 and unc-52 protein homolog 1', 111, NULL, NULL, 40997),
(40998, '3.60.10.10-FF-000255', NULL, 'Endonuclease/exonuclease/phosphatase family protein', 244, NULL, NULL, 40998),
(40999, '1.10.10.10-FF-000008', NULL, 'E2F transcription factor 1', 74, NULL, NULL, 40999),
(41000, '1.20.1560.10-FF-000289', NULL, 'ABC transporter B family member 11 isoform A', 174, NULL, NULL, 41000),
(41001, '3.50.50.60-FF-001183', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 90, NULL, NULL, 41001),
(41002, '1.10.10.440-FF-000004', NULL, 'Transcription elongation regulator 1 like', 60, NULL, NULL, 41002),
(41003, '2.60.120.970-FF-000056', NULL, 'Myoglianin', 252, NULL, NULL, 41003),
(41004, '1.10.510.10-FF-003914', NULL, NULL, 77, NULL, NULL, 41004),
(41005, '1.25.40.10-FF-002978', NULL, 'Pre-mRNA-splicing factor CLF1', 154, NULL, NULL, 41005),
(41006, '2.60.40.10-FF-001877', NULL, 'LOC100170443 protein', 92, NULL, NULL, 41006),
(41007, '1.10.300.10-FF-000009', NULL, 'Adenylosuccinate synthetase 2', 100, NULL, NULL, 41007),
(41008, '2.130.10.10-FF-001973', NULL, 'Ribosome biogenesis protein YTM1', 380, NULL, NULL, 41008),
(41009, '2.40.50.1070-FF-000001', NULL, 'tRNA/tmRNA (uracil-C(5))-methyltransferase', 145, NULL, NULL, 41009),
(41010, '3.30.2410.10-FF-000044', NULL, 'Uncharacterized protein', 58, NULL, NULL, 41010),
(41011, '3.20.200.10-FF-000014', NULL, 'Uncharacterized protein', 57, NULL, NULL, 41011);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(41012, '2.130.10.10-FF-003570', NULL, 'Uncharacterized protein', 203, NULL, NULL, 41012),
(41013, '2.30.29.30-FF-001015', NULL, 'IQ motif and Sec7 domain 3a', 123, NULL, NULL, 41013),
(41014, '4.10.60.10-FF-000100', NULL, 'Arginine/serine-rich splicing factor RSZ23 transcript III', 68, NULL, NULL, 41014),
(41015, '2.10.110.10-FF-000199', NULL, 'Uncharacterized protein', 67, NULL, NULL, 41015),
(41016, '3.30.930.10-FF-000073', NULL, 'Biotin--protein ligase', 227, NULL, NULL, 41016),
(41017, '3.40.50.410-FF-000348', NULL, 'Protein transport protein SEC23', 102, NULL, NULL, 41017),
(41018, '3.10.290.10-FF-000011', NULL, 'Pseudouridine synthase', 75, NULL, NULL, 41018),
(41019, '3.30.70.260-FF-000080', NULL, 'Ribose 5-phosphate isomerase A', 79, NULL, NULL, 41019),
(41020, '1.10.10.430-FF-000001', NULL, 'protein phosphatase 1B isoform X1', 73, NULL, NULL, 41020),
(41021, '1.25.40.10-FF-000123', NULL, '43 kDa receptor-associated protein of the synapse', 191, NULL, NULL, 41021),
(41022, '3.30.365.10-FF-000023', NULL, 'Aldehyde oxidase4', 135, NULL, NULL, 41022),
(41023, '3.30.160.60-FF-001911', NULL, 'zinc finger protein 624 isoform X1', 36, NULL, NULL, 41023),
(41024, '1.50.40.10-FF-000508', NULL, 'ADP,ATP carrier protein', 237, NULL, NULL, 41024),
(41025, '3.80.10.10-FF-000900', NULL, 'Leucine-rich repeat transmembrane protein kinase, putative, expressed', 69, NULL, NULL, 41025),
(41026, '3.20.20.140-FF-000053', NULL, 'Ribonuclease P complex subunit Pop2', 163, NULL, NULL, 41026),
(41027, '1.25.40.20-FF-000126', NULL, 'Kinase D-interacting substrate of 220 kDa', 125, NULL, NULL, 41027),
(41028, '2.40.50.140-FF-000991', NULL, NULL, 87, NULL, NULL, 41028),
(41029, '1.20.1070.10-FF-001151', NULL, 'Olfactory receptor 4A16', 293, NULL, NULL, 41029),
(41030, '1.20.120.350-FF-000004', NULL, 'Sodium channel protein', 121, NULL, NULL, 41030),
(41031, '2.30.30.770-FF-000014', NULL, NULL, 64, NULL, NULL, 41031),
(41032, '3.30.60.30-FF-000102', NULL, 'GEO10195p1', 65, NULL, NULL, 41032),
(41033, '1.25.10.10-FF-003281', NULL, 'Predicted protein', 189, NULL, NULL, 41033),
(41034, '3.40.250.10-FF-000209', NULL, 'Predicted protein', 180, NULL, NULL, 41034),
(41035, '3.30.460.10-FF-000093', NULL, 'Interleukin enhancer-binding factor 2', 152, NULL, NULL, 41035),
(41036, '2.130.10.10-FF-003463', NULL, 'Uncharacterized protein', 85, NULL, NULL, 41036),
(41037, '3.20.20.100-FF-000092', NULL, 'Oxidoreductase', 300, NULL, NULL, 41037),
(41038, '2.170.300.10-FF-000081', NULL, 'Uncharacterized protein', 118, NULL, NULL, 41038),
(41039, '3.30.930.10-FF-000157', NULL, 'Seryl-tRNA synthetase, putative', 291, NULL, NULL, 41039),
(41040, '2.60.40.10-FF-002501', NULL, 'Colony stimulating factor 1 receptor, a', 82, NULL, NULL, 41040),
(41041, '4.10.1000.10-FF-000034', NULL, 'pre-mRNA-splicing factor RBM22', 57, NULL, NULL, 41041),
(41042, '3.30.230.10-FF-000391', NULL, 'Uncharacterized protein', 92, NULL, NULL, 41042),
(41043, '3.40.50.150-FF-001428', NULL, NULL, 152, NULL, NULL, 41043),
(41044, '1.20.58.1610-FF-000027', NULL, NULL, 101, NULL, NULL, 41044),
(41045, '3.40.50.1820-FF-001080', NULL, 'AaceriAFR601Cp', 236, NULL, NULL, 41045),
(41046, '3.60.10.10-FF-000272', NULL, 'Uncharacterized protein', 235, NULL, NULL, 41046),
(41047, '1.20.120.610-FF-000026', NULL, 'ATPase, F0/V0 complex, subunit C protein', 77, NULL, NULL, 41047),
(41048, '1.20.120.910-FF-000009', NULL, 'Uncharacterized protein HI_1497', 75, NULL, NULL, 41048),
(41049, '1.25.40.10-FF-001652', NULL, 'Pentatricopeptide repeat-containing protein', 124, NULL, NULL, 41049),
(41050, '1.10.8.60-FF-000270', NULL, 'AAA family ATPase putative', 64, NULL, NULL, 41050),
(41051, '3.80.10.10-FF-000776', NULL, 'Transforming growth factor beta activator LRRC33', 186, NULL, NULL, 41051),
(41052, '3.40.50.1820-FF-000618', NULL, 'Lipase', 269, NULL, NULL, 41052),
(41053, '1.20.1420.10-FF-000015', NULL, 'Talin 2b', 57, NULL, NULL, 41053),
(41054, '2.70.50.80-FF-000004', NULL, 'TEA domain transcription factor 1', 134, NULL, NULL, 41054),
(41055, '1.10.730.20-FF-000011', NULL, 'Isoleucyl-tRNA synthetase, mitochondrial', 276, NULL, NULL, 41055);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(41056, '1.25.40.20-FF-001655', NULL, 'Uncharacterized protein', 87, NULL, NULL, 41056),
(41057, '1.10.510.10-FF-003931', NULL, NULL, 70, NULL, NULL, 41057),
(41058, '1.10.10.10-FF-001554', NULL, 'DDE-recombinase A', 76, NULL, NULL, 41058),
(41059, '3.40.30.10-FF-000442', NULL, 'Dolichyl-diphosphooligosaccharide--protein glycosyltransferase subunit 3', 171, NULL, NULL, 41059),
(41060, '3.90.1720.10-FF-000003', NULL, 'FAM84B isoform 1', 111, NULL, NULL, 41060),
(41061, '1.10.510.10-FF-001790', NULL, 'Protein CBG20999', 308, NULL, NULL, 41061),
(41062, '1.10.1580.10-FF-000034', NULL, 'Nucleolar GTP-binding protein 2', 96, NULL, NULL, 41062),
(41063, '2.30.42.10-FF-000574', NULL, NULL, 118, NULL, NULL, 41063),
(41064, '3.20.20.190-FF-000062', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', 183, NULL, NULL, 41064),
(41065, '1.20.120.340-FF-000001', NULL, 'Flagellar secretion chaperone FliS', 128, NULL, NULL, 41065),
(41066, '2.60.40.10-FF-003603', NULL, NULL, 120, NULL, NULL, 41066),
(41067, '3.40.50.300-FF-003278', NULL, 'ATP-dependent DNA helicase', 210, NULL, NULL, 41067),
(41068, '2.30.110.10-FF-000071', NULL, 'Pyridoxamine 5''-phosphate oxidase-related FMN-binding', 132, NULL, NULL, 41068),
(41069, '1.10.150.20-FF-000186', NULL, 'YALI0B22242p', 66, NULL, NULL, 41069),
(41070, '1.20.1560.10-FF-000761', NULL, 'Multidrug resistance-associated protein, putative', 324, NULL, NULL, 41070),
(41071, '3.30.420.110-FF-000030', NULL, 'DNA mismatch repair protein MutS', 139, NULL, NULL, 41071),
(41072, '1.20.1250.20-FF-002354', NULL, 'Uncharacterized protein', 136, NULL, NULL, 41072),
(41073, '1.20.5.170-FF-000081', NULL, 'Nestin', 91, NULL, NULL, 41073),
(41074, '3.90.1720.30-FF-000009', NULL, NULL, 161, NULL, NULL, 41074),
(41075, '3.40.50.11540-FF-000004', NULL, 'Ion-translocating oxidoreductase complex subunit C', 150, NULL, NULL, 41075),
(41076, '1.20.5.110-FF-000214', NULL, 'Yeast SEC homolog', 86, NULL, NULL, 41076),
(41077, '1.10.10.160-FF-000044', NULL, 'AaceriAFR093Wp', 75, NULL, NULL, 41077),
(41078, '1.25.40.120-FF-000045', NULL, 'YALI0E13662p', 347, NULL, NULL, 41078),
(41079, '3.30.160.60-FF-003564', NULL, 'Zinc finger protein 440', 33, NULL, NULL, 41079),
(41080, '3.30.160.60-FF-006312', NULL, NULL, 67, NULL, NULL, 41080),
(41081, '1.20.58.60-FF-000627', NULL, 'Spectrin repeat-containing, nuclear envelope 1b', 298, NULL, NULL, 41081),
(41082, '3.40.570.10-FF-000048', NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase 3', 291, NULL, NULL, 41082),
(41083, '1.10.8.60-FF-000466', NULL, 'Uncharacterized protein', 89, NULL, NULL, 41083),
(41084, '2.60.120.200-FF-000197', NULL, 'Blast:Protein eyes shut', 184, NULL, NULL, 41084),
(41085, '1.20.1310.20-FF-000032', NULL, 'Erythrocyte membrane protein 1', 183, NULL, NULL, 41085),
(41086, '3.40.50.11660-FF-000057', NULL, NULL, 52, NULL, NULL, 41086),
(41087, '3.30.1330.30-FF-000105', NULL, 'Uncharacterized protein P883.19', 95, NULL, NULL, 41087),
(41088, '1.20.120.350-FF-000111', NULL, 'Cation channel sperm-associated protein 3', 124, NULL, NULL, 41088),
(41089, '2.30.30.140-FF-000152', NULL, 'GM14014p', 71, NULL, NULL, 41089),
(41090, '3.40.50.11530-FF-000001', NULL, 'interleukin-17 receptor C isoform X1', 159, NULL, NULL, 41090),
(41091, '1.10.3730.20-FF-000061', NULL, 'Uncharacterized protein', 104, NULL, NULL, 41091),
(41092, '3.40.50.300-FF-007549', NULL, 'Uncharacterized protein', 298, NULL, NULL, 41092),
(41093, '2.60.40.10-FF-004210', NULL, NULL, 74, NULL, NULL, 41093),
(41094, '2.30.30.490-FF-000037', NULL, 'Origin recognition complex subunit 1', 176, NULL, NULL, 41094),
(41095, '2.40.128.20-FF-000005', NULL, 'Retinol binding protein 4, like', 175, NULL, NULL, 41095),
(41096, '3.20.20.80-FF-000087', NULL, 'Oligo-1,6-glucosidase IMA1', 327, NULL, NULL, 41096),
(41097, '1.10.246.190-FF-000011', NULL, NULL, 53, NULL, NULL, 41097),
(41098, '1.25.40.10-FF-004890', NULL, 'Uncharacterized protein', 97, NULL, NULL, 41098),
(41099, '3.40.50.1010-FF-000022', NULL, 'DNA repair protein complementing XP-G cells homolog', 219, NULL, NULL, 41099);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(41100, '3.30.160.60-FF-004171', NULL, 'LD39664p', 65, NULL, NULL, 41100),
(41101, '3.90.190.10-FF-000468', NULL, 'Uncharacterized protein', 186, NULL, NULL, 41101),
(41102, '3.30.420.40-FF-000779', NULL, 'YALI0B10934p', 183, NULL, NULL, 41102),
(41103, '3.30.1360.40-FF-000043', NULL, 'DNA topoisomerase IV, ATP/GTP binding site', 104, NULL, NULL, 41103),
(41104, '1.25.40.10-FF-001904', NULL, 'Exomer complex subunit', 212, NULL, NULL, 41104),
(41105, '3.10.350.10-FF-000089', NULL, 'Predicted protein', 62, NULL, NULL, 41105),
(41106, '3.40.50.2300-FF-000639', NULL, 'GLutamate Receptor family (AMPA)', 202, NULL, NULL, 41106),
(41107, '3.30.420.140-FF-000039', NULL, 'SH2 domain containing protein', 158, NULL, NULL, 41107),
(41108, '3.40.50.300-FF-007460', NULL, 'Uncharacterized protein', 243, NULL, NULL, 41108),
(41109, '3.30.1150.10-FF-000001', NULL, 'Cell envelope integrity protein TolA', 89, NULL, NULL, 41109),
(41110, '1.10.472.80-FF-000237', NULL, NULL, 139, NULL, NULL, 41110),
(41111, '4.10.240.10-FF-000223', NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', 85, NULL, NULL, 41111),
(41112, '3.60.40.10-FF-000189', NULL, 'Probable protein phosphatase 2C 61', 289, NULL, NULL, 41112),
(41113, '3.30.572.10-FF-000010', NULL, 'Thymidylate synthase 1', 278, NULL, NULL, 41113),
(41114, '3.30.930.10-FF-000409', NULL, 'Predicted protein', 69, NULL, NULL, 41114),
(41115, '3.40.250.10-FF-000013', NULL, 'Dual specificity phosphatase 10 (Predicted)', 141, NULL, NULL, 41115),
(41116, '2.60.40.10-FF-001349', NULL, 'Jitterbug, isoform F', 84, NULL, NULL, 41116),
(41117, '3.40.80.10-FF-000046', NULL, 'Uncharacterized protein', 91, NULL, NULL, 41117),
(41118, '2.60.320.10-FF-000001', NULL, 'Transcription termination/antitermination protein NusG', 82, NULL, NULL, 41118),
(41119, '1.10.533.10-FF-000050', NULL, 'E3 ubiquitin-protein ligase XIAP', 26, NULL, NULL, 41119),
(41120, '2.70.130.10-FF-000012', NULL, 'Insulin-like growth factor 2 receptor', 162, NULL, NULL, 41120),
(41121, '3.40.50.2300-FF-000971', NULL, NULL, 152, NULL, NULL, 41121),
(41122, '1.20.58.2220-FF-000002', NULL, 'Dishevelled associated activator of morphogenesis 1', 407, NULL, NULL, 41122),
(41123, '1.20.1250.20-FF-000645', NULL, 'Autophagy-related protein', 208, NULL, NULL, 41123),
(41124, '1.20.272.40-FF-000017', NULL, 'AGAP012862-PA', 77, NULL, NULL, 41124),
(41125, '3.40.50.10330-FF-000074', NULL, 'NAD kinase', 87, NULL, NULL, 41125),
(41126, '1.20.1070.10-FF-000785', NULL, 'Uncharacterized protein', 122, NULL, NULL, 41126),
(41127, '3.90.550.10-FF-000131', NULL, 'Glycosyl transferase', 252, NULL, NULL, 41127),
(41128, '3.40.1190.20-FF-000055', NULL, 'Hydroxyethylthiazole kinase', 310, NULL, NULL, 41128),
(41129, '1.10.630.10-FF-000219', NULL, 'Putative inactive cytochrome P450 2G1', 127, NULL, NULL, 41129),
(41130, '3.90.1200.10-FF-000054', NULL, 'Spore coat, CotS family protein', 237, NULL, NULL, 41130),
(41131, '3.40.20.10-FF-000161', NULL, 'Protovillin', 133, NULL, NULL, 41131),
(41132, '3.40.50.800-FF-000117', NULL, 'Ornithine carbamoyltransferase chloroplastic', 72, NULL, NULL, 41132),
(41133, '1.20.58.60-FF-000734', NULL, 'Protein CBG15811', 103, NULL, NULL, 41133),
(41134, '1.25.40.20-FF-001907', NULL, 'Uncharacterized protein', 78, NULL, NULL, 41134),
(41135, '3.30.505.10-FF-000012', NULL, 'Tyrosine-protein phosphatase non-receptor type', 113, NULL, NULL, 41135),
(41136, '2.10.250.10-FF-000001', NULL, 'Calnexin homolog', 146, NULL, NULL, 41136),
(41137, '3.40.1190.10-FF-000052', NULL, NULL, 102, NULL, NULL, 41137),
(41138, '2.60.40.10-FF-001097', NULL, 'Immunoglobulin-like and fibronectin type III domain-containing protein 1', 94, NULL, NULL, 41138),
(41139, '1.25.40.770-FF-000026', NULL, 'Predicted protein', 70, NULL, NULL, 41139),
(41140, '2.40.30.10-FF-000023', NULL, 'tRNA-specific 2-thiouridylase MnmA', 88, NULL, NULL, 41140),
(41141, '1.25.10.10-FF-001279', NULL, 'RING-type E3 ubiquitin transferase', 168, NULL, NULL, 41141),
(41142, '3.30.160.60-FF-002260', NULL, NULL, 28, NULL, NULL, 41142),
(41143, '3.40.710.10-FF-000037', NULL, 'Penicillin-binding protein, 1A family', 93, NULL, NULL, 41143);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(41144, '2.130.10.10-FF-003244', NULL, 'Uncharacterized protein', 223, NULL, NULL, 41144),
(41145, '3.40.50.620-FF-000187', NULL, 'Probable FAD synthetase', 243, NULL, NULL, 41145),
(41146, '2.40.30.20-FF-000026', NULL, 'ATP synthase subunit alpha', 74, NULL, NULL, 41146),
(41147, '3.40.50.12780-FF-000168', NULL, 'Benzoate-coenzyme A ligase, putative', 427, NULL, NULL, 41147),
(41148, '1.20.1270.280-FF-000017', NULL, 'Axonemal dynein heavy chain', 139, NULL, NULL, 41148),
(41149, '1.10.10.60-FF-001198', NULL, NULL, 85, NULL, NULL, 41149),
(41150, '3.30.230.10-FF-000284', NULL, 'Elongation factor G, mitochondrial', 129, NULL, NULL, 41150),
(41151, '1.20.58.1120-FF-000009', NULL, 'Dynein heavy chain, putative', 155, NULL, NULL, 41151),
(41152, '3.80.10.10-FF-001142', NULL, 'Leucine-rich repeats and IQ motif containing 1', 129, NULL, NULL, 41152),
(41153, '3.40.630.30-FF-000205', NULL, 'Acetyltransferase', 171, NULL, NULL, 41153),
(41154, '1.10.472.80-FF-000041', NULL, 'TBC domain containing protein', 136, NULL, NULL, 41154),
(41155, '3.40.50.1820-FF-000927', NULL, 'Predicted protein', 246, NULL, NULL, 41155),
(41156, '1.10.630.10-FF-000528', NULL, 'Protein DesVIII', 383, NULL, NULL, 41156),
(41157, '1.10.8.60-FF-000051', NULL, 'CbxX/CfqX family protein', 90, NULL, NULL, 41157),
(41158, '3.30.160.60-FF-003709', NULL, NULL, 29, NULL, NULL, 41158),
(41159, '1.10.472.10-FF-000599', NULL, 'Uncharacterized protein', 20, NULL, NULL, 41159),
(41160, '2.40.50.140-FF-000884', NULL, NULL, 84, NULL, NULL, 41160),
(41161, '1.20.1730.10-FF-000027', NULL, 'Uncharacterized protein', 520, NULL, NULL, 41161),
(41162, '3.40.309.10-FF-000094', NULL, 'Aldehyde dehydrogenase, putative', 19, NULL, NULL, 41162),
(41163, '2.60.40.10-FF-001462', NULL, 'Receptor-type tyrosine-protein phosphatase C', 103, NULL, NULL, 41163),
(41164, '1.10.600.10-FF-000139', NULL, 'Predicted protein', 73, NULL, NULL, 41164),
(41165, '1.25.40.20-FF-000019', NULL, 'Glutaminase liver isoform, mitochondrial', 97, NULL, NULL, 41165),
(41166, '1.25.40.10-FF-004777', NULL, 'Uncharacterized protein', 296, NULL, NULL, 41166),
(41167, '2.40.240.10-FF-000044', NULL, '50S ribosomal protein L25', 88, NULL, NULL, 41167),
(41168, '2.130.10.10-FF-003772', NULL, 'Uncharacterized protein', 317, NULL, NULL, 41168),
(41169, '1.25.40.10-FF-005143', NULL, 'Uncharacterized protein', 281, NULL, NULL, 41169),
(41170, '3.90.1580.10-FF-000014', NULL, 'Gliding motility protein GldJ', 91, NULL, NULL, 41170),
(41171, '3.40.1350.60-FF-000006', NULL, 'Sugar fermentation stimulation protein homolog', 143, NULL, NULL, 41171),
(41172, '1.25.40.420-FF-000028', NULL, 'kelch-like protein 8 isoform X3', 73, NULL, NULL, 41172),
(41173, '3.40.50.360-FF-000165', NULL, 'Uncharacterized protein', 117, NULL, NULL, 41173),
(41174, '3.30.1370.100-FF-000035', NULL, 'Mismatch repair protein', 113, NULL, NULL, 41174),
(41175, '3.30.160.880-FF-000004', NULL, 'Cell division protein ZapA', 47, NULL, NULL, 41175),
(41176, '1.20.58.1100-FF-000003', NULL, 'Phorbol ester/diacylglycerol-binding protein unc-13', 147, NULL, NULL, 41176),
(41177, '1.25.40.10-FF-000016', NULL, 'probable serine/threonine-protein kinase At4g35230', 110, NULL, NULL, 41177),
(41178, '3.90.1750.10-FF-000027', NULL, 'HECT and RLD domain containing E3 ubiquitin protein ligase 5', 149, NULL, NULL, 41178),
(41179, '3.30.420.40-FF-000998', NULL, 'Uncharacterized protein', 76, NULL, NULL, 41179),
(41180, '1.25.40.10-FF-003361', NULL, 'Pre-mRNA-splicing factor CLF1', 70, NULL, NULL, 41180),
(41181, '4.10.410.10-FF-000017', NULL, 'papilin isoform X2', 63, NULL, NULL, 41181),
(41182, '1.10.10.440-FF-000021', NULL, 'pre-mRNA-processing protein 40C isoform X1', 78, NULL, NULL, 41182),
(41183, '2.130.10.10-FF-001529', NULL, 'WD repeat-containing protein SAZD, putative', 165, NULL, NULL, 41183),
(41184, '1.10.287.70-FF-000208', NULL, 'Blast:Probable glutamate receptor', 130, NULL, NULL, 41184),
(41185, '3.60.20.10-FF-000188', NULL, NULL, 144, NULL, NULL, 41185),
(41186, '3.40.1160.10-FF-000078', NULL, 'Aspartate/glutamate/uridylate kinase', 266, NULL, NULL, 41186);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(41187, '3.40.50.1820-FF-000837', NULL, 'Carboxypeptidase', 178, NULL, NULL, 41187),
(41188, '1.10.8.970-FF-000002', NULL, 'Genome polyprotein', 74, NULL, NULL, 41188),
(41189, '3.30.1360.120-FF-000011', NULL, 'Aminomethyltransferase', 146, NULL, NULL, 41189),
(41190, '3.50.50.60-FF-001048', NULL, 'FAD dependent oxidoreductase domain containing 1', 147, NULL, NULL, 41190),
(41191, '3.30.450.20-FF-000376', NULL, 'Regulatory components of sensory transductionsystem', 126, NULL, NULL, 41191),
(41192, '3.80.10.10-FF-004267', NULL, 'Uncharacterized protein', 58, NULL, NULL, 41192),
(41193, '2.60.120.620-FF-000081', NULL, 'Uncharacterized protein', 172, NULL, NULL, 41193),
(41194, '2.40.50.140-FF-001070', NULL, NULL, 92, NULL, NULL, 41194),
(41195, '1.10.510.10-FF-001677', NULL, 'Serine/threonine protein kinase', 217, NULL, NULL, 41195),
(41196, '1.10.640.10-FF-000029', NULL, 'Protein CBG06977', 588, NULL, NULL, 41196),
(41197, '1.10.10.140-FF-000015', NULL, 'Cytochrome c oxidase subunit VIb polypeptide 1 (ubiquitous)', 51, NULL, NULL, 41197),
(41198, '3.80.10.10-FF-003160', NULL, 'Protein CBG00082', 419, NULL, NULL, 41198),
(41199, '1.10.287.70-FF-000517', NULL, 'Phosphomevalonate kinase', 141, NULL, NULL, 41199),
(41200, '2.60.40.10-FF-002878', NULL, 'GD14480', 102, NULL, NULL, 41200),
(41201, '1.20.1280.50-FF-000251', NULL, 'Predicted protein', 83, NULL, NULL, 41201),
(41202, '3.30.40.10-FF-000786', NULL, 'Putative E3 ubiquitin-protein ligase RHA4A isoform A', 79, NULL, NULL, 41202),
(41203, '2.60.40.60-FF-000015', NULL, 'FAT atypical cadherin 1', 105, NULL, NULL, 41203),
(41204, '2.60.40.10-FF-005149', NULL, NULL, 95, NULL, NULL, 41204),
(41205, '2.60.120.290-FF-000167', NULL, 'Uncharacterized protein', 120, NULL, NULL, 41205),
(41206, '3.40.50.300-FF-002114', NULL, 'ATP-dependent RNA helicase DEAH12 chloroplastic', 193, NULL, NULL, 41206),
(41207, '2.60.40.10-FF-003805', NULL, NULL, 95, NULL, NULL, 41207),
(41208, '1.20.120.1080-FF-000078', NULL, 'Pre-mRNA splicing factor ATP-dependent RNA helicase, putative', 143, NULL, NULL, 41208),
(41209, '2.40.37.10-FF-000067', NULL, NULL, 33, NULL, NULL, 41209),
(41210, '3.40.50.720-FF-002577', NULL, 'Uncharacterized protein', 29, NULL, NULL, 41210),
(41211, '1.20.1740.10-FF-000163', NULL, 'Amino acid transporter (Eurofung)', 413, NULL, NULL, 41211),
(41212, '2.130.10.30-FF-000035', NULL, 'Putative regulator of chromosome condensation', 371, NULL, NULL, 41212),
(41213, '1.20.140.10-FF-000073', NULL, 'Putative acyl-CoA dehydrogenase, mitochondrial', 114, NULL, NULL, 41213),
(41214, '3.40.720.10-FF-000173', NULL, 'Predicted protein', 71, NULL, NULL, 41214),
(41215, '3.10.100.10-FF-000121', NULL, 'Mannose receptor, C type 1b', 134, NULL, NULL, 41215),
(41216, '3.40.50.2000-FF-000869', NULL, 'UDP glucuronosyltransferase 2 family, polypeptide A1, complex locus', 195, NULL, NULL, 41216),
(41217, '3.40.50.300-FF-000315', NULL, 'Adenylate kinase 1', 192, NULL, NULL, 41217),
(41218, '1.20.5.110-FF-000181', NULL, 'Hypothetical_protein_-_conserved', 100, NULL, NULL, 41218),
(41219, '2.60.40.1180-FF-000113', NULL, 'Glucosylceramidase', 68, NULL, NULL, 41219),
(41220, '1.20.58.1220-FF-000017', NULL, 'Exocyst complex component exo84', 102, NULL, NULL, 41220),
(41221, '2.130.10.10-FF-005481', NULL, 'WD domain containing protein', 139, NULL, NULL, 41221),
(41222, '2.30.30.370-FF-000001', NULL, 'Possible 2-hydroxyhepta-2,4-diene-1,7-dioate isomerase', 31, NULL, NULL, 41222),
(41223, '3.20.20.100-FF-000198', NULL, 'Uncharacterized protein', 61, NULL, NULL, 41223),
(41224, '2.30.30.380-FF-000004', NULL, 'SEC24 homolog B, COPII coat complex component', 66, NULL, NULL, 41224),
(41225, '1.25.40.10-FF-004996', NULL, 'Uncharacterized protein', 130, NULL, NULL, 41225),
(41226, '2.60.40.10-FF-005514', NULL, NULL, 76, NULL, NULL, 41226),
(41227, '3.40.50.720-FF-000885', NULL, 'Phosphoglycerate dehydrogenase', 185, NULL, NULL, 41227),
(41228, '4.10.900.10-FF-000015', NULL, 'Cadherin 24, type 2b', 93, NULL, NULL, 41228),
(41229, '2.60.40.10-FF-004896', NULL, NULL, 87, NULL, NULL, 41229);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(41230, '3.30.160.60-FF-000152', NULL, 'DNA-binding protein creA', 34, NULL, NULL, 41230),
(41231, '6.10.140.2150-FF-000001', NULL, 'Sphingosine-1-phosphate lyase 1', 46, NULL, NULL, 41231),
(41232, '1.10.287.110-FF-000035', NULL, 'DnaJ homolog subfamily C member 9', 105, NULL, NULL, 41232),
(41233, '2.60.200.40-FF-000052', NULL, 'Diacylglycerol kinase', 120, NULL, NULL, 41233),
(41234, '1.25.40.10-FF-003670', NULL, 'Pentatricopeptide repeat protein PPR986-12', 100, NULL, NULL, 41234),
(41235, '3.40.1110.10-FF-000474', NULL, NULL, 172, NULL, NULL, 41235),
(41236, '3.30.160.60-FF-005817', NULL, NULL, 85, NULL, NULL, 41236),
(41237, '1.10.3380.10-FF-000036', NULL, 'Uncharacterized protein', 136, NULL, NULL, 41237),
(41238, '1.20.120.730-FF-000011', NULL, 'Sfb3p', 137, NULL, NULL, 41238),
(41239, '1.10.287.1150-FF-000005', NULL, 'probable 2-oxoglutarate dehydrogenase E1 component DHKTD1, mitochondrial', 78, NULL, NULL, 41239),
(41240, '1.10.1450.10-FF-000120', NULL, 'Uncharacterized protein (Fragment)', 120, NULL, NULL, 41240),
(41241, '3.30.430.20-FF-000049', NULL, 'Cysteine-rich receptor-like protein kinase 36', 104, NULL, NULL, 41241),
(41242, '1.20.960.50-FF-000001', NULL, 'Cleavage stimulation factor subunit 1', 60, NULL, NULL, 41242),
(41243, '1.25.40.10-FF-003142', NULL, 'Uncharacterized protein', 125, NULL, NULL, 41243),
(41244, '1.10.260.40-FF-000059', NULL, 'Transcriptional regulator', 101, NULL, NULL, 41244),
(41245, '3.40.50.300-FF-005296', NULL, 'ABC transporter E family member 3', 174, NULL, NULL, 41245),
(41246, '1.10.510.10-FF-002043', NULL, 'Uncharacterized protein', 163, NULL, NULL, 41246),
(41247, '1.10.630.10-FF-000309', NULL, 'Uncharacterized protein', 301, NULL, NULL, 41247),
(41248, '1.10.555.10-FF-000140', NULL, 'GTPase-activating protein rrc-1', 205, NULL, NULL, 41248),
(41249, '1.25.40.10-FF-001343', NULL, 'Pentatricopeptide (PPR) repeat-containing protein', 70, NULL, NULL, 41249),
(41250, '3.40.910.10-FF-000002', NULL, 'Deoxyhypusine synthase', 342, NULL, NULL, 41250),
(41251, '3.40.50.200-FF-000055', NULL, 'Tk-subtilisin', 283, NULL, NULL, 41251),
(41252, '1.25.40.20-FF-001346', NULL, 'Uncharacterized protein', 110, NULL, NULL, 41252),
(41253, '1.10.510.10-FF-003369', NULL, NULL, 203, NULL, NULL, 41253),
(41254, '3.40.50.2300-FF-000987', NULL, NULL, 82, NULL, NULL, 41254),
(41255, '1.10.260.100-FF-000024', NULL, 'Putative TPR repeat family protein', 72, NULL, NULL, 41255),
(41256, '3.30.70.1820-FF-000008', NULL, NULL, 70, NULL, NULL, 41256),
(41257, '3.40.50.300-FF-003497', NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase PRP16', 175, NULL, NULL, 41257),
(41258, '1.20.1110.10-FF-000025', NULL, 'Sodium/potassium-transporting ATPase subunit alpha', 408, NULL, NULL, 41258),
(41259, '3.30.1520.10-FF-000159', NULL, 'Predicted protein', 137, NULL, NULL, 41259),
(41260, '1.25.40.10-FF-001871', NULL, 'Protein_of_uncharacterized_function_(DUF3808)/Tet ratricopeptide_repeat', 195, NULL, NULL, 41260),
(41261, '2.60.120.590-FF-000066', NULL, 'Predicted protein', 159, NULL, NULL, 41261),
(41262, '3.40.50.620-FF-000838', NULL, 'Uncharacterized protein', 107, NULL, NULL, 41262),
(41263, '2.60.120.920-FF-000210', NULL, 'Uncharacterized protein', 169, NULL, NULL, 41263),
(41264, '2.130.10.10-FF-003098', NULL, 'WD domain, G-beta repeat, putative', 313, NULL, NULL, 41264),
(41265, '3.20.20.80-FF-000851', NULL, 'Chitinase, putative', 120, NULL, NULL, 41265),
(41266, '2.30.29.30-FF-000717', NULL, 'Ran-binding protein 3', 127, NULL, NULL, 41266),
(41267, '1.20.58.1210-FF-000014', NULL, 'Exocyst complex component exo84', 120, NULL, NULL, 41267),
(41268, '2.60.120.330-FF-000128', NULL, 'Leucoanthocyanidin dioxygenase', 150, NULL, NULL, 41268),
(41269, '3.60.40.10-FF-000190', NULL, 'Protein serine/threonine phosphatase', 268, NULL, NULL, 41269),
(41270, '2.60.40.420-FF-000181', NULL, 'Copper-containing nitrite reductase', 113, NULL, NULL, 41270),
(41271, '3.30.870.10-FF-000101', NULL, 'Phosphatidylcholine-hydrolyzing phospholipase D (PLD) protein', 174, NULL, NULL, 41271),
(41272, '3.30.70.260-FF-000079', NULL, 'UPF0250 protein NCTC10783_06313', 87, NULL, NULL, 41272);
INSERT INTO "PUBLIC"."MODEL" VALUES
(41273, '1.20.1250.20-FF-000864', NULL, 'solute carrier family 15 member 2-like isoform X1', 140, NULL, NULL, 41273),
(41274, '4.10.1240.50-FF-000001', NULL, 'Metastasis-associated 1 family, member 3', 120, NULL, NULL, 41274),
(41275, '1.25.10.10-FF-001734', NULL, 'Uncharacterized protein', 188, NULL, NULL, 41275),
(41276, '3.40.30.10-FF-000420', NULL, 'Protein disulfide-isomerase, putative', 105, NULL, NULL, 41276),
(41277, '3.40.850.10-FF-000542', NULL, 'Kinesin family member 1C', 252, NULL, NULL, 41277),
(41278, '3.90.550.10-FF-000440', NULL, 'Gll3051 protein', 242, NULL, NULL, 41278),
(41279, '1.10.10.60-FF-001209', NULL, NULL, 82, NULL, NULL, 41279),
(41280, '1.25.40.20-FF-001874', NULL, 'Intracelllar PhosphoLipase A family', 128, NULL, NULL, 41280),
(41281, '3.10.105.10-FF-000110', NULL, 'ABC-type transport system periplasmic substrate-binding protein (Probable substrate dipeptide/oligopeptide)', 68, NULL, NULL, 41281),
(41282, '1.10.510.10-FF-000244', NULL, 'Dual serine/threonine and tyrosine protein kinase', 279, NULL, NULL, 41282),
(41283, '2.30.29.30-FF-000627', NULL, 'Bud site selection protein 4', 125, NULL, NULL, 41283),
(41284, '1.20.1270.10-FF-000109', NULL, 'Uncharacterized protein', 38, NULL, NULL, 41284),
(41285, '1.20.58.80-FF-000021', NULL, 'MIT domain-containing protein 1', 89, NULL, NULL, 41285),
(41286, '1.25.40.180-FF-000164', NULL, NULL, 232, NULL, NULL, 41286),
(41287, '1.20.870.10-FF-000010', NULL, 'ras guanyl-releasing protein 3 isoform X2', 134, NULL, NULL, 41287),
(41288, '2.30.30.140-FF-000062', NULL, 'trinucleotide repeat-containing gene 18 protein-like', 64, NULL, NULL, 41288),
(41289, '2.40.50.140-FF-001047', NULL, NULL, 118, NULL, NULL, 41289),
(41290, '2.40.30.30-FF-000029', NULL, 'Riboflavin kinase', 147, NULL, NULL, 41290),
(41291, '2.40.50.90-FF-000149', NULL, 'Uncharacterized protein', 122, NULL, NULL, 41291),
(41292, '2.20.100.10-FF-000089', NULL, 'Complement component C9', 52, NULL, NULL, 41292),
(41293, '1.20.58.90-FF-000024', NULL, 'IcmR', 73, NULL, NULL, 41293),
(41294, '1.20.5.110-FF-000068', NULL, 'Syntaxin 1A', 109, NULL, NULL, 41294),
(41295, '2.102.10.10-FF-000070', NULL, 'Protochlorophyllide-dependent translocon component 52 chloroplastic', 69, NULL, NULL, 41295),
(41296, '1.10.418.10-FF-000001', NULL, 'Actinin alpha 1', 117, NULL, NULL, 41296),
(41297, '1.10.10.10-FF-001189', NULL, 'Fork head domain protein', 75, NULL, NULL, 41297),
(41298, '3.40.50.300-FF-001951', NULL, 'ATP-dependent RNA helicase DBP5', 200, NULL, NULL, 41298),
(41299, '3.30.70.660-FF-000076', NULL, 'tRNA pseudouridine synthase', 108, NULL, NULL, 41299),
(41300, '3.40.50.300-FF-001709', NULL, 'RNA helicase', 121, NULL, NULL, 41300),
(41301, '3.40.50.300-FF-004115', NULL, 'DNA helicase', 171, NULL, NULL, 41301),
(41302, '1.10.8.60-FF-000360', NULL, 'ATPase WRNIP1', 77, NULL, NULL, 41302),
(41303, '1.10.418.20-FF-000004', NULL, 'sentrin-specific protease 7 isoform X1', 50, NULL, NULL, 41303),
(41304, '1.20.1280.50-FF-000032', NULL, 'F-box/WD repeat-containing protein 5 isoform X1', 41, NULL, NULL, 41304),
(41305, '3.40.50.620-FF-000496', NULL, 'Valyl tRNA Synthetase, putative', 228, NULL, NULL, 41305),
(41306, '3.30.200.20-FF-000768', NULL, 'Dual specificity protein kinase lkH1, putative', 92, NULL, NULL, 41306),
(41307, '3.40.50.1460-FF-000134', NULL, 'Uncharacterized protein', 278, NULL, NULL, 41307),
(41308, '3.40.1030.10-FF-000001', NULL, 'Thymidine phosphorylase', 256, NULL, NULL, 41308),
(41309, '2.10.25.10-FF-000237', NULL, 'Signal peptide, CUB domain and EGF like domain containing 2', 48, NULL, NULL, 41309),
(41310, '3.50.50.60-FF-000795', NULL, 'Kynurenine 3-monooxygenase', 274, NULL, NULL, 41310),
(41311, '3.40.50.11840-FF-000010', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 2', 69, NULL, NULL, 41311),
(41312, '3.40.50.10420-FF-000022', NULL, '5-formyltetrahydrofolate cyclo-ligase family, putative', 148, NULL, NULL, 41312),
(41313, '2.130.10.10-FF-005823', NULL, 'Uncharacterized protein', 61, NULL, NULL, 41313),
(41314, '1.20.900.10-FF-000019', NULL, 'Pleckstrin homology domain-containing family G member 1', 215, NULL, NULL, 41314);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(41315, '1.20.1250.20-FF-001050', NULL, 'Related to nitrate transporter', 209, NULL, NULL, 41315),
(41316, '2.60.120.200-FF-000449', NULL, 'Predicted protein', 193, NULL, NULL, 41316),
(41317, '1.10.418.30-FF-000007', NULL, 'Uncharacterized protein', 118, NULL, NULL, 41317),
(41318, '3.90.180.10-FF-000187', NULL, 'Uncharacterized protein', 86, NULL, NULL, 41318),
(41319, '2.60.120.290-FF-000190', NULL, 'AGAP005526-PA', 112, NULL, NULL, 41319),
(41320, '1.25.40.420-FF-000051', NULL, 'Kelch-like protein 8', 124, NULL, NULL, 41320),
(41321, '3.40.50.300-FF-000063', NULL, 'dynein heavy chain 6, axonemal', 150, NULL, NULL, 41321),
(41322, '2.60.40.10-FF-005604', NULL, NULL, 130, NULL, NULL, 41322),
(41323, '1.25.10.10-FF-000897', NULL, 'Ataxin-10', 89, NULL, NULL, 41323),
(41324, '1.10.3520.10-FF-000025', NULL, 'Uncharacterized protein', 208, NULL, NULL, 41324),
(41325, '2.60.120.200-FF-000758', NULL, 'Galectin', 93, NULL, NULL, 41325),
(41326, '1.10.8.60-FF-000157', NULL, 'AAA family ATPase', 94, NULL, NULL, 41326),
(41327, '2.60.120.10-FF-000323', NULL, '5-deoxy-glucuronate isomerase', 99, NULL, NULL, 41327),
(41328, '1.10.510.10-FF-001880', NULL, 'Uncharacterized protein', 107, NULL, NULL, 41328),
(41329, '3.30.460.10-FF-000183', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 48, NULL, NULL, 41329),
(41330, '1.25.10.10-FF-001515', NULL, 'Formin-D', 301, NULL, NULL, 41330),
(41331, '3.40.50.300-FF-005442', NULL, 'Rad50, isoform E', 257, NULL, NULL, 41331),
(41332, '3.10.490.20-FF-000001', NULL, 'dynein heavy chain 7, axonemal', 143, NULL, NULL, 41332),
(41333, '3.20.20.80-FF-000632', NULL, 'Uncharacterized protein', 119, NULL, NULL, 41333),
(41334, '3.40.250.10-FF-000119', NULL, 'Putative thiosulfate sulfurtransferase', 146, NULL, NULL, 41334),
(41335, '3.40.50.300-FF-000405', NULL, 'Fe-S cluster assembly ATPase SufC', 248, NULL, NULL, 41335),
(41336, '3.20.20.140-FF-000305', NULL, 'Putative adenosine monophosphate deaminase', 173, NULL, NULL, 41336),
(41337, '2.10.25.10-FF-000546', NULL, 'Vacuolar-sorting receptor 1', 38, NULL, NULL, 41337),
(41338, '3.40.50.720-FF-001251', NULL, 'Adenosylhomocysteinase', 159, NULL, NULL, 41338),
(41339, '3.30.930.10-FF-000303', NULL, 'Class II aaRS and biotin synthetases superfamily protein', 204, NULL, NULL, 41339),
(41340, '3.30.160.60-FF-006003', NULL, NULL, 41, NULL, NULL, 41340),
(41341, '2.30.230.10-FF-000046', NULL, 'Uncharacterized protein', 48, NULL, NULL, 41341),
(41342, '3.40.50.1700-FF-000021', NULL, 'Probable beta-glucosidase D', 264, NULL, NULL, 41342),
(41343, '1.20.1720.10-FF-000055', NULL, 'Synaptic vesicular amine transporter', 155, NULL, NULL, 41343),
(41344, '3.20.10.10-FF-000026', NULL, 'Branched-chain amino acid aminotransferase', 205, NULL, NULL, 41344),
(41345, '2.130.10.10-FF-005571', NULL, 'Chromosome 16, whole genome shotgun sequence', 211, NULL, NULL, 41345),
(41346, '1.25.10.10-FF-001173', NULL, 'Uncharacterized protein', 157, NULL, NULL, 41346),
(41347, '3.40.190.10-FF-000749', NULL, 'Glutamate receptor', 114, NULL, NULL, 41347),
(41348, '3.30.200.20-FF-001173', NULL, 'Kinase family protein', 117, NULL, NULL, 41348),
(41349, '1.20.1250.10-FF-000097', NULL, NULL, 164, NULL, NULL, 41349),
(41350, '3.40.1160.10-FF-000005', NULL, 'Amino-acid acetyltransferase', 288, NULL, NULL, 41350),
(41351, '3.30.160.60-FF-001765', NULL, 'zinc finger protein 324A', 31, NULL, NULL, 41351),
(41352, '1.20.1270.280-FF-000040', NULL, 'Uncharacterized protein', 164, NULL, NULL, 41352),
(41353, '2.60.40.10-FF-003592', NULL, NULL, 96, NULL, NULL, 41353),
(41354, '1.10.472.80-FF-000147', NULL, 'Uncharacterized protein', 134, NULL, NULL, 41354),
(41355, '1.10.510.10-FF-001329', NULL, 'Protein kinase, putative', 233, NULL, NULL, 41355),
(41356, '2.20.100.10-FF-000179', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs gon-1', 59, NULL, NULL, 41356),
(41357, '1.25.40.10-FF-005159', NULL, 'Programmed cell death 11', 86, NULL, NULL, 41357),
(41358, '1.25.40.10-FF-001562', NULL, 'Pentatricopeptide repeat-containing protein', 143, NULL, NULL, 41358);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(41359, '3.40.50.2300-FF-001353', NULL, NULL, 44, NULL, NULL, 41359),
(41360, '3.40.50.10810-FF-000122', NULL, 'Uncharacterized protein', 273, NULL, NULL, 41360),
(41361, '3.30.200.20-FF-001482', NULL, 'Serine/threonine-protein kinase 38', 41, NULL, NULL, 41361),
(41362, '3.90.870.10-FF-000037', NULL, 'Threonylcarbamoyl-AMP synthase', 134, NULL, NULL, 41362),
(41363, '1.25.40.180-FF-000254', NULL, NULL, 290, NULL, NULL, 41363),
(41364, '4.10.280.10-FF-000080', NULL, 'Taiman isoform A', 84, NULL, NULL, 41364),
(41365, '2.60.40.10-FF-003569', NULL, NULL, 131, NULL, NULL, 41365),
(41366, '3.90.180.10-FF-000097', NULL, 'Alcohol dehydrogenase GroES domain protein', 163, NULL, NULL, 41366),
(41367, '3.40.50.300-FF-003749', NULL, 'Uncharacterized protein', 235, NULL, NULL, 41367),
(41368, '2.60.40.200-FF-000007', NULL, 'Cell surface Cu-only superoxide dismutase 5', 157, NULL, NULL, 41368),
(41369, '3.30.70.100-FF-000172', NULL, NULL, 90, NULL, NULL, 41369),
(41370, '2.70.150.10-FF-000210', NULL, 'Copper-transporting ATPase RAN1', 218, NULL, NULL, 41370),
(41371, '3.30.160.20-FF-000056', NULL, 'Adenosine deaminase domain-containing 2', 75, NULL, NULL, 41371),
(41372, '3.20.20.70-FF-000320', NULL, 'Quinate pathway repressor protein QutR', 264, NULL, NULL, 41372),
(41373, '3.40.50.2300-FF-001044', NULL, NULL, 172, NULL, NULL, 41373),
(41374, '2.60.120.10-FF-000014', NULL, 'Potassium voltage-gated channel, subfamily H (Eag-related), member 4', 166, NULL, NULL, 41374),
(41375, '3.10.580.10-FF-000134', NULL, 'CBS domain containing protein', 84, NULL, NULL, 41375),
(41376, '1.10.575.10-FF-000006', NULL, 'p1 nuclease, putative', 302, NULL, NULL, 41376),
(41377, '1.10.8.10-FF-000261', NULL, 'baculoviral IAP repeat-containing protein 7 isoform X1', 58, NULL, NULL, 41377),
(41378, '1.25.40.10-FF-001197', NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', 216, NULL, NULL, 41378),
(41379, '2.10.50.10-FF-000166', NULL, 'Predicted protein', 47, NULL, NULL, 41379),
(41380, '3.40.220.10-FF-000039', NULL, 'Phosphatase, putative (AFU_orthologue AFUA_1G16556)', 182, NULL, NULL, 41380),
(41381, '3.30.160.60-FF-001456', NULL, 'flt3-interacting zinc finger protein 1', 29, NULL, NULL, 41381),
(41382, '3.40.50.2000-FF-000982', NULL, 'Uncharacterized protein', 68, NULL, NULL, 41382),
(41383, '3.50.50.60-FF-001413', NULL, 'Dihydropyrimidine dehydrogenase [NADP(+)]', 132, NULL, NULL, 41383),
(41384, '3.40.20.10-FF-000138', NULL, 'Uncharacterized protein', 136, NULL, NULL, 41384),
(41385, '3.30.450.20-FF-000612', NULL, 'Protein TWIN LOV 1', 136, NULL, NULL, 41385),
(41386, '3.30.160.60-FF-005256', NULL, NULL, 28, NULL, NULL, 41386),
(41387, '3.30.160.60-FF-005508', NULL, NULL, 30, NULL, NULL, 41387),
(41388, '3.30.300.20-FF-000045', NULL, 'Ribosome-binding factor A', 117, NULL, NULL, 41388),
(41389, '2.130.10.10-FF-005352', NULL, 'Uncharacterized protein', 177, NULL, NULL, 41389),
(41390, '1.10.2000.10-FF-000019', NULL, 'Corin, isoform B', 130, NULL, NULL, 41390),
(41391, '3.30.300.30-FF-000048', NULL, 'Coronamic acid synthetase CmaA', 104, NULL, NULL, 41391),
(41392, '3.50.50.60-FF-001503', NULL, 'Leucine zipper like transcription regulator 1', 28, NULL, NULL, 41392),
(41393, '1.10.530.10-FF-000043', NULL, 'Tail associated lysin', 121, NULL, NULL, 41393),
(41394, '2.70.150.10-FF-000120', NULL, 'Phospholipid-transporting ATPase', 167, NULL, NULL, 41394),
(41395, '2.10.220.10-FF-000050', NULL, 'Proprotein convertase subtilisin/kexin type 5', 65, NULL, NULL, 41395),
(41396, '3.30.70.330-FF-003074', NULL, NULL, 178, NULL, NULL, 41396),
(41397, '3.50.50.60-FF-000885', NULL, 'FAD-dependent oxidoreductase (Homolog to geranylgeranyl reductase)', 336, NULL, NULL, 41397),
(41398, '1.20.5.780-FF-000010', NULL, 'DUF1778 domain-containing protein', 84, NULL, NULL, 41398),
(41399, '3.10.290.10-FF-000033', NULL, 'Pseudouridine synthase', 72, NULL, NULL, 41399),
(41400, '3.40.50.2000-FF-000763', NULL, 'UDP-glucuronosyltransferase', 174, NULL, NULL, 41400),
(41401, '1.10.10.2770-FF-000001', NULL, 'Selenocysteine-specific translation elongation factor', 128, NULL, NULL, 41401);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(41402, '1.10.510.10-FF-001571', NULL, 'cyclin-dependent kinase 19', 207, NULL, NULL, 41402),
(41403, '3.30.300.10-FF-000042', NULL, 'S-adenosylmethionine synthase', 33, NULL, NULL, 41403),
(41404, '2.10.25.10-FF-001041', NULL, 'GD22027', 65, NULL, NULL, 41404),
(41405, '3.40.50.2000-FF-000673', NULL, 'Uncharacterized protein', 205, NULL, NULL, 41405),
(41406, '3.90.550.10-FF-000108', NULL, 'hyaluronan synthase 1', 281, NULL, NULL, 41406),
(41407, '1.10.238.10-FF-001319', NULL, 'Mitochondrial Rho GTPase 1', 192, NULL, NULL, 41407),
(41408, '1.10.390.10-FF-000054', NULL, 'Uncharacterized protein', 283, NULL, NULL, 41408),
(41409, '3.50.50.60-FF-001161', NULL, 'Uncharacterized protein', 44, NULL, NULL, 41409),
(41410, '3.40.50.720-FF-001032', NULL, 'ADP-L-glycero-D-manno-heptose-6-epimerase', 209, NULL, NULL, 41410),
(41411, '3.30.70.260-FF-000169', NULL, 'Aspartokinase 1 chloroplastic', 48, NULL, NULL, 41411),
(41412, '3.30.200.20-FF-001515', NULL, NULL, 107, NULL, NULL, 41412),
(41413, '3.30.200.20-FF-002100', NULL, 'Predicted protein', 80, NULL, NULL, 41413),
(41414, '3.10.450.240-FF-000001', NULL, 'Mitochondrial import inner membrane translocase subunit TIM44', 192, NULL, NULL, 41414),
(41415, '3.30.160.60-FF-001546', NULL, 'Zinc finger protein 296', 29, NULL, NULL, 41415),
(41416, '3.40.50.2300-FF-001134', NULL, NULL, 134, NULL, NULL, 41416),
(41417, '1.20.140.100-FF-000040', NULL, 'Dynein-1-beta heavy chain, flagellar inner arm I1 complex', 158, NULL, NULL, 41417),
(41418, '1.25.40.10-FF-005249', NULL, 'Uncharacterized protein', 164, NULL, NULL, 41418),
(41419, '4.10.400.10-FF-000067', NULL, 'Serine peptidase inhibitor, Kunitz type 1', 42, NULL, NULL, 41419),
(41420, '1.20.1250.20-FF-001027', NULL, 'Riboflavin transporter RibJ', 202, NULL, NULL, 41420),
(41421, '3.40.50.300-FF-005751', NULL, 'Slr1959 protein', 132, NULL, NULL, 41421),
(41422, '1.10.10.60-FF-000214', NULL, 'Homeobox expressed in ES cells 1', 67, NULL, NULL, 41422),
(41423, '3.30.200.20-FF-001824', NULL, 'Serine/threonine-protein kinase NEK', 48, NULL, NULL, 41423),
(41424, '3.10.105.10-FF-000020', NULL, 'Monoacyl phosphatidylinositol tetramannoside-binding protein LpqW', 248, NULL, NULL, 41424),
(41425, '3.30.70.1230-FF-000130', NULL, 'Adenylate cyclase', 190, NULL, NULL, 41425),
(41426, '1.25.10.10-FF-001824', NULL, 'Uncharacterized protein', 378, NULL, NULL, 41426),
(41427, '3.30.450.40-FF-000005', NULL, 'Phosphodiesterase', 183, NULL, NULL, 41427),
(41428, '3.30.450.50-FF-000008', NULL, 'Vesicle-associated membrane protein 711', 125, NULL, NULL, 41428),
(41429, '1.25.40.710-FF-000014', NULL, 'Chromosome 1, whole genome shotgun sequence', 233, NULL, NULL, 41429),
(41430, '3.30.40.10-FF-002276', NULL, 'Uncharacterized protein', 50, NULL, NULL, 41430),
(41431, '3.50.30.30-FF-000127', NULL, 'Uncharacterized protein', 219, NULL, NULL, 41431),
(41432, '2.130.10.10-FF-000225', NULL, 'Endoplasmic reticulum to nucleus-signaling 1', 283, NULL, NULL, 41432),
(41433, '3.30.160.60-FF-000034', NULL, 'zinc finger protein 25', 28, NULL, NULL, 41433),
(41434, '3.30.710.10-FF-000186', NULL, 'Uncharacterized protein', 126, NULL, NULL, 41434),
(41435, '3.40.50.300-FF-005756', NULL, 'AGAP010790-PA', 126, NULL, NULL, 41435),
(41436, '2.60.120.200-FF-000438', NULL, 'Transport protein ExbB2', 180, NULL, NULL, 41436),
(41437, '1.10.510.10-FF-004302', NULL, NULL, 158, NULL, NULL, 41437),
(41438, '3.10.20.90-FF-000253', NULL, 'unc-112-related protein', 89, NULL, NULL, 41438),
(41439, '3.40.50.720-FF-000537', NULL, 'NADH-ubiquinone oxidoreductase 39 kDa subunit', 229, NULL, NULL, 41439),
(41440, '2.60.40.1180-FF-000001', NULL, 'Maltase-glucoamylase, intestinal', 99, NULL, NULL, 41440),
(41441, '1.20.58.390-FF-000331', NULL, 'Uncharacterized protein', 75, NULL, NULL, 41441),
(41442, '2.60.40.10-FF-000601', NULL, 'striated muscle preferentially expressed protein kinase', 98, NULL, NULL, 41442),
(41443, '3.40.367.20-FF-000028', NULL, 'Phosphotransferase', 45, NULL, NULL, 41443),
(41444, '1.20.5.2650-FF-000002', NULL, '40S ribosomal protein S6', 102, NULL, NULL, 41444);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(41445, '1.10.510.10-FF-003690', NULL, NULL, 168, NULL, NULL, 41445),
(41446, '2.130.10.10-FF-001086', NULL, 'GATOR complex protein MIOS', 325, NULL, NULL, 41446),
(41447, '3.30.540.30-FF-000021', NULL, 'Uncharacterized protein', 167, NULL, NULL, 41447),
(41448, '3.50.50.60-FF-000790', NULL, '2-polyprenyl-6-methoxyphenol hydroxylase and related FAD-dependent oxidoreductases', 246, NULL, NULL, 41448),
(41449, '3.40.630.30-FF-000284', NULL, 'Putative N-acetyltransferase HLS1', 125, NULL, NULL, 41449),
(41450, '3.30.1140.60-FF-000021', NULL, 'F-actin-capping protein subunit alpha', 97, NULL, NULL, 41450),
(41451, '1.10.575.10-FF-000017', NULL, 'Uncharacterized protein', 269, NULL, NULL, 41451),
(41452, '3.30.160.60-FF-005935', NULL, NULL, 57, NULL, NULL, 41452),
(41453, '3.10.105.10-FF-000121', NULL, 'Periplasmic oligopeptide-binding protein', 198, NULL, NULL, 41453),
(41454, '4.10.280.10-FF-000091', NULL, 'HLH DNA binding domain protein', 82, NULL, NULL, 41454),
(41455, '2.60.40.1190-FF-000004', NULL, 'Uncharacterized protein', 236, NULL, NULL, 41455),
(41456, '3.20.20.10-FF-000083', NULL, 'Orn/DAP/Arg decarboxylase 2', 215, NULL, NULL, 41456),
(41457, '1.20.920.10-FF-000150', NULL, 'PolyBRoMo domain containing', 139, NULL, NULL, 41457),
(41458, '2.70.170.10-FF-000110', NULL, 'Uncharacterized protein', 273, NULL, NULL, 41458),
(41459, '3.30.9.10-FF-000051', NULL, 'Digeranylgeranylglycerophospholipid reductase', 132, NULL, NULL, 41459),
(41460, '1.20.1070.10-FF-000881', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 2', 81, NULL, NULL, 41460),
(41461, '3.50.50.60-FF-001402', NULL, 'Uncharacterized protein', 170, NULL, NULL, 41461),
(41462, '1.20.120.350-FF-000240', NULL, NULL, 106, NULL, NULL, 41462),
(41463, '2.30.30.140-FF-000281', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 100, NULL, NULL, 41463),
(41464, '1.10.630.10-FF-000085', NULL, 'Cytochrome P450 family 2 subfamily C member 8', 290, NULL, NULL, 41464),
(41465, '3.30.70.330-FF-000893', NULL, 'Eukaryotic translation initiation factor 3 subunit G', 139, NULL, NULL, 41465),
(41466, '1.25.40.10-FF-005148', NULL, 'Uncharacterized protein', 95, NULL, NULL, 41466),
(41467, '1.25.40.10-FF-001449', NULL, 'Tetratricopeptide repeat domain 7B', 151, NULL, NULL, 41467),
(41468, '2.20.25.10-FF-000017', NULL, 'protein preY, mitochondrial', 58, NULL, NULL, 41468),
(41469, '3.30.160.60-FF-003811', NULL, 'LD13921p', 58, NULL, NULL, 41469),
(41470, '3.30.200.20-FF-001162', NULL, 'Uncharacterized protein', 79, NULL, NULL, 41470),
(41471, '2.20.100.10-FF-000078', NULL, 'ADAMTS like 2', 58, NULL, NULL, 41471),
(41472, '3.40.50.2000-FF-000886', NULL, 'Uncharacterized protein', 277, NULL, NULL, 41472),
(41473, '3.30.40.10-FF-000797', NULL, 'BnaA02g29780D protein', 102, NULL, NULL, 41473),
(41474, '1.10.287.70-FF-000747', NULL, 'Uncharacterized protein', 85, NULL, NULL, 41474),
(41475, '2.40.50.140-FF-000788', NULL, NULL, 144, NULL, NULL, 41475),
(41476, '2.40.30.70-FF-000024', NULL, 'TA01342p', 87, NULL, NULL, 41476),
(41477, '1.50.10.20-FF-000139', NULL, 'Uncharacterized protein', 53, NULL, NULL, 41477),
(41478, '1.10.555.10-FF-000022', NULL, 'rho GTPase-activating protein 19', 221, NULL, NULL, 41478),
(41479, '1.10.150.50-FF-000054', NULL, 'Sterile alpha motif domain-containing protein', 59, NULL, NULL, 41479),
(41480, '2.60.40.10-FF-004300', NULL, NULL, 106, NULL, NULL, 41480),
(41481, '3.40.50.620-FF-000849', NULL, 'Arginine--tRNA ligase', 399, NULL, NULL, 41481),
(41482, '2.60.120.330-FF-000123', NULL, 'Putative 2-oxoglutarate-dependent dioxygenase AOP1.2', 209, NULL, NULL, 41482),
(41483, '3.40.50.150-FF-001086', NULL, 'tRNA (Uracil-5-)-methyltransferase, putative', 224, NULL, NULL, 41483),
(41484, '3.30.200.20-FF-001841', NULL, 'Cell division control protein, putative', 100, NULL, NULL, 41484),
(41485, '1.50.10.10-FF-000136', NULL, 'N-acylglucosamine 2-epimerase-like', 399, NULL, NULL, 41485),
(41486, '3.40.50.10330-FF-000102', NULL, 'Diacylglycerol kinase', 67, NULL, NULL, 41486),
(41487, '3.30.450.20-FF-000365', NULL, 'Predicted protein', 109, NULL, NULL, 41487);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(41488, '1.10.287.70-FF-000068', NULL, 'Voltage-dependent N-type calcium channel subunit alpha', 129, NULL, NULL, 41488),
(41489, '3.40.50.720-FF-001043', NULL, 'Aspergillus niger contig An11c0010, genomic contig', 211, NULL, NULL, 41489),
(41490, '3.20.20.140-FF-000384', NULL, 'PHP domain protein', 180, NULL, NULL, 41490),
(41491, '3.20.20.70-FF-000640', NULL, NULL, 253, NULL, NULL, 41491),
(41492, '1.20.1250.20-FF-000656', NULL, 'MFS transporter', 382, NULL, NULL, 41492),
(41493, '3.40.50.300-FF-005661', NULL, 'ATP-dependent DNA helicase', 204, NULL, NULL, 41493),
(41494, '3.40.50.300-FF-004233', NULL, 'ATP-dependent helicase, putative', 205, NULL, NULL, 41494),
(41495, '1.10.720.30-FF-000070', NULL, 'Uncharacterized protein', 50, NULL, NULL, 41495),
(41496, '4.10.400.10-FF-000180', NULL, 'Low-density lipoprotein receptor-related protein', 41, NULL, NULL, 41496),
(41497, '1.10.10.60-FF-001075', NULL, NULL, 93, NULL, NULL, 41497),
(41498, '1.10.510.10-FF-001661', NULL, 'Protein kinase, putative', 189, NULL, NULL, 41498),
(41499, '3.40.80.10-FF-000035', NULL, 'Uncharacterized protein', 116, NULL, NULL, 41499),
(41500, '1.20.900.10-FF-000036', NULL, 'EG:23E12.2, isoform B', 205, NULL, NULL, 41500),
(41501, '2.130.10.10-FF-005464', NULL, 'Uncharacterized protein', 171, NULL, NULL, 41501),
(41502, '2.70.130.10-FF-000001', NULL, 'Endoplasmic reticulum lectin 1', 121, NULL, NULL, 41502),
(41503, '3.40.50.10330-FF-000091', NULL, 'Predicted protein', 168, NULL, NULL, 41503),
(41504, '1.20.5.4820-FF-000012', NULL, 'Class II myosin', 136, NULL, NULL, 41504),
(41505, '2.60.40.10-FF-003148', NULL, 'Tie-like receptor tyrosine kinase', 97, NULL, NULL, 41505),
(41506, '1.20.58.60-FF-000599', NULL, 'spectrin beta chain, non-erythrocytic 2', 152, NULL, NULL, 41506),
(41507, '3.30.170.10-FF-000003', NULL, 'Cyclin-dependent kinases regulatory subunit', 84, NULL, NULL, 41507),
(41508, '4.10.40.20-FF-000012', NULL, 'Insulin like growth factor binding protein 2', 50, NULL, NULL, 41508),
(41509, '1.20.5.110-FF-000310', NULL, 'Uncharacterized protein', 58, NULL, NULL, 41509),
(41510, '3.30.70.890-FF-000032', NULL, 'Mevalonate kinase', 137, NULL, NULL, 41510),
(41511, '3.30.160.60-FF-004412', NULL, NULL, 26, NULL, NULL, 41511),
(41512, '1.10.1760.10-FF-000003', NULL, 'Actin-related protein 2/3 complex subunit 3', 174, NULL, NULL, 41512),
(41513, '2.20.25.100-FF-000008', NULL, 'Uncharacterized protein', 41, NULL, NULL, 41513),
(41514, '3.80.10.10-FF-000546', NULL, 'Partner of Paired', 82, NULL, NULL, 41514),
(41515, '1.20.1560.10-FF-000525', NULL, 'Multidrug resistance-associated ABC transporter', 220, NULL, NULL, 41515),
(41516, '3.20.20.80-FF-000429', NULL, 'Uncharacterized protein', 94, NULL, NULL, 41516),
(41517, '1.25.10.10-FF-001268', NULL, 'HEAT-like_repeat_-_putative', 845, NULL, NULL, 41517),
(41518, '3.40.50.10190-FF-000234', NULL, 'ECT2 (Mammalian Rho GEF) homolog', 85, NULL, NULL, 41518),
(41519, '2.60.40.420-FF-000057', NULL, 'Ephrin A4', 145, NULL, NULL, 41519),
(41520, '1.25.40.10-FF-003703', NULL, 'Uncharacterized protein', 144, NULL, NULL, 41520),
(41521, '1.10.555.10-FF-000117', NULL, 'LIM and Rho-GAP domain-containing protein', 242, NULL, NULL, 41521),
(41522, '1.10.225.10-FF-000036', NULL, 'LD25144p', 40, NULL, NULL, 41522),
(41523, '2.80.10.50-FF-000026', NULL, 'Blast:Protein O-mannosyl-transferase 2', 204, NULL, NULL, 41523),
(41524, '3.20.20.70-FF-000426', NULL, 'tRNA-dihydrouridine synthase', 231, NULL, NULL, 41524),
(41525, '2.60.40.340-FF-000004', NULL, 'Nuclear factor NF-kappa-B p105 subunit isoform 1', 186, NULL, NULL, 41525),
(41526, '2.60.120.330-FF-000218', NULL, 'Uncharacterized protein', 71, NULL, NULL, 41526),
(41527, '3.40.50.1820-FF-000377', NULL, 'LIPaSe related', 250, NULL, NULL, 41527),
(41528, '3.30.1330.30-FF-000083', NULL, '40S ribosomal protein S12', 98, NULL, NULL, 41528),
(41529, '2.60.40.10-FF-006003', NULL, NULL, 52, NULL, NULL, 41529),
(41530, '4.10.280.10-FF-000102', NULL, 'Nescient helix-loop-helix 1', 58, NULL, NULL, 41530),
(41531, '2.60.40.10-FF-003362', NULL, 'Immununoglobulin light chain', 109, NULL, NULL, 41531);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(41532, '1.20.58.390-FF-000005', NULL, 'Putative gamma-aminobutyric acid receptor subunit rho-2-like', 133, NULL, NULL, 41532),
(41533, '2.30.29.30-FF-000841', NULL, 'Pleckstrin homology-like domain, family B, member 2a', 50, NULL, NULL, 41533),
(41534, '3.40.1110.10-FF-000159', NULL, 'Phospholipid-transporting ATPase', 182, NULL, NULL, 41534),
(41535, '3.30.70.330-FF-001073', NULL, 'U1snRNP-specific protein, putative', 80, NULL, NULL, 41535),
(41536, '3.30.1490.20-FF-000035', NULL, 'D-alanine--D-alanine ligase', 67, NULL, NULL, 41536),
(41537, '3.50.30.20-FF-000012', NULL, 'Aspartate carbamoyltransferase', 158, NULL, NULL, 41537),
(41538, '3.50.50.60-FF-001391', NULL, 'Uncharacterized protein', 211, NULL, NULL, 41538),
(41539, '3.40.910.10-FF-000013', NULL, 'Deoxyhypusine synthase', 319, NULL, NULL, 41539),
(41540, '1.10.8.10-FF-000171', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 37, NULL, NULL, 41540),
(41541, '2.30.40.10-FF-000182', NULL, 'Uncharacterized protein', 45, NULL, NULL, 41541),
(41542, '3.30.450.90-FF-000003', NULL, 'Type II secretion system protein E', 126, NULL, NULL, 41542),
(41543, '2.60.40.10-FF-001445', NULL, 'Tyrosine-protein phosphatase 10D', 98, NULL, NULL, 41543),
(41544, '3.50.30.30-FF-000015', NULL, 'Putative e3 ubiquitin-protein ligase rnf43', 155, NULL, NULL, 41544),
(41545, '1.20.120.1080-FF-000112', NULL, 'DEAH-box RNA helicase (Dhr1), putative (AFU_orthologue AFUA_6G04330)', 93, NULL, NULL, 41545),
(41546, '1.10.1760.20-FF-000006', NULL, 'Biotin transporter', 179, NULL, NULL, 41546),
(41547, '3.40.50.300-FF-001378', NULL, 'Zinc ABC transporter, ATP-binding protein', 229, NULL, NULL, 41547),
(41548, '1.10.246.30-FF-000001', NULL, 'Portal protein', 64, NULL, NULL, 41548),
(41549, '3.30.160.60-FF-003895', NULL, NULL, 24, NULL, NULL, 41549),
(41550, '4.10.900.10-FF-000010', NULL, 'Cadherin 24', 96, NULL, NULL, 41550),
(41551, '2.130.10.10-FF-001765', NULL, 'Uncharacterized protein', 158, NULL, NULL, 41551),
(41552, '3.40.50.1260-FF-000052', NULL, 'Phosphoglycerate kinase', 84, NULL, NULL, 41552),
(41553, '3.40.120.10-FF-000110', NULL, 'Phosphoglucomutase/phosphomannomutase family protein', 174, NULL, NULL, 41553),
(41554, '1.25.40.10-FF-005362', NULL, 'Uncharacterized protein', 51, NULL, NULL, 41554),
(41555, '1.10.1410.10-FF-000022', NULL, 'U3 small nucleolar RNA-associated protein 22', 183, NULL, NULL, 41555),
(41556, '3.10.250.10-FF-000132', NULL, NULL, 108, NULL, NULL, 41556),
(41557, '1.10.510.10-FF-003364', NULL, NULL, 151, NULL, NULL, 41557),
(41558, '1.10.287.470-FF-000019', NULL, 'Efflux transporter periplasmic adaptor subunit', 72, NULL, NULL, 41558),
(41559, '3.40.50.1820-FF-000714', NULL, 'Triacylglycerol lipase, putative', 139, NULL, NULL, 41559),
(41560, '2.20.25.530-FF-000002', NULL, 'Ribonuclease H2 subunit B', 71, NULL, NULL, 41560),
(41561, '2.10.90.10-FF-000073', NULL, 'Beadex/dlmo protein', 110, NULL, NULL, 41561),
(41562, '3.40.220.10-FF-000045', NULL, 'Poly [ADP-ribose] polymerase', 190, NULL, NULL, 41562),
(41563, '3.30.160.60-FF-005609', NULL, NULL, 25, NULL, NULL, 41563),
(41564, '3.60.40.10-FF-000330', NULL, 'Uncharacterized protein', 163, NULL, NULL, 41564),
(41565, '1.10.238.10-FF-000324', NULL, 'EF hand', 69, NULL, NULL, 41565),
(41566, '2.30.29.30-FF-001116', NULL, 'Uncharacterized protein', 135, NULL, NULL, 41566),
(41567, '3.30.160.60-FF-004997', NULL, NULL, 53, NULL, NULL, 41567),
(41568, '2.10.50.10-FF-000059', NULL, 'TNF receptor superfamily member 8', 42, NULL, NULL, 41568),
(41569, '3.20.20.330-FF-000008', NULL, 'S-methylmethionine--homocysteine S-methyltransferase BHMT2 isoform X2', 87, NULL, NULL, 41569),
(41570, '3.40.50.1400-FF-000032', NULL, 'Sirohydrochlorin cobaltochelatase CbiKC', 129, NULL, NULL, 41570),
(41571, '1.25.10.10-FF-003185', NULL, 'PIKK family atypical protein kinase', 312, NULL, NULL, 41571),
(41572, '1.25.10.10-FF-003297', NULL, 'Protein ARABIDILLO 2', 176, NULL, NULL, 41572),
(41573, '3.80.10.10-FF-003986', NULL, 'Uncharacterized protein', 158, NULL, NULL, 41573),
(41574, '3.90.1410.10-FF-000002', NULL, 'SET domain-containing protein 4 isoform X1', 282, NULL, NULL, 41574); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(41575, '3.40.1280.30-FF-000020', NULL, 'Uncharacterized protein', 196, NULL, NULL, 41575),
(41576, '3.40.190.10-FF-000030', NULL, 'Molybdate ABC transporter substrate-binding protein', 113, NULL, NULL, 41576),
(41577, '4.10.410.10-FF-000040', NULL, 'Serine protease inhibitor, putative', 61, NULL, NULL, 41577),
(41578, '4.10.1060.10-FF-000009', NULL, 'YY1 associated factor 2', 43, NULL, NULL, 41578),
(41579, '1.10.1200.10-FF-000085', NULL, 'Nonribosomal peptide synthetase 9', 83, NULL, NULL, 41579),
(41580, '2.30.42.10-FF-000585', NULL, NULL, 128, NULL, NULL, 41580),
(41581, '3.10.50.40-FF-000105', NULL, 'Peptidyl-prolyl cis-trans isomerase FKBP20-2, chloroplastic', 134, NULL, NULL, 41581),
(41582, '2.30.30.190-FF-000037', NULL, NULL, 99, NULL, NULL, 41582),
(41583, '1.10.506.10-FF-000026', NULL, 'Plexin D1', 428, NULL, NULL, 41583),
(41584, '3.40.30.10-FF-000419', NULL, 'Protein disulfide-isomerase MPD1', 141, NULL, NULL, 41584),
(41585, '3.40.50.1820-FF-001203', NULL, 'Phosphatidylcholine-sterol acyltransferase', 91, NULL, NULL, 41585),
(41586, '2.60.220.50-FF-000163', NULL, 'Predicted protein', 210, NULL, NULL, 41586),
(41587, '1.50.40.10-FF-000059', NULL, 'Mitochondrial ornithine transporter 2', 97, NULL, NULL, 41587),
(41588, '3.40.50.300-FF-001592', NULL, 'ATP-binding cassette protein subfamily A, member 6', 259, NULL, NULL, 41588),
(41589, '2.60.40.10-FF-005486', NULL, NULL, 98, NULL, NULL, 41589),
(41590, '3.30.60.30-FF-000006', NULL, 'Follistatin a', 73, NULL, NULL, 41590),
(41591, '2.30.180.10-FF-000030', NULL, 'Stabilin 1', 132, NULL, NULL, 41591),
(41592, '3.40.1370.10-FF-000021', NULL, 'Uncharacterized protein', 194, NULL, NULL, 41592),
(41593, '2.70.50.40-FF-000009', NULL, 'Uncharacterized protein', 84, NULL, NULL, 41593),
(41594, '3.30.160.60-FF-001771', NULL, 'Zinc finger protein 200', 24, NULL, NULL, 41594),
(41595, '3.40.50.1000-FF-000002', NULL, 'Potassium-transporting ATPase ATP-binding subunit', 163, NULL, NULL, 41595),
(41596, '3.40.50.1010-FF-000005', NULL, 'ATP-binding protein', 148, NULL, NULL, 41596),
(41597, '2.70.160.11-FF-000055', NULL, 'Uncharacterized protein', 175, NULL, NULL, 41597),
(41598, '2.80.10.50-FF-000240', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 94, NULL, NULL, 41598),
(41599, '1.20.120.350-FF-000009', NULL, 'Voltage-dependent T-type calcium channel subunit alpha', 134, NULL, NULL, 41599),
(41600, '1.20.1070.10-FF-000667', NULL, 'Uncharacterized protein', 329, NULL, NULL, 41600),
(41601, '2.70.50.30-FF-000006', NULL, 'Rho GDP exchange inhibitor, putative', 174, NULL, NULL, 41601),
(41602, '2.30.30.100-FF-000067', NULL, 'U6 snRNA-associated Sm-like protein LSm5', 87, NULL, NULL, 41602),
(41603, '3.20.20.80-FF-000643', NULL, 'Predicted protein', 97, NULL, NULL, 41603),
(41604, '1.25.10.10-FF-003308', NULL, 'Uncharacterized protein', 160, NULL, NULL, 41604),
(41605, '3.90.70.10-FF-000105', NULL, 'Ubiquitin C-terminal hydrolase Ubp3', 391, NULL, NULL, 41605),
(41606, '3.90.1420.10-FF-000042', NULL, 'Predicted protein', 151, NULL, NULL, 41606),
(41607, '3.30.70.330-FF-001410', NULL, 'La protein 1', 115, NULL, NULL, 41607),
(41608, '1.25.40.10-FF-000140', NULL, 'Coatomer subunit epsilon', 285, NULL, NULL, 41608),
(41609, '1.20.5.2210-FF-000005', NULL, 'Uncharacterized protein', 70, NULL, NULL, 41609),
(41610, '1.20.1250.20-FF-000982', NULL, 'CLN3 protein', 372, NULL, NULL, 41610),
(41611, '3.30.930.10-FF-000404', NULL, 'Uncharacterized protein', 89, NULL, NULL, 41611),
(41612, '3.30.420.10-FF-000534', NULL, NULL, 95, NULL, NULL, 41612),
(41613, '3.40.30.10-FF-000212', NULL, 'Endoplasmic reticulum resident protein 27', 110, NULL, NULL, 41613),
(41614, '2.60.40.10-FF-002046', NULL, 'Muscle M-line assembly protein unc-89', 99, NULL, NULL, 41614),
(41615, '3.40.1170.10-FF-000040', NULL, 'DNA mismatch repair protein MutS', 137, NULL, NULL, 41615),
(41616, '1.10.730.20-FF-000022', NULL, 'Uncharacterized protein', 152, NULL, NULL, 41616),
(41617, '3.10.20.230-FF-000037', NULL, 'Uncharacterized protein', 89, NULL, NULL, 41617),
(41618, '3.30.70.330-FF-002596', NULL, NULL, 134, NULL, NULL, 41618);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(41619, '1.25.10.10-FF-001156', NULL, 'Uncharacterized protein', 299, NULL, NULL, 41619),
(41620, '1.25.50.20-FF-000071', NULL, 'Aminopeptidase', 316, NULL, NULL, 41620),
(41621, '1.10.8.10-FF-000266', NULL, 'Uncharacterized protein', 76, NULL, NULL, 41621),
(41622, '1.50.40.10-FF-000531', NULL, 'Uncharacterized protein', 158, NULL, NULL, 41622),
(41623, '2.130.10.10-FF-001439', NULL, 'Possible glycosyl hydrolase', 337, NULL, NULL, 41623),
(41624, '1.10.150.50-FF-000149', NULL, 'uncharacterized protein LOC100179383 isoform X1', 58, NULL, NULL, 41624),
(41625, '1.25.40.20-FF-000143', NULL, 'transient receptor potential cation channel subfamily V member 5', 206, NULL, NULL, 41625),
(41626, '3.50.50.60-FF-000559', NULL, 'tRNA 5-methylaminomethyl-2-thiouridine biosynthesis bifunctional protein MnmC', 242, NULL, NULL, 41626),
(41627, '1.10.630.10-FF-000438', NULL, 'Cytochrome P450', 291, NULL, NULL, 41627),
(41628, '3.80.10.10-FF-002575', NULL, 'Uncharacterized protein', 118, NULL, NULL, 41628),
(41629, '3.30.160.60-FF-001557', NULL, 'Transcription factor E4F1', 26, NULL, NULL, 41629),
(41630, '1.10.555.10-FF-000229', NULL, NULL, 258, NULL, NULL, 41630),
(41631, '3.20.20.140-FF-000058', NULL, 'Phosphotriesterase-related protein', 349, NULL, NULL, 41631),
(41632, '3.40.1800.20-FF-000018', NULL, 'AGAP008515-PA', 73, NULL, NULL, 41632),
(41633, '3.40.50.2300-FF-000869', NULL, 'Vomeronasal 2, receptor 56', 216, NULL, NULL, 41633),
(41634, '3.40.50.10190-FF-000346', NULL, 'Uncharacterized protein', 82, NULL, NULL, 41634),
(41635, '3.90.190.10-FF-000608', NULL, 'Uncharacterized protein', 140, NULL, NULL, 41635),
(41636, '3.40.50.1110-FF-000147', NULL, 'Uncharacterized protein', 130, NULL, NULL, 41636),
(41637, '3.40.50.410-FF-000337', NULL, 'Uncharacterized protein', 151, NULL, NULL, 41637),
(41638, '2.30.180.10-FF-000125', NULL, NULL, 142, NULL, NULL, 41638),
(41639, '3.40.710.10-FF-000127', NULL, 'Penicillin-binding protein', 77, NULL, NULL, 41639),
(41640, '4.10.1240.10-FF-000012', NULL, 'Calcitonin receptor', 101, NULL, NULL, 41640),
(41641, '3.90.25.10-FF-000046', NULL, 'NmrA family transcriptional regulator', 109, NULL, NULL, 41641),
(41642, '1.10.860.10-FF-000017', NULL, 'DNA primase', 149, NULL, NULL, 41642),
(41643, '3.30.160.60-FF-000360', NULL, 'zinc finger protein 572', 28, NULL, NULL, 41643),
(41644, '2.60.40.10-FF-005391', NULL, NULL, 53, NULL, NULL, 41644),
(41645, '3.40.50.1820-FF-000489', NULL, 'Hydrolase, CocE/NonD family', 287, NULL, NULL, 41645),
(41646, '2.60.40.790-FF-000004', NULL, 'ubiquitin carboxyl-terminal hydrolase 19 isoform X9', 111, NULL, NULL, 41646),
(41647, '1.10.510.10-FF-003459', NULL, NULL, 274, NULL, NULL, 41647),
(41648, '1.10.510.10-FF-001773', NULL, 'Uncharacterized protein', 166, NULL, NULL, 41648),
(41649, '1.10.1580.10-FF-000017', NULL, 'Short integuments 2 mitochondrial', 116, NULL, NULL, 41649),
(41650, '2.130.10.10-FF-005576', NULL, 'Uncharacterized protein', 207, NULL, NULL, 41650),
(41651, '3.40.50.1100-FF-000144', NULL, 'Threonine dehydratase catabolic putative', 49, NULL, NULL, 41651),
(41652, '3.40.50.720-FF-000649', NULL, 'dTDP-glucose 4,6-dehydratase', 313, NULL, NULL, 41652),
(41653, '3.90.180.10-FF-000092', NULL, 'Protein CBG23238', 76, NULL, NULL, 41653),
(41654, '3.80.10.10-FF-002912', NULL, 'Uncharacterized protein', 93, NULL, NULL, 41654),
(41655, '3.30.70.360-FF-000008', NULL, 'Cytosolic non-specific dipeptidase', 174, NULL, NULL, 41655),
(41656, '1.10.10.10-FF-000340', NULL, 'ETS translocation variant 2', 125, NULL, NULL, 41656),
(41657, '3.30.70.330-FF-002719', NULL, NULL, 101, NULL, NULL, 41657),
(41658, '3.30.710.10-FF-000298', NULL, 'Rho-related BTB domain-containing 1', 83, NULL, NULL, 41658),
(41659, '2.60.40.790-FF-000021', NULL, 'nudC domain-containing protein 2', 64, NULL, NULL, 41659),
(41660, '3.30.70.330-FF-001617', NULL, NULL, 91, NULL, NULL, 41660),
(41661, '1.25.10.10-FF-001835', NULL, 'Uncharacterized protein', 279, NULL, NULL, 41661),
(41662, '2.30.29.30-FF-001330', NULL, 'ArfGAP with SH3 domain, ankyrin repeat and PH domain 3', 59, NULL, NULL, 41662);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(41663, '3.30.565.10-FF-000111', NULL, 'Two-component sensor histidine kinase', 152, NULL, NULL, 41663),
(41664, '1.20.58.900-FF-000018', NULL, 'RUN and FYVE domain-containing protein 2 isoform X5', 120, NULL, NULL, 41664),
(41665, '3.50.50.60-FF-001514', NULL, 'Uncharacterized protein', 90, NULL, NULL, 41665),
(41666, '1.25.40.10-FF-001337', NULL, 'Suppressor with Morphological effect on Genitalia', 229, NULL, NULL, 41666),
(41667, '1.10.4200.10-FF-000001', NULL, 'Triphosphoribosyl-dephospho-CoA synthase CitG', 249, NULL, NULL, 41667),
(41668, '4.10.400.10-FF-000207', NULL, 'Thioester-containing protein 6', 41, NULL, NULL, 41668),
(41669, '3.30.60.30-FF-000220', NULL, 'Protein CBR-AGR-1', 58, NULL, NULL, 41669),
(41670, '2.60.40.60-FF-001095', NULL, 'Uncharacterized protein', 117, NULL, NULL, 41670),
(41671, '1.25.10.10-FF-002111', NULL, 'Predicted protein', 358, NULL, NULL, 41671),
(41672, '1.10.555.10-FF-000134', NULL, 'SLIT-ROBO Rho GTPase-activating protein 2', 96, NULL, NULL, 41672),
(41673, '3.40.50.2300-FF-000757', NULL, NULL, 33, NULL, NULL, 41673),
(41674, '3.30.160.60-FF-002046', NULL, 'zinc finger protein 275', 31, NULL, NULL, 41674),
(41675, '1.10.225.10-FF-000019', NULL, 'Saposin-related', 87, NULL, NULL, 41675),
(41676, '3.20.20.80-FF-000076', NULL, 'Mannan endo-1,4-beta-mannosidase A', 345, NULL, NULL, 41676),
(41677, '1.20.5.4880-FF-000002', NULL, 'rab-3A-interacting protein isoform X2', 61, NULL, NULL, 41677),
(41678, '3.80.10.10-FF-002558', NULL, 'geranylgeranyl transferase type-2 subunit alpha', 138, NULL, NULL, 41678),
(41679, '1.10.840.10-FF-000022', NULL, 'Ral GDS-Like', 286, NULL, NULL, 41679),
(41680, '1.10.10.10-FF-001863', NULL, 'Vacuolar protein-sorting-associated protein 36', 71, NULL, NULL, 41680),
(41681, '3.40.50.2000-FF-001050', NULL, 'Uncharacterized protein', 124, NULL, NULL, 41681),
(41682, '3.30.200.20-FF-000998', NULL, 'Protein kinase, putative', 93, NULL, NULL, 41682),
(41683, '1.20.1280.50-FF-000234', NULL, 'Uncharacterized protein', 85, NULL, NULL, 41683),
(41684, '1.10.510.10-FF-003038', NULL, NULL, 217, NULL, NULL, 41684),
(41685, '1.25.10.10-FF-000312', NULL, 'Kinesin-like protein', 183, NULL, NULL, 41685),
(41686, '3.30.200.20-FF-001274', NULL, 'Kinase, NEK', 88, NULL, NULL, 41686),
(41687, '1.20.1250.20-FF-000089', NULL, 'L-fucose:H+ symporter permease', 222, NULL, NULL, 41687),
(41688, '3.40.50.300-FF-007443', NULL, 'Uncharacterized ABC transporter ATP-binding protein C323.04', 251, NULL, NULL, 41688),
(41689, '1.10.472.80-FF-000254', NULL, NULL, 78, NULL, NULL, 41689),
(41690, '2.60.120.970-FF-000062', NULL, 'Bone morphogenetic protein 7', 188, NULL, NULL, 41690),
(41691, '3.40.1170.60-FF-000026', NULL, 'DNA polymerase IV', 64, NULL, NULL, 41691),
(41692, '3.40.50.2300-FF-001033', NULL, NULL, 122, NULL, NULL, 41692),
(41693, '3.20.20.70-FF-000409', NULL, 'FMN-dependent alpha-hydroxy acid dehydrogenase', 400, NULL, NULL, 41693),
(41694, '2.60.40.650-FF-000007', NULL, 'Molybdopterin-binding oxidoreductase', 107, NULL, NULL, 41694),
(41695, '3.20.20.70-FF-000073', NULL, '12-oxophytodienoate reductase 3', 367, NULL, NULL, 41695),
(41696, '2.60.120.330-FF-000235', NULL, '2-oxoglutarate (2OG) and Fe(II)-dependent oxygenase superfamily protein', 86, NULL, NULL, 41696),
(41697, '3.40.1550.20-FF-000010', NULL, 'Transcriptional regulator MraZ', 147, NULL, NULL, 41697),
(41698, '3.40.850.10-FF-000429', NULL, 'Uncharacterized protein', 157, NULL, NULL, 41698),
(41699, '1.20.1250.10-FF-000086', NULL, NULL, 88, NULL, NULL, 41699),
(41700, '2.30.42.10-FF-000259', NULL, 'Uncharacterized protein', 103, NULL, NULL, 41700),
(41701, '1.10.3500.10-FF-000029', NULL, 'Uncharacterized protein', 246, NULL, NULL, 41701),
(41702, '3.50.50.60-FF-000997', NULL, 'Predicted protein', 42, NULL, NULL, 41702),
(41703, '1.10.630.10-FF-000208', NULL, 'Cytochrome P450, family 2, subfamily k, polypeptide 20', 199, NULL, NULL, 41703),
(41704, '2.60.40.10-FF-005609', NULL, NULL, 102, NULL, NULL, 41704),
(41705, '2.30.110.10-FF-000082', NULL, 'Uncharacterized protein', 222, NULL, NULL, 41705);
INSERT INTO "PUBLIC"."MODEL" VALUES
(41706, '3.40.50.2000-FF-000774', NULL, 'GDP-Man:Man(3)GlcNAc(2)-PP-Dol alpha-1,2-mannosyltransferase', 212, NULL, NULL, 41706),
(41707, '3.40.50.300-FF-003744', NULL, 'ATPase, AAA family protein', 167, NULL, NULL, 41707),
(41708, '3.30.420.10-FF-000197', NULL, 'CCR4-NOT transcription complex subunit 7', 270, NULL, NULL, 41708),
(41709, '2.40.50.140-FF-000676', NULL, NULL, 94, NULL, NULL, 41709),
(41710, '3.40.50.720-FF-000554', NULL, 'Homoserine dehydrogenase', 178, NULL, NULL, 41710),
(41711, '1.10.10.10-FF-001442', NULL, 'Nodulation protein D 2', 86, NULL, NULL, 41711),
(41712, '3.20.20.60-FF-000070', NULL, 'Phosphotransferase system fructose-specific transporter subunit EI/HPr/EIIA', 329, NULL, NULL, 41712),
(41713, '1.50.40.10-FF-000301', NULL, 'Uncoupling protein 4B, isoform C', 216, NULL, NULL, 41713),
(41714, '3.20.19.10-FF-000012', NULL, 'Aconitate hydratase A', 144, NULL, NULL, 41714),
(41715, '3.10.20.90-FF-000270', NULL, 'Ubiquitin regulatory protein, putative', 121, NULL, NULL, 41715),
(41716, '1.20.1070.10-FF-001510', NULL, 'Uncharacterized protein', 196, NULL, NULL, 41716),
(41717, '1.25.40.10-FF-004659', NULL, 'Superkiller protein 3', 115, NULL, NULL, 41717),
(41718, '2.10.25.10-FF-000451', NULL, 'alpha-tectorin isoform X1', 45, NULL, NULL, 41718),
(41719, '1.25.40.10-FF-001096', NULL, 'Pentatricopeptide repeat-containing protein', 134, NULL, NULL, 41719),
(41720, '4.10.280.110-FF-000012', NULL, 'Yeast PRP (Splicing factor) related', 75, NULL, NULL, 41720),
(41721, '1.25.10.10-FF-001594', NULL, 'Uncharacterized protein', 451, NULL, NULL, 41721),
(41722, '1.20.1270.60-FF-000309', NULL, 'Uncharacterized protein', 65, NULL, NULL, 41722),
(41723, '1.10.150.310-FF-000006', NULL, 'Uncharacterized protein (Fragment)', 137, NULL, NULL, 41723),
(41724, '3.40.1160.10-FF-000084', NULL, 'Uncharacterized protein', 319, NULL, NULL, 41724),
(41725, '3.30.1360.120-FF-000101', NULL, 'Glr1472 protein', 104, NULL, NULL, 41725),
(41726, '3.10.450.240-FF-000006', NULL, 'Mitochondrial inner membrane translocase complex, subunit Tim44-related protein', 156, NULL, NULL, 41726),
(41727, '1.25.40.20-FF-001099', NULL, 'Kinase, NEK', 82, NULL, NULL, 41727),
(41728, '2.10.220.10-FF-000162', NULL, 'Uncharacterized protein', 96, NULL, NULL, 41728),
(41729, '3.30.160.60-FF-005368', NULL, NULL, 55, NULL, NULL, 41729),
(41730, '1.20.5.2950-FF-000002', NULL, 'V-type proton ATPase subunit G, putative', 113, NULL, NULL, 41730),
(41731, '3.40.250.10-FF-000226', NULL, 'Cdc25b protein', 78, NULL, NULL, 41731),
(41732, '1.20.920.10-FF-000133', NULL, 'Uncharacterized protein', 113, NULL, NULL, 41732),
(41733, '2.10.90.10-FF-000056', NULL, 'Protein spaetzle', 106, NULL, NULL, 41733),
(41734, '3.30.420.40-FF-000886', NULL, 'Uncharacterized protein', 20, NULL, NULL, 41734),
(41735, '3.40.190.80-FF-000039', NULL, 'Inositol-1-monophosphatase protein', 108, NULL, NULL, 41735),
(41736, '2.60.40.640-FF-000004', NULL, 'Vacuolar protein sorting-associated protein 26', 151, NULL, NULL, 41736),
(41737, '3.60.110.10-FF-000077', NULL, NULL, 276, NULL, NULL, 41737),
(41738, '3.30.9.100-FF-000001', NULL, 'Possible oxygenase', 107, NULL, NULL, 41738),
(41739, '3.40.50.300-FF-003295', NULL, 'GD25727', 343, NULL, NULL, 41739),
(41740, '3.10.100.10-FF-000020', NULL, 'Mannose receptor C type 2', 140, NULL, NULL, 41740),
(41741, '3.40.50.720-FF-002454', NULL, 'Autophagy protein', 273, NULL, NULL, 41741),
(41742, '1.10.8.1220-FF-000019', NULL, 'MKIAA1697 protein', 54, NULL, NULL, 41742),
(41743, '3.40.50.300-FF-007908', NULL, 'Uncharacterized protein', 186, NULL, NULL, 41743),
(41744, '2.60.120.200-FF-000652', NULL, 'Uncharacterized protein', 98, NULL, NULL, 41744),
(41745, '3.40.50.10810-FF-000021', NULL, 'DNA repair and recombination protein RAD54', 268, NULL, NULL, 41745),
(41746, '2.130.10.10-FF-004975', NULL, 'Intraflagellar transport protein 80', 83, NULL, NULL, 41746),
(41747, '1.10.3060.10-FF-000012', NULL, 'Protein translocase subunit SecA', 209, NULL, NULL, 41747),
(41748, '3.40.630.30-FF-000407', NULL, 'Histone acetyltransferase', 28, NULL, NULL, 41748);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(41749, '3.30.505.10-FF-000091', NULL, 'Uncharacterized protein, isoform C', 125, NULL, NULL, 41749),
(41750, '3.30.420.10-FF-000422', NULL, NULL, 153, NULL, NULL, 41750),
(41751, '3.40.50.300-FF-007673', NULL, 'Uncharacterized protein', 119, NULL, NULL, 41751),
(41752, '1.10.150.300-FF-000003', NULL, 'Obg-like ATPase 1', 90, NULL, NULL, 41752),
(41753, '3.40.20.10-FF-000043', NULL, 'macrophage-capping protein-like isoform X2', 125, NULL, NULL, 41753),
(41754, '2.60.120.260-FF-000658', NULL, 'Uncharacterized protein', 173, NULL, NULL, 41754),
(41755, '3.40.720.10-FF-000285', NULL, 'Protein CBG09284', 279, NULL, NULL, 41755),
(41756, '3.30.40.10-FF-001202', NULL, 'GM14467p', 95, NULL, NULL, 41756),
(41757, '4.10.1060.10-FF-000026', NULL, 'Zn-finger in Ran binding protein', 31, NULL, NULL, 41757),
(41758, '3.80.10.10-FF-000097', NULL, 'leucine-rich repeat protein SHOC-2 isoform X2', 92, NULL, NULL, 41758),
(41759, '3.30.450.20-FF-000691', NULL, 'PAS sensor protein', 144, NULL, NULL, 41759),
(41760, '1.20.1270.60-FF-000186', NULL, 'Transcription modulator, putative', 203, NULL, NULL, 41760),
(41761, '2.60.120.10-FF-000441', NULL, 'cGMP-dependent protein kinase', 141, NULL, NULL, 41761),
(41762, '3.40.50.300-FF-005318', NULL, 'GM13376', 160, NULL, NULL, 41762),
(41763, '1.25.40.10-FF-003350', NULL, 'Pentatricopeptide repeat-containing protein At4g11690', 80, NULL, NULL, 41763),
(41764, '1.20.58.60-FF-000392', NULL, 'Dystonin', 287, NULL, NULL, 41764),
(41765, '3.40.50.300-FF-000181', NULL, 'Guanine nucleotide-binding protein subunit alpha', 187, NULL, NULL, 41765),
(41766, '1.10.405.10-FF-000022', NULL, 'Amine oxidase', 94, NULL, NULL, 41766),
(41767, '1.10.1080.10-FF-000007', NULL, 'Glutathione synthetase', 56, NULL, NULL, 41767),
(41768, '3.60.21.10-FF-000050', NULL, 'Calcineurin-like metallo-phosphoesterase superfamily protein', 256, NULL, NULL, 41768),
(41769, '3.90.550.20-FF-000016', NULL, 'Glycosyltransferase family 32 protein', 173, NULL, NULL, 41769),
(41770, '3.30.559.10-FF-000069', NULL, 'Protein CBG23894', 274, NULL, NULL, 41770),
(41771, '3.10.250.10-FF-000020', NULL, 'serine protease hepsin', 107, NULL, NULL, 41771),
(41772, '1.10.357.140-FF-000027', NULL, 'Fumagillin beta-trans-bergamotene synthase af520', 143, NULL, NULL, 41772),
(41773, '2.60.40.10-FF-005374', NULL, NULL, 60, NULL, NULL, 41773),
(41774, '3.30.479.10-FF-000017', NULL, '6-carboxy-5,6,7,8-tetrahydropterin synthase', 112, NULL, NULL, 41774),
(41775, '3.40.50.410-FF-000225', NULL, 'Integrin beta', 124, NULL, NULL, 41775),
(41776, '3.40.50.2020-FF-000100', NULL, 'Ribose-phosphate pyrophosphokinase, putative', 150, NULL, NULL, 41776),
(41777, '1.20.1740.10-FF-000056', NULL, 'Y+L amino acid transporter 2', 183, NULL, NULL, 41777),
(41778, '3.30.70.1130-FF-000010', NULL, 'Uncharacterized protein', 125, NULL, NULL, 41778),
(41779, '3.10.50.40-FF-000122', NULL, 'Peptidylprolyl isomerase', 57, NULL, NULL, 41779),
(41780, '2.130.10.30-FF-000136', NULL, NULL, 265, NULL, NULL, 41780),
(41781, '2.60.220.50-FF-000146', NULL, 'Uncharacterized protein', 372, NULL, NULL, 41781),
(41782, '3.90.550.10-FF-000013', NULL, 'mannose-1-phosphate guanyltransferase beta', 232, NULL, NULL, 41782),
(41783, '3.40.50.300-FF-003418', NULL, 'RecBCD enzyme subunit RecB', 131, NULL, NULL, 41783),
(41784, '3.30.930.10-FF-000067', NULL, 'Lysine--tRNA ligase', 376, NULL, NULL, 41784),
(41785, '3.90.190.10-FF-000255', NULL, 'putative tyrosine-protein phosphatase auxilin', 207, NULL, NULL, 41785),
(41786, '3.40.50.1400-FF-000015', NULL, 'Ferrochelatase', 140, NULL, NULL, 41786),
(41787, '1.25.40.10-FF-001663', NULL, 'GM20009', 291, NULL, NULL, 41787),
(41788, '2.130.10.10-FF-003238', NULL, 'WD domain, G-beta repeat, putative', 242, NULL, NULL, 41788),
(41789, '3.40.50.850-FF-000008', NULL, 'Blast:Pyrazinamidase/nicotinamidase', 219, NULL, NULL, 41789),
(41790, '1.10.3200.20-FF-000004', NULL, 'DNA polymerase', 183, NULL, NULL, 41790),
(41791, '3.30.160.60-FF-000601', NULL, 'Histone-lysine N-methyltransferase PRDM9', 28, NULL, NULL, 41791),
(41792, '1.25.40.20-FF-001666', NULL, 'Kinase, NEK', 83, NULL, NULL, 41792);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(41793, '3.30.70.330-FF-001056', NULL, 'HnRNP A1 homolog', 101, NULL, NULL, 41793),
(41794, '1.10.510.10-FF-001447', NULL, 'Os07g0227300 protein', 215, NULL, NULL, 41794),
(41795, '3.90.190.10-FF-000485', NULL, 'Uncharacterized protein', 165, NULL, NULL, 41795),
(41796, '1.25.40.370-FF-000007', NULL, 'Putative apoptotic protease-activating factor', 136, NULL, NULL, 41796),
(41797, '3.80.10.10-FF-000760', NULL, 'LRR receptor-like serine/threonine-protein kinase RCH1', 126, NULL, NULL, 41797),
(41798, '3.40.1110.10-FF-000373', NULL, NULL, 165, NULL, NULL, 41798),
(41799, '1.10.510.10-FF-003476', NULL, NULL, 269, NULL, NULL, 41799),
(41800, '3.40.50.300-FF-002316', NULL, 'Multidrug ABC transporter ATP-binding protein', 214, NULL, NULL, 41800),
(41801, '3.30.70.1230-FF-000129', NULL, 'Adenylate/guanylate cyclase', 192, NULL, NULL, 41801),
(41802, '1.10.10.10-FF-000014', NULL, 'Cullin 1', 90, NULL, NULL, 41802),
(41803, '3.30.160.60-FF-001883', NULL, 'zinc finger protein 683', 24, NULL, NULL, 41803),
(41804, '2.130.10.10-FF-000130', NULL, 'DNA excision repair protein ERCC-8', 365, NULL, NULL, 41804),
(41805, '2.60.40.10-FF-000034', NULL, 'Titin isoform A', 99, NULL, NULL, 41805),
(41806, '2.10.70.10-FF-000173', NULL, 'Uncharacterized protein', 59, NULL, NULL, 41806),
(41807, '1.10.510.10-FF-000036', NULL, 'RAF proto-oncogene serine/threonine-protein kinase', 192, NULL, NULL, 41807),
(41808, '2.70.130.10-FF-000113', NULL, NULL, 175, NULL, NULL, 41808),
(41809, '2.60.40.2690-FF-000004', NULL, 'Splicing factor 3A subunit 2, putative', 121, NULL, NULL, 41809),
(41810, '3.60.20.10-FF-000216', NULL, NULL, 153, NULL, NULL, 41810),
(41811, '3.10.350.10-FF-000084', NULL, 'Lipoprotein NlpD', 65, NULL, NULL, 41811),
(41812, '3.30.710.10-FF-000427', NULL, 'Protein CBG06295', 104, NULL, NULL, 41812),
(41813, '3.40.1010.20-FF-000003', NULL, '4-hydroxy-3-methylbut-2-enyl diphosphate reductase', 97, NULL, NULL, 41813),
(41814, '3.40.50.300-FF-007347', NULL, 'Superfamily I DNA and RNA helicase and helicase subunits-like protein', 220, NULL, NULL, 41814),
(41815, '2.30.29.30-FF-000487', NULL, 'Stress-activated map kinase-interacting protein 1', 118, NULL, NULL, 41815),
(41816, '3.40.50.150-FF-001069', NULL, NULL, 242, NULL, NULL, 41816),
(41817, '2.60.40.10-FF-005935', NULL, NULL, 100, NULL, NULL, 41817),
(41818, '4.10.240.10-FF-000094', NULL, 'Zcf29p', 41, NULL, NULL, 41818),
(41819, '1.20.120.850-FF-000053', NULL, 'Uncharacterized protein', 30, NULL, NULL, 41819),
(41820, '3.80.10.10-FF-000658', NULL, 'Serine/threonine-protein kinase 11-interacting protein', 131, NULL, NULL, 41820),
(41821, '3.30.160.60-FF-003474', NULL, 'Related to ZAP1-metalloregulatory protein involved in zinc-responsive transcriptional regulation', 31, NULL, NULL, 41821),
(41822, '1.20.1560.10-FF-000637', NULL, 'Uncharacterized protein', 197, NULL, NULL, 41822),
(41823, '1.10.1670.40-FF-000005', NULL, 'Chromosome 1, whole genome shotgun sequence', 45, NULL, NULL, 41823),
(41824, '1.20.1730.10-FF-000128', NULL, 'Uncharacterized protein', 64, NULL, NULL, 41824),
(41825, '3.90.660.10-FF-000134', NULL, NULL, 35, NULL, NULL, 41825),
(41826, '3.40.50.720-FF-000880', NULL, 'NADH dehydrogenase (Ubiquinone) 1 alpha subcomplex 9', 215, NULL, NULL, 41826),
(41827, '1.10.132.30-FF-000012', NULL, 'DNA-directed RNA polymerase subunit', 119, NULL, NULL, 41827),
(41828, '2.130.10.10-FF-005138', NULL, 'WD repeat-containing protein 19-like Protein', 100, NULL, NULL, 41828),
(41829, '3.40.50.10140-FF-000034', NULL, 'Tehao', 112, NULL, NULL, 41829),
(41830, '3.80.10.10-FF-003401', NULL, 'Uncharacterized protein', 92, NULL, NULL, 41830),
(41831, '3.40.50.2300-FF-001600', NULL, NULL, 88, NULL, NULL, 41831),
(41832, '3.60.21.60-FF-000036', NULL, 'DNA polymerase alpha subunit B', 214, NULL, NULL, 41832),
(41833, '3.20.20.190-FF-000157', NULL, NULL, 192, NULL, NULL, 41833),
(41834, '1.20.58.340-FF-000018', NULL, 'Magnesium transport protein CorA', 58, NULL, NULL, 41834),
(41835, '2.60.40.10-FF-003474', NULL, NULL, 98, NULL, NULL, 41835),
(41836, '3.40.50.300-FF-005189', NULL, 'ATP-dependent dethiobiotin synthetase BioD', 214, NULL, NULL, 41836);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(41837, '3.30.499.10-FF-000002', NULL, 'Aconitate hydratase', 366, NULL, NULL, 41837),
(41838, '1.10.472.10-FF-000031', NULL, 'cyclin-L1-1-like isoform X1', 101, NULL, NULL, 41838),
(41839, '3.40.50.1820-FF-001220', NULL, 'Gastric triacylglycerol lipase, putative', 358, NULL, NULL, 41839),
(41840, '1.20.120.900-FF-000006', NULL, 'Peroxin 19', 114, NULL, NULL, 41840),
(41841, '2.70.98.30-FF-000009', NULL, 'Alpha-mannosidase', 288, NULL, NULL, 41841),
(41842, '3.40.50.10130-FF-000031', NULL, 'Probable crossover junction endonuclease EME2', 223, NULL, NULL, 41842),
(41843, '3.30.470.20-FF-000248', NULL, 'Uncharacterized protein', 50, NULL, NULL, 41843),
(41844, '1.10.8.60-FF-000365', NULL, 'Predicted protein', 90, NULL, NULL, 41844),
(41845, '3.30.420.40-FF-001049', NULL, 'Actin-related protein 8', 230, NULL, NULL, 41845),
(41846, '4.10.280.10-FF-000214', NULL, 'MLX-interacting protein-like protein', 49, NULL, NULL, 41846),
(41847, '3.40.50.1820-FF-000944', NULL, 'Protein phosphatase methylesterase 1', 305, NULL, NULL, 41847),
(41848, '1.20.1110.10-FF-000143', NULL, 'Calcium-translocating P-type ATPase, PMCA-type', 400, NULL, NULL, 41848),
(41849, '1.50.40.10-FF-000076', NULL, 'Mitochondrial phosphate carrier protein 2', 110, NULL, NULL, 41849),
(41850, '1.10.1200.270-FF-000010', NULL, 'Predicted protein', 130, NULL, NULL, 41850),
(41851, '1.10.10.10-FF-001425', NULL, 'Putative transcriptional regulator, LuxR family', 64, NULL, NULL, 41851),
(41852, '1.25.10.10-FF-001717', NULL, 'UTP20 small subunit (SSU) processome component', 224, NULL, NULL, 41852),
(41853, '1.10.565.10-FF-000180', NULL, 'Hepatic nuclear factor 4, beta', 135, NULL, NULL, 41853),
(41854, '3.90.70.10-FF-000122', NULL, 'Ubiquitin carboxyl-terminal hydrolase 2', 114, NULL, NULL, 41854),
(41855, '2.170.300.10-FF-000069', NULL, 'Laminin subunit alpha-1-like Protein', 76, NULL, NULL, 41855),
(41856, '2.30.30.1020-FF-000027', NULL, 'Protein CBR-TAG-153', 234, NULL, NULL, 41856),
(41857, '3.40.50.620-FF-000625', NULL, 'FAD synthase', 104, NULL, NULL, 41857),
(41858, '3.40.50.10880-FF-000014', NULL, NULL, 77, NULL, NULL, 41858),
(41859, '3.30.70.80-FF-000033', NULL, 'Predicted protein', 101, NULL, NULL, 41859),
(41860, '3.30.505.10-FF-000220', NULL, NULL, 104, NULL, NULL, 41860),
(41861, '3.30.930.10-FF-000163', NULL, 'Lysine--tRNA ligase', 374, NULL, NULL, 41861),
(41862, '3.40.50.300-FF-006032', NULL, 'DNA helicase', 198, NULL, NULL, 41862),
(41863, '3.10.290.70-FF-000017', NULL, NULL, 89, NULL, NULL, 41863),
(41864, '2.40.420.20-FF-000027', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 101, NULL, NULL, 41864),
(41865, '1.10.8.530-FF-000005', NULL, 'DNA polymerase alpha subunit B', 78, NULL, NULL, 41865),
(41866, '3.30.40.10-FF-000573', NULL, 'CDK-activating kinase assembly factor', 64, NULL, NULL, 41866),
(41867, '3.30.505.10-FF-000214', NULL, NULL, 109, NULL, NULL, 41867),
(41868, '3.40.50.2300-FF-001246', NULL, NULL, 30, NULL, NULL, 41868),
(41869, '2.40.50.140-FF-001064', NULL, NULL, 99, NULL, NULL, 41869),
(41870, '3.40.710.10-FF-000144', NULL, 'D-alanyl-D-alanine carboxypeptidase', 254, NULL, NULL, 41870),
(41871, '3.40.50.360-FF-000058', NULL, 'Sulfite reductase (NADPH) hemoprotein, beta-component', 172, NULL, NULL, 41871),
(41872, '1.10.260.100-FF-000007', NULL, 'hsc70-interacting protein-like isoform X1', 58, NULL, NULL, 41872),
(41873, '3.40.50.200-FF-000038', NULL, 'Clan SB, family S8, subtilisin-like serine peptidase', 350, NULL, NULL, 41873),
(41874, '1.50.40.10-FF-000514', NULL, 'Uncharacterized protein', 195, NULL, NULL, 41874),
(41875, '1.20.120.1010-FF-000001', NULL, 'Sumoylation ligase MMS21', 191, NULL, NULL, 41875),
(41876, '2.160.20.80-FF-000021', NULL, NULL, 89, NULL, NULL, 41876),
(41877, '3.30.40.10-FF-001174', NULL, 'Ring finger protein 138', 78, NULL, NULL, 41877),
(41878, '1.25.40.10-FF-001225', NULL, 'Pentatricopeptide repeat-containing protein', 130, NULL, NULL, 41878),
(41879, '2.10.60.10-FF-000015', NULL, 'Urokinase plasminogen activator surface receptor', 93, NULL, NULL, 41879),
(41880, '3.40.50.2300-FF-001151', NULL, NULL, 142, NULL, NULL, 41880);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(41881, '4.10.1000.10-FF-000129', NULL, 'Uncharacterized protein', 26, NULL, NULL, 41881),
(41882, '3.80.10.10-FF-004149', NULL, 'Uncharacterized protein', 107, NULL, NULL, 41882),
(41883, '3.40.50.2020-FF-000072', NULL, 'Uncharacterized protein, isoform I', 107, NULL, NULL, 41883),
(41884, '3.40.50.300-FF-001827', NULL, 'Septin', 359, NULL, NULL, 41884),
(41885, '3.40.50.11990-FF-000010', NULL, 'Uncharacterized protein Ca49C10.12c', 170, NULL, NULL, 41885),
(41886, '3.80.10.10-FF-001501', NULL, 'Insulin-like growth factor-binding protein complex acid labile subunit', 119, NULL, NULL, 41886),
(41887, '1.10.3380.10-FF-000053', NULL, 'AGAP009060-PA', 159, NULL, NULL, 41887),
(41888, '3.30.460.10-FF-000188', NULL, 'Uncharacterized protein', 193, NULL, NULL, 41888),
(41889, '3.40.50.300-FF-000630', NULL, 'ATP-binding cassette (ABC) transporter, putative', 251, NULL, NULL, 41889),
(41890, '1.10.510.10-FF-002402', NULL, NULL, 109, NULL, NULL, 41890),
(41891, '2.130.10.10-FF-003564', NULL, 'Uncharacterized protein', 134, NULL, NULL, 41891),
(41892, '3.30.230.10-FF-000385', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 162, NULL, NULL, 41892),
(41893, '3.30.1360.40-FF-000037', NULL, 'Ribosome-recycling factor, mitochondrial', 76, NULL, NULL, 41893),
(41894, '1.10.472.80-FF-000142', NULL, 'Uncharacterized protein', 128, NULL, NULL, 41894),
(41895, '3.40.1350.60-FF-000012', NULL, 'Predicted protein', 60, NULL, NULL, 41895),
(41896, '3.40.50.300-FF-007555', NULL, 'Adenylate kinase 5', 191, NULL, NULL, 41896),
(41897, '3.40.50.300-FF-003856', NULL, 'Recombinase RecA', 187, NULL, NULL, 41897),
(41898, '3.90.190.10-FF-000581', NULL, 'Uncharacterized protein', 218, NULL, NULL, 41898),
(41899, '3.30.40.10-FF-001073', NULL, 'Ubiquitin-protein ligase', 75, NULL, NULL, 41899),
(41900, '2.10.25.10-FF-000990', NULL, 'Transmembrane matrix receptor MUP-4', 54, NULL, NULL, 41900),
(41901, '1.20.58.940-FF-000002', NULL, NULL, 61, NULL, NULL, 41901),
(41902, '3.30.70.330-FF-000808', NULL, 'Heterogeneous nuclear ribonucleoprotein Q isoform A', 179, NULL, NULL, 41902),
(41903, '2.30.30.100-FF-000179', NULL, 'Uncharacterized protein', 82, NULL, NULL, 41903),
(41904, '3.40.50.300-FF-007235', NULL, 'ATP-dependent DNA helicase', 161, NULL, NULL, 41904),
(41905, '1.20.1110.10-FF-000137', NULL, NULL, 27, NULL, NULL, 41905),
(41906, '3.30.450.20-FF-000606', NULL, 'Calcium voltage-gated channel auxiliary subunit alpha2delta 4', 73, NULL, NULL, 41906),
(41907, '1.10.287.70-FF-000523', NULL, 'Uncharacterized protein', 119, NULL, NULL, 41907),
(41908, '1.10.630.10-FF-000326', NULL, 'Uncharacterized protein', 160, NULL, NULL, 41908),
(41909, '2.130.10.10-FF-002041', NULL, 'AaceriADL184Wp', 205, NULL, NULL, 41909),
(41910, '3.40.720.10-FF-000072', NULL, 'GPI ethanolamine phosphate transferase 3,putative', 251, NULL, NULL, 41910),
(41911, '2.60.40.10-FF-000152', NULL, 'receptor-type tyrosine-protein phosphatase T isoform X1', 100, NULL, NULL, 41911),
(41912, '1.25.40.120-FF-000051', NULL, 'RAB geranylgeranyl transferase alpha subunit, putative', 95, NULL, NULL, 41912),
(41913, '3.40.50.1440-FF-000111', NULL, 'Tubulin alpha chain', 248, NULL, NULL, 41913),
(41914, '2.130.10.10-FF-001327', NULL, 'Ribosome biogenesis protein BOP1 homolog', 352, NULL, NULL, 41914),
(41915, '1.10.10.10-FF-001655', NULL, 'Uncharacterized protein', 73, NULL, NULL, 41915),
(41916, '1.10.287.70-FF-000298', NULL, 'Uncharacterized protein', 171, NULL, NULL, 41916),
(41917, '3.20.20.330-FF-000025', NULL, 'S-methylmethionine--homocysteine S-methyltransferase BHMT2 isoform X2', 210, NULL, NULL, 41917),
(41918, '3.10.50.10-FF-000029', NULL, 'Glycoside hydrolase', 108, NULL, NULL, 41918),
(41919, '3.30.1360.120-FF-000005', NULL, 'Aminomethyltransferase', 146, NULL, NULL, 41919),
(41920, '3.20.20.70-FF-000191', NULL, 'ribulose-phosphate 3-epimerase isoform X2', 228, NULL, NULL, 41920),
(41921, '2.60.40.10-FF-005048', NULL, NULL, 102, NULL, NULL, 41921),
(41922, '2.40.50.140-FF-000558', NULL, 'Primosomal replication protein N', 100, NULL, NULL, 41922);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(41923, '4.10.410.10-FF-000023', NULL, 'Axotactin, isoform D', 70, NULL, NULL, 41923),
(41924, '1.25.40.10-FF-001545', NULL, 'tetratricopeptide repeat protein 28', 91, NULL, NULL, 41924),
(41925, '1.20.58.1250-FF-000003', NULL, 'Tubulin-folding cofactor C', 117, NULL, NULL, 41925),
(41926, '2.60.40.10-FF-003586', NULL, NULL, 111, NULL, NULL, 41926),
(41927, '1.20.1110.10-FF-000042', NULL, 'Potassium/sodium P-type ATPase, putative', 389, NULL, NULL, 41927),
(41928, '3.30.200.20-FF-001403', NULL, 'Cyclin-dependent protein kinase-activating kinase', 100, NULL, NULL, 41928),
(41929, '2.60.120.10-FF-000109', NULL, 'Acyl-CoA thioesterase II', 124, NULL, NULL, 41929),
(41930, '3.20.20.80-FF-000194', NULL, 'Conserved exported protein of uncharacterized function', 209, NULL, NULL, 41930),
(41931, '3.40.50.1010-FF-000235', NULL, NULL, 69, NULL, NULL, 41931),
(41932, '3.40.50.11260-FF-000027', NULL, 'Os09g0474300 protein', 65, NULL, NULL, 41932),
(41933, '2.40.50.100-FF-000006', NULL, 'DNA-directed RNA polymerase subunit beta', 82, NULL, NULL, 41933),
(41934, '3.30.300.20-FF-000040', NULL, 'Ribosome-binding factor A', 118, NULL, NULL, 41934),
(41935, '2.60.40.10-FF-005727', NULL, NULL, 141, NULL, NULL, 41935),
(41936, '2.60.40.1730-FF-000082', NULL, NULL, 69, NULL, NULL, 41936),
(41937, '3.80.10.10-FF-000990', NULL, '187-kDa microtubule-associated protein AIR9', 80, NULL, NULL, 41937),
(41938, '3.30.365.10-FF-000017', NULL, 'Xanthine dehydrogenase yagR molybdenum-binding subunit', 93, NULL, NULL, 41938),
(41939, '1.10.510.10-FF-001885', NULL, 'Ribosomal protein S6 kinase', 192, NULL, NULL, 41939),
(41940, '1.10.287.130-FF-000165', NULL, 'Two-component hybrid sensor and regulator', 110, NULL, NULL, 41940),
(41941, '1.10.287.70-FF-000309', NULL, 'Uncharacterized protein', 167, NULL, NULL, 41941),
(41942, '1.10.10.60-FF-000799', NULL, NULL, 60, NULL, NULL, 41942),
(41943, '1.10.1740.10-FF-000007', NULL, 'RNA polymerase sigma factor SigE', 103, NULL, NULL, 41943),
(41944, '3.30.160.60-FF-005273', NULL, NULL, 93, NULL, NULL, 41944),
(41945, '3.60.130.10-FF-000073', NULL, 'Uncharacterized protein', 105, NULL, NULL, 41945),
(41946, '3.40.50.1820-FF-000832', NULL, 'Chromosome 1, whole genome shotgun sequence', 242, NULL, NULL, 41946),
(41947, '3.40.50.1000-FF-000114', NULL, 'Phosphoserine phosphatase, chloroplastic', 56, NULL, NULL, 41947),
(41948, '1.20.58.60-FF-000728', NULL, 'Uncharacterized protein', 105, NULL, NULL, 41948),
(41949, '2.40.50.690-FF-000020', NULL, 'Exosome complex exonuclease RRP44', 111, NULL, NULL, 41949),
(41950, '3.20.70.20-FF-000038', NULL, 'Ribonucleoside-diphosphate reductase nrdEB subunit alpha', 375, NULL, NULL, 41950),
(41951, '3.10.580.10-FF-000117', NULL, 'CBS-domain containing protein', 152, NULL, NULL, 41951),
(41952, '1.10.8.60-FF-000045', NULL, 'Anaerobic nitric oxide reductase transcription regulator NorR', 81, NULL, NULL, 41952),
(41953, '3.80.10.10-FF-004262', NULL, 'EIN3-binding F-box protein 1', 63, NULL, NULL, 41953),
(41954, '2.130.10.10-FF-003901', NULL, 'Transducin family protein / WD-40 repeat family protein', 271, NULL, NULL, 41954),
(41955, '3.40.50.450-FF-000107', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit alpha 2', 143, NULL, NULL, 41955),
(41956, '2.60.40.10-FF-001675', NULL, 'Endothelial cell-selective adhesion molecule', 121, NULL, NULL, 41956),
(41957, '3.40.33.10-FF-000022', NULL, 'peptidase inhibitor 15', 206, NULL, NULL, 41957),
(41958, '2.60.40.60-FF-000021', NULL, 'FAT atypical cadherin 1', 101, NULL, NULL, 41958),
(41959, '3.40.50.200-FF-000151', NULL, 'Uncharacterized protein', 333, NULL, NULL, 41959),
(41960, '3.40.50.1000-FF-000232', NULL, 'Trehalose-phosphatase', 90, NULL, NULL, 41960),
(41961, '1.10.510.10-FF-003246', NULL, NULL, 117, NULL, NULL, 41961),
(41962, '2.130.10.10-FF-001535', NULL, 'Intraflagellar transport protein 172 homolog', 219, NULL, NULL, 41962),
(41963, '3.40.50.720-FF-000981', NULL, '3-hydroxybutyrate dehydrogenase', 257, NULL, NULL, 41963),
(41964, '3.40.50.1460-FF-000117', NULL, 'Caspase-like Protein', 279, NULL, NULL, 41964);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(41965, '3.30.1120.30-FF-000045', NULL, 'Serine/threonine-protein kinase PLK', 98, NULL, NULL, 41965),
(41966, '3.30.160.20-FF-000163', NULL, 'Uncharacterized protein', 65, NULL, NULL, 41966),
(41967, '1.10.10.440-FF-000015', NULL, 'pre-mRNA-processing factor 40 homolog B isoform X2', 67, NULL, NULL, 41967),
(41968, '2.130.10.10-FF-001647', NULL, 'Unplaced genomic scaffold supercont1.83, whole genome shotgun sequence', 85, NULL, NULL, 41968),
(41969, '1.10.8.10-FF-000154', NULL, 'NSFL1 cofactor p47', 43, NULL, NULL, 41969),
(41970, '3.30.200.20-FF-000785', NULL, 'Protein kinase superfamily protein', 94, NULL, NULL, 41970),
(41971, '3.40.33.10-FF-000117', NULL, 'Golgi-associated plant pathogenesis-related protein 1', 147, NULL, NULL, 41971),
(41972, '2.30.42.10-FF-000467', NULL, NULL, 88, NULL, NULL, 41972),
(41973, '3.20.20.100-FF-000193', NULL, 'Alcohol dehydrogenase [NADP(+)] A-like Protein', 92, NULL, NULL, 41973),
(41974, '3.40.50.1010-FF-000117', NULL, 'Posttranscriptional regulation nuclease (Mkt1), putative (AFU_orthologue AFUA_5G12250)', 210, NULL, NULL, 41974),
(41975, '3.90.70.80-FF-000093', NULL, 'Uncharacterized protein', 156, NULL, NULL, 41975),
(41976, '3.10.580.10-FF-000022', NULL, 'Cystathionine beta-synthase Cbs', 130, NULL, NULL, 41976),
(41977, '4.10.240.10-FF-000217', NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', 50, NULL, NULL, 41977),
(41978, '3.40.50.300-FF-000310', NULL, 'RuvB-like helicase', 193, NULL, NULL, 41978),
(41979, '3.40.50.150-FF-000012', NULL, 'tRNA/tmRNA (uracil-C(5))-methyltransferase', 203, NULL, NULL, 41979),
(41980, '1.10.3520.10-FF-000031', NULL, 'Uncharacterized protein', 136, NULL, NULL, 41980),
(41981, '3.40.50.300-FF-000422', NULL, 'Guanylate-binding protein 1', 281, NULL, NULL, 41981),
(41982, '3.30.1490.180-FF-000041', NULL, 'DNA-directed RNA polymerase subunit', 59, NULL, NULL, 41982),
(41983, '1.10.260.40-FF-000054', NULL, 'POU domain protein', 91, NULL, NULL, 41983),
(41984, '3.40.30.10-FF-000083', NULL, 'Thiol:disulfide interchange protein', 159, NULL, NULL, 41984),
(41985, '1.20.1310.20-FF-000026', NULL, 'Erythrocyte binding ligand-1', 196, NULL, NULL, 41985),
(41986, '3.30.260.10-FF-000095', NULL, NULL, 81, NULL, NULL, 41986),
(41987, '2.60.120.290-FF-000173', NULL, 'Fibropellin-1', 118, NULL, NULL, 41987),
(41988, '2.40.170.20-FF-000131', NULL, NULL, 279, NULL, NULL, 41988),
(41989, '3.60.21.10-FF-000403', NULL, 'Serine/threonine protein phosphatase, putative', 304, NULL, NULL, 41989),
(41990, '2.60.40.10-FF-000360', NULL, 'Sidekick cell adhesion molecule 2', 109, NULL, NULL, 41990),
(41991, '1.25.40.10-FF-000022', NULL, 'lysine-specific demethylase 6A isoform X1', 185, NULL, NULL, 41991),
(41992, '3.40.50.150-FF-000107', NULL, 'tRNA 5-methylaminomethyl-2-thiouridine biosynthesis bifunctional protein MnmC', 241, NULL, NULL, 41992),
(41993, '3.40.190.10-FF-000856', NULL, 'Uncharacterized protein', 60, NULL, NULL, 41993),
(41994, '2.40.50.140-FF-000890', NULL, NULL, 86, NULL, NULL, 41994),
(41995, '3.30.900.10-FF-000009', NULL, 'Meiosis-specific protein ASY2', 269, NULL, NULL, 41995),
(41996, '3.30.450.40-FF-000230', NULL, 'Heat-inducible transcription repressor HrcA', 158, NULL, NULL, 41996),
(41997, '3.40.1110.10-FF-000261', NULL, 'Phospholipid-transporting ATPase', 180, NULL, NULL, 41997),
(41998, '1.20.5.170-FF-000075', NULL, 'BZIP transcription factor (MetR)', 72, NULL, NULL, 41998),
(41999, '1.10.510.10-FF-003925', NULL, NULL, 74, NULL, NULL, 41999),
(42000, '2.10.25.10-FF-000563', NULL, 'Wall-associated receptor kinase-like 8', 39, NULL, NULL, 42000),
(42001, '1.25.40.20-FF-000025', NULL, 'GA-binding protein subunit beta-1 isoform X1', 153, NULL, NULL, 42001),
(42002, '1.25.10.10-FF-001622', NULL, 'Uncharacterized protein', 1070, NULL, NULL, 42002),
(42003, '2.40.50.140-FF-001159', NULL, NULL, 83, NULL, NULL, 42003),
(42004, '3.40.50.360-FF-000171', NULL, 'Uncharacterized protein', 180, NULL, NULL, 42004),
(42005, '3.60.10.10-FF-000148', NULL, 'DNA-(Apurinic or apyrimidinic site) lyase,putative', 250, NULL, NULL, 42005);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(42006, '3.80.10.10-FF-002671', NULL, 'Predicted protein', 139, NULL, NULL, 42006),
(42007, '3.30.160.60-FF-004300', NULL, NULL, 72, NULL, NULL, 42007),
(42008, '3.80.10.10-FF-004363', NULL, 'NLR family, pyrin domain-containing 12', 175, NULL, NULL, 42008),
(42009, '2.30.30.140-FF-000264', NULL, 'Histone acetyltransferase', 140, NULL, NULL, 42009),
(42010, '3.10.20.110-FF-000001', NULL, 'Protective antigen', 119, NULL, NULL, 42010),
(42011, '1.20.1270.280-FF-000023', NULL, 'Dynein-1-beta heavy chain, flagellar inner arm I1 complex', 170, NULL, NULL, 42011),
(42012, '1.10.630.10-FF-000534', NULL, 'Uncharacterized protein', 374, NULL, NULL, 42012),
(42013, '3.40.50.2000-FF-000656', NULL, 'Glycosyltransferase', 237, NULL, NULL, 42013),
(42014, '3.30.200.20-FF-001280', NULL, 'Mitogen-activated protein kinase kinase kinase kinase 4', 68, NULL, NULL, 42014),
(42015, '3.40.250.10-FF-000114', NULL, 'Predicted protein', 153, NULL, NULL, 42015),
(42016, '3.30.9.10-FF-000163', NULL, 'Uncharacterized protein', 42, NULL, NULL, 42016),
(42017, '3.30.70.330-FF-001409', NULL, 'la-related protein 7', 111, NULL, NULL, 42017),
(42018, '3.30.70.340-FF-000002', NULL, 'Carboxypeptidase A', 87, NULL, NULL, 42018),
(42019, '1.25.40.10-FF-003574', NULL, 'Protein TONSOKU', 188, NULL, NULL, 42019),
(42020, '1.10.1520.10-FF-000025', NULL, 'Unplaced genomic scaffold supercont1.15, whole genome shotgun sequence', 171, NULL, NULL, 42020),
(42021, '2.60.40.10-FF-003709', NULL, NULL, 88, NULL, NULL, 42021),
(42022, '2.10.25.10-FF-000658', NULL, 'cubilin', 67, NULL, NULL, 42022),
(42023, '1.20.5.110-FF-000208', NULL, 'Protein CBR-SYX-4', 104, NULL, NULL, 42023),
(42024, '3.30.40.10-FF-001410', NULL, 'Uncharacterized protein', 84, NULL, NULL, 42024),
(42025, '2.130.10.10-FF-002142', NULL, 'Uncharacterized protein', 86, NULL, NULL, 42025),
(42026, '1.20.120.350-FF-000010', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 138, NULL, NULL, 42026),
(42027, '3.40.50.300-FF-005644', NULL, 'Uncharacterized protein', 225, NULL, NULL, 42027),
(42028, '1.25.40.10-FF-004991', NULL, 'Uncharacterized protein', 255, NULL, NULL, 42028),
(42029, '2.60.40.10-FF-001557', NULL, 'Echinoid, isoform C', 115, NULL, NULL, 42029),
(42030, '3.40.20.10-FF-000155', NULL, 'Cofilin-5', 117, NULL, NULL, 42030),
(42031, '3.40.50.800-FF-000123', NULL, 'Histidyl-tRNA synthetase', 64, NULL, NULL, 42031),
(42032, '3.30.40.10-FF-000359', NULL, 'E3 ubiquitin-protein ligase At3g02290-like', 71, NULL, NULL, 42032),
(42033, '3.30.750.24-FF-000179', NULL, 'Solute carrier family 26 member 9', 100, NULL, NULL, 42033),
(42034, '3.30.450.270-FF-000005', NULL, 'Bacteriophytochrome (Light-regulated signal transduction histidine kinase), PhyB2', 138, NULL, NULL, 42034),
(42035, '1.10.10.160-FF-000027', NULL, 'RecBCD enzyme subunit RecC', 99, NULL, NULL, 42035),
(42036, '2.60.200.40-FF-000046', NULL, 'Ceramide kinase-like isoform 14', 148, NULL, NULL, 42036),
(42037, '3.30.70.3310-FF-000006', NULL, 'Protein glp-1', 150, NULL, NULL, 42037),
(42038, '3.40.50.11830-FF-000001', NULL, 'Transcriptional activator CadC', 161, NULL, NULL, 42038),
(42039, '3.40.50.300-FF-005874', NULL, 'ATP-dependent DNA helicase CHL1', 182, NULL, NULL, 42039),
(42040, '3.30.572.10-FF-000015', NULL, 'Thymidylate synthase', 287, NULL, NULL, 42040),
(42041, '3.30.450.260-FF-000002', NULL, 'guanylate cyclase soluble subunit alpha-2', 128, NULL, NULL, 42041),
(42042, '4.10.240.10-FF-000195', NULL, 'Putative transcription factor with C2H2 and Zn(2)-Cys(6) DNA binding domain (Eurofung)', 30, NULL, NULL, 42042),
(42043, '2.60.200.30-FF-000043', NULL, 'Uncharacterized protein', 126, NULL, NULL, 42043),
(42044, '3.40.50.300-FF-008050', NULL, 'Uncharacterized protein', 127, NULL, NULL, 42044),
(42045, '3.50.50.60-FF-001520', NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', 229, NULL, NULL, 42045),
(42046, '1.25.40.420-FF-000045', NULL, 'Uncharacterized protein', 50, NULL, NULL, 42046),
(42047, '1.10.565.10-FF-000062', NULL, 'Nuclear Hormone Receptor family', 253, NULL, NULL, 42047);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(42048, '1.10.1040.10-FF-000095', NULL, 'Probable 2-dehydropantoate 2-reductase', 123, NULL, NULL, 42048),
(42049, '3.30.70.330-FF-001281', NULL, 'Cold-shock DEAD-box protein A', 75, NULL, NULL, 42049),
(42050, '1.25.40.10-FF-005036', NULL, 'AGAP000136-PA', 133, NULL, NULL, 42050),
(42051, '3.40.50.11850-FF-000007', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', 113, NULL, NULL, 42051),
(42052, '1.20.5.650-FF-000005', NULL, 'Transcription factor TFIIIB complex subunit Brf1, putative', 62, NULL, NULL, 42052),
(42053, '2.60.120.290-FF-000184', NULL, 'Uncharacterized protein', 103, NULL, NULL, 42053),
(42054, '3.40.710.10-FF-000032', NULL, 'Penicillin-binding protein 3', 332, NULL, NULL, 42054),
(42055, '3.30.160.60-FF-005823', NULL, NULL, 22, NULL, NULL, 42055),
(42056, '1.20.1070.10-FF-000229', NULL, 'Gastric inhibitory polypeptide receptor', 308, NULL, NULL, 42056),
(42057, '3.80.10.10-FF-001035', NULL, 'GH20134p', 228, NULL, NULL, 42057),
(42058, '2.60.120.10-FF-000227', NULL, 'Crp/Fnr family transcriptional regulator', 218, NULL, NULL, 42058),
(42059, '3.30.160.60-FF-003923', NULL, NULL, 80, NULL, NULL, 42059),
(42060, '3.40.50.1820-FF-000259', NULL, 'Lysophospholipase L2', 262, NULL, NULL, 42060),
(42061, '3.40.605.10-FF-000113', NULL, 'Delta-1-pyrroline-5-carboxylate synthase', 129, NULL, NULL, 42061),
(42062, '1.20.1250.20-FF-001044', NULL, 'Solute carrier family 49 member 4 homolog', 212, NULL, NULL, 42062),
(42063, '1.20.5.5160-FF-000002', NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', 55, NULL, NULL, 42063),
(42064, '3.30.160.60-FF-003569', NULL, 'zinc finger protein 287 isoform X1', 26, NULL, NULL, 42064),
(42065, '1.20.58.60-FF-000841', NULL, 'Spectrin repeat containing nuclear envelope protein 2', 150, NULL, NULL, 42065),
(42066, '1.25.40.10-FF-005266', NULL, 'Uncharacterized protein', 153, NULL, NULL, 42066),
(42067, '2.10.25.10-FF-000097', NULL, 'Fibrillin 2', 67, NULL, NULL, 42067),
(42068, '3.30.930.10-FF-000275', NULL, 'Lysine--tRNA ligase', 370, NULL, NULL, 42068),
(42069, '3.30.9.10-FF-000264', NULL, 'FAD-dependent catabolic D-arginine dehydrogenase DauA', 150, NULL, NULL, 42069),
(42070, '3.20.20.380-FF-000012', NULL, 'Uncharacterized protein', 205, NULL, NULL, 42070),
(42071, '3.40.850.10-FF-000194', NULL, 'AaceriADR145Cp', 351, NULL, NULL, 42071),
(42072, '3.30.565.10-FF-000212', NULL, 'Sensor histidine kinase', 159, NULL, NULL, 42072),
(42073, '3.40.720.10-FF-000190', NULL, 'Uncharacterized protein', 147, NULL, NULL, 42073),
(42074, '2.10.70.10-FF-000061', NULL, 'Pappalysin 1', 62, NULL, NULL, 42074),
(42075, '3.40.50.11840-FF-000004', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 2', 98, NULL, NULL, 42075),
(42076, '2.30.30.40-FF-000330', NULL, 'Purine-binding chemotaxis protein CheW', 56, NULL, NULL, 42076),
(42077, '3.40.50.300-FF-006150', NULL, 'Zgc:113442', 190, NULL, NULL, 42077),
(42078, '3.40.50.80-FF-000195', NULL, 'YALI0F01386p', 127, NULL, NULL, 42078),
(42079, '3.10.105.10-FF-000003', NULL, 'Glutathione ABC transporter substrate-binding protein GsiB', 214, NULL, NULL, 42079),
(42080, '1.20.1250.20-FF-000768', NULL, 'Solute carrier organic anion transporter family member', 270, NULL, NULL, 42080),
(42081, '3.40.50.300-FF-004121', NULL, 'tRNA modification GTPase MnmE', 167, NULL, NULL, 42081),
(42082, '3.30.160.20-FF-000152', NULL, 'Dicer-like 4', 77, NULL, NULL, 42082),
(42083, '1.25.40.10-FF-002040', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 101, NULL, NULL, 42083),
(42084, '3.40.710.10-FF-000133', NULL, 'Peptidase M15', 267, NULL, NULL, 42084),
(42085, '3.90.1200.10-FF-000059', NULL, 'Predicted protein', 163, NULL, NULL, 42085),
(42086, '2.60.40.10-FF-003811', NULL, NULL, 91, NULL, NULL, 42086),
(42087, '3.40.50.300-FF-002108', NULL, 'ATP-binding cassette sub-family F member 1', 273, NULL, NULL, 42087),
(42088, '1.25.40.10-FF-002973', NULL, 'Pentatricopeptide repeat-containing protein', 164, NULL, NULL, 42088),
(42089, '3.30.160.60-FF-003682', NULL, NULL, 31, NULL, NULL, 42089),
(42090, '3.30.70.330-FF-001522', NULL, 'RNA-binding domain-containing protein', 177, NULL, NULL, 42090);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(42091, '1.20.120.1080-FF-000084', NULL, 'Let-355 protein', 119, NULL, NULL, 42091),
(42092, '3.20.20.140-FF-000412', NULL, 'TatD related DNase', 86, NULL, NULL, 42092),
(42093, '3.20.20.80-FF-000755', NULL, 'Uncharacterized protein', 353, NULL, NULL, 42093),
(42094, '3.40.50.1820-FF-000591', NULL, 'Serine carboxypeptidase, putative', 239, NULL, NULL, 42094),
(42095, '2.10.270.10-FF-000013', NULL, 'Dextransucrase', 127, NULL, NULL, 42095),
(42096, '3.30.460.10-FF-000076', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 236, NULL, NULL, 42096),
(42097, '3.40.50.720-FF-001610', NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', 138, NULL, NULL, 42097),
(42098, '1.20.1250.20-FF-000870', NULL, 'MFS transporter', 210, NULL, NULL, 42098),
(42099, '2.60.120.330-FF-000005', NULL, '1-aminocyclopropane-1-carboxylate oxidase homolog 1', 329, NULL, NULL, 42099),
(42100, '2.60.120.920-FF-000204', NULL, 'Si:dkey-56m15.9', 89, NULL, NULL, 42100),
(42101, '3.30.160.60-FF-002400', NULL, 'Uncharacterized protein', 24, NULL, NULL, 42101),
(42102, '3.80.10.10-FF-002463', NULL, 'Si:ch211-214b16.3', 79, NULL, NULL, 42102),
(42103, '1.10.3520.10-FF-000042', NULL, 'pleckstrin homology domain-containing family A member 8 isoform X1', 225, NULL, NULL, 42103),
(42104, '3.40.50.720-FF-000992', NULL, 'Oxidoreductase', 252, NULL, NULL, 42104),
(42105, '3.30.160.60-FF-001669', NULL, 'Uncharacterized protein, isoform B', 30, NULL, NULL, 42105),
(42106, '3.20.10.10-FF-000043', NULL, 'Branched-chain amino acid aminotransferase', 150, NULL, NULL, 42106),
(42107, '2.60.120.10-FF-000340', NULL, 'Mannose-6-phosphate isomerase', 67, NULL, NULL, 42107),
(42108, '3.40.50.2000-FF-000448', NULL, 'UDP-glucoronosyl and UDP-glucosyl transferase family protein', 181, NULL, NULL, 42108),
(42109, '1.50.10.10-FF-000018', NULL, 'Glucoamylase', 472, NULL, NULL, 42109),
(42110, '2.60.120.320-FF-000002', NULL, 'Thiamine pyrophosphokinase', 83, NULL, NULL, 42110),
(42111, '1.20.1110.10-FF-000031', NULL, 'Calcium-transporting ATPase 1', 48, NULL, NULL, 42111),
(42112, '3.40.50.1100-FF-000032', NULL, 'Cysteine synthase B', 191, NULL, NULL, 42112),
(42113, '1.25.40.180-FF-000271', NULL, NULL, 191, NULL, NULL, 42113),
(42114, '2.20.100.10-FF-000196', NULL, 'Uncharacterized protein', 51, NULL, NULL, 42114),
(42115, '1.10.287.70-FF-000629', NULL, 'Uncharacterized protein', 208, NULL, NULL, 42115),
(42116, '3.40.605.10-FF-000012', NULL, 'NAD-dependent succinate-semialdehyde dehydrogenase', 258, NULL, NULL, 42116),
(42117, '3.30.559.10-FF-000283', NULL, 'Uncharacterized protein', 114, NULL, NULL, 42117),
(42118, '2.130.10.10-FF-005930', NULL, 'Uncharacterized protein', 268, NULL, NULL, 42118),
(42119, '3.40.50.1110-FF-000035', NULL, 'Acyl-CoA thioesterase', 184, NULL, NULL, 42119),
(42120, '3.30.230.10-FF-000267', NULL, 'Diphosphomevalonate decarboxylase', 195, NULL, NULL, 42120),
(42121, '1.25.10.10-FF-000071', NULL, 'Coatomer subunit gamma', 211, NULL, NULL, 42121),
(42122, '2.60.40.420-FF-000175', NULL, 'Aspergillus niger contig An12c0160, genomic contig', 152, NULL, NULL, 42122),
(42123, '2.30.29.30-FF-000599', NULL, 'AGAP011491-PA', 109, NULL, NULL, 42123),
(42124, '1.10.10.10-FF-001537', NULL, 'C-type lectin', 87, NULL, NULL, 42124),
(42125, '3.80.10.10-FF-000759', NULL, 'Leucine-rich repeat receptor protein kinase EMS1', 260, NULL, NULL, 42125),
(42126, '3.40.30.10-FF-000324', NULL, 'Iodothyronine deiodinase', 126, NULL, NULL, 42126),
(42127, '3.60.10.10-FF-000047', NULL, 'Deoxyribonuclease', 255, NULL, NULL, 42127),
(42128, '1.10.472.80-FF-000024', NULL, 'TBC1 domain family member 20', 135, NULL, NULL, 42128),
(42129, '1.10.8.60-FF-000253', NULL, 'GM14642', 50, NULL, NULL, 42129),
(42130, '2.10.270.10-FF-000002', NULL, 'NLP/P60 protein', 44, NULL, NULL, 42130),
(42131, '3.20.20.190-FF-000045', NULL, 'Glycerophosphodiester phosphodiesterase', 189, NULL, NULL, 42131),
(42132, '1.10.510.10-FF-001565', NULL, 'WNK protein kinase', 183, NULL, NULL, 42132),
(42133, '1.20.5.640-FF-000002', NULL, 'Transcriptional regulator, IclR family', 12, NULL, NULL, 42133);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(42134, '3.30.70.2630-FF-000004', NULL, 'Telomerase reverse transcriptase', 66, NULL, NULL, 42134),
(42135, '2.60.40.10-FF-001911', NULL, 'Titin', 91, NULL, NULL, 42135),
(42136, '1.10.238.10-FF-000330', NULL, 'Putative calcium-binding protein CML41', 87, NULL, NULL, 42136),
(42137, '3.90.70.10-FF-000010', NULL, 'Calpain 15', 132, NULL, NULL, 42137),
(42138, '2.10.25.10-FF-000552', NULL, 'Basement membrane proteoglycan', 49, NULL, NULL, 42138),
(42139, '2.30.29.30-FF-000392', NULL, 'Signal transducing adaptor family member 1', 145, NULL, NULL, 42139),
(42140, '1.20.1270.60-FF-000068', NULL, 'Islet cell autoantigen', 200, NULL, NULL, 42140),
(42141, '3.30.70.1230-FF-000034', NULL, 'Adenylyl cyclase beta', 184, NULL, NULL, 42141),
(42142, '2.130.10.10-FF-000012', NULL, 'Putative pleiotropic regulator 1', 334, NULL, NULL, 42142),
(42143, '1.20.1740.10-FF-000168', NULL, 'Uncharacterized protein', 57, NULL, NULL, 42143),
(42144, '2.40.240.10-FF-000027', NULL, 'Glutamine--tRNA ligase', 100, NULL, NULL, 42144),
(42145, '1.10.10.10-FF-000132', NULL, 'Histone acetyltransferase', 83, NULL, NULL, 42145),
(42146, '1.25.10.10-FF-003067', NULL, 'Exportin, putative', 264, NULL, NULL, 42146),
(42147, '1.20.5.170-FF-000176', NULL, 'Aureochrome 1', 68, NULL, NULL, 42147),
(42148, '2.60.40.10-FF-005840', NULL, NULL, 108, NULL, NULL, 42148),
(42149, '1.10.3210.10-FF-000041', NULL, 'GTP pyrophosphokinase', 179, NULL, NULL, 42149),
(42150, '3.30.1330.30-FF-000100', NULL, 'Uncharacterized protein', 93, NULL, NULL, 42150),
(42151, '2.60.120.200-FF-000764', NULL, 'Uncharacterized protein', 76, NULL, NULL, 42151),
(42152, '3.60.21.10-FF-000162', NULL, 'Sphingomyelin phosphodiesterase', 292, NULL, NULL, 42152),
(42153, '1.20.120.790-FF-000006', NULL, 'Chaperone protein HtpG', 134, NULL, NULL, 42153),
(42154, '1.20.1250.20-FF-002129', NULL, 'Uncharacterized MFS-type transporter C947.06c', 213, NULL, NULL, 42154),
(42155, '3.40.50.300-FF-005094', NULL, 'Predicted protein', 344, NULL, NULL, 42155),
(42156, '1.25.10.10-FF-001509', NULL, 'Protein phosphatase 4 regulatory subunit 1', 265, NULL, NULL, 42156),
(42157, '3.30.200.20-FF-001509', NULL, 'Mitogen-activated protein kinase 13', 31, NULL, NULL, 42157),
(42158, '6.10.140.2220-FF-000062', NULL, 'Uncharacterized protein', 64, NULL, NULL, 42158),
(42159, '2.40.150.20-FF-000023', NULL, 'Predicted protein', 120, NULL, NULL, 42159),
(42160, '3.90.245.10-FF-000012', NULL, 'Hydrolase, putative', 361, NULL, NULL, 42160),
(42161, '1.10.10.60-FF-000698', NULL, 'Anthocyanin regulatory C1 protein', 42, NULL, NULL, 42161),
(42162, '3.30.230.80-FF-000023', NULL, 'Heat shock protein 75 kDa, mitochondrial-like Protein', 117, NULL, NULL, 42162),
(42163, '3.50.50.60-FF-001065', NULL, 'Uncharacterized protein', 76, NULL, NULL, 42163),
(42164, '3.40.720.10-FF-000313', NULL, 'Uncharacterized protein', 207, NULL, NULL, 42164),
(42165, '3.30.70.330-FF-000685', NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', 90, NULL, NULL, 42165),
(42166, '1.20.5.110-FF-000085', NULL, '25.3 kDa vesicle transport protein-like isoform X2', 63, NULL, NULL, 42166),
(42167, '3.10.50.40-FF-000010', NULL, 'Peptidyl-prolyl cis-trans isomerase Pin1', 115, NULL, NULL, 42167),
(42168, '3.30.505.10-FF-000006', NULL, 'Phosphatidylinositol 3-kinase regulatory subunit alpha', 108, NULL, NULL, 42168),
(42169, '1.20.58.380-FF-000002', NULL, 'Flagellar protein FliT', 111, NULL, NULL, 42169),
(42170, '1.25.40.20-FF-001548', NULL, 'Uncharacterized protein', 114, NULL, NULL, 42170),
(42171, '3.40.50.1820-FF-001315', NULL, 'Uncharacterized protein', 261, NULL, NULL, 42171),
(42172, '3.40.50.720-FF-000099', NULL, 'Aspartate-semialdehyde dehydrogenase', 143, NULL, NULL, 42172),
(42173, '1.20.1280.50-FF-000026', NULL, 'F-box only protein 21 isoform X2', 93, NULL, NULL, 42173),
(42174, '3.80.10.10-FF-004469', NULL, 'Uncharacterized protein', 66, NULL, NULL, 42174),
(42175, '3.80.10.10-FF-000872', NULL, 'Protein NUD1', 149, NULL, NULL, 42175),
(42176, '2.60.40.10-FF-003356', NULL, NULL, 101, NULL, NULL, 42176),
(42177, '1.10.20.10-FF-000060', NULL, 'BTB domain containing 11', 141, NULL, NULL, 42177);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(42178, '4.10.830.40-FF-000013', NULL, NULL, 75, NULL, NULL, 42178),
(42179, '1.25.40.20-FF-001778', NULL, 'Uncharacterized protein', 185, NULL, NULL, 42179),
(42180, '3.40.630.30-FF-000312', NULL, 'AANAT (Arylalkylamine N-AcetylTransferase) homolog', 227, NULL, NULL, 42180),
(42181, '3.30.70.330-FF-001168', NULL, 'Nuclear RNA export factor 1', 104, NULL, NULL, 42181),
(42182, '3.90.190.10-FF-000373', NULL, 'Protein-tyrosine-phosphatase PTP1', 176, NULL, NULL, 42182),
(42183, '4.10.410.10-FF-000034', NULL, 'CBN-MEC-1 protein', 66, NULL, NULL, 42183),
(42184, '1.25.10.10-FF-001386', NULL, 'Polyubiquitin binding protein, putative', 284, NULL, NULL, 42184),
(42185, '3.50.50.60-FF-000789', NULL, 'YALI0B23430p', 212, NULL, NULL, 42185),
(42186, '2.130.10.10-FF-003665', NULL, 'Uncharacterized protein', 321, NULL, NULL, 42186),
(42187, '3.40.1110.10-FF-000272', NULL, NULL, 197, NULL, NULL, 42187),
(42188, '2.40.50.140-FF-000996', NULL, NULL, 92, NULL, NULL, 42188),
(42189, '3.30.300.20-FF-000039', NULL, 'Probable transcription termination protein NusA', 70, NULL, NULL, 42189),
(42190, '2.30.30.40-FF-000010', NULL, 'Tyrosine-protein kinase', 57, NULL, NULL, 42190),
(42191, '2.10.230.10-FF-000005', NULL, 'DnaJ homolog subfamily A member 1', 67, NULL, NULL, 42191),
(42192, '3.30.810.10-FF-000002', NULL, 'Phosphatidylinositol 4-phosphate 5-kinase type-1 gamma', 169, NULL, NULL, 42192),
(42193, '3.20.20.330-FF-000014', NULL, 'Os01g0772900 protein', 184, NULL, NULL, 42193),
(42194, '3.90.550.10-FF-000114', NULL, 'UTP--glucose-1-phosphate uridylyltransferase 3 chloroplastic', 456, NULL, NULL, 42194),
(42195, '1.20.140.10-FF-000056', NULL, 'Acyl-CoA dehydrogenase family member 9', 121, NULL, NULL, 42195),
(42196, '1.20.1250.20-FF-001033', NULL, 'Oligopeptide transporter, kidney isoform', 235, NULL, NULL, 42196),
(42197, '3.40.930.10-FF-000014', NULL, 'PTS system fructose-specific IIA component', 147, NULL, NULL, 42197),
(42198, '1.20.1070.10-FF-001044', NULL, 'AGAP002679-PA', 239, NULL, NULL, 42198),
(42199, '2.30.39.10-FF-000105', NULL, 'Serpin family B member 8', 99, NULL, NULL, 42199),
(42200, '1.10.510.10-FF-000250', NULL, 'Death-associated protein kinase 3', 206, NULL, NULL, 42200),
(42201, '2.40.50.140-FF-001053', NULL, NULL, 111, NULL, NULL, 42201),
(42202, '1.10.10.60-FF-001193', NULL, NULL, 89, NULL, NULL, 42202),
(42203, '3.10.580.10-FF-000128', NULL, 'CBS domain-containing protein', 112, NULL, NULL, 42203),
(42204, '1.10.10.750-FF-000007', NULL, 'TBC1 domain family member', 53, NULL, NULL, 42204),
(42205, '1.25.40.20-FF-001880', NULL, 'C2 domain containing protein', 123, NULL, NULL, 42205),
(42206, '2.40.420.20-FF-000016', NULL, 'Efflux transporter, RND family, MFP subunit', 90, NULL, NULL, 42206),
(42207, '3.30.40.10-FF-000814', NULL, 'Uncharacterized protein, isoform A', 77, NULL, NULL, 42207),
(42208, '3.40.50.300-FF-003845', NULL, 'GTP-binding protein Rheb homolog 1', 172, NULL, NULL, 42208),
(42209, '1.20.1560.10-FF-000755', NULL, 'p-glycoprotein 5 putative', 54, NULL, NULL, 42209),
(42210, '3.30.200.20-FF-001611', NULL, 'Uncharacterized protein', 100, NULL, NULL, 42210),
(42211, '1.20.58.60-FF-000487', NULL, 'AGAP004440-PC', 119, NULL, NULL, 42211),
(42212, '1.10.287.110-FF-000260', NULL, 'Uncharacterized protein', 100, NULL, NULL, 42212),
(42213, '3.20.20.80-FF-000317', NULL, 'Arabinogalactan endo-beta-1,4-galactanase', 374, NULL, NULL, 42213),
(42214, '3.10.250.10-FF-000019', NULL, 'Neurotrypsin', 109, NULL, NULL, 42214),
(42215, '2.30.29.30-FF-000953', NULL, 'Putative wiskott-aldrich syndrome-like a', 114, NULL, NULL, 42215),
(42216, '3.40.1190.20-FF-000038', NULL, 'Hydroxymethylpyrimidine/phosphomethylpyrimidine kinase THI20', 314, NULL, NULL, 42216),
(42217, '3.40.80.10-FF-000041', NULL, 'Glr3318 protein', 172, NULL, NULL, 42217),
(42218, '1.10.10.740-FF-000004', NULL, 'Uncharacterized protein', 42, NULL, NULL, 42218),
(42219, '3.40.20.10-FF-000144', NULL, 'Uncharacterized protein', 134, NULL, NULL, 42219),
(42220, '3.40.50.800-FF-000134', NULL, 'Uncharacterized protein', 58, NULL, NULL, 42220);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(42221, '1.20.1070.10-FF-000768', NULL, 'Uncharacterized protein', 127, NULL, NULL, 42221),
(42222, '1.10.196.10-FF-000007', NULL, 'regulator of G-protein signaling 21', 41, NULL, NULL, 42222),
(42223, '1.20.1250.20-FF-000538', NULL, 'Major facilitator transporter', 217, NULL, NULL, 42223),
(42224, '3.40.1190.10-FF-000035', NULL, 'Dihydrofolate synthetase', 292, NULL, NULL, 42224),
(42225, '3.40.190.80-FF-000040', NULL, '3''(2''),5''-bisphosphate nucleotidase CysQ', 103, NULL, NULL, 42225),
(42226, '1.10.10.730-FF-000001', NULL, 'Transcriptional repressor protein KorB', 56, NULL, NULL, 42226),
(42227, '3.40.50.150-FF-000001', NULL, 'Fibrillarin like 1', 178, NULL, NULL, 42227),
(42228, '3.50.30.80-FF-000002', NULL, 'Dehydratase, YjhG/YagF family', 151, NULL, NULL, 42228),
(42229, '1.10.238.200-FF-000002', NULL, 'DCN1-like protein', 104, NULL, NULL, 42229),
(42230, '3.30.1490.180-FF-000030', NULL, 'RNA polymerase Rpb1, domain 2 family protein', 70, NULL, NULL, 42230),
(42231, '1.10.10.60-FF-000001', NULL, 'MYB-related transcription factor', 54, NULL, NULL, 42231),
(42232, '1.25.40.10-FF-003136', NULL, 'Uncharacterized protein', 290, NULL, NULL, 42232),
(42233, '1.20.120.610-FF-000009', NULL, 'V-type proton ATPase 16 kDa proteolipid subunit', 106, NULL, NULL, 42233),
(42234, '1.25.40.570-FF-000062', NULL, 'Uncharacterized protein', 165, NULL, NULL, 42234),
(42235, '3.40.50.300-FF-002221', NULL, 'RuvB-like 2', 242, NULL, NULL, 42235),
(42236, '3.40.50.1700-FF-000015', NULL, 'Exported beta-glucosidase', 55, NULL, NULL, 42236),
(42237, '3.30.420.10-FF-000079', NULL, 'Polynucleotidyl transferase ribonuclease H fold protein with HRDC domain', 276, NULL, NULL, 42237),
(42238, '3.30.40.10-FF-000679', NULL, 'SH3 domain-containing protein', 99, NULL, NULL, 42238),
(42239, '3.20.20.70-FF-000314', NULL, 'Uncharacterized protein, isoform E', 285, NULL, NULL, 42239),
(42240, '1.10.287.130-FF-000266', NULL, 'Putative two-component system sensor kinase/response regulator', 61, NULL, NULL, 42240),
(42241, '3.40.50.150-FF-001535', NULL, NULL, 96, NULL, NULL, 42241),
(42242, '6.10.250.3310-FF-000001', NULL, 'Signal transducer and activator of transcription', 42, NULL, NULL, 42242),
(42243, '3.40.50.300-FF-001945', NULL, 'Nuclease SbcCD subunit C', 257, NULL, NULL, 42243),
(42244, '1.20.1420.10-FF-000032', NULL, NULL, 160, NULL, NULL, 42244),
(42245, '2.30.140.10-FF-000033', NULL, 'Spermidine synthase', 38, NULL, NULL, 42245),
(42246, '1.10.238.210-FF-000005', NULL, 'Putative Glutaminase kidney', 88, NULL, NULL, 42246),
(42247, '2.130.10.10-FF-005256', NULL, 'Uncharacterized protein', 272, NULL, NULL, 42247),
(42248, '3.30.450.20-FF-000483', NULL, 'Histidine kinase', 131, NULL, NULL, 42248),
(42249, '2.60.40.10-FF-001237', NULL, 'Tyrosine-protein kinase receptor', 92, NULL, NULL, 42249),
(42250, '1.10.238.220-FF-000008', NULL, NULL, 115, NULL, NULL, 42250),
(42251, '3.30.540.30-FF-000015', NULL, 'Dipeptidyl peptidase 3', 113, NULL, NULL, 42251),
(42252, '1.25.10.10-FF-001381', NULL, 'Uncharacterized protein', 601, NULL, NULL, 42252),
(42253, '3.30.160.60-FF-003805', NULL, NULL, 59, NULL, NULL, 42253),
(42254, '1.10.510.10-FF-003684', NULL, NULL, 169, NULL, NULL, 42254),
(42255, '2.60.120.200-FF-000444', NULL, 'Calreticulin family protein', 245, NULL, NULL, 42255),
(42256, '3.30.450.20-FF-000371', NULL, 'Methyl-accepting chemotaxis protein', 129, NULL, NULL, 42256),
(42257, '3.30.960.10-FF-000007', NULL, 'Uncharacterized protein', 103, NULL, NULL, 42257),
(42258, '1.25.40.10-FF-005154', NULL, 'Flagellar associated protein', 90, NULL, NULL, 42258),
(42259, '3.90.1580.10-FF-000003', NULL, 'Sulfatase modifying factor 2', 204, NULL, NULL, 42259),
(42260, '1.20.920.10-FF-000144', NULL, 'Uncharacterized protein', 114, NULL, NULL, 42260),
(42261, '3.30.1960.10-FF-000001', NULL, 'tRNA wybutosine-synthesizing protein 3 homolog', 202, NULL, NULL, 42261),
(42262, '1.10.246.140-FF-000007', NULL, 'Transcription and mRNA export factor ENY2', 96, NULL, NULL, 42262),
(42263, '3.40.395.10-FF-000011', NULL, 'Ulp2p', 261, NULL, NULL, 42263);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(42264, '1.10.238.10-FF-000004', NULL, 'Actinin alpha 1', 69, NULL, NULL, 42264),
(42265, '3.90.850.10-FF-000047', NULL, NULL, 64, NULL, NULL, 42265),
(42266, '3.40.50.300-FF-003626', NULL, 'AGAP006235-PA', 366, NULL, NULL, 42266),
(42267, '1.10.238.20-FF-000007', NULL, 'Odorant-binding protein 57b', 106, NULL, NULL, 42267),
(42268, '3.90.180.10-FF-000198', NULL, 'Uncharacterized protein', 147, NULL, NULL, 42268),
(42269, '3.40.50.300-FF-005762', NULL, 'Dynein heavy chain', 120, NULL, NULL, 42269),
(42270, '3.40.50.300-FF-002103', NULL, 'DEAD box helicase, putative', 197, NULL, NULL, 42270),
(42271, '1.10.246.130-FF-000004', NULL, 'Gamma-glutamyltranspeptidase (Ggt)', 114, NULL, NULL, 42271),
(42272, '3.40.630.30-FF-000290', NULL, 'Protein CBG23731', 174, NULL, NULL, 42272),
(42273, '3.50.50.60-FF-000784', NULL, 'Cinnamate reductase', 121, NULL, NULL, 42273),
(42274, '1.20.1280.50-FF-000021', NULL, 'Adagio protein 1', 48, NULL, NULL, 42274),
(42275, '3.10.450.10-FF-000012', NULL, 'Retinoic acid receptor responder (tazarotene-induced) 1', 124, NULL, NULL, 42275),
(42276, '2.130.10.10-FF-005363', NULL, 'Cirhin-like Protein', 172, NULL, NULL, 42276),
(42277, '3.30.420.10-FF-000433', NULL, NULL, 90, NULL, NULL, 42277),
(42278, '3.20.20.140-FF-000283', NULL, 'Uncharacterized protein', 308, NULL, NULL, 42278),
(42279, '2.20.25.20-FF-000026', NULL, NULL, 102, NULL, NULL, 42279),
(42280, '3.30.9.10-FF-000045', NULL, 'D-amino acid oxidase', 159, NULL, NULL, 42280),
(42281, '1.10.1760.20-FF-000012', NULL, 'Thiamine transporter ThiT', 182, NULL, NULL, 42281),
(42282, '2.60.120.330-FF-000117', NULL, '2OG-Fe(II) oxygenase family protein', 279, NULL, NULL, 42282),
(42283, '3.80.10.10-FF-000552', NULL, 'RNI-like superfamily protein', 189, NULL, NULL, 42283),
(42284, '3.40.50.2000-FF-000987', NULL, 'Uncharacterized protein', 61, NULL, NULL, 42284),
(42285, '4.10.40.20-FF-000006', NULL, 'insulin-like growth factor-binding protein 7', 83, NULL, NULL, 42285),
(42286, '3.40.50.300-FF-001491', NULL, 'Dynein heavy chain domain 1', 170, NULL, NULL, 42286),
(42287, '3.40.50.10490-FF-000116', NULL, NULL, 208, NULL, NULL, 42287),
(42288, '1.50.10.10-FF-000237', NULL, 'Uncharacterized protein', 59, NULL, NULL, 42288),
(42289, '2.20.25.10-FF-000023', NULL, 'Predicted protein', 56, NULL, NULL, 42289),
(42290, '2.40.37.10-FF-000084', NULL, NULL, 74, NULL, NULL, 42290),
(42291, '4.10.1240.10-FF-000006', NULL, 'corticotropin-releasing factor receptor 2 isoform X2', 70, NULL, NULL, 42291),
(42292, '1.10.287.370-FF-000091', NULL, 'Uncharacterized protein', 89, NULL, NULL, 42292),
(42293, '1.10.8.10-FF-000165', NULL, 'Baculoviral IAP repeat-containing protein 7', 50, NULL, NULL, 42293),
(42294, '1.10.630.10-FF-000091', NULL, 'Uncharacterized protein', 469, NULL, NULL, 42294),
(42295, '3.30.160.60-FF-000028', NULL, 'zinc finger protein 90 homolog', 29, NULL, NULL, 42295),
(42296, '2.60.40.10-FF-003249', NULL, '1,4-alpha-glucan branching enzyme GlgB', 100, NULL, NULL, 42296),
(42297, '2.60.40.10-FF-005385', NULL, NULL, 56, NULL, NULL, 42297),
(42298, '1.10.1780.10-FF-000004', NULL, 'ATP-dependent Clp protease ATP-binding subunit ClpC', 149, NULL, NULL, 42298),
(42299, '3.40.1160.10-FF-000106', NULL, 'Glutamate 5-kinase (Eurofung)', 100, NULL, NULL, 42299),
(42300, '2.30.29.30-FF-000509', NULL, 'Phosphatidylinositol 3-kinase 2', 122, NULL, NULL, 42300),
(42301, '1.25.40.10-FF-003018', NULL, 'Pentatricopeptide repeat-containing protein At5g11310, mitochondrial', 111, NULL, NULL, 42301),
(42302, '2.70.150.10-FF-000002', NULL, 'Copper-transporting ATPase 1, putative', 122, NULL, NULL, 42302),
(42303, '3.30.160.60-FF-005941', NULL, NULL, 28, NULL, NULL, 42303),
(42304, '3.10.105.10-FF-000115', NULL, 'Glr3204 protein', 211, NULL, NULL, 42304),
(42305, '4.10.280.10-FF-000085', NULL, 'Transcription factor bHLH126', 89, NULL, NULL, 42305),
(42306, '3.30.1610.10-FF-000020', NULL, 'Uncharacterized protein', 122, NULL, NULL, 42306),
(42307, '2.60.40.790-FF-000010', NULL, '17.3 kDa class II heat shock protein-like', 145, NULL, NULL, 42307);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(42308, '1.25.40.10-FF-005261', NULL, 'Pentatricopeptide repeat-containing protein', 157, NULL, NULL, 42308),
(42309, '3.40.1190.20-FF-000044', NULL, 'Carbohydrate kinase', 312, NULL, NULL, 42309),
(42310, '1.20.5.350-FF-000027', NULL, NULL, 79, NULL, NULL, 42310),
(42311, '3.30.70.890-FF-000026', NULL, 'Diphosphomevalonate decarboxylase', 146, NULL, NULL, 42311),
(42312, '3.30.70.330-FF-001404', NULL, 'Uncharacterized protein', 78, NULL, NULL, 42312),
(42313, '2.70.98.30-FF-000010', NULL, 'Cytosolic alpha-mannosidase', 242, NULL, NULL, 42313),
(42314, '3.20.20.140-FF-000390', NULL, 'Uncharacterized protein', 167, NULL, NULL, 42314),
(42315, '1.25.10.10-FF-001274', NULL, 'Uncharacterized protein', 197, NULL, NULL, 42315),
(42316, '3.80.10.10-FF-002783', NULL, 'F-box family protein', 79, NULL, NULL, 42316),
(42317, '1.20.90.10-FF-000047', NULL, NULL, 127, NULL, NULL, 42317),
(42318, '3.30.470.10-FF-000037', NULL, 'Branched-chain amino acid aminotransferase', 118, NULL, NULL, 42318),
(42319, '1.20.58.390-FF-000230', NULL, 'Uncharacterized protein', 44, NULL, NULL, 42319),
(42320, '2.40.40.20-FF-000083', NULL, 'Predicted protein', 39, NULL, NULL, 42320),
(42321, '1.10.287.70-FF-000074', NULL, 'Transient receptor potential cation channel subfamily V member 1', 140, NULL, NULL, 42321),
(42322, '2.60.40.10-FF-002052', NULL, 'Ig heavy chain V region MOO', 114, NULL, NULL, 42322),
(42323, '3.40.30.10-FF-000206', NULL, 'Probable glutathione S-transferase', 86, NULL, NULL, 42323),
(42324, '3.40.50.720-FF-002572', NULL, 'NmrA-like family domain-containing protein 1', 36, NULL, NULL, 42324),
(42325, '2.10.25.10-FF-000119', NULL, 'vitamin K-dependent protein S', 87, NULL, NULL, 42325),
(42326, '1.10.510.10-FF-002161', NULL, 'Kinase, NEK', 318, NULL, NULL, 42326),
(42327, '1.25.40.10-FF-000949', NULL, 'Pentatricopeptide repeat-containing protein', 131, NULL, NULL, 42327),
(42328, '1.10.20.10-FF-000301', NULL, NULL, 56, NULL, NULL, 42328),
(42329, '3.80.10.10-FF-002676', NULL, 'Leucine-rich repeat transmembrane protein kinase', 109, NULL, NULL, 42329),
(42330, '3.80.10.10-FF-002569', NULL, 'Uncharacterized protein', 121, NULL, NULL, 42330),
(42331, '1.10.150.50-FF-000155', NULL, 'STE11', 80, NULL, NULL, 42331),
(42332, '3.40.50.1820-FF-001321', NULL, '3-oxoadipate enol-lactone hydrolase', 258, NULL, NULL, 42332),
(42333, '2.130.10.10-FF-003227', NULL, 'Uncharacterized protein', 274, NULL, NULL, 42333),
(42334, '3.40.1190.10-FF-000041', NULL, NULL, 244, NULL, NULL, 42334),
(42335, '3.40.50.720-FF-001037', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', 193, NULL, NULL, 42335),
(42336, '3.40.630.30-FF-000183', NULL, 'Acetyltransferase YpeA', 137, NULL, NULL, 42336),
(42337, '1.20.58.60-FF-000616', NULL, 'Predicted protein', 104, NULL, NULL, 42337),
(42338, '3.40.50.300-FF-003519', NULL, 'GD23310', 192, NULL, NULL, 42338),
(42339, '2.130.10.10-FF-003906', NULL, 'Uncharacterized protein', 268, NULL, NULL, 42339),
(42340, '1.10.10.10-FF-001217', NULL, 'Transcriptional regulatory protein TcrA', 100, NULL, NULL, 42340),
(42341, '1.10.10.490-FF-000002', NULL, 'protein LZIC isoform X1', 54, NULL, NULL, 42341),
(42342, '1.10.1200.10-FF-000102', NULL, 'Nonribosomal peptide synthetase fmqC', 74, NULL, NULL, 42342),
(42343, '3.30.40.10-FF-001522', NULL, 'Uncharacterized protein', 71, NULL, NULL, 42343),
(42344, '3.10.20.90-FF-000152', NULL, 'regulator of G-protein signaling 12', 71, NULL, NULL, 42344),
(42345, '1.20.1070.10-FF-000780', NULL, 'Predicted protein', 281, NULL, NULL, 42345),
(42346, '1.10.150.50-FF-000048', NULL, 'kazrin isoform X1', 100, NULL, NULL, 42346),
(42347, '2.30.29.30-FF-000728', NULL, 'Myotubularin-related protein 9', 107, NULL, NULL, 42347),
(42348, '1.10.1060.10-FF-000006', NULL, 'Glutamate synthase (NADPH/NADH)', 155, NULL, NULL, 42348),
(42349, '1.25.10.10-FF-003409', NULL, 'Uncharacterized protein', 50, NULL, NULL, 42349),
(42350, '1.20.58.80-FF-000026', NULL, 'serine/threonine-protein kinase ULK3', 75, NULL, NULL, 42350),
(42351, '1.10.287.470-FF-000025', NULL, 'HlyD family secretion protein', 61, NULL, NULL, 42351);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(42352, '1.20.58.90-FF-000029', NULL, NULL, 78, NULL, NULL, 42352),
(42353, '3.30.70.330-FF-002697', NULL, NULL, 169, NULL, NULL, 42353),
(42354, '1.20.58.60-FF-000386', NULL, 'Spectrin repeat containing, nuclear envelope 1a', 297, NULL, NULL, 42354),
(42355, '3.40.570.10-FF-000037', NULL, 'Predicted protein', 182, NULL, NULL, 42355),
(42356, '3.40.720.10-FF-000077', NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase 3', 266, NULL, NULL, 42356),
(42357, '2.20.100.10-FF-000191', NULL, 'Netrin receptor unc-5', 69, NULL, NULL, 42357),
(42358, '2.10.50.10-FF-000065', NULL, 'TNF receptor superfamily member 14', 34, NULL, NULL, 42358),
(42359, '3.20.20.80-FF-000856', NULL, 'Uncharacterized protein', 48, NULL, NULL, 42359),
(42360, '3.60.40.10-FF-000324', NULL, 'Uncharacterized protein', 198, NULL, NULL, 42360),
(42361, '3.40.120.10-FF-000104', NULL, 'Phosphoglucomutase/phosphomannomutase alpha/beta/alpha domain I', 94, NULL, NULL, 42361),
(42362, '1.10.10.10-FF-000020', NULL, 'SWI/SNF complex subunit SMARCC2 isoform c', 88, NULL, NULL, 42362),
(42363, '1.20.1070.10-FF-000549', NULL, 'Olfactory receptor 10T2', 289, NULL, NULL, 42363),
(42364, '3.40.718.10-FF-000038', NULL, '1,2-dihydroxy-3,5-cyclohexadiene-1,4-dicarboxylate dehydrogenase', 310, NULL, NULL, 42364),
(42365, '1.10.506.10-FF-000032', NULL, 'RAS protein activator like-3', 174, NULL, NULL, 42365),
(42366, '3.90.1480.20-FF-000043', NULL, 'Uncharacterized protein', 274, NULL, NULL, 42366),
(42367, '3.20.20.190-FF-000051', NULL, 'DNA-(Apurinic or apyrimidinic site) lyase 2', 268, NULL, NULL, 42367),
(42368, '2.30.29.30-FF-000498', NULL, 'Switch-associated protein 70', 109, NULL, NULL, 42368),
(42369, '1.20.1560.10-FF-000750', NULL, 'Os06g0184766 protein', 94, NULL, NULL, 42369),
(42370, '3.40.1620.60-FF-000005', NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 9', 90, NULL, NULL, 42370),
(42371, '2.60.40.60-FF-000133', NULL, 'protocadherin-18 isoform X2', 106, NULL, NULL, 42371),
(42372, '3.40.50.10470-FF-000003', NULL, 'Methylthioribose-1-phosphate isomerase', 197, NULL, NULL, 42372),
(42373, '2.20.25.10-FF-000130', NULL, 'DNA-directed RNA polymerase subunit', 67, NULL, NULL, 42373),
(42374, '2.60.40.420-FF-000282', NULL, 'Cytochrome c oxidase subunit 2', 168, NULL, NULL, 42374),
(42375, '3.40.140.20-FF-000002', NULL, 'Bifunctional purine biosynthesis protein PurH', 155, NULL, NULL, 42375),
(42376, '3.40.50.150-FF-001294', NULL, NULL, 215, NULL, NULL, 42376),
(42377, '1.10.8.10-FF-000272', NULL, 'Tyrosyl-DNA phosphodiesterase 2', 47, NULL, NULL, 42377),
(42378, '3.40.30.10-FF-000195', NULL, 'thioredoxin-like fold domain-containing protein MRL7, chloroplastic', 126, NULL, NULL, 42378),
(42379, '1.10.390.10-FF-000043', NULL, 'Putative aminopeptidase-2', 257, NULL, NULL, 42379),
(42380, '2.60.40.1820-FF-000002', NULL, 'Late embryogenesis abundant protein Lea14-A', 124, NULL, NULL, 42380),
(42381, '2.40.50.140-FF-000889', NULL, NULL, 86, NULL, NULL, 42381),
(42382, '3.30.70.330-FF-001067', NULL, 'Serine/arginine-rich splicing factor 4', 84, NULL, NULL, 42382),
(42383, '2.30.42.10-FF-000579', NULL, NULL, 114, NULL, NULL, 42383),
(42384, '3.10.105.10-FF-000008', NULL, 'Peptide/nickel ABC transporter substrate-binding protein', 215, NULL, NULL, 42384),
(42385, '3.90.550.10-FF-000007', NULL, 'probable xyloglucan glycosyltransferase 5', 225, NULL, NULL, 42385),
(42386, '3.20.20.140-FF-000176', NULL, 'Deoxyribonuclease tatD', 102, NULL, NULL, 42386),
(42387, '2.60.40.340-FF-000010', NULL, 'Nuclear factor of activated T cells 3', 48, NULL, NULL, 42387),
(42388, '3.50.50.60-FF-000677', NULL, 'Spermine oxidase', 78, NULL, NULL, 42388),
(42389, '3.40.50.1100-FF-000150', NULL, 'Tryptophan synthase beta chain', 174, NULL, NULL, 42389),
(42390, '3.40.720.10-FF-000307', NULL, 'Uncharacterized protein', 218, NULL, NULL, 42390),
(42391, '3.20.20.140-FF-000064', NULL, 'Adenosine deaminase', 196, NULL, NULL, 42391),
(42392, '1.10.510.10-FF-003577', NULL, NULL, 214, NULL, NULL, 42392),
(42393, '3.30.420.10-FF-000540', NULL, NULL, 82, NULL, NULL, 42393);
INSERT INTO "PUBLIC"."MODEL" VALUES
(42394, '3.40.50.10480-FF-000006', NULL, 'RNA processing factor 1, putative', 173, NULL, NULL, 42394),
(42395, '3.40.50.300-FF-005981', NULL, '26S protease regulatory subunit s10b putative', 93, NULL, NULL, 42395),
(42396, '3.40.50.1820-FF-000490', NULL, 'Peptidase S10 serine carboxypeptidase', 472, NULL, NULL, 42396),
(42397, '1.10.10.10-FF-001650', NULL, 'Predicted protein', 78, NULL, NULL, 42397),
(42398, '3.40.50.300-FF-006959', NULL, 'RAD51-like protein 1', 222, NULL, NULL, 42398),
(42399, '3.40.80.10-FF-000029', NULL, 'N-acetylmuramoyl-L-alanine amidase family 2', 162, NULL, NULL, 42399),
(42400, '1.25.40.10-FF-003804', NULL, 'Uncharacterized protein', 140, NULL, NULL, 42400),
(42401, '3.40.50.10490-FF-000009', NULL, 'DNA-binding transcriptional regulator HexR', 186, NULL, NULL, 42401),
(42402, '1.20.960.40-FF-000003', NULL, 'Putative trans-2-enoyl-CoA reductase, mitochondrial isoform X1', 81, NULL, NULL, 42402),
(42403, '3.40.50.1110-FF-000153', NULL, 'Uncharacterized protein', 70, NULL, NULL, 42403),
(42404, '3.10.20.860-FF-000001', NULL, 'Antitoxin MqsA', 62, NULL, NULL, 42404),
(42405, '2.60.40.1930-FF-000035', NULL, 'Complement component C3-4', 51, NULL, NULL, 42405),
(42406, '3.30.360.20-FF-000026', NULL, NULL, 123, NULL, NULL, 42406),
(42407, '1.20.1250.20-FF-001600', NULL, 'YALI0E27225p', 250, NULL, NULL, 42407),
(42408, '3.10.20.90-FF-000040', NULL, 'FERM, RhoGEF and pleckstrin domain-containing protein', 85, NULL, NULL, 42408),
(42409, '3.30.450.20-FF-000590', NULL, 'C4-dicarboxylate transport sensor protein dctB', 117, NULL, NULL, 42409),
(42410, '1.10.730.20-FF-000016', NULL, 'Putative isoleucine-tRNA ligase', 298, NULL, NULL, 42410),
(42411, '1.25.40.20-FF-001902', NULL, 'Uncharacterized protein', 101, NULL, NULL, 42411),
(42412, '3.30.70.330-FF-000792', NULL, 'RNA-binding protein, putative', 154, NULL, NULL, 42412),
(42413, '1.20.1270.190-FF-000002', NULL, 'ExsD', 77, NULL, NULL, 42413),
(42414, '1.10.238.10-FF-000111', NULL, 'Calcium-dependent protein kinase 2', 84, NULL, NULL, 42414),
(42415, '2.60.40.10-FF-005615', NULL, NULL, 102, NULL, NULL, 42415),
(42416, '3.40.50.300-FF-007667', NULL, 'Uncharacterized protein', 122, NULL, NULL, 42416),
(42417, '1.10.30.10-FF-000122', NULL, 'PMS1 homolog 1, mismatch repair system component', 85, NULL, NULL, 42417),
(42418, '3.30.420.10-FF-000652', NULL, NULL, 213, NULL, NULL, 42418),
(42419, '4.10.900.10-FF-000004', NULL, 'lymphoid enhancer-binding factor 1 isoform X2', 65, NULL, NULL, 42419),
(42420, '1.50.40.10-FF-000065', NULL, 'ADP,ATP carrier protein ER-ANT1', 295, NULL, NULL, 42420),
(42421, '3.50.30.30-FF-000116', NULL, 'Ring finger protein 167', 140, NULL, NULL, 42421),
(42422, '3.20.70.20-FF-000033', NULL, 'Uncharacterized protein', 793, NULL, NULL, 42422),
(42423, '3.60.21.10-FF-000061', NULL, 'Metallophosphoesterase', 182, NULL, NULL, 42423),
(42424, '3.30.160.60-FF-003794', NULL, NULL, 30, NULL, NULL, 42424),
(42425, '1.10.238.10-FF-001297', NULL, 'Uncharacterized protein', 77, NULL, NULL, 42425),
(42426, '3.80.10.10-FF-000771', NULL, 'LRR receptor-like serine/threonine-protein kinase GSO1', 159, NULL, NULL, 42426),
(42427, '3.90.70.10-FF-000111', NULL, 'Ubiquitin carboxyl-terminal hydrolase 11', 273, NULL, NULL, 42427),
(42428, '3.30.1780.10-FF-000015', NULL, 'Ornithine cyclodeaminase', 138, NULL, NULL, 42428),
(42429, '3.20.20.150-FF-000067', NULL, 'Putative hydroxypyruvate isomerase', 267, NULL, NULL, 42429),
(42430, '1.10.510.10-FF-004201', NULL, NULL, 221, NULL, NULL, 42430),
(42431, '2.30.40.10-FF-000176', NULL, 'Isoaspartyl dipeptidase', 101, NULL, NULL, 42431),
(42432, '3.80.10.10-FF-001260', NULL, 'Toll-like receptor 6', 100, NULL, NULL, 42432),
(42433, '2.170.300.10-FF-000064', NULL, 'Uncharacterized protein', 116, NULL, NULL, 42433),
(42434, '1.10.287.310-FF-000005', NULL, '50S ribosomal protein L29', 64, NULL, NULL, 42434),
(42435, '3.20.20.80-FF-000637', NULL, 'Uncharacterized protein', 111, NULL, NULL, 42435),
(42436, '1.10.287.70-FF-000293', NULL, 'Osm-9 and Capsaicin receptor-Related', 154, NULL, NULL, 42436);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(42437, '3.30.499.10-FF-000013', NULL, 'Homoaconitase, mitochondrial', 155, NULL, NULL, 42437),
(42438, '3.30.479.20-FF-000009', NULL, 'Elongation factor Ts', 37, NULL, NULL, 42438),
(42439, '3.40.970.10-FF-000011', NULL, NULL, 52, NULL, NULL, 42439),
(42440, '3.90.1430.10-FF-000003', NULL, 'Elongation factor 2', 104, NULL, NULL, 42440),
(42441, '3.40.50.300-FF-003396', NULL, 'DNA replication ATP-dependent helicase/nuclease DNA2', 185, NULL, NULL, 42441),
(42442, '3.80.10.10-FF-002457', NULL, 'Receptor-like protein 6', 53, NULL, NULL, 42442),
(42443, '3.40.50.1400-FF-000026', NULL, 'Ferrochelatase-like protein', 111, NULL, NULL, 42443),
(42444, '3.30.479.10-FF-000006', NULL, '6-carboxy-5,6,7,8-tetrahydropterin synthase', 127, NULL, NULL, 42444),
(42445, '3.20.20.70-FF-000634', NULL, NULL, 263, NULL, NULL, 42445),
(42446, '2.60.40.10-FF-006104', NULL, NULL, 94, NULL, NULL, 42446),
(42447, '3.10.50.40-FF-000111', NULL, 'PPIC-type PPIASE domain containing protein', 121, NULL, NULL, 42447),
(42448, '1.10.530.10-FF-000032', NULL, 'Putative autolysin, N-acetylmuramidase', 124, NULL, NULL, 42448),
(42449, '3.40.30.10-FF-000425', NULL, 'Sulfhydryl oxidase', 135, NULL, NULL, 42449),
(42450, '1.25.10.10-FF-003179', NULL, 'Uncharacterized protein', 320, NULL, NULL, 42450),
(42451, '1.20.120.1710-FF-000003', NULL, 'NAD-dependent histone deacetylase SIR2', 112, NULL, NULL, 42451),
(42452, '1.10.8.590-FF-000006', NULL, NULL, 55, NULL, NULL, 42452),
(42453, '1.10.555.10-FF-000016', NULL, 'Rho GTPase activating protein 29', 234, NULL, NULL, 42453),
(42454, '2.10.25.10-FF-000445', NULL, 'Delta-like protein', 37, NULL, NULL, 42454),
(42455, '3.40.630.30-FF-000071', NULL, 'Acetyltransf_1', 145, NULL, NULL, 42455),
(42456, '3.40.50.11500-FF-000026', NULL, NULL, 154, NULL, NULL, 42456),
(42457, '3.40.50.10190-FF-000133', NULL, 'DNA ligase', 84, NULL, NULL, 42457),
(42458, '2.30.30.190-FF-000043', NULL, NULL, 52, NULL, NULL, 42458),
(42459, '3.30.460.10-FF-000082', NULL, 'Poly(A) polymerase', 165, NULL, NULL, 42459),
(42460, '3.40.950.10-FF-000004', NULL, 'NADP-reducing hydrogenase subunit HndD', 142, NULL, NULL, 42460),
(42461, '2.60.120.920-FF-000081', NULL, 'Vacuolar import and degradation protein', 234, NULL, NULL, 42461),
(42462, '3.40.50.620-FF-000743', NULL, 'Uncharacterized protein C167.05', 151, NULL, NULL, 42462),
(42463, '3.90.650.10-FF-000066', NULL, 'Phosphoribosylformylglycinamidine synthase', 187, NULL, NULL, 42463),
(42464, '1.10.10.10-FF-001094', NULL, 'DNA-binding transcriptional regulator, MarR family', 145, NULL, NULL, 42464),
(42465, '1.10.225.10-FF-000025', NULL, 'Saposin-related', 86, NULL, NULL, 42465),
(42466, '1.25.40.720-FF-000028', NULL, 'Liquid facets-Related, isoform D', 86, NULL, NULL, 42466),
(42467, '3.30.56.30-FF-000002', NULL, 'Signal recognition particle 19kDa', 121, NULL, NULL, 42467),
(42468, '1.10.510.10-FF-001672', NULL, 'Tyrosine-protein kinase', 215, NULL, NULL, 42468),
(42469, '3.90.1290.10-FF-000014', NULL, 'microtubule-actin cross-linking factor 1 isoform X21', 137, NULL, NULL, 42469),
(42470, '3.40.1350.10-FF-000025', NULL, 'AGAP009485-PA', 94, NULL, NULL, 42470),
(42471, '2.20.100.10-FF-000207', NULL, 'Thrombospondin type I repeat-containing single pass transmembrane protein', 43, NULL, NULL, 42471),
(42472, '3.30.470.20-FF-000254', NULL, '3-methylornithine--L-lysine ligase', 269, NULL, NULL, 42472),
(42473, '3.40.50.300-FF-004020', NULL, 'Putative ATP-dependent RNA helicase DDX56', 155, NULL, NULL, 42473),
(42474, '3.40.50.300-FF-005650', NULL, 'Uncharacterized protein', 215, NULL, NULL, 42474),
(42475, '1.25.10.10-FF-001829', NULL, 'Uncharacterized protein', 354, NULL, NULL, 42475),
(42476, '3.40.50.720-FF-000655', NULL, 'D-erythrose-4-phosphate dehydrogenase', 162, NULL, NULL, 42476),
(42477, '1.20.5.3310-FF-000003', NULL, 'Sec-independent protein translocase protein TATB, chloroplastic', 50, NULL, NULL, 42477),
(42478, '1.25.40.180-FF-000259', NULL, NULL, 251, NULL, NULL, 42478),
(42479, '3.20.20.140-FF-000171', NULL, 'AMP deaminase 3', 335, NULL, NULL, 42479);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(42480, '3.30.70.330-FF-001623', NULL, NULL, 73, NULL, NULL, 42480),
(42481, '1.25.40.10-FF-003237', NULL, 'Pentatricopeptide repeat-containing protein isoform A', 192, NULL, NULL, 42481),
(42482, '1.10.601.10-FF-000006', NULL, 'RNA polymerase sigma factor', 263, NULL, NULL, 42482),
(42483, '1.10.1580.10-FF-000023', NULL, 'Ferrous iron transporter B', 125, NULL, NULL, 42483),
(42484, '2.60.40.10-FF-001670', NULL, 'Down syndrome cell adhesion molecule-like protein Dscam2', 103, NULL, NULL, 42484),
(42485, '3.90.228.10-FF-000028', NULL, 'Poly [ADP-ribose] polymerase', 69, NULL, NULL, 42485),
(42486, '1.10.238.10-FF-000116', NULL, 'calretinin isoform X2', 74, NULL, NULL, 42486),
(42487, '3.40.630.30-FF-000413', NULL, 'ActC', 167, NULL, NULL, 42487),
(42488, '1.10.3060.10-FF-000006', NULL, 'Protein translocase subunit SecA 2', 176, NULL, NULL, 42488),
(42489, '3.40.720.10-FF-000291', NULL, 'Uncharacterized protein', 269, NULL, NULL, 42489),
(42490, '3.30.1490.80-FF-000019', NULL, 'Glutathione synthetase', 64, NULL, NULL, 42490),
(42491, '3.50.50.60-FF-001166', NULL, 'Uncharacterized protein', 30, NULL, NULL, 42491),
(42492, '3.60.90.10-FF-000035', NULL, 'Uncharacterized protein', 79, NULL, NULL, 42492),
(42493, '3.30.160.60-FF-005722', NULL, NULL, 96, NULL, NULL, 42493),
(42494, '3.30.160.60-FF-005048', NULL, NULL, 24, NULL, NULL, 42494),
(42495, '3.30.1490.70-FF-000016', NULL, 'Uncharacterized protein', 48, NULL, NULL, 42495),
(42496, '1.20.5.350-FF-000022', NULL, NULL, 145, NULL, NULL, 42496),
(42497, '2.30.30.140-FF-000163', NULL, 'Histone acetyltransferase', 116, NULL, NULL, 42497),
(42498, '3.40.50.2300-FF-000763', NULL, 'Odorant receptor VR5.3', 102, NULL, NULL, 42498),
(42499, '3.80.10.10-FF-002906', NULL, 'Protein CBG18939', 113, NULL, NULL, 42499),
(42500, '1.10.8.10-FF-000053', NULL, 'Ubiquitin-associated and SH3 domain-containing, A', 45, NULL, NULL, 42500),
(42501, '3.30.160.60-FF-005374', NULL, NULL, 50, NULL, NULL, 42501),
(42502, '1.20.120.340-FF-000012', NULL, 'Perilipin', 133, NULL, NULL, 42502),
(42503, '1.20.120.350-FF-000015', NULL, 'Voltage-dependent N-type calcium channel subunit alpha', 120, NULL, NULL, 42503),
(42504, '2.10.250.10-FF-000006', NULL, 'Calreticulin', 67, NULL, NULL, 42504),
(42505, '3.70.10.10-FF-000052', NULL, 'DNA repair protein Rad1', 260, NULL, NULL, 42505),
(42506, '2.130.10.10-FF-005144', NULL, 'Predicted protein', 208, NULL, NULL, 42506),
(42507, '3.40.50.300-FF-005543', NULL, 'ADP-ribosylation factor A1F', 31, NULL, NULL, 42507),
(42508, '2.60.40.1130-FF-000008', NULL, 'Rab geranylgeranyltransferase subunit alpha', 49, NULL, NULL, 42508),
(42509, '1.20.1560.10-FF-000643', NULL, 'Multidrug resistance protein, putative', 148, NULL, NULL, 42509),
(42510, '3.40.50.720-FF-000548', NULL, 'Ast1p', 60, NULL, NULL, 42510),
(42511, '3.40.50.2000-FF-001044', NULL, 'Uncharacterized protein', 141, NULL, NULL, 42511),
(42512, '3.10.129.10-FF-000249', NULL, 'Uncharacterized protein', 130, NULL, NULL, 42512),
(42513, '3.40.50.150-FF-001299', NULL, NULL, 302, NULL, NULL, 42513),
(42514, '2.60.120.200-FF-000663', NULL, 'Uncharacterized protein', 78, NULL, NULL, 42514),
(42515, '1.10.1900.20-FF-000001', NULL, '50S ribosomal protein L20', 63, NULL, NULL, 42515),
(42516, '2.30.30.770-FF-000003', NULL, '60S ribosomal protein L27', 146, NULL, NULL, 42516),
(42517, '2.60.40.2690-FF-000010', NULL, 'Uncharacterized protein', 126, NULL, NULL, 42517),
(42518, '1.10.630.10-FF-000646', NULL, 'Os04g0174100 protein', 209, NULL, NULL, 42518),
(42519, '3.80.10.10-FF-002238', NULL, 'Os08g0203100 protein', 135, NULL, NULL, 42519),
(42520, '3.40.50.150-FF-001636', NULL, NULL, 236, NULL, NULL, 42520),
(42521, '2.60.40.10-FF-005941', NULL, NULL, 120, NULL, NULL, 42521),
(42522, '4.10.280.10-FF-000208', NULL, 'Predicted protein', 55, NULL, NULL, 42522),
(42523, '3.40.50.150-FF-000113', NULL, 'Glycine N-methyltransferase', 187, NULL, NULL, 42523),
(42524, '3.30.200.20-FF-001268', NULL, 'Cdc2-related kinase 8', 94, NULL, NULL, 42524),
(42525, '1.10.3500.10-FF-000035', NULL, 'Uncharacterized protein', 119, NULL, NULL, 42525);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(42526, '3.30.70.1230-FF-000135', NULL, 'Predicted protein', 90, NULL, NULL, 42526),
(42527, '3.40.50.1820-FF-001214', NULL, 'Uncharacterized protein', 54, NULL, NULL, 42527),
(42528, '1.10.10.60-FF-000113', NULL, 'homeobox protein Hox-B1', 96, NULL, NULL, 42528),
(42529, '1.10.10.60-FF-000006', NULL, 'DNA-binding protein Fis', 98, NULL, NULL, 42529),
(42530, '3.30.70.330-FF-000100', NULL, 'Putative ribonucleoprotein PTB-binding 1', 92, NULL, NULL, 42530),
(42531, '3.30.200.20-FF-001616', NULL, 'Serine/threonine-protein kinase 38-like', 99, NULL, NULL, 42531),
(42532, '3.50.50.60-FF-001508', NULL, 'Predicted protein', 18, NULL, NULL, 42532),
(42533, '3.40.50.2000-FF-000768', NULL, 'Glucuronosyltransferase', 172, NULL, NULL, 42533),
(42534, '3.60.140.10-FF-000017', NULL, 'Polyphenol oxidase', 266, NULL, NULL, 42534),
(42535, '1.20.1740.10-FF-000062', NULL, 'Vesicular inhibitory amino acid transporter', 386, NULL, NULL, 42535),
(42536, '1.10.555.10-FF-000235', NULL, NULL, 107, NULL, NULL, 42536),
(42537, '1.20.1250.10-FF-000092', NULL, NULL, 180, NULL, NULL, 42537),
(42538, '1.20.58.390-FF-000123', NULL, 'Uncharacterized protein', 125, NULL, NULL, 42538),
(42539, '3.10.50.40-FF-000116', NULL, 'Peptidylprolyl isomerase', 125, NULL, NULL, 42539),
(42540, '3.30.160.60-FF-003468', NULL, 'Zinc finger protein 233', 21, NULL, NULL, 42540),
(42541, '3.40.50.300-FF-002322', NULL, 'Shikimate kinase', 168, NULL, NULL, 42541),
(42542, '3.40.50.10190-FF-000352', NULL, 'BRCT-containing protein 1', 88, NULL, NULL, 42542),
(42543, '3.30.200.20-FF-001723', NULL, 'Serine/threonine-protein kinase haspin', 136, NULL, NULL, 42543),
(42544, '2.10.70.10-FF-000302', NULL, 'Uncharacterized protein', 48, NULL, NULL, 42544),
(42545, '3.20.20.80-FF-000418', NULL, 'Uncharacterized protein', 261, NULL, NULL, 42545),
(42546, '1.25.40.10-FF-001438', NULL, 'Sel1 repeat protein', 117, NULL, NULL, 42546),
(42547, '2.130.10.10-FF-000017', NULL, 'SEC13 homolog (S. cerevisiae)', 302, NULL, NULL, 42547),
(42548, '1.10.8.1220-FF-000008', NULL, 'Dynein heavy chain, putative', 94, NULL, NULL, 42548),
(42549, '3.10.350.10-FF-000078', NULL, 'Predicted protein', 71, NULL, NULL, 42549),
(42550, '1.25.10.10-FF-002105', NULL, 'Uncharacterized protein', 149, NULL, NULL, 42550),
(42551, '1.10.555.10-FF-000128', NULL, 'Rho GTPase-activating protein 39', 134, NULL, NULL, 42551),
(42552, '3.40.50.1400-FF-000021', NULL, 'Sirohydrochlorin ferrochelatase B', 126, NULL, NULL, 42552),
(42553, '3.90.660.10-FF-000128', NULL, NULL, 77, NULL, NULL, 42553),
(42554, '3.20.20.70-FF-000415', NULL, 'Anaerobic ribonucleoside-triphosphate reductase activating protein', 202, NULL, NULL, 42554),
(42555, '4.10.240.10-FF-000088', NULL, 'Zinc cluster transcription factor, putative', 62, NULL, NULL, 42555),
(42556, '4.10.1000.40-FF-000003', NULL, 'Nuclear polyadenylated RNA-binding protein NAB2', 75, NULL, NULL, 42556),
(42557, '1.20.1250.20-FF-000095', NULL, 'Alpha-ketoglutarate permease', 420, NULL, NULL, 42557),
(42558, '3.40.50.620-FF-000069', NULL, 'diphthine--ammonia ligase', 157, NULL, NULL, 42558),
(42559, '3.40.50.150-FF-000006', NULL, 'Ribosomal RNA small subunit methyltransferase A', 200, NULL, NULL, 42559),
(42560, '3.40.630.30-FF-000076', NULL, 'Blast:N-acetyltransferase 6', 148, NULL, NULL, 42560),
(42561, '3.30.70.100-FF-000048', NULL, 'Antibiotic biosynthesis monooxygenase', 99, NULL, NULL, 42561),
(42562, '1.20.120.1910-FF-000052', NULL, 'Uncharacterized protein', 145, NULL, NULL, 42562),
(42563, '2.60.40.10-FF-005722', NULL, NULL, 32, NULL, NULL, 42563),
(42564, '2.30.29.30-FF-000616', NULL, 'Oxysterol-binding protein-like 7', 58, NULL, NULL, 42564),
(42565, '3.30.70.1820-FF-000003', NULL, 'Protein unc-13 homolog C', 87, NULL, NULL, 42565),
(42566, '3.30.200.20-FF-001049', NULL, 'Elongation factor 2 kinase', 150, NULL, NULL, 42566),
(42567, '4.10.40.20-FF-000001', NULL, 'Insulin-like growth factor binding protein 5', 73, NULL, NULL, 42567),
(42568, '1.20.5.390-FF-000011', NULL, NULL, 45, NULL, NULL, 42568),
(42569, '4.10.400.10-FF-000191', NULL, 'Blast:Prolow-density lipoprotein receptor-related protein 1', 28, NULL, NULL, 42569);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(42570, '1.10.287.770-FF-000008', NULL, 'pickpocket protein 28', 60, NULL, NULL, 42570),
(42571, '1.20.120.1240-FF-000059', NULL, 'Dynamin-related GTPase', 198, NULL, NULL, 42571),
(42572, '2.40.50.90-FF-000138', NULL, 'LD30829p', 82, NULL, NULL, 42572),
(42573, '3.40.1110.10-FF-000160', NULL, 'Cation transport ATPase, E1-E2 family', 109, NULL, NULL, 42573),
(42574, '3.10.20.90-FF-000045', NULL, 'TFG isoform 1', 82, NULL, NULL, 42574),
(42575, '1.10.1200.270-FF-000004', NULL, 'Salicylate/benzoate carboxyl methyltransferase', 143, NULL, NULL, 42575),
(42576, '1.20.5.110-FF-000309', NULL, 'Condensin complex subunit 2', 59, NULL, NULL, 42576),
(42577, '1.20.1250.20-FF-001151', NULL, 'Drug resistance transporter EmrB/QacA subfamily', 173, NULL, NULL, 42577),
(42578, '3.20.20.190-FF-000163', NULL, NULL, 146, NULL, NULL, 42578),
(42579, '1.25.40.10-FF-001657', NULL, 'EMB2750', 93, NULL, NULL, 42579),
(42580, '1.10.1200.10-FF-000091', NULL, 'Nonribosomal peptide synthase, putative', 74, NULL, NULL, 42580),
(42581, '3.40.50.300-FF-003289', NULL, 'Small GTP-binding rab protein, putative', 220, NULL, NULL, 42581),
(42582, '2.60.40.10-FF-003816', NULL, NULL, 88, NULL, NULL, 42582),
(42583, '1.10.220.160-FF-000011', NULL, 'protein msta', 89, NULL, NULL, 42583),
(42584, '2.60.40.10-FF-005380', NULL, NULL, 57, NULL, NULL, 42584),
(42585, '1.20.5.170-FF-000294', NULL, 'Predicted protein', 35, NULL, NULL, 42585),
(42586, '2.60.40.10-FF-004311', NULL, NULL, 102, NULL, NULL, 42586),
(42587, '1.20.58.1210-FF-000019', NULL, 'Uncharacterized protein', 129, NULL, NULL, 42587),
(42588, '3.50.30.20-FF-000006', NULL, 'Putative carbamoyl-phosphate synthase', 153, NULL, NULL, 42588),
(42589, '3.40.50.2300-FF-001471', NULL, NULL, 148, NULL, NULL, 42589),
(42590, '1.10.8.10-FF-000160', NULL, 'UBA/TS-N domain containing protein', 45, NULL, NULL, 42590),
(42591, '3.50.30.30-FF-000009', NULL, 'Carboxypeptidase Q', 143, NULL, NULL, 42591),
(42592, '1.10.565.10-FF-000067', NULL, 'Putative retinoic acid receptor alpha', 95, NULL, NULL, 42592),
(42593, '2.30.30.790-FF-000009', NULL, '50S ribosomal protein L19', 112, NULL, NULL, 42593),
(42594, '3.30.70.1130-FF-000004', NULL, 'Translation initiation factor 2 subunit alpha', 92, NULL, NULL, 42594),
(42595, '3.40.50.1820-FF-000938', NULL, 'Uncharacterized protein', 314, NULL, NULL, 42595),
(42596, '2.70.98.20-FF-000012', NULL, 'Amine oxidase', 336, NULL, NULL, 42596),
(42597, '1.20.58.340-FF-000024', NULL, 'Magnesium transporter MRS2-5', 179, NULL, NULL, 42597),
(42598, '3.40.50.720-FF-000874', NULL, 'Oxidoreductase, short-chain dehydrogenase/reductase family', 261, NULL, NULL, 42598),
(42599, '3.40.1160.10-FF-000090', NULL, 'Aspartokinase 1 chloroplastic', 126, NULL, NULL, 42599),
(42600, '3.40.910.10-FF-000007', NULL, 'Probable deoxyhypusine synthase', 311, NULL, NULL, 42600),
(42601, '3.40.50.300-FF-005195', NULL, 'Molybdopterin guanine dinucleotide synthesis protein B', 212, NULL, NULL, 42601),
(42602, '2.60.40.10-FF-003468', NULL, NULL, 99, NULL, NULL, 42602),
(42603, '1.20.5.110-FF-000186', NULL, 'WGS project CABT00000000 data, contig 2.13', 60, NULL, NULL, 42603),
(42604, '3.30.1490.310-FF-000001', NULL, 'Serine/threonine-protein kinase BRI1-like 1', 58, NULL, NULL, 42604),
(42605, '1.10.357.120-FF-000015', NULL, 'DNA-directed RNA polymerase subunit', 120, NULL, NULL, 42605),
(42606, '3.30.1960.10-FF-000006', NULL, 'tRNA-yW synthesizing protein 3 homolog', 85, NULL, NULL, 42606),
(42607, '3.90.280.10-FF-000020', NULL, NULL, 191, NULL, NULL, 42607),
(42608, '3.60.20.10-FF-000087', NULL, 'Asparagine synthase B', 195, NULL, NULL, 42608),
(42609, '3.30.505.10-FF-000001', NULL, 'Tyrosine-protein kinase', 110, NULL, NULL, 42609),
(42610, '2.70.98.30-FF-000015', NULL, 'Glycoside hydrolase family 81 protein', 208, NULL, NULL, 42610),
(42611, '1.10.287.2210-FF-000003', NULL, 'YALI0D22520p', 41, NULL, NULL, 42611),
(42612, '1.10.132.30-FF-000006', NULL, 'DNA-directed RNA polymerase subunit', 118, NULL, NULL, 42612),
(42613, '2.60.120.10-FF-000222', NULL, 'Predicted protein', 159, NULL, NULL, 42613);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(42614, '2.10.90.10-FF-000062', NULL, 'GK21666', 106, NULL, NULL, 42614),
(42615, '2.40.440.10-FF-000020', NULL, 'Murein L,D-transpeptidase', 138, NULL, NULL, 42615),
(42616, '1.25.40.10-FF-003911', NULL, 'Uncharacterized protein', 39, NULL, NULL, 42616),
(42617, '3.30.70.270-FF-000296', NULL, NULL, 58, NULL, NULL, 42617),
(42618, '2.60.40.10-FF-000040', NULL, 'Nuclear factor of activated T-cells, cytoplasmic, calcineurin-dependent 2', 107, NULL, NULL, 42618),
(42619, '2.130.10.10-FF-005470', NULL, 'Uncharacterized protein', 165, NULL, NULL, 42619),
(42620, '3.30.365.10-FF-000012', NULL, 'Selenate reductase, molybdenum-binding subunit', 132, NULL, NULL, 42620),
(42621, '3.40.50.800-FF-000016', NULL, 'Proline--tRNA ligase, chloroplastic/mitochondrial', 125, NULL, NULL, 42621),
(42622, '3.40.50.1220-FF-000074', NULL, 'Electron transfer flavoprotein subunit alpha', 38, NULL, NULL, 42622),
(42623, '1.10.287.70-FF-000186', NULL, 'Cation channel sperm-associated protein 3', 151, NULL, NULL, 42623),
(42624, '2.30.29.30-FF-000835', NULL, 'FI17948p1', 110, NULL, NULL, 42624),
(42625, '3.40.1190.20-FF-000156', NULL, 'PfkB family kinase', 293, NULL, NULL, 42625),
(42626, '1.10.287.2900-FF-000002', NULL, 'Mitochondrial intermembrane space import and assembly protein', 81, NULL, NULL, 42626),
(42627, '2.30.39.10-FF-000094', NULL, 'Uncharacterized protein', 147, NULL, NULL, 42627),
(42628, '1.10.132.20-FF-000003', NULL, 'ribosome-recycling factor, mitochondrial isoform X2', 75, NULL, NULL, 42628),
(42629, '3.40.50.2300-FF-000982', NULL, NULL, 123, NULL, NULL, 42629),
(42630, '3.30.160.60-FF-001670', NULL, 'Zinc finger protein 524', 27, NULL, NULL, 42630),
(42631, '1.10.8.60-FF-000152', NULL, 'DNA helicase', 65, NULL, NULL, 42631),
(42632, '3.30.1490.180-FF-000029', NULL, 'DNA-directed RNA polymerase subunit', 72, NULL, NULL, 42632),
(42633, '2.60.120.430-FF-000041', NULL, 'Endoglucanase', 148, NULL, NULL, 42633),
(42634, '1.20.190.60-FF-000001', NULL, 'SMG-7', 186, NULL, NULL, 42634),
(42635, '2.60.40.60-FF-000026', NULL, 'FAT atypical cadherin 1', 99, NULL, NULL, 42635),
(42636, '2.40.10.10-FF-000033', NULL, 'Replicase polyprotein 1a', 112, NULL, NULL, 42636),
(42637, '2.10.25.10-FF-000338', NULL, 'hepatocyte growth factor activator', 84, NULL, NULL, 42637),
(42638, '1.10.472.80-FF-000029', NULL, 'Growth hormone-regulated TBC protein 1', 144, NULL, NULL, 42638),
(42639, '3.40.50.620-FF-000288', NULL, 'Glutamate--tRNA ligase 1', 313, NULL, NULL, 42639),
(42640, '3.30.160.60-FF-002501', NULL, 'Zinc finger protein 526', 26, NULL, NULL, 42640),
(42641, '1.10.510.10-FF-001453', NULL, 'Protein kinase domain containing protein', 203, NULL, NULL, 42641),
(42642, '1.20.1280.50-FF-000240', NULL, 'Uncharacterized protein', 45, NULL, NULL, 42642),
(42643, '2.20.100.10-FF-000084', NULL, 'WNT1-inducible-signaling pathway protein 2 isoform X1', 57, NULL, NULL, 42643),
(42644, '3.80.10.10-FF-002564', NULL, 'Uncharacterized protein', 129, NULL, NULL, 42644),
(42645, '3.40.1800.20-FF-000007', NULL, 'Hangover, isoform C', 74, NULL, NULL, 42645),
(42646, '3.40.50.2000-FF-000549', NULL, 'Sucrose synthase 3', 127, NULL, NULL, 42646),
(42647, '3.40.50.1010-FF-000230', NULL, NULL, 82, NULL, NULL, 42647),
(42648, '3.40.50.720-FF-000329', NULL, 'Corticosteroid 11-beta-dehydrogenase isozyme 1', 272, NULL, NULL, 42648),
(42649, '2.60.40.1180-FF-000102', NULL, 'Alpha/beta hydrolase', 104, NULL, NULL, 42649),
(42650, '3.30.160.60-FF-003687', NULL, NULL, 29, NULL, NULL, 42650),
(42651, '1.20.120.350-FF-000234', NULL, NULL, 156, NULL, NULL, 42651),
(42652, '2.60.120.320-FF-000007', NULL, 'Thiamine pyrophosphokinase', 85, NULL, NULL, 42652),
(42653, '3.40.190.10-FF-000963', NULL, 'ABC transporter, periplasmic substrate-binding protein', 301, NULL, NULL, 42653),
(42654, '3.30.460.10-FF-000205', NULL, 'Uncharacterized protein', 59, NULL, NULL, 42654),
(42655, '1.10.150.20-FF-000287', NULL, 'Uncharacterized protein', 169, NULL, NULL, 42655),
(42656, '3.40.50.360-FF-000064', NULL, 'Flavin reductase', 196, NULL, NULL, 42656),
(42657, '3.30.160.60-FF-006211', NULL, NULL, 29, NULL, NULL, 42657);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(42658, '3.40.1380.20-FF-000075', NULL, 'Uncharacterized protein', 50, NULL, NULL, 42658),
(42659, '3.10.20.30-FF-000050', NULL, 'Threonine--tRNA ligase', 64, NULL, NULL, 42659),
(42660, '2.130.10.10-FF-005705', NULL, 'Predicted protein', 148, NULL, NULL, 42660),
(42661, '2.40.50.140-FF-001058', NULL, NULL, 102, NULL, NULL, 42661),
(42662, '1.25.10.10-FF-001723', NULL, 'Uncharacterized protein', 210, NULL, NULL, 42662),
(42663, '1.25.40.10-FF-001219', NULL, 'Pentatricopeptide repeat-containing protein', 133, NULL, NULL, 42663),
(42664, '3.30.300.10-FF-000031', NULL, 'S-adenosylmethionine synthase', 103, NULL, NULL, 42664),
(42665, '3.90.190.10-FF-000480', NULL, 'Dual-specificity protein phosphatase', 170, NULL, NULL, 42665),
(42666, '1.10.287.130-FF-000159', NULL, 'Two-component sensor histidine kinase', 80, NULL, NULL, 42666),
(42667, '1.10.565.10-FF-000174', NULL, 'Uncharacterized protein', 173, NULL, NULL, 42667),
(42668, '3.40.50.10130-FF-000025', NULL, 'GD10756', 175, NULL, NULL, 42668),
(42669, '3.40.50.150-FF-001861', NULL, NULL, 200, NULL, NULL, 42669),
(42670, '1.10.8.530-FF-000011', NULL, 'Uncharacterized protein', 46, NULL, NULL, 42670),
(42671, '3.40.50.10420-FF-000011', NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', 227, NULL, NULL, 42671),
(42672, '3.40.50.720-FF-000767', NULL, 'YMR090W-like protein', 223, NULL, NULL, 42672),
(42673, '2.60.120.10-FF-000115', NULL, 'Cyclic nucleotide-binding domain protein', 142, NULL, NULL, 42673),
(42674, '3.30.300.20-FF-000034', NULL, 'GTPase Era', 113, NULL, NULL, 42674),
(42675, '3.40.250.10-FF-000097', NULL, 'Putative thiosulfate sulfurtransferase mpst-1', 134, NULL, NULL, 42675),
(42676, '3.20.20.80-FF-000188', NULL, 'Beta-N-acetylhexosaminidase', 378, NULL, NULL, 42676),
(42677, '3.40.50.2300-FF-001252', NULL, NULL, 102, NULL, NULL, 42677),
(42678, '3.30.40.10-FF-001180', NULL, 'GG22947', 84, NULL, NULL, 42678),
(42679, '1.20.1560.10-FF-000076', NULL, 'Peptidase domain-containing ABC transporter', 303, NULL, NULL, 42679),
(42680, '3.30.40.100-FF-000014', NULL, 'Uncharacterized protein', 62, NULL, NULL, 42680),
(42681, '2.130.10.10-FF-003558', NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', 200, NULL, NULL, 42681),
(42682, '2.60.40.10-FF-001782', NULL, 'Uncharacterized protein, isoform B', 95, NULL, NULL, 42682),
(42683, '3.90.1150.190-FF-000001', NULL, 'Polycomb protein scmh1 isoform 4', 117, NULL, NULL, 42683),
(42684, '3.10.290.60-FF-000008', NULL, 'Putative ubiquitin-activating enzyme e1', 94, NULL, NULL, 42684),
(42685, '3.30.160.60-FF-004070', NULL, NULL, 61, NULL, NULL, 42685),
(42686, '1.25.40.10-FF-003349', NULL, 'Os03g0701400 protein', 83, NULL, NULL, 42686),
(42687, '2.60.120.290-FF-000072', NULL, 'Zinc metalloproteinase', 112, NULL, NULL, 42687),
(42688, '2.60.120.590-FF-000055', NULL, 'Uncharacterized protein', 196, NULL, NULL, 42688),
(42689, '3.30.1740.10-FF-000024', NULL, 'Poly [ADP-ribose] polymerase', 114, NULL, NULL, 42689),
(42690, '1.10.8.60-FF-000371', NULL, 'Uncharacterized protein', 66, NULL, NULL, 42690),
(42691, '3.40.50.1450-FF-000013', NULL, 'Hydrogenase maturation protease', 146, NULL, NULL, 42691),
(42692, '3.40.50.2300-FF-001145', NULL, NULL, 72, NULL, NULL, 42692),
(42693, '2.20.28.10-FF-000041', NULL, 'Probable rubredoxin HupI', 52, NULL, NULL, 42693),
(42694, '3.40.640.10-FF-000020', NULL, 'sphingosine-1-phosphate lyase 1', 261, NULL, NULL, 42694),
(42695, '2.40.10.190-FF-000003', NULL, '60S ribosomal protein L35a', 118, NULL, NULL, 42695),
(42696, '3.20.20.70-FF-000185', NULL, 'Thiamine phosphate pyrophosphorylase', 202, NULL, NULL, 42696),
(42697, '3.30.420.10-FF-000085', NULL, 'IS1239 transposase', 154, NULL, NULL, 42697),
(42698, '2.60.120.200-FF-000096', NULL, 'L-type lectin-domain containing receptor kinase V.9', 245, NULL, NULL, 42698),
(42699, '3.40.250.10-FF-000108', NULL, 'Thiosulfate sulfurtransferase', 151, NULL, NULL, 42699),
(42700, '3.40.50.1440-FF-000010', NULL, 'Tubulin gamma chain', 269, NULL, NULL, 42700),
(42701, '3.40.50.150-FF-000332', NULL, 'Ribosomal RNA large subunit methyltransferase J', 206, NULL, NULL, 42701);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(42702, '3.40.190.80-FF-000034', NULL, 'Inositol-1-monophosphatase', 122, NULL, NULL, 42702),
(42703, '3.30.200.20-FF-000886', NULL, 'At3g57720', 93, NULL, NULL, 42703),
(42704, '3.40.630.30-FF-000525', NULL, 'Uncharacterized protein', 95, NULL, NULL, 42704),
(42705, '1.50.40.10-FF-000413', NULL, 'Uncharacterized protein', 209, NULL, NULL, 42705),
(42706, '2.30.30.140-FF-000051', NULL, 'Tudor domain-containing protein 5', 76, NULL, NULL, 42706),
(42707, '1.10.510.10-FF-001902', NULL, 'Leucine-rich repeat receptor protein kinase MSP1', 197, NULL, NULL, 42707),
(42708, '3.40.50.300-FF-007229', NULL, 'Uncharacterized protein', 162, NULL, NULL, 42708),
(42709, '3.90.70.10-FF-000223', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 154, NULL, NULL, 42709),
(42710, '3.20.20.330-FF-000019', NULL, '5-methyltetrahydrofolate S-homocysteine methyltransferase', 300, NULL, NULL, 42710),
(42711, '1.10.10.2030-FF-000004', NULL, 'Uncharacterized protein', 54, NULL, NULL, 42711),
(42712, '1.10.238.10-FF-001185', NULL, 'EF hand family protein', 84, NULL, NULL, 42712),
(42713, '3.10.580.10-FF-000016', NULL, 'Transcriptional repressor CcpN', 147, NULL, NULL, 42713),
(42714, '2.170.150.30-FF-000006', NULL, 'DEXH (Asp-Glu-X-His) box polypeptide 58', 76, NULL, NULL, 42714),
(42715, '1.10.10.2020-FF-000001', NULL, 'Host-nuclease inhibitor protein gam', 98, NULL, NULL, 42715),
(42716, '2.60.120.430-FF-000035', NULL, 'Endoglucanase H', 171, NULL, NULL, 42716),
(42717, '3.20.20.100-FF-000187', NULL, 'Uncharacterized protein', 113, NULL, NULL, 42717),
(42718, '3.40.50.1220-FF-000068', NULL, 'Electron transfer flavoprotein subunit alpha', 73, NULL, NULL, 42718),
(42719, '1.25.40.10-FF-004985', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 138, NULL, NULL, 42719),
(42720, '3.30.830.10-FF-000003', NULL, 'Insulin-degrading enzyme', 221, NULL, NULL, 42720),
(42721, '1.25.40.20-FF-001554', NULL, 'Uncharacterized protein', 107, NULL, NULL, 42721),
(42722, '3.40.50.300-FF-003957', NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', 174, NULL, NULL, 42722),
(42723, '3.80.10.10-FF-004475', NULL, 'Uncharacterized protein', 216, NULL, NULL, 42723),
(42724, '1.25.40.20-FF-000031', NULL, 'Ankyrin repeat, family A (RFXANK-like), 2', 166, NULL, NULL, 42724),
(42725, '1.20.1560.10-FF-000749', NULL, 'Predicted protein', 94, NULL, NULL, 42725),
(42726, '1.20.120.1460-FF-000001', NULL, 'tRNA-dihydrouridine(20/20a) synthase', 74, NULL, NULL, 42726),
(42727, '1.10.510.10-FF-003919', NULL, NULL, 75, NULL, NULL, 42727),
(42728, '2.130.10.10-FF-005812', NULL, 'Cleavage stimulation factor, 3'' pre-RNA, subunit 1', 81, NULL, NULL, 42728),
(42729, '3.40.50.1460-FF-000016', NULL, 'GPI-anchor transamidase, putative', 275, NULL, NULL, 42729),
(42730, '2.130.10.10-FF-001434', NULL, 'Uncharacterized protein', 262, NULL, NULL, 42730),
(42731, '3.40.50.10140-FF-000028', NULL, 'Protein kinase family protein', 143, NULL, NULL, 42731),
(42732, '1.10.260.100-FF-000013', NULL, 'NEDD8-activating enzyme E1 catalytic subunit', 57, NULL, NULL, 42732),
(42733, '1.10.287.130-FF-000272', NULL, 'BfiS', 67, NULL, NULL, 42733),
(42734, '1.10.630.10-FF-000433', NULL, 'Uncharacterized protein', 118, NULL, NULL, 42734),
(42735, '3.80.10.10-FF-002345', NULL, 'Leucine-rich repeat (LRR) family protein', 115, NULL, NULL, 42735),
(42736, '1.10.630.10-FF-000540', NULL, 'Uncharacterized protein', 361, NULL, NULL, 42736),
(42737, '1.10.287.70-FF-000416', NULL, 'Uncharacterized protein', 94, NULL, NULL, 42737),
(42738, '3.90.190.10-FF-000148', NULL, 'Dual specificity protein phosphatase PHS1', 175, NULL, NULL, 42738),
(42739, '3.40.50.200-FF-000044', NULL, 'Serine protease/ABC transporter B family protein tagC', 368, NULL, NULL, 42739),
(42740, '3.40.50.300-FF-001833', NULL, 'Stage III sporulation protein AA', 145, NULL, NULL, 42740),
(42741, '3.40.50.1460-FF-000123', NULL, 'Uncharacterized protein', 211, NULL, NULL, 42741),
(42742, '3.40.33.10-FF-000123', NULL, 'Uncharacterized protein', 190, NULL, NULL, 42742),
(42743, '2.10.25.10-FF-000557', NULL, 'fibulin-5 isoform X1', 48, NULL, NULL, 42743);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(42744, '3.50.50.60-FF-001060', NULL, 'Os01g0269100 protein', 93, NULL, NULL, 42744),
(42745, '3.40.366.10-FF-000057', NULL, 'Malonyl-CoA:acyl-carrier-protein transacylase', 208, NULL, NULL, 42745),
(42746, '1.20.1270.60-FF-000074', NULL, 'Rho GTPase-activating protein 42', 127, NULL, NULL, 42746),
(42747, '3.40.50.140-FF-000003', NULL, 'DNA topoisomerase', 165, NULL, NULL, 42747),
(42748, '2.60.40.10-FF-002400', NULL, 'Stranded at second, isoform C', 88, NULL, NULL, 42748),
(42749, '2.10.60.10-FF-000021', NULL, 'Receptor protein serine/threonine kinase', 105, NULL, NULL, 42749),
(42750, '3.30.460.10-FF-000194', NULL, 'Predicted protein', 111, NULL, NULL, 42750),
(42751, '1.10.3380.10-FF-000047', NULL, 'DEAD/DEAH box helicase', 118, NULL, NULL, 42751),
(42752, '2.130.10.10-FF-001541', NULL, 'Coronin', 347, NULL, NULL, 42752),
(42753, '1.25.10.10-FF-001616', NULL, 'Protein phosphatase 2A regulatory subunit, putative', 565, NULL, NULL, 42753),
(42754, '3.40.20.10-FF-000037', NULL, 'macrophage-capping protein-like isoform X2', 108, NULL, NULL, 42754),
(42755, '3.30.160.570-FF-000001', NULL, 'SPC24, NDC80 kinetochore complex component', 65, NULL, NULL, 42755),
(42756, '1.20.1560.10-FF-000862', NULL, 'Uncharacterized protein', 178, NULL, NULL, 42756),
(42757, '2.60.40.10-FF-001669', NULL, 'Uncharacterized protein, isoform B', 94, NULL, NULL, 42757),
(42758, '3.40.50.300-FF-001940', NULL, 'ATP-dependent DNA helicase', 282, NULL, NULL, 42758),
(42759, '3.40.50.300-FF-007448', NULL, 'ABC transporter', 247, NULL, NULL, 42759),
(42760, '2.130.10.10-FF-000124', NULL, 'WD repeat-containing protein 62 isoform 1', 143, NULL, NULL, 42760),
(42761, '2.60.40.10-FF-005834', NULL, NULL, 110, NULL, NULL, 42761),
(42762, '3.40.20.10-FF-000149', NULL, 'Predicted protein', 99, NULL, NULL, 42762),
(42763, '1.10.1740.10-FF-000013', NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase, apicoplastic', 93, NULL, NULL, 42763),
(42764, '3.60.20.10-FF-000093', NULL, 'Proteasome endopeptidase complex', 237, NULL, NULL, 42764),
(42765, '1.10.8.50-FF-000036', NULL, 'Nei like DNA glycosylase 3', 84, NULL, NULL, 42765),
(42766, '3.30.70.330-FF-003085', NULL, NULL, 107, NULL, NULL, 42766),
(42767, '1.25.40.10-FF-003462', NULL, 'Os09g0423300 protein', 106, NULL, NULL, 42767),
(42768, '1.10.238.10-FF-001078', NULL, 'Putative calcium-binding protein CML41', 73, NULL, NULL, 42768),
(42769, '2.30.29.30-FF-001004', NULL, 'Uncharacterized protein', 126, NULL, NULL, 42769),
(42770, '3.40.50.1000-FF-000120', NULL, 'Magnesium-dependent phosphatase 1', 161, NULL, NULL, 42770),
(42771, '3.30.160.20-FF-000157', NULL, 'Plastid ribosomal protein S5', 69, NULL, NULL, 42771),
(42772, '3.40.50.20-FF-000087', NULL, 'Uncharacterized protein', 42, NULL, NULL, 42772),
(42773, '1.20.1110.10-FF-000036', NULL, 'Calcium-transporting ATPase', 59, NULL, NULL, 42773),
(42774, '2.30.29.30-FF-000386', NULL, 'Oxysterol-binding protein', 63, NULL, NULL, 42774),
(42775, '2.60.40.10-FF-001563', NULL, 'Interferon receptor 1 isoform 4', 101, NULL, NULL, 42775),
(42776, '2.10.25.10-FF-000664', NULL, 'Blast:Protein spitz', 52, NULL, NULL, 42776),
(42777, '2.130.10.10-FF-003671', NULL, 'Semaphorin 6B', 236, NULL, NULL, 42777),
(42778, '3.30.40.10-FF-002377', NULL, 'TNF receptor-associated factor', 50, NULL, NULL, 42778),
(42779, '3.10.580.10-FF-000123', NULL, 'Metal transporter cnnm-2', 153, NULL, NULL, 42779),
(42780, '1.10.8.60-FF-000039', NULL, 'peroxisome biogenesis factor 6', 87, NULL, NULL, 42780),
(42781, '3.40.50.300-FF-000523', NULL, 'DNA mismatch repair protein', 313, NULL, NULL, 42781),
(42782, '1.10.8.60-FF-000590', NULL, 'Uncharacterized protein', 103, NULL, NULL, 42782),
(42783, '3.80.10.10-FF-000984', NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', 121, NULL, NULL, 42783),
(42784, '3.40.50.300-FF-003177', NULL, 'Replication factor C small subunit', 113, NULL, NULL, 42784),
(42785, '3.40.50.300-FF-005088', NULL, 'Bsl1937 protein', 52, NULL, NULL, 42785),
(42786, '3.30.70.260-FF-000068', NULL, 'Glycine cleavage system transcriptional repressor', 89, NULL, NULL, 42786);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(42787, '3.30.160.20-FF-000045', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 2', 79, NULL, NULL, 42787),
(42788, '3.90.190.10-FF-000261', NULL, 'MAP kinase phosphatase-1', 160, NULL, NULL, 42788),
(42789, '1.10.510.10-FF-001559', NULL, 'Serine/threonine protein kinase, putative', 100, NULL, NULL, 42789),
(42790, '3.90.199.10-FF-000016', NULL, NULL, 49, NULL, NULL, 42790),
(42791, '3.30.70.2630-FF-000010', NULL, 'Telomerase reverse transcriptase', 104, NULL, NULL, 42791),
(42792, '3.30.505.10-FF-000113', NULL, 'Holliday-junction_resolvase-like_of_SPT6 /SH2_domain_containing_protein_-_putative', 110, NULL, NULL, 42792),
(42793, '1.20.5.170-FF-000288', NULL, 'Uncharacterized protein', 47, NULL, NULL, 42793),
(42794, '2.60.40.10-FF-003923', NULL, NULL, 107, NULL, NULL, 42794),
(42795, '1.25.40.10-FF-001551', NULL, 'TPR Domain containing protein', 184, NULL, NULL, 42795),
(42796, '3.30.160.60-FF-005267', NULL, NULL, 81, NULL, NULL, 42796),
(42797, '2.40.50.140-FF-001165', NULL, NULL, 70, NULL, NULL, 42797),
(42798, '2.30.30.140-FF-000270', NULL, 'Chromatin binding protein', 86, NULL, NULL, 42798),
(42799, '3.30.70.330-FF-002478', NULL, NULL, 153, NULL, NULL, 42799),
(42800, '2.130.10.10-FF-003890', NULL, 'Uncharacterized protein', 274, NULL, NULL, 42800),
(42801, '3.10.490.20-FF-000012', NULL, 'Putative dynein beta chain', 145, NULL, NULL, 42801),
(42802, '1.25.10.10-FF-000998', NULL, 'GM16513', 169, NULL, NULL, 42802),
(42803, '1.10.8.60-FF-000258', NULL, 'Spermatogenesis-associated protein 5-like protein 1', 91, NULL, NULL, 42803),
(42804, '3.20.20.140-FF-000406', NULL, 'Uncharacterized protein', 103, NULL, NULL, 42804),
(42805, '3.100.10.10-FF-000066', NULL, NULL, 41, NULL, NULL, 42805),
(42806, '3.40.50.300-FF-000304', NULL, 'Iron-sulfur cluster carrier protein', 246, NULL, NULL, 42806),
(42807, '3.30.70.1230-FF-000141', NULL, 'Adenylate cyclase', 205, NULL, NULL, 42807),
(42808, '1.25.40.10-FF-002967', NULL, 'RNA polymerase-associated protein CTR9', 379, NULL, NULL, 42808),
(42809, '3.30.160.60-FF-005486', NULL, NULL, 38, NULL, NULL, 42809),
(42810, '2.170.190.11-FF-000010', NULL, 'Molybdopterin molybdenumtransferase', 98, NULL, NULL, 42810),
(42811, '2.30.29.30-FF-000167', NULL, 'Pleckstrin homology domain-containing family F member 2', 125, NULL, NULL, 42811),
(42812, '3.30.930.10-FF-000062', NULL, 'Proline--tRNA ligase', 79, NULL, NULL, 42812),
(42813, '3.30.160.60-FF-006104', NULL, NULL, 59, NULL, NULL, 42813),
(42814, '1.10.287.70-FF-000635', NULL, 'Uncharacterized protein', 197, NULL, NULL, 42814),
(42815, '1.10.510.10-FF-001891', NULL, 'Dual specificity mitogen-activated protein kinase kinase mek-1', 197, NULL, NULL, 42815),
(42816, '1.20.1270.10-FF-000087', NULL, 'hypoxia up-regulated protein 1-like isoform X2', 110, NULL, NULL, 42816),
(42817, '1.20.5.170-FF-000069', NULL, 'cGMP-gated cation channel alpha-1', 73, NULL, NULL, 42817),
(42818, '2.130.10.10-FF-005924', NULL, 'Uncharacterized protein', 271, NULL, NULL, 42818),
(42819, '3.30.450.50-FF-000019', NULL, 'arf-GAP domain and FG repeat-containing protein 1 isoform X5', 45, NULL, NULL, 42819),
(42820, '3.40.50.150-FF-000225', NULL, 'tRNA (guanine(37)-N1)-methyltransferase', 198, NULL, NULL, 42820),
(42821, '3.30.420.40-FF-000301', NULL, 'Actin-related protein 8', 201, NULL, NULL, 42821),
(42822, '1.10.630.10-FF-000652', NULL, 'Uncharacterized protein', 201, NULL, NULL, 42822),
(42823, '1.10.260.40-FF-000048', NULL, 'DNA-binding helix-turn-helix protein', 67, NULL, NULL, 42823),
(42824, '3.30.230.10-FF-000379', NULL, '30S ribosomal protein S9', 139, NULL, NULL, 42824),
(42825, '1.10.472.80-FF-000136', NULL, 'TBC1 domain family member', 130, NULL, NULL, 42825),
(42826, '3.40.1170.10-FF-000039', NULL, 'DNA mismatch repair protein MutS', 174, NULL, NULL, 42826),
(42827, '3.20.10.10-FF-000037', NULL, 'Branched-chain-amino-acid aminotransferase', 221, NULL, NULL, 42827),
(42828, '3.40.50.1010-FF-000123', NULL, 'Uncharacterized protein', 160, NULL, NULL, 42828),
(42829, '3.10.450.240-FF-000012', NULL, 'TIMM44 isoform 4', 45, NULL, NULL, 42829);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(42830, '2.130.10.10-FF-003339', NULL, 'Uncharacterized protein', 100, NULL, NULL, 42830),
(42831, '3.40.1110.10-FF-000047', NULL, 'Phospholipid-transporting ATPase', 130, NULL, NULL, 42831),
(42832, '1.10.10.1050-FF-000013', NULL, 'Hydrolase, NUDIX family protein', 91, NULL, NULL, 42832),
(42833, '1.10.225.10-FF-000031', NULL, 'Granulysin', 76, NULL, NULL, 42833),
(42834, '3.40.50.150-FF-001642', NULL, NULL, 232, NULL, NULL, 42834),
(42835, '1.10.10.10-FF-001649', NULL, 'Transcriptional regulator, MarR family', 142, NULL, NULL, 42835),
(42836, '3.30.200.20-FF-001504', NULL, 'Predicted protein', 92, NULL, NULL, 42836),
(42837, '4.10.1000.10-FF-000135', NULL, 'Predicted protein', 58, NULL, NULL, 42837),
(42838, '1.10.10.41-FF-000007', NULL, NULL, 77, NULL, NULL, 42838),
(42839, '2.130.10.10-FF-001653', NULL, 'WD domain, G-beta repeat-containing protein', 248, NULL, NULL, 42839),
(42840, '3.50.50.60-FF-000907', NULL, 'Expressed protein', 46, NULL, NULL, 42840),
(42841, '4.10.280.110-FF-000017', NULL, NULL, 70, NULL, NULL, 42841),
(42842, '3.40.1170.60-FF-000032', NULL, NULL, 48, NULL, NULL, 42842),
(42843, '1.20.58.630-FF-000004', NULL, NULL, 36, NULL, NULL, 42843),
(42844, '1.25.40.420-FF-000039', NULL, 'BTB/POZ domain-containing protein 2', 105, NULL, NULL, 42844),
(42845, '1.10.630.10-FF-000197', NULL, 'Cytochrome P450 pisatin demethylase, putative', 485, NULL, NULL, 42845),
(42846, '1.20.940.10-FF-000027', NULL, 'Splicing factor Prp18 family protein', 77, NULL, NULL, 42846),
(42847, '1.20.1070.10-FF-000993', NULL, '5-hydroxytryptamine (serotonin) receptor 5A, genome duplicate a', 252, NULL, NULL, 42847),
(42848, '3.10.10.20-FF-000001', NULL, 'Telomerase reverse transcriptase', 20, NULL, NULL, 42848),
(42849, '3.90.1030.10-FF-000029', NULL, 'Uncharacterized protein', 64, NULL, NULL, 42849),
(42850, '3.30.160.60-FF-003917', NULL, NULL, 32, NULL, NULL, 42850),
(42851, '1.10.630.10-FF-000539', NULL, 'Uncharacterized protein', 362, NULL, NULL, 42851),
(42852, '3.90.70.10-FF-000004', NULL, 'Putative ubiquitin carboxyl-terminal hydrolase 25', 366, NULL, NULL, 42852),
(42853, '2.130.10.10-FF-001198', NULL, 'DNA damage-binding protein CMR1', 228, NULL, NULL, 42853),
(42854, '3.20.20.380-FF-000006', NULL, 'CutC family protein', 262, NULL, NULL, 42854),
(42855, '3.30.890.10-FF-000001', NULL, 'methyl-CpG-binding domain protein 1 isoform X7', 77, NULL, NULL, 42855),
(42856, '3.80.10.10-FF-001041', NULL, 'Preferentially-expressed antigen in melanoma-like', 282, NULL, NULL, 42856),
(42857, '2.10.220.10-FF-000061', NULL, 'Proprotein convertase subtilisin/kexin type 6 isoform PACE4-AI preproprotein', 59, NULL, NULL, 42857),
(42858, '3.40.50.300-FF-002215', NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', 263, NULL, NULL, 42858),
(42859, '3.40.50.620-FF-000737', NULL, 'Uncharacterized protein', 156, NULL, NULL, 42859),
(42860, '3.30.572.10-FF-000021', NULL, 'Thymidylate synthase', 299, NULL, NULL, 42860),
(42861, '3.50.50.60-FF-000896', NULL, 'Flavin-containing amine oxidasedehydrogenase', 120, NULL, NULL, 42861),
(42862, '3.40.50.300-FF-001597', NULL, 'Origin recognition complex subunit Orc4', 206, NULL, NULL, 42862),
(42863, '3.90.180.10-FF-000086', NULL, 'NADP-dependent alcohol dehydrogenase', 176, NULL, NULL, 42863),
(42864, '1.10.510.10-FF-000143', NULL, 'Mitogen-activated protein kinase kinase kinase 7', 222, NULL, NULL, 42864),
(42865, '3.40.50.300-FF-003738', NULL, 'ATPase family AAA domain-containing 5b', 220, NULL, NULL, 42865),
(42866, '2.60.120.290-FF-000178', NULL, 'Zgc:154142', 113, NULL, NULL, 42866),
(42867, '2.60.120.380-FF-000093', NULL, 'Putative calpain-like cysteine protease A', 149, NULL, NULL, 42867),
(42868, '3.30.40.10-FF-000685', NULL, 'E3 ubiquitin-protein ligase RNF114', 51, NULL, NULL, 42868),
(42869, '1.25.10.10-FF-001493', NULL, 'Predicted protein', 120, NULL, NULL, 42869),
(42870, '1.50.40.10-FF-000290', NULL, 'GM26277', 84, NULL, NULL, 42870),
(42871, '3.30.450.50-FF-000020', NULL, 'Synaptobrevin homolog YKT6', 140, NULL, NULL, 42871),
(42872, '1.20.1280.50-FF-000133', NULL, 'F-box and WD repeat domain-containing 7', 62, NULL, NULL, 42872);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(42873, '3.40.50.300-FF-004014', NULL, 'DEAD-box ATP-dependent RNA helicase 38', 176, NULL, NULL, 42873),
(42874, '3.30.160.60-FF-001776', NULL, 'zinc finger protein 75D isoform X1', 24, NULL, NULL, 42874),
(42875, '1.10.437.10-FF-000023', NULL, 'Predicted protein', 157, NULL, NULL, 42875),
(42876, '3.90.1290.10-FF-000008', NULL, 'microtubule-actin cross-linking factor 1 isoform X2', 129, NULL, NULL, 42876),
(42877, '3.80.10.10-FF-000765', NULL, 'Receptor-like protein kinase 2', 98, NULL, NULL, 42877),
(42878, '3.40.50.300-FF-001939', NULL, 'Nucleotide binding protein, putative', 177, NULL, NULL, 42878),
(42879, '3.40.50.620-FF-000395', NULL, 'Leucine--tRNA ligase', 227, NULL, NULL, 42879),
(42880, '3.30.450.20-FF-000477', NULL, 'Probable serine/threonine-protein kinase DDB_G0280133', 110, NULL, NULL, 42880),
(42881, '3.40.50.12650-FF-000011', NULL, 'Unplaced genomic scaffold supercont1.142, whole genome shotgun sequence', 156, NULL, NULL, 42881),
(42882, '1.10.287.2620-FF-000025', NULL, 'Dynein heavy chain', 65, NULL, NULL, 42882),
(42883, '3.30.70.100-FF-000161', NULL, NULL, 71, NULL, NULL, 42883),
(42884, '2.40.10.120-FF-000010', NULL, 'NS3 protease', 179, NULL, NULL, 42884),
(42885, '3.40.710.10-FF-000026', NULL, 'Penicillin-binding protein 1', 348, NULL, NULL, 42885),
(42886, '1.50.10.10-FF-000024', NULL, 'alpha-1,2-Mannosidase', 467, NULL, NULL, 42886),
(42887, '1.25.40.20-FF-000250', NULL, 'Serine/threonine-protein phosphatase 6 regulatory ankyrin repeat subunit A', 69, NULL, NULL, 42887),
(42888, '1.10.860.10-FF-000023', NULL, 'DNA primase', 122, NULL, NULL, 42888),
(42889, '1.25.40.570-FF-000056', NULL, 'Uncharacterized protein', 325, NULL, NULL, 42889),
(42890, '3.40.950.10-FF-000010', NULL, 'Nar1p', 176, NULL, NULL, 42890),
(42891, '3.40.50.12660-FF-000014', NULL, 'Metacaspase, putative', 298, NULL, NULL, 42891),
(42892, '1.25.40.180-FF-000265', NULL, NULL, 214, NULL, NULL, 42892),
(42893, '2.40.50.110-FF-000004', NULL, 'Toxic shock syndrome toxin-1', 71, NULL, NULL, 42893),
(42894, '3.40.50.1820-FF-000607', NULL, 'Lipase, member Ia', 314, NULL, NULL, 42894),
(42895, '3.30.160.60-FF-002052', NULL, 'Krueppel factor 7', 23, NULL, NULL, 42895),
(42896, '2.60.200.30-FF-000037', NULL, 'NAD kinase', 137, NULL, NULL, 42896),
(42897, '2.60.40.10-FF-005273', NULL, NULL, 85, NULL, NULL, 42897),
(42898, '1.25.40.10-FF-004766', NULL, 'Pentatricopeptide repeat-containing protein', 206, NULL, NULL, 42898),
(42899, '1.10.10.10-FF-001088', NULL, 'DEP domain containing protein', 101, NULL, NULL, 42899),
(42900, '3.30.9.10-FF-000157', NULL, 'Putative bifunctional amine oxidase DDB_G0291301', 174, NULL, NULL, 42900),
(42901, '1.20.1250.20-FF-000544', NULL, 'Alpha-ketoglutarate permease', 189, NULL, NULL, 42901),
(42902, '1.20.5.650-FF-000011', NULL, NULL, 50, NULL, NULL, 42902),
(42903, '3.30.70.270-FF-000184', NULL, 'Diguanylate cyclase/phosphodiesterase (GGDEF & EAL domains) with PAS/PAC sensor(S)', 170, NULL, NULL, 42903),
(42904, '3.30.420.10-FF-000646', NULL, NULL, 136, NULL, NULL, 42904),
(42905, '1.25.40.20-FF-000137', NULL, 'Ankyrin repeat domain-containing protein 6', 48, NULL, NULL, 42905),
(42906, '2.30.29.30-FF-000947', NULL, 'rho GTPase-activating protein 26', 118, NULL, NULL, 42906),
(42907, '1.20.1720.10-FF-000066', NULL, 'MFS transporter', 210, NULL, NULL, 42907),
(42908, '1.10.3520.10-FF-000036', NULL, 'Uncharacterized protein', 106, NULL, NULL, 42908),
(42909, '1.25.40.70-FF-000017', NULL, 'Phosphatidylinositol-4-phosphate 3-kinase catalytic subunit type 2 beta', 107, NULL, NULL, 42909),
(42910, '1.25.10.10-FF-003292', NULL, 'ATR serine/threonine kinase', 492, NULL, NULL, 42910),
(42911, '1.20.120.1080-FF-000090', NULL, 'DEAH-box helicase 40', 156, NULL, NULL, 42911),
(42912, '2.60.120.10-FF-000334', NULL, 'Protein Kinase, cGMP-dependent', 137, NULL, NULL, 42912),
(42913, '2.130.10.10-FF-005582', NULL, 'Uncharacterized protein', 205, NULL, NULL, 42913),
(42914, '2.60.40.10-FF-004997', NULL, NULL, 107, NULL, NULL, 42914),
(42915, '1.10.510.10-FF-003813', NULL, NULL, 116, NULL, NULL, 42915); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(42916, '1.25.40.60-FF-000014', NULL, 'SEC1 family transport protein SLY1', 101, NULL, NULL, 42916),
(42917, '1.10.238.10-FF-000223', NULL, 'Related to alpha-actinin', 65, NULL, NULL, 42917),
(42918, '2.60.60.20-FF-000038', NULL, NULL, 117, NULL, NULL, 42918),
(42919, '2.30.140.10-FF-000027', NULL, 'Spermidine synthase', 71, NULL, NULL, 42919),
(42920, '3.40.970.10-FF-000005', NULL, 'RNase H domain-containing protein', 53, NULL, NULL, 42920),
(42921, '3.30.70.260-FF-000181', NULL, 'Arogenate dehydratase/prephenate dehydratase 2 chloroplastic', 98, NULL, NULL, 42921),
(42922, '4.10.830.40-FF-000007', NULL, 'E3 ubiquitin/ISG15 ligase TRIM25', 78, NULL, NULL, 42922),
(42923, '3.40.50.450-FF-000102', NULL, 'Phosphofructokinase, platelet a', 157, NULL, NULL, 42923),
(42924, '2.40.420.20-FF-000022', NULL, 'Resistance-Nodulation-Cell Division (RND) efflux membrane fusion protein', 90, NULL, NULL, 42924),
(42925, '1.20.1560.10-FF-000188', NULL, 'ABC multidrug transporter, putative', 352, NULL, NULL, 42925),
(42926, '1.10.510.10-FF-003471', NULL, NULL, 271, NULL, NULL, 42926),
(42927, '3.30.420.10-FF-000208', NULL, 'DNA polymerase', 195, NULL, NULL, 42927),
(42928, '3.30.70.1570-FF-000001', NULL, 'Isocitrate dehydrogenase', 119, NULL, NULL, 42928),
(42929, '2.40.30.20-FF-000037', NULL, 'ATP synthase subunit alpha', 85, NULL, NULL, 42929),
(42930, '3.40.50.300-FF-007780', NULL, 'Dephospho-CoA kinase', 53, NULL, NULL, 42930),
(42931, '2.40.70.10-FF-000031', NULL, 'Aspartyl protease AED1', 184, NULL, NULL, 42931),
(42932, '3.30.470.20-FF-000147', NULL, 'Uncharacterized protein', 266, NULL, NULL, 42932),
(42933, '2.60.40.2240-FF-000004', NULL, 'Uncharacterized protein', 150, NULL, NULL, 42933),
(42934, '3.40.20.10-FF-000150', NULL, 'Uncharacterized protein', 98, NULL, NULL, 42934),
(42935, '3.40.50.800-FF-000128', NULL, 'Uncharacterized protein', 66, NULL, NULL, 42935),
(42936, '3.20.20.70-FF-000308', NULL, 'Protein CBG12371', 241, NULL, NULL, 42936),
(42937, '2.130.10.10-FF-001872', NULL, 'WD repeat-containing protein 90', 231, NULL, NULL, 42937),
(42938, '3.30.1780.10-FF-000021', NULL, 'Ornithine cyclodeaminase', 126, NULL, NULL, 42938),
(42939, '3.60.10.10-FF-000154', NULL, 'DNA-(apurinic or apyrimidinic site) lyase', 312, NULL, NULL, 42939),
(42940, '3.30.160.60-FF-003575', NULL, 'IKAROS family zinc finger 4', 38, NULL, NULL, 42940),
(42941, '1.20.120.350-FF-000122', NULL, 'Ion transport protein', 114, NULL, NULL, 42941),
(42942, '2.30.29.30-FF-001223', NULL, 'AGC family protein kinase', 118, NULL, NULL, 42942),
(42943, '2.40.50.990-FF-000003', NULL, 'Elongation factor 3, putative', 95, NULL, NULL, 42943),
(42944, '3.30.930.10-FF-000281', NULL, 'Uncharacterized protein', 361, NULL, NULL, 42944),
(42945, '3.30.559.10-FF-000176', NULL, 'Uncharacterized protein', 141, NULL, NULL, 42945),
(42946, '1.10.10.160-FF-000033', NULL, 'DNA helicase', 24, NULL, NULL, 42946),
(42947, '2.60.120.10-FF-000553', NULL, 'Uncharacterized protein', 185, NULL, NULL, 42947),
(42948, '2.60.40.650-FF-000002', NULL, 'sulfite oxidase', 128, NULL, NULL, 42948),
(42949, '1.20.140.10-FF-000062', NULL, 'Acyl-CoA oxidase, putative', 154, NULL, NULL, 42949),
(42950, '3.90.530.10-FF-000012', NULL, NULL, 78, NULL, NULL, 42950),
(42951, '1.20.5.110-FF-000203', NULL, 'Synaptobrevin (V-SNARE), putative', 112, NULL, NULL, 42951),
(42952, '2.30.39.10-FF-000111', NULL, 'Serpin, putative', 158, NULL, NULL, 42952),
(42953, '1.25.10.10-FF-003415', NULL, 'Uncharacterized protein', 338, NULL, NULL, 42953),
(42954, '2.30.40.10-FF-000069', NULL, 'Amidohydrolase', 93, NULL, NULL, 42954),
(42955, '3.30.60.270-FF-000018', NULL, 'Sortilin', 77, NULL, NULL, 42955),
(42956, '2.60.40.10-FF-003704', NULL, NULL, 97, NULL, NULL, 42956),
(42957, '1.20.1740.10-FF-000174', NULL, 'Bumetanide-sensitive sodium-(Potassium)-chloride cotransporter-like Protein', 474, NULL, NULL, 42957),
(42958, '3.40.630.30-FF-000306', NULL, 'Acetyltransferase, GNAT family protein', 163, NULL, NULL, 42958),
(42959, '1.20.120.790-FF-000012', NULL, 'Cation-transporting ATPase, putative', 162, NULL, NULL, 42959);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(42960, '1.20.58.390-FF-000011', NULL, 'neuronal acetylcholine receptor subunit alpha-7', 77, NULL, NULL, 42960),
(42961, '2.60.40.10-FF-005492', NULL, NULL, 96, NULL, NULL, 42961),
(42962, '3.40.930.10-FF-000008', NULL, 'Anion exchange protein', 314, NULL, NULL, 42962),
(42963, '2.40.50.140-FF-000783', NULL, NULL, 84, NULL, NULL, 42963),
(42964, '1.10.30.10-FF-000015', NULL, 'high mobility group protein B1', 86, NULL, NULL, 42964),
(42965, '3.60.130.10-FF-000067', NULL, 'Uncharacterized protein', 196, NULL, NULL, 42965),
(42966, '3.40.50.1820-FF-000484', NULL, 'Dipeptidyl peptidase 2', 320, NULL, NULL, 42966),
(42967, '4.10.960.10-FF-000002', NULL, '60S ribosomal protein L3', 49, NULL, NULL, 42967),
(42968, '2.30.180.10-FF-000024', NULL, 'fasciclin-like arabinogalactan protein 15', 143, NULL, NULL, 42968),
(42969, '2.30.30.490-FF-000026', NULL, 'Polybromo-1, putative', 253, NULL, NULL, 42969),
(42970, '2.60.120.330-FF-000230', NULL, 'Probable flavonol synthase 6', 150, NULL, NULL, 42970),
(42971, '2.40.240.10-FF-000033', NULL, 'Glutamate--tRNA ligase', 93, NULL, NULL, 42971),
(42972, '3.90.190.10-FF-000367', NULL, 'receptor-type tyrosine-protein phosphatase alpha-like isoform X1', 315, NULL, NULL, 42972),
(42973, '1.25.10.10-FF-003073', NULL, 'tRNA exportin, putative', 554, NULL, NULL, 42973),
(42974, '1.20.5.170-FF-000182', NULL, 'C-type lectin domain family 4 member F', 30, NULL, NULL, 42974),
(42975, '1.10.510.10-FF-003358', NULL, NULL, 231, NULL, NULL, 42975),
(42976, '3.40.50.1820-FF-001102', NULL, 'Putative serine esterase family protein', 178, NULL, NULL, 42976),
(42977, '3.40.50.720-FF-002347', NULL, 'Uncharacterized protein', 116, NULL, NULL, 42977),
(42978, '3.30.60.20-FF-000110', NULL, 'Diacylglycerol kinase', 62, NULL, NULL, 42978),
(42979, '1.10.10.10-FF-001762', NULL, 'Replication protein', 90, NULL, NULL, 42979),
(42980, '3.30.930.10-FF-000168', NULL, 'Glycine--tRNA ligase', 282, NULL, NULL, 42980),
(42981, '3.40.50.12780-FF-000157', NULL, 'Natural product biosynthesis luciferase-like monooxygenase domain-containing protein', 193, NULL, NULL, 42981),
(42982, '3.40.50.150-FF-001748', NULL, NULL, 173, NULL, NULL, 42982),
(42983, '3.40.50.150-FF-001529', NULL, NULL, 99, NULL, NULL, 42983),
(42984, '1.20.1420.10-FF-000026', NULL, NULL, 163, NULL, NULL, 42984),
(42985, '3.30.1520.10-FF-000148', NULL, 'Uncharacterized protein', 112, NULL, NULL, 42985),
(42986, '3.40.50.1700-FF-000009', NULL, 'Periplasmic beta-glucosidase', 258, NULL, NULL, 42986),
(42987, '6.10.140.2220-FF-000056', NULL, 'Uncharacterized protein', 49, NULL, NULL, 42987),
(42988, '1.10.10.10-FF-001543', NULL, 'Histone acetyltransferase', 84, NULL, NULL, 42988),
(42989, '2.40.50.100-FF-000220', NULL, 'Sugar ABC transporter, ATP-binding protein', 24, NULL, NULL, 42989),
(42990, '3.30.70.330-FF-000679', NULL, 'Heterogeneous nuclear ribonucleoprotein A1', 79, NULL, NULL, 42990),
(42991, '3.30.70.1230-FF-000028', NULL, 'Guanylate cyclase', 192, NULL, NULL, 42991),
(42992, '3.40.50.1820-FF-000826', NULL, 'Alpha/Beta hydrolase protein', 211, NULL, NULL, 42992),
(42993, '4.10.240.10-FF-000105', NULL, 'Transcription factor PDR1', 84, NULL, NULL, 42993),
(42994, '3.40.605.10-FF-000006', NULL, '1-pyrroline-5-carboxylate dehydrogenase', 317, NULL, NULL, 42994),
(42995, '1.20.1600.10-FF-000012', NULL, 'Outer membrane protein TolC', 398, NULL, NULL, 42995),
(42996, '3.30.70.330-FF-000898', NULL, 'GTPase activating protein (SH3 domain) binding protein 1', 153, NULL, NULL, 42996),
(42997, '3.50.50.60-FF-001059', NULL, 'Uncharacterized protein', 107, NULL, NULL, 42997),
(42998, '3.80.10.10-FF-004256', NULL, 'Uncharacterized protein', 68, NULL, NULL, 42998),
(42999, '2.90.20.10-FF-000003', NULL, 'cartilage acidic protein 1 isoform X1', 96, NULL, NULL, 42999),
(43000, '3.30.60.30-FF-000113', NULL, 'Agrin', 62, NULL, NULL, 43000),
(43001, '2.60.120.200-FF-000770', NULL, 'Uncharacterized protein', 56, NULL, NULL, 43001),
(43002, '3.40.50.1010-FF-000229', NULL, NULL, 82, NULL, NULL, 43002),
(43003, '1.20.1070.10-FF-000555', NULL, 'NeuroPeptide Receptor family', 332, NULL, NULL, 43003);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(43004, '3.40.50.620-FF-000518', NULL, 'Riboflavin biosynthesis protein', 159, NULL, NULL, 43004),
(43005, '3.40.50.300-FF-002092', NULL, 'Dynein-related AAA-type ATPase', 91, NULL, NULL, 43005),
(43006, '3.30.40.10-FF-000808', NULL, 'RBR-type E3 ubiquitin transferase', 112, NULL, NULL, 43006),
(43007, '3.40.50.1110-FF-000041', NULL, 'Lipase/acylhydrolase, GDSL family', 190, NULL, NULL, 43007),
(43008, '3.60.20.10-FF-000199', NULL, NULL, 218, NULL, NULL, 43008),
(43009, '1.20.1070.10-FF-000774', NULL, 'Uncharacterized protein', 352, NULL, NULL, 43009),
(43010, '3.40.30.10-FF-000650', NULL, 'Putative ovule protein', 61, NULL, NULL, 43010),
(43011, '3.40.50.300-FF-003851', NULL, 'Uncharacterized protein', 161, NULL, NULL, 43011),
(43012, '4.10.400.10-FF-000202', NULL, 'LDL receptor protein 1, isoform G', 43, NULL, NULL, 43012),
(43013, '3.90.1200.10-FF-000065', NULL, 'Ethanolamine kinase', 246, NULL, NULL, 43013),
(43014, '3.40.50.11980-FF-000012', NULL, 'Uncharacterized protein', 136, NULL, NULL, 43014),
(43015, '3.10.450.70-FF-000002', NULL, 'Thiol:disulfide interchange protein', 70, NULL, NULL, 43015),
(43016, '3.40.50.620-FF-000850', NULL, 'Isoleucine--tRNA ligase', 286, NULL, NULL, 43016),
(43017, '3.40.50.10190-FF-000240', NULL, 'Tumor suppressor p53-binding protein 1', 114, NULL, NULL, 43017),
(43018, '2.130.10.10-FF-003452', NULL, 'Exosome complex exonuclease RRP46-like protein', 118, NULL, NULL, 43018),
(43019, '2.30.30.30-FF-000001', NULL, '50S ribosomal protein L2', 78, NULL, NULL, 43019),
(43020, '3.40.50.80-FF-000189', NULL, 'Sulfite reductase (Nadph), alpha subunit', 170, NULL, NULL, 43020),
(43021, '3.90.640.10-FF-000127', NULL, 'Actin', 14, NULL, NULL, 43021),
(43022, '2.70.98.90-FF-000005', NULL, 'Membrane protein insertase YidC', 294, NULL, NULL, 43022),
(43023, '3.30.200.20-FF-000200', NULL, 'Serine/threonine-protein kinase RIO3', 109, NULL, NULL, 43023),
(43024, '3.40.50.150-FF-001187', NULL, NULL, 32, NULL, NULL, 43024),
(43025, '3.40.720.10-FF-000184', NULL, 'Multifunctional alkaline phosphatase superfamily protein PehA', 468, NULL, NULL, 43025),
(43026, '1.20.1070.10-FF-001050', NULL, 'Rhodopsin, GQ-coupled', 332, NULL, NULL, 43026),
(43027, '1.10.10.60-FF-001187', NULL, NULL, 93, NULL, NULL, 43027),
(43028, '3.30.1490.20-FF-000029', NULL, 'synapsin', 64, NULL, NULL, 43028),
(43029, '1.25.10.10-FF-000200', NULL, 'Centrosomal protein of 104 kDa', 263, NULL, NULL, 43029),
(43030, '1.25.40.10-FF-003681', NULL, 'PPR superfamily protein', 116, NULL, NULL, 43030),
(43031, '2.30.30.40-FF-000004', NULL, 'Sorbin and SH3 domain-containing protein 1 isoform 2', 65, NULL, NULL, 43031),
(43032, '2.10.230.10-FF-000011', NULL, 'Chaperone protein dnaJ 3', 62, NULL, NULL, 43032),
(43033, '2.70.220.10-FF-000008', NULL, 'Putative phosphatidylglycerol/phosphatidylinositol transfer protein 2', 66, NULL, NULL, 43033),
(43034, '3.30.70.330-FF-001174', NULL, 'RNA methyltransferase TrmH family protein', 92, NULL, NULL, 43034),
(43035, '1.20.58.60-FF-000493', NULL, 'AGAP009554-PA', 285, NULL, NULL, 43035),
(43036, '2.40.50.100-FF-000001', NULL, '50S ribosomal protein L27', 80, NULL, NULL, 43036),
(43037, '3.10.50.30-FF-000001', NULL, 'Transcription elongation factor GreA', 78, NULL, NULL, 43037),
(43038, '3.40.50.1000-FF-000007', NULL, 'Calcium-transporting ATPase', 127, NULL, NULL, 43038),
(43039, '2.10.80.10-FF-000016', NULL, 'Prokineticin 2', 97, NULL, NULL, 43039),
(43040, '3.10.250.10-FF-000025', NULL, 'Transmembrane protease, serine 3 (Predicted)', 102, NULL, NULL, 43040),
(43041, '2.60.40.420-FF-000169', NULL, 'Uncharacterized protein', 205, NULL, NULL, 43041),
(43042, '2.40.37.10-FF-000078', NULL, NULL, 130, NULL, NULL, 43042),
(43043, '3.60.10.10-FF-000373', NULL, 'Uncharacterized protein', 102, NULL, NULL, 43043),
(43044, '3.40.30.10-FF-000318', NULL, 'Ribosomal protein L43, mitochondrial, putative', 140, NULL, NULL, 43044),
(43045, '3.20.20.70-FF-000527', NULL, 'Predicted protein', 254, NULL, NULL, 43045),
(43046, '3.20.20.330-FF-000020', NULL, 'Selenocysteine methyltransferase', 85, NULL, NULL, 43046);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(43047, '3.30.70.330-FF-002933', NULL, NULL, 162, NULL, NULL, 43047),
(43048, '1.10.3080.10-FF-000007', NULL, 'Putative ion-transport protein YfeO', 400, NULL, NULL, 43048),
(43049, '1.20.810.10-FF-000023', NULL, 'Cytochrome b6', 114, NULL, NULL, 43049),
(43050, '3.30.40.10-FF-000466', NULL, 'E3 ubiquitin-protein ligase RNF168', 113, NULL, NULL, 43050),
(43051, '3.10.50.40-FF-000004', NULL, 'Peptidyl-prolyl cis-trans isomerase', 110, NULL, NULL, 43051),
(43052, '2.60.120.620-FF-000103', NULL, '2OG-Fe(II) oxygenase family protein', 186, NULL, NULL, 43052),
(43053, '3.40.50.300-FF-007561', NULL, 'AGAP011893-PA', 186, NULL, NULL, 43053),
(43054, '3.30.40.10-FF-001303', NULL, 'Im:7158173 protein', 78, NULL, NULL, 43054),
(43055, '3.40.850.10-FF-000188', NULL, 'Kinesin-like protein', 312, NULL, NULL, 43055),
(43056, '3.60.40.10-FF-000088', NULL, 'Protein phosphatase PPM4, putative', 317, NULL, NULL, 43056),
(43057, '3.40.50.720-FF-002566', NULL, 'NmrA-like family domain-containing protein 1', 43, NULL, NULL, 43057),
(43058, '3.30.160.60-FF-003356', NULL, NULL, 27, NULL, NULL, 43058),
(43059, '1.10.10.1350-FF-000002', NULL, NULL, 109, NULL, NULL, 43059),
(43060, '3.30.40.150-FF-000001', NULL, 'F-box only protein 30', 50, NULL, NULL, 43060),
(43061, '2.60.40.1530-FF-000022', NULL, NULL, 201, NULL, NULL, 43061),
(43062, '1.10.510.10-FF-003139', NULL, NULL, 182, NULL, NULL, 43062),
(43063, '1.25.10.10-FF-002797', NULL, 'Predicted protein', 154, NULL, NULL, 43063),
(43064, '3.30.9.10-FF-000270', NULL, 'Uncharacterized protein', 108, NULL, NULL, 43064),
(43065, '3.30.70.330-FF-001516', NULL, 'RNA recognition motif-containing protein', 108, NULL, NULL, 43065),
(43066, '1.20.58.60-FF-000835', NULL, 'Uncharacterized protein', 157, NULL, NULL, 43066),
(43067, '2.10.25.10-FF-000900', NULL, 'Netrin 4', 44, NULL, NULL, 43067),
(43068, '3.30.420.40-FF-000987', NULL, 'Actin-related protein 8', 100, NULL, NULL, 43068),
(43069, '3.40.250.10-FF-000221', NULL, 'Uncharacterized protein', 132, NULL, NULL, 43069),
(43070, '4.10.410.10-FF-000028', NULL, 'CBN-MEC-1 protein', 71, NULL, NULL, 43070),
(43071, '1.10.167.10-FF-000030', NULL, 'Regulator of G-protein signaling egl-10', 70, NULL, NULL, 43071),
(43072, '1.20.920.10-FF-000138', NULL, 'Transcription initiation factor TFIID subunit 1', 176, NULL, NULL, 43072),
(43073, '3.20.20.370-FF-000003', NULL, 'CLUMA_CG003232, isoform B', 271, NULL, NULL, 43073),
(43074, '3.40.30.10-FF-001207', NULL, 'Predicted protein', 52, NULL, NULL, 43074),
(43075, '1.20.120.550-FF-000025', NULL, 'Microsomal glutathione S-transferase 3', 102, NULL, NULL, 43075),
(43076, '2.40.30.10-FF-000496', NULL, 'Uncharacterized protein', 111, NULL, NULL, 43076),
(43077, '3.30.160.60-FF-004323', NULL, NULL, 36, NULL, NULL, 43077),
(43078, '3.30.200.20-FF-001752', NULL, 'Raf-1 proto-oncogene, serine/threonine kinase', 77, NULL, NULL, 43078),
(43079, '3.10.105.10-FF-000083', NULL, 'ABC transporter substrate-binding protein', 218, NULL, NULL, 43079),
(43080, '1.10.10.2660-FF-000025', NULL, 'ThiF family protein', 167, NULL, NULL, 43080),
(43081, '1.10.510.10-FF-001616', NULL, 'CAMK family protein kinase', 316, NULL, NULL, 43081),
(43082, '1.20.1610.10-FF-000013', NULL, 'Alpha-1,2-mannosidase, putative', 146, NULL, NULL, 43082),
(43083, '2.40.30.10-FF-000024', NULL, 'Eukaryotic peptide chain release factor GTP-binding subunit ERF3A', 87, NULL, NULL, 43083),
(43084, '3.40.50.720-FF-001049', NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', 103, NULL, NULL, 43084),
(43085, '3.40.50.12650-FF-000040', NULL, 'Uncharacterized protein', 88, NULL, NULL, 43085),
(43086, '3.40.1190.20-FF-000207', NULL, NULL, 107, NULL, NULL, 43086),
(43087, '1.25.40.180-FF-000097', NULL, 'Uncharacterized protein', 226, NULL, NULL, 43087),
(43088, '1.25.40.10-FF-005222', NULL, 'AGAP003595-PA', 192, NULL, NULL, 43088),
(43089, '1.20.1250.20-FF-001135', NULL, 'Ascorbate transporter chloroplastic', 113, NULL, NULL, 43089),
(43090, '2.30.30.40-FF-000180', NULL, 'epidermal growth factor receptor kinase substrate 8-like protein 2', 68, NULL, NULL, 43090);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(43091, '1.10.287.70-FF-000658', NULL, 'Uncharacterized protein', 136, NULL, NULL, 43091),
(43092, '3.30.70.1230-FF-000080', NULL, 'LuxR family transcriptional regulator', 173, NULL, NULL, 43092),
(43093, '3.30.1120.10-FF-000062', NULL, 'Arylsulphatase A', 58, NULL, NULL, 43093),
(43094, '3.90.70.200-FF-000009', NULL, 'Uncharacterized protein', 132, NULL, NULL, 43094),
(43095, '3.90.870.10-FF-000015', NULL, 'Probable riboflavin biosynthesis protein RibA1 (GTP cyclohydrolase II)', 203, NULL, NULL, 43095),
(43096, '2.130.10.10-FF-001625', NULL, 'Uncharacterized protein, isoform A', 225, NULL, NULL, 43096),
(43097, '2.30.29.30-FF-000898', NULL, 'Non-specific serine/threonine protein kinase', 103, NULL, NULL, 43097),
(43098, '4.10.280.10-FF-000097', NULL, 'Neuronal PAS domain-containing protein 2', 58, NULL, NULL, 43098),
(43099, '2.60.15.10-FF-000027', NULL, 'ATP synthase subunit delta, mitochondrial', 58, NULL, NULL, 43099),
(43100, '3.90.1750.10-FF-000085', NULL, 'Predicted protein', 117, NULL, NULL, 43100),
(43101, '3.40.1170.60-FF-000049', NULL, NULL, 20, NULL, NULL, 43101),
(43102, '2.60.120.380-FF-000037', NULL, 'Serine protease', 120, NULL, NULL, 43102),
(43103, '2.60.40.1120-FF-000001', NULL, 'Nodal modulator 1', 74, NULL, NULL, 43103),
(43104, '1.10.10.10-FF-000190', NULL, 'COP9 signalosome complex subunit 4', 81, NULL, NULL, 43104),
(43105, '3.30.1960.10-FF-000013', NULL, 'tRNA wybutosine-synthesizing protein 3 homolog', 60, NULL, NULL, 43105),
(43106, '4.10.240.10-FF-000151', NULL, 'Uga32p', 72, NULL, NULL, 43106),
(43107, '2.30.30.550-FF-000011', NULL, NULL, 55, NULL, NULL, 43107),
(43108, '3.30.70.330-FF-001028', NULL, 'RNA binding protein, putative', 94, NULL, NULL, 43108),
(43109, '3.40.50.10320-FF-000010', NULL, 'Glucosamine-6-phosphate isomerase / GlcNAc-PI de-N-acetylase family protein', 272, NULL, NULL, 43109),
(43110, '2.40.160.120-FF-000051', NULL, 'Oxysterol binding protein', 82, NULL, NULL, 43110),
(43111, '3.40.20.10-FF-000133', NULL, 'YALI0E34687p', 122, NULL, NULL, 43111),
(43112, '3.40.50.300-FF-003104', NULL, 'Suppressor of Stomatin mutant Uncoordination', 280, NULL, NULL, 43112),
(43113, '3.40.50.150-FF-000636', NULL, 'Class I SAM-dependent methyltransferase', 102, NULL, NULL, 43113),
(43114, '1.10.3520.10-FF-000020', NULL, 'Uncharacterized protein', 202, NULL, NULL, 43114),
(43115, '2.70.98.10-FF-000111', NULL, 'Uncharacterized protein', 75, NULL, NULL, 43115),
(43116, '3.30.260.10-FF-000090', NULL, NULL, 99, NULL, NULL, 43116),
(43117, '3.40.50.1360-FF-000054', NULL, 'Predicted protein', 142, NULL, NULL, 43117),
(43118, '3.40.50.150-FF-001625', NULL, NULL, 244, NULL, NULL, 43118),
(43119, '1.10.8.60-FF-000085', NULL, 'DNA polymerase III subunit delta', 69, NULL, NULL, 43119),
(43120, '3.30.2130.10-FF-000001', NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase', 160, NULL, NULL, 43120),
(43121, '1.25.40.20-FF-000380', NULL, 'Os01g0892800 protein', 138, NULL, NULL, 43121),
(43122, '2.60.40.10-FF-003738', NULL, NULL, 86, NULL, NULL, 43122),
(43123, '1.10.510.10-FF-000627', NULL, 'Os02g0694800 protein', 202, NULL, NULL, 43123),
(43124, '3.30.70.330-FF-001467', NULL, 'UBP1-associated protein 2C', 130, NULL, NULL, 43124),
(43125, '3.40.30.10-FF-000218', NULL, 'spermatogenesis-associated protein 20', 173, NULL, NULL, 43125),
(43126, '3.30.160.60-FF-003334', NULL, NULL, 30, NULL, NULL, 43126),
(43127, '3.80.10.10-FF-001704', NULL, 'Os02g0216000 protein', 98, NULL, NULL, 43127),
(43128, '3.40.50.300-FF-002115', NULL, 'disks large homolog 4 isoform X1', 26, NULL, NULL, 43128),
(43129, '3.40.50.10810-FF-000241', NULL, 'Uncharacterized protein', 187, NULL, NULL, 43129),
(43130, '3.10.310.10-FF-000014', NULL, 'Diaminopimelate epimerase', 137, NULL, NULL, 43130),
(43131, '3.30.70.1430-FF-000016', NULL, 'Probable Resistance-Nodulation-Cell Division (RND) efflux transporter', 104, NULL, NULL, 43131),
(43132, '1.10.510.10-FF-002605', NULL, NULL, 169, NULL, NULL, 43132),
(43133, '4.10.400.10-FF-000186', NULL, 'MAM and LDL-receptor class A domain-containing protein 1', 39, NULL, NULL, 43133);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(43134, '2.40.290.10-FF-000020', NULL, 'Related to ATP-dependent DNA helicase II, 80 kDa subunit', 186, NULL, NULL, 43134),
(43135, '3.30.1680.10-FF-000031', NULL, 'Similar to semaphorin-I', 60, NULL, NULL, 43135),
(43136, '2.70.98.40-FF-000007', NULL, 'Cyclic beta-1,2-glucan synthase', 297, NULL, NULL, 43136),
(43137, '1.10.418.10-FF-000272', NULL, 'Uncharacterized protein', 81, NULL, NULL, 43137),
(43138, '3.30.230.70-FF-000173', NULL, 'Uncharacterized protein', 82, NULL, NULL, 43138),
(43139, '1.10.30.10-FF-000134', NULL, 'Uncharacterized protein', 91, NULL, NULL, 43139),
(43140, '3.30.230.80-FF-000030', NULL, 'Uncharacterized protein', 69, NULL, NULL, 43140),
(43141, '3.20.20.70-FF-000646', NULL, NULL, 243, NULL, NULL, 43141),
(43142, '2.60.40.1170-FF-000055', NULL, 'Coatomer subunit delta', 115, NULL, NULL, 43142),
(43143, '3.20.20.80-FF-000503', NULL, 'Glycoside hydrolase family 17 protein', 147, NULL, NULL, 43143),
(43144, '3.40.50.2300-FF-001562', NULL, NULL, 13, NULL, NULL, 43144),
(43145, '2.60.120.620-FF-000065', NULL, 'Predicted protein', 103, NULL, NULL, 43145),
(43146, '2.60.200.40-FF-000041', NULL, 'Sphingosine kinase 2', 204, NULL, NULL, 43146),
(43147, '3.40.525.10-FF-000040', NULL, 'Cell surface biosynthesis and architecture modulator, putative', 170, NULL, NULL, 43147),
(43148, '1.10.10.60-FF-000625', NULL, 'Transcriptional regulator, AraC/XylS family', 54, NULL, NULL, 43148),
(43149, '2.60.40.10-FF-000512', NULL, 'neurofascin isoform X1', 98, NULL, NULL, 43149),
(43150, '2.40.50.100-FF-000209', NULL, 'Glr3987 protein', 69, NULL, NULL, 43150),
(43151, '1.20.1110.10-FF-000020', NULL, 'Sodium ion P-type ATPase', 59, NULL, NULL, 43151),
(43152, '2.60.40.10-FF-002749', NULL, 'T cell receptor delta variable 3', 97, NULL, NULL, 43152),
(43153, '3.90.180.10-FF-000159', NULL, 'Predicted protein', 145, NULL, NULL, 43153),
(43154, '3.40.50.300-FF-007758', NULL, 'Uncharacterized protein', 72, NULL, NULL, 43154),
(43155, '1.25.10.10-FF-003096', NULL, 'MMS19 nucleotide excision repair protein homolog', 223, NULL, NULL, 43155),
(43156, '3.30.420.40-FF-000021', NULL, 'heat shock 70 kDa protein 4', 93, NULL, NULL, 43156),
(43157, '3.90.1410.10-FF-000008', NULL, 'SET domain-containing protein', 269, NULL, NULL, 43157),
(43158, '3.30.70.100-FF-000055', NULL, 'Antibiotic biosynthesis monooxygenase', 89, NULL, NULL, 43158),
(43159, '2.60.120.740-FF-000016', NULL, 'Uncharacterized protein', 115, NULL, NULL, 43159),
(43160, '2.60.40.60-FF-000533', NULL, 'Uncharacterized protein', 128, NULL, NULL, 43160),
(43161, '1.10.10.1250-FF-000001', NULL, 'Probable DNA-directed RNA polymerase subunit delta', 81, NULL, NULL, 43161),
(43162, '2.130.10.10-FF-000636', NULL, 'Telomerase protein component 1', 129, NULL, NULL, 43162),
(43163, '2.60.40.150-FF-000095', NULL, 'myoferlin isoform X2', 125, NULL, NULL, 43163),
(43164, '1.20.1740.10-FF-000197', NULL, 'AGAP011499-PA', 192, NULL, NULL, 43164),
(43165, '3.30.760.10-FF-000083', NULL, 'Uncharacterized protein', 153, NULL, NULL, 43165),
(43166, '3.30.40.10-FF-001113', NULL, '3'',5''-cyclic nucleotide phosphodiesterase, putative', 69, NULL, NULL, 43166),
(43167, '1.10.540.10-FF-000016', NULL, 'acyl-CoA dehydrogenase family member 11', 132, NULL, NULL, 43167),
(43168, '2.170.270.10-FF-000061', NULL, 'Down and out, isoform A', 28, NULL, NULL, 43168),
(43169, '3.30.500.10-FF-000007', NULL, 'Major histocompatibility complex class I LDA', 174, NULL, NULL, 43169),
(43170, '3.40.50.300-FF-003576', NULL, 'ABC transporter ATP-binding protein', 222, NULL, NULL, 43170),
(43171, '3.90.730.10-FF-000005', NULL, 'Genome polyprotein', 167, NULL, NULL, 43171),
(43172, '3.90.810.10-FF-000006', NULL, 'Neural Wiskott-Aldrich syndrome protein', 63, NULL, NULL, 43172),
(43173, '2.30.42.10-FF-000445', NULL, NULL, 98, NULL, NULL, 43173),
(43174, '2.10.25.10-FF-001334', NULL, 'Si:dkey-1m11.6', 44, NULL, NULL, 43174),
(43175, '3.40.228.10-FF-000029', NULL, 'DMSO reductase chain A', 305, NULL, NULL, 43175),
(43176, '1.10.357.20-FF-000020', NULL, 'Uncharacterized protein', 198, NULL, NULL, 43176);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(43177, '1.20.5.4770-FF-000009', NULL, 'Tumor necrosis factor, alpha-induced protein 3', 52, NULL, NULL, 43177),
(43178, '2.60.40.10-FF-001940', NULL, 'Twitchin', 88, NULL, NULL, 43178),
(43179, '3.30.450.40-FF-000169', NULL, 'PAS sensor protein', 177, NULL, NULL, 43179),
(43180, '1.25.40.10-FF-002788', NULL, 'Chitin synthase regulatory factor 2', 212, NULL, NULL, 43180),
(43181, '2.40.50.140-FF-000553', NULL, 'Cytochrome c-type biogenesis protein CcmE homolog, mitochondrial', 131, NULL, NULL, 43181),
(43182, '3.20.20.70-FF-000293', NULL, 'Triosephosphate isomerase', 233, NULL, NULL, 43182),
(43183, '3.30.40.10-FF-001585', NULL, 'Zinc finger, C3HC4 type (RING finger), putative', 122, NULL, NULL, 43183),
(43184, '1.20.1070.10-FF-002169', NULL, 'Predicted protein', 123, NULL, NULL, 43184),
(43185, '3.40.120.10-FF-000116', NULL, 'Uncharacterized protein', 64, NULL, NULL, 43185),
(43186, '3.90.79.10-FF-000250', NULL, 'Nudix hydrolase 16 mitochondrial', 147, NULL, NULL, 43186),
(43187, '2.20.70.10-FF-000252', NULL, 'Uncharacterized protein', 50, NULL, NULL, 43187),
(43188, '3.40.50.2000-FF-000634', NULL, 'Glycosyltransferase', 269, NULL, NULL, 43188),
(43189, '3.40.720.10-FF-000145', NULL, 'Uncharacterized protein', 72, NULL, NULL, 43189),
(43190, '3.30.2350.10-FF-000012', NULL, 'tRNA pseudouridine synthase B', 223, NULL, NULL, 43190),
(43191, '1.10.238.10-FF-000174', NULL, 'Calcium-dependent protein kinase 4', 87, NULL, NULL, 43191),
(43192, '1.20.1070.10-FF-001713', NULL, 'Uncharacterized protein', 102, NULL, NULL, 43192),
(43193, '3.40.1110.10-FF-000458', NULL, NULL, 118, NULL, NULL, 43193),
(43194, '2.130.10.10-FF-004970', NULL, 'Uncharacterized protein', 86, NULL, NULL, 43194),
(43195, '3.40.50.300-FF-006010', NULL, 'DNA helicase', 199, NULL, NULL, 43195),
(43196, '3.30.160.60-FF-000428', NULL, 'PR domain zinc finger protein 10', 55, NULL, NULL, 43196),
(43197, '1.10.630.10-FF-000254', NULL, 'Uncharacterized protein', 356, NULL, NULL, 43197),
(43198, '1.20.1250.20-FF-000179', NULL, 'Solute carrier family 16 member 2', 193, NULL, NULL, 43198),
(43199, '3.90.70.10-FF-000230', NULL, 'Peptidase domain-containing ABC transporter', 144, NULL, NULL, 43199),
(43200, '3.90.640.10-FF-000206', NULL, 'Predicted protein', 110, NULL, NULL, 43200),
(43201, '3.40.1110.10-FF-000019', NULL, 'Phospholipid-transporting ATPase', 132, NULL, NULL, 43201),
(43202, '2.40.50.140-FF-001042', NULL, NULL, 123, NULL, NULL, 43202),
(43203, '1.25.10.10-FF-001651', NULL, 'Transport and golgi organization 6 homolog (Drosophila)', 385, NULL, NULL, 43203),
(43204, '1.10.10.10-FF-001499', NULL, 'Iron/manganese-dependent transcriptional regulator', 130, NULL, NULL, 43204),
(43205, '3.80.10.10-FF-000395', NULL, 'Reticulon 4 receptor like 2', 160, NULL, NULL, 43205),
(43206, '1.20.58.390-FF-000079', NULL, 'Cholinergic receptor, nicotinic, epsilon', 93, NULL, NULL, 43206),
(43207, '2.10.25.10-FF-000378', NULL, 'neurogenic locus notch homolog protein 2', 33, NULL, NULL, 43207),
(43208, '3.30.310.130-FF-000023', NULL, 'Si:dkey-100n23.3', 60, NULL, NULL, 43208),
(43209, '1.20.120.910-FF-000004', NULL, 'Conjugal transfer protein TraR', 73, NULL, NULL, 43209),
(43210, '3.30.160.60-FF-001417', NULL, 'zinc finger protein 423', 85, NULL, NULL, 43210),
(43211, '3.10.20.90-FF-000473', NULL, 'Auxin-responsive protein', 96, NULL, NULL, 43211),
(43212, '2.90.10.10-FF-000060', NULL, 'Putative S-locus receptor-like protein kinase family protein', 72, NULL, NULL, 43212),
(43213, '2.60.120.260-FF-000586', NULL, 'Si:ch73-40a2.1', 159, NULL, NULL, 43213),
(43214, '1.10.238.10-FF-000235', NULL, 'Probable calcium-binding protein CML15', 82, NULL, NULL, 43214),
(43215, '1.50.40.10-FF-000279', NULL, 'Mitochondrial carrier protein (Rim2), putative', 269, NULL, NULL, 43215),
(43216, '3.40.50.10140-FF-000080', NULL, 'Uncharacterized protein', 148, NULL, NULL, 43216),
(43217, '3.40.33.10-FF-000051', NULL, 'Protein CBG01191', 149, NULL, NULL, 43217),
(43218, '1.10.400.10-FF-000006', NULL, 'Guanine nucleotide-binding protein G(Z) subunit alpha', 120, NULL, NULL, 43218);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(43219, '1.10.520.10-FF-000072', NULL, 'Peroxidase 12', 18, NULL, NULL, 43219),
(43220, '2.40.420.20-FF-000056', NULL, 'RND superfamily efflux pump MFP component', 102, NULL, NULL, 43220),
(43221, '3.20.20.140-FF-000132', NULL, 'Amidohydrolase', 270, NULL, NULL, 43221),
(43222, '2.60.40.1760-FF-000018', NULL, 'Oligosaccharide 4-alpha-D-glucosyltransferase', 201, NULL, NULL, 43222),
(43223, '1.25.10.10-FF-002168', NULL, 'Coatomer subunit beta', 493, NULL, NULL, 43223),
(43224, '2.20.25.80-FF-000005', NULL, 'probable WRKY transcription factor 14', 81, NULL, NULL, 43224),
(43225, '3.30.160.810-FF-000006', NULL, '50S ribosomal protein L3', 63, NULL, NULL, 43225),
(43226, '3.30.420.40-FF-000460', NULL, 'Heat shock protein 70, putative', 64, NULL, NULL, 43226),
(43227, '1.10.8.140-FF-000018', NULL, 'AaceriAGL074Wp', 79, NULL, NULL, 43227),
(43228, '3.30.70.330-FF-002456', NULL, NULL, 84, NULL, NULL, 43228),
(43229, '3.30.479.20-FF-000066', NULL, 'Uncharacterized protein', 80, NULL, NULL, 43229),
(43230, '3.80.10.10-FF-000715', NULL, 'F-box and leucine-rich repeat protein 5', 148, NULL, NULL, 43230),
(43231, '1.10.510.10-FF-003533', NULL, NULL, 239, NULL, NULL, 43231),
(43232, '1.10.287.470-FF-000082', NULL, 'RND family efflux transporter MFP subunit', 26, NULL, NULL, 43232),
(43233, '2.170.130.10-FF-000051', NULL, NULL, 95, NULL, NULL, 43233),
(43234, '3.10.250.10-FF-000043', NULL, 'Lysyl oxidase homolog 3B', 104, NULL, NULL, 43234),
(43235, '2.60.450.20-FF-000014', NULL, 'Uncharacterized protein', 216, NULL, NULL, 43235),
(43236, '2.10.110.10-FF-000132', NULL, 'Pxl1p', 64, NULL, NULL, 43236),
(43237, '3.30.160.60-FF-000580', NULL, 'Zinc finger protein 512', 92, NULL, NULL, 43237),
(43238, '1.25.40.10-FF-004233', NULL, 'Uncharacterized protein', 250, NULL, NULL, 43238),
(43239, '3.30.160.60-FF-000900', NULL, 'Zinc finger and BTB domain containing 47', 27, NULL, NULL, 43239),
(43240, '1.25.40.420-FF-000006', NULL, 'RCC1 and BTB domain-containing protein 2 isoform X1', 61, NULL, NULL, 43240),
(43241, '3.90.230.10-FF-000012', NULL, 'ERBB-3 BINDING PROTEIN 1', 258, NULL, NULL, 43241),
(43242, '3.30.1740.10-FF-000002', NULL, 'Poly [ADP-ribose] polymerase', 111, NULL, NULL, 43242),
(43243, '3.30.200.20-FF-000763', NULL, 'Titin homolog', 126, NULL, NULL, 43243),
(43244, '3.40.50.1980-FF-000032', NULL, 'Ferrichrome ABC transporter substrate-bindingprotein', 90, NULL, NULL, 43244),
(43245, '1.20.58.1030-FF-000045', NULL, 'DNA replication complex GINS protein SLD5', 48, NULL, NULL, 43245),
(43246, '2.60.40.3510-FF-000010', NULL, 'Delta-like protein', 164, NULL, NULL, 43246),
(43247, '3.30.230.10-FF-000262', NULL, 'Uncharacterized protein', 119, NULL, NULL, 43247),
(43248, '2.130.10.10-FF-005807', NULL, 'WD repeat domain 19', 86, NULL, NULL, 43248),
(43249, '3.30.70.3290-FF-000001', NULL, 'Probable polyketide synthase Pks8', 131, NULL, NULL, 43249),
(43250, '1.25.10.10-FF-002640', NULL, 'Uncharacterized protein', 119, NULL, NULL, 43250),
(43251, '2.40.10.170-FF-000020', NULL, 'ATP synthase subunit beta', 74, NULL, NULL, 43251),
(43252, '1.50.10.10-FF-000098', NULL, 'Glucanase', 494, NULL, NULL, 43252),
(43253, '1.10.10.10-FF-001532', NULL, 'Two-component response regulator, SAPR family, consists of REC, wHTH and BTAD domains', 92, NULL, NULL, 43253),
(43254, '3.40.50.980-FF-000059', NULL, 'Acyl-CoA ligase easD', 147, NULL, NULL, 43254),
(43255, '3.40.800.20-FF-000003', NULL, 'Histone deacetylase', 374, NULL, NULL, 43255),
(43256, '3.40.50.300-FF-006510', NULL, 'Uncharacterized protein', 112, NULL, NULL, 43256),
(43257, '3.30.30.30-FF-000045', NULL, 'Uncharacterized protein', 56, NULL, NULL, 43257),
(43258, '1.10.8.10-FF-000031', NULL, 'Elongation factor Ts, mitochondrial', 60, NULL, NULL, 43258),
(43259, '1.20.920.10-FF-000156', NULL, 'ATPase family AAA domain-containing protein 2B', 135, NULL, NULL, 43259),
(43260, '2.60.40.10-FF-001440', NULL, 'CD101 molecule', 128, NULL, NULL, 43260),
(43261, '3.40.50.10260-FF-000031', NULL, 'enhancer of mRNA-decapping protein 3-like', 263, NULL, NULL, 43261),
(43262, '3.30.530.20-FF-000164', NULL, 'Uncharacterized protein', 132, NULL, NULL, 43262);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(43263, '1.20.1410.10-FF-000032', NULL, 'Predicted protein', 154, NULL, NULL, 43263),
(43264, '3.40.50.150-FF-001272', NULL, NULL, 228, NULL, NULL, 43264),
(43265, '3.40.50.1000-FF-000643', NULL, NULL, 171, NULL, NULL, 43265),
(43266, '1.25.40.10-FF-000051', NULL, 'Cell division cycle protein 27 isoform X3', 104, NULL, NULL, 43266),
(43267, '3.40.630.10-FF-000346', NULL, 'Carboxypeptidase, putative', 225, NULL, NULL, 43267),
(43268, '2.30.180.10-FF-000036', NULL, 'Stabilin 1', 125, NULL, NULL, 43268),
(43269, '3.40.50.2300-FF-000634', NULL, 'Vomeronasal 2, receptor 120', 137, NULL, NULL, 43269),
(43270, '3.40.50.1100-FF-000055', NULL, 'Threonine synthase', 97, NULL, NULL, 43270),
(43271, '3.40.50.11260-FF-000022', NULL, 'Endoplasmin homolog', 87, NULL, NULL, 43271),
(43272, '1.25.40.720-FF-000006', NULL, 'Telomere binding protein', 87, NULL, NULL, 43272),
(43273, '3.10.450.10-FF-000024', NULL, 'Cystatin F', 108, NULL, NULL, 43273),
(43274, '1.25.40.10-FF-002288', NULL, 'Pentatricopeptide repeat-containing protein At5g27460', 82, NULL, NULL, 43274),
(43275, '3.40.50.2300-FF-001123', NULL, NULL, 93, NULL, NULL, 43275),
(43276, '3.30.420.10-FF-000445', NULL, NULL, 205, NULL, NULL, 43276),
(43277, '1.20.1250.20-FF-002124', NULL, 'Solute carrier family 22 member 21', 216, NULL, NULL, 43277),
(43278, '2.130.10.10-FF-005487', NULL, 'Uncharacterized protein', 125, NULL, NULL, 43278),
(43279, '1.10.720.30-FF-000059', NULL, 'Ubiquitin-conjugating enzyme', 35, NULL, NULL, 43279),
(43280, '1.10.510.10-FF-002252', NULL, NULL, 237, NULL, NULL, 43280),
(43281, '2.130.10.10-FF-005015', NULL, 'Uncharacterized protein', 20, NULL, NULL, 43281),
(43282, '1.25.40.10-FF-001832', NULL, 'Pentatricopeptide repeat-containing protein At3g16610', 99, NULL, NULL, 43282),
(43283, '1.20.5.100-FF-000004', NULL, 'Integrin beta', 73, NULL, NULL, 43283),
(43284, '3.30.1360.120-FF-000012', NULL, 'sarcosine dehydrogenase, mitochondrial', 206, NULL, NULL, 43284),
(43285, '3.30.10.10-FF-000004', NULL, 'Serine proteinase inhibitor', 66, NULL, NULL, 43285),
(43286, '2.130.10.10-FF-005307', NULL, 'Predicted protein', 212, NULL, NULL, 43286),
(43287, '2.130.10.10-FF-002553', NULL, 'Dynein assembly factor with WDR repeat domains 1', 111, NULL, NULL, 43287),
(43288, '1.10.20.10-FF-000336', NULL, NULL, 109, NULL, NULL, 43288),
(43289, '2.40.70.10-FF-000442', NULL, NULL, 89, NULL, NULL, 43289),
(43290, '2.10.25.10-FF-000878', NULL, 'Otogelin-like', 61, NULL, NULL, 43290),
(43291, '3.80.10.10-FF-002340', NULL, 'Uncharacterized protein', 89, NULL, NULL, 43291),
(43292, '3.90.190.10-FF-000424', NULL, 'Uncharacterized protein', 82, NULL, NULL, 43292),
(43293, '3.40.1190.10-FF-000030', NULL, 'UDP-N-acetylmuramoyl-L-alanyl-D-glutamate--2,6-diaminopimelate ligase', 232, NULL, NULL, 43293),
(43294, '1.25.10.10-FF-000223', NULL, 'Serine/threonine-protein kinase TIO', 270, NULL, NULL, 43294),
(43295, '1.20.58.1480-FF-000011', NULL, 'Lon protease homolog 2, peroxisomal', 110, NULL, NULL, 43295),
(43296, '2.40.70.10-FF-000150', NULL, 'Gag-Pro polyprotein', 110, NULL, NULL, 43296),
(43297, '1.25.40.450-FF-000021', NULL, 'Uncharacterized protein', 112, NULL, NULL, 43297),
(43298, '3.30.450.50-FF-000026', NULL, 'SNARE protein', 137, NULL, NULL, 43298),
(43299, '1.25.40.10-FF-001540', NULL, 'Os07g0598500 protein', 217, NULL, NULL, 43299),
(43300, '3.10.100.10-FF-000268', NULL, NULL, 72, NULL, NULL, 43300),
(43301, '3.40.1390.10-FF-000006', NULL, 'UDP-N-acetylmuramoyl-L-alanyl-D-glutamate--2,6-diaminopimelate ligase', 110, NULL, NULL, 43301),
(43302, '1.10.150.20-FF-000001', NULL, 'DNA-directed RNA polymerase subunit alpha', 86, NULL, NULL, 43302),
(43303, '3.40.33.10-FF-000112', NULL, 'Uncharacterized protein', 118, NULL, NULL, 43303),
(43304, '4.10.910.10-FF-000005', NULL, '30S ribosomal protein S13, chloroplastic', 50, NULL, NULL, 43304),
(43305, '2.60.40.10-FF-004666', NULL, NULL, 99, NULL, NULL, 43305),
(43306, '3.40.50.11620-FF-000001', NULL, 'Phosphotransferase RcsD', 113, NULL, NULL, 43306),
(43307, '1.20.58.80-FF-000084', NULL, 'Uncharacterized protein', 136, NULL, NULL, 43307);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(43308, '3.60.10.10-FF-000025', NULL, 'Angel homolog 1 (Drosophila)', 371, NULL, NULL, 43308),
(43309, '1.25.40.20-FF-001189', NULL, 'Ankyrin repeat and SOCS box containing 5', 165, NULL, NULL, 43309),
(43310, '2.160.20.70-FF-000041', NULL, 'Uncharacterized protein', 140, NULL, NULL, 43310),
(43311, '1.10.510.10-FF-002105', NULL, NULL, 129, NULL, NULL, 43311),
(43312, '1.20.272.40-FF-000012', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 56, NULL, NULL, 43312),
(43313, '3.30.160.60-FF-005251', NULL, NULL, 64, NULL, NULL, 43313),
(43314, '3.40.50.300-FF-007258', NULL, 'Uncharacterized protein', 158, NULL, NULL, 43314),
(43315, '2.60.40.150-FF-000156', NULL, 'E3 ubiquitin-protein ligase', 127, NULL, NULL, 43315),
(43316, '2.30.29.30-FF-000959', NULL, 'Uncharacterized protein', 111, NULL, NULL, 43316),
(43317, '1.10.533.10-FF-000051', NULL, 'Baculoviral IAP repeat containing 2', 123, NULL, NULL, 43317),
(43318, '3.30.160.60-FF-001097', NULL, 'IKAROS family zinc finger 5', 33, NULL, NULL, 43318),
(43319, '3.80.10.10-FF-003621', NULL, 'Uncharacterized protein', 81, NULL, NULL, 43319),
(43320, '1.10.630.10-FF-000754', NULL, 'Uncharacterized protein', 55, NULL, NULL, 43320),
(43321, '1.10.150.20-FF-000181', NULL, 'Exonuclease I, putative', 79, NULL, NULL, 43321),
(43322, '1.10.510.10-FF-002544', NULL, 'Cysteine-rich receptor-like protein kinase 40', 298, NULL, NULL, 43322),
(43323, '3.90.226.10-FF-000053', NULL, 'Tricorn protease homolog', 213, NULL, NULL, 43323),
(43324, '3.30.70.330-FF-001528', NULL, NULL, 90, NULL, NULL, 43324),
(43325, '3.40.50.1240-FF-000131', NULL, NULL, 144, NULL, NULL, 43325),
(43326, '2.60.120.200-FF-000175', NULL, 'Laminin subunit alpha 5', 173, NULL, NULL, 43326),
(43327, '1.20.58.60-FF-000459', NULL, 'AGAP009554-PA', 278, NULL, NULL, 43327),
(43328, '2.60.120.260-FF-000086', NULL, 'Non-specific cytotoxic cell receptor protein 1', 183, NULL, NULL, 43328),
(43329, '3.40.30.10-FF-000370', NULL, 'Peroxiredoxin', 159, NULL, NULL, 43329),
(43330, '3.80.10.10-FF-001643', NULL, 'Toll-like receptor 13', 179, NULL, NULL, 43330),
(43331, '3.30.250.20-FF-000002', NULL, 'LINE1 type transposase domain containing 1', 68, NULL, NULL, 43331),
(43332, '1.25.40.20-FF-000700', NULL, 'Mann-cup, isoform B', 82, NULL, NULL, 43332),
(43333, '1.10.600.10-FF-000134', NULL, 'Uncharacterized protein', 54, NULL, NULL, 43333),
(43334, '3.30.200.20-FF-001691', NULL, 'Leucine-rich repeat receptor kinase-like protein', 66, NULL, NULL, 43334),
(43335, '3.30.700.40-FF-000003', NULL, NULL, 145, NULL, NULL, 43335),
(43336, '3.20.20.80-FF-000475', NULL, 'Uncharacterized protein', 310, NULL, NULL, 43336),
(43337, '1.25.40.20-FF-000880', NULL, 'Uncharacterized protein', 257, NULL, NULL, 43337),
(43338, '3.10.20.90-FF-000973', NULL, 'Uncharacterized protein', 101, NULL, NULL, 43338),
(43339, '1.20.120.610-FF-000004', NULL, 'V-type ATP synthase subunit K', 150, NULL, NULL, 43339),
(43340, '1.10.10.10-FF-000251', NULL, 'Transcriptional regulator, GntR family', 78, NULL, NULL, 43340),
(43341, '3.30.60.20-FF-000044', NULL, 'SH3 and cysteine-rich domain-containing protein', 59, NULL, NULL, 43341),
(43342, '3.10.50.40-FF-000067', NULL, 'Peptidylprolyl isomerase', 122, NULL, NULL, 43342),
(43343, '3.30.160.60-FF-002406', NULL, 'Zinc finger and BTB domain containing 11', 29, NULL, NULL, 43343),
(43344, '1.20.120.350-FF-000229', NULL, NULL, 128, NULL, NULL, 43344),
(43345, '3.40.50.1820-FF-001165', NULL, 'Methyl esterase 10', 94, NULL, NULL, 43345),
(43346, '1.20.1280.290-FF-000001', NULL, 'Bidirectional sugar transporter SWEET', 91, NULL, NULL, 43346),
(43347, '4.10.80.30-FF-000001', NULL, 'Putative autolysin, N-acetylmuramidase', 27, NULL, NULL, 43347),
(43348, '1.10.238.10-FF-000999', NULL, 'Repetin', 65, NULL, NULL, 43348),
(43349, '1.25.10.10-FF-000370', NULL, 'phosphoinositide 3-kinase regulatory subunit 4-like', 140, NULL, NULL, 43349),
(43350, '2.60.40.10-FF-003238', NULL, 'Ig delta chain C region membrane-bound form', 91, NULL, NULL, 43350),
(43351, '2.40.37.10-FF-000062', NULL, NULL, 94, NULL, NULL, 43351);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(43352, '4.10.240.10-FF-000212', NULL, 'Uncharacterized protein', 63, NULL, NULL, 43352),
(43353, '1.50.10.10-FF-000131', NULL, 'alpha-1,2-Mannosidase', 63, NULL, NULL, 43353),
(43354, '1.25.40.10-FF-001299', NULL, 'Pentatricopeptide repeat-containing protein At5g39980, chloroplastic', 120, NULL, NULL, 43354),
(43355, '2.40.50.140-FF-000053', NULL, 'Elongation factor P-like protein', 65, NULL, NULL, 43355),
(43356, '2.120.10.80-FF-000045', NULL, 'leucine-zipper-like transcriptional regulator 1 isoform X1', 180, NULL, NULL, 43356),
(43357, '3.40.50.300-FF-001659', NULL, 'Peptide ABC transporter ATP-binding protein', 331, NULL, NULL, 43357),
(43358, '1.10.630.10-FF-000607', NULL, 'Uncharacterized protein', 259, NULL, NULL, 43358),
(43359, '1.10.1070.11-FF-000008', NULL, 'serine/threonine-protein kinase SMG1 isoform X2', 190, NULL, NULL, 43359),
(43360, '1.10.555.10-FF-000096', NULL, 'Chromosome 1, whole genome shotgun sequence', 210, NULL, NULL, 43360),
(43361, '1.25.40.20-FF-001217', NULL, 'Uncharacterized protein', 100, NULL, NULL, 43361),
(43362, '1.20.58.90-FF-000002', NULL, 'syntaxin-6 isoform X1', 109, NULL, NULL, 43362),
(43363, '3.40.50.150-FF-000283', NULL, 'Class I SAM-dependent methyltransferase', 179, NULL, NULL, 43363),
(43364, '2.60.120.620-FF-000126', NULL, 'Uncharacterized protein', 87, NULL, NULL, 43364),
(43365, '3.40.50.1440-FF-000039', NULL, 'Tubulin gamma chain', 268, NULL, NULL, 43365),
(43366, '1.20.1740.10-FF-000225', NULL, 'Amino-acid permease 1', 448, NULL, NULL, 43366),
(43367, '3.40.50.2300-FF-000134', NULL, 'Autolysin response regulator LytR', 130, NULL, NULL, 43367),
(43368, '2.70.70.10-FF-000019', NULL, 'M23 family peptidase', 156, NULL, NULL, 43368),
(43369, '3.40.605.10-FF-000041', NULL, 'Aldehyde dehydrogenase 1 family member A3', 94, NULL, NULL, 43369),
(43370, '3.30.1320.10-FF-000010', NULL, '30S ribosomal protein S16', 88, NULL, NULL, 43370),
(43371, '3.20.20.80-FF-000183', NULL, 'Glycosyl hydrolase family 25', 229, NULL, NULL, 43371),
(43372, '1.25.10.10-FF-001712', NULL, 'Sister chromatid cohesion protein', 236, NULL, NULL, 43372),
(43373, '3.40.50.360-FF-000109', NULL, 'Multimeric flavodoxin WrbA-like protein', 166, NULL, NULL, 43373),
(43374, '3.40.120.10-FF-000055', NULL, 'Phosphomannomutase PmmB', 129, NULL, NULL, 43374),
(43375, '3.30.70.330-FF-001500', NULL, NULL, 113, NULL, NULL, 43375),
(43376, '3.40.50.620-FF-000709', NULL, '7-cyano-7-deazaguanine synthase', 222, NULL, NULL, 43376),
(43377, '1.10.730.20-FF-000028', NULL, 'Isoleucyl-tRNA synthetase', 198, NULL, NULL, 43377),
(43378, '1.10.472.170-FF-000010', NULL, 'Transcription initiation factor IIB', 140, NULL, NULL, 43378),
(43379, '2.60.120.920-FF-000065', NULL, 'Ear1p', 215, NULL, NULL, 43379),
(43380, '3.30.310.50-FF-000016', NULL, 'Phosphomannomutase', 83, NULL, NULL, 43380),
(43381, '2.40.50.100-FF-000148', NULL, 'Vacuolar ATP synthase catalytic subunit A', 87, NULL, NULL, 43381),
(43382, '2.40.10.10-FF-000433', NULL, NULL, 121, NULL, NULL, 43382),
(43383, '3.40.640.10-FF-000291', NULL, 'Aromatic amino acid aminotransferase, putative', 518, NULL, NULL, 43383),
(43384, '3.40.50.300-FF-005813', NULL, 'Dynein heavy chain', 247, NULL, NULL, 43384),
(43385, '1.10.10.10-FF-001971', NULL, 'Chromosome 1, whole genome shotgun sequence', 65, NULL, NULL, 43385),
(43386, '4.10.410.10-FF-000012', NULL, 'Tissue factor pathway inhibitor', 68, NULL, NULL, 43386),
(43387, '1.10.10.10-FF-000543', NULL, 'Transcriptional regulator, GntR family', 81, NULL, NULL, 43387),
(43388, '1.20.1270.10-FF-000060', NULL, 'Heat shock protein 70-related protein', 73, NULL, NULL, 43388),
(43389, '1.10.287.1040-FF-000018', NULL, 'Exodeoxyribonuclease 7 small subunit', 59, NULL, NULL, 43389),
(43390, '2.60.40.60-FF-000033', NULL, 'FAT atypical cadherin 1', 106, NULL, NULL, 43390),
(43391, '3.30.460.10-FF-000071', NULL, 'Predicted protein', 133, NULL, NULL, 43391),
(43392, '2.40.50.140-FF-000845', NULL, NULL, 63, NULL, NULL, 43392),
(43393, '2.30.29.30-FF-000398', NULL, 'FACT complex subunit POB3', 99, NULL, NULL, 43393),
(43394, '1.10.472.80-FF-000002', NULL, 'Ecotropic viral integration site 5', 151, NULL, NULL, 43394);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(43395, '3.40.50.300-FF-003604', NULL, 'Small Rab GTPase, putative', 172, NULL, NULL, 43395),
(43396, '1.10.472.80-FF-000182', NULL, NULL, 94, NULL, NULL, 43396),
(43397, '3.100.10.10-FF-000049', NULL, NULL, 89, NULL, NULL, 43397),
(43398, '3.30.559.10-FF-000210', NULL, 'Siderophore peptide synthetase fer3', 196, NULL, NULL, 43398),
(43399, '1.25.40.10-FF-005194', NULL, 'Uncharacterized protein', 221, NULL, NULL, 43399),
(43400, '3.90.1150.10-FF-000409', NULL, 'Aspartate aminotransferase', 92, NULL, NULL, 43400),
(43401, '3.30.930.10-FF-000383', NULL, 'Lipoate protein ligase', 232, NULL, NULL, 43401),
(43402, '3.30.40.10-FF-001293', NULL, 'Uncharacterized protein', 81, NULL, NULL, 43402),
(43403, '3.40.1350.10-FF-000032', NULL, 'Predicted protein', 84, NULL, NULL, 43403),
(43404, '3.30.70.330-FF-002809', NULL, NULL, 147, NULL, NULL, 43404),
(43405, '3.30.565.10-FF-000331', NULL, 'Two-component sensor histidine kinase', 163, NULL, NULL, 43405),
(43406, '1.20.5.170-FF-000244', NULL, 'X-box-binding protein 1', 54, NULL, NULL, 43406),
(43407, '3.40.50.300-FF-004532', NULL, 'GL13229', 102, NULL, NULL, 43407),
(43408, '3.30.110.150-FF-000001', NULL, 'Cell division protein SepF', 83, NULL, NULL, 43408),
(43409, '3.10.20.90-FF-000181', NULL, 'transmembrane and ubiquitin-like domain-containing protein 1', 69, NULL, NULL, 43409),
(43410, '3.30.450.20-FF-000455', NULL, 'Response receiver sensor histidine kinase, PAS domain-containing', 116, NULL, NULL, 43410),
(43411, '3.10.620.30-FF-000010', NULL, 'Peptide-N(4)-(N-acetyl-beta-glucosaminyl)asparagine amidase', 173, NULL, NULL, 43411),
(43412, '3.80.10.10-FF-004138', NULL, 'Uncharacterized protein', 281, NULL, NULL, 43412),
(43413, '4.10.960.10-FF-000008', NULL, 'Uncharacterized protein', 17, NULL, NULL, 43413),
(43414, '1.25.40.10-FF-002316', NULL, 'UTP6 small subunit processome component', 102, NULL, NULL, 43414),
(43415, '1.25.10.10-FF-001179', NULL, 'HEAT repeat domain containing protein', 563, NULL, NULL, 43415),
(43416, '2.60.120.290-FF-000162', NULL, 'Adhesion G protein-coupled receptor L3', 122, NULL, NULL, 43416),
(43417, '3.30.70.330-FF-000039', NULL, 'U1 small nuclear ribonucleoprotein A', 105, NULL, NULL, 43417),
(43418, '3.30.56.30-FF-000003', NULL, 'Signal recognition particle SEC65 subunit', 118, NULL, NULL, 43418),
(43419, '3.30.1360.40-FF-000032', NULL, 'Ribosomal recycling factor, mitochondrial, putative', 81, NULL, NULL, 43419),
(43420, '1.10.1740.10-FF-000031', NULL, 'RNA polymerase sigma factor', 86, NULL, NULL, 43420),
(43421, '3.10.110.10-FF-000033', NULL, 'NEDD8-conjugating enzyme UBE2F', 165, NULL, NULL, 43421),
(43422, '3.30.1120.70-FF-000001', NULL, 'Lambda phage portal protein B', 50, NULL, NULL, 43422),
(43423, '3.40.395.10-FF-000006', NULL, 'sentrin-specific protease 5 isoform X2', 99, NULL, NULL, 43423),
(43424, '3.40.1410.10-FF-000003', NULL, 'GntR family transcriptional regulator', 163, NULL, NULL, 43424),
(43425, '2.10.25.160-FF-000001', NULL, 'Granulin precursor', 60, NULL, NULL, 43425),
(43426, '3.40.50.2000-FF-000342', NULL, 'Related to alpha,alpha-trehalose-phosphate synthase, 115 KD subunit', 255, NULL, NULL, 43426),
(43427, '1.10.246.130-FF-000011', NULL, 'Probable bifunctional acylase ggtA: cephalosporin acylase + gamma-glutamyltranspeptidase', 110, NULL, NULL, 43427),
(43428, '3.30.70.660-FF-000054', NULL, 'tRNA pseudouridine synthase', 157, NULL, NULL, 43428),
(43429, '3.40.50.1820-FF-000237', NULL, 'Acetyl xylan esterase', 315, NULL, NULL, 43429),
(43430, '1.20.1070.10-FF-001421', NULL, 'Olfactory receptor', 229, NULL, NULL, 43430),
(43431, '3.90.190.10-FF-000396', NULL, 'Slr1617 protein', 104, NULL, NULL, 43431),
(43432, '3.30.40.10-FF-000657', NULL, 'E3 ubiquitin-protein ligase RGLG1', 59, NULL, NULL, 43432),
(43433, '1.10.8.60-FF-000405', NULL, 'AAA-type ATPase family protein isoform 3', 44, NULL, NULL, 43433),
(43434, '3.30.160.20-FF-000175', NULL, 'Uncharacterized protein', 70, NULL, NULL, 43434),
(43435, '2.70.150.10-FF-000267', NULL, 'Uncharacterized protein', 108, NULL, NULL, 43435),
(43436, '3.30.70.250-FF-000021', NULL, NULL, 63, NULL, NULL, 43436);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(43437, '3.40.47.10-FF-000021', NULL, 'Fatty acid synthase subunit alpha', 601, NULL, NULL, 43437),
(43438, '1.10.455.10-FF-000032', NULL, '30S ribosomal protein S7', 208, NULL, NULL, 43438),
(43439, '3.40.50.300-FF-005021', NULL, 'Predicted protein', 135, NULL, NULL, 43439),
(43440, '1.20.1560.10-FF-000599', NULL, 'Predicted protein', 63, NULL, NULL, 43440),
(43441, '3.60.21.60-FF-000043', NULL, 'Uncharacterized protein', 111, NULL, NULL, 43441),
(43442, '1.25.40.10-FF-003777', NULL, 'Uncharacterized protein', 321, NULL, NULL, 43442),
(43443, '3.40.50.2300-FF-000926', NULL, NULL, 137, NULL, NULL, 43443),
(43444, '1.20.120.1900-FF-000044', NULL, 'gamma-tubulin complex component 6 isoform X3', 95, NULL, NULL, 43444),
(43445, '1.10.560.10-FF-000046', NULL, '60 kDa chaperonin', 245, NULL, NULL, 43445),
(43446, '2.10.220.10-FF-000022', NULL, 'proprotein convertase subtilisin/kexin type 5 isoform X2', 104, NULL, NULL, 43446),
(43447, '3.30.360.10-FF-000035', NULL, 'Galactose 1-dehydrogenase', 192, NULL, NULL, 43447),
(43448, '3.40.390.10-FF-000310', NULL, NULL, 117, NULL, NULL, 43448),
(43449, '1.10.8.10-FF-000323', NULL, 'Uncharacterized protein', 75, NULL, NULL, 43449),
(43450, '2.30.30.190-FF-000032', NULL, NULL, 83, NULL, NULL, 43450),
(43451, '1.20.58.60-FF-000870', NULL, 'Uncharacterized protein', 119, NULL, NULL, 43451),
(43452, '3.30.1490.20-FF-000030', NULL, 'Acetyl coenzyme A synthetase (ADP forming), alpha domain-containing protein', 77, NULL, NULL, 43452),
(43453, '3.40.640.10-FF-000111', NULL, 'Cystathionine gamma-synthase', 220, NULL, NULL, 43453),
(43454, '1.10.10.60-FF-001261', NULL, NULL, 48, NULL, NULL, 43454),
(43455, '2.130.10.10-FF-001272', NULL, 'WD domain, G-beta repeat-containing protein', 153, NULL, NULL, 43455),
(43456, '3.30.160.60-FF-001389', NULL, 'Zinc finger and AT-hook domain containing', 67, NULL, NULL, 43456),
(43457, '3.40.50.150-FF-001564', NULL, NULL, 73, NULL, NULL, 43457),
(43458, '3.30.930.10-FF-000236', NULL, 'Proline--tRNA ligase, cytoplasmic', 87, NULL, NULL, 43458),
(43459, '1.10.8.60-FF-000585', NULL, 'Katanin-like protein', 18, NULL, NULL, 43459),
(43460, '1.10.287.950-FF-000012', NULL, 'Methyl-accepting chemotaxis protein', 304, NULL, NULL, 43460),
(43461, '3.30.540.10-FF-000072', NULL, 'Uncharacterized protein', 173, NULL, NULL, 43461),
(43462, '3.30.1300.10-FF-000008', NULL, 'Pantothenate synthetase', 73, NULL, NULL, 43462),
(43463, '2.30.29.30-FF-000931', NULL, 'Predicted protein', 129, NULL, NULL, 43463),
(43464, '3.40.630.30-FF-000032', NULL, 'Aminoalkylphosphonic acid N-acetyltransferase', 139, NULL, NULL, 43464),
(43465, '3.40.50.300-FF-005993', NULL, 'Orc1-type DNA replication protein', 163, NULL, NULL, 43465),
(43466, '1.20.58.400-FF-000037', NULL, 'Predicted protein', 91, NULL, NULL, 43466),
(43467, '3.90.950.10-FF-000016', NULL, 'dTTP/UTP pyrophosphatase', 190, NULL, NULL, 43467),
(43468, '2.10.25.10-FF-000086', NULL, 'Fibrillin 2', 39, NULL, NULL, 43468),
(43469, '3.40.50.300-FF-000350', NULL, 'RNA polymerase-associated protein RapA', 153, NULL, NULL, 43469),
(43470, '3.40.50.720-FF-002538', NULL, 'Malic enzyme', 76, NULL, NULL, 43470),
(43471, '3.30.559.10-FF-000238', NULL, 'Uncharacterized protein', 150, NULL, NULL, 43471),
(43472, '2.60.40.10-FF-003385', NULL, NULL, 98, NULL, NULL, 43472),
(43473, '1.10.287.130-FF-000238', NULL, 'Circadian input kinase A', 93, NULL, NULL, 43473),
(43474, '2.180.10.10-FF-000022', NULL, 'Protein CBR-TEN-1', 594, NULL, NULL, 43474),
(43475, '3.30.70.890-FF-000038', NULL, 'Diphosphomevalonate decarboxylase', 135, NULL, NULL, 43475),
(43476, '3.30.1490.20-FF-000058', NULL, 'UvrABC system protein A', 70, NULL, NULL, 43476),
(43477, '2.30.30.1020-FF-000034', NULL, NULL, 188, NULL, NULL, 43477),
(43478, '3.40.50.300-FF-002587', NULL, 'Multidrug ABC transporter ATP-binding protein', 253, NULL, NULL, 43478),
(43479, '3.10.20.90-FF-000001', NULL, 'Probable polyubiquitin', 76, NULL, NULL, 43479),
(43480, '1.20.1250.20-FF-000207', NULL, 'Solute carrier organic anion transporter family member', 361, NULL, NULL, 43480);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(43481, '3.10.180.10-FF-000099', NULL, 'Glyoxalase family protein', 133, NULL, NULL, 43481),
(43482, '3.30.1370.10-FF-000193', NULL, 'High density lipoprotein-binding protein a', 93, NULL, NULL, 43482),
(43483, '1.10.287.80-FF-000015', NULL, 'ATP synthase gamma chain', 101, NULL, NULL, 43483),
(43484, '4.10.280.10-FF-000125', NULL, 'Transcription factor EGL1', 73, NULL, NULL, 43484),
(43485, '1.10.274.10-FF-000004', NULL, 'Phosphotransferase system fructose-specific transporter subunit EI/HPr/EIIA', 119, NULL, NULL, 43485),
(43486, '1.20.58.340-FF-000025', NULL, 'CorA Metal Ion Transporter (MIT) Family', 173, NULL, NULL, 43486),
(43487, '3.30.160.60-FF-001917', NULL, 'Zinc finger and SCAN domain containing 10', 25, NULL, NULL, 43487),
(43488, '3.40.50.300-FF-003868', NULL, 'Uncharacterized protein', 188, NULL, NULL, 43488),
(43489, '1.25.40.20-FF-001717', NULL, 'Uncharacterized protein', 237, NULL, NULL, 43489),
(43490, '1.20.1070.10-FF-001213', NULL, 'Uncharacterized protein', 313, NULL, NULL, 43490),
(43491, '1.10.565.10-FF-000186', NULL, 'Uncharacterized protein', 101, NULL, NULL, 43491),
(43492, '1.20.5.170-FF-000036', NULL, 'ABSCISIC ACID-INSENSITIVE 5-like protein 2', 53, NULL, NULL, 43492),
(43493, '1.25.10.10-FF-001151', NULL, 'Uncharacterized protein', 406, NULL, NULL, 43493),
(43494, '3.40.449.10-FF-000003', NULL, 'Phosphoenolpyruvate carboxykinase, cytosolic [GTP]', 216, NULL, NULL, 43494),
(43495, '2.170.16.10-FF-000030', NULL, 'Transcriptional regulator, XRE family', 120, NULL, NULL, 43495),
(43496, '3.30.160.60-FF-001861', NULL, 'Protein tramtrack, beta isoform', 32, NULL, NULL, 43496),
(43497, '3.10.20.30-FF-000062', NULL, 'Sulfur carrier protein ThiS', 66, NULL, NULL, 43497),
(43498, '1.25.40.10-FF-000079', NULL, 'WD and tetratricopeptide repeats protein 1', 120, NULL, NULL, 43498),
(43499, '1.20.120.1750-FF-000038', NULL, 'RBR-type E3 ubiquitin transferase', 98, NULL, NULL, 43499),
(43500, '3.30.70.330-FF-001175', NULL, 'Heterogeneous nuclear ribonucleoprotein A3', 128, NULL, NULL, 43500),
(43501, '1.25.40.20-FF-001661', NULL, 'Uncharacterized protein', 250, NULL, NULL, 43501),
(43502, '1.20.58.390-FF-000107', NULL, 'AcetylCholine Receptor', 77, NULL, NULL, 43502),
(43503, '2.30.130.10-FF-000033', NULL, 'Ribosome biogenesis protein NIP7, putative', 54, NULL, NULL, 43503),
(43504, '3.10.50.40-FF-000100', NULL, 'Peptidylprolyl isomerase', 77, NULL, NULL, 43504),
(43505, '1.20.140.10-FF-000034', NULL, 'Acyl-coenzyme A oxidase', 132, NULL, NULL, 43505),
(43506, '1.20.1250.20-FF-001427', NULL, 'Solute carrier organic anion transporter family member', 161, NULL, NULL, 43506),
(43507, '4.10.60.10-FF-000163', NULL, 'Vasa', 33, NULL, NULL, 43507),
(43508, '3.30.450.20-FF-000663', NULL, 'PAS sensor protein', 112, NULL, NULL, 43508),
(43509, '1.20.58.390-FF-000051', NULL, 'Cholinergic receptor, nicotinic, alpha 6', 79, NULL, NULL, 43509),
(43510, '3.40.228.10-FF-000001', NULL, 'Periplasmic nitrate reductase', 274, NULL, NULL, 43510),
(43511, '2.70.20.10-FF-000016', NULL, 'DNA topoisomerase', 78, NULL, NULL, 43511),
(43512, '1.10.472.10-FF-000234', NULL, 'Cyclin family protein', 107, NULL, NULL, 43512),
(43513, '3.80.10.10-FF-003560', NULL, 'Uncharacterized protein', 148, NULL, NULL, 43513),
(43514, '2.70.50.40-FF-000004', NULL, 'protein unc-119 homolog A isoform X3', 178, NULL, NULL, 43514),
(43515, '2.60.120.260-FF-000647', NULL, 'Uncharacterized protein', 98, NULL, NULL, 43515),
(43516, '3.30.200.20-FF-001460', NULL, 'TUBE', 104, NULL, NULL, 43516),
(43517, '1.10.340.30-FF-000013', NULL, 'DNA-3-methyladenine glycosylase II', 121, NULL, NULL, 43517),
(43518, '1.20.1510.10-FF-000096', NULL, NULL, 197, NULL, NULL, 43518),
(43519, '1.10.10.440-FF-000078', NULL, 'Uncharacterized protein', 76, NULL, NULL, 43519),
(43520, '1.20.120.790-FF-000013', NULL, 'Heat shock protein 90, putative', 147, NULL, NULL, 43520),
(43521, '3.30.420.10-FF-000153', NULL, 'Bifunctional RNase H/acid phosphatase', 140, NULL, NULL, 43521),
(43522, '1.20.5.110-FF-000125', NULL, 'Vesicule-associated membrane protein, putative', 104, NULL, NULL, 43522);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(43523, '2.10.25.10-FF-001042', NULL, 'HL01444p', 38, NULL, NULL, 43523),
(43524, '3.90.1480.20-FF-000050', NULL, 'ST3 beta-galactoside alpha-2,3-sialyltransferase 3a', 176, NULL, NULL, 43524),
(43525, '3.40.50.12470-FF-000019', NULL, NULL, 106, NULL, NULL, 43525),
(43526, '1.20.140.80-FF-000010', NULL, 'Uncharacterized protein', 136, NULL, NULL, 43526),
(43527, '1.10.510.10-FF-004461', NULL, NULL, 281, NULL, NULL, 43527),
(43528, '2.60.40.1180-FF-000204', NULL, 'Alpha-L-fucosidase', 111, NULL, NULL, 43528),
(43529, '3.90.1770.10-FF-000001', NULL, 'acetyl-CoA carboxylase 1', 45, NULL, NULL, 43529),
(43530, '3.40.50.1000-FF-000351', NULL, 'Trehalose-6-phosphatase synthase S4', 149, NULL, NULL, 43530),
(43531, '3.40.605.10-FF-000102', NULL, 'Uncharacterized protein', 144, NULL, NULL, 43531),
(43532, '1.20.140.100-FF-000007', NULL, 'Dynein axonemal heavy chain 9', 152, NULL, NULL, 43532),
(43533, '2.70.220.10-FF-000003', NULL, 'NPC2p protein', 127, NULL, NULL, 43533),
(43534, '1.10.1060.10-FF-000001', NULL, 'Succinate dehydrogenase iron-sulfur subunit SdhB', 132, NULL, NULL, 43534),
(43535, '2.40.128.20-FF-000068', NULL, 'Heart-type fatty acid-binding protein', 24, NULL, NULL, 43535),
(43536, '3.40.50.720-FF-001196', NULL, 'Fluoren-9-ol dehydrogenase', 269, NULL, NULL, 43536),
(43537, '3.20.20.70-FF-000793', NULL, NULL, 43, NULL, NULL, 43537),
(43538, '3.40.50.300-FF-001098', NULL, 'Cytochrome c biogenesis ATP-binding export protein CcmA', 204, NULL, NULL, 43538),
(43539, '3.40.1110.10-FF-000430', NULL, NULL, 216, NULL, NULL, 43539),
(43540, '1.10.510.10-FF-001324', NULL, 'Protein kinase domain containing protein', 196, NULL, NULL, 43540),
(43541, '1.10.260.30-FF-000012', NULL, 'Signal recognition particle 54 kDa protein', 126, NULL, NULL, 43541),
(43542, '2.40.50.90-FF-000184', NULL, 'Uncharacterized protein', 80, NULL, NULL, 43542),
(43543, '3.90.226.10-FF-000261', NULL, 'Bifunctional fatty acid oxidation enzyme', 314, NULL, NULL, 43543),
(43544, '1.20.1440.170-FF-000002', NULL, 'TMA16p protein', 125, NULL, NULL, 43544),
(43545, '3.80.10.10-FF-000895', NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase', 94, NULL, NULL, 43545),
(43546, '1.25.10.10-FF-001679', NULL, 'AGAP010793-PA', 296, NULL, NULL, 43546),
(43547, '3.30.70.1390-FF-000015', NULL, 'Roco10, ROCO family protein', 87, NULL, NULL, 43547),
(43548, '1.10.287.370-FF-000018', NULL, 'Prefoldin, alpha subunit', 146, NULL, NULL, 43548),
(43549, '2.30.30.40-FF-000033', NULL, 'FCH and double SH3 domains protein 2', 61, NULL, NULL, 43549),
(43550, '1.25.40.120-FF-000006', NULL, 'Geranylgeranyl transferase type-2 subunit alpha', 266, NULL, NULL, 43550),
(43551, '1.20.1250.20-FF-001899', NULL, 'Slc2A8 protein, putative', 63, NULL, NULL, 43551),
(43552, '2.160.10.10-FF-000040', NULL, 'UDP-2-acetamido-3-amino-2,3-dideoxy-glucuronate N-acetyltransferase', 148, NULL, NULL, 43552),
(43553, '1.25.40.10-FF-002849', NULL, 'Putative TPR repeat family protein', 114, NULL, NULL, 43553),
(43554, '2.130.10.10-FF-001772', NULL, 'WD-repeat protein', 325, NULL, NULL, 43554),
(43555, '3.20.20.80-FF-000211', NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', 177, NULL, NULL, 43555),
(43556, '3.10.129.10-FF-000143', NULL, 'Putative esterase MT1895', 128, NULL, NULL, 43556),
(43557, '3.40.50.150-FF-001772', NULL, NULL, 202, NULL, NULL, 43557),
(43558, '2.40.10.10-FF-000202', NULL, 'Granzyme H', 72, NULL, NULL, 43558),
(43559, '3.40.850.10-FF-000418', NULL, 'ATP binding microtubule motor family protein', 212, NULL, NULL, 43559),
(43560, '1.25.10.10-FF-002140', NULL, 'AP-3 complex subunit beta', 561, NULL, NULL, 43560),
(43561, '3.30.470.30-FF-000050', NULL, 'mRNA-capping enzyme subunit alpha', 167, NULL, NULL, 43561),
(43562, '3.50.30.30-FF-000004', NULL, 'alpha-1,2-Mannosidase', 146, NULL, NULL, 43562),
(43563, '1.20.1560.10-FF-000571', NULL, 'Phosphatidylcholine translocator ABCB4', 22, NULL, NULL, 43563),
(43564, '1.20.1050.20-FF-000018', NULL, NULL, 107, NULL, NULL, 43564),
(43565, '3.40.50.11530-FF-000007', NULL, 'adapter protein CIKS isoform X3', 155, NULL, NULL, 43565);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(43566, '2.30.39.10-FF-000038', NULL, 'Os01g0267300 protein', 169, NULL, NULL, 43566),
(43567, '3.40.140.10-FF-000090', NULL, 'Cytidine deoxycytidylate deaminase family protein', 170, NULL, NULL, 43567),
(43568, '3.30.160.60-FF-003042', NULL, 'Transcription factor che-1', 27, NULL, NULL, 43568),
(43569, '3.40.1390.30-FF-000017', NULL, 'Nif3-related protein', 118, NULL, NULL, 43569),
(43570, '1.10.10.60-FF-001053', NULL, NULL, 58, NULL, NULL, 43570),
(43571, '3.50.50.60-FF-000133', NULL, 'Protoporphyrinogen oxidase', 477, NULL, NULL, 43571),
(43572, '3.30.160.60-FF-004470', NULL, NULL, 30, NULL, NULL, 43572),
(43573, '2.60.40.790-FF-000112', NULL, '17.4 kDa class III heat shock protein', 93, NULL, NULL, 43573),
(43574, '3.30.1240.10-FF-000037', NULL, 'Haloacid dehalogenase-like hydrolase', 124, NULL, NULL, 43574),
(43575, '2.60.40.10-FF-005155', NULL, NULL, 95, NULL, NULL, 43575),
(43576, '1.10.510.10-FF-000599', NULL, 'Serine/threonine-protein kinase Aurora-1', 176, NULL, NULL, 43576),
(43577, '2.30.30.140-FF-000006', NULL, 'DNA (Cytosine-5)-methyltransferase 3B isoform 3', 74, NULL, NULL, 43577),
(43578, '3.80.10.10-FF-003649', NULL, 'Uncharacterized protein', 185, NULL, NULL, 43578),
(43579, '1.10.555.10-FF-000157', NULL, 'Uncharacterized protein', 264, NULL, NULL, 43579),
(43580, '2.30.29.30-FF-001123', NULL, 'mRNA-decapping enzyme subunit 1', 127, NULL, NULL, 43580),
(43581, '1.20.58.1220-FF-000012', NULL, 'Exocyst complex component EXO84', 123, NULL, NULL, 43581),
(43582, '3.40.50.150-FF-000344', NULL, 'Blast:Calmodulin-lysine N-methyltransferase', 263, NULL, NULL, 43582),
(43583, '1.10.2080.10-FF-000002', NULL, 'GD24980', 87, NULL, NULL, 43583),
(43584, '3.40.50.12090-FF-000001', NULL, 'Cell surface protein', 97, NULL, NULL, 43584),
(43585, '2.130.10.10-FF-005987', NULL, 'Uncharacterized protein', 228, NULL, NULL, 43585),
(43586, '1.10.8.60-FF-000377', NULL, 'ATP-dependent 26S proteasome regulatory subunit Posttranslational modification protein', 84, NULL, NULL, 43586),
(43587, '1.10.10.1550-FF-000001', NULL, 'MucR family transcriptional regulator', 58, NULL, NULL, 43587),
(43588, '3.30.230.130-FF-000089', NULL, 'Uncharacterized protein', 83, NULL, NULL, 43588),
(43589, '1.20.1270.60-FF-000142', NULL, 'Rho GTPase-activating protein 92B', 237, NULL, NULL, 43589),
(43590, '3.80.10.10-FF-000215', NULL, 'Receptor-like protein kinase HSL1', 308, NULL, NULL, 43590),
(43591, '3.40.50.11020-FF-000001', NULL, 'Orf1a polyprotein', 116, NULL, NULL, 43591),
(43592, '3.40.50.720-FF-001460', NULL, 'Putative UDP-glucose 6-dehydrogenase', 155, NULL, NULL, 43592),
(43593, '2.130.10.10-FF-000344', NULL, 'Protein NEDD1', 175, NULL, NULL, 43593),
(43594, '3.40.50.300-FF-003284', NULL, 'Rab family GTPase', 193, NULL, NULL, 43594),
(43595, '3.80.10.10-FF-002132', NULL, 'Receptor-like protein 55', 332, NULL, NULL, 43595),
(43596, '3.40.1380.20-FF-000042', NULL, 'Pyruvate kinase', 131, NULL, NULL, 43596),
(43597, '1.20.120.310-FF-000004', NULL, 'Sulfhydryl oxidase', 154, NULL, NULL, 43597),
(43598, '2.60.40.10-FF-000220', NULL, 'X-linked interleukin-1 receptor accessory protein-like 1', 114, NULL, NULL, 43598),
(43599, '3.90.70.10-FF-000522', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 158, NULL, NULL, 43599),
(43600, '3.40.1280.10-FF-000088', NULL, 'Uncharacterized protein', 188, NULL, NULL, 43600),
(43601, '2.130.10.10-FF-005279', NULL, 'Predicted protein', 236, NULL, NULL, 43601),
(43602, '3.40.1500.10-FF-000010', NULL, 'Oxygen-dependent coproporphyrinogen-III oxidase', 308, NULL, NULL, 43602),
(43603, '1.10.10.60-FF-000333', NULL, 'Fis family transcriptional regulator', 43, NULL, NULL, 43603),
(43604, '1.10.287.70-FF-000366', NULL, 'Predicted protein', 261, NULL, NULL, 43604),
(43605, '3.30.160.60-FF-005812', NULL, NULL, 33, NULL, NULL, 43605),
(43606, '3.40.830.10-FF-000002', NULL, 'MEMO1 isoform 1', 293, NULL, NULL, 43606),
(43607, '3.60.40.10-FF-000206', NULL, 'Stage II sporulation E family protein', 241, NULL, NULL, 43607),
(43608, '1.10.10.520-FF-000012', NULL, 'SUMO-activating enzyme subunit', 204, NULL, NULL, 43608);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(43609, '1.25.10.10-FF-000431', NULL, 'ARM repeat superfamily protein', 281, NULL, NULL, 43609),
(43610, '3.30.300.160-FF-000002', NULL, 'Type II secretion system protein E', 80, NULL, NULL, 43610),
(43611, '2.30.180.10-FF-000183', NULL, NULL, 140, NULL, NULL, 43611),
(43612, '1.20.1250.20-FF-000651', NULL, 'Glutathione uptake transporter', 506, NULL, NULL, 43612),
(43613, '1.10.132.60-FF-000033', NULL, 'DNA polymerase', 77, NULL, NULL, 43613),
(43614, '3.90.550.10-FF-000087', NULL, 'Glycosyl transferase', 206, NULL, NULL, 43614),
(43615, '1.20.870.10-FF-000011', NULL, 'RAS guanyl-releasing protein 2 isoform X1', 133, NULL, NULL, 43615),
(43616, '3.30.2130.10-FF-000029', NULL, 'Uncharacterized protein', 136, NULL, NULL, 43616),
(43617, '2.40.30.10-FF-000524', NULL, 'Uncharacterized protein', 132, NULL, NULL, 43617),
(43618, '3.30.710.10-FF-000164', NULL, 'Uncharacterized protein, isoform B', 119, NULL, NULL, 43618),
(43619, '3.80.10.10-FF-002840', NULL, 'Uncharacterized protein', 140, NULL, NULL, 43619),
(43620, '3.30.70.330-FF-000983', NULL, 'Uncharacterized protein', 104, NULL, NULL, 43620),
(43621, '3.40.50.150-FF-000136', NULL, 'tRNA (Adenine(22)-N(1))-methyltransferase TrmK', 164, NULL, NULL, 43621),
(43622, '2.10.25.10-FF-000850', NULL, 'Pro-epidermal growth factor', 41, NULL, NULL, 43622),
(43623, '3.30.40.10-FF-000949', NULL, 'Zinc finger, C3HC4 type (RING finger) domain containing protein', 102, NULL, NULL, 43623),
(43624, '3.40.50.1820-FF-001518', NULL, 'Uncharacterized protein', 510, NULL, NULL, 43624),
(43625, '2.130.10.10-FF-001064', NULL, 'Tricorn protease homolog', 257, NULL, NULL, 43625),
(43626, '4.10.240.10-FF-000179', NULL, 'Putative transcription factor with C2H2 and Zn(2)-Cys(6) DNA binding domain (Eurofung)', 55, NULL, NULL, 43626),
(43627, '2.60.40.10-FF-004874', NULL, NULL, 61, NULL, NULL, 43627),
(43628, '3.30.420.40-FF-001038', NULL, 'Predicted protein', 179, NULL, NULL, 43628),
(43629, '3.20.20.60-FF-000025', NULL, 'Pyruvate kinase', 167, NULL, NULL, 43629),
(43630, '1.20.5.110-FF-000333', NULL, 'Syntaxin, putative', 42, NULL, NULL, 43630),
(43631, '1.10.8.60-FF-000113', NULL, 'Lon protease homolog, mitochondrial', 144, NULL, NULL, 43631),
(43632, '3.40.20.10-FF-000072', NULL, 'Villin-1', 116, NULL, NULL, 43632),
(43633, '3.80.10.10-FF-001204', NULL, 'F-box/leucine rich repeat protein', 102, NULL, NULL, 43633),
(43634, '1.25.40.10-FF-004997', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 129, NULL, NULL, 43634),
(43635, '1.25.40.20-FF-001397', NULL, 'Uncharacterized protein', 276, NULL, NULL, 43635),
(43636, '1.20.810.10-FF-000035', NULL, 'Cytochrome b', 213, NULL, NULL, 43636),
(43637, '3.40.50.1820-FF-000529', NULL, 'S10 family peptidase', 443, NULL, NULL, 43637),
(43638, '3.40.50.10190-FF-000223', NULL, 'Poly [ADP-ribose] polymerase', 99, NULL, NULL, 43638),
(43639, '2.60.120.1440-FF-000001', NULL, 'Putative anti-sigma factor', 148, NULL, NULL, 43639),
(43640, '1.25.40.20-FF-001509', NULL, 'Uncharacterized protein', 202, NULL, NULL, 43640),
(43641, '4.10.400.10-FF-000214', NULL, 'low-density lipoprotein receptor 1', 43, NULL, NULL, 43641),
(43642, '1.10.510.10-FF-004230', NULL, NULL, 204, NULL, NULL, 43642),
(43643, '3.40.50.880-FF-000063', NULL, 'Protein DJ-1 homolog D', 195, NULL, NULL, 43643),
(43644, '2.120.10.30-FF-000171', NULL, 'Predicted protein', 101, NULL, NULL, 43644),
(43645, '1.25.40.10-FF-002024', NULL, 'Pentatricopeptide repeat-containing protein At1g05670, mitochondrial', 71, NULL, NULL, 43645),
(43646, '3.20.20.210-FF-000029', NULL, 'Uncharacterized protein', 130, NULL, NULL, 43646),
(43647, '3.10.450.30-FF-000002', NULL, 'Guanyl-specific ribonuclease T1', 104, NULL, NULL, 43647),
(43648, '3.40.50.2300-FF-000898', NULL, NULL, 212, NULL, NULL, 43648),
(43649, '1.20.1070.10-FF-000696', NULL, 'Olfactory receptor', 302, NULL, NULL, 43649),
(43650, '3.40.50.300-FF-002615', NULL, 'ABC transporter', 131, NULL, NULL, 43650),
(43651, '1.10.3080.10-FF-000031', NULL, 'Putative chloride channel-like protein CLC-g', 116, NULL, NULL, 43651);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(43652, '1.20.58.1780-FF-000011', NULL, 'Nuclear Pore complex Protein', 258, NULL, NULL, 43652),
(43653, '3.30.160.60-FF-004262', NULL, NULL, 26, NULL, NULL, 43653),
(43654, '3.90.1410.10-FF-000155', NULL, 'Uncharacterized protein', 111, NULL, NULL, 43654),
(43655, '3.40.50.300-FF-002879', NULL, 'DNA helicase', 178, NULL, NULL, 43655),
(43656, '3.90.360.10-FF-000016', NULL, 'Histone acetyltransferase type B catalytic subunit', 124, NULL, NULL, 43656),
(43657, '3.90.1430.10-FF-000010', NULL, NULL, 110, NULL, NULL, 43657),
(43658, '2.40.30.30-FF-000035', NULL, 'Riboflavin kinase/fmn adenylyltransferase, putative', 147, NULL, NULL, 43658),
(43659, '2.60.120.200-FF-000383', NULL, 'GM25102', 320, NULL, NULL, 43659),
(43660, '1.25.70.10-FF-000019', NULL, 'mTERF family protein', 151, NULL, NULL, 43660),
(43661, '1.10.630.10-FF-000815', NULL, 'Uncharacterized protein', 270, NULL, NULL, 43661),
(43662, '3.80.10.10-FF-003913', NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', 116, NULL, NULL, 43662),
(43663, '3.40.50.1380-FF-000032', NULL, 'Bifunctional purine biosynthesis protein PURH', 196, NULL, NULL, 43663),
(43664, '1.10.510.10-FF-000335', NULL, 'receptor-like cytosolic serine/threonine-protein kinase RBK2', 203, NULL, NULL, 43664),
(43665, '2.60.40.10-FF-006111', NULL, NULL, 110, NULL, NULL, 43665),
(43666, '3.40.50.200-FF-000174', NULL, 'Predicted protein', 354, NULL, NULL, 43666),
(43667, '3.60.40.10-FF-000145', NULL, 'PPM1A isoform 7', 147, NULL, NULL, 43667),
(43668, '3.40.50.10190-FF-000162', NULL, 'Pescadillo homolog', 71, NULL, NULL, 43668),
(43669, '1.25.40.20-FF-001009', NULL, 'Predicted protein', 75, NULL, NULL, 43669),
(43670, '1.25.40.10-FF-001771', NULL, 'Pentatricopeptide repeat-containing protein At3g26782, mitochondrial', 181, NULL, NULL, 43670),
(43671, '3.40.33.10-FF-000079', NULL, 'Predicted protein', 154, NULL, NULL, 43671),
(43672, '3.40.720.10-FF-000084', NULL, 'Uncharacterized protein', 451, NULL, NULL, 43672),
(43673, '3.40.50.2000-FF-001123', NULL, 'Glycogen [starch] synthase', 277, NULL, NULL, 43673),
(43674, '1.10.8.10-FF-000059', NULL, 'Lingerer, isoform I', 61, NULL, NULL, 43674),
(43675, '2.60.40.10-FF-004166', NULL, NULL, 88, NULL, NULL, 43675),
(43676, '3.20.70.20-FF-000011', NULL, 'Formate acetyltransferase', 757, NULL, NULL, 43676),
(43677, '3.40.640.10-FF-000083', NULL, 'Selenocysteine lyase', 206, NULL, NULL, 43677),
(43678, '3.10.150.10-FF-000007', NULL, 'Beta sliding clamp', 177, NULL, NULL, 43678),
(43679, '2.60.40.2440-FF-000003', NULL, 'protein phosphatase 1 regulatory subunit 3F isoform X1', 101, NULL, NULL, 43679),
(43680, '1.20.1740.10-FF-000017', NULL, 'Amino acid permease', 467, NULL, NULL, 43680),
(43681, '2.120.10.10-FF-000013', NULL, 'Sialidase', 374, NULL, NULL, 43681),
(43682, '3.40.50.720-FF-000532', NULL, 'SLOwpoke potassium channel family', 139, NULL, NULL, 43682),
(43683, '3.30.160.60-FF-004823', NULL, NULL, 53, NULL, NULL, 43683),
(43684, '3.30.160.60-FF-002053', NULL, 'C2H2 finger domain protein (Gli3)', 33, NULL, NULL, 43684),
(43685, '2.120.10.30-FF-000019', NULL, 'Low-density lipoprotein receptor-related protein 1', 305, NULL, NULL, 43685),
(43686, '3.40.1090.10-FF-000141', NULL, 'Uncharacterized protein', 82, NULL, NULL, 43686),
(43687, '1.25.40.10-FF-003805', NULL, 'DAP3-binding cell death enhancer 1', 139, NULL, NULL, 43687),
(43688, '3.20.20.100-FF-000199', NULL, 'Aldo-keto reductase family 1, member C19', 53, NULL, NULL, 43688),
(43689, '2.130.10.10-FF-001564', NULL, 'Vacuolar protein sorting/targeting protein PEP1', 170, NULL, NULL, 43689),
(43690, '3.30.497.10-FF-000105', NULL, 'Uncharacterized protein', 103, NULL, NULL, 43690),
(43691, '1.10.510.10-FF-001588', NULL, 'Protein CBG04908', 205, NULL, NULL, 43691),
(43692, '1.20.1250.20-FF-001635', NULL, 'Glucose transporter GLUT4', 89, NULL, NULL, 43692),
(43693, '3.90.79.10-FF-000103', NULL, 'MutT/nudix family protein', 182, NULL, NULL, 43693),
(43694, '2.130.10.10-FF-004998', NULL, 'Notchless-like protein isoform 1', 65, NULL, NULL, 43694),
(43695, '2.60.40.3210-FF-000010', NULL, 'Transforming growth factor beta receptor type 3', 92, NULL, NULL, 43695); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(43696, '3.30.420.40-FF-000521', NULL, 'Actin-related protein 9', 198, NULL, NULL, 43696),
(43697, '2.60.200.30-FF-000004', NULL, 'NAD kinase 2, chloroplastic', 138, NULL, NULL, 43697),
(43698, '3.40.50.1820-FF-000681', NULL, 'Siderophore esterase IroE-like protein', 274, NULL, NULL, 43698),
(43699, '3.80.10.10-FF-001143', NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM2', 158, NULL, NULL, 43699),
(43700, '3.50.50.60-FF-000958', NULL, 'Sarcosine oxidase', 185, NULL, NULL, 43700),
(43701, '2.170.270.10-FF-000089', NULL, 'N-lysine methyltransferase SMYD2', 45, NULL, NULL, 43701),
(43702, '3.60.21.10-FF-000022', NULL, 'Putative metallophosphoesterase 1', 284, NULL, NULL, 43702),
(43703, '1.25.10.10-FF-003157', NULL, 'Serine/threonine-protein kinase TOR', 414, NULL, NULL, 43703),
(43704, '3.90.180.10-FF-000098', NULL, 'Uncharacterized protein', 60, NULL, NULL, 43704),
(43705, '3.40.50.410-FF-000203', NULL, 'KU80 protein', 224, NULL, NULL, 43705),
(43706, '3.80.10.10-FF-002632', NULL, 'Uncharacterized protein', 163, NULL, NULL, 43706),
(43707, '3.40.50.300-FF-004324', NULL, 'Uncharacterized protein', 89, NULL, NULL, 43707),
(43708, '3.30.70.1730-FF-000016', NULL, 'Related to ribosomal protein YmL11, mitochondrial', 167, NULL, NULL, 43708),
(43709, '3.40.50.1110-FF-000092', NULL, 'Uncharacterized protein', 254, NULL, NULL, 43709),
(43710, '3.30.40.10-FF-001613', NULL, 'Pre-mRNA-splicing factor CWC24', 59, NULL, NULL, 43710),
(43711, '2.40.110.10-FF-000064', NULL, 'Acyl-CoA dehydrogenase domain protein', 114, NULL, NULL, 43711),
(43712, '1.10.405.20-FF-000003', NULL, 'Uncharacterized protein', 134, NULL, NULL, 43712),
(43713, '2.10.25.10-FF-000586', NULL, 'EGF, latrophilin seven transmembrane domain-containing protein 1', 49, NULL, NULL, 43713),
(43714, '1.10.630.10-FF-000462', NULL, 'Cytochrome P-450 IIC4, putative', 125, NULL, NULL, 43714),
(43715, '2.130.10.10-FF-005779', NULL, 'Predicted protein', 104, NULL, NULL, 43715),
(43716, '1.20.1070.10-FF-002141', NULL, 'Uncharacterized protein', 203, NULL, NULL, 43716),
(43717, '2.70.130.10-FF-000176', NULL, NULL, 155, NULL, NULL, 43717),
(43718, '1.10.30.10-FF-000073', NULL, 'High mobility group protein 1 homolog', 81, NULL, NULL, 43718),
(43719, '1.20.120.1150-FF-000010', NULL, 'Serine/threonine-protein phosphatase 2A activator', 65, NULL, NULL, 43719),
(43720, '3.90.550.10-FF-000351', NULL, 'Glycosyl transferase', 243, NULL, NULL, 43720),
(43721, '3.60.110.10-FF-000100', NULL, NULL, 234, NULL, NULL, 43721),
(43722, '1.10.10.10-FF-000835', NULL, 'Ribosomal protein', 44, NULL, NULL, 43722),
(43723, '3.40.50.10810-FF-000180', NULL, 'Snf2 family helicase', 83, NULL, NULL, 43723),
(43724, '2.60.120.650-FF-000141', NULL, 'Uncharacterized protein', 224, NULL, NULL, 43724),
(43725, '3.40.30.40-FF-000002', NULL, 'Thiol-activated cytolysin', 125, NULL, NULL, 43725),
(43726, '3.30.40.10-FF-000449', NULL, 'General transcription factor IIH subunit', 78, NULL, NULL, 43726),
(43727, '3.30.160.60-FF-002114', NULL, 'zinc finger protein 133 isoform X2', 27, NULL, NULL, 43727),
(43728, '1.10.285.10-FF-000001', NULL, 'Glutamate dehydrogenase', 73, NULL, NULL, 43728),
(43729, '1.10.150.50-FF-000077', NULL, 'DDHD domain-containing 2', 62, NULL, NULL, 43729),
(43730, '1.20.1070.10-FF-001921', NULL, 'Serpentine Receptor, class SX', 282, NULL, NULL, 43730),
(43731, '1.20.58.2220-FF-000003', NULL, 'protein diaphanous homolog 1 isoform X2', 294, NULL, NULL, 43731),
(43732, '3.90.550.10-FF-000407', NULL, 'Glycosyl transferase family 2', 187, NULL, NULL, 43732),
(43733, '3.40.50.12780-FF-000079', NULL, 'Capsule biosynthesis protein CapK', 312, NULL, NULL, 43733),
(43734, '1.10.630.10-FF-000315', NULL, 'Uncharacterized protein', 127, NULL, NULL, 43734),
(43735, '3.40.50.1820-FF-000029', NULL, 'Acetylcholinesterase', 535, NULL, NULL, 43735),
(43736, '1.10.10.10-FF-002016', NULL, 'Putative marR-family regulatory protein', 148, NULL, NULL, 43736),
(43737, '3.40.50.10190-FF-000015', NULL, 'protein ECT2 isoform X1', 89, NULL, NULL, 43737),
(43738, '1.10.10.60-FF-000272', NULL, 'zinc fingers and homeoboxes protein 2', 70, NULL, NULL, 43738);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(43739, '1.10.510.10-FF-000099', NULL, 'Serine/threonine-protein kinase receptor', 217, NULL, NULL, 43739),
(43740, '3.30.70.330-FF-000247', NULL, 'Multiple RNA-binding domain-containing protein 1', 108, NULL, NULL, 43740),
(43741, '2.40.50.1070-FF-000018', NULL, 'RNA methyltransferase', 136, NULL, NULL, 43741),
(43742, '3.40.50.300-FF-005549', NULL, 'DNA repair helicase Rad3', 272, NULL, NULL, 43742),
(43743, '2.60.200.20-FF-000114', NULL, 'Uncharacterized protein', 113, NULL, NULL, 43743),
(43744, '4.10.280.110-FF-000018', NULL, NULL, 67, NULL, NULL, 43744),
(43745, '1.10.20.10-FF-000044', NULL, 'Histone H3.3', 84, NULL, NULL, 43745),
(43746, '3.40.50.410-FF-000091', NULL, 'General transcription factor IIH subunit', 186, NULL, NULL, 43746),
(43747, '2.130.10.10-FF-004026', NULL, 'Uncharacterized protein', 221, NULL, NULL, 43747),
(43748, '1.25.40.10-FF-000843', NULL, 'Pentatricopeptide repeat-containing protein', 116, NULL, NULL, 43748),
(43749, '3.30.160.60-FF-003542', NULL, NULL, 25, NULL, NULL, 43749),
(43750, '1.20.58.60-FF-000370', NULL, 'AcTiniN', 114, NULL, NULL, 43750),
(43751, '3.90.70.80-FF-000059', NULL, 'Uncharacterized protein', 162, NULL, NULL, 43751),
(43752, '2.130.10.10-FF-003834', NULL, 'Uncharacterized protein', 297, NULL, NULL, 43752),
(43753, '3.40.50.720-FF-001813', NULL, 'Uncharacterized protein', 271, NULL, NULL, 43753),
(43754, '3.30.60.30-FF-000081', NULL, 'AGRin (Synaptic protein) homolog', 74, NULL, NULL, 43754),
(43755, '1.10.1450.10-FF-000076', NULL, 'Tetraspanin', 85, NULL, NULL, 43755),
(43756, '3.90.70.10-FF-000258', NULL, 'Ubiquitin carboxyl-terminal hydrolase 32', 157, NULL, NULL, 43756),
(43757, '3.30.750.24-FF-000180', NULL, 'Solute carrier family 26 member 9', 61, NULL, NULL, 43757),
(43758, '3.10.20.90-FF-000681', NULL, 'ISG15 ubiquitin-like modifier', 59, NULL, NULL, 43758),
(43759, '2.130.10.10-FF-004498', NULL, 'Uncharacterized protein', 241, NULL, NULL, 43759),
(43760, '1.10.1200.10-FF-000176', NULL, 'Polyketide synthase/nonribosomal peptide synthetase hybrid RzxA', 86, NULL, NULL, 43760),
(43761, '2.80.10.50-FF-000246', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 70, NULL, NULL, 43761),
(43762, '1.20.900.10-FF-000126', NULL, 'Kalirin RhoGEF kinase a', 93, NULL, NULL, 43762),
(43763, '1.20.1070.10-FF-000432', NULL, 'Mas-related G protein-coupled receptor D', 300, NULL, NULL, 43763),
(43764, '1.25.40.10-FF-003305', NULL, 'Uncharacterized protein', 139, NULL, NULL, 43764),
(43765, '2.40.50.180-FF-000014', NULL, 'Probable chemotaxis protein', 71, NULL, NULL, 43765),
(43766, '3.40.50.170-FF-000030', NULL, 'Phosphoribosylglycinamide formyltransferase', 198, NULL, NULL, 43766),
(43767, '1.25.40.10-FF-003569', NULL, 'Adenylate/guanylate cyclase domain-containing protein', 206, NULL, NULL, 43767),
(43768, '3.40.50.620-FF-000648', NULL, 'Os02g0814900 protein', 123, NULL, NULL, 43768),
(43769, '3.30.830.10-FF-000291', NULL, 'Clan ME, family M16, insulinase-like metallopeptidase', 152, NULL, NULL, 43769),
(43770, '3.40.30.10-FF-000718', NULL, 'Thioredoxin', 136, NULL, NULL, 43770),
(43771, '1.25.40.320-FF-000010', NULL, 'Uncharacterized protein', 76, NULL, NULL, 43771),
(43772, '3.60.10.10-FF-000317', NULL, 'Uncharacterized protein', 282, NULL, NULL, 43772),
(43773, '3.10.280.10-FF-000016', NULL, 'Putative p22 protein', 181, NULL, NULL, 43773),
(43774, '1.20.1560.10-FF-000099', NULL, 'ABC transporter ATP-binding protein/permease', 311, NULL, NULL, 43774),
(43775, '2.30.29.30-FF-001387', NULL, 'Mitogen-activated protein kinase', 120, NULL, NULL, 43775),
(43776, '1.20.58.190-FF-000019', NULL, NULL, 133, NULL, NULL, 43776),
(43777, '3.30.40.10-FF-000596', NULL, 'FYVE zinc finger protein', 79, NULL, NULL, 43777),
(43778, '2.130.10.10-FF-003981', NULL, 'Predicted protein', 234, NULL, NULL, 43778),
(43779, '2.160.20.10-FF-000130', NULL, 'Cell surface protein', 282, NULL, NULL, 43779),
(43780, '3.40.50.150-FF-001064', NULL, 'Uncharacterized protein', 254, NULL, NULL, 43780),
(43781, '1.10.1520.10-FF-000048', NULL, 'Ribonuclease 3', 144, NULL, NULL, 43781);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(43782, '3.90.1180.10-FF-000029', NULL, NULL, 67, NULL, NULL, 43782),
(43783, '3.30.710.10-FF-000372', NULL, 'Kruppel-like zinc-finger protein, putative', 122, NULL, NULL, 43783),
(43784, '3.60.40.10-FF-000353', NULL, 'Uncharacterized protein', 324, NULL, NULL, 43784),
(43785, '3.40.1550.10-FF-000013', NULL, NULL, 164, NULL, NULL, 43785),
(43786, '3.40.50.2300-FF-000426', NULL, 'Eg243628', 181, NULL, NULL, 43786),
(43787, '3.30.70.100-FF-000116', NULL, NULL, 91, NULL, NULL, 43787),
(43788, '3.10.20.90-FF-000529', NULL, 'UBX domain-containing protein 10', 81, NULL, NULL, 43788),
(43789, '2.60.34.10-FF-000099', NULL, 'Uncharacterized protein', 182, NULL, NULL, 43789),
(43790, '1.20.58.1880-FF-000007', NULL, 'Homeodomain-like superfamily protein', 91, NULL, NULL, 43790),
(43791, '2.130.10.30-FF-000030', NULL, 'Secretion-regulating guanine nucleotide exchange factor', 154, NULL, NULL, 43791),
(43792, '3.40.630.30-FF-000240', NULL, 'GCN5 family acetyltransferase', 163, NULL, NULL, 43792),
(43793, '1.20.120.350-FF-000168', NULL, NULL, 43, NULL, NULL, 43793),
(43794, '3.30.43.10-FF-000046', NULL, 'FAD-binding oxidoreductase', 100, NULL, NULL, 43794),
(43795, '3.30.200.20-FF-002500', NULL, 'Predicted protein', 12, NULL, NULL, 43795),
(43796, '1.50.40.10-FF-000487', NULL, 'Uncharacterized protein', 276, NULL, NULL, 43796),
(43797, '2.60.40.10-FF-004374', NULL, NULL, 91, NULL, NULL, 43797),
(43798, '2.60.40.10-FF-005094', NULL, NULL, 126, NULL, NULL, 43798),
(43799, '3.80.10.10-FF-004077', NULL, 'Uncharacterized protein', 298, NULL, NULL, 43799),
(43800, '3.40.50.720-FF-001549', NULL, 'Uncharacterized protein', 356, NULL, NULL, 43800),
(43801, '3.90.640.10-FF-000178', NULL, 'Actin4-1', 75, NULL, NULL, 43801),
(43802, '3.80.10.10-FF-001351', NULL, 'Leucine-rich repeat receptor protein kinase MSL1', 120, NULL, NULL, 43802),
(43803, '3.20.20.190-FF-000006', NULL, 'Phosphoinositide phospholipase C', 192, NULL, NULL, 43803),
(43804, '3.90.1290.10-FF-000066', NULL, 'Uncharacterized protein', 179, NULL, NULL, 43804),
(43805, '3.30.70.980-FF-000032', NULL, 'AGAP001629-PA', 84, NULL, NULL, 43805),
(43806, '1.20.5.340-FF-000109', NULL, 'Uncharacterized protein', 111, NULL, NULL, 43806),
(43807, '3.40.1110.10-FF-000166', NULL, 'Calcium-transporting P-type ATPase, putative', 204, NULL, NULL, 43807),
(43808, '3.40.50.300-FF-005493', NULL, 'ATP-dependent RecD-like DNA helicase', 297, NULL, NULL, 43808),
(43809, '3.90.780.10-FF-000008', NULL, 'Ser/Thr protein phosphatase family', 88, NULL, NULL, 43809),
(43810, '1.25.40.10-FF-000579', NULL, 'Pentatricopeptide repeat-containing protein At5g39710', 108, NULL, NULL, 43810),
(43811, '3.10.129.130-FF-000001', NULL, 'Endoribonuclease ToxN', 180, NULL, NULL, 43811),
(43812, '3.20.20.70-FF-000585', NULL, 'Tryptophan synthase', 267, NULL, NULL, 43812),
(43813, '3.40.50.2000-FF-000926', NULL, 'ADP-heptose--lipopolysaccharide heptosyltransferase', 157, NULL, NULL, 43813),
(43814, '1.10.3860.10-FF-000006', NULL, 'Dicarboxylate/amino acid:cation symporter', 396, NULL, NULL, 43814),
(43815, '3.40.190.10-FF-000593', NULL, 'Glutamate ionotropic receptor NMDA type subunit 1', 19, NULL, NULL, 43815),
(43816, '3.30.70.330-FF-000511', NULL, 'RNA binding motif protein 34', 94, NULL, NULL, 43816),
(43817, '1.10.3730.20-FF-000062', NULL, '10 TMS drug/metabolite efflux pump (DME) family', 104, NULL, NULL, 43817),
(43818, '1.10.510.10-FF-001824', NULL, 'Kinase-like protein', 223, NULL, NULL, 43818),
(43819, '3.40.850.10-FF-000065', NULL, 'Kinesin-like protein', 393, NULL, NULL, 43819),
(43820, '3.90.1720.30-FF-000004', NULL, 'PPPDE putative peptidase domain containing protein', 151, NULL, NULL, 43820),
(43821, '3.30.40.10-FF-001877', NULL, 'Uncharacterized protein', 76, NULL, NULL, 43821),
(43822, '1.10.287.110-FF-000199', NULL, 'Molecular chaperones (DnaJ family)', 74, NULL, NULL, 43822),
(43823, '3.30.70.360-FF-000054', NULL, 'N-carbamoyl-L-amino acid hydrolase, putative', 75, NULL, NULL, 43823),
(43824, '3.30.160.60-FF-001709', NULL, 'Zelda, isoform F', 47, NULL, NULL, 43824),
(43825, '1.10.510.10-FF-002044', NULL, 'Protein kinase superfamily protein', 145, NULL, NULL, 43825);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(43826, '2.30.31.10-FF-000009', NULL, 'activated RNA polymerase II transcriptional coactivator p15-like', 74, NULL, NULL, 43826),
(43827, '1.20.120.230-FF-000014', NULL, 'Catenin alpha like 1', 116, NULL, NULL, 43827),
(43828, '1.20.1560.10-FF-000924', NULL, 'ABC transporter B family member 29 chloroplastic', 82, NULL, NULL, 43828),
(43829, '1.20.1250.20-FF-000707', NULL, 'Sugar transporter', 423, NULL, NULL, 43829),
(43830, '3.40.50.300-FF-001598', NULL, 'ABC transporter ced-7', 241, NULL, NULL, 43830),
(43831, '2.130.10.10-FF-005515', NULL, 'Uncharacterized protein', 72, NULL, NULL, 43831),
(43832, '2.60.40.10-FF-000720', NULL, 'Platelet-derived growth factor receptor alpha', 96, NULL, NULL, 43832),
(43833, '3.30.160.60-FF-001597', NULL, 'Zinc finger protein 222', 27, NULL, NULL, 43833),
(43834, '1.10.472.10-FF-000442', NULL, 'Uncharacterized protein', 151, NULL, NULL, 43834),
(43835, '3.40.350.10-FF-000072', NULL, 'Uncharacterized protein', 186, NULL, NULL, 43835),
(43836, '3.80.10.10-FF-000687', NULL, 'Leucine Rich Repeat family protein, expressed', 96, NULL, NULL, 43836),
(43837, '2.130.10.10-FF-000283', NULL, 'WD repeat domain 34', 215, NULL, NULL, 43837),
(43838, '1.10.2000.10-FF-000082', NULL, NULL, 47, NULL, NULL, 43838),
(43839, '3.30.160.60-FF-005751', NULL, NULL, 27, NULL, NULL, 43839),
(43840, '2.60.40.60-FF-000797', NULL, 'Cadherin-1', 88, NULL, NULL, 43840),
(43841, '3.70.10.10-FF-000064', NULL, 'DNA polymerase sliding clamp 2', 246, NULL, NULL, 43841),
(43842, '2.60.40.1730-FF-000122', NULL, NULL, 31, NULL, NULL, 43842),
(43843, '3.90.550.50-FF-000104', NULL, 'Hexosyltransferase', 274, NULL, NULL, 43843),
(43844, '2.40.30.10-FF-000288', NULL, 'NADH-cytochrome b5 reductase', 103, NULL, NULL, 43844),
(43845, '1.10.238.10-FF-001163', NULL, 'Uncharacterized protein', 104, NULL, NULL, 43845),
(43846, '3.30.9.10-FF-000271', NULL, 'Uncharacterized protein', 107, NULL, NULL, 43846),
(43847, '2.30.29.30-FF-000870', NULL, 'extensin isoform X1', 126, NULL, NULL, 43847),
(43848, '1.20.140.40-FF-000077', NULL, NULL, 120, NULL, NULL, 43848),
(43849, '2.60.120.10-FF-000464', NULL, 'cGMP-dependent protein kinase 15-1', 139, NULL, NULL, 43849),
(43850, '3.40.1180.10-FF-000024', NULL, 'Alkyl transferase', 170, NULL, NULL, 43850),
(43851, '1.10.510.10-FF-001116', NULL, 'Scy1p', 197, NULL, NULL, 43851),
(43852, '3.40.50.1820-FF-000737', NULL, 'Carboxylic ester hydrolase', 238, NULL, NULL, 43852),
(43853, '3.30.870.10-FF-000057', NULL, 'DEAD/DEAH box helicase', 173, NULL, NULL, 43853),
(43854, '3.40.50.720-FF-000268', NULL, 'Malate dehydrogenase', 147, NULL, NULL, 43854),
(43855, '2.60.40.10-FF-005655', NULL, NULL, 90, NULL, NULL, 43855),
(43856, '2.60.40.10-FF-003969', NULL, NULL, 103, NULL, NULL, 43856),
(43857, '3.40.1050.10-FF-000020', NULL, 'Carbonic anhydrase', 58, NULL, NULL, 43857),
(43858, '2.40.50.690-FF-000015', NULL, 'RNB domain-containing protein', 107, NULL, NULL, 43858),
(43859, '1.20.58.120-FF-000015', NULL, NULL, 79, NULL, NULL, 43859),
(43860, '3.30.1150.10-FF-000002', NULL, 'Energy transducer TonB', 102, NULL, NULL, 43860),
(43861, '3.30.70.270-FF-000268', NULL, NULL, 159, NULL, NULL, 43861),
(43862, '3.30.160.60-FF-006268', NULL, NULL, 22, NULL, NULL, 43862),
(43863, '3.40.50.80-FF-000021', NULL, 'Cytochrome b5 reductase 4', 143, NULL, NULL, 43863),
(43864, '2.60.120.340-FF-000020', NULL, 'Nucleophosmin 1a', 48, NULL, NULL, 43864),
(43865, '3.40.50.2300-FF-001354', NULL, NULL, 40, NULL, NULL, 43865),
(43866, '2.30.29.30-FF-000459', NULL, 'Arf-GAP with GTPase, ANK repeat and PH domain-containing protein 2', 120, NULL, NULL, 43866),
(43867, '1.10.418.70-FF-000003', NULL, 'AGAP002293-PA', 127, NULL, NULL, 43867),
(43868, '3.40.50.10810-FF-000033', NULL, 'E1A-binding protein p400 isoform X9', 267, NULL, NULL, 43868),
(43869, '2.30.250.10-FF-000008', NULL, 'aspartyl aminopeptidase isoform X2', 106, NULL, NULL, 43869),
(43870, '1.10.3370.10-FF-000042', NULL, 'Uncharacterized protein', 186, NULL, NULL, 43870),
(43871, '2.60.40.10-FF-000012', NULL, 'titin isoform X1', 96, NULL, NULL, 43871);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(43872, '2.30.30.40-FF-000533', NULL, 'AaceriABR082Wp', 62, NULL, NULL, 43872),
(43873, '2.60.40.1180-FF-000092', NULL, 'Glycosyl hydrolase', 106, NULL, NULL, 43873),
(43874, '3.90.550.50-FF-000251', NULL, 'Mitotic spindle checkpoint protein MAD1', 141, NULL, NULL, 43874),
(43875, '2.60.120.260-FF-000294', NULL, 'CocE/NonD family hydrolase', 164, NULL, NULL, 43875),
(43876, '3.30.900.10-FF-000055', NULL, 'Uncharacterized protein', 243, NULL, NULL, 43876),
(43877, '1.20.1270.20-FF-000001', NULL, 'Hydroxylamine reductase', 84, NULL, NULL, 43877),
(43878, '1.20.1250.20-FF-002096', NULL, 'Monocarboxylate transporter, putative', 249, NULL, NULL, 43878),
(43879, '3.30.420.10-FF-000737', NULL, NULL, 177, NULL, NULL, 43879),
(43880, '3.40.50.720-FF-002477', NULL, 'Ubiquitin-activating enzyme E1 1, putative', 246, NULL, NULL, 43880),
(43881, '1.10.575.10-FF-000012', NULL, 'Endonuclease', 244, NULL, NULL, 43881),
(43882, '2.30.42.10-FF-000237', NULL, 'AFaDin (Actin filament binding protein) homolog', 100, NULL, NULL, 43882),
(43883, '1.10.10.60-FF-000833', NULL, NULL, 68, NULL, NULL, 43883),
(43884, '1.25.40.20-FF-000228', NULL, 'Ankyrin repeat and SOCS box containing 10', 77, NULL, NULL, 43884),
(43885, '2.60.40.10-FF-003446', NULL, NULL, 103, NULL, NULL, 43885),
(43886, '3.80.10.10-FF-003149', NULL, 'Uncharacterized protein', 301, NULL, NULL, 43886),
(43887, '1.25.40.10-FF-000282', NULL, 'Transcriptional corepressor Cyc8', 110, NULL, NULL, 43887),
(43888, '1.20.1070.10-FF-001360', NULL, 'Uncharacterized protein', 264, NULL, NULL, 43888),
(43889, '1.10.3680.20-FF-000001', NULL, 'Actin cross-linking toxin VgrG1', 137, NULL, NULL, 43889),
(43890, '1.10.533.10-FF-000112', NULL, 'Uncharacterized protein', 104, NULL, NULL, 43890),
(43891, '2.40.50.140-FF-000261', NULL, 'Putative 30S Ribosomal protein S17', 76, NULL, NULL, 43891),
(43892, '1.10.150.240-FF-000014', NULL, 'HAD hydrolase, family IA, variant 1', 69, NULL, NULL, 43892),
(43893, '3.80.10.10-FF-000423', NULL, 'Leucine rich repeat containing 1', 243, NULL, NULL, 43893),
(43894, '3.40.30.10-FF-000870', NULL, 'Glutaredoxin 3', 98, NULL, NULL, 43894),
(43895, '3.30.9.10-FF-000124', NULL, 'Glycerol-3-phosphate dehydrogenase', 160, NULL, NULL, 43895),
(43896, '2.60.120.10-FF-000200', NULL, 'YGR125W-like protein', 133, NULL, NULL, 43896),
(43897, '3.30.160.60-FF-005604', NULL, NULL, 27, NULL, NULL, 43897),
(43898, '2.130.10.10-FF-000844', NULL, 'Elongator acetyltransferase complex subunit 2', 155, NULL, NULL, 43898),
(43899, '3.20.20.80-FF-000683', NULL, 'Uncharacterized protein', 324, NULL, NULL, 43899),
(43900, '2.130.10.10-FF-000136', NULL, 'Probable cytosolic iron-sulfur protein assembly protein CIAO1', 334, NULL, NULL, 43900),
(43901, '3.20.20.70-FF-000438', NULL, 'Uncharacterized protein', 283, NULL, NULL, 43901),
(43902, '1.10.10.10-FF-001763', NULL, 'DNA-directed RNA polymerase III subunit RPC3', 90, NULL, NULL, 43902),
(43903, '3.40.50.970-FF-000202', NULL, 'Uncharacterized protein', 126, NULL, NULL, 43903),
(43904, '1.10.287.70-FF-000158', NULL, 'Sodium channel protein', 100, NULL, NULL, 43904),
(43905, '3.90.25.10-FF-000007', NULL, 'dTDP-4-dehydrorhamnose reductase', 70, NULL, NULL, 43905),
(43906, '1.10.10.60-FF-000125', NULL, 'diencephalon/mesencephalon homeobox protein 1', 85, NULL, NULL, 43906),
(43907, '1.10.510.10-FF-004258', NULL, NULL, 188, NULL, NULL, 43907),
(43908, '1.10.530.40-FF-000002', NULL, 'Endolysin', 164, NULL, NULL, 43908),
(43909, '2.60.40.1400-FF-000023', NULL, NULL, 28, NULL, NULL, 43909),
(43910, '3.30.1070.10-FF-000001', NULL, 'Cell division topological specificity factor', 82, NULL, NULL, 43910),
(43911, '1.20.1070.10-FF-001449', NULL, 'Predicted protein', 220, NULL, NULL, 43911),
(43912, '1.25.10.10-FF-001387', NULL, 'Condensin complex subunit 1', 417, NULL, NULL, 43912),
(43913, '3.40.50.200-FF-000197', NULL, 'Uncharacterized protein', 59, NULL, NULL, 43913),
(43914, '2.20.70.10-FF-000044', NULL, 'E3 ubiquitin-protein ligase SMURF2', 35, NULL, NULL, 43914),
(43915, '2.60.40.10-FF-002660', NULL, 'Tyrosine-protein kinase receptor', 103, NULL, NULL, 43915); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(43916, '3.10.490.20-FF-000035', NULL, 'Dynein heavy chain 6, axonemal', 162, NULL, NULL, 43916),
(43917, '2.70.150.10-FF-000059', NULL, 'ATPase 2 plasma membrane-type', 82, NULL, NULL, 43917),
(43918, '1.10.510.10-FF-004314', NULL, NULL, 150, NULL, NULL, 43918),
(43919, '1.25.40.10-FF-002996', NULL, 'Intraflagellar transport protein IFT88', 129, NULL, NULL, 43919),
(43920, '3.50.50.60-FF-001358', NULL, 'Flavin-containing monooxygenase', 90, NULL, NULL, 43920),
(43921, '1.20.58.390-FF-000287', NULL, 'Predicted protein', 48, NULL, NULL, 43921),
(43922, '3.20.20.140-FF-000401', NULL, 'Uncharacterized protein', 122, NULL, NULL, 43922),
(43923, '3.40.1190.20-FF-000095', NULL, 'Fructoselysine kinase', 270, NULL, NULL, 43923),
(43924, '1.10.1420.10-FF-000164', NULL, 'Uncharacterized protein', 287, NULL, NULL, 43924),
(43925, '2.40.170.20-FF-000014', NULL, 'TonB-dependent haem/haemoglobin receptor', 541, NULL, NULL, 43925),
(43926, '1.10.8.270-FF-000181', NULL, 'Uncharacterized protein', 159, NULL, NULL, 43926),
(43927, '3.50.50.60-FF-000902', NULL, 'Sll0321 protein', 97, NULL, NULL, 43927),
(43928, '3.60.20.10-FF-000059', NULL, 'Proteasome subunit alpha type', 246, NULL, NULL, 43928),
(43929, '2.170.180.11-FF-000004', NULL, 'GM14282', 118, NULL, NULL, 43929),
(43930, '3.40.50.10680-FF-000005', NULL, 'RNA helicase', 133, NULL, NULL, 43930),
(43931, '1.25.10.10-FF-001443', NULL, 'Serine/threonine-protein kinase TOR', 432, NULL, NULL, 43931),
(43932, '3.40.50.150-FF-000491', NULL, 'Putative siderophore biosysnthesis protein', 289, NULL, NULL, 43932),
(43933, '3.30.499.10-FF-000031', NULL, NULL, 52, NULL, NULL, 43933),
(43934, '1.25.10.10-FF-000931', NULL, 'Pumilio family RNA-binding protein', 341, NULL, NULL, 43934),
(43935, '1.10.10.580-FF-000007', NULL, 'Sister chromatid cohesion 1 protein 1', 79, NULL, NULL, 43935),
(43936, '1.20.1070.10-FF-001505', NULL, 'Predicted protein', 366, NULL, NULL, 43936),
(43937, '1.10.268.20-FF-000004', NULL, 'Sarcoplasmic reticulum glycoprotein, putative', 130, NULL, NULL, 43937),
(43938, '1.20.120.350-FF-000201', NULL, NULL, 128, NULL, NULL, 43938),
(43939, '2.60.210.10-FF-000022', NULL, 'TRAF-like family protein', 143, NULL, NULL, 43939),
(43940, '3.40.630.30-FF-000301', NULL, 'Ribosomal-protein-alanine acetyltransferase', 143, NULL, NULL, 43940),
(43941, '3.40.390.10-FF-000102', NULL, 'Matrix metalloproteinase 16', 253, NULL, NULL, 43941),
(43942, '2.60.40.10-FF-002221', NULL, 'Major histocompatibility complex class I ZKA', 100, NULL, NULL, 43942),
(43943, '3.20.20.70-FF-000062', NULL, 'Cytochrome b2, mitochondrial, putative', 371, NULL, NULL, 43943),
(43944, '3.40.50.300-FF-006241', NULL, 'Predicted protein', 235, NULL, NULL, 43944),
(43945, '1.10.150.370-FF-000002', NULL, 'Protein her-1', 64, NULL, NULL, 43945),
(43946, '3.40.50.12690-FF-000001', NULL, 'Predicted protein', 61, NULL, NULL, 43946),
(43947, '3.40.630.30-FF-000296', NULL, 'N-acetyltransferase', 175, NULL, NULL, 43947),
(43948, '1.20.120.290-FF-000009', NULL, 'Oxygen evolving enhancer protein 3', 138, NULL, NULL, 43948),
(43949, '3.40.350.10-FF-000100', NULL, 'Predicted protein', 177, NULL, NULL, 43949),
(43950, '3.20.20.60-FF-000109', NULL, 'HpcH/HpaI aldolase/citrate lyase family, putative', 344, NULL, NULL, 43950),
(43951, '3.10.20.90-FF-000265', NULL, 'Ras-associating and dilute domain-containing protein', 166, NULL, NULL, 43951),
(43952, '1.10.150.60-FF-000018', NULL, 'AT-rich interactive domain-containing protein 3', 100, NULL, NULL, 43952),
(43953, '1.20.58.1280-FF-000007', NULL, 'DNA repair protein REV1', 90, NULL, NULL, 43953),
(43954, '3.40.190.10-FF-000418', NULL, 'Probable transcriptional regulator', 86, NULL, NULL, 43954),
(43955, '3.40.50.10190-FF-000246', NULL, 'Uncharacterized protein', 178, NULL, NULL, 43955),
(43956, '2.30.330.10-FF-000009', NULL, 'Flagellar motor switch protein FliM', 95, NULL, NULL, 43956),
(43957, '3.30.160.60-FF-006471', NULL, NULL, 48, NULL, NULL, 43957),
(43958, '3.40.50.1820-FF-001434', NULL, 'Lipase, putative', 194, NULL, NULL, 43958),
(43959, '1.10.472.10-FF-000526', NULL, 'Uncharacterized protein', 92, NULL, NULL, 43959);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(43960, '3.80.10.10-FF-003413', NULL, 'Uncharacterized protein', 259, NULL, NULL, 43960),
(43961, '4.10.970.10-FF-000009', NULL, 'Uncharacterized protein', 63, NULL, NULL, 43961),
(43962, '1.10.510.10-FF-003325', NULL, NULL, 65, NULL, NULL, 43962),
(43963, '1.10.10.10-FF-000279', NULL, 'Transcriptional regulator, ArsR family', 93, NULL, NULL, 43963),
(43964, '3.20.20.220-FF-000066', NULL, 'Proline dehydrogenase', 168, NULL, NULL, 43964),
(43965, '3.30.160.60-FF-000636', NULL, 'Zinc finger protein', 25, NULL, NULL, 43965),
(43966, '2.130.10.10-FF-003334', NULL, 'Pre-mRNA processing factor 4 (PRP4) like/WD domain, G-beta repeat, putative', 155, NULL, NULL, 43966),
(43967, '1.20.1280.50-FF-000078', NULL, 'F-box family protein', 47, NULL, NULL, 43967),
(43968, '2.40.128.330-FF-000015', NULL, 'Mitochondrial inner membrane magnesium transporter MRS2', 92, NULL, NULL, 43968),
(43969, '3.90.70.10-FF-000319', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 321, NULL, NULL, 43969),
(43970, '2.130.10.10-FF-001480', NULL, 'WD domain, G-beta repeat-containing protein', 192, NULL, NULL, 43970),
(43971, '3.30.420.40-FF-000252', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', 205, NULL, NULL, 43971),
(43972, '1.10.3080.10-FF-000087', NULL, 'Chloride channel protein', 224, NULL, NULL, 43972),
(43973, '2.60.40.820-FF-000048', NULL, 'Uncharacterized protein', 61, NULL, NULL, 43973),
(43974, '3.40.50.300-FF-006185', NULL, 'Predicted protein', 69, NULL, NULL, 43974),
(43975, '3.30.160.20-FF-000091', NULL, 'Peptide chain release factor 2', 91, NULL, NULL, 43975),
(43976, '1.25.40.10-FF-004025', NULL, 'Uncharacterized protein', 333, NULL, NULL, 43976),
(43977, '3.30.930.10-FF-000028', NULL, 'Phenylalanyl-tRNA synthetase alpha chain', 273, NULL, NULL, 43977),
(43978, '1.10.20.10-FF-000105', NULL, 'Inner kinetochore subunit cnp20', 106, NULL, NULL, 43978),
(43979, '2.10.70.10-FF-000185', NULL, 'Uncharacterized protein', 57, NULL, NULL, 43979),
(43980, '3.80.10.10-FF-001120', NULL, 'MDIS1-interacting receptor like kinase 2 isoform A', 100, NULL, NULL, 43980),
(43981, '3.90.70.30-FF-000005', NULL, 'Uncharacterized protein', 164, NULL, NULL, 43981),
(43982, '1.20.1270.10-FF-000088', NULL, 'ER-located HSP110/SSE-like protein', 107, NULL, NULL, 43982),
(43983, '3.40.390.10-FF-000046', NULL, 'Serralysin', 227, NULL, NULL, 43983),
(43984, '2.60.120.290-FF-000218', NULL, 'C-type LECtin', 114, NULL, NULL, 43984),
(43985, '3.10.50.30-FF-000007', NULL, 'Trigger factor', 84, NULL, NULL, 43985),
(43986, '3.30.1590.10-FF-000001', NULL, 'Malto-oligosyltrehalose synthase', 138, NULL, NULL, 43986),
(43987, '3.30.40.10-FF-001821', NULL, 'Uncharacterized ATP-dependent helicase C144.05', 101, NULL, NULL, 43987),
(43988, '1.20.1560.10-FF-000863', NULL, 'Uncharacterized protein', 173, NULL, NULL, 43988),
(43989, '3.40.50.300-FF-000878', NULL, 'Mitochondrial Rho GTPase', 99, NULL, NULL, 43989),
(43990, '3.30.160.60-FF-004907', NULL, NULL, 70, NULL, NULL, 43990),
(43991, '3.40.50.300-FF-007527', NULL, 'DNA helicase', 208, NULL, NULL, 43991),
(43992, '3.10.580.10-FF-000005', NULL, 'HlyC/CorC family transporter', 154, NULL, NULL, 43992),
(43993, '1.25.40.20-FF-000436', NULL, 'Swh1p', 90, NULL, NULL, 43993),
(43994, '3.80.10.10-FF-003357', NULL, 'Uncharacterized protein, isoform D', 114, NULL, NULL, 43994),
(43995, '1.20.1250.20-FF-002332', NULL, 'Uncharacterized protein', 159, NULL, NULL, 43995),
(43996, '2.130.10.10-FF-005695', NULL, 'Uncharacterized protein', 152, NULL, NULL, 43996),
(43997, '3.40.50.1100-FF-000263', NULL, 'Uncharacterized protein', 119, NULL, NULL, 43997),
(43998, '3.30.565.10-FF-000062', NULL, 'Type 2 DNA topoisomerase 6 subunit B', 230, NULL, NULL, 43998),
(43999, '3.20.20.100-FF-000176', NULL, 'Oxidoreductase, aldo/keto reductase family protein', 164, NULL, NULL, 43999),
(44000, '1.25.40.10-FF-001271', NULL, 'HemY protein', 87, NULL, NULL, 44000),
(44001, '3.40.50.150-FF-000052', NULL, 'Probable histone-arginine methyltransferase CARM1', 161, NULL, NULL, 44001),
(44002, '3.40.50.300-FF-004296', NULL, 'Predicted protein', 303, NULL, NULL, 44002);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(44003, '1.10.510.10-FF-003802', NULL, NULL, 122, NULL, NULL, 44003),
(44004, '3.30.1670.10-FF-000002', NULL, 'Mercaptopyruvate sulfurtransferase, putative', 69, NULL, NULL, 44004),
(44005, '2.30.30.30-FF-000120', NULL, 'Ribosomal protein L26, putative', 90, NULL, NULL, 44005),
(44006, '1.10.472.10-FF-000150', NULL, 'Cyclin-T1-3 isoform A', 91, NULL, NULL, 44006),
(44007, '1.10.287.4070-FF-000011', NULL, 'Nucleolar protein NOP5/ snoRNA binding domain', 165, NULL, NULL, 44007),
(44008, '3.40.50.2300-FF-000842', NULL, 'Vomeronasal 2, receptor 73', 148, NULL, NULL, 44008),
(44009, '1.10.720.140-FF-000001', NULL, 'E3 ubiquitin-protein ligase RNF34 isoform X1', 81, NULL, NULL, 44009),
(44010, '1.25.40.10-FF-004502', NULL, 'TPR repeat protein', 92, NULL, NULL, 44010),
(44011, '1.10.510.10-FF-000571', NULL, 'Maternal embryonic leucine zipper kinase', 336, NULL, NULL, 44011),
(44012, '2.10.25.10-FF-001126', NULL, 'Uncharacterized protein (Fragment)', 37, NULL, NULL, 44012),
(44013, '1.25.40.530-FF-000011', NULL, 'Myosin 10A, isoform C', 182, NULL, NULL, 44013),
(44014, '1.20.5.700-FF-000004', NULL, 'Cytochrome b6-f complex iron-sulfur subunit', 43, NULL, NULL, 44014),
(44015, '2.40.50.100-FF-000120', NULL, 'Molybdenum import ATP-binding protein ModC', 76, NULL, NULL, 44015),
(44016, '3.90.1150.10-FF-000297', NULL, 'Transcriptional regulator, GntR family', 137, NULL, NULL, 44016),
(44017, '2.10.50.10-FF-000127', NULL, 'C-type LECtin', 54, NULL, NULL, 44017),
(44018, '3.30.420.10-FF-000237', NULL, 'DNA polymerase', 257, NULL, NULL, 44018),
(44019, '3.40.50.1110-FF-000120', NULL, 'Uncharacterized protein', 243, NULL, NULL, 44019),
(44020, '2.60.40.3960-FF-000004', NULL, 'Spore development regulator vosA', 176, NULL, NULL, 44020),
(44021, '3.40.50.300-FF-003312', NULL, 'Small GTPase EhRabX14, putative', 205, NULL, NULL, 44021),
(44022, '2.40.70.10-FF-000234', NULL, 'Endopeptidase', 159, NULL, NULL, 44022),
(44023, '3.30.930.10-FF-000091', NULL, 'Glycine--tRNA ligase', 74, NULL, NULL, 44023),
(44024, '2.10.25.10-FF-000614', NULL, 'Neurogenic locus notch protein 1', 38, NULL, NULL, 44024),
(44025, '3.40.50.1000-FF-000851', NULL, NULL, 59, NULL, NULL, 44025),
(44026, '3.30.450.30-FF-000048', NULL, 'Late endosomal/lysosomal adaptor, Mapk (MAPK) and mToR (MTOR) activator homolog', 94, NULL, NULL, 44026),
(44027, '3.30.70.20-FF-000050', NULL, 'Periplasmic [Fe] hydrogenase large subunit', 54, NULL, NULL, 44027),
(44028, '1.20.144.10-FF-000094', NULL, 'Phospholipid phosphatase 1', 266, NULL, NULL, 44028),
(44029, '2.60.120.920-FF-000149', NULL, 'Uncharacterized protein', 113, NULL, NULL, 44029),
(44030, '1.10.630.10-FF-000838', NULL, 'Uncharacterized protein', 348, NULL, NULL, 44030),
(44031, '3.10.100.10-FF-000004', NULL, 'CD44 antigen isoform X2', 92, NULL, NULL, 44031),
(44032, '1.20.1530.20-FF-000072', NULL, 'Cation/H(+) antiporter 15', 70, NULL, NULL, 44032),
(44033, '3.30.1330.90-FF-000017', NULL, 'L-serine ammonia-lyase', 49, NULL, NULL, 44033),
(44034, '1.10.510.10-FF-002460', NULL, 'Uncharacterized protein', 275, NULL, NULL, 44034),
(44035, '1.10.730.10-FF-000054', NULL, 'Valine--tRNA ligase', 189, NULL, NULL, 44035),
(44036, '1.10.730.10-FF-000110', NULL, 'Leucine--tRNA ligase', 173, NULL, NULL, 44036),
(44037, '3.40.30.10-FF-000926', NULL, 'Probable thiol:disulfide interchange protein', 123, NULL, NULL, 44037),
(44038, '3.40.50.1580-FF-000064', NULL, 'Purine nucleoside phosphorylase', 196, NULL, NULL, 44038),
(44039, '2.130.10.10-FF-001417', NULL, 'WD repeat domain 90', 275, NULL, NULL, 44039),
(44040, '1.10.3380.10-FF-000076', NULL, 'DEAD/DEAH box helicase family protein', 141, NULL, NULL, 44040),
(44041, '2.60.40.290-FF-000001', NULL, 'Glucanase', 110, NULL, NULL, 44041),
(44042, '3.40.50.300-FF-000081', NULL, 'Preprotein translocase subunit SecA', 256, NULL, NULL, 44042),
(44043, '1.20.1310.20-FF-000033', NULL, 'PfEMP1 variant 1 of strain MC', 181, NULL, NULL, 44043),
(44044, '4.10.800.10-FF-000031', NULL, 'Uncharacterized protein', 60, NULL, NULL, 44044),
(44045, '1.20.1050.10-FF-000077', NULL, 'Protein CBG23268', 113, NULL, NULL, 44045);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(44046, '1.10.510.10-FF-002021', NULL, NULL, 139, NULL, NULL, 44046),
(44047, '1.10.10.1800-FF-000003', NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', 104, NULL, NULL, 44047),
(44048, '3.40.1260.10-FF-000002', NULL, 'Sulfurtransferase TusB', 95, NULL, NULL, 44048),
(44049, '3.15.20.10-FF-000017', NULL, 'Uncharacterized protein', 105, NULL, NULL, 44049),
(44050, '3.40.50.2300-FF-001298', NULL, NULL, 133, NULL, NULL, 44050),
(44051, '3.30.160.60-FF-003126', NULL, 'Zinc finger imprinted 2', 25, NULL, NULL, 44051),
(44052, '2.40.10.10-FF-000697', NULL, NULL, 128, NULL, NULL, 44052),
(44053, '3.30.465.10-FF-000003', NULL, 'Magnesium and cobalt efflux protein corC', 95, NULL, NULL, 44053),
(44054, '2.130.10.10-FF-005223', NULL, 'Ribosome biogenesis protein WDR12 homolog', 74, NULL, NULL, 44054),
(44055, '2.20.100.10-FF-000197', NULL, 'Thrombospondin type 1 domain containing 7A', 58, NULL, NULL, 44055),
(44056, '2.40.100.10-FF-000063', NULL, 'Peptidyl-prolyl cis-trans isomerase', 163, NULL, NULL, 44056),
(44057, '3.40.190.10-FF-000946', NULL, 'Uncharacterized protein', 13, NULL, NULL, 44057),
(44058, '3.40.50.300-FF-003840', NULL, 'Uncharacterized protein', 247, NULL, NULL, 44058),
(44059, '3.40.50.150-FF-001833', NULL, NULL, 65, NULL, NULL, 44059),
(44060, '4.10.1060.10-FF-000066', NULL, 'Uncharacterized protein', 36, NULL, NULL, 44060),
(44061, '3.30.830.10-FF-000083', NULL, 'Putative insulinase', 234, NULL, NULL, 44061),
(44062, '2.60.40.1930-FF-000007', NULL, 'Complement C4-A', 124, NULL, NULL, 44062),
(44063, '3.10.330.20-FF-000018', NULL, 'tRNA (Adenine(58)-N(1))-methyltransferase, mitochondrial', 66, NULL, NULL, 44063),
(44064, '1.50.40.10-FF-000015', NULL, 'Solute carrier family 25 member 36', 306, NULL, NULL, 44064),
(44065, '3.20.20.140-FF-000396', NULL, 'Ribonuclease P protein subunit p30, putative', 140, NULL, NULL, 44065),
(44066, '2.60.40.2160-FF-000009', NULL, NULL, 99, NULL, NULL, 44066),
(44067, '3.80.10.10-FF-002901', NULL, 'Uncharacterized protein', 147, NULL, NULL, 44067),
(44068, '3.50.50.60-FF-000897', NULL, 'Glutathione reductase', 117, NULL, NULL, 44068),
(44069, '3.40.50.150-FF-000844', NULL, NULL, 170, NULL, NULL, 44069),
(44070, '2.160.20.60-FF-000004', NULL, 'NAD(P)H-dependent glutamate synthase, putative', 272, NULL, NULL, 44070),
(44071, '3.30.450.20-FF-000686', NULL, 'Blr6052 protein', 49, NULL, NULL, 44071),
(44072, '1.20.1280.50-FF-000134', NULL, 'F-box domain containing protein, expressed', 50, NULL, NULL, 44072),
(44073, '3.30.160.60-FF-002614', NULL, 'Pita, isoform B', 31, NULL, NULL, 44073),
(44074, '2.30.30.140-FF-000242', NULL, 'Protein CBR-ARID-1', 120, NULL, NULL, 44074),
(44075, '3.40.1340.10-FF-000003', NULL, 'DNA-directed RNA polymerase II, putative', 129, NULL, NULL, 44075),
(44076, '3.20.70.20-FF-000039', NULL, 'Uncharacterized protein', 173, NULL, NULL, 44076),
(44077, '3.20.20.80-FF-000267', NULL, 'Beta-galactosidase', 261, NULL, NULL, 44077),
(44078, '1.20.1070.10-FF-000640', NULL, 'Frizzled-2', 382, NULL, NULL, 44078),
(44079, '3.40.50.300-FF-008039', NULL, 'Uncharacterized protein', 133, NULL, NULL, 44079),
(44080, '3.40.50.11040-FF-000012', NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', 207, NULL, NULL, 44080),
(44081, '3.40.50.720-FF-001757', NULL, 'Uncharacterized protein', 177, NULL, NULL, 44081),
(44082, '3.90.580.10-FF-000004', NULL, 'DNA primase domain protein', 83, NULL, NULL, 44082),
(44083, '3.80.10.10-FF-002429', NULL, 'Uncharacterized protein', 152, NULL, NULL, 44083),
(44084, '3.40.50.2020-FF-000117', NULL, 'Phosphoribosyl pyrophosphate synthetase', 148, NULL, NULL, 44084),
(44085, '2.130.10.10-FF-003278', NULL, 'DmX-like protein 2', 155, NULL, NULL, 44085),
(44086, '3.40.50.10090-FF-000042', NULL, 'Uroporphyrinogen III synthase/methyltransferase', 95, NULL, NULL, 44086),
(44087, '3.40.50.300-FF-003368', NULL, 'Putative DEAD/DEAH box helicase', 249, NULL, NULL, 44087),
(44088, '1.10.390.10-FF-000015', NULL, 'Aminopeptidase', 260, NULL, NULL, 44088),
(44089, '1.25.40.180-FF-000209', NULL, NULL, 159, NULL, NULL, 44089);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(44090, '2.60.40.150-FF-000420', NULL, 'Protein SRC2 homolog', 132, NULL, NULL, 44090),
(44091, '1.10.10.1500-FF-000003', NULL, 'Uncharacterized protein', 75, NULL, NULL, 44091),
(44092, '3.10.25.10-FF-000016', NULL, 'Methionyl-tRNA formyltransferase', 109, NULL, NULL, 44092),
(44093, '3.80.10.10-FF-002368', NULL, 'At1g80630', 231, NULL, NULL, 44093),
(44094, '3.90.1100.10-FF-000053', NULL, 'RNA polymerase I subunit B', 96, NULL, NULL, 44094),
(44095, '1.10.10.10-FF-000335', NULL, 'Spi-C transcription factor', 133, NULL, NULL, 44095),
(44096, '1.25.40.70-FF-000018', NULL, 'Phosphatidylinositol 4-kinase', 141, NULL, NULL, 44096),
(44097, '3.10.100.10-FF-000032', NULL, 'Secretory phospholipase A2 receptor', 145, NULL, NULL, 44097),
(44098, '2.60.40.10-FF-000243', NULL, 'MAM domain-containing glycosylphosphatidylinositol anchor protein 1', 105, NULL, NULL, 44098),
(44099, '1.25.40.550-FF-000017', NULL, 'Uncharacterized protein', 194, NULL, NULL, 44099),
(44100, '3.40.50.10130-FF-000020', NULL, 'Crossover junction endonuclease MUS81', 161, NULL, NULL, 44100),
(44101, '3.30.450.40-FF-000080', NULL, 'Two component sensor histidine kinase', 152, NULL, NULL, 44101),
(44102, '1.10.565.10-FF-000130', NULL, 'AGAP012921-PA', 89, NULL, NULL, 44102),
(44103, '1.10.287.70-FF-000389', NULL, 'CPD photolyase class II', 139, NULL, NULL, 44103),
(44104, '3.90.1300.10-FF-000034', NULL, 'Fatty acid amide hydrolase, gene 3', 337, NULL, NULL, 44104),
(44105, '3.30.300.20-FF-000063', NULL, 'Uncharacterized protein', 42, NULL, NULL, 44105),
(44106, '3.30.465.10-FF-000059', NULL, 'D-lactate dehydrogenase-like protein', 211, NULL, NULL, 44106),
(44107, '1.50.40.10-FF-000190', NULL, 'Unplaced genomic scaffold supercont2.19, whole genome shotgun sequence', 91, NULL, NULL, 44107),
(44108, '1.20.1270.280-FF-000052', NULL, 'Uncharacterized protein', 163, NULL, NULL, 44108),
(44109, '1.20.58.1070-FF-000006', NULL, 'Gem-associated protein 2', 66, NULL, NULL, 44109),
(44110, '2.60.260.20-FF-000067', NULL, 'GD13648', 83, NULL, NULL, 44110),
(44111, '1.25.10.10-FF-000515', NULL, 'Importin subunit alpha', 419, NULL, NULL, 44111),
(44112, '2.60.120.780-FF-000005', NULL, 'Chromatin protein', 147, NULL, NULL, 44112),
(44113, '3.30.505.10-FF-000114', NULL, 'Tyrosine-protein kinase', 106, NULL, NULL, 44113),
(44114, '3.30.160.60-FF-005487', NULL, NULL, 38, NULL, NULL, 44114),
(44115, '1.20.5.1190-FF-000014', NULL, 'Sodium channel protein', 29, NULL, NULL, 44115),
(44116, '2.60.260.20-FF-000123', NULL, 'DnaJ-like protein subfamily A member 2', 71, NULL, NULL, 44116),
(44117, '3.30.160.60-FF-005543', NULL, NULL, 27, NULL, NULL, 44117),
(44118, '1.20.1540.10-FF-000013', NULL, 'Rhomboid protease aarA', 186, NULL, NULL, 44118),
(44119, '3.90.660.10-FF-000005', NULL, 'Polyamine oxidase 2', 218, NULL, NULL, 44119),
(44120, '2.60.110.10-FF-000019', NULL, 'Thaumatin-like protein 1', 215, NULL, NULL, 44120),
(44121, '1.10.287.930-FF-000001', NULL, 'Potassium voltage-gated channel, subfamily G, member 1', 68, NULL, NULL, 44121),
(44122, '1.20.1250.20-FF-000387', NULL, 'H(+) MyoInositol coTransporter', 146, NULL, NULL, 44122),
(44123, '1.20.930.40-FF-000025', NULL, 'Putative zinc metalloprotease', 164, NULL, NULL, 44123),
(44124, '3.90.79.10-FF-000042', NULL, 'Probable NADH pyrophosphatase', 155, NULL, NULL, 44124),
(44125, '2.60.34.10-FF-000127', NULL, 'Uncharacterized protein', 117, NULL, NULL, 44125),
(44126, '1.20.1270.60-FF-000226', NULL, 'Brain-specific angiogenesis inhibitor 1-associated protein 2', 230, NULL, NULL, 44126),
(44127, '3.30.457.60-FF-000005', NULL, 'Spindle assembly checkpoint component', 102, NULL, NULL, 44127),
(44128, '1.10.287.1080-FF-000007', NULL, 'Nucleotide pyrophosphohydrolase', 101, NULL, NULL, 44128),
(44129, '1.10.150.670-FF-000002', NULL, 'Crossover junction endonuclease EME1', 103, NULL, NULL, 44129),
(44130, '1.20.990.10-FF-000019', NULL, 'Methionine synthase reductase', 132, NULL, NULL, 44130),
(44131, '1.20.1530.20-FF-000044', NULL, 'Glutathione-gated K(+)-efflux system KefB', 382, NULL, NULL, 44131),
(44132, '1.10.167.10-FF-000036', NULL, 'Regulator of G-protein signaling rgs-3', 133, NULL, NULL, 44132);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(44133, '3.40.50.1820-FF-001018', NULL, 'Uncharacterized protein', 205, NULL, NULL, 44133),
(44134, '3.90.740.10-FF-000006', NULL, 'Isoleucine--tRNA ligase', 151, NULL, NULL, 44134),
(44135, '6.10.250.3290-FF-000001', NULL, 'Resistin-like beta', 20, NULL, NULL, 44135),
(44136, '1.20.1250.20-FF-000882', NULL, 'Enterobactin transporter', 193, NULL, NULL, 44136),
(44137, '3.20.20.70-FF-000085', NULL, '7-carboxy-7-deazaguanine synthase', 222, NULL, NULL, 44137),
(44138, '3.80.10.10-FF-000479', NULL, 'Uncharacterized protein, isoform C', 149, NULL, NULL, 44138),
(44139, '3.40.605.10-FF-000125', NULL, 'Long-chain acyl-protein thioester reductase', 125, NULL, NULL, 44139),
(44140, '2.130.10.10-FF-000075', NULL, 'Protein HIRA', 307, NULL, NULL, 44140),
(44141, '3.30.160.60-FF-006476', NULL, NULL, 39, NULL, NULL, 44141),
(44142, '3.30.1610.10-FF-000021', NULL, 'Uncharacterized protein', 98, NULL, NULL, 44142),
(44143, '3.30.70.1560-FF-000004', NULL, 'Ribosomal large subunit pseudouridine synthase B', 86, NULL, NULL, 44143),
(44144, '3.90.1420.10-FF-000009', NULL, 'Histone-lysine N-methyltransferase setd3', 148, NULL, NULL, 44144),
(44145, '3.30.572.10-FF-000027', NULL, 'Putative thymidylate synthase', 218, NULL, NULL, 44145),
(44146, '2.10.80.10-FF-000011', NULL, 'Uncharacterized protein', 85, NULL, NULL, 44146),
(44147, '3.90.1150.10-FF-000292', NULL, 'Threonine aldolase', 92, NULL, NULL, 44147),
(44148, '2.60.120.310-FF-000005', NULL, 'Peptidylglycine alpha-hydroxylating monooxygenase', 151, NULL, NULL, 44148),
(44149, '2.60.120.10-FF-000672', NULL, 'Uncharacterized protein', 103, NULL, NULL, 44149),
(44150, '3.40.50.1820-FF-000945', NULL, 'Uncharacterized protein', 304, NULL, NULL, 44150),
(44151, '3.40.50.20-FF-000082', NULL, 'Uncharacterized protein', 104, NULL, NULL, 44151),
(44152, '3.40.50.620-FF-000564', NULL, 'Probable nicotinate-nucleotide adenylyltransferase', 203, NULL, NULL, 44152),
(44153, '3.30.40.10-FF-000888', NULL, 'Histone-lysine N-methyltransferase', 102, NULL, NULL, 44153),
(44154, '3.30.70.330-FF-002248', NULL, NULL, 147, NULL, NULL, 44154),
(44155, '3.40.50.720-FF-000032', NULL, 'UDP-glucose 6-dehydrogenase', 210, NULL, NULL, 44155),
(44156, '3.30.360.10-FF-000119', NULL, 'Uncharacterized protein', 83, NULL, NULL, 44156),
(44157, '2.160.10.10-FF-000101', NULL, 'Probable maltose O-acetyltransferase', 192, NULL, NULL, 44157),
(44158, '2.20.25.20-FF-000010', NULL, 'RBR-type E3 ubiquitin transferase', 44, NULL, NULL, 44158),
(44159, '3.30.40.10-FF-002310', NULL, 'Uncharacterized protein', 112, NULL, NULL, 44159),
(44160, '3.90.550.20-FF-000005', NULL, 'Unplaced genomic scaffold supercont1.17, whole genome shotgun sequence', 202, NULL, NULL, 44160),
(44161, '3.50.50.100-FF-000029', NULL, 'Type-II NADH dehydrogenase', 130, NULL, NULL, 44161),
(44162, '1.10.1060.10-FF-000029', NULL, 'Succinate dehydrogenase [ubiquinone] iron-sulfur subunit, mitochondrial', 142, NULL, NULL, 44162),
(44163, '2.30.29.30-FF-000667', NULL, 'Phosphoinositide phospholipase C', 135, NULL, NULL, 44163),
(44164, '3.40.710.10-FF-000139', NULL, 'D-alanyl-D-alanine carboxypeptidase', 330, NULL, NULL, 44164),
(44165, '3.90.226.10-FF-000345', NULL, 'Enoyl-CoA hydratase, short chain 1', 54, NULL, NULL, 44165),
(44166, '3.80.10.10-FF-004341', NULL, 'Protein CLP1 homolog', 190, NULL, NULL, 44166),
(44167, '3.40.50.360-FF-000053', NULL, 'Protein NrdI', 130, NULL, NULL, 44167),
(44168, '1.10.238.10-FF-000319', NULL, 'Allograft inflammatory factor 1-like', 83, NULL, NULL, 44168),
(44169, '3.30.160.60-FF-004054', NULL, NULL, 34, NULL, NULL, 44169),
(44170, '3.80.10.10-FF-004369', NULL, 'Ras guanine nucleotide exchange factor L', 369, NULL, NULL, 44170),
(44171, '3.30.70.330-FF-001236', NULL, 'Uncharacterized protein', 86, NULL, NULL, 44171),
(44172, '2.60.120.200-FF-000467', NULL, 'Basement membrane proteoglycan', 164, NULL, NULL, 44172),
(44173, '2.60.40.10-FF-005863', NULL, NULL, 67, NULL, NULL, 44173),
(44174, '1.20.1250.20-FF-000590', NULL, 'Vba1p', 178, NULL, NULL, 44174),
(44175, '1.10.8.60-FF-000321', NULL, 'Lon protease', 93, NULL, NULL, 44175);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(44176, '3.30.1370.10-FF-000013', NULL, 'Mex-3 RNA-binding family member B', 71, NULL, NULL, 44176),
(44177, '1.20.1460.10-FF-000012', NULL, 'V-type proton ATPase subunit C', 62, NULL, NULL, 44177),
(44178, '1.10.238.10-FF-000027', NULL, 'Calmodulin (CaM)', 26, NULL, NULL, 44178),
(44179, '3.30.710.10-FF-000517', NULL, 'Uncharacterized protein', 49, NULL, NULL, 44179),
(44180, '1.25.40.20-FF-001892', NULL, 'Transient receptor potential cation channel subfamily A member 1 homolog', 150, NULL, NULL, 44180),
(44181, '2.130.10.10-FF-003750', NULL, 'Uncharacterized protein', 328, NULL, NULL, 44181),
(44182, '3.90.175.10-FF-000001', NULL, 'Grass carp reovirus (GCRV)-induced gene 2e', 100, NULL, NULL, 44182),
(44183, '3.30.200.20-FF-001983', NULL, 'Uncharacterized protein', 99, NULL, NULL, 44183),
(44184, '2.130.10.30-FF-000119', NULL, 'Serine/threonine-protein kinase Nek8-like Protein', 340, NULL, NULL, 44184),
(44185, '3.20.20.140-FF-000340', NULL, 'Adenosine/AMP deaminase', 359, NULL, NULL, 44185),
(44186, '3.40.47.10-FF-000105', NULL, 'Polyketide biosynthesis 3-hydroxy-3-methylglutaryl-ACP synthase PksG', 152, NULL, NULL, 44186),
(44187, '2.20.110.10-FF-000079', NULL, NULL, 88, NULL, NULL, 44187),
(44188, '3.30.200.20-FF-000971', NULL, 'Putative serine/threonine-protein kinase Nek3', 94, NULL, NULL, 44188),
(44189, '2.60.40.60-FF-000302', NULL, 'CaDHerin family', 105, NULL, NULL, 44189),
(44190, '2.40.50.140-FF-001250', NULL, NULL, 143, NULL, NULL, 44190),
(44191, '4.10.1110.10-FF-000003', NULL, 'AN1-type zinc finger protein 2B isoform X1', 62, NULL, NULL, 44191),
(44192, '1.10.10.1200-FF-000008', NULL, 'Melanoma-associated antigen G1-like protein', 104, NULL, NULL, 44192),
(44193, '2.60.40.1720-FF-000001', NULL, 'Calcium-dependent cell adhesion molecule 1', 118, NULL, NULL, 44193),
(44194, '3.40.50.1000-FF-000435', NULL, NULL, 69, NULL, NULL, 44194),
(44195, '3.60.10.10-FF-000289', NULL, 'DNA-(apurinic or apyrimidinic site) lyase', 128, NULL, NULL, 44195),
(44196, '2.40.50.140-FF-001278', NULL, NULL, 138, NULL, NULL, 44196),
(44197, '3.30.499.10-FF-000036', NULL, NULL, 122, NULL, NULL, 44197),
(44198, '3.40.50.300-FF-004801', NULL, 'Nitrogen assimilation regulatory protein ntrX', 174, NULL, NULL, 44198),
(44199, '1.20.1280.50-FF-000139', NULL, 'AGAP011930-PA', 39, NULL, NULL, 44199),
(44200, '3.40.50.1440-FF-000011', NULL, 'Tubulin alpha chain', 268, NULL, NULL, 44200),
(44201, '1.10.533.10-FF-000135', NULL, 'SBP (S-ribonuclease binding protein) family protein', 134, NULL, NULL, 44201),
(44202, '3.40.50.720-FF-000768', NULL, 'Prodigiosin synthesizing transferase PigC', 180, NULL, NULL, 44202),
(44203, '3.40.605.10-FF-000069', NULL, 'Predicted protein', 27, NULL, NULL, 44203),
(44204, '3.40.50.740-FF-000038', NULL, 'NADH-quinone oxidoreductase', 213, NULL, NULL, 44204),
(44205, '1.10.10.10-FF-001768', NULL, 'ORC1-type DNA replication protein', 102, NULL, NULL, 44205),
(44206, '3.90.320.10-FF-000047', NULL, 'Uncharacterized protein', 150, NULL, NULL, 44206),
(44207, '1.10.287.130-FF-000154', NULL, 'Adaptive-response sensory kinase', 79, NULL, NULL, 44207),
(44208, '4.10.1240.10-FF-000007', NULL, 'Corticotropin-releasing factor receptor 1', 83, NULL, NULL, 44208),
(44209, '1.10.10.10-FF-001263', NULL, 'Cullin-like protein', 83, NULL, NULL, 44209),
(44210, '2.60.40.10-FF-001968', NULL, 'KETtiN (Drosophila actin-binding) homolog', 114, NULL, NULL, 44210),
(44211, '3.40.50.300-FF-004616', NULL, 'Small nuclear ribonucleoprotein U5 subunit 200', 50, NULL, NULL, 44211),
(44212, '3.40.1190.20-FF-000090', NULL, 'Putative Pyridoxal kinase', 300, NULL, NULL, 44212),
(44213, '3.40.50.2300-FF-001331', NULL, NULL, 80, NULL, NULL, 44213),
(44214, '1.10.730.10-FF-000082', NULL, 'Methionyl-tRNA synthetase, putative', 180, NULL, NULL, 44214),
(44215, '3.80.10.10-FF-000631', NULL, 'Leucine-rich repeat extensin-like protein 5', 141, NULL, NULL, 44215),
(44216, '1.10.150.50-FF-000105', NULL, 'Blast:Protein aveugle', 78, NULL, NULL, 44216),
(44217, '3.40.50.620-FF-000912', NULL, 'Uncharacterized protein', 31, NULL, NULL, 44217);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(44218, '3.40.525.10-FF-000068', NULL, 'Uncharacterized protein', 301, NULL, NULL, 44218),
(44219, '3.30.70.330-FF-000303', NULL, 'RNA-binding motif protein 12', 121, NULL, NULL, 44219),
(44220, '2.120.10.80-FF-000337', NULL, 'Uncharacterized protein', 121, NULL, NULL, 44220),
(44221, '2.20.100.10-FF-000253', NULL, 'Uncharacterized protein', 45, NULL, NULL, 44221),
(44222, '3.40.630.10-FF-000138', NULL, 'Protein CBG11596', 299, NULL, NULL, 44222),
(44223, '1.25.40.10-FF-005014', NULL, 'Uncharacterized protein', 115, NULL, NULL, 44223),
(44224, '2.60.40.10-FF-004402', NULL, NULL, 77, NULL, NULL, 44224),
(44225, '3.30.1120.130-FF-000001', NULL, 'serine/threonine-protein kinase PLK4 isoform X1', 108, NULL, NULL, 44225),
(44226, '3.40.50.300-FF-003784', NULL, 'Iron-sulfur cluster carrier protein', 228, NULL, NULL, 44226),
(44227, '1.10.287.40-FF-000026', NULL, 'Serine--tRNA ligase', 48, NULL, NULL, 44227),
(44228, '1.10.287.70-FF-000630', NULL, 'Uncharacterized protein', 206, NULL, NULL, 44228),
(44229, '1.10.10.60-FF-000064', NULL, 'Zinc finger homeobox protein 4', 66, NULL, NULL, 44229),
(44230, '3.30.60.210-FF-000001', NULL, 'Meiotic chromosome segregation protein P8B7.28c', 58, NULL, NULL, 44230),
(44231, '3.40.50.300-FF-000906', NULL, 'Probable ATP-dependent RNA helicase DDX52', 239, NULL, NULL, 44231),
(44232, '1.25.40.1010-FF-000006', NULL, 'Unplaced genomic scaffold supercont1.13, whole genome shotgun sequence', 205, NULL, NULL, 44232),
(44233, '3.30.60.30-FF-000142', NULL, 'SPARC-related modular calcium-binding 1', 56, NULL, NULL, 44233),
(44234, '2.60.40.10-FF-003946', NULL, NULL, 105, NULL, NULL, 44234),
(44235, '3.40.50.720-FF-001752', NULL, 'S-(Hydroxymethyl)glutathione dehydrogenase', 142, NULL, NULL, 44235),
(44236, '1.20.1250.20-FF-001219', NULL, 'Glucitol/sorbitol-specific transport protein GutA', 213, NULL, NULL, 44236),
(44237, '3.30.1360.200-FF-000002', NULL, 'Preprotein translocase subunit SecD', 130, NULL, NULL, 44237),
(44238, '3.80.10.10-FF-002424', NULL, 'Uncharacterized protein', 104, NULL, NULL, 44238),
(44239, '3.30.160.60-FF-004531', NULL, NULL, 20, NULL, NULL, 44239),
(44240, '3.60.21.10-FF-000230', NULL, 'Protein phosphotase, putative', 171, NULL, NULL, 44240),
(44241, '3.30.1360.220-FF-000008', NULL, 'FYVE zinc finger domaincontaining protein', 70, NULL, NULL, 44241),
(44242, '2.60.40.10-FF-004930', NULL, NULL, 95, NULL, NULL, 44242),
(44243, '1.25.40.20-FF-001925', NULL, 'Uncharacterized protein', 179, NULL, NULL, 44243),
(44244, '3.30.505.10-FF-000086', NULL, 'SH2 domain protein B', 108, NULL, NULL, 44244),
(44245, '2.60.120.10-FF-000700', NULL, 'Chromosome 23, whole genome shotgun sequence', 220, NULL, NULL, 44245),
(44246, '2.40.160.110-FF-000014', NULL, 'Lysosome-associated membrane glycoprotein 1', 171, NULL, NULL, 44246),
(44247, '2.40.50.100-FF-000064', NULL, 'Exosome complex component RRP4, putative', 60, NULL, NULL, 44247),
(44248, '3.30.200.20-FF-001308', NULL, 'Uncharacterized protein', 95, NULL, NULL, 44248),
(44249, '3.90.1260.10-FF-000007', NULL, 'Argininosuccinate synthase', 224, NULL, NULL, 44249),
(44250, '1.25.40.10-FF-000343', NULL, 'Pentatricopeptide repeat-containing protein At3g58590', 101, NULL, NULL, 44250),
(44251, '3.20.200.10-FF-000015', NULL, 'Alpha-kinase 3b', 104, NULL, NULL, 44251),
(44252, '1.10.287.70-FF-000097', NULL, 'Potassium voltage-gated channel subfamily G member 3', 111, NULL, NULL, 44252),
(44253, '1.20.140.150-FF-000005', NULL, 'Germ cell-specific gene 1-like', 234, NULL, NULL, 44253),
(44254, '3.90.550.10-FF-000615', NULL, 'Uncharacterized protein', 213, NULL, NULL, 44254),
(44255, '3.40.50.300-FF-008455', NULL, 'Uncharacterized protein', 255, NULL, NULL, 44255),
(44256, '3.40.50.720-FF-000824', NULL, 'Possible oxidoreductase', 331, NULL, NULL, 44256),
(44257, '3.30.160.60-FF-001125', NULL, 'Zinc finger and BTB domain-containing protein 24', 25, NULL, NULL, 44257),
(44258, '3.30.40.140-FF-000004', NULL, 'Checkpoint with forkhead and ring finger domains, E3 ubiquitin protein ligase', 123, NULL, NULL, 44258),
(44259, '1.10.1520.10-FF-000109', NULL, 'Dicer-like protein', 146, NULL, NULL, 44259);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(44260, '2.10.25.10-FF-000906', NULL, 'Versican a', 41, NULL, NULL, 44260),
(44261, '1.10.510.10-FF-000419', NULL, 'STE20-related kinase adapter protein beta', 194, NULL, NULL, 44261),
(44262, '2.102.10.10-FF-000031', NULL, 'Nitrite reductase [NAD(P)H]', 116, NULL, NULL, 44262),
(44263, '1.10.10.10-FF-001824', NULL, 'Uncharacterized protein', 104, NULL, NULL, 44263),
(44264, '2.40.440.10-FF-000021', NULL, 'Putative lipoprotein', 115, NULL, NULL, 44264),
(44265, '3.40.50.620-FF-000856', NULL, 'Uncharacterized protein', 209, NULL, NULL, 44265),
(44266, '1.10.246.90-FF-000019', NULL, 'Uncharacterized protein', 100, NULL, NULL, 44266),
(44267, '1.25.40.10-FF-004974', NULL, 'Uncharacterized protein', 277, NULL, NULL, 44267),
(44268, '1.25.10.10-FF-003388', NULL, 'Uncharacterized protein', 141, NULL, NULL, 44268),
(44269, '1.10.287.70-FF-000102', NULL, 'Two-pore potassium channel 3', 115, NULL, NULL, 44269),
(44270, '3.40.50.1000-FF-000379', NULL, 'HAD-IB family hydrolase', 109, NULL, NULL, 44270),
(44271, '2.10.70.10-FF-000157', NULL, 'Predicted protein', 63, NULL, NULL, 44271),
(44272, '3.40.50.10860-FF-000054', NULL, 'Shikimate dehydrogenase (NADP(+))', 117, NULL, NULL, 44272),
(44273, '2.40.50.510-FF-000006', NULL, 'Uncharacterized protein', 104, NULL, NULL, 44273),
(44274, '3.30.60.190-FF-000006', NULL, 'Hit1p', 50, NULL, NULL, 44274),
(44275, '3.90.550.10-FF-000290', NULL, 'Protein CDI', 248, NULL, NULL, 44275),
(44276, '1.10.287.540-FF-000007', NULL, 'ATP synthase epsilon chain', 48, NULL, NULL, 44276),
(44277, '1.10.10.1760-FF-000007', NULL, '60S ribosomal protein L36', 85, NULL, NULL, 44277),
(44278, '3.80.10.10-FF-004285', NULL, 'Uncharacterized protein', 243, NULL, NULL, 44278),
(44279, '1.25.40.1030-FF-000017', NULL, 'Protein transport protein SEC31 homolog B', 184, NULL, NULL, 44279),
(44280, '3.40.1380.10-FF-000005', NULL, 'ATP synthase subunit gamma', 213, NULL, NULL, 44280),
(44281, '3.40.50.150-FF-000900', NULL, NULL, 80, NULL, NULL, 44281),
(44282, '2.70.50.30-FF-000030', NULL, NULL, 104, NULL, NULL, 44282),
(44283, '3.90.228.10-FF-000035', NULL, 'Poly [ADP-ribose] polymerase', 189, NULL, NULL, 44283),
(44284, '3.90.640.90-FF-000011', NULL, 'Anti-proliferation factor BTG1/TOB, putative', 117, NULL, NULL, 44284),
(44285, '1.10.287.3240-FF-000032', NULL, 'Predicted protein', 213, NULL, NULL, 44285),
(44286, '2.60.40.640-FF-000062', NULL, 'pH-response regulator protein palF', 163, NULL, NULL, 44286),
(44287, '1.25.40.20-FF-000964', NULL, 'Calmodulin-binding transcription activator 1 isoform A', 232, NULL, NULL, 44287),
(44288, '1.20.1250.20-FF-001404', NULL, 'Drug resistence protein, putative', 187, NULL, NULL, 44288),
(44289, '2.60.120.200-FF-000091', NULL, 'Beta-1,3-galactosyltransferase GALT1', 148, NULL, NULL, 44289),
(44290, '3.40.710.10-FF-000055', NULL, 'Probable penicillin-binding protein dacB1', 311, NULL, NULL, 44290),
(44291, '1.10.10.2010-FF-000004', NULL, 'Protein CBR-MAC-1', 72, NULL, NULL, 44291),
(44292, '2.60.120.330-FF-000163', NULL, 'Isopenicillin N synthase', 331, NULL, NULL, 44292),
(44293, '3.40.50.1240-FF-000215', NULL, NULL, 252, NULL, NULL, 44293),
(44294, '3.30.110.40-FF-000003', NULL, 'Response regulator SirA', 75, NULL, NULL, 44294),
(44295, '3.20.20.370-FF-000032', NULL, 'YdjC chitooligosaccharide deacetylase homolog', 207, NULL, NULL, 44295),
(44296, '3.40.50.300-FF-007966', NULL, 'ATP-dependent DEAH-box RNA helicase, putative', 164, NULL, NULL, 44296),
(44297, '2.40.30.130-FF-000035', NULL, 'Alanine--tRNA ligase, mitochondrial', 95, NULL, NULL, 44297),
(44298, '3.30.310.10-FF-000032', NULL, 'Ribonuclease HIII', 65, NULL, NULL, 44298),
(44299, '1.20.58.830-FF-000048', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 157, NULL, NULL, 44299),
(44300, '2.70.130.10-FF-000120', NULL, NULL, 61, NULL, NULL, 44300),
(44301, '1.10.510.10-FF-000043', NULL, 'probable serine/threonine-protein kinase At1g54610', 242, NULL, NULL, 44301),
(44302, '2.10.25.10-FF-001542', NULL, 'Si:dkey-88l16.4', 38, NULL, NULL, 44302),
(44303, '3.10.20.740-FF-000005', NULL, 'NADH:ubiquinone oxidoreductase subunit', 122, NULL, NULL, 44303);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(44304, '1.25.40.10-FF-003069', NULL, 'Pentatricopeptide repeat-containing protein', 199, NULL, NULL, 44304),
(44305, '3.30.40.10-FF-000096', NULL, 'E3 ubiquitin-protein ligase MARCH6', 68, NULL, NULL, 44305),
(44306, '1.20.120.350-FF-000145', NULL, NULL, 127, NULL, NULL, 44306),
(44307, '2.70.150.10-FF-000003', NULL, 'Sodium/potassium-transporting ATPase subunit alpha', 159, NULL, NULL, 44307),
(44308, '2.60.40.60-FF-000741', NULL, 'Cdh-4', 109, NULL, NULL, 44308),
(44309, '3.90.45.10-FF-000014', NULL, 'Peptide deformylase', 161, NULL, NULL, 44309),
(44310, '2.40.70.10-FF-000178', NULL, 'Protein CBG08575', 132, NULL, NULL, 44310),
(44311, '1.20.142.10-FF-000016', NULL, 'Poly [ADP-ribose] polymerase', 161, NULL, NULL, 44311),
(44312, '1.20.1530.20-FF-000100', NULL, 'Uncharacterized protein', 184, NULL, NULL, 44312),
(44313, '2.10.90.10-FF-000012', NULL, 'Growth/differentiation factor 9 (Predicted)', 113, NULL, NULL, 44313),
(44314, '3.30.160.60-FF-003598', NULL, NULL, 27, NULL, NULL, 44314),
(44315, '2.60.40.10-FF-006083', NULL, NULL, 50, NULL, NULL, 44315),
(44316, '3.30.160.60-FF-000872', NULL, 'zinc finger X-linked protein ZXDB', 39, NULL, NULL, 44316),
(44317, '1.10.238.10-FF-000090', NULL, 'calumenin isoform X2', 77, NULL, NULL, 44317),
(44318, '1.10.150.110-FF-000003', NULL, 'DNA polymerase mu', 94, NULL, NULL, 44318),
(44319, '2.160.10.10-FF-000096', NULL, 'UTP--glucose-1-phosphate uridylyltransferase family protein', 110, NULL, NULL, 44319),
(44320, '3.90.180.10-FF-000075', NULL, 'Glucose 1-dehydrogenase', 195, NULL, NULL, 44320),
(44321, '3.10.450.580-FF-000019', NULL, 'Mediator of RNA polymerase II transcription subunit 6', 118, NULL, NULL, 44321),
(44322, '2.40.30.10-FF-000260', NULL, '50S ribosomal protein L3', 81, NULL, NULL, 44322),
(44323, '2.30.110.10-FF-000026', NULL, 'PPOX class F420-dependent oxidoreductase', 146, NULL, NULL, 44323),
(44324, '3.40.630.10-FF-000054', NULL, 'Peptide hydrolase', 253, NULL, NULL, 44324),
(44325, '3.10.20.90-FF-000029', NULL, 'SH3 and multiple ankyrin repeat domains protein 1', 85, NULL, NULL, 44325),
(44326, '3.40.50.1820-FF-001726', NULL, 'Uncharacterized protein', 102, NULL, NULL, 44326),
(44327, '3.50.50.60-FF-000610', NULL, 'Halogenase PltM', 428, NULL, NULL, 44327),
(44328, '2.130.10.10-FF-003481', NULL, 'Mauve', 308, NULL, NULL, 44328),
(44329, '1.10.510.10-FF-001908', NULL, 'Uncharacterized protein', 375, NULL, NULL, 44329),
(44330, '3.50.50.60-FF-001122', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 134, NULL, NULL, 44330),
(44331, '3.30.70.80-FF-000045', NULL, 'AGR386Cp', 71, NULL, NULL, 44331),
(44332, '1.25.40.10-FF-002760', NULL, 'Pentatricopeptide repeat domain containing protein, putative', 186, NULL, NULL, 44332),
(44333, '3.30.160.60-FF-004615', NULL, NULL, 48, NULL, NULL, 44333),
(44334, '3.10.250.10-FF-000104', NULL, NULL, 111, NULL, NULL, 44334),
(44335, '3.30.930.10-FF-000175', NULL, 'ATP phosphoribosyltransferase regulatory subunit', 326, NULL, NULL, 44335),
(44336, '1.10.510.10-FF-004022', NULL, NULL, 117, NULL, NULL, 44336),
(44337, '3.50.50.60-FF-001066', NULL, 'Prenylcysteine oxidase 1-like', 154, NULL, NULL, 44337),
(44338, '3.10.20.70-FF-000023', NULL, 'Probable glutamine synthetase', 101, NULL, NULL, 44338),
(44339, '3.40.50.2020-FF-000084', NULL, 'Adenine phosphoribosyltransferase', 67, NULL, NULL, 44339),
(44340, '2.60.120.970-FF-000091', NULL, 'Uncharacterized protein', 187, NULL, NULL, 44340),
(44341, '4.10.320.10-FF-000005', NULL, 'Acetyltransferase component of pyruvate dehydrogenase complex', 50, NULL, NULL, 44341),
(44342, '3.10.20.90-FF-000557', NULL, 'Ubiquitin carboxyl-terminal hydrolase 7', 115, NULL, NULL, 44342),
(44343, '2.60.120.650-FF-000197', NULL, 'Lysine demethylase 4C', 41, NULL, NULL, 44343),
(44344, '3.40.50.11660-FF-000018', NULL, 'Fucosyltransferase 7 (alpha (1,3) fucosyltransferase)', 200, NULL, NULL, 44344),
(44345, '3.30.70.2110-FF-000001', NULL, 'Penicillin-binding protein 1 (Peptidoglycan synthetase)', 84, NULL, NULL, 44345),
(44346, '3.80.10.10-FF-001412', NULL, 'Uncharacterized protein', 124, NULL, NULL, 44346); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(44347, '3.30.1520.10-FF-000194', NULL, 'Neutrophil cytosolic factor 4', 50, NULL, NULL, 44347),
(44348, '3.90.190.10-FF-000008', NULL, 'putative tyrosine-protein phosphatase auxilin isoform X2', 160, NULL, NULL, 44348),
(44349, '2.60.40.10-FF-005099', NULL, NULL, 99, NULL, NULL, 44349),
(44350, '1.25.40.860-FF-000031', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 74, NULL, NULL, 44350),
(44351, '1.10.10.60-FF-000917', NULL, NULL, 64, NULL, NULL, 44351),
(44352, '2.60.40.10-FF-000804', NULL, 'V-set and transmembrane domain containing 2B', 125, NULL, NULL, 44352),
(44353, '3.40.50.720-FF-002393', NULL, 'Uncharacterized protein', 87, NULL, NULL, 44353),
(44354, '3.40.50.300-FF-002295', NULL, 'Elongation factor G, mitochondrial', 291, NULL, NULL, 44354),
(44355, '3.40.50.620-FF-000148', NULL, 'Cytoplasmic protein', 132, NULL, NULL, 44355),
(44356, '3.40.50.300-FF-000586', NULL, 'Rab family GTPase', 199, NULL, NULL, 44356),
(44357, '3.30.70.330-FF-002692', NULL, NULL, 133, NULL, NULL, 44357),
(44358, '2.10.110.10-FF-000216', NULL, 'Four and a half LIM domains 5', 62, NULL, NULL, 44358),
(44359, '1.20.1070.10-FF-001652', NULL, 'Rhodopsin', 131, NULL, NULL, 44359),
(44360, '2.160.10.10-FF-000129', NULL, 'UTP--glucose-1-phosphate uridylyltransferase', 52, NULL, NULL, 44360),
(44361, '3.30.160.60-FF-000400', NULL, 'Zinc finger protein 276', 30, NULL, NULL, 44361),
(44362, '3.10.28.10-FF-000017', NULL, 'V-type proton ATPase catalytic subunit A', 121, NULL, NULL, 44362),
(44363, '3.10.430.100-FF-000006', NULL, '50S ribosomal protein L9', 85, NULL, NULL, 44363),
(44364, '2.60.120.200-FF-000736', NULL, 'BAM-2', 195, NULL, NULL, 44364),
(44365, '3.40.50.1820-FF-001249', NULL, 'Protein phosphatase methylesterase 1', 315, NULL, NULL, 44365),
(44366, '3.30.420.40-FF-000049', NULL, 'N-acetyl-D-glucosamine kinase', 121, NULL, NULL, 44366),
(44367, '1.20.120.20-FF-000036', NULL, 'Apolipoprotein Ea', 74, NULL, NULL, 44367),
(44368, '3.40.50.980-FF-000003', NULL, 'Vibriobactin-specific 2,3-dihydroxybenzoate-AMP ligase', 173, NULL, NULL, 44368),
(44369, '1.25.40.10-FF-004789', NULL, 'Pentatricopeptide repeat-containing protein', 174, NULL, NULL, 44369),
(44370, '2.60.40.10-FF-002513', NULL, 'Uncharacterized protein', 88, NULL, NULL, 44370),
(44371, '3.40.50.300-FF-006038', NULL, 'Uncharacterized protein', 209, NULL, NULL, 44371),
(44372, '1.50.10.20-FF-000016', NULL, 'Cobalamin binding intrinsic factor', 273, NULL, NULL, 44372),
(44373, '1.10.287.1770-FF-000006', NULL, 'Ferrous iron transport protein B', 64, NULL, NULL, 44373),
(44374, '3.40.50.300-FF-007674', NULL, 'Protein-tyrosine sulfotransferase', 119, NULL, NULL, 44374),
(44375, '1.25.40.10-FF-002232', NULL, 'ALBINO3-like protein 2 chloroplastic', 172, NULL, NULL, 44375),
(44376, '3.90.70.10-FF-000027', NULL, 'Calpain 5', 148, NULL, NULL, 44376),
(44377, '3.30.2310.20-FF-000012', NULL, 'Toxin ParE', 98, NULL, NULL, 44377),
(44378, '3.30.70.330-FF-002164', NULL, NULL, 92, NULL, NULL, 44378),
(44379, '1.10.10.650-FF-000023', NULL, 'Uncharacterized protein', 23, NULL, NULL, 44379),
(44380, '1.10.8.870-FF-000006', NULL, 'Aerobic glycerol-3-phosphate dehydrogenase', 136, NULL, NULL, 44380),
(44381, '3.40.970.10-FF-000012', NULL, NULL, 47, NULL, NULL, 44381),
(44382, '1.20.1070.10-FF-000488', NULL, 'Adrenoceptor alpha 2B', 259, NULL, NULL, 44382),
(44383, '1.10.510.10-FF-002313', NULL, NULL, 220, NULL, NULL, 44383),
(44384, '3.30.470.20-FF-000193', NULL, 'Uncharacterized protein', 124, NULL, NULL, 44384),
(44385, '1.20.58.60-FF-000375', NULL, 'Spectrin, beta, non-erythrocytic 5', 111, NULL, NULL, 44385),
(44386, '1.10.1200.10-FF-000092', NULL, 'Nonribosomal peptide synthetase 8', 72, NULL, NULL, 44386),
(44387, '2.130.10.10-FF-000928', NULL, 'DDB1-and CUL4-associated factor 13', 105, NULL, NULL, 44387),
(44388, '3.40.50.300-FF-002351', NULL, 'ATP-dependent helicase/nuclease subunit A', 138, NULL, NULL, 44388),
(44389, '3.10.450.350-FF-000012', NULL, 'M23 family peptidase', 115, NULL, NULL, 44389),
(44390, '3.20.20.70-FF-000354', NULL, 'Alpha-galactosidase', 272, NULL, NULL, 44390);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(44391, '3.40.1310.20-FF-000004', NULL, 'Initiator protein NS1', 207, NULL, NULL, 44391),
(44392, '3.30.30.30-FF-000022', NULL, 'Lumenal Hsp70 protein', 54, NULL, NULL, 44392),
(44393, '1.10.3720.10-FF-000204', NULL, 'Amino ABC transporter, permease protein, 3-TM region, His/Glu/Gln/Arg/opine family domain protein', 225, NULL, NULL, 44393),
(44394, '2.60.40.790-FF-000056', NULL, '15.7 kDa heat shock protein, peroxisomal', 138, NULL, NULL, 44394),
(44395, '1.10.238.10-FF-000735', NULL, 'Dual oxidase', 200, NULL, NULL, 44395),
(44396, '3.40.30.10-FF-000398', NULL, 'Thioredoxin domain-containing protein', 111, NULL, NULL, 44396),
(44397, '2.60.120.10-FF-000756', NULL, 'Uncharacterized protein', 84, NULL, NULL, 44397),
(44398, '3.40.50.2300-FF-000550', NULL, 'Sigma-54 dependent response regulator', 130, NULL, NULL, 44398),
(44399, '2.30.42.10-FF-000153', NULL, 'Scribbled, isoform T', 107, NULL, NULL, 44399),
(44400, '3.20.20.190-FF-000130', NULL, NULL, 151, NULL, NULL, 44400),
(44401, '3.40.50.300-FF-000114', NULL, 'ATP-dependent RNA helicase DDX6', 171, NULL, NULL, 44401),
(44402, '1.25.40.20-FF-000144', NULL, 'inversin isoform X1', 128, NULL, NULL, 44402),
(44403, '3.40.50.300-FF-007819', NULL, 'Putative RNA helicase armi-like Protein', 276, NULL, NULL, 44403),
(44404, '3.30.200.20-FF-000263', NULL, 'Choline kinase alpha', 72, NULL, NULL, 44404),
(44405, '2.60.40.10-FF-002457', NULL, 'Uncharacterized protein, isoform E', 101, NULL, NULL, 44405),
(44406, '3.40.980.10-FF-000041', NULL, 'Uncharacterized protein', 144, NULL, NULL, 44406),
(44407, '1.10.1520.10-FF-000076', NULL, 'Endoribonuclease Dicer 2b', 127, NULL, NULL, 44407),
(44408, '3.80.10.10-FF-003065', NULL, 'Leucine-rich repeat-containing protein 51-like Protein', 142, NULL, NULL, 44408),
(44409, '3.30.70.330-FF-002956', NULL, NULL, 105, NULL, NULL, 44409),
(44410, '3.40.630.30-FF-000588', NULL, 'Uncharacterized protein', 91, NULL, NULL, 44410),
(44411, '1.25.10.10-FF-002404', NULL, 'Uncharacterized protein', 255, NULL, NULL, 44411),
(44412, '3.90.550.10-FF-000323', NULL, 'Processive diacylglycerol beta-glycosyltransferase', 210, NULL, NULL, 44412),
(44413, '1.20.1270.20-FF-000006', NULL, 'Hydroxylamine reductase, putative', 84, NULL, NULL, 44413),
(44414, '3.30.450.60-FF-000091', NULL, 'Uncharacterized protein', 115, NULL, NULL, 44414),
(44415, '3.30.160.60-FF-000344', NULL, 'zinc finger protein 90 homolog', 27, NULL, NULL, 44415),
(44416, '1.10.287.110-FF-000227', NULL, 'Uncharacterized protein', 152, NULL, NULL, 44416),
(44417, '3.40.50.1820-FF-000473', NULL, 'YNL320W-like protein', 214, NULL, NULL, 44417),
(44418, '3.30.70.1230-FF-000164', NULL, 'Adenylyl cyclase class-3/4/guanylyl cyclase', 202, NULL, NULL, 44418),
(44419, '1.10.510.10-FF-003617', NULL, NULL, 196, NULL, NULL, 44419),
(44420, '3.40.50.1820-FF-001581', NULL, 'Alpha/beta-Hydrolases superfamily protein', 99, NULL, NULL, 44420),
(44421, '3.30.2320.60-FF-000002', NULL, 'DUF2662 domain-containing protein', 122, NULL, NULL, 44421),
(44422, '2.160.20.10-FF-000158', NULL, 'Uncharacterized protein', 258, NULL, NULL, 44422),
(44423, '1.25.40.10-FF-001068', NULL, 'Pentatricopeptide repeat-containing protein isoform A', 107, NULL, NULL, 44423),
(44424, '2.130.10.10-FF-005190', NULL, 'Uncharacterized protein', 113, NULL, NULL, 44424),
(44425, '3.40.50.1100-FF-000078', NULL, 'Threonine synthase-like 2', 62, NULL, NULL, 44425),
(44426, '1.10.510.10-FF-003297', NULL, NULL, 85, NULL, NULL, 44426),
(44427, '1.20.120.720-FF-000037', NULL, 'Heavy chain, Unconventional Myosin', 142, NULL, NULL, 44427),
(44428, '3.40.50.300-FF-007730', NULL, 'Uncharacterized protein', 88, NULL, NULL, 44428),
(44429, '3.40.50.720-FF-000740', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 192, NULL, NULL, 44429),
(44430, '2.10.70.10-FF-000213', NULL, 'CUB and sushi domain-containing protein 1', 63, NULL, NULL, 44430),
(44431, '3.90.1600.10-FF-000074', NULL, 'DNA polymerase alpha subunit one', 36, NULL, NULL, 44431),
(44432, '3.40.50.261-FF-000002', NULL, 'Succinate--CoA ligase [ADP-forming] subunit alpha', 171, NULL, NULL, 44432); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(44433, '1.10.510.10-FF-001532', NULL, 'Ribosomal protein S6 kinase', 225, NULL, NULL, 44433),
(44434, '3.20.20.140-FF-000429', NULL, 'Uncharacterized protein', 204, NULL, NULL, 44434),
(44435, '3.80.10.10-FF-002716', NULL, 'Putative inactive leucine-rich repeat receptor-like protein kinase', 98, NULL, NULL, 44435),
(44436, '3.90.190.10-FF-000340', NULL, 'Dual specificity protein phosphatase, putative', 175, NULL, NULL, 44436),
(44437, '3.40.50.300-FF-004240', NULL, 'Probable chromosome partitioning ATPase', 240, NULL, NULL, 44437),
(44438, '1.10.8.700-FF-000001', NULL, 'DNA polymerase clamp loader subunit', 71, NULL, NULL, 44438),
(44439, '3.40.1190.20-FF-000179', NULL, NULL, 108, NULL, NULL, 44439),
(44440, '3.40.1190.20-FF-000123', NULL, 'Nucleoside kinase', 287, NULL, NULL, 44440),
(44441, '2.130.10.10-FF-002637', NULL, 'Uncharacterized protein', 248, NULL, NULL, 44441),
(44442, '2.120.10.80-FF-000253', NULL, 'Galactose oxidase, central domain containing protein, putative', 230, NULL, NULL, 44442),
(44443, '3.40.50.300-FF-008511', NULL, 'AAA family cell division control-like protein', 196, NULL, NULL, 44443),
(44444, '3.30.70.270-FF-000263', NULL, NULL, 110, NULL, NULL, 44444),
(44445, '3.90.70.10-FF-000286', NULL, 'Ubiquitinyl hydrolase 1', 316, NULL, NULL, 44445),
(44446, '3.20.20.10-FF-000090', NULL, 'Arginine decarboxylase', 171, NULL, NULL, 44446),
(44447, '1.25.40.10-FF-000287', NULL, 'uncharacterized TPR repeat-containing protein At1g05150-like', 196, NULL, NULL, 44447),
(44448, '2.40.50.1070-FF-000013', NULL, 'tRNA/tmRNA (uracil-C(5))-methyltransferase', 138, NULL, NULL, 44448),
(44449, '1.10.510.10-FF-000127', NULL, 'Putative cyclin-dependent kinase-like 5', 208, NULL, NULL, 44449),
(44450, '1.25.10.10-FF-002876', NULL, 'Uncharacterized protein', 151, NULL, NULL, 44450),
(44451, '1.25.40.210-FF-000005', NULL, 'Uncharacterized protein', 204, NULL, NULL, 44451),
(44452, '1.20.210.10-FF-000006', NULL, 'Cytochrome c oxidase subunit 1', 527, NULL, NULL, 44452),
(44453, '3.10.580.10-FF-000152', NULL, 'Uncharacterized protein', 174, NULL, NULL, 44453),
(44454, '2.60.40.150-FF-000656', NULL, 'Copine 5', 103, NULL, NULL, 44454),
(44455, '3.30.160.60-FF-000080', NULL, 'IKAROS family zinc finger 4', 28, NULL, NULL, 44455),
(44456, '1.50.10.10-FF-000070', NULL, 'Putative bile acid beta-glucosidase', 228, NULL, NULL, 44456),
(44457, '3.40.50.300-FF-004329', NULL, 'ABC transporter ATP-binding protein', 263, NULL, NULL, 44457),
(44458, '1.20.1310.10-FF-000171', NULL, NULL, 131, NULL, NULL, 44458),
(44459, '2.30.30.40-FF-000264', NULL, 'HECT E3 ubiquitin ligase', 88, NULL, NULL, 44459),
(44460, '1.10.1040.10-FF-000090', NULL, '2-dehydropantoate 2-reductase', 137, NULL, NULL, 44460),
(44461, '2.170.130.10-FF-000079', NULL, NULL, 86, NULL, NULL, 44461),
(44462, '1.50.10.10-FF-000159', NULL, 'Uncharacterized protein', 360, NULL, NULL, 44462),
(44463, '3.30.2180.10-FF-000004', NULL, 'ATP12-like chaperone protein, putative', 68, NULL, NULL, 44463),
(44464, '3.40.50.10490-FF-000162', NULL, NULL, 249, NULL, NULL, 44464),
(44465, '1.20.940.10-FF-000016', NULL, 'Transport protein Sec31A', 110, NULL, NULL, 44465),
(44466, '3.40.640.10-FF-000403', NULL, 'Predicted protein', 276, NULL, NULL, 44466),
(44467, '2.130.10.10-FF-004262', NULL, 'Uncharacterized protein', 135, NULL, NULL, 44467),
(44468, '1.10.8.720-FF-000012', NULL, 'Dynein heavy chain-like protein', 168, NULL, NULL, 44468),
(44469, '3.40.30.10-FF-000454', NULL, 'Thioredoxin', 77, NULL, NULL, 44469),
(44470, '1.25.40.10-FF-003485', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 86, NULL, NULL, 44470),
(44471, '2.60.40.10-FF-003677', NULL, NULL, 115, NULL, NULL, 44471),
(44472, '3.30.910.20-FF-000002', NULL, 'Outer membrane chaperone Skp (OmpH)', 143, NULL, NULL, 44472),
(44473, '4.10.400.10-FF-000006', NULL, 'Putative low-density lipoprotein receptor', 40, NULL, NULL, 44473),
(44474, '1.25.40.20-FF-000672', NULL, 'Uncharacterized protein', 453, NULL, NULL, 44474),
(44475, '3.90.380.10-FF-000023', NULL, NULL, 85, NULL, NULL, 44475);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(44476, '3.40.50.300-FF-005313', NULL, 'Shikimate kinase', 167, NULL, NULL, 44476),
(44477, '3.40.50.1380-FF-000004', NULL, 'Carbamoyl-phosphate synthase large chain', 137, NULL, NULL, 44477),
(44478, '1.10.260.40-FF-000077', NULL, 'Replication factor C small subunit', 49, NULL, NULL, 44478),
(44479, '3.20.20.20-FF-000036', NULL, 'Predicted protein', 162, NULL, NULL, 44479),
(44480, '3.30.70.330-FF-003092', NULL, NULL, 105, NULL, NULL, 44480),
(44481, '3.60.140.10-FF-000012', NULL, 'Polyphenol oxidase', 224, NULL, NULL, 44481),
(44482, '3.40.140.10-FF-000146', NULL, 'ER membrane protein complex subunit 8/9 homolog', 144, NULL, NULL, 44482),
(44483, '1.20.1250.10-FF-000058', NULL, 'Leptin A1', 147, NULL, NULL, 44483),
(44484, '3.30.420.10-FF-000506', NULL, NULL, 178, NULL, NULL, 44484),
(44485, '1.20.120.1080-FF-000146', NULL, 'Tudor domain containing 9', 178, NULL, NULL, 44485),
(44486, '1.10.238.10-FF-001247', NULL, 'Uncharacterized protein', 84, NULL, NULL, 44486),
(44487, '2.70.98.10-FF-000050', NULL, 'Aldose 1-epimerase-like protein', 383, NULL, NULL, 44487),
(44488, '3.40.50.2300-FF-001062', NULL, NULL, 109, NULL, NULL, 44488),
(44489, '2.30.42.10-FF-000529', NULL, NULL, 55, NULL, NULL, 44489),
(44490, '3.40.50.450-FF-000075', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase', 178, NULL, NULL, 44490),
(44491, '2.60.40.1510-FF-000056', NULL, 'Integrin beta', 77, NULL, NULL, 44491),
(44492, '3.30.160.60-FF-005835', NULL, NULL, 26, NULL, NULL, 44492),
(44493, '1.10.10.60-FF-000541', NULL, 'mRNA, clone: RTFL01-36-L09', 45, NULL, NULL, 44493),
(44494, '2.130.10.10-FF-000552', NULL, 'Cytoplasmic dynein 1 intermediate chain', 167, NULL, NULL, 44494),
(44495, '1.10.3720.10-FF-000171', NULL, 'Molybdenum transport system permease', 222, NULL, NULL, 44495),
(44496, '3.40.50.300-FF-000642', NULL, 'RuvB-like helicase', 193, NULL, NULL, 44496),
(44497, '1.10.20.10-FF-000072', NULL, 'Transcriptional activator spt7', 104, NULL, NULL, 44497),
(44498, '3.60.20.10-FF-000262', NULL, NULL, 109, NULL, NULL, 44498),
(44499, '3.30.200.20-FF-001191', NULL, 'Discoidin domain-containing receptor A', 99, NULL, NULL, 44499),
(44500, '1.10.10.160-FF-000056', NULL, 'DNA helicase', 72, NULL, NULL, 44500),
(44501, '3.30.70.1180-FF-000014', NULL, 'V-type proton ATPase subunit C', 41, NULL, NULL, 44501),
(44502, '1.10.287.70-FF-000574', NULL, 'ATP-sensitive inward rectifier potassium channel 12-like Protein', 135, NULL, NULL, 44502),
(44503, '3.90.1170.40-FF-000015', NULL, 'Predicted protein', 117, NULL, NULL, 44503),
(44504, '1.10.1300.10-FF-000037', NULL, 'Phosphodiesterase', 342, NULL, NULL, 44504),
(44505, '2.10.25.10-FF-001311', NULL, 'Multiple EGF like domains 8', 30, NULL, NULL, 44505),
(44506, '2.40.10.10-FF-000641', NULL, NULL, 157, NULL, NULL, 44506),
(44507, '2.10.50.10-FF-000094', NULL, 'Predicted protein', 55, NULL, NULL, 44507),
(44508, '1.20.120.980-FF-000008', NULL, 'Serine protease 16', 40, NULL, NULL, 44508),
(44509, '1.10.287.160-FF-000017', NULL, 'Target of rapamycin complex 2 subunit ste20', 80, NULL, NULL, 44509),
(44510, '3.30.70.330-FF-000539', NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', 97, NULL, NULL, 44510),
(44511, '3.30.200.20-FF-002152', NULL, 'Uncharacterized protein', 68, NULL, NULL, 44511),
(44512, '3.40.50.2300-FF-001623', NULL, NULL, 284, NULL, NULL, 44512),
(44513, '3.30.450.30-FF-000020', NULL, 'Profilin', 130, NULL, NULL, 44513),
(44514, '3.30.420.40-FF-000813', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', 105, NULL, NULL, 44514),
(44515, '3.30.60.30-FF-000226', NULL, 'Predicted protein', 54, NULL, NULL, 44515),
(44516, '3.30.559.30-FF-000008', NULL, 'Non-ribosomal peptide synthetase', 230, NULL, NULL, 44516),
(44517, '1.20.245.10-FF-000002', NULL, 'Lipoxygenase', 365, NULL, NULL, 44517),
(44518, '2.10.25.10-FF-000294', NULL, 'Delta-like protein', 40, NULL, NULL, 44518),
(44519, '3.60.21.10-FF-000314', NULL, 'Serine/threonine protein phosphatase', 226, NULL, NULL, 44519),
(44520, '1.25.10.10-FF-000459', NULL, 'ARM repeat superfamily protein', 1004, NULL, NULL, 44520);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(44521, '2.60.40.10-FF-001529', NULL, 'Cell adhesion molecule', 102, NULL, NULL, 44521),
(44522, '1.20.1640.10-FF-000072', NULL, 'Hopanoid biosynthesis associated RND transporter like protein HpnN', 173, NULL, NULL, 44522),
(44523, '1.20.120.960-FF-000002', NULL, 'Sensor protein', 108, NULL, NULL, 44523),
(44524, '2.60.40.10-FF-001732', NULL, 'titin isoform X1', 97, NULL, NULL, 44524),
(44525, '3.40.50.300-FF-007022', NULL, 'Predicted protein', 206, NULL, NULL, 44525),
(44526, '3.90.550.50-FF-000020', NULL, 'Hexosyltransferase', 226, NULL, NULL, 44526),
(44527, '2.60.120.10-FF-000195', NULL, 'Putative quercetin 2,3-dioxygenase Rv0181c', 106, NULL, NULL, 44527),
(44528, '1.20.120.1760-FF-000070', NULL, NULL, 197, NULL, NULL, 44528),
(44529, '1.10.1600.10-FF-000021', NULL, 'Putative dna-binding subunit of a dna-dependent protein kinase ku70 autoantigen', 96, NULL, NULL, 44529),
(44530, '3.30.450.20-FF-000247', NULL, 'Aryl hydrocarbon receptor protein 1', 115, NULL, NULL, 44530),
(44531, '1.25.10.10-FF-000987', NULL, 'Putative splicing factor 3B subunit 1', 310, NULL, NULL, 44531),
(44532, '3.30.420.40-FF-000757', NULL, 'Actin-like 6B', 91, NULL, NULL, 44532),
(44533, '3.80.10.10-FF-000007', NULL, 'Leucine-rich repeat and calponin homology domain-containing protein 1 isoform 3', 240, NULL, NULL, 44533),
(44534, '3.50.30.30-FF-000179', NULL, 'Uncharacterized protein', 12, NULL, NULL, 44534),
(44535, '3.60.21.10-FF-000461', NULL, 'Uncharacterized protein', 150, NULL, NULL, 44535),
(44536, '3.40.50.720-FF-001465', NULL, 'Predicted protein', 239, NULL, NULL, 44536),
(44537, '1.25.40.10-FF-002052', NULL, 'Protein CLMP1', 125, NULL, NULL, 44537),
(44538, '1.20.5.340-FF-000025', NULL, 'Myosin heavy chain, isoform G', 117, NULL, NULL, 44538),
(44539, '1.20.1110.10-FF-000043', NULL, 'Metal ABC transporter ATPase', 289, NULL, NULL, 44539),
(44540, '3.50.50.60-FF-000138', NULL, 'Flavin-containing monooxygenase', 100, NULL, NULL, 44540),
(44541, '1.20.58.1970-FF-000006', NULL, 'Uncharacterized protein', 176, NULL, NULL, 44541),
(44542, '3.30.200.20-FF-002005', NULL, 'Kinase', 96, NULL, NULL, 44542),
(44543, '3.90.199.10-FF-000005', NULL, 'DNA topoisomerase (ATP-hydrolyzing)', 245, NULL, NULL, 44543),
(44544, '2.30.30.380-FF-000022', NULL, 'calpain-D isoform X3', 80, NULL, NULL, 44544),
(44545, '3.40.50.300-FF-006746', NULL, 'Uncharacterized protein', 68, NULL, NULL, 44545),
(44546, '2.40.50.730-FF-000016', NULL, 'DNA polymerase', 11, NULL, NULL, 44546),
(44547, '3.30.160.60-FF-006240', NULL, NULL, 31, NULL, NULL, 44547),
(44548, '1.10.8.10-FF-000295', NULL, 'UBX domain-containing protein 3', 55, NULL, NULL, 44548),
(44549, '2.60.40.2140-FF-000003', NULL, 'Uncharacterized protein, isoform A', 97, NULL, NULL, 44549),
(44550, '3.30.40.10-FF-001905', NULL, 'Uncharacterized protein', 112, NULL, NULL, 44550),
(44551, '2.60.120.10-FF-000048', NULL, 'Protein phosphatase 2C and cyclic nucleotide-binding/kinase domain-containing protein', 141, NULL, NULL, 44551),
(44552, '1.20.920.10-FF-000217', NULL, 'WD-repeat protein, putative', 87, NULL, NULL, 44552),
(44553, '3.50.50.60-FF-000666', NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme GidA', 230, NULL, NULL, 44553),
(44554, '1.20.1070.10-FF-000724', NULL, 'Putative G-protein coupled receptor 101', 130, NULL, NULL, 44554),
(44555, '1.20.1560.10-FF-000071', NULL, 'ATP binding cassette subfamily B member 5', 647, NULL, NULL, 44555),
(44556, '3.30.40.10-FF-000040', NULL, 'E3 ubiquitin protein ligase', 74, NULL, NULL, 44556),
(44557, '3.40.50.1700-FF-000055', NULL, 'Probable beta-glucosidase O', 109, NULL, NULL, 44557),
(44558, '1.20.1250.20-FF-000679', NULL, 'Putative hexose transporter', 254, NULL, NULL, 44558),
(44559, '3.40.50.1010-FF-000236', NULL, NULL, 69, NULL, NULL, 44559),
(44560, '3.30.160.60-FF-005779', NULL, NULL, 91, NULL, NULL, 44560),
(44561, '1.25.10.10-FF-002371', NULL, 'Uncharacterized protein', 276, NULL, NULL, 44561),
(44562, '2.60.200.10-FF-000049', NULL, 'Predicted protein', 178, NULL, NULL, 44562),
(44563, '1.20.1020.10-FF-000013', NULL, NULL, 78, NULL, NULL, 44563);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(44564, '1.20.1420.30-FF-000044', NULL, 'sodium/potassium/calcium exchanger 3 isoform X2', 146, NULL, NULL, 44564),
(44565, '3.30.479.30-FF-000007', NULL, 'Protein HflK', 132, NULL, NULL, 44565),
(44566, '3.90.226.10-FF-000289', NULL, 'Uncharacterized protein', 185, NULL, NULL, 44566),
(44567, '3.40.50.10900-FF-000032', NULL, 'Proteasome assembly chaperone 2', 54, NULL, NULL, 44567),
(44568, '4.10.640.10-FF-000024', NULL, 'GM16961', 52, NULL, NULL, 44568),
(44569, '3.40.50.80-FF-000049', NULL, 'Nitrate reductase', 146, NULL, NULL, 44569),
(44570, '1.20.1280.50-FF-000050', NULL, 'F-box and leucine-rich repeat protein 4', 47, NULL, NULL, 44570),
(44571, '1.10.510.10-FF-003241', NULL, NULL, 118, NULL, NULL, 44571),
(44572, '3.40.50.80-FF-000105', NULL, 'Ferric-chelate reductase, putative', 201, NULL, NULL, 44572),
(44573, '3.40.630.30-FF-000532', NULL, 'Predicted protein', 79, NULL, NULL, 44573),
(44574, '2.40.128.20-FF-000040', NULL, 'Uncharacterized protein, isoform A', 175, NULL, NULL, 44574),
(44575, '3.10.660.10-FF-000006', NULL, 'Diphthamide biosynthesis protein 4', 85, NULL, NULL, 44575),
(44576, '1.10.3430.10-FF-000013', NULL, 'Rh-like protein/ammonium transporter', 440, NULL, NULL, 44576),
(44577, '3.30.160.60-FF-006184', NULL, NULL, 59, NULL, NULL, 44577),
(44578, '2.60.40.10-FF-005571', NULL, NULL, 110, NULL, NULL, 44578),
(44579, '3.30.9.10-FF-000040', NULL, 'D-aspartate oxidase', 84, NULL, NULL, 44579),
(44580, '2.60.40.10-FF-005947', NULL, NULL, 95, NULL, NULL, 44580),
(44581, '2.30.29.30-FF-000375', NULL, 'Related to Neural Wiskott-Aldrich syndrome protein', 138, NULL, NULL, 44581),
(44582, '2.60.120.10-FF-000380', NULL, 'cAMP/cGMP-dependent 3'',5''-cAMP/cGMP phosphodiesterase B', 130, NULL, NULL, 44582),
(44583, '3.40.50.1000-FF-000290', NULL, 'glycerol-3-phosphate phosphatase', 131, NULL, NULL, 44583),
(44584, '2.30.140.10-FF-000034', NULL, 'Uncharacterized protein', 27, NULL, NULL, 44584),
(44585, '3.30.160.60-FF-003834', NULL, NULL, 76, NULL, NULL, 44585),
(44586, '3.40.50.620-FF-000620', NULL, 'CPD photolyase type II', 156, NULL, NULL, 44586),
(44587, '1.10.1520.10-FF-000020', NULL, 'Protein NUCLEAR FUSION DEFECTIVE 2', 145, NULL, NULL, 44587),
(44588, '1.25.40.10-FF-003013', NULL, 'Uncharacterized protein', 348, NULL, NULL, 44588),
(44589, '1.20.920.30-FF-000050', NULL, 'Uncharacterized protein', 133, NULL, NULL, 44589),
(44590, '3.10.20.90-FF-000501', NULL, 'WGS project CABT00000000 data, contig 2.11', 83, NULL, NULL, 44590),
(44591, '3.40.50.1000-FF-000143', NULL, 'Phosphoserine phosphatase serb', 249, NULL, NULL, 44591),
(44592, '1.10.287.1150-FF-000023', NULL, 'Putative 2-oxoglutarate dehydrogenase E1 component DHKTD1 homolog, mitochondrial-like Protein', 81, NULL, NULL, 44592),
(44593, '1.10.1280.10-FF-000012', NULL, 'Uncharacterized protein', 360, NULL, NULL, 44593),
(44594, '3.30.200.20-FF-001044', NULL, 'Serine/threonine-protein kinase MRCK beta', 59, NULL, NULL, 44594),
(44595, '1.10.10.60-FF-000209', NULL, 'Psp operon transcriptional activator', 62, NULL, NULL, 44595),
(44596, '1.20.58.60-FF-000662', NULL, 'Uncharacterized protein', 188, NULL, NULL, 44596),
(44597, '1.10.340.70-FF-000002', NULL, 'Zinc finger and BTB domain-containing protein 11', 98, NULL, NULL, 44597),
(44598, '3.40.50.150-FF-001356', NULL, NULL, 188, NULL, NULL, 44598),
(44599, '3.40.50.300-FF-005785', NULL, 'DNA repair and recombination protein, putative helicase', 87, NULL, NULL, 44599),
(44600, '3.30.479.10-FF-000001', NULL, '6-carboxy-5,6,7,8-tetrahydropterin synthase', 120, NULL, NULL, 44600),
(44601, '3.40.720.10-FF-000353', NULL, 'Uncharacterized protein', 109, NULL, NULL, 44601),
(44602, '3.40.720.10-FF-000168', NULL, 'Iduronate-2-sulfatase and sulfatase 1', 397, NULL, NULL, 44602),
(44603, '3.40.50.720-FF-001521', NULL, 'Hydroxysteroid (17-beta) dehydrogenase 14', 80, NULL, NULL, 44603),
(44604, '3.40.50.10470-FF-000004', NULL, 'Translation initiation factor eIF-2B subunit beta', 204, NULL, NULL, 44604),
(44605, '3.30.420.10-FF-000653', NULL, NULL, 205, NULL, NULL, 44605),
(44606, '2.70.170.10-FF-000061', NULL, 'Ligand-gated ion channel 4', 222, NULL, NULL, 44606);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(44607, '2.10.10.20-FF-000010', NULL, 'Chitin-binding protein', 45, NULL, NULL, 44607),
(44608, '2.60.40.10-FF-004082', NULL, NULL, 95, NULL, NULL, 44608),
(44609, '2.30.40.10-FF-000171', NULL, 'Uncharacterized protein', 43, NULL, NULL, 44609),
(44610, '1.20.1310.10-FF-000204', NULL, NULL, 105, NULL, NULL, 44610),
(44611, '1.20.120.140-FF-000015', NULL, 'Signal peptide binding domain protein', 20, NULL, NULL, 44611),
(44612, '2.60.40.3210-FF-000015', NULL, 'Si:ch211-14a17.6', 105, NULL, NULL, 44612),
(44613, '3.40.50.2000-FF-000398', NULL, 'AGAP009137-PA', 204, NULL, NULL, 44613),
(44614, '3.30.559.10-FF-000002', NULL, 'carnitine O-palmitoyltransferase 1, liver isoform', 273, NULL, NULL, 44614),
(44615, '3.40.1280.10-FF-000060', NULL, 'rRNA methyltransferase', 165, NULL, NULL, 44615),
(44616, '3.10.610.10-FF-000003', NULL, 'General secretion pathway protein J', 108, NULL, NULL, 44616),
(44617, '1.25.40.180-FF-000125', NULL, 'Putative eukaryotic translation initiation factor 4 gamma', 235, NULL, NULL, 44617),
(44618, '2.130.10.10-FF-002261', NULL, 'Uncharacterized protein', 316, NULL, NULL, 44618),
(44619, '2.60.40.10-FF-001676', NULL, 'CD96 isoform 3', 110, NULL, NULL, 44619),
(44620, '3.30.420.40-FF-001033', NULL, 'Heat shock protein 70 family', 32, NULL, NULL, 44620),
(44621, '3.40.50.300-FF-001367', NULL, 'Elongation factor 2', 205, NULL, NULL, 44621),
(44622, '3.30.160.60-FF-001889', NULL, 'Paternally-expressed gene 3 protein', 48, NULL, NULL, 44622),
(44623, '1.25.40.10-FF-001776', NULL, 'Pentatricopeptide repeat-containing protein', 93, NULL, NULL, 44623),
(44624, '1.20.1420.30-FF-000100', NULL, 'Uncharacterized protein', 190, NULL, NULL, 44624),
(44625, '2.40.30.10-FF-000440', NULL, 'Elongation factor Tu', 54, NULL, NULL, 44625),
(44626, '2.60.120.260-FF-000114', NULL, 'Glycoside hydrolase family 3 protein', 165, NULL, NULL, 44626),
(44627, '3.60.40.10-FF-000061', NULL, 'Probable protein phosphatase 2C 67', 289, NULL, NULL, 44627),
(44628, '3.40.1360.10-FF-000061', NULL, 'Spo11-like type II topoisomerase', 209, NULL, NULL, 44628),
(44629, '3.40.50.300-FF-001570', NULL, 'Adenylate isopentenyltransferase', 183, NULL, NULL, 44629),
(44630, '3.30.1490.190-FF-000027', NULL, 'Ferric uptake regulation protein', 52, NULL, NULL, 44630),
(44631, '1.10.630.10-FF-000170', NULL, 'Cytochrome P450 137', 422, NULL, NULL, 44631),
(44632, '3.40.850.10-FF-000357', NULL, 'Myosin, heavy chain 11a, smooth muscle', 75, NULL, NULL, 44632),
(44633, '3.30.70.330-FF-001091', NULL, 'Protein CBR-RNP-8.1', 91, NULL, NULL, 44633),
(44634, '2.120.10.30-FF-000463', NULL, 'RING finger-containing protein, putative', 81, NULL, NULL, 44634),
(44635, '1.20.1560.10-FF-000632', NULL, 'Uncharacterized protein', 227, NULL, NULL, 44635),
(44636, '3.30.160.60-FF-001945', NULL, 'Zinc finger protein 559', 31, NULL, NULL, 44636),
(44637, '2.60.40.420-FF-000052', NULL, 'Iron uptake system component EfeO', 98, NULL, NULL, 44637),
(44638, '4.10.1000.40-FF-000009', NULL, 'Uncharacterized protein', 52, NULL, NULL, 44638),
(44639, '3.30.40.10-FF-000601', NULL, 'Nitric oxide synthase-interacting protein homolog', 56, NULL, NULL, 44639),
(44640, '3.30.950.10-FF-000030', NULL, 'Uroporphyrin-III synthase', 112, NULL, NULL, 44640),
(44641, '3.90.550.10-FF-000379', NULL, 'Alpha-D-GlcNAc-pyrophosphate polyprenol, alpha-3-L-rhamnosyltransferase', 231, NULL, NULL, 44641),
(44642, '1.20.1260.10-FF-000031', NULL, 'Neutrophil activating protein A (NapA)', 151, NULL, NULL, 44642),
(44643, '3.40.850.10-FF-000413', NULL, 'Kinesin heavy chain isoform 5C', 238, NULL, NULL, 44643),
(44644, '3.10.110.10-FF-000089', NULL, 'Ubiquitin-conjugating enzyme E2 I', 150, NULL, NULL, 44644),
(44645, '2.10.220.10-FF-000045', NULL, 'Proprotein convertase subtilisin/kexin type 4', 118, NULL, NULL, 44645),
(44646, '2.40.30.10-FF-000108', NULL, 'Vanillate O-demethylase oxidoreductase', 97, NULL, NULL, 44646),
(44647, '2.60.40.10-FF-005386', NULL, NULL, 55, NULL, NULL, 44647),
(44648, '3.30.160.60-FF-002345', NULL, 'YPR013C-like protein', 38, NULL, NULL, 44648),
(44649, '2.60.40.10-FF-004458', NULL, NULL, 106, NULL, NULL, 44649);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(44650, '2.40.30.230-FF-000008', NULL, 'ATP-dependent helicase upf1', 92, NULL, NULL, 44650),
(44651, '1.10.565.10-FF-000214', NULL, 'Uncharacterized protein', 162, NULL, NULL, 44651),
(44652, '1.20.120.1750-FF-000010', NULL, 'RBR-type E3 ubiquitin transferase', 63, NULL, NULL, 44652),
(44653, '3.40.1170.60-FF-000021', NULL, 'DNA polymerase IV', 58, NULL, NULL, 44653),
(44654, '1.10.760.10-FF-000027', NULL, 'Nitrite reductase', 106, NULL, NULL, 44654),
(44655, '3.30.505.10-FF-000030', NULL, 'Transcription elongation factor spt6', 107, NULL, NULL, 44655),
(44656, '1.10.3060.10-FF-000001', NULL, 'Preprotein translocase subunit SecA', 213, NULL, NULL, 44656),
(44657, '2.60.120.290-FF-000185', NULL, 'Soluble neuropilin 2a2', 62, NULL, NULL, 44657),
(44658, '3.30.2320.80-FF-000008', NULL, 'Hydrogenase maturation factor HypA 2', 115, NULL, NULL, 44658),
(44659, '3.30.160.20-FF-000236', NULL, 'Uncharacterized protein', 74, NULL, NULL, 44659),
(44660, '1.10.10.10-FF-001004', NULL, 'Heat shock transcription factor, putative', 99, NULL, NULL, 44660),
(44661, '3.10.20.230-FF-000032', NULL, 'Doublecortin', 84, NULL, NULL, 44661),
(44662, '1.10.10.970-FF-000001', NULL, 'RNA 2''-phosphotransferase', 72, NULL, NULL, 44662),
(44663, '2.130.10.10-FF-002109', NULL, 'WD repeat protein', 72, NULL, NULL, 44663),
(44664, '1.10.510.10-FF-001296', NULL, 'Dual serine/threonine and tyrosine protein kinase', 174, NULL, NULL, 44664),
(44665, '3.40.640.10-FF-000167', NULL, 'Putative serine palmitoyltransferase', 254, NULL, NULL, 44665),
(44666, '2.160.20.10-FF-000214', NULL, 'Pectinesterase', 327, NULL, NULL, 44666),
(44667, '2.130.10.10-FF-005751', NULL, 'Uncharacterized protein', 120, NULL, NULL, 44667),
(44668, '3.40.50.150-FF-000428', NULL, 'Alkylated DNA repair protein alkB homolog 8', 198, NULL, NULL, 44668),
(44669, '3.30.70.1620-FF-000011', NULL, 'Structural maintenance of chromosomes protein', 86, NULL, NULL, 44669),
(44670, '3.40.50.2000-FF-000578', NULL, 'Glycosyl transferase', 164, NULL, NULL, 44670),
(44671, '1.10.472.30-FF-000009', NULL, 'Transcription factor BYE1', 153, NULL, NULL, 44671),
(44672, '3.40.50.1820-FF-000001', NULL, 'Neuroligin 3 isoform', 574, NULL, NULL, 44672),
(44673, '1.10.287.600-FF-000014', NULL, 'Tubulin alpha chain', 23, NULL, NULL, 44673),
(44674, '3.90.1010.10-FF-000023', NULL, 'Iron-sulfur cluster assembly scaffold protein', 121, NULL, NULL, 44674),
(44675, '1.25.40.20-FF-001689', NULL, 'Predicted protein', 73, NULL, NULL, 44675),
(44676, '3.60.21.50-FF-000006', NULL, 'DNA polymerase delta subunit 2, putative', 311, NULL, NULL, 44676),
(44677, '1.25.50.20-FF-000026', NULL, 'Aminopeptidase', 323, NULL, NULL, 44677),
(44678, '3.30.40.10-FF-002366', NULL, 'Ubiquitinyl hydrolase 1', 129, NULL, NULL, 44678),
(44679, '3.40.30.10-FF-000634', NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 2', 68, NULL, NULL, 44679),
(44680, '3.60.10.10-FF-000233', NULL, 'Endonuclease/Exonuclease/phosphatase family protein', 340, NULL, NULL, 44680),
(44681, '1.20.1070.10-FF-000016', NULL, 'Adhesion G protein-coupled receptor B2', 272, NULL, NULL, 44681),
(44682, '2.130.10.10-FF-001709', NULL, 'Elongator complex protein 2', 175, NULL, NULL, 44682),
(44683, '2.60.40.10-FF-000187', NULL, 'neogenin isoform X2', 110, NULL, NULL, 44683),
(44684, '1.20.1560.10-FF-000576', NULL, 'Protein CBR-PGP-9', 621, NULL, NULL, 44684),
(44685, '2.10.25.10-FF-001598', NULL, 'Uncharacterized protein', 29, NULL, NULL, 44685),
(44686, '2.30.40.10-FF-000019', NULL, 'Urease subunit alpha', 183, NULL, NULL, 44686),
(44687, '1.10.630.10-FF-000546', NULL, 'Uncharacterized protein', 350, NULL, NULL, 44687),
(44688, '1.10.10.440-FF-000106', NULL, 'Uncharacterized protein', 71, NULL, NULL, 44688),
(44689, '3.30.450.20-FF-000394', NULL, 'Membrane-anchored chemotaxis sensory transducer', 98, NULL, NULL, 44689),
(44690, '3.40.50.300-FF-005257', NULL, 'Probable thymidylate kinase', 187, NULL, NULL, 44690),
(44691, '2.130.10.10-FF-006004', NULL, 'Uncharacterized protein', 49, NULL, NULL, 44691),
(44692, '3.40.50.300-FF-002531', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', 311, NULL, NULL, 44692);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(44693, '3.20.19.10-FF-000018', NULL, 'Uncharacterized protein', 103, NULL, NULL, 44693),
(44694, '1.25.40.10-FF-003541', NULL, 'LD41803p', 104, NULL, NULL, 44694),
(44695, '3.30.1370.210-FF-000007', NULL, 'Zinc finger CCCH domain-containing protein', 63, NULL, NULL, 44695),
(44696, '1.10.10.10-FF-000043', NULL, 'RNA polymerase sigma factor', 71, NULL, NULL, 44696),
(44697, '2.60.120.10-FF-000228', NULL, 'Acetyltransferase Pat', 145, NULL, NULL, 44697),
(44698, '2.80.10.50-FF-000162', NULL, 'Putative fibroblast growth factor 1', 144, NULL, NULL, 44698),
(44699, '2.10.90.10-FF-000068', NULL, 'AGAP000342-PA', 133, NULL, NULL, 44699),
(44700, '3.40.1110.10-FF-000435', NULL, NULL, 67, NULL, NULL, 44700),
(44701, '2.130.10.10-FF-001856', NULL, 'Bromodomain and WD repeat-containing protein', 248, NULL, NULL, 44701),
(44702, '1.20.920.60-FF-000007', NULL, 'Uncharacterized protein', 172, NULL, NULL, 44702),
(44703, '1.10.10.60-FF-001137', NULL, NULL, 59, NULL, NULL, 44703),
(44704, '1.10.12.10-FF-000025', NULL, 'Enoyl-CoA hydratase EchA19', 58, NULL, NULL, 44704),
(44705, '2.30.30.140-FF-000186', NULL, 'Acylphosphatase', 75, NULL, NULL, 44705),
(44706, '3.20.20.70-FF-000410', NULL, 'Radical SAM domain protein', 267, NULL, NULL, 44706),
(44707, '1.20.120.850-FF-000025', NULL, 'Protein CBR-SSL-1', 50, NULL, NULL, 44707),
(44708, '3.30.160.60-FF-002906', NULL, 'Protein CBR-LSY-2', 34, NULL, NULL, 44708),
(44709, '2.60.40.150-FF-000712', NULL, 'Predicted protein', 138, NULL, NULL, 44709),
(44710, '1.25.10.10-FF-002224', NULL, 'Uncharacterized protein', 400, NULL, NULL, 44710),
(44711, '1.25.40.20-FF-000200', NULL, 'ankyrin repeat domain-containing protein 6', 52, NULL, NULL, 44711),
(44712, '3.30.1120.30-FF-000040', NULL, 'Probable serine/threonine-protein kinase CCRP1', 67, NULL, NULL, 44712),
(44713, '3.80.10.10-FF-003121', NULL, 'Leucine-rich, glioma inactivated 1b', 87, NULL, NULL, 44713),
(44714, '1.25.10.10-FF-001948', NULL, 'HECT-domain (Ubiquitin-transferase), putative', 289, NULL, NULL, 44714),
(44715, '1.20.1540.10-FF-000069', NULL, 'Rhombosortase', 191, NULL, NULL, 44715),
(44716, '2.60.40.10-FF-005419', NULL, NULL, 128, NULL, NULL, 44716),
(44717, '1.10.225.10-FF-000020', NULL, 'Saposin-related', 84, NULL, NULL, 44717),
(44718, '2.20.110.10-FF-000023', NULL, 'GD23870', 49, NULL, NULL, 44718),
(44719, '2.60.40.10-FF-001024', NULL, 'Tyrosine-protein kinase receptor', 96, NULL, NULL, 44719),
(44720, '2.130.10.120-FF-000006', NULL, 'Prolyl oligopeptidase family protein', 354, NULL, NULL, 44720),
(44721, '2.60.120.260-FF-000642', NULL, 'Uncharacterized protein', 103, NULL, NULL, 44721),
(44722, '3.30.70.590-FF-000010', NULL, 'Uncharacterized protein', 115, NULL, NULL, 44722),
(44723, '3.30.420.40-FF-000105', NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase', 20, NULL, NULL, 44723),
(44724, '3.30.720.10-FF-000018', NULL, 'Signal recognition particle 14kD protein', 110, NULL, NULL, 44724),
(44725, '1.20.5.190-FF-000014', NULL, 'IQ motif containing F5', 52, NULL, NULL, 44725),
(44726, '3.30.230.120-FF-000024', NULL, NULL, 96, NULL, NULL, 44726),
(44727, '2.60.40.840-FF-000003', NULL, 'Kurtz arrestin', 177, NULL, NULL, 44727),
(44728, '3.20.80.10-FF-000008', NULL, 'SOUL heme-binding protein', 172, NULL, NULL, 44728),
(44729, '3.40.50.300-FF-006802', NULL, 'Uncharacterized protein', 52, NULL, NULL, 44729),
(44730, '1.10.840.10-FF-000028', NULL, 'Cell division control protein 25', 224, NULL, NULL, 44730),
(44731, '3.30.800.10-FF-000019', NULL, 'Unplaced genomic scaffold supercont1.157, whole genome shotgun sequence', 177, NULL, NULL, 44731),
(44732, '1.20.120.1770-FF-000016', NULL, 'Uncharacterized protein', 180, NULL, NULL, 44732),
(44733, '2.170.120.20-FF-000019', NULL, 'Predicted protein', 90, NULL, NULL, 44733),
(44734, '4.10.1130.20-FF-000007', NULL, 'CHORD, putative', 76, NULL, NULL, 44734),
(44735, '1.50.40.10-FF-000307', NULL, 'Uncharacterized protein', 92, NULL, NULL, 44735),
(44736, '4.10.410.10-FF-000035', NULL, 'Protein CBR-MLT-11', 69, NULL, NULL, 44736),
(44737, '2.60.40.10-FF-000748', NULL, 'Uncharacterized protein, isoform J', 97, NULL, NULL, 44737);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(44738, '2.30.29.30-FF-001207', NULL, 'Goodpasture antigen-binding protein, putative', 53, NULL, NULL, 44738),
(44739, '1.10.10.10-FF-000751', NULL, 'Histone acetyltransferase', 66, NULL, NULL, 44739),
(44740, '1.20.58.870-FF-000009', NULL, NULL, 108, NULL, NULL, 44740),
(44741, '1.25.10.10-FF-002932', NULL, 'AP-3 complex subunit beta', 91, NULL, NULL, 44741),
(44742, '1.10.560.10-FF-000023', NULL, 'T-complex protein 1, beta subunit', 237, NULL, NULL, 44742),
(44743, '2.60.40.10-FF-000035', NULL, 'Contactin 1', 102, NULL, NULL, 44743),
(44744, '3.40.5.120-FF-000004', NULL, 'Chromodomain-helicase-DNA-binding protein 8', 49, NULL, NULL, 44744),
(44745, '1.20.1280.290-FF-000006', NULL, 'mannose-P-dolichol utilization defect 1 protein', 89, NULL, NULL, 44745),
(44746, '1.10.10.570-FF-000010', NULL, 'ESCRT-II complex subunit-domain-containing protein', 92, NULL, NULL, 44746),
(44747, '1.10.8.60-FF-000580', NULL, 'Uncharacterized protein', 39, NULL, NULL, 44747),
(44748, '1.20.1250.90-FF-000003', NULL, 'Uncharacterized protein', 136, NULL, NULL, 44748),
(44749, '2.102.10.10-FF-000059', NULL, 'Cytochrome b6/f complex iron-sulfur subunit', 110, NULL, NULL, 44749),
(44750, '1.10.640.10-FF-000075', NULL, 'Uncharacterized protein', 63, NULL, NULL, 44750),
(44751, '2.60.120.650-FF-000017', NULL, 'lysine-specific demethylase hairless isoform X1', 323, NULL, NULL, 44751),
(44752, '3.40.20.10-FF-000077', NULL, 'Gelsolin, isoform A', 109, NULL, NULL, 44752),
(44753, '3.90.1110.10-FF-000019', NULL, 'DNA-directed RNA polymerase subunit beta', 178, NULL, NULL, 44753),
(44754, '1.20.5.170-FF-000272', NULL, 'Chromosome 1, whole genome shotgun sequence', 68, NULL, NULL, 44754),
(44755, '1.20.1250.20-FF-001079', NULL, 'Uncharacterized protein', 467, NULL, NULL, 44755),
(44756, '2.40.30.170-FF-000024', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 67, NULL, NULL, 44756),
(44757, '3.40.50.300-FF-005818', NULL, 'Uncharacterized protein', 239, NULL, NULL, 44757),
(44758, '1.10.150.50-FF-000021', NULL, 'Diacylglycerol kinase', 74, NULL, NULL, 44758),
(44759, '3.40.390.30-FF-000001', NULL, 'Endoribonuclease YbeY', 155, NULL, NULL, 44759),
(44760, '3.30.200.20-FF-002264', NULL, 'Uncharacterized protein', 113, NULL, NULL, 44760),
(44761, '3.40.50.720-FF-000976', NULL, 'Succinate--CoA ligase [ADP-forming] subunit alpha', 93, NULL, NULL, 44761),
(44762, '3.40.1110.10-FF-000082', NULL, 'Phospholipid-transporting ATPase', 99, NULL, NULL, 44762),
(44763, '3.30.70.100-FF-000111', NULL, 'Heavy metal translocating P-type ATPase', 77, NULL, NULL, 44763),
(44764, '1.20.120.1240-FF-000037', NULL, 'Predicted protein', 209, NULL, NULL, 44764),
(44765, '1.20.810.10-FF-000030', NULL, 'Cytochrome b mRNA maturase bI2', 172, NULL, NULL, 44765),
(44766, '3.40.50.1000-FF-000166', NULL, 'Cytosolic 5-nucleotidase', 184, NULL, NULL, 44766),
(44767, '3.30.160.60-FF-001092', NULL, 'Wilms tumor protein isoform X2', 40, NULL, NULL, 44767),
(44768, '1.25.40.10-FF-001416', NULL, 'Tetratricopeptide repeat-containing protein', 160, NULL, NULL, 44768),
(44769, '3.40.50.300-FF-007382', NULL, 'Guanylate-binding protein, putative', 313, NULL, NULL, 44769),
(44770, '1.10.10.41-FF-000008', NULL, NULL, 80, NULL, NULL, 44770),
(44771, '2.30.36.90-FF-000005', NULL, NULL, 29, NULL, NULL, 44771),
(44772, '3.40.50.300-FF-008371', NULL, 'Uncharacterized protein', 221, NULL, NULL, 44772),
(44773, '3.20.20.60-FF-000020', NULL, 'Malyl-CoA lyase', 318, NULL, NULL, 44773),
(44774, '3.40.630.30-FF-000408', NULL, 'O-GlcNAc selective N-Acetyl-beta-D-glucosaminidase (O-GlcNAcase)', 206, NULL, NULL, 44774),
(44775, '3.80.10.10-FF-002216', NULL, 'Predicted protein', 61, NULL, NULL, 44775),
(44776, '2.60.40.10-FF-001496', NULL, 'Plexin A, isoform B', 141, NULL, NULL, 44776),
(44777, '1.20.59.10-FF-000020', NULL, 'Chorismate mutase', 102, NULL, NULL, 44777),
(44778, '3.30.70.330-FF-000955', NULL, 'RNA binding protein, putative', 95, NULL, NULL, 44778),
(44779, '3.30.1490.20-FF-000002', NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta', 84, NULL, NULL, 44779);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(44780, '3.40.50.1240-FF-000007', NULL, 'Phosphoglycerate mutase', 254, NULL, NULL, 44780),
(44781, '3.40.50.1440-FF-000163', NULL, 'Predicted protein', 114, NULL, NULL, 44781),
(44782, '3.40.50.300-FF-000294', NULL, 'ADP-ribosylation factor-like protein 5A', 173, NULL, NULL, 44782),
(44783, '3.40.630.10-FF-000402', NULL, 'Peptidase M20', 239, NULL, NULL, 44783),
(44784, '2.40.70.10-FF-000026', NULL, 'Endothiapepsin', 168, NULL, NULL, 44784),
(44785, '3.30.1640.10-FF-000062', NULL, 'DNA replication licensing factor mcm6', 131, NULL, NULL, 44785),
(44786, '2.20.80.10-FF-000022', NULL, 'Hemelipoglyco-carrier protein', 206, NULL, NULL, 44786),
(44787, '3.40.50.150-FF-000108', NULL, 'DNA (cytosine-5)-methyltransferase', 31, NULL, NULL, 44787),
(44788, '3.90.79.20-FF-000016', NULL, 'NADH pyrophosphatase', 139, NULL, NULL, 44788),
(44789, '3.100.10.10-FF-000044', NULL, NULL, 77, NULL, NULL, 44789),
(44790, '2.40.10.10-FF-000489', NULL, NULL, 189, NULL, NULL, 44790),
(44791, '2.30.42.10-FF-000501', NULL, NULL, 73, NULL, NULL, 44791),
(44792, '1.10.472.80-FF-000007', NULL, 'Rab GTPase-activating protein 1 isoform X1', 153, NULL, NULL, 44792),
(44793, '3.30.1240.10-FF-000065', NULL, 'Hydrolase, haloacid dehalogenase-like hydrolase', 101, NULL, NULL, 44793),
(44794, '1.10.630.10-FF-000731', NULL, 'Predicted protein', 93, NULL, NULL, 44794),
(44795, '1.25.40.10-FF-000427', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 155, NULL, NULL, 44795),
(44796, '1.10.1070.11-FF-000132', NULL, 'Predicted protein', 197, NULL, NULL, 44796),
(44797, '2.30.42.10-FF-000389', NULL, NULL, 83, NULL, NULL, 44797),
(44798, '1.20.58.340-FF-000002', NULL, 'Zinc transport protein ZntB', 128, NULL, NULL, 44798),
(44799, '3.90.1030.10-FF-000018', NULL, '50S ribosomal protein L17', 116, NULL, NULL, 44799),
(44800, '2.60.40.1590-FF-000001', NULL, 'Peptidase M23', 100, NULL, NULL, 44800),
(44801, '1.10.10.10-FF-000127', NULL, 'GntR family transcriptional regulator', 66, NULL, NULL, 44801),
(44802, '2.40.270.10-FF-000013', NULL, 'DNA-directed RNA polymerase II subunit RPB2', 84, NULL, NULL, 44802),
(44803, '3.30.160.60-FF-002822', NULL, 'Unplaced genomic scaffold supercont1.138, whole genome shotgun sequence', 35, NULL, NULL, 44803),
(44804, '1.10.510.10-FF-002549', NULL, 'Predicted protein', 362, NULL, NULL, 44804),
(44805, '2.10.25.10-FF-000081', NULL, 'Netrin 1', 101, NULL, NULL, 44805),
(44806, '3.40.50.300-FF-002643', NULL, 'YDR061W-like protein', 244, NULL, NULL, 44806),
(44807, '3.90.480.20-FF-000005', NULL, 'Nitrite/sulfite reductase, 4Fe-4S iron-sulfur cluster-binding domain protein', 174, NULL, NULL, 44807),
(44808, '1.20.58.80-FF-000089', NULL, 'Sorting nexin 15', 78, NULL, NULL, 44808),
(44809, '2.60.40.60-FF-001078', NULL, 'Uncharacterized protein', 111, NULL, NULL, 44809),
(44810, '3.90.226.10-FF-000025', NULL, 'Peroxisomal fatty acid beta-oxidation multifunctional protein', 303, NULL, NULL, 44810),
(44811, '3.30.450.20-FF-000478', NULL, 'Uncharacterized protein', 158, NULL, NULL, 44811),
(44812, '1.25.10.10-FF-002112', NULL, 'Uncharacterized protein', 274, NULL, NULL, 44812),
(44813, '3.40.50.10810-FF-000185', NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily A-like protein 1', 139, NULL, NULL, 44813),
(44814, '3.30.9.10-FF-000208', NULL, 'Dao1p', 181, NULL, NULL, 44814),
(44815, '2.130.10.10-FF-004442', NULL, 'Uncharacterized protein', 352, NULL, NULL, 44815),
(44816, '1.25.40.10-FF-003721', NULL, 'Tetratricopeptide repeat domain 36', 79, NULL, NULL, 44816),
(44817, '3.80.10.10-FF-001699', NULL, 'Uncharacterized protein', 102, NULL, NULL, 44817),
(44818, '3.30.200.20-FF-001275', NULL, 'Serine/threonine/tyrosine protein kinase', 87, NULL, NULL, 44818),
(44819, '1.10.630.10-FF-000198', NULL, 'Cytochrome P450, family 7, subfamily B, polypeptide 1', 477, NULL, NULL, 44819),
(44820, '2.30.38.10-FF-000019', NULL, 'Uncharacterized protein', 79, NULL, NULL, 44820),
(44821, '3.30.450.50-FF-000003', NULL, '25.3 kDa vesicle transport protein-like', 128, NULL, NULL, 44821);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(44822, '3.30.70.330-FF-001944', NULL, NULL, 128, NULL, NULL, 44822),
(44823, '2.10.25.10-FF-000873', NULL, 'FAT atypical cadherin 2', 41, NULL, NULL, 44823),
(44824, '3.40.190.290-FF-000045', NULL, 'Helix-turn-helix transcriptional regulator, LysR family', 202, NULL, NULL, 44824),
(44825, '3.30.60.270-FF-000019', NULL, 'Uncharacterized protein', 35, NULL, NULL, 44825),
(44826, '2.130.10.10-FF-001569', NULL, 'WD repeat-containing protein 74-like Protein', 173, NULL, NULL, 44826),
(44827, '3.40.50.1220-FF-000001', NULL, 'Electron transfer flavoprotein, alpha subunit', 128, NULL, NULL, 44827),
(44828, '2.70.98.10-FF-000055', NULL, 'Aldose 1-epimerase', 325, NULL, NULL, 44828),
(44829, '1.10.8.10-FF-000328', NULL, 'UBA/TS-N domain containing protein', 46, NULL, NULL, 44829),
(44830, '3.20.20.80-FF-000059', NULL, 'Alpha-L-iduronidase', 352, NULL, NULL, 44830),
(44831, '3.40.50.300-FF-003099', NULL, 'PhiRv1 phage protein', 166, NULL, NULL, 44831),
(44832, '3.30.160.60-FF-002030', NULL, 'zinc finger protein 445 isoform X1', 35, NULL, NULL, 44832),
(44833, '2.130.10.10-FF-002137', NULL, 'U4/U6 small nuclear ribonucleoprotein PRP4-like protein', 216, NULL, NULL, 44833),
(44834, '3.30.160.60-FF-005695', NULL, NULL, 64, NULL, NULL, 44834),
(44835, '4.10.240.10-FF-000095', NULL, 'C6 transcription factor, putative', 74, NULL, NULL, 44835),
(44836, '1.10.840.10-FF-000005', NULL, 'Ral guanine nucleotide dissociation stimulator isoform 1', 285, NULL, NULL, 44836),
(44837, '3.40.50.150-FF-001569', NULL, NULL, 69, NULL, NULL, 44837),
(44838, '3.40.1380.20-FF-000014', NULL, 'Pyruvate kinase', 118, NULL, NULL, 44838),
(44839, '3.40.50.150-FF-000159', NULL, 'Malonyl-[acyl-carrier protein] O-methyltransferase', 211, NULL, NULL, 44839),
(44840, '3.30.70.330-FF-002512', NULL, NULL, 70, NULL, NULL, 44840),
(44841, '1.10.510.10-FF-003909', NULL, NULL, 80, NULL, NULL, 44841),
(44842, '3.30.1370.10-FF-000198', NULL, 'Synaptic functional regulator FMR1', 124, NULL, NULL, 44842),
(44843, '3.80.10.10-FF-000659', NULL, 'Leucine-rich repeat protein', 142, NULL, NULL, 44843),
(44844, '1.20.58.870-FF-000004', NULL, 'DNA helicase', 101, NULL, NULL, 44844),
(44845, '3.40.50.300-FF-005077', NULL, 'Uncharacterized protein', 93, NULL, NULL, 44845),
(44846, '3.60.21.10-FF-000337', NULL, 'Uncharacterized protein', 134, NULL, NULL, 44846),
(44847, '2.60.40.10-FF-004790', NULL, NULL, 161, NULL, NULL, 44847),
(44848, '3.30.590.20-FF-000016', NULL, 'Glutamate--cysteine ligase', 351, NULL, NULL, 44848),
(44849, '1.10.240.10-FF-000027', NULL, 'Tryptophanyl-tRNA synthetase', 102, NULL, NULL, 44849),
(44850, '3.40.190.80-FF-000074', NULL, 'Predicted protein', 101, NULL, NULL, 44850),
(44851, '1.25.40.20-FF-000756', NULL, 'Mechanosensory transduction channel NOMPC', 144, NULL, NULL, 44851),
(44852, '3.40.50.200-FF-000090', NULL, 'Proprotein convertase subtilisin/kexin type 5', 330, NULL, NULL, 44852),
(44853, '3.40.50.1000-FF-000115', NULL, 'Copper-exporting P-type ATPase', 173, NULL, NULL, 44853),
(44854, '1.10.640.10-FF-000024', NULL, 'AGAP013282-PA', 577, NULL, NULL, 44854),
(44855, '3.30.300.10-FF-000003', NULL, 'S-adenosylmethionine synthase', 106, NULL, NULL, 44855),
(44856, '1.25.40.20-FF-001745', NULL, 'Zinc finger protein', 211, NULL, NULL, 44856),
(44857, '2.130.10.10-FF-003565', NULL, 'Predicted protein', 208, NULL, NULL, 44857),
(44858, '3.60.21.60-FF-000020', NULL, 'DNA polymerase alpha subunit B', 161, NULL, NULL, 44858),
(44859, '2.130.10.10-FF-002997', NULL, 'WD40-repeat-containing domain protein', 194, NULL, NULL, 44859),
(44860, '3.30.1360.120-FF-000040', NULL, 'Folate-dependent protein for Fe/S cluster synthesis/repair in oxidative stress', 145, NULL, NULL, 44860),
(44861, '1.25.40.10-FF-002844', NULL, 'Clustered mitochondria protein homolog', 124, NULL, NULL, 44861),
(44862, '3.40.50.1820-FF-001642', NULL, 'Serine carboxypeptidase S10 family member 1', 404, NULL, NULL, 44862),
(44863, '3.30.450.50-FF-000054', NULL, 'Uncharacterized protein', 123, NULL, NULL, 44863),
(44864, '1.20.140.10-FF-000118', NULL, 'Putative acyl CoA oxidase', 157, NULL, NULL, 44864);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(44865, '3.30.565.10-FF-000275', NULL, 'Two-component hybrid sensor and regulator', 149, NULL, NULL, 44865),
(44866, '1.20.1070.10-FF-001657', NULL, 'MAS related GPR family member F', 129, NULL, NULL, 44866),
(44867, '3.30.450.40-FF-000113', NULL, 'Histidine kinase', 152, NULL, NULL, 44867),
(44868, '3.30.70.2880-FF-000001', NULL, 'PelD', 137, NULL, NULL, 44868),
(44869, '2.30.29.30-FF-001090', NULL, 'Uncharacterized protein', 54, NULL, NULL, 44869),
(44870, '2.60.40.10-FF-002452', NULL, 'Tyrosine-protein kinase receptor', 87, NULL, NULL, 44870),
(44871, '1.25.10.10-FF-001595', NULL, 'Rotatin-like Protein', 146, NULL, NULL, 44871),
(44872, '3.30.300.30-FF-000009', NULL, 'Bifunctional protein Aas', 98, NULL, NULL, 44872),
(44873, '1.10.238.10-FF-000230', NULL, 'Protein S100-A3', 101, NULL, NULL, 44873),
(44874, '2.60.40.1180-FF-000209', NULL, 'Alpha-N-arabinofuranosidase', 96, NULL, NULL, 44874),
(44875, '2.30.30.40-FF-000117', NULL, 'SH3 domain-binding protein 4', 61, NULL, NULL, 44875),
(44876, '3.30.1360.10-FF-000012', NULL, 'DNA-directed RNA polymerases I and III subunit RPAC2', 104, NULL, NULL, 44876),
(44877, '3.90.70.10-FF-000174', NULL, 'Ubiquitinyl hydrolase 1', 209, NULL, NULL, 44877),
(44878, '3.40.50.10140-FF-000017', NULL, 'B cell scaffold protein with ankyrin repeats 1', 133, NULL, NULL, 44878),
(44879, '3.40.50.300-FF-001654', NULL, 'Replication factor C subunit 5, putative', 184, NULL, NULL, 44879),
(44880, '1.25.40.20-FF-000705', NULL, 'Glycerophosphocholine phosphodiesterase Gde1', 57, NULL, NULL, 44880),
(44881, '3.40.640.10-FF-000116', NULL, 'Pyridoxal phosphate (PLP)-dependent transferases superfamily protein', 246, NULL, NULL, 44881),
(44882, '3.30.160.60-FF-006263', NULL, NULL, 61, NULL, NULL, 44882),
(44883, '1.20.58.60-FF-000875', NULL, 'Spectrin beta chain', 211, NULL, NULL, 44883),
(44884, '2.40.50.140-FF-000429', NULL, 'Transcription elongation factor SPT6', 64, NULL, NULL, 44884),
(44885, '3.30.360.10-FF-000030', NULL, 'NAD binding Rossmann fold oxidoreductase', 241, NULL, NULL, 44885),
(44886, '3.40.50.2060-FF-000017', NULL, 'Vacuolar protein sorting-associated protein 33B', 134, NULL, NULL, 44886),
(44887, '1.20.58.2220-FF-000031', NULL, 'Formin 2', 313, NULL, NULL, 44887),
(44888, '1.10.220.10-FF-000032', NULL, 'Annexin', 38, NULL, NULL, 44888),
(44889, '2.60.40.1670-FF-000019', NULL, 'Protein transport protein SEC23', 122, NULL, NULL, 44889),
(44890, '1.10.510.10-FF-000312', NULL, 'Serine/threonine-protein kinase OXI1', 122, NULL, NULL, 44890),
(44891, '1.20.1370.60-FF-000003', NULL, 'Uncharacterized protein', 79, NULL, NULL, 44891),
(44892, '3.20.20.70-FF-000270', NULL, 'Triosephosphate isomerase', 276, NULL, NULL, 44892),
(44893, '2.50.20.20-FF-000003', NULL, 'Lipoprotein LprA', 206, NULL, NULL, 44893),
(44894, '1.10.472.10-FF-000206', NULL, 'Cyclin domain containing protein', 132, NULL, NULL, 44894),
(44895, '2.30.29.30-FF-001151', NULL, 'Uncharacterized protein', 111, NULL, NULL, 44895),
(44896, '3.30.505.10-FF-000266', NULL, NULL, 157, NULL, NULL, 44896),
(44897, '1.25.10.10-FF-001656', NULL, 'Transport and Golgi organization 6', 367, NULL, NULL, 44897),
(44898, '3.30.450.70-FF-000009', NULL, 'Trafficking protein particle complex 4', 107, NULL, NULL, 44898),
(44899, '1.25.40.60-FF-000009', NULL, 'Sly1p', 103, NULL, NULL, 44899),
(44900, '1.25.40.510-FF-000005', NULL, 'Unplaced genomic scaffold supercont2.9, whole genome shotgun sequence', 317, NULL, NULL, 44900),
(44901, '1.10.287.470-FF-000054', NULL, 'RND efflux system membrane fusion protein CmeA', 74, NULL, NULL, 44901),
(44902, '1.10.10.10-FF-000919', NULL, 'DNA-binding response regulator', 106, NULL, NULL, 44902),
(44903, '2.60.40.4100-FF-000024', NULL, 'Uncharacterized protein', 118, NULL, NULL, 44903),
(44904, '3.80.10.10-FF-003565', NULL, 'leucine-rich repeat transmembrane neuronal protein 1-like', 146, NULL, NULL, 44904),
(44905, '1.10.3720.10-FF-000024', NULL, 'Glutathione ABC transporter permease GsiC', 214, NULL, NULL, 44905),
(44906, '3.40.50.1820-FF-000653', NULL, 'Protein CBG25340', 215, NULL, NULL, 44906);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(44907, '3.90.1290.10-FF-000043', NULL, 'Uncharacterized protein', 170, NULL, NULL, 44907),
(44908, '3.90.530.10-FF-000001', NULL, 'DNA repair protein complementing XP-A cells', 111, NULL, NULL, 44908),
(44909, '1.10.420.10-FF-000013', NULL, 'Peroxidase', 146, NULL, NULL, 44909),
(44910, '3.30.1440.10-FF-000013', NULL, '60S ribosomal protein L11-1', 76, NULL, NULL, 44910),
(44911, '1.10.220.160-FF-000006', NULL, 'Blast:Chromosome-associated kinesin KIF4A', 90, NULL, NULL, 44911),
(44912, '1.25.40.660-FF-000022', NULL, 'Vacuolar protein sorting-associated protein 35', 252, NULL, NULL, 44912),
(44913, '1.25.10.10-FF-000246', NULL, 'Transportin MOS14', 929, NULL, NULL, 44913),
(44914, '2.70.20.10-FF-000011', NULL, 'DNA topoisomerase 1A', 169, NULL, NULL, 44914),
(44915, '1.25.40.20-FF-000644', NULL, 'Ankyrin repeat family protein', 87, NULL, NULL, 44915),
(44916, '3.30.70.1050-FF-000003', NULL, 'Trigger factor', 116, NULL, NULL, 44916),
(44917, '3.40.50.720-FF-000588', NULL, 'Putative ubiquitin activating enzyme', 231, NULL, NULL, 44917),
(44918, '1.20.1070.10-FF-000308', NULL, 'Uncharacterized protein', 353, NULL, NULL, 44918),
(44919, '3.40.50.1820-FF-001693', NULL, 'Predicted protein', 196, NULL, NULL, 44919),
(44920, '3.30.70.1070-FF-000009', NULL, 'DedD protein', 72, NULL, NULL, 44920),
(44921, '2.60.40.2830-FF-000002', NULL, 'Autophagy-related protein 34', 106, NULL, NULL, 44921),
(44922, '1.20.1070.10-FF-000668', NULL, 'Olfactory receptor 587, pseudogene 1', 158, NULL, NULL, 44922),
(44923, '2.60.40.10-FF-005711', NULL, NULL, 46, NULL, NULL, 44923),
(44924, '3.30.1390.20-FF-000017', NULL, '60S ribosomal protein L7, putative', 55, NULL, NULL, 44924),
(44925, '3.40.50.720-FF-000184', NULL, 'Probable GDP-L-fucose synthase', 213, NULL, NULL, 44925),
(44926, '1.50.10.100-FF-000006', NULL, 'Xanthan lyase', 361, NULL, NULL, 44926),
(44927, '3.40.449.10-FF-000008', NULL, 'D111/G-patch domain-containing protein', 136, NULL, NULL, 44927),
(44928, '4.10.400.10-FF-000242', NULL, 'CBN-MIG-13 protein', 42, NULL, NULL, 44928),
(44929, '2.40.240.100-FF-000002', NULL, 'Glutamate--tRNA ligase', 55, NULL, NULL, 44929),
(44930, '3.30.200.20-FF-002213', NULL, NULL, 45, NULL, NULL, 44930),
(44931, '3.30.1330.50-FF-000005', NULL, 'Bifunctional enzyme IspD/IspF', 160, NULL, NULL, 44931),
(44932, '2.160.20.10-FF-000074', NULL, 'Poly(Beta-D-mannuronate) C5 epimerase', 424, NULL, NULL, 44932),
(44933, '3.60.40.10-FF-000297', NULL, 'Uncharacterized protein', 145, NULL, NULL, 44933),
(44934, '1.25.40.10-FF-003833', NULL, 'Uncharacterized protein', 124, NULL, NULL, 44934),
(44935, '3.40.50.620-FF-000772', NULL, '7-cyano-7-deazaguanine synthase', 110, NULL, NULL, 44935),
(44936, '3.40.50.1010-FF-000056', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 183, NULL, NULL, 44936),
(44937, '3.40.50.12710-FF-000024', NULL, 'Protein arginine methyltransferase NDUFAF7', 373, NULL, NULL, 44937),
(44938, '1.10.10.60-FF-000569', NULL, 'telomere repeats-binding bouquet formation protein 1', 48, NULL, NULL, 44938),
(44939, '3.40.50.12350-FF-000012', NULL, 'Eyes absent homolog', 205, NULL, NULL, 44939),
(44940, '3.90.76.10-FF-000041', NULL, 'Oligopeptide transport system binding protein', 121, NULL, NULL, 44940),
(44941, '1.10.260.30-FF-000017', NULL, 'Uncharacterized protein', 120, NULL, NULL, 44941),
(44942, '2.160.20.70-FF-000013', NULL, 'Probable septum site-determining protein MinC', 130, NULL, NULL, 44942),
(44943, '3.30.70.330-FF-002400', NULL, NULL, 158, NULL, NULL, 44943),
(44944, '3.40.50.1000-FF-000519', NULL, 'Cation-transporting ATPase (P-type)', 139, NULL, NULL, 44944),
(44945, '2.130.10.10-FF-002025', NULL, 'Uncharacterized protein', 71, NULL, NULL, 44945),
(44946, '3.40.50.720-FF-001544', NULL, 'Putative short-chain dehydrogenase/reductase, SDR family', 261, NULL, NULL, 44946),
(44947, '3.30.70.520-FF-000001', NULL, 'Formylmethanofuran--tetrahydromethanopterin formyltransferase', 146, NULL, NULL, 44947),
(44948, '3.10.20.90-FF-000445', NULL, 'Ubiquitin family protein', 96, NULL, NULL, 44948);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(44949, '3.40.390.10-FF-000254', NULL, NULL, 241, NULL, NULL, 44949),
(44950, '1.10.340.30-FF-000018', NULL, 'Os07g0657600 protein', 126, NULL, NULL, 44950),
(44951, '2.10.25.10-FF-000822', NULL, 'Transmembrane matrix receptor MUP-4', 40, NULL, NULL, 44951),
(44952, '3.40.50.150-FF-000260', NULL, 'RNA methylase family protein', 219, NULL, NULL, 44952),
(44953, '2.60.40.1730-FF-000066', NULL, NULL, 204, NULL, NULL, 44953),
(44954, '3.10.580.10-FF-000213', NULL, 'Chloride channel protein', 150, NULL, NULL, 44954),
(44955, '3.40.630.30-FF-000476', NULL, 'Uncharacterized protein', 156, NULL, NULL, 44955),
(44956, '3.30.160.60-FF-002081', NULL, 'Zinc finger protein 1060', 32, NULL, NULL, 44956),
(44957, '1.20.1560.10-FF-000104', NULL, 'ABC transporter ATP-binding protein/permease', 317, NULL, NULL, 44957),
(44958, '3.30.160.60-FF-003278', NULL, NULL, 28, NULL, NULL, 44958),
(44959, '3.90.550.10-FF-000435', NULL, 'Uncharacterized protein', 166, NULL, NULL, 44959),
(44960, '1.25.10.10-FF-003101', NULL, 'AGAP002100-PA', 222, NULL, NULL, 44960),
(44961, '1.10.238.10-FF-000730', NULL, 'Centrin, putative', 85, NULL, NULL, 44961),
(44962, '1.20.1310.10-FF-000024', NULL, 'Cullin-4 like', 112, NULL, NULL, 44962),
(44963, '2.130.10.10-FF-003986', NULL, 'Uncharacterized protein', 232, NULL, NULL, 44963),
(44964, '3.90.190.10-FF-000452', NULL, 'Uncharacterized protein', 234, NULL, NULL, 44964),
(44965, '3.20.20.70-FF-000118', NULL, 'Alpha-galactosidase', 323, NULL, NULL, 44965),
(44966, '1.10.510.10-FF-000363', NULL, 'Striated muscle preferentially expressed protein kinase', 218, NULL, NULL, 44966),
(44967, '1.20.1640.10-FF-000105', NULL, NULL, 180, NULL, NULL, 44967),
(44968, '1.20.58.1120-FF-000044', NULL, NULL, 170, NULL, NULL, 44968),
(44969, '3.40.850.10-FF-000385', NULL, 'Kinesin-like protein', 311, NULL, NULL, 44969),
(44970, '3.40.190.10-FF-000385', NULL, 'LysR family transcriptional regulator', 89, NULL, NULL, 44970),
(44971, '1.20.1250.20-FF-000735', NULL, 'Putative sugar transporter', 196, NULL, NULL, 44971),
(44972, '2.60.40.60-FF-000589', NULL, 'Protocadherin 1 gamma 1', 109, NULL, NULL, 44972),
(44973, '3.20.20.300-FF-000051', NULL, 'Glycoside hydrolase family 3 domain protein', 322, NULL, NULL, 44973),
(44974, '3.40.50.11320-FF-000006', NULL, 'Carboxypeptidase', 95, NULL, NULL, 44974),
(44975, '6.10.140.2150-FF-000013', NULL, 'Sphingosine Phosphate Lyase', 42, NULL, NULL, 44975),
(44976, '1.10.555.10-FF-000101', NULL, 'Oligophrenin 1', 57, NULL, NULL, 44976),
(44977, '2.130.10.10-FF-005982', NULL, 'Uncharacterized protein', 232, NULL, NULL, 44977),
(44978, '2.60.40.1530-FF-000011', NULL, 'Integrin subunit alpha 1', 184, NULL, NULL, 44978),
(44979, '2.40.10.10-FF-000085', NULL, 'Prothrombin', 139, NULL, NULL, 44979),
(44980, '3.90.1210.10-FF-000004', NULL, 'Flagella basal body P-ring formation protein FlgA', 62, NULL, NULL, 44980),
(44981, '3.90.1280.20-FF-000006', NULL, 'Chloride channel protein', 63, NULL, NULL, 44981),
(44982, '1.10.510.10-FF-002780', NULL, 'Uncharacterized protein', 312, NULL, NULL, 44982),
(44983, '4.10.240.10-FF-000027', NULL, 'Specific RNA polymerase II transcription factor', 65, NULL, NULL, 44983),
(44984, '1.25.40.10-FF-000023', NULL, 'Pre-mRNA-splicing factor SYF1', 167, NULL, NULL, 44984),
(44985, '3.40.980.10-FF-000046', NULL, 'Molybdopterin molybdenumtransferase', 143, NULL, NULL, 44985),
(44986, '1.20.1250.20-FF-001551', NULL, 'Uncharacterized protein', 410, NULL, NULL, 44986),
(44987, '3.40.50.300-FF-007494', NULL, 'ATP-dependent RNA helicase RhlE', 226, NULL, NULL, 44987),
(44988, '1.10.238.10-FF-001168', NULL, 'Uncharacterized protein', 193, NULL, NULL, 44988),
(44989, '1.10.10.10-FF-000066', NULL, 'ETS-related transcription factor Elf-2 isoform X1', 141, NULL, NULL, 44989),
(44990, '3.40.1110.10-FF-000194', NULL, 'Ca ion P-type ATPase', 203, NULL, NULL, 44990),
(44991, '3.40.190.10-FF-000205', NULL, 'Membrane-bound lytic murein transglycosylase F', 123, NULL, NULL, 44991),
(44992, '3.30.70.330-FF-002580', NULL, NULL, 138, NULL, NULL, 44992),
(44993, '3.40.50.2000-FF-000639', NULL, 'Os02g0242900 protein', 117, NULL, NULL, 44993);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(44994, '1.20.1050.60-FF-000007', NULL, 'Glycosyl hydrolase', 100, NULL, NULL, 44994),
(44995, '1.10.2000.10-FF-000054', NULL, NULL, 135, NULL, NULL, 44995),
(44996, '1.20.120.520-FF-000005', NULL, 'Iron-sulfur cluster repair protein DnrN', 144, NULL, NULL, 44996),
(44997, '1.25.40.10-FF-001304', NULL, 'Pentatricopeptide repeat-containing protein At5g15300', 76, NULL, NULL, 44997),
(44998, '1.20.5.170-FF-000160', NULL, 'C/EBP (CCAAT/enhancer-binding protein) homolog', 71, NULL, NULL, 44998),
(44999, '3.40.630.10-FF-000470', NULL, 'Uncharacterized protein', 71, NULL, NULL, 44999),
(45000, '2.60.40.10-FF-001092', NULL, 'Sodium channel subunit beta-2', 124, NULL, NULL, 45000),
(45001, '3.10.250.10-FF-000071', NULL, NULL, 110, NULL, NULL, 45001),
(45002, '2.60.120.10-FF-000487', NULL, 'Uncharacterized protein', 114, NULL, NULL, 45002),
(45003, '3.30.200.20-FF-000639', NULL, 'Serine/threonine-protein kinase BUD32', 72, NULL, NULL, 45003),
(45004, '3.40.50.2300-FF-000578', NULL, 'Uncharacterized protein', 135, NULL, NULL, 45004),
(45005, '3.30.160.810-FF-000001', NULL, '50S ribosomal protein L3', 65, NULL, NULL, 45005),
(45006, '3.30.230.10-FF-000138', NULL, 'DNA mismatch repair protein MutL', 118, NULL, NULL, 45006),
(45007, '2.60.40.60-FF-000409', NULL, 'DE-cadherin', 103, NULL, NULL, 45007),
(45008, '1.10.418.10-FF-000148', NULL, 'Alpha-parvin', 122, NULL, NULL, 45008),
(45009, '3.30.470.20-FF-000018', NULL, 'Trifunctional purine biosynthetic protein adenosine-3', 137, NULL, NULL, 45009),
(45010, '3.30.50.10-FF-000006', NULL, 'Nuclear receptor subfamily 5 group A member', 107, NULL, NULL, 45010),
(45011, '3.60.130.10-FF-000039', NULL, 'Os01g0190000 protein', 218, NULL, NULL, 45011),
(45012, '4.10.860.20-FF-000004', NULL, 'PKHD-type hydroxylase RPA3479', 48, NULL, NULL, 45012),
(45013, '2.30.30.140-FF-000326', NULL, 'Uncharacterized protein', 26, NULL, NULL, 45013),
(45014, '3.30.710.10-FF-000169', NULL, 'BTB/POZ domain-containing protein 2', 155, NULL, NULL, 45014),
(45015, '1.20.90.10-FF-000025', NULL, NULL, 117, NULL, NULL, 45015),
(45016, '3.30.70.330-FF-001152', NULL, 'Glycine-rich rna-binding protein', 113, NULL, NULL, 45016),
(45017, '3.20.20.150-FF-000045', NULL, 'Predicted protein', 332, NULL, NULL, 45017),
(45018, '1.25.40.10-FF-003333', NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', 98, NULL, NULL, 45018),
(45019, '1.10.760.10-FF-000022', NULL, 'Cytochrome c4', 97, NULL, NULL, 45019),
(45020, '2.130.10.10-FF-001648', NULL, 'Uncharacterized protein, isoform B', 86, NULL, NULL, 45020),
(45021, '3.40.190.80-FF-000006', NULL, 'Bisphosphate nucleotidase 1', 128, NULL, NULL, 45021),
(45022, '3.30.160.60-FF-000113', NULL, 'zinc finger protein 699 isoform X1', 28, NULL, NULL, 45022),
(45023, '2.130.10.10-FF-004054', NULL, 'Uncharacterized protein', 213, NULL, NULL, 45023),
(45024, '2.60.120.10-FF-000436', NULL, 'Cyclic nucleotide-gated channel 12', 113, NULL, NULL, 45024),
(45025, '2.40.40.20-FF-000027', NULL, 'Sec18p', 81, NULL, NULL, 45025),
(45026, '3.80.10.10-FF-001148', NULL, 'Si:dkey-286j17.4', 127, NULL, NULL, 45026),
(45027, '2.20.28.10-FF-000042', NULL, 'DNA helicase', 63, NULL, NULL, 45027),
(45028, '3.40.50.300-FF-005465', NULL, 'DNA helicase', 225, NULL, NULL, 45028),
(45029, '3.90.1150.10-FF-000112', NULL, 'Cystathionine gamma-lyase, putative', 136, NULL, NULL, 45029),
(45030, '3.30.470.20-FF-000069', NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', 189, NULL, NULL, 45030),
(45031, '3.40.50.200-FF-000022', NULL, 'Extracellular protease', 334, NULL, NULL, 45031),
(45032, '3.30.200.20-FF-001196', NULL, 'Alpha-protein kinase 1', 71, NULL, NULL, 45032),
(45033, '2.20.25.10-FF-000001', NULL, 'Probable Transcription elongation factor S-II', 72, NULL, NULL, 45033),
(45034, '1.10.418.70-FF-000008', NULL, 'Uncharacterized protein', 123, NULL, NULL, 45034),
(45035, '3.30.2410.10-FF-000039', NULL, 'E3 ubiquitin-protein ligase HACE1', 78, NULL, NULL, 45035),
(45036, '3.40.50.300-FF-007314', NULL, 'Uncharacterized protein', 147, NULL, NULL, 45036),
(45037, '2.60.40.150-FF-000212', NULL, 'Synaptotagmin like 1', 85, NULL, NULL, 45037);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(45038, '2.60.40.150-FF-000504', NULL, 'Uncharacterized protein', 118, NULL, NULL, 45038),
(45039, '3.30.160.60-FF-006212', NULL, NULL, 28, NULL, NULL, 45039),
(45040, '1.25.40.570-FF-000028', NULL, 'Eukaryotic translation initiation factor 3 subunit E', 151, NULL, NULL, 45040),
(45041, '2.60.40.3510-FF-000015', NULL, 'Delta-like protein', 164, NULL, NULL, 45041),
(45042, '3.40.640.10-FF-000408', NULL, 'Uncharacterized protein', 130, NULL, NULL, 45042),
(45043, '1.25.40.770-FF-000004', NULL, 'transcription initiation factor TFIID subunit 6', 206, NULL, NULL, 45043),
(45044, '2.40.50.140-FF-000497', NULL, 'Aspartyl-tRNA synthetase, putative', 128, NULL, NULL, 45044),
(45045, '1.25.40.10-FF-001484', NULL, 'Pentatricopeptide repeat-containing protein', 117, NULL, NULL, 45045),
(45046, '1.20.120.1130-FF-000004', NULL, 'Vacuolar protein sorting-associated protein 28', 97, NULL, NULL, 45046),
(45047, '3.40.50.12780-FF-000135', NULL, 'Nonribosomal peptide synthetase, discrete adenylation domain', 400, NULL, NULL, 45047),
(45048, '3.90.70.10-FF-000106', NULL, 'Ubiquitin carboxyl-terminal hydrolase 35', 270, NULL, NULL, 45048),
(45049, '3.40.225.10-FF-000051', NULL, NULL, 221, NULL, NULL, 45049),
(45050, '3.40.630.30-FF-000560', NULL, 'Putative acetyltransferase', 125, NULL, NULL, 45050),
(45051, '3.30.1140.60-FF-000022', NULL, 'F-actin-capping protein subunit alpha', 88, NULL, NULL, 45051),
(45052, '2.30.30.140-FF-000034', NULL, 'Histone-lysine N-methyltransferase', 64, NULL, NULL, 45052),
(45053, '3.30.160.20-FF-000208', NULL, 'A-to-I RNA editing regulator adr-1', 84, NULL, NULL, 45053),
(45054, '3.30.160.60-FF-002901', NULL, 'Zinc finger protein 564', 34, NULL, NULL, 45054),
(45055, '1.25.40.10-FF-000074', NULL, 'ER membrane protein complex subunit 2', 280, NULL, NULL, 45055),
(45056, '3.40.50.2300-FF-001146', NULL, NULL, 70, NULL, NULL, 45056),
(45057, '3.40.50.300-FF-008219', NULL, 'Uncharacterized protein', 65, NULL, NULL, 45057),
(45058, '2.60.120.10-FF-000728', NULL, 'Uncharacterized protein', 133, NULL, NULL, 45058),
(45059, '1.20.1070.10-FF-001365', NULL, 'Predicted protein', 261, NULL, NULL, 45059),
(45060, '1.10.1450.10-FF-000132', NULL, 'Tetraspanin', 110, NULL, NULL, 45060),
(45061, '3.40.50.720-FF-001044', NULL, 'Ketose-bisphosphate aldolase class-II family protein', 167, NULL, NULL, 45061),
(45062, '1.10.357.110-FF-000013', NULL, 'Vacuolar protein sorting-associated protein 53', 174, NULL, NULL, 45062),
(45063, '2.130.10.10-FF-002929', NULL, 'Uncharacterized protein', 114, NULL, NULL, 45063),
(45064, '3.30.160.60-FF-001833', NULL, NULL, 29, NULL, NULL, 45064),
(45065, '3.80.20.20-FF-000022', NULL, 'Receptor protein-tyrosine kinase', 200, NULL, NULL, 45065),
(45066, '1.20.1300.20-FF-000004', NULL, 'RNA-binding protein 8A', 158, NULL, NULL, 45066),
(45067, '3.40.50.1820-FF-001350', NULL, 'AER322Cp', 242, NULL, NULL, 45067),
(45068, '2.60.9.10-FF-000003', NULL, 'Putative vasopressin-like neuropeptide preprohormone', 89, NULL, NULL, 45068),
(45069, '1.25.40.10-FF-005250', NULL, 'Uncharacterized protein', 164, NULL, NULL, 45069),
(45070, '3.90.1640.10-FF-000020', NULL, 'Uncharacterized protein', 258, NULL, NULL, 45070),
(45071, '3.30.9.10-FF-000147', NULL, 'FAD-binding oxidoreductase', 145, NULL, NULL, 45071),
(45072, '3.40.50.300-FF-003548', NULL, 'Iron-sulfur cluster carrier protein', 261, NULL, NULL, 45072),
(45073, '2.10.25.10-FF-000434', NULL, 'Predicted protein', 38, NULL, NULL, 45073),
(45074, '2.40.70.10-FF-000526', NULL, NULL, 21, NULL, NULL, 45074),
(45075, '3.40.50.11530-FF-000002', NULL, 'Interleukin 17 receptor A', 169, NULL, NULL, 45075),
(45076, '2.60.40.10-FF-001884', NULL, 'Fc receptor like 4', 81, NULL, NULL, 45076),
(45077, '2.60.40.1080-FF-000005', NULL, 'Intimin', 91, NULL, NULL, 45077),
(45078, '3.30.1370.50-FF-000002', NULL, 'Immunoglobulin mu DNA-binding protein 2', 78, NULL, NULL, 45078),
(45079, '3.40.1810.10-FF-000056', NULL, NULL, 74, NULL, NULL, 45079),
(45080, '1.10.287.70-FF-000282', NULL, 'Calcium channel subunit Cch1', 128, NULL, NULL, 45080),
(45081, '3.20.20.80-FF-000508', NULL, 'Linamarase family protein', 58, NULL, NULL, 45081);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(45082, '3.30.70.1730-FF-000044', NULL, '50S ribosomal protein L10', 113, NULL, NULL, 45082),
(45083, '1.10.630.10-FF-000310', NULL, 'Uncharacterized protein', 119, NULL, NULL, 45083),
(45084, '2.30.42.10-FF-000001', NULL, 'Disks large homolog 1 isoform 2', 119, NULL, NULL, 45084),
(45085, '2.160.20.10-FF-000102', NULL, 'Uncharacterized protein', 191, NULL, NULL, 45085),
(45086, '2.40.50.140-FF-000137', NULL, '28S ribosomal protein S17, mitochondrial', 110, NULL, NULL, 45086),
(45087, '4.10.280.10-FF-000092', NULL, 'transcription factor bHLH68 isoform X1', 54, NULL, NULL, 45087),
(45088, '1.20.58.60-FF-000807', NULL, 'Uncharacterized protein', 202, NULL, NULL, 45088),
(45089, '1.20.120.1750-FF-000033', NULL, 'Ring finger protein, putative', 86, NULL, NULL, 45089),
(45090, '1.10.10.10-FF-001476', NULL, 'Putative helicase mug81', 95, NULL, NULL, 45090),
(45091, '1.10.1420.10-FF-000012', NULL, 'DNA mismatch repair protein MSH4', 172, NULL, NULL, 45091),
(45092, '2.130.10.10-FF-004003', NULL, 'Uncharacterized protein', 227, NULL, NULL, 45092),
(45093, '3.40.50.720-FF-000476', NULL, 'Chromosome 19, whole genome shotgun sequence', 248, NULL, NULL, 45093),
(45094, '3.30.160.60-FF-002322', NULL, 'Homeotic protein spalt-major', 24, NULL, NULL, 45094),
(45095, '1.25.10.10-FF-002163', NULL, 'Uncharacterized protein', 506, NULL, NULL, 45095),
(45096, '1.10.287.1490-FF-000012', NULL, 'intraflagellar transport protein 74 homolog', 173, NULL, NULL, 45096),
(45097, '1.20.1250.20-FF-000174', NULL, 'Sucrose transport protein', 467, NULL, NULL, 45097),
(45098, '2.60.120.620-FF-000093', NULL, 'Uncharacterized protein', 200, NULL, NULL, 45098),
(45099, '3.40.30.10-FF-000746', NULL, 'Iodothyronine deiodinase', 115, NULL, NULL, 45099),
(45100, '3.30.1120.10-FF-000034', NULL, 'Arylsulfatase', 67, NULL, NULL, 45100),
(45101, '1.10.472.10-FF-000318', NULL, 'Cyclin domain-containing protein', 114, NULL, NULL, 45101),
(45102, '3.20.20.190-FF-000158', NULL, NULL, 186, NULL, NULL, 45102),
(45103, '3.30.40.10-FF-001057', NULL, 'Protein CBG07029', 59, NULL, NULL, 45103),
(45104, '2.20.25.30-FF-000007', NULL, 'Ribosomal protein', 31, NULL, NULL, 45104),
(45105, '3.40.50.300-FF-005757', NULL, 'Dynein heavy chain', 125, NULL, NULL, 45105),
(45106, '3.30.1370.70-FF-000008', NULL, NULL, 58, NULL, NULL, 45106),
(45107, '3.40.50.2300-FF-001067', NULL, NULL, 86, NULL, NULL, 45107),
(45108, '1.25.10.10-FF-002988', NULL, 'Uncharacterized protein', 374, NULL, NULL, 45108),
(45109, '1.10.238.10-FF-000651', NULL, 'Centrin-related-protein,putative', 79, NULL, NULL, 45109),
(45110, '1.10.10.830-FF-000009', NULL, 'Isoleucyl-tRNA synthetase', 53, NULL, NULL, 45110),
(45111, '2.60.120.380-FF-000032', NULL, 'Zgc:162184', 154, NULL, NULL, 45111),
(45112, '3.30.160.60-FF-005756', NULL, NULL, 38, NULL, NULL, 45112),
(45113, '2.60.40.10-FF-003733', NULL, NULL, 86, NULL, NULL, 45113),
(45114, '3.40.50.1700-FF-000050', NULL, 'Glycoside hydrolase family 3 domain protein', 79, NULL, NULL, 45114),
(45115, '3.30.160.60-FF-004346', NULL, NULL, 35, NULL, NULL, 45115),
(45116, '1.10.10.10-FF-000015', NULL, 'Leucine-responsive transcriptional regulator Lrp', 65, NULL, NULL, 45116),
(45117, '2.30.29.30-FF-000583', NULL, 'Protein CBG09025', 133, NULL, NULL, 45117),
(45118, '3.20.20.80-FF-000559', NULL, 'GH13872p', 108, NULL, NULL, 45118),
(45119, '3.30.160.60-FF-001884', NULL, 'Zinc finger protein 836', 29, NULL, NULL, 45119),
(45120, '3.30.200.20-FF-002505', NULL, 'Uncharacterized protein', 116, NULL, NULL, 45120),
(45121, '1.50.40.10-FF-000335', NULL, 'Mitochondrial carrier domain-containing protein', 258, NULL, NULL, 45121),
(45122, '1.10.238.20-FF-000036', NULL, 'GD25639', 103, NULL, NULL, 45122),
(45123, '2.60.34.20-FF-000012', NULL, NULL, 146, NULL, NULL, 45123),
(45124, '3.30.428.10-FF-000030', NULL, 'Hydrolase, putative', 139, NULL, NULL, 45124),
(45125, '3.40.109.10-FF-000017', NULL, 'Putative NAD(P)H nitroreductase', 219, NULL, NULL, 45125),
(45126, '1.25.40.20-FF-000352', NULL, 'YIL001W-like protein', 104, NULL, NULL, 45126),
(45127, '3.40.50.300-FF-006033', NULL, 'Uncharacterized protein', 198, NULL, NULL, 45127);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(45128, '2.60.120.590-FF-000038', NULL, 'ALKBH3 isoform 7', 155, NULL, NULL, 45128),
(45129, '1.10.510.10-FF-000751', NULL, 'Non-specific serine/threonine protein kinase', 206, NULL, NULL, 45129),
(45130, '2.80.10.50-FF-000010', NULL, 'Fascin', 136, NULL, NULL, 45130),
(45131, '1.10.555.10-FF-000005', NULL, 'Chimaerin', 201, NULL, NULL, 45131),
(45132, '1.10.10.10-FF-000627', NULL, 'MarR family transcriptional regulator', 120, NULL, NULL, 45132),
(45133, '1.10.510.10-FF-000655', NULL, 'serine/threonine-protein kinase 35', 214, NULL, NULL, 45133),
(45134, '3.80.10.10-FF-003273', NULL, 'Uncharacterized protein', 179, NULL, NULL, 45134),
(45135, '1.10.10.2660-FF-000002', NULL, 'Ubiquitin-activating enzyme E1 2', 254, NULL, NULL, 45135),
(45136, '3.80.20.20-FF-000073', NULL, 'Erb-b2 receptor tyrosine kinase 3b', 142, NULL, NULL, 45136),
(45137, '1.10.510.10-FF-003117', NULL, NULL, 191, NULL, NULL, 45137),
(45138, '2.60.120.230-FF-000015', NULL, NULL, 155, NULL, NULL, 45138),
(45139, '2.60.40.10-FF-002373', NULL, 'High Incidence of Males (Increased X chromosome loss)', 86, NULL, NULL, 45139),
(45140, '2.40.240.20-FF-000014', NULL, NULL, 68, NULL, NULL, 45140),
(45141, '1.20.58.100-FF-000009', NULL, 'L-aspartate oxidase', 116, NULL, NULL, 45141),
(45142, '3.40.50.300-FF-001575', NULL, 'Protein translocase subunit SecA 2', 256, NULL, NULL, 45142),
(45143, '1.20.120.310-FF-000009', NULL, 'FAD-linked sulfhydryl oxidase', 103, NULL, NULL, 45143),
(45144, '3.40.140.10-FF-000202', NULL, 'COP9 signalosome complex subunit 6', 185, NULL, NULL, 45144),
(45145, '2.60.34.10-FF-000094', NULL, 'Uncharacterized protein', 185, NULL, NULL, 45145),
(45146, '2.40.160.20-FF-000013', NULL, 'Outer membrane protein OprG', 210, NULL, NULL, 45146),
(45147, '1.10.287.110-FF-000143', NULL, 'Unplaced genomic scaffold supercont2.13, whole genome shotgun sequence', 90, NULL, NULL, 45147),
(45148, '3.40.930.10-FF-000043', NULL, NULL, 148, NULL, NULL, 45148),
(45149, '3.40.1380.20-FF-000065', NULL, 'Pyruvate kinase', 118, NULL, NULL, 45149),
(45150, '3.30.70.980-FF-000037', NULL, 'GD20114', 68, NULL, NULL, 45150),
(45151, '3.40.50.620-FF-000384', NULL, '7-cyano-7-deazaguanine synthase', 229, NULL, NULL, 45151),
(45152, '1.10.630.10-FF-000698', NULL, 'Uncharacterized protein', 136, NULL, NULL, 45152),
(45153, '1.10.472.130-FF-000054', NULL, 'Predicted protein', 147, NULL, NULL, 45153),
(45154, '2.60.120.970-FF-000063', NULL, 'Uncharacterized protein', 273, NULL, NULL, 45154),
(45155, '3.30.160.60-FF-002373', NULL, 'Protein krueppel', 34, NULL, NULL, 45155),
(45156, '3.30.40.100-FF-000015', NULL, 'Uncharacterized protein', 49, NULL, NULL, 45156),
(45157, '3.40.50.300-FF-001362', NULL, 'DNA repair protein recA 1 like', 296, NULL, NULL, 45157),
(45158, '3.40.50.410-FF-000259', NULL, 'Uncharacterized protein', 194, NULL, NULL, 45158),
(45159, '3.30.160.60-FF-005195', NULL, NULL, 44, NULL, NULL, 45159),
(45160, '1.50.10.10-FF-000215', NULL, 'Predicted protein', 130, NULL, NULL, 45160),
(45161, '2.30.30.40-FF-000505', NULL, 'BAR domaincontaining protein', 55, NULL, NULL, 45161),
(45162, '2.120.10.30-FF-000547', NULL, 'Putative oxidoreductase', 346, NULL, NULL, 45162),
(45163, '3.30.830.10-FF-000116', NULL, 'Uncharacterized protein', 225, NULL, NULL, 45163),
(45164, '3.30.70.660-FF-000059', NULL, 'Pseudouridylate synthase 3 (AFU_orthologue AFUA_3G13350)', 264, NULL, NULL, 45164),
(45165, '3.40.30.10-FF-000403', NULL, 'Protein disulfide-isomerase A4', 114, NULL, NULL, 45165),
(45166, '3.30.200.20-FF-001988', NULL, 'Uncharacterized protein', 98, NULL, NULL, 45166),
(45167, '3.40.850.10-FF-000273', NULL, 'Kinesin-like protein', 224, NULL, NULL, 45167),
(45168, '4.10.1060.10-FF-000061', NULL, 'Uncharacterized protein', 44, NULL, NULL, 45168),
(45169, '3.90.1330.10-FF-000002', NULL, 'Extracellular xylan exo-alpha-(1->2)-glucuronosidase', 231, NULL, NULL, 45169),
(45170, '3.30.1330.40-FF-000019', NULL, 'YLR143W-like protein', 141, NULL, NULL, 45170),
(45171, '1.25.40.10-FF-003272', NULL, 'Pentatricopeptide repeat-containing protein At1g10910, chloroplastic', 142, NULL, NULL, 45171);
INSERT INTO "PUBLIC"."MODEL" VALUES
(45172, '1.20.5.110-FF-000069', NULL, 'Related to syntaxin 18', 101, NULL, NULL, 45172),
(45173, '2.60.120.260-FF-000119', NULL, 'Probable beta-glucosidase I', 167, NULL, NULL, 45173),
(45174, '2.40.70.10-FF-000318', NULL, NULL, 178, NULL, NULL, 45174),
(45175, '3.40.50.300-FF-005526', NULL, 'RAB40C, member RAS oncogene family', 105, NULL, NULL, 45175),
(45176, '2.60.40.1090-FF-000042', NULL, 'Long polar fimbrial protein LpfE', 140, NULL, NULL, 45176),
(45177, '3.80.10.10-FF-002508', NULL, 'Uncharacterized protein', 132, NULL, NULL, 45177),
(45178, '2.60.40.10-FF-000327', NULL, 'Cell adhesion associated, oncogene regulated', 93, NULL, NULL, 45178),
(45179, '3.55.40.20-FF-000020', NULL, 'Superoxide dismutase', 117, NULL, NULL, 45179),
(45180, '3.30.450.20-FF-000135', NULL, 'Ptaureo1a lov2 domain', 151, NULL, NULL, 45180),
(45181, '1.25.40.10-FF-000135', NULL, 'intraflagellar transport protein 88 homolog isoform X1', 212, NULL, NULL, 45181),
(45182, '3.30.40.10-FF-000629', NULL, 'RING finger domain protein, putative', 89, NULL, NULL, 45182),
(45183, '3.40.630.10-FF-000110', NULL, 'Acetylornithine deacetylase', 208, NULL, NULL, 45183),
(45184, '1.20.58.90-FF-000007', NULL, 'E3 ubiquitin-protein ligase ipaH9.8', 78, NULL, NULL, 45184),
(45185, '1.20.1260.100-FF-000007', NULL, NULL, 157, NULL, NULL, 45185),
(45186, '1.20.1250.20-FF-000915', NULL, 'Similar to MFS multidrug transporter', 430, NULL, NULL, 45186),
(45187, '2.10.50.10-FF-000043', NULL, 'Tumor necrosis factor receptor superfamily member 5', 53, NULL, NULL, 45187),
(45188, '3.40.50.1000-FF-000407', NULL, 'Os02g0790500 protein', 81, NULL, NULL, 45188),
(45189, '1.10.555.10-FF-000213', NULL, NULL, 67, NULL, NULL, 45189),
(45190, '3.30.70.330-FF-001231', NULL, 'RNA-binding domain-containing protein', 112, NULL, NULL, 45190),
(45191, '1.25.40.70-FF-000046', NULL, 'Phosphatidylinositol 4-kinase (STT4), putative', 106, NULL, NULL, 45191),
(45192, '3.40.50.1100-FF-000027', NULL, 'Threonine synthase', 226, NULL, NULL, 45192),
(45193, '2.30.40.10-FF-000047', NULL, 'Amidohydrolase', 70, NULL, NULL, 45193),
(45194, '3.40.50.1820-FF-001142', NULL, 'Uncharacterized protein', 64, NULL, NULL, 45194),
(45195, '3.30.1370.10-FF-000018', NULL, 'vigilin isoform X1', 79, NULL, NULL, 45195),
(45196, '3.40.630.30-FF-000116', NULL, 'Putative N-acetyltransferase HLS1', 132, NULL, NULL, 45196),
(45197, '3.30.420.10-FF-000681', NULL, NULL, 160, NULL, NULL, 45197),
(45198, '1.10.10.350-FF-000028', NULL, NULL, 78, NULL, NULL, 45198),
(45199, '3.40.50.300-FF-001311', NULL, 'Dynamin-like protein-related', 305, NULL, NULL, 45199),
(45200, '1.10.533.10-FF-000056', NULL, 'NACHT, LRR and PYD domains-containing protein 14', 95, NULL, NULL, 45200),
(45201, '2.40.50.730-FF-000011', NULL, 'DNA polymerase', 95, NULL, NULL, 45201),
(45202, '3.80.10.10-FF-000367', NULL, 'Putative leucine-rich repeat receptor-like protein kinase', 191, NULL, NULL, 45202),
(45203, '3.10.50.40-FF-000044', NULL, 'Peptidylprolyl isomerase', 119, NULL, NULL, 45203),
(45204, '2.130.10.10-FF-000400', NULL, 'Elongator acetyltransferase complex subunit 2', 305, NULL, NULL, 45204),
(45205, '3.30.2410.10-FF-000011', NULL, 'Putative Ubiquitin-protein ligase E3C', 113, NULL, NULL, 45205),
(45206, '2.60.40.1230-FF-000011', NULL, 'ADP-ribosylation factor-binding protein GGA2', 123, NULL, NULL, 45206),
(45207, '2.60.40.10-FF-001316', NULL, 'PKHD1 like 1', 89, NULL, NULL, 45207),
(45208, '3.40.720.10-FF-000229', NULL, 'Iduronate 2-sulfatase (Hunter syndrome), isoform CRA_e', 386, NULL, NULL, 45208),
(45209, '3.30.40.10-FF-001580', NULL, 'Putative RING-H2 finger protein ATL62', 87, NULL, NULL, 45209),
(45210, '1.20.1300.10-FF-000018', NULL, 'Fumarate reductase subunit C', 127, NULL, NULL, 45210),
(45211, '3.30.40.10-FF-000152', NULL, 'E3 ubiquitin-protein ligase Praja-1 isoform X1', 87, NULL, NULL, 45211),
(45212, '1.20.1250.20-FF-001371', NULL, 'Major facilitator superfamily domain-containing protein 12-like Protein', 196, NULL, NULL, 45212),
(45213, '3.10.590.10-FF-000006', NULL, 'Chromosome 7, whole genome shotgun sequence', 165, NULL, NULL, 45213); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(45214, '1.20.1110.10-FF-000256', NULL, NULL, 109, NULL, NULL, 45214),
(45215, '2.10.50.30-FF-000049', NULL, 'Uncharacterized protein', 57, NULL, NULL, 45215),
(45216, '2.30.29.30-FF-000662', NULL, 'GD19751', 103, NULL, NULL, 45216),
(45217, '3.90.79.10-FF-000255', NULL, 'Diphosphoinositol polyphosphate phosphohydrolase aps1', 138, NULL, NULL, 45217),
(45218, '3.40.50.300-FF-002300', NULL, 'ABC transporter G family protein', 261, NULL, NULL, 45218),
(45219, '1.10.418.10-FF-000036', NULL, 'Actinin alpha 1', 116, NULL, NULL, 45219),
(45220, '3.20.110.10-FF-000036', NULL, 'Alpha-mannosidase E', 231, NULL, NULL, 45220),
(45221, '1.10.510.10-FF-000863', NULL, 'Muscle M-line assembly protein unc-89', 302, NULL, NULL, 45221),
(45222, '1.50.40.10-FF-000043', NULL, 'mitochondrial dicarboxylate carrier isoform X2', 277, NULL, NULL, 45222),
(45223, '3.90.1720.10-FF-000021', NULL, 'Guanylate cyclase', 212, NULL, NULL, 45223),
(45224, '1.10.287.80-FF-000010', NULL, 'ATP synthase gamma chain', 100, NULL, NULL, 45224),
(45225, '3.20.20.140-FF-000216', NULL, 'AMP deaminase', 235, NULL, NULL, 45225),
(45226, '1.25.40.10-FF-003749', NULL, 'Pentatricopeptide repeat-containing protein At3g18110, chloroplastic', 165, NULL, NULL, 45226),
(45227, '3.60.21.10-FF-000045', NULL, 'Sphingomyelin phosphodiesterase', 285, NULL, NULL, 45227),
(45228, '3.30.160.60-FF-004138', NULL, NULL, 33, NULL, NULL, 45228),
(45229, '3.30.70.2580-FF-000001', NULL, 'tRNA (guanine(37)-N1)-methyltransferase Trm5b', 64, NULL, NULL, 45229),
(45230, '3.30.70.3290-FF-000006', NULL, 'GD23207', 98, NULL, NULL, 45230),
(45231, '3.40.710.10-FF-000111', NULL, 'Penicillin-binding protein 1C', 353, NULL, NULL, 45231),
(45232, '1.25.10.10-FF-002084', NULL, 'Uncharacterized protein', 105, NULL, NULL, 45232),
(45233, '1.20.930.40-FF-000002', NULL, 'Transferrin receptor protein 1', 142, NULL, NULL, 45233),
(45234, '4.10.1080.10-FF-000005', NULL, 'Thrombospondin type 3 repeat', 83, NULL, NULL, 45234),
(45235, '1.20.1070.10-FF-000752', NULL, 'Predicted protein', 301, NULL, NULL, 45235),
(45236, '1.25.40.470-FF-000004', NULL, 'WD repeat-containing protein 35', 208, NULL, NULL, 45236),
(45237, '1.10.238.10-FF-000679', NULL, 'Serine/threonine-protein phosphatase', 154, NULL, NULL, 45237),
(45238, '2.60.220.50-FF-000129', NULL, 'G-protein coupled receptor 126-like Protein', 177, NULL, NULL, 45238),
(45239, '2.40.100.10-FF-000147', NULL, 'AAR045Cp', 176, NULL, NULL, 45239),
(45240, '2.170.150.10-FF-000018', NULL, 'Guanine nucleotide exchange factor', 136, NULL, NULL, 45240),
(45241, '3.40.120.10-FF-000083', NULL, 'Phosphohexomutase (Phosphoglucomutase / phosphomannomutase)', 138, NULL, NULL, 45241),
(45242, '1.20.1250.20-FF-002040', NULL, 'Solute carrier family 43 member 1', 320, NULL, NULL, 45242),
(45243, '1.25.10.10-FF-003444', NULL, 'Uncharacterized protein', 232, NULL, NULL, 45243),
(45244, '1.20.5.340-FF-000020', NULL, 'polycystin-2 isoform X1', 64, NULL, NULL, 45244),
(45245, '3.50.7.10-FF-000053', NULL, NULL, 188, NULL, NULL, 45245),
(45246, '1.20.930.60-FF-000008', NULL, 'GD25149', 120, NULL, NULL, 45246),
(45247, '3.30.70.1470-FF-000005', NULL, 'Uncharacterized protein', 90, NULL, NULL, 45247),
(45248, '2.60.120.200-FF-000591', NULL, 'Predicted protein', 161, NULL, NULL, 45248),
(45249, '3.30.70.1020-FF-000011', NULL, NULL, 81, NULL, NULL, 45249),
(45250, '1.10.150.530-FF-000005', NULL, 'Radical SAM superfamily protein', 64, NULL, NULL, 45250),
(45251, '3.40.50.300-FF-006533', NULL, 'Si:dkey-79f11.7', 108, NULL, NULL, 45251),
(45252, '1.20.1530.20-FF-000105', NULL, 'Uncharacterized protein', 118, NULL, NULL, 45252),
(45253, '3.20.19.10-FF-000013', NULL, 'Aconitate hydratase', 144, NULL, NULL, 45253),
(45254, '3.40.50.620-FF-000204', NULL, 'Probable electron transfer flavoprotein beta chain', 263, NULL, NULL, 45254),
(45255, '3.40.50.2000-FF-000718', NULL, 'Glycosyl transferase family 9', 157, NULL, NULL, 45255),
(45256, '1.10.1580.10-FF-000001', NULL, 'Nucleolar GTP-binding protein 2', 91, NULL, NULL, 45256),
(45257, '1.20.920.20-FF-000018', NULL, 'Dynein heavy chain 2', 339, NULL, NULL, 45257);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(45258, '3.30.1330.20-FF-000013', NULL, 'Tubulin gamma chain', 109, NULL, NULL, 45258),
(45259, '2.60.200.30-FF-000027', NULL, 'NAD kinase 2, mitochondrial', 103, NULL, NULL, 45259),
(45260, '6.20.50.160-FF-000008', NULL, 'Complement component C5', 63, NULL, NULL, 45260),
(45261, '3.30.70.330-FF-002220', NULL, NULL, 112, NULL, NULL, 45261),
(45262, '1.50.10.10-FF-000007', NULL, 'Phosphorylase b kinase regulatory subunit', 298, NULL, NULL, 45262),
(45263, '2.70.150.10-FF-000211', NULL, 'Copper-transporting ATPase 2', 123, NULL, NULL, 45263),
(45264, '2.30.30.490-FF-000055', NULL, 'Polybromo 1', 150, NULL, NULL, 45264),
(45265, '3.30.200.20-FF-000999', NULL, 'Protein phosphatase 2C and cyclic nucleotide-binding/kinase domain-containing protein', 88, NULL, NULL, 45265),
(45266, '3.30.200.60-FF-000011', NULL, 'OTU deubiquitinase, ubiquitin aldehyde-binding 1a', 64, NULL, NULL, 45266),
(45267, '1.10.8.10-FF-000036', NULL, 'Toll-interacting protein-like Protein', 52, NULL, NULL, 45267),
(45268, '3.40.850.10-FF-000121', NULL, 'Myosin B', 229, NULL, NULL, 45268),
(45269, '3.30.160.60-FF-003839', NULL, NULL, 36, NULL, NULL, 45269),
(45270, '1.10.510.10-FF-004174', NULL, NULL, 169, NULL, NULL, 45270),
(45271, '2.130.10.10-FF-005335', NULL, 'Uncharacterized protein', 186, NULL, NULL, 45271),
(45272, '2.10.25.10-FF-000322', NULL, 'Integrin beta', 42, NULL, NULL, 45272),
(45273, '3.40.50.12650-FF-000012', NULL, 'DNA repair metallo-beta-lactamase, putative', 134, NULL, NULL, 45273),
(45274, '3.30.190.20-FF-000036', NULL, '39S ribosomal protein L1, mitochondrial isoform X1', 99, NULL, NULL, 45274),
(45275, '3.80.10.10-FF-003352', NULL, 'Si:zfos-323e3.4', 115, NULL, NULL, 45275),
(45276, '3.30.200.20-FF-001724', NULL, 'Receptor protein kinase TMK1', 110, NULL, NULL, 45276),
(45277, '3.30.200.20-FF-001836', NULL, 'Putative leucine-rich repeat receptor-like protein kinase', 110, NULL, NULL, 45277),
(45278, '3.30.70.330-FF-003029', NULL, NULL, 55, NULL, NULL, 45278),
(45279, '2.30.30.940-FF-000010', NULL, 'ATP-dependent RecD-like DNA helicase', 75, NULL, NULL, 45279),
(45280, '4.10.520.10-FF-000009', NULL, 'Nucleoid DNA-binding protein', 98, NULL, NULL, 45280),
(45281, '1.25.40.10-FF-005306', NULL, 'Uncharacterized protein', 127, NULL, NULL, 45281),
(45282, '3.20.20.300-FF-000079', NULL, NULL, 227, NULL, NULL, 45282),
(45283, '3.30.450.40-FF-000293', NULL, 'PAS sensor protein', 195, NULL, NULL, 45283),
(45284, '3.40.50.620-FF-000833', NULL, 'Uncharacterized protein', 72, NULL, NULL, 45284),
(45285, '1.10.10.160-FF-000005', NULL, 'DNA helicase', 75, NULL, NULL, 45285),
(45286, '3.30.160.60-FF-001653', NULL, 'Zinc finger and BTB domain containing 7C', 28, NULL, NULL, 45286),
(45287, '2.60.40.150-FF-000443', NULL, 'Protein-transporting protein', 137, NULL, NULL, 45287),
(45288, '3.40.50.300-FF-007943', NULL, 'DNA helicase', 171, NULL, NULL, 45288),
(45289, '1.20.1250.20-FF-000123', NULL, 'Tricarballylate/proton symporter TcuC', 189, NULL, NULL, 45289),
(45290, '3.30.40.10-FF-001349', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 100, NULL, NULL, 45290),
(45291, '1.10.1370.30-FF-000025', NULL, 'Angiotensin-converting enzyme', 229, NULL, NULL, 45291),
(45292, '3.30.450.20-FF-000399', NULL, 'Aryl hydrocarbon receptor type 1', 118, NULL, NULL, 45292),
(45293, '3.40.50.10490-FF-000038', NULL, 'Fructoselysine 6-phosphate deglycase', 157, NULL, NULL, 45293),
(45294, '3.40.50.1000-FF-000615', NULL, NULL, 128, NULL, NULL, 45294),
(45295, '3.40.50.1010-FF-000152', NULL, NULL, 147, NULL, NULL, 45295),
(45296, '3.40.50.300-FF-004116', NULL, 'AAA_domain_containing_protein_-_putative', 259, NULL, NULL, 45296),
(45297, '3.40.50.300-FF-003492', NULL, 'AGAP012735-PA', 124, NULL, NULL, 45297),
(45298, '3.30.160.60-FF-001541', NULL, 'zinc finger protein OZF', 37, NULL, NULL, 45298),
(45299, '2.60.40.1170-FF-000050', NULL, 'AP-3 complex subunit mu', 153, NULL, NULL, 45299),
(45300, '2.130.10.10-FF-005459', NULL, 'Uncharacterized protein', 182, NULL, NULL, 45300),
(45301, '2.60.200.10-FF-000021', NULL, 'Interferon regulatory factor 9', 141, NULL, NULL, 45301);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(45302, '3.30.70.330-FF-001383', NULL, 'RNA recognition motif domain containing protein', 176, NULL, NULL, 45302),
(45303, '1.10.287.890-FF-000005', NULL, 'Adenylate isopentenyltransferase 4', 105, NULL, NULL, 45303),
(45304, '3.30.70.3030-FF-000007', NULL, 'Nucleolar protein 6', 126, NULL, NULL, 45304),
(45305, '3.30.70.330-FF-001495', NULL, 'Protein CBR-UNC-75', 147, NULL, NULL, 45305),
(45306, '1.10.238.10-FF-000943', NULL, 'Uncharacterized protein', 102, NULL, NULL, 45306),
(45307, '1.20.1560.10-FF-000284', NULL, 'ABC multidrug transporter, putative', 628, NULL, NULL, 45307),
(45308, '1.10.8.60-FF-000080', NULL, 'Lon protease homolog, mitochondrial', 94, NULL, NULL, 45308),
(45309, '3.30.2130.30-FF-000035', NULL, 'Uncharacterized protein', 152, NULL, NULL, 45309),
(45310, '3.40.50.10470-FF-000032', NULL, 'Translation initiation factor eIF-2B subunit family protein', 221, NULL, NULL, 45310),
(45311, '3.30.1460.50-FF-000009', NULL, 'Autophagy-related protein 3', 150, NULL, NULL, 45311),
(45312, '2.70.170.10-FF-000206', NULL, 'Predicted protein', 160, NULL, NULL, 45312),
(45313, '3.90.1170.30-FF-000006', NULL, 'Pyrimidine-nucleoside phosphorylase', 88, NULL, NULL, 45313),
(45314, '1.20.58.80-FF-000061', NULL, 'YALI0C00165p', 125, NULL, NULL, 45314),
(45315, '2.60.40.10-FF-001592', NULL, 'Tenascin-X', 68, NULL, NULL, 45315),
(45316, '1.20.120.350-FF-000224', NULL, NULL, 144, NULL, NULL, 45316),
(45317, '1.10.275.40-FF-000015', NULL, 'Uncharacterized protein', 99, NULL, NULL, 45317),
(45318, '3.30.559.10-FF-000154', NULL, 'Si:ch211-256m1.8', 219, NULL, NULL, 45318),
(45319, '3.30.530.20-FF-000012', NULL, 'Acyl-coenzyme A thioesterase 11', 257, NULL, NULL, 45319),
(45320, '3.40.50.1360-FF-000026', NULL, 'DeoR/GlpR transcriptional regulator', 160, NULL, NULL, 45320),
(45321, '2.40.10.10-FF-000146', NULL, 'Serine protease 53', 237, NULL, NULL, 45321),
(45322, '3.90.340.10-FF-000009', NULL, 'Nitric oxide synthase 1', 104, NULL, NULL, 45322),
(45323, '1.50.40.10-FF-000223', NULL, 'SLC (SoLute Carrier) homolog', 112, NULL, NULL, 45323),
(45324, '1.25.40.10-FF-000523', NULL, 'Clathrin heavy chain', 236, NULL, NULL, 45324),
(45325, '3.40.190.10-FF-000834', NULL, 'Opine/polyamine ABC transporter, periplasmic substrate-binding protein', 123, NULL, NULL, 45325),
(45326, '1.10.10.10-FF-001408', NULL, 'Iron-dependent transcriptional repressor, putative', 131, NULL, NULL, 45326),
(45327, '3.30.1460.30-FF-000003', NULL, 'DNA transformation protein TfoX', 104, NULL, NULL, 45327),
(45328, '1.10.730.10-FF-000115', NULL, 'Methionyl-tRNA synthetase', 182, NULL, NULL, 45328),
(45329, '1.10.10.10-FF-001184', NULL, 'Transcriptional regulator YetL MarR family', 160, NULL, NULL, 45329),
(45330, '3.40.640.10-FF-000459', NULL, 'Uncharacterized protein', 194, NULL, NULL, 45330),
(45331, '3.40.50.300-FF-007882', NULL, 'Spindle E', 197, NULL, NULL, 45331),
(45332, '3.40.50.2000-FF-000870', NULL, 'Chromosome 23, whole genome shotgun sequence', 319, NULL, NULL, 45332),
(45333, '3.40.50.720-FF-001605', NULL, '2,4-diaminopentanoate dehydrogenase', 154, NULL, NULL, 45333),
(45334, '3.40.50.150-FF-001120', NULL, NULL, 197, NULL, NULL, 45334),
(45335, '2.60.120.200-FF-000259', NULL, 'Chromosome 9, whole genome shotgun sequence', 189, NULL, NULL, 45335),
(45336, '3.30.560.10-FF-000011', NULL, 'Dehydrogenase xptC', 333, NULL, NULL, 45336),
(45337, '1.10.135.10-FF-000013', NULL, 'Uncharacterized protein', 49, NULL, NULL, 45337),
(45338, '3.90.1600.10-FF-000023', NULL, 'DNA polymerase', 147, NULL, NULL, 45338),
(45339, '3.20.20.140-FF-000160', NULL, 'Sodium/hydrogen exchanger 2', 87, NULL, NULL, 45339),
(45340, '3.30.160.60-FF-004290', NULL, NULL, 64, NULL, NULL, 45340),
(45341, '1.10.4200.10-FF-000002', NULL, 'Probable 2-(5''''-triphosphoribosyl)-3''-dephosphocoenzyme-A synthase', 130, NULL, NULL, 45341),
(45342, '2.60.120.330-FF-000219', NULL, 'Uncharacterized protein', 70, NULL, NULL, 45342),
(45343, '2.30.30.140-FF-000214', NULL, 'Os04g0101300 protein', 135, NULL, NULL, 45343),
(45344, '3.50.50.60-FF-000661', NULL, 'Predicted protein', 43, NULL, NULL, 45344);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(45345, '2.10.25.10-FF-001339', NULL, 'Predicted protein', 38, NULL, NULL, 45345),
(45346, '3.20.20.140-FF-000008', NULL, 'Probable phosphatase YcdX', 245, NULL, NULL, 45346),
(45347, '3.50.50.60-FF-001335', NULL, 'Uncharacterized protein', 62, NULL, NULL, 45347),
(45348, '1.20.1310.30-FF-000002', NULL, 'Exocyst complex protein EXO70', 155, NULL, NULL, 45348),
(45349, '3.90.226.10-FF-000137', NULL, 'Possible protease IV sppA (Endopeptidase IV)', 116, NULL, NULL, 45349),
(45350, '3.20.20.80-FF-000739', NULL, 'Uncharacterized protein', 84, NULL, NULL, 45350),
(45351, '3.30.70.1230-FF-000113', NULL, 'Adenylate cyclase-like protein', 239, NULL, NULL, 45351),
(45352, '3.90.1410.10-FF-000003', NULL, 'Rubisco methyltransferase family protein', 268, NULL, NULL, 45352),
(45353, '1.25.50.20-FF-000021', NULL, 'Aminopeptidase', 309, NULL, NULL, 45353),
(45354, '2.60.40.60-FF-000510', NULL, 'Predicted protein', 86, NULL, NULL, 45354),
(45355, '3.40.30.10-FF-001202', NULL, 'Calsequestrin', 69, NULL, NULL, 45355),
(45356, '1.10.10.10-FF-000307', NULL, 'Crossover junction endonuclease MUS81', 110, NULL, NULL, 45356),
(45357, '2.60.40.1120-FF-000057', NULL, 'Carboxypeptidase D, a', 100, NULL, NULL, 45357),
(45358, '3.40.50.300-FF-008399', NULL, 'ATP-dependent DNA helicase', 178, NULL, NULL, 45358),
(45359, '2.30.30.40-FF-000213', NULL, 'High osmolarity signaling protein SHO1', 63, NULL, NULL, 45359),
(45360, '2.60.120.260-FF-000350', NULL, 'Uncharacterized protein', 47, NULL, NULL, 45360),
(45361, '2.60.220.50-FF-000017', NULL, 'Adhesion G protein-coupled receptor F3', 152, NULL, NULL, 45361),
(45362, '2.40.100.10-FF-000035', NULL, 'Peptidyl-prolyl cis-trans isomerase', 179, NULL, NULL, 45362),
(45363, '1.10.730.20-FF-000023', NULL, 'Isoleucyl-tRNA synthetase', 315, NULL, NULL, 45363),
(45364, '3.10.110.10-FF-000302', NULL, 'Predicted protein', 97, NULL, NULL, 45364),
(45365, '1.10.287.110-FF-000435', NULL, 'Predicted protein', 79, NULL, NULL, 45365),
(45366, '3.40.140.10-FF-000270', NULL, 'Uncharacterized protein', 93, NULL, NULL, 45366),
(45367, '3.40.605.10-FF-000046', NULL, 'Aldehyde dehydrogenase family 7 member A1', 257, NULL, NULL, 45367),
(45368, '3.90.550.50-FF-000048', NULL, 'beta-1,3-N-acetylglucosaminyltransferase radical fringe', 200, NULL, NULL, 45368),
(45369, '2.30.240.10-FF-000002', NULL, 'Uncharacterized protein At3g07460', 132, NULL, NULL, 45369),
(45370, '3.20.20.120-FF-000002', NULL, 'Enolase 1', 308, NULL, NULL, 45370),
(45371, '1.20.1310.10-FF-000120', NULL, NULL, 118, NULL, NULL, 45371),
(45372, '3.40.50.300-FF-002082', NULL, 'Ras GTPAse, putative', 135, NULL, NULL, 45372),
(45373, '1.25.40.20-FF-001133', NULL, 'Kinase, NEK', 168, NULL, NULL, 45373),
(45374, '3.30.530.20-FF-000136', NULL, 'Uncharacterized protein', 155, NULL, NULL, 45374),
(45375, '2.60.40.1180-FF-000148', NULL, 'Alpha-galactosidase', 89, NULL, NULL, 45375),
(45376, '2.60.120.620-FF-000149', NULL, 'Uncharacterized protein', 183, NULL, NULL, 45376),
(45377, '3.30.1010.10-FF-000048', NULL, 'Phosphatidylinositol 4-kinase, putative', 148, NULL, NULL, 45377),
(45378, '3.40.1110.10-FF-000143', NULL, 'Phospholipid-transporting ATPase', 142, NULL, NULL, 45378),
(45379, '3.30.160.60-FF-006324', NULL, NULL, 26, NULL, NULL, 45379),
(45380, '1.25.10.10-FF-000307', NULL, '26S proteasome regulatory subunit RPN1, putative', 438, NULL, NULL, 45380),
(45381, '3.80.10.10-FF-000743', NULL, 'Uncharacterized protein', 253, NULL, NULL, 45381),
(45382, '3.20.20.70-FF-000641', NULL, NULL, 253, NULL, NULL, 45382),
(45383, '3.40.50.300-FF-006325', NULL, 'Uncharacterized protein', 192, NULL, NULL, 45383),
(45384, '1.20.1070.10-FF-001157', NULL, 'Hydroxycarboxylic acid receptor 1-4', 292, NULL, NULL, 45384),
(45385, '1.25.10.10-FF-001095', NULL, 'Coatomer protein complex, subunit gamma 2', 91, NULL, NULL, 45385),
(45386, '4.10.400.10-FF-000181', NULL, 'Low-density lipoprotein RecePtor related', 50, NULL, NULL, 45386),
(45387, '1.10.1200.10-FF-000029', NULL, 'Acyl carrier protein', 79, NULL, NULL, 45387),
(45388, '2.60.40.10-FF-002665', NULL, 'Immunoglobulin superfamily, member 8', 134, NULL, NULL, 45388);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(45389, '1.10.8.270-FF-000001', NULL, 'TBC1 domain family member 1', 90, NULL, NULL, 45389),
(45390, '2.60.220.30-FF-000011', NULL, 'P53-induced death domain protein 1', 156, NULL, NULL, 45390),
(45391, '1.10.1450.10-FF-000020', NULL, 'Tetraspanin', 93, NULL, NULL, 45391),
(45392, '1.10.630.10-FF-000282', NULL, 'Lanosterol 14-alpha demethylase', 76, NULL, NULL, 45392),
(45393, '1.20.1250.20-FF-000527', NULL, 'Probable triacylglyceride transporter Mb1445c', 207, NULL, NULL, 45393),
(45394, '1.20.1640.10-FF-000009', NULL, 'Dispatched homolog 1 (Drosophila)', 163, NULL, NULL, 45394),
(45395, '3.40.1110.10-FF-000486', NULL, NULL, 13, NULL, NULL, 45395),
(45396, '1.10.460.10-FF-000038', NULL, 'DNA topoisomerase type IA core', 31, NULL, NULL, 45396),
(45397, '2.60.120.920-FF-000121', NULL, 'Ryanodine receptor 3', 178, NULL, NULL, 45397),
(45398, '3.40.50.300-FF-001862', NULL, 'Disease resistance protein RPS4', 168, NULL, NULL, 45398),
(45399, '3.30.505.10-FF-000058', NULL, 'SH2 domain-containing adapter protein D', 118, NULL, NULL, 45399),
(45400, '2.60.40.1290-FF-000001', NULL, 'Clumping factor A', 158, NULL, NULL, 45400),
(45401, '2.130.10.10-FF-004211', NULL, 'Uncharacterized WD repeat-containing protein C32H8.09', 152, NULL, NULL, 45401),
(45402, '2.30.29.30-FF-001100', NULL, 'Uncharacterized protein', 158, NULL, NULL, 45402),
(45403, '2.10.25.10-FF-000642', NULL, 'Delta-like protein', 48, NULL, NULL, 45403),
(45404, '3.30.160.60-FF-002261', NULL, 'zinc finger protein 236 isoform X7', 26, NULL, NULL, 45404),
(45405, '3.30.420.10-FF-000029', NULL, 'ERI1 exoribonuclease 3 isoform X1', 204, NULL, NULL, 45405),
(45406, '1.25.10.10-FF-000807', NULL, 'Serine/threonine-protein kinase TOR', 179, NULL, NULL, 45406),
(45407, '2.10.70.10-FF-000218', NULL, 'Protein lev-9', 46, NULL, NULL, 45407),
(45408, '3.30.70.330-FF-000775', NULL, 'GL16640', 70, NULL, NULL, 45408),
(45409, '1.20.58.390-FF-000231', NULL, 'Uncharacterized protein', 167, NULL, NULL, 45409),
(45410, '3.40.470.10-FF-000024', NULL, NULL, 207, NULL, NULL, 45410),
(45411, '3.90.190.10-FF-000368', NULL, 'Uncharacterized protein', 285, NULL, NULL, 45411),
(45412, '3.90.260.10-FF-000008', NULL, 'DNA repair protein RAD4', 161, NULL, NULL, 45412),
(45413, '1.20.210.10-FF-000001', NULL, 'Cytochrome c oxidase subunit 1', 514, NULL, NULL, 45413),
(45414, '3.40.50.720-FF-002033', NULL, 'Short-chain alcohol dehydrogenase, putative', 190, NULL, NULL, 45414),
(45415, '3.30.70.1230-FF-000248', NULL, 'Predicted protein', 213, NULL, NULL, 45415),
(45416, '1.10.287.70-FF-000490', NULL, 'Uncharacterized protein', 138, NULL, NULL, 45416),
(45417, '3.60.110.10-FF-000044', NULL, 'Carbon-nitrogen hydrolase', 268, NULL, NULL, 45417),
(45418, '2.60.120.650-FF-000085', NULL, 'Uncharacterized protein', 177, NULL, NULL, 45418),
(45419, '3.40.33.10-FF-000056', NULL, 'AGAP002703-PA', 113, NULL, NULL, 45419),
(45420, '3.10.110.10-FF-000061', NULL, 'Ubiquitin-conjugating enzyme E2 8', 157, NULL, NULL, 45420),
(45421, '3.30.460.80-FF-000007', NULL, 'Formate hydrogenase HycE', 100, NULL, NULL, 45421),
(45422, '3.90.920.10-FF-000020', NULL, 'Multifunctional non-homologous end joining protein LigD', 285, NULL, NULL, 45422),
(45423, '3.40.50.1110-FF-000148', NULL, 'Uncharacterized protein', 121, NULL, NULL, 45423),
(45424, '1.10.150.50-FF-000133', NULL, 'Predicted protein', 57, NULL, NULL, 45424),
(45425, '1.25.10.10-FF-001027', NULL, 'Uncharacterized protein', 276, NULL, NULL, 45425),
(45426, '3.40.50.2300-FF-000050', NULL, 'Response regulator receiver', 137, NULL, NULL, 45426),
(45427, '1.20.144.10-FF-000122', NULL, 'Lipid A 4''-phosphatase', 190, NULL, NULL, 45427),
(45428, '1.20.1310.20-FF-000010', NULL, 'Erythrocyte binding antigen-181', 166, NULL, NULL, 45428),
(45429, '1.25.40.10-FF-000315', NULL, 'Transcriptional activator CadC', 162, NULL, NULL, 45429),
(45430, '3.30.160.60-FF-000405', NULL, 'pogo transposable element with ZNF domain isoform X1', 60, NULL, NULL, 45430),
(45431, '3.40.720.10-FF-000117', NULL, 'Predicted protein', 317, NULL, NULL, 45431),
(45432, '1.10.150.110-FF-000031', NULL, 'DNA polymerase', 85, NULL, NULL, 45432);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(45433, '3.30.160.60-FF-003339', NULL, NULL, 27, NULL, NULL, 45433),
(45434, '2.10.60.10-FF-000004', NULL, 'Ly6/PLAUR domain-containing protein 6', 88, NULL, NULL, 45434),
(45435, '2.60.120.200-FF-000759', NULL, 'Galectin', 89, NULL, NULL, 45435),
(45436, '3.30.160.60-FF-000748', NULL, 'PR domain zinc finger protein', 20, NULL, NULL, 45436),
(45437, '2.60.40.10-FF-001384', NULL, 'Beta-D-xylosidase 4', 108, NULL, NULL, 45437),
(45438, '3.20.20.10-FF-000027', NULL, 'Pyridoxal-dependent decarboxylase, putative', 248, NULL, NULL, 45438),
(45439, '3.40.630.30-FF-000184', NULL, 'GCN5-related N-acetyl-transferase family protein', 92, NULL, NULL, 45439),
(45440, '1.10.10.10-FF-001684', NULL, 'Interferon regulatory factor 2', 116, NULL, NULL, 45440),
(45441, '4.10.960.10-FF-000003', NULL, '50S ribosomal protein L3', 85, NULL, NULL, 45441),
(45442, '3.30.420.40-FF-000465', NULL, 'Heat shock cognate 70 kDa protein 2', 48, NULL, NULL, 45442),
(45443, '2.60.40.10-FF-002401', NULL, 'Cytokine receptor like factor 2', 94, NULL, NULL, 45443),
(45444, '2.40.290.30-FF-000003', NULL, 'Prostate tumor-overexpressed gene 1 protein', 67, NULL, NULL, 45444),
(45445, '3.10.20.90-FF-000153', NULL, 'Ral guanine nucleotide dissociation stimulator like 2', 90, NULL, NULL, 45445),
(45446, '2.70.98.40-FF-000002', NULL, 'Putative maltose phosphorylase', 266, NULL, NULL, 45446),
(45447, '4.10.880.10-FF-000002', NULL, 'Genome polyprotein', 51, NULL, NULL, 45447),
(45448, '3.40.50.720-FF-000796', NULL, 'Enoyl-CoA Hydratase', 216, NULL, NULL, 45448),
(45449, '3.60.40.10-FF-000089', NULL, 'Protein phosphatase 2C 71', 331, NULL, NULL, 45449),
(45450, '1.25.40.10-FF-003625', NULL, 'Pentatricopeptide repeat-containing protein At3g09040, mitochondrial', 86, NULL, NULL, 45450),
(45451, '1.20.1250.20-FF-002208', NULL, 'Uncharacterized protein', 140, NULL, NULL, 45451),
(45452, '6.10.140.2220-FF-000057', NULL, 'LD37257p', 58, NULL, NULL, 45452),
(45453, '3.40.50.300-FF-005173', NULL, 'Type II/IV secretion system ATPase TadZ/CpaE, associated with Flp pilus assembly', 221, NULL, NULL, 45453),
(45454, '3.40.50.620-FF-000592', NULL, 'Predicted protein', 154, NULL, NULL, 45454),
(45455, '3.30.60.20-FF-000100', NULL, 'Diacylglycerol kinase', 56, NULL, NULL, 45455),
(45456, '3.30.930.10-FF-000388', NULL, 'Phenylalanine--tRNA ligase beta subunit', 196, NULL, NULL, 45456),
(45457, '2.60.120.10-FF-000144', NULL, 'sodium/hydrogen exchanger 11 isoform X2', 131, NULL, NULL, 45457),
(45458, '3.40.30.10-FF-001090', NULL, 'Uncharacterized protein', 103, NULL, NULL, 45458),
(45459, '2.60.40.10-FF-005599', NULL, NULL, 75, NULL, NULL, 45459),
(45460, '2.40.160.50-FF-000005', NULL, 'Outer membrane OMP85 family protein', 363, NULL, NULL, 45460),
(45461, '1.20.1050.10-FF-000133', NULL, 'Tau class glutathione S-transferase', 138, NULL, NULL, 45461),
(45462, '3.40.366.10-FF-000029', NULL, 'Malonyl CoA-acyl carrier protein transacylase', 201, NULL, NULL, 45462),
(45463, '3.40.50.300-FF-002823', NULL, 'ATP-binding cassette (ABC) transporter, putative', 245, NULL, NULL, 45463),
(45464, '3.40.50.620-FF-000272', NULL, 'Universal stress protein family', 127, NULL, NULL, 45464),
(45465, '3.40.395.10-FF-000001', NULL, 'Sentrin-specific protease 1', 233, NULL, NULL, 45465),
(45466, '3.20.20.140-FF-000284', NULL, 'Uncharacterized protein', 304, NULL, NULL, 45466),
(45467, '3.30.870.10-FF-000113', NULL, 'Cardiolipin synthetase', 203, NULL, NULL, 45467),
(45468, '3.40.1280.30-FF-000015', NULL, 'tRNA methyltransferase', 176, NULL, NULL, 45468),
(45469, '1.10.510.10-FF-000543', NULL, 'Serine/threonine-protein kinase CDL1-like', 204, NULL, NULL, 45469),
(45470, '2.40.50.100-FF-000041', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 76, NULL, NULL, 45470),
(45471, '1.20.1730.10-FF-000112', NULL, 'Uncharacterized protein', 166, NULL, NULL, 45471),
(45472, '3.30.160.60-FF-004790', NULL, NULL, 25, NULL, NULL, 45472),
(45473, '1.25.40.10-FF-004289', NULL, 'Pentatricopeptide repeat-containing protein', 201, NULL, NULL, 45473),
(45474, '1.20.1270.60-FF-000170', NULL, 'Rgd3p', 222, NULL, NULL, 45474);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(45475, '1.10.3730.10-FF-000002', NULL, 'Pyrroline-5-carboxylate reductase', 104, NULL, NULL, 45475),
(45476, '2.30.30.40-FF-000005', NULL, 'SLIT-ROBO Rho GTPase-activating protein 1 isoform 2', 70, NULL, NULL, 45476),
(45477, '3.30.160.60-FF-003098', NULL, NULL, 33, NULL, NULL, 45477),
(45478, '2.120.10.80-FF-000017', NULL, 'kelch-like protein 1 isoform X2', 199, NULL, NULL, 45478),
(45479, '2.30.30.1020-FF-000011', NULL, 'CCR4-NOT transcriptional complex subunit', 215, NULL, NULL, 45479),
(45480, '3.30.1740.10-FF-000007', NULL, 'Poly [ADP-ribose] polymerase', 94, NULL, NULL, 45480),
(45481, '1.20.920.10-FF-000072', NULL, 'Bromodomain-containing factor 2', 122, NULL, NULL, 45481),
(45482, '1.10.510.10-FF-000020', NULL, 'serine/threonine-protein kinase D6PK-like', 124, NULL, NULL, 45482),
(45483, '3.40.50.150-FF-000788', NULL, 'Uncharacterized protein', 199, NULL, NULL, 45483),
(45484, '1.10.3810.10-FF-000003', NULL, 'Penicillin-binding protein 1a', 195, NULL, NULL, 45484),
(45485, '3.40.800.20-FF-000008', NULL, 'Histone deacetylase', 382, NULL, NULL, 45485),
(45486, '3.40.50.410-FF-000147', NULL, 'Copine family protein', 184, NULL, NULL, 45486),
(45487, '3.40.50.300-FF-003992', NULL, 'Uncharacterized protein', 353, NULL, NULL, 45487),
(45488, '3.40.50.10380-FF-000005', NULL, 'Malic enzyme', 264, NULL, NULL, 45488),
(45489, '1.10.3210.10-FF-000093', NULL, 'HD family hydrolase', 293, NULL, NULL, 45489),
(45490, '2.60.40.60-FF-000010', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', 105, NULL, NULL, 45490),
(45491, '2.130.10.10-FF-003273', NULL, 'Uncharacterized protein', 166, NULL, NULL, 45491),
(45492, '3.30.110.20-FF-000020', NULL, 'Rpp20 subunit of nuclear RNase MRP and P-domain-containing protein', 132, NULL, NULL, 45492),
(45493, '3.40.720.10-FF-000061', NULL, 'Sulfatase atsG', 414, NULL, NULL, 45493),
(45494, '2.40.50.120-FF-000047', NULL, 'Agrin', 111, NULL, NULL, 45494),
(45495, '2.60.40.3800-FF-000001', NULL, 'Gingipain R2', 206, NULL, NULL, 45495),
(45496, '3.30.50.10-FF-000158', NULL, 'Uncharacterized protein', 101, NULL, NULL, 45496),
(45497, '1.10.287.660-FF-000021', NULL, 'Pre-mRNA-splicing factor ISY1', 56, NULL, NULL, 45497),
(45498, '1.20.1270.280-FF-000075', NULL, 'Predicted protein', 70, NULL, NULL, 45498),
(45499, '1.10.510.10-FF-001768', NULL, 'Uncharacterized protein', 343, NULL, NULL, 45499),
(45500, '3.80.10.10-FF-002896', NULL, 'Uncharacterized protein', 50, NULL, NULL, 45500),
(45501, '1.20.58.340-FF-000053', NULL, 'Magnesium and cobalt transport protein', 133, NULL, NULL, 45501),
(45502, '3.30.565.10-FF-000207', NULL, 'Two-component sensor histidine kinase', 127, NULL, NULL, 45502),
(45503, '1.10.510.10-FF-002100', NULL, 'Cell division control protein, putative', 296, NULL, NULL, 45503),
(45504, '3.30.450.40-FF-000225', NULL, 'PAS sensor protein', 185, NULL, NULL, 45504),
(45505, '1.20.1320.30-FF-000008', NULL, NULL, 152, NULL, NULL, 45505),
(45506, '1.10.510.10-FF-001644', NULL, 'Serine/threonine-protein kinase US3 homolog', 229, NULL, NULL, 45506),
(45507, '1.25.10.20-FF-000024', NULL, 'Uncharacterized protein', 132, NULL, NULL, 45507),
(45508, '1.20.140.10-FF-000006', NULL, 'Glutaryl-CoA dehydrogenase, mitochondrial', 154, NULL, NULL, 45508),
(45509, '1.10.287.110-FF-000255', NULL, 'Predicted protein', 105, NULL, NULL, 45509),
(45510, '3.90.470.40-FF-000005', NULL, 'DNA damage-inducible transcript 4-like protein', 131, NULL, NULL, 45510),
(45511, '1.10.472.80-FF-000058', NULL, 'Ubiquitin specific peptidase 6', 133, NULL, NULL, 45511),
(45512, '1.10.1660.10-FF-000002', NULL, 'Redox-sensitive transcriptional activator SoxR', 135, NULL, NULL, 45512),
(45513, '2.70.150.10-FF-000031', NULL, 'Phospholipid-transporting ATPase', 147, NULL, NULL, 45513),
(45514, '3.90.1420.10-FF-000037', NULL, 'Lysine N-methylase', 165, NULL, NULL, 45514),
(45515, '3.30.160.60-FF-004059', NULL, NULL, 26, NULL, NULL, 45515),
(45516, '3.90.228.20-FF-000009', NULL, 'Os04g0592500 protein', 100, NULL, NULL, 45516),
(45517, '3.30.70.20-FF-000106', NULL, NULL, 63, NULL, NULL, 45517),
(45518, '1.10.287.540-FF-000002', NULL, 'Fimbrial assembly membrane protein', 36, NULL, NULL, 45518);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(45519, '3.30.40.10-FF-000781', NULL, 'Uncharacterized protein', 88, NULL, NULL, 45519),
(45520, '3.30.830.10-FF-000324', NULL, 'Presequence protease', 89, NULL, NULL, 45520),
(45521, '2.60.40.10-FF-000535', NULL, 'neural cell adhesion molecule L1-like protein isoform X1', 106, NULL, NULL, 45521),
(45522, '3.30.420.10-FF-000361', NULL, NULL, 211, NULL, NULL, 45522),
(45523, '3.40.1780.10-FF-000002', NULL, 'S-adenosylmethionine:tRNA ribosyltransferase-isomerase', 199, NULL, NULL, 45523),
(45524, '1.10.510.10-FF-003977', NULL, NULL, 330, NULL, NULL, 45524),
(45525, '3.30.40.10-FF-001169', NULL, 'Uncharacterized protein', 91, NULL, NULL, 45525),
(45526, '3.30.1780.10-FF-000004', NULL, '2,3-diaminopropionate biosynthesis protein SbnB', 151, NULL, NULL, 45526),
(45527, '1.10.10.10-FF-000515', NULL, 'DNA-directed RNA polymerase III subunit rpc3', 86, NULL, NULL, 45527),
(45528, '2.70.170.10-FF-000274', NULL, 'Predicted protein', 107, NULL, NULL, 45528),
(45529, '3.30.70.80-FF-000040', NULL, 'Tk-subtilisin', 69, NULL, NULL, 45529),
(45530, '3.90.550.10-FF-000727', NULL, 'Uncharacterized protein', 253, NULL, NULL, 45530),
(45531, '2.60.120.330-FF-000039', NULL, 'Unplaced genomic scaffold supercont1.13, whole genome shotgun sequence', 360, NULL, NULL, 45531),
(45532, '1.25.40.20-FF-000195', NULL, 'Kinase D-interacting substrate of 220 kDa', 166, NULL, NULL, 45532),
(45533, '1.10.630.10-FF-000759', NULL, 'Fatty acid hydroxylase, cytochrome P450', 505, NULL, NULL, 45533),
(45534, '1.25.40.190-FF-000010', NULL, NULL, 131, NULL, NULL, 45534),
(45535, '1.20.5.100-FF-000009', NULL, 'Integrin beta', 74, NULL, NULL, 45535),
(45536, '1.25.10.10-FF-001999', NULL, 'ADR334Wp', 272, NULL, NULL, 45536),
(45537, '1.10.167.10-FF-000031', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 131, NULL, NULL, 45537),
(45538, '3.40.50.300-FF-005869', NULL, 'ATP-dependent DNA helicase recQ', 105, NULL, NULL, 45538),
(45539, '1.10.510.10-FF-004253', NULL, NULL, 193, NULL, NULL, 45539),
(45540, '1.10.10.2360-FF-000002', NULL, 'Unplaced genomic scaffold supercont1.219, whole genome shotgun sequence', 58, NULL, NULL, 45540),
(45541, '3.40.50.300-FF-002435', NULL, 'Probable SNF2-component of SWI/SNF global transcription activator complex', 233, NULL, NULL, 45541),
(45542, '1.10.238.110-FF-000004', NULL, 'Diacylglycerol kinase', 114, NULL, NULL, 45542),
(45543, '4.10.1000.10-FF-000118', NULL, 'Pharynx and intestine in excess protein 1', 70, NULL, NULL, 45543),
(45544, '2.130.10.10-FF-003194', NULL, 'Uncharacterized protein', 114, NULL, NULL, 45544),
(45545, '3.80.10.10-FF-001087', NULL, 'Leucine-rich_repeat_protein_-_putative', 88, NULL, NULL, 45545),
(45546, '3.30.420.10-FF-000181', NULL, 'RNase H', 138, NULL, NULL, 45546),
(45547, '3.30.70.100-FF-000083', NULL, 'Heavy-metal transporting CPx-type ATPase', 70, NULL, NULL, 45547),
(45548, '2.60.120.10-FF-000279', NULL, 'Unplaced genomic scaffold supercont2.1, whole genome shotgun sequence', 330, NULL, NULL, 45548),
(45549, '1.20.1270.60-FF-000018', NULL, 'Rho GTPase activating protein 44', 246, NULL, NULL, 45549),
(45550, '1.20.1070.10-FF-000376', NULL, 'probable G-protein coupled receptor 141', 279, NULL, NULL, 45550),
(45551, '3.90.228.10-FF-000063', NULL, 'Poly [ADP-ribose] polymerase', 112, NULL, NULL, 45551),
(45552, '3.30.70.270-FF-000004', NULL, 'Pol polyprotein', 105, NULL, NULL, 45552),
(45553, '3.30.70.330-FF-002012', NULL, NULL, 74, NULL, NULL, 45553),
(45554, '2.60.40.10-FF-006055', NULL, NULL, 109, NULL, NULL, 45554),
(45555, '2.40.10.10-FF-000410', NULL, NULL, 189, NULL, NULL, 45555),
(45556, '2.60.40.790-FF-000168', NULL, NULL, 127, NULL, NULL, 45556),
(45557, '2.130.10.10-FF-004554', NULL, 'Uncharacterized protein', 217, NULL, NULL, 45557),
(45558, '1.10.3500.10-FF-000013', NULL, 'Holliday-junction_resolvase-like_of_SPT6 /SH2_domain_containing_protein_-_putative', 273, NULL, NULL, 45558),
(45559, '3.40.532.10-FF-000028', NULL, NULL, 130, NULL, NULL, 45559),
(45560, '3.30.200.20-FF-001483', NULL, 'Inactive leucine-rich repeat receptor-like protein kinase isoform A', 107, NULL, NULL, 45560);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(45561, '3.80.10.10-FF-004133', NULL, 'Probable serine/threonine-protein kinase pats1', 282, NULL, NULL, 45561),
(45562, '2.60.210.10-FF-000027', NULL, 'Pectinesterase', 127, NULL, NULL, 45562),
(45563, '3.10.50.30-FF-000002', NULL, 'Regulator of nucleoside diphosphate kinase', 92, NULL, NULL, 45563),
(45564, '2.10.90.10-FF-000040', NULL, 'Persephin', 92, NULL, NULL, 45564),
(45565, '2.10.25.10-FF-001603', NULL, 'Uncharacterized protein', 48, NULL, NULL, 45565),
(45566, '3.30.70.330-FF-001736', NULL, NULL, 104, NULL, NULL, 45566),
(45567, '2.60.40.420-FF-000265', NULL, 'Uncharacterized protein', 55, NULL, NULL, 45567),
(45568, '3.30.710.10-FF-000405', NULL, 'Rho-related BTB domain-containing 2', 132, NULL, NULL, 45568),
(45569, '2.10.50.10-FF-000122', NULL, 'Ephrin receptor like protein', 62, NULL, NULL, 45569),
(45570, '1.20.58.530-FF-000020', NULL, 'Myosin C', 158, NULL, NULL, 45570),
(45571, '3.80.10.10-FF-003857', NULL, 'Uncharacterized protein', 248, NULL, NULL, 45571),
(45572, '3.40.50.10890-FF-000006', NULL, 'Cleavage and polyadenylation specificity factor subunit 2', 191, NULL, NULL, 45572),
(45573, '3.30.1320.10-FF-000015', NULL, '30S ribosomal protein S16', 115, NULL, NULL, 45573),
(45574, '3.40.50.300-FF-000226', NULL, 'Ras-related GTP-binding protein D', 181, NULL, NULL, 45574),
(45575, '2.130.10.10-FF-001120', NULL, 'Blast:DmX-like protein 2', 241, NULL, NULL, 45575),
(45576, '1.25.10.10-FF-001920', NULL, 'Uncharacterized protein', 299, NULL, NULL, 45576),
(45577, '2.30.120.10-FF-000004', NULL, 'Penicillin acylase II', 68, NULL, NULL, 45577),
(45578, '1.10.287.2620-FF-000008', NULL, 'Dynein heavy chain, cytoplasmic', 64, NULL, NULL, 45578),
(45579, '2.60.40.150-FF-000100', NULL, 'Extended synaptotagmin-2', 140, NULL, NULL, 45579),
(45580, '3.40.50.1820-FF-001721', NULL, 'Predicted protein', 126, NULL, NULL, 45580),
(45581, '1.10.275.30-FF-000001', NULL, 'DNA repair helicase RAD3', 83, NULL, NULL, 45581),
(45582, '1.20.120.360-FF-000002', NULL, 'Axin interactor, dorsalization associated', 85, NULL, NULL, 45582),
(45583, '1.25.10.10-FF-002320', NULL, 'Armadillo-like helical domain-containing protein', 309, NULL, NULL, 45583),
(45584, '2.60.40.10-FF-001945', NULL, 'Usherin', 104, NULL, NULL, 45584),
(45585, '3.40.630.30-FF-000060', NULL, 'Alpha-tubulin N-acetyltransferase 1', 194, NULL, NULL, 45585),
(45586, '3.40.50.1010-FF-000287', NULL, NULL, 187, NULL, NULL, 45586),
(45587, '1.20.58.400-FF-000009', NULL, 'Unplaced genomic scaffold supercont1.201, whole genome shotgun sequence', 102, NULL, NULL, 45587),
(45588, '3.30.420.140-FF-000034', NULL, 'Transcription elongation factor spt6', 67, NULL, NULL, 45588),
(45589, '3.30.160.60-FF-003918', NULL, NULL, 38, NULL, NULL, 45589),
(45590, '1.20.5.1700-FF-000004', NULL, 'Homer homolog 2 (Drosophila)', 69, NULL, NULL, 45590),
(45591, '3.40.50.1820-FF-000361', NULL, 'Thioesterase TesA', 238, NULL, NULL, 45591),
(45592, '1.20.5.2440-FF-000007', NULL, 'Rab-11 Family Interacting-Protein', 60, NULL, NULL, 45592),
(45593, '1.25.40.20-FF-000413', NULL, 'Ankyrin repeat domain 23', 171, NULL, NULL, 45593),
(45594, '3.40.50.720-FF-001252', NULL, 'Nadp-dependent leukotriene b4', 168, NULL, NULL, 45594),
(45595, '3.80.10.10-FF-001648', NULL, 'Nuclear RNA export factor 3', 144, NULL, NULL, 45595),
(45596, '1.10.540.10-FF-000039', NULL, 'Acyl-CoA dehydrogenase FadE28', 100, NULL, NULL, 45596),
(45597, '3.40.50.2300-FF-000954', NULL, NULL, 120, NULL, NULL, 45597),
(45598, '3.40.630.10-FF-000026', NULL, 'Carboxypeptidase D', 292, NULL, NULL, 45598),
(45599, '3.40.50.261-FF-000007', NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta', 153, NULL, NULL, 45599),
(45600, '3.40.50.1000-FF-000227', NULL, 'Predicted protein', 243, NULL, NULL, 45600),
(45601, '2.120.10.30-FF-000311', NULL, 'Gluconolactonase', 288, NULL, NULL, 45601),
(45602, '3.30.70.330-FF-000371', NULL, 'RNA-binding protein 28 isoform X1', 109, NULL, NULL, 45602),
(45603, '1.25.40.20-FF-000913', NULL, 'Zgc:112001', 157, NULL, NULL, 45603),
(45604, '1.10.287.1260-FF-000005', NULL, 'Mechanosensitive ion channel family protein', 123, NULL, NULL, 45604);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(45605, '3.30.160.60-FF-002665', NULL, NULL, 27, NULL, NULL, 45605),
(45606, '2.30.30.210-FF-000022', NULL, 'Uncharacterized protein', 129, NULL, NULL, 45606),
(45607, '2.40.50.140-FF-000761', NULL, NULL, 45, NULL, NULL, 45607),
(45608, '3.40.50.1820-FF-000922', NULL, 'Predicted protein', 119, NULL, NULL, 45608),
(45609, '1.10.357.120-FF-000005', NULL, 'DNA-directed RNA polymerase subunit', 145, NULL, NULL, 45609),
(45610, '3.80.10.10-FF-004346', NULL, 'Probable serine/threonine-protein kinase roco5', 185, NULL, NULL, 45610),
(45611, '1.10.565.10-FF-000006', NULL, 'Thyroid hormone receptor beta 2', 262, NULL, NULL, 45611),
(45612, '3.40.1480.10-FF-000013', NULL, 'Uncharacterized protein', 198, NULL, NULL, 45612),
(45613, '3.90.550.10-FF-000227', NULL, 'Glycosyltransferases', 255, NULL, NULL, 45613),
(45614, '1.25.40.20-FF-001425', NULL, 'Uncharacterized protein', 179, NULL, NULL, 45614),
(45615, '1.10.1280.10-FF-000017', NULL, 'Amino acid transporter (Eurofung)', 329, NULL, NULL, 45615),
(45616, '1.20.1070.10-FF-000937', NULL, 'Uncharacterized protein', 193, NULL, NULL, 45616),
(45617, '2.30.29.30-FF-000370', NULL, 'Dynamin, putative', 131, NULL, NULL, 45617),
(45618, '1.10.20.140-FF-000018', NULL, NULL, 47, NULL, NULL, 45618),
(45619, '2.60.40.10-FF-002165', NULL, 'Disorganized muscle protein 1', 106, NULL, NULL, 45619),
(45620, '2.130.10.10-FF-003773', NULL, 'Uncharacterized protein', 317, NULL, NULL, 45620),
(45621, '3.30.70.1230-FF-000136', NULL, 'Uncharacterized protein', 78, NULL, NULL, 45621),
(45622, '2.120.10.30-FF-000255', NULL, 'Uncharacterized protein', 180, NULL, NULL, 45622),
(45623, '3.40.50.740-FF-000015', NULL, 'Anaerobic dimethyl sulfoxide reductase subunit A', 209, NULL, NULL, 45623),
(45624, '1.10.8.480-FF-000007', NULL, 'rRNA adenine N(6)-methyltransferase', 99, NULL, NULL, 45624),
(45625, '1.10.510.10-FF-000520', NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', 307, NULL, NULL, 45625),
(45626, '2.130.10.10-FF-000052', NULL, 'semaphorin-3F isoform X2', 492, NULL, NULL, 45626),
(45627, '2.60.40.10-FF-005886', NULL, NULL, 103, NULL, NULL, 45627),
(45628, '1.10.510.10-FF-001032', NULL, 'KP78b, isoform A', 334, NULL, NULL, 45628),
(45629, '1.10.630.10-FF-000574', NULL, 'Uncharacterized protein', 314, NULL, NULL, 45629),
(45630, '2.40.50.140-FF-001273', NULL, NULL, 176, NULL, NULL, 45630),
(45631, '2.30.30.40-FF-000269', NULL, 'SH3 adapter protein SPIN90', 58, NULL, NULL, 45631),
(45632, '3.60.40.10-FF-000066', NULL, 'Serine/threonine-protein phosphatase', 233, NULL, NULL, 45632),
(45633, '1.20.120.530-FF-000019', NULL, 'GntR family transcriptional regulator', 129, NULL, NULL, 45633),
(45634, '2.40.50.690-FF-000010', NULL, 'Rrp44p homologue, putative', 120, NULL, NULL, 45634),
(45635, '1.10.238.10-FF-000494', NULL, 'Ubiquitin interaction motif-containing protein', 86, NULL, NULL, 45635),
(45636, '3.40.50.300-FF-000406', NULL, 'tRNA (N6-adenosine(37)-N6)-threonylcarbamoyltransferase complex ATPase TsaE', 152, NULL, NULL, 45636),
(45637, '4.10.280.10-FF-000209', NULL, 'Uncharacterized protein', 54, NULL, NULL, 45637),
(45638, '2.60.40.10-FF-001608', NULL, 'Uncharacterized protein', 99, NULL, NULL, 45638),
(45639, '3.40.50.300-FF-004740', NULL, 'Septin 7b', 216, NULL, NULL, 45639),
(45640, '3.80.10.10-FF-003801', NULL, 'Leucine-rich repeat-containing protein', 245, NULL, NULL, 45640),
(45641, '1.20.1720.10-FF-000050', NULL, 'Major facilitator superfamily transporter', 235, NULL, NULL, 45641),
(45642, '3.30.1370.100-FF-000042', NULL, 'Uncharacterized protein', 13, NULL, NULL, 45642),
(45643, '1.20.1310.10-FF-000176', NULL, NULL, 153, NULL, NULL, 45643),
(45644, '3.40.50.2300-FF-000398', NULL, 'Glutamate receptor', 104, NULL, NULL, 45644),
(45645, '1.25.40.20-FF-001369', NULL, 'Uncharacterized protein', 89, NULL, NULL, 45645),
(45646, '2.120.10.30-FF-000199', NULL, 'Serine peptidase family S9', 153, NULL, NULL, 45646),
(45647, '1.20.1740.10-FF-000045', NULL, 'Inner membrane transporter YhjV', 403, NULL, NULL, 45647),
(45648, '2.130.10.30-FF-000114', NULL, 'NimA-like kinase', 313, NULL, NULL, 45648); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(45649, '3.90.190.10-FF-000188', NULL, 'Protein tyrosine phosphatase type IVA 3', 145, NULL, NULL, 45649),
(45650, '3.30.40.10-FF-000337', NULL, 'Zinc finger family protein', 68, NULL, NULL, 45650),
(45651, '3.80.10.10-FF-000075', NULL, 'F-box/LRR-repeat protein 14 isoform X1', 146, NULL, NULL, 45651),
(45652, '2.130.10.10-FF-003722', NULL, 'Predicted protein', 340, NULL, NULL, 45652),
(45653, '2.160.20.10-FF-000310', NULL, 'Uncharacterized protein', 113, NULL, NULL, 45653),
(45654, '1.10.238.10-FF-000443', NULL, 'Ubiquitin specific peptidase 32', 85, NULL, NULL, 45654),
(45655, '1.25.40.10-FF-003564', NULL, 'Plastid transcriptionally active 3', 239, NULL, NULL, 45655),
(45656, '3.10.110.10-FF-000241', NULL, 'Ubiquitin-conjugating enzyme E2 2', 54, NULL, NULL, 45656),
(45657, '3.90.1140.10-FF-000004', NULL, 'A-kinase anchoring protein 7 isoform X1', 211, NULL, NULL, 45657),
(45658, '3.40.50.1010-FF-000213', NULL, NULL, 144, NULL, NULL, 45658),
(45659, '2.40.37.20-FF-000003', NULL, 'D-serine deaminase, pyridoxal phosphate-dependent', 126, NULL, NULL, 45659),
(45660, '1.10.3720.10-FF-000232', NULL, 'Sugar ABC transporter, permease protein', 267, NULL, NULL, 45660),
(45661, '2.60.120.200-FF-000023', NULL, 'Galectin', 139, NULL, NULL, 45661),
(45662, '1.10.10.60-FF-000041', NULL, 'insulin gene enhancer protein ISL-1', 66, NULL, NULL, 45662),
(45663, '3.40.1090.10-FF-000146', NULL, 'Uncharacterized protein', 102, NULL, NULL, 45663),
(45664, '3.40.30.10-FF-000538', NULL, 'Glutathione s-transferase', 100, NULL, NULL, 45664),
(45665, '3.40.50.2300-FF-001410', NULL, NULL, 83, NULL, NULL, 45665),
(45666, '1.10.238.10-FF-000387', NULL, 'Myosin light chain 1', 75, NULL, NULL, 45666),
(45667, '3.40.630.30-FF-000684', NULL, 'Uncharacterized protein', 91, NULL, NULL, 45667),
(45668, '1.20.58.60-FF-000139', NULL, 'nesprin-1 isoform X1', 291, NULL, NULL, 45668),
(45669, '2.40.10.10-FF-000646', NULL, NULL, 135, NULL, NULL, 45669),
(45670, '3.30.1460.20-FF-000017', NULL, 'Arp2/3 complex 34 kDa subunit', 175, NULL, NULL, 45670),
(45671, '3.80.10.10-FF-004397', NULL, 'Uncharacterized protein', 164, NULL, NULL, 45671),
(45672, '1.25.10.10-FF-002376', NULL, 'Uncharacterized protein', 274, NULL, NULL, 45672),
(45673, '3.40.50.1820-FF-001485', NULL, 'Uncharacterized protein', 167, NULL, NULL, 45673),
(45674, '3.30.230.130-FF-000061', NULL, 'YALI0A02200p', 158, NULL, NULL, 45674),
(45675, '3.90.280.10-FF-000010', NULL, 'Phosphatidylethanolamine binding protein 4', 165, NULL, NULL, 45675),
(45676, '1.10.150.20-FF-000214', NULL, 'Uncharacterized protein', 75, NULL, NULL, 45676),
(45677, '1.25.10.10-FF-002432', NULL, 'Wings apart family (Drosophila), putative', 241, NULL, NULL, 45677),
(45678, '3.40.440.10-FF-000011', NULL, NULL, 72, NULL, NULL, 45678),
(45679, '3.40.50.1370-FF-000063', NULL, NULL, 178, NULL, NULL, 45679),
(45680, '3.80.10.10-FF-000979', NULL, 'NBS-LRR class disease resistance protein', 324, NULL, NULL, 45680),
(45681, '1.25.40.20-FF-001476', NULL, 'Uncharacterized protein', 99, NULL, NULL, 45681),
(45682, '3.30.160.60-FF-005464', NULL, NULL, 69, NULL, NULL, 45682),
(45683, '2.10.220.10-FF-000106', NULL, 'Proprotein convertase subtilisin/kexin type 5a', 58, NULL, NULL, 45683),
(45684, '3.10.20.90-FF-000653', NULL, 'Uncharacterized protein', 107, NULL, NULL, 45684),
(45685, '3.90.550.50-FF-000043', NULL, 'Hexosyltransferase', 191, NULL, NULL, 45685),
(45686, '2.30.30.40-FF-000325', NULL, 'Hof1p', 70, NULL, NULL, 45686),
(45687, '2.130.10.30-FF-000058', NULL, 'Regulator of chromosome condensation', 253, NULL, NULL, 45687),
(45688, '3.40.50.300-FF-002379', NULL, 'Hydrogenobyrinate a,c-diamide synthase', 157, NULL, NULL, 45688),
(45689, '1.20.1310.10-FF-000232', NULL, NULL, 110, NULL, NULL, 45689),
(45690, '3.90.1140.10-FF-000055', NULL, 'Uncharacterized protein', 197, NULL, NULL, 45690),
(45691, '3.40.50.1010-FF-000264', NULL, NULL, 156, NULL, NULL, 45691),
(45692, '2.40.100.10-FF-000012', NULL, 'Peptidyl-prolyl cis-trans isomerase', 161, NULL, NULL, 45692),
(45693, '2.60.40.60-FF-000853', NULL, 'Uncharacterized protein', 61, NULL, NULL, 45693); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(45694, '3.40.50.2000-FF-000426', NULL, 'Glycosyltransferase', 129, NULL, NULL, 45694),
(45695, '1.10.1620.20-FF-000002', NULL, 'ATP synthase subunit epsilon, mitochondrial', 56, NULL, NULL, 45695),
(45696, '2.60.120.10-FF-000312', NULL, 'cGMP-dependent 3'',5''-cGMP phosphodiesterase A', 117, NULL, NULL, 45696),
(45697, '1.10.3720.10-FF-000176', NULL, 'ABC transporter, permease protein', 250, NULL, NULL, 45697),
(45698, '1.10.20.120-FF-000012', NULL, 'Ribonuclease H2 subunit B', 148, NULL, NULL, 45698),
(45699, '3.40.50.2020-FF-000180', NULL, 'Uncharacterized protein', 114, NULL, NULL, 45699),
(45700, '3.60.21.10-FF-000106', NULL, 'Sphingomyelin phosphodiesterase', 282, NULL, NULL, 45700),
(45701, '3.30.70.1950-FF-000003', NULL, 'Adapter protein MecA', 92, NULL, NULL, 45701),
(45702, '1.20.1110.10-FF-000251', NULL, NULL, 350, NULL, NULL, 45702),
(45703, '3.80.10.10-FF-002492', NULL, 'Uncharacterized protein', 176, NULL, NULL, 45703),
(45704, '1.10.10.440-FF-000050', NULL, 'U1 snRNP protein', 71, NULL, NULL, 45704),
(45705, '3.30.200.20-FF-001600', NULL, 'Protein CBR-FLR-4', 105, NULL, NULL, 45705),
(45706, '2.60.200.20-FF-000086', NULL, 'Uncharacterized protein, isoform C', 98, NULL, NULL, 45706),
(45707, '1.10.472.80-FF-000238', NULL, NULL, 138, NULL, NULL, 45707),
(45708, '1.10.510.10-FF-002336', NULL, NULL, 203, NULL, NULL, 45708),
(45709, '3.30.450.20-FF-000635', NULL, 'Histidine kinase', 124, NULL, NULL, 45709),
(45710, '3.30.200.20-FF-002000', NULL, 'Uncharacterized protein', 96, NULL, NULL, 45710),
(45711, '3.30.460.10-FF-000127', NULL, '2''-5''-oligoadenylate synthetase-like protein isoform 2', 150, NULL, NULL, 45711),
(45712, '1.10.510.10-FF-001936', NULL, 'Guanylate cyclase', 94, NULL, NULL, 45712),
(45713, '2.60.120.10-FF-000205', NULL, 'Lysophospholipase NTE1', 174, NULL, NULL, 45713),
(45714, '3.90.180.10-FF-000070', NULL, 'Mitochondrial enoyl reductase, putative', 132, NULL, NULL, 45714),
(45715, '3.30.160.60-FF-000248', NULL, 'zinc finger protein 62 homolog isoform X2', 28, NULL, NULL, 45715),
(45716, '1.25.40.120-FF-000034', NULL, 'Uncharacterized protein', 276, NULL, NULL, 45716),
(45717, '3.40.50.300-FF-006538', NULL, 'Uncharacterized protein', 108, NULL, NULL, 45717),
(45718, '1.10.150.20-FF-000265', NULL, 'Predicted protein', 62, NULL, NULL, 45718),
(45719, '1.25.40.10-FF-002260', NULL, 'AGAP001809-PA', 112, NULL, NULL, 45719),
(45720, '1.20.1110.10-FF-000195', NULL, NULL, 131, NULL, NULL, 45720),
(45721, '3.30.160.60-FF-004115', NULL, NULL, 37, NULL, NULL, 45721),
(45722, '1.20.5.30-FF-000002', NULL, 'matrilin-4 isoform X1', 43, NULL, NULL, 45722),
(45723, '3.10.10.10-FF-000050', NULL, NULL, 124, NULL, NULL, 45723),
(45724, '2.170.150.20-FF-000004', NULL, 'Peptide-methionine (R)-S-oxide reductase', 143, NULL, NULL, 45724),
(45725, '3.40.50.720-FF-001257', NULL, 'Fatty acyl-CoA reductase', 342, NULL, NULL, 45725),
(45726, '1.10.287.70-FF-000338', NULL, 'Ion transport protein/Polycystin cation channel, putative', 136, NULL, NULL, 45726),
(45727, '3.30.450.60-FF-000063', NULL, 'AP complex subunit sigma', 98, NULL, NULL, 45727),
(45728, '1.25.40.20-FF-000172', NULL, 'Ankyrin repeat domain-containing protein 2', 137, NULL, NULL, 45728),
(45729, '1.20.1250.20-FF-001871', NULL, 'Os02g0832100 protein', 108, NULL, NULL, 45729),
(45730, '1.10.8.60-FF-000293', NULL, 'WGS project CABT00000000 data, contig 2.3', 141, NULL, NULL, 45730),
(45731, '1.25.10.10-FF-000982', NULL, 'Hypothetical_protein_-_conserved', 290, NULL, NULL, 45731),
(45732, '3.80.10.10-FF-000182', NULL, 'volume-regulated anion channel subunit LRRC8C isoform X2', 169, NULL, NULL, 45732),
(45733, '3.90.79.10-FF-000070', NULL, 'Nucleoside diphosphate hydrolase, putative', 184, NULL, NULL, 45733),
(45734, '1.20.5.50-FF-000008', NULL, 'Cell division protein ZapA', 47, NULL, NULL, 45734),
(45735, '3.90.660.10-FF-000056', NULL, NULL, 102, NULL, NULL, 45735),
(45736, '1.20.940.10-FF-000011', NULL, 'Pre-mRNA-splicing factor 18', 169, NULL, NULL, 45736),
(45737, '3.30.200.20-FF-000027', NULL, 'Putative Cyclin-dependent kinase 1', 84, NULL, NULL, 45737);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(45738, '3.40.50.11350-FF-000049', NULL, 'Uncharacterized protein', 170, NULL, NULL, 45738),
(45739, '3.60.10.10-FF-000238', NULL, 'Uncharacterized protein', 326, NULL, NULL, 45739),
(45740, '1.20.1070.10-FF-000196', NULL, 'Glucagon like peptide 2 receptor', 303, NULL, NULL, 45740),
(45741, '1.20.120.1760-FF-000075', NULL, NULL, 190, NULL, NULL, 45741),
(45742, '1.10.1370.30-FF-000002', NULL, 'M3 family oligoendopeptidase', 564, NULL, NULL, 45742),
(45743, '1.20.1050.10-FF-000189', NULL, 'Uncharacterized protein', 98, NULL, NULL, 45743),
(45744, '3.50.30.30-FF-000151', NULL, 'Uncharacterized protein', 126, NULL, NULL, 45744),
(45745, '2.130.10.10-FF-001412', NULL, 'AGAP010693-PA', 223, NULL, NULL, 45745),
(45746, '3.90.740.10-FF-000034', NULL, 'Leucine--tRNA ligase, mitochondrial', 184, NULL, NULL, 45746),
(45747, '3.50.50.60-FF-001150', NULL, 'Os10g0554300 protein', 71, NULL, NULL, 45747),
(45748, '1.10.287.130-FF-000093', NULL, 'Two-component sensor histidine kinase', 69, NULL, NULL, 45748),
(45749, '1.25.40.10-FF-000635', NULL, 'Serine/threonine-protein kinase ATR', 360, NULL, NULL, 45749),
(45750, '3.30.830.10-FF-000055', NULL, 'Falcilysin', 238, NULL, NULL, 45750),
(45751, '3.40.50.300-FF-008163', NULL, 'Predicted protein', 89, NULL, NULL, 45751),
(45752, '1.10.10.350-FF-000023', NULL, 'Glutamate-tRNA ligase', 93, NULL, NULL, 45752),
(45753, '3.40.50.200-FF-000146', NULL, 'Predicted protein', 58, NULL, NULL, 45753),
(45754, '1.20.1250.20-FF-000466', NULL, 'Uncharacterized protein', 188, NULL, NULL, 45754),
(45755, '3.20.20.80-FF-000391', NULL, 'Beta-galactosidase', 324, NULL, NULL, 45755),
(45756, '1.20.1070.10-FF-001096', NULL, 'Alpha-1A adrenergic receptor', 316, NULL, NULL, 45756),
(45757, '3.40.1360.10-FF-000066', NULL, 'ADR025Wp', 191, NULL, NULL, 45757),
(45758, '2.60.40.150-FF-000780', NULL, 'Uncharacterized protein', 99, NULL, NULL, 45758),
(45759, '2.130.10.10-FF-000900', NULL, 'Periodic tryptophan protein 2', 204, NULL, NULL, 45759),
(45760, '3.30.930.10-FF-000152', NULL, 'Histidine--tRNA ligase', 341, NULL, NULL, 45760),
(45761, '3.40.50.150-FF-001856', NULL, NULL, 282, NULL, NULL, 45761),
(45762, '3.40.50.1820-FF-001081', NULL, 'Carboxypeptidase', 472, NULL, NULL, 45762),
(45763, '3.20.20.70-FF-000854', NULL, NULL, 67, NULL, NULL, 45763),
(45764, '1.20.58.70-FF-000024', NULL, 'Syntaxin, Qa-SNARE family', 201, NULL, NULL, 45764),
(45765, '2.60.40.10-FF-000304', NULL, 'Nectin cell adhesion molecule 1', 114, NULL, NULL, 45765),
(45766, '2.130.10.10-FF-004234', NULL, 'Uncharacterized protein', 144, NULL, NULL, 45766),
(45767, '2.40.33.10-FF-000002', NULL, 'Pyruvate kinase', 97, NULL, NULL, 45767),
(45768, '4.10.1000.10-FF-000113', NULL, 'Predicted protein', 73, NULL, NULL, 45768),
(45769, '1.25.40.10-FF-003457', NULL, 'Pentatricopeptide repeat-containing protein At4g20090', 115, NULL, NULL, 45769),
(45770, '1.20.1070.10-FF-000084', NULL, 'Probable G-protein coupled receptor 22', 110, NULL, NULL, 45770),
(45771, '1.10.510.10-FF-003797', NULL, NULL, 125, NULL, NULL, 45771),
(45772, '2.60.40.1660-FF-000022', NULL, 'ATPase Na+/K+-transporting subunit beta 2a', 90, NULL, NULL, 45772),
(45773, '2.40.10.10-FF-000702', NULL, NULL, 102, NULL, NULL, 45773),
(45774, '2.10.25.10-FF-000665', NULL, 'Merozoite surface protein 10', 44, NULL, NULL, 45774),
(45775, '3.40.50.300-FF-000581', NULL, 'Cystic fibrosis transmembrane conductance regulator', 286, NULL, NULL, 45775),
(45776, '3.40.630.10-FF-000133', NULL, 'VPS70p protein', 265, NULL, NULL, 45776),
(45777, '3.80.10.10-FF-000867', NULL, 'Blast:Protein halfway', 208, NULL, NULL, 45777),
(45778, '1.10.287.1770-FF-000001', NULL, 'Ferrous iron transport protein B', 100, NULL, NULL, 45778),
(45779, '1.10.555.10-FF-000236', NULL, NULL, 217, NULL, NULL, 45779),
(45780, '3.30.40.10-FF-000388', NULL, 'Putative RING zinc finger domain superfamily protein', 80, NULL, NULL, 45780),
(45781, '1.10.506.10-FF-000089', NULL, 'Uncharacterized protein', 101, NULL, NULL, 45781),
(45782, '2.10.50.10-FF-000066', NULL, 'Cysteine repeat modular protein 3', 54, NULL, NULL, 45782);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(45783, '3.20.20.100-FF-000171', NULL, 'Uncharacterized protein', 174, NULL, NULL, 45783),
(45784, '2.60.40.10-FF-001653', NULL, 'Tyrosine-protein kinase receptor TYRO3', 96, NULL, NULL, 45784),
(45785, '1.10.630.10-FF-000467', NULL, 'Cytochrome P450, putative', 150, NULL, NULL, 45785),
(45786, '3.30.710.10-FF-000512', NULL, 'Predicted protein', 122, NULL, NULL, 45786),
(45787, '3.40.50.880-FF-000035', NULL, 'ES1 protein homolog, mitochondrial isoform X1', 228, NULL, NULL, 45787),
(45788, '3.90.70.10-FF-000382', NULL, 'Uncharacterized protein', 387, NULL, NULL, 45788),
(45789, '3.40.50.300-FF-001070', NULL, 'Translocase of chloroplast', 267, NULL, NULL, 45789),
(45790, '1.25.40.20-FF-000121', NULL, 'SMC5-SMC6 complex localization factor protein 1', 143, NULL, NULL, 45790),
(45791, '1.20.1250.20-FF-001820', NULL, 'Predicted protein', 154, NULL, NULL, 45791),
(45792, '3.80.10.10-FF-000928', NULL, 'Peroxidasin homolog', 112, NULL, NULL, 45792),
(45793, '3.80.10.10-FF-000131', NULL, 'acidic leucine-rich nuclear phosphoprotein 32-related protein-like', 163, NULL, NULL, 45793),
(45794, '3.40.50.720-FF-000745', NULL, 'Ktr system potassium uptake protein A', 141, NULL, NULL, 45794),
(45795, '1.10.10.200-FF-000006', NULL, 'Putative transcriptional regulatory protein', 75, NULL, NULL, 45795),
(45796, '1.20.960.30-FF-000001', NULL, 'F-box-like/WD repeat-containing protein TBL1XR1', 90, NULL, NULL, 45796),
(45797, '3.30.70.940-FF-000008', NULL, 'Transcription termination/antitermination protein NusG', 111, NULL, NULL, 45797),
(45798, '3.30.200.20-FF-000976', NULL, 'Serine/threonine protein kinase, putative', 131, NULL, NULL, 45798),
(45799, '3.40.50.300-FF-001867', NULL, 'Dynein heavy chain-like protein', 291, NULL, NULL, 45799),
(45800, '3.30.1330.30-FF-000078', NULL, 'Ribose methyltransferase, putative', 81, NULL, NULL, 45800),
(45801, '1.20.1110.10-FF-000200', NULL, NULL, 112, NULL, NULL, 45801),
(45802, '3.40.50.300-FF-002267', NULL, 'ATP-dependent RNA helicase prh1, putative', 178, NULL, NULL, 45802),
(45803, '3.10.280.10-FF-000011', NULL, 'Uncharacterized protein AT4g32610', 180, NULL, NULL, 45803),
(45804, '2.30.39.10-FF-000033', NULL, 'LP08647p', 129, NULL, NULL, 45804),
(45805, '3.40.50.12430-FF-000002', NULL, 'FoLliCuliN', 125, NULL, NULL, 45805),
(45806, '3.10.660.10-FF-000001', NULL, 'Diphthamide biosynthesis 3', 80, NULL, NULL, 45806),
(45807, '1.25.10.10-FF-001319', NULL, 'HEAT repeat family protein, expressed', 335, NULL, NULL, 45807),
(45808, '1.20.1070.10-FF-000191', NULL, 'Probable G-protein coupled receptor 83', 318, NULL, NULL, 45808),
(45809, '1.10.8.270-FF-000057', NULL, 'Rab GTPase activator, putative', 90, NULL, NULL, 45809),
(45810, '3.30.230.90-FF-000004', NULL, NULL, 98, NULL, NULL, 45810),
(45811, '1.10.472.10-FF-000594', NULL, 'Cyclin A1', 26, NULL, NULL, 45811),
(45812, '3.60.20.10-FF-000183', NULL, NULL, 195, NULL, NULL, 45812),
(45813, '4.10.60.10-FF-000051', NULL, 'Zinc finger protein containing protein', 22, NULL, NULL, 45813),
(45814, '2.120.10.30-FF-000143', NULL, 'Protein roller-3', 257, NULL, NULL, 45814),
(45815, '2.60.40.60-FF-000297', NULL, 'Cadherin 12', 108, NULL, NULL, 45815),
(45816, '3.30.160.60-FF-002553', NULL, 'Zinc finger protein 343', 23, NULL, NULL, 45816),
(45817, '2.60.40.60-FF-000353', NULL, 'Dachsous, isoform B', 106, NULL, NULL, 45817),
(45818, '1.20.1560.10-FF-000784', NULL, 'Uncharacterized protein', 270, NULL, NULL, 45818),
(45819, '3.80.10.10-FF-000187', NULL, 'F-box and leucine rich repeat protein 18', 180, NULL, NULL, 45819),
(45820, '3.40.1190.20-FF-000027', NULL, 'Hydroxyethylthiazole kinase', 268, NULL, NULL, 45820),
(45821, '1.50.40.10-FF-000066', NULL, 'Mitochondrial ornithine transporter 2', 201, NULL, NULL, 45821),
(45822, '1.10.220.150-FF-000060', NULL, 'Uncharacterized protein', 79, NULL, NULL, 45822),
(45823, '3.40.30.10-FF-000477', NULL, 'Eps1p', 119, NULL, NULL, 45823),
(45824, '1.10.506.10-FF-000084', NULL, 'Uncharacterized protein', 129, NULL, NULL, 45824),
(45825, '1.20.58.70-FF-000075', NULL, 'Uncharacterized protein', 216, NULL, NULL, 45825);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(45826, '3.10.450.350-FF-000017', NULL, 'Peptidoglycan-specific endopeptidase, M23 family', 119, NULL, NULL, 45826),
(45827, '3.30.70.850-FF-000021', NULL, 'Predicted protein', 77, NULL, NULL, 45827),
(45828, '3.40.50.300-FF-002374', NULL, 'E3 ubiquitin-protein ligase arc-1', 172, NULL, NULL, 45828),
(45829, '3.40.50.300-FF-004796', NULL, 'DNA helicase', 228, NULL, NULL, 45829),
(45830, '2.60.40.10-FF-006032', NULL, NULL, 69, NULL, NULL, 45830),
(45831, '3.40.190.10-FF-000093', NULL, 'HTH-type transcriptional regulator YidZ', 106, NULL, NULL, 45831),
(45832, '1.20.58.120-FF-000010', NULL, 'BAG family molecular chaperone regulator 6', 92, NULL, NULL, 45832),
(45833, '2.10.25.10-FF-001098', NULL, 'Epidermal growth factor', 41, NULL, NULL, 45833),
(45834, '3.30.460.50-FF-000004', NULL, 'Poly(A) polymerase, putative', 91, NULL, NULL, 45834),
(45835, '1.25.40.10-FF-004002', NULL, 'Uncharacterized protein', 207, NULL, NULL, 45835),
(45836, '1.20.58.1000-FF-000002', NULL, 'Transcriptional repressor FrmR', 91, NULL, NULL, 45836),
(45837, '1.10.472.10-FF-000650', NULL, 'Retinoblastoma-like 1 (p107)', 108, NULL, NULL, 45837),
(45838, '3.90.280.10-FF-000015', NULL, 'PEBP-like protein', 184, NULL, NULL, 45838),
(45839, '1.10.490.10-FF-000023', NULL, 'GLoBin related', 154, NULL, NULL, 45839),
(45840, '3.30.420.40-FF-000173', NULL, 'Xylulose kinase', 243, NULL, NULL, 45840),
(45841, '2.10.25.10-FF-001154', NULL, 'Laminin subunit alpha 5', 49, NULL, NULL, 45841),
(45842, '1.10.238.10-FF-000382', NULL, 'Uncharacterized protein', 90, NULL, NULL, 45842),
(45843, '3.30.40.10-FF-002361', NULL, 'Ubiquitinyl hydrolase 1', 136, NULL, NULL, 45843),
(45844, '3.90.1100.10-FF-000058', NULL, 'Uncharacterized protein', 181, NULL, NULL, 45844),
(45845, '3.30.160.60-FF-004975', NULL, NULL, 36, NULL, NULL, 45845),
(45846, '3.40.50.970-FF-000062', NULL, 'Acetolactate synthase, catabolic', 191, NULL, NULL, 45846),
(45847, '3.50.50.60-FF-001043', NULL, 'Protoporphyrinogen IX oxidase2', 35, NULL, NULL, 45847),
(45848, '3.90.70.10-FF-000786', NULL, 'Uncharacterized protein', 346, NULL, NULL, 45848),
(45849, '3.30.160.60-FF-001209', NULL, 'Zinc finger and BTB domain-containing protein 38', 29, NULL, NULL, 45849),
(45850, '1.10.10.410-FF-000007', NULL, 'Aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase subunit B', 62, NULL, NULL, 45850),
(45851, '3.40.50.300-FF-004852', NULL, 'Putative ribosome-releasing factor 2 mitochondrial', 194, NULL, NULL, 45851),
(45852, '1.10.132.60-FF-000038', NULL, 'DNA polymerase B region', 153, NULL, NULL, 45852),
(45853, '1.25.40.10-FF-001192', NULL, 'Pentatricopeptide repeat-containing protein', 105, NULL, NULL, 45853),
(45854, '3.40.50.10330-FF-000075', NULL, 'ATP-NADH kinase, putative', 167, NULL, NULL, 45854),
(45855, '3.40.50.720-FF-002325', NULL, 'Uncharacterized protein', 121, NULL, NULL, 45855),
(45856, '3.10.110.10-FF-000246', NULL, 'Predicted protein', 116, NULL, NULL, 45856),
(45857, '3.90.190.10-FF-000076', NULL, 'Paladin isoform B', 251, NULL, NULL, 45857),
(45858, '2.130.10.10-FF-002317', NULL, 'Uncharacterized protein', 130, NULL, NULL, 45858),
(45859, '1.10.8.50-FF-000020', NULL, 'Fibronectin-binding domain-containing protein', 70, NULL, NULL, 45859),
(45860, '3.30.420.40-FF-000280', NULL, 'Actin-like protein, putative', 104, NULL, NULL, 45860),
(45861, '3.40.50.300-FF-006589', NULL, 'Torsin family 2, member A', 98, NULL, NULL, 45861),
(45862, '3.20.20.80-FF-000239', NULL, 'Pullulanase 1, chloroplastic', 580, NULL, NULL, 45862),
(45863, '1.20.920.60-FF-000002', NULL, 'Uncharacterized protein', 188, NULL, NULL, 45863),
(45864, '1.20.1540.10-FF-000064', NULL, 'Rhomboid protease AarA', 211, NULL, NULL, 45864),
(45865, '3.30.450.190-FF-000004', NULL, 'Small monomeric GTPase (Gtr2)', 140, NULL, NULL, 45865),
(45866, '3.40.30.10-FF-000426', NULL, 'Putative Disulfide-isomerase A4', 113, NULL, NULL, 45866),
(45867, '1.10.510.10-FF-001829', NULL, NULL, 128, NULL, NULL, 45867),
(45868, '1.20.1070.10-FF-001101', NULL, 'G protein-coupled receptor 78a', 313, NULL, NULL, 45868),
(45869, '1.20.1420.10-FF-000010', NULL, 'Rhea, isoform B', 154, NULL, NULL, 45869);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(45870, '2.30.180.10-FF-000188', NULL, NULL, 118, NULL, NULL, 45870),
(45871, '1.10.8.270-FF-000006', NULL, 'Small G protein signaling modulator 2', 87, NULL, NULL, 45871),
(45872, '2.60.60.20-FF-000016', NULL, 'Polycystin family receptor for egg jelly', 121, NULL, NULL, 45872),
(45873, '3.80.10.10-FF-000923', NULL, 'Flyers-cup, isoform F', 174, NULL, NULL, 45873),
(45874, '1.10.10.2150-FF-000001', NULL, 'Ribosomal RNA-processing protein 8', 51, NULL, NULL, 45874),
(45875, '3.30.1150.10-FF-000030', NULL, NULL, 127, NULL, NULL, 45875),
(45876, '1.20.120.530-FF-000014', NULL, 'GntR family transcriptional regulator', 153, NULL, NULL, 45876),
(45877, '1.10.510.10-FF-003393', NULL, NULL, 308, NULL, NULL, 45877),
(45878, '2.10.25.10-FF-001103', NULL, 'Transmembrane cell adhesion receptor mua-3', 56, NULL, NULL, 45878),
(45879, '1.10.12.10-FF-000053', NULL, 'Enoyl-CoA hydratase', 58, NULL, NULL, 45879),
(45880, '2.60.40.10-FF-000248', NULL, 'peroxidasin homolog', 95, NULL, NULL, 45880),
(45881, '1.20.1070.10-FF-000140', NULL, 'Mas-related G-protein coupled receptor member X2', 301, NULL, NULL, 45881),
(45882, '3.40.50.1820-FF-000861', NULL, 'Palmitoyl-protein thioesterase 1 (ceroid-lipofuscinosis, neuronal 1, infantile)', 186, NULL, NULL, 45882),
(45883, '3.30.110.90-FF-000001', NULL, 'Imidazolonepropionase-like amidohydrolase', 75, NULL, NULL, 45883),
(45884, '3.20.20.190-FF-000034', NULL, 'Glycerophosphodiester phosphodiesterase GDPD2', 300, NULL, NULL, 45884),
(45885, '3.90.190.10-FF-000183', NULL, 'Tyrosine-protein phosphatase 4', 297, NULL, NULL, 45885),
(45886, '1.25.40.70-FF-000069', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit, putative', 121, NULL, NULL, 45886),
(45887, '3.40.30.10-FF-000078', NULL, '39S ribosomal protein L43, mitochondrial', 158, NULL, NULL, 45887),
(45888, '3.40.50.10860-FF-000003', NULL, 'Glutamate dehydrogenase', 144, NULL, NULL, 45888),
(45889, '1.10.246.120-FF-000002', NULL, 'rab5 GDP/GTP exchange factor isoform X1', 103, NULL, NULL, 45889),
(45890, '3.40.50.300-FF-007606', NULL, 'ATP-dependent helicase (DinG family)', 159, NULL, NULL, 45890),
(45891, '3.40.50.300-FF-002031', NULL, 'RNA cytidine acetyltransferase', 158, NULL, NULL, 45891),
(45892, '2.10.110.10-FF-000340', NULL, 'Uncharacterized protein', 88, NULL, NULL, 45892),
(45893, '1.20.1070.10-FF-001152', NULL, 'C-X-C chemokine receptor type 1', 373, NULL, NULL, 45893),
(45894, '2.70.150.10-FF-000054', NULL, 'Phospholipid-transporting ATPase', 175, NULL, NULL, 45894),
(45895, '1.25.10.10-FF-001364', NULL, 'WGS project CABT00000000 data, contig 2.52', 1003, NULL, NULL, 45895),
(45896, '1.10.510.10-FF-001088', NULL, 'Uncharacterized protein', 342, NULL, NULL, 45896),
(45897, '1.10.10.820-FF-000012', NULL, 'Chitin synthase ChsE', 71, NULL, NULL, 45897),
(45898, '1.50.40.10-FF-000515', NULL, 'Predicted protein', 194, NULL, NULL, 45898),
(45899, '3.40.50.12390-FF-000001', NULL, '5''-3'' exoribonuclease', 225, NULL, NULL, 45899),
(45900, '3.10.260.10-FF-000009', NULL, 'Enhanced filamentous growth protein 1', 127, NULL, NULL, 45900),
(45901, '1.20.1070.10-FF-001500', NULL, 'Uncharacterized protein', 199, NULL, NULL, 45901),
(45902, '3.30.70.330-FF-001731', NULL, NULL, 92, NULL, NULL, 45902),
(45903, '2.60.120.200-FF-000815', NULL, 'Calreticulin-2', 78, NULL, NULL, 45903),
(45904, '3.40.250.10-FF-000148', NULL, 'Uncharacterized protein', 94, NULL, NULL, 45904),
(45905, '1.20.58.1020-FF-000008', NULL, 'Uncharacterized protein', 110, NULL, NULL, 45905),
(45906, '1.10.579.10-FF-000004', NULL, 'Cryptochrome-1', 220, NULL, NULL, 45906),
(45907, '3.60.15.10-FF-000053', NULL, 'protein artemis isoform X2', 75, NULL, NULL, 45907),
(45908, '2.60.40.10-FF-003469', NULL, NULL, 126, NULL, NULL, 45908),
(45909, '3.40.50.720-FF-002269', NULL, 'Phosphoglycerate dehydrogenase', 39, NULL, NULL, 45909),
(45910, '1.10.10.670-FF-000001', NULL, 'Photosystem II CP43 reaction center protein', 96, NULL, NULL, 45910),
(45911, '3.10.450.220-FF-000001', NULL, '60S ribosome subunit biogenesis protein NIP7 homolog', 93, NULL, NULL, 45911);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(45912, '3.40.50.10190-FF-000167', NULL, 'Predicted protein', 98, NULL, NULL, 45912),
(45913, '1.25.10.10-FF-001943', NULL, 'Uncharacterized protein', 313, NULL, NULL, 45913),
(45914, '1.25.40.20-FF-001537', NULL, 'Espin like', 130, NULL, NULL, 45914),
(45915, '3.40.50.300-FF-006302', NULL, 'Uncharacterized protein', 212, NULL, NULL, 45915),
(45916, '1.20.58.760-FF-000027', NULL, 'Uncharacterized protein', 142, NULL, NULL, 45916),
(45917, '1.10.10.10-FF-001740', NULL, 'ATP-dependent DNA helicase, RecQ family', 63, NULL, NULL, 45917),
(45918, '3.30.470.10-FF-000009', NULL, 'D-alanine aminotransferase', 118, NULL, NULL, 45918),
(45919, '3.30.870.10-FF-000052', NULL, 'Polyphosphate kinase', 184, NULL, NULL, 45919),
(45920, '3.10.250.10-FF-000127', NULL, NULL, 101, NULL, NULL, 45920),
(45921, '1.25.40.10-FF-002496', NULL, 'Uncharacterized protein', 172, NULL, NULL, 45921),
(45922, '3.10.490.20-FF-000007', NULL, 'Dynein cytoplasmic 2 heavy chain 1', 132, NULL, NULL, 45922),
(45923, '2.40.170.20-FF-000082', NULL, 'Transporter, outer membrane receptor (OMR) family', 525, NULL, NULL, 45923),
(45924, '3.10.110.10-FF-000297', NULL, 'Ubiquitin-conjugating enzyme E2 6, putative', 105, NULL, NULL, 45924),
(45925, '1.20.1070.10-FF-000876', NULL, 'Adhesion G protein-coupled receptor L4', 164, NULL, NULL, 45925),
(45926, '1.10.287.2620-FF-000003', NULL, 'Dynein, axonemal, heavy chain 5', 66, NULL, NULL, 45926),
(45927, '3.30.200.20-FF-001488', NULL, NULL, 25, NULL, NULL, 45927),
(45928, '3.30.1380.20-FF-000016', NULL, 'Transport protein particle (TRAPP) subunit, putative', 182, NULL, NULL, 45928),
(45929, '3.40.50.150-FF-000895', NULL, 'Cyclopropane fatty acid synthase', 289, NULL, NULL, 45929),
(45930, '2.130.10.10-FF-001356', NULL, 'Excision repair cross-complementation group 8', 143, NULL, NULL, 45930),
(45931, '3.30.420.40-FF-000128', NULL, 'actin-related protein 7', 114, NULL, NULL, 45931),
(45932, '2.130.10.10-FF-003778', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit', 316, NULL, NULL, 45932),
(45933, '3.80.10.10-FF-002660', NULL, 'Leucine-rich receptor-like protein kinase family protein', 257, NULL, NULL, 45933),
(45934, '2.60.40.10-FF-004582', NULL, NULL, 96, NULL, NULL, 45934),
(45935, '3.50.50.60-FF-001442', NULL, 'Uncharacterized protein', 100, NULL, NULL, 45935),
(45936, '3.30.40.10-FF-001405', NULL, 'TNF Receptor Associated Factor (TRAF) homolog', 107, NULL, NULL, 45936),
(45937, '1.25.40.10-FF-002552', NULL, 'Uncharacterized protein', 99, NULL, NULL, 45937),
(45938, '2.130.10.10-FF-006027', NULL, 'Probable elongator complex protein 2', 128, NULL, NULL, 45938),
(45939, '2.60.200.20-FF-000142', NULL, 'AGAP005926-PA', 122, NULL, NULL, 45939),
(45940, '3.40.50.10610-FF-000001', NULL, 'Curli production assembly/transport component CsgG', 96, NULL, NULL, 45940),
(45941, '3.30.420.40-FF-000965', NULL, 'Uncharacterized protein', 33, NULL, NULL, 45941),
(45942, '2.40.37.20-FF-000008', NULL, NULL, 132, NULL, NULL, 45942),
(45943, '3.30.300.20-FF-000068', NULL, 'GTPase Era, mitochondrial-like', 89, NULL, NULL, 45943),
(45944, '1.10.1420.10-FF-000136', NULL, 'Endonuclease MutS2', 113, NULL, NULL, 45944),
(45945, '4.10.320.60-FF-000003', NULL, 'Mitochondrial FAD-linked sulfhydryl oxidase erv1', 33, NULL, NULL, 45945),
(45946, '3.40.50.2300-FF-001415', NULL, NULL, 56, NULL, NULL, 45946),
(45947, '1.20.900.10-FF-000065', NULL, 'T-cell activation Rho GTPase activating protein, putative', 195, NULL, NULL, 45947),
(45948, '3.40.50.720-FF-001313', NULL, 'Uncharacterized protein', 216, NULL, NULL, 45948),
(45949, '3.30.420.10-FF-000529', NULL, NULL, 100, NULL, NULL, 45949),
(45950, '3.10.100.10-FF-000420', NULL, NULL, 86, NULL, NULL, 45950),
(45951, '3.40.50.1000-FF-000727', NULL, NULL, 77, NULL, NULL, 45951),
(45952, '3.80.10.10-FF-002784', NULL, 'Uncharacterized protein', 153, NULL, NULL, 45952),
(45953, '3.30.710.10-FF-000220', NULL, 'BTB/POZ and TAZ domain-containing protein 2', 116, NULL, NULL, 45953),
(45954, '2.130.10.10-FF-005627', NULL, 'Uncharacterized protein', 180, NULL, NULL, 45954);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(45955, '3.40.50.740-FF-000010', NULL, 'Thiosulfate reductase PhsA', 312, NULL, NULL, 45955),
(45956, '3.90.290.10-FF-000016', NULL, 'latent-transforming growth factor beta-binding protein 4 isoform X1', 71, NULL, NULL, 45956),
(45957, '1.10.510.10-FF-003792', NULL, NULL, 128, NULL, NULL, 45957),
(45958, '3.30.70.890-FF-000010', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 125, NULL, NULL, 45958),
(45959, '1.20.1070.10-FF-000932', NULL, 'Uncharacterized protein', 273, NULL, NULL, 45959),
(45960, '2.130.10.10-FF-001305', NULL, 'Unplaced genomic scaffold supercont2.2, whole genome shotgun sequence', 281, NULL, NULL, 45960),
(45961, '2.30.130.40-FF-000008', NULL, 'Lon protease homolog 2, peroxisomal', 124, NULL, NULL, 45961),
(45962, '1.25.40.690-FF-000014', NULL, 'Nuclear pore complex protein Nup98-Nup96', 91, NULL, NULL, 45962),
(45963, '1.10.630.10-FF-000523', NULL, 'Uncharacterized protein', 397, NULL, NULL, 45963),
(45964, '2.30.29.30-FF-001382', NULL, 'Uncharacterized protein', 121, NULL, NULL, 45964),
(45965, '1.50.40.10-FF-000459', NULL, 'Uncharacterized protein', 93, NULL, NULL, 45965),
(45966, '1.25.10.10-FF-001887', NULL, 'Uncharacterized protein', 335, NULL, NULL, 45966),
(45967, '3.40.50.1460-FF-000106', NULL, 'Uncharacterized protein', 126, NULL, NULL, 45967),
(45968, '1.20.120.1080-FF-000141', NULL, 'Predicted protein', 162, NULL, NULL, 45968),
(45969, '3.10.450.240-FF-000007', NULL, '39S ribosomal protein L45, mitochondrial isoform X2', 66, NULL, NULL, 45969),
(45970, '2.170.270.10-FF-000117', NULL, 'PR domain zinc finger protein 10', 56, NULL, NULL, 45970),
(45971, '2.10.25.10-FF-001047', NULL, 'GM21210', 35, NULL, NULL, 45971),
(45972, '3.90.460.10-FF-000001', NULL, 'Ferredoxin-thioredoxin reductase, catalytic chain', 115, NULL, NULL, 45972),
(45973, '3.40.50.300-FF-002323', NULL, 'ADP-ribosylation factor, putative', 164, NULL, NULL, 45973),
(45974, '1.10.10.60-FF-001289', NULL, NULL, 52, NULL, NULL, 45974),
(45975, '3.30.200.20-FF-001544', NULL, 'Probable protein kinase DDB_G0291133', 110, NULL, NULL, 45975),
(45976, '2.20.100.10-FF-000174', NULL, 'GD10852', 84, NULL, NULL, 45976),
(45977, '1.20.1090.10-FF-000023', NULL, '3-dehydroquinate synthase', 190, NULL, NULL, 45977),
(45978, '3.30.70.330-FF-001675', NULL, 'Ribonucleoprotein, putative (AFU_orthologue AFUA_7G05810)', 123, NULL, NULL, 45978),
(45979, '3.40.50.800-FF-000106', NULL, 'Histidine-tRNA ligase', 106, NULL, NULL, 45979),
(45980, '3.90.980.20-FF-000021', NULL, 'GD21826', 158, NULL, NULL, 45980),
(45981, '3.20.20.140-FF-000391', NULL, 'Uncharacterized protein MJ1587', 166, NULL, NULL, 45981),
(45982, '3.40.50.300-FF-001923', NULL, 'DEAD/DEAH box helicase', 139, NULL, NULL, 45982),
(45983, '2.60.40.10-FF-002721', NULL, 'Anosmin 1', 125, NULL, NULL, 45983),
(45984, '3.40.50.300-FF-006246', NULL, 'DNA excision repair protein ERCC-6-like protein', 208, NULL, NULL, 45984),
(45985, '2.60.120.10-FF-000256', NULL, 'Cyclic nucleotide-binding domain-containing protein', 138, NULL, NULL, 45985),
(45986, '3.40.50.300-FF-005285', NULL, 'Ras family protein', 177, NULL, NULL, 45986),
(45987, '3.10.105.10-FF-000116', NULL, 'Putative solute-binding lipoprotein', 193, NULL, NULL, 45987),
(45988, '3.50.30.30-FF-000156', NULL, 'Peptide hydrolase', 107, NULL, NULL, 45988),
(45989, '3.30.160.60-FF-006032', NULL, NULL, 25, NULL, NULL, 45989),
(45990, '2.30.30.380-FF-000027', NULL, 'Sfb3p', 75, NULL, NULL, 45990),
(45991, '3.30.505.10-FF-000035', NULL, 'phosphatidylinositol 3,4,5-trisphosphate 5-phosphatase 1', 112, NULL, NULL, 45991),
(45992, '2.130.10.10-FF-005228', NULL, 'WD repeat-containing protein 91 homolog', 60, NULL, NULL, 45992),
(45993, '3.20.20.70-FF-000562', NULL, 'Isopentenyl-diphosphate delta-isomerase (Type II)', 346, NULL, NULL, 45993),
(45994, '3.40.50.300-FF-002935', NULL, 'RNA helicase', 240, NULL, NULL, 45994),
(45995, '1.25.40.10-FF-003513', NULL, 'Uncharacterized protein', 199, NULL, NULL, 45995),
(45996, '2.130.10.10-FF-001980', NULL, 'WD-repeat membrane protein', 174, NULL, NULL, 45996),
(45997, '3.30.870.10-FF-000001', NULL, 'Polyphosphate kinase', 183, NULL, NULL, 45997);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(45998, '4.10.1000.10-FF-000057', NULL, 'Expressed protein', 32, NULL, NULL, 45998),
(45999, '1.10.10.60-FF-000889', NULL, NULL, 77, NULL, NULL, 45999),
(46000, '3.30.40.10-FF-000444', NULL, 'Nitric oxide synthase-interacting protein', 107, NULL, NULL, 46000),
(46001, '1.10.30.10-FF-000050', NULL, 'Nuclear autoantigen Sp-100', 61, NULL, NULL, 46001),
(46002, '1.20.870.10-FF-000016', NULL, 'Uncharacterized protein, isoform B', 142, NULL, NULL, 46002),
(46003, '3.40.830.10-FF-000007', NULL, 'Extradiol ring-cleavage dioxygenase, putative', 266, NULL, NULL, 46003),
(46004, '3.30.160.20-FF-000028', NULL, 'ATP-dependent RNA helicase A', 96, NULL, NULL, 46004),
(46005, '3.40.50.1460-FF-000090', NULL, 'Uncharacterized protein', 205, NULL, NULL, 46005),
(46006, '1.20.120.1910-FF-000053', NULL, 'Cysteine--tRNA ligase', 137, NULL, NULL, 46006),
(46007, '1.20.900.10-FF-000014', NULL, 'active breakpoint cluster region-related protein isoform X2', 201, NULL, NULL, 46007),
(46008, '2.30.29.30-FF-001331', NULL, 'Uncharacterized protein', 58, NULL, NULL, 46008),
(46009, '3.40.30.10-FF-000134', NULL, 'Protein disulfide-isomerase', 126, NULL, NULL, 46009),
(46010, '3.10.180.10-FF-000071', NULL, 'Lactoylglutathione lyase family protein', 121, NULL, NULL, 46010),
(46011, '2.60.40.10-FF-005942', NULL, NULL, 96, NULL, NULL, 46011),
(46012, '2.30.26.10-FF-000003', NULL, 'Dihydroorotate dehydrogenase (fumarate)', 67, NULL, NULL, 46012),
(46013, '4.10.410.20-FF-000009', NULL, 'Proteoglycan 4', 48, NULL, NULL, 46013),
(46014, '1.20.920.30-FF-000055', NULL, 'Dynein heavy chain family protein', 202, NULL, NULL, 46014),
(46015, '3.40.910.10-FF-000008', NULL, 'Deoxyhypusine synthase', 214, NULL, NULL, 46015),
(46016, '1.20.1280.50-FF-000055', NULL, 'F-box/SPRY domain-containing protein 1', 47, NULL, NULL, 46016),
(46017, '3.50.50.60-FF-001094', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 262, NULL, NULL, 46017),
(46018, '2.130.10.10-FF-005690', NULL, 'Uncharacterized protein', 156, NULL, NULL, 46018),
(46019, '3.40.50.150-FF-000552', NULL, 'Probable RNA methyltransferase CG11342', 238, NULL, NULL, 46019),
(46020, '3.90.190.10-FF-000132', NULL, 'Dual specificity protein phosphatase, putative', 148, NULL, NULL, 46020),
(46021, '2.60.40.10-FF-001760', NULL, 'Murinoglobulin-1', 87, NULL, NULL, 46021),
(46022, '2.60.40.10-FF-005594', NULL, NULL, 87, NULL, NULL, 46022),
(46023, '1.10.510.10-FF-001268', NULL, 'Protein lipid droplet kinase (LDK)', 312, NULL, NULL, 46023),
(46024, '3.10.290.50-FF-000001', NULL, NULL, 97, NULL, NULL, 46024),
(46025, '6.10.140.2220-FF-000034', NULL, 'Putative MYND finger domain protein', 51, NULL, NULL, 46025),
(46026, '3.80.10.10-FF-003060', NULL, 'Protein CBG16793', 331, NULL, NULL, 46026),
(46027, '3.30.70.1230-FF-000187', NULL, 'Adenylate/guanylate cyclase domain-containing protein', 158, NULL, NULL, 46027),
(46028, '3.40.1110.10-FF-000374', NULL, NULL, 160, NULL, NULL, 46028),
(46029, '2.60.40.10-FF-002160', NULL, 'Paired immunoglobulin-like receptor B', 97, NULL, NULL, 46029),
(46030, '3.40.50.200-FF-000202', NULL, 'Proprotein convertase subtilisin/kexin type 4', 323, NULL, NULL, 46030),
(46031, '3.40.47.10-FF-000285', NULL, NULL, 61, NULL, NULL, 46031),
(46032, '3.30.1360.70-FF-000007', NULL, 'Arginine--tRNA ligase', 105, NULL, NULL, 46032),
(46033, '3.30.200.20-FF-002556', NULL, 'Putative serine/threonine protein kinase', 70, NULL, NULL, 46033),
(46034, '1.10.510.10-FF-000812', NULL, 'CMGC/DYRK protein kinase', 83, NULL, NULL, 46034),
(46035, '3.40.718.10-FF-000016', NULL, 'Isocitrate dehydrogenase [NADP]', 412, NULL, NULL, 46035),
(46036, '3.30.1330.30-FF-000022', NULL, '60S ribosomal protein L7a', 143, NULL, NULL, 46036),
(46037, '2.60.40.60-FF-000185', NULL, 'Protocadherin 2 alpha c', 105, NULL, NULL, 46037),
(46038, '2.40.30.10-FF-000316', NULL, 'Ribosome-releasing factor 2, mitochondrial', 123, NULL, NULL, 46038),
(46039, '2.40.50.140-FF-000997', NULL, NULL, 91, NULL, NULL, 46039),
(46040, '3.40.120.10-FF-000032', NULL, 'Udp-glucose-pyrophosphorylase phosphoglucomutase', 130, NULL, NULL, 46040);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(46041, '2.60.40.1910-FF-000024', NULL, NULL, 96, NULL, NULL, 46041),
(46042, '2.30.30.490-FF-000004', NULL, 'DNA (cytosine-5)-methyltransferase', 163, NULL, NULL, 46042),
(46043, '3.60.9.10-FF-000001', NULL, 'Aldehyde:ferredoxin oxidoreductase, tungsten-containing', 208, NULL, NULL, 46043),
(46044, '1.10.10.60-FF-001002', NULL, NULL, 79, NULL, NULL, 46044),
(46045, '1.20.1070.10-FF-000645', NULL, 'Uncharacterized protein', 308, NULL, NULL, 46045),
(46046, '2.60.40.420-FF-000260', NULL, 'Cupredoxin superfamily protein', 70, NULL, NULL, 46046),
(46047, '3.30.70.330-FF-000663', NULL, 'CUGBP Elav-like family member 2', 137, NULL, NULL, 46047),
(46048, '2.80.10.50-FF-000185', NULL, 'Inositol 1,4,5-trisphosphate receptor type 3', 70, NULL, NULL, 46048),
(46049, '1.10.10.60-FF-000384', NULL, 'Transcriptional regulatory protein TOD6', 50, NULL, NULL, 46049),
(46050, '2.80.10.50-FF-000241', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 90, NULL, NULL, 46050),
(46051, '3.30.300.250-FF-000001', NULL, 'Lipoprotein YghG', 110, NULL, NULL, 46051),
(46052, '4.10.800.10-FF-000003', NULL, 'SPARC-related modular calcium-binding protein 2 isoform 1', 69, NULL, NULL, 46052),
(46053, '1.10.10.10-FF-001471', NULL, 'Protein CBG05575', 68, NULL, NULL, 46053),
(46054, '2.40.10.10-FF-000197', NULL, 'chymotrypsin-1', 104, NULL, NULL, 46054),
(46055, '1.10.390.10-FF-000038', NULL, 'Aminopeptidase', 251, NULL, NULL, 46055),
(46056, '2.30.140.10-FF-000011', NULL, 'Polyamine aminopropyltransferase', 56, NULL, NULL, 46056),
(46057, '2.40.10.10-FF-000253', NULL, NULL, 12, NULL, NULL, 46057),
(46058, '1.25.40.10-FF-003856', NULL, 'Uncharacterized protein', 109, NULL, NULL, 46058),
(46059, '3.30.390.60-FF-000001', NULL, 'Heat-inducible transcription repressor HrcA', 102, NULL, NULL, 46059),
(46060, '3.30.70.60-FF-000039', NULL, '30S ribosomal protein S6, chloroplastic', 98, NULL, NULL, 46060),
(46061, '3.40.50.10860-FF-000059', NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', 107, NULL, NULL, 46061),
(46062, '2.60.40.10-FF-004014', NULL, NULL, 99, NULL, NULL, 46062),
(46063, '1.10.10.920-FF-000003', NULL, 'Coproporphyrinogen-III oxidase', 91, NULL, NULL, 46063),
(46064, '2.60.40.150-FF-000336', NULL, 'Protein kinase, putative', 120, NULL, NULL, 46064),
(46065, '1.10.533.10-FF-000163', NULL, 'Putative BOI-related E3 ubiquitin-protein ligase 3', 127, NULL, NULL, 46065),
(46066, '1.20.1390.10-FF-000012', NULL, 'RNA-binding motif protein 25a', 80, NULL, NULL, 46066),
(46067, '2.130.10.10-FF-002429', NULL, 'Periodic tryptophan protein 2 homolog', 244, NULL, NULL, 46067),
(46068, '3.30.60.20-FF-000105', NULL, 'Diacylglycerol kinase', 53, NULL, NULL, 46068),
(46069, '3.40.50.2000-FF-000134', NULL, 'UDP-glucuronosyltransferase 2A2 isoform X1', 132, NULL, NULL, 46069),
(46070, '3.30.70.330-FF-002804', NULL, NULL, 95, NULL, NULL, 46070),
(46071, '2.130.10.10-FF-000288', NULL, 'RAB6A-GEF complex partner protein 1 isoform X3', 275, NULL, NULL, 46071),
(46072, '2.30.30.100-FF-000045', NULL, 'U6 snRNA-associated Sm-like protein LSm1', 127, NULL, NULL, 46072),
(46073, '3.10.290.10-FF-000017', NULL, 'Tyrosine--tRNA ligase', 100, NULL, NULL, 46073),
(46074, '3.40.950.10-FF-000005', NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', 174, NULL, NULL, 46074),
(46075, '1.25.10.10-FF-002668', NULL, 'Uncharacterized protein', 92, NULL, NULL, 46075),
(46076, '2.60.40.10-FF-005650', NULL, NULL, 90, NULL, NULL, 46076),
(46077, '3.30.390.80-FF-000007', NULL, 'Predicted protein', 129, NULL, NULL, 46077),
(46078, '3.40.50.300-FF-002828', NULL, 'PEX6p AAA-peroxin', 170, NULL, NULL, 46078),
(46079, '1.10.287.1080-FF-000002', NULL, 'Histidine biosynthesis bifunctional protein HisIE', 91, NULL, NULL, 46079),
(46080, '1.25.40.990-FF-000042', NULL, 'Predicted protein', 292, NULL, NULL, 46080),
(46081, '2.60.120.40-FF-000035', NULL, 'Elastin microfibril interfacer 2a', 141, NULL, NULL, 46081),
(46082, '2.130.10.10-FF-001917', NULL, 'Transducin (beta)-like 1 X-linked receptor 1a', 266, NULL, NULL, 46082),
(46083, '1.20.920.10-FF-000009', NULL, 'Protein polybromo-1 isoform 1', 146, NULL, NULL, 46083); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(46084, '1.10.10.60-FF-000277', NULL, 'Pre-B-cell leukemia transcription factor 1', 78, NULL, NULL, 46084),
(46085, '1.20.5.400-FF-000004', NULL, 'CD209 molecule', 54, NULL, NULL, 46085),
(46086, '1.20.58.1210-FF-000003', NULL, 'Exocyst complex component EXO84', 122, NULL, NULL, 46086),
(46087, '1.10.3430.10-FF-000081', NULL, 'Uncharacterized protein', 35, NULL, NULL, 46087),
(46088, '3.30.830.10-FF-000167', NULL, 'Mitochondrial-processing peptidase subunit alpha-1', 226, NULL, NULL, 46088),
(46089, '1.25.40.20-FF-001768', NULL, 'Autophagy-related protein', 189, NULL, NULL, 46089),
(46090, '1.20.1440.260-FF-000001', NULL, 'Protein HIT1', 95, NULL, NULL, 46090),
(46091, '3.30.1330.40-FF-000064', NULL, 'Uncharacterized protein', 120, NULL, NULL, 46091),
(46092, '1.10.238.10-FF-000095', NULL, 'dual oxidase 2', 184, NULL, NULL, 46092),
(46093, '1.20.990.10-FF-000014', NULL, 'NADPH-cytochrome p450 reductase', 134, NULL, NULL, 46093),
(46094, '2.60.40.10-FF-005543', NULL, NULL, 30, NULL, NULL, 46094),
(46095, '3.40.50.80-FF-000173', NULL, 'NADPH--cytochrome P450 reductase 2', 121, NULL, NULL, 46095),
(46096, '3.40.50.720-FF-000296', NULL, 'peroxisomal bifunctional enzyme isoform X1', 184, NULL, NULL, 46096),
(46097, '1.10.510.10-FF-003561', NULL, NULL, 223, NULL, NULL, 46097),
(46098, '3.40.50.2000-FF-000078', NULL, 'Glycosyltransferase', 186, NULL, NULL, 46098),
(46099, '1.25.10.10-FF-000690', NULL, 'RING-type E3 ubiquitin transferase', 119, NULL, NULL, 46099),
(46100, '3.40.220.10-FF-000028', NULL, 'Possible lipoprotein lppD', 203, NULL, NULL, 46100),
(46101, '1.25.40.20-FF-000464', NULL, 'Ankyrin-like protein', 143, NULL, NULL, 46101),
(46102, '3.60.15.10-FF-000160', NULL, 'Rhodanese domain protein / beta-lactamase domain protein', 234, NULL, NULL, 46102),
(46103, '1.10.10.10-FF-001139', NULL, 'DNA-binding response regulator', 70, NULL, NULL, 46103),
(46104, '2.60.40.10-FF-002901', NULL, 'Cilia and flagella associated protein 65', 103, NULL, NULL, 46104),
(46105, '3.40.50.410-FF-000208', NULL, 'Voltage-dependent calcium channel subunit alpha-2/delta-1', 213, NULL, NULL, 46105),
(46106, '3.30.420.240-FF-000002', NULL, 'Mu phage large terminase subunit GpE', 194, NULL, NULL, 46106),
(46107, '3.30.565.10-FF-000090', NULL, 'Heme sensor histidine kinase HssS', 152, NULL, NULL, 46107),
(46108, '3.40.50.10190-FF-000274', NULL, 'Putative dna topoisomerase 2-binding protein 1 isoform x1', 94, NULL, NULL, 46108),
(46109, '3.30.60.30-FF-000221', NULL, 'Uncharacterized protein', 57, NULL, NULL, 46109),
(46110, '1.25.40.10-FF-005019', NULL, 'Uncharacterized protein', 114, NULL, NULL, 46110),
(46111, '3.40.30.10-FF-000246', NULL, 'Glutathione peroxidase', 166, NULL, NULL, 46111),
(46112, '2.60.120.10-FF-000604', NULL, 'Mannose-6-phosphate isomerase', 80, NULL, NULL, 46112),
(46113, '3.40.190.10-FF-000598', NULL, 'Dipeptide-binding protein', 118, NULL, NULL, 46113),
(46114, '3.20.20.110-FF-000005', NULL, 'Ribulose bisphosphate carboxylase-like protein', 290, NULL, NULL, 46114),
(46115, '4.10.365.10-FF-000002', NULL, 'cyclin-dependent kinase inhibitor 1C', 79, NULL, NULL, 46115),
(46116, '3.40.50.150-FF-001277', NULL, NULL, 224, NULL, NULL, 46116),
(46117, '3.90.45.10-FF-000019', NULL, 'Peptide deformylase', 165, NULL, NULL, 46117),
(46118, '1.25.10.10-FF-002724', NULL, 'Predicted protein', 926, NULL, NULL, 46118),
(46119, '1.10.8.10-FF-000267', NULL, 'HBS1-like protein', 54, NULL, NULL, 46119),
(46120, '1.25.40.10-FF-001708', NULL, 'Pre-mRNA-processing factor 6-like Protein', 73, NULL, NULL, 46120),
(46121, '3.10.170.20-FF-000011', NULL, 'Cell surface protease gp63 putative', 173, NULL, NULL, 46121),
(46122, '2.170.260.10-FF-000004', NULL, 'Dicer-like 104', 123, NULL, NULL, 46122),
(46123, '3.30.40.10-FF-000101', NULL, 'Integrator complex subunit 12', 64, NULL, NULL, 46123),
(46124, '3.40.50.11210-FF-000024', NULL, NULL, 52, NULL, NULL, 46124),
(46125, '1.10.150.240-FF-000126', NULL, 'Uncharacterized protein', 72, NULL, NULL, 46125),
(46126, '2.30.30.40-FF-000617', NULL, 'Uncharacterized protein', 49, NULL, NULL, 46126);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(46127, '3.40.50.1820-FF-001193', NULL, 'Uncharacterized protein', 86, NULL, NULL, 46127),
(46128, '3.30.460.20-FF-000012', NULL, 'Magnesium and cobalt transport protein', 144, NULL, NULL, 46128),
(46129, '3.50.50.100-FF-000001', NULL, 'NADH dehydrogenase', 409, NULL, NULL, 46129),
(46130, '3.30.450.20-FF-000186', NULL, 'Unplaced genomic scaffold supercont2.18, whole genome shotgun sequence', 119, NULL, NULL, 46130),
(46131, '1.10.150.240-FF-000019', NULL, 'HAD family hydrolase', 65, NULL, NULL, 46131),
(46132, '2.60.220.30-FF-000034', NULL, 'Uncharacterized protein', 149, NULL, NULL, 46132),
(46133, '2.60.40.60-FF-000241', NULL, 'Cadherin 16', 99, NULL, NULL, 46133),
(46134, '3.40.50.300-FF-007090', NULL, 'Uncharacterized protein', 190, NULL, NULL, 46134),
(46135, '3.10.50.40-FF-000095', NULL, 'Peptidylprolyl isomerase', 199, NULL, NULL, 46135),
(46136, '3.40.720.10-FF-000292', NULL, 'WASH complex subunit 7-like Protein', 264, NULL, NULL, 46136),
(46137, '2.30.30.100-FF-000101', NULL, 'AGAP007326-PB', 117, NULL, NULL, 46137),
(46138, '2.70.160.11-FF-000038', NULL, 'Arginine N-methyltransferase, type II, putative', 230, NULL, NULL, 46138),
(46139, '2.20.25.10-FF-000125', NULL, 'Uncharacterized protein', 115, NULL, NULL, 46139),
(46140, '3.30.70.3490-FF-000061', NULL, NULL, 121, NULL, NULL, 46140),
(46141, '3.10.100.10-FF-000240', NULL, NULL, 86, NULL, NULL, 46141),
(46142, '3.50.50.60-FF-000874', NULL, 'Monooxygenase', 378, NULL, NULL, 46142),
(46143, '4.10.640.10-FF-000001', NULL, '30S ribosomal protein S18', 74, NULL, NULL, 46143),
(46144, '3.40.50.12660-FF-000009', NULL, 'Metacaspase-2', 283, NULL, NULL, 46144),
(46145, '3.50.50.60-FF-001274', NULL, 'Flavin-containing monooxygenase', 71, NULL, NULL, 46145),
(46146, '2.150.10.10-FF-000006', NULL, 'RTX-I toxin determinant A from serotypes 5/10', 107, NULL, NULL, 46146),
(46147, '3.40.50.720-FF-001021', NULL, 'NAD-dependent dehydratase', 122, NULL, NULL, 46147),
(46148, '1.25.40.10-FF-001984', NULL, 'Embryo specific2', 112, NULL, NULL, 46148),
(46149, '2.130.10.10-FF-002761', NULL, 'General transcription factor IIIC, polypeptide 2, beta', 253, NULL, NULL, 46149),
(46150, '1.20.1250.20-FF-002091', NULL, 'RE25916p', 261, NULL, NULL, 46150),
(46151, '1.25.10.10-FF-001471', NULL, 'Dynein axonemal assembly factor 5', 213, NULL, NULL, 46151),
(46152, '1.20.120.850-FF-000048', NULL, 'Meiotic recombination protein rdh54', 90, NULL, NULL, 46152),
(46153, '2.30.30.140-FF-000265', NULL, 'Histone acetyltransferase ESA1', 75, NULL, NULL, 46153),
(46154, '4.10.1120.10-FF-000004', NULL, 'Rod phosphodiesterase gamma subunit', 50, NULL, NULL, 46154),
(46155, '1.20.1280.50-FF-000111', NULL, 'F-box and WD domain protein', 85, NULL, NULL, 46155),
(46156, '3.90.1150.10-FF-000117', NULL, 'Cystathionine gamma-synthase', 137, NULL, NULL, 46156),
(46157, '1.10.1200.80-FF-000005', NULL, 'tRNA-dihydrouridine synthase', 69, NULL, NULL, 46157),
(46158, '3.40.630.30-FF-000291', NULL, 'GNAT family acetyltransferase', 136, NULL, NULL, 46158),
(46159, '2.40.30.70-FF-000019', NULL, 'Uncharacterized protein', 109, NULL, NULL, 46159),
(46160, '3.40.50.2300-FF-000847', NULL, 'ETR4 ethylene receptor protein', 133, NULL, NULL, 46160),
(46161, '3.50.50.60-FF-001386', NULL, 'Predicted protein', 42, NULL, NULL, 46161),
(46162, '2.60.200.20-FF-000030', NULL, 'FHA domain-containing protein', 125, NULL, NULL, 46162),
(46163, '3.50.50.60-FF-001330', NULL, 'Uncharacterized protein', 111, NULL, NULL, 46163),
(46164, '3.30.200.20-FF-001252', NULL, 'Nerve growth factor receptor TRKA, putative', 52, NULL, NULL, 46164),
(46165, '3.40.50.10090-FF-000070', NULL, 'Uncharacterized protein', 70, NULL, NULL, 46165),
(46166, '1.10.4050.10-FF-000001', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 110, NULL, NULL, 46166),
(46167, '3.10.330.20-FF-000013', NULL, 'tRNA (adenine(58)-N(1))-methyltransferase', 70, NULL, NULL, 46167),
(46168, '1.20.1560.10-FF-000508', NULL, 'Protein CBR-MRP-6', 357, NULL, NULL, 46168),
(46169, '3.40.50.2300-FF-001359', NULL, NULL, 27, NULL, NULL, 46169);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(46170, '2.60.40.10-FF-004290', NULL, NULL, 114, NULL, NULL, 46170),
(46171, '1.10.510.10-FF-003741', NULL, NULL, 149, NULL, NULL, 46171),
(46172, '3.30.160.60-FF-005863', NULL, NULL, 91, NULL, NULL, 46172),
(46173, '2.130.10.10-FF-000395', NULL, 'lipopolysaccharide-responsive and beige-like anchor protein isoform X2', 120, NULL, NULL, 46173),
(46174, '3.40.1160.10-FF-000085', NULL, 'Acetylglutamate kinase', 296, NULL, NULL, 46174),
(46175, '1.10.472.10-FF-000026', NULL, 'Cyclin-T1-5 like', 151, NULL, NULL, 46175),
(46176, '3.90.810.10-FF-000034', NULL, NULL, 71, NULL, NULL, 46176),
(46177, '1.10.1450.10-FF-000071', NULL, 'Tetraspanin', 78, NULL, NULL, 46177),
(46178, '1.10.880.10-FF-000002', NULL, 'transcription regulator protein BACH2 isoform X1', 87, NULL, NULL, 46178),
(46179, '3.30.160.60-FF-005987', NULL, NULL, 49, NULL, NULL, 46179),
(46180, '1.10.8.10-FF-000087', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 70, NULL, NULL, 46180),
(46181, '1.20.900.10-FF-000121', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF b', 153, NULL, NULL, 46181),
(46182, '3.40.50.300-FF-000794', NULL, 'ATP-dependent RNA helicase', 168, NULL, NULL, 46182),
(46183, '3.40.50.150-FF-000496', NULL, 'Chromosome 21, whole genome shotgun sequence', 338, NULL, NULL, 46183),
(46184, '1.20.920.20-FF-000069', NULL, 'Uncharacterized protein', 205, NULL, NULL, 46184),
(46185, '2.60.120.920-FF-000126', NULL, 'Ryanodine receptor 3', 201, NULL, NULL, 46185),
(46186, '2.10.110.10-FF-000008', NULL, 'Paxillin isoform 1', 59, NULL, NULL, 46186),
(46187, '3.40.605.10-FF-000097', NULL, 'Uncharacterized protein', 99, NULL, NULL, 46187),
(46188, '3.30.200.20-FF-002449', NULL, 'Uncharacterized protein', 60, NULL, NULL, 46188),
(46189, '1.10.10.1760-FF-000002', NULL, '60S ribosomal protein L36', 105, NULL, NULL, 46189),
(46190, '3.10.100.10-FF-000184', NULL, 'Mannose receptor, C type 1b', 136, NULL, NULL, 46190),
(46191, '1.20.1070.10-FF-001444', NULL, 'Uncharacterized protein', 221, NULL, NULL, 46191),
(46192, '2.130.10.10-FF-004846', NULL, 'Uncharacterized protein', 321, NULL, NULL, 46192),
(46193, '3.30.710.10-FF-000113', NULL, 'BTB/POZ domain-containing protein KCTD5', 24, NULL, NULL, 46193),
(46194, '3.30.70.330-FF-000770', NULL, 'Polyadenylate-binding protein, putative', 104, NULL, NULL, 46194),
(46195, '2.170.270.10-FF-000229', NULL, 'Uncharacterized protein', 91, NULL, NULL, 46195),
(46196, '1.10.3080.10-FF-000059', NULL, 'Predicted protein', 458, NULL, NULL, 46196),
(46197, '3.80.10.10-FF-001199', NULL, 'Expressed sequence C87414', 188, NULL, NULL, 46197),
(46198, '3.30.300.130-FF-000038', NULL, NULL, 79, NULL, NULL, 46198),
(46199, '3.30.60.30-FF-000165', NULL, 'Uncharacterized protein', 47, NULL, NULL, 46199),
(46200, '2.40.50.90-FF-000009', NULL, 'tudor domain-containing protein 7 isoform X2', 94, NULL, NULL, 46200),
(46201, '1.10.510.10-FF-003409', NULL, NULL, 296, NULL, NULL, 46201),
(46202, '3.60.20.10-FF-000138', NULL, 'Proteasome subunit alpha type', 244, NULL, NULL, 46202),
(46203, '3.30.70.330-FF-001444', NULL, 'RNA-binding_protein_-_putative', 138, NULL, NULL, 46203),
(46204, '1.10.1650.10-FF-000001', NULL, 'Ribosomal protein L19', 56, NULL, NULL, 46204),
(46205, '3.40.50.150-FF-001620', NULL, NULL, 246, NULL, NULL, 46205),
(46206, '2.40.170.20-FF-000019', NULL, 'TonB-dependent siderophore receptor', 523, NULL, NULL, 46206),
(46207, '3.40.50.300-FF-005577', NULL, 'Uncharacterized protein', 240, NULL, NULL, 46207),
(46208, '2.130.10.10-FF-001069', NULL, 'Related to GLE2-required for nuclear pore complex structure and function', 379, NULL, NULL, 46208),
(46209, '2.60.40.10-FF-005363', NULL, NULL, 64, NULL, NULL, 46209),
(46210, '3.30.200.20-FF-001775', NULL, 'Serine/threonine protein kinase-43', 92, NULL, NULL, 46210),
(46211, '3.40.1180.10-FF-000029', NULL, 'Alkyl transferase', 267, NULL, NULL, 46211),
(46212, '3.30.160.60-FF-001592', NULL, 'Abrupt, isoform A', 65, NULL, NULL, 46212),
(46213, '1.25.40.10-FF-003221', NULL, 'Protein O-mannosyl-transferase TMTC4', 68, NULL, NULL, 46213),
(46214, '3.90.70.10-FF-000730', NULL, 'Uncharacterized protein', 179, NULL, NULL, 46214);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(46215, '3.40.50.2300-FF-001646', NULL, NULL, 241, NULL, NULL, 46215),
(46216, '1.10.510.10-FF-001375', NULL, 'Protein kinase, putative', 115, NULL, NULL, 46216),
(46217, '2.30.29.30-FF-001275', NULL, 'Predicted protein', 98, NULL, NULL, 46217),
(46218, '2.10.110.10-FF-000284', NULL, 'Uncharacterized protein', 75, NULL, NULL, 46218),
(46219, '3.40.50.720-FF-002218', NULL, 'Uncharacterized protein', 114, NULL, NULL, 46219),
(46220, '3.40.800.20-FF-000059', NULL, 'Uncharacterized protein', 55, NULL, NULL, 46220),
(46221, '3.20.20.80-FF-000003', NULL, '1,4-alpha-glucan branching enzyme GlgB', 398, NULL, NULL, 46221),
(46222, '2.30.29.30-FF-000875', NULL, 'Uncharacterized protein', 118, NULL, NULL, 46222),
(46223, '1.25.40.20-FF-000520', NULL, 'Uncharacterized protein', 106, NULL, NULL, 46223),
(46224, '2.60.120.10-FF-000548', NULL, 'Uncharacterized protein', 122, NULL, NULL, 46224),
(46225, '3.30.70.2740-FF-000021', NULL, 'Putative oxidoreductase', 97, NULL, NULL, 46225),
(46226, '3.30.470.160-FF-000005', NULL, 'Inositol polyphosphate multikinase', 296, NULL, NULL, 46226),
(46227, '1.10.287.370-FF-000086', NULL, 'Predicted protein', 106, NULL, NULL, 46227),
(46228, '3.10.20.90-FF-000260', NULL, 'Phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit gamma', 144, NULL, NULL, 46228),
(46229, '4.10.720.10-FF-000002', NULL, 'Putative smad anchor for receptor activation', 31, NULL, NULL, 46229),
(46230, '3.30.160.60-FF-003626', NULL, 'Zinc finger protein', 60, NULL, NULL, 46230),
(46231, '1.10.287.3510-FF-000012', NULL, 'NADH-ubiquinone oxidoreductase chain 4L', 91, NULL, NULL, 46231),
(46232, '2.120.10.80-FF-000129', NULL, 'Kelch domain containing 2', 187, NULL, NULL, 46232),
(46233, '1.10.510.10-FF-002049', NULL, 'Protein CBG09052', 342, NULL, NULL, 46233),
(46234, '2.60.120.520-FF-000001', NULL, '4-deoxy-L-threo-5-hexosulose-uronate ketol-isomerase', 114, NULL, NULL, 46234),
(46235, '3.40.50.300-FF-002143', NULL, 'ATP-dependent DNA helicase RecQ', 193, NULL, NULL, 46235),
(46236, '2.40.30.10-FF-000029', NULL, '116 kDa U5 small nuclear ribonucleoprotein component', 142, NULL, NULL, 46236),
(46237, '3.30.160.60-FF-002266', NULL, 'zinc finger protein 526', 26, NULL, NULL, 46237),
(46238, '1.25.10.10-FF-002612', NULL, 'Uncharacterized protein', 138, NULL, NULL, 46238),
(46239, '1.10.1780.10-FF-000005', NULL, 'protein SUPPRESSOR OF MAX2 1', 167, NULL, NULL, 46239),
(46240, '1.10.3730.20-FF-000067', NULL, 'Uncharacterized protein', 89, NULL, NULL, 46240),
(46241, '2.130.10.10-FF-001013', NULL, 'Coronin', 182, NULL, NULL, 46241),
(46242, '3.30.450.150-FF-000015', NULL, 'UPF0303 protein P4H10.12', 170, NULL, NULL, 46242),
(46243, '1.20.1270.10-FF-000065', NULL, 'DnaK protein', 113, NULL, NULL, 46243),
(46244, '3.40.190.10-FF-000885', NULL, 'Uncharacterized protein', 132, NULL, NULL, 46244),
(46245, '1.20.120.1080-FF-000085', NULL, 'Predicted protein', 105, NULL, NULL, 46245),
(46246, '3.90.1170.20-FF-000009', NULL, 'Nicotinate-nucleotide pyrophosphorylase [carboxylating]', 113, NULL, NULL, 46246),
(46247, '1.20.1560.10-FF-000840', NULL, 'Uncharacterized protein', 652, NULL, NULL, 46247),
(46248, '3.80.10.10-FF-002891', NULL, 'Involucrin', 328, NULL, NULL, 46248),
(46249, '4.10.1040.10-FF-000003', NULL, 'doublesex- and mab-3-related transcription factor 3a-like', 49, NULL, NULL, 46249),
(46250, '2.40.270.10-FF-000018', NULL, 'Predicted protein', 228, NULL, NULL, 46250),
(46251, '1.10.3810.10-FF-000008', NULL, 'Monofunctional biosynthetic peptidoglycan transglycosylase', 192, NULL, NULL, 46251),
(46252, '2.70.130.10-FF-000092', NULL, NULL, 140, NULL, NULL, 46252),
(46253, '3.30.420.10-FF-000630', NULL, NULL, 159, NULL, NULL, 46253),
(46254, '3.60.40.10-FF-000358', NULL, 'Predicted protein', 296, NULL, NULL, 46254),
(46255, '3.30.40.10-FF-000736', NULL, 'RING-type E3 ubiquitin transferase', 99, NULL, NULL, 46255),
(46256, '3.30.200.60-FF-000016', NULL, 'Predicted protein', 95, NULL, NULL, 46256),
(46257, '1.10.287.70-FF-000782', NULL, 'Uncharacterized protein', 87, NULL, NULL, 46257),
(46258, '2.40.50.140-FF-000873', NULL, NULL, 89, NULL, NULL, 46258);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(46259, '2.60.40.10-FF-003918', NULL, NULL, 108, NULL, NULL, 46259),
(46260, '2.40.70.10-FF-000206', NULL, 'Os08g0207800 protein', 176, NULL, NULL, 46260),
(46261, '2.40.10.10-FF-000141', NULL, 'Enterokinase light chain', 243, NULL, NULL, 46261),
(46262, '3.90.550.10-FF-000059', NULL, 'Hexosyltransferase', 277, NULL, NULL, 46262),
(46263, '1.10.630.10-FF-000810', NULL, 'Ent-kaurenoic acid oxidase 1', 299, NULL, NULL, 46263),
(46264, '3.40.50.1780-FF-000028', NULL, 'Uncharacterized protein', 136, NULL, NULL, 46264),
(46265, '1.10.10.60-FF-001058', NULL, NULL, 49, NULL, NULL, 46265),
(46266, '3.30.40.10-FF-001793', NULL, 'Predicted protein', 58, NULL, NULL, 46266),
(46267, '2.130.10.10-FF-004503', NULL, 'LD47540p', 238, NULL, NULL, 46267),
(46268, '3.40.140.10-FF-000207', NULL, 'Uncharacterized protein', 164, NULL, NULL, 46268),
(46269, '3.40.1380.10-FF-000028', NULL, 'ATP synthase subunit gamma, mitochondrial', 215, NULL, NULL, 46269),
(46270, '3.30.70.270-FF-000055', NULL, 'Sensor domain-containing diguanylate cyclase', 159, NULL, NULL, 46270),
(46271, '3.90.550.10-FF-000115', NULL, 'Dolichyl-phosphate beta-glucosyltransferase isoform A', 272, NULL, NULL, 46271),
(46272, '3.40.1170.10-FF-000023', NULL, 'DNA mismatch repair protein Msh2', 148, NULL, NULL, 46272),
(46273, '1.10.20.10-FF-000280', NULL, NULL, 74, NULL, NULL, 46273),
(46274, '3.40.50.300-FF-004560', NULL, 'Dynein heavy chain family protein', 188, NULL, NULL, 46274),
(46275, '3.30.1660.10-FF-000001', NULL, 'Multiple stress resistance protein BhsA', 65, NULL, NULL, 46275),
(46276, '1.20.1270.280-FF-000024', NULL, 'Dynein heavy chain family protein', 166, NULL, NULL, 46276),
(46277, '1.10.1410.10-FF-000074', NULL, 'Terminal uridylyl transferase 4', 54, NULL, NULL, 46277),
(46278, '3.20.70.20-FF-000016', NULL, 'Vitamin B12-dependent ribonucleotide reductase', 315, NULL, NULL, 46278),
(46279, '2.60.40.60-FF-000061', NULL, 'FAT atypical cadherin 3', 107, NULL, NULL, 46279),
(46280, '1.20.1060.20-FF-000024', NULL, NULL, 63, NULL, NULL, 46280),
(46281, '3.40.50.1100-FF-000139', NULL, 'Cysteine synthase CysK', 106, NULL, NULL, 46281),
(46282, '1.25.10.10-FF-003449', NULL, 'HEAT repeat-containing 5B', 223, NULL, NULL, 46282),
(46283, '1.20.1520.10-FF-000006', NULL, 'The ARF-like 2 binding protein BART, putative', 119, NULL, NULL, 46283),
(46284, '2.30.30.40-FF-000056', NULL, 'rho GTPase-activating protein 12 isoform X1', 75, NULL, NULL, 46284),
(46285, '3.40.50.880-FF-000203', NULL, 'Putative glutamine amidotransferase-like protein MJ0138', 202, NULL, NULL, 46285),
(46286, '3.40.50.2300-FF-000286', NULL, 'Histidine kinase', 136, NULL, NULL, 46286),
(46287, '2.40.50.510-FF-000001', NULL, 'RecQ-mediated genome instability protein 1', 97, NULL, NULL, 46287),
(46288, '1.20.272.10-FF-000048', NULL, NULL, 94, NULL, NULL, 46288),
(46289, '3.10.110.10-FF-000353', NULL, 'Uncharacterized protein', 85, NULL, NULL, 46289),
(46290, '3.80.30.20-FF-000023', NULL, 'RNA modification enzyme, MiaB family', 242, NULL, NULL, 46290),
(46291, '1.20.140.150-FF-000033', NULL, 'Natural killer cell granule protein 7', 115, NULL, NULL, 46291),
(46292, '2.60.40.150-FF-000448', NULL, 'Calcium-dependent lipid-binding (CaLB domain) family protein', 87, NULL, NULL, 46292),
(46293, '2.60.40.10-FF-004138', NULL, NULL, 90, NULL, NULL, 46293),
(46294, '1.10.10.60-FF-000620', NULL, 'Mechanosensory protein 3', 68, NULL, NULL, 46294),
(46295, '1.10.10.10-FF-001291', NULL, 'Uncharacterized protein', 42, NULL, NULL, 46295),
(46296, '3.90.70.10-FF-000550', NULL, 'Uncharacterized protein', 263, NULL, NULL, 46296),
(46297, '3.40.20.10-FF-000021', NULL, 'protein flightless-1 homolog isoform X2', 125, NULL, NULL, 46297),
(46298, '1.20.1740.10-FF-000169', NULL, 'Amino acid transporter (Eurofung)', 147, NULL, NULL, 46298),
(46299, '3.10.110.10-FF-000010', NULL, 'Ubiquitin-conjugating enzyme E2-16 kDa', 147, NULL, NULL, 46299),
(46300, '3.90.1720.10-FF-000026', NULL, 'N-acetylmuramoyl-L-alanine amidase', 132, NULL, NULL, 46300),
(46301, '2.40.340.10-FF-000013', NULL, NULL, 68, NULL, NULL, 46301); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(46302, '3.30.420.80-FF-000005', NULL, '39S ribosomal protein L18, mitochondrial', 143, NULL, NULL, 46302),
(46303, '2.60.40.4100-FF-000029', NULL, 'SD02173p', 139, NULL, NULL, 46303),
(46304, '1.25.40.10-FF-004238', NULL, 'Uncharacterized protein', 245, NULL, NULL, 46304),
(46305, '2.40.50.100-FF-000092', NULL, 'EXOSome (Multiexonuclease complex) component', 60, NULL, NULL, 46305),
(46306, '3.40.1390.30-FF-000012', NULL, 'YbgI/family dinuclear metal center protein', 81, NULL, NULL, 46306),
(46307, '3.40.50.300-FF-000518', NULL, 'Dephospho-CoA kinase', 206, NULL, NULL, 46307),
(46308, '3.30.450.200-FF-000002', NULL, 'MAP kinase-activating death domain protein isoform X1', 155, NULL, NULL, 46308),
(46309, '3.30.160.60-FF-003446', NULL, NULL, 31, NULL, NULL, 46309),
(46310, '3.40.50.300-FF-001811', NULL, 'Rab family GTPase', 197, NULL, NULL, 46310),
(46311, '2.60.40.1670-FF-000031', NULL, NULL, 140, NULL, NULL, 46311),
(46312, '3.20.20.220-FF-000038', NULL, 'Proline dehydrogenase', 97, NULL, NULL, 46312),
(46313, '3.30.300.10-FF-000026', NULL, 'Arl-6', 76, NULL, NULL, 46313),
(46314, '3.40.50.300-FF-008450', NULL, 'DNA repair helicase, putative', 58, NULL, NULL, 46314),
(46315, '3.30.70.330-FF-002568', NULL, NULL, 145, NULL, NULL, 46315),
(46316, '1.20.58.2130-FF-000004', NULL, 'YALI0C09614p', 249, NULL, NULL, 46316),
(46317, '3.90.260.10-FF-000071', NULL, 'Uncharacterized protein', 153, NULL, NULL, 46317),
(46318, '2.60.40.60-FF-001022', NULL, 'FAT atypical cadherin 2', 77, NULL, NULL, 46318),
(46319, '3.40.850.10-FF-000278', NULL, 'Si:ch211-63b16.4', 143, NULL, NULL, 46319),
(46320, '1.25.40.10-FF-000927', NULL, 'Pentatricopeptide repeat-containing protein', 242, NULL, NULL, 46320),
(46321, '3.40.50.12760-FF-000022', NULL, 'Uncharacterized protein', 213, NULL, NULL, 46321),
(46322, '2.40.50.1060-FF-000021', NULL, 'DNA-directed RNA polymerase I subunit rpa43', 87, NULL, NULL, 46322),
(46323, '3.40.50.880-FF-000147', NULL, 'Imidazole glycerol phosphate synthase subunit HisH', 210, NULL, NULL, 46323),
(46324, '1.10.600.10-FF-000078', NULL, 'Terpene synthase', 298, NULL, NULL, 46324),
(46325, '3.40.50.620-FF-000884', NULL, 'Uncharacterized protein', 105, NULL, NULL, 46325),
(46326, '4.10.400.10-FF-000130', NULL, 'Low-density lipoprotein receptor-related protein 2', 34, NULL, NULL, 46326),
(46327, '3.40.50.300-FF-005521', NULL, 'DEAH (Asp-Glu-Ala-His) box polypeptide 35', 119, NULL, NULL, 46327),
(46328, '3.90.550.50-FF-000099', NULL, 'Hexosyltransferase', 120, NULL, NULL, 46328),
(46329, '2.130.10.10-FF-003486', NULL, 'F-box and WD domain-containing protein', 293, NULL, NULL, 46329),
(46330, '3.30.9.90-FF-000013', NULL, 'Uncharacterized protein', 86, NULL, NULL, 46330),
(46331, '3.90.470.10-FF-000058', NULL, 'Ac2-210', 58, NULL, NULL, 46331),
(46332, '3.40.190.10-FF-000542', NULL, 'GD15119', 125, NULL, NULL, 46332),
(46333, '3.10.20.90-FF-000821', NULL, 'Autophagy-related protein', 130, NULL, NULL, 46333),
(46334, '2.110.10.10-FF-000002', NULL, 'Matrix metallopeptidase 3', 195, NULL, NULL, 46334),
(46335, '2.10.70.10-FF-000281', NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing 1', 60, NULL, NULL, 46335),
(46336, '3.40.50.12780-FF-000028', NULL, 'Long-chain-fatty-acid--CoA ligase 1', 443, NULL, NULL, 46336),
(46337, '2.60.40.10-FF-003177', NULL, NULL, 86, NULL, NULL, 46337),
(46338, '3.90.70.10-FF-000494', NULL, 'Uncharacterized protein', 365, NULL, NULL, 46338),
(46339, '1.25.40.10-FF-002108', NULL, 'Pentatricopeptide repeat-containing protein At3g61360', 168, NULL, NULL, 46339),
(46340, '2.30.170.20-FF-000016', NULL, '60S ribosomal protein L24', 67, NULL, NULL, 46340),
(46341, '3.30.1520.10-FF-000019', NULL, 'Putative sorting nexin-19', 137, NULL, NULL, 46341),
(46342, '3.90.1260.10-FF-000002', NULL, 'Argininosuccinate synthase', 212, NULL, NULL, 46342),
(46343, '3.30.70.3540-FF-000003', NULL, 'Replicase polyprotein 1ab', 95, NULL, NULL, 46343),
(46344, '1.25.40.10-FF-003277', NULL, 'Uncharacterized protein CaJ7.0066', 137, NULL, NULL, 46344),
(46345, '1.20.1310.20-FF-000061', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 192, NULL, NULL, 46345);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(46346, '1.10.510.10-FF-003685', NULL, NULL, 169, NULL, NULL, 46346),
(46347, '2.30.29.170-FF-000030', NULL, NULL, 69, NULL, NULL, 46347),
(46348, '1.10.510.10-FF-000251', NULL, 'eukaryotic translation initiation factor 2-alpha kinase 3', 199, NULL, NULL, 46348),
(46349, '1.25.40.1040-FF-000054', NULL, 'Uncharacterized protein', 280, NULL, NULL, 46349),
(46350, '2.60.40.60-FF-000746', NULL, 'Predicted protein', 108, NULL, NULL, 46350),
(46351, '3.30.160.60-FF-004683', NULL, NULL, 25, NULL, NULL, 46351),
(46352, '3.30.930.10-FF-000096', NULL, 'ATP phosphoribosyltransferase regulatory subunit', 327, NULL, NULL, 46352),
(46353, '2.10.25.10-FF-000934', NULL, 'Drosophila CRumBs homolog', 41, NULL, NULL, 46353),
(46354, '1.25.40.1030-FF-000012', NULL, 'Secretory 31, isoform B', 408, NULL, NULL, 46354),
(46355, '1.20.140.10-FF-000057', NULL, 'Medium-chain acyl-CoA dehydrogenase, putative', 145, NULL, NULL, 46355),
(46356, '1.50.10.10-FF-000238', NULL, 'alpha-1,2-Mannosidase', 265, NULL, NULL, 46356),
(46357, '2.180.10.10-FF-000027', NULL, 'Uncharacterized protein', 191, NULL, NULL, 46357),
(46358, '1.20.1250.20-FF-000415', NULL, 'Monocarboxylate transporter, putative', 221, NULL, NULL, 46358),
(46359, '2.30.29.30-FF-001095', NULL, 'Uncharacterized protein', 45, NULL, NULL, 46359),
(46360, '3.90.1180.10-FF-000001', NULL, '50S ribosomal protein L13', 142, NULL, NULL, 46360),
(46361, '3.40.50.300-FF-004408', NULL, 'Uncharacterized protein', 184, NULL, NULL, 46361),
(46362, '1.25.40.10-FF-002440', NULL, 'Pentatricopeptide repeat-containing protein At1g62914, mitochondrial', 104, NULL, NULL, 46362),
(46363, '2.60.120.200-FF-000528', NULL, 'Uncharacterized protein', 302, NULL, NULL, 46363),
(46364, '3.30.160.60-FF-004407', NULL, NULL, 57, NULL, NULL, 46364),
(46365, '2.10.25.10-FF-000030', NULL, 'Signal peptide, CUB domain and EGF-like domain-containing 2', 33, NULL, NULL, 46365),
(46366, '1.10.3210.10-FF-000109', NULL, 'Predicted protein', 80, NULL, NULL, 46366),
(46367, '2.60.40.790-FF-000117', NULL, 'Heat shock protein Hsp20', 124, NULL, NULL, 46367),
(46368, '3.40.50.300-FF-000850', NULL, 'Malignant fibrous histiocytoma-amplified sequence 1 homolog', 91, NULL, NULL, 46368),
(46369, '1.10.3930.10-FF-000006', NULL, 'Arginine deiminase', 77, NULL, NULL, 46369),
(46370, '1.10.20.10-FF-000128', NULL, 'Chromatin accessibility complex 14kD protein', 125, NULL, NULL, 46370),
(46371, '2.170.190.11-FF-000005', NULL, 'Molybdopterin biosynthesis MoeA protein', 89, NULL, NULL, 46371),
(46372, '1.10.510.10-FF-004466', NULL, NULL, 275, NULL, NULL, 46372),
(46373, '2.60.40.10-FF-001996', NULL, 'Muscle M-line assembly protein unc-89', 96, NULL, NULL, 46373),
(46374, '2.20.100.10-FF-000129', NULL, 'Zinc metalloproteinase dpy-31', 63, NULL, NULL, 46374),
(46375, '3.30.160.60-FF-000136', NULL, 'GLI family zinc finger 4', 28, NULL, NULL, 46375),
(46376, '2.60.120.200-FF-000708', NULL, 'Uncharacterized protein', 183, NULL, NULL, 46376),
(46377, '3.90.640.10-FF-000094', NULL, 'Actin, putative', 95, NULL, NULL, 46377),
(46378, '3.80.10.10-FF-000474', NULL, 'Si:ch211-214c20.1', 125, NULL, NULL, 46378),
(46379, '3.40.50.300-FF-002087', NULL, 'Cobalt ABC transporter ATP-binding protien', 204, NULL, NULL, 46379),
(46380, '1.10.510.10-FF-004522', NULL, NULL, 219, NULL, NULL, 46380),
(46381, '3.40.50.720-FF-001201', NULL, 'NADPH-dependent reductase BacG', 260, NULL, NULL, 46381),
(46382, '2.130.10.10-FF-000631', NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', 378, NULL, NULL, 46382),
(46383, '2.20.70.10-FF-000196', NULL, 'Rho GTPase-activating protein 27,-like', 55, NULL, NULL, 46383),
(46384, '1.10.150.20-FF-000321', NULL, 'DNA polymerase IV', 51, NULL, NULL, 46384),
(46385, '1.10.287.70-FF-000506', NULL, 'Uncharacterized protein', 156, NULL, NULL, 46385),
(46386, '3.40.50.2300-FF-001303', NULL, NULL, 126, NULL, NULL, 46386),
(46387, '1.50.10.100-FF-000001', NULL, 'dermatan-sulfate epimerase isoform X1', 342, NULL, NULL, 46387),
(46388, '1.20.1600.10-FF-000007', NULL, 'Outer membrane efflux protein', 450, NULL, NULL, 46388);
INSERT INTO "PUBLIC"."MODEL" VALUES
(46389, '2.102.10.10-FF-000054', NULL, 'Uncharacterized protein', 136, NULL, NULL, 46389),
(46390, '2.60.40.60-FF-000802', NULL, 'Protein CBR-CDH-12', 110, NULL, NULL, 46390),
(46391, '3.40.50.11320-FF-000001', NULL, 'Carboxypeptidase', 95, NULL, NULL, 46391),
(46392, '1.10.510.10-FF-000195', NULL, 'pto-interacting protein 1', 212, NULL, NULL, 46392),
(46393, '3.40.390.10-FF-000198', NULL, 'Zinc metalloproteinase', 252, NULL, NULL, 46393),
(46394, '3.40.50.300-FF-007651', NULL, 'Uncharacterized protein', 133, NULL, NULL, 46394),
(46395, '1.25.10.10-FF-000015', NULL, 'Catenin beta-1', 544, NULL, NULL, 46395),
(46396, '2.60.40.10-FF-003233', NULL, 'Interferon gamma receptor 2', 99, NULL, NULL, 46396),
(46397, '3.90.1800.10-FF-000027', NULL, 'DNA-directed RNA polymerase subunit beta', 103, NULL, NULL, 46397),
(46398, '2.40.490.10-FF-000001', NULL, 'Fusion glycoprotein F0', 88, NULL, NULL, 46398),
(46399, '3.20.140.10-FF-000021', NULL, 'Nicotinate phosphoribosyltransferase', 409, NULL, NULL, 46399),
(46400, '3.30.559.10-FF-000266', NULL, 'Acylsugar acyltransferase 3', 212, NULL, NULL, 46400),
(46401, '1.20.91.20-FF-000002', NULL, 'Complement C4-A', 80, NULL, NULL, 46401),
(46402, '1.25.40.10-FF-001147', NULL, 'LD33695p', 68, NULL, NULL, 46402),
(46403, '3.40.190.10-FF-000941', NULL, 'Uncharacterized protein', 28, NULL, NULL, 46403),
(46404, '2.60.40.1760-FF-000013', NULL, 'Alpha glucosidase-like protein', 131, NULL, NULL, 46404),
(46405, '3.30.70.330-FF-001787', NULL, NULL, 89, NULL, NULL, 46405),
(46406, '1.20.58.390-FF-000282', NULL, 'Uncharacterized protein', 59, NULL, NULL, 46406),
(46407, '3.30.200.20-FF-000139', NULL, 'inactive tyrosine-protein kinase transmembrane receptor ROR1', 92, NULL, NULL, 46407),
(46408, '1.10.150.280-FF-000003', NULL, 'Kinesin-like protein KIN-10C', 74, NULL, NULL, 46408),
(46409, '3.20.190.10-FF-000024', NULL, 'Predicted protein', 67, NULL, NULL, 46409),
(46410, '3.40.50.300-FF-007994', NULL, 'Uncharacterized protein', 154, NULL, NULL, 46410),
(46411, '1.10.275.40-FF-000010', NULL, 'XPD (Xeroderma Pigmentosum complementation group D) related', 35, NULL, NULL, 46411),
(46412, '3.30.1510.10-FF-000013', NULL, 'Predicted protein', 105, NULL, NULL, 46412),
(46413, '3.40.50.11950-FF-000009', NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', 60, NULL, NULL, 46413),
(46414, '3.30.1430.10-FF-000012', NULL, 'Ribosomal protein L3', 58, NULL, NULL, 46414),
(46415, '1.20.1070.10-FF-001949', NULL, 'Uncharacterized protein', 209, NULL, NULL, 46415),
(46416, '3.30.710.10-FF-000456', NULL, 'AGAP008506-PA', 135, NULL, NULL, 46416),
(46417, '3.30.200.20-FF-001432', NULL, 'Uncharacterized protein', 93, NULL, NULL, 46417),
(46418, '1.20.1250.20-FF-000359', NULL, 'equilibrative nucleoside transporter 2', 209, NULL, NULL, 46418),
(46419, '2.40.20.10-FF-000023', NULL, 'Cysteine repeat modular protein 1', 114, NULL, NULL, 46419),
(46420, '3.90.228.10-FF-000012', NULL, 'Poly(ADP-ribose) polymerase family member 6', 63, NULL, NULL, 46420),
(46421, '3.30.70.1730-FF-000067', NULL, 'Ribosome assembly factor mrt4', 48, NULL, NULL, 46421),
(46422, '1.10.238.10-FF-000151', NULL, 'Calpain 9', 172, NULL, NULL, 46422),
(46423, '3.10.129.10-FF-000227', NULL, 'Predicted protein', 320, NULL, NULL, 46423),
(46424, '2.60.40.640-FF-000090', NULL, 'YALI0A18359p', 162, NULL, NULL, 46424),
(46425, '3.40.50.1820-FF-001373', NULL, 'Uncharacterized protein', 223, NULL, NULL, 46425),
(46426, '2.10.25.10-FF-000373', NULL, 'sushi, nidogen and EGF-like domain-containing protein 1', 37, NULL, NULL, 46426),
(46427, '1.20.120.1750-FF-000089', NULL, 'Protein CBG27680', 102, NULL, NULL, 46427),
(46428, '3.40.50.300-FF-007319', NULL, 'Si:ch73-170d6.2', 146, NULL, NULL, 46428),
(46429, '3.30.70.330-FF-001388', NULL, 'RNA recognition motif domain containing protein', 190, NULL, NULL, 46429),
(46430, '1.20.1250.20-FF-000758', NULL, 'Mch1p', 458, NULL, NULL, 46430),
(46431, '2.60.120.480-FF-000005', NULL, 'Allantoicase, putative', 195, NULL, NULL, 46431),
(46432, '3.40.1810.10-FF-000051', NULL, NULL, 55, NULL, NULL, 46432);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(46433, '1.10.287.40-FF-000003', NULL, 'Serine--tRNA ligase cytoplasmic', 109, NULL, NULL, 46433),
(46434, '3.40.50.720-FF-000240', NULL, 'SDR family oxidoreductase', 256, NULL, NULL, 46434),
(46435, '3.20.20.70-FF-000798', NULL, NULL, 237, NULL, NULL, 46435),
(46436, '3.40.50.300-FF-003609', NULL, 'Polyphosphate kinase 2', 285, NULL, NULL, 46436),
(46437, '1.10.10.10-FF-001976', NULL, 'Uncharacterized protein', 62, NULL, NULL, 46437),
(46438, '3.90.70.10-FF-000151', NULL, 'Ubiquitinyl hydrolase 1', 224, NULL, NULL, 46438),
(46439, '3.30.200.20-FF-001831', NULL, 'Uncharacterized protein', 117, NULL, NULL, 46439),
(46440, '3.80.10.10-FF-001435', NULL, 'Toll-like receptor 15', 93, NULL, NULL, 46440),
(46441, '1.20.58.60-FF-000583', NULL, 'Spectrin beta chain', 221, NULL, NULL, 46441),
(46442, '4.10.400.10-FF-000074', NULL, 'low-density lipoprotein receptor-related protein 6', 39, NULL, NULL, 46442),
(46443, '3.40.50.2300-FF-000342', NULL, 'Related to serine/threonine protein kinase', 130, NULL, NULL, 46443),
(46444, '1.10.287.110-FF-000204', NULL, 'Co-chaperone-curved DNA binding protein A', 111, NULL, NULL, 46444),
(46445, '3.40.50.1820-FF-000973', NULL, 'Os02g0463500 protein', 271, NULL, NULL, 46445),
(46446, '3.10.20.90-FF-000765', NULL, 'ubiquitin carboxyl-terminal hydrolase 32', 88, NULL, NULL, 46446),
(46447, '1.20.1250.10-FF-000137', NULL, NULL, 65, NULL, NULL, 46447),
(46448, '1.10.560.10-FF-000074', NULL, 'T-complex protein 1 subunit delta, putative', 132, NULL, NULL, 46448),
(46449, '2.130.10.10-FF-003542', NULL, 'QUInine non-avoider', 142, NULL, NULL, 46449),
(46450, '2.60.40.10-FF-002957', NULL, 'Hemicentin-2', 85, NULL, NULL, 46450),
(46451, '3.30.60.20-FF-000049', NULL, 'serine/threonine-protein kinase MRCK gamma isoform X2', 54, NULL, NULL, 46451),
(46452, '3.80.10.10-FF-000636', NULL, 'Leucine rich repeat containing 15', 195, NULL, NULL, 46452),
(46453, '3.40.50.300-FF-003048', NULL, 'Ras-related protein RabN2', 191, NULL, NULL, 46453),
(46454, '3.40.250.10-FF-000036', NULL, 'M-phase inducer phosphatase', 185, NULL, NULL, 46454),
(46455, '3.30.70.100-FF-000032', NULL, 'Copper-exporting P-type ATPase', 63, NULL, NULL, 46455),
(46456, '1.20.120.350-FF-000117', NULL, 'Predicted protein', 165, NULL, NULL, 46456),
(46457, '3.40.50.10420-FF-000006', NULL, 'Lactate utilization protein C', 189, NULL, NULL, 46457),
(46458, '1.10.510.10-FF-000071', NULL, 'Mitogen-activated protein kinase kinase kinase 3 isoform 2', 265, NULL, NULL, 46458),
(46459, '3.30.40.10-FF-001118', NULL, 'Nhl repeat-containing protein', 86, NULL, NULL, 46459),
(46460, '3.30.70.330-FF-002748', NULL, NULL, 88, NULL, NULL, 46460),
(46461, '1.20.1070.10-FF-000988', NULL, 'Uncharacterized protein', 308, NULL, NULL, 46461),
(46462, '2.10.70.10-FF-000005', NULL, 'Chordin-like 1, isoform CRA_c', 42, NULL, NULL, 46462),
(46463, '3.30.200.20-FF-000471', NULL, 'muscle M-line assembly protein unc-89 isoform X5', 50, NULL, NULL, 46463),
(46464, '3.30.830.10-FF-000111', NULL, 'Uncharacterized protein', 224, NULL, NULL, 46464),
(46465, '3.40.710.10-FF-000116', NULL, 'Penicillin-binding proteins 1A and 1B', 375, NULL, NULL, 46465),
(46466, '3.30.70.120-FF-000038', NULL, NULL, 102, NULL, NULL, 46466),
(46467, '3.30.70.330-FF-003024', NULL, NULL, 59, NULL, NULL, 46467),
(46468, '2.60.300.12-FF-000020', NULL, 'HesB domain-containing protein', 104, NULL, NULL, 46468),
(46469, '1.10.274.30-FF-000038', NULL, 'MRG family protein', 124, NULL, NULL, 46469),
(46470, '3.30.565.10-FF-000270', NULL, 'DNA topoisomerase II beta', 94, NULL, NULL, 46470),
(46471, '4.10.240.10-FF-000072', NULL, 'Unplaced genomic scaffold supercont1.201, whole genome shotgun sequence', 41, NULL, NULL, 46471),
(46472, '2.130.10.10-FF-005419', NULL, 'Predicted protein', 208, NULL, NULL, 46472),
(46473, '3.40.1090.10-FF-000045', NULL, 'NTE family protein', 99, NULL, NULL, 46473),
(46474, '2.60.40.720-FF-000001', NULL, 'Runt-related transcription factor', 142, NULL, NULL, 46474),
(46475, '1.50.40.10-FF-000228', NULL, 'Uncharacterized protein', 196, NULL, NULL, 46475);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(46476, '3.40.30.10-FF-000639', NULL, 'Uncharacterized protein', 131, NULL, NULL, 46476),
(46477, '3.40.50.720-FF-002089', NULL, 'HIV-1 Tat interactive protein 2', 137, NULL, NULL, 46477),
(46478, '3.30.160.60-FF-003755', NULL, NULL, 24, NULL, NULL, 46478),
(46479, '1.10.580.10-FF-000030', NULL, 'Citrate synthase', 229, NULL, NULL, 46479),
(46480, '3.30.230.10-FF-000211', NULL, 'Mevalonate kinase', 157, NULL, NULL, 46480),
(46481, '2.60.20.10-FF-000028', NULL, NULL, 51, NULL, NULL, 46481),
(46482, '3.80.10.10-FF-002744', NULL, 'Uncharacterized protein', 308, NULL, NULL, 46482),
(46483, '3.90.550.50-FF-000200', NULL, 'Uncharacterized protein', 184, NULL, NULL, 46483),
(46484, '3.30.200.20-FF-002320', NULL, 'Os08g0374600 protein', 89, NULL, NULL, 46484),
(46485, '1.20.1250.20-FF-002175', NULL, 'Uncharacterized protein', 174, NULL, NULL, 46485),
(46486, '2.30.30.140-FF-000349', NULL, 'Predicted protein', 104, NULL, NULL, 46486),
(46487, '1.50.10.10-FF-000210', NULL, 'Uncharacterized protein', 169, NULL, NULL, 46487),
(46488, '3.30.200.20-FF-000712', NULL, 'WAK-like kinase', 110, NULL, NULL, 46488),
(46489, '1.25.10.10-FF-000291', NULL, 'Cytokinesis protein sepA', 353, NULL, NULL, 46489),
(46490, '1.25.40.1030-FF-000040', NULL, 'COPII coat assembly protein sec16', 419, NULL, NULL, 46490),
(46491, '1.20.58.480-FF-000022', NULL, 'Uncharacterized protein', 72, NULL, NULL, 46491),
(46492, '3.50.50.60-FF-000262', NULL, 'Cholesterol oxidase ChoD', 92, NULL, NULL, 46492),
(46493, '3.40.50.720-FF-001600', NULL, 'Fatty acyl-CoA reductase', 346, NULL, NULL, 46493),
(46494, '1.20.1270.60-FF-000046', NULL, 'Vacuolar protein sorting-associated protein 17', 220, NULL, NULL, 46494),
(46495, '1.10.8.710-FF-000026', NULL, NULL, 109, NULL, NULL, 46495),
(46496, '1.10.472.130-FF-000026', NULL, 'Glutathione S-transferase class-mu 26 kDa isozyme', 156, NULL, NULL, 46496),
(46497, '2.60.120.10-FF-000413', NULL, 'Uncharacterized protein', 143, NULL, NULL, 46497),
(46498, '3.90.1150.220-FF-000005', NULL, 'DNA repair-related protein, putative', 87, NULL, NULL, 46498),
(46499, '1.10.150.20-FF-000113', NULL, 'DNA polymerase theta, putative', 151, NULL, NULL, 46499),
(46500, '3.40.309.10-FF-000122', NULL, 'Aldehyde dehydrogenase', 86, NULL, NULL, 46500),
(46501, '2.60.120.1040-FF-000005', NULL, 'Zinc finger protein, putative', 161, NULL, NULL, 46501),
(46502, '1.10.30.10-FF-000185', NULL, 'Uncharacterized protein', 41, NULL, NULL, 46502),
(46503, '3.40.50.300-FF-002536', NULL, 'Rs1', 246, NULL, NULL, 46503),
(46504, '2.60.40.10-FF-003317', NULL, NULL, 93, NULL, NULL, 46504),
(46505, '3.40.50.2000-FF-001039', NULL, 'Uncharacterized protein', 165, NULL, NULL, 46505),
(46506, '3.90.70.10-FF-000281', NULL, 'ABC transporter ATP-binding/membrane-spanning-hemolysin secretion protein', 139, NULL, NULL, 46506),
(46507, '4.10.640.10-FF-000029', NULL, '30S ribosomal protein S18', 87, NULL, NULL, 46507),
(46508, '3.40.50.300-FF-006870', NULL, 'Uncharacterized protein', 401, NULL, NULL, 46508),
(46509, '3.30.1120.10-FF-000011', NULL, 'Arylsulfatase AtsB', 100, NULL, NULL, 46509),
(46510, '1.10.2000.10-FF-000059', NULL, NULL, 80, NULL, NULL, 46510),
(46511, '2.10.25.10-FF-000766', NULL, 'Complement component C9', 66, NULL, NULL, 46511),
(46512, '3.40.50.20-FF-000059', NULL, 'UDP-N-acetylbacillosamine N-acetyltransferase', 75, NULL, NULL, 46512),
(46513, '3.90.1110.10-FF-000031', NULL, NULL, 172, NULL, NULL, 46513),
(46514, '3.40.50.1000-FF-000059', NULL, 'HAD family hydrolase', 138, NULL, NULL, 46514),
(46515, '1.20.920.10-FF-000105', NULL, 'Zinc finger, MYND-type-containing 11', 112, NULL, NULL, 46515),
(46516, '4.10.280.10-FF-000046', NULL, 'Transcription factor bHLH83', 60, NULL, NULL, 46516),
(46517, '1.20.1740.10-FF-000146', NULL, 'Os01g0945100 protein', 389, NULL, NULL, 46517),
(46518, '1.20.1070.10-FF-000836', NULL, 'Uncharacterized protein', 297, NULL, NULL, 46518),
(46519, '1.10.10.60-FF-000204', NULL, 'transcription factor MYB80', 61, NULL, NULL, 46519),
(46520, '3.90.76.10-FF-000029', NULL, 'Diguanylate phosphodiesterase', 108, NULL, NULL, 46520);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(46521, '1.25.10.10-FF-003045', NULL, 'Uncharacterized protein', 290, NULL, NULL, 46521),
(46522, '1.10.287.70-FF-000237', NULL, 'Voltage-gated Ion Channel (VIC) Superfamily', 114, NULL, NULL, 46522),
(46523, '3.40.50.10490-FF-000066', NULL, 'RpiR family transcriptional regulator', 182, NULL, NULL, 46523),
(46524, '2.60.40.150-FF-000044', NULL, 'dedicator of cytokinesis protein 1', 195, NULL, NULL, 46524),
(46525, '3.10.20.90-FF-000905', NULL, 'Uncharacterized protein', 140, NULL, NULL, 46525),
(46526, '3.30.497.10-FF-000026', NULL, 'Serine protease inhibitor (serpin) 19', 51, NULL, NULL, 46526),
(46527, '1.10.1410.10-FF-000079', NULL, 'Os06g0558766 protein', 55, NULL, NULL, 46527),
(46528, '2.120.10.30-FF-000412', NULL, 'Uncharacterized protein', 186, NULL, NULL, 46528),
(46529, '3.40.30.10-FF-001258', NULL, 'Uncharacterized protein', 111, NULL, NULL, 46529),
(46530, '3.30.160.60-FF-004374', NULL, NULL, 24, NULL, NULL, 46530),
(46531, '1.25.10.10-FF-002056', NULL, 'AP complex subunit beta', 268, NULL, NULL, 46531),
(46532, '3.20.20.140-FF-000244', NULL, 'N-ethylammeline chlorohydrolase', 273, NULL, NULL, 46532),
(46533, '1.25.10.10-FF-000302', NULL, 'Anaphase-promoting complex subunit 1', 195, NULL, NULL, 46533),
(46534, '3.10.450.10-FF-000075', NULL, 'Kininogen 2', 49, NULL, NULL, 46534),
(46535, '2.60.40.10-FF-005251', NULL, NULL, 88, NULL, NULL, 46535),
(46536, '3.30.450.20-FF-000534', NULL, 'Two-component sensor PprA', 132, NULL, NULL, 46536),
(46537, '3.30.160.40-FF-000001', NULL, 'Porphobilinogen deaminase', 86, NULL, NULL, 46537),
(46538, '1.25.40.10-FF-003665', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 105, NULL, NULL, 46538),
(46539, '3.30.200.20-FF-001331', NULL, 'Cysteine-rich RLK (RECEPTOR-like protein kinase) 13', 113, NULL, NULL, 46539),
(46540, '1.10.510.10-FF-003645', NULL, NULL, 187, NULL, NULL, 46540),
(46541, '3.50.50.60-FF-000745', NULL, 'Flavin-binding monooxygenase-like, putative', 182, NULL, NULL, 46541),
(46542, '3.40.630.10-FF-000397', NULL, 'Uncharacterized protein', 304, NULL, NULL, 46542),
(46543, '1.10.8.60-FF-000473', NULL, 'Valosin-containing protein homolog, putative', 71, NULL, NULL, 46543),
(46544, '3.40.50.150-FF-001676', NULL, NULL, 151, NULL, NULL, 46544),
(46545, '3.40.640.10-FF-000223', NULL, 'GntR family transcriptional regulator', 204, NULL, NULL, 46545),
(46546, '3.30.50.10-FF-000001', NULL, 'GATA transcription factor (GATAd)', 50, NULL, NULL, 46546),
(46547, '3.30.2140.20-FF-000027', NULL, 'Uncharacterized protein', 137, NULL, NULL, 46547),
(46548, '3.30.420.10-FF-000496', NULL, NULL, 153, NULL, NULL, 46548),
(46549, '1.10.560.10-FF-000130', NULL, 'Uncharacterized protein', 53, NULL, NULL, 46549),
(46550, '1.20.120.430-FF-000023', NULL, 'tRNA modification GTPase MnmE', 168, NULL, NULL, 46550),
(46551, '4.10.950.10-FF-000002', NULL, '60S ribosomal protein L2', 78, NULL, NULL, 46551),
(46552, '3.30.200.20-FF-001701', NULL, NULL, 59, NULL, NULL, 46552),
(46553, '2.30.30.490-FF-000083', NULL, 'Uncharacterized protein', 165, NULL, NULL, 46553),
(46554, '1.20.1070.10-FF-001781', NULL, 'Uncharacterized protein', 327, NULL, NULL, 46554),
(46555, '1.10.940.10-FF-000013', NULL, 'Transcription antitermination protein NusB', 136, NULL, NULL, 46555),
(46556, '3.30.160.60-FF-004711', NULL, NULL, 49, NULL, NULL, 46556),
(46557, '3.30.1120.30-FF-000017', NULL, 'Serine/threonine-protein kinase PLK', 87, NULL, NULL, 46557),
(46558, '1.20.120.1630-FF-000019', NULL, 'Possible conserved transmembrane protein', 199, NULL, NULL, 46558),
(46559, '3.60.10.10-FF-000093', NULL, 'Exodeoxyribonuclease III, putative', 224, NULL, NULL, 46559),
(46560, '3.40.630.30-FF-000453', NULL, 'Uncharacterized protein', 229, NULL, NULL, 46560),
(46561, '3.40.50.300-FF-002166', NULL, 'BnaAnng32580D protein', 233, NULL, NULL, 46561),
(46562, '3.40.50.1000-FF-000222', NULL, 'NLI interacting factor-like phosphatase', 232, NULL, NULL, 46562),
(46563, '3.40.630.30-FF-000144', NULL, 'Putatative acetyltransferase', 142, NULL, NULL, 46563),
(46564, '1.10.150.50-FF-000009', NULL, 'Stromal interaction molecule 1', 68, NULL, NULL, 46564);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(46565, '1.20.120.1250-FF-000001', NULL, 'GM23464', 130, NULL, NULL, 46565),
(46566, '3.40.50.460-FF-000044', NULL, 'Phosphofructokinase, putative', 54, NULL, NULL, 46566),
(46567, '3.30.530.20-FF-000052', NULL, 'Coenzyme Q', 151, NULL, NULL, 46567),
(46568, '3.20.20.120-FF-000025', NULL, 'ENO3 isoform 7', 156, NULL, NULL, 46568),
(46569, '3.10.20.90-FF-000422', NULL, 'Ubiquitin-specific protease', 111, NULL, NULL, 46569),
(46570, '2.60.40.10-FF-003789', NULL, NULL, 102, NULL, NULL, 46570),
(46571, '2.40.160.20-FF-000036', NULL, 'Outer membrane protein MopB', 168, NULL, NULL, 46571),
(46572, '3.90.850.10-FF-000020', NULL, 'Putative 4-hydroxyphenylacetate degradation bifunctional isomerase', 211, NULL, NULL, 46572),
(46573, '3.30.565.10-FF-000382', NULL, 'Uncharacterized protein', 157, NULL, NULL, 46573),
(46574, '3.90.1150.10-FF-000140', NULL, 'alanine aminotransferase 1', 182, NULL, NULL, 46574),
(46575, '3.30.70.330-FF-002405', NULL, NULL, 157, NULL, NULL, 46575),
(46576, '1.20.930.10-FF-000033', NULL, 'Transcription elongation factor S-II', 95, NULL, NULL, 46576),
(46577, '4.10.1000.10-FF-000080', NULL, 'Zinc finger CCCH domain-containing protein 3', 81, NULL, NULL, 46577),
(46578, '2.40.50.90-FF-000088', NULL, 'Staphylococcal nuclease-like, putative', 132, NULL, NULL, 46578),
(46579, '3.30.1340.10-FF-000005', NULL, 'Fructose-specific PTS system IIA component', 85, NULL, NULL, 46579),
(46580, '1.20.1460.20-FF-000004', NULL, 'V-type ATP synthase subunit I', 168, NULL, NULL, 46580),
(46581, '1.10.238.10-FF-000286', NULL, 'Myosin alkali light chain 1', 82, NULL, NULL, 46581),
(46582, '3.30.342.10-FF-000055', NULL, 'DNA polymerase zeta catalytic subunit, putative', 124, NULL, NULL, 46582),
(46583, '1.10.472.80-FF-000070', NULL, 'Serine/threonine protein kinase', 121, NULL, NULL, 46583),
(46584, '1.20.1070.10-FF-001129', NULL, 'Neuropeptide FF receptor 2', 352, NULL, NULL, 46584),
(46585, '3.40.50.11370-FF-000004', NULL, 'Inositol-tetrakisphosphate 1-kinase', 126, NULL, NULL, 46585),
(46586, '2.40.50.140-FF-000957', NULL, NULL, 51, NULL, NULL, 46586),
(46587, '3.40.30.10-FF-000269', NULL, 'Selenoprotein H', 90, NULL, NULL, 46587),
(46588, '1.25.40.540-FF-000008', NULL, 'Uncharacterized protein', 202, NULL, NULL, 46588),
(46589, '3.20.20.70-FF-000697', NULL, NULL, 165, NULL, NULL, 46589),
(46590, '3.10.20.90-FF-000113', NULL, 'ras association domain-containing protein 9', 101, NULL, NULL, 46590),
(46591, '2.60.120.200-FF-000596', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', 157, NULL, NULL, 46591),
(46592, '2.60.120.560-FF-000018', NULL, 'Beta-fructofuranosidase suc1-Aspergillus niger', 139, NULL, NULL, 46592),
(46593, '2.60.120.260-FF-000035', NULL, 'probable carboxypeptidase X1 isoform X2', 171, NULL, NULL, 46593),
(46594, '1.25.40.10-FF-001748', NULL, 'Vesicle-associated protein 1-1', 111, NULL, NULL, 46594),
(46595, '2.130.10.10-FF-003621', NULL, 'Uncharacterized protein', 177, NULL, NULL, 46595),
(46596, '1.10.260.60-FF-000004', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', 126, NULL, NULL, 46596),
(46597, '3.40.50.2000-FF-000746', NULL, 'Uncharacterized protein', 145, NULL, NULL, 46597),
(46598, '3.40.50.300-FF-000249', NULL, 'tRNA modification GTPase MnmE', 166, NULL, NULL, 46598),
(46599, '1.25.10.10-FF-000611', NULL, 'Condensin-2 complex subunit D3', 208, NULL, NULL, 46599),
(46600, '1.10.472.80-FF-000114', NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', 136, NULL, NULL, 46600),
(46601, '3.30.200.110-FF-000015', NULL, NULL, 54, NULL, NULL, 46601),
(46602, '2.20.200.10-FF-000002', NULL, 'Probable outer membrane efflux protein', 83, NULL, NULL, 46602),
(46603, '2.30.29.30-FF-000690', NULL, 'Tectonin beta-propeller repeat-containing protein 1', 115, NULL, NULL, 46603),
(46604, '1.10.510.10-FF-001184', NULL, 'GM17114', 317, NULL, NULL, 46604),
(46605, '3.30.1330.80-FF-000008', NULL, 'AT-hook motif nuclear-localized protein', 129, NULL, NULL, 46605),
(46606, '3.10.28.10-FF-000012', NULL, 'Replicative DNA helicase', 112, NULL, NULL, 46606),
(46607, '2.120.10.90-FF-000014', NULL, 'DNA topoisomerase (ATP-hydrolyzing)', 294, NULL, NULL, 46607);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(46608, '1.10.472.10-FF-000330', NULL, 'Cyclin-like protein', 109, NULL, NULL, 46608),
(46609, '3.40.50.300-FF-006561', NULL, 'Uncharacterized protein', 103, NULL, NULL, 46609),
(46610, '3.40.50.980-FF-000008', NULL, 'Long-chain-fatty-acid--[acyl-carrier-protein] ligase AEE15, chloroplastic', 44, NULL, NULL, 46610),
(46611, '1.25.40.10-FF-002237', NULL, 'DnaJ-like chaperone, putative', 275, NULL, NULL, 46611),
(46612, '1.20.140.40-FF-000009', NULL, 'Invertase/pectin methylesterase inhibitor family protein', 150, NULL, NULL, 46612),
(46613, '3.40.532.10-FF-000040', NULL, NULL, 53, NULL, NULL, 46613),
(46614, '1.10.510.10-FF-000239', NULL, 'Proline-rich receptor-like protein kinase PERK1', 209, NULL, NULL, 46614),
(46615, '1.10.750.20-FF-000007', NULL, 'Suppressor of cytokine signaling', 34, NULL, NULL, 46615),
(46616, '3.40.50.720-FF-002409', NULL, 'Predicted protein', 245, NULL, NULL, 46616),
(46617, '3.90.1410.10-FF-000059', NULL, 'Uncharacterized protein', 236, NULL, NULL, 46617),
(46618, '2.130.10.10-FF-000215', NULL, 'Regulatory associated protein of MTOR, complex 1', 94, NULL, NULL, 46618),
(46619, '3.80.10.10-FF-000283', NULL, 'Si:cabz01069012.2', 119, NULL, NULL, 46619),
(46620, '3.30.160.60-FF-002457', NULL, 'Zinc finger and SCAN domain-containing 4B', 24, NULL, NULL, 46620),
(46621, '1.10.8.1310-FF-000019', NULL, 'Uncharacterized protein', 119, NULL, NULL, 46621),
(46622, '3.40.50.410-FF-000299', NULL, 'Sec24d protein', 175, NULL, NULL, 46622),
(46623, '3.30.40.10-FF-000545', NULL, 'E3 ubiquitin-protein ligase RNF135', 79, NULL, NULL, 46623),
(46624, '2.10.10.10-FF-000024', NULL, 'Insulin-like growth factor 2 receptor', 49, NULL, NULL, 46624),
(46625, '3.30.1330.20-FF-000053', NULL, 'Tubulin gamma chain', 109, NULL, NULL, 46625),
(46626, '1.10.287.70-FF-000607', NULL, 'Uncharacterized protein', 274, NULL, NULL, 46626),
(46627, '3.30.70.330-FF-002877', NULL, NULL, 67, NULL, NULL, 46627),
(46628, '3.30.1490.50-FF-000005', NULL, 'Eukaryotic glutathione synthase', 67, NULL, NULL, 46628),
(46629, '3.90.230.10-FF-000063', NULL, NULL, 231, NULL, NULL, 46629),
(46630, '1.25.40.10-FF-001309', NULL, 'Putative intraflagellar transport protein IFT88', 146, NULL, NULL, 46630),
(46631, '3.10.250.10-FF-000094', NULL, NULL, 100, NULL, NULL, 46631),
(46632, '2.60.40.10-FF-000900', NULL, 'Titin a', 104, NULL, NULL, 46632),
(46633, '2.60.40.10-FF-001991', NULL, 'Uncharacterized protein YeeJ', 102, NULL, NULL, 46633),
(46634, '3.30.70.330-FF-000270', NULL, 'RNA binding motif protein 20', 97, NULL, NULL, 46634),
(46635, '3.40.1650.10-FF-000009', NULL, 'Uncharacterized protein', 85, NULL, NULL, 46635),
(46636, '3.30.70.990-FF-000001', NULL, 'UPF0234 protein YajQ', 89, NULL, NULL, 46636),
(46637, '1.10.10.60-FF-000193', NULL, 'Ultrabithorax, isoform C', 80, NULL, NULL, 46637),
(46638, '2.60.40.10-FF-000080', NULL, 'Myosin light chain kinase, smooth muscle', 100, NULL, NULL, 46638),
(46639, '2.30.29.170-FF-000018', NULL, 'Uncharacterized protein', 121, NULL, NULL, 46639),
(46640, '3.20.20.70-FF-000242', NULL, 'Dihydroorotate reductase PyrE', 343, NULL, NULL, 46640),
(46641, '3.30.40.10-FF-001164', NULL, 'E3 ubiquitin-protein ligase RNF4 isoform X1', 63, NULL, NULL, 46641),
(46642, '2.60.120.200-FF-000287', NULL, 'tectonin beta-propeller repeat-containing protein', 155, NULL, NULL, 46642),
(46643, '1.20.1560.10-FF-000683', NULL, 'Serine protease/ABC transporter B family protein tagB', 12, NULL, NULL, 46643),
(46644, '3.40.50.2300-FF-001674', NULL, NULL, 116, NULL, NULL, 46644),
(46645, '3.30.160.60-FF-001940', NULL, 'RB-associated KRAB zinc finger protein-like', 29, NULL, NULL, 46645),
(46646, '2.60.40.2030-FF-000049', NULL, 'Adhesion G protein-coupled receptor V1', 127, NULL, NULL, 46646),
(46647, '2.130.10.10-FF-004610', NULL, 'Chromosome 7, whole genome shotgun sequence', 202, NULL, NULL, 46647),
(46648, '1.20.1110.10-FF-000228', NULL, 'Calcium-transporting ATPase, putative', 403, NULL, NULL, 46648),
(46649, '3.90.105.10-FF-000014', NULL, 'Molybdopterin molybdenumtransferase', 57, NULL, NULL, 46649);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(46650, '1.20.990.10-FF-000042', NULL, 'Sulfite reductase [NADPH] flavoprotein alpha-component', 106, NULL, NULL, 46650),
(46651, '3.40.50.300-FF-003155', NULL, 'ATP-dependent DNA helicase', 118, NULL, NULL, 46651),
(46652, '2.40.50.140-FF-000502', NULL, '30S ribosomal protein S1', 87, NULL, NULL, 46652),
(46653, '3.30.160.60-FF-001838', NULL, 'Zinc finger protein 646', 75, NULL, NULL, 46653),
(46654, '1.10.20.10-FF-000257', NULL, NULL, 57, NULL, NULL, 46654),
(46655, '6.20.50.160-FF-000003', NULL, 'Complement C3', 64, NULL, NULL, 46655),
(46656, '2.60.120.290-FF-000050', NULL, 'Cubilin', 111, NULL, NULL, 46656),
(46657, '2.170.270.10-FF-000010', NULL, 'Histone-lysine N-methyltransferase', 233, NULL, NULL, 46657),
(46658, '3.30.420.510-FF-000010', NULL, 'Pantothenate kinase 2, mitochondrial, putative', 148, NULL, NULL, 46658),
(46659, '3.30.460.10-FF-000150', NULL, 'Uncharacterized protein', 134, NULL, NULL, 46659),
(46660, '3.30.160.60-FF-005672', NULL, NULL, 27, NULL, NULL, 46660),
(46661, '1.10.10.60-FF-000513', NULL, 'Chromatin-remodeling complex ATPase chain', 104, NULL, NULL, 46661),
(46662, '2.110.10.10-FF-000025', NULL, 'Vitronectin', 110, NULL, NULL, 46662),
(46663, '3.90.70.10-FF-000634', NULL, 'Uncharacterized protein', 362, NULL, NULL, 46663),
(46664, '3.40.1260.20-FF-000011', NULL, 'Cytoplasmic axial filament protein, putative', 85, NULL, NULL, 46664),
(46665, '1.20.120.730-FF-000006', NULL, 'Protein transport protein SEC23', 138, NULL, NULL, 46665),
(46666, '3.80.10.10-FF-003700', NULL, 'Uncharacterized protein', 167, NULL, NULL, 46666),
(46667, '3.30.200.20-FF-000403', NULL, 'Serine/threonine-protein kinase RIO1', 109, NULL, NULL, 46667),
(46668, '2.60.120.200-FF-000607', NULL, 'Uncharacterized protein', 152, NULL, NULL, 46668),
(46669, '1.10.800.10-FF-000003', NULL, 'Phenylalanine-4-hydroxylase', 433, NULL, NULL, 46669),
(46670, '2.60.40.10-FF-002480', NULL, 'High Incidence of Males (Increased X chromosome loss)', 90, NULL, NULL, 46670),
(46671, '1.25.40.570-FF-000023', NULL, '26S proteasome regulatory subunit RPN7,putative', 320, NULL, NULL, 46671),
(46672, '2.60.40.3180-FF-000006', NULL, 'transcription factor COE1 isoform X1', 39, NULL, NULL, 46672),
(46673, '2.30.42.10-FF-000557', NULL, NULL, 58, NULL, NULL, 46673),
(46674, '2.60.40.10-FF-004262', NULL, NULL, 98, NULL, NULL, 46674),
(46675, '2.60.200.20-FF-000243', NULL, 'Uncharacterized protein', 133, NULL, NULL, 46675),
(46676, '3.30.420.210-FF-000010', NULL, 'NSFL1 cofactor p47, putative', 60, NULL, NULL, 46676),
(46677, '1.25.10.20-FF-000029', NULL, 'Uncharacterized protein', 93, NULL, NULL, 46677),
(46678, '1.20.1070.10-FF-000483', NULL, 'G protein-coupled receptor 31', 297, NULL, NULL, 46678),
(46679, '3.40.1380.20-FF-000019', NULL, 'Pyruvate kinase', 123, NULL, NULL, 46679),
(46680, '2.40.10.10-FF-000545', NULL, NULL, 84, NULL, NULL, 46680),
(46681, '3.40.50.300-FF-005925', NULL, 'Multidrug resistance-associated protein 1', 253, NULL, NULL, 46681),
(46682, '1.10.287.110-FF-000250', NULL, 'Chaperone protein DNAJ, putative', 79, NULL, NULL, 46682),
(46683, '3.80.10.10-FF-003380', NULL, 'Tehao', 105, NULL, NULL, 46683),
(46684, '2.170.120.20-FF-000014', NULL, '50S ribosomal protein L25', 88, NULL, NULL, 46684),
(46685, '3.30.70.330-FF-001579', NULL, 'SR Protein (Splicing factor)', 160, NULL, NULL, 46685),
(46686, '2.40.30.10-FF-000428', NULL, 'Translation elongation factor-1-alpha', 110, NULL, NULL, 46686),
(46687, '3.80.10.10-FF-001772', NULL, 'Uncharacterized protein', 119, NULL, NULL, 46687),
(46688, '1.10.3380.30-FF-000003', NULL, 'ATP dependent RNA helicase (Dob1)', 224, NULL, NULL, 46688),
(46689, '1.25.10.10-FF-002409', NULL, 'Uncharacterized protein', 253, NULL, NULL, 46689),
(46690, '1.20.5.170-FF-000148', NULL, 'Nuclear pore complex protein Nup54', 46, NULL, NULL, 46690),
(46691, '3.40.50.300-FF-003464', NULL, 'Cell division control protein', 178, NULL, NULL, 46691),
(46692, '3.40.190.10-FF-000441', NULL, 'Tungstate ABC transporter, periplasmic tungstate-binding protein', 129, NULL, NULL, 46692),
(46693, '3.40.50.1000-FF-000531', NULL, NULL, 105, NULL, NULL, 46693);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(46694, '2.60.40.10-FF-005234', NULL, NULL, 89, NULL, NULL, 46694),
(46695, '1.20.58.130-FF-000001', NULL, 'Intracellular protein transport protein (UsoA), putative', 72, NULL, NULL, 46695),
(46696, '3.30.450.20-FF-000551', NULL, 'Signal-transducing histidine kinase', 102, NULL, NULL, 46696),
(46697, '3.10.310.70-FF-000004', NULL, 'N-substituted formamide deformylase', 120, NULL, NULL, 46697),
(46698, '1.25.40.10-FF-005334', NULL, 'Pentatricopeptide repeat-containing protein At3g23020', 73, NULL, NULL, 46698),
(46699, '1.10.510.10-FF-001976', NULL, 'Protein CBG16237', 179, NULL, NULL, 46699),
(46700, '2.60.40.60-FF-000645', NULL, 'Uncharacterized protein', 121, NULL, NULL, 46700),
(46701, '3.40.50.1820-FF-001614', NULL, 'Thymusspecific serine protease, putative', 63, NULL, NULL, 46701),
(46702, '3.20.20.70-FF-000725', NULL, NULL, 101, NULL, NULL, 46702),
(46703, '1.10.720.60-FF-000023', NULL, 'Uncharacterized protein', 48, NULL, NULL, 46703),
(46704, '3.40.140.120-FF-000001', NULL, 'Lambda phage portal protein B', 119, NULL, NULL, 46704),
(46705, '2.60.40.10-FF-000872', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', 87, NULL, NULL, 46705),
(46706, '2.30.180.10-FF-000087', NULL, NULL, 157, NULL, NULL, 46706),
(46707, '2.60.40.10-FF-003334', NULL, 'Fibronectin 1b', 94, NULL, NULL, 46707),
(46708, '3.40.50.150-FF-001693', NULL, NULL, 93, NULL, NULL, 46708),
(46709, '1.10.8.60-FF-000456', NULL, 'Uncharacterized protein', 59, NULL, NULL, 46709),
(46710, '3.40.50.300-FF-005942', NULL, 'Uncharacterized protein', 180, NULL, NULL, 46710),
(46711, '3.30.300.30-FF-000116', NULL, 'Nonribosomal peptide synthase inpB', 142, NULL, NULL, 46711),
(46712, '3.30.300.130-FF-000010', NULL, 'Protein AE7-like 1', 92, NULL, NULL, 46712),
(46713, '3.30.1490.20-FF-000007', NULL, 'D-alanine--D-alanine ligase', 73, NULL, NULL, 46713),
(46714, '3.40.50.10190-FF-000066', NULL, 'BRCT domain protein (Eurofung)', 90, NULL, NULL, 46714),
(46715, '3.40.250.10-FF-000188', NULL, 'MBL fold metallo-hydrolase', 96, NULL, NULL, 46715),
(46716, '3.40.50.1100-FF-000004', NULL, 'Tryptophan synthase beta chain', 212, NULL, NULL, 46716),
(46717, '4.10.280.10-FF-000176', NULL, 'Carbohydrate metabolism regulator TYE7', 95, NULL, NULL, 46717),
(46718, '3.30.1240.10-FF-000060', NULL, 'Cof-type HAD-IIB family hydrolase', 99, NULL, NULL, 46718),
(46719, '3.80.10.10-FF-000827', NULL, 'Leucine Rich Repeat family protein, expressed', 158, NULL, NULL, 46719),
(46720, '3.30.1370.10-FF-000142', NULL, 'AGAP004145-PA', 98, NULL, NULL, 46720),
(46721, '3.30.160.60-FF-000220', NULL, 'Zinc finger and BTB domain-containing protein 18', 25, NULL, NULL, 46721),
(46722, '3.40.50.1010-FF-000051', NULL, 'Rad2-like endonuclease, putative (AFU_orthologue AFUA_3G13260)', 95, NULL, NULL, 46722),
(46723, '1.10.10.60-FF-000985', NULL, NULL, 114, NULL, NULL, 46723),
(46724, '3.90.228.20-FF-000004', NULL, 'Phosphoenolpyruvate carboxykinase [GTP], mitochondrial', 120, NULL, NULL, 46724),
(46725, '1.20.5.320-FF-000019', NULL, 'Predicted protein', 50, NULL, NULL, 46725),
(46726, '3.90.850.10-FF-000003', NULL, 'Fumarylacetoacetate hydrolase domain-containing 1', 218, NULL, NULL, 46726),
(46727, '3.30.70.240-FF-000052', NULL, 'Elongation factor G, mitochondrial', 98, NULL, NULL, 46727),
(46728, '3.30.230.70-FF-000105', NULL, 'Uncharacterized protein', 174, NULL, NULL, 46728),
(46729, '1.25.10.10-FF-001128', NULL, 'ARM repeat superfamily protein', 244, NULL, NULL, 46729),
(46730, '2.130.10.10-FF-000996', NULL, 'WD repeat-containing protein 3', 199, NULL, NULL, 46730),
(46731, '3.40.50.2300-FF-001202', NULL, NULL, 100, NULL, NULL, 46731),
(46732, '2.40.10.10-FF-000562', NULL, NULL, 70, NULL, NULL, 46732),
(46733, '1.20.1740.10-FF-000276', NULL, 'Uncharacterized protein', 391, NULL, NULL, 46733),
(46734, '1.20.140.10-FF-000113', NULL, 'Acyl-coenzyme A oxidase', 139, NULL, NULL, 46734),
(46735, '3.10.20.620-FF-000019', NULL, NULL, 40, NULL, NULL, 46735),
(46736, '3.30.450.40-FF-000118', NULL, 'Diguanylate cyclase-related enzyme', 140, NULL, NULL, 46736);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(46737, '2.60.40.10-FF-000580', NULL, 'Myosin light chain kinase, smooth muscle', 109, NULL, NULL, 46737),
(46738, '3.30.450.30-FF-000071', NULL, 'Uncharacterized protein', 125, NULL, NULL, 46738),
(46739, '2.40.50.140-FF-000974', NULL, NULL, 153, NULL, NULL, 46739),
(46740, '2.30.29.30-FF-000347', NULL, 'Docking protein 3', 108, NULL, NULL, 46740),
(46741, '3.30.1490.180-FF-000002', NULL, 'DNA-directed RNA polymerase subunit', 62, NULL, NULL, 46741),
(46742, '1.25.40.840-FF-000008', NULL, 'Subunit of the CCR4-NOT transcriptional complex, putative', 169, NULL, NULL, 46742),
(46743, '2.130.10.10-FF-001704', NULL, 'echinoderm microtubule-associated protein-like 5 isoform X3', 174, NULL, NULL, 46743),
(46744, '3.40.33.10-FF-000163', NULL, 'Uncharacterized protein', 116, NULL, NULL, 46744),
(46745, '1.10.238.10-FF-001275', NULL, 'Calbindin 2a', 73, NULL, NULL, 46745),
(46746, '2.10.25.10-FF-000827', NULL, 'Uncharacterized protein', 39, NULL, NULL, 46746),
(46747, '1.20.58.340-FF-000076', NULL, 'Uncharacterized protein', 46, NULL, NULL, 46747),
(46748, '2.40.240.130-FF-000005', NULL, 'Segment polarity protein dishevelled DVL-1', 27, NULL, NULL, 46748),
(46749, '1.50.40.10-FF-000167', NULL, 'Uncharacterized mitochondrial carrier C29A3.11c', 303, NULL, NULL, 46749),
(46750, '2.60.40.10-FF-004615', NULL, NULL, 85, NULL, NULL, 46750),
(46751, '3.30.420.40-FF-000572', NULL, 'Protein CBG18255', 173, NULL, NULL, 46751),
(46752, '2.60.40.150-FF-000105', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 165, NULL, NULL, 46752),
(46753, '1.20.1070.10-FF-001472', NULL, 'Uncharacterized protein', 210, NULL, NULL, 46753),
(46754, '1.20.1250.20-FF-000258', NULL, 'Melibiose carrier protein', 196, NULL, NULL, 46754),
(46755, '3.30.470.20-FF-000125', NULL, 'D-alanyl-alanine synthetase A', 149, NULL, NULL, 46755),
(46756, '3.40.50.10380-FF-000033', NULL, 'Malic enzyme', 216, NULL, NULL, 46756),
(46757, '3.30.160.60-FF-005200', NULL, NULL, 25, NULL, NULL, 46757),
(46758, '1.25.10.10-FF-000274', NULL, 'Non-SMC condensin I complex subunit G', 339, NULL, NULL, 46758),
(46759, '2.60.40.10-FF-001491', NULL, 'Sidekick, isoform B', 105, NULL, NULL, 46759),
(46760, '1.25.40.20-FF-000312', NULL, 'serine/threonine-protein kinase STY8', 122, NULL, NULL, 46760),
(46761, '1.10.630.10-FF-000703', NULL, 'Uncharacterized protein', 124, NULL, NULL, 46761),
(46762, '2.60.120.10-FF-000060', NULL, 'Putative mannose-6-phosphate isomerase', 161, NULL, NULL, 46762),
(46763, '2.30.110.10-FF-000021', NULL, 'Pyridoxine 5''-phosphate oxidase', 201, NULL, NULL, 46763),
(46764, '3.80.10.10-FF-002391', NULL, 'Leucine-rich repeat-containing protein 40', 251, NULL, NULL, 46764),
(46765, '1.10.510.10-FF-001537', NULL, 'CAMK family protein kinase', 276, NULL, NULL, 46765),
(46766, '1.10.510.10-FF-004281', NULL, NULL, 175, NULL, NULL, 46766),
(46767, '3.40.50.1010-FF-000079', NULL, 'Uncharacterized protein', 193, NULL, NULL, 46767),
(46768, '3.40.50.720-FF-000953', NULL, 'Oxidoreductase', 140, NULL, NULL, 46768),
(46769, '2.60.300.12-FF-000025', NULL, NULL, 107, NULL, NULL, 46769),
(46770, '3.30.450.40-FF-000220', NULL, 'Phytochrome-like protein cph1', 199, NULL, NULL, 46770),
(46771, '1.10.287.810-FF-000015', NULL, 'Mitochondrial import inner membrane translocase subunit Tim9', 78, NULL, NULL, 46771),
(46772, '1.20.58.150-FF-000007', NULL, 'Putative clathrin assembly protein', 152, NULL, NULL, 46772),
(46773, '3.10.150.10-FF-000030', NULL, 'Proliferating cell nuclear antigen', 168, NULL, NULL, 46773),
(46774, '2.170.140.10-FF-000057', NULL, 'Obstructor-G', 65, NULL, NULL, 46774),
(46775, '1.10.3090.10-FF-000037', NULL, 'tRNA nucleotidyltransferase, putative', 115, NULL, NULL, 46775),
(46776, '3.40.50.300-FF-007207', NULL, 'Uncharacterized protein', 166, NULL, NULL, 46776),
(46777, '1.20.1080.10-FF-000129', NULL, 'Uncharacterized protein', 74, NULL, NULL, 46777),
(46778, '3.30.160.60-FF-004402', NULL, NULL, 65, NULL, NULL, 46778),
(46779, '1.20.58.730-FF-000001', NULL, 'Protein zwilch homolog', 100, NULL, NULL, 46779),
(46780, '2.30.29.30-FF-000908', NULL, 'FACT complex subunit SSRP1', 93, NULL, NULL, 46780);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(46781, '1.20.1740.10-FF-000129', NULL, 'Lysine/arginine permease, putative', 470, NULL, NULL, 46781),
(46782, '1.25.40.10-FF-001591', NULL, 'Clathrin heavy chain', 146, NULL, NULL, 46782),
(46783, '3.20.20.80-FF-000571', NULL, 'Oligosaccharide 4-alpha-D-glucosyltransferase', 378, NULL, NULL, 46783),
(46784, '3.90.76.10-FF-000046', NULL, 'ABC transporter substrate-binding protein', 143, NULL, NULL, 46784),
(46785, '3.80.10.10-FF-003037', NULL, 'Uncharacterized protein', 163, NULL, NULL, 46785),
(46786, '3.30.70.330-FF-000399', NULL, 'Nuclear cap-binding protein subunit 2', 147, NULL, NULL, 46786),
(46787, '1.10.287.550-FF-000016', NULL, 'Uncharacterized protein', 59, NULL, NULL, 46787),
(46788, '2.60.40.150-FF-000027', NULL, 'Synaptotagmin 7', 142, NULL, NULL, 46788),
(46789, '2.120.10.30-FF-000042', NULL, 'Tyrosine-protein kinase receptor', 249, NULL, NULL, 46789),
(46790, '2.30.30.380-FF-000050', NULL, 'AGAP000829-PA', 59, NULL, NULL, 46790),
(46791, '1.25.10.10-FF-003028', NULL, 'Cellular apoptosis susceptibility protein', 317, NULL, NULL, 46791),
(46792, '3.30.2230.10-FF-000014', NULL, 'Uncharacterized protein', 111, NULL, NULL, 46792),
(46793, '3.40.140.10-FF-000067', NULL, 'COP9 signalosome, subunit CSN5', 274, NULL, NULL, 46793),
(46794, '1.10.238.10-FF-000106', NULL, 'Allograft inflammatory factor 1', 136, NULL, NULL, 46794),
(46795, '3.30.420.610-FF-000023', NULL, 'Tudor domain-containing protein 7A', 77, NULL, NULL, 46795),
(46796, '1.10.40.30-FF-000017', NULL, 'Argininosuccinate lyase', 34, NULL, NULL, 46796),
(46797, '1.20.1690.10-FF-000001', NULL, 'V-type proton ATPase subunit', 105, NULL, NULL, 46797),
(46798, '3.30.360.10-FF-000086', NULL, 'Glyceraldehyde 3-phosphate dehydrogenase isoform', 79, NULL, NULL, 46798),
(46799, '3.40.850.10-FF-000469', NULL, 'Uncharacterized protein', 362, NULL, NULL, 46799),
(46800, '4.10.400.10-FF-000135', NULL, 'LDL receptor protein 1, isoform G', 42, NULL, NULL, 46800),
(46801, '3.30.559.30-FF-000036', NULL, 'Nonribosomal peptide synthase, putative', 243, NULL, NULL, 46801),
(46802, '1.20.120.160-FF-000049', NULL, 'Chemotaxis protein', 133, NULL, NULL, 46802),
(46803, '3.20.20.140-FF-000261', NULL, 'Amidohydrolase domain protein', 137, NULL, NULL, 46803),
(46804, '3.30.70.3000-FF-000010', NULL, 'Uncharacterized protein', 165, NULL, NULL, 46804),
(46805, '1.10.630.10-FF-000175', NULL, 'Cytochrome P450 family 81 subfamily D polypeptide 8', 90, NULL, NULL, 46805),
(46806, '2.20.20.110-FF-000003', NULL, 'Putative DNA repair protein Rad4', 59, NULL, NULL, 46806),
(46807, '1.25.40.10-FF-002900', NULL, 'Uncharacterized protein', 205, NULL, NULL, 46807),
(46808, '3.30.420.10-FF-000057', NULL, 'IS150, transposase orfB', 164, NULL, NULL, 46808),
(46809, '1.10.510.10-FF-002156', NULL, 'Kinase, NEK-like', 263, NULL, NULL, 46809),
(46810, '1.10.510.10-FF-003662', NULL, NULL, 179, NULL, NULL, 46810),
(46811, '1.10.1070.11-FF-000104', NULL, 'Serine/threonine-protein kinase tel1', 170, NULL, NULL, 46811),
(46812, '1.10.1170.10-FF-000043', NULL, 'Protein bir1', 101, NULL, NULL, 46812),
(46813, '2.60.40.10-FF-001209', NULL, 'Colony stimulating factor 3 receptor', 85, NULL, NULL, 46813),
(46814, '3.30.200.20-FF-000050', NULL, 'Mitogen-activated protein kinase', 120, NULL, NULL, 46814),
(46815, '1.25.40.20-FF-000649', NULL, 'WGS project CABT00000000 data, contig 2.8', 147, NULL, NULL, 46815),
(46816, '3.30.200.20-FF-001668', NULL, 'Tribbles pseudokinase 3', 82, NULL, NULL, 46816),
(46817, '3.30.160.20-FF-000124', NULL, 'Adenosine deaminase acting on RNA (Adar)-1', 80, NULL, NULL, 46817),
(46818, '2.130.10.10-FF-001176', NULL, 'Os02g0290300 protein', 261, NULL, NULL, 46818),
(46819, '3.30.160.60-FF-001485', NULL, 'Krueppel-related zinc finger protein', 29, NULL, NULL, 46819),
(46820, '2.60.120.10-FF-000043', NULL, 'cGMP-dependent protein kinase', 137, NULL, NULL, 46820),
(46821, '2.40.50.140-FF-001121', NULL, NULL, 54, NULL, NULL, 46821),
(46822, '4.10.400.10-FF-000265', NULL, 'AGAP003656-PA', 41, NULL, NULL, 46822),
(46823, '2.120.10.80-FF-000141', NULL, 'Attractin-like protein 1', 132, NULL, NULL, 46823);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(46824, '3.90.79.10-FF-000171', NULL, 'Flavin-dependent trigonelline monooxygenase, reductase component', 129, NULL, NULL, 46824),
(46825, '3.10.20.90-FF-000361', NULL, 'Membrane-anchored ubiquitin-fold protein', 100, NULL, NULL, 46825),
(46826, '1.10.10.10-FF-002100', NULL, 'Uncharacterized protein', 35, NULL, NULL, 46826),
(46827, '1.20.120.140-FF-000043', NULL, 'Signal recognition particle receptor', 142, NULL, NULL, 46827),
(46828, '1.25.40.10-FF-000130', NULL, 'Transmembrane and tetratricopeptide repeat containing 2', 71, NULL, NULL, 46828),
(46829, '3.90.390.10-FF-000001', NULL, 'Methyl-coenzyme M reductase I subunit alpha', 101, NULL, NULL, 46829),
(46830, '1.50.10.10-FF-000182', NULL, 'Uncharacterized protein (Fragment)', 336, NULL, NULL, 46830),
(46831, '3.90.1530.10-FF-000006', NULL, 'Siderophore biosynthesis protein SbnI', 88, NULL, NULL, 46831),
(46832, '1.25.40.860-FF-000003', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 134, NULL, NULL, 46832),
(46833, '1.25.40.1040-FF-000026', NULL, 'Putative nucleotide kinase', 307, NULL, NULL, 46833),
(46834, '1.25.10.10-FF-001763', NULL, 'Exportin-T', 959, NULL, NULL, 46834),
(46835, '3.10.290.10-FF-000101', NULL, 'Tyrosine--tRNA ligase', 88, NULL, NULL, 46835),
(46836, '3.40.630.30-FF-000392', NULL, 'Uncharacterized protein', 114, NULL, NULL, 46836),
(46837, '1.10.10.10-FF-001611', NULL, 'Predicted protein', 100, NULL, NULL, 46837),
(46838, '2.10.50.10-FF-000150', NULL, 'Predicted protein', 36, NULL, NULL, 46838),
(46839, '3.30.160.60-FF-006156', NULL, NULL, 22, NULL, NULL, 46839),
(46840, '3.40.50.720-FF-001100', NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase catalytic region', 178, NULL, NULL, 46840),
(46841, '2.60.40.10-FF-001389', NULL, 'Immunoglobulin-like and fibronectin type III domain-containing 1', 98, NULL, NULL, 46841),
(46842, '3.30.1370.210-FF-000035', NULL, 'Zinc finger cx8-c-x5-c-x3-h type (and similar) domain-containing protein', 75, NULL, NULL, 46842),
(46843, '3.90.70.10-FF-000651', NULL, 'Ubiquitin-specific peptidase 28', 86, NULL, NULL, 46843),
(46844, '3.30.1360.120-FF-000063', NULL, 'Folate-binding protein YgfZ', 319, NULL, NULL, 46844),
(46845, '2.60.120.1000-FF-000004', NULL, 'collagen alpha-2(XI) chain isoform X1', 196, NULL, NULL, 46845),
(46846, '1.10.3210.10-FF-000098', NULL, 'YALI0B16566p', 197, NULL, NULL, 46846),
(46847, '1.20.920.10-FF-000077', NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', 151, NULL, NULL, 46847),
(46848, '3.30.420.10-FF-000366', NULL, NULL, 87, NULL, NULL, 46848),
(46849, '1.20.59.10-FF-000008', NULL, 'Chorismate mutase', 93, NULL, NULL, 46849),
(46850, '1.10.10.60-FF-001165', NULL, NULL, 49, NULL, NULL, 46850),
(46851, '1.10.418.10-FF-000160', NULL, 'Fimbrin', 112, NULL, NULL, 46851),
(46852, '3.40.50.10900-FF-000004', NULL, 'Proteasome assembly chaperone 2', 149, NULL, NULL, 46852),
(46853, '3.40.50.1100-FF-000134', NULL, 'L-serine dehydratase/L-threonine deaminase', 93, NULL, NULL, 46853),
(46854, '2.40.30.10-FF-000445', NULL, 'Uncharacterized protein', 117, NULL, NULL, 46854),
(46855, '2.60.120.260-FF-000518', NULL, 'Beta-galactosidase', 130, NULL, NULL, 46855),
(46856, '3.40.50.12780-FF-000219', NULL, 'Uncharacterized protein', 110, NULL, NULL, 46856),
(46857, '3.40.50.300-FF-003947', NULL, 'Bifunctional adenosylcobalamin biosynthesis protein', 165, NULL, NULL, 46857),
(46858, '1.10.150.20-FF-000130', NULL, '5''-3'' exonuclease', 91, NULL, NULL, 46858),
(46859, '3.40.605.10-FF-000092', NULL, 'Aldehyde dehydrogenase 4 family member A1', 261, NULL, NULL, 46859),
(46860, '3.30.930.10-FF-000332', NULL, 'Uncharacterized protein', 130, NULL, NULL, 46860),
(46861, '3.40.50.2000-FF-000393', NULL, 'Glycosyltransferase', 244, NULL, NULL, 46861),
(46862, '3.40.50.720-FF-001128', NULL, 'Homoserine dehydrogenase', 172, NULL, NULL, 46862),
(46863, '2.10.70.10-FF-000033', NULL, 'Complement receptor type 1', 62, NULL, NULL, 46863),
(46864, '2.40.40.20-FF-000067', NULL, 'Predicted protein', 41, NULL, NULL, 46864),
(46865, '3.30.342.10-FF-000038', NULL, 'DNA polymerase epsilon catalytic subunit', 164, NULL, NULL, 46865);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(46866, '1.10.540.10-FF-000067', NULL, 'Acyl-CoA dehydrogenase FadE22', 115, NULL, NULL, 46866),
(46867, '3.30.70.100-FF-000004', NULL, 'NIPSNAP family protein', 104, NULL, NULL, 46867),
(46868, '1.20.140.10-FF-000130', NULL, 'Uncharacterized protein', 166, NULL, NULL, 46868),
(46869, '3.30.70.330-FF-002905', NULL, NULL, 41, NULL, NULL, 46869),
(46870, '1.10.510.10-FF-004410', NULL, NULL, 79, NULL, NULL, 46870),
(46871, '2.60.40.10-FF-003289', NULL, 'Uncharacterized protein', 83, NULL, NULL, 46871),
(46872, '3.90.190.10-FF-000345', NULL, 'Protein tyrosine phosphatase type IVA 1', 168, NULL, NULL, 46872),
(46873, '3.80.10.10-FF-000266', NULL, 'F-box and leucine rich repeat protein 13', 164, NULL, NULL, 46873),
(46874, '1.25.40.20-FF-001268', NULL, 'Uncharacterized protein', 195, NULL, NULL, 46874),
(46875, '3.40.50.10190-FF-000083', NULL, 'DNA damage repair protein (Rad9)', 159, NULL, NULL, 46875),
(46876, '3.80.10.10-FF-004189', NULL, 'Uncharacterized protein', 94, NULL, NULL, 46876),
(46877, '1.10.10.2210-FF-000008', NULL, NULL, 53, NULL, NULL, 46877),
(46878, '1.10.3230.20-FF-000001', NULL, 'DNA stabilization, phage-associated', 150, NULL, NULL, 46878),
(46879, '1.20.5.190-FF-000042', NULL, 'IQ motif containing F6', 55, NULL, NULL, 46879),
(46880, '3.10.20.90-FF-000922', NULL, 'Predicted protein', 82, NULL, NULL, 46880),
(46881, '1.20.1560.10-FF-000239', NULL, 'ABC type transmembrane transporter', 335, NULL, NULL, 46881),
(46882, '2.40.30.10-FF-000136', NULL, 'NADPH-cytochrome p450 reductase', 59, NULL, NULL, 46882),
(46883, '3.40.50.300-FF-007842', NULL, 'Predicted protein', 231, NULL, NULL, 46883),
(46884, '3.40.50.300-FF-005381', NULL, 'ATP-binding cassette, sub-family B (MDR/TAP), member 11b', 14, NULL, NULL, 46884),
(46885, '1.10.10.10-FF-000200', NULL, 'GA-binding protein alpha chain, putative', 135, NULL, NULL, 46885),
(46886, '3.40.50.200-FF-000106', NULL, 'YALI0C15532p', 303, NULL, NULL, 46886),
(46887, '3.30.70.330-FF-001708', NULL, NULL, 78, NULL, NULL, 46887),
(46888, '1.25.40.10-FF-003417', NULL, 'Putative pentatricopeptide repeat-containing protein', 112, NULL, NULL, 46888),
(46889, '3.80.10.10-FF-001463', NULL, 'Uncharacterized protein', 73, NULL, NULL, 46889),
(46890, '3.30.720.150-FF-000009', NULL, 'UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase', 49, NULL, NULL, 46890),
(46891, '3.30.2090.10-FF-000025', NULL, 'Probable Resistance-Nodulation-Cell Division (RND) efflux transporter', 89, NULL, NULL, 46891),
(46892, '4.10.280.10-FF-000029', NULL, 'Achaete-scute family bHLH transcription factor 1', 63, NULL, NULL, 46892),
(46893, '2.10.25.10-FF-001446', NULL, 'Uncharacterized protein', 44, NULL, NULL, 46893),
(46894, '2.60.40.10-FF-000563', NULL, 'interleukin-6 receptor subunit beta', 110, NULL, NULL, 46894),
(46895, '3.40.50.720-FF-001437', NULL, 'Myo-inositol-1-phosphate synthase', 142, NULL, NULL, 46895),
(46896, '3.40.1190.10-FF-000007', NULL, 'UDP-N-acetylmuramoyl-tripeptide--D-alanyl-D-alanine ligase', 230, NULL, NULL, 46896),
(46897, '2.60.40.1670-FF-000014', NULL, 'Protein transport protein SEC23', 165, NULL, NULL, 46897),
(46898, '3.40.50.410-FF-000271', NULL, 'Predicted protein', 76, NULL, NULL, 46898),
(46899, '2.130.10.10-FF-005083', NULL, 'Uncharacterized protein', 265, NULL, NULL, 46899),
(46900, '1.10.506.10-FF-000016', NULL, 'Neurofibromin 1', 56, NULL, NULL, 46900),
(46901, '3.40.50.10810-FF-000112', NULL, 'SuUR', 215, NULL, NULL, 46901),
(46902, '1.10.1450.10-FF-000008', NULL, 'Tetraspanin', 94, NULL, NULL, 46902),
(46903, '1.25.10.10-FF-000583', NULL, 'MAP3K epsilon protein kinase 1', 305, NULL, NULL, 46903),
(46904, '3.40.50.300-FF-004436', NULL, 'Fe(2+) transporter FeoB', 163, NULL, NULL, 46904),
(46905, '2.10.25.10-FF-000518', NULL, 'latent-transforming growth factor beta-binding protein 3 isoform X1', 42, NULL, NULL, 46905),
(46906, '3.90.1150.10-FF-000269', NULL, 'DegT/DnrJ/EryC1/StrS aminotransferase', 114, NULL, NULL, 46906),
(46907, '3.30.160.650-FF-000003', NULL, 'Alkylglycerone-phosphate synthase', 42, NULL, NULL, 46907),
(46908, '1.10.357.10-FF-000051', NULL, 'TetR family transcriptional regulator', 148, NULL, NULL, 46908);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(46909, '3.40.190.80-FF-000001', NULL, 'Fructose-1,6-bisphosphatase class 1', 134, NULL, NULL, 46909),
(46910, '3.15.10.10-FF-000011', NULL, 'Latherin', 211, NULL, NULL, 46910),
(46911, '3.40.50.12760-FF-000005', NULL, 'Methyltransferase, putative', 335, NULL, NULL, 46911),
(46912, '3.15.10.30-FF-000017', NULL, NULL, 71, NULL, NULL, 46912),
(46913, '2.40.70.10-FF-000330', NULL, NULL, 172, NULL, NULL, 46913),
(46914, '3.90.550.10-FF-000519', NULL, 'Glycoside transferase family 2', 249, NULL, NULL, 46914),
(46915, '1.10.510.10-FF-002948', NULL, NULL, 46, NULL, NULL, 46915),
(46916, '2.160.20.10-FF-000107', NULL, 'Uncharacterized protein', 368, NULL, NULL, 46916),
(46917, '3.30.70.2850-FF-000026', NULL, 'DNA-directed RNA polymerase subunit', 214, NULL, NULL, 46917),
(46918, '3.30.420.40-FF-000701', NULL, 'L-fuculose kinase', 234, NULL, NULL, 46918),
(46919, '1.10.375.10-FF-000008', NULL, 'Gag polyprotein', 140, NULL, NULL, 46919),
(46920, '3.40.50.620-FF-000569', NULL, 'Sll1606 protein', 158, NULL, NULL, 46920),
(46921, '2.60.40.1210-FF-000005', NULL, 'Uncharacterized protein', 143, NULL, NULL, 46921),
(46922, '1.10.150.110-FF-000008', NULL, 'DNA polymerase', 81, NULL, NULL, 46922),
(46923, '4.10.400.10-FF-000057', NULL, 'Very low density lipoprotein receptor', 41, NULL, NULL, 46923),
(46924, '1.10.510.10-FF-002364', NULL, NULL, 181, NULL, NULL, 46924),
(46925, '1.25.40.10-FF-004362', NULL, 'Cell cycle control protein cwf4', 263, NULL, NULL, 46925),
(46926, '3.30.450.20-FF-000079', NULL, 'NADPH-dependent FMN reductase', 138, NULL, NULL, 46926),
(46927, '1.20.1250.20-FF-000275', NULL, 'Major facilitator superfamily domain-containing protein 6', 118, NULL, NULL, 46927),
(46928, '2.130.10.10-FF-002002', NULL, 'U3 small nucleolar RNA-associated protein 15 homolog', 148, NULL, NULL, 46928),
(46929, '2.60.120.290-FF-000033', NULL, 'Transmembrane protease serine 7', 112, NULL, NULL, 46929),
(46930, '2.60.40.10-FF-001417', NULL, 'Receptor-type tyrosine-protein phosphatase eta', 82, NULL, NULL, 46930),
(46931, '3.90.550.10-FF-000430', NULL, 'Bifunctional glycosyltransferase pgtA', 285, NULL, NULL, 46931),
(46932, '1.25.40.20-FF-001077', NULL, 'Uncharacterized protein', 135, NULL, NULL, 46932),
(46933, '2.130.10.10-FF-001384', NULL, 'Putative polyadenylation factor i complex subunit pfs2', 97, NULL, NULL, 46933),
(46934, '3.30.70.330-FF-002799', NULL, NULL, 95, NULL, NULL, 46934),
(46935, '2.140.10.30-FF-000001', NULL, 'Dipeptidyl peptidase 4', 465, NULL, NULL, 46935),
(46936, '3.40.50.2000-FF-000185', NULL, 'Glycosyltransferase', 267, NULL, NULL, 46936),
(46937, '3.40.50.300-FF-001210', NULL, 'D-glycerate 3-kinase, chloroplastic', 271, NULL, NULL, 46937),
(46938, '1.25.40.90-FF-000108', NULL, 'Uncharacterized protein', 83, NULL, NULL, 46938),
(46939, '1.10.287.1490-FF-000035', NULL, 'Protein NETWORKED 1A', 162, NULL, NULL, 46939),
(46940, '2.60.40.10-FF-001844', NULL, 'Titin, isoform CRA_a', 88, NULL, NULL, 46940),
(46941, '3.40.50.1820-FF-000097', NULL, 'Alpha/beta hydrolase family protein', 253, NULL, NULL, 46941),
(46942, '1.10.30.10-FF-000005', NULL, 'TOX high mobility group box family member 3', 102, NULL, NULL, 46942),
(46943, '2.40.160.210-FF-000022', NULL, 'Uncharacterized protein', 227, NULL, NULL, 46943),
(46944, '2.40.50.140-FF-001019', NULL, NULL, 57, NULL, NULL, 46944),
(46945, '3.40.570.10-FF-000015', NULL, 'GM25382', 254, NULL, NULL, 46945),
(46946, '2.120.10.30-FF-000603', NULL, 'Serine peptidase family S9', 200, NULL, NULL, 46946),
(46947, '3.30.505.10-FF-000081', NULL, 'Transcription elongation factor spt6', 98, NULL, NULL, 46947),
(46948, '3.40.50.300-FF-007179', NULL, 'Predicted protein', 172, NULL, NULL, 46948),
(46949, '3.40.50.150-FF-000732', NULL, 'THUMP domain-containing protein 3', 176, NULL, NULL, 46949),
(46950, '3.30.160.60-FF-005228', NULL, NULL, 28, NULL, NULL, 46950),
(46951, '3.30.930.10-FF-000124', NULL, 'Putative aspartyl-tRNA synthetase Dps1', 365, NULL, NULL, 46951),
(46952, '3.30.1330.30-FF-000073', NULL, 'tRNA/rRNA methyltransferase', 82, NULL, NULL, 46952),
(46953, '3.10.350.10-FF-000056', NULL, 'Peptidase, M23 family', 47, NULL, NULL, 46953);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(46954, '3.30.70.1210-FF-000001', NULL, 'CRISPR system Cascade subunit CasE', 123, NULL, NULL, 46954),
(46955, '2.130.10.10-FF-001968', NULL, 'Uncharacterized protein', 235, NULL, NULL, 46955),
(46956, '2.60.120.260-FF-000018', NULL, 'Laminin subunit gamma 1', 275, NULL, NULL, 46956),
(46957, '1.10.510.10-FF-001959', NULL, 'Uncharacterized protein', 202, NULL, NULL, 46957),
(46958, '2.40.10.10-FF-000354', NULL, 'Complement component 1, r subcomponent', 250, NULL, NULL, 46958),
(46959, '3.10.20.90-FF-000130', NULL, 'SHANK-associated RH domain interactor', 100, NULL, NULL, 46959),
(46960, '3.60.130.10-FF-000034', NULL, 'Alpha-ketoglutarate-dependent xanthine dioxygenase xanA', 365, NULL, NULL, 46960),
(46961, '3.30.360.20-FF-000004', NULL, '18S rRNA biogenesis protein', 98, NULL, NULL, 46961),
(46962, '3.40.50.2300-FF-000494', NULL, 'PTS system fructose-specific transporter subunit IIBC', 103, NULL, NULL, 46962),
(46963, '1.10.101.10-FF-000036', NULL, 'Membrane-bound lytic transglycosylase MltB_2 family', 64, NULL, NULL, 46963),
(46964, '1.10.238.10-FF-000415', NULL, 'Mitochondrial carrier protein, putative', 142, NULL, NULL, 46964),
(46965, '1.20.58.860-FF-000012', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 66, NULL, NULL, 46965),
(46966, '1.10.418.20-FF-000033', NULL, 'Predicted protein', 38, NULL, NULL, 46966),
(46967, '1.25.40.180-FF-000338', NULL, NULL, 214, NULL, NULL, 46967),
(46968, '3.80.10.10-FF-004009', NULL, 'Uncharacterized protein', 321, NULL, NULL, 46968),
(46969, '3.30.559.10-FF-000261', NULL, 'Acyltransferase easC', 188, NULL, NULL, 46969),
(46970, '3.90.1150.10-FF-000168', NULL, 'HTH-type transcriptional regulator NorG', 139, NULL, NULL, 46970),
(46971, '3.40.140.100-FF-000006', NULL, 'Autophagy protein apg7, putative', 24, NULL, NULL, 46971),
(46972, '4.10.410.10-FF-000080', NULL, 'Putative salivary kunitz domain protein', 65, NULL, NULL, 46972),
(46973, '3.40.50.300-FF-006089', NULL, 'Uncharacterized protein', 132, NULL, NULL, 46973),
(46974, '3.90.940.10-FF-000010', NULL, NULL, 71, NULL, NULL, 46974),
(46975, '1.20.1110.10-FF-000099', NULL, 'Transport ATPase', 137, NULL, NULL, 46975),
(46976, '2.130.10.10-FF-003430', NULL, 'Uncharacterized protein', 162, NULL, NULL, 46976),
(46977, '2.60.40.1730-FF-000043', NULL, 'TAF2 RNA polymerase II, TATA box binding (TBP)-associated factor, 150 kDa (TAF2), mRNA protein', 226, NULL, NULL, 46977),
(46978, '3.30.160.60-FF-001277', NULL, 'zinc finger and BTB domain-containing protein 6', 39, NULL, NULL, 46978),
(46979, '3.30.70.330-FF-001916', NULL, NULL, 54, NULL, NULL, 46979),
(46980, '3.30.565.10-FF-000410', NULL, 'Sensory transduction histidine kinase', 162, NULL, NULL, 46980),
(46981, '3.10.100.10-FF-000009', NULL, 'Aggrecan core protein', 99, NULL, NULL, 46981),
(46982, '1.25.40.90-FF-000097', NULL, 'Regulation of nuclear pre-mRNA domain containing 2b', 95, NULL, NULL, 46982),
(46983, '1.10.10.10-FF-000330', NULL, 'Ferric uptake regulation protein', 93, NULL, NULL, 46983),
(46984, '1.20.1070.10-FF-000983', NULL, 'Uncharacterized protein', 371, NULL, NULL, 46984),
(46985, '2.40.50.740-FF-000002', NULL, '30S ribosomal protein S4e', 55, NULL, NULL, 46985),
(46986, '3.40.50.300-FF-008034', NULL, 'Uncharacterized protein', 136, NULL, NULL, 46986),
(46987, '1.20.80.10-FF-000064', NULL, 'Uncharacterized protein', 104, NULL, NULL, 46987),
(46988, '2.60.210.10-FF-000050', NULL, NULL, 192, NULL, NULL, 46988),
(46989, '1.20.272.10-FF-000065', NULL, NULL, 88, NULL, NULL, 46989),
(46990, '1.10.630.10-FF-000383', NULL, 'Os02g0503100 protein', 316, NULL, NULL, 46990),
(46991, '3.40.20.10-FF-000004', NULL, 'Gelsolin', 121, NULL, NULL, 46991),
(46992, '1.10.220.160-FF-000001', NULL, 'N-lysine methyltransferase SMYD2 isoform X1', 83, NULL, NULL, 46992),
(46993, '2.70.170.10-FF-000307', NULL, 'Uncharacterized protein', 89, NULL, NULL, 46993),
(46994, '1.10.8.60-FF-000534', NULL, 'Predicted protein', 11, NULL, NULL, 46994),
(46995, '3.40.50.300-FF-000693', NULL, 'Nephrocystin-3', 155, NULL, NULL, 46995),
(46996, '1.10.287.130-FF-000126', NULL, 'Related to SLN1-histidine kinase osmosensor that regulates a MAP kinase cascade', 91, NULL, NULL, 46996);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(46997, '1.20.58.2220-FF-000071', NULL, 'Uncharacterized protein', 75, NULL, NULL, 46997),
(46998, '3.40.50.720-FF-001780', NULL, '2-dehydropantoate 2-reductase', 176, NULL, NULL, 46998),
(46999, '4.10.860.10-FF-000012', NULL, 'UvrABC system protein C', 44, NULL, NULL, 46999),
(47000, '1.20.58.2010-FF-000007', NULL, 'Pollen-specific kinase partner protein', 83, NULL, NULL, 47000),
(47001, '3.30.40.10-FF-000528', NULL, 'E3 ubiquitin-protein ligase XBAT33', 81, NULL, NULL, 47001),
(47002, '1.10.287.110-FF-000120', NULL, 'Hlj1p', 129, NULL, NULL, 47002),
(47003, '1.25.10.10-FF-002617', NULL, 'Putative ARM repeat-containing protein containing family protein', 134, NULL, NULL, 47003),
(47004, '3.30.460.10-FF-000048', NULL, 'PolyA polymerase family protein', 165, NULL, NULL, 47004),
(47005, '3.30.450.40-FF-000192', NULL, 'Uncharacterized protein', 152, NULL, NULL, 47005),
(47006, '3.30.30.10-FF-000016', NULL, NULL, 63, NULL, NULL, 47006),
(47007, '3.40.50.150-FF-001384', NULL, NULL, 174, NULL, NULL, 47007),
(47008, '2.10.25.10-FF-001238', NULL, 'Protein C (inactivator of coagulation factors Va and VIIIa), a', 38, NULL, NULL, 47008),
(47009, '3.40.50.300-FF-003672', NULL, '26S proteasome regulatory subunit', 32, NULL, NULL, 47009),
(47010, '2.60.120.970-FF-000040', NULL, 'Nodal homolog 5', 192, NULL, NULL, 47010),
(47011, '2.30.29.30-FF-001319', NULL, 'PH and Rap-GAP domain-containing protein DDB_G0271806', 68, NULL, NULL, 47011),
(47012, '1.10.560.10-FF-000158', NULL, 'Uncharacterized protein', 173, NULL, NULL, 47012),
(47013, '3.30.1490.20-FF-000081', NULL, 'Blr0101 protein', 76, NULL, NULL, 47013),
(47014, '3.30.2290.10-FF-000023', NULL, 'Peptidase U62 modulator of DNA gyrase', 214, NULL, NULL, 47014),
(47015, '1.20.120.1220-FF-000003', NULL, 'Type 4 prepilin-like proteins leader peptide-processing enzyme', 150, NULL, NULL, 47015),
(47016, '3.30.70.270-FF-000139', NULL, 'Pol polyprotein', 73, NULL, NULL, 47016),
(47017, '3.30.70.330-FF-002113', NULL, NULL, 113, NULL, NULL, 47017),
(47018, '2.40.37.10-FF-000011', NULL, 'Diaminopimelate decarboxylase', 167, NULL, NULL, 47018),
(47019, '1.10.287.3550-FF-000001', NULL, 'Stromal interaction molecule 1', 101, NULL, NULL, 47019),
(47020, '3.40.50.300-FF-003716', NULL, 'DNA replication and repair protein RecF', 155, NULL, NULL, 47020),
(47021, '2.60.40.10-FF-002800', NULL, 'CD4-1 molecule', 107, NULL, NULL, 47021),
(47022, '1.25.40.10-FF-003648', NULL, 'Uncharacterized protein', 211, NULL, NULL, 47022),
(47023, '1.20.1070.10-FF-000275', NULL, 'Gonadotropin-releasing hormone II receptor', 342, NULL, NULL, 47023),
(47024, '2.10.25.10-FF-000266', NULL, 'Urokinase-type plasminogen activator', 39, NULL, NULL, 47024),
(47025, '3.30.160.60-FF-003677', NULL, 'Zinc finger and BTB domain-containing protein 17', 40, NULL, NULL, 47025),
(47026, '3.40.50.620-FF-000777', NULL, 'Uncharacterized protein', 101, NULL, NULL, 47026),
(47027, '1.25.40.10-FF-005082', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 90, NULL, NULL, 47027),
(47028, '3.20.20.70-FF-000517', NULL, 'Putative dihydropyrimidine dehydrogenase [NADP+]', 289, NULL, NULL, 47028),
(47029, '3.20.20.80-FF-000054', NULL, 'Glycogen debranching enzyme', 468, NULL, NULL, 47029),
(47030, '3.30.200.20-FF-001140', NULL, 'Protein kinase domain containing protein', 100, NULL, NULL, 47030),
(47031, '1.25.40.10-FF-003064', NULL, 'Uncharacterized protein', 216, NULL, NULL, 47031),
(47032, '3.30.70.330-FF-001607', NULL, NULL, 105, NULL, NULL, 47032),
(47033, '3.40.50.300-FF-008343', NULL, 'Uncharacterized protein', 191, NULL, NULL, 47033),
(47034, '1.20.890.10-FF-000006', NULL, 'Sperm surface protein Sp17', 43, NULL, NULL, 47034),
(47035, '1.20.5.1240-FF-000001', NULL, 'Tail spike protein', 52, NULL, NULL, 47035),
(47036, '3.90.550.50-FF-000172', NULL, 'Uncharacterized protein', 259, NULL, NULL, 47036),
(47037, '1.20.1250.20-FF-000067', NULL, 'sialin isoform X2', 207, NULL, NULL, 47037),
(47038, '3.40.50.720-FF-000509', NULL, 'Short chain dehydrogenase', 253, NULL, NULL, 47038),
(47039, '2.10.70.10-FF-000264', NULL, 'Complement factor H-related 1', 29, NULL, NULL, 47039); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(47040, '3.40.50.1820-FF-000349', NULL, 'Monoglyceride lipase', 313, NULL, NULL, 47040),
(47041, '1.10.530.10-FF-000010', NULL, 'chitinase-like protein 2', 183, NULL, NULL, 47041),
(47042, '3.30.40.10-FF-001034', NULL, 'E3 ubiquitin-protein ligase SHPRH', 81, NULL, NULL, 47042),
(47043, '2.60.40.150-FF-000499', NULL, 'Uncharacterized protein PYUK71.03c', 140, NULL, NULL, 47043),
(47044, '3.30.160.60-FF-001529', NULL, 'zinc finger X-linked protein ZXDB', 31, NULL, NULL, 47044),
(47045, '3.40.30.10-FF-000741', NULL, 'Thioredoxin', 121, NULL, NULL, 47045),
(47046, '1.20.1070.10-FF-001601', NULL, 'Uncharacterized protein', 152, NULL, NULL, 47046),
(47047, '3.40.630.30-FF-000161', NULL, 'Acetyl transferase', 137, NULL, NULL, 47047),
(47048, '3.40.350.10-FF-000004', NULL, 'xaa-Pro aminopeptidase 1 isoform X1', 164, NULL, NULL, 47048),
(47049, '3.80.10.10-FF-000619', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 329, NULL, NULL, 47049),
(47050, '3.40.50.620-FF-000468', NULL, 'Cytidylyltransferase', 247, NULL, NULL, 47050),
(47051, '1.25.40.20-FF-001285', NULL, 'Ankyrin repeat and zinc finger domain-containing 1', 174, NULL, NULL, 47051),
(47052, '3.10.400.20-FF-000030', NULL, 'Uncharacterized protein', 96, NULL, NULL, 47052),
(47053, '1.10.1300.10-FF-000088', NULL, 'Uncharacterized protein', 201, NULL, NULL, 47053),
(47054, '3.30.70.330-FF-003041', NULL, NULL, 126, NULL, NULL, 47054),
(47055, '3.30.300.30-FF-000088', NULL, 'Dihydroaeruginoic acid synthetase', 90, NULL, NULL, 47055),
(47056, '3.40.50.300-FF-005734', NULL, 'Endoribonuclease Dicer-like 2', 153, NULL, NULL, 47056),
(47057, '2.60.120.200-FF-000416', NULL, 'Pappalysin 1', 144, NULL, NULL, 47057),
(47058, '2.60.40.2030-FF-000021', NULL, 'Adhesion G protein-coupled receptor V1', 125, NULL, NULL, 47058),
(47059, '4.10.240.10-FF-000055', NULL, 'C6 transcription factor (Ctf1B)', 64, NULL, NULL, 47059),
(47060, '3.90.1150.10-FF-000477', NULL, '8-amino-3,8-dideoxy-alpha-D-manno-octulosonate transaminase', 145, NULL, NULL, 47060),
(47061, '1.10.520.10-FF-000049', NULL, 'Uncharacterized protein', 67, NULL, NULL, 47061),
(47062, '3.10.580.10-FF-000079', NULL, 'DUF21 domain-containing protein At1g47330', 51, NULL, NULL, 47062),
(47063, '1.20.58.60-FF-000802', NULL, 'AGAP009554-PA', 205, NULL, NULL, 47063),
(47064, '3.40.920.10-FF-000014', NULL, 'Pyruvic-ferredoxin oxidoreductase, gamma subunit', 186, NULL, NULL, 47064),
(47065, '1.20.58.60-FF-000690', NULL, 'Predicted protein', 113, NULL, NULL, 47065),
(47066, '1.10.287.70-FF-000737', NULL, 'Sodium channel protein', 111, NULL, NULL, 47066),
(47067, '2.40.70.10-FF-000021', NULL, 'Aspartyl protease AED1', 194, NULL, NULL, 47067),
(47068, '3.40.50.150-FF-000996', NULL, NULL, 209, NULL, NULL, 47068),
(47069, '3.40.50.300-FF-004291', NULL, 'Guanylate-binding family protein', 107, NULL, NULL, 47069),
(47070, '3.20.20.80-FF-000363', NULL, 'Chitinase, putative', 250, NULL, NULL, 47070),
(47071, '3.20.20.80-FF-000615', NULL, 'Predicted protein', 150, NULL, NULL, 47071),
(47072, '3.40.50.720-FF-001881', NULL, 'dTDP-4-dehydrorhamnose 3,5-epimerase', 313, NULL, NULL, 47072),
(47073, '2.130.10.10-FF-003958', NULL, 'Coronin', 242, NULL, NULL, 47073),
(47074, '1.25.40.10-FF-002445', NULL, 'Os03g0701400 protein', 95, NULL, NULL, 47074),
(47075, '3.40.50.1110-FF-000125', NULL, 'Similar to c-type cytochrome', 201, NULL, NULL, 47075),
(47076, '3.40.50.300-FF-006353', NULL, 'LD28840p', 141, NULL, NULL, 47076),
(47077, '2.130.10.10-FF-002210', NULL, 'WD repeat-containing protein 82', 75, NULL, NULL, 47077),
(47078, '2.60.40.60-FF-000662', NULL, 'Cadherin 17', 103, NULL, NULL, 47078),
(47079, '3.30.420.40-FF-000364', NULL, 'Heat shock protein 70 family protein', 121, NULL, NULL, 47079),
(47080, '1.10.3210.10-FF-000126', NULL, 'Uncharacterized protein', 274, NULL, NULL, 47080),
(47081, '3.70.10.10-FF-000143', NULL, 'DNA repair exonuclease REC1', 78, NULL, NULL, 47081),
(47082, '1.20.1730.10-FF-000056', NULL, 'Uncharacterized protein', 472, NULL, NULL, 47082),
(47083, '3.20.20.140-FF-000492', NULL, 'Error-prone DNA polymerase', 266, NULL, NULL, 47083);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(47084, '1.10.510.10-FF-001745', NULL, 'Non-specific protein-tyrosine kinase', 218, NULL, NULL, 47084),
(47085, '3.90.80.10-FF-000005', NULL, 'Pyrophosphatase (inorganic) 2', 290, NULL, NULL, 47085),
(47086, '3.40.720.10-FF-000241', NULL, 'Uncharacterized protein', 248, NULL, NULL, 47086),
(47087, '3.40.50.300-FF-001991', NULL, 'DNA polymerase III, delta prime subunit', 165, NULL, NULL, 47087),
(47088, '3.40.50.300-FF-008135', NULL, 'ATP-dependent RNA helicase', 103, NULL, NULL, 47088),
(47089, '2.30.42.10-FF-000102', NULL, 'Putative pro-interleukin-16', 122, NULL, NULL, 47089),
(47090, '3.40.50.300-FF-006898', NULL, 'Anion-transporting ATPase family protein', 240, NULL, NULL, 47090),
(47091, '3.40.50.720-FF-001572', NULL, 'Short-chain dehydrogenase, putative', 240, NULL, NULL, 47091),
(47092, '1.10.10.60-FF-000968', NULL, NULL, 52, NULL, NULL, 47092),
(47093, '1.10.8.10-FF-000244', NULL, 'NSFL1 cofactor p47', 45, NULL, NULL, 47093),
(47094, '1.10.274.100-FF-000029', NULL, 'Uncharacterized protein', 121, NULL, NULL, 47094),
(47095, '3.30.70.240-FF-000035', NULL, 'Ribosome-releasing factor 2, mitochondrial', 104, NULL, NULL, 47095),
(47096, '1.50.10.10-FF-000108', NULL, 'Glucan 1,4-alpha-glucosidase, putative', 508, NULL, NULL, 47096),
(47097, '2.30.30.40-FF-000292', NULL, 'Calcium Channel, Beta subunit', 147, NULL, NULL, 47097),
(47098, '2.130.10.10-FF-000524', NULL, 'Autophagy-related protein 18, putative', 353, NULL, NULL, 47098),
(47099, '1.25.40.180-FF-000237', NULL, NULL, 195, NULL, NULL, 47099),
(47100, '2.60.40.150-FF-000235', NULL, 'Activating signal cointegrator 1 complex subunit 3', 118, NULL, NULL, 47100),
(47101, '2.60.120.920-FF-000177', NULL, 'Si:dkeyp-4f2.1', 54, NULL, NULL, 47101),
(47102, '3.40.50.300-FF-001682', NULL, 'Putative pre-mRNA splicing factor ATP-dependent RNA helicase', 214, NULL, NULL, 47102),
(47103, '2.130.10.10-FF-000979', NULL, 'WD repeat domain 60', 172, NULL, NULL, 47103),
(47104, '1.10.1030.10-FF-000016', NULL, 'Predicted protein', 139, NULL, NULL, 47104),
(47105, '4.10.400.10-FF-000366', NULL, 'Uncharacterized protein', 41, NULL, NULL, 47105),
(47106, '2.60.40.150-FF-000605', NULL, 'Uncharacterized protein', 165, NULL, NULL, 47106),
(47107, '3.30.160.20-FF-000096', NULL, 'Os01g0887400 protein', 73, NULL, NULL, 47107),
(47108, '1.20.1310.10-FF-000209', NULL, NULL, 111, NULL, NULL, 47108),
(47109, '1.10.3720.10-FF-000209', NULL, 'Arginine transport system permease protein', 214, NULL, NULL, 47109),
(47110, '2.130.10.10-FF-003649', NULL, 'Elongator acetyltransferase complex subunit 2', 150, NULL, NULL, 47110),
(47111, '1.20.1560.10-FF-000492', NULL, 'ABC transporter, putative (Eurofung)', 246, NULL, NULL, 47111),
(47112, '2.40.30.10-FF-000092', NULL, 'Elongation factor Tu', 56, NULL, NULL, 47112),
(47113, '2.30.29.30-FF-001044', NULL, 'Uncharacterized protein', 146, NULL, NULL, 47113),
(47114, '3.30.1010.10-FF-000104', NULL, 'Predicted protein', 188, NULL, NULL, 47114),
(47115, '3.30.160.60-FF-001985', NULL, 'SEM-4 long form', 26, NULL, NULL, 47115),
(47116, '1.10.150.190-FF-000004', NULL, 'Eukaryotic translation initiation factor 2 subunit 1', 86, NULL, NULL, 47116),
(47117, '3.20.20.80-FF-000716', NULL, 'Uncharacterized protein', 172, NULL, NULL, 47117),
(47118, '3.10.20.90-FF-000097', NULL, 'UBX domain-containing protein 7', 82, NULL, NULL, 47118),
(47119, '1.20.1250.20-FF-001247', NULL, 'Uncharacterized protein', 441, NULL, NULL, 47119),
(47120, '2.70.160.11-FF-000033', NULL, 'Protein arginine N-methyltransferase, putative', 163, NULL, NULL, 47120),
(47121, '1.25.10.10-FF-001555', NULL, 'Uncharacterized protein', 160, NULL, NULL, 47121),
(47122, '1.20.58.390-FF-000219', NULL, 'Gamma-aminobutyric acid (GABA) A receptor, alpha 1', 98, NULL, NULL, 47122),
(47123, '1.20.1420.30-FF-000095', NULL, 'Uncharacterized protein', 232, NULL, NULL, 47123),
(47124, '1.10.510.10-FF-003292', NULL, NULL, 90, NULL, NULL, 47124),
(47125, '1.10.510.10-FF-001392', NULL, 'Px serine/threonine kinase (Pxk)', 160, NULL, NULL, 47125),
(47126, '1.20.58.390-FF-000175', NULL, 'Predicted protein', 119, NULL, NULL, 47126);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(47127, '2.130.10.10-FF-006055', NULL, 'Uncharacterized protein', 134, NULL, NULL, 47127),
(47128, '1.10.565.10-FF-000118', NULL, 'Steroid hormone receptor 3', 255, NULL, NULL, 47128),
(47129, '1.10.1420.10-FF-000052', NULL, 'Msh4p', 129, NULL, NULL, 47129),
(47130, '3.30.160.60-FF-004391', NULL, NULL, 62, NULL, NULL, 47130),
(47131, '2.60.40.10-FF-005998', NULL, NULL, 70, NULL, NULL, 47131),
(47132, '2.60.120.380-FF-000060', NULL, 'Uncharacterized protein', 149, NULL, NULL, 47132),
(47133, '1.20.120.1910-FF-000030', NULL, 'YALI0D15268p', 188, NULL, NULL, 47133),
(47134, '3.50.50.60-FF-001234', NULL, 'Glr0393 protein', 214, NULL, NULL, 47134),
(47135, '1.20.1310.10-FF-000108', NULL, NULL, 129, NULL, NULL, 47135),
(47136, '1.20.1560.10-FF-000020', NULL, 'ABC metal ion transporter', 330, NULL, NULL, 47136),
(47137, '1.10.260.40-FF-000026', NULL, 'Predicted DNA-binding transcriptional regulator', 75, NULL, NULL, 47137),
(47138, '2.30.30.40-FF-000404', NULL, 'Rho GTPase-activating protein 4', 75, NULL, NULL, 47138),
(47139, '3.30.160.60-FF-006291', NULL, NULL, 43, NULL, NULL, 47139),
(47140, '3.30.70.1510-FF-000001', NULL, 'Probable tRNA sulfurtransferase', 83, NULL, NULL, 47140),
(47141, '2.40.170.20-FF-000126', NULL, NULL, 342, NULL, NULL, 47141),
(47142, '1.20.1070.10-FF-001337', NULL, 'Si:dkey-94e7.1', 276, NULL, NULL, 47142),
(47143, '3.40.50.150-FF-001805', NULL, NULL, 118, NULL, NULL, 47143),
(47144, '3.30.230.80-FF-000007', NULL, 'Heat shock protein 90', 172, NULL, NULL, 47144),
(47145, '2.40.50.90-FF-000116', NULL, 'Spindle E', 61, NULL, NULL, 47145),
(47146, '3.30.160.60-FF-002249', NULL, 'Zinc finger protein 560', 27, NULL, NULL, 47146),
(47147, '3.40.50.10470-FF-000055', NULL, 'Uncharacterized protein', 196, NULL, NULL, 47147),
(47148, '2.60.120.200-FF-000624', NULL, 'Uncharacterized protein', 135, NULL, NULL, 47148),
(47149, '2.102.10.10-FF-000003', NULL, 'apoptosis-inducing factor 3 isoform X2', 110, NULL, NULL, 47149),
(47150, '2.160.20.10-FF-000001', NULL, 'Pectinesterase', 318, NULL, NULL, 47150),
(47151, '3.50.4.10-FF-000052', NULL, NULL, 80, NULL, NULL, 47151),
(47152, '3.30.160.60-FF-003885', NULL, 'RE23320p', 86, NULL, NULL, 47152),
(47153, '3.90.1480.20-FF-000027', NULL, 'ST3 beta-galactoside alpha-2,3-sialyltransferase 3a', 184, NULL, NULL, 47153),
(47154, '2.130.10.10-FF-001693', NULL, 'WD repeats protein kinase', 109, NULL, NULL, 47154),
(47155, '3.40.50.720-FF-002398', NULL, 'Glutathione-gated K(+)-efflux system KefB', 158, NULL, NULL, 47155),
(47156, '1.10.238.160-FF-000002', NULL, 'Predicted transcriptional regulator', 57, NULL, NULL, 47156),
(47157, '2.30.30.830-FF-000005', NULL, 'Pilus assembly protein PilZ', 64, NULL, NULL, 47157),
(47158, '3.20.20.190-FF-000135', NULL, NULL, 92, NULL, NULL, 47158),
(47159, '3.90.1440.10-FF-000016', NULL, 'AGAP011982-PA', 36, NULL, NULL, 47159),
(47160, '3.40.50.150-FF-000524', NULL, 'PHD finger-like domain-containing protein 5A', 278, NULL, NULL, 47160),
(47161, '1.50.40.10-FF-000358', NULL, 'Uncharacterized protein', 169, NULL, NULL, 47161),
(47162, '1.10.10.800-FF-000006', NULL, 'YALI0A17281p', 88, NULL, NULL, 47162),
(47163, '3.40.50.1820-FF-000760', NULL, 'Alpha/beta hydrolase family protein', 311, NULL, NULL, 47163),
(47164, '3.40.50.880-FF-000198', NULL, 'Chromosome 9, whole genome shotgun sequence', 124, NULL, NULL, 47164),
(47165, '3.30.540.10-FF-000004', NULL, 'Inositol-1-monophosphatase', 144, NULL, NULL, 47165),
(47166, '3.40.1190.20-FF-000128', NULL, 'GD14306', 299, NULL, NULL, 47166),
(47167, '3.30.1330.30-FF-000134', NULL, 'Uncharacterized protein', 98, NULL, NULL, 47167),
(47168, '3.30.230.60-FF-000001', NULL, '5,6,7,8-tetrahydromethanopterin hydro-lyase', 163, NULL, NULL, 47168),
(47169, '3.50.50.60-FF-001381', NULL, 'Uncharacterized protein', 112, NULL, NULL, 47169),
(47170, '2.20.25.10-FF-000108', NULL, 'Transcription elongation factor s-II, putative', 73, NULL, NULL, 47170),
(47171, '2.60.40.1510-FF-000005', NULL, 'Integrin beta', 111, NULL, NULL, 47171),
(47172, '1.20.1050.80-FF-000013', NULL, 'Ankyrin repeat domain 27 (VPS9 domain)', 151, NULL, NULL, 47172);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(47173, '3.90.1750.10-FF-000017', NULL, 'Ubiquitin-protein ligase E3B', 159, NULL, NULL, 47173),
(47174, '1.25.40.20-FF-000560', NULL, 'Os07g0193200 protein', 147, NULL, NULL, 47174),
(47175, '3.30.160.60-FF-000760', NULL, 'Zinc finger protein 423', 61, NULL, NULL, 47175),
(47176, '3.30.160.60-FF-003738', NULL, NULL, 28, NULL, NULL, 47176),
(47177, '3.80.10.10-FF-002761', NULL, 'Predicted protein', 86, NULL, NULL, 47177),
(47178, '3.40.1110.10-FF-000351', NULL, NULL, 84, NULL, NULL, 47178),
(47179, '3.80.10.10-FF-003481', NULL, 'Fgr51p', 204, NULL, NULL, 47179),
(47180, '3.40.50.150-FF-001704', NULL, NULL, 67, NULL, NULL, 47180),
(47181, '2.130.10.10-FF-005436', NULL, 'Uncharacterized WD repeat-containing protein C1306.02', 216, NULL, NULL, 47181),
(47182, '3.40.1090.10-FF-000062', NULL, 'Uncharacterized NTE family protein M110.7', 122, NULL, NULL, 47182),
(47183, '1.50.10.150-FF-000004', NULL, 'Malic acid transporter', 355, NULL, NULL, 47183),
(47184, '1.10.3720.10-FF-000108', NULL, 'Oligopeptide ABC transporter permease', 214, NULL, NULL, 47184),
(47185, '1.20.1560.10-FF-000739', NULL, 'Uncharacterized protein', 165, NULL, NULL, 47185),
(47186, '1.20.1540.10-FF-000120', NULL, 'Uncharacterized protein', 101, NULL, NULL, 47186),
(47187, '3.90.190.10-FF-000553', NULL, 'Uncharacterized protein', 108, NULL, NULL, 47187),
(47188, '1.25.10.10-FF-002308', NULL, 'Uncharacterized protein', 317, NULL, NULL, 47188),
(47189, '1.20.58.480-FF-000005', NULL, 'Indoleamine 2,3-dioxygenase family protein', 245, NULL, NULL, 47189),
(47190, '2.130.10.10-FF-004110', NULL, 'Uncharacterized protein', 191, NULL, NULL, 47190),
(47191, '2.60.40.10-FF-003525', NULL, NULL, 82, NULL, NULL, 47191),
(47192, '3.90.70.10-FF-000842', NULL, 'Uncharacterized protein', 127, NULL, NULL, 47192),
(47193, '3.40.50.300-FF-004083', NULL, 'Serine_hydrolase_(FSH1)/50S_ribosome-binding_GTPase/GTPase_of_uncharacterized_function_C-terminal_-_putative', 52, NULL, NULL, 47193),
(47194, '2.60.120.330-FF-000051', NULL, 'Clavaminate synthase-like protein', 329, NULL, NULL, 47194),
(47195, '2.60.120.560-FF-000035', NULL, 'Uncharacterized protein', 180, NULL, NULL, 47195),
(47196, '1.25.40.20-FF-001740', NULL, 'C2 domain containing protein', 214, NULL, NULL, 47196),
(47197, '3.90.1070.10-FF-000004', NULL, 'Sucrose-phosphate synthase family protein', 79, NULL, NULL, 47197),
(47198, '3.80.10.10-FF-002975', NULL, 'CLL4B clavata1-like receptor S/T protein kinase protein', 101, NULL, NULL, 47198),
(47199, '3.30.1010.10-FF-000149', NULL, 'Uncharacterized protein', 97, NULL, NULL, 47199),
(47200, '3.90.1170.10-FF-000023', NULL, 'Ribosomal protein L16', 123, NULL, NULL, 47200),
(47201, '3.40.50.300-FF-002183', NULL, 'Nucleotide-binding protein', 231, NULL, NULL, 47201),
(47202, '3.60.21.10-FF-000365', NULL, 'Sphingomyelin phosphodiesterase, putative', 134, NULL, NULL, 47202),
(47203, '1.25.40.10-FF-004929', NULL, 'Pentatricopeptide repeat-containing protein', 48, NULL, NULL, 47203),
(47204, '1.10.630.10-FF-000597', NULL, 'Cytochrome P450 superfamily protein', 278, NULL, NULL, 47204),
(47205, '1.25.10.10-FF-002983', NULL, 'Condensin complex subunit 3-like Protein', 383, NULL, NULL, 47205),
(47206, '1.20.1250.20-FF-000628', NULL, 'Unplaced genomic scaffold supercont1.223, whole genome shotgun sequence', 189, NULL, NULL, 47206),
(47207, '1.20.58.1040-FF-000014', NULL, '1,3-beta-glucanosyltransferase', 113, NULL, NULL, 47207),
(47208, '3.30.40.210-FF-000008', NULL, 'Transcription elongation factor SPT4', 107, NULL, NULL, 47208),
(47209, '2.60.40.420-FF-000001', NULL, 'Cytochrome c oxidase subunit 2', 134, NULL, NULL, 47209),
(47210, '3.40.50.300-FF-003363', NULL, 'ATPase family, AAA domain containing 5a', 108, NULL, NULL, 47210),
(47211, '2.60.40.1180-FF-000171', NULL, 'Predicted protein', 124, NULL, NULL, 47211),
(47212, '2.60.40.60-FF-000454', NULL, 'Si:dkey-30k22.7', 100, NULL, NULL, 47212),
(47213, '3.40.50.11350-FF-000009', NULL, 'Galactoside 2-alpha-L-fucosyltransferase', 155, NULL, NULL, 47213),
(47214, '3.30.470.20-FF-000097', NULL, 'Phosphoribosylamine--glycine ligase-like protein', 140, NULL, NULL, 47214);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(47215, '1.20.120.1200-FF-000008', NULL, 'NADH-ubiquinone oxidoreductase chain 6', 185, NULL, NULL, 47215),
(47216, '1.10.10.10-FF-001583', NULL, 'RNA polymerase sigma-38 factor, stationary phase', 72, NULL, NULL, 47216),
(47217, '3.30.160.60-FF-005880', NULL, NULL, 38, NULL, NULL, 47217),
(47218, '2.60.120.10-FF-000543', NULL, 'Uncharacterized protein', 158, NULL, NULL, 47218),
(47219, '1.10.220.30-FF-000015', NULL, 'Flagellar motor switch protein FliG', 103, NULL, NULL, 47219),
(47220, '1.20.58.1120-FF-000049', NULL, NULL, 142, NULL, NULL, 47220),
(47221, '3.90.1410.10-FF-000076', NULL, 'Uncharacterized protein', 228, NULL, NULL, 47221),
(47222, '3.90.320.10-FF-000019', NULL, 'DNA replication ATP-dependent helicase Dna2', 190, NULL, NULL, 47222),
(47223, '3.40.30.10-FF-000139', NULL, 'Protein disulfide-isomerase', 116, NULL, NULL, 47223),
(47224, '3.40.50.1820-FF-000658', NULL, 'Alpha/beta hydrolase, putative (AFU_orthologue AFUA_7G06650)', 277, NULL, NULL, 47224),
(47225, '2.10.70.100-FF-000001', NULL, 'Sensory transduction histidine kinase', 47, NULL, NULL, 47225),
(47226, '2.30.29.30-FF-001191', NULL, 'YL1 nuclear protein Cterminal domain-containing protein', 89, NULL, NULL, 47226),
(47227, '3.40.50.2000-FF-000494', NULL, 'Related to SPT14-N-acetylglucosaminyltransferase', 180, NULL, NULL, 47227),
(47228, '3.40.50.720-FF-001229', NULL, 'Oxidoreductase-like protein', 169, NULL, NULL, 47228),
(47229, '1.20.1330.10-FF-000008', NULL, 'Flagellin', 87, NULL, NULL, 47229),
(47230, '3.90.1860.10-FF-000008', NULL, 'RNA-splicing ligase RtcB', 476, NULL, NULL, 47230),
(47231, '3.10.20.30-FF-000039', NULL, 'Putative threonyl-tRNA synthetase', 65, NULL, NULL, 47231),
(47232, '1.10.510.10-FF-002673', NULL, NULL, 65, NULL, NULL, 47232),
(47233, '2.60.120.590-FF-000033', NULL, 'Hydroxyproline-rich glycoprotein family protein', 216, NULL, NULL, 47233),
(47234, '3.30.160.20-FF-000023', NULL, 'DGCR8, microprocessor complex subunit', 57, NULL, NULL, 47234),
(47235, '3.30.1330.40-FF-000047', NULL, 'diphthine--ammonia ligase isoform X1', 124, NULL, NULL, 47235),
(47236, '3.40.190.10-FF-000250', NULL, 'RGD-containing lipoprotein', 301, NULL, NULL, 47236),
(47237, '3.40.50.2300-FF-001011', NULL, NULL, 139, NULL, NULL, 47237),
(47238, '2.60.40.790-FF-000180', NULL, NULL, 122, NULL, NULL, 47238),
(47239, '3.90.550.50-FF-000071', NULL, 'Hexosyltransferase', 226, NULL, NULL, 47239),
(47240, '3.40.50.300-FF-002744', NULL, 'Oligopeptide ABC transporter ATP-binding protein', 255, NULL, NULL, 47240),
(47241, '3.30.450.20-FF-000343', NULL, 'Sensor histidine kinase, Cache_1, HAMP and PAS domain-containing', 144, NULL, NULL, 47241),
(47242, '2.60.40.60-FF-001073', NULL, 'Protein CBR-CDH-3', 29, NULL, NULL, 47242),
(47243, '1.25.40.10-FF-005126', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 109, NULL, NULL, 47243),
(47244, '3.50.50.60-FF-000762', NULL, 'FAD-binding oxidoreductase', 48, NULL, NULL, 47244),
(47245, '3.40.50.300-FF-004644', NULL, 'DNA helicase', 49, NULL, NULL, 47245),
(47246, '3.90.105.10-FF-000031', NULL, 'Molybdopterin molybdenumtransferase', 55, NULL, NULL, 47246),
(47247, '3.40.30.10-FF-000847', NULL, 'Protein disulfide isomerase1-2', 113, NULL, NULL, 47247),
(47248, '3.30.160.60-FF-000451', NULL, 'Zinc finger protein 710', 30, NULL, NULL, 47248),
(47249, '3.30.1640.10-FF-000034', NULL, 'Os06g0723400 protein', 89, NULL, NULL, 47249),
(47250, '1.50.10.20-FF-000067', NULL, 'Protein CBG20759', 335, NULL, NULL, 47250),
(47251, '3.40.50.10190-FF-000291', NULL, 'Predicted protein', 62, NULL, NULL, 47251),
(47252, '1.25.40.10-FF-004154', NULL, 'Uncharacterized protein', 110, NULL, NULL, 47252),
(47253, '3.30.9.10-FF-000091', NULL, 'D-amino acid oxidase', 138, NULL, NULL, 47253),
(47254, '3.40.50.1100-FF-000235', NULL, 'Serine racemase', 56, NULL, NULL, 47254),
(47255, '3.50.50.60-FF-000054', NULL, 'Flavoprotein disulfide reductase', 119, NULL, NULL, 47255),
(47256, '3.10.350.10-FF-000011', NULL, 'Peptidoglycan endopeptidase LytF', 54, NULL, NULL, 47256),
(47257, '3.60.40.10-FF-000274', NULL, 'Uncharacterized protein', 266, NULL, NULL, 47257);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(47258, '1.10.167.10-FF-000008', NULL, 'rho guanine nucleotide exchange factor 12', 215, NULL, NULL, 47258),
(47259, '3.90.1200.10-FF-000021', NULL, 'Choline kinase', 196, NULL, NULL, 47259),
(47260, '1.10.10.830-FF-000004', NULL, 'Isoleucyl-tRNA synthetase, mitochondrial, putative', 51, NULL, NULL, 47260),
(47261, '3.40.1110.10-FF-000087', NULL, 'Phospholipid-transporting ATPase', 160, NULL, NULL, 47261),
(47262, '1.10.510.10-FF-003853', NULL, NULL, 102, NULL, NULL, 47262),
(47263, '3.40.50.1000-FF-000194', NULL, 'Mitochondrial import inner membrane translocase subunit TIM50', 181, NULL, NULL, 47263),
(47264, '2.110.10.10-FF-000042', NULL, 'Uncharacterized protein', 98, NULL, NULL, 47264),
(47265, '3.30.530.20-FF-000035', NULL, 'ENHANCED DISEASE RESISTANCE 2', 202, NULL, NULL, 47265),
(47266, '3.40.250.10-FF-000087', NULL, 'Sulfurtransferase', 118, NULL, NULL, 47266),
(47267, '3.40.50.150-FF-000215', NULL, 'Hua enhancer1', 249, NULL, NULL, 47267),
(47268, '3.30.230.10-FF-000003', NULL, 'Elongation factor G', 136, NULL, NULL, 47268),
(47269, '3.40.50.720-FF-000291', NULL, 'Phosphoglycerate dehydrogenase, putative; 33424-31403', 199, NULL, NULL, 47269),
(47270, '3.30.1370.10-FF-000041', NULL, 'vigilin isoform X1', 86, NULL, NULL, 47270),
(47271, '2.60.40.10-FF-002906', NULL, 'Cheerio, isoform I', 109, NULL, NULL, 47271),
(47272, '3.30.160.60-FF-005571', NULL, NULL, 48, NULL, NULL, 47272),
(47273, '1.20.5.340-FF-000076', NULL, 'Uncharacterized protein', 95, NULL, NULL, 47273),
(47274, '2.40.50.140-FF-001222', NULL, NULL, 66, NULL, NULL, 47274),
(47275, '2.30.180.10-FF-000115', NULL, NULL, 175, NULL, NULL, 47275),
(47276, '2.10.90.10-FF-000164', NULL, 'Uncharacterized protein', 56, NULL, NULL, 47276),
(47277, '3.10.620.10-FF-000004', NULL, 'Uncharacterized protein', 143, NULL, NULL, 47277),
(47278, '3.40.47.10-FF-000133', NULL, '3-hydroxy-3-methylglutaryl coenzyme A synthase', 279, NULL, NULL, 47278),
(47279, '3.30.70.1450-FF-000022', NULL, 'Sodium/sulfate transporter, putative', 80, NULL, NULL, 47279),
(47280, '3.40.50.620-FF-000671', NULL, 'Uncharacterized protein', 85, NULL, NULL, 47280),
(47281, '1.10.10.10-FF-000094', NULL, 'Phosphatidylinositol-3,4,5-trisphosphate dependent Rac exchange factor 1', 100, NULL, NULL, 47281),
(47282, '3.40.50.2300-FF-000393', NULL, 'Sucrose operon repressor ScrR LacI family', 123, NULL, NULL, 47282),
(47283, '3.40.30.10-FF-000286', NULL, 'Protein disulfide-isomerase domain', 124, NULL, NULL, 47283),
(47284, '3.40.50.410-FF-000170', NULL, 'Collagen, type VI, alpha 1', 196, NULL, NULL, 47284),
(47285, '1.20.1070.10-FF-000628', NULL, 'Adenosine receptor A3', 107, NULL, NULL, 47285),
(47286, '1.25.40.540-FF-000025', NULL, 'TAP42-like protein', 207, NULL, NULL, 47286),
(47287, '3.90.70.10-FF-000179', NULL, 'Ubiquitin carboxyl-terminal hydrolase 1, putative', 331, NULL, NULL, 47287),
(47288, '3.30.70.330-FF-001360', NULL, 'Putative RNA-binding protein', 114, NULL, NULL, 47288),
(47289, '3.30.565.10-FF-000174', NULL, 'Serine phosphatase RsbU, regulator of sigma subunit', 129, NULL, NULL, 47289),
(47290, '1.20.5.110-FF-000254', NULL, 'Syx-3', 104, NULL, NULL, 47290),
(47291, '3.90.550.10-FF-000328', NULL, 'Predicted protein', 261, NULL, NULL, 47291),
(47292, '3.30.9.10-FF-000248', NULL, 'Uncharacterized protein', 174, NULL, NULL, 47292),
(47293, '1.20.58.60-FF-000347', NULL, 'Muscle-specific protein 300 kDa, isoform L', 205, NULL, NULL, 47293),
(47294, '3.30.420.40-FF-000600', NULL, 'DnaK protein', 198, NULL, NULL, 47294),
(47295, '1.20.120.180-FF-000004', NULL, 'Uncharacterized protein', 133, NULL, NULL, 47295),
(47296, '2.60.40.10-FF-000136', NULL, 'Ciliary neurotrophic factor receptor alpha', 105, NULL, NULL, 47296),
(47297, '1.20.1250.20-FF-001556', NULL, 'Solute carrier family 22 member 16', 406, NULL, NULL, 47297),
(47298, '3.30.160.60-FF-002558', NULL, 'Uncharacterized protein', 30, NULL, NULL, 47298),
(47299, '1.20.120.1750-FF-000061', NULL, 'RBR-type E3 ubiquitin transferase', 126, NULL, NULL, 47299),
(47300, '2.60.40.10-FF-002036', NULL, 'Contactin', 83, NULL, NULL, 47300);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(47301, '3.40.50.1820-FF-001277', NULL, 'Uncharacterized protein', 298, NULL, NULL, 47301),
(47302, '1.25.40.60-FF-000004', NULL, 'syntaxin-binding protein 3 isoform X2', 116, NULL, NULL, 47302),
(47303, '3.90.1310.10-FF-000012', NULL, 'Penicillin-binding protein 1 (Peptidoglycan synthetase)', 93, NULL, NULL, 47303),
(47304, '3.40.1190.20-FF-000230', NULL, 'Predicted protein', 387, NULL, NULL, 47304),
(47305, '3.60.90.10-FF-000013', NULL, 'S-adenosylmethionine decarboxylase proenzyme', 120, NULL, NULL, 47305),
(47306, '1.10.238.10-FF-000887', NULL, 'Rab-GTPase-TBC domain-domain-containing protein', 168, NULL, NULL, 47306),
(47307, '3.40.50.12160-FF-000022', NULL, 'tRNA (N(6)-L-threonylcarbamoyladenosine(37)-C(2))-methylthiotransferase MtaB', 116, NULL, NULL, 47307),
(47308, '1.10.240.10-FF-000022', NULL, 'Tryptophanyl-tRNA synthetase', 125, NULL, NULL, 47308),
(47309, '3.40.50.720-FF-000852', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(P)+]', 117, NULL, NULL, 47309),
(47310, '3.40.350.10-FF-000105', NULL, 'Xaa-Pro aminopeptidase 1-like Protein', 106, NULL, NULL, 47310),
(47311, '2.60.40.10-FF-002345', NULL, 'FMS related tyrosine kinase 1', 123, NULL, NULL, 47311),
(47312, '3.30.1370.100-FF-000002', NULL, 'DNA mismatch repair protein MutL', 89, NULL, NULL, 47312),
(47313, '1.25.40.10-FF-001383', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 94, NULL, NULL, 47313),
(47314, '1.10.238.10-FF-000623', NULL, 'Putative calmodulin-related protein', 95, NULL, NULL, 47314),
(47315, '1.20.1250.20-FF-000730', NULL, 'Protein CBG05932', 208, NULL, NULL, 47315),
(47316, '3.30.70.980-FF-000009', NULL, 'Putative transcriptional regulatory protein', 78, NULL, NULL, 47316),
(47317, '1.10.510.10-FF-001083', NULL, 'Probable peptidoglycan biosynthesis protein MviN', 153, NULL, NULL, 47317),
(47318, '2.60.40.10-FF-004031', NULL, NULL, 124, NULL, NULL, 47318),
(47319, '1.10.555.10-FF-000180', NULL, NULL, 218, NULL, NULL, 47319),
(47320, '3.40.50.300-FF-007415', NULL, 'ATP binding cassette subfamily B member 1', 22, NULL, NULL, 47320),
(47321, '1.25.40.20-FF-001638', NULL, 'Protein 21.1, putative', 94, NULL, NULL, 47321),
(47322, '3.30.160.60-FF-000349', NULL, 'metal regulatory transcription factor 1', 32, NULL, NULL, 47322),
(47323, '1.10.1520.10-FF-000071', NULL, 'Uncharacterized protein', 182, NULL, NULL, 47323),
(47324, '1.10.238.10-FF-000314', NULL, 'Reticulocalbin 1', 90, NULL, NULL, 47324),
(47325, '2.130.10.10-FF-004155', NULL, 'Uncharacterized protein', 174, NULL, NULL, 47325),
(47326, '3.30.160.60-FF-004503', NULL, NULL, 23, NULL, NULL, 47326),
(47327, '3.30.1330.20-FF-000036', NULL, 'Uncharacterized protein', 108, NULL, NULL, 47327),
(47328, '1.25.10.10-FF-003236', NULL, 'Uncharacterized protein', 905, NULL, NULL, 47328),
(47329, '3.40.50.300-FF-002036', NULL, 'ATP-dependent rRNA helicase SPB4', 92, NULL, NULL, 47329),
(47330, '3.30.70.960-FF-000003', NULL, 'MUC16 isoform 1', 131, NULL, NULL, 47330),
(47331, '3.30.1370.120-FF-000008', NULL, 'Type III secretion outer membrane pore YscC', 99, NULL, NULL, 47331),
(47332, '2.10.25.10-FF-000619', NULL, 'Brevican core protein', 63, NULL, NULL, 47332),
(47333, '3.10.20.90-FF-000552', NULL, 'Uncharacterized protein', 88, NULL, NULL, 47333),
(47334, '3.40.630.30-FF-000583', NULL, 'MGC78821 protein, putative', 93, NULL, NULL, 47334),
(47335, '1.25.10.10-FF-000510', NULL, 'V-type proton ATPase subunit H', 354, NULL, NULL, 47335),
(47336, '3.50.30.30-FF-000095', NULL, 'Uncharacterized protein', 180, NULL, NULL, 47336),
(47337, '1.10.10.60-FF-000092', NULL, 'Trihelix transcription factor GT-2', 62, NULL, NULL, 47337),
(47338, '1.25.40.10-FF-001956', NULL, 'GD21390', 129, NULL, NULL, 47338),
(47339, '1.10.3470.10-FF-000010', NULL, 'Branched-chain amino acid ABC transporter permease', 177, NULL, NULL, 47339),
(47340, '3.50.50.60-FF-000846', NULL, 'Uncharacterized protein', 188, NULL, NULL, 47340),
(47341, '1.20.58.60-FF-000246', NULL, 'Dystrophin', 105, NULL, NULL, 47341),
(47342, '3.90.1170.50-FF-000001', NULL, 'Aldehyde oxidase 1', 95, NULL, NULL, 47342);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(47343, '2.10.25.10-FF-000182', NULL, 'Protransforming growth factor alpha', 50, NULL, NULL, 47343),
(47344, '3.30.70.330-FF-003069', NULL, NULL, 103, NULL, NULL, 47344),
(47345, '3.20.20.140-FF-000345', NULL, 'Uncharacterized protein', 339, NULL, NULL, 47345),
(47346, '1.10.3450.30-FF-000003', NULL, 'UPF0536 protein', 202, NULL, NULL, 47346),
(47347, '3.40.140.10-FF-000275', NULL, 'Cytidine/deoxycytidylate deaminase family protein', 75, NULL, NULL, 47347),
(47348, '1.25.10.10-FF-000403', NULL, 'Condensin complex subunit 1', 181, NULL, NULL, 47348),
(47349, '3.90.550.10-FF-000183', NULL, 'isoprenoid synthase domain-containing protein isoform X2', 137, NULL, NULL, 47349),
(47350, '3.40.30.10-FF-000055', NULL, 'Glutathione S-transferase YfcF', 91, NULL, NULL, 47350),
(47351, '2.40.10.240-FF-000013', NULL, NULL, 76, NULL, NULL, 47351),
(47352, '2.70.130.10-FF-000064', NULL, NULL, 127, NULL, NULL, 47352),
(47353, '1.20.58.60-FF-000774', NULL, 'Spectrin, beta, non-erythrocytic 5', 232, NULL, NULL, 47353),
(47354, '1.20.140.150-FF-000112', NULL, 'Uncharacterized protein', 153, NULL, NULL, 47354),
(47355, '3.40.50.410-FF-000068', NULL, 'ATP-dependent DNA helicase 2 subunit KU70', 233, NULL, NULL, 47355),
(47356, '3.20.80.10-FF-000059', NULL, 'Uncharacterized protein', 112, NULL, NULL, 47356),
(47357, '3.60.20.40-FF-000023', NULL, 'Uncharacterized protein', 118, NULL, NULL, 47357),
(47358, '2.40.180.10-FF-000034', NULL, 'Uncharacterized protein', 120, NULL, NULL, 47358),
(47359, '3.40.50.300-FF-007281', NULL, 'Uncharacterized protein', 154, NULL, NULL, 47359),
(47360, '1.25.40.10-FF-001517', NULL, 'Tonsoku-like protein', 147, NULL, NULL, 47360),
(47361, '3.40.1080.10-FF-000016', NULL, 'Uncharacterized protein', 184, NULL, NULL, 47361),
(47362, '1.10.20.10-FF-000156', NULL, 'Centromere protein S', 109, NULL, NULL, 47362),
(47363, '2.20.110.10-FF-000074', NULL, NULL, 46, NULL, NULL, 47363),
(47364, '3.40.50.300-FF-000513', NULL, 'ras-related protein Rab-28 isoform X2', 177, NULL, NULL, 47364),
(47365, '2.60.40.10-FF-004407', NULL, NULL, 101, NULL, NULL, 47365),
(47366, '1.25.40.10-FF-002029', NULL, 'Pentatricopeptide repeat protein', 153, NULL, NULL, 47366),
(47367, '2.40.50.140-FF-000749', NULL, NULL, 79, NULL, NULL, 47367),
(47368, '3.10.580.10-FF-000056', NULL, 'Chloride channel protein', 124, NULL, NULL, 47368),
(47369, '1.20.120.980-FF-000031', NULL, 'Dipeptidyl peptidase 2', 110, NULL, NULL, 47369),
(47370, '1.10.10.880-FF-000002', NULL, 'Sigma factor AlgU regulatory protein MucA', 67, NULL, NULL, 47370),
(47371, '3.40.50.720-FF-001701', NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase family', 190, NULL, NULL, 47371),
(47372, '3.30.230.130-FF-000010', NULL, 'Anaphase-promoting complex subunit 2', 146, NULL, NULL, 47372),
(47373, '3.10.20.600-FF-000008', NULL, NULL, 96, NULL, NULL, 47373),
(47374, '1.20.900.10-FF-000093', NULL, 'ECT2 (Mammalian Rho GEF) homolog', 229, NULL, NULL, 47374),
(47375, '1.10.510.10-FF-003746', NULL, NULL, 145, NULL, NULL, 47375),
(47376, '2.40.20.10-FF-000046', NULL, 'Uncharacterized protein', 104, NULL, NULL, 47376),
(47377, '1.20.120.150-FF-000001', NULL, 'Serine/threonine-protein kinase TOR', 94, NULL, NULL, 47377),
(47378, '1.20.120.350-FF-000089', NULL, 'Four domain-type voltage-gated ion channel alpha-1 subunit', 136, NULL, NULL, 47378),
(47379, '3.40.50.10330-FF-000052', NULL, 'NAD kinase', 113, NULL, NULL, 47379),
(47380, '1.10.510.10-FF-003218', NULL, NULL, 137, NULL, NULL, 47380),
(47381, '1.20.1070.10-FF-000409', NULL, 'Uncharacterized protein', 324, NULL, NULL, 47381),
(47382, '2.60.40.10-FF-003098', NULL, 'Hemicentin, putative', 95, NULL, NULL, 47382),
(47383, '3.30.200.20-FF-002421', NULL, 'Protein ver-2', 84, NULL, NULL, 47383),
(47384, '1.50.40.10-FF-000127', NULL, 'MC family mitochondrial carrier protein', 148, NULL, NULL, 47384),
(47385, '3.40.50.300-FF-000018', NULL, 'Cell division control 48', 175, NULL, NULL, 47385),
(47386, '3.30.160.60-FF-003654', NULL, NULL, 28, NULL, NULL, 47386),
(47387, '3.40.50.10190-FF-000302', NULL, 'Uncharacterized protein', 103, NULL, NULL, 47387);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(47388, '1.10.472.10-FF-000577', NULL, 'Cyclin, N-terminal domain containing protein', 50, NULL, NULL, 47388),
(47389, '1.10.8.270-FF-000074', NULL, 'TBC domain containing protein', 96, NULL, NULL, 47389),
(47390, '3.40.309.10-FF-000021', NULL, 'Aldehyde dehydrogenase family 8 member A1', 201, NULL, NULL, 47390),
(47391, '3.40.50.1460-FF-000062', NULL, 'GPI-anchor transamidase, putative', 227, NULL, NULL, 47391),
(47392, '1.20.58.830-FF-000043', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 133, NULL, NULL, 47392),
(47393, '1.10.10.10-FF-001712', NULL, 'ATP-dependent DNA helicase RecQ', 180, NULL, NULL, 47393),
(47394, '3.90.260.10-FF-000003', NULL, 'XPC complex subunit, DNA damage recognition and repair factor', 146, NULL, NULL, 47394),
(47395, '1.20.1270.280-FF-000001', NULL, 'dynein heavy chain 7, axonemal', 168, NULL, NULL, 47395),
(47396, '1.20.58.70-FF-000092', NULL, 'Putative snare protein syntaxin 1', 130, NULL, NULL, 47396),
(47397, '2.40.70.10-FF-000127', NULL, 'Os04g0334700 protein', 193, NULL, NULL, 47397),
(47398, '3.40.50.720-FF-000392', NULL, '3-oxoacyl-[acyl-carrier protein] reductase', 246, NULL, NULL, 47398),
(47399, '1.10.287.370-FF-000046', NULL, 'Prefoldin subunit 2', 76, NULL, NULL, 47399),
(47400, '3.30.40.230-FF-000003', NULL, 'Glycine--tRNA ligase', 104, NULL, NULL, 47400),
(47401, '3.40.30.10-FF-000494', NULL, 'Thiol-dependent reductase 1', 84, NULL, NULL, 47401),
(47402, '3.30.70.330-FF-000854', NULL, 'Putative RNA-binding protein', 94, NULL, NULL, 47402),
(47403, '3.30.2160.10-FF-000025', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 79, NULL, NULL, 47403),
(47404, '2.60.40.10-FF-000664', NULL, 'Tyrosine-protein kinase receptor', 88, NULL, NULL, 47404),
(47405, '3.40.50.300-FF-004189', NULL, 'AGAP012081-PA', 120, NULL, NULL, 47405),
(47406, '3.80.10.10-FF-002317', NULL, 'Uncharacterized protein', 162, NULL, NULL, 47406),
(47407, '1.25.40.10-FF-000231', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 102, NULL, NULL, 47407),
(47408, '3.40.1160.10-FF-000062', NULL, 'Delta-1-pyrroline-5-carboxylate synthase', 165, NULL, NULL, 47408),
(47409, '2.60.40.3710-FF-000002', NULL, 'Putative lipoprotein', 104, NULL, NULL, 47409),
(47410, '3.50.50.60-FF-001465', NULL, 'Probable lysine-specific histone demethylase 1', 68, NULL, NULL, 47410),
(47411, '3.40.50.150-FF-001249', NULL, NULL, 209, NULL, NULL, 47411),
(47412, '3.40.50.2000-FF-001090', NULL, 'Uncharacterized protein', 87, NULL, NULL, 47412),
(47413, '1.25.40.990-FF-000014', NULL, '26S proteasome regulatory subunit RPN12, putative', 227, NULL, NULL, 47413),
(47414, '1.10.150.460-FF-000001', NULL, NULL, 52, NULL, NULL, 47414),
(47415, '3.90.1200.10-FF-000049', NULL, 'GD20644', 182, NULL, NULL, 47415),
(47416, '1.20.58.70-FF-000103', NULL, 'Predicted protein', 127, NULL, NULL, 47416),
(47417, '1.20.5.190-FF-000126', NULL, NULL, 68, NULL, NULL, 47417),
(47418, '3.40.50.300-FF-003256', NULL, 'Replication factor C, subunit 3', 164, NULL, NULL, 47418),
(47419, '2.130.10.10-FF-000440', NULL, 'Bromodomain and WD repeat-containing protein', 135, NULL, NULL, 47419),
(47420, '3.40.50.1820-FF-001378', NULL, 'Feruloyl esterase C', 222, NULL, NULL, 47420),
(47421, '1.20.120.1080-FF-000062', NULL, 'ATP-dependent helicase HrpB', 147, NULL, NULL, 47421),
(47422, '4.10.410.20-FF-000004', NULL, 'ectonucleotide pyrophosphatase/phosphodiesterase family member 3', 46, NULL, NULL, 47422),
(47423, '2.30.29.30-FF-000791', NULL, 'Src kinase-associated phosphoprotein 1', 108, NULL, NULL, 47423),
(47424, '3.90.70.10-FF-000426', NULL, 'Uncharacterized protein', 296, NULL, NULL, 47424),
(47425, '1.10.238.10-FF-001011', NULL, 'UBA domain-containing protein 8', 122, NULL, NULL, 47425),
(47426, '1.20.1110.10-FF-000127', NULL, NULL, 109, NULL, NULL, 47426),
(47427, '2.60.40.10-FF-000355', NULL, 'Leucine-rich repeat neuronal protein 1', 94, NULL, NULL, 47427),
(47428, '2.130.10.130-FF-000020', NULL, 'Glycosylphosphatidylinositol specific phospholipase D1', 231, NULL, NULL, 47428),
(47429, '1.10.357.30-FF-000017', NULL, NULL, 177, NULL, NULL, 47429);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(47430, '2.40.30.10-FF-000344', NULL, 'Uncharacterized protein', 107, NULL, NULL, 47430),
(47431, '3.90.190.10-FF-000576', NULL, 'Uncharacterized protein', 131, NULL, NULL, 47431),
(47432, '3.20.20.70-FF-000803', NULL, NULL, 147, NULL, NULL, 47432),
(47433, '3.30.230.40-FF-000006', NULL, 'Imidazoleglycerol-phosphate dehydratase', 87, NULL, NULL, 47433),
(47434, '3.40.710.10-FF-000184', NULL, 'Penicillin-sensitive carboxypeptidase A', 196, NULL, NULL, 47434),
(47435, '3.30.70.2190-FF-000002', NULL, 'FAD-binding oxidoreductase', 117, NULL, NULL, 47435),
(47436, '2.10.90.10-FF-000017', NULL, 'Platelet derived growth factor subunit A', 167, NULL, NULL, 47436),
(47437, '3.30.160.60-FF-004475', NULL, NULL, 31, NULL, NULL, 47437),
(47438, '2.10.220.10-FF-000157', NULL, 'High cysteine membrane protein Group 5', 36, NULL, NULL, 47438),
(47439, '3.30.160.60-FF-003963', NULL, NULL, 31, NULL, NULL, 47439),
(47440, '1.20.920.10-FF-000004', NULL, 'probable global transcription activator SNF2L2 isoform X1', 128, NULL, NULL, 47440),
(47441, '3.30.70.260-FF-000018', NULL, 'Ribose-5-phosphate isomerase A', 84, NULL, NULL, 47441),
(47442, '1.20.5.110-FF-000029', NULL, 'Syntaxin-binding protein 6', 61, NULL, NULL, 47442),
(47443, '3.90.1150.10-FF-000241', NULL, 'Transcriptional regulator, GntR family', 157, NULL, NULL, 47443),
(47444, '1.20.1560.10-FF-000812', NULL, 'Sulfonylurea receptor, putative', 138, NULL, NULL, 47444),
(47445, '2.60.40.10-FF-005026', NULL, NULL, 104, NULL, NULL, 47445),
(47446, '1.25.10.10-FF-001819', NULL, 'MMS19 nucleotide excision repair protein homolog', 290, NULL, NULL, 47446),
(47447, '2.60.40.10-FF-004514', NULL, NULL, 95, NULL, NULL, 47447),
(47448, '4.10.410.10-FF-000119', NULL, 'Uncharacterized protein', 72, NULL, NULL, 47448),
(47449, '3.80.10.10-FF-002952', NULL, 'Uncharacterized protein', 168, NULL, NULL, 47449),
(47450, '1.10.20.10-FF-000049', NULL, 'Nuclear transcription factor Y subunit B-6', 117, NULL, NULL, 47450),
(47451, '3.10.120.10-FF-000011', NULL, 'Fatty acid 2-hydroxylase', 90, NULL, NULL, 47451),
(47452, '3.30.420.10-FF-000602', NULL, NULL, 188, NULL, NULL, 47452),
(47453, '2.60.120.10-FF-000644', NULL, 'Predicted protein', 158, NULL, NULL, 47453),
(47454, '2.10.25.10-FF-001710', NULL, 'Uncharacterized protein', 60, NULL, NULL, 47454),
(47455, '3.40.50.300-FF-006662', NULL, 'Uncharacterized protein', 86, NULL, NULL, 47455),
(47456, '1.25.40.10-FF-002136', NULL, 'Pentatricopeptide repeat-containing protein', 159, NULL, NULL, 47456),
(47457, '1.20.140.100-FF-000035', NULL, 'Uncharacterized protein', 147, NULL, NULL, 47457),
(47458, '3.20.20.100-FF-000120', NULL, 'Glutamate--cysteine ligase regulatory subunit', 167, NULL, NULL, 47458),
(47459, '2.60.120.820-FF-000001', NULL, 'BTB/POZ domain-containing protein 3', 153, NULL, NULL, 47459),
(47460, '3.50.20.20-FF-000001', NULL, '14 kDa phosphohistidine phosphatase', 120, NULL, NULL, 47460),
(47461, '2.130.10.10-FF-000788', NULL, 'mRNA cleavage and polyadenylation factor subunit', 384, NULL, NULL, 47461),
(47462, '3.40.50.2020-FF-000168', NULL, 'Uncharacterized protein', 121, NULL, NULL, 47462),
(47463, '1.10.10.60-FF-000777', NULL, 'Homeobox protein dsc-1', 71, NULL, NULL, 47463),
(47464, '3.30.2300.10-FF-000014', NULL, 'THUMP domain protein', 78, NULL, NULL, 47464),
(47465, '3.30.1330.30-FF-000027', NULL, 'H/ACA ribonucleoprotein complex subunit 2', 131, NULL, NULL, 47465),
(47466, '1.10.287.130-FF-000098', NULL, 'Histidine kinase', 83, NULL, NULL, 47466),
(47467, '3.40.50.2000-FF-000847', NULL, 'Zeaxanthin glucosyl transferase', 241, NULL, NULL, 47467),
(47468, '3.30.200.20-FF-002056', NULL, 'Uncharacterized protein', 87, NULL, NULL, 47468),
(47469, '3.50.50.60-FF-000161', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 118, NULL, NULL, 47469),
(47470, '3.90.70.10-FF-000050', NULL, 'Cathepsin F', 214, NULL, NULL, 47470),
(47471, '2.10.90.10-FF-000141', NULL, 'Uncharacterized protein', 112, NULL, NULL, 47471),
(47472, '2.10.50.10-FF-000015', NULL, 'TNF receptor superfamily member 11a', 79, NULL, NULL, 47472);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(47473, '2.30.29.30-FF-000139', NULL, 'ADP-ribosylation factor GTPase-activating protein AGD3', 116, NULL, NULL, 47473),
(47474, '3.30.420.10-FF-000597', NULL, NULL, 195, NULL, NULL, 47474),
(47475, '1.20.1250.20-FF-002276', NULL, 'Uncharacterized protein', 93, NULL, NULL, 47475),
(47476, '3.40.630.30-FF-000509', NULL, 'Uncharacterized protein', 108, NULL, NULL, 47476),
(47477, '3.30.420.40-FF-000145', NULL, 'Xylulose kinase', 187, NULL, NULL, 47477),
(47478, '1.10.3730.20-FF-000039', NULL, 'Purine permease-related protein', 119, NULL, NULL, 47478),
(47479, '1.25.40.590-FF-000001', NULL, 'DotU family type IV/VI secretion system protein', 159, NULL, NULL, 47479),
(47480, '3.40.50.300-FF-006134', NULL, 'Dynein heavy chain family protein', 244, NULL, NULL, 47480),
(47481, '3.30.60.30-FF-000193', NULL, 'Vasotab', 61, NULL, NULL, 47481),
(47482, '3.30.390.30-FF-000026', NULL, 'Irc15p', 123, NULL, NULL, 47482),
(47483, '2.100.10.30-FF-000014', NULL, 'Putative zinc metalloproteinase C607.06c', 130, NULL, NULL, 47483),
(47484, '3.60.40.10-FF-000173', NULL, 'Phosphatase 2C family protein', 305, NULL, NULL, 47484),
(47485, '3.40.50.800-FF-000062', NULL, 'Histidine--tRNA ligase', 97, NULL, NULL, 47485),
(47486, '1.10.510.10-FF-003437', NULL, NULL, 361, NULL, NULL, 47486),
(47487, '2.170.270.10-FF-000038', NULL, 'Histone-lysine N-methyltransferase ATXR5', 229, NULL, NULL, 47487),
(47488, '3.60.20.10-FF-000166', NULL, NULL, 214, NULL, NULL, 47488),
(47489, '3.30.460.10-FF-000178', NULL, 'PAP associated domain containing 5 (Predicted)', 55, NULL, NULL, 47489),
(47490, '3.40.50.1000-FF-000430', NULL, 'Uncharacterized protein', 165, NULL, NULL, 47490),
(47491, '3.50.50.60-FF-000537', NULL, 'WGS project CABT00000000 data, contig 2.2', 122, NULL, NULL, 47491),
(47492, '3.40.50.300-FF-002391', NULL, 'Ras family protein-like protein', 188, NULL, NULL, 47492),
(47493, '1.20.1720.10-FF-000038', NULL, 'Major facilitator superfamily MFS_1', 206, NULL, NULL, 47493),
(47494, '3.20.20.140-FF-000036', NULL, 'Carbamoyl-phosphate synthase large chain', 340, NULL, NULL, 47494),
(47495, '3.60.21.10-FF-000129', NULL, 'DNA double-strand break repair protein Mre11', 238, NULL, NULL, 47495),
(47496, '3.20.20.70-FF-000826', NULL, NULL, 147, NULL, NULL, 47496),
(47497, '3.40.50.720-FF-001206', NULL, 'Molybdopterin biosynthesis protein', 254, NULL, NULL, 47497),
(47498, '3.30.160.60-FF-004166', NULL, NULL, 23, NULL, NULL, 47498),
(47499, '2.40.50.100-FF-000171', NULL, 'Sugar ABC transporter ATP-binding protein', 57, NULL, NULL, 47499),
(47500, '2.130.10.10-FF-005644', NULL, 'Uncharacterized protein', 174, NULL, NULL, 47500),
(47501, '2.60.40.10-FF-002114', NULL, 'Twitchin', 96, NULL, NULL, 47501),
(47502, '4.10.1230.10-FF-000001', NULL, 'Ecotin', 58, NULL, NULL, 47502),
(47503, '3.90.70.10-FF-000207', NULL, 'Putative cysteine proteinase', 336, NULL, NULL, 47503),
(47504, '3.30.70.330-FF-002304', NULL, NULL, 140, NULL, NULL, 47504),
(47505, '3.40.50.1100-FF-000218', NULL, 'Uncharacterized protein', 57, NULL, NULL, 47505),
(47506, '1.10.287.700-FF-000005', NULL, 'Plant Late Embryo Abundant (LEA) related', 93, NULL, NULL, 47506),
(47507, '3.40.630.10-FF-000503', NULL, 'Peptidase M28', 233, NULL, NULL, 47507),
(47508, '3.30.420.10-FF-000288', NULL, 'Putative DNA polymerase III, epsilon subunit', 180, NULL, NULL, 47508),
(47509, '3.40.50.920-FF-000013', NULL, 'Ferredoxin oxidoreductase alpha subunit', 115, NULL, NULL, 47509),
(47510, '2.70.170.10-FF-000173', NULL, 'Uncharacterized protein', 208, NULL, NULL, 47510),
(47511, '1.20.1270.10-FF-000037', NULL, 'Heat shock protein 110, putative', 111, NULL, NULL, 47511),
(47512, '3.30.70.850-FF-000009', NULL, 'Proprotein convertase subtilisin/kexin type 5', 37, NULL, NULL, 47512),
(47513, '1.10.150.50-FF-000217', NULL, 'Predicted protein', 78, NULL, NULL, 47513),
(47514, '3.40.50.720-FF-000717', NULL, 'Probable short-chain dehydrogenase', 241, NULL, NULL, 47514),
(47515, '2.60.40.10-FF-001283', NULL, 'Carcinoembryonic antigen related cell adhesion molecule 16', 107, NULL, NULL, 47515),
(47516, '3.90.660.10-FF-000084', NULL, 'lysine-specific histone demethylase 1B', 234, NULL, NULL, 47516);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(47517, '1.10.287.660-FF-000026', NULL, 'Aquaporin SIP1-1', 49, NULL, NULL, 47517),
(47518, '3.50.50.100-FF-000024', NULL, 'Apoptosis-inducing factor', 344, NULL, NULL, 47518),
(47519, '3.40.390.10-FF-000097', NULL, 'Metalloendopeptidase', 169, NULL, NULL, 47519),
(47520, '3.50.50.60-FF-001026', NULL, 'Peroxisomal N(1)-acetyl-spermine/spermidine oxidase', 121, NULL, NULL, 47520),
(47521, '3.90.1750.20-FF-000008', NULL, 'DNA invertase', 135, NULL, NULL, 47521),
(47522, '3.40.630.30-FF-000352', NULL, 'Histone acetyltransferase', 49, NULL, NULL, 47522),
(47523, '3.30.160.60-FF-006420', NULL, NULL, 26, NULL, NULL, 47523),
(47524, '3.30.390.10-FF-000020', NULL, '2-oxoglutarate decarboxylase/hydro-lyase/magnesium ion-binding protein', 133, NULL, NULL, 47524),
(47525, '3.30.40.10-FF-002198', NULL, 'E3 ubiquitin-protein ligase WAVH1', 74, NULL, NULL, 47525),
(47526, '3.30.470.20-FF-000209', NULL, 'Uncharacterized protein', 185, NULL, NULL, 47526),
(47527, '3.40.50.10240-FF-000025', NULL, 'Thiamine pyrophosphokinase', 146, NULL, NULL, 47527),
(47528, '3.10.20.90-FF-000321', NULL, 'Ral GDS-Like', 125, NULL, NULL, 47528),
(47529, '3.90.1460.10-FF-000006', NULL, 'General transcription factor II-I repeat domain-containing protein 1', 104, NULL, NULL, 47529),
(47530, '3.10.180.10-FF-000003', NULL, 'Methylmalonyl-CoA epimerase, mitochondrial', 133, NULL, NULL, 47530),
(47531, '1.20.1060.10-FF-000010', NULL, 'DNA polymerase I', 120, NULL, NULL, 47531),
(47532, '2.30.130.40-FF-000020', NULL, 'Lon protease', 110, NULL, NULL, 47532),
(47533, '1.10.1380.10-FF-000008', NULL, 'Probable zinc metalloprotease', 342, NULL, NULL, 47533),
(47534, '1.10.274.100-FF-000001', NULL, 'DNA-directed RNA polymerase subunit', 157, NULL, NULL, 47534),
(47535, '2.40.320.10-FF-000023', NULL, 'Predicted protein', 284, NULL, NULL, 47535),
(47536, '2.130.10.10-FF-002238', NULL, 'Uncharacterized protein', 319, NULL, NULL, 47536),
(47537, '3.80.10.10-FF-000974', NULL, 'NACHT, LRR and PYD domains-containing protein 2', 58, NULL, NULL, 47537),
(47538, '2.30.29.30-FF-000010', NULL, 'dynamin-1 isoform X2', 128, NULL, NULL, 47538),
(47539, '2.10.220.10-FF-000129', NULL, 'Uncharacterized protein', 70, NULL, NULL, 47539),
(47540, '1.20.5.1430-FF-000024', NULL, 'MIP05284p', 56, NULL, NULL, 47540),
(47541, '2.80.10.50-FF-000117', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 123, NULL, NULL, 47541),
(47542, '3.40.30.10-FF-000185', NULL, 'Protein disulfide-isomerase', 102, NULL, NULL, 47542),
(47543, '1.10.287.370-FF-000041', NULL, 'Prefoldin, alpha subunit, putative', 144, NULL, NULL, 47543),
(47544, '1.20.1250.20-FF-001011', NULL, 'SLC (SoLute Carrier) homolog', 209, NULL, NULL, 47544),
(47545, '1.25.40.20-FF-001829', NULL, 'Predicted protein', 150, NULL, NULL, 47545),
(47546, '3.40.50.300-FF-000822', NULL, 'Shikimate kinase, chloroplastic', 215, NULL, NULL, 47546),
(47547, '1.25.40.20-FF-001493', NULL, 'Ankyrin repeat-containing protein', 77, NULL, NULL, 47547),
(47548, '2.40.33.10-FF-000025', NULL, 'Pyruvate kinase', 95, NULL, NULL, 47548),
(47549, '2.170.120.30-FF-000005', NULL, 'CdaA regulatory protein CdaR', 101, NULL, NULL, 47549),
(47550, '1.10.287.110-FF-000103', NULL, 'DnaJ subfamily B member', 119, NULL, NULL, 47550),
(47551, '1.10.510.10-FF-004146', NULL, NULL, 45, NULL, NULL, 47551),
(47552, '1.10.287.110-FF-000339', NULL, 'Uncharacterized protein', 70, NULL, NULL, 47552),
(47553, '1.20.58.530-FF-000043', NULL, NULL, 167, NULL, NULL, 47553),
(47554, '3.30.200.20-FF-001932', NULL, 'Os07g0534100 protein', 69, NULL, NULL, 47554),
(47555, '3.40.50.1820-FF-000996', NULL, 'Sn1-specific diacylglycerol lipase beta', 236, NULL, NULL, 47555),
(47556, '3.90.70.10-FF-000735', NULL, 'Ubiquitin-specific peptidase 19', 159, NULL, NULL, 47556),
(47557, '3.40.50.300-FF-008112', NULL, 'Uncharacterized protein', 107, NULL, NULL, 47557),
(47558, '3.50.50.60-FF-001482', NULL, 'Uncharacterized protein', 55, NULL, NULL, 47558),
(47559, '2.60.40.10-FF-002244', NULL, 'CBN-TWK-30 protein', 114, NULL, NULL, 47559),
(47560, '1.20.58.60-FF-000791', NULL, 'Uncharacterized protein', 214, NULL, NULL, 47560);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(47561, '1.10.287.130-FF-000109', NULL, 'Sensor histidine kinase', 78, NULL, NULL, 47561),
(47562, '1.20.80.10-FF-000047', NULL, 'Tyrosine-protein phosphatase', 108, NULL, NULL, 47562),
(47563, '1.25.40.10-FF-000214', NULL, 'MAU2 chromatid cohesion factor homolog', 129, NULL, NULL, 47563),
(47564, '3.40.47.10-FF-000234', NULL, NULL, 69, NULL, NULL, 47564),
(47565, '3.40.50.300-FF-000474', NULL, 'Putative ABC transporter ATP-binding subunit', 239, NULL, NULL, 47565),
(47566, '3.30.200.20-FF-001437', NULL, NULL, 57, NULL, NULL, 47566),
(47567, '1.10.510.10-FF-003876', NULL, NULL, 92, NULL, NULL, 47567),
(47568, '2.60.120.200-FF-000523', NULL, 'Novel protein similar to vertebrate pentaxin-related', 207, NULL, NULL, 47568),
(47569, '3.30.70.920-FF-000025', NULL, 'Transcriptional regulator AsnC family', 84, NULL, NULL, 47569),
(47570, '2.130.10.10-FF-000423', NULL, 'YncE family protein', 323, NULL, NULL, 47570),
(47571, '1.10.10.10-FF-001392', NULL, 'ArsR family transcriptional regulator', 99, NULL, NULL, 47571),
(47572, '1.10.150.50-FF-000234', NULL, 'Uncharacterized protein', 71, NULL, NULL, 47572),
(47573, '1.25.10.10-FF-000038', NULL, 'Coatomer subunit gamma', 292, NULL, NULL, 47573),
(47574, '1.20.58.60-FF-000555', NULL, 'Predicted protein', 110, NULL, NULL, 47574),
(47575, '1.10.10.10-FF-001639', NULL, 'Ferric uptake regulator, putative', 84, NULL, NULL, 47575),
(47576, '1.10.287.10-FF-000051', NULL, 'Uncharacterized protein', 50, NULL, NULL, 47576),
(47577, '2.130.10.30-FF-000182', NULL, NULL, 224, NULL, NULL, 47577),
(47578, '3.40.50.300-FF-004745', NULL, 'Smarca5 protein', 157, NULL, NULL, 47578),
(47579, '1.25.40.10-FF-001647', NULL, 'Os03g0369700 protein', 154, NULL, NULL, 47579),
(47580, '1.25.40.10-FF-003434', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 98, NULL, NULL, 47580),
(47581, '3.40.50.200-FF-000123', NULL, 'Uncharacterized protein', 245, NULL, NULL, 47581),
(47582, '2.40.240.10-FF-000005', NULL, 'Bifunctional glutamate/proline--tRNA ligase', 76, NULL, NULL, 47582),
(47583, '2.40.50.140-FF-001149', NULL, NULL, 78, NULL, NULL, 47583),
(47584, '2.70.170.10-FF-000201', NULL, 'Uncharacterized protein', 171, NULL, NULL, 47584),
(47585, '3.50.20.20-FF-000006', NULL, 'Putative secreted protein', 118, NULL, NULL, 47585),
(47586, '3.40.50.300-FF-005364', NULL, 'Structural maintenance of chromosomes protein', 195, NULL, NULL, 47586),
(47587, '3.40.220.10-FF-000023', NULL, 'ADP-ribose 1''''-phosphate phosphatase', 176, NULL, NULL, 47587),
(47588, '1.25.40.10-FF-004053', NULL, 'Extra spindle pole bodies like 1, separase', 169, NULL, NULL, 47588),
(47589, '1.10.1200.10-FF-000069', NULL, 'Yersiniabactin polyketide/non-ribosomal peptide synthetase', 84, NULL, NULL, 47589),
(47590, '1.10.620.20-FF-000003', NULL, 'Ribonucleoside-diphosphate reductase subunit beta', 329, NULL, NULL, 47590),
(47591, '1.10.3720.10-FF-000120', NULL, 'Iron(III) ABC transporter permease', 262, NULL, NULL, 47591),
(47592, '3.10.20.310-FF-000045', NULL, 'Outer membrane protein Omp85 family', 76, NULL, NULL, 47592),
(47593, '2.170.300.10-FF-000019', NULL, 'Platelet endothelial aggregation receptor 1', 128, NULL, NULL, 47593),
(47594, '3.50.30.30-FF-000072', NULL, 'RING finger protein 150', 156, NULL, NULL, 47594),
(47595, '3.40.50.10950-FF-000002', NULL, 'NADP-dependent malic enzyme', 152, NULL, NULL, 47595),
(47596, '3.40.50.800-FF-000090', NULL, 'Proline--tRNA ligase, cytoplasmic', 149, NULL, NULL, 47596),
(47597, '1.20.1250.40-FF-000022', NULL, 'DNA-directed RNA polymerase III subunit rpc9', 118, NULL, NULL, 47597),
(47598, '2.40.50.90-FF-000189', NULL, 'Uncharacterized protein', 64, NULL, NULL, 47598),
(47599, '1.10.287.70-FF-000501', NULL, 'Uncharacterized protein', 111, NULL, NULL, 47599),
(47600, '3.40.50.1820-FF-000889', NULL, 'Triacylglycerol lipase', 147, NULL, NULL, 47600),
(47601, '3.30.565.10-FF-000308', NULL, 'Two-component hybrid sensor and regulator', 158, NULL, NULL, 47601),
(47602, '2.60.120.10-FF-000088', NULL, 'Guanine nucleotide exchange factor', 174, NULL, NULL, 47602);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(47603, '3.30.70.270-FF-000156', NULL, NULL, 90, NULL, NULL, 47603),
(47604, '1.20.1250.20-FF-001348', NULL, 'Uncharacterized protein', 205, NULL, NULL, 47604),
(47605, '1.20.5.110-FF-000046', NULL, 'syntaxin-17 isoform X1', 67, NULL, NULL, 47605),
(47606, '2.30.30.140-FF-000130', NULL, 'Uncharacterized protein, isoform B', 91, NULL, NULL, 47606),
(47607, '3.90.1530.30-FF-000001', NULL, 'Chromosome partitioning protein ParB', 63, NULL, NULL, 47607),
(47608, '2.130.10.10-FF-004346', NULL, 'Uncharacterized protein', 97, NULL, NULL, 47608),
(47609, '2.60.260.20-FF-000016', NULL, 'DnaJ (Hsp40) homolog, subfamily A, member 2', 85, NULL, NULL, 47609),
(47610, '2.10.25.10-FF-000165', NULL, 'FAT atypical cadherin 3', 38, NULL, NULL, 47610),
(47611, '2.160.10.10-FF-000045', NULL, 'Translation initiation factor eIF-2B subunit gamma', 117, NULL, NULL, 47611),
(47612, '1.10.150.850-FF-000011', NULL, 'Uncharacterized protein', 70, NULL, NULL, 47612),
(47613, '2.130.10.10-FF-003166', NULL, 'Periodic tryptophan protein 2-like protein', 224, NULL, NULL, 47613),
(47614, '1.20.58.1610-FF-000011', NULL, 'NADH-quinone oxidoreductase subunit A', 124, NULL, NULL, 47614),
(47615, '1.10.287.70-FF-000153', NULL, 'High-affinity cell membrane calcium channel protein', 153, NULL, NULL, 47615),
(47616, '3.30.230.40-FF-000001', NULL, 'Imidazoleglycerol-phosphate dehydratase HisB', 107, NULL, NULL, 47616),
(47617, '4.10.400.10-FF-000282', NULL, 'Low-density lipoprotein RecePtor related', 44, NULL, NULL, 47617),
(47618, '1.10.10.2670-FF-000011', NULL, 'Uncharacterized protein', 100, NULL, NULL, 47618),
(47619, '1.25.10.10-FF-002511', NULL, 'Uncharacterized protein', 199, NULL, NULL, 47619),
(47620, '2.20.25.10-FF-000097', NULL, 'DNA-directed RNA polymerase subunit', 51, NULL, NULL, 47620),
(47621, '1.10.10.250-FF-000004', NULL, '39S ribosomal protein L11, mitochondrial', 74, NULL, NULL, 47621),
(47622, '3.40.50.1820-FF-001069', NULL, 'Predicted protein', 51, NULL, NULL, 47622),
(47623, '3.40.109.10-FF-000040', NULL, 'Albonoursin synthase', 180, NULL, NULL, 47623),
(47624, '3.30.70.240-FF-000012', NULL, 'Elongation factor G', 72, NULL, NULL, 47624),
(47625, '3.30.160.60-FF-005919', NULL, NULL, 18, NULL, NULL, 47625),
(47626, '3.20.20.10-FF-000067', NULL, 'D-threo-3-hydroxyaspartate dehydratase', 223, NULL, NULL, 47626),
(47627, '1.10.287.1490-FF-000052', NULL, 'Phosphatidylinositol 3-kinase regulatory subunit alpha', 92, NULL, NULL, 47627),
(47628, '3.60.15.10-FF-000188', NULL, 'Prostate cancer susceptibility protein-like protein', 216, NULL, NULL, 47628),
(47629, '2.30.130.40-FF-000025', NULL, 'Lon protease homolog, mitochondrial', 106, NULL, NULL, 47629),
(47630, '3.10.110.10-FF-000162', NULL, 'Calmodulin-binding transcription activator 2', 89, NULL, NULL, 47630),
(47631, '1.25.40.10-FF-000686', NULL, 'Clathrin heavy chain', 330, NULL, NULL, 47631),
(47632, '3.90.470.20-FF-000022', NULL, 'L-aminoadipate-semialdehyde dehydrogenase-phosphopantetheinyl transferase', 116, NULL, NULL, 47632),
(47633, '1.20.1270.60-FF-000277', NULL, 'Uncharacterized protein', 49, NULL, NULL, 47633),
(47634, '3.40.50.1260-FF-000030', NULL, 'Phosphoglycerate kinase', 72, NULL, NULL, 47634),
(47635, '1.10.486.10-FF-000047', NULL, 'DNA helicase', 210, NULL, NULL, 47635),
(47636, '1.10.340.30-FF-000041', NULL, 'N-glycosylase/DNA lyase', 125, NULL, NULL, 47636),
(47637, '2.30.30.40-FF-000393', NULL, 'Uncharacterized protein, isoform C', 131, NULL, NULL, 47637),
(47638, '1.10.287.70-FF-000462', NULL, 'Uncharacterized protein', 222, NULL, NULL, 47638),
(47639, '3.30.590.10-FF-000024', NULL, 'Glutamine synthetase catalytic region', 318, NULL, NULL, 47639),
(47640, '1.10.238.10-FF-000522', NULL, 'Uncharacterized protein', 85, NULL, NULL, 47640),
(47641, '3.30.40.10-FF-001017', NULL, 'RBR-type E3 ubiquitin transferase', 85, NULL, NULL, 47641),
(47642, '1.10.1040.10-FF-000067', NULL, '2-dehydropantoate 2-reductase', 129, NULL, NULL, 47642),
(47643, '1.20.1250.20-FF-000819', NULL, 'General substrate transporter', 457, NULL, NULL, 47643),
(47644, '3.30.420.100-FF-000022', NULL, 'Uncharacterized protein', 96, NULL, NULL, 47644);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(47645, '1.10.1200.10-FF-000041', NULL, 'Acyl carrier protein', 76, NULL, NULL, 47645),
(47646, '3.10.50.40-FF-000090', NULL, 'MIP25048p', 116, NULL, NULL, 47646),
(47647, '3.80.10.10-FF-004318', NULL, 'Uncharacterized protein', 206, NULL, NULL, 47647),
(47648, '1.20.1250.20-FF-000483', NULL, 'Related to allantoate permease', 197, NULL, NULL, 47648),
(47649, '6.10.300.40-FF-000005', NULL, NULL, 43, NULL, NULL, 47649),
(47650, '2.130.10.10-FF-003727', NULL, 'Uncharacterized protein', 337, NULL, NULL, 47650),
(47651, '3.40.50.300-FF-004184', NULL, 'ATP-binding cassette, sub-family B (MDR/TAP), member 10', 261, NULL, NULL, 47651),
(47652, '2.60.40.2020-FF-000001', NULL, 'Inhibitor of cysteine proteases', 83, NULL, NULL, 47652),
(47653, '2.60.40.1090-FF-000014', NULL, 'Fimbrial family protein', 152, NULL, NULL, 47653),
(47654, '3.30.540.10-FF-000105', NULL, 'Predicted protein', 175, NULL, NULL, 47654),
(47655, '2.30.110.10-FF-000066', NULL, 'Flavin oxidoreductase', 150, NULL, NULL, 47655),
(47656, '3.30.70.940-FF-000020', NULL, 'Transcription termination/antitermination protein NusG', 115, NULL, NULL, 47656),
(47657, '3.75.10.10-FF-000048', NULL, NULL, 239, NULL, NULL, 47657),
(47658, '2.80.10.50-FF-000089', NULL, 'Dolichyl-phosphate-mannose-protein mannosyltransferase 7', 210, NULL, NULL, 47658),
(47659, '3.30.60.30-FF-000086', NULL, 'Enhancer of split m1 protein', 54, NULL, NULL, 47659),
(47660, '3.40.250.10-FF-000160', NULL, 'AaceriAFR296Cp', 136, NULL, NULL, 47660),
(47661, '3.40.630.20-FF-000023', NULL, 'Uncharacterized protein', 182, NULL, NULL, 47661),
(47662, '3.40.50.300-FF-004060', NULL, 'Uncharacterized protein', 186, NULL, NULL, 47662),
(47663, '3.30.160.60-FF-003547', NULL, NULL, 34, NULL, NULL, 47663),
(47664, '3.30.420.80-FF-000033', NULL, '30S ribosomal protein S11', 87, NULL, NULL, 47664),
(47665, '2.30.42.10-FF-000658', NULL, NULL, 97, NULL, NULL, 47665),
(47666, '3.40.50.10190-FF-000297', NULL, 'Uncharacterized protein', 99, NULL, NULL, 47666),
(47667, '2.60.40.10-FF-003109', NULL, 'receptor-type tyrosine-protein phosphatase beta isoform X4', 95, NULL, NULL, 47667),
(47668, '1.25.40.10-FF-004738', NULL, 'Uncharacterized protein', 77, NULL, NULL, 47668),
(47669, '3.30.365.10-FF-000063', NULL, 'Uncharacterized protein', 57, NULL, NULL, 47669),
(47670, '1.10.510.10-FF-000094', NULL, 'MAP kinase-activated protein kinase 2', 188, NULL, NULL, 47670),
(47671, '3.30.1600.10-FF-000020', NULL, 'Related to NAD-dependent histone deacetylase', 17, NULL, NULL, 47671),
(47672, '3.40.50.1010-FF-000096', NULL, 'Exonuclease 1', 207, NULL, NULL, 47672),
(47673, '1.10.287.130-FF-000025', NULL, 'Histidine kinase 1-like protein', 80, NULL, NULL, 47673),
(47674, '2.70.130.10-FF-000171', NULL, NULL, 67, NULL, NULL, 47674),
(47675, '3.40.50.150-FF-000316', NULL, 'Uncharacterized protein', 153, NULL, NULL, 47675),
(47676, '3.40.50.300-FF-001002', NULL, 'Disease resistance protein (TIR-NBS-LRR class)', 166, NULL, NULL, 47676),
(47677, '1.10.8.60-FF-000225', NULL, 'Os09g0560200 protein', 83, NULL, NULL, 47677),
(47678, '2.170.120.12-FF-000013', NULL, 'DNA-directed RNA polymerase II subunit RPB3', 156, NULL, NULL, 47678),
(47679, '1.10.10.60-FF-000412', NULL, 'Anomalous homeobox', 68, NULL, NULL, 47679),
(47680, '2.130.10.10-FF-004711', NULL, 'Predicted protein', 170, NULL, NULL, 47680),
(47681, '3.30.70.330-FF-002776', NULL, NULL, 71, NULL, NULL, 47681),
(47682, '1.10.533.10-FF-000264', NULL, 'Uncharacterized protein', 106, NULL, NULL, 47682),
(47683, '3.30.1410.10-FF-000005', NULL, 'Uncharacterized protein', 90, NULL, NULL, 47683),
(47684, '3.40.50.300-FF-003239', NULL, 'Autoinducer 2 import ATP-binding protein LsrA', 236, NULL, NULL, 47684),
(47685, '3.40.50.150-FF-000501', NULL, 'Ubiquinone biosynthesis O-methyltransferase, mitochondrial', 243, NULL, NULL, 47685),
(47686, '3.40.50.1820-FF-001041', NULL, 'Uncharacterized protein', 99, NULL, NULL, 47686),
(47687, '2.30.30.30-FF-000064', NULL, 'SPT5 homolog, DSIF elongation factor subunit', 71, NULL, NULL, 47687),
(47688, '2.60.40.10-FF-004037', NULL, NULL, 97, NULL, NULL, 47688);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(47689, '2.60.40.10-FF-003418', NULL, NULL, 109, NULL, NULL, 47689),
(47690, '3.60.10.10-FF-000345', NULL, 'Uncharacterized protein', 191, NULL, NULL, 47690),
(47691, '3.40.50.300-FF-004217', NULL, 'Uncharacterized protein', 223, NULL, NULL, 47691),
(47692, '1.20.1250.20-FF-001803', NULL, 'Monocarboxylate transporter, putative', 169, NULL, NULL, 47692),
(47693, '1.10.510.10-FF-004365', NULL, NULL, 106, NULL, NULL, 47693),
(47694, '1.10.472.80-FF-000215', NULL, NULL, 163, NULL, NULL, 47694),
(47695, '3.40.50.620-FF-000480', NULL, 'Asparagine synthase (Glutamine-hydrolyzing)', 279, NULL, NULL, 47695),
(47696, '3.90.105.20-FF-000005', NULL, 'Putative ribosome biogenesis protein MRT4', 74, NULL, NULL, 47696),
(47697, '3.10.20.90-FF-000214', NULL, 'Serine/threonine-protein kinase STE11', 118, NULL, NULL, 47697),
(47698, '2.120.10.80-FF-000360', NULL, 'Predicted protein', 261, NULL, NULL, 47698),
(47699, '1.10.10.10-FF-001948', NULL, 'Uncharacterized protein', 82, NULL, NULL, 47699),
(47700, '1.10.287.70-FF-000681', NULL, 'Uncharacterized protein', 89, NULL, NULL, 47700),
(47701, '3.90.20.20-FF-000033', NULL, 'GrpE protein homolog', 115, NULL, NULL, 47701),
(47702, '3.40.50.1000-FF-000778', NULL, NULL, 79, NULL, NULL, 47702),
(47703, '3.30.160.60-FF-004582', NULL, NULL, 60, NULL, NULL, 47703),
(47704, '1.10.287.110-FF-000356', NULL, 'HSP40/DnaJ peptide-binding protein', 133, NULL, NULL, 47704),
(47705, '3.50.50.60-FF-000953', NULL, 'FAD dependent oxidoreductase', 204, NULL, NULL, 47705),
(47706, '2.130.10.10-FF-005330', NULL, 'POC1 centriolar protein homolog', 190, NULL, NULL, 47706),
(47707, '2.60.260.20-FF-000090', NULL, 'DnaJ heat shock protein family (Hsp40) member A3', 25, NULL, NULL, 47707),
(47708, '3.30.160.60-FF-004958', NULL, NULL, 39, NULL, NULL, 47708),
(47709, '3.40.30.10-FF-000038', NULL, 'Predicted glutathione S-transferase', 80, NULL, NULL, 47709),
(47710, '3.30.750.24-FF-000112', NULL, 'Uncharacterized protein', 140, NULL, NULL, 47710),
(47711, '1.10.287.1490-FF-000136', NULL, 'Uncharacterized protein', 193, NULL, NULL, 47711),
(47712, '3.90.76.10-FF-000001', NULL, 'Oligopeptide ABC transporter substrate-binding protein', 124, NULL, NULL, 47712),
(47713, '1.10.472.10-FF-000105', NULL, 'cyclin-L2 isoform X4', 82, NULL, NULL, 47713),
(47714, '3.40.50.150-FF-001468', NULL, NULL, 132, NULL, NULL, 47714),
(47715, '3.90.780.10-FF-000003', NULL, 'Protein UshA', 187, NULL, NULL, 47715),
(47716, '3.40.1350.10-FF-000009', NULL, 'Fanconi-associated nuclease', 82, NULL, NULL, 47716),
(47717, '3.40.50.740-FF-000061', NULL, 'Thiosulfate reductase', 176, NULL, NULL, 47717),
(47718, '3.40.50.300-FF-008242', NULL, 'Uncharacterized protein', 54, NULL, NULL, 47718),
(47719, '2.130.10.10-FF-003385', NULL, 'Uncharacterized protein', 141, NULL, NULL, 47719),
(47720, '3.40.50.10330-FF-000035', NULL, 'Chromosome 1, whole genome shotgun sequence', 211, NULL, NULL, 47720),
(47721, '3.10.450.50-FF-000053', NULL, 'Nuclear RNA export factor 7', 184, NULL, NULL, 47721),
(47722, '1.10.287.690-FF-000024', NULL, 'DNA polymerase', 36, NULL, NULL, 47722),
(47723, '3.40.50.300-FF-000165', NULL, 'ADP-ribosylation factor 1', 176, NULL, NULL, 47723),
(47724, '3.90.70.10-FF-000090', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 305, NULL, NULL, 47724),
(47725, '3.90.640.10-FF-000066', NULL, 'Actin-related protein 8', 101, NULL, NULL, 47725),
(47726, '2.10.25.10-FF-000957', NULL, 'Os10g0151100 protein', 42, NULL, NULL, 47726),
(47727, '3.40.630.30-FF-000245', NULL, 'Acetyltransferase, GNAT family', 131, NULL, NULL, 47727),
(47728, '2.60.120.200-FF-000490', NULL, 'Tetanus toxin', 245, NULL, NULL, 47728),
(47729, '3.10.400.20-FF-000013', NULL, 'Translation machinery-associated protein 20', 181, NULL, NULL, 47729),
(47730, '2.130.10.10-FF-002896', NULL, 'U4/U6 small nuclear ribonucleoprotein Prp4, putative', 222, NULL, NULL, 47730),
(47731, '2.130.10.10-FF-002441', NULL, 'Subunit of the mRNA cleavage and polyadenylation factor, putative', 365, NULL, NULL, 47731),
(47732, '3.40.50.300-FF-007078', NULL, 'Small GTP-binding protein, putative', 192, NULL, NULL, 47732);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(47733, '3.30.160.60-FF-005127', NULL, NULL, 30, NULL, NULL, 47733),
(47734, '3.10.620.10-FF-000009', NULL, 'Uncharacterized protein', 216, NULL, NULL, 47734),
(47735, '3.40.33.10-FF-000186', NULL, 'Os07g0127700 protein', 50, NULL, NULL, 47735),
(47736, '1.25.40.10-FF-001720', NULL, 'SGT1 homolog, MIS12 kinetochore complex assembly cochaperone', 118, NULL, NULL, 47736),
(47737, '2.60.40.1390-FF-000025', NULL, 'Transcriptional regulator PacG/VIB-1', 50, NULL, NULL, 47737),
(47738, '2.30.29.150-FF-000007', NULL, 'Histone_chaperone_Rttp106-like_-_putative', 162, NULL, NULL, 47738),
(47739, '1.20.58.60-FF-000010', NULL, 'plectin isoform X2', 144, NULL, NULL, 47739),
(47740, '2.30.30.140-FF-000113', NULL, 'SAGA-associated factor 29 protein', 63, NULL, NULL, 47740),
(47741, '3.30.200.20-FF-000948', NULL, 'ATMKK3 MITOGEN-ACTIVATED kinase', 84, NULL, NULL, 47741),
(47742, '3.30.565.10-FF-000191', NULL, 'Histidine kinase response regulator hybrid protein', 154, NULL, NULL, 47742),
(47743, '3.30.40.10-FF-001725', NULL, 'Uncharacterized protein', 43, NULL, NULL, 47743),
(47744, '1.10.357.70-FF-000018', NULL, 'Exocyst complex component 3 like 4', 175, NULL, NULL, 47744),
(47745, '3.30.930.10-FF-000231', NULL, 'Serine/threonine-protein kinase, putative', 345, NULL, NULL, 47745),
(47746, '1.25.40.820-FF-000025', NULL, 'Uncharacterized protein', 172, NULL, NULL, 47746),
(47747, '4.10.400.10-FF-000051', NULL, 'Very low density lipoprotein receptor', 34, NULL, NULL, 47747),
(47748, '2.10.25.10-FF-000530', NULL, 'Crumbs 2, cell polarity complex component', 38, NULL, NULL, 47748),
(47749, '3.90.190.10-FF-000536', NULL, 'Uncharacterized protein', 178, NULL, NULL, 47749),
(47750, '1.20.1250.20-FF-000859', NULL, 'Uncharacterized protein', 187, NULL, NULL, 47750),
(47751, '3.30.160.60-FF-005655', NULL, NULL, 62, NULL, NULL, 47751),
(47752, '2.60.40.420-FF-000248', NULL, 'Cytochrome c oxidase,ba3-type, subunit I, putative', 107, NULL, NULL, 47752),
(47753, '3.30.70.920-FF-000042', NULL, 'Transcriptional regulator, AsnC family', 84, NULL, NULL, 47753),
(47754, '3.40.50.2020-FF-000140', NULL, 'Uncharacterized protein', 156, NULL, NULL, 47754),
(47755, '3.30.710.10-FF-000484', NULL, 'Potassium voltage-gated channel, Shab-related subfamily, member 2', 87, NULL, NULL, 47755),
(47756, '3.20.20.80-FF-000846', NULL, 'Uncharacterized protein', 213, NULL, NULL, 47756),
(47757, '2.30.42.10-FF-000097', NULL, 'PDZ domain-containing protein GIPC1 isoform 1', 94, NULL, NULL, 47757),
(47758, '1.25.10.10-FF-002191', NULL, 'Uncharacterized protein', 450, NULL, NULL, 47758),
(47759, '1.25.40.20-FF-000088', NULL, 'short transient receptor potential channel 1 isoform X1', 300, NULL, NULL, 47759),
(47760, '3.80.10.10-FF-002992', NULL, 'Uncharacterized protein', 121, NULL, NULL, 47760),
(47761, '3.30.710.10-FF-000012', NULL, 'Potassium voltage-gated channel subfamily A member 10', 100, NULL, NULL, 47761),
(47762, '2.60.40.60-FF-000229', NULL, 'Cadherin 15', 112, NULL, NULL, 47762),
(47763, '3.30.70.370-FF-000040', NULL, NULL, 36, NULL, NULL, 47763),
(47764, '3.30.420.270-FF-000005', NULL, 'TonB system transport protein ExbD', 66, NULL, NULL, 47764),
(47765, '1.25.40.560-FF-000003', NULL, 'Putative nf-kappa b regulator ap20/cezanne', 92, NULL, NULL, 47765),
(47766, '1.10.357.50-FF-000012', NULL, 'Unc-13 homolog A', 114, NULL, NULL, 47766),
(47767, '2.60.11.10-FF-000018', NULL, 'Uncharacterized protein', 58, NULL, NULL, 47767),
(47768, '1.20.58.80-FF-000016', NULL, 'Calpain 7', 76, NULL, NULL, 47768),
(47769, '3.40.50.11350-FF-000026', NULL, 'Predicted protein', 158, NULL, NULL, 47769),
(47770, '3.30.420.40-FF-001089', NULL, 'Glycerol kinase, putative', 95, NULL, NULL, 47770),
(47771, '3.30.1370.10-FF-000069', NULL, 'Zinc finger CCCH domain-containing protein 52', 99, NULL, NULL, 47771),
(47772, '3.20.20.100-FF-000047', NULL, 'Putative aldo/keto reductase', 278, NULL, NULL, 47772),
(47773, '2.30.29.30-FF-001174', NULL, 'Uncharacterized protein', 91, NULL, NULL, 47773),
(47774, '2.130.10.10-FF-001277', NULL, 'Pre-mRNA-splicing factor RSE1', 331, NULL, NULL, 47774);
INSERT INTO "PUBLIC"."MODEL" VALUES
(47775, '1.25.40.20-FF-001184', NULL, 'Uncharacterized protein', 171, NULL, NULL, 47775),
(47776, '2.30.39.10-FF-000050', NULL, 'Heterochromatin-associated protein MENT', 104, NULL, NULL, 47776),
(47777, '1.10.287.90-FF-000001', NULL, 'Cytochrome c oxidase subunit 2', 91, NULL, NULL, 47777),
(47778, '2.130.10.10-FF-005566', NULL, 'Predicted protein', 214, NULL, NULL, 47778),
(47779, '3.30.160.60-FF-002002', NULL, 'Zinc finger protein 786', 25, NULL, NULL, 47779),
(47780, '3.30.1330.60-FF-000025', NULL, 'Outer membrane protein/peptidoglycan-associated lipoprotein', 153, NULL, NULL, 47780),
(47781, '3.40.525.10-FF-000012', NULL, 'bcl-2/adenovirus E1B 19 kDa-interacting protein 2-like protein', 155, NULL, NULL, 47781),
(47782, '3.90.1420.10-FF-000032', NULL, 'Ribosomal lysine N-methyltransferase 4', 135, NULL, NULL, 47782),
(47783, '3.40.190.10-FF-000025', NULL, 'glutamate receptor ionotropic, NMDA 1 isoform X3', 28, NULL, NULL, 47783),
(47784, '3.50.30.30-FF-000055', NULL, 'Minor extracellular protease VpR', 123, NULL, NULL, 47784),
(47785, '1.25.40.20-FF-000565', NULL, '6-phosphofructo-2-kinase/fructose-2, 6-biphosphatase, putative', 129, NULL, NULL, 47785),
(47786, '3.40.50.300-FF-005965', NULL, 'ATP-dependent DNA helicase, RecQ family', 171, NULL, NULL, 47786),
(47787, '3.30.40.10-FF-001242', NULL, 'Ubiquitin fusion degradation protein 2, putative', 92, NULL, NULL, 47787),
(47788, '3.30.160.60-FF-004508', NULL, NULL, 32, NULL, NULL, 47788),
(47789, '2.60.40.60-FF-000084', NULL, 'FAT atypical cadherin 3', 105, NULL, NULL, 47789),
(47790, '1.25.10.10-FF-001100', NULL, 'WGS project CABT00000000 data, contig 2.18', 302, NULL, NULL, 47790),
(47791, '3.60.40.10-FF-000257', NULL, 'Protein phosphatase 2C 3', 81, NULL, NULL, 47791),
(47792, '3.30.70.330-FF-001596', NULL, NULL, 109, NULL, NULL, 47792),
(47793, '3.40.50.300-FF-002727', NULL, 'RNA polymerase II Elongator complex associated protein Kti12, putative', 195, NULL, NULL, 47793),
(47794, '1.10.760.10-FF-000050', NULL, 'Bll0021 protein', 124, NULL, NULL, 47794),
(47795, '3.30.200.20-FF-001567', NULL, 'Uncharacterized protein', 56, NULL, NULL, 47795),
(47796, '1.25.40.10-FF-000995', NULL, 'Uncharacterized protein, isoform B', 299, NULL, NULL, 47796),
(47797, '2.60.120.470-FF-000008', NULL, 'DUF1000-domain-containing protein', 183, NULL, NULL, 47797),
(47798, '1.20.1250.20-FF-001320', NULL, 'Monocarboxylate transporter, putative', 158, NULL, NULL, 47798),
(47799, '1.20.1070.10-FF-001106', NULL, 'Substance-P receptor', 356, NULL, NULL, 47799),
(47800, '2.130.10.10-FF-000187', NULL, 'WD repeat-containing protein 35', 276, NULL, NULL, 47800),
(47801, '2.130.10.10-FF-004150', NULL, 'Uncharacterized protein', 177, NULL, NULL, 47801),
(47802, '3.40.50.300-FF-003817', NULL, 'ABC a-pheromone efflux pump AtrD', 257, NULL, NULL, 47802),
(47803, '3.40.50.1820-FF-001833', NULL, 'Putative phospholipase', 85, NULL, NULL, 47803),
(47804, '1.25.40.10-FF-005357', NULL, 'Pentatricopeptide repeat-containing protein At2g39620', 111, NULL, NULL, 47804),
(47805, '2.10.110.10-FF-000020', NULL, 'PDZ and LIM domain protein 5', 59, NULL, NULL, 47805),
(47806, '1.10.8.270-FF-000102', NULL, 'Uncharacterized protein', 126, NULL, NULL, 47806),
(47807, '1.10.10.10-FF-000419', NULL, 'DNA-binding response regulator', 101, NULL, NULL, 47807),
(47808, '2.60.40.10-FF-002261', NULL, 'Transglutaminase 2, like', 113, NULL, NULL, 47808),
(47809, '3.90.79.10-FF-000154', NULL, 'Nudix hydrolase DR_0079', 178, NULL, NULL, 47809),
(47810, '1.25.40.170-FF-000009', NULL, 'Protein Smaug homolog 2-like Protein', 102, NULL, NULL, 47810),
(47811, '1.10.10.10-FF-001509', NULL, 'Vacuolar protein-sorting-associated protein 36', 69, NULL, NULL, 47811),
(47812, '1.20.1080.10-FF-000101', NULL, 'Uncharacterized protein', 183, NULL, NULL, 47812),
(47813, '4.10.60.10-FF-000056', NULL, 'Splicing factor, arginine/serine-rich 7', 66, NULL, NULL, 47813),
(47814, '2.30.30.190-FF-000009', NULL, 'Kinesin family member 13B', 79, NULL, NULL, 47814),
(47815, '2.30.30.40-FF-000084', NULL, 'dynamin-binding protein isoform X1', 91, NULL, NULL, 47815);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(47816, '1.25.40.10-FF-003209', NULL, 'TPR repeat, putative', 80, NULL, NULL, 47816),
(47817, '1.50.40.10-FF-000583', NULL, 'Uncharacterized protein', 60, NULL, NULL, 47817),
(47818, '2.30.29.130-FF-000001', NULL, 'Glycoprotein', 94, NULL, NULL, 47818),
(47819, '1.10.287.70-FF-000046', NULL, 'Sodium channel protein', 143, NULL, NULL, 47819),
(47820, '1.10.510.10-FF-001167', NULL, 'Uncharacterized protein', 204, NULL, NULL, 47820),
(47821, '1.20.1250.20-FF-000966', NULL, 'YMR155W-like protein', 176, NULL, NULL, 47821),
(47822, '1.20.120.1760-FF-000047', NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', 181, NULL, NULL, 47822),
(47823, '2.60.40.60-FF-000561', NULL, 'Cadherin 5', 113, NULL, NULL, 47823),
(47824, '3.80.10.10-FF-000844', NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase isoform B', 102, NULL, NULL, 47824),
(47825, '3.40.50.1240-FF-000035', NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', 393, NULL, NULL, 47825),
(47826, '1.10.510.10-FF-002257', NULL, NULL, 227, NULL, NULL, 47826),
(47827, '1.20.5.780-FF-000005', NULL, 'FXYD domain-containing ion transport regulator', 55, NULL, NULL, 47827),
(47828, '1.20.1110.10-FF-000205', NULL, NULL, 94, NULL, NULL, 47828),
(47829, '3.30.1520.10-FF-000087', NULL, 'GD16870', 152, NULL, NULL, 47829),
(47830, '3.30.160.60-FF-002474', NULL, 'E3 ubiquitin-protein ligase TRIM16', 69, NULL, NULL, 47830),
(47831, '3.30.160.60-FF-001384', NULL, 'Zinc finger protein', 27, NULL, NULL, 47831),
(47832, '1.20.120.1110-FF-000009', NULL, 'Uncharacterized protein', 111, NULL, NULL, 47832),
(47833, '3.30.1360.40-FF-000004', NULL, 'Arginine repressor', 81, NULL, NULL, 47833),
(47834, '3.30.1360.120-FF-000080', NULL, 'Predicted protein', 104, NULL, NULL, 47834),
(47835, '3.30.40.10-FF-001618', NULL, 'RBR-type E3 ubiquitin transferase', 90, NULL, NULL, 47835),
(47836, '3.40.50.150-FF-000631', NULL, 'Uncharacterized protein', 194, NULL, NULL, 47836),
(47837, '1.10.565.10-FF-000034', NULL, 'Hormone receptor 4, isoform J', 244, NULL, NULL, 47837),
(47838, '1.10.238.10-FF-000050', NULL, 'Calcium-dependent protein kinase 7', 176, NULL, NULL, 47838),
(47839, '3.30.2290.10-FF-000029', NULL, 'Peptidase U62 modulator of DNA gyrase', 198, NULL, NULL, 47839),
(47840, '3.30.40.10-FF-001473', NULL, 'Uncharacterized protein', 67, NULL, NULL, 47840),
(47841, '1.25.40.20-FF-001869', NULL, 'Predicted protein', 129, NULL, NULL, 47841),
(47842, '3.30.200.20-FF-002404', NULL, 'Tyrosine-protein kinase', 89, NULL, NULL, 47842),
(47843, '1.25.10.10-FF-003129', NULL, 'Uncharacterized protein', 532, NULL, NULL, 47843),
(47844, '3.30.1010.10-FF-000020', NULL, 'Serine/threonine-protein kinase ATR', 119, NULL, NULL, 47844),
(47845, '3.30.1490.430-FF-000004', NULL, 'Uncharacterized protein', 41, NULL, NULL, 47845),
(47846, '1.10.10.60-FF-001266', NULL, NULL, 89, NULL, NULL, 47846),
(47847, '2.10.25.10-FF-000726', NULL, 'Laminin-like protein epi-1', 46, NULL, NULL, 47847),
(47848, '3.40.1190.20-FF-000235', NULL, NULL, 236, NULL, NULL, 47848),
(47849, '3.30.420.10-FF-000473', NULL, 'Predicted protein', 252, NULL, NULL, 47849),
(47850, '3.40.50.300-FF-005280', NULL, 'Adenosylcobinamide kinase/adenosylcobinamidephosphate guanylyltransferase', 178, NULL, NULL, 47850),
(47851, '3.30.230.10-FF-000239', NULL, 'Probable DNA topoisomerase 2', 127, NULL, NULL, 47851),
(47852, '2.130.10.10-FF-004239', NULL, 'Uncharacterized protein', 142, NULL, NULL, 47852),
(47853, '1.20.920.10-FF-000184', NULL, 'Bromodomain-containing protein 1', 120, NULL, NULL, 47853),
(47854, '3.40.50.1820-FF-001294', NULL, 'Protein phosphatase methylesterase 1', 279, NULL, NULL, 47854),
(47855, '2.60.120.290-FF-000241', NULL, 'Metalloendopeptidase', 50, NULL, NULL, 47855),
(47856, '1.25.40.10-FF-003518', NULL, 'Uncharacterized protein', 124, NULL, NULL, 47856),
(47857, '3.40.50.150-FF-001485', NULL, NULL, 122, NULL, NULL, 47857),
(47858, '3.30.9.10-FF-000017', NULL, 'Sarcosine oxidase, beta subunit', 157, NULL, NULL, 47858),
(47859, '1.20.5.190-FF-000143', NULL, NULL, 58, NULL, NULL, 47859); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(47860, '2.60.40.60-FF-000870', NULL, 'Uncharacterized protein', 101, NULL, NULL, 47860),
(47861, '3.30.565.10-FF-000511', NULL, 'Sensor histidine kinase', 157, NULL, NULL, 47861),
(47862, '3.40.50.720-FF-000936', NULL, 'Oxidoreductase, short-chain dehydrogenase/reductase family', 233, NULL, NULL, 47862),
(47863, '2.40.160.120-FF-000023', NULL, 'Oxysterol-binding protein', 200, NULL, NULL, 47863),
(47864, '3.40.50.1440-FF-000067', NULL, 'Tubulin delta chain', 407, NULL, NULL, 47864),
(47865, '1.10.238.10-FF-000994', NULL, 'CALUmenin (Calcium-binding protein) homolog', 90, NULL, NULL, 47865),
(47866, '1.10.510.10-FF-000003', NULL, 'TRAF2 and NCK-interacting protein kinase isoform 4', 207, NULL, NULL, 47866),
(47867, '1.10.10.500-FF-000006', NULL, NULL, 76, NULL, NULL, 47867),
(47868, '1.20.120.350-FF-000061', NULL, 'Potassium voltage-gated channel subfamily C member 2', 138, NULL, NULL, 47868),
(47869, '1.20.1170.10-FF-000001', NULL, 'Hemolytic enterotoxin HBL', 338, NULL, NULL, 47869),
(47870, '3.40.50.10260-FF-000003', NULL, 'Multifunctional fusion protein', 212, NULL, NULL, 47870),
(47871, '2.40.50.140-FF-001227', NULL, NULL, 58, NULL, NULL, 47871),
(47872, '2.130.10.10-FF-004947', NULL, 'Sperm associated antigen 16', 98, NULL, NULL, 47872),
(47873, '3.30.1360.210-FF-000011', NULL, 'Uncharacterized protein', 118, NULL, NULL, 47873),
(47874, '3.10.110.10-FF-000145', NULL, 'Probable ubiquitin-conjugating enzyme E2 21', 156, NULL, NULL, 47874),
(47875, '3.20.180.20-FF-000032', NULL, 'Dynein heavy chain', 106, NULL, NULL, 47875),
(47876, '2.60.40.10-FF-004823', NULL, NULL, 123, NULL, NULL, 47876),
(47877, '2.10.310.10-FF-000001', NULL, 'Serpin family A member 1', 39, NULL, NULL, 47877),
(47878, '1.20.1730.10-FF-000084', NULL, 'Predicted protein', 470, NULL, NULL, 47878),
(47879, '1.10.472.10-FF-000021', NULL, 'Cyclin-K (Predicted)', 144, NULL, NULL, 47879),
(47880, '3.40.50.1820-FF-000905', NULL, 'Ves G 1 allergen precursor, putative', 184, NULL, NULL, 47880),
(47881, '1.10.510.10-FF-003185', NULL, NULL, 153, NULL, NULL, 47881),
(47882, '3.40.50.1820-FF-001305', NULL, 'Uncharacterized protein', 272, NULL, NULL, 47882),
(47883, '3.40.1360.10-FF-000038', NULL, 'Mitochondrial helicase twinkle', 121, NULL, NULL, 47883),
(47884, '3.20.20.70-FF-000478', NULL, 'tRNA-dihydrouridine synthase', 243, NULL, NULL, 47884),
(47885, '1.20.1560.10-FF-000503', NULL, 'Uncharacterized protein', 335, NULL, NULL, 47885),
(47886, '3.40.50.620-FF-000676', NULL, 'Uncharacterized protein', 226, NULL, NULL, 47886),
(47887, '3.40.50.720-FF-000408', NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', 252, NULL, NULL, 47887),
(47888, '1.20.58.390-FF-000214', NULL, 'Uncharacterized protein', 81, NULL, NULL, 47888),
(47889, '1.10.238.10-FF-000207', NULL, 'Putative 45 kDa calcium-binding protein', 90, NULL, NULL, 47889),
(47890, '3.40.850.10-FF-000486', NULL, 'Uncharacterized protein', 84, NULL, NULL, 47890),
(47891, '3.40.630.10-FF-000161', NULL, 'Uncharacterized protein, isoform A', 318, NULL, NULL, 47891),
(47892, '2.40.30.20-FF-000010', NULL, 'ATP synthase subunit alpha', 91, NULL, NULL, 47892),
(47893, '3.30.160.60-FF-002710', NULL, 'Zinc finger protein 880', 36, NULL, NULL, 47893),
(47894, '1.10.287.100-FF-000005', NULL, 'Transcription initiation factor IIA subunit 1', 51, NULL, NULL, 47894),
(47895, '3.40.50.300-FF-007387', NULL, 'Uncharacterized protein', 319, NULL, NULL, 47895),
(47896, '2.60.40.10-FF-003553', NULL, NULL, 87, NULL, NULL, 47896),
(47897, '1.10.3380.10-FF-000020', NULL, 'Chromosome 10, whole genome shotgun sequence', 135, NULL, NULL, 47897),
(47898, '3.40.50.300-FF-004661', NULL, 'Predicted protein', 267, NULL, NULL, 47898),
(47899, '3.10.20.230-FF-000009', NULL, 'Echinoderm microtubule-associated protein-like CG42247', 82, NULL, NULL, 47899),
(47900, '3.30.565.10-FF-000202', NULL, 'Sensor histidine kinase TodS', 163, NULL, NULL, 47900),
(47901, '3.10.105.10-FF-000088', NULL, 'Peptide ABC transporter substrate-binding protein', 249, NULL, NULL, 47901),
(47902, '1.25.40.10-FF-001411', NULL, 'Outer membrane protein assembly factor BamD', 229, NULL, NULL, 47902);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(47903, '1.20.144.10-FF-000127', NULL, 'Phospholipid phosphatase 4', 152, NULL, NULL, 47903),
(47904, '3.40.190.10-FF-000334', NULL, 'Peptide ABC transporter, periplasmic peptide-binding protein', 139, NULL, NULL, 47904),
(47905, '3.40.50.300-FF-000058', NULL, 'Translation elongation factor 2', 235, NULL, NULL, 47905),
(47906, '1.25.40.10-FF-004137', NULL, 'Uncharacterized protein', 117, NULL, NULL, 47906),
(47907, '1.25.10.10-FF-000858', NULL, 'Vimar', 191, NULL, NULL, 47907),
(47908, '1.25.10.10-FF-000482', NULL, 'TOG array regulator of axonemal microtubules 1', 153, NULL, NULL, 47908),
(47909, '2.40.50.100-FF-000193', NULL, 'Putative heavy metal efflux system protein', 60, NULL, NULL, 47909),
(47910, '3.30.160.20-FF-000107', NULL, 'Peptide chain release factor 1, putative', 80, NULL, NULL, 47910),
(47911, '3.40.630.30-FF-000167', NULL, 'GNAT family acetyltransferase Nat4, putative', 196, NULL, NULL, 47911),
(47912, '3.80.10.10-FF-001356', NULL, 'Receptor-like protein kinase HSL1', 163, NULL, NULL, 47912),
(47913, '1.20.1330.10-FF-000003', NULL, 'Flagellin', 267, NULL, NULL, 47913),
(47914, '3.90.550.10-FF-000744', NULL, 'Uncharacterized protein', 123, NULL, NULL, 47914),
(47915, '1.10.287.10-FF-000034', NULL, 'Histidyl-tRNA synthetase, isoform D', 32, NULL, NULL, 47915),
(47916, '3.30.497.10-FF-000009', NULL, 'serpin B5 isoform X2', 211, NULL, NULL, 47916),
(47917, '1.10.510.10-FF-003893', NULL, NULL, 87, NULL, NULL, 47917),
(47918, '3.90.830.10-FF-000018', NULL, 'Syntaxin binding protein, putative', 58, NULL, NULL, 47918),
(47919, '3.60.10.10-FF-000429', NULL, 'Uncharacterized protein', 91, NULL, NULL, 47919),
(47920, '3.40.47.10-FF-000150', NULL, NULL, 235, NULL, NULL, 47920),
(47921, '3.90.640.10-FF-000173', NULL, 'Actin family protein', 115, NULL, NULL, 47921),
(47922, '1.10.510.10-FF-000548', NULL, 'Serine/threonine-protein kinase ATG1', 307, NULL, NULL, 47922),
(47923, '3.30.200.20-FF-000151', NULL, 'G2-specific protein kinase nimA', 40, NULL, NULL, 47923),
(47924, '1.25.40.10-FF-004845', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 136, NULL, NULL, 47924),
(47925, '3.30.160.60-FF-000765', NULL, 'Zinc finger 45-like', 28, NULL, NULL, 47925),
(47926, '3.40.50.2300-FF-000022', NULL, 'Fructose repressor (Catabolite repressor/activator)', 93, NULL, NULL, 47926),
(47927, '3.30.160.60-FF-000456', NULL, 'Zinc finger and BTB domain containing 5', 32, NULL, NULL, 47927),
(47928, '2.30.40.10-FF-000148', NULL, 'Probable N-acetylglucosamine-6-phosphate deacetylase', 108, NULL, NULL, 47928),
(47929, '1.20.1510.10-FF-000101', NULL, NULL, 127, NULL, NULL, 47929),
(47930, '2.170.120.40-FF-000014', NULL, 'YbbR family protein', 87, NULL, NULL, 47930),
(47931, '2.40.290.10-FF-000025', NULL, 'Uncharacterized protein', 204, NULL, NULL, 47931),
(47932, '1.20.1070.10-FF-000853', NULL, 'Uncharacterized protein', 103, NULL, NULL, 47932),
(47933, '3.40.50.12780-FF-000236', NULL, 'Uncharacterized protein', 113, NULL, NULL, 47933),
(47934, '3.30.160.60-FF-003093', NULL, 'Zinc finger protein 662', 38, NULL, NULL, 47934),
(47935, '1.20.5.110-FF-000176', NULL, 'Qa-SNARE protein, putative', 81, NULL, NULL, 47935),
(47936, '3.30.40.10-FF-002237', NULL, 'Qin', 64, NULL, NULL, 47936),
(47937, '3.10.20.90-FF-000136', NULL, 'Arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 1', 112, NULL, NULL, 47937),
(47938, '2.60.60.20-FF-000011', NULL, 'Lipoxygenase homology domain-containing protein 1', 119, NULL, NULL, 47938),
(47939, '1.20.5.430-FF-000007', NULL, 'Heat shock factor-binding protein 1', 47, NULL, NULL, 47939),
(47940, '1.10.630.10-FF-000602', NULL, 'Uncharacterized protein', 272, NULL, NULL, 47940),
(47941, '2.170.300.10-FF-000036', NULL, 'Uncharacterized protein', 105, NULL, NULL, 47941),
(47942, '3.30.710.10-FF-000377', NULL, 'SCF ubiquitin ligase complex protein SKP1b', 65, NULL, NULL, 47942),
(47943, '2.60.40.60-FF-000538', NULL, 'Uncharacterized protein', 104, NULL, NULL, 47943),
(47944, '1.10.1410.10-FF-000006', NULL, 'Nucleolar protein 6', 51, NULL, NULL, 47944);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(47945, '1.10.3580.10-FF-000001', NULL, 'ATP synthase mitochondrial F1 complex assembly factor 2', 172, NULL, NULL, 47945),
(47946, '2.30.29.30-FF-000246', NULL, 'Docking protein 1', 110, NULL, NULL, 47946),
(47947, '3.10.450.10-FF-000092', NULL, 'Uncharacterized protein', 109, NULL, NULL, 47947),
(47948, '3.30.2350.10-FF-000040', NULL, 'Os04g0576300 protein', 163, NULL, NULL, 47948),
(47949, '2.40.50.100-FF-000204', NULL, 'Uncharacterized protein', 40, NULL, NULL, 47949),
(47950, '3.30.70.330-FF-001343', NULL, 'Single-stranded DNA binding protein, putative', 125, NULL, NULL, 47950),
(47951, '3.40.20.10-FF-000009', NULL, 'gelsolin isoform X1', 114, NULL, NULL, 47951),
(47952, '3.20.170.50-FF-000001', NULL, 'Dot/Icm secretion system protein IcmQ', 117, NULL, NULL, 47952),
(47953, '3.30.450.40-FF-000309', NULL, 'Phosphodiesterase', 71, NULL, NULL, 47953),
(47954, '3.40.190.10-FF-000677', NULL, 'Transcriptional regulatory protein', 112, NULL, NULL, 47954),
(47955, '2.60.120.260-FF-000243', NULL, 'Alpha-1,3/4-fucosidase', 120, NULL, NULL, 47955),
(47956, '3.40.50.150-FF-001699', NULL, NULL, 82, NULL, NULL, 47956),
(47957, '3.30.10.20-FF-000001', NULL, 'Stage V sporulation protein D', 58, NULL, NULL, 47957),
(47958, '1.10.275.10-FF-000023', NULL, NULL, 98, NULL, NULL, 47958),
(47959, '3.20.20.80-FF-000138', NULL, 'Putative alpha-glucosidase AgdA', 191, NULL, NULL, 47959),
(47960, '3.40.50.800-FF-000101', NULL, 'Histidine--tRNA ligase', 87, NULL, NULL, 47960),
(47961, '3.30.160.60-FF-006055', NULL, NULL, 31, NULL, NULL, 47961),
(47962, '1.20.970.10-FF-000024', NULL, 'Anthranilate phosphoribosyltransferase', 66, NULL, NULL, 47962),
(47963, '2.60.210.10-FF-000078', NULL, NULL, 133, NULL, NULL, 47963),
(47964, '2.130.10.10-FF-001513', NULL, 'Cilia and flagella associated protein 52', 128, NULL, NULL, 47964),
(47965, '2.130.10.130-FF-000048', NULL, NULL, 200, NULL, NULL, 47965),
(47966, '3.40.50.2300-FF-001567', NULL, NULL, 160, NULL, NULL, 47966),
(47967, '1.10.8.60-FF-000450', NULL, 'Uncharacterized protein', 93, NULL, NULL, 47967),
(47968, '3.40.50.1980-FF-000111', NULL, 'Hemin-binding periplasmic protein hmuT', 130, NULL, NULL, 47968),
(47969, '3.30.2010.10-FF-000003', NULL, 'CAAX prenyl protease', 84, NULL, NULL, 47969),
(47970, '1.10.510.10-FF-001728', NULL, 'Protein CBG02852', 199, NULL, NULL, 47970),
(47971, '1.10.560.10-FF-000153', NULL, 'Uncharacterized protein', 138, NULL, NULL, 47971),
(47972, '3.40.50.720-FF-000375', NULL, 'Uncharacterized protein, chloroplastic', 228, NULL, NULL, 47972),
(47973, '3.40.50.300-FF-000619', NULL, 'Phosphoribulokinase', 231, NULL, NULL, 47973),
(47974, '1.20.1050.10-FF-000184', NULL, 'Hypothetical glutathione S-transferase like protein', 117, NULL, NULL, 47974),
(47975, '1.20.272.10-FF-000060', NULL, NULL, 94, NULL, NULL, 47975),
(47976, '3.40.50.300-FF-006218', NULL, 'Predicted protein', 72, NULL, NULL, 47976),
(47977, '3.30.30.10-FF-000011', NULL, 'Plant defensin 1.5', 53, NULL, NULL, 47977),
(47978, '3.40.50.2300-FF-000477', NULL, 'Two-component response regulator', 162, NULL, NULL, 47978),
(47979, '1.10.540.10-FF-000140', NULL, 'Uncharacterized protein', 28, NULL, NULL, 47979),
(47980, '2.130.10.10-FF-000895', NULL, 'Two-component system sensor histidine kinase/response regulator', 309, NULL, NULL, 47980),
(47981, '3.30.260.10-FF-000067', NULL, NULL, 92, NULL, NULL, 47981),
(47982, '2.70.170.10-FF-000190', NULL, 'Uncharacterized protein', 227, NULL, NULL, 47982),
(47983, '3.20.20.60-FF-000132', NULL, 'Uncharacterized protein', 54, NULL, NULL, 47983),
(47984, '3.30.559.70-FF-000014', NULL, 'Carnitine palmitoyltransferase-like protein', 287, NULL, NULL, 47984),
(47985, '1.25.10.10-FF-003461', NULL, 'Uncharacterized protein', 234, NULL, NULL, 47985),
(47986, '2.20.28.290-FF-000005', NULL, 'Leucine--tRNA ligase', 49, NULL, NULL, 47986),
(47987, '3.30.70.330-FF-001490', NULL, 'Uncharacterized protein', 108, NULL, NULL, 47987),
(47988, '1.20.58.2220-FF-000054', NULL, 'Uncharacterized protein', 136, NULL, NULL, 47988),
(47989, '2.60.40.1730-FF-000026', NULL, 'TAF2', 82, NULL, NULL, 47989);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(47990, '2.60.220.50-FF-000124', NULL, 'Uncharacterized protein', 31, NULL, NULL, 47990),
(47991, '3.10.290.10-FF-000085', NULL, 'Tyrosine--tRNA ligase', 109, NULL, NULL, 47991),
(47992, '3.90.215.10-FF-000005', NULL, 'angiopoietin-1 isoform X2', 183, NULL, NULL, 47992),
(47993, '3.80.10.10-FF-002284', NULL, 'Leucine-rich repeat protein (LRRP), putative', 68, NULL, NULL, 47993),
(47994, '1.10.10.10-FF-001403', NULL, 'PeRoXisome assembly factor', 62, NULL, NULL, 47994),
(47995, '2.40.30.330-FF-000016', NULL, 'Predicted protein', 89, NULL, NULL, 47995),
(47996, '2.10.25.160-FF-000006', NULL, 'Granulin a', 60, NULL, NULL, 47996),
(47997, '3.40.50.620-FF-000221', NULL, 'Nicotinamide/nicotinic acid mononucleotide adenylyltransferase 3', 244, NULL, NULL, 47997),
(47998, '3.30.160.60-FF-005436', NULL, NULL, 55, NULL, NULL, 47998),
(47999, '2.70.150.10-FF-000082', NULL, 'Cation-transporter ATPase I CtpI', 137, NULL, NULL, 47999),
(48000, '3.30.70.330-FF-002669', NULL, NULL, 139, NULL, NULL, 48000),
(48001, '2.60.200.40-FF-000013', NULL, 'Diacylglycerol kinase', 162, NULL, NULL, 48001),
(48002, '2.30.29.30-FF-000774', NULL, 'Dynamin 2b', 98, NULL, NULL, 48002),
(48003, '2.60.120.430-FF-000007', NULL, 'FERONIA receptor-like kinase', 190, NULL, NULL, 48003),
(48004, '2.40.70.10-FF-000105', NULL, 'aspartic proteinase PCS1', 194, NULL, NULL, 48004),
(48005, '3.40.50.2000-FF-000977', NULL, 'Uncharacterized protein', 81, NULL, NULL, 48005),
(48006, '2.170.8.10-FF-000011', NULL, 'Phosphoenolpyruvate carboxykinase [GTP]', 83, NULL, NULL, 48006),
(48007, '2.40.110.10-FF-000013', NULL, 'Acyl-coenzyme A oxidase 4 peroxisomal', 107, NULL, NULL, 48007),
(48008, '1.20.1070.10-FF-000292', NULL, 'Vomeronasal type-1 receptor', 294, NULL, NULL, 48008),
(48009, '3.40.50.150-FF-000760', NULL, 'Uncharacterized protein', 170, NULL, NULL, 48009),
(48010, '3.30.160.60-FF-005094', NULL, NULL, 33, NULL, NULL, 48010),
(48011, '2.60.120.920-FF-000172', NULL, 'Uncharacterized protein', 89, NULL, NULL, 48011),
(48012, '2.10.25.10-FF-001255', NULL, 'C-type lectin domain-containing 14A', 66, NULL, NULL, 48012),
(48013, '1.10.10.750-FF-000047', NULL, 'Uncharacterized protein', 33, NULL, NULL, 48013),
(48014, '2.60.40.10-FF-004481', NULL, NULL, 159, NULL, NULL, 48014),
(48015, '3.80.10.10-FF-004425', NULL, 'Uncharacterized protein', 249, NULL, NULL, 48015),
(48016, '1.10.10.790-FF-000048', NULL, NULL, 66, NULL, NULL, 48016),
(48017, '2.90.10.10-FF-000037', NULL, 'Serine/threonine-protein kinase', 132, NULL, NULL, 48017),
(48018, '1.10.10.440-FF-000073', NULL, 'Predicted protein', 41, NULL, NULL, 48018),
(48019, '3.30.450.20-FF-000450', NULL, 'Uncharacterized protein', 147, NULL, NULL, 48019),
(48020, '3.10.100.10-FF-000083', NULL, 'C-type lectin domain family 1 member B', 170, NULL, NULL, 48020),
(48021, '1.20.810.10-FF-000007', NULL, 'Ubiquinol-cytochrome C reductase B subunit', 432, NULL, NULL, 48021),
(48022, '3.30.450.20-FF-000118', NULL, 'Potassium voltage-gated channel subfamily H member 8', 126, NULL, NULL, 48022),
(48023, '3.40.50.2300-FF-001438', NULL, NULL, 82, NULL, NULL, 48023),
(48024, '1.10.510.10-FF-001875', NULL, 'Receptor protein-tyrosine kinase', 189, NULL, NULL, 48024),
(48025, '1.10.8.60-FF-000118', NULL, 'Propionate catabolism operon regulatory protein PrpR', 83, NULL, NULL, 48025),
(48026, '3.40.50.720-FF-001336', NULL, 'SDR family NAD(P)-dependent oxidoreductase', 252, NULL, NULL, 48026),
(48027, '1.10.630.10-FF-000366', NULL, 'Ent-kaurene oxidase', 450, NULL, NULL, 48027),
(48028, '3.40.50.970-FF-000197', NULL, 'Pyruvate decarboxylase', 122, NULL, NULL, 48028),
(48029, '3.40.50.300-FF-005841', NULL, 'Uncharacterized protein', 201, NULL, NULL, 48029),
(48030, '1.10.10.60-FF-000884', NULL, NULL, 64, NULL, NULL, 48030),
(48031, '3.40.50.720-FF-002426', NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', 40, NULL, NULL, 48031),
(48032, '2.60.40.10-FF-000771', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', 91, NULL, NULL, 48032),
(48033, '1.20.140.40-FF-000026', NULL, 'Os08g0541800 protein', 149, NULL, NULL, 48033);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(48034, '2.60.40.10-FF-001861', NULL, 'Cell adhesion molecule', 108, NULL, NULL, 48034),
(48035, '1.10.20.60-FF-000002', NULL, 'Amidase', 55, NULL, NULL, 48035),
(48036, '2.60.120.260-FF-000619', NULL, 'Uncharacterized protein', 269, NULL, NULL, 48036),
(48037, '3.40.50.300-FF-003711', NULL, 'Eukaryotic initiation factor 4A-III', 95, NULL, NULL, 48037),
(48038, '3.40.50.10810-FF-000117', NULL, 'Defense against restriction protein B', 271, NULL, NULL, 48038),
(48039, '2.10.90.10-FF-000124', NULL, 'Bone morphogenetic protein 7', 111, NULL, NULL, 48039),
(48040, '1.25.40.10-FF-005087', NULL, 'Pentatricopeptide repeat-containing protein At3g49170, chloroplastic', 80, NULL, NULL, 48040),
(48041, '2.40.30.10-FF-000237', NULL, 'tRNA-specific 2-thiouridylase MnmA', 90, NULL, NULL, 48041),
(48042, '1.20.120.550-FF-000020', NULL, 'Uncharacterized protein', 143, NULL, NULL, 48042),
(48043, '2.60.40.420-FF-000029', NULL, 'L-ascorbate oxidase homolog', 122, NULL, NULL, 48043),
(48044, '1.10.10.10-FF-000223', NULL, 'RNA polymerase sigma factor', 73, NULL, NULL, 48044),
(48045, '3.30.950.10-FF-000007', NULL, 'Diphthine synthase', 159, NULL, NULL, 48045),
(48046, '2.30.30.140-FF-000219', NULL, 'AT14886p', 75, NULL, NULL, 48046),
(48047, '1.10.287.450-FF-000003', NULL, 'Non-homologous end-joining factor 1', 90, NULL, NULL, 48047),
(48048, '3.10.100.10-FF-000425', NULL, NULL, 83, NULL, NULL, 48048),
(48049, '6.10.140.2220-FF-000006', NULL, 'Ubiquitin carboxyl-terminal hydrolase 15', 51, NULL, NULL, 48049),
(48050, '3.30.479.20-FF-000061', NULL, 'Elongation factor Ts, mitochondrial', 64, NULL, NULL, 48050),
(48051, '3.40.640.10-FF-000532', NULL, 'Uncharacterized protein', 80, NULL, NULL, 48051),
(48052, '3.60.40.10-FF-000038', NULL, 'Probable protein phosphatase 2C 34', 304, NULL, NULL, 48052),
(48053, '1.10.486.10-FF-000069', NULL, 'DNA helicase', 145, NULL, NULL, 48053),
(48054, '1.10.10.60-FF-000176', NULL, 'pancreas/duodenum homeobox protein 1', 95, NULL, NULL, 48054),
(48055, '3.80.10.10-FF-003464', NULL, 'Uncharacterized protein', 222, NULL, NULL, 48055),
(48056, '2.30.30.40-FF-000320', NULL, 'E3 ubiquitin-protein ligase hecd-1', 79, NULL, NULL, 48056),
(48057, '2.60.40.10-FF-005442', NULL, NULL, 117, NULL, NULL, 48057),
(48058, '1.25.40.20-FF-000543', NULL, 'Uncharacterized protein', 171, NULL, NULL, 48058),
(48059, '3.80.10.10-FF-002536', NULL, 'TOLl (Drosophila) family', 192, NULL, NULL, 48059),
(48060, '3.10.100.10-FF-000116', NULL, 'Complement component C1q receptor', 174, NULL, NULL, 48060),
(48061, '3.20.20.80-FF-000470', NULL, 'Predicted protein', 356, NULL, NULL, 48061),
(48062, '2.60.40.1180-FF-000041', NULL, 'Alpha-xylosidase A', 92, NULL, NULL, 48062),
(48063, '3.30.70.330-FF-000163', NULL, 'Eukaryotic translation initiation factor 4B', 108, NULL, NULL, 48063),
(48064, '3.30.420.40-FF-000381', NULL, 'Glucosamine kinase GpsK', 159, NULL, NULL, 48064),
(48065, '3.90.700.10-FF-000009', NULL, 'Adenylylsulfate reductase, alpha subunit', 131, NULL, NULL, 48065),
(48066, '3.20.80.10-FF-000031', NULL, 'Uncharacterized protein', 168, NULL, NULL, 48066),
(48067, '3.40.50.10810-FF-000084', NULL, 'Protein CHROMATIN REMODELING 19', 237, NULL, NULL, 48067),
(48068, '1.10.460.10-FF-000010', NULL, 'DNA topoisomerase 1A', 132, NULL, NULL, 48068),
(48069, '1.50.40.10-FF-000274', NULL, 'Carnitine/acyl carnitine carrier, putative', 315, NULL, NULL, 48069),
(48070, '1.10.287.370-FF-000063', NULL, 'Uri-1', 123, NULL, NULL, 48070),
(48071, '2.60.40.150-FF-000128', NULL, 'C2 domain-containing protein', 145, NULL, NULL, 48071),
(48072, '3.20.20.140-FF-000267', NULL, 'Uncharacterized protein MJ0699', 193, NULL, NULL, 48072),
(48073, '3.40.50.2300-FF-001191', NULL, NULL, 60, NULL, NULL, 48073),
(48074, '1.10.730.10-FF-000222', NULL, 'Uncharacterized protein', 195, NULL, NULL, 48074),
(48075, '3.40.50.300-FF-001766', NULL, 'Elongator complex protein 4', 320, NULL, NULL, 48075),
(48076, '3.30.70.141-FF-000017', NULL, 'Nucleoside diphosphate kinase', 150, NULL, NULL, 48076),
(48077, '2.40.10.10-FF-000461', NULL, NULL, 138, NULL, NULL, 48077);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(48078, '3.40.50.150-FF-001013', NULL, NULL, 196, NULL, NULL, 48078),
(48079, '1.20.120.30-FF-000005', NULL, 'Methyl-accepting chemotaxis citrate transducer', 173, NULL, NULL, 48079),
(48080, '1.25.40.180-FF-000092', NULL, 'SD07232p', 227, NULL, NULL, 48080),
(48081, '1.10.268.10-FF-000035', NULL, NULL, 110, NULL, NULL, 48081),
(48082, '2.30.40.10-FF-000042', NULL, 'N-acetylglucosamine 6-phosphate deacetylase', 74, NULL, NULL, 48082),
(48083, '1.25.10.10-FF-001786', NULL, 'Adaptor protein, putative', 602, NULL, NULL, 48083),
(48084, '3.30.519.10-FF-000005', NULL, 'Rab GDP dissociation inhibitor', 92, NULL, NULL, 48084),
(48085, '1.20.1560.10-FF-000048', NULL, 'ATP-binding cassette sub-family B member 10, mitochondrial', 331, NULL, NULL, 48085),
(48086, '3.30.70.330-FF-000871', NULL, 'Sex lethal', 140, NULL, NULL, 48086),
(48087, '3.40.50.300-FF-001238', NULL, 'DNA mismatch repair protein', 240, NULL, NULL, 48087),
(48088, '3.40.50.2000-FF-000269', NULL, '3-deoxy-D-manno-octulosonic acid transferase', 188, NULL, NULL, 48088),
(48089, '3.40.50.2000-FF-001016', NULL, 'Glycosyl transferase, putative', 185, NULL, NULL, 48089),
(48090, '4.10.1240.10-FF-000052', NULL, 'Secretin receptor', 49, NULL, NULL, 48090),
(48091, '2.60.40.150-FF-000151', NULL, 'Rab11 family-interacting protein 1', 152, NULL, NULL, 48091),
(48092, '3.40.50.10930-FF-000007', NULL, NULL, 147, NULL, NULL, 48092),
(48093, '3.30.160.60-FF-002221', NULL, 'Zinc finger protein 559', 48, NULL, NULL, 48093),
(48094, '2.60.120.290-FF-000038', NULL, 'enteropeptidase isoform X2', 114, NULL, NULL, 48094),
(48095, '1.10.8.10-FF-000019', NULL, 'Putative e3 ubiquitin-protein ligase huwe1 isoform x2', 46, NULL, NULL, 48095),
(48096, '1.10.730.10-FF-000003', NULL, 'Leucine--tRNA ligase', 173, NULL, NULL, 48096),
(48097, '2.60.200.20-FF-000018', NULL, 'Centrosomal protein of 170 kDa', 126, NULL, NULL, 48097),
(48098, '1.10.472.10-FF-000094', NULL, 'G1/S-specific cyclin-D3 isoform X3', 15, NULL, NULL, 48098),
(48099, '3.80.10.10-FF-003806', NULL, 'Septation initiation network scaffold protein cdc11', 86, NULL, NULL, 48099),
(48100, '3.30.70.1230-FF-000220', NULL, 'Atrial natriuretic peptide receptor, putative', 75, NULL, NULL, 48100),
(48101, '3.30.470.20-FF-000226', NULL, 'Pyruvate carboxylase', 112, NULL, NULL, 48101),
(48102, '2.10.70.10-FF-000269', NULL, 'Complement component 1, s subcomponent', 65, NULL, NULL, 48102),
(48103, '3.40.50.150-FF-001721', NULL, NULL, 186, NULL, NULL, 48103),
(48104, '1.20.120.1900-FF-000016', NULL, 'Spindle pole body component', 287, NULL, NULL, 48104),
(48105, '3.40.50.300-FF-005509', NULL, 'RAD51-like 3 (S. cerevisiae), isoform CRA_a', 159, NULL, NULL, 48105),
(48106, '3.30.500.10-FF-000002', NULL, 'Antigen-presenting glycoprotein CD1d1', 181, NULL, NULL, 48106),
(48107, '2.40.170.20-FF-000087', NULL, 'TonB dependent receptor', 626, NULL, NULL, 48107),
(48108, '2.70.20.20-FF-000002', NULL, 'Matrix protein VP40', 156, NULL, NULL, 48108),
(48109, '2.40.10.10-FF-000438', NULL, NULL, 66, NULL, NULL, 48109),
(48110, '3.40.50.10240-FF-000008', NULL, 'Thiamine pyrophosphokinase, putative', 213, NULL, NULL, 48110),
(48111, '3.30.70.870-FF-000004', NULL, 'Translation factor GUF1, mitochondrial', 82, NULL, NULL, 48111),
(48112, '3.30.70.330-FF-001124', NULL, 'Nucleic acid binding protein', 103, NULL, NULL, 48112),
(48113, '3.40.50.10910-FF-000001', NULL, 'Imidazolonepropionase-like amidohydrolase', 138, NULL, NULL, 48113),
(48114, '2.60.40.150-FF-000460', NULL, 'Bud/polarization protein, putative', 173, NULL, NULL, 48114),
(48115, '3.80.10.10-FF-002845', NULL, 'Uncharacterized protein', 102, NULL, NULL, 48115),
(48116, '3.30.9.10-FF-000220', NULL, 'Uncharacterized protein', 58, NULL, NULL, 48116),
(48117, '3.50.50.60-FF-001251', NULL, 'Flavin-containing monooxygenase', 138, NULL, NULL, 48117),
(48118, '3.30.300.160-FF-000007', NULL, 'Type II secretion system protein GspE', 86, NULL, NULL, 48118),
(48119, '2.30.29.30-FF-000555', NULL, 'dynamin-1-like isoform X1', 134, NULL, NULL, 48119),
(48120, '1.25.40.90-FF-000092', NULL, 'Putative clathrin assembly protein', 88, NULL, NULL, 48120);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(48121, '3.20.20.140-FF-000452', NULL, 'DNA mismatch repair protein', 341, NULL, NULL, 48121),
(48122, '3.30.379.10-FF-000016', NULL, NULL, 108, NULL, NULL, 48122),
(48123, '1.20.80.10-FF-000069', NULL, 'Uncharacterized protein', 33, NULL, NULL, 48123),
(48124, '2.130.10.10-FF-002132', NULL, 'WD domain containing protein', 76, NULL, NULL, 48124),
(48125, '3.40.50.410-FF-000198', NULL, 'Integrin beta', 45, NULL, NULL, 48125),
(48126, '3.30.450.60-FF-000068', NULL, 'AP-1 complex subunit mu-2', 72, NULL, NULL, 48126),
(48127, '3.40.850.10-FF-000014', NULL, 'Kinesin-like protein KIN-7G', 359, NULL, NULL, 48127),
(48128, '1.10.1420.10-FF-000035', NULL, 'DNA mismatch repair protein', 172, NULL, NULL, 48128),
(48129, '3.40.30.10-FF-000510', NULL, 'Iodothyronine deiodinase', 145, NULL, NULL, 48129),
(48130, '3.40.50.10220-FF-000002', NULL, 'DNA polymerase III subunit psi', 101, NULL, NULL, 48130),
(48131, '1.20.1070.10-FF-001000', NULL, 'opsin', 318, NULL, NULL, 48131),
(48132, '3.30.559.30-FF-000031', NULL, 'Nonribosomal peptide synthase GliP2', 244, NULL, NULL, 48132),
(48133, '1.20.1250.20-FF-002192', NULL, 'Uncharacterized protein', 155, NULL, NULL, 48133),
(48134, '1.25.10.10-FF-001572', NULL, 'Uncharacterized protein', 294, NULL, NULL, 48134),
(48135, '1.20.1560.10-FF-000267', NULL, 'p-GlycoProtein related', 20, NULL, NULL, 48135),
(48136, '3.10.310.20-FF-000023', NULL, NULL, 119, NULL, NULL, 48136),
(48137, '3.30.470.10-FF-000004', NULL, 'Branched-chain-amino-acid aminotransferase', 160, NULL, NULL, 48137),
(48138, '2.170.270.10-FF-000241', NULL, 'SET and MYND domain containing 1a', 26, NULL, NULL, 48138),
(48139, '3.30.1380.20-FF-000011', NULL, 'Trafficking protein particle complex subunit 3', 112, NULL, NULL, 48139),
(48140, '3.40.50.150-FF-000395', NULL, 'N-terminal Xaa-Pro-Lys N-methyltransferase 1', 230, NULL, NULL, 48140),
(48141, '3.30.70.330-FF-001832', NULL, NULL, 85, NULL, NULL, 48141),
(48142, '2.60.120.10-FF-000627', NULL, 'Uncharacterized protein', 148, NULL, NULL, 48142),
(48143, '3.10.580.10-FF-000096', NULL, 'Magnesium and cobalt efflux protein CorC', 151, NULL, NULL, 48143),
(48144, '2.130.10.10-FF-005875', NULL, 'Uncharacterized protein', 305, NULL, NULL, 48144),
(48145, '2.60.40.10-FF-004059', NULL, NULL, 96, NULL, NULL, 48145),
(48146, '3.50.4.10-FF-000035', NULL, 'Hepatocyte growth factor', 97, NULL, NULL, 48146),
(48147, '3.40.50.300-FF-001547', NULL, 'Dynein heavy chain, cytosolic, putative', 235, NULL, NULL, 48147),
(48148, '2.40.10.10-FF-000129', NULL, 'Tequila, isoform D', 247, NULL, NULL, 48148),
(48149, '3.10.170.20-FF-000034', NULL, NULL, 162, NULL, NULL, 48149),
(48150, '3.65.10.10-FF-000026', NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', 209, NULL, NULL, 48150),
(48151, '1.10.472.10-FF-000127', NULL, 'Cyclin I family member 2', 91, NULL, NULL, 48151),
(48152, '1.10.630.10-FF-000147', NULL, '(S)-stylopine synthase 1', 461, NULL, NULL, 48152),
(48153, '3.40.850.10-FF-000380', NULL, 'Uncharacterized protein', 318, NULL, NULL, 48153),
(48154, '2.60.40.10-FF-005818', NULL, NULL, 54, NULL, NULL, 48154),
(48155, '2.60.40.150-FF-000004', NULL, 'RNA helicase, activating signal cointegrator 1', 109, NULL, NULL, 48155),
(48156, '2.30.29.30-FF-000807', NULL, 'Protein CBG15618', 130, NULL, NULL, 48156),
(48157, '1.10.8.10-FF-000351', NULL, 'UBA domain-containing protein 3', 67, NULL, NULL, 48157),
(48158, '1.20.1560.10-FF-000609', NULL, 'ABC transporter, multidrug resistance associated protein', 329, NULL, NULL, 48158),
(48159, '1.20.120.160-FF-000026', NULL, 'Uncharacterized protein', 126, NULL, NULL, 48159),
(48160, '3.40.980.10-FF-000018', NULL, 'CinA-like protein', 179, NULL, NULL, 48160),
(48161, '3.30.200.20-FF-001696', NULL, 'Uncharacterized protein', 63, NULL, NULL, 48161),
(48162, '3.80.10.10-FF-003245', NULL, 'Uncharacterized protein', 179, NULL, NULL, 48162),
(48163, '2.130.10.10-FF-001148', NULL, 'WD repeat-containing protein 3', 105, NULL, NULL, 48163),
(48164, '1.20.5.450-FF-000002', NULL, NULL, 92, NULL, NULL, 48164),
(48165, '3.40.50.1000-FF-000323', NULL, 'Phosphoglycolate phosphatase', 96, NULL, NULL, 48165);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(48166, '3.40.1000.50-FF-000006', NULL, 'Repressor of RNA polymerase III transcription MAF1', 148, NULL, NULL, 48166),
(48167, '3.40.190.10-FF-000789', NULL, 'Peptide ABC transporter substrate-binding protein', 140, NULL, NULL, 48167),
(48168, '2.40.10.230-FF-000004', NULL, 'H/ACA ribonucleoprotein complex subunit', 92, NULL, NULL, 48168),
(48169, '1.10.472.30-FF-000004', NULL, 'SPOC domain containing 1', 115, NULL, NULL, 48169),
(48170, '3.30.450.20-FF-000427', NULL, 'Probable transcriptional regulator', 113, NULL, NULL, 48170),
(48171, '2.30.30.140-FF-000343', NULL, 'Histone acetyltransferase', 158, NULL, NULL, 48171),
(48172, '3.10.100.10-FF-000212', NULL, 'GM21154', 125, NULL, NULL, 48172),
(48173, '3.20.20.80-FF-000498', NULL, 'Uncharacterized protein', 174, NULL, NULL, 48173),
(48174, '3.40.50.720-FF-001105', NULL, 'WGS project CABT00000000 data, contig 2.10', 99, NULL, NULL, 48174),
(48175, '3.40.50.300-FF-004200', NULL, 'DNA2/NAM7 helicase family protein', 285, NULL, NULL, 48175),
(48176, '3.90.1150.10-FF-000033', NULL, 'Cystathionine gamma-synthase', 134, NULL, NULL, 48176),
(48177, '2.60.40.10-FF-001075', NULL, 'Hemicentin 1', 95, NULL, NULL, 48177),
(48178, '2.130.10.10-FF-000108', NULL, 'cytoplasmic dynein 1 intermediate chain 1 isoform X1', 159, NULL, NULL, 48178),
(48179, '3.80.10.10-FF-003256', NULL, 'Uncharacterized protein', 172, NULL, NULL, 48179),
(48180, '2.60.40.700-FF-000001', NULL, 'Diphtheria toxin', 154, NULL, NULL, 48180),
(48181, '1.20.1250.20-FF-001663', NULL, 'Uncharacterized protein', 216, NULL, NULL, 48181),
(48182, '1.25.40.20-FF-000335', NULL, 'Palmitoyltransferase', 137, NULL, NULL, 48182),
(48183, '1.20.120.850-FF-000020', NULL, 'DNA repair protein, putative', 91, NULL, NULL, 48183),
(48184, '2.40.40.20-FF-000044', NULL, 'Transitional endoplasmic reticulum ATPase', 62, NULL, NULL, 48184),
(48185, '3.30.160.60-FF-004267', NULL, NULL, 26, NULL, NULL, 48185),
(48186, '3.20.20.10-FF-000050', NULL, 'L-glutamyl-[BtrI acyl-carrier protein] decarboxylase', 255, NULL, NULL, 48186),
(48187, '3.40.50.2300-FF-001455', NULL, NULL, 125, NULL, NULL, 48187),
(48188, '1.10.287.70-FF-000714', NULL, 'Predicted protein', 151, NULL, NULL, 48188),
(48189, '2.60.260.40-FF-000005', NULL, 'NADH dehydrogenase [ubiquinone] iron-sulfur protein 6, mitochondrial', 41, NULL, NULL, 48189),
(48190, '3.40.50.10190-FF-000089', NULL, 'DDK kinase regulatory subunit DBF4', 100, NULL, NULL, 48190),
(48191, '4.10.280.10-FF-000153', NULL, 'Transcription factor bHLH167', 78, NULL, NULL, 48191),
(48192, '1.10.287.810-FF-000010', NULL, 'Mitochondrial import inner membrane translocase subunit TIM9, putative', 77, NULL, NULL, 48192),
(48193, '2.60.120.10-FF-000419', NULL, 'Regulatory subunit of protein kinase a-like protein', 140, NULL, NULL, 48193),
(48194, '3.40.50.150-FF-001148', NULL, NULL, 177, NULL, NULL, 48194),
(48195, '1.20.920.10-FF-000212', NULL, 'Uncharacterized protein', 103, NULL, NULL, 48195),
(48196, '3.90.850.10-FF-000008', NULL, 'FAA hydrolase family protein', 217, NULL, NULL, 48196),
(48197, '1.10.730.10-FF-000211', NULL, 'Predicted protein', 176, NULL, NULL, 48197),
(48198, '3.30.70.330-FF-002984', NULL, NULL, 87, NULL, NULL, 48198),
(48199, '2.40.160.20-FF-000030', NULL, 'p44-18ES, P44 outer membrane protein expression locus with P44-18', 134, NULL, NULL, 48199),
(48200, '1.25.10.10-FF-002533', NULL, 'Exportin 1 (CRM1 homolog, yeast) b', 186, NULL, NULL, 48200),
(48201, '2.60.40.150-FF-000572', NULL, 'Uncharacterized protein', 122, NULL, NULL, 48201),
(48202, '3.90.550.10-FF-000082', NULL, 'Dolichol-phosphate mannosyltransferase subunit 1', 233, NULL, NULL, 48202),
(48203, '1.20.120.230-FF-000042', NULL, 'TaLiN', 128, NULL, NULL, 48203),
(48204, '1.10.110.30-FF-000001', NULL, 'CCA-adding enzyme', 95, NULL, NULL, 48204),
(48205, '1.10.510.10-FF-002128', NULL, NULL, 83, NULL, NULL, 48205),
(48206, '2.60.40.60-FF-000898', NULL, 'Uncharacterized protein', 103, NULL, NULL, 48206),
(48207, '3.40.1810.10-FF-000005', NULL, 'MADS-box transcription factor 21', 67, NULL, NULL, 48207),
(48208, '3.30.420.10-FF-000389', NULL, NULL, 129, NULL, NULL, 48208);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(48209, '3.40.50.300-FF-006342', NULL, 'Predicted protein', 104, NULL, NULL, 48209),
(48210, '3.40.50.1820-FF-000344', NULL, 'Acylamino-acid-releasing enzyme', 266, NULL, NULL, 48210),
(48211, '3.30.710.10-FF-000248', NULL, 'Uncharacterized protein', 72, NULL, NULL, 48211),
(48212, '3.30.200.20-FF-001224', NULL, 'Predicted protein', 40, NULL, NULL, 48212),
(48213, '2.102.10.10-FF-000008', NULL, 'Ubiquinol-cytochrome c reductase iron-sulfur subunit', 149, NULL, NULL, 48213),
(48214, '2.130.10.10-FF-005431', NULL, 'Uncharacterized protein', 225, NULL, NULL, 48214),
(48215, '3.30.420.10-FF-000501', NULL, NULL, 191, NULL, NULL, 48215),
(48216, '1.25.40.10-FF-005115', NULL, 'Uncharacterized protein', 114, NULL, NULL, 48216),
(48217, '3.40.50.300-FF-003683', NULL, 'Peroxisome biosynthesis protein-like protein', 185, NULL, NULL, 48217),
(48218, '3.40.50.620-FF-000816', NULL, 'Probable ethanolamine-phosphate cytidylyltransferase', 180, NULL, NULL, 48218),
(48219, '1.20.1070.10-FF-001348', NULL, 'Uncharacterized protein', 271, NULL, NULL, 48219),
(48220, '1.20.58.390-FF-000186', NULL, 'Gamma-aminobutyric acid (GABA) A receptor, alpha 3', 53, NULL, NULL, 48220),
(48221, '1.10.10.10-FF-001167', NULL, 'GntR family transcriptional regulator', 73, NULL, NULL, 48221),
(48222, '1.10.1200.10-FF-000052', NULL, 'Nonribosomal peptide synthase GliP', 73, NULL, NULL, 48222),
(48223, '3.30.930.10-FF-000360', NULL, 'Alanyl-tRNA synthetase 2, mitochondrial (putative)', 229, NULL, NULL, 48223),
(48224, '1.10.238.10-FF-000067', NULL, 'serine/threonine protein phosphatase 2A regulatory subunit B''''beta-like', 172, NULL, NULL, 48224),
(48225, '3.80.10.10-FF-002637', NULL, 'LRR receptor-like serine/threonine-protein kinase GSO2', 110, NULL, NULL, 48225),
(48226, '3.40.50.2300-FF-000027', NULL, 'HTH-type transcriptional regulator GalR', 115, NULL, NULL, 48226),
(48227, '3.40.50.720-FF-002533', NULL, 'L-lactate dehydrogenase', 90, NULL, NULL, 48227),
(48228, '1.25.10.10-FF-003152', NULL, 'Target of rapamycin homolog', 441, NULL, NULL, 48228),
(48229, '1.20.1280.290-FF-000057', NULL, 'Bidirectional sugar transporter SWEET', 96, NULL, NULL, 48229),
(48230, '1.10.10.250-FF-000015', NULL, '60S ribosomal protein L12, putative', 83, NULL, NULL, 48230),
(48231, '3.40.190.10-FF-000694', NULL, 'ABC transporter, solute-binding protein', 135, NULL, NULL, 48231),
(48232, '3.10.330.10-FF-000021', NULL, 'Vesicle-fusing ATPase, putative', 93, NULL, NULL, 48232),
(48233, '3.40.50.1820-FF-000765', NULL, 'Kynurenine formamidase', 297, NULL, NULL, 48233),
(48234, '3.80.10.10-FF-001227', NULL, 'F-box/LRR-repeat protein', 268, NULL, NULL, 48234),
(48235, '1.25.40.10-FF-000006', NULL, 'Prolyl 4-hydroxylase subunit alpha 2', 130, NULL, NULL, 48235),
(48236, '2.60.40.10-FF-002805', NULL, NULL, 90, NULL, NULL, 48236),
(48237, '3.30.420.10-FF-000490', NULL, NULL, 139, NULL, NULL, 48237),
(48238, '3.90.1640.20-FF-000006', NULL, 'Uncharacterized protein', 111, NULL, NULL, 48238),
(48239, '3.40.50.150-FF-000529', NULL, 'tRNA (1-methyladenosine) methyltransferase', 190, NULL, NULL, 48239),
(48240, '2.10.25.10-FF-001811', NULL, 'Uncharacterized protein', 31, NULL, NULL, 48240),
(48241, '1.25.40.10-FF-000899', NULL, 'Si:ch211-114c17.1', 288, NULL, NULL, 48241),
(48242, '1.10.8.1080-FF-000006', NULL, 'Glucokinase regulatory protein', 122, NULL, NULL, 48242),
(48243, '1.10.288.10-FF-000002', NULL, 'Methionine synthase (B12-dependent)', 98, NULL, NULL, 48243),
(48244, '3.40.50.300-FF-003469', NULL, 'Uncharacterized protein', 174, NULL, NULL, 48244),
(48245, '1.10.260.70-FF-000001', NULL, 'DNA-binding protein SATB', 80, NULL, NULL, 48245),
(48246, '2.40.160.120-FF-000006', NULL, 'oxysterol-binding protein-related protein 1D isoform X1', 173, NULL, NULL, 48246),
(48247, '3.40.430.10-FF-000033', NULL, 'Uncharacterized protein', 130, NULL, NULL, 48247),
(48248, '2.40.10.10-FF-000017', NULL, 'Chymotrypsin-like elastase family member 1', 127, NULL, NULL, 48248),
(48249, '3.90.830.10-FF-000013', NULL, 'BnaCnng68440D protein', 115, NULL, NULL, 48249),
(48250, '3.90.470.10-FF-000030', NULL, 'RL17, ribosomal protein 17-like 60S large ribosomal subunit', 175, NULL, NULL, 48250);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(48251, '2.130.10.10-FF-003874', NULL, 'Uncharacterized protein', 280, NULL, NULL, 48251),
(48252, '2.20.20.160-FF-000001', NULL, 'Blast:Protein giant-lens', 71, NULL, NULL, 48252),
(48253, '3.40.50.300-FF-007865', NULL, 'Uncharacterized protein', 210, NULL, NULL, 48253),
(48254, '3.40.50.1820-FF-001058', NULL, 'Predicted protein', 377, NULL, NULL, 48254),
(48255, '1.10.10.60-FF-000518', NULL, 'Two-component system sensor histidine kinase/response regulator', 53, NULL, NULL, 48255),
(48256, '2.130.10.10-FF-000529', NULL, 'WD repeat domain phosphoinositide-interacting protein 1', 261, NULL, NULL, 48256),
(48257, '1.10.3370.10-FF-000047', NULL, 'Uncharacterized protein', 104, NULL, NULL, 48257),
(48258, '3.20.20.80-FF-000610', NULL, 'Uncharacterized protein', 165, NULL, NULL, 48258),
(48259, '3.40.50.300-FF-002059', NULL, 'ADP-dependent DNA helicase RecQ', 228, NULL, NULL, 48259),
(48260, '2.30.30.40-FF-000073', NULL, 'SH3 and cysteine-rich domain-containing protein 2', 61, NULL, NULL, 48260),
(48261, '1.20.1250.20-FF-001242', NULL, 'Sialin, putative', 113, NULL, NULL, 48261),
(48262, '1.50.10.10-FF-000103', NULL, 'Mannosyl-oligosaccharide 1,2-alpha-mannosidase IB', 77, NULL, NULL, 48262),
(48263, '1.10.418.10-FF-000165', NULL, 'Rac guanine nucleotide exchange factor B', 128, NULL, NULL, 48263),
(48264, '1.25.40.10-FF-004598', NULL, 'Uncharacterized protein', 168, NULL, NULL, 48264),
(48265, '2.130.10.10-FF-003177', NULL, 'WD repeat domain 27', 208, NULL, NULL, 48265),
(48266, '3.40.1190.10-FF-000002', NULL, 'UDP-N-acetylmuramoylalanine--D-glutamate ligase', 206, NULL, NULL, 48266),
(48267, '2.130.10.10-FF-001957', NULL, 'U5 snRNP-specific 40 kDa protein', 306, NULL, NULL, 48267),
(48268, '1.20.1070.10-FF-000729', NULL, 'Frizzled 3, isoform C', 318, NULL, NULL, 48268),
(48269, '2.60.40.60-FF-000201', NULL, 'Dachsous cadherin-related 1', 106, NULL, NULL, 48269),
(48270, '1.25.40.20-FF-001633', NULL, 'Kinase, NEK', 95, NULL, NULL, 48270),
(48271, '3.30.70.60-FF-000011', NULL, '30S ribosomal protein S6', 101, NULL, NULL, 48271),
(48272, '1.25.40.10-FF-003412', NULL, 'Pentatricopeptide repeat-containing protein At1g53600, mitochondrial', 121, NULL, NULL, 48272),
(48273, '2.10.25.10-FF-000390', NULL, 'Laminin subunit alpha 3', 40, NULL, NULL, 48273),
(48274, '2.60.40.10-FF-005678', NULL, NULL, 83, NULL, NULL, 48274),
(48275, '3.40.50.300-FF-002290', NULL, 'Elongation factor Tu', 296, NULL, NULL, 48275),
(48276, '1.20.1070.10-FF-000617', NULL, 'Predicted protein', 271, NULL, NULL, 48276),
(48277, '2.60.40.790-FF-000185', NULL, NULL, 113, NULL, NULL, 48277),
(48278, '3.30.250.20-FF-000007', NULL, 'Uncharacterized protein', 59, NULL, NULL, 48278),
(48279, '3.40.50.300-FF-005386', NULL, 'Uncharacterized protein', 294, NULL, NULL, 48279),
(48280, '3.40.30.10-FF-000393', NULL, 'Glutathione S-transferase', 78, NULL, NULL, 48280),
(48281, '1.10.565.10-FF-000158', NULL, 'Retinoid X receptor, putative', 216, NULL, NULL, 48281),
(48282, '1.20.58.390-FF-000091', NULL, 'Glycine receptor, beta a', 98, NULL, NULL, 48282),
(48283, '3.40.50.300-FF-000243', NULL, 'Bifunctional 3''-phosphoadenosine 5''-phosphosulfate synthase 1', 211, NULL, NULL, 48283),
(48284, '3.30.497.10-FF-000133', NULL, 'Serine protease inhibitor 2.1', 65, NULL, NULL, 48284),
(48285, '2.30.29.30-FF-001308', NULL, 'Diacylglycerol kinase', 76, NULL, NULL, 48285),
(48286, '3.30.70.330-FF-001135', NULL, 'Poly(A) binding protein', 129, NULL, NULL, 48286),
(48287, '3.30.70.80-FF-000017', NULL, 'Subtilisin-like protease SBT2.5', 110, NULL, NULL, 48287),
(48288, '1.20.58.60-FF-000454', NULL, 'Dystonin', 112, NULL, NULL, 48288),
(48289, '1.10.10.10-FF-001959', NULL, 'Uncharacterized protein', 73, NULL, NULL, 48289),
(48290, '1.20.58.60-FF-000566', NULL, 'Dystrophin', 109, NULL, NULL, 48290),
(48291, '3.30.1520.10-FF-000098', NULL, 'Rho GTPase-activating protein 33', 121, NULL, NULL, 48291),
(48292, '1.10.510.10-FF-000672', NULL, 'Serine/threonine protein kinase', 346, NULL, NULL, 48292),
(48293, '2.10.25.10-FF-001002', NULL, 'Protein eyes shut homolog', 45, NULL, NULL, 48293); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(48294, '3.40.30.10-FF-000263', NULL, 'Redoxin', 154, NULL, NULL, 48294),
(48295, '3.30.1330.30-FF-000050', NULL, 'Putative selenocysteine insertion sequence-binding protein 2', 100, NULL, NULL, 48295),
(48296, '3.40.50.720-FF-001914', NULL, 'UDP-galactopyranose mutase', 68, NULL, NULL, 48296),
(48297, '1.50.10.130-FF-000021', NULL, NULL, 129, NULL, NULL, 48297),
(48298, '3.40.80.10-FF-000002', NULL, '1,6-anhydro-N-acetylmuramyl-L-alanine amidase', 181, NULL, NULL, 48298),
(48299, '1.20.1280.170-FF-000004', NULL, 'Exocyst complex component 7', 167, NULL, NULL, 48299),
(48300, '3.40.50.12470-FF-000014', NULL, 'Dehydrogenase E1 and transketolase domain containing 1', 71, NULL, NULL, 48300),
(48301, '1.20.1740.10-FF-000253', NULL, 'Solute carrier family 12 member 3', 280, NULL, NULL, 48301),
(48302, '2.60.120.200-FF-000731', NULL, 'Uncharacterized protein', 311, NULL, NULL, 48302),
(48303, '2.30.30.40-FF-000426', NULL, 'Peroxisomal membrane protein, putative', 70, NULL, NULL, 48303),
(48304, '3.30.750.44-FF-000011', NULL, 'Tricorn protease homolog', 69, NULL, NULL, 48304),
(48305, '2.40.128.20-FF-000045', NULL, 'CRE-LPR-2 protein', 160, NULL, NULL, 48305),
(48306, '1.10.150.530-FF-000022', NULL, 'Probable dual-specificity RNA methyltransferase RlmN', 59, NULL, NULL, 48306),
(48307, '3.20.20.70-FF-000169', NULL, 'Fatty acid synthase subunit beta', 49, NULL, NULL, 48307),
(48308, '2.170.16.10-FF-000035', NULL, 'DNA topoisomerase 1', 63, NULL, NULL, 48308),
(48309, '3.30.160.60-FF-003862', NULL, NULL, 28, NULL, NULL, 48309),
(48310, '1.25.40.10-FF-003884', NULL, 'Uncharacterized protein', 83, NULL, NULL, 48310),
(48311, '2.40.170.20-FF-000115', NULL, 'Putative outer membrane protein, probably involved in nutrient binding', 600, NULL, NULL, 48311),
(48312, '1.10.510.10-FF-001509', NULL, 'Double-stranded RNA activated protein kinase 1', 183, NULL, NULL, 48312),
(48313, '3.30.930.10-FF-000129', NULL, 'Histidine--tRNA ligase', 366, NULL, NULL, 48313),
(48314, '3.40.50.300-FF-000614', NULL, 'ATP-dependent DNA helicase', 233, NULL, NULL, 48314),
(48315, '2.130.10.10-FF-006050', NULL, 'Uncharacterized protein', 200, NULL, NULL, 48315),
(48316, '2.60.40.10-FF-005239', NULL, NULL, 89, NULL, NULL, 48316),
(48317, '2.30.29.30-FF-000566', NULL, 'Uncharacterized protein, isoform B', 165, NULL, NULL, 48317),
(48318, '3.30.1330.80-FF-000020', NULL, 'Predicted protein', 81, NULL, NULL, 48318),
(48319, '3.40.50.410-FF-000276', NULL, 'Protein transport protein SEC23', 64, NULL, NULL, 48319),
(48320, '2.60.40.10-FF-005127', NULL, NULL, 97, NULL, NULL, 48320),
(48321, '3.40.50.300-FF-004425', NULL, 'Small GTPase Rab7, putative', 174, NULL, NULL, 48321),
(48322, '1.25.40.10-FF-003772', NULL, 'Uncharacterized protein', 156, NULL, NULL, 48322),
(48323, '2.60.40.1090-FF-000025', NULL, 'Fimbrial protein', 133, NULL, NULL, 48323),
(48324, '1.25.10.10-FF-000616', NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit, putative', 592, NULL, NULL, 48324),
(48325, '1.10.390.10-FF-000111', NULL, 'GH14075p', 153, NULL, NULL, 48325),
(48326, '3.30.70.330-FF-002080', NULL, NULL, 78, NULL, NULL, 48326),
(48327, '3.80.10.10-FF-002525', NULL, 'Leucine-rich repeats and immunoglobulin-like domains protein sma-10', 142, NULL, NULL, 48327),
(48328, '3.30.70.330-FF-000646', NULL, 'U1 small nuclear ribonucleoprotein, putative', 122, NULL, NULL, 48328),
(48329, '1.10.287.70-FF-000361', NULL, 'TWiK family of potassium channels', 313, NULL, NULL, 48329),
(48330, '3.20.20.70-FF-000702', NULL, NULL, 154, NULL, NULL, 48330),
(48331, '2.60.40.10-FF-001867', NULL, 'Titin', 98, NULL, NULL, 48331),
(48332, '2.70.170.10-FF-000302', NULL, 'Uncharacterized protein', 116, NULL, NULL, 48332),
(48333, '2.30.180.10-FF-000008', NULL, 'Fasciclin-like arabinogalactan protein 10', 150, NULL, NULL, 48333),
(48334, '3.10.20.620-FF-000014', NULL, NULL, 110, NULL, NULL, 48334),
(48335, '2.60.40.10-FF-000456', NULL, 'protogenin isoform X2', 95, NULL, NULL, 48335),
(48336, '2.10.25.10-FF-000513', NULL, 'Coagulation factor VII', 54, NULL, NULL, 48336);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(48337, '1.20.970.10-FF-000035', NULL, 'Uncharacterized protein aq_209', 72, NULL, NULL, 48337),
(48338, '3.30.40.10-FF-001720', NULL, 'WD40 repeat-containing protein', 53, NULL, NULL, 48338),
(48339, '1.10.10.10-FF-000083', NULL, 'AsnC family transcriptional regulator', 53, NULL, NULL, 48339),
(48340, '1.10.3090.10-FF-000014', NULL, 'tRNA nucleotidyltransferase, putative', 212, NULL, NULL, 48340),
(48341, '3.40.50.11350-FF-000021', NULL, 'Alpha(1,6)-fucosyltransferase family protein', 79, NULL, NULL, 48341),
(48342, '3.10.20.10-FF-000039', NULL, 'Uncharacterized protein', 107, NULL, NULL, 48342),
(48343, '2.10.50.30-FF-000021', NULL, 'Vomeronasal 2, receptor 28', 73, NULL, NULL, 48343),
(48344, '3.30.160.60-FF-000001', NULL, 'Zinc finger protein 1 homolog', 28, NULL, NULL, 48344),
(48345, '3.30.160.60-FF-002238', NULL, 'zinc finger protein 606 isoform X1', 29, NULL, NULL, 48345),
(48346, '3.30.40.10-FF-000764', NULL, 'RING-H2 zinc finger protein RHA4a', 71, NULL, NULL, 48346),
(48347, '3.30.830.10-FF-000307', NULL, 'Uncharacterized protein', 111, NULL, NULL, 48347),
(48348, '2.60.120.650-FF-000068', NULL, 'UTX (Ubiquitously transcribed TPR on X) homolog', 355, NULL, NULL, 48348),
(48349, '2.10.25.10-FF-001699', NULL, 'Predicted protein', 42, NULL, NULL, 48349),
(48350, '3.30.390.50-FF-000032', NULL, 'Uncharacterized protein', 88, NULL, NULL, 48350),
(48351, '1.10.472.80-FF-000075', NULL, 'Growth hormone-regulated TBC protein 1', 134, NULL, NULL, 48351),
(48352, '1.10.555.10-FF-000073', NULL, 'SLIT-ROBO Rho GTPase-activating protein 2', 194, NULL, NULL, 48352),
(48353, '2.60.120.40-FF-000063', NULL, 'Collagen X alpha I', 46, NULL, NULL, 48353),
(48354, '1.20.58.2010-FF-000002', NULL, 'Rop guanine nucleotide exchange factor 9', 217, NULL, NULL, 48354),
(48355, '3.40.50.300-FF-007735', NULL, 'Uncharacterized protein', 84, NULL, NULL, 48355),
(48356, '3.30.160.60-FF-001041', NULL, 'Zinc finger protein 142', 60, NULL, NULL, 48356),
(48357, '2.120.10.30-FF-000047', NULL, 'Acylamino-acid-releasing enzyme', 234, NULL, NULL, 48357),
(48358, '3.70.10.10-FF-000019', NULL, 'Checkpoint protein', 286, NULL, NULL, 48358),
(48359, '1.10.1370.10-FF-000047', NULL, 'Uncharacterized protein', 115, NULL, NULL, 48359),
(48360, '1.25.40.10-FF-001063', NULL, 'Pentatricopeptide repeat-containing protein isoform A', 136, NULL, NULL, 48360),
(48361, '3.30.1120.10-FF-000017', NULL, 'Sulfatase', 68, NULL, NULL, 48361),
(48362, '1.20.1250.20-FF-000623', NULL, 'Mch2p', 194, NULL, NULL, 48362),
(48363, '3.40.140.10-FF-000174', NULL, 'Eukaryotic translation initiation factor 3 subunit H', 267, NULL, NULL, 48363),
(48364, '2.20.100.10-FF-000045', NULL, 'ADAMTS-like protein 2', 53, NULL, NULL, 48364),
(48365, '2.60.120.10-FF-000520', NULL, 'cGMP binding protein with small GTPase-serine/threonine kinase-dep-rasgef-gram-and two cGMP binding domains', 137, NULL, NULL, 48365),
(48366, '3.30.420.40-FF-000706', NULL, 'Mitochondrion protein, putative', 185, NULL, NULL, 48366),
(48367, '1.25.10.10-FF-000830', NULL, 'Importin subunit alpha, putative', 421, NULL, NULL, 48367),
(48368, '1.20.1070.10-FF-001253', NULL, 'Uncharacterized protein', 227, NULL, NULL, 48368),
(48369, '2.130.10.10-FF-003065', NULL, 'Uncharacterized protein', 132, NULL, NULL, 48369),
(48370, '3.40.50.10190-FF-000190', NULL, 'Uncharacterized protein', 114, NULL, NULL, 48370),
(48371, '3.40.50.620-FF-000463', NULL, 'Cytoplasmic tRNA 2-thiolation protein 1', 321, NULL, NULL, 48371),
(48372, '3.60.21.10-FF-000258', NULL, 'Phosphoprotein phosphatase', 269, NULL, NULL, 48372),
(48373, '3.10.100.10-FF-000324', NULL, NULL, 186, NULL, NULL, 48373),
(48374, '3.30.200.20-FF-001584', NULL, 'Receptor protein serine/threonine kinase', 54, NULL, NULL, 48374),
(48375, '2.60.120.260-FF-000479', NULL, 'Uncharacterized protein', 148, NULL, NULL, 48375),
(48376, '3.40.50.300-FF-002952', NULL, 'CBN-MAC-1 protein', 180, NULL, NULL, 48376),
(48377, '3.10.180.10-FF-000104', NULL, 'Gll3193 protein', 123, NULL, NULL, 48377),
(48378, '1.20.1300.10-FF-000035', NULL, 'Succinate dehydrogenase, hydrophobic membrane anchor protein', 110, NULL, NULL, 48378);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(48379, '2.40.70.10-FF-000094', NULL, 'Eukaryotic aspartyl protease family protein', 192, NULL, NULL, 48379),
(48380, '3.40.50.2300-FF-000819', NULL, NULL, 143, NULL, NULL, 48380),
(48381, '3.40.50.620-FF-000693', NULL, 'Predicted protein', 272, NULL, NULL, 48381),
(48382, '3.30.780.10-FF-000073', NULL, 'Exocyst complex component SEC5A', 94, NULL, NULL, 48382),
(48383, '3.30.930.10-FF-000343', NULL, 'Uncharacterized protein', 74, NULL, NULL, 48383),
(48384, '2.60.40.10-FF-003862', NULL, NULL, 85, NULL, NULL, 48384),
(48385, '1.10.630.10-FF-000259', NULL, 'Uncharacterized protein', 96, NULL, NULL, 48385),
(48386, '3.30.2290.10-FF-000001', NULL, 'Metalloprotease TldD homolog', 226, NULL, NULL, 48386),
(48387, '1.50.40.10-FF-000352', NULL, 'Predicted protein', 159, NULL, NULL, 48387),
(48388, '3.30.9.10-FF-000225', NULL, 'Uncharacterized protein', 123, NULL, NULL, 48388),
(48389, '3.80.10.10-FF-003144', NULL, 'Uncharacterized protein', 312, NULL, NULL, 48389),
(48390, '3.80.10.10-FF-001244', NULL, 'Carboxypeptidase N subunit 2', 70, NULL, NULL, 48390),
(48391, '3.30.70.330-FF-001927', NULL, NULL, 144, NULL, NULL, 48391),
(48392, '1.20.1560.10-FF-000604', NULL, 'Uncharacterized protein', 367, NULL, NULL, 48392),
(48393, '3.30.70.330-FF-001591', NULL, NULL, 108, NULL, NULL, 48393),
(48394, '1.10.3860.10-FF-000034', NULL, 'Excitatory amino acid transporter 4', 64, NULL, NULL, 48394),
(48395, '3.40.190.290-FF-000062', NULL, 'LysR family transcriptional regulator', 206, NULL, NULL, 48395),
(48396, '2.60.40.60-FF-000117', NULL, 'protocadherin-8 isoform X1', 109, NULL, NULL, 48396),
(48397, '3.90.230.10-FF-000035', NULL, 'T0096427 isoform 1', 156, NULL, NULL, 48397),
(48398, '3.30.160.60-FF-002013', NULL, 'Uncharacterized protein', 30, NULL, NULL, 48398),
(48399, '1.20.144.10-FF-000021', NULL, 'Glucose-6-phosphatase 2', 189, NULL, NULL, 48399),
(48400, '3.40.720.10-FF-000252', NULL, 'Arylsulfatase A', 89, NULL, NULL, 48400),
(48401, '1.10.10.10-FF-001504', NULL, 'Transcriptional regulator, Crp/Fnr family', 90, NULL, NULL, 48401),
(48402, '3.30.160.60-FF-005678', NULL, NULL, 26, NULL, NULL, 48402),
(48403, '2.40.50.140-FF-001014', NULL, NULL, 98, NULL, NULL, 48403),
(48404, '3.30.70.330-FF-002872', NULL, NULL, 72, NULL, NULL, 48404),
(48405, '2.40.160.210-FF-000033', NULL, 'Predicted protein', 95, NULL, NULL, 48405),
(48406, '2.130.10.10-FF-005543', NULL, 'Uncharacterized protein', 224, NULL, NULL, 48406),
(48407, '1.10.640.10-FF-000007', NULL, 'Peroxidase mlt-7', 551, NULL, NULL, 48407),
(48408, '1.20.1720.10-FF-000027', NULL, 'MFS multidrug transporter, putative', 216, NULL, NULL, 48408),
(48409, '3.30.450.20-FF-000539', NULL, 'C4-dicarboxylate transport sensor protein', 40, NULL, NULL, 48409),
(48410, '3.90.180.10-FF-000154', NULL, 'Predicted protein', 158, NULL, NULL, 48410),
(48411, '3.40.1110.10-FF-000014', NULL, 'Cation-transporting ATPase', 178, NULL, NULL, 48411),
(48412, '1.20.1070.10-FF-001236', NULL, 'frizzled-10-B-like', 365, NULL, NULL, 48412),
(48413, '3.90.550.10-FF-000194', NULL, 'Cellulose synthase-like protein G2 isoform A', 90, NULL, NULL, 48413),
(48414, '2.80.10.50-FF-000218', NULL, 'Dolichyl-phosphate-mannose--protein mannosyltransferase 1', 204, NULL, NULL, 48414),
(48415, '2.30.39.10-FF-000078', NULL, 'GM20478', 144, NULL, NULL, 48415),
(48416, '1.10.10.60-FF-001249', NULL, NULL, 88, NULL, NULL, 48416),
(48417, '3.30.1330.40-FF-000036', NULL, '2-iminobutanoate/2-iminopropanoate deaminase', 127, NULL, NULL, 48417),
(48418, '2.130.10.10-FF-003514', NULL, 'Uncharacterized protein', 191, NULL, NULL, 48418),
(48419, '2.40.30.230-FF-000003', NULL, 'Regulator of nonsense transcripts 1', 95, NULL, NULL, 48419),
(48420, '2.130.10.10-FF-001620', NULL, 'Flagellar inner dynein arm I1 intermediate chain IC140', 209, NULL, NULL, 48420),
(48421, '1.10.510.10-FF-004045', NULL, NULL, 75, NULL, NULL, 48421),
(48422, '3.50.50.60-FF-000301', NULL, 'Uncharacterized protein', 115, NULL, NULL, 48422),
(48423, '1.10.510.10-FF-001291', NULL, 'Serine/threonine protein kinase PAK, putative', 275, NULL, NULL, 48423);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(48424, '1.25.50.20-FF-000049', NULL, 'Aminopeptidase', 315, NULL, NULL, 48424),
(48425, '1.20.1050.10-FF-000285', NULL, 'Predicted protein', 138, NULL, NULL, 48425),
(48426, '2.60.40.150-FF-000600', NULL, 'Uncharacterized protein', 145, NULL, NULL, 48426),
(48427, '2.60.40.10-FF-003441', NULL, NULL, 103, NULL, NULL, 48427),
(48428, '1.10.10.1460-FF-000002', NULL, NULL, 50, NULL, NULL, 48428),
(48429, '1.20.1560.10-FF-000155', NULL, 'ATP-binding cassette transporter, subfamily B, member 2, group MDR/PGP protein PpABCB2', 141, NULL, NULL, 48429),
(48430, '3.10.129.10-FF-000199', NULL, 'HotDog domain-containing protein', 142, NULL, NULL, 48430),
(48431, '2.60.40.10-FF-000344', NULL, 'Muscle M-line assembly protein unc-89', 96, NULL, NULL, 48431),
(48432, '2.40.50.140-FF-000160', NULL, 'single-stranded DNA-binding protein, mitochondrial', 120, NULL, NULL, 48432),
(48433, '1.10.357.70-FF-000029', NULL, 'Uncharacterized protein', 164, NULL, NULL, 48433),
(48434, '1.20.1250.20-FF-001680', NULL, 'Sugar transporter ERD6-like 6', 289, NULL, NULL, 48434),
(48435, '1.10.10.10-FF-000195', NULL, 'LsrR family transcriptional regulator', 63, NULL, NULL, 48435),
(48436, '2.60.120.260-FF-000142', NULL, 'Beta-galactosidase', 128, NULL, NULL, 48436),
(48437, '3.30.160.60-FF-003778', NULL, NULL, 29, NULL, NULL, 48437),
(48438, '1.10.4160.10-FF-000026', NULL, 'Permease for cytosine/purines uracil thiamine allantoin', 440, NULL, NULL, 48438),
(48439, '3.40.50.410-FF-000304', NULL, 'Serine/threonine protein kinase PpkA', 156, NULL, NULL, 48439),
(48440, '4.10.280.10-FF-000041', NULL, 'aryl hydrocarbon receptor repressor', 58, NULL, NULL, 48440),
(48441, '1.10.238.10-FF-001039', NULL, 'Uncharacterized protein', 51, NULL, NULL, 48441),
(48442, '3.40.50.1000-FF-000087', NULL, 'Phospholipid-transporting ATPase', 190, NULL, NULL, 48442),
(48443, '2.40.50.140-FF-000188', NULL, 'mRNA capping enzyme family protein', 110, NULL, NULL, 48443),
(48444, '3.90.640.10-FF-000285', NULL, 'Predicted protein', 122, NULL, NULL, 48444),
(48445, '3.90.70.10-FF-000415', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 304, NULL, NULL, 48445),
(48446, '3.40.50.1000-FF-000183', NULL, 'Pyrimidine nucleotidase, putative', 123, NULL, NULL, 48446),
(48447, '4.10.1300.10-FF-000001', NULL, 'Dinoflagellate luciferase', 113, NULL, NULL, 48447),
(48448, '3.30.200.20-FF-000398', NULL, 'serine/threonine-protein kinase Nek9 isoform X2', 92, NULL, NULL, 48448),
(48449, '1.10.8.60-FF-000349', NULL, 'Chromosomal replication initiator protein DnaA', 72, NULL, NULL, 48449),
(48450, '1.25.40.20-FF-000205', NULL, 'Fem-1 homolog B', 234, NULL, NULL, 48450),
(48451, '1.10.340.30-FF-000069', NULL, 'Endonuclease III homolog', 73, NULL, NULL, 48451),
(48452, '2.20.80.10-FF-000005', NULL, 'Vit-6', 242, NULL, NULL, 48452),
(48453, '3.90.79.20-FF-000033', NULL, 'Uncharacterized protein', 147, NULL, NULL, 48453),
(48454, '1.10.10.10-FF-000650', NULL, 'Transcriptional regulator, RpiR family', 78, NULL, NULL, 48454),
(48455, '1.25.10.10-FF-000167', NULL, 'RNA binding protein Jsn1', 318, NULL, NULL, 48455),
(48456, '3.60.40.10-FF-000381', NULL, 'Uncharacterized protein', 213, NULL, NULL, 48456),
(48457, '1.25.40.540-FF-000020', NULL, 'Uncharacterized protein', 97, NULL, NULL, 48457),
(48458, '2.60.40.10-FF-004267', NULL, NULL, 108, NULL, NULL, 48458),
(48459, '1.10.533.10-FF-000039', NULL, 'Mucosa-associated lymphoid tissue lymphoma translocation protein 1', 98, NULL, NULL, 48459),
(48460, '3.30.2160.10-FF-000014', NULL, 'Putative E3 ubiquitin-protein ligase HECTD3', 82, NULL, NULL, 48460),
(48461, '2.20.100.10-FF-000157', NULL, 'papilin isoform X5', 54, NULL, NULL, 48461),
(48462, '3.30.710.10-FF-000265', NULL, 'GM12221', 147, NULL, NULL, 48462),
(48463, '2.60.40.10-FF-005919', NULL, NULL, 110, NULL, NULL, 48463),
(48464, '1.25.10.10-FF-002180', NULL, 'Beta-catenin-like protein 1 homolog', 468, NULL, NULL, 48464),
(48465, '3.30.413.10-FF-000029', NULL, 'Sulfite reductase hemoprotein beta component (CysI)', 143, NULL, NULL, 48465),
(48466, '2.130.10.10-FF-002446', NULL, 'Notchless', 145, NULL, NULL, 48466);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(48467, '1.20.120.1220-FF-000014', NULL, 'ComC processing protease Leader peptidase / N-methyltransferase', 166, NULL, NULL, 48467),
(48468, '1.25.40.180-FF-000232', NULL, NULL, 243, NULL, NULL, 48468),
(48469, '3.30.1640.10-FF-000045', NULL, 'DNA helicase', 100, NULL, NULL, 48469),
(48470, '3.30.70.150-FF-000002', NULL, '2,3-diketo-5-methylthiopentyl-1-phosphate enolase', 121, NULL, NULL, 48470),
(48471, '3.30.830.10-FF-000184', NULL, 'Peptidase, mitochondrial processing alpha subunit', 108, NULL, NULL, 48471),
(48472, '3.30.70.360-FF-000059', NULL, 'Dipeptidase, putative', 116, NULL, NULL, 48472),
(48473, '3.60.20.10-FF-000267', NULL, NULL, 179, NULL, NULL, 48473),
(48474, '2.40.110.10-FF-000092', NULL, 'Uncharacterized protein', 55, NULL, NULL, 48474),
(48475, '3.40.50.720-FF-000167', NULL, 'Ketol-acid reductoisomerase, mitochondrial', 205, NULL, NULL, 48475),
(48476, '1.25.10.10-FF-001235', NULL, 'CLIP-associating protein', 251, NULL, NULL, 48476),
(48477, '2.130.10.10-FF-004363', NULL, 'Uncharacterized protein', 88, NULL, NULL, 48477),
(48478, '3.30.420.110-FF-000019', NULL, 'DNA mismatch repair protein MutS', 135, NULL, NULL, 48478),
(48479, '2.130.10.10-FF-004133', NULL, 'Uncharacterized protein C4G3.03', 184, NULL, NULL, 48479),
(48480, '3.30.70.330-FF-001023', NULL, 'Pre-mRNA branch site protein p14, putative', 112, NULL, NULL, 48480),
(48481, '3.20.20.140-FF-000025', NULL, 'Dihydroorotase', 304, NULL, NULL, 48481),
(48482, '3.40.50.1820-FF-000782', NULL, 'Esterase', 245, NULL, NULL, 48482),
(48483, '3.30.70.2740-FF-000004', NULL, 'Glycolate oxidase, subunit GlcD', 82, NULL, NULL, 48483),
(48484, '3.30.497.10-FF-000021', NULL, 'Proteinase inhibitor I4 serpin', 204, NULL, NULL, 48484),
(48485, '3.90.1600.10-FF-000006', NULL, 'DNA polymerase epsilon catalytic subunit', 202, NULL, NULL, 48485),
(48486, '3.30.160.60-FF-000905', NULL, 'PR domain containing 14', 31, NULL, NULL, 48486),
(48487, '1.10.20.10-FF-000252', NULL, NULL, 66, NULL, NULL, 48487),
(48488, '3.40.50.800-FF-000073', NULL, 'Proline--tRNA ligase', 120, NULL, NULL, 48488),
(48489, '2.60.120.180-FF-000005', NULL, 'Endo-1,4-beta-xylanase', 180, NULL, NULL, 48489),
(48490, '1.25.10.10-FF-000263', NULL, 'ARM repeat superfamily protein', 530, NULL, NULL, 48490),
(48491, '2.60.40.10-FF-002013', NULL, 'KETtiN (Drosophila actin-binding) homolog', 100, NULL, NULL, 48491),
(48492, '2.20.28.10-FF-000025', NULL, 'DNA replication licensing factor MCM3', 49, NULL, NULL, 48492),
(48493, '1.20.82.10-FF-000001', NULL, 'ADP-ribosyl cyclase/cyclic ADP-ribose hydrolase 1', 119, NULL, NULL, 48493),
(48494, '1.10.10.10-FF-000987', NULL, 'Cullin family protein', 87, NULL, NULL, 48494),
(48495, '3.10.290.10-FF-000096', NULL, 'Pseudouridine synthase', 58, NULL, NULL, 48495),
(48496, '3.60.150.10-FF-000018', NULL, 'Chorismate synthase', 351, NULL, NULL, 48496),
(48497, '1.20.1270.10-FF-000048', NULL, 'Heat shock cognate protein 70', 74, NULL, NULL, 48497),
(48498, '3.50.50.60-FF-000638', NULL, 'Flavin-binding monooxygenase-like, putative', 99, NULL, NULL, 48498),
(48499, '3.10.20.30-FF-000034', NULL, 'Vanillate monooxygenase, oxidoreductase subunit', 97, NULL, NULL, 48499),
(48500, '2.60.40.10-FF-003784', NULL, NULL, 76, NULL, NULL, 48500),
(48501, '3.30.160.40-FF-000006', NULL, 'Porphobilinogen deaminase', 88, NULL, NULL, 48501),
(48502, '1.20.5.110-FF-000277', NULL, 'syntaxin-binding protein 6', 58, NULL, NULL, 48502),
(48503, '3.40.50.300-FF-002160', NULL, 'Elongator complex protein 6', 243, NULL, NULL, 48503),
(48504, '3.30.2140.20-FF-000004', NULL, 'Putative N-acetyltransferase', 250, NULL, NULL, 48504),
(48505, '3.30.160.60-FF-003199', NULL, 'Hunchback-like protein', 68, NULL, NULL, 48505),
(48506, '2.60.40.10-FF-001524', NULL, 'Uncharacterized protein, isoform B', 89, NULL, NULL, 48506),
(48507, '2.60.40.1730-FF-000049', NULL, 'TATA binding protein-associated factor, putative', 229, NULL, NULL, 48507),
(48508, '2.40.100.10-FF-000164', NULL, 'Uncharacterized protein', 187, NULL, NULL, 48508),
(48509, '3.40.50.300-FF-000726', NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase', 224, NULL, NULL, 48509);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(48510, '3.50.50.60-FF-001127', NULL, 'LOC100158500 protein', 125, NULL, NULL, 48510),
(48511, '3.90.1480.20-FF-000004', NULL, 'alpha-2,8-sialyltransferase 8E isoform X1', 284, NULL, NULL, 48511),
(48512, '3.30.70.1320-FF-000011', NULL, 'Transporter, AcrB/D/F family', 104, NULL, NULL, 48512),
(48513, '2.60.40.2030-FF-000010', NULL, 'Fraser extracellular matrix complex subunit 1', 122, NULL, NULL, 48513),
(48514, '2.60.34.10-FF-000043', NULL, 'Heat shock protein 70, putative', 193, NULL, NULL, 48514),
(48515, '3.30.1490.110-FF-000009', NULL, 'Cell division protein FtsA', 70, NULL, NULL, 48515),
(48516, '1.20.1310.10-FF-000103', NULL, 'SCF ubiquitin ligase complex subunit CulA, putative', 155, NULL, NULL, 48516),
(48517, '3.60.21.10-FF-000354', NULL, 'Uncharacterized protein', 176, NULL, NULL, 48517),
(48518, '2.130.10.10-FF-003857', NULL, 'Histone-binding protein RBBP7', 285, NULL, NULL, 48518),
(48519, '3.30.1330.20-FF-000030', NULL, 'Tubulin alpha chain', 115, NULL, NULL, 48519),
(48520, '1.25.10.10-FF-000959', NULL, 'Protein phosphatase PP2A regulatory subunit B', 150, NULL, NULL, 48520),
(48521, '2.130.10.10-FF-003418', NULL, 'Sortilin', 182, NULL, NULL, 48521),
(48522, '1.20.1250.20-FF-002068', NULL, 'Uncharacterized protein', 283, NULL, NULL, 48522),
(48523, '1.10.510.10-FF-000442', NULL, 'Testis-specific serine/threonine-protein kinase 6', 266, NULL, NULL, 48523),
(48524, '1.10.287.2070-FF-000001', NULL, 'StAR-related lipid transfer domain-containing 13', 71, NULL, NULL, 48524),
(48525, '1.25.40.10-FF-001967', NULL, 'Pentatricopeptide repeat-containing protein isoform A', 106, NULL, NULL, 48525),
(48526, '1.10.510.10-FF-003426', NULL, NULL, 288, NULL, NULL, 48526),
(48527, '1.10.3290.10-FF-000013', NULL, 'Phosphocholine transferase AnkX', 189, NULL, NULL, 48527),
(48528, '1.25.40.20-FF-001616', NULL, 'Uncharacterized protein', 101, NULL, NULL, 48528),
(48529, '3.40.50.2000-FF-000741', NULL, 'UDP-glucuronosyltransferase', 247, NULL, NULL, 48529),
(48530, '1.10.10.1100-FF-000012', NULL, 'Bacterioferritin-associated ferredoxin', 55, NULL, NULL, 48530),
(48531, '3.30.200.20-FF-001707', NULL, 'Serine/threonine-protein kinase RIO1', 48, NULL, NULL, 48531),
(48532, '3.80.10.10-FF-004537', NULL, 'F-box protein At5g03100', 163, NULL, NULL, 48532),
(48533, '1.20.58.390-FF-000074', NULL, 'Gamma-aminobutyric acid type A receptor gamma2 subunit', 136, NULL, NULL, 48533),
(48534, '1.10.10.2100-FF-000003', NULL, NULL, 33, NULL, NULL, 48534),
(48535, '3.90.1410.10-FF-000071', NULL, 'Predicted protein', 309, NULL, NULL, 48535),
(48536, '2.10.220.10-FF-000146', NULL, 'Proprotein convertase subtilisin/kexin type 5', 44, NULL, NULL, 48536),
(48537, '3.40.50.10490-FF-000061', NULL, '40S ribosomal protein S2, putative', 219, NULL, NULL, 48537),
(48538, '3.40.50.1000-FF-000750', NULL, NULL, 117, NULL, NULL, 48538),
(48539, '2.20.28.120-FF-000005', NULL, '39S ribosomal protein L33, mitochondrial', 65, NULL, NULL, 48539),
(48540, '3.40.50.10810-FF-000005', NULL, 'Photoperiod-independent early flowering 1', 276, NULL, NULL, 48540),
(48541, '1.20.1250.20-FF-000606', NULL, 'Unplaced genomic scaffold supercont2.17, whole genome shotgun sequence', 205, NULL, NULL, 48541),
(48542, '2.60.20.10-FF-000005', NULL, 'Crystallin, beta B1', 103, NULL, NULL, 48542),
(48543, '1.20.1280.50-FF-000218', NULL, 'Predicted protein', 77, NULL, NULL, 48543),
(48544, '2.10.25.10-FF-000743', NULL, 'Si:dkey-220k22.1', 48, NULL, NULL, 48544),
(48545, '3.90.650.10-FF-000027', NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase', 221, NULL, NULL, 48545),
(48546, '1.20.890.10-FF-000001', NULL, 'cAMP-dependent protein kinase type I-alpha regulatory subunit', 58, NULL, NULL, 48546),
(48547, '3.30.428.10-FF-000058', NULL, 'APTX isoform 28', 48, NULL, NULL, 48547),
(48548, '2.40.33.10-FF-000042', NULL, 'Pyruvate kinase', 46, NULL, NULL, 48548),
(48549, '1.25.10.10-FF-001578', NULL, 'Exportin-6-B-like Protein', 587, NULL, NULL, 48549),
(48550, '1.10.30.10-FF-000078', NULL, 'ARS-binding factor', 78, NULL, NULL, 48550),
(48551, '3.30.70.260-FF-000147', NULL, 'Aspartokinase', 49, NULL, NULL, 48551);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(48552, '3.30.160.60-FF-001524', NULL, 'Zinc finger protein 8', 31, NULL, NULL, 48552),
(48553, '1.10.8.60-FF-000006', NULL, '26S protease regulatory subunit 8', 78, NULL, NULL, 48553),
(48554, '2.40.70.10-FF-000577', NULL, NULL, 56, NULL, NULL, 48554),
(48555, '3.40.50.300-FF-003571', NULL, 'ABC transporter, ATP-binding protein', 232, NULL, NULL, 48555),
(48556, '3.30.70.330-FF-003052', NULL, NULL, 112, NULL, NULL, 48556),
(48557, '3.40.50.300-FF-001671', NULL, 'Type IV secretion system protein VirD4', 235, NULL, NULL, 48557),
(48558, '3.30.420.40-FF-000044', NULL, 'Actin-like 6a isoform 3', 122, NULL, NULL, 48558),
(48559, '1.25.40.10-FF-005227', NULL, 'Uncharacterized protein', 186, NULL, NULL, 48559),
(48560, '3.50.50.60-FF-001257', NULL, 'Salicylate monooxygenase-related protein', 112, NULL, NULL, 48560),
(48561, '1.50.40.10-FF-000482', NULL, 'Uncharacterized protein', 279, NULL, NULL, 48561),
(48562, '4.10.240.10-FF-000044', NULL, 'Pyrimidine pathway regulatory protein 1', 62, NULL, NULL, 48562),
(48563, '3.30.760.10-FF-000088', NULL, 'Predicted protein', 126, NULL, NULL, 48563),
(48564, '2.10.110.10-FF-000025', NULL, 'Cysteine-rich protein 2', 75, NULL, NULL, 48564),
(48565, '2.30.30.40-FF-000409', NULL, 'Uncharacterized protein', 73, NULL, NULL, 48565),
(48566, '3.40.50.1950-FF-000012', NULL, 'Flavin prenyltransferase UbiX', 196, NULL, NULL, 48566),
(48567, '1.10.630.10-FF-000389', NULL, 'Cytochrome P450, putative (Eurofung)', 211, NULL, NULL, 48567),
(48568, '1.10.150.240-FF-000042', NULL, 'Haloacid dehalogenase-like hydrolase domain-containing protein At4g39970', 98, NULL, NULL, 48568),
(48569, '1.20.930.10-FF-000038', NULL, 'Uncharacterized protein', 139, NULL, NULL, 48569),
(48570, '3.80.10.10-FF-000608', NULL, 'Leucine-rich repeat family protein', 242, NULL, NULL, 48570),
(48571, '1.20.1640.10-FF-000077', NULL, 'Transmembrane transport protein MmpL3', 195, NULL, NULL, 48571),
(48572, '1.10.220.110-FF-000003', NULL, 'GDNF family receptor alpha 4', 108, NULL, NULL, 48572),
(48573, '1.10.220.10-FF-000015', NULL, 'Annexin', 71, NULL, NULL, 48573),
(48574, '3.30.160.360-FF-000012', NULL, 'Hypothetical_protein_-_conserved', 163, NULL, NULL, 48574),
(48575, '2.60.120.620-FF-000042', NULL, 'Phytanoyl-CoA dioxygenase (PhyH)', 273, NULL, NULL, 48575),
(48576, '1.20.1560.10-FF-000947', NULL, 'Uncharacterized protein', 245, NULL, NULL, 48576),
(48577, '3.60.10.10-FF-000109', NULL, 'Endonuclease/exonuclease/phosphatase family protein', 291, NULL, NULL, 48577),
(48578, '2.60.120.560-FF-000030', NULL, 'Chromosome 9, whole genome shotgun sequence', 151, NULL, NULL, 48578),
(48579, '2.40.30.170-FF-000075', NULL, NULL, 65, NULL, NULL, 48579),
(48580, '1.10.3720.10-FF-000103', NULL, 'ABC transporter permease, nitrate/sulfonate/bicarbonate transport', 194, NULL, NULL, 48580),
(48581, '3.40.190.10-FF-000817', NULL, 'Uncharacterized protein', 18, NULL, NULL, 48581),
(48582, '3.40.50.300-FF-004088', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 250, NULL, NULL, 48582),
(48583, '1.25.40.10-FF-004710', NULL, 'Uncharacterized protein', 93, NULL, NULL, 48583),
(48584, '1.20.140.40-FF-000021', NULL, 'Probable pectinesterase/pectinesterase inhibitor 51', 150, NULL, NULL, 48584),
(48585, '3.40.50.300-FF-003599', NULL, 'Shikimate kinase', 179, NULL, NULL, 48585),
(48586, '3.30.160.60-FF-004930', NULL, NULL, 33, NULL, NULL, 48586),
(48587, '1.10.510.10-FF-002600', NULL, NULL, 177, NULL, NULL, 48587),
(48588, '1.10.472.10-FF-000678', NULL, 'Putative cyclin-Y-like protein 3', 192, NULL, NULL, 48588),
(48589, '3.30.460.10-FF-000155', NULL, 'Os06g0319600 protein', 56, NULL, NULL, 48589),
(48590, '1.20.1560.10-FF-000716', NULL, 'Predicted protein', 346, NULL, NULL, 48590),
(48591, '3.60.10.10-FF-000340', NULL, 'Uncharacterized protein', 212, NULL, NULL, 48591),
(48592, '1.20.1410.10-FF-000037', NULL, 'Uncharacterized protein', 63, NULL, NULL, 48592),
(48593, '3.60.21.10-FF-000146', NULL, 'Serine/threonine-protein phosphatase', 311, NULL, NULL, 48593),
(48594, '3.30.70.1350-FF-000003', NULL, 'Cation diffusion facilitator 1', 81, NULL, NULL, 48594); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(48595, '2.60.120.10-FF-000065', NULL, 'HTH-type transcriptional regulator ChbR', 88, NULL, NULL, 48595),
(48596, '1.10.3210.10-FF-000025', NULL, 'Exopolyphosphatase', 197, NULL, NULL, 48596),
(48597, '3.30.160.60-FF-006167', NULL, NULL, 74, NULL, NULL, 48597),
(48598, '1.10.510.10-FF-001852', NULL, 'Uncharacterized protein', 152, NULL, NULL, 48598),
(48599, '3.30.70.330-FF-002321', NULL, NULL, 116, NULL, NULL, 48599),
(48600, '3.20.20.70-FF-000253', NULL, 'Nicotinate phosphoribosyltransferase', 175, NULL, NULL, 48600),
(48601, '3.40.50.1000-FF-000879', NULL, NULL, 178, NULL, NULL, 48601),
(48602, '2.60.40.10-FF-003992', NULL, NULL, 100, NULL, NULL, 48602),
(48603, '3.40.50.720-FF-000829', NULL, 'Glyoxylate reductase', 85, NULL, NULL, 48603),
(48604, '1.25.10.10-FF-000055', NULL, 'AP-3 complex subunit delta', 589, NULL, NULL, 48604),
(48605, '2.30.29.170-FF-000013', NULL, 'Uncharacterized protein', 112, NULL, NULL, 48605),
(48606, '2.60.120.430-FF-000002', NULL, 'Leucine-rich repeat receptor-like protein kinase', 192, NULL, NULL, 48606),
(48607, '2.90.10.10-FF-000032', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase SD3-1', 120, NULL, NULL, 48607),
(48608, '3.40.50.150-FF-000288', NULL, 'Spermine/spermidine synthase, putative', 228, NULL, NULL, 48608),
(48609, '3.30.870.10-FF-000080', NULL, 'Probable tyrosyl-DNA phosphodiesterase', 235, NULL, NULL, 48609),
(48610, '2.60.40.10-FF-000799', NULL, 'Semaphorin 4G', 84, NULL, NULL, 48610),
(48611, '3.40.50.300-FF-003924', NULL, 'Protein peanut', 298, NULL, NULL, 48611),
(48612, '3.90.70.10-FF-000078', NULL, 'Ubiquitin carboxyl-terminal hydrolase 23', 313, NULL, NULL, 48612),
(48613, '3.40.50.720-FF-001353', NULL, 'Retinol dehydrogenase 7', 82, NULL, NULL, 48613),
(48614, '3.30.470.20-FF-000086', NULL, 'inositol-tetrakisphosphate 1-kinase isoform X1', 80, NULL, NULL, 48614),
(48615, '3.10.280.10-FF-000039', NULL, 'Uncharacterized protein', 173, NULL, NULL, 48615),
(48616, '2.60.40.10-FF-004610', NULL, NULL, 122, NULL, NULL, 48616),
(48617, '1.20.140.90-FF-000007', NULL, 'Uncharacterized protein', 151, NULL, NULL, 48617),
(48618, '1.10.10.10-FF-001616', NULL, 'DEP domain-containing protein DDB_G0279099', 162, NULL, NULL, 48618),
(48619, '3.40.50.2300-FF-001207', NULL, NULL, 84, NULL, NULL, 48619),
(48620, '3.30.420.40-FF-000156', NULL, 'Phosphotransferase', 167, NULL, NULL, 48620),
(48621, '2.60.40.10-FF-000905', NULL, 'Ankyrin repeat and fibronectin type III domain containing 1', 112, NULL, NULL, 48621),
(48622, '3.40.250.10-FF-000064', NULL, 'Chromosome 1, whole genome shotgun sequence', 152, NULL, NULL, 48622),
(48623, '3.80.10.10-FF-002396', NULL, 'Uncharacterized protein', 87, NULL, NULL, 48623),
(48624, '2.10.25.10-FF-001570', NULL, 'Uncharacterized protein', 47, NULL, NULL, 48624),
(48625, '2.10.25.10-FF-000951', NULL, 'Integrin beta', 41, NULL, NULL, 48625),
(48626, '2.60.40.790-FF-000213', NULL, NULL, 133, NULL, NULL, 48626),
(48627, '3.70.10.10-FF-000036', NULL, 'Uncharacterized protein', 254, NULL, NULL, 48627),
(48628, '3.40.50.150-FF-000400', NULL, 'Glutathione S-transferase C-terminal domain-containing protein', 174, NULL, NULL, 48628),
(48629, '2.10.60.10-FF-000072', NULL, 'Lymphocyte antigen 6 family member E', 41, NULL, NULL, 48629),
(48630, '3.40.390.10-FF-000237', NULL, NULL, 77, NULL, NULL, 48630),
(48631, '1.10.220.20-FF-000001', NULL, 'IQ motif and SEC7 domain-containing protein 1', 95, NULL, NULL, 48631),
(48632, '3.40.720.10-FF-000140', NULL, 'Predicted protein', 389, NULL, NULL, 48632),
(48633, '1.10.10.440-FF-000090', NULL, 'ADR159Cp', 63, NULL, NULL, 48633),
(48634, '2.60.120.290-FF-000134', NULL, 'GD12774', 122, NULL, NULL, 48634),
(48635, '1.10.20.10-FF-000021', NULL, 'Histone H2A', 133, NULL, NULL, 48635),
(48636, '3.30.360.10-FF-000007', NULL, 'D-erythrose-4-phosphate dehydrogenase', 165, NULL, NULL, 48636),
(48637, '3.10.620.30-FF-000015', NULL, 'Protein-glutamine gamma-glutamyltransferase', 194, NULL, NULL, 48637),
(48638, '2.130.10.10-FF-003626', NULL, 'Dynein, axonemal, intermediate chain 1, paralog 1', 176, NULL, NULL, 48638);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(48639, '3.20.20.70-FF-000247', NULL, 'Pyridoxine 5''-phosphate synthase', 241, NULL, NULL, 48639),
(48640, '1.25.40.10-FF-000091', NULL, 'Pre-mRNA-processing factor 39', 176, NULL, NULL, 48640),
(48641, '3.30.10.20-FF-000018', NULL, 'Serine/threonine-protein kinase PrkC', 68, NULL, NULL, 48641),
(48642, '1.10.510.10-FF-000234', NULL, 'Citron rho-interacting serine/threonine kinase', 200, NULL, NULL, 48642),
(48643, '2.30.29.30-FF-001067', NULL, 'DAB adaptor protein 2', 75, NULL, NULL, 48643),
(48644, '3.10.250.10-FF-000099', NULL, NULL, 108, NULL, NULL, 48644),
(48645, '3.30.50.10-FF-000023', NULL, 'Vitamin D3 receptor', 110, NULL, NULL, 48645),
(48646, '3.30.160.60-FF-005548', NULL, NULL, 34, NULL, NULL, 48646),
(48647, '3.20.90.10-FF-000009', NULL, NULL, 148, NULL, NULL, 48647),
(48648, '3.30.40.10-FF-002338', NULL, 'Uncharacterized protein', 94, NULL, NULL, 48648),
(48649, '1.10.510.10-FF-001953', NULL, 'Uncharacterized protein', 195, NULL, NULL, 48649),
(48650, '3.20.20.80-FF-000155', NULL, '1,3-beta-glucanosyltransferase', 357, NULL, NULL, 48650),
(48651, '3.10.110.10-FF-000038', NULL, 'SUMO-conjugating enzyme SCE1', 158, NULL, NULL, 48651),
(48652, '1.20.140.10-FF-000135', NULL, 'Predicted protein', 61, NULL, NULL, 48652),
(48653, '3.40.50.300-FF-005369', NULL, 'Primosomal protein N''', 182, NULL, NULL, 48653),
(48654, '4.10.400.10-FF-000158', NULL, 'LDL receptor related protein 2', 40, NULL, NULL, 48654),
(48655, '1.10.30.10-FF-000106', NULL, 'Zgc:165618 protein', 62, NULL, NULL, 48655),
(48656, '3.40.50.10810-FF-000213', NULL, 'Uncharacterized protein', 92, NULL, NULL, 48656),
(48657, '3.50.50.60-FF-000397', NULL, 'Probable monooxygenase', 140, NULL, NULL, 48657),
(48658, '3.40.50.300-FF-001783', NULL, 'DNA repair protein RecN', 312, NULL, NULL, 48658),
(48659, '3.40.190.10-FF-000126', NULL, 'Transcriptional regulator, LysR family', 103, NULL, NULL, 48659),
(48660, '1.10.10.1800-FF-000008', NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', 91, NULL, NULL, 48660),
(48661, '3.30.160.60-FF-003418', NULL, 'Zinc finger protein 407', 65, NULL, NULL, 48661),
(48662, '1.20.5.420-FF-000010', NULL, 'Truncated muramidase-released protein', 82, NULL, NULL, 48662),
(48663, '2.20.70.10-FF-000179', NULL, 'YALI0C19404p', 62, NULL, NULL, 48663),
(48664, '3.30.70.260-FF-000035', NULL, 'Modulator protein MzrA', 81, NULL, NULL, 48664),
(48665, '2.60.420.10-FF-000009', NULL, 'Alpha-L-rhamnosidase B, putative', 76, NULL, NULL, 48665),
(48666, '1.10.533.10-FF-000011', NULL, 'Myeloid cell nuclear differentiation antigen', 95, NULL, NULL, 48666),
(48667, '2.60.40.10-FF-001737', NULL, 'CD226 molecule', 119, NULL, NULL, 48667),
(48668, '3.40.220.30-FF-000001', NULL, 'Orf1a polyprotein', 131, NULL, NULL, 48668),
(48669, '3.40.50.2300-FF-000269', NULL, 'Sugar ABC transporter substrate-binding protein', 133, NULL, NULL, 48669),
(48670, '1.25.40.10-FF-001175', NULL, 'Pentatricopeptide repeat-containing protein At1g19720', 127, NULL, NULL, 48670),
(48671, '3.90.190.10-FF-000429', NULL, 'Uncharacterized protein', 76, NULL, NULL, 48671),
(48672, '1.10.287.70-FF-000259', NULL, 'Sodium channel protein', 134, NULL, NULL, 48672),
(48673, '2.60.40.1120-FF-000080', NULL, 'Carboxypeptidase M', 54, NULL, NULL, 48673),
(48674, '3.40.50.300-FF-007623', NULL, 'Uncharacterized protein', 148, NULL, NULL, 48674),
(48675, '3.30.160.60-FF-006280', NULL, NULL, 50, NULL, NULL, 48675),
(48676, '3.30.40.10-FF-000197', NULL, 'E3 ubiquitin-protein ligase RNF152', 87, NULL, NULL, 48676),
(48677, '1.10.400.10-FF-000001', NULL, 'Guanine nucleotide-binding protein G(I) subunit alpha', 119, NULL, NULL, 48677),
(48678, '1.20.1070.10-FF-000168', NULL, 'Cholecystokinin receptor type A', 218, NULL, NULL, 48678),
(48679, '1.20.120.730-FF-000001', NULL, 'Protein transport protein SEC23', 141, NULL, NULL, 48679),
(48680, '3.20.190.10-FF-000007', NULL, 'DNA glycosylase', 125, NULL, NULL, 48680),
(48681, '3.30.160.60-FF-004722', NULL, NULL, 24, NULL, NULL, 48681),
(48682, '3.30.420.10-FF-000052', NULL, 'DNA polymerase', 197, NULL, NULL, 48682);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(48683, '3.30.70.2020-FF-000002', NULL, 'Phosphoserine phosphatase', 105, NULL, NULL, 48683),
(48684, '3.30.420.150-FF-000003', NULL, 'ectonucleoside triphosphate diphosphohydrolase 7', 295, NULL, NULL, 48684),
(48685, '3.80.10.10-FF-000951', NULL, 'SCF E3 ubiquitin ligase complex F-box protein GRR1', 265, NULL, NULL, 48685),
(48686, '3.20.20.60-FF-000149', NULL, 'Citrate lyase beta-like', 119, NULL, NULL, 48686),
(48687, '2.60.40.10-FF-000113', NULL, 'Opioid-binding protein/cell adhesion molecule', 81, NULL, NULL, 48687),
(48688, '1.20.1250.20-FF-002309', NULL, 'Chromosome 19, whole genome shotgun sequence', 167, NULL, NULL, 48688),
(48689, '3.30.160.60-FF-002581', NULL, 'Zinc finger protein 407', 26, NULL, NULL, 48689),
(48690, '3.40.50.790-FF-000013', NULL, '50S ribosomal protein L1', 94, NULL, NULL, 48690),
(48691, '3.10.20.90-FF-000349', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 80, NULL, NULL, 48691),
(48692, '1.10.10.60-FF-001154', NULL, NULL, 53, NULL, NULL, 48692),
(48693, '3.40.50.300-FF-002514', NULL, 'GTP-binding protein', 207, NULL, NULL, 48693),
(48694, '2.60.40.10-FF-003654', NULL, NULL, 101, NULL, NULL, 48694),
(48695, '2.10.25.10-FF-001250', NULL, 'Uncharacterized protein', 41, NULL, NULL, 48695),
(48696, '2.40.50.40-FF-000118', NULL, 'CHD gene family protein containing chromodomain, helicase domain, and DNA-binding domain', 83, NULL, NULL, 48696),
(48697, '2.60.120.330-FF-000062', NULL, '2-oxoglutarate-dependent dioxygenase AOP3', 129, NULL, NULL, 48697),
(48698, '3.80.10.10-FF-000159', NULL, 'Ras suppressor protein 1', 123, NULL, NULL, 48698),
(48699, '1.10.510.10-FF-002572', NULL, NULL, 243, NULL, NULL, 48699),
(48700, '2.10.25.10-FF-001362', NULL, 'Notch receptor 3', 41, NULL, NULL, 48700),
(48701, '1.25.10.10-FF-001347', NULL, 'HEAT repeat-containing protein', 321, NULL, NULL, 48701),
(48702, '3.20.20.80-FF-000582', NULL, 'Uncharacterized protein', 258, NULL, NULL, 48702),
(48703, '3.90.226.10-FF-000160', NULL, 'Chromosome 19, whole genome shotgun sequence', 259, NULL, NULL, 48703),
(48704, '3.30.2350.10-FF-000068', NULL, 'Trans-splicing factor Raa2, chloroplastic', 76, NULL, NULL, 48704),
(48705, '1.20.120.350-FF-000191', NULL, NULL, 97, NULL, NULL, 48705),
(48706, '3.40.50.620-FF-000249', NULL, 'Ethanolamine-phosphate cytidylyltransferase', 193, NULL, NULL, 48706),
(48707, '1.10.268.10-FF-000018', NULL, 'DNA topoisomerase 2', 195, NULL, NULL, 48707),
(48708, '3.40.50.1000-FF-000306', NULL, 'HAD family phosphatase', 111, NULL, NULL, 48708),
(48709, '1.20.1740.10-FF-000141', NULL, 'Uncharacterized protein', 448, NULL, NULL, 48709),
(48710, '1.20.140.150-FF-000117', NULL, 'Uncharacterized protein', 121, NULL, NULL, 48710),
(48711, '2.130.10.30-FF-000086', NULL, 'BTB/POZ domain/Regulator of chromosome condensation (RCC1) repeat, putative', 210, NULL, NULL, 48711),
(48712, '1.20.58.70-FF-000120', NULL, 'Syntaxin-132', 115, NULL, NULL, 48712),
(48713, '3.60.21.10-FF-000466', NULL, 'Serine/threonine-protein phosphatase', 129, NULL, NULL, 48713),
(48714, '1.20.910.10-FF-000043', NULL, 'Bsl7393 protein', 66, NULL, NULL, 48714),
(48715, '3.40.430.10-FF-000050', NULL, 'Riboflavin biosynthesis protein RibD', 217, NULL, NULL, 48715),
(48716, '1.20.1070.10-FF-001005', NULL, 'Uncharacterized protein', 356, NULL, NULL, 48716),
(48717, '2.60.120.970-FF-000046', NULL, 'Uncharacterized protein', 201, NULL, NULL, 48717),
(48718, '3.30.160.60-FF-003750', NULL, 'Zgc:174234 protein', 27, NULL, NULL, 48718),
(48719, '4.10.280.10-FF-000069', NULL, 'Transcription factor PIF7', 63, NULL, NULL, 48719),
(48720, '3.30.200.20-FF-001128', NULL, 'Non-specific serine/threonine protein kinase', 34, NULL, NULL, 48720),
(48721, '1.20.120.140-FF-000032', NULL, 'Cell division protein FtsY homolog chloroplastic', 56, NULL, NULL, 48721),
(48722, '2.60.40.150-FF-000021', NULL, 'dysferlin isoform X2', 123, NULL, NULL, 48722),
(48723, '1.10.472.130-FF-000037', NULL, 'Flagellar inner arm dynein 1 heavy chain alpha', 163, NULL, NULL, 48723),
(48724, '1.20.120.450-FF-000006', NULL, NULL, 167, NULL, NULL, 48724);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(48725, '1.20.5.170-FF-000137', NULL, 'Unplaced genomic scaffold supercont2.16, whole genome shotgun sequence', 55, NULL, NULL, 48725),
(48726, '3.80.20.20-FF-000101', NULL, 'Predicted protein', 211, NULL, NULL, 48726),
(48727, '2.40.30.30-FF-000007', NULL, 'Riboflavin kinase', 165, NULL, NULL, 48727),
(48728, '3.30.70.20-FF-000027', NULL, 'Electron transport protein hydN', 64, NULL, NULL, 48728),
(48729, '2.60.40.10-FF-005335', NULL, NULL, 74, NULL, NULL, 48729),
(48730, '1.20.58.2220-FF-000059', NULL, 'Si:ch1073-209e23.1', 87, NULL, NULL, 48730),
(48731, '2.40.50.140-FF-000738', NULL, NULL, 123, NULL, NULL, 48731),
(48732, '1.10.150.120-FF-000023', NULL, NULL, 100, NULL, NULL, 48732),
(48733, '1.10.720.30-FF-000036', NULL, 'Plastid transcriptionally active 3', 56, NULL, NULL, 48733),
(48734, '1.20.1250.20-FF-001112', NULL, 'MFS transporter', 371, NULL, NULL, 48734),
(48735, '1.10.510.10-FF-002145', NULL, 'Receptor tyrosine kinase-like protein', 304, NULL, NULL, 48735),
(48736, '3.90.1110.10-FF-000036', NULL, NULL, 63, NULL, NULL, 48736),
(48737, '1.10.40.90-FF-000001', NULL, 'DNA-directed RNA polymerase subunit beta', 42, NULL, NULL, 48737),
(48738, '1.10.1450.10-FF-000109', NULL, 'Tetraspanin', 103, NULL, NULL, 48738),
(48739, '2.40.30.10-FF-000001', NULL, 'Elongation factor Tu', 130, NULL, NULL, 48739),
(48740, '3.30.160.60-FF-001069', NULL, 'zinc finger protein 217', 24, NULL, NULL, 48740),
(48741, '3.40.50.720-FF-001448', NULL, 'GDP-mannose 4,6 dehydratase', 41, NULL, NULL, 48741),
(48742, '3.30.160.60-FF-006072', NULL, NULL, 49, NULL, NULL, 48742),
(48743, '1.10.287.110-FF-000126', NULL, 'Cell division related protein-like', 110, NULL, NULL, 48743),
(48744, '3.30.40.10-FF-000860', NULL, 'Plus-3 domain/Zinc finger', 71, NULL, NULL, 48744),
(48745, '2.130.10.10-FF-001592', NULL, 'Anaphase-promoting complex component Cut20/Apc4, putative', 283, NULL, NULL, 48745),
(48746, '3.30.70.100-FF-000015', NULL, 'Potassium efflux system KefA', 95, NULL, NULL, 48746),
(48747, '3.10.129.10-FF-000087', NULL, 'Thioesterase family protein', 127, NULL, NULL, 48747),
(48748, '3.80.10.10-FF-002767', NULL, 'Uncharacterized protein', 218, NULL, NULL, 48748),
(48749, '1.10.630.10-FF-000591', NULL, 'Uncharacterized protein', 289, NULL, NULL, 48749),
(48750, '2.60.40.10-FF-002356', NULL, 'Protein roller-3', 115, NULL, NULL, 48750),
(48751, '1.10.150.50-FF-000004', NULL, 'PTPRF interacting protein alpha 1', 96, NULL, NULL, 48751),
(48752, '3.30.70.100-FF-000139', NULL, NULL, 70, NULL, NULL, 48752),
(48753, '3.30.70.330-FF-001815', NULL, NULL, 108, NULL, NULL, 48753),
(48754, '2.30.30.380-FF-000073', NULL, 'Protein transport protein SEC23', 56, NULL, NULL, 48754),
(48755, '2.160.20.10-FF-000231', NULL, 'Uncharacterized protein', 241, NULL, NULL, 48755),
(48756, '1.10.10.10-FF-001717', NULL, 'Response regulator receiver and SARP domain protein', 107, NULL, NULL, 48756),
(48757, '3.50.50.60-FF-000189', NULL, 'Monomeric sarcosine oxidase', 206, NULL, NULL, 48757),
(48758, '2.60.40.10-FF-001625', NULL, 'titin isoform X1', 89, NULL, NULL, 48758),
(48759, '3.40.50.1000-FF-000295', NULL, 'Phosphatidyl synthase, putative', 97, NULL, NULL, 48759),
(48760, '3.30.160.60-FF-001496', NULL, 'zinc finger protein 581', 28, NULL, NULL, 48760),
(48761, '1.10.10.10-FF-000644', NULL, 'DNA-binding response regulator', 95, NULL, NULL, 48761),
(48762, '3.40.20.10-FF-000105', NULL, 'Protein flightless-1 homolog', 105, NULL, NULL, 48762),
(48763, '3.40.1080.20-FF-000002', NULL, 'Acetyl-CoA hydrolase/transferase', 146, NULL, NULL, 48763),
(48764, '1.20.120.1910-FF-000036', NULL, 'Cysteine--tRNA ligase', 155, NULL, NULL, 48764),
(48765, '3.80.10.10-FF-003014', NULL, 'LRR F-box protein MAX2a', 176, NULL, NULL, 48765),
(48766, '1.20.120.1750-FF-000050', NULL, 'RBR-type E3 ubiquitin transferase', 88, NULL, NULL, 48766),
(48767, '3.30.1370.110-FF-000016', NULL, 'DNA mismatch repair protein MutS', 133, NULL, NULL, 48767),
(48768, '3.30.200.20-FF-000055', NULL, 'Receptor protein serine/threonine kinase', 117, NULL, NULL, 48768),
(48769, '3.40.50.2000-FF-000286', NULL, 'UDP-glucuronosyltransferase 3A2', 250, NULL, NULL, 48769);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(48770, '3.30.40.10-FF-001933', NULL, 'Ligand of numb-protein X 2b', 70, NULL, NULL, 48770),
(48771, '3.20.20.105-FF-000025', NULL, 'Predicted protein', 63, NULL, NULL, 48771),
(48772, '1.25.40.20-FF-001841', NULL, 'Uncharacterized protein', 144, NULL, NULL, 48772),
(48773, '3.40.30.10-FF-000617', NULL, 'Protein disulfide isomerase family A member 3', 112, NULL, NULL, 48773),
(48774, '3.30.160.60-FF-000552', NULL, 'Zinc finger protein 131', 35, NULL, NULL, 48774),
(48775, '1.25.10.10-FF-002516', NULL, 'Uncharacterized protein', 194, NULL, NULL, 48775),
(48776, '1.25.40.10-FF-000787', NULL, 'CHIP', 108, NULL, NULL, 48776),
(48777, '3.40.50.1240-FF-000136', NULL, NULL, 243, NULL, NULL, 48777),
(48778, '3.30.420.10-FF-000260', NULL, 'DNA polymerase catalytic subunit', 231, NULL, NULL, 48778),
(48779, '2.120.10.80-FF-000040', NULL, 'Kelch-like family member 22', 312, NULL, NULL, 48779),
(48780, '3.30.160.20-FF-000231', NULL, 'Predicted protein', 67, NULL, NULL, 48780),
(48781, '1.10.1600.10-FF-000026', NULL, 'Ku70-like protein', 93, NULL, NULL, 48781),
(48782, '1.10.510.10-FF-003089', NULL, NULL, 199, NULL, NULL, 48782),
(48783, '3.90.550.10-FF-000531', NULL, 'Uncharacterized protein', 102, NULL, NULL, 48783),
(48784, '2.60.120.650-FF-000040', NULL, 'lysine-specific demethylase JMJ25 isoform X1', 361, NULL, NULL, 48784),
(48785, '3.40.50.300-FF-008011', NULL, 'Molybdopterin-guanine dinucleotide biosynthesis protein B/molybdopterin converting factor, large subunit', 143, NULL, NULL, 48785),
(48786, '3.30.160.60-FF-001962', NULL, 'Zinc finger and SCAN domain-containing protein 32', 28, NULL, NULL, 48786),
(48787, '1.10.1070.11-FF-000003', NULL, 'Phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit beta', 198, NULL, NULL, 48787),
(48788, '1.10.238.10-FF-000634', NULL, 'Calpain 8', 170, NULL, NULL, 48788),
(48789, '3.40.50.1240-FF-000030', NULL, 'Lysophosphatidic acid phosphatase type 6', 389, NULL, NULL, 48789),
(48790, '1.10.287.70-FF-000602', NULL, 'Uncharacterized protein', 89, NULL, NULL, 48790),
(48791, '2.60.40.420-FF-000136', NULL, 'Predicted protein', 107, NULL, NULL, 48791),
(48792, '2.60.40.1180-FF-000069', NULL, 'Glucosidase II', 102, NULL, NULL, 48792),
(48793, '3.40.50.1260-FF-000018', NULL, 'Phosphoglycerate kinase', 167, NULL, NULL, 48793),
(48794, '3.40.50.80-FF-000156', NULL, 'Predicted protein', 153, NULL, NULL, 48794),
(48795, '2.130.10.10-FF-002789', NULL, 'Predicted protein', 211, NULL, NULL, 48795),
(48796, '3.90.550.10-FF-000295', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 394, NULL, NULL, 48796),
(48797, '3.10.28.10-FF-000034', NULL, 'Probable intron-encoded DNA endonuclease aI1', 124, NULL, NULL, 48797),
(48798, '3.30.40.10-FF-000995', NULL, 'Zinc finger domain containing protein', 84, NULL, NULL, 48798),
(48799, '1.20.1560.10-FF-000498', NULL, 'ABC transporter', 229, NULL, NULL, 48799),
(48800, '2.40.50.140-FF-000637', NULL, 'Polyribonucleotide nucleotidyltransferase', 101, NULL, NULL, 48800),
(48801, '3.20.20.70-FF-000141', NULL, 'D-tagatose-1,6-bisphosphate aldolase subunit GatZ', 268, NULL, NULL, 48801),
(48802, '3.40.1160.10-FF-000045', NULL, 'Glutamate 5-kinase, variant', 91, NULL, NULL, 48802),
(48803, '1.25.40.90-FF-000075', NULL, 'VHS domain containing protein, putative', 155, NULL, NULL, 48803),
(48804, '2.170.270.10-FF-000145', NULL, 'Histone-lysine N-methyltransferase', 244, NULL, NULL, 48804),
(48805, '3.80.10.10-FF-001339', NULL, 'Leucine-rich repeat protein SHOC-2', 79, NULL, NULL, 48805),
(48806, '1.50.10.10-FF-000075', NULL, 'alpha-1,2-Mannosidase', 516, NULL, NULL, 48806),
(48807, '1.10.3380.10-FF-000003', NULL, 'SEC63 homolog, protein translocation regulator', 156, NULL, NULL, 48807),
(48808, '3.30.470.20-FF-000198', NULL, 'Tubulin glycylase 3F', 233, NULL, NULL, 48808),
(48809, '1.20.120.150-FF-000006', NULL, 'Phosphatidylinositol 3-kinase-like protein', 83, NULL, NULL, 48809),
(48810, '2.120.10.80-FF-000146', NULL, 'tRNA wybutosine-synthesizing protein 2/3/4', 144, NULL, NULL, 48810),
(48811, '1.10.455.10-FF-000037', NULL, 'Uncharacterized protein', 68, NULL, NULL, 48811);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(48812, '2.130.10.10-FF-001165', NULL, 'WD repeat-containing protein 63 isoform X3', 225, NULL, NULL, 48812),
(48813, '1.25.40.10-FF-003980', NULL, 'Predicted protein', 343, NULL, NULL, 48813),
(48814, '3.90.76.10-FF-000024', NULL, 'Peptide ABC transporter permease protein', 125, NULL, NULL, 48814),
(48815, '3.30.160.60-FF-006403', NULL, NULL, 29, NULL, NULL, 48815),
(48816, '1.10.8.10-FF-000115', NULL, 'DNA damage-inducible protein', 42, NULL, NULL, 48816),
(48817, '3.90.640.10-FF-000190', NULL, 'Actin-related protein 5', 57, NULL, NULL, 48817),
(48818, '3.40.50.1820-FF-001850', NULL, 'Uncharacterized protein', 64, NULL, NULL, 48818),
(48819, '1.10.1070.11-FF-000109', NULL, 'Predicted protein', 197, NULL, NULL, 48819),
(48820, '1.25.40.10-FF-002344', NULL, 'GD21537', 112, NULL, NULL, 48820),
(48821, '3.30.200.20-FF-001679', NULL, 'Protein kinase, putative', 79, NULL, NULL, 48821),
(48822, '1.10.10.60-FF-000069', NULL, 'MYB transcription factor', 57, NULL, NULL, 48822),
(48823, '3.40.50.300-FF-006454', NULL, 'Structural maintenance of chromosomes protein 1A', 121, NULL, NULL, 48823),
(48824, '1.20.140.100-FF-000030', NULL, 'GM10109', 154, NULL, NULL, 48824),
(48825, '3.30.420.10-FF-000613', NULL, NULL, 178, NULL, NULL, 48825),
(48826, '3.30.300.110-FF-000004', NULL, 'tRNA (guanine(37)-N1)-methyltransferase', 78, NULL, NULL, 48826),
(48827, '3.80.10.10-FF-000390', NULL, 'fibromodulin', 221, NULL, NULL, 48827),
(48828, '3.10.105.10-FF-000060', NULL, 'ABC transporter substrate-binding protein', 221, NULL, NULL, 48828),
(48829, '2.10.25.10-FF-000058', NULL, 'Fibrillin 2', 36, NULL, NULL, 48829),
(48830, '1.20.120.1200-FF-000020', NULL, 'NADH-quinone oxidoreductase subunit J', 162, NULL, NULL, 48830),
(48831, '3.30.200.20-FF-001336', NULL, 'Non-specific serine/threonine protein kinase', 41, NULL, NULL, 48831),
(48832, '3.20.20.70-FF-000618', NULL, NULL, 246, NULL, NULL, 48832),
(48833, '3.30.40.10-FF-000652', NULL, 'E3 ubiquitin-protein ligase', 67, NULL, NULL, 48833),
(48834, '3.40.50.1980-FF-000004', NULL, 'Histidinol dehydrogenase', 222, NULL, NULL, 48834),
(48835, '4.10.400.10-FF-000034', NULL, 'Low-density lipoprotein receptor-related protein 2', 40, NULL, NULL, 48835),
(48836, '3.10.20.90-FF-000006', NULL, 'Polyubiquitin 10', 76, NULL, NULL, 48836),
(48837, '1.10.640.10-FF-000092', NULL, 'NADPH thyroid oxidase 2', 343, NULL, NULL, 48837),
(48838, '2.30.39.10-FF-000162', NULL, 'Uncharacterized protein', 78, NULL, NULL, 48838),
(48839, '3.30.230.130-FF-000033', NULL, 'Cullin family-like protein', 162, NULL, NULL, 48839),
(48840, '3.30.505.10-FF-000187', NULL, NULL, 51, NULL, NULL, 48840),
(48841, '3.40.50.360-FF-000137', NULL, 'NADPH-dependent FMN reductase', 186, NULL, NULL, 48841),
(48842, '3.80.10.10-FF-001671', NULL, 'Leucine rich repeat neuronal 3', 268, NULL, NULL, 48842),
(48843, '1.10.472.80-FF-000081', NULL, 'CRE-TAG-236 protein', 151, NULL, NULL, 48843),
(48844, '3.80.10.10-FF-000058', NULL, 'immunoglobulin superfamily containing leucine-rich repeat protein 2', 234, NULL, NULL, 48844),
(48845, '3.30.420.10-FF-000158', NULL, 'Ribonuclease H', 167, NULL, NULL, 48845),
(48846, '3.40.630.30-FF-000616', NULL, 'Predicted protein', 194, NULL, NULL, 48846),
(48847, '3.30.160.380-FF-000001', NULL, 'Endoribonuclease dicer-like 1', 97, NULL, NULL, 48847),
(48848, '3.30.310.50-FF-000044', NULL, 'Phosphomannomutase', 83, NULL, NULL, 48848),
(48849, '1.10.443.10-FF-000021', NULL, 'Site-specific recombinase, phage integrase family', 102, NULL, NULL, 48849),
(48850, '3.40.309.10-FF-000049', NULL, 'Aldehyde dehydrogenase', 191, NULL, NULL, 48850),
(48851, '3.30.420.270-FF-000022', NULL, 'Putative biopolymer transmembrane protein', 69, NULL, NULL, 48851),
(48852, '4.10.240.10-FF-000156', NULL, 'Dal81p', 70, NULL, NULL, 48852),
(48853, '2.30.30.100-FF-000129', NULL, 'U6 snRNA-associated Sm-like protein LSm4', 78, NULL, NULL, 48853),
(48854, '3.90.1150.10-FF-000488', NULL, '3,4-dihydroxyphenylacetaldehyde synthase 2', 30, NULL, NULL, 48854),
(48855, '1.25.40.10-FF-001164', NULL, 'mRNA splicing factor (Prp1/Zer1), putative (AFU_orthologue AFUA_2G06070)', 423, NULL, NULL, 48855);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(48856, '3.70.10.10-FF-000120', NULL, 'Zgc:56197', 173, NULL, NULL, 48856),
(48857, '3.40.50.300-FF-005948', NULL, 'DExH-box helicase 34', 101, NULL, NULL, 48857),
(48858, '3.40.50.300-FF-007634', NULL, 'Uncharacterized protein', 143, NULL, NULL, 48858),
(48859, '1.10.10.10-FF-001398', NULL, 'Cadmium resistance transcriptional regulatory protein CadC', 89, NULL, NULL, 48859),
(48860, '1.25.40.10-FF-000444', NULL, 'Pentatricopeptide repeat-containing protein', 103, NULL, NULL, 48860),
(48861, '2.130.10.10-FF-000316', NULL, 'Plexin C1', 407, NULL, NULL, 48861),
(48862, '3.10.400.20-FF-000018', NULL, 'Malignant T-cell-amplified sequence 1 homolog', 180, NULL, NULL, 48862),
(48863, '3.40.50.300-FF-008354', NULL, 'Uncharacterized protein', 189, NULL, NULL, 48863),
(48864, '3.40.50.300-FF-000373', NULL, 'Cytoplasmic dynein heavy chain 2', 125, NULL, NULL, 48864),
(48865, '1.10.630.10-FF-000714', NULL, 'Cytochrome P450 1B', 110, NULL, NULL, 48865),
(48866, '1.10.1750.10-FF-000014', NULL, NULL, 88, NULL, NULL, 48866),
(48867, '3.40.140.10-FF-000062', NULL, 'tRNA-specific adenosine deaminase-like protein 3', 154, NULL, NULL, 48867),
(48868, '2.60.120.200-FF-000282', NULL, 'BEACH-DOMAIN HOMOLOG A1', 130, NULL, NULL, 48868),
(48869, '3.30.200.20-FF-000156', NULL, 'MAP kinase-activated protein kinase 3', 96, NULL, NULL, 48869),
(48870, '1.20.1250.10-FF-000053', NULL, 'Growth hormone 2', 189, NULL, NULL, 48870),
(48871, '3.90.105.10-FF-000019', NULL, 'Molybdopterin molybdenumtransferase', 57, NULL, NULL, 48871),
(48872, '2.130.10.10-FF-002688', NULL, 'Uncharacterized protein', 335, NULL, NULL, 48872),
(48873, '2.40.20.10-FF-000063', NULL, 'Uncharacterized protein', 83, NULL, NULL, 48873),
(48874, '2.130.10.10-FF-005094', NULL, 'Uncharacterized protein', 256, NULL, NULL, 48874),
(48875, '3.30.1330.60-FF-000042', NULL, 'Peptidoglycan associated lipoprotein', 111, NULL, NULL, 48875),
(48876, '3.40.630.30-FF-000037', NULL, 'N-alpha-acetyltransferase daf-31-like', 167, NULL, NULL, 48876),
(48877, '1.20.58.400-FF-000032', NULL, 'Uncharacterized protein', 95, NULL, NULL, 48877),
(48878, '1.25.70.10-FF-000042', NULL, 'Mitochondrial transcription termination factor 2', 165, NULL, NULL, 48878),
(48879, '3.30.930.10-FF-000259', NULL, 'Threonine--tRNA ligase, chloroplastic/mitochondrial 2 isoform B', 210, NULL, NULL, 48879),
(48880, '3.10.25.10-FF-000011', NULL, 'Methionyl-tRNA formyltransferase', 107, NULL, NULL, 48880),
(48881, '2.40.70.10-FF-000122', NULL, 'Plasmepsin VII', 160, NULL, NULL, 48881),
(48882, '1.20.5.2050-FF-000002', NULL, 'Transcription factor with AP2 domain(S)', 50, NULL, NULL, 48882),
(48883, '3.40.30.10-FF-001123', NULL, 'Chloride intracellular channel 4', 109, NULL, NULL, 48883),
(48884, '1.50.40.10-FF-000144', NULL, 'Mitochondrial glycine transporter', 202, NULL, NULL, 48884),
(48885, '1.20.1250.20-FF-000595', NULL, 'MFS transporter, putative', 467, NULL, NULL, 48885),
(48886, '2.40.10.10-FF-000225', NULL, 'GD19101', 236, NULL, NULL, 48886),
(48887, '3.40.50.2300-FF-001663', NULL, NULL, 175, NULL, NULL, 48887),
(48888, '1.25.10.10-FF-000375', NULL, 'Predicted protein', 1143, NULL, NULL, 48888),
(48889, '2.130.10.10-FF-003969', NULL, 'Uncharacterized protein', 238, NULL, NULL, 48889),
(48890, '3.30.200.20-FF-001792', NULL, 'Uncharacterized protein', 138, NULL, NULL, 48890),
(48891, '1.10.540.10-FF-000062', NULL, 'Flavin-dependent monooxygenase, oxygenase subunit HsaA', 114, NULL, NULL, 48891),
(48892, '3.80.10.10-FF-004442', NULL, 'Uncharacterized protein', 123, NULL, NULL, 48892),
(48893, '1.10.20.10-FF-000364', NULL, NULL, 87, NULL, NULL, 48893),
(48894, '2.30.42.10-FF-000546', NULL, NULL, 93, NULL, NULL, 48894),
(48895, '1.10.10.10-FF-000436', NULL, 'ArsR family transcriptional regulator', 100, NULL, NULL, 48895),
(48896, '2.40.50.100-FF-000176', NULL, 'Uncharacterized protein', 80, NULL, NULL, 48896),
(48897, '1.25.40.840-FF-000003', NULL, 'Transcription regulator', 169, NULL, NULL, 48897),
(48898, '3.20.20.140-FF-000137', NULL, 'Protein CBG19874', 189, NULL, NULL, 48898),
(48899, '3.30.40.10-FF-002097', NULL, 'Uncharacterized protein', 79, NULL, NULL, 48899); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(48900, '2.40.10.10-FF-000101', NULL, 'Genome polyprotein', 106, NULL, NULL, 48900),
(48901, '1.25.40.20-FF-000104', NULL, 'Ankyrin 2, isoform G', 412, NULL, NULL, 48901),
(48902, '2.10.110.10-FF-000267', NULL, 'LIM homeobox 2a', 69, NULL, NULL, 48902),
(48903, '3.40.50.1010-FF-000073', NULL, 'Ribonuclease VapC', 132, NULL, NULL, 48903),
(48904, '3.40.50.12710-FF-000007', NULL, 'SAM-dependent methyltransferase', 365, NULL, NULL, 48904),
(48905, '3.60.20.10-FF-000155', NULL, 'Asparagine synthetase (Eurofung)', 211, NULL, NULL, 48905),
(48906, '2.60.40.150-FF-000364', NULL, 'Sperm vesicle fusion protein fer-1', 173, NULL, NULL, 48906),
(48907, '3.40.50.300-FF-006797', NULL, 'Uncharacterized protein', 54, NULL, NULL, 48907),
(48908, '1.25.40.10-FF-002001', NULL, 'Pentatricopeptide repeat-containing protein At1g79490, mitochondrial', 132, NULL, NULL, 48908),
(48909, '4.10.860.120-FF-000029', NULL, 'DNA-directed RNA polymerase subunit', 122, NULL, NULL, 48909),
(48910, '2.60.40.1930-FF-000002', NULL, 'PZP, alpha-2-macroglobulin like', 109, NULL, NULL, 48910),
(48911, '3.40.50.2020-FF-000033', NULL, 'Xanthine phosphoribosyltransferase 1', 204, NULL, NULL, 48911),
(48912, '3.80.10.10-FF-002188', NULL, 'Uncharacterized protein', 127, NULL, NULL, 48912),
(48913, '2.60.40.10-FF-001636', NULL, 'Tyrosine-protein kinase receptor', 62, NULL, NULL, 48913),
(48914, '1.20.1000.10-FF-000001', NULL, 'Guanylate binding protein 1', 296, NULL, NULL, 48914),
(48915, '1.10.10.60-FF-000524', NULL, 'cDNA FLJ16624 fis, clone TESTI4015442, moderately similar to Mus musculus zinc finger homeodomain 4 (Zfh4-pending)', 66, NULL, NULL, 48915),
(48916, '1.20.1270.60-FF-000041', NULL, 'F-BAR and double SH3 domains protein 1', 273, NULL, NULL, 48916),
(48917, '3.40.50.300-FF-003020', NULL, 'SNF2-related domain-containing protein', 305, NULL, NULL, 48917),
(48918, '3.30.565.10-FF-000516', NULL, 'Uncharacterized protein', 171, NULL, NULL, 48918),
(48919, '1.25.40.10-FF-001725', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 96, NULL, NULL, 48919),
(48920, '3.40.50.1100-FF-000111', NULL, 'Threonine synthase', 228, NULL, NULL, 48920),
(48921, '1.10.510.10-FF-003668', NULL, NULL, 177, NULL, NULL, 48921),
(48922, '2.60.120.1000-FF-000027', NULL, 'Predicted protein', 193, NULL, NULL, 48922),
(48923, '1.10.1520.10-FF-000104', NULL, 'Uncharacterized protein', 115, NULL, NULL, 48923),
(48924, '2.130.10.10-FF-003306', NULL, 'Chromosome 12, whole genome shotgun sequence', 252, NULL, NULL, 48924),
(48925, '3.90.79.10-FF-000047', NULL, 'Transient receptor potential cation channel subfamily M member 2', 158, NULL, NULL, 48925),
(48926, '3.20.20.70-FF-000039', NULL, 'N-acetylneuraminate lyase', 293, NULL, NULL, 48926),
(48927, '1.20.5.100-FF-000032', NULL, 'Integrin beta', 66, NULL, NULL, 48927),
(48928, '3.40.50.1820-FF-001619', NULL, 'Os04g0381400 protein', 59, NULL, NULL, 48928),
(48929, '3.40.50.150-FF-000743', NULL, 'Protein with similarity to HEN1 (Arabidopsis thaliana)', 257, NULL, NULL, 48929),
(48930, '3.90.190.10-FF-000323', NULL, 'Chromosome 16, whole genome shotgun sequence', 333, NULL, NULL, 48930),
(48931, '3.40.50.720-FF-002078', NULL, 'Fatty acyl-CoA reductase', 144, NULL, NULL, 48931),
(48932, '3.40.1110.10-FF-000222', NULL, 'Cation-transporting ATPase', 145, NULL, NULL, 48932),
(48933, '3.30.230.10-FF-000346', NULL, 'Uncharacterized protein', 29, NULL, NULL, 48933),
(48934, '3.40.50.300-FF-007073', NULL, 'Uncharacterized protein', 193, NULL, NULL, 48934),
(48935, '1.10.10.10-FF-000206', NULL, '1-phosphatidylinositol 3-phosphate 5-kinase isoform X1', 133, NULL, NULL, 48935),
(48936, '2.60.40.60-FF-000089', NULL, 'FAT atypical cadherin 1', 107, NULL, NULL, 48936),
(48937, '1.10.472.80-FF-000103', NULL, 'TBC Kinase homolog', 121, NULL, NULL, 48937),
(48938, '1.20.1560.10-FF-000363', NULL, 'Multidrug resistance-associated protein 1', 330, NULL, NULL, 48938),
(48939, '1.25.10.10-FF-001336', NULL, 'Uncharacterized protein', 411, NULL, NULL, 48939),
(48940, '1.10.150.20-FF-000006', NULL, 'DNA ligase', 79, NULL, NULL, 48940);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(48941, '1.20.5.710-FF-000018', NULL, '50S ribosomal protein L7/L12', 50, NULL, NULL, 48941),
(48942, '3.40.50.620-FF-000704', NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', 241, NULL, NULL, 48942),
(48943, '2.30.110.10-FF-000043', NULL, 'Uncharacterized protein', 257, NULL, NULL, 48943),
(48944, '3.40.720.10-FF-000038', NULL, 'Arylsulfatase AtsA', 459, NULL, NULL, 48944),
(48945, '1.10.238.10-FF-000179', NULL, 'EF-hand calcium-binding domain-containing protein 6', 76, NULL, NULL, 48945),
(48946, '2.10.25.10-FF-001019', NULL, 'Uncharacterized protein', 41, NULL, NULL, 48946),
(48947, '2.30.30.190-FF-000004', NULL, 'Putative ubiquitin carboxyl-terminal hydrolase CYLD', 72, NULL, NULL, 48947),
(48948, '1.20.120.1080-FF-000068', NULL, 'ATP-dependent RNA helicase, putative', 158, NULL, NULL, 48948),
(48949, '2.40.50.90-FF-000083', NULL, 'Staphylococcal nuclease domain-containing protein', 165, NULL, NULL, 48949),
(48950, '3.90.182.10-FF-000001', NULL, 'Protective antigen', 258, NULL, NULL, 48950),
(48951, '3.50.50.60-FF-001015', NULL, 'Glycerol-3-phosphate dehydrogenase', 167, NULL, NULL, 48951),
(48952, '2.60.120.260-FF-000030', NULL, 'Reelin', 154, NULL, NULL, 48952),
(48953, '1.10.8.60-FF-000433', NULL, 'ORC1-type DNA replication protein 6', 91, NULL, NULL, 48953),
(48954, '3.40.50.720-FF-001561', NULL, 'Uncharacterized protein', 249, NULL, NULL, 48954),
(48955, '3.30.70.120-FF-000010', NULL, 'Divalent cation tolerance protein, CutA1 family', 106, NULL, NULL, 48955),
(48956, '3.40.50.20-FF-000054', NULL, 'SyNapsiN', 100, NULL, NULL, 48956),
(48957, '1.20.58.1880-FF-000030', NULL, 'Myb domain-containing protein', 101, NULL, NULL, 48957),
(48958, '3.40.50.1000-FF-000536', NULL, NULL, 194, NULL, NULL, 48958),
(48959, '1.20.1070.10-FF-000960', NULL, 'Uncharacterized protein', 339, NULL, NULL, 48959),
(48960, '1.10.10.10-FF-000779', NULL, 'Histone acetyltransferase', 71, NULL, NULL, 48960),
(48961, '3.30.40.10-FF-001478', NULL, 'MIZ/SP-RING zinc finger, putative', 121, NULL, NULL, 48961),
(48962, '3.30.67.10-FF-000005', NULL, 'Genome polyprotein', 81, NULL, NULL, 48962),
(48963, '3.90.70.10-FF-000314', NULL, 'Ubiquitinyl hydrolase 1', 159, NULL, NULL, 48963),
(48964, '3.30.200.20-FF-000499', NULL, 'Cdc2-related protein kinase 4', 101, NULL, NULL, 48964),
(48965, '2.30.29.30-FF-000903', NULL, 'FERM, RhoGEF (ARHGEF) and pleckstrin domain protein 1 (chondrocyte-derived)', 127, NULL, NULL, 48965),
(48966, '3.10.110.10-FF-000370', NULL, 'Histone acetyltransferase type B catalytic subunit', 121, NULL, NULL, 48966),
(48967, '3.40.50.1440-FF-000084', NULL, 'Tubulin/FtsZ family, C-terminal domain containing protein', 128, NULL, NULL, 48967),
(48968, '2.130.10.10-FF-002345', NULL, 'Protein phosphatase PP2A regulatory subunit B', 210, NULL, NULL, 48968),
(48969, '3.30.70.2850-FF-000037', NULL, 'DNA-directed RNA polymerase subunit', 236, NULL, NULL, 48969),
(48970, '2.40.50.120-FF-000070', NULL, 'Uncharacterized protein', 17, NULL, NULL, 48970),
(48971, '1.25.40.10-FF-003193', NULL, 'Pentatricopeptide repeat-containing protein isoform A', 94, NULL, NULL, 48971),
(48972, '4.10.1000.10-FF-000085', NULL, 'FI03239p', 66, NULL, NULL, 48972),
(48973, '1.10.8.60-FF-000557', NULL, 'Uncharacterized protein', 97, NULL, NULL, 48973),
(48974, '2.60.530.10-FF-000001', NULL, 'Surface protein adhesin', 337, NULL, NULL, 48974),
(48975, '1.20.1070.10-FF-000067', NULL, 'G-protein coupled receptor 12', 278, NULL, NULL, 48975),
(48976, '1.10.1270.20-FF-000003', NULL, 'tRNA (guanine-N(1)-)-methyltransferase', 54, NULL, NULL, 48976),
(48977, '1.10.10.10-FF-001055', NULL, 'IclR family transcriptional regulator', 78, NULL, NULL, 48977),
(48978, '2.60.120.920-FF-000042', NULL, 'neuralized-like protein 2 isoform X1', 166, NULL, NULL, 48978),
(48979, '1.20.1730.10-FF-000067', NULL, 'High affinity choline transporter, putative', 139, NULL, NULL, 48979),
(48980, '3.40.50.300-FF-005605', NULL, 'Dynein heavy chain 14, axonemal', 58, NULL, NULL, 48980),
(48981, '3.40.50.150-FF-001592', NULL, NULL, 275, NULL, NULL, 48981),
(48982, '3.40.50.150-FF-000182', NULL, 'Nicotianamine synthase', 273, NULL, NULL, 48982);
INSERT INTO "PUBLIC"."MODEL" VALUES
(48983, '3.90.320.10-FF-000042', NULL, 'DNA helicase II', 205, NULL, NULL, 48983),
(48984, '3.40.30.10-FF-000162', NULL, 'Glutathione S-transferase Gst3', 175, NULL, NULL, 48984),
(48985, '2.60.40.10-FF-001069', NULL, 'Fibronectin 1', 86, NULL, NULL, 48985),
(48986, '3.40.50.620-FF-000917', NULL, 'Electron transfer flavoprotein subunit alpha mitochondrial', 77, NULL, NULL, 48986),
(48987, '3.30.200.20-FF-001808', NULL, NULL, 86, NULL, NULL, 48987),
(48988, '2.60.120.200-FF-000388', NULL, 'Anti-tumor lectin', 159, NULL, NULL, 48988),
(48989, '1.20.1440.340-FF-000014', NULL, 'AGAP012567-PA', 118, NULL, NULL, 48989),
(48990, '1.10.8.720-FF-000035', NULL, 'Putative dynein heavy chain', 130, NULL, NULL, 48990),
(48991, '3.80.20.20-FF-000106', NULL, 'Predicted protein', 170, NULL, NULL, 48991),
(48992, '3.40.50.300-FF-000934', NULL, 'ADP-ribosylation factor-like 15 isoform X1', 173, NULL, NULL, 48992),
(48993, '1.10.418.10-FF-000171', NULL, 'dixin isoform X1', 113, NULL, NULL, 48993),
(48994, '2.40.37.10-FF-000039', NULL, 'Probable diaminopimelate decarboxylase', 153, NULL, NULL, 48994),
(48995, '2.60.260.20-FF-000011', NULL, 'DnaJ homolog subfamily A member 1', 70, NULL, NULL, 48995),
(48996, '3.40.720.10-FF-000376', NULL, 'Predicted protein', 298, NULL, NULL, 48996),
(48997, '3.20.20.80-FF-000604', NULL, 'Uncharacterized protein', 183, NULL, NULL, 48997),
(48998, '3.40.50.300-FF-001446', NULL, 'DsDNA exonuclease SbcC', 157, NULL, NULL, 48998),
(48999, '1.20.1250.40-FF-000045', NULL, 'Uncharacterized protein', 111, NULL, NULL, 48999),
(49000, '1.10.3410.10-FF-000001', NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase', 127, NULL, NULL, 49000),
(49001, '2.40.150.20-FF-000007', NULL, '50S ribosomal protein L14', 139, NULL, NULL, 49001),
(49002, '1.10.10.10-FF-001268', NULL, 'Ferric uptake regulator, Fur family', 85, NULL, NULL, 49002),
(49003, '3.40.50.2000-FF-000954', NULL, 'Uncharacterized protein', 109, NULL, NULL, 49003),
(49004, '2.70.150.10-FF-000071', NULL, 'Phospholipid-transporting ATPase', 141, NULL, NULL, 49004),
(49005, '3.30.70.3400-FF-000006', NULL, 'Protein translocase subunit SecD', 87, NULL, NULL, 49005),
(49006, '1.20.120.1200-FF-000025', NULL, 'NADH-quinone oxidoreductase subunit J', 157, NULL, NULL, 49006),
(49007, '1.10.8.10-FF-000227', NULL, 'Ubiquitin family protein', 48, NULL, NULL, 49007),
(49008, '1.10.3090.10-FF-000020', NULL, 'Bifunctional uridylyltransferase/uridylyl-removing enzyme', 193, NULL, NULL, 49008),
(49009, '3.10.20.620-FF-000008', NULL, 'Autophagy protein 5', 78, NULL, NULL, 49009),
(49010, '2.130.10.10-FF-000535', NULL, 'Eukaryotic translation initiation factor 2 alpha kinase 3', 172, NULL, NULL, 49010),
(49011, '2.30.29.30-FF-000797', NULL, 'Uncharacterized protein', 83, NULL, NULL, 49011),
(49012, '3.30.160.60-FF-002137', NULL, 'Specific RNA polymerase II transcription factor', 30, NULL, NULL, 49012),
(49013, '3.40.50.10490-FF-000167', NULL, NULL, 113, NULL, NULL, 49013),
(49014, '3.65.10.20-FF-000023', NULL, 'RNA terminal phosphate cyclase-like 1', 87, NULL, NULL, 49014),
(49015, '1.20.120.350-FF-000196', NULL, NULL, 125, NULL, NULL, 49015),
(49016, '1.25.10.10-FF-003472', NULL, 'Uncharacterized protein', 225, NULL, NULL, 49016),
(49017, '3.30.40.210-FF-000003', NULL, 'Transcription elongation factor SPT4', 101, NULL, NULL, 49017),
(49018, '3.40.640.10-FF-000324', NULL, 'Predicted protein', 76, NULL, NULL, 49018),
(49019, '4.10.240.10-FF-000050', NULL, 'C6 transcription factor, putative', 68, NULL, NULL, 49019),
(49020, '3.20.20.70-FF-000489', NULL, NULL, 129, NULL, NULL, 49020),
(49021, '1.20.58.60-FF-000667', NULL, 'Microtubule-actin cross-linking factor 1, isoforms 1/2/3/5', 81, NULL, NULL, 49021),
(49022, '2.70.170.10-FF-000066', NULL, 'Glutamate-gated ChLoride channel', 217, NULL, NULL, 49022),
(49023, '3.80.10.10-FF-000614', NULL, 'polycystin-1 isoform X2', 152, NULL, NULL, 49023),
(49024, '1.10.1200.10-FF-000046', NULL, 'Nonribosomal peptide synthetase easA', 77, NULL, NULL, 49024),
(49025, '1.10.486.10-FF-000064', NULL, 'DNA helicase', 170, NULL, NULL, 49025);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(49026, '3.40.50.300-FF-007859', NULL, 'Uncharacterized protein', 211, NULL, NULL, 49026),
(49027, '2.60.40.10-FF-005447', NULL, NULL, 92, NULL, NULL, 49027),
(49028, '3.30.160.60-FF-002244', NULL, 'Zinc finger protein 625', 29, NULL, NULL, 49028),
(49029, '1.25.40.1040-FF-000037', NULL, 'N-terminal acetyltransferase A complex subunit NAT1, putative', 433, NULL, NULL, 49029),
(49030, '3.40.1060.10-FF-000009', NULL, 'Uncharacterized protein', 81, NULL, NULL, 49030),
(49031, '3.30.40.10-FF-001377', NULL, 'NHL repeat containing E3 ubiquitin protein ligase 1', 79, NULL, NULL, 49031),
(49032, '2.60.40.150-FF-000471', NULL, 'Uncharacterized protein', 129, NULL, NULL, 49032),
(49033, '1.20.1270.260-FF-000001', NULL, 'Uncharacterized protein', 84, NULL, NULL, 49033),
(49034, '3.10.20.310-FF-000022', NULL, 'Outer membrane protein', 88, NULL, NULL, 49034),
(49035, '1.20.1070.10-FF-001028', NULL, 'Uncharacterized protein', 257, NULL, NULL, 49035),
(49036, '3.30.40.10-FF-000865', NULL, 'CHD3-type chromatin-remodeling factor PICKLE', 54, NULL, NULL, 49036),
(49037, '1.20.1560.10-FF-000368', NULL, 'Predicted protein', 191, NULL, NULL, 49037),
(49038, '3.30.160.60-FF-001625', NULL, 'Zinc finger protein 569', 27, NULL, NULL, 49038),
(49039, '2.130.10.10-FF-003290', NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', 358, NULL, NULL, 49039),
(49040, '3.30.160.60-FF-001732', NULL, 'Zgc:162936', 29, NULL, NULL, 49040),
(49041, '3.40.50.150-FF-001480', NULL, NULL, 126, NULL, NULL, 49041),
(49042, '3.30.1330.30-FF-000151', NULL, 'Uncharacterized protein', 184, NULL, NULL, 49042),
(49043, '1.10.1100.10-FF-000005', NULL, 'Uncharacterized protein', 58, NULL, NULL, 49043),
(49044, '3.30.40.10-FF-000972', NULL, 'RING-type E3 ubiquitin transferase', 75, NULL, NULL, 49044),
(49045, '2.40.30.170-FF-000069', NULL, NULL, 95, NULL, NULL, 49045),
(49046, '1.20.1070.10-FF-000516', NULL, 'Uncharacterized protein', 331, NULL, NULL, 49046),
(49047, '2.20.100.10-FF-000146', NULL, 'CBN-PPN-1 protein', 61, NULL, NULL, 49047),
(49048, '2.20.28.120-FF-000011', NULL, 'Mrpl39p', 70, NULL, NULL, 49048),
(49049, '2.60.120.200-FF-000495', NULL, 'Laminin subunit alpha 1', 190, NULL, NULL, 49049),
(49050, '3.30.9.10-FF-000012', NULL, 'Dimethylglycine dehydrogenase, mitochondrial', 170, NULL, NULL, 49050),
(49051, '1.20.1560.10-FF-000475', NULL, 'ABC-type multidrug/protein/lipid transport system, ATPase component', 319, NULL, NULL, 49051),
(49052, '1.25.40.10-FF-003081', NULL, 'Uncharacterized protein', 177, NULL, NULL, 49052),
(49053, '1.25.40.20-FF-001846', NULL, 'Poly [ADP-ribose] polymerase', 140, NULL, NULL, 49053),
(49054, '1.10.510.10-FF-001515', NULL, 'Serine/threonine protein kinase', 311, NULL, NULL, 49054),
(49055, '3.20.20.80-FF-000599', NULL, 'Glycoside hydrolase, putative', 193, NULL, NULL, 49055),
(49056, '3.30.300.110-FF-000009', NULL, 'tRNA (Guanine(37)-N1)-methyltransferase Trm5b', 81, NULL, NULL, 49056),
(49057, '3.30.160.60-FF-006408', NULL, NULL, 41, NULL, NULL, 49057),
(49058, '3.40.1110.10-FF-000227', NULL, NULL, 63, NULL, NULL, 49058),
(49059, '1.25.40.10-FF-003985', NULL, 'N-ethylmaleimide-sensitive factor attachment protein, beta a', 216, NULL, NULL, 49059),
(49060, '2.30.30.1150-FF-000022', NULL, 'Uncharacterized protein', 138, NULL, NULL, 49060),
(49061, '4.10.1240.10-FF-000075', NULL, 'Uncharacterized protein', 67, NULL, NULL, 49061),
(49062, '1.10.287.3160-FF-000002', NULL, NULL, 143, NULL, NULL, 49062),
(49063, '3.40.50.1820-FF-000445', NULL, 'Lecithin-cholesterol acyltransferase', 180, NULL, NULL, 49063),
(49064, '1.10.630.10-FF-000046', NULL, 'Cytochrome P450 90A1', 450, NULL, NULL, 49064),
(49065, '2.60.40.10-FF-004161', NULL, NULL, 89, NULL, NULL, 49065),
(49066, '3.40.50.10260-FF-000008', NULL, 'Multifunctional fusion protein', 209, NULL, NULL, 49066),
(49067, '1.20.140.160-FF-000002', NULL, 'RNA polymerase sigma factor RpoH', 158, NULL, NULL, 49067),
(49068, '3.30.200.20-FF-000611', NULL, 'Protein kinase, putative', 126, NULL, NULL, 49068),
(49069, '2.10.70.10-FF-000241', NULL, 'Complement factor B', 59, NULL, NULL, 49069);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(49070, '1.20.1270.280-FF-000007', NULL, 'dynein heavy chain 2, axonemal', 167, NULL, NULL, 49070),
(49071, '2.30.29.30-FF-000802', NULL, 'Wiskott-Aldrich syndrome, like', 144, NULL, NULL, 49071),
(49072, '3.30.2350.20-FF-000054', NULL, NULL, 117, NULL, NULL, 49072),
(49073, '3.30.230.10-FF-000110', NULL, 'DNA topoisomerase 2', 119, NULL, NULL, 49073),
(49074, '1.10.10.60-FF-000305', NULL, 'AraC family transcriptional regulator', 107, NULL, NULL, 49074),
(49075, '1.20.970.10-FF-000029', NULL, 'Anthranilate phosphoribosyltransferase', 69, NULL, NULL, 49075),
(49076, '2.30.40.10-FF-000143', NULL, 'Alpha-D-ribose 1-methylphosphonate 5-triphosphate diphosphatase', 38, NULL, NULL, 49076),
(49077, '1.25.40.20-FF-000329', NULL, 'No mechanoreceptor potential C, isoform D', 151, NULL, NULL, 49077),
(49078, '1.10.287.3240-FF-000037', NULL, 'Uncharacterized protein', 215, NULL, NULL, 49078),
(49079, '3.40.50.10470-FF-000072', NULL, 'Translation initiation factor eif-2b alpha subunit', 202, NULL, NULL, 49079),
(49080, '3.40.50.1820-FF-000338', NULL, 'Uncharacterized protein', 321, NULL, NULL, 49080),
(49081, '3.80.10.10-FF-000496', NULL, 'Thyrotropin receptor', 314, NULL, NULL, 49081),
(49082, '3.40.50.10330-FF-000058', NULL, 'Diacylglycerol kinase', 132, NULL, NULL, 49082),
(49083, '3.40.50.300-FF-001339', NULL, 'Mitochondrial ribosome-associated GTPase 2', 178, NULL, NULL, 49083),
(49084, '3.40.1020.10-FF-000001', NULL, 'L-threonine dehydratase', 178, NULL, NULL, 49084),
(49085, '1.10.287.810-FF-000004', NULL, 'Mitochondrial import inner membrane translocase subunit Tim9', 89, NULL, NULL, 49085),
(49086, '3.30.160.210-FF-000001', NULL, 'Nuclease SbcCD subunit D', 61, NULL, NULL, 49086),
(49087, '3.30.200.20-FF-001915', NULL, 'Predicted protein', 79, NULL, NULL, 49087),
(49088, '1.25.40.470-FF-000083', NULL, 'Predicted protein', 182, NULL, NULL, 49088),
(49089, '2.60.120.330-FF-000079', NULL, 'Protein SRG1', 335, NULL, NULL, 49089),
(49090, '1.10.720.30-FF-000031', NULL, 'Apoptotic chromatin condensation inducer 1', 68, NULL, NULL, 49090),
(49091, '3.40.50.300-FF-005717', NULL, 'Dynein heavy chain', 164, NULL, NULL, 49091),
(49092, '1.10.510.10-FF-004270', NULL, NULL, 185, NULL, NULL, 49092),
(49093, '3.20.20.105-FF-000002', NULL, 'Queuine tRNA-ribosyltransferase accessory subunit 2', 374, NULL, NULL, 49093),
(49094, '1.20.1070.10-FF-001461', NULL, 'Uncharacterized protein', 216, NULL, NULL, 49094),
(49095, '1.50.10.10-FF-000199', NULL, 'alpha-1,2-Mannosidase', 210, NULL, NULL, 49095),
(49096, '1.10.390.10-FF-000010', NULL, 'Leucyl-cystinyl aminopeptidase', 249, NULL, NULL, 49096),
(49097, '1.20.5.110-FF-000153', NULL, 'Target SNARE, putative', 105, NULL, NULL, 49097),
(49098, '3.40.190.10-FF-000121', NULL, 'HTH-type transcriptional regulator cbl', 108, NULL, NULL, 49098),
(49099, '1.10.1200.10-FF-000153', NULL, 'Uncharacterized protein', 78, NULL, NULL, 49099),
(49100, '3.80.10.10-FF-001912', NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', 90, NULL, NULL, 49100),
(49101, '3.30.70.330-FF-001259', NULL, 'Putative rna recognition domain-containing protein', 131, NULL, NULL, 49101),
(49102, '2.60.120.330-FF-000186', NULL, '2-oxoglutarate (2OG) and Fe(II)-dependent oxygenase superfamily protein', 188, NULL, NULL, 49102),
(49103, '3.40.30.10-FF-001011', NULL, 'Tumor suppressor candidate 3', 62, NULL, NULL, 49103),
(49104, '3.90.980.10-FF-000001', NULL, 'DNA primase', 131, NULL, NULL, 49104),
(49105, '3.30.750.24-FF-000005', NULL, 'Anti-sigma F factor antagonist', 115, NULL, NULL, 49105),
(49106, '3.40.50.720-FF-002297', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 177, NULL, NULL, 49106),
(49107, '1.10.510.10-FF-003432', NULL, NULL, 285, NULL, NULL, 49107),
(49108, '1.10.510.10-FF-001408', NULL, 'Tyrosine-protein kinase', 239, NULL, NULL, 49108),
(49109, '2.60.40.640-FF-000067', NULL, 'Vacuolar sorting-associated protein-like,putative', 153, NULL, NULL, 49109),
(49110, '3.30.310.10-FF-000055', NULL, 'TATA-box-binding protein 2', 16, NULL, NULL, 49110),
(49111, '3.40.50.300-FF-007174', NULL, 'Uncharacterized protein', 173, NULL, NULL, 49111);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(49112, '3.40.50.410-FF-000175', NULL, 'Complement factor B', 103, NULL, NULL, 49112),
(49113, '2.60.40.790-FF-000191', NULL, NULL, 93, NULL, NULL, 49113),
(49114, '3.80.10.10-FF-001019', NULL, 'Si:ch211-213a13.5', 111, NULL, NULL, 49114),
(49115, '1.10.555.10-FF-000197', NULL, NULL, 147, NULL, NULL, 49115),
(49116, '1.10.150.440-FF-000001', NULL, 'Antimicrobial peptide microplusin', 90, NULL, NULL, 49116),
(49117, '1.20.5.730-FF-000007', NULL, 'V-type proton ATPase subunit G', 42, NULL, NULL, 49117),
(49118, '2.60.40.60-FF-000325', NULL, 'Fat-like cadherin-related tumor suppressor homolog', 108, NULL, NULL, 49118),
(49119, '3.90.1480.20-FF-000010', NULL, 'ST6 beta-galactoside alpha-2,6-sialyltransferase 2', 318, NULL, NULL, 49119),
(49120, '3.30.413.10-FF-000018', NULL, 'Nitrite/sulfite reductase, 4Fe-4S iron-sulfur cluster-binding domain protein', 143, NULL, NULL, 49120),
(49121, '3.80.10.10-FF-001452', NULL, 'Leucine-rich repeat containing protein', 124, NULL, NULL, 49121),
(49122, '2.30.39.10-FF-000061', NULL, 'Serpin 2', 200, NULL, NULL, 49122),
(49123, '3.30.200.20-FF-001016', NULL, 'Probable cyclin-dependent kinase 10', 93, NULL, NULL, 49123),
(49124, '2.60.110.10-FF-000014', NULL, 'Thaumatin-like protein 1', 185, NULL, NULL, 49124),
(49125, '3.80.10.10-FF-000507', NULL, 'negative regulator of reactive oxygen species isoform X1', 178, NULL, NULL, 49125),
(49126, '2.70.150.10-FF-000290', NULL, 'Cation-transporting ATPase', 109, NULL, NULL, 49126),
(49127, '2.10.25.10-FF-000974', NULL, 'Laminin subunit gamma-1', 59, NULL, NULL, 49127),
(49128, '3.30.160.380-FF-000006', NULL, 'Dicer-2', 107, NULL, NULL, 49128),
(49129, '1.10.533.10-FF-000028', NULL, 'Interleukin 1 receptor-associated kinase 4', 113, NULL, NULL, 49129),
(49130, '3.30.420.270-FF-000028', NULL, 'Biopolymer transport protein', 70, NULL, NULL, 49130),
(49131, '3.90.70.10-FF-000073', NULL, 'Calpain 10', 117, NULL, NULL, 49131),
(49132, '3.30.1490.20-FF-000098', NULL, 'Uncharacterized protein', 75, NULL, NULL, 49132),
(49133, '1.10.287.90-FF-000029', NULL, 'Cytochrome c oxidase subunit 2', 48, NULL, NULL, 49133),
(49134, '3.30.70.330-FF-002664', NULL, NULL, 171, NULL, NULL, 49134),
(49135, '2.60.220.50-FF-000096', NULL, 'Uncharacterized protein', 59, NULL, NULL, 49135),
(49136, '2.130.10.10-FF-005088', NULL, 'Uncharacterized protein', 261, NULL, NULL, 49136),
(49137, '3.40.50.2000-FF-000050', NULL, 'UDP-glucuronosyltransferase', 170, NULL, NULL, 49137),
(49138, '3.30.40.10-FF-000758', NULL, 'WGS project CABT00000000 data, contig 2.1', 93, NULL, NULL, 49138),
(49139, '1.25.40.10-FF-001624', NULL, 'PsbB mRNA maturation factor Mbb1', 151, NULL, NULL, 49139),
(49140, '3.40.50.2020-FF-000056', NULL, 'Ribose-phosphate pyrophosphokinase II', 113, NULL, NULL, 49140),
(49141, '3.40.630.10-FF-000498', NULL, 'Aspartyl aminopeptidase', 78, NULL, NULL, 49141),
(49142, '3.30.70.1630-FF-000003', NULL, 'tRNA-modifying protein YgfZ', 74, NULL, NULL, 49142),
(49143, '1.20.140.90-FF-000002', NULL, 'Malonyl-CoA decarboxylase family protein', 157, NULL, NULL, 49143),
(49144, '2.20.25.10-FF-000092', NULL, 'Uncharacterized protein', 123, NULL, NULL, 49144),
(49145, '3.90.20.20-FF-000016', NULL, 'Protein GrpE', 114, NULL, NULL, 49145),
(49146, '2.60.40.1180-FF-000176', NULL, 'Epididymis-specific alpha-mannosidase', 78, NULL, NULL, 49146),
(49147, '2.10.70.10-FF-000022', NULL, 'fibronectin isoform X1', 44, NULL, NULL, 49147),
(49148, '2.10.70.10-FF-000134', NULL, 'Complement inhibitory factor H', 58, NULL, NULL, 49148),
(49149, '1.10.238.10-FF-000073', NULL, 'calcineurin B-like protein 3', 194, NULL, NULL, 49149),
(49150, '3.30.70.330-FF-001129', NULL, 'RNA-binding protein 39', 53, NULL, NULL, 49150),
(49151, '2.10.109.10-FF-000067', NULL, 'Transcriptional repressor LexA, putative', 123, NULL, NULL, 49151),
(49152, '1.10.287.70-FF-000029', NULL, 'Voltage-dependent T-type calcium channel subunit alpha', 130, NULL, NULL, 49152),
(49153, '3.90.940.40-FF-000002', NULL, 'Gsl0285 protein', 71, NULL, NULL, 49153),
(49154, '3.40.1110.10-FF-000334', NULL, NULL, 125, NULL, NULL, 49154);
INSERT INTO "PUBLIC"."MODEL" VALUES
(49155, '1.10.510.10-FF-001397', NULL, 'Protein kinase domain containing protein', 280, NULL, NULL, 49155),
(49156, '1.25.10.10-FF-003253', NULL, 'Predicted protein', 226, NULL, NULL, 49156),
(49157, '1.25.10.10-FF-003365', NULL, 'Predicted protein', 170, NULL, NULL, 49157),
(49158, '3.40.50.620-FF-000013', NULL, 'Pantothenate synthetase', 179, NULL, NULL, 49158),
(49159, '1.20.1250.20-FF-001236', NULL, 'Putative anion transporter 3 chloroplastic', 133, NULL, NULL, 49159),
(49160, '3.30.420.100-FF-000005', NULL, '50S ribosomal protein L18', 106, NULL, NULL, 49160),
(49161, '3.40.1810.10-FF-000011', NULL, 'MADS-box transcription factor 7', 87, NULL, NULL, 49161),
(49162, '3.10.20.80-FF-000015', NULL, 'Probable mitochondrial translation initiation factor', 51, NULL, NULL, 49162),
(49163, '3.50.30.30-FF-000078', NULL, 'Zinc and ring finger 3', 89, NULL, NULL, 49163),
(49164, '3.40.50.300-FF-006229', NULL, 'Predicted protein', 106, NULL, NULL, 49164),
(49165, '1.25.40.10-FF-004497', NULL, 'Uncharacterized protein', 95, NULL, NULL, 49165),
(49166, '2.30.42.10-FF-000653', NULL, NULL, 126, NULL, NULL, 49166),
(49167, '1.10.3210.10-FF-000002', NULL, 'Nucleotidase YfbR', 199, NULL, NULL, 49167),
(49168, '3.40.50.300-FF-002851', NULL, 'ADP-ribosylation factor-like protein', 199, NULL, NULL, 49168),
(49169, '3.30.450.20-FF-000326', NULL, 'Hybrid sensor histidine kinase/response regulator', 131, NULL, NULL, 49169),
(49170, '1.10.1140.10-FF-000007', NULL, 'V-type ATP synthase alpha chain', 98, NULL, NULL, 49170),
(49171, '3.90.640.10-FF-000077', NULL, 'Actin-like protein 2', 95, NULL, NULL, 49171),
(49172, '3.40.50.1100-FF-000212', NULL, 'Predicted protein', 156, NULL, NULL, 49172),
(49173, '2.102.10.10-FF-000014', NULL, 'Oxidoreductase, FAD dependent', 105, NULL, NULL, 49173),
(49174, '2.30.30.140-FF-000118', NULL, 'E3 ubiquitin-protein ligase UHRF2', 63, NULL, NULL, 49174),
(49175, '1.10.1040.10-FF-000062', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', 152, NULL, NULL, 49175),
(49176, '3.30.60.30-FF-000069', NULL, 'Solute carrier organic anion transporter family member', 63, NULL, NULL, 49176),
(49177, '3.40.50.1820-FF-000557', NULL, 'Probable lipase', 273, NULL, NULL, 49177),
(49178, '3.40.50.720-FF-001330', NULL, 'Peroxisomal 2,4-dienoyl-CoA reductase, putative', 258, NULL, NULL, 49178),
(49179, '3.30.160.60-FF-003986', NULL, 'C2H2 zinc finger protein EGL-46', 80, NULL, NULL, 49179),
(49180, '2.130.10.10-FF-002452', NULL, 'Bifunctional endoribonuclease/protein kinase', 315, NULL, NULL, 49180),
(49181, '1.10.10.60-FF-000417', NULL, 'Even-skipped homeobox 1', 77, NULL, NULL, 49181),
(49182, '3.40.50.300-FF-000827', NULL, 'KTI12 chromatin-associated homolog', 186, NULL, NULL, 49182),
(49183, '2.30.29.30-FF-001179', NULL, 'cAMP-dependent protein kinase catalytic subunit, putative', 87, NULL, NULL, 49183),
(49184, '3.40.640.10-FF-000431', NULL, 'Uncharacterized protein', 137, NULL, NULL, 49184),
(49185, '1.20.1250.20-FF-000836', NULL, 'Solute carrier family 2, (Facilitated glucose transporter) member 8, isoform CRA_c', 314, NULL, NULL, 49185),
(49186, '3.40.50.300-FF-004301', NULL, 'Os03g0627300 protein', 119, NULL, NULL, 49186),
(49187, '3.40.720.10-FF-000269', NULL, 'Predicted protein', 499, NULL, NULL, 49187),
(49188, '3.30.160.60-FF-004610', NULL, NULL, 50, NULL, NULL, 49188),
(49189, '2.40.40.20-FF-000050', NULL, 'Thiosulfate reductase', 145, NULL, NULL, 49189),
(49190, '3.30.1330.10-FF-000044', NULL, 'Uncharacterized protein', 128, NULL, NULL, 49190),
(49191, '1.10.533.10-FF-000247', NULL, 'Uncharacterized protein', 130, NULL, NULL, 49191),
(49192, '1.20.58.1370-FF-000006', NULL, NULL, 76, NULL, NULL, 49192),
(49193, '1.20.5.340-FF-000104', NULL, 'Forkhead box protein P1', 23, NULL, NULL, 49193),
(49194, '1.10.510.10-FF-002920', NULL, NULL, 71, NULL, NULL, 49194),
(49195, '1.10.287.110-FF-000463', NULL, 'Radial spoke protein 16', 114, NULL, NULL, 49195),
(49196, '2.130.10.10-FF-000428', NULL, 'F-box and WD repeat domain containing 8', 135, NULL, NULL, 49196),
(49197, '1.10.10.10-FF-001375', NULL, 'Transcriptional repressor', 74, NULL, NULL, 49197);
INSERT INTO "PUBLIC"."MODEL" VALUES
(49198, '1.10.3210.30-FF-000008', NULL, 'CRISPR-associated helicase Cas3', 179, NULL, NULL, 49198),
(49199, '1.25.40.180-FF-000333', NULL, NULL, 164, NULL, NULL, 49199),
(49200, '3.20.20.80-FF-000711', NULL, 'Lactase, gene 2', 143, NULL, NULL, 49200),
(49201, '1.10.10.10-FF-000886', NULL, 'U5 small nuclear ribonucleoprotein helicase, putative', 87, NULL, NULL, 49201),
(49202, '1.10.10.10-FF-002117', NULL, 'Uncharacterized protein', 53, NULL, NULL, 49202),
(49203, '1.20.1070.10-FF-001680', NULL, 'Uncharacterized protein', 115, NULL, NULL, 49203),
(49204, '3.10.20.600-FF-000002', NULL, 'NADH-quinone oxidoreductase subunit F', 92, NULL, NULL, 49204),
(49205, '1.10.510.10-FF-004382', NULL, NULL, 94, NULL, NULL, 49205),
(49206, '2.40.20.10-FF-000040', NULL, 'Uncharacterized protein', 87, NULL, NULL, 49206),
(49207, '1.20.5.340-FF-000093', NULL, 'Rho-associated protein kinase 1-like Protein', 165, NULL, NULL, 49207),
(49208, '2.40.10.10-FF-000118', NULL, 'Chymotrypsinogen A', 131, NULL, NULL, 49208),
(49209, '3.20.14.10-FF-000002', NULL, 'L-fucose isomerase', 136, NULL, NULL, 49209),
(49210, '1.20.1270.60-FF-000147', NULL, 'Protein CBG09025', 257, NULL, NULL, 49210),
(49211, '1.25.70.10-FF-000047', NULL, 'Cleavage and polyadenylation factor 6-related protein', 162, NULL, NULL, 49211),
(49212, '3.40.50.790-FF-000036', NULL, 'Uncharacterized protein', 97, NULL, NULL, 49212),
(49213, '2.40.50.140-FF-000396', NULL, 'rRNA biogenesis protein RRP5', 77, NULL, NULL, 49213),
(49214, '1.10.10.2670-FF-000016', NULL, 'E3 ubiquitin-protein ligase UBR2', 98, NULL, NULL, 49214),
(49215, '3.40.50.300-FF-000030', NULL, '26S protease regulatory subunit 8', 182, NULL, NULL, 49215),
(49216, '1.25.40.20-FF-000548', NULL, 'Protein 21.1', 164, NULL, NULL, 49216),
(49217, '1.20.1250.20-FF-001450', NULL, 'Solute carrier family 2, facilitated glucose transporter member 2', 415, NULL, NULL, 49217),
(49218, '2.40.340.10-FF-000030', NULL, NULL, 59, NULL, NULL, 49218),
(49219, '3.30.710.10-FF-000473', NULL, 'Uncharacterized protein', 101, NULL, NULL, 49219),
(49220, '2.10.90.10-FF-000147', NULL, 'Uncharacterized protein', 104, NULL, NULL, 49220),
(49221, '3.30.40.10-FF-000753', NULL, 'DNA repair protein RAD16', 63, NULL, NULL, 49221),
(49222, '1.20.120.160-FF-000021', NULL, 'Chemotaxis protein CheA', 138, NULL, NULL, 49222),
(49223, '2.60.120.200-FF-000040', NULL, 'neural-cadherin isoform X1', 201, NULL, NULL, 49223),
(49224, '3.40.50.300-FF-000035', NULL, 'Ribosome-binding ATPase YchF', 177, NULL, NULL, 49224),
(49225, '3.10.310.20-FF-000028', NULL, NULL, 147, NULL, NULL, 49225),
(49226, '3.80.10.10-FF-002868', NULL, 'Uncharacterized protein', 221, NULL, NULL, 49226),
(49227, '1.25.40.10-FF-002928', NULL, 'Pellicle/biofilm biosynthesis protein PelB', 162, NULL, NULL, 49227),
(49228, '3.30.9.10-FF-000231', NULL, 'Amino acid oxidase fmpA', 83, NULL, NULL, 49228),
(49229, '1.25.40.10-FF-003204', NULL, 'Pentatricopeptide repeat-containing protein isoform A', 86, NULL, NULL, 49229),
(49230, '3.40.50.620-FF-000805', NULL, 'Uncharacterized protein', 62, NULL, NULL, 49230),
(49231, '3.30.565.10-FF-000067', NULL, 'Two-component system sensor histidine kinase CreC', 154, NULL, NULL, 49231),
(49232, '3.30.30.170-FF-000011', NULL, NULL, 103, NULL, NULL, 49232),
(49233, '1.25.10.10-FF-002067', NULL, 'DNA-dependent protein kinase subunit', 449, NULL, NULL, 49233),
(49234, '3.40.50.300-FF-005594', NULL, 'Uncharacterized protein', 61, NULL, NULL, 49234),
(49235, '1.20.120.1080-FF-000045', NULL, 'Uncharacterized protein', 136, NULL, NULL, 49235),
(49236, '1.25.40.990-FF-000019', NULL, 'SAC3/GANP/Nin1/mts3/eIF-3 p25 family, putative', 239, NULL, NULL, 49236),
(49237, '3.40.50.10540-FF-000008', NULL, 'Probable CoA-transferase Rv1866', 298, NULL, NULL, 49237),
(49238, '1.20.990.10-FF-000031', NULL, 'Probable oxidoreductase', 39, NULL, NULL, 49238),
(49239, '2.40.50.140-FF-000401', NULL, 'Exosome complex exonuclease RRP40', 65, NULL, NULL, 49239),
(49240, '1.20.1070.10-FF-002085', NULL, 'Growth hormone releasing hormone receptor', 224, NULL, NULL, 49240);
INSERT INTO "PUBLIC"."MODEL" VALUES
(49241, '3.20.20.70-FF-000377', NULL, 'Radical SAM domain protein', 273, NULL, NULL, 49241),
(49242, '3.30.565.10-FF-000415', NULL, 'ATP-binding region ATPase domain protein', 143, NULL, NULL, 49242),
(49243, '3.30.830.10-FF-000190', NULL, 'Uncharacterized protein', 239, NULL, NULL, 49243),
(49244, '2.60.120.820-FF-000006', NULL, 'Blast:BTB/POZ domain-containing protein 3', 166, NULL, NULL, 49244),
(49245, '3.40.50.10810-FF-000218', NULL, 'Uncharacterized protein', 78, NULL, NULL, 49245),
(49246, '1.10.10.10-FF-001156', NULL, 'Crp/Fnr family transcriptional regulator', 81, NULL, NULL, 49246),
(49247, '3.40.850.10-FF-000149', NULL, 'Kinesin-like protein', 254, NULL, NULL, 49247),
(49248, '1.10.238.10-FF-000078', NULL, 'Hippocalcin-like 1', 83, NULL, NULL, 49248),
(49249, '2.60.120.260-FF-000485', NULL, 'Uncharacterized protein', 130, NULL, NULL, 49249),
(49250, '2.130.10.10-FF-002901', NULL, 'Uncharacterized protein', 102, NULL, NULL, 49250),
(49251, '1.10.472.10-FF-000122', NULL, 'Cyclin-related protein FAM58A', 134, NULL, NULL, 49251),
(49252, '3.20.20.140-FF-000475', NULL, 'Predicted protein', 154, NULL, NULL, 49252),
(49253, '2.70.150.10-FF-000183', NULL, 'Phospholipid-transporting ATPase IIB, putative', 151, NULL, NULL, 49253),
(49254, '2.130.10.10-FF-005195', NULL, 'WD-repeat protein, putative', 110, NULL, NULL, 49254),
(49255, '3.30.1640.10-FF-000039', NULL, 'DNA helicase', 136, NULL, NULL, 49255),
(49256, '2.60.120.290-FF-000246', NULL, 'Uncharacterized protein', 125, NULL, NULL, 49256),
(49257, '3.40.50.300-FF-001558', NULL, 'Ribosome biogenesis GTPase Lsg1, putative', 176, NULL, NULL, 49257),
(49258, '3.10.580.10-FF-000180', NULL, 'Uncharacterized protein', 93, NULL, NULL, 49258),
(49259, '2.60.40.10-FF-003093', NULL, 'Si:ch211-141e20.2', 114, NULL, NULL, 49259),
(49260, '1.25.10.10-FF-003360', NULL, 'Uncharacterized protein', 188, NULL, NULL, 49260),
(49261, '4.10.95.10-FF-000007', NULL, 'Uncharacterized protein', 36, NULL, NULL, 49261),
(49262, '1.25.40.180-FF-000226', NULL, 'Uncharacterized protein', 255, NULL, NULL, 49262),
(49263, '1.10.510.10-FF-000211', NULL, 'Cyclin-dependent kinase G-2', 238, NULL, NULL, 49263),
(49264, '3.90.780.10-FF-000020', NULL, '5`-nucleotidase, putative', 204, NULL, NULL, 49264),
(49265, '3.90.1750.10-FF-000118', NULL, 'Uncharacterized protein', 168, NULL, NULL, 49265),
(49266, '3.40.525.10-FF-000017', NULL, 'Phosphatidylinositol transfer protein sfh5', 286, NULL, NULL, 49266),
(49267, '3.40.50.2300-FF-001090', NULL, NULL, 162, NULL, NULL, 49267),
(49268, '3.80.10.10-FF-000491', NULL, 'Blast:Protein toll', 101, NULL, NULL, 49268),
(49269, '2.60.120.290-FF-000139', NULL, 'Cubilin homolog', 152, NULL, NULL, 49269),
(49270, '3.50.50.60-FF-000970', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 165, NULL, NULL, 49270),
(49271, '3.40.50.150-FF-000423', NULL, 'tRNA (guanine(37)-N1)-methyltransferase', 209, NULL, NULL, 49271),
(49272, '3.30.70.330-FF-000062', NULL, 'serine/arginine-rich splicing factor SR34A-like', 78, NULL, NULL, 49272),
(49273, '2.30.30.40-FF-000634', NULL, 'Glutamate 5-kinase', 85, NULL, NULL, 49273),
(49274, '1.20.1560.10-FF-000256', NULL, 'Similar to ABC transporter', 321, NULL, NULL, 49274),
(49275, '1.10.510.10-FF-003769', NULL, NULL, 137, NULL, NULL, 49275),
(49276, '1.20.58.830-FF-000020', NULL, 'Erythrocyte binding ligand-1', 118, NULL, NULL, 49276),
(49277, '2.60.40.10-FF-004958', NULL, NULL, 78, NULL, NULL, 49277),
(49278, '1.20.1000.10-FF-000006', NULL, 'Uncharacterized protein', 293, NULL, NULL, 49278),
(49279, '2.60.120.970-FF-000023', NULL, 'Anti-dorsalizing morphogenetic protein 1', 215, NULL, NULL, 49279),
(49280, '1.20.1280.170-FF-000015', NULL, 'Protein REDUCED WALL ACETYLATION 3', 171, NULL, NULL, 49280),
(49281, '3.80.10.10-FF-002531', NULL, 'Uncharacterized protein', 175, NULL, NULL, 49281),
(49282, '3.30.160.60-FF-001737', NULL, 'Zinc finger protein 100', 28, NULL, NULL, 49282),
(49283, '1.10.287.90-FF-000024', NULL, 'Cytochrome c oxidase subunit 2', 85, NULL, NULL, 49283),
(49284, '2.60.200.20-FF-000007', NULL, 'microspherule protein 1 isoform X1', 146, NULL, NULL, 49284);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(49285, '3.40.30.10-FF-000050', NULL, 'protein disulfide-isomerase A6 isoform X1', 125, NULL, NULL, 49285),
(49286, '3.30.40.10-FF-001372', NULL, 'Uncharacterized protein', 54, NULL, NULL, 49286),
(49287, '3.60.21.10-FF-000123', NULL, 'SA0881 protein', 297, NULL, NULL, 49287),
(49288, '3.60.20.10-FF-000054', NULL, 'Proteasome subunit alpha type', 248, NULL, NULL, 49288),
(49289, '3.30.1050.10-FF-000011', NULL, 'Peroxisomal multifunctional enzyme type 2', 109, NULL, NULL, 49289),
(49290, '2.30.110.10-FF-000049', NULL, 'Uncharacterized protein', 139, NULL, NULL, 49290),
(49291, '3.90.550.10-FF-000188', NULL, 'Polysaccharide biosynthesis protein', 209, NULL, NULL, 49291),
(49292, '3.30.70.330-FF-000410', NULL, 'ASF/SF2-like pre-mRNA splicing factor SRP31', 108, NULL, NULL, 49292),
(49293, '3.40.50.410-FF-000282', NULL, 'Uncharacterized protein', 42, NULL, NULL, 49293),
(49294, '3.20.20.140-FF-000368', NULL, 'Predicted protein', 229, NULL, NULL, 49294),
(49295, '3.40.50.1820-FF-001513', NULL, 'Os01g0934600 protein', 151, NULL, NULL, 49295),
(49296, '1.20.1250.20-FF-000494', NULL, 'Transporter, MFS superfamily', 199, NULL, NULL, 49296),
(49297, '2.70.130.10-FF-000069', NULL, NULL, 117, NULL, NULL, 49297),
(49298, '3.40.50.2000-FF-000735', NULL, 'UDP-glycosyltransferase 82A1', 262, NULL, NULL, 49298),
(49299, '1.10.357.10-FF-000034', NULL, 'Transcriptional regulator, TetR family', 127, NULL, NULL, 49299),
(49300, '2.130.10.10-FF-001940', NULL, 'Pre-rRNA-processing protein IPI3', 250, NULL, NULL, 49300),
(49301, '3.30.420.40-FF-000712', NULL, 'Uncharacterized protein', 85, NULL, NULL, 49301),
(49302, '1.10.10.580-FF-000002', NULL, 'Sister chromatid cohesion 1 protein 4', 78, NULL, NULL, 49302),
(49303, '1.10.287.10-FF-000039', NULL, '40S ribosomal protein S13', 25, NULL, NULL, 49303),
(49304, '3.20.20.80-FF-000823', NULL, 'Uncharacterized protein', 60, NULL, NULL, 49304),
(49305, '3.40.50.2000-FF-001011', NULL, 'Uncharacterized protein', 191, NULL, NULL, 49305),
(49306, '3.30.420.10-FF-000714', NULL, NULL, 89, NULL, NULL, 49306),
(49307, '3.20.20.70-FF-000034', NULL, 'Deoxyribose-phosphate aldolase', 259, NULL, NULL, 49307),
(49308, '1.10.8.10-FF-000008', NULL, 'Holliday junction ATP-dependent DNA helicase RuvA', 48, NULL, NULL, 49308),
(49309, '3.30.1370.100-FF-000025', NULL, 'DNA mismatch repair protein pms1', 100, NULL, NULL, 49309),
(49310, '3.30.160.60-FF-000557', NULL, 'zinc finger and SCAN domain-containing protein 29', 31, NULL, NULL, 49310),
(49311, '2.60.40.10-FF-002137', NULL, 'Putative adhesin', 94, NULL, NULL, 49311),
(49312, '1.20.1250.20-FF-000831', NULL, 'MFS transporter', 387, NULL, NULL, 49312),
(49313, '3.40.50.450-FF-000052', NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase', 191, NULL, NULL, 49313),
(49314, '3.90.550.10-FF-000536', NULL, 'Mannosylglycerate synthase', 76, NULL, NULL, 49314),
(49315, '2.40.160.10-FF-000044', NULL, 'AGAP002595-PA', 215, NULL, NULL, 49315),
(49316, '3.10.580.10-FF-000073', NULL, 'CBS domain protein', 149, NULL, NULL, 49316),
(49317, '1.20.120.1750-FF-000162', NULL, 'Predicted protein', 57, NULL, NULL, 49317),
(49318, '1.20.5.190-FF-000019', NULL, 'Calmodulin-binding transcription activator 1', 45, NULL, NULL, 49318),
(49319, '2.60.40.10-FF-004054', NULL, NULL, 122, NULL, NULL, 49319),
(49320, '3.30.40.10-FF-001714', NULL, 'Kinase, NEK', 59, NULL, NULL, 49320),
(49321, '3.40.630.30-FF-000375', NULL, 'Acetyltransferase', 169, NULL, NULL, 49321),
(49322, '2.40.10.10-FF-000337', NULL, 'Uncharacterized protein, isoform D', 206, NULL, NULL, 49322),
(49323, '2.60.120.1000-FF-000021', NULL, 'Predicted protein', 221, NULL, NULL, 49323),
(49324, '3.40.50.300-FF-006903', NULL, 'Uncharacterized protein', 323, NULL, NULL, 49324),
(49325, '3.40.50.300-FF-006117', NULL, 'DNA helicase related protein', 352, NULL, NULL, 49325),
(49326, '3.10.20.90-FF-000344', NULL, 'Nuclear protein localization protein 4', 83, NULL, NULL, 49326),
(49327, '3.40.50.1820-FF-000552', NULL, 'Alpha/beta hydrolase', 308, NULL, NULL, 49327),
(49328, '3.30.930.10-FF-000023', NULL, 'Proline--tRNA ligase', 281, NULL, NULL, 49328);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(49329, '2.40.30.10-FF-000232', NULL, 'Metalloreductase, putative', 98, NULL, NULL, 49329),
(49330, '1.20.930.80-FF-000014', NULL, 'Uncharacterized protein', 276, NULL, NULL, 49330),
(49331, '1.20.1250.20-FF-001455', NULL, 'Major facilitator superfamily domain-containing protein', 231, NULL, NULL, 49331),
(49332, '1.20.120.980-FF-000036', NULL, 'Uncharacterized protein', 122, NULL, NULL, 49332),
(49333, '3.30.70.330-FF-000747', NULL, 'Serine and arginine rich splicing factor 12', 81, NULL, NULL, 49333),
(49334, '2.60.40.10-FF-003778', NULL, NULL, 105, NULL, NULL, 49334),
(49335, '3.30.1490.120-FF-000018', NULL, 'Uncharacterized protein', 87, NULL, NULL, 49335),
(49336, '1.10.510.10-FF-003084', NULL, NULL, 200, NULL, NULL, 49336),
(49337, '2.130.10.10-FF-002233', NULL, 'GM24813', 164, NULL, NULL, 49337),
(49338, '1.25.40.70-FF-000086', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', 78, NULL, NULL, 49338),
(49339, '3.40.630.10-FF-000150', NULL, 'Nicastrin', 289, NULL, NULL, 49339),
(49340, '2.130.10.10-FF-001833', NULL, 'Polyadenylation factor subunit 2', 129, NULL, NULL, 49340),
(49341, '3.30.420.40-FF-000605', NULL, 'Uncharacterized protein', 59, NULL, NULL, 49341),
(49342, '2.60.120.10-FF-000621', NULL, 'Uncharacterized protein', 75, NULL, NULL, 49342),
(49343, '3.40.50.150-FF-000979', NULL, 'Uncharacterized protein', 220, NULL, NULL, 49343),
(49344, '3.40.190.10-FF-000469', NULL, 'Dipeptide ABC transporter, substrate-binding protein', 93, NULL, NULL, 49344),
(49345, '3.40.1000.10-FF-000017', NULL, 'Tagatose-6-phosphate ketose/aldose isomerase, putative (Mog1/PsbP/DUF1795-like photosystem II reaction center PsbP family protein)', 173, NULL, NULL, 49345),
(49346, '1.10.287.370-FF-000069', NULL, 'Uncharacterized protein', 52, NULL, NULL, 49346),
(49347, '1.20.1070.10-FF-000623', NULL, 'Gonadotropin-releasing hormone receptor', 342, NULL, NULL, 49347),
(49348, '3.30.60.90-FF-000053', NULL, 'Uncharacterized protein', 47, NULL, NULL, 49348),
(49349, '3.30.160.60-FF-005447', NULL, NULL, 38, NULL, NULL, 49349),
(49350, '2.30.33.40-FF-000006', NULL, 'Head assembly cochaperone with GroEL', 111, NULL, NULL, 49350),
(49351, '3.80.10.10-FF-002076', NULL, 'Uncharacterized protein', 158, NULL, NULL, 49351),
(49352, '2.130.10.10-FF-001485', NULL, 'WD domain, G-beta repeat-containing protein', 169, NULL, NULL, 49352),
(49353, '3.40.50.720-FF-001673', NULL, 'Uncharacterized protein', 185, NULL, NULL, 49353),
(49354, '3.30.420.40-FF-000257', NULL, 'Actin-related protein', 187, NULL, NULL, 49354),
(49355, '1.25.10.10-FF-002741', NULL, 'Predicted protein', 789, NULL, NULL, 49355),
(49356, '3.80.10.10-FF-002289', NULL, 'F-box/LRR-repeat protein 20-like Protein', 237, NULL, NULL, 49356),
(49357, '2.20.28.10-FF-000019', NULL, 'Dna replication licensing factor mcm9 mini-chromosome maintenance deficient 9 hmcm9 mini-chromosome maintenance deficient domain-containing protein', 57, NULL, NULL, 49357),
(49358, '3.40.50.1460-FF-000067', NULL, 'Uncharacterized protein', 107, NULL, NULL, 49358),
(49359, '2.60.40.150-FF-000252', NULL, 'Uncharacterized protein, isoform A', 165, NULL, NULL, 49359),
(49360, '3.20.20.60-FF-000155', NULL, 'Pyruvate kinase', 205, NULL, NULL, 49360),
(49361, '3.30.160.60-FF-001518', NULL, 'Zinc finger with KRAB and SCAN domains 4', 29, NULL, NULL, 49361),
(49362, '2.60.40.1180-FF-000064', NULL, 'Type I pullulanase', 90, NULL, NULL, 49362),
(49363, '3.30.70.580-FF-000013', NULL, 'Ribosomal large subunit pseudouridine synthase B', 94, NULL, NULL, 49363),
(49364, '3.50.50.100-FF-000041', NULL, 'Slr1591 protein', 382, NULL, NULL, 49364),
(49365, '1.20.5.490-FF-000014', NULL, 'Uncharacterized protein', 40, NULL, NULL, 49365),
(49366, '1.10.1140.10-FF-000002', NULL, 'V-type proton ATPase catalytic subunit A', 154, NULL, NULL, 49366),
(49367, '3.30.870.10-FF-000181', NULL, 'Phospholipase D-related protein', 143, NULL, NULL, 49367),
(49368, '3.30.200.20-FF-000959', NULL, 'Cysteine-rich receptor-like protein kinase 17', 107, NULL, NULL, 49368),
(49369, '3.40.50.1260-FF-000013', NULL, 'Phosphoglycerate kinase', 212, NULL, NULL, 49369);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(49370, '1.25.40.10-FF-000107', NULL, 'CCR4-NOT transcription complex subunit 10 isoform X1', 352, NULL, NULL, 49370),
(49371, '3.30.200.20-FF-001359', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 81, NULL, NULL, 49371),
(49372, '1.25.40.170-FF-000004', NULL, 'Protein Smaug', 73, NULL, NULL, 49372),
(49373, '1.25.10.10-FF-001448', NULL, 'Serine/threonine-protein kinase TOR', 282, NULL, NULL, 49373),
(49374, '3.40.50.1980-FF-000116', NULL, 'Ferrichrome ABC transporter substrate-binding protein', 111, NULL, NULL, 49374),
(49375, '2.10.110.10-FF-000031', NULL, 'LIM homeobox 6, isoform CRA_b', 57, NULL, NULL, 49375),
(49376, '3.30.450.20-FF-000219', NULL, 'Nitrogen regulation protein', 113, NULL, NULL, 49376),
(49377, '3.30.160.60-FF-002682', NULL, 'Zinc finger protein 646', 31, NULL, NULL, 49377),
(49378, '3.40.850.10-FF-000256', NULL, 'KIF20A isoform 5', 119, NULL, NULL, 49378),
(49379, '3.40.50.150-FF-001816', NULL, NULL, 98, NULL, NULL, 49379),
(49380, '1.10.510.10-FF-002465', NULL, 'CAMK family protein kinase', 297, NULL, NULL, 49380),
(49381, '2.60.40.10-FF-003997', NULL, NULL, 100, NULL, NULL, 49381),
(49382, '3.30.70.330-FF-003046', NULL, NULL, 119, NULL, NULL, 49382),
(49383, '1.10.472.10-FF-000341', NULL, 'Mitotic cyclin, putative', 80, NULL, NULL, 49383),
(49384, '1.20.58.70-FF-000108', NULL, 'Uncharacterized protein', 223, NULL, NULL, 49384),
(49385, '1.10.565.10-FF-000023', NULL, 'Steroid hormone receptor ERR1', 237, NULL, NULL, 49385),
(49386, '2.120.10.30-FF-000272', NULL, 'Tyrosine-protein kinase receptor', 269, NULL, NULL, 49386),
(49387, '3.10.100.10-FF-000111', NULL, 'Adhesion G protein-coupled receptor L3', 140, NULL, NULL, 49387),
(49388, '3.30.10.20-FF-000024', NULL, NULL, 60, NULL, NULL, 49388),
(49389, '2.60.40.10-FF-004273', NULL, NULL, 108, NULL, NULL, 49389),
(49390, '3.40.50.300-FF-000378', NULL, 'ATP-dependent Clp protease ATP-binding subunit clpX-like, mitochondrial', 292, NULL, NULL, 49390),
(49391, '1.10.510.10-FF-002813', NULL, NULL, 162, NULL, NULL, 49391),
(49392, '3.40.50.720-FF-000728', NULL, 'D-lactate dehydrogenase', 196, NULL, NULL, 49392),
(49393, '3.40.50.620-FF-000120', NULL, 'Valine--tRNA ligase, mitochondrial', 233, NULL, NULL, 49393),
(49394, '1.20.1300.10-FF-000046', NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', 128, NULL, NULL, 49394),
(49395, '1.20.1250.20-FF-001798', NULL, 'Solute carrier family 22 member 12', 175, NULL, NULL, 49395),
(49396, '3.30.1330.40-FF-000042', NULL, 'Chorismate mutase AroH', 123, NULL, NULL, 49396),
(49397, '2.60.40.10-FF-001176', NULL, 'Usherin', 97, NULL, NULL, 49397),
(49398, '3.30.160.60-FF-002007', NULL, 'Zinc finger protein 80', 31, NULL, NULL, 49398),
(49399, '2.120.10.80-FF-000388', NULL, 'Uncharacterized protein', 210, NULL, NULL, 49399),
(49400, '1.25.40.10-FF-003873', NULL, 'Os01g0164700 protein', 93, NULL, NULL, 49400),
(49401, '3.30.70.330-FF-001366', NULL, 'RNA-binding domain-containing protein', 131, NULL, NULL, 49401),
(49402, '3.90.190.10-FF-000559', NULL, 'Cell division cycle 14B', 96, NULL, NULL, 49402),
(49403, '1.10.418.10-FF-000064', NULL, 'Parvin, gamma', 128, NULL, NULL, 49403),
(49404, '3.90.1150.10-FF-000376', NULL, 'Methionine aminotransferase', 18, NULL, NULL, 49404),
(49405, '3.60.21.10-FF-000360', NULL, 'Uncharacterized protein', 141, NULL, NULL, 49405),
(49406, '3.40.50.720-FF-002292', NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase NAD-binding', 184, NULL, NULL, 49406),
(49407, '3.40.50.360-FF-000132', NULL, 'Uncharacterized protein', 192, NULL, NULL, 49407),
(49408, '3.30.160.60-FF-006392', NULL, NULL, 49, NULL, NULL, 49408),
(49409, '3.40.1160.10-FF-000068', NULL, 'Glutamate 5-kinase', 272, NULL, NULL, 49409),
(49410, '3.30.1360.20-FF-000004', NULL, 'Transcriptional coactivator/pterin dehydratase', 102, NULL, NULL, 49410),
(49411, '2.60.120.10-FF-000751', NULL, 'Metal transporter CNNM4', 95, NULL, NULL, 49411),
(49412, '3.30.200.100-FF-000001', NULL, 'Sigma-E factor regulatory protein RseB', 101, NULL, NULL, 49412),
(49413, '3.30.160.60-FF-005099', NULL, NULL, 61, NULL, NULL, 49413);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(49414, '2.120.10.30-FF-000620', NULL, 'Uncharacterized protein', 37, NULL, NULL, 49414),
(49415, '2.40.128.180-FF-000009', NULL, NULL, 86, NULL, NULL, 49415),
(49416, '2.60.40.420-FF-000237', NULL, 'Iron transport multicopper oxidase fio1', 130, NULL, NULL, 49416),
(49417, '3.30.70.20-FF-000134', NULL, NULL, 48, NULL, NULL, 49417),
(49418, '3.30.160.60-FF-001176', NULL, 'C2H2 finger domain protein', 40, NULL, NULL, 49418),
(49419, '3.30.450.40-FF-000085', NULL, 'PAS/PAC sensor protein', 177, NULL, NULL, 49419),
(49420, '3.30.870.10-FF-000074', NULL, 'Phospholipase D family protein', 176, NULL, NULL, 49420),
(49421, '3.20.20.80-FF-000262', NULL, 'Glycogen debranching enzyme GlgX', 434, NULL, NULL, 49421),
(49422, '2.60.200.20-FF-000226', NULL, 'Predicted protein', 87, NULL, NULL, 49422),
(49423, '2.70.40.10-FF-000023', NULL, '2''-deoxycytidine 5''-triphosphate deaminase', 172, NULL, NULL, 49423),
(49424, '2.60.40.150-FF-000813', NULL, 'Extended synaptotagmin-like protein 2b', 128, NULL, NULL, 49424),
(49425, '3.30.465.10-FF-000138', NULL, 'Glycolate oxidase subunit', 210, NULL, NULL, 49425),
(49426, '3.30.470.20-FF-000092', NULL, 'Glutathione synthetase', 108, NULL, NULL, 49426),
(49427, '1.10.472.80-FF-000210', NULL, NULL, 121, NULL, NULL, 49427),
(49428, '3.60.10.10-FF-000334', NULL, 'Phosphatidylinositol phosphatase', 229, NULL, NULL, 49428),
(49429, '2.130.10.10-FF-003519', NULL, 'Small nucleolar ribonucleoprotein complex subunit, putative (AFU_orthologue AFUA_4G07540)', 113, NULL, NULL, 49429),
(49430, '3.20.20.100-FF-000148', NULL, 'Uncharacterized protein', 268, NULL, NULL, 49430),
(49431, '3.30.1360.120-FF-000068', NULL, 'Predicted protein', 152, NULL, NULL, 49431),
(49432, '2.170.270.10-FF-000033', NULL, 'Histone-lysine N-methyltransferase', 243, NULL, NULL, 49432),
(49433, '2.60.40.1660-FF-000005', NULL, 'Sodium/potassium-transporting ATPase subunit beta', 273, NULL, NULL, 49433),
(49434, '3.30.40.10-FF-001141', NULL, 'Histone-lysine N-methyltransferase', 70, NULL, NULL, 49434),
(49435, '1.10.472.80-FF-000098', NULL, 'Tbc domain containing protein', 129, NULL, NULL, 49435),
(49436, '2.130.10.10-FF-005667', NULL, 'Predicted protein', 163, NULL, NULL, 49436),
(49437, '1.25.10.10-FF-002303', NULL, 'Predicted protein', 321, NULL, NULL, 49437),
(49438, '3.30.390.30-FF-000037', NULL, 'Glutathione reductase', 113, NULL, NULL, 49438),
(49439, '3.30.50.10-FF-000130', NULL, 'Mineralocorticoid receptor', 62, NULL, NULL, 49439),
(49440, '1.25.40.10-FF-004946', NULL, 'Os05g0305300 protein', 177, NULL, NULL, 49440),
(49441, '3.30.505.10-FF-000182', NULL, NULL, 106, NULL, NULL, 49441),
(49442, '2.30.29.150-FF-000001', NULL, 'Fact complex subunit ssrp1', 140, NULL, NULL, 49442),
(49443, '1.25.40.10-FF-001169', NULL, 'Os07g0588100 protein', 101, NULL, NULL, 49443),
(49444, '3.30.2380.10-FF-000002', NULL, 'EKC/KEOPS complex subunit CGI121', 175, NULL, NULL, 49444),
(49445, '3.30.2360.10-FF-000001', NULL, 'Inositol-3-phosphate synthase isozyme 1', 41, NULL, NULL, 49445),
(49446, '2.130.10.10-FF-002008', NULL, 'Polyadenylation factor subunit 2', 208, NULL, NULL, 49446),
(49447, '3.40.30.10-FF-000842', NULL, 'Protein disulfide-isomerase', 123, NULL, NULL, 49447),
(49448, '3.30.70.250-FF-000026', NULL, NULL, 74, NULL, NULL, 49448),
(49449, '1.20.1250.20-FF-001904', NULL, 'Os01g0556700 protein', 41, NULL, NULL, 49449),
(49450, '2.40.50.140-FF-001126', NULL, NULL, 90, NULL, NULL, 49450),
(49451, '2.40.50.100-FF-000069', NULL, 'Putative maltose ABC transporter, ATP-binding protein', 64, NULL, NULL, 49451),
(49452, '3.40.50.1820-FF-000102', NULL, 'Putative serine esterase family protein', 215, NULL, NULL, 49452),
(49453, '3.10.280.10-FF-000033', NULL, 'Predicted protein', 173, NULL, NULL, 49453),
(49454, '3.30.565.10-FF-000303', NULL, 'Two-component sensor histidine kinase', 161, NULL, NULL, 49454),
(49455, '3.90.70.80-FF-000054', NULL, 'Uncharacterized protein', 148, NULL, NULL, 49455),
(49456, '3.30.360.10-FF-000114', NULL, 'Myo-inositol 2-dehydrogenase', 131, NULL, NULL, 49456),
(49457, '2.130.10.10-FF-004138', NULL, 'ADL248Cp', 377, NULL, NULL, 49457);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(49458, '2.160.20.10-FF-000006', NULL, 'F-box only protein 11', 138, NULL, NULL, 49458),
(49459, '3.80.10.10-FF-003020', NULL, 'Predicted protein', 157, NULL, NULL, 49459),
(49460, '3.30.310.80-FF-000036', NULL, 'Non-specific serine/threonine protein kinase', 85, NULL, NULL, 49460),
(49461, '3.40.50.300-FF-005049', NULL, 'Uncharacterized protein', 112, NULL, NULL, 49461),
(49462, '1.25.40.150-FF-000009', NULL, NULL, 103, NULL, NULL, 49462),
(49463, '3.30.160.60-FF-004031', NULL, NULL, 28, NULL, NULL, 49463),
(49464, '3.30.342.10-FF-000050', NULL, 'DNA polymerase', 127, NULL, NULL, 49464),
(49465, '3.30.70.560-FF-000018', NULL, 'Uncharacterized protein', 120, NULL, NULL, 49465),
(49466, '1.20.120.80-FF-000003', NULL, 'Cytochrome c oxidase subunit 3', 212, NULL, NULL, 49466),
(49467, '2.10.25.10-FF-001463', NULL, 'Uncharacterized protein', 40, NULL, NULL, 49467),
(49468, '3.40.250.10-FF-000165', NULL, 'Hydrolase glyoxylase', 114, NULL, NULL, 49468),
(49469, '2.70.98.110-FF-000011', NULL, 'Uncharacterized protein', 288, NULL, NULL, 49469),
(49470, '3.30.1010.10-FF-000121', NULL, 'Uncharacterized protein', 72, NULL, NULL, 49470),
(49471, '1.20.1250.20-FF-001000', NULL, 'Multidrug efflux MFS transporter putative', 197, NULL, NULL, 49471),
(49472, '1.10.565.10-FF-000135', NULL, 'RAR related orphan receptor C', 164, NULL, NULL, 49472),
(49473, '3.30.160.60-FF-001968', NULL, 'chorion transcription factor Cf2 isoform X3', 27, NULL, NULL, 49473),
(49474, '2.60.40.2320-FF-000001', NULL, 'Type I pullulanase', 95, NULL, NULL, 49474),
(49475, '1.20.1560.10-FF-000817', NULL, 'Uncharacterized protein', 109, NULL, NULL, 49475),
(49476, '1.25.40.10-FF-004261', NULL, 'Pentatricopeptide repeat-containing protein', 225, NULL, NULL, 49476),
(49477, '2.60.40.10-FF-003885', NULL, NULL, 98, NULL, NULL, 49477),
(49478, '3.20.20.105-FF-000019', NULL, 'Queuine tRNA-ribosyltransferase accessory subunit 2', 161, NULL, NULL, 49478),
(49479, '2.130.10.10-FF-002340', NULL, 'Protein HIRA', 200, NULL, NULL, 49479),
(49480, '2.130.10.130-FF-000043', NULL, NULL, 270, NULL, NULL, 49480),
(49481, '3.60.110.10-FF-000027', NULL, 'AGAP012662-PA', 276, NULL, NULL, 49481),
(49482, '1.20.58.60-FF-000111', NULL, 'dystonin isoform X1', 218, NULL, NULL, 49482),
(49483, '3.30.70.850-FF-000004', NULL, 'Proprotein convertase subtilisin/kexin type 6', 50, NULL, NULL, 49483),
(49484, '1.10.287.130-FF-000233', NULL, 'Histidine kinase', 76, NULL, NULL, 49484),
(49485, '1.10.1410.10-FF-000107', NULL, 'Uncharacterized protein', 156, NULL, NULL, 49485),
(49486, '3.40.50.300-FF-002407', NULL, 'ABC transporter ATP-binding protein-amino acid transport', 213, NULL, NULL, 49486),
(49487, '1.10.287.70-FF-000473', NULL, 'Uncharacterized protein', 218, NULL, NULL, 49487),
(49488, '1.20.120.1910-FF-000013', NULL, 'Cysteine--tRNA ligase', 156, NULL, NULL, 49488),
(49489, '3.90.215.10-FF-000016', NULL, 'DNA ligase', 230, NULL, NULL, 49489),
(49490, '3.40.50.300-FF-000266', NULL, 'DNA replication protein DnaC', 176, NULL, NULL, 49490),
(49491, '3.80.10.10-FF-003705', NULL, 'P-granule-associated novel protein 1', 159, NULL, NULL, 49491),
(49492, '2.30.30.40-FF-000421', NULL, 'Predicted protein', 64, NULL, NULL, 49492),
(49493, '3.60.21.60-FF-000003', NULL, 'DNA polymerase alpha subunit B', 106, NULL, NULL, 49493),
(49494, '2.20.28.10-FF-000002', NULL, 'DNA helicase', 51, NULL, NULL, 49494),
(49495, '3.10.20.30-FF-000011', NULL, '2Fe-2S ferredoxin YfaE', 84, NULL, NULL, 49495),
(49496, '3.90.920.10-FF-000003', NULL, 'DNA primase', 408, NULL, NULL, 49496),
(49497, '1.20.120.1630-FF-000036', NULL, 'Phosphatidylethanolamine N-methyltransferase', 123, NULL, NULL, 49497),
(49498, '3.90.190.10-FF-000109', NULL, 'Dual specificity phosphatase', 163, NULL, NULL, 49498),
(49499, '3.30.1490.100-FF-000012', NULL, 'DNA polymerase IV', 111, NULL, NULL, 49499),
(49500, '1.25.40.20-FF-001498', NULL, 'Uncharacterized protein', 65, NULL, NULL, 49500),
(49501, '1.10.3380.10-FF-000008', NULL, 'DExH-box ATP-dependent RNA helicase DExH17', 151, NULL, NULL, 49501),
(49502, '1.25.10.10-FF-001780', NULL, 'Uncharacterized protein', 725, NULL, NULL, 49502);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(49503, '3.30.160.60-FF-000664', NULL, 'Uncharacterized protein', 28, NULL, NULL, 49503),
(49504, '2.60.40.820-FF-000020', NULL, 'T-box transcription factor 18', 202, NULL, NULL, 49504),
(49505, '3.30.200.20-FF-002073', NULL, 'Uncharacterized protein', 84, NULL, NULL, 49505),
(49506, '3.40.50.150-FF-000187', NULL, 'Ribosomal RNA methyltransferase putative', 189, NULL, NULL, 49506),
(49507, '2.30.42.10-FF-000310', NULL, 'Pro-apoptotic serine protease NMA111', 74, NULL, NULL, 49507),
(49508, '1.10.472.10-FF-000335', NULL, 'Cyclin-like protein', 99, NULL, NULL, 49508),
(49509, '3.60.20.10-FF-000161', NULL, NULL, 242, NULL, NULL, 49509),
(49510, '3.40.50.1220-FF-000029', NULL, 'NAD-dependent protein deacetylase sirtuin-6 isoform X2', 77, NULL, NULL, 49510),
(49511, '3.30.450.190-FF-000021', NULL, 'Gtr1/RagA G protein conserved region-domain-containing protein', 135, NULL, NULL, 49511),
(49512, '2.130.10.10-FF-004470', NULL, 'Uncharacterized WD repeat-containing protein C227.12', 78, NULL, NULL, 49512),
(49513, '3.30.70.100-FF-000009', NULL, 'ATPase copper transporting beta', 71, NULL, NULL, 49513),
(49514, '3.40.50.10140-FF-000085', NULL, 'Uncharacterized protein', 132, NULL, NULL, 49514),
(49515, '3.30.200.20-FF-002180', NULL, 'Uncharacterized protein', 58, NULL, NULL, 49515),
(49516, '3.50.50.60-FF-001021', NULL, 'FAD dependent oxidoreductase', 136, NULL, NULL, 49516),
(49517, '1.10.630.10-FF-000490', NULL, 'Uncharacterized protein', 467, NULL, NULL, 49517),
(49518, '3.90.1750.20-FF-000003', NULL, 'Serine recombinase', 174, NULL, NULL, 49518),
(49519, '3.40.50.1000-FF-000300', NULL, 'Putative cytosolic 5''-nucleotidase 3', 191, NULL, NULL, 49519),
(49520, '3.40.33.10-FF-000180', NULL, 'Predicted protein', 78, NULL, NULL, 49520),
(49521, '3.40.50.300-FF-005156', NULL, 'Adenylyl-sulfate kinase', 226, NULL, NULL, 49521),
(49522, '3.30.70.330-FF-000859', NULL, 'Uncharacterized protein, isoform B', 76, NULL, NULL, 49522),
(49523, '2.60.40.10-FF-000119', NULL, 'Sallimus, isoform P', 109, NULL, NULL, 49523),
(49524, '3.80.20.20-FF-000090', NULL, 'Predicted protein', 95, NULL, NULL, 49524),
(49525, '3.30.160.60-FF-002805', NULL, 'Uncharacterized protein, isoform B', 68, NULL, NULL, 49525),
(49526, '3.40.50.300-FF-001890', NULL, 'DNA helicase', 35, NULL, NULL, 49526),
(49527, '1.25.40.10-FF-004042', NULL, 'CCR4-NOT transcription complex subunit, putative', 176, NULL, NULL, 49527),
(49528, '1.10.540.10-FF-000056', NULL, 'Acyl-CoA dehydrogenase FadE6', 104, NULL, NULL, 49528),
(49529, '3.30.70.330-FF-003153', NULL, NULL, 108, NULL, NULL, 49529),
(49530, '1.10.3080.10-FF-000082', NULL, 'Chloride channel protein', 497, NULL, NULL, 49530),
(49531, '1.20.58.390-FF-000315', NULL, 'Uncharacterized protein', 96, NULL, NULL, 49531),
(49532, '3.30.2160.10-FF-000020', NULL, 'E3 ubiquitin-protein ligase', 84, NULL, NULL, 49532),
(49533, '1.25.40.10-FF-003642', NULL, 'Uncharacterized protein', 217, NULL, NULL, 49533),
(49534, '3.40.850.10-FF-000481', NULL, 'Kinesin-like protein', 340, NULL, NULL, 49534),
(49535, '3.30.950.10-FF-000018', NULL, 'Uroporphyrin-III C-methyltransferase', 125, NULL, NULL, 49535),
(49536, '3.40.50.1460-FF-000073', NULL, 'Predicted protein', 250, NULL, NULL, 49536),
(49537, '3.40.50.410-FF-000063', NULL, 'von Willebrand factor', 189, NULL, NULL, 49537),
(49538, '1.10.10.10-FF-001847', NULL, 'Uncharacterized protein', 123, NULL, NULL, 49538),
(49539, '1.20.120.430-FF-000006', NULL, 'tRNA modification GTPase MnmE', 167, NULL, NULL, 49539),
(49540, '3.20.20.220-FF-000061', NULL, 'Proline dehydrogenase', 272, NULL, NULL, 49540),
(49541, '3.40.50.150-FF-001709', NULL, NULL, 59, NULL, NULL, 49541),
(49542, '3.30.160.60-FF-005335', NULL, NULL, 70, NULL, NULL, 49542),
(49543, '3.30.230.130-FF-000038', NULL, 'AGAP005048-PA', 153, NULL, NULL, 49543),
(49544, '3.80.10.10-FF-001564', NULL, 'Malignant fibrous histiocytoma-amplified sequence 1 homolog', 107, NULL, NULL, 49544),
(49545, '2.130.10.10-FF-001721', NULL, 'Spliceosomal protein sap, putative', 38, NULL, NULL, 49545),
(49546, '3.40.50.1000-FF-000082', NULL, 'N-acylneuraminate cytidylyltransferase A', 165, NULL, NULL, 49546);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(49547, '1.20.1720.10-FF-000134', NULL, NULL, 65, NULL, NULL, 49547),
(49548, '3.20.20.70-FF-000146', NULL, 'Indole-3-glycerol phosphate synthase chloroplastic', 279, NULL, NULL, 49548),
(49549, '1.10.268.10-FF-000012', NULL, 'DNA topoisomerase 2', 166, NULL, NULL, 49549),
(49550, '3.40.720.10-FF-000033', NULL, 'Alkaline-phosphatase-like family protein', 264, NULL, NULL, 49550),
(49551, '3.30.1370.100-FF-000019', NULL, 'DNA mismatch repair protein MutL', 96, NULL, NULL, 49551),
(49552, '3.30.200.20-FF-001229', NULL, 'Uncharacterized protein', 81, NULL, NULL, 49552),
(49553, '3.40.50.300-FF-001103', NULL, 'DNA repair protein RAD51 homolog 3', 270, NULL, NULL, 49553),
(49554, '2.130.10.10-FF-005774', NULL, 'Uncharacterized protein', 105, NULL, NULL, 49554),
(49555, '2.130.10.10-FF-005886', NULL, 'Uncharacterized protein', 297, NULL, NULL, 49555),
(49556, '1.10.10.1410-FF-000004', NULL, 'Uncharacterized protein', 52, NULL, NULL, 49556),
(49557, '3.40.50.1980-FF-000009', NULL, 'Iron-enterobactin transporter periplasmic binding protein', 119, NULL, NULL, 49557),
(49558, '3.40.50.720-FF-002185', NULL, 'Uncharacterized protein', 52, NULL, NULL, 49558),
(49559, '2.30.30.380-FF-000067', NULL, 'Uncharacterized protein', 38, NULL, NULL, 49559),
(49560, '3.90.190.10-FF-000216', NULL, 'Protein-tyrosine phosphatase delta-b', 187, NULL, NULL, 49560),
(49561, '2.170.270.10-FF-000140', NULL, 'Histone-lysine N-methyltransferase', 115, NULL, NULL, 49561),
(49562, '3.40.47.10-FF-000026', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 2', 412, NULL, NULL, 49562),
(49563, '3.90.190.10-FF-000328', NULL, 'Tyrosine phosphatase', 288, NULL, NULL, 49563),
(49564, '2.60.40.10-FF-001631', NULL, 'titin isoform X1', 100, NULL, NULL, 49564),
(49565, '1.10.10.10-FF-001723', NULL, 'Putative iron-dependent transcriptional regulator', 65, NULL, NULL, 49565),
(49566, '2.30.29.30-FF-000454', NULL, 'Ran-specific GTPase-activating protein 2', 197, NULL, NULL, 49566),
(49567, '3.80.10.10-FF-001800', NULL, 'Putative leucine-rich repeat protein', 112, NULL, NULL, 49567),
(49568, '1.20.1070.10-FF-000859', NULL, 'G-protein coupled receptor, putative', 175, NULL, NULL, 49568),
(49569, '3.40.30.10-FF-000611', NULL, 'Putative elongation factor 1-gamma', 81, NULL, NULL, 49569),
(49570, '3.40.50.300-FF-004537', NULL, 'ATP-dependent (ABC) transporter, putative', 260, NULL, NULL, 49570),
(49571, '2.40.50.140-FF-000744', NULL, NULL, 79, NULL, NULL, 49571),
(49572, '2.60.120.10-FF-000172', NULL, 'Transcriptional regulator, Crp/Fnr family', 131, NULL, NULL, 49572),
(49573, '3.40.1110.10-FF-000115', NULL, 'Plasma membrane ATPase', 146, NULL, NULL, 49573),
(49574, '3.80.10.10-FF-004217', NULL, 'Uncharacterized protein', 86, NULL, NULL, 49574),
(49575, '3.30.420.40-FF-000948', NULL, 'Uncharacterized protein', 79, NULL, NULL, 49575),
(49576, '3.30.420.10-FF-000046', NULL, 'Three prime repair exonuclease 1', 217, NULL, NULL, 49576),
(49577, '1.50.40.10-FF-000251', NULL, 'Solute carrier family 25 member 51', 268, NULL, NULL, 49577),
(49578, '3.40.50.360-FF-000025', NULL, 'methionine synthase reductase', 169, NULL, NULL, 49578),
(49579, '1.20.5.170-FF-000143', NULL, 'Structural maintenance of chromosomes', 60, NULL, NULL, 49579),
(49580, '3.20.80.10-FF-000054', NULL, 'Uncharacterized protein', 155, NULL, NULL, 49580),
(49581, '3.40.50.2300-FF-001432', NULL, NULL, 136, NULL, NULL, 49581),
(49582, '3.30.365.10-FF-000086', NULL, 'Uncharacterized protein', 39, NULL, NULL, 49582),
(49583, '3.30.70.330-FF-000298', NULL, 'U1 small nuclear ribonucleoprotein 70 kDa', 122, NULL, NULL, 49583),
(49584, '3.80.10.10-FF-002183', NULL, 'Uncharacterized protein', 126, NULL, NULL, 49584),
(49585, '3.60.21.10-FF-000253', NULL, 'Ser/Thr protein phosphatase, putative', 295, NULL, NULL, 49585),
(49586, '1.20.1170.10-FF-000007', NULL, NULL, 157, NULL, NULL, 49586),
(49587, '1.10.630.10-FF-000158', NULL, 'Cytochrome P450, putative (Eurofung)', 454, NULL, NULL, 49587),
(49588, '2.60.200.20-FF-000119', NULL, 'Uncharacterized protein', 107, NULL, NULL, 49588),
(49589, '3.40.50.300-FF-002519', NULL, 'Hydrolase, P-loop-like family protein', 178, NULL, NULL, 49589); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(49590, '3.30.70.330-FF-000404', NULL, 'RNA-binding protein with multiple splicing', 91, NULL, NULL, 49590),
(49591, '1.10.150.120-FF-000017', NULL, NULL, 108, NULL, NULL, 49591),
(49592, '1.10.390.40-FF-000002', NULL, NULL, 64, NULL, NULL, 49592),
(49593, '3.40.50.720-FF-000959', NULL, 'Unplaced genomic scaffold supercont1.208, whole genome shotgun sequence', 128, NULL, NULL, 49593),
(49594, '3.60.40.10-FF-000049', NULL, 'Protein phosphatase 2C 57', 297, NULL, NULL, 49594),
(49595, '3.40.980.10-FF-000029', NULL, 'Molybdopterin molybdenumtransferase', 145, NULL, NULL, 49595),
(49596, '1.20.82.10-FF-000006', NULL, 'Uncharacterized protein', 67, NULL, NULL, 49596),
(49597, '3.20.20.60-FF-000048', NULL, 'Pyruvate kinase', 169, NULL, NULL, 49597),
(49598, '1.20.1110.10-FF-000104', NULL, 'E1-E2 ATPase family protein', 110, NULL, NULL, 49598),
(49599, '1.50.40.10-FF-000375', NULL, 'Mitochondrial carrier protein', 116, NULL, NULL, 49599),
(49600, '3.40.50.1010-FF-000180', NULL, NULL, 173, NULL, NULL, 49600),
(49601, '1.25.40.10-FF-001276', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 180, NULL, NULL, 49601),
(49602, '3.40.50.2000-FF-000499', NULL, 'DNA beta-glucosyltransferase', 166, NULL, NULL, 49602),
(49603, '3.30.1680.10-FF-000036', NULL, 'AGAP005742-PA', 62, NULL, NULL, 49603),
(49604, '1.10.8.60-FF-000326', NULL, 'Transitional endoplasmic reticulum ATPase', 61, NULL, NULL, 49604),
(49605, '3.90.1200.10-FF-000026', NULL, 'Putative aminoglycoside phosphotransferase', 239, NULL, NULL, 49605),
(49606, '3.90.70.10-FF-000421', NULL, 'Uncharacterized protein', 153, NULL, NULL, 49606),
(49607, '3.40.50.150-FF-000075', NULL, 'NOP2/Sun RNA methyltransferase 2', 344, NULL, NULL, 49607),
(49608, '3.40.50.300-FF-000485', NULL, 'Dephospho-CoA kinase CAB5', 202, NULL, NULL, 49608),
(49609, '1.20.1250.20-FF-000488', NULL, 'MonoCarboxylate Transporter family', 201, NULL, NULL, 49609),
(49610, '3.10.100.10-FF-000217', NULL, NULL, 168, NULL, NULL, 49610),
(49611, '1.25.10.10-FF-002292', NULL, 'Uncharacterized protein', 326, NULL, NULL, 49611),
(49612, '3.65.10.10-FF-000037', NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', 198, NULL, NULL, 49612),
(49613, '3.20.20.190-FF-000118', NULL, NULL, 165, NULL, NULL, 49613),
(49614, '3.40.430.10-FF-000056', NULL, 'Dihydrofolate reductase', 221, NULL, NULL, 49614),
(49615, '1.20.5.440-FF-000010', NULL, 'pH-gated potassium channel KcsA', 41, NULL, NULL, 49615),
(49616, '2.60.120.10-FF-000296', NULL, 'AraC family transcriptional regulator', 89, NULL, NULL, 49616),
(49617, '3.40.50.300-FF-007522', NULL, 'AGR108Cp', 210, NULL, NULL, 49617),
(49618, '1.10.10.10-FF-000431', NULL, 'DNA-directed RNA polymerase III subunit RPC6', 85, NULL, NULL, 49618),
(49619, '3.30.200.20-FF-001561', NULL, 'Predicted protein', 121, NULL, NULL, 49619),
(49620, '2.10.25.10-FF-000406', NULL, 'CD248 molecule', 40, NULL, NULL, 49620),
(49621, '3.10.350.10-FF-000039', NULL, 'Putative membrane bound murein transglycosylase', 46, NULL, NULL, 49621),
(49622, '3.40.50.620-FF-000699', NULL, 'Asparagine synthase', 250, NULL, NULL, 49622),
(49623, '2.130.10.10-FF-003413', NULL, 'WD repeat and HMG-box DNA binding protein 1', 186, NULL, NULL, 49623),
(49624, '3.30.40.10-FF-000989', NULL, 'E3 ubiquitin-protein ligase AIP2', 83, NULL, NULL, 49624),
(49625, '3.40.50.2000-FF-000842', NULL, 'Uncharacterized protein', 54, NULL, NULL, 49625),
(49626, '3.30.420.10-FF-000265', NULL, 'DNA polymerase I', 192, NULL, NULL, 49626),
(49627, '2.60.120.200-FF-000276', NULL, 'Galectin', 133, NULL, NULL, 49627),
(49628, '3.30.160.60-FF-004155', NULL, NULL, 25, NULL, NULL, 49628),
(49629, '3.30.460.10-FF-000043', NULL, 'Putative nucleotidyltransferase', 108, NULL, NULL, 49629),
(49630, '1.20.120.450-FF-000001', NULL, 'Damage-inducible protein DinB', 167, NULL, NULL, 49630),
(49631, '3.30.420.10-FF-000607', NULL, NULL, 182, NULL, NULL, 49631),
(49632, '3.40.640.10-FF-000212', NULL, 'Gamma-aminobutyrate transaminase POP2 mitochondrial', 59, NULL, NULL, 49632),
(49633, '1.10.510.10-FF-001740', NULL, 'AEL173Wp', 245, NULL, NULL, 49633);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(49634, '2.30.30.40-FF-000640', NULL, 'Mindbomb E3 ubiquitin protein ligase 2', 81, NULL, NULL, 49634),
(49635, '2.130.10.30-FF-000081', NULL, 'Regulator of chromosome condensation (RCC1) family protein', 280, NULL, NULL, 49635),
(49636, '3.40.50.300-FF-003812', NULL, 'MCM / cell division control protein 21', 74, NULL, NULL, 49636),
(49637, '1.10.3120.10-FF-000012', NULL, 'Trigger factor', 197, NULL, NULL, 49637),
(49638, '3.70.10.10-FF-000013', NULL, 'Beta sliding clamp', 188, NULL, NULL, 49638),
(49639, '2.60.40.10-FF-004722', NULL, NULL, 97, NULL, NULL, 49639),
(49640, '1.20.140.100-FF-000024', NULL, 'Cytoplasmic dynein 1b heavy chain', 144, NULL, NULL, 49640),
(49641, '1.10.1520.10-FF-000099', NULL, 'Uncharacterized protein', 110, NULL, NULL, 49641),
(49642, '1.50.40.10-FF-000594', NULL, 'Uncharacterized protein', 153, NULL, NULL, 49642),
(49643, '2.60.40.10-FF-003429', NULL, NULL, 106, NULL, NULL, 49643),
(49644, '1.20.120.350-FF-000084', NULL, 'Cation channel sperm associated 2', 130, NULL, NULL, 49644),
(49645, '1.20.58.60-FF-000797', NULL, 'Muscle-specific protein 300 kDa, isoform B', 208, NULL, NULL, 49645),
(49646, '3.40.50.11340-FF-000012', NULL, 'Fucosyltransferase 2', 55, NULL, NULL, 49646),
(49647, '1.10.510.10-FF-000447', NULL, 'Polo-like kinase 4 (Drosophila)', 179, NULL, NULL, 49647),
(49648, '3.40.50.720-FF-000616', NULL, 'D-3-phosphoglycerate dehydrogenase 2 chloroplastic', 32, NULL, NULL, 49648),
(49649, '1.10.510.10-FF-000104', NULL, 'serine/threonine-protein kinase MAK isoform X1', 211, NULL, NULL, 49649),
(49650, '3.40.30.10-FF-000954', NULL, 'Uncharacterized protein', 106, NULL, NULL, 49650),
(49651, '3.60.10.10-FF-000098', NULL, 'Uncharacterized protein', 265, NULL, NULL, 49651),
(49652, '1.25.10.10-FF-001903', NULL, 'Armadillo repeat-containing protein', 224, NULL, NULL, 49652),
(49653, '1.10.287.1490-FF-000147', NULL, 'Uncharacterized protein', 170, NULL, NULL, 49653),
(49654, '1.25.40.20-FF-000099', NULL, 'ankyrin repeat and sterile alpha motif domain-containing protein 1B isoform X5', 120, NULL, NULL, 49654),
(49655, '3.30.420.110-FF-000014', NULL, 'DNA mismatch repair protein MutS', 121, NULL, NULL, 49655),
(49656, '1.10.220.20-FF-000006', NULL, 'F-box only protein 8', 71, NULL, NULL, 49656),
(49657, '3.30.40.10-FF-001265', NULL, 'Uncharacterized protein', 81, NULL, NULL, 49657),
(49658, '3.40.30.10-FF-001230', NULL, 'Uncharacterized protein', 110, NULL, NULL, 49658),
(49659, '2.60.120.260-FF-000378', NULL, 'Uncharacterized protein', 58, NULL, NULL, 49659),
(49660, '3.30.70.940-FF-000025', NULL, 'Transcription termination/antitermination protein NusG', 82, NULL, NULL, 49660),
(49661, '3.90.870.10-FF-000010', NULL, 'Si:ch211-153b23.4', 216, NULL, NULL, 49661),
(49662, '1.50.10.160-FF-000013', NULL, 'Putative geranyllinalool synthase', 148, NULL, NULL, 49662),
(49663, '3.30.540.10-FF-000100', NULL, 'Uncharacterized protein', 86, NULL, NULL, 49663),
(49664, '3.40.1810.10-FF-000028', NULL, 'Agamous-like MADS-box protein AGL66 isoform A', 66, NULL, NULL, 49664),
(49665, '1.20.5.170-FF-000249', NULL, 'Uncharacterized protein', 68, NULL, NULL, 49665),
(49666, '1.10.8.60-FF-000220', NULL, 'Chromosomal replication initiator protein DnaA', 73, NULL, NULL, 49666),
(49667, '2.10.25.10-FF-001025', NULL, 'Protein CBG11506', 66, NULL, NULL, 49667),
(49668, '2.30.29.30-FF-000111', NULL, 'anillin isoform X1', 133, NULL, NULL, 49668),
(49669, '2.60.40.10-FF-003761', NULL, NULL, 128, NULL, NULL, 49669),
(49670, '1.20.1070.10-FF-001230', NULL, 'Uncharacterized protein', 293, NULL, NULL, 49670),
(49671, '4.10.60.10-FF-000180', NULL, 'Predicted protein', 36, NULL, NULL, 49671),
(49672, '2.60.40.10-FF-001288', NULL, 'Embigin', 99, NULL, NULL, 49672),
(49673, '3.40.710.10-FF-000083', NULL, 'D-alanyl-D-alanine carboxypeptidase', 264, NULL, NULL, 49673),
(49674, '1.10.287.70-FF-000597', NULL, 'Uncharacterized protein', 208, NULL, NULL, 49674),
(49675, '3.40.50.300-FF-000721', NULL, 'DNA replication ATP-dependent helicase/nuclease DNA2', 101, NULL, NULL, 49675),
(49676, '3.40.50.10090-FF-000047', NULL, 'Uroporphyrinogen decarboxylase', 107, NULL, NULL, 49676);
INSERT INTO "PUBLIC"."MODEL" VALUES
(49677, '1.10.20.10-FF-000151', NULL, 'Uncharacterized protein', 86, NULL, NULL, 49677),
(49678, '3.40.190.10-FF-000918', NULL, 'Uncharacterized protein', 80, NULL, NULL, 49678),
(49679, '3.30.1370.110-FF-000011', NULL, 'Endonuclease MutS2', 87, NULL, NULL, 49679),
(49680, '1.50.10.20-FF-000084', NULL, 'Terpene cyclase/mutase family member', 352, NULL, NULL, 49680),
(49681, '3.40.50.300-FF-004431', NULL, 'Uncharacterized protein', 165, NULL, NULL, 49681),
(49682, '1.25.40.10-FF-000551', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 143, NULL, NULL, 49682),
(49683, '2.130.10.10-FF-000760', NULL, 'Splicing factor 3B subunit 3', 341, NULL, NULL, 49683),
(49684, '3.40.50.2300-FF-000718', NULL, 'Natriuretic peptide receptor 3', 103, NULL, NULL, 49684),
(49685, '1.10.510.10-FF-002701', NULL, NULL, 111, NULL, NULL, 49685),
(49686, '3.40.50.300-FF-008247', NULL, 'Uncharacterized protein', 53, NULL, NULL, 49686),
(49687, '3.30.70.330-FF-002771', NULL, NULL, 128, NULL, NULL, 49687),
(49688, '3.30.160.60-FF-003194', NULL, 'Zinc finger protein 429', 26, NULL, NULL, 49688),
(49689, '2.60.40.10-FF-002581', NULL, 'Muscle M-line assembly protein unc-89-like Protein', 108, NULL, NULL, 49689),
(49690, '3.40.1080.10-FF-000011', NULL, 'CoA-transferase (Alpha subunit)', 236, NULL, NULL, 49690),
(49691, '2.60.40.2300-FF-000006', NULL, 'Uncharacterized protein', 133, NULL, NULL, 49691),
(49692, '2.60.40.10-FF-000451', NULL, 'aggrecan core protein', 127, NULL, NULL, 49692),
(49693, '3.40.630.30-FF-000268', NULL, 'GNAT family acetyltransferase', 171, NULL, NULL, 49693),
(49694, '3.90.550.10-FF-000643', NULL, 'Uncharacterized protein', 157, NULL, NULL, 49694),
(49695, '1.10.287.110-FF-000351', NULL, 'Uncharacterized protein', 84, NULL, NULL, 49695),
(49696, '3.40.50.1910-FF-000028', NULL, 'Vacuolar protein-sorting-associated protein 33 homolog', 105, NULL, NULL, 49696),
(49697, '1.10.510.10-FF-003870', NULL, NULL, 94, NULL, NULL, 49697),
(49698, '3.30.559.10-FF-000137', NULL, 'Protein ECERIFERUM 2', 184, NULL, NULL, 49698),
(49699, '1.10.1070.11-FF-000115', NULL, 'Uncharacterized protein', 190, NULL, NULL, 49699),
(49700, '3.40.50.300-FF-000142', NULL, 'Midasin', 170, NULL, NULL, 49700),
(49701, '1.20.120.1760-FF-000058', NULL, NULL, 198, NULL, NULL, 49701),
(49702, '3.20.20.80-FF-000368', NULL, 'Os01g0942300 protein', 136, NULL, NULL, 49702),
(49703, '1.20.1070.10-FF-002192', NULL, 'Uncharacterized protein', 60, NULL, NULL, 49703),
(49704, '2.10.25.10-FF-000749', NULL, 'SP2353, isoform A', 46, NULL, NULL, 49704),
(49705, '3.40.50.1240-FF-000024', NULL, 'Periplasmic glucose-1-phosphatase', 147, NULL, NULL, 49705),
(49706, '3.30.60.20-FF-000072', NULL, 'Protein kinase C', 35, NULL, NULL, 49706),
(49707, '2.120.10.80-FF-000152', NULL, 'Gpb1p', 222, NULL, NULL, 49707),
(49708, '3.40.50.200-FF-000129', NULL, 'Uncharacterized protein', 140, NULL, NULL, 49708),
(49709, '1.20.1270.60-FF-000035', NULL, 'Sorting nexin 4', 238, NULL, NULL, 49709),
(49710, '2.60.40.790-FF-000084', NULL, 'Calcyclin binding protein, putative', 91, NULL, NULL, 49710),
(49711, '3.30.70.20-FF-000022', NULL, 'Pyruvate:ferredoxin (Flavodoxin) oxidoreductase', 118, NULL, NULL, 49711),
(49712, '3.90.226.10-FF-000154', NULL, 'Glutaconyl-CoA decarboxylase subunit alpha', 228, NULL, NULL, 49712),
(49713, '3.40.50.1820-FF-000788', NULL, 'Linear gramicidin dehydrogenase LgrE', 229, NULL, NULL, 49713),
(49714, '2.60.40.60-FF-000437', NULL, 'Dachsous, isoform B', 131, NULL, NULL, 49714),
(49715, '2.60.40.10-FF-003542', NULL, NULL, 104, NULL, NULL, 49715),
(49716, '1.10.287.110-FF-000019', NULL, 'dnaJ homolog subfamily C member 27', 80, NULL, NULL, 49716),
(49717, '3.90.1530.30-FF-000006', NULL, 'ParB-like partition protein', 61, NULL, NULL, 49717),
(49718, '1.25.40.10-FF-000894', NULL, 'Tetratricopeptide repeat domain 21B', 150, NULL, NULL, 49718),
(49719, '3.30.1300.10-FF-000003', NULL, 'PAN6 Pantoate-beta-alanine ligase, putative', 127, NULL, NULL, 49719),
(49720, '3.30.70.260-FF-000142', NULL, 'D-3-phosphoglycerate dehydrogenase', 85, NULL, NULL, 49720);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(49721, '1.20.58.2190-FF-000016', NULL, 'Uncharacterized protein', 86, NULL, NULL, 49721),
(49722, '3.40.50.1820-FF-001064', NULL, 'Glutathione S-transferase family protein', 87, NULL, NULL, 49722),
(49723, '3.10.129.10-FF-000194', NULL, 'Acyl-CoA hydrolase', 154, NULL, NULL, 49723),
(49724, '1.25.40.10-FF-001512', NULL, 'Os06g0143500 protein', 92, NULL, NULL, 49724),
(49725, '3.40.1360.10-FF-000049', NULL, 'Type IIB DNA topoisomerase family protein', 212, NULL, NULL, 49725),
(49726, '3.30.230.70-FF-000100', NULL, 'Uncharacterized protein', 230, NULL, NULL, 49726),
(49727, '3.10.20.90-FF-000237', NULL, 'BAG family molecular chaperone regulator 1', 72, NULL, NULL, 49727),
(49728, '3.40.50.1110-FF-000108', NULL, 'GDSL esterase/lipase At3g05180', 343, NULL, NULL, 49728),
(49729, '1.10.287.950-FF-000035', NULL, 'Methyl-accepting chemotaxis sensory transducer, class 40+24H', 109, NULL, NULL, 49729),
(49730, '1.20.1250.20-FF-001343', NULL, 'MFS general substrate transporter', 207, NULL, NULL, 49730),
(49731, '3.40.50.300-FF-007286', NULL, 'Uncharacterized protein', 282, NULL, NULL, 49731),
(49732, '1.25.10.10-FF-000723', NULL, 'Receptor mediated endocytosis 8, isoform B', 259, NULL, NULL, 49732),
(49733, '3.40.630.10-FF-000262', NULL, 'Uncharacterized protein, isoform B', 309, NULL, NULL, 49733),
(49734, '3.40.50.1370-FF-000046', NULL, NULL, 130, NULL, NULL, 49734),
(49735, '1.10.1450.10-FF-000104', NULL, 'Tetraspanin', 109, NULL, NULL, 49735),
(49736, '1.25.40.10-FF-001170', NULL, 'Uncharacterized protein', 192, NULL, NULL, 49736),
(49737, '2.60.40.1120-FF-000074', NULL, 'Uncharacterized protein', 80, NULL, NULL, 49737),
(49738, '3.40.50.1820-FF-001406', NULL, 'GPI inositol-deacylase', 209, NULL, NULL, 49738),
(49739, '3.30.200.20-FF-000162', NULL, 'Adenine nucleotide alpha hydrolase-like domain kinase', 104, NULL, NULL, 49739),
(49740, '3.40.50.880-FF-000170', NULL, 'Putative glutathione-independent glyoxalase hsp3105', 237, NULL, NULL, 49740),
(49741, '3.60.20.40-FF-000046', NULL, 'Uncharacterized protein', 182, NULL, NULL, 49741),
(49742, '3.40.50.300-FF-007628', NULL, 'Predicted protein', 146, NULL, NULL, 49742),
(49743, '3.30.200.20-FF-000504', NULL, 'Non-specific serine/threonine protein kinase', 11, NULL, NULL, 49743),
(49744, '3.40.1000.50-FF-000001', NULL, 'Repressor of RNA polymerase III transcription MAF1', 52, NULL, NULL, 49744),
(49745, '1.20.1560.10-FF-000711', NULL, 'ABC transporter ATP-binding protein RamA', 298, NULL, NULL, 49745),
(49746, '2.60.120.650-FF-000169', NULL, 'Lysine-specific demethylase REF6', 180, NULL, NULL, 49746),
(49747, '1.25.40.10-FF-000219', NULL, 'Tetratricopeptide repeat domain 21B', 236, NULL, NULL, 49747),
(49748, '3.40.50.11380-FF-000013', NULL, NULL, 204, NULL, NULL, 49748),
(49749, '3.30.200.20-FF-000847', NULL, 'Protein kinase family protein with leucine-rich repeat domain', 92, NULL, NULL, 49749),
(49750, '3.40.190.10-FF-000233', NULL, 'Membrane-bound lytic murein transglycosylase F', 96, NULL, NULL, 49750),
(49751, '3.40.30.10-FF-000499', NULL, 'Glutathione S-transferase', 191, NULL, NULL, 49751),
(49752, '1.25.40.20-FF-001392', NULL, 'Uncharacterized protein', 55, NULL, NULL, 49752),
(49753, '1.25.40.20-FF-000773', NULL, 'Ankyrin repeat domain-containing protein', 147, NULL, NULL, 49753),
(49754, '1.20.144.10-FF-000026', NULL, 'Lipid phosphate phosphatase epsilon 2 chloroplastic', 95, NULL, NULL, 49754),
(49755, '3.40.50.300-FF-002396', NULL, 'Cell division inhibitor SulA', 119, NULL, NULL, 49755),
(49756, '1.10.510.10-FF-003538', NULL, NULL, 236, NULL, NULL, 49756),
(49757, '3.90.180.10-FF-000047', NULL, '(R)-specific carbonyl reductase', 185, NULL, NULL, 49757),
(49758, '3.90.1660.10-FF-000004', NULL, 'Coenzyme F420:L-glutamate ligase', 87, NULL, NULL, 49758),
(49759, '2.60.40.10-FF-004503', NULL, NULL, 98, NULL, NULL, 49759),
(49760, '1.25.40.10-FF-001855', NULL, 'AGAP002782-PA', 157, NULL, NULL, 49760),
(49761, '1.20.1250.20-FF-000382', NULL, 'Nitrate transporter CrnA', 198, NULL, NULL, 49761),
(49762, '2.40.70.10-FF-000335', NULL, NULL, 166, NULL, NULL, 49762);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(49763, '3.30.40.10-FF-001826', NULL, 'Predicted protein', 110, NULL, NULL, 49763),
(49764, '2.60.40.60-FF-000218', NULL, 'Protocadherin-20', 147, NULL, NULL, 49764),
(49765, '1.25.10.10-FF-000162', NULL, 'GCN1, eIF2 alpha kinase activator homolog', 239, NULL, NULL, 49765),
(49766, '3.40.366.10-FF-000001', NULL, 'Malonyl CoA-acyl carrier protein transacylase', 210, NULL, NULL, 49766),
(49767, '1.10.510.10-FF-004157', NULL, NULL, 202, NULL, NULL, 49767),
(49768, '3.40.50.300-FF-007067', NULL, 'Uncharacterized protein', 194, NULL, NULL, 49768),
(49769, '3.30.40.10-FF-002102', NULL, 'Uncharacterized protein', 71, NULL, NULL, 49769),
(49770, '3.30.40.10-FF-001484', NULL, 'Protein CBG04193', 82, NULL, NULL, 49770),
(49771, '1.10.238.10-FF-000527', NULL, 'Calmodulin-3', 148, NULL, NULL, 49771),
(49772, '3.40.50.1820-FF-001625', NULL, 'Carboxylic ester hydrolase', 495, NULL, NULL, 49772),
(49773, '3.40.50.620-FF-000356', NULL, 'Os02g0722001 protein', 158, NULL, NULL, 49773),
(49774, '2.60.40.1390-FF-000014', NULL, 'Rep1p', 214, NULL, NULL, 49774),
(49775, '3.30.2290.10-FF-000006', NULL, 'Modulator of DNA gyrase', 227, NULL, NULL, 49775),
(49776, '1.10.260.40-FF-000009', NULL, 'Hepatocyte nuclear factor 1-beta', 98, NULL, NULL, 49776),
(49777, '3.90.470.20-FF-000027', NULL, 'Enterobactin synthase component D', 20, NULL, NULL, 49777),
(49778, '3.40.190.10-FF-000014', NULL, 'Arginine ABC transporter substrate-binding protein', 94, NULL, NULL, 49778),
(49779, '3.30.200.20-FF-001123', NULL, 'Predicted protein', 94, NULL, NULL, 49779),
(49780, '3.30.160.60-FF-004716', NULL, NULL, 38, NULL, NULL, 49780),
(49781, '1.25.40.10-FF-002131', NULL, 'Putative pentatricopeptide repeat-containing protein At5g09950', 119, NULL, NULL, 49781),
(49782, '1.10.472.170-FF-000015', NULL, 'Transcription initiation factor IIB', 186, NULL, NULL, 49782),
(49783, '1.25.40.10-FF-001731', NULL, 'AGAP000136-PA', 115, NULL, NULL, 49783),
(49784, '3.90.70.10-FF-000527', NULL, 'Putative ubiquitin hydrolase putative cysteine peptidase Clan CA family C19', 83, NULL, NULL, 49784),
(49785, '3.30.565.10-FF-000522', NULL, 'Two component signal transduction system histidine kinase', 145, NULL, NULL, 49785),
(49786, '2.10.50.10-FF-000026', NULL, 'Tumor necrosis factor receptor superfamily member 4', 84, NULL, NULL, 49786),
(49787, '3.40.50.2020-FF-000163', NULL, 'Ribose phosphate pyrophosphokinase NadR', 150, NULL, NULL, 49787),
(49788, '1.10.3720.10-FF-000092', NULL, 'Iron ABC transporter permease', 256, NULL, NULL, 49788),
(49789, '1.20.1270.60-FF-000254', NULL, 'Inositol-pentakisphosphate 2-kinase', 212, NULL, NULL, 49789),
(49790, '2.40.50.140-FF-000289', NULL, 'Chromosome 1, whole genome shotgun sequence', 83, NULL, NULL, 49790),
(49791, '3.80.10.10-FF-001221', NULL, 'Leucine_rich_repeat/Leucine_Rich_Repeat_-_putative', 164, NULL, NULL, 49791),
(49792, '1.10.510.10-FF-000228', NULL, 'cyclin-G-associated kinase isoform X1', 313, NULL, NULL, 49792),
(49793, '3.90.660.10-FF-000073', NULL, NULL, 87, NULL, NULL, 49793),
(49794, '3.40.50.2300-FF-000033', NULL, 'Amino acid ABC transporter substrate-binding protein', 129, NULL, NULL, 49794),
(49795, '3.30.160.60-FF-000321', NULL, 'myeloid zinc finger 1 isoform X1', 28, NULL, NULL, 49795),
(49796, '3.30.70.3170-FF-000004', NULL, 'Galactokinase family protein', 24, NULL, NULL, 49796),
(49797, '3.30.2320.10-FF-000004', NULL, NULL, 102, NULL, NULL, 49797),
(49798, '1.20.1310.10-FF-000092', NULL, 'Cullin family protein', 104, NULL, NULL, 49798),
(49799, '3.90.550.10-FF-000300', NULL, 'UDP-sugar pyrophosphorylase', 472, NULL, NULL, 49799),
(49800, '3.40.50.10190-FF-000307', NULL, 'DNA repair and telomere maintenance protein nbs1', 101, NULL, NULL, 49800),
(49801, '3.30.420.510-FF-000027', NULL, 'Type II pantothenate kinase', 168, NULL, NULL, 49801),
(49802, '3.20.20.10-FF-000044', NULL, 'Alanine racemase', 206, NULL, NULL, 49802),
(49803, '2.60.40.10-FF-002249', NULL, 'Uncharacterized protein, isoform G', 95, NULL, NULL, 49803),
(49804, '1.20.1250.20-FF-000943', NULL, 'Amino acid/peptide transporter family protein', 235, NULL, NULL, 49804);
INSERT INTO "PUBLIC"."MODEL" VALUES
(49805, '2.60.120.1040-FF-000016', NULL, NULL, 75, NULL, NULL, 49805),
(49806, '1.20.1070.10-FF-001573', NULL, 'Predicted protein', 163, NULL, NULL, 49806),
(49807, '3.40.109.10-FF-000045', NULL, 'Uncharacterized protein', 139, NULL, NULL, 49807),
(49808, '3.50.50.60-FF-000402', NULL, 'Flavoprotein monooxygenase, putative', 141, NULL, NULL, 49808),
(49809, '1.20.5.110-FF-000041', NULL, 'Synaptosomal-associated protein 29', 78, NULL, NULL, 49809),
(49810, '1.10.287.70-FF-000254', NULL, 'CRE-TWK-16 protein', 287, NULL, NULL, 49810),
(49811, '2.130.10.10-FF-003851', NULL, 'Uncharacterized protein', 289, NULL, NULL, 49811),
(49812, '2.30.30.40-FF-000185', NULL, 'brain-specific angiogenesis inhibitor 1-associated protein 2-like protein 2', 66, NULL, NULL, 49812),
(49813, '2.30.29.170-FF-000007', NULL, 'EF-Hand domain-Containing protein 1 homolog', 119, NULL, NULL, 49813),
(49814, '1.20.120.850-FF-000008', NULL, 'DsDNA-dependent ATPase (Rad54b), putative', 104, NULL, NULL, 49814),
(49815, '1.25.10.10-FF-002005', NULL, 'ARM repeat superfamily protein', 223, NULL, NULL, 49815),
(49816, '1.10.10.60-FF-000142', NULL, 'homeobox protein OTX2 isoform X2', 79, NULL, NULL, 49816),
(49817, '3.40.50.300-FF-007921', NULL, 'Uncharacterized protein', 176, NULL, NULL, 49817),
(49818, '1.25.40.470-FF-000077', NULL, 'Uncharacterized protein', 120, NULL, NULL, 49818),
(49819, '3.20.20.220-FF-000021', NULL, 'Aldehyde dehydrogenase family protein', 412, NULL, NULL, 49819),
(49820, '3.80.10.10-FF-003312', NULL, 'Uncharacterized protein', 185, NULL, NULL, 49820),
(49821, '3.30.160.60-FF-002715', NULL, NULL, 28, NULL, NULL, 49821),
(49822, '1.25.40.10-FF-003614', NULL, 'Pentatricopeptide repeat-containing protein At1g12300, mitochondrial', 104, NULL, NULL, 49822),
(49823, '3.40.50.1820-FF-000872', NULL, 'Uncharacterized protein', 277, NULL, NULL, 49823),
(49824, '2.10.220.10-FF-000005', NULL, 'Tyrosine-protein kinase receptor', 69, NULL, NULL, 49824),
(49825, '2.60.40.10-FF-003694', NULL, NULL, 81, NULL, NULL, 49825),
(49826, '3.90.226.10-FF-000070', NULL, 'Enoyl-CoA hydratase/isomerase family protein', 214, NULL, NULL, 49826),
(49827, '3.30.590.50-FF-000019', NULL, 'Uncharacterized protein', 94, NULL, NULL, 49827),
(49828, '1.10.238.10-FF-000544', NULL, 'Serine/threonine-protein phosphatase', 179, NULL, NULL, 49828),
(49829, '3.40.390.30-FF-000007', NULL, 'Predicted protein', 96, NULL, NULL, 49829),
(49830, '1.20.5.500-FF-000017', NULL, NULL, 46, NULL, NULL, 49830),
(49831, '3.40.50.300-FF-001968', NULL, 'ATP-dependent DNA helicase CHL1', 240, NULL, NULL, 49831),
(49832, '3.40.50.620-FF-000339', NULL, 'Cysteine--tRNA ligase', 307, NULL, NULL, 49832),
(49833, '1.20.1070.10-FF-000887', NULL, 'Olfactory receptor 1487', 111, NULL, NULL, 49833),
(49834, '3.30.70.330-FF-003075', NULL, NULL, 98, NULL, NULL, 49834),
(49835, '3.30.160.60-FF-003817', NULL, NULL, 79, NULL, NULL, 49835),
(49836, '3.30.530.20-FF-000001', NULL, 'Phosphatidylinositol transfer protein membrane associated 2', 271, NULL, NULL, 49836),
(49837, '1.10.510.10-FF-003696', NULL, NULL, 166, NULL, NULL, 49837),
(49838, '1.10.510.10-FF-000470', NULL, 'Ephrin type-B receptor 6', 181, NULL, NULL, 49838),
(49839, '1.10.510.10-FF-002122', NULL, NULL, 107, NULL, NULL, 49839),
(49840, '1.10.8.60-FF-000568', NULL, 'Uncharacterized protein', 77, NULL, NULL, 49840),
(49841, '1.10.3470.10-FF-000004', NULL, 'Iron compound ABC transporter, permease', 322, NULL, NULL, 49841),
(49842, '1.20.120.350-FF-000246', NULL, NULL, 105, NULL, NULL, 49842),
(49843, '2.30.30.140-FF-000287', NULL, 'Uncharacterized protein', 87, NULL, NULL, 49843),
(49844, '3.10.105.10-FF-000127', NULL, 'Predicted protein', 75, NULL, NULL, 49844),
(49845, '3.40.50.1000-FF-000160', NULL, 'HAD hydrolase, family IA', 142, NULL, NULL, 49845),
(49846, '3.40.50.150-FF-001581', NULL, NULL, 50, NULL, NULL, 49846),
(49847, '1.10.10.60-FF-001244', NULL, NULL, 43, NULL, NULL, 49847),
(49848, '3.40.50.10190-FF-000145', NULL, 'Microcephalin, isoform D', 86, NULL, NULL, 49848),
(49849, '1.10.10.10-FF-000234', NULL, 'Vacuolar-sorting protein SNF8', 86, NULL, NULL, 49849);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(49850, '4.10.280.10-FF-000108', NULL, 'Basic helix-loop-helix transcription factor', 56, NULL, NULL, 49850),
(49851, '3.40.50.300-FF-000507', NULL, 'Pre-mRNA-splicing factor', 193, NULL, NULL, 49851),
(49852, '3.30.110.120-FF-000003', NULL, 'Carbamoyltransferase', 21, NULL, NULL, 49852),
(49853, '3.10.580.10-FF-000219', NULL, 'Chloride channel protein EriC', 117, NULL, NULL, 49853),
(49854, '1.20.1740.10-FF-000208', NULL, 'Uncharacterized protein', 143, NULL, NULL, 49854),
(49855, '1.10.20.10-FF-000206', NULL, NULL, 120, NULL, NULL, 49855),
(49856, '3.40.50.300-FF-005830', NULL, 'ABC transporter B family member 7', 272, NULL, NULL, 49856),
(49857, '3.30.230.10-FF-000099', NULL, 'Elongation factor Tu, putative', 275, NULL, NULL, 49857),
(49858, '1.25.40.180-FF-000108', NULL, 'MIF4G domain-containing protein A', 223, NULL, NULL, 49858),
(49859, '2.130.10.10-FF-002244', NULL, 'Protein transport protein sec13, putative', 324, NULL, NULL, 49859),
(49860, '3.40.50.1010-FF-000163', NULL, NULL, 108, NULL, NULL, 49860),
(49861, '2.60.120.620-FF-000109', NULL, 'Predicted protein', 174, NULL, NULL, 49861),
(49862, '3.40.1000.30-FF-000006', NULL, 'Chromosome 8, whole genome shotgun sequence', 171, NULL, NULL, 49862),
(49863, '1.20.58.60-FF-000768', NULL, 'Protein CBG15811', 246, NULL, NULL, 49863),
(49864, '3.30.420.40-FF-000504', NULL, 'Cell division protein FtsA', 85, NULL, NULL, 49864),
(49865, '3.50.50.60-FF-000796', NULL, 'Chromosome 1, whole genome shotgun sequence', 345, NULL, NULL, 49865),
(49866, '2.60.40.10-FF-006009', NULL, NULL, 74, NULL, NULL, 49866),
(49867, '3.30.40.10-FF-000287', NULL, 'RING finger membrane protein', 74, NULL, NULL, 49867),
(49868, '3.30.70.330-FF-000848', NULL, 'Sgn1p', 144, NULL, NULL, 49868),
(49869, '3.30.590.20-FF-000010', NULL, 'Glutamate--cysteine ligase', 446, NULL, NULL, 49869),
(49870, '1.20.1280.50-FF-000033', NULL, 'F-box only protein 31', 90, NULL, NULL, 49870),
(49871, '1.20.1270.10-FF-000043', NULL, 'Heat shock 70 kDa protein 15-like', 87, NULL, NULL, 49871),
(49872, '1.20.5.690-FF-000001', NULL, 'Importin subunit alpha', 42, NULL, NULL, 49872),
(49873, '2.60.40.10-FF-002120', NULL, 'obscurin-like isoform X3', 93, NULL, NULL, 49873),
(49874, '3.20.20.140-FF-000295', NULL, 'AaceriAER218Cp', 445, NULL, NULL, 49874),
(49875, '2.130.10.10-FF-001581', NULL, 'Polycomb protein mes-6', 393, NULL, NULL, 49875),
(49876, '3.40.1190.20-FF-000196', NULL, NULL, 238, NULL, NULL, 49876),
(49877, '4.10.220.40-FF-000001', NULL, NULL, 50, NULL, NULL, 49877),
(49878, '3.30.450.40-FF-000006', NULL, 'Phytochrome', 210, NULL, NULL, 49878),
(49879, '3.30.40.10-FF-000966', NULL, 'E3 ubiquitin-protein ligase CCNB1IP1 homolog', 78, NULL, NULL, 49879),
(49880, '1.20.58.60-FF-000089', NULL, 'microtubule-actin cross-linking factor 1 isoform X9', 113, NULL, NULL, 49880),
(49881, '2.40.50.140-FF-001172', NULL, NULL, 50, NULL, NULL, 49881),
(49882, '2.40.70.10-FF-000133', NULL, 'Cathepsin E-like protease', 131, NULL, NULL, 49882),
(49883, '3.30.450.50-FF-000009', NULL, 'Vesicle-associated membrane protein 724', 127, NULL, NULL, 49883),
(49884, '2.130.10.10-FF-002570', NULL, 'Uncharacterized protein', 90, NULL, NULL, 49884),
(49885, '1.20.5.170-FF-000227', NULL, 'BZIP transcription factor bZIP44', 83, NULL, NULL, 49885),
(49886, '1.20.1060.10-FF-000004', NULL, 'Plastid replication-repair enzyme', 113, NULL, NULL, 49886),
(49887, '1.25.10.10-FF-001342', NULL, 'Uncharacterized protein', 350, NULL, NULL, 49887),
(49888, '2.60.40.10-FF-004211', NULL, NULL, 74, NULL, NULL, 49888),
(49889, '3.40.50.11000-FF-000006', NULL, 'Fe-S cluster assembly protein DRE2', 148, NULL, NULL, 49889),
(49890, '1.25.10.10-FF-003466', NULL, 'Uncharacterized protein', 69, NULL, NULL, 49890),
(49891, '2.130.10.10-FF-003672', NULL, 'Uncharacterized protein', 189, NULL, NULL, 49891),
(49892, '2.60.40.10-FF-000142', NULL, 'V-set domain-containing T-cell activation inhibitor 1', 121, NULL, NULL, 49892),
(49893, '1.20.5.110-FF-000316', NULL, 'Vesicle transport through interaction with t-SNAREs 1b, isoform B', 48, NULL, NULL, 49893);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(49894, '1.20.1560.10-FF-000469', NULL, 'Antibiotic ABC transporter ATP-binding protein', 320, NULL, NULL, 49894),
(49895, '3.30.160.60-FF-001726', NULL, 'Zinc finger protein 275', 25, NULL, NULL, 49895),
(49896, '3.30.930.10-FF-000366', NULL, 'Uncharacterized protein', 173, NULL, NULL, 49896),
(49897, '1.10.287.660-FF-000032', NULL, 'Uncharacterized protein', 77, NULL, NULL, 49897),
(49898, '3.90.190.10-FF-000407', NULL, 'Uncharacterized protein', 110, NULL, NULL, 49898),
(49899, '1.10.287.3700-FF-000001', NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', 94, NULL, NULL, 49899),
(49900, '2.40.50.40-FF-000085', NULL, 'Chromo domain-containing protein 1', 62, NULL, NULL, 49900),
(49901, '1.20.1250.20-FF-000988', NULL, 'MFS multidrug transporter, putative', 441, NULL, NULL, 49901),
(49902, '3.40.50.1820-FF-001535', NULL, 'Ndrg family member 3a', 140, NULL, NULL, 49902),
(49903, '3.50.50.60-FF-001313', NULL, 'Uncharacterized protein', 126, NULL, NULL, 49903),
(49904, '2.40.10.10-FF-000124', NULL, 'Cationic trypsin', 102, NULL, NULL, 49904),
(49905, '1.10.238.110-FF-000015', NULL, 'Diacylglycerol kinase', 105, NULL, NULL, 49905),
(49906, '1.10.10.10-FF-001662', NULL, 'Winged helix-turn-helix transcriptional regulator, MarR family', 140, NULL, NULL, 49906),
(49907, '1.20.1060.20-FF-000007', NULL, 'Structural maintenance of chromosomes protein', 102, NULL, NULL, 49907),
(49908, '1.25.40.10-FF-005059', NULL, 'Pentatricopeptide repeat-containing protein At1g62670, mitochondrial', 107, NULL, NULL, 49908),
(49909, '1.10.1740.10-FF-000014', NULL, 'RNA polymerase sigma factor', 72, NULL, NULL, 49909),
(49910, '3.40.395.10-FF-000023', NULL, 'Ulp1 protease family c-terminal catalytic domain co', 211, NULL, NULL, 49910),
(49911, '2.30.40.10-FF-000093', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 77, NULL, NULL, 49911),
(49912, '3.90.190.10-FF-000087', NULL, 'Tyrosine-protein phosphatase non-receptor type 20', 306, NULL, NULL, 49912),
(49913, '3.30.420.110-FF-000031', NULL, 'DNA mismatch repair protein', 151, NULL, NULL, 49913),
(49914, '3.40.50.12780-FF-000096', NULL, 'Peptide synthetase Nrp', 379, NULL, NULL, 49914),
(49915, '2.30.30.100-FF-000236', NULL, 'Bifunctional ligase/repressor BirA', 50, NULL, NULL, 49915),
(49916, '1.10.287.70-FF-000288', NULL, 'Two pore potassium channel protein sup-9', 268, NULL, NULL, 49916),
(49917, '1.10.510.10-FF-000144', NULL, 'Cyclin-dependent kinase 2', 211, NULL, NULL, 49917),
(49918, '3.40.50.300-FF-007275', NULL, 'Uncharacterized protein', 155, NULL, NULL, 49918),
(49919, '2.10.25.10-FF-001704', NULL, 'Uncharacterized protein', 41, NULL, NULL, 49919),
(49920, '1.20.1070.10-FF-001404', NULL, 'Olfactory receptor family 2 subfamily T member 11 (gene/pseudogene)', 236, NULL, NULL, 49920),
(49921, '1.20.810.10-FF-000018', NULL, 'Cytochrome b mRNA maturase bI3', 238, NULL, NULL, 49921),
(49922, '1.10.1450.10-FF-000093', NULL, 'Tetraspanin', 106, NULL, NULL, 49922),
(49923, '3.10.20.90-FF-000810', NULL, 'Ubiquitin family protein', 87, NULL, NULL, 49923),
(49924, '1.10.510.10-FF-004213', NULL, NULL, 214, NULL, NULL, 49924),
(49925, '2.40.33.10-FF-000047', NULL, 'Pyruvate kinase', 17, NULL, NULL, 49925),
(49926, '3.40.50.300-FF-001289', NULL, 'RAB7a, member RAS oncogene family', 59, NULL, NULL, 49926),
(49927, '1.25.10.10-FF-001488', NULL, 'AP complex subunit beta', 623, NULL, NULL, 49927),
(49928, '3.30.160.60-FF-006077', NULL, NULL, 53, NULL, NULL, 49928),
(49929, '1.10.287.110-FF-000362', NULL, 'Co-chaperone Hsc20 family protein', 112, NULL, NULL, 49929),
(49930, '3.60.21.60-FF-000026', NULL, 'DNA polymerase epsilon subunit b, putative', 184, NULL, NULL, 49930),
(49931, '3.30.360.10-FF-000018', NULL, 'Glucose-6-phosphate 1-dehydrogenase', 310, NULL, NULL, 49931),
(49932, '3.40.50.360-FF-000098', NULL, 'Flavodoxin family protein', 168, NULL, NULL, 49932),
(49933, '3.30.300.10-FF-000009', NULL, 'GMP synthase [glutamine-hydrolyzing]', 133, NULL, NULL, 49933),
(49934, '3.30.200.20-FF-001382', NULL, 'Uncharacterized protein', 90, NULL, NULL, 49934),
(49935, '1.20.1250.20-FF-001505', NULL, 'Uncharacterized protein', 189, NULL, NULL, 49935);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(49936, '2.40.50.120-FF-000058', NULL, 'Uncharacterized protein', 128, NULL, NULL, 49936),
(49937, '3.40.50.2300-FF-001253', NULL, NULL, 97, NULL, NULL, 49937),
(49938, '1.10.8.10-FF-000340', NULL, 'Toll interacting protein', 29, NULL, NULL, 49938),
(49939, '1.10.506.10-FF-000100', NULL, 'Uncharacterized protein', 76, NULL, NULL, 49939),
(49940, '2.30.39.10-FF-000055', NULL, 'GM21844', 127, NULL, NULL, 49940),
(49941, '3.30.470.20-FF-000176', NULL, 'Inositol-tetrakisphosphate 1-kinase', 90, NULL, NULL, 49941),
(49942, '1.10.1410.10-FF-000028', NULL, 'U3 small nucleolar RNA-associated protein 22', 45, NULL, NULL, 49942),
(49943, '3.60.21.50-FF-000023', NULL, 'Predicted protein', 170, NULL, NULL, 49943),
(49944, '3.30.70.660-FF-000037', NULL, 'tRNA pseudouridine synthase A', 135, NULL, NULL, 49944),
(49945, '3.40.1110.10-FF-000328', NULL, NULL, 237, NULL, NULL, 49945),
(49946, '3.70.10.10-FF-000047', NULL, 'Cell cycle checkpoint protein', 180, NULL, NULL, 49946),
(49947, '1.25.40.10-FF-003294', NULL, 'Protein kinase, putative', 168, NULL, NULL, 49947),
(49948, '3.40.630.30-FF-000515', NULL, 'Uncharacterized protein', 77, NULL, NULL, 49948),
(49949, '3.30.160.60-FF-003497', NULL, 'Zinc finger protein 142', 86, NULL, NULL, 49949),
(49950, '1.50.40.10-FF-000442', NULL, 'Uncharacterized protein', 150, NULL, NULL, 49950),
(49951, '2.30.30.40-FF-000550', NULL, 'Calcium voltage-gated channel auxiliary subunit beta 3', 79, NULL, NULL, 49951),
(49952, '3.40.910.10-FF-000019', NULL, 'Uncharacterized protein', 178, NULL, NULL, 49952),
(49953, '3.90.980.20-FF-000010', NULL, 'Set1/Ash2 histone methyltransferase complex subunit ash-2', 174, NULL, NULL, 49953),
(49954, '2.130.10.30-FF-000159', NULL, NULL, 131, NULL, NULL, 49954),
(49955, '3.30.70.330-FF-002765', NULL, NULL, 78, NULL, NULL, 49955),
(49956, '2.120.10.80-FF-000062', NULL, 'Putative LOV domain-containing protein', 136, NULL, NULL, 49956),
(49957, '1.20.120.1760-FF-000030', NULL, 'Cardiolipin synthase, putative', 192, NULL, NULL, 49957),
(49958, '3.40.50.300-FF-005976', NULL, 'Type VI secretion system ATPase TssH', 209, NULL, NULL, 49958),
(49959, '2.60.40.10-FF-003368', NULL, NULL, 57, NULL, NULL, 49959),
(49960, '3.30.710.10-FF-000355', NULL, 'Protein abrupt', 149, NULL, NULL, 49960),
(49961, '2.30.30.1020-FF-000017', NULL, 'CCR4-NOT transcription complex, subunit 2', 47, NULL, NULL, 49961),
(49962, '3.40.720.10-FF-000275', NULL, 'Sulfatase 1', 357, NULL, NULL, 49962),
(49963, '3.40.30.10-FF-000853', NULL, 'Protein disulfide-isomerase', 98, NULL, NULL, 49963),
(49964, '2.60.40.10-FF-002266', NULL, '1,4-alpha-glucan-branching enzyme', 117, NULL, NULL, 49964),
(49965, '3.40.50.720-FF-000869', NULL, 'Pteridine reductase', 267, NULL, NULL, 49965),
(49966, '3.30.40.10-FF-001276', NULL, 'RNA binding (RRM/RBD/RNP motifs) family protein', 72, NULL, NULL, 49966),
(49967, '2.130.10.10-FF-005650', NULL, 'Uncharacterized protein', 170, NULL, NULL, 49967),
(49968, '3.60.40.10-FF-000336', NULL, 'Uncharacterized protein', 141, NULL, NULL, 49968),
(49969, '3.40.50.150-FF-000327', NULL, 'Unplaced genomic scaffold supercont2.6, whole genome shotgun sequence', 167, NULL, NULL, 49969),
(49970, '1.10.1070.11-FF-000025', NULL, 'Serine/threonine-protein kinase Tel1', 172, NULL, NULL, 49970),
(49971, '2.130.10.10-FF-000153', NULL, 'WD and tetratricopeptide repeats protein 1', 266, NULL, NULL, 49971),
(49972, '3.30.70.330-FF-001837', NULL, NULL, 117, NULL, NULL, 49972),
(49973, '3.40.50.720-FF-001212', NULL, 'Short chain dehydrogenase', 242, NULL, NULL, 49973),
(49974, '3.40.109.10-FF-000062', NULL, 'Uncharacterized protein', 174, NULL, NULL, 49974),
(49975, '3.40.120.10-FF-000072', NULL, 'Phosphoacetylglucosamine mutase', 147, NULL, NULL, 49975),
(49976, '1.20.120.1370-FF-000003', NULL, 'Regulator of sigma D', 157, NULL, NULL, 49976),
(49977, '3.40.50.300-FF-000833', NULL, 'F-box DNA helicase 1', 153, NULL, NULL, 49977),
(49978, '3.40.605.10-FF-000024', NULL, 'Aldehyde dehydrogenase', 149, NULL, NULL, 49978),
(49979, '3.30.390.30-FF-000032', NULL, 'Pyridine nucleotide-disulfide oxidoreductase', 115, NULL, NULL, 49979);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(49980, '3.30.43.10-FF-000001', NULL, 'Xanthine dehydrogenase/oxidase', 64, NULL, NULL, 49980),
(49981, '2.60.120.200-FF-000658', NULL, 'EGF family domaincontaining protein', 86, NULL, NULL, 49981),
(49982, '2.40.50.590-FF-000002', NULL, 'DNA polymerase', 70, NULL, NULL, 49982),
(49983, '1.10.10.10-FF-001369', NULL, 'Transcriptional regulator, IclR family', 60, NULL, NULL, 49983),
(49984, '3.40.710.10-FF-000190', NULL, 'D-alanyl-D-alanine endopeptidase', 262, NULL, NULL, 49984),
(49985, '2.80.10.50-FF-000263', NULL, 'Beta-porphyranase A', 126, NULL, NULL, 49985),
(49986, '2.60.40.10-FF-001277', NULL, 'sialoadhesin isoform X1', 101, NULL, NULL, 49986),
(49987, '3.80.10.10-FF-002795', NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase At3g28040', 105, NULL, NULL, 49987),
(49988, '2.60.40.60-FF-000050', NULL, 'protocadherin-15 isoform X1', 108, NULL, NULL, 49988),
(49989, '1.20.58.340-FF-000008', NULL, 'CorA family metal ion transporter', 77, NULL, NULL, 49989),
(49990, '1.20.58.390-FF-000242', NULL, 'AGAP009493-PA', 159, NULL, NULL, 49990),
(49991, '1.10.472.80-FF-000165', NULL, NULL, 140, NULL, NULL, 49991),
(49992, '3.40.50.720-FF-001358', NULL, 'At1g19690', 301, NULL, NULL, 49992),
(49993, '3.30.160.60-FF-005088', NULL, NULL, 24, NULL, NULL, 49993),
(49994, '1.25.10.10-FF-000240', NULL, 'TELO2-interacting protein 1 homolog', 173, NULL, NULL, 49994),
(49995, '3.30.160.60-FF-002362', NULL, 'Zinc finger protein 620', 26, NULL, NULL, 49995),
(49996, '3.30.1390.30-FF-000014', NULL, NULL, 77, NULL, NULL, 49996),
(49997, '3.60.21.10-FF-000005', NULL, 'Serine/threonine-protein phosphatase', 303, NULL, NULL, 49997),
(49998, '1.10.1440.10-FF-000002', NULL, 'Apolipoprotein C-II', 77, NULL, NULL, 49998),
(49999, '3.40.50.410-FF-000248', NULL, 'Methanol oxidation protein', 204, NULL, NULL, 49999),
(50000, '3.30.1390.20-FF-000011', NULL, '50S ribosomal protein L30', 59, NULL, NULL, 50000),
(50001, '3.30.200.20-FF-001443', NULL, 'Cyclin-dependent kinase 19', 43, NULL, NULL, 50001),
(50002, '1.10.287.110-FF-000036', NULL, 'dnaJ homolog subfamily C member 25', 110, NULL, NULL, 50002),
(50003, '1.10.287.2250-FF-000004', NULL, 'Si:dkey-267n13.1', 81, NULL, NULL, 50003),
(50004, '1.10.30.10-FF-000090', NULL, 'High mobility group protein 2', 98, NULL, NULL, 50004),
(50005, '1.25.40.10-FF-004603', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic/mitochondrial', 165, NULL, NULL, 50005),
(50006, '2.70.170.10-FF-000021', NULL, 'Gamma-aminobutyric acid receptor isoform 3b', 208, NULL, NULL, 50006),
(50007, '3.30.420.40-FF-000830', NULL, 'Actin-like protein arp5', 32, NULL, NULL, 50007),
(50008, '1.10.246.20-FF-000004', NULL, 'Mediator of RNA polymerase II transcription subunit 15', 52, NULL, NULL, 50008),
(50009, '3.30.200.20-FF-001589', NULL, NULL, 115, NULL, NULL, 50009),
(50010, '3.10.20.90-FF-000164', NULL, 'UBX domain-containing protein 2A', 125, NULL, NULL, 50010),
(50011, '2.130.10.10-FF-005796', NULL, 'Uncharacterized protein', 94, NULL, NULL, 50011),
(50012, '2.60.120.330-FF-000085', NULL, '1-aminocyclopropane-1-carboxylate oxidase 1', 195, NULL, NULL, 50012),
(50013, '3.30.420.10-FF-000136', NULL, 'Poly(A)-specific ribonuclease PARN', 219, NULL, NULL, 50013),
(50014, '2.102.10.10-FF-000071', NULL, 'Aromatic 1,2-dioxygenase, alpha subunit', 129, NULL, NULL, 50014),
(50015, '1.10.246.10-FF-000001', NULL, 'Serum albumin', 105, NULL, NULL, 50015),
(50016, '3.30.70.330-FF-001630', NULL, NULL, 147, NULL, NULL, 50016),
(50017, '1.10.510.10-FF-001279', NULL, 'Ser/Thr protein kinase, putative', 164, NULL, NULL, 50017),
(50018, '3.40.50.1000-FF-000334', NULL, '2-deoxyglucose-6-phosphate phosphatase, putative', 91, NULL, NULL, 50018),
(50019, '3.30.420.10-FF-000754', NULL, NULL, 297, NULL, NULL, 50019),
(50020, '3.40.630.30-FF-000195', NULL, 'Histone acetyltransferase', 110, NULL, NULL, 50020),
(50021, '2.130.10.10-FF-001255', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 402, NULL, NULL, 50021),
(50022, '2.30.30.40-FF-000050', NULL, 'RAS p21 protein activator 1', 58, NULL, NULL, 50022);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(50023, '3.30.160.60-FF-000271', NULL, 'Zinc finger protein 662', 27, NULL, NULL, 50023),
(50024, '3.40.50.300-FF-006140', NULL, 'DNA helicase related protein', 217, NULL, NULL, 50024),
(50025, '1.10.10.1180-FF-000002', NULL, 'LEM domain-containing protein 2', 97, NULL, NULL, 50025),
(50026, '3.30.70.1230-FF-000237', NULL, 'Adenylate cyclase, putative', 162, NULL, NULL, 50026),
(50027, '3.30.2160.10-FF-000019', NULL, 'E3 ubiquitin-protein ligase UPL5 isoform A', 83, NULL, NULL, 50027),
(50028, '2.60.40.150-FF-000139', NULL, 'extended synaptotagmin-1 isoform X1', 145, NULL, NULL, 50028),
(50029, '3.30.160.20-FF-000192', NULL, 'Uncharacterized protein', 114, NULL, NULL, 50029),
(50030, '2.60.120.10-FF-000481', NULL, 'Cyclic nucleotide-binding domain containing protein, putative', 141, NULL, NULL, 50030),
(50031, '1.10.8.60-FF-000422', NULL, 'Replication factor C small subunit', 62, NULL, NULL, 50031),
(50032, '1.20.120.20-FF-000019', NULL, 'Apolipoprotein A-I', 179, NULL, NULL, 50032),
(50033, '1.25.10.10-FF-002331', NULL, 'Uncharacterized protein', 300, NULL, NULL, 50033),
(50034, '1.10.405.10-FF-000012', NULL, 'Probable flavin-containing monoamine oxidase aofH', 92, NULL, NULL, 50034),
(50035, '2.130.10.10-FF-001934', NULL, '66 kDa stress protein putative', 209, NULL, NULL, 50035),
(50036, '3.40.50.1820-FF-001209', NULL, 'Uncharacterized protein', 298, NULL, NULL, 50036),
(50037, '1.10.533.10-FF-000034', NULL, 'tumor necrosis factor receptor superfamily member 16', 94, NULL, NULL, 50037),
(50038, '2.60.120.10-FF-000801', NULL, 'Predicted protein', 130, NULL, NULL, 50038),
(50039, '1.20.1250.20-FF-002287', NULL, 'Uncharacterized protein', 75, NULL, NULL, 50039),
(50040, '1.10.287.3990-FF-000009', NULL, 'Uncharacterized protein', 144, NULL, NULL, 50040),
(50041, '3.40.50.300-FF-005358', NULL, 'Dynamin 2', 298, NULL, NULL, 50041),
(50042, '1.10.1200.10-FF-000075', NULL, 'Nonribosomal peptide synthetase 13', 72, NULL, NULL, 50042),
(50043, '3.40.50.720-FF-000369', NULL, 'flavin reductase (NADPH)', 206, NULL, NULL, 50043),
(50044, '4.10.400.10-FF-000169', NULL, 'Low-density lipoprotein receptor-related protein', 51, NULL, NULL, 50044),
(50045, '1.10.287.380-FF-000038', NULL, 'ABC transporter, ATP-binding protein', 85, NULL, NULL, 50045),
(50046, '3.10.310.10-FF-000031', NULL, 'Proline racemase, putative', 204, NULL, NULL, 50046),
(50047, '1.10.30.10-FF-000117', NULL, 'Uncharacterized protein', 80, NULL, NULL, 50047),
(50048, '3.40.50.10810-FF-000224', NULL, 'SNF2 histone linker PHD RING helicase', 60, NULL, NULL, 50048),
(50049, '1.20.120.1080-FF-000039', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 135, NULL, NULL, 50049),
(50050, '1.20.120.1900-FF-000027', NULL, 'Spindle pole body component', 295, NULL, NULL, 50050),
(50051, '1.10.10.60-FF-000316', NULL, 'Transcription factor MYB15', 74, NULL, NULL, 50051),
(50052, '1.50.40.10-FF-000296', NULL, 'SLC (SoLute Carrier) homolog', 162, NULL, NULL, 50052),
(50053, '3.40.710.10-FF-000038', NULL, 'Penicillin-binding protein, transpeptidase domain protein', 191, NULL, NULL, 50053),
(50054, '3.30.450.260-FF-000008', NULL, 'Soluble guanylate cyclase gcy-37', 134, NULL, NULL, 50054),
(50055, '1.10.287.370-FF-000035', NULL, 'Probable prefoldin subunit 1', 114, NULL, NULL, 50055),
(50056, '2.130.10.10-FF-001755', NULL, 'GD12195', 277, NULL, NULL, 50056),
(50057, '3.90.1470.20-FF-000004', NULL, 'Uncharacterized protein', 102, NULL, NULL, 50057),
(50058, '2.60.120.620-FF-000082', NULL, 'Uncharacterized protein', 197, NULL, NULL, 50058),
(50059, '2.130.10.10-FF-003407', NULL, 'Predicted protein', 196, NULL, NULL, 50059),
(50060, '3.30.830.10-FF-000010', NULL, 'Mitochondrial-processing peptidase alpha subunit, mitochondrial', 222, NULL, NULL, 50060),
(50061, '1.20.1280.170-FF-000009', NULL, 'Exocyst complex protein EXO70', 150, NULL, NULL, 50061),
(50062, '1.20.5.390-FF-000001', NULL, 'rho guanine nucleotide exchange factor 7 isoform X1', 61, NULL, NULL, 50062),
(50063, '3.40.30.10-FF-000527', NULL, 'Glutaredoxin', 87, NULL, NULL, 50063);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(50064, '2.30.29.30-FF-001106', NULL, 'Uncharacterized protein C1610.01', 148, NULL, NULL, 50064),
(50065, '3.30.160.60-FF-003643', NULL, 'Putative tiptop', 98, NULL, NULL, 50065),
(50066, '1.20.58.70-FF-000125', NULL, 'Uncharacterized protein', 75, NULL, NULL, 50066),
(50067, '1.20.5.4820-FF-000002', NULL, 'Myosin heavy chain 10', 128, NULL, NULL, 50067),
(50068, '1.10.510.10-FF-000205', NULL, 'Cyclin-dependent kinase 6', 206, NULL, NULL, 50068),
(50069, '3.30.160.60-FF-006105', NULL, NULL, 86, NULL, NULL, 50069),
(50070, '3.90.1470.10-FF-000001', NULL, 'Phosphoserine phosphatase ThrH', 95, NULL, NULL, 50070),
(50071, '1.20.120.160-FF-000015', NULL, 'Hybrid sensor kinase RscS', 115, NULL, NULL, 50071),
(50072, '3.30.70.100-FF-000038', NULL, 'Superoxide dismutase 1 copper chaperone', 69, NULL, NULL, 50072),
(50073, '1.25.40.570-FF-000074', NULL, 'COP9 signalosome complex subunit 2', 173, NULL, NULL, 50073),
(50074, '1.10.287.70-FF-000349', NULL, 'Uncharacterized protein', 139, NULL, NULL, 50074),
(50075, '1.10.530.10-FF-000061', NULL, 'Morphogenesis protein 1', 159, NULL, NULL, 50075),
(50076, '2.130.10.10-FF-002070', NULL, 'WD domain, G-beta repeat, putative', 130, NULL, NULL, 50076),
(50077, '1.10.10.10-FF-001869', NULL, 'Probable intron-encoded endonuclease bI1', 64, NULL, NULL, 50077),
(50078, '1.10.437.10-FF-000029', NULL, 'Bcl2-associated X protein b', 159, NULL, NULL, 50078),
(50079, '2.60.40.10-FF-004183', NULL, NULL, 84, NULL, NULL, 50079),
(50080, '2.130.10.10-FF-000653', NULL, 'Telomerase protein component 1', 179, NULL, NULL, 50080),
(50081, '1.20.920.10-FF-000173', NULL, 'Chromosome 8, whole genome shotgun sequence', 115, NULL, NULL, 50081),
(50082, '3.60.21.10-FF-000270', NULL, 'Purple acid phosphatase', 79, NULL, NULL, 50082),
(50083, '3.40.50.720-FF-001712', NULL, 'Bifunctional dTDP-4-dehydrorhamnose 3,5-epimerase/dTDP-4-dehydrorhamnose reductase', 134, NULL, NULL, 50083),
(50084, '1.10.10.250-FF-000010', NULL, 'Putative ribosomal protein L11', 74, NULL, NULL, 50084),
(50085, '2.70.98.60-FF-000002', NULL, 'Alpha-galactosidase', 301, NULL, NULL, 50085),
(50086, '3.40.50.300-FF-000333', NULL, 'Dynein cytoplasmic 1 light intermediate chain 2', 180, NULL, NULL, 50086),
(50087, '1.20.5.2440-FF-000001', NULL, 'RAB11 family interacting protein 4', 63, NULL, NULL, 50087),
(50088, '3.40.50.300-FF-008410', NULL, 'Uncharacterized protein', 263, NULL, NULL, 50088),
(50089, '2.70.130.10-FF-000075', NULL, NULL, 156, NULL, NULL, 50089),
(50090, '3.40.50.300-FF-003559', NULL, 'Guanine nucleotide-binding protein G(i) subunit alpha-1', 233, NULL, NULL, 50090),
(50091, '3.30.200.20-FF-001089', NULL, 'Serine/threonine protein kinase', 84, NULL, NULL, 50091),
(50092, '2.60.120.330-FF-000146', NULL, 'Predicted protein', 121, NULL, NULL, 50092),
(50093, '1.10.510.10-FF-001925', NULL, 'Uncharacterized protein', 242, NULL, NULL, 50093),
(50094, '3.40.449.10-FF-000020', NULL, 'Uncharacterized protein', 35, NULL, NULL, 50094),
(50095, '3.30.420.10-FF-000462', NULL, 'AGAP007533-PA', 247, NULL, NULL, 50095),
(50096, '3.10.450.10-FF-000007', NULL, 'latexin', 98, NULL, NULL, 50096),
(50097, '1.50.40.10-FF-000116', NULL, 'Mitochondrial substrate carrier', 298, NULL, NULL, 50097),
(50098, '2.60.40.10-FF-000203', NULL, 'Plexin B2', 126, NULL, NULL, 50098),
(50099, '2.30.29.30-FF-000004', NULL, 'IQ motif and SEC7 domain-containing protein 1', 139, NULL, NULL, 50099),
(50100, '3.40.640.10-FF-000009', NULL, 'Cystathionine gamma-synthase homolog', 246, NULL, NULL, 50100),
(50101, '3.30.1640.10-FF-000101', NULL, 'MCM / cell division control protein 21', 48, NULL, NULL, 50101),
(50102, '3.40.140.10-FF-000016', NULL, 'Cytosine deaminase', 150, NULL, NULL, 50102),
(50103, '3.30.40.10-FF-001422', NULL, 'Uncharacterized protein', 58, NULL, NULL, 50103),
(50104, '3.30.565.10-FF-000022', NULL, 'Anti-sigma F factor', 142, NULL, NULL, 50104),
(50105, '2.60.200.10-FF-000010', NULL, 'Interferon regulatory factor 8', 206, NULL, NULL, 50105),
(50106, '3.30.70.330-FF-003136', NULL, NULL, 102, NULL, NULL, 50106),
(50107, '1.10.540.10-FF-000033', NULL, 'Acyl-coenzyme A oxidase', 127, NULL, NULL, 50107);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(50108, '2.170.270.10-FF-000044', NULL, 'Zinc finger protein 408', 144, NULL, NULL, 50108),
(50109, '2.60.200.20-FF-000013', NULL, 'FHA domain-containing protein FhaA', 97, NULL, NULL, 50109),
(50110, '1.20.1730.10-FF-000062', NULL, 'High affinity choline transporter 1', 482, NULL, NULL, 50110),
(50111, '1.20.120.1070-FF-000003', NULL, 'Translation initiation factor eIF-2B subunit alpha', 103, NULL, NULL, 50111),
(50112, '3.30.160.60-FF-004306', NULL, NULL, 52, NULL, NULL, 50112),
(50113, '1.20.5.170-FF-000199', NULL, 'Glial fibrillary acidic protein', 24, NULL, NULL, 50113),
(50114, '2.60.120.200-FF-000719', NULL, 'Uncharacterized protein', 340, NULL, NULL, 50114),
(50115, '3.40.190.10-FF-000784', NULL, 'Uncharacterized protein', 100, NULL, NULL, 50115),
(50116, '1.20.5.110-FF-000142', NULL, 'Syntaxin-binding protein 6 (amisyn),-like', 53, NULL, NULL, 50116),
(50117, '3.30.565.10-FF-000314', NULL, 'Two component system histidine kinase', 161, NULL, NULL, 50117),
(50118, '3.80.10.10-FF-002469', NULL, 'Uncharacterized protein', 280, NULL, NULL, 50118),
(50119, '2.60.60.20-FF-000062', NULL, NULL, 173, NULL, NULL, 50119),
(50120, '3.90.70.10-FF-000600', NULL, 'Uncharacterized protein', 190, NULL, NULL, 50120),
(50121, '3.30.70.240-FF-000001', NULL, 'Elongation factor G', 72, NULL, NULL, 50121),
(50122, '1.10.10.60-FF-000081', NULL, 'Empty spiracles homeobox 2', 83, NULL, NULL, 50122),
(50123, '1.10.10.440-FF-000095', NULL, 'Uncharacterized protein', 60, NULL, NULL, 50123),
(50124, '2.30.30.140-FF-000080', NULL, 'Fragile X mental retardation protein 1 B', 33, NULL, NULL, 50124),
(50125, '3.40.250.10-FF-000137', NULL, 'Rhodanese domain protein / beta-lactamase domain protein', 113, NULL, NULL, 50125),
(50126, '1.10.287.70-FF-000675', NULL, 'Uncharacterized protein', 102, NULL, NULL, 50126),
(50127, '2.40.160.110-FF-000031', NULL, 'Uncharacterized protein', 91, NULL, NULL, 50127),
(50128, '2.130.10.10-FF-001608', NULL, 'Transducin/WD40 repeat-like superfamily protein', 163, NULL, NULL, 50128),
(50129, '3.90.70.10-FF-000213', NULL, 'Cysteine protease 11', 331, NULL, NULL, 50129),
(50130, '3.30.300.30-FF-000167', NULL, 'Tryptophan N-acetyltransferase ivoA', 125, NULL, NULL, 50130),
(50131, '3.10.20.90-FF-000490', NULL, 'Uncharacterized protein', 68, NULL, NULL, 50131),
(50132, '2.60.40.60-FF-000988', NULL, 'Uncharacterized protein', 116, NULL, NULL, 50132),
(50133, '3.50.30.60-FF-000002', NULL, 'Microcin immunity protein MccF', 169, NULL, NULL, 50133),
(50134, '2.60.40.10-FF-000821', NULL, 'Myomesin 3', 115, NULL, NULL, 50134),
(50135, '1.10.20.120-FF-000001', NULL, 'Ribonuclease H2 subunit B', 140, NULL, NULL, 50135),
(50136, '2.10.50.10-FF-000021', NULL, 'Tumor necrosis factor receptor superfamily member 6', 51, NULL, NULL, 50136),
(50137, '2.10.25.10-FF-000980', NULL, 'Fibrillin-1', 41, NULL, NULL, 50137),
(50138, '2.40.40.20-FF-000016', NULL, 'peroxisome biogenesis factor 1', 97, NULL, NULL, 50138),
(50139, '2.40.10.480-FF-000006', NULL, 'Os06g0111600 protein', 71, NULL, NULL, 50139),
(50140, '3.20.20.70-FF-000337', NULL, 'NADPH dehydrogenase', 389, NULL, NULL, 50140),
(50141, '2.10.25.10-FF-001789', NULL, 'Uncharacterized protein', 30, NULL, NULL, 50141),
(50142, '4.10.240.10-FF-000134', NULL, 'Fluconazole resistance protein 1', 87, NULL, NULL, 50142),
(50143, '2.40.160.120-FF-000034', NULL, 'Oxysterol-binding protein 11', 181, NULL, NULL, 50143),
(50144, '3.10.20.360-FF-000003', NULL, 'Patronin (microtubule-binding protein) homolog', 119, NULL, NULL, 50144),
(50145, '1.10.20.130-FF-000004', NULL, 'Poly [ADP-ribose] polymerase', 77, NULL, NULL, 50145),
(50146, '3.30.160.60-FF-005588', NULL, NULL, 73, NULL, NULL, 50146),
(50147, '2.60.120.260-FF-000569', NULL, 'Si:dkey-202e22.2', 251, NULL, NULL, 50147),
(50148, '2.40.40.10-FF-000013', NULL, NULL, 107, NULL, NULL, 50148),
(50149, '3.30.70.250-FF-000004', NULL, 'Malonyl CoA-acyl carrier transacylase', 73, NULL, NULL, 50149),
(50150, '3.90.550.10-FF-000216', NULL, 'Cellulose synthase-like protein G2', 164, NULL, NULL, 50150),
(50151, '3.80.10.10-FF-001721', NULL, 'Leucine rich repeat containing 8 VRAC subunit E', 263, NULL, NULL, 50151);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(50152, '3.40.50.10490-FF-000145', NULL, NULL, 32, NULL, NULL, 50152),
(50153, '2.20.25.530-FF-000008', NULL, 'Predicted protein', 63, NULL, NULL, 50153),
(50154, '1.25.40.990-FF-000025', NULL, 'Uncharacterized protein', 283, NULL, NULL, 50154),
(50155, '1.20.1070.10-FF-000915', NULL, 'Uncharacterized protein', 161, NULL, NULL, 50155),
(50156, '3.40.50.300-FF-004402', NULL, 'DNA replication protein DnaC', 192, NULL, NULL, 50156),
(50157, '3.30.70.1660-FF-000017', NULL, 'Peptide chain release factor 1, mitochondrial', 119, NULL, NULL, 50157),
(50158, '3.40.33.10-FF-000034', NULL, 'Protein CBG17161', 148, NULL, NULL, 50158),
(50159, '1.25.10.10-FF-003079', NULL, 'Phosphoprotein p93', 240, NULL, NULL, 50159),
(50160, '3.20.20.70-FF-000629', NULL, NULL, 271, NULL, NULL, 50160),
(50161, '2.130.10.10-FF-003733', NULL, 'Uncharacterized protein', 334, NULL, NULL, 50161),
(50162, '2.40.150.20-FF-000029', NULL, 'Uncharacterized protein', 82, NULL, NULL, 50162),
(50163, '3.30.2020.30-FF-000021', NULL, 'Uncharacterized protein', 91, NULL, NULL, 50163),
(50164, '3.40.50.1820-FF-000546', NULL, 'Uncharacterized protein', 298, NULL, NULL, 50164),
(50165, '3.10.50.40-FF-000084', NULL, 'Peptidylprolyl isomerase', 107, NULL, NULL, 50165),
(50166, '1.10.510.10-FF-003078', NULL, NULL, 202, NULL, NULL, 50166),
(50167, '2.60.120.200-FF-000484', NULL, 'Uncharacterized protein', 20, NULL, NULL, 50167),
(50168, '3.40.50.300-FF-007893', NULL, 'Si:dkeyp-86b9.1', 305, NULL, NULL, 50168),
(50169, '3.40.50.2300-FF-000797', NULL, 'Guanylate cyclase', 213, NULL, NULL, 50169),
(50170, '3.40.50.200-FF-000157', NULL, 'Predicted protein', 289, NULL, NULL, 50170),
(50171, '2.60.40.10-FF-005846', NULL, NULL, 103, NULL, NULL, 50171),
(50172, '3.40.50.740-FF-000055', NULL, 'NADH dehydrogenase I chain G', 142, NULL, NULL, 50172),
(50173, '1.10.10.1940-FF-000011', NULL, NULL, 46, NULL, NULL, 50173),
(50174, '3.40.50.1820-FF-001182', NULL, 'Predicted protein', 158, NULL, NULL, 50174),
(50175, '1.10.10.60-FF-000642', NULL, 'MYB transcription factor', 72, NULL, NULL, 50175),
(50176, '3.80.10.10-FF-003930', NULL, 'Uncharacterized protein', 95, NULL, NULL, 50176),
(50177, '3.30.160.60-FF-000563', NULL, 'Krueppel-like factor 8', 28, NULL, NULL, 50177),
(50178, '3.30.450.20-FF-000585', NULL, 'Sensory box protein', 124, NULL, NULL, 50178),
(50179, '3.40.50.720-FF-000695', NULL, 'UDP-glucose 4-epimerase', 226, NULL, NULL, 50179),
(50180, '2.60.40.1770-FF-000010', NULL, 'Ephrin receptor', 57, NULL, NULL, 50180),
(50181, '2.60.40.60-FF-000903', NULL, 'Uncharacterized protein', 115, NULL, NULL, 50181),
(50182, '1.10.3210.10-FF-000047', NULL, 'HD domain containing protein', 303, NULL, NULL, 50182),
(50183, '3.10.400.20-FF-000007', NULL, 'Putative translation initiation factor SUI1', 186, NULL, NULL, 50183),
(50184, '1.10.10.10-FF-000560', NULL, 'Iron-dependent transcriptional regulator', 130, NULL, NULL, 50184),
(50185, '3.40.50.2300-FF-000151', NULL, 'Penicillin-binding protein activator LpoA', 132, NULL, NULL, 50185),
(50186, '2.40.50.140-FF-000070', NULL, 'Maltose/maltodextrin import ATP-binding protein MalK', 55, NULL, NULL, 50186),
(50187, '3.40.50.1100-FF-000038', NULL, 'Threonine synthase', 139, NULL, NULL, 50187),
(50188, '3.40.50.10260-FF-000014', NULL, 'NAD(P)H-hydrate epimerase', 222, NULL, NULL, 50188),
(50189, '3.30.30.30-FF-000062', NULL, 'DnaK protein', 59, NULL, NULL, 50189),
(50190, '3.90.79.10-FF-000120', NULL, 'MutT/nudix family protein', 171, NULL, NULL, 50190),
(50191, '3.30.70.330-FF-002939', NULL, NULL, 112, NULL, NULL, 50191),
(50192, '3.30.160.60-FF-001698', NULL, 'Zinc finger protein 90 homolog', 40, NULL, NULL, 50192),
(50193, '2.130.10.10-FF-003379', NULL, 'Probable serine/threonine-protein kinase vps15', 180, NULL, NULL, 50193),
(50194, '2.30.180.10-FF-000053', NULL, 'Transforming growth factor-beta-induced protein', 137, NULL, NULL, 50194),
(50195, '3.40.50.450-FF-000092', NULL, 'Putative cytokinin riboside 5''-monophosphate phosphoribohydrolase LOG9', 127, NULL, NULL, 50195),
(50196, '3.40.1160.10-FF-000040', NULL, 'Glutamate 5-kinase', 264, NULL, NULL, 50196);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(50197, '2.130.10.10-FF-000327', NULL, 'F-box/WD repeat-containing protein 4 isoform X1', 148, NULL, NULL, 50197),
(50198, '2.30.110.50-FF-000004', NULL, 'Putative VGR-related protein', 84, NULL, NULL, 50198),
(50199, '3.30.200.20-FF-000280', NULL, 'membrane-associated tyrosine- and threonine-specific cdc2-inhibitory kinase', 112, NULL, NULL, 50199),
(50200, '1.10.600.10-FF-000089', NULL, 'Geranylgeranyl pyrophosphate synthase, chloroplastic', 104, NULL, NULL, 50200),
(50201, '3.30.500.10-FF-000024', NULL, NULL, 92, NULL, NULL, 50201),
(50202, '3.40.50.300-FF-003913', NULL, 'Dephospho-CoA_kinase_-_putative', 214, NULL, NULL, 50202),
(50203, '3.40.50.150-FF-001255', NULL, NULL, 80, NULL, NULL, 50203),
(50204, '2.30.42.10-FF-000428', NULL, NULL, 65, NULL, NULL, 50204),
(50205, '3.40.50.300-FF-005684', NULL, 'ABC multidrug transporter (Eurofung)', 185, NULL, NULL, 50205),
(50206, '3.40.50.1000-FF-000660', NULL, NULL, 206, NULL, NULL, 50206),
(50207, '1.25.40.10-FF-003468', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 101, NULL, NULL, 50207),
(50208, '2.10.70.10-FF-000084', NULL, 'Mannan-binding lectin serine protease 2', 74, NULL, NULL, 50208),
(50209, '3.50.50.60-FF-000211', NULL, 'Amine oxidase, flavin-containing superfamily', 198, NULL, NULL, 50209),
(50210, '3.10.400.10-FF-000004', NULL, 'PAPS synthetase, isoform D', 164, NULL, NULL, 50210),
(50211, '3.40.50.10330-FF-000029', NULL, 'NAD+ kinase, putative', 204, NULL, NULL, 50211),
(50212, '3.80.10.10-FF-001160', NULL, 'Receptor-like protein kinase HSL1 isoform A', 324, NULL, NULL, 50212),
(50213, '2.60.40.1090-FF-000020', NULL, 'Fimbrial protein YehD', 147, NULL, NULL, 50213),
(50214, '3.30.200.20-FF-002106', NULL, 'Uncharacterized protein', 79, NULL, NULL, 50214),
(50215, '1.10.357.20-FF-000003', NULL, 'Uncharacterized protein, isoform B', 187, NULL, NULL, 50215),
(50216, '3.40.50.1260-FF-000007', NULL, 'Phosphoglycerate kinase', 217, NULL, NULL, 50216),
(50217, '3.40.50.300-FF-001761', NULL, 'Replicative DNA helicase', 281, NULL, NULL, 50217),
(50218, '1.10.720.30-FF-000076', NULL, 'Ribonuclease', 45, NULL, NULL, 50218),
(50219, '1.20.1250.20-FF-001152', NULL, 'Sugar transporter ERD6-like 6', 92, NULL, NULL, 50219),
(50220, '2.60.40.10-FF-005285', NULL, NULL, 83, NULL, NULL, 50220),
(50221, '2.60.120.10-FF-000094', NULL, 'cGMP-dependent protein kinase', 117, NULL, NULL, 50221),
(50222, '1.10.220.60-FF-000007', NULL, 'GM15554', 56, NULL, NULL, 50222),
(50223, '2.130.10.10-FF-003172', NULL, 'WD repeat-containing protein 16-like Protein', 185, NULL, NULL, 50223),
(50224, '2.60.120.970-FF-000102', NULL, 'Transforming growth factor beta', 116, NULL, NULL, 50224),
(50225, '3.30.505.10-FF-000131', NULL, 'Tyrosine-protein kinase', 140, NULL, NULL, 50225),
(50226, '1.20.1110.10-FF-000150', NULL, 'Sodium/potassium-transporting ATPase subunit alpha', 409, NULL, NULL, 50226),
(50227, '1.25.10.10-FF-000532', NULL, 'Serine/threonine-protein kinase mTOR', 245, NULL, NULL, 50227),
(50228, '3.40.50.300-FF-004223', NULL, 'MRP-like ABC transporter', 253, NULL, NULL, 50228),
(50229, '3.40.50.12650-FF-000023', NULL, 'Uncharacterized protein', 165, NULL, NULL, 50229),
(50230, '3.20.20.10-FF-000073', NULL, 'Uncharacterized protein', 103, NULL, NULL, 50230),
(50231, '3.20.20.60-FF-000008', NULL, 'Citrate (Pro-3S)-lyase subunit beta', 297, NULL, NULL, 50231),
(50232, '1.10.472.10-FF-000251', NULL, 'Uncharacterized protein', 82, NULL, NULL, 50232),
(50233, '2.30.29.30-FF-000089', NULL, 'Oxysterol-binding protein', 103, NULL, NULL, 50233),
(50234, '1.10.357.30-FF-000006', NULL, 'Hypothetical_protein_-_conserved', 189, NULL, NULL, 50234),
(50235, '1.10.10.390-FF-000001', NULL, 'Histone acetyltransferase type B catalytic subunit', 54, NULL, NULL, 50235),
(50236, '3.40.50.2020-FF-000011', NULL, 'Putative ribose-phosphate pyrophosphokinase 1', 156, NULL, NULL, 50236),
(50237, '2.60.40.10-FF-001923', NULL, 'KETtiN (Drosophila actin-binding) homolog', 115, NULL, NULL, 50237),
(50238, '1.20.1070.10-FF-001730', NULL, 'Zg02', 94, NULL, NULL, 50238);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(50239, '1.20.58.60-FF-000589', NULL, 'Spectrin beta chain', 209, NULL, NULL, 50239),
(50240, '3.40.50.150-FF-000153', NULL, 'S-adenosyl-L-methionine-dependent methyltransferase superfamily protein', 344, NULL, NULL, 50240),
(50241, '3.80.10.10-FF-002823', NULL, 'Leucine Rich Repeat family protein', 160, NULL, NULL, 50241),
(50242, '3.30.70.1230-FF-000063', NULL, 'Adenylate cyclase', 222, NULL, NULL, 50242),
(50243, '3.40.470.10-FF-000002', NULL, 'G/T mismatch-specific thymine DNA glycosylase', 204, NULL, NULL, 50243),
(50244, '3.90.550.10-FF-000542', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 392, NULL, NULL, 50244),
(50245, '3.40.50.1820-FF-001035', NULL, 'Putative isoprenylcysteine alpha-carbonyl methylesterase ICMEL2', 145, NULL, NULL, 50245),
(50246, '1.20.58.60-FF-000561', NULL, 'Vab-10', 112, NULL, NULL, 50246),
(50247, '1.10.8.10-FF-000194', NULL, 'Plant UBX domain-containing protein 7', 44, NULL, NULL, 50247),
(50248, '1.20.81.10-FF-000004', NULL, 'GG17180', 121, NULL, NULL, 50248),
(50249, '3.30.160.60-FF-006431', NULL, NULL, 43, NULL, NULL, 50249),
(50250, '2.170.150.80-FF-000011', NULL, 'NAC domain-containing protein 41', 142, NULL, NULL, 50250),
(50251, '2.130.10.10-FF-005942', NULL, 'F-box/WD repeat-containing protein A-like protein', 255, NULL, NULL, 50251),
(50252, '2.60.120.10-FF-000655', NULL, 'Dimethlysulfonioproprionate lyase DddW', 135, NULL, NULL, 50252),
(50253, '1.20.1270.60-FF-000097', NULL, 'Vacuolar protein sorting-associated protein 17', 195, NULL, NULL, 50253),
(50254, '3.40.390.10-FF-000001', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 1', 219, NULL, NULL, 50254),
(50255, '2.60.40.2690-FF-000011', NULL, 'Predicted protein', 84, NULL, NULL, 50255),
(50256, '2.60.40.10-FF-003076', NULL, 'Uncharacterized protein', 105, NULL, NULL, 50256),
(50257, '3.10.20.90-FF-000310', NULL, 'BolA-like protein 1', 101, NULL, NULL, 50257),
(50258, '2.30.110.10-FF-000072', NULL, 'Pyridoxamine 5''-phosphate oxidase-related FMN-binding', 125, NULL, NULL, 50258),
(50259, '3.40.630.30-FF-000341', NULL, 'Hypothetical acetyltransferase', 144, NULL, NULL, 50259),
(50260, '1.10.630.10-FF-000737', NULL, 'Uncharacterized protein', 89, NULL, NULL, 50260),
(50261, '2.30.30.140-FF-000107', NULL, 'Six-banded, isoform H', 107, NULL, NULL, 50261),
(50262, '3.80.10.10-FF-000878', NULL, 'Adenylate cyclase', 149, NULL, NULL, 50262),
(50263, '3.40.50.1240-FF-000001', NULL, '6-phosphofructo-2-kinase/fructose-2, 6-bisphosphatase 3 isoform 2', 217, NULL, NULL, 50263),
(50264, '1.25.10.10-FF-002185', NULL, 'Os03g0701000 protein', 460, NULL, NULL, 50264),
(50265, '1.10.730.10-FF-000008', NULL, 'Arginine--tRNA ligase', 126, NULL, NULL, 50265),
(50266, '2.130.10.10-FF-001873', NULL, 'Small nucleolar ribonucleoprotein complex subunit, putative', 172, NULL, NULL, 50266),
(50267, '3.90.1410.10-FF-000110', NULL, 'Histone-lysine N-methyltransferase setd3-like Protein', 228, NULL, NULL, 50267),
(50268, '3.40.30.10-FF-000353', NULL, 'Methionyl-tRNA synthetase', 78, NULL, NULL, 50268),
(50269, '1.10.287.310-FF-000006', NULL, '50S ribosomal protein L29', 67, NULL, NULL, 50269),
(50270, '3.40.30.10-FF-000409', NULL, 'Fmp46p', 133, NULL, NULL, 50270),
(50271, '3.20.20.70-FF-000837', NULL, NULL, 103, NULL, NULL, 50271),
(50272, '3.40.710.10-FF-000156', NULL, 'Cell division protein ftsI', 373, NULL, NULL, 50272),
(50273, '3.30.200.20-FF-000954', NULL, 'Cell division control protein, putative', 99, NULL, NULL, 50273),
(50274, '1.20.1270.420-FF-000010', NULL, 'Uncharacterized protein', 232, NULL, NULL, 50274),
(50275, '3.20.20.140-FF-000115', NULL, 'Dihydropyrimidinase', 25, NULL, NULL, 50275),
(50276, '1.10.10.790-FF-000031', NULL, NULL, 59, NULL, NULL, 50276),
(50277, '3.80.10.10-FF-003604', NULL, 'Dynein assembly factor 1, axonemal', 126, NULL, NULL, 50277),
(50278, '3.30.160.360-FF-000017', NULL, 'Lysine (K)-specific methyltransferase 2D', 86, NULL, NULL, 50278),
(50279, '3.30.160.60-FF-005649', NULL, NULL, 85, NULL, NULL, 50279),
(50280, '1.25.40.20-FF-000571', NULL, 'Rab GTPase activating protein, putative', 87, NULL, NULL, 50280);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(50281, '2.30.42.10-FF-000636', NULL, NULL, 64, NULL, NULL, 50281),
(50282, '3.30.300.10-FF-000043', NULL, 'S-adenosylmethionine synthase', 104, NULL, NULL, 50282),
(50283, '2.60.40.10-FF-000321', NULL, 'protein turtle homolog B isoform X2', 87, NULL, NULL, 50283),
(50284, '2.40.420.20-FF-000039', NULL, 'RND family efflux transporter, MFP subunit', 91, NULL, NULL, 50284),
(50285, '3.20.20.80-FF-000784', NULL, 'Predicted protein', 196, NULL, NULL, 50285),
(50286, '3.40.1690.10-FF-000006', NULL, 'Flagellar biosynthetic protein flhB', 137, NULL, NULL, 50286),
(50287, '1.20.58.70-FF-000007', NULL, 'ER-golgi SNARE complex subunit', 228, NULL, NULL, 50287),
(50288, '2.10.25.10-FF-000480', NULL, 'Protein Z, vitamin K-dependent plasma glycoprotein', 39, NULL, NULL, 50288),
(50289, '3.30.160.60-FF-002423', NULL, 'Blast:Protein glass', 36, NULL, NULL, 50289),
(50290, '1.20.1110.10-FF-000211', NULL, NULL, 69, NULL, NULL, 50290),
(50291, '1.10.8.10-FF-000368', NULL, 'AGAP000733-PA', 109, NULL, NULL, 50291),
(50292, '1.10.287.470-FF-000065', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 73, NULL, NULL, 50292),
(50293, '2.60.40.10-FF-002412', NULL, 'Synaptogenesis protein syg-1', 78, NULL, NULL, 50293),
(50294, '2.40.128.20-FF-000023', NULL, 'Epididymal-specific lipocalin-12', 175, NULL, NULL, 50294),
(50295, '1.10.10.60-FF-000434', NULL, 'Transcription termination factor 1', 40, NULL, NULL, 50295),
(50296, '3.40.50.2300-FF-000589', NULL, 'LacI family transcriptional regulator', 130, NULL, NULL, 50296),
(50297, '1.20.58.60-FF-000004', NULL, 'Actinin alpha 1', 117, NULL, NULL, 50297),
(50298, '3.40.1690.20-FF-000009', NULL, 'Unplaced genomic scaffold supercont1.113, whole genome shotgun sequence', 109, NULL, NULL, 50298),
(50299, '1.10.3710.10-FF-000012', NULL, 'Recombinase RarA', 73, NULL, NULL, 50299),
(50300, '3.30.800.10-FF-000036', NULL, NULL, 148, NULL, NULL, 50300),
(50301, '3.30.310.10-FF-000015', NULL, 'Transcription initiation factor TFiid', 87, NULL, NULL, 50301),
(50302, '1.50.40.10-FF-000381', NULL, 'Mitochondrial carrier protein MTM1', 85, NULL, NULL, 50302),
(50303, '1.25.40.10-FF-004896', NULL, 'Uncharacterized protein', 90, NULL, NULL, 50303),
(50304, '1.10.533.10-FF-000213', NULL, 'Tumor necrosis factor receptor superfamily, member 1a', 105, NULL, NULL, 50304),
(50305, '1.20.5.1030-FF-000005', NULL, 'preprotein translocase subunit SECE1', 53, NULL, NULL, 50305),
(50306, '3.30.420.10-FF-000636', NULL, NULL, 156, NULL, NULL, 50306),
(50307, '1.10.840.10-FF-000045', NULL, 'Cyclic GMP-binding protein D', 251, NULL, NULL, 50307),
(50308, '3.10.250.10-FF-000060', NULL, 'Predicted protein', 107, NULL, NULL, 50308),
(50309, '1.25.40.20-FF-000037', NULL, 'short transient receptor potential channel 3 isoform X1', 187, NULL, NULL, 50309),
(50310, '2.20.28.10-FF-000053', NULL, 'DNA replication licensing factor MCM7', 36, NULL, NULL, 50310),
(50311, '2.60.120.200-FF-000692', NULL, 'Uncharacterized protein', 240, NULL, NULL, 50311),
(50312, '1.25.40.10-FF-000034', NULL, 'Peroxisomal biogenesis factor 5 isoform 1', 327, NULL, NULL, 50312),
(50313, '3.40.50.360-FF-000126', NULL, 'Uncharacterized protein', 200, NULL, NULL, 50313),
(50314, '3.30.60.30-FF-000209', NULL, 'Uncharacterized protein', 55, NULL, NULL, 50314),
(50315, '2.130.10.10-FF-005616', NULL, 'Predicted protein', 185, NULL, NULL, 50315),
(50316, '3.40.50.720-FF-002286', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 200, NULL, NULL, 50316),
(50317, '2.30.29.30-FF-001224', NULL, 'Uncharacterized protein', 118, NULL, NULL, 50317),
(50318, '3.10.120.10-FF-000022', NULL, 'Cytochrome b5-like Heme/Steroid binding domain containing protein, putative', 102, NULL, NULL, 50318),
(50319, '3.30.200.20-FF-001617', NULL, 'Uncharacterized protein', 99, NULL, NULL, 50319),
(50320, '1.20.5.110-FF-000024', NULL, 'Vesicle transport through interaction with t-SNAREs homolog 1A', 81, NULL, NULL, 50320),
(50321, '1.20.58.340-FF-000042', NULL, 'Magnesium transport protein CorA', 77, NULL, NULL, 50321),
(50322, '3.40.50.10420-FF-000023', NULL, 'Uncharacterized protein', 242, NULL, NULL, 50322);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(50323, '1.10.1900.10-FF-000021', NULL, 'E3 ubiquitin-protein ligase UBR5 isoform X1', 75, NULL, NULL, 50323),
(50324, '3.30.300.20-FF-000046', NULL, 'Transcription termination/antitermination protein NusA', 64, NULL, NULL, 50324),
(50325, '2.60.120.470-FF-000014', NULL, NULL, 166, NULL, NULL, 50325),
(50326, '3.30.70.330-FF-001276', NULL, NULL, 84, NULL, NULL, 50326),
(50327, '1.20.58.390-FF-000208', NULL, 'Uncharacterized protein', 89, NULL, NULL, 50327),
(50328, '3.90.260.10-FF-000031', NULL, 'Uncharacterized protein', 129, NULL, NULL, 50328),
(50329, '1.20.1070.10-FF-001112', NULL, 'Beta-2 adrenergic receptor', 310, NULL, NULL, 50329),
(50330, '1.20.58.930-FF-000005', NULL, 'Biosynthetic arginine decarboxylase', 93, NULL, NULL, 50330),
(50331, '3.40.50.2300-FF-001640', NULL, NULL, 256, NULL, NULL, 50331),
(50332, '3.30.1330.30-FF-000123', NULL, '60S ribosomal protein L7a', 132, NULL, NULL, 50332),
(50333, '1.25.40.20-FF-001818', NULL, 'Poly [ADP-ribose] polymerase', 159, NULL, NULL, 50333),
(50334, '1.10.565.10-FF-000085', NULL, 'Vitamin D3 receptor', 128, NULL, NULL, 50334),
(50335, '3.40.630.10-FF-000155', NULL, 'Zn-dependent exopeptidase', 354, NULL, NULL, 50335),
(50336, '1.20.140.10-FF-000079', NULL, 'Isovaleryl-CoA dehydrogenase', 144, NULL, NULL, 50336),
(50337, '3.90.550.10-FF-000042', NULL, 'Glucoside xylosyltransferase 1', 271, NULL, NULL, 50337),
(50338, '1.20.58.920-FF-000002', NULL, 'Putative phosphoglycerate transport regulatory protein PgtB', 117, NULL, NULL, 50338),
(50339, '3.30.565.10-FF-000140', NULL, 'Cation-transporting ATPase, putative', 238, NULL, NULL, 50339),
(50340, '1.20.1070.10-FF-001258', NULL, 'Uncharacterized protein', 278, NULL, NULL, 50340),
(50341, '3.30.200.20-FF-001943', NULL, 'Protein kinase 3', 109, NULL, NULL, 50341),
(50342, '1.20.1300.10-FF-000012', NULL, 'Succinate dehydrogenase hydrophobic membrane anchor subunit', 113, NULL, NULL, 50342),
(50343, '2.10.25.10-FF-000895', NULL, 'Teneurin-1', 30, NULL, NULL, 50343),
(50344, '3.30.310.10-FF-000072', NULL, 'TATA-box-binding protein 2', 23, NULL, NULL, 50344),
(50345, '1.25.10.10-FF-000740', NULL, 'Nucleolar protein 9', 128, NULL, NULL, 50345),
(50346, '3.90.550.50-FF-000003', NULL, 'Beta-1,3-N-acetylglucosaminyltransferase', 279, NULL, NULL, 50346),
(50347, '3.30.1380.20-FF-000005', NULL, 'Trafficking protein particle complex subunit 5', 167, NULL, NULL, 50347),
(50348, '2.60.120.620-FF-000143', NULL, 'Uncharacterized protein', 170, NULL, NULL, 50348),
(50349, '3.10.50.40-FF-000145', NULL, 'Peptidylprolyl isomerase', 120, NULL, NULL, 50349),
(50350, '1.10.40.70-FF-000001', NULL, 'Type II secretion system protein GspE', 63, NULL, NULL, 50350),
(50351, '3.40.1110.10-FF-000475', NULL, NULL, 13, NULL, NULL, 50351),
(50352, '3.30.1380.10-FF-000002', NULL, 'Penicillin-insensitive murein endopeptidase', 255, NULL, NULL, 50352),
(50353, '2.60.40.10-FF-005493', NULL, NULL, 95, NULL, NULL, 50353),
(50354, '1.10.510.10-FF-004505', NULL, NULL, 63, NULL, NULL, 50354),
(50355, '2.60.40.10-FF-004065', NULL, NULL, 96, NULL, NULL, 50355),
(50356, '1.20.1300.20-FF-000015', NULL, 'Ubiquitin thioesterase otubain-like', 16, NULL, NULL, 50356),
(50357, '3.40.720.10-FF-000128', NULL, 'Iduronate-sulfatase or arylsulfatase A', 383, NULL, NULL, 50357),
(50358, '3.40.50.2000-FF-000825', NULL, 'Uncharacterized protein', 172, NULL, NULL, 50358),
(50359, '3.40.50.970-FF-000101', NULL, 'Putative phosphonopyruvate decarboxylase', 186, NULL, NULL, 50359),
(50360, '1.20.1250.20-FF-001270', NULL, 'Major facilitator superfamily domain containing 2B', 231, NULL, NULL, 50360),
(50361, '3.40.50.1440-FF-000117', NULL, 'Tubulin gamma chain', 278, NULL, NULL, 50361),
(50362, '3.30.160.20-FF-000219', NULL, 'Uncharacterized protein', 70, NULL, NULL, 50362),
(50363, '3.40.190.10-FF-000019', NULL, 'Sulfate ABC transporter', 156, NULL, NULL, 50363),
(50364, '3.30.70.1230-FF-000271', NULL, 'Predicted protein', 122, NULL, NULL, 50364),
(50365, '1.10.1450.10-FF-000121', NULL, 'Tetraspanin', 117, NULL, NULL, 50365),
(50366, '3.80.10.10-FF-001042', NULL, 'Si:dkey-264f17.1', 148, NULL, NULL, 50366);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(50367, '1.25.50.10-FF-000006', NULL, 'Peptidase M1 family protein', 208, NULL, NULL, 50367),
(50368, '2.130.10.10-FF-000092', NULL, 'notchless protein homolog', 375, NULL, NULL, 50368),
(50369, '1.25.10.10-FF-001634', NULL, 'Proteasome activator complex subunit 4-like Protein', 461, NULL, NULL, 50369),
(50370, '3.40.50.720-FF-001151', NULL, '2-dehydropantoate 2-reductase', 192, NULL, NULL, 50370),
(50371, '3.40.50.1700-FF-000038', NULL, 'Lysosomal beta glucosidase', 245, NULL, NULL, 50371),
(50372, '2.60.40.1180-FF-000193', NULL, 'Glucan 1\3-alpha-glucosidase ROT2', 113, NULL, NULL, 50372),
(50373, '3.10.310.40-FF-000012', NULL, 'Alanine--tRNA ligase', 66, NULL, NULL, 50373),
(50374, '2.30.29.30-FF-000976', NULL, 'Tyrosine-protein phosphatase 1', 94, NULL, NULL, 50374),
(50375, '3.40.50.1220-FF-000136', NULL, 'Pyruvate decarboxylase', 78, NULL, NULL, 50375),
(50376, '3.40.50.1820-FF-001243', NULL, 'Uncharacterized protein', 322, NULL, NULL, 50376),
(50377, '1.25.50.20-FF-000009', NULL, 'Aminopeptidase', 318, NULL, NULL, 50377),
(50378, '2.10.220.10-FF-000152', NULL, 'Proprotein convertase subtilisin/kexin type 5', 107, NULL, NULL, 50378),
(50379, '3.20.20.100-FF-000098', NULL, 'Os10g0113375 protein', 114, NULL, NULL, 50379),
(50380, '3.30.160.60-FF-006223', NULL, NULL, 85, NULL, NULL, 50380),
(50381, '3.30.70.330-FF-001219', NULL, 'Putative G3BP-like protein', 147, NULL, NULL, 50381),
(50382, '3.40.50.300-FF-004015', NULL, 'ABC transporter ATP-binding protein', 296, NULL, NULL, 50382),
(50383, '3.90.190.10-FF-000379', NULL, 'Uncharacterized protein', 177, NULL, NULL, 50383),
(50384, '3.30.70.330-FF-001130', NULL, 'CUGBP Elav-like family member 4', 49, NULL, NULL, 50384),
(50385, '1.25.40.10-FF-001815', NULL, 'Putative pentatricopeptide repeat-containing protein At1g56570', 96, NULL, NULL, 50385),
(50386, '1.20.1070.10-FF-000595', NULL, 'Substance-P receptor', 130, NULL, NULL, 50386),
(50387, '1.10.630.10-FF-000771', NULL, 'Uncharacterized protein', 185, NULL, NULL, 50387),
(50388, '1.20.1250.20-FF-000696', NULL, 'Solute carrier organic anion transporter family member', 363, NULL, NULL, 50388),
(50389, '2.60.40.150-FF-000173', NULL, 'Calpain 5b', 119, NULL, NULL, 50389),
(50390, '3.40.50.11980-FF-000013', NULL, 'mitochondrial ribonuclease P catalytic subunit', 169, NULL, NULL, 50390),
(50391, '2.60.40.10-FF-006010', NULL, NULL, 114, NULL, NULL, 50391),
(50392, '3.30.40.10-FF-000787', NULL, 'Os02g0130300 protein', 57, NULL, NULL, 50392),
(50393, '3.40.50.1820-FF-000838', NULL, 'Uncharacterized protein', 271, NULL, NULL, 50393),
(50394, '3.80.10.10-FF-004386', NULL, 'Predicted protein', 168, NULL, NULL, 50394),
(50395, '2.60.120.10-FF-000273', NULL, 'Cysteine dioxygenase', 198, NULL, NULL, 50395),
(50396, '3.40.1030.10-FF-000002', NULL, 'Anthranilate phosphoribosyltransferase', 270, NULL, NULL, 50396),
(50397, '3.80.10.10-FF-004268', NULL, 'Uncharacterized protein', 58, NULL, NULL, 50397),
(50398, '1.10.238.20-FF-000047', NULL, 'AGAP012319-PA', 113, NULL, NULL, 50398),
(50399, '3.40.50.300-FF-000007', NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase', 176, NULL, NULL, 50399),
(50400, '2.40.10.10-FF-000511', NULL, NULL, 71, NULL, NULL, 50400),
(50401, '1.25.40.10-FF-004688', NULL, 'Pre-mRNA-splicing factor CLF1', 103, NULL, NULL, 50401),
(50402, '2.40.50.140-FF-001233', NULL, NULL, 47, NULL, NULL, 50402),
(50403, '3.20.20.190-FF-000169', NULL, NULL, 112, NULL, NULL, 50403),
(50404, '1.20.5.1430-FF-000002', NULL, 'microtubule-associated protein RP/EB family member 2 isoform X1', 85, NULL, NULL, 50404),
(50405, '3.40.50.1000-FF-000126', NULL, 'Cytosolic purine 5-nucleotidase', 202, NULL, NULL, 50405),
(50406, '1.10.238.10-FF-000044', NULL, 'Protein S100', 95, NULL, NULL, 50406),
(50407, '2.102.10.10-FF-000037', NULL, 'Benzoate 1,2-dioxygenase, large subunit', 128, NULL, NULL, 50407),
(50408, '1.50.40.10-FF-000088', NULL, 'Mitochondrial carrier protein RIM2', 243, NULL, NULL, 50408),
(50409, '3.30.70.330-FF-002001', NULL, NULL, 86, NULL, NULL, 50409),
(50410, '3.40.50.300-FF-003498', NULL, 'Si:dkey-73p2.2', 188, NULL, NULL, 50410);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(50411, '2.130.10.10-FF-006021', NULL, 'Uncharacterized protein', 137, NULL, NULL, 50411),
(50412, '3.90.470.20-FF-000044', NULL, 'Holo-[acyl-carrier-protein] synthase', 116, NULL, NULL, 50412),
(50413, '3.60.20.10-FF-000099', NULL, 'Proteasome subunit beta', 230, NULL, NULL, 50413),
(50414, '1.20.120.1900-FF-000061', NULL, 'Spindle pole body component', 133, NULL, NULL, 50414),
(50415, '1.10.510.10-FF-003842', NULL, NULL, 107, NULL, NULL, 50415),
(50416, '3.40.720.10-FF-000336', NULL, 'Uncharacterized protein', 110, NULL, NULL, 50416),
(50417, '3.30.160.60-FF-002215', NULL, 'Zinc finger protein 544', 29, NULL, NULL, 50417),
(50418, '3.90.1750.10-FF-000101', NULL, 'Uncharacterized protein', 84, NULL, NULL, 50418),
(50419, '3.80.10.10-FF-002177', NULL, 'Leucine-rich repeat protein (LRRP), putative', 174, NULL, NULL, 50419),
(50420, '3.65.10.20-FF-000012', NULL, 'RNA 3''-terminal phosphate cyclase, putative', 233, NULL, NULL, 50420),
(50421, '3.30.70.100-FF-000072', NULL, 'V-type proton ATPase subunit C', 21, NULL, NULL, 50421),
(50422, '3.40.250.10-FF-000019', NULL, 'Sulfurtransferase', 143, NULL, NULL, 50422),
(50423, '4.10.280.10-FF-000142', NULL, 'Spermatogenesis and oogenesis specific basic helix-loop-helix 1', 57, NULL, NULL, 50423),
(50424, '1.10.510.10-FF-000026', NULL, 'Calcium/calmodulin-dependent protein kinase type 1', 217, NULL, NULL, 50424),
(50425, '2.10.250.10-FF-000007', NULL, 'calreticulin-like', 68, NULL, NULL, 50425),
(50426, '3.40.50.1010-FF-000129', NULL, '6-hydroxy-3-succinoylpyridine hydroxylase', 215, NULL, NULL, 50426),
(50427, '3.30.200.20-FF-000100', NULL, 'Dual specificity mitogen-activated protein kinase kinase 1', 114, NULL, NULL, 50427),
(50428, '2.10.270.10-FF-000008', NULL, 'Lysin', 84, NULL, NULL, 50428),
(50429, '3.40.50.300-FF-005858', NULL, 'Uncharacterized protein', 270, NULL, NULL, 50429),
(50430, '3.30.70.890-FF-000055', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 121, NULL, NULL, 50430),
(50431, '1.20.900.10-FF-000082', NULL, 'Uncharacterized protein', 100, NULL, NULL, 50431),
(50432, '1.10.287.70-FF-000760', NULL, 'Uncharacterized protein', 44, NULL, NULL, 50432),
(50433, '1.10.510.10-FF-000705', NULL, 'SRSF protein kinase 2', 87, NULL, NULL, 50433),
(50434, '6.10.140.2150-FF-000002', NULL, 'Sphinganine-1-phosphate aldolase Bst1', 57, NULL, NULL, 50434),
(50435, '2.60.40.10-FF-000057', NULL, 'neural cell adhesion molecule L1', 114, NULL, NULL, 50435),
(50436, '1.50.40.10-FF-000324', NULL, 'Low-CO2-inducible chloroplast envelope protein', 319, NULL, NULL, 50436),
(50437, '3.30.1520.10-FF-000093', NULL, 'Vacuolar protein sorting-associated protein vps17', 144, NULL, NULL, 50437),
(50438, '1.25.40.10-FF-001462', NULL, 'OJ991214_12.4 protein', 89, NULL, NULL, 50438),
(50439, '2.10.25.10-FF-000687', NULL, 'Neurogenic locus notch homolog protein 3', 37, NULL, NULL, 50439),
(50440, '1.20.5.100-FF-000021', NULL, 'UDP-glucose/GDP-mannose dehydrogenase, putative', 26, NULL, NULL, 50440),
(50441, '1.20.120.980-FF-000053', NULL, 'Predicted protein', 78, NULL, NULL, 50441),
(50442, '3.40.718.10-FF-000067', NULL, 'Isocitrate dehydrogenase [NADP]', 405, NULL, NULL, 50442),
(50443, '2.60.40.60-FF-000016', NULL, 'Protocadherin 9', 106, NULL, NULL, 50443),
(50444, '1.10.510.10-FF-001897', NULL, 'Uncharacterized protein', 162, NULL, NULL, 50444),
(50445, '1.10.150.300-FF-000009', NULL, NULL, 13, NULL, NULL, 50445),
(50446, '3.80.10.10-FF-002677', NULL, 'leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3', 106, NULL, NULL, 50446),
(50447, '3.30.160.60-FF-004514', NULL, NULL, 26, NULL, NULL, 50447),
(50448, '3.40.1110.10-FF-000267', NULL, NULL, 143, NULL, NULL, 50448),
(50449, '3.10.20.90-FF-000282', NULL, 'Blast:Ral guanine nucleotide dissociation stimulator-like 1', 114, NULL, NULL, 50449),
(50450, '3.40.50.410-FF-000366', NULL, 'General transcription and DNA repair factor IIH subunit tfb4', 211, NULL, NULL, 50450),
(50451, '2.30.30.40-FF-000078', NULL, 'Putative e3 ubiquitin-protein ligase mib2', 92, NULL, NULL, 50451),
(50452, '3.40.50.300-FF-006201', NULL, 'Uncharacterized protein', 135, NULL, NULL, 50452);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(50453, '3.30.70.1230-FF-000119', NULL, 'Guanylate cyclase', 195, NULL, NULL, 50453),
(50454, '3.90.1290.10-FF-000021', NULL, 'microtubule-actin cross-linking factor 1 isoform X25', 180, NULL, NULL, 50454),
(50455, '3.30.420.40-FF-000212', NULL, 'L-xylulose/3-keto-L-gulonate kinase', 241, NULL, NULL, 50455),
(50456, '1.10.238.260-FF-000009', NULL, 'Putative 2-isopropylmalate synthase', 79, NULL, NULL, 50456),
(50457, '1.10.287.570-FF-000005', NULL, 'Anion transporter ABTS-2', 46, NULL, NULL, 50457),
(50458, '2.130.10.10-FF-001816', NULL, 'WD-repeat protein', 270, NULL, NULL, 50458),
(50459, '2.60.260.20-FF-000140', NULL, 'DnaJ-related molecular chaperone', 73, NULL, NULL, 50459),
(50460, '1.20.5.340-FF-000008', NULL, 'Myosin heavy chain 11', 113, NULL, NULL, 50460),
(50461, '1.10.3420.10-FF-000001', NULL, 'Cof family protein', 168, NULL, NULL, 50461),
(50462, '1.10.760.10-FF-000044', NULL, 'Cytochrome c2', 112, NULL, NULL, 50462),
(50463, '3.30.160.60-FF-002480', NULL, 'Zinc finger protein 1050', 23, NULL, NULL, 50463),
(50464, '3.40.50.720-FF-000987', NULL, 'Enoyl-[acyl-carrier-protein] reductase [NADH]', 400, NULL, NULL, 50464),
(50465, '2.70.130.10-FF-000103', NULL, NULL, 148, NULL, NULL, 50465),
(50466, '3.10.110.10-FF-000050', NULL, 'eIF-2-alpha kinase GCN2', 130, NULL, NULL, 50466),
(50467, '3.80.10.10-FF-000586', NULL, 'Blast:Protein toll', 103, NULL, NULL, 50467),
(50468, '3.40.50.150-FF-000445', NULL, 'Protein-L-isoaspartate O-methyltransferase', 209, NULL, NULL, 50468),
(50469, '1.20.120.1110-FF-000004', NULL, 'TBP-associated factor 4, isoform F', 109, NULL, NULL, 50469),
(50470, '1.20.1600.10-FF-000024', NULL, 'Multidrug efflux transporter outer membrane subunit OpmD', 330, NULL, NULL, 50470),
(50471, '3.40.50.300-FF-000272', NULL, 'UvrABC system protein A', 199, NULL, NULL, 50471),
(50472, '2.10.70.10-FF-000112', NULL, 'Uncharacterized protein, isoform C', 63, NULL, NULL, 50472),
(50473, '1.10.555.10-FF-000258', NULL, NULL, 107, NULL, NULL, 50473),
(50474, '1.20.120.1100-FF-000001', NULL, 'Fatty-acid and retinol-binding protein 1', 140, NULL, NULL, 50474),
(50475, '1.10.167.10-FF-000019', NULL, 'A-kinase anchor protein 10, mitochondrial isoform X1', 98, NULL, NULL, 50475),
(50476, '2.60.120.970-FF-000017', NULL, 'Bone morphogenetic protein 8a', 250, NULL, NULL, 50476),
(50477, '1.10.230.10-FF-000015', NULL, 'Citrate synthase', 98, NULL, NULL, 50477),
(50478, '2.60.40.150-FF-000111', NULL, 'synaptotagmin-5 isoform X1', 137, NULL, NULL, 50478),
(50479, '2.40.50.100-FF-000018', NULL, 'p-hydroxybenzoic acid efflux pump subunit AaeA', 69, NULL, NULL, 50479),
(50480, '3.90.420.10-FF-000004', NULL, 'Sulfite oxidase', 262, NULL, NULL, 50480),
(50481, '3.90.1720.10-FF-000009', NULL, 'Peptidoglycan endopeptidase LytF', 123, NULL, NULL, 50481),
(50482, '2.40.160.20-FF-000002', NULL, 'Lipid A palmitoyltransferase PagP', 162, NULL, NULL, 50482),
(50483, '3.40.50.300-FF-002306', NULL, 'Grc3p', 231, NULL, NULL, 50483),
(50484, '1.10.630.10-FF-000563', NULL, 'Uncharacterized protein', 328, NULL, NULL, 50484),
(50485, '3.40.1000.10-FF-000028', NULL, 'Uncharacterized protein', 153, NULL, NULL, 50485),
(50486, '1.20.1070.10-FF-000707', NULL, 'Angiotensin II receptor, type 2', 354, NULL, NULL, 50486),
(50487, '3.80.10.10-FF-001513', NULL, 'PH domain and leucine rich repeat protein phosphatase 1', 154, NULL, NULL, 50487),
(50488, '3.40.50.300-FF-000215', NULL, 'ATP-binding protein', 208, NULL, NULL, 50488),
(50489, '1.20.1070.10-FF-000387', NULL, 'DOPamine receptor', 127, NULL, NULL, 50489),
(50490, '3.90.228.10-FF-000052', NULL, 'Poly [ADP-ribose] polymerase', 106, NULL, NULL, 50490),
(50491, '3.40.50.620-FF-000839', NULL, 'Uncharacterized protein', 93, NULL, NULL, 50491),
(50492, '1.20.1250.20-FF-000808', NULL, 'Sucrose transport protein SUC5, putative', 220, NULL, NULL, 50492),
(50493, '2.60.260.20-FF-000022', NULL, 'HSP40, subfamily A, putative', 68, NULL, NULL, 50493),
(50494, '3.60.10.10-FF-000216', NULL, 'Uncharacterized protein', 260, NULL, NULL, 50494),
(50495, '1.10.472.80-FF-000047', NULL, 'Uncharacterized protein, isoform B', 150, NULL, NULL, 50495);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(50496, '3.90.550.10-FF-000250', NULL, 'Glycosyl transferase, group 2 family', 200, NULL, NULL, 50496),
(50497, '2.130.10.10-FF-003879', NULL, 'Uncharacterized protein', 278, NULL, NULL, 50497),
(50498, '1.20.970.10-FF-000030', NULL, 'Anthranilate phosphoribosyltransferase', 68, NULL, NULL, 50498),
(50499, '1.10.8.270-FF-000107', NULL, 'TBC1 domain family member 28', 84, NULL, NULL, 50499),
(50500, '2.40.290.10-FF-000003', NULL, 'RNA-binding motif protein 15', 178, NULL, NULL, 50500),
(50501, '3.40.50.2300-FF-000825', NULL, NULL, 142, NULL, NULL, 50501),
(50502, '3.40.50.10140-FF-000063', NULL, 'Interleukin 1 receptor accessory protein', 54, NULL, NULL, 50502),
(50503, '3.40.1810.10-FF-000034', NULL, 'Os09g0116000 protein', 60, NULL, NULL, 50503),
(50504, '1.10.10.10-FF-000060', NULL, 'DNA-binding transcriptional regulator HexR', 77, NULL, NULL, 50504),
(50505, '1.20.1070.10-FF-001051', NULL, 'Uncharacterized protein', 332, NULL, NULL, 50505),
(50506, '2.30.29.30-FF-000768', NULL, 'Protein CBG15745', 112, NULL, NULL, 50506),
(50507, '3.40.50.150-FF-001463', NULL, NULL, 138, NULL, NULL, 50507),
(50508, '1.10.10.10-FF-000116', NULL, 'DNA-directed RNA polymerase III subunit RPC6', 66, NULL, NULL, 50508),
(50509, '2.10.25.10-FF-001204', NULL, 'Predicted protein', 24, NULL, NULL, 50509),
(50510, '2.30.30.140-FF-000169', NULL, 'DNA (cytosine-5-)-methyltransferase 3 beta, duplicate b.2', 71, NULL, NULL, 50510),
(50511, '3.60.20.10-FF-000245', NULL, NULL, 65, NULL, NULL, 50511),
(50512, '3.10.590.10-FF-000017', NULL, 'Uncharacterized protein', 149, NULL, NULL, 50512),
(50513, '1.10.132.30-FF-000035', NULL, 'Uncharacterized protein', 110, NULL, NULL, 50513),
(50514, '2.130.10.10-FF-001463', NULL, 'Uncharacterized protein, isoform D', 101, NULL, NULL, 50514),
(50515, '2.10.90.10-FF-000175', NULL, 'Uncharacterized protein', 136, NULL, NULL, 50515),
(50516, '3.30.9.10-FF-000169', NULL, 'Uncharacterized protein', 111, NULL, NULL, 50516),
(50517, '2.60.120.10-FF-000773', NULL, 'Uncharacterized protein', 45, NULL, NULL, 50517),
(50518, '3.40.50.1820-FF-000990', NULL, 'Uncharacterized protein', 247, NULL, NULL, 50518),
(50519, '3.80.10.10-FF-004532', NULL, 'Uncharacterized protein', 194, NULL, NULL, 50519),
(50520, '3.40.50.300-FF-002424', NULL, 'ATP-dependent DNA helicase RecQ', 196, NULL, NULL, 50520),
(50521, '2.10.220.10-FF-000123', NULL, 'Fibronectin domain-containing protein', 80, NULL, NULL, 50521),
(50522, '2.60.40.10-FF-002474', NULL, 'Titin homolog', 100, NULL, NULL, 50522),
(50523, '2.10.70.10-FF-000230', NULL, 'Mannose-binding lectin associated serine protease', 64, NULL, NULL, 50523),
(50524, '2.60.40.1730-FF-000077', NULL, NULL, 215, NULL, NULL, 50524),
(50525, '1.20.1250.10-FF-000098', NULL, NULL, 164, NULL, NULL, 50525),
(50526, '1.20.5.3600-FF-000001', NULL, 'inner centromere protein-like', 47, NULL, NULL, 50526),
(50527, '1.10.10.1050-FF-000014', NULL, 'Uncharacterized protein', 79, NULL, NULL, 50527),
(50528, '2.40.150.20-FF-000030', NULL, '60S ribosomal protein L23', 43, NULL, NULL, 50528),
(50529, '1.10.287.130-FF-000194', NULL, 'Sensor histidine kinase, PAS, PAS and PAS domain-containing', 84, NULL, NULL, 50529),
(50530, '1.10.287.110-FF-000244', NULL, 'Chaperone protein dnaJ 3', 129, NULL, NULL, 50530),
(50531, '3.10.580.10-FF-000045', NULL, 'Magnesium and cobalt transporter', 81, NULL, NULL, 50531),
(50532, '3.30.160.60-FF-000119', NULL, 'Zinc finger and BTB domain containing 37', 27, NULL, NULL, 50532),
(50533, '3.30.70.330-FF-002973', NULL, NULL, 150, NULL, NULL, 50533),
(50534, '2.40.50.140-FF-001087', NULL, NULL, 76, NULL, NULL, 50534),
(50535, '3.40.50.300-FF-000625', NULL, 'Ras-like protein family member 10B', 185, NULL, NULL, 50535),
(50536, '3.30.760.10-FF-000066', NULL, 'Eukaryotic translation initiation factor 4E family member 2', 127, NULL, NULL, 50536),
(50537, '2.60.220.30-FF-000017', NULL, 'ZO-1 (Zonula Occludens tight junctional protein) Ortholog', 145, NULL, NULL, 50537),
(50538, '3.30.160.60-FF-004632', NULL, NULL, 27, NULL, NULL, 50538),
(50539, '3.30.420.40-FF-000330', NULL, 'Transcriptional regulator MT0503', 155, NULL, NULL, 50539);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(50540, '1.10.555.10-FF-000051', NULL, 'Synapse defective Rho GTPase homolog 1', 235, NULL, NULL, 50540),
(50541, '3.40.50.1100-FF-000246', NULL, 'Putative truncated L-serine dehydratase YIL168W', 30, NULL, NULL, 50541),
(50542, '3.40.1360.10-FF-000021', NULL, 'Type 2 DNA topoisomerase 6 subunit A', 219, NULL, NULL, 50542),
(50543, '3.40.50.10130-FF-000060', NULL, 'Crossover junction endonuclease eme1', 202, NULL, NULL, 50543),
(50544, '3.30.70.330-FF-001337', NULL, 'SART-3/p110 homolog', 97, NULL, NULL, 50544),
(50545, '3.40.50.300-FF-004987', NULL, 'Uncharacterized protein', 153, NULL, NULL, 50545),
(50546, '3.30.160.60-FF-004161', NULL, NULL, 31, NULL, NULL, 50546),
(50547, '2.40.70.10-FF-000341', NULL, NULL, 162, NULL, NULL, 50547),
(50548, '3.40.50.300-FF-007393', NULL, 'SWI/SNF related, matrix associated, actin dependent regulator of chromatin, subfamily a, member 1', 314, NULL, NULL, 50548),
(50549, '3.40.930.10-FF-000021', NULL, 'PTS sugar transporter subunit IIA', 149, NULL, NULL, 50549),
(50550, '3.40.50.720-FF-000723', NULL, 'Glyoxylate reductase', 115, NULL, NULL, 50550),
(50551, '3.40.50.300-FF-004610', NULL, 'ATP-dependent DNA helicase Dna2', 94, NULL, NULL, 50551),
(50552, '2.40.70.10-FF-000251', NULL, 'Probable aspartic-type endopeptidase AFUA_3G01220', 184, NULL, NULL, 50552),
(50553, '2.30.29.30-FF-000297', NULL, 'Sorting nexin 31', 114, NULL, NULL, 50553),
(50554, '3.40.50.800-FF-000096', NULL, 'Ornithine carbamoyltransferase chloroplastic', 80, NULL, NULL, 50554),
(50555, '2.60.40.1910-FF-000041', NULL, NULL, 80, NULL, NULL, 50555),
(50556, '3.30.200.120-FF-000001', NULL, 'Serine/threonine-protein kinase CtkA', 94, NULL, NULL, 50556),
(50557, '1.20.5.110-FF-000288', NULL, 'Vesicle transport v-SNARE protein', 79, NULL, NULL, 50557),
(50558, '3.30.160.60-FF-005296', NULL, NULL, 33, NULL, NULL, 50558),
(50559, '3.30.930.10-FF-000192', NULL, 'Phenylalanyl-tRNA synthetase subunit alpha', 257, NULL, NULL, 50559),
(50560, '1.10.510.10-FF-001779', NULL, 'Probable myosin light chain kinase DDB_G0292624', 310, NULL, NULL, 50560),
(50561, '1.25.40.10-FF-005205', NULL, 'Uncharacterized protein', 204, NULL, NULL, 50561),
(50562, '2.60.40.60-FF-000224', NULL, 'Si:dkey-22o22.2', 107, NULL, NULL, 50562),
(50563, '2.60.40.640-FF-000106', NULL, 'Arrestin domain-containing protein C31A2.12', 133, NULL, NULL, 50563),
(50564, '2.70.150.10-FF-000076', NULL, 'P-type ATPase, putative', 137, NULL, NULL, 50564),
(50565, '3.30.1330.20-FF-000002', NULL, 'Tubulin beta chain', 110, NULL, NULL, 50565),
(50566, '3.10.100.10-FF-000223', NULL, NULL, 144, NULL, NULL, 50566),
(50567, '3.30.70.80-FF-000028', NULL, 'Uncharacterized protein', 66, NULL, NULL, 50567),
(50568, '3.30.190.20-FF-000047', NULL, 'Uncharacterized protein', 56, NULL, NULL, 50568),
(50569, '4.10.320.10-FF-000022', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 52, NULL, NULL, 50569),
(50570, '1.20.1070.10-FF-001522', NULL, 'Adenylate cyclase-activating polypeptide 1a (pituitary) receptor type I', 189, NULL, NULL, 50570),
(50571, '3.80.10.10-FF-000378', NULL, 'Leucine-rich repeat family protein', 100, NULL, NULL, 50571),
(50572, '1.10.238.10-FF-000191', NULL, 'Calmodulin like 4', 147, NULL, NULL, 50572),
(50573, '3.20.20.70-FF-000276', NULL, 'Thiamine-phosphate synthase', 207, NULL, NULL, 50573),
(50574, '1.20.190.50-FF-000015', NULL, 'Nuclear pore complex protein', 78, NULL, NULL, 50574),
(50575, '3.90.79.10-FF-000002', NULL, 'diphosphoinositol polyphosphate phosphohydrolase 1', 146, NULL, NULL, 50575),
(50576, '1.25.10.10-FF-000032', NULL, 'Vac14 homolog (S. cerevisiae)', 205, NULL, NULL, 50576),
(50577, '3.30.505.10-FF-000013', NULL, 'SH2 domain-containing protein 3C isoform X1', 119, NULL, NULL, 50577),
(50578, '3.40.1280.30-FF-000026', NULL, 'Predicted protein', 186, NULL, NULL, 50578),
(50579, '1.10.8.60-FF-000214', NULL, 'CbbX protein', 93, NULL, NULL, 50579),
(50580, '1.10.510.10-FF-003724', NULL, NULL, 153, NULL, NULL, 50580),
(50581, '1.25.40.10-FF-001669', NULL, 'Tetratricopeptide repeat-containing protein', 159, NULL, NULL, 50581);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(50582, '3.40.50.10330-FF-000030', NULL, 'NAD kinase', 134, NULL, NULL, 50582),
(50583, '2.60.40.10-FF-002002', NULL, 'FiLamiN (Actin binding protein) homolog', 86, NULL, NULL, 50583),
(50584, '2.170.190.11-FF-000022', NULL, 'Molybdopterin biosynthesis protein (MoeA-2)', 91, NULL, NULL, 50584),
(50585, '3.30.160.60-FF-005442', NULL, NULL, 48, NULL, NULL, 50585),
(50586, '2.10.50.10-FF-000167', NULL, 'Uncharacterized protein', 39, NULL, NULL, 50586),
(50587, '3.90.230.10-FF-000057', NULL, NULL, 80, NULL, NULL, 50587),
(50588, '3.40.50.150-FF-000653', NULL, 'Protein-L-isoaspartate O-methyltransferase', 201, NULL, NULL, 50588),
(50589, '1.10.8.60-FF-000068', NULL, 'spermatogenesis-associated protein 5 isoform X1', 84, NULL, NULL, 50589),
(50590, '3.30.870.10-FF-000102', NULL, 'Cardiolipin synthase', 166, NULL, NULL, 50590),
(50591, '3.30.160.60-FF-000063', NULL, 'Wilms tumor 1-KTS isoform', 93, NULL, NULL, 50591),
(50592, '3.30.160.60-FF-004014', NULL, 'GM23838', 99, NULL, NULL, 50592),
(50593, '3.10.290.10-FF-000034', NULL, 'RNA-binding protein S4', 56, NULL, NULL, 50593),
(50594, '2.60.220.50-FF-000175', NULL, 'Uncharacterized protein', 86, NULL, NULL, 50594),
(50595, '1.10.510.10-FF-003578', NULL, NULL, 214, NULL, NULL, 50595),
(50596, '2.30.30.140-FF-000315', NULL, 'Uncharacterized protein', 61, NULL, NULL, 50596),
(50597, '3.40.50.300-FF-007449', NULL, 'ATP-dependent helicase (DinG family)', 247, NULL, NULL, 50597),
(50598, '3.30.1330.30-FF-000005', NULL, '40S ribosomal protein S12', 136, NULL, NULL, 50598),
(50599, '2.130.10.10-FF-002126', NULL, 'WD40 repeat-like protein', 248, NULL, NULL, 50599),
(50600, '2.60.40.1090-FF-000019', NULL, 'Type 1 fimbrial protein subunit FimI', 151, NULL, NULL, 50600),
(50601, '3.30.40.10-FF-000848', NULL, 'AGAP001386-PA', 89, NULL, NULL, 50601),
(50602, '1.20.5.4130-FF-000008', NULL, 'Disease resistance protein RGA5', 119, NULL, NULL, 50602),
(50603, '3.30.2350.20-FF-000003', NULL, 'Pseudouridylate synthase 7 homolog', 190, NULL, NULL, 50603),
(50604, '1.10.10.140-FF-000005', NULL, 'Cytochrome c oxidase subunit', 80, NULL, NULL, 50604),
(50605, '1.10.10.60-FF-001098', NULL, NULL, 105, NULL, NULL, 50605),
(50606, '3.30.160.60-FF-003609', NULL, NULL, 32, NULL, NULL, 50606),
(50607, '2.10.220.10-FF-000213', NULL, 'Proprotein convertase subtilisin/kexin type 5', 50, NULL, NULL, 50607),
(50608, '3.60.40.10-FF-000044', NULL, 'probable protein phosphatase 2C 25', 263, NULL, NULL, 50608),
(50609, '4.10.400.10-FF-000023', NULL, 'Low density lipoprotein receptor-related protein 1', 45, NULL, NULL, 50609),
(50610, '1.25.40.10-FF-003878', NULL, 'Uncharacterized protein', 86, NULL, NULL, 50610),
(50611, '3.30.1460.10-FF-000003', NULL, 'Type III export apparatus protein', 126, NULL, NULL, 50611),
(50612, '1.10.730.10-FF-000216', NULL, 'Valyl-tRNA synthetase', 148, NULL, NULL, 50612),
(50613, '1.10.3430.10-FF-000030', NULL, 'Rh family, C glycoprotein b', 398, NULL, NULL, 50613),
(50614, '3.80.10.10-FF-000996', NULL, 'Os04g0503500 protein', 95, NULL, NULL, 50614),
(50615, '3.40.30.10-FF-000561', NULL, 'Periplasmic [Fe] hydrogenase 1', 76, NULL, NULL, 50615),
(50616, '2.60.40.10-FF-005964', NULL, NULL, 87, NULL, NULL, 50616),
(50617, '3.40.50.1820-FF-000428', NULL, 'YJR098C-like protein', 157, NULL, NULL, 50617),
(50618, '3.40.50.1000-FF-000008', NULL, 'Plasma membrane ATPase', 149, NULL, NULL, 50618),
(50619, '3.10.250.10-FF-000026', NULL, 'Tequila, isoform D', 108, NULL, NULL, 50619),
(50620, '2.70.98.110-FF-000016', NULL, NULL, 331, NULL, NULL, 50620),
(50621, '3.40.1800.20-FF-000042', NULL, NULL, 70, NULL, NULL, 50621),
(50622, '2.60.40.10-FF-002620', NULL, 'Down syndrome cell adhesion molecule 3, isoform E', 100, NULL, NULL, 50622),
(50623, '1.10.3720.10-FF-000131', NULL, 'Molybdenum transport system permease', 217, NULL, NULL, 50623),
(50624, '3.30.160.60-FF-003851', NULL, NULL, 29, NULL, NULL, 50624),
(50625, '3.20.20.70-FF-000219', NULL, 'Thiamine phosphate synthase', 203, NULL, NULL, 50625),
(50626, '1.10.135.10-FF-000002', NULL, 'creatine kinase S-type, mitochondrial', 110, NULL, NULL, 50626);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(50627, '3.40.50.1980-FF-000015', NULL, 'Fe(3+)-hydroxamate ABC transporter substrate-binding protein FhuD', 174, NULL, NULL, 50627),
(50628, '1.20.1250.20-FF-001213', NULL, 'MFS transporter, putative (AFU_orthologue AFUA_2G08230)', 237, NULL, NULL, 50628),
(50629, '3.40.50.300-FF-008264', NULL, 'Uncharacterized protein', 47, NULL, NULL, 50629),
(50630, '1.20.1280.170-FF-000010', NULL, 'Exocyst complex component 7', 573, NULL, NULL, 50630),
(50631, '1.25.40.10-FF-000888', NULL, 'Pentatricopeptide repeat-containing protein', 127, NULL, NULL, 50631),
(50632, '2.60.120.10-FF-000155', NULL, 'Mannose-6-phosphate isomerase, class I', 92, NULL, NULL, 50632),
(50633, '3.40.50.150-FF-000092', NULL, 'Leucine carboxyl methyltransferase 1', 313, NULL, NULL, 50633),
(50634, '1.25.40.20-FF-000071', NULL, 'E3 ubiquitin-protein ligase MIB2 isoform X3', 137, NULL, NULL, 50634),
(50635, '3.90.79.20-FF-000005', NULL, 'NADH pyrophosphatase, putative', 134, NULL, NULL, 50635),
(50636, '3.30.200.20-FF-001117', NULL, 'Putative kinase-like protein TMKL1', 96, NULL, NULL, 50636),
(50637, '4.10.900.10-FF-000016', NULL, 'Uncharacterized protein', 58, NULL, NULL, 50637),
(50638, '2.130.10.10-FF-005824', NULL, 'Protein FAN', 60, NULL, NULL, 50638),
(50639, '2.60.40.10-FF-003194', NULL, 'Neuron-derived neurotrophic factor', 74, NULL, NULL, 50639),
(50640, '3.40.50.720-FF-001504', NULL, 'Putative CDP tyvulose epimerase', 348, NULL, NULL, 50640),
(50641, '3.80.10.10-FF-001249', NULL, 'Leucine rich repeats (6 copies)/Leucine Rich repeat', 329, NULL, NULL, 50641),
(50642, '2.130.10.10-FF-002036', NULL, 'Unplaced genomic scaffold supercont1.18, whole genome shotgun sequence', 240, NULL, NULL, 50642),
(50643, '1.10.472.10-FF-000133', NULL, 'Putative cyclin-F1-2', 122, NULL, NULL, 50643),
(50644, '1.10.1220.10-FF-000019', NULL, 'Antitoxin FitA', 50, NULL, NULL, 50644),
(50645, '3.30.420.10-FF-000428', NULL, NULL, 97, NULL, NULL, 50645),
(50646, '3.40.50.720-FF-000577', NULL, 'Proline utilization protein PrnX, putative', 208, NULL, NULL, 50646),
(50647, '3.40.50.1970-FF-000012', NULL, '3-dehydroquinate synthase', 176, NULL, NULL, 50647),
(50648, '1.20.920.10-FF-000139', NULL, 'AT24439p', 124, NULL, NULL, 50648),
(50649, '3.40.50.150-FF-000035', NULL, 'tRNA (guanine-N(7)-)-methyltransferase', 212, NULL, NULL, 50649),
(50650, '3.60.15.10-FF-000210', NULL, 'Predicted protein', 38, NULL, NULL, 50650),
(50651, '3.10.450.580-FF-000013', NULL, 'Mediator of RNA polymerase II transcription subunit 6', 126, NULL, NULL, 50651),
(50652, '2.30.29.30-FF-001078', NULL, 'Ran-specific GTPase-activating protein', 67, NULL, NULL, 50652),
(50653, '3.10.129.10-FF-000188', NULL, 'Probable acyl-coenzyme a thioester hydrolase', 149, NULL, NULL, 50653),
(50654, '3.40.50.300-FF-006055', NULL, 'Uncharacterized protein', 258, NULL, NULL, 50654),
(50655, '3.30.70.3270-FF-000006', NULL, 'NAD(P)H-quinone oxidoreductase subunit I, chloroplastic', 116, NULL, NULL, 50655),
(50656, '1.25.40.10-FF-005093', NULL, 'Pentatricopeptide repeat-containing protein At4g35130, chloroplastic', 69, NULL, NULL, 50656),
(50657, '3.10.450.10-FF-000041', NULL, 'Uncharacterized protein', 98, NULL, NULL, 50657),
(50658, '1.20.1070.10-FF-002186', NULL, 'Uncharacterized protein', 87, NULL, NULL, 50658),
(50659, '3.40.190.10-FF-000020', NULL, 'Histidine ABC transporter substrate-binding periplasmic protein', 101, NULL, NULL, 50659),
(50660, '1.20.58.1390-FF-000001', NULL, 'Methyltransferase family protein', 83, NULL, NULL, 50660),
(50661, '2.60.120.920-FF-000166', NULL, 'HNRNPUL2-BSCL2 readthrough (NMD candidate)', 119, NULL, NULL, 50661),
(50662, '3.30.70.330-FF-000202', NULL, 'HIV Tat-specific factor 1', 83, NULL, NULL, 50662),
(50663, '3.30.450.30-FF-000003', NULL, 'ragulator complex protein LAMTOR3 homolog', 124, NULL, NULL, 50663),
(50664, '3.40.50.2300-FF-001606', NULL, NULL, 67, NULL, NULL, 50664),
(50665, '3.30.40.10-FF-001304', NULL, 'Putative oxidoreductase, chloroplastic isoform B', 77, NULL, NULL, 50665),
(50666, '1.10.10.250-FF-000009', NULL, '60S ribosomal protein L12', 83, NULL, NULL, 50666);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(50667, '3.30.60.30-FF-000243', NULL, 'Predicted protein', 45, NULL, NULL, 50667),
(50668, '4.10.1290.10-FF-000004', NULL, NULL, 46, NULL, NULL, 50668),
(50669, '3.30.200.20-FF-001735', NULL, 'Uncharacterized protein', 121, NULL, NULL, 50669),
(50670, '3.60.21.10-FF-000331', NULL, 'Acid sphingomyelinase-like phosphodiesterase 3a', 231, NULL, NULL, 50670),
(50671, '3.40.50.2000-FF-000617', NULL, 'Uncharacterized protein', 158, NULL, NULL, 50671),
(50672, '3.90.20.10-FF-000002', NULL, 'Hemagglutinin', 191, NULL, NULL, 50672),
(50673, '1.10.390.10-FF-000055', NULL, 'Uncharacterized protein', 122, NULL, NULL, 50673),
(50674, '3.40.50.1360-FF-000037', NULL, '6-phosphogluconolactonase', 241, NULL, NULL, 50674),
(50675, '1.10.220.10-FF-000043', NULL, 'Annexin', 79, NULL, NULL, 50675),
(50676, '3.50.50.60-FF-001105', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 210, NULL, NULL, 50676),
(50677, '3.40.800.20-FF-000020', NULL, 'Histone deacetylase', 377, NULL, NULL, 50677),
(50678, '1.10.10.10-FF-001454', NULL, 'Meiotic recombination protein SPO11-4', 136, NULL, NULL, 50678),
(50679, '2.130.10.10-FF-000445', NULL, 'Regulatory-associated protein of TOR 1', 175, NULL, NULL, 50679),
(50680, '2.30.29.30-FF-000561', NULL, 'FERM domain (Protein4.1-ezrin-radixin-moesin) family', 128, NULL, NULL, 50680),
(50681, '3.90.640.10-FF-000280', NULL, 'Actin-like protein arp5', 53, NULL, NULL, 50681),
(50682, '3.30.200.20-FF-002399', NULL, 'Uncharacterized protein', 92, NULL, NULL, 50682),
(50683, '3.30.450.350-FF-000002', NULL, 'Adenylate cyclase, germination specific', 221, NULL, NULL, 50683),
(50684, '3.30.559.70-FF-000020', NULL, 'Putative carnitine acetyltransferase', 347, NULL, NULL, 50684),
(50685, '1.10.10.580-FF-000024', NULL, 'Cohesin subunit rad21', 85, NULL, NULL, 50685),
(50686, '3.20.20.70-FF-000129', NULL, 'Probable galactinol--sucrose galactosyltransferase 1', 328, NULL, NULL, 50686),
(50687, '1.20.1310.10-FF-000131', NULL, NULL, 122, NULL, NULL, 50687),
(50688, '2.30.30.40-FF-000224', NULL, 'Src like adaptor 2', 73, NULL, NULL, 50688),
(50689, '1.10.287.70-FF-000467', NULL, 'Uncharacterized protein', 257, NULL, NULL, 50689),
(50690, '3.40.50.300-FF-008000', NULL, 'Uncharacterized protein', 151, NULL, NULL, 50690),
(50691, '1.25.40.10-FF-001198', NULL, 'Transcriptional regulator, LuxR family', 201, NULL, NULL, 50691),
(50692, '3.30.420.40-FF-000066', NULL, 'Actin-related protein 6', 124, NULL, NULL, 50692),
(50693, '3.40.50.2300-FF-001045', NULL, NULL, 165, NULL, NULL, 50693),
(50694, '1.20.1070.10-FF-001612', NULL, 'Uncharacterized protein', 148, NULL, NULL, 50694),
(50695, '2.60.120.920-FF-000109', NULL, 'Heterogeneous nuclear ribonucleoprotein U-like 2', 208, NULL, NULL, 50695),
(50696, '1.10.1410.10-FF-000113', NULL, 'Nucleolar protein 6', 106, NULL, NULL, 50696),
(50697, '3.30.420.10-FF-000580', NULL, NULL, 303, NULL, NULL, 50697),
(50698, '3.30.1480.10-FF-000009', NULL, 'Transcription termination/antitermination protein NusA', 127, NULL, NULL, 50698),
(50699, '2.60.40.10-FF-003755', NULL, NULL, 95, NULL, NULL, 50699),
(50700, '3.80.10.10-FF-002941', NULL, 'Uncharacterized protein', 71, NULL, NULL, 50700),
(50701, '1.20.58.390-FF-000096', NULL, 'Ligand-Gated ion Channel', 143, NULL, NULL, 50701),
(50702, '3.40.50.720-FF-002168', NULL, 'Predicted protein', 73, NULL, NULL, 50702),
(50703, '4.10.1060.10-FF-000049', NULL, 'Zn-finger in Ran binding protein and others, putative', 38, NULL, NULL, 50703),
(50704, '3.30.70.330-FF-001484', NULL, 'DAZ-associated protein 1', 73, NULL, NULL, 50704),
(50705, '1.20.1560.10-FF-000762', NULL, 'Multidrug resistance-associated protein, putative', 324, NULL, NULL, 50705),
(50706, '3.20.20.60-FF-000126', NULL, 'Uncharacterized protein', 97, NULL, NULL, 50706),
(50707, '3.30.310.130-FF-000006', NULL, 'Probable ubiquitin-like-specific protease 2B', 132, NULL, NULL, 50707),
(50708, '2.130.10.10-FF-005206', NULL, 'WD40-repeat protein', 95, NULL, NULL, 50708),
(50709, '3.90.190.10-FF-000587', NULL, 'Predicted protein', 88, NULL, NULL, 50709),
(50710, '1.10.10.350-FF-000040', NULL, NULL, 112, NULL, NULL, 50710);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(50711, '2.90.10.10-FF-000043', NULL, 'Uncharacterized protein', 79, NULL, NULL, 50711),
(50712, '1.10.510.10-FF-000998', NULL, 'Anchored-membrane serine/threonine-protein kinase pknF', 179, NULL, NULL, 50712),
(50713, '3.40.50.2300-FF-001461', NULL, NULL, 171, NULL, NULL, 50713),
(50714, '4.10.110.10-FF-000012', NULL, 'Epi-1', 47, NULL, NULL, 50714),
(50715, '3.30.450.20-FF-000377', NULL, 'Two-component response regulator', 128, NULL, NULL, 50715),
(50716, '2.130.10.10-FF-003817', NULL, 'Uncharacterized protein', 507, NULL, NULL, 50716),
(50717, '3.60.40.10-FF-000128', NULL, 'Serine/threonine phosphatase containing a PAS domain', 247, NULL, NULL, 50717),
(50718, '1.10.260.40-FF-000094', NULL, 'Transcriptional regulator, putative', 95, NULL, NULL, 50718),
(50719, '1.20.1250.20-FF-002169', NULL, 'Monocarboxylate transporter, putative', 179, NULL, NULL, 50719),
(50720, '1.10.510.10-FF-002706', NULL, NULL, 206, NULL, NULL, 50720),
(50721, '4.10.400.10-FF-000287', NULL, 'Low-density lipoprotein receptor-related protein', 48, NULL, NULL, 50721),
(50722, '3.40.50.300-FF-005768', NULL, 'Predicted protein', 108, NULL, NULL, 50722),
(50723, '2.60.120.10-FF-000363', NULL, 'Regulatory subunit of protein kinase a-like protein', 144, NULL, NULL, 50723),
(50724, '1.20.1250.20-FF-000573', NULL, 'Unplaced genomic scaffold supercont1.138, whole genome shotgun sequence', 202, NULL, NULL, 50724),
(50725, '1.50.40.10-FF-000234', NULL, 'Peroxisomal membrane protein, putative', 155, NULL, NULL, 50725),
(50726, '1.20.1160.20-FF-000009', NULL, 'Regulator of telomere elongation helicase 1', 85, NULL, NULL, 50726),
(50727, '1.20.1720.10-FF-000089', NULL, 'Bcr/CflA family efflux transporter', 379, NULL, NULL, 50727),
(50728, '3.30.40.10-FF-002001', NULL, 'RING-H2 finger protein ATL1I', 52, NULL, NULL, 50728),
(50729, '3.40.50.720-FF-000487', NULL, 'Pyrroline-5-carboxylate reductase', 189, NULL, NULL, 50729),
(50730, '3.40.50.460-FF-000038', NULL, 'ATP-dependent 6-phosphofructokinase 3', 44, NULL, NULL, 50730),
(50731, '1.10.630.10-FF-000153', NULL, 'Os05g0424300 protein', 488, NULL, NULL, 50731),
(50732, '1.10.8.10-FF-000076', NULL, 'Ubiquitin associated and SH3 domain containing A', 70, NULL, NULL, 50732),
(50733, '2.60.40.10-FF-001659', NULL, 'Terribly reduced optic lobes, isoform AY', 91, NULL, NULL, 50733),
(50734, '1.10.1760.20-FF-000018', NULL, NULL, 176, NULL, NULL, 50734),
(50735, '1.25.10.10-FF-001926', NULL, 'Uncharacterized protein', 150, NULL, NULL, 50735),
(50736, '3.40.50.150-FF-000535', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', 128, NULL, NULL, 50736),
(50737, '2.10.70.10-FF-000292', NULL, 'Uncharacterized protein', 53, NULL, NULL, 50737),
(50738, '3.40.50.450-FF-000035', NULL, 'Phosphofructokinase, muscle b', 61, NULL, NULL, 50738),
(50739, '3.40.630.10-FF-000301', NULL, 'Carboxypeptidase B2 (plasma)', 216, NULL, NULL, 50739),
(50740, '3.40.50.10380-FF-000022', NULL, 'Malic enzyme', 158, NULL, NULL, 50740),
(50741, '3.30.9.10-FF-000107', NULL, 'FAD dependent oxidoreductase superfamily', 168, NULL, NULL, 50741),
(50742, '2.10.25.10-FF-000277', NULL, 'Thrombospondin 4', 36, NULL, NULL, 50742),
(50743, '3.20.20.140-FF-000407', NULL, 'Predicted protein', 100, NULL, NULL, 50743),
(50744, '3.40.50.300-FF-001553', NULL, 'Snf2-related CBP activator', 61, NULL, NULL, 50744),
(50745, '3.30.200.20-FF-002314', NULL, 'Serine/threonine protein kinase, putative', 11, NULL, NULL, 50745),
(50746, '3.30.160.60-FF-005852', NULL, NULL, 68, NULL, NULL, 50746),
(50747, '2.60.120.620-FF-000020', NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', 207, NULL, NULL, 50747),
(50748, '1.10.510.10-FF-003639', NULL, NULL, 189, NULL, NULL, 50748),
(50749, '1.10.3860.10-FF-000023', NULL, 'Dicarboxylate/amino acid:cation symporter', 401, NULL, NULL, 50749),
(50750, '1.20.1070.10-FF-002068', NULL, 'Olfactory receptor family 10 subfamily D member 3 (putative)', 73, NULL, NULL, 50750),
(50751, '3.40.1110.10-FF-000183', NULL, 'Cation-transporter ATPase I CtpI', 184, NULL, NULL, 50751);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(50752, '3.30.559.30-FF-000025', NULL, 'Vibriobactin synthetase, amide synthase subunit VibH', 246, NULL, NULL, 50752),
(50753, '2.60.40.10-FF-002058', NULL, 'Sidekick, isoform B', 94, NULL, NULL, 50753),
(50754, '3.30.70.1230-FF-000029', NULL, 'Adenylate cyclase type 2', 195, NULL, NULL, 50754),
(50755, '3.20.20.70-FF-000394', NULL, 'Polyketide biosynthesis protein PksE', 333, NULL, NULL, 50755),
(50756, '1.10.645.10-FF-000001', NULL, 'NADH-quinone oxidoreductase subunit C/D', 386, NULL, NULL, 50756),
(50757, '2.60.40.10-FF-001985', NULL, 'Hemicentin 2', 80, NULL, NULL, 50757),
(50758, '1.20.5.340-FF-000042', NULL, 'NHS like 2', 81, NULL, NULL, 50758),
(50759, '2.60.40.10-FF-003839', NULL, NULL, 103, NULL, NULL, 50759),
(50760, '3.30.497.10-FF-000032', NULL, 'Putative non-inhibitory serpin-Z11', 99, NULL, NULL, 50760),
(50761, '2.120.10.80-FF-000270', NULL, 'Negative regulator of sporulation MDS3', 209, NULL, NULL, 50761),
(50762, '1.20.920.10-FF-000055', NULL, 'AAA family ATPase, putative', 146, NULL, NULL, 50762),
(50763, '3.30.420.10-FF-000344', NULL, 'CAF1 family ribonuclease, putative', 181, NULL, NULL, 50763),
(50764, '2.60.40.10-FF-001715', NULL, 'Sidekick, isoform B', 104, NULL, NULL, 50764),
(50765, '3.30.420.10-FF-000546', NULL, NULL, 72, NULL, NULL, 50765),
(50766, '1.25.40.10-FF-003671', NULL, 'Uncharacterized protein', 149, NULL, NULL, 50766),
(50767, '1.20.1270.50-FF-000004', NULL, 'alpha-mannosidase 2C1 isoform X1', 97, NULL, NULL, 50767),
(50768, '1.20.120.140-FF-000037', NULL, 'P-loop containing nucleoside triphosphate hydrolases superfamily protein', 83, NULL, NULL, 50768),
(50769, '2.130.10.10-FF-005532', NULL, 'Uncharacterized protein', 278, NULL, NULL, 50769),
(50770, '3.40.50.150-FF-000209', NULL, 'rRNA adenine N(6)-methyltransferase', 245, NULL, NULL, 50770),
(50771, '3.20.20.80-FF-000397', NULL, 'Amino acid Transporter GlycoProtein subunit', 344, NULL, NULL, 50771),
(50772, '2.70.150.10-FF-000222', NULL, 'Sodium/potassium-transporting ATPase subunit alpha', 65, NULL, NULL, 50772),
(50773, '1.10.167.10-FF-000053', NULL, 'Predicted protein', 79, NULL, NULL, 50773),
(50774, '2.130.10.10-FF-005908', NULL, 'Uncharacterized protein', 281, NULL, NULL, 50774),
(50775, '1.20.210.10-FF-000023', NULL, 'Cox-type terminal oxidase subunit I', 518, NULL, NULL, 50775),
(50776, '1.10.8.10-FF-000278', NULL, 'Uncharacterized protein', 41, NULL, NULL, 50776),
(50777, '2.20.25.10-FF-000136', NULL, 'Peptide-N(4)-(N-acetyl-beta-glucosaminyl)asparagine amidase', 51, NULL, NULL, 50777),
(50778, '3.40.630.30-FF-000307', NULL, 'Probable serine/threonine-protein kinase DDB_G0279719', 207, NULL, NULL, 50778),
(50779, '3.30.470.10-FF-000055', NULL, 'Branched-chain-amino-acid aminotransferase', 75, NULL, NULL, 50779),
(50780, '2.60.120.200-FF-000776', NULL, 'Beta-porphyranase B', 277, NULL, NULL, 50780),
(50781, '2.10.25.10-FF-000923', NULL, 'GM14656', 62, NULL, NULL, 50781),
(50782, '2.60.40.10-FF-005880', NULL, NULL, 107, NULL, NULL, 50782),
(50783, '1.50.10.10-FF-000053', NULL, 'Putative glycosyl hydrolase', 403, NULL, NULL, 50783),
(50784, '1.20.120.1920-FF-000005', NULL, 'Ubiquitin associated protein 1', 46, NULL, NULL, 50784),
(50785, '2.40.170.20-FF-000121', NULL, 'SusC homolog', 477, NULL, NULL, 50785),
(50786, '1.10.472.10-FF-000043', NULL, 'Transcription initiation factor IIB', 104, NULL, NULL, 50786),
(50787, '1.10.287.110-FF-000305', NULL, 'Putative chaperone protein DNAj', 110, NULL, NULL, 50787),
(50788, '3.40.50.620-FF-000873', NULL, 'Valine--tRNA ligase, mitochondrial', 129, NULL, NULL, 50788),
(50789, '2.30.30.40-FF-000432', NULL, 'BAR domaincontaining protein', 58, NULL, NULL, 50789),
(50790, '2.40.10.120-FF-000011', NULL, 'Genome polyprotein', 61, NULL, NULL, 50790),
(50791, '3.40.50.1000-FF-000542', NULL, NULL, 56, NULL, NULL, 50791),
(50792, '3.80.10.10-FF-002587', NULL, 'leucine-rich repeat neuronal protein 1-like', 98, NULL, NULL, 50792),
(50793, '4.10.280.10-FF-000198', NULL, 'Polyadenylate-binding protein', 71, NULL, NULL, 50793),
(50794, '1.10.630.10-FF-000529', NULL, 'Cytochrome P450, putative', 383, NULL, NULL, 50794);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(50795, '1.10.287.1240-FF-000005', NULL, 'Exodeoxyribonuclease I', 58, NULL, NULL, 50795),
(50796, '1.20.120.1910-FF-000002', NULL, 'Cysteine--tRNA ligase', 161, NULL, NULL, 50796),
(50797, '1.20.58.150-FF-000018', NULL, NULL, 156, NULL, NULL, 50797),
(50798, '1.25.10.10-FF-002859', NULL, 'Uncharacterized protein', 166, NULL, NULL, 50798),
(50799, '3.40.710.10-FF-000072', NULL, 'Alanine rich lipoprotein LppW', 239, NULL, NULL, 50799),
(50800, '3.40.50.10810-FF-000140', NULL, 'DNA repair and recombination protein Rhp26p', 288, NULL, NULL, 50800),
(50801, '6.10.250.3260-FF-000003', NULL, '60S ribosomal protein L21', 68, NULL, NULL, 50801),
(50802, '2.60.40.10-FF-005554', NULL, NULL, 114, NULL, NULL, 50802),
(50803, '3.90.228.10-FF-000018', NULL, 'Putative zinc finger protein', 262, NULL, NULL, 50803),
(50804, '1.10.10.10-FF-000026', NULL, 'HTH-type transcriptional regulator IscR', 144, NULL, NULL, 50804),
(50805, '1.25.40.20-FF-001583', NULL, 'Ankyrin repeat family protein', 139, NULL, NULL, 50805),
(50806, '3.30.160.60-FF-001783', NULL, 'Zinc finger protein 142', 68, NULL, NULL, 50806),
(50807, '3.40.50.10190-FF-000353', NULL, 'Uncharacterized protein', 158, NULL, NULL, 50807),
(50808, '3.40.50.1980-FF-000133', NULL, 'ABC-type transport system periplasmic substrate-binding protein', 142, NULL, NULL, 50808),
(50809, '3.30.160.60-FF-002923', NULL, 'Asparagine-rich zinc-finger protein', 61, NULL, NULL, 50809),
(50810, '2.10.90.10-FF-000085', NULL, 'Uncharacterized protein', 173, NULL, NULL, 50810),
(50811, '2.130.10.10-FF-001963', NULL, 'WD repeat domain phosphoinositide-interacting protein', 271, NULL, NULL, 50811),
(50812, '1.25.40.10-FF-001580', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 203, NULL, NULL, 50812),
(50813, '2.80.10.50-FF-000145', NULL, 'Lymphocyte antigen 75', 125, NULL, NULL, 50813),
(50814, '3.50.50.60-FF-000588', NULL, 'Pyridine nucleotide-disulphide oxidoreductase, putative', 96, NULL, NULL, 50814),
(50815, '3.60.21.10-FF-000062', NULL, 'Tartrate-resistant acid phosphatase type 5', 306, NULL, NULL, 50815),
(50816, '1.10.510.10-FF-002330', NULL, NULL, 206, NULL, NULL, 50816),
(50817, '3.40.50.720-FF-001920', NULL, 'Short-chain dehydrogenase/reductase SDR', 182, NULL, NULL, 50817),
(50818, '1.10.12.10-FF-000008', NULL, 'Chromodomain Y like 2', 57, NULL, NULL, 50818),
(50819, '1.20.140.40-FF-000032', NULL, 'Pectinesterase inhibitor', 150, NULL, NULL, 50819),
(50820, '4.10.1000.10-FF-000074', NULL, 'GM22131', 56, NULL, NULL, 50820),
(50821, '2.60.40.340-FF-000016', NULL, NULL, 89, NULL, NULL, 50821),
(50822, '3.40.50.300-FF-002216', NULL, 'ATP-dependent Clp protease', 308, NULL, NULL, 50822),
(50823, '1.10.10.10-FF-001605', NULL, 'Uncharacterized protein', 113, NULL, NULL, 50823),
(50824, '3.30.70.330-FF-001719', NULL, NULL, 104, NULL, NULL, 50824),
(50825, '1.25.40.10-FF-003406', NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', 124, NULL, NULL, 50825),
(50826, '1.20.120.350-FF-000038', NULL, 'Sodium leak channel non-selective protein', 128, NULL, NULL, 50826),
(50827, '3.80.10.10-FF-003048', NULL, 'AGAP009086-PA', 155, NULL, NULL, 50827),
(50828, '3.40.33.10-FF-000152', NULL, 'Uncharacterized protein', 135, NULL, NULL, 50828),
(50829, '2.30.30.140-FF-000079', NULL, 'Enhancer of polycomb-like transcription factor protein', 51, NULL, NULL, 50829),
(50830, '2.60.40.150-FF-000201', NULL, 'Phosphoinositide phospholipase C', 187, NULL, NULL, 50830),
(50831, '3.80.10.10-FF-003104', NULL, 'Uncharacterized protein', 107, NULL, NULL, 50831),
(50832, '1.10.150.510-FF-000016', NULL, 'Uncharacterized protein', 57, NULL, NULL, 50832),
(50833, '3.30.40.10-FF-001219', NULL, 'Structure-specific endonuclease subunit SLX1', 81, NULL, NULL, 50833),
(50834, '3.40.50.300-FF-008202', NULL, 'Uncharacterized protein', 74, NULL, NULL, 50834),
(50835, '3.30.420.40-FF-000122', NULL, 'ARP5 actin-related protein 5 homolog', 153, NULL, NULL, 50835),
(50836, '3.40.640.10-FF-000217', NULL, 'Cysteine desulfurase', 257, NULL, NULL, 50836),
(50837, '1.20.5.190-FF-000031', NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', 53, NULL, NULL, 50837);
INSERT INTO "PUBLIC"."MODEL" VALUES
(50838, '1.25.40.10-FF-003176', NULL, 'Pentatricopeptide repeat-containing protein', 106, NULL, NULL, 50838),
(50839, '1.20.930.10-FF-000027', NULL, 'Transcription elongation factor TFIIS', 101, NULL, NULL, 50839),
(50840, '2.40.50.140-FF-001115', NULL, NULL, 63, NULL, NULL, 50840),
(50841, '3.90.1750.10-FF-000040', NULL, 'E3 ubiquitin-protein ligase', 145, NULL, NULL, 50841),
(50842, '2.60.40.60-FF-000139', NULL, 'Cadherin-2 preproprotein', 89, NULL, NULL, 50842),
(50843, '3.40.720.10-FF-000218', NULL, 'N-acetylgalactosamine 6-sulfatase (GALNS)', 373, NULL, NULL, 50843),
(50844, '1.10.533.10-FF-000152', NULL, 'Caspase-8', 92, NULL, NULL, 50844),
(50845, '4.10.410.10-FF-000052', NULL, 'CBN-PPN-1 protein', 61, NULL, NULL, 50845),
(50846, '1.20.1270.60-FF-000333', NULL, 'Uncharacterized protein', 201, NULL, NULL, 50846),
(50847, '3.40.50.300-FF-007713', NULL, 'ATP-dependent DNA helicase', 97, NULL, NULL, 50847),
(50848, '3.80.10.10-FF-003043', NULL, 'Uncharacterized protein', 158, NULL, NULL, 50848),
(50849, '3.40.630.70-FF-000010', NULL, NULL, 118, NULL, NULL, 50849),
(50850, '3.20.20.140-FF-000087', NULL, 'TatD-like deoxyribonuclease, putative', 345, NULL, NULL, 50850),
(50851, '2.130.10.10-FF-004604', NULL, 'Uncharacterized protein', 203, NULL, NULL, 50851),
(50852, '2.130.10.10-FF-001373', NULL, 'F-box protein MET30', 127, NULL, NULL, 50852),
(50853, '1.20.58.60-FF-000297', NULL, 'Spectrin beta chain', 213, NULL, NULL, 50853),
(50854, '3.90.1410.10-FF-000082', NULL, 'Uncharacterized protein', 275, NULL, NULL, 50854),
(50855, '3.30.930.10-FF-000158', NULL, 'Glycyl-tRNA synthetase', 85, NULL, NULL, 50855),
(50856, '1.20.5.170-FF-000019', NULL, 'BZIP family transcription factor', 50, NULL, NULL, 50856),
(50857, '1.20.58.390-FF-000124', NULL, 'Protein CBG26995', 133, NULL, NULL, 50857),
(50858, '2.40.10.10-FF-000242', NULL, 'chymotrypsinogen A-like', 235, NULL, NULL, 50858),
(50859, '1.25.40.10-FF-005267', NULL, 'Uncharacterized protein', 153, NULL, NULL, 50859),
(50860, '3.40.1110.10-FF-000357', NULL, NULL, 154, NULL, NULL, 50860),
(50861, '3.30.505.10-FF-000193', NULL, NULL, 106, NULL, NULL, 50861),
(50862, '3.40.430.10-FF-000027', NULL, 'Riboflavin biosynthesis protein RibD', 224, NULL, NULL, 50862),
(50863, '3.40.1110.10-FF-000385', NULL, NULL, 136, NULL, NULL, 50863),
(50864, '1.10.510.10-FF-001987', NULL, 'MAP kinase-interacting serine/threonine-protein kinase 1', 212, NULL, NULL, 50864),
(50865, '2.10.220.10-FF-000062', NULL, 'Extracellular matrix protein FRAS1', 76, NULL, NULL, 50865),
(50866, '2.40.30.10-FF-000125', NULL, 'Ferric reduction oxidase 7', 103, NULL, NULL, 50866),
(50867, '1.10.630.10-FF-000681', NULL, 'Uncharacterized protein', 158, NULL, NULL, 50867),
(50868, '1.25.40.10-FF-002687', NULL, 'Uncharacterized protein', 150, NULL, NULL, 50868),
(50869, '1.10.540.10-FF-000117', NULL, 'Acyl-coenzyme A oxidase', 119, NULL, NULL, 50869),
(50870, '3.40.50.300-FF-003677', NULL, 'Cell death protein 4', 205, NULL, NULL, 50870),
(50871, '3.30.60.90-FF-000036', NULL, 'Putative N6-adenosine-methyltransferase with ZZ-type zinc-binding domains', 56, NULL, NULL, 50871),
(50872, '3.50.50.60-FF-001521', NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', 219, NULL, NULL, 50872),
(50873, '3.30.63.20-FF-000005', NULL, 'Uncharacterized protein', 91, NULL, NULL, 50873),
(50874, '3.40.50.1820-FF-001327', NULL, 'Uncharacterized protein', 257, NULL, NULL, 50874),
(50875, '3.30.160.60-FF-005526', NULL, NULL, 76, NULL, NULL, 50875),
(50876, '1.10.510.10-FF-001841', NULL, 'Protein kinase, putative', 133, NULL, NULL, 50876),
(50877, '3.30.9.10-FF-000170', NULL, 'Uncharacterized protein', 173, NULL, NULL, 50877),
(50878, '2.60.40.150-FF-000257', NULL, 'Uncharacterized protein, isoform B', 143, NULL, NULL, 50878),
(50879, '1.10.150.50-FF-000178', NULL, 'Mitogen-activated protein kinase kinase kinase 15', 72, NULL, NULL, 50879),
(50880, '3.30.63.10-FF-000002', NULL, 'Guanylate kinase 1', 60, NULL, NULL, 50880),
(50881, '1.20.120.1080-FF-000124', NULL, 'DEAH-box helicase 16', 56, NULL, NULL, 50881);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(50882, '3.40.50.1000-FF-000216', NULL, 'Phosphomannomutase', 144, NULL, NULL, 50882),
(50883, '2.30.29.30-FF-001314', NULL, 'Phosphoinositide phospholipase C', 73, NULL, NULL, 50883),
(50884, '3.40.50.1010-FF-000219', NULL, NULL, 123, NULL, NULL, 50884),
(50885, '2.60.120.970-FF-000074', NULL, 'Uncharacterized protein', 248, NULL, NULL, 50885),
(50886, '3.80.10.10-FF-002059', NULL, 'Leucine-rich repeat receptor protein kinase MSP1', 284, NULL, NULL, 50886),
(50887, '2.60.300.12-FF-000031', NULL, NULL, 83, NULL, NULL, 50887),
(50888, '1.20.1110.10-FF-000065', NULL, 'Sarcoplasmic/endoplasmic reticulum calcium ATPase 1', 412, NULL, NULL, 50888),
(50889, '3.10.105.10-FF-000009', NULL, 'ABC transporter substrate-binding protein', 243, NULL, NULL, 50889),
(50890, '2.30.30.90-FF-000014', NULL, 'Diphtheria toxin repressor', 77, NULL, NULL, 50890),
(50891, '3.80.10.10-FF-002738', NULL, 'Predicted protein', 69, NULL, NULL, 50891),
(50892, '3.40.605.10-FF-000142', NULL, 'Uncharacterized protein', 72, NULL, NULL, 50892),
(50893, '2.40.50.150-FF-000011', NULL, 'DNA-directed RNA polymerase subunit beta', 60, NULL, NULL, 50893),
(50894, '1.25.40.180-FF-000198', NULL, NULL, 154, NULL, NULL, 50894),
(50895, '3.40.50.300-FF-001497', NULL, 'SNF2 family DNA-dependent ATPase', 202, NULL, NULL, 50895),
(50896, '1.10.510.10-FF-003932', NULL, NULL, 69, NULL, NULL, 50896),
(50897, '4.10.400.10-FF-000085', NULL, 'low-density lipoprotein receptor-related protein 4', 40, NULL, NULL, 50897),
(50898, '2.60.120.260-FF-000041', NULL, 'Reelin', 157, NULL, NULL, 50898),
(50899, '3.30.160.60-FF-005796', NULL, NULL, 24, NULL, NULL, 50899),
(50900, '1.10.510.10-FF-004421', NULL, NULL, 67, NULL, NULL, 50900),
(50901, '1.10.1000.11-FF-000015', NULL, 'GTP exchange factor for ARFs 1', 114, NULL, NULL, 50901),
(50902, '3.30.70.330-FF-001629', NULL, 'Nucleolar protein 6', 148, NULL, NULL, 50902),
(50903, '1.10.287.70-FF-000552', NULL, 'Uncharacterized protein', 144, NULL, NULL, 50903),
(50904, '3.40.50.10190-FF-000263', NULL, 'Predicted protein', 68, NULL, NULL, 50904),
(50905, '1.10.287.70-FF-000496', NULL, 'Predicted protein', 243, NULL, NULL, 50905),
(50906, '1.20.1560.10-FF-000554', NULL, 'Haemolysin secretion ATP-binding protein', 315, NULL, NULL, 50906),
(50907, '1.10.540.10-FF-000090', NULL, 'GM20419', 94, NULL, NULL, 50907),
(50908, '2.130.10.130-FF-000054', NULL, NULL, 137, NULL, NULL, 50908),
(50909, '3.40.250.10-FF-000194', NULL, 'Adenylyltransferase and sulfurtransferase MOCS3', 119, NULL, NULL, 50909),
(50910, '1.10.510.10-FF-000352', NULL, 'SCY1-like pseudokinase 2', 192, NULL, NULL, 50910),
(50911, '3.40.1380.20-FF-000025', NULL, 'Pyruvate kinase', 98, NULL, NULL, 50911),
(50912, '1.10.8.10-FF-000306', NULL, 'Release factor glutamine methyltransferase', 85, NULL, NULL, 50912),
(50913, '3.80.10.10-FF-001250', NULL, 'RE09158p', 181, NULL, NULL, 50913),
(50914, '3.40.50.620-FF-000457', NULL, 'Predicted protein', 57, NULL, NULL, 50914),
(50915, '3.30.30.30-FF-000005', NULL, 'Heat shock protein ssb1', 55, NULL, NULL, 50915),
(50916, '3.40.50.300-FF-008056', NULL, 'Uncharacterized protein', 125, NULL, NULL, 50916),
(50917, '2.30.30.40-FF-000342', NULL, 'Bzz1p', 69, NULL, NULL, 50917),
(50918, '3.40.1380.10-FF-000022', NULL, 'ATP synthase gamma chain', 217, NULL, NULL, 50918),
(50919, '3.30.160.60-FF-003289', NULL, NULL, 39, NULL, NULL, 50919),
(50920, '3.30.200.20-FF-001590', NULL, NULL, 108, NULL, NULL, 50920),
(50921, '2.130.10.10-FF-004689', NULL, 'Gll0893 protein', 332, NULL, NULL, 50921),
(50922, '2.60.120.200-FF-000574', NULL, 'ALK tyrosine kinase receptor homolog scd-2', 227, NULL, NULL, 50922),
(50923, '3.60.10.10-FF-000396', NULL, 'Type I inositol polyphosphate 5-phosphatase 2', 60, NULL, NULL, 50923),
(50924, '2.10.220.10-FF-000067', NULL, 'Proprotein convertase subtilisin/kexin type 5', 46, NULL, NULL, 50924),
(50925, '3.40.50.300-FF-007983', NULL, 'Predicted protein', 157, NULL, NULL, 50925),
(50926, '3.30.160.60-FF-000506', NULL, 'Zinc finger protein 23', 28, NULL, NULL, 50926),
(50927, '2.20.25.10-FF-000046', NULL, 'UPF0434 protein Rv1684', 60, NULL, NULL, 50927);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(50928, '3.90.25.10-FF-000086', NULL, 'Uncharacterized protein', 73, NULL, NULL, 50928),
(50929, '3.10.20.90-FF-000574', NULL, 'Autophagy-related protein', 127, NULL, NULL, 50929),
(50930, '2.60.40.10-FF-004003', NULL, NULL, 126, NULL, NULL, 50930),
(50931, '1.20.120.1220-FF-000008', NULL, 'Type IV peptidase', 149, NULL, NULL, 50931),
(50932, '1.25.40.10-FF-002102', NULL, 'Pentatricopeptide repeat-containing protein103', 152, NULL, NULL, 50932),
(50933, '3.40.50.300-FF-007836', NULL, 'Predicted protein', 236, NULL, NULL, 50933),
(50934, '1.20.120.350-FF-000128', NULL, 'Uncharacterized protein', 122, NULL, NULL, 50934),
(50935, '1.10.510.10-FF-000060', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', 204, NULL, NULL, 50935),
(50936, '2.130.10.10-FF-005678', NULL, 'Uncharacterized protein', 161, NULL, NULL, 50936),
(50937, '2.80.10.50-FF-000055', NULL, 'Fascin', 125, NULL, NULL, 50937),
(50938, '3.40.980.10-FF-000001', NULL, 'Molybdopterin molybdenumtransferase', 151, NULL, NULL, 50938),
(50939, '3.10.110.10-FF-000111', NULL, 'Serine/threonine protein kinase', 159, NULL, NULL, 50939),
(50940, '1.10.510.10-FF-001982', NULL, 'Cyclin-dependent protein kinase-activating kinase', 222, NULL, NULL, 50940),
(50941, '1.20.1070.10-FF-001814', NULL, 'Uncharacterized protein', 311, NULL, NULL, 50941),
(50942, '3.80.10.10-FF-001103', NULL, 'Putative internalin', 278, NULL, NULL, 50942),
(50943, '3.40.630.30-FF-000077', NULL, 'Histone acetyltransferase type B catalytic subunit', 131, NULL, NULL, 50943),
(50944, '3.60.15.10-FF-000002', NULL, 'Ribonuclease Z', 304, NULL, NULL, 50944),
(50945, '2.10.25.10-FF-000507', NULL, 'Crumbs, isoform C', 38, NULL, NULL, 50945),
(50946, '1.10.472.140-FF-000012', NULL, 'Retinoblastoma-like protein 1', 153, NULL, NULL, 50946),
(50947, '3.40.50.1110-FF-000103', NULL, 'Uncharacterized protein', 205, NULL, NULL, 50947),
(50948, '1.20.58.390-FF-000326', NULL, 'Uncharacterized protein', 53, NULL, NULL, 50948),
(50949, '3.10.20.90-FF-000046', NULL, 'Homocysteine-responsive endoplasmic reticulum-resident ubiquitin-like domain member 2 protein', 77, NULL, NULL, 50949),
(50950, '2.130.10.10-FF-005588', NULL, 'Uncharacterized protein', 201, NULL, NULL, 50950),
(50951, '2.60.40.1970-FF-000008', NULL, 'Transcription initiation factor TFIID subunit 14', 154, NULL, NULL, 50951),
(50952, '1.20.58.390-FF-000034', NULL, 'Cholinergic receptor nicotinic beta 4 subunit', 76, NULL, NULL, 50952),
(50953, '3.30.460.10-FF-000144', NULL, 'Ribosomal silencing factor RsfS', 108, NULL, NULL, 50953),
(50954, '3.30.40.10-FF-001512', NULL, 'At1g74990', 112, NULL, NULL, 50954),
(50955, '1.10.630.10-FF-000653', NULL, 'Uncharacterized protein', 200, NULL, NULL, 50955),
(50956, '3.10.490.10-FF-000015', NULL, 'Gamma-glutamylcyclotransferase', 165, NULL, NULL, 50956),
(50957, '3.40.50.11380-FF-000018', NULL, NULL, 85, NULL, NULL, 50957),
(50958, '1.20.58.60-FF-000499', NULL, 'Protein CBR-SMA-1', 213, NULL, NULL, 50958),
(50959, '3.30.1950.10-FF-000001', NULL, 'Sugar ABC transporter substrate-binding protein', 54, NULL, NULL, 50959),
(50960, '3.80.10.10-FF-002733', NULL, 'Predicted protein', 119, NULL, NULL, 50960),
(50961, '1.10.510.10-FF-004331', NULL, NULL, 135, NULL, NULL, 50961),
(50962, '3.30.9.10-FF-000080', NULL, 'FAD-binding oxidoreductase', 151, NULL, NULL, 50962),
(50963, '2.60.40.10-FF-002148', NULL, 'DS cell adhesion molecule', 75, NULL, NULL, 50963),
(50964, '2.40.240.10-FF-000056', NULL, '50S ribosomal protein L25', 101, NULL, NULL, 50964),
(50965, '3.40.50.10330-FF-000119', NULL, 'Uncharacterized protein', 91, NULL, NULL, 50965),
(50966, '2.70.170.10-FF-000083', NULL, 'AcetylCholine Receptor', 250, NULL, NULL, 50966),
(50967, '3.10.20.70-FF-000040', NULL, 'Glutamine synthetase catalytic region', 104, NULL, NULL, 50967),
(50968, '3.40.50.1820-FF-001125', NULL, 'Oligopeptidase B protein, putative', 337, NULL, NULL, 50968),
(50969, '2.30.39.10-FF-000084', NULL, 'Serine protease inhibitor (serpin) 14', 162, NULL, NULL, 50969),
(50970, '1.20.1270.170-FF-000002', NULL, 'Stress response kinase A', 98, NULL, NULL, 50970);
INSERT INTO "PUBLIC"."MODEL" VALUES
(50971, '2.10.25.10-FF-000777', NULL, 'neurogenic locus notch homolog protein 3', 40, NULL, NULL, 50971),
(50972, '3.40.50.1010-FF-000281', NULL, NULL, 48, NULL, NULL, 50972),
(50973, '3.40.50.1100-FF-000100', NULL, '1-aminocyclopropane-1-carboxylate deaminase, putative', 250, NULL, NULL, 50973),
(50974, '3.10.450.50-FF-000002', NULL, 'Ras GTPase-activating protein-binding protein 2 isoform 1', 139, NULL, NULL, 50974),
(50975, '1.10.357.90-FF-000007', NULL, 'Telomerase reverse transcriptase', 189, NULL, NULL, 50975),
(50976, '3.40.50.300-FF-004133', NULL, 'ATP-dependent DNA helicase RecQ', 202, NULL, NULL, 50976),
(50977, '3.10.490.20-FF-000018', NULL, 'Dynein heavy chain 5, axonemal', 143, NULL, NULL, 50977),
(50978, '3.40.630.10-FF-000071', NULL, 'Peptidase M20 domain-containing protein 2', 226, NULL, NULL, 50978),
(50979, '1.10.285.10-FF-000007', NULL, 'NADP-specific glutamate dehydrogenase', 71, NULL, NULL, 50979),
(50980, '1.10.150.340-FF-000004', NULL, 'Endoplasmin like', 63, NULL, NULL, 50980),
(50981, '3.40.50.720-FF-002376', NULL, 'Zinc-type alcohol dehydrogenase-like protein C16A3.02c', 171, NULL, NULL, 50981),
(50982, '2.40.50.150-FF-000016', NULL, 'DNA-directed RNA polymerase subunit beta', 124, NULL, NULL, 50982),
(50983, '3.30.420.510-FF-000004', NULL, 'Fbl, isoform B', 161, NULL, NULL, 50983),
(50984, '3.40.50.720-FF-000807', NULL, '3-keto-dihydrosphingosine reductase', 279, NULL, NULL, 50984),
(50985, '1.25.40.20-FF-000127', NULL, 'Nuclear factor NF-kappa-B p100 subunit isoform b', 272, NULL, NULL, 50985),
(50986, '2.170.260.10-FF-000015', NULL, 'Dicer-like 4', 111, NULL, NULL, 50986),
(50987, '2.130.10.10-FF-005706', NULL, 'Transducin family protein / WD-40 repeat family protein', 147, NULL, NULL, 50987),
(50988, '2.40.100.10-FF-000080', NULL, 'Peptidyl-prolyl cis-trans isomerase', 90, NULL, NULL, 50988),
(50989, '3.40.720.10-FF-000246', NULL, 'Sulfatase', 210, NULL, NULL, 50989),
(50990, '3.40.630.30-FF-000279', NULL, 'PHD zinc finger protein', 108, NULL, NULL, 50990),
(50991, '3.30.160.20-FF-000158', NULL, 'Predicted protein', 80, NULL, NULL, 50991),
(50992, '2.40.40.20-FF-000073', NULL, 'cDNA FLJ54381, highly similar to Vesicle-fusing ATPase', 53, NULL, NULL, 50992),
(50993, '2.30.180.10-FF-000137', NULL, NULL, 150, NULL, NULL, 50993),
(50994, '1.25.40.10-FF-000124', NULL, 'Prolyl 3-hydroxylase 1', 100, NULL, NULL, 50994),
(50995, '3.10.50.40-FF-000027', NULL, 'Peptidylprolyl isomerase', 149, NULL, NULL, 50995),
(50996, '1.20.58.1100-FF-000015', NULL, 'Uncharacterized protein', 139, NULL, NULL, 50996),
(50997, '1.10.472.10-FF-000015', NULL, 'Putative cyclin-c', 132, NULL, NULL, 50997),
(50998, '1.20.1640.10-FF-000032', NULL, 'MMPL family transporter', 218, NULL, NULL, 50998),
(50999, '3.30.200.20-FF-001527', NULL, 'Leucine Rich Repeat family protein, expressed', 91, NULL, NULL, 50999),
(51000, '3.40.1370.10-FF-000050', NULL, 'Uncharacterized protein', 67, NULL, NULL, 51000),
(51001, '3.40.50.720-FF-000459', NULL, 'Dehydrogenase/reductase SDR family member 1', 259, NULL, NULL, 51001),
(51002, '1.10.506.10-FF-000038', NULL, 'Bud2p', 218, NULL, NULL, 51002),
(51003, '1.25.10.10-FF-003348', NULL, 'Uncharacterized protein', 219, NULL, NULL, 51003),
(51004, '3.90.740.10-FF-000051', NULL, 'Leucine--tRNA ligase', 236, NULL, NULL, 51004),
(51005, '3.40.50.1820-FF-001417', NULL, 'Protein CBG10455', 201, NULL, NULL, 51005),
(51006, '3.10.20.90-FF-000248', NULL, 'Plexin A, isoform B', 141, NULL, NULL, 51006),
(51007, '1.10.357.70-FF-000001', NULL, 'Exocyst complex component 3', 177, NULL, NULL, 51007),
(51008, '1.10.238.10-FF-000426', NULL, 'Centrin-4', 82, NULL, NULL, 51008),
(51009, '3.40.30.10-FF-000089', NULL, 'Glutathione S-transferase', 83, NULL, NULL, 51009),
(51010, '3.40.50.300-FF-000423', NULL, 'ABC transporter ATP-binding protein YbbA', 227, NULL, NULL, 51010),
(51011, '1.25.10.10-FF-000622', NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit', 405, NULL, NULL, 51011),
(51012, '2.30.29.30-FF-001196', NULL, 'Uncharacterized protein', 70, NULL, NULL, 51012);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(51013, '1.10.238.10-FF-000336', NULL, 'HLH domain-containing protein', 79, NULL, NULL, 51013),
(51014, '3.20.20.190-FF-000113', NULL, NULL, 90, NULL, NULL, 51014),
(51015, '3.80.10.10-FF-000940', NULL, 'Disease resistance RPP8-like protein 3', 350, NULL, NULL, 51015),
(51016, '1.25.40.10-FF-001754', NULL, 'Toll-Interleukin receptor', 182, NULL, NULL, 51016),
(51017, '3.20.20.140-FF-000379', NULL, 'Uncharacterized protein', 199, NULL, NULL, 51017),
(51018, '3.30.450.200-FF-000013', NULL, 'DENN domain-containing protein 1A', 44, NULL, NULL, 51018),
(51019, '3.40.50.620-FF-000547', NULL, 'Electron transfer flavoprotein subunit beta', 269, NULL, NULL, 51019),
(51020, '3.30.70.3000-FF-000004', NULL, 'tRNA(His) guanylyltransferase', 285, NULL, NULL, 51020),
(51021, '1.20.120.1080-FF-000129', NULL, 'Kurz protein, putative', 100, NULL, NULL, 51021),
(51022, '3.30.160.60-FF-001491', NULL, 'Cross-pathway control protein A', 62, NULL, NULL, 51022),
(51023, '1.10.155.10-FF-000003', NULL, 'Chemotaxis protein methyltransferase', 75, NULL, NULL, 51023),
(51024, '3.30.70.330-FF-001545', NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', 96, NULL, NULL, 51024),
(51025, '1.10.720.30-FF-000019', NULL, 'Uncharacterized protein', 44, NULL, NULL, 51025),
(51026, '3.90.70.10-FF-000336', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 382, NULL, NULL, 51026),
(51027, '3.30.160.60-FF-003379', NULL, NULL, 28, NULL, NULL, 51027),
(51028, '3.40.1010.10-FF-000001', NULL, 'Siroheme synthase', 118, NULL, NULL, 51028),
(51029, '1.10.510.10-FF-000262', NULL, 'Serine/threonine-protein kinase Nek8', 197, NULL, NULL, 51029),
(51030, '1.10.20.10-FF-000122', NULL, 'CCAAT-HAP5 transcription factor', 131, NULL, NULL, 51030),
(51031, '2.60.40.10-FF-001569', NULL, 'Sallimus, isoform P', 89, NULL, NULL, 51031),
(51032, '3.20.20.20-FF-000019', NULL, '5-methyltetrahydrofolate:corrinoid/iron-sulfur protein co-methyltransferase', 262, NULL, NULL, 51032),
(51033, '2.10.25.10-FF-000272', NULL, 'neurogenic locus notch homolog protein 3', 41, NULL, NULL, 51033),
(51034, '3.40.140.10-FF-000073', NULL, 'COP9 signalosome complex subunit 6a', 185, NULL, NULL, 51034),
(51035, '3.40.50.300-FF-003970', NULL, 'Glycosyl transferase family 1', 256, NULL, NULL, 51035),
(51036, '1.20.58.1250-FF-000009', NULL, 'Uncharacterized protein', 128, NULL, NULL, 51036),
(51037, '3.30.300.30-FF-000083', NULL, 'acyl-CoA synthetase family member 3, mitochondrial', 82, NULL, NULL, 51037),
(51038, '4.10.410.10-FF-000057', NULL, 'CRE-MEC-9 protein', 40, NULL, NULL, 51038),
(51039, '1.10.1420.10-FF-000057', NULL, 'Mismatch repair protein', 185, NULL, NULL, 51039),
(51040, '2.130.10.10-FF-003880', NULL, 'Predicted protein', 278, NULL, NULL, 51040),
(51041, '3.40.605.10-FF-000086', NULL, 'Succinate semialdehyde dehydrogenase', 164, NULL, NULL, 51041),
(51042, '2.40.100.10-FF-000170', NULL, 'Uncharacterized protein', 55, NULL, NULL, 51042),
(51043, '3.30.300.20-FF-000080', NULL, 'GTPase Era', 108, NULL, NULL, 51043),
(51044, '1.20.58.2010-FF-000013', NULL, 'Rop guanine nucleotide exchange factor 7', 89, NULL, NULL, 51044),
(51045, '1.10.3260.10-FF-000022', NULL, 'Protein CBR-LIG-4', 206, NULL, NULL, 51045),
(51046, '3.30.160.60-FF-004840', NULL, NULL, 64, NULL, NULL, 51046),
(51047, '3.10.250.10-FF-000144', NULL, NULL, 80, NULL, NULL, 51047),
(51048, '2.60.40.10-FF-003637', NULL, NULL, 86, NULL, NULL, 51048),
(51049, '2.60.40.1960-FF-000005', NULL, 'Uncharacterized protein', 17, NULL, NULL, 51049),
(51050, '4.10.400.10-FF-000141', NULL, 'Transmembrane serine protease 4', 35, NULL, NULL, 51050),
(51051, '3.40.50.800-FF-000067', NULL, 'Histidine--tRNA ligase', 96, NULL, NULL, 51051),
(51052, '3.10.450.60-FF-000005', NULL, 'Lipoxygenase', 135, NULL, NULL, 51052),
(51053, '3.30.9.90-FF-000002', NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase, mitochondrial', 195, NULL, NULL, 51053),
(51054, '3.40.50.10330-FF-000086', NULL, 'NAD kinase', 115, NULL, NULL, 51054),
(51055, '3.30.40.10-FF-000495', NULL, 'E3 ubiquitin-protein ligase ORTHRUS 2', 118, NULL, NULL, 51055); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(51056, '2.120.10.90-FF-000003', NULL, 'DNA topoisomerase 4 subunit A', 249, NULL, NULL, 51056),
(51057, '2.60.40.10-FF-000260', NULL, 'Muscle, skeletal receptor tyrosine protein kinase', 97, NULL, NULL, 51057),
(51058, '1.20.5.110-FF-000232', NULL, 'Syntaxin-17', 74, NULL, NULL, 51058),
(51059, '3.40.50.1100-FF-000280', NULL, 'Uncharacterized protein', 49, NULL, NULL, 51059),
(51060, '1.10.1450.10-FF-000003', NULL, 'Tetraspanin', 101, NULL, NULL, 51060),
(51061, '3.40.50.620-FF-000783', NULL, 'Predicted protein', 84, NULL, NULL, 51061),
(51062, '3.30.160.60-FF-004222', NULL, NULL, 34, NULL, NULL, 51062),
(51063, '2.40.10.10-FF-000040', NULL, 'Serine protease 23', 115, NULL, NULL, 51063),
(51064, '3.30.1490.180-FF-000036', NULL, 'Uncharacterized protein', 75, NULL, NULL, 51064),
(51065, '1.25.40.450-FF-000004', NULL, 'Nuclear pore complex protein Nup155', 176, NULL, NULL, 51065),
(51066, '1.10.510.10-FF-004275', NULL, NULL, 178, NULL, NULL, 51066),
(51067, '1.10.510.10-FF-004005', NULL, NULL, 156, NULL, NULL, 51067),
(51068, '2.10.25.10-FF-001143', NULL, 'Uncharacterized protein', 50, NULL, NULL, 51068),
(51069, '2.70.98.30-FF-000016', NULL, 'Alpha-mannosidase', 270, NULL, NULL, 51069),
(51070, '2.60.40.10-FF-004621', NULL, NULL, 50, NULL, NULL, 51070),
(51071, '3.40.1190.20-FF-000106', NULL, 'Bifunctional NAD(P)H-hydrate repair enzyme Nnr', 256, NULL, NULL, 51071),
(51072, '3.30.450.40-FF-000040', NULL, 'Formate hydrogenlyase transcriptional activator', 159, NULL, NULL, 51072),
(51073, '1.10.8.720-FF-000052', NULL, 'Uncharacterized protein', 210, NULL, NULL, 51073),
(51074, '3.50.30.20-FF-000007', NULL, 'Carbamoyl-phosphate synthase small chain', 147, NULL, NULL, 51074),
(51075, '3.30.1330.30-FF-000067', NULL, 'H/ACA ribonucleoprotein complex subunit 2 isoform X3', 56, NULL, NULL, 51075),
(51076, '3.30.750.24-FF-000022', NULL, 'Anti-sigma factor antagonist', 104, NULL, NULL, 51076),
(51077, '3.40.50.10490-FF-000055', NULL, 'Mitochondrial ribosomal protein', 213, NULL, NULL, 51077),
(51078, '2.10.25.10-FF-000833', NULL, 'Drosophila CRumBs homolog', 40, NULL, NULL, 51078),
(51079, '3.30.450.50-FF-000043', NULL, 'Uncharacterized protein', 124, NULL, NULL, 51079),
(51080, '1.10.1200.10-FF-000018', NULL, 'Nonribosomal siderophore peptide synthase SidC', 75, NULL, NULL, 51080),
(51081, '2.70.98.10-FF-000010', NULL, 'Alpha-1,2-mannosidase family protein', 312, NULL, NULL, 51081),
(51082, '2.60.40.2300-FF-000001', NULL, 'N-acylsphingosine amidohydrolase 2', 139, NULL, NULL, 51082),
(51083, '3.30.1370.210-FF-000029', NULL, 'Uncharacterized protein', 66, NULL, NULL, 51083),
(51084, '2.130.10.10-FF-003790', NULL, 'Uncharacterized protein', 314, NULL, NULL, 51084),
(51085, '2.30.39.10-FF-000140', NULL, 'Serpin peptidase inhibitor 7', 50, NULL, NULL, 51085),
(51086, '3.80.10.10-FF-001805', NULL, 'GM16316', 93, NULL, NULL, 51086),
(51087, '2.60.40.10-FF-000911', NULL, 'tyrosine-protein kinase receptor Tie-1 isoform X2', 84, NULL, NULL, 51087),
(51088, '1.25.40.10-FF-005323', NULL, 'Uncharacterized protein', 110, NULL, NULL, 51088),
(51089, '3.90.1750.10-FF-000045', NULL, 'Ubiquitin ligase e3', 155, NULL, NULL, 51089),
(51090, '3.30.420.310-FF-000001', NULL, '2-oxo-3-deoxygalactonate kinase', 203, NULL, NULL, 51090),
(51091, '3.40.50.1820-FF-001743', NULL, 'Carboxypeptidase', 59, NULL, NULL, 51091),
(51092, '1.25.40.440-FF-000001', NULL, 'Nuclear pore complex subunit', 82, NULL, NULL, 51092),
(51093, '1.20.1250.20-FF-001062', NULL, 'Uncharacterized transporter YwbF', 194, NULL, NULL, 51093),
(51094, '3.90.180.10-FF-000199', NULL, 'Uncharacterized protein', 142, NULL, NULL, 51094),
(51095, '3.90.640.10-FF-000279', NULL, 'Uncharacterized protein', 63, NULL, NULL, 51095),
(51096, '2.40.170.20-FF-000031', NULL, 'TonB-dependent heme receptor HasR', 556, NULL, NULL, 51096),
(51097, '2.60.40.60-FF-000342', NULL, 'Fat-like cadherin-related tumor suppressor homolog', 108, NULL, NULL, 51097),
(51098, '2.160.20.80-FF-000027', NULL, NULL, 124, NULL, NULL, 51098),
(51099, '3.40.50.1240-FF-000029', NULL, 'Phosphoglycerate mutase-like protein 4', 213, NULL, NULL, 51099);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(51100, '3.30.750.44-FF-000028', NULL, NULL, 15, NULL, NULL, 51100),
(51101, '3.20.20.10-FF-000016', NULL, 'D-serine dehydratase', 233, NULL, NULL, 51101),
(51102, '3.30.450.60-FF-000046', NULL, 'Coatomer subunit delta', 124, NULL, NULL, 51102),
(51103, '4.10.91.20-FF-000001', NULL, 'Uncharacterized protein', 63, NULL, NULL, 51103),
(51104, '1.50.10.10-FF-000176', NULL, 'LanC-like protein 3 homolog', 395, NULL, NULL, 51104),
(51105, '2.60.40.10-FF-000350', NULL, 'Immunoglobulin kappa chain variable 18-36', 109, NULL, NULL, 51105),
(51106, '4.10.400.10-FF-000231', NULL, 'LDL receptor repeat-containing protein egg-1', 47, NULL, NULL, 51106),
(51107, '3.40.50.200-FF-000067', NULL, 'Uncharacterized protein', 230, NULL, NULL, 51107),
(51108, '1.25.40.10-FF-001607', NULL, 'Os02g0152100 protein', 133, NULL, NULL, 51108),
(51109, '1.25.10.10-FF-001550', NULL, 'Uncharacterized protein', 171, NULL, NULL, 51109),
(51110, '2.60.130.10-FF-000004', NULL, 'Protocatechuate 3,4-dioxygenase (PcxB)', 167, NULL, NULL, 51110),
(51111, '3.40.20.10-FF-000173', NULL, 'Uncharacterized protein', 134, NULL, NULL, 51111),
(51112, '3.40.50.1820-FF-001092', NULL, 'Uncharacterized protein', 323, NULL, NULL, 51112),
(51113, '1.20.990.10-FF-000059', NULL, 'Uncharacterized protein', 28, NULL, NULL, 51113),
(51114, '3.30.160.60-FF-005942', NULL, NULL, 36, NULL, NULL, 51114),
(51115, '1.20.1250.20-FF-001713', NULL, 'Os09g0556400 protein', 90, NULL, NULL, 51115),
(51116, '2.60.200.60-FF-000002', NULL, 'Uncharacterized protein', 92, NULL, NULL, 51116),
(51117, '1.25.40.10-FF-003378', NULL, 'Intraflagellar transport protein 139', 307, NULL, NULL, 51117),
(51118, '2.70.98.20-FF-000013', NULL, 'Amine oxidase', 430, NULL, NULL, 51118),
(51119, '1.20.120.1080-FF-000096', NULL, 'ATP-dependent RNA helicase, putative', 77, NULL, NULL, 51119),
(51120, '3.40.1110.10-FF-000413', NULL, NULL, 49, NULL, NULL, 51120),
(51121, '3.40.50.300-FF-008146', NULL, 'Uncharacterized protein', 95, NULL, NULL, 51121),
(51122, '2.160.20.70-FF-000024', NULL, 'Tubulin binding cofactor C, putative', 122, NULL, NULL, 51122),
(51123, '3.30.810.10-FF-000008', NULL, 'MSS4p Phosphatidylinositol-4-phosphate 5-kinase', 187, NULL, NULL, 51123),
(51124, '3.30.780.10-FF-000067', NULL, 'Predicted protein', 60, NULL, NULL, 51124),
(51125, '3.40.50.300-FF-007657', NULL, 'Uncharacterized protein', 129, NULL, NULL, 51125),
(51126, '3.30.420.220-FF-000002', NULL, 'Pre-mRNA processing ribonucleoprotein, binding domain protein', 128, NULL, NULL, 51126),
(51127, '3.50.30.10-FF-000004', NULL, 'Pyruvate kinase', 112, NULL, NULL, 51127),
(51128, '1.10.238.10-FF-000252', NULL, 'Phosphoinositide phospholipase C', 45, NULL, NULL, 51128),
(51129, '1.25.40.10-FF-001670', NULL, 'WGS project CABT00000000 data, contig 2.13', 157, NULL, NULL, 51129),
(51130, '3.30.160.60-FF-003525', NULL, 'Uncharacterized protein, isoform A', 70, NULL, NULL, 51130),
(51131, '2.70.50.30-FF-000013', NULL, NULL, 186, NULL, NULL, 51131),
(51132, '2.80.10.50-FF-000229', NULL, 'Putative polypeptide N-acetylgalactosaminyltransferase 12', 132, NULL, NULL, 51132),
(51133, '2.170.210.10-FF-000012', NULL, 'Uncharacterized protein', 115, NULL, NULL, 51133),
(51134, '2.60.120.200-FF-000158', NULL, 'Chondroitin sulfate proteoglycan 4', 187, NULL, NULL, 51134),
(51135, '2.60.40.10-FF-005638', NULL, NULL, 95, NULL, NULL, 51135),
(51136, '3.30.160.60-FF-003997', NULL, NULL, 28, NULL, NULL, 51136),
(51137, '1.25.40.10-FF-003794', NULL, 'Cytochrome c-type biogenesis protein CycH', 145, NULL, NULL, 51137),
(51138, '2.60.220.50-FF-000091', NULL, 'Adhesion G protein-coupled receptor L3', 144, NULL, NULL, 51138),
(51139, '1.10.3730.20-FF-000022', NULL, 'Magnesium transporter NIPA2', 124, NULL, NULL, 51139),
(51140, '1.20.1440.90-FF-000001', NULL, 'Phosphoenolpyruvate carboxylase 1', 136, NULL, NULL, 51140),
(51141, '1.25.40.10-FF-003850', NULL, 'Uncharacterized protein', 115, NULL, NULL, 51141),
(51142, '2.40.10.190-FF-000009', NULL, 'Uncharacterized protein', 73, NULL, NULL, 51142),
(51143, '3.30.40.10-FF-000579', NULL, 'Tripartite motif-containing protein 67', 46, NULL, NULL, 51143);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(51144, '2.10.50.10-FF-000049', NULL, 'Cysteine repeat modular protein 2 PbCRM2', 57, NULL, NULL, 51144),
(51145, '2.10.50.10-FF-000105', NULL, 'TvbS1', 27, NULL, NULL, 51145),
(51146, '3.40.50.10810-FF-000050', NULL, 'Snf2-related CBP activator', 236, NULL, NULL, 51146),
(51147, '2.10.25.10-FF-001620', NULL, 'Predicted protein', 52, NULL, NULL, 51147),
(51148, '3.30.360.10-FF-000052', NULL, 'Unplaced genomic scaffold supercont1.170, whole genome shotgun sequence', 191, NULL, NULL, 51148),
(51149, '3.50.50.100-FF-000046', NULL, 'Predicted protein', 130, NULL, NULL, 51149),
(51150, '3.80.10.10-FF-000794', NULL, 'Similar to preferentially-expressed antigen in melanoma-like 3', 164, NULL, NULL, 51150),
(51151, '2.40.10.170-FF-000003', NULL, 'ATP synthase subunit beta', 75, NULL, NULL, 51151),
(51152, '3.40.50.670-FF-000011', NULL, 'DNA topoisomerase 2', 210, NULL, NULL, 51152),
(51153, '1.10.8.960-FF-000011', NULL, 'Predicted protein', 54, NULL, NULL, 51153),
(51154, '3.40.50.300-FF-007567', NULL, 'Uncharacterized protein', 185, NULL, NULL, 51154),
(51155, '3.90.230.10-FF-000052', NULL, NULL, 164, NULL, NULL, 51155),
(51156, '3.30.1330.20-FF-000058', NULL, 'Tubulin gamma chain, putative', 66, NULL, NULL, 51156),
(51157, '3.30.1490.20-FF-000075', NULL, 'D-alanine--D-alanine ligase', 64, NULL, NULL, 51157),
(51158, '3.60.40.10-FF-000370', NULL, 'Protein phosphatase 2C 29', 256, NULL, NULL, 51158),
(51159, '3.30.70.330-FF-002849', NULL, NULL, 83, NULL, NULL, 51159),
(51160, '3.30.40.10-FF-000202', NULL, 'PHD finger protein 10 isoform X1', 116, NULL, NULL, 51160),
(51161, '1.20.120.640-FF-000002', NULL, 'Cysteine--tRNA ligase', 85, NULL, NULL, 51161),
(51162, '1.10.340.40-FF-000004', NULL, 'Zinc finger CCCH domain-containing protein 14', 101, NULL, NULL, 51162),
(51163, '3.40.50.12710-FF-000002', NULL, 'Protein arginine methyltransferase NDUFAF7', 374, NULL, NULL, 51163),
(51164, '2.120.10.30-FF-000064', NULL, 'Uncharacterized protein', 79, NULL, NULL, 51164),
(51165, '3.30.530.20-FF-000181', NULL, 'Uncharacterized protein', 99, NULL, NULL, 51165),
(51166, '1.20.1110.10-FF-000149', NULL, 'Sodium/potassium-transporting ATPase subunit alpha', 420, NULL, NULL, 51166),
(51167, '3.40.250.10-FF-000227', NULL, 'Thiosulfate/3-mercaptopyruvate sulfurtransferase 1 mitochondrial', 75, NULL, NULL, 51167),
(51168, '3.30.365.10-FF-000041', NULL, 'Glyceraldehyde dehydrogenase large chain', 131, NULL, NULL, 51168),
(51169, '1.10.10.1050-FF-000019', NULL, 'Uncharacterized protein', 84, NULL, NULL, 51169),
(51170, '1.25.40.180-FF-000288', NULL, NULL, 130, NULL, NULL, 51170),
(51171, '3.40.140.70-FF-000012', NULL, 'Ubiquitin-like modifier-activating enzyme ATG7, putative', 193, NULL, NULL, 51171),
(51172, '3.40.50.2300-FF-001314', NULL, NULL, 114, NULL, NULL, 51172),
(51173, '3.40.50.1000-FF-000452', NULL, 'Haloacid dehalogenase-like hydrolase domain-containing protein 2', 177, NULL, NULL, 51173),
(51174, '3.40.50.300-FF-002188', NULL, 'ATP-dependent helicase STH1/SNF2', 298, NULL, NULL, 51174),
(51175, '3.30.60.30-FF-000120', NULL, 'Predicted protein', 55, NULL, NULL, 51175),
(51176, '1.25.10.10-FF-000061', NULL, 'armadillo repeat-containing protein 8 isoform X1', 402, NULL, NULL, 51176),
(51177, '1.20.1270.280-FF-000035', NULL, 'Dynein heavy chain, putative', 181, NULL, NULL, 51177),
(51178, '1.20.1270.60-FF-000187', NULL, 'YALI0E05489p', 214, NULL, NULL, 51178),
(51179, '3.40.50.300-FF-005476', NULL, 'Uncharacterized protein', 304, NULL, NULL, 51179),
(51180, '3.30.420.10-FF-000198', NULL, 'Protein RRP6-like 2', 225, NULL, NULL, 51180),
(51181, '3.50.30.20-FF-000013', NULL, 'CAD protein', 84, NULL, NULL, 51181),
(51182, '1.10.472.80-FF-000255', NULL, NULL, 64, NULL, NULL, 51182),
(51183, '1.10.510.10-FF-000913', NULL, 'Non-specific serine/threonine protein kinase', 243, NULL, NULL, 51183),
(51184, '2.60.120.920-FF-000082', NULL, 'Compass component', 197, NULL, NULL, 51184),
(51185, '3.30.420.10-FF-000254', NULL, 'Integrase/recombinase core subunit', 167, NULL, NULL, 51185),
(51186, '2.30.29.30-FF-000499', NULL, 'Pleckstrin y domain-containing family H member 2', 105, NULL, NULL, 51186);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(51187, '1.10.1200.260-FF-000002', NULL, 'Potassium voltage-gated channel subfamily H member 8', 42, NULL, NULL, 51187),
(51188, '2.60.40.10-FF-005695', NULL, NULL, 71, NULL, NULL, 51188),
(51189, '2.60.40.1230-FF-000017', NULL, 'ADP-ribosylation factor-binding protein GGA1', 126, NULL, NULL, 51189),
(51190, '3.90.1750.10-FF-000039', NULL, 'Ubiquitin-protein ligase, putative', 159, NULL, NULL, 51190),
(51191, '3.20.20.190-FF-000080', NULL, 'Glycerophosphoryl diester phosphodiesterase, putative', 301, NULL, NULL, 51191),
(51192, '2.40.440.10-FF-000004', NULL, 'L,D-transpeptidase catalytic domain', 117, NULL, NULL, 51192),
(51193, '3.50.30.10-FF-000010', NULL, 'Phosphotransferase system fructose-specific transporter subunit EI/HPr/EIIA', 103, NULL, NULL, 51193),
(51194, '2.40.50.140-FF-001082', NULL, NULL, 84, NULL, NULL, 51194),
(51195, '2.40.50.140-FF-000952', NULL, NULL, 65, NULL, NULL, 51195),
(51196, '6.10.140.2220-FF-000079', NULL, 'SET and MYND domain-containing protein DDB_G0288495', 61, NULL, NULL, 51196),
(51197, '3.30.830.10-FF-000009', NULL, 'Presequence protease, mitochondrial', 234, NULL, NULL, 51197),
(51198, '1.10.287.110-FF-000070', NULL, 'Endoplasmic reticulum protein, putative', 123, NULL, NULL, 51198),
(51199, '2.170.130.20-FF-000014', NULL, NULL, 106, NULL, NULL, 51199),
(51200, '3.30.450.40-FF-000242', NULL, 'Phosphodiesterase', 174, NULL, NULL, 51200),
(51201, '3.40.1350.10-FF-000015', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 114, NULL, NULL, 51201),
(51202, '3.30.70.20-FF-000033', NULL, 'Anaerobic sulfite reductase subunit AsrC', 59, NULL, NULL, 51202),
(51203, '1.20.1280.50-FF-000156', NULL, 'Uncharacterized protein', 90, NULL, NULL, 51203),
(51204, '3.80.10.10-FF-002879', NULL, 'Leucine Rich Repeat family protein', 169, NULL, NULL, 51204),
(51205, '2.40.50.100-FF-000081', NULL, 'DNA-directed RNA polymerase subunit beta', 64, NULL, NULL, 51205),
(51206, '3.40.30.10-FF-001016', NULL, 'Uncharacterized protein', 58, NULL, NULL, 51206),
(51207, '1.10.1200.270-FF-000005', NULL, 'Paraxanthine methyltransferase 1', 131, NULL, NULL, 51207),
(51208, '3.30.160.60-FF-004132', NULL, NULL, 30, NULL, NULL, 51208),
(51209, '3.40.1180.10-FF-000041', NULL, 'Uncharacterized protein', 94, NULL, NULL, 51209),
(51210, '1.10.150.50-FF-000094', NULL, 'Actin cytoskeleton-regulatory complex protein SLA1', 71, NULL, NULL, 51210),
(51211, '2.60.40.10-FF-001367', NULL, 'titin isoform X1', 92, NULL, NULL, 51211),
(51212, '3.90.79.10-FF-000204', NULL, 'Mitochondrial RNA binding complex 1 subunit', 133, NULL, NULL, 51212),
(51213, '3.70.10.10-FF-000081', NULL, 'DNA polymerase sliding clamp 1', 239, NULL, NULL, 51213),
(51214, '3.30.70.330-FF-002647', NULL, NULL, 213, NULL, NULL, 51214),
(51215, '3.30.457.60-FF-000022', NULL, 'Uncharacterized protein', 75, NULL, NULL, 51215),
(51216, '3.30.60.20-FF-000004', NULL, 'B-Raf proto-oncogene serine/threonine-protein kinase', 47, NULL, NULL, 51216),
(51217, '1.10.10.10-FF-001459', NULL, 'DNA-directed RNA polymerase III subunit RPC6', 36, NULL, NULL, 51217),
(51218, '2.170.16.10-FF-000018', NULL, 'DNA-directed RNA polymerase III subunit rpc2', 150, NULL, NULL, 51218),
(51219, '2.60.200.20-FF-000131', NULL, 'Adenylate cyclase-like protein', 106, NULL, NULL, 51219),
(51220, '1.25.10.10-FF-000206', NULL, 'Transportin-1', 886, NULL, NULL, 51220),
(51221, '2.60.40.60-FF-000611', NULL, 'Protocadherin gamma B6', 54, NULL, NULL, 51221),
(51222, '3.30.60.30-FF-000007', NULL, 'follistatin-related protein 5 isoform X1', 69, NULL, NULL, 51222),
(51223, '3.40.50.1100-FF-000128', NULL, 'Putative serine-threonine dehydratase', 107, NULL, NULL, 51223),
(51224, '1.20.1310.20-FF-000050', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 266, NULL, NULL, 51224),
(51225, '3.10.20.90-FF-000607', NULL, 'SF3A1 splicing factor 3a, subunit 1', 113, NULL, NULL, 51225),
(51226, '3.30.160.60-FF-000237', NULL, 'Krueppel-like factor 2', 41, NULL, NULL, 51226),
(51227, '1.50.40.10-FF-000526', NULL, 'Mitochondrial carrier protein-like protein', 230, NULL, NULL, 51227);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(51228, '2.130.10.10-FF-004043', NULL, 'Uncharacterized protein', 218, NULL, NULL, 51228),
(51229, '2.60.120.10-FF-000447', NULL, 'Uncharacterized protein', 95, NULL, NULL, 51229),
(51230, '1.20.58.60-FF-000858', NULL, 'Uncharacterized protein', 130, NULL, NULL, 51230),
(51231, '1.10.10.10-FF-001370', NULL, 'WNK lysine deficient protein kinase 4', 48, NULL, NULL, 51231),
(51232, '3.40.50.10860-FF-000014', NULL, 'Shikimate 5-dehydrogenase', 100, NULL, NULL, 51232),
(51233, '1.10.8.60-FF-000484', NULL, 'Uncharacterized protein', 101, NULL, NULL, 51233),
(51234, '3.60.21.10-FF-000152', NULL, 'Nuclease SbcCD subunit D', 265, NULL, NULL, 51234),
(51235, '3.30.9.10-FF-000254', NULL, 'L-2-hydroxyglutarate dehydrogenase, mitochondrial-like Protein', 161, NULL, NULL, 51235),
(51236, '1.10.287.130-FF-000076', NULL, 'Two-component sensor histidine kinase', 61, NULL, NULL, 51236),
(51237, '3.40.50.720-FF-001830', NULL, 'NADP(+) coupled glycerol dehydrogenase (Eurofung)', 143, NULL, NULL, 51237),
(51238, '3.40.630.30-FF-000638', NULL, 'Uncharacterized N-acetyltransferase C56E4.07', 223, NULL, NULL, 51238),
(51239, '3.40.50.20-FF-000037', NULL, 'Ribosomal modification protein rimK like family member A', 80, NULL, NULL, 51239),
(51240, '3.40.1090.10-FF-000011', NULL, 'Phospholipase, patatin family', 97, NULL, NULL, 51240),
(51241, '3.30.1480.10-FF-000004', NULL, 'Transcription termination/antitermination protein NusA', 99, NULL, NULL, 51241),
(51242, '1.25.40.10-FF-004160', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic/mitochondrial', 105, NULL, NULL, 51242),
(51243, '3.40.50.2300-FF-001371', NULL, NULL, 96, NULL, NULL, 51243),
(51244, '2.40.20.10-FF-000068', NULL, 'Uncharacterized protein', 97, NULL, NULL, 51244),
(51245, '3.40.50.1100-FF-000241', NULL, 'Uncharacterized protein', 47, NULL, NULL, 51245),
(51246, '1.10.560.10-FF-000063', NULL, 'T-complex protein 1 subunit gamma', 178, NULL, NULL, 51246),
(51247, '3.20.20.80-FF-000576', NULL, 'Beta-galactosidase', 265, NULL, NULL, 51247),
(51248, '1.10.10.60-FF-000232', NULL, 'homeobox-leucine zipper protein ATHB-13-like', 47, NULL, NULL, 51248),
(51249, '1.10.30.10-FF-000151', NULL, 'Kinetoplast-associated protein 4', 79, NULL, NULL, 51249),
(51250, '1.20.1070.10-FF-000269', NULL, 'C3a anaphylatoxin chemotactic receptor', 186, NULL, NULL, 51250),
(51251, '2.40.50.100-FF-000226', NULL, 'Cytochrome f, chloroplastic', 59, NULL, NULL, 51251),
(51252, '3.20.10.10-FF-000044', NULL, 'Slr0887 protein', 132, NULL, NULL, 51252),
(51253, '1.20.1560.10-FF-000470', NULL, 'ABC transporter, ATP-binding protein', 320, NULL, NULL, 51253),
(51254, '2.40.20.10-FF-000012', NULL, 'Phosphoinositide-3-kinase-interacting protein 1', 99, NULL, NULL, 51254),
(51255, '3.30.457.10-FF-000001', NULL, 'Primary amine oxidase', 84, NULL, NULL, 51255),
(51256, '3.20.20.140-FF-000323', NULL, 'Allantoinase', 174, NULL, NULL, 51256),
(51257, '3.40.50.2300-FF-000909', NULL, NULL, 163, NULL, NULL, 51257),
(51258, '3.30.900.10-FF-000038', NULL, 'Uncharacterized protein', 234, NULL, NULL, 51258),
(51259, '1.10.533.10-FF-000005', NULL, 'Tumor necrosis factor receptor superfamily member 21', 79, NULL, NULL, 51259),
(51260, '2.60.40.10-FF-003840', NULL, NULL, 124, NULL, NULL, 51260),
(51261, '3.30.60.10-FF-000001', NULL, 'Basic endochitinase', 42, NULL, NULL, 51261),
(51262, '3.10.20.310-FF-000011', NULL, 'Protein TOC75-3 chloroplastic', 82, NULL, NULL, 51262),
(51263, '1.10.287.210-FF-000004', NULL, 'LPS O-antigen length regulator', 106, NULL, NULL, 51263),
(51264, '2.30.30.40-FF-000140', NULL, 'vinexin isoform X2', 66, NULL, NULL, 51264),
(51265, '3.40.50.300-FF-000390', NULL, 'tRNA dimethylallyltransferase', 124, NULL, NULL, 51265),
(51266, '3.30.70.100-FF-000190', NULL, NULL, 95, NULL, NULL, 51266),
(51267, '3.30.160.20-FF-000074', NULL, 'RNA polymerase II C-terminal domain phosphatase-like 1', 85, NULL, NULL, 51267),
(51268, '1.10.287.110-FF-000272', NULL, 'Chaperone protein DnaJ', 114, NULL, NULL, 51268),
(51269, '3.30.160.60-FF-000035', NULL, 'Zinc finger protein ZIC 1', 31, NULL, NULL, 51269);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(51270, '4.10.400.10-FF-000315', NULL, 'neurotrypsin-like isoform X1', 38, NULL, NULL, 51270),
(51271, '3.30.160.60-FF-006021', NULL, NULL, 30, NULL, NULL, 51271),
(51272, '1.25.10.10-FF-000004', NULL, 'Pumilio homolog 1 isoform 2', 350, NULL, NULL, 51272),
(51273, '1.10.150.80-FF-000013', NULL, 'Bloom syndrome protein homolog', 86, NULL, NULL, 51273),
(51274, '1.10.510.10-FF-002999', NULL, NULL, 139, NULL, NULL, 51274),
(51275, '1.10.8.10-FF-000222', NULL, 'ubiquitin-associated protein 2-like isoform X3', 63, NULL, NULL, 51275),
(51276, '2.60.120.920-FF-000025', NULL, 'E3 ubiquitin-protein ligase TRIM41 isoform X1', 189, NULL, NULL, 51276),
(51277, '3.40.30.10-FF-000145', NULL, 'thioredoxin-like protein HCF164, chloroplastic', 113, NULL, NULL, 51277),
(51278, '1.20.5.540-FF-000006', NULL, 'Uncharacterized protein', 31, NULL, NULL, 51278),
(51279, '1.10.8.60-FF-000540', NULL, 'DNA damage checkpoint protein', 61, NULL, NULL, 51279),
(51280, '3.10.20.90-FF-000720', NULL, 'FERM domain-containing protein A', 84, NULL, NULL, 51280),
(51281, '2.130.10.10-FF-003907', NULL, 'Uncharacterized protein', 267, NULL, NULL, 51281),
(51282, '2.130.10.10-FF-003256', NULL, 'Polyadenylation factor subunit 2', 199, NULL, NULL, 51282),
(51283, '2.40.50.1010-FF-000001', NULL, 'tRNA(Ile2) 2-agmatinylcytidine synthetase TiaS', 149, NULL, NULL, 51283),
(51284, '3.90.320.10-FF-000025', NULL, 'ATP-dependent DNA helicase', 180, NULL, NULL, 51284),
(51285, '1.20.1440.240-FF-000001', NULL, 'L-amino acid oxidase LaoA', 109, NULL, NULL, 51285),
(51286, '2.40.10.500-FF-000001', NULL, 'tripartite motif-containing protein 3-like', 79, NULL, NULL, 51286),
(51287, '3.40.50.880-FF-000102', NULL, 'Probable amidotransferase', 219, NULL, NULL, 51287),
(51288, '3.40.50.300-FF-003767', NULL, 'Midasin', 217, NULL, NULL, 51288),
(51289, '3.40.50.2000-FF-000943', NULL, 'Uncharacterized protein', 128, NULL, NULL, 51289),
(51290, '3.40.50.300-FF-006347', NULL, 'Predicted protein', 110, NULL, NULL, 51290),
(51291, '3.30.160.60-FF-001816', NULL, 'Uncharacterized protein', 29, NULL, NULL, 51291),
(51292, '2.120.10.30-FF-000300', NULL, 'adipocyte plasma membrane-associated protein-like', 334, NULL, NULL, 51292),
(51293, '3.40.50.300-FF-000951', NULL, 'Putative pre-mRNA-splicing factor ATP-dependent RNA helicase', 228, NULL, NULL, 51293),
(51294, '2.20.70.10-FF-000061', NULL, 'Rho GTPase activating protein 27', 57, NULL, NULL, 51294),
(51295, '2.60.40.10-FF-003929', NULL, NULL, 107, NULL, NULL, 51295),
(51296, '3.50.50.60-FF-001431', NULL, 'Predicted protein', 114, NULL, NULL, 51296),
(51297, '1.25.10.20-FF-000007', NULL, 'Crossveinless d', 322, NULL, NULL, 51297),
(51298, '1.25.40.10-FF-005177', NULL, 'Tetratricopeptide repeat-like superfamily protein', 58, NULL, NULL, 51298),
(51299, '1.25.40.1030-FF-000057', NULL, 'Uncharacterized protein', 138, NULL, NULL, 51299),
(51300, '2.60.40.60-FF-000140', NULL, 'Dachsous cadherin-related 1', 108, NULL, NULL, 51300),
(51301, '4.10.80.10-FF-000001', NULL, 'Genome polyprotein', 69, NULL, NULL, 51301),
(51302, '3.30.1610.10-FF-000004', NULL, 'Nuclear pore complex protein Nup98-Nup96', 156, NULL, NULL, 51302),
(51303, '3.30.70.330-FF-001068', NULL, 'Polyadenylate-binding protein', 98, NULL, NULL, 51303),
(51304, '1.10.580.10-FF-000007', NULL, 'Citrate synthase 2', 61, NULL, NULL, 51304),
(51305, '2.60.120.380-FF-000077', NULL, 'Uncharacterized protein', 87, NULL, NULL, 51305),
(51306, '3.80.10.10-FF-002407', NULL, 'Uncharacterized protein', 97, NULL, NULL, 51306),
(51307, '3.40.1810.10-FF-000039', NULL, 'Agamous-like MADS-box protein AGL62', 85, NULL, NULL, 51307),
(51308, '2.110.10.10-FF-000047', NULL, 'Matrix metallopeptidase 9', 80, NULL, NULL, 51308),
(51309, '3.30.70.260-FF-000187', NULL, 'Homoserine dehydrogenase', 74, NULL, NULL, 51309),
(51310, '1.25.40.250-FF-000011', NULL, 'Eukaryotic translation initiation factor 3 subunit K', 117, NULL, NULL, 51310),
(51311, '3.30.160.60-FF-004076', NULL, 'LD35343p', 77, NULL, NULL, 51311),
(51312, '1.20.140.100-FF-000001', NULL, 'dynein heavy chain 17, axonemal', 150, NULL, NULL, 51312);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(51313, '3.30.70.580-FF-000018', NULL, 'Pseudouridine synthase', 85, NULL, NULL, 51313),
(51314, '2.40.70.10-FF-000015', NULL, 'Aspartyl protease family protein', 198, NULL, NULL, 51314),
(51315, '3.40.50.300-FF-007365', NULL, 'Uncharacterized protein', 240, NULL, NULL, 51315),
(51316, '3.30.1120.10-FF-000045', NULL, 'N-acetyl-galactosamine-6-sulfatase (GALNS)', 73, NULL, NULL, 51316),
(51317, '1.10.2000.10-FF-000037', NULL, NULL, 73, NULL, NULL, 51317),
(51318, '4.10.240.10-FF-000218', NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', 47, NULL, NULL, 51318),
(51319, '1.25.40.10-FF-000360', NULL, 'Lysine (K)-specific demethylase 6A, like', 168, NULL, NULL, 51319),
(51320, '3.40.50.300-FF-005712', NULL, 'DsRNA-specific nuclease dicer and related ribonuclease', 167, NULL, NULL, 51320),
(51321, '1.25.10.10-FF-001842', NULL, 'Uncharacterized protein', 595, NULL, NULL, 51321),
(51322, '2.130.10.10-FF-000243', NULL, 'Transcription initiation factor TFIID subunit 5', 178, NULL, NULL, 51322),
(51323, '1.20.1070.10-FF-000977', NULL, 'Protein CBG08799', 334, NULL, NULL, 51323),
(51324, '3.40.50.720-FF-001302', NULL, 'Pyrroline-5-carboxylate reductase', 161, NULL, NULL, 51324),
(51325, '1.25.40.20-FF-000363', NULL, 'Ankyrin repeat domain 31', 173, NULL, NULL, 51325),
(51326, '1.25.40.20-FF-000306', NULL, 'L-asparaginase', 98, NULL, NULL, 51326),
(51327, '1.20.140.150-FF-000022', NULL, 'Germ cell-specific 1 protein', 205, NULL, NULL, 51327),
(51328, '4.10.280.10-FF-000018', NULL, 'Aryl hydrocarbon receptor nuclear translocator-like protein 1', 68, NULL, NULL, 51328),
(51329, '3.40.50.1820-FF-000962', NULL, 'protein NDRG1 isoform X6', 279, NULL, NULL, 51329),
(51330, '2.40.128.490-FF-000001', NULL, 'TonB family protein', 130, NULL, NULL, 51330),
(51331, '3.30.2410.10-FF-000062', NULL, 'Uncharacterized protein', 80, NULL, NULL, 51331),
(51332, '3.90.70.80-FF-000099', NULL, 'Uncharacterized protein', 120, NULL, NULL, 51332),
(51333, '1.20.1270.60-FF-000243', NULL, 'Islet cell autoantigen, putative', 66, NULL, NULL, 51333),
(51334, '3.30.230.10-FF-000329', NULL, 'Uncharacterized protein', 84, NULL, NULL, 51334),
(51335, '2.60.120.330-FF-000056', NULL, 'Flavonol synthase', 312, NULL, NULL, 51335),
(51336, '3.30.40.10-FF-001186', NULL, 'Putative Zn-finger domain protein', 76, NULL, NULL, 51336),
(51337, '2.60.40.10-FF-001895', NULL, 'PeroXidasiN (Drosophila peroxidase) homolog', 94, NULL, NULL, 51337),
(51338, '2.60.40.10-FF-001838', NULL, 'Protein kinase, AMP-activated, beta 1 non-catalytic subunit, b', 96, NULL, NULL, 51338),
(51339, '3.30.40.10-FF-001506', NULL, 'Uncharacterized protein', 74, NULL, NULL, 51339),
(51340, '3.80.10.10-FF-003430', NULL, 'Uncharacterized protein', 254, NULL, NULL, 51340),
(51341, '1.10.10.730-FF-000002', NULL, 'Chromosome-partitioning protein ParB', 52, NULL, NULL, 51341),
(51342, '3.20.20.140-FF-000177', NULL, 'Similar to carbohydrate esterase family 9 protein', 315, NULL, NULL, 51342),
(51343, '1.25.10.10-FF-001549', NULL, 'Exportin-T', 198, NULL, NULL, 51343),
(51344, '3.40.30.10-FF-000235', NULL, 'nucleoredoxin-like protein 1', 145, NULL, NULL, 51344),
(51345, '3.40.50.300-FF-002660', NULL, 'Nucleotide-binding protein', 123, NULL, NULL, 51345),
(51346, '3.40.50.12100-FF-000004', NULL, 'Putative transmembrane protein', 146, NULL, NULL, 51346),
(51347, '3.20.20.70-FF-000663', NULL, 'Deoxyribose-phosphate aldolase', 226, NULL, NULL, 51347),
(51348, '2.30.30.490-FF-000072', NULL, 'Origin recognition complex subunit 1', 174, NULL, NULL, 51348),
(51349, '2.30.29.30-FF-001050', NULL, 'Uncharacterized protein', 113, NULL, NULL, 51349),
(51350, '3.90.1490.10-FF-000002', NULL, 'Diphthine--ammonia ligase', 97, NULL, NULL, 51350),
(51351, '2.60.40.1170-FF-000072', NULL, NULL, 106, NULL, NULL, 51351),
(51352, '1.10.3370.10-FF-000025', NULL, 'Uncharacterized protein', 352, NULL, NULL, 51352),
(51353, '3.20.20.140-FF-000233', NULL, 'Putative AMP deaminase', 167, NULL, NULL, 51353),
(51354, '3.40.50.150-FF-001755', NULL, NULL, 264, NULL, NULL, 51354),
(51355, '3.40.50.150-FF-001811', NULL, NULL, 107, NULL, NULL, 51355);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(51356, '3.40.1160.10-FF-000039', NULL, 'Glutamate 5-kinase', 235, NULL, NULL, 51356),
(51357, '2.60.40.1180-FF-000075', NULL, 'Alpha-xylosidase 1', 167, NULL, NULL, 51357),
(51358, '3.30.1370.210-FF-000030', NULL, 'Zinc finger matrin-type protein 5', 67, NULL, NULL, 51358),
(51359, '1.20.1560.10-FF-000846', NULL, 'ATP-binding cassette transporter, subfamily B, member 11, group MDR/PGP protein PpABCB11', 333, NULL, NULL, 51359),
(51360, '2.60.40.10-FF-002822', NULL, 'Tenascin C', 91, NULL, NULL, 51360),
(51361, '3.40.50.1460-FF-000039', NULL, 'Caspase b', 264, NULL, NULL, 51361),
(51362, '2.60.40.1180-FF-000131', NULL, 'Uncharacterized protein', 80, NULL, NULL, 51362),
(51363, '2.60.40.10-FF-003278', NULL, 'Hypothetical_protein_-_conserved', 122, NULL, NULL, 51363),
(51364, '1.25.40.90-FF-000069', NULL, 'Huntingtin interacting protein 1', 96, NULL, NULL, 51364),
(51365, '1.10.8.60-FF-000394', NULL, 'AGAP012537-PA', 68, NULL, NULL, 51365),
(51366, '1.25.10.10-FF-001752', NULL, 'Protein VAC14-like', 113, NULL, NULL, 51366),
(51367, '3.40.50.150-FF-000361', NULL, 'Ferredoxin-fold anticodon-binding domain-containing protein 1 homolog', 140, NULL, NULL, 51367),
(51368, '1.10.510.10-FF-003926', NULL, NULL, 73, NULL, NULL, 51368),
(51369, '2.60.40.150-FF-000403', NULL, 'Unc-13-like protein A', 70, NULL, NULL, 51369),
(51370, '1.25.40.10-FF-000450', NULL, 'Putative pentatricopeptide repeat-containing protein', 115, NULL, NULL, 51370),
(51371, '2.60.120.590-FF-000084', NULL, 'Uncharacterized protein', 112, NULL, NULL, 51371),
(51372, '3.30.70.260-FF-000097', NULL, 'Bifunctional (P)ppGpp synthase/hydrolase SpoT', 82, NULL, NULL, 51372),
(51373, '3.90.730.10-FF-000022', NULL, 'Rnt2', 128, NULL, NULL, 51373),
(51374, '2.60.120.10-FF-000537', NULL, 'Uncharacterized protein', 113, NULL, NULL, 51374),
(51375, '1.10.10.10-FF-000352', NULL, 'Forkhead box Q2', 105, NULL, NULL, 51375),
(51376, '2.130.10.10-FF-003587', NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', 257, NULL, NULL, 51376),
(51377, '3.30.2170.10-FF-000020', NULL, NULL, 116, NULL, NULL, 51377),
(51378, '3.80.10.10-FF-003374', NULL, 'Uncharacterized protein', 107, NULL, NULL, 51378),
(51379, '1.25.10.10-FF-001078', NULL, 'Uncharacterized protein', 225, NULL, NULL, 51379),
(51380, '3.20.20.80-FF-000666', NULL, 'Predicted protein', 438, NULL, NULL, 51380),
(51381, '3.50.50.60-FF-001228', NULL, 'Uncharacterized protein', 236, NULL, NULL, 51381),
(51382, '3.40.50.1440-FF-000033', NULL, 'Tubulin beta chain', 272, NULL, NULL, 51382),
(51383, '3.20.20.70-FF-000192', NULL, 'Multifunctional tryptophan biosynthesis protein', 204, NULL, NULL, 51383),
(51384, '1.10.10.10-FF-001931', NULL, 'Uncharacterized protein', 90, NULL, NULL, 51384),
(51385, '4.10.1240.10-FF-000086', NULL, 'Pituitary adenylate cyclase-activating polypeptide type I receptor', 58, NULL, NULL, 51385),
(51386, '3.30.930.10-FF-000337', NULL, 'Alanyl-tRNA synthetase, putative', 104, NULL, NULL, 51386),
(51387, '1.25.40.20-FF-000453', NULL, 'Ankyrin repeat domain 1a (cardiac muscle)', 126, NULL, NULL, 51387),
(51388, '1.10.10.10-FF-001746', NULL, 'Transcriptional regulator, MarR family', 148, NULL, NULL, 51388),
(51389, '3.50.50.60-FF-001285', NULL, 'Apoptosis-inducing factor 1', 186, NULL, NULL, 51389),
(51390, '1.10.101.10-FF-000031', NULL, 'Lytic murein transglycosylase', 57, NULL, NULL, 51390),
(51391, '3.30.40.10-FF-001130', NULL, 'Ring finger domain containing protein, putative', 52, NULL, NULL, 51391),
(51392, '3.10.28.10-FF-000040', NULL, 'Ribonucleoside-diphosphate reductase nrdEB subunit alpha', 182, NULL, NULL, 51392),
(51393, '3.90.1410.10-FF-000025', NULL, 'Uncharacterized protein', 260, NULL, NULL, 51393),
(51394, '3.40.50.1440-FF-000090', NULL, 'Uncharacterized protein', 129, NULL, NULL, 51394),
(51395, '1.10.510.10-FF-002151', NULL, NULL, 116, NULL, NULL, 51395),
(51396, '2.10.10.10-FF-000018', NULL, 'Uncharacterized protein', 51, NULL, NULL, 51396),
(51397, '1.20.5.110-FF-000086', NULL, 'Vesicle transport v-SNARE protein VTI1, putative', 80, NULL, NULL, 51397);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(51398, '2.130.10.10-FF-005296', NULL, 'WD repeat protein, putative', 218, NULL, NULL, 51398),
(51399, '2.10.10.100-FF-000006', NULL, NULL, 49, NULL, NULL, 51399),
(51400, '2.130.10.10-FF-005386', NULL, 'Uncharacterized protein', 154, NULL, NULL, 51400),
(51401, '1.10.510.10-FF-002061', NULL, 'Kinase, NEK', 281, NULL, NULL, 51401),
(51402, '2.70.160.11-FF-000084', NULL, 'Uncharacterized protein', 25, NULL, NULL, 51402),
(51403, '2.40.30.10-FF-000041', NULL, 'NADPH--cytochrome P450 reductase', 111, NULL, NULL, 51403),
(51404, '3.90.1420.10-FF-000054', NULL, 'Predicted protein', 93, NULL, NULL, 51404),
(51405, '3.30.200.20-FF-001819', NULL, 'Kinase, NEK', 59, NULL, NULL, 51405),
(51406, '1.25.40.10-FF-004103', NULL, 'Uncharacterized protein', 144, NULL, NULL, 51406),
(51407, '3.40.50.720-FF-001066', NULL, 'Short-chain dehydrogenase/reductase family protein', 261, NULL, NULL, 51407),
(51408, '3.30.40.10-FF-001220', NULL, 'Ubiquitinyl hydrolase 1', 70, NULL, NULL, 51408),
(51409, '3.40.50.150-FF-000119', NULL, 'probable pectin methyltransferase QUA2', 184, NULL, NULL, 51409),
(51410, '2.60.40.10-FF-005077', NULL, NULL, 100, NULL, NULL, 51410),
(51411, '1.25.40.540-FF-000031', NULL, 'Uncharacterized protein', 45, NULL, NULL, 51411),
(51412, '1.10.1420.10-FF-000001', NULL, 'DNA mismatch repair protein MutS', 177, NULL, NULL, 51412),
(51413, '2.70.20.10-FF-000033', NULL, 'DNA topoisomerase', 12, NULL, NULL, 51413),
(51414, '3.30.499.10-FF-000014', NULL, 'Aconitate hydratase 1', 221, NULL, NULL, 51414),
(51415, '3.10.50.10-FF-000069', NULL, 'Predicted protein', 18, NULL, NULL, 51415),
(51416, '1.20.1560.10-FF-000885', NULL, 'ABC protein, subfamily ABCC', 150, NULL, NULL, 51416),
(51417, '1.10.287.2900-FF-000008', NULL, 'AGAP002940-PA-like protein', 79, NULL, NULL, 51417),
(51418, '2.60.40.10-FF-002204', NULL, '1,4-alpha-glucan branching enzyme GlgB', 95, NULL, NULL, 51418),
(51419, '2.60.40.1180-FF-000018', NULL, 'Alpha-mannosidase', 98, NULL, NULL, 51419),
(51420, '3.30.70.330-FF-001158', NULL, 'RNA-binding protein, mRNA-processing factor 2b', 66, NULL, NULL, 51420),
(51421, '2.150.10.10-FF-000017', NULL, 'Putative Mannuronan C-5-epimerase', 230, NULL, NULL, 51421),
(51422, '1.20.58.340-FF-000070', NULL, 'Cobalt/magnesium transport protein CorA', 127, NULL, NULL, 51422),
(51423, '1.25.40.70-FF-000063', NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', 161, NULL, NULL, 51423),
(51424, '3.40.630.30-FF-000133', NULL, 'Acetyltransferase, GNAT family', 156, NULL, NULL, 51424),
(51425, '1.10.555.10-FF-000174', NULL, 'YALI0E07601p', 246, NULL, NULL, 51425),
(51426, '1.25.40.120-FF-000080', NULL, 'Rab geranylgeranyltransferase', 324, NULL, NULL, 51426),
(51427, '2.130.10.30-FF-000069', NULL, 'Serine/threonine-protein kinase-like protein CR4', 157, NULL, NULL, 51427),
(51428, '1.10.510.10-FF-002004', NULL, 'NimA-related protein kinase 1', 182, NULL, NULL, 51428),
(51429, '2.60.120.10-FF-000650', NULL, 'Uncharacterized protein', 143, NULL, NULL, 51429),
(51430, '2.60.40.1180-FF-000221', NULL, 'Oligosaccharide 4-alpha-D-glucosyltransferase', 148, NULL, NULL, 51430),
(51431, '3.40.50.300-FF-000277', NULL, 'ATP-dependent zinc metalloprotease FtsH', 190, NULL, NULL, 51431),
(51432, '3.90.1410.10-FF-000115', NULL, 'Uncharacterized protein', 212, NULL, NULL, 51432),
(51433, '1.10.730.10-FF-000132', NULL, 'Leucyl-tRNA synthetase 2, mitochondrial', 23, NULL, NULL, 51433),
(51434, '2.40.50.90-FF-000167', NULL, 'Uncharacterized protein', 141, NULL, NULL, 51434),
(51435, '3.10.20.90-FF-000102', NULL, 'Plexin B2', 112, NULL, NULL, 51435),
(51436, '4.10.1000.10-FF-000158', NULL, 'Uncharacterized protein', 69, NULL, NULL, 51436),
(51437, '3.40.50.12500-FF-000001', NULL, 'Putative hydantoin racemase', 238, NULL, NULL, 51437),
(51438, '3.40.30.10-FF-000292', NULL, 'Molecular chaperone DnaJ', 116, NULL, NULL, 51438),
(51439, '1.10.3380.10-FF-000054', NULL, 'Predicted protein', 137, NULL, NULL, 51439),
(51440, '3.20.20.70-FF-000753', NULL, NULL, 65, NULL, NULL, 51440),
(51441, '2.30.29.30-FF-000645', NULL, 'FACT complex subunit SSRP1', 108, NULL, NULL, 51441);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(51442, '3.50.4.10-FF-000001', NULL, 'Coagulation factor XI', 92, NULL, NULL, 51442),
(51443, '3.40.50.150-FF-001665', NULL, NULL, 198, NULL, NULL, 51443),
(51444, '2.60.40.10-FF-000349', NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein', 87, NULL, NULL, 51444),
(51445, '1.10.510.10-FF-003308', NULL, NULL, 77, NULL, NULL, 51445),
(51446, '2.40.270.10-FF-000030', NULL, NULL, 45, NULL, NULL, 51446),
(51447, '3.30.230.130-FF-000050', NULL, 'Cullin-4A', 157, NULL, NULL, 51447),
(51448, '1.25.10.10-FF-001639', NULL, 'Uncharacterized protein', 1064, NULL, NULL, 51448),
(51449, '3.40.30.10-FF-000325', NULL, 'Glutathione S-transferase kappa', 208, NULL, NULL, 51449),
(51450, '3.40.50.300-FF-000187', NULL, 'Vesicular-fusion ATPase SEC18', 191, NULL, NULL, 51450),
(51451, '3.40.50.300-FF-002750', NULL, 'Cdc3p', 320, NULL, NULL, 51451),
(51452, '3.80.10.10-FF-003520', NULL, 'Leucine-rich repeat protein', 306, NULL, NULL, 51452),
(51453, '1.10.3080.10-FF-000014', NULL, 'Chloride channel protein', 464, NULL, NULL, 51453),
(51454, '3.30.930.10-FF-000427', NULL, 'Lysine--tRNA ligase', 359, NULL, NULL, 51454),
(51455, '3.40.50.300-FF-005566', NULL, 'Dynein heavy chain domain 1', 146, NULL, NULL, 51455),
(51456, '3.30.160.60-FF-006307', NULL, NULL, 73, NULL, NULL, 51456),
(51457, '1.10.510.10-FF-002622', NULL, NULL, 97, NULL, NULL, 51457),
(51458, '2.30.29.30-FF-001140', NULL, 'Uncharacterized protein', 116, NULL, NULL, 51458),
(51459, '3.20.20.80-FF-000756', NULL, 'Glycosyl hydrolase', 320, NULL, NULL, 51459),
(51460, '3.40.50.300-FF-002222', NULL, 'AFG1-family ATPase, variant', 179, NULL, NULL, 51460),
(51461, '1.20.1280.50-FF-000117', NULL, 'F-box/WD repeat-containing protein lin-23', 91, NULL, NULL, 51461),
(51462, '3.40.33.10-FF-000096', NULL, 'MIP08535p', 236, NULL, NULL, 51462),
(51463, '1.25.40.10-FF-001377', NULL, 'Fleer', 137, NULL, NULL, 51463),
(51464, '1.10.630.10-FF-000237', NULL, 'Cytochrome P450 3A9-like', 481, NULL, NULL, 51464),
(51465, '3.40.50.300-FF-002042', NULL, 'ATP-dependent RNA helicase', 161, NULL, NULL, 51465),
(51466, '2.40.10.10-FF-000039', NULL, 'Brain-specific serine protease 4', 252, NULL, NULL, 51466),
(51467, '1.20.120.1080-FF-000040', NULL, 'ATP-dependent RNA helicase DHX36', 126, NULL, NULL, 51467),
(51468, '3.30.200.20-FF-001297', NULL, 'Fibroblast growth factor receptor', 119, NULL, NULL, 51468),
(51469, '3.30.160.60-FF-002036', NULL, 'Ras-responsive element-binding protein 1', 37, NULL, NULL, 51469),
(51470, '3.10.580.10-FF-000129', NULL, 'Predicted protein', 136, NULL, NULL, 51470),
(51471, '3.40.50.2300-FF-001168', NULL, NULL, 157, NULL, NULL, 51471),
(51472, '3.40.630.30-FF-000223', NULL, 'GNAT family acetyltransferase, putative', 260, NULL, NULL, 51472),
(51473, '3.20.20.80-FF-000812', NULL, 'Uncharacterized protein', 110, NULL, NULL, 51473),
(51474, '1.10.630.10-FF-000708', NULL, 'Uncharacterized protein', 119, NULL, NULL, 51474),
(51475, '2.130.10.10-FF-001547', NULL, 'Nuclear distribution protein PAC1', 300, NULL, NULL, 51475),
(51476, '3.90.780.10-FF-000025', NULL, 'UDP-sugar hydrolase', 181, NULL, NULL, 51476),
(51477, '2.60.40.10-FF-004391', NULL, NULL, 63, NULL, NULL, 51477),
(51478, '2.60.40.10-FF-005728', NULL, NULL, 115, NULL, NULL, 51478),
(51479, '1.20.1740.10-FF-000091', NULL, 'Amino acid permease family protein', 425, NULL, NULL, 51479),
(51480, '3.40.50.410-FF-000164', NULL, 'LOC553407 protein', 87, NULL, NULL, 51480),
(51481, '2.30.29.30-FF-000589', NULL, 'disabled homolog 1 isoform X5', 87, NULL, NULL, 51481),
(51482, '3.30.160.60-FF-002507', NULL, NULL, 28, NULL, NULL, 51482),
(51483, '3.40.50.2000-FF-000797', NULL, 'Uncharacterized protein', 91, NULL, NULL, 51483),
(51484, '4.10.1240.10-FF-000029', NULL, 'PDF receptor isoform X3', 108, NULL, NULL, 51484),
(51485, '3.30.450.20-FF-000646', NULL, 'PAS sensor protein', 124, NULL, NULL, 51485),
(51486, '2.60.120.1540-FF-000014', NULL, 'MHC-linked complement C4', 61, NULL, NULL, 51486),
(51487, '1.10.510.10-FF-001695', NULL, 'Ribosomal protein S6 kinase', 149, NULL, NULL, 51487);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(51488, '1.10.520.10-FF-000032', NULL, 'Peroxidase', 97, NULL, NULL, 51488),
(51489, '3.40.50.2000-FF-000887', NULL, 'Chromosome 7, whole genome shotgun sequence', 276, NULL, NULL, 51489),
(51490, '3.30.70.2430-FF-000001', NULL, 'Fatty acid synthase subunit beta', 56, NULL, NULL, 51490),
(51491, '2.10.25.10-FF-000979', NULL, 'Delta-like protein', 43, NULL, NULL, 51491),
(51492, '3.50.50.60-FF-001375', NULL, 'Probable alkylhalidase homolog', 192, NULL, NULL, 51492),
(51493, '3.30.310.10-FF-000010', NULL, 'TATA-box-binding protein', 87, NULL, NULL, 51493),
(51494, '3.40.50.300-FF-006403', NULL, 'Uncharacterized protein', 133, NULL, NULL, 51494),
(51495, '3.30.420.40-FF-000414', NULL, 'Glycerol kinase, putative', 232, NULL, NULL, 51495),
(51496, '3.90.190.10-FF-000317', NULL, 'Uncharacterized protein', 306, NULL, NULL, 51496),
(51497, '2.40.50.90-FF-000077', NULL, 'Nuclease domain containing protein', 133, NULL, NULL, 51497),
(51498, '3.40.50.1460-FF-000096', NULL, 'Uncharacterized protein', 284, NULL, NULL, 51498),
(51499, '3.90.1480.20-FF-000033', NULL, 'Uncharacterized protein', 83, NULL, NULL, 51499),
(51500, '1.20.1510.10-FF-000079', NULL, NULL, 197, NULL, NULL, 51500),
(51501, '3.40.33.10-FF-000039', NULL, 'Predicted protein', 148, NULL, NULL, 51501),
(51502, '3.30.70.330-FF-001214', NULL, 'Peptidyl-prolyl cis-trans isomerase E, putative', 86, NULL, NULL, 51502),
(51503, '3.40.50.2000-FF-001106', NULL, 'Uncharacterized protein', 15, NULL, NULL, 51503),
(51504, '3.90.1200.10-FF-000015', NULL, 'Choline kinase', 285, NULL, NULL, 51504),
(51505, '1.20.58.2220-FF-000020', NULL, 'Formin-like protein', 386, NULL, NULL, 51505),
(51506, '1.20.1740.10-FF-000124', NULL, 'Y+L amino acid transporter 2', 84, NULL, NULL, 51506),
(51507, '1.10.10.10-FF-000442', NULL, 'Transcriptional activator CadC', 102, NULL, NULL, 51507),
(51508, '3.20.20.370-FF-000010', NULL, 'Carbohydrate deacetylase', 245, NULL, NULL, 51508),
(51509, '3.30.1130.10-FF-000017', NULL, '7,8-dihydroneopterin aldolase', 120, NULL, NULL, 51509),
(51510, '1.10.510.10-FF-003640', NULL, NULL, 189, NULL, NULL, 51510),
(51511, '1.50.40.10-FF-000240', NULL, 'WGS project CABT00000000 data, contig 2.3', 144, NULL, NULL, 51511),
(51512, '3.40.1160.10-FF-000096', NULL, 'Predicted protein', 191, NULL, NULL, 51512),
(51513, '3.30.1360.40-FF-000038', NULL, 'Ribosome-recycling factor, mitochondrial', 79, NULL, NULL, 51513),
(51514, '3.40.720.10-FF-000191', NULL, 'Protein CBG24051', 256, NULL, NULL, 51514),
(51515, '3.30.450.20-FF-000085', NULL, 'PAS domain-containing protein tyrosine kinase family protein', 106, NULL, NULL, 51515),
(51516, '3.30.70.330-FF-000938', NULL, 'Ribosome biogenesis (Nop4), putative', 112, NULL, NULL, 51516),
(51517, '1.25.10.10-FF-001696', NULL, 'Predicted protein', 271, NULL, NULL, 51517),
(51518, '3.40.1110.10-FF-000093', NULL, 'Phospholipid-transporting ATPase', 182, NULL, NULL, 51518),
(51519, '2.40.50.140-FF-000300', NULL, 'Replication protein A1, small', 129, NULL, NULL, 51519),
(51520, '3.30.70.2450-FF-000007', NULL, 'Oxidoreductase, putative', 80, NULL, NULL, 51520),
(51521, '1.10.287.370-FF-000097', NULL, 'Uncharacterized protein', 75, NULL, NULL, 51521),
(51522, '3.90.1200.10-FF-000072', NULL, 'Uncharacterized protein, isoform E', 32, NULL, NULL, 51522),
(51523, '3.40.50.300-FF-002132', NULL, 'Cytosolic Fe-S cluster assembly factor CFD1', 268, NULL, NULL, 51523),
(51524, '1.25.40.10-FF-003940', NULL, 'Clustered mitochondria protein homolog', 277, NULL, NULL, 51524),
(51525, '1.20.1110.10-FF-000239', NULL, NULL, 177, NULL, NULL, 51525),
(51526, '2.130.10.10-FF-000097', NULL, 'WD repeat domain 1', 319, NULL, NULL, 51526),
(51527, '3.40.50.720-FF-001156', NULL, 'Shikimate dehydrogenase (NADP(+))', 123, NULL, NULL, 51527),
(51528, '1.10.3080.10-FF-000042', NULL, 'Chloride channel protein', 170, NULL, NULL, 51528),
(51529, '1.10.1280.10-FF-000023', NULL, 'Uncharacterized protein', 336, NULL, NULL, 51529),
(51530, '1.25.40.10-FF-003558', NULL, 'Putative TPR repeat family protein', 260, NULL, NULL, 51530),
(51531, '1.10.287.70-FF-000670', NULL, 'Uncharacterized protein', 113, NULL, NULL, 51531);
INSERT INTO "PUBLIC"."MODEL" VALUES
(51532, '1.10.510.10-FF-003168', NULL, NULL, 166, NULL, NULL, 51532),
(51533, '3.40.1090.10-FF-000101', NULL, 'Uncharacterized protein', 224, NULL, NULL, 51533),
(51534, '2.40.50.690-FF-000004', NULL, 'DIS3-like exonuclease 1 isoform X1', 130, NULL, NULL, 51534),
(51535, '3.10.129.10-FF-000278', NULL, 'Acyl-CoA thioesterase 7', 63, NULL, NULL, 51535),
(51536, '2.60.40.10-FF-003750', NULL, NULL, 56, NULL, NULL, 51536),
(51537, '3.90.1140.10-FF-000010', NULL, 'RNA 2'',3''-cyclic phosphodiesterase', 179, NULL, NULL, 51537),
(51538, '4.10.240.10-FF-000139', NULL, 'C6 transcription factor, putative', 41, NULL, NULL, 51538),
(51539, '2.130.10.10-FF-003823', NULL, 'Uncharacterized WD repeat-containing protein C4F10.18', 393, NULL, NULL, 51539),
(51540, '4.10.860.120-FF-000001', NULL, 'DNA-directed RNA polymerase subunit beta', 121, NULL, NULL, 51540),
(51541, '1.10.10.10-FF-001813', NULL, 'Gll3293 protein', 76, NULL, NULL, 51541),
(51542, '2.70.150.10-FF-000109', NULL, 'Cation-transporting ATPase', 188, NULL, NULL, 51542),
(51543, '3.30.70.330-FF-003131', NULL, NULL, 85, NULL, NULL, 51543),
(51544, '1.10.10.60-FF-001188', NULL, NULL, 93, NULL, NULL, 51544),
(51545, '3.40.50.450-FF-000029', NULL, 'Diphosphate-fructose-6-phosphate 1-phosphotransferase', 173, NULL, NULL, 51545),
(51546, '3.10.20.90-FF-000315', NULL, 'Uncharacterized protein, isoform A', 111, NULL, NULL, 51546),
(51547, '1.20.1070.10-FF-000943', NULL, 'Uncharacterized protein', 290, NULL, NULL, 51547),
(51548, '3.40.630.30-FF-000346', NULL, 'N(alpha)-acetyltransferase 40, NatD catalytic subunit', 128, NULL, NULL, 51548),
(51549, '3.90.190.10-FF-000289', NULL, 'Uncharacterized protein', 189, NULL, NULL, 51549),
(51550, '3.30.160.60-FF-000473', NULL, 'zinc finger protein 14 homolog isoform X1', 29, NULL, NULL, 51550),
(51551, '1.25.40.10-FF-002035', NULL, 'Tetratricopeptide repeat domain 21B', 202, NULL, NULL, 51551),
(51552, '1.25.40.10-FF-001467', NULL, 'Serine/threonine protein phosphatase, putative', 119, NULL, NULL, 51552),
(51553, '2.60.40.1730-FF-000015', NULL, 'Transcription initiation factor TFIID subunit 2', 180, NULL, NULL, 51553),
(51554, '1.20.1250.10-FF-000036', NULL, 'Growth hormone d15', 215, NULL, NULL, 51554),
(51555, '1.20.1160.20-FF-000015', NULL, 'Regulator of telomere elongation helicase 1 homolog', 88, NULL, NULL, 51555),
(51556, '1.10.4030.10-FF-000005', NULL, 'Chaperone SurA', 127, NULL, NULL, 51556),
(51557, '1.20.1720.10-FF-000095', NULL, 'Uncharacterized protein', 252, NULL, NULL, 51557),
(51558, '4.10.1170.10-FF-000001', NULL, 'MAP kinase-activated protein kinase 3', 66, NULL, NULL, 51558),
(51559, '1.25.40.950-FF-000002', NULL, 'Arf-GAP with SH3 domain, ANK repeat and PH domain-containing protein 3', 74, NULL, NULL, 51559),
(51560, '2.60.40.10-FF-005936', NULL, NULL, 99, NULL, NULL, 51560),
(51561, '1.10.260.40-FF-000088', NULL, 'Mu phage transposase OrfB TnpB_MuSo2', 62, NULL, NULL, 51561),
(51562, '2.40.10.10-FF-000601', NULL, NULL, 127, NULL, NULL, 51562),
(51563, '3.30.505.10-FF-000041', NULL, 'Tyrosine-protein kinase', 124, NULL, NULL, 51563),
(51564, '1.10.1370.40-FF-000011', NULL, 'Putative cytosolic oligopeptidase A-like Protein', 270, NULL, NULL, 51564),
(51565, '1.10.540.10-FF-000123', NULL, 'Acryloyl-CoA reductase (NADH)', 128, NULL, NULL, 51565),
(51566, '3.30.460.10-FF-000026', NULL, 'Protein Iojap, chloroplastic', 106, NULL, NULL, 51566),
(51567, '1.10.565.10-FF-000107', NULL, 'Uncharacterized protein', 220, NULL, NULL, 51567),
(51568, '1.25.40.120-FF-000079', NULL, 'Uncharacterized protein', 384, NULL, NULL, 51568),
(51569, '1.10.10.10-FF-001864', NULL, 'Uncharacterized protein', 70, NULL, NULL, 51569),
(51570, '1.25.40.10-FF-002895', NULL, 'Predicted protein', 211, NULL, NULL, 51570),
(51571, '2.60.40.10-FF-003845', NULL, NULL, 117, NULL, NULL, 51571),
(51572, '1.10.510.10-FF-004415', NULL, NULL, 76, NULL, NULL, 51572),
(51573, '1.20.5.390-FF-000006', NULL, 'Early endosome antigen 1', 57, NULL, NULL, 51573),
(51574, '3.10.20.90-FF-000366', NULL, 'Raf homolog serine/threonine-protein kinase', 88, NULL, NULL, 51574);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(51575, '3.40.50.2300-FF-000792', NULL, NULL, 103, NULL, NULL, 51575),
(51576, '3.50.50.60-FF-001515', NULL, 'Uncharacterized protein', 85, NULL, NULL, 51576),
(51577, '3.30.160.60-FF-001996', NULL, 'Zinc finger protein 398', 29, NULL, NULL, 51577),
(51578, '2.60.120.970-FF-000012', NULL, 'inhibin beta B chain', 225, NULL, NULL, 51578),
(51579, '1.20.1440.230-FF-000003', NULL, 'NADH-quinone oxidoreductase subunit F', 93, NULL, NULL, 51579),
(51580, '1.20.1250.20-FF-001028', NULL, 'Solute carrier family 16 member 14', 191, NULL, NULL, 51580),
(51581, '3.30.565.10-FF-000112', NULL, 'Two-component system sensor kinase', 163, NULL, NULL, 51581),
(51582, '2.130.10.10-FF-002300', NULL, 'WD40 repeat-like protein', 140, NULL, NULL, 51582),
(51583, '3.90.228.10-FF-000057', NULL, 'Predicted protein', 166, NULL, NULL, 51583),
(51584, '3.30.420.40-FF-000302', NULL, 'Actin-like protein ARP9', 191, NULL, NULL, 51584),
(51585, '1.20.920.30-FF-000010', NULL, 'Dynein heavy chain family protein', 195, NULL, NULL, 51585),
(51586, '1.25.10.10-FF-000184', NULL, 'HEAT repeat-containing protein 5B', 266, NULL, NULL, 51586),
(51587, '3.40.50.300-FF-007477', NULL, 'Brefeldin A resistance protein', 237, NULL, NULL, 51587),
(51588, '3.40.50.720-FF-001482', NULL, 'YALI0E19657p', 147, NULL, NULL, 51588),
(51589, '3.30.160.60-FF-005318', NULL, NULL, 31, NULL, NULL, 51589),
(51590, '1.10.8.50-FF-000037', NULL, 'Uncharacterized protein YloA', 69, NULL, NULL, 51590),
(51591, '2.130.10.10-FF-001199', NULL, 'Probable cytosolic iron-sulfur protein assembly protein 1', 207, NULL, NULL, 51591),
(51592, '2.40.30.10-FF-000131', NULL, 'NADPH-dependent ferric siderophore reductase', 131, NULL, NULL, 51592),
(51593, '3.80.10.10-FF-003161', NULL, 'F-box and leucine-rich repeat protein 4', 282, NULL, NULL, 51593),
(51594, '3.40.850.10-FF-000464', NULL, 'Kinesin-like protein', 370, NULL, NULL, 51594),
(51595, '3.30.200.20-FF-001645', NULL, 'Protein kinase, putative', 89, NULL, NULL, 51595),
(51596, '2.130.10.10-FF-005852', NULL, 'Predicted protein', 327, NULL, NULL, 51596),
(51597, '1.10.3860.10-FF-000017', NULL, 'Amino acid transporter', 397, NULL, NULL, 51597),
(51598, '3.90.132.10-FF-000003', NULL, 'GP63-like', 132, NULL, NULL, 51598),
(51599, '3.80.10.10-FF-001070', NULL, 'Leucine-rich repeat transmembrane protein kinase', 203, NULL, NULL, 51599),
(51600, '3.40.50.300-FF-002429', NULL, 'Dynein heavy chain, putative', 193, NULL, NULL, 51600),
(51601, '2.170.150.20-FF-000010', NULL, 'Protein yippee-like', 122, NULL, NULL, 51601),
(51602, '3.30.40.10-FF-001006', NULL, 'Expressed protein', 94, NULL, NULL, 51602),
(51603, '1.20.120.350-FF-000044', NULL, 'Potassium voltage-gated channel subfamily V member 1', 148, NULL, NULL, 51603),
(51604, '1.10.238.10-FF-000600', NULL, 'Probable calcium-binding protein CML12', 154, NULL, NULL, 51604),
(51605, '1.50.40.10-FF-000291', NULL, 'Flavin adenine dinucleotide transporter', 75, NULL, NULL, 51605),
(51606, '3.20.20.60-FF-000071', NULL, 'Citryl-CoA lyase', 269, NULL, NULL, 51606),
(51607, '1.10.630.10-FF-000568', NULL, 'Uncharacterized protein', 320, NULL, NULL, 51607),
(51608, '1.20.120.1160-FF-000002', NULL, 'Minor nucleoprotein VP30', 159, NULL, NULL, 51608),
(51609, '1.10.287.1490-FF-000063', NULL, 'Viral A-type inclusion protein, putative', 150, NULL, NULL, 51609),
(51610, '3.40.50.720-FF-000925', NULL, 'Putative NAD dependent epimerase/dehydratase', 261, NULL, NULL, 51610),
(51611, '2.60.40.10-FF-002322', NULL, 'macrophage colony-stimulating factor 1 receptor', 108, NULL, NULL, 51611),
(51612, '1.10.510.10-FF-002712', NULL, NULL, 217, NULL, NULL, 51612),
(51613, '1.20.910.10-FF-000026', NULL, 'Transcriptional activator (TenA-2)', 221, NULL, NULL, 51613),
(51614, '2.20.110.10-FF-000068', NULL, NULL, 46, NULL, NULL, 51614),
(51615, '1.25.40.10-FF-002361', NULL, 'Pentatricopeptide repeat-containing protein', 112, NULL, NULL, 51615),
(51616, '4.10.400.10-FF-000293', NULL, 'LDL receptor-related protein 6', 35, NULL, NULL, 51616),
(51617, '2.120.10.30-FF-000305', NULL, 'Uncharacterized protein', 113, NULL, NULL, 51617);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(51618, '3.80.10.10-FF-002267', NULL, 'Uncharacterized protein', 101, NULL, NULL, 51618),
(51619, '3.40.50.300-FF-004346', NULL, 'ATPases involved in chromosome partitioning', 246, NULL, NULL, 51619),
(51620, '3.40.20.10-FF-000139', NULL, 'YALI0E34687p', 131, NULL, NULL, 51620),
(51621, '3.30.70.100-FF-000162', NULL, NULL, 74, NULL, NULL, 51621),
(51622, '2.60.40.10-FF-004413', NULL, NULL, 99, NULL, NULL, 51622),
(51623, '3.40.30.10-FF-000651', NULL, 'Thio-Specific Antioxidant (TSA) Peroxidase', 194, NULL, NULL, 51623),
(51624, '1.20.1560.10-FF-000913', NULL, 'ATP binding cassette subfamily B member 8', 138, NULL, NULL, 51624),
(51625, '3.80.10.10-FF-002946', NULL, 'Uncharacterized protein', 236, NULL, NULL, 51625),
(51626, '3.40.630.20-FF-000017', NULL, 'Pyroglutamyl-peptidase I (PGP), putative', 215, NULL, NULL, 51626),
(51627, '1.25.10.10-FF-002207', NULL, '26S proteasome regulatory subunit rpn1', 432, NULL, NULL, 51627),
(51628, '3.40.50.10810-FF-000022', NULL, 'Blast:Putative DNA helicase Ino80', 272, NULL, NULL, 51628),
(51629, '3.30.60.30-FF-000092', NULL, 'AGRin (Synaptic protein) homolog', 68, NULL, NULL, 51629),
(51630, '3.80.10.10-FF-003514', NULL, 'Uncharacterized protein', 177, NULL, NULL, 51630),
(51631, '3.40.50.200-FF-000101', NULL, 'Peptidase S8 and S53 subtilisin kexin sedolisin', 378, NULL, NULL, 51631),
(51632, '3.40.50.10190-FF-000347', NULL, 'ADL145Cp', 121, NULL, NULL, 51632),
(51633, '2.30.30.140-FF-000085', NULL, 'Tudor domain-containing protein 6', 67, NULL, NULL, 51633),
(51634, '3.50.50.60-FF-000998', NULL, 'Putative bifunctional amine oxidase DDB_G0291301', 219, NULL, NULL, 51634),
(51635, '3.90.190.10-FF-000582', NULL, 'Protein tyrosine phosphatase, receptor type, A', 191, NULL, NULL, 51635),
(51636, '3.80.10.10-FF-003110', NULL, 'Uncharacterized protein', 105, NULL, NULL, 51636),
(51637, '4.10.400.10-FF-000079', NULL, 'Low-density lipoprotein receptor-related protein 1B', 33, NULL, NULL, 51637),
(51638, '2.60.40.10-FF-000405', NULL, 'nephrin isoform X1', 97, NULL, NULL, 51638),
(51639, '1.25.40.700-FF-000006', NULL, 'Predicted protein', 96, NULL, NULL, 51639),
(51640, '1.20.1280.50-FF-000235', NULL, 'Uncharacterized protein', 41, NULL, NULL, 51640),
(51641, '3.20.20.140-FF-000093', NULL, 'Adenosine deaminase', 334, NULL, NULL, 51641),
(51642, '3.90.70.10-FF-000044', NULL, 'Ubiquitin carboxyl-terminal hydrolase 13', 329, NULL, NULL, 51642),
(51643, '1.20.1250.20-FF-000365', NULL, 'chromaffin granule amine transporter isoform X2', 163, NULL, NULL, 51643),
(51644, '3.30.360.10-FF-000142', NULL, 'Uncharacterized protein', 72, NULL, NULL, 51644),
(51645, '3.30.9.10-FF-000259', NULL, 'Uncharacterized protein', 159, NULL, NULL, 51645),
(51646, '3.40.710.10-FF-000066', NULL, 'Penicillin-binding membrane protein PbpB', 194, NULL, NULL, 51646),
(51647, '2.80.10.50-FF-000139', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 146, NULL, NULL, 51647),
(51648, '3.30.70.240-FF-000057', NULL, 'Uncharacterized protein', 99, NULL, NULL, 51648),
(51649, '2.30.130.10-FF-000011', NULL, 'Glutamate 5-kinase', 94, NULL, NULL, 51649),
(51650, '3.30.830.10-FF-000212', NULL, 'Peptidase family protein', 202, NULL, NULL, 51650),
(51651, '2.60.120.970-FF-000107', NULL, 'Uncharacterized protein', 195, NULL, NULL, 51651),
(51652, '2.60.40.10-FF-003896', NULL, NULL, 105, NULL, NULL, 51652),
(51653, '2.60.40.10-FF-005548', NULL, NULL, 118, NULL, NULL, 51653),
(51654, '2.60.40.150-FF-000263', NULL, 'Regulator of G-protein signaling 3', 153, NULL, NULL, 51654),
(51655, '1.20.1640.10-FF-000094', NULL, 'Multifunctional fusion protein', 211, NULL, NULL, 51655),
(51656, '1.10.8.60-FF-000192', NULL, 'Fis family transcriptional regulator', 75, NULL, NULL, 51656),
(51657, '2.60.40.10-FF-002390', NULL, 'Muscle M-line assembly protein unc-89', 91, NULL, NULL, 51657),
(51658, '2.60.120.290-FF-000168', NULL, 'Uncharacterized protein', 119, NULL, NULL, 51658),
(51659, '1.10.10.10-FF-001538', NULL, 'Uncharacterized protein', 86, NULL, NULL, 51659),
(51660, '3.40.50.300-FF-000305', NULL, 'CTP synthase', 292, NULL, NULL, 51660); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(51661, '3.40.50.2300-FF-001129', NULL, 'Uncharacterized protein', 245, NULL, NULL, 51661),
(51662, '1.10.860.10-FF-000018', NULL, 'DNA primase', 144, NULL, NULL, 51662),
(51663, '1.10.630.10-FF-000473', NULL, 'Probable cytochrome P450 522A1', 466, NULL, NULL, 51663),
(51664, '4.10.1000.10-FF-000068', NULL, 'Zinc finger C-x8-C-x5-C-x3-H type (And similar), putative', 97, NULL, NULL, 51664),
(51665, '3.40.640.10-FF-000004', NULL, 'Acetylornithine aminotransferase', 248, NULL, NULL, 51665),
(51666, '1.20.1440.240-FF-000006', NULL, 'Putative L-amino-acid oxidase YobN', 105, NULL, NULL, 51666),
(51667, '2.60.40.3210-FF-000032', NULL, 'Uncharacterized protein', 104, NULL, NULL, 51667),
(51668, '1.10.287.110-FF-000160', NULL, 'Chaperone protein DnaJ', 114, NULL, NULL, 51668),
(51669, '2.40.10.120-FF-000005', NULL, 'Genome polyprotein', 59, NULL, NULL, 51669),
(51670, '1.20.1080.10-FF-000011', NULL, 'Formate family transporter', 261, NULL, NULL, 51670),
(51671, '3.30.70.240-FF-000006', NULL, 'Elongation factor like GTPase 1', 135, NULL, NULL, 51671),
(51672, '1.25.10.10-FF-001718', NULL, 'YALI0D16841p', 218, NULL, NULL, 51672),
(51673, '3.90.550.10-FF-000340', NULL, 'CMP-sialic acid synthase', 184, NULL, NULL, 51673),
(51674, '3.10.280.10-FF-000005', NULL, 'Glycoprotein gC1qBP, putative', 198, NULL, NULL, 51674),
(51675, '2.60.40.200-FF-000025', NULL, 'Uncharacterized protein', 154, NULL, NULL, 51675),
(51676, '1.10.10.200-FF-000012', NULL, 'Uncharacterized protein', 81, NULL, NULL, 51676),
(51677, '3.40.250.10-FF-000261', NULL, 'Tyrosine protein phosphatase', 163, NULL, NULL, 51677),
(51678, '3.40.50.10810-FF-000134', NULL, 'Uncharacterized protein', 270, NULL, NULL, 51678),
(51679, '1.10.60.10-FF-000001', NULL, 'Iron dependent repressor', 63, NULL, NULL, 51679),
(51680, '3.30.160.60-FF-006133', NULL, NULL, 76, NULL, NULL, 51680),
(51681, '1.25.10.10-FF-000116', NULL, 'importin-11 isoform X1', 968, NULL, NULL, 51681),
(51682, '3.80.20.20-FF-000005', NULL, 'Receptor protein-tyrosine kinase', 198, NULL, NULL, 51682),
(51683, '3.30.160.60-FF-005644', NULL, NULL, 58, NULL, NULL, 51683),
(51684, '3.30.310.50-FF-000010', NULL, 'Phosphoglucomutase', 131, NULL, NULL, 51684),
(51685, '1.10.510.10-FF-001774', NULL, 'Uncharacterized protein', 152, NULL, NULL, 51685),
(51686, '3.80.10.10-FF-000934', NULL, 'Leucine-rich repeat protein kinase family protein', 51, NULL, NULL, 51686),
(51687, '3.90.640.90-FF-000022', NULL, 'Predicted protein', 119, NULL, NULL, 51687),
(51688, '3.40.140.70-FF-000017', NULL, 'Uncharacterized protein', 45, NULL, NULL, 51688),
(51689, '3.40.630.70-FF-000004', NULL, 'Leucyl/phenylalanyl-tRNA--protein transferase', 177, NULL, NULL, 51689),
(51690, '1.20.5.1040-FF-000003', NULL, 'Sensor protein QseC', 62, NULL, NULL, 51690),
(51691, '2.10.25.10-FF-000659', NULL, 'Crumbs cell polarity complex component 2b', 40, NULL, NULL, 51691),
(51692, '2.10.90.10-FF-000118', NULL, 'Vascular endothelial growth factor-like protein', 100, NULL, NULL, 51692),
(51693, '3.60.21.10-FF-000275', NULL, 'Sphingomyelin phosphodiesterase A', 98, NULL, NULL, 51693),
(51694, '3.30.870.10-FF-000107', NULL, 'Phospholipase D endonuclease superfamily', 59, NULL, NULL, 51694),
(51695, '3.40.50.200-FF-000152', NULL, 'Collagenolytic serine protease', 330, NULL, NULL, 51695),
(51696, '3.40.50.410-FF-000338', NULL, 'Predicted protein', 149, NULL, NULL, 51696),
(51697, '1.10.510.10-FF-001723', NULL, 'Mitogen-activated protein kinase', 57, NULL, NULL, 51697),
(51698, '3.30.9.10-FF-000164', NULL, 'Uncharacterized protein', 28, NULL, NULL, 51698),
(51699, '3.55.50.30-FF-000012', NULL, 'Probable transmembrane sensor', 76, NULL, NULL, 51699),
(51700, '1.20.58.390-FF-000118', NULL, 'GABA-gated ion channel', 68, NULL, NULL, 51700),
(51701, '2.20.25.530-FF-000003', NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', 73, NULL, NULL, 51701),
(51702, '2.40.50.120-FF-000053', NULL, 'Predicted protein', 121, NULL, NULL, 51702),
(51703, '3.30.70.1660-FF-000012', NULL, 'Peptide chain release factor 1', 131, NULL, NULL, 51703);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(51704, '3.30.1370.30-FF-000007', NULL, 'Related to MRPS8-mitochondrial ribosomal protein, small subunit', 83, NULL, NULL, 51704),
(51705, '4.10.1250.10-FF-000002', NULL, 'Aminomethyltransferase', 45, NULL, NULL, 51705),
(51706, '1.25.40.10-FF-003463', NULL, 'Pentatricopeptide repeat-containing protein', 105, NULL, NULL, 51706),
(51707, '2.40.50.140-FF-001048', NULL, NULL, 115, NULL, NULL, 51707),
(51708, '1.20.1250.20-FF-000932', NULL, 'Uncharacterized protein', 223, NULL, NULL, 51708),
(51709, '1.20.120.350-FF-000095', NULL, 'Voltage-gated Ca2+ channel, alpha subunit', 121, NULL, NULL, 51709),
(51710, '3.30.200.20-FF-001533', NULL, 'Predicted protein', 113, NULL, NULL, 51710),
(51711, '2.40.30.10-FF-000243', NULL, 'Methionine synthase reductase', 91, NULL, NULL, 51711),
(51712, '2.40.50.230-FF-000001', NULL, 'Type VI secretion protein VgrG', 103, NULL, NULL, 51712),
(51713, '3.40.50.150-FF-000097', NULL, 'tRNA (adenine(58)-N(1))-methyltransferase catalytic subunit TRMT61A', 225, NULL, NULL, 51713),
(51714, '3.10.20.30-FF-000051', NULL, 'Possible oxygenase', 96, NULL, NULL, 51714),
(51715, '3.40.50.300-FF-008320', NULL, 'Predicted protein', 248, NULL, NULL, 51715),
(51716, '3.30.70.250-FF-000009', NULL, 'Malonyl-CoA:ACP transferase', 81, NULL, NULL, 51716),
(51717, '2.40.50.140-FF-001109', NULL, NULL, 81, NULL, NULL, 51717),
(51718, '2.60.40.10-FF-001507', NULL, 'tyrosine-protein phosphatase 10D isoform X2', 98, NULL, NULL, 51718),
(51719, '1.25.10.10-FF-001870', NULL, 'Integrator complex subunit 4 homolog', 149, NULL, NULL, 51719),
(51720, '3.30.200.20-FF-001319', NULL, 'Interleukin-1 receptor-associated kinase 4', 105, NULL, NULL, 51720),
(51721, '1.50.40.10-FF-000414', NULL, 'MIP14680p', 203, NULL, NULL, 51721),
(51722, '3.40.50.1440-FF-000112', NULL, 'Uncharacterized protein', 117, NULL, NULL, 51722),
(51723, '3.40.50.2000-FF-001084', NULL, 'Sulfoquinovosyl transferase SQD2', 116, NULL, NULL, 51723),
(51724, '3.30.230.70-FF-000015', NULL, 'Exosome complex component RRP41-like', 240, NULL, NULL, 51724),
(51725, '3.40.50.2000-FF-000595', NULL, 'UDP-glucuronosyltransferase', 174, NULL, NULL, 51725),
(51726, '1.25.40.10-FF-001372', NULL, 'Pentatricopeptide repeat-containing protein At4g21300', 169, NULL, NULL, 51726),
(51727, '3.20.20.190-FF-000079', NULL, 'POGO family transposase, putative', 259, NULL, NULL, 51727),
(51728, '3.30.310.80-FF-000019', NULL, 'Non-specific serine/threonine protein kinase', 100, NULL, NULL, 51728),
(51729, '2.10.70.10-FF-000286', NULL, 'Uncharacterized protein', 59, NULL, NULL, 51729),
(51730, '3.90.190.10-FF-000082', NULL, 'Serine/threonine/tyrosine-interacting-like protein 1', 152, NULL, NULL, 51730),
(51731, '3.90.79.10-FF-000064', NULL, 'GDP-mannose mannosyl hydrolase', 159, NULL, NULL, 51731),
(51732, '3.40.30.10-FF-000763', NULL, 'Glutathione S-transferase kappa', 194, NULL, NULL, 51732),
(51733, '1.10.10.1050-FF-000020', NULL, 'Decapping enzyme complex catalytic component', 94, NULL, NULL, 51733),
(51734, '2.60.120.10-FF-000150', NULL, 'Spherulin, putative', 178, NULL, NULL, 51734),
(51735, '3.30.230.80-FF-000018', NULL, 'Heat Shock Protein', 174, NULL, NULL, 51735),
(51736, '2.130.10.10-FF-005526', NULL, 'Uncharacterized protein', 22, NULL, NULL, 51736),
(51737, '3.30.700.20-FF-000003', NULL, 'Uncharacterized protein, PH0010 family/AmmeMemoRadiSam system protein A, putative', 90, NULL, NULL, 51737),
(51738, '3.40.50.150-FF-001457', NULL, NULL, 139, NULL, NULL, 51738),
(51739, '3.40.1280.30-FF-000021', NULL, 'tRNA (guanineN(1)-)-methyltransferase', 92, NULL, NULL, 51739),
(51740, '3.40.50.2300-FF-001404', NULL, NULL, 123, NULL, NULL, 51740),
(51741, '3.80.10.10-FF-004296', NULL, 'Uncharacterized protein', 230, NULL, NULL, 51741),
(51742, '3.40.630.60-FF-000001', NULL, 'Ornithine decarboxylase antizyme 1', 134, NULL, NULL, 51742),
(51743, '3.30.60.30-FF-000041', NULL, 'agrin isoform X5', 68, NULL, NULL, 51743),
(51744, '2.60.120.290-FF-000117', NULL, 'Complement factor D, putative', 119, NULL, NULL, 51744),
(51745, '1.20.1250.20-FF-001354', NULL, 'Predicted protein', 202, NULL, NULL, 51745);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(51746, '1.25.40.20-FF-001375', NULL, 'Uncharacterized protein', 82, NULL, NULL, 51746),
(51747, '3.40.1340.10-FF-000014', NULL, 'Putative DNA-directed RNA polymerase II', 109, NULL, NULL, 51747),
(51748, '2.60.40.10-FF-000147', NULL, 'Myosin light chain kinase', 98, NULL, NULL, 51748),
(51749, '2.30.39.10-FF-000027', NULL, 'Serpin peptidase inhibitor 29', 151, NULL, NULL, 51749),
(51750, '1.10.510.10-FF-000700', NULL, 'CMGC/RCK protein kinase', 230, NULL, NULL, 51750),
(51751, '2.80.10.50-FF-000061', NULL, 'Protein FRG1', 153, NULL, NULL, 51751),
(51752, '2.10.90.10-FF-000169', NULL, 'Uncharacterized protein', 92, NULL, NULL, 51752),
(51753, '1.10.420.10-FF-000030', NULL, 'Peroxidase', 121, NULL, NULL, 51753),
(51754, '3.40.50.410-FF-000097', NULL, 'Protein transport protein Sec24-like CEF', 241, NULL, NULL, 51754),
(51755, '1.20.1560.10-FF-000790', NULL, 'Uncharacterized protein', 227, NULL, NULL, 51755),
(51756, '1.10.1200.10-FF-000131', NULL, 'Nonribosomal peptide synthase inpB', 73, NULL, NULL, 51756),
(51757, '3.40.50.1010-FF-000039', NULL, 'rRNA-processing protein FCF1 family protein', 143, NULL, NULL, 51757),
(51758, '1.25.40.10-FF-003384', NULL, 'Pentatricopeptide repeat-containing protein At2g37230', 147, NULL, NULL, 51758),
(51759, '2.60.40.2860-FF-000028', NULL, 'Sporozoite surface protein P36p', 124, NULL, NULL, 51759),
(51760, '3.40.1350.60-FF-000007', NULL, 'Uncharacterized protein', 220, NULL, NULL, 51760),
(51761, '2.10.25.10-FF-000890', NULL, 'Notch, isoform B', 44, NULL, NULL, 51761),
(51762, '3.10.20.90-FF-000580', NULL, 'Ubiquitin-2_like_Rad60_SUMO-like_-_putative', 112, NULL, NULL, 51762),
(51763, '3.90.190.10-FF-000177', NULL, 'Protein tyrosine phosphatase TpbA', 162, NULL, NULL, 51763),
(51764, '2.60.40.60-FF-000701', NULL, 'Predicted protein', 102, NULL, NULL, 51764),
(51765, '1.10.472.130-FF-000003', NULL, 'Dynein, axonemal, heavy chain 2', 145, NULL, NULL, 51765),
(51766, '2.10.25.10-FF-001502', NULL, 'Reelin', 30, NULL, NULL, 51766),
(51767, '1.20.1310.10-FF-000007', NULL, 'Cullin 1', 114, NULL, NULL, 51767),
(51768, '3.40.910.10-FF-000014', NULL, 'Deoxyhypusine synthase', 165, NULL, NULL, 51768),
(51769, '2.60.120.470-FF-000019', NULL, NULL, 173, NULL, NULL, 51769),
(51770, '3.40.50.1000-FF-000036', NULL, 'HAD family hydrolase', 127, NULL, NULL, 51770),
(51771, '2.60.40.10-FF-005762', NULL, NULL, 51, NULL, NULL, 51771),
(51772, '3.40.50.200-FF-000073', NULL, 'Peptidase S8 and S53 subtilisin kexin sedolisin', 365, NULL, NULL, 51772),
(51773, '2.60.120.200-FF-000809', NULL, 'Predicted protein', 258, NULL, NULL, 51773),
(51774, '2.120.10.100-FF-000002', NULL, 'Apyrase, putative', 327, NULL, NULL, 51774),
(51775, '3.40.50.300-FF-000182', NULL, 'ras-related protein Rap-1b', 167, NULL, NULL, 51775),
(51776, '1.10.1070.11-FF-000020', NULL, 'Serine/threonine-protein kinase TOR', 173, NULL, NULL, 51776),
(51777, '2.20.100.10-FF-000028', NULL, 'R-spondin 2', 51, NULL, NULL, 51777),
(51778, '1.10.472.140-FF-000006', NULL, 'Cell cycle regulator p107, putative', 159, NULL, NULL, 51778),
(51779, '2.40.50.700-FF-000013', NULL, NULL, 75, NULL, NULL, 51779),
(51780, '2.10.25.10-FF-001053', NULL, 'Slit homolog 1b (Drosophila)', 41, NULL, NULL, 51780),
(51781, '1.10.510.10-FF-001835', NULL, 'Casein kinase 1 isoform 2, putative', 335, NULL, NULL, 51781),
(51782, '2.30.110.10-FF-000009', NULL, 'PPOX class F420-dependent enzyme', 133, NULL, NULL, 51782),
(51783, '2.10.25.10-FF-000485', NULL, 'Epidermal growth factor-like protein 7', 66, NULL, NULL, 51783),
(51784, '1.25.10.10-FF-001218', NULL, 'Predicted protein', 285, NULL, NULL, 51784),
(51785, '1.10.510.10-FF-004011', NULL, NULL, 132, NULL, NULL, 51785),
(51786, '3.10.105.10-FF-000122', NULL, '4-phytase', 204, NULL, NULL, 51786),
(51787, '1.20.1070.10-FF-001202', NULL, 'Uncharacterized protein', 132, NULL, NULL, 51787),
(51788, '2.40.10.10-FF-000034', NULL, 'Eupolytin', 232, NULL, NULL, 51788),
(51789, '3.30.505.10-FF-000215', NULL, NULL, 109, NULL, NULL, 51789),
(51790, '1.20.58.390-FF-000332', NULL, 'Uncharacterized protein', 74, NULL, NULL, 51790);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(51791, '3.40.50.150-FF-000322', NULL, 'Protein arginine N-methyltransferase', 82, NULL, NULL, 51791),
(51792, '2.60.40.10-FF-001833', NULL, 'Uncharacterized protein, isoform A', 96, NULL, NULL, 51792),
(51793, '1.10.150.250-FF-000011', NULL, NULL, 80, NULL, NULL, 51793),
(51794, '3.90.550.10-FF-000014', NULL, 'Glucose-1-phosphate adenylyltransferase', 300, NULL, NULL, 51794),
(51795, '3.30.497.10-FF-000150', NULL, 'Serpin family C member 1', 77, NULL, NULL, 51795),
(51796, '3.30.1490.20-FF-000070', NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta, mitochondrial', 98, NULL, NULL, 51796),
(51797, '1.10.630.10-FF-000647', NULL, 'Uncharacterized protein', 208, NULL, NULL, 51797),
(51798, '3.40.50.300-FF-006988', NULL, 'Predicted protein', 214, NULL, NULL, 51798),
(51799, '2.10.25.10-FF-000159', NULL, 'Fibrillin 2', 37, NULL, NULL, 51799),
(51800, '3.40.1000.50-FF-000023', NULL, 'Uncharacterized protein', 156, NULL, NULL, 51800),
(51801, '2.10.60.10-FF-000049', NULL, 'Serine/threonine-protein kinase receptor', 55, NULL, NULL, 51801),
(51802, '2.70.170.10-FF-000111', NULL, 'Uncharacterized protein', 163, NULL, NULL, 51802),
(51803, '3.60.21.50-FF-000028', NULL, 'DNA polymerase delta small subunit-like Protein', 63, NULL, NULL, 51803),
(51804, '1.10.575.10-FF-000018', NULL, 'Uncharacterized protein', 266, NULL, NULL, 51804),
(51805, '3.30.420.40-FF-000274', NULL, 'Glucose kinase', 112, NULL, NULL, 51805),
(51806, '3.30.200.20-FF-000010', NULL, 'Serine/threonine-protein kinase WNK1 isoform 2', 94, NULL, NULL, 51806),
(51807, '1.25.40.470-FF-000072', NULL, 'Cotamer alpha, putative', 183, NULL, NULL, 51807),
(51808, '3.90.70.80-FF-000037', NULL, 'OTU domain-containing protein', 113, NULL, NULL, 51808),
(51809, '3.40.50.300-FF-005706', NULL, 'SNF2 DNA repair protein, putative', 173, NULL, NULL, 51809),
(51810, '1.20.1070.10-FF-001820', NULL, 'Uncharacterized protein', 309, NULL, NULL, 51810),
(51811, '1.20.140.150-FF-000134', NULL, 'Uncharacterized protein', 82, NULL, NULL, 51811),
(51812, '3.30.1360.70-FF-000002', NULL, 'arginine--tRNA ligase, cytoplasmic', 110, NULL, NULL, 51812),
(51813, '3.80.10.10-FF-000581', NULL, 'Leucine Rich Repeat family protein, expressed', 172, NULL, NULL, 51813),
(51814, '2.130.10.10-FF-005414', NULL, 'Serine/threonine-protein kinase ppk4', 287, NULL, NULL, 51814),
(51815, '2.10.70.10-FF-000174', NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing 1', 58, NULL, NULL, 51815),
(51816, '3.30.530.20-FF-000006', NULL, 'StAR-related lipid transfer protein 7, mitochondrial', 214, NULL, NULL, 51816),
(51817, '2.130.10.130-FF-000060', NULL, NULL, 86, NULL, NULL, 51817),
(51818, '3.30.40.10-FF-001074', NULL, 'RING finger protein 5', 72, NULL, NULL, 51818),
(51819, '2.160.20.10-FF-000023', NULL, 'Exo-beta-1,3-glucanase Exg0', 373, NULL, NULL, 51819),
(51820, '3.60.40.10-FF-000246', NULL, 'TipA', 246, NULL, NULL, 51820),
(51821, '1.10.418.20-FF-000022', NULL, 'Uncharacterized protein', 45, NULL, NULL, 51821),
(51822, '2.60.120.620-FF-000019', NULL, '2-oxoglutarate and iron-dependent oxygenase domain-containing protein 3', 212, NULL, NULL, 51822),
(51823, '1.20.120.350-FF-000218', NULL, NULL, 73, NULL, NULL, 51823),
(51824, '3.40.50.150-FF-001783', NULL, NULL, 184, NULL, NULL, 51824),
(51825, '2.60.470.10-FF-000029', NULL, 'Pickpocket 30, isoform A', 126, NULL, NULL, 51825),
(51826, '3.60.20.10-FF-000037', NULL, 'Asparagine synthetase B', 192, NULL, NULL, 51826),
(51827, '1.20.1050.80-FF-000002', NULL, 'Ras and Rab interactor 2', 154, NULL, NULL, 51827),
(51828, '2.60.200.20-FF-000136', NULL, 'Serine/threonine-protein kinase Chk2', 71, NULL, NULL, 51828),
(51829, '3.80.10.10-FF-003402', NULL, 'Uncharacterized protein', 92, NULL, NULL, 51829),
(51830, '1.25.10.10-FF-002033', NULL, 'Microtubule associated protein', 225, NULL, NULL, 51830),
(51831, '1.10.510.10-FF-004062', NULL, NULL, 199, NULL, NULL, 51831),
(51832, '2.60.40.10-FF-005318', NULL, NULL, 78, NULL, NULL, 51832),
(51833, '3.30.450.350-FF-000007', NULL, 'Sensor histidine kinase, CHASE domain-containing', 126, NULL, NULL, 51833);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(51834, '3.30.40.10-FF-000843', NULL, 'E3 ubiquitin-protein ligase PEP5', 121, NULL, NULL, 51834),
(51835, '3.30.1480.10-FF-000010', NULL, 'Transcription termination/antitermination protein NusA', 123, NULL, NULL, 51835),
(51836, '1.10.3060.10-FF-000007', NULL, 'Protein translocase subunit SecA', 218, NULL, NULL, 51836),
(51837, '3.20.20.190-FF-000107', NULL, NULL, 116, NULL, NULL, 51837),
(51838, '1.20.1560.10-FF-000638', NULL, 'Uncharacterized protein', 178, NULL, NULL, 51838),
(51839, '3.20.20.140-FF-000385', NULL, 'Uncharacterized protein', 176, NULL, NULL, 51839),
(51840, '2.60.40.10-FF-000473', NULL, 'WAP, Kazal, immunoglobulin, Kunitz and NTR domain-containing protein 2', 100, NULL, NULL, 51840),
(51841, '2.40.20.10-FF-000124', NULL, 'Uncharacterized protein', 55, NULL, NULL, 51841),
(51842, '3.30.300.20-FF-000074', NULL, 'Ribosome-binding factor A', 112, NULL, NULL, 51842),
(51843, '1.50.40.10-FF-000386', NULL, 'Calcium-binding mitochondrial carrier protein SCaMC-2', 284, NULL, NULL, 51843),
(51844, '2.60.40.1670-FF-000036', NULL, NULL, 59, NULL, NULL, 51844),
(51845, '3.30.230.10-FF-000189', NULL, 'Lon protease homolog, mitochondrial', 201, NULL, NULL, 51845),
(51846, '2.60.40.1260-FF-000003', NULL, 'Intermediate filament protein A', 145, NULL, NULL, 51846),
(51847, '3.80.10.10-FF-002790', NULL, 'Os02g0277700 protein', 220, NULL, NULL, 51847),
(51848, '3.40.50.2300-FF-001601', NULL, NULL, 82, NULL, NULL, 51848),
(51849, '1.10.287.130-FF-000199', NULL, 'Two component signal transduction system histidine kinase', 110, NULL, NULL, 51849),
(51850, '1.10.3210.10-FF-000103', NULL, 'Hydrolase', 163, NULL, NULL, 51850),
(51851, '3.40.50.1110-FF-000070', NULL, 'Si:ch211-214p16.3', 272, NULL, NULL, 51851),
(51852, '3.30.450.200-FF-000007', NULL, 'MAP kinase-activating death domain protein isoform X10', 120, NULL, NULL, 51852),
(51853, '1.10.1610.10-FF-000004', NULL, NULL, 57, NULL, NULL, 51853),
(51854, '3.40.50.300-FF-000131', NULL, 'GTP-binding nuclear protein Ran', 216, NULL, NULL, 51854),
(51855, '1.20.1250.20-FF-002377', NULL, 'Facilitated trehalose transporter Tret1-2 homolog-like Protein', 212, NULL, NULL, 51855),
(51856, '2.170.260.10-FF-000009', NULL, 'Dicer-2', 113, NULL, NULL, 51856),
(51857, '3.40.50.12780-FF-000186', NULL, 'MIP16841p', 488, NULL, NULL, 51857),
(51858, '3.30.930.10-FF-000197', NULL, 'Lysine--tRNA ligase, putative', 228, NULL, NULL, 51858),
(51859, '3.40.50.11350-FF-000004', NULL, 'GDP-fucose protein O-fucosyltransferase 1', 174, NULL, NULL, 51859),
(51860, '3.30.450.20-FF-000641', NULL, 'Cytokinin receptor AtCKI2-like protein', 133, NULL, NULL, 51860),
(51861, '1.20.1280.50-FF-000061', NULL, 'F-box only protein 15', 102, NULL, NULL, 51861),
(51862, '3.30.160.60-FF-005936', NULL, NULL, 29, NULL, NULL, 51862),
(51863, '2.70.98.10-FF-000004', NULL, 'Glucans biosynthesis protein D', 379, NULL, NULL, 51863),
(51864, '3.40.50.1820-FF-000198', NULL, 'Putative esterase', 278, NULL, NULL, 51864),
(51865, '2.40.160.10-FF-000061', NULL, 'Bll5078 protein', 391, NULL, NULL, 51865),
(51866, '3.40.50.10130-FF-000065', NULL, 'Uncharacterized protein', 100, NULL, NULL, 51866),
(51867, '2.40.240.10-FF-000062', NULL, 'Glutamine--tRNA ligase', 113, NULL, NULL, 51867),
(51868, '1.25.40.10-FF-001046', NULL, 'Pentatricopeptide repeat-containing protein At3g14330', 94, NULL, NULL, 51868),
(51869, '1.10.555.10-FF-000056', NULL, 'AGAP001687-PB', 256, NULL, NULL, 51869),
(51870, '3.40.50.300-FF-000417', NULL, 'Cell division inhibitor SulA', 116, NULL, NULL, 51870),
(51871, '2.70.98.20-FF-000007', NULL, 'Primary amine oxidase', 410, NULL, NULL, 51871),
(51872, '3.30.300.30-FF-000077', NULL, 'Benzoate-CoA ligase family', 103, NULL, NULL, 51872),
(51873, '4.10.240.10-FF-000078', NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', 90, NULL, NULL, 51873),
(51874, '1.10.10.10-FF-001246', NULL, 'Histone acetyltransferase', 63, NULL, NULL, 51874),
(51875, '3.40.50.10140-FF-000068', NULL, 'Toll-like receptor 9', 110, NULL, NULL, 51875),
(51876, '3.90.1100.10-FF-000013', NULL, 'DNA-directed RNA polymerase subunit beta', 159, NULL, NULL, 51876);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(51877, '3.30.40.10-FF-001950', NULL, 'Uncharacterized protein', 107, NULL, NULL, 51877),
(51878, '1.10.8.60-FF-000366', NULL, 'Uncharacterized protein', 89, NULL, NULL, 51878),
(51879, '3.60.10.10-FF-000418', NULL, 'Imidazole glycerol phosphate synthase hisHF chloroplastic', 150, NULL, NULL, 51879),
(51880, '3.90.550.10-FF-000452', NULL, 'Uncharacterized protein', 326, NULL, NULL, 51880),
(51881, '3.40.50.10490-FF-000089', NULL, 'Glucosamine--fructose-6-phosphate aminotransferase, isomerizing', 144, NULL, NULL, 51881),
(51882, '1.25.10.10-FF-001544', NULL, 'Uncharacterized protein', 346, NULL, NULL, 51882),
(51883, '3.40.50.10190-FF-000173', NULL, 'Protein CBR-MUS-101', 101, NULL, NULL, 51883),
(51884, '3.50.50.60-FF-001436', NULL, 'Predicted protein', 238, NULL, NULL, 51884),
(51885, '1.20.1050.90-FF-000005', NULL, 'DNA replication and repair protein RecF', 180, NULL, NULL, 51885),
(51886, '3.40.50.1820-FF-001530', NULL, 'Uncharacterized protein', 144, NULL, NULL, 51886),
(51887, '1.10.630.10-FF-000361', NULL, 'Uncharacterized protein', 462, NULL, NULL, 51887),
(51888, '3.50.50.60-FF-000947', NULL, 'Uncharacterized protein', 184, NULL, NULL, 51888),
(51889, '3.90.190.10-FF-000531', NULL, 'Uncharacterized protein', 189, NULL, NULL, 51889),
(51890, '3.30.160.60-FF-003727', NULL, NULL, 29, NULL, NULL, 51890),
(51891, '1.20.58.1120-FF-000027', NULL, 'dynein heavy chain 12, axonemal', 145, NULL, NULL, 51891),
(51892, '2.30.29.90-FF-000005', NULL, 'Exocyst complex component 1', 104, NULL, NULL, 51892),
(51893, '2.40.290.10-FF-000008', NULL, 'ATP-dependent DNA helicase II subunit 2', 219, NULL, NULL, 51893),
(51894, '3.40.1190.20-FF-000073', NULL, 'Fructokinase, putative', 318, NULL, NULL, 51894),
(51895, '3.30.60.30-FF-000215', NULL, 'Uncharacterized protein', 64, NULL, NULL, 51895),
(51896, '3.90.280.10-FF-000004', NULL, 'Mitochondrial large ribosomal subunit YmL35', 208, NULL, NULL, 51896),
(51897, '3.30.470.30-FF-000010', NULL, 'Snurportin-1', 310, NULL, NULL, 51897),
(51898, '3.60.21.10-FF-000207', NULL, 'Putative serine/threonine protein phosphatase 2B catalytic subunit A2', 391, NULL, NULL, 51898),
(51899, '2.130.10.10-FF-003548', NULL, 'Dmx-like 2', 210, NULL, NULL, 51899),
(51900, '3.80.10.10-FF-002997', NULL, 'Chromosome 1, whole genome shotgun sequence', 99, NULL, NULL, 51900),
(51901, '3.80.10.10-FF-001811', NULL, 'DNA-damage repair/toleration 100', 230, NULL, NULL, 51901),
(51902, '3.30.460.10-FF-000138', NULL, 'Protein CBG22981', 115, NULL, NULL, 51902),
(51903, '1.20.58.390-FF-000040', NULL, 'Gamma-aminobutyric acid receptor subunit beta-like', 133, NULL, NULL, 51903),
(51904, '1.20.870.10-FF-000022', NULL, 'Rho GTPase-activating protein', 171, NULL, NULL, 51904),
(51905, '3.30.40.10-FF-001332', NULL, 'Predicted zinc finger protein', 127, NULL, NULL, 51905),
(51906, '3.40.50.980-FF-000020', NULL, 'Luciferin 4-monooxygenase', 181, NULL, NULL, 51906),
(51907, '3.50.30.30-FF-000162', NULL, 'Glutamate carboxypeptidase, putative', 155, NULL, NULL, 51907),
(51908, '3.40.140.10-FF-000106', NULL, 'Cytidine/deoxycytidylate deaminase family protein', 124, NULL, NULL, 51908),
(51909, '1.10.472.80-FF-000249', NULL, NULL, 122, NULL, NULL, 51909),
(51910, '3.30.1640.30-FF-000017', NULL, NULL, 64, NULL, NULL, 51910),
(51911, '3.40.50.410-FF-000046', NULL, 'von Willebrand factor A domain-containing protein 1', 184, NULL, NULL, 51911),
(51912, '3.30.1490.270-FF-000001', NULL, 'Hypothetical alanine and leucine rich protein', 56, NULL, NULL, 51912),
(51913, '3.30.450.40-FF-000130', NULL, 'Transcriptional regulatory protein', 176, NULL, NULL, 51913),
(51914, '2.60.40.10-FF-005195', NULL, NULL, 92, NULL, NULL, 51914),
(51915, '1.25.40.10-FF-004401', NULL, 'Uncharacterized protein', 136, NULL, NULL, 51915),
(51916, '3.90.980.20-FF-000015', NULL, 'Histidine kinase A', 130, NULL, NULL, 51916),
(51917, '3.30.710.10-FF-000299', NULL, 'Predicted protein', 106, NULL, NULL, 51917),
(51918, '3.30.160.60-FF-002160', NULL, 'Transcriptional regulator NRG1', 35, NULL, NULL, 51918),
(51919, '3.30.1520.10-FF-000177', NULL, 'Uncharacterized protein', 105, NULL, NULL, 51919);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(51920, '3.30.530.20-FF-000057', NULL, 'Conserved protein', 143, NULL, NULL, 51920),
(51921, '3.40.50.2000-FF-000769', NULL, 'Glycosyltransferase family 1 protein', 221, NULL, NULL, 51921),
(51922, '1.20.120.850-FF-000003', NULL, 'DNA repair and recombination protein RAD54', 99, NULL, NULL, 51922),
(51923, '3.40.1690.20-FF-000015', NULL, 'ATP-dependent zinc metalloprotease FTSH 8', 95, NULL, NULL, 51923),
(51924, '3.80.10.10-FF-002379', NULL, 'AGAP012425-PA', 133, NULL, NULL, 51924),
(51925, '3.90.1580.10-FF-000032', NULL, 'Uncharacterized protein', 223, NULL, NULL, 51925),
(51926, '2.20.25.10-FF-000052', NULL, 'Transcription elongation factor-like protein', 72, NULL, NULL, 51926),
(51927, '1.10.10.750-FF-000042', NULL, 'RabGAP/TBC domain-containing protein', 42, NULL, NULL, 51927),
(51928, '1.20.1070.10-FF-000590', NULL, 'Adhesion G-protein coupled receptor D1', 287, NULL, NULL, 51928),
(51929, '2.60.120.260-FF-000400', NULL, 'Endo-1,4-beta-xylanase Y', 159, NULL, NULL, 51929),
(51930, '3.40.50.11340-FF-000001', NULL, 'GDP-fucose protein O-fucosyltransferase 1', 190, NULL, NULL, 51930),
(51931, '3.40.50.360-FF-000093', NULL, 'Flavin reductase', 178, NULL, NULL, 51931),
(51932, '3.30.1640.10-FF-000011', NULL, 'DNA helicase', 115, NULL, NULL, 51932),
(51933, '3.40.50.12760-FF-000028', NULL, 'FtsJ methyltransferase domaincontaining protein 2, putative', 110, NULL, NULL, 51933),
(51934, '2.30.40.10-FF-000098', NULL, 'Bll3830 protein', 119, NULL, NULL, 51934),
(51935, '2.60.40.10-FF-001479', NULL, 'Immunoglobulin lambda variable 7-43', 98, NULL, NULL, 51935),
(51936, '3.30.1150.10-FF-000024', NULL, NULL, 125, NULL, NULL, 51936),
(51937, '1.10.510.10-FF-003786', NULL, NULL, 132, NULL, NULL, 51937),
(51938, '1.10.1420.10-FF-000063', NULL, 'MutS family protein', 131, NULL, NULL, 51938),
(51939, '3.40.1690.10-FF-000012', NULL, 'Flagellar biosynthesis protein FlhB', 90, NULL, NULL, 51939),
(51940, '2.30.30.140-FF-000164', NULL, 'Uncharacterized protein', 64, NULL, NULL, 51940),
(51941, '1.10.3720.10-FF-000007', NULL, 'Dipeptide ABC transporter permease DppC', 208, NULL, NULL, 51941),
(51942, '2.40.30.10-FF-000310', NULL, '5-methyltetrahydrofolate-homocysteine methyltransferase reductase', 90, NULL, NULL, 51942),
(51943, '3.30.930.10-FF-000225', NULL, 'Uncharacterized protein, isoform B', 194, NULL, NULL, 51943),
(51944, '1.25.50.20-FF-000066', NULL, 'Aminopeptidase', 253, NULL, NULL, 51944),
(51945, '1.20.1250.20-FF-001421', NULL, 'Uncharacterized protein', 171, NULL, NULL, 51945),
(51946, '1.20.120.330-FF-000004', NULL, 'Mannitol operon repressor', 167, NULL, NULL, 51946),
(51947, '2.30.39.10-FF-000139', NULL, 'Uncharacterized protein', 158, NULL, NULL, 51947),
(51948, '3.40.30.10-FF-000297', NULL, 'Glutathione S-transferase', 83, NULL, NULL, 51948),
(51949, '3.30.70.2130-FF-000001', NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase-like', 140, NULL, NULL, 51949),
(51950, '1.20.120.340-FF-000007', NULL, 'Perilipin 4', 154, NULL, NULL, 51950),
(51951, '3.30.160.60-FF-003519', NULL, NULL, 29, NULL, NULL, 51951),
(51952, '3.40.50.1820-FF-001204', NULL, 'Uncharacterized protein', 82, NULL, NULL, 51952),
(51953, '1.10.238.10-FF-001298', NULL, 'Uncharacterized protein', 76, NULL, NULL, 51953),
(51954, '3.60.40.10-FF-000364', NULL, 'Uncharacterized protein', 283, NULL, NULL, 51954),
(51955, '1.10.1040.10-FF-000045', NULL, 'Ketose-bisphosphate aldolase class-II family protein', 133, NULL, NULL, 51955),
(51956, '2.30.180.10-FF-000025', NULL, 'Midline fasciclin, isoform F', 141, NULL, NULL, 51956),
(51957, '3.10.290.10-FF-000062', NULL, 'Tyrosine--tRNA ligase', 80, NULL, NULL, 51957),
(51958, '3.50.30.30-FF-000049', NULL, 'VPS70p protein', 223, NULL, NULL, 51958),
(51959, '3.40.50.300-FF-005971', NULL, 'ATP-binding cassette alpha-factor transporter', 303, NULL, NULL, 51959),
(51960, '2.10.70.10-FF-000056', NULL, 'CUB and Sushi multiple domains 3', 59, NULL, NULL, 51960),
(51961, '1.10.510.10-FF-001274', NULL, 'Putative serine/threonine protein kinase', 271, NULL, NULL, 51961),
(51962, '1.10.10.790-FF-000025', NULL, 'Mrna splicing factor', 68, NULL, NULL, 51962);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(51963, '2.30.140.10-FF-000017', NULL, 'Polyamine aminopropyltransferase', 51, NULL, NULL, 51963),
(51964, '2.60.40.640-FF-000101', NULL, 'Arrestin domain-containing protein C31A2.12', 150, NULL, NULL, 51964),
(51965, '3.40.1650.10-FF-000004', NULL, 'D-ribose pyranase', 122, NULL, NULL, 51965),
(51966, '2.120.10.30-FF-000013', NULL, 'E3 ubiquitin-protein ligase TRIM71', 86, NULL, NULL, 51966),
(51967, '1.10.533.10-FF-000157', NULL, 'NALP2', 94, NULL, NULL, 51967),
(51968, '2.170.260.10-FF-000010', NULL, 'Argonaute (Plant)-Like protein', 131, NULL, NULL, 51968),
(51969, '3.40.50.150-FF-001339', NULL, NULL, 196, NULL, NULL, 51969),
(51970, '2.60.40.10-FF-005644', NULL, NULL, 93, NULL, NULL, 51970),
(51971, '2.170.210.10-FF-000006', NULL, 'DNA repair protein xrcc4', 112, NULL, NULL, 51971),
(51972, '3.40.1110.10-FF-000418', NULL, NULL, 35, NULL, NULL, 51972),
(51973, '3.10.50.40-FF-000106', NULL, 'Peptidylprolyl isomerase', 126, NULL, NULL, 51973),
(51974, '2.80.10.50-FF-000235', NULL, 'Predicted protein', 126, NULL, NULL, 51974),
(51975, '3.10.150.10-FF-000001', NULL, 'Beta sliding clamp', 123, NULL, NULL, 51975),
(51976, '3.30.160.60-FF-002367', NULL, 'zinc finger protein 226 isoform X2', 29, NULL, NULL, 51976),
(51977, '3.40.50.1820-FF-000636', NULL, 'Serine peptidase, family S28, putative', 176, NULL, NULL, 51977),
(51978, '1.25.40.10-FF-003912', NULL, 'Uncharacterized protein', 309, NULL, NULL, 51978),
(51979, '1.10.510.10-FF-003398', NULL, NULL, 305, NULL, NULL, 51979),
(51980, '3.30.160.60-FF-001378', NULL, 'Zinc finger protein 652', 87, NULL, NULL, 51980),
(51981, '3.90.520.10-FF-000006', NULL, 'Mothers against decapentaplegic homolog', 143, NULL, NULL, 51981),
(51982, '3.30.160.60-FF-000243', NULL, 'Probable transcription factor steA', 30, NULL, NULL, 51982),
(51983, '3.10.50.40-FF-000089', NULL, 'Peptidylprolyl isomerase', 121, NULL, NULL, 51983),
(51984, '2.60.220.50-FF-000085', NULL, 'Predicted protein', 180, NULL, NULL, 51984),
(51985, '2.70.160.11-FF-000089', NULL, 'Protein arginine N-methyltransferase', 179, NULL, NULL, 51985),
(51986, '3.40.50.1820-FF-001187', NULL, 'Uncharacterized protein', 112, NULL, NULL, 51986),
(51987, '3.40.50.10860-FF-000008', NULL, 'Glutamate dehydrogenase', 136, NULL, NULL, 51987),
(51988, '3.80.10.10-FF-002497', NULL, 'Probable serine/threonine-protein kinase pats1', 189, NULL, NULL, 51988),
(51989, '1.10.10.10-FF-001572', NULL, 'Putative GntR-family regulatory protein', 72, NULL, NULL, 51989),
(51990, '1.25.70.10-FF-000064', NULL, 'Transcription termination factor MTERF15, mitochondrial', 256, NULL, NULL, 51990),
(51991, '1.10.3730.20-FF-000073', NULL, 'LOC568275 protein', 124, NULL, NULL, 51991),
(51992, '3.20.20.70-FF-000309', NULL, 'Triosephosphate isomerase', 255, NULL, NULL, 51992),
(51993, '3.40.50.300-FF-001199', NULL, 'Probable RNA helicase SDE3', 102, NULL, NULL, 51993),
(51994, '1.20.5.190-FF-000036', NULL, 'IQ motif containing N', 43, NULL, NULL, 51994),
(51995, '1.10.10.10-FF-002027', NULL, 'Protein CBG25628', 105, NULL, NULL, 51995),
(51996, '2.60.120.10-FF-000649', NULL, 'Cysteine dioxygenase', 148, NULL, NULL, 51996),
(51997, '3.50.50.100-FF-000052', NULL, 'Uncharacterized protein', 213, NULL, NULL, 51997),
(51998, '3.30.160.60-FF-000181', NULL, 'C2H2 type zinc finger protein', 30, NULL, NULL, 51998),
(51999, '1.25.40.10-FF-001759', NULL, 'Rhomboid family intramembrane serine protease', 121, NULL, NULL, 51999),
(52000, '1.20.1560.10-FF-000672', NULL, 'Multidrug resistance-associated protein putative', 36, NULL, NULL, 52000),
(52001, '1.20.1080.10-FF-000096', NULL, 'Uncharacterized protein', 236, NULL, NULL, 52001),
(52002, '3.90.1480.20-FF-000038', NULL, 'ST8 alpha-N-acetyl-neuraminide alpha-2,8-sialyltransferase 1', 117, NULL, NULL, 52002),
(52003, '1.10.287.10-FF-000028', NULL, 'Uncharacterized protein, isoform A', 47, NULL, NULL, 52003),
(52004, '3.10.170.20-FF-000005', NULL, 'MSP-A1 surface protease homolog', 167, NULL, NULL, 52004),
(52005, '3.40.50.2020-FF-000134', NULL, 'Adenine phosphoribosyltransferase, putative', 222, NULL, NULL, 52005);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(52006, '1.10.3730.20-FF-000016', NULL, 'NIPA1 (NonImprinted gene in Prader-Willi/Angelman syndrome region 1) homolog', 122, NULL, NULL, 52006),
(52007, '3.30.310.170-FF-000001', NULL, 'Outer membrane protein assembly factor BamC', 119, NULL, NULL, 52007),
(52008, '2.60.40.60-FF-000134', NULL, 'protocadherin Fat 4', 102, NULL, NULL, 52008),
(52009, '2.20.100.10-FF-000236', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs adt-1 isoform X1', 49, NULL, NULL, 52009),
(52010, '3.40.30.10-FF-001022', NULL, 'Uncharacterized protein', 54, NULL, NULL, 52010),
(52011, '3.10.20.90-FF-000074', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', 218, NULL, NULL, 52011),
(52012, '2.30.110.10-FF-000077', NULL, 'Putative 4-nitrophenol hydroxylase component B', 168, NULL, NULL, 52012),
(52013, '3.40.1110.10-FF-000323', NULL, NULL, 196, NULL, NULL, 52013),
(52014, '3.40.50.300-FF-006145', NULL, 'Rothmund-thomson syndrome DNA helicase recq4, putative', 119, NULL, NULL, 52014),
(52015, '3.30.565.10-FF-000084', NULL, 'Sensor histidine kinase', 150, NULL, NULL, 52015),
(52016, '3.30.450.90-FF-000004', NULL, 'Type IV pili twitching motility protein PilT', 99, NULL, NULL, 52016),
(52017, '1.20.58.390-FF-000152', NULL, 'GABA/Glycine Receptor family (See gbr)', 159, NULL, NULL, 52017),
(52018, '3.30.70.940-FF-000003', NULL, 'Transcription elongation factor SPT5', 109, NULL, NULL, 52018),
(52019, '3.30.310.180-FF-000004', NULL, 'Mediator of RNA polymerase II transcription subunit 20', 110, NULL, NULL, 52019),
(52020, '3.80.10.10-FF-002885', NULL, 'Si:ch211-213a13.2', 117, NULL, NULL, 52020),
(52021, '3.50.50.60-FF-001223', NULL, 'Uncharacterized protein', 252, NULL, NULL, 52021),
(52022, '2.40.50.140-FF-000946', NULL, NULL, 79, NULL, NULL, 52022),
(52023, '3.50.50.60-FF-001487', NULL, 'Predicted protein', 46, NULL, NULL, 52023),
(52024, '1.10.238.10-FF-000213', NULL, 'Reticulocalbin 1', 95, NULL, NULL, 52024),
(52025, '3.30.160.60-FF-002272', NULL, 'Zinc finger protein 445', 30, NULL, NULL, 52025),
(52026, '1.20.120.1080-FF-000034', NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase PRP16', 106, NULL, NULL, 52026),
(52027, '3.30.450.80-FF-000001', NULL, 'Transcriptional activator protein TraR', 171, NULL, NULL, 52027),
(52028, '2.80.10.50-FF-000140', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 146, NULL, NULL, 52028),
(52029, '2.60.120.380-FF-000083', NULL, 'Calpain 9', 129, NULL, NULL, 52029),
(52030, '2.60.40.3110-FF-000002', NULL, 'Fimbrial biogenesis outer membrane usher protein', 63, NULL, NULL, 52030),
(52031, '1.10.510.10-FF-001369', NULL, 'Protein kinase, putative', 177, NULL, NULL, 52031),
(52032, '1.25.10.10-FF-001836', NULL, 'Uncharacterized protein', 272, NULL, NULL, 52032),
(52033, '1.10.150.50-FF-000212', NULL, 'DDHD domain-containing 2', 43, NULL, NULL, 52033),
(52034, '3.90.640.10-FF-000167', NULL, 'Actin-related protein 6', 44, NULL, NULL, 52034),
(52035, '2.60.40.10-FF-004121', NULL, NULL, 92, NULL, NULL, 52035),
(52036, '2.60.40.10-FF-004008', NULL, NULL, 99, NULL, NULL, 52036),
(52037, '3.40.50.2300-FF-001584', NULL, NULL, 135, NULL, NULL, 52037),
(52038, '2.130.10.10-FF-000237', NULL, 'Flowering time control protein FY', 138, NULL, NULL, 52038),
(52039, '2.60.120.920-FF-000076', NULL, 'ATP-dependent RNA helicase DDX1', 190, NULL, NULL, 52039),
(52040, '2.120.10.30-FF-000070', NULL, 'Low-density lipoprotein receptor-related protein', 318, NULL, NULL, 52040),
(52041, '3.30.160.60-FF-005762', NULL, NULL, 24, NULL, NULL, 52041),
(52042, '1.20.58.60-FF-000645', NULL, 'Uncharacterized protein', 215, NULL, NULL, 52042),
(52043, '3.40.720.10-FF-000185', NULL, 'Iduronate-sulfatase (Partial) and sulfatase 1', 445, NULL, NULL, 52043),
(52044, '3.40.50.300-FF-007769', NULL, 'Ras, putative', 66, NULL, NULL, 52044),
(52045, '4.10.280.10-FF-000024', NULL, 'Aryl hydrocarbon receptor 2', 52, NULL, NULL, 52045),
(52046, '2.60.120.620-FF-000087', NULL, 'Ectoine dioxygenase', 298, NULL, NULL, 52046),
(52047, '2.130.10.10-FF-000501', NULL, 'WD repeat domain 70', 220, NULL, NULL, 52047);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(52048, '3.90.290.10-FF-000010', NULL, 'Fibrillin 2', 72, NULL, NULL, 52048),
(52049, '1.20.140.100-FF-000052', NULL, 'Uncharacterized protein', 94, NULL, NULL, 52049),
(52050, '3.40.1550.20-FF-000005', NULL, 'Transcriptional regulator MraZ', 148, NULL, NULL, 52050),
(52051, '3.40.50.410-FF-000158', NULL, 'Predicted protein', 181, NULL, NULL, 52051),
(52052, '3.80.30.30-FF-000003', NULL, 'PA0069 family radical SAM protein', 200, NULL, NULL, 52052),
(52053, '3.40.50.720-FF-000690', NULL, 'Glucose-6-phosphate 1-dehydrogenase', 195, NULL, NULL, 52053),
(52054, '3.40.605.10-FF-000108', NULL, '10-formyltetrahydrofolate dehydrogenase', 244, NULL, NULL, 52054),
(52055, '3.40.50.300-FF-004054', NULL, 'ATP-dependent DNA helicase', 212, NULL, NULL, 52055),
(52056, '1.25.40.20-FF-000514', NULL, 'Uncharacterized protein', 232, NULL, NULL, 52056),
(52057, '3.80.10.10-FF-001362', NULL, 'Lrr receptor-like serinethreonine-protein kinase gso2', 91, NULL, NULL, 52057),
(52058, '3.40.50.300-FF-002194', NULL, '3''-phosphoadenosine 5''-phosphosulfate synthase 1', 121, NULL, NULL, 52058),
(52059, '3.40.50.300-FF-000064', NULL, 'Septin 4', 296, NULL, NULL, 52059),
(52060, '3.80.10.10-FF-001305', NULL, 'EIN3-binding F-box domain containing protein', 103, NULL, NULL, 52060),
(52061, '3.40.50.300-FF-002137', NULL, 'Elongation factor 2, putative', 224, NULL, NULL, 52061),
(52062, '2.60.40.3120-FF-000005', NULL, 'Putative zinc carboxypeptidase', 118, NULL, NULL, 52062),
(52063, '2.70.50.30-FF-000007', NULL, 'Rho GDI/ GDP dissociation inhibitor', 143, NULL, NULL, 52063),
(52064, '1.20.1050.10-FF-000268', NULL, 'Predicted protein', 117, NULL, NULL, 52064),
(52065, '3.40.1160.10-FF-000034', NULL, 'Acetylglutamate kinase', 252, NULL, NULL, 52065),
(52066, '3.40.50.300-FF-000743', NULL, 'Torsin', 225, NULL, NULL, 52066),
(52067, '1.10.287.70-FF-000636', NULL, 'Predicted protein', 196, NULL, NULL, 52067),
(52068, '3.20.10.10-FF-000038', NULL, 'Branched-chain-amino-acid aminotransferase', 162, NULL, NULL, 52068),
(52069, '1.20.1560.10-FF-000464', NULL, 'ATP-binding cassette sub-family B member 6, mitochondrial', 329, NULL, NULL, 52069),
(52070, '2.60.40.780-FF-000002', NULL, 'von Hippel-Lindau disease tumor suppressor', 52, NULL, NULL, 52070),
(52071, '3.40.30.10-FF-000033', NULL, 'Calsequestrin', 102, NULL, NULL, 52071),
(52072, '2.60.60.20-FF-000067', NULL, NULL, 124, NULL, NULL, 52072),
(52073, '1.10.10.60-FF-000114', NULL, 'cyclin-D-binding Myb-like transcription factor 1 isoform X1', 39, NULL, NULL, 52073),
(52074, '1.25.40.10-FF-001872', NULL, 'Uncharacterized protein', 332, NULL, NULL, 52074),
(52075, '1.10.10.60-FF-000226', NULL, 'Paired box gene 4', 75, NULL, NULL, 52075),
(52076, '3.40.50.300-FF-003554', NULL, 'Uncharacterized protein', 100, NULL, NULL, 52076),
(52077, '3.90.190.10-FF-000290', NULL, 'Protein tyrosine phosphatase', 175, NULL, NULL, 52077),
(52078, '2.60.120.330-FF-000118', NULL, 'Uncharacterized protein', 267, NULL, NULL, 52078),
(52079, '2.150.10.10-FF-000012', NULL, 'Putative Mannuronan C-5-epimerase', 188, NULL, NULL, 52079),
(52080, '3.40.50.300-FF-005678', NULL, 'DnaJ-like protein subfamily C member 27', 188, NULL, NULL, 52080),
(52081, '3.80.10.10-FF-002828', NULL, 'Uncharacterized protein', 86, NULL, NULL, 52081),
(52082, '1.25.40.10-FF-001990', NULL, 'Os05g0439300 protein', 100, NULL, NULL, 52082),
(52083, '2.60.40.790-FF-000005', NULL, 'Small heat shock protein IbpB', 105, NULL, NULL, 52083),
(52084, '3.10.450.10-FF-000002', NULL, 'Kininogen 1', 114, NULL, NULL, 52084),
(52085, '3.30.420.10-FF-000467', NULL, NULL, 207, NULL, NULL, 52085),
(52086, '3.40.50.150-FF-001671', NULL, NULL, 166, NULL, NULL, 52086),
(52087, '2.40.20.10-FF-000074', NULL, 'Predicted protein', 96, NULL, NULL, 52087),
(52088, '1.20.1070.10-FF-001371', NULL, 'Uncharacterized protein', 257, NULL, NULL, 52088),
(52089, '1.10.533.10-FF-000270', NULL, 'Uncharacterized protein', 99, NULL, NULL, 52089),
(52090, '3.30.450.20-FF-000287', NULL, 'Transcriptional regulator TyrR', 105, NULL, NULL, 52090),
(52091, '2.80.10.50-FF-000027', NULL, 'Interleukin-1 beta', 153, NULL, NULL, 52091); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(52092, '3.10.490.10-FF-000010', NULL, 'Urea amidolyase', 138, NULL, NULL, 52092),
(52093, '3.30.160.60-FF-005857', NULL, NULL, 65, NULL, NULL, 52093),
(52094, '1.25.40.20-FF-001875', NULL, 'Leucine-rich repeat serine/threonine-protein kinase 1', 128, NULL, NULL, 52094),
(52095, '2.40.110.10-FF-000018', NULL, 'Acyl-CoA dehydrogenase fadE29', 111, NULL, NULL, 52095),
(52096, '1.10.8.10-FF-000216', NULL, 'ER organization and biogenesis-related protein, putative', 48, NULL, NULL, 52096),
(52097, '2.60.40.10-FF-005436', NULL, NULL, 91, NULL, NULL, 52097),
(52098, '3.30.160.60-FF-003795', NULL, NULL, 38, NULL, NULL, 52098),
(52099, '1.25.40.180-FF-000075', NULL, 'SGD1p nuclear protein', 285, NULL, NULL, 52099),
(52100, '2.70.150.10-FF-000110', NULL, 'Phospholipid-transporting ATPase', 105, NULL, NULL, 52100),
(52101, '3.40.1550.10-FF-000002', NULL, 'Chemotaxis protein CheX', 153, NULL, NULL, 52101),
(52102, '3.20.80.10-FF-000025', NULL, 'Heme-binding-like protein chloroplastic', 138, NULL, NULL, 52102),
(52103, '2.110.10.10-FF-000053', NULL, 'Hemopexin', 200, NULL, NULL, 52103),
(52104, '3.80.10.10-FF-000468', NULL, 'nischarin isoform X2', 150, NULL, NULL, 52104),
(52105, '1.20.1070.10-FF-001899', NULL, 'Uncharacterized protein', 288, NULL, NULL, 52105),
(52106, '1.20.120.350-FF-000162', NULL, NULL, 88, NULL, NULL, 52106),
(52107, '3.40.630.30-FF-000285', NULL, 'GNAT family N-acetyltransferase', 163, NULL, NULL, 52107),
(52108, '1.10.530.10-FF-000033', NULL, 'Transglycosylase', 154, NULL, NULL, 52108),
(52109, '2.60.120.290-FF-000235', NULL, 'Uncharacterized protein', 147, NULL, NULL, 52109),
(52110, '2.60.120.620-FF-000025', NULL, 'MGC115642 protein', 255, NULL, NULL, 52110),
(52111, '3.10.105.10-FF-000037', NULL, 'Nickel ABC transporter periplasmic nickel-binding protein', 219, NULL, NULL, 52111),
(52112, '1.10.1740.10-FF-000042', NULL, 'ECF RNA polymerase sigma factor SigJ', 74, NULL, NULL, 52112),
(52113, '3.10.20.90-FF-000254', NULL, 'UV excision repair protein Rad23', 78, NULL, NULL, 52113),
(52114, '1.10.268.10-FF-000041', NULL, NULL, 55, NULL, NULL, 52114),
(52115, '1.10.8.60-FF-000478', NULL, 'Uncharacterized protein', 61, NULL, NULL, 52115),
(52116, '3.60.10.10-FF-000183', NULL, 'Uncharacterized protein', 79, NULL, NULL, 52116),
(52117, '3.30.930.10-FF-000282', NULL, 'Phenylalanine--tRNA ligase alpha subunit', 295, NULL, NULL, 52117),
(52118, '3.30.70.330-FF-001506', NULL, NULL, 87, NULL, NULL, 52118),
(52119, '3.30.70.580-FF-000024', NULL, 'RNA pseudouridylate synthase', 80, NULL, NULL, 52119),
(52120, '1.10.510.10-FF-002206', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 1-like Protein', 206, NULL, NULL, 52120),
(52121, '1.10.287.3240-FF-000015', NULL, 'Vacuolar ATP synthase subunit d, putative', 233, NULL, NULL, 52121),
(52122, '3.10.490.20-FF-000013', NULL, 'Dynein, axonemal, heavy chain 11', 137, NULL, NULL, 52122),
(52123, '1.10.510.10-FF-002263', NULL, NULL, 146, NULL, NULL, 52123),
(52124, '1.20.920.10-FF-000178', NULL, 'Uncharacterized protein', 83, NULL, NULL, 52124),
(52125, '2.60.40.10-FF-004301', NULL, NULL, 106, NULL, NULL, 52125),
(52126, '3.30.479.20-FF-000044', NULL, 'Elongation factor Ts, mitochondrial 2', 95, NULL, NULL, 52126),
(52127, '1.25.40.10-FF-005149', NULL, 'Uncharacterized protein', 95, NULL, NULL, 52127),
(52128, '1.20.810.10-FF-000013', NULL, 'Cytochrome bc1 complex cytochrome b subunit', 246, NULL, NULL, 52128),
(52129, '3.10.100.10-FF-000341', NULL, NULL, 154, NULL, NULL, 52129),
(52130, '1.20.1070.10-FF-001314', NULL, 'Uncharacterized protein', 139, NULL, NULL, 52130),
(52131, '3.30.40.10-FF-001624', NULL, 'Uncharacterized protein', 68, NULL, NULL, 52131),
(52132, '3.30.420.110-FF-000036', NULL, 'DNA mismatch repair protein MSH3', 177, NULL, NULL, 52132),
(52133, '3.30.160.60-FF-000922', NULL, 'PR domain zinc finger protein 4', 28, NULL, NULL, 52133),
(52134, '3.30.1140.60-FF-000016', NULL, 'F-actin-capping protein subunit alpha', 102, NULL, NULL, 52134),
(52135, '3.10.105.10-FF-000094', NULL, 'Similar to periplasmic dipeptide transport protein (Dipeptide-binding protein) (DBP)-putative secreted, membrane associated or paryphoplasmic protein', 227, NULL, NULL, 52135);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(52136, '2.20.25.10-FF-000131', NULL, 'DNA-directed RNA polymerase subunit', 65, NULL, NULL, 52136),
(52137, '2.60.40.10-FF-005369', NULL, NULL, 61, NULL, NULL, 52137),
(52138, '3.90.550.50-FF-000205', NULL, 'Hexosyltransferase', 172, NULL, NULL, 52138),
(52139, '1.10.275.10-FF-000006', NULL, 'Adenylosuccinate lyase', 92, NULL, NULL, 52139),
(52140, '2.40.50.990-FF-000004', NULL, 'Uncharacterized protein', 16, NULL, NULL, 52140),
(52141, '1.20.120.550-FF-000014', NULL, 'Probable microsomal glutathione S-transferase', 141, NULL, NULL, 52141),
(52142, '1.20.1270.60-FF-000119', NULL, 'Unplaced genomic scaffold supercont1.126, whole genome shotgun sequence', 221, NULL, NULL, 52142),
(52143, '3.90.550.10-FF-000222', NULL, '3-deoxy-manno-octulosonate cytidylyltransferase', 238, NULL, NULL, 52143),
(52144, '3.30.160.40-FF-000023', NULL, 'Uncharacterized protein', 122, NULL, NULL, 52144),
(52145, '2.130.10.10-FF-003374', NULL, 'Uncharacterized protein', 163, NULL, NULL, 52145),
(52146, '1.25.40.20-FF-000239', NULL, 'BTB/POZ domain and ankyrin repeat-containing protein NPR1', 150, NULL, NULL, 52146),
(52147, '2.130.10.10-FF-000125', NULL, 'Outer membrane protein assembly factor BamB', 371, NULL, NULL, 52147),
(52148, '1.10.275.20-FF-000009', NULL, NULL, 65, NULL, NULL, 52148),
(52149, '1.10.287.950-FF-000052', NULL, 'Predicted protein', 119, NULL, NULL, 52149),
(52150, '3.40.50.2300-FF-001308', NULL, NULL, 120, NULL, NULL, 52150),
(52151, '3.10.20.90-FF-000815', NULL, 'F15I1.6 protein', 42, NULL, NULL, 52151),
(52152, '3.30.200.20-FF-001095', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase CES101 isoform A', 114, NULL, NULL, 52152),
(52153, '3.30.70.890-FF-000027', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 120, NULL, NULL, 52153),
(52154, '3.30.70.330-FF-002855', NULL, NULL, 81, NULL, NULL, 52154),
(52155, '1.20.1600.10-FF-000052', NULL, 'Efflux pump, RND family, outer membrane protein', 382, NULL, NULL, 52155),
(52156, '1.20.58.150-FF-000013', NULL, NULL, 69, NULL, NULL, 52156),
(52157, '3.30.210.10-FF-000013', NULL, 'Putative DNA polymerase X', 64, NULL, NULL, 52157),
(52158, '2.60.40.10-FF-002210', NULL, 'Hibris, isoform B', 93, NULL, NULL, 52158),
(52159, '2.130.10.10-FF-001749', NULL, 'Nucleoporin SEH1', 324, NULL, NULL, 52159),
(52160, '3.50.50.60-FF-000498', NULL, 'FAD-dependent oxidoreductase', 205, NULL, NULL, 52160),
(52161, '1.25.40.10-FF-000236', NULL, 'pre-mRNA-processing factor 39 isoform X2', 134, NULL, NULL, 52161),
(52162, '1.20.1560.10-FF-000559', NULL, 'Uncharacterized protein', 156, NULL, NULL, 52162),
(52163, '1.20.5.170-FF-000289', NULL, 'Uncharacterized protein', 43, NULL, NULL, 52163),
(52164, '1.20.1250.20-FF-000865', NULL, 'Predicted protein', 159, NULL, NULL, 52164),
(52165, '3.40.50.720-FF-002488', NULL, 'Uncharacterized protein', 178, NULL, NULL, 52165),
(52166, '2.120.10.80-FF-000410', NULL, 'Uncharacterized protein', 193, NULL, NULL, 52166),
(52167, '3.30.160.60-FF-000029', NULL, 'GLI family zinc finger 4', 29, NULL, NULL, 52167),
(52168, '3.10.20.310-FF-000005', NULL, 'Outer membrane protein assembly factor BamA', 82, NULL, NULL, 52168),
(52169, '3.40.50.10190-FF-000229', NULL, 'CTD phosphatase-related (Eurofung)', 90, NULL, NULL, 52169),
(52170, '3.30.1370.210-FF-000024', NULL, 'Predicted protein', 59, NULL, NULL, 52170),
(52171, '3.40.50.300-FF-004554', NULL, 'Uncharacterized protein', 52, NULL, NULL, 52171),
(52172, '1.20.1250.20-FF-001303', NULL, 'Uncharacterized protein', 214, NULL, NULL, 52172),
(52173, '3.40.50.2300-FF-001573', NULL, NULL, 150, NULL, NULL, 52173),
(52174, '3.20.20.220-FF-000083', NULL, 'Proline dehydrogenase', 87, NULL, NULL, 52174),
(52175, '1.10.8.870-FF-000023', NULL, 'Glycerol-3-phosphate dehydrogenase', 125, NULL, NULL, 52175),
(52176, '3.40.50.360-FF-000008', NULL, 'Glutathione-regulated potassium-efflux system ancillary protein KefF', 176, NULL, NULL, 52176),
(52177, '1.25.40.10-FF-000978', NULL, 'Pentatricopeptide repeat-containing protein', 119, NULL, NULL, 52177),
(52178, '3.60.20.10-FF-000189', NULL, NULL, 103, NULL, NULL, 52178);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(52179, '2.60.40.60-FF-000055', NULL, 'protocadherin-15 isoform X1', 116, NULL, NULL, 52179),
(52180, '1.25.40.450-FF-000009', NULL, 'Uncharacterized protein', 170, NULL, NULL, 52180),
(52181, '2.30.33.40-FF-000028', NULL, 'Os06g0197550 protein', 43, NULL, NULL, 52181),
(52182, '3.80.10.10-FF-004178', NULL, 'Uncharacterized protein', 98, NULL, NULL, 52182),
(52183, '3.30.70.870-FF-000021', NULL, 'Putative Mitochondrial elongation factor G', 69, NULL, NULL, 52183),
(52184, '1.10.275.10-FF-000017', NULL, 'Argininosuccinate lyase', 121, NULL, NULL, 52184),
(52185, '3.30.160.60-FF-005970', NULL, NULL, 71, NULL, NULL, 52185),
(52186, '1.20.1500.20-FF-000002', NULL, 'DEAD/DEAH box helicase, putative', 71, NULL, NULL, 52186),
(52187, '1.10.10.10-FF-001925', NULL, 'Uncharacterized protein', 94, NULL, NULL, 52187),
(52188, '3.40.50.1820-FF-000748', NULL, 'Uncharacterized protein', 84, NULL, NULL, 52188),
(52189, '3.40.50.150-FF-001749', NULL, NULL, 168, NULL, NULL, 52189),
(52190, '1.25.40.20-FF-000801', NULL, 'Protein 21.1', 204, NULL, NULL, 52190),
(52191, '3.80.10.10-FF-003722', NULL, 'Uncharacterized protein', 144, NULL, NULL, 52191),
(52192, '2.130.10.10-FF-003935', NULL, 'Predicted protein', 254, NULL, NULL, 52192),
(52193, '3.80.10.10-FF-004476', NULL, 'Uncharacterized protein', 201, NULL, NULL, 52193),
(52194, '1.10.1000.11-FF-000021', NULL, 'Golgi-specific brefeldin A-resistance factor 1', 38, NULL, NULL, 52194),
(52195, '1.10.20.10-FF-000330', NULL, NULL, 187, NULL, NULL, 52195),
(52196, '3.40.30.10-FF-000471', NULL, 'Glutathione S-transferase 1', 93, NULL, NULL, 52196),
(52197, '1.20.1740.10-FF-000175', NULL, 'Transport protein (Probable substrate cationic amino acids)', 477, NULL, NULL, 52197),
(52198, '2.30.40.10-FF-000126', NULL, '5-methylthioadenosine-S-adenosylhomocysteine deaminase protein', 83, NULL, NULL, 52198),
(52199, '1.20.120.1460-FF-000002', NULL, 'tRNA-dihydrouridine synthase', 70, NULL, NULL, 52199),
(52200, '1.20.1070.10-FF-000831', NULL, 'Uncharacterized protein', 302, NULL, NULL, 52200),
(52201, '3.90.70.10-FF-000544', NULL, 'Uncharacterized protein', 224, NULL, NULL, 52201),
(52202, '1.10.287.500-FF-000001', NULL, 'Protein phosphatase CheZ', 134, NULL, NULL, 52202),
(52203, '3.30.160.60-FF-000361', NULL, 'Zinc finger protein 658', 28, NULL, NULL, 52203),
(52204, '4.10.410.10-FF-000018', NULL, 'Tissue factor pathway inhibitor', 62, NULL, NULL, 52204),
(52205, '3.40.80.10-FF-000036', NULL, 'Uncharacterized protein', 111, NULL, NULL, 52205),
(52206, '1.20.1250.20-FF-000983', NULL, 'MFS transporter, putative', 258, NULL, NULL, 52206),
(52207, '3.30.420.40-FF-001084', NULL, 'Uncharacterized protein', 116, NULL, NULL, 52207),
(52208, '2.10.25.10-FF-001148', NULL, 'Uncharacterized protein', 49, NULL, NULL, 52208),
(52209, '3.30.1130.10-FF-000023', NULL, 'Dihydropteroate synthase', 118, NULL, NULL, 52209),
(52210, '1.10.510.10-FF-003634', NULL, NULL, 191, NULL, NULL, 52210),
(52211, '1.10.1410.10-FF-000023', NULL, 'Uncharacterized protein', 76, NULL, NULL, 52211),
(52212, '2.40.50.100-FF-000142', NULL, 'ABC transporter ATP-binding protein', 57, NULL, NULL, 52212),
(52213, '1.25.40.10-FF-001254', NULL, 'Uncharacterized protein, isoform C', 302, NULL, NULL, 52213),
(52214, '3.40.50.300-FF-007505', NULL, 'Uncharacterized protein', 370, NULL, NULL, 52214),
(52215, '3.30.200.20-FF-001825', NULL, 'Tyrosine-protein kinase', 48, NULL, NULL, 52215),
(52216, '1.20.1630.10-FF-000003', NULL, 'Oxidoreductase, membrane subunit', 337, NULL, NULL, 52216),
(52217, '1.10.150.560-FF-000003', NULL, 'Major DNA-binding protein', 96, NULL, NULL, 52217),
(52218, '3.40.50.20-FF-000088', NULL, 'Uncharacterized protein', 37, NULL, NULL, 52218),
(52219, '2.30.34.10-FF-000005', NULL, 'GP63-like protein, leishmanolysin-like protein', 104, NULL, NULL, 52219),
(52220, '3.30.70.330-FF-001394', NULL, 'RBD (RNA binding domain) protein', 69, NULL, NULL, 52220),
(52221, '1.10.10.10-FF-001982', NULL, 'Predicted protein', 55, NULL, NULL, 52221),
(52222, '1.25.40.10-FF-005183', NULL, 'Uncharacterized protein', 261, NULL, NULL, 52222);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(52223, '3.30.160.60-FF-001928', NULL, 'Zinc finger protein 131', 28, NULL, NULL, 52223),
(52224, '2.40.30.20-FF-000038', NULL, 'H(+)-transporting ATP synthase, subunit alpha', 69, NULL, NULL, 52224),
(52225, '3.30.200.20-FF-002101', NULL, 'Predicted protein', 79, NULL, NULL, 52225),
(52226, '3.30.930.10-FF-000214', NULL, 'Aspartate--tRNA(Asp/Asn) ligase', 352, NULL, NULL, 52226),
(52227, '1.10.565.10-FF-000175', NULL, 'Uncharacterized protein', 172, NULL, NULL, 52227),
(52228, '1.10.472.80-FF-000137', NULL, 'Rab GTPase activating protein, putative', 149, NULL, NULL, 52228),
(52229, '3.50.30.30-FF-000050', NULL, 'Uncharacterized protein', 146, NULL, NULL, 52229),
(52230, '1.20.1250.20-FF-001360', NULL, 'Major facilitator superfamily domain-containing protein', 198, NULL, NULL, 52230),
(52231, '2.40.30.10-FF-000035', NULL, 'HBS1-like translational GTPase', 108, NULL, NULL, 52231),
(52232, '1.10.287.520-FF-000007', NULL, 'Uncharacterized protein', 50, NULL, NULL, 52232),
(52233, '2.10.80.10-FF-000017', NULL, 'Uncharacterized protein', 92, NULL, NULL, 52233),
(52234, '2.60.40.150-FF-000055', NULL, 'Toll-interacting protein-like Protein', 124, NULL, NULL, 52234),
(52235, '3.50.50.60-FF-001049', NULL, 'D-amino acid dehydrogenase 2', 50, NULL, NULL, 52235),
(52236, '1.25.10.10-FF-000408', NULL, 'Uncharacterized protein', 253, NULL, NULL, 52236),
(52237, '3.40.120.10-FF-000105', NULL, 'Phosphoglucomutase/phosphomannomutase family protein', 193, NULL, NULL, 52237),
(52238, '2.130.10.10-FF-003992', NULL, 'Uncharacterized protein', 230, NULL, NULL, 52238),
(52239, '1.10.1520.10-FF-000059', NULL, 'Endoribonuclease Dicer-like protein 1', 197, NULL, NULL, 52239),
(52240, '2.30.30.190-FF-000038', NULL, NULL, 56, NULL, NULL, 52240),
(52241, '3.10.100.10-FF-000133', NULL, 'C-type LECtin', 143, NULL, NULL, 52241),
(52242, '2.10.60.10-FF-000050', NULL, 'TGF-beta receptor type-2', 111, NULL, NULL, 52242),
(52243, '3.80.10.10-FF-004419', NULL, 'Receptor-like protein 14', 311, NULL, NULL, 52243),
(52244, '1.20.1250.20-FF-001921', NULL, 'Uncharacterized protein', 221, NULL, NULL, 52244),
(52245, '2.20.25.10-FF-000018', NULL, 'Multifunctional methyltransferase subunit TRM112-like B', 123, NULL, NULL, 52245),
(52246, '2.60.120.920-FF-000019', NULL, 'Ryanodine receptor 1 (skeletal)', 163, NULL, NULL, 52246),
(52247, '2.30.29.30-FF-000937', NULL, 'Uncharacterized protein', 126, NULL, NULL, 52247),
(52248, '3.30.160.20-FF-000197', NULL, 'Class I peptide chain release factor', 99, NULL, NULL, 52248),
(52249, '2.170.240.10-FF-000008', NULL, 'Uncharacterized protein', 216, NULL, NULL, 52249),
(52250, '2.130.10.10-FF-005791', NULL, 'Predicted protein', 96, NULL, NULL, 52250),
(52251, '4.10.400.10-FF-000080', NULL, 'Low-density lipoprotein receptor-related protein 1B', 34, NULL, NULL, 52251),
(52252, '2.130.10.10-FF-005734', NULL, 'Vacuolar protein sorting/targeting protein 10', 131, NULL, NULL, 52252),
(52253, '3.30.40.10-FF-001124', NULL, 'YALI0F20834p', 93, NULL, NULL, 52253),
(52254, '1.10.101.10-FF-000025', NULL, 'N-acetylmuramoyl-L-alanine amidase', 83, NULL, NULL, 52254),
(52255, '2.170.300.10-FF-000098', NULL, 'Uncharacterized protein', 52, NULL, NULL, 52255),
(52256, '2.170.270.10-FF-000100', NULL, 'PR domain-containing 2, with ZNF domain b', 172, NULL, NULL, 52256),
(52257, '3.30.1390.30-FF-000008', NULL, NULL, 74, NULL, NULL, 52257),
(52258, '3.40.50.2300-FF-001516', NULL, NULL, 92, NULL, NULL, 52258),
(52259, '3.40.50.720-FF-001414', NULL, 'NAD binding domain of 6-phosphogluconate dehydrogenase/NAD-binding of NADP-dependent 3-hydroxyisobutyrate dehydrogenase, putative', 179, NULL, NULL, 52259),
(52260, '3.30.342.10-FF-000033', NULL, 'DNA polymerase', 123, NULL, NULL, 52260),
(52261, '2.60.40.10-FF-003284', NULL, 'Mcam protein', 127, NULL, NULL, 52261),
(52262, '1.25.40.180-FF-000086', NULL, 'Eukaryotic initiation factor 4a, putative', 245, NULL, NULL, 52262),
(52263, '1.10.510.10-FF-003898', NULL, NULL, 85, NULL, NULL, 52263),
(52264, '3.30.200.20-FF-001207', NULL, 'CDPK-related kinase 1', 49, NULL, NULL, 52264);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(52265, '2.60.40.10-FF-003924', NULL, NULL, 107, NULL, NULL, 52265),
(52266, '1.20.120.80-FF-000020', NULL, 'Cytochrome c oxidase polypeptide I', 181, NULL, NULL, 52266),
(52267, '1.10.510.10-FF-001482', NULL, 'Serine/threonine-protein kinase 1', 260, NULL, NULL, 52267),
(52268, '2.130.10.10-FF-003615', NULL, 'Uncharacterized protein', 334, NULL, NULL, 52268),
(52269, '3.40.30.10-FF-000319', NULL, 'Thioredoxin domain-containing protein PLP3B', 135, NULL, NULL, 52269),
(52270, '3.20.20.70-FF-000461', NULL, 'Magnesium-dependent deoxyribonuclease, TatD family, and radical SAM domain iron-sulfur oxidoreductase', 191, NULL, NULL, 52270),
(52271, '3.20.20.70-FF-000747', NULL, NULL, 67, NULL, NULL, 52271),
(52272, '3.20.20.80-FF-000464', NULL, 'Beta-glucosidase 40', 388, NULL, NULL, 52272),
(52273, '1.10.238.10-FF-000224', NULL, 'CMD1p Calmodulin', 146, NULL, NULL, 52273),
(52274, '2.130.10.10-FF-005173', NULL, 'Uncharacterized protein', 127, NULL, NULL, 52274),
(52275, '2.40.330.10-FF-000001', NULL, 'Auxin response factor', 105, NULL, NULL, 52275),
(52276, '1.25.40.10-FF-002310', NULL, 'Pentatricopeptide repeat-containing protein At1g77170, mitochondrial', 114, NULL, NULL, 52276),
(52277, '3.30.980.10-FF-000048', NULL, 'Threonine--tRNA ligase', 80, NULL, NULL, 52277),
(52278, '1.10.510.10-FF-002274', NULL, NULL, 176, NULL, NULL, 52278),
(52279, '2.60.120.680-FF-000015', NULL, 'Oxysterol-binding protein related protein', 107, NULL, NULL, 52279),
(52280, '3.40.50.620-FF-000659', NULL, 'DALR anticodon binding domain containing protein', 128, NULL, NULL, 52280),
(52281, '2.130.10.10-FF-004897', NULL, 'Uncharacterized protein', 114, NULL, NULL, 52281),
(52282, '1.10.3080.10-FF-000008', NULL, 'Chloride channel protein', 445, NULL, NULL, 52282),
(52283, '1.20.1740.10-FF-000118', NULL, 'Amino acid permease, putative', 412, NULL, NULL, 52283),
(52284, '2.60.120.620-FF-000104', NULL, 'Predicted protein', 184, NULL, NULL, 52284),
(52285, '3.30.160.60-FF-006313', NULL, NULL, 29, NULL, NULL, 52285),
(52286, '3.30.200.20-FF-001084', NULL, 'Serine/threonine protein kinase', 97, NULL, NULL, 52286),
(52287, '1.25.10.10-FF-000201', NULL, 'Importin beta-3 subunit', 1063, NULL, NULL, 52287),
(52288, '2.60.120.10-FF-000099', NULL, '1,2-dihydroxy-3-keto-5-methylthiopentene dioxygenase', 180, NULL, NULL, 52288),
(52289, '1.10.287.130-FF-000216', NULL, 'Two-component system sensor protein', 64, NULL, NULL, 52289),
(52290, '3.30.70.890-FF-000016', NULL, 'Homoserine kinase', 135, NULL, NULL, 52290),
(52291, '1.10.10.10-FF-001364', NULL, 'Protein CBR-DSH-2', 97, NULL, NULL, 52291),
(52292, '1.20.5.340-FF-000121', NULL, 'Uncharacterized protein', 80, NULL, NULL, 52292),
(52293, '1.10.510.10-FF-003691', NULL, NULL, 168, NULL, NULL, 52293),
(52294, '3.30.160.60-FF-005818', NULL, NULL, 38, NULL, NULL, 52294),
(52295, '1.10.8.60-FF-000248', NULL, 'AAA family ATPase', 86, NULL, NULL, 52295),
(52296, '3.60.10.10-FF-000194', NULL, 'Endonuclease/exonuclease/phosphatase family protein', 302, NULL, NULL, 52296),
(52297, '3.30.160.60-FF-001367', NULL, 'replication initiator 1 isoform X1', 42, NULL, NULL, 52297),
(52298, '1.25.10.10-FF-000066', NULL, 'Splicing factor 3B subunit 1', 284, NULL, NULL, 52298),
(52299, '1.10.1040.50-FF-000028', NULL, NULL, 127, NULL, NULL, 52299),
(52300, '3.40.50.2300-FF-000679', NULL, 'Peroxide stress-activated histidine kinase mak2', 140, NULL, NULL, 52300),
(52301, '1.10.510.10-FF-000200', NULL, 'inactive tyrosine-protein kinase 7', 192, NULL, NULL, 52301),
(52302, '1.10.20.10-FF-000055', NULL, 'Transcription initiation factor TFIID subunit 11', 90, NULL, NULL, 52302),
(52303, '3.90.1200.10-FF-000066', NULL, 'Aminoglycoside phosphotransferase', 213, NULL, NULL, 52303),
(52304, '3.30.160.60-FF-000681', NULL, 'zinc finger protein 205 isoform X1', 27, NULL, NULL, 52304),
(52305, '3.90.1200.10-FF-000009', NULL, 'Acyl-CoA dehydrogenase family member 11', 235, NULL, NULL, 52305),
(52306, '1.20.120.550-FF-000003', NULL, 'Leukotriene C4 synthase', 147, NULL, NULL, 52306),
(52307, '3.40.140.10-FF-000191', NULL, 'Cytidine deaminase', 132, NULL, NULL, 52307);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(52308, '1.10.520.10-FF-000026', NULL, 'Peroxidase', 131, NULL, NULL, 52308),
(52309, '3.30.70.1230-FF-000181', NULL, 'Protein kinase, putative', 178, NULL, NULL, 52309),
(52310, '1.20.5.110-FF-000344', NULL, 'Predicted protein', 47, NULL, NULL, 52310),
(52311, '1.10.287.70-FF-000557', NULL, 'Voltage-dependent calcium channel type A subunit alpha-1-like Protein', 74, NULL, NULL, 52311),
(52312, '1.20.120.350-FF-000123', NULL, 'Potassium channel subunit', 112, NULL, NULL, 52312),
(52313, '1.10.600.10-FF-000084', NULL, 'Phytoene/squalene synthase family protein', 271, NULL, NULL, 52313),
(52314, '3.40.50.10190-FF-000061', NULL, 'Transcription coactivator', 89, NULL, NULL, 52314),
(52315, '1.20.1050.20-FF-000012', NULL, NULL, 83, NULL, NULL, 52315),
(52316, '1.10.287.110-FF-000210', NULL, 'DnaJ domain containing protein, putative', 94, NULL, NULL, 52316),
(52317, '2.30.31.10-FF-000021', NULL, 'SsDNA-binding transcriptional regulator', 52, NULL, NULL, 52317),
(52318, '3.30.70.870-FF-000010', NULL, 'GTP-binding translation elongation factor, putative', 106, NULL, NULL, 52318),
(52319, '3.80.10.10-FF-000822', NULL, 'Patatin', 171, NULL, NULL, 52319),
(52320, '2.60.40.10-FF-000411', NULL, 'Vascular endothelial growth factor receptor 3', 140, NULL, NULL, 52320),
(52321, '2.30.30.140-FF-000259', NULL, 'SGF29 tudor-like domain-containing protein', 61, NULL, NULL, 52321),
(52322, '3.30.40.10-FF-000961', NULL, 'TNF-receptor-associated factor 2', 63, NULL, NULL, 52322),
(52323, '3.30.465.10-FF-000099', NULL, 'Xanthine dehydrogenase/oxidase', 129, NULL, NULL, 52323),
(52324, '3.30.420.40-FF-000510', NULL, 'Kanosamine kinase', 137, NULL, NULL, 52324),
(52325, '3.20.20.140-FF-000446', NULL, 'Polymerase/histidinol phosphatase-like', 73, NULL, NULL, 52325),
(52326, '3.30.1330.80-FF-000003', NULL, 'AT-hook motif nuclear-localized protein 1-like', 132, NULL, NULL, 52326),
(52327, '2.10.25.10-FF-001261', NULL, 'Bb-cadherin', 38, NULL, NULL, 52327),
(52328, '1.25.10.10-FF-001426', NULL, 'Spindle pole body protein, putative', 238, NULL, NULL, 52328),
(52329, '3.50.50.60-FF-000829', NULL, 'YALI0D21076p', 114, NULL, NULL, 52329),
(52330, '1.10.1420.10-FF-000181', NULL, 'Uncharacterized protein', 88, NULL, NULL, 52330),
(52331, '1.20.1250.20-FF-001180', NULL, 'Pantothenate transporter', 200, NULL, NULL, 52331),
(52332, '3.30.1360.120-FF-000085', NULL, 'Aminomethyltransferase', 132, NULL, NULL, 52332),
(52333, '3.90.70.10-FF-000005', NULL, 'Ubiquitin carboxyl-terminal hydrolase 7', 312, NULL, NULL, 52333),
(52334, '1.10.20.120-FF-000006', NULL, 'Uncharacterized protein', 210, NULL, NULL, 52334),
(52335, '1.20.58.60-FF-000437', NULL, 'Dystonin', 187, NULL, NULL, 52335),
(52336, '3.20.20.70-FF-000186', NULL, 'Lipoyl synthase', 217, NULL, NULL, 52336),
(52337, '2.60.120.1540-FF-000020', NULL, 'Complement component 4A (Rodgers blood group)', 68, NULL, NULL, 52337),
(52338, '3.20.20.80-FF-000189', NULL, 'Endoglucanase', 315, NULL, NULL, 52338),
(52339, '1.10.3520.10-FF-000026', NULL, 'ceramide-1-phosphate transfer protein', 218, NULL, NULL, 52339),
(52340, '3.30.160.330-FF-000003', NULL, 'Protein E7', 56, NULL, NULL, 52340),
(52341, '3.40.50.2020-FF-000067', NULL, 'Ribose-phosphate diphosphokinase', 51, NULL, NULL, 52341),
(52342, '2.70.98.30-FF-000044', NULL, 'Uncharacterized protein', 46, NULL, NULL, 52342),
(52343, '2.10.25.10-FF-000367', NULL, 'EGF-containing fibulin-like extracellular matrix protein 2', 48, NULL, NULL, 52343),
(52344, '3.40.50.1110-FF-000069', NULL, 'GDSL esterase/lipase 6', 326, NULL, NULL, 52344),
(52345, '3.30.160.60-FF-002159', NULL, 'Zinc finger protein 841', 29, NULL, NULL, 52345),
(52346, '1.20.1110.10-FF-000026', NULL, 'Cation-transporting ATPase', 252, NULL, NULL, 52346),
(52347, '3.30.1120.90-FF-000001', NULL, 'Nucleosome assembly protein 1-like 1', 184, NULL, NULL, 52347),
(52348, '3.90.1410.10-FF-000109', NULL, 'Predicted protein', 235, NULL, NULL, 52348),
(52349, '2.10.25.10-FF-000985', NULL, 'NIDogen (Basement membrane protein)', 39, NULL, NULL, 52349),
(52350, '2.60.120.200-FF-000714', NULL, 'Uncharacterized protein', 178, NULL, NULL, 52350);
INSERT INTO "PUBLIC"."MODEL" VALUES
(52351, '3.40.50.300-FF-005914', NULL, 'ATP-binding cassette transporter (ABC transporter) family C member 11', 276, NULL, NULL, 52351),
(52352, '3.40.50.300-FF-001120', NULL, 'ADP-ribosylation factor family', 176, NULL, NULL, 52352),
(52353, '3.40.50.11040-FF-000001', NULL, 'RNA cytidine acetyltransferase', 198, NULL, NULL, 52353),
(52354, '3.40.50.10190-FF-000268', NULL, 'Putative dna topoisomerase 2-binding protein 1 isoform x1', 100, NULL, NULL, 52354),
(52355, '3.40.1370.10-FF-000016', NULL, '60S ribosomal protein L4, mitochondrial', 229, NULL, NULL, 52355),
(52356, '3.40.47.10-FF-000043', NULL, '3-hydroxy-3-methylglutaryl CoA synthase', 240, NULL, NULL, 52356),
(52357, '2.130.10.10-FF-005914', NULL, 'Uncharacterized protein', 278, NULL, NULL, 52357),
(52358, '3.30.450.20-FF-000298', NULL, 'Methyl-accepting chemotaxis protein', 152, NULL, NULL, 52358),
(52359, '1.20.5.4820-FF-000007', NULL, 'Myosin-A', 113, NULL, NULL, 52359),
(52360, '3.90.780.10-FF-000031', NULL, 'Putative nucleotidase YunD', 180, NULL, NULL, 52360),
(52361, '3.30.479.20-FF-000055', NULL, 'Elongation factor Ts 2, mitochondrial', 117, NULL, NULL, 52361),
(52362, '2.40.50.100-FF-000221', NULL, 'Uncharacterized protein', 20, NULL, NULL, 52362),
(52363, '2.20.28.230-FF-000010', NULL, NULL, 36, NULL, NULL, 52363),
(52364, '1.50.40.10-FF-000178', NULL, 'Mitochondrial Carrier (MC) Family', 247, NULL, NULL, 52364),
(52365, '3.40.50.1820-FF-000866', NULL, 'Uncharacterized protein', 239, NULL, NULL, 52365),
(52366, '3.40.50.300-FF-001974', NULL, 'DNA mismatch repair protein MutS', 293, NULL, NULL, 52366),
(52367, '3.30.160.60-FF-002721', NULL, NULL, 27, NULL, NULL, 52367),
(52368, '3.30.1540.20-FF-000012', NULL, 'MutL homolog 3 (E. coli)', 102, NULL, NULL, 52368),
(52369, '3.90.380.10-FF-000006', NULL, 'Chlorophyllide a oxygenase, chloroplastic', 187, NULL, NULL, 52369),
(52370, '1.10.10.60-FF-001238', NULL, NULL, 48, NULL, NULL, 52370),
(52371, '3.40.50.300-FF-002542', NULL, 'ATP-dependent RNA helicase cgh-1', 206, NULL, NULL, 52371),
(52372, '3.40.50.720-FF-000982', NULL, 'NmrA-like family protein (AFU_orthologue AFUA_8G01860)', 310, NULL, NULL, 52372),
(52373, '1.10.10.10-FF-000228', NULL, 'heterochromatin protein 1-binding protein 3 isoform X1', 73, NULL, NULL, 52373),
(52374, '1.10.150.80-FF-000018', NULL, 'Putative ribonuclease D', 92, NULL, NULL, 52374),
(52375, '2.30.330.10-FF-000003', NULL, 'Flagellar motor switch protein FliM', 81, NULL, NULL, 52375),
(52376, '3.40.30.10-FF-000645', NULL, 'Glutathione peroxidase', 140, NULL, NULL, 52376),
(52377, '3.30.160.60-FF-003177', NULL, 'Zinc finger protein 25', 42, NULL, NULL, 52377),
(52378, '2.60.40.10-FF-003688', NULL, NULL, 104, NULL, NULL, 52378),
(52379, '3.90.1100.10-FF-000002', NULL, 'DNA-directed RNA polymerase subunit beta', 137, NULL, NULL, 52379),
(52380, '1.20.1740.10-FF-000096', NULL, 'Amino Acid Transporter', 453, NULL, NULL, 52380),
(52381, '1.10.640.10-FF-000069', NULL, 'Uncharacterized protein', 161, NULL, NULL, 52381),
(52382, '2.60.40.10-FF-000029', NULL, 'Myomesin 1', 100, NULL, NULL, 52382),
(52383, '1.10.238.10-FF-000550', NULL, 'EF-hand calcium-binding domain 6', 80, NULL, NULL, 52383),
(52384, '3.90.1170.30-FF-000001', NULL, 'Thymidine phosphorylase', 97, NULL, NULL, 52384),
(52385, '3.40.50.200-FF-000191', NULL, 'Uncharacterized protein', 283, NULL, NULL, 52385),
(52386, '3.40.50.300-FF-000395', NULL, 'Replication factor C subunit 1', 183, NULL, NULL, 52386),
(52387, '3.40.50.300-FF-000451', NULL, 'Neuron navigator 2', 158, NULL, NULL, 52387),
(52388, '3.10.580.10-FF-000163', NULL, 'Uncharacterized protein', 78, NULL, NULL, 52388),
(52389, '3.20.20.60-FF-000065', NULL, 'Pyruvate kinase', 231, NULL, NULL, 52389),
(52390, '3.90.550.10-FF-000660', NULL, 'Uncharacterized protein', 123, NULL, NULL, 52390),
(52391, '2.30.42.10-FF-000288', NULL, 'MAGI family member, X-linked a', 108, NULL, NULL, 52391),
(52392, '3.30.70.100-FF-000156', NULL, NULL, 74, NULL, NULL, 52392),
(52393, '2.30.30.40-FF-000218', NULL, 'Myosin light chain kinase, smooth muscle', 67, NULL, NULL, 52393);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(52394, '3.30.200.20-FF-000072', NULL, 'Rho-associated protein kinase 2', 147, NULL, NULL, 52394),
(52395, '1.10.510.10-FF-003808', NULL, NULL, 119, NULL, NULL, 52395),
(52396, '1.10.287.2900-FF-000003', NULL, 'mitochondrial intermembrane space import and assembly protein 40', 78, NULL, NULL, 52396),
(52397, '2.130.10.10-FF-000007', NULL, 'Guanine nucleotide-binding protein G(I)/G(S)/G(T) subunit beta-1', 340, NULL, NULL, 52397),
(52398, '1.25.40.660-FF-000016', NULL, 'Vacuolar protein sorting-associated protein 35', 315, NULL, NULL, 52398),
(52399, '3.40.50.2000-FF-001101', NULL, 'Protein CBG00513', 47, NULL, NULL, 52399),
(52400, '1.10.10.1740-FF-000007', NULL, 'Transmembrane proteins 14C, putative', 100, NULL, NULL, 52400),
(52401, '1.10.560.10-FF-000068', NULL, 'GD22056', 245, NULL, NULL, 52401),
(52402, '1.10.1740.10-FF-000008', NULL, 'RNA polymerase sigma factor PvdS', 71, NULL, NULL, 52402),
(52403, '2.60.40.10-FF-001597', NULL, 'V-type immunoglobulin domain-containing suppressor of T-cell activation', 129, NULL, NULL, 52403),
(52404, '3.30.160.20-FF-000079', NULL, 'Disco interacting protein isoform TO67', 77, NULL, NULL, 52404),
(52405, '3.20.10.10-FF-000072', NULL, 'Uncharacterized protein', 132, NULL, NULL, 52405),
(52406, '3.40.50.2000-FF-000477', NULL, 'Uncharacterized protein', 209, NULL, NULL, 52406),
(52407, '3.90.70.10-FF-000331', NULL, 'Clan CA, family C1, cathepsin L-like cysteine peptidase', 273, NULL, NULL, 52407),
(52408, '2.40.240.10-FF-000028', NULL, 'Probable glutamine-tRNA ligase', 155, NULL, NULL, 52408),
(52409, '2.10.270.10-FF-000003', NULL, 'Toxin B', 92, NULL, NULL, 52409),
(52410, '1.10.510.10-FF-001717', NULL, 'Ribosomal protein S6 kinase A1', 95, NULL, NULL, 52410),
(52411, '3.30.70.260-FF-000125', NULL, 'Homoserine dehydrogenase', 82, NULL, NULL, 52411),
(52412, '3.30.200.20-FF-001651', NULL, 'Kinase, NEK', 87, NULL, NULL, 52412),
(52413, '3.30.70.330-FF-003018', NULL, NULL, 70, NULL, NULL, 52413),
(52414, '1.10.238.110-FF-000009', NULL, 'Diacylglycerol kinase', 92, NULL, NULL, 52414),
(52415, '2.10.25.10-FF-000709', NULL, 'Protocadherin Fat 4', 38, NULL, NULL, 52415),
(52416, '4.10.280.50-FF-000007', NULL, 'Glutamate decarboxylase', 61, NULL, NULL, 52416),
(52417, '4.10.400.10-FF-000236', NULL, 'AGAP003656-PC', 37, NULL, NULL, 52417),
(52418, '1.10.472.80-FF-000283', NULL, NULL, 114, NULL, NULL, 52418),
(52419, '1.10.10.430-FF-000002', NULL, 'Protein phosphatase, Mg2+/Mn2+ dependent 1A', 72, NULL, NULL, 52419),
(52420, '1.10.565.10-FF-000057', NULL, 'Retinoid x receptor', 232, NULL, NULL, 52420),
(52421, '1.10.10.440-FF-000005', NULL, 'Transcription elongation regulator 1 (CA150)', 61, NULL, NULL, 52421),
(52422, '2.40.50.40-FF-000079', NULL, 'Uncharacterized protein', 67, NULL, NULL, 52422),
(52423, '3.20.80.10-FF-000020', NULL, 'Uncharacterized protein', 158, NULL, NULL, 52423),
(52424, '3.30.160.60-FF-003284', NULL, 'KRAB zinc finger protein', 35, NULL, NULL, 52424),
(52425, '3.40.50.150-FF-000440', NULL, 'Os09g0479300 protein', 152, NULL, NULL, 52425),
(52426, '3.30.200.20-FF-001595', NULL, 'Serine/threonine protein kinase', 129, NULL, NULL, 52426),
(52427, '3.40.50.1820-FF-001541', NULL, 'Uncharacterized protein', 133, NULL, NULL, 52427),
(52428, '2.30.42.10-FF-000395', NULL, NULL, 109, NULL, NULL, 52428),
(52429, '2.60.40.2840-FF-000011', NULL, 'calcium-binding and coiled-coil domain-containing protein 2 isoform X4', 69, NULL, NULL, 52429),
(52430, '2.60.40.1730-FF-000021', NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', 219, NULL, NULL, 52430),
(52431, '3.40.50.300-FF-005919', NULL, 'ABC transporter ATP-binding protein', 273, NULL, NULL, 52431),
(52432, '3.90.550.10-FF-000334', NULL, 'CMP-N-acetlyneuraminic acid synthetase', 226, NULL, NULL, 52432),
(52433, '3.30.70.3310-FF-000007', NULL, 'Uncharacterized protein', 127, NULL, NULL, 52433),
(52434, '3.20.20.70-FF-000124', NULL, 'Heme chaperone HemW', 214, NULL, NULL, 52434),
(52435, '3.30.565.10-FF-000432', NULL, 'Histidine kinase response regulator hybrid protein', 166, NULL, NULL, 52435);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(52436, '3.80.10.10-FF-001603', NULL, 'Protein kinase family protein with leucine-rich repeat domain', 268, NULL, NULL, 52436),
(52437, '2.130.10.10-FF-002250', NULL, 'Uncharacterized protein', 334, NULL, NULL, 52437),
(52438, '3.30.200.20-FF-001325', NULL, 'Mitogen-activated protein kinase', 21, NULL, NULL, 52438),
(52439, '3.30.70.330-FF-001624', NULL, NULL, 73, NULL, NULL, 52439),
(52440, '1.20.1640.10-FF-000111', NULL, NULL, 210, NULL, NULL, 52440),
(52441, '3.10.20.90-FF-000372', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 72, NULL, NULL, 52441),
(52442, '2.10.25.10-FF-000721', NULL, 'Odd Oz/ten-m (Odz2), mRNA protein', 32, NULL, NULL, 52442),
(52443, '3.20.20.60-FF-000121', NULL, 'Uncharacterized protein', 14, NULL, NULL, 52443),
(52444, '3.30.1600.10-FF-000003', NULL, 'NAD-dependent histone deacetylase sirtuin-1', 114, NULL, NULL, 52444),
(52445, '3.40.50.300-FF-003739', NULL, 'Peroxisomal biogenesis factor 6', 165, NULL, NULL, 52445),
(52446, '3.30.450.20-FF-000528', NULL, 'Histidine kinase', 136, NULL, NULL, 52446),
(52447, '1.20.1310.10-FF-000125', NULL, NULL, 131, NULL, NULL, 52447),
(52448, '1.20.58.100-FF-000015', NULL, NULL, 116, NULL, NULL, 52448),
(52449, '2.60.40.10-FF-002272', NULL, 'Paired immunoglobulin-like receptor B', 95, NULL, NULL, 52449),
(52450, '3.40.30.10-FF-000971', NULL, 'Uncharacterized protein', 97, NULL, NULL, 52450),
(52451, '3.30.70.100-FF-000105', NULL, NULL, 77, NULL, NULL, 52451),
(52452, '3.40.50.880-FF-000080', NULL, 'Para-aminobenzoate synthase, glutamine amidotransferase, component II', 189, NULL, NULL, 52452),
(52453, '3.40.50.10420-FF-000051', NULL, 'Probable 5-formyltetrahydrofolate cyclo-ligase', 200, NULL, NULL, 52453),
(52454, '3.20.20.60-FF-000014', NULL, 'Citrate lyase subunit beta-like protein', 305, NULL, NULL, 52454),
(52455, '3.20.20.70-FF-000017', NULL, 'Glutamate synthase [NADH], amyloplastic', 421, NULL, NULL, 52455),
(52456, '3.40.250.10-FF-000255', NULL, 'Predicted protein', 65, NULL, NULL, 52456),
(52457, '3.40.30.10-FF-000701', NULL, 'Sulfhydryl oxidase', 77, NULL, NULL, 52457),
(52458, '1.20.1640.10-FF-000004', NULL, 'Protein translocase subunit SecD', 183, NULL, NULL, 52458),
(52459, '1.10.510.10-FF-000464', NULL, 'Protein O-mannose kinase', 303, NULL, NULL, 52459),
(52460, '2.130.10.10-FF-001249', NULL, 'WD repeat domain 54', 253, NULL, NULL, 52460),
(52461, '3.40.50.300-FF-001648', NULL, 'ABC transporter', 229, NULL, NULL, 52461),
(52462, '1.10.10.10-FF-001807', NULL, 'Transcriptional adapter', 82, NULL, NULL, 52462),
(52463, '1.20.144.10-FF-000043', NULL, 'GD12067', 228, NULL, NULL, 52463),
(52464, '1.10.275.60-FF-000004', NULL, 'Predicted protein', 32, NULL, NULL, 52464),
(52465, '4.10.400.10-FF-000343', NULL, 'Uncharacterized protein', 36, NULL, NULL, 52465),
(52466, '2.70.130.10-FF-000108', NULL, NULL, 146, NULL, NULL, 52466),
(52467, '1.25.40.10-FF-002041', NULL, 'Pentatricopeptide repeat-containing protein At1g09900', 126, NULL, NULL, 52467),
(52468, '2.130.10.30-FF-000165', NULL, NULL, 97, NULL, NULL, 52468),
(52469, '3.30.470.30-FF-000004', NULL, 'mRNA-capping enzyme', 163, NULL, NULL, 52469),
(52470, '1.25.40.20-FF-000806', NULL, 'Predicted protein', 116, NULL, NULL, 52470),
(52471, '1.10.287.110-FF-000042', NULL, 'Iron-sulfur cluster co-chaperone protein HscB, mitochondrial', 114, NULL, NULL, 52471),
(52472, '1.20.58.2220-FF-000025', NULL, 'Formin-E', 381, NULL, NULL, 52472),
(52473, '3.40.50.1010-FF-000157', NULL, NULL, 183, NULL, NULL, 52473),
(52474, '3.40.50.1820-FF-000928', NULL, 'Carboxylic ester hydrolase', 555, NULL, NULL, 52474),
(52475, '3.40.50.2300-FF-001292', NULL, NULL, 142, NULL, NULL, 52475),
(52476, '1.20.120.290-FF-000003', NULL, 'Photosynthetic NDH subunit of lumenal location 3, chloroplastic', 139, NULL, NULL, 52476),
(52477, '3.80.10.10-FF-002907', NULL, 'Uncharacterized protein', 100, NULL, NULL, 52477),
(52478, '3.40.640.10-FF-000010', NULL, 'Phosphoserine aminotransferase', 246, NULL, NULL, 52478),
(52479, '3.40.50.720-FF-000875', NULL, 'tRNA threonylcarbamoyladenosine dehydratase 1', 265, NULL, NULL, 52479);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(52480, '3.30.200.20-FF-000021', NULL, 'probable serine/threonine-protein kinase At1g54610', 96, NULL, NULL, 52480),
(52481, '3.30.360.10-FF-000136', NULL, 'Predicted protein', 135, NULL, NULL, 52481),
(52482, '3.30.160.60-FF-004071', NULL, NULL, 61, NULL, NULL, 52482),
(52483, '2.40.440.10-FF-000009', NULL, 'L,D-transpeptidase', 137, NULL, NULL, 52483),
(52484, '2.60.40.200-FF-000031', NULL, 'Uncharacterized protein', 110, NULL, NULL, 52484),
(52485, '1.25.10.10-FF-002325', NULL, 'Uncharacterized protein', 304, NULL, NULL, 52485),
(52486, '3.40.630.30-FF-000633', NULL, 'Uncharacterized protein', 179, NULL, NULL, 52486),
(52487, '2.130.10.10-FF-003559', NULL, 'Uncharacterized protein', 179, NULL, NULL, 52487),
(52488, '1.20.1310.10-FF-000018', NULL, 'Cullin 2', 114, NULL, NULL, 52488),
(52489, '1.10.10.650-FF-000006', NULL, 'Uncharacterized protein', 167, NULL, NULL, 52489),
(52490, '3.30.70.330-FF-002299', NULL, NULL, 153, NULL, NULL, 52490),
(52491, '2.60.120.10-FF-000149', NULL, '1,2-dihydroxy-3-keto-5-methylthiopentene dioxygenase homolog', 157, NULL, NULL, 52491),
(52492, '2.60.40.10-FF-000181', NULL, 'receptor-type tyrosine-protein phosphatase delta isoform X4', 87, NULL, NULL, 52492),
(52493, '3.80.10.10-FF-000816', NULL, 'Nuclear RNA export factor 2', 151, NULL, NULL, 52493),
(52494, '3.30.40.10-FF-001063', NULL, 'Putative ring finger protein', 68, NULL, NULL, 52494),
(52495, '1.25.10.10-FF-002213', NULL, 'Nipped-B protein', 421, NULL, NULL, 52495),
(52496, '3.40.50.12160-FF-000005', NULL, 'threonylcarbamoyladenosine tRNA methylthiotransferase isoform X1', 122, NULL, NULL, 52496),
(52497, '1.10.287.1490-FF-000057', NULL, 'At5g52280', 143, NULL, NULL, 52497),
(52498, '1.10.287.1490-FF-000001', NULL, 'Putative phosphatidylinositol 3-kinase regulatory subunit alpha', 169, NULL, NULL, 52498),
(52499, '3.40.50.2300-FF-001247', NULL, NULL, 30, NULL, NULL, 52499),
(52500, '1.10.8.60-FF-000304', NULL, 'AAA-domain-containing protein', 83, NULL, NULL, 52500),
(52501, '1.10.437.10-FF-000063', NULL, 'Uncharacterized protein', 210, NULL, NULL, 52501),
(52502, '1.10.8.60-FF-000416', NULL, 'Replication factor C subunit 1', 65, NULL, NULL, 52502),
(52503, '2.120.10.90-FF-000008', NULL, 'DNA gyrase subunit A', 270, NULL, NULL, 52503),
(52504, '3.30.70.1230-FF-000243', NULL, 'Adenylyl cyclase', 90, NULL, NULL, 52504),
(52505, '1.20.5.3310-FF-000004', NULL, 'Sec-independent protein translocase protein TatA', 47, NULL, NULL, 52505),
(52506, '3.30.420.210-FF-000004', NULL, 'UBX domain-containing protein 2A', 63, NULL, NULL, 52506),
(52507, '2.180.10.10-FF-000033', NULL, 'Uncharacterized protein', 413, NULL, NULL, 52507),
(52508, '1.10.510.10-FF-000357', NULL, 'Mitogen-activated protein kinase kinase kinase 5', 302, NULL, NULL, 52508),
(52509, '3.90.640.10-FF-000049', NULL, 'Putative actin-related protein', 72, NULL, NULL, 52509),
(52510, '3.30.160.60-FF-000304', NULL, 'Zinc finger and BTB domain-containing protein 20', 26, NULL, NULL, 52510),
(52511, '1.20.58.1240-FF-000001', NULL, 'Conserved oligomeric Golgi complex component', 154, NULL, NULL, 52511),
(52512, '3.40.250.10-FF-000199', NULL, 'Dual specificity protein phosphatase', 132, NULL, NULL, 52512),
(52513, '3.40.50.10130-FF-000026', NULL, 'FA core complex-associated protein 24', 143, NULL, NULL, 52513),
(52514, '1.20.1300.20-FF-000010', NULL, 'cDNA clone:J023014N14, full insert sequence', 60, NULL, NULL, 52514),
(52515, '2.60.40.1730-FF-000072', NULL, NULL, 65, NULL, NULL, 52515),
(52516, '3.40.50.720-FF-000931', NULL, 'Short chain dehydrogenase family protein', 248, NULL, NULL, 52516),
(52517, '3.40.50.300-FF-000125', NULL, 'Guanine nucleotide-binding protein G(Q) subunit alpha', 189, NULL, NULL, 52517),
(52518, '2.40.10.340-FF-000015', NULL, 'Uncharacterized protein', 69, NULL, NULL, 52518),
(52519, '3.40.1380.20-FF-000020', NULL, 'Pyruvate kinase', 148, NULL, NULL, 52519),
(52520, '2.40.50.100-FF-000108', NULL, 'DNA-directed RNA polymerase subunit beta''', 89, NULL, NULL, 52520),
(52521, '1.20.58.1250-FF-000004', NULL, 'Unplaced genomic scaffold supercont2.7, whole genome shotgun sequence', 89, NULL, NULL, 52521);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(52522, '3.60.10.10-FF-000368', NULL, 'Type I inositol polyphosphate 5-phosphatase 10', 113, NULL, NULL, 52522),
(52523, '3.90.550.10-FF-000008', NULL, 'UTP--glucose-1-phosphate uridylyltransferase', 302, NULL, NULL, 52523),
(52524, '2.130.10.10-FF-003492', NULL, 'GPI inositol-deacylase', 272, NULL, NULL, 52524),
(52525, '3.30.1370.30-FF-000013', NULL, 'Ribosomal Protein, Small subunit', 40, NULL, NULL, 52525),
(52526, '3.30.565.10-FF-000106', NULL, 'Two-component system sensor histidine kinase', 157, NULL, NULL, 52526),
(52527, '3.60.21.10-FF-000157', NULL, 'Metallophosphoesterase', 186, NULL, NULL, 52527),
(52528, '3.40.850.10-FF-000458', NULL, 'Predicted protein', 54, NULL, NULL, 52528),
(52529, '3.10.20.30-FF-000045', NULL, 'Obg-like ATPase 1', 99, NULL, NULL, 52529),
(52530, '1.10.472.80-FF-000171', NULL, NULL, 78, NULL, NULL, 52530),
(52531, '1.10.10.10-FF-001870', NULL, 'Predicted protein', 63, NULL, NULL, 52531),
(52532, '3.10.250.10-FF-000065', NULL, 'Uncharacterized protein', 110, NULL, NULL, 52532),
(52533, '1.20.1070.10-FF-001090', NULL, 'Visual pigment-like receptor peropsin', 319, NULL, NULL, 52533),
(52534, '1.20.1560.10-FF-000907', NULL, 'Novel protein similar to human transporter 2, ATP-binding cassette, sub-family B (MDR/TAP2)', 165, NULL, NULL, 52534),
(52535, '1.10.560.10-FF-000124', NULL, 'Chaperonin-containing TCP1, subunit 2 (beta)', 98, NULL, NULL, 52535),
(52536, '3.30.70.260-FF-000069', NULL, 'Ribose-5-phosphate isomerase A', 84, NULL, NULL, 52536),
(52537, '1.20.1250.20-FF-000926', NULL, 'Major facilitator superfamily (MFS) transporter', 189, NULL, NULL, 52537),
(52538, '3.40.50.300-FF-003891', NULL, 'Heme ABC transporter ATP-binding protein', 256, NULL, NULL, 52538),
(52539, '3.30.40.10-FF-001012', NULL, 'Alcohol sensitive Ring/PHD finger', 59, NULL, NULL, 52539),
(52540, '1.25.40.20-FF-001588', NULL, 'Ankyrin repeat domain-containing protein 27-like Protein', 118, NULL, NULL, 52540),
(52541, '2.60.490.10-FF-000025', NULL, 'Predicted protein', 48, NULL, NULL, 52541),
(52542, '3.30.160.60-FF-000804', NULL, 'PR domain zinc finger protein 4', 49, NULL, NULL, 52542),
(52543, '1.10.1070.11-FF-000031', NULL, 'Phosphatidyl inositol 3-kinase', 191, NULL, NULL, 52543),
(52544, '1.25.10.10-FF-000122', NULL, 'Mitogen-activated protein kinase kinase kinase 1 (Predicted)', 260, NULL, NULL, 52544),
(52545, '3.30.710.10-FF-000349', NULL, 'Uncharacterized protein', 124, NULL, NULL, 52545),
(52546, '1.10.3720.10-FF-000018', NULL, 'Molybdenum transport system permease', 223, NULL, NULL, 52546),
(52547, '2.130.10.10-FF-002362', NULL, 'Guanine nucleotide-binding protein subunit beta-like protein 1', 152, NULL, NULL, 52547),
(52548, '3.40.50.1820-FF-000187', NULL, 'Phosphatidylcholine-sterol acyltransferase', 173, NULL, NULL, 52548),
(52549, '1.10.506.10-FF-000033', NULL, 'PLeXin', 222, NULL, NULL, 52549),
(52550, '2.60.120.560-FF-000041', NULL, 'Uncharacterized protein', 59, NULL, NULL, 52550),
(52551, '3.40.50.300-FF-007269', NULL, 'Predicted protein', 156, NULL, NULL, 52551),
(52552, '3.90.190.10-FF-000295', NULL, 'LOC100036671 protein', 164, NULL, NULL, 52552),
(52553, '1.20.1560.10-FF-000677', NULL, 'ABC transporter', 22, NULL, NULL, 52553),
(52554, '3.30.160.60-FF-001934', NULL, 'Zinc finger protein 430', 28, NULL, NULL, 52554),
(52555, '1.10.510.10-FF-003960', NULL, NULL, 46, NULL, NULL, 52555),
(52556, '3.40.30.10-FF-000920', NULL, 'Predicted protein', 126, NULL, NULL, 52556),
(52557, '2.170.270.10-FF-000162', NULL, 'Predicted protein', 129, NULL, NULL, 52557),
(52558, '3.40.1690.10-FF-000001', NULL, 'Flagellar biosynthetic protein FlhB', 86, NULL, NULL, 52558),
(52559, '1.10.287.470-FF-000060', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 74, NULL, NULL, 52559),
(52560, '3.40.50.300-FF-007483', NULL, 'Uncharacterized protein', 233, NULL, NULL, 52560),
(52561, '3.40.50.150-FF-000114', NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', 331, NULL, NULL, 52561),
(52562, '2.60.40.150-FF-000050', NULL, 'Multiple C2 and transmembrane domain containing 1', 133, NULL, NULL, 52562);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(52563, '2.130.10.10-FF-004048', NULL, 'Uncharacterized protein', 500, NULL, NULL, 52563),
(52564, '3.40.720.10-FF-000123', NULL, 'Predicted protein', 368, NULL, NULL, 52564),
(52565, '3.10.20.90-FF-000602', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', 199, NULL, NULL, 52565),
(52566, '3.40.1350.60-FF-000013', NULL, 'Uncharacterized protein', 55, NULL, NULL, 52566),
(52567, '2.10.60.10-FF-000055', NULL, 'RIKEN cDNA 2210407C18', 81, NULL, NULL, 52567),
(52568, '3.30.565.10-FF-000320', NULL, 'Sensor histidine kinase TodS', 174, NULL, NULL, 52568),
(52569, '3.40.250.10-FF-000143', NULL, 'Thiosulfate sulfurtransferase, putative', 160, NULL, NULL, 52569),
(52570, '3.30.160.60-FF-005650', NULL, NULL, 43, NULL, NULL, 52570),
(52571, '3.30.360.20-FF-000027', NULL, NULL, 14, NULL, NULL, 52571),
(52572, '1.50.40.10-FF-000560', NULL, 'Uncharacterized protein', 122, NULL, NULL, 52572),
(52573, '3.40.50.10810-FF-000016', NULL, 'Chromatin structure-remodeling complex protein SYD', 245, NULL, NULL, 52573),
(52574, '3.30.200.20-FF-001376', NULL, 'Uncharacterized protein', 51, NULL, NULL, 52574),
(52575, '1.10.287.110-FF-000154', NULL, 'Hypothetical_protein_-_conserved', 74, NULL, NULL, 52575),
(52576, '1.25.40.120-FF-000085', NULL, 'Prenyltransferase alpha subunit, putative', 286, NULL, NULL, 52576),
(52577, '1.20.120.1760-FF-000024', NULL, 'Probable phosphatidylinositol synthase pgsA1', 195, NULL, NULL, 52577),
(52578, '2.40.50.140-FF-001166', NULL, NULL, 66, NULL, NULL, 52578),
(52579, '3.30.40.10-FF-001282', NULL, 'Remodeling and spacing factor 1b, tandem duplicate 1', 119, NULL, NULL, 52579),
(52580, '3.30.70.330-FF-001843', NULL, NULL, 116, NULL, NULL, 52580),
(52581, '2.170.16.10-FF-000013', NULL, 'Replication factor C small subunit', 156, NULL, NULL, 52581),
(52582, '1.25.40.10-FF-003620', NULL, 'Pentatricopeptide repeat-containing protein', 104, NULL, NULL, 52582),
(52583, '3.40.640.10-FF-000122', NULL, 'Bifunctional dethiobiotin synthetase/adenosylmethionine-8-amino-7-oxononanoate aminotransferase', 327, NULL, NULL, 52583),
(52584, '3.30.360.10-FF-000024', NULL, 'Inositol-3-phosphate synthase', 109, NULL, NULL, 52584),
(52585, '2.130.10.10-FF-001468', NULL, 'WD repeat domain 55', 133, NULL, NULL, 52585),
(52586, '3.40.50.10800-FF-000013', NULL, 'Quinolinate synthase A', 104, NULL, NULL, 52586),
(52587, '6.10.140.2150-FF-000007', NULL, 'Putative sphingosine 1-phosphate lyase', 54, NULL, NULL, 52587),
(52588, '2.10.110.30-FF-000003', NULL, 'E3 ubiquitin-protein ligase UBR3 isoform X3', 48, NULL, NULL, 52588),
(52589, '3.30.1610.10-FF-000009', NULL, 'Nucleoporin, putative', 120, NULL, NULL, 52589),
(52590, '3.40.50.300-FF-002430', NULL, 'Zinc finger protein family member', 178, NULL, NULL, 52590),
(52591, '1.20.1070.10-FF-000477', NULL, 'Chemokine (C-X-C motif) receptor 3, tandem duplicate 2', 300, NULL, NULL, 52591),
(52592, '2.60.40.10-FF-005756', NULL, NULL, 142, NULL, NULL, 52592),
(52593, '3.30.930.10-FF-000107', NULL, 'Putative lipoate-protein ligase A', 263, NULL, NULL, 52593),
(52594, '3.30.420.150-FF-000020', NULL, 'Ppx/GppA phosphatase', 179, NULL, NULL, 52594),
(52595, '3.30.830.10-FF-000004', NULL, 'Putative insulin-degrading enzyme', 246, NULL, NULL, 52595),
(52596, '1.10.405.10-FF-000006', NULL, 'Rab GDP dissociation inhibitor', 105, NULL, NULL, 52596),
(52597, '1.10.1450.10-FF-000126', NULL, 'Tetraspanin', 77, NULL, NULL, 52597),
(52598, '2.60.40.2840-FF-000016', NULL, 'Uncharacterized protein', 36, NULL, NULL, 52598),
(52599, '3.60.40.10-FF-000196', NULL, 'Protein phosphatase 2C, putative', 374, NULL, NULL, 52599),
(52600, '1.25.10.10-FF-003399', NULL, 'Uncharacterized protein', 121, NULL, NULL, 52600),
(52601, '1.10.287.370-FF-000029', NULL, 'Prefoldin subunit 2 putative', 108, NULL, NULL, 52601),
(52602, '1.10.630.10-FF-000029', NULL, 'Cytochrome P450 734A1', 491, NULL, NULL, 52602),
(52603, '1.10.405.20-FF-000009', NULL, NULL, 124, NULL, NULL, 52603),
(52604, '1.50.40.10-FF-000408', NULL, 'Solute carrier family 25 member 18', 227, NULL, NULL, 52604);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(52605, '2.10.70.10-FF-000168', NULL, 'Uncharacterized protein', 58, NULL, NULL, 52605),
(52606, '1.50.40.10-FF-000122', NULL, 'Uncharacterized protein, isoform A', 194, NULL, NULL, 52606),
(52607, '1.10.510.10-FF-002830', NULL, NULL, 107, NULL, NULL, 52607),
(52608, '3.40.50.1000-FF-000328', NULL, 'BnaAnng05460D protein', 71, NULL, NULL, 52608),
(52609, '3.30.40.10-FF-001068', NULL, 'RING finger protein 44', 74, NULL, NULL, 52609),
(52610, '1.10.150.250-FF-000005', NULL, 'Succinate dehydrogenase assembly factor 2, mitochondrial', 76, NULL, NULL, 52610),
(52611, '2.30.40.10-FF-000177', NULL, 'N-substituted formamide deformylase', 71, NULL, NULL, 52611),
(52612, '3.40.50.2000-FF-000589', NULL, 'Putative teichuronic acid biosynthesis glycosyl transferase TuaC', 143, NULL, NULL, 52612),
(52613, '1.10.418.60-FF-000011', NULL, 'Uncharacterized protein', 162, NULL, NULL, 52613),
(52614, '2.60.40.10-FF-001485', NULL, 'Tripartite motif containing 45', 105, NULL, NULL, 52614),
(52615, '3.40.50.720-FF-001706', NULL, 'Erythronate-4-phosphate dehydrogenase', 166, NULL, NULL, 52615),
(52616, '3.40.720.10-FF-000067', NULL, 'Predicted protein', 198, NULL, NULL, 52616),
(52617, '3.40.50.300-FF-006701', NULL, 'Protein CBG27014', 79, NULL, NULL, 52617),
(52618, '3.30.420.10-FF-000748', NULL, NULL, 72, NULL, NULL, 52618),
(52619, '1.25.40.10-FF-001585', NULL, 'TPR repeat', 144, NULL, NULL, 52619),
(52620, '1.10.8.60-FF-000309', NULL, 'AAA family ATPase', 91, NULL, NULL, 52620),
(52621, '3.40.1110.10-FF-000188', NULL, 'Phospholipid-transporting ATPase', 252, NULL, NULL, 52621),
(52622, '3.40.30.10-FF-000533', NULL, 'ThioRedoXin [see also xtr]', 146, NULL, NULL, 52622),
(52623, '1.20.1070.10-FF-000825', NULL, 'Adrenoceptor alpha 2B', 325, NULL, NULL, 52623),
(52624, '2.30.30.40-FF-000106', NULL, 'disks large homolog 4 isoform X2', 85, NULL, NULL, 52624),
(52625, '3.60.40.10-FF-000252', NULL, 'Stage II sporulation protein E', 221, NULL, NULL, 52625),
(52626, '3.40.50.1580-FF-000013', NULL, 'Purine nucleoside phosphorylase', 270, NULL, NULL, 52626),
(52627, '3.80.10.10-FF-002385', NULL, 'Leucine Rich Repeat family protein', 111, NULL, NULL, 52627),
(52628, '1.20.1110.10-FF-000144', NULL, 'Calcium-transporting ATPase', 386, NULL, NULL, 52628),
(52629, '2.130.10.10-FF-002031', NULL, 'WD repeat domain 48b', 161, NULL, NULL, 52629),
(52630, '3.80.10.10-FF-001480', NULL, 'Leucine-rich repeat transmembrane protein kinase', 146, NULL, NULL, 52630),
(52631, '1.10.238.20-FF-000042', NULL, 'Odorant binding protein C15', 109, NULL, NULL, 52631),
(52632, '1.25.10.70-FF-000005', NULL, 'Uncharacterized protein', 295, NULL, NULL, 52632),
(52633, '3.20.20.190-FF-000085', NULL, NULL, 37, NULL, NULL, 52633),
(52634, '1.20.58.70-FF-000131', NULL, 'Uncharacterized protein', 50, NULL, NULL, 52634),
(52635, '3.40.630.30-FF-000228', NULL, 'Histone acetyltransferase', 60, NULL, NULL, 52635),
(52636, '2.60.120.200-FF-000697', NULL, 'Uncharacterized protein', 195, NULL, NULL, 52636),
(52637, '2.30.30.30-FF-000103', NULL, 'Elongation factor P 1', 62, NULL, NULL, 52637),
(52638, '2.60.40.10-FF-003963', NULL, NULL, 104, NULL, NULL, 52638),
(52639, '2.40.50.140-FF-000828', NULL, NULL, 102, NULL, NULL, 52639),
(52640, '3.30.160.60-FF-002502', NULL, NULL, 28, NULL, NULL, 52640),
(52641, '2.130.10.130-FF-000003', NULL, 'Integrin alpha V', 446, NULL, NULL, 52641),
(52642, '1.10.510.10-FF-002381', NULL, NULL, 123, NULL, NULL, 52642),
(52643, '3.30.450.40-FF-000124', NULL, 'Sigma-54 dependent transcriptional regulator', 185, NULL, NULL, 52643),
(52644, '1.10.287.370-FF-000092', NULL, 'Putative prefoldin subunit 5', 82, NULL, NULL, 52644),
(52645, '1.10.4080.10-FF-000008', NULL, 'ADP-ribosylglycohydrolase, putative', 237, NULL, NULL, 52645),
(52646, '3.90.190.10-FF-000525', NULL, 'Uncharacterized protein', 287, NULL, NULL, 52646),
(52647, '3.40.50.1100-FF-000302', NULL, 'Uncharacterized protein', 36, NULL, NULL, 52647),
(52648, '3.90.550.10-FF-000160', NULL, 'Hexosyltransferase', 269, NULL, NULL, 52648),
(52649, '1.25.40.10-FF-001933', NULL, 'Os06g0235800 protein', 252, NULL, NULL, 52649); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(52650, '2.30.29.30-FF-001145', NULL, 'Uncharacterized protein', 112, NULL, NULL, 52650),
(52651, '1.10.287.1490-FF-000006', NULL, 'Centromere protein E', 152, NULL, NULL, 52651),
(52652, '3.30.479.10-FF-000007', NULL, '6-pyruvoyltetrahydropterin synthase', 163, NULL, NULL, 52652),
(52653, '2.130.10.10-FF-001794', NULL, 'Angio-associated migratory cell protein, putative', 213, NULL, NULL, 52653),
(52654, '2.70.130.10-FF-000041', NULL, 'Protein OS-9 homolog', 138, NULL, NULL, 52654),
(52655, '2.10.25.10-FF-000479', NULL, 'Notch homolog 4, [Drosophila]', 43, NULL, NULL, 52655),
(52656, '3.40.640.10-FF-000341', NULL, 'Glutamine--scyllo-inositol transaminase', 252, NULL, NULL, 52656),
(52657, '3.60.21.10-FF-000213', NULL, 'Serine/threonine-protein phosphatase', 180, NULL, NULL, 52657),
(52658, '1.20.140.10-FF-000107', NULL, 'Uncharacterized protein', 142, NULL, NULL, 52658),
(52659, '3.30.60.30-FF-000035', NULL, 'Serine protease inhibitor dipetalogastin', 45, NULL, NULL, 52659),
(52660, '3.30.160.60-FF-001878', NULL, 'Uncharacterized protein, isoform A', 27, NULL, NULL, 52660),
(52661, '3.30.365.10-FF-000046', NULL, 'Uncharacterized protein', 43, NULL, NULL, 52661),
(52662, '3.30.70.330-FF-001006', NULL, 'Nucleolin 2', 143, NULL, NULL, 52662),
(52663, '3.30.420.40-FF-000622', NULL, 'N-methylhydantoinase A related protein (HuyA-like)', 81, NULL, NULL, 52663),
(52664, '2.170.270.10-FF-000050', NULL, 'Chromosome 1, whole genome shotgun sequence', 114, NULL, NULL, 52664),
(52665, '3.40.50.980-FF-000014', NULL, 'Non-ribosomal peptide synthetase', 168, NULL, NULL, 52665),
(52666, '3.30.1120.10-FF-000040', NULL, 'Putative secreted sulfatase ydeN', 80, NULL, NULL, 52666),
(52667, '1.10.630.10-FF-000355', NULL, 'Predicted protein', 497, NULL, NULL, 52667),
(52668, '3.30.530.20-FF-000063', NULL, 'SRPBCC family protein', 149, NULL, NULL, 52668),
(52669, '3.70.10.10-FF-000053', NULL, 'DNA polymerase processivity factor', 304, NULL, NULL, 52669),
(52670, '3.80.10.10-FF-001081', NULL, 'Ribonuclease inhibitor-like protein', 110, NULL, NULL, 52670),
(52671, '1.20.120.340-FF-000002', NULL, 'Flagellar secretion chaperone FliS', 126, NULL, NULL, 52671),
(52672, '1.10.510.10-FF-001487', NULL, 'Uncharacterized protein', 128, NULL, NULL, 52672),
(52673, '3.40.980.10-FF-000052', NULL, 'Uncharacterized protein', 89, NULL, NULL, 52673),
(52674, '3.40.50.300-FF-007488', NULL, 'Uncharacterized protein', 230, NULL, NULL, 52674),
(52675, '3.40.50.2300-FF-001466', NULL, NULL, 157, NULL, NULL, 52675),
(52676, '3.30.160.60-FF-001608', NULL, 'Zinc finger protein 605', 27, NULL, NULL, 52676),
(52677, '1.10.30.10-FF-000123', NULL, 'FACT complex subunit SSRP1', 109, NULL, NULL, 52677),
(52678, '3.40.50.720-FF-001364', NULL, 'Uncharacterized protein', 26, NULL, NULL, 52678),
(52679, '3.30.160.60-FF-002154', NULL, 'Zinc finger protein 337', 28, NULL, NULL, 52679),
(52680, '3.40.50.300-FF-001755', NULL, 'Methionine import ATP-binding protein MetN', 256, NULL, NULL, 52680),
(52681, '3.65.10.10-FF-000003', NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', 181, NULL, NULL, 52681),
(52682, '3.65.10.20-FF-000006', NULL, 'RNA terminal phosphate cyclase like 1', 121, NULL, NULL, 52682),
(52683, '1.20.1250.20-FF-001146', NULL, 'Sodium/phosphate transporter, putative', 168, NULL, NULL, 52683),
(52684, '3.40.50.300-FF-008500', NULL, 'Uncharacterized protein', 287, NULL, NULL, 52684),
(52685, '3.60.10.10-FF-000424', NULL, 'Uncharacterized protein', 107, NULL, NULL, 52685),
(52686, '3.40.50.150-FF-000333', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', 183, NULL, NULL, 52686),
(52687, '3.30.200.20-FF-000302', NULL, 'striated muscle preferentially expressed protein kinase', 97, NULL, NULL, 52687),
(52688, '2.10.70.10-FF-000117', NULL, 'Uncharacterized protein, isoform A', 73, NULL, NULL, 52688),
(52689, '1.10.20.10-FF-000173', NULL, 'Histone H2A', 123, NULL, NULL, 52689),
(52690, '3.30.2410.10-FF-000028', NULL, 'Ubiquitin protein ligase, putative', 113, NULL, NULL, 52690),
(52691, '3.30.70.890-FF-000061', NULL, 'Putative mevalonate kinase', 145, NULL, NULL, 52691);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(52692, '1.25.40.10-FF-003732', NULL, 'Uncharacterized protein', 121, NULL, NULL, 52692),
(52693, '3.20.20.80-FF-000346', NULL, 'Alpha-xylosidase BoGH31A', 363, NULL, NULL, 52693),
(52694, '3.40.50.300-FF-000069', NULL, 'Ras GTP-binding protein YPT1', 199, NULL, NULL, 52694),
(52695, '1.10.510.10-FF-002504', NULL, 'CK1 family protein kinase', 303, NULL, NULL, 52695),
(52696, '2.60.40.10-FF-001890', NULL, 'Cell adhesion molecule L1-like a', 87, NULL, NULL, 52696),
(52697, '3.30.450.20-FF-000579', NULL, 'PAS domain-containing serine/threonine kinase', 62, NULL, NULL, 52697),
(52698, '1.10.3720.10-FF-000013', NULL, 'Spermidine/putrescine ABC transporter permease PotC', 251, NULL, NULL, 52698),
(52699, '3.50.50.60-FF-001280', NULL, 'Uncharacterized protein', 56, NULL, NULL, 52699),
(52700, '1.10.8.720-FF-000001', NULL, 'dynein heavy chain 7, axonemal', 168, NULL, NULL, 52700),
(52701, '2.60.40.1770-FF-000004', NULL, 'ephrin type-B receptor 6', 69, NULL, NULL, 52701),
(52702, '3.40.50.720-FF-000689', NULL, 'D-galactose 1-dehydrogenase', 112, NULL, NULL, 52702),
(52703, '3.30.160.60-FF-006083', NULL, NULL, 47, NULL, NULL, 52703),
(52704, '2.60.120.10-FF-000037', NULL, 'cGMP-dependent protein kinase', 137, NULL, NULL, 52704),
(52705, '3.30.70.980-FF-000043', NULL, 'Probable transcriptional regulatory protein RB5500', 77, NULL, NULL, 52705),
(52706, '2.60.40.10-FF-002502', NULL, 'CBN-UNC-40 protein', 89, NULL, NULL, 52706),
(52707, '3.40.1170.60-FF-000027', NULL, 'DNA polymerase Y family protein', 57, NULL, NULL, 52707),
(52708, '3.30.160.60-FF-006425', NULL, NULL, 44, NULL, NULL, 52708),
(52709, '3.30.160.60-FF-002103', NULL, 'Zinc finger protein 766', 26, NULL, NULL, 52709),
(52710, '1.25.10.10-FF-001757', NULL, 'Uncharacterized protein', 84, NULL, NULL, 52710),
(52711, '1.10.4160.10-FF-000009', NULL, 'NCS1 family nucleobase:cation symporter-1', 474, NULL, NULL, 52711),
(52712, '1.10.10.750-FF-000036', NULL, 'Rab-like GTPase activating protein, putative', 43, NULL, NULL, 52712),
(52713, '2.130.10.10-FF-005291', NULL, 'Uncharacterized protein', 222, NULL, NULL, 52713),
(52714, '1.20.920.30-FF-000004', NULL, 'Dynein axonemal heavy chain 5', 213, NULL, NULL, 52714),
(52715, '2.60.40.1180-FF-000103', NULL, 'Antimony resistance marker of 58 kDa', 100, NULL, NULL, 52715),
(52716, '3.10.310.40-FF-000006', NULL, 'Alanine--tRNA ligase, cytoplasmic', 107, NULL, NULL, 52716),
(52717, '1.20.5.3960-FF-000002', NULL, 'DNA polymerase gamma, catalytic subunit', 24, NULL, NULL, 52717),
(52718, '1.25.40.180-FF-000316', NULL, NULL, 256, NULL, NULL, 52718),
(52719, '2.60.40.1170-FF-000100', NULL, NULL, 103, NULL, NULL, 52719),
(52720, '1.10.630.10-FF-000299', NULL, 'Cytochrome P450 2C9', 476, NULL, NULL, 52720),
(52721, '3.30.420.40-FF-000010', NULL, 'Actin-related protein 3 (ARP3)', 133, NULL, NULL, 52721),
(52722, '3.40.50.300-FF-005471', NULL, 'Uncharacterized protein', 219, NULL, NULL, 52722),
(52723, '3.10.310.30-FF-000003', NULL, 'Cyclic-di-AMP phosphodiesterase', 107, NULL, NULL, 52723),
(52724, '1.10.8.60-FF-000186', NULL, 'Cell division control protein', 90, NULL, NULL, 52724),
(52725, '2.30.30.760-FF-000001', NULL, 'Flagella basal body P-ring formation protein FlgA', 60, NULL, NULL, 52725),
(52726, '3.40.50.970-FF-000011', NULL, 'Pyruvate dehydrogenase E1 component', 418, NULL, NULL, 52726),
(52727, '3.30.160.60-FF-005594', NULL, NULL, 60, NULL, NULL, 52727),
(52728, '1.25.40.10-FF-001259', NULL, 'Glutenin, low molecular weight subunit protein', 220, NULL, NULL, 52728),
(52729, '1.10.150.300-FF-000004', NULL, 'Ribosome-binding ATPase YchF', 82, NULL, NULL, 52729),
(52730, '1.10.565.10-FF-000113', NULL, 'Nuclear Hormone Receptor family', 203, NULL, NULL, 52730),
(52731, '2.60.40.2690-FF-000005', NULL, 'Pre-mRNA-splicing factor PRP11', 153, NULL, NULL, 52731),
(52732, '3.40.50.300-FF-001699', NULL, 'ATP-binding cassette sub-family A member', 252, NULL, NULL, 52732),
(52733, '3.90.76.10-FF-000052', NULL, 'Oligopeptide ABC transporter, periplasmic oligopeptide-binding protein', 131, NULL, NULL, 52733),
(52734, '2.70.170.10-FF-000105', NULL, 'Nicotinic acetylcholine receptor a9 subunit splice variant', 221, NULL, NULL, 52734);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(52735, '1.20.1280.50-FF-000241', NULL, 'F-box/WD repeat-containing protein mec-15', 58, NULL, NULL, 52735),
(52736, '3.20.20.70-FF-000343', NULL, 'tRNA-dihydrouridine(47) synthase [NAD(P)(+)]', 237, NULL, NULL, 52736),
(52737, '2.60.120.230-FF-000021', NULL, NULL, 85, NULL, NULL, 52737),
(52738, '3.40.50.10090-FF-000025', NULL, 'uroporphyrinogen-III synthase', 98, NULL, NULL, 52738),
(52739, '1.25.40.10-FF-003171', NULL, 'Uncharacterized protein', 111, NULL, NULL, 52739),
(52740, '1.50.40.10-FF-000173', NULL, 'Mitochondrial glycine transporter', 113, NULL, NULL, 52740),
(52741, '3.30.70.330-FF-000320', NULL, 'RNA-binding protein Musashi 2', 83, NULL, NULL, 52741),
(52742, '3.20.20.140-FF-000328', NULL, '2-amino-3-carboxymuconate-6-semialdehyde decarboxylase', 175, NULL, NULL, 52742),
(52743, '2.60.120.920-FF-000020', NULL, 'Putative E3 ubiquitin-protein ligase NEURL1B', 152, NULL, NULL, 52743),
(52744, '3.40.50.300-FF-006027', NULL, 'Uncharacterized protein', 255, NULL, NULL, 52744),
(52745, '3.40.50.720-FF-001038', NULL, '2-dehydropantoate 2-reductase', 173, NULL, NULL, 52745),
(52746, '3.30.9.10-FF-000102', NULL, 'FAD-dependent oxidoreductase', 155, NULL, NULL, 52746),
(52747, '2.40.50.100-FF-000103', NULL, 'Cation efflux system protein', 69, NULL, NULL, 52747),
(52748, '3.50.50.60-FF-001493', NULL, 'Uncharacterized protein', 41, NULL, NULL, 52748),
(52749, '2.30.110.10-FF-000015', NULL, 'Glutamyl-tRNA reductase-binding protein, chloroplastic', 144, NULL, NULL, 52749),
(52750, '1.20.1610.10-FF-000002', NULL, 'Alpha-1,2-mannosidase family protein', 175, NULL, NULL, 52750),
(52751, '3.90.190.10-FF-000469', NULL, 'Predicted protein', 185, NULL, NULL, 52751),
(52752, '3.30.505.10-FF-000221', NULL, NULL, 103, NULL, NULL, 52752),
(52753, '3.30.1680.10-FF-000053', NULL, 'Integrin beta', 53, NULL, NULL, 52753),
(52754, '3.40.50.450-FF-000086', NULL, 'Phosphofructokinase, platelet b', 155, NULL, NULL, 52754),
(52755, '2.10.240.10-FF-000001', NULL, 'Dihydroorotate dehydrogenase B (NAD(+)), electron transfer subunit', 42, NULL, NULL, 52755),
(52756, '3.10.100.10-FF-000021', NULL, 'Mannose receptor C type 2', 151, NULL, NULL, 52756),
(52757, '3.40.50.300-FF-001429', NULL, 'Torsin family protein C9orf167-like', 209, NULL, NULL, 52757),
(52758, '3.40.720.10-FF-000016', NULL, 'Phosphoethanolamine transferase CptA', 337, NULL, NULL, 52758),
(52759, '1.20.1310.10-FF-000013', NULL, 'Cullin-1 like', 114, NULL, NULL, 52759),
(52760, '2.40.430.10-FF-000003', NULL, 'Binding-protein-dependent transport systems inner membrane component', 86, NULL, NULL, 52760),
(52761, '2.30.30.770-FF-000004', NULL, '60S ribosomal protein L27', 144, NULL, NULL, 52761),
(52762, '3.40.50.1700-FF-000044', NULL, 'Uncharacterized protein', 86, NULL, NULL, 52762),
(52763, '3.40.50.1010-FF-000045', NULL, 'Transcriptional protein swt1', 154, NULL, NULL, 52763),
(52764, '3.40.640.10-FF-000015', NULL, 'Aspartate aminotransferase', 241, NULL, NULL, 52764),
(52765, '1.10.1420.10-FF-000006', NULL, 'DNA mismatch repair protein', 180, NULL, NULL, 52765),
(52766, '3.30.200.20-FF-001269', NULL, NULL, 94, NULL, NULL, 52766),
(52767, '4.10.280.10-FF-000086', NULL, 'protein extra-macrochaetae', 59, NULL, NULL, 52767),
(52768, '1.20.1720.10-FF-000117', NULL, 'Bcr/CflA family efflux transporter', 379, NULL, NULL, 52768),
(52769, '1.25.40.10-FF-002153', NULL, 'Pentatricopeptide repeat-containing protein', 100, NULL, NULL, 52769),
(52770, '3.40.50.300-FF-005690', NULL, 'Pentafunctional AROM polypeptide', 181, NULL, NULL, 52770),
(52771, '3.40.50.2000-FF-001045', NULL, 'Protein CBG08872', 135, NULL, NULL, 52771),
(52772, '3.40.50.1000-FF-000042', NULL, 'HAD hydrolase, family IF', 127, NULL, NULL, 52772),
(52773, '3.30.70.330-FF-001950', NULL, NULL, 95, NULL, NULL, 52773),
(52774, '3.20.20.70-FF-000068', NULL, 'Fructose-bisphosphate aldolase', 358, NULL, NULL, 52774),
(52775, '3.30.360.10-FF-000131', NULL, 'Uncharacterized protein', 55, NULL, NULL, 52775),
(52776, '2.130.10.10-FF-001575', NULL, 'WGS project CABT00000000 data, contig 2.15', 355, NULL, NULL, 52776);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(52777, '3.40.50.2020-FF-000185', NULL, 'Ribose-phosphate pyrophosphokinase 2 chloroplastic', 75, NULL, NULL, 52777),
(52778, '1.10.10.1940-FF-000005', NULL, 'Metalloendopeptidase', 42, NULL, NULL, 52778),
(52779, '1.20.1310.20-FF-000016', NULL, 'Erythrocyte membrane protein 1', 206, NULL, NULL, 52779),
(52780, '2.60.120.10-FF-000442', NULL, 'Uncharacterized protein', 107, NULL, NULL, 52780),
(52781, '3.40.50.2300-FF-001073', NULL, NULL, 136, NULL, NULL, 52781),
(52782, '3.40.33.10-FF-000157', NULL, 'Uncharacterized protein', 125, NULL, NULL, 52782),
(52783, '3.30.160.60-FF-003733', NULL, NULL, 26, NULL, NULL, 52783),
(52784, '1.25.40.10-FF-001877', NULL, 'Os06g0681900 protein', 174, NULL, NULL, 52784),
(52785, '1.20.1530.20-FF-000004', NULL, 'Kef family K(+) transporter', 393, NULL, NULL, 52785),
(52786, '1.10.390.10-FF-000083', NULL, 'Predicted protein', 45, NULL, NULL, 52786),
(52787, '3.40.190.10-FF-000778', NULL, 'ABC-type dipeptide transport system, solute-binding protein', 282, NULL, NULL, 52787),
(52788, '3.90.1100.10-FF-000007', NULL, 'DNA-directed RNA polymerase subunit beta', 343, NULL, NULL, 52788),
(52789, '2.30.29.30-FF-000437', NULL, 'Focal adhesion kinase, isoform F', 141, NULL, NULL, 52789),
(52790, '3.30.70.1660-FF-000023', NULL, 'Peptide chain release factor-like protein', 88, NULL, NULL, 52790),
(52791, '1.20.1530.10-FF-000001', NULL, 'Na(+)/H(+) antiporter NhaA', 388, NULL, NULL, 52791),
(52792, '1.25.40.10-FF-002889', NULL, 'PsbB mRNA maturation factor Mbb1, chloroplastic', 227, NULL, NULL, 52792),
(52793, '2.30.29.30-FF-001218', NULL, 'Rho guanine nucleotide exchange factor (GEF) 26', 161, NULL, NULL, 52793),
(52794, '3.30.1490.220-FF-000008', NULL, 'Inositol-tetrakisphosphate 1-kinase', 86, NULL, NULL, 52794),
(52795, '1.10.287.470-FF-000059', NULL, 'Efflux transporter, RND family, MFP subunit', 74, NULL, NULL, 52795),
(52796, '3.20.20.140-FF-000109', NULL, '4-oxalomesaconate hydratase', 339, NULL, NULL, 52796),
(52797, '1.25.40.10-FF-000129', NULL, 'protein sel-1 homolog 3 isoform X1', 101, NULL, NULL, 52797),
(52798, '3.20.20.140-FF-000059', NULL, 'Histidinol-phosphatase', 268, NULL, NULL, 52798),
(52799, '1.10.1040.10-FF-000039', NULL, 'Blast:Putative oxidoreductase GLYR1 homolog', 122, NULL, NULL, 52799),
(52800, '3.30.70.330-FF-001225', NULL, 'Transformer-2 sex-determining protein-like Protein', 173, NULL, NULL, 52800),
(52801, '3.90.1410.10-FF-000104', NULL, 'AFL100Wp', 250, NULL, NULL, 52801),
(52802, '3.40.50.1100-FF-000033', NULL, 'Diaminopropionate ammonia-lyase', 228, NULL, NULL, 52802),
(52803, '2.40.10.10-FF-000303', NULL, 'GM18242', 95, NULL, NULL, 52803),
(52804, '1.20.1070.10-FF-000589', NULL, 'Uncharacterized protein', 206, NULL, NULL, 52804),
(52805, '1.25.70.10-FF-000070', NULL, NULL, 124, NULL, NULL, 52805),
(52806, '1.20.5.110-FF-000075', NULL, 'Related to SEC9-protein transport protein', 69, NULL, NULL, 52806),
(52807, '3.30.60.90-FF-000031', NULL, 'Transcriptional adaptor ADA2, putative', 53, NULL, NULL, 52807),
(52808, '2.10.90.10-FF-000057', NULL, 'Interleukin 17E', 116, NULL, NULL, 52808),
(52809, '2.130.10.10-FF-001867', NULL, 'Chromosome 1, whole genome shotgun sequence', 266, NULL, NULL, 52809),
(52810, '1.10.510.10-FF-003516', NULL, NULL, 247, NULL, NULL, 52810),
(52811, '2.30.29.30-FF-000656', NULL, 'Uncharacterized protein', 122, NULL, NULL, 52811),
(52812, '2.170.240.10-FF-000003', NULL, 'Collagen, type IV, alpha 4', 227, NULL, NULL, 52812),
(52813, '3.30.930.10-FF-000219', NULL, 'Uncharacterized protein', 250, NULL, NULL, 52813),
(52814, '4.10.1060.10-FF-000055', NULL, 'E3 SUMO-protein ligase RanBP2', 35, NULL, NULL, 52814),
(52815, '3.20.20.80-FF-000790', NULL, 'Predicted protein', 186, NULL, NULL, 52815),
(52816, '1.25.50.20-FF-000072', NULL, 'Aminopeptidase', 312, NULL, NULL, 52816),
(52817, '3.20.19.10-FF-000007', NULL, 'Isopropylmalate/citramalate isomerase small subunit', 166, NULL, NULL, 52817),
(52818, '3.30.420.40-FF-000061', NULL, 'Heat shock protein family A (Hsp70) member 12A', 206, NULL, NULL, 52818),
(52819, '1.10.730.10-FF-000014', NULL, 'Valine--tRNA ligase', 233, NULL, NULL, 52819);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(52820, '3.40.50.300-FF-007718', NULL, 'Glycerate kinase', 96, NULL, NULL, 52820),
(52821, '2.60.120.10-FF-000711', NULL, 'Uncharacterized protein', 151, NULL, NULL, 52821),
(52822, '2.60.120.10-FF-000661', NULL, 'Bll6461 protein', 126, NULL, NULL, 52822),
(52823, '3.40.50.11980-FF-000007', NULL, 'ORF13', 165, NULL, NULL, 52823),
(52824, '3.40.630.30-FF-000015', NULL, 'N-alpha-acetyltransferase 20 isoform X1', 165, NULL, NULL, 52824),
(52825, '1.25.10.10-FF-003287', NULL, 'Uncharacterized protein', 186, NULL, NULL, 52825),
(52826, '1.20.1250.20-FF-000814', NULL, 'Uncharacterized protein', 277, NULL, NULL, 52826),
(52827, '2.60.40.10-FF-004071', NULL, NULL, 95, NULL, NULL, 52827),
(52828, '3.40.50.300-FF-002250', NULL, 'ATP-dependent RNA helicase DDX51', 286, NULL, NULL, 52828),
(52829, '3.10.100.10-FF-000015', NULL, 'C-type lectin Cal', 135, NULL, NULL, 52829),
(52830, '3.30.420.10-FF-000574', NULL, NULL, 240, NULL, NULL, 52830),
(52831, '2.60.40.1180-FF-000142', NULL, 'Maltase A8', 82, NULL, NULL, 52831),
(52832, '1.10.357.30-FF-000012', NULL, NULL, 185, NULL, NULL, 52832),
(52833, '3.40.50.300-FF-004009', NULL, 'Uncharacterized protein YpbR', 207, NULL, NULL, 52833),
(52834, '2.40.10.10-FF-000247', NULL, 'GG11533', 131, NULL, NULL, 52834),
(52835, '3.30.160.60-FF-004520', NULL, NULL, 55, NULL, NULL, 52835),
(52836, '2.130.10.10-FF-003048', NULL, 'Uncharacterized protein', 148, NULL, NULL, 52836),
(52837, '2.30.39.10-FF-000089', NULL, 'Serpin peptidase inhibitor 22', 136, NULL, NULL, 52837),
(52838, '3.40.50.300-FF-003447', NULL, 'Type I restriction-modification system restriction subunit R', 209, NULL, NULL, 52838),
(52839, '1.25.10.10-FF-002090', NULL, 'Predicted protein', 197, NULL, NULL, 52839),
(52840, '3.10.50.40-FF-000151', NULL, 'Inactive peptidyl-prolyl cis-trans isomerase shutdown', 129, NULL, NULL, 52840),
(52841, '3.90.25.10-FF-000081', NULL, 'UDP-glucose 4-epimerase', 98, NULL, NULL, 52841),
(52842, '3.40.50.1100-FF-000072', NULL, 'Related to cysteine synthase', 113, NULL, NULL, 52842),
(52843, '4.10.60.10-FF-000213', NULL, 'Predicted protein', 62, NULL, NULL, 52843),
(52844, '2.30.180.10-FF-000019', NULL, 'Cell surface lipoprotein', 153, NULL, NULL, 52844),
(52845, '3.40.630.20-FF-000012', NULL, 'Pyroglutamyl-peptidase I-like', 191, NULL, NULL, 52845),
(52846, '3.30.200.20-FF-001937', NULL, 'Uncharacterized protein', 34, NULL, NULL, 52846),
(52847, '3.80.10.10-FF-002615', NULL, 'Putative phopshatase', 220, NULL, NULL, 52847),
(52848, '3.40.50.410-FF-000372', NULL, 'Uncharacterized protein', 179, NULL, NULL, 52848),
(52849, '2.40.30.10-FF-000361', NULL, 'Putative nadp-dependent flavoprotein reductase', 92, NULL, NULL, 52849),
(52850, '1.10.275.10-FF-000012', NULL, 'Adenylosuccinate lyase', 98, NULL, NULL, 52850),
(52851, '3.30.160.60-FF-006318', NULL, NULL, 29, NULL, NULL, 52851),
(52852, '3.90.180.10-FF-000137', NULL, 'Lovastatin diketide synthase LovF', 353, NULL, NULL, 52852),
(52853, '3.40.50.300-FF-006139', NULL, 'Uncharacterized protein', 20, NULL, NULL, 52853),
(52854, '3.30.70.330-FF-001332', NULL, 'Uncharacterized protein', 129, NULL, NULL, 52854),
(52855, '1.20.5.110-FF-000018', NULL, 'Synaptosomal-associated protein', 85, NULL, NULL, 52855),
(52856, '1.20.58.390-FF-000006', NULL, 'Putative gamma-aminobutyric acid receptor subunit gamma-2', 134, NULL, NULL, 52856),
(52857, '2.130.10.10-FF-003380', NULL, 'Intraflagellar transport 172', 171, NULL, NULL, 52857),
(52858, '3.30.70.360-FF-000037', NULL, 'Carboxypeptidase G2', 110, NULL, NULL, 52858),
(52859, '3.20.20.70-FF-000742', NULL, NULL, 74, NULL, NULL, 52859),
(52860, '3.40.50.300-FF-005920', NULL, 'Cadmium ion transporter, putative', 271, NULL, NULL, 52860),
(52861, '3.50.50.60-FF-001167', NULL, 'Uncharacterized protein', 288, NULL, NULL, 52861),
(52862, '3.40.1370.10-FF-000022', NULL, '50S ribosomal protein L4', 216, NULL, NULL, 52862),
(52863, '1.25.70.10-FF-000013', NULL, 'uncharacterized protein LOC106769908', 147, NULL, NULL, 52863),
(52864, '3.80.10.10-FF-002559', NULL, 'RAB geranylgeranyl transferase alpha subunit, putative', 137, NULL, NULL, 52864);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(52865, '1.25.10.10-FF-001196', NULL, 'Cyclosome subunit-like protein', 152, NULL, NULL, 52865),
(52866, '1.10.287.160-FF-000028', NULL, 'Uncharacterized protein', 64, NULL, NULL, 52866),
(52867, '2.60.40.420-FF-000097', NULL, 'Basic blue copper protein', 102, NULL, NULL, 52867),
(52868, '3.80.10.10-FF-001255', NULL, 'Leucine rich repeats (6 copies)/Leucine Rich repeat', 109, NULL, NULL, 52868),
(52869, '1.25.40.180-FF-000193', NULL, 'Pre-mRNA-splicing factor CWC22', 290, NULL, NULL, 52869),
(52870, '2.130.10.10-FF-000451', NULL, 'Plexin A4, B', 459, NULL, NULL, 52870),
(52871, '1.10.730.10-FF-000121', NULL, 'Arginine--tRNA ligase', 120, NULL, NULL, 52871),
(52872, '2.10.90.10-FF-000113', NULL, 'Uncharacterized protein', 110, NULL, NULL, 52872),
(52873, '1.20.58.830-FF-000003', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 146, NULL, NULL, 52873),
(52874, '3.10.120.10-FF-000016', NULL, 'Nitrate reductase', 88, NULL, NULL, 52874),
(52875, '1.10.225.10-FF-000026', NULL, 'Saposin-related', 81, NULL, NULL, 52875),
(52876, '2.10.90.10-FF-000170', NULL, 'Bone morphogenetic protein 2', 83, NULL, NULL, 52876),
(52877, '1.20.58.530-FF-000014', NULL, 'unconventional myosin-XVIIIa isoform X2', 180, NULL, NULL, 52877),
(52878, '1.10.730.20-FF-000017', NULL, 'Isoleucyl-tRNA synthetase', 96, NULL, NULL, 52878),
(52879, '1.10.10.60-FF-000440', NULL, 'NK7.1, isoform A', 77, NULL, NULL, 52879),
(52880, '1.10.10.10-FF-002033', NULL, 'Cell division control protein 18', 97, NULL, NULL, 52880),
(52881, '3.40.140.10-FF-000140', NULL, 'Putative 26S proteasome non-ATPase regulatory subunit', 212, NULL, NULL, 52881),
(52882, '3.30.200.20-FF-001090', NULL, 'Probable serine/threonine-protein kinase YabT', 76, NULL, NULL, 52882),
(52883, '1.25.40.20-FF-000301', NULL, 'Palmitoyltransferase', 231, NULL, NULL, 52883),
(52884, '1.10.1040.10-FF-000096', NULL, 'Glyoxylate reductase 1', 44, NULL, NULL, 52884),
(52885, '1.25.40.10-FF-003906', NULL, 'Uncharacterized protein', 59, NULL, NULL, 52885),
(52886, '3.80.10.10-FF-003222', NULL, 'Predicted protein', 203, NULL, NULL, 52886),
(52887, '3.40.720.10-FF-000342', NULL, 'Alkaline phosphatase, biomineralization-associated', 82, NULL, NULL, 52887),
(52888, '3.40.50.720-FF-001190', NULL, 'Short-chain dehydrogenase/reductase SDR', 263, NULL, NULL, 52888),
(52889, '1.10.510.10-FF-004067', NULL, NULL, 30, NULL, NULL, 52889),
(52890, '3.20.20.80-FF-000745', NULL, 'Uncharacterized protein', 72, NULL, NULL, 52890),
(52891, '3.90.1580.10-FF-000037', NULL, 'Uncharacterized protein', 160, NULL, NULL, 52891),
(52892, '3.40.140.10-FF-000101', NULL, 'Uncharacterized protein', 161, NULL, NULL, 52892),
(52893, '1.20.5.100-FF-000015', NULL, 'Integrin beta', 73, NULL, NULL, 52893),
(52894, '2.30.39.10-FF-000145', NULL, 'Serpin, putative', 152, NULL, NULL, 52894),
(52895, '1.20.1000.10-FF-000023', NULL, 'Guanylate-binding protein 3', 295, NULL, NULL, 52895),
(52896, '2.60.120.290-FF-000229', NULL, 'Uncharacterized protein', 94, NULL, NULL, 52896),
(52897, '2.60.120.330-FF-000225', NULL, 'Uncharacterized protein', 177, NULL, NULL, 52897),
(52898, '3.10.200.10-FF-000017', NULL, NULL, 145, NULL, NULL, 52898),
(52899, '3.10.105.10-FF-000043', NULL, 'Oligopeptide ABC transporter, oligopeptide-binding protein', 211, NULL, NULL, 52899),
(52900, '3.40.50.2000-FF-000876', NULL, 'Uncharacterized protein', 190, NULL, NULL, 52900),
(52901, '1.25.40.10-FF-002602', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 50, NULL, NULL, 52901),
(52902, '3.20.20.70-FF-000635', NULL, NULL, 262, NULL, NULL, 52902),
(52903, '3.30.450.20-FF-000293', NULL, 'Histidine kinase', 102, NULL, NULL, 52903),
(52904, '2.60.40.10-FF-001159', NULL, 'Fms related tyrosine kinase 3', 93, NULL, NULL, 52904),
(52905, '2.40.110.10-FF-000024', NULL, 'Acyl-CoA dehydrogenase FadE23', 115, NULL, NULL, 52905),
(52906, '3.20.20.80-FF-000458', NULL, 'Cyanogenic beta-glucosidase', 89, NULL, NULL, 52906),
(52907, '1.20.1560.10-FF-000346', NULL, 'ABC transporter, putative', 330, NULL, NULL, 52907),
(52908, '3.30.160.60-FF-001659', NULL, 'Uncharacterized protein', 27, NULL, NULL, 52908);
INSERT INTO "PUBLIC"."MODEL" VALUES
(52909, '2.60.120.10-FF-000329', NULL, 'AraC family transcriptional regulator', 96, NULL, NULL, 52909),
(52910, '3.30.429.10-FF-000004', NULL, 'Tautomerase/MIF superfamily protein', 109, NULL, NULL, 52910),
(52911, '3.40.50.300-FF-004228', NULL, 'Elongation factor 1-alpha, putative (TuF-2)', 234, NULL, NULL, 52911),
(52912, '3.30.160.60-FF-004301', NULL, NULL, 41, NULL, NULL, 52912),
(52913, '3.40.50.300-FF-006252', NULL, 'Uncharacterized protein', 175, NULL, NULL, 52913),
(52914, '3.20.20.80-FF-000638', NULL, 'Uncharacterized protein', 107, NULL, NULL, 52914),
(52915, '2.60.40.150-FF-000611', NULL, 'Extended synaptotagmin-2, putative', 151, NULL, NULL, 52915),
(52916, '3.40.50.720-FF-001145', NULL, 'GDP-L-fucose synthase isoform X2', 92, NULL, NULL, 52916),
(52917, '1.10.510.10-FF-002212', NULL, NULL, 133, NULL, NULL, 52917),
(52918, '3.40.50.300-FF-007831', NULL, 'DNA helicase II', 190, NULL, NULL, 52918),
(52919, '3.40.50.10330-FF-000024', NULL, 'Diacylglycerol kinase', 130, NULL, NULL, 52919),
(52920, '3.40.50.720-FF-000583', NULL, 'Glutamate dehydrogenase', 296, NULL, NULL, 52920),
(52921, '2.40.50.140-FF-000311', NULL, '30S ribosomal protein S17', 94, NULL, NULL, 52921),
(52922, '2.60.40.4230-FF-000001', NULL, 'Resistin-like beta', 62, NULL, NULL, 52922),
(52923, '1.10.418.10-FF-000081', NULL, 'Leucine-rich-repeats and calponin homology domain protein, isoform C', 114, NULL, NULL, 52923),
(52924, '1.10.167.10-FF-000025', NULL, 'Axin, isoform B', 78, NULL, NULL, 52924),
(52925, '3.30.420.40-FF-000004', NULL, 'Molecular chaperone DnaK', 188, NULL, NULL, 52925),
(52926, '2.60.40.10-FF-000703', NULL, 'Neural cell adhesion molecule L1-like protein', 76, NULL, NULL, 52926),
(52927, '2.30.29.30-FF-000763', NULL, 'FE65-like protein', 77, NULL, NULL, 52927),
(52928, '1.25.40.10-FF-000242', NULL, 'Pentatricopeptide repeat-containing protein', 227, NULL, NULL, 52928),
(52929, '1.20.58.60-FF-000763', NULL, 'Nesprin-1', 255, NULL, NULL, 52929),
(52930, '1.25.40.20-FF-000245', NULL, 'Ankyrin repeat-containing protein ITN1', 140, NULL, NULL, 52930),
(52931, '3.40.1000.10-FF-000034', NULL, 'Uncharacterized protein', 52, NULL, NULL, 52931),
(52932, '3.40.50.300-FF-005864', NULL, 'Uncharacterized protein', 209, NULL, NULL, 52932),
(52933, '1.20.5.350-FF-000017', NULL, NULL, 107, NULL, NULL, 52933),
(52934, '3.80.10.10-FF-003166', NULL, 'F-box and leucine-rich repeat protein 17', 273, NULL, NULL, 52934),
(52935, '3.20.20.140-FF-000441', NULL, 'Uncharacterized protein', 99, NULL, NULL, 52935),
(52936, '2.60.40.10-FF-002614', NULL, 'Filamin 2, putative', 85, NULL, NULL, 52936),
(52937, '3.30.110.170-FF-000001', NULL, 'Oxidative stress defense protein', 92, NULL, NULL, 52937),
(52938, '1.10.8.60-FF-000074', NULL, 'Chromosome transmission fidelity protein 18', 66, NULL, NULL, 52938),
(52939, '1.20.1070.10-FF-000882', NULL, 'Uncharacterized protein', 303, NULL, NULL, 52939),
(52940, '3.40.50.720-FF-002494', NULL, 'Uncharacterized protein', 158, NULL, NULL, 52940),
(52941, '2.130.10.10-FF-005465', NULL, 'Heterotrimeric G protein beta subunit 1', 170, NULL, NULL, 52941),
(52942, '3.20.20.70-FF-000455', NULL, 'Coenzyme PQQ synthesis protein E', 314, NULL, NULL, 52942),
(52943, '3.30.70.330-FF-001282', NULL, 'SD09402p', 93, NULL, NULL, 52943),
(52944, '1.20.5.340-FF-000014', NULL, 'Cell division protein ZapB', 79, NULL, NULL, 52944),
(52945, '1.20.5.340-FF-000126', NULL, 'Myhz2 protein', 47, NULL, NULL, 52945),
(52946, '3.30.160.60-FF-002210', NULL, 'Zinc finger and BTB domain containing 17', 24, NULL, NULL, 52946),
(52947, '3.90.400.10-FF-000003', NULL, 'Probable alpha-glucosidase (Maltase)', 75, NULL, NULL, 52947),
(52948, '1.10.10.60-FF-000108', NULL, 'NK2 homeobox 1', 82, NULL, NULL, 52948),
(52949, '1.20.58.480-FF-000027', NULL, 'Uncharacterized protein', 107, NULL, NULL, 52949),
(52950, '2.40.160.120-FF-000028', NULL, 'Oxysterol-binding protein', 189, NULL, NULL, 52950),
(52951, '1.25.40.10-FF-003619', NULL, 'Pentatricopeptide repeat-containing protein', 106, NULL, NULL, 52951),
(52952, '3.40.1110.10-FF-000149', NULL, 'Probable copper-transporting ATPase HMA5', 144, NULL, NULL, 52952);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(52953, '1.25.40.10-FF-005295', NULL, 'Uncharacterized protein', 134, NULL, NULL, 52953),
(52954, '3.30.830.10-FF-000217', NULL, 'Uncharacterized protein', 240, NULL, NULL, 52954),
(52955, '1.20.1260.10-FF-000076', NULL, 'Ferritin 2 light chain-like protein', 63, NULL, NULL, 52955),
(52956, '2.120.10.30-FF-000598', NULL, 'Gll1703 protein', 153, NULL, NULL, 52956),
(52957, '3.30.930.10-FF-000276', NULL, 'Uncharacterized protein', 155, NULL, NULL, 52957),
(52958, '2.40.10.10-FF-000360', NULL, NULL, 62, NULL, NULL, 52958),
(52959, '2.60.40.10-FF-005487', NULL, NULL, 98, NULL, NULL, 52959),
(52960, '2.130.10.10-FF-005408', NULL, 'Uncharacterized protein', 169, NULL, NULL, 52960),
(52961, '2.130.10.10-FF-000119', NULL, 'peptidylprolyl isomerase domain and WD repeat-containing protein 1 isoform X2', 154, NULL, NULL, 52961),
(52962, '1.20.1250.20-FF-001472', NULL, 'Uncharacterized protein', 363, NULL, NULL, 52962),
(52963, '3.40.1190.20-FF-000078', NULL, 'Ribokinase', 306, NULL, NULL, 52963),
(52964, '1.10.275.20-FF-000015', NULL, NULL, 66, NULL, NULL, 52964),
(52965, '3.90.1150.10-FF-000050', NULL, 'GntR family transcriptional regulator', 146, NULL, NULL, 52965),
(52966, '3.40.50.2300-FF-001522', NULL, NULL, 86, NULL, NULL, 52966),
(52967, '3.30.70.340-FF-000031', NULL, NULL, 84, NULL, NULL, 52967),
(52968, '1.20.120.550-FF-000008', NULL, 'Predicted protein', 138, NULL, NULL, 52968),
(52969, '1.20.1680.10-FF-000001', NULL, 'Putative deoxyuridine triphosphatase', 116, NULL, NULL, 52969),
(52970, '3.40.30.10-FF-000084', NULL, 'Protein disulfide-isomerase A4', 107, NULL, NULL, 52970),
(52971, '1.20.5.110-FF-000294', NULL, 'Uncharacterized protein', 92, NULL, NULL, 52971),
(52972, '2.30.31.10-FF-000026', NULL, 'Uncharacterized protein', 64, NULL, NULL, 52972),
(52973, '1.25.50.10-FF-000012', NULL, 'Peptidase M1 family protein', 154, NULL, NULL, 52973),
(52974, '1.10.510.10-FF-004303', NULL, NULL, 157, NULL, NULL, 52974),
(52975, '3.30.230.10-FF-000020', NULL, 'Homoserine kinase', 166, NULL, NULL, 52975),
(52976, '3.30.560.10-FF-000005', NULL, 'Glucose-methanol-choline (Gmc) oxidoreductase', 323, NULL, NULL, 52976),
(52977, '3.30.40.10-FF-001630', NULL, 'Uncharacterized protein', 59, NULL, NULL, 52977),
(52978, '1.20.1070.10-FF-001320', NULL, 'DOPamine receptor', 271, NULL, NULL, 52978),
(52979, '4.10.280.10-FF-000193', NULL, 'Uncharacterized protein', 67, NULL, NULL, 52979),
(52980, '1.25.50.20-FF-000015', NULL, 'Aminopeptidase', 308, NULL, NULL, 52980),
(52981, '3.30.1460.50-FF-000003', NULL, 'Autophagy-related protein 3', 138, NULL, NULL, 52981),
(52982, '2.130.10.10-FF-005178', NULL, 'Pre-mRNA-splicing factor RSE1', 126, NULL, NULL, 52982),
(52983, '3.90.550.50-FF-000211', NULL, 'Uncharacterized protein', 158, NULL, NULL, 52983),
(52984, '1.20.1530.20-FF-000111', NULL, 'Uncharacterized protein', 152, NULL, NULL, 52984),
(52985, '4.10.280.10-FF-000136', NULL, 'CBN-MXL-2 protein', 92, NULL, NULL, 52985),
(52986, '6.10.250.3440-FF-000001', NULL, 'Mitochondrial ribosomal protein L40', 99, NULL, NULL, 52986),
(52987, '2.60.40.150-FF-000381', NULL, 'Phosphatidylserine decarboxylase proenzyme 2', 157, NULL, NULL, 52987),
(52988, '2.60.40.10-FF-003396', NULL, NULL, 110, NULL, NULL, 52988),
(52989, '2.30.33.40-FF-000023', NULL, 'Uncharacterized protein', 70, NULL, NULL, 52989),
(52990, '6.10.250.3450-FF-000004', NULL, 'Ribosomal protein L35', 46, NULL, NULL, 52990),
(52991, '2.60.40.10-FF-002053', NULL, 'Triggering receptor expressed on myeloid cells 1', 119, NULL, NULL, 52991),
(52992, '1.10.418.20-FF-000027', NULL, 'Ulp1 protease family protein (AFU_orthologue AFUA_5G03200)', 46, NULL, NULL, 52992),
(52993, '3.40.1110.10-FF-000481', NULL, NULL, 135, NULL, NULL, 52993),
(52994, '1.25.10.10-FF-003343', NULL, 'Uncharacterized protein', 448, NULL, NULL, 52994),
(52995, '3.40.30.10-FF-000027', NULL, 'protein disulfide-isomerase A2', 116, NULL, NULL, 52995),
(52996, '1.20.1300.20-FF-000009', NULL, 'Ubiquitin thioesterase', 145, NULL, NULL, 52996),
(52997, '3.40.50.2000-FF-000819', NULL, 'Pseudaminic acid cytidylyltransferase and UDP-2,4-diacetamido-2,4,6-trideoxy-beta-L-altropyranose hydrolase', 125, NULL, NULL, 52997);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(52998, '3.40.50.720-FF-001999', NULL, 'Uncharacterized protein', 232, NULL, NULL, 52998),
(52999, '2.40.40.20-FF-000078', NULL, 'Uncharacterized protein', 64, NULL, NULL, 52999),
(53000, '3.30.310.10-FF-000021', NULL, 'Ribonuclease HIII', 87, NULL, NULL, 53000),
(53001, '2.60.40.790-FF-000011', NULL, 'Alpha-crystallin B chain', 126, NULL, NULL, 53001),
(53002, '3.30.9.10-FF-000046', NULL, 'Sarcosine dehydrogenase', 79, NULL, NULL, 53002),
(53003, '2.30.180.10-FF-000132', NULL, NULL, 116, NULL, NULL, 53003),
(53004, '1.25.40.10-FF-003058', NULL, 'WGS project CABT00000000 data, contig 2.19', 66, NULL, NULL, 53004),
(53005, '3.40.50.300-FF-006471', NULL, 'Os06g0158200 protein', 119, NULL, NULL, 53005),
(53006, '3.80.10.10-FF-004184', NULL, 'Uncharacterized protein', 269, NULL, NULL, 53006),
(53007, '1.10.400.10-FF-000023', NULL, 'Guanine nucleotide-binding protein alpha-6 subunit', 122, NULL, NULL, 53007),
(53008, '2.60.40.10-FF-003632', NULL, 'Platelet-derived growth factor receptor, beta polypeptide', 86, NULL, NULL, 53008),
(53009, '3.40.1360.10-FF-000015', NULL, 'Topoisomerase, putative', 219, NULL, NULL, 53009),
(53010, '1.25.40.10-FF-003676', NULL, 'At5g02130', 104, NULL, NULL, 53010),
(53011, '3.40.50.1820-FF-000754', NULL, 'Protein of uncharacterized function (DUF2424)', 345, NULL, NULL, 53011),
(53012, '2.30.18.10-FF-000001', NULL, 'Transcription initiation factor IIA subunit 2', 52, NULL, NULL, 53012),
(53013, '1.20.5.110-FF-000237', NULL, 'Syntaxin, putative', 63, NULL, NULL, 53013),
(53014, '2.60.40.60-FF-000403', NULL, 'Protocadherin 15', 104, NULL, NULL, 53014),
(53015, '3.40.50.410-FF-000153', NULL, 'RfeF', 171, NULL, NULL, 53015),
(53016, '3.40.33.10-FF-000118', NULL, 'Vap-1', 197, NULL, NULL, 53016),
(53017, '1.25.40.740-FF-000001', NULL, 'Sel1 repeat family protein', 65, NULL, NULL, 53017),
(53018, '3.30.342.10-FF-000027', NULL, 'DNA polymerase', 137, NULL, NULL, 53018),
(53019, '2.130.10.10-FF-004161', NULL, 'MGC69094 protein, putative', 172, NULL, NULL, 53019),
(53020, '3.40.1190.10-FF-000036', NULL, 'Uncharacterized protein', 279, NULL, NULL, 53020),
(53021, '1.20.1070.10-FF-001045', NULL, 'Beta-1 adrenergic receptor', 234, NULL, NULL, 53021),
(53022, '2.130.10.10-FF-001811', NULL, 'Unplaced genomic scaffold supercont1.15, whole genome shotgun sequence', 127, NULL, NULL, 53022),
(53023, '2.60.40.1530-FF-000017', NULL, 'Integrin alpha5tr subunit', 215, NULL, NULL, 53023),
(53024, '3.40.50.1820-FF-000698', NULL, 'Lysosomal thioesterase PPT2', 96, NULL, NULL, 53024),
(53025, '3.80.10.10-FF-004526', NULL, 'F-box/leucine rich repeat protein, putative', 260, NULL, NULL, 53025),
(53026, '3.30.810.10-FF-000003', NULL, 'Phosphatidylinositol 5-phosphate 4-kinase type-2 beta', 169, NULL, NULL, 53026),
(53027, '2.60.40.60-FF-000347', NULL, 'Cadherin 2', 110, NULL, NULL, 53027),
(53028, '2.130.10.10-FF-003885', NULL, 'Protein CBG05170', 276, NULL, NULL, 53028),
(53029, '1.20.1070.10-FF-000769', NULL, 'Predicted protein', 303, NULL, NULL, 53029),
(53030, '3.30.230.80-FF-000013', NULL, 'Heat shock protein Hsp90', 170, NULL, NULL, 53030),
(53031, '3.40.140.100-FF-000001', NULL, 'Ubiquitin-like modifier-activating enzyme ATG7', 141, NULL, NULL, 53031),
(53032, '3.40.190.10-FF-000143', NULL, 'Glutamate receptor ionotropic, NMDA 2B', 33, NULL, NULL, 53032),
(53033, '3.30.160.60-FF-001991', NULL, 'Zinc finger and SCAN domain containing 26', 28, NULL, NULL, 53033),
(53034, '1.20.1250.20-FF-000691', NULL, 'Conserved protein', 220, NULL, NULL, 53034),
(53035, '2.10.70.10-FF-000224', NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing 1', 68, NULL, NULL, 53035),
(53036, '3.30.1330.30-FF-000128', NULL, 'Uncharacterized protein', 120, NULL, NULL, 53036),
(53037, '2.60.40.10-FF-003576', NULL, NULL, 91, NULL, NULL, 53037),
(53038, '3.40.50.300-FF-004902', NULL, 'ADR093Wp', 178, NULL, NULL, 53038),
(53039, '3.40.50.10330-FF-000081', NULL, 'Sphingoid long-chain bases kinase 2, mitochondrial', 149, NULL, NULL, 53039),
(53040, '3.40.1580.20-FF-000001', NULL, 'Protein Syd', 181, NULL, NULL, 53040);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(53041, '1.25.40.10-FF-001546', NULL, 'Translation regulator (Cya5), putative', 188, NULL, NULL, 53041),
(53042, '3.40.50.1820-FF-001030', NULL, 'Predicted protein', 166, NULL, NULL, 53042),
(53043, '1.10.10.10-FF-000122', NULL, 'Forkhead box protein N1', 99, NULL, NULL, 53043),
(53044, '2.130.10.10-FF-005740', NULL, 'Uncharacterized protein', 124, NULL, NULL, 53044),
(53045, '1.10.510.10-FF-003286', NULL, NULL, 96, NULL, NULL, 53045),
(53046, '2.10.25.10-FF-001210', NULL, 'Predicted protein', 56, NULL, NULL, 53046),
(53047, '1.25.40.10-FF-001602', NULL, 'WGS project CABT00000000 data, contig 2.59', 149, NULL, NULL, 53047),
(53048, '1.10.287.110-FF-000480', NULL, 'DnaJ-like protein', 111, NULL, NULL, 53048),
(53049, '1.20.1270.60-FF-000125', NULL, 'Putative phosphoinositide-binding protein', 212, NULL, NULL, 53049),
(53050, '3.30.160.60-FF-000355', NULL, 'zinc finger and SCAN domain-containing protein 20 isoform X1', 28, NULL, NULL, 53050),
(53051, '2.60.40.10-FF-001777', NULL, 'myopalladin isoform X3', 78, NULL, NULL, 53051),
(53052, '3.30.160.60-FF-004008', NULL, NULL, 21, NULL, NULL, 53052),
(53053, '3.40.50.720-FF-001420', NULL, 'Zgc:158138 protein', 70, NULL, NULL, 53053),
(53054, '1.20.1330.10-FF-000014', NULL, 'Flagellar hook-associated protein FlgL', 188, NULL, NULL, 53054),
(53055, '1.10.10.1050-FF-000008', NULL, 'M7GpppN-mRNA hydrolase', 85, NULL, NULL, 53055),
(53056, '2.10.50.10-FF-000173', NULL, 'Uncharacterized protein', 65, NULL, NULL, 53056),
(53057, '2.130.10.10-FF-003941', NULL, 'Uncharacterized protein', 249, NULL, NULL, 53057),
(53058, '1.10.3210.10-FF-000042', NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase-like protein', 196, NULL, NULL, 53058),
(53059, '1.10.238.10-FF-000331', NULL, 'Ca2+-binding EF-hand protein', 71, NULL, NULL, 53059),
(53060, '1.10.10.390-FF-000006', NULL, 'Histone acetyltransferase type B catalytic subunit', 75, NULL, NULL, 53060),
(53061, '1.10.287.950-FF-000001', NULL, 'Methyl-accepting chemotaxis sensory transducer', 330, NULL, NULL, 53061),
(53062, '1.10.720.30-FF-000014', NULL, 'E3 SUMO-protein ligase SIZ1', 69, NULL, NULL, 53062),
(53063, '1.10.10.10-FF-001577', NULL, 'Zinc uptake regulation protein ZUR', 64, NULL, NULL, 53063),
(53064, '3.90.226.10-FF-000300', NULL, 'Uncharacterized protein', 136, NULL, NULL, 53064),
(53065, '1.10.287.1060-FF-000007', NULL, 'Charged multivesicular body protein 7', 79, NULL, NULL, 53065),
(53066, '3.30.1360.120-FF-000091', NULL, 'Predicted protein', 152, NULL, NULL, 53066),
(53067, '3.40.1110.10-FF-000205', NULL, 'Ca2+-transporting ATPase-like protein', 155, NULL, NULL, 53067),
(53068, '2.30.130.10-FF-000016', NULL, 'tRNA pseudouridine synthase B', 63, NULL, NULL, 53068),
(53069, '3.40.50.300-FF-003885', NULL, 'ATP binding protein', 381, NULL, NULL, 53069),
(53070, '3.90.530.10-FF-000007', NULL, NULL, 110, NULL, NULL, 53070),
(53071, '3.50.30.30-FF-000044', NULL, 'N-acetylated alpha-linked acidic dipeptidase like 1', 188, NULL, NULL, 53071),
(53072, '1.10.287.110-FF-000148', NULL, 'DnaJ protein', 111, NULL, NULL, 53072),
(53073, '3.40.30.10-FF-001140', NULL, 'Uncharacterized protein DpGSTM3', 60, NULL, NULL, 53073),
(53074, '2.60.40.150-FF-000049', NULL, 'Protein kinase C delta type', 130, NULL, NULL, 53074),
(53075, '3.80.10.10-FF-000873', NULL, 'Leucine-rich repeat-containing protein 8C', 368, NULL, NULL, 53075),
(53076, '1.10.3730.20-FF-000011', NULL, 'EamA family transporter', 92, NULL, NULL, 53076),
(53077, '3.40.50.261-FF-000013', NULL, 'Acetyltransferase, GNAT family', 171, NULL, NULL, 53077),
(53078, '1.20.1250.20-FF-000578', NULL, 'Mch4p', 190, NULL, NULL, 53078),
(53079, '3.30.1320.10-FF-000021', NULL, 'Putative 28S ribosomal protein S16, mitochondrial', 114, NULL, NULL, 53079),
(53080, '3.30.1010.10-FF-000099', NULL, 'Phosphatidylinositol kinase', 147, NULL, NULL, 53080),
(53081, '3.40.50.2020-FF-000073', NULL, 'Uncharacterized protein, isoform L', 60, NULL, NULL, 53081),
(53082, '3.10.20.770-FF-000008', NULL, 'Si:rp71-17i16.5', 286, NULL, NULL, 53082),
(53083, '3.30.70.330-FF-002006', NULL, NULL, 82, NULL, NULL, 53083);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(53084, '2.130.10.10-FF-004104', NULL, 'Uncharacterized protein', 193, NULL, NULL, 53084),
(53085, '3.40.50.300-FF-007157', NULL, 'Rab family GTPase', 175, NULL, NULL, 53085),
(53086, '1.50.10.10-FF-000171', NULL, 'Uncharacterized protein', 420, NULL, NULL, 53086),
(53087, '1.20.1050.80-FF-000007', NULL, 'Vacuolar protein sorting-associated protein 9A', 164, NULL, NULL, 53087),
(53088, '3.40.50.360-FF-000059', NULL, '5-methyltetrahydrofolate-homocysteine methyltransferase reductase', 166, NULL, NULL, 53088),
(53089, '3.90.70.10-FF-000095', NULL, 'Ubiquitinyl hydrolase 1', 338, NULL, NULL, 53089),
(53090, '2.60.40.10-FF-003519', NULL, NULL, 86, NULL, NULL, 53090),
(53091, '3.30.160.60-FF-004284', NULL, NULL, 28, NULL, NULL, 53091),
(53092, '1.10.530.10-FF-000027', NULL, 'Cell wall hydrolase', 143, NULL, NULL, 53092),
(53093, '3.40.50.1100-FF-000252', NULL, 'Uncharacterized protein', 197, NULL, NULL, 53093),
(53094, '1.10.287.1040-FF-000001', NULL, 'Exodeoxyribonuclease 7 small subunit', 75, NULL, NULL, 53094),
(53095, '3.40.50.150-FF-000041', NULL, 'Ribosomal RNA small subunit methyltransferase G', 238, NULL, NULL, 53095),
(53096, '3.10.580.10-FF-000051', NULL, 'Chloride channel protein', 158, NULL, NULL, 53096),
(53097, '3.30.70.330-FF-002967', NULL, NULL, 99, NULL, NULL, 53097),
(53098, '2.10.230.10-FF-000006', NULL, 'Chaperone protein dnaJ A6 chloroplastic', 65, NULL, NULL, 53098),
(53099, '3.40.50.300-FF-007595', NULL, 'Glr1151 protein', 166, NULL, NULL, 53099),
(53100, '3.40.350.10-FF-000021', NULL, 'xaa-Pro aminopeptidase 1 isoform X4', 84, NULL, NULL, 53100),
(53101, '3.30.160.60-FF-000411', NULL, 'PR domain zinc finger protein 10', 28, NULL, NULL, 53101),
(53102, '3.40.430.10-FF-000022', NULL, 'Riboflavin biosynthesis protein RibD', 227, NULL, NULL, 53102),
(53103, '3.90.640.10-FF-000274', NULL, 'DnaK protein', 81, NULL, NULL, 53103),
(53104, '3.30.830.10-FF-000330', NULL, 'Presequence protease', 39, NULL, NULL, 53104),
(53105, '2.70.150.10-FF-000104', NULL, 'Phospholipid-transporting ATPase', 182, NULL, NULL, 53105),
(53106, '2.60.40.1510-FF-000011', NULL, 'Integrin beta', 116, NULL, NULL, 53106),
(53107, '3.40.50.2020-FF-000016', NULL, 'Ribose-phosphate pyrophosphokinase II', 57, NULL, NULL, 53107),
(53108, '3.30.1370.70-FF-000002', NULL, 'NFU1 iron-sulfur cluster scaffold homolog, mitochondrial', 104, NULL, NULL, 53108),
(53109, '3.40.50.300-FF-003846', NULL, 'Spliceosome RNA helicase DDX39B', 133, NULL, NULL, 53109),
(53110, '3.30.40.10-FF-001394', NULL, 'CRE-MADD-2 protein', 50, NULL, NULL, 53110),
(53111, '1.10.10.10-FF-001690', NULL, 'DEP domain-containing protein 5', 108, NULL, NULL, 53111),
(53112, '1.10.418.10-FF-000204', NULL, 'Uncharacterized protein', 134, NULL, NULL, 53112),
(53113, '2.170.210.10-FF-000001', NULL, 'Non-homologous end-joining factor 1', 135, NULL, NULL, 53113),
(53114, '2.170.210.20-FF-000004', NULL, NULL, 215, NULL, NULL, 53114),
(53115, '2.40.50.140-FF-001093', NULL, NULL, 161, NULL, NULL, 53115),
(53116, '3.20.20.10-FF-000078', NULL, 'Proline synthase co-transcribed bacterial homolog protein', 148, NULL, NULL, 53116),
(53117, '1.10.8.270-FF-000113', NULL, 'TBC1 domain family, member 17', 44, NULL, NULL, 53117),
(53118, '3.30.230.70-FF-000010', NULL, 'Exosome complex component RRP41', 226, NULL, NULL, 53118),
(53119, '3.40.50.300-FF-004161', NULL, 'YALI0A17171p', 255, NULL, NULL, 53119),
(53120, '4.10.400.10-FF-000017', NULL, 'LDL receptor related protein 4', 39, NULL, NULL, 53120),
(53121, '3.40.50.620-FF-000665', NULL, 'Uncharacterized protein', 137, NULL, NULL, 53121),
(53122, '1.20.1270.50-FF-000009', NULL, 'Alpha-mannosidase F', 107, NULL, NULL, 53122),
(53123, '1.10.3720.10-FF-000125', NULL, 'ABC amino acid transporter, permease component', 216, NULL, NULL, 53123),
(53124, '3.30.160.60-FF-003789', NULL, 'Uncharacterized protein', 88, NULL, NULL, 53124),
(53125, '1.10.238.10-FF-000218', NULL, 'Phosphatase 2A regulatory subunit-related protein, putative', 169, NULL, NULL, 53125),
(53126, '3.30.40.10-FF-000899', NULL, 'PHD finger and BAH domain-containing protein', 65, NULL, NULL, 53126);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(53127, '1.10.132.70-FF-000024', NULL, 'Telomerase reverse transcriptase', 144, NULL, NULL, 53127),
(53128, '3.30.160.60-FF-003845', NULL, NULL, 38, NULL, NULL, 53128),
(53129, '1.10.287.70-FF-000344', NULL, 'KCNN (Potassium K ChaNNel, calcium activated)-Like', 177, NULL, NULL, 53129),
(53130, '3.40.50.200-FF-000039', NULL, 'Predicted protein', 85, NULL, NULL, 53130),
(53131, '3.40.1190.20-FF-000191', NULL, NULL, 269, NULL, NULL, 53131),
(53132, '3.30.479.20-FF-000049', NULL, 'Elongation factor Ts', 120, NULL, NULL, 53132),
(53133, '3.30.1360.120-FF-000034', NULL, 'Aminomethyltransferase', 143, NULL, NULL, 53133),
(53134, '1.20.1410.10-FF-000015', NULL, 'WGS project CABT00000000 data, contig 2.10', 194, NULL, NULL, 53134),
(53135, '2.30.30.140-FF-000321', NULL, 'Transcription elongation factor S-II, putative', 116, NULL, NULL, 53135),
(53136, '2.60.120.200-FF-000366', NULL, 'Laminin subunit alpha 3', 174, NULL, NULL, 53136),
(53137, '3.40.50.300-FF-007775', NULL, 'Predicted protein', 58, NULL, NULL, 53137),
(53138, '3.30.40.10-FF-001517', NULL, 'Zinc finger, C3HC4 type (RING finger), putative', 73, NULL, NULL, 53138),
(53139, '1.10.8.720-FF-000057', NULL, 'Dynein heavy chain, cytoplasmic', 170, NULL, NULL, 53139),
(53140, '1.10.472.80-FF-000244', NULL, NULL, 129, NULL, NULL, 53140),
(53141, '3.40.50.450-FF-000030', NULL, 'Diphosphate-fructose-6-phosphate 1-phosphotransferase', 101, NULL, NULL, 53141),
(53142, '1.10.287.1490-FF-000113', NULL, 'Spindle pole body protein pcp1', 139, NULL, NULL, 53142),
(53143, '3.30.460.10-FF-000077', NULL, 'Poly(A) polymerase, putative', 156, NULL, NULL, 53143),
(53144, '1.10.437.10-FF-000057', NULL, 'Uncharacterized protein', 66, NULL, NULL, 53144),
(53145, '3.40.50.300-FF-008051', NULL, 'Uncharacterized protein', 127, NULL, NULL, 53145),
(53146, '3.90.470.20-FF-000050', NULL, 'Holo-[acyl-carrier-protein] synthase', 80, NULL, NULL, 53146),
(53147, '3.30.310.220-FF-000005', NULL, 'Uncharacterized protein', 60, NULL, NULL, 53147),
(53148, '3.70.10.10-FF-000103', NULL, 'Cell cycle checkpoint control protein', 266, NULL, NULL, 53148),
(53149, '3.40.630.30-FF-000397', NULL, 'Histone acetyltransferase type B catalytic subunit', 127, NULL, NULL, 53149),
(53150, '3.40.50.12350-FF-000017', NULL, 'Uncharacterized protein', 257, NULL, NULL, 53150),
(53151, '3.30.470.110-FF-000001', NULL, 'ATP-citrate synthase', 236, NULL, NULL, 53151),
(53152, '3.30.572.10-FF-000016', NULL, 'Thymidylate synthase', 293, NULL, NULL, 53152),
(53153, '1.10.1520.10-FF-000065', NULL, 'YALI0D18150p', 239, NULL, NULL, 53153),
(53154, '2.130.10.10-FF-003267', NULL, 'Pre-mRNA-splicing factor RSE1', 176, NULL, NULL, 53154),
(53155, '3.40.50.300-FF-008270', NULL, 'Uncharacterized protein', 41, NULL, NULL, 53155),
(53156, '3.40.50.1240-FF-000153', NULL, NULL, 229, NULL, NULL, 53156),
(53157, '3.40.50.1820-FF-000479', NULL, 'Phosphoribosyl transferase', 215, NULL, NULL, 53157),
(53158, '3.40.50.300-FF-000013', NULL, 'PhoH family ATPase', 209, NULL, NULL, 53158),
(53159, '3.30.310.210-FF-000002', NULL, 'KH domain-containing protein', 170, NULL, NULL, 53159),
(53160, '3.30.160.60-FF-004065', NULL, NULL, 78, NULL, NULL, 53160),
(53161, '1.20.1070.10-FF-001606', NULL, '5-hydroxytryptamine receptor 1E', 149, NULL, NULL, 53161),
(53162, '1.10.510.10-FF-004180', NULL, NULL, 112, NULL, NULL, 53162),
(53163, '1.10.510.10-FF-000138', NULL, 'PX domain-containing protein kinase-like protein isoform X3', 142, NULL, NULL, 53163),
(53164, '1.10.220.10-FF-000037', NULL, 'Annexin', 100, NULL, NULL, 53164),
(53165, '3.80.10.10-FF-001311', NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', 121, NULL, NULL, 53165),
(53166, '3.10.20.90-FF-000080', NULL, 'protein-tyrosine kinase 2-beta isoform X1', 117, NULL, NULL, 53166),
(53167, '1.25.40.20-FF-001824', NULL, 'Uncharacterized protein', 302, NULL, NULL, 53167),
(53168, '1.10.510.10-FF-004123', NULL, NULL, 99, NULL, NULL, 53168),
(53169, '3.30.40.10-FF-001450', NULL, 'Uncharacterized protein', 79, NULL, NULL, 53169),
(53170, '1.20.1070.10-FF-001264', NULL, 'Adhesion G protein-coupled receptor B3', 290, NULL, NULL, 53170);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(53171, '3.30.160.60-FF-004340', NULL, NULL, 37, NULL, NULL, 53171),
(53172, '1.20.1250.20-FF-001034', NULL, 'Uncharacterized protein', 198, NULL, NULL, 53172),
(53173, '1.25.10.10-FF-000414', NULL, 'Kinase family with ARM repeat domain-containing protein', 274, NULL, NULL, 53173),
(53174, '1.10.565.10-FF-000169', NULL, 'Uncharacterized protein', 178, NULL, NULL, 53174),
(53175, '1.10.1200.10-FF-000136', NULL, 'Nonribosomal peptide synthase, putative (JCVI)', 62, NULL, NULL, 53175),
(53176, '2.60.40.790-FF-000050', NULL, 'Probable inactive shikimate kinase like 2, chloroplastic', 104, NULL, NULL, 53176),
(53177, '2.30.30.280-FF-000003', NULL, 'tRNA (5-methylaminomethyl-2-thiouridylate)-methyltransferase, putative', 63, NULL, NULL, 53177),
(53178, '3.40.50.1110-FF-000075', NULL, 'Uncharacterized protein', 235, NULL, NULL, 53178),
(53179, '1.25.40.10-FF-001821', NULL, 'TPR Domain containing protein', 115, NULL, NULL, 53179),
(53180, '3.10.20.30-FF-000101', NULL, NULL, 41, NULL, NULL, 53180),
(53181, '2.10.50.10-FF-000116', NULL, 'Predicted protein', 72, NULL, NULL, 53181),
(53182, '3.30.450.40-FF-000012', NULL, 'Phosphoenolpyruvate-protein phosphotransferase PtsP', 162, NULL, NULL, 53182),
(53183, '2.40.50.140-FF-000598', NULL, 'Single-stranded DNA-binding protein', 165, NULL, NULL, 53183),
(53184, '3.30.70.80-FF-000034', NULL, 'Proprotein convertase subtilisin/kexin type 9', 82, NULL, NULL, 53184),
(53185, '1.25.40.20-FF-000065', NULL, 'Ankyrin repeat domain-containing protein 27', 173, NULL, NULL, 53185),
(53186, '3.40.50.300-FF-004341', NULL, 'RAD51 paralog D', 248, NULL, NULL, 53186),
(53187, '1.50.10.10-FF-000058', NULL, 'YMR196W-like protein', 190, NULL, NULL, 53187),
(53188, '1.20.5.110-FF-000350', NULL, 'Qc-SNARE protein, Tlg1/Syntaxin 6-family', 65, NULL, NULL, 53188),
(53189, '3.30.70.1020-FF-000005', NULL, 'Trehalose 6-phosphate phosphatase', 73, NULL, NULL, 53189),
(53190, '1.10.510.10-FF-003847', NULL, NULL, 105, NULL, NULL, 53190),
(53191, '3.60.10.10-FF-000188', NULL, 'YALI0C08657p', 360, NULL, NULL, 53191),
(53192, '2.20.25.240-FF-000017', NULL, 'AGAP004541-PA', 87, NULL, NULL, 53192),
(53193, '2.40.150.20-FF-000024', NULL, 'Uncharacterized protein', 114, NULL, NULL, 53193),
(53194, '4.10.240.10-FF-000196', NULL, 'Putative transcription factor with C2H2 and Zn(2)-Cys(6) DNA binding domain (Eurofung)', 58, NULL, NULL, 53194),
(53195, '2.130.10.10-FF-000232', NULL, 'enhancer of mRNA-decapping protein 4', 315, NULL, NULL, 53195),
(53196, '1.10.238.110-FF-000010', NULL, 'Diacylglycerol kinase', 55, NULL, NULL, 53196),
(53197, '3.30.70.1170-FF-000022', NULL, 'S-adenosyl-L-methionine-dependent methyltransferase', 80, NULL, NULL, 53197),
(53198, '3.10.300.10-FF-000002', NULL, 'DNA-3-methyladenine glycosylase, putative', 201, NULL, NULL, 53198),
(53199, '2.10.25.10-FF-000772', NULL, 'Multiple epidermal growth factor-like domains 6', 38, NULL, NULL, 53199),
(53200, '1.10.20.10-FF-000004', NULL, 'Histone H2A', 127, NULL, NULL, 53200),
(53201, '3.30.420.40-FF-001078', NULL, 'Uncharacterized protein', 139, NULL, NULL, 53201),
(53202, '1.10.510.10-FF-000413', NULL, 'Serine/threonine-protein kinase', 176, NULL, NULL, 53202),
(53203, '1.20.1270.60-FF-000069', NULL, 'Nostrin, isoform D', 284, NULL, NULL, 53203),
(53204, '3.80.10.10-FF-001036', NULL, 'Uncharacterized protein, isoform A', 100, NULL, NULL, 53204),
(53205, '2.40.128.20-FF-000028', NULL, 'Violaxanthin de-epoxidase, chloroplastic', 184, NULL, NULL, 53205),
(53206, '3.40.50.10190-FF-000055', NULL, 'Microcephalin', 103, NULL, NULL, 53206),
(53207, '3.90.520.10-FF-000001', NULL, 'Mothers against decapentaplegic homolog', 125, NULL, NULL, 53207),
(53208, '1.10.150.50-FF-000206', NULL, 'Uncharacterized protein', 83, NULL, NULL, 53208),
(53209, '2.60.40.2000-FF-000001', NULL, 'Spore protein YabP', 58, NULL, NULL, 53209),
(53210, '3.40.50.300-FF-000631', NULL, 'Ras small monomeric GTPase', 167, NULL, NULL, 53210),
(53211, '3.40.50.300-FF-008612', NULL, 'Pre-initiation complex, subunit CDC6', 70, NULL, NULL, 53211),
(53212, '3.40.1670.10-FF-000005', NULL, 'UbiD family decarboxylase', 114, NULL, NULL, 53212);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(53213, '1.10.20.10-FF-000061', NULL, 'TFIID subunit', 89, NULL, NULL, 53213),
(53214, '1.10.10.60-FF-000221', NULL, 'MYB transcription factor', 73, NULL, NULL, 53214),
(53215, '2.60.40.60-FF-000460', NULL, 'Dachsous, isoform B', 109, NULL, NULL, 53215),
(53216, '3.30.160.60-FF-000630', NULL, 'Zinc finger protein 180', 28, NULL, NULL, 53216),
(53217, '2.10.25.10-FF-000715', NULL, 'Hemicentin 2', 43, NULL, NULL, 53217),
(53218, '2.130.10.10-FF-003609', NULL, 'SEC31 homolog B, COPII coat complex component', 86, NULL, NULL, 53218),
(53219, '3.30.9.10-FF-000085', NULL, 'Putative secreted oxidoreductase', 162, NULL, NULL, 53219),
(53220, '3.90.70.10-FF-000218', NULL, 'Uncharacterized protein', 370, NULL, NULL, 53220),
(53221, '2.60.120.380-FF-000088', NULL, 'Predicted protein', 88, NULL, NULL, 53221),
(53222, '3.30.70.260-FF-000119', NULL, 'D-3-phosphoglycerate dehydrogenase', 82, NULL, NULL, 53222),
(53223, '2.130.10.10-FF-003666', NULL, 'Uncharacterized protein', 264, NULL, NULL, 53223),
(53224, '3.20.20.70-FF-000399', NULL, 'Homocitrate synthase', 270, NULL, NULL, 53224),
(53225, '3.10.20.90-FF-000259', NULL, 'Raf serine/threonine-protein kinase phl', 83, NULL, NULL, 53225),
(53226, '2.10.25.10-FF-001272', NULL, 'Laminin subunit alpha-1', 50, NULL, NULL, 53226),
(53227, '1.20.1250.20-FF-000567', NULL, 'MonoCarboxylate Transporter family', 224, NULL, NULL, 53227),
(53228, '2.60.40.1170-FF-000004', NULL, 'SH3-containing GRB2-like protein 3-interacting protein 1 isoform X2', 26, NULL, NULL, 53228),
(53229, '3.40.50.300-FF-003638', NULL, 'DNA repair protein RecN', 230, NULL, NULL, 53229),
(53230, '3.20.10.10-FF-000066', NULL, 'Branched-chain-amino-acid aminotransferase', 176, NULL, NULL, 53230),
(53231, '3.40.50.2300-FF-001511', NULL, NULL, 97, NULL, NULL, 53231),
(53232, '3.30.540.10-FF-000021', NULL, 'Inositol monophosphatase', 149, NULL, NULL, 53232),
(53233, '3.20.20.70-FF-000551', NULL, NULL, 185, NULL, NULL, 53233),
(53234, '3.40.50.1820-FF-001440', NULL, 'Uncharacterized protein', 190, NULL, NULL, 53234),
(53235, '3.40.1010.10-FF-000023', NULL, NULL, 111, NULL, NULL, 53235),
(53236, '2.60.120.330-FF-000034', NULL, '2-oxoglutarate (2OG) and Fe(II)-dependent oxygenase superfamily protein', 327, NULL, NULL, 53236),
(53237, '3.30.70.330-FF-000899', NULL, 'RNA-binding protein 1', 104, NULL, NULL, 53237),
(53238, '1.10.1200.10-FF-000007', NULL, 'Probable polyketide synthase pks17', 98, NULL, NULL, 53238),
(53239, '1.25.40.610-FF-000007', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1', 127, NULL, NULL, 53239),
(53240, '3.30.9.10-FF-000057', NULL, 'Protein CBG22093', 167, NULL, NULL, 53240),
(53241, '2.60.120.620-FF-000014', NULL, 'Prolyl 3,4-dihydroxylase TPA1', 236, NULL, NULL, 53241),
(53242, '3.60.21.10-FF-000382', NULL, 'Uncharacterized protein', 78, NULL, NULL, 53242),
(53243, '3.10.490.20-FF-000041', NULL, 'Predicted protein', 92, NULL, NULL, 53243),
(53244, '1.10.8.10-FF-000082', NULL, 'Ubiquilin 3', 51, NULL, NULL, 53244),
(53245, '3.40.50.300-FF-000412', NULL, 'ADP-ribosylation factor 1', 174, NULL, NULL, 53245),
(53246, '1.10.10.10-FF-001757', NULL, 'DNA-directed RNA polymerase III subunit RPC3', 72, NULL, NULL, 53246),
(53247, '2.60.40.10-FF-004306', NULL, NULL, 102, NULL, NULL, 53247),
(53248, '1.50.40.10-FF-000184', NULL, 'Mitochondrial carrier protein, putative (AFU_orthologue AFUA_6G12900)', 297, NULL, NULL, 53248),
(53249, '1.10.150.80-FF-000024', NULL, 'Unplaced genomic scaffold supercont1.37, whole genome shotgun sequence', 89, NULL, NULL, 53249),
(53250, '3.50.50.60-FF-001408', NULL, 'Uncharacterized protein', 143, NULL, NULL, 53250),
(53251, '2.60.40.60-FF-000471', NULL, 'E-cadherin-like protein', 126, NULL, NULL, 53251),
(53252, '1.20.120.350-FF-000151', NULL, NULL, 115, NULL, NULL, 53252),
(53253, '1.10.520.10-FF-000021', NULL, 'Peroxidase', 124, NULL, NULL, 53253),
(53254, '2.70.170.10-FF-000116', NULL, 'CHRNA7 (exons 5-10) and FAM7A (exons A-E) fusion', 85, NULL, NULL, 53254),
(53255, '3.10.450.240-FF-000029', NULL, 'Uncharacterized protein C13G7.11', 154, NULL, NULL, 53255);
INSERT INTO "PUBLIC"."MODEL" VALUES
(53256, '3.30.70.1230-FF-000142', NULL, 'Blr5637 protein', 202, NULL, NULL, 53256),
(53257, '1.10.8.60-FF-000147', NULL, 'Putative ATP-dependent zinc metallopeptidase', 77, NULL, NULL, 53257),
(53258, '2.60.40.10-FF-001709', NULL, 'filamin-A isoform X9', 77, NULL, NULL, 53258),
(53259, '1.10.555.10-FF-000028', NULL, 'rho GTPase-activating protein 18 isoform X1', 255, NULL, NULL, 53259),
(53260, '4.10.1240.10-FF-000018', NULL, 'Secretin receptor', 78, NULL, NULL, 53260),
(53261, '2.30.29.30-FF-000847', NULL, 'RanBP1 domain containing protein', 188, NULL, NULL, 53261),
(53262, '3.90.640.10-FF-000257', NULL, 'Uncharacterized protein', 92, NULL, NULL, 53262),
(53263, '1.20.120.1080-FF-000118', NULL, 'Putative mrna splicing factor atp-dependent rna helicase', 105, NULL, NULL, 53263),
(53264, '1.25.10.10-FF-001393', NULL, 'VAC (Yeast VACuole morphology)-Like', 168, NULL, NULL, 53264),
(53265, '2.10.230.10-FF-000028', NULL, 'AGAP005908-PA', 63, NULL, NULL, 53265),
(53266, '3.10.580.10-FF-000157', NULL, 'Uncharacterized protein', 146, NULL, NULL, 53266),
(53267, '2.60.40.1180-FF-000007', NULL, 'Sucrose isomerase', 78, NULL, NULL, 53267),
(53268, '3.40.50.300-FF-004144', NULL, 'ADP-ribosylation factor, putative', 164, NULL, NULL, 53268),
(53269, '3.20.20.80-FF-000554', NULL, 'Uncharacterized protein', 128, NULL, NULL, 53269),
(53270, '3.40.140.10-FF-000230', NULL, 'CMP/dCMP deaminase, zinc-binding domain-containing protein', 167, NULL, NULL, 53270),
(53271, '2.30.310.10-FF-000002', NULL, 'nuclear export mediator factor Nemf', 158, NULL, NULL, 53271),
(53272, '1.20.5.240-FF-000001', NULL, 'Cholera enterotoxin subunit A', 46, NULL, NULL, 53272),
(53273, '1.20.1560.10-FF-000857', NULL, 'Bll6336 protein', 238, NULL, NULL, 53273),
(53274, '1.10.418.10-FF-000221', NULL, 'PH domain-containing protein DDB_G0287875', 123, NULL, NULL, 53274),
(53275, '1.10.510.10-FF-004308', NULL, NULL, 155, NULL, NULL, 53275),
(53276, '2.10.220.10-FF-000056', NULL, 'Fraser extracellular matrix complex subunit 1', 105, NULL, NULL, 53276),
(53277, '1.10.510.10-FF-003275', NULL, NULL, 102, NULL, NULL, 53277),
(53278, '3.10.105.10-FF-000032', NULL, 'Probable periplasmic oligopeptide-binding lipoprotein oppA', 214, NULL, NULL, 53278),
(53279, '2.40.250.10-FF-000006', NULL, 'Uncharacterized protein', 86, NULL, NULL, 53279),
(53280, '1.25.40.10-FF-004171', NULL, 'SYF pre-mRNA splicing factor homolog', 432, NULL, NULL, 53280),
(53281, '3.40.50.1820-FF-000967', NULL, 'AGAP001825-PA', 277, NULL, NULL, 53281),
(53282, '1.10.238.10-FF-000123', NULL, 'probable calcium-binding protein CML18', 77, NULL, NULL, 53282),
(53283, '3.80.10.10-FF-003407', NULL, 'Uncharacterized leucine-rich repeat-containing protein C926.06c', 88, NULL, NULL, 53283),
(53284, '2.60.40.10-FF-005397', NULL, NULL, 47, NULL, NULL, 53284),
(53285, '2.30.29.30-FF-001027', NULL, 'Uncharacterized protein', 141, NULL, NULL, 53285),
(53286, '3.20.80.10-FF-000014', NULL, 'Heme-binding-like protein, chloroplastic', 121, NULL, NULL, 53286),
(53287, '3.80.10.10-FF-000457', NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g34110', 160, NULL, NULL, 53287),
(53288, '2.170.130.30-FF-000006', NULL, NULL, 110, NULL, NULL, 53288),
(53289, '3.40.50.10330-FF-000097', NULL, 'Diacylglycerol kinase A', 154, NULL, NULL, 53289),
(53290, '2.60.40.10-FF-001698', NULL, 'contactin', 89, NULL, NULL, 53290),
(53291, '3.30.200.20-FF-001168', NULL, 'Protein kinase, putative', 97, NULL, NULL, 53291),
(53292, '4.10.1130.20-FF-000002', NULL, 'cysteine and histidine-rich domain-containing protein 1', 75, NULL, NULL, 53292),
(53293, '2.30.22.10-FF-000011', NULL, 'Putative co-chaperone, GrpE', 61, NULL, NULL, 53293),
(53294, '1.10.10.60-FF-001295', NULL, NULL, 99, NULL, NULL, 53294),
(53295, '3.20.70.20-FF-000045', NULL, 'Uncharacterized protein', 120, NULL, NULL, 53295),
(53296, '2.170.130.20-FF-000003', NULL, 'Multidomain scavenger receptor', 115, NULL, NULL, 53296),
(53297, '1.25.40.20-FF-000166', NULL, 'rabankyrin-5 isoform X1', 148, NULL, NULL, 53297),
(53298, '3.30.499.10-FF-000025', NULL, 'Aconitate hydratase', 356, NULL, NULL, 53298);
INSERT INTO "PUBLIC"."MODEL" VALUES
(53299, '1.20.1280.50-FF-000128', NULL, 'Leucine rich repeat protein', 42, NULL, NULL, 53299),
(53300, '2.20.70.10-FF-000201', NULL, 'Uncharacterized protein', 46, NULL, NULL, 53300),
(53301, '3.80.10.10-FF-000766', NULL, 'Os05g0263100 protein', 237, NULL, NULL, 53301),
(53302, '2.130.10.10-FF-001676', NULL, 'WD domain, G-beta repeat-containing protein', 192, NULL, NULL, 53302),
(53303, '3.40.50.1820-FF-000288', NULL, 'Pancreatic triacylglycerol lipase', 331, NULL, NULL, 53303),
(53304, '2.60.40.60-FF-000145', NULL, 'protocadherin-20', 101, NULL, NULL, 53304),
(53305, '3.40.50.10330-FF-000108', NULL, 'NAD kinase', 90, NULL, NULL, 53305),
(53306, '1.10.630.10-FF-000675', NULL, 'Os01g0388000 protein', 170, NULL, NULL, 53306),
(53307, '1.25.40.10-FF-001911', NULL, 'Uncharacterized protein', 438, NULL, NULL, 53307),
(53308, '2.130.10.10-FF-005375', NULL, 'WD repeat domain 27', 161, NULL, NULL, 53308),
(53309, '3.40.1840.10-FF-000002', NULL, 'Conserved protein', 75, NULL, NULL, 53309),
(53310, '3.30.160.60-FF-002620', NULL, 'Zinc finger protein 516', 69, NULL, NULL, 53310),
(53311, '1.10.1420.10-FF-000214', NULL, 'DNA mismatch repair protein', 135, NULL, NULL, 53311),
(53312, '3.40.50.300-FF-000119', NULL, 'Sulfate adenylyltransferase subunit 1', 230, NULL, NULL, 53312),
(53313, '1.20.1270.280-FF-000046', NULL, 'Uncharacterized protein', 117, NULL, NULL, 53313),
(53314, '2.40.440.10-FF-000015', NULL, 'ErfK/YbiS/YcfS/YnhG family protein', 122, NULL, NULL, 53314),
(53315, '3.40.33.10-FF-000146', NULL, 'Uncharacterized protein', 143, NULL, NULL, 53315),
(53316, '3.40.190.80-FF-000029', NULL, 'Inositol monophosphatase family protein', 120, NULL, NULL, 53316),
(53317, '1.10.10.440-FF-000044', NULL, 'Transcription elongation regulator 1', 68, NULL, NULL, 53317),
(53318, '1.25.50.20-FF-000094', NULL, 'Uncharacterized protein', 247, NULL, NULL, 53318),
(53319, '2.40.50.100-FF-000114', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 99, NULL, NULL, 53319),
(53320, '3.30.930.10-FF-000315', NULL, 'Phenylalanine--tRNA ligase beta subunit', 163, NULL, NULL, 53320),
(53321, '1.10.1450.10-FF-000042', NULL, 'Tetraspanin', 123, NULL, NULL, 53321),
(53322, '2.30.42.10-FF-000496', NULL, NULL, 53, NULL, NULL, 53322),
(53323, '2.30.110.10-FF-000004', NULL, 'Cellular repressor of E1A-stimulated genes 1', 166, NULL, NULL, 53323),
(53324, '4.10.400.10-FF-000091', NULL, 'Low-density lipoprotein receptor (Ldl)', 40, NULL, NULL, 53324),
(53325, '1.25.40.60-FF-000021', NULL, NULL, 121, NULL, NULL, 53325),
(53326, '3.10.50.40-FF-000016', NULL, 'Peptidylprolyl isomerase', 121, NULL, NULL, 53326),
(53327, '3.40.50.720-FF-001263', NULL, 'Siroheme synthase', 112, NULL, NULL, 53327),
(53328, '1.20.1250.20-FF-000893', NULL, 'Similar to transporter', 178, NULL, NULL, 53328),
(53329, '2.60.40.10-FF-005734', NULL, NULL, 111, NULL, NULL, 53329),
(53330, '3.30.200.20-FF-001494', NULL, NULL, 119, NULL, NULL, 53330),
(53331, '3.80.10.10-FF-002374', NULL, 'Insulin-like growth factor-binding protein complex acid labile subunit', 171, NULL, NULL, 53331),
(53332, '2.60.40.10-FF-003952', NULL, NULL, 105, NULL, NULL, 53332),
(53333, '1.10.630.10-FF-000349', NULL, 'Ent-kaurene oxidase', 476, NULL, NULL, 53333),
(53334, '3.30.450.90-FF-000009', NULL, 'Twitching motility protein PilT', 96, NULL, NULL, 53334),
(53335, '3.40.50.2300-FF-000685', NULL, 'Uncharacterized protein', 165, NULL, NULL, 53335),
(53336, '3.10.250.10-FF-000138', NULL, NULL, 70, NULL, NULL, 53336),
(53337, '3.40.50.300-FF-003964', NULL, 'Endoribonuclease Dcr-1', 207, NULL, NULL, 53337),
(53338, '3.40.50.300-FF-004470', NULL, 'Predicted protein', 319, NULL, NULL, 53338),
(53339, '2.60.40.150-FF-000414', NULL, 'Phosphoinositide phospholipase C', 135, NULL, NULL, 53339),
(53340, '1.50.10.10-FF-000047', NULL, 'Mannosyl-oligosaccharide alpha-1,2-mannosidase', 481, NULL, NULL, 53340),
(53341, '2.60.220.50-FF-000169', NULL, 'Uncharacterized protein', 125, NULL, NULL, 53341),
(53342, '1.10.287.110-FF-000311', NULL, 'Uncharacterized protein', 117, NULL, NULL, 53342);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(53343, '2.130.10.10-FF-003930', NULL, 'Prolactin regulatory element binding', 259, NULL, NULL, 53343),
(53344, '3.40.605.10-FF-000136', NULL, '4-trimethylaminobutyraldehyde dehydrogenase', 69, NULL, NULL, 53344),
(53345, '1.10.8.60-FF-000517', NULL, 'Uncharacterized protein', 48, NULL, NULL, 53345),
(53346, '3.40.50.2300-FF-001174', NULL, NULL, 109, NULL, NULL, 53346),
(53347, '3.30.160.60-FF-004109', NULL, NULL, 58, NULL, NULL, 53347),
(53348, '2.40.50.150-FF-000005', NULL, 'DNA-directed RNA polymerase subunit beta', 122, NULL, NULL, 53348),
(53349, '1.10.510.10-FF-003954', NULL, NULL, 53, NULL, NULL, 53349),
(53350, '1.25.40.70-FF-000024', NULL, 'Phosphatidylinositol 3-kinase age-1', 206, NULL, NULL, 53350),
(53351, '3.30.1490.220-FF-000003', NULL, 'inositol 1,3,4-trisphosphate 5/6-kinase 4 isoform X2', 99, NULL, NULL, 53351),
(53352, '1.25.40.10-FF-005273', NULL, 'Uncharacterized protein', 320, NULL, NULL, 53352),
(53353, '2.170.260.10-FF-000021', NULL, 'Endoribonuclease Dicer-like protein 1', 113, NULL, NULL, 53353),
(53354, '1.10.1520.10-FF-000054', NULL, 'Endoribonuclease Dicer-like Protein', 162, NULL, NULL, 53354),
(53355, '3.40.50.2300-FF-000994', NULL, NULL, 84, NULL, NULL, 53355),
(53356, '3.10.50.30-FF-000013', NULL, 'Uncharacterized protein', 82, NULL, NULL, 53356),
(53357, '1.20.1110.10-FF-000071', NULL, 'Calcium-transporting ATPase', 169, NULL, NULL, 53357),
(53358, '3.40.50.1820-FF-001114', NULL, 'Carboxylic ester hydrolase', 103, NULL, NULL, 53358),
(53359, '3.30.160.60-FF-000366', NULL, 'Putative Krueppel-like factor 4', 25, NULL, NULL, 53359),
(53360, '2.80.10.50-FF-000151', NULL, 'Otogelin-like', 143, NULL, NULL, 53360),
(53361, '3.40.50.2000-FF-000685', NULL, 'Glycosyltransferase, group 1 family protein', 190, NULL, NULL, 53361),
(53362, '2.40.50.140-FF-000002', NULL, 'Translation initiation factor IF-1', 72, NULL, NULL, 53362),
(53363, '1.10.1040.50-FF-000023', NULL, NULL, 145, NULL, NULL, 53363),
(53364, '1.10.720.30-FF-000008', NULL, 'Myocardin', 64, NULL, NULL, 53364),
(53365, '3.30.70.330-FF-001416', NULL, 'Peroxisome proliferator-activated receptor gamma, coactivator-related 1', 105, NULL, NULL, 53365),
(53366, '1.25.40.10-FF-003709', NULL, 'Uncharacterized protein', 77, NULL, NULL, 53366),
(53367, '3.30.2410.10-FF-000034', NULL, 'WWP1 isoform 12', 55, NULL, NULL, 53367),
(53368, '3.90.190.10-FF-000519', NULL, 'Uncharacterized protein', 123, NULL, NULL, 53368),
(53369, '1.10.510.10-FF-002173', NULL, 'Serine/threonine-protein kinase PLK', 178, NULL, NULL, 53369),
(53370, '3.40.30.10-FF-000432', NULL, 'Tryparedoxin peroxidase, putative', 196, NULL, NULL, 53370),
(53371, '3.40.950.10-FF-000033', NULL, NULL, 61, NULL, NULL, 53371),
(53372, '3.30.1360.120-FF-000107', NULL, 'Dimethylglycine dehydrogenase', 52, NULL, NULL, 53372),
(53373, '3.30.160.60-FF-001468', NULL, 'Zinc finger protein 672', 29, NULL, NULL, 53373),
(53374, '3.30.40.10-FF-001534', NULL, 'Vacuolar protein sorting-associated protein 11 homolog', 106, NULL, NULL, 53374),
(53375, '2.70.130.10-FF-000007', NULL, 'Insulin-like growth factor 2 receptor', 142, NULL, NULL, 53375),
(53376, '1.20.1070.10-FF-000792', NULL, 'galanin receptor type 1-like', 311, NULL, NULL, 53376),
(53377, '3.30.65.10-FF-000012', NULL, 'DNA topoisomerase', 52, NULL, NULL, 53377),
(53378, '3.90.1200.10-FF-000004', NULL, 'Thiamine kinase', 183, NULL, NULL, 53378),
(53379, '1.20.58.70-FF-000030', NULL, 'TLG2p Syntaxin-like t-SNARE', 232, NULL, NULL, 53379),
(53380, '1.20.58.390-FF-000028', NULL, 'Cholinergic receptor nicotinic beta 2 subunit', 70, NULL, NULL, 53380),
(53381, '3.90.1750.10-FF-000034', NULL, 'E3 ubiquitin-protein ligase', 155, NULL, NULL, 53381),
(53382, '1.20.120.1760-FF-000081', NULL, NULL, 162, NULL, NULL, 53382),
(53383, '3.40.1370.10-FF-000027', NULL, '50S ribosomal protein L4', 208, NULL, NULL, 53383),
(53384, '2.40.10.340-FF-000009', NULL, 'Cell shape-determining protein MreC', 73, NULL, NULL, 53384),
(53385, '3.50.30.10-FF-000015', NULL, NULL, 134, NULL, NULL, 53385),
(53386, '3.40.50.720-FF-000774', NULL, 'Glyoxylate reductase/hydroxypyruvate reductase', 97, NULL, NULL, 53386);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(53387, '1.25.40.10-FF-001248', NULL, 'Pentatricopeptide repeat-containing protein At5g09450, mitochondrial', 192, NULL, NULL, 53387),
(53388, '3.90.640.20-FF-000001', NULL, 'Immunogenic protein Mpt64', 86, NULL, NULL, 53388),
(53389, '2.60.40.10-FF-002171', NULL, 'Twitchin', 92, NULL, NULL, 53389),
(53390, '3.40.50.150-FF-000232', NULL, 'Sterol 24-C-methyltransferase erg6', 267, NULL, NULL, 53390),
(53391, '3.40.30.10-FF-000802', NULL, 'Uncharacterized protein', 62, NULL, NULL, 53391),
(53392, '3.40.50.300-FF-007707', NULL, 'Uncharacterized protein', 100, NULL, NULL, 53392),
(53393, '1.10.260.100-FF-000036', NULL, 'Uncharacterized protein', 41, NULL, NULL, 53393),
(53394, '4.10.410.10-FF-000046', NULL, 'AGAP011765-PA', 62, NULL, NULL, 53394),
(53395, '3.40.50.300-FF-007696', NULL, 'Uncharacterized protein', 105, NULL, NULL, 53395),
(53396, '1.20.1270.10-FF-000094', NULL, 'Uncharacterized protein', 112, NULL, NULL, 53396),
(53397, '3.30.70.330-FF-001096', NULL, 'Uncharacterized protein', 97, NULL, NULL, 53397),
(53398, '1.20.58.80-FF-000033', NULL, 'Alpha-1,4-glucan:maltose-1-phosphate maltosyltransferase', 81, NULL, NULL, 53398),
(53399, '1.10.510.10-FF-000402', NULL, 'MAPK/MAK/MRK overlapping kinase', 202, NULL, NULL, 53399),
(53400, '3.40.120.10-FF-000021', NULL, 'Phosphomannomutase/phosphoglucomutase', 78, NULL, NULL, 53400),
(53401, '1.10.20.10-FF-000111', NULL, 'Histone H3', 74, NULL, NULL, 53401),
(53402, '1.25.10.10-FF-001746', NULL, 'Uncharacterized protein', 995, NULL, NULL, 53402),
(53403, '1.20.1250.20-FF-001073', NULL, 'Uncharacterized protein, isoform C', 220, NULL, NULL, 53403),
(53404, '1.10.720.10-FF-000002', NULL, 'Transcription termination factor Rho', 47, NULL, NULL, 53404),
(53405, '3.40.50.300-FF-005555', NULL, 'Protein SMAX1-LIKE 6', 277, NULL, NULL, 53405),
(53406, '3.30.160.60-FF-001777', NULL, 'zinc finger protein 770', 35, NULL, NULL, 53406),
(53407, '3.20.20.10-FF-000005', NULL, 'Ornithine decarboxylase', 229, NULL, NULL, 53407),
(53408, '3.30.40.10-FF-001225', NULL, 'Protein CBG01632', 95, NULL, NULL, 53408),
(53409, '2.60.40.640-FF-000112', NULL, 'RE30730p', 76, NULL, NULL, 53409),
(53410, '1.20.58.90-FF-000036', NULL, NULL, 77, NULL, NULL, 53410),
(53411, '1.20.120.980-FF-000002', NULL, 'lysosomal Pro-X carboxypeptidase', 150, NULL, NULL, 53411),
(53412, '2.10.220.10-FF-000073', NULL, 'CXXC-rich, putative', 89, NULL, NULL, 53412),
(53413, '3.50.50.60-FF-001190', NULL, 'Flavin-containing monooxygenase', 60, NULL, NULL, 53413),
(53414, '1.10.3590.10-FF-000002', NULL, 'acid-sensing ion channel 1 isoform X2', 67, NULL, NULL, 53414),
(53415, '1.25.40.10-FF-003726', NULL, 'Glr1376 protein', 175, NULL, NULL, 53415),
(53416, '1.20.5.1190-FF-000008', NULL, 'Sodium channel protein', 27, NULL, NULL, 53416),
(53417, '1.20.1050.20-FF-000001', NULL, 'Signal transducer and activator of transcription', 181, NULL, NULL, 53417),
(53418, '1.10.287.2170-FF-000003', NULL, 'Predicted site-specific integrase-resolvase', 48, NULL, NULL, 53418),
(53419, '3.90.226.10-FF-000002', NULL, 'ATP-dependent Clp protease proteolytic subunit', 195, NULL, NULL, 53419),
(53420, '3.30.200.20-FF-001640', NULL, 'Putative serine/threonine-protein kinase pknB', 89, NULL, NULL, 53420),
(53421, '1.20.5.1180-FF-000005', NULL, NULL, 49, NULL, NULL, 53421),
(53422, '3.90.70.10-FF-000016', NULL, 'Ubiquitin carboxyl-terminal hydrolase 36', 314, NULL, NULL, 53422),
(53423, '3.30.160.60-FF-003929', NULL, NULL, 35, NULL, NULL, 53423),
(53424, '1.10.510.10-FF-001684', NULL, 'Cyclin-G-associated kinase', 301, NULL, NULL, 53424),
(53425, '3.30.930.10-FF-000287', NULL, 'eIF-2-alpha kinase GCN2', 330, NULL, NULL, 53425),
(53426, '3.30.70.1180-FF-000020', NULL, 'V-type proton ATPase subunit C', 44, NULL, NULL, 53426),
(53427, '3.40.50.10190-FF-000257', NULL, 'PIS (Pax-2, IA-1/6, Smad-2 interacting protein) homolog', 113, NULL, NULL, 53427),
(53428, '3.40.50.11840-FF-000016', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 2', 89, NULL, NULL, 53428),
(53429, '3.40.950.10-FF-000016', NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', 20, NULL, NULL, 53429);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(53430, '3.30.920.90-FF-000001', NULL, '5-methylcytosine-specific restriction enzyme B (EcoKMcrBC)', 169, NULL, NULL, 53430),
(53431, '1.25.10.10-FF-002117', NULL, 'RING-type E3 ubiquitin transferase', 159, NULL, NULL, 53431),
(53432, '3.30.505.10-FF-000108', NULL, 'Tyrosine-protein kinase', 100, NULL, NULL, 53432),
(53433, '1.10.540.10-FF-000084', NULL, 'Acyl-CoA dehydrogenase', 115, NULL, NULL, 53433),
(53434, '3.30.40.10-FF-001551', NULL, 'Si:dkey-111e8.1', 53, NULL, NULL, 53434),
(53435, '1.10.555.10-FF-000045', NULL, 'RhoGAP domain containing protein', 199, NULL, NULL, 53435),
(53436, '1.20.1560.10-FF-000548', NULL, 'Predicted protein', 327, NULL, NULL, 53436),
(53437, '3.40.50.300-FF-002227', NULL, 'DNA polymerase III subunit delta', 180, NULL, NULL, 53437),
(53438, '3.40.50.2300-FF-000100', NULL, 'Taste receptor type 1 member 2', 286, NULL, NULL, 53438),
(53439, '2.60.120.290-FF-000196', NULL, 'Uncharacterized protein', 65, NULL, NULL, 53439),
(53440, '3.40.1370.10-FF-000044', NULL, 'Uncharacterized protein', 118, NULL, NULL, 53440),
(53441, '1.20.120.730-FF-000023', NULL, 'Uncharacterized protein C4.03c', 133, NULL, NULL, 53441),
(53442, '3.30.160.60-FF-000512', NULL, 'zinc finger protein 197 isoform X1', 29, NULL, NULL, 53442),
(53443, '2.70.150.10-FF-000233', NULL, 'Calcium-transporting ATPase 9 plasma membrane-type', 132, NULL, NULL, 53443),
(53444, '1.20.1270.280-FF-000030', NULL, 'Dynein heavy chain 7', 174, NULL, NULL, 53444),
(53445, '3.30.160.60-FF-005829', NULL, NULL, 87, NULL, NULL, 53445),
(53446, '1.25.40.420-FF-000057', NULL, 'Goa-1', 75, NULL, NULL, 53446),
(53447, '2.10.50.10-FF-000072', NULL, 'TNF receptor superfamily member 8', 84, NULL, NULL, 53447),
(53448, '3.30.1360.170-FF-000015', NULL, 'Flavin-dependent thymidylate synthase', 155, NULL, NULL, 53448),
(53449, '3.30.980.10-FF-000043', NULL, 'Uncharacterized protein', 140, NULL, NULL, 53449),
(53450, '2.40.30.130-FF-000001', NULL, 'Alanine--tRNA ligase', 101, NULL, NULL, 53450),
(53451, '3.30.70.330-FF-000005', NULL, 'ELAV-like protein', 85, NULL, NULL, 53451),
(53452, '1.10.510.10-FF-003819', NULL, NULL, 114, NULL, NULL, 53452),
(53453, '1.20.1280.50-FF-000145', NULL, 'Predicted protein', 36, NULL, NULL, 53453),
(53454, '1.20.1250.20-FF-001056', NULL, 'Major facilitator superfamily MFS_1', 202, NULL, NULL, 53454),
(53455, '2.40.50.140-FF-000587', NULL, 'Replication protein A 32 kDa subunit B', 118, NULL, NULL, 53455),
(53456, '1.10.10.60-FF-000030', NULL, 'DNA-binding transcriptional regulator SoxS', 66, NULL, NULL, 53456),
(53457, '2.60.40.60-FF-000162', NULL, 'Protocadherin-20', 105, NULL, NULL, 53457),
(53458, '3.40.50.10330-FF-000125', NULL, 'Diacylglycerol kinase', 80, NULL, NULL, 53458),
(53459, '3.30.70.660-FF-000088', NULL, 'Uncharacterized protein', 74, NULL, NULL, 53459),
(53460, '3.30.160.60-FF-001794', NULL, NULL, 29, NULL, NULL, 53460),
(53461, '1.20.1050.40-FF-000007', NULL, 'YALI0F07667p', 138, NULL, NULL, 53461),
(53462, '1.10.10.2750-FF-000001', NULL, 'TBC1 domain family member 1 isoform X2', 82, NULL, NULL, 53462),
(53463, '3.30.70.340-FF-000008', NULL, 'Putative carboxypeptidase suro-1', 90, NULL, NULL, 53463),
(53464, '1.20.5.110-FF-000193', NULL, 'Uncharacterized protein', 47, NULL, NULL, 53464),
(53465, '3.40.50.300-FF-003655', NULL, 'Uncharacterized protein B13D15.290', 63, NULL, NULL, 53465),
(53466, '2.60.40.10-FF-003817', NULL, NULL, 100, NULL, NULL, 53466),
(53467, '1.10.1200.10-FF-000024', NULL, 'Nonribosomal peptide synthase Pes1', 72, NULL, NULL, 53467),
(53468, '3.40.50.1390-FF-000001', NULL, 'DNA recombinase', 125, NULL, NULL, 53468),
(53469, '4.10.400.10-FF-000118', NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein', 40, NULL, NULL, 53469),
(53470, '3.40.50.300-FF-004453', NULL, 'Uncharacterized protein', 173, NULL, NULL, 53470),
(53471, '1.20.1250.20-FF-002158', NULL, 'Potassium channel, putative', 194, NULL, NULL, 53471),
(53472, '3.40.1110.10-FF-000407', NULL, NULL, 68, NULL, NULL, 53472),
(53473, '3.30.60.30-FF-000131', NULL, 'Protein CBG17314', 56, NULL, NULL, 53473);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(53474, '1.25.40.10-FF-003491', NULL, 'Putative pentatricopeptide repeat-containing protein isoform A', 76, NULL, NULL, 53474),
(53475, '2.40.170.20-FF-000025', NULL, 'Fe(III)-pyochelin outer membrane receptor', 538, NULL, NULL, 53475),
(53476, '3.20.10.10-FF-000049', NULL, 'Branched chain amino acid aminotransferase', 169, NULL, NULL, 53476),
(53477, '2.130.10.10-FF-003604', NULL, 'Coronin', 148, NULL, NULL, 53477),
(53478, '3.10.490.20-FF-000024', NULL, 'Dynein heavy chain', 147, NULL, NULL, 53478),
(53479, '1.25.40.20-FF-001886', NULL, 'Protein 21.1', 182, NULL, NULL, 53479),
(53480, '1.20.120.1320-FF-000016', NULL, NULL, 104, NULL, NULL, 53480),
(53481, '3.40.50.10090-FF-000019', NULL, 'Uroporphyrinogen-III synthase', 130, NULL, NULL, 53481),
(53482, '3.10.450.240-FF-000013', NULL, 'Uncharacterized protein', 166, NULL, NULL, 53482),
(53483, '3.40.50.300-FF-002553', NULL, 'Adenylyl-sulfate kinase', 198, NULL, NULL, 53483),
(53484, '3.40.50.300-FF-000092', NULL, 'DNA repair protein Rad51 homolog', 243, NULL, NULL, 53484),
(53485, '3.10.20.90-FF-000052', NULL, 'Ubiquitin-like protein 5', 73, NULL, NULL, 53485),
(53486, '3.30.420.40-FF-000100', NULL, 'Actin-related protein 8', 187, NULL, NULL, 53486),
(53487, '3.80.10.10-FF-004291', NULL, 'Protein CBR-PXN-2', 237, NULL, NULL, 53487),
(53488, '2.40.50.140-FF-001104', NULL, NULL, 66, NULL, NULL, 53488),
(53489, '2.30.39.10-FF-000134', NULL, 'Uncharacterized protein', 78, NULL, NULL, 53489),
(53490, '1.20.5.170-FF-000295', NULL, 'Activating transcription factor 5', 35, NULL, NULL, 53490),
(53491, '1.20.1420.10-FF-000038', NULL, NULL, 150, NULL, NULL, 53491),
(53492, '3.40.50.2300-FF-000668', NULL, 'DNA-binding response regulator', 127, NULL, NULL, 53492),
(53493, '2.170.16.10-FF-000007', NULL, 'Protein RecA', 105, NULL, NULL, 53493),
(53494, '3.40.50.1820-FF-000597', NULL, 'Uncharacterized protein', 253, NULL, NULL, 53494),
(53495, '1.10.167.10-FF-000042', NULL, 'G protein-coupled receptor kinase', 177, NULL, NULL, 53495),
(53496, '1.10.8.10-FF-000065', NULL, 'E3 ubiquitin-protein ligase XIAP isoform X1', 54, NULL, NULL, 53496),
(53497, '3.20.20.140-FF-000418', NULL, 'Uncharacterized protein', 71, NULL, NULL, 53497),
(53498, '1.10.1060.10-FF-000035', NULL, NULL, 120, NULL, NULL, 53498),
(53499, '2.130.10.10-FF-005066', NULL, 'UBP9-binding protein bun107', 271, NULL, NULL, 53499),
(53500, '1.25.40.10-FF-001883', NULL, 'DnaJ_domain_containing_protein_-_putative', 381, NULL, NULL, 53500),
(53501, '3.40.630.30-FF-000318', NULL, 'Uncharacterized protein', 97, NULL, NULL, 53501),
(53502, '1.20.58.60-FF-000847', NULL, 'Uncharacterized protein', 141, NULL, NULL, 53502),
(53503, '3.40.605.10-FF-000119', NULL, 'Putative aldehyde dehydrogenase', 247, NULL, NULL, 53503),
(53504, '3.40.630.30-FF-000083', NULL, 'Acyl-CoA N-acyltransferases (NAT) superfamily protein', 168, NULL, NULL, 53504),
(53505, '3.30.530.20-FF-000113', NULL, 'Phosphatidylinositol transfer protein cytoplasmic 1', 130, NULL, NULL, 53505),
(53506, '3.30.200.20-FF-001538', NULL, 'Predicted protein', 97, NULL, NULL, 53506),
(53507, '3.40.50.620-FF-000862', NULL, 'Tyrosyl-tRNA synthetase 2', 170, NULL, NULL, 53507),
(53508, '3.40.50.720-FF-002589', NULL, 'L-lactate dehydrogenase', 146, NULL, NULL, 53508),
(53509, '1.10.533.10-FF-000281', NULL, 'Putative inhibitor of apoptosis', 121, NULL, NULL, 53509),
(53510, '1.25.40.70-FF-000041', NULL, 'Phosphatidylinositol 3-kinase class, putative', 228, NULL, NULL, 53510),
(53511, '1.20.1560.10-FF-000874', NULL, 'Predicted protein', 125, NULL, NULL, 53511),
(53512, '3.30.40.10-FF-002299', NULL, 'Uncharacterized protein', 117, NULL, NULL, 53512),
(53513, '1.25.40.10-FF-005290', NULL, 'HL04910p', 139, NULL, NULL, 53513),
(53514, '1.20.58.390-FF-000130', NULL, 'Si:ch211-256e16.7', 113, NULL, NULL, 53514),
(53515, '3.40.1160.10-FF-000091', NULL, 'Uncharacterized protein', 120, NULL, NULL, 53515),
(53516, '3.90.245.10-FF-000041', NULL, 'Uncharacterized protein', 293, NULL, NULL, 53516),
(53517, '2.130.10.10-FF-005919', NULL, 'Bromodomain and WD repeat-containing DDB_G0285837', 273, NULL, NULL, 53517);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(53518, '2.130.10.10-FF-003458', NULL, 'Alkaline phosphatase', 97, NULL, NULL, 53518),
(53519, '3.40.720.10-FF-000196', NULL, 'Predicted protein', 144, NULL, NULL, 53519),
(53520, '2.30.30.40-FF-000112', NULL, 'SH3 domain-containing kinase-binding protein 1', 60, NULL, NULL, 53520),
(53521, '1.20.1070.10-FF-000819', NULL, 'Frizzled', 168, NULL, NULL, 53521),
(53522, '1.20.1180.10-FF-000002', NULL, 'Probable acyl-[acyl-carrier-protein]--UDP-N-acetylglucosamine O-acyltransferase, mitochondrial', 84, NULL, NULL, 53522),
(53523, '3.90.190.10-FF-000475', NULL, 'Uncharacterized protein', 177, NULL, NULL, 53523),
(53524, '3.40.50.1260-FF-000058', NULL, 'Phosphoglycerate kinase', 35, NULL, NULL, 53524),
(53525, '3.40.50.2300-FF-000977', NULL, NULL, 169, NULL, NULL, 53525),
(53526, '3.90.245.10-FF-000024', NULL, 'Purine nucleosidase, putative (IunH-1)', 311, NULL, NULL, 53526),
(53527, '3.30.160.60-FF-003385', NULL, NULL, 31, NULL, NULL, 53527),
(53528, '3.40.50.720-FF-001307', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 194, NULL, NULL, 53528),
(53529, '1.25.40.20-FF-001577', NULL, 'Uncharacterized protein', 168, NULL, NULL, 53529),
(53530, '6.10.140.2220-FF-000068', NULL, 'Uncharacterized protein', 50, NULL, NULL, 53530),
(53531, '2.10.10.10-FF-000007', NULL, 'hepatocyte growth factor activator', 55, NULL, NULL, 53531),
(53532, '3.80.10.10-FF-004498', NULL, 'Predicted protein', 291, NULL, NULL, 53532),
(53533, '3.30.2410.10-FF-000051', NULL, 'Probable E3 ubiquitin protein ligase C167.07c', 113, NULL, NULL, 53533),
(53534, '3.40.120.10-FF-000004', NULL, 'Phosphoglucomutase 5', 105, NULL, NULL, 53534),
(53535, '3.30.200.20-FF-001314', NULL, 'Serine/threonine-protein kinase STE11', 69, NULL, NULL, 53535),
(53536, '1.10.510.10-FF-002510', NULL, NULL, 128, NULL, NULL, 53536),
(53537, '3.30.70.330-FF-001551', NULL, 'Uncharacterized protein', 93, NULL, NULL, 53537),
(53538, '3.40.50.1240-FF-000052', NULL, '6-phosphofructo-2-kinase/fructose-2,6-biphosphatase 1', 198, NULL, NULL, 53538),
(53539, '3.40.20.10-FF-000167', NULL, 'Predicted protein', 62, NULL, NULL, 53539),
(53540, '3.40.30.10-FF-000095', NULL, 'Glutaredoxin 2', 78, NULL, NULL, 53540),
(53541, '3.40.50.300-FF-000075', NULL, 'Dynein heavy chain, cytoplasmic', 336, NULL, NULL, 53541),
(53542, '2.70.130.10-FF-000024', NULL, 'Putative vacuolar sorting receptor', 173, NULL, NULL, 53542),
(53543, '2.30.39.10-FF-000117', NULL, 'Serpin A3-8', 101, NULL, NULL, 53543),
(53544, '2.130.10.10-FF-003149', NULL, 'Intraflagellar transport protein 122', 131, NULL, NULL, 53544),
(53545, '3.80.10.10-FF-002598', NULL, 'F-box/LRR-repeat protein 4', 71, NULL, NULL, 53545),
(53546, '1.50.40.10-FF-000521', NULL, 'Mitochondrial carrier protein-like protein', 181, NULL, NULL, 53546),
(53547, '2.130.10.10-FF-005049', NULL, 'WD-40 repeat protein, putative', 282, NULL, NULL, 53547),
(53548, '3.60.10.10-FF-000076', NULL, 'Type I inositol polyphosphate 5-phosphatase 8', 342, NULL, NULL, 53548),
(53549, '1.20.1730.10-FF-000039', NULL, 'Na+/glucose cotransporter', 512, NULL, NULL, 53549),
(53550, '1.20.1250.40-FF-000005', NULL, 'DNA-directed RNA polymerase III subunit RPC9 isoform X5', 48, NULL, NULL, 53550),
(53551, '3.90.190.10-FF-000166', NULL, 'Leucine rich repeat and phosphatase domain containing protein', 139, NULL, NULL, 53551),
(53552, '3.50.50.60-FF-001088', NULL, 'Os03g0193400 protein', 81, NULL, NULL, 53552),
(53553, '1.20.58.80-FF-000050', NULL, 'Bride of doubletime', 91, NULL, NULL, 53553),
(53554, '2.30.29.30-FF-000982', NULL, 'AER092Wp', 61, NULL, NULL, 53554),
(53555, '3.90.70.10-FF-000342', NULL, 'Ananain, putative, expressed', 129, NULL, NULL, 53555),
(53556, '3.90.1750.10-FF-000051', NULL, 'Ubiquitin protein ligase, putative', 152, NULL, NULL, 53556),
(53557, '4.10.410.10-FF-000063', NULL, 'Putative salivary kunitz domain protein', 60, NULL, NULL, 53557),
(53558, '1.25.40.10-FF-001574', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial isoform A', 61, NULL, NULL, 53558),
(53559, '1.10.510.10-FF-001358', NULL, 'Serine-threonine protein kinase, putative', 170, NULL, NULL, 53559);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(53560, '1.10.437.10-FF-000052', NULL, 'MCL1 apoptosis regulator, BCL2 family member b', 107, NULL, NULL, 53560),
(53561, '3.90.1450.10-FF-000005', NULL, 'Guanylate cyclase activator 2A', 84, NULL, NULL, 53561),
(53562, '2.130.10.10-FF-002502', NULL, 'Histidine kinase/response regulator hybrid protein', 101, NULL, NULL, 53562),
(53563, '3.40.50.280-FF-000012', NULL, 'Methylmalonyl-CoA mutase', 146, NULL, NULL, 53563),
(53564, '2.130.10.10-FF-005358', NULL, 'Uncharacterized protein', 174, NULL, NULL, 53564),
(53565, '1.20.1260.100-FF-000002', NULL, 'TspO and MBR related proteins', 151, NULL, NULL, 53565),
(53566, '3.30.160.60-FF-002283', NULL, 'Zinc finger protein 646', 22, NULL, NULL, 53566),
(53567, '2.60.120.10-FF-000352', NULL, 'Cyclic nucleotide-binding protein', 220, NULL, NULL, 53567),
(53568, '3.10.490.10-FF-000021', NULL, 'Gamma-glutamylcyclotransferase', 210, NULL, NULL, 53568),
(53569, '2.130.10.10-FF-000041', NULL, 'Splicing factor 3b subunit 3', 382, NULL, NULL, 53569),
(53570, '1.20.1250.20-FF-001410', NULL, 'MFS transporter, putative (AFU_orthologue AFUA_3G07120)', 256, NULL, NULL, 53570),
(53571, '3.20.20.10-FF-000022', NULL, 'S-adenosylmethionine decarboxylase-ornithine decarboxylase', 37, NULL, NULL, 53571),
(53572, '1.10.510.10-FF-001667', NULL, 'Serine/threonine-protein kinase/endoribonuclease IRE1', 186, NULL, NULL, 53572),
(53573, '1.10.510.10-FF-002201', NULL, 'Predicted protein', 217, NULL, NULL, 53573),
(53574, '1.10.520.10-FF-000004', NULL, 'Catalase-peroxidase', 179, NULL, NULL, 53574),
(53575, '2.80.10.50-FF-000134', NULL, 'Polypeptide N-acetylgalactosaminyltransferase 17', 100, NULL, NULL, 53575),
(53576, '1.10.10.10-FF-001920', NULL, 'Forkhead domain protein Q2-like protein', 97, NULL, NULL, 53576),
(53577, '3.30.160.60-FF-006026', NULL, NULL, 28, NULL, NULL, 53577),
(53578, '3.20.20.70-FF-000416', NULL, '4-hydroxy-2-oxoglutarate aldolase/2-dehydro-3-deoxyphosphogluconate aldolase', 201, NULL, NULL, 53578),
(53579, '3.40.30.10-FF-000656', NULL, 'Oligosaccharyltransferase complex subunit, putative', 175, NULL, NULL, 53579),
(53580, '2.130.10.10-FF-003784', NULL, 'Uncharacterized protein', 314, NULL, NULL, 53580),
(53581, '2.60.120.920-FF-000014', NULL, 'neuralized-like protein 4 isoform X2', 169, NULL, NULL, 53581),
(53582, '3.30.200.70-FF-000002', NULL, 'Stress response kinase A', 71, NULL, NULL, 53582),
(53583, '1.20.1250.20-FF-000876', NULL, 'Protein CBG07685', 205, NULL, NULL, 53583),
(53584, '3.40.190.290-FF-000101', NULL, 'LysR family transcriptional regulator', 207, NULL, NULL, 53584),
(53585, '3.40.630.30-FF-000644', NULL, 'AGAP009686-PA', 169, NULL, NULL, 53585),
(53586, '1.25.40.10-FF-003165', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 114, NULL, NULL, 53586),
(53587, '3.30.160.270-FF-000013', NULL, 'ADL015Cp', 176, NULL, NULL, 53587),
(53588, '1.10.8.270-FF-000012', NULL, 'TBC domain-containing protein kinase-like protein-like', 97, NULL, NULL, 53588),
(53589, '3.10.50.40-FF-000033', NULL, 'Foldase protein PrsA', 117, NULL, NULL, 53589),
(53590, '3.90.226.10-FF-000311', NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', 94, NULL, NULL, 53590),
(53591, '3.40.50.720-FF-001280', NULL, 'Molybdopterin biosynthesis protein MoeY', 164, NULL, NULL, 53591),
(53592, '3.40.50.720-FF-000791', NULL, 'Polyketide synthetase mbtD', 450, NULL, NULL, 53592),
(53593, '2.60.40.10-FF-000254', NULL, 'Antigen-presenting glycoprotein CD1d1', 100, NULL, NULL, 53593),
(53594, '3.40.50.1440-FF-000005', NULL, 'Tubulin beta chain', 262, NULL, NULL, 53594),
(53595, '3.40.50.12500-FF-000006', NULL, 'Peptide/nickel transport system ATP-binding protein', 240, NULL, NULL, 53595),
(53596, '3.30.980.10-FF-000026', NULL, 'Threonyl/alanyl tRNA synthetase SAD', 155, NULL, NULL, 53596),
(53597, '1.20.1440.100-FF-000004', NULL, 'Glycerol-3-phosphate 2-O-acyltransferase 6-like', 75, NULL, NULL, 53597),
(53598, '2.60.120.310-FF-000011', NULL, 'Predicted protein', 119, NULL, NULL, 53598),
(53599, '1.25.40.420-FF-000074', NULL, 'Uncharacterized protein', 77, NULL, NULL, 53599);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(53600, '1.20.1110.10-FF-000054', NULL, 'Calcium-transporting ATPase', 380, NULL, NULL, 53600),
(53601, '3.30.70.2850-FF-000009', NULL, 'DNA-directed RNA polymerase subunit', 198, NULL, NULL, 53601),
(53602, '3.40.50.1820-FF-000951', NULL, 'Alpha/beta hydrolase', 297, NULL, NULL, 53602),
(53603, '2.40.50.150-FF-000022', NULL, 'DNA-directed RNA polymerase subunit beta', 128, NULL, NULL, 53603),
(53604, '3.40.50.1010-FF-000258', NULL, NULL, 82, NULL, NULL, 53604),
(53605, '2.70.150.10-FF-000216', NULL, 'Cation-transporting ATPase', 166, NULL, NULL, 53605),
(53606, '1.10.510.10-FF-000256', NULL, 'Serine/threonine-protein kinase TOUSLED', 288, NULL, NULL, 53606),
(53607, '2.30.42.10-FF-000479', NULL, NULL, 98, NULL, NULL, 53607),
(53608, '3.30.160.60-FF-005846', NULL, NULL, 76, NULL, NULL, 53608),
(53609, '2.120.10.80-FF-000303', NULL, 'Uncharacterized protein', 188, NULL, NULL, 53609),
(53610, '2.40.20.10-FF-000001', NULL, 'Urokinase-type plasminogen activator', 90, NULL, NULL, 53610),
(53611, '3.40.50.1450-FF-000008', NULL, 'Periplasmically oriented, membrane-bound [NiFe]-hydrogenase maturation protease', 160, NULL, NULL, 53611),
(53612, '3.40.50.300-FF-004127', NULL, 'ATP-dependent nuclease subunit A', 150, NULL, NULL, 53612),
(53613, '1.10.510.10-FF-004101', NULL, NULL, 130, NULL, NULL, 53613),
(53614, '3.30.160.60-FF-003694', NULL, 'Draculin-like 3', 25, NULL, NULL, 53614),
(53615, '2.60.120.330-FF-000017', NULL, '2-oxoglutarate-dependent dioxygenase DAO', 301, NULL, NULL, 53615),
(53616, '3.40.50.1820-FF-001131', NULL, '2310038E17Rik protein', 171, NULL, NULL, 53616),
(53617, '3.30.1610.10-FF-000015', NULL, 'YALI0D17886p', 160, NULL, NULL, 53617),
(53618, '1.10.1040.50-FF-000006', NULL, 'Peroxisomal bifunctional enzyme', 233, NULL, NULL, 53618),
(53619, '1.20.120.1080-FF-000135', NULL, 'Uncharacterized protein', 154, NULL, NULL, 53619),
(53620, '3.40.50.740-FF-000004', NULL, 'Formate dehydrogenase subunit alpha', 261, NULL, NULL, 53620),
(53621, '3.30.230.70-FF-000122', NULL, 'RE29317p', 228, NULL, NULL, 53621),
(53622, '2.130.10.10-FF-000602', NULL, 'Periodic tryptophan protein 2', 219, NULL, NULL, 53622),
(53623, '3.30.450.40-FF-000135', NULL, 'Bacteriophytochrome', 205, NULL, NULL, 53623),
(53624, '2.10.220.10-FF-000191', NULL, 'Proprotein convertase subtilisin/kexin type 5a', 63, NULL, NULL, 53624),
(53625, '1.20.1250.20-FF-001365', NULL, 'Uncharacterized protein', 197, NULL, NULL, 53625),
(53626, '3.30.70.80-FF-000039', NULL, 'Uncharacterized protein', 75, NULL, NULL, 53626),
(53627, '3.60.21.10-FF-000090', NULL, 'Sphingomyelin phosphodiesterase', 88, NULL, NULL, 53627),
(53628, '1.20.1280.50-FF-000263', NULL, 'Uncharacterized protein', 55, NULL, NULL, 53628),
(53629, '3.40.140.70-FF-000006', NULL, 'ThiF family protein', 142, NULL, NULL, 53629),
(53630, '3.40.50.300-FF-006044', NULL, 'Senataxin', 146, NULL, NULL, 53630),
(53631, '1.25.10.10-FF-000111', NULL, 'Protein zer-1 homolog', 423, NULL, NULL, 53631),
(53632, '3.40.50.10860-FF-000020', NULL, 'Probable bifunctional methylenetetrahydrofolate dehydrogenase/cyclohydrolase 2', 33, NULL, NULL, 53632),
(53633, '3.40.50.150-FF-001867', NULL, NULL, 154, NULL, NULL, 53633),
(53634, '3.30.60.30-FF-000114', NULL, 'GG13119', 54, NULL, NULL, 53634),
(53635, '3.60.10.10-FF-000284', NULL, 'Uncharacterized protein', 238, NULL, NULL, 53635),
(53636, '2.30.30.100-FF-000096', NULL, 'Small nuclear ribonucleoprotein G', 75, NULL, NULL, 53636),
(53637, '3.40.1110.10-FF-000380', NULL, NULL, 232, NULL, NULL, 53637),
(53638, '2.160.20.70-FF-000018', NULL, 'Tubulin folding cofactor C', 177, NULL, NULL, 53638),
(53639, '1.10.287.110-FF-000165', NULL, 'Fe-S protein assembly co-chaperone HscB', 113, NULL, NULL, 53639),
(53640, '2.30.30.90-FF-000003', NULL, 'Iron-dependent repressor IdeR', 96, NULL, NULL, 53640),
(53641, '2.10.90.10-FF-000063', NULL, 'Glycoprotein hormone beta 5', 90, NULL, NULL, 53641),
(53642, '3.50.50.60-FF-001072', NULL, 'Uncharacterized protein', 51, NULL, NULL, 53642),
(53643, '1.25.10.10-FF-003337', NULL, 'Uncharacterized protein', 250, NULL, NULL, 53643);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(53644, '3.40.50.1820-FF-001086', NULL, '1H-3-hydroxy-4-oxoquinaldine 2,4-dioxygenase', 175, NULL, NULL, 53644),
(53645, '3.90.70.10-FF-000134', NULL, 'Ubiquitin-specific protease', 379, NULL, NULL, 53645),
(53646, '2.60.40.10-FF-001889', NULL, 'fasciclin-2 isoform X2', 124, NULL, NULL, 53646),
(53647, '1.10.510.10-FF-000273', NULL, 'Cyclin-dependent kinase C-2', 243, NULL, NULL, 53647),
(53648, '3.10.20.90-FF-000613', NULL, 'AGAP010770-PA', 82, NULL, NULL, 53648),
(53649, '3.40.50.300-FF-000120', NULL, 'ATP-dependent chaperone ClpB', 203, NULL, NULL, 53649),
(53650, '4.10.410.10-FF-000029', NULL, 'CRE-MEC-1 protein', 62, NULL, NULL, 53650),
(53651, '1.10.10.10-FF-001465', NULL, 'DNA-binding response regulator', 69, NULL, NULL, 53651),
(53652, '1.20.1250.20-FF-000921', NULL, 'Putative efflux transporter', 377, NULL, NULL, 53652),
(53653, '2.60.120.970-FF-000085', NULL, 'Uncharacterized protein', 211, NULL, NULL, 53653),
(53654, '1.20.1270.60-FF-000338', NULL, 'Uncharacterized protein', 87, NULL, NULL, 53654),
(53655, '2.40.50.140-FF-001076', NULL, NULL, 88, NULL, NULL, 53655),
(53656, '3.40.50.620-FF-000098', NULL, 'Valine--tRNA ligase', 216, NULL, NULL, 53656),
(53657, '3.40.50.10130-FF-000037', NULL, 'Uncharacterized protein', 157, NULL, NULL, 53657),
(53658, '1.10.8.60-FF-000282', NULL, 'Sigma-54-dependent Fis family transcriptional regulator', 75, NULL, NULL, 53658),
(53659, '1.20.1270.60-FF-000294', NULL, 'Asap2a protein', 146, NULL, NULL, 53659),
(53660, '1.20.140.40-FF-000043', NULL, '21 kDa protein', 161, NULL, NULL, 53660),
(53661, '4.10.1000.40-FF-000004', NULL, 'Uncharacterized protein, isoform A', 76, NULL, NULL, 53661),
(53662, '2.60.40.4330-FF-000003', NULL, 'Kinesin-like protein', 111, NULL, NULL, 53662),
(53663, '2.60.40.10-FF-002406', NULL, 'Wrapper/Rega-1/Klingon homolog', 103, NULL, NULL, 53663),
(53664, '3.20.20.70-FF-000197', NULL, 'Alpha-galactosidase', 280, NULL, NULL, 53664),
(53665, '2.10.60.10-FF-000027', NULL, 'Receptor protein serine/threonine kinase', 80, NULL, NULL, 53665),
(53666, '3.30.200.20-FF-000420', NULL, 'Putative receptor-like protein kinase', 108, NULL, NULL, 53666),
(53667, '1.20.970.10-FF-000007', NULL, 'Anthranilate phosphoribosyltransferase', 65, NULL, NULL, 53667),
(53668, '3.90.190.20-FF-000011', NULL, 'Folylpolyglutamate synthase', 198, NULL, NULL, 53668),
(53669, '4.10.1000.30-FF-000001', NULL, 'Zinc finger CCCH domain-containing protein 14', 64, NULL, NULL, 53669),
(53670, '2.40.30.10-FF-000254', NULL, 'Uncharacterized protein', 94, NULL, NULL, 53670),
(53671, '3.10.20.540-FF-000001', NULL, 'Replicase polyprotein 1a', 58, NULL, NULL, 53671),
(53672, '1.10.238.10-FF-001197', NULL, 'Uncharacterized protein', 79, NULL, NULL, 53672),
(53673, '3.80.10.10-FF-002609', NULL, 'Nuclear export factor-a isoform 1', 54, NULL, NULL, 53673),
(53674, '1.10.510.10-FF-003499', NULL, NULL, 256, NULL, NULL, 53674),
(53675, '3.30.60.90-FF-000025', NULL, 'Unplaced genomic scaffold supercont1.18, whole genome shotgun sequence', 60, NULL, NULL, 53675),
(53676, '1.10.10.10-FF-000037', NULL, 'Heat stress transcription factor B-4', 99, NULL, NULL, 53676),
(53677, '3.50.50.60-FF-001173', NULL, 'Predicted protein', 166, NULL, NULL, 53677),
(53678, '2.10.90.10-FF-000107', NULL, 'Protein CBR-DAF-7', 119, NULL, NULL, 53678),
(53679, '2.60.40.1730-FF-000088', NULL, NULL, 192, NULL, NULL, 53679),
(53680, '3.40.630.10-FF-000003', NULL, 'Probable aspartyl aminopeptidase', 296, NULL, NULL, 53680),
(53681, '3.30.870.10-FF-000023', NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', 235, NULL, NULL, 53681),
(53682, '2.60.40.340-FF-000011', NULL, 'Nuclear factor of activated T cells 3', 59, NULL, NULL, 53682),
(53683, '2.60.40.10-FF-003935', NULL, NULL, 134, NULL, NULL, 53683),
(53684, '1.20.120.680-FF-000002', NULL, 'Formimidoyltransferase-cyclodeaminase', 112, NULL, NULL, 53684),
(53685, '2.30.30.140-FF-000158', NULL, 'maternal protein tudor', 94, NULL, NULL, 53685),
(53686, '2.10.25.10-FF-000575', NULL, 'Crumbs, isoform C', 38, NULL, NULL, 53686),
(53687, '3.40.30.10-FF-000448', NULL, 'Protein disulfide-isomerase', 97, NULL, NULL, 53687);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(53688, '3.30.160.60-FF-004082', NULL, NULL, 34, NULL, NULL, 53688),
(53689, '3.40.50.300-FF-007680', NULL, 'Uncharacterized protein', 114, NULL, NULL, 53689),
(53690, '3.40.630.20-FF-000006', NULL, 'Peptidase C15, pyroglutamyl peptidase I-like protein', 234, NULL, NULL, 53690),
(53691, '3.30.160.60-FF-003368', NULL, NULL, 33, NULL, NULL, 53691),
(53692, '3.30.200.20-FF-000797', NULL, 'PTI1-like tyrosine-protein kinase 3', 78, NULL, NULL, 53692),
(53693, '3.90.228.10-FF-000029', NULL, 'Poly [ADP-ribose] polymerase', 218, NULL, NULL, 53693),
(53694, '1.20.1270.280-FF-000029', NULL, 'Dynein heavy chain 2', 168, NULL, NULL, 53694),
(53695, '1.25.10.10-FF-000010', NULL, 'Serine/threonine-protein phosphatase 2A 56 kDa regulatory subunit', 399, NULL, NULL, 53695),
(53696, '1.50.40.10-FF-000419', NULL, 'Mitochondrial substrate carrier family protein I', 309, NULL, NULL, 53696),
(53697, '2.40.50.100-FF-000131', NULL, 'Predicted protein', 53, NULL, NULL, 53697),
(53698, '2.10.50.10-FF-000088', NULL, 'Si:ch211-261n11.7', 84, NULL, NULL, 53698),
(53699, '1.25.40.10-FF-003373', NULL, 'Putative pentatricopeptide repeat-containing protein At3g16890, mitochondrial', 187, NULL, NULL, 53699),
(53700, '3.40.50.800-FF-000028', NULL, 'Histidine--tRNA ligase', 113, NULL, NULL, 53700),
(53701, '2.60.120.10-FF-000234', NULL, 'AraC family transcriptional regulator', 96, NULL, NULL, 53701),
(53702, '2.10.220.10-FF-000202', NULL, 'Predicted protein', 116, NULL, NULL, 53702),
(53703, '3.40.630.30-FF-000009', NULL, 'Amino-acid acetyltransferase', 147, NULL, NULL, 53703),
(53704, '1.10.8.870-FF-000012', NULL, 'Glycerol-3-phosphate dehydrogenase', 86, NULL, NULL, 53704),
(53705, '3.40.430.10-FF-000005', NULL, 'Riboflavin biosynthesis protein ribD', 217, NULL, NULL, 53705),
(53706, '3.40.50.300-FF-003981', NULL, 'Phosphatidylcholine translocator ABCB4', 22, NULL, NULL, 53706),
(53707, '3.20.20.380-FF-000007', NULL, 'Copper homeostasis protein CutC', 240, NULL, NULL, 53707),
(53708, '3.40.190.80-FF-000046', NULL, 'Ammonium transport protein', 127, NULL, NULL, 53708),
(53709, '3.20.20.190-FF-000074', NULL, 'Phosphatidylinositol-specific phospholipase c, putative', 295, NULL, NULL, 53709),
(53710, '3.10.290.10-FF-000023', NULL, '40S ribosomal protein S9', 75, NULL, NULL, 53710),
(53711, '2.60.220.50-FF-000186', NULL, 'Uncharacterized protein', 46, NULL, NULL, 53711),
(53712, '1.20.990.10-FF-000008', NULL, 'NADPH-dependent diflavin oxidoreductase 1', 128, NULL, NULL, 53712),
(53713, '2.70.98.20-FF-000018', NULL, 'Amine oxidase', 378, NULL, NULL, 53713),
(53714, '3.10.20.90-FF-000714', NULL, 'Nuclear protein localization protein 4 homolog', 72, NULL, NULL, 53714),
(53715, '3.40.50.300-FF-002244', NULL, 'ATP-dependent DNA helicase', 175, NULL, NULL, 53715),
(53716, '3.40.50.10190-FF-000049', NULL, 'RNA Polymerase II CTD phosphatase Fcp1', 90, NULL, NULL, 53716),
(53717, '2.60.40.10-FF-002507', NULL, 'Fc receptor like 4', 83, NULL, NULL, 53717),
(53718, '1.10.20.10-FF-000066', NULL, 'H2B histone family member W testis-specific', 131, NULL, NULL, 53718),
(53719, '3.40.50.300-FF-000636', NULL, 'ATP-binding cassette sub-family D member 3', 226, NULL, NULL, 53719),
(53720, '3.30.300.350-FF-000003', NULL, 'Probable GTP-binding protein OBGC1, chloroplastic', 72, NULL, NULL, 53720),
(53721, '2.130.10.10-FF-003913', NULL, 'Semaphorin 4d', 265, NULL, NULL, 53721),
(53722, '1.20.1250.20-FF-001039', NULL, 'Uncharacterized protein', 243, NULL, NULL, 53722),
(53723, '3.60.21.10-FF-000202', NULL, 'Acid sphingomyelinase-like phosphodiesterase 3b', 291, NULL, NULL, 53723),
(53724, '2.60.120.290-FF-000179', NULL, 'Uncharacterized protein', 112, NULL, NULL, 53724),
(53725, '3.30.70.1180-FF-000019', NULL, 'V-type proton ATPase subunit C', 46, NULL, NULL, 53725),
(53726, '3.30.70.340-FF-000025', NULL, NULL, 85, NULL, NULL, 53726),
(53727, '3.60.10.10-FF-000385', NULL, 'Uncharacterized protein', 72, NULL, NULL, 53727),
(53728, '1.25.40.20-FF-000251', NULL, 'Protein LHCP TRANSLOCATION DEFECT', 93, NULL, NULL, 53728),
(53729, '2.60.120.200-FF-000787', NULL, 'Uncharacterized protein', 116, NULL, NULL, 53729);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(53730, '3.30.830.10-FF-000223', NULL, 'Putative mitochondrial-processing peptidase subunit beta mitochondrial', 114, NULL, NULL, 53730),
(53731, '2.10.25.10-FF-000148', NULL, 'Delta-like protein', 41, NULL, NULL, 53731),
(53732, '3.80.10.10-FF-003172', NULL, 'Uncharacterized protein', 269, NULL, NULL, 53732),
(53733, '1.20.58.60-FF-000538', NULL, 'Nesprin-2', 216, NULL, NULL, 53733),
(53734, '1.10.8.960-FF-000005', NULL, 'Putative gamma-glutamylcysteine synthetase', 54, NULL, NULL, 53734),
(53735, '3.40.710.10-FF-000061', NULL, 'Penicillin-binding protein A', 308, NULL, NULL, 53735),
(53736, '3.30.60.20-FF-000111', NULL, 'CBN-KSR-1 protein', 73, NULL, NULL, 53736),
(53737, '2.40.110.10-FF-000030', NULL, 'Acyl-CoA dehydrogenase FadE4', 110, NULL, NULL, 53737),
(53738, '2.170.11.10-FF-000002', NULL, 'DNA topoisomerase I', 110, NULL, NULL, 53738),
(53739, '1.25.40.20-FF-000621', NULL, 'Uncharacterized protein', 112, NULL, NULL, 53739),
(53740, '3.30.420.10-FF-000349', NULL, 'DNA polymerase', 216, NULL, NULL, 53740),
(53741, '3.40.50.800-FF-000129', NULL, 'Uncharacterized protein', 108, NULL, NULL, 53741),
(53742, '2.60.40.10-FF-003834', NULL, NULL, 96, NULL, NULL, 53742),
(53743, '3.30.9.10-FF-000203', NULL, 'D-aspartate oxidase', 137, NULL, NULL, 53743),
(53744, '1.10.8.720-FF-000063', NULL, 'Dynein heavy chain family protein', 190, NULL, NULL, 53744),
(53745, '2.160.20.110-FF-000004', NULL, 'CXC-rich protein', 180, NULL, NULL, 53745),
(53746, '2.40.50.140-FF-000795', NULL, 'Eukaryotic translation initiation factor 2 subunit 1', 89, NULL, NULL, 53746),
(53747, '2.40.50.100-FF-000232', NULL, 'Fe(3+) ions import ATP-binding protein FbpC 1', 80, NULL, NULL, 53747),
(53748, '1.10.510.10-FF-000610', NULL, 'Calcium and calcium/calmodulin-dependent serine/threonine-protein kinase', 191, NULL, NULL, 53748),
(53749, '2.20.70.10-FF-000010', NULL, 'Transcription elongation regulator 1 (CA150)', 72, NULL, NULL, 53749),
(53750, '2.130.10.10-FF-004301', NULL, 'Uncharacterized protein', 117, NULL, NULL, 53750),
(53751, '3.30.1150.10-FF-000013', NULL, 'Protein TonB', 101, NULL, NULL, 53751),
(53752, '3.30.1110.10-FF-000005', NULL, 'Uncharacterized protein', 63, NULL, NULL, 53752),
(53753, '3.40.640.10-FF-000240', NULL, 'Molybdenum cofactor sulfurase', 285, NULL, NULL, 53753),
(53754, '1.25.40.1040-FF-000009', NULL, 'N-acetyltransferase subunit Nat1', 492, NULL, NULL, 53754),
(53755, '2.40.10.10-FF-000045', NULL, 'Replicase polyprotein 1a', 85, NULL, NULL, 53755),
(53756, '1.10.3500.10-FF-000036', NULL, 'Predicted protein', 116, NULL, NULL, 53756),
(53757, '3.40.630.10-FF-000312', NULL, 'Predicted protein', 292, NULL, NULL, 53757),
(53758, '2.40.155.10-FF-000009', NULL, 'Hemicentin 2', 227, NULL, NULL, 53758),
(53759, '3.40.190.10-FF-000879', NULL, 'Predicted protein', 105, NULL, NULL, 53759),
(53760, '1.25.40.1030-FF-000006', NULL, 'SEC31 homolog B, COPII coat complex component', 411, NULL, NULL, 53760),
(53761, '3.90.850.10-FF-000048', NULL, NULL, 300, NULL, NULL, 53761),
(53762, '3.40.50.150-FF-000024', NULL, 'tRNA (guanine-N(7)-)-methyltransferase', 210, NULL, NULL, 53762),
(53763, '2.60.40.10-FF-001474', NULL, 'Protein tyrosine phosphatase, receptor type Q', 95, NULL, NULL, 53763),
(53764, '3.40.50.2000-FF-000994', NULL, 'Uncharacterized protein', 46, NULL, NULL, 53764),
(53765, '3.30.70.260-FF-000092', NULL, 'Homoserine dehydrogenase', 75, NULL, NULL, 53765),
(53766, '3.20.20.140-FF-000435', NULL, 'Carbamoyl-phosphate synthetase 2, aspartate transcarbamylase, and dihydroorotase', 144, NULL, NULL, 53766),
(53767, '3.40.50.300-FF-000900', NULL, 'Eukaryotic elongation factor, selenocysteine-tRNA-specific', 198, NULL, NULL, 53767),
(53768, '3.40.50.1000-FF-000031', NULL, 'Probable copper-transporting ATPase HMA5', 166, NULL, NULL, 53768),
(53769, '3.30.200.20-FF-000212', NULL, 'Proline-rich receptor-like protein kinase PERK8', 104, NULL, NULL, 53769),
(53770, '1.25.40.490-FF-000004', NULL, 'Uncharacterized protein', 147, NULL, NULL, 53770),
(53771, '2.170.190.11-FF-000011', NULL, 'Molybdopterin molybdenumtransferase', 112, NULL, NULL, 53771);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(53772, '2.40.40.20-FF-000084', NULL, 'Uncharacterized protein', 83, NULL, NULL, 53772),
(53773, '2.40.100.10-FF-000102', NULL, 'Peptidyl-prolyl cis-trans isomerase, putative', 180, NULL, NULL, 53773),
(53774, '3.40.50.2300-FF-001056', NULL, NULL, 128, NULL, NULL, 53774),
(53775, '3.30.420.40-FF-000307', NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', 141, NULL, NULL, 53775),
(53776, '1.20.58.1590-FF-000010', NULL, 'Uncharacterized protein', 103, NULL, NULL, 53776),
(53777, '2.10.25.10-FF-000912', NULL, 'low-density lipoprotein receptor-related protein 2', 62, NULL, NULL, 53777),
(53778, '3.30.980.10-FF-000009', NULL, 'Uridine kinase', 143, NULL, NULL, 53778),
(53779, '3.40.50.450-FF-000024', NULL, 'Probable cytokinin riboside 5''-monophosphate phosphoribohydrolase LOG4', 183, NULL, NULL, 53779),
(53780, '3.30.200.20-FF-001185', NULL, 'Spore coat protein, CotS family', 94, NULL, NULL, 53780),
(53781, '3.40.50.300-FF-007887', NULL, 'Uncharacterized protein', 194, NULL, NULL, 53781),
(53782, '3.40.50.460-FF-000027', NULL, '6-phosphofructokinase, pyrophosphate-dependent', 151, NULL, NULL, 53782),
(53783, '1.25.40.20-FF-000357', NULL, 'ankyrin repeat domain-containing protein 6 isoform X1', 200, NULL, NULL, 53783),
(53784, '1.10.246.130-FF-000005', NULL, 'Gamma-glutamyltranspeptidase 1, putative', 107, NULL, NULL, 53784),
(53785, '2.40.40.20-FF-000022', NULL, 'Thiosulfate reductase PhsA', 136, NULL, NULL, 53785),
(53786, '1.10.246.140-FF-000008', NULL, 'Transcription and mRNA export factor SUS1', 112, NULL, NULL, 53786),
(53787, '1.25.40.10-FF-001439', NULL, 'Protein F54C1.5/ TPR repeat family', 104, NULL, NULL, 53787),
(53788, '2.130.10.10-FF-001659', NULL, 'Cleavage and polyadenylation specific factor 1, 160kDa (Predicted), isoform CRA_a', 161, NULL, NULL, 53788),
(53789, '3.30.930.10-FF-000433', NULL, 'Uncharacterized protein', 108, NULL, NULL, 53789),
(53790, '3.20.20.70-FF-000208', NULL, 'Fructose-bisphosphate aldolase', 156, NULL, NULL, 53790),
(53791, '3.30.499.10-FF-000042', NULL, NULL, 70, NULL, NULL, 53791),
(53792, '1.10.132.20-FF-000021', NULL, 'Uncharacterized protein', 90, NULL, NULL, 53792),
(53793, '1.20.1560.10-FF-000891', NULL, 'Predicted protein', 30, NULL, NULL, 53793),
(53794, '1.10.10.10-FF-001892', NULL, 'RNA polymerase sigma factor', 50, NULL, NULL, 53794),
(53795, '2.130.10.10-FF-002047', NULL, 'WD domain containing protein', 192, NULL, NULL, 53795),
(53796, '3.40.50.300-FF-007825', NULL, 'RAD50 DNA repair-like protein', 272, NULL, NULL, 53796),
(53797, '3.40.50.2300-FF-001483', NULL, NULL, 135, NULL, NULL, 53797),
(53798, '3.30.160.60-FF-001586', NULL, 'Zinc finger protein 354B', 33, NULL, NULL, 53798),
(53799, '3.90.770.10-FF-000002', NULL, '3-hydroxy-3-methylglutaryl coenzyme A reductase', 176, NULL, NULL, 53799),
(53800, '1.10.3480.20-FF-000002', NULL, 'AGAP012757-PA', 70, NULL, NULL, 53800),
(53801, '1.10.8.480-FF-000002', NULL, 'rRNA adenine N(6)-methyltransferase', 104, NULL, NULL, 53801),
(53802, '1.10.132.30-FF-000024', NULL, 'DNA-directed RNA polymerase I subunit rpa1', 100, NULL, NULL, 53802),
(53803, '4.10.110.10-FF-000001', NULL, 'Trefoil factor 3', 56, NULL, NULL, 53803),
(53804, '1.20.900.10-FF-000059', NULL, 'Protein CBG22463', 209, NULL, NULL, 53804),
(53805, '1.10.630.10-FF-000658', NULL, 'Uncharacterized protein', 193, NULL, NULL, 53805),
(53806, '1.10.580.10-FF-000013', NULL, 'Citrate synthase-like protein, putative', 30, NULL, NULL, 53806),
(53807, '1.10.510.10-FF-004073', NULL, NULL, 175, NULL, NULL, 53807),
(53808, '1.10.260.40-FF-000083', NULL, 'Transcriptional repressor LexA, putative', 77, NULL, NULL, 53808),
(53809, '3.90.245.10-FF-000007', NULL, 'Nucleoside hydrolase', 343, NULL, NULL, 53809),
(53810, '2.10.220.10-FF-000090', NULL, 'Fraser extracellular matrix complex subunit 1', 58, NULL, NULL, 53810),
(53811, '3.30.1120.10-FF-000039', NULL, 'N-acetylgalactosamine 6-sulfate sulfatase (GALNS)', 81, NULL, NULL, 53811),
(53812, '2.60.120.10-FF-000026', NULL, 'Homogentisate 1,2-dioxygenase', 137, NULL, NULL, 53812);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(53813, '3.30.60.30-FF-000013', NULL, 'Agrin', 58, NULL, NULL, 53813),
(53814, '3.30.2310.20-FF-000006', NULL, 'Possible toxin pare2', 89, NULL, NULL, 53814),
(53815, '3.30.9.10-FF-000192', NULL, 'FAD dependent oxidoreductase', 186, NULL, NULL, 53815),
(53816, '3.40.50.300-FF-003773', NULL, 'Protein CBR-PGP-10', 139, NULL, NULL, 53816),
(53817, '2.40.30.10-FF-000153', NULL, 'GTP-binding protein TypA/BipA', 126, NULL, NULL, 53817),
(53818, '3.30.70.1560-FF-000010', NULL, 'Uncharacterized RNA pseudouridine synthase jhp_1352', 92, NULL, NULL, 53818),
(53819, '1.10.150.50-FF-000156', NULL, 'Uncharacterized protein, isoform A', 79, NULL, NULL, 53819),
(53820, '3.90.25.10-FF-000075', NULL, 'UDP-glucose-4-epimerase', 96, NULL, NULL, 53820),
(53821, '3.60.21.10-FF-000101', NULL, 'Serine/threonine-protein phosphatase', 354, NULL, NULL, 53821),
(53822, '2.10.70.10-FF-000207', NULL, 'Uncharacterized protein', 59, NULL, NULL, 53822),
(53823, '3.80.10.10-FF-003071', NULL, 'Uncharacterized protein', 133, NULL, NULL, 53823),
(53824, '3.40.50.300-FF-001839', NULL, 'RuvB-like helicase', 164, NULL, NULL, 53824),
(53825, '3.30.60.20-FF-000010', NULL, 'Putative kinase suppressor of Ras 1', 49, NULL, NULL, 53825),
(53826, '1.10.3060.10-FF-000018', NULL, 'Protein translocase subunit SecA 1', 210, NULL, NULL, 53826),
(53827, '1.10.472.80-FF-000261', NULL, NULL, 126, NULL, NULL, 53827),
(53828, '1.10.150.80-FF-000041', NULL, 'ATP-dependent DNA helicase', 87, NULL, NULL, 53828),
(53829, '3.30.70.330-FF-002698', NULL, NULL, 114, NULL, NULL, 53829),
(53830, '3.50.50.60-FF-001425', NULL, 'Expressed protein', 244, NULL, NULL, 53830),
(53831, '1.10.8.10-FF-000273', NULL, 'ATP-dependent protease ATPase subunit HslU', 73, NULL, NULL, 53831),
(53832, '1.10.10.10-FF-001774', NULL, 'Two-component response regulator', 111, NULL, NULL, 53832),
(53833, '3.40.50.2020-FF-000078', NULL, 'ribose-phosphate pyrophosphokinase 4', 144, NULL, NULL, 53833),
(53834, '3.30.160.60-FF-003840', NULL, NULL, 30, NULL, NULL, 53834),
(53835, '3.60.21.10-FF-000410', NULL, 'Serine/threonine-protein phosphatase', 289, NULL, NULL, 53835),
(53836, '1.25.40.180-FF-000294', NULL, NULL, 113, NULL, NULL, 53836),
(53837, '3.40.50.300-FF-008505', NULL, 'UvrD/REP helicase domain protein, putative', 128, NULL, NULL, 53837),
(53838, '2.60.120.290-FF-000078', NULL, 'CUB and zona pellucida-like domain-containing protein 1', 117, NULL, NULL, 53838),
(53839, '3.40.50.1010-FF-000034', NULL, 'Ribonuclease H', 166, NULL, NULL, 53839),
(53840, '1.25.40.10-FF-002046', NULL, 'Pentatricopeptide repeat-containing protein At2g18940, chloroplastic', 124, NULL, NULL, 53840),
(53841, '1.10.10.10-FF-000801', NULL, 'Histone acetyltransferase', 86, NULL, NULL, 53841),
(53842, '3.40.50.720-FF-001515', NULL, 'Chromosome 12, whole genome shotgun sequence', 268, NULL, NULL, 53842),
(53843, '1.50.10.10-FF-000165', NULL, 'Family 48 cellulase', 122, NULL, NULL, 53843),
(53844, '2.60.120.220-FF-000001', NULL, 'Capsid protein', 165, NULL, NULL, 53844),
(53845, '3.40.50.2000-FF-001056', NULL, 'Uncharacterized protein', 110, NULL, NULL, 53845),
(53846, '2.60.40.1180-FF-000024', NULL, 'Cytoplasmic alpha-amylase', 86, NULL, NULL, 53846),
(53847, '3.90.190.10-FF-000267', NULL, 'Putative tyrosine phosphatase', 130, NULL, NULL, 53847),
(53848, '2.60.120.10-FF-000335', NULL, 'Cysteine dioxygenase', 207, NULL, NULL, 53848),
(53849, '3.40.50.2300-FF-001365', NULL, NULL, 163, NULL, NULL, 53849),
(53850, '1.25.40.20-FF-000150', NULL, 'calmodulin-binding transcription activator 5', 141, NULL, NULL, 53850),
(53851, '1.20.1250.20-FF-002366', NULL, 'Uncharacterized protein', 337, NULL, NULL, 53851),
(53852, '1.10.287.70-FF-000428', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 165, NULL, NULL, 53852),
(53853, '2.30.30.380-FF-000016', NULL, 'Protein transport protein SEC23', 59, NULL, NULL, 53853),
(53854, '2.60.120.10-FF-000705', NULL, 'Predicted protein', 72, NULL, NULL, 53854),
(53855, '1.20.1280.50-FF-000162', NULL, 'Uncharacterized protein', 100, NULL, NULL, 53855),
(53856, '4.10.400.10-FF-000309', NULL, 'GPR insulin like receptor 1', 35, NULL, NULL, 53856);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(53857, '3.40.140.10-FF-000213', NULL, 'Uncharacterized protein', 64, NULL, NULL, 53857),
(53858, '1.10.220.10-FF-000054', NULL, 'Annexin', 47, NULL, NULL, 53858),
(53859, '1.10.3520.10-FF-000037', NULL, 'Os04g0438600 protein', 92, NULL, NULL, 53859),
(53860, '2.60.40.1170-FF-000021', NULL, 'AP-4 complex subunit mu-1 isoform X1', 120, NULL, NULL, 53860),
(53861, '3.60.130.10-FF-000079', NULL, 'Uncharacterized protein', 221, NULL, NULL, 53861),
(53862, '3.40.50.1820-FF-001322', NULL, 'Lipase, putative', 258, NULL, NULL, 53862),
(53863, '2.130.10.10-FF-003593', NULL, 'Uncharacterized protein', 258, NULL, NULL, 53863),
(53864, '3.60.21.10-FF-000308', NULL, 'Uncharacterized protein', 272, NULL, NULL, 53864),
(53865, '3.80.10.10-FF-002918', NULL, 'Uncharacterized protein', 77, NULL, NULL, 53865),
(53866, '1.25.40.10-FF-001782', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 166, NULL, NULL, 53866),
(53867, '1.25.40.20-FF-001785', NULL, 'Uncharacterized protein', 177, NULL, NULL, 53867),
(53868, '1.20.1250.20-FF-000685', NULL, 'MFS transporter', 187, NULL, NULL, 53868),
(53869, '2.60.120.330-FF-000152', NULL, 'Oxidoreductase, 2OG-Fe(II) oxygenase family, putative', 305, NULL, NULL, 53869),
(53870, '2.60.40.790-FF-000033', NULL, 'Ubiquitin specific peptidase 19', 92, NULL, NULL, 53870),
(53871, '3.90.260.10-FF-000020', NULL, 'Uncharacterized protein, isoform C', 158, NULL, NULL, 53871),
(53872, '3.90.1290.10-FF-000032', NULL, 'AGAP011396-PA', 151, NULL, NULL, 53872),
(53873, '3.40.30.10-FF-000241', NULL, 'Glutathione S-transferase F9', 80, NULL, NULL, 53873),
(53874, '3.30.70.330-FF-001107', NULL, 'GM14902', 89, NULL, NULL, 53874),
(53875, '1.10.630.10-FF-000804', NULL, 'Uncharacterized protein', 421, NULL, NULL, 53875),
(53876, '1.25.40.10-FF-004300', NULL, 'Uncharacterized protein', 194, NULL, NULL, 53876),
(53877, '2.60.40.10-FF-005526', NULL, NULL, 62, NULL, NULL, 53877),
(53878, '1.25.40.10-FF-003682', NULL, 'Putative pentatricopeptide repeat-containing protein', 118, NULL, NULL, 53878),
(53879, '1.10.287.1890-FF-000003', NULL, 'tRNA (Adenine(22)-N(1))-methyltransferase', 61, NULL, NULL, 53879),
(53880, '2.130.10.10-FF-005493', NULL, 'Cleavage and polyadenylation specificity factor, putative', 120, NULL, NULL, 53880),
(53881, '3.90.950.20-FF-000002', NULL, 'CinA-like protein', 158, NULL, NULL, 53881),
(53882, '2.60.40.10-FF-001682', NULL, 'filamin-A isoform X8', 102, NULL, NULL, 53882),
(53883, '1.25.40.20-FF-000503', NULL, 'Ankyrin repeat domain 2 (stretch responsive muscle)', 124, NULL, NULL, 53883),
(53884, '2.30.29.30-FF-000538', NULL, 'Pleckstrin-like domain-containing protein', 113, NULL, NULL, 53884),
(53885, '3.40.50.10470-FF-000010', NULL, 'Methylthioribose-1-phosphate isomerase', 195, NULL, NULL, 53885),
(53886, '1.10.287.1130-FF-000011', NULL, 'Cx9C motif-containing protein 4', 68, NULL, NULL, 53886),
(53887, '2.170.270.10-FF-000201', NULL, 'Predicted protein', 177, NULL, NULL, 53887),
(53888, '3.40.50.1010-FF-000242', NULL, NULL, 238, NULL, NULL, 53888),
(53889, '1.20.1070.10-FF-001281', NULL, 'Uncharacterized protein', 336, NULL, NULL, 53889),
(53890, '2.10.25.10-FF-000928', NULL, 'Protein eyes shut homolog', 30, NULL, NULL, 53890),
(53891, '1.25.40.120-FF-000074', NULL, 'Uncharacterized protein', 105, NULL, NULL, 53891),
(53892, '1.20.1310.20-FF-000055', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 199, NULL, NULL, 53892),
(53893, '1.10.8.10-FF-000289', NULL, 'Ubiquitinyl hydrolase 1', 82, NULL, NULL, 53893),
(53894, '3.30.2160.10-FF-000042', NULL, 'Predicted protein', 80, NULL, NULL, 53894),
(53895, '1.20.1070.10-FF-000775', NULL, 'Predicted protein', 194, NULL, NULL, 53895),
(53896, '1.10.287.70-FF-000546', NULL, 'Uncharacterized protein', 115, NULL, NULL, 53896),
(53897, '2.60.40.10-FF-002300', NULL, 'Ephrin receptor 1', 100, NULL, NULL, 53897),
(53898, '1.10.3370.10-FF-000019', NULL, 'Retrotransposon protein, putative, Ty3-gypsy subclass', 116, NULL, NULL, 53898),
(53899, '3.30.200.20-FF-000111', NULL, 'Tyrosine-protein kinase receptor TYRO3', 112, NULL, NULL, 53899);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(53900, '1.20.120.350-FF-000134', NULL, 'Uncharacterized protein', 153, NULL, NULL, 53900),
(53901, '1.10.3380.10-FF-000048', NULL, 'Activating signal cointegrator 1 complex subunit 3', 52, NULL, NULL, 53901),
(53902, '1.10.287.2900-FF-000014', NULL, 'Uncharacterized protein', 76, NULL, NULL, 53902),
(53903, '1.25.40.790-FF-000004', NULL, 'Not1, isoform C', 299, NULL, NULL, 53903),
(53904, '2.60.40.10-FF-000400', NULL, 'Hepatocyte growth factor receptor', 125, NULL, NULL, 53904),
(53905, '1.25.40.180-FF-000176', NULL, 'nuclear cap-binding protein subunit 1-A-like', 294, NULL, NULL, 53905),
(53906, '1.10.287.1150-FF-000017', NULL, '2-oxoglutarate dehydrogenase subunit, putative', 93, NULL, NULL, 53906),
(53907, '1.10.287.660-FF-000009', NULL, 'Golgi to ER traffic protein 1', 84, NULL, NULL, 53907),
(53908, '1.10.10.430-FF-000007', NULL, 'Protein phosphatase 1A', 71, NULL, NULL, 53908),
(53909, '1.10.150.910-FF-000018', NULL, 'Putative CPSF-domain protein', 170, NULL, NULL, 53909),
(53910, '1.10.1780.10-FF-000011', NULL, 'Heat shock protein 101', 153, NULL, NULL, 53910),
(53911, '3.40.50.300-FF-007679', NULL, 'Uncharacterized protein', 114, NULL, NULL, 53911),
(53912, '3.30.499.10-FF-000008', NULL, 'Aconitate hydratase B', 183, NULL, NULL, 53912),
(53913, '3.10.450.580-FF-000002', NULL, 'Mediator of RNA polymerase II transcription subunit 6', 130, NULL, NULL, 53913),
(53914, '3.40.50.1440-FF-000140', NULL, 'Uncharacterized protein', 56, NULL, NULL, 53914),
(53915, '2.130.10.10-FF-005392', NULL, 'Uncharacterized protein', 151, NULL, NULL, 53915),
(53916, '1.10.840.10-FF-000034', NULL, 'Uncharacterized protein', 298, NULL, NULL, 53916),
(53917, '3.40.50.10190-FF-000358', NULL, 'Uncharacterized protein', 68, NULL, NULL, 53917),
(53918, '1.25.40.20-FF-000149', NULL, '26S proteasome non-ATPase regulatory subunit 10 isoform X1', 225, NULL, NULL, 53918),
(53919, '3.30.160.60-FF-002491', NULL, 'Zinc finger protein 217', 23, NULL, NULL, 53919),
(53920, '2.60.40.10-FF-003626', NULL, NULL, 98, NULL, NULL, 53920),
(53921, '3.90.550.10-FF-000121', NULL, 'Probable molybdenum cofactor guanylyltransferase', 193, NULL, NULL, 53921),
(53922, '3.30.70.330-FF-003007', NULL, NULL, 136, NULL, NULL, 53922),
(53923, '3.30.310.10-FF-000004', NULL, 'AP-2 complex subunit alpha', 113, NULL, NULL, 53923),
(53924, '1.25.40.10-FF-000500', NULL, 'Tetratricopeptide repeat domain 21A', 108, NULL, NULL, 53924),
(53925, '3.30.450.50-FF-000032', NULL, 'AGAP000700-PA', 122, NULL, NULL, 53925),
(53926, '1.25.10.10-FF-002218', NULL, 'Protein purity of essence-like Protein', 409, NULL, NULL, 53926),
(53927, '1.10.510.10-FF-002055', NULL, 'Protein kinase', 311, NULL, NULL, 53927),
(53928, '3.90.70.10-FF-000443', NULL, 'Uncharacterized protein', 141, NULL, NULL, 53928),
(53929, '2.130.10.10-FF-001805', NULL, 'Putative dynein', 181, NULL, NULL, 53929),
(53930, '3.20.20.140-FF-000183', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 312, NULL, NULL, 53930),
(53931, '2.70.160.11-FF-000078', NULL, 'Protein arginine N-methyltransferase', 131, NULL, NULL, 53931),
(53932, '3.40.50.1000-FF-000340', NULL, 'RNA polymerase II ctd phosphatase, putative', 224, NULL, NULL, 53932),
(53933, '2.10.25.10-FF-000457', NULL, 'Sushi, nidogen and EGF like domains 1', 41, NULL, NULL, 53933),
(53934, '1.10.1200.270-FF-000033', NULL, 'S-adenosyl-L-methionine-dependent methyltransferases superfamily protein', 78, NULL, NULL, 53934),
(53935, '2.40.20.10-FF-000017', NULL, 'Prothrombin', 156, NULL, NULL, 53935),
(53936, '3.30.1360.70-FF-000024', NULL, NULL, 129, NULL, NULL, 53936),
(53937, '3.30.505.10-FF-000243', NULL, NULL, 65, NULL, NULL, 53937),
(53938, '3.40.50.2000-FF-000893', NULL, 'Putative transferase', 175, NULL, NULL, 53938),
(53939, '2.60.40.10-FF-005425', NULL, NULL, 14, NULL, NULL, 53939),
(53940, '3.30.40.10-FF-001742', NULL, 'Lipase', 99, NULL, NULL, 53940),
(53941, '1.20.1560.10-FF-000649', NULL, 'Protein CBG14016', 134, NULL, NULL, 53941),
(53942, '2.60.490.10-FF-000019', NULL, 'Uncharacterized protein', 114, NULL, NULL, 53942),
(53943, '1.20.1070.10-FF-001180', NULL, 'Melatonin receptor type 1B', 335, NULL, NULL, 53943);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(53944, '3.30.70.330-FF-001208', NULL, 'Polyadenylate-binding protein', 52, NULL, NULL, 53944),
(53945, '1.25.10.10-FF-000420', NULL, 'Sister chromatid cohesion protein PDS5 isogeny B', 187, NULL, NULL, 53945),
(53946, '1.25.50.20-FF-000077', NULL, 'Aminopeptidase', 210, NULL, NULL, 53946),
(53947, '2.130.10.10-FF-002710', NULL, 'WD40-repeat-containing domain protein', 316, NULL, NULL, 53947),
(53948, '3.40.710.10-FF-000167', NULL, 'Peptidoglycan glycosyltransferase', 418, NULL, NULL, 53948),
(53949, '3.40.50.1000-FF-000137', NULL, 'Hydrolase family protein / HAD-superfamily protein', 168, NULL, NULL, 53949),
(53950, '1.10.10.790-FF-000020', NULL, 'RNA splicing factor', 58, NULL, NULL, 53950),
(53951, '3.30.160.60-FF-005638', NULL, NULL, 26, NULL, NULL, 53951),
(53952, '1.20.5.2950-FF-000008', NULL, NULL, 112, NULL, NULL, 53952),
(53953, '3.40.50.2020-FF-000123', NULL, 'Adenine phosphoribosyltransferase', 180, NULL, NULL, 53953),
(53954, '1.10.1740.170-FF-000001', NULL, 'Erythrocyte binding antigen', 84, NULL, NULL, 53954),
(53955, '3.20.20.70-FF-000860', NULL, NULL, 48, NULL, NULL, 53955),
(53956, '1.20.5.110-FF-000092', NULL, 'Transport protein SEC22', 84, NULL, NULL, 53956),
(53957, '1.20.1640.10-FF-000021', NULL, 'Cation efflux system protein CusA', 222, NULL, NULL, 53957),
(53958, '3.40.50.720-FF-001072', NULL, 'Hypothetical_protein_-_conserved', 233, NULL, NULL, 53958),
(53959, '1.10.10.10-FF-000700', NULL, 'DNA helicase', 89, NULL, NULL, 53959),
(53960, '3.30.160.60-FF-006234', NULL, NULL, 57, NULL, NULL, 53960),
(53961, '1.20.80.30-FF-000002', NULL, 'Pyruvate, phosphate dikinase', 95, NULL, NULL, 53961),
(53962, '2.60.40.10-FF-000046', NULL, 'Nuclear factor NF-kappa-B p105 subunit', 114, NULL, NULL, 53962),
(53963, '1.50.40.10-FF-000313', NULL, 'Mitochondrial carrier protein', 206, NULL, NULL, 53963),
(53964, '3.30.559.10-FF-000098', NULL, 'Nonribosomal peptide synthase SidC', 184, NULL, NULL, 53964),
(53965, '1.20.120.1080-FF-000091', NULL, 'RNA helicase, putative', 124, NULL, NULL, 53965),
(53966, '1.20.120.350-FF-000033', NULL, 'potassium voltage-gated channel subfamily A member 10', 172, NULL, NULL, 53966),
(53967, '4.10.1240.10-FF-000035', NULL, 'Glucagon receptor a', 92, NULL, NULL, 53967),
(53968, '3.60.20.40-FF-000006', NULL, 'Protein CBG05566', 199, NULL, NULL, 53968),
(53969, '3.40.720.10-FF-000207', NULL, 'Putative glycosylphosphatidylinositol anchor synthesis protein', 280, NULL, NULL, 53969),
(53970, '3.40.50.980-FF-000025', NULL, 'Amino acid adenylation', 166, NULL, NULL, 53970),
(53971, '1.25.10.10-FF-001954', NULL, 'Uncharacterized protein', 272, NULL, NULL, 53971),
(53972, '1.20.5.340-FF-000031', NULL, 'CDC42 binding protein kinase gamma', 73, NULL, NULL, 53972),
(53973, '1.20.1250.20-FF-001601', NULL, 'Battenin', 244, NULL, NULL, 53973),
(53974, '3.90.640.90-FF-000016', NULL, 'Uncharacterized protein', 126, NULL, NULL, 53974),
(53975, '3.40.50.300-FF-004026', NULL, 'DEAD box helicase, putative', 283, NULL, NULL, 53975),
(53976, '1.10.10.350-FF-000017', NULL, 'Glutamyl-tRNA synthetase, mitochondrial', 102, NULL, NULL, 53976),
(53977, '2.60.40.790-FF-000123', NULL, NULL, 129, NULL, NULL, 53977),
(53978, '2.60.40.1180-FF-000125', NULL, 'Alpha-galactosidase', 85, NULL, NULL, 53978),
(53979, '3.30.160.60-FF-000703', NULL, 'Uncharacterized protein', 29, NULL, NULL, 53979),
(53980, '3.60.20.30-FF-000003', NULL, 'N(4)-(Beta-N-acetylglucosaminyl)-L-asparaginase isoform X1', 138, NULL, NULL, 53980),
(53981, '2.60.40.10-FF-001783', NULL, 'Anosmin 1', 108, NULL, NULL, 53981),
(53982, '2.130.10.10-FF-006010', NULL, 'Uncharacterized protein', 230, NULL, NULL, 53982),
(53983, '2.120.10.80-FF-000202', NULL, 'Protein UNUSUAL FLORAL ORGANS', 304, NULL, NULL, 53983),
(53984, '3.40.50.1460-FF-000045', NULL, 'AGAP010829-PA', 237, NULL, NULL, 53984),
(53985, '1.20.1410.10-FF-000009', NULL, 'Sla2p', 225, NULL, NULL, 53985),
(53986, '1.25.40.10-FF-002400', NULL, 'Pentatricopeptide repeat (PPR) superfamily protein', 149, NULL, NULL, 53986),
(53987, '3.30.70.1230-FF-000260', NULL, 'Predicted protein', 155, NULL, NULL, 53987);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(53988, '3.10.50.40-FF-000134', NULL, 'Peptidylprolyl isomerase', 109, NULL, NULL, 53988),
(53989, '3.30.420.10-FF-000557', NULL, NULL, 58, NULL, NULL, 53989),
(53990, '3.60.21.10-FF-000056', NULL, 'Serine/threonine-protein phosphatase with EF-hands', 352, NULL, NULL, 53990),
(53991, '3.30.450.20-FF-000697', NULL, 'Energy taxis modulating methyl accepting sensory transducer', 125, NULL, NULL, 53991),
(53992, '3.30.70.1230-FF-000158', NULL, 'Uncharacterized protein', 221, NULL, NULL, 53992),
(53993, '1.25.40.20-FF-001695', NULL, 'Uncharacterized protein', 70, NULL, NULL, 53993),
(53994, '1.10.560.10-FF-000113', NULL, 'Chaperonin-containing TCP1 subunit 3', 62, NULL, NULL, 53994),
(53995, '3.30.70.3490-FF-000010', NULL, 'Oxysterol binding protein (Osh1)', 72, NULL, NULL, 53995),
(53996, '1.20.120.1750-FF-000004', NULL, 'RBR-type E3 ubiquitin transferase', 223, NULL, NULL, 53996),
(53997, '3.90.550.10-FF-000019', NULL, 'Undecaprenyl-phosphate 4-deoxy-4-formamido-L-arabinose transferase', 227, NULL, NULL, 53997),
(53998, '3.30.40.10-FF-001181', NULL, 'RING/FYVE/PHD zinc finger superfamily protein', 119, NULL, NULL, 53998),
(53999, '3.40.50.300-FF-007781', NULL, 'Uncharacterized protein', 53, NULL, NULL, 53999),
(54000, '2.60.40.10-FF-004340', NULL, NULL, 204, NULL, NULL, 54000),
(54001, '2.40.50.1070-FF-000007', NULL, '23S rRNA (Uracil-5-)-methyltransferase RumA', 155, NULL, NULL, 54001),
(54002, '3.40.1110.10-FF-000396', NULL, NULL, 99, NULL, NULL, 54002),
(54003, '3.40.50.150-FF-001659', NULL, NULL, 194, NULL, NULL, 54003),
(54004, '1.20.272.10-FF-000020', NULL, 'Putative replication factor C3', 97, NULL, NULL, 54004),
(54005, '1.25.10.10-FF-001645', NULL, 'Uncharacterized protein', 437, NULL, NULL, 54005),
(54006, '2.120.10.30-FF-000103', NULL, 'Sortilin-related receptor', 303, NULL, NULL, 54006),
(54007, '2.70.130.10-FF-000142', NULL, NULL, 80, NULL, NULL, 54007),
(54008, '2.40.50.1060-FF-000004', NULL, 'TWIST neighbor', 134, NULL, NULL, 54008),
(54009, '3.40.50.300-FF-000193', NULL, 'Probable Elongation factor 3', 221, NULL, NULL, 54009),
(54010, '1.25.40.10-FF-001692', NULL, 'Os07g0203900 protein', 190, NULL, NULL, 54010),
(54011, '3.10.20.90-FF-000405', NULL, 'PB1_domain_containing_protein', 95, NULL, NULL, 54011),
(54012, '3.40.50.2000-FF-000584', NULL, 'ADP-heptose--LPS heptosyltransferase', 157, NULL, NULL, 54012),
(54013, '1.10.8.60-FF-000490', NULL, 'Uncharacterized protein', 90, NULL, NULL, 54013),
(54014, '3.40.50.300-FF-005881', NULL, 'ATP-dependent DNA helicase DDX11 isoform X1', 152, NULL, NULL, 54014),
(54015, '3.30.572.10-FF-000022', NULL, 'Putative phage-related deoxyuridylate hydroxymethyltransferase', 280, NULL, NULL, 54015),
(54016, '3.40.50.200-FF-000045', NULL, 'Serine protease AprX', 300, NULL, NULL, 54016),
(54017, '3.40.50.720-FF-000919', NULL, 'Fatty acyl-CoA reductase', 337, NULL, NULL, 54017),
(54018, '3.40.250.10-FF-000249', NULL, 'Uncharacterized protein', 96, NULL, NULL, 54018),
(54019, '1.10.287.10-FF-000017', NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase', 39, NULL, NULL, 54019),
(54020, '3.80.10.10-FF-001272', NULL, 'TIR-NBS-LRR class disease resistance protein', 158, NULL, NULL, 54020),
(54021, '3.30.160.60-FF-000142', NULL, 'Putative zinc finger protein 143', 28, NULL, NULL, 54021),
(54022, '3.20.20.70-FF-000096', NULL, 'Thiamine-phosphate synthase', 212, NULL, NULL, 54022),
(54023, '1.25.10.10-FF-000009', NULL, 'Importin subunit alpha', 423, NULL, NULL, 54023),
(54024, '2.60.120.200-FF-000681', NULL, 'Papp-a2', 217, NULL, NULL, 54024),
(54025, '3.40.630.30-FF-000436', NULL, 'Acyl-CoA N-acyltransferase (NAT) superfamily protein', 97, NULL, NULL, 54025),
(54026, '1.20.120.1760-FF-000007', NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', 188, NULL, NULL, 54026),
(54027, '3.20.20.370-FF-000004', NULL, 'Related to Chitin deacetylase', 211, NULL, NULL, 54027),
(54028, '1.10.510.10-FF-000065', NULL, 'Non-specific serine/threonine protein kinase', 205, NULL, NULL, 54028),
(54029, '1.10.510.10-FF-001459', NULL, 'Ribosomal protein S6 kinase beta-2', 117, NULL, NULL, 54029);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(54030, '1.10.1000.11-FF-000010', NULL, 'ARF guanine-nucleotide exchange factor GNOM-like', 119, NULL, NULL, 54030),
(54031, '3.40.20.10-FF-000049', NULL, 'Vesicle coat component', 146, NULL, NULL, 54031),
(54032, '1.20.58.390-FF-000129', NULL, 'AcetylCholine Receptor', 74, NULL, NULL, 54032),
(54033, '3.30.1370.30-FF-000002', NULL, '30S ribosomal protein S8', 74, NULL, NULL, 54033),
(54034, '1.10.8.60-FF-000181', NULL, 'DnaA regulatory inactivator Hda', 65, NULL, NULL, 54034),
(54035, '3.20.20.360-FF-000001', NULL, 'Malate synthase', 406, NULL, NULL, 54035),
(54036, '1.20.1070.10-FF-000466', NULL, 'Urotensin 2 receptor 5', 292, NULL, NULL, 54036),
(54037, '3.20.20.60-FF-000093', NULL, 'Pyruvate kinase', 70, NULL, NULL, 54037),
(54038, '3.40.50.300-FF-005572', NULL, 'Uncharacterized protein', 291, NULL, NULL, 54038),
(54039, '3.30.40.10-FF-000719', NULL, 'Uncharacterized protein, isoform C', 109, NULL, NULL, 54039),
(54040, '3.30.450.20-FF-000388', NULL, 'Sensory transduction histidine kinase', 111, NULL, NULL, 54040),
(54041, '1.25.40.20-FF-000812', NULL, 'Uncharacterized protein', 74, NULL, NULL, 54041),
(54042, '1.10.238.10-FF-000005', NULL, 'Phosphoinositide phospholipase C', 86, NULL, NULL, 54042),
(54043, '3.40.50.620-FF-000878', NULL, 'Isoleucyl-tRNA synthetase 2, mitochondrial', 121, NULL, NULL, 54043),
(54044, '1.10.150.510-FF-000005', NULL, 'Receptor (G protein-coupled) activity-modifying protein 2', 96, NULL, NULL, 54044),
(54045, '3.30.160.60-FF-003576', NULL, 'Uncharacterized protein, isoform D', 37, NULL, NULL, 54045),
(54046, '3.40.50.300-FF-005779', NULL, 'DNA helicase', 99, NULL, NULL, 54046),
(54047, '2.30.29.30-FF-001353', NULL, 'Predicted protein', 134, NULL, NULL, 54047),
(54048, '2.60.40.200-FF-000020', NULL, 'Copper chaperone for superoxide dismutase', 48, NULL, NULL, 54048),
(54049, '3.80.10.10-FF-004509', NULL, 'Uncharacterized protein', 103, NULL, NULL, 54049),
(54050, '2.60.120.200-FF-000579', NULL, 'Uncharacterized protein', 169, NULL, NULL, 54050),
(54051, '2.60.120.290-FF-000224', NULL, 'Uncharacterized protein', 112, NULL, NULL, 54051),
(54052, '3.40.50.1820-FF-001013', NULL, 'Predicted protein', 215, NULL, NULL, 54052),
(54053, '3.20.20.80-FF-000099', NULL, 'Lactase-phlorizin hydrolase, putative', 502, NULL, NULL, 54053),
(54054, '3.30.160.60-FF-005728', NULL, NULL, 32, NULL, NULL, 54054),
(54055, '1.20.5.540-FF-000001', NULL, 'focal adhesion kinase 1 isoform X1', 38, NULL, NULL, 54055),
(54056, '2.30.30.140-FF-000192', NULL, 'Histone acetyltransferase', 145, NULL, NULL, 54056),
(54057, '2.60.40.3210-FF-000021', NULL, 'Novel protein with a zona pellucida-like domain', 113, NULL, NULL, 54057),
(54058, '1.20.5.190-FF-000160', NULL, NULL, 49, NULL, NULL, 54058),
(54059, '3.40.50.300-FF-002345', NULL, 'YNR029C-like protein', 225, NULL, NULL, 54059),
(54060, '3.30.40.10-FF-001079', NULL, 'Transcription factor', 104, NULL, NULL, 54060),
(54061, '3.40.720.10-FF-000095', NULL, 'GPI ethanolamine phosphate transferase 3', 319, NULL, NULL, 54061),
(54062, '3.50.50.60-FF-001279', NULL, 'Uncharacterized protein', 56, NULL, NULL, 54062),
(54063, '3.40.50.300-FF-007472', NULL, 'Uncharacterized protein', 239, NULL, NULL, 54063),
(54064, '1.20.1740.10-FF-000085', NULL, 'large neutral amino acids transporter small subunit 2', 343, NULL, NULL, 54064),
(54065, '3.30.200.20-FF-002011', NULL, 'Probable serine/threonine-protein kinase DDB_G0283065', 189, NULL, NULL, 54065),
(54066, '3.40.50.1400-FF-000044', NULL, 'Uncharacterized protein', 80, NULL, NULL, 54066),
(54067, '3.30.930.10-FF-000169', NULL, 'Phenylalanine--tRNA ligase beta subunit', 211, NULL, NULL, 54067),
(54068, '3.50.30.30-FF-000038', NULL, 'alpha-1,2-Mannosidase', 152, NULL, NULL, 54068),
(54069, '3.30.565.10-FF-000117', NULL, 'Two-component system sensor histidine kinase DcuS', 141, NULL, NULL, 54069),
(54070, '3.30.160.60-FF-005419', NULL, NULL, 38, NULL, NULL, 54070),
(54071, '3.40.850.10-FF-000099', NULL, 'Myosin E, putative', 335, NULL, NULL, 54071),
(54072, '3.30.420.40-FF-000201', NULL, 'Actin-related protein 8', 46, NULL, NULL, 54072);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(54073, '1.10.565.10-FF-000208', NULL, 'Uncharacterized protein', 147, NULL, NULL, 54073),
(54074, '3.90.1600.10-FF-000040', NULL, 'DNA-directed DNA polymerase', 44, NULL, NULL, 54074),
(54075, '3.30.559.30-FF-000070', NULL, 'Nonribosomal peptide synthase nlsA', 244, NULL, NULL, 54075),
(54076, '1.10.287.70-FF-000664', NULL, 'Predicted protein', 121, NULL, NULL, 54076),
(54077, '3.80.10.10-FF-004408', NULL, 'Uncharacterized protein', 83, NULL, NULL, 54077),
(54078, '1.25.40.10-FF-003608', NULL, 'Transcriptional activator domain', 126, NULL, NULL, 54078),
(54079, '2.30.30.140-FF-000293', NULL, 'Uncharacterized protein', 80, NULL, NULL, 54079),
(54080, '3.40.50.2300-FF-000893', NULL, NULL, 135, NULL, NULL, 54080),
(54081, '1.10.510.10-FF-001566', NULL, 'Protein_kinase_-_putative', 98, NULL, NULL, 54081),
(54082, '3.30.40.10-FF-000927', NULL, 'E3 ubiquitin-protein ligase RING1-like isoform A', 88, NULL, NULL, 54082),
(54083, '3.30.70.330-FF-001517', NULL, NULL, 107, NULL, NULL, 54083),
(54084, '1.20.810.10-FF-000024', NULL, 'Predicted protein', 114, NULL, NULL, 54084),
(54085, '3.20.20.140-FF-000289', NULL, 'Putative lactonase', 250, NULL, NULL, 54085),
(54086, '2.60.60.20-FF-000039', NULL, 'Lipoxygenase', 149, NULL, NULL, 54086),
(54087, '1.20.5.110-FF-000299', NULL, 'Uncharacterized protein', 108, NULL, NULL, 54087),
(54088, '3.40.50.12240-FF-000001', NULL, 'V-type proton ATPase subunit B, brain', 457, NULL, NULL, 54088),
(54089, '3.30.70.330-FF-003125', NULL, NULL, 117, NULL, NULL, 54089),
(54090, '2.20.70.10-FF-000100', NULL, 'Pre-mRNA-processing protein 40A isoform A', 44, NULL, NULL, 54090),
(54091, '3.10.450.10-FF-000018', NULL, 'Secreted phosphoprotein 2', 104, NULL, NULL, 54091),
(54092, '3.40.50.12650-FF-000034', NULL, 'Uncharacterized protein', 145, NULL, NULL, 54092),
(54093, '2.30.30.40-FF-000230', NULL, 'Uncharacterized protein, isoform C', 69, NULL, NULL, 54093),
(54094, '1.20.1280.50-FF-000027', NULL, 'F-box only protein 39', 41, NULL, NULL, 54094),
(54095, '3.90.1580.10-FF-000009', NULL, 'Gliding motility lipoprotein GldJ', 281, NULL, NULL, 54095),
(54096, '1.20.1260.10-FF-000065', NULL, 'Ferritin', 116, NULL, NULL, 54096),
(54097, '3.40.1190.20-FF-000157', NULL, 'Ketohexokinase', 292, NULL, NULL, 54097),
(54098, '3.30.420.10-FF-000451', NULL, NULL, 176, NULL, NULL, 54098),
(54099, '1.20.920.10-FF-000162', NULL, 'Histone-lysine N-methyltransferase ash1', 118, NULL, NULL, 54099),
(54100, '1.25.10.10-FF-001971', NULL, 'Serine/threonine-protein kinase TOR', 189, NULL, NULL, 54100),
(54101, '1.20.1070.10-FF-000893', NULL, 'Predicted protein', 210, NULL, NULL, 54101),
(54102, '3.40.50.300-FF-008421', NULL, 'Uncharacterized protein', 119, NULL, NULL, 54102),
(54103, '3.30.160.60-FF-002182', NULL, 'Zinc finger protein 319', 59, NULL, NULL, 54103),
(54104, '3.40.50.1000-FF-000121', NULL, 'Uncharacterized protein', 189, NULL, NULL, 54104),
(54105, '1.20.1600.10-FF-000035', NULL, 'Efflux pump, RND family, outer membrane protein', 405, NULL, NULL, 54105),
(54106, '1.10.10.10-FF-000240', NULL, 'Global nitrogen regulator NtcA', 94, NULL, NULL, 54106),
(54107, '2.30.29.30-FF-000948', NULL, 'BEACH domain-containing protein lvsA', 118, NULL, NULL, 54107),
(54108, '1.10.8.10-FF-000183', NULL, 'Probable peptidyl-tRNA hydrolase 2', 79, NULL, NULL, 54108),
(54109, '2.60.40.10-FF-005835', NULL, NULL, 110, NULL, NULL, 54109),
(54110, '1.20.58.1150-FF-000002', NULL, NULL, 94, NULL, NULL, 54110),
(54111, '2.170.150.80-FF-000022', NULL, 'ANAC084', 142, NULL, NULL, 54111),
(54112, '3.40.630.30-FF-000189', NULL, 'Probable ribosomal-protein-alanine acetyltransferase rimI', 149, NULL, NULL, 54112),
(54113, '3.40.50.261-FF-000024', NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta', 152, NULL, NULL, 54113),
(54114, '3.60.21.10-FF-000281', NULL, 'Acid phosphatase 5a, tartrate-resistant', 172, NULL, NULL, 54114),
(54115, '1.10.530.10-FF-000038', NULL, 'Soluble lytic murein transglycosylase', 172, NULL, NULL, 54115),
(54116, '3.40.50.140-FF-000004', NULL, 'DNA topoisomerase 3', 156, NULL, NULL, 54116);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(54117, '1.25.10.10-FF-001864', NULL, 'AGAP000374-PA', 170, NULL, NULL, 54117),
(54118, '3.80.10.10-FF-001064', NULL, 'Protein singed wings 2', 202, NULL, NULL, 54118),
(54119, '3.30.160.60-FF-002075', NULL, 'zinc finger protein 646', 32, NULL, NULL, 54119),
(54120, '1.10.3080.10-FF-000036', NULL, 'Chloride channel protein', 435, NULL, NULL, 54120),
(54121, '3.80.10.10-FF-000991', NULL, 'DnaJ family protein', 195, NULL, NULL, 54121),
(54122, '2.60.40.10-FF-005296', NULL, NULL, 82, NULL, NULL, 54122),
(54123, '2.102.10.10-FF-000065', NULL, 'Rieske (2Fe-2S) domain protein', 102, NULL, NULL, 54123),
(54124, '2.60.40.150-FF-000622', NULL, 'Uncharacterized protein', 145, NULL, NULL, 54124),
(54125, '1.20.58.60-FF-000729', NULL, 'Alpha-actinin A', 105, NULL, NULL, 54125),
(54126, '1.20.5.390-FF-000012', NULL, NULL, 74, NULL, NULL, 54126),
(54127, '2.10.25.10-FF-001171', NULL, 'Uncharacterized protein', 53, NULL, NULL, 54127),
(54128, '3.90.480.20-FF-000011', NULL, 'Ferredoxin-nitrite reductase', 103, NULL, NULL, 54128),
(54129, '1.20.5.1430-FF-000007', NULL, 'Protein BIM1', 97, NULL, NULL, 54129),
(54130, '1.25.40.10-FF-005065', NULL, 'Uncharacterized protein', 101, NULL, NULL, 54130),
(54131, '1.10.620.20-FF-000020', NULL, 'Ribonucleoside-diphosphate reductase small chain', 330, NULL, NULL, 54131),
(54132, '2.60.40.790-FF-000016', NULL, 'Very-long-chain (3R)-3-hydroxyacyl-CoA dehydratase', 104, NULL, NULL, 54132),
(54133, '2.80.10.50-FF-000050', NULL, 'Fascin', 121, NULL, NULL, 54133),
(54134, '3.30.230.80-FF-000024', NULL, 'Heat shock protein HSP 90-alpha', 92, NULL, NULL, 54134),
(54135, '2.70.150.10-FF-000008', NULL, 'Calcium-transporting ATPase', 158, NULL, NULL, 54135),
(54136, '3.40.1500.20-FF-000002', NULL, 'Phytochromobilin:ferredoxin oxidoreductase, chloroplast / phytochromobilin synthase (HY2)', 240, NULL, NULL, 54136),
(54137, '3.30.70.330-FF-000798', NULL, 'Heterogeneous nuclear ribonucleoprotein A0', 94, NULL, NULL, 54137),
(54138, '3.80.10.10-FF-002789', NULL, 'Leucine Rich Repeat family protein', 293, NULL, NULL, 54138),
(54139, '2.60.40.1180-FF-000108', NULL, 'Alpha-galactosidase AgaA', 97, NULL, NULL, 54139),
(54140, '3.20.20.70-FF-000450', NULL, '3-dehydroquinate dehydratase', 198, NULL, NULL, 54140),
(54141, '2.60.200.30-FF-000038', NULL, 'NAD kinase', 133, NULL, NULL, 54141),
(54142, '3.40.33.10-FF-000045', NULL, 'GLIPR1-like protein 1', 196, NULL, NULL, 54142),
(54143, '3.40.50.720-FF-001162', NULL, 'Polyketide synthase RzxD', 456, NULL, NULL, 54143),
(54144, '3.40.50.300-FF-004043', NULL, 'Probable non-intrinsic ABC protein 5', 167, NULL, NULL, 54144),
(54145, '2.40.20.10-FF-000091', NULL, 'Hepatocyte growth factor', 74, NULL, NULL, 54145),
(54146, '3.40.50.720-FF-002483', NULL, 'Uncharacterized protein', 189, NULL, NULL, 54146),
(54147, '3.30.230.70-FF-000021', NULL, 'Exosome complex exonuclease RRP46 homolog', 239, NULL, NULL, 54147),
(54148, '3.30.160.60-FF-001676', NULL, 'Zinc finger protein 668', 27, NULL, NULL, 54148),
(54149, '3.30.1440.10-FF-000007', NULL, 'Uncharacterized protein', 37, NULL, NULL, 54149),
(54150, '1.10.287.70-FF-000771', NULL, 'Uncharacterized protein', 132, NULL, NULL, 54150),
(54151, '1.20.58.390-FF-000236', NULL, 'Uncharacterized protein', 140, NULL, NULL, 54151),
(54152, '2.60.40.1170-FF-000105', NULL, NULL, 124, NULL, NULL, 54152),
(54153, '3.30.40.10-FF-001326', NULL, 'Related to postreplication repair protein uvsH/nuvA', 98, NULL, NULL, 54153),
(54154, '3.20.20.80-FF-000453', NULL, 'YALI0F13299p', 109, NULL, NULL, 54154),
(54155, '3.30.70.1720-FF-000002', NULL, 'Calmodulin-sensitive adenylate cyclase', 135, NULL, NULL, 54155),
(54156, '2.40.20.10-FF-000102', NULL, 'Uncharacterized protein', 133, NULL, NULL, 54156),
(54157, '2.60.40.1510-FF-000022', NULL, 'Integrin beta', 110, NULL, NULL, 54157),
(54158, '3.30.160.60-FF-005947', NULL, NULL, 62, NULL, NULL, 54158),
(54159, '3.40.50.300-FF-002109', NULL, 'ABC transporter B family member 2', 177, NULL, NULL, 54159),
(54160, '1.10.287.110-FF-000412', NULL, 'Predicted protein', 132, NULL, NULL, 54160);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(54161, '1.10.20.10-FF-000212', NULL, NULL, 148, NULL, NULL, 54161),
(54162, '2.70.150.10-FF-000115', NULL, 'Phospholipid-transporting ATPase, putative', 135, NULL, NULL, 54162),
(54163, '3.40.50.2020-FF-000005', NULL, 'Ribose-phosphate pyrophosphokinase 1', 144, NULL, NULL, 54163),
(54164, '3.40.1170.60-FF-000055', NULL, NULL, 53, NULL, NULL, 54164),
(54165, '2.40.160.120-FF-000045', NULL, 'Uncharacterized protein', 175, NULL, NULL, 54165),
(54166, '3.40.50.2030-FF-000008', NULL, 'Hybrid cluster protein lateral transfer candidate', 157, NULL, NULL, 54166),
(54167, '3.40.50.300-FF-005347', NULL, 'endoribonuclease Dicer', 238, NULL, NULL, 54167),
(54168, '1.20.1070.10-FF-000691', NULL, 'Predicted vertebrate-like dopamine D1-like G-protein coupled receptor', 314, NULL, NULL, 54168),
(54169, '2.60.200.20-FF-000035', NULL, 'Protein phosphatase 2C 70', 135, NULL, NULL, 54169),
(54170, '1.10.8.140-FF-000024', NULL, 'Uncharacterized protein', 59, NULL, NULL, 54170),
(54171, '1.25.40.20-FF-000711', NULL, 'Poly [ADP-ribose] polymerase', 389, NULL, NULL, 54171),
(54172, '3.30.450.50-FF-000048', NULL, 'Vesicle-trafficking protein SEC22b', 127, NULL, NULL, 54172),
(54173, '3.40.50.300-FF-004352', NULL, 'ABC transporter ATP-binding protein', 235, NULL, NULL, 54173),
(54174, '3.30.830.10-FF-000032', NULL, 'Mitochondrial processing peptidase, alpha subunit', 226, NULL, NULL, 54174),
(54175, '1.25.10.10-FF-001185', NULL, 'HEAT repeat-containing 1', 151, NULL, NULL, 54175),
(54176, '3.30.505.10-FF-000142', NULL, NULL, 96, NULL, NULL, 54176),
(54177, '3.40.50.1110-FF-000064', NULL, 'Acetylxylan esterase', 217, NULL, NULL, 54177),
(54178, '3.40.1810.10-FF-000062', NULL, NULL, 82, NULL, NULL, 54178),
(54179, '3.30.160.60-FF-001895', NULL, 'Zinc finger protein 559', 25, NULL, NULL, 54179),
(54180, '3.40.50.300-FF-002800', NULL, 'Dynein heavy chain family protein', 128, NULL, NULL, 54180),
(54181, '1.20.1250.20-FF-001281', NULL, 'Predicted protein', 472, NULL, NULL, 54181),
(54182, '2.90.10.10-FF-000054', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase LECRK3', 129, NULL, NULL, 54182),
(54183, '1.10.3210.10-FF-000053', NULL, 'Exopolyphosphatase', 145, NULL, NULL, 54183),
(54184, '2.30.130.10-FF-000005', NULL, 'Ribosomal RNA large subunit methyltransferase I', 72, NULL, NULL, 54184),
(54185, '2.130.10.10-FF-002401', NULL, 'Uncharacterized protein', 171, NULL, NULL, 54185),
(54186, '1.10.510.10-FF-001892', NULL, 'Guanylate cyclase', 296, NULL, NULL, 54186),
(54187, '3.30.70.330-FF-000213', NULL, 'Uncharacterized protein, isoform R', 96, NULL, NULL, 54187),
(54188, '3.30.200.20-FF-002112', NULL, 'Uncharacterized protein', 78, NULL, NULL, 54188),
(54189, '3.40.50.1100-FF-000061', NULL, 'Cysteine synthase', 165, NULL, NULL, 54189),
(54190, '1.25.40.10-FF-001810', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 231, NULL, NULL, 54190),
(54191, '2.60.40.3500-FF-000001', NULL, 'N-acetylmuramoyl-L-alanine amidase', 122, NULL, NULL, 54191),
(54192, '2.30.29.30-FF-001252', NULL, 'Vacuolar protein-sorting-associated protein 36', 108, NULL, NULL, 54192),
(54193, '3.50.30.30-FF-000139', NULL, 'Uncharacterized protein', 142, NULL, NULL, 54193),
(54194, '3.40.1110.10-FF-000290', NULL, NULL, 67, NULL, NULL, 54194),
(54195, '3.20.20.190-FF-000057', NULL, 'Phosphoinositide phospholipase C', 253, NULL, NULL, 54195),
(54196, '1.10.510.10-FF-000150', NULL, 'Protein kinase C, theta', 202, NULL, NULL, 54196),
(54197, '1.10.510.10-FF-004000', NULL, NULL, 187, NULL, NULL, 54197),
(54198, '3.40.50.300-FF-002328', NULL, 'Helicase-like protein', 206, NULL, NULL, 54198),
(54199, '1.10.287.600-FF-000008', NULL, 'Tubulin beta chain', 70, NULL, NULL, 54199),
(54200, '1.10.10.480-FF-000005', NULL, 'Probable ATP-dependent 6-phosphofructokinase', 85, NULL, NULL, 54200),
(54201, '3.30.160.60-FF-005745', NULL, NULL, 90, NULL, NULL, 54201),
(54202, '2.30.30.770-FF-000009', NULL, NULL, 139, NULL, NULL, 54202),
(54203, '1.10.238.10-FF-000701', NULL, 'Defective in cullin neddylation protein', 54, NULL, NULL, 54203);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(54204, '3.40.1360.10-FF-000010', NULL, 'DNA primase DnaG', 101, NULL, NULL, 54204),
(54205, '3.30.160.20-FF-000186', NULL, '39S ribosomal protein L44, mitochondrial', 84, NULL, NULL, 54205),
(54206, '3.30.40.10-FF-001107', NULL, 'Histone-lysine N-methyltransferase', 48, NULL, NULL, 54206),
(54207, '3.40.50.1400-FF-000027', NULL, 'Ferrochelatase', 51, NULL, NULL, 54207),
(54208, '3.10.50.40-FF-000117', NULL, 'Peptidylprolyl isomerase', 124, NULL, NULL, 54208),
(54209, '2.60.40.4380-FF-000001', NULL, 'Translational regulator CsrA', 60, NULL, NULL, 54209),
(54210, '1.50.40.10-FF-000436', NULL, 'Uncharacterized protein', 167, NULL, NULL, 54210),
(54211, '3.40.50.720-FF-001381', NULL, 'Epimerase', 176, NULL, NULL, 54211),
(54212, '1.25.40.20-FF-000060', NULL, 'E3 ubiquitin-protein ligase MIB1 isoform X3', 133, NULL, NULL, 54212),
(54213, '2.40.30.10-FF-000400', NULL, 'NADPH--cytochrome p450 reductase, putative', 87, NULL, NULL, 54213),
(54214, '1.10.390.10-FF-000066', NULL, 'cDNA FLJ56120, highly similar to Aminopeptidase N', 114, NULL, NULL, 54214),
(54215, '2.60.40.1180-FF-000215', NULL, 'Predicted protein', 116, NULL, NULL, 54215),
(54216, '3.90.1410.10-FF-000121', NULL, 'Uncharacterized protein', 161, NULL, NULL, 54216),
(54217, '3.40.50.2300-FF-000786', NULL, 'Ribose ABC transporter, periplasmic ribose-binding protein', 168, NULL, NULL, 54217),
(54218, '3.20.20.80-FF-000762', NULL, 'Klotho beta', 325, NULL, NULL, 54218),
(54219, '2.130.10.10-FF-004172', NULL, 'Uncharacterized protein', 167, NULL, NULL, 54219),
(54220, '3.40.1190.10-FF-000047', NULL, NULL, 292, NULL, NULL, 54220),
(54221, '1.25.40.10-FF-003827', NULL, 'Uncharacterized protein', 128, NULL, NULL, 54221),
(54222, '3.40.50.1000-FF-000800', NULL, NULL, 225, NULL, NULL, 54222),
(54223, '3.10.20.90-FF-000158', NULL, 'Polyubiquitin 5', 76, NULL, NULL, 54223),
(54224, '2.130.10.10-FF-001912', NULL, 'Putative_intraflagellar_transport_protein_D4', 260, NULL, NULL, 54224),
(54225, '2.30.29.30-FF-000639', NULL, 'SH2B adaptor protein 3', 139, NULL, NULL, 54225),
(54226, '2.20.25.10-FF-000041', NULL, 'DNA-directed RNA polymerase 2 subunit', 48, NULL, NULL, 54226),
(54227, '1.25.10.10-FF-001494', NULL, 'Vacuolar protein 14 C-terminal Fig4p binding-domain-containing protein', 210, NULL, NULL, 54227),
(54228, '3.90.1410.10-FF-000031', NULL, 'Chromosome 1, whole genome shotgun sequence', 272, NULL, NULL, 54228),
(54229, '3.40.930.10-FF-000032', NULL, 'Phosphotransferase system fructose-specific transporter subunit EI/HPr/EIIA', 132, NULL, NULL, 54229),
(54230, '2.120.10.30-FF-000204', NULL, 'Uncharacterized protein', 128, NULL, NULL, 54230),
(54231, '2.130.10.10-FF-005274', NULL, 'WD repeat-containing protein 16-like Protein', 248, NULL, NULL, 54231),
(54232, '1.10.533.10-FF-000101', NULL, 'Receptor-interacting serine/threonine kinase 1', 105, NULL, NULL, 54232),
(54233, '1.10.1420.10-FF-000113', NULL, 'DNA mismatch repair protein MutS 1', 123, NULL, NULL, 54233),
(54234, '2.60.470.10-FF-000018', NULL, 'Pickpocket 21, isoform B', 185, NULL, NULL, 54234),
(54235, '1.10.238.10-FF-000229', NULL, 'Calcineurin B subunit isoform 1', 177, NULL, NULL, 54235),
(54236, '3.40.50.300-FF-005673', NULL, 'Uncharacterized protein', 191, NULL, NULL, 54236),
(54237, '3.10.10.20-FF-000002', NULL, 'Telomerase reverse transcriptase', 67, NULL, NULL, 54237),
(54238, '2.30.29.30-FF-000729', NULL, 'Uncharacterized protein', 104, NULL, NULL, 54238),
(54239, '2.10.70.10-FF-000073', NULL, 'Sushi repeat-containing protein SRPX2', 60, NULL, NULL, 54239),
(54240, '1.10.30.10-FF-000128', NULL, 'High mobility group protein', 70, NULL, NULL, 54240),
(54241, '2.130.10.10-FF-005953', NULL, 'Uncharacterized protein', 248, NULL, NULL, 54241),
(54242, '2.60.40.10-FF-002423', NULL, 'Protein-tyrosine-phosphatase', 106, NULL, NULL, 54242),
(54243, '1.10.8.60-FF-000265', NULL, '26S protease regulatory subunit 6B isoform X1', 27, NULL, NULL, 54243),
(54244, '3.10.20.90-FF-000630', NULL, 'Uncharacterized protein', 82, NULL, NULL, 54244),
(54245, '3.40.30.10-FF-000550', NULL, 'Glutathione S-transferase theta-2-like', 82, NULL, NULL, 54245);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(54246, '2.60.40.1730-FF-000009', NULL, 'Aminopeptidase', 208, NULL, NULL, 54246),
(54247, '3.30.160.60-FF-006111', NULL, NULL, 50, NULL, NULL, 54247),
(54248, '2.130.10.10-FF-001098', NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', 360, NULL, NULL, 54248),
(54249, '1.10.10.10-FF-001656', NULL, 'Uncharacterized protein', 72, NULL, NULL, 54249),
(54250, '3.20.20.80-FF-000672', NULL, 'Mannan endo-1,4-beta-mannosidase', 352, NULL, NULL, 54250),
(54251, '1.25.10.10-FF-000083', NULL, 'Serine/threonine-protein kinase TOR', 207, NULL, NULL, 54251),
(54252, '2.60.40.1820-FF-000008', NULL, 'Late embryogenesis abundant (LEA) hydroxyproline-rich glycoprotein family', 148, NULL, NULL, 54252),
(54253, '1.10.238.200-FF-000020', NULL, 'Defective in cullin neddylation protein', 105, NULL, NULL, 54253),
(54254, '2.60.40.10-FF-001934', NULL, 'Uncharacterized protein', 125, NULL, NULL, 54254),
(54255, '3.10.260.10-FF-000004', NULL, 'Transcription factor MBP1', 134, NULL, NULL, 54255),
(54256, '3.30.200.20-FF-001746', NULL, 'Serine/threonine-protein kinase greatwall', 21, NULL, NULL, 54256),
(54257, '2.130.10.10-FF-005583', NULL, 'WD repeat protein, putative', 205, NULL, NULL, 54257),
(54258, '3.40.50.300-FF-005982', NULL, 'Uncharacterized protein', 142, NULL, NULL, 54258),
(54259, '3.40.50.620-FF-000654', NULL, 'Protein CBR-WARS-1', 53, NULL, NULL, 54259),
(54260, '1.10.10.60-FF-001087', NULL, NULL, 75, NULL, NULL, 54260),
(54261, '1.25.40.10-FF-004070', NULL, 'Putative Gamma-soluble NSF attachment protein (SNAP-gamma) (N-ethylmaleimide-sensitive factor attachment protein, gamma)', 160, NULL, NULL, 54261),
(54262, '2.60.40.10-FF-004205', NULL, NULL, 79, NULL, NULL, 54262),
(54263, '2.40.50.140-FF-001205', NULL, NULL, 91, NULL, NULL, 54263),
(54264, '1.10.287.130-FF-000188', NULL, 'Sensor protein atoS', 75, NULL, NULL, 54264),
(54265, '3.40.720.10-FF-000308', NULL, 'Uncharacterized protein', 215, NULL, NULL, 54265),
(54266, '1.10.630.10-FF-000097', NULL, 'Cytochrome P-450 19', 481, NULL, NULL, 54266),
(54267, '1.10.1200.10-FF-000125', NULL, 'Nonribosomal peptide synthase 2', 78, NULL, NULL, 54267),
(54268, '1.25.50.20-FF-000004', NULL, 'Aminopeptidase', 307, NULL, NULL, 54268),
(54269, '3.40.50.1100-FF-000151', NULL, 'Cysteine synthase', 108, NULL, NULL, 54269),
(54270, '3.30.60.30-FF-000232', NULL, 'Predicted protein', 51, NULL, NULL, 54270),
(54271, '1.10.472.80-FF-000036', NULL, 'TBC1 domain family member 17', 132, NULL, NULL, 54271),
(54272, '1.25.10.10-FF-001499', NULL, 'AP-2 complex subunit beta-like Protein', 151, NULL, NULL, 54272),
(54273, '3.30.70.330-FF-000489', NULL, 'RNA-binding protein 12B', 80, NULL, NULL, 54273),
(54274, '1.25.40.10-FF-005048', NULL, 'Os11g0680200 protein', 120, NULL, NULL, 54274),
(54275, '1.20.5.100-FF-000010', NULL, 'Cytochrome c1, putative', 42, NULL, NULL, 54275),
(54276, '1.10.565.10-FF-000074', NULL, 'Nuclear hormone receptor family member nhr-25', 193, NULL, NULL, 54276),
(54277, '1.10.287.110-FF-000047', NULL, 'Heat shock 40 kDa protein', 116, NULL, NULL, 54277),
(54278, '3.40.630.30-FF-000661', NULL, 'Uncharacterized protein', 216, NULL, NULL, 54278),
(54279, '3.40.50.300-FF-000530', NULL, 'ABC transporter G family member 6', 227, NULL, NULL, 54279),
(54280, '1.20.58.340-FF-000031', NULL, 'Chromosome 12, whole genome shotgun sequence', 183, NULL, NULL, 54280),
(54281, '1.10.418.10-FF-000103', NULL, 'Fimbrin', 113, NULL, NULL, 54281),
(54282, '2.40.70.10-FF-000144', NULL, 'Aspartic protease', 170, NULL, NULL, 54282),
(54283, '3.30.70.330-FF-001287', NULL, 'WGS project CABT00000000 data, contig 2.24', 123, NULL, NULL, 54283),
(54284, '3.30.40.10-FF-001309', NULL, 'Uncharacterized protein', 73, NULL, NULL, 54284),
(54285, '3.40.1340.10-FF-000008', NULL, 'RNA polymerase I subunit 1RPB5', 148, NULL, NULL, 54285),
(54286, '3.40.720.10-FF-000297', NULL, 'Uncharacterized protein', 243, NULL, NULL, 54286),
(54287, '3.30.450.40-FF-000017', NULL, 'HTH-type transcriptional repressor AllR', 179, NULL, NULL, 54287),
(54288, '3.40.250.10-FF-000250', NULL, 'Uncharacterized protein', 184, NULL, NULL, 54288);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(54289, '3.80.10.10-FF-000682', NULL, 'Protein kinase family protein with leucine-rich repeat domain', 141, NULL, NULL, 54289),
(54290, '3.30.1330.30-FF-000090', NULL, 'Peptide chain release factor subunit 1', 97, NULL, NULL, 54290),
(54291, '2.10.25.10-FF-000704', NULL, 'Os12g0614800 protein', 47, NULL, NULL, 54291),
(54292, '3.40.190.80-FF-000063', NULL, 'Sulfite Synthesis/biphosphate phosphatase', 126, NULL, NULL, 54292),
(54293, '2.40.50.140-FF-000103', NULL, 'protein RRP5 homolog', 85, NULL, NULL, 54293),
(54294, '3.40.390.10-FF-000299', NULL, NULL, 66, NULL, NULL, 54294),
(54295, '2.60.120.590-FF-000078', NULL, 'Uncharacterized protein', 213, NULL, NULL, 54295),
(54296, '3.40.50.10420-FF-000034', NULL, '5-formyltetrahydrofolate cyclo-ligase', 203, NULL, NULL, 54296),
(54297, '1.20.1110.10-FF-000037', NULL, 'Calcium-transporting ATPase, putative', 251, NULL, NULL, 54297),
(54298, '2.10.70.10-FF-000180', NULL, 'Furrowed, isoform B', 56, NULL, NULL, 54298),
(54299, '4.10.900.10-FF-000027', NULL, 'Novel protein similar to vertebrate cadherin family protein', 97, NULL, NULL, 54299),
(54300, '3.40.1170.60-FF-000038', NULL, NULL, 52, NULL, NULL, 54300),
(54301, '2.70.150.10-FF-000132', NULL, 'Phospholipid-transporting ATPase', 147, NULL, NULL, 54301),
(54302, '3.30.450.30-FF-000014', NULL, 'Profilin', 90, NULL, NULL, 54302),
(54303, '2.60.40.150-FF-000206', NULL, 'C2 calcium-dependent domain containing 2', 133, NULL, NULL, 54303),
(54304, '1.20.144.10-FF-000060', NULL, 'Phospholipid phosphatase 4', 178, NULL, NULL, 54304),
(54305, '3.30.200.20-FF-000004', NULL, 'Calcium-dependent protein kinase 1', 84, NULL, NULL, 54305),
(54306, '1.10.10.10-FF-000021', NULL, 'HTH-type transcriptional regulator CysB', 90, NULL, NULL, 54306),
(54307, '3.40.1110.10-FF-000295', NULL, NULL, 16, NULL, NULL, 54307),
(54308, '1.20.1070.10-FF-000674', NULL, 'Uncharacterized protein', 165, NULL, NULL, 54308),
(54309, '3.30.1360.120-FF-000006', NULL, 'Pyruvate dehydrogenase phosphatase regulatory subunit, mitochondrial', 185, NULL, NULL, 54309),
(54310, '3.60.21.10-FF-000320', NULL, 'Vacuolar protein sorting-associated protein 29', 184, NULL, NULL, 54310),
(54311, '3.40.50.1820-FF-000849', NULL, 'Serine protease', 296, NULL, NULL, 54311),
(54312, '3.40.50.360-FF-000087', NULL, 'Sulfite reductase [NADPH] flavoprotein alpha-component', 166, NULL, NULL, 54312),
(54313, '1.10.8.10-FF-000188', NULL, 'AGAP003615-PA', 48, NULL, NULL, 54313),
(54314, '2.60.120.620-FF-000132', NULL, '1-deoxypentalenic acid 11-beta-hydroxylase', 266, NULL, NULL, 54314),
(54315, '2.30.30.140-FF-000074', NULL, 'E3 ubiquitin-protein ligase UHRF2 isoform X1', 87, NULL, NULL, 54315),
(54316, '3.30.450.20-FF-000596', NULL, 'Sensor histidine kinase, PAS domain-containing', 124, NULL, NULL, 54316),
(54317, '3.30.70.1230-FF-000057', NULL, 'Guanylate cyclase', 230, NULL, NULL, 54317),
(54318, '1.10.510.10-FF-001583', NULL, 'Uncharacterized protein', 129, NULL, NULL, 54318),
(54319, '2.60.40.10-FF-004531', NULL, NULL, 94, NULL, NULL, 54319),
(54320, '1.10.10.10-FF-000245', NULL, 'forkhead box protein M1 isoform X2', 100, NULL, NULL, 54320),
(54321, '2.130.10.10-FF-004402', NULL, 'Actin-interacting protein 1-2', 55, NULL, NULL, 54321),
(54322, '3.30.70.330-FF-003086', NULL, NULL, 107, NULL, NULL, 54322),
(54323, '3.30.559.30-FF-000053', NULL, 'Nonribosomal peptide synthetase 13', 219, NULL, NULL, 54323),
(54324, '3.30.360.10-FF-000029', NULL, 'NAD-dependent dihydrogenase, Gfo/Idh/MocA family', 172, NULL, NULL, 54324),
(54325, '3.40.50.300-FF-007932', NULL, 'Uncharacterized protein', 173, NULL, NULL, 54325),
(54326, '3.40.140.10-FF-000022', NULL, 'Single-stranded DNA cytosine deaminase', 181, NULL, NULL, 54326),
(54327, '1.10.560.10-FF-000012', NULL, 'RuBisCO large subunit-binding protein subunit beta', 241, NULL, NULL, 54327),
(54328, '3.30.40.10-FF-001416', NULL, 'RING finger protein 113 homolog', 111, NULL, NULL, 54328),
(54329, '3.40.449.10-FF-000014', NULL, 'Phosphoenolpyruvate carboxykinase (ATP)', 157, NULL, NULL, 54329),
(54330, '1.10.510.10-FF-004191', NULL, NULL, 191, NULL, NULL, 54330); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(54331, '1.10.8.60-FF-000591', NULL, 'Uncharacterized protein', 97, NULL, NULL, 54331),
(54332, '1.10.700.10-FF-000001', NULL, NULL, 113, NULL, NULL, 54332),
(54333, '1.10.10.790-FF-000008', NULL, 'SURP and G-patch domain-containing protein 2', 62, NULL, NULL, 54333),
(54334, '2.10.25.10-FF-001401', NULL, 'Uncharacterized protein', 43, NULL, NULL, 54334),
(54335, '3.90.1580.10-FF-000026', NULL, 'Sulfatase-modifying factor 1-like Protein', 281, NULL, NULL, 54335),
(54336, '3.40.140.10-FF-000112', NULL, 'Mov34/MPN/PAD-1 metallopeptidase, putative', 294, NULL, NULL, 54336),
(54337, '1.20.1070.10-FF-000584', NULL, 'Predicted protein', 298, NULL, NULL, 54337),
(54338, '3.40.50.1820-FF-001215', NULL, 'Uncharacterized protein', 371, NULL, NULL, 54338),
(54339, '2.60.40.10-FF-003391', NULL, NULL, 102, NULL, NULL, 54339),
(54340, '3.30.420.610-FF-000006', NULL, 'tudor domain-containing protein 7 isoform X2', 79, NULL, NULL, 54340),
(54341, '1.10.510.10-FF-001931', NULL, 'Kinase, NEK-frag', 217, NULL, NULL, 54341),
(54342, '3.90.70.10-FF-000117', NULL, 'Probable papain cysteine protease', 268, NULL, NULL, 54342),
(54343, '3.40.50.150-FF-000810', NULL, 'Uncharacterized protein', 259, NULL, NULL, 54343),
(54344, '3.40.50.12550-FF-000004', NULL, 'Ubiquitin-activating enzyme', 201, NULL, NULL, 54344),
(54345, '3.40.50.12650-FF-000017', NULL, 'DNA cross-link repair 1C', 94, NULL, NULL, 54345),
(54346, '2.40.160.20-FF-000007', NULL, 'Outer membrane protein OmpA', 191, NULL, NULL, 54346),
(54347, '1.25.40.20-FF-000930', NULL, 'Uncharacterized protein', 181, NULL, NULL, 54347),
(54348, '1.20.810.10-FF-000029', NULL, 'Uncharacterized protein', 73, NULL, NULL, 54348),
(54349, '2.130.10.10-FF-000131', NULL, 'Kinesin family member 21A', 97, NULL, NULL, 54349),
(54350, '2.60.40.3510-FF-000004', NULL, 'Delta-like protein', 139, NULL, NULL, 54350),
(54351, '3.40.50.300-FF-008404', NULL, 'Uncharacterized protein', 171, NULL, NULL, 54351),
(54352, '1.20.1560.10-FF-000902', NULL, 'ABC transporter B family member 26 chloroplastic', 202, NULL, NULL, 54352),
(54353, '1.20.1600.10-FF-000018', NULL, 'Outer membrane efflux protein', 426, NULL, NULL, 54353),
(54354, '3.40.395.10-FF-000012', NULL, 'Deubiquitinase and deneddylase Dub2', 125, NULL, NULL, 54354),
(54355, '3.30.1120.10-FF-000051', NULL, 'Arylsulfatase A', 72, NULL, NULL, 54355),
(54356, '2.60.120.380-FF-000026', NULL, 'Calpain a', 174, NULL, NULL, 54356),
(54357, '2.170.150.80-FF-000005', NULL, 'NAC transcription factor 56', 158, NULL, NULL, 54357),
(54358, '3.90.660.10-FF-000039', NULL, 'Amine oxidase', 217, NULL, NULL, 54358),
(54359, '2.60.40.1120-FF-000012', NULL, 'probable carboxypeptidase X1 isoform X2', 80, NULL, NULL, 54359),
(54360, '1.20.120.790-FF-000018', NULL, 'Molecular chaperone/ Grp94/Hsp90', 158, NULL, NULL, 54360),
(54361, '3.40.50.300-FF-005763', NULL, 'Exodeoxyribonuclease V subunit beta', 119, NULL, NULL, 54361),
(54362, '3.40.50.880-FF-000012', NULL, 'CTP synthase', 266, NULL, NULL, 54362),
(54363, '2.60.40.200-FF-000019', NULL, 'Superoxide dismutase [Cu-Zn]', 150, NULL, NULL, 54363),
(54364, '3.40.50.150-FF-001558', NULL, NULL, 75, NULL, NULL, 54364),
(54365, '3.40.50.300-FF-005987', NULL, 'YALI0C00671p', 193, NULL, NULL, 54365),
(54366, '1.10.10.10-FF-001875', NULL, 'Uncharacterized protein', 53, NULL, NULL, 54366),
(54367, '3.30.200.20-FF-001730', NULL, 'Wee1 kinase', 110, NULL, NULL, 54367),
(54368, '1.20.1250.20-FF-000792', NULL, 'Synaptic vesicle amine transporter, putative', 172, NULL, NULL, 54368),
(54369, '2.60.40.10-FF-005279', NULL, NULL, 84, NULL, NULL, 54369),
(54370, '3.90.70.10-FF-000252', NULL, 'Ubiquitin carboxyl-terminal hydrolase domain containing protein', 308, NULL, NULL, 54370),
(54371, '2.130.10.10-FF-000024', NULL, 'Putative echinoderm microtubule-associated protein-like 6', 314, NULL, NULL, 54371),
(54372, '1.10.530.10-FF-000055', NULL, 'Uncharacterized protein', 133, NULL, NULL, 54372),
(54373, '3.40.50.300-FF-000327', NULL, 'ATP-binding cassette sub-family A member 3', 260, NULL, NULL, 54373),
(54374, '3.40.50.10190-FF-000156', NULL, 'Protein BREAST CANCER SUSCEPTIBILITY 1 homolog', 95, NULL, NULL, 54374);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(54375, '3.30.160.60-FF-002058', NULL, 'YML081W-like protein', 30, NULL, NULL, 54375),
(54376, '2.10.250.10-FF-000013', NULL, 'Calreticulin family protein', 91, NULL, NULL, 54376),
(54377, '1.10.472.80-FF-000159', NULL, NULL, 134, NULL, NULL, 54377),
(54378, '3.40.50.200-FF-000163', NULL, 'Uncharacterized protein', 157, NULL, NULL, 54378),
(54379, '1.10.510.10-FF-004224', NULL, NULL, 207, NULL, NULL, 54379),
(54380, '2.10.25.10-FF-000558', NULL, 'Neurogenic locus notch homolog protein 1', 42, NULL, NULL, 54380),
(54381, '3.40.1190.20-FF-000067', NULL, 'Ribokinase', 307, NULL, NULL, 54381),
(54382, '3.30.1390.30-FF-000003', NULL, 'Peptidoglycan D,D-transpeptidase MrdA', 76, NULL, NULL, 54382),
(54383, '3.10.20.90-FF-000175', NULL, 'UV excision repair protein Rad23', 76, NULL, NULL, 54383),
(54384, '3.10.180.10-FF-000020', NULL, '4-hydroxyphenylpyruvate dioxygenase', 184, NULL, NULL, 54384),
(54385, '1.10.287.70-FF-000754', NULL, 'Voltage-dependent T-type calcium channel subunit alpha', 71, NULL, NULL, 54385),
(54386, '3.30.40.10-FF-000837', NULL, 'E3 ubiquitin-protein ligase', 55, NULL, NULL, 54386),
(54387, '3.30.160.60-FF-004183', NULL, NULL, 28, NULL, NULL, 54387),
(54388, '2.20.25.530-FF-000014', NULL, 'Uncharacterized protein', 82, NULL, NULL, 54388),
(54389, '1.10.472.130-FF-000060', NULL, 'Dynein heavy chain 1, axonemal', 172, NULL, NULL, 54389),
(54390, '3.30.460.10-FF-000195', NULL, 'Ribosomal silencing factor RsfS', 110, NULL, NULL, 54390),
(54391, '2.60.40.60-FF-000027', NULL, 'Cadherin 2', 105, NULL, NULL, 54391),
(54392, '3.60.21.10-FF-000174', NULL, 'Serine/threonine-protein phosphatase', 478, NULL, NULL, 54392),
(54393, '2.60.40.10-FF-005498', NULL, NULL, 94, NULL, NULL, 54393),
(54394, '3.80.10.10-FF-000884', NULL, 'NACHT, LRR and PYD domains-containing protein 12', 264, NULL, NULL, 54394),
(54395, '2.40.40.10-FF-000007', NULL, 'Papaya barwin-like protein', 122, NULL, NULL, 54395),
(54396, '1.10.132.20-FF-000004', NULL, 'Ribosome-recycling factor', 86, NULL, NULL, 54396),
(54397, '1.10.418.20-FF-000016', NULL, 'Ubiquitin-like protease 4', 100, NULL, NULL, 54397),
(54398, '1.10.10.10-FF-001791', NULL, 'Transcription factor Dp-1', 60, NULL, NULL, 54398),
(54399, '3.30.70.330-FF-002962', NULL, NULL, 102, NULL, NULL, 54399),
(54400, '3.30.70.330-FF-001197', NULL, 'AGAP013051-PA', 81, NULL, NULL, 54400),
(54401, '1.10.287.3240-FF-000009', NULL, 'ATPase H+ transporting V1 subunit D', 67, NULL, NULL, 54401),
(54402, '3.40.50.410-FF-000361', NULL, 'Collagen, type VI, alpha 3', 55, NULL, NULL, 54402),
(54403, '1.20.1070.10-FF-001073', NULL, 'Trace amine-associated receptor 7h', 328, NULL, NULL, 54403),
(54404, '2.10.70.10-FF-000090', NULL, 'Complement component 4 binding protein beta', 53, NULL, NULL, 54404),
(54405, '1.10.275.10-FF-000001', NULL, 'Fumarate hydratase, mitochondrial', 136, NULL, NULL, 54405),
(54406, '1.10.10.10-FF-002038', NULL, 'Possible transcriptional regulator', 82, NULL, NULL, 54406),
(54407, '3.30.160.60-FF-004003', NULL, NULL, 35, NULL, NULL, 54407),
(54408, '3.40.605.10-FF-000035', NULL, 'Succinate-semialdehyde dehydrogenase', 189, NULL, NULL, 54408),
(54409, '1.20.140.10-FF-000068', NULL, 'Acyl-CoA dehydrogenase domain protein', 147, NULL, NULL, 54409),
(54410, '1.10.132.10-FF-000001', NULL, 'DNA topoisomerase I', 179, NULL, NULL, 54410),
(54411, '1.20.58.390-FF-000253', NULL, 'Uncharacterized protein', 108, NULL, NULL, 54411),
(54412, '3.90.230.10-FF-000001', NULL, 'Methionine aminopeptidase', 261, NULL, NULL, 54412),
(54413, '1.20.120.350-FF-000235', NULL, NULL, 141, NULL, NULL, 54413),
(54414, '1.10.555.10-FF-000129', NULL, 'Uncharacterized protein', 116, NULL, NULL, 54414),
(54415, '3.90.640.10-FF-000156', NULL, 'Actin-related protein 8', 103, NULL, NULL, 54415),
(54416, '3.80.10.10-FF-001373', NULL, 'GH20134p', 121, NULL, NULL, 54416),
(54417, '3.40.630.30-FF-000335', NULL, 'FI06426p', 160, NULL, NULL, 54417),
(54418, '1.10.150.50-FF-000049', NULL, 'phosphatidylinositol 3,4,5-trisphosphate 5-phosphatase 2', 61, NULL, NULL, 54418),
(54419, '3.30.70.100-FF-000184', NULL, NULL, 96, NULL, NULL, 54419);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(54420, '3.10.20.90-FF-000523', NULL, 'Predicted protein', 80, NULL, NULL, 54420),
(54421, '2.60.40.10-FF-005189', NULL, NULL, 92, NULL, NULL, 54421),
(54422, '3.80.10.10-FF-000575', NULL, 'Leucine rich repeat containing 41', 123, NULL, NULL, 54422),
(54423, '1.20.120.790-FF-000035', NULL, 'Uncharacterized protein', 69, NULL, NULL, 54423),
(54424, '1.20.58.60-FF-000864', NULL, 'Uncharacterized protein', 122, NULL, NULL, 54424),
(54425, '4.10.280.10-FF-000131', NULL, 'Basic helix-loop-helix protein', 65, NULL, NULL, 54425),
(54426, '3.30.1380.20-FF-000033', NULL, 'Trafficking protein particle complex subunit', 172, NULL, NULL, 54426),
(54427, '4.10.110.10-FF-000017', NULL, 'Predicted protein', 36, NULL, NULL, 54427),
(54428, '3.10.20.90-FF-000304', NULL, 'Rho GTPase activating protein at 15B, isoform B', 81, NULL, NULL, 54428),
(54429, '2.60.120.920-FF-000194', NULL, 'Uncharacterized protein', 43, NULL, NULL, 54429),
(54430, '1.10.287.70-FF-000445', NULL, 'Inositol 1,4,5-trisphosphate receptor type 3', 57, NULL, NULL, 54430),
(54431, '2.60.40.10-FF-004222', NULL, NULL, 70, NULL, NULL, 54431),
(54432, '3.30.160.60-FF-004312', NULL, 'IP15679p', 65, NULL, NULL, 54432),
(54433, '1.20.1070.10-FF-001382', NULL, 'Uncharacterized protein', 251, NULL, NULL, 54433),
(54434, '1.10.418.10-FF-000013', NULL, 'IQ motif containing GTPase activating protein 1', 164, NULL, NULL, 54434),
(54435, '2.30.30.1020-FF-000040', NULL, NULL, 141, NULL, NULL, 54435),
(54436, '3.30.40.10-FF-001635', NULL, 'Structure-specific endonuclease subunit SLX1', 83, NULL, NULL, 54436),
(54437, '3.40.1160.10-FF-000017', NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase', 298, NULL, NULL, 54437),
(54438, '1.25.40.10-FF-001703', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 98, NULL, NULL, 54438),
(54439, '1.50.40.10-FF-000329', NULL, 'Uncharacterized protein', 289, NULL, NULL, 54439),
(54440, '2.130.10.10-FF-003694', NULL, 'F-box/WD repeat-containing protein pof10', 91, NULL, NULL, 54440),
(54441, '3.10.450.10-FF-000013', NULL, 'Cysteine proteinase inhibitor', 90, NULL, NULL, 54441),
(54442, '1.10.1200.10-FF-000108', NULL, 'Non-ribosomal peptide synthetase', 88, NULL, NULL, 54442),
(54443, '3.30.70.330-FF-002130', NULL, NULL, 103, NULL, NULL, 54443),
(54444, '3.40.50.1110-FF-000047', NULL, 'GDSL family lipase', 197, NULL, NULL, 54444),
(54445, '1.10.510.10-FF-003729', NULL, NULL, 152, NULL, NULL, 54445),
(54446, '1.10.8.60-FF-000411', NULL, 'DNA polymerase epsilon subunit B', 71, NULL, NULL, 54446),
(54447, '3.20.20.190-FF-000164', NULL, NULL, 137, NULL, NULL, 54447),
(54448, '2.10.25.10-FF-000249', NULL, 'Integrin subunit beta like 1', 47, NULL, NULL, 54448),
(54449, '1.10.3210.10-FF-000070', NULL, 'HDIG domain protein', 171, NULL, NULL, 54449),
(54450, '4.10.365.10-FF-000007', NULL, 'Cyclin-dependent kinase inhibitor 2', 63, NULL, NULL, 54450),
(54451, '3.30.40.10-FF-001080', NULL, 'Anaphase-promoting_complex_subunit_11_RING-H2_finger/Zinc_finger', 65, NULL, NULL, 54451),
(54452, '3.30.30.30-FF-000056', NULL, 'Heat shock protein 70 putative', 57, NULL, NULL, 54452),
(54453, '3.40.50.300-FF-007590', NULL, 'Uncharacterized protein', 172, NULL, NULL, 54453),
(54454, '3.40.50.1100-FF-000044', NULL, 'Phenylserine dehydratase', 97, NULL, NULL, 54454),
(54455, '3.30.160.60-FF-000602', NULL, 'Teashirt zinc finger homeobox 2', 73, NULL, NULL, 54455),
(54456, '3.80.10.10-FF-000665', NULL, 'Geranylgeranyl transferase type-2 subunit alpha 1', 124, NULL, NULL, 54456),
(54457, '4.10.400.10-FF-000192', NULL, 'Low density lipoprotein receptor-related protein 1Bb', 46, NULL, NULL, 54457),
(54458, '3.30.160.60-FF-003946', NULL, NULL, 33, NULL, NULL, 54458),
(54459, '1.20.920.10-FF-000167', NULL, 'Uncharacterized protein', 111, NULL, NULL, 54459),
(54460, '3.30.420.10-FF-000456', NULL, 'DNA polymerase', 268, NULL, NULL, 54460),
(54461, '1.10.3280.10-FF-000001', NULL, 'Bifunctional dehydrogenase/ferrochelatase', 85, NULL, NULL, 54461),
(54462, '3.40.50.150-FF-000007', NULL, 'rRNA adenine N(6)-methyltransferase', 186, NULL, NULL, 54462);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(54463, '3.30.160.20-FF-000181', NULL, 'Uncharacterized protein', 65, NULL, NULL, 54463),
(54464, '2.40.10.480-FF-000012', NULL, 'Cell surface protein', 62, NULL, NULL, 54464),
(54465, '3.40.630.30-FF-000554', NULL, 'Acetyltransferase, GNAT family protein', 131, NULL, NULL, 54465),
(54466, '2.60.40.60-FF-000246', NULL, 'Cadherin 86C, isoform E', 108, NULL, NULL, 54466),
(54467, '1.25.40.10-FF-002501', NULL, 'Predicted protein', 98, NULL, NULL, 54467),
(54468, '1.10.10.10-FF-001549', NULL, 'GTPase-activating protein', 80, NULL, NULL, 54468),
(54469, '2.130.10.10-FF-000350', NULL, 'C-Jun-amino-terminal kinase-interacting protein 3 isoform X1', 201, NULL, NULL, 54469),
(54470, '2.60.40.10-FF-003727', NULL, NULL, 88, NULL, NULL, 54470),
(54471, '1.10.720.30-FF-000082', NULL, 'Predicted protein', 56, NULL, NULL, 54471),
(54472, '2.40.50.140-FF-001059', NULL, NULL, 101, NULL, NULL, 54472),
(54473, '3.30.559.10-FF-000199', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 91, NULL, NULL, 54473),
(54474, '1.10.8.60-FF-000063', NULL, 'Nuclear valosin-containing protein-like', 134, NULL, NULL, 54474),
(54475, '2.40.160.120-FF-000040', NULL, 'Oxysterol-binding protein 7', 193, NULL, NULL, 54475),
(54476, '2.40.10.120-FF-000016', NULL, 'Genome polyprotein', 198, NULL, NULL, 54476),
(54477, '3.80.10.10-FF-001154', NULL, 'Dma-1', 181, NULL, NULL, 54477),
(54478, '3.40.50.620-FF-000199', NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', 367, NULL, NULL, 54478),
(54479, '1.20.1270.60-FF-000193', NULL, 'YALI0F13673p', 234, NULL, NULL, 54479),
(54480, '3.40.50.300-FF-000204', NULL, 'Translation elongation factor Tu', 241, NULL, NULL, 54480),
(54481, '3.30.70.100-FF-000061', NULL, 'Photoactivated adenylate cyclase subunit beta-like protein 1224-5/1F', 135, NULL, NULL, 54481),
(54482, '3.30.160.60-FF-000260', NULL, 'Spalt-like transcription factor 1', 29, NULL, NULL, 54482),
(54483, '3.10.670.10-FF-000001', NULL, 'Dermonecrotic toxin', 186, NULL, NULL, 54483),
(54484, '1.10.8.60-FF-000372', NULL, 'AaceriAER065Cp', 66, NULL, NULL, 54484),
(54485, '3.30.1960.10-FF-000007', NULL, 'tRNA-yW synthesizing protein 3 homolog', 85, NULL, NULL, 54485),
(54486, '3.30.160.60-FF-001923', NULL, 'Zinc finger protein 236', 60, NULL, NULL, 54486),
(54487, '3.90.70.10-FF-000033', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 301, NULL, NULL, 54487),
(54488, '3.40.30.10-FF-000347', NULL, 'Sulfhydryl oxidase', 129, NULL, NULL, 54488),
(54489, '3.40.190.10-FF-000042', NULL, 'LysR family transcriptional regulator', 73, NULL, NULL, 54489),
(54490, '3.20.20.220-FF-000015', NULL, 'Methylenetetrahydrofolate reductase', 316, NULL, NULL, 54490),
(54491, '3.40.50.300-FF-003880', NULL, 'RAS like family 12', 114, NULL, NULL, 54491),
(54492, '1.25.50.10-FF-000001', NULL, 'Aminopeptidase N', 325, NULL, NULL, 54492),
(54493, '1.25.10.10-FF-000190', NULL, 'Ecm29 proteasome adaptor and scaffold', 246, NULL, NULL, 54493),
(54494, '3.10.250.10-FF-000054', NULL, 'Uncharacterized protein', 98, NULL, NULL, 54494),
(54495, '3.40.50.150-FF-001777', NULL, NULL, 195, NULL, NULL, 54495),
(54496, '3.30.300.10-FF-000037', NULL, 'Probable GMP synthase [glutamine-hydrolyzing]', 106, NULL, NULL, 54496),
(54497, '1.10.10.2450-FF-000001', NULL, 'Origin recognition complex subunit 1', 137, NULL, NULL, 54497),
(54498, '3.40.630.10-FF-000104', NULL, 'Silver, isoform N', 315, NULL, NULL, 54498),
(54499, '3.10.250.10-FF-000048', NULL, 'Uncharacterized protein', 99, NULL, NULL, 54499),
(54500, '1.25.40.20-FF-001667', NULL, 'RBR-type E3 ubiquitin transferase', 83, NULL, NULL, 54500),
(54501, '1.20.1070.10-FF-001163', NULL, 'Alpha-1A adrenergic receptor', 342, NULL, NULL, 54501),
(54502, '1.20.1560.10-FF-000666', NULL, 'Uncharacterized protein', 51, NULL, NULL, 54502),
(54503, '2.130.10.10-FF-003475', NULL, 'AGAP010035-PA', 316, NULL, NULL, 54503),
(54504, '1.20.5.110-FF-000119', NULL, '60S ribosomal protein L13', 44, NULL, NULL, 54504),
(54505, '3.30.505.10-FF-000226', NULL, NULL, 95, NULL, NULL, 54505),
(54506, '3.30.9.10-FF-000293', NULL, 'Uncharacterized protein', 111, NULL, NULL, 54506);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(54507, '1.25.40.10-FF-001664', NULL, 'Tetratricopeptide repeat protein 7A', 174, NULL, NULL, 54507),
(54508, '1.20.120.330-FF-000010', NULL, 'Dishevelled associated activator of morphogenesis 1', 101, NULL, NULL, 54508),
(54509, '3.30.830.10-FF-000122', NULL, 'Ubiquinol-cytochrome c reductase core protein 2a', 204, NULL, NULL, 54509),
(54510, '3.30.70.330-FF-001181', NULL, 'CBN-MEC-8 protein', 92, NULL, NULL, 54510),
(54511, '3.10.20.30-FF-000056', NULL, 'developmentally-regulated GTP-binding protein 2 isoform X2', 52, NULL, NULL, 54511),
(54512, '3.40.50.300-FF-003874', NULL, 'ATP-binding cassette protein subfamily H, member 2', 279, NULL, NULL, 54512),
(54513, '2.30.30.140-FF-000057', NULL, 'Histone-lysine N-methyltransferase NSD2', 142, NULL, NULL, 54513),
(54514, '2.10.25.10-FF-000474', NULL, 'Teneurin transmembrane protein 2', 37, NULL, NULL, 54514),
(54515, '3.30.160.60-FF-000821', NULL, 'Zinc finger protein 524', 30, NULL, NULL, 54515),
(54516, '2.40.420.20-FF-000045', NULL, 'Putative MacA', 65, NULL, NULL, 54516),
(54517, '2.40.50.100-FF-000024', NULL, 'Exosome complex component CSL4', 51, NULL, NULL, 54517),
(54518, '3.30.420.10-FF-000675', NULL, NULL, 170, NULL, NULL, 54518),
(54519, '2.10.70.10-FF-000106', NULL, 'Complement factor H related 5', 57, NULL, NULL, 54519),
(54520, '2.60.120.200-FF-000686', NULL, 'Uncharacterized protein', 207, NULL, NULL, 54520),
(54521, '1.20.120.340-FF-000013', NULL, 'Flagellar secretion chaperone FliS', 119, NULL, NULL, 54521),
(54522, '2.30.30.40-FF-000027', NULL, 'Disks large homolog 3 isoform 1', 102, NULL, NULL, 54522),
(54523, '3.40.50.150-FF-000338', NULL, 'Protein-L-isoaspartate (D-aspartate) O-methyltransferase domain containing 1', 99, NULL, NULL, 54523),
(54524, '3.40.710.10-FF-000162', NULL, 'Membrane transglycosylase and transpeptidase PBP1A', 396, NULL, NULL, 54524),
(54525, '3.30.160.60-FF-005599', NULL, NULL, 44, NULL, NULL, 54525),
(54526, '2.30.180.10-FF-000031', NULL, 'periostin isoform X1', 144, NULL, NULL, 54526),
(54527, '1.10.533.10-FF-000062', NULL, 'Fas-associated via death domain', 86, NULL, NULL, 54527),
(54528, '3.30.160.60-FF-006217', NULL, NULL, 21, NULL, NULL, 54528),
(54529, '3.40.50.920-FF-000030', NULL, 'Pyruvate dehydrogenase E1 component beta subunit', 133, NULL, NULL, 54529),
(54530, '3.30.1330.20-FF-000007', NULL, 'Cell division protein ftsZ, putative', 109, NULL, NULL, 54530),
(54531, '2.60.120.10-FF-000560', NULL, 'Uncharacterized protein', 149, NULL, NULL, 54531),
(54532, '3.40.50.300-FF-000221', NULL, 'Multidrug ABC transporter ATP-binding protein', 253, NULL, NULL, 54532),
(54533, '1.10.10.10-FF-001566', NULL, 'DsRNA activated Z-DNA binding protein kinase', 59, NULL, NULL, 54533),
(54534, '2.160.20.70-FF-000030', NULL, 'Tubulin binding cofactor C-domain-containing protein', 159, NULL, NULL, 54534),
(54535, '2.60.40.10-FF-004115', NULL, NULL, 92, NULL, NULL, 54535),
(54536, '2.40.420.20-FF-000051', NULL, 'Cation efflux system protein', 79, NULL, NULL, 54536),
(54537, '3.40.50.720-FF-000684', NULL, 'PROBABLE SHORT-CHAIN TYPE DEHYDROGENASE/REDUCTASE', 241, NULL, NULL, 54537),
(54538, '1.10.260.100-FF-000019', NULL, 'TPR Domain containing protein', 67, NULL, NULL, 54538),
(54539, '3.50.7.10-FF-000002', NULL, 'T-complex protein 1 subunit beta', 153, NULL, NULL, 54539),
(54540, '1.25.40.10-FF-003811', NULL, 'UTP6 small subunit processome component', 138, NULL, NULL, 54540),
(54541, '3.10.110.20-FF-000002', NULL, 'FA complementation group L', 35, NULL, NULL, 54541),
(54542, '3.30.70.980-FF-000054', NULL, 'YALI0E16214p', 80, NULL, NULL, 54542),
(54543, '3.30.310.270-FF-000003', NULL, 'Blast:Protein bicaudal C', 180, NULL, NULL, 54543),
(54544, '1.10.555.10-FF-000264', NULL, NULL, 80, NULL, NULL, 54544),
(54545, '1.20.120.350-FF-000016', NULL, 'Potassium voltage-gated channel subfamily D member 3', 150, NULL, NULL, 54545),
(54546, '3.40.720.10-FF-000078', NULL, 'GPI ethanolamine phosphate transferase 2 isoform X4', 179, NULL, NULL, 54546),
(54547, '1.10.510.10-FF-000172', NULL, 'serine/threonine-protein kinase Nek1 isoform X1', 201, NULL, NULL, 54547);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(54548, '3.30.310.10-FF-000009', NULL, 'TatA box-binding protein-like protein 1', 82, NULL, NULL, 54548),
(54549, '3.30.70.330-FF-001652', NULL, NULL, 130, NULL, NULL, 54549),
(54550, '1.25.10.10-FF-001729', NULL, 'Uncharacterized protein', 200, NULL, NULL, 54550),
(54551, '1.10.10.1340-FF-000005', NULL, 'Mediator of RNA polymerase II transcription subunit 31', 105, NULL, NULL, 54551),
(54552, '1.10.287.660-FF-000004', NULL, 'tail-anchored protein insertion receptor WRB', 77, NULL, NULL, 54552),
(54553, '3.30.160.60-FF-003469', NULL, 'Zinc finger protein', 58, NULL, NULL, 54553),
(54554, '1.10.230.10-FF-000021', NULL, 'Citrate synthase family protein', 88, NULL, NULL, 54554),
(54555, '1.10.405.10-FF-000017', NULL, 'Guanosine nucleotide diphosphate dissociation inhibitor', 59, NULL, NULL, 54555),
(54556, '2.30.29.30-FF-001117', NULL, 'Uncharacterized protein', 134, NULL, NULL, 54556),
(54557, '3.90.190.10-FF-000593', NULL, 'Predicted protein', 49, NULL, NULL, 54557),
(54558, '3.40.50.2300-FF-001590', NULL, NULL, 131, NULL, NULL, 54558),
(54559, '3.30.810.10-FF-000014', NULL, 'Phosphatidylinositol-4-phosphate 5-kinase', 186, NULL, NULL, 54559),
(54560, '1.10.287.370-FF-000024', NULL, 'Prefoldin_subunit', 128, NULL, NULL, 54560),
(54561, '3.40.1110.10-FF-000273', NULL, NULL, 136, NULL, NULL, 54561),
(54562, '3.60.21.10-FF-000191', NULL, '5`-nucleotidase, putative', 365, NULL, NULL, 54562),
(54563, '3.40.50.1820-FF-000743', NULL, 'Serine carboxypeptidase, putative', 117, NULL, NULL, 54563),
(54564, '1.25.40.10-FF-000028', NULL, 'beta-soluble NSF attachment protein-like isoform X1', 287, NULL, NULL, 54564),
(54565, '1.20.1110.10-FF-000262', NULL, NULL, 65, NULL, NULL, 54565),
(54566, '1.20.1250.20-FF-001264', NULL, 'Major facilitator superfamily protein', 369, NULL, NULL, 54566),
(54567, '3.30.230.10-FF-000296', NULL, 'DNA mismatch repair protein MutL', 116, NULL, NULL, 54567),
(54568, '3.40.470.10-FF-000007', NULL, 'Uracil-DNA glycosylase', 246, NULL, NULL, 54568),
(54569, '3.30.200.20-FF-001623', NULL, 'Putative cell division control protein 7-like protein 2', 97, NULL, NULL, 54569),
(54570, '2.120.10.30-FF-000120', NULL, 'Transmembrane serine/threonine-protein kinase D', 262, NULL, NULL, 54570),
(54571, '1.10.472.80-FF-000053', NULL, 'TBC domain-containing protein', 138, NULL, NULL, 54571),
(54572, '3.30.420.110-FF-000042', NULL, 'DNA mismatch repair protein MutS', 120, NULL, NULL, 54572),
(54573, '3.40.50.10470-FF-000026', NULL, 'Methylthioribose-1-phosphate isomerase', 191, NULL, NULL, 54573),
(54574, '3.90.1430.10-FF-000004', NULL, 'U5 small nuclear ribonuclear protein, putative', 104, NULL, NULL, 54574),
(54575, '3.40.50.300-FF-001637', NULL, 'replication factor C subunit 2 isoform X2', 78, NULL, NULL, 54575),
(54576, '1.10.287.70-FF-000529', NULL, 'cation channel sperm-associated protein 2-like', 159, NULL, NULL, 54576),
(54577, '3.90.1720.10-FF-000015', NULL, 'Probable cell wall hydrolase LytN', 157, NULL, NULL, 54577),
(54578, '3.80.10.10-FF-002935', NULL, 'Uncharacterized protein', 108, NULL, NULL, 54578),
(54579, '3.30.450.90-FF-000010', NULL, 'Competence protein CglA', 107, NULL, NULL, 54579),
(54580, '4.10.400.10-FF-000208', NULL, 'SCO-spondin', 43, NULL, NULL, 54580),
(54581, '4.10.60.10-FF-000112', NULL, 'Ribosomal protein L15', 68, NULL, NULL, 54581),
(54582, '1.20.140.10-FF-000085', NULL, 'Acyl-CoA dehydrogenase', 148, NULL, NULL, 54582),
(54583, '2.40.50.140-FF-000896', NULL, NULL, 92, NULL, NULL, 54583),
(54584, '1.10.1410.10-FF-000051', NULL, 'DNA2/NAM7 helicase family protein', 220, NULL, NULL, 54584),
(54585, '3.90.260.10-FF-000025', NULL, 'DNA repair protein complementing XP-C cells homolog', 183, NULL, NULL, 54585),
(54586, '1.25.10.10-FF-002134', NULL, 'Uncharacterized protein', 320, NULL, NULL, 54586),
(54587, '1.20.1070.10-FF-001056', NULL, 'Putative Class a rhodopsin g-protein coupled receptor gprop1', 184, NULL, NULL, 54587),
(54588, '2.60.300.12-FF-000008', NULL, 'iron-sulfur assembly protein IscA, chloroplastic', 109, NULL, NULL, 54588),
(54589, '1.50.40.10-FF-000330', NULL, 'Uncharacterized protein', 285, NULL, NULL, 54589);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(54590, '3.30.200.20-FF-000313', NULL, 'Leucine-rich repeat serine/threonine-protein kinase 2', 85, NULL, NULL, 54590),
(54591, '3.30.1310.10-FF-000003', NULL, 'Nucleoid-associated protein MRA_3753', 110, NULL, NULL, 54591),
(54592, '3.20.20.70-FF-000298', NULL, 'Delta-aminolevulinic acid dehydratase', 360, NULL, NULL, 54592),
(54593, '1.25.40.10-FF-001338', NULL, 'WGS project CABT00000000 data, contig 2.24', 171, NULL, NULL, 54593),
(54594, '2.30.29.30-FF-001230', NULL, 'PH and Rap-GAP domain-containing protein DDB_G0271806', 116, NULL, NULL, 54594),
(54595, '2.60.40.150-FF-000280', NULL, 'Phosphoinositide phospholipase C', 157, NULL, NULL, 54595),
(54596, '2.60.40.10-FF-003497', NULL, NULL, 115, NULL, NULL, 54596),
(54597, '2.60.40.10-FF-003508', NULL, NULL, 89, NULL, NULL, 54597),
(54598, '1.10.840.10-FF-000051', NULL, 'SH2 domain containing 3Ca', 104, NULL, NULL, 54598),
(54599, '3.40.50.2000-FF-000668', NULL, 'Glucuronosyltransferase', 212, NULL, NULL, 54599),
(54600, '1.25.40.10-FF-003266', NULL, 'AGR398Wp', 147, NULL, NULL, 54600),
(54601, '2.30.30.910-FF-000001', NULL, 'Basal-body rod modification protein FlgD', 44, NULL, NULL, 54601),
(54602, '1.10.510.10-FF-001476', NULL, 'Serine/threonine protein kinase, putative', 295, NULL, NULL, 54602),
(54603, '2.40.10.10-FF-000152', NULL, 'Plasminogen activator', 107, NULL, NULL, 54603),
(54604, '2.30.30.1020-FF-000039', NULL, NULL, 144, NULL, NULL, 54604),
(54605, '2.60.34.20-FF-000006', NULL, NULL, 167, NULL, NULL, 54605),
(54606, '2.10.69.10-FF-000002', NULL, NULL, 30, NULL, NULL, 54606),
(54607, '1.10.10.60-FF-000013', NULL, 'DNA-binding transcriptional activator MarA', 53, NULL, NULL, 54607),
(54608, '3.30.1360.120-FF-000023', NULL, 'Sarcosine dehydrogenase', 115, NULL, NULL, 54608),
(54609, '4.10.280.10-FF-000237', NULL, 'Id-1', 64, NULL, NULL, 54609),
(54610, '2.80.10.50-FF-000033', NULL, 'Fibroblast growth factor', 133, NULL, NULL, 54610),
(54611, '3.30.2130.10-FF-000023', NULL, 'Uncharacterized protein', 127, NULL, NULL, 54611),
(54612, '3.30.450.20-FF-000517', NULL, 'Slr0302 protein', 74, NULL, NULL, 54612),
(54613, '1.50.40.10-FF-000094', NULL, 'Phosphate carrier protein, mitochondrial', 106, NULL, NULL, 54613),
(54614, '2.130.10.10-FF-003677', NULL, 'Protein CBR-DAF-10', 264, NULL, NULL, 54614),
(54615, '3.90.550.50-FF-000110', NULL, 'GD22797', 130, NULL, NULL, 54615),
(54616, '3.40.50.11490-FF-000001', NULL, 'Chromo domain-containing protein 1', 153, NULL, NULL, 54616),
(54617, '1.20.1250.20-FF-000657', NULL, 'Sugar transporter, putative', 212, NULL, NULL, 54617),
(54618, '1.10.8.430-FF-000009', NULL, 'Disease resistance protein CHS1', 81, NULL, NULL, 54618),
(54619, '1.20.1070.10-FF-001415', NULL, 'Uncharacterized protein', 231, NULL, NULL, 54619),
(54620, '2.30.30.140-FF-000309', NULL, 'DNA mismatch repair protein', 119, NULL, NULL, 54620),
(54621, '2.10.220.10-FF-000101', NULL, 'Fraser extracellular matrix complex subunit 1', 91, NULL, NULL, 54621),
(54622, '3.50.50.60-FF-000936', NULL, 'Mercury(II) reductase', 122, NULL, NULL, 54622),
(54623, '3.60.20.40-FF-000001', NULL, 'Gamma-glutamyltranspeptidase 1', 195, NULL, NULL, 54623),
(54624, '1.10.10.60-FF-000120', NULL, 'pogo transposable element with ZNF domain isoform X1', 55, NULL, NULL, 54624),
(54625, '2.60.40.1130-FF-000009', NULL, 'Uncharacterized protein', 42, NULL, NULL, 54625),
(54626, '1.25.40.470-FF-000055', NULL, 'Uncharacterized protein', 209, NULL, NULL, 54626),
(54627, '3.90.79.20-FF-000011', NULL, 'NADH pyrophosphatase', 127, NULL, NULL, 54627),
(54628, '3.40.50.150-FF-000451', NULL, 'Probable methyltransferase PMT19', 162, NULL, NULL, 54628),
(54629, '3.30.2130.30-FF-000029', NULL, 'Probable tRNA sulfurtransferase', 177, NULL, NULL, 54629),
(54630, '1.25.10.10-FF-000425', NULL, 'RING-type E3 ubiquitin transferase', 96, NULL, NULL, 54630),
(54631, '3.30.70.330-FF-001961', NULL, NULL, 122, NULL, NULL, 54631),
(54632, '2.10.270.10-FF-000014', NULL, 'Dextransucrase', 84, NULL, NULL, 54632),
(54633, '3.40.50.150-FF-000142', NULL, 'Ubiquinone biosynthesis O-methyltransferase, mitochondrial', 238, NULL, NULL, 54633);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(54634, '1.20.1740.10-FF-000068', NULL, 'Branched-chain amino acid transport system carrier protein', 442, NULL, NULL, 54634),
(54635, '1.10.510.10-FF-000481', NULL, 'Asator, isoform D', 336, NULL, NULL, 54635),
(54636, '3.40.50.10490-FF-000139', NULL, NULL, 41, NULL, NULL, 54636),
(54637, '2.130.10.10-FF-003368', NULL, 'Uncharacterized protein', 306, NULL, NULL, 54637),
(54638, '3.90.420.10-FF-000010', NULL, 'DMSO/TMAO reductase YedYZ molybdopterin-dependent catalytic subunit', 223, NULL, NULL, 54638),
(54639, '2.40.50.140-FF-001284', NULL, NULL, 121, NULL, NULL, 54639),
(54640, '3.40.50.300-FF-002019', NULL, 'DNA helicase I', 229, NULL, NULL, 54640),
(54641, '1.25.10.10-FF-003438', NULL, 'Uncharacterized protein', 109, NULL, NULL, 54641),
(54642, '2.60.40.10-FF-002081', NULL, 'Titin homolog', 110, NULL, NULL, 54642),
(54643, '3.30.930.10-FF-000394', NULL, 'Predicted protein', 154, NULL, NULL, 54643),
(54644, '4.10.240.10-FF-000128', NULL, 'Uncharacterized protein', 66, NULL, NULL, 54644),
(54645, '2.60.40.1120-FF-000006', NULL, 'Carboxypeptidase D', 80, NULL, NULL, 54645),
(54646, '2.10.25.10-FF-000693', NULL, 'Delta-like protein', 45, NULL, NULL, 54646),
(54647, '1.10.20.10-FF-000302', NULL, NULL, 55, NULL, NULL, 54647),
(54648, '3.30.479.20-FF-000038', NULL, 'Elongation factor Ts, mitochondrial', 113, NULL, NULL, 54648),
(54649, '3.80.10.10-FF-003301', NULL, 'Si:ch73-236c18.2', 100, NULL, NULL, 54649),
(54650, '2.170.190.11-FF-000016', NULL, 'Molybdenum cofactor synthesis domain protein', 92, NULL, NULL, 54650),
(54651, '3.40.50.200-FF-000180', NULL, 'Hypothetical phage protein', 307, NULL, NULL, 54651),
(54652, '1.10.506.10-FF-000061', NULL, 'Plexin B3', 106, NULL, NULL, 54652),
(54653, '3.90.550.10-FF-000036', NULL, 'Dolichol-phosphate mannosyltransferase subunit 1', 237, NULL, NULL, 54653),
(54654, '3.90.550.20-FF-000039', NULL, 'Predicted protein', 67, NULL, NULL, 54654),
(54655, '1.20.5.990-FF-000006', NULL, 'Centrosomal protein of 55 kDa', 94, NULL, NULL, 54655),
(54656, '3.40.50.2300-FF-000876', NULL, NULL, 79, NULL, NULL, 54656),
(54657, '1.10.565.10-FF-000091', NULL, 'Retinoid x receptor', 235, NULL, NULL, 54657),
(54658, '2.30.110.10-FF-000083', NULL, 'Flavin reductase domain protein FMN-binding', 165, NULL, NULL, 54658),
(54659, '3.90.1290.10-FF-000015', NULL, 'dystonin isoform X7', 201, NULL, NULL, 54659),
(54660, '2.130.10.10-FF-005931', NULL, 'TKL family protein kinase', 266, NULL, NULL, 54660),
(54661, '2.30.30.490-FF-000049', NULL, 'Origin recognition complex subunit 1', 229, NULL, NULL, 54661),
(54662, '3.30.9.10-FF-000074', NULL, 'FAD dependent oxidoreductase, putative', 175, NULL, NULL, 54662),
(54663, '1.25.40.10-FF-001809', NULL, 'Pentatricopeptide repeat-containing protein At2g29760, chloroplastic', 102, NULL, NULL, 54663),
(54664, '1.20.272.10-FF-000003', NULL, 'DNA polymerase III subunit gamma/tau', 120, NULL, NULL, 54664),
(54665, '1.25.40.120-FF-000057', NULL, 'Uncharacterized protein', 228, NULL, NULL, 54665),
(54666, '2.40.50.140-FF-001194', NULL, NULL, 106, NULL, NULL, 54666),
(54667, '3.30.70.100-FF-000167', NULL, NULL, 71, NULL, NULL, 54667),
(54668, '2.40.30.180-FF-000010', NULL, 'Ubiquitin-activating enzyme E1', 82, NULL, NULL, 54668),
(54669, '3.30.160.60-FF-000057', NULL, 'Zinc finger with KRAB and SCAN domains 4', 28, NULL, NULL, 54669),
(54670, '1.10.510.10-FF-000711', NULL, 'Probable cyclin-dependent kinase 1', 208, NULL, NULL, 54670),
(54671, '2.130.10.10-FF-005622', NULL, 'Protein kinase, putative', 183, NULL, NULL, 54671),
(54672, '3.40.630.30-FF-000419', NULL, 'Uncharacterized protein', 176, NULL, NULL, 54672),
(54673, '1.20.5.650-FF-000017', NULL, NULL, 74, NULL, NULL, 54673),
(54674, '3.20.20.70-FF-000079', NULL, 'GMP reductase', 327, NULL, NULL, 54674),
(54675, '3.60.10.10-FF-000177', NULL, 'inositol polyphosphate 5-phosphatase K isoform X2', 171, NULL, NULL, 54675),
(54676, '4.10.280.110-FF-000024', NULL, NULL, 81, NULL, NULL, 54676),
(54677, '3.20.20.60-FF-000076', NULL, 'HpcH/HpaI aldolase/citrate lyase family protein', 260, NULL, NULL, 54677);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(54678, '1.50.10.10-FF-000137', NULL, 'ADL225Wp', 515, NULL, NULL, 54678),
(54679, '2.10.25.10-FF-000783', NULL, 'Laminin subunit alpha-3', 50, NULL, NULL, 54679),
(54680, '1.10.10.10-FF-001347', NULL, 'Cullin_family /Cullin_protein_neddylation_domain_containing_protein_-_putative', 77, NULL, NULL, 54680),
(54681, '1.20.58.60-FF-000639', NULL, 'Uncharacterized protein', 286, NULL, NULL, 54681),
(54682, '3.40.50.10420-FF-000017', NULL, '5-formyltetrahydrofolate cyclo-ligase', 178, NULL, NULL, 54682),
(54683, '3.80.10.10-FF-001047', NULL, 'Hypothetical_protein_-_conserved', 128, NULL, NULL, 54683),
(54684, '1.20.1270.420-FF-000004', NULL, 'Inhibitor of kappa light polypeptide gene enhancer in B-cells, kinase epsilon', 242, NULL, NULL, 54684),
(54685, '3.40.20.10-FF-000066', NULL, 'Secretory 24AB, isoform A', 139, NULL, NULL, 54685),
(54686, '3.30.1380.20-FF-000050', NULL, 'Predicted protein', 106, NULL, NULL, 54686),
(54687, '2.40.128.20-FF-000017', NULL, 'OsWRKY4 family protein', 183, NULL, NULL, 54687),
(54688, '1.25.40.10-FF-001557', NULL, 'Pentatricopeptide repeat-containing protein', 131, NULL, NULL, 54688),
(54689, '2.60.40.1870-FF-000001', NULL, 'Interleukin-7 receptor subunit alpha', 93, NULL, NULL, 54689),
(54690, '1.10.510.10-FF-003836', NULL, NULL, 108, NULL, NULL, 54690),
(54691, '2.170.300.10-FF-000093', NULL, 'Netrin, putative', 68, NULL, NULL, 54691),
(54692, '3.40.50.11530-FF-000013', NULL, 'Si:ch211-207e14.4', 158, NULL, NULL, 54692),
(54693, '3.80.10.10-FF-004392', NULL, 'Uncharacterized protein', 165, NULL, NULL, 54693),
(54694, '2.60.40.10-FF-005857', NULL, NULL, 96, NULL, NULL, 54694),
(54695, '3.30.1330.30-FF-000117', NULL, 'Uncharacterized protein', 69, NULL, NULL, 54695),
(54696, '3.40.50.800-FF-000045', NULL, 'Threonine--tRNA ligase', 104, NULL, NULL, 54696),
(54697, '3.40.1110.10-FF-000306', NULL, 'Calcium-transporting ATPase, endoplasmic reticulum-type', 258, NULL, NULL, 54697),
(54698, '3.90.190.10-FF-000374', NULL, 'Protein-tyrosine phosphatase', 166, NULL, NULL, 54698),
(54699, '3.40.50.1110-FF-000154', NULL, 'GDSL esterase/lipase CPRD49', 60, NULL, NULL, 54699),
(54700, '2.60.40.420-FF-000086', NULL, 'Multicopper oxidase abr1', 180, NULL, NULL, 54700),
(54701, '2.130.10.10-FF-005257', NULL, 'WD repeat-containing protein 6', 271, NULL, NULL, 54701),
(54702, '1.10.132.30-FF-000029', NULL, 'Uncharacterized protein', 48, NULL, NULL, 54702),
(54703, '1.10.238.10-FF-000140', NULL, 'follistatin-related protein 5 isoform X2', 112, NULL, NULL, 54703),
(54704, '2.60.40.10-FF-000153', NULL, 'Probable E3 ubiquitin-protein ligase MID2', 98, NULL, NULL, 54704),
(54705, '1.10.510.10-FF-002190', NULL, 'Cyclin dependent kinase 16', 170, NULL, NULL, 54705),
(54706, '2.40.10.10-FF-000371', NULL, NULL, 117, NULL, NULL, 54706),
(54707, '3.30.870.10-FF-000006', NULL, 'CDP-diacylglycerol--serine O-phosphatidyltransferase', 220, NULL, NULL, 54707),
(54708, '1.25.70.10-FF-000002', NULL, 'transcription termination factor 3, mitochondrial', 270, NULL, NULL, 54708),
(54709, '3.40.50.300-FF-001856', NULL, 'RAS small monomeric GTPase, putative', 204, NULL, NULL, 54709),
(54710, '1.10.510.10-FF-000149', NULL, 'phosphorylase b kinase gamma catalytic chain, liver/testis isoform', 191, NULL, NULL, 54710),
(54711, '3.30.56.30-FF-000008', NULL, 'SRP19_protein_-_putative', 140, NULL, NULL, 54711),
(54712, '2.60.40.10-FF-004424', NULL, NULL, 93, NULL, NULL, 54712),
(54713, '1.10.510.10-FF-004202', NULL, NULL, 220, NULL, NULL, 54713),
(54714, '3.80.10.10-FF-001300', NULL, 'Uncharacterized protein', 174, NULL, NULL, 54714),
(54715, '3.40.50.2300-FF-001281', NULL, NULL, 167, NULL, NULL, 54715),
(54716, '1.10.510.10-FF-003584', NULL, NULL, 211, NULL, NULL, 54716),
(54717, '2.60.120.10-FF-000251', NULL, 'cGMP-dependent protein kinase 1-3', 131, NULL, NULL, 54717),
(54718, '3.40.50.10140-FF-000057', NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', 169, NULL, NULL, 54718),
(54719, '2.60.120.920-FF-000115', NULL, 'Si:ch211-207e19.2', 159, NULL, NULL, 54719),
(54720, '1.10.10.2330-FF-000016', NULL, NULL, 59, NULL, NULL, 54720);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(54721, '2.130.10.10-FF-002603', NULL, 'Uncharacterized protein', 345, NULL, NULL, 54721),
(54722, '3.40.50.300-FF-005656', NULL, 'Putative DNA adenine methyltransferase and helicase, darB', 208, NULL, NULL, 54722),
(54723, '3.40.50.300-FF-004262', NULL, 'AGAP013180-PA', 241, NULL, NULL, 54723),
(54724, '3.30.160.60-FF-002311', NULL, 'zinc finger protein 236 isoform X4', 26, NULL, NULL, 54724),
(54725, '2.130.10.10-FF-001985', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit trm82', 111, NULL, NULL, 54725),
(54726, '3.10.105.10-FF-000015', NULL, 'ABC transporter, substrate-binding protein, family 5', 157, NULL, NULL, 54726),
(54727, '3.30.160.60-FF-001693', NULL, 'zinc finger and SCAN domain-containing protein 26 isoform X1', 30, NULL, NULL, 54727),
(54728, '1.10.4200.10-FF-000007', NULL, '2''-(5''''-triphosphoribosyl)-3''-dephospho-coenzyme A synthase', 132, NULL, NULL, 54728),
(54729, '3.40.50.1760-FF-000028', NULL, NULL, 47, NULL, NULL, 54729),
(54730, '2.60.120.40-FF-000012', NULL, 'Adipolin isoform X1', 150, NULL, NULL, 54730),
(54731, '2.60.120.290-FF-000095', NULL, 'LEV-10A protein', 126, NULL, NULL, 54731),
(54732, '3.30.160.60-FF-005964', NULL, NULL, 78, NULL, NULL, 54732),
(54733, '1.10.287.70-FF-000299', NULL, 'Uncharacterized protein', 154, NULL, NULL, 54733),
(54734, '3.40.630.20-FF-000001', NULL, 'Pyrrolidone-carboxylate peptidase', 215, NULL, NULL, 54734),
(54735, '3.30.160.60-FF-005493', NULL, NULL, 89, NULL, NULL, 54735),
(54736, '1.10.238.200-FF-000003', NULL, 'DCN1-like protein 3', 110, NULL, NULL, 54736),
(54737, '1.10.1580.10-FF-000029', NULL, 'Guanine nucleotide-binding protein-like 3-like protein', 93, NULL, NULL, 54737),
(54738, '1.10.1670.40-FF-000017', NULL, 'DNA-3-methyladenine glycosidase II, putative', 42, NULL, NULL, 54738),
(54739, '3.10.100.10-FF-000026', NULL, 'C-type mannose receptor 2', 136, NULL, NULL, 54739),
(54740, '2.60.40.1730-FF-000083', NULL, NULL, 92, NULL, NULL, 54740),
(54741, '4.10.280.50-FF-000002', NULL, 'Glutamate decarboxylase', 65, NULL, NULL, 54741),
(54742, '3.30.200.20-FF-001729', NULL, 'Uncharacterized protein', 110, NULL, NULL, 54742),
(54743, '3.30.505.10-FF-000120', NULL, 'Tyrosine-protein kinase Fyn', 105, NULL, NULL, 54743),
(54744, '2.40.50.140-FF-000210', NULL, 'Ribosomal protein S12 methylthiotransferase RimO', 64, NULL, NULL, 54744),
(54745, '1.10.150.50-FF-000184', NULL, 'Uncharacterized protein', 73, NULL, NULL, 54745),
(54746, '1.10.238.210-FF-000006', NULL, 'Putative glutaminase 2', 90, NULL, NULL, 54746),
(54747, '2.70.98.30-FF-000038', NULL, 'Uncharacterized protein', 205, NULL, NULL, 54747),
(54748, '1.25.10.10-FF-003219', NULL, 'Predicted protein', 269, NULL, NULL, 54748),
(54749, '2.130.10.10-FF-005728', NULL, 'Uncharacterized protein', 135, NULL, NULL, 54749),
(54750, '2.30.29.30-FF-001336', NULL, 'Uncharacterized protein', 48, NULL, NULL, 54750),
(54751, '3.40.120.10-FF-000111', NULL, 'Probable phosphoribomutase', 130, NULL, NULL, 54751),
(54752, '3.90.550.10-FF-000345', NULL, 'Predicted protein', 254, NULL, NULL, 54752),
(54753, '1.20.1270.60-FF-000299', NULL, 'Uncharacterized protein', 135, NULL, NULL, 54753),
(54754, '1.25.40.10-FF-003575', NULL, 'U6 snRNP complex subunit', 185, NULL, NULL, 54754),
(54755, '2.30.30.220-FF-000002', NULL, 'ClpXP protease specificity-enhancing factor', 119, NULL, NULL, 54755),
(54756, '2.10.220.10-FF-000174', NULL, 'Uncharacterized protein', 79, NULL, NULL, 54756),
(54757, '1.10.510.10-FF-002403', NULL, NULL, 210, NULL, NULL, 54757),
(54758, '2.30.30.140-FF-000276', NULL, 'Uncharacterized protein', 98, NULL, NULL, 54758),
(54759, '1.20.5.110-FF-000338', NULL, 'Uncharacterized protein', 56, NULL, NULL, 54759),
(54760, '1.20.1560.10-FF-000447', NULL, 'AAA protein', 312, NULL, NULL, 54760),
(54761, '1.10.510.10-FF-001785', NULL, 'Protein CBG00525', 292, NULL, NULL, 54761),
(54762, '3.30.460.10-FF-000088', NULL, 'Protein HESO1', 123, NULL, NULL, 54762),
(54763, '2.130.10.10-FF-001570', NULL, 'Transducin family protein / WD-40 repeat family protein', 193, NULL, NULL, 54763);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(54764, '3.40.50.300-FF-006061', NULL, 'Uncharacterized protein', 195, NULL, NULL, 54764),
(54765, '2.60.40.2240-FF-000011', NULL, 'Acyl-CoA thioesterase 4', 53, NULL, NULL, 54765),
(54766, '1.10.1450.10-FF-000025', NULL, 'Tetraspanin', 104, NULL, NULL, 54766),
(54767, '1.25.40.10-FF-003917', NULL, 'Coatomer subunit epsilon', 297, NULL, NULL, 54767),
(54768, '3.40.50.410-FF-000254', NULL, 'ANTXR cell adhesion molecule 1d', 54, NULL, NULL, 54768),
(54769, '3.30.160.60-FF-004110', NULL, NULL, 29, NULL, NULL, 54769),
(54770, '3.60.110.10-FF-000095', NULL, NULL, 324, NULL, NULL, 54770),
(54771, '2.60.40.1480-FF-000007', NULL, 'Coatomer subunit gamma', 161, NULL, NULL, 54771),
(54772, '1.10.1740.10-FF-000036', NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', 83, NULL, NULL, 54772),
(54773, '1.10.10.60-FF-000119', NULL, 'Transcription factor GAMYB', 47, NULL, NULL, 54773),
(54774, '3.30.70.100-FF-000077', NULL, 'Putative copper-transporting ATPase HMA5', 80, NULL, NULL, 54774),
(54775, '1.20.1280.50-FF-000246', NULL, 'Chromosome 7, whole genome shotgun sequence', 58, NULL, NULL, 54775),
(54776, '3.40.1110.10-FF-000379', NULL, NULL, 151, NULL, NULL, 54776),
(54777, '3.40.50.720-FF-000993', NULL, 'Oxidoreductase', 248, NULL, NULL, 54777),
(54778, '3.60.10.10-FF-000267', NULL, 'Type IV inositol polyphosphate 5-phosphatase 6', 61, NULL, NULL, 54778),
(54779, '3.30.310.130-FF-000012', NULL, 'Chromosome 1, whole genome shotgun sequence', 71, NULL, NULL, 54779),
(54780, '3.30.70.890-FF-000033', NULL, 'Phosphomevalonate kinase', 140, NULL, NULL, 54780),
(54781, '1.10.1040.10-FF-000028', NULL, 'Mannitol 2-dehydrogenase', 205, NULL, NULL, 54781),
(54782, '1.10.565.10-FF-000181', NULL, 'Uncharacterized protein', 134, NULL, NULL, 54782),
(54783, '2.60.220.50-FF-000068', NULL, 'Adhesion G protein-coupled receptor G3', 109, NULL, NULL, 54783),
(54784, '2.60.120.970-FF-000068', NULL, 'Nodal homolog 3-C', 142, NULL, NULL, 54784),
(54785, '3.40.50.2300-FF-001039', NULL, NULL, 183, NULL, NULL, 54785),
(54786, '3.40.50.1220-FF-000097', NULL, 'Electron transfer flavoprotein alpha-subunit', 127, NULL, NULL, 54786),
(54787, '2.20.110.10-FF-000057', NULL, NULL, 63, NULL, NULL, 54787),
(54788, '3.30.70.330-FF-001742', NULL, NULL, 103, NULL, NULL, 54788),
(54789, '3.40.50.10130-FF-000054', NULL, 'Uncharacterized protein', 157, NULL, NULL, 54789),
(54790, '3.30.160.60-FF-002165', NULL, NULL, 29, NULL, NULL, 54790),
(54791, '3.30.70.580-FF-000041', NULL, 'tRNA pseudouridine synthase', 128, NULL, NULL, 54791),
(54792, '2.20.50.20-FF-000012', NULL, 'Vitellogenin-2', 40, NULL, NULL, 54792),
(54793, '3.20.20.60-FF-000003', NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', 267, NULL, NULL, 54793),
(54794, '3.30.40.10-FF-000944', NULL, 'Lysine (K)-specific demethylase 5Ba', 81, NULL, NULL, 54794),
(54795, '2.40.50.690-FF-000021', NULL, 'Uncharacterized protein', 134, NULL, NULL, 54795),
(54796, '2.30.30.230-FF-000005', NULL, 'Fumarylacetoacetase', 115, NULL, NULL, 54796),
(54797, '3.60.20.10-FF-000239', NULL, NULL, 76, NULL, NULL, 54797),
(54798, '3.40.630.30-FF-000190', NULL, 'YGR111W-like protein', 148, NULL, NULL, 54798),
(54799, '3.80.10.10-FF-002683', NULL, 'Receptor kinase-like protein Xa21', 303, NULL, NULL, 54799),
(54800, '1.10.390.10-FF-000049', NULL, 'Transcription initiation factor TFIID subunit 2', 262, NULL, NULL, 54800),
(54801, '3.40.50.300-FF-001946', NULL, 'DEAD box helicase, putative', 246, NULL, NULL, 54801),
(54802, '2.60.40.10-FF-000063', NULL, 'neural cell adhesion molecule L1', 95, NULL, NULL, 54802),
(54803, '3.30.60.30-FF-000030', NULL, 'HtrA serine peptidase 3', 36, NULL, NULL, 54803),
(54804, '1.20.1250.20-FF-002259', NULL, 'Tetracycline-efflux transporter, putative', 104, NULL, NULL, 54804),
(54805, '1.25.40.10-FF-003356', NULL, 'Putative pentatricopeptide repeat-containing protein', 74, NULL, NULL, 54805),
(54806, '1.20.120.1070-FF-000014', NULL, 'Translation initiation factor eif-2B alpha subunit, putative', 101, NULL, NULL, 54806),
(54807, '3.30.390.30-FF-000009', NULL, 'Pyridine nucleotide-disulfide oxidoreductase domain-containing protein 1', 83, NULL, NULL, 54807);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(54808, '2.130.10.10-FF-005167', NULL, 'Uncharacterized protein', 132, NULL, NULL, 54808),
(54809, '2.60.120.920-FF-000205', NULL, 'Si:ch211-227p7.5', 62, NULL, NULL, 54809),
(54810, '1.10.150.650-FF-000013', NULL, '3'',5''-nucleoside bisphosphate phosphatase', 73, NULL, NULL, 54810),
(54811, '2.40.30.10-FF-000170', NULL, 'Mitochondrial elongation factor Tu homologue', 54, NULL, NULL, 54811),
(54812, '2.130.10.10-FF-005509', NULL, 'Uncharacterized protein', 91, NULL, NULL, 54812),
(54813, '1.20.5.4770-FF-000003', NULL, 'OTU domain-containing protein 7B', 43, NULL, NULL, 54813),
(54814, '2.30.31.10-FF-000015', NULL, 'Uncharacterized protein', 65, NULL, NULL, 54814),
(54815, '2.60.40.10-FF-006004', NULL, NULL, 41, NULL, NULL, 54815),
(54816, '3.20.20.70-FF-000225', NULL, 'Thiamine-phosphate pyrophosphorylase', 241, NULL, NULL, 54816),
(54817, '3.30.70.330-FF-001433', NULL, NULL, 100, NULL, NULL, 54817),
(54818, '1.10.150.780-FF-000001', NULL, 'Vacuolar protein sorting-associated protein 16 homolog', 98, NULL, NULL, 54818),
(54819, '1.20.58.340-FF-000047', NULL, 'MGT2 magnesium transporter', 72, NULL, NULL, 54819),
(54820, '3.40.1180.10-FF-000018', NULL, 'Alkyl transferase', 245, NULL, NULL, 54820),
(54821, '1.10.286.20-FF-000001', NULL, 'Elongation factor Ts', 46, NULL, NULL, 54821),
(54822, '3.40.50.1460-FF-000129', NULL, 'Predicted protein', 117, NULL, NULL, 54822),
(54823, '3.30.390.10-FF-000003', NULL, 'D-galactonate dehydratase', 117, NULL, NULL, 54823),
(54824, '1.20.1560.10-FF-000756', NULL, 'Uncharacterized protein', 44, NULL, NULL, 54824),
(54825, '3.40.50.300-FF-006370', NULL, 'Uncharacterized protein', 138, NULL, NULL, 54825),
(54826, '2.20.25.10-FF-000024', NULL, 'DNA-directed RNA polymerase subunit', 63, NULL, NULL, 54826),
(54827, '1.20.120.1080-FF-000017', NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase', 102, NULL, NULL, 54827),
(54828, '3.40.720.10-FF-000224', NULL, 'Predicted protein', 245, NULL, NULL, 54828),
(54829, '3.40.800.10-FF-000011', NULL, 'Arginase-1', 322, NULL, NULL, 54829),
(54830, '2.60.40.1730-FF-000116', NULL, NULL, 81, NULL, NULL, 54830),
(54831, '1.10.274.80-FF-000002', NULL, 'Toxin B', 100, NULL, NULL, 54831),
(54832, '3.40.1280.30-FF-000032', NULL, 'Uncharacterized protein', 200, NULL, NULL, 54832),
(54833, '3.40.50.2000-FF-001073', NULL, 'Uncharacterized protein', 60, NULL, NULL, 54833),
(54834, '3.30.420.40-FF-000072', NULL, 'Pantothenate kinase 2', 110, NULL, NULL, 54834),
(54835, '3.40.1800.20-FF-000036', NULL, NULL, 77, NULL, NULL, 54835),
(54836, '2.60.200.40-FF-000047', NULL, 'Diacylglycerol kinase', 125, NULL, NULL, 54836),
(54837, '3.20.20.140-FF-000290', NULL, 'Phosphoesterase-related protein', 235, NULL, NULL, 54837),
(54838, '3.30.200.20-FF-001078', NULL, 'Putative cyclin-dependent protein kinase', 106, NULL, NULL, 54838),
(54839, '3.40.800.20-FF-000014', NULL, 'Histone deacetylase 15', 376, NULL, NULL, 54839),
(54840, '2.60.40.10-FF-005751', NULL, NULL, 92, NULL, NULL, 54840),
(54841, '1.25.40.180-FF-000069', NULL, 'Uncharacterized protein', 251, NULL, NULL, 54841),
(54842, '3.90.190.10-FF-000284', NULL, 'Dual specificity protein phosphatase 5', 153, NULL, NULL, 54842),
(54843, '2.10.90.10-FF-000091', NULL, 'Uncharacterized protein', 112, NULL, NULL, 54843),
(54844, '2.130.10.10-FF-001766', NULL, 'Transcription factor C subunit 6', 369, NULL, NULL, 54844),
(54845, '2.60.40.10-FF-000372', NULL, 'Myosin light chain kinase, smooth muscle', 101, NULL, NULL, 54845),
(54846, '3.40.50.300-FF-005908', NULL, 'Predicted protein', 261, NULL, NULL, 54846),
(54847, '2.70.150.10-FF-000025', NULL, 'Phospholipid-transporting ATPase', 173, NULL, NULL, 54847),
(54848, '2.60.40.10-FF-005970', NULL, NULL, 104, NULL, NULL, 54848),
(54849, '2.60.200.20-FF-000260', NULL, 'Uncharacterized protein', 157, NULL, NULL, 54849),
(54850, '3.30.365.10-FF-000018', NULL, 'Xanthine dehydrogenase yagR molybdenum-binding subunit', 168, NULL, NULL, 54850),
(54851, '3.30.450.260-FF-000003', NULL, 'Soluble guanylate cyclase gcy-32', 156, NULL, NULL, 54851),
(54852, '2.60.40.10-FF-005509', NULL, NULL, 81, NULL, NULL, 54852);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(54853, '3.20.20.70-FF-000534', NULL, NULL, 240, NULL, NULL, 54853),
(54854, '2.80.10.50-FF-000252', NULL, 'Predicted protein', 137, NULL, NULL, 54854),
(54855, '3.40.50.150-FF-000029', NULL, 'Protein arginine N-methyltransferase 5', 167, NULL, NULL, 54855),
(54856, '3.40.30.10-FF-000016', NULL, 'Glutathione S-transferase F2', 85, NULL, NULL, 54856),
(54857, '1.20.1420.30-FF-000010', NULL, 'Na+/Ca+ antiporter, CaCA family', 226, NULL, NULL, 54857),
(54858, '3.30.505.10-FF-000007', NULL, 'E3 ubiquitin-protein ligase CBL', 86, NULL, NULL, 54858),
(54859, '2.10.70.10-FF-000179', NULL, 'sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1 isoform X2', 61, NULL, NULL, 54859),
(54860, '3.30.160.60-FF-002530', NULL, 'Zinc finger protein', 33, NULL, NULL, 54860),
(54861, '3.40.33.10-FF-000129', NULL, 'Uncharacterized protein', 192, NULL, NULL, 54861),
(54862, '3.80.10.10-FF-002593', NULL, 'NLR family CARD domain containing 3', 81, NULL, NULL, 54862),
(54863, '2.60.200.20-FF-000041', NULL, 'Protein phosphatase 2C 11', 99, NULL, NULL, 54863),
(54864, '2.40.10.10-FF-000062', NULL, 'mannan-binding lectin serine protease 1 isoform X1', 138, NULL, NULL, 54864),
(54865, '2.40.270.10-FF-000007', NULL, 'DNA-directed RNA polymerase subunit beta', 41, NULL, NULL, 54865),
(54866, '1.10.630.10-FF-000765', NULL, 'Cytochrome P450, family 7, subfamily B, polypeptide 1', 481, NULL, NULL, 54866),
(54867, '1.25.40.10-FF-003047', NULL, 'Pentatricopeptide repeat-containing protein', 82, NULL, NULL, 54867),
(54868, '3.60.40.10-FF-000347', NULL, 'Os03g0104100 protein', 70, NULL, NULL, 54868),
(54869, '2.130.10.10-FF-005476', NULL, 'WD repeat-containing protein 3-like Protein', 152, NULL, NULL, 54869),
(54870, '3.40.1050.10-FF-000014', NULL, 'Carbonic anhydrase', 237, NULL, NULL, 54870),
(54871, '3.40.50.10810-FF-000027', NULL, 'helicase-like transcription factor isoform X3', 123, NULL, NULL, 54871),
(54872, '3.90.1150.170-FF-000001', NULL, 'Glutamate decarboxylase like 1', 217, NULL, NULL, 54872),
(54873, '2.130.10.10-FF-002042', NULL, 'Chromatin assembly factor 1 subunit B', 206, NULL, NULL, 54873),
(54874, '1.10.540.10-FF-000011', NULL, 'Predicted acyl-CoA dehydrogenase', 117, NULL, NULL, 54874),
(54875, '1.20.1110.10-FF-000172', NULL, NULL, 69, NULL, NULL, 54875),
(54876, '1.20.890.10-FF-000023', NULL, 'Predicted protein', 57, NULL, NULL, 54876),
(54877, '3.30.20.10-FF-000004', NULL, 'Chitinase family protein', 52, NULL, NULL, 54877),
(54878, '2.60.40.150-FF-000313', NULL, 'Putative ATP-dependent RNA helicase', 111, NULL, NULL, 54878),
(54879, '3.30.1490.20-FF-000036', NULL, 'Phosphoribosylamine--glycine ligase-like protein', 59, NULL, NULL, 54879),
(54880, '2.20.28.10-FF-000047', NULL, 'Rapid-growth-like protein 42', 54, NULL, NULL, 54880),
(54881, '3.40.50.1440-FF-000123', NULL, 'Miscellaneous Zn(II)2Cys6 transcription factor (Eurofung)', 75, NULL, NULL, 54881),
(54882, '2.60.120.10-FF-000812', NULL, 'Protein kinase, cAMP-dependent, regulatory, type II, alpha, B', 110, NULL, NULL, 54882),
(54883, '3.40.50.2300-FF-001258', NULL, NULL, 65, NULL, NULL, 54883),
(54884, '3.40.640.10-FF-000133', NULL, 'Dihydrodipicolinate reductase', 224, NULL, NULL, 54884),
(54885, '3.40.50.1000-FF-000014', NULL, 'Phospholipid-transporting ATPase', 193, NULL, NULL, 54885),
(54886, '2.130.10.10-FF-001457', NULL, 'GM11645', 375, NULL, NULL, 54886),
(54887, '3.30.200.20-FF-001387', NULL, 'Protein CBG16237', 89, NULL, NULL, 54887),
(54888, '2.130.10.10-FF-005818', NULL, 'Uncharacterized protein', 68, NULL, NULL, 54888),
(54889, '2.60.120.10-FF-000470', NULL, 'Predicted protein', 194, NULL, NULL, 54889),
(54890, '2.60.120.680-FF-000009', NULL, 'Blast:Protein real-time', 139, NULL, NULL, 54890),
(54891, '2.30.30.40-FF-000011', NULL, 'Microtubule-actin cross-linking factor 1', 69, NULL, NULL, 54891),
(54892, '1.10.8.10-FF-000166', NULL, 'RAD23A isoform 4', 43, NULL, NULL, 54892),
(54893, '2.70.170.10-FF-000223', NULL, 'Uncharacterized protein', 105, NULL, NULL, 54893),
(54894, '1.10.630.10-FF-000456', NULL, 'Uncharacterized protein', 183, NULL, NULL, 54894);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(54895, '2.30.40.10-FF-000109', NULL, 'Uncharacterized protein', 13, NULL, NULL, 54895),
(54896, '2.30.29.30-FF-000864', NULL, 'GM23249p', 136, NULL, NULL, 54896),
(54897, '3.40.930.10-FF-000015', NULL, 'Anion exchange protein', 306, NULL, NULL, 54897),
(54898, '3.40.50.300-FF-006151', NULL, 'Uncharacterized protein', 210, NULL, NULL, 54898),
(54899, '3.50.50.60-FF-001318', NULL, 'Uncharacterized protein', 40, NULL, NULL, 54899),
(54900, '1.10.30.10-FF-000022', NULL, 'nucleolar transcription factor 1 isoform X2', 98, NULL, NULL, 54900),
(54901, '2.10.60.10-FF-000044', NULL, 'Serine/threonine-protein kinase receptor', 79, NULL, NULL, 54901),
(54902, '3.60.40.10-FF-000095', NULL, 'Protein phosphatase PPM9', 156, NULL, NULL, 54902),
(54903, '3.10.580.10-FF-000039', NULL, 'Putative arabinose 5-phosphate isomerase', 129, NULL, NULL, 54903),
(54904, '3.70.10.10-FF-000058', NULL, 'Cell cycle checkpoint protein hpr-9', 272, NULL, NULL, 54904),
(54905, '4.10.40.20-FF-000007', NULL, 'Insulin-like growth factor-binding protein 2', 87, NULL, NULL, 54905),
(54906, '1.25.40.180-FF-000159', NULL, 'Uncharacterized protein', 315, NULL, NULL, 54906),
(54907, '2.10.220.10-FF-000207', NULL, 'Predicted protein', 55, NULL, NULL, 54907),
(54908, '3.20.20.80-FF-000537', NULL, 'Glucan 1,6-alpha-glucosidase', 305, NULL, NULL, 54908),
(54909, '1.10.510.10-FF-002280', NULL, NULL, 137, NULL, NULL, 54909),
(54910, '3.30.70.330-FF-001523', NULL, 'mRNA-binding ribosome biosynthesis protein', 136, NULL, NULL, 54910),
(54911, '2.60.40.150-FF-000061', NULL, 'dysferlin isoform X8', 127, NULL, NULL, 54911),
(54912, '1.10.10.10-FF-001802', NULL, 'Selenocysteine-specific translation elongation factor', 55, NULL, NULL, 54912),
(54913, '3.30.930.10-FF-000208', NULL, 'Glycine--tRNA ligase', 325, NULL, NULL, 54913),
(54914, '2.60.120.10-FF-000357', NULL, 'Protein kinase, putative', 129, NULL, NULL, 54914),
(54915, '1.25.40.10-FF-005166', NULL, 'TPR domain protein', 75, NULL, NULL, 54915),
(54916, '1.10.1220.10-FF-000014', NULL, 'Antitoxin VapB41', 40, NULL, NULL, 54916),
(54917, '1.10.238.20-FF-000019', NULL, 'GEO07291p1', 126, NULL, NULL, 54917),
(54918, '1.20.1070.10-FF-000359', NULL, 'opsin, ultraviolet-sensitive', 314, NULL, NULL, 54918),
(54919, '3.40.50.2300-FF-000887', NULL, NULL, 143, NULL, NULL, 54919),
(54920, '3.10.490.20-FF-000029', NULL, 'Uncharacterized protein', 83, NULL, NULL, 54920),
(54921, '1.20.1260.10-FF-000059', NULL, 'Ferritin', 154, NULL, NULL, 54921),
(54922, '4.10.110.10-FF-000006', NULL, 'Trefoil factor 1', 52, NULL, NULL, 54922),
(54923, '3.30.2170.10-FF-000003', NULL, 'Endonuclease V', 181, NULL, NULL, 54923),
(54924, '3.40.50.261-FF-000030', NULL, 'Acyl-CoA synthetase, putative', 167, NULL, NULL, 54924),
(54925, '3.30.160.60-FF-001575', NULL, 'zinc finger protein 646', 79, NULL, NULL, 54925),
(54926, '3.80.10.10-FF-002688', NULL, 'Receptor-like protein kinase HSL1', 86, NULL, NULL, 54926),
(54927, '3.30.70.890-FF-000050', NULL, 'Mevalonate kinase', 131, NULL, NULL, 54927),
(54928, '2.60.40.150-FF-000521', NULL, 'Rho GTPase-activating protein gacEE', 129, NULL, NULL, 54928),
(54929, '1.50.10.10-FF-000154', NULL, 'Predicted protein', 325, NULL, NULL, 54929),
(54930, '1.10.510.10-FF-004320', NULL, NULL, 146, NULL, NULL, 54930),
(54931, '3.10.100.10-FF-000150', NULL, 'Mannose receptor, C type 2', 123, NULL, NULL, 54931),
(54932, '3.30.160.60-FF-003699', NULL, 'D4, zinc and double PHD fingers family 1', 67, NULL, NULL, 54932),
(54933, '3.40.50.300-FF-007909', NULL, 'Uncharacterized protein', 186, NULL, NULL, 54933),
(54934, '3.40.50.620-FF-000867', NULL, 'Uncharacterized protein', 137, NULL, NULL, 54934),
(54935, '3.20.20.70-FF-000539', NULL, 'L-lactate dehydrogenase', 379, NULL, NULL, 54935),
(54936, '1.25.10.10-FF-001965', NULL, 'NIMA related kinase 10', 210, NULL, NULL, 54936),
(54937, '1.10.286.20-FF-000006', NULL, 'Elongation factor Ts, mitochondrial', 45, NULL, NULL, 54937),
(54938, '2.20.70.30-FF-000005', NULL, 'Nascent polypeptide-associated complex subunit beta', 51, NULL, NULL, 54938),
(54939, '1.25.40.20-FF-000273', NULL, 'Ankyrin repeat domain-containing protein 6', 105, NULL, NULL, 54939);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(54940, '1.10.510.10-FF-002066', NULL, 'Protein kinase superfamily protein', 242, NULL, NULL, 54940),
(54941, '3.40.50.300-FF-002008', NULL, 'Uridine kinase', 210, NULL, NULL, 54941),
(54942, '2.10.70.10-FF-000191', NULL, 'kielin/chordin-like protein', 35, NULL, NULL, 54942),
(54943, '1.10.10.10-FF-001908', NULL, 'Os04g0176200 protein', 21, NULL, NULL, 54943),
(54944, '3.40.50.410-FF-000029', NULL, 'Cochlin', 192, NULL, NULL, 54944),
(54945, '2.20.25.10-FF-000035', NULL, 'DNA-directed RNA polymerase subunit', 53, NULL, NULL, 54945),
(54946, '3.40.50.1820-FF-001007', NULL, 'Alpha/beta hydrolase', 227, NULL, NULL, 54946),
(54947, '3.80.10.10-FF-001165', NULL, 'Receptor kinase-like protein', 93, NULL, NULL, 54947),
(54948, '3.40.50.720-FF-001061', NULL, 'Potassium transporter peripheral membrane component', 134, NULL, NULL, 54948),
(54949, '3.50.50.60-FF-001420', NULL, 'Uncharacterized protein', 253, NULL, NULL, 54949),
(54950, '3.30.70.1230-FF-000035', NULL, 'Guanylate cyclase', 223, NULL, NULL, 54950),
(54951, '1.10.472.130-FF-000071', NULL, 'Dynein heavy chain, cytoplasmic', 159, NULL, NULL, 54951),
(54952, '1.10.150.50-FF-000072', NULL, 'Sexual stage-specific protein kinase', 67, NULL, NULL, 54952),
(54953, '3.30.40.10-FF-001427', NULL, 'Uncharacterized protein', 76, NULL, NULL, 54953),
(54954, '1.20.120.350-FF-000139', NULL, 'Putative calcium channel protein', 120, NULL, NULL, 54954),
(54955, '2.40.30.130-FF-000006', NULL, 'Alanine--tRNA ligase', 91, NULL, NULL, 54955),
(54956, '1.10.238.10-FF-000016', NULL, 'Dystrobrevin alpha', 75, NULL, NULL, 54956),
(54957, '1.10.238.200-FF-000014', NULL, 'Defective in cullin neddylation protein', 94, NULL, NULL, 54957),
(54958, '1.10.442.10-FF-000007', NULL, NULL, 46, NULL, NULL, 54958),
(54959, '1.10.246.130-FF-000016', NULL, NULL, 105, NULL, NULL, 54959),
(54960, '2.130.10.10-FF-005268', NULL, 'Uncharacterized protein', 254, NULL, NULL, 54960),
(54961, '3.30.70.340-FF-000003', NULL, 'Carboxypeptidase B2', 92, NULL, NULL, 54961),
(54962, '1.50.40.10-FF-000077', NULL, 'Mitochondrial dicarboxylate carrier', 272, NULL, NULL, 54962),
(54963, '1.10.510.10-FF-003589', NULL, NULL, 210, NULL, NULL, 54963),
(54964, '3.20.20.370-FF-000026', NULL, 'Hydrolase, putative', 282, NULL, NULL, 54964),
(54965, '1.25.10.10-FF-001286', NULL, 'Importin subunit alpha-1', 374, NULL, NULL, 54965),
(54966, '3.20.20.80-FF-000447', NULL, 'Putative beta-glucosidase 41', 148, NULL, NULL, 54966),
(54967, '3.30.190.20-FF-000019', NULL, 'Mitochondrial Ribosomal Protein, Large', 117, NULL, NULL, 54967),
(54968, '2.40.110.10-FF-000041', NULL, 'Acyl-CoA dehydrogenase FadE18', 97, NULL, NULL, 54968),
(54969, '2.60.40.10-FF-006021', NULL, NULL, 93, NULL, NULL, 54969),
(54970, '3.20.20.140-FF-000188', NULL, 'RNA-binding RNA processing protein', 141, NULL, NULL, 54970),
(54971, '2.80.10.50-FF-000044', NULL, 'Dolichyl-phosphate-mannose-protein mannosyltransferase 4', 204, NULL, NULL, 54971),
(54972, '2.40.30.10-FF-000501', NULL, 'NADH-cytochrome b5 reductase-like protein', 96, NULL, NULL, 54972),
(54973, '3.40.50.10190-FF-000252', NULL, 'YALI0B15576p', 97, NULL, NULL, 54973),
(54974, '3.50.50.60-FF-000689', NULL, 'Phytoene dehydrogenase', 113, NULL, NULL, 54974),
(54975, '1.25.40.10-FF-001793', NULL, 'Pentatricopeptide repeat-containing protein', 182, NULL, NULL, 54975),
(54976, '1.10.287.70-FF-000765', NULL, 'Sodium channel protein', 135, NULL, NULL, 54976),
(54977, '3.40.720.10-FF-000331', NULL, 'Uncharacterized protein', 123, NULL, NULL, 54977),
(54978, '1.20.1250.20-FF-000674', NULL, 'Major facilitator superfamily transporter', 205, NULL, NULL, 54978),
(54979, '1.10.510.10-FF-000621', NULL, 'Serine/threonine-protein kinase', 214, NULL, NULL, 54979),
(54980, '3.40.1110.10-FF-000177', NULL, 'Potassium/sodium eff', 208, NULL, NULL, 54980),
(54981, '2.60.40.60-FF-000038', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', 105, NULL, NULL, 54981),
(54982, '3.40.50.1820-FF-000395', NULL, 'Alpha/beta hydrolase', 233, NULL, NULL, 54982),
(54983, '3.30.160.60-FF-004430', NULL, NULL, 26, NULL, NULL, 54983);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(54984, '2.60.40.1180-FF-000114', NULL, 'Alpha-amylase', 55, NULL, NULL, 54984),
(54985, '2.20.100.10-FF-000096', NULL, 'Cartilage intermediate layer protein 1', 72, NULL, NULL, 54985),
(54986, '3.20.20.70-FF-000444', NULL, '3-dehydroquinate dehydratase', 234, NULL, NULL, 54986),
(54987, '1.25.40.20-FF-001796', NULL, 'Uncharacterized protein', 169, NULL, NULL, 54987),
(54988, '2.30.29.30-FF-000954', NULL, 'Uncharacterized protein', 114, NULL, NULL, 54988),
(54989, '2.60.40.10-FF-005841', NULL, NULL, 106, NULL, NULL, 54989),
(54990, '3.40.50.150-FF-001199', NULL, '3-hydroxy-5-methyl-1-naphthoate 3-O-methyltransferase', 235, NULL, NULL, 54990),
(54991, '3.40.50.10480-FF-000018', NULL, 'U3 small nucleolar ribonucleoprotein protein IMP4, putative (AFU_orthologue AFUA_1G13070)', 109, NULL, NULL, 54991),
(54992, '3.40.50.300-FF-005774', NULL, 'Uncharacterized protein', 104, NULL, NULL, 54992),
(54993, '2.110.10.10-FF-000070', NULL, 'Uncharacterized protein', 111, NULL, NULL, 54993),
(54994, '3.30.479.10-FF-000018', NULL, 'Uncharacterized protein', 65, NULL, NULL, 54994),
(54995, '2.130.10.10-FF-005482', NULL, 'Predicted protein', 137, NULL, NULL, 54995),
(54996, '2.60.40.10-FF-000714', NULL, 'Titin novex-3', 99, NULL, NULL, 54996),
(54997, '3.40.50.300-FF-001396', NULL, 'Structural maintenance of chromosomes protein', 182, NULL, NULL, 54997),
(54998, '1.20.1070.10-FF-001511', NULL, 'Growth hormone secretagogue receptor', 195, NULL, NULL, 54998),
(54999, '3.40.50.140-FF-000010', NULL, 'DNA topoisomerase', 160, NULL, NULL, 54999),
(55000, '3.30.160.60-FF-000052', NULL, 'zinc finger protein 546 isoform X1', 29, NULL, NULL, 55000),
(55001, '3.30.40.10-FF-000489', NULL, 'E3 ubiquitin-protein ligase PRT1', 96, NULL, NULL, 55001),
(55002, '3.50.50.60-FF-001195', NULL, 'Uncharacterized protein', 423, NULL, NULL, 55002),
(55003, '1.10.555.10-FF-000135', NULL, 'Rho GTPase-activating protein 18', 268, NULL, NULL, 55003),
(55004, '1.20.1600.10-FF-000029', NULL, 'Outer membrane secretion protein', 407, NULL, NULL, 55004),
(55005, '3.40.50.2000-FF-000999', NULL, 'Alpha-1,4 glucan phosphorylase', 28, NULL, NULL, 55005),
(55006, '1.20.1250.20-FF-001612', NULL, 'Uncharacterized protein', 175, NULL, NULL, 55006),
(55007, '2.170.150.80-FF-000016', NULL, 'Apical meristem formation protein-related', 137, NULL, NULL, 55007),
(55008, '1.10.1240.10-FF-000009', NULL, 'Probable transcriptional regulator', 79, NULL, NULL, 55008),
(55009, '1.10.1410.10-FF-000040', NULL, 'Poly(U) Polymerase', 163, NULL, NULL, 55009),
(55010, '1.10.520.10-FF-000009', NULL, 'Peroxidase', 153, NULL, NULL, 55010),
(55011, '3.90.550.20-FF-000034', NULL, 'Predicted protein', 204, NULL, NULL, 55011),
(55012, '3.40.50.10470-FF-000015', NULL, 'Eukaryotic translation initiation factor 2B subunit alpha', 82, NULL, NULL, 55012),
(55013, '1.25.40.20-FF-001807', NULL, 'Stress-activated protein kinase alpha', 164, NULL, NULL, 55013),
(55014, '2.60.120.920-FF-000104', NULL, 'E3 ubiquitin-protein ligase RNF123', 128, NULL, NULL, 55014),
(55015, '2.10.25.10-FF-000564', NULL, 'Fibulin 2', 50, NULL, NULL, 55015),
(55016, '1.20.58.390-FF-000023', NULL, 'Nicotinic acetylcholine receptor subunit alpha6', 103, NULL, NULL, 55016),
(55017, '3.30.160.60-FF-002401', NULL, 'zinc finger protein 39', 29, NULL, NULL, 55017),
(55018, '1.25.40.10-FF-001804', NULL, 'Tetratricopeptide repeat protein 30 homolog', 97, NULL, NULL, 55018),
(55019, '3.10.50.40-FF-000140', NULL, 'Peptidylprolyl isomerase', 82, NULL, NULL, 55019),
(55020, '1.20.1250.20-FF-000769', NULL, 'Protein CBR-ENT-2', 266, NULL, NULL, 55020),
(55021, '3.80.10.10-FF-000890', NULL, 'Toll-like receptor 7', 280, NULL, NULL, 55021),
(55022, '3.90.190.10-FF-000514', NULL, 'Predicted protein', 130, NULL, NULL, 55022),
(55023, '1.10.30.10-FF-000027', NULL, 'Transcription factor SOX-30', 82, NULL, NULL, 55023),
(55024, '1.20.5.110-FF-000209', NULL, 'Si:ch211-208k15.1', 41, NULL, NULL, 55024),
(55025, '3.40.50.1700-FF-000033', NULL, 'Beta-glucosidase (Gentiobiase)', 222, NULL, NULL, 55025),
(55026, '2.130.10.10-FF-001783', NULL, 'Predicted protein', 166, NULL, NULL, 55026);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(55027, '3.10.290.10-FF-000028', NULL, 'Pseudouridine synthase', 63, NULL, NULL, 55027),
(55028, '3.30.160.60-FF-002513', NULL, 'Zinc finger protein 606', 28, NULL, NULL, 55028),
(55029, '3.40.140.10-FF-000123', NULL, 'Cytidine deaminase, putative', 127, NULL, NULL, 55029),
(55030, '1.10.10.10-FF-000032', NULL, 'Forkhead box protein O4', 91, NULL, NULL, 55030),
(55031, '3.50.30.30-FF-000033', NULL, 'Glutamate carboxypeptidase 2 homolog', 227, NULL, NULL, 55031),
(55032, '1.10.510.10-FF-004106', NULL, NULL, 301, NULL, NULL, 55032),
(55033, '3.90.550.10-FF-000031', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 391, NULL, NULL, 55033),
(55034, '3.30.1360.180-FF-000013', NULL, 'Uncharacterized protein', 89, NULL, NULL, 55034),
(55035, '3.30.810.10-FF-000019', NULL, 'Putative 1-phosphatidylinositol-4-phosphate 5-kinase/ zinc ion binding family', 73, NULL, NULL, 55035),
(55036, '6.10.140.2220-FF-000080', NULL, 'Protein 5NUC-like Protein', 50, NULL, NULL, 55036),
(55037, '3.60.21.10-FF-000180', NULL, 'Acid sphingomyelinase family phosphodiesterase, putative', 298, NULL, NULL, 55037),
(55038, '3.30.1490.20-FF-000053', NULL, 'D-alanine--D-alanine ligase', 61, NULL, NULL, 55038),
(55039, '3.30.530.20-FF-000203', NULL, 'Uncharacterized protein', 37, NULL, NULL, 55039),
(55040, '1.10.630.10-FF-000782', NULL, 'Os09g0530275 protein', 134, NULL, NULL, 55040),
(55041, '2.130.10.10-FF-004071', NULL, 'Uncharacterized protein', 205, NULL, NULL, 55041),
(55042, '1.10.510.10-FF-003494', NULL, NULL, 260, NULL, NULL, 55042),
(55043, '3.30.930.10-FF-000085', NULL, 'Serine-tRNA ligase', 383, NULL, NULL, 55043),
(55044, '3.30.1360.170-FF-000010', NULL, 'Thymidylate synthase complementing protein ThyX', 208, NULL, NULL, 55044),
(55045, '1.10.405.10-FF-000040', NULL, 'L-amino-acid oxidase', 46, NULL, NULL, 55045),
(55046, '1.20.120.790-FF-000024', NULL, 'Uncharacterized protein', 144, NULL, NULL, 55046),
(55047, '2.30.30.40-FF-000022', NULL, 'Tyrosine-protein kinase', 62, NULL, NULL, 55047),
(55048, '3.50.50.60-FF-000104', NULL, 'Squalene monooxygenase', 377, NULL, NULL, 55048),
(55049, '3.30.428.30-FF-000002', NULL, 'CDP-diacylglycerol pyrophosphatase', 224, NULL, NULL, 55049),
(55050, '3.30.470.10-FF-000049', NULL, 'Probable branched-chain amino acid aminotransferase', 84, NULL, NULL, 55050),
(55051, '1.20.58.530-FF-000003', NULL, 'Myosin heavy chain 10', 180, NULL, NULL, 55051),
(55052, '3.40.930.10-FF-000026', NULL, 'Nitrogen regulatory IIA protein', 152, NULL, NULL, 55052),
(55053, '2.60.120.10-FF-000571', NULL, 'Mannose-6-phosphate isomerase', 190, NULL, NULL, 55053),
(55054, '1.10.418.10-FF-000114', NULL, 'Protein Hook homolog 2', 84, NULL, NULL, 55054),
(55055, '3.40.50.10190-FF-000038', NULL, 'SMC5-SMC6 complex localization factor protein 1', 92, NULL, NULL, 55055),
(55056, '3.40.50.300-FF-002334', NULL, 'RuvB-like helicase', 95, NULL, NULL, 55056),
(55057, '2.60.40.10-FF-001816', NULL, 'Tyrosine-protein kinase receptor', 112, NULL, NULL, 55057),
(55058, '1.10.101.10-FF-000008', NULL, 'Probable CtpA-like serine protease', 73, NULL, NULL, 55058),
(55059, '2.60.40.10-FF-001928', NULL, 'neuroglian isoform X2', 107, NULL, NULL, 55059),
(55060, '3.30.450.20-FF-000169', NULL, 'Bacteriophytochrome protein', 140, NULL, NULL, 55060),
(55061, '2.10.25.10-FF-000917', NULL, 'Fibrillin-1', 39, NULL, NULL, 55061),
(55062, '1.20.140.10-FF-000074', NULL, 'GD11444', 129, NULL, NULL, 55062),
(55063, '1.20.58.240-FF-000006', NULL, 'Signal transducer and activator of transcription A', 118, NULL, NULL, 55063),
(55064, '3.30.505.10-FF-000136', NULL, 'Predicted protein', 105, NULL, NULL, 55064),
(55065, '3.80.10.10-FF-003205', NULL, 'Decorin', 224, NULL, NULL, 55065),
(55066, '1.20.1000.10-FF-000040', NULL, NULL, 123, NULL, NULL, 55066),
(55067, '2.160.20.10-FF-000040', NULL, 'Probable exopolygalacturonase B', 380, NULL, NULL, 55067),
(55068, '3.40.50.850-FF-000026', NULL, 'Uncharacterized protein', 189, NULL, NULL, 55068),
(55069, '1.20.190.50-FF-000010', NULL, 'Nuclear pore complex protein', 264, NULL, NULL, 55069),
(55070, '3.30.70.330-FF-000697', NULL, 'Nucleic acid binding', 84, NULL, NULL, 55070);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(55071, '1.10.418.20-FF-000005', NULL, 'sentrin-specific protease 6 isoform X2', 171, NULL, NULL, 55071),
(55072, '3.30.70.330-FF-001186', NULL, 'RNA-binding protein putative', 111, NULL, NULL, 55072),
(55073, '3.30.60.30-FF-000136', NULL, 'Uncharacterized protein', 48, NULL, NULL, 55073),
(55074, '2.120.10.30-FF-000210', NULL, 'Tyrosine-protein kinase receptor', 258, NULL, NULL, 55074),
(55075, '2.60.40.650-FF-000025', NULL, 'Predicted protein', 39, NULL, NULL, 55075),
(55076, '2.60.40.10-FF-003587', NULL, NULL, 103, NULL, NULL, 55076),
(55077, '1.10.1200.120-FF-000011', NULL, 'Large conductance mechanosensitive channel protein', 109, NULL, NULL, 55077),
(55078, '1.10.132.70-FF-000013', NULL, 'Telomerase reverse transcriptase', 183, NULL, NULL, 55078),
(55079, '3.20.20.70-FF-000332', NULL, 'Phospho-2-dehydro-3-deoxyheptonate aldolase', 357, NULL, NULL, 55079),
(55080, '1.20.5.110-FF-000198', NULL, 'Qb+Qc-SNARE, SNAP33-family', 87, NULL, NULL, 55080),
(55081, '3.30.565.10-FF-000224', NULL, 'Sensor kinase CitA', 142, NULL, NULL, 55081),
(55082, '3.90.550.10-FF-000126', NULL, 'Exostosin glycosyltransferase 2', 103, NULL, NULL, 55082),
(55083, '2.60.120.620-FF-000121', NULL, 'Uncharacterized protein', 135, NULL, NULL, 55083),
(55084, '2.130.10.10-FF-001906', NULL, 'Uncharacterized WD repeat-containing protein C343.04c', 87, NULL, NULL, 55084),
(55085, '1.20.1280.50-FF-000140', NULL, 'F-box/SPRY domain-containing protein 1', 82, NULL, NULL, 55085),
(55086, '1.10.132.60-FF-000010', NULL, 'DNA polymerase', 152, NULL, NULL, 55086),
(55087, '3.40.50.1820-FF-001333', NULL, 'Predicted protein', 254, NULL, NULL, 55087),
(55088, '3.30.160.60-FF-003492', NULL, 'GD18769', 25, NULL, NULL, 55088),
(55089, '3.90.190.10-FF-000609', NULL, 'Predicted protein', 129, NULL, NULL, 55089),
(55090, '3.40.50.1400-FF-000033', NULL, 'Sirohydrochlorin cobaltochelatase CbiKC', 124, NULL, NULL, 55090),
(55091, '1.20.1560.10-FF-000655', NULL, 'Uncharacterized protein', 103, NULL, NULL, 55091),
(55092, '1.25.40.10-FF-001681', NULL, 'Pentatricopeptide repeat-containing protein At4g33170 family', 213, NULL, NULL, 55092),
(55093, '3.30.160.60-FF-002390', NULL, 'zinc finger protein 404 isoform X2', 28, NULL, NULL, 55093),
(55094, '2.60.40.420-FF-000187', NULL, 'Predicted protein', 159, NULL, NULL, 55094),
(55095, '3.30.160.60-FF-000147', NULL, 'POZ-, AT hook-, and zinc finger-containing protein 1', 28, NULL, NULL, 55095),
(55096, '2.70.150.10-FF-000014', NULL, 'Calcium-transporting ATPase, putative', 159, NULL, NULL, 55096),
(55097, '3.90.245.10-FF-000029', NULL, 'Uncharacterized protein', 286, NULL, NULL, 55097),
(55098, '2.60.120.200-FF-000782', NULL, 'Galectin', 140, NULL, NULL, 55098),
(55099, '2.30.180.10-FF-000160', NULL, NULL, 91, NULL, NULL, 55099),
(55100, '3.30.160.60-FF-005953', NULL, NULL, 77, NULL, NULL, 55100),
(55101, '3.30.70.600-FF-000019', NULL, '40S ribosomal protein S20-1', 105, NULL, NULL, 55101),
(55102, '1.25.40.20-FF-001684', NULL, 'CARD- and ANK-containing Inflammasome Adaptor Protein', 75, NULL, NULL, 55102),
(55103, '3.40.50.10130-FF-000048', NULL, 'Uncharacterized protein', 67, NULL, NULL, 55103),
(55104, '2.60.40.1480-FF-000002', NULL, 'Coatomer subunit gamma', 154, NULL, NULL, 55104),
(55105, '2.30.30.770-FF-000015', NULL, NULL, 51, NULL, NULL, 55105),
(55106, '3.80.10.10-FF-002930', NULL, 'Uncharacterized protein', 128, NULL, NULL, 55106),
(55107, '3.30.160.60-FF-005739', NULL, NULL, 30, NULL, NULL, 55107),
(55108, '1.20.1070.10-FF-001623', NULL, 'Predicted protein', 143, NULL, NULL, 55108),
(55109, '3.50.50.60-FF-001083', NULL, 'Protein anon-37Cs-like Protein', 198, NULL, NULL, 55109),
(55110, '3.40.50.300-FF-005886', NULL, 'ATP-dependent DNA helicase CHL1', 118, NULL, NULL, 55110),
(55111, '2.60.120.200-FF-000568', NULL, 'Uncharacterized protein', 233, NULL, NULL, 55111),
(55112, '2.60.40.10-FF-003492', NULL, NULL, 118, NULL, NULL, 55112),
(55113, '3.30.420.40-FF-001067', NULL, 'Uncharacterized protein', 54, NULL, NULL, 55113),
(55114, '3.40.50.720-FF-002584', NULL, 'D-3-phosphoglycerate dehydrogenase', 16, NULL, NULL, 55114);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(55115, '3.20.100.30-FF-000002', NULL, 'Vacuolar transporter chaperone', 296, NULL, NULL, 55115),
(55116, '3.30.450.20-FF-000495', NULL, 'Response receiver sensor protein serine/threonine phosphatase, PP2C family, PAS and PAS domain-containing', 123, NULL, NULL, 55116),
(55117, '2.40.50.140-FF-000929', NULL, NULL, 95, NULL, NULL, 55117),
(55118, '3.40.50.2000-FF-000792', NULL, '3-deoxy-D-manno-octulosonic acid transferase', 189, NULL, NULL, 55118),
(55119, '3.30.70.340-FF-000020', NULL, NULL, 86, NULL, NULL, 55119),
(55120, '3.30.420.40-FF-000999', NULL, 'Stress-70 protein, mitochondrial', 75, NULL, NULL, 55120),
(55121, '3.20.20.370-FF-000009', NULL, 'Chitin deacetylase', 229, NULL, NULL, 55121),
(55122, '1.25.40.10-FF-005278', NULL, 'Uncharacterized protein', 147, NULL, NULL, 55122),
(55123, '1.10.10.10-FF-001881', NULL, 'Uncharacterized protein', 40, NULL, NULL, 55123),
(55124, '3.30.200.20-FF-001628', NULL, 'Membrane-associated tyrosine-and threonine-specific cdc2-inhibitory kinase', 95, NULL, NULL, 55124),
(55125, '2.60.40.10-FF-005178', NULL, NULL, 93, NULL, NULL, 55125),
(55126, '1.10.10.60-FF-000018', NULL, 'Homeobox A10', 75, NULL, NULL, 55126),
(55127, '3.30.200.20-FF-001292', NULL, 'Rhoptry protein 4', 142, NULL, NULL, 55127),
(55128, '2.30.180.10-FF-000143', NULL, NULL, 132, NULL, NULL, 55128),
(55129, '3.40.630.30-FF-000425', NULL, 'GNAT family N-acetyltransferase', 213, NULL, NULL, 55129),
(55130, '1.10.225.10-FF-000037', NULL, 'Prosaposin', 54, NULL, NULL, 55130),
(55131, '3.90.190.10-FF-000598', NULL, 'Uncharacterized protein', 283, NULL, NULL, 55131),
(55132, '3.20.20.70-FF-000091', NULL, 'galactocerebrosidase precursor', 176, NULL, NULL, 55132),
(55133, '1.10.510.10-FF-003831', NULL, NULL, 111, NULL, NULL, 55133),
(55134, '3.40.605.10-FF-000131', NULL, 'Uncharacterized protein', 85, NULL, NULL, 55134),
(55135, '2.30.29.30-FF-000971', NULL, 'Beta-1-syntrophin', 98, NULL, NULL, 55135),
(55136, '3.90.1750.10-FF-000062', NULL, 'Predicted protein', 133, NULL, NULL, 55136),
(55137, '4.10.400.10-FF-000225', NULL, 'AGAP003656-PA', 41, NULL, NULL, 55137),
(55138, '3.20.20.70-FF-000427', NULL, 'Alpha-galactosidase', 220, NULL, NULL, 55138),
(55139, '1.25.40.20-FF-000256', NULL, 'HECT domain and ankyrin repeat containing E3 ubiquitin protein ligase 1', 111, NULL, NULL, 55139),
(55140, '1.25.10.10-FF-001853', NULL, 'Condensin complex subunit 1', 197, NULL, NULL, 55140),
(55141, '3.40.50.1820-FF-001119', NULL, 'Alpha/beta fold hydrolase', 90, NULL, NULL, 55141),
(55142, '3.20.20.140-FF-000430', NULL, 'Phosphotransferase, PolIIIAc domain-containing, putative', 199, NULL, NULL, 55142),
(55143, '3.90.400.10-FF-000014', NULL, 'Oligo-1,6-glucosidase', 78, NULL, NULL, 55143),
(55144, '3.30.160.60-FF-002064', NULL, 'Zinc finger protein 1078', 32, NULL, NULL, 55144),
(55145, '3.40.50.720-FF-000908', NULL, 'Methenyl tetrahydrofolate cyclohydrolase / NADP-dependent methylene H4F dehydrogenase', 123, NULL, NULL, 55145),
(55146, '1.10.246.190-FF-000006', NULL, 'Autophagy protein 5', 60, NULL, NULL, 55146),
(55147, '3.40.50.450-FF-000108', NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase LOG7', 106, NULL, NULL, 55147),
(55148, '3.40.50.300-FF-008062', NULL, 'Dynein heavy chain, cytoplasmic', 124, NULL, NULL, 55148),
(55149, '3.50.50.60-FF-001178', NULL, 'Uncharacterized protein', 214, NULL, NULL, 55149),
(55150, '1.25.40.10-FF-001355', NULL, 'Pentatricopeptide repeat-containing protein isoform A', 134, NULL, NULL, 55150),
(55151, '3.40.20.10-FF-000156', NULL, 'Actin binding protein (Eurofung)', 106, NULL, NULL, 55151),
(55152, '1.25.40.10-FF-000253', NULL, 'Pentatricopeptide repeat-containing protein', 146, NULL, NULL, 55152),
(55153, '3.10.120.10-FF-000033', NULL, 'Stearic acid desaturase, putative', 104, NULL, NULL, 55153),
(55154, '1.10.10.160-FF-000039', NULL, 'DNA helicase', 86, NULL, NULL, 55154),
(55155, '3.40.190.10-FF-000868', NULL, 'Predicted protein', 157, NULL, NULL, 55155),
(55156, '4.10.1240.10-FF-000013', NULL, 'Glucagon like peptide 1 receptor', 105, NULL, NULL, 55156);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(55157, '1.10.555.10-FF-000152', NULL, NULL, 215, NULL, NULL, 55157),
(55158, '3.40.190.80-FF-000057', NULL, 'Predicted protein', 130, NULL, NULL, 55158),
(55159, '3.30.40.10-FF-001315', NULL, 'E3 ubiquitin-protein ligase SPL2', 68, NULL, NULL, 55159),
(55160, '1.25.40.10-FF-003249', NULL, 'Uncharacterized protein', 174, NULL, NULL, 55160),
(55161, '3.20.20.150-FF-000079', NULL, 'Protein arginine N-methyltransferase skb1', 260, NULL, NULL, 55161),
(55162, '1.10.560.10-FF-000006', NULL, 'T-complex protein 1 subunit beta', 231, NULL, NULL, 55162),
(55163, '3.80.10.10-FF-004375', NULL, 'Predicted protein', 172, NULL, NULL, 55163),
(55164, '3.40.1110.10-FF-000391', NULL, NULL, 112, NULL, NULL, 55164),
(55165, '3.30.70.1230-FF-000147', NULL, 'Guanylyl cyclase, membrane', 213, NULL, NULL, 55165),
(55166, '2.60.120.970-FF-000080', NULL, 'Uncharacterized protein', 233, NULL, NULL, 55166),
(55167, '3.80.10.10-FF-004279', NULL, 'Protein CBR-LET-413', 257, NULL, NULL, 55167),
(55168, '1.10.560.10-FF-000102', NULL, 'T-complex protein 1 subunit eta', 59, NULL, NULL, 55168),
(55169, '1.10.472.80-FF-000272', NULL, NULL, 66, NULL, NULL, 55169),
(55170, '3.40.50.300-FF-007786', NULL, 'Uncharacterized protein', 50, NULL, NULL, 55170),
(55171, '3.40.50.300-FF-002901', NULL, 'Antimicrobial peptide ABC transporter ATPase', 260, NULL, NULL, 55171),
(55172, '3.40.50.1820-FF-001221', NULL, 'Uncharacterized protein', 358, NULL, NULL, 55172),
(55173, '3.80.10.10-FF-003531', NULL, 'Uncharacterized protein', 166, NULL, NULL, 55173),
(55174, '3.30.300.10-FF-000054', NULL, 'Uncharacterized protein', 130, NULL, NULL, 55174),
(55175, '2.30.30.90-FF-000008', NULL, 'Ferrous iron transport protein A', 76, NULL, NULL, 55175),
(55176, '3.10.50.40-FF-000123', NULL, 'Peptidylprolyl isomerase', 129, NULL, NULL, 55176),
(55177, '2.60.40.10-FF-005627', NULL, NULL, 97, NULL, NULL, 55177),
(55178, '1.25.40.20-FF-000610', NULL, 'Protein CBR-CNT-1', 152, NULL, NULL, 55178),
(55179, '3.40.50.300-FF-003857', NULL, 'RAB38, member RAS oncogene family', 122, NULL, NULL, 55179),
(55180, '3.40.50.1100-FF-000050', NULL, 'D-cysteine desulfhydrase 2, mitochondrial', 102, NULL, NULL, 55180),
(55181, '3.10.290.10-FF-000045', NULL, 'Pseudouridine synthase', 68, NULL, NULL, 55181),
(55182, '2.60.40.60-FF-000252', NULL, 'Cadherin related family member 2', 122, NULL, NULL, 55182),
(55183, '3.30.9.10-FF-000276', NULL, 'Uncharacterized protein', 86, NULL, NULL, 55183),
(55184, '2.60.40.640-FF-000022', NULL, 'Arrestin 1', 202, NULL, NULL, 55184),
(55185, '4.10.1060.10-FF-000044', NULL, 'Mitochondrial RNA binding complex 1 subunit', 35, NULL, NULL, 55185),
(55186, '3.20.10.10-FF-000061', NULL, 'Branched-chain-amino-acid aminotransferase', 101, NULL, NULL, 55186),
(55187, '3.30.300.20-FF-000057', NULL, 'Probable transcription termination protein NusA', 69, NULL, NULL, 55187),
(55188, '2.40.420.20-FF-000028', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 78, NULL, NULL, 55188),
(55189, '1.25.10.10-FF-003298', NULL, 'Phosphoinositide 3-kinase regulatory subunit 4-like Protein', 176, NULL, NULL, 55189),
(55190, '3.40.630.30-FF-000329', NULL, 'Acetyltransferase putative', 169, NULL, NULL, 55190),
(55191, '1.10.20.10-FF-000201', NULL, NULL, 114, NULL, NULL, 55191),
(55192, '3.40.1810.10-FF-000073', NULL, NULL, 75, NULL, NULL, 55192),
(55193, '2.130.10.10-FF-003806', NULL, 'Vacuolar protein sorting-associated protein 8', 308, NULL, NULL, 55193),
(55194, '2.170.260.10-FF-000026', NULL, 'Argonaute-like protein', 127, NULL, NULL, 55194),
(55195, '3.40.50.300-FF-007926', NULL, 'Uncharacterized protein', 174, NULL, NULL, 55195),
(55196, '3.40.1170.60-FF-000044', NULL, NULL, 49, NULL, NULL, 55196),
(55197, '3.10.110.10-FF-000201', NULL, 'Putative ubiquitin-conjugating enzyme family', 72, NULL, NULL, 55197),
(55198, '3.30.160.60-FF-000490', NULL, 'Zinc finger protein 605', 28, NULL, NULL, 55198),
(55199, '1.10.287.110-FF-000401', NULL, 'Predicted protein', 119, NULL, NULL, 55199),
(55200, '1.10.8.60-FF-000057', NULL, 'AAA family ATPase, CDC48 subfamily', 95, NULL, NULL, 55200);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(55201, '2.40.10.120-FF-000022', NULL, 'Uncharacterized protein', 159, NULL, NULL, 55201),
(55202, '3.10.450.240-FF-000024', NULL, 'Uncharacterized protein', 189, NULL, NULL, 55202),
(55203, '1.10.10.10-FF-001555', NULL, 'Uncharacterized protein', 76, NULL, NULL, 55203),
(55204, '3.90.640.80-FF-000002', NULL, 'Poly [ADP-ribose] polymerase', 127, NULL, NULL, 55204),
(55205, '2.60.40.10-FF-002631', NULL, 'Envelope glycoprotein C', 98, NULL, NULL, 55205),
(55206, '3.40.250.10-FF-000244', NULL, 'Uncharacterized protein', 103, NULL, NULL, 55206),
(55207, '1.25.70.10-FF-000081', NULL, NULL, 216, NULL, NULL, 55207),
(55208, '1.10.287.470-FF-000037', NULL, 'Efflux transporter periplasmic adaptor subunit', 74, NULL, NULL, 55208),
(55209, '1.20.1110.10-FF-000273', NULL, NULL, 87, NULL, NULL, 55209),
(55210, '3.90.640.90-FF-000005', NULL, 'Putative b-cell translocation protein 1', 124, NULL, NULL, 55210),
(55211, '1.10.246.20-FF-000009', NULL, 'Mediator of RNA polymerase II transcription subunit 15a-like protein', 69, NULL, NULL, 55211),
(55212, '1.10.150.50-FF-000055', NULL, 'Sterile alpha motif domain containing 5', 67, NULL, NULL, 55212),
(55213, '1.10.10.10-FF-002044', NULL, 'Transcriptional regulator, putative', 75, NULL, NULL, 55213),
(55214, '3.30.160.60-FF-005627', NULL, NULL, 22, NULL, NULL, 55214),
(55215, '3.40.50.300-FF-006263', NULL, 'SNF2 family N-terminal domain containing protein', 18, NULL, NULL, 55215),
(55216, '1.20.1270.10-FF-000099', NULL, 'Heat shock 70 kDa protein-related protein', 124, NULL, NULL, 55216),
(55217, '3.30.70.330-FF-001635', NULL, NULL, 124, NULL, NULL, 55217),
(55218, '2.130.10.10-FF-001671', NULL, 'WD domain containing protein', 60, NULL, NULL, 55218),
(55219, '3.90.1720.10-FF-000004', NULL, 'Bifunctional glutathionylspermidine synthetase/amidase', 200, NULL, NULL, 55219),
(55220, '3.40.30.10-FF-000437', NULL, 'Phosducin-like protein 1', 131, NULL, NULL, 55220),
(55221, '1.10.506.10-FF-000044', NULL, 'Plexin A3', 410, NULL, NULL, 55221),
(55222, '2.60.40.650-FF-000008', NULL, 'Molybdopterin binding oxidoreductase', 139, NULL, NULL, 55222),
(55223, '1.25.40.20-FF-001919', NULL, 'Ankyrin-repeat protein, putative', 151, NULL, NULL, 55223),
(55224, '3.30.70.330-FF-001309', NULL, 'Serrate RNA effector molecule homolog B', 112, NULL, NULL, 55224),
(55225, '1.10.630.10-FF-000670', NULL, 'Os02g0503800 protein', 176, NULL, NULL, 55225),
(55226, '2.60.120.330-FF-000236', NULL, 'Uncharacterized protein', 82, NULL, NULL, 55226),
(55227, '1.10.540.10-FF-000106', NULL, 'Putative oxidoreductase involved in 2-Alkyl-4-hydroxymethylfuran-3-carboxylic acid biosynthesis, MmfH', 101, NULL, NULL, 55227),
(55228, '1.20.5.170-FF-000188', NULL, 'X-box Binding Protein homolog', 61, NULL, NULL, 55228),
(55229, '1.10.510.10-FF-001706', NULL, 'Protein kinase, putative', 351, NULL, NULL, 55229),
(55230, '3.40.50.410-FF-000355', NULL, 'Uncharacterized protein', 81, NULL, NULL, 55230),
(55231, '3.90.550.10-FF-000143', NULL, 'Dolichyl-phosphate beta-glucosyltransferase, putative', 279, NULL, NULL, 55231),
(55232, '3.50.50.60-FF-001206', NULL, 'Uncharacterized protein', 373, NULL, NULL, 55232),
(55233, '2.60.40.640-FF-000005', NULL, 'Arrestin domain-containing protein 3', 144, NULL, NULL, 55233),
(55234, '3.90.1410.10-FF-000020', NULL, 'Hypothetical_protein_-_conserved', 302, NULL, NULL, 55234),
(55235, '2.40.50.140-FF-000789', NULL, NULL, 66, NULL, NULL, 55235),
(55236, '3.30.1330.30-FF-000112', NULL, 'Uncharacterized protein', 81, NULL, NULL, 55236),
(55237, '1.25.40.10-FF-001916', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 145, NULL, NULL, 55237),
(55238, '3.80.10.10-FF-001502', NULL, 'EIN3-binding F-box protein 1', 120, NULL, NULL, 55238),
(55239, '3.30.40.10-FF-001641', NULL, 'Uncharacterized protein', 61, NULL, NULL, 55239),
(55240, '1.20.1070.10-FF-000797', NULL, 'Uncharacterized protein', 312, NULL, NULL, 55240),
(55241, '2.60.40.630-FF-000002', NULL, 'Signal transducer and activator of transcription', 139, NULL, NULL, 55241),
(55242, '1.10.8.1120-FF-000007', NULL, 'Predicted protein', 35, NULL, NULL, 55242);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(55243, '2.10.25.10-FF-000794', NULL, 'Fibrillin-1', 36, NULL, NULL, 55243),
(55244, '2.40.240.10-FF-000039', NULL, 'Glutamate-tRNA ligase / Glutamine-tRNA ligase', 77, NULL, NULL, 55244),
(55245, '3.90.260.10-FF-000042', NULL, 'Uncharacterized protein', 297, NULL, NULL, 55245),
(55246, '1.25.40.10-FF-003816', NULL, 'Predicted protein', 134, NULL, NULL, 55246),
(55247, '1.20.58.80-FF-000038', NULL, 'AGAP001945-PA', 96, NULL, NULL, 55247),
(55248, '3.40.50.300-FF-005448', NULL, 'Uncharacterized protein B13D15.290', 246, NULL, NULL, 55248),
(55249, '3.90.650.10-FF-000078', NULL, 'Uncharacterized protein', 85, NULL, NULL, 55249),
(55250, '1.10.238.10-FF-000342', NULL, 'EF-hand calcium binding domain 6', 103, NULL, NULL, 55250),
(55251, '1.25.40.10-FF-003480', NULL, 'Pentatricopeptide repeat-containing protein', 92, NULL, NULL, 55251),
(55252, '2.40.50.140-FF-001065', NULL, NULL, 96, NULL, NULL, 55252),
(55253, '3.40.50.1000-FF-000132', NULL, 'HAD family hydrolase', 141, NULL, NULL, 55253),
(55254, '2.10.90.10-FF-000102', NULL, 'Uncharacterized protein', 161, NULL, NULL, 55254),
(55255, '2.130.10.10-FF-002154', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 197, NULL, NULL, 55255),
(55256, '4.10.400.10-FF-000321', NULL, 'Uncharacterized protein', 44, NULL, NULL, 55256),
(55257, '3.20.20.330-FF-000026', NULL, 'Uncharacterized protein', 440, NULL, NULL, 55257),
(55258, '3.20.20.80-FF-000661', NULL, 'Uncharacterized protein', 52, NULL, NULL, 55258),
(55259, '3.40.50.150-FF-000030', NULL, 'Carboxy-S-adenosyl-L-methionine synthase', 230, NULL, NULL, 55259),
(55260, '3.40.50.300-FF-004037', NULL, 'Disks large homolog 1', 133, NULL, NULL, 55260),
(55261, '3.40.50.300-FF-000440', NULL, 'Ras-related protein Rab-30', 187, NULL, NULL, 55261),
(55262, '3.30.70.380-FF-000003', NULL, 'Phenylalanine--tRNA ligase chloroplastic/mitochondrial', 95, NULL, NULL, 55262),
(55263, '1.10.10.10-FF-001785', NULL, 'Transcriptional regulator, MarR family', 181, NULL, NULL, 55263),
(55264, '2.40.100.10-FF-000113', NULL, 'Peptidyl-prolyl cis-trans isomerase', 176, NULL, NULL, 55264),
(55265, '3.40.50.1010-FF-000135', NULL, 'Unplaced genomic scaffold supercont1.6, whole genome shotgun sequence', 101, NULL, NULL, 55265),
(55266, '1.10.10.10-FF-002061', NULL, 'Predicted protein', 123, NULL, NULL, 55266),
(55267, '3.40.605.10-FF-000029', NULL, 'Aldehyde dehydrogenase, mitochondrial', 303, NULL, NULL, 55267),
(55268, '3.30.530.20-FF-000080', NULL, 'Abscisic acid receptor PYL3', 190, NULL, NULL, 55268),
(55269, '2.130.10.10-FF-000260', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 202, NULL, NULL, 55269),
(55270, '2.60.120.380-FF-000009', NULL, 'Calpain-6', 140, NULL, NULL, 55270),
(55271, '2.70.50.30-FF-000024', NULL, NULL, 130, NULL, NULL, 55271),
(55272, '3.30.720.220-FF-000002', NULL, 'Protein JTB', 53, NULL, NULL, 55272),
(55273, '2.10.25.10-FF-000581', NULL, 'Axotactin, isoform F', 40, NULL, NULL, 55273),
(55274, '1.10.510.10-FF-000604', NULL, 'AGC protein kinase', 72, NULL, NULL, 55274),
(55275, '4.10.60.10-FF-000005', NULL, 'E3 ubiquitin-protein ligase RBBP6', 52, NULL, NULL, 55275),
(55276, '1.10.8.10-FF-000284', NULL, 'UBA/TS-N domain containing protein, putative', 74, NULL, NULL, 55276),
(55277, '2.130.10.10-FF-001878', NULL, 'Uncharacterized protein', 278, NULL, NULL, 55277),
(55278, '3.90.70.10-FF-000123', NULL, 'Ubiquitinyl hydrolase 1', 237, NULL, NULL, 55278),
(55279, '3.60.40.10-FF-000229', NULL, 'Predicted protein', 293, NULL, NULL, 55279),
(55280, '2.30.30.490-FF-000038', NULL, 'AT-rich interactive domain-containing protein 5B', 142, NULL, NULL, 55280),
(55281, '1.20.1640.10-FF-000026', NULL, 'Dispatched RND transporter family member 2', 163, NULL, NULL, 55281),
(55282, '1.10.287.310-FF-000017', NULL, 'Ribosomal L29 family protein', 38, NULL, NULL, 55282),
(55283, '1.20.20.20-FF-000001', NULL, 'Putative exported protein', 101, NULL, NULL, 55283),
(55284, '2.60.120.370-FF-000006', NULL, 'YhcH/YjgK/YiaL family protein', 148, NULL, NULL, 55284),
(55285, '3.30.160.60-FF-004216', NULL, NULL, 31, NULL, NULL, 55285);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(55286, '2.10.25.10-FF-001070', NULL, 'Protein CBR-TAG-53', 54, NULL, NULL, 55286),
(55287, '3.30.230.80-FF-000035', NULL, 'Endoplasmin', 103, NULL, NULL, 55287),
(55288, '3.20.20.140-FF-000076', NULL, 'Dihydropyrimidinase like 2', 373, NULL, NULL, 55288),
(55289, '1.10.10.2010-FF-000010', NULL, NULL, 38, NULL, NULL, 55289),
(55290, '3.30.830.10-FF-000133', NULL, 'Metalloenzyme, LuxS/M16 peptidase-like protein', 229, NULL, NULL, 55290),
(55291, '4.10.400.10-FF-000096', NULL, 'Transmembrane serine protease 6', 37, NULL, NULL, 55291),
(55292, '3.40.190.290-FF-000011', NULL, 'LysR family transcriptional regulator', 205, NULL, NULL, 55292),
(55293, '3.30.450.50-FF-000037', NULL, 'SNARE domain-containing protein', 130, NULL, NULL, 55293),
(55294, '1.25.40.70-FF-000029', NULL, 'phosphatidylinositol 4-kinase beta 1-like', 93, NULL, NULL, 55294),
(55295, '1.10.510.10-FF-003477', NULL, NULL, 268, NULL, NULL, 55295),
(55296, '2.30.29.30-FF-001229', NULL, 'Nucleoside diphosphate kinase', 116, NULL, NULL, 55296),
(55297, '1.20.5.110-FF-000226', NULL, 'Probable syntaxin-8B', 63, NULL, NULL, 55297),
(55298, '3.40.1030.10-FF-000013', NULL, 'Uncharacterized protein', 46, NULL, NULL, 55298),
(55299, '1.20.1250.20-FF-000786', NULL, 'MFS multidrug transporter, putative', 233, NULL, NULL, 55299),
(55300, '2.60.40.790-FF-000022', NULL, 'Protein SHQ1 homolog', 126, NULL, NULL, 55300),
(55301, '3.40.710.10-FF-000049', NULL, 'Putative D-alanyl-D-alanine carboxypeptidase', 388, NULL, NULL, 55301),
(55302, '3.90.228.10-FF-000041', NULL, 'Poly [ADP-ribose] polymerase', 201, NULL, NULL, 55302),
(55303, '2.130.10.10-FF-005594', NULL, 'Predicted protein', 196, NULL, NULL, 55303),
(55304, '2.60.40.1180-FF-000226', NULL, 'Putative glucosylceramidase/O-glycosyl hydrolase', 68, NULL, NULL, 55304),
(55305, '3.40.50.11980-FF-000018', NULL, 'Uncharacterized protein', 183, NULL, NULL, 55305),
(55306, '2.40.50.100-FF-000007', NULL, 'Cytochrome f', 59, NULL, NULL, 55306),
(55307, '3.40.50.10420-FF-000028', NULL, '5-formyltetrahydrofolate cyclo-ligase', 184, NULL, NULL, 55307),
(55308, '3.30.930.10-FF-000422', NULL, 'Lysine--tRNA ligase', 374, NULL, NULL, 55308),
(55309, '3.40.1110.10-FF-000065', NULL, 'Copper-transporting ATPase RAN1', 94, NULL, NULL, 55309),
(55310, '3.40.50.2300-FF-001376', NULL, NULL, 122, NULL, NULL, 55310),
(55311, '1.10.405.10-FF-000023', NULL, 'Uncharacterized protein', 104, NULL, NULL, 55311),
(55312, '1.25.40.180-FF-000283', NULL, NULL, 154, NULL, NULL, 55312),
(55313, '3.40.710.10-FF-000145', NULL, 'Penicillin-binding protein', 400, NULL, NULL, 55313),
(55314, '1.10.510.10-FF-001577', NULL, 'Uncharacterized protein', 259, NULL, NULL, 55314),
(55315, '2.130.10.10-FF-004312', NULL, 'Uncharacterized protein', 112, NULL, NULL, 55315),
(55316, '3.30.450.40-FF-000034', NULL, 'Sensor domain-containing diguanylate cyclase', 189, NULL, NULL, 55316),
(55317, '1.10.1780.10-FF-000016', NULL, 'Protein SMAX1-LIKE 2', 167, NULL, NULL, 55317),
(55318, '3.80.10.10-FF-001406', NULL, 'Uncharacterized protein', 171, NULL, NULL, 55318),
(55319, '3.30.420.10-FF-000552', NULL, NULL, 62, NULL, NULL, 55319),
(55320, '3.40.50.10330-FF-000092', NULL, 'Predicted protein', 160, NULL, NULL, 55320),
(55321, '3.90.70.120-FF-000002', NULL, 'Large tegument protein deneddylase', 213, NULL, NULL, 55321),
(55322, '2.60.40.10-FF-004216', NULL, NULL, 73, NULL, NULL, 55322),
(55323, '2.60.40.10-FF-001575', NULL, 'Uncharacterized protein, isoform B', 113, NULL, NULL, 55323),
(55324, '3.90.79.10-FF-000210', NULL, 'Adenine DNA glycosylase', 129, NULL, NULL, 55324),
(55325, '3.40.50.1360-FF-000009', NULL, 'Probable 6-phosphogluconolactonase', 253, NULL, NULL, 55325),
(55326, '1.20.1250.20-FF-001500', NULL, 'Uncharacterized protein', 417, NULL, NULL, 55326),
(55327, '3.90.1480.20-FF-000055', NULL, 'Uncharacterized protein', 158, NULL, NULL, 55327),
(55328, '1.10.287.70-FF-000439', NULL, 'Uncharacterized protein', 157, NULL, NULL, 55328),
(55329, '1.20.120.350-FF-000241', NULL, NULL, 90, NULL, NULL, 55329),
(55330, '2.60.40.10-FF-001788', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', 88, NULL, NULL, 55330);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(55331, '1.20.1720.10-FF-000078', NULL, NULL, 209, NULL, NULL, 55331),
(55332, '4.10.1240.50-FF-000013', NULL, 'Uncharacterized protein', 131, NULL, NULL, 55332),
(55333, '2.60.40.10-FF-002064', NULL, 'Basal cell adhesion molecule', 116, NULL, NULL, 55333),
(55334, '3.30.160.60-FF-000164', NULL, 'Fez family zinc finger protein 2', 27, NULL, NULL, 55334),
(55335, '3.30.60.30-FF-000119', NULL, 'Predicted protein', 49, NULL, NULL, 55335),
(55336, '2.30.30.140-FF-000068', NULL, 'E3 ubiquitin-protein ligase UHRF1 isoform 1', 85, NULL, NULL, 55336),
(55337, '3.60.21.10-FF-000303', NULL, 'Tartrate-resistant acid phosphatase type 5', 304, NULL, NULL, 55337),
(55338, '1.10.565.10-FF-000080', NULL, 'Nuclear Hormone Receptor family', 237, NULL, NULL, 55338),
(55339, '2.30.29.30-FF-001022', NULL, 'Uncharacterized protein', 100, NULL, NULL, 55339),
(55340, '3.10.20.90-FF-000271', NULL, 'Type VII secretion integral membrane protein EccD', 86, NULL, NULL, 55340),
(55341, '3.40.50.10810-FF-000151', NULL, 'Snf2-related CREBBP activator protein', 83, NULL, NULL, 55341),
(55342, '1.10.150.900-FF-000004', NULL, 'Carboxypeptidase PM20D1.2', 82, NULL, NULL, 55342),
(55343, '1.20.1440.90-FF-000012', NULL, NULL, 124, NULL, NULL, 55343),
(55344, '3.90.70.130-FF-000005', NULL, 'Predicted protein', 124, NULL, NULL, 55344),
(55345, '4.10.1240.10-FF-000030', NULL, 'Vasoactive intestinal polypeptide receptor', 49, NULL, NULL, 55345),
(55346, '2.60.40.10-FF-000265', NULL, 'Tyrosine-protein kinase receptor', 123, NULL, NULL, 55346),
(55347, '1.10.3720.10-FF-000041', NULL, 'Inner membrane ABC transporter permease ycjO', 237, NULL, NULL, 55347),
(55348, '3.30.420.10-FF-000097', NULL, 'Ribonuclease H1', 151, NULL, NULL, 55348),
(55349, '1.25.10.10-FF-002241', NULL, 'Uncharacterized protein', 379, NULL, NULL, 55349),
(55350, '3.30.40.10-FF-001203', NULL, 'E3 SUMO-protein ligase MMS21', 92, NULL, NULL, 55350),
(55351, '3.30.505.10-FF-000232', NULL, NULL, 87, NULL, NULL, 55351),
(55352, '1.10.10.10-FF-001993', NULL, 'H-N-H endonuclease F-TflIV', 42, NULL, NULL, 55352),
(55353, '2.130.10.10-FF-003469', NULL, 'YALI0A03883p', 366, NULL, NULL, 55353),
(55354, '3.40.50.360-FF-000076', NULL, 'Flavodoxin/Radical SAM superfamily/Wyosine base formation, putative', 166, NULL, NULL, 55354),
(55355, '3.40.50.300-FF-007573', NULL, 'Putative mitochondrial ATP-dependent helicase irc3', 181, NULL, NULL, 55355),
(55356, '3.90.190.10-FF-000486', NULL, 'Uncharacterized protein', 161, NULL, NULL, 55356),
(55357, '3.40.50.2020-FF-000090', NULL, 'Protein CBG07940', 204, NULL, NULL, 55357),
(55358, '2.30.30.1020-FF-000045', NULL, NULL, 192, NULL, NULL, 55358),
(55359, '3.30.200.20-FF-001516', NULL, 'Uncharacterized protein', 105, NULL, NULL, 55359),
(55360, '4.10.410.10-FF-000041', NULL, 'Protein CBR-MLT-11', 67, NULL, NULL, 55360),
(55361, '1.20.1110.10-FF-000155', NULL, NULL, 213, NULL, NULL, 55361),
(55362, '3.30.565.10-FF-000241', NULL, 'GAF domain-containing protein', 132, NULL, NULL, 55362),
(55363, '3.30.200.20-FF-002022', NULL, 'Uncharacterized protein', 93, NULL, NULL, 55363),
(55364, '3.30.200.20-FF-000898', NULL, 'Mitogen-activated protein kinase', 94, NULL, NULL, 55364),
(55365, '4.10.400.10-FF-000113', NULL, 'Low-density lipoprotein receptor-related protein 8', 44, NULL, NULL, 55365),
(55366, '3.30.70.80-FF-000051', NULL, 'Serine protease, subtilase family', 72, NULL, NULL, 55366),
(55367, '1.10.510.10-FF-002420', NULL, 'Uncharacterized protein', 303, NULL, NULL, 55367),
(55368, '1.10.510.10-FF-001914', NULL, 'Uncharacterized protein', 134, NULL, NULL, 55368),
(55369, '3.30.930.10-FF-000181', NULL, 'Holocarboxylase synthetase 2', 204, NULL, NULL, 55369),
(55370, '3.40.50.150-FF-000243', NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', 326, NULL, NULL, 55370),
(55371, '1.10.630.10-FF-000439', NULL, 'Uncharacterized protein', 265, NULL, NULL, 55371),
(55372, '2.130.10.10-FF-005723', NULL, 'Uncharacterized protein', 137, NULL, NULL, 55372),
(55373, '1.50.40.10-FF-000532', NULL, 'Predicted protein', 156, NULL, NULL, 55373),
(55374, '3.80.10.10-FF-000788', NULL, 'chaoptin', 167, NULL, NULL, 55374);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(55375, '2.170.300.10-FF-000087', NULL, 'Uncharacterized protein', 105, NULL, NULL, 55375),
(55376, '2.40.50.100-FF-000119', NULL, 'GD24941', 87, NULL, NULL, 55376),
(55377, '3.40.50.1000-FF-000345', NULL, 'Cat eye syndrome critical region protein', 159, NULL, NULL, 55377),
(55378, '3.40.50.720-FF-000785', NULL, 'Polyketide synthase Pks12', 174, NULL, NULL, 55378),
(55379, '1.10.132.10-FF-000006', NULL, 'DNA topoisomerase type IB small subunit', 137, NULL, NULL, 55379),
(55380, '1.10.3380.10-FF-000071', NULL, 'GH18520p', 43, NULL, NULL, 55380),
(55381, '1.10.1200.270-FF-000011', NULL, 'Uncharacterized protein', 115, NULL, NULL, 55381),
(55382, '1.10.10.750-FF-000025', NULL, 'AGAP002392-PA-like protein', 59, NULL, NULL, 55382),
(55383, '3.30.40.10-FF-001091', NULL, 'PHD-finger domain containing protein', 76, NULL, NULL, 55383),
(55384, '1.10.30.50-FF-000011', NULL, 'Zinc finger, RAN-binding domain containing 3', 95, NULL, NULL, 55384),
(55385, '3.80.10.10-FF-004167', NULL, 'PeroXidasiN (Drosophila peroxidase) homolog', 100, NULL, NULL, 55385),
(55386, '1.10.472.80-FF-000160', NULL, NULL, 88, NULL, NULL, 55386),
(55387, '3.40.30.10-FF-000780', NULL, 'Ubx domain containing protein, putative', 130, NULL, NULL, 55387),
(55388, '3.40.50.2300-FF-001163', NULL, NULL, 211, NULL, NULL, 55388),
(55389, '1.20.1070.10-FF-001062', NULL, 'Predicted protein', 126, NULL, NULL, 55389),
(55390, '3.80.10.10-FF-004487', NULL, 'Uncharacterized protein', 111, NULL, NULL, 55390),
(55391, '1.25.40.10-FF-003693', NULL, 'Uncharacterized protein', 204, NULL, NULL, 55391),
(55392, '1.10.287.110-FF-000064', NULL, 'Molecular chaperone DnaJ', 118, NULL, NULL, 55392),
(55393, '3.80.10.10-FF-002929', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 152, NULL, NULL, 55393),
(55394, '3.30.9.10-FF-000304', NULL, 'Predicted protein', 105, NULL, NULL, 55394),
(55395, '1.10.510.10-FF-001689', NULL, 'Protein kinase, putative', 156, NULL, NULL, 55395),
(55396, '3.40.50.2300-FF-001264', NULL, NULL, 211, NULL, NULL, 55396),
(55397, '3.30.40.10-FF-001192', NULL, 'RING/U-box superfamily protein', 64, NULL, NULL, 55397),
(55398, '1.10.287.130-FF-000183', NULL, 'Histidine kinase', 74, NULL, NULL, 55398),
(55399, '1.20.1110.10-FF-000060', NULL, 'Calcium-transporting ATPase', 264, NULL, NULL, 55399),
(55400, '1.20.1070.10-FF-000808', NULL, 'AKH/corazonin-related peptide', 166, NULL, NULL, 55400),
(55401, '2.130.10.10-FF-004520', NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', 231, NULL, NULL, 55401),
(55402, '3.30.810.10-FF-000020', NULL, 'Putative phosphatidylinositol 4-phosphate 5-kinase 11', 188, NULL, NULL, 55402),
(55403, '1.25.40.10-FF-001563', NULL, 'Clustered mitochondria protein homolog', 149, NULL, NULL, 55403),
(55404, '3.30.40.10-FF-002288', NULL, 'Uncharacterized protein', 43, NULL, NULL, 55404),
(55405, '2.130.10.10-FF-003582', NULL, 'Uncharacterized protein', 195, NULL, NULL, 55405),
(55406, '3.30.160.60-FF-000714', NULL, 'Zinc finger protein 335', 26, NULL, NULL, 55406),
(55407, '3.30.70.980-FF-000060', NULL, 'Probable transcriptional regulatory protein glr2507', 74, NULL, NULL, 55407),
(55408, '1.10.510.10-FF-002307', NULL, NULL, 223, NULL, NULL, 55408),
(55409, '2.130.10.10-FF-004200', NULL, 'Predicted protein', 157, NULL, NULL, 55409),
(55410, '3.30.2410.10-FF-000056', NULL, 'Neural precursor cell expressed, developmentally down-regulated 4, E3 ubiquitin protein ligase', 63, NULL, NULL, 55410),
(55411, '3.30.930.10-FF-000068', NULL, 'eIF-2-alpha kinase GCN2', 337, NULL, NULL, 55411),
(55412, '1.10.760.10-FF-000100', NULL, 'Lipoprotein cytochrome c, 1 heme-binding site', 102, NULL, NULL, 55412),
(55413, '3.90.190.10-FF-000059', NULL, 'Dual specificity phosphatase 13, isoform CRA_b', 173, NULL, NULL, 55413),
(55414, '3.10.580.10-FF-000034', NULL, 'Glycine betaine/choline ABC transporter ATP-binding protein', 112, NULL, NULL, 55414),
(55415, '3.40.50.720-FF-001723', NULL, 'Predicted protein', 141, NULL, NULL, 55415),
(55416, '3.40.1800.20-FF-000019', NULL, 'Zeste-white 5', 79, NULL, NULL, 55416);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(55417, '1.20.1740.10-FF-000186', NULL, 'Uncharacterized protein', 268, NULL, NULL, 55417),
(55418, '2.60.120.10-FF-000806', NULL, 'Uncharacterized protein', 119, NULL, NULL, 55418),
(55419, '3.40.1280.30-FF-000037', NULL, 'Uncharacterized protein', 118, NULL, NULL, 55419),
(55420, '1.10.630.10-FF-000344', NULL, 'Cytochrome P450, family 8, subfamily B, polypeptide 1', 139, NULL, NULL, 55420),
(55421, '3.80.10.10-FF-001614', NULL, 'Uncharacterized protein, isoform B', 521, NULL, NULL, 55421),
(55422, '3.40.50.1000-FF-000250', NULL, 'Probable cation-transporting ATPase HI_0290', 136, NULL, NULL, 55422),
(55423, '1.10.357.140-FF-000039', NULL, 'Naringenin 8-dimethylallyltransferase 2, chloroplastic', 156, NULL, NULL, 55423),
(55424, '3.30.365.10-FF-000035', NULL, 'Nicotinate dehydrogenase subunit B', 143, NULL, NULL, 55424),
(55425, '3.30.505.10-FF-000119', NULL, 'Tyrosine-protein kinase', 103, NULL, NULL, 55425),
(55426, '1.25.10.10-FF-001527', NULL, 'Probable serine/threonine-protein kinase tsuA', 126, NULL, NULL, 55426),
(55427, '2.30.30.100-FF-000197', NULL, 'Small nuclear ribonucleoprotein Sm D2', 101, NULL, NULL, 55427),
(55428, '2.60.40.10-FF-000170', NULL, 'Kirre like nephrin family adhesion molecule 3', 102, NULL, NULL, 55428),
(55429, '3.30.710.10-FF-000439', NULL, 'Predicted protein', 176, NULL, NULL, 55429),
(55430, '3.40.50.1000-FF-000019', NULL, 'Mitochondrial import inner membrane translocase subunit TIM50', 183, NULL, NULL, 55430),
(55431, '2.10.25.10-FF-000468', NULL, 'Crumbs cell polarity complex component 1', 39, NULL, NULL, 55431),
(55432, '2.60.40.10-FF-005745', NULL, NULL, 104, NULL, NULL, 55432),
(55433, '3.40.50.1010-FF-000253', NULL, NULL, 147, NULL, NULL, 55433),
(55434, '2.70.98.30-FF-000033', NULL, 'Uncharacterized protein', 187, NULL, NULL, 55434),
(55435, '1.20.1250.20-FF-001051', NULL, 'Citrate-proton symporter', 209, NULL, NULL, 55435),
(55436, '1.10.150.650-FF-000007', NULL, 'PHP domain protein', 72, NULL, NULL, 55436),
(55437, '3.40.50.1820-FF-000956', NULL, 'Hydrolase, alpha/beta fold family, putative', 289, NULL, NULL, 55437),
(55438, '3.30.505.10-FF-000024', NULL, 'Vav guanine nucleotide exchange factor 2', 123, NULL, NULL, 55438),
(55439, '1.20.1560.10-FF-000868', NULL, 'Uncharacterized protein', 134, NULL, NULL, 55439),
(55440, '2.60.40.10-FF-003716', NULL, NULL, 88, NULL, NULL, 55440),
(55441, '3.40.50.12800-FF-000001', NULL, 'Penicillin-binding protein 1b', 69, NULL, NULL, 55441),
(55442, '3.20.20.140-FF-000317', NULL, 'Putative formylmethanofuran dehydrogenase subunit A', 80, NULL, NULL, 55442),
(55443, '3.60.110.10-FF-000078', NULL, NULL, 274, NULL, NULL, 55443),
(55444, '2.60.40.150-FF-000066', NULL, 'Extended synaptotagmin-2', 119, NULL, NULL, 55444),
(55445, '3.40.50.140-FF-000009', NULL, 'DNA topoisomerase I', 154, NULL, NULL, 55445),
(55446, '3.30.160.60-FF-006015', NULL, NULL, 33, NULL, NULL, 55446),
(55447, '1.20.5.690-FF-000006', NULL, 'Importin subunit alpha', 42, NULL, NULL, 55447),
(55448, '1.10.8.60-FF-000169', NULL, '26S proteasome ATPase subunit S4', 81, NULL, NULL, 55448),
(55449, '3.30.420.40-FF-000431', NULL, 'Protein CBG18255', 226, NULL, NULL, 55449),
(55450, '2.60.120.10-FF-000453', NULL, 'Mannose-6-phosphate isomerase', 99, NULL, NULL, 55450),
(55451, '3.80.10.10-FF-003290', NULL, 'Uncharacterized protein', 84, NULL, NULL, 55451),
(55452, '2.20.50.20-FF-000006', NULL, 'Vitellogenin 7', 45, NULL, NULL, 55452),
(55453, '3.30.1130.10-FF-000012', NULL, 'GTP cyclohydrolase 1', 132, NULL, NULL, 55453),
(55454, '1.10.490.30-FF-000001', NULL, 'Colicin N', 200, NULL, NULL, 55454),
(55455, '1.20.1310.10-FF-000142', NULL, NULL, 101, NULL, NULL, 55455),
(55456, '1.10.1740.10-FF-000019', NULL, 'DNA-directed RNA polymerase sigma-70 factor', 94, NULL, NULL, 55456),
(55457, '3.30.530.20-FF-000074', NULL, 'Protein CBG02248', 236, NULL, NULL, 55457),
(55458, '3.30.160.20-FF-000068', NULL, 'RNA polymerase II C-terminal domain phosphatase-like 1', 78, NULL, NULL, 55458),
(55459, '2.40.100.10-FF-000001', NULL, 'Peptidyl-prolyl cis-trans isomerase', 184, NULL, NULL, 55459);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(55460, '1.20.1270.60-FF-000086', NULL, 'Rho GTPase-activating protein 10', 156, NULL, NULL, 55460),
(55461, '1.20.58.1100-FF-000004', NULL, 'Conserved protein', 145, NULL, NULL, 55461),
(55462, '2.130.10.10-FF-000030', NULL, 'Actin-related protein 2/3 complex subunit', 370, NULL, NULL, 55462),
(55463, '2.10.230.10-FF-000023', NULL, 'dnaJ homolog subfamily A member 2', 47, NULL, NULL, 55463),
(55464, '3.10.450.240-FF-000018', NULL, 'Uncharacterized protein', 201, NULL, NULL, 55464),
(55465, '3.30.9.10-FF-000068', NULL, 'N,N-dimethylglycine oxidase', 181, NULL, NULL, 55465),
(55466, '3.30.160.60-FF-000613', NULL, 'zinc finger protein 462 isoform X1', 82, NULL, NULL, 55466),
(55467, '1.20.58.1540-FF-000001', NULL, 'SRC kinase signaling inhibitor 1', 125, NULL, NULL, 55467),
(55468, '3.90.70.10-FF-000235', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 101, NULL, NULL, 55468),
(55469, '3.40.50.300-FF-007359', NULL, 'Exodeoxyribonuclease v gamma chain', 120, NULL, NULL, 55469),
(55470, '1.20.5.170-FF-000194', NULL, 'Sodium/potassium-transporting ATPase subunit beta', 59, NULL, NULL, 55470),
(55471, '1.10.1420.10-FF-000080', NULL, 'DNA mismatch repair protein MSH5', 222, NULL, NULL, 55471),
(55472, '2.70.98.20-FF-000030', NULL, 'Amine oxidase', 289, NULL, NULL, 55472),
(55473, '3.40.50.150-FF-001648', NULL, NULL, 185, NULL, NULL, 55473),
(55474, '2.60.40.10-FF-003699', NULL, NULL, 101, NULL, NULL, 55474),
(55475, '1.50.40.10-FF-000189', NULL, 'Mitochondrial ornithine transporter 1-like protein', 115, NULL, NULL, 55475),
(55476, '2.130.10.10-FF-003683', NULL, 'Uncharacterized protein', 119, NULL, NULL, 55476),
(55477, '2.60.40.10-FF-005392', NULL, NULL, 53, NULL, NULL, 55477),
(55478, '3.30.70.330-FF-001074', NULL, 'Splicing factor, arginine/serine-rich 7', 76, NULL, NULL, 55478),
(55479, '3.90.190.10-FF-000391', NULL, 'Cyclin-G-associated kinase', 172, NULL, NULL, 55479),
(55480, '3.30.160.60-FF-005178', NULL, NULL, 77, NULL, NULL, 55480),
(55481, '1.25.10.10-FF-000212', NULL, 'Cell division control protein', 189, NULL, NULL, 55481),
(55482, '3.40.50.300-FF-003649', NULL, 'Conjugal transfer protein TraD', 175, NULL, NULL, 55482),
(55483, '3.30.450.200-FF-000024', NULL, NULL, 44, NULL, NULL, 55483),
(55484, '1.10.3720.10-FF-000142', NULL, 'Sugar-transport integral membrane protein ABC transporter', 246, NULL, NULL, 55484),
(55485, '1.10.640.10-FF-000058', NULL, 'Peroxinectin, putative', 247, NULL, NULL, 55485),
(55486, '3.30.1360.120-FF-000017', NULL, 'Glycine cleavage system T protein', 152, NULL, NULL, 55486),
(55487, '1.50.40.10-FF-000105', NULL, 'Nicotinamide adenine dinucleotide transporter 1, chloroplastic', 111, NULL, NULL, 55487),
(55488, '3.40.1190.20-FF-000174', NULL, NULL, 120, NULL, NULL, 55488),
(55489, '3.40.50.12780-FF-000169', NULL, 'Putative acetyl-CoA synethetase', 507, NULL, NULL, 55489),
(55490, '1.20.1280.50-FF-000044', NULL, 'F-box/WD repeat-containing protein 9 isoform X2', 58, NULL, NULL, 55490),
(55491, '3.10.580.10-FF-000146', NULL, 'Chloride channel protein', 163, NULL, NULL, 55491),
(55492, '1.10.510.10-FF-002515', NULL, NULL, 150, NULL, NULL, 55492),
(55493, '1.10.510.10-FF-000054', NULL, 'Mitogen-activated protein kinase kinase kinase 5', 193, NULL, NULL, 55493),
(55494, '2.40.20.10-FF-000107', NULL, 'Uncharacterized protein', 90, NULL, NULL, 55494),
(55495, '3.40.630.30-FF-000330', NULL, 'GNAT family N-acetyltransferase', 168, NULL, NULL, 55495),
(55496, '3.30.160.60-FF-006442', NULL, NULL, 84, NULL, NULL, 55496),
(55497, '1.20.1560.10-FF-000773', NULL, 'ABC transporter, putative', 304, NULL, NULL, 55497),
(55498, '3.40.800.20-FF-000031', NULL, 'Histone deacetylase-like amidohydrolase', 379, NULL, NULL, 55498),
(55499, '3.30.572.10-FF-000033', NULL, 'Bifunctional dihydrofolate reductase-thymidylate synthase', 298, NULL, NULL, 55499),
(55500, '3.40.50.1580-FF-000030', NULL, 'Uncharacterized protein', 200, NULL, NULL, 55500),
(55501, '3.40.50.880-FF-000220', NULL, 'Transcriptional regulator DJ-1, putative', 113, NULL, NULL, 55501),
(55502, '3.30.160.110-FF-000004', NULL, 'Siroheme biosynthesis protein MET8', 37, NULL, NULL, 55502);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(55503, '3.40.20.10-FF-000162', NULL, 'Protovillin', 132, NULL, NULL, 55503),
(55504, '3.40.630.30-FF-000537', NULL, 'Histone acetyltransferase', 43, NULL, NULL, 55504),
(55505, '3.30.160.60-FF-002305', NULL, 'zinc finger protein 777', 34, NULL, NULL, 55505),
(55506, '2.30.30.40-FF-000235', NULL, 'Myosin VIIb', 78, NULL, NULL, 55506),
(55507, '3.30.30.30-FF-000073', NULL, 'Uncharacterized protein', 46, NULL, NULL, 55507),
(55508, '3.10.20.90-FF-000506', NULL, 'SEP domain/UBX domain containing protein, putative', 145, NULL, NULL, 55508),
(55509, '1.10.3260.10-FF-000005', NULL, 'DNA ligase', 218, NULL, NULL, 55509),
(55510, '3.40.50.300-FF-004700', NULL, 'Meiotic recombination protein DMC1-like protein', 172, NULL, NULL, 55510),
(55511, '2.40.70.10-FF-000043', NULL, 'retroviral-like aspartic protease 1 isoform X3', 121, NULL, NULL, 55511),
(55512, '3.30.2020.30-FF-000010', NULL, 'Clavaminate synthase-like protein', 109, NULL, NULL, 55512),
(55513, '1.10.10.10-FF-000150', NULL, 'HTH-type transcriptional repressor NanR', 72, NULL, NULL, 55513),
(55514, '2.30.29.30-FF-001342', NULL, 'Protein tyrosine kinase 2 beta, a', 38, NULL, NULL, 55514),
(55515, '3.40.50.200-FF-000056', NULL, 'Uncharacterized protein', 113, NULL, NULL, 55515),
(55516, '1.25.40.10-FF-003581', NULL, 'Adenylyl cyclase class-3/4/guanylyl cyclase', 173, NULL, NULL, 55516),
(55517, '3.40.50.1440-FF-000016', NULL, 'Tubulin alpha chain', 135, NULL, NULL, 55517),
(55518, '3.30.200.20-FF-001415', NULL, 'Putative Serine/threonine-protein kinase 17A', 83, NULL, NULL, 55518),
(55519, '3.30.70.1230-FF-000052', NULL, 'Adenylate/guanylate cyclase catalytic domain protein', 189, NULL, NULL, 55519),
(55520, '2.60.40.10-FF-005953', NULL, NULL, 91, NULL, NULL, 55520),
(55521, '1.25.40.470-FF-000049', NULL, 'WD repeat-containing protein dyf-2', 198, NULL, NULL, 55521),
(55522, '2.70.130.10-FF-000131', NULL, NULL, 117, NULL, NULL, 55522),
(55523, '1.25.40.340-FF-000010', NULL, NULL, 58, NULL, NULL, 55523),
(55524, '3.40.50.300-FF-001963', NULL, 'Obg family GTPase CgtA', 144, NULL, NULL, 55524),
(55525, '3.40.50.1820-FF-001451', NULL, 'Uncharacterized protein', 184, NULL, NULL, 55525),
(55526, '3.40.50.620-FF-000749', NULL, 'Predicted protein', 146, NULL, NULL, 55526),
(55527, '3.30.160.60-FF-003587', NULL, NULL, 27, NULL, NULL, 55527),
(55528, '3.30.9.10-FF-000181', NULL, 'FAD-dependent oxidoreductase', 151, NULL, NULL, 55528),
(55529, '2.40.50.1020-FF-000009', NULL, 'Response regulator BlpR', 105, NULL, NULL, 55529),
(55530, '2.10.25.10-FF-000356', NULL, 'pro-neuregulin-4, membrane-bound isoform', 46, NULL, NULL, 55530),
(55531, '1.10.560.10-FF-000091', NULL, 'T-complex protein 1 subunit eta', 63, NULL, NULL, 55531),
(55532, '2.130.10.10-FF-001991', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', 274, NULL, NULL, 55532),
(55533, '1.25.40.10-FF-002878', NULL, 'Bardet-Biedl syndrome 4 protein, putative', 241, NULL, NULL, 55533),
(55534, '1.10.238.10-FF-000134', NULL, 'polycystin-2 isoform X2', 46, NULL, NULL, 55534),
(55535, '2.60.120.10-FF-000245', NULL, 'Lysophospholipase NTE1', 145, NULL, NULL, 55535),
(55536, '1.10.20.10-FF-000100', NULL, 'Transcription initiation factor TFIID subunit 9B', 72, NULL, NULL, 55536),
(55537, '3.80.10.10-FF-002576', NULL, 'leucine-rich repeat neuronal protein 1-like', 116, NULL, NULL, 55537),
(55538, '3.30.70.640-FF-000003', NULL, 'Molybdenum cofactor biosynthesis protein, putative', 157, NULL, NULL, 55538),
(55539, '4.10.280.10-FF-000232', NULL, 'MAX dimerization protein MLX', 91, NULL, NULL, 55539),
(55540, '1.20.225.10-FF-000001', NULL, 'Carnocyclin-A', 60, NULL, NULL, 55540),
(55541, '3.40.50.2300-FF-001617', NULL, NULL, 302, NULL, NULL, 55541),
(55542, '3.40.50.300-FF-003762', NULL, 'Midasin', 183, NULL, NULL, 55542),
(55543, '3.40.30.10-FF-000229', NULL, 'Thioredoxin (TRX)', 124, NULL, NULL, 55543),
(55544, '3.40.50.2300-FF-000999', NULL, NULL, 132, NULL, NULL, 55544),
(55545, '1.10.274.30-FF-000010', NULL, 'Uncharacterized protein', 159, NULL, NULL, 55545);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(55546, '3.40.50.800-FF-000039', NULL, 'Histidine-tRNA ligase', 96, NULL, NULL, 55546),
(55547, '3.30.559.10-FF-000188', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 263, NULL, NULL, 55547),
(55548, '1.10.10.440-FF-000022', NULL, 'Pre-mRNA-processing protein 40A', 82, NULL, NULL, 55548),
(55549, '1.25.40.20-FF-000161', NULL, 'ankyrin repeat domain-containing protein 17 isoform X3', 188, NULL, NULL, 55549),
(55550, '1.10.8.60-FF-000512', NULL, 'AAA ATPase domain-containing protein', 55, NULL, NULL, 55550),
(55551, '2.130.10.10-FF-005835', NULL, 'Uncharacterized protein', 373, NULL, NULL, 55551),
(55552, '2.120.10.80-FF-000101', NULL, 'kelch-like protein 8 isoform X3', 131, NULL, NULL, 55552),
(55553, '2.40.50.1000-FF-000003', NULL, '40S ribosomal protein S11', 158, NULL, NULL, 55553),
(55554, '3.40.50.300-FF-005892', NULL, 'Lincomycin resistance ABC-F type ribosomal protection protein', 248, NULL, NULL, 55554),
(55555, '3.40.1350.10-FF-000037', NULL, 'Uncharacterized protein', 91, NULL, NULL, 55555),
(55556, '3.30.70.1170-FF-000005', NULL, 'Sun-family protein, putative', 104, NULL, NULL, 55556),
(55557, '3.30.70.1180-FF-000008', NULL, 'V-type proton ATPase subunit C', 48, NULL, NULL, 55557),
(55558, '2.70.170.10-FF-000240', NULL, 'Uncharacterized protein', 222, NULL, NULL, 55558),
(55559, '3.40.50.300-FF-002126', NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase, putative', 171, NULL, NULL, 55559),
(55560, '1.10.8.60-FF-000158', NULL, 'Calmodulin-interacting protein 111', 157, NULL, NULL, 55560),
(55561, '3.80.10.10-FF-000676', NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', 153, NULL, NULL, 55561),
(55562, '3.30.56.30-FF-000014', NULL, 'Signal recognition particle protein, putative', 111, NULL, NULL, 55562),
(55563, '1.50.40.10-FF-000543', NULL, 'Uncharacterized protein', 139, NULL, NULL, 55563),
(55564, '3.80.10.10-FF-003082', NULL, 'Uncharacterized protein', 127, NULL, NULL, 55564),
(55565, '2.130.10.10-FF-005605', NULL, 'Predicted protein', 190, NULL, NULL, 55565),
(55566, '3.80.10.10-FF-001053', NULL, 'Tubulin folding COfactor E-Like protein', 143, NULL, NULL, 55566),
(55567, '3.40.50.720-FF-000897', NULL, '2-dehydropantoate 2-reductase', 171, NULL, NULL, 55567),
(55568, '3.30.160.60-FF-001687', NULL, 'Zinc finger protein 217', 56, NULL, NULL, 55568),
(55569, '3.90.1750.10-FF-000056', NULL, 'Ubiquitin ligase, putative', 183, NULL, NULL, 55569),
(55570, '3.40.50.450-FF-000097', NULL, 'Uncharacterized protein', 89, NULL, NULL, 55570),
(55571, '3.30.70.330-FF-000112', NULL, 'RNA-binding motif protein 15', 72, NULL, NULL, 55571),
(55572, '3.40.190.10-FF-000969', NULL, 'Nickel ABC transporter, solute-binding protein', 200, NULL, NULL, 55572),
(55573, '2.60.300.12-FF-000003', NULL, 'Iron-sulfur cluster insertion protein ErpA', 105, NULL, NULL, 55573),
(55574, '3.30.160.60-FF-005386', NULL, NULL, 25, NULL, NULL, 55574),
(55575, '3.30.70.330-FF-001540', NULL, NULL, 107, NULL, NULL, 55575),
(55576, '1.10.510.10-FF-001678', NULL, 'Muscle, skeletal receptor tyrosine protein kinase', 213, NULL, NULL, 55576),
(55577, '3.40.50.2300-FF-001275', NULL, NULL, 177, NULL, NULL, 55577),
(55578, '3.30.870.10-FF-000012', NULL, 'Tyrosyl-DNA phosphodiesterase 1', 203, NULL, NULL, 55578),
(55579, '3.40.50.720-FF-001173', NULL, '2-dehydropantoate 2-reductase', 195, NULL, NULL, 55579),
(55580, '3.90.1760.10-FF-000001', NULL, 'Bifunctional hemolysin/adenylate cyclase', 145, NULL, NULL, 55580),
(55581, '3.30.200.20-FF-001393', NULL, NULL, 106, NULL, NULL, 55581),
(55582, '2.60.40.10-FF-004430', NULL, NULL, 92, NULL, NULL, 55582),
(55583, '2.30.30.1020-FF-000056', NULL, NULL, 146, NULL, NULL, 55583),
(55584, '3.40.1010.10-FF-000012', NULL, 'S-adenosylmethionine-dependent methyltransferase, YraL family', 115, NULL, NULL, 55584),
(55585, '1.20.1280.50-FF-000252', NULL, 'Putative F-box/kelch-repeat protein At1g12870', 45, NULL, NULL, 55585),
(55586, '3.50.50.60-FF-001291', NULL, 'Uncharacterized protein', 179, NULL, NULL, 55586),
(55587, '3.50.30.30-FF-000128', NULL, 'Uncharacterized protein', 165, NULL, NULL, 55587);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(55588, '1.25.10.10-FF-000330', NULL, 'RING-type E3 ubiquitin transferase', 297, NULL, NULL, 55588),
(55589, '3.40.120.10-FF-000015', NULL, 'Phosphoacetylglucosamine mutase', 80, NULL, NULL, 55589),
(55590, '1.10.1280.10-FF-000006', NULL, 'Larval serum protein 1 gamma', 263, NULL, NULL, 55590),
(55591, '2.60.40.790-FF-000134', NULL, NULL, 100, NULL, NULL, 55591),
(55592, '3.30.160.60-FF-003828', NULL, NULL, 36, NULL, NULL, 55592),
(55593, '3.30.420.40-FF-000420', NULL, 'Actin-like protein 2', 163, NULL, NULL, 55593),
(55594, '3.30.70.330-FF-003108', NULL, NULL, 186, NULL, NULL, 55594),
(55595, '3.20.20.220-FF-000010', NULL, 'Proline dehydrogenase', 361, NULL, NULL, 55595),
(55596, '1.10.540.10-FF-000005', NULL, 'Crotonobetainyl-CoA reductase', 117, NULL, NULL, 55596),
(55597, '2.60.120.200-FF-000669', NULL, 'Uncharacterized protein', 64, NULL, NULL, 55597),
(55598, '3.30.160.60-FF-005841', NULL, NULL, 19, NULL, NULL, 55598),
(55599, '1.20.1440.100-FF-000009', NULL, 'HAD-IB family hydrolase', 74, NULL, NULL, 55599),
(55600, '1.10.8.60-FF-000271', NULL, 'Vacuolar protein sorting 4 homolog B', 65, NULL, NULL, 55600),
(55601, '1.10.418.10-FF-000002', NULL, 'Microtubule-actin cross-linking factor 1', 115, NULL, NULL, 55601),
(55602, '1.25.10.10-FF-002230', NULL, 'Predicted protein', 391, NULL, NULL, 55602),
(55603, '1.10.1900.10-FF-000010', NULL, 'Polyadenylate-binding protein', 86, NULL, NULL, 55603),
(55604, '3.20.20.80-FF-000773', NULL, 'Predicted protein', 314, NULL, NULL, 55604),
(55605, '1.10.1420.10-FF-000203', NULL, 'Uncharacterized protein', 80, NULL, NULL, 55605),
(55606, '3.40.50.10190-FF-000370', NULL, 'Uncharacterized protein', 63, NULL, NULL, 55606),
(55607, '3.60.21.10-FF-000067', NULL, 'Manganese-dependent ADP-ribose/CDP-alcohol diphosphatase', 315, NULL, NULL, 55607),
(55608, '3.30.460.10-FF-000094', NULL, 'Ribosomal silencing factor RsfS', 108, NULL, NULL, 55608),
(55609, '3.80.10.10-FF-000777', NULL, 'RNI-like superfamily protein', 219, NULL, NULL, 55609),
(55610, '3.40.30.10-FF-000342', NULL, 'Protein disulfide isomerase', 145, NULL, NULL, 55610),
(55611, '2.10.220.10-FF-000180', NULL, 'Uncharacterized protein', 68, NULL, NULL, 55611),
(55612, '1.25.40.10-FF-003479', NULL, 'Os05g0112900 protein', 93, NULL, NULL, 55612),
(55613, '3.20.20.70-FF-000540', NULL, NULL, 226, NULL, NULL, 55613),
(55614, '2.40.440.10-FF-000026', NULL, 'ErfK/YbiS/YcfS/YnhG family protein', 158, NULL, NULL, 55614),
(55615, '3.90.226.10-FF-000103', NULL, 'POSSIBLE ENOYL-COA HYDRATASE', 113, NULL, NULL, 55615),
(55616, '3.30.160.60-FF-003941', NULL, NULL, 31, NULL, NULL, 55616),
(55617, '1.10.510.10-FF-000155', NULL, 'Casein kinase I isoform epsilon', 320, NULL, NULL, 55617),
(55618, '1.20.190.50-FF-000004', NULL, 'Nuclear pore complex protein', 266, NULL, NULL, 55618),
(55619, '2.60.40.10-FF-000501', NULL, 'Leptin receptor', 88, NULL, NULL, 55619),
(55620, '3.10.20.90-FF-000383', NULL, 'Ubiquitin like 4B', 74, NULL, NULL, 55620),
(55621, '3.40.50.300-FF-007691', NULL, 'Predicted protein', 107, NULL, NULL, 55621),
(55622, '2.10.90.10-FF-000074', NULL, 'Interleukin cytokine-related protein 17.1', 121, NULL, NULL, 55622),
(55623, '2.130.10.10-FF-000810', NULL, 'Nucleoporin 43', 164, NULL, NULL, 55623),
(55624, '2.60.40.1120-FF-000023', NULL, 'TonB-dependent outer membrane receptor', 76, NULL, NULL, 55624),
(55625, '2.60.40.200-FF-000008', NULL, 'Superoxide dismutase [Cu-Zn]', 166, NULL, NULL, 55625),
(55626, '1.20.5.500-FF-000006', NULL, 'ATPase inhibitor, mitochondrial', 62, NULL, NULL, 55626),
(55627, '1.10.287.70-FF-000647', NULL, 'Predicted protein', 168, NULL, NULL, 55627),
(55628, '3.40.140.10-FF-000005', NULL, 'tRNA-specific adenosine deaminase', 164, NULL, NULL, 55628),
(55629, '3.90.550.50-FF-000014', NULL, 'Hexosyltransferase', 240, NULL, NULL, 55629),
(55630, '2.40.20.10-FF-000006', NULL, 'Kremen protein 2', 89, NULL, NULL, 55630),
(55631, '1.20.190.40-FF-000001', NULL, 'Major DNA-binding protein', 134, NULL, NULL, 55631),
(55632, '3.30.980.40-FF-000001', NULL, 'DNA translocase FtsK', 105, NULL, NULL, 55632);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(55633, '3.30.160.60-FF-003486', NULL, 'Uncharacterized protein', 24, NULL, NULL, 55633),
(55634, '3.30.70.330-FF-001427', NULL, 'Uncharacterized protein', 102, NULL, NULL, 55634),
(55635, '2.40.170.20-FF-000036', NULL, 'TonB-dependent vitamin B12 receptor', 456, NULL, NULL, 55635),
(55636, '1.25.40.10-FF-004210', NULL, 'Uncharacterized protein', 63, NULL, NULL, 55636),
(55637, '3.30.200.20-FF-001954', NULL, 'Uncharacterized protein', 106, NULL, NULL, 55637),
(55638, '2.30.29.30-FF-001134', NULL, 'Uncharacterized protein', 118, NULL, NULL, 55638),
(55639, '2.10.50.10-FF-000077', NULL, 'Ectodysplasin A receptor', 73, NULL, NULL, 55639),
(55640, '1.10.580.10-FF-000002', NULL, 'Citrate synthase', 241, NULL, NULL, 55640),
(55641, '1.10.630.10-FF-000552', NULL, 'Os02g0217300 protein', 338, NULL, NULL, 55641),
(55642, '3.40.50.410-FF-000237', NULL, 'Integrator complex subunit 14', 176, NULL, NULL, 55642),
(55643, '1.20.1070.10-FF-001303', NULL, 'Uncharacterized protein', 136, NULL, NULL, 55643),
(55644, '3.40.50.2020-FF-000112', NULL, 'Uncharacterized protein', 91, NULL, NULL, 55644),
(55645, '4.10.40.20-FF-000013', NULL, 'Uncharacterized protein', 41, NULL, NULL, 55645),
(55646, '1.20.1070.10-FF-000685', NULL, 'Octopamine receptor beta-1R', 365, NULL, NULL, 55646),
(55647, '1.25.40.10-FF-003934', NULL, 'IFT complex B', 286, NULL, NULL, 55647),
(55648, '1.20.58.2220-FF-000014', NULL, 'FH2 domain containing 1', 386, NULL, NULL, 55648),
(55649, '1.25.40.10-FF-003704', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 108, NULL, NULL, 55649),
(55650, '1.10.1200.10-FF-000097', NULL, 'Fatty acyl-AMP ligase', 96, NULL, NULL, 55650),
(55651, '2.60.40.640-FF-000117', NULL, 'Uncharacterized protein', 159, NULL, NULL, 55651),
(55652, '3.90.1410.10-FF-000132', NULL, 'Uncharacterized protein', 271, NULL, NULL, 55652),
(55653, '3.20.70.20-FF-000056', NULL, 'Gll3966 protein', 106, NULL, NULL, 55653),
(55654, '2.30.29.30-FF-000858', NULL, 'Uncharacterized protein', 150, NULL, NULL, 55654),
(55655, '4.10.1000.40-FF-000015', NULL, 'Uncharacterized protein', 68, NULL, NULL, 55655),
(55656, '3.30.70.330-FF-001085', NULL, 'Related to TIF3-translation initiation factor eIF-4B', 105, NULL, NULL, 55656),
(55657, '3.30.200.20-FF-002230', NULL, 'Uncharacterized protein', 38, NULL, NULL, 55657),
(55658, '1.25.40.650-FF-000002', NULL, 'Penicillin-binding protein activator LpoA', 105, NULL, NULL, 55658),
(55659, '3.40.50.2000-FF-001067', NULL, 'Os06g0564800 protein', 78, NULL, NULL, 55659),
(55660, '1.25.40.660-FF-000005', NULL, 'Vacuolar protein sorting-associated protein 35', 308, NULL, NULL, 55660),
(55661, '3.40.30.10-FF-000903', NULL, 'Predicted protein', 139, NULL, NULL, 55661),
(55662, '1.20.120.1070-FF-000008', NULL, 'Related to GCN3-translation initiation factor eIF2B, 34 KD, alpha subunit', 105, NULL, NULL, 55662),
(55663, '1.20.1270.60-FF-000327', NULL, 'Uncharacterized protein', 250, NULL, NULL, 55663),
(55664, '1.25.40.10-FF-003592', NULL, 'Pentatricopeptide repeat-containing protein', 152, NULL, NULL, 55664),
(55665, '2.40.50.140-FF-001177', NULL, NULL, 118, NULL, NULL, 55665),
(55666, '1.20.58.390-FF-000141', NULL, 'Predicted protein', 106, NULL, NULL, 55666),
(55667, '1.10.287.1150-FF-000006', NULL, '2-oxoglutarate dehydrogenase, mitochondrial', 96, NULL, NULL, 55667),
(55668, '1.20.1250.20-FF-001157', NULL, 'Solute carrier family 15 member 5', 362, NULL, NULL, 55668),
(55669, '1.20.1310.20-FF-000044', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 151, NULL, NULL, 55669),
(55670, '2.60.40.10-FF-001693', NULL, 'Dystroglycan, isoform B', 110, NULL, NULL, 55670),
(55671, '2.30.30.40-FF-000134', NULL, 'src-like-adapter isoform X1', 71, NULL, NULL, 55671),
(55672, '3.40.50.10470-FF-000021', NULL, 'Initiation factor 2 subunit family, putative', 204, NULL, NULL, 55672),
(55673, '3.90.190.10-FF-000497', NULL, 'Uncharacterized protein', 150, NULL, NULL, 55673),
(55674, '3.30.60.20-FF-000021', NULL, 'Serine/threonine-protein kinase', 75, NULL, NULL, 55674),
(55675, '3.15.20.10-FF-000006', NULL, 'BPI fold containing family C', 103, NULL, NULL, 55675);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(55676, '3.20.20.70-FF-000770', NULL, NULL, 321, NULL, NULL, 55676),
(55677, '2.60.120.290-FF-000191', NULL, 'AGAP005526-PA', 114, NULL, NULL, 55677),
(55678, '1.10.10.10-FF-001673', NULL, 'Transcriptional regulator, MarR family', 135, NULL, NULL, 55678),
(55679, '3.30.930.10-FF-000079', NULL, 'Lysine--tRNA ligase 1', 347, NULL, NULL, 55679),
(55680, '1.20.1310.10-FF-000041', NULL, 'cullin-3 isoform X2', 71, NULL, NULL, 55680),
(55681, '3.30.160.60-FF-004104', NULL, NULL, 28, NULL, NULL, 55681),
(55682, '1.10.533.10-FF-000202', NULL, 'Uncharacterized protein', 92, NULL, NULL, 55682),
(55683, '3.30.60.30-FF-000024', NULL, 'Transmembrane agrin', 73, NULL, NULL, 55683),
(55684, '3.30.420.10-FF-000670', NULL, NULL, 287, NULL, NULL, 55684),
(55685, '3.40.33.10-FF-000135', NULL, 'Uncharacterized protein', 175, NULL, NULL, 55685),
(55686, '3.30.2130.10-FF-000006', NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase', 88, NULL, NULL, 55686),
(55687, '3.30.40.10-FF-000938', NULL, 'PHD transcription factor', 104, NULL, NULL, 55687),
(55688, '1.20.120.340-FF-000018', NULL, 'Flagellar secretion chaperone FliS', 119, NULL, NULL, 55688),
(55689, '1.10.10.440-FF-000033', NULL, 'Formin binding protein (FNB3)', 69, NULL, NULL, 55689),
(55690, '3.40.50.300-FF-003969', NULL, 'ATP-binding protein', 263, NULL, NULL, 55690),
(55691, '3.60.110.10-FF-000089', NULL, NULL, 126, NULL, NULL, 55691),
(55692, '3.40.50.10310-FF-000001', NULL, 'Creatininase family protein', 238, NULL, NULL, 55692),
(55693, '3.30.420.10-FF-000338', NULL, 'Polymerase (DNA directed), theta', 250, NULL, NULL, 55693),
(55694, '3.40.50.1110-FF-000171', NULL, 'Predicted protein', 117, NULL, NULL, 55694),
(55695, '2.30.30.140-FF-000282', NULL, 'Uncharacterized protein', 99, NULL, NULL, 55695),
(55696, '1.25.40.470-FF-000038', NULL, 'Intraflagellar transport 122', 166, NULL, NULL, 55696),
(55697, '1.20.1270.280-FF-000041', NULL, 'Dynein heavy chain', 237, NULL, NULL, 55697),
(55698, '3.30.40.10-FF-001214', NULL, 'Probable E3 ubiquitin-protein ligase makorin-3', 77, NULL, NULL, 55698),
(55699, '2.80.10.50-FF-000156', NULL, 'Ricin B-like lectin', 148, NULL, NULL, 55699),
(55700, '2.30.30.370-FF-000002', NULL, '2-hydroxyhepta-2,4-diene-1,7-dioate isomerase', 54, NULL, NULL, 55700),
(55701, '3.40.140.10-FF-000224', NULL, 'Uncharacterized protein', 174, NULL, NULL, 55701),
(55702, '1.10.1450.10-FF-000031', NULL, 'Tetraspanin', 100, NULL, NULL, 55702),
(55703, '3.90.1420.10-FF-000060', NULL, 'Ribosomal lysine N-methyltransferase set10', 158, NULL, NULL, 55703),
(55704, '1.25.40.20-FF-000722', NULL, 'Caseinolytic peptidase B protein homolog isoform 2', 80, NULL, NULL, 55704),
(55705, '3.60.21.10-FF-000421', NULL, 'Uncharacterized protein', 273, NULL, NULL, 55705),
(55706, '1.10.132.20-FF-000009', NULL, 'Similar to ribosome recycling factor', 94, NULL, NULL, 55706),
(55707, '2.30.30.380-FF-000005', NULL, 'E3 ubiquitin-protein ligase Mdm2', 45, NULL, NULL, 55707),
(55708, '2.60.120.290-FF-000089', NULL, 'Uncharacterized protein, isoform A', 123, NULL, NULL, 55708),
(55709, '3.40.50.300-FF-007814', NULL, 'Uncharacterized protein', 286, NULL, NULL, 55709),
(55710, '3.40.50.300-FF-004245', NULL, 'ATP-dependent RecD-like DNA helicase', 216, NULL, NULL, 55710),
(55711, '2.60.120.330-FF-000141', NULL, 'Protein DMR6-LIKE OXYGENASE 2', 109, NULL, NULL, 55711),
(55712, '3.40.630.30-FF-000217', NULL, 'GNAT family N-acetyltransferase', 105, NULL, NULL, 55712),
(55713, '2.70.170.10-FF-000010', NULL, 'neuronal acetylcholine receptor subunit alpha-9', 215, NULL, NULL, 55713),
(55714, '1.20.58.60-FF-000746', NULL, 'Spectrin, beta, non-erythrocytic 5', 70, NULL, NULL, 55714),
(55715, '3.40.50.150-FF-001098', NULL, 'N(2), N(2)-dimethylguanosine tRNA methyltransferase, putative', 430, NULL, NULL, 55715),
(55716, '1.10.510.10-FF-003943', NULL, NULL, 61, NULL, NULL, 55716),
(55717, '3.10.580.10-FF-000135', NULL, 'Uncharacterized protein', 82, NULL, NULL, 55717),
(55718, '1.10.150.50-FF-000167', NULL, 'Sphingomyelin synthase-related protein 1', 83, NULL, NULL, 55718);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(55719, '3.40.50.10330-FF-000007', NULL, 'Diacylglycerol kinase', 140, NULL, NULL, 55719),
(55720, '1.25.10.10-FF-001735', NULL, 'Uncharacterized protein', 188, NULL, NULL, 55720),
(55721, '1.10.287.110-FF-000300', NULL, 'Uncharacterized protein', 91, NULL, NULL, 55721),
(55722, '1.10.555.10-FF-000247', NULL, NULL, 169, NULL, NULL, 55722),
(55723, '2.10.250.10-FF-000018', NULL, 'Calreticulin 3', 27, NULL, NULL, 55723),
(55724, '1.10.510.10-FF-001791', NULL, 'Protein CBG02188', 253, NULL, NULL, 55724),
(55725, '1.10.1580.10-FF-000035', NULL, 'Probable ribosome biogenesis GTPase A', 93, NULL, NULL, 55725),
(55726, '2.60.40.10-FF-002530', NULL, 'CBN-SAX-3 protein', 107, NULL, NULL, 55726),
(55727, '3.30.160.60-FF-006004', NULL, NULL, 39, NULL, NULL, 55727),
(55728, '1.10.230.10-FF-000004', NULL, 'ATP-citrate synthase', 97, NULL, NULL, 55728),
(55729, '2.130.10.10-FF-003705', NULL, 'TAF (TBP-associated transcription factor) family', 168, NULL, NULL, 55729),
(55730, '1.25.10.10-FF-002011', NULL, 'ARM repeat-containing protein', 198, NULL, NULL, 55730),
(55731, '3.40.50.10320-FF-000004', NULL, 'N-acetylglucosaminylphosphatidylinositol de-N-acetylase', 245, NULL, NULL, 55731),
(55732, '2.10.25.10-FF-000676', NULL, 'Protein eyes shut homolog', 46, NULL, NULL, 55732),
(55733, '1.20.920.10-FF-000049', NULL, 'RSC complex member', 110, NULL, NULL, 55733),
(55734, '3.40.50.720-FF-000667', NULL, 'Alpha-aminoadipic semialdehyde synthase', 130, NULL, NULL, 55734),
(55735, '3.40.50.150-FF-000125', NULL, 'Glutathione S-transferase C-terminal domain-containing protein', 180, NULL, NULL, 55735),
(55736, '3.40.630.10-FF-000211', NULL, 'Hypothetical_protein_-_conserved', 249, NULL, NULL, 55736),
(55737, '3.40.50.300-FF-000535', NULL, 'rac-like GTP-binding protein RAC2', 189, NULL, NULL, 55737),
(55738, '3.40.50.2300-FF-000769', NULL, NULL, 140, NULL, NULL, 55738),
(55739, '3.30.830.10-FF-000015', NULL, 'Putative zinc metalloprotease', 235, NULL, NULL, 55739),
(55740, '3.20.20.80-FF-000548', NULL, 'Uncharacterized protein', 140, NULL, NULL, 55740),
(55741, '2.170.190.11-FF-000027', NULL, 'Molybdopterin molybdenumtransferase', 104, NULL, NULL, 55741),
(55742, '3.50.50.60-FF-001414', NULL, 'Uncharacterized protein', 131, NULL, NULL, 55742),
(55743, '3.40.50.720-FF-001055', NULL, 'UDP-glucose dehydrogenase Ugd1, putative', 215, NULL, NULL, 55743),
(55744, '1.10.238.10-FF-000022', NULL, 'E3 ubiquitin-protein ligase CBL', 89, NULL, NULL, 55744),
(55745, '1.25.40.20-FF-001897', NULL, 'Predicted protein', 116, NULL, NULL, 55745),
(55746, '3.80.10.10-FF-002694', NULL, 'CLL3 clavata1-like receptor S/T protein kinase protein', 75, NULL, NULL, 55746),
(55747, '3.30.1120.10-FF-000056', NULL, 'Predicted protein', 66, NULL, NULL, 55747),
(55748, '2.20.25.190-FF-000002', NULL, 'Transcription elongation factor 1 homolog', 60, NULL, NULL, 55748),
(55749, '3.30.420.10-FF-000439', NULL, NULL, 206, NULL, NULL, 55749),
(55750, '3.40.50.2300-FF-001505', NULL, NULL, 104, NULL, NULL, 55750),
(55751, '3.30.40.10-FF-001433', NULL, 'Uncharacterized protein', 91, NULL, NULL, 55751),
(55752, '3.30.565.10-FF-000011', NULL, 'Sensor histidine kinase CpxA', 154, NULL, NULL, 55752),
(55753, '3.30.9.10-FF-000063', NULL, 'Oxidoreductase, putative', 221, NULL, NULL, 55753),
(55754, '3.20.20.70-FF-000545', NULL, NULL, 214, NULL, NULL, 55754),
(55755, '3.30.710.10-FF-000198', NULL, 'Germ cell-less, isoform B', 159, NULL, NULL, 55755),
(55756, '3.10.450.10-FF-000030', NULL, 'Latexin', 125, NULL, NULL, 55756),
(55757, '3.80.10.10-FF-003306', NULL, 'Uncharacterized protein', 252, NULL, NULL, 55757),
(55758, '3.40.50.2000-FF-000898', NULL, 'Glr3757 protein', 173, NULL, NULL, 55758),
(55759, '3.50.50.60-FF-001296', NULL, 'Uncharacterized protein', 236, NULL, NULL, 55759),
(55760, '3.30.160.60-FF-004317', NULL, NULL, 28, NULL, NULL, 55760),
(55761, '2.60.40.1170-FF-000010', NULL, 'AP-1 complex subunit mu-2', 148, NULL, NULL, 55761),
(55762, '1.10.1220.10-FF-000008', NULL, 'Addiction module antitoxin, RelB/DinJ family', 79, NULL, NULL, 55762),
(55763, '3.40.30.10-FF-000117', NULL, 'thioredoxin-related transmembrane protein 1', 109, NULL, NULL, 55763);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(55764, '2.60.120.330-FF-000028', NULL, 'Unplaced genomic scaffold supercont1.142, whole genome shotgun sequence', 326, NULL, NULL, 55764),
(55765, '1.20.870.10-FF-000033', NULL, 'Ras family guanine nucleotide exchange factor', 178, NULL, NULL, 55765),
(55766, '1.25.40.10-FF-005172', NULL, 'Signal recognition particle receptor FtsY', 67, NULL, NULL, 55766),
(55767, '3.80.10.10-FF-001171', NULL, 'Centrosomal protein 97kDa, isoform B', 86, NULL, NULL, 55767),
(55768, '3.40.50.720-FF-002578', NULL, 'Uncharacterized protein', 27, NULL, NULL, 55768),
(55769, '1.50.10.10-FF-000148', NULL, 'Uncharacterized protein', 323, NULL, NULL, 55769),
(55770, '3.30.70.890-FF-000044', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 106, NULL, NULL, 55770),
(55771, '3.30.499.10-FF-000019', NULL, 'Aconitate hydratase', 264, NULL, NULL, 55771),
(55772, '3.40.50.10330-FF-000114', NULL, 'Uncharacterized protein', 158, NULL, NULL, 55772),
(55773, '3.40.50.300-FF-002014', NULL, 'DNA polymerase III, delta prime subunit', 161, NULL, NULL, 55773),
(55774, '2.130.10.10-FF-005381', NULL, 'F21J9.19', 156, NULL, NULL, 55774),
(55775, '3.40.50.300-FF-005780', NULL, 'Chromosome 7, whole genome shotgun sequence', 95, NULL, NULL, 55775),
(55776, '4.10.1240.10-FF-000024', NULL, 'latrophilin Cirl isoform X1', 59, NULL, NULL, 55776),
(55777, '3.40.50.10190-FF-000139', NULL, 'Nibrin', 98, NULL, NULL, 55777),
(55778, '3.30.200.20-FF-001174', NULL, 'Dual serine/threonine and tyrosine protein kinase', 89, NULL, NULL, 55778),
(55779, '2.70.150.10-FF-000020', NULL, 'Copper-exporting P-type ATPase A', 117, NULL, NULL, 55779),
(55780, '2.60.40.10-FF-002070', NULL, 'roundabout homolog 2', 104, NULL, NULL, 55780),
(55781, '1.10.20.10-FF-000307', NULL, NULL, 45, NULL, NULL, 55781),
(55782, '2.70.130.10-FF-000013', NULL, 'Insulin-like growth factor 2 receptor', 143, NULL, NULL, 55782),
(55783, '1.10.8.270-FF-000130', NULL, 'RabGAP/TBC protein', 110, NULL, NULL, 55783),
(55784, '3.40.80.10-FF-000047', NULL, 'Peptidoglycan recognition protein 6', 79, NULL, NULL, 55784),
(55785, '1.20.1250.20-FF-000994', NULL, 'MFS transporter', 399, NULL, NULL, 55785),
(55786, '1.10.246.20-FF-000010', NULL, 'Mediator complex subunit Med15', 81, NULL, NULL, 55786),
(55787, '1.10.30.10-FF-000140', NULL, 'FACT complex subunit SSRP1', 99, NULL, NULL, 55787),
(55788, '3.30.160.60-FF-000046', NULL, 'Putative B-cell lymphoma/leukemia 11A', 24, NULL, NULL, 55788),
(55789, '1.10.8.430-FF-000004', NULL, 'Disease resistance protein (TIR-NBS-LRR class)', 86, NULL, NULL, 55789),
(55790, '1.20.1070.10-FF-000786', NULL, 'Predicted protein', 288, NULL, NULL, 55790),
(55791, '2.60.40.10-FF-003267', NULL, 'Interleukin 13 receptor, alpha 2', 103, NULL, NULL, 55791),
(55792, '2.60.40.60-FF-000370', NULL, 'FAT atypical cadherin 3', 99, NULL, NULL, 55792),
(55793, '1.10.510.10-FF-003595', NULL, NULL, 206, NULL, NULL, 55793),
(55794, '3.90.930.1-FF-000003', NULL, NULL, 108, NULL, NULL, 55794),
(55795, '3.30.160.60-FF-002300', NULL, 'Kruppel like factor 18', 31, NULL, NULL, 55795),
(55796, '2.60.120.10-FF-000458', NULL, 'Anti-sigma-E factor ChrR', 92, NULL, NULL, 55796),
(55797, '3.30.160.60-FF-004424', NULL, NULL, 55, NULL, NULL, 55797),
(55798, '1.20.1250.20-FF-000668', NULL, 'MFS drug efflux pump', 231, NULL, NULL, 55798),
(55799, '3.30.40.10-FF-001540', NULL, 'Uncharacterized protein', 63, NULL, NULL, 55799),
(55800, '1.10.8.420-FF-000001', NULL, 'Recombination protein RecR', 51, NULL, NULL, 55800),
(55801, '1.20.5.930-FF-000005', NULL, 'Integrin, alpha 10', 46, NULL, NULL, 55801),
(55802, '2.60.40.10-FF-003593', NULL, NULL, 96, NULL, NULL, 55802),
(55803, '3.40.30.10-FF-000224', NULL, 'Thioredoxin domain containing 2 (Spermatozoa)', 123, NULL, NULL, 55803),
(55804, '1.10.132.70-FF-000007', NULL, 'Telomerase reverse transcriptase', 304, NULL, NULL, 55804),
(55805, '1.10.238.200-FF-000008', NULL, 'Defective in cullin neddylation protein', 99, NULL, NULL, 55805),
(55806, '2.30.30.140-FF-000304', NULL, 'Protein SAWADEE HOMEODOMAIN HOMOLOG 1', 73, NULL, NULL, 55806),
(55807, '3.30.70.330-FF-001422', NULL, 'Uncharacterized protein', 129, NULL, NULL, 55807);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(55808, '1.20.900.10-FF-000048', NULL, 'GL21162', 194, NULL, NULL, 55808),
(55809, '2.40.10.10-FF-000500', NULL, NULL, 107, NULL, NULL, 55809),
(55810, '1.10.533.10-FF-000303', NULL, 'Apoptosis 2 inhibitor-like Protein', 65, NULL, NULL, 55810),
(55811, '3.40.50.1100-FF-000156', NULL, 'Os01g0695600 protein', 37, NULL, NULL, 55811),
(55812, '2.40.40.10-FF-000002', NULL, 'Membrane-bound lytic murein transglycosylase A', 174, NULL, NULL, 55812),
(55813, '1.10.510.10-FF-003269', NULL, NULL, 108, NULL, NULL, 55813),
(55814, '3.30.505.50-FF-000002', NULL, 'Ribosome hibernation promoting factor', 47, NULL, NULL, 55814),
(55815, '3.50.50.60-FF-000695', NULL, 'Protoporphyrinogen oxidase', 143, NULL, NULL, 55815),
(55816, '3.30.160.60-FF-000372', NULL, 'IKAROS family zinc finger 4', 30, NULL, NULL, 55816),
(55817, '1.20.1270.60-FF-000209', NULL, 'Bridging integrator 3-like protein', 210, NULL, NULL, 55817),
(55818, '3.40.950.10-FF-000027', NULL, NULL, 32, NULL, NULL, 55818),
(55819, '3.40.50.12110-FF-000002', NULL, 'Spore photoproduct lyase', 112, NULL, NULL, 55819),
(55820, '3.30.60.20-FF-000015', NULL, 'Vav guanine nucleotide exchange factor 1', 64, NULL, NULL, 55820),
(55821, '2.40.40.20-FF-000005', NULL, 'Periplasmic nitrate reductase', 125, NULL, NULL, 55821),
(55822, '1.10.246.130-FF-000022', NULL, NULL, 48, NULL, NULL, 55822),
(55823, '2.40.30.130-FF-000012', NULL, 'Predicted gene, 27029', 89, NULL, NULL, 55823),
(55824, '2.30.30.620-FF-000004', NULL, 'Predicted protein', 70, NULL, NULL, 55824),
(55825, '2.20.50.20-FF-000001', NULL, 'Vitellogenin 5', 45, NULL, NULL, 55825),
(55826, '2.60.120.620-FF-000008', NULL, 'transmembrane prolyl 4-hydroxylase', 245, NULL, NULL, 55826),
(55827, '2.70.170.10-FF-000122', NULL, 'Uncharacterized protein', 124, NULL, NULL, 55827),
(55828, '3.40.50.300-FF-007808', NULL, 'Predicted protein', 34, NULL, NULL, 55828),
(55829, '1.10.286.20-FF-000012', NULL, NULL, 23, NULL, NULL, 55829),
(55830, '3.30.60.30-FF-000018', NULL, 'Transmembrane agrin', 73, NULL, NULL, 55830),
(55831, '3.10.20.90-FF-000170', NULL, 'Polycomb group RING finger protein 2', 117, NULL, NULL, 55831),
(55832, '1.20.272.60-FF-000001', NULL, NULL, 122, NULL, NULL, 55832),
(55833, '1.10.150.50-FF-000066', NULL, 'ephrin type-A receptor 10', 77, NULL, NULL, 55833),
(55834, '1.10.510.10-FF-002072', NULL, 'Serine/threonine-protein kinase', 180, NULL, NULL, 55834),
(55835, '3.40.50.1110-FF-000159', NULL, 'Uncharacterized protein', 127, NULL, NULL, 55835),
(55836, '2.130.10.10-FF-003924', NULL, 'Uncharacterized protein', 260, NULL, NULL, 55836),
(55837, '2.60.120.620-FF-000115', NULL, 'Predicted protein', 167, NULL, NULL, 55837),
(55838, '3.30.930.10-FF-000416', NULL, 'Lysine--tRNA ligase', 352, NULL, NULL, 55838),
(55839, '3.40.50.300-FF-007915', NULL, 'Uncharacterized protein', 183, NULL, NULL, 55839),
(55840, '2.70.170.10-FF-000015', NULL, 'gamma-aminobutyric acid receptor subunit rho-1 isoform X1', 206, NULL, NULL, 55840),
(55841, '2.20.25.10-FF-000029', NULL, 'DNA-directed RNA polymerase subunit M', 56, NULL, NULL, 55841),
(55842, '3.10.20.90-FF-000063', NULL, 'Talin 1', 41, NULL, NULL, 55842),
(55843, '3.40.50.10760-FF-000001', NULL, 'Outer capsid protein lambda-2', 263, NULL, NULL, 55843),
(55844, '3.40.630.30-FF-000094', NULL, 'Histone acetyltransferase', 120, NULL, NULL, 55844),
(55845, '3.30.160.60-FF-001569', NULL, 'Zinc finger protein 341', 24, NULL, NULL, 55845),
(55846, '3.40.50.2300-FF-001612', NULL, NULL, 44, NULL, NULL, 55846),
(55847, '3.30.930.10-FF-000309', NULL, 'DNA polymerase subunit gamma-2, putative', 185, NULL, NULL, 55847),
(55848, '1.10.510.10-FF-003488', NULL, NULL, 263, NULL, NULL, 55848),
(55849, '3.50.30.30-FF-000027', NULL, 'E3 ubiquitin-protein ligase RNF130', 104, NULL, NULL, 55849),
(55850, '3.40.140.10-FF-000117', NULL, 'Cytidine deaminase,putative', 144, NULL, NULL, 55850),
(55851, '1.10.405.10-FF-000034', NULL, 'Uncharacterized protein', 53, NULL, NULL, 55851),
(55852, '2.10.70.10-FF-000078', NULL, 'Complement decay-accelerating factor', 64, NULL, NULL, 55852),
(55853, '6.10.140.2220-FF-000074', NULL, 'SET (Trithorax/polycomb) domain containing', 47, NULL, NULL, 55853);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(55854, '2.60.40.60-FF-000263', NULL, 'LOW QUALITY PROTEIN: protocadherin-23', 104, NULL, NULL, 55854),
(55855, '2.40.50.140-FF-001071', NULL, NULL, 89, NULL, NULL, 55855),
(55856, '3.40.50.1820-FF-001232', NULL, 'Carboxylic ester hydrolase', 549, NULL, NULL, 55856),
(55857, '2.60.34.20-FF-000001', NULL, 'protein AAR2 homolog', 141, NULL, NULL, 55857),
(55858, '1.25.40.10-FF-000045', NULL, 'Cell division cycle protein 27 isoform X3', 77, NULL, NULL, 55858),
(55859, '1.20.1250.20-FF-000887', NULL, 'Probable multidrug-efflux transporter MT1670', 177, NULL, NULL, 55859),
(55860, '2.30.29.30-FF-001128', NULL, 'Nuclear pore complex component NPAP60L/NUP50, putative', 122, NULL, NULL, 55860),
(55861, '2.10.25.10-FF-001064', NULL, 'Uncharacterized protein', 38, NULL, NULL, 55861),
(55862, '1.10.8.270-FF-000023', NULL, 'TBC domain-containing protein C1778.09', 92, NULL, NULL, 55862),
(55863, '1.10.1080.10-FF-000019', NULL, 'Glutathione synthetase, putative', 81, NULL, NULL, 55863),
(55864, '3.30.450.90-FF-000015', NULL, 'General secretion pathway protein E', 125, NULL, NULL, 55864),
(55865, '3.40.50.1820-FF-001120', NULL, 'Carboxylic ester hydrolase', 79, NULL, NULL, 55865),
(55866, '3.30.200.20-FF-001960', NULL, 'Uncharacterized protein', 128, NULL, NULL, 55866),
(55867, '1.10.510.10-FF-003376', NULL, NULL, 374, NULL, NULL, 55867),
(55868, '1.20.1250.20-FF-001511', NULL, 'Solute carrier family 2, facilitated glucose transporter member 5', 480, NULL, NULL, 55868),
(55869, '3.40.50.980-FF-000031', NULL, 'N-(5-amino-5-carboxypentanoyl)-L-cysteinyl-D-valine synthase', 171, NULL, NULL, 55869),
(55870, '3.40.140.20-FF-000008', NULL, 'Bifunctional purine biosynthesis protein PURH', 147, NULL, NULL, 55870),
(55871, '1.25.40.20-FF-000048', NULL, 'SH3 and multiple ankyrin repeat domains protein 3', 97, NULL, NULL, 55871),
(55872, '3.40.50.1700-FF-000027', NULL, 'Lin1840 protein', 247, NULL, NULL, 55872),
(55873, '3.40.50.10470-FF-000009', NULL, 'Translation initiation factor eIF2B subunit', 202, NULL, NULL, 55873),
(55874, '1.20.1270.60-FF-000198', NULL, 'YALI0B15686p', 153, NULL, NULL, 55874),
(55875, '2.60.40.10-FF-003486', NULL, NULL, 120, NULL, NULL, 55875),
(55876, '2.160.30.10-FF-000001', NULL, 'Short tail fiber protein gp12', 43, NULL, NULL, 55876),
(55877, '2.40.10.170-FF-000014', NULL, 'ATP synthase subunit beta', 77, NULL, NULL, 55877),
(55878, '3.90.1410.10-FF-000126', NULL, 'ADR237Cp', 285, NULL, NULL, 55878),
(55879, '2.30.40.10-FF-000087', NULL, 'Dihydropyrimidinase', 80, NULL, NULL, 55879),
(55880, '1.10.30.10-FF-000033', NULL, 'nucleolar transcription factor 1 isoform X1', 67, NULL, NULL, 55880),
(55881, '1.10.1200.270-FF-000022', NULL, 'S-adenosyl-L-methionine-dependent methyltransferase superfamily protein', 94, NULL, NULL, 55881),
(55882, '3.30.2310.20-FF-000001', NULL, 'Addiction module toxin, Txe/YoeB family', 84, NULL, NULL, 55882),
(55883, '1.10.1410.10-FF-000034', NULL, 'Os01g0702900 protein', 58, NULL, NULL, 55883),
(55884, '3.50.50.60-FF-000110', NULL, 'Nitrite reductase large subunit', 139, NULL, NULL, 55884),
(55885, '2.130.10.10-FF-001777', NULL, 'Neural precursor cell-expressed, developmentally down-regulated 1', 103, NULL, NULL, 55885),
(55886, '1.25.40.20-FF-000481', NULL, 'Oxysterol-binding family protein', 80, NULL, NULL, 55886),
(55887, '3.70.10.10-FF-000070', NULL, 'Uncharacterized protein', 258, NULL, NULL, 55887),
(55888, '1.10.10.10-FF-002050', NULL, 'Uncharacterized protein', 72, NULL, NULL, 55888),
(55889, '2.60.120.920-FF-000087', NULL, 'Tripartite motif-containing 5', 209, NULL, NULL, 55889),
(55890, '3.40.910.10-FF-000025', NULL, 'Deoxyhypusine synthase', 210, NULL, NULL, 55890),
(55891, '2.30.180.10-FF-000154', NULL, NULL, 140, NULL, NULL, 55891),
(55892, '3.40.50.1100-FF-000049', NULL, 'Cysteine synthase, putative', 30, NULL, NULL, 55892),
(55893, '3.90.79.10-FF-000221', NULL, 'Uncharacterized protein', 79, NULL, NULL, 55893),
(55894, '1.20.1530.20-FF-000021', NULL, 'Probable sodium/metabolite cotransporter BASS4, chloroplastic', 331, NULL, NULL, 55894),
(55895, '3.90.1430.10-FF-000009', NULL, NULL, 102, NULL, NULL, 55895);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(55896, '3.30.565.10-FF-000230', NULL, 'PAS domain-containing sensor histidine kinase', 160, NULL, NULL, 55896),
(55897, '2.30.180.10-FF-000042', NULL, 'Fasciclin domain family', 153, NULL, NULL, 55897),
(55898, '3.30.1360.170-FF-000004', NULL, 'Flavin-dependent thymidylate synthase', 202, NULL, NULL, 55898),
(55899, '2.30.30.190-FF-000049', NULL, NULL, 101, NULL, NULL, 55899),
(55900, '3.40.50.300-FF-003863', NULL, 'Predicted protein', 133, NULL, NULL, 55900),
(55901, '1.10.1200.120-FF-000005', NULL, 'Large-conductance mechanosensitive channel', 125, NULL, NULL, 55901),
(55902, '1.10.10.10-FF-001561', NULL, 'Cullin 4B, putative', 72, NULL, NULL, 55902),
(55903, '2.60.40.10-FF-004110', NULL, NULL, 93, NULL, NULL, 55903),
(55904, '3.40.50.10860-FF-000031', NULL, 'Shikimate dehydrogenase (NADP(+))', 111, NULL, NULL, 55904),
(55905, '1.20.1250.20-FF-000775', NULL, 'Drug resistance translocase', 201, NULL, NULL, 55905),
(55906, '1.10.287.600-FF-000003', NULL, 'Tubulin beta chain', 57, NULL, NULL, 55906),
(55907, '2.60.120.330-FF-000242', NULL, 'Uncharacterized protein', 183, NULL, NULL, 55907),
(55908, '3.50.50.60-FF-001077', NULL, 'Os04g0224900 protein', 115, NULL, NULL, 55908),
(55909, '3.40.50.300-FF-007578', NULL, 'Helicase, ATP-dependent, putative', 178, NULL, NULL, 55909),
(55910, '3.10.250.10-FF-000037', NULL, 'Transmembrane protease serine 3', 102, NULL, NULL, 55910),
(55911, '3.30.810.10-FF-000025', NULL, 'Uncharacterized protein', 151, NULL, NULL, 55911),
(55912, '1.10.8.870-FF-000001', NULL, 'Glycerol-3-phosphate dehydrogenase', 130, NULL, NULL, 55912),
(55913, '3.40.50.2000-FF-000909', NULL, 'UDP-N-acetylglucosamine 2-epimerase', 164, NULL, NULL, 55913),
(55914, '3.30.1360.180-FF-000007', NULL, 'Nucleotide phosphatase', 124, NULL, NULL, 55914),
(55915, '1.10.132.60-FF-000004', NULL, 'DNA polymerase', 183, NULL, NULL, 55915),
(55916, '3.40.50.300-FF-000086', NULL, 'Ras-related small GTPase', 192, NULL, NULL, 55916),
(55917, '1.10.10.60-FF-000350', NULL, 'Tigger transposable element derived 6', 58, NULL, NULL, 55917),
(55918, '2.30.31.10-FF-000004', NULL, 'RNA polymerase II transcriptional coactivator KELP', 77, NULL, NULL, 55918),
(55919, '1.25.40.10-FF-001905', NULL, 'Nephrocystin-3', 208, NULL, NULL, 55919),
(55920, '3.30.70.330-FF-001192', NULL, 'TIA-1/TIAL RNA binding protein homolog', 103, NULL, NULL, 55920),
(55921, '3.30.930.10-FF-000186', NULL, 'Aspartyl-tRNA synthetase', 354, NULL, NULL, 55921),
(55922, '3.90.1780.10-FF-000002', NULL, 'Hemagglutinin', 115, NULL, NULL, 55922),
(55923, '1.10.510.10-FF-004207', NULL, NULL, 218, NULL, NULL, 55923),
(55924, '2.60.40.60-FF-000044', NULL, 'Cadherin, EGF LAG seven-pass G-type receptor 3', 102, NULL, NULL, 55924),
(55925, '3.50.50.60-FF-001307', NULL, 'Glutathione reductase', 214, NULL, NULL, 55925),
(55926, '3.90.730.10-FF-000011', NULL, 'Uncharacterized protein', 238, NULL, NULL, 55926),
(55927, '1.25.40.20-FF-001678', NULL, 'Uncharacterized protein', 77, NULL, NULL, 55927),
(55928, '2.60.40.650-FF-000019', NULL, 'Uncharacterized protein', 87, NULL, NULL, 55928),
(55929, '2.130.10.10-FF-003464', NULL, 'Kinesin family member 21B', 85, NULL, NULL, 55929),
(55930, '3.40.30.10-FF-000336', NULL, '2-hydroxychromene-2-carboxylate isomerase', 195, NULL, NULL, 55930),
(55931, '3.90.550.10-FF-000132', NULL, 'UDP-glucose:glycoprotein glucosyltransferase', 242, NULL, NULL, 55931),
(55932, '2.160.20.70-FF-000035', NULL, 'Adenylyl cyclase-associated protein', 164, NULL, NULL, 55932),
(55933, '3.30.160.60-FF-003716', NULL, NULL, 27, NULL, NULL, 55933),
(55934, '1.25.40.10-FF-001675', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 102, NULL, NULL, 55934),
(55935, '3.40.50.300-FF-002121', NULL, 'Uncharacterized protein', 197, NULL, NULL, 55935),
(55936, '2.60.40.10-FF-006015', NULL, NULL, 99, NULL, NULL, 55936),
(55937, '1.20.120.790-FF-000030', NULL, 'Predicted protein', 139, NULL, NULL, 55937),
(55938, '1.10.418.10-FF-000120', NULL, 'Calponin domain containing protein', 107, NULL, NULL, 55938),
(55939, '1.10.3200.20-FF-000016', NULL, NULL, 141, NULL, NULL, 55939);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(55940, '3.30.420.10-FF-000658', NULL, NULL, 294, NULL, NULL, 55940),
(55941, '1.20.1070.10-FF-001410', NULL, 'Uncharacterized protein', 233, NULL, NULL, 55941),
(55942, '3.30.160.60-FF-000153', NULL, 'Zinc finger RNA-binding protein 2', 45, NULL, NULL, 55942),
(55943, '1.25.40.20-FF-001908', NULL, 'Protein 21.1', 74, NULL, NULL, 55943),
(55944, '4.10.1060.10-FF-000038', NULL, 'Uncharacterized protein', 39, NULL, NULL, 55944),
(55945, '2.10.90.10-FF-000080', NULL, 'Nodal homolog 4-A', 112, NULL, NULL, 55945),
(55946, '3.90.190.10-FF-000615', NULL, 'Protein tyrosine phosphatase, receptor type S', 90, NULL, NULL, 55946),
(55947, '1.20.140.150-FF-000050', NULL, 'Uncharacterized protein, isoform B', 126, NULL, NULL, 55947),
(55948, '3.40.605.10-FF-000018', NULL, 'Ethanolamine utilization aldehyde dehydrogenase', 201, NULL, NULL, 55948),
(55949, '3.30.200.20-FF-001067', NULL, 'CAMK/CAMKL protein kinase', 82, NULL, NULL, 55949),
(55950, '2.60.40.1180-FF-000120', NULL, 'Glucosidase, putative', 143, NULL, NULL, 55950),
(55951, '2.170.11.10-FF-000007', NULL, 'Uncharacterized protein', 101, NULL, NULL, 55951),
(55952, '3.80.10.10-FF-000558', NULL, 'Si:ch211-11p18.6', 172, NULL, NULL, 55952),
(55953, '1.20.120.350-FF-000252', NULL, NULL, 173, NULL, NULL, 55953),
(55954, '1.20.140.10-FF-000080', NULL, 'Acyl-Coenzyme A dehydrogenase', 135, NULL, NULL, 55954),
(55955, '2.30.29.30-FF-000853', NULL, 'SMEK (Dictyostelium Suppressor of MEK null) homolog', 58, NULL, NULL, 55955),
(55956, '3.30.1490.20-FF-000047', NULL, 'ATP-grasp domain protein', 63, NULL, NULL, 55956),
(55957, '2.60.40.10-FF-000613', NULL, 'Leptin receptor', 95, NULL, NULL, 55957),
(55958, '3.40.50.300-FF-004138', NULL, 'Related to Cell division control protein 18', 168, NULL, NULL, 55958),
(55959, '1.10.533.10-FF-000180', NULL, 'Si:dkeyp-97b10.3', 101, NULL, NULL, 55959),
(55960, '1.10.630.10-FF-000776', NULL, 'Uncharacterized protein', 161, NULL, NULL, 55960),
(55961, '3.10.20.410-FF-000007', NULL, 'Fimbrial outer membrane usher protein', 115, NULL, NULL, 55961),
(55962, '2.70.50.70-FF-000002', NULL, 'Endoglucanase II', 226, NULL, NULL, 55962),
(55963, '1.10.287.70-FF-000759', NULL, 'Predicted protein', 49, NULL, NULL, 55963),
(55964, '2.60.40.640-FF-000016', NULL, 'thioredoxin-interacting protein-like', 145, NULL, NULL, 55964),
(55965, '1.20.5.110-FF-000215', NULL, 'Vesicle-trafficking protein SEC22b-B', 83, NULL, NULL, 55965),
(55966, '3.30.40.10-FF-000697', NULL, 'Bonus, isoform C', 65, NULL, NULL, 55966),
(55967, '2.40.420.20-FF-000034', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 66, NULL, NULL, 55967),
(55968, '3.40.1180.10-FF-000007', NULL, 'Alkyl transferase', 272, NULL, NULL, 55968),
(55969, '1.20.1440.100-FF-000015', NULL, 'MmyP', 73, NULL, NULL, 55969),
(55970, '2.60.120.310-FF-000022', NULL, 'Uncharacterized protein', 97, NULL, NULL, 55970),
(55971, '3.10.50.40-FF-000022', NULL, 'Peptidylprolyl isomerase', 115, NULL, NULL, 55971),
(55972, '2.60.120.10-FF-000239', NULL, 'Crp/Fnr family transcriptional regulator', 139, NULL, NULL, 55972),
(55973, '3.30.60.90-FF-000008', NULL, 'Transcriptional adapter 2', 55, NULL, NULL, 55973),
(55974, '2.70.50.80-FF-000005', NULL, 'Transcription enhancer factor-like protein egl-44', 205, NULL, NULL, 55974),
(55975, '3.40.50.1820-FF-000496', NULL, 'Protein AUXIN RESPONSE 4 isoform A', 268, NULL, NULL, 55975),
(55976, '3.20.20.70-FF-000433', NULL, '2-isopropylmalate synthase 1 chloroplastic', 193, NULL, NULL, 55976),
(55977, '4.10.400.10-FF-000219', NULL, 'LDL receptor protein 1, isoform F', 45, NULL, NULL, 55977),
(55978, '1.10.150.210-FF-000005', NULL, NULL, 55, NULL, NULL, 55978),
(55979, '1.10.10.60-FF-000024', NULL, 'DNA-directed RNA polymerases I, II, and III subunit', 69, NULL, NULL, 55979),
(55980, '3.30.160.60-FF-004205', NULL, NULL, 76, NULL, NULL, 55980),
(55981, '3.30.200.20-FF-001634', NULL, 'Uncharacterized protein', 92, NULL, NULL, 55981),
(55982, '1.25.10.10-FF-002123', NULL, 'Serine/threonine-protein kinase ULK4', 193, NULL, NULL, 55982),
(55983, '2.60.200.20-FF-000052', NULL, 'Microspherule protein 1', 150, NULL, NULL, 55983);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(55984, '3.30.160.60-FF-000158', NULL, 'Zinc finger protein 362', 28, NULL, NULL, 55984),
(55985, '3.40.50.720-FF-001167', NULL, 'Pentafunctional AROM polypeptide, putative', 194, NULL, NULL, 55985),
(55986, '3.30.450.260-FF-000014', NULL, 'Uncharacterized protein', 45, NULL, NULL, 55986),
(55987, '3.30.70.340-FF-000014', NULL, NULL, 89, NULL, NULL, 55987),
(55988, '1.10.472.80-FF-000266', NULL, NULL, 136, NULL, NULL, 55988),
(55989, '3.30.70.2280-FF-000001', NULL, 'ATP-dependent RNA helicase DDX50', 76, NULL, NULL, 55989),
(55990, '3.30.890.10-FF-000013', NULL, 'Methyl-CpG-binding domain protein 4', 123, NULL, NULL, 55990),
(55991, '3.40.950.10-FF-000022', NULL, 'Periplasmic [Fe] hydrogenase', 229, NULL, NULL, 55991),
(55992, '1.20.1280.50-FF-000151', NULL, 'F-box/kelch-repeat protein At5g42360', 38, NULL, NULL, 55992),
(55993, '3.30.70.330-FF-000011', NULL, 'trinucleotide repeat-containing gene 6A protein-like', 88, NULL, NULL, 55993),
(55994, '2.130.10.10-FF-005829', NULL, 'Putative CPSF-domain protein', 12, NULL, NULL, 55994),
(55995, '2.60.200.40-FF-000058', NULL, 'Diacylglycerol kinase', 170, NULL, NULL, 55995),
(55996, '3.50.50.60-FF-001184', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 89, NULL, NULL, 55996),
(55997, '1.10.246.190-FF-000012', NULL, NULL, 67, NULL, NULL, 55997),
(55998, '3.30.450.20-FF-000489', NULL, 'Sensor histidine kinase, PAS and GAF domain-containing', 125, NULL, NULL, 55998),
(55999, '1.20.58.60-FF-000853', NULL, 'Uncharacterized protein', 138, NULL, NULL, 55999),
(56000, '3.40.50.2000-FF-000786', NULL, 'Uncharacterized protein', 86, NULL, NULL, 56000),
(56001, '3.30.930.10-FF-000293', NULL, 'Uncharacterized protein', 367, NULL, NULL, 56001),
(56002, '1.10.132.70-FF-000002', NULL, 'Telomerase reverse transcriptase', 252, NULL, NULL, 56002),
(56003, '3.40.50.300-FF-006162', NULL, 'Uncharacterized protein', 71, NULL, NULL, 56003),
(56004, '3.20.20.370-FF-000015', NULL, 'Carbohydrate deacetylase', 292, NULL, NULL, 56004),
(56005, '1.25.10.10-FF-000217', NULL, '20S cyclosome subunit (APC1/BimE)', 212, NULL, NULL, 56005),
(56006, '1.10.150.200-FF-000002', NULL, 'Maltooligosyl trehalose synthase', 109, NULL, NULL, 56006),
(56007, '1.10.510.10-FF-001690', NULL, 'Protein kinase, putative', 144, NULL, NULL, 56007),
(56008, '2.60.40.10-FF-003379', NULL, 'GM15906', 107, NULL, NULL, 56008),
(56009, '1.10.246.20-FF-000015', NULL, 'Mediator of RNA polymerase II transcription subunit 15', 38, NULL, NULL, 56009),
(56010, '1.10.630.10-FF-000557', NULL, 'Os01g0350200 protein', 332, NULL, NULL, 56010),
(56011, '3.40.250.10-FF-000238', NULL, 'Protein CBG23257', 52, NULL, NULL, 56011),
(56012, '2.130.10.10-FF-001558', NULL, 'Eukaryotic translation initiation factor 2A', 156, NULL, NULL, 56012),
(56013, '3.30.70.330-FF-001641', NULL, 'Uncharacterized protein', 150, NULL, NULL, 56013),
(56014, '2.60.40.1860-FF-000003', NULL, 'Protein-arginine deiminase type-4', 118, NULL, NULL, 56014),
(56015, '1.25.40.10-FF-000601', NULL, 'DNAJ heat shock N-terminal domain-containing protein', 144, NULL, NULL, 56015),
(56016, '1.25.40.570-FF-000068', NULL, 'Uncharacterized protein', 56, NULL, NULL, 56016),
(56017, '3.40.50.300-FF-005903', NULL, 'tRNA modification GTPase MnmE', 166, NULL, NULL, 56017),
(56018, '1.25.40.10-FF-003148', NULL, 'Uncharacterized protein', 122, NULL, NULL, 56018),
(56019, '3.30.200.20-FF-001286', NULL, 'serine/threonine-protein kinase Chk1 isoform X3', 56, NULL, NULL, 56019),
(56020, '1.25.40.180-FF-000277', NULL, NULL, 167, NULL, NULL, 56020),
(56021, '2.120.10.30-FF-000002', NULL, 'low-density lipoprotein receptor isoform X1', 260, NULL, NULL, 56021),
(56022, '2.30.110.10-FF-000105', NULL, 'Pyridoxamine 5''-phosphate oxidase family protein', 113, NULL, NULL, 56022),
(56023, '1.10.510.10-FF-003483', NULL, NULL, 266, NULL, NULL, 56023),
(56024, '3.40.50.300-FF-006504', NULL, 'GTP-binding protein hflx, putative', 113, NULL, NULL, 56024),
(56025, '1.25.40.20-FF-000604', NULL, 'CBN-TRP-1 protein', 288, NULL, NULL, 56025),
(56026, '1.20.120.1750-FF-000111', NULL, 'RBR-type E3 ubiquitin transferase', 48, NULL, NULL, 56026);
INSERT INTO "PUBLIC"."MODEL" VALUES
(56027, '2.30.30.140-FF-000181', NULL, 'Ubiquitin family, putative', 68, NULL, NULL, 56027),
(56028, '3.30.160.60-FF-006341', NULL, NULL, 61, NULL, NULL, 56028),
(56029, '1.25.70.10-FF-000103', NULL, NULL, 210, NULL, NULL, 56029),
(56030, '3.40.630.30-FF-000431', NULL, 'Uncharacterized protein', 125, NULL, NULL, 56030),
(56031, '3.40.50.2000-FF-001062', NULL, 'Glycogen [starch] synthase', 102, NULL, NULL, 56031),
(56032, '3.10.20.90-FF-000400', NULL, 'Uncharacterized protein', 105, NULL, NULL, 56032),
(56033, '2.30.39.10-FF-000128', NULL, 'Uncharacterized protein', 147, NULL, NULL, 56033),
(56034, '1.10.287.2250-FF-000010', NULL, 'AGAP002720-PA', 80, NULL, NULL, 56034),
(56035, '3.30.9.10-FF-000282', NULL, 'Uncharacterized protein', 187, NULL, NULL, 56035),
(56036, '1.10.10.60-FF-001199', NULL, NULL, 85, NULL, NULL, 56036),
(56037, '3.40.50.150-FF-001654', NULL, NULL, 209, NULL, NULL, 56037),
(56038, '2.40.10.10-FF-000270', NULL, 'GM15595', 237, NULL, NULL, 56038),
(56039, '3.20.20.80-FF-000329', NULL, 'Chitinase', 279, NULL, NULL, 56039),
(56040, '3.40.50.300-FF-001957', NULL, 'Disease resistance protein (TIR-NBS-LRR class)', 152, NULL, NULL, 56040),
(56041, '1.25.40.10-FF-002979', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 153, NULL, NULL, 56041),
(56042, '1.25.10.10-FF-002016', NULL, 'Armadillo-type protein', 153, NULL, NULL, 56042),
(56043, '1.10.290.10-FF-000002', NULL, 'DNA topoisomerase 1', 125, NULL, NULL, 56043),
(56044, '2.130.10.10-FF-000035', NULL, 'Putative echinoderm microtubule-associated protein-like 6', 324, NULL, NULL, 56044),
(56045, '2.60.60.20-FF-000056', NULL, NULL, 116, NULL, NULL, 56045),
(56046, '2.30.30.30-FF-000013', NULL, 'Transcription elongation factor SPT5', 58, NULL, NULL, 56046),
(56047, '2.30.30.100-FF-000079', NULL, 'Sm B', 97, NULL, NULL, 56047),
(56048, '3.40.30.10-FF-000662', NULL, 'YALI0D11066p', 157, NULL, NULL, 56048),
(56049, '3.30.60.20-FF-000122', NULL, 'Protein kinase C', 65, NULL, NULL, 56049),
(56050, '3.90.1200.10-FF-000077', NULL, 'Predicted protein', 171, NULL, NULL, 56050),
(56051, '3.40.50.11980-FF-000024', NULL, 'Uncharacterized protein', 31, NULL, NULL, 56051),
(56052, '3.30.60.30-FF-000125', NULL, 'GM10857', 65, NULL, NULL, 56052),
(56053, '3.30.300.10-FF-000048', NULL, 'GMP synthase [glutamine-hydrolyzing]', 129, NULL, NULL, 56053),
(56054, '3.30.565.10-FF-000016', NULL, 'Chemotaxis protein CheA, putative', 187, NULL, NULL, 56054),
(56055, '3.40.50.720-FF-000566', NULL, 'Putative xanthine dehydrogenase accessory factor subfamily', 128, NULL, NULL, 56055),
(56056, '3.40.50.1820-FF-000619', NULL, 'IP21433p', 267, NULL, NULL, 56056),
(56057, '1.25.40.10-FF-003255', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 162, NULL, NULL, 56057),
(56058, '2.70.50.30-FF-000018', NULL, NULL, 178, NULL, NULL, 56058),
(56059, '1.20.1560.10-FF-000661', NULL, 'AGAP009835-PA', 69, NULL, NULL, 56059),
(56060, '3.40.50.300-FF-006611', NULL, 'ATP binding cassette subfamily A member 2', 95, NULL, NULL, 56060),
(56061, '1.10.8.60-FF-000495', NULL, 'Uncharacterized protein', 85, NULL, NULL, 56061),
(56062, '3.40.50.300-FF-000434', NULL, 'Katanin p60 ATPase-containing subunit A-like 2', 189, NULL, NULL, 56062),
(56063, '2.60.40.1180-FF-000232', NULL, 'Alpha-galactosidase', 102, NULL, NULL, 56063),
(56064, '1.10.555.10-FF-000146', NULL, 'Similar to rho-type GTPase-activating protein', 265, NULL, NULL, 56064),
(56065, '2.30.29.30-FF-000965', NULL, 'AFR725Cp', 106, NULL, NULL, 56065),
(56066, '1.10.1130.10-FF-000001', NULL, 'Periplasmic nitrate reductase, electron transfer subunit', 67, NULL, NULL, 56066),
(56067, '2.60.40.10-FF-005852', NULL, NULL, 100, NULL, NULL, 56067),
(56068, '3.30.70.1230-FF-000153', NULL, 'Guanylyl cyclase, membrane', 218, NULL, NULL, 56068),
(56069, '1.10.1740.10-FF-000025', NULL, 'ECF RNA polymerase sigma factor SigM', 116, NULL, NULL, 56069),
(56070, '2.60.120.370-FF-000012', NULL, NULL, 153, NULL, NULL, 56070),
(56071, '3.90.1100.10-FF-000030', NULL, 'DNA-directed RNA polymerase subunit beta', 175, NULL, NULL, 56071); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(56072, '1.25.40.20-FF-000262', NULL, 'E3 ubiquitin-protein ligase XBAT33', 135, NULL, NULL, 56072),
(56073, '3.40.50.300-FF-002233', NULL, 'Signal recognition particle binding protein', 210, NULL, NULL, 56073),
(56074, '2.60.40.60-FF-000600', NULL, 'Protocadherin 1 gamma 32', 109, NULL, NULL, 56074),
(56075, '3.40.50.2000-FF-000679', NULL, 'Uncharacterized protein', 197, NULL, NULL, 56075),
(56076, '3.40.1110.10-FF-000059', NULL, 'Phospholipid-transporting ATPase', 160, NULL, NULL, 56076),
(56077, '1.10.437.10-FF-000035', NULL, 'Predicted protein', 142, NULL, NULL, 56077),
(56078, '3.20.80.10-FF-000003', NULL, 'Heme-binding protein 1', 172, NULL, NULL, 56078),
(56079, '1.50.40.10-FF-000206', NULL, 'Protein CBG03753', 194, NULL, NULL, 56079),
(56080, '1.10.3080.10-FF-000019', NULL, 'Voltage-gated chloride channel', 394, NULL, NULL, 56080),
(56081, '2.60.120.380-FF-000015', NULL, 'Calpain', 124, NULL, NULL, 56081),
(56082, '3.40.50.140-FF-000021', NULL, 'DNA topoisomerase', 63, NULL, NULL, 56082),
(56083, '3.50.50.60-FF-001419', NULL, 'Uncharacterized protein', 125, NULL, NULL, 56083),
(56084, '1.25.10.10-FF-001847', NULL, 'Dynein, axonemal, assembly factor 5', 234, NULL, NULL, 56084),
(56085, '3.20.20.70-FF-000326', NULL, 'Putative Dihydrodipicolinate synthase', 288, NULL, NULL, 56085),
(56086, '1.10.8.1220-FF-000026', NULL, NULL, 96, NULL, NULL, 56086),
(56087, '1.10.10.350-FF-000006', NULL, 'Glutamate--tRNA ligase', 98, NULL, NULL, 56087),
(56088, '3.40.50.300-FF-002340', NULL, 'Axonemal dynein heavy chain', 176, NULL, NULL, 56088),
(56089, '2.40.240.10-FF-000045', NULL, 'Glutamine--tRNA ligase', 84, NULL, NULL, 56089),
(56090, '2.40.50.100-FF-000013', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 85, NULL, NULL, 56090),
(56091, '3.90.400.10-FF-000020', NULL, 'Alpha-amylase SusG', 45, NULL, NULL, 56091),
(56092, '2.30.30.40-FF-000016', NULL, 'RIMS-binding protein 2 isoform X2', 69, NULL, NULL, 56092),
(56093, '1.25.40.10-FF-001349', NULL, 'Dia2p', 158, NULL, NULL, 56093),
(56094, '1.25.40.10-FF-003474', NULL, 'Os05g0112900 protein', 95, NULL, NULL, 56094),
(56095, '2.30.29.30-FF-001016', NULL, 'IQ motif and SEC7 domain-containing protein 2 isoform X3', 136, NULL, NULL, 56095),
(56096, '2.10.25.10-FF-000788', NULL, 'Neurogenic locus notch homolog protein 2', 32, NULL, NULL, 56096),
(56097, '2.70.130.10-FF-000018', NULL, 'N-acetylglucosamine-1-phosphotransferase subunit gamma', 105, NULL, NULL, 56097),
(56098, '3.30.160.60-FF-002631', NULL, 'zinc finger protein 407 isoform X1', 49, NULL, NULL, 56098),
(56099, '3.30.2020.30-FF-000015', NULL, 'Taurine catabolism dioxygenase TauD, TfdA family-domain-containing protein', 114, NULL, NULL, 56099),
(56100, '3.30.1330.30-FF-000106', NULL, 'YALI0F07447p', 174, NULL, NULL, 56100),
(56101, '2.60.40.640-FF-000011', NULL, 'S-arrestin isoform X2', 184, NULL, NULL, 56101),
(56102, '3.30.70.330-FF-001315', NULL, 'RNA-binding protein with serine-rich domain 1', 143, NULL, NULL, 56102),
(56103, '2.10.25.10-FF-001412', NULL, 'Protein lin-12', 37, NULL, NULL, 56103),
(56104, '3.90.190.10-FF-000508', NULL, 'Uncharacterized protein', 142, NULL, NULL, 56104),
(56105, '4.10.60.10-FF-000011', NULL, 'splicing factor 1', 54, NULL, NULL, 56105),
(56106, '3.90.245.10-FF-000018', NULL, 'Inosine-uridine preferring nucleoside hydrolase family protein', 313, NULL, NULL, 56106),
(56107, '3.30.160.60-FF-005285', NULL, NULL, 89, NULL, NULL, 56107),
(56108, '2.130.10.10-FF-000254', NULL, 'dmX-like protein 2 isoform X2', 270, NULL, NULL, 56108),
(56109, '2.40.10.10-FF-000163', NULL, 'AGAP001251-PA', 92, NULL, NULL, 56109),
(56110, '1.10.630.10-FF-000664', NULL, 'Uncharacterized protein', 183, NULL, NULL, 56110),
(56111, '2.120.10.30-FF-000221', NULL, 'Predicted protein', 83, NULL, NULL, 56111),
(56112, '2.60.120.10-FF-000565', NULL, 'Cyclic AMP-dependent protein kinase-like protein regulatory subunit', 131, NULL, NULL, 56112),
(56113, '2.60.40.650-FF-000014', NULL, 'Uncharacterized protein', 135, NULL, NULL, 56113),
(56114, '3.90.1410.10-FF-000014', NULL, 'SET domain-containing protein', 277, NULL, NULL, 56114);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(56115, '3.40.120.10-FF-000010', NULL, 'phosphomannomutase/phosphoglucomutase isoform X1', 78, NULL, NULL, 56115),
(56116, '2.30.29.30-FF-000746', NULL, 'Serine/threonine-protein kinase NrkA', 97, NULL, NULL, 56116),
(56117, '1.20.1070.10-FF-000567', NULL, 'Uncharacterized protein', 268, NULL, NULL, 56117),
(56118, '1.10.8.10-FF-000290', NULL, 'Uncharacterized protein', 70, NULL, NULL, 56118),
(56119, '1.10.506.10-FF-000050', NULL, 'Uncharacterized protein', 258, NULL, NULL, 56119),
(56120, '3.30.200.20-FF-001179', NULL, 'Uncharacterized protein', 65, NULL, NULL, 56120),
(56121, '2.130.10.10-FF-001665', NULL, 'U3 small nucleolar RNA-associated protein 13', 246, NULL, NULL, 56121),
(56122, '3.10.450.240-FF-000030', NULL, 'Predicted protein', 126, NULL, NULL, 56122),
(56123, '1.20.1720.10-FF-000084', NULL, NULL, 223, NULL, NULL, 56123),
(56124, '3.90.1480.20-FF-000061', NULL, 'Uncharacterized protein', 68, NULL, NULL, 56124),
(56125, '2.60.40.10-FF-003598', NULL, NULL, 89, NULL, NULL, 56125),
(56126, '3.20.20.60-FF-000104', NULL, 'Putative lysase', 280, NULL, NULL, 56126),
(56127, '4.10.280.10-FF-000119', NULL, 'Helix Loop Helix', 82, NULL, NULL, 56127),
(56128, '1.20.1110.10-FF-000048', NULL, 'Phospholipid-transporting ATPase', 103, NULL, NULL, 56128),
(56129, '1.20.1070.10-FF-000909', NULL, 'Uncharacterized protein', 328, NULL, NULL, 56129),
(56130, '1.20.1560.10-FF-000880', NULL, 'Chromosome 21, whole genome shotgun sequence', 311, NULL, NULL, 56130),
(56131, '1.25.10.10-FF-003427', NULL, 'Predicted protein', 176, NULL, NULL, 56131),
(56132, '3.30.1040.20-FF-000002', NULL, 'Thiol-activated cytolysin', 48, NULL, NULL, 56132),
(56133, '1.25.40.10-FF-003822', NULL, 'Uncharacterized protein', 130, NULL, NULL, 56133),
(56134, '1.25.40.10-FF-003603', NULL, 'Squamous cell carcinoma antigen recognized by T-cells 3', 304, NULL, NULL, 56134),
(56135, '3.30.360.10-FF-000041', NULL, 'Dihydrodipicolinate reductase', 96, NULL, NULL, 56135),
(56136, '3.40.50.410-FF-000349', NULL, 'Uncharacterized protein', 96, NULL, NULL, 56136),
(56137, '3.10.105.10-FF-000026', NULL, 'Extracellular solute-binding protein, family 5', 177, NULL, NULL, 56137),
(56138, '1.25.40.70-FF-000035', NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', 195, NULL, NULL, 56138),
(56139, '3.30.65.10-FF-000001', NULL, 'DNA topoisomerase 1', 63, NULL, NULL, 56139),
(56140, '1.20.1540.10-FF-000098', NULL, 'Integral membrane protein Rhomboid homolog', 195, NULL, NULL, 56140),
(56141, '2.60.40.10-FF-001917', NULL, 'Protogenin', 97, NULL, NULL, 56141),
(56142, '2.40.30.10-FF-000046', NULL, 'Elongation factor Tu', 61, NULL, NULL, 56142),
(56143, '3.40.720.10-FF-000325', NULL, 'Predicted protein', 138, NULL, NULL, 56143),
(56144, '1.20.5.110-FF-000097', NULL, 'Syntaxin, Qa-SNARE family', 100, NULL, NULL, 56144),
(56145, '2.130.10.10-FF-005936', NULL, 'Intraflagellar transport 140', 261, NULL, NULL, 56145),
(56146, '3.90.550.10-FF-000137', NULL, 'Hexosyltransferase', 270, NULL, NULL, 56146),
(56147, '3.40.50.720-FF-002359', NULL, 'Uncharacterized protein', 79, NULL, NULL, 56147),
(56148, '3.30.70.330-FF-001860', NULL, NULL, 107, NULL, NULL, 56148),
(56149, '1.20.5.4090-FF-000002', NULL, 'Uncharacterized protein, isoform A', 94, NULL, NULL, 56149),
(56150, '4.10.170.10-FF-000004', NULL, 'Nucleosome assembly protein 1', 45, NULL, NULL, 56150),
(56151, '3.40.1170.60-FF-000050', NULL, NULL, 72, NULL, NULL, 56151),
(56152, '1.10.510.10-FF-001919', NULL, 'Protein CBR-TWK-5', 265, NULL, NULL, 56152),
(56153, '3.10.290.10-FF-000039', NULL, 'Pseudouridine synthase', 56, NULL, NULL, 56153),
(56154, '3.30.200.20-FF-001853', NULL, 'Ribosomal protein S6 kinase', 19, NULL, NULL, 56154),
(56155, '2.60.40.10-FF-000164', NULL, 'nexilin isoform X1', 99, NULL, NULL, 56155),
(56156, '1.10.10.60-FF-000243', NULL, 'Motor neuron and pancreas homeobox 1', 94, NULL, NULL, 56156),
(56157, '3.80.10.10-FF-002817', NULL, 'Protein zer-1 homolog-like Protein', 319, NULL, NULL, 56157),
(56158, '1.25.40.10-FF-004311', NULL, 'Uncharacterized protein', 182, NULL, NULL, 56158);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(56159, '3.30.500.10-FF-000030', NULL, NULL, 179, NULL, NULL, 56159),
(56160, '3.40.630.30-FF-000650', NULL, 'Uncharacterized protein', 163, NULL, NULL, 56160),
(56161, '3.30.160.60-FF-005498', NULL, NULL, 85, NULL, NULL, 56161),
(56162, '2.60.120.10-FF-000346', NULL, 'Germin-like protein', 196, NULL, NULL, 56162),
(56163, '2.130.10.10-FF-001884', NULL, 'WD domain-containing protein', 176, NULL, NULL, 56163),
(56164, '3.40.50.720-FF-001274', NULL, 'Pentafunctional AROM polypeptide, putative', 173, NULL, NULL, 56164),
(56165, '3.40.50.2300-FF-001382', NULL, NULL, 150, NULL, NULL, 56165),
(56166, '1.50.40.10-FF-000083', NULL, 'Mitochondrial substrate carrier family protein', 179, NULL, NULL, 56166),
(56167, '3.30.450.20-FF-000618', NULL, 'Uncharacterized protein', 109, NULL, NULL, 56167),
(56168, '3.20.20.80-FF-000655', NULL, 'Zgc:66313', 67, NULL, NULL, 56168),
(56169, '3.40.1030.10-FF-000007', NULL, 'Anthranilate phosphoribosyltransferase', 260, NULL, NULL, 56169),
(56170, '3.30.160.60-FF-001788', NULL, 'ras-responsive element-binding protein 1', 29, NULL, NULL, 56170),
(56171, '1.10.730.10-FF-000031', NULL, 'Putative Methionyl-tRNA synthetase', 154, NULL, NULL, 56171),
(56172, '3.30.160.60-FF-006122', NULL, NULL, 83, NULL, NULL, 56172),
(56173, '3.20.20.140-FF-000082', NULL, 'Amidohydrolase', 347, NULL, NULL, 56173),
(56174, '2.40.30.190-FF-000002', NULL, 'Protein ORF2', 93, NULL, NULL, 56174),
(56175, '3.30.160.60-FF-002070', NULL, 'Zinc finger protein', 30, NULL, NULL, 56175),
(56176, '1.10.246.10-FF-000012', NULL, 'Serum albumin', 28, NULL, NULL, 56176),
(56177, '3.30.1310.20-FF-000001', NULL, 'DNA sequence', 63, NULL, NULL, 56177),
(56178, '3.30.420.40-FF-000190', NULL, 'Hsp70 family chaperone Lhs1/Orp150', 153, NULL, NULL, 56178),
(56179, '1.25.10.10-FF-002342', NULL, 'Uncharacterized protein', 290, NULL, NULL, 56179),
(56180, '1.10.3380.10-FF-000059', NULL, 'Uncharacterized protein', 121, NULL, NULL, 56180),
(56181, '3.30.505.10-FF-000125', NULL, 'GD21505', 102, NULL, NULL, 56181),
(56182, '3.20.20.70-FF-000652', NULL, NULL, 235, NULL, NULL, 56182),
(56183, '2.30.29.30-FF-001235', NULL, 'Predicted protein', 114, NULL, NULL, 56183),
(56184, '3.40.50.720-FF-001622', NULL, 'Fatty acyl-CoA reductase', 75, NULL, NULL, 56184),
(56185, '1.25.40.20-FF-000043', NULL, 'Transient receptor potential cation channel subfamily C member 7', 213, NULL, NULL, 56185),
(56186, '1.20.58.90-FF-000047', NULL, NULL, 77, NULL, NULL, 56186),
(56187, '3.40.50.720-FF-000998', NULL, 'Short-chain dehydrogenase/reductase SDR', 234, NULL, NULL, 56187),
(56188, '2.60.40.1180-FF-000013', NULL, 'Alpha-L-fucosidase', 101, NULL, NULL, 56188),
(56189, '1.10.150.390-FF-000002', NULL, 'DNA-directed RNA polymerase subunit beta''''', 62, NULL, NULL, 56189),
(56190, '1.25.40.10-FF-000040', NULL, 'Tetratricopeptide repeat domain 28', 313, NULL, NULL, 56190),
(56191, '1.25.40.10-FF-001568', NULL, 'Pentatricopeptide repeat-containing protein At1g09900', 91, NULL, NULL, 56191),
(56192, '3.30.230.80-FF-000029', NULL, 'Heat shock protein 82, putative', 82, NULL, NULL, 56192),
(56193, '1.10.510.10-FF-003825', NULL, NULL, 112, NULL, NULL, 56193),
(56194, '1.20.5.5160-FF-000008', NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', 42, NULL, NULL, 56194),
(56195, '3.90.1490.10-FF-000013', NULL, 'Uncharacterized protein', 94, NULL, NULL, 56195),
(56196, '2.60.40.10-FF-005633', NULL, NULL, 133, NULL, NULL, 56196),
(56197, '3.40.1110.10-FF-000278', NULL, NULL, 166, NULL, NULL, 56197),
(56198, '2.60.40.10-FF-000506', NULL, 'HEPACAM family member 2 isoform X2', 84, NULL, NULL, 56198),
(56199, '2.130.10.10-FF-002160', NULL, 'Autophagy related 16 like 1', 137, NULL, NULL, 56199),
(56200, '1.20.58.70-FF-000041', NULL, 'Pep12p', 131, NULL, NULL, 56200),
(56201, '3.20.20.140-FF-000424', NULL, 'Uncharacterized protein', 48, NULL, NULL, 56201),
(56202, '1.20.58.80-FF-000044', NULL, 'SD04548p', 112, NULL, NULL, 56202),
(56203, '3.90.1140.10-FF-000021', NULL, 'AaceriAEL214Cp', 216, NULL, NULL, 56203),
(56204, '3.80.10.10-FF-002475', NULL, 'Uncharacterized protein', 265, NULL, NULL, 56204);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(56205, '3.40.50.150-FF-001873', NULL, NULL, 159, NULL, NULL, 56205),
(56206, '3.30.160.60-FF-002412', NULL, 'Zinc finger protein', 28, NULL, NULL, 56206),
(56207, '3.10.490.20-FF-000030', NULL, 'Predicted protein', 50, NULL, NULL, 56207),
(56208, '3.20.10.10-FF-000055', NULL, 'Uncharacterized protein', 132, NULL, NULL, 56208),
(56209, '3.40.30.10-FF-000443', NULL, 'Ubiquitin regulatory X', 155, NULL, NULL, 56209),
(56210, '1.10.8.60-FF-000276', NULL, 'Origin of replication binding protein, putative', 78, NULL, NULL, 56210),
(56211, '2.80.10.50-FF-000038', NULL, 'very large A-kinase anchor protein isoform X1', 128, NULL, NULL, 56211),
(56212, '1.10.472.80-FF-000154', NULL, 'Uncharacterized protein', 141, NULL, NULL, 56212),
(56213, '3.90.190.10-FF-000492', NULL, 'Dual specificity phosphatase', 155, NULL, NULL, 56213),
(56214, '3.90.70.10-FF-000128', NULL, 'Ubiquitin carboxyl-terminal hydrolase 15', 310, NULL, NULL, 56214),
(56215, '3.30.200.20-FF-001522', NULL, 'Non-specific serine/threonine protein kinase', 96, NULL, NULL, 56215),
(56216, '3.30.230.10-FF-000397', NULL, 'Uncharacterized protein', 165, NULL, NULL, 56216),
(56217, '3.30.365.10-FF-000029', NULL, 'Aldehyde oxidase', 137, NULL, NULL, 56217),
(56218, '1.10.1900.10-FF-000015', NULL, 'Hyperplastic discs, isoform B', 82, NULL, NULL, 56218),
(56219, '4.10.400.10-FF-000107', NULL, 'low-density lipoprotein receptor-related protein 1B', 40, NULL, NULL, 56219),
(56220, '1.10.510.10-FF-002414', NULL, 'Uncharacterized protein', 280, NULL, NULL, 56220),
(56221, '3.30.450.40-FF-000141', NULL, 'Adenylate cyclase', 162, NULL, NULL, 56221),
(56222, '1.10.510.10-FF-001796', NULL, 'UNC51-like kinase, putative', 355, NULL, NULL, 56222),
(56223, '3.30.460.10-FF-000099', NULL, 'GM17777', 110, NULL, NULL, 56223),
(56224, '3.40.50.300-FF-006050', NULL, 'ABC transporter, putative', 131, NULL, NULL, 56224),
(56225, '1.25.10.10-FF-000105', NULL, 'Exportin for tRNA', 939, NULL, NULL, 56225),
(56226, '3.30.70.330-FF-001753', NULL, 'RE24907p', 169, NULL, NULL, 56226),
(56227, '1.10.3260.10-FF-000011', NULL, 'DNA ligase', 237, NULL, NULL, 56227),
(56228, '3.40.720.10-FF-000090', NULL, 'DUF4976 domain-containing protein', 480, NULL, NULL, 56228),
(56229, '3.30.870.10-FF-000130', NULL, 'Putative endonuclease', 148, NULL, NULL, 56229),
(56230, '1.20.120.1320-FF-000005', NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase', 102, NULL, NULL, 56230),
(56231, '2.10.25.30-FF-000002', NULL, NULL, 69, NULL, NULL, 56231),
(56232, '2.60.120.1540-FF-000003', NULL, 'Complement C3', 116, NULL, NULL, 56232),
(56233, '3.80.10.10-FF-000906', NULL, 'Leucine Rich Repeat family protein, expressed', 199, NULL, NULL, 56233),
(56234, '3.40.50.300-FF-000209', NULL, 'Cell division protein FtsK', 302, NULL, NULL, 56234),
(56235, '2.60.40.690-FF-000003', NULL, 'Thioester-containing protein 2, isoform B', 150, NULL, NULL, 56235),
(56236, '2.60.40.10-FF-000271', NULL, 'Sidekick cell adhesion molecule 2', 93, NULL, NULL, 56236),
(56237, '3.30.200.20-FF-001398', NULL, NULL, 102, NULL, NULL, 56237),
(56238, '3.10.20.90-FF-000512', NULL, 'Phosphoinositide phospholipase C', 123, NULL, NULL, 56238),
(56239, '2.60.40.3210-FF-000004', NULL, 'oncoprotein-induced transcript 3 protein', 113, NULL, NULL, 56239),
(56240, '1.10.630.10-FF-000338', NULL, 'Uncharacterized protein', 84, NULL, NULL, 56240),
(56241, '3.40.50.1440-FF-000022', NULL, 'Cell division protein FtsZ 1, chloroplastic', 215, NULL, NULL, 56241),
(56242, '2.30.30.1020-FF-000051', NULL, NULL, 172, NULL, NULL, 56242),
(56243, '1.50.40.10-FF-000431', NULL, 'Solute carrier family 25 member 31', 178, NULL, NULL, 56243),
(56244, '3.30.2460.20-FF-000006', NULL, 'Protein Wnt', 67, NULL, NULL, 56244),
(56245, '2.130.10.10-FF-001339', NULL, 'Guanine nucleotide-binding protein beta subunit-like protein', 209, NULL, NULL, 56245),
(56246, '1.10.840.10-FF-000039', NULL, 'Protein ste6', 216, NULL, NULL, 56246),
(56247, '1.20.120.1760-FF-000002', NULL, 'Choline/ethanolamine phosphotransferase 1', 197, NULL, NULL, 56247),
(56248, '3.40.50.360-FF-000082', NULL, 'Probable NAD(P)H dehydrogenase', 258, NULL, NULL, 56248);
INSERT INTO "PUBLIC"."MODEL" VALUES
(56249, '3.30.1360.40-FF-000049', NULL, 'DNA topoisomerase 2', 97, NULL, NULL, 56249),
(56250, '1.25.40.10-FF-002170', NULL, 'Pentatricopeptide repeat-containing protein At1g22830', 60, NULL, NULL, 56250),
(56251, '2.60.120.290-FF-000084', NULL, 'Zinc metalloproteinase', 111, NULL, NULL, 56251),
(56252, '3.40.640.10-FF-000032', NULL, 'Histidinol-phosphate aminotransferase', 205, NULL, NULL, 56252),
(56253, '2.130.10.10-FF-001446', NULL, 'WD domain containing protein', 307, NULL, NULL, 56253),
(56254, '2.130.10.10-FF-005717', NULL, 'Damage-specific DNA binding protein 1', 140, NULL, NULL, 56254),
(56255, '2.60.40.10-FF-003941', NULL, NULL, 105, NULL, NULL, 56255),
(56256, '3.40.630.30-FF-000543', NULL, 'Uncharacterized protein', 224, NULL, NULL, 56256),
(56257, '3.40.50.1460-FF-000028', NULL, 'Uncharacterized protein', 241, NULL, NULL, 56257),
(56258, '3.40.50.300-FF-001738', NULL, 'Putative DNA repair helicase', 257, NULL, NULL, 56258),
(56259, '3.40.250.10-FF-000126', NULL, 'Uncharacterized protein', 146, NULL, NULL, 56259),
(56260, '1.10.287.110-FF-000171', NULL, 'Related to PAM16-Presequence translocase-Associated Motor', 91, NULL, NULL, 56260),
(56261, '2.60.40.3200-FF-000001', NULL, 'Structural polyprotein', 206, NULL, NULL, 56261),
(56262, '3.30.30.30-FF-000067', NULL, 'Uncharacterized protein', 60, NULL, NULL, 56262),
(56263, '3.30.2440.10-FF-000002', NULL, 'SPI-2 type III secretion system effector SseJ', 102, NULL, NULL, 56263),
(56264, '2.60.120.1560-FF-000009', NULL, 'Flocculation protein FLO9', 164, NULL, NULL, 56264),
(56265, '3.40.50.150-FF-000350', NULL, 'Probable pectin methylesterase CGR3', 177, NULL, NULL, 56265),
(56266, '3.30.930.10-FF-000074', NULL, 'Serine/threonine-protein kinase gcn2', 336, NULL, NULL, 56266),
(56267, '3.10.250.10-FF-000149', NULL, NULL, 59, NULL, NULL, 56267),
(56268, '3.30.160.60-FF-006116', NULL, NULL, 43, NULL, NULL, 56268),
(56269, '1.10.132.10-FF-000012', NULL, NULL, 69, NULL, NULL, 56269),
(56270, '3.40.190.80-FF-000052', NULL, 'AGAP001047-PA', 128, NULL, NULL, 56270),
(56271, '1.10.132.20-FF-000015', NULL, 'Ribosome-recycling factor, mitochondrial', 93, NULL, NULL, 56271),
(56272, '1.10.510.10-FF-001807', NULL, NULL, 60, NULL, NULL, 56272),
(56273, '3.30.830.10-FF-000021', NULL, 'Cytochrome b-c1 complex subunit 2', 219, NULL, NULL, 56273),
(56274, '3.40.50.2300-FF-001270', NULL, NULL, 191, NULL, NULL, 56274),
(56275, '1.20.1560.10-FF-000767', NULL, 'Predicted protein', 322, NULL, NULL, 56275),
(56276, '2.130.10.10-FF-003576', NULL, 'WD repeat domain 36', 217, NULL, NULL, 56276),
(56277, '1.10.132.30-FF-000018', NULL, 'DNA-directed RNA polymerase subunit', 96, NULL, NULL, 56277),
(56278, '2.40.50.830-FF-000001', NULL, 'mRNA-capping enzyme catalytic subunit', 134, NULL, NULL, 56278),
(56279, '3.80.10.10-FF-004493', NULL, 'Leucine-rich repeat protein kinase family protein', 88, NULL, NULL, 56279),
(56280, '3.50.70.10-FF-000012', NULL, 'Chalcone-flavonone isomerase family protein', 12, NULL, NULL, 56280),
(56281, '3.40.390.10-FF-000288', NULL, NULL, 101, NULL, NULL, 56281),
(56282, '4.10.1000.10-FF-000147', NULL, 'Zinc finger protein', 38, NULL, NULL, 56282),
(56283, '1.10.10.750-FF-000019', NULL, 'Unplaced genomic scaffold supercont1.13, whole genome shotgun sequence', 85, NULL, NULL, 56283),
(56284, '1.25.10.10-FF-001741', NULL, 'cell differentiation protein RCD1 homolog', 170, NULL, NULL, 56284),
(56285, '3.40.50.200-FF-000062', NULL, 'Peptidase S53 propeptide', 372, NULL, NULL, 56285),
(56286, '3.30.160.20-FF-000169', NULL, 'Uncharacterized protein', 76, NULL, NULL, 56286),
(56287, '3.30.420.40-FF-000206', NULL, 'pantothenate kinase 1 isoform X2', 73, NULL, NULL, 56287),
(56288, '3.30.310.130-FF-000001', NULL, 'sentrin-specific protease 6 isoform X1', 53, NULL, NULL, 56288),
(56289, '3.40.50.2300-FF-001157', NULL, NULL, 30, NULL, NULL, 56289),
(56290, '3.30.40.10-FF-001085', NULL, 'Uncharacterized protein', 42, NULL, NULL, 56290),
(56291, '2.60.40.10-FF-001687', NULL, 'Neuroglian, isoform E', 104, NULL, NULL, 56291),
(56292, '3.90.70.10-FF-000241', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 334, NULL, NULL, 56292);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(56293, '1.10.510.10-FF-003937', NULL, NULL, 67, NULL, NULL, 56293),
(56294, '3.60.10.10-FF-000278', NULL, 'Uncharacterized protein', 83, NULL, NULL, 56294),
(56295, '2.130.10.10-FF-005830', NULL, 'Intraflagellar transport 140 homolog (Chlamydomonas)', 386, NULL, NULL, 56295),
(56296, '1.10.3380.10-FF-000065', NULL, 'Uncharacterized protein', 74, NULL, NULL, 56296),
(56297, '1.10.150.20-FF-000299', NULL, 'Uncharacterized protein', 92, NULL, NULL, 56297),
(56298, '3.40.50.720-FF-000779', NULL, 'Homoserine dehydrogenase', 153, NULL, NULL, 56298),
(56299, '3.40.50.10130-FF-000043', NULL, 'FA core complex-associated protein 24', 144, NULL, NULL, 56299),
(56300, '3.40.33.10-FF-000141', NULL, 'Uncharacterized protein', 149, NULL, NULL, 56300),
(56301, '1.10.565.10-FF-000192', NULL, 'Predicted protein', 107, NULL, NULL, 56301),
(56302, '1.10.10.440-FF-000027', NULL, 'Formin binding protein (FNB3)', 81, NULL, NULL, 56302),
(56303, '3.40.50.720-FF-001510', NULL, 'Dihydroflavonol-4-reductase', 140, NULL, NULL, 56303),
(56304, '1.20.1270.60-FF-000092', NULL, 'Gvp36p', 291, NULL, NULL, 56304),
(56305, '1.10.540.10-FF-000112', NULL, 'Acyl-coenzyme A oxidase', 117, NULL, NULL, 56305),
(56306, '2.60.120.10-FF-000127', NULL, 'Glutamine-transport ATP-binding protein ABC transporter GLNQ', 102, NULL, NULL, 56306),
(56307, '3.30.420.40-FF-000313', NULL, 'Actin family', 155, NULL, NULL, 56307),
(56308, '3.40.50.150-FF-000237', NULL, 'N-methyltransferase 1', 232, NULL, NULL, 56308),
(56309, '1.20.920.30-FF-000021', NULL, 'Dynein heavy chain 6, axonemal', 216, NULL, NULL, 56309),
(56310, '3.40.50.300-FF-008180', NULL, 'Protein translocase subunit SecA', 82, NULL, NULL, 56310),
(56311, '3.30.70.330-FF-003097', NULL, NULL, 147, NULL, NULL, 56311),
(56312, '2.130.10.10-FF-003795', NULL, 'Uncharacterized protein', 396, NULL, NULL, 56312),
(56313, '3.30.160.60-FF-005279', NULL, NULL, 76, NULL, NULL, 56313),
(56314, '3.20.20.190-FF-000175', NULL, NULL, 27, NULL, NULL, 56314),
(56315, '1.10.10.10-FF-001903', NULL, 'N(4)-bis(aminopropyl)spermidine synthase', 83, NULL, NULL, 56315),
(56316, '2.40.10.10-FF-000051', NULL, 'complement C2 isoform X1', 172, NULL, NULL, 56316),
(56317, '1.50.40.10-FF-000318', NULL, 'Peroxisomal adenine nucleotide carrier 1', 69, NULL, NULL, 56317),
(56318, '1.20.1250.20-FF-001163', NULL, 'Transporter, putative', 206, NULL, NULL, 56318),
(56319, '1.20.5.110-FF-000327', NULL, 'Qa-SNARE, SYP2/Pep12p/Syntaxin 7-type', 102, NULL, NULL, 56319),
(56320, '3.40.1110.10-FF-000172', NULL, 'Phospholipid-transporting ATPase', 176, NULL, NULL, 56320),
(56321, '1.10.10.10-FF-000144', NULL, 'la-related protein 4 isoform X2', 94, NULL, NULL, 56321),
(56322, '2.40.50.690-FF-000032', NULL, 'Uncharacterized protein', 158, NULL, NULL, 56322),
(56323, '3.40.1050.10-FF-000003', NULL, 'Carbonic anhydrase', 208, NULL, NULL, 56323),
(56324, '3.40.50.150-FF-000018', NULL, 'Ribosomal RNA large subunit methyltransferase K/L', 175, NULL, NULL, 56324),
(56325, '1.10.510.10-FF-003718', NULL, NULL, 156, NULL, NULL, 56325),
(56326, '3.60.130.10-FF-000085', NULL, 'Uncharacterized protein', 108, NULL, NULL, 56326),
(56327, '2.40.30.10-FF-000052', NULL, 'Selenocysteine-specific elongation factor EF-Sec', 90, NULL, NULL, 56327),
(56328, '3.40.50.1820-FF-000844', NULL, 'Uncharacterized protein', 337, NULL, NULL, 56328),
(56329, '1.10.560.10-FF-000001', NULL, '60 kDa chaperonin', 242, NULL, NULL, 56329),
(56330, '2.60.40.150-FF-000072', NULL, 'translocation protein SEC63 homolog', 126, NULL, NULL, 56330),
(56331, '3.40.50.150-FF-001547', NULL, NULL, 87, NULL, NULL, 56331),
(56332, '3.30.160.60-FF-006009', NULL, NULL, 35, NULL, NULL, 56332),
(56333, '3.30.70.1230-FF-000046', NULL, 'Luxr family transcriptional regulator', 100, NULL, NULL, 56333),
(56334, '3.40.50.140-FF-000015', NULL, 'DNA topoisomerase', 182, NULL, NULL, 56334),
(56335, '1.20.5.990-FF-000001', NULL, 'TNFAIP3 interacting protein 1', 113, NULL, NULL, 56335),
(56336, '2.70.98.30-FF-000027', NULL, 'Lysosomal alpha-mannosidase, putative', 268, NULL, NULL, 56336),
(56337, '3.40.50.10070-FF-000002', NULL, 'Tol-Pal system protein TolB', 164, NULL, NULL, 56337);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(56338, '3.60.10.10-FF-000059', NULL, 'Inositol phosphosphingolipids phospholipase C', 327, NULL, NULL, 56338),
(56339, '3.40.50.1010-FF-000247', NULL, NULL, 173, NULL, NULL, 56339),
(56340, '3.90.1100.10-FF-000024', NULL, 'DNA-directed RNA polymerase subunit beta', 455, NULL, NULL, 56340),
(56341, '1.10.287.1490-FF-000080', NULL, 'Bicaudal D', 190, NULL, NULL, 56341),
(56342, '2.60.40.10-FF-002305', NULL, 'Basement membrane proteoglycan', 96, NULL, NULL, 56342),
(56343, '1.25.10.10-FF-001960', NULL, 'RNA binding S1 domain protein', 225, NULL, NULL, 56343),
(56344, '2.40.240.10-FF-000051', NULL, 'Glutamine-tRNA ligase', 91, NULL, NULL, 56344),
(56345, '3.40.630.30-FF-000324', NULL, 'Autoinducer synthase', 198, NULL, NULL, 56345),
(56346, '3.40.50.1000-FF-000025', NULL, 'HAD hydrolase, family IB', 138, NULL, NULL, 56346),
(56347, '1.20.1280.50-FF-000038', NULL, 'F-box/LRR-repeat protein 17 isoform X3', 46, NULL, NULL, 56347),
(56348, '3.30.160.60-FF-000501', NULL, 'PR domain zinc finger protein 12', 26, NULL, NULL, 56348),
(56349, '3.40.33.10-FF-000028', NULL, 'Uncharacterized protein, isoform B', 266, NULL, NULL, 56349),
(56350, '3.30.200.20-FF-001409', NULL, 'Serine/threonine protein kinase', 88, NULL, NULL, 56350),
(56351, '2.40.170.20-FF-000042', NULL, 'TonB-linked outer membrane protein, SusC/RagA family', 644, NULL, NULL, 56351),
(56352, '3.40.800.20-FF-000025', NULL, 'Histone deacetylase HOS1', 408, NULL, NULL, 56352),
(56353, '1.25.40.10-FF-004204', NULL, 'Pentatricopeptide repeat-containing protein', 70, NULL, NULL, 56353),
(56354, '3.30.60.160-FF-000003', NULL, 'Polyhomeotic distal, isoform A', 37, NULL, NULL, 56354),
(56355, '1.20.1600.10-FF-000030', NULL, 'TolC-like outer membrane protein', 407, NULL, NULL, 56355),
(56356, '3.30.1150.10-FF-000007', NULL, 'Energy transducer TonB', 100, NULL, NULL, 56356),
(56357, '3.40.50.1000-FF-000244', NULL, 'Haloacid dehalogenase-like hydrolase', 121, NULL, NULL, 56357),
(56358, '3.30.40.10-FF-002389', NULL, 'Uncharacterized protein', 60, NULL, NULL, 56358),
(56359, '3.40.850.10-FF-000548', NULL, 'Uncharacterized protein', 213, NULL, NULL, 56359),
(56360, '3.40.50.720-FF-000892', NULL, 'Nuclear receptor binding factor-like protein', 173, NULL, NULL, 56360),
(56361, '1.20.58.2220-FF-000008', NULL, 'Grid2 interacting protein', 363, NULL, NULL, 56361),
(56362, '1.10.20.10-FF-000190', NULL, 'Histone H2A', 121, NULL, NULL, 56362),
(56363, '3.40.50.1010-FF-000028', NULL, '5''-3'' exonuclease family protein', 203, NULL, NULL, 56363),
(56364, '2.30.30.40-FF-000241', NULL, 'Menage a trois, isoform C', 146, NULL, NULL, 56364),
(56365, '3.30.70.1660-FF-000040', NULL, 'Uncharacterized protein', 97, NULL, NULL, 56365),
(56366, '2.130.10.10-FF-000029', NULL, 'WD repeat-containing protein 5', 315, NULL, NULL, 56366),
(56367, '2.60.40.10-FF-005739', NULL, NULL, 105, NULL, NULL, 56367),
(56368, '3.20.20.220-FF-000004', NULL, 'Bifunctional protein PutA', 393, NULL, NULL, 56368),
(56369, '3.40.1090.10-FF-000112', NULL, 'Lysophospholipase', 378, NULL, NULL, 56369),
(56370, '1.10.3080.10-FF-000025', NULL, 'Chloride channel protein', 476, NULL, NULL, 56370),
(56371, '3.30.70.390-FF-000001', NULL, 'EBNA1', 149, NULL, NULL, 56371),
(56372, '3.40.50.150-FF-001766', NULL, NULL, 215, NULL, NULL, 56372),
(56373, '1.10.510.10-FF-002521', NULL, 'Uncharacterized protein', 267, NULL, NULL, 56373),
(56374, '2.40.10.10-FF-000612', NULL, NULL, 109, NULL, NULL, 56374),
(56375, '3.40.50.300-FF-001845', NULL, 'Pre-mRNA-splicing helicase BRR2, putative', 35, NULL, NULL, 56375),
(56376, '1.20.58.340-FF-000036', NULL, 'CorA-like Mg2+ transporter protein, putative', 57, NULL, NULL, 56376),
(56377, '2.10.25.10-FF-000569', NULL, 'Laminin subunit alpha 4', 75, NULL, NULL, 56377),
(56378, '1.10.10.10-FF-001780', NULL, 'Uncharacterized protein', 72, NULL, NULL, 56378),
(56379, '3.90.190.10-FF-000385', NULL, 'Uncharacterized protein', 172, NULL, NULL, 56379),
(56380, '1.25.10.10-FF-001398', NULL, 'Condensin complex subunit 1', 163, NULL, NULL, 56380),
(56381, '3.60.10.10-FF-000391', NULL, 'Uncharacterized protein', 108, NULL, NULL, 56381);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(56382, '2.60.40.10-FF-004323', NULL, NULL, 92, NULL, NULL, 56382),
(56383, '3.40.1800.20-FF-000025', NULL, NULL, 76, NULL, NULL, 56383),
(56384, '3.40.50.300-FF-000428', NULL, 'TATA-binding protein-associated factor 172', 313, NULL, NULL, 56384),
(56385, '3.30.70.1230-FF-000265', NULL, 'Uncharacterized protein', 142, NULL, NULL, 56385),
(56386, '1.10.630.10-FF-000445', NULL, 'Uncharacterized protein', 254, NULL, NULL, 56386),
(56387, '3.30.70.330-FF-001534', NULL, 'RNA binding protein, putative', 158, NULL, NULL, 56387),
(56388, '3.20.20.210-FF-000001', NULL, 'Uroporphyrinogen decarboxylase', 353, NULL, NULL, 56388),
(56389, '1.10.442.10-FF-000002', NULL, 'Cytochrome c oxidase subunit V', 128, NULL, NULL, 56389),
(56390, '1.20.1740.10-FF-000192', NULL, 'Uncharacterized protein', 224, NULL, NULL, 56390),
(56391, '3.30.1960.10-FF-000018', NULL, 'Uncharacterized protein', 222, NULL, NULL, 56391),
(56392, '1.25.40.10-FF-003367', NULL, 'Pentatricopeptide repeat-containing protein isoform A', 67, NULL, NULL, 56392),
(56393, '1.25.10.10-FF-001628', NULL, 'YALI0F19382p', 489, NULL, NULL, 56393),
(56394, '1.10.10.1200-FF-000003', NULL, 'MAGE family member F1', 95, NULL, NULL, 56394),
(56395, '3.90.1200.10-FF-000083', NULL, 'Uncharacterized protein', 131, NULL, NULL, 56395),
(56396, '2.130.10.10-FF-002053', NULL, 'Uncharacterized protein', 169, NULL, NULL, 56396),
(56397, '4.10.400.10-FF-000220', NULL, 'Lipophorin receptor 2, isoform A', 41, NULL, NULL, 56397),
(56398, '2.60.40.1730-FF-000094', NULL, NULL, 216, NULL, NULL, 56398),
(56399, '3.80.10.10-FF-000889', NULL, 'RE38148p', 139, NULL, NULL, 56399),
(56400, '2.60.40.10-FF-001468', NULL, 'ICOS ligand isoform b', 125, NULL, NULL, 56400),
(56401, '2.130.10.10-FF-003812', NULL, 'Uncharacterized protein', 308, NULL, NULL, 56401),
(56402, '1.10.8.60-FF-000383', NULL, 'Uncharacterized protein', 90, NULL, NULL, 56402),
(56403, '2.70.98.20-FF-000024', NULL, 'Amine oxidase', 447, NULL, NULL, 56403),
(56404, '3.20.20.370-FF-000021', NULL, 'Uncharacterized protein', 212, NULL, NULL, 56404),
(56405, '3.30.1130.10-FF-000006', NULL, 'NADPH-dependent 7-cyano-7-deazaguanine reductase', 118, NULL, NULL, 56405),
(56406, '3.10.580.10-FF-000028', NULL, 'Chloride channel protein', 149, NULL, NULL, 56406),
(56407, '3.40.50.300-FF-002452', NULL, 'ABC-type metal ion transporter', 267, NULL, NULL, 56407),
(56408, '3.30.505.10-FF-000018', NULL, 'Tyrosine-protein phosphatase non-receptor type', 102, NULL, NULL, 56408),
(56409, '1.20.1110.10-FF-000161', NULL, NULL, 97, NULL, NULL, 56409),
(56410, '2.60.40.1730-FF-000105', NULL, NULL, 209, NULL, NULL, 56410),
(56411, '1.20.58.1100-FF-000010', NULL, 'Uncharacterized protein', 166, NULL, NULL, 56411),
(56412, '2.70.98.10-FF-000021', NULL, 'Uncharacterized isomerase YNR071C', 342, NULL, NULL, 56412),
(56413, '3.30.40.10-FF-001321', NULL, 'Polycomb group RING finger protein 1', 54, NULL, NULL, 56413),
(56414, '1.10.510.10-FF-002302', NULL, NULL, 230, NULL, NULL, 56414),
(56415, '2.30.30.140-FF-000175', NULL, 'Histone acetyltransferase', 108, NULL, NULL, 56415),
(56416, '3.80.10.10-FF-003200', NULL, 'Toll-like receptor 2', 227, NULL, NULL, 56416),
(56417, '1.10.3570.10-FF-000001', NULL, 'Nucleoprotein', 183, NULL, NULL, 56417),
(56418, '1.10.510.10-FF-004090', NULL, NULL, 155, NULL, NULL, 56418),
(56419, '2.30.110.10-FF-000094', NULL, 'AaceriAAR087Cp', 175, NULL, NULL, 56419),
(56420, '3.90.1290.10-FF-000026', NULL, 'Dystonin', 150, NULL, NULL, 56420),
(56421, '3.80.10.10-FF-002582', NULL, 'Uncharacterized protein', 105, NULL, NULL, 56421),
(56422, '3.30.160.60-FF-004211', NULL, NULL, 55, NULL, NULL, 56422),
(56423, '3.30.160.60-FF-003593', NULL, 'GM21248', 81, NULL, NULL, 56423),
(56424, '1.10.274.30-FF-000004', NULL, 'Putative Chromatin modification-related protein eaf3', 180, NULL, NULL, 56424),
(56425, '3.30.565.10-FF-000123', NULL, 'GHKL domain protein', 135, NULL, NULL, 56425),
(56426, '3.90.228.10-FF-000046', NULL, 'Probable inactive poly [ADP-ribose] polymerase SRO5', 189, NULL, NULL, 56426),
(56427, '1.20.1250.20-FF-000449', NULL, 'monocarboxylate transporter 13', 203, NULL, NULL, 56427);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(56428, '1.25.40.120-FF-000068', NULL, 'Uncharacterized protein', 196, NULL, NULL, 56428),
(56429, '1.10.15.40-FF-000001', NULL, 'Ion-translocating oxidoreductase complex subunit B', 51, NULL, NULL, 56429),
(56430, '2.40.50.1020-FF-000015', NULL, 'DNA-binding response regulator', 102, NULL, NULL, 56430),
(56431, '1.10.510.10-FF-004432', NULL, NULL, 58, NULL, NULL, 56431),
(56432, '2.130.10.10-FF-003357', NULL, 'Uncharacterized protein', 97, NULL, NULL, 56432),
(56433, '3.40.50.300-FF-003756', NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 10, mitochondrial', 137, NULL, NULL, 56433),
(56434, '3.40.50.620-FF-000755', NULL, 'Os01g0259600 protein', 135, NULL, NULL, 56434),
(56435, '3.40.190.10-FF-000975', NULL, 'Peptide ABC transporter, peptide-binding protein', 107, NULL, NULL, 56435),
(56436, '3.30.200.20-FF-000105', NULL, 'Casein kinase II subunit alpha', 60, NULL, NULL, 56436),
(56437, '3.90.70.10-FF-000022', NULL, 'Ubiquitin carboxyl-terminal hydrolase 24', 361, NULL, NULL, 56437),
(56438, '3.50.50.60-FF-000003', NULL, 'Succinate dehydrogenase [ubiquinone] flavoprotein subunit, mitochondrial', 303, NULL, NULL, 56438),
(56439, '1.10.287.70-FF-000198', NULL, 'TOK2 potassium channel', 109, NULL, NULL, 56439),
(56440, '3.40.50.300-FF-007685', NULL, 'Protein CBR-RAB-30', 111, NULL, NULL, 56440),
(56441, '2.130.10.10-FF-000361', NULL, 'Activating molecule in beclin-1-regulated autophagy', 193, NULL, NULL, 56441),
(56442, '1.10.510.10-FF-000161', NULL, 'Wall-associated receptor kinase-like 20', 211, NULL, NULL, 56442),
(56443, '1.10.220.10-FF-000060', NULL, 'Annexin', 77, NULL, NULL, 56443),
(56444, '1.10.8.60-FF-000506', NULL, 'ATPase, AAA family protein', 63, NULL, NULL, 56444),
(56445, '3.10.20.90-FF-000731', NULL, 'SWAP (Suppressor-of-White-APricot)/surp domain-containing protein', 71, NULL, NULL, 56445),
(56446, '3.40.50.150-FF-000131', NULL, 'tRNA wybutosine-synthesizing protein 2/3/4', 196, NULL, NULL, 56446),
(56447, '2.60.40.10-FF-002182', NULL, 'Titin homolog', 112, NULL, NULL, 56447),
(56448, '2.70.130.10-FF-000125', NULL, NULL, 207, NULL, NULL, 56448),
(56449, '3.80.10.10-FF-002924', NULL, 'Uncharacterized protein', 130, NULL, NULL, 56449),
(56450, '3.30.830.10-FF-000240', NULL, 'Probable mitochondrial-processing peptidase subunit alpha', 219, NULL, NULL, 56450),
(56451, '1.10.238.10-FF-000128', NULL, 'Ubiquitin carboxyl-terminal hydrolase 32', 150, NULL, NULL, 56451),
(56452, '3.30.9.10-FF-000175', NULL, 'N-methyl-L-tryptophan oxidase', 158, NULL, NULL, 56452),
(56453, '1.20.120.350-FF-000027', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 131, NULL, NULL, 56453),
(56454, '3.80.10.10-FF-000783', NULL, 'Leucine-rich repeat-containing protein 15', 203, NULL, NULL, 56454),
(56455, '1.25.10.10-FF-000324', NULL, 'Tetratricopeptide repeat domain 12', 405, NULL, NULL, 56455),
(56456, '3.40.50.300-FF-004032', NULL, 'Dynein heavy chain', 222, NULL, NULL, 56456),
(56457, '3.30.160.60-FF-003935', NULL, NULL, 29, NULL, NULL, 56457),
(56458, '3.40.50.300-FF-000760', NULL, 'Cobalt ABC transporter ATP-binding protein', 237, NULL, NULL, 56458),
(56459, '3.20.20.70-FF-000764', NULL, NULL, 368, NULL, NULL, 56459),
(56460, '1.10.287.610-FF-000006', NULL, 'DNA ligase B', 53, NULL, NULL, 56460),
(56461, '3.60.21.10-FF-000073', NULL, 'Serine/threonine-protein phosphatase with EF-hands', 147, NULL, NULL, 56461),
(56462, '3.40.1190.20-FF-000168', NULL, 'Carbohydrate kinase, PfkB family', 326, NULL, NULL, 56462),
(56463, '1.10.418.20-FF-000011', NULL, 'Ubiquitin-like-specific protease 1D', 112, NULL, NULL, 56463),
(56464, '1.20.1070.10-FF-000898', NULL, 'Vasoactive intestinal polypeptide receptor 2 variant 1', 83, NULL, NULL, 56464),
(56465, '3.90.550.10-FF-000244', NULL, 'Ime2-dependent signaling-related protein', 287, NULL, NULL, 56465),
(56466, '3.20.20.80-FF-000767', NULL, 'Uncharacterized protein', 48, NULL, NULL, 56466),
(56467, '2.60.40.10-FF-000052', NULL, 'Contactin 1', 101, NULL, NULL, 56467),
(56468, '1.10.10.60-FF-000131', NULL, 'Ventral anterior homeobox 2', 83, NULL, NULL, 56468);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(56469, '1.25.50.20-FF-000105', NULL, 'Uncharacterized protein', 106, NULL, NULL, 56469),
(56470, '3.90.550.50-FF-000121', NULL, 'Uncharacterized protein', 199, NULL, NULL, 56470),
(56471, '1.50.40.10-FF-000195', NULL, 'Mitochondrial carrier protein, putative', 323, NULL, NULL, 56471),
(56472, '1.50.40.10-FF-000537', NULL, 'Uncharacterized protein', 153, NULL, NULL, 56472),
(56473, '1.10.510.10-FF-000503', NULL, 'Uncharacterized protein, isoform D', 186, NULL, NULL, 56473),
(56474, '1.20.1740.10-FF-000079', NULL, 'Amino acid APC family transporter', 436, NULL, NULL, 56474),
(56475, '1.25.40.10-FF-000152', NULL, 'Amyloid protein-binding protein 2 isoform 1', 155, NULL, NULL, 56475),
(56476, '3.30.160.60-FF-000265', NULL, 'IKAROS family zinc finger 1', 27, NULL, NULL, 56476),
(56477, '3.30.1360.70-FF-000030', NULL, NULL, 107, NULL, NULL, 56477),
(56478, '3.30.160.60-FF-006010', NULL, NULL, 35, NULL, NULL, 56478),
(56479, '3.30.200.20-FF-001741', NULL, NULL, 91, NULL, NULL, 56479),
(56480, '3.40.120.10-FF-000009', NULL, 'Phosphoglucomutase, cytoplasmic 1', 99, NULL, NULL, 56480),
(56481, '3.40.50.11190-FF-000001', NULL, 'Cytidylyltransferase domain protein', 134, NULL, NULL, 56481),
(56482, '1.10.150.650-FF-000002', NULL, 'PHP domain-containing protein', 73, NULL, NULL, 56482),
(56483, '3.40.50.10860-FF-000025', NULL, 'Shikimate dehydrogenase (NADP(+))', 136, NULL, NULL, 56483),
(56484, '1.25.40.20-FF-000155', NULL, 'Serine/threonine-protein kinase TNNI3K', 135, NULL, NULL, 56484),
(56485, '1.10.10.10-FF-001448', NULL, 'Replication Factor A 28 kDa subunit, putative', 61, NULL, NULL, 56485),
(56486, '4.10.280.10-FF-000226', NULL, 'Uncharacterized protein', 79, NULL, NULL, 56486),
(56487, '3.30.160.60-FF-000607', NULL, 'zinc finger X-chromosomal protein-like isoform X1', 65, NULL, NULL, 56487),
(56488, '2.40.20.10-FF-000113', NULL, 'Uncharacterized protein', 77, NULL, NULL, 56488),
(56489, '3.30.420.10-FF-000664', NULL, NULL, 288, NULL, NULL, 56489),
(56490, '3.40.1350.10-FF-000043', NULL, 'Uncharacterized protein', 122, NULL, NULL, 56490),
(56491, '1.25.40.10-FF-001456', NULL, 'Vegetative storage protein', 115, NULL, NULL, 56491),
(56492, '3.40.50.200-FF-000168', NULL, 'Uncharacterized protein', 96, NULL, NULL, 56492),
(56493, '3.30.160.60-FF-005734', NULL, NULL, 71, NULL, NULL, 56493),
(56494, '1.25.40.790-FF-000010', NULL, 'NTL-1a', 309, NULL, NULL, 56494),
(56495, '3.80.10.10-FF-001401', NULL, 'F-box and leucine rich repeat protein 18', 162, NULL, NULL, 56495),
(56496, '1.20.120.350-FF-000140', NULL, NULL, 145, NULL, NULL, 56496),
(56497, '3.60.21.10-FF-000415', NULL, 'Uncharacterized protein', 283, NULL, NULL, 56497),
(56498, '1.10.510.10-FF-000048', NULL, 'Protein kinase C', 196, NULL, NULL, 56498),
(56499, '2.60.40.10-FF-003828', NULL, NULL, 107, NULL, NULL, 56499),
(56500, '1.10.287.3610-FF-000002', NULL, 'Diacylglycerol kinase', 116, NULL, NULL, 56500),
(56501, '1.10.238.10-FF-000241', NULL, 'Calpain-A, isoform C', 170, NULL, NULL, 56501),
(56502, '3.30.70.100-FF-000066', NULL, 'Protein PYRICULARIA ORYZAE RESISTANCE 21', 65, NULL, NULL, 56502),
(56503, '1.10.8.60-FF-000164', NULL, 'ATP-dependent Clp protease, putative', 103, NULL, NULL, 56503),
(56504, '3.40.30.10-FF-000555', NULL, 'Protein disulfide-isomerase domain', 137, NULL, NULL, 56504),
(56505, '3.30.450.90-FF-000021', NULL, 'General secretion pathway protein E', 125, NULL, NULL, 56505),
(56506, '3.30.70.270-FF-000089', NULL, 'Biofilm architecture maintenance protein mbaA', 185, NULL, NULL, 56506),
(56507, '1.20.1070.10-FF-000679', NULL, 'Predicted protein', 121, NULL, NULL, 56507),
(56508, '2.60.40.60-FF-000151', NULL, 'Cadherin 17', 107, NULL, NULL, 56508),
(56509, '3.90.1740.10-FF-000005', NULL, 'Uncharacterized protein', 251, NULL, NULL, 56509),
(56510, '1.10.10.790-FF-000003', NULL, 'Splicing factor, suppressor of white-apricot homolog', 59, NULL, NULL, 56510),
(56511, '1.10.1200.270-FF-000016', NULL, 'Salicylate/benzoate carboxyl methyltransferase', 76, NULL, NULL, 56511),
(56512, '1.10.230.10-FF-000010', NULL, 'ATP-citrate synthase', 103, NULL, NULL, 56512);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(56513, '2.60.40.640-FF-000123', NULL, 'Meiotically up-regulated gene 170 protein', 136, NULL, NULL, 56513),
(56514, '3.30.70.260-FF-000086', NULL, 'Methionine import ATP-binding protein MetN', 102, NULL, NULL, 56514),
(56515, '1.25.40.10-FF-003586', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 162, NULL, NULL, 56515),
(56516, '1.20.58.390-FF-000135', NULL, 'Ligand-Gated ion Channel', 143, NULL, NULL, 56516),
(56517, '1.10.560.10-FF-000107', NULL, 'T-complex protein 1 subunit epsilon', 74, NULL, NULL, 56517),
(56518, '3.90.226.10-FF-000210', NULL, 'Peptidase', 199, NULL, NULL, 56518),
(56519, '3.90.550.20-FF-000028', NULL, 'Alpha-1,6-mannosyltransferase, putative', 241, NULL, NULL, 56519),
(56520, '3.10.20.90-FF-000057', NULL, 'Putative ubiquitin carboxyl-terminal hydrolase 7', 97, NULL, NULL, 56520),
(56521, '2.10.25.10-FF-001300', NULL, 'cadherin EGF LAG seven-pass G-type receptor 2 isoform X2', 39, NULL, NULL, 56521),
(56522, '3.40.120.10-FF-000122', NULL, 'Uncharacterized protein', 69, NULL, NULL, 56522),
(56523, '2.10.25.10-FF-000682', NULL, 'Fat-like cadherin-related tumor suppressor homolog', 39, NULL, NULL, 56523),
(56524, '2.60.120.920-FF-000093', NULL, 'Si:dkey-103k4.1', 190, NULL, NULL, 56524),
(56525, '2.10.50.10-FF-000083', NULL, 'TNF receptor superfamily member 10c', 28, NULL, NULL, 56525),
(56526, '1.10.555.10-FF-000253', NULL, NULL, 126, NULL, NULL, 56526),
(56527, '1.20.58.60-FF-000398', NULL, 'VAB-10B protein', 308, NULL, NULL, 56527),
(56528, '3.40.720.10-FF-000089', NULL, 'Sulfatase', 413, NULL, NULL, 56528),
(56529, '3.30.70.1820-FF-000015', NULL, NULL, 91, NULL, NULL, 56529),
(56530, '3.40.630.30-FF-000088', NULL, 'Ebony protein', 213, NULL, NULL, 56530),
(56531, '2.130.10.10-FF-000142', NULL, 'Nuclear pore complex protein Nup214', 403, NULL, NULL, 56531),
(56532, '3.80.10.10-FF-001620', NULL, 'Leucine-rich repeat receptor protein kinase EMS1', 140, NULL, NULL, 56532),
(56533, '1.20.1250.20-FF-000781', NULL, 'Vesicular GLUtamate transporter', 195, NULL, NULL, 56533),
(56534, '3.40.20.10-FF-000055', NULL, 'Quail, isoform C', 113, NULL, NULL, 56534),
(56535, '2.60.40.10-FF-004104', NULL, NULL, 93, NULL, NULL, 56535),
(56536, '4.10.900.10-FF-000022', NULL, 'Cadherin 26', 81, NULL, NULL, 56536),
(56537, '1.25.40.20-FF-001459', NULL, 'Uncharacterized protein', 302, NULL, NULL, 56537),
(56538, '1.10.150.50-FF-000173', NULL, 'Ephrin receptor', 76, NULL, NULL, 56538),
(56539, '3.40.50.2020-FF-000106', NULL, 'Uridine kinase, putative (AFU_orthologue AFUA_2G05430)', 211, NULL, NULL, 56539),
(56540, '3.40.50.300-FF-007466', NULL, 'Uncharacterized protein ABCG33', 241, NULL, NULL, 56540),
(56541, '3.10.290.10-FF-000040', NULL, 'Pseudouridine synthase', 58, NULL, NULL, 56541),
(56542, '4.10.280.10-FF-000007', NULL, 'single-minded homolog 1 isoform X1', 53, NULL, NULL, 56542),
(56543, '3.40.50.300-FF-000541', NULL, 'Immunity related GTPase M', 182, NULL, NULL, 56543),
(56544, '2.60.120.40-FF-000001', NULL, 'Complement C1q B chain', 133, NULL, NULL, 56544),
(56545, '3.40.50.1400-FF-000038', NULL, 'Protoporphyrin ferrochelatase', 108, NULL, NULL, 56545),
(56546, '3.30.40.10-FF-001208', NULL, 'Histone-lysine N-methyltransferase', 44, NULL, NULL, 56546),
(56547, '4.10.240.10-FF-000229', NULL, 'Uncharacterized protein', 80, NULL, NULL, 56547),
(56548, '2.170.150.20-FF-000021', NULL, 'Peptide methionine sulfoxide reductase MsrB (R-form specific)', 132, NULL, NULL, 56548),
(56549, '3.30.70.330-FF-001079', NULL, 'La protein homolog', 120, NULL, NULL, 56549),
(56550, '3.10.50.40-FF-000128', NULL, 'Peptidylprolyl isomerase', 77, NULL, NULL, 56550),
(56551, '3.90.25.10-FF-000058', NULL, 'dTDP-4-dehydrorhamnose reductase', 69, NULL, NULL, 56551),
(56552, '1.20.272.10-FF-000014', NULL, 'DNA polymerase clamp loader subunit', 91, NULL, NULL, 56552),
(56553, '1.10.238.260-FF-000004', NULL, 'Homocitrate synthase', 105, NULL, NULL, 56553),
(56554, '2.40.50.140-FF-001183', NULL, NULL, 153, NULL, NULL, 56554),
(56555, '2.30.42.10-FF-000597', NULL, NULL, 102, NULL, NULL, 56555);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(56556, '3.40.140.10-FF-000011', NULL, 'tRNA-specific adenosine deaminase', 156, NULL, NULL, 56556),
(56557, '3.30.1330.30-FF-000095', NULL, 'YALI0F27995p', 82, NULL, NULL, 56557),
(56558, '3.40.50.300-FF-003975', NULL, 'Structural maintenance of chromosomes protein', 218, NULL, NULL, 56558),
(56559, '1.10.510.10-FF-000380', NULL, 'Serine/threonine-protein kinase ppk15', 224, NULL, NULL, 56559),
(56560, '4.10.400.10-FF-000326', NULL, 'glycoprotein 330-like isoform X1', 40, NULL, NULL, 56560),
(56561, '1.10.565.10-FF-000079', NULL, 'Hepatocyte nuclear factor 4-alpha', 248, NULL, NULL, 56561),
(56562, '3.30.160.60-FF-000720', NULL, 'zinc finger protein 18 isoform X2', 31, NULL, NULL, 56562),
(56563, '2.10.25.10-FF-000805', NULL, 'Low-density lipoprotein receptor-related protein 2', 38, NULL, NULL, 56563),
(56564, '1.10.220.160-FF-000023', NULL, NULL, 21, NULL, NULL, 56564),
(56565, '2.130.10.30-FF-000148', NULL, NULL, 183, NULL, NULL, 56565),
(56566, '2.60.40.790-FF-000140', NULL, NULL, 130, NULL, NULL, 56566),
(56567, '3.40.140.20-FF-000014', NULL, NULL, 97, NULL, NULL, 56567),
(56568, '3.90.550.10-FF-000025', NULL, 'Glycogenin-1 isoform 1', 262, NULL, NULL, 56568),
(56569, '3.30.70.330-FF-002838', NULL, NULL, 85, NULL, NULL, 56569),
(56570, '3.40.50.2000-FF-000100', NULL, 'Glycosyltransferase family 1 protein', 243, NULL, NULL, 56570),
(56571, '3.40.50.1820-FF-001226', NULL, 'Carboxylic ester hydrolase', 351, NULL, NULL, 56571),
(56572, '2.30.39.10-FF-000016', NULL, 'Probable non-inhibitory serpin-Z5', 134, NULL, NULL, 56572),
(56573, '3.40.50.300-FF-004251', NULL, 'Midasin', 147, NULL, NULL, 56573),
(56574, '1.10.8.720-FF-000080', NULL, 'Dynein heavy chain, cytosolic, putative', 192, NULL, NULL, 56574),
(56575, '1.10.390.10-FF-000061', NULL, 'Uncharacterized protein', 272, NULL, NULL, 56575),
(56576, '1.20.1070.10-FF-001174', NULL, 'G-protein coupled receptor moody', 288, NULL, NULL, 56576),
(56577, '3.40.50.1100-FF-000162', NULL, 'Cysteine synthase, putative', 50, NULL, NULL, 56577),
(56578, '2.60.120.330-FF-000135', NULL, 'Putative 2-oxoacid dependent dioxygenase', 120, NULL, NULL, 56578),
(56579, '1.10.287.70-FF-000653', NULL, 'Uncharacterized protein', 149, NULL, NULL, 56579),
(56580, '3.40.1010.10-FF-000006', NULL, 'Siroheme synthase, putative', 122, NULL, NULL, 56580),
(56581, '3.40.50.10190-FF-000364', NULL, 'Uncharacterized protein', 129, NULL, NULL, 56581),
(56582, '1.20.5.170-FF-000087', NULL, 'FOS like 1, AP-1 transcription factor subunit', 41, NULL, NULL, 56582),
(56583, '1.10.20.10-FF-000313', NULL, NULL, 32, NULL, NULL, 56583),
(56584, '2.60.40.60-FF-000712', NULL, 'Cadherin 3', 100, NULL, NULL, 56584),
(56585, '3.50.50.80-FF-000009', NULL, NULL, 118, NULL, NULL, 56585),
(56586, '3.40.50.880-FF-000113', NULL, 'Homoserine O-succinyltransferase', 302, NULL, NULL, 56586),
(56587, '3.15.20.10-FF-000012', NULL, 'Putative BPI/LBP family protein At1g04970', 253, NULL, NULL, 56587),
(56588, '1.10.1000.11-FF-000004', NULL, 'PH and SEC7 domain-containing protein 2', 117, NULL, NULL, 56588),
(56589, '2.60.40.200-FF-000014', NULL, 'Superoxide dismutase 1 copper chaperone', 130, NULL, NULL, 56589),
(56590, '2.40.50.140-FF-000688', NULL, NULL, 58, NULL, NULL, 56590),
(56591, '3.30.2130.10-FF-000012', NULL, 'Aspartokinase', 81, NULL, NULL, 56591),
(56592, '3.40.50.1110-FF-000165', NULL, 'Iduronate-2-sulfatase', 252, NULL, NULL, 56592),
(56593, '1.20.1310.20-FF-000038', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 187, NULL, NULL, 56593),
(56594, '1.20.5.110-FF-000108', NULL, 'SNARE protein, putative', 74, NULL, NULL, 56594),
(56595, '2.130.10.10-FF-003918', NULL, 'Transcription factor tau subunit sfc6', 262, NULL, NULL, 56595),
(56596, '3.10.110.10-FF-000100', NULL, 'RWD domain-containing protein', 118, NULL, NULL, 56596),
(56597, '3.90.70.10-FF-000460', NULL, 'Uncharacterized protein', 134, NULL, NULL, 56597),
(56598, '3.40.50.300-FF-008303', NULL, 'Uncharacterized protein', 262, NULL, NULL, 56598),
(56599, '3.40.50.300-FF-000322', NULL, 'probable ATP-dependent RNA helicase DDX23', 279, NULL, NULL, 56599);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(56600, '1.25.40.20-FF-000374', NULL, 'Vacuolar protein sorting-associated protein 27', 153, NULL, NULL, 56600),
(56601, '1.10.10.10-FF-001667', NULL, 'Non-structural maintenance of chromosomes element 1 homolog', 49, NULL, NULL, 56601),
(56602, '1.10.533.10-FF-000073', NULL, 'Inactive caspase-12', 79, NULL, NULL, 56602),
(56603, '1.10.287.130-FF-000177', NULL, 'Hybrid sensor histidine kinase/response regulator', 65, NULL, NULL, 56603),
(56604, '3.40.50.1820-FF-000389', NULL, 'Mono-and diacylglycerol lipase', 286, NULL, NULL, 56604),
(56605, '1.10.530.10-FF-000050', NULL, 'Possible membrane protein', 123, NULL, NULL, 56605),
(56606, '2.60.120.200-FF-000675', NULL, 'Uncharacterized protein', 51, NULL, NULL, 56606),
(56607, '3.40.50.450-FF-000007', NULL, 'LOG family protein ygdH', 329, NULL, NULL, 56607),
(56608, '1.10.238.10-FF-000460', NULL, 'Calcium-binding allergen Ole e 8', 72, NULL, NULL, 56608),
(56609, '2.60.40.10-FF-003609', NULL, NULL, 135, NULL, NULL, 56609),
(56610, '2.40.50.100-FF-000125', NULL, 'Efflux transporter, RND family, MFP subunit', 71, NULL, NULL, 56610),
(56611, '1.25.40.20-FF-001791', NULL, 'Uncharacterized protein', 173, NULL, NULL, 56611),
(56612, '3.30.420.610-FF-000001', NULL, 'Meiosis regulator and mRNA stability factor 1', 71, NULL, NULL, 56612),
(56613, '3.50.30.30-FF-000134', NULL, 'Predicted protein', 150, NULL, NULL, 56613),
(56614, '2.60.40.4070-FF-000003', NULL, 'Basal-body rod modification protein FlgD', 87, NULL, NULL, 56614),
(56615, '1.25.10.10-FF-003197', NULL, 'PIKK family atypical protein kinase', 296, NULL, NULL, 56615),
(56616, '3.30.2130.30-FF-000018', NULL, 'THUMP domain-containing 3', 100, NULL, NULL, 56616),
(56617, '2.130.10.10-FF-002727', NULL, 'Uncharacterized protein', 301, NULL, NULL, 56617),
(56618, '3.30.565.10-FF-000005', NULL, 'Heat shock protein 90', 232, NULL, NULL, 56618),
(56619, '3.30.70.330-FF-003119', NULL, NULL, 49, NULL, NULL, 56619),
(56620, '1.10.20.140-FF-000024', NULL, NULL, 52, NULL, NULL, 56620),
(56621, '3.40.1440.10-FF-000005', NULL, 'Structure-specific endonuclease subunit SLX1 homolog', 100, NULL, NULL, 56621),
(56622, '1.25.10.10-FF-000869', NULL, 'Uncharacterized protein', 296, NULL, NULL, 56622),
(56623, '3.80.10.10-FF-000069', NULL, 'leucine-rich repeat-containing protein 3B', 170, NULL, NULL, 56623),
(56624, '2.60.260.20-FF-000005', NULL, 'Chaperone protein dnaJ 1, mitochondrial', 107, NULL, NULL, 56624),
(56625, '3.30.160.60-FF-002671', NULL, NULL, 28, NULL, NULL, 56625),
(56626, '1.20.1250.40-FF-000039', NULL, 'Protein CBG03003', 50, NULL, NULL, 56626),
(56627, '3.40.50.2000-FF-000960', NULL, 'Uncharacterized protein', 101, NULL, NULL, 56627),
(56628, '1.25.40.20-FF-000907', NULL, 'Uncharacterized protein', 186, NULL, NULL, 56628),
(56629, '3.40.50.300-FF-001013', NULL, 'Dynein heavy chain, cytoplasmic', 189, NULL, NULL, 56629),
(56630, '3.40.50.300-FF-001452', NULL, 'U5 small nuclear ribonucleoprotein component', 194, NULL, NULL, 56630),
(56631, '1.10.20.10-FF-000162', NULL, 'CBF/NF-Y transcription factor domain containing protein', 110, NULL, NULL, 56631),
(56632, '1.20.58.60-FF-000252', NULL, 'Spectrin beta chain', 96, NULL, NULL, 56632),
(56633, '3.10.110.10-FF-000179', NULL, 'Uncharacterized protein', 74, NULL, NULL, 56633),
(56634, '3.10.20.770-FF-000019', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit beta isoform', 166, NULL, NULL, 56634),
(56635, '3.20.20.10-FF-000089', NULL, 'Uncharacterized protein', 179, NULL, NULL, 56635),
(56636, '3.30.70.330-FF-000365', NULL, 'U4/U6 snRNA-associated-splicing factor PRP24', 81, NULL, NULL, 56636),
(56637, '3.10.100.10-FF-000094', NULL, 'Uncharacterized protein', 94, NULL, NULL, 56637),
(56638, '2.10.25.10-FF-000232', NULL, 'thrombospondin-3 isoform X1', 38, NULL, NULL, 56638),
(56639, '3.40.50.300-FF-004678', NULL, 'AGAP008081-PA', 163, NULL, NULL, 56639),
(56640, '3.40.640.10-FF-000318', NULL, 'Uncharacterized protein', 252, NULL, NULL, 56640),
(56641, '1.10.530.10-FF-000044', NULL, 'Lipoprotein LpqU', 158, NULL, NULL, 56641),
(56642, '1.10.150.910-FF-000001', NULL, 'DNA damage-binding protein 1', 97, NULL, NULL, 56642);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(56643, '3.40.50.1370-FF-000057', NULL, NULL, 137, NULL, NULL, 56643),
(56644, '3.40.47.10-FF-000167', NULL, '3-oxoacyl-(Acyl carrier protein) synthase II', 246, NULL, NULL, 56644),
(56645, '1.10.8.10-FF-000177', NULL, 'Ubiquitinyl hydrolase 1', 35, NULL, NULL, 56645),
(56646, '3.40.50.10330-FF-000013', NULL, 'NAD kinase isoform X1', 170, NULL, NULL, 56646),
(56647, '1.20.80.10-FF-000030', NULL, 'Pez, isoform A', 118, NULL, NULL, 56647),
(56648, '2.70.150.10-FF-000121', NULL, 'Phospholipid-transporting ATPase', 137, NULL, NULL, 56648),
(56649, '1.20.20.10-FF-000021', NULL, 'ATP synthase subunit 9, mitochondrial', 76, NULL, NULL, 56649),
(56650, '2.120.10.80-FF-000219', NULL, 'Kelch domain-containing protein 9', 167, NULL, NULL, 56650),
(56651, '3.30.160.60-FF-005425', NULL, NULL, 36, NULL, NULL, 56651),
(56652, '3.90.550.10-FF-000233', NULL, 'Glycosyl transferase, group 2 family protein', 234, NULL, NULL, 56652),
(56653, '3.40.50.880-FF-000029', NULL, 'Carbamoyl-phosphate synthase small chain', 181, NULL, NULL, 56653),
(56654, '2.40.50.140-FF-000699', NULL, NULL, 61, NULL, NULL, 56654),
(56655, '1.20.1250.10-FF-000143', NULL, NULL, 25, NULL, NULL, 56655),
(56656, '3.30.470.10-FF-000010', NULL, 'Branched-chain-amino-acid aminotransferase-like protein 1', 126, NULL, NULL, 56656),
(56657, '1.10.630.10-FF-000580', NULL, 'Os10g0514300 protein', 306, NULL, NULL, 56657),
(56658, '3.90.190.10-FF-000250', NULL, 'Predicted protein', 253, NULL, NULL, 56658),
(56659, '2.130.10.10-FF-005280', NULL, 'Uncharacterized protein', 236, NULL, NULL, 56659),
(56660, '3.40.350.10-FF-000038', NULL, 'Aminopeptidase P', 155, NULL, NULL, 56660),
(56661, '3.30.565.10-FF-000477', NULL, 'Uncharacterized protein', 88, NULL, NULL, 56661),
(56662, '3.30.160.60-FF-006414', NULL, NULL, 56, NULL, NULL, 56662),
(56663, '2.20.25.90-FF-000008', NULL, 'Tetrathionate reductase subunit A', 91, NULL, NULL, 56663),
(56664, '1.25.40.970-FF-000002', NULL, 'N-lysine methyltransferase SMYD2 isoform X1', 74, NULL, NULL, 56664),
(56665, '2.80.10.50-FF-000100', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 133, NULL, NULL, 56665),
(56666, '1.10.8.270-FF-000124', NULL, 'Si:ch211-266k8.4', 148, NULL, NULL, 56666),
(56667, '3.40.50.150-FF-000962', NULL, 'mRNA cap guanine-N7 methyltransferase', 314, NULL, NULL, 56667),
(56668, '2.40.20.10-FF-000085', NULL, 'uncharacterized protein LOC101242091', 119, NULL, NULL, 56668),
(56669, '3.30.2350.20-FF-000048', NULL, 'Predicted protein', 252, NULL, NULL, 56669),
(56670, '3.40.50.300-FF-000024', NULL, 'ADP-ribosylation factor 1', 176, NULL, NULL, 56670),
(56671, '3.10.310.20-FF-000017', NULL, 'Exopolyphosphatase', 168, NULL, NULL, 56671),
(56672, '3.30.40.10-FF-000450', NULL, 'RING finger protein 10', 69, NULL, NULL, 56672),
(56673, '1.10.287.370-FF-000052', NULL, 'Tubulin-binding prefolding complex subunit', 130, NULL, NULL, 56673),
(56674, '2.60.40.10-FF-002603', NULL, 'Muscle M-line assembly protein unc-89-like Protein', 94, NULL, NULL, 56674),
(56675, '1.20.1250.20-FF-001814', NULL, 'Monocarboxylate transporter, putative', 159, NULL, NULL, 56675),
(56676, '2.30.31.10-FF-000010', NULL, 'Uncharacterized protein', 77, NULL, NULL, 56676),
(56677, '3.40.30.10-FF-000544', NULL, 'Hydrogenase subunit HymB, putative', 95, NULL, NULL, 56677),
(56678, '3.30.160.60-FF-003660', NULL, NULL, 57, NULL, NULL, 56678),
(56679, '1.20.920.30-FF-000049', NULL, 'Dynein-1-beta heavy chain, flagellar inner arm I1 complex', 141, NULL, NULL, 56679),
(56680, '2.60.120.200-FF-000349', NULL, 'H0201G08.2 protein', 139, NULL, NULL, 56680),
(56681, '3.40.50.1460-FF-000112', NULL, 'Uncharacterized protein', 102, NULL, NULL, 56681),
(56682, '3.20.20.70-FF-000500', NULL, 'Component II, glutamine amidotransferase', 255, NULL, NULL, 56682),
(56683, '3.30.200.20-FF-002415', NULL, 'Uncharacterized protein', 87, NULL, NULL, 56683),
(56684, '2.60.40.1180-FF-000058', NULL, 'Cysteine peptidase, Clan CA, family C2, putative', 104, NULL, NULL, 56684),
(56685, '3.40.50.2300-FF-000308', NULL, 'Metabotropic glutamate receptor', 146, NULL, NULL, 56685);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(56686, '1.10.486.10-FF-000058', NULL, 'ATP-dependent nuclease subunit A', 152, NULL, NULL, 56686),
(56687, '1.20.140.100-FF-000041', NULL, 'Dynein heavy chain', 158, NULL, NULL, 56687),
(56688, '3.30.160.60-FF-005897', NULL, NULL, 53, NULL, NULL, 56688),
(56689, '1.20.1740.10-FF-000051', NULL, 'Amino acid permease', 432, NULL, NULL, 56689),
(56690, '3.40.1160.10-FF-000023', NULL, 'Probable aspartokinase', 306, NULL, NULL, 56690),
(56691, '3.10.580.10-FF-000062', NULL, 'SNF1-related protein kinase regulatory subunit gamma-1-like', 150, NULL, NULL, 56691),
(56692, '2.160.20.10-FF-000304', NULL, 'F-box containing protein, putative', 153, NULL, NULL, 56692),
(56693, '2.40.50.140-FF-000227', NULL, 'Ribonuclease R', 82, NULL, NULL, 56693),
(56694, '3.40.1080.10-FF-000022', NULL, 'Acetyl-CoA hydrolase', 188, NULL, NULL, 56694),
(56695, '2.40.30.270-FF-000026', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', 60, NULL, NULL, 56695),
(56696, '1.20.140.150-FF-000095', NULL, 'Calcium voltage-gated channel auxiliary subunit gamma 7', 53, NULL, NULL, 56696),
(56697, '3.40.50.300-FF-004239', NULL, 'Mitochondrial Rho GTPase', 169, NULL, NULL, 56697),
(56698, '3.90.70.10-FF-000376', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 315, NULL, NULL, 56698),
(56699, '1.10.10.10-FF-000717', NULL, 'Transcription factor of the Forkhead/HNF3 family', 116, NULL, NULL, 56699),
(56700, '2.30.29.30-FF-000752', NULL, 'FERM domain containing protein', 95, NULL, NULL, 56700),
(56701, '3.90.1150.80-FF-000003', NULL, NULL, 114, NULL, NULL, 56701),
(56702, '2.60.120.330-FF-000129', NULL, 'Oxidoreductase, 2OG-Fe oxygenase family protein, expressed', 144, NULL, NULL, 56702),
(56703, '3.40.50.300-FF-005667', NULL, 'DNA double-strand break repair Rad50 ATPase', 196, NULL, NULL, 56703),
(56704, '1.10.510.10-FF-001942', NULL, 'Cdc2, putative', 133, NULL, NULL, 56704),
(56705, '1.25.40.10-FF-003131', NULL, 'Developmental protein', 144, NULL, NULL, 56705),
(56706, '3.80.10.10-FF-001497', NULL, 'Blast:F-box/LRR-repeat protein 2', 167, NULL, NULL, 56706),
(56707, '2.70.130.10-FF-000058', NULL, NULL, 162, NULL, NULL, 56707),
(56708, '3.30.890.10-FF-000002', NULL, 'Bromodomain adjacent to zinc finger domain protein 2B', 64, NULL, NULL, 56708),
(56709, '1.10.405.10-FF-000028', NULL, 'Guanosine nucleotide diphosphate dissociation inhibitor', 31, NULL, NULL, 56709),
(56710, '3.40.1360.10-FF-000004', NULL, 'DNA primase', 128, NULL, NULL, 56710),
(56711, '3.30.1370.100-FF-000036', NULL, 'ATPase, putative', 95, NULL, NULL, 56711),
(56712, '1.20.120.1080-FF-000023', NULL, 'ATP-dependent RNA helicase', 117, NULL, NULL, 56712),
(56713, '1.20.1250.20-FF-000472', NULL, 'Pantothenate transporter, putative', 228, NULL, NULL, 56713),
(56714, '1.20.5.190-FF-000076', NULL, 'Uncharacterized protein, isoform A', 54, NULL, NULL, 56714),
(56715, '3.20.20.80-FF-000649', NULL, 'Predicted protein', 84, NULL, NULL, 56715),
(56716, '3.40.50.11660-FF-000052', NULL, NULL, 85, NULL, NULL, 56716),
(56717, '3.30.70.940-FF-000014', NULL, 'Transcription antitermination protein RfaH', 164, NULL, NULL, 56717),
(56718, '2.40.320.10-FF-000017', NULL, 'Mediator of RNA polymerase II transcription subunit 18', 273, NULL, NULL, 56718),
(56719, '2.60.40.420-FF-000226', NULL, 'Uncharacterized protein', 190, NULL, NULL, 56719),
(56720, '3.40.50.300-FF-003430', NULL, 'DNA mismatch repair protein mutS, putative', 264, NULL, NULL, 56720),
(56721, '3.30.450.20-FF-000629', NULL, 'Serine phosphatase RsbU', 112, NULL, NULL, 56721),
(56722, '3.90.20.20-FF-000022', NULL, 'Protein GrpE', 123, NULL, NULL, 56722),
(56723, '2.40.10.10-FF-000287', NULL, 'Coagulation factor XI', 133, NULL, NULL, 56723),
(56724, '3.30.710.10-FF-000046', NULL, 'BTB/POZ domain-containing protein KCTD7 isoform X1', 101, NULL, NULL, 56724),
(56725, '1.20.1560.10-FF-000806', NULL, 'Uncharacterized protein', 176, NULL, NULL, 56725),
(56726, '2.60.40.10-FF-004520', NULL, NULL, 85, NULL, NULL, 56726),
(56727, '1.10.390.10-FF-000072', NULL, 'Predicted protein', 160, NULL, NULL, 56727); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(56728, '3.80.10.10-FF-002486', NULL, 'Cell surface protein', 130, NULL, NULL, 56728),
(56729, '1.25.40.710-FF-000003', NULL, 'Tripeptidyl-peptidase', 226, NULL, NULL, 56729),
(56730, '3.40.630.10-FF-000200', NULL, 'Uncharacterized protein', 60, NULL, NULL, 56730),
(56731, '2.60.40.1390-FF-000003', NULL, 'myelin regulatory factor-like protein', 75, NULL, NULL, 56731),
(56732, '1.20.120.900-FF-000001', NULL, 'Putative peroxisomal biogenesis factor 19', 126, NULL, NULL, 56732),
(56733, '3.30.2300.10-FF-000008', NULL, 'Probable tRNA sulfurtransferase', 82, NULL, NULL, 56733),
(56734, '3.30.160.60-FF-004469', NULL, NULL, 25, NULL, NULL, 56734),
(56735, '3.90.660.10-FF-000062', NULL, NULL, 219, NULL, NULL, 56735),
(56736, '3.40.850.10-FF-000183', NULL, 'Kinesin-related protein', 303, NULL, NULL, 56736),
(56737, '2.30.110.10-FF-000116', NULL, 'Chromosome 21, whole genome shotgun sequence', 222, NULL, NULL, 56737),
(56738, '2.30.29.70-FF-000005', NULL, 'Proteasomal ubiquitin receptor ADRM1', 120, NULL, NULL, 56738),
(56739, '1.20.5.170-FF-000070', NULL, 'CREB/ATF bZIP transcription factor', 49, NULL, NULL, 56739),
(56740, '2.130.10.10-FF-004705', NULL, 'Predicted protein', 171, NULL, NULL, 56740),
(56741, '1.20.5.1160-FF-000033', NULL, 'Uncharacterized protein', 120, NULL, NULL, 56741),
(56742, '2.60.40.10-FF-004048', NULL, NULL, 97, NULL, NULL, 56742),
(56743, '3.40.50.300-FF-008101', NULL, 'Uncharacterized protein', 110, NULL, NULL, 56743),
(56744, '1.10.287.190-FF-000003', NULL, 'Transcription initiation factor IIA subunit 2', 33, NULL, NULL, 56744),
(56745, '3.40.50.1820-FF-000063', NULL, 'Lipase member H', 306, NULL, NULL, 56745),
(56746, '1.25.40.20-FF-001043', NULL, 'Kinase D-interacting substrate 220', 65, NULL, NULL, 56746),
(56747, '1.25.10.10-FF-000077', NULL, 'Exportin 4', 452, NULL, NULL, 56747),
(56748, '1.25.40.10-FF-000697', NULL, 'UNC-45', 135, NULL, NULL, 56748),
(56749, '1.25.40.10-FF-004912', NULL, 'Pentatricopeptide repeat-containing protein At5g39710', 72, NULL, NULL, 56749),
(56750, '2.60.40.150-FF-000302', NULL, 'C2 domain-containing protein', 150, NULL, NULL, 56750),
(56751, '2.170.120.12-FF-000007', NULL, 'DNA-directed RNA polymerases I and III subunit RPAC1', 139, NULL, NULL, 56751),
(56752, '3.40.50.1580-FF-000002', NULL, 'Purine nucleoside phosphorylase DeoD-type', 235, NULL, NULL, 56752),
(56753, '3.30.1380.20-FF-000022', NULL, 'Trafficking protein particle complex subunit 3 homolog', 180, NULL, NULL, 56753),
(56754, '2.60.40.10-FF-003059', NULL, 'Enterochelin esterase', 126, NULL, NULL, 56754),
(56755, '2.60.120.10-FF-000638', NULL, 'Predicted protein', 309, NULL, NULL, 56755),
(56756, '3.30.470.30-FF-000049', NULL, 'Methyltransferase, putative', 175, NULL, NULL, 56756),
(56757, '3.30.70.330-FF-001321', NULL, 'Glycine-rich RNA-binding, abscisic acid-inducible protein', 104, NULL, NULL, 56757),
(56758, '1.10.150.50-FF-000223', NULL, 'Uncharacterized protein', 85, NULL, NULL, 56758),
(56759, '1.25.40.990-FF-000008', NULL, 'Nuclear mRNA export protein SAC3', 316, NULL, NULL, 56759),
(56760, '3.30.200.20-FF-001073', NULL, 'Predicted protein', 88, NULL, NULL, 56760),
(56761, '1.25.40.820-FF-000036', NULL, 'Uncharacterized protein', 94, NULL, NULL, 56761),
(56762, '2.60.40.10-FF-004992', NULL, NULL, 107, NULL, NULL, 56762),
(56763, '3.30.70.330-FF-002310', NULL, NULL, 114, NULL, NULL, 56763),
(56764, '3.30.200.20-FF-001898', NULL, 'Uncharacterized protein', 86, NULL, NULL, 56764),
(56765, '3.90.1150.10-FF-000235', NULL, 'Cystathionine gamma-synthase', 128, NULL, NULL, 56765),
(56766, '3.40.50.620-FF-000182', NULL, 'YdcF family protein', 141, NULL, NULL, 56766),
(56767, '3.40.50.620-FF-000502', NULL, 'Glutamyl-tRNA synthetase (AFU_orthologue AFUA_5G03560)', 64, NULL, NULL, 56767),
(56768, '3.90.226.10-FF-000227', NULL, 'Uncharacterized protein', 231, NULL, NULL, 56768),
(56769, '3.30.465.10-FF-000060', NULL, 'Probable dehydrogenase', 214, NULL, NULL, 56769),
(56770, '2.60.40.10-FF-003531', NULL, NULL, 76, NULL, NULL, 56770),
(56771, '2.30.30.140-FF-000124', NULL, 'Nuclease domain-containing protein 1', 93, NULL, NULL, 56771);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(56772, '1.25.40.10-FF-004379', NULL, 'TPR repeat protein', 146, NULL, NULL, 56772),
(56773, '3.40.50.1820-FF-000563', NULL, 'Lipase, putative', 226, NULL, NULL, 56773),
(56774, '1.10.3720.10-FF-000114', NULL, 'NitT/TauT family transport system permease protein', 204, NULL, NULL, 56774),
(56775, '1.10.510.10-FF-000953', NULL, 'Uncharacterized protein', 177, NULL, NULL, 56775),
(56776, '3.30.1740.20-FF-000005', NULL, '40S ribosomal protein S26', 116, NULL, NULL, 56776),
(56777, '2.130.10.10-FF-003716', NULL, 'Uncharacterized protein', 204, NULL, NULL, 56777),
(56778, '3.60.40.10-FF-000027', NULL, 'Probable protein phosphatase 2C 76', 261, NULL, NULL, 56778),
(56779, '1.25.40.410-FF-000003', NULL, 'Dedicator of cytokinesis protein 4', 143, NULL, NULL, 56779),
(56780, '2.60.200.20-FF-000029', NULL, 'Mediator of DNA damage checkpoint protein 1', 121, NULL, NULL, 56780),
(56781, '2.100.10.30-FF-000008', NULL, 'Hemolysin', 135, NULL, NULL, 56781),
(56782, '3.30.1330.60-FF-000036', NULL, 'Chemotaxis protein MotB', 165, NULL, NULL, 56782),
(56783, '3.30.1460.20-FF-000023', NULL, 'Arp2/3 complex 34 kDa subunit', 57, NULL, NULL, 56783),
(56784, '2.60.450.10-FF-000011', NULL, 'Cell envelope biogenesis protein YhbN', 135, NULL, NULL, 56784),
(56785, '1.20.5.4820-FF-000018', NULL, NULL, 113, NULL, NULL, 56785),
(56786, '2.60.40.10-FF-005829', NULL, NULL, 33, NULL, NULL, 56786),
(56787, '1.20.1070.10-FF-000078', NULL, 'Neuromedin-K receptor', 354, NULL, NULL, 56787),
(56788, '3.40.1690.20-FF-000026', NULL, 'Uncharacterized protein', 84, NULL, NULL, 56788),
(56789, '3.30.160.60-FF-003008', NULL, 'Zinc finger protein 989', 29, NULL, NULL, 56789),
(56790, '3.10.450.50-FF-000042', NULL, 'RNA polymerase sigma factor', 119, NULL, NULL, 56790),
(56791, '1.20.1530.20-FF-000015', NULL, 'Na(+)/H(+) antiporter 2', 372, NULL, NULL, 56791),
(56792, '1.10.150.20-FF-000208', NULL, 'Meiotic recombination protein DMC1', 61, NULL, NULL, 56792),
(56793, '2.60.220.50-FF-000074', NULL, 'Putative g protein-coupled receptor', 192, NULL, NULL, 56793),
(56794, '3.40.50.300-FF-006595', NULL, 'Uncharacterized protein', 97, NULL, NULL, 56794),
(56795, '4.10.1240.10-FF-000069', NULL, 'C1A receptor, putative', 84, NULL, NULL, 56795),
(56796, '1.25.40.430-FF-000009', NULL, 'GD23333', 149, NULL, NULL, 56796),
(56797, '3.30.559.10-FF-000064', NULL, 'Non-ribosomal peptide synthetase OfaC', 198, NULL, NULL, 56797),
(56798, '4.10.900.10-FF-000033', NULL, 'Transcription factor 7 like 1', 51, NULL, NULL, 56798),
(56799, '1.25.40.730-FF-000009', NULL, 'Clathrin heavy chain', 95, NULL, NULL, 56799),
(56800, '1.25.10.10-FF-002786', NULL, 'Predicted protein', 231, NULL, NULL, 56800),
(56801, '1.20.1250.20-FF-000033', NULL, 'Hexose phosphate transporter', 216, NULL, NULL, 56801),
(56802, '3.30.750.24-FF-000062', NULL, 'Anti-anti-sigma regulatory factor (Antagonist of anti-sigma factor)', 114, NULL, NULL, 56802),
(56803, '1.25.40.20-FF-000054', NULL, 'E3 ubiquitin-protein ligase HACE1 isoform X1', 109, NULL, NULL, 56803),
(56804, '3.40.50.880-FF-000181', NULL, 'Anthranilate synthase component 2', 197, NULL, NULL, 56804),
(56805, '1.25.40.10-FF-002142', NULL, 'Os07g0662700 protein', 97, NULL, NULL, 56805),
(56806, '3.30.160.60-FF-004969', NULL, NULL, 31, NULL, NULL, 56806),
(56807, '3.40.50.1110-FF-000058', NULL, 'Isoamyl acetate-hydrolyzing esterase, putative', 253, NULL, NULL, 56807),
(56808, '3.30.420.40-FF-000667', NULL, 'Uncharacterized protein', 82, NULL, NULL, 56808),
(56809, '1.20.1050.10-FF-000195', NULL, 'Elongation factor 1-gamma', 153, NULL, NULL, 56809),
(56810, '3.20.20.100-FF-000114', NULL, 'Aldo/keto reductase', 267, NULL, NULL, 56810),
(56811, '2.120.10.80-FF-000371', NULL, 'Acyl-CoA-binding domain-containing protein 4', 168, NULL, NULL, 56811),
(56812, '1.20.58.2190-FF-000005', NULL, 'Plant UBX domain-containing protein 2', 88, NULL, NULL, 56812),
(56813, '3.40.50.2020-FF-000174', NULL, 'Uncharacterized protein', 68, NULL, NULL, 56813),
(56814, '3.90.780.10-FF-000042', NULL, '5'' nucleotidase, putative', 187, NULL, NULL, 56814);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(56815, '3.40.50.300-FF-006656', NULL, 'Predicted protein', 87, NULL, NULL, 56815),
(56816, '3.40.50.1000-FF-000789', NULL, NULL, 28, NULL, NULL, 56816),
(56817, '3.30.450.310-FF-000001', NULL, 'Bifunctional diguanylate cyclase/phosphodiesterase', 127, NULL, NULL, 56817),
(56818, '3.40.50.970-FF-000056', NULL, '3D-(3,5/4)-trihydroxycyclohexane-1,2-dione hydrolase', 208, NULL, NULL, 56818),
(56819, '1.20.1070.10-FF-002023', NULL, 'Uncharacterized protein', 127, NULL, NULL, 56819),
(56820, '1.50.40.10-FF-000133', NULL, 'Solute carrier family 25 (Mitochondrial phosphate transporter), member 3', 285, NULL, NULL, 56820),
(56821, '1.10.10.790-FF-000014', NULL, 'Splicing factor SWAP', 102, NULL, NULL, 56821),
(56822, '1.10.357.50-FF-000029', NULL, 'Uncharacterized protein', 95, NULL, NULL, 56822),
(56823, '1.20.920.10-FF-000010', NULL, 'protein polybromo-1 isoform X3', 131, NULL, NULL, 56823),
(56824, '1.10.1380.10-FF-000014', NULL, 'GH01974p', 335, NULL, NULL, 56824),
(56825, '3.40.50.10240-FF-000019', NULL, 'Thiamine pyrophosphokinase Thi80', 251, NULL, NULL, 56825),
(56826, '3.30.40.10-FF-000803', NULL, 'Mpe1p', 88, NULL, NULL, 56826),
(56827, '1.25.40.20-FF-001835', NULL, 'Kinase, NEK', 146, NULL, NULL, 56827),
(56828, '1.20.5.110-FF-000007', NULL, 'Synaptosomal-associated protein', 80, NULL, NULL, 56828),
(56829, '1.25.40.10-FF-002642', NULL, 'Uncharacterized protein', 85, NULL, NULL, 56829),
(56830, '3.30.1010.10-FF-000054', NULL, 'Putative phosphatidylinositol 3-related kinase', 127, NULL, NULL, 56830),
(56831, '3.50.50.60-FF-001476', NULL, 'FAD-dependent oxidoreductase family protein', 61, NULL, NULL, 56831),
(56832, '3.30.450.40-FF-000023', NULL, 'IclR family transcriptional regulator', 174, NULL, NULL, 56832),
(56833, '2.10.25.10-FF-001160', NULL, 'Uncharacterized protein', 61, NULL, NULL, 56833),
(56834, '1.10.472.10-FF-000408', NULL, 'AGAP004963-PA', 143, NULL, NULL, 56834),
(56835, '1.25.10.10-FF-001325', NULL, 'Transporter of SR proteins', 792, NULL, NULL, 56835),
(56836, '3.30.160.60-FF-001743', NULL, 'zinc finger protein 581', 26, NULL, NULL, 56836),
(56837, '2.40.170.20-FF-000076', NULL, 'Probable outer membrane receptor for iron transport', 562, NULL, NULL, 56837),
(56838, '1.25.40.10-FF-000197', NULL, 'Tetratricopeptide repeat domain 21B', 355, NULL, NULL, 56838),
(56839, '3.30.70.330-FF-001293', NULL, 'Os07g0603100 protein', 143, NULL, NULL, 56839),
(56840, '3.40.50.300-FF-006156', NULL, 'Uncharacterized protein', 261, NULL, NULL, 56840),
(56841, '1.10.472.10-FF-000588', NULL, 'Uncharacterized protein', 35, NULL, NULL, 56841),
(56842, '1.10.8.270-FF-000063', NULL, 'TBC1 domain family member', 104, NULL, NULL, 56842),
(56843, '1.25.40.10-FF-002934', NULL, 'Uncharacterized protein', 159, NULL, NULL, 56843),
(56844, '1.10.10.10-FF-001206', NULL, 'Transcriptional regulator,LysR family', 87, NULL, NULL, 56844),
(56845, '1.10.287.90-FF-000018', NULL, 'Cytochrome c oxidase subunit 2', 76, NULL, NULL, 56845),
(56846, '1.20.1000.10-FF-000012', NULL, 'Guanylate-binding protein 4', 221, NULL, NULL, 56846),
(56847, '2.60.120.200-FF-000821', NULL, 'Putative neuramidase (Putative secreted protein)', 200, NULL, NULL, 56847),
(56848, '3.40.50.1000-FF-000817', NULL, NULL, 104, NULL, NULL, 56848),
(56849, '3.30.200.20-FF-001926', NULL, NULL, 38, NULL, NULL, 56849),
(56850, '3.40.50.300-FF-008601', NULL, 'Predicted protein', 13, NULL, NULL, 56850),
(56851, '1.20.120.1750-FF-000156', NULL, 'RBR-type E3 ubiquitin transferase', 72, NULL, NULL, 56851),
(56852, '3.40.50.1260-FF-000024', NULL, 'Phosphoglycerate kinase', 71, NULL, NULL, 56852),
(56853, '1.25.10.10-FF-001797', NULL, 'Uncharacterized protein', 223, NULL, NULL, 56853),
(56854, '3.90.1240.10-FF-000001', NULL, 'Botulinum neurotoxin type B', 427, NULL, NULL, 56854),
(56855, '3.40.50.300-FF-000996', NULL, 'Cytoplasmic dynein heavy chain', 150, NULL, NULL, 56855),
(56856, '1.10.565.10-FF-000068', NULL, 'Nuclear hormone receptor family member nhr-86', 246, NULL, NULL, 56856),
(56857, '1.10.287.110-FF-000053', NULL, 'Putative Mitochondrial DnaJ chaperone', 132, NULL, NULL, 56857);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(56858, '3.10.20.690-FF-000001', NULL, 'DNA gyrase subunit B', 89, NULL, NULL, 56858),
(56859, '1.10.287.690-FF-000030', NULL, 'Predicted protein', 25, NULL, NULL, 56859),
(56860, '2.10.110.10-FF-000278', NULL, 'Chromosome 19, whole genome shotgun sequence', 64, NULL, NULL, 56860),
(56861, '2.60.40.3350-FF-000001', NULL, 'Antireceptor', 126, NULL, NULL, 56861),
(56862, '3.40.1190.20-FF-000180', NULL, NULL, 193, NULL, NULL, 56862),
(56863, '3.90.70.10-FF-000729', NULL, 'Uncharacterized protein', 180, NULL, NULL, 56863),
(56864, '2.60.120.260-FF-000440', NULL, 'Endo-beta-N-acetylglucosaminidase', 209, NULL, NULL, 56864),
(56865, '2.30.30.40-FF-000387', NULL, 'ITSN (Intersectin) family', 56, NULL, NULL, 56865),
(56866, '1.10.579.10-FF-000010', NULL, 'Deoxyribodipyrimidine photo-lyase', 96, NULL, NULL, 56866),
(56867, '3.60.15.10-FF-000194', NULL, 'Rubredoxin:oxygen/nitric oxide oxidoreductase', 249, NULL, NULL, 56867),
(56868, '1.10.510.10-FF-001150', NULL, 'Os02g0136900 protein', 214, NULL, NULL, 56868),
(56869, '3.60.20.10-FF-000144', NULL, 'Glutamine-fructose-6-phosphate transaminase (Isomerizing) (GlmS-2)', 233, NULL, NULL, 56869),
(56870, '1.20.58.70-FF-000081', NULL, 'SNAP receptor', 125, NULL, NULL, 56870),
(56871, '1.10.1040.10-FF-000056', NULL, '3-hydroxyisobutyrate dehydrogenase a', 129, NULL, NULL, 56871),
(56872, '1.10.10.10-FF-001353', NULL, 'Crp/Fnr family transcriptional regulator', 87, NULL, NULL, 56872),
(56873, '3.80.10.10-FF-000541', NULL, 'Si:dkey-190j3.2', 62, NULL, NULL, 56873),
(56874, '1.25.40.20-FF-001543', NULL, 'Sex-determining protein fem-1', 127, NULL, NULL, 56874),
(56875, '1.10.8.60-FF-000259', NULL, 'Cell division protein FstH', 74, NULL, NULL, 56875),
(56876, '3.75.10.10-FF-000031', NULL, NULL, 115, NULL, NULL, 56876),
(56877, '3.50.50.60-FF-001004', NULL, 'Uncharacterized protein', 125, NULL, NULL, 56877),
(56878, '3.10.129.10-FF-000025', NULL, 'GNAT family N-acetyltransferase', 151, NULL, NULL, 56878),
(56879, '3.30.160.60-FF-003508', NULL, 'Zinc finger protein 639', 61, NULL, NULL, 56879),
(56880, '1.20.1070.10-FF-000578', NULL, 'Predicted protein', 300, NULL, NULL, 56880),
(56881, '1.10.287.70-FF-000451', NULL, 'Sodium channel protein', 141, NULL, NULL, 56881),
(56882, '1.20.120.620-FF-000007', NULL, 'Sensor histidine kinase, KdpD', 106, NULL, NULL, 56882),
(56883, '3.30.70.270-FF-000206', NULL, NULL, 172, NULL, NULL, 56883),
(56884, '1.10.730.10-FF-000025', NULL, 'Isoleucine--tRNA ligase cytoplasmic', 193, NULL, NULL, 56884),
(56885, '3.40.33.10-FF-000197', NULL, 'Predicted protein', 77, NULL, NULL, 56885),
(56886, '2.10.70.10-FF-000067', NULL, 'CUB and Sushi multiple domains 3', 57, NULL, NULL, 56886),
(56887, '2.60.120.670-FF-000001', NULL, 'Spike protein P5', 144, NULL, NULL, 56887),
(56888, '3.30.870.10-FF-000091', NULL, 'Phospholipase D', 170, NULL, NULL, 56888),
(56889, '1.50.10.20-FF-000134', NULL, 'Protein farnesyltransferase subunit beta', 381, NULL, NULL, 56889),
(56890, '2.30.130.40-FF-000014', NULL, 'ATP-dependent protease La (LON) domain protein', 114, NULL, NULL, 56890),
(56891, '3.40.50.300-FF-007612', NULL, 'Senataxin', 155, NULL, NULL, 56891),
(56892, '4.10.80.40-FF-000004', NULL, 'Succinate dehydrogenase [ubiquinone] flavoprotein subunit, mitochondrial', 65, NULL, NULL, 56892),
(56893, '1.20.1280.50-FF-000196', NULL, 'Uncharacterized protein', 52, NULL, NULL, 56893),
(56894, '3.40.367.20-FF-000023', NULL, 'Phosphotransferase', 266, NULL, NULL, 56894),
(56895, '3.30.465.10-FF-000121', NULL, 'Uncharacterized protein', 106, NULL, NULL, 56895),
(56896, '3.30.310.40-FF-000013', NULL, 'Uncharacterized protein', 89, NULL, NULL, 56896),
(56897, '2.40.50.960-FF-000001', NULL, 'ACD, shelterin complex subunit and telomerase recruitment factor', 161, NULL, NULL, 56897),
(56898, '2.160.20.10-FF-000276', NULL, 'Cell surface protein', 250, NULL, NULL, 56898),
(56899, '1.20.1540.10-FF-000070', NULL, 'Uncharacterized protein', 192, NULL, NULL, 56899),
(56900, '2.130.10.10-FF-004352', NULL, 'Uncharacterized protein', 94, NULL, NULL, 56900),
(56901, '3.90.470.20-FF-000061', NULL, 'L-aminoadipate-semialdehyde dehydrogenase-phosphopantetheinyl transferase', 91, NULL, NULL, 56901);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(56902, '3.30.160.60-FF-006386', NULL, NULL, 50, NULL, NULL, 56902),
(56903, '2.130.10.30-FF-000176', NULL, NULL, 262, NULL, NULL, 56903),
(56904, '2.130.10.10-FF-001890', NULL, 'TBC1 domain family, member 31', 160, NULL, NULL, 56904),
(56905, '2.60.40.150-FF-000482', NULL, 'Phosphatidylinositol 3-kinase VPS34', 136, NULL, NULL, 56905),
(56906, '3.30.70.3190-FF-000004', NULL, NULL, 70, NULL, NULL, 56906),
(56907, '3.30.70.330-FF-002782', NULL, NULL, 57, NULL, NULL, 56907),
(56908, '1.10.287.1490-FF-000102', NULL, 'NUP-1 protein, putative', 172, NULL, NULL, 56908),
(56909, '3.90.640.10-FF-000032', NULL, 'heat shock 70 kDa protein 13', 25, NULL, NULL, 56909),
(56910, '4.10.410.10-FF-000097', NULL, 'Tissue factor pathway inhibitor', 75, NULL, NULL, 56910),
(56911, '1.25.40.10-FF-001214', NULL, 'Pentatricopeptide repeat-containing protein At2g20540', 147, NULL, NULL, 56911),
(56912, '2.60.40.10-FF-002283', NULL, 'Platelet-derived growth factor receptor alpha', 103, NULL, NULL, 56912),
(56913, '2.30.42.10-FF-000271', NULL, 'Pdz domain containing protein, putative', 84, NULL, NULL, 56913),
(56914, '3.30.420.40-FF-000167', NULL, 'Actin-related protein 4', 87, NULL, NULL, 56914),
(56915, '3.30.450.190-FF-000010', NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', 142, NULL, NULL, 56915),
(56916, '3.40.50.300-FF-007584', NULL, 'eIF2-interacting protein ABC50, putative', 177, NULL, NULL, 56916),
(56917, '2.30.42.10-FF-000299', NULL, 'MAGI (Membrane Associated Guanylate kinase Inverted) homolog', 103, NULL, NULL, 56917),
(56918, '4.10.410.20-FF-000015', NULL, 'Uncharacterized protein', 51, NULL, NULL, 56918),
(56919, '3.90.25.10-FF-000041', NULL, 'UDP-glucose 4-epimerase', 44, NULL, NULL, 56919),
(56920, '2.60.40.150-FF-000774', NULL, 'Uncharacterized protein', 107, NULL, NULL, 56920),
(56921, '2.30.29.30-FF-001241', NULL, 'Probable serine/threonine-protein kinase roco5', 113, NULL, NULL, 56921),
(56922, '3.20.20.60-FF-000110', NULL, 'HpcH/HpaI aldolase', 249, NULL, NULL, 56922),
(56923, '1.10.238.10-FF-000561', NULL, 'Myosin, essential light chain', 75, NULL, NULL, 56923),
(56924, '4.10.60.10-FF-000045', NULL, 'CCHC-type zinc finger protein-like', 33, NULL, NULL, 56924),
(56925, '3.40.850.10-FF-000211', NULL, 'Kinesin, putative', 360, NULL, NULL, 56925),
(56926, '3.30.200.20-FF-000437', NULL, 'Mixed lineage kinase domain-like pseudokinase', 108, NULL, NULL, 56926),
(56927, '1.10.260.100-FF-000002', NULL, 'Stress-induced-phosphoprotein 1 (Hsp70/Hsp90-organizing)', 69, NULL, NULL, 56927),
(56928, '3.40.50.10420-FF-000040', NULL, 'Methenyltetrahydrofolate synthetase domain containing', 225, NULL, NULL, 56928),
(56929, '3.40.1190.20-FF-000033', NULL, 'Sugar kinase', 312, NULL, NULL, 56929),
(56930, '3.30.40.10-FF-001759', NULL, 'PHD finger domain protein, putative (AFU_orthologue AFUA_3G11940)', 32, NULL, NULL, 56930),
(56931, '1.10.472.10-FF-000560', NULL, 'Putative cyclin-D7-1', 66, NULL, NULL, 56931),
(56932, '3.80.10.10-FF-002778', NULL, 'LOC502201 protein', 107, NULL, NULL, 56932),
(56933, '2.30.30.30-FF-000058', NULL, 'Transcription elongation factor SPT5', 49, NULL, NULL, 56933),
(56934, '3.30.420.40-FF-000959', NULL, 'Predicted protein', 27, NULL, NULL, 56934),
(56935, '3.40.190.10-FF-000475', NULL, 'Glutamate receptor', 64, NULL, NULL, 56935),
(56936, '3.50.50.60-FF-000520', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 171, NULL, NULL, 56936),
(56937, '3.30.70.260-FF-000024', NULL, 'Tyrosine 3-monooxygenase', 93, NULL, NULL, 56937),
(56938, '3.10.100.10-FF-000414', NULL, NULL, 101, NULL, NULL, 56938),
(56939, '2.130.10.10-FF-000018', NULL, 'Receptor for activated C kinase 1', 309, NULL, NULL, 56939),
(56940, '2.10.25.10-FF-001188', NULL, 'Protein kinase domain containing protein', 34, NULL, NULL, 56940),
(56941, '3.40.1110.10-FF-000284', NULL, NULL, 115, NULL, NULL, 56941),
(56942, '3.30.40.10-FF-002395', NULL, 'Uncharacterized protein', 95, NULL, NULL, 56942),
(56943, '2.60.40.60-FF-000679', NULL, 'Cadherin-4', 105, NULL, NULL, 56943),
(56944, '3.10.180.10-FF-000014', NULL, 'glyoxalase domain-containing protein 4', 133, NULL, NULL, 56944);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(56945, '1.25.40.10-FF-004620', NULL, 'Uncharacterized protein', 158, NULL, NULL, 56945),
(56946, '1.20.1250.20-FF-001461', NULL, 'MFS transporter, putative', 226, NULL, NULL, 56946),
(56947, '3.30.590.10-FF-000018', NULL, 'GD11708', 274, NULL, NULL, 56947),
(56948, '3.40.190.100-FF-000005', NULL, 'Amino acid ABC transporter, periplasmic amino acid-binding protein', 132, NULL, NULL, 56948),
(56949, '1.20.120.330-FF-000044', NULL, 'Tyrosine-protein kinase', 107, NULL, NULL, 56949),
(56950, '3.40.50.2000-FF-000808', NULL, 'Glycogen [starch] synthase', 91, NULL, NULL, 56950),
(56951, '1.10.790.10-FF-000001', NULL, 'Major prion protein', 141, NULL, NULL, 56951),
(56952, '1.20.58.760-FF-000033', NULL, 'ATP-dependent zinc metalloprotease FtsH', 173, NULL, NULL, 56952),
(56953, '1.25.10.10-FF-003450', NULL, 'Crescerin-like protein che-12', 221, NULL, NULL, 56953),
(56954, '3.80.10.10-FF-000569', NULL, 'Partner of Paired', 154, NULL, NULL, 56954),
(56955, '3.10.20.90-FF-000647', NULL, 'Ubiquitin, putative', 77, NULL, NULL, 56955),
(56956, '3.40.50.300-FF-006948', NULL, 'Uncharacterized protein', 225, NULL, NULL, 56956),
(56957, '2.30.30.390-FF-000002', NULL, 'Clp protease adapter protein ClpF, chloroplastic', 104, NULL, NULL, 56957),
(56958, '3.40.190.10-FF-000036', NULL, 'Dipeptide ABC transporter, substrate-binding protein', 94, NULL, NULL, 56958),
(56959, '2.30.42.10-FF-000119', NULL, 'Membrane associated guanylate kinase, WW and PDZ domain containing 2', 88, NULL, NULL, 56959),
(56960, '3.40.250.10-FF-000154', NULL, 'Metallo-beta-lactamase', 104, NULL, NULL, 56960),
(56961, '1.25.10.10-FF-002814', NULL, 'Predicted protein', 199, NULL, NULL, 56961),
(56962, '2.10.25.10-FF-001721', NULL, 'Uncharacterized protein', 59, NULL, NULL, 56962),
(56963, '3.30.160.60-FF-001182', NULL, 'Zinc finger, C2H2 type', 28, NULL, NULL, 56963),
(56964, '1.20.58.1610-FF-000005', NULL, 'NADH-quinone oxidoreductase subunit A', 121, NULL, NULL, 56964),
(56965, '1.25.10.10-FF-003303', NULL, 'Predicted protein', 173, NULL, NULL, 56965),
(56966, '3.40.630.30-FF-000678', NULL, 'Predicted protein', 142, NULL, NULL, 56966),
(56967, '3.40.50.300-FF-004178', NULL, 'Uncharacterized protein', 115, NULL, NULL, 56967),
(56968, '3.40.50.920-FF-000002', NULL, '1-deoxy-D-xylulose-5-phosphate synthase', 132, NULL, NULL, 56968),
(56969, '1.25.40.10-FF-000989', NULL, 'Pentatricopeptide repeat-containing protein At1g31430', 210, NULL, NULL, 56969),
(56970, '3.30.160.60-FF-004177', NULL, NULL, 25, NULL, NULL, 56970),
(56971, '3.30.9.10-FF-000006', NULL, 'N-methyl-L-tryptophan oxidase', 189, NULL, NULL, 56971),
(56972, '1.20.1250.20-FF-000825', NULL, 'Cln7, isoform A', 415, NULL, NULL, 56972),
(56973, '2.130.10.10-FF-000962', NULL, 'Coronin', 254, NULL, NULL, 56973),
(56974, '3.40.50.1820-FF-001491', NULL, 'Uncharacterized protein', 165, NULL, NULL, 56974),
(56975, '1.10.10.60-FF-000951', NULL, NULL, 68, NULL, NULL, 56975),
(56976, '2.40.50.40-FF-000129', NULL, 'Uncharacterized protein', 57, NULL, NULL, 56976),
(56977, '3.30.160.60-FF-000254', NULL, 'Odd-skipped related transciption factor 1', 26, NULL, NULL, 56977),
(56978, '3.30.450.20-FF-000276', NULL, 'Sensor histidine kinase', 138, NULL, NULL, 56978),
(56979, '1.10.238.10-FF-000409', NULL, 'Magu, isoform F', 113, NULL, NULL, 56979),
(56980, '2.40.10.240-FF-000002', NULL, 'S-adenosylmethionine:tRNA ribosyltransferase-isomerase', 99, NULL, NULL, 56980),
(56981, '1.10.510.10-FF-003207', NULL, NULL, 145, NULL, NULL, 56981),
(56982, '3.40.50.80-FF-000167', NULL, 'YALI0F07040p', 167, NULL, NULL, 56982),
(56983, '3.40.50.300-FF-004739', NULL, 'Predicted protein', 77, NULL, NULL, 56983),
(56984, '3.90.120.10-FF-000004', NULL, 'DNA (cytosine-5)-methyltransferase', 79, NULL, NULL, 56984),
(56985, '3.40.50.800-FF-000112', NULL, 'Uncharacterized protein', 100, NULL, NULL, 56985),
(56986, '1.10.510.10-FF-003387', NULL, NULL, 314, NULL, NULL, 56986),
(56987, '1.10.10.60-FF-000007', NULL, 'Two-component response regulator', 64, NULL, NULL, 56987),
(56988, '3.20.20.190-FF-000040', NULL, 'Glycerophosphoryl diester phosphodiesterase family protein', 340, NULL, NULL, 56988);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(56989, '3.40.30.10-FF-000044', NULL, 'Glutathione S-transferase GSTU6', 86, NULL, NULL, 56989),
(56990, '3.40.50.1820-FF-000855', NULL, 'IP20428p', 233, NULL, NULL, 56990),
(56991, '3.60.10.10-FF-000351', NULL, 'DNA-(apurinic or apyrimidinic site) lyase', 165, NULL, NULL, 56991),
(56992, '1.25.40.10-FF-004087', NULL, 'Uncharacterized protein', 303, NULL, NULL, 56992),
(56993, '2.40.50.360-FF-000001', NULL, 'RuvB-like helicase', 126, NULL, NULL, 56993),
(56994, '3.40.50.2300-FF-000460', NULL, 'Transcriptional regulator', 80, NULL, NULL, 56994),
(56995, '3.30.70.330-FF-001854', NULL, NULL, 110, NULL, NULL, 56995),
(56996, '1.20.120.1910-FF-000047', NULL, 'Probable cysteine--tRNA ligase, mitochondrial', 166, NULL, NULL, 56996),
(56997, '1.20.1420.10-FF-000004', NULL, 'Talin 2', 174, NULL, NULL, 56997),
(56998, '1.10.287.130-FF-000031', NULL, 'Two-component sensor histidine kinase', 74, NULL, NULL, 56998),
(56999, '1.10.168.20-FF-000002', NULL, '40S ribosomal protein S8', 69, NULL, NULL, 56999),
(57000, '3.40.50.720-FF-002331', NULL, 'Uncharacterized protein', 205, NULL, NULL, 57000),
(57001, '3.40.50.620-FF-000210', NULL, 'tRNA-specific 2-thiouridylase MnmA', 199, NULL, NULL, 57001),
(57002, '2.30.29.30-FF-000313', NULL, 'Diacylglycerol kinase', 110, NULL, NULL, 57002),
(57003, '3.30.40.10-FF-000011', NULL, 'chromodomain-helicase-DNA-binding protein 4 isoform X1', 60, NULL, NULL, 57003),
(57004, '2.60.40.10-FF-000158', NULL, 'Sidekick cell adhesion molecule 2', 96, NULL, NULL, 57004),
(57005, '3.30.40.10-FF-002248', NULL, 'AGAP007417-PA', 58, NULL, NULL, 57005),
(57006, '1.20.1600.10-FF-000041', NULL, 'Outer membrane protein TolC', 408, NULL, NULL, 57006),
(57007, '1.50.40.10-FF-000425', NULL, 'Oxoglutarate/malate carrier protein, putative', 186, NULL, NULL, 57007),
(57008, '1.10.287.70-FF-000012', NULL, 'Voltage-dependent N-type calcium channel subunit alpha', 140, NULL, NULL, 57008),
(57009, '2.170.300.10-FF-000025', NULL, 'Platelet endothelial aggregation receptor 1', 109, NULL, NULL, 57009),
(57010, '3.30.70.330-FF-002602', NULL, NULL, 133, NULL, NULL, 57010),
(57011, '3.60.15.10-FF-000047', NULL, 'integrator complex subunit 11 isoform X2', 41, NULL, NULL, 57011),
(57012, '2.130.10.10-FF-002227', NULL, 'Kinesin family member 21A', 177, NULL, NULL, 57012),
(57013, '3.40.720.10-FF-000319', NULL, 'Uncharacterized protein', 189, NULL, NULL, 57013),
(57014, '1.10.510.10-FF-002870', NULL, NULL, 129, NULL, NULL, 57014),
(57015, '2.30.40.10-FF-000137', NULL, 'Amidohydrolase', 107, NULL, NULL, 57015),
(57016, '2.130.10.10-FF-005633', NULL, 'Predicted protein', 177, NULL, NULL, 57016),
(57017, '2.30.30.40-FF-000679', NULL, 'Variant SH3 domain containing protein', 73, NULL, NULL, 57017),
(57018, '3.30.710.10-FF-000338', NULL, 'zinc finger protein 55 isoform X1', 135, NULL, NULL, 57018),
(57019, '3.40.50.300-FF-000816', NULL, 'Adenylate isopentenyltransferase 5, chloroplastic', 165, NULL, NULL, 57019),
(57020, '3.80.10.10-FF-003003', NULL, 'F-box protein FBW2', 80, NULL, NULL, 57020),
(57021, '1.10.238.270-FF-000001', NULL, 'Odorant-binding protein 58c', 175, NULL, NULL, 57021),
(57022, '2.60.40.420-FF-000198', NULL, 'Cytochrome c oxidase subunit II', 143, NULL, NULL, 57022),
(57023, '3.30.70.470-FF-000002', NULL, 'Methyl-coenzyme M reductase I subunit beta', 147, NULL, NULL, 57023),
(57024, '3.20.20.190-FF-000068', NULL, 'Putative glycerophosphoryl diester phosphodiesterase', 235, NULL, NULL, 57024),
(57025, '2.60.40.10-FF-002103', NULL, 'Colony-stimulating factor 1 receptor, a', 84, NULL, NULL, 57025),
(57026, '3.40.47.10-FF-000228', NULL, NULL, 88, NULL, NULL, 57026),
(57027, '1.20.1550.10-FF-000008', NULL, 'Disulfide bond formation protein B', 177, NULL, NULL, 57027),
(57028, '3.60.21.10-FF-000168', NULL, 'Serine/threonine-protein phosphatase', 358, NULL, NULL, 57028),
(57029, '1.10.533.10-FF-000258', NULL, 'Caspase-8', 88, NULL, NULL, 57029),
(57030, '2.60.40.10-FF-001614', NULL, 'Down syndrome cell adhesion molecule 3, isoform C', 95, NULL, NULL, 57030),
(57031, '2.170.140.10-FF-000023', NULL, 'Predicted protein', 63, NULL, NULL, 57031);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(57032, '2.160.10.10-FF-000039', NULL, 'Dynactin subunit 5', 181, NULL, NULL, 57032),
(57033, '1.10.1420.10-FF-000102', NULL, 'Mismatch repair ATPase Msh2', 134, NULL, NULL, 57033),
(57034, '3.40.50.720-FF-000386', NULL, 'Quinate repressor protein', 203, NULL, NULL, 57034),
(57035, '3.80.10.10-FF-002514', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', 132, NULL, NULL, 57035),
(57036, '3.30.505.10-FF-000176', NULL, NULL, 119, NULL, NULL, 57036),
(57037, '3.90.190.10-FF-000542', NULL, 'Predicted protein', 158, NULL, NULL, 57037),
(57038, '3.30.40.10-FF-002187', NULL, 'Uncharacterized protein', 79, NULL, NULL, 57038),
(57039, '3.50.30.30-FF-000061', NULL, 'Subtilisin-like protease SBT3.13', 116, NULL, NULL, 57039),
(57040, '3.80.10.10-FF-002986', NULL, 'Uncharacterized protein', 171, NULL, NULL, 57040),
(57041, '3.30.160.60-FF-005133', NULL, NULL, 29, NULL, NULL, 57041),
(57042, '2.60.260.20-FF-000185', NULL, 'Uncharacterized protein', 42, NULL, NULL, 57042),
(57043, '3.30.50.10-FF-000068', NULL, 'Transcription factor', 68, NULL, NULL, 57043),
(57044, '1.10.390.10-FF-000100', NULL, 'Uncharacterized protein', 98, NULL, NULL, 57044),
(57045, '3.40.50.300-FF-001744', NULL, 'Mitochondrial Rho GTPase', 169, NULL, NULL, 57045),
(57046, '2.60.40.60-FF-000179', NULL, 'Cadherin 24', 111, NULL, NULL, 57046),
(57047, '2.170.270.10-FF-000027', NULL, 'PR domain zinc finger protein 13', 126, NULL, NULL, 57047),
(57048, '3.30.70.330-FF-002810', NULL, NULL, 93, NULL, NULL, 57048),
(57049, '2.40.50.140-FF-000519', NULL, 'Transcription termination/antitermination protein NusA', 62, NULL, NULL, 57049),
(57050, '1.10.510.10-FF-000806', NULL, 'Non-specific serine/threonine protein kinase', 219, NULL, NULL, 57050),
(57051, '3.40.50.300-FF-007084', NULL, 'Uncharacterized protein', 191, NULL, NULL, 57051),
(57052, '2.70.40.10-FF-000017', NULL, 'dUTPase', 144, NULL, NULL, 57052),
(57053, '3.40.718.10-FF-000022', NULL, 'Isocitrate dehydrogenase (NADP(+)) 2, mitochondrial', 243, NULL, NULL, 57053),
(57054, '1.10.472.80-FF-000148', NULL, 'TBC domain-containing protein C1952.17c', 143, NULL, NULL, 57054),
(57055, '2.60.40.150-FF-000274', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', 137, NULL, NULL, 57055),
(57056, '3.30.420.40-FF-001095', NULL, 'Uncharacterized protein', 77, NULL, NULL, 57056),
(57057, '1.25.40.10-FF-001714', NULL, 'Pentatricopeptide repeat-containing protein At1g13040, mitochondrial', 105, NULL, NULL, 57057),
(57058, '1.20.1050.130-FF-000020', NULL, 'Uncharacterized protein', 62, NULL, NULL, 57058),
(57059, '3.30.465.10-FF-000088', NULL, 'Uncharacterized protein', 234, NULL, NULL, 57059),
(57060, '3.30.1360.70-FF-000013', NULL, 'Arginine--tRNA ligase', 111, NULL, NULL, 57060),
(57061, '2.60.40.10-FF-001794', NULL, 'Fasciclin 3, isoform C', 107, NULL, NULL, 57061),
(57062, '3.60.15.10-FF-000255', NULL, 'Predicted protein', 226, NULL, NULL, 57062),
(57063, '1.25.40.10-FF-004851', NULL, 'Uncharacterized protein', 354, NULL, NULL, 57063),
(57064, '2.130.10.10-FF-002435', NULL, 'WD domain, G-beta repeat, putative', 189, NULL, NULL, 57064),
(57065, '3.90.170.10-FF-000007', NULL, 'Adenylosuccinate synthetase', 81, NULL, NULL, 57065),
(57066, '3.30.565.10-FF-000185', NULL, 'Sensory box histidine kinase/response regulator', 171, NULL, NULL, 57066),
(57067, '2.60.120.10-FF-000610', NULL, 'Mannose-6-phosphate isomerase', 104, NULL, NULL, 57067),
(57068, '1.20.5.780-FF-000011', NULL, 'FXYD domain-containing ion transport regulator', 61, NULL, NULL, 57068),
(57069, '3.30.413.10-FF-000007', NULL, 'Nitrite reductase [NAD(P)H] large subunit', 124, NULL, NULL, 57069),
(57070, '1.10.10.10-FF-000425', NULL, 'GntR family transcriptional regulator', 75, NULL, NULL, 57070),
(57071, '2.10.50.10-FF-000004', NULL, 'Tumor necrosis factor receptor superfamily member 6', 81, NULL, NULL, 57071),
(57072, '3.30.70.1450-FF-000056', NULL, 'Glutathione-gated K(+)-efflux system KefB', 73, NULL, NULL, 57072),
(57073, '1.10.510.10-FF-002898', NULL, 'Uncharacterized protein', 272, NULL, NULL, 57073);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(57074, '3.80.10.10-FF-003975', NULL, 'Uncharacterized protein', 340, NULL, NULL, 57074),
(57075, '1.10.150.240-FF-000132', NULL, 'Imidazoleglycerol-phosphate dehydratase', 79, NULL, NULL, 57075),
(57076, '1.10.260.40-FF-000015', NULL, 'Endothelial differentiation-related factor 1', 84, NULL, NULL, 57076),
(57077, '1.10.418.80-FF-000006', NULL, NULL, 37, NULL, NULL, 57077),
(57078, '3.30.40.10-FF-001731', NULL, 'Uncharacterized protein', 112, NULL, NULL, 57078),
(57079, '2.30.29.30-FF-000605', NULL, 'Heavy chain, Unconventional Myosin', 100, NULL, NULL, 57079),
(57080, '1.25.10.10-FF-002286', NULL, 'Pumilio homolog 14', 328, NULL, NULL, 57080),
(57081, '1.20.1250.20-FF-000180', NULL, 'MFS monosaccharide transporter', 484, NULL, NULL, 57081),
(57082, '1.10.510.10-FF-001381', NULL, 'Protein kinase, putative', 200, NULL, NULL, 57082),
(57083, '1.10.10.60-FF-000479', NULL, 'Homebox and aldo/keto reductase', 86, NULL, NULL, 57083),
(57084, '3.40.30.10-FF-000252', NULL, 'Phosphoadenosine-phosphosulphate reductase', 118, NULL, NULL, 57084),
(57085, '1.10.400.10-FF-000040', NULL, 'Odr-3', 26, NULL, NULL, 57085),
(57086, '2.60.40.10-FF-000366', NULL, 'fibronectin type-III domain-containing protein 3A isoform X1', 98, NULL, NULL, 57086),
(57087, '3.40.220.10-FF-000034', NULL, 'Leucyl aminopeptidase', 156, NULL, NULL, 57087),
(57088, '3.30.40.10-FF-000742', NULL, 'DNA-binding E3 ubiquitin-protein ligase', 71, NULL, NULL, 57088),
(57089, '1.20.5.2480-FF-000002', NULL, 'Reticulon-like protein', 72, NULL, NULL, 57089),
(57090, '1.20.1560.10-FF-000245', NULL, 'Multidrug resistance protein pgp-1', 49, NULL, NULL, 57090),
(57091, '2.30.29.30-FF-001269', NULL, 'Uncharacterized protein', 100, NULL, NULL, 57091),
(57092, '4.10.1060.10-FF-000004', NULL, 'Zinc finger Ran-binding domain-containing protein 2', 36, NULL, NULL, 57092),
(57093, '2.170.130.10-FF-000017', NULL, 'TonB-dependent siderophore receptor', 136, NULL, NULL, 57093),
(57094, '3.80.10.10-FF-003503', NULL, 'Uncharacterized protein', 314, NULL, NULL, 57094),
(57095, '3.40.50.200-FF-000112', NULL, 'Predicted protein', 179, NULL, NULL, 57095),
(57096, '3.40.50.10190-FF-000280', NULL, 'Predicted protein', 103, NULL, NULL, 57096),
(57097, '3.40.190.290-FF-000135', NULL, 'Probable transcriptional regulator', 195, NULL, NULL, 57097),
(57098, '1.10.510.10-FF-002459', NULL, NULL, 170, NULL, NULL, 57098),
(57099, '1.10.3160.10-FF-000003', NULL, 'Putative surface antigen', 184, NULL, NULL, 57099),
(57100, '1.20.5.190-FF-000137', NULL, NULL, 48, NULL, NULL, 57100),
(57101, '3.30.830.10-FF-000173', NULL, 'Mitochondrial-processing peptidase subunit alpha', 226, NULL, NULL, 57101),
(57102, '1.10.287.1490-FF-000074', NULL, 'Kinase interacting (KIP1-like) family protein', 164, NULL, NULL, 57102),
(57103, '1.10.510.10-FF-003415', NULL, NULL, 294, NULL, NULL, 57103),
(57104, '1.10.287.10-FF-000040', NULL, 'Histidyl-tRNA synthetase', 59, NULL, NULL, 57104),
(57105, '2.60.40.10-FF-003031', NULL, 'Uncharacterized protein', 119, NULL, NULL, 57105),
(57106, '1.20.120.160-FF-000032', NULL, 'Hybrid sensor histidine kinase/response regulator', 113, NULL, NULL, 57106),
(57107, '1.20.1050.10-FF-000015', NULL, 'Glutathione S-transferase YfcF', 109, NULL, NULL, 57107),
(57108, '2.130.10.10-FF-001007', NULL, 'THO complex subunit 3', 174, NULL, NULL, 57108),
(57109, '1.10.510.10-FF-003887', NULL, NULL, 88, NULL, NULL, 57109),
(57110, '3.90.1150.10-FF-000382', NULL, 'Selenocysteine lyase', 11, NULL, NULL, 57110),
(57111, '3.30.70.920-FF-000036', NULL, 'Lrp/AsnC family transcriptional regulator', 90, NULL, NULL, 57111),
(57112, '2.160.20.10-FF-000012', NULL, 'Polygalacturonase At1g48100 family', 395, NULL, NULL, 57112),
(57113, '1.20.920.10-FF-000190', NULL, 'Chromosome 8, whole genome shotgun sequence', 118, NULL, NULL, 57113),
(57114, '1.25.40.10-FF-003159', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 118, NULL, NULL, 57114),
(57115, '3.90.70.10-FF-000668', NULL, 'Ubiquitin specific protease, putative', 302, NULL, NULL, 57115),
(57116, '3.30.300.20-FF-000001', NULL, '30S ribosomal protein S3', 92, NULL, NULL, 57116);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(57117, '3.40.50.720-FF-000886', NULL, 'Formate dehydrogenase', 136, NULL, NULL, 57117),
(57118, '2.60.40.10-FF-002311', NULL, 'Beta-mannosidase', 87, NULL, NULL, 57118),
(57119, '1.20.144.10-FF-000032', NULL, 'PAP2 superfamily protein', 238, NULL, NULL, 57119),
(57120, '2.30.29.30-FF-000460', NULL, 'Pleckstrin y domain-containing family H member 2', 108, NULL, NULL, 57120),
(57121, '3.40.50.300-FF-005959', NULL, 'YALI0E01760p', 172, NULL, NULL, 57121),
(57122, '3.40.50.720-FF-001403', NULL, 'GDPmannose 4,6-dehydratase', 217, NULL, NULL, 57122),
(57123, '3.40.50.300-FF-000316', NULL, 'Putative neuron navigator 3', 175, NULL, NULL, 57123),
(57124, '3.30.300.90-FF-000010', NULL, NULL, 56, NULL, NULL, 57124),
(57125, '1.20.1080.10-FF-000051', NULL, 'Uncharacterized protein', 231, NULL, NULL, 57125),
(57126, '3.30.200.160-FF-000002', NULL, 'Transcription factor IIIC, subunit 5', 112, NULL, NULL, 57126),
(57127, '1.25.40.10-FF-000725', NULL, 'Pentatricopeptide repeat-containing protein At3g63370, chloroplastic', 99, NULL, NULL, 57127),
(57128, '3.30.110.10-FF-000017', NULL, 'Translation initiation factor IF-3', 94, NULL, NULL, 57128),
(57129, '3.10.100.10-FF-000386', NULL, NULL, 129, NULL, NULL, 57129),
(57130, '1.10.10.60-FF-000390', NULL, 'YDR026C-like protein', 52, NULL, NULL, 57130),
(57131, '3.40.30.10-FF-000836', NULL, 'Protein disulfide-isomerase', 130, NULL, NULL, 57131),
(57132, '3.30.160.60-FF-003952', NULL, NULL, 22, NULL, NULL, 57132),
(57133, '3.40.50.150-FF-001007', NULL, NULL, 200, NULL, NULL, 57133),
(57134, '1.10.8.80-FF-000006', NULL, 'Mg-protoporphyrin IX chelatase', 82, NULL, NULL, 57134),
(57135, '3.80.10.10-FF-004223', NULL, 'Uncharacterized protein', 82, NULL, NULL, 57135),
(57136, '2.20.100.10-FF-000135', NULL, 'F-spondin', 70, NULL, NULL, 57136),
(57137, '2.40.10.10-FF-000579', NULL, NULL, 50, NULL, NULL, 57137),
(57138, '3.10.100.10-FF-000122', NULL, 'Killer cell lectin-like receptor subfamily A, member 1', 68, NULL, NULL, 57138),
(57139, '2.60.40.60-FF-000387', NULL, 'CAlSYntenin/Alcadein homolog', 101, NULL, NULL, 57139),
(57140, '2.40.50.140-FF-000671', NULL, NULL, 112, NULL, NULL, 57140),
(57141, '3.30.200.20-FF-002354', NULL, 'Phosphorylase kinase, gamma 1b (muscle)', 43, NULL, NULL, 57141),
(57142, '2.60.120.970-FF-000001', NULL, 'Growth/differentiation factor 8', 232, NULL, NULL, 57142),
(57143, '3.30.1050.10-FF-000028', NULL, 'Uncharacterized protein', 114, NULL, NULL, 57143),
(57144, '1.25.10.10-FF-003011', NULL, 'Uncharacterized protein', 336, NULL, NULL, 57144),
(57145, '3.40.190.10-FF-000183', NULL, 'Prephenate dehydratase', 89, NULL, NULL, 57145),
(57146, '2.130.10.10-FF-003155', NULL, 'Vacuolar assembly protein', 116, NULL, NULL, 57146),
(57147, '3.30.160.60-FF-005397', NULL, NULL, 45, NULL, NULL, 57147),
(57148, '1.25.40.690-FF-000008', NULL, 'Nuclear pore complex protein Nup98-Nup96', 92, NULL, NULL, 57148),
(57149, '2.130.10.10-FF-002699', NULL, 'WD domain, G-beta repeat, putative', 323, NULL, NULL, 57149),
(57150, '2.60.120.650-FF-000107', NULL, 'ARID/BRIGHT DNA binding domain-containing protein', 299, NULL, NULL, 57150),
(57151, '1.25.40.10-FF-001978', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 143, NULL, NULL, 57151),
(57152, '2.60.120.260-FF-000501', NULL, 'Uncharacterized protein', 83, NULL, NULL, 57152),
(57153, '3.30.565.10-FF-000505', NULL, 'Uncharacterized protein', 145, NULL, NULL, 57153),
(57154, '1.25.40.10-FF-001506', NULL, 'Os03g0317100 protein', 117, NULL, NULL, 57154),
(57155, '1.10.1750.10-FF-000003', NULL, 'Chromosomal replication initiator protein DnaA', 101, NULL, NULL, 57155),
(57156, '3.40.50.720-FF-002123', NULL, 'Fatty acyl-CoA reductase', 110, NULL, NULL, 57156),
(57157, '1.20.58.390-FF-000197', NULL, 'Glutamate-gated chloride channel, putative', 87, NULL, NULL, 57157),
(57158, '1.10.8.430-FF-000015', NULL, 'Disease resistance protein (CC-NBS-LRR class) family', 85, NULL, NULL, 57158),
(57159, '3.30.200.20-FF-000145', NULL, 'receptor-like serine/threonine-protein kinase SD1-8', 103, NULL, NULL, 57159);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(57160, '3.20.140.10-FF-000015', NULL, 'Nicotinate phosphoribosyltransferase', 153, NULL, NULL, 57160),
(57161, '1.10.3460.10-FF-000015', NULL, 'Os02g0610700 protein', 146, NULL, NULL, 57161),
(57162, '3.40.50.300-FF-000788', NULL, 'DNA annealing helicase and endonuclease ZRANB3', 245, NULL, NULL, 57162),
(57163, '2.130.10.10-FF-005925', NULL, 'EF hand family protein', 271, NULL, NULL, 57163),
(57164, '3.10.450.40-FF-000005', NULL, 'Amine oxidase', 94, NULL, NULL, 57164),
(57165, '1.10.3380.10-FF-000014', NULL, 'Putative DEAD/DEAH box helicase', 131, NULL, NULL, 57165),
(57166, '3.40.50.880-FF-000001', NULL, 'GMP synthase [glutamine-hydrolyzing]', 192, NULL, NULL, 57166),
(57167, '3.40.50.300-FF-007404', NULL, 'Uncharacterized protein', 28, NULL, NULL, 57167),
(57168, '3.40.50.410-FF-000057', NULL, 'Protein transport protein SEC23', 246, NULL, NULL, 57168),
(57169, '3.30.160.60-FF-003188', NULL, NULL, 31, NULL, NULL, 57169),
(57170, '3.40.50.300-FF-007292', NULL, 'Uncharacterized protein', 151, NULL, NULL, 57170),
(57171, '3.30.70.3400-FF-000017', NULL, 'Protein translocase subunit SecD', 76, NULL, NULL, 57171),
(57172, '1.10.730.10-FF-000172', NULL, 'Valine--tRNA ligase', 178, NULL, NULL, 57172),
(57173, '3.10.20.90-FF-000939', NULL, 'CHD gene family protein containing chromodomain, helicase domain, and DNA-binding domain', 76, NULL, NULL, 57173),
(57174, '1.10.357.110-FF-000007', NULL, 'Vacuolar sorting protein', 228, NULL, NULL, 57174),
(57175, '3.40.50.720-FF-001667', NULL, 'Glyoxylate/hydroxypyruvate reductase, putative', 190, NULL, NULL, 57175),
(57176, '3.20.20.70-FF-000028', NULL, 'Dihydroorotate dehydrogenase (quinone)', 336, NULL, NULL, 57176),
(57177, '3.40.50.2000-FF-000516', NULL, 'GD13807', 168, NULL, NULL, 57177),
(57178, '3.30.160.60-FF-002171', NULL, 'Zinc finger and BTB domain-containing protein 16', 30, NULL, NULL, 57178),
(57179, '1.10.510.10-FF-003179', NULL, NULL, 158, NULL, NULL, 57179),
(57180, '3.30.750.24-FF-000123', NULL, 'Sulfate transporter 2.1-like protein', 135, NULL, NULL, 57180),
(57181, '2.10.25.10-FF-000732', NULL, 'Cryptic family protein 1B', 36, NULL, NULL, 57181),
(57182, '3.30.230.70-FF-000139', NULL, 'Exosomal 3''-5'' exoribonuclease complex, subunit Rrp41, putative', 148, NULL, NULL, 57182),
(57183, '1.10.486.10-FF-000030', NULL, 'RecBCD enzyme subunit RecB', 142, NULL, NULL, 57183),
(57184, '2.20.70.10-FF-000134', NULL, 'Uncharacterized protein, isoform C', 84, NULL, NULL, 57184),
(57185, '1.10.565.10-FF-000040', NULL, 'Uncharacterized protein, isoform A', 211, NULL, NULL, 57185),
(57186, '3.40.50.2300-FF-000016', NULL, 'Taste 1 receptor member 2', 159, NULL, NULL, 57186),
(57187, '2.60.40.10-FF-005801', NULL, NULL, 80, NULL, NULL, 57187),
(57188, '3.30.450.60-FF-000001', NULL, 'AP complex subunit sigma', 157, NULL, NULL, 57188),
(57189, '3.30.710.10-FF-000107', NULL, 'Zinc finger and BTB domain containing 22', 138, NULL, NULL, 57189),
(57190, '3.30.70.1660-FF-000034', NULL, 'Uncharacterized protein', 136, NULL, NULL, 57190),
(57191, '2.10.25.10-FF-000171', NULL, 'Fibrillin 2', 43, NULL, NULL, 57191),
(57192, '3.40.50.620-FF-000682', NULL, 'Protein CBR-VARS-1', 150, NULL, NULL, 57192),
(57193, '1.25.40.20-FF-001190', NULL, 'KN motif and ankyrin repeat domains 3', 131, NULL, NULL, 57193),
(57194, '1.20.1250.20-FF-002242', NULL, 'Uncharacterized protein', 114, NULL, NULL, 57194),
(57195, '3.30.1010.10-FF-000115', NULL, 'Ataxia telangiectasia mutated, putative', 99, NULL, NULL, 57195),
(57196, '2.60.200.40-FF-000007', NULL, 'diacylglycerol kinase', 182, NULL, NULL, 57196),
(57197, '3.40.800.10-FF-000028', NULL, 'Uncharacterized protein', 291, NULL, NULL, 57197),
(57198, '2.60.40.10-FF-002783', NULL, 'AMP-activated protein kinase', 90, NULL, NULL, 57198),
(57199, '3.40.50.300-FF-007792', NULL, 'ZRAB1B, member RAS oncogene family a', 48, NULL, NULL, 57199),
(57200, '3.40.50.720-FF-000678', NULL, 'Aos1p', 346, NULL, NULL, 57200),
(57201, '1.10.10.10-FF-000217', NULL, 'Peroxisomal membrane protein PEX14', 63, NULL, NULL, 57201),
(57202, '3.30.40.10-FF-000950', NULL, 'Nhl repeat-containing protein, putative', 99, NULL, NULL, 57202);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(57203, '1.20.1070.10-FF-000550', NULL, 'Vomeronasal type-1 receptor', 296, NULL, NULL, 57203),
(57204, '1.10.510.10-FF-003679', NULL, NULL, 171, NULL, NULL, 57204),
(57205, '2.130.10.10-FF-004144', NULL, 'AGAP002345-PA', 180, NULL, NULL, 57205),
(57206, '3.20.20.100-FF-000053', NULL, 'Aldo-keto oxidoreductase', 279, NULL, NULL, 57206),
(57207, '1.25.10.10-FF-002022', NULL, 'Transportin-1', 347, NULL, NULL, 57207),
(57208, '3.40.50.720-FF-000414', NULL, 'Calcium-activated potassium channel subunit alpha-1', 145, NULL, NULL, 57208),
(57209, '2.130.10.10-FF-004852', NULL, 'Uncharacterized protein', 128, NULL, NULL, 57209),
(57210, '3.90.660.10-FF-000123', NULL, NULL, 115, NULL, NULL, 57210),
(57211, '3.30.300.130-FF-000044', NULL, NULL, 33, NULL, NULL, 57211),
(57212, '3.40.50.1440-FF-000073', NULL, 'Cell division protein, GTPase domain', 194, NULL, NULL, 57212),
(57213, '3.40.50.300-FF-000524', NULL, 'ATP-dependent RNA helicase DDX42', 175, NULL, NULL, 57213),
(57214, '3.30.160.60-FF-004941', NULL, NULL, 73, NULL, NULL, 57214),
(57215, '3.40.50.1970-FF-000057', NULL, NULL, 142, NULL, NULL, 57215),
(57216, '4.10.1240.50-FF-000002', NULL, 'REST corepressor isoform X1', 86, NULL, NULL, 57216),
(57217, '1.10.287.70-FF-000304', NULL, 'TWiK family of potassium channels', 278, NULL, NULL, 57217),
(57218, '3.10.450.50-FF-000103', NULL, 'Predicted protein', 175, NULL, NULL, 57218),
(57219, '2.120.10.80-FF-000399', NULL, 'Uncharacterized protein', 141, NULL, NULL, 57219),
(57220, '3.30.160.60-FF-004880', NULL, NULL, 34, NULL, NULL, 57220),
(57221, '2.60.40.1090-FF-000003', NULL, 'Fimbrial subunit', 153, NULL, NULL, 57221),
(57222, '3.90.810.10-FF-000040', NULL, NULL, 71, NULL, NULL, 57222),
(57223, '3.40.1190.20-FF-000241', NULL, NULL, 91, NULL, NULL, 57223),
(57224, '3.50.50.60-FF-001268', NULL, 'Uncharacterized protein', 84, NULL, NULL, 57224),
(57225, '1.25.40.10-FF-001006', NULL, 'Sel1 repeat family protein', 70, NULL, NULL, 57225),
(57226, '3.90.70.10-FF-000876', NULL, 'Protein CBG06541', 59, NULL, NULL, 57226),
(57227, '3.80.10.10-FF-004431', NULL, 'Uncharacterized protein', 208, NULL, NULL, 57227),
(57228, '3.20.180.20-FF-000026', NULL, 'Uncharacterized protein', 96, NULL, NULL, 57228),
(57229, '3.40.720.10-FF-000027', NULL, 'iduronate 2-sulfatase', 495, NULL, NULL, 57229),
(57230, '2.60.40.10-FF-004020', NULL, NULL, 98, NULL, NULL, 57230),
(57231, '1.10.3430.10-FF-000075', NULL, 'Uncharacterized protein', 129, NULL, NULL, 57231),
(57232, '2.10.25.10-FF-000996', NULL, 'Notch homolog 2', 34, NULL, NULL, 57232),
(57233, '3.60.21.10-FF-000399', NULL, 'Serine/threonine-protein phosphatase', 315, NULL, NULL, 57233),
(57234, '3.30.40.10-FF-001467', NULL, 'Uncharacterized protein', 104, NULL, NULL, 57234),
(57235, '3.30.200.20-FF-000645', NULL, 'Receptor-like protein kinase FERONIA', 105, NULL, NULL, 57235),
(57236, '2.130.10.10-FF-002199', NULL, 'Probable elongator complex protein 2', 144, NULL, NULL, 57236),
(57237, '2.10.110.10-FF-000014', NULL, 'PDZ and LIM domain protein 5', 71, NULL, NULL, 57237),
(57238, '3.40.640.10-FF-000026', NULL, 'Aspartate aminotransferase', 273, NULL, NULL, 57238),
(57239, '2.40.10.10-FF-000079', NULL, 'Serine protease 53', 223, NULL, NULL, 57239),
(57240, '3.30.70.330-FF-002574', NULL, NULL, 142, NULL, NULL, 57240),
(57241, '3.40.50.300-FF-002733', NULL, 'Galactose-3-O-sulfotransferase 4', 336, NULL, NULL, 57241),
(57242, '3.30.160.60-FF-002732', NULL, 'zinc finger protein 5', 77, NULL, NULL, 57242),
(57243, '1.20.950.20-FF-000020', NULL, 'Cytochrome b', 81, NULL, NULL, 57243),
(57244, '2.130.10.10-FF-003363', NULL, 'Myosin heavy chain kinase C', 286, NULL, NULL, 57244),
(57245, '1.10.510.10-FF-001734', NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 130', 122, NULL, NULL, 57245),
(57246, '3.30.2080.10-FF-000002', NULL, 'Glycosyl hydrolase family 92', 150, NULL, NULL, 57246),
(57247, '2.40.30.10-FF-000378', NULL, 'Elongation factor 2', 120, NULL, NULL, 57247),
(57248, '3.40.50.1820-FF-001552', NULL, 'Uncharacterized protein', 124, NULL, NULL, 57248),
(57249, '3.30.1640.30-FF-000006', NULL, 'Uncharacterized protein, isoform A', 63, NULL, NULL, 57249);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(57250, '3.30.470.30-FF-000021', NULL, 'DNA ligase', 221, NULL, NULL, 57250),
(57251, '3.40.50.1100-FF-000201', NULL, 'Threonine ammonia-lyase', 64, NULL, NULL, 57251),
(57252, '3.30.70.20-FF-000016', NULL, 'NADH-quinone oxidoreductase', 74, NULL, NULL, 57252),
(57253, '3.30.830.10-FF-000234', NULL, 'Uncharacterized protein', 135, NULL, NULL, 57253),
(57254, '3.10.350.10-FF-000045', NULL, 'N-acetylmuramoyl-L-alanine amidase', 62, NULL, NULL, 57254),
(57255, '3.40.1110.10-FF-000312', NULL, NULL, 128, NULL, NULL, 57255),
(57256, '1.10.1200.10-FF-000119', NULL, 'Polyketide synthase, putative (JCVI)', 105, NULL, NULL, 57256),
(57257, '3.30.420.10-FF-000271', NULL, 'Ribonuclease, putative', 324, NULL, NULL, 57257),
(57258, '3.30.30.10-FF-000005', NULL, 'Defensin', 40, NULL, NULL, 57258),
(57259, '1.20.1070.10-FF-001567', NULL, 'Uncharacterized protein', 167, NULL, NULL, 57259),
(57260, '2.130.10.10-FF-001979', NULL, 'WD domain, G-beta repeat, putative', 179, NULL, NULL, 57260),
(57261, '3.40.20.10-FF-000015', NULL, 'supervillin isoform X2', 118, NULL, NULL, 57261),
(57262, '1.10.8.60-FF-000170', NULL, 'Uncharacterized protein, isoform A', 88, NULL, NULL, 57262),
(57263, '3.40.630.10-FF-000464', NULL, 'Uncharacterized protein', 108, NULL, NULL, 57263),
(57264, '1.20.1560.10-FF-000306', NULL, 'Uncharacterized protein', 355, NULL, NULL, 57264),
(57265, '4.10.1010.10-FF-000001', NULL, 'Apical membrane antigen 1', 105, NULL, NULL, 57265),
(57266, '3.40.30.10-FF-001033', NULL, 'Selenoprotein V', 46, NULL, NULL, 57266),
(57267, '3.30.70.580-FF-000035', NULL, 'tRNA pseudouridine synthase, putative', 123, NULL, NULL, 57267),
(57268, '3.30.460.10-FF-000037', NULL, 'Lincosamide nucleotidyltransferase', 136, NULL, NULL, 57268),
(57269, '2.60.40.2030-FF-000032', NULL, 'Adhesion G protein-coupled receptor V1', 116, NULL, NULL, 57269),
(57270, '3.80.10.10-FF-002278', NULL, 'Uncharacterized protein', 85, NULL, NULL, 57270),
(57271, '2.60.40.60-FF-000887', NULL, 'Si:dkey-30k22.7', 58, NULL, NULL, 57271),
(57272, '3.30.160.60-FF-004677', NULL, NULL, 29, NULL, NULL, 57272),
(57273, '3.30.70.270-FF-000061', NULL, 'DNA polymerase IV', 98, NULL, NULL, 57273),
(57274, '1.25.40.20-FF-001251', NULL, 'Predicted protein', 227, NULL, NULL, 57274),
(57275, '3.40.50.2000-FF-000308', NULL, 'Glycosyltransferase family 1 protein', 221, NULL, NULL, 57275),
(57276, '2.60.40.10-FF-002575', NULL, 'Protein tyrosine phosphatase, receptor type Q', 86, NULL, NULL, 57276),
(57277, '1.10.238.10-FF-000909', NULL, 'Phosphoinositide phospholipase C', 92, NULL, NULL, 57277),
(57278, '1.10.490.10-FF-000017', NULL, 'Globin-like protein 6', 161, NULL, NULL, 57278),
(57279, '3.90.1150.10-FF-000443', NULL, 'Uncharacterized protein', 156, NULL, NULL, 57279),
(57280, '2.30.42.10-FF-000327', NULL, 'Protein inturned', 87, NULL, NULL, 57280),
(57281, '2.10.90.10-FF-000130', NULL, 'Noggin', 123, NULL, NULL, 57281),
(57282, '1.25.40.10-FF-000489', NULL, 'cilia- and flagella-associated protein 70 isoform X2', 84, NULL, NULL, 57282),
(57283, '2.30.30.100-FF-000219', NULL, 'Sm protein', 74, NULL, NULL, 57283),
(57284, '3.40.30.10-FF-001180', NULL, 'Glutathione S-transferase', 82, NULL, NULL, 57284),
(57285, '2.120.10.30-FF-000137', NULL, 'Dappled', 106, NULL, NULL, 57285),
(57286, '3.40.190.10-FF-000683', NULL, 'Putative glutamate receptor ionotropic kainate 3', 104, NULL, NULL, 57286),
(57287, '3.10.20.90-FF-000439', NULL, 'Autophagy protein 5', 133, NULL, NULL, 57287),
(57288, '3.40.50.300-FF-002469', NULL, 'Cell division control protein 21', 338, NULL, NULL, 57288),
(57289, '3.40.50.1820-FF-000271', NULL, 'Neuroligin-1', 594, NULL, NULL, 57289),
(57290, '3.30.450.20-FF-000068', NULL, 'Methyl-accepting chemotaxis protein', 99, NULL, NULL, 57290),
(57291, '3.20.20.70-FF-000528', NULL, 'Fe hydrogenase maturation rSAM protein HydG', 386, NULL, NULL, 57291),
(57292, '1.25.40.10-FF-003923', NULL, 'SnoRNA-binding rRNA-processing protein', 292, NULL, NULL, 57292),
(57293, '3.30.160.60-FF-000462', NULL, 'Zinc finger protein 410', 27, NULL, NULL, 57293),
(57294, '1.10.510.10-FF-004084', NULL, NULL, 163, NULL, NULL, 57294);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(57295, '1.10.287.110-FF-000345', NULL, 'Molecular chaperones (DnaJ family)', 64, NULL, NULL, 57295),
(57296, '1.10.10.60-FF-000743', NULL, 'Transcription factor MYB57', 65, NULL, NULL, 57296),
(57297, '2.130.10.10-FF-000754', NULL, 'SMU1, DNA replication regulator and spliceosomal factor', 134, NULL, NULL, 57297),
(57298, '1.20.58.60-FF-000313', NULL, 'Microtubule-actin cross-linking factor 1', 117, NULL, NULL, 57298),
(57299, '2.60.40.10-FF-005184', NULL, NULL, 93, NULL, NULL, 57299),
(57300, '2.60.120.430-FF-000013', NULL, 'Putative receptor-like protein kinase', 186, NULL, NULL, 57300),
(57301, '3.40.50.2000-FF-000196', NULL, 'UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase GtfA subunit', 172, NULL, NULL, 57301),
(57302, '3.40.50.800-FF-000051', NULL, 'Proline--tRNA ligase', 112, NULL, NULL, 57302),
(57303, '3.10.290.60-FF-000009', NULL, 'Ubiquitin activating enzyme, putative', 91, NULL, NULL, 57303),
(57304, '3.40.5.60-FF-000001', NULL, 'DNA replication complex GINS protein SLD5', 59, NULL, NULL, 57304),
(57305, '2.60.120.10-FF-000110', NULL, 'AGC/AGC-SAR/CILIATE-E2B protein kinase', 125, NULL, NULL, 57305),
(57306, '3.30.70.330-FF-002102', NULL, NULL, 120, NULL, NULL, 57306),
(57307, '1.10.1670.10-FF-000002', NULL, 'Adenine DNA glycosylase', 93, NULL, NULL, 57307),
(57308, '2.10.25.10-FF-001249', NULL, 'Matrilin 3a', 35, NULL, NULL, 57308),
(57309, '1.10.510.10-FF-000453', NULL, 'LRR receptor-like serine/threonine-protein kinase HSL2', 212, NULL, NULL, 57309),
(57310, '3.40.50.300-FF-001805', NULL, 'Similar to DNA repair protein rad50', 166, NULL, NULL, 57310),
(57311, '1.25.40.10-FF-004587', NULL, 'Uncharacterized protein', 173, NULL, NULL, 57311),
(57312, '1.25.40.330-FF-000013', NULL, 'Uncharacterized protein', 67, NULL, NULL, 57312),
(57313, '2.30.29.30-FF-000105', NULL, 'Target of rapamycin complex 2 subunit MAPKAP1', 125, NULL, NULL, 57313),
(57314, '3.30.540.10-FF-000038', NULL, 'Inositol-1-monophosphatase SuhB', 164, NULL, NULL, 57314),
(57315, '1.25.40.10-FF-001153', NULL, 'Serine/threonine-protein phosphatase', 126, NULL, NULL, 57315),
(57316, '1.25.70.10-FF-000053', NULL, 'mTERF family protein', 204, NULL, NULL, 57316),
(57317, '1.25.10.10-FF-002606', NULL, 'LOC553344 protein', 143, NULL, NULL, 57317),
(57318, '2.70.130.10-FF-000119', NULL, NULL, 67, NULL, NULL, 57318),
(57319, '1.10.30.10-FF-000016', NULL, 'FACT complex subunit SSRP1', 94, NULL, NULL, 57319),
(57320, '1.20.1070.10-FF-000286', NULL, 'Neuropeptide CCHamide-1 receptor', 359, NULL, NULL, 57320),
(57321, '3.10.110.10-FF-000151', NULL, 'Ubiquitin-conjugating enzyme E2-17 kDa', 148, NULL, NULL, 57321),
(57322, '1.20.58.60-FF-000460', NULL, 'AGAP004440-PA', 108, NULL, NULL, 57322),
(57323, '2.60.120.290-FF-000044', NULL, 'Complement C1r subcomponent like', 124, NULL, NULL, 57323),
(57324, '2.60.40.10-FF-001406', NULL, 'Protein-glutamine gamma-glutamyltransferase 4', 118, NULL, NULL, 57324),
(57325, '2.40.50.1020-FF-000021', NULL, 'Two-component system response regulator protein', 92, NULL, NULL, 57325),
(57326, '3.30.70.330-FF-000157', NULL, 'RNA-binding protein 8A', 165, NULL, NULL, 57326),
(57327, '1.10.287.1970-FF-000004', NULL, 'Aminotransferase, classes I and II family protein', 46, NULL, NULL, 57327),
(57328, '3.30.160.380-FF-000012', NULL, NULL, 96, NULL, NULL, 57328),
(57329, '3.30.40.10-FF-001259', NULL, 'Os11g0610600 protein', 60, NULL, NULL, 57329),
(57330, '4.10.400.10-FF-000332', NULL, 'Suppressor of tumorigenicity 14 protein homolog', 36, NULL, NULL, 57330),
(57331, '1.10.10.10-FF-000689', NULL, 'Transcriptional regulator, LysR family', 84, NULL, NULL, 57331),
(57332, '1.10.238.10-FF-000853', NULL, 'Uncharacterized protein', 68, NULL, NULL, 57332),
(57333, '2.60.40.10-FF-005037', NULL, NULL, 103, NULL, NULL, 57333),
(57334, '3.30.70.100-FF-000173', NULL, NULL, 73, NULL, NULL, 57334),
(57335, '1.20.272.10-FF-000054', NULL, NULL, 45, NULL, NULL, 57335),
(57336, '1.20.58.160-FF-000010', NULL, NULL, 105, NULL, NULL, 57336),
(57337, '3.30.390.50-FF-000026', NULL, 'Uncharacterized protein', 87, NULL, NULL, 57337); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(57338, '2.130.10.10-FF-004644', NULL, 'Predicted protein', 192, NULL, NULL, 57338),
(57339, '2.130.10.10-FF-003216', NULL, 'Uncharacterized protein', 24, NULL, NULL, 57339),
(57340, '4.10.270.10-FF-000006', NULL, 'Calmodulin-binding transcription activator 1', 46, NULL, NULL, 57340),
(57341, '3.40.50.720-FF-000178', NULL, 'Saccharopine dehydrogenase-like oxidoreductase', 168, NULL, NULL, 57341),
(57342, '2.30.110.10-FF-000088', NULL, 'Pyridoxamine 5''-phosphate oxidase-related FMN-binding', 137, NULL, NULL, 57342),
(57343, '3.30.70.330-FF-000865', NULL, 'Plastid-specific 30S ribosomal protein 2', 109, NULL, NULL, 57343),
(57344, '2.40.50.140-FF-000727', NULL, NULL, 63, NULL, NULL, 57344),
(57345, '3.30.70.1820-FF-000009', NULL, NULL, 97, NULL, NULL, 57345),
(57346, '2.40.70.10-FF-000408', NULL, NULL, 114, NULL, NULL, 57346),
(57347, '3.30.420.10-FF-000119', NULL, 'Ribonuclease H', 146, NULL, NULL, 57347),
(57348, '1.20.1250.20-FF-000241', NULL, 'MFS transporter', 238, NULL, NULL, 57348),
(57349, '3.30.390.30-FF-000015', NULL, 'Nitrite reductase large subunit', 82, NULL, NULL, 57349),
(57350, '1.10.510.10-FF-002398', NULL, NULL, 231, NULL, NULL, 57350),
(57351, '1.25.40.10-FF-002434', NULL, 'Putative pentatricopeptide repeat family protein', 90, NULL, NULL, 57351),
(57352, '1.10.287.70-FF-000512', NULL, 'Uncharacterized protein', 97, NULL, NULL, 57352),
(57353, '3.40.50.300-FF-006364', NULL, 'Protein CBG21117', 139, NULL, NULL, 57353),
(57354, '2.30.30.40-FF-000179', NULL, 'PML-RARA regulated adaptor molecule 1', 83, NULL, NULL, 57354),
(57355, '3.80.10.10-FF-000480', NULL, 'Leucine rich repeat containing 1', 174, NULL, NULL, 57355),
(57356, '2.170.270.10-FF-000235', NULL, 'PR domain containing 4', 59, NULL, NULL, 57356),
(57357, '3.90.15.10-FF-000012', NULL, 'DNA topoisomerase I', 155, NULL, NULL, 57357),
(57358, '1.20.1310.10-FF-000086', NULL, 'Cullin-like protein-like protein', 109, NULL, NULL, 57358),
(57359, '1.10.150.310-FF-000001', NULL, 'RNA-binding transcriptional accessory protein', 138, NULL, NULL, 57359),
(57360, '3.90.190.10-FF-000278', NULL, 'Protein CBG26392', 159, NULL, NULL, 57360),
(57361, '3.80.10.10-FF-002014', NULL, 'Receptor-like protein 30', 75, NULL, NULL, 57361),
(57362, '3.30.40.10-FF-000539', NULL, 'Ring finger domain protein', 64, NULL, NULL, 57362),
(57363, '1.10.510.10-FF-000189', NULL, 'Serine/threonine-protein kinase PLK', 177, NULL, NULL, 57363),
(57364, '2.60.110.10-FF-000020', NULL, 'Os08g0381600 protein', 63, NULL, NULL, 57364),
(57365, '2.40.70.10-FF-000296', NULL, NULL, 62, NULL, NULL, 57365),
(57366, '3.40.50.1000-FF-000317', NULL, 'NLI interacting factor-like phosphatase, putative', 190, NULL, NULL, 57366),
(57367, '1.25.40.470-FF-000061', NULL, 'WD repeat-containing protein 19', 150, NULL, NULL, 57367),
(57368, '3.30.160.60-FF-001243', NULL, 'myeloid zinc finger 1 isoform X1', 25, NULL, NULL, 57368),
(57369, '2.10.25.10-FF-001660', NULL, 'Uncharacterized protein', 70, NULL, NULL, 57369),
(57370, '3.80.10.10-FF-001558', NULL, 'Leucine rich repeat and phosphatase domain containing protein', 127, NULL, NULL, 57370),
(57371, '2.60.40.150-FF-000010', NULL, 'Ras GTPase-activating protein nGAP isoform 2', 112, NULL, NULL, 57371),
(57372, '2.30.29.30-FF-000813', NULL, 'Guanine nucleotide exchange factor UNC-73B', 121, NULL, NULL, 57372),
(57373, '2.10.60.10-FF-000038', NULL, 'Serine/threonine-protein kinase receptor', 99, NULL, NULL, 57373),
(57374, '3.40.50.300-FF-001244', NULL, 'tRNA threonylcarbamoyl adenosine modification protein YjeE', 137, NULL, NULL, 57374),
(57375, '4.10.280.10-FF-000243', NULL, 'Uncharacterized protein', 60, NULL, NULL, 57375),
(57376, '1.25.40.120-FF-000040', NULL, 'Protein farnesyltransferase/geranylgeranyltransferase type-1 subunit alpha', 319, NULL, NULL, 57376),
(57377, '4.10.60.10-FF-000106', NULL, 'Zinc finger protein containing protein', 27, NULL, NULL, 57377),
(57378, '3.30.70.141-FF-000023', NULL, 'Nucleoside diphosphate kinase, putative', 156, NULL, NULL, 57378),
(57379, '1.20.120.1750-FF-000095', NULL, 'Probable E3 ubiquitin-protein ligase ARI12', 245, NULL, NULL, 57379);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(57380, '1.20.120.220-FF-000011', NULL, 'ATP synthase subunit a', 155, NULL, NULL, 57380),
(57381, '1.10.472.170-FF-000009', NULL, 'Putative transcription factor', 166, NULL, NULL, 57381),
(57382, '1.10.10.10-FF-001145', NULL, 'PCI domain-containing protein C1105.07c', 69, NULL, NULL, 57382),
(57383, '1.20.1270.60-FF-000260', NULL, 'Uncharacterized protein', 185, NULL, NULL, 57383),
(57384, '1.10.238.10-FF-000089', NULL, 'calmodulin-like protein 3', 72, NULL, NULL, 57384),
(57385, '3.40.630.30-FF-000150', NULL, 'N-hydroxycinnamoyl-CoA:tyramine N-hydroxycinnamoyl transferase THT7-1', 178, NULL, NULL, 57385),
(57386, '3.30.160.60-FF-003452', NULL, NULL, 27, NULL, NULL, 57386),
(57387, '1.25.40.20-FF-000846', NULL, 'Kinase, NEK', 206, NULL, NULL, 57387),
(57388, '1.20.1050.10-FF-000223', NULL, 'Uncharacterized protein', 105, NULL, NULL, 57388),
(57389, '3.80.10.10-FF-003767', NULL, 'Uncharacterized protein', 112, NULL, NULL, 57389),
(57390, '4.10.400.10-FF-000068', NULL, 'Low-density lipoprotein receptor-related protein 1B', 43, NULL, NULL, 57390),
(57391, '2.40.50.120-FF-000013', NULL, 'Complement C3', 149, NULL, NULL, 57391),
(57392, '3.30.870.10-FF-000147', NULL, 'Probable tyrosyl-DNA phosphodiesterase', 274, NULL, NULL, 57392),
(57393, '1.10.510.10-FF-002959', NULL, 'Chromosome 21, whole genome shotgun sequence', 192, NULL, NULL, 57393),
(57394, '2.10.25.10-FF-001513', NULL, 'Fibulin-1', 49, NULL, NULL, 57394),
(57395, '1.10.3720.10-FF-000086', NULL, 'Glutathione transport system permease protein GsiC', 226, NULL, NULL, 57395),
(57396, '3.40.190.10-FF-000536', NULL, 'Norspermidine sensor', 157, NULL, NULL, 57396),
(57397, '2.70.160.11-FF-000044', NULL, 'Histone-arginine methyltransferase CARM1', 205, NULL, NULL, 57397),
(57398, '1.10.10.60-FF-000890', NULL, 'CHD gene family protein containing chromodomain, helicase domain, and DNA-binding domain', 109, NULL, NULL, 57398),
(57399, '1.20.5.370-FF-000006', NULL, 'Myosin heavy chain', 49, NULL, NULL, 57399),
(57400, '1.25.10.10-FF-002494', NULL, 'Uncharacterized protein', 206, NULL, NULL, 57400),
(57401, '1.20.1440.180-FF-000005', NULL, 'Probable serine/threonine-protein kinase irlD', 162, NULL, NULL, 57401),
(57402, '3.30.160.60-FF-001390', NULL, 'Uncharacterized protein', 30, NULL, NULL, 57402),
(57403, '1.20.1560.10-FF-000453', NULL, 'ABC transporter B family member 6', 328, NULL, NULL, 57403),
(57404, '3.50.50.60-FF-000487', NULL, 'Thiol-specific monooxygenase', 313, NULL, NULL, 57404),
(57405, '2.30.150.10-FF-000001', NULL, 'DNA-directed RNA polymerase subunit beta', 67, NULL, NULL, 57405),
(57406, '3.30.1370.10-FF-000075', NULL, 'KRR1 small subunit processome component', 103, NULL, NULL, 57406),
(57407, '3.50.50.100-FF-000063', NULL, 'Uncharacterized protein', 78, NULL, NULL, 57407),
(57408, '3.40.50.10810-FF-000123', NULL, 'Uncharacterized protein', 137, NULL, NULL, 57408),
(57409, '1.20.1270.60-FF-000108', NULL, 'Rho-GTPase-activating protein RGD2', 207, NULL, NULL, 57409),
(57410, '3.40.50.1820-FF-000119', NULL, 'Alpha/beta hydrolase family protein', 94, NULL, NULL, 57410),
(57411, '3.30.70.330-FF-001793', NULL, NULL, 113, NULL, NULL, 57411),
(57412, '2.60.210.10-FF-000084', NULL, NULL, 48, NULL, NULL, 57412),
(57413, '1.10.472.10-FF-000088', NULL, 'Cyclin-H', 119, NULL, NULL, 57413),
(57414, '2.70.70.10-FF-000053', NULL, 'PTS beta-glucoside transporter subunit IIBCA', 160, NULL, NULL, 57414),
(57415, '2.10.70.10-FF-000275', NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing 1', 62, NULL, NULL, 57415),
(57416, '2.40.50.140-FF-000019', NULL, 'Translation initiation factor IF-1, chloroplastic', 77, NULL, NULL, 57416),
(57417, '1.25.40.10-FF-000225', NULL, 'Protein SMG7', 246, NULL, NULL, 57417),
(57418, '1.10.1070.11-FF-000042', NULL, 'Phosphatidylinositol 3-kinase VPS34', 201, NULL, NULL, 57418),
(57419, '3.30.420.40-FF-000375', NULL, 'Actin-related protein 8', 69, NULL, NULL, 57419),
(57420, '3.30.200.20-FF-001426', NULL, 'MAP kinase-interacting serine/threonine-protein kinase 2 isoform X1', 30, NULL, NULL, 57420); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(57421, '3.40.525.10-FF-000006', NULL, 'SEC14-like lipid binding 1', 281, NULL, NULL, 57421),
(57422, '1.20.1160.11-FF-000002', NULL, 'Paired amphipathic helix protein SIN3', 74, NULL, NULL, 57422),
(57423, '1.10.8.10-FF-000205', NULL, 'Ubiquitin family protein', 68, NULL, NULL, 57423),
(57424, '2.60.40.10-FF-001294', NULL, 'EGF like, fibronectin type III and laminin G domains', 112, NULL, NULL, 57424),
(57425, '2.70.170.10-FF-000184', NULL, 'Uncharacterized protein', 217, NULL, NULL, 57425),
(57426, '3.40.50.720-FF-001903', NULL, 'Uncharacterized protein', 68, NULL, NULL, 57426),
(57427, '2.10.220.10-FF-000168', NULL, 'Uncharacterized protein', 90, NULL, NULL, 57427),
(57428, '2.30.29.30-FF-000252', NULL, 'ARF GTPase activator (Csx2)', 120, NULL, NULL, 57428),
(57429, '3.40.720.10-FF-000230', NULL, 'Arylsulfatase (A or B)', 386, NULL, NULL, 57429),
(57430, '3.40.50.2000-FF-000460', NULL, 'Glycosyltransferase', 254, NULL, NULL, 57430),
(57431, '1.10.268.10-FF-000029', NULL, NULL, 93, NULL, NULL, 57431),
(57432, '3.40.50.300-FF-008573', NULL, 'Uncharacterized protein', 52, NULL, NULL, 57432),
(57433, '3.40.50.300-FF-006887', NULL, 'Predicted ATP-dependent endonuclease, OLD family', 372, NULL, NULL, 57433),
(57434, '1.10.10.10-FF-001706', NULL, 'MW2463 protein', 68, NULL, NULL, 57434),
(57435, '3.30.420.40-FF-000898', NULL, 'Uncharacterized protein', 90, NULL, NULL, 57435),
(57436, '1.25.40.10-FF-003659', NULL, 'Transcription factor IIIC-gamma subunit', 178, NULL, NULL, 57436),
(57437, '2.130.10.10-FF-005369', NULL, 'Uncharacterized protein', 167, NULL, NULL, 57437),
(57438, '2.60.40.10-FF-004784', NULL, NULL, 74, NULL, NULL, 57438),
(57439, '1.20.58.480-FF-000016', NULL, 'Uncharacterized protein', 248, NULL, NULL, 57439),
(57440, '2.60.120.920-FF-000003', NULL, 'ryanodine receptor isoform X2', 179, NULL, NULL, 57440),
(57441, '1.25.10.10-FF-003039', NULL, 'Uncharacterized protein', 299, NULL, NULL, 57441),
(57442, '2.60.120.330-FF-000040', NULL, 'Chromosome 21, whole genome shotgun sequence', 332, NULL, NULL, 57442),
(57443, '3.90.1110.10-FF-000025', NULL, NULL, 184, NULL, NULL, 57443),
(57444, '1.10.287.70-FF-000720', NULL, 'Uncharacterized protein', 242, NULL, NULL, 57444),
(57445, '3.40.50.300-FF-004150', NULL, 'Adapter protein unc-53', 118, NULL, NULL, 57445),
(57446, '2.60.40.10-FF-004312', NULL, NULL, 193, NULL, NULL, 57446),
(57447, '3.10.100.10-FF-000206', NULL, 'Uncharacterized protein', 128, NULL, NULL, 57447),
(57448, '1.10.520.10-FF-000015', NULL, 'Peroxidase', 147, NULL, NULL, 57448),
(57449, '1.25.40.10-FF-004648', NULL, 'Protein CBG11979', 234, NULL, NULL, 57449),
(57450, '2.130.10.10-FF-005425', NULL, 'Uncharacterized protein', 242, NULL, NULL, 57450),
(57451, '2.20.100.10-FF-000051', NULL, 'Cartilage intermediate layer protein 2', 59, NULL, NULL, 57451),
(57452, '3.40.50.10490-FF-000072', NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', 146, NULL, NULL, 57452),
(57453, '3.40.50.1820-FF-000294', NULL, 'Uncharacterized protein, isoform B', 294, NULL, NULL, 57453),
(57454, '1.10.472.30-FF-000010', NULL, 'Uncharacterized protein, isoform B', 119, NULL, NULL, 57454),
(57455, '2.40.10.10-FF-000495', NULL, NULL, 130, NULL, NULL, 57455),
(57456, '2.60.40.150-FF-000038', NULL, 'Type I inositol 3,4-bisphosphate 4-phosphatase', 130, NULL, NULL, 57456),
(57457, '1.25.40.10-FF-004704', NULL, 'Os06g0705300 protein', 97, NULL, NULL, 57457),
(57458, '2.40.10.10-FF-000551', NULL, NULL, 77, NULL, NULL, 57458),
(57459, '2.10.25.10-FF-000816', NULL, 'Thrombomodulin', 40, NULL, NULL, 57459),
(57460, '3.30.230.10-FF-000205', NULL, 'Phosphomevalonate kinase', 238, NULL, NULL, 57460),
(57461, '1.10.510.10-FF-002662', NULL, NULL, 126, NULL, NULL, 57461),
(57462, '3.90.640.10-FF-000263', NULL, 'Actin family protein', 78, NULL, NULL, 57462),
(57463, '3.30.540.10-FF-000015', NULL, '3'',5''-bisphosphate nucleotidase', 217, NULL, NULL, 57463),
(57464, '3.40.50.300-FF-004094', NULL, 'Putative dynein heavy chain', 182, NULL, NULL, 57464),
(57465, '2.60.40.10-FF-004256', NULL, NULL, 143, NULL, NULL, 57465);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(57466, '2.130.10.10-FF-004913', NULL, 'Uncharacterized protein', 110, NULL, NULL, 57466),
(57467, '2.110.10.10-FF-000064', NULL, 'Uncharacterized protein', 130, NULL, NULL, 57467),
(57468, '3.40.1090.10-FF-000051', NULL, 'Triacylglycerol lipase SDP1L', 82, NULL, NULL, 57468),
(57469, '2.115.10.20-FF-000006', NULL, 'Glycoside hydrolase, putative', 408, NULL, NULL, 57469),
(57470, '3.40.50.12780-FF-000202', NULL, 'Solute carrier family 27 member 2', 332, NULL, NULL, 57470),
(57471, '2.40.50.40-FF-000040', NULL, 'CCL4L2 isoform 1', 41, NULL, NULL, 57471),
(57472, '1.10.10.10-FF-000661', NULL, 'Apoptotic protease-activating factor', 81, NULL, NULL, 57472),
(57473, '1.20.1740.10-FF-000107', NULL, 'Amino acid permease-associated region', 412, NULL, NULL, 57473),
(57474, '3.30.530.20-FF-000046', NULL, 'Conserved protein', 146, NULL, NULL, 57474),
(57475, '3.60.10.10-FF-000087', NULL, 'Ngl1p', 361, NULL, NULL, 57475),
(57476, '1.10.150.380-FF-000005', NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit E', 61, NULL, NULL, 57476),
(57477, '1.10.150.50-FF-000015', NULL, 'ankyrin repeat and sterile alpha motif domain-containing protein 1B', 60, NULL, NULL, 57477),
(57478, '3.40.50.1010-FF-000062', NULL, 'rRNA processing protein, putative', 201, NULL, NULL, 57478),
(57479, '2.30.29.230-FF-000008', NULL, 'Small G protein signaling modulator 2', 188, NULL, NULL, 57479),
(57480, '3.40.50.150-FF-001154', NULL, NULL, 155, NULL, NULL, 57480),
(57481, '2.130.10.10-FF-001154', NULL, 'WD repeat and HMG-box DNA-binding protein 1', 230, NULL, NULL, 57481),
(57482, '3.30.40.10-FF-001528', NULL, 'SLX1 homolog B, structure-specific endonuclease subunit', 69, NULL, NULL, 57482),
(57483, '3.40.1110.10-FF-000076', NULL, 'Phospholipid-transporting ATPase', 18, NULL, NULL, 57483),
(57484, '3.30.70.330-FF-001938', NULL, NULL, 183, NULL, NULL, 57484),
(57485, '1.10.3470.10-FF-000049', NULL, 'Iron compound ABC transporter, permease protein', 74, NULL, NULL, 57485),
(57486, '1.25.40.420-FF-000068', NULL, 'Topoisomerase TOP1-interacting protein BTBD1, putative', 105, NULL, NULL, 57486),
(57487, '2.130.10.10-FF-005897', NULL, 'Uncharacterized protein', 288, NULL, NULL, 57487),
(57488, '1.10.10.60-FF-001143', NULL, NULL, 58, NULL, NULL, 57488),
(57489, '2.60.40.10-FF-001030', NULL, 'Usherin', 87, NULL, NULL, 57489),
(57490, '3.30.420.110-FF-000076', NULL, 'DNA mismatch repair protein MutS', 128, NULL, NULL, 57490),
(57491, '1.10.10.10-FF-000133', NULL, 'Regulatory protein RecX', 62, NULL, NULL, 57491),
(57492, '3.20.20.80-FF-000065', NULL, 'Cytoplasmic alpha-amylase', 263, NULL, NULL, 57492),
(57493, '1.10.420.10-FF-000007', NULL, 'Peroxidase', 144, NULL, NULL, 57493),
(57494, '3.30.9.10-FF-000214', NULL, 'Uncharacterized protein', 114, NULL, NULL, 57494),
(57495, '3.40.50.620-FF-000390', NULL, 'Ethanolamine-phosphate cytidylyltransferase', 178, NULL, NULL, 57495),
(57496, '3.90.1170.10-FF-000034', NULL, 'Uncharacterized protein', 41, NULL, NULL, 57496),
(57497, '1.10.510.10-FF-002167', NULL, 'Serine/threonine-protein kinase/endoribonuclease ire-1', 190, NULL, NULL, 57497),
(57498, '1.25.10.10-FF-000285', NULL, 'RING-type E3 ubiquitin transferase', 133, NULL, NULL, 57498),
(57499, '3.40.50.10190-FF-000100', NULL, 'DNA polymerase II complex', 97, NULL, NULL, 57499),
(57500, '3.30.160.60-FF-000962', NULL, 'zinc finger protein 513 isoform X1', 26, NULL, NULL, 57500),
(57501, '3.40.50.620-FF-000766', NULL, 'Os02g0134000 protein', 118, NULL, NULL, 57501),
(57502, '3.30.70.330-FF-002074', NULL, NULL, 83, NULL, NULL, 57502),
(57503, '3.20.20.140-FF-000194', NULL, 'Amidohydrolase', 250, NULL, NULL, 57503),
(57504, '1.10.238.10-FF-000589', NULL, 'Uncharacterized protein', 70, NULL, NULL, 57504),
(57505, '3.10.330.10-FF-000015', NULL, 'Ubiquitin fusion degradation protein 1, putative', 78, NULL, NULL, 57505),
(57506, '2.60.40.10-FF-005301', NULL, NULL, 81, NULL, NULL, 57506),
(57507, '3.40.50.150-FF-001682', NULL, NULL, 134, NULL, NULL, 57507),
(57508, '3.80.10.10-FF-003211', NULL, 'Leucine-rich repeat (LRR) family protein', 217, NULL, NULL, 57508);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(57509, '3.40.50.2300-FF-000988', NULL, NULL, 82, NULL, NULL, 57509),
(57510, '3.40.50.150-FF-001210', NULL, 'Modification methylase PvuII', 305, NULL, NULL, 57510),
(57511, '3.30.342.10-FF-000016', NULL, 'DNA polymerase', 167, NULL, NULL, 57511),
(57512, '2.30.29.30-FF-000521', NULL, 'Cnk', 102, NULL, NULL, 57512),
(57513, '3.40.50.300-FF-006387', NULL, 'Uncharacterized protein', 135, NULL, NULL, 57513),
(57514, '3.80.10.10-FF-004515', NULL, 'Leucine-rich repeat receptor-like kinase', 80, NULL, NULL, 57514),
(57515, '3.30.980.10-FF-000032', NULL, 'Alanyl-tRNA synthetase-related protein', 158, NULL, NULL, 57515),
(57516, '3.60.40.10-FF-000235', NULL, 'Predicted protein', 291, NULL, NULL, 57516),
(57517, '3.30.160.60-FF-001035', NULL, 'zinc finger protein 697', 28, NULL, NULL, 57517),
(57518, '3.30.420.40-FF-000398', NULL, 'Probable apyrase 6', 134, NULL, NULL, 57518),
(57519, '1.25.40.20-FF-001274', NULL, 'Os09g0328600 protein', 186, NULL, NULL, 57519),
(57520, '3.40.640.10-FF-000173', NULL, 'Possible 8-amino-7-oxononanoate synthase bioF2', 234, NULL, NULL, 57520),
(57521, '3.80.10.10-FF-004195', NULL, 'Uncharacterized protein', 91, NULL, NULL, 57521),
(57522, '1.10.238.10-FF-000117', NULL, 'multiple coagulation factor deficiency protein 2', 78, NULL, NULL, 57522),
(57523, '3.30.160.60-FF-002816', NULL, 'Protein TRANSPARENT TESTA 1', 72, NULL, NULL, 57523),
(57524, '3.60.90.10-FF-000007', NULL, 'S-adenosylmethionine decarboxylase proenzyme isoform X3', 37, NULL, NULL, 57524),
(57525, '2.60.120.200-FF-000613', NULL, 'Predicted protein', 149, NULL, NULL, 57525),
(57526, '3.40.50.1440-FF-000157', NULL, 'Tubulin beta chain', 342, NULL, NULL, 57526),
(57527, '3.30.200.20-FF-001218', NULL, 'Serine/threonine-protein kinase Nek7', 84, NULL, NULL, 57527),
(57528, '1.10.101.10-FF-000014', NULL, 'N-acetylmuramoyl-L-alanine amidase CwlH', 76, NULL, NULL, 57528),
(57529, '1.10.10.60-FF-000682', NULL, 'Predicted protein', 68, NULL, NULL, 57529),
(57530, '2.30.30.40-FF-000123', NULL, 'Ephexin-1 isoform X1', 63, NULL, NULL, 57530),
(57531, '3.40.50.300-FF-008365', NULL, 'Uncharacterized protein', 180, NULL, NULL, 57531),
(57532, '3.60.10.10-FF-000143', NULL, 'PhosphoDiEsterase', 347, NULL, NULL, 57532),
(57533, '3.40.50.1820-FF-001108', NULL, 'Putative alpha/beta hydrolase fold family protein', 217, NULL, NULL, 57533),
(57534, '1.10.1070.11-FF-000126', NULL, 'Uncharacterized protein', 131, NULL, NULL, 57534),
(57535, '3.80.10.10-FF-001266', NULL, 'Leucine-rich repeat containing protein', 136, NULL, NULL, 57535),
(57536, '3.90.70.40-FF-000008', NULL, 'Machado-Joseph disease protein 1 (Ataxin-3), putative', 116, NULL, NULL, 57536),
(57537, '3.20.20.80-FF-000560', NULL, 'Uncharacterized protein', 147, NULL, NULL, 57537),
(57538, '1.10.1200.240-FF-000007', NULL, 'Ribosomal protein L19', 47, NULL, NULL, 57538),
(57539, '1.10.418.10-FF-000215', NULL, 'Protein Hook homolog 3', 165, NULL, NULL, 57539),
(57540, '3.90.76.10-FF-000035', NULL, 'ABC transporter substrate-binding protein', 140, NULL, NULL, 57540),
(57541, '2.20.80.10-FF-000016', NULL, 'Vitellogenin', 204, NULL, NULL, 57541),
(57542, '1.20.1250.20-FF-001989', NULL, 'Membrane protein, major facilitator superfamily', 388, NULL, NULL, 57542),
(57543, '1.25.40.10-FF-000433', NULL, 'mRNA, clone: RTFL01-04-G16', 96, NULL, NULL, 57543),
(57544, '1.10.30.10-FF-000191', NULL, 'HMG', 87, NULL, NULL, 57544),
(57545, '2.120.10.80-FF-000163', NULL, 'F-box domain containing protein', 230, NULL, NULL, 57545),
(57546, '3.20.180.20-FF-000049', NULL, 'Uncharacterized protein', 114, NULL, NULL, 57546),
(57547, '3.30.450.20-FF-000101', NULL, 'Similar, isoform B', 139, NULL, NULL, 57547),
(57548, '3.40.50.720-FF-000594', NULL, 'Short-chain oxidoreductase', 298, NULL, NULL, 57548),
(57549, '3.30.1370.10-FF-000159', NULL, 'Putative eukaryotic LigT', 82, NULL, NULL, 57549),
(57550, '3.10.580.20-FF-000008', NULL, 'Chloride channel protein', 86, NULL, NULL, 57550),
(57551, '1.50.10.10-FF-000160', NULL, 'Glucan 14-alpha-glucosidase Cga', 478, NULL, NULL, 57551),
(57552, '2.60.40.10-FF-001822', NULL, 'EBF transcription factor 2', 67, NULL, NULL, 57552); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(57553, '1.25.40.90-FF-000086', NULL, 'Predicted protein', 132, NULL, NULL, 57553),
(57554, '3.30.530.20-FF-000102', NULL, 'Predicted protein', 212, NULL, NULL, 57554),
(57555, '2.30.29.30-FF-000044', NULL, 'amyloid beta A4 precursor protein-binding family A member 1', 168, NULL, NULL, 57555),
(57556, '1.10.10.10-FF-001914', NULL, 'Uncharacterized protein', 102, NULL, NULL, 57556),
(57557, '1.20.1050.10-FF-000307', NULL, 'Glutathione s-transferase', 25, NULL, NULL, 57557),
(57558, '3.40.50.300-FF-001660', NULL, 'NF-X1 finger and helicase protein, putative', 222, NULL, NULL, 57558),
(57559, '3.50.50.60-FF-001212', NULL, 'Dehydrogenase (Flavoprotein)', 351, NULL, NULL, 57559),
(57560, '3.40.50.1820-FF-001636', NULL, 'Uncharacterized protein', 420, NULL, NULL, 57560),
(57561, '1.25.10.10-FF-001589', NULL, 'Condensin complex subunit 1', 263, NULL, NULL, 57561),
(57562, '2.120.10.90-FF-000020', NULL, 'DNA topoisomerase 4 subunit A', 265, NULL, NULL, 57562),
(57563, '3.30.160.60-FF-005217', NULL, NULL, 32, NULL, NULL, 57563),
(57564, '1.10.472.10-FF-000324', NULL, 'Uncharacterized protein', 129, NULL, NULL, 57564),
(57565, '1.10.1090.10-FF-000003', NULL, 'Ubiquinol-cytochrome c reductase complex subunit, putative', 112, NULL, NULL, 57565),
(57566, '2.40.50.90-FF-000094', NULL, 'GM17876', 104, NULL, NULL, 57566),
(57567, '1.20.5.710-FF-000007', NULL, '50S ribosomal protein L7/L12', 52, NULL, NULL, 57567),
(57568, '1.10.3290.10-FF-000007', NULL, 'Protein adenylyltransferase SoFic', 229, NULL, NULL, 57568),
(57569, '1.25.40.60-FF-000015', NULL, NULL, 122, NULL, NULL, 57569),
(57570, '1.20.58.1060-FF-000003', NULL, 'microtubule-actin cross-linking factor 1 isoform X1', 151, NULL, NULL, 57570),
(57571, '3.90.245.10-FF-000030', NULL, 'Nucleoside hydrolase', 117, NULL, NULL, 57571),
(57572, '3.40.640.10-FF-000526', NULL, 'Uncharacterized protein', 106, NULL, NULL, 57572),
(57573, '1.10.220.10-FF-000026', NULL, 'Annexin', 73, NULL, NULL, 57573),
(57574, '3.40.50.300-FF-000732', NULL, 'Elongation factor like GTPase 1', 234, NULL, NULL, 57574),
(57575, '1.10.10.10-FF-000925', NULL, 'LysR family transcriptional regulator', 88, NULL, NULL, 57575),
(57576, '1.10.510.10-FF-004112', NULL, NULL, 117, NULL, NULL, 57576),
(57577, '1.25.40.540-FF-000014', NULL, 'Uncharacterized protein', 211, NULL, NULL, 57577),
(57578, '3.40.50.300-FF-001221', NULL, 'Axonemal dynein heavy chain 8', 169, NULL, NULL, 57578),
(57579, '1.20.1310.10-FF-000030', NULL, 'Cullin-4', 132, NULL, NULL, 57579),
(57580, '2.60.40.10-FF-000889', NULL, 'fibrocystin isoform X1', 86, NULL, NULL, 57580),
(57581, '3.30.200.20-FF-002207', NULL, 'Uncharacterized protein', 47, NULL, NULL, 57581),
(57582, '3.40.50.720-FF-000650', NULL, 'NADH dehydrogenase 1 alpha subcomplex subunit 9', 294, NULL, NULL, 57582),
(57583, '3.40.50.300-FF-005931', NULL, 'Spermatogenesis-associated protein 5-like protein 1', 184, NULL, NULL, 57583),
(57584, '3.30.450.20-FF-000045', NULL, 'Sensor histidine kinase DcuS', 141, NULL, NULL, 57584),
(57585, '3.40.1260.20-FF-000005', NULL, 'Ribonuclease E/G-like protein chloroplastic', 118, NULL, NULL, 57585),
(57586, '2.30.140.10-FF-000028', NULL, 'Spermine/spermidine synthase-domain-containing protein', 68, NULL, NULL, 57586),
(57587, '3.40.1370.10-FF-000033', NULL, 'Plastid ribosomal protein L4', 214, NULL, NULL, 57587),
(57588, '1.20.1080.10-FF-000135', NULL, 'Integrin beta', 143, NULL, NULL, 57588),
(57589, '1.10.1170.10-FF-000037', NULL, 'Uncharacterized protein', 121, NULL, NULL, 57589),
(57590, '3.40.50.12350-FF-000006', NULL, 'Eyes absent homolog 4', 119, NULL, NULL, 57590),
(57591, '1.20.5.900-FF-000002', NULL, 'CD4', 63, NULL, NULL, 57591),
(57592, '3.30.70.600-FF-000025', NULL, '30S ribosomal protein S10', 105, NULL, NULL, 57592),
(57593, '1.10.630.10-FF-000372', NULL, 'Predicted protein', 434, NULL, NULL, 57593),
(57594, '2.30.22.10-FF-000005', NULL, 'Co-chaperone GrpE', 57, NULL, NULL, 57594),
(57595, '2.30.30.40-FF-000595', NULL, 'Uncharacterized protein', 61, NULL, NULL, 57595),
(57596, '3.40.50.300-FF-005403', NULL, 'Uncharacterized protein', 90, NULL, NULL, 57596);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(57597, '3.30.1340.10-FF-000011', NULL, 'Phosphotransferase system, fructose-specific EI/HPr/EIIA components', 80, NULL, NULL, 57597),
(57598, '3.30.160.60-FF-001474', NULL, 'zinc finger and BTB domain-containing protein 38', 23, NULL, NULL, 57598),
(57599, '3.60.10.10-FF-000407', NULL, 'Inositol polyphosphate phosphatase-like protein', 140, NULL, NULL, 57599),
(57600, '3.10.290.10-FF-000051', NULL, '40S ribosomal protein S4, X isoform', 117, NULL, NULL, 57600),
(57601, '1.25.40.10-FF-003715', NULL, 'Tetratricopeptide repeat protein 21B-like Protein', 235, NULL, NULL, 57601),
(57602, '1.20.58.60-FF-000521', NULL, 'Uncharacterized protein', 294, NULL, NULL, 57602),
(57603, '3.40.50.300-FF-005083', NULL, 'Uncharacterized protein', 72, NULL, NULL, 57603),
(57604, '2.160.20.70-FF-000007', NULL, 'tubulin-specific chaperone C', 170, NULL, NULL, 57604),
(57605, '3.40.462.20-FF-000008', NULL, 'Uncharacterized protein', 221, NULL, NULL, 57605),
(57606, '3.30.160.60-FF-004705', NULL, NULL, 86, NULL, NULL, 57606),
(57607, '1.10.1450.10-FF-000019', NULL, 'Tetraspanin', 97, NULL, NULL, 57607),
(57608, '3.30.930.10-FF-000321', NULL, 'Uncharacterized protein', 200, NULL, NULL, 57608),
(57609, '1.20.1510.10-FF-000011', NULL, 'zinc transporter 2 isoform X1', 213, NULL, NULL, 57609),
(57610, '1.20.1250.20-FF-002006', NULL, 'Folate-like transporter DDB_G0272544', 377, NULL, NULL, 57610),
(57611, '3.30.70.3490-FF-000027', NULL, 'Oxysterol-binding protein homolog C354.07c', 79, NULL, NULL, 57611),
(57612, '2.160.20.50-FF-000001', NULL, 'Uncharacterized protein', 92, NULL, NULL, 57612),
(57613, '1.25.40.20-FF-000762', NULL, 'Zgc:113279', 172, NULL, NULL, 57613),
(57614, '3.40.50.2000-FF-000691', NULL, 'Chitobiosyldiphosphodolichol beta-mannosyltransferase', 185, NULL, NULL, 57614),
(57615, '3.40.50.300-FF-005459', NULL, 'ABC ATPase, putative', 232, NULL, NULL, 57615),
(57616, '3.80.10.10-FF-003683', NULL, 'Predicted protein', 188, NULL, NULL, 57616),
(57617, '2.60.120.10-FF-000054', NULL, 'Global nitrogen regulator NtcA', 124, NULL, NULL, 57617),
(57618, '1.20.1560.10-FF-000161', NULL, 'Uncharacterized protein, isoform C', 344, NULL, NULL, 57618),
(57619, '3.30.2230.10-FF-000003', NULL, 'ubiquitin carboxyl-terminal hydrolase 15 isoform X1', 129, NULL, NULL, 57619),
(57620, '2.160.20.10-FF-000068', NULL, 'Polygalacturonase', 375, NULL, NULL, 57620),
(57621, '2.30.29.30-FF-001033', NULL, 'cAMP-dependent protein kinase catalytic subunit, putative', 96, NULL, NULL, 57621),
(57622, '3.90.245.10-FF-000035', NULL, 'Uncharacterized protein C17G8.02', 321, NULL, NULL, 57622),
(57623, '3.20.20.30-FF-000011', NULL, 'LLM class flavin-dependent oxidoreductase', 342, NULL, NULL, 57623),
(57624, '3.60.15.10-FF-000278', NULL, 'AGAP000597-PA', 160, NULL, NULL, 57624),
(57625, '3.30.40.10-FF-000242', NULL, 'E3 ubiquitin-protein ligase RNF8', 85, NULL, NULL, 57625),
(57626, '3.40.50.150-FF-000754', NULL, 'Malonyl-[acyl-carrier protein] O-methyltransferase', 201, NULL, NULL, 57626),
(57627, '2.60.40.10-FF-005245', NULL, NULL, 88, NULL, NULL, 57627),
(57628, '1.10.1040.50-FF-000017', NULL, NULL, 77, NULL, NULL, 57628),
(57629, '3.30.2070.10-FF-000001', NULL, 'DMSO reductase', 64, NULL, NULL, 57629),
(57630, '1.10.287.70-FF-000243', NULL, 'Voltage-gated potassium channel', 103, NULL, NULL, 57630),
(57631, '2.30.29.30-FF-000049', NULL, 'pleckstrin homology domain-containing family A member 1 isoform X1', 123, NULL, NULL, 57631),
(57632, '2.30.30.100-FF-000163', NULL, 'Small nuclear ribonucleoprotein Sm D2', 96, NULL, NULL, 57632),
(57633, '1.10.600.10-FF-000016', NULL, 'decaprenyl-diphosphate synthase subunit 2', 342, NULL, NULL, 57633),
(57634, '3.40.50.720-FF-002100', NULL, 'Uncharacterized protein', 127, NULL, NULL, 57634),
(57635, '2.130.10.10-FF-003132', NULL, 'SEC31 homolog A, COPII coat complex component', 214, NULL, NULL, 57635),
(57636, '3.20.20.140-FF-000250', NULL, '3'',5''-nucleoside bisphosphate phosphatase', 174, NULL, NULL, 57636),
(57637, '2.70.98.10-FF-000049', NULL, 'Glucose-6-phosphate 1-epimerase', 286, NULL, NULL, 57637);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(57638, '2.130.10.10-FF-001682', NULL, 'U3 small nucleolar RNA-associated protein 13', 275, NULL, NULL, 57638),
(57639, '3.40.140.10-FF-000056', NULL, 'tRNA-specific adenosine deaminase TAD3 isoform A', 143, NULL, NULL, 57639),
(57640, '3.40.50.300-FF-001188', NULL, 'DNA mismatch repair protein', 264, NULL, NULL, 57640),
(57641, '3.40.50.1240-FF-000069', NULL, 'Possible phosphoglycerate mutase gpm2', 203, NULL, NULL, 57641),
(57642, '2.40.10.350-FF-000012', NULL, 'Cell shape-determining protein MreC', 82, NULL, NULL, 57642),
(57643, '1.20.1250.20-FF-001606', NULL, 'MFS allantoate transporter, putative (AFU_orthologue AFUA_6G03720)', 208, NULL, NULL, 57643),
(57644, '3.40.50.280-FF-000001', NULL, 'Methionine synthase', 152, NULL, NULL, 57644),
(57645, '2.90.10.30-FF-000009', NULL, 'Uncharacterized protein', 191, NULL, NULL, 57645),
(57646, '2.60.40.2150-FF-000006', NULL, 'Uncharacterized protein', 42, NULL, NULL, 57646),
(57647, '3.30.300.30-FF-000066', NULL, 'Non-ribosomal peptide synthetase', 99, NULL, NULL, 57647),
(57648, '1.20.58.1080-FF-000009', NULL, 'Uncharacterized protein', 116, NULL, NULL, 57648),
(57649, '2.60.40.150-FF-000566', NULL, 'Uncharacterized protein', 134, NULL, NULL, 57649),
(57650, '2.130.10.10-FF-001507', NULL, 'Vacuolar protein sorting-associated protein 41 homolog', 248, NULL, NULL, 57650),
(57651, '1.10.340.30-FF-000075', NULL, 'Predicted protein', 131, NULL, NULL, 57651),
(57652, '3.90.79.10-FF-000188', NULL, 'Isopentenyl-diphosphate Delta-isomerase', 181, NULL, NULL, 57652),
(57653, '2.30.42.10-FF-000063', NULL, 'Peptidase, S41 family', 88, NULL, NULL, 57653),
(57654, '3.90.660.20-FF-000008', NULL, 'Protoporphyrinogen oxidase', 214, NULL, NULL, 57654),
(57655, '3.30.200.20-FF-002146', NULL, 'Uncharacterized protein', 69, NULL, NULL, 57655),
(57656, '3.30.1330.80-FF-000014', NULL, 'AT-hook motif nuclear-localized protein', 113, NULL, NULL, 57656),
(57657, '2.60.40.60-FF-000595', NULL, 'Protocadherin fat, putative', 61, NULL, NULL, 57657),
(57658, '1.10.10.570-FF-000004', NULL, 'Unplaced genomic scaffold supercont1.6, whole genome shotgun sequence', 105, NULL, NULL, 57658),
(57659, '3.40.190.290-FF-000051', NULL, 'LysR family transcriptional regulator', 209, NULL, NULL, 57659),
(57660, '3.30.870.10-FF-000203', NULL, 'Predicted protein', 129, NULL, NULL, 57660),
(57661, '3.30.450.20-FF-000540', NULL, 'Sensory transduction histidine kinase', 127, NULL, NULL, 57661),
(57662, '1.20.1280.290-FF-000063', NULL, 'Uncharacterized protein', 94, NULL, NULL, 57662),
(57663, '3.40.50.10140-FF-000023', NULL, 'Sterile alpha and TIR motif-containing protein tir-1', 135, NULL, NULL, 57663),
(57664, '3.40.50.10190-FF-000044', NULL, 'DNA ligase', 103, NULL, NULL, 57664),
(57665, '3.30.760.10-FF-000021', NULL, 'Eukaryotic translation initiation factor 4E-3', 186, NULL, NULL, 57665),
(57666, '3.20.20.80-FF-000121', NULL, 'Beta-galactosidase', 279, NULL, NULL, 57666),
(57667, '1.20.1250.20-FF-000680', NULL, 'Sugar efflux transporter', 192, NULL, NULL, 57667),
(57668, '3.50.7.10-FF-000019', NULL, 'McKusick-Kaufman syndrome', 156, NULL, NULL, 57668),
(57669, '3.40.50.1220-FF-000063', NULL, '2-oxoglutarate decarboxylase/hydro-lyase/magnesium ion-binding protein', 175, NULL, NULL, 57669),
(57670, '3.40.50.360-FF-000143', NULL, 'Uncharacterized protein MG342', 168, NULL, NULL, 57670),
(57671, '1.25.40.10-FF-002850', NULL, 'Putative pentatricopeptide repeat-containing protein', 112, NULL, NULL, 57671),
(57672, '1.25.40.840-FF-000014', NULL, 'Uncharacterized protein', 157, NULL, NULL, 57672),
(57673, '2.40.240.130-FF-000011', NULL, 'Predicted protein', 68, NULL, NULL, 57673),
(57674, '2.130.10.10-FF-000698', NULL, 'Putative pre-mRNA splicing factor', 214, NULL, NULL, 57674),
(57675, '2.60.40.60-FF-001084', NULL, 'Cadherin-related tumor suppressor-like Protein', 108, NULL, NULL, 57675),
(57676, '3.40.1110.10-FF-000020', NULL, 'Phospholipid-transporting ATPase', 109, NULL, NULL, 57676),
(57677, '3.40.50.300-FF-003514', NULL, 'Uncharacterized protein', 296, NULL, NULL, 57677),
(57678, '3.30.70.260-FF-000108', NULL, 'Aspartokinase', 65, NULL, NULL, 57678);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(57679, '1.20.5.170-FF-000098', NULL, 'Basic leucine zipper 24', 79, NULL, NULL, 57679),
(57680, '3.40.190.10-FF-000391', NULL, 'Chromosome 1, whole genome shotgun sequence', 112, NULL, NULL, 57680),
(57681, '3.40.630.10-FF-000228', NULL, 'Peptide hydrolase', 283, NULL, NULL, 57681),
(57682, '2.60.200.10-FF-000055', NULL, 'Predicted protein', 121, NULL, NULL, 57682),
(57683, '1.20.1070.10-FF-001275', NULL, 'cDNA FLJ51399, highly similar to Cadherin EGF LAG seven-pass G-type receptor 1', 134, NULL, NULL, 57683),
(57684, '3.30.50.10-FF-000012', NULL, 'Hepatocyte nuclear factor 4, alpha', 92, NULL, NULL, 57684),
(57685, '3.40.50.300-FF-003458', NULL, 'DNA mismatch repair protein', 271, NULL, NULL, 57685),
(57686, '1.25.40.10-FF-005340', NULL, 'Pentatricopeptide repeat-containing protein At1g12300, mitochondrial', 69, NULL, NULL, 57686),
(57687, '2.10.25.10-FF-001452', NULL, 'Uncharacterized protein', 42, NULL, NULL, 57687),
(57688, '2.40.50.140-FF-000935', NULL, NULL, 88, NULL, NULL, 57688),
(57689, '1.25.40.10-FF-005284', NULL, 'Uncharacterized protein', 142, NULL, NULL, 57689),
(57690, '2.40.70.10-FF-000088', NULL, 'Eukaryotic aspartyl protease family protein', 199, NULL, NULL, 57690),
(57691, '3.40.50.11500-FF-000021', NULL, 'DENN domain containing protein 2D', 133, NULL, NULL, 57691),
(57692, '3.30.160.60-FF-000170', NULL, 'Zinc finger protein 711 isoform X2', 25, NULL, NULL, 57692),
(57693, '2.40.50.140-FF-001008', NULL, NULL, 78, NULL, NULL, 57693),
(57694, '3.20.20.60-FF-000082', NULL, 'GD14986', 108, NULL, NULL, 57694),
(57695, '2.60.120.320-FF-000008', NULL, 'Thiamine pyrophosphokinase', 91, NULL, NULL, 57695),
(57696, '3.10.20.90-FF-000916', NULL, 'Putative ubiquitin thioesterase otu1', 81, NULL, NULL, 57696),
(57697, '3.30.457.50-FF-000002', NULL, 'Unplaced genomic scaffold supercont2.13, whole genome shotgun sequence', 98, NULL, NULL, 57697),
(57698, '3.30.300.30-FF-000122', NULL, 'Uncharacterized protein', 132, NULL, NULL, 57698),
(57699, '4.10.280.10-FF-000035', NULL, 'Pancreas-specific transcription factor 1a', 63, NULL, NULL, 57699),
(57700, '1.10.510.10-FF-000689', NULL, 'Tyrosine kinase', 186, NULL, NULL, 57700),
(57701, '3.40.50.1000-FF-000525', NULL, NULL, 108, NULL, NULL, 57701),
(57702, '2.60.40.1120-FF-000063', NULL, 'Chitinase, GH18 family', 96, NULL, NULL, 57702),
(57703, '1.25.40.10-FF-005104', NULL, 'DnaJ domain containing protein', 120, NULL, NULL, 57703),
(57704, '3.40.30.10-FF-001269', NULL, 'Uncharacterized protein', 70, NULL, NULL, 57704),
(57705, '2.60.40.150-FF-000510', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 134, NULL, NULL, 57705),
(57706, '2.60.40.60-FF-000651', NULL, 'Uncharacterized protein', 118, NULL, NULL, 57706),
(57707, '3.40.50.300-FF-003166', NULL, 'Sulfate adenylyltransferase, putative', 187, NULL, NULL, 57707),
(57708, '3.30.200.20-FF-000881', NULL, 'Serine/threonine-protein kinase', 109, NULL, NULL, 57708),
(57709, '3.30.160.60-FF-003688', NULL, NULL, 30, NULL, NULL, 57709),
(57710, '1.10.150.80-FF-000035', NULL, 'ATP-dependent DNA helicase RecQ', 78, NULL, NULL, 57710),
(57711, '2.60.20.10-FF-000011', NULL, 'very large A-kinase anchor protein', 83, NULL, NULL, 57711),
(57712, '1.25.10.10-FF-000280', NULL, 'serine/threonine-protein kinase 36 isoform X1', 80, NULL, NULL, 57712),
(57713, '3.10.129.10-FF-000289', NULL, 'Uncharacterized protein', 87, NULL, NULL, 57713),
(57714, '2.20.25.30-FF-000013', NULL, 'Uncharacterized protein', 83, NULL, NULL, 57714),
(57715, '3.90.650.10-FF-000033', NULL, 'Trifunctional purine biosynthetic protein adenosine-3', 192, NULL, NULL, 57715),
(57716, '2.130.10.10-FF-003508', NULL, 'E3 ubiquitin-protein ligase PEP5', 234, NULL, NULL, 57716),
(57717, '3.30.70.330-FF-002338', NULL, NULL, 166, NULL, NULL, 57717),
(57718, '1.10.510.10-FF-000745', NULL, 'Serine/threonine-protein kinase BUD32', 127, NULL, NULL, 57718),
(57719, '1.10.3720.10-FF-000030', NULL, 'Maltose ABC transporter permease MalF', 245, NULL, NULL, 57719),
(57720, '3.40.50.1980-FF-000094', NULL, 'Histidine biosynthesis trifunctional protein', 121, NULL, NULL, 57720);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(57721, '3.30.1490.80-FF-000031', NULL, 'Glutathione synthetase', 34, NULL, NULL, 57721),
(57722, '1.10.220.160-FF-000012', NULL, 'SET domain containing protein, putative', 84, NULL, NULL, 57722),
(57723, '2.60.120.1000-FF-000010', NULL, 'Uncharacterized protein, isoform B', 210, NULL, NULL, 57723),
(57724, '3.40.50.300-FF-003661', NULL, 'Uncharacterized protein, isoform B', 268, NULL, NULL, 57724),
(57725, '3.50.50.60-FF-000279', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 125, NULL, NULL, 57725),
(57726, '1.10.510.10-FF-003095', NULL, NULL, 198, NULL, NULL, 57726),
(57727, '3.30.200.20-FF-000729', NULL, 'Serine/threonine-protein kinase Nek4', 55, NULL, NULL, 57727),
(57728, '3.90.226.10-FF-000143', NULL, 'Acetyl-CoA carboxylase/pyruvate carboxylase fusion protein, putative', 218, NULL, NULL, 57728),
(57729, '2.10.230.10-FF-000017', NULL, 'DnaJ heat shock protein family (Hsp40) member A3', 34, NULL, NULL, 57729),
(57730, '3.90.228.20-FF-000010', NULL, 'Phosphoenolypyruvate CarboxyKinase', 235, NULL, NULL, 57730),
(57731, '3.40.350.10-FF-000010', NULL, 'Probable Xaa-Pro aminopeptidase P', 160, NULL, NULL, 57731),
(57732, '3.30.160.60-FF-000546', NULL, 'Zinc finger protein 333', 27, NULL, NULL, 57732),
(57733, '3.30.70.330-FF-002490', NULL, NULL, 76, NULL, NULL, 57733),
(57734, '3.40.50.2000-FF-000252', NULL, 'Trehalose-6-phosphate synthase', 223, NULL, NULL, 57734),
(57735, '1.10.860.10-FF-000029', NULL, 'DNA primase', 134, NULL, NULL, 57735),
(57736, '2.60.120.590-FF-000044', NULL, 'Predicted protein', 235, NULL, NULL, 57736),
(57737, '3.90.110.10-FF-000003', NULL, 'L-lactate dehydrogenase A chain', 168, NULL, NULL, 57737),
(57738, '3.40.50.150-FF-000226', NULL, 'probable methyltransferase-like protein 15 isoform X3', 108, NULL, NULL, 57738),
(57739, '2.70.130.10-FF-000030', NULL, 'Endoplasmic reticulum lectin 1', 127, NULL, NULL, 57739),
(57740, '1.10.555.10-FF-000039', NULL, 'N-chimaerin isoform X5', 191, NULL, NULL, 57740),
(57741, '1.10.472.10-FF-000296', NULL, 'Uncharacterized protein', 87, NULL, NULL, 57741),
(57742, '3.40.50.2300-FF-000191', NULL, 'D-allose-binding periplasmic protein (ALBP)', 117, NULL, NULL, 57742),
(57743, '3.30.740.10-FF-000019', NULL, NULL, 101, NULL, NULL, 57743),
(57744, '3.40.50.300-FF-007876', NULL, 'Uncharacterized protein', 203, NULL, NULL, 57744),
(57745, '2.70.70.10-FF-000076', NULL, 'Uncharacterized protein', 140, NULL, NULL, 57745),
(57746, '1.10.555.10-FF-000011', NULL, 'Rho GTPase-activating protein 39', 196, NULL, NULL, 57746),
(57747, '3.90.1410.10-FF-000065', NULL, 'N-lysine methyltransferase', 200, NULL, NULL, 57747),
(57748, '1.25.40.20-FF-001690', NULL, 'AGAP003151-PA', 73, NULL, NULL, 57748),
(57749, '3.30.40.10-FF-002164', NULL, 'Structure-specific endonuclease subunit SLX1 homolog', 84, NULL, NULL, 57749),
(57750, '3.10.20.340-FF-000008', NULL, 'Arginine biosynthesis bifunctional protein ArgJ 2, mitochondrial', 149, NULL, NULL, 57750),
(57751, '3.40.50.720-FF-000914', NULL, 'Pyrroline-5-carboxylate reductase', 177, NULL, NULL, 57751),
(57752, '3.40.190.10-FF-000328', NULL, 'Glycerol-3-phosphate ABC transporter glycerol-3-phosphate-binding protein', 199, NULL, NULL, 57752),
(57753, '3.40.50.150-FF-000198', NULL, 'Uncharacterized protein', 259, NULL, NULL, 57753),
(57754, '3.30.200.20-FF-000206', NULL, 'Serine/threonine-protein kinase Ssp1', 102, NULL, NULL, 57754),
(57755, '1.10.238.20-FF-000002', NULL, 'AGAP000641-PA', 124, NULL, NULL, 57755),
(57756, '3.50.50.60-FF-000251', NULL, 'Ferrodoxin reductase-like protein', 134, NULL, NULL, 57756),
(57757, '3.40.190.170-FF-000009', NULL, 'TRAP transporter substrate-binding protein DctP', 313, NULL, NULL, 57757),
(57758, '2.60.120.920-FF-000008', NULL, 'Set1/Ash2 histone methyltransferase complex subunit ASH2', 184, NULL, NULL, 57758),
(57759, '3.90.1280.20-FF-000012', NULL, NULL, 91, NULL, NULL, 57759),
(57760, '2.60.40.10-FF-005240', NULL, NULL, 89, NULL, NULL, 57760),
(57761, '3.40.1110.10-FF-000104', NULL, 'Calcium-transporting ATPase', 223, NULL, NULL, 57761),
(57762, '3.30.160.40-FF-000012', NULL, 'Porphobilinogen deaminase', 85, NULL, NULL, 57762);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(57763, '1.20.1730.10-FF-000045', NULL, 'Solute carrier family 5 (sodium/sugar cotransporter), member 9', 490, NULL, NULL, 57763),
(57764, '3.30.450.40-FF-000107', NULL, 'Sensor histidine kinase KdpD', 153, NULL, NULL, 57764),
(57765, '1.10.3470.10-FF-000044', NULL, 'ABC-type cobalamin uptake system permease component BtuC', 362, NULL, NULL, 57765),
(57766, '1.25.40.10-FF-001922', NULL, 'Os01g0815900 protein', 147, NULL, NULL, 57766),
(57767, '1.10.1670.10-FF-000025', NULL, 'Ogg1p', 78, NULL, NULL, 57767),
(57768, '1.20.1070.10-FF-001359', NULL, 'Uncharacterized protein', 264, NULL, NULL, 57768),
(57769, '2.60.120.200-FF-000118', NULL, 'Growth arrest specific 6', 209, NULL, NULL, 57769),
(57770, '2.120.10.80-FF-000427', NULL, 'Uncharacterized protein', 164, NULL, NULL, 57770),
(57771, '3.30.60.220-FF-000004', NULL, NULL, 33, NULL, NULL, 57771),
(57772, '1.20.140.10-FF-000124', NULL, 'Uncharacterized protein', 104, NULL, NULL, 57772),
(57773, '1.25.10.10-FF-000841', NULL, 'Maestro heat like repeat family member 2B', 340, NULL, NULL, 57773),
(57774, '1.20.5.1300-FF-000002', NULL, 'Histidinol dehydrogenase, chloroplastic', 44, NULL, NULL, 57774),
(57775, '3.30.360.10-FF-000092', NULL, 'Uncharacterized protein', 159, NULL, NULL, 57775),
(57776, '2.130.10.10-FF-000693', NULL, 'Sortilin', 201, NULL, NULL, 57776),
(57777, '2.60.120.230-FF-000009', NULL, NULL, 104, NULL, NULL, 57777),
(57778, '2.40.160.120-FF-000017', NULL, 'Oxysterol-binding protein homolog C2F12.05c', 194, NULL, NULL, 57778),
(57779, '4.10.60.10-FF-000129', NULL, 'Phragmoplastin interacting protein 1', 45, NULL, NULL, 57779),
(57780, '3.40.50.11610-FF-000026', NULL, NULL, 133, NULL, NULL, 57780),
(57781, '1.20.1070.10-FF-002107', NULL, 'Uncharacterized protein', 138, NULL, NULL, 57781),
(57782, '3.30.1120.10-FF-000028', NULL, 'Choline-sulfatase', 74, NULL, NULL, 57782),
(57783, '2.60.40.1730-FF-000004', NULL, 'Leukotriene A(4) hydrolase', 192, NULL, NULL, 57783),
(57784, '2.10.25.10-FF-000440', NULL, 'Laminin subunit beta 3', 52, NULL, NULL, 57784),
(57785, '3.40.30.10-FF-001241', NULL, 'Protein disulfide-isomerase', 84, NULL, NULL, 57785),
(57786, '3.90.1480.20-FF-000049', NULL, 'Uncharacterized protein', 177, NULL, NULL, 57786),
(57787, '3.30.1360.210-FF-000005', NULL, '60S ribosomal protein L22', 122, NULL, NULL, 57787),
(57788, '2.60.120.200-FF-000793', NULL, 'Galectin', 64, NULL, NULL, 57788),
(57789, '3.40.430.10-FF-000011', NULL, 'Rib7p', 229, NULL, NULL, 57789),
(57790, '3.30.160.60-FF-005633', NULL, NULL, 29, NULL, NULL, 57790),
(57791, '3.30.559.10-FF-000148', NULL, 'Uncharacterized protein', 154, NULL, NULL, 57791),
(57792, '3.30.700.10-FF-000017', NULL, 'MSHA minor pilin protein MshC', 143, NULL, NULL, 57792),
(57793, '3.30.40.10-FF-000186', NULL, 'RBR-type E3 ubiquitin transferase', 89, NULL, NULL, 57793),
(57794, '1.20.1250.20-FF-000117', NULL, 'MFS hexose transporter', 463, NULL, NULL, 57794),
(57795, '3.80.10.10-FF-003267', NULL, 'Uncharacterized protein', 142, NULL, NULL, 57795),
(57796, '3.40.50.10110-FF-000003', NULL, 'DNA polymerase III holoenzyme chi subunit', 140, NULL, NULL, 57796),
(57797, '1.10.287.770-FF-000020', NULL, 'Blast:Pickpocket protein 11', 59, NULL, NULL, 57797),
(57798, '1.10.532.10-FF-000003', NULL, 'Signal transducer and activator of transcription', 130, NULL, NULL, 57798),
(57799, '1.25.40.20-FF-000346', NULL, 'Palmitoyltransferase', 220, NULL, NULL, 57799),
(57800, '2.40.40.20-FF-000033', NULL, 'DNA-directed RNA polymerase subunit', 121, NULL, NULL, 57800),
(57801, '3.30.2160.10-FF-000059', NULL, 'Predicted protein', 65, NULL, NULL, 57801),
(57802, '1.10.510.10-FF-004404', NULL, NULL, 84, NULL, NULL, 57802),
(57803, '2.60.40.10-FF-002367', NULL, 'papilin isoform X1', 90, NULL, NULL, 57803),
(57804, '1.10.520.10-FF-000010', NULL, 'Peroxidase', 154, NULL, NULL, 57804),
(57805, '1.20.58.390-FF-000017', NULL, 'Neuronal acetylcholine receptor subunit alpha-3', 83, NULL, NULL, 57805),
(57806, '3.30.750.24-FF-000146', NULL, 'Chloride anion exchanger', 175, NULL, NULL, 57806),
(57807, '3.30.2410.10-FF-000045', NULL, 'Predicted protein', 82, NULL, NULL, 57807);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(57808, '1.10.287.810-FF-000021', NULL, NULL, 58, NULL, NULL, 57808),
(57809, '2.60.40.10-FF-001878', NULL, 'Immunoglobulin heavy variable 1-4', 119, NULL, NULL, 57809),
(57810, '1.25.10.10-FF-000605', NULL, 'Armadillo repeat containing 4', 92, NULL, NULL, 57810),
(57811, '1.20.140.140-FF-000002', NULL, 'Uncharacterized protein, isoform B', 214, NULL, NULL, 57811),
(57812, '3.10.129.10-FF-000261', NULL, 'Uncharacterized protein', 81, NULL, NULL, 57812),
(57813, '1.10.40.30-FF-000023', NULL, 'Argininosuccinate lyase', 76, NULL, NULL, 57813),
(57814, '2.60.40.60-FF-001140', NULL, 'Uncharacterized protein', 115, NULL, NULL, 57814),
(57815, '1.20.1600.10-FF-000069', NULL, 'Uncharacterized protein', 361, NULL, NULL, 57815),
(57816, '3.40.50.720-FF-000122', NULL, 'Dehydrogenase/reductase SDR family member 7B', 285, NULL, NULL, 57816),
(57817, '2.40.30.10-FF-000439', NULL, 'Uncharacterized protein', 135, NULL, NULL, 57817),
(57818, '3.70.10.10-FF-000002', NULL, 'Beta sliding clamp', 187, NULL, NULL, 57818),
(57819, '1.10.287.110-FF-000137', NULL, 'DnaJ homolog subfamily B member 1', 120, NULL, NULL, 57819),
(57820, '2.130.10.10-FF-004060', NULL, 'Uncharacterized protein', 210, NULL, NULL, 57820),
(57821, '3.30.428.10-FF-000064', NULL, 'Wpkci', 115, NULL, NULL, 57821),
(57822, '1.10.510.10-FF-000661', NULL, 'Receptor-interacting serine/threonine-protein kinase 3', 314, NULL, NULL, 57822),
(57823, '2.30.30.140-FF-000040', NULL, 'PHD finger protein 1 isoform X1', 79, NULL, NULL, 57823),
(57824, '3.30.40.10-FF-002220', NULL, 'Uncharacterized protein', 69, NULL, NULL, 57824),
(57825, '1.10.10.10-FF-000189', NULL, 'HTH-type transcriptional regulator MntR', 68, NULL, NULL, 57825),
(57826, '3.30.70.270-FF-000122', NULL, 'Uncharacterized protein', 97, NULL, NULL, 57826),
(57827, '1.20.1250.20-FF-000264', NULL, 'vesicular glutamate transporter 1', 197, NULL, NULL, 57827),
(57828, '2.130.10.10-FF-001710', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', 311, NULL, NULL, 57828),
(57829, '2.130.10.10-FF-003424', NULL, 'Intraflagellar transport protein 140-like protein', 176, NULL, NULL, 57829),
(57830, '3.40.50.300-FF-000108', NULL, 'ATP-dependent RNA helicase RhlE', 205, NULL, NULL, 57830),
(57831, '1.10.238.10-FF-001045', NULL, 'Calmodulin, putative', 42, NULL, NULL, 57831),
(57832, '1.10.510.10-FF-004399', NULL, NULL, 86, NULL, NULL, 57832),
(57833, '3.10.129.10-FF-000109', NULL, 'Acyl dehydratase', 160, NULL, NULL, 57833),
(57834, '1.25.40.10-FF-000809', NULL, 'Os12g0289800 protein', 66, NULL, NULL, 57834),
(57835, '2.40.110.10-FF-000035', NULL, 'Putative acyl-CoA dehydrogenase', 99, NULL, NULL, 57835),
(57836, '3.30.200.20-FF-000353', NULL, 'Sterile20-like kinase, isoform B', 97, NULL, NULL, 57836),
(57837, '3.40.1380.20-FF-000008', NULL, 'Pyruvate kinase', 119, NULL, NULL, 57837),
(57838, '1.25.40.10-FF-001361', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 103, NULL, NULL, 57838),
(57839, '1.10.238.10-FF-000645', NULL, 'Respiratory burst oxidase-like protein F isoform A', 122, NULL, NULL, 57839),
(57840, '3.40.50.300-FF-005111', NULL, 'Elongator complex protein 6', 257, NULL, NULL, 57840),
(57841, '1.25.40.10-FF-003687', NULL, 'Uncharacterized protein', 123, NULL, NULL, 57841),
(57842, '3.90.1030.10-FF-000024', NULL, 'Uncharacterized protein', 117, NULL, NULL, 57842),
(57843, '1.25.40.10-FF-000961', NULL, 'Protein TONSOKU', 156, NULL, NULL, 57843),
(57844, '3.30.70.330-FF-002866', NULL, NULL, 77, NULL, NULL, 57844),
(57845, '3.30.70.240-FF-000046', NULL, 'Translation factor GUF1 homolog, mitochondrial', 66, NULL, NULL, 57845),
(57846, '3.40.50.10710-FF-000003', NULL, 'Ribonuclease J', 151, NULL, NULL, 57846),
(57847, '1.10.150.530-FF-000011', NULL, 'Probable dual-specificity RNA methyltransferase RlmN', 60, NULL, NULL, 57847),
(57848, '1.10.10.10-FF-000897', NULL, 'Transcriptional regulator, BadM/Rrf2 family', 132, NULL, NULL, 57848),
(57849, '3.10.20.90-FF-000883', NULL, 'Uncharacterized protein', 58, NULL, NULL, 57849),
(57850, '1.10.3170.10-FF-000004', NULL, 'RecBCD enzyme subunit RecB', 191, NULL, NULL, 57850);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(57851, '2.60.40.10-FF-003328', NULL, NULL, 102, NULL, NULL, 57851),
(57852, '3.90.70.10-FF-000645', NULL, 'Uncharacterized protein', 97, NULL, NULL, 57852),
(57853, '3.30.40.10-FF-000039', NULL, 'PHD finger protein 13', 52, NULL, NULL, 57853),
(57854, '1.10.20.10-FF-000246', NULL, NULL, 92, NULL, NULL, 57854),
(57855, '3.30.1520.10-FF-000053', NULL, 'Uncharacterized protein', 113, NULL, NULL, 57855),
(57856, '2.60.40.10-FF-003300', NULL, 'DLEC1, cilia and flagella associated protein', 104, NULL, NULL, 57856),
(57857, '1.10.150.120-FF-000006', NULL, 'Aldehyde oxidase', 132, NULL, NULL, 57857),
(57858, '1.25.10.10-FF-001241', NULL, 'Uncharacterized protein', 221, NULL, NULL, 57858),
(57859, '3.90.550.50-FF-000222', NULL, 'Uncharacterized protein', 132, NULL, NULL, 57859),
(57860, '3.40.50.620-FF-000238', NULL, 'Phosphopantetheine adenylyltransferase', 151, NULL, NULL, 57860),
(57861, '2.30.30.40-FF-000651', NULL, 'Tyrosine-protein kinase PR2-like Protein', 72, NULL, NULL, 57861),
(57862, '1.20.5.170-FF-000154', NULL, 'Cgmp-dependent protein kinase', 65, NULL, NULL, 57862),
(57863, '2.60.34.10-FF-000037', NULL, 'Uncharacterized protein', 118, NULL, NULL, 57863),
(57864, '1.10.3120.10-FF-000001', NULL, 'Trigger factor', 205, NULL, NULL, 57864),
(57865, '3.30.160.60-FF-000815', NULL, 'zinc finger protein 621', 29, NULL, NULL, 57865),
(57866, '2.130.10.10-FF-004621', NULL, 'Uncharacterized protein', 199, NULL, NULL, 57866),
(57867, '2.130.10.10-FF-004436', NULL, 'Met proto-oncogene', 356, NULL, NULL, 57867),
(57868, '1.10.3090.10-FF-000003', NULL, 'Poly(A) polymerase I', 252, NULL, NULL, 57868),
(57869, '3.40.50.300-FF-004386', NULL, 'IcmB', 203, NULL, NULL, 57869),
(57870, '2.130.10.10-FF-005133', NULL, 'Uncharacterized protein', 157, NULL, NULL, 57870),
(57871, '2.60.40.10-FF-004604', NULL, NULL, 96, NULL, NULL, 57871),
(57872, '3.80.10.10-FF-003498', NULL, 'AGAP006408-PA', 191, NULL, NULL, 57872),
(57873, '3.40.50.2000-FF-000724', NULL, 'Similar to UDP-N-acetylglucosamine 2-epimerase', 141, NULL, NULL, 57873),
(57874, '3.60.10.10-FF-000290', NULL, 'Predicted protein', 275, NULL, NULL, 57874),
(57875, '3.40.50.1110-FF-000030', NULL, 'Transmembrane acyltransferase', 222, NULL, NULL, 57875),
(57876, '3.90.180.10-FF-000036', NULL, 'Zinc-dependent alcohol dehydrogenase', 208, NULL, NULL, 57876),
(57877, '1.25.40.10-FF-004356', NULL, 'TPR Domain containing protein', 157, NULL, NULL, 57877),
(57878, '2.60.40.10-FF-004548', NULL, NULL, 77, NULL, NULL, 57878),
(57879, '1.20.1250.20-FF-000909', NULL, 'Uncharacterized protein', 287, NULL, NULL, 57879),
(57880, '2.120.10.30-FF-000553', NULL, 'Uncharacterized protein', 84, NULL, NULL, 57880),
(57881, '1.25.40.10-FF-004412', NULL, 'Uncharacterized protein', 132, NULL, NULL, 57881),
(57882, '1.10.510.10-FF-002370', NULL, NULL, 172, NULL, NULL, 57882),
(57883, '1.10.630.10-FF-000400', NULL, 'Uncharacterized protein', 52, NULL, NULL, 57883),
(57884, '2.40.50.140-FF-000463', NULL, 'DNA repair protein RecO', 74, NULL, NULL, 57884),
(57885, '3.90.550.10-FF-000469', NULL, 'N-acetylglucosaminyltransferase related protein (NodC-like)', 220, NULL, NULL, 57885),
(57886, '1.10.357.10-FF-000045', NULL, 'TetR family transcriptional regulator', 210, NULL, NULL, 57886),
(57887, '1.10.10.10-FF-002078', NULL, 'Predicted protein', 31, NULL, NULL, 57887),
(57888, '3.30.60.90-FF-000019', NULL, 'Protein KRI1, putative', 54, NULL, NULL, 57888),
(57889, '2.40.50.700-FF-000002', NULL, 'Cell wall biogenesis protein', 81, NULL, NULL, 57889),
(57890, '1.20.120.1750-FF-000100', NULL, 'RBR-type E3 ubiquitin transferase', 169, NULL, NULL, 57890),
(57891, '3.40.50.1820-FF-000147', NULL, 'uncharacterized protein LOC108093882 isoform X9', 189, NULL, NULL, 57891),
(57892, '3.30.710.10-FF-000490', NULL, 'Protein CBG09885', 66, NULL, NULL, 57892),
(57893, '3.40.630.40-FF-000012', NULL, 'N-acetylmuramoyl-L-alanine amidase', 172, NULL, NULL, 57893),
(57894, '1.50.10.10-FF-000013', NULL, 'Non-lysosomal glucosylceramidase', 314, NULL, NULL, 57894),
(57895, '3.90.550.10-FF-000525', NULL, 'Glycoside transferase family 2', 248, NULL, NULL, 57895);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(57896, '1.50.10.160-FF-000002', NULL, 'cis-abienol synthase, chloroplastic', 204, NULL, NULL, 57896),
(57897, '3.90.930.12-FF-000034', NULL, NULL, 97, NULL, NULL, 57897),
(57898, '1.25.10.10-FF-003242', NULL, 'Formin-J', 237, NULL, NULL, 57898),
(57899, '1.25.40.20-FF-001127', NULL, 'Kinase, NEK-frag', 184, NULL, NULL, 57899),
(57900, '3.60.10.10-FF-000379', NULL, 'Angel homolog 1 (Drosophila)', 85, NULL, NULL, 57900),
(57901, '3.30.70.330-FF-000073', NULL, 'Heterogeneous nuclear ribonucleoprotein L like', 100, NULL, NULL, 57901),
(57902, '1.25.40.10-FF-000141', NULL, 'Mitochondrial import receptor subunit TOM70', 114, NULL, NULL, 57902),
(57903, '4.10.860.10-FF-000006', NULL, 'calcyclin-binding protein-like', 48, NULL, NULL, 57903),
(57904, '2.60.40.10-FF-000861', NULL, 'interleukin-13 receptor subunit alpha-1 isoform X1', 104, NULL, NULL, 57904),
(57905, '3.90.70.10-FF-000084', NULL, 'inactive ubiquitin carboxyl-terminal hydrolase 50', 326, NULL, NULL, 57905),
(57906, '3.40.50.300-FF-008129', NULL, 'Uncharacterized protein', 105, NULL, NULL, 57906),
(57907, '3.30.460.10-FF-000161', NULL, 'Uncharacterized protein', 155, NULL, NULL, 57907),
(57908, '3.30.1370.50-FF-000036', NULL, 'Uncharacterized protein', 65, NULL, NULL, 57908),
(57909, '1.20.1560.10-FF-000722', NULL, 'Putative ABC transporter ATP-binding protein MG014', 345, NULL, NULL, 57909),
(57910, '1.10.3680.10-FF-000003', NULL, 'Tellurium resistance protein TerB', 149, NULL, NULL, 57910),
(57911, '2.130.10.10-FF-005077', NULL, 'Uncharacterized protein', 266, NULL, NULL, 57911),
(57912, '1.10.10.60-FF-000974', NULL, NULL, 37, NULL, NULL, 57912),
(57913, '3.40.50.2300-FF-000224', NULL, 'Asc operon transcriptional repressor', 102, NULL, NULL, 57913),
(57914, '3.40.850.10-FF-000267', NULL, 'Kinesin-like protein', 367, NULL, NULL, 57914),
(57915, '3.40.50.10810-FF-000207', NULL, 'Uncharacterized protein', 131, NULL, NULL, 57915),
(57916, '3.40.50.12760-FF-000011', NULL, 'Protein CBG15196', 308, NULL, NULL, 57916),
(57917, '2.10.25.10-FF-000524', NULL, 'Neurogenic locus notch protein 1', 40, NULL, NULL, 57917),
(57918, '3.20.20.140-FF-000014', NULL, '5-methylthioadenosine/S-adenosylhomocysteine deaminase', 292, NULL, NULL, 57918),
(57919, '3.40.390.10-FF-000187', NULL, NULL, 105, NULL, NULL, 57919),
(57920, '3.40.50.150-FF-001502', NULL, NULL, 114, NULL, NULL, 57920),
(57921, '2.130.10.10-FF-003896', NULL, 'Predicted Ca-binding lipoprotein', 272, NULL, NULL, 57921),
(57922, '3.40.50.300-FF-006095', NULL, 'ATP-binding cassette transporter, subfamily B, member 2, group MDR/PGP protein PpABCB2', 167, NULL, NULL, 57922),
(57923, '2.60.40.10-FF-002991', NULL, 'Vesicle-associated protein 1-1', 124, NULL, NULL, 57923),
(57924, '3.30.230.10-FF-000352', NULL, 'Uncharacterized protein', 171, NULL, NULL, 57924),
(57925, '3.10.180.10-FF-000037', NULL, 'Catechol 2,3-dioxygenase', 161, NULL, NULL, 57925),
(57926, '4.10.1080.10-FF-000011', NULL, 'Uncharacterized protein', 164, NULL, NULL, 57926),
(57927, '2.20.25.350-FF-000005', NULL, NULL, 38, NULL, NULL, 57927),
(57928, '1.25.40.10-FF-002703', NULL, 'Bardet-Biedl syndrome 4 protein', 118, NULL, NULL, 57928),
(57929, '3.30.2020.30-FF-000004', NULL, 'Nucleotide-binding protein', 94, NULL, NULL, 57929),
(57930, '3.30.930.10-FF-000118', NULL, 'Asparagine-tRNA ligase', 302, NULL, NULL, 57930),
(57931, '1.20.200.10-FF-000034', NULL, 'Uncharacterized protein', 55, NULL, NULL, 57931),
(57932, '3.40.630.30-FF-000442', NULL, 'Polyamine acetyltransferase', 204, NULL, NULL, 57932),
(57933, '3.40.50.1000-FF-000289', NULL, 'Haloacid_dehalogenase-like_hydrolase/HAD-hyrolase-like', 158, NULL, NULL, 57933),
(57934, '3.40.50.1820-FF-001783', NULL, 'Predicted protein', 175, NULL, NULL, 57934),
(57935, '3.30.70.3040-FF-000010', NULL, 'Cell division protein FtsX', 108, NULL, NULL, 57935),
(57936, '3.80.10.10-FF-001789', NULL, 'Uncharacterized protein', 254, NULL, NULL, 57936),
(57937, '3.40.50.620-FF-000002', NULL, 'Sulfate adenylyltransferase subunit 2', 206, NULL, NULL, 57937),
(57938, '3.40.50.620-FF-000474', NULL, 'Putative membrane protein', 139, NULL, NULL, 57938);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(57939, '3.40.50.720-FF-000206', NULL, 'Adenylyltransferase and sulfurtransferase MOCS3', 251, NULL, NULL, 57939),
(57940, '4.10.1000.10-FF-000091', NULL, 'GH07148p', 25, NULL, NULL, 57940),
(57941, '1.10.437.10-FF-000046', NULL, 'Uncharacterized protein', 143, NULL, NULL, 57941),
(57942, '3.90.226.10-FF-000199', NULL, 'Nisin-resistance protein', 216, NULL, NULL, 57942),
(57943, '3.20.20.80-FF-000357', NULL, 'Predicted protein', 290, NULL, NULL, 57943),
(57944, '1.10.10.10-FF-001622', NULL, 'MarR family transcriptional regulator', 162, NULL, NULL, 57944),
(57945, '1.20.1720.10-FF-000016', NULL, 'EmrB/QacA family drug resistance transporter', 206, NULL, NULL, 57945),
(57946, '3.30.160.60-FF-006330', NULL, NULL, 26, NULL, NULL, 57946),
(57947, '3.40.50.12780-FF-000017', NULL, 'Crotonobetaine/carnitine--CoA ligase', 415, NULL, NULL, 57947),
(57948, '3.40.630.30-FF-000386', NULL, 'Transcriptional regulator, MarR family', 131, NULL, NULL, 57948),
(57949, '2.40.10.10-FF-000348', NULL, NULL, 119, NULL, NULL, 57949),
(57950, '3.30.1520.10-FF-000137', NULL, 'Uncharacterized protein', 100, NULL, NULL, 57950),
(57951, '2.30.170.20-FF-000005', NULL, '60S ribosomal protein L24, putative', 69, NULL, NULL, 57951),
(57952, '2.60.40.60-FF-000920', NULL, 'AGAP011529-PA', 93, NULL, NULL, 57952),
(57953, '1.20.1270.10-FF-000003', NULL, 'heat shock cognate 71 kDa protein-like', 118, NULL, NULL, 57953),
(57954, '3.90.25.10-FF-000069', NULL, 'Uncharacterized protein', 74, NULL, NULL, 57954),
(57955, '1.10.8.60-FF-000175', NULL, 'Msp1p', 92, NULL, NULL, 57955),
(57956, '1.10.238.10-FF-000792', NULL, 'Phosphoinositide phospholipase C', 132, NULL, NULL, 57956),
(57957, '3.30.160.60-FF-001327', NULL, 'Uncharacterized protein', 30, NULL, NULL, 57957),
(57958, '3.40.1310.10-FF-000001', NULL, 'Replication protein E1', 144, NULL, NULL, 57958),
(57959, '3.30.160.60-FF-004672', NULL, NULL, 57, NULL, NULL, 57959),
(57960, '1.25.40.200-FF-000002', NULL, 'Ran GTPase activating protein, isoform B', 179, NULL, NULL, 57960),
(57961, '3.40.50.1000-FF-000609', NULL, NULL, 238, NULL, NULL, 57961),
(57962, '3.30.470.20-FF-000136', NULL, 'Uncharacterized protein', 265, NULL, NULL, 57962),
(57963, '3.20.20.140-FF-000486', NULL, 'Os07g0157900 protein', 49, NULL, NULL, 57963),
(57964, '3.40.50.2300-FF-000696', NULL, 'Glutamate receptor IIB', 148, NULL, NULL, 57964),
(57965, '3.30.70.2120-FF-000004', NULL, 'Flagellin', 53, NULL, NULL, 57965),
(57966, '1.20.1250.20-FF-001697', NULL, 'Uncharacterized protein', 289, NULL, NULL, 57966),
(57967, '3.40.50.300-FF-004442', NULL, 'Ras-related protein Rab-11A', 154, NULL, NULL, 57967),
(57968, '3.80.10.10-FF-000805', NULL, 'Blast:F-box/LRR-repeat protein 4', 109, NULL, NULL, 57968),
(57969, '3.40.250.10-FF-000070', NULL, 'Sulfurtransferase', 156, NULL, NULL, 57969),
(57970, '3.40.630.10-FF-000380', NULL, 'Uncharacterized protein', 85, NULL, NULL, 57970),
(57971, '3.30.40.10-FF-001675', NULL, 'Origin recognition complex subunit 1', 78, NULL, NULL, 57971),
(57972, '2.60.120.200-FF-000321', NULL, 'Uncharacterized protein, isoform A', 304, NULL, NULL, 57972),
(57973, '3.30.70.330-FF-001377', NULL, 'Os01g0945800 protein', 143, NULL, NULL, 57973),
(57974, '3.30.460.10-FF-000009', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 250, NULL, NULL, 57974),
(57975, '3.30.2350.10-FF-000074', NULL, 'Uncharacterized protein', 190, NULL, NULL, 57975),
(57976, '1.20.1250.20-FF-000533', NULL, 'Siderophore iron transporter mirC', 236, NULL, NULL, 57976),
(57977, '1.10.287.70-FF-000804', NULL, 'Voltage-gated Ca2+ channel, alpha subunit', 174, NULL, NULL, 57977),
(57978, '1.10.1300.10-FF-000094', NULL, 'Uncharacterized protein', 82, NULL, NULL, 57978),
(57979, '3.50.50.60-FF-000756', NULL, 'Oxidoreductase', 98, NULL, NULL, 57979),
(57980, '3.40.1090.10-FF-000079', NULL, 'Cytosolic phospholipase A2 gamma', 264, NULL, NULL, 57980),
(57981, '1.10.1200.10-FF-000035', NULL, 'Polyketide synthetase mbtD', 84, NULL, NULL, 57981),
(57982, '3.40.50.410-FF-000001', NULL, 'Collagen, type XII, alpha 1', 191, NULL, NULL, 57982);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(57983, '1.10.472.10-FF-000616', NULL, 'Chromosome 8, whole genome shotgun sequence', 131, NULL, NULL, 57983),
(57984, '2.40.50.1060-FF-000010', NULL, 'Uncharacterized protein', 170, NULL, NULL, 57984),
(57985, '3.60.20.10-FF-000205', NULL, NULL, 199, NULL, NULL, 57985),
(57986, '3.30.70.100-FF-000201', NULL, NULL, 73, NULL, NULL, 57986),
(57987, '2.130.10.10-FF-000985', NULL, 'Ribosome biogenesis protein YTM1', 142, NULL, NULL, 57987),
(57988, '2.40.30.170-FF-000058', NULL, NULL, 89, NULL, NULL, 57988),
(57989, '3.40.190.10-FF-000767', NULL, 'Predicted protein', 295, NULL, NULL, 57989),
(57990, '3.10.20.90-FF-000355', NULL, 'Dual specificity mitogen-activated protein kinase kinase 5', 60, NULL, NULL, 57990),
(57991, '1.25.10.10-FF-001533', NULL, 'Coatomer subunit gamma', 369, NULL, NULL, 57991),
(57992, '1.10.287.110-FF-000429', NULL, 'Uncharacterized protein', 87, NULL, NULL, 57992),
(57993, '2.30.29.30-FF-000336', NULL, 'protein Dok-7 isoform X2', 110, NULL, NULL, 57993),
(57994, '1.20.272.10-FF-000059', NULL, NULL, 94, NULL, NULL, 57994),
(57995, '3.20.20.300-FF-000085', NULL, NULL, 100, NULL, NULL, 57995),
(57996, '3.60.21.10-FF-000404', NULL, 'Uncharacterized protein', 304, NULL, NULL, 57996),
(57997, '1.25.10.10-FF-000313', NULL, 'Importin beta-2 subunit, putative', 353, NULL, NULL, 57997),
(57998, '1.20.1250.20-FF-001045', NULL, 'Solute carrier family 17 (sodium phosphate), member 3', 87, NULL, NULL, 57998),
(57999, '3.30.70.330-FF-003035', NULL, NULL, 39, NULL, NULL, 57999),
(58000, '1.10.1420.10-FF-000074', NULL, 'MutS protein homolog him-14', 239, NULL, NULL, 58000),
(58001, '1.10.510.10-FF-004168', NULL, NULL, 302, NULL, NULL, 58001),
(58002, '2.60.40.10-FF-002659', NULL, 'Uncharacterized protein', 75, NULL, NULL, 58002),
(58003, '3.40.50.2300-FF-001005', NULL, NULL, 126, NULL, NULL, 58003),
(58004, '1.20.1640.10-FF-000015', NULL, 'Dispatched RND transporter family member 3', 202, NULL, NULL, 58004),
(58005, '3.40.20.10-FF-000010', NULL, 'Putative destrin', 166, NULL, NULL, 58005),
(58006, '2.70.150.10-FF-000205', NULL, 'Phospholipid-transporting ATPase', 145, NULL, NULL, 58006),
(58007, '3.10.20.90-FF-000411', NULL, 'ESX-4 secretion system protein EccD4', 78, NULL, NULL, 58007),
(58008, '1.10.8.60-FF-000231', NULL, 'Origin recognition complex subunit 5', 31, NULL, NULL, 58008),
(58009, '1.10.238.10-FF-000937', NULL, 'Calmodulin like 6', 147, NULL, NULL, 58009),
(58010, '1.20.1250.20-FF-001753', NULL, 'Predicted protein', 194, NULL, NULL, 58010),
(58011, '2.170.150.10-FF-000024', NULL, 'Uncharacterized protein', 155, NULL, NULL, 58011),
(58012, '3.30.160.60-FF-005402', NULL, NULL, 16, NULL, NULL, 58012),
(58013, '3.80.10.10-FF-002250', NULL, 'F-box protein At-B', 120, NULL, NULL, 58013),
(58014, '1.10.238.10-FF-001101', NULL, 'Uncharacterized protein', 64, NULL, NULL, 58014),
(58015, '3.90.550.50-FF-000166', NULL, 'Uncharacterized protein', 140, NULL, NULL, 58015),
(58016, '1.10.150.20-FF-000147', NULL, 'Transcription termination/antitermination protein NusA', 45, NULL, NULL, 58016),
(58017, '3.40.140.100-FF-000012', NULL, 'Ubiquitin-like modifier-activating enzyme ATG7', 128, NULL, NULL, 58017),
(58018, '3.30.1640.10-FF-000028', NULL, 'DNA helicase', 98, NULL, NULL, 58018),
(58019, '1.50.10.20-FF-000073', NULL, 'Mannan endo-1,6-alpha-mannosidase', 202, NULL, NULL, 58019),
(58020, '3.50.50.60-FF-000812', NULL, 'Flavoprotein monooxygenase, putative', 181, NULL, NULL, 58020),
(58021, '1.20.1070.10-FF-001798', NULL, 'Uncharacterized protein', 318, NULL, NULL, 58021),
(58022, '2.60.120.200-FF-000265', NULL, 'FlaMIngo (Cadherin plus 7TM domain) homolog', 156, NULL, NULL, 58022),
(58023, '2.30.30.140-FF-000332', NULL, 'Sop-2-related protein 3', 107, NULL, NULL, 58023),
(58024, '1.10.730.10-FF-000109', NULL, 'Arginine--tRNA ligase', 125, NULL, NULL, 58024),
(58025, '3.90.70.10-FF-000229', NULL, 'Ubiquitin carboxyl-terminal hydrolase domain containing protein', 144, NULL, NULL, 58025),
(58026, '3.30.230.70-FF-000111', NULL, 'Uncharacterized protein', 261, NULL, NULL, 58026),
(58027, '3.20.20.30-FF-000039', NULL, 'Alkanal monooxygenase beta chain', 82, NULL, NULL, 58027);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(58028, '3.40.50.1820-FF-000799', NULL, 'Carboxylesterase', 496, NULL, NULL, 58028),
(58029, '3.30.160.60-FF-003744', NULL, NULL, 21, NULL, NULL, 58029),
(58030, '3.40.50.2300-FF-000752', NULL, 'Uncharacterized protein', 85, NULL, NULL, 58030),
(58031, '3.30.420.610-FF-000012', NULL, 'Tudor domain-containing protein 7', 78, NULL, NULL, 58031),
(58032, '2.60.120.260-FF-000496', NULL, 'Protein CBG04403', 95, NULL, NULL, 58032),
(58033, '3.30.230.10-FF-000172', NULL, 'Elongation factor G, mitochondrial', 119, NULL, NULL, 58033),
(58034, '2.130.10.10-FF-004728', NULL, 'Uncharacterized protein', 166, NULL, NULL, 58034),
(58035, '3.40.190.10-FF-000244', NULL, 'Putative solute-binding protein', 112, NULL, NULL, 58035),
(58036, '1.25.10.10-FF-002078', NULL, 'Serine/threonine kinase 36 (fused homolog, Drosophila)', 157, NULL, NULL, 58036),
(58037, '2.30.39.10-FF-000100', NULL, 'Protein CBG10463', 159, NULL, NULL, 58037),
(58038, '3.90.1170.50-FF-000018', NULL, 'Aldehyde oxidase / xanthine dehydrogenase family molybdopterin cytosine dinucleotide-binding subunit', 149, NULL, NULL, 58038),
(58039, '3.20.110.10-FF-000042', NULL, 'Lysosomal alpha-mannosidase, putative', 69, NULL, NULL, 58039),
(58040, '3.60.120.10-FF-000011', NULL, 'Aminodeoxychorismate synthase', 529, NULL, NULL, 58040),
(58041, '3.40.50.2000-FF-000016', NULL, 'UDP-N-acetylglucosamine--N-acetylmuramyl-(pentapeptide) pyrophosphoryl-undecaprenol N-acetylglucosamine transferase', 153, NULL, NULL, 58041),
(58042, '3.80.10.10-FF-000625', NULL, 'Leucine-rich repeat receptor-like protein kinase', 353, NULL, NULL, 58042),
(58043, '2.40.30.10-FF-000147', NULL, 'Sulfate adenylyltransferase subunit 1', 106, NULL, NULL, 58043),
(58044, '2.60.40.10-FF-001586', NULL, 'Single Ig IL-1-related receptor', 113, NULL, NULL, 58044),
(58045, '2.40.50.910-FF-000003', NULL, 'ESX-3 secretion system ATPase EccB3', 87, NULL, NULL, 58045),
(58046, '3.30.960.10-FF-000002', NULL, 'Eukaryotic peptide chain release factor subunit 1', 132, NULL, NULL, 58046),
(58047, '3.90.1170.30-FF-000012', NULL, 'Pyrimidine-nucleoside phosphorylase', 85, NULL, NULL, 58047),
(58048, '4.10.240.10-FF-000061', NULL, 'Transcription factor', 41, NULL, NULL, 58048),
(58049, '3.40.50.300-FF-008281', NULL, 'Predicted protein', 35, NULL, NULL, 58049),
(58050, '3.40.50.12550-FF-000010', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 117, NULL, NULL, 58050),
(58051, '1.20.58.900-FF-000002', NULL, 'small G protein signaling modulator 1', 185, NULL, NULL, 58051),
(58052, '3.40.50.720-FF-001611', NULL, 'Putative precorrin-2 dehydrogenase', 135, NULL, NULL, 58052),
(58053, '3.90.70.10-FF-000140', NULL, 'Ubiquitin C-terminal hydrolase', 384, NULL, NULL, 58053),
(58054, '3.90.640.10-FF-000116', NULL, 'Heat shock protein 70 putative', 87, NULL, NULL, 58054),
(58055, '3.30.70.1170-FF-000011', NULL, 'Ribosomal RNA small subunit methyltransferase B', 93, NULL, NULL, 58055),
(58056, '3.30.760.10-FF-000049', NULL, 'Eukaryotic translation initiation factor 4E family member 1c', 77, NULL, NULL, 58056),
(58057, '3.60.21.10-FF-000371', NULL, '5'' nucleotidase, putative', 113, NULL, NULL, 58057),
(58058, '2.40.100.10-FF-000153', NULL, 'Peptidyl-prolyl cis-trans isomerase', 152, NULL, NULL, 58058),
(58059, '3.30.200.20-FF-001134', NULL, 'Receptor protein-tyrosine kinase', 83, NULL, NULL, 58059),
(58060, '1.25.40.10-FF-000517', NULL, 'Pentatricopeptide repeat-containing protein At1g50270', 110, NULL, NULL, 58060),
(58061, '3.40.50.300-FF-003930', NULL, 'RAB34, member RAS oncogene family a', 188, NULL, NULL, 58061),
(58062, '3.40.309.10-FF-000111', NULL, 'Uncharacterized protein', 124, NULL, NULL, 58062),
(58063, '3.30.70.2470-FF-000002', NULL, 'Receptor-type tyrosine-protein phosphatase N2 isoform 3', 60, NULL, NULL, 58063),
(58064, '3.40.50.300-FF-003222', NULL, 'ABC transporter ATP-binding protein YtrE', 229, NULL, NULL, 58064),
(58065, '3.40.50.1370-FF-000001', NULL, 'Aspartate carbamoyltransferase', 135, NULL, NULL, 58065),
(58066, '3.40.50.450-FF-000018', NULL, 'Lysine decarboxylase-like protein', 229, NULL, NULL, 58066);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(58067, '2.130.10.30-FF-000092', NULL, 'Uncharacterized protein', 417, NULL, NULL, 58067),
(58068, '3.30.200.20-FF-001842', NULL, 'Proto-oncogene receptor tyrosine protein kinase ret, putative', 126, NULL, NULL, 58068),
(58069, '2.40.70.10-FF-000324', NULL, NULL, 176, NULL, NULL, 58069),
(58070, '3.90.550.10-FF-000289', NULL, 'GalNAc(5)-diNAcBac-PP-undecaprenol beta-1,3-glucosyltransferase', 258, NULL, NULL, 58070),
(58071, '3.60.40.10-FF-000004', NULL, 'Probable protein phosphatase 2C 22', 278, NULL, NULL, 58071),
(58072, '3.60.110.10-FF-000038', NULL, 'Glutamine-dependent NAD(+) synthetase', 195, NULL, NULL, 58072),
(58073, '2.40.50.140-FF-000643', NULL, 'Single-stranded DNA-binding protein', 132, NULL, NULL, 58073),
(58074, '3.30.420.10-FF-000035', NULL, 'Poly(A)-specific ribonuclease PARN', 297, NULL, NULL, 58074),
(58075, '3.90.920.10-FF-000014', NULL, 'DNA primase', 413, NULL, NULL, 58075),
(58076, '2.60.40.10-FF-000097', NULL, 'Bent, isoform F', 102, NULL, NULL, 58076),
(58077, '2.60.40.420-FF-000142', NULL, 'Multicopper oxidase', 216, NULL, NULL, 58077),
(58078, '1.10.150.190-FF-000010', NULL, NULL, 87, NULL, NULL, 58078),
(58079, '1.10.3430.10-FF-000070', NULL, 'Predicted protein', 194, NULL, NULL, 58079),
(58080, '3.30.160.60-FF-001979', NULL, 'Zinc finger protein 222', 29, NULL, NULL, 58080),
(58081, '2.120.10.30-FF-000373', NULL, 'Predicted protein', 131, NULL, NULL, 58081),
(58082, '3.40.50.1970-FF-000052', NULL, NULL, 167, NULL, NULL, 58082),
(58083, '3.30.1330.30-FF-000140', NULL, 'Predicted protein', 66, NULL, NULL, 58083),
(58084, '1.10.10.440-FF-000016', NULL, 'pre-mRNA-processing factor 40 homolog B isoform X1', 73, NULL, NULL, 58084),
(58085, '3.30.70.330-FF-000781', NULL, 'Peptidyl-prolyl cis-trans isomerase E', 127, NULL, NULL, 58085),
(58086, '1.10.760.10-FF-000117', NULL, 'Glr3801 protein', 197, NULL, NULL, 58086),
(58087, '2.60.40.10-FF-005532', NULL, NULL, 56, NULL, NULL, 58087),
(58088, '1.25.40.180-FF-000035', NULL, 'snRNA cap binding complex subunit (Gcr3)', 212, NULL, NULL, 58088),
(58089, '3.30.40.10-FF-001495', NULL, 'Uncharacterized protein', 78, NULL, NULL, 58089),
(58090, '2.20.70.10-FF-000218', NULL, 'Rho GTPase-activating protein 27,-like', 57, NULL, NULL, 58090),
(58091, '3.40.850.10-FF-000503', NULL, 'Uncharacterized protein', 208, NULL, NULL, 58091),
(58092, '3.90.1150.10-FF-000151', NULL, 'Alanine aminotransferase 2', 127, NULL, NULL, 58092),
(58093, '1.10.510.10-FF-001386', NULL, 'Uncharacterized protein', 183, NULL, NULL, 58093),
(58094, '1.10.8.20-FF-000011', NULL, 'Retinol-binding protein pinta', 73, NULL, NULL, 58094),
(58095, '3.30.1010.10-FF-000110', NULL, 'Predicted protein', 126, NULL, NULL, 58095),
(58096, '1.10.510.10-FF-001442', NULL, 'Non-specific serine/threonine protein kinase', 189, NULL, NULL, 58096),
(58097, '1.10.3210.10-FF-000087', NULL, 'Uncharacterized protein', 146, NULL, NULL, 58097),
(58098, '1.10.565.10-FF-000124', NULL, 'Tailless ortholog', 223, NULL, NULL, 58098),
(58099, '3.40.850.10-FF-000447', NULL, 'RT07324p', 106, NULL, NULL, 58099),
(58100, '3.40.50.2000-FF-000544', NULL, 'Alpha,alpha-trehalose-phosphate synthase', 210, NULL, NULL, 58100),
(58101, '3.40.50.720-FF-001898', NULL, 'Pyrroline-5-carboxylate reductase', 176, NULL, NULL, 58101),
(58102, '3.30.200.20-FF-002438', NULL, 'Os10g0200000 protein', 70, NULL, NULL, 58102),
(58103, '1.25.40.20-FF-001779', NULL, 'Pho81p', 182, NULL, NULL, 58103),
(58104, '1.20.1280.140-FF-000006', NULL, 'Uncharacterized protein', 88, NULL, NULL, 58104),
(58105, '3.30.160.60-FF-002255', NULL, 'Zinc finger protein 460', 31, NULL, NULL, 58105),
(58106, '3.40.50.1000-FF-000761', NULL, NULL, 132, NULL, NULL, 58106),
(58107, '2.70.170.10-FF-000004', NULL, 'Gamma-aminobutyric acid receptor subunit beta-2 isoform A', 217, NULL, NULL, 58107),
(58108, '3.10.10.10-FF-000016', NULL, 'Uncharacterized protein', 56, NULL, NULL, 58108),
(58109, '2.130.10.10-FF-000462', NULL, 'Katanin p80 WD40 repeat-containing subunit B1', 131, NULL, NULL, 58109),
(58110, '2.30.30.40-FF-000207', NULL, 'CLUMA_CG020965, isoform A', 62, NULL, NULL, 58110);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(58111, '1.10.720.60-FF-000017', NULL, 'Enolase-phosphatase E1', 98, NULL, NULL, 58111),
(58112, '3.40.50.2000-FF-000488', NULL, 'Alpha-1,3-mannosyltransferase ALG2, putative', 193, NULL, NULL, 58112),
(58113, '3.40.50.1000-FF-000233', NULL, 'Haloacid dehalogenase-like hydrolase', 153, NULL, NULL, 58113),
(58114, '3.30.160.60-FF-002199', NULL, 'Uncharacterized protein', 25, NULL, NULL, 58114),
(58115, '2.10.25.10-FF-001744', NULL, 'Uncharacterized protein', 57, NULL, NULL, 58115),
(58116, '1.20.1310.10-FF-000114', NULL, NULL, 105, NULL, NULL, 58116),
(58117, '1.20.1560.10-FF-000014', NULL, 'Multidrug resistance-associated protein member 4', 346, NULL, NULL, 58117),
(58118, '2.130.10.10-FF-004149', NULL, 'Uncharacterized protein', 177, NULL, NULL, 58118),
(58119, '3.30.420.10-FF-000563', NULL, NULL, 51, NULL, NULL, 58119),
(58120, '3.30.70.1230-FF-000254', NULL, 'Guanylate cyclase', 190, NULL, NULL, 58120),
(58121, '2.130.10.10-FF-004880', NULL, 'Uncharacterized protein', 119, NULL, NULL, 58121),
(58122, '1.25.10.10-FF-002314', NULL, 'Uncharacterized protein', 314, NULL, NULL, 58122),
(58123, '3.40.50.10490-FF-000105', NULL, 'Glucosamine-fructose-6-phosphate aminotransferase, putative', 229, NULL, NULL, 58123),
(58124, '3.30.1320.10-FF-000009', NULL, '30S ribosomal protein S16', 139, NULL, NULL, 58124),
(58125, '2.60.120.560-FF-000029', NULL, 'Uncharacterized protein', 110, NULL, NULL, 58125),
(58126, '3.40.50.620-FF-000710', NULL, 'Uncharacterized protein', 221, NULL, NULL, 58126),
(58127, '3.30.40.210-FF-000014', NULL, 'Transcription initiation protein, putative', 84, NULL, NULL, 58127),
(58128, '3.30.40.10-FF-000511', NULL, 'PHD and RING finger domain-containing protein 1', 83, NULL, NULL, 58128),
(58129, '2.170.270.10-FF-000151', NULL, 'SET (Trithorax/polycomb) domain containing', 305, NULL, NULL, 58129),
(58130, '3.50.50.60-FF-000195', NULL, 'L-ornithine N(5)-monooxygenase', 472, NULL, NULL, 58130),
(58131, '2.60.120.260-FF-000529', NULL, 'Uncharacterized protein', 91, NULL, NULL, 58131),
(58132, '3.30.160.60-FF-004385', NULL, NULL, 87, NULL, NULL, 58132),
(58133, '3.30.70.1220-FF-000009', NULL, 'Uncharacterized protein', 64, NULL, NULL, 58133),
(58134, '3.30.1390.10-FF-000014', NULL, 'ATP-dependent Clp protease adaptor protein ClpS', 88, NULL, NULL, 58134),
(58135, '2.30.220.10-FF-000001', NULL, 'Flagellin', 93, NULL, NULL, 58135),
(58136, '2.60.40.150-FF-000802', NULL, 'Uncharacterized protein', 154, NULL, NULL, 58136),
(58137, '3.40.50.300-FF-002817', NULL, 'ESX-3 secretion system protein EccC3', 285, NULL, NULL, 58137),
(58138, '1.10.1240.60-FF-000002', NULL, 'CRE-EAT-16 protein', 98, NULL, NULL, 58138),
(58139, '3.40.50.1980-FF-000150', NULL, 'Iron-uptake system binding protein', 151, NULL, NULL, 58139),
(58140, '3.30.160.60-FF-006094', NULL, NULL, 23, NULL, NULL, 58140),
(58141, '2.60.120.10-FF-000138', NULL, 'Homogentisate 1,2-dioxygenase', 139, NULL, NULL, 58141),
(58142, '1.10.510.10-FF-003151', NULL, NULL, 174, NULL, NULL, 58142),
(58143, '3.40.309.10-FF-000055', NULL, 'Aldehyde dehydrogenase', 189, NULL, NULL, 58143),
(58144, '2.60.40.10-FF-001058', NULL, 'Sallimus, isoform P', 101, NULL, NULL, 58144),
(58145, '1.10.287.470-FF-000048', NULL, 'Efflux transporter, RND family, MFP subunit', 60, NULL, NULL, 58145),
(58146, '2.60.40.60-FF-000448', NULL, 'Cadherin 2', 122, NULL, NULL, 58146),
(58147, '3.10.450.490-FF-000003', NULL, 'Elastase', 86, NULL, NULL, 58147),
(58148, '1.20.58.1120-FF-000010', NULL, 'Dynein heavy chain domain 1', 169, NULL, NULL, 58148),
(58149, '2.60.200.20-FF-000237', NULL, 'GGDEF family protein', 131, NULL, NULL, 58149),
(58150, '2.30.42.10-FF-000619', NULL, NULL, 88, NULL, NULL, 58150),
(58151, '3.30.479.20-FF-000004', NULL, 'Elongation factor Ts', 98, NULL, NULL, 58151),
(58152, '1.10.10.60-FF-001227', NULL, NULL, 48, NULL, NULL, 58152),
(58153, '2.10.60.10-FF-000010', NULL, 'Receptor protein serine/threonine kinase', 76, NULL, NULL, 58153),
(58154, '3.90.1600.10-FF-000017', NULL, 'DNA polymerase', 155, NULL, NULL, 58154),
(58155, '2.60.40.10-FF-001114', NULL, 'Chitinase A1', 87, NULL, NULL, 58155);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(58156, '3.10.200.10-FF-000006', NULL, 'Carbonic anhydrase-related protein-like', 268, NULL, NULL, 58156),
(58157, '1.10.400.10-FF-000068', NULL, 'Uncharacterized protein', 76, NULL, NULL, 58157),
(58158, '3.30.160.60-FF-003216', NULL, 'Zinc finger protein 451', 67, NULL, NULL, 58158),
(58159, '1.10.10.60-FF-000451', NULL, 'Homeobox protein vent1', 118, NULL, NULL, 58159),
(58160, '1.50.40.10-FF-000217', NULL, 'Uncharacterized protein, isoform A', 271, NULL, NULL, 58160),
(58161, '1.10.10.10-FF-001061', NULL, 'Cullin family protein', 90, NULL, NULL, 58161),
(58162, '1.20.58.60-FF-000605', NULL, 'Spectrin beta chain', 300, NULL, NULL, 58162),
(58163, '3.30.1490.290-FF-000001', NULL, NULL, 106, NULL, NULL, 58163),
(58164, '3.40.50.1010-FF-000146', NULL, 'DNA polymerase I', 170, NULL, NULL, 58164),
(58165, '1.20.1270.60-FF-000024', NULL, 'growth arrest-specific protein 7 isoform X2', 282, NULL, NULL, 58165),
(58166, '1.20.1050.130-FF-000048', NULL, 'Uncharacterized protein', 86, NULL, NULL, 58166),
(58167, '2.130.10.10-FF-005841', NULL, 'Apaf-1 related killer DARK', 350, NULL, NULL, 58167),
(58168, '3.50.50.60-FF-000048', NULL, '2-octaprenyl-3-methyl-6-methoxy-1,4-benzoquinol hydroxylase', 253, NULL, NULL, 58168),
(58169, '2.130.10.10-FF-002019', NULL, 'Protein ROOT INITIATION DEFECTIVE 3', 116, NULL, NULL, 58169),
(58170, '3.40.50.2300-FF-001477', NULL, NULL, 138, NULL, NULL, 58170),
(58171, '1.25.40.180-FF-000182', NULL, 'Uncharacterized protein', 258, NULL, NULL, 58171),
(58172, '3.40.1490.10-FF-000008', NULL, 'Uncharacterized protein', 89, NULL, NULL, 58172),
(58173, '3.40.50.10890-FF-000012', NULL, 'Cleavage and polyadenylation specificity factor', 188, NULL, NULL, 58173),
(58174, '3.40.532.10-FF-000034', NULL, NULL, 113, NULL, NULL, 58174),
(58175, '2.60.40.10-FF-005329', NULL, NULL, 76, NULL, NULL, 58175),
(58176, '1.20.1080.10-FF-000079', NULL, 'Delta-TIP homolog', 118, NULL, NULL, 58176),
(58177, '3.10.120.10-FF-000005', NULL, 'E3 ubiquitin-protein ligase HERC2 isoform X2', 92, NULL, NULL, 58177),
(58178, '3.30.70.330-FF-000449', NULL, 'splicing factor U2AF 35 kDa subunit isoform X3', 73, NULL, NULL, 58178),
(58179, '1.20.1070.10-FF-000634', NULL, 'Uncharacterized protein', 262, NULL, NULL, 58179),
(58180, '3.30.1780.10-FF-000010', NULL, 'Ornithine cyclodeaminase', 107, NULL, NULL, 58180),
(58181, '3.40.50.300-FF-004947', NULL, 'Uncharacterized protein', 162, NULL, NULL, 58181),
(58182, '3.40.50.150-FF-000518', NULL, 'Salicylate carboxymethyltransferase', 203, NULL, NULL, 58182),
(58183, '3.20.20.100-FF-000137', NULL, 'Predicted protein', 302, NULL, NULL, 58183),
(58184, '3.40.50.300-FF-001513', NULL, 'Structural maintenance of chromosomes protein', 192, NULL, NULL, 58184),
(58185, '1.25.10.10-FF-002258', NULL, 'Predicted protein', 356, NULL, NULL, 58185),
(58186, '3.30.830.10-FF-000318', NULL, 'Uncharacterized protein', 69, NULL, NULL, 58186),
(58187, '1.25.40.10-FF-003070', NULL, 'Crooked neck protein, putative, expressed', 197, NULL, NULL, 58187),
(58188, '3.30.70.330-FF-000629', NULL, 'ATP-dependent RNA helicase DeaD', 69, NULL, NULL, 58188),
(58189, '3.30.420.40-FF-000723', NULL, 'DnaK protein', 83, NULL, NULL, 58189),
(58190, '4.10.1000.30-FF-000006', NULL, 'Uncharacterized protein', 50, NULL, NULL, 58190),
(58191, '2.40.30.10-FF-000350', NULL, 'Iron only hydrogenase large subunit, C-terminal domain containing protein', 80, NULL, NULL, 58191),
(58192, '3.50.30.30-FF-000089', NULL, 'Probable E3 ubiquitin-protein ligase plr-1', 162, NULL, NULL, 58192),
(58193, '1.25.10.10-FF-001297', NULL, 'Predicted protein', 335, NULL, NULL, 58193),
(58194, '3.40.50.720-FF-001375', NULL, 'Glyoxylate reductase protein', 30, NULL, NULL, 58194),
(58195, '3.40.1280.10-FF-000003', NULL, 'Ribosomal RNA small subunit methyltransferase', 206, NULL, NULL, 58195),
(58196, '3.30.260.10-FF-000033', NULL, 'Chaperonin-containing T-complex subunit', 107, NULL, NULL, 58196),
(58197, '3.30.160.60-FF-005689', NULL, NULL, 15, NULL, NULL, 58197),
(58198, '2.70.150.10-FF-000149', NULL, 'Phospholipid-transporting ATPase', 17, NULL, NULL, 58198);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(58199, '3.30.450.20-FF-000337', NULL, 'Methyl-accepting chemotaxis protein', 154, NULL, NULL, 58199),
(58200, '3.30.200.20-FF-002062', NULL, 'Serine/threonine protein kinase', 86, NULL, NULL, 58200),
(58201, '2.40.50.40-FF-000068', NULL, 'Chromodomain protein, Y-like', 63, NULL, NULL, 58201),
(58202, '3.90.1150.10-FF-000527', NULL, 'Uncharacterized protein', 115, NULL, NULL, 58202),
(58203, '3.30.420.40-FF-000903', NULL, 'Heat shock protein, putative', 42, NULL, NULL, 58203),
(58204, '1.20.120.1760-FF-000013', NULL, 'Inner membrane protein YnjF', 194, NULL, NULL, 58204),
(58205, '1.25.10.10-FF-000369', NULL, 'Vimar', 378, NULL, NULL, 58205),
(58206, '1.20.58.60-FF-000044', NULL, 'Short stop, isoform K', 109, NULL, NULL, 58206),
(58207, '3.40.50.300-FF-006712', NULL, 'Thymidine kinase', 76, NULL, NULL, 58207),
(58208, '3.40.1280.30-FF-000009', NULL, 'tRNA (Guanine-N(1)-)-methyltransferase TRM10, putative', 193, NULL, NULL, 58208),
(58209, '2.130.10.10-FF-001238', NULL, 'Small nucleolar ribonucleoprotein complex subunit, putative', 74, NULL, NULL, 58209),
(58210, '1.25.40.10-FF-002086', NULL, 'RNA processing factor 4', 71, NULL, NULL, 58210),
(58211, '1.20.120.1630-FF-000025', NULL, 'DUF1295 domain-containing protein', 201, NULL, NULL, 58211),
(58212, '1.10.630.10-FF-000080', NULL, 'Carotene epsilon-monooxygenase, chloroplastic', 460, NULL, NULL, 58212),
(58213, '3.90.1310.10-FF-000006', NULL, 'Penicillin-binding A domain protein', 135, NULL, NULL, 58213),
(58214, '1.20.58.60-FF-000752', NULL, 'Uncharacterized protein', 62, NULL, NULL, 58214),
(58215, '3.30.710.10-FF-000102', NULL, 'Potassium voltage-gated channel subfamily S member 1', 123, NULL, NULL, 58215),
(58216, '3.40.50.150-FF-000670', NULL, 'Amine N-MethylTransferase', 259, NULL, NULL, 58216),
(58217, '1.10.287.3440-FF-000007', NULL, 'Biosynthetic arginine decarboxylase', 59, NULL, NULL, 58217),
(58218, '1.10.418.10-FF-000182', NULL, 'Uncharacterized protein', 114, NULL, NULL, 58218),
(58219, '2.60.40.10-FF-000658', NULL, 'Neural cell adhesion molecule L1', 88, NULL, NULL, 58219),
(58220, '3.40.50.300-FF-007112', NULL, 'Small GTP-binding protein, putative', 186, NULL, NULL, 58220),
(58221, '3.60.15.10-FF-000171', NULL, 'Beta-lactamase superfamily domain/DNA repair metallo-beta-lactamase, putative', 157, NULL, NULL, 58221),
(58222, '2.130.10.10-FF-002351', NULL, 'Uncharacterized protein', 188, NULL, NULL, 58222),
(58223, '3.40.50.300-FF-007820', NULL, 'Uncharacterized protein', 276, NULL, NULL, 58223),
(58224, '1.25.50.20-FF-000083', NULL, 'Aminopeptidase', 163, NULL, NULL, 58224),
(58225, '1.20.58.860-FF-000006', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 68, NULL, NULL, 58225),
(58226, '2.60.120.260-FF-000024', NULL, 'SUN domain containing ossification factor', 168, NULL, NULL, 58226),
(58227, '3.40.50.80-FF-000139', NULL, 'Flavodoxin family protein', 193, NULL, NULL, 58227),
(58228, '1.10.10.60-FF-000395', NULL, 'GS homeobox 2', 73, NULL, NULL, 58228),
(58229, '2.40.37.10-FF-000028', NULL, 'Alanine racemase', 135, NULL, NULL, 58229),
(58230, '1.10.1520.10-FF-000110', NULL, 'Dicer-like ribonuclease with helicase and Rnase III domains', 198, NULL, NULL, 58230),
(58231, '3.30.1360.70-FF-000018', NULL, 'Arginyl-tRNA synthetase', 125, NULL, NULL, 58231),
(58232, '3.40.718.10-FF-000027', NULL, 'Probable LYS12-Homo-isocitrate dehydrogenase', 375, NULL, NULL, 58232),
(58233, '3.40.50.150-FF-001446', NULL, NULL, 142, NULL, NULL, 58233),
(58234, '1.20.120.430-FF-000017', NULL, 'tRNA modification GTPase GTPBP3, mitochondrial', 171, NULL, NULL, 58234),
(58235, '3.30.420.40-FF-000870', NULL, 'Uncharacterized protein', 75, NULL, NULL, 58235),
(58236, '2.10.110.10-FF-000306', NULL, 'LIM domain-containing protein, putative', 39, NULL, NULL, 58236),
(58237, '1.25.40.10-FF-003631', NULL, 'Tetratricopeptide repeat domain 37', 139, NULL, NULL, 58237),
(58238, '3.30.230.70-FF-000055', NULL, 'RNasePH-like protein', 327, NULL, NULL, 58238),
(58239, '2.10.90.10-FF-000158', NULL, 'Uncharacterized protein', 79, NULL, NULL, 58239),
(58240, '3.40.30.10-FF-000600', NULL, 'Glutathione peroxidase', 169, NULL, NULL, 58240);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(58241, '3.40.50.300-FF-005167', NULL, 'Plasmid stability/partitioning determinant RepA', 223, NULL, NULL, 58241),
(58242, '3.30.70.330-FF-000596', NULL, 'RNA-binding protein Musashi homolog 1', 70, NULL, NULL, 58242),
(58243, '3.40.50.300-FF-002441', NULL, 'ABC transporter B family member 3', 222, NULL, NULL, 58243),
(58244, '1.20.5.340-FF-000082', NULL, 'Predicted protein', 97, NULL, NULL, 58244),
(58245, '1.10.30.50-FF-000005', NULL, 'HNH endonuclease domain protein', 91, NULL, NULL, 58245),
(58246, '3.20.20.80-FF-000413', NULL, 'Uncharacterized protein', 322, NULL, NULL, 58246),
(58247, '2.120.10.30-FF-000406', NULL, 'Uncharacterized protein', 197, NULL, NULL, 58247),
(58248, '1.10.760.10-FF-000084', NULL, 'Di-heme enzyme, MXAN_0977 family', 177, NULL, NULL, 58248),
(58249, '2.60.120.290-FF-000128', NULL, 'mannan-binding lectin serine protease 1-like', 117, NULL, NULL, 58249),
(58250, '1.20.1070.10-FF-000814', NULL, 'Taste receptor type 2', 290, NULL, NULL, 58250),
(58251, '1.20.120.1200-FF-000014', NULL, 'NADH-ubiquinone oxidoreductase chain 6', 188, NULL, NULL, 58251),
(58252, '1.10.268.10-FF-000001', NULL, 'DNA gyrase subunit A', 99, NULL, NULL, 58252),
(58253, '2.130.10.110-FF-000003', NULL, 'Clathrin heavy chain', 365, NULL, NULL, 58253),
(58254, '3.40.50.300-FF-005875', NULL, 'Uncharacterized protein', 176, NULL, NULL, 58254),
(58255, '3.30.460.80-FF-000013', NULL, 'Uncharacterized protein', 61, NULL, NULL, 58255),
(58256, '1.20.5.350-FF-000028', NULL, NULL, 38, NULL, NULL, 58256),
(58257, '1.10.510.10-FF-002931', NULL, 'Uncharacterized protein', 276, NULL, NULL, 58257),
(58258, '1.10.510.10-FF-003331', NULL, NULL, 55, NULL, NULL, 58258),
(58259, '3.30.160.60-FF-002963', NULL, 'Transcriptional repressor CTCF', 29, NULL, NULL, 58259),
(58260, '1.10.1820.10-FF-000003', NULL, 'Casein kinase II subunit beta', 102, NULL, NULL, 58260),
(58261, '2.10.25.10-FF-001688', NULL, 'Uncharacterized protein', 66, NULL, NULL, 58261),
(58262, '2.130.10.10-FF-001390', NULL, 'U3 small nucleolar RNA-associated protein 13', 247, NULL, NULL, 58262),
(58263, '3.40.640.10-FF-000257', NULL, 'DegT/DnrJ/EryC1/StrS family aminotransferase', 247, NULL, NULL, 58263),
(58264, '3.30.230.130-FF-000027', NULL, 'Cullin family protein', 165, NULL, NULL, 58264),
(58265, '3.40.50.300-FF-000496', NULL, 'Nucleolar GTP-binding protein 1', 198, NULL, NULL, 58265),
(58266, '1.10.10.10-FF-000509', NULL, 'transcription factor ETV7', 115, NULL, NULL, 58266),
(58267, '1.20.1070.10-FF-000106', NULL, 'Apelin receptor a', 320, NULL, NULL, 58267),
(58268, '3.20.100.10-FF-000013', NULL, 'Uncharacterized protein', 389, NULL, NULL, 58268),
(58269, '3.20.80.10-FF-000065', NULL, 'Uncharacterized protein', 78, NULL, NULL, 58269),
(58270, '1.10.1870.10-FF-000006', NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', 106, NULL, NULL, 58270),
(58271, '3.60.130.10-FF-000040', NULL, 'Predicted protein', 87, NULL, NULL, 58271),
(58272, '3.80.10.10-FF-002194', NULL, 'Toll-like receptor 21', 120, NULL, NULL, 58272),
(58273, '3.30.310.50-FF-000050', NULL, 'Uncharacterized protein', 95, NULL, NULL, 58273),
(58274, '1.10.1900.10-FF-000004', NULL, 'Polyadenylate-binding protein', 87, NULL, NULL, 58274),
(58275, '3.30.70.330-FF-000421', NULL, 'CUGBP Elav-like family member 4', 96, NULL, NULL, 58275),
(58276, '2.120.10.30-FF-000261', NULL, 'Predicted protein', 191, NULL, NULL, 58276),
(58277, '1.10.8.480-FF-000013', NULL, 'rRNA adenine N(6)-methyltransferase', 82, NULL, NULL, 58277),
(58278, '3.40.850.10-FF-000559', NULL, 'Uncharacterized protein', 107, NULL, NULL, 58278),
(58279, '3.30.160.60-FF-003183', NULL, 'KLUmpfuss related', 26, NULL, NULL, 58279),
(58280, '3.40.50.300-FF-001980', NULL, 'Cytosolic Fe-S cluster assembly factor NUBP1 homolog', 276, NULL, NULL, 58280),
(58281, '1.10.10.580-FF-000013', NULL, 'Segregation and condensation protein A', 67, NULL, NULL, 58281),
(58282, '1.10.472.10-FF-000532', NULL, 'Predicted protein', 88, NULL, NULL, 58282),
(58283, '3.60.20.10-FF-000121', NULL, 'Proteasome subunit beta', 207, NULL, NULL, 58283);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(58284, '1.10.150.60-FF-000024', NULL, 'SWI/SNF chromatin-remodeling complex subunit SWI1', 121, NULL, NULL, 58284),
(58285, '1.10.565.10-FF-000012', NULL, 'Nuclear receptor subfamily 2 group C member 1', 249, NULL, NULL, 58285),
(58286, '3.40.50.2000-FF-000432', NULL, '3-deoxy-D-manno-octulosonic acid transferase', 160, NULL, NULL, 58286),
(58287, '2.30.30.210-FF-000016', NULL, 'ribonuclease P protein subunit p29-like', 96, NULL, NULL, 58287),
(58288, '1.10.132.130-FF-000006', NULL, NULL, 80, NULL, NULL, 58288),
(58289, '1.25.40.10-FF-004064', NULL, 'Uncharacterized protein', 327, NULL, NULL, 58289),
(58290, '1.10.287.280-FF-000002', NULL, 'DNA-directed RNA polymerase', 78, NULL, NULL, 58290),
(58291, '3.90.550.50-FF-000082', NULL, 'GM18192', 195, NULL, NULL, 58291),
(58292, '3.30.70.270-FF-000229', NULL, NULL, 184, NULL, NULL, 58292),
(58293, '1.25.40.20-FF-001419', NULL, 'Uncharacterized protein', 114, NULL, NULL, 58293),
(58294, '1.20.58.60-FF-000196', NULL, 'Uncharacterized protein, isoform D', 200, NULL, NULL, 58294),
(58295, '3.40.1480.10-FF-000007', NULL, 'Glycerate kinase', 172, NULL, NULL, 58295),
(58296, '3.40.50.300-FF-004734', NULL, 'Predicted protein', 254, NULL, NULL, 58296),
(58297, '1.10.510.10-FF-000037', NULL, 'Serine/threonine-protein kinase tousled-like 2', 313, NULL, NULL, 58297),
(58298, '1.20.1070.10-FF-001983', NULL, 'Uncharacterized protein', 164, NULL, NULL, 58298),
(58299, '3.30.160.60-FF-004913', NULL, NULL, 51, NULL, NULL, 58299),
(58300, '3.90.70.10-FF-000432', NULL, 'Uncharacterized protein', 119, NULL, NULL, 58300),
(58301, '1.20.120.810-FF-000002', NULL, 'Vinculin b', 229, NULL, NULL, 58301),
(58302, '2.70.130.10-FF-000114', NULL, NULL, 100, NULL, NULL, 58302),
(58303, '2.40.128.330-FF-000009', NULL, 'Magnesium ion transporter, putative', 91, NULL, NULL, 58303),
(58304, '3.30.70.2630-FF-000005', NULL, 'Telomerase reverse transcriptase', 83, NULL, NULL, 58304),
(58305, '3.40.50.1100-FF-000257', NULL, 'Pyridoxal-5''-phosphate-dependent protein beta subunit', 162, NULL, NULL, 58305),
(58306, '3.30.420.40-FF-000291', NULL, 'Actin, alpha skeletal muscle', 174, NULL, NULL, 58306),
(58307, '3.40.50.970-FF-000180', NULL, 'Oxoglutarate dehydrogenase (Succinyl-transferring), E1 component', 376, NULL, NULL, 58307),
(58308, '1.25.10.10-FF-000925', NULL, 'Proteasome activator complex subunit', 452, NULL, NULL, 58308),
(58309, '3.20.20.70-FF-000023', NULL, 'Lipoyl synthase', 212, NULL, NULL, 58309),
(58310, '3.90.1140.10-FF-000061', NULL, 'Protein UBASH3A homolog-like Protein', 199, NULL, NULL, 58310),
(58311, '3.40.50.150-FF-000485', NULL, 'rRNA adenine N(6)-methyltransferase', 233, NULL, NULL, 58311),
(58312, '3.30.2160.10-FF-000031', NULL, 'E3 ubiquitin-protein ligase hecd-1', 55, NULL, NULL, 58312),
(58313, '3.80.10.10-FF-000125', NULL, 'Brassinosteroid LRR receptor kinase', 567, NULL, NULL, 58313),
(58314, '2.60.40.10-FF-002159', NULL, 'Cilia and flagella associated protein 65', 99, NULL, NULL, 58314),
(58315, '3.30.200.20-FF-000173', NULL, 'Probable serine/threonine-protein kinase At1g01540', 96, NULL, NULL, 58315),
(58316, '3.40.140.10-FF-000269', NULL, 'Uncharacterized protein', 95, NULL, NULL, 58316),
(58317, '1.10.510.10-FF-000458', NULL, 'Tyrosine-protein kinase', 261, NULL, NULL, 58317),
(58318, '3.40.30.10-FF-000488', NULL, 'Unplaced genomic scaffold supercont2.20, whole genome shotgun sequence', 195, NULL, NULL, 58318),
(58319, '1.10.238.10-FF-000437', NULL, 'Ede1p', 115, NULL, NULL, 58319),
(58320, '1.20.58.70-FF-000086', NULL, 'Syntaxin-12', 117, NULL, NULL, 58320),
(58321, '2.30.230.10-FF-000007', NULL, 'Apolipoprotein lipid transfer particle', 279, NULL, NULL, 58321),
(58322, '1.20.1050.10-FF-000251', NULL, 'Uncharacterized protein', 28, NULL, NULL, 58322),
(58323, '2.10.220.10-FF-000112', NULL, 'Furin-like protease 2', 68, NULL, NULL, 58323),
(58324, '3.40.50.300-FF-005291', NULL, 'Arl_A64 protein', 175, NULL, NULL, 58324),
(58325, '1.20.1310.10-FF-000119', NULL, NULL, 115, NULL, NULL, 58325),
(58326, '3.40.50.2000-FF-000483', NULL, 'Glycosyltransferase', 222, NULL, NULL, 58326);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(58327, '2.60.120.10-FF-000262', NULL, 'Homogentisate 1,2-dioxygenase', 98, NULL, NULL, 58327),
(58328, '3.40.50.20-FF-000020', NULL, 'D-alanine--D-alanine ligase', 117, NULL, NULL, 58328),
(58329, '1.25.40.20-FF-000970', NULL, 'YALI0F16940p', 165, NULL, NULL, 58329),
(58330, '3.30.450.60-FF-000006', NULL, 'AP-1 complex subunit mu-1 isoform 1', 140, NULL, NULL, 58330),
(58331, '3.80.10.10-FF-003891', NULL, 'Uncharacterized protein', 147, NULL, NULL, 58331),
(58332, '1.25.40.10-FF-000753', NULL, 'KIF1-binding protein', 216, NULL, NULL, 58332),
(58333, '1.10.10.60-FF-000827', NULL, NULL, 53, NULL, NULL, 58333),
(58334, '2.40.50.140-FF-000704', NULL, NULL, 139, NULL, NULL, 58334),
(58335, '2.30.29.30-FF-000257', NULL, 'Pleckstrin homology domain-containing family M member 3', 116, NULL, NULL, 58335),
(58336, '1.20.1250.20-FF-001758', NULL, 'Chromosome 1, whole genome shotgun sequence', 191, NULL, NULL, 58336),
(58337, '3.90.480.10-FF-000002', NULL, 'Sulfite reductase [ferredoxin]', 73, NULL, NULL, 58337),
(58338, '3.60.20.10-FF-000172', NULL, NULL, 193, NULL, NULL, 58338),
(58339, '3.90.740.10-FF-000040', NULL, 'Valine--tRNA ligase', 35, NULL, NULL, 58339),
(58340, '3.40.50.1460-FF-000056', NULL, 'Asparaginyl peptidase, putative', 151, NULL, NULL, 58340),
(58341, '2.60.120.280-FF-000002', NULL, 'Transcriptional regulator, AraC family', 120, NULL, NULL, 58341),
(58342, '3.40.50.970-FF-000079', NULL, 'Indolepyruvate ferredoxin oxidoreductase alpha subunit', 198, NULL, NULL, 58342),
(58343, '3.30.160.20-FF-000034', NULL, 'NFKB repressing factor', 80, NULL, NULL, 58343),
(58344, '3.30.590.10-FF-000013', NULL, 'Related to fluG protein', 337, NULL, NULL, 58344),
(58345, '3.40.1180.10-FF-000030', NULL, 'Tritrans,polycis-undecaprenyl-diphosphate synthase (geranylgeranyl-diphosphate specific)', 240, NULL, NULL, 58345),
(58346, '3.10.20.90-FF-000703', NULL, 'Protein DDI1 homolog', 93, NULL, NULL, 58346),
(58347, '2.170.300.10-FF-000002', NULL, 'Multiple epidermal growth factor-like domains 10', 126, NULL, NULL, 58347),
(58348, '3.40.47.10-FF-000223', NULL, NULL, 125, NULL, NULL, 58348),
(58349, '3.30.160.60-FF-004964', NULL, NULL, 29, NULL, NULL, 58349),
(58350, '3.40.50.300-FF-008045', NULL, 'Atlastin GTPase 3', 131, NULL, NULL, 58350),
(58351, '3.40.50.1820-FF-001428', NULL, 'Uncharacterized protein', 196, NULL, NULL, 58351),
(58352, '3.40.1380.10-FF-000011', NULL, 'ATP synthase subunit gamma', 217, NULL, NULL, 58352),
(58353, '3.40.50.1000-FF-000492', NULL, NULL, 65, NULL, NULL, 58353),
(58354, '1.25.10.10-FF-000021', NULL, 'Importin subunit alpha', 423, NULL, NULL, 58354),
(58355, '3.30.1010.10-FF-000082', NULL, 'Chromosome 12, whole genome shotgun sequence', 124, NULL, NULL, 58355),
(58356, '2.130.10.10-FF-004228', NULL, 'Uncharacterized protein', 145, NULL, NULL, 58356),
(58357, '1.20.1720.10-FF-000044', NULL, 'Putative multidrug resistance protein B', 205, NULL, NULL, 58357),
(58358, '3.90.190.10-FF-000194', NULL, 'Protein tyrosine phosphatase putative', 280, NULL, NULL, 58358),
(58359, '1.10.8.60-FF-000203', NULL, 'ESX-2 secretion system protein EccA2', 95, NULL, NULL, 58359),
(58360, '3.30.70.270-FF-000330', NULL, NULL, 109, NULL, NULL, 58360),
(58361, '1.20.58.860-FF-000001', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 74, NULL, NULL, 58361),
(58362, '3.40.50.620-FF-000446', NULL, 'Isoleucine--tRNA ligase', 240, NULL, NULL, 58362),
(58363, '3.40.630.10-FF-000195', NULL, 'Probable M28 family peptidase (Homolog to aminopeptidase YwaD)', 228, NULL, NULL, 58363),
(58364, '3.90.550.10-FF-000177', NULL, 'MNN5p Alpha-1,2-mannosyltransferase', 215, NULL, NULL, 58364),
(58365, '1.10.510.10-FF-001818', NULL, 'Uncharacterized protein', 278, NULL, NULL, 58365),
(58366, '3.10.260.10-FF-000010', NULL, 'Mycelial growth factor-1', 181, NULL, NULL, 58366),
(58367, '2.40.70.10-FF-000352', NULL, NULL, 147, NULL, NULL, 58367),
(58368, '2.10.25.10-FF-000608', NULL, 'Laminin subunit beta 4', 46, NULL, NULL, 58368),
(58369, '2.10.50.10-FF-000009', NULL, 'Tumor necrosis factor receptor superfamily member 14', 41, NULL, NULL, 58369);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(58370, '3.80.10.10-FF-002430', NULL, 'Leucine-rich repeat-containing 15', 120, NULL, NULL, 58370),
(58371, '1.20.1300.10-FF-000001', NULL, 'Succinate dehydrogenase hydrophobic membrane anchor subunit', 115, NULL, NULL, 58371),
(58372, '3.80.10.10-FF-001974', NULL, 'Erbb2-interacting protein', 136, NULL, NULL, 58372),
(58373, '3.30.160.60-FF-004121', NULL, NULL, 54, NULL, NULL, 58373),
(58374, '3.10.129.10-FF-000002', NULL, '1,4-dihydroxy-2-naphthoyl-CoA hydrolase', 137, NULL, NULL, 58374),
(58375, '1.10.510.10-FF-002454', NULL, NULL, 226, NULL, NULL, 58375),
(58376, '3.50.30.30-FF-000145', NULL, 'Signal peptide peptidase like 2B', 83, NULL, NULL, 58376),
(58377, '2.130.10.10-FF-005577', NULL, 'Uncharacterized protein', 207, NULL, NULL, 58377),
(58378, '3.50.50.60-FF-001032', NULL, 'N,N-dimethylglycine oxidase, putative (AFU_orthologue AFUA_8G06470)', 91, NULL, NULL, 58378),
(58379, '2.30.30.40-FF-000382', NULL, 'ABl Interactor homolog', 67, NULL, NULL, 58379),
(58380, '3.40.250.10-FF-000210', NULL, 'tRNA sulfurtransferase', 88, NULL, NULL, 58380),
(58381, '3.90.1420.10-FF-000043', NULL, 'Uncharacterized protein', 123, NULL, NULL, 58381),
(58382, '1.20.1250.20-FF-000409', NULL, 'MFS general substrate transporter', 183, NULL, NULL, 58382),
(58383, '2.30.30.30-FF-000114', NULL, 'Translation elongation factor EF-P', 64, NULL, NULL, 58383),
(58384, '3.40.50.300-FF-008096', NULL, 'RNA cytidine acetyltransferase', 112, NULL, NULL, 58384),
(58385, '2.10.220.10-FF-000163', NULL, 'CXC-rich protein', 96, NULL, NULL, 58385),
(58386, '1.20.1050.10-FF-000200', NULL, 'Glutathione S-transferase theta-2B', 162, NULL, NULL, 58386),
(58387, '3.30.40.10-FF-001815', NULL, 'Uncharacterized protein', 90, NULL, NULL, 58387),
(58388, '3.20.140.10-FF-000038', NULL, 'Nicotinate phosphoribosyltransferase', 155, NULL, NULL, 58388),
(58389, '1.25.40.10-FF-004935', NULL, 'Uncharacterized protein', 204, NULL, NULL, 58389),
(58390, '3.40.50.300-FF-006600', NULL, 'Uncharacterized protein', 97, NULL, NULL, 58390),
(58391, '1.10.472.10-FF-000144', NULL, 'Cyclin 4', 101, NULL, NULL, 58391),
(58392, '3.60.10.10-FF-000295', NULL, 'Inositol-1,4,5-trisphosphate 5-phosphatase 2', 343, NULL, NULL, 58392),
(58393, '2.130.10.10-FF-001474', NULL, 'Cleavage and polyadenylation specificity factor-like protein', 401, NULL, NULL, 58393),
(58394, '1.25.40.10-FF-002198', NULL, 'DNA polymerase interacting tpr containing protein of 47kD, isoform A', 161, NULL, NULL, 58394),
(58395, '1.10.10.10-FF-000341', NULL, 'Forkhead box protein N2', 100, NULL, NULL, 58395),
(58396, '1.25.40.500-FF-000002', NULL, 'TAF5-like RNA polymerase II p300/CBP-associated factor-associated factor 65 kDa subunit 5L', 157, NULL, NULL, 58396),
(58397, '1.10.10.10-FF-000453', NULL, 'Transcriptional regulator, RpiR family', 77, NULL, NULL, 58397),
(58398, '1.10.287.70-FF-000456', NULL, 'Glutamate receptor', 122, NULL, NULL, 58398),
(58399, '2.60.40.10-FF-000361', NULL, 'versican core protein-like', 129, NULL, NULL, 58399),
(58400, '2.10.10.20-FF-000004', NULL, 'Peptidase M28', 43, NULL, NULL, 58400),
(58401, '3.40.50.1010-FF-000270', NULL, NULL, 139, NULL, NULL, 58401),
(58402, '3.40.50.300-FF-003374', NULL, 'Ribose ABC transporter ATP-binding protein', 228, NULL, NULL, 58402),
(58403, '2.30.110.20-FF-000001', NULL, 'Type VI secretion system effector', 162, NULL, NULL, 58403),
(58404, '1.10.287.130-FF-000036', NULL, 'Two-component sensor histidine kinase', 70, NULL, NULL, 58404),
(58405, '2.30.130.40-FF-000019', NULL, 'Lon protease', 115, NULL, NULL, 58405),
(58406, '3.20.20.80-FF-000273', NULL, 'Glucan endo-1,3-beta-glucosidase 1', 166, NULL, NULL, 58406),
(58407, '1.50.40.10-FF-000509', NULL, 'Uncharacterized protein', 301, NULL, NULL, 58407),
(58408, '2.60.40.1660-FF-000016', NULL, 'Uncharacterized protein', 140, NULL, NULL, 58408),
(58409, '3.20.20.70-FF-000848', NULL, NULL, 81, NULL, NULL, 58409),
(58410, '3.30.43.40-FF-000004', NULL, 'Pre-mRNA processing factor 8', 52, NULL, NULL, 58410),
(58411, '3.30.160.60-FF-004172', NULL, NULL, 30, NULL, NULL, 58411),
(58412, '3.30.1330.40-FF-000002', NULL, 'Endoribonuclease L-PSP family protein', 114, NULL, NULL, 58412);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(58413, '2.130.10.10-FF-004380', NULL, 'Predicted protein', 76, NULL, NULL, 58413),
(58414, '2.60.40.2840-FF-000005', NULL, 'inositol polyphosphate 5-phosphatase K', 106, NULL, NULL, 58414),
(58415, '1.50.40.10-FF-000009', NULL, 'Mitochondrial 2-oxoglutarate/malate carrier protein', 288, NULL, NULL, 58415),
(58416, '1.20.144.10-FF-000037', NULL, 'Phosphatidic acid phosphatase protein-like protein', 161, NULL, NULL, 58416),
(58417, '3.30.70.141-FF-000028', NULL, 'NME/NM23 family member 5', 153, NULL, NULL, 58417),
(58418, '3.80.10.10-FF-000985', NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', 107, NULL, NULL, 58418),
(58419, '3.30.930.10-FF-000034', NULL, 'Serine--tRNA ligase', 316, NULL, NULL, 58419),
(58420, '1.25.10.10-FF-001010', NULL, 'Tubulin folding cofactor D', 200, NULL, NULL, 58420),
(58421, '3.40.50.800-FF-000056', NULL, 'Prolyl-tRNA synthetase, putative', 121, NULL, NULL, 58421),
(58422, '1.10.220.150-FF-000003', NULL, 'ARF GTPase-activating protein GIT2 isoform 1', 116, NULL, NULL, 58422),
(58423, '1.10.510.10-FF-000829', NULL, 'Serine/threonine-protein kinase TOS3', 373, NULL, NULL, 58423),
(58424, '3.30.40.10-FF-000394', NULL, 'Histone-lysine N-methyltransferase', 55, NULL, NULL, 58424),
(58425, '1.25.40.10-FF-002939', NULL, 'Predicted protein', 207, NULL, NULL, 58425),
(58426, '3.40.50.300-FF-008157', NULL, 'Uncharacterized protein', 91, NULL, NULL, 58426),
(58427, '2.60.40.10-FF-000310', NULL, 'Down syndrome cell adhesion molecule, isoform D', 104, NULL, NULL, 58427),
(58428, '1.25.40.10-FF-000641', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 119, NULL, NULL, 58428),
(58429, '3.40.50.300-FF-002385', NULL, 'Predicted protein', 273, NULL, NULL, 58429),
(58430, '3.30.160.60-FF-002608', NULL, 'Zinc finger protein 337', 28, NULL, NULL, 58430),
(58431, '3.90.226.10-FF-000351', NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', 66, NULL, NULL, 58431),
(58432, '3.30.160.60-FF-001187', NULL, 'Zinc finger protein 599', 28, NULL, NULL, 58432),
(58433, '1.10.238.10-FF-000325', NULL, 'EF-hand calcium binding domain 6', 181, NULL, NULL, 58433),
(58434, '3.30.450.220-FF-000002', NULL, 'Autoinducer 2 sensor kinase/phosphatase LuxQ', 157, NULL, NULL, 58434),
(58435, '3.30.160.60-FF-000698', NULL, 'Zinc finger with KRAB and SCAN domains 7', 28, NULL, NULL, 58435),
(58436, '3.30.40.10-FF-002304', NULL, 'Uncharacterized protein', 115, NULL, NULL, 58436),
(58437, '3.40.50.300-FF-001749', NULL, 'P-loop containing nucleoside triphosphate hydrolase', 204, NULL, NULL, 58437),
(58438, '3.10.290.10-FF-000079', NULL, 'Uncharacterized RNA pseudouridine synthase slr1629', 62, NULL, NULL, 58438),
(58439, '1.20.1070.10-FF-001562', NULL, 'Adhesion G protein-coupled receptor V1', 170, NULL, NULL, 58439),
(58440, '3.80.10.10-FF-004307', NULL, 'Uncharacterized protein', 216, NULL, NULL, 58440),
(58441, '2.160.20.60-FF-000010', NULL, 'Putative formylmethanofurane dehydrogenase subunit', 75, NULL, NULL, 58441),
(58442, '3.15.20.10-FF-000023', NULL, 'Uncharacterized protein', 85, NULL, NULL, 58442),
(58443, '3.40.50.970-FF-000028', NULL, 'Transketolase isoform 1', 194, NULL, NULL, 58443),
(58444, '2.40.30.270-FF-000003', NULL, 'DNA-binding protein SMUBP-2 isoform X2', 132, NULL, NULL, 58444),
(58445, '3.90.640.10-FF-000055', NULL, 'Actin-related protein 8', 155, NULL, NULL, 58445),
(58446, '3.10.110.10-FF-000235', NULL, 'AFR314Wp', 152, NULL, NULL, 58446),
(58447, '1.20.1310.20-FF-000027', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 244, NULL, NULL, 58447),
(58448, '1.10.10.10-FF-000392', NULL, 'FEV, ETS transcription factor', 112, NULL, NULL, 58448),
(58449, '3.30.559.70-FF-000031', NULL, 'Choline oacetyltransferase, putative', 65, NULL, NULL, 58449),
(58450, '3.40.50.150-FF-001002', NULL, NULL, 206, NULL, NULL, 58450),
(58451, '1.25.40.10-FF-000702', NULL, 'Trafficking protein particle complex subunit 12', 171, NULL, NULL, 58451),
(58452, '3.80.10.10-FF-001474', NULL, 'Piriformospora indica-insensitive protein 2', 274, NULL, NULL, 58452),
(58453, '1.20.1110.10-FF-000189', NULL, NULL, 154, NULL, NULL, 58453);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(58454, '3.50.30.40-FF-000002', NULL, '4-carboxy-4-hydroxy-2-oxoadipate aldolase/oxaloacetate decarboxylase', 194, NULL, NULL, 58454),
(58455, '3.20.20.60-FF-000115', NULL, 'Pyruvate kinase', 232, NULL, NULL, 58455),
(58456, '2.30.30.40-FF-000331', NULL, 'Signal transducing adapter molecule 1', 73, NULL, NULL, 58456),
(58457, '3.40.50.300-FF-007056', NULL, 'ATP-binding cassette protein', 197, NULL, NULL, 58457),
(58458, '2.60.120.10-FF-000666', NULL, 'RmlC-like cupins superfamily protein', 113, NULL, NULL, 58458),
(58459, '1.10.20.40-FF-000002', NULL, 'Diaphanous, isoform C', 53, NULL, NULL, 58459),
(58460, '1.10.340.70-FF-000036', NULL, 'Uncharacterized protein', 95, NULL, NULL, 58460),
(58461, '3.30.365.10-FF-000001', NULL, 'Xanthine dehydrogenase oxidase', 96, NULL, NULL, 58461),
(58462, '3.30.565.10-FF-000533', NULL, 'Peroxide stress-activated histidine kinase mak3', 169, NULL, NULL, 58462),
(58463, '3.50.50.60-FF-000043', NULL, 'Putative dihydrolipoyl dehydrogenase', 128, NULL, NULL, 58463),
(58464, '3.30.1330.60-FF-000008', NULL, 'Outer membrane protein OmpA', 142, NULL, NULL, 58464),
(58465, '3.40.50.12160-FF-000011', NULL, 'CDK5 regulatory subunit associated protein 1-like 1', 34, NULL, NULL, 58465),
(58466, '3.40.50.11030-FF-000009', NULL, 'Threonylcarbamoyl-AMP synthase', 144, NULL, NULL, 58466),
(58467, '1.20.5.190-FF-000053', NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', 41, NULL, NULL, 58467),
(58468, '3.30.160.60-FF-002547', NULL, NULL, 28, NULL, NULL, 58468),
(58469, '2.60.40.10-FF-005032', NULL, NULL, 104, NULL, NULL, 58469),
(58470, '3.30.300.20-FF-000006', NULL, '40S ribosomal protein S3', 92, NULL, NULL, 58470),
(58471, '3.40.50.670-FF-000028', NULL, 'Uncharacterized protein', 44, NULL, NULL, 58471),
(58472, '3.30.450.60-FF-000057', NULL, 'Probable coatomer subunit zeta-A', 149, NULL, NULL, 58472),
(58473, '3.30.160.60-FF-000310', NULL, 'GLIS family zinc finger 2', 31, NULL, NULL, 58473),
(58474, '3.30.70.3270-FF-000017', NULL, '4Fe-4S ferredoxin iron-sulfur binding domain protein', 148, NULL, NULL, 58474),
(58475, '3.40.50.620-FF-000558', NULL, '7-cyano-7-deazaguanine synthase', 220, NULL, NULL, 58475),
(58476, '1.20.900.10-FF-000003', NULL, 'Rho guanine nucleotide exchange factor 10 like', 214, NULL, NULL, 58476),
(58477, '2.40.50.140-FF-001211', NULL, NULL, 82, NULL, NULL, 58477),
(58478, '1.10.472.10-FF-000644', NULL, 'Uncharacterized protein', 129, NULL, NULL, 58478),
(58479, '3.30.1890.10-FF-000007', NULL, 'Chain-length determining protein', 160, NULL, NULL, 58479),
(58480, '4.10.60.10-FF-000101', NULL, 'Serine/arginine-rich splicing factor RSZ21A isoform C', 74, NULL, NULL, 58480),
(58481, '1.10.10.10-FF-001701', NULL, 'Rubisco operon transcriptional regulator', 91, NULL, NULL, 58481),
(58482, '3.90.280.10-FF-000021', NULL, NULL, 204, NULL, NULL, 58482),
(58483, '1.10.506.10-FF-000078', NULL, 'Plexin C1', 178, NULL, NULL, 58483),
(58484, '1.20.930.20-FF-000013', NULL, 'Mixed lineage kinase domain like pseudokinase', 117, NULL, NULL, 58484),
(58485, '2.120.10.80-FF-000343', NULL, 'Uncharacterized protein', 114, NULL, NULL, 58485),
(58486, '1.20.930.40-FF-000019', NULL, 'Predicted protein', 92, NULL, NULL, 58486),
(58487, '3.30.1330.30-FF-000084', NULL, 'SECIS (SeCis) Binding Protein homolog', 94, NULL, NULL, 58487),
(58488, '1.10.238.10-FF-000376', NULL, 'CAMK/CDPK protein kinase', 176, NULL, NULL, 58488),
(58489, '1.10.510.10-FF-000930', NULL, 'Blast:Serine/threonine-protein kinase PINK1, mitochondrial', 264, NULL, NULL, 58489),
(58490, '1.25.40.20-FF-001307', NULL, 'Uncharacterized protein', 149, NULL, NULL, 58490),
(58491, '3.80.10.10-FF-004228', NULL, 'Uncharacterized protein', 80, NULL, NULL, 58491),
(58492, '3.40.50.1580-FF-000007', NULL, 'Purine nucleoside phosphorylase', 267, NULL, NULL, 58492),
(58493, '3.40.50.620-FF-000507', NULL, 'Cryptochrome DASH', 139, NULL, NULL, 58493),
(58494, '1.25.10.10-FF-000521', NULL, 'ARM repeat superfamily protein', 150, NULL, NULL, 58494),
(58495, '3.30.430.20-FF-000010', NULL, 'Cysteine-rich receptor-like protein kinase 10', 106, NULL, NULL, 58495);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(58496, '3.40.50.300-FF-006651', NULL, 'Uncharacterized protein', 87, NULL, NULL, 58496),
(58497, '1.25.40.10-FF-002147', NULL, 'Pentatricopeptide repeat-containing protein', 97, NULL, NULL, 58497),
(58498, '3.90.190.10-FF-000126', NULL, 'Metal ion binding/oxidoreductase', 243, NULL, NULL, 58498),
(58499, '3.80.10.10-FF-000193', NULL, 'Leucine-rich repeat-containing protein 40', 213, NULL, NULL, 58499),
(58500, '1.25.40.760-FF-000001', NULL, 'Nonsense-mediated mRNA decay protein', 207, NULL, NULL, 58500),
(58501, '3.40.50.2300-FF-000044', NULL, 'Two-component system response regulator NarL', 127, NULL, NULL, 58501),
(58502, '2.40.10.330-FF-000001', NULL, 'Peptidyl-prolyl cis-trans isomerase', 43, NULL, NULL, 58502),
(58503, '3.40.50.720-FF-002275', NULL, 'Predicted protein', 25, NULL, NULL, 58503),
(58504, '3.10.450.50-FF-000047', NULL, 'Aklanonic acid methyl ester cyclase AcmA', 153, NULL, NULL, 58504),
(58505, '1.20.1540.10-FF-000007', NULL, 'Rhomboid like 2', 194, NULL, NULL, 58505),
(58506, '3.40.50.720-FF-001370', NULL, '2-hydroxyacid dehydrogenase', 102, NULL, NULL, 58506),
(58507, '3.10.450.50-FF-000098', NULL, 'MIP14975p', 89, NULL, NULL, 58507),
(58508, '6.20.10.30-FF-000003', NULL, 'DNA ligase', 40, NULL, NULL, 58508),
(58509, '3.80.10.10-FF-002042', NULL, 'Acid labile subunit', 113, NULL, NULL, 58509),
(58510, '2.10.110.10-FF-000042', NULL, 'lipoma-preferred partner isoform X1', 77, NULL, NULL, 58510),
(58511, '3.20.20.10-FF-000033', NULL, 'Alanine racemase', 215, NULL, NULL, 58511),
(58512, '3.30.470.10-FF-000015', NULL, 'Branched-chain-amino-acid aminotransferase', 128, NULL, NULL, 58512),
(58513, '3.30.160.60-FF-001266', NULL, 'Zinc finger protein 662', 28, NULL, NULL, 58513),
(58514, '3.40.50.300-FF-000468', NULL, 'ATP-dependent RNA helicase RhlE', 182, NULL, NULL, 58514),
(58515, '2.60.110.10-FF-000025', NULL, 'Thaumatin-like protein 1', 150, NULL, NULL, 58515),
(58516, '1.20.1250.20-FF-001837', NULL, 'Uncharacterized protein', 140, NULL, NULL, 58516),
(58517, '2.10.70.10-FF-000123', NULL, 'Coagulation factor XIII B chain', 67, NULL, NULL, 58517),
(58518, '3.90.79.10-FF-000081', NULL, '54S ribosomal protein L17, mitochondrial', 126, NULL, NULL, 58518),
(58519, '3.30.70.850-FF-000015', NULL, 'Proprotein convertase subtilisin/kexin type 5', 89, NULL, NULL, 58519),
(58520, '1.20.910.10-FF-000009', NULL, 'Aminopyrimidine aminohydrolase', 224, NULL, NULL, 58520),
(58521, '3.40.50.1820-FF-001075', NULL, 'Endo-1,4-beta-xylanase Z', 265, NULL, NULL, 58521),
(58522, '3.30.365.10-FF-000052', NULL, 'Uncharacterized protein', 32, NULL, NULL, 58522),
(58523, '3.80.10.10-FF-000013', NULL, 'Erbin isoform 7', 93, NULL, NULL, 58523),
(58524, '3.30.200.20-FF-002090', NULL, 'Uncharacterized protein', 81, NULL, NULL, 58524),
(58525, '1.20.120.530-FF-000008', NULL, 'GntR family transcriptional regulator', 148, NULL, NULL, 58525),
(58526, '1.10.3710.10-FF-000001', NULL, 'Replication-associated recombination protein A', 102, NULL, NULL, 58526),
(58527, '1.20.5.560-FF-000001', NULL, NULL, 33, NULL, NULL, 58527),
(58528, '2.60.120.200-FF-000473', NULL, 'Uncharacterized protein', 159, NULL, NULL, 58528),
(58529, '3.30.930.10-FF-000113', NULL, 'eIF-2-alpha kinase GCN2', 346, NULL, NULL, 58529),
(58530, '1.10.3660.10-FF-000019', NULL, 'Uncharacterized protein', 118, NULL, NULL, 58530),
(58531, '3.50.70.10-FF-000001', NULL, 'Fatty-acid-binding protein 1', 146, NULL, NULL, 58531),
(58532, '2.60.40.10-FF-002047', NULL, 'Mesocentin', 96, NULL, NULL, 58532),
(58533, '1.25.40.10-FF-000692', NULL, 'Pentatricopeptide repeat-containing protein At3g13880', 128, NULL, NULL, 58533),
(58534, '2.10.25.10-FF-000255', NULL, 'Sushi, nidogen and EGF-like domains 1', 39, NULL, NULL, 58534),
(58535, '1.10.357.120-FF-000016', NULL, 'DNA-directed RNA polymerase subunit', 117, NULL, NULL, 58535),
(58536, '3.20.20.140-FF-000042', NULL, 'Isoaspartyl dipeptidase', 279, NULL, NULL, 58536),
(58537, '3.40.50.1820-FF-000939', NULL, 'Acetylcholinesterase', 545, NULL, NULL, 58537),
(58538, '3.30.1380.20-FF-000027', NULL, 'Uncharacterized protein', 70, NULL, NULL, 58538);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(58539, '1.20.1070.10-FF-002000', NULL, 'Uncharacterized protein', 144, NULL, NULL, 58539),
(58540, '1.20.58.70-FF-000018', NULL, 'SNARE domain protein', 122, NULL, NULL, 58540),
(58541, '3.30.40.10-FF-000798', NULL, 'RING finger protein 121', 60, NULL, NULL, 58541),
(58542, '1.10.10.820-FF-000006', NULL, 'Myosin IIIA', 65, NULL, NULL, 58542),
(58543, '1.10.506.10-FF-000027', NULL, 'Plexin A, isoform B', 242, NULL, NULL, 58543),
(58544, '1.25.10.10-FF-000572', NULL, 'Importin 5', 649, NULL, NULL, 58544),
(58545, '3.40.50.1820-FF-000911', NULL, 'Predicted protein', 161, NULL, NULL, 58545),
(58546, '2.20.25.20-FF-000004', NULL, 'RBR-type E3 ubiquitin transferase', 52, NULL, NULL, 58546),
(58547, '2.60.40.10-FF-002098', NULL, 'Immunoglobulin heavy variable 3-72', 106, NULL, NULL, 58547),
(58548, '3.40.47.10-FF-000291', NULL, NULL, 53, NULL, NULL, 58548),
(58549, '3.40.640.10-FF-000021', NULL, 'Glutamate-1-semialdehyde 2,1-aminomutase', 249, NULL, NULL, 58549),
(58550, '3.30.559.30-FF-000047', NULL, 'Plipastatin synthase subunit A', 224, NULL, NULL, 58550),
(58551, '1.20.20.10-FF-000026', NULL, 'ATP synthase subunit 9, mitochondrial', 74, NULL, NULL, 58551),
(58552, '1.20.5.780-FF-000016', NULL, 'FXYD domain-containing ion transport regulator', 74, NULL, NULL, 58552),
(58553, '1.20.1070.10-FF-000926', NULL, 'Uncharacterized protein', 375, NULL, NULL, 58553),
(58554, '3.30.360.10-FF-000125', NULL, 'Uncharacterized protein', 39, NULL, NULL, 58554),
(58555, '3.40.50.300-FF-001036', NULL, 'SWI/SNF related, matrix associated, actin dependent regulator of chromatin, subfamily a like 1', 254, NULL, NULL, 58555),
(58556, '4.10.860.10-FF-000001', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 53, NULL, NULL, 58556),
(58557, '3.20.20.80-FF-000301', NULL, 'Os03g0323350 protein', 101, NULL, NULL, 58557),
(58558, '1.10.510.10-FF-003735', NULL, NULL, 150, NULL, NULL, 58558),
(58559, '3.30.70.330-FF-000388', NULL, 'RNA-binding protein 24-B isoform X1', 108, NULL, NULL, 58559),
(58560, '1.20.58.60-FF-000549', NULL, 'Uncharacterized protein', 295, NULL, NULL, 58560),
(58561, '3.90.70.10-FF-000792', NULL, 'Uncharacterized protein', 327, NULL, NULL, 58561),
(58562, '3.30.1540.20-FF-000001', NULL, 'DNA mismatch repair endonuclease MutL', 82, NULL, NULL, 58562),
(58563, '3.40.570.10-FF-000026', NULL, 'Uncharacterized protein', 267, NULL, NULL, 58563),
(58564, '3.40.50.150-FF-000546', NULL, 'Phosphoethanolamine MethylTransferase', 264, NULL, NULL, 58564),
(58565, '1.20.1110.10-FF-000138', NULL, NULL, 21, NULL, NULL, 58565),
(58566, '1.25.40.10-FF-002439', NULL, 'Putative pentatricopeptide repeat-containing protein', 107, NULL, NULL, 58566),
(58567, '3.40.250.10-FF-000098', NULL, '3-mercaptopyruvate sulfurtransferase', 141, NULL, NULL, 58567),
(58568, '1.10.150.20-FF-000271', NULL, 'Uncharacterized protein', 46, NULL, NULL, 58568),
(58569, '2.60.120.580-FF-000002', NULL, 'Formamidase FmdS', 132, NULL, NULL, 58569),
(58570, '3.40.720.10-FF-000022', NULL, 'Phosphoethanolamine transferase eptA', 331, NULL, NULL, 58570),
(58571, '1.25.40.20-FF-000582', NULL, 'Os11g0435300 protein', 62, NULL, NULL, 58571),
(58572, '1.25.40.20-FF-001487', NULL, 'Putative huntingtin interacting protein (HIP)', 87, NULL, NULL, 58572),
(58573, '3.30.160.60-FF-000198', NULL, 'zinc finger protein 10 isoform X1', 28, NULL, NULL, 58573),
(58574, '3.90.320.10-FF-000008', NULL, 'ATP-dependent helicase/nuclease subunit A', 242, NULL, NULL, 58574),
(58575, '3.40.30.10-FF-000128', NULL, 'endoplasmic reticulum resident protein 44', 101, NULL, NULL, 58575),
(58576, '3.40.50.10330-FF-000069', NULL, 'Diacylglycerol kinase', 126, NULL, NULL, 58576),
(58577, '1.20.5.990-FF-000012', NULL, 'Muscle myosin heavy chain, putative', 89, NULL, NULL, 58577),
(58578, '1.10.510.10-FF-003443', NULL, NULL, 280, NULL, NULL, 58578),
(58579, '3.30.1540.20-FF-000029', NULL, NULL, 69, NULL, NULL, 58579),
(58580, '1.10.10.60-FF-000895', NULL, 'Chromatin remodeling factor CHD3 (PICKLE)', 138, NULL, NULL, 58580),
(58581, '3.40.50.150-FF-000838', NULL, 'Methyltransferase FkbM family', 197, NULL, NULL, 58581);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(58582, '2.60.260.20-FF-000033', NULL, 'DnaJ family protein', 84, NULL, NULL, 58582),
(58583, '3.30.160.60-FF-004525', NULL, NULL, 29, NULL, NULL, 58583),
(58584, '3.30.505.10-FF-000092', NULL, 'SH2 domain containing 1B', 104, NULL, NULL, 58584),
(58585, '1.25.10.10-FF-002319', NULL, 'Uncharacterized protein', 311, NULL, NULL, 58585),
(58586, '3.30.200.20-FF-000914', NULL, 'Cytoplasmic export protein', 90, NULL, NULL, 58586),
(58587, '3.10.100.10-FF-000358', NULL, NULL, 50, NULL, NULL, 58587),
(58588, '2.60.40.1090-FF-000008', NULL, 'Fimbrial major subunit StfA', 156, NULL, NULL, 58588),
(58589, '3.30.200.20-FF-001550', NULL, NULL, 100, NULL, NULL, 58589),
(58590, '3.30.230.10-FF-000413', NULL, 'Uncharacterized protein', 130, NULL, NULL, 58590),
(58591, '1.20.1250.20-FF-000477', NULL, 'MFS monosaccharide transporter (Hxt8), putative', 458, NULL, NULL, 58591),
(58592, '1.10.287.70-FF-000748', NULL, 'Glutamate receptor, putative', 81, NULL, NULL, 58592),
(58593, '3.40.50.2300-FF-001421', NULL, NULL, 41, NULL, NULL, 58593),
(58594, '2.60.40.10-FF-004576', NULL, NULL, 95, NULL, NULL, 58594),
(58595, '3.30.70.330-FF-001669', NULL, NULL, 103, NULL, NULL, 58595),
(58596, '2.130.10.10-FF-005285', NULL, 'Uncharacterized protein', 228, NULL, NULL, 58596),
(58597, '3.30.70.20-FF-000044', NULL, 'Ion-translocating oxidoreductase complex subunit C', 75, NULL, NULL, 58597),
(58598, '3.40.50.1000-FF-000441', NULL, 'Phospholipid-transporting ATPase', 83, NULL, NULL, 58598),
(58599, '2.10.109.10-FF-000056', NULL, 'Signal peptidase', 120, NULL, NULL, 58599),
(58600, '3.40.50.1820-FF-001816', NULL, 'Uncharacterized protein', 105, NULL, NULL, 58600),
(58601, '1.10.472.10-FF-000032', NULL, 'G2/mitotic-specific cyclin-1', 128, NULL, NULL, 58601),
(58602, '2.40.70.10-FF-000240', NULL, 'Acid protease', 193, NULL, NULL, 58602),
(58603, '1.20.120.1760-FF-000069', NULL, NULL, 227, NULL, NULL, 58603),
(58604, '1.25.40.10-FF-005020', NULL, 'Predicted protein', 109, NULL, NULL, 58604),
(58605, '1.25.40.180-FF-000187', NULL, 'MA3 domain containing protein, putative', 252, NULL, NULL, 58605),
(58606, '3.30.565.10-FF-000449', NULL, 'DNA mismatch repair protein PMS1', 211, NULL, NULL, 58606),
(58607, '3.30.460.10-FF-000189', NULL, 'Uncharacterized protein', 157, NULL, NULL, 58607),
(58608, '3.30.1370.60-FF-000005', NULL, NULL, 211, NULL, NULL, 58608),
(58609, '2.60.40.10-FF-000653', NULL, 'Follistatin like 4', 95, NULL, NULL, 58609),
(58610, '2.30.30.40-FF-000090', NULL, 'E3 ubiquitin-protein ligase MIB1 isoform X1', 74, NULL, NULL, 58610),
(58611, '1.20.1530.20-FF-000010', NULL, 'Solute carrier family 10 member 6', 294, NULL, NULL, 58611),
(58612, '3.40.50.300-FF-008449', NULL, 'Predicted protein', 59, NULL, NULL, 58612),
(58613, '1.20.140.100-FF-000046', NULL, 'Dynein heavy chain, cytosolic, putative', 167, NULL, NULL, 58613),
(58614, '2.40.50.100-FF-000058', NULL, 'ABC sugar transporter, ATP-binding subunit', 52, NULL, NULL, 58614),
(58615, '2.130.10.10-FF-002463', NULL, 'Transducin beta protein 3', 133, NULL, NULL, 58615),
(58616, '3.30.420.10-FF-000243', NULL, 'Uncharacterized protein', 181, NULL, NULL, 58616),
(58617, '1.10.510.10-FF-002375', NULL, NULL, 148, NULL, NULL, 58617),
(58618, '3.40.190.10-FF-000660', NULL, 'ABC transporter substrate-binding protein', 124, NULL, NULL, 58618),
(58619, '3.20.20.140-FF-000334', NULL, 'Uncharacterized protein', 59, NULL, NULL, 58619),
(58620, '3.80.10.10-FF-001553', NULL, 'AGAP001807-PA', 157, NULL, NULL, 58620),
(58621, '3.30.70.330-FF-002107', NULL, NULL, 116, NULL, NULL, 58621),
(58622, '3.30.70.330-FF-001618', NULL, NULL, 91, NULL, NULL, 58622),
(58623, '1.10.287.70-FF-000799', NULL, 'Uncharacterized protein', 121, NULL, NULL, 58623),
(58624, '2.60.40.640-FF-000056', NULL, 'Vacuolar protein sorting/targeting protein VPS26', 133, NULL, NULL, 58624),
(58625, '1.25.40.10-FF-003507', NULL, 'TPR Domain containing protein', 220, NULL, NULL, 58625),
(58626, '1.20.1260.80-FF-000006', NULL, 'Uncharacterized protein', 192, NULL, NULL, 58626),
(58627, '1.10.510.10-FF-001886', NULL, 'Uncharacterized protein', 252, NULL, NULL, 58627);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(58628, '3.40.850.10-FF-000508', NULL, 'Kinesin-like protein', 171, NULL, NULL, 58628),
(58629, '3.80.10.10-FF-003739', NULL, 'Uncharacterized protein', 131, NULL, NULL, 58629),
(58630, '1.10.10.2670-FF-000005', NULL, 'Uncharacterized protein, isoform A', 102, NULL, NULL, 58630),
(58631, '1.25.10.70-FF-000011', NULL, 'Nucleoporin nup184', 285, NULL, NULL, 58631),
(58632, '1.20.1250.20-FF-002326', NULL, 'Organic cation/carnitine transporter 7', 216, NULL, NULL, 58632),
(58633, '2.30.29.30-FF-001325', NULL, 'Zinc finger protein, putative', 64, NULL, NULL, 58633),
(58634, '1.20.1270.60-FF-000232', NULL, 'Uncharacterized protein', 249, NULL, NULL, 58634),
(58635, '2.130.10.10-FF-001362', NULL, 'WD repeat-containing protein 70', 134, NULL, NULL, 58635),
(58636, '2.40.320.10-FF-000012', NULL, 'Thiamine triphosphatase', 216, NULL, NULL, 58636),
(58637, '3.40.50.720-FF-001931', NULL, 'Chromosome 8, whole genome shotgun sequence', 288, NULL, NULL, 58637),
(58638, '2.60.120.920-FF-000188', NULL, 'Si:dkey-23n7.10', 92, NULL, NULL, 58638),
(58639, '2.60.120.200-FF-000085', NULL, 'collagen alpha-1(XXVII) chain isoform X1', 213, NULL, NULL, 58639),
(58640, '1.25.40.10-FF-004795', NULL, 'Uncharacterized protein', 173, NULL, NULL, 58640),
(58641, '1.20.1070.10-FF-000134', NULL, 'proto-oncogene Mas', 307, NULL, NULL, 58641),
(58642, '3.40.50.2300-FF-001472', NULL, NULL, 148, NULL, NULL, 58642),
(58643, '2.60.60.20-FF-000022', NULL, 'Uncharacterized protein', 121, NULL, NULL, 58643),
(58644, '2.60.40.10-FF-000602', NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein', 95, NULL, NULL, 58644),
(58645, '1.20.1250.10-FF-000019', NULL, 'Interleukin 20', 158, NULL, NULL, 58645),
(58646, '1.20.900.10-FF-000071', NULL, 'Phosphatidylinositol 3,4,5-trisphosphate-dependent Rac exchanger 2 protein isoform a', 41, NULL, NULL, 58646),
(58647, '1.10.8.60-FF-000315', NULL, 'Chromosome 12, whole genome shotgun sequence', 93, NULL, NULL, 58647),
(58648, '3.30.160.20-FF-000085', NULL, 'Peptidyl-tRNA hydrolase ICT1, putative', 145, NULL, NULL, 58648),
(58649, '2.60.40.10-FF-003115', NULL, 'Plexin B, isoform B', 136, NULL, NULL, 58649),
(58650, '3.30.160.60-FF-001215', NULL, 'Zinc finger 202 m1', 27, NULL, NULL, 58650),
(58651, '3.40.50.300-FF-002317', NULL, 'ADP-ribosylation factor, putative', 198, NULL, NULL, 58651),
(58652, '2.40.240.10-FF-000011', NULL, 'Glutamine--tRNA ligase cytoplasmic', 86, NULL, NULL, 58652),
(58653, '1.20.1090.10-FF-000017', NULL, 'Alcohol dehydrogenase lateral transfer candidate', 200, NULL, NULL, 58653),
(58654, '2.160.20.10-FF-000309', NULL, 'Uncharacterized protein', 138, NULL, NULL, 58654),
(58655, '1.20.140.10-FF-000091', NULL, 'Acyl-CoA dehydrogenase short/branched chain', 21, NULL, NULL, 58655),
(58656, '2.10.110.10-FF-000334', NULL, 'Predicted protein', 53, NULL, NULL, 58656),
(58657, '2.60.40.10-FF-002839', NULL, 'Uncharacterized protein', 100, NULL, NULL, 58657),
(58658, '2.60.40.10-FF-004525', NULL, NULL, 56, NULL, NULL, 58658),
(58659, '3.80.10.10-FF-000917', NULL, 'Si:dkey-26m3.3', 63, NULL, NULL, 58659),
(58660, '3.40.1280.10-FF-000026', NULL, 'Ribosomal RNA small subunit methyltransferase E', 163, NULL, NULL, 58660),
(58661, '3.20.20.80-FF-000352', NULL, 'Predicted protein', 260, NULL, NULL, 58661),
(58662, '1.25.40.10-FF-005071', NULL, 'Pentatricopeptide repeat-containing protein At3g49170, chloroplastic', 97, NULL, NULL, 58662),
(58663, '2.60.40.820-FF-000054', NULL, 'Uncharacterized protein', 101, NULL, NULL, 58663),
(58664, '2.40.50.140-FF-000755', NULL, NULL, 139, NULL, NULL, 58664),
(58665, '3.40.50.300-FF-005139', NULL, 'Uncharacterized protein', 237, NULL, NULL, 58665),
(58666, '1.10.238.10-FF-000033', NULL, 'Troponin C, slow skeletal and cardiac muscles', 159, NULL, NULL, 58666),
(58667, '2.60.40.420-FF-000254', NULL, 'Predicted protein', 102, NULL, NULL, 58667),
(58668, '3.90.1310.10-FF-000001', NULL, 'Peptidoglycan D,D-transpeptidase MrdA', 105, NULL, NULL, 58668),
(58669, '3.40.50.410-FF-000321', NULL, 'Uncharacterized protein', 86, NULL, NULL, 58669);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(58670, '3.30.160.60-FF-005077', NULL, NULL, 33, NULL, NULL, 58670),
(58671, '3.40.190.10-FF-000559', NULL, 'LysR family transcriptional regulator', 77, NULL, NULL, 58671),
(58672, '2.60.40.60-FF-000235', NULL, 'Dachsous cadherin-related 1', 107, NULL, NULL, 58672),
(58673, '1.25.40.820-FF-000031', NULL, 'Uncharacterized protein', 153, NULL, NULL, 58673),
(58674, '3.30.40.10-FF-002243', NULL, 'Uncharacterized protein', 61, NULL, NULL, 58674),
(58675, '2.40.50.100-FF-000030', NULL, 'Macrolide transporter subunit MacA', 65, NULL, NULL, 58675),
(58676, '3.30.310.40-FF-000018', NULL, 'Uncharacterized protein', 94, NULL, NULL, 58676),
(58677, '3.50.50.60-FF-000604', NULL, 'Ferredoxin NADP+ reductase-like protein', 249, NULL, NULL, 58677),
(58678, '1.20.81.30-FF-000004', NULL, 'Toxin co-regulated pilus biosynthesis protein E', 113, NULL, NULL, 58678),
(58679, '2.30.39.10-FF-000095', NULL, 'Serpin 7', 146, NULL, NULL, 58679),
(58680, '3.40.50.11660-FF-000024', NULL, 'Uncharacterized protein', 218, NULL, NULL, 58680),
(58681, '3.40.190.10-FF-000031', NULL, 'Arogenate dehydratase', 82, NULL, NULL, 58681),
(58682, '3.90.120.10-FF-000009', NULL, 'DNA methyltransferase Dim-2', 116, NULL, NULL, 58682),
(58683, '3.30.1330.30-FF-000016', NULL, 'H/ACA ribonucleoprotein complex subunit 2', 121, NULL, NULL, 58683),
(58684, '3.30.450.380-FF-000005', NULL, 'ATPase TadA', 173, NULL, NULL, 58684),
(58685, '2.40.50.120-FF-000036', NULL, 'TIMP metallopeptidase inhibitor 4, tandem duplicate 3', 87, NULL, NULL, 58685),
(58686, '3.40.50.300-FF-007140', NULL, 'Predicted protein', 178, NULL, NULL, 58686),
(58687, '3.40.50.150-FF-000777', NULL, 'Polyprotein P1234', 201, NULL, NULL, 58687),
(58688, '3.40.50.300-FF-006572', NULL, 'Uncharacterized protein', 101, NULL, NULL, 58688),
(58689, '3.40.50.720-FF-002387', NULL, 'Alcohol dehydrogenase, zinc-containing', 137, NULL, NULL, 58689),
(58690, '3.30.160.60-FF-004621', NULL, NULL, 85, NULL, NULL, 58690),
(58691, '2.130.10.10-FF-002379', NULL, 'Guanine nucleotide-binding protein subunit beta, putative', 309, NULL, NULL, 58691),
(58692, '3.90.190.10-FF-000014', NULL, 'receptor-type tyrosine-protein phosphatase U isoform X2', 282, NULL, NULL, 58692),
(58693, '1.25.40.10-FF-001658', NULL, 'Bardet-Biedl syndrome 4 protein homolog', 70, NULL, NULL, 58693),
(58694, '3.30.70.330-FF-002754', NULL, NULL, 131, NULL, NULL, 58694),
(58695, '1.20.1250.20-FF-000820', NULL, 'Sucrose transporter, putative', 466, NULL, NULL, 58695),
(58696, '3.30.160.60-FF-000759', NULL, 'zinc finger protein 16', 30, NULL, NULL, 58696),
(58697, '3.30.450.70-FF-000043', NULL, NULL, 136, NULL, NULL, 58697),
(58698, '3.80.10.10-FF-003059', NULL, 'Predicted protein', 146, NULL, NULL, 58698),
(58699, '3.30.200.20-FF-000465', NULL, 'Cysteine-rich receptor-like protein kinase 6', 101, NULL, NULL, 58699),
(58700, '2.10.70.80-FF-000020', NULL, 'Sortilin', 40, NULL, NULL, 58700),
(58701, '1.10.10.160-FF-000062', NULL, 'DNA helicase', 112, NULL, NULL, 58701),
(58702, '1.10.510.10-FF-002903', NULL, NULL, 192, NULL, NULL, 58702),
(58703, '1.25.40.20-FF-000138', NULL, 'leucine-rich repeat serine/threonine-protein kinase 1', 176, NULL, NULL, 58703),
(58704, '2.60.300.12-FF-000014', NULL, 'Iron-sulfur cluster assembly accessory protein Isa2, putative', 132, NULL, NULL, 58704),
(58705, '3.30.420.40-FF-000111', NULL, 'Sedoheptulokinase', 203, NULL, NULL, 58705),
(58706, '1.25.10.10-FF-002730', NULL, 'Predicted protein', 881, NULL, NULL, 58706),
(58707, '2.10.70.10-FF-000011', NULL, 'CUB and sushi domain-containing protein 3 isoform A', 58, NULL, NULL, 58707),
(58708, '3.10.20.520-FF-000001', NULL, 'Phenylacetate-CoA oxygenase, PaaH subunit', 64, NULL, NULL, 58708),
(58709, '3.90.70.10-FF-000724', NULL, 'Uncharacterized protein', 186, NULL, NULL, 58709),
(58710, '1.20.140.10-FF-000040', NULL, 'Acyl-CoA dehydrogenase FadE21', 146, NULL, NULL, 58710),
(58711, '4.10.740.10-FF-000003', NULL, 'Uncharacterized protein', 28, NULL, NULL, 58711),
(58712, '1.10.10.10-FF-000953', NULL, 'MarR family transcriptional regulator', 134, NULL, NULL, 58712);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(58713, '1.10.238.10-FF-000729', NULL, 'Uncharacterized protein', 164, NULL, NULL, 58713),
(58714, '3.30.160.60-FF-003896', NULL, NULL, 28, NULL, NULL, 58714),
(58715, '3.30.470.20-FF-000187', NULL, 'Uncharacterized protein', 92, NULL, NULL, 58715),
(58716, '2.60.40.1910-FF-000030', NULL, NULL, 101, NULL, NULL, 58716),
(58717, '3.20.20.70-FF-000736', NULL, NULL, 81, NULL, NULL, 58717),
(58718, '3.30.1230.20-FF-000011', NULL, '40S ribosomal protein S21', 82, NULL, NULL, 58718),
(58719, '3.40.50.1000-FF-000784', NULL, NULL, 62, NULL, NULL, 58719),
(58720, '1.10.287.660-FF-000010', NULL, 'Isy1 splicing protein-like protein', 55, NULL, NULL, 58720),
(58721, '2.60.120.20-FF-000023', NULL, NULL, 211, NULL, NULL, 58721),
(58722, '3.30.1370.210-FF-000013', NULL, 'Zinc finger CCCH domain-containing protein 46', 72, NULL, NULL, 58722),
(58723, '1.20.920.10-FF-000015', NULL, 'protein polybromo-1 isoform X3', 119, NULL, NULL, 58723),
(58724, '3.40.30.10-FF-000196', NULL, 'Glutathione S-transferase theta-4', 81, NULL, NULL, 58724),
(58725, '2.30.180.10-FF-000126', NULL, NULL, 140, NULL, NULL, 58725),
(58726, '3.40.50.620-FF-000154', NULL, 'Leucine--tRNA ligase', 95, NULL, NULL, 58726),
(58727, '2.10.90.10-FF-000006', NULL, 'growth/differentiation factor 8', 108, NULL, NULL, 58727),
(58728, '3.30.200.20-FF-001893', NULL, NULL, 116, NULL, NULL, 58728),
(58729, '3.30.1370.10-FF-000131', NULL, 'Exosome complex exonuclease RRP40', 121, NULL, NULL, 58729),
(58730, '3.30.70.370-FF-000034', NULL, NULL, 105, NULL, NULL, 58730),
(58731, '2.130.10.10-FF-004672', NULL, 'Transducin/WD40 repeat-like superfamily protein', 336, NULL, NULL, 58731),
(58732, '1.25.40.990-FF-000036', NULL, 'Predicted protein', 297, NULL, NULL, 58732),
(58733, '2.60.40.60-FF-000864', NULL, 'Uncharacterized protein', 105, NULL, NULL, 58733),
(58734, '3.30.420.10-FF-000304', NULL, 'DNA polymerase', 262, NULL, NULL, 58734),
(58735, '1.25.40.480-FF-000007', NULL, 'Fanconi anemia, complementation group E', 168, NULL, NULL, 58735),
(58736, '1.20.1070.10-FF-000022', NULL, 'Pituitary adenylate cyclase-activating polypeptide type I receptor', 296, NULL, NULL, 58736),
(58737, '2.60.40.10-FF-003295', NULL, 'Leukemia inhibitory factor receptor alpha b', 82, NULL, NULL, 58737),
(58738, '2.40.30.10-FF-000355', NULL, 'Uncharacterized protein', 78, NULL, NULL, 58738),
(58739, '1.10.555.10-FF-000270', NULL, NULL, 265, NULL, NULL, 58739),
(58740, '3.40.970.10-FF-000006', NULL, NULL, 34, NULL, NULL, 58740),
(58741, '3.30.70.330-FF-001326', NULL, 'Pre-rRNA-processing protein ESF2', 152, NULL, NULL, 58741),
(58742, '2.30.30.100-FF-000051', NULL, 'RNA-binding protein Hfq', 62, NULL, NULL, 58742),
(58743, '3.30.40.10-FF-001287', NULL, 'Uncharacterized protein', 56, NULL, NULL, 58743),
(58744, '1.20.120.1750-FF-000151', NULL, 'RBR-type E3 ubiquitin transferase', 45, NULL, NULL, 58744),
(58745, '1.25.40.10-FF-002226', NULL, 'Tetratricopeptide repeat', 262, NULL, NULL, 58745),
(58746, '2.60.120.40-FF-000029', NULL, 'Complement C1q tumor necrosis factor-related protein 1', 145, NULL, NULL, 58746),
(58747, '1.20.120.1420-FF-000001', NULL, 'Nuclear targeted protein LntA', 150, NULL, NULL, 58747),
(58748, '4.10.240.10-FF-000010', NULL, 'Fungal transcriptional regulatory protein', 55, NULL, NULL, 58748),
(58749, '3.30.70.3020-FF-000004', NULL, 'U3 small nucleolar RNA-associated protein 22', 104, NULL, NULL, 58749),
(58750, '2.60.40.10-FF-000810', NULL, 'Tyrosine-protein kinase receptor UFO', 100, NULL, NULL, 58750),
(58751, '4.10.280.10-FF-000187', NULL, 'YALI0F05126p', 55, NULL, NULL, 58751),
(58752, '2.60.120.10-FF-000554', NULL, 'Uncharacterized protein', 125, NULL, NULL, 58752),
(58753, '3.30.160.60-FF-003632', NULL, 'Zinc finger protein 131', 52, NULL, NULL, 58753),
(58754, '3.10.100.10-FF-000066', NULL, 'Lymphocyte antigen 75', 127, NULL, NULL, 58754),
(58755, '4.10.400.10-FF-000012', NULL, 'Low-density lipoprotein receptor-related protein 1', 42, NULL, NULL, 58755),
(58756, '3.30.230.10-FF-000121', NULL, 'Phosphomevalonate kinase', 266, NULL, NULL, 58756),
(58757, '2.40.50.140-FF-000412', NULL, '40S ribosomal protein S23', 58, NULL, NULL, 58757);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(58758, '2.10.110.10-FF-000222', NULL, 'LIM and senescent cell antigen-like-containing domain protein 2 isoform X4', 42, NULL, NULL, 58758),
(58759, '4.10.320.10-FF-000011', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 49, NULL, NULL, 58759),
(58760, '1.10.357.50-FF-000006', NULL, 'Exocyst complex component sec6', 195, NULL, NULL, 58760),
(58761, '2.40.30.10-FF-000198', NULL, 'Bifunctional cytochrome P450/NADPH--P450 reductase', 73, NULL, NULL, 58761),
(58762, '3.90.1290.10-FF-000009', NULL, 'microtubule-actin cross-linking factor 1 isoform X13', 145, NULL, NULL, 58762),
(58763, '2.30.29.30-FF-000549', NULL, 'Nuclear Pore complex Protein', 162, NULL, NULL, 58763),
(58764, '1.20.1250.20-FF-001466', NULL, 'Peptide transporter family 1-like Protein', 389, NULL, NULL, 58764),
(58765, '2.130.10.10-FF-002643', NULL, 'Mediator of RNA polymerase II transcription subunit 16', 272, NULL, NULL, 58765),
(58766, '3.50.50.60-FF-001392', NULL, 'Amine oxidase, putative', 210, NULL, NULL, 58766),
(58767, '3.40.50.720-FF-001139', NULL, 'Nicotinamide nucleotide transhydrogenase 2', 99, NULL, NULL, 58767),
(58768, '2.60.200.20-FF-000024', NULL, 'afadin isoform X2', 108, NULL, NULL, 58768),
(58769, '3.40.50.300-FF-004234', NULL, 'DNA helicase', 196, NULL, NULL, 58769),
(58770, '2.10.25.10-FF-000204', NULL, 'LDL receptor related protein 1', 43, NULL, NULL, 58770),
(58771, '1.20.1260.10-FF-000025', NULL, '5-demethoxyubiquinone hydroxylase, mitochondrial', 149, NULL, NULL, 58771),
(58772, '1.10.510.10-FF-004292', NULL, NULL, 164, NULL, NULL, 58772),
(58773, '3.30.160.60-FF-006419', NULL, NULL, 51, NULL, NULL, 58773),
(58774, '2.70.130.10-FF-000086', NULL, NULL, 144, NULL, NULL, 58774),
(58775, '3.30.70.330-FF-000337', NULL, 'nuclear cap-binding protein subunit 3 isoform X1', 89, NULL, NULL, 58775),
(58776, '1.25.40.10-FF-004564', NULL, 'Uncharacterized protein', 200, NULL, NULL, 58776),
(58777, '2.60.120.200-FF-000534', NULL, 'Galectin', 148, NULL, NULL, 58777),
(58778, '3.40.50.10330-FF-000018', NULL, 'Probable NAD kinase 1', 167, NULL, NULL, 58778),
(58779, '3.40.1160.10-FF-000079', NULL, 'Acetylglutamate kinase', 251, NULL, NULL, 58779),
(58780, '3.30.70.420-FF-000004', NULL, '3-hydroxy-3-methylglutaryl-coenzyme A reductase 2', 13, NULL, NULL, 58780),
(58781, '1.10.287.110-FF-000373', NULL, 'Predicted protein', 101, NULL, NULL, 58781),
(58782, '1.10.1740.100-FF-000008', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-36 specific', 107, NULL, NULL, 58782),
(58783, '1.20.1070.10-FF-002051', NULL, 'Uncharacterized protein', 100, NULL, NULL, 58783),
(58784, '2.130.10.10-FF-002755', NULL, 'SET1-complex chromatin-modification component, putative', 257, NULL, NULL, 58784),
(58785, '2.60.120.260-FF-000445', NULL, 'Uncharacterized protein', 184, NULL, NULL, 58785),
(58786, '3.30.200.20-FF-000089', NULL, 'Tyrosine-protein kinase', 87, NULL, NULL, 58786),
(58787, '3.40.50.10190-FF-000105', NULL, 'DNA ligase', 129, NULL, NULL, 58787),
(58788, '3.40.190.10-FF-000891', NULL, 'Nodulation protein D 1', 100, NULL, NULL, 58788),
(58789, '3.90.1170.40-FF-000009', NULL, 'Molybdopterin-guanine dinucleotide biosynthesis protein MobB', 136, NULL, NULL, 58789),
(58790, '3.90.640.10-FF-000268', NULL, 'Uncharacterized protein', 72, NULL, NULL, 58790),
(58791, '2.130.10.10-FF-001131', NULL, 'Related to UTP21-U3 snoRNP protein', 86, NULL, NULL, 58791),
(58792, '2.60.40.10-FF-004284', NULL, NULL, 94, NULL, NULL, 58792),
(58793, '3.20.20.10-FF-000084', NULL, 'Uncharacterized protein', 127, NULL, NULL, 58793),
(58794, '1.20.1250.10-FF-000120', NULL, NULL, 146, NULL, NULL, 58794),
(58795, '2.120.10.80-FF-000135', NULL, 'Protein GLUTELIN PRECURSOR ACCUMULATION 3', 168, NULL, NULL, 58795),
(58796, '3.80.10.10-FF-001261', NULL, 'Si:dkey-191j3.2', 183, NULL, NULL, 58796),
(58797, '3.30.70.1230-FF-000170', NULL, 'Adenylate cyclase', 194, NULL, NULL, 58797),
(58798, '2.120.10.80-FF-000247', NULL, 'Development protein DG1106', 271, NULL, NULL, 58798),
(58799, '1.25.40.10-FF-002378', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 79, NULL, NULL, 58799);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(58800, '3.30.710.10-FF-000282', NULL, 'GM13105', 167, NULL, NULL, 58800),
(58801, '3.40.30.10-FF-000460', NULL, 'Thioredoxin-like, putative', 177, NULL, NULL, 58801),
(58802, '1.20.120.1080-FF-000079', NULL, 'Putative ATP-dependent DEAD/H RNA helicase', 105, NULL, NULL, 58802),
(58803, '3.40.50.1240-FF-000041', NULL, 'Phosphoglucomutase-2', 183, NULL, NULL, 58803),
(58804, '2.60.40.2240-FF-000005', NULL, 'Uncharacterized protein', 130, NULL, NULL, 58804),
(58805, '3.90.550.10-FF-000738', NULL, 'Glycosyltransferase', 246, NULL, NULL, 58805),
(58806, '1.25.10.10-FF-000364', NULL, 'Uncharacterized protein', 270, NULL, NULL, 58806),
(58807, '1.20.1000.10-FF-000017', NULL, NULL, 103, NULL, NULL, 58807),
(58808, '3.40.50.300-FF-002997', NULL, 'Sulfotransferase', 136, NULL, NULL, 58808),
(58809, '2.60.40.10-FF-004817', NULL, NULL, 100, NULL, NULL, 58809),
(58810, '1.20.990.10-FF-000020', NULL, 'Sulfite reductase [NADPH] flavoprotein alpha-component', 108, NULL, NULL, 58810),
(58811, '1.10.510.10-FF-000981', NULL, 'Predicted protein', 186, NULL, NULL, 58811),
(58812, '1.10.418.10-FF-000210', NULL, 'Microtubule-associated protein RP/EB family member 3', 43, NULL, NULL, 58812),
(58813, '2.40.50.90-FF-000127', NULL, 'Uncharacterized protein', 153, NULL, NULL, 58813),
(58814, '1.10.930.10-FF-000001', NULL, 'Tyrosine-protein kinase', 42, NULL, NULL, 58814),
(58815, '2.70.160.11-FF-000100', NULL, 'Protein arginine Nmethyltransferase, putative', 61, NULL, NULL, 58815),
(58816, '3.80.10.10-FF-003447', NULL, 'Uncharacterized protein', 347, NULL, NULL, 58816),
(58817, '1.10.20.140-FF-000001', NULL, 'tRNA dimethylallyltransferase', 71, NULL, NULL, 58817),
(58818, '2.60.40.10-FF-003407', NULL, NULL, 95, NULL, NULL, 58818),
(58819, '3.90.380.10-FF-000017', NULL, 'Terephthalate 1,2-dioxygenase oxygenase large subunit', 263, NULL, NULL, 58819),
(58820, '2.60.40.10-FF-000574', NULL, 'neurofascin isoform X1', 96, NULL, NULL, 58820),
(58821, '1.25.40.10-FF-003215', NULL, 'Uncharacterized protein', 211, NULL, NULL, 58821),
(58822, '1.10.275.30-FF-000012', NULL, 'Uncharacterized protein', 110, NULL, NULL, 58822),
(58823, '3.30.780.10-FF-000056', NULL, 'Translation machinery-associated protein 22', 112, NULL, NULL, 58823),
(58824, '1.25.40.20-FF-000402', NULL, 'Transient receptor potential channel', 163, NULL, NULL, 58824),
(58825, '2.10.25.10-FF-000047', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 2', 63, NULL, NULL, 58825),
(58826, '3.40.50.300-FF-005583', NULL, 'Si:dkey-96f10.1', 113, NULL, NULL, 58826),
(58827, '3.40.850.10-FF-000216', NULL, 'Kinesin-like protein, putative', 269, NULL, NULL, 58827),
(58828, '1.20.58.60-FF-000757', NULL, 'Uncharacterized protein', 49, NULL, NULL, 58828),
(58829, '1.10.510.10-FF-003623', NULL, NULL, 195, NULL, NULL, 58829),
(58830, '2.20.100.10-FF-000112', NULL, 'Thrombospondin-related apical membrane protein', 55, NULL, NULL, 58830),
(58831, '2.60.40.10-FF-003183', NULL, NULL, 86, NULL, NULL, 58831),
(58832, '3.40.50.1370-FF-000029', NULL, 'Ornithine carbamoyltransferase', 172, NULL, NULL, 58832),
(58833, '3.30.450.20-FF-000192', NULL, 'Sensory box sensor histidine kinase', 136, NULL, NULL, 58833),
(58834, '3.30.160.60-FF-006381', NULL, NULL, 72, NULL, NULL, 58834),
(58835, '3.30.500.50-FF-000002', NULL, 'Envelope glycoprotein H', 208, NULL, NULL, 58835),
(58836, '3.40.50.880-FF-000153', NULL, 'Anthranilate synthase beta subunit 1 chloroplastic', 171, NULL, NULL, 58836),
(58837, '3.40.50.150-FF-001215', NULL, NULL, 167, NULL, NULL, 58837),
(58838, '1.10.510.10-FF-001094', NULL, 'RIO kinase 2', 158, NULL, NULL, 58838),
(58839, '3.40.50.300-FF-007668', NULL, 'Uncharacterized protein', 121, NULL, NULL, 58839),
(58840, '1.25.40.10-FF-001130', NULL, 'Clustered mitochondria protein homolog', 213, NULL, NULL, 58840),
(58841, '2.60.120.10-FF-000762', NULL, 'Uncharacterized protein', 71, NULL, NULL, 58841),
(58842, '3.40.390.10-FF-000012', NULL, 'Protein MtfA', 122, NULL, NULL, 58842),
(58843, '3.40.390.10-FF-000136', NULL, 'Uncharacterized protein, isoform D', 272, NULL, NULL, 58843);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(58844, '1.10.730.10-FF-000020', NULL, 'Leucine--tRNA ligase cytoplasmic', 116, NULL, NULL, 58844),
(58845, '1.20.5.5270-FF-000002', NULL, 'Lon protease homolog', 50, NULL, NULL, 58845),
(58846, '3.30.1640.10-FF-000079', NULL, 'DNA replication licensing factor MCM7', 92, NULL, NULL, 58846),
(58847, '3.40.50.1820-FF-001024', NULL, 'Uncharacterized protein', 188, NULL, NULL, 58847),
(58848, '3.10.100.10-FF-000178', NULL, 'GM16582', 150, NULL, NULL, 58848),
(58849, '3.30.750.24-FF-000090', NULL, 'Anti-sigma factor antagonist', 115, NULL, NULL, 58849),
(58850, '3.40.50.300-FF-002025', NULL, 'DEAD box helicase, putative', 193, NULL, NULL, 58850),
(58851, '2.30.29.110-FF-000001', NULL, 'inositol polyphosphate 5-phosphatase OCRL-1', 119, NULL, NULL, 58851),
(58852, '1.10.630.10-FF-000748', NULL, 'Uncharacterized protein', 73, NULL, NULL, 58852),
(58853, '1.20.1250.20-FF-001258', NULL, 'High-affinity glucose transporter, putative', 395, NULL, NULL, 58853),
(58854, '3.40.50.1780-FF-000034', NULL, '4Fe-4S ferredoxin iron-sulfur binding domain protein', 91, NULL, NULL, 58854),
(58855, '2.30.29.30-FF-000757', NULL, 'GTPase-activating protein testicular GAP1', 130, NULL, NULL, 58855),
(58856, '1.25.10.10-FF-001038', NULL, 'Importin beta-3 subunit', 1142, NULL, NULL, 58856),
(58857, '3.60.10.10-FF-000031', NULL, 'Calcofluor white hypersensitive protein', 201, NULL, NULL, 58857),
(58858, '3.90.1150.10-FF-000387', NULL, 'Probable glycine dehydrogenase (decarboxylating) subunit 2', 121, NULL, NULL, 58858),
(58859, '1.10.540.10-FF-000078', NULL, 'Acyl-CoA dehydrogenase family protein', 117, NULL, NULL, 58859),
(58860, '2.170.8.10-FF-000005', NULL, 'Phosphoenolypyruvate CarboxyKinase', 109, NULL, NULL, 58860),
(58861, '3.40.470.10-FF-000013', NULL, 'Type-4 uracil-DNA glycosylase', 191, NULL, NULL, 58861),
(58862, '3.30.980.10-FF-000037', NULL, 'Alanyl-tRNA editing protein AlaX-S', 88, NULL, NULL, 58862),
(58863, '1.10.1200.10-FF-000086', NULL, 'Nonribosomal peptide synthase SidC', 83, NULL, NULL, 58863),
(58864, '1.10.10.10-FF-001201', NULL, 'RNA polymerase sigma factor sigD, chloroplastic', 80, NULL, NULL, 58864),
(58865, '2.60.40.10-FF-002608', NULL, 'KALlmann syndrome homolog', 115, NULL, NULL, 58865),
(58866, '1.25.40.20-FF-000790', NULL, 'Uncharacterized protein', 115, NULL, NULL, 58866),
(58867, '3.40.50.2000-FF-000140', NULL, 'L-arabinokinase', 197, NULL, NULL, 58867),
(58868, '3.30.200.20-FF-002331', NULL, 'Uncharacterized protein', 72, NULL, NULL, 58868),
(58869, '3.30.559.30-FF-000098', NULL, 'Uncharacterized protein', 247, NULL, NULL, 58869),
(58870, '3.90.550.10-FF-000109', NULL, 'Exostosin like glycosyltransferase 1', 253, NULL, NULL, 58870),
(58871, '1.20.5.340-FF-000019', NULL, 'Myosin heavy chain, isoform G', 123, NULL, NULL, 58871),
(58872, '3.40.50.1820-FF-001608', NULL, 'Uncharacterized protein', 71, NULL, NULL, 58872),
(58873, '2.30.29.30-FF-000196', NULL, 'unconventional myosin-X', 105, NULL, NULL, 58873),
(58874, '1.20.1270.280-FF-000018', NULL, 'Dynein heavy chain 4', 166, NULL, NULL, 58874),
(58875, '2.40.30.10-FF-000434', NULL, 'Elongation factor Tu C-terminal domain containing protein', 91, NULL, NULL, 58875),
(58876, '1.10.1410.10-FF-000068', NULL, 'Uncharacterized protein', 85, NULL, NULL, 58876),
(58877, '2.10.25.10-FF-001396', NULL, 'Basement membrane proteoglycan', 47, NULL, NULL, 58877),
(58878, '1.10.10.2830-FF-000008', NULL, 'Chromosome partitioning protein, ParB family', 133, NULL, NULL, 58878),
(58879, '1.10.510.10-FF-003100', NULL, NULL, 197, NULL, NULL, 58879),
(58880, '1.20.1050.10-FF-000190', NULL, 'Uncharacterized protein', 138, NULL, NULL, 58880),
(58881, '1.10.472.10-FF-000352', NULL, 'Cyclin domain-containing protein, variant 1', 120, NULL, NULL, 58881),
(58882, '3.30.160.60-FF-004733', NULL, NULL, 103, NULL, NULL, 58882),
(58883, '1.20.1070.10-FF-001039', NULL, 'C-X-C motif chemokine receptor 2', 272, NULL, NULL, 58883),
(58884, '2.70.98.50-FF-000005', NULL, 'Uncharacterized protein', 176, NULL, NULL, 58884),
(58885, '3.10.580.20-FF-000003', NULL, 'Chloride channel protein', 85, NULL, NULL, 58885);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(58886, '1.20.970.10-FF-000018', NULL, 'Anthranilate phosphoribosyltransferase', 69, NULL, NULL, 58886),
(58887, '3.40.50.10260-FF-000025', NULL, 'Multifunctional fusion protein', 212, NULL, NULL, 58887),
(58888, '2.60.120.260-FF-000237', NULL, 'Uncharacterized protein YdaN', 147, NULL, NULL, 58888),
(58889, '3.40.50.300-FF-005791', NULL, 'ATP synthase subunit alpha, mitochondrial', 67, NULL, NULL, 58889),
(58890, '3.30.40.10-FF-000163', NULL, 'Putative ring finger protein 37', 81, NULL, NULL, 58890),
(58891, '2.10.25.10-FF-000940', NULL, 'Hemolectin, isoform B', 59, NULL, NULL, 58891),
(58892, '1.25.40.90-FF-000119', NULL, 'Predicted protein', 56, NULL, NULL, 58892),
(58893, '3.40.50.2300-FF-000336', NULL, 'Stage II sporulation protein E', 142, NULL, NULL, 58893),
(58894, '1.25.40.10-FF-003007', NULL, 'Pentatricopeptide repeat-containing protein', 122, NULL, NULL, 58894),
(58895, '2.130.10.10-FF-002255', NULL, 'Uncharacterized protein, isoform B', 328, NULL, NULL, 58895),
(58896, '3.80.10.10-FF-003970', NULL, 'Uncharacterized protein', 162, NULL, NULL, 58896),
(58897, '2.60.40.10-FF-004076', NULL, NULL, 95, NULL, NULL, 58897),
(58898, '3.40.50.970-FF-000112', NULL, 'Dehydrogenase E1 component', 320, NULL, NULL, 58898),
(58899, '3.60.21.10-FF-000455', NULL, 'Uncharacterized protein', 277, NULL, NULL, 58899),
(58900, '3.40.50.1100-FF-000145', NULL, 'Pyridoxal-5''-phosphate-dependent enzyme family protein', 33, NULL, NULL, 58900),
(58901, '3.40.50.2020-FF-000022', NULL, 'Adenine phosphoribosyltransferase 1', 180, NULL, NULL, 58901),
(58902, '3.30.70.330-FF-000601', NULL, 'CC1-like, splicing factor', 109, NULL, NULL, 58902),
(58903, '3.40.50.300-FF-006943', NULL, 'Elongator complex protein 5', 227, NULL, NULL, 58903),
(58904, '2.40.10.10-FF-000135', NULL, 'Coagulation factor II (thrombin)', 70, NULL, NULL, 58904),
(58905, '2.60.120.330-FF-000096', NULL, 'Uncharacterized protein', 320, NULL, NULL, 58905),
(58906, '3.30.200.20-FF-000589', NULL, 'Discoidin domain receptor tyrosine kinase 1', 109, NULL, NULL, 58906),
(58907, '2.130.10.10-FF-000226', NULL, 'TBC1 domain family member 31', 183, NULL, NULL, 58907),
(58908, '4.10.640.10-FF-000018', NULL, '28S ribosomal protein S18C, mitochondrial', 70, NULL, NULL, 58908),
(58909, '2.30.29.170-FF-000024', NULL, NULL, 122, NULL, NULL, 58909),
(58910, '3.90.660.10-FF-000090', NULL, NULL, 214, NULL, NULL, 58910),
(58911, '3.40.430.10-FF-000016', NULL, 'Possible bifunctional enzyme riboflavin biosynthesis protein ribD: diaminohydroxyphosphoribosylaminopyrimidine deaminase + 5-amino-6-(5-phosphoribosylamino)uracil reductase', 258, NULL, NULL, 58911),
(58912, '2.130.10.10-FF-003891', NULL, 'Nucleoporin 214', 274, NULL, NULL, 58912),
(58913, '3.10.20.770-FF-000014', NULL, 'Phosphatidylinositol 3-kinase 1', 277, NULL, NULL, 58913),
(58914, '3.30.70.330-FF-002630', NULL, NULL, 125, NULL, NULL, 58914),
(58915, '1.20.58.60-FF-000257', NULL, 'Uncharacterized protein, isoform H', 114, NULL, NULL, 58915),
(58916, '2.40.150.20-FF-000018', NULL, 'Ribosomal protein L14, putative', 115, NULL, NULL, 58916),
(58917, '3.90.70.10-FF-000089', NULL, 'Ubiquitinyl hydrolase 1', 354, NULL, NULL, 58917),
(58918, '1.10.3210.10-FF-000036', NULL, 'GTP pyrophosphokinase', 207, NULL, NULL, 58918),
(58919, '3.10.129.10-FF-000053', NULL, 'Probable enoyl-CoA hydratase 1', 151, NULL, NULL, 58919),
(58920, '3.30.830.10-FF-000049', NULL, 'Mitochondrial processing peptidase alpha subunit', 216, NULL, NULL, 58920),
(58921, '1.10.10.60-FF-000215', NULL, 'dnaJ homolog subfamily C member 2 isoform X1', 67, NULL, NULL, 58921),
(58922, '1.20.120.1770-FF-000022', NULL, 'Predicted protein', 222, NULL, NULL, 58922),
(58923, '3.40.50.10810-FF-000067', NULL, 'ATP-dependent DNA helicase', 228, NULL, NULL, 58923),
(58924, '3.40.50.620-FF-000890', NULL, 'Predicted protein', 98, NULL, NULL, 58924),
(58925, '1.10.3730.20-FF-000005', NULL, 'Cystine transporter YijE', 110, NULL, NULL, 58925),
(58926, '3.80.10.10-FF-003239', NULL, 'F-box protein SKIP28', 185, NULL, NULL, 58926),
(58927, '1.10.150.50-FF-000190', NULL, 'Stromal interaction molecule 1', 68, NULL, NULL, 58927);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(58928, '3.40.50.1820-FF-001367', NULL, 'Os02g0633000 protein', 227, NULL, NULL, 58928),
(58929, '3.50.50.60-FF-000543', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 91, NULL, NULL, 58929),
(58930, '2.40.160.40-FF-000002', NULL, 'N-acetylneuraminic acid outer membrane channel protein NanC', 214, NULL, NULL, 58930),
(58931, '3.90.640.10-FF-000004', NULL, 'Heat shock 70 kDa protein 4', 84, NULL, NULL, 58931),
(58932, '1.20.920.20-FF-000075', NULL, 'Dynein heavy chain 9', 68, NULL, NULL, 58932),
(58933, '2.90.10.30-FF-000004', NULL, 'Serine/threonine-protein kinase', 144, NULL, NULL, 58933),
(58934, '1.10.630.10-FF-000405', NULL, 'Cytochrome P450, putative (Eurofung)', 483, NULL, NULL, 58934),
(58935, '3.40.930.10-FF-000009', NULL, 'PTS system, fructose specific IIABC component', 151, NULL, NULL, 58935),
(58936, '3.40.850.10-FF-000008', NULL, 'Putative unconventional myosin-IXa', 43, NULL, NULL, 58936),
(58937, '1.25.10.10-FF-003455', NULL, 'Maestro heat-like repeat-containing protein family member 1', 207, NULL, NULL, 58937),
(58938, '2.30.30.40-FF-000443', NULL, 'Tyrosine-protein kinase', 75, NULL, NULL, 58938),
(58939, '3.40.50.620-FF-000215', NULL, 'Os03g0241600 protein', 137, NULL, NULL, 58939),
(58940, '1.25.10.10-FF-000864', NULL, 'Uncharacterized protein', 121, NULL, NULL, 58940),
(58941, '1.25.10.10-FF-002550', NULL, '26S proteasome non-ATPase regulatory subunit 1-like Protein', 178, NULL, NULL, 58941),
(58942, '2.130.10.10-FF-005869', NULL, 'Uncharacterized protein', 308, NULL, NULL, 58942),
(58943, '2.30.280.10-FF-000010', NULL, NULL, 134, NULL, NULL, 58943),
(58944, '3.30.160.60-FF-002204', NULL, 'Zinc finger protein 790', 27, NULL, NULL, 58944),
(58945, '1.10.238.10-FF-000668', NULL, 'Uncharacterized protein', 145, NULL, NULL, 58945),
(58946, '1.20.890.10-FF-000017', NULL, 'Hypothetical_protein', 41, NULL, NULL, 58946),
(58947, '1.10.510.10-FF-001206', NULL, 'putative receptor-like protein kinase At1g80870', 110, NULL, NULL, 58947),
(58948, '3.10.20.90-FF-000771', NULL, 'Autophagy protein 5', 84, NULL, NULL, 58948),
(58949, '2.40.160.60-FF-000008', NULL, 'Probable outer membrane protein', 443, NULL, NULL, 58949),
(58950, '3.80.10.10-FF-002722', NULL, 'Os06g0185966 protein', 75, NULL, NULL, 58950),
(58951, '1.20.1060.20-FF-000018', NULL, 'Structural maintenance of chromosomes protein', 129, NULL, NULL, 58951),
(58952, '2.120.10.30-FF-000081', NULL, 'NHL repeat-containing protein 2', 156, NULL, NULL, 58952),
(58953, '3.40.50.1820-FF-000647', NULL, 'Serine carboxypeptidase family protein', 202, NULL, NULL, 58953),
(58954, '2.60.200.20-FF-000092', NULL, 'FHA domain-containing protein', 111, NULL, NULL, 58954),
(58955, '2.60.40.150-FF-000454', NULL, 'extended synaptotagmin-2 isoform X4', 133, NULL, NULL, 58955),
(58956, '3.60.20.10-FF-000200', NULL, NULL, 215, NULL, NULL, 58956),
(58957, '1.25.40.280-FF-000003', NULL, 'RHPN1 isoform 1', 376, NULL, NULL, 58957),
(58958, '1.10.8.10-FF-000093', NULL, 'Ubiquitin-associated and SH3 domain-containing protein B', 25, NULL, NULL, 58958),
(58959, '2.40.50.140-FF-000547', NULL, '26S protease regulatory subunit 7, putative', 126, NULL, NULL, 58959),
(58960, '1.10.3260.10-FF-000039', NULL, 'ATP dependent DNA ligase', 216, NULL, NULL, 58960),
(58961, '1.10.3720.10-FF-000119', NULL, 'ABC transporter permease protein', 195, NULL, NULL, 58961),
(58962, '3.90.1150.10-FF-000179', NULL, 'Aminotransferase, class III', 124, NULL, NULL, 58962),
(58963, '3.20.20.70-FF-000231', NULL, 'Pyridoxine biosynthetic enzyme pdx1', 296, NULL, NULL, 58963),
(58964, '4.10.410.20-FF-000010', NULL, 'Sushi domain containing 2', 43, NULL, NULL, 58964),
(58965, '3.30.40.10-FF-001523', NULL, 'Putative peroxisome assembly protein', 71, NULL, NULL, 58965),
(58966, '2.170.270.10-FF-000055', NULL, 'PR/SET domain 2', 125, NULL, NULL, 58966),
(58967, '3.50.50.60-FF-001324', NULL, 'Uncharacterized protein', 145, NULL, NULL, 58967),
(58968, '3.80.10.10-FF-002542', NULL, 'NLR family CARD domain containing 5', 161, NULL, NULL, 58968),
(58969, '3.40.800.10-FF-000005', NULL, 'Arginase', 302, NULL, NULL, 58969);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(58970, '2.130.10.10-FF-005689', NULL, 'Predicted protein', 156, NULL, NULL, 58970),
(58971, '2.170.270.10-FF-000179', NULL, 'PR domain 4', 85, NULL, NULL, 58971),
(58972, '2.60.40.10-FF-004464', NULL, NULL, 109, NULL, NULL, 58972),
(58973, '2.60.40.10-FF-001327', NULL, 'titin isoform X1', 107, NULL, NULL, 58973),
(58974, '1.20.1270.50-FF-000015', NULL, 'Lysosomal alpha-mannosidase, putative', 49, NULL, NULL, 58974),
(58975, '3.55.50.30-FF-000029', NULL, 'Fec operon regulator FecR', 76, NULL, NULL, 58975),
(58976, '1.20.1250.20-FF-002265', NULL, 'Uncharacterized protein', 100, NULL, NULL, 58976),
(58977, '1.10.20.10-FF-000010', NULL, 'Histone H3', 135, NULL, NULL, 58977),
(58978, '3.40.50.10490-FF-000156', NULL, NULL, 62, NULL, NULL, 58978),
(58979, '2.30.30.30-FF-000002', NULL, 'Transcription termination/antitermination factor NusG', 61, NULL, NULL, 58979),
(58980, '1.20.5.170-FF-000126', NULL, 'Unplaced genomic scaffold supercont1.19, whole genome shotgun sequence', 70, NULL, NULL, 58980),
(58981, '3.40.920.10-FF-000003', NULL, 'Pyruvate ferredoxin oxidoreductase, alpha subunit', 178, NULL, NULL, 58981),
(58982, '3.30.160.60-FF-004413', NULL, NULL, 32, NULL, NULL, 58982),
(58983, '3.40.50.300-FF-000844', NULL, 'Nuclear GTP-binding protein NUG1', 182, NULL, NULL, 58983),
(58984, '1.20.5.860-FF-000001', NULL, 'Cytochrome b559 subunit alpha', 80, NULL, NULL, 58984),
(58985, '3.30.43.10-FF-000012', NULL, 'Cytokinin dehydrogenase 7', 108, NULL, NULL, 58985),
(58986, '1.10.10.10-FF-000745', NULL, 'RNA polymerase sigma factor', 85, NULL, NULL, 58986),
(58987, '3.40.390.10-FF-000080', NULL, 'A disintegrin and metallopeptidase domain 30', 195, NULL, NULL, 58987),
(58988, '1.25.40.10-FF-000192', NULL, 'G-protein-signaling modulator 1 isoform a', 108, NULL, NULL, 58988),
(58989, '2.170.300.10-FF-000053', NULL, 'Uncharacterized protein', 126, NULL, NULL, 58989),
(58990, '3.40.50.1820-FF-000086', NULL, 'Diacylglycerol acyltransferase/mycolyltransferase Ag85C', 283, NULL, NULL, 58990),
(58991, '1.10.8.60-FF-000467', NULL, 'Predicted protein', 86, NULL, NULL, 58991),
(58992, '3.90.70.10-FF-000224', NULL, 'GM06507p', 261, NULL, NULL, 58992),
(58993, '2.60.120.290-FF-000100', NULL, 'RIKEN cDNA 5430419D17 gene', 117, NULL, NULL, 58993),
(58994, '1.10.890.20-FF-000006', NULL, NULL, 29, NULL, NULL, 58994),
(58995, '3.40.50.300-FF-008606', NULL, 'Peroxisome biosynthesis protein', 157, NULL, NULL, 58995),
(58996, '1.20.1070.10-FF-000994', NULL, 'Predicted protein', 202, NULL, NULL, 58996),
(58997, '2.60.120.380-FF-000094', NULL, 'Alpha-xylosidase BoGH31A', 142, NULL, NULL, 58997),
(58998, '1.10.10.10-FF-000869', NULL, 'DNA-binding response regulator', 99, NULL, NULL, 58998),
(58999, '3.30.420.10-FF-000647', NULL, NULL, 134, NULL, NULL, 58999),
(59000, '2.70.170.10-FF-000217', NULL, 'Uncharacterized protein', 126, NULL, NULL, 59000),
(59001, '1.20.1070.10-FF-001270', NULL, 'Uncharacterized protein', 158, NULL, NULL, 59001),
(59002, '3.40.350.10-FF-000015', NULL, 'Xaa-Pro aminopeptidase app-1', 169, NULL, NULL, 59002),
(59003, '3.40.50.300-FF-000968', NULL, 'Helicase and polymerase-containing protein TEBICHI', 221, NULL, NULL, 59003),
(59004, '1.10.238.100-FF-000001', NULL, 'BZIP transcription factor (AP-1)', 80, NULL, NULL, 59004),
(59005, '3.40.50.300-FF-005515', NULL, 'ATP-dependent DEAD/H RNA helicase, putative', 145, NULL, NULL, 59005),
(59006, '3.40.50.720-FF-001870', NULL, 'Uncharacterized oxidoreductase C19A8.06', 318, NULL, NULL, 59006),
(59007, '3.40.1190.20-FF-000185', NULL, NULL, 294, NULL, NULL, 59007),
(59008, '3.40.50.410-FF-000260', NULL, 'Predicted protein', 147, NULL, NULL, 59008),
(59009, '1.25.40.460-FF-000001', NULL, 'Teg12', 96, NULL, NULL, 59009),
(59010, '3.60.21.10-FF-000112', NULL, 'YNL217W-like protein', 279, NULL, NULL, 59010),
(59011, '1.10.3020.20-FF-000002', NULL, 'CocE/NonD family hydrolase', 47, NULL, NULL, 59011),
(59012, '2.40.50.960-FF-000006', NULL, 'Uncharacterized protein', 155, NULL, NULL, 59012),
(59013, '3.40.50.720-FF-000234', NULL, '2-hydroxyacid dehydrogenase, putative', 135, NULL, NULL, 59013);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(59014, '3.40.50.1000-FF-000845', NULL, NULL, 66, NULL, NULL, 59014),
(59015, '1.20.140.20-FF-000009', NULL, '[pyruvate dehydrogenase [lipoamide]] kinase, mitochondrial, putative', 181, NULL, NULL, 59015),
(59016, '1.25.40.10-FF-003283', NULL, 'Pentatricopeptide repeat-containing protein', 132, NULL, NULL, 59016),
(59017, '1.10.510.10-FF-001998', NULL, 'Uncharacterized protein', 193, NULL, NULL, 59017),
(59018, '3.90.550.50-FF-000161', NULL, 'Hydroxyproline O-galactosyltransferase GALT4', 207, NULL, NULL, 59018),
(59019, '1.25.40.10-FF-000933', NULL, 'Pentatricopeptide repeat-containing protein', 130, NULL, NULL, 59019),
(59020, '3.10.20.340-FF-000003', NULL, 'Arginine biosynthesis bifunctional protein ArgJ', 127, NULL, NULL, 59020),
(59021, '3.40.50.10880-FF-000003', NULL, 'Pantothenate kinase 2', 164, NULL, NULL, 59021),
(59022, '1.10.510.10-FF-003235', NULL, NULL, 121, NULL, NULL, 59022),
(59023, '3.80.10.10-FF-003391', NULL, 'Uncharacterized protein', 100, NULL, NULL, 59023),
(59024, '3.30.70.260-FF-000001', NULL, 'Acetolactate synthase, small subunit', 79, NULL, NULL, 59024),
(59025, '2.30.30.40-FF-000623', NULL, 'Predicted protein', 39, NULL, NULL, 59025),
(59026, '3.10.100.10-FF-000419', NULL, NULL, 95, NULL, NULL, 59026),
(59027, '1.25.10.10-FF-001302', NULL, 'Exportin-6', 714, NULL, NULL, 59027),
(59028, '3.40.50.300-FF-003453', NULL, '26S protease regulatory subunit 6A', 192, NULL, NULL, 59028),
(59029, '1.20.5.1000-FF-000002', NULL, 'Uncharacterized protein', 85, NULL, NULL, 59029),
(59030, '2.20.110.10-FF-000017', NULL, 'ALS2 C-terminal like', 57, NULL, NULL, 59030),
(59031, '3.30.1240.10-FF-000071', NULL, 'Uncharacterized protein', 110, NULL, NULL, 59031),
(59032, '3.30.260.10-FF-000084', NULL, NULL, 62, NULL, NULL, 59032),
(59033, '3.40.50.80-FF-000111', NULL, 'Respiratory burst oxidase', 77, NULL, NULL, 59033),
(59034, '3.30.70.330-FF-001118', NULL, 'Nucleolin like 2', 179, NULL, NULL, 59034),
(59035, '3.10.129.10-FF-000233', NULL, 'Uncharacterized protein', 109, NULL, NULL, 59035),
(59036, '3.30.450.40-FF-000282', NULL, 'Phosphodiesterase', 88, NULL, NULL, 59036),
(59037, '1.25.40.10-FF-004643', NULL, 'Putative pentatricopeptide repeat-containing protein', 124, NULL, NULL, 59037),
(59038, '3.30.200.20-FF-000201', NULL, 'TP53-regulating kinase isoform X1', 73, NULL, NULL, 59038),
(59039, '3.40.50.150-FF-000434', NULL, 'Arginine N-methyltransferase', 151, NULL, NULL, 59039),
(59040, '1.50.40.10-FF-000577', NULL, 'Solute carrier family 25 (mitochondrial carrier; phosphate carrier), member 24, like', 74, NULL, NULL, 59040),
(59041, '3.40.50.720-FF-000358', NULL, 'NADH-ubiquinone oxidoreductase 39 kDa subunit', 280, NULL, NULL, 59041),
(59042, '3.65.10.20-FF-000001', NULL, 'RNA terminal phosphate cyclase-like 1', 234, NULL, NULL, 59042),
(59043, '3.90.1010.10-FF-000017', NULL, 'Iron-sulfur cluster assembly scaffold protein', 147, NULL, NULL, 59043),
(59044, '2.130.10.30-FF-000120', NULL, NULL, 346, NULL, NULL, 59044),
(59045, '2.60.220.50-FF-000130', NULL, 'Predicted protein', 201, NULL, NULL, 59045),
(59046, '2.40.50.140-FF-000204', NULL, '30S ribosomal protein S17', 82, NULL, NULL, 59046),
(59047, '1.10.275.40-FF-000004', NULL, 'DNA repair helicase RAD3', 114, NULL, NULL, 59047),
(59048, '3.40.50.300-FF-002093', NULL, 'Structural maintenance of chromosomes protein', 164, NULL, NULL, 59048),
(59049, '3.40.50.300-FF-008388', NULL, 'Uncharacterized protein', 197, NULL, NULL, 59049),
(59050, '1.10.1520.10-FF-000014', NULL, '60S ribosomal protein L3', 207, NULL, NULL, 59050),
(59051, '3.30.710.10-FF-000462', NULL, 'Uncharacterized protein', 123, NULL, NULL, 59051),
(59052, '1.25.40.20-FF-001830', NULL, 'Kinase, NEK', 149, NULL, NULL, 59052),
(59053, '1.10.510.10-FF-001026', NULL, 'probable L-type lectin-domain containing receptor kinase S.5', 195, NULL, NULL, 59053),
(59054, '2.90.20.10-FF-000004', NULL, 'Wall-associated receptor kinase-like 18', 92, NULL, NULL, 59054),
(59055, '3.30.160.20-FF-000242', NULL, 'Mitochondrial translation release factor 1', 44, NULL, NULL, 59055),
(59056, '1.10.1600.10-FF-000015', NULL, 'Uncharacterized protein', 99, NULL, NULL, 59056);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(59057, '3.90.550.10-FF-000385', NULL, 'Glycoside transferase family 2', 196, NULL, NULL, 59057),
(59058, '1.10.150.80-FF-000030', NULL, 'Ribonuclease D', 79, NULL, NULL, 59058),
(59059, '2.60.40.150-FF-000797', NULL, 'Uncharacterized protein', 72, NULL, NULL, 59059),
(59060, '2.30.42.10-FF-000294', NULL, 'Uncharacterized protein, isoform A', 77, NULL, NULL, 59060),
(59061, '1.25.40.20-FF-000470', NULL, 'Suppressor protein SPT23, putative', 138, NULL, NULL, 59061),
(59062, '3.30.450.20-FF-000124', NULL, 'uncharacterized protein LOC108093306', 176, NULL, NULL, 59062),
(59063, '1.10.287.600-FF-000020', NULL, 'Tubulin beta chain', 66, NULL, NULL, 59063),
(59064, '3.40.50.1000-FF-000284', NULL, 'Nuclear LIM interactor-interacting factor 1', 199, NULL, NULL, 59064),
(59065, '3.40.30.10-FF-001213', NULL, 'Uncharacterized protein', 38, NULL, NULL, 59065),
(59066, '1.20.5.1430-FF-000013', NULL, 'Microtubule-binding protein, putative', 65, NULL, NULL, 59066),
(59067, '3.40.630.30-FF-000526', NULL, 'Histone acetyltransferase', 90, NULL, NULL, 59067),
(59068, '3.30.40.10-FF-001787', NULL, 'Ubiquitination factor E4a, putative', 62, NULL, NULL, 59068),
(59069, '3.30.200.20-FF-002270', NULL, NULL, 168, NULL, NULL, 59069),
(59070, '1.10.238.10-FF-001106', NULL, 'Uncharacterized protein', 60, NULL, NULL, 59070),
(59071, '1.10.540.10-FF-000022', NULL, 'Isovaleryl-CoA dehydrogenase isoform 2', 123, NULL, NULL, 59071),
(59072, '3.80.10.10-FF-001710', NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', 164, NULL, NULL, 59072),
(59073, '3.40.190.10-FF-000323', NULL, 'Related to HEM3-porphobilinogen deaminase', 75, NULL, NULL, 59073),
(59074, '1.10.357.110-FF-000002', NULL, 'Vacuolar protein sorting-associated protein 53 A', 141, NULL, NULL, 59074),
(59075, '1.25.40.10-FF-000910', NULL, 'Pentatricopeptide repeat-containing protein At5g14080', 265, NULL, NULL, 59075),
(59076, '3.30.500.10-FF-000013', NULL, 'Histocompatibility 2, blastocyst', 95, NULL, NULL, 59076),
(59077, '3.40.309.10-FF-000116', NULL, 'Predicted protein', 31, NULL, NULL, 59077),
(59078, '2.130.10.10-FF-001631', NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', 192, NULL, NULL, 59078),
(59079, '3.30.420.40-FF-000403', NULL, 'Actin 2 isoform 1', 109, NULL, NULL, 59079),
(59080, '3.40.190.10-FF-000267', NULL, 'HTH-type transcriptional regulator HdfR', 86, NULL, NULL, 59080),
(59081, '3.50.50.60-FF-000312', NULL, 'GMC-type oxidoreductase', 54, NULL, NULL, 59081),
(59082, '3.30.40.10-FF-001967', NULL, 'Uncharacterized protein', 63, NULL, NULL, 59082),
(59083, '1.20.58.400-FF-000043', NULL, 'Uncharacterized protein', 76, NULL, NULL, 59083),
(59084, '2.60.40.60-FF-000527', NULL, 'Dachsous cadherin-related 1a', 103, NULL, NULL, 59084),
(59085, '3.40.630.10-FF-000352', NULL, 'Uncharacterized protein', 192, NULL, NULL, 59085),
(59086, '2.60.40.10-FF-003744', NULL, 'Cellulose 1,4-beta-cellobiosidase', 98, NULL, NULL, 59086),
(59087, '2.40.70.10-FF-000032', NULL, 'renin', 173, NULL, NULL, 59087),
(59088, '1.10.287.1250-FF-000002', NULL, 'Phosphotransferase', 58, NULL, NULL, 59088),
(59089, '3.30.70.330-FF-000949', NULL, 'Uncharacterized protein, isoform A', 90, NULL, NULL, 59089),
(59090, '1.25.40.1050-FF-000001', NULL, '5''-3'' exoribonuclease 1', 100, NULL, NULL, 59090),
(59091, '3.80.10.10-FF-002166', NULL, 'GM14094', 212, NULL, NULL, 59091),
(59092, '1.10.940.10-FF-000007', NULL, 'rRNA cytosine-C5-methyltransferase', 140, NULL, NULL, 59092),
(59093, '3.80.10.10-FF-002222', NULL, 'Predicted protein', 176, NULL, NULL, 59093),
(59094, '2.60.40.10-FF-003800', NULL, NULL, 94, NULL, NULL, 59094),
(59095, '1.10.510.10-FF-003174', NULL, NULL, 162, NULL, NULL, 59095),
(59096, '3.30.200.20-FF-000706', NULL, 'Protein kinase', 114, NULL, NULL, 59096),
(59097, '3.40.50.300-FF-007432', NULL, 'Predicted protein', 258, NULL, NULL, 59097),
(59098, '3.30.160.60-FF-000574', NULL, 'sal-like protein 2 isoform X2', 32, NULL, NULL, 59098),
(59099, '1.25.40.10-FF-001366', NULL, 'Pentatricopeptide repeat-containing protein', 196, NULL, NULL, 59099);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(59100, '3.40.50.1360-FF-000060', NULL, '6-phosphogluconolactonase', 200, NULL, NULL, 59100),
(59101, '2.40.30.170-FF-000030', NULL, 'Membrane fusion protein (MFP) family protein', 106, NULL, NULL, 59101),
(59102, '2.60.120.1190-FF-000016', NULL, 'Uncharacterized protein', 176, NULL, NULL, 59102),
(59103, '1.20.1270.60-FF-000052', NULL, 'Rho GTPase activating protein 4', 273, NULL, NULL, 59103),
(59104, '3.30.70.330-FF-003030', NULL, NULL, 54, NULL, NULL, 59104),
(59105, '3.30.230.70-FF-000116', NULL, 'Predicted protein', 304, NULL, NULL, 59105),
(59106, '1.20.120.520-FF-000016', NULL, 'Glutaredoxin/malate transporter fusion protein', 143, NULL, NULL, 59106),
(59107, '3.90.70.10-FF-000909', NULL, 'Ubiquitinyl hydrolase 1', 175, NULL, NULL, 59107),
(59108, '3.90.1150.10-FF-000466', NULL, 'Uncharacterized protein', 129, NULL, NULL, 59108),
(59109, '4.10.240.10-FF-000089', NULL, 'Transcriptional regulator', 56, NULL, NULL, 59109),
(59110, '3.30.540.10-FF-000066', NULL, 'Probable inositol-1(Or 4)-monophosphatase / fructose-1,6-bisphosphatase, archaeal-type', 138, NULL, NULL, 59110),
(59111, '2.60.120.650-FF-000023', NULL, 'Probable lysine-specific demethylase ELF6', 348, NULL, NULL, 59111),
(59112, '1.20.120.1900-FF-000050', NULL, 'Gamma-tubulin complex component', 380, NULL, NULL, 59112),
(59113, '3.80.10.10-FF-002273', NULL, 'Uncharacterized protein', 93, NULL, NULL, 59113),
(59114, '3.30.70.100-FF-000049', NULL, 'copper-transporting ATPase 1', 73, NULL, NULL, 59114),
(59115, '3.10.310.10-FF-000008', NULL, 'Trans-L-3-hydroxyproline dehydratase', 161, NULL, NULL, 59115),
(59116, '3.40.50.720-FF-002151', NULL, 'Uncharacterized protein', 84, NULL, NULL, 59116),
(59117, '2.130.10.10-FF-002143', NULL, 'Brevis plant1', 175, NULL, NULL, 59117),
(59118, '3.50.50.60-FF-001509', NULL, 'Uncharacterized protein', 17, NULL, NULL, 59118),
(59119, '3.40.50.300-FF-006920', NULL, 'Uncharacterized protein', 233, NULL, NULL, 59119),
(59120, '3.10.129.10-FF-000284', NULL, 'Probable enoyl-CoA hydratase 2', 158, NULL, NULL, 59120),
(59121, '3.30.420.10-FF-000012', NULL, 'DNA polymerase III subunit epsilon', 181, NULL, NULL, 59121),
(59122, '3.20.190.10-FF-000018', NULL, 'Predicted protein', 59, NULL, NULL, 59122),
(59123, '3.30.160.270-FF-000007', NULL, '2-isopropylmalate synthase', 109, NULL, NULL, 59123),
(59124, '1.10.510.10-FF-004409', NULL, NULL, 80, NULL, NULL, 59124),
(59125, '2.10.25.10-FF-001373', NULL, 'Fibropellin-1', 39, NULL, NULL, 59125),
(59126, '1.10.510.10-FF-003123', NULL, NULL, 187, NULL, NULL, 59126),
(59127, '1.10.540.10-FF-000073', NULL, 'Acyl-coenzyme A oxidase', 132, NULL, NULL, 59127),
(59128, '3.90.226.10-FF-000171', NULL, 'Enoyl-CoA hydratase', 284, NULL, NULL, 59128),
(59129, '2.30.18.10-FF-000018', NULL, 'Transcription initiation factor IIA subunit 2', 47, NULL, NULL, 59129),
(59130, '3.40.50.300-FF-000288', NULL, 'DNA replication licensing factor MCM7', 336, NULL, NULL, 59130),
(59131, '1.10.560.10-FF-000080', NULL, 'TCP-1 chaperonin subunit beta', 230, NULL, NULL, 59131),
(59132, '2.40.50.100-FF-000215', NULL, 'Cytoplasmic membrane protein for maltose uptake', 45, NULL, NULL, 59132),
(59133, '1.25.10.10-FF-001538', NULL, 'V-type proton ATPase subunit H', 325, NULL, NULL, 59133),
(59134, '3.80.20.20-FF-000011', NULL, 'Tyrosine-protein kinase receptor', 231, NULL, NULL, 59134),
(59135, '3.30.160.60-FF-003340', NULL, 'Zinc finger protein 574', 23, NULL, NULL, 59135),
(59136, '1.20.58.1120-FF-000038', NULL, NULL, 145, NULL, NULL, 59136),
(59137, '2.130.10.10-FF-002194', NULL, 'Uncharacterized protein', 278, NULL, NULL, 59137),
(59138, '3.40.30.10-FF-001264', NULL, 'Uncharacterized protein', 94, NULL, NULL, 59138),
(59139, '3.10.28.10-FF-000051', NULL, 'Probable intron-encoded endonuclease aI3', 118, NULL, NULL, 59139),
(59140, '1.25.40.10-FF-001473', NULL, 'Os08g0162200 protein', 95, NULL, NULL, 59140),
(59141, '1.10.1320.10-FF-000010', NULL, 'DNA-directed RNA polymerase', 308, NULL, NULL, 59141),
(59142, '1.20.59.10-FF-000014', NULL, 'Chorismate mutase', 102, NULL, NULL, 59142),
(59143, '3.40.50.300-FF-002593', NULL, 'SNF2 family helicase/ATPase, putative', 248, NULL, NULL, 59143);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(59144, '3.40.50.300-FF-007325', NULL, 'Predicted protein', 145, NULL, NULL, 59144),
(59145, '3.40.50.10810-FF-000235', NULL, 'Protein CHROMATIN REMODELING 24', 220, NULL, NULL, 59145),
(59146, '2.60.120.200-FF-000293', NULL, 'NeuReXin related', 182, NULL, NULL, 59146),
(59147, '3.40.50.300-FF-006864', NULL, 'Cytosolic Fe-S cluster assembly factor NUBP1 homolog', 254, NULL, NULL, 59147),
(59148, '3.30.1640.10-FF-000056', NULL, 'DNA helicase', 100, NULL, NULL, 59148),
(59149, '4.10.240.10-FF-000145', NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', 77, NULL, NULL, 59149),
(59150, '2.130.10.10-FF-002087', NULL, 'Intraflagellar transport protein 122', 237, NULL, NULL, 59150),
(59151, '1.20.1070.10-FF-001831', NULL, 'Uncharacterized protein', 305, NULL, NULL, 59151),
(59152, '3.100.10.10-FF-000050', NULL, NULL, 87, NULL, NULL, 59152),
(59153, '3.30.300.130-FF-000021', NULL, 'BnaA04g19200D protein', 80, NULL, NULL, 59153),
(59154, '3.90.79.20-FF-000022', NULL, 'NAD+ diphosphatase, putative', 107, NULL, NULL, 59154),
(59155, '3.30.70.920-FF-000008', NULL, 'Transcriptional regulator, AsnC family', 85, NULL, NULL, 59155),
(59156, '3.30.200.20-FF-000757', NULL, 'Serine/threonine-protein kinase SSN3', 65, NULL, NULL, 59156),
(59157, '3.30.9.10-FF-000158', NULL, 'Glycerol-3-phosphate dehydrogenase', 56, NULL, NULL, 59157),
(59158, '3.40.50.1980-FF-000026', NULL, 'Histidinol dehydrogenase', 196, NULL, NULL, 59158),
(59159, '1.10.8.60-FF-000523', NULL, 'Uncharacterized protein', 19, NULL, NULL, 59159),
(59160, '3.30.230.10-FF-000256', NULL, 'Uncharacterized protein', 126, NULL, NULL, 59160),
(59161, '2.60.40.4100-FF-000030', NULL, 'Uncharacterized protein', 142, NULL, NULL, 59161),
(59162, '2.60.40.60-FF-000572', NULL, 'Cadherin 15, type 1, M-cadherin (myotubule)', 100, NULL, NULL, 59162),
(59163, '3.90.550.10-FF-000497', NULL, 'Nucleotide-diphospho-sugar transferase', 283, NULL, NULL, 59163),
(59164, '3.60.15.10-FF-000227', NULL, 'Cleavage and polyadenylation specificity factor 73-like Protein', 72, NULL, NULL, 59164),
(59165, '1.10.630.10-FF-000248', NULL, 'Cytochrome p450-like protein', 502, NULL, NULL, 59165),
(59166, '1.50.40.10-FF-000341', NULL, 'Predicted protein', 147, NULL, NULL, 59166),
(59167, '3.30.70.330-FF-002462', NULL, NULL, 82, NULL, NULL, 59167),
(59168, '3.30.450.40-FF-000231', NULL, 'Heat-inducible transcription repressor HrcA', 132, NULL, NULL, 59168),
(59169, '3.80.10.10-FF-000709', NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', 176, NULL, NULL, 59169),
(59170, '3.40.50.720-FF-002095', NULL, 'Uncharacterized protein', 134, NULL, NULL, 59170),
(59171, '1.10.640.10-FF-000081', NULL, 'Peroxidase, putative', 223, NULL, NULL, 59171),
(59172, '3.30.565.10-FF-000325', NULL, 'Two-component hybrid sensor and regulator', 151, NULL, NULL, 59172),
(59173, '1.20.1070.10-FF-000314', NULL, 'Adenosine receptor, isoform A', 328, NULL, NULL, 59173),
(59174, '3.60.21.10-FF-000376', NULL, 'Serine/threonine-protein phosphatase', 102, NULL, NULL, 59174),
(59175, '3.30.559.10-FF-000272', NULL, 'Predicted protein', 151, NULL, NULL, 59175),
(59176, '1.20.85.10-FF-000013', NULL, 'Uncharacterized protein', 84, NULL, NULL, 59176),
(59177, '3.40.50.2000-FF-000640', NULL, 'O-antigen polymerase', 171, NULL, NULL, 59177),
(59178, '3.40.50.620-FF-000715', NULL, 'Uncharacterized protein', 219, NULL, NULL, 59178),
(59179, '3.30.50.10-FF-000040', NULL, 'GATA-type zinc finger protein 1', 41, NULL, NULL, 59179),
(59180, '1.10.472.80-FF-000120', NULL, 'TBC domain containing protein', 128, NULL, NULL, 59180),
(59181, '3.30.1380.10-FF-000013', NULL, 'Uncharacterized protein', 111, NULL, NULL, 59181),
(59182, '2.130.10.10-FF-002879', NULL, 'Denticleless protein homolog', 205, NULL, NULL, 59182),
(59183, '3.30.565.10-FF-000157', NULL, 'Two-component sensor histidine kinase', 143, NULL, NULL, 59183),
(59184, '3.40.50.280-FF-000006', NULL, 'Methionine synthase (B12-dependent)', 128, NULL, NULL, 59184),
(59185, '1.25.40.10-FF-002726', NULL, 'Uncharacterized protein', 286, NULL, NULL, 59185); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(59186, '3.40.50.2300-FF-000691', NULL, 'Uncharacterized protein', 128, NULL, NULL, 59186),
(59187, '3.30.9.10-FF-000265', NULL, 'Predicted protein', 146, NULL, NULL, 59187),
(59188, '1.10.238.10-FF-000168', NULL, 'Solute carrier family 25 member 24', 78, NULL, NULL, 59188),
(59189, '2.20.70.10-FF-000246', NULL, 'Uncharacterized protein', 54, NULL, NULL, 59189),
(59190, '1.25.40.20-FF-001751', NULL, 'Phosphocholine transferase AnkX', 201, NULL, NULL, 59190),
(59191, '3.30.70.330-FF-000101', NULL, 'Protein MEI2-like 1', 95, NULL, NULL, 59191),
(59192, '1.10.10.10-FF-001066', NULL, 'Cullin family protein', 81, NULL, NULL, 59192),
(59193, '3.40.50.2000-FF-000752', NULL, 'UGT protein', 256, NULL, NULL, 59193),
(59194, '3.30.40.10-FF-000663', NULL, 'Histone-lysine N-methyltransferase NSD2', 63, NULL, NULL, 59194),
(59195, '3.40.50.300-FF-003958', NULL, 'DNA helicase', 89, NULL, NULL, 59195),
(59196, '2.130.10.10-FF-003503', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 248, NULL, NULL, 59196),
(59197, '2.30.29.90-FF-000011', NULL, 'Uncharacterized protein', 130, NULL, NULL, 59197),
(59198, '3.90.70.10-FF-000168', NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', 392, NULL, NULL, 59198),
(59199, '1.20.1560.10-FF-000222', NULL, 'ABC transporter B family member 19 isoform A', 27, NULL, NULL, 59199),
(59200, '3.30.70.1730-FF-000050', NULL, '54S ribosomal protein L11, mitochondrial', 156, NULL, NULL, 59200),
(59201, '3.40.50.300-FF-001300', NULL, 'Cytosolic Fe-S cluster assembly factor CFD1', 267, NULL, NULL, 59201),
(59202, '2.60.120.290-FF-000123', NULL, 'GD12774', 117, NULL, NULL, 59202),
(59203, '3.10.110.10-FF-000027', NULL, 'Ubiquitin-conjugating enzyme E2 36', 152, NULL, NULL, 59203),
(59204, '2.70.170.10-FF-000268', NULL, 'Uncharacterized protein', 129, NULL, NULL, 59204),
(59205, '2.10.25.10-FF-000024', NULL, 'Putative latent-transforming growth factor beta-binding protein 2', 41, NULL, NULL, 59205),
(59206, '3.30.70.2170-FF-000002', NULL, 'V-type ATP synthase subunit I', 68, NULL, NULL, 59206),
(59207, '1.20.200.10-FF-000039', NULL, 'Adenylosuccinate lyase', 35, NULL, NULL, 59207),
(59208, '3.90.1750.10-FF-000028', NULL, 'HECT E3 ubiquitin ligase', 160, NULL, NULL, 59208),
(59209, '2.170.150.10-FF-000001', NULL, 'Tumor protein, translationally-controlled 1', 172, NULL, NULL, 59209),
(59210, '3.30.40.10-FF-001231', NULL, 'RBR-type E3 ubiquitin transferase', 82, NULL, NULL, 59210),
(59211, '3.40.850.10-FF-000239', NULL, 'Kinesin, putative', 179, NULL, NULL, 59211),
(59212, '3.40.50.1820-FF-001760', NULL, 'Uncharacterized protein', 230, NULL, NULL, 59212),
(59213, '1.20.120.730-FF-000012', NULL, 'Protein transport protein Sec24A', 121, NULL, NULL, 59213),
(59214, '3.30.450.50-FF-000060', NULL, 'Synaptobrevin', 131, NULL, NULL, 59214),
(59215, '3.30.40.10-FF-000118', NULL, 'Putative polycomb group RING finger protein 5', 107, NULL, NULL, 59215),
(59216, '3.40.50.1240-FF-000046', NULL, 'Phosphoglycerate mutase', 253, NULL, NULL, 59216),
(59217, '1.10.510.10-FF-000245', NULL, 'serine/threonine-protein kinase STK11', 194, NULL, NULL, 59217),
(59218, '3.40.50.11260-FF-000016', NULL, 'Hsp90 domain protein', 81, NULL, NULL, 59218),
(59219, '3.90.550.10-FF-000441', NULL, 'Uncharacterized protein', 85, NULL, NULL, 59219),
(59220, '1.25.40.720-FF-000012', NULL, 'Predicted protein', 133, NULL, NULL, 59220),
(59221, '3.90.550.10-FF-000553', NULL, 'Uncharacterized protein', 226, NULL, NULL, 59221),
(59222, '3.40.50.300-FF-003902', NULL, 'RE19845p', 235, NULL, NULL, 59222),
(59223, '1.20.1250.20-FF-000185', NULL, 'sodium-dependent lysophosphatidylcholine symporter 1 isoform X1', 226, NULL, NULL, 59223),
(59224, '3.40.1350.10-FF-000026', NULL, 'tRNA-splicing endonuclease subunit Sen2', 43, NULL, NULL, 59224),
(59225, '1.25.40.20-FF-000638', NULL, 'WGS project CABT00000000 data, contig 2.8', 109, NULL, NULL, 59225),
(59226, '1.10.357.10-FF-000017', NULL, 'TetR family transcriptional regulator', 202, NULL, NULL, 59226),
(59227, '1.50.10.20-FF-000050', NULL, 'Geranylgeranyl transferase type-1 subunit beta', 359, NULL, NULL, 59227);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(59228, '1.10.510.10-FF-004516', NULL, NULL, 181, NULL, NULL, 59228),
(59229, '1.20.1070.10-FF-001775', NULL, 'Olfactory receptor 282', 31, NULL, NULL, 59229),
(59230, '3.30.160.60-FF-006206', NULL, NULL, 34, NULL, NULL, 59230),
(59231, '3.30.300.30-FF-000127', NULL, 'Acetyl-CoA synthetase (Acetate-CoA ligase) carboxy-end. (AcsA-3)', 71, NULL, NULL, 59231),
(59232, '1.50.40.10-FF-000397', NULL, 'Predicted protein', 126, NULL, NULL, 59232),
(59233, '3.90.226.10-FF-000019', NULL, 'Enoyl-CoA hydratase, mitochondrial', 199, NULL, NULL, 59233),
(59234, '3.30.450.40-FF-000175', NULL, 'Regulator of polyketide synthase expression', 164, NULL, NULL, 59234),
(59235, '3.80.10.10-FF-001761', NULL, 'Toll-like receptor 19', 231, NULL, NULL, 59235),
(59236, '1.10.10.10-FF-000976', NULL, 'Protein CBG12577', 83, NULL, NULL, 59236),
(59237, '1.20.120.1750-FF-000072', NULL, 'RBR-type E3 ubiquitin transferase', 150, NULL, NULL, 59237),
(59238, '1.10.460.10-FF-000021', NULL, 'DNA topoisomerase', 45, NULL, NULL, 59238),
(59239, '1.20.1070.10-FF-002175', NULL, 'Predicted protein', 115, NULL, NULL, 59239),
(59240, '3.30.1370.50-FF-000013', NULL, 'Unplaced genomic scaffold supercont2.5, whole genome shotgun sequence', 98, NULL, NULL, 59240),
(59241, '1.50.40.10-FF-000285', NULL, 'Peroxisomal membrane protein, putative', 165, NULL, NULL, 59241),
(59242, '1.10.1370.40-FF-000005', NULL, 'Organellar oligopeptidase A, chloroplastic/mitochondrial', 170, NULL, NULL, 59242),
(59243, '1.20.58.60-FF-000021', NULL, 'Microtubule-actin cross-linking factor 1', 109, NULL, NULL, 59243),
(59244, '1.10.441.10-FF-000005', NULL, 'Mannose-6-phosphate isomerase, class I', 82, NULL, NULL, 59244),
(59245, '3.40.120.10-FF-000049', NULL, 'Phosphoacetylglucosamine mutase', 109, NULL, NULL, 59245),
(59246, '3.10.129.10-FF-000177', NULL, '4-hydroxybenzoyl-CoA thioesterase family protein', 145, NULL, NULL, 59246),
(59247, '2.60.40.10-FF-003795', NULL, NULL, 97, NULL, NULL, 59247),
(59248, '1.10.510.10-FF-003067', NULL, NULL, 250, NULL, NULL, 59248),
(59249, '3.40.50.300-FF-003161', NULL, 'Protein Rep68', 212, NULL, NULL, 59249),
(59250, '3.40.50.12440-FF-000005', NULL, 'Nitrate reductase NarX', 213, NULL, NULL, 59250),
(59251, '3.30.160.60-FF-003396', NULL, 'Zinc finger protein GLIS2 homolog', 28, NULL, NULL, 59251),
(59252, '3.40.50.300-FF-000176', NULL, 'bifunctional heparan sulfate N-deacetylase/N-sulfotransferase 1', 304, NULL, NULL, 59252),
(59253, '3.40.50.300-FF-004447', NULL, 'Replicative DNA helicase', 148, NULL, NULL, 59253),
(59254, '3.40.30.10-FF-000696', NULL, 'Protein disulfide-isomerase', 137, NULL, NULL, 59254),
(59255, '2.60.120.260-FF-000468', NULL, 'Uncharacterized protein', 43, NULL, NULL, 59255),
(59256, '2.30.29.90-FF-000016', NULL, 'Uncharacterized protein', 79, NULL, NULL, 59256),
(59257, '2.30.29.30-FF-001089', NULL, 'IL2-inducible T cell kinase', 54, NULL, NULL, 59257),
(59258, '3.40.50.2300-FF-000516', NULL, 'Metabotropic glutamate receptor-like protein A', 139, NULL, NULL, 59258),
(59259, '3.20.20.70-FF-000236', NULL, 'Deoxyribose-phosphate aldolase', 260, NULL, NULL, 59259),
(59260, '3.30.160.60-FF-004756', NULL, NULL, 49, NULL, NULL, 59260),
(59261, '1.10.510.10-FF-002611', NULL, NULL, 141, NULL, NULL, 59261),
(59262, '3.40.50.360-FF-000115', NULL, 'NADPH--cytochrome P450 reductase', 177, NULL, NULL, 59262),
(59263, '2.60.40.2030-FF-000055', NULL, 'Adhesion G-protein coupled receptor V1', 123, NULL, NULL, 59263),
(59264, '1.10.357.50-FF-000001', NULL, 'Protein unc-13 homolog B', 171, NULL, NULL, 59264),
(59265, '2.40.420.20-FF-000062', NULL, 'Probable membrane-fusion protein', 65, NULL, NULL, 59265),
(59266, '1.10.357.10-FF-000068', NULL, 'Copper outer membrane regulator', 198, NULL, NULL, 59266),
(59267, '3.40.50.300-FF-002761', NULL, 'DNA repair protein RAD55', 286, NULL, NULL, 59267),
(59268, '3.40.1110.10-FF-000025', NULL, 'Phospholipid-transporting ATPase', 134, NULL, NULL, 59268),
(59269, '3.90.110.10-FF-000026', NULL, NULL, 159, NULL, NULL, 59269),
(59270, '2.30.29.30-FF-000544', NULL, 'Binding protein', 120, NULL, NULL, 59270);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(59271, '3.90.1150.10-FF-000522', NULL, 'Uncharacterized protein', 65, NULL, NULL, 59271),
(59272, '2.20.28.10-FF-000036', NULL, 'DNA replication licensing factor, MCM2/3/5 family', 49, NULL, NULL, 59272),
(59273, '3.30.200.20-FF-001106', NULL, 'Guanylate cyclase', 72, NULL, NULL, 59273),
(59274, '1.20.1270.60-FF-000001', NULL, 'Rho GTPase-activating protein 26', 256, NULL, NULL, 59274),
(59275, '3.50.50.60-FF-000256', NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', 255, NULL, NULL, 59275),
(59276, '3.10.20.90-FF-000591', NULL, 'Fermitin family homolog 2', 42, NULL, NULL, 59276),
(59277, '2.60.40.2860-FF-000011', NULL, 'Transmission-blocking target antigen S230', 121, NULL, NULL, 59277),
(59278, '2.60.40.10-FF-000922', NULL, 'hepatocyte cell adhesion molecule isoform X1', 94, NULL, NULL, 59278),
(59279, '2.40.50.90-FF-000066', NULL, 'Tudor domain containing protein', 155, NULL, NULL, 59279),
(59280, '2.60.120.970-FF-000113', NULL, 'Bone morphogenetic protein 7', 102, NULL, NULL, 59280),
(59281, '3.20.20.80-FF-000857', NULL, 'Uncharacterized protein', 312, NULL, NULL, 59281),
(59282, '3.80.10.10-FF-003508', NULL, 'RNI-like superfamily protein', 184, NULL, NULL, 59282),
(59283, '3.40.50.2300-FF-001180', NULL, NULL, 62, NULL, NULL, 59283),
(59284, '3.40.1380.20-FF-000076', NULL, 'Pyruvate kinase', 50, NULL, NULL, 59284),
(59285, '3.40.50.12780-FF-000197', NULL, 'Uncharacterized protein', 398, NULL, NULL, 59285),
(59286, '4.10.400.10-FF-000124', NULL, 'Low density lipoprotein receptor', 52, NULL, NULL, 59286),
(59287, '3.40.190.10-FF-000216', NULL, 'Porphobilinogen deaminase, variant', 107, NULL, NULL, 59287),
(59288, '1.25.40.10-FF-004351', NULL, 'Peptidylprolyl isomerase', 72, NULL, NULL, 59288),
(59289, '1.20.960.40-FF-000004', NULL, 'Oral-facial-digital syndrome 1', 78, NULL, NULL, 59289),
(59290, '2.60.40.1670-FF-000025', NULL, NULL, 165, NULL, NULL, 59290),
(59291, '2.20.140.10-FF-000002', NULL, 'Poly [ADP-ribose] polymerase', 71, NULL, NULL, 59291),
(59292, '3.30.70.330-FF-000152', NULL, 'poly(U)-binding-splicing factor PUF60 isoform X1', 86, NULL, NULL, 59292),
(59293, '1.25.40.450-FF-000015', NULL, 'Chromosome 10, whole genome shotgun sequence', 170, NULL, NULL, 59293),
(59294, '2.160.20.10-FF-000192', NULL, 'F-box only protein 11-like Protein', 141, NULL, NULL, 59294),
(59295, '2.40.50.140-FF-000435', NULL, 'Ribonuclease R', 151, NULL, NULL, 59295),
(59296, '1.20.1160.20-FF-000021', NULL, 'Uncharacterized protein', 75, NULL, NULL, 59296),
(59297, '3.30.1490.100-FF-000046', NULL, 'AAR136Wp', 120, NULL, NULL, 59297),
(59298, '3.40.50.1240-FF-000097', NULL, 'Histidine phosphatase superfamily (Branch 1), putative', 234, NULL, NULL, 59298),
(59299, '3.90.190.10-FF-000306', NULL, 'Protein-tyrosine phosphatase n9, putative', 65, NULL, NULL, 59299),
(59300, '2.40.10.10-FF-000427', NULL, 'IP19441p', 231, NULL, NULL, 59300),
(59301, '3.40.50.300-FF-005408', NULL, 'Probable helicase DDB_G0274399', 300, NULL, NULL, 59301),
(59302, '3.40.50.720-FF-000419', NULL, 'Decaprenylphosphoryl-D-2-keto erythropentose reductase', 245, NULL, NULL, 59302),
(59303, '3.30.1520.10-FF-000132', NULL, 'Uncharacterized protein', 116, NULL, NULL, 59303),
(59304, '1.20.58.60-FF-000072', NULL, 'Spectrin beta chain', 115, NULL, NULL, 59304),
(59305, '3.30.160.60-FF-002839', NULL, 'Zinc finger protein 621', 29, NULL, NULL, 59305),
(59306, '1.25.40.10-FF-003390', NULL, 'Pentatricopeptide repeat-containing protein isoform A', 141, NULL, NULL, 59306),
(59307, '2.40.30.10-FF-000142', NULL, 'Ferredoxin NADP reductase', 160, NULL, NULL, 59307),
(59308, '1.20.1250.20-FF-001489', NULL, 'Monocarboxylate transporter, putative', 134, NULL, NULL, 59308),
(59309, '2.120.10.30-FF-000429', NULL, 'Uncharacterized protein', 139, NULL, NULL, 59309),
(59310, '3.30.70.330-FF-001113', NULL, 'RNP domain protein', 155, NULL, NULL, 59310),
(59311, '3.60.130.10-FF-000045', NULL, 'Uncharacterized protein', 345, NULL, NULL, 59311),
(59312, '3.40.850.10-FF-000391', NULL, 'Kinesin-like protein', 293, NULL, NULL, 59312),
(59313, '3.30.200.20-FF-002382', NULL, 'Uncharacterized protein', 85, NULL, NULL, 59313);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(59314, '3.10.40.10-FF-000001', NULL, 'Aerolysin', 90, NULL, NULL, 59314),
(59315, '3.30.160.60-FF-005189', NULL, NULL, 28, NULL, NULL, 59315),
(59316, '3.90.226.10-FF-000194', NULL, 'Enoyl-CoA hydratase/isomerase, putative', 262, NULL, NULL, 59316),
(59317, '3.30.60.270-FF-000002', NULL, 'Sortilin-related receptor isoform A', 82, NULL, NULL, 59317),
(59318, '1.20.58.340-FF-000019', NULL, 'CorA-like Mg2+ transporter protein', 177, NULL, NULL, 59318),
(59319, '3.80.10.10-FF-001822', NULL, 'GH22922p', 121, NULL, NULL, 59319),
(59320, '1.20.5.110-FF-000187', NULL, 'SNARE domain containing protein', 100, NULL, NULL, 59320),
(59321, '1.20.5.110-FF-000243', NULL, 'Uncharacterized protein', 103, NULL, NULL, 59321),
(59322, '3.30.450.20-FF-000309', NULL, 'Hybrid sensor histidine kinase/response regulator', 92, NULL, NULL, 59322),
(59323, '3.50.50.60-FF-000200', NULL, 'Thioredoxin reductase 2, mitochondrial', 162, NULL, NULL, 59323),
(59324, '3.10.129.10-FF-000210', NULL, 'Thioesterase domain protein', 130, NULL, NULL, 59324),
(59325, '3.80.10.10-FF-001766', NULL, 'MstProx', 145, NULL, NULL, 59325),
(59326, '1.20.1250.20-FF-000741', NULL, 'Phosphate transporter', 259, NULL, NULL, 59326),
(59327, '1.10.760.10-FF-000061', NULL, 'Di-heme cytochrome C peroxidase', 139, NULL, NULL, 59327),
(59328, '2.130.10.10-FF-005009', NULL, 'Coronin', 47, NULL, NULL, 59328),
(59329, '3.30.70.330-FF-000837', NULL, 'Hrp1p', 123, NULL, NULL, 59329),
(59330, '3.30.160.780-FF-000003', NULL, 'Uncharacterized protein', 63, NULL, NULL, 59330),
(59331, '1.20.58.80-FF-000078', NULL, 'Related to yeast Vacuolar Protein Sorting factor', 85, NULL, NULL, 59331),
(59332, '3.40.50.150-FF-001507', NULL, NULL, 111, NULL, NULL, 59332),
(59333, '3.80.10.10-FF-000249', NULL, 'Leucine rich repeat containing 39', 123, NULL, NULL, 59333),
(59334, '1.20.1070.10-FF-001770', NULL, 'Olfactory receptor 1415', 56, NULL, NULL, 59334),
(59335, '1.20.1250.20-FF-001197', NULL, 'Glucose/mannose transporter GlcP', 189, NULL, NULL, 59335),
(59336, '1.10.8.60-FF-000023', NULL, 'Holliday junction ATP-dependent DNA helicase RuvB', 73, NULL, NULL, 59336),
(59337, '1.25.40.20-FF-001195', NULL, 'Uncharacterized protein', 212, NULL, NULL, 59337),
(59338, '3.60.10.10-FF-000019', NULL, 'Type IV inositol polyphosphate 5-phosphatase 7', 286, NULL, NULL, 59338),
(59339, '1.20.120.1630-FF-000002', NULL, 'Steroid 5 alpha-reductase 1', 175, NULL, NULL, 59339),
(59340, '3.30.1370.10-FF-000187', NULL, 'YALI0C05324p', 91, NULL, NULL, 59340),
(59341, '1.25.40.270-FF-000006', NULL, 'Glucan synthase-like 10', 160, NULL, NULL, 59341),
(59342, '3.40.50.300-FF-007320', NULL, 'Predicted protein', 146, NULL, NULL, 59342),
(59343, '1.10.2000.10-FF-000048', NULL, NULL, 52, NULL, NULL, 59343),
(59344, '1.10.3050.10-FF-000001', NULL, 'Nucleoprotein', 135, NULL, NULL, 59344),
(59345, '1.10.418.10-FF-000098', NULL, 'Uncharacterized protein', 107, NULL, NULL, 59345),
(59346, '1.20.5.190-FF-000109', NULL, NULL, 58, NULL, NULL, 59346),
(59347, '3.80.30.20-FF-000017', NULL, 'Threonylcarbamoyladenosine tRNA methylthiotransferase MtaB', 233, NULL, NULL, 59347),
(59348, '2.60.40.10-FF-000866', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', 108, NULL, NULL, 59348),
(59349, '1.20.5.600-FF-000002', NULL, 'Potassium voltage-gated channel, shaker-related subfamily, member 4', 93, NULL, NULL, 59349),
(59350, '3.30.40.100-FF-000009', NULL, 'Zinc ion binding protein', 60, NULL, NULL, 59350),
(59351, '3.30.420.40-FF-000515', NULL, 'Glycerol kinase', 240, NULL, NULL, 59351),
(59352, '1.20.58.80-FF-000027', NULL, 'AMSH-like protease', 143, NULL, NULL, 59352),
(59353, '3.30.470.20-FF-000075', NULL, 'Putative periplasmic protein', 116, NULL, NULL, 59353),
(59354, '2.60.40.10-FF-001142', NULL, 'Immunoglobulin heavy variable 5-15', 111, NULL, NULL, 59354),
(59355, '1.20.1250.20-FF-001545', NULL, 'Folate-biopterin transporter', 419, NULL, NULL, 59355),
(59356, '2.60.40.1180-FF-000030', NULL, 'Alpha-mannosidase', 112, NULL, NULL, 59356),
(59357, '1.10.1200.10-FF-000030', NULL, 'Ebony protein', 71, NULL, NULL, 59357);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(59358, '3.30.1490.20-FF-000064', NULL, 'Alpha-L-glutamate ligase, RimK family', 66, NULL, NULL, 59358),
(59359, '1.20.1740.10-FF-000219', NULL, 'AGAP011500-PA', 76, NULL, NULL, 59359),
(59360, '3.30.70.2850-FF-000015', NULL, 'DNA-directed RNA polymerase I subunit rpa1', 235, NULL, NULL, 59360),
(59361, '3.40.50.2000-FF-000701', NULL, 'Glycosyl transferase group 1', 179, NULL, NULL, 59361),
(59362, '2.60.200.20-FF-000209', NULL, 'Predicted protein', 138, NULL, NULL, 59362),
(59363, '3.30.200.20-FF-000701', NULL, 'CMGC/DYRK protein kinase', 55, NULL, NULL, 59363),
(59364, '2.120.10.30-FF-000530', NULL, 'Uncharacterized protein', 143, NULL, NULL, 59364),
(59365, '2.60.40.10-FF-001086', NULL, 'Cell surface glycoprotein MUC18', 97, NULL, NULL, 59365),
(59366, '3.30.479.30-FF-000041', NULL, 'Predicted protein', 135, NULL, NULL, 59366),
(59367, '2.40.10.10-FF-000472', NULL, NULL, 44, NULL, NULL, 59367),
(59368, '2.40.30.170-FF-000035', NULL, 'Resistance-Nodulation-Cell Division (RND) efflux membrane fusion protein', 82, NULL, NULL, 59368),
(59369, '1.10.510.10-FF-002723', NULL, NULL, 246, NULL, NULL, 59369),
(59370, '2.130.10.10-FF-005072', NULL, 'WD-40 repeat protein, putative', 269, NULL, NULL, 59370),
(59371, '3.80.10.10-FF-003559', NULL, 'Uncharacterized protein', 148, NULL, NULL, 59371),
(59372, '3.30.230.10-FF-000200', NULL, 'N-acetylgalactosamine kinase', 46, NULL, NULL, 59372),
(59373, '2.60.40.2450-FF-000001', NULL, 'Beta-1,3-xylanase', 99, NULL, NULL, 59373),
(59374, '1.10.238.10-FF-001129', NULL, 'Uncharacterized protein', 165, NULL, NULL, 59374),
(59375, '1.20.5.170-FF-000103', NULL, 'tropomyosin alpha-1 chain isoform X10', 43, NULL, NULL, 59375),
(59376, '1.20.120.520-FF-000011', NULL, 'Heavy metal translocating P-type ATPase', 146, NULL, NULL, 59376),
(59377, '1.50.10.10-FF-000221', NULL, 'Uncharacterized protein', 76, NULL, NULL, 59377),
(59378, '1.10.10.60-FF-001171', NULL, NULL, 42, NULL, NULL, 59378),
(59379, '1.10.10.830-FF-000015', NULL, 'Uncharacterized protein', 48, NULL, NULL, 59379),
(59380, '1.20.1160.20-FF-000026', NULL, 'Uncharacterized protein', 47, NULL, NULL, 59380),
(59381, '3.20.20.80-FF-000621', NULL, 'Uncharacterized protein', 140, NULL, NULL, 59381),
(59382, '2.30.30.1020-FF-000028', NULL, 'GD24003', 175, NULL, NULL, 59382),
(59383, '3.30.530.20-FF-000170', NULL, 'Abscisic acid receptor PYL9', 119, NULL, NULL, 59383),
(59384, '1.10.238.10-FF-001281', NULL, 'Uncharacterized protein', 63, NULL, NULL, 59384),
(59385, '1.10.418.10-FF-000154', NULL, 'girdin', 153, NULL, NULL, 59385),
(59386, '3.20.20.150-FF-000051', NULL, 'Xylose isomerase-like TIM barrel', 256, NULL, NULL, 59386),
(59387, '1.10.600.10-FF-000128', NULL, 'Geranylgeranyl pyrophosphate synthase', 344, NULL, NULL, 59387),
(59388, '1.10.510.10-FF-000301', NULL, 'Serine/threonine-protein kinase Chk1', 178, NULL, NULL, 59388),
(59389, '2.40.50.140-FF-000486', NULL, 'Ribonuclease, Rne/Rng family', 120, NULL, NULL, 59389),
(59390, '2.40.10.10-FF-000028', NULL, 'Serine protease easter', 116, NULL, NULL, 59390),
(59391, '2.60.40.10-FF-001434', NULL, 'titin isoform X1', 92, NULL, NULL, 59391),
(59392, '3.40.50.960-FF-000019', NULL, '6,7-dimethyl-8-ribityllumazine synthase', 60, NULL, NULL, 59392),
(59393, '1.20.210.10-FF-000040', NULL, 'COX1-i7 protein, alternatively spliced', 377, NULL, NULL, 59393),
(59394, '1.10.10.10-FF-000009', NULL, 'LexA repressor', 69, NULL, NULL, 59394),
(59395, '3.40.390.10-FF-000248', NULL, NULL, 11, NULL, NULL, 59395),
(59396, '3.40.50.300-FF-007264', NULL, 'Uncharacterized protein', 156, NULL, NULL, 59396),
(59397, '2.60.40.150-FF-000162', NULL, 'Synaptotagmin-15', 127, NULL, NULL, 59397),
(59398, '1.10.940.10-FF-000002', NULL, 'Ribosomal RNA small subunit methyltransferase B', 145, NULL, NULL, 59398),
(59399, '3.40.50.10810-FF-000128', NULL, 'SNF2_family_N-terminal_domain /Helicase_conserved_C-terminal_domain_containing_protein_-_putative', 288, NULL, NULL, 59399),
(59400, '1.20.1560.10-FF-000166', NULL, 'Putative ABC transporter', 323, NULL, NULL, 59400),
(59401, '1.25.10.10-FF-002994', NULL, 'Uncharacterized protein', 366, NULL, NULL, 59401);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(59402, '3.90.190.10-FF-000418', NULL, 'Dual specificity protein phosphatase, putative', 93, NULL, NULL, 59402),
(59403, '3.40.50.790-FF-000002', NULL, 'Ribosomal protein', 90, NULL, NULL, 59403),
(59404, '2.40.70.10-FF-000532', NULL, NULL, 202, NULL, NULL, 59404),
(59405, '1.25.40.10-FF-000017', NULL, 'NADPH oxidase regulator NoxR', 193, NULL, NULL, 59405),
(59406, '2.10.25.10-FF-000884', NULL, 'Delta-like protein', 37, NULL, NULL, 59406),
(59407, '3.30.160.60-FF-002940', NULL, 'Zinc finger protein 236', 75, NULL, NULL, 59407),
(59408, '2.130.10.110-FF-000008', NULL, 'Clathrin heavy chain', 369, NULL, NULL, 59408),
(59409, '3.40.50.620-FF-000030', NULL, 'Arginine--tRNA ligase', 345, NULL, NULL, 59409),
(59410, '1.25.10.10-FF-003270', NULL, 'Uncharacterized protein', 205, NULL, NULL, 59410),
(59411, '1.10.1300.10-FF-000071', NULL, 'Uncharacterized protein', 113, NULL, NULL, 59411),
(59412, '3.20.20.70-FF-000287', NULL, '2-isopropylmalate synthase', 324, NULL, NULL, 59412),
(59413, '2.130.10.10-FF-003211', NULL, 'Transducin/WD-40 repeat protein family', 59, NULL, NULL, 59413),
(59414, '3.40.50.12780-FF-000192', NULL, 'Uncharacterized protein', 116, NULL, NULL, 59414),
(59415, '1.20.1560.10-FF-000514', NULL, 'YALI0A19580p', 322, NULL, NULL, 59415),
(59416, '3.30.420.10-FF-000063', NULL, 'Retrovirus-related Pol polyprotein from transposon 297-like Protein', 192, NULL, NULL, 59416),
(59417, '3.30.450.20-FF-000461', NULL, 'Hypoxia-inducible factor 1 subunit alpha,-like 2', 138, NULL, NULL, 59417),
(59418, '2.30.30.140-FF-000091', NULL, 'Tudor domain-containing protein 1', 71, NULL, NULL, 59418),
(59419, '1.20.58.1120-FF-000033', NULL, 'Dynein heavy chain, putative', 163, NULL, NULL, 59419),
(59420, '2.60.220.30-FF-000028', NULL, 'Unc-5 netrin receptor B', 75, NULL, NULL, 59420),
(59421, '1.10.510.10-FF-002162', NULL, NULL, 25, NULL, NULL, 59421),
(59422, '1.10.150.20-FF-000091', NULL, 'Unplaced genomic scaffold supercont1.20, whole genome shotgun sequence', 95, NULL, NULL, 59422),
(59423, '3.40.50.10490-FF-000100', NULL, 'MurR/RpiR family transcriptional regulator', 178, NULL, NULL, 59423),
(59424, '1.20.1560.10-FF-000458', NULL, 'Uncharacterized protein', 141, NULL, NULL, 59424),
(59425, '2.120.10.30-FF-000581', NULL, 'Uncharacterized protein', 156, NULL, NULL, 59425),
(59426, '3.30.160.60-FF-001827', NULL, 'zinc finger protein 629 isoform X2', 42, NULL, NULL, 59426),
(59427, '3.30.160.60-FF-002991', NULL, 'C2H2 transcription factor, putative', 33, NULL, NULL, 59427),
(59428, '3.40.50.300-FF-003610', NULL, 'RAB24, member RAS oncogene family', 162, NULL, NULL, 59428),
(59429, '1.10.1200.80-FF-000011', NULL, 'tRNA-dihydrouridine synthase', 69, NULL, NULL, 59429),
(59430, '2.40.37.10-FF-000005', NULL, 'Ornithine decarboxylase', 145, NULL, NULL, 59430),
(59431, '3.80.20.20-FF-000016', NULL, 'Cell wall protein ECM33', 146, NULL, NULL, 59431),
(59432, '3.40.50.2000-FF-000696', NULL, 'Glycosyltransferase, group 1 family protein', 182, NULL, NULL, 59432),
(59433, '2.60.40.150-FF-000561', NULL, 'Uncharacterized protein', 141, NULL, NULL, 59433),
(59434, '2.70.170.10-FF-000156', NULL, 'Uncharacterized protein', 169, NULL, NULL, 59434),
(59435, '2.40.50.140-FF-000143', NULL, 'DIS3-like exonuclease 1 isoform X1', 97, NULL, NULL, 59435),
(59436, '2.30.130.30-FF-000005', NULL, 'UPF0267 protein VC_1576', 102, NULL, NULL, 59436),
(59437, '2.60.40.10-FF-005324', NULL, NULL, 77, NULL, NULL, 59437),
(59438, '1.25.40.570-FF-000034', NULL, 'Eukaryotic translation initiation factor 3 subunit C', 97, NULL, NULL, 59438),
(59439, '1.10.8.60-FF-000579', NULL, 'Uncharacterized protein', 44, NULL, NULL, 59439),
(59440, '3.30.160.60-FF-001479', NULL, 'ZFP69 zinc finger protein B', 29, NULL, NULL, 59440),
(59441, '2.20.25.10-FF-000119', NULL, 'Transcription factor S-II-like protein', 45, NULL, NULL, 59441),
(59442, '3.40.720.10-FF-000286', NULL, 'Uncharacterized protein', 277, NULL, NULL, 59442),
(59443, '1.10.472.130-FF-000048', NULL, 'Uncharacterized protein', 149, NULL, NULL, 59443),
(59444, '1.20.58.60-FF-000813', NULL, 'Uncharacterized protein', 193, NULL, NULL, 59444);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(59445, '3.40.640.10-FF-000285', NULL, 'dTDP-4-dehydro-6-deoxy-D-glucose 4-aminotransferase', 244, NULL, NULL, 59445),
(59446, '1.50.40.10-FF-000392', NULL, 'Solute carrier family 25 member 18', 184, NULL, NULL, 59446),
(59447, '2.60.120.260-FF-000524', NULL, 'Uncharacterized protein', 85, NULL, NULL, 59447),
(59448, '2.60.120.970-FF-000057', NULL, 'Uncharacterized protein', 214, NULL, NULL, 59448),
(59449, '1.10.10.10-FF-000633', NULL, 'U5 small nuclear ribonucleoprotein-specific protein', 96, NULL, NULL, 59449),
(59450, '3.30.70.330-FF-000096', NULL, 'U2 snRNP auxiliary factor large subunit', 108, NULL, NULL, 59450),
(59451, '1.10.10.10-FF-001122', NULL, 'Manganese transport regulator MntR', 67, NULL, NULL, 59451),
(59452, '3.10.100.10-FF-000234', NULL, NULL, 149, NULL, NULL, 59452),
(59453, '1.10.150.770-FF-000004', NULL, NULL, 74, NULL, NULL, 59453),
(59454, '2.130.10.10-FF-004796', NULL, 'Uncharacterized protein', 148, NULL, NULL, 59454),
(59455, '3.30.160.60-FF-003391', NULL, 'TPR-containing protein DDB_G0280363', 64, NULL, NULL, 59455),
(59456, '1.20.1070.10-FF-000258', NULL, 'G-protein coupled receptor', 311, NULL, NULL, 59456),
(59457, '1.25.40.470-FF-000066', NULL, 'Osm-1', 124, NULL, NULL, 59457),
(59458, '3.40.50.720-FF-002544', NULL, 'Uncharacterized protein', 71, NULL, NULL, 59458),
(59459, '3.30.565.10-FF-000269', NULL, 'Sensory box histidine kinase', 159, NULL, NULL, 59459),
(59460, '3.40.50.150-FF-000277', NULL, 'RNA methyltransferase', 163, NULL, NULL, 59460),
(59461, '3.20.20.300-FF-000062', NULL, NULL, 354, NULL, NULL, 59461),
(59462, '3.30.470.20-FF-000131', NULL, 'ATP domain protein', 124, NULL, NULL, 59462),
(59463, '1.20.5.1500-FF-000006', NULL, 'Testis-specific Y-encoded-like protein 2', 78, NULL, NULL, 59463),
(59464, '1.25.10.10-FF-002106', NULL, 'Uncharacterized protein', 339, NULL, NULL, 59464),
(59465, '1.10.472.10-FF-000375', NULL, 'Uncharacterized protein', 153, NULL, NULL, 59465),
(59466, '3.30.930.10-FF-000326', NULL, 'Uncharacterized protein', 163, NULL, NULL, 59466),
(59467, '3.40.190.80-FF-000012', NULL, 'Inositol-1-monophosphatase', 126, NULL, NULL, 59467),
(59468, '2.60.120.260-FF-000176', NULL, 'Si:ch211-12m10.1', 136, NULL, NULL, 59468),
(59469, '2.60.40.10-FF-005537', NULL, NULL, 49, NULL, NULL, 59469),
(59470, '3.40.50.150-FF-001570', NULL, NULL, 67, NULL, NULL, 59470),
(59471, '1.10.150.480-FF-000001', NULL, 'Fibronectin-binding protein', 99, NULL, NULL, 59471),
(59472, '3.60.21.60-FF-000037', NULL, 'DNA polymerase epsilon subunit', 160, NULL, NULL, 59472),
(59473, '2.40.290.10-FF-000014', NULL, 'Uncharacterized protein', 87, NULL, NULL, 59473),
(59474, '1.10.10.60-FF-000619', NULL, 'Protein OVEREXPRESSOR OF CATIONIC PEROXIDASE 3', 60, NULL, NULL, 59474),
(59475, '2.30.42.10-FF-000451', NULL, NULL, 106, NULL, NULL, 59475),
(59476, '2.40.50.700-FF-000007', NULL, 'Putative rrp44p homologue', 79, NULL, NULL, 59476),
(59477, '3.40.1230.10-FF-000023', NULL, 'Uncharacterized protein', 37, NULL, NULL, 59477),
(59478, '2.40.37.10-FF-000056', NULL, NULL, 148, NULL, NULL, 59478),
(59479, '3.10.490.10-FF-000055', NULL, 'Gamma-glutamylcyclotransferase', 177, NULL, NULL, 59479),
(59480, '1.25.10.10-FF-003118', NULL, 'Meiotic check point regulator-like protein', 211, NULL, NULL, 59480),
(59481, '2.30.30.490-FF-000061', NULL, 'Uncharacterized protein', 58, NULL, NULL, 59481),
(59482, '3.80.10.10-FF-003615', NULL, 'Uncharacterized protein', 140, NULL, NULL, 59482),
(59483, '1.20.90.10-FF-000031', NULL, NULL, 136, NULL, NULL, 59483),
(59484, '3.40.50.1000-FF-000109', NULL, 'Cation-transporting ATPase', 175, NULL, NULL, 59484),
(59485, '3.40.50.1820-FF-000243', NULL, 'Alpha/beta hydrolase domain containing protein', 283, NULL, NULL, 59485),
(59486, '3.30.160.60-FF-000467', NULL, 'Zinc finger and SCAN domain-containing 21', 28, NULL, NULL, 59486),
(59487, '2.60.40.10-FF-001266', NULL, 'Protein tyrosine phosphatase, receptor type Q', 107, NULL, NULL, 59487),
(59488, '1.25.40.10-FF-003783', NULL, 'TPR Domain containing protein', 153, NULL, NULL, 59488),
(59489, '3.40.390.10-FF-000304', NULL, NULL, 246, NULL, NULL, 59489);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(59490, '1.10.10.10-FF-000684', NULL, 'Transcriptional regulator, MarR family', 146, NULL, NULL, 59490),
(59491, '3.40.30.10-FF-000752', NULL, 'Iodothyronine deiodinase', 104, NULL, NULL, 59491),
(59492, '3.90.550.10-FF-000446', NULL, 'Predicted protein', 253, NULL, NULL, 59492),
(59493, '3.40.50.10810-FF-000179', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 98, NULL, NULL, 59493),
(59494, '3.30.310.80-FF-000002', NULL, 'Non-specific serine/threonine protein kinase', 127, NULL, NULL, 59494),
(59495, '3.40.50.300-FF-005015', NULL, 'Predicted protein', 291, NULL, NULL, 59495),
(59496, '1.10.10.60-FF-001019', NULL, NULL, 69, NULL, NULL, 59496),
(59497, '3.20.20.80-FF-000565', NULL, 'Glucosylceramidase', 60, NULL, NULL, 59497),
(59498, '3.80.10.10-FF-000305', NULL, 'Adenylate cyclase AcyA', 214, NULL, NULL, 59498),
(59499, '2.120.10.80-FF-000079', NULL, 'Putative LOV domain-containing protein', 152, NULL, NULL, 59499),
(59500, '2.70.150.10-FF-000273', NULL, 'Phospholipid-transporting ATPase-like protein', 160, NULL, NULL, 59500),
(59501, '3.30.1370.10-FF-000136', NULL, 'RNA-binding protein, putative', 115, NULL, NULL, 59501),
(59502, '2.60.120.970-FF-000006', NULL, 'Transforming growth factor beta', 280, NULL, NULL, 59502),
(59503, '2.60.40.10-FF-001827', NULL, 'Immunoglobulin kappa variable 4-1', 108, NULL, NULL, 59503),
(59504, '3.40.50.720-FF-001583', NULL, 'Uncharacterized protein', 230, NULL, NULL, 59504),
(59505, '1.20.58.60-FF-000600', NULL, 'Uncharacterized protein', 139, NULL, NULL, 59505),
(59506, '3.30.420.40-FF-000347', NULL, 'actin-related protein 5', 55, NULL, NULL, 59506),
(59507, '3.30.70.330-FF-000045', NULL, 'Nucleolysin tiar isoform 1', 101, NULL, NULL, 59507),
(59508, '3.50.50.60-FF-000548', NULL, 'Amine oxidase', 415, NULL, NULL, 59508),
(59509, '1.20.120.730-FF-000017', NULL, 'Protein transport protein SEC23', 140, NULL, NULL, 59509),
(59510, '2.130.10.10-FF-002935', NULL, 'Protein HIRA', 246, NULL, NULL, 59510),
(59511, '3.30.160.60-FF-005138', NULL, NULL, 28, NULL, NULL, 59511),
(59512, '3.80.10.10-FF-004015', NULL, 'Uncharacterized protein', 147, NULL, NULL, 59512),
(59513, '1.20.920.20-FF-000052', NULL, 'Uncharacterized protein', 231, NULL, NULL, 59513),
(59514, '3.40.1110.10-FF-000317', NULL, NULL, 141, NULL, NULL, 59514),
(59515, '3.40.50.300-FF-001305', NULL, 'ABCG transporter ABC superfamily', 244, NULL, NULL, 59515),
(59516, '3.30.70.330-FF-000657', NULL, 'Eukaryotic translation initiation factor 3 subunit G', 120, NULL, NULL, 59516),
(59517, '2.130.10.10-FF-001923', NULL, 'Uncharacterized protein', 326, NULL, NULL, 59517),
(59518, '3.30.300.70-FF-000004', NULL, 'Ribosome maturation factor RimP', 70, NULL, NULL, 59518),
(59519, '1.25.10.10-FF-000633', NULL, 'Deoxyhypusine hydroxylase', 155, NULL, NULL, 59519),
(59520, '6.10.140.2220-FF-000040', NULL, 'Uncharacterized protein', 52, NULL, NULL, 59520),
(59521, '2.40.50.90-FF-000178', NULL, 'Uncharacterized protein', 101, NULL, NULL, 59521),
(59522, '3.40.50.1820-FF-000642', NULL, 'Phospholipase A1 1-like Protein', 276, NULL, NULL, 59522),
(59523, '2.160.10.10-FF-000034', NULL, 'Galactoside O-acetyltransferase', 171, NULL, NULL, 59523),
(59524, '3.30.1330.40-FF-000025', NULL, 'Chorismate mutase AroH', 123, NULL, NULL, 59524),
(59525, '3.30.200.20-FF-002562', NULL, 'Serine/threonine protein kinase, putative', 46, NULL, NULL, 59525),
(59526, '1.20.120.310-FF-000010', NULL, 'Sulfhydryl oxidase', 148, NULL, NULL, 59526),
(59527, '2.60.120.920-FF-000183', NULL, 'Trithorax protein ash2, putative', 132, NULL, NULL, 59527),
(59528, '3.40.1110.10-FF-000368', NULL, NULL, 186, NULL, NULL, 59528),
(59529, '3.40.1110.10-FF-000424', NULL, NULL, 12, NULL, NULL, 59529),
(59530, '3.30.420.40-FF-000639', NULL, 'Uncharacterized protein', 186, NULL, NULL, 59530),
(59531, '3.30.497.10-FF-000167', NULL, 'Uncharacterized protein', 39, NULL, NULL, 59531),
(59532, '3.90.79.10-FF-000249', NULL, 'Uncharacterized protein', 151, NULL, NULL, 59532),
(59533, '1.10.1450.10-FF-000014', NULL, 'Tetraspanin', 109, NULL, NULL, 59533);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(59534, '1.20.1390.10-FF-000006', NULL, 'zinc finger CCCH domain-containing protein 14', 70, NULL, NULL, 59534),
(59535, '3.30.1390.20-FF-000028', NULL, '60S ribosomal protein L7-2, putative', 96, NULL, NULL, 59535),
(59536, '3.40.50.410-FF-000265', NULL, 'Predicted protein', 110, NULL, NULL, 59536),
(59537, '3.80.10.10-FF-000417', NULL, 'F-box/LRR-repeat protein 4 isoform X1', 146, NULL, NULL, 59537),
(59538, '1.25.10.10-FF-000577', NULL, 'Uncharacterized protein, isoform A', 232, NULL, NULL, 59538),
(59539, '3.50.7.10-FF-000047', NULL, NULL, 47, NULL, NULL, 59539),
(59540, '3.30.60.30-FF-000108', NULL, 'Solute carrier organic anion transporter family member', 50, NULL, NULL, 59540),
(59541, '1.20.1260.100-FF-000013', NULL, NULL, 89, NULL, NULL, 59541),
(59542, '3.40.1650.10-FF-000010', NULL, 'Uncharacterized protein', 57, NULL, NULL, 59542),
(59543, '2.60.220.50-FF-000135', NULL, 'Uncharacterized protein', 163, NULL, NULL, 59543),
(59544, '3.20.20.80-FF-000801', NULL, 'Protein CBR-AGL-1', 146, NULL, NULL, 59544),
(59545, '3.40.50.720-FF-001875', NULL, 'Shikimate dehydrogenase (NADP(+))', 148, NULL, NULL, 59545),
(59546, '1.20.1270.60-FF-000288', NULL, 'FES proto-oncogene, tyrosine kinase', 178, NULL, NULL, 59546),
(59547, '1.20.58.60-FF-000544', NULL, 'Microtubule actin crosslinking factor 1a', 215, NULL, NULL, 59547),
(59548, '3.40.50.2000-FF-000191', NULL, 'Lipopolysaccharide core heptosyltransferase RfaQ', 157, NULL, NULL, 59548),
(59549, '1.10.555.10-FF-000163', NULL, 'Rgd1p', 235, NULL, NULL, 59549),
(59550, '2.10.110.10-FF-000065', NULL, 'Testin', 77, NULL, NULL, 59550),
(59551, '3.90.79.10-FF-000305', NULL, 'Uncharacterized protein', 58, NULL, NULL, 59551),
(59552, '2.30.40.10-FF-000053', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 78, NULL, NULL, 59552),
(59553, '3.90.70.10-FF-000617', NULL, 'Uncharacterized protein', 150, NULL, NULL, 59553),
(59554, '1.20.5.110-FF-000131', NULL, 'QA-SNARE protein putative', 74, NULL, NULL, 59554),
(59555, '3.90.1150.10-FF-000230', NULL, 'Aminotransferase', 123, NULL, NULL, 59555),
(59556, '1.25.10.10-FF-001089', NULL, 'RING-type E3 ubiquitin transferase', 186, NULL, NULL, 59556),
(59557, '3.40.50.300-FF-000737', NULL, 'Bifunctional polynucleotide phosphatase/kinase', 183, NULL, NULL, 59557),
(59558, '2.60.120.200-FF-000585', NULL, 'Uncharacterized protein', 164, NULL, NULL, 59558),
(59559, '3.40.50.300-FF-001249', NULL, 'DNA mismatch repair protein MSH4', 282, NULL, NULL, 59559),
(59560, '3.30.70.330-FF-002861', NULL, NULL, 78, NULL, NULL, 59560),
(59561, '2.60.40.10-FF-003452', NULL, NULL, 102, NULL, NULL, 59561),
(59562, '2.130.10.10-FF-002486', NULL, 'HEAT repeat domain containing protein', 205, NULL, NULL, 59562),
(59563, '2.130.10.10-FF-000338', NULL, 'WD repeat and HMG-box DNA binding protein 1', 182, NULL, NULL, 59563),
(59564, '3.40.720.10-FF-000179', NULL, 'Uncharacterized protein', 208, NULL, NULL, 59564),
(59565, '3.30.200.20-FF-000358', NULL, 'Tau tubulin kinase 2b', 74, NULL, NULL, 59565),
(59566, '3.30.70.330-FF-000713', NULL, 'Pre-mRNA-splicing factor CWC2', 108, NULL, NULL, 59566),
(59567, '3.30.360.20-FF-000010', NULL, 'RNA 3''-terminal phosphate cyclase-like protein', 100, NULL, NULL, 59567),
(59568, '1.10.3370.10-FF-000036', NULL, 'Uncharacterized protein', 361, NULL, NULL, 59568),
(59569, '1.20.1560.10-FF-000565', NULL, 'Pgp-1', 330, NULL, NULL, 59569),
(59570, '2.130.10.10-FF-001974', NULL, 'Protein required for cell viability, possible role in assembly of the ribosome', 215, NULL, NULL, 59570),
(59571, '3.30.420.40-FF-000746', NULL, 'Actin, putative', 31, NULL, NULL, 59571),
(59572, '1.20.900.10-FF-000008', NULL, 'rho guanine nucleotide exchange factor 25', 204, NULL, NULL, 59572),
(59573, '2.30.30.140-FF-000208', NULL, 'GM23618', 86, NULL, NULL, 59573),
(59574, '3.40.140.10-FF-000084', NULL, 'Eukaryotic translation initiation factor 3 subunit H', 173, NULL, NULL, 59574),
(59575, '1.25.40.10-FF-003895', NULL, 'Uncharacterized protein', 76, NULL, NULL, 59575),
(59576, '3.40.640.10-FF-000465', NULL, 'Predicted protein', 171, NULL, NULL, 59576);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(59577, '1.20.58.1220-FF-000006', NULL, 'Exocyst complex component EXO84, variant', 103, NULL, NULL, 59577),
(59578, '1.25.40.10-FF-001765', NULL, 'Pentatricopeptide repeat-containing protein', 126, NULL, NULL, 59578),
(59579, '1.20.1250.20-FF-002034', NULL, 'MFS drug transporter, putative', 335, NULL, NULL, 59579),
(59580, '2.10.25.10-FF-001665', NULL, 'Uncharacterized protein', 69, NULL, NULL, 59580),
(59581, '2.60.40.420-FF-000203', NULL, 'Uncharacterized protein', 158, NULL, NULL, 59581),
(59582, '3.30.70.330-FF-000606', NULL, 'Polyadenylate-binding protein', 92, NULL, NULL, 59582),
(59583, '2.80.10.50-FF-000128', NULL, 'Endo-1,4-beta-xylanase A', 73, NULL, NULL, 59583),
(59584, '1.10.3380.30-FF-000020', NULL, 'Ski2-like RNA helicase', 112, NULL, NULL, 59584),
(59585, '2.120.10.80-FF-000404', NULL, 'Uncharacterized protein', 61, NULL, NULL, 59585),
(59586, '3.50.50.60-FF-001217', NULL, 'Flavin-containing monooxygenase', 290, NULL, NULL, 59586),
(59587, '1.10.472.10-FF-000083', NULL, 'Transcription initiation factor IIB', 91, NULL, NULL, 59587),
(59588, '1.20.1070.10-FF-000606', NULL, 'Olfactory receptor 536', 64, NULL, NULL, 59588),
(59589, '1.25.40.90-FF-000114', NULL, 'Nine-cis-epoxycarotenoid dioxygenase7', 53, NULL, NULL, 59589),
(59590, '3.50.50.60-FF-000599', NULL, 'Methylenetetrahydrofolate--tRNA-(uracil-5-)-methyltransferase TrmFO', 173, NULL, NULL, 59590),
(59591, '3.90.1410.10-FF-000093', NULL, 'Uncharacterized protein', 283, NULL, NULL, 59591),
(59592, '1.25.40.90-FF-000058', NULL, 'Hse1p', 157, NULL, NULL, 59592),
(59593, '3.40.630.30-FF-000122', NULL, 'Acetyltransferase (GNAT) family protein', 169, NULL, NULL, 59593),
(59594, '3.40.50.80-FF-000223', NULL, 'NADH-cytochrome b5 reductase-like protein', 181, NULL, NULL, 59594),
(59595, '1.20.120.770-FF-000001', NULL, 'Amyloid beta A4 protein-like isoform 1', 218, NULL, NULL, 59595),
(59596, '2.40.330.10-FF-000018', NULL, NULL, 105, NULL, NULL, 59596),
(59597, '3.30.40.10-FF-002136', NULL, 'RBR-type E3 ubiquitin transferase', 129, NULL, NULL, 59597),
(59598, '1.10.1370.10-FF-000013', NULL, 'Peptidase family M3', 368, NULL, NULL, 59598),
(59599, '2.130.10.10-FF-005521', NULL, 'Uncharacterized protein', 54, NULL, NULL, 59599),
(59600, '1.10.150.240-FF-000076', NULL, 'Possible phosphatase', 65, NULL, NULL, 59600),
(59601, '2.130.10.10-FF-001182', NULL, 'Unplaced genomic scaffold supercont1.58, whole genome shotgun sequence', 331, NULL, NULL, 59601),
(59602, '3.30.160.60-FF-002047', NULL, 'Uncharacterized protein', 30, NULL, NULL, 59602),
(59603, '3.40.720.10-FF-000235', NULL, 'Predicted protein', 82, NULL, NULL, 59603),
(59604, '3.40.50.2020-FF-000179', NULL, 'Uncharacterized protein', 172, NULL, NULL, 59604),
(59605, '1.25.40.180-FF-000243', NULL, NULL, 154, NULL, NULL, 59605),
(59606, '2.40.160.210-FF-000016', NULL, 'Peroxisomal Acyl-CoA thioesterase Tes1p, putative', 334, NULL, NULL, 59606),
(59607, '1.10.510.10-FF-002954', NULL, NULL, 110, NULL, NULL, 59607),
(59608, '3.30.70.580-FF-000030', NULL, 'Putative tRNA pseudouridine synthase A', 79, NULL, NULL, 59608),
(59609, '1.20.120.790-FF-000007', NULL, 'Heat shock protein 90', 154, NULL, NULL, 59609),
(59610, '2.60.120.200-FF-000641', NULL, 'Neurogenic locus notch, putative', 113, NULL, NULL, 59610),
(59611, '3.40.50.2300-FF-000067', NULL, 'Olfactory receptor C family, h1', 309, NULL, NULL, 59611),
(59612, '2.60.40.10-FF-000597', NULL, 'tyrosine-protein kinase receptor Tie-1 isoform X1', 97, NULL, NULL, 59612),
(59613, '2.60.220.50-FF-000079', NULL, 'Uncharacterized protein', 191, NULL, NULL, 59613),
(59614, '3.40.50.150-FF-001238', NULL, NULL, 96, NULL, NULL, 59614),
(59615, '3.20.20.100-FF-000002', NULL, '2,5-diketo-D-gluconic acid reductase A', 272, NULL, NULL, 59615),
(59616, '1.10.10.10-FF-000902', NULL, 'Related to Histone H1', 90, NULL, NULL, 59616),
(59617, '3.30.450.20-FF-000129', NULL, 'Uncharacterized protein', 106, NULL, NULL, 59617),
(59618, '3.30.2130.30-FF-000041', NULL, 'Probable tRNA sulfurtransferase', 173, NULL, NULL, 59618),
(59619, '3.40.50.300-FF-002941', NULL, 'Pre-mRNA-processing ATP-dependent RNA helicase PRP5', 202, NULL, NULL, 59619);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(59620, '3.20.20.30-FF-000016', NULL, 'Oxidoreductase, LLM family', 347, NULL, NULL, 59620),
(59621, '2.70.160.11-FF-000095', NULL, 'Uncharacterized protein', 173, NULL, NULL, 59621),
(59622, '2.60.40.10-FF-006049', NULL, NULL, 69, NULL, NULL, 59622),
(59623, '3.90.1150.160-FF-000004', NULL, 'Glutamate decarboxylase', 103, NULL, NULL, 59623),
(59624, '3.30.70.330-FF-001169', NULL, 'Zinc finger protein containing protein', 109, NULL, NULL, 59624),
(59625, '1.10.340.70-FF-000013', NULL, 'Uncharacterized protein', 94, NULL, NULL, 59625),
(59626, '1.25.10.10-FF-002781', NULL, 'STE family protein kinase', 350, NULL, NULL, 59626),
(59627, '1.10.275.40-FF-000009', NULL, 'ATP-dependent DNA helicase', 125, NULL, NULL, 59627),
(59628, '1.25.40.70-FF-000052', NULL, 'Phosphatidylinositol 3-kinase', 221, NULL, NULL, 59628),
(59629, '1.20.1290.10-FF-000010', NULL, 'Uncharacterized protein', 243, NULL, NULL, 59629),
(59630, '1.10.1370.30-FF-000019', NULL, 'Angiotensin-converting enzyme', 135, NULL, NULL, 59630),
(59631, '2.60.40.1180-FF-000086', NULL, 'Glycogen debranching enzyme GlgX', 101, NULL, NULL, 59631),
(59632, '3.40.50.300-FF-007033', NULL, 'Uncharacterized protein', 303, NULL, NULL, 59632),
(59633, '1.10.8.10-FF-000317', NULL, 'UBA domain-containing protein Mud1', 82, NULL, NULL, 59633),
(59634, '2.30.30.40-FF-000674', NULL, 'Uncharacterized protein', 118, NULL, NULL, 59634),
(59635, '1.10.860.10-FF-000001', NULL, 'Replicative DNA helicase', 165, NULL, NULL, 59635),
(59636, '3.40.640.10-FF-000234', NULL, 'Adenosylmethionine-8-amino-7-oxononanoate aminotransferase', 264, NULL, NULL, 59636),
(59637, '3.30.559.30-FF-000042', NULL, 'Nonribosomal peptide synthase Pes1', 236, NULL, NULL, 59637),
(59638, '3.20.20.80-FF-000060', NULL, 'Lysozyme M1', 208, NULL, NULL, 59638),
(59639, '3.30.420.40-FF-000791', NULL, 'O-Sialoglycoprotein Endopeptidase family', 61, NULL, NULL, 59639),
(59640, '1.10.1710.10-FF-000001', NULL, 'RNA chaperone ProQ', 119, NULL, NULL, 59640),
(59641, '2.60.40.10-FF-001035', NULL, 'Down syndrome cell adhesion molecule-like protein Dscam2', 87, NULL, NULL, 59641),
(59642, '3.30.450.40-FF-000287', NULL, 'Phosphodiesterase', 57, NULL, NULL, 59642),
(59643, '3.10.490.10-FF-000004', NULL, 'Gamma-glutamyl cyclotransferase', 154, NULL, NULL, 59643),
(59644, '1.20.890.10-FF-000012', NULL, 'DPY30 domain containing 2', 43, NULL, NULL, 59644),
(59645, '4.10.520.10-FF-000015', NULL, 'DNA-binding protein HU', 100, NULL, NULL, 59645),
(59646, '3.80.10.10-FF-002834', NULL, 'Uncharacterized protein', 76, NULL, NULL, 59646),
(59647, '3.40.50.300-FF-003722', NULL, 'ATPase, AAA family', 151, NULL, NULL, 59647),
(59648, '3.40.50.2000-FF-000988', NULL, 'Uncharacterized protein', 58, NULL, NULL, 59648),
(59649, '1.20.1250.40-FF-000011', NULL, 'RNA polymerase C', 80, NULL, NULL, 59649),
(59650, '3.30.200.20-FF-001718', NULL, 'Protein kinase', 141, NULL, NULL, 59650),
(59651, '3.10.450.10-FF-000058', NULL, 'Cysteine proteinase inhibitor', 95, NULL, NULL, 59651),
(59652, '1.10.3860.10-FF-000012', NULL, 'Amino acid transporter', 140, NULL, NULL, 59652),
(59653, '3.40.50.10490-FF-000044', NULL, 'Transcriptional regulator, RpiR family', 185, NULL, NULL, 59653),
(59654, '3.30.420.10-FF-000355', NULL, NULL, 162, NULL, NULL, 59654),
(59655, '3.30.40.10-FF-000955', NULL, 'Putative phosphatidylinositol kinase', 93, NULL, NULL, 59655),
(59656, '2.130.10.10-FF-005341', NULL, 'U3 small nucleolar RNA-associated protein 4 homolog', 182, NULL, NULL, 59656),
(59657, '2.60.40.10-FF-004756', NULL, NULL, 99, NULL, NULL, 59657),
(59658, '3.40.1440.60-FF-000003', NULL, 'Primosomal protein N''', 106, NULL, NULL, 59658),
(59659, '2.60.40.10-FF-004868', NULL, NULL, 88, NULL, NULL, 59659),
(59660, '2.70.150.10-FF-000093', NULL, 'Cation-transporting ATPase, E1-E2 family protein', 84, NULL, NULL, 59660),
(59661, '3.40.50.150-FF-001058', NULL, 'Methyltransferase-like protein', 261, NULL, NULL, 59661),
(59662, '3.60.15.10-FF-000103', NULL, 'ETHE1, persulfide dioxygenase', 60, NULL, NULL, 59662),
(59663, '3.20.20.70-FF-000579', NULL, NULL, 162, NULL, NULL, 59663);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(59664, '3.90.1170.10-FF-000006', NULL, '60S ribosomal protein L10', 26, NULL, NULL, 59664),
(59665, '3.40.50.1000-FF-000553', NULL, NULL, 169, NULL, NULL, 59665),
(59666, '1.25.40.10-FF-005076', NULL, 'Putative pentatricopeptide repeat-containing protein mitochondrial', 94, NULL, NULL, 59666),
(59667, '2.10.25.10-FF-001772', NULL, 'Uncharacterized protein', 35, NULL, NULL, 59667),
(59668, '1.10.510.10-FF-001594', NULL, 'Protein kinase, putative', 219, NULL, NULL, 59668),
(59669, '1.10.510.10-FF-001650', NULL, 'Serine/threonine protein kinase Chk2,putative', 249, NULL, NULL, 59669),
(59670, '2.70.170.10-FF-000212', NULL, 'Uncharacterized protein', 151, NULL, NULL, 59670),
(59671, '3.40.50.10380-FF-000011', NULL, 'Malic enzyme', 253, NULL, NULL, 59671),
(59672, '3.40.50.300-FF-005807', NULL, 'DNA helicase, SNF2/RAD54 family', 258, NULL, NULL, 59672),
(59673, '3.90.1010.10-FF-000012', NULL, 'Cysteine desulfuration protein SufE', 150, NULL, NULL, 59673),
(59674, '3.30.710.10-FF-000170', NULL, 'SKP1-like protein 5', 156, NULL, NULL, 59674),
(59675, '1.10.10.1770-FF-000005', NULL, 'Glr3962 protein', 79, NULL, NULL, 59675),
(59676, '3.60.10.10-FF-000082', NULL, 'Endonuclease', 242, NULL, NULL, 59676),
(59677, '1.10.20.10-FF-000167', NULL, 'Histone H2A', 102, NULL, NULL, 59677),
(59678, '3.30.160.60-FF-003901', NULL, NULL, 26, NULL, NULL, 59678),
(59679, '1.10.1170.10-FF-000032', NULL, 'Uncharacterized protein', 128, NULL, NULL, 59679),
(59680, '2.60.120.260-FF-000232', NULL, 'Protein CBG03913', 163, NULL, NULL, 59680),
(59681, '3.10.330.10-FF-000010', NULL, 'vesicle-fusing ATPase 2', 112, NULL, NULL, 59681),
(59682, '2.170.120.12-FF-000002', NULL, 'DNA-directed RNA polymerase II subunit RPB3', 126, NULL, NULL, 59682),
(59683, '3.40.50.12650-FF-000006', NULL, 'DNA ligase', 156, NULL, NULL, 59683),
(59684, '3.20.20.140-FF-000222', NULL, 'Phospho-furanose lactonase', 363, NULL, NULL, 59684),
(59685, '3.30.1610.20-FF-000001', NULL, 'Methyltransferase type 12', 230, NULL, NULL, 59685),
(59686, '3.40.850.10-FF-000059', NULL, 'Myosin type-2 heavy chain', 265, NULL, NULL, 59686),
(59687, '3.40.50.1000-FF-000733', NULL, NULL, 70, NULL, NULL, 59687),
(59688, '1.20.920.10-FF-000066', NULL, 'Transcription initiation factor TFIID subunit 1', 126, NULL, NULL, 59688),
(59689, '3.40.640.10-FF-000178', NULL, 'Aminotransferase, class I/II domain protein', 417, NULL, NULL, 59689),
(59690, '1.25.10.10-FF-001937', NULL, 'Uncharacterized protein', 386, NULL, NULL, 59690),
(59691, '3.40.50.300-FF-002885', NULL, 'GTP-binding protein YPTM1', 207, NULL, NULL, 59691),
(59692, '1.25.40.10-FF-005312', NULL, 'Uncharacterized protein', 122, NULL, NULL, 59692),
(59693, '3.20.20.140-FF-000278', NULL, 'Uncharacterized protein', 332, NULL, NULL, 59693),
(59694, '2.60.40.10-FF-006105', NULL, NULL, 93, NULL, NULL, 59694),
(59695, '3.40.50.12780-FF-000141', NULL, 'AMP-binding enzyme, putative (AFU_orthologue AFUA_5G04270)', 467, NULL, NULL, 59695),
(59696, '3.40.50.1820-FF-000535', NULL, 'Carboxylic ester hydrolase', 305, NULL, NULL, 59696),
(59697, '1.20.970.10-FF-000013', NULL, 'Anthranilate phosphoribosyltransferase', 63, NULL, NULL, 59697),
(59698, '1.10.510.10-FF-002667', NULL, NULL, 106, NULL, NULL, 59698),
(59699, '3.30.60.20-FF-000162', NULL, 'Uncharacterized protein', 33, NULL, NULL, 59699),
(59700, '3.40.800.10-FF-000056', NULL, NULL, 197, NULL, NULL, 59700),
(59701, '3.30.230.10-FF-000144', NULL, 'Phosphomevalonate kinase', 202, NULL, NULL, 59701),
(59702, '3.80.10.10-FF-003907', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 277, NULL, NULL, 59702),
(59703, '3.30.160.60-FF-003160', NULL, 'Si:ch73-221f6.3', 29, NULL, NULL, 59703),
(59704, '1.10.950.10-FF-000008', NULL, 'Quail, isoform C', 78, NULL, NULL, 59704),
(59705, '3.40.640.10-FF-000521', NULL, 'Serine--pyruvate aminotransferase', 140, NULL, NULL, 59705),
(59706, '3.30.2230.10-FF-000031', NULL, 'Uncharacterized protein', 152, NULL, NULL, 59706),
(59707, '1.20.120.1080-FF-000028', NULL, 'ATP-dependent RNA helicase', 100, NULL, NULL, 59707),
(59708, '1.10.10.60-FF-000327', NULL, 'Myb transcription factor', 46, NULL, NULL, 59708);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(59709, '3.40.190.10-FF-000828', NULL, 'Sugar ABC transporter, periplasmic sugar-binding protein', 146, NULL, NULL, 59709),
(59710, '2.130.10.10-FF-000670', NULL, 'Tomosyn, isoform K', 144, NULL, NULL, 59710),
(59711, '3.40.50.150-FF-001390', NULL, NULL, 171, NULL, NULL, 59711),
(59712, '3.40.50.300-FF-002609', NULL, 'GD23605', 192, NULL, NULL, 59712),
(59713, '2.60.120.620-FF-000031', NULL, 'Predicted protein', 200, NULL, NULL, 59713),
(59714, '3.40.50.1820-FF-000411', NULL, 'Probable carboxylesterase Os04g0669600', 221, NULL, NULL, 59714),
(59715, '4.10.1240.10-FF-000041', NULL, 'Putative diuretic hormone 44 receptor', 94, NULL, NULL, 59715),
(59716, '3.40.1160.10-FF-000028', NULL, 'Uridylate kinase isoform A', 247, NULL, NULL, 59716),
(59717, '3.80.10.10-FF-001997', NULL, 'Putative leucine-rich repeat receptor-like serine/threonine-protein kinase isoform A', 109, NULL, NULL, 59717),
(59718, '3.30.450.20-FF-000416', NULL, 'Sensor box histidine kinase', 127, NULL, NULL, 59718),
(59719, '1.20.58.1880-FF-000013', NULL, 'WGS project CABT00000000 data, contig 2.5', 109, NULL, NULL, 59719),
(59720, '2.60.40.10-FF-001322', NULL, '1,4-alpha-glucan-branching enzyme 3', 54, NULL, NULL, 59720),
(59721, '3.90.1480.20-FF-000044', NULL, 'Uncharacterized protein', 273, NULL, NULL, 59721),
(59722, '3.40.630.30-FF-000234', NULL, 'GH28833p', 236, NULL, NULL, 59722),
(59723, '3.30.70.1250-FF-000001', NULL, 'Phosphopentomutase', 121, NULL, NULL, 59723),
(59724, '4.10.240.10-FF-000033', NULL, 'C6 transcription factor (AflR)', 58, NULL, NULL, 59724),
(59725, '1.10.630.10-FF-000136', NULL, 'Uncharacterized protein', 471, NULL, NULL, 59725),
(59726, '3.90.550.10-FF-000677', NULL, 'UDP-N-acetylglucosamine pyrophosphorylase', 94, NULL, NULL, 59726),
(59727, '1.10.10.10-FF-001414', NULL, 'RNA polymerase sigma factor', 85, NULL, NULL, 59727),
(59728, '1.10.510.10-FF-001318', NULL, 'Mitogen-activated protein kinase', 221, NULL, NULL, 59728),
(59729, '3.40.570.10-FF-000021', NULL, 'GM23913', 243, NULL, NULL, 59729),
(59730, '3.30.160.60-FF-001535', NULL, 'Zinc finger protein 236', 78, NULL, NULL, 59730),
(59731, '3.30.450.20-FF-000017', NULL, 'SIM bHLH transcription factor 2', 147, NULL, NULL, 59731),
(59732, '1.10.10.10-FF-000577', NULL, 'MarR family transcriptional regulator', 144, NULL, NULL, 59732),
(59733, '3.90.1150.10-FF-000174', NULL, 'Putrescine aminotransferase', 148, NULL, NULL, 59733),
(59734, '3.30.70.1470-FF-000011', NULL, 'Caspase 2', 64, NULL, NULL, 59734),
(59735, '3.30.40.10-FF-000270', NULL, 'pathogenesis-related homeodomain protein-like', 61, NULL, NULL, 59735),
(59736, '2.130.10.10-FF-001070', NULL, 'Dynein intermediate chain, cytosolic', 240, NULL, NULL, 59736),
(59737, '3.40.50.300-FF-001536', NULL, 'Probable VPS21-Rab5-like GTPase involved in vacuolar protein sorting', 180, NULL, NULL, 59737),
(59738, '1.10.730.10-FF-000233', NULL, 'Valyl tRNA Synthetase, putative', 118, NULL, NULL, 59738),
(59739, '2.40.30.10-FF-000086', NULL, 'Bifunctional cytochrome P450/NADPH--P450 reductase', 103, NULL, NULL, 59739),
(59740, '2.130.10.10-FF-003104', NULL, 'Uncharacterized protein', 296, NULL, NULL, 59740),
(59741, '2.120.10.80-FF-000186', NULL, 'tRNA wybutosine-synthesizing protein 2/3/4', 108, NULL, NULL, 59741),
(59742, '2.130.10.10-FF-002704', NULL, 'WD repeat domain phosphoinositide-interacting protein 2', 321, NULL, NULL, 59742),
(59743, '2.30.29.30-FF-000021', NULL, 'Rho guanine nucleotide exchange factor 2', 129, NULL, NULL, 59743),
(59744, '3.40.850.10-FF-000003', NULL, 'Myosin heavy chain', 264, NULL, NULL, 59744),
(59745, '3.40.50.150-FF-000726', NULL, 'Ribosomal RNA methyltransferase', 187, NULL, NULL, 59745),
(59746, '2.30.30.940-FF-000004', NULL, 'Tetratricopeptide repeat protein', 68, NULL, NULL, 59746),
(59747, '1.20.1070.10-FF-000426', NULL, 'Transmembrane receptor LIN-17', 344, NULL, NULL, 59747),
(59748, '1.20.120.1150-FF-000004', NULL, 'Serine/threonine-protein phosphatase 2A activator 1', 119, NULL, NULL, 59748),
(59749, '1.20.1280.290-FF-000068', NULL, 'PQ loop repeat protein', 93, NULL, NULL, 59749);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(59750, '1.10.1670.10-FF-000053', NULL, NULL, 73, NULL, NULL, 59750),
(59751, '3.40.50.1460-FF-000051', NULL, 'Uncharacterized protein', 260, NULL, NULL, 59751),
(59752, '1.25.40.10-FF-000984', NULL, 'Os05g0572900 protein', 98, NULL, NULL, 59752),
(59753, '1.20.58.390-FF-000225', NULL, 'Predicted protein', 147, NULL, NULL, 59753),
(59754, '2.60.120.650-FF-000079', NULL, 'Uncharacterized protein', 342, NULL, NULL, 59754),
(59755, '1.20.1250.20-FF-001253', NULL, 'Major facilitator superfamily domain-containing 3', 406, NULL, NULL, 59755),
(59756, '3.40.630.10-FF-000172', NULL, 'Succinylglutamate desuccinylase', 336, NULL, NULL, 59756),
(59757, '3.90.260.10-FF-000014', NULL, 'DNA repair protein RAD4 isoform B', 264, NULL, NULL, 59757),
(59758, '1.10.30.10-FF-000067', NULL, 'Lysine-specific histone demethylase Aof2, putative', 105, NULL, NULL, 59758),
(59759, '3.30.1520.10-FF-000076', NULL, 'Sorting nexin 20', 79, NULL, NULL, 59759),
(59760, '1.10.510.10-FF-003628', NULL, NULL, 192, NULL, NULL, 59760),
(59761, '1.10.472.10-FF-000700', NULL, 'Uncharacterized protein', 21, NULL, NULL, 59761),
(59762, '3.30.160.60-FF-005245', NULL, NULL, 48, NULL, NULL, 59762),
(59763, '1.25.10.10-FF-003163', NULL, 'Beta subunit of clathrin adaptor complex AP2', 612, NULL, NULL, 59763),
(59764, '3.40.50.1820-FF-001316', NULL, 'AFR306Cp', 261, NULL, NULL, 59764),
(59765, '3.40.50.720-FF-000127', NULL, 'Enoyl-[acyl-carrier-protein] reductase [NADH]', 256, NULL, NULL, 59765),
(59766, '1.25.10.10-FF-001033', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 173, NULL, NULL, 59766),
(59767, '1.10.287.660-FF-000015', NULL, 'Predicted protein', 76, NULL, NULL, 59767),
(59768, '3.10.20.90-FF-000203', NULL, 'FERM and PDZ domain containing 1', 75, NULL, NULL, 59768),
(59769, '1.20.1060.10-FF-000021', NULL, 'DNA polymerase I', 108, NULL, NULL, 59769),
(59770, '3.40.50.11270-FF-000002', NULL, 'mRNA, clone: RTFL01-07-F02', 91, NULL, NULL, 59770),
(59771, '2.60.34.10-FF-000032', NULL, 'Heat shock 70 kDa protein, putative', 188, NULL, NULL, 59771),
(59772, '1.20.58.60-FF-000364', NULL, 'Spectrin repeat-containing, nuclear envelope family member 3', 275, NULL, NULL, 59772),
(59773, '1.10.101.10-FF-000019', NULL, 'General secretion pathway protein A', 66, NULL, NULL, 59773),
(59774, '1.25.40.10-FF-000309', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 103, NULL, NULL, 59774),
(59775, '3.40.630.30-FF-000178', NULL, 'GNAT family N-acetyltransferase', 144, NULL, NULL, 59775),
(59776, '2.10.25.10-FF-000592', NULL, 'Cadherin-related tumor suppressor', 41, NULL, NULL, 59776),
(59777, '2.60.40.10-FF-002339', NULL, 'Protein-tyrosine-phosphatase', 106, NULL, NULL, 59777),
(59778, '3.30.70.260-FF-000052', NULL, 'Glycine cleavage system transcriptional regulator', 67, NULL, NULL, 59778),
(59779, '3.20.180.20-FF-000021', NULL, 'Dynein heavy chain', 112, NULL, NULL, 59779),
(59780, '3.10.20.90-FF-000147', NULL, 'Inhibitor of nuclear factor kappa B kinase subunit epsilon', 77, NULL, NULL, 59780),
(59781, '3.30.2160.10-FF-000036', NULL, 'Uncharacterized protein', 77, NULL, NULL, 59781),
(59782, '2.60.450.20-FF-000020', NULL, 'Uncharacterized protein', 90, NULL, NULL, 59782),
(59783, '3.30.200.20-FF-000196', NULL, 'Myosin light chain kinase family, member 4', 88, NULL, NULL, 59783),
(59784, '2.30.29.30-FF-000600', NULL, 'CRE-TAG-318 protein', 138, NULL, NULL, 59784),
(59785, '3.40.50.1220-FF-000119', NULL, 'Predicted protein', 187, NULL, NULL, 59785),
(59786, '2.30.130.110-FF-000005', NULL, 'D-galactarate dehydratase', 77, NULL, NULL, 59786),
(59787, '3.10.100.10-FF-000127', NULL, 'CD209f antigen', 177, NULL, NULL, 59787),
(59788, '2.40.50.90-FF-000122', NULL, 'Slr6011 protein', 144, NULL, NULL, 59788),
(59789, '3.40.50.300-FF-000232', NULL, 'ATP-binding cassette, sub-family A (ABC1), member 1', 247, NULL, NULL, 59789),
(59790, '1.10.150.50-FF-000083', NULL, 'Kinase suppressor of ras', 66, NULL, NULL, 59790),
(59791, '2.30.30.40-FF-000095', NULL, 'Tyrosine-protein kinase', 61, NULL, NULL, 59791);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(59792, '3.90.280.10-FF-000009', NULL, 'Carboxypeptidase Y inhibitor', 215, NULL, NULL, 59792),
(59793, '2.30.30.30-FF-000053', NULL, 'Protein RNA-directed DNA methylation 3', 69, NULL, NULL, 59793),
(59794, '3.60.150.10-FF-000007', NULL, 'Chorismate synthase', 149, NULL, NULL, 59794),
(59795, '3.30.230.10-FF-000088', NULL, 'U5 small nuclear ribonuclear protein, putative', 155, NULL, NULL, 59795),
(59796, '1.10.287.3490-FF-000005', NULL, 'Mediator of RNA polymerase II transcription subunit 11', 94, NULL, NULL, 59796),
(59797, '1.20.930.10-FF-000016', NULL, 'IWS1-like protein, putative', 142, NULL, NULL, 59797),
(59798, '2.40.100.10-FF-000029', NULL, 'Peptidyl-prolyl cis-trans isomerase', 104, NULL, NULL, 59798),
(59799, '1.10.238.10-FF-000617', NULL, 'Fimbrin-2', 85, NULL, NULL, 59799),
(59800, '3.30.160.40-FF-000017', NULL, 'Porphobilinogen deaminase', 102, NULL, NULL, 59800),
(59801, '3.40.1550.10-FF-000007', NULL, 'CheY-P-specific phosphatase CheC', 202, NULL, NULL, 59801),
(59802, '2.60.120.650-FF-000135', NULL, 'Predicted protein', 339, NULL, NULL, 59802),
(59803, '2.60.40.10-FF-003290', NULL, 'Mcam protein', 76, NULL, NULL, 59803),
(59804, '2.130.10.10-FF-002648', NULL, 'Uncharacterized protein', 277, NULL, NULL, 59804),
(59805, '1.25.10.10-FF-000813', NULL, 'D-Importin 7/RanBP7', 1014, NULL, NULL, 59805),
(59806, '3.60.20.40-FF-000012', NULL, 'Probable bifunctional acylase ggtA: cephalosporin acylase + gamma-glutamyltranspeptidase', 174, NULL, NULL, 59806),
(59807, '3.40.50.300-FF-000575', NULL, 'ATP-dependent helicase hrpA', 225, NULL, NULL, 59807),
(59808, '3.30.160.60-FF-002884', NULL, 'ZNF429 isoform 4', 26, NULL, NULL, 59808),
(59809, '1.25.40.10-FF-004295', NULL, 'Putative ERAD-associated E3 ubiquitin-protein ligase component', 199, NULL, NULL, 59809),
(59810, '3.90.180.10-FF-000013', NULL, 'L-arabinitol 4-dehydrogenase', 176, NULL, NULL, 59810),
(59811, '3.40.50.1820-FF-001659', NULL, 'Uncharacterized protein', 87, NULL, NULL, 59811),
(59812, '1.20.5.5270-FF-000007', NULL, 'Lon protease', 48, NULL, NULL, 59812),
(59813, '3.30.40.10-FF-001736', NULL, 'DNA repair protein, putative', 103, NULL, NULL, 59813),
(59814, '2.130.10.10-FF-000850', NULL, 'WD40 repeat-containing protein', 307, NULL, NULL, 59814),
(59815, '2.60.120.260-FF-000288', NULL, 'Beta-glucosidase', 145, NULL, NULL, 59815),
(59816, '2.40.50.1070-FF-000024', NULL, NULL, 148, NULL, NULL, 59816),
(59817, '3.30.160.60-FF-000810', NULL, 'Zgc:174563 protein', 26, NULL, NULL, 59817),
(59818, '1.10.10.10-FF-000397', NULL, 'Vacuolar-sorting protein SNF8', 69, NULL, NULL, 59818),
(59819, '3.40.50.2300-FF-000960', NULL, NULL, 46, NULL, NULL, 59819),
(59820, '3.30.540.10-FF-000010', NULL, 'Sedoheptulose-1,7-bisphosphatase, chloroplastic', 177, NULL, NULL, 59820),
(59821, '1.20.1250.20-FF-002214', NULL, 'High affinity nitrate transporter 2.7', 136, NULL, NULL, 59821),
(59822, '2.60.40.10-FF-001378', NULL, 'Immunoglobulin kappa variable 4-1', 113, NULL, NULL, 59822),
(59823, '1.10.10.60-FF-000507', NULL, 'transcription factor LBX2', 84, NULL, NULL, 59823),
(59824, '3.90.70.10-FF-000437', NULL, 'Cysteine protease, putative', 221, NULL, NULL, 59824),
(59825, '3.40.30.10-FF-000864', NULL, 'Calsequestrin', 125, NULL, NULL, 59825),
(59826, '3.40.50.1100-FF-000196', NULL, 'D-cysteine desulfhydrase 2, mitochondrial', 24, NULL, NULL, 59826),
(59827, '3.40.50.2300-FF-000628', NULL, 'Glutamate receptor ionotropic, NMDA 3B', 156, NULL, NULL, 59827),
(59828, '2.30.42.10-FF-000563', NULL, NULL, 44, NULL, NULL, 59828),
(59829, '3.40.50.1820-FF-000355', NULL, 'Alpha/beta hydrolase', 262, NULL, NULL, 59829),
(59830, '3.60.21.10-FF-000163', NULL, 'Nuclease SbcCD subunit D', 290, NULL, NULL, 59830),
(59831, '2.10.109.10-FF-000033', NULL, 'Peptidase S26B, signal peptidase', 107, NULL, NULL, 59831),
(59832, '1.20.58.760-FF-000010', NULL, 'ATP-dependent zinc metalloprotease FTSH', 196, NULL, NULL, 59832),
(59833, '3.40.140.10-FF-000264', NULL, 'Uncharacterized protein', 116, NULL, NULL, 59833),
(59834, '2.40.50.140-FF-000199', NULL, 'tRNA-aminoacylation cofactor ARC1', 182, NULL, NULL, 59834);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(59835, '2.30.29.30-FF-000201', NULL, 'arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 3', 110, NULL, NULL, 59835),
(59836, '2.60.120.330-FF-000101', NULL, 'Uncharacterized protein', 115, NULL, NULL, 59836),
(59837, '3.40.50.620-FF-000322', NULL, 'Electron transfer flavoprotein alpha subunit', 183, NULL, NULL, 59837),
(59838, '3.40.50.720-FF-000526', NULL, 'D-mandelate dehydrogenase, putative', 194, NULL, NULL, 59838),
(59839, '3.40.50.1820-FF-000299', NULL, 'Carboxylic ester hydrolase', 512, NULL, NULL, 59839),
(59840, '2.130.10.10-FF-000518', NULL, 'Small nucleolar ribonucleoprotein complex subunit, putative', 144, NULL, NULL, 59840),
(59841, '2.10.25.10-FF-000991', NULL, 'Mucin-19', 63, NULL, NULL, 59841),
(59842, '2.40.50.140-FF-000255', NULL, 'Single-stranded DNA-binding protein', 113, NULL, NULL, 59842),
(59843, '1.25.40.1040-FF-000015', NULL, 'Unplaced genomic scaffold supercont1.13, whole genome shotgun sequence', 516, NULL, NULL, 59843),
(59844, '1.10.287.130-FF-000087', NULL, 'Ethylene receptor 4', 96, NULL, NULL, 59844),
(59845, '3.30.565.10-FF-000556', NULL, 'AAL093Cp', 213, NULL, NULL, 59845),
(59846, '3.30.420.40-FF-000459', NULL, 'Actin-related protein 8', 116, NULL, NULL, 59846),
(59847, '1.10.287.70-FF-000220', NULL, 'Uncharacterized protein, isoform A', 199, NULL, NULL, 59847),
(59848, '3.40.50.1000-FF-000677', NULL, NULL, 167, NULL, NULL, 59848),
(59849, '3.10.50.10-FF-000058', NULL, 'Chitinase, putative', 73, NULL, NULL, 59849),
(59850, '1.20.1250.20-FF-000977', NULL, 'Solute carrier organic anion transporter family, member 5A1', 188, NULL, NULL, 59850),
(59851, '3.40.50.12780-FF-000085', NULL, 'RfbL protein', 369, NULL, NULL, 59851),
(59852, '1.20.58.2140-FF-000007', NULL, 'Translin family protein', 193, NULL, NULL, 59852),
(59853, '1.25.10.10-FF-000757', NULL, 'BHLHB9 isoform 1', 213, NULL, NULL, 59853),
(59854, '3.30.70.3490-FF-000004', NULL, 'Oxysterol-binding protein', 70, NULL, NULL, 59854),
(59855, '3.90.340.10-FF-000015', NULL, 'Nitric oxide synthase, inducible', 29, NULL, NULL, 59855),
(59856, '1.20.58.390-FF-000169', NULL, 'Uncharacterized protein', 121, NULL, NULL, 59856),
(59857, '3.30.497.10-FF-000043', NULL, 'Serine protease inhibitor (serpin) 19', 163, NULL, NULL, 59857),
(59858, '3.30.420.10-FF-000299', NULL, 'Argonaute (Plant)-Like protein', 279, NULL, NULL, 59858),
(59859, '3.20.20.300-FF-000017', NULL, 'Glycoside hydrolase family 3', 314, NULL, NULL, 59859),
(59860, '2.60.120.200-FF-000242', NULL, 'Uncharacterized protein, isoform B', 173, NULL, NULL, 59860),
(59861, '3.40.50.300-FF-003666', NULL, 'Uncharacterized protein', 143, NULL, NULL, 59861),
(59862, '3.20.20.100-FF-000058', NULL, 'Aldose reductase, putative', 300, NULL, NULL, 59862),
(59863, '3.90.228.20-FF-000015', NULL, NULL, 170, NULL, NULL, 59863),
(59864, '2.130.10.30-FF-000171', NULL, NULL, 311, NULL, NULL, 59864),
(59865, '1.10.472.140-FF-000001', NULL, 'Retinoblastoma-like 2, isoform CRA_a', 152, NULL, NULL, 59865),
(59866, '1.20.1070.10-FF-001483', NULL, 'Platelet-activating factor receptor', 207, NULL, NULL, 59866),
(59867, '1.10.10.160-FF-000067', NULL, 'ATP-dependent DNA helicase', 28, NULL, NULL, 59867),
(59868, '3.40.50.2000-FF-000932', NULL, 'Uncharacterized protein', 153, NULL, NULL, 59868),
(59869, '3.30.160.60-FF-001715', NULL, NULL, 28, NULL, NULL, 59869),
(59870, '2.60.40.10-FF-004812', NULL, NULL, 73, NULL, NULL, 59870),
(59871, '3.30.460.10-FF-000133', NULL, '2''-5''-oligoadenylate synthase 2', 42, NULL, NULL, 59871),
(59872, '1.25.10.20-FF-000018', NULL, 'Microsomal triglyceride transfer protein large subunit', 309, NULL, NULL, 59872),
(59873, '3.30.40.10-FF-001175', NULL, 'Protein CBG13933', 90, NULL, NULL, 59873),
(59874, '1.10.418.40-FF-000022', NULL, 'Beclin homolog', 94, NULL, NULL, 59874),
(59875, '1.10.10.10-FF-001358', NULL, 'Cell death protein 4', 177, NULL, NULL, 59875),
(59876, '1.10.287.940-FF-000009', NULL, 'P2X purinoceptor', 29, NULL, NULL, 59876),
(59877, '1.25.40.10-FF-005132', NULL, 'Pentatricopeptide repeat-containing protein At2g15820, chloroplastic', 103, NULL, NULL, 59877);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(59878, '3.40.50.300-FF-008337', NULL, 'Chromosome 1, whole genome shotgun sequence', 266, NULL, NULL, 59878),
(59879, '1.20.5.4820-FF-000013', NULL, 'LOW QUALITY PROTEIN: unconventional myosin-Ib', 104, NULL, NULL, 59879),
(59880, '1.20.120.350-FF-000050', NULL, 'Solute carrier family 9 member C1', 128, NULL, NULL, 59880),
(59881, '1.10.287.70-FF-000164', NULL, 'Voltage-sensitive potassium channel', 95, NULL, NULL, 59881),
(59882, '1.25.40.10-FF-000461', NULL, 'cilia- and flagella-associated protein 70 isoform X1', 127, NULL, NULL, 59882),
(59883, '3.30.420.140-FF-000028', NULL, 'Suppressor of Ty 6 homolog', 174, NULL, NULL, 59883),
(59884, '1.20.1260.80-FF-000001', NULL, 'BARP protein', 185, NULL, NULL, 59884),
(59885, '1.25.40.10-FF-000585', NULL, 'Tetratricopeptide repeat domain 37', 181, NULL, NULL, 59885),
(59886, '3.90.550.10-FF-000733', NULL, 'Probable two-domain glycosyltransferase', 250, NULL, NULL, 59886),
(59887, '1.20.140.150-FF-000090', NULL, 'uncharacterized protein LOC100183788 isoform X1', 164, NULL, NULL, 59887),
(59888, '1.10.640.10-FF-000018', NULL, 'Peroxinectin A', 505, NULL, NULL, 59888),
(59889, '2.60.40.60-FF-000128', NULL, 'neural-cadherin isoform X2', 115, NULL, NULL, 59889),
(59890, '4.10.280.10-FF-000030', NULL, 'Twist transcription factor', 65, NULL, NULL, 59890),
(59891, '2.10.25.10-FF-000316', NULL, 'matrilin-2 isoform X2', 34, NULL, NULL, 59891),
(59892, '3.30.900.10-FF-000049', NULL, 'Uncharacterized protein', 104, NULL, NULL, 59892),
(59893, '1.10.472.80-FF-000064', NULL, 'GTPase-activating protein GYP3', 151, NULL, NULL, 59893),
(59894, '3.30.70.270-FF-000274', NULL, NULL, 124, NULL, NULL, 59894),
(59895, '1.10.287.920-FF-000003', NULL, 'Pheromone receptor', 81, NULL, NULL, 59895),
(59896, '2.40.50.140-FF-000379', NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase PRP22', 88, NULL, NULL, 59896),
(59897, '3.40.30.10-FF-000988', NULL, 'Uncharacterized protein', 86, NULL, NULL, 59897),
(59898, '2.40.20.10-FF-000080', NULL, 'Uncharacterized protein', 94, NULL, NULL, 59898),
(59899, '3.50.50.60-FF-000835', NULL, 'Flavin-containing monooxygenase', 100, NULL, NULL, 59899),
(59900, '3.30.40.10-FF-002012', NULL, 'Uncharacterized protein', 48, NULL, NULL, 59900),
(59901, '3.40.710.10-FF-000173', NULL, 'ABC1 family protein', 312, NULL, NULL, 59901),
(59902, '3.30.200.20-FF-000937', NULL, 'Related to checkpoint kinase chk1', 81, NULL, NULL, 59902),
(59903, '1.25.40.20-FF-001482', NULL, 'Uncharacterized protein', 94, NULL, NULL, 59903),
(59904, '2.40.70.10-FF-000083', NULL, 'lysosomal aspartic protease', 68, NULL, NULL, 59904),
(59905, '3.40.50.2300-FF-000808', NULL, NULL, 137, NULL, NULL, 59905),
(59906, '1.10.1410.10-FF-000017', NULL, 'Putative nucleotidyltransferase', 152, NULL, NULL, 59906),
(59907, '2.60.40.10-FF-003851', NULL, NULL, 100, NULL, NULL, 59907),
(59908, '1.10.730.10-FF-000177', NULL, 'Leucyl-tRNA synthetase 2, mitochondrial', 190, NULL, NULL, 59908),
(59909, '1.10.287.380-FF-000021', NULL, 'ABC transporter related', 76, NULL, NULL, 59909),
(59910, '1.20.1730.10-FF-000106', NULL, 'Sodium-dependent glucose transporter SGLT-I', 184, NULL, NULL, 59910),
(59911, '3.30.1490.80-FF-000003', NULL, 'Glutathione synthetase', 82, NULL, NULL, 59911),
(59912, '3.30.1010.10-FF-000031', NULL, 'Phosphatidylinositol 4-kinase beta', 155, NULL, NULL, 59912),
(59913, '2.60.40.340-FF-000005', NULL, 'RELB proto-oncogene, NF-kB subunit', 179, NULL, NULL, 59913),
(59914, '2.60.120.330-FF-000045', NULL, 'Oxidoreductase, 2OG-Fe(II) oxygenase family, putative', 318, NULL, NULL, 59914),
(59915, '2.60.40.790-FF-000174', NULL, NULL, 132, NULL, NULL, 59915),
(59916, '3.30.160.60-FF-000754', NULL, 'Zinc finger protein 585A', 30, NULL, NULL, 59916),
(59917, '1.10.1380.10-FF-000019', NULL, 'Fra mauro, isoform F', 43, NULL, NULL, 59917),
(59918, '3.30.200.20-FF-001213', NULL, 'Os04g0616200 protein', 62, NULL, NULL, 59918),
(59919, '1.25.10.10-FF-000072', NULL, 'dnaJ homolog subfamily C member 13 isoform X2', 196, NULL, NULL, 59919),
(59920, '2.40.50.140-FF-001216', NULL, NULL, 75, NULL, NULL, 59920);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(59921, '2.130.10.10-FF-004560', NULL, 'Uncharacterized protein', 215, NULL, NULL, 59921),
(59922, '1.10.1200.240-FF-000002', NULL, 'Uncharacterized protein', 121, NULL, NULL, 59922),
(59923, '2.40.50.690-FF-000009', NULL, 'Probable DIS3 3`-5` exoribonuclease required for 3` end formation of 5.8S rRNA', 109, NULL, NULL, 59923),
(59924, '3.30.70.330-FF-002282', NULL, NULL, 104, NULL, NULL, 59924),
(59925, '1.20.1250.20-FF-000292', NULL, 'Inner membrane transporter YdiM', 189, NULL, NULL, 59925),
(59926, '2.20.70.10-FF-000139', NULL, 'E3 ubiquitin-protein ligase Smurf1', 54, NULL, NULL, 59926),
(59927, '3.40.50.620-FF-000266', NULL, 'Isoleucine--tRNA ligase, putative', 243, NULL, NULL, 59927),
(59928, '1.10.287.70-FF-000563', NULL, 'Predicted protein', 97, NULL, NULL, 59928),
(59929, '1.10.3470.10-FF-000021', NULL, 'Staphyloferrin B ABC transporter permease subunit', 328, NULL, NULL, 59929),
(59930, '3.10.20.90-FF-000708', NULL, 'Ubiquilin', 85, NULL, NULL, 59930),
(59931, '3.40.50.720-FF-000706', NULL, 'Malic enzyme', 310, NULL, NULL, 59931),
(59932, '3.30.200.20-FF-000414', NULL, 'Putative serine/threonine-protein kinase haspin', 147, NULL, NULL, 59932),
(59933, '1.10.287.110-FF-000261', NULL, 'DnaJ_domain_containing_protein_-_putative', 101, NULL, NULL, 59933),
(59934, '3.40.50.1000-FF-000497', NULL, 'Phospholipid-transporting ATPase', 154, NULL, NULL, 59934),
(59935, '1.20.1270.10-FF-000026', NULL, 'Heat shock 70-related protein 1, mitochondrial', 85, NULL, NULL, 59935),
(59936, '2.170.120.40-FF-000003', NULL, 'YbbR-like domain-containing protein ybbR', 87, NULL, NULL, 59936),
(59937, '2.60.40.10-FF-002491', NULL, 'T cell receptor beta variable 12-4', 116, NULL, NULL, 59937),
(59938, '1.20.144.10-FF-000116', NULL, 'Uncharacterized protein', 203, NULL, NULL, 59938),
(59939, '3.30.160.60-FF-001030', NULL, 'Zinc finger protein 407', 27, NULL, NULL, 59939),
(59940, '4.10.60.10-FF-000157', NULL, 'Cleavage and polyadenylation specificity factor 30 kDa subunit', 43, NULL, NULL, 59940),
(59941, '1.10.510.10-FF-000537', NULL, 'Putative receptor-like protein kinase', 206, NULL, NULL, 59941),
(59942, '1.25.40.10-FF-004856', NULL, 'Predicted protein', 237, NULL, NULL, 59942),
(59943, '3.30.160.60-FF-004464', NULL, NULL, 41, NULL, NULL, 59943),
(59944, '3.80.10.10-FF-000693', NULL, 'LRR receptor-like serine/threonine-protein kinase EFR', 158, NULL, NULL, 59944),
(59945, '3.40.50.300-FF-007376', NULL, 'Uncharacterized protein', 264, NULL, NULL, 59945),
(59946, '2.60.40.770-FF-000016', NULL, 'AGAP002852-PA', 126, NULL, NULL, 59946),
(59947, '3.30.565.10-FF-000213', NULL, 'Sensor histidine kinase, KdpD', 153, NULL, NULL, 59947),
(59948, '1.25.40.10-FF-001422', NULL, 'HAT1-interacting factor 1', 282, NULL, NULL, 59948),
(59949, '3.40.225.10-FF-000017', NULL, 'Transcriptional regulator', 179, NULL, NULL, 59949),
(59950, '1.20.1560.10-FF-000801', NULL, 'Uncharacterized protein', 198, NULL, NULL, 59950),
(59951, '1.10.510.10-FF-001830', NULL, 'Predicted protein', 108, NULL, NULL, 59951),
(59952, '3.30.160.60-FF-001631', NULL, 'Zinc finger protein 836', 29, NULL, NULL, 59952),
(59953, '1.25.10.10-FF-001437', NULL, 'Uncharacterized protein', 193, NULL, NULL, 59953),
(59954, '1.10.8.720-FF-000029', NULL, 'Dynein heavy chain, putative', 186, NULL, NULL, 59954),
(59955, '1.10.1420.10-FF-000170', NULL, 'Gll4003 protein', 206, NULL, NULL, 59955),
(59956, '2.30.29.30-FF-000364', NULL, 'Rho guanyl nucleotide exchange factor', 155, NULL, NULL, 59956),
(59957, '2.130.10.10-FF-003767', NULL, 'Uncharacterized protein', 319, NULL, NULL, 59957),
(59958, '1.20.1560.10-FF-000374', NULL, 'HlyB/MsbA family ABC transporter', 313, NULL, NULL, 59958),
(59959, '3.80.10.10-FF-000620', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 142, NULL, NULL, 59959),
(59960, '1.10.472.10-FF-000476', NULL, 'Uncharacterized protein', 203, NULL, NULL, 59960),
(59961, '2.10.110.10-FF-000357', NULL, 'LIM domain-containing protein', 63, NULL, NULL, 59961),
(59962, '3.60.20.10-FF-000065', NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', 240, NULL, NULL, 59962);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(59963, '3.30.40.10-FF-000871', NULL, 'SNF2 family helicase/ATPase, putative', 92, NULL, NULL, 59963),
(59964, '1.20.1070.10-FF-001455', NULL, 'Uncharacterized protein', 218, NULL, NULL, 59964),
(59965, '2.40.170.20-FF-000008', NULL, 'TonB-linked outer membrane protein, SusC/RagA family', 689, NULL, NULL, 59965),
(59966, '1.10.8.270-FF-000175', NULL, 'Uncharacterized protein', 49, NULL, NULL, 59966),
(59967, '2.130.10.10-FF-000541', NULL, 'PWP2, small subunit processome component', 112, NULL, NULL, 59967),
(59968, '1.20.1440.340-FF-000008', NULL, 'Galactokinase, variant', 153, NULL, NULL, 59968),
(59969, '3.40.50.10090-FF-000036', NULL, 'Uroporphyrinogen-iii synthase', 113, NULL, NULL, 59969),
(59970, '3.40.50.2000-FF-000376', NULL, 'Glycosyltransferase', 47, NULL, NULL, 59970),
(59971, '1.20.58.390-FF-000293', NULL, 'Uncharacterized protein', 111, NULL, NULL, 59971),
(59972, '3.40.50.10900-FF-000021', NULL, 'Proteasome assembly chaperone 2', 170, NULL, NULL, 59972),
(59973, '3.40.50.10380-FF-000016', NULL, 'Malic enzyme', 192, NULL, NULL, 59973),
(59974, '1.10.510.10-FF-004264', NULL, NULL, 187, NULL, NULL, 59974),
(59975, '1.10.8.10-FF-000126', NULL, 'Enhancer of EfL-1 mutant phenotype', 59, NULL, NULL, 59975),
(59976, '1.20.58.150-FF-000024', NULL, NULL, 121, NULL, NULL, 59976),
(59977, '1.20.1070.10-FF-001938', NULL, 'Uncharacterized protein', 247, NULL, NULL, 59977),
(59978, '1.10.1370.30-FF-000047', NULL, 'Angiotensin-converting enzyme', 136, NULL, NULL, 59978),
(59979, '1.10.10.10-FF-000768', NULL, 'Transcriptional regulator, MarR family', 147, NULL, NULL, 59979),
(59980, '3.40.50.2300-FF-000359', NULL, 'DNA-binding response regulator', 122, NULL, NULL, 59980),
(59981, '2.30.30.40-FF-000319', NULL, 'CIN85 and CD2AP related, isoform C', 81, NULL, NULL, 59981),
(59982, '1.10.510.10-FF-000565', NULL, 'Serine/threonine-protein kinase ATG1a', 340, NULL, NULL, 59982),
(59983, '3.20.20.60-FF-000059', NULL, 'Acyl-CoA lyase subunit beta', 275, NULL, NULL, 59983),
(59984, '1.25.40.10-FF-003991', NULL, 'Uncharacterized protein', 214, NULL, NULL, 59984),
(59985, '2.30.30.40-FF-000275', NULL, 'Chemotaxis protein CheW', 59, NULL, NULL, 59985),
(59986, '3.40.50.1000-FF-000738', NULL, NULL, 53, NULL, NULL, 59986),
(59987, '2.60.120.1030-FF-000002', NULL, 'Clp1-related protein, putative', 109, NULL, NULL, 59987),
(59988, '1.20.1260.10-FF-000020', NULL, 'Ferritin', 207, NULL, NULL, 59988),
(59989, '1.20.58.60-FF-000201', NULL, 'nesprin-1 isoform X2', 286, NULL, NULL, 59989),
(59990, '1.10.287.110-FF-000457', NULL, 'DnaJ (Hsp40), subfamily C, member 13, putative', 44, NULL, NULL, 59990),
(59991, '3.50.50.60-FF-000419', NULL, 'Probable dehydrogenase', 140, NULL, NULL, 59991),
(59992, '3.90.1150.210-FF-000002', NULL, 'F-actin-capping protein subunit alpha', 144, NULL, NULL, 59992),
(59993, '2.40.30.10-FF-000119', NULL, 'Blast:Translation initiation factor IF-2, mitochondrial', 93, NULL, NULL, 59993),
(59994, '3.40.1190.20-FF-000112', NULL, 'PfkB-like carbohydrate kinase family protein', 306, NULL, NULL, 59994),
(59995, '1.20.1310.10-FF-000226', NULL, NULL, 133, NULL, NULL, 59995),
(59996, '3.40.850.10-FF-000132', NULL, 'Kinesin, putative', 384, NULL, NULL, 59996),
(59997, '3.40.190.10-FF-000907', NULL, 'Predicted protein', 107, NULL, NULL, 59997),
(59998, '3.40.50.740-FF-000021', NULL, 'NADH:ubiquinone oxidoreductase core subunit S1', 128, NULL, NULL, 59998),
(59999, '1.25.10.10-FF-002426', NULL, 'Uncharacterized protein', 244, NULL, NULL, 59999),
(60000, '2.20.70.10-FF-000038', NULL, 'E3 ubiquitin-protein ligase', 34, NULL, NULL, 60000),
(60001, '3.40.50.300-FF-002492', NULL, 'GTP-binding protein YPT11', 178, NULL, NULL, 60001),
(60002, '2.30.30.380-FF-000033', NULL, 'Endonuclease/Exonuclease/phosphatase family protein, expressed', 49, NULL, NULL, 60002),
(60003, '3.40.630.10-FF-000251', NULL, 'Putative N-acyl-L-amino acid amidohydrolase', 188, NULL, NULL, 60003),
(60004, '3.40.30.10-FF-000595', NULL, 'Cytochrome c oxidase assembly protein', 122, NULL, NULL, 60004),
(60005, '2.130.10.10-FF-006038', NULL, 'Predicted protein', 256, NULL, NULL, 60005);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(60006, '3.40.50.1820-FF-000451', NULL, 'Carboxylic ester hydrolase', 560, NULL, NULL, 60006),
(60007, '3.30.1490.40-FF-000002', NULL, 'CD2 antigen cytoplasmic tail-binding protein 2', 65, NULL, NULL, 60007),
(60008, '3.30.300.110-FF-000015', NULL, 'Protein CBG19351', 108, NULL, NULL, 60008),
(60009, '1.10.110.10-FF-000001', NULL, 'Bifunctional inhibitor/lipid-transfer protein/seed storage 2S albumin superfamily protein', 82, NULL, NULL, 60009),
(60010, '1.25.10.10-FF-000818', NULL, 'Pumilio homolog 24', 347, NULL, NULL, 60010),
(60011, '1.10.3720.10-FF-000226', NULL, 'Putative polyamine transport system, permease protein', 276, NULL, NULL, 60011),
(60012, '3.40.1110.10-FF-000233', NULL, NULL, 14, NULL, NULL, 60012),
(60013, '2.10.25.10-FF-000283', NULL, 'sushi, nidogen and EGF-like domain-containing protein 1 isoform X2', 37, NULL, NULL, 60013),
(60014, '1.10.10.10-FF-000329', NULL, 'regulator of G-protein signaling 9 isoform X2', 110, NULL, NULL, 60014),
(60015, '3.30.40.10-FF-001490', NULL, 'Putative zinc finger in N-recognin-domain-containing protein', 80, NULL, NULL, 60015),
(60016, '1.10.510.10-FF-003319', NULL, NULL, 71, NULL, NULL, 60016),
(60017, '1.10.730.10-FF-000093', NULL, 'Methionine--tRNA ligase', 182, NULL, NULL, 60017),
(60018, '3.40.50.300-FF-001873', NULL, 'ABC transporter family protein', 247, NULL, NULL, 60018),
(60019, '1.25.40.10-FF-002563', NULL, 'Leucine-rich PPR motif-containing protein, mitochondrial', 179, NULL, NULL, 60019),
(60020, '2.130.10.10-FF-003284', NULL, 'Pre-mRNA-splicing factor RSE1', 353, NULL, NULL, 60020),
(60021, '3.30.70.2600-FF-000002', NULL, 'Dipeptidyl peptidase 3', 76, NULL, NULL, 60021),
(60022, '1.20.58.120-FF-000009', NULL, 'BAG family molecular chaperone regulator 5', 83, NULL, NULL, 60022),
(60023, '3.90.550.10-FF-000284', NULL, 'Glycosyl transferase family 2', 225, NULL, NULL, 60023),
(60024, '3.30.70.330-FF-000314', NULL, 'RNA-binding protein Musashi Rbp6', 91, NULL, NULL, 60024),
(60025, '3.90.320.10-FF-000036', NULL, 'CRISPR-associated exonuclease Cas4', 168, NULL, NULL, 60025),
(60026, '1.25.10.10-FF-002382', NULL, 'Cullin-associated NEDD8-dissociated protein 1', 269, NULL, NULL, 60026),
(60027, '3.40.50.300-FF-006235', NULL, 'Predicted protein', 260, NULL, NULL, 60027),
(60028, '1.20.1070.10-FF-002074', NULL, 'Uncharacterized protein', 64, NULL, NULL, 60028),
(60029, '3.90.550.10-FF-000654', NULL, 'Dolichyl-phosphate beta-D-mannosyltransferase related protein', 127, NULL, NULL, 60029),
(60030, '3.30.460.20-FF-000023', NULL, 'Magnesium/cobalt transport protein', 121, NULL, NULL, 60030),
(60031, '3.40.30.10-FF-001112', NULL, 'Predicted protein', 19, NULL, NULL, 60031),
(60032, '1.20.58.2050-FF-000008', NULL, 'DNA replication complex GINS protein psf3', 163, NULL, NULL, 60032),
(60033, '1.20.1310.10-FF-000182', NULL, NULL, 149, NULL, NULL, 60033),
(60034, '1.25.40.120-FF-000091', NULL, 'Uncharacterized protein', 212, NULL, NULL, 60034),
(60035, '2.130.10.30-FF-000108', NULL, NULL, 182, NULL, NULL, 60035),
(60036, '2.130.10.10-FF-002339', NULL, 'Uncharacterized protein', 160, NULL, NULL, 60036),
(60037, '2.70.150.10-FF-000172', NULL, 'Cation-transporting ATPase', 147, NULL, NULL, 60037),
(60038, '3.90.1260.10-FF-000013', NULL, 'Uncharacterized protein', 79, NULL, NULL, 60038),
(60039, '3.40.50.450-FF-000041', NULL, 'ATP-dependent 6-phosphofructokinase', 222, NULL, NULL, 60039),
(60040, '3.40.720.10-FF-000050', NULL, 'Extracellular sulfatase SULF-1', 398, NULL, NULL, 60040),
(60041, '3.10.440.10-FF-000001', NULL, '60S ribosomal protein L31', 112, NULL, NULL, 60041),
(60042, '1.20.58.60-FF-000673', NULL, 'Nesprin-2', 281, NULL, NULL, 60042),
(60043, '2.102.10.10-FF-000020', NULL, 'Aromatic ring-hydroxylating dioxygenase subunit alpha', 120, NULL, NULL, 60043),
(60044, '2.40.160.10-FF-000033', NULL, 'Uncharacterized protein', 104, NULL, NULL, 60044),
(60045, '1.25.40.1040-FF-000043', NULL, 'Chromosome 21, whole genome shotgun sequence', 349, NULL, NULL, 60045),
(60046, '1.10.418.10-FF-000058', NULL, 'F-actin-methionine sulfoxide oxidase MICAL1 isoform X1', 109, NULL, NULL, 60046);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(60047, '2.40.50.140-FF-001267', NULL, NULL, 86, NULL, NULL, 60047),
(60048, '3.40.50.1910-FF-000017', NULL, 'BnaA02g18530D protein', 181, NULL, NULL, 60048),
(60049, '3.30.160.60-FF-003429', NULL, 'Zinc finger protein 1179', 28, NULL, NULL, 60049),
(60050, '1.20.120.420-FF-000020', NULL, 'Translation initiation factor EIF-2B subunit 1', 95, NULL, NULL, 60050),
(60051, '1.10.10.10-FF-001274', NULL, '(R,S)-reticuline 7-O-methyltransferase isoform A', 103, NULL, NULL, 60051),
(60052, '3.30.160.60-FF-004857', NULL, NULL, 80, NULL, NULL, 60052),
(60053, '2.60.40.10-FF-003643', NULL, NULL, 101, NULL, NULL, 60053),
(60054, '2.60.40.10-FF-001182', NULL, 'T-cell immunoreceptor with Ig and ITIM domains', 116, NULL, NULL, 60054),
(60055, '3.40.50.300-FF-000928', NULL, 'Pilus assembly protein CpaF', 201, NULL, NULL, 60055),
(60056, '2.30.250.10-FF-000014', NULL, 'Clan MH, family M18, aspartyl aminopeptidase-like metallopeptidase', 65, NULL, NULL, 60056),
(60057, '2.70.170.10-FF-000072', NULL, 'Uncharacterized protein', 222, NULL, NULL, 60057),
(60058, '3.30.40.10-FF-002327', NULL, 'Uncharacterized protein', 98, NULL, NULL, 60058),
(60059, '3.90.180.10-FF-000064', NULL, 'NADPH-dependent alkenal/one oxidoreductase, chloroplastic', 183, NULL, NULL, 60059),
(60060, '3.60.10.10-FF-000430', NULL, 'Predicted protein', 73, NULL, NULL, 60060),
(60061, '1.10.150.20-FF-000259', NULL, 'Probable DNA-directed RNA polymerase', 204, NULL, NULL, 60061),
(60062, '2.60.40.10-FF-000237', NULL, 'Sidekick cell adhesion molecule 2', 99, NULL, NULL, 60062),
(60063, '1.10.8.60-FF-000310', NULL, 'RAD17 checkpoint clamp loader component', 84, NULL, NULL, 60063),
(60064, '3.30.50.10-FF-000164', NULL, 'Zinc finger, C4 type, putative', 86, NULL, NULL, 60064),
(60065, '1.20.1460.10-FF-000001', NULL, 'V-type proton ATPase subunit C', 184, NULL, NULL, 60065),
(60066, '1.10.510.10-FF-000902', NULL, 'Muscle M-line assembly protein unc-89', 209, NULL, NULL, 60066),
(60067, '3.30.450.20-FF-000225', NULL, 'Methyl-accepting chemotaxis protein', 103, NULL, NULL, 60067),
(60068, '2.60.40.60-FF-000319', NULL, 'FAT atypical cadherin 1b', 104, NULL, NULL, 60068),
(60069, '2.60.40.10-FF-004632', NULL, NULL, 109, NULL, NULL, 60069),
(60070, '1.20.1050.10-FF-000144', NULL, 'Uncharacterized protein', 116, NULL, NULL, 60070),
(60071, '3.30.200.20-FF-000858', NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', 109, NULL, NULL, 60071),
(60072, '3.40.50.80-FF-000246', NULL, 'NADPH oxidase 4', 90, NULL, NULL, 60072),
(60073, '3.40.1280.10-FF-000071', NULL, 'Uncharacterized protein', 198, NULL, NULL, 60073),
(60074, '3.40.50.1980-FF-000127', NULL, 'Vitamin B12 ABC transporter, B12-binding component BtuF', 146, NULL, NULL, 60074),
(60075, '3.30.230.10-FF-000357', NULL, 'Uncharacterized protein', 205, NULL, NULL, 60075),
(60076, '1.25.40.10-FF-003182', NULL, 'Os03g0283500 protein', 102, NULL, NULL, 60076),
(60077, '1.25.40.530-FF-000005', NULL, 'Kinesin-like calmodulin-binding protein (ZWICHEL)', 183, NULL, NULL, 60077),
(60078, '3.40.50.11380-FF-000007', NULL, NULL, 98, NULL, NULL, 60078),
(60079, '3.40.630.30-FF-000627', NULL, 'Uncharacterized protein', 182, NULL, NULL, 60079),
(60080, '3.30.870.10-FF-000170', NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', 206, NULL, NULL, 60080),
(60081, '3.90.45.10-FF-000003', NULL, 'Peptide deformylase', 184, NULL, NULL, 60081),
(60082, '3.40.50.970-FF-000005', NULL, '1-deoxy-D-xylulose-5-phosphate synthase', 169, NULL, NULL, 60082),
(60083, '2.10.70.10-FF-000016', NULL, 'Mannan-binding lectin serine protease 1', 76, NULL, NULL, 60083),
(60084, '1.20.140.30-FF-000006', NULL, 'Mob1p', 236, NULL, NULL, 60084),
(60085, '1.10.1520.10-FF-000115', NULL, 'Dicer-1, putative', 215, NULL, NULL, 60085),
(60086, '3.40.50.300-FF-005616', NULL, 'Dynein, axonemal, heavy chain 11', 96, NULL, NULL, 60086),
(60087, '1.25.10.10-FF-002735', NULL, 'Uncharacterized protein', 836, NULL, NULL, 60087),
(60088, '3.40.50.300-FF-007180', NULL, 'Uncharacterized protein', 286, NULL, NULL, 60088);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(60089, '3.30.559.10-FF-000013', NULL, 'Peroxisomal carnitine O-octanoyltransferase', 154, NULL, NULL, 60089),
(60090, '2.30.29.30-FF-000701', NULL, 'Vacuolar protein-sorting-associated protein 36', 132, NULL, NULL, 60090),
(60091, '3.30.160.60-FF-000675', NULL, 'Zinc finger protein 624', 28, NULL, NULL, 60091),
(60092, '1.20.58.1070-FF-000012', NULL, 'WGS project CABT00000000 data, contig 2.4', 162, NULL, NULL, 60092),
(60093, '3.40.50.150-FF-001367', NULL, NULL, 285, NULL, NULL, 60093),
(60094, '1.20.80.10-FF-000081', NULL, 'Uncharacterized protein', 75, NULL, NULL, 60094),
(60095, '3.40.50.1000-FF-000429', NULL, '4-nitrophenylphosphatase, putative', 136, NULL, NULL, 60095),
(60096, '3.80.10.10-FF-001446', NULL, 'Si:ch211-11p18.6', 127, NULL, NULL, 60096),
(60097, '1.20.5.190-FF-000025', NULL, 'IQ motif containing E', 54, NULL, NULL, 60097),
(60098, '3.30.420.40-FF-000246', NULL, 'Xks1p', 315, NULL, NULL, 60098),
(60099, '3.40.50.10800-FF-000007', NULL, 'Quinolinate synthase A', 98, NULL, NULL, 60099),
(60100, '3.30.420.10-FF-000720', NULL, NULL, 78, NULL, NULL, 60100),
(60101, '1.20.1070.10-FF-000027', NULL, 'alpha-1A adrenergic receptor', 345, NULL, NULL, 60101),
(60102, '3.30.70.330-FF-001725', NULL, NULL, 96, NULL, NULL, 60102),
(60103, '3.30.559.30-FF-000019', NULL, 'Nonribosomal siderophore peptide synthase SidC', 251, NULL, NULL, 60103),
(60104, '3.30.2090.10-FF-000008', NULL, 'Cation efflux system protein CusA', 94, NULL, NULL, 60104),
(60105, '2.10.60.10-FF-000061', NULL, 'TGF-beta receptor type-2', 114, NULL, NULL, 60105),
(60106, '1.10.10.2830-FF-000003', NULL, 'Probable chromosome 2-partitioning protein ParB', 136, NULL, NULL, 60106),
(60107, '3.10.450.50-FF-000093', NULL, 'Uncharacterized protein C11D3.04c', 118, NULL, NULL, 60107),
(60108, '1.25.40.10-FF-004019', NULL, 'Lysine (K)-specific demethylase 6A,-like', 194, NULL, NULL, 60108),
(60109, '2.60.40.10-FF-005088', NULL, NULL, 100, NULL, NULL, 60109),
(60110, '3.30.750.24-FF-000011', NULL, 'Anti-sigma factor antagonist', 112, NULL, NULL, 60110),
(60111, '3.40.5.10-FF-000026', NULL, '50S ribosomal protein L9 chloroplastic', 44, NULL, NULL, 60111),
(60112, '1.25.40.20-FF-000003', NULL, 'Ankyrin, isoform B', 416, NULL, NULL, 60112),
(60113, '3.80.10.10-FF-002065', NULL, 'Disease resistance protein RPS6', 235, NULL, NULL, 60113),
(60114, '3.40.50.2300-FF-000729', NULL, 'Olfactory receptor C family, g2', 72, NULL, NULL, 60114),
(60115, '1.10.287.1080-FF-000018', NULL, 'Nucleotide pyrophosphohydrolase', 104, NULL, NULL, 60115),
(60116, '1.10.533.10-FF-000129', NULL, 'Predicted protein', 98, NULL, NULL, 60116),
(60117, '3.20.20.80-FF-000245', NULL, 'Histone H2B', 353, NULL, NULL, 60117),
(60118, '3.40.50.150-FF-000850', NULL, 'Uncharacterized methyltransferase C977.03', 137, NULL, NULL, 60118),
(60119, '2.60.40.2170-FF-000012', NULL, 'AGAP006405-PA', 126, NULL, NULL, 60119),
(60120, '2.170.270.10-FF-000156', NULL, 'Uncharacterized protein', 148, NULL, NULL, 60120),
(60121, '2.60.40.10-FF-004941', NULL, NULL, 59, NULL, NULL, 60121),
(60122, '2.60.40.1930-FF-000013', NULL, 'Alpha-2-macroglobulin like 1', 106, NULL, NULL, 60122),
(60123, '4.10.1000.10-FF-000107', NULL, 'Nuclear fragile X mental retardation-interacting protein 1-domain-containing protein', 84, NULL, NULL, 60123),
(60124, '1.20.1070.10-FF-001808', NULL, 'Uncharacterized protein', 314, NULL, NULL, 60124),
(60125, '2.40.100.10-FF-000057', NULL, 'Cyclophilin 14, putative', 171, NULL, NULL, 60125),
(60126, '2.10.25.10-FF-001581', NULL, 'Delta-like protein', 36, NULL, NULL, 60126),
(60127, '1.20.120.720-FF-000003', NULL, 'Putative unconventional myosin-IXa', 132, NULL, NULL, 60127),
(60128, '2.30.30.100-FF-000011', NULL, 'small nuclear ribonucleoprotein F', 78, NULL, NULL, 60128),
(60129, '1.20.120.80-FF-000014', NULL, 'Cytochrome c oxidase subunit 3', 133, NULL, NULL, 60129),
(60130, '1.10.510.10-FF-001993', NULL, 'Serine/threonine-protein kinase, putative', 287, NULL, NULL, 60130),
(60131, '2.60.40.3170-FF-000003', NULL, 'tripeptidyl-peptidase 2', 131, NULL, NULL, 60131);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(60132, '3.20.20.70-FF-000388', NULL, 'Histone acetyltransferase Elp3 homolog', 198, NULL, NULL, 60132),
(60133, '2.40.50.140-FF-000648', NULL, 'Mitochondrial 37S ribosomal protein S17', 143, NULL, NULL, 60133),
(60134, '1.25.40.10-FF-002693', NULL, 'Uncharacterized protein', 319, NULL, NULL, 60134),
(60135, '2.40.50.140-FF-000278', NULL, 'rRNA biogenesis protein rrp5', 89, NULL, NULL, 60135),
(60136, '2.60.120.200-FF-000141', NULL, 'L-type lectin-domain containing receptor kinase VIII.1', 241, NULL, NULL, 60136),
(60137, '2.130.10.30-FF-000064', NULL, 'RCC1 domain-containing protein RUG3, mitochondrial', 193, NULL, NULL, 60137),
(60138, '2.40.10.10-FF-000236', NULL, 'Putative trypsin', 133, NULL, NULL, 60138),
(60139, '1.25.40.10-FF-004963', NULL, 'Pentatricopeptide repeat-containing protein At1g62260, mitochondrial', 159, NULL, NULL, 60139),
(60140, '3.30.310.10-FF-000049', NULL, 'AP complex subunit beta', 116, NULL, NULL, 60140),
(60141, '2.10.110.10-FF-000227', NULL, 'Protein DA1-related 5', 78, NULL, NULL, 60141),
(60142, '2.30.42.10-FF-000187', NULL, 'Na(+)/H(+) exchange regulatory cofactor NHE-RF3', 103, NULL, NULL, 60142),
(60143, '1.25.40.860-FF-000020', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 76, NULL, NULL, 60143),
(60144, '2.60.40.10-FF-003008', NULL, 'Probable beta-D-xylosidase 5', 119, NULL, NULL, 60144),
(60145, '3.90.70.10-FF-000325', NULL, 'Ubiquitin carboxyl-terminal hydrolase 33', 48, NULL, NULL, 60145),
(60146, '3.40.50.620-FF-000131', NULL, '7-cyano-7-deazaguanine synthase', 216, NULL, NULL, 60146),
(60147, '1.25.10.10-FF-003371', NULL, 'Unc-45 homolog B (C. elegans) (Predicted)', 164, NULL, NULL, 60147),
(60148, '3.30.160.60-FF-004048', NULL, NULL, 32, NULL, NULL, 60148),
(60149, '2.40.70.10-FF-000228', NULL, 'Uncharacterized protein', 182, NULL, NULL, 60149),
(60150, '3.40.30.10-FF-000948', NULL, 'Thioredoxin domain containing 12', 108, NULL, NULL, 60150),
(60151, '2.10.50.10-FF-000133', NULL, 'Ephrin type-B receptor 5', 66, NULL, NULL, 60151),
(60152, '3.80.10.10-FF-003846', NULL, 'Leucine Rich Repeat family protein', 258, NULL, NULL, 60152),
(60153, '3.30.720.170-FF-000004', NULL, 'Perilipin', 48, NULL, NULL, 60153),
(60154, '3.40.50.150-FF-000541', NULL, 'Putative O-methyltransferase', 226, NULL, NULL, 60154),
(60155, '3.90.740.10-FF-000028', NULL, 'Valine--tRNA ligase', 34, NULL, NULL, 60155),
(60156, '2.60.40.60-FF-000780', NULL, 'Cadherin 15, type 1, M-cadherin (myotubule)', 102, NULL, NULL, 60156),
(60157, '3.30.70.330-FF-002670', NULL, NULL, 139, NULL, NULL, 60157),
(60158, '1.10.260.50-FF-000001', NULL, 'Selenocysteine lyase', 90, NULL, NULL, 60158),
(60159, '3.30.1370.210-FF-000018', NULL, 'Predicted protein', 88, NULL, NULL, 60159),
(60160, '1.20.1070.10-FF-000527', NULL, 'Parathyroid hormone/parathyroid hormone-related peptide receptor', 314, NULL, NULL, 60160),
(60161, '3.40.50.1820-FF-000804', NULL, 'Carboxylic ester hydrolase', 560, NULL, NULL, 60161),
(60162, '3.50.50.60-FF-000728', NULL, 'WGS project CABT00000000 data, contig 2.37', 147, NULL, NULL, 60162),
(60163, '1.25.40.10-FF-003210', NULL, 'SEL-1', 80, NULL, NULL, 60163),
(60164, '3.20.20.190-FF-000091', NULL, 'Phosphoinositide phospholipase C', 166, NULL, NULL, 60164),
(60165, '2.60.260.20-FF-000117', NULL, 'DnaJ protein', 76, NULL, NULL, 60165),
(60166, '1.25.10.10-FF-002073', NULL, 'Transportin2-like protein', 281, NULL, NULL, 60166),
(60167, '1.10.510.10-FF-000874', NULL, 'Non-specific serine/threonine protein kinase', 201, NULL, NULL, 60167),
(60168, '1.20.1250.20-FF-000393', NULL, 'solute carrier family 45 member 3', 210, NULL, NULL, 60168),
(60169, '1.10.510.10-FF-003336', NULL, NULL, 51, NULL, NULL, 60169),
(60170, '3.30.160.60-FF-005537', NULL, NULL, 48, NULL, NULL, 60170),
(60171, '1.10.510.10-FF-002482', NULL, NULL, 229, NULL, NULL, 60171),
(60172, '1.10.730.10-FF-000076', NULL, 'Leucyl-tRNA synthetase, cytoplasmic, putative', 116, NULL, NULL, 60172),
(60173, '1.20.990.10-FF-000025', NULL, 'Oxidoreductase-like protein', 154, NULL, NULL, 60173),
(60174, '3.90.320.10-FF-000053', NULL, 'CRISPR-associated exonuclease Cas4', 190, NULL, NULL, 60174);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(60175, '3.30.420.150-FF-000014', NULL, 'Ectonucleoside triphosphate diphosphohydrolase 6', 88, NULL, NULL, 60175),
(60176, '1.20.1070.10-FF-002091', NULL, 'Transmembrane receptor, putative', 326, NULL, NULL, 60176),
(60177, '3.90.25.10-FF-000092', NULL, 'Uncharacterized protein', 16, NULL, NULL, 60177),
(60178, '3.40.50.2000-FF-000600', NULL, 'GD20680', 170, NULL, NULL, 60178),
(60179, '3.40.50.1700-FF-000061', NULL, 'Uncharacterized protein', 115, NULL, NULL, 60179),
(60180, '2.30.29.30-FF-001292', NULL, 'Uncharacterized protein', 88, NULL, NULL, 60180),
(60181, '3.30.565.10-FF-000073', NULL, 'DNA topoisomerase II large subunit', 231, NULL, NULL, 60181),
(60182, '1.10.287.1490-FF-000153', NULL, 'Uncharacterized protein', 163, NULL, NULL, 60182),
(60183, '3.30.40.10-FF-000399', NULL, 'SNF2 helicase, putative (ISWI)', 117, NULL, NULL, 60183),
(60184, '3.30.40.10-FF-000219', NULL, 'PHD finger protein 6 isoform X1', 126, NULL, NULL, 60184),
(60185, '2.20.110.10-FF-000012', NULL, 'Junctophilin', 46, NULL, NULL, 60185),
(60186, '2.130.10.10-FF-002356', NULL, 'Uncharacterized protein', 178, NULL, NULL, 60186),
(60187, '2.60.40.10-FF-001535', NULL, 'Basal cell adhesion molecule', 84, NULL, NULL, 60187),
(60188, '3.40.47.10-FF-000279', NULL, NULL, 52, NULL, NULL, 60188),
(60189, '2.60.220.50-FF-000023', NULL, 'Adhesion G protein-coupled receptor G3', 177, NULL, NULL, 60189),
(60190, '3.30.200.20-FF-000488', NULL, 'Related to severin kinase', 92, NULL, NULL, 60190),
(60191, '1.10.238.10-FF-000432', NULL, 'Calcium-dependent protein kinase 18', 178, NULL, NULL, 60191),
(60192, '2.160.20.10-FF-000225', NULL, 'Os01g0549000 protein', 265, NULL, NULL, 60192),
(60193, '1.25.40.10-FF-004828', NULL, 'Enhanced entry protein enhC, tetratricopeptide repeat family', 356, NULL, NULL, 60193),
(60194, '1.25.10.10-FF-000948', NULL, 'Related to KOG1-Subunit of TORC1, a rapamycin-sensitive complex involved in growth control', 221, NULL, NULL, 60194),
(60195, '3.30.420.40-FF-000616', NULL, 'Putative glycerol kinase 5', 120, NULL, NULL, 60195),
(60196, '3.30.70.330-FF-000736', NULL, 'Polyadenylate-binding protein, putative', 87, NULL, NULL, 60196),
(60197, '1.10.287.110-FF-000002', NULL, 'putative tyrosine-protein phosphatase auxilin isoform X2', 126, NULL, NULL, 60197),
(60198, '1.20.1090.10-FF-000057', NULL, '3-dehydroquinate synthase', 182, NULL, NULL, 60198),
(60199, '3.80.10.10-FF-002435', NULL, 'Uncharacterized protein', 153, NULL, NULL, 60199),
(60200, '3.40.50.1110-FF-000007', NULL, 'Acyloxyacyl hydrolase', 212, NULL, NULL, 60200),
(60201, '2.60.40.10-FF-004469', NULL, NULL, 97, NULL, NULL, 60201),
(60202, '2.40.160.10-FF-000050', NULL, 'Probable mitochondrial import receptor subunit TOM40-2', 280, NULL, NULL, 60202),
(60203, '3.40.50.1000-FF-000868', NULL, NULL, 19, NULL, NULL, 60203),
(60204, '1.10.510.10-FF-001493', NULL, 'Protein kinase domain containing protein', 330, NULL, NULL, 60204),
(60205, '3.30.160.60-FF-001159', NULL, 'Protein glass', 32, NULL, NULL, 60205),
(60206, '3.10.310.60-FF-000001', NULL, 'Yos9p', 136, NULL, NULL, 60206),
(60207, '1.25.10.10-FF-000509', NULL, 'AP-2 complex subunit alpha, putative', 625, NULL, NULL, 60207),
(60208, '2.60.40.10-FF-005897', NULL, NULL, 72, NULL, NULL, 60208),
(60209, '3.90.640.10-FF-000083', NULL, 'Protein CBG05834', 98, NULL, NULL, 60209),
(60210, '3.30.70.330-FF-002198', NULL, NULL, 113, NULL, NULL, 60210),
(60211, '1.10.565.10-FF-000017', NULL, 'Peroxisome proliferator-activated receptor gamma', 270, NULL, NULL, 60211),
(60212, '3.90.45.10-FF-000020', NULL, 'Peptide deformylase', 165, NULL, NULL, 60212),
(60213, '3.40.50.11660-FF-000001', NULL, 'alpha-(1,3)-fucosyltransferase 9', 197, NULL, NULL, 60213),
(60214, '3.30.50.10-FF-000147', NULL, 'YALI0E02442p', 65, NULL, NULL, 60214),
(60215, '3.90.228.10-FF-000001', NULL, 'Poly [ADP-ribose] polymerase tankyrase-2', 162, NULL, NULL, 60215),
(60216, '1.10.1420.10-FF-000153', NULL, 'Predicted protein', 108, NULL, NULL, 60216),
(60217, '3.30.830.10-FF-000077', NULL, 'YOL098Cp-like protein', 224, NULL, NULL, 60217);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(60218, '1.10.8.270-FF-000192', NULL, 'Uncharacterized protein', 83, NULL, NULL, 60218),
(60219, '1.10.472.10-FF-000459', NULL, 'Uncharacterized protein', 138, NULL, NULL, 60219),
(60220, '3.30.1490.190-FF-000005', NULL, 'Fur family transcriptional regulator', 51, NULL, NULL, 60220),
(60221, '1.25.40.20-FF-001594', NULL, 'Predicted protein', 115, NULL, NULL, 60221),
(60222, '3.30.1010.10-FF-000003', NULL, 'Phosphatidylinositol 4-kinase, catalytic, beta', 150, NULL, NULL, 60222),
(60223, '3.60.40.10-FF-000139', NULL, 'DNA-binding response regulator', 244, NULL, NULL, 60223),
(60224, '3.30.2340.10-FF-000005', NULL, 'tRNA pseudouridine synthase D', 82, NULL, NULL, 60224),
(60225, '3.30.710.10-FF-000467', NULL, 'Protein CBG00481', 112, NULL, NULL, 60225),
(60226, '2.30.29.30-FF-000673', NULL, 'Src kinase associated phosphoprotein 1', 109, NULL, NULL, 60226),
(60227, '1.10.472.10-FF-000537', NULL, 'Meiosis-specific cyclin crs1', 82, NULL, NULL, 60227),
(60228, '2.60.40.10-FF-006077', NULL, NULL, 80, NULL, NULL, 60228),
(60229, '3.40.50.620-FF-000570', NULL, 'Uncharacterized protein', 154, NULL, NULL, 60229),
(60230, '4.10.800.10-FF-000020', NULL, 'Magu, isoform F', 71, NULL, NULL, 60230),
(60231, '3.30.160.60-FF-004918', NULL, NULL, 30, NULL, NULL, 60231),
(60232, '1.20.5.470-FF-000002', NULL, 'Argininosuccinate synthase', 35, NULL, NULL, 60232),
(60233, '3.30.450.40-FF-000074', NULL, 'Phosphodiesterase', 31, NULL, NULL, 60233),
(60234, '3.40.50.2000-FF-000729', NULL, 'Uncharacterized protein', 107, NULL, NULL, 60234),
(60235, '2.130.10.10-FF-005684', NULL, 'Vacuolar protein sorting/targeting protein 10', 159, NULL, NULL, 60235),
(60236, '2.10.25.10-FF-000311', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', 39, NULL, NULL, 60236),
(60237, '2.130.10.10-FF-004256', NULL, 'Predicted protein', 138, NULL, NULL, 60237),
(60238, '1.25.40.1030-FF-000023', NULL, 'Protein transport protein Sec31, putative', 345, NULL, NULL, 60238),
(60239, '3.20.20.100-FF-000165', NULL, 'Oxidoreductase, aldo/keto reductase family protein', 199, NULL, NULL, 60239),
(60240, '1.10.287.3240-FF-000026', NULL, 'V-type h-atpase subunit', 213, NULL, NULL, 60240),
(60241, '2.60.120.330-FF-000197', NULL, 'Uncharacterized protein', 158, NULL, NULL, 60241),
(60242, '3.30.160.60-FF-002592', NULL, 'Zinc finger protein 527', 28, NULL, NULL, 60242),
(60243, '2.60.120.260-FF-000491', NULL, 'Uncharacterized protein', 110, NULL, NULL, 60243),
(60244, '3.40.630.30-FF-000599', NULL, 'Uncharacterized protein', 72, NULL, NULL, 60244),
(60245, '1.10.510.10-FF-001049', NULL, 'YPL236C-like protein', 166, NULL, NULL, 60245),
(60246, '3.40.50.300-FF-008489', NULL, 'Protein CBG24214', 158, NULL, NULL, 60246),
(60247, '3.40.50.300-FF-000384', NULL, 'Thymidine kinase', 141, NULL, NULL, 60247),
(60248, '1.10.10.10-FF-001302', NULL, 'RNA polymerase sigma factor sigD, chloroplastic', 54, NULL, NULL, 60248),
(60249, '3.30.40.10-FF-000062', NULL, 'E3 ubiquitin-protein ligase RNF185', 70, NULL, NULL, 60249),
(60250, '1.10.287.130-FF-000008', NULL, 'Two-component sensor histidine kinase', 76, NULL, NULL, 60250),
(60251, '2.30.30.40-FF-000628', NULL, 'Wu:fi04e12', 12, NULL, NULL, 60251),
(60252, '3.30.200.20-FF-001022', NULL, 'Serine/threonine-protein kinase STE7 homolog', 108, NULL, NULL, 60252),
(60253, '1.20.58.740-FF-000004', NULL, 'Dedicator of cytokinesis protein 1', 130, NULL, NULL, 60253),
(60254, '1.10.287.950-FF-000046', NULL, 'Methyl-accepting chemotaxis protein', 293, NULL, NULL, 60254),
(60255, '3.30.450.20-FF-000197', NULL, 'Probable sensor histidine kinase pdtaS', 151, NULL, NULL, 60255),
(60256, '3.80.10.10-FF-000592', NULL, 'Toll-like receptor 5', 220, NULL, NULL, 60256),
(60257, '3.40.50.1100-FF-000089', NULL, 'Threonine synthase', 192, NULL, NULL, 60257),
(60258, '3.30.710.10-FF-000130', NULL, 'SKP1-like protein 5', 154, NULL, NULL, 60258),
(60259, '3.40.50.300-FF-008461', NULL, 'Uncharacterized protein', 71, NULL, NULL, 60259),
(60260, '1.25.40.10-FF-000337', NULL, 'Poly-beta-1,6 N-acetyl-D-glucosamine export porin PgaA', 320, NULL, NULL, 60260);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(60261, '2.60.40.10-FF-005560', NULL, NULL, 112, NULL, NULL, 60261),
(60262, '3.40.50.1000-FF-000076', NULL, 'Haloacid dehalogenase hydrolase', 192, NULL, NULL, 60262),
(60263, '3.40.50.2000-FF-000067', NULL, 'Digalactosyldiacylglycerol synthase 1, chloroplastic', 151, NULL, NULL, 60263),
(60264, '1.20.1050.10-FF-000083', NULL, 'Glutathione S-transferase Mu 1', 105, NULL, NULL, 60264),
(60265, '3.40.50.720-FF-000818', NULL, 'NAD(P)-dependent oxidoreductase', 247, NULL, NULL, 60265),
(60266, '3.30.30.30-FF-000011', NULL, 'heat shock protein 105 kDa isoform X2', 52, NULL, NULL, 60266),
(60267, '1.20.5.490-FF-000008', NULL, 'AraJ, Arabinose efflux permease', 62, NULL, NULL, 60267),
(60268, '2.120.10.30-FF-000266', NULL, 'Probable TolB protein', 125, NULL, NULL, 60268),
(60269, '3.40.850.10-FF-000115', NULL, 'Myosin heavy polypeptide 6', 101, NULL, NULL, 60269),
(60270, '3.40.50.300-FF-002845', NULL, 'ATP-binding cassette subfamily B member 5', 119, NULL, NULL, 60270),
(60271, '3.40.50.10490-FF-000049', NULL, 'Putative arabinose 5-phosphate isomerase', 194, NULL, NULL, 60271),
(60272, '1.10.8.720-FF-000046', NULL, 'Uncharacterized protein', 123, NULL, NULL, 60272),
(60273, '3.10.20.90-FF-000568', NULL, 'UV excision repair RAD23 protein, putative', 82, NULL, NULL, 60273),
(60274, '3.40.50.300-FF-002862', NULL, 'Dynein heavy chain family protein', 180, NULL, NULL, 60274),
(60275, '1.10.720.30-FF-000025', NULL, 'Protein THO1', 48, NULL, NULL, 60275),
(60276, '1.20.1250.20-FF-001101', NULL, 'MFS transporter', 421, NULL, NULL, 60276),
(60277, '2.40.128.180-FF-000015', NULL, NULL, 38, NULL, NULL, 60277),
(60278, '3.10.129.10-FF-000076', NULL, '3-hydroxyacyl-[acyl-carrier-protein] dehydratase FabZ', 146, NULL, NULL, 60278),
(60279, '1.10.1410.10-FF-000096', NULL, 'U3 small nucleolar RNA-associated protein 22', 51, NULL, NULL, 60279),
(60280, '3.40.50.620-FF-000261', NULL, 'Ethanolamine-phosphate cytidylyltransferase', 245, NULL, NULL, 60280),
(60281, '2.130.10.10-FF-002811', NULL, 'DNA damage-binding protein CMR1', 376, NULL, NULL, 60281),
(60282, '2.20.100.10-FF-000247', NULL, 'Uncharacterized protein', 76, NULL, NULL, 60282),
(60283, '2.60.40.10-FF-004924', NULL, NULL, 59, NULL, NULL, 60283),
(60284, '1.10.150.50-FF-000111', NULL, 'Predicted protein', 71, NULL, NULL, 60284),
(60285, '1.10.10.60-FF-000058', NULL, 'zinc finger homeobox protein 4', 65, NULL, NULL, 60285),
(60286, '3.40.190.10-FF-000115', NULL, 'ATP phosphoribosyltransferase', 113, NULL, NULL, 60286),
(60287, '3.30.830.10-FF-000094', NULL, 'Zn-dependent peptidase putative', 254, NULL, NULL, 60287),
(60288, '1.10.238.10-FF-001258', NULL, 'Rhomboid-like protein', 61, NULL, NULL, 60288),
(60289, '2.40.160.110-FF-000008', NULL, 'Uncharacterized protein', 175, NULL, NULL, 60289),
(60290, '3.40.50.300-FF-003790', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 265, NULL, NULL, 60290),
(60291, '3.40.50.80-FF-000116', NULL, 'Uncharacterized protein', 171, NULL, NULL, 60291),
(60292, '1.20.930.80-FF-000008', NULL, 'DNA primase large subunit, putative', 220, NULL, NULL, 60292),
(60293, '3.30.470.20-FF-000108', NULL, 'D-alanine--d-alanine ligase', 158, NULL, NULL, 60293),
(60294, '3.60.10.10-FF-000300', NULL, 'Predicted protein', 329, NULL, NULL, 60294),
(60295, '1.25.40.180-FF-000322', NULL, NULL, 71, NULL, NULL, 60295),
(60296, '1.20.144.10-FF-000144', NULL, 'Putative lipid phosphate phosphatase 3 chloroplastic', 111, NULL, NULL, 60296),
(60297, '3.40.50.300-FF-002992', NULL, 'RNA helicase', 188, NULL, NULL, 60297),
(60298, '1.20.940.10-FF-000005', NULL, 'protein transport protein Sec31B isoform X1', 111, NULL, NULL, 60298),
(60299, '1.25.40.170-FF-000010', NULL, 'Uncharacterized protein', 132, NULL, NULL, 60299),
(60300, '1.10.150.810-FF-000005', NULL, 'DNA polymerase kappa-like', 92, NULL, NULL, 60300),
(60301, '1.25.40.10-FF-000776', NULL, 'Pentatricopeptide repeat-containing protein At3g13880', 250, NULL, NULL, 60301),
(60302, '3.30.590.10-FF-000041', NULL, 'Glutamine synthetase catalytic region', 324, NULL, NULL, 60302);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(60303, '1.25.40.10-FF-001265', NULL, 'Pentatricopeptide repeat-containing protein isoform B', 220, NULL, NULL, 60303),
(60304, '1.25.40.10-FF-000646', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 100, NULL, NULL, 60304),
(60305, '3.40.50.300-FF-008152', NULL, 'Dynein heavy chain', 94, NULL, NULL, 60305),
(60306, '2.20.150.10-FF-000003', NULL, NULL, 43, NULL, NULL, 60306),
(60307, '3.20.20.80-FF-000700', NULL, 'Uncharacterized protein', 197, NULL, NULL, 60307),
(60308, '3.30.70.330-FF-002653', NULL, NULL, 120, NULL, NULL, 60308),
(60309, '3.30.200.20-FF-001005', NULL, 'LRR receptor-like serine/threonine-protein kinase HSL2', 103, NULL, NULL, 60309),
(60310, '1.25.10.10-FF-002865', NULL, 'Maestro heat-like repeat-containing protein family member 2B', 161, NULL, NULL, 60310),
(60311, '2.60.40.10-FF-002154', NULL, 'Uncharacterized protein', 90, NULL, NULL, 60311),
(60312, '3.80.10.10-FF-000518', NULL, 'F-box family protein', 168, NULL, NULL, 60312),
(60313, '1.10.730.10-FF-000104', NULL, 'Methionine-tRNA ligase', 176, NULL, NULL, 60313),
(60314, '3.80.10.10-FF-003054', NULL, 'Uncharacterized protein', 149, NULL, NULL, 60314),
(60315, '3.40.30.10-FF-000965', NULL, '2-hydroxychromene-2-carboxylate isomerase', 197, NULL, NULL, 60315),
(60316, '1.25.40.10-FF-005008', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 118, NULL, NULL, 60316),
(60317, '3.40.50.720-FF-000026', NULL, 'Glyoxylate/hydroxypyruvate reductase B', 189, NULL, NULL, 60317),
(60318, '3.30.160.60-FF-003076', NULL, 'zinc finger and BTB domain-containing protein 49 isoform X2', 27, NULL, NULL, 60318),
(60319, '2.10.25.10-FF-000620', NULL, 'Mutant fibrillin-1', 40, NULL, NULL, 60319),
(60320, '2.130.10.10-FF-005993', NULL, 'Protein CBR-KLP-12', 226, NULL, NULL, 60320),
(60321, '2.60.40.2610-FF-000009', NULL, NULL, 89, NULL, NULL, 60321),
(60322, '2.60.40.10-FF-003660', NULL, NULL, 119, NULL, NULL, 60322),
(60323, '4.10.1000.10-FF-000063', NULL, 'Zinc finger C-x8-C-x5-C-x3-H type (And similar), putative', 70, NULL, NULL, 60323),
(60324, '3.60.15.10-FF-000098', NULL, 'Ribonuclease Z', 295, NULL, NULL, 60324),
(60325, '3.40.50.300-FF-003481', NULL, 'Phosphomevalonate kinase', 184, NULL, NULL, 60325),
(60326, '3.30.40.10-FF-001708', NULL, 'Peptidase', 61, NULL, NULL, 60326),
(60327, '1.20.1070.10-FF-001146', NULL, 'Rhodopsin, GQ-coupled', 348, NULL, NULL, 60327),
(60328, '3.30.70.330-FF-001242', NULL, 'CLUMA_CG015149, isoform A', 78, NULL, NULL, 60328),
(60329, '3.30.565.10-FF-000056', NULL, 'Sensor histidine kinase', 155, NULL, NULL, 60329),
(60330, '1.25.40.10-FF-005317', NULL, 'Uncharacterized protein', 117, NULL, NULL, 60330),
(60331, '2.60.40.60-FF-000336', NULL, 'Protocadherin Fat', 64, NULL, NULL, 60331),
(60332, '3.30.40.10-FF-002344', NULL, 'Uncharacterized protein', 90, NULL, NULL, 60332),
(60333, '3.30.160.60-FF-001614', NULL, 'Uncharacterized protein', 29, NULL, NULL, 60333),
(60334, '2.60.120.260-FF-000052', NULL, 'Reelin', 163, NULL, NULL, 60334),
(60335, '3.80.10.10-FF-001929', NULL, 'Ran GTPase activating protein, isoform B', 345, NULL, NULL, 60335),
(60336, '1.20.1280.140-FF-000001', NULL, 'Cell wall serine-threonine-rich galactomannoprotein Mp1', 87, NULL, NULL, 60336),
(60337, '3.40.30.10-FF-000140', NULL, 'polyglutamine-binding protein 1 isoform X1', 93, NULL, NULL, 60337),
(60338, '3.90.70.10-FF-000297', NULL, 'Dipeptidyl aminopeptidase 2', 355, NULL, NULL, 60338),
(60339, '3.40.850.10-FF-000262', NULL, 'Kinesin-like protein', 382, NULL, NULL, 60339),
(60340, '3.30.160.60-FF-003300', NULL, 'Zinc finger protein', 26, NULL, NULL, 60340),
(60341, '2.60.200.20-FF-000097', NULL, 'AGAP005560-PA-like protein', 115, NULL, NULL, 60341),
(60342, '3.80.10.10-FF-003363', NULL, 'Uncharacterized protein', 111, NULL, NULL, 60342),
(60343, '1.25.10.10-FF-001454', NULL, 'DAAM (Disheveled-Associated Activator of Morphogenesis) homolog', 237, NULL, NULL, 60343),
(60344, '2.170.40.20-FF-000004', NULL, 'Envelope glycoprotein gp160', 101, NULL, NULL, 60344),
(60345, '1.25.10.10-FF-003354', NULL, 'Uncharacterized protein', 203, NULL, NULL, 60345);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(60346, '3.30.230.130-FF-000055', NULL, 'Predicted protein', 136, NULL, NULL, 60346),
(60347, '3.40.50.620-FF-000114', NULL, 'Pantothenate synthetase', 178, NULL, NULL, 60347),
(60348, '2.10.25.10-FF-001137', NULL, 'GM15468', 39, NULL, NULL, 60348),
(60349, '4.10.60.10-FF-000096', NULL, 'Zinc finger CCHC-type containing 7', 80, NULL, NULL, 60349),
(60350, '2.130.10.10-FF-000069', NULL, 'WD repeat domain 33', 127, NULL, NULL, 60350),
(60351, '3.80.10.10-FF-002727', NULL, 'Uncharacterized protein', 172, NULL, NULL, 60351),
(60352, '3.30.420.130-FF-000003', NULL, 'Cation efflux system protein', 118, NULL, NULL, 60352),
(60353, '2.60.40.1170-FF-000089', NULL, NULL, 136, NULL, NULL, 60353),
(60354, '3.80.10.10-FF-001901', NULL, 'Protein TORNADO 1', 137, NULL, NULL, 60354),
(60355, '3.40.50.300-FF-007533', NULL, 'ATP-binding cassette transporter, subfamily F, member 9 protein PpABCF9', 206, NULL, NULL, 60355),
(60356, '3.10.20.90-FF-000698', NULL, 'Uncharacterized protein', 79, NULL, NULL, 60356),
(60357, '2.60.220.50-FF-000006', NULL, 'Adhesion G-protein coupled receptor G6', 185, NULL, NULL, 60357),
(60358, '3.30.160.60-FF-000203', NULL, 'Zinc finger protein 366', 26, NULL, NULL, 60358),
(60359, '2.60.40.10-FF-002715', NULL, 'Secreted trypsin-like serine protease', 109, NULL, NULL, 60359),
(60360, '1.10.238.10-FF-000741', NULL, 'Novel protein similar to human signal transducer and activator of transcription (STAT)', 38, NULL, NULL, 60360),
(60361, '3.30.210.10-FF-000002', NULL, 'DNA polymerase', 66, NULL, NULL, 60361),
(60362, '2.60.120.260-FF-000361', NULL, 'Predicted protein', 179, NULL, NULL, 60362),
(60363, '1.10.238.10-FF-000769', NULL, 'Apicoplast calcium binding protein 1', 125, NULL, NULL, 60363),
(60364, '3.80.10.10-FF-002418', NULL, 'Uncharacterized protein', 176, NULL, NULL, 60364),
(60365, '3.60.110.10-FF-000033', NULL, 'Putative nitrilase', 274, NULL, NULL, 60365),
(60366, '3.30.70.330-FF-000753', NULL, 'Serine/arginine-rich SC35-like splicing factor SCL28', 138, NULL, NULL, 60366),
(60367, '2.60.120.1440-FF-000018', NULL, 'Fec operon regulator FecR', 140, NULL, NULL, 60367),
(60368, '3.20.20.220-FF-000072', NULL, 'Proline dehydrogenase', 348, NULL, NULL, 60368),
(60369, '2.60.40.10-FF-005588', NULL, NULL, 139, NULL, NULL, 60369),
(60370, '3.80.10.10-FF-001890', NULL, 'Predicted protein', 194, NULL, NULL, 60370),
(60371, '3.30.160.60-FF-004609', NULL, NULL, 50, NULL, NULL, 60371),
(60372, '2.130.10.10-FF-004565', NULL, 'Uncharacterized protein', 214, NULL, NULL, 60372),
(60373, '3.40.532.10-FF-000039', NULL, NULL, 77, NULL, NULL, 60373),
(60374, '1.20.140.50-FF-000001', NULL, 'programmed cell death 6-interacting protein-like isoform X2', 182, NULL, NULL, 60374),
(60375, '2.60.40.1660-FF-000011', NULL, 'Sodium/potassium-transporting ATPase subunit beta', 188, NULL, NULL, 60375),
(60376, '2.30.39.10-FF-000151', NULL, 'Protein CBG10463', 123, NULL, NULL, 60376),
(60377, '3.30.160.60-FF-003531', NULL, NULL, 28, NULL, NULL, 60377),
(60378, '3.90.650.10-FF-000038', NULL, 'Hydrogenase expression/formation protein HypE', 182, NULL, NULL, 60378),
(60379, '3.90.70.80-FF-000048', NULL, 'Uncharacterized protein', 140, NULL, NULL, 60379),
(60380, '2.170.16.10-FF-000024', NULL, 'Replicative DNA helicase', 72, NULL, NULL, 60380),
(60381, '2.60.40.1910-FF-000018', NULL, 'Aminopeptidase', 84, NULL, NULL, 60381),
(60382, '2.60.40.10-FF-005116', NULL, NULL, 98, NULL, NULL, 60382),
(60383, '3.40.50.2300-FF-000701', NULL, 'Uncharacterized protein', 114, NULL, NULL, 60383),
(60384, '3.30.450.40-FF-000091', NULL, 'IclR family transcriptional regulator', 177, NULL, NULL, 60384),
(60385, '3.20.20.190-FF-000017', NULL, 'glycerophosphodiester phosphodiesterase domain-containing protein 1', 250, NULL, NULL, 60385),
(60386, '2.60.40.1220-FF-000008', NULL, 'Internalin protein', 98, NULL, NULL, 60386),
(60387, '1.10.10.60-FF-000867', NULL, NULL, 79, NULL, NULL, 60387),
(60388, '1.20.1250.20-FF-001910', NULL, 'Uncharacterized protein', 235, NULL, NULL, 60388),
(60389, '2.60.40.10-FF-002463', NULL, 'High Incidence of Males (Increased X chromosome loss)', 84, NULL, NULL, 60389);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(60390, '3.40.50.300-FF-007724', NULL, 'Uncharacterized protein', 92, NULL, NULL, 60390),
(60391, '1.20.1270.60-FF-000237', NULL, 'Mental retardation GTPase activating protein homolog 4', 251, NULL, NULL, 60391),
(60392, '2.130.10.120-FF-000028', NULL, 'Uncharacterized protein', 226, NULL, NULL, 60392),
(60393, '2.10.110.10-FF-000166', NULL, 'LIM domain containing protein, expressed', 123, NULL, NULL, 60393),
(60394, '3.60.20.10-FF-000256', NULL, NULL, 95, NULL, NULL, 60394),
(60395, '3.40.50.150-FF-000878', NULL, 'Os06g0315000 protein', 194, NULL, NULL, 60395),
(60396, '3.10.250.10-FF-000110', NULL, NULL, 97, NULL, NULL, 60396),
(60397, '3.40.50.720-FF-000257', NULL, 'Shikimate dehydrogenase (NADP(+))', 141, NULL, NULL, 60397),
(60398, '1.10.1200.10-FF-000142', NULL, 'Putative acyl carrier protein', 89, NULL, NULL, 60398),
(60399, '1.20.1070.10-FF-001590', NULL, 'Uncharacterized protein', 155, NULL, NULL, 60399),
(60400, '2.60.40.60-FF-000763', NULL, 'Fat-like cadherin-related tumor suppressor homolog', 106, NULL, NULL, 60400),
(60401, '3.50.50.60-FF-001116', NULL, 'Os10g0554300 protein', 152, NULL, NULL, 60401),
(60402, '3.40.1810.10-FF-000045', NULL, 'Floral homeotic protein APETALA 1', 56, NULL, NULL, 60402),
(60403, '3.40.50.1110-FF-000081', NULL, 'Uncharacterized protein', 199, NULL, NULL, 60403),
(60404, '3.40.109.10-FF-000039', NULL, 'Nitroreductase', 183, NULL, NULL, 60404),
(60405, '3.30.70.850-FF-000010', NULL, 'Proprotein convertase subtilisin/kexin type 2', 89, NULL, NULL, 60405),
(60406, '1.10.1670.10-FF-000070', NULL, NULL, 70, NULL, NULL, 60406),
(60407, '2.30.29.30-FF-000229', NULL, 'Dual adapter for phosphotyrosine and 3-phosphotyrosine and 3-phosphoinositide', 126, NULL, NULL, 60407),
(60408, '1.25.40.10-FF-004463', NULL, 'Uncharacterized protein', 109, NULL, NULL, 60408),
(60409, '1.25.40.10-FF-004519', NULL, 'Pentatricopeptide repeat-containing protein', 81, NULL, NULL, 60409),
(60410, '3.40.50.2300-FF-000600', NULL, 'Two-component response regulator', 122, NULL, NULL, 60410),
(60411, '1.25.10.10-FF-001246', NULL, 'Cytoskeleton-associated protein 5', 142, NULL, NULL, 60411),
(60412, '2.70.98.110-FF-000005', NULL, 'Blast:Mannosyl-oligosaccharide glucosidase', 285, NULL, NULL, 60412),
(60413, '1.25.40.20-FF-001622', NULL, 'Skeletrophin, putative', 99, NULL, NULL, 60413),
(60414, '2.60.40.420-FF-000147', NULL, 'Os12g0150500 protein', 106, NULL, NULL, 60414),
(60415, '3.40.50.300-FF-004335', NULL, 'ABC-type multidrug transport system, ATPase component', 249, NULL, NULL, 60415),
(60416, '3.40.190.10-FF-000716', NULL, 'Sll0224 protein', 93, NULL, NULL, 60416),
(60417, '1.10.510.10-FF-002791', NULL, NULL, 198, NULL, NULL, 60417),
(60418, '3.40.50.1820-FF-001631', NULL, 'Carboxypeptidase sxa2', 455, NULL, NULL, 60418),
(60419, '2.130.10.10-FF-000878', NULL, 'Ribosome biogenesis protein WDR12 homolog', 81, NULL, NULL, 60419),
(60420, '3.30.160.60-FF-002912', NULL, NULL, 28, NULL, NULL, 60420),
(60421, '3.30.2010.10-FF-000020', NULL, 'Peptidase M48 Ste24p', 82, NULL, NULL, 60421),
(60422, '1.10.10.650-FF-000017', NULL, 'Transcription elongation factor Spt6', 147, NULL, NULL, 60422),
(60423, '3.30.160.60-FF-000866', NULL, 'zinc finger protein 212', 31, NULL, NULL, 60423),
(60424, '1.10.490.10-FF-000040', NULL, 'Globin X', 165, NULL, NULL, 60424),
(60425, '3.30.200.20-FF-002511', NULL, 'Os01g0568800 protein', 113, NULL, NULL, 60425),
(60426, '3.40.50.1820-FF-000203', NULL, 'Feruloyl esterase B', 250, NULL, NULL, 60426),
(60427, '3.40.50.2300-FF-001320', NULL, NULL, 104, NULL, NULL, 60427),
(60428, '2.60.120.920-FF-000132', NULL, 'neuralized-like protein 2', 160, NULL, NULL, 60428),
(60429, '3.40.1700.10-FF-000008', NULL, 'Diadenylate cyclase', 161, NULL, NULL, 60429),
(60430, '2.60.40.150-FF-000706', NULL, 'Phosphatidylinositol 3-kinase class, putative', 144, NULL, NULL, 60430),
(60431, '3.40.50.11060-FF-000001', NULL, 'GTPase HflX', 98, NULL, NULL, 60431),
(60432, '3.30.420.10-FF-000248', NULL, 'CCR4-NOT transcription complex subunit 8', 102, NULL, NULL, 60432),
(60433, '3.40.50.300-FF-005055', NULL, 'Uncharacterized protein', 134, NULL, NULL, 60433);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(60434, '1.20.120.20-FF-000042', NULL, 'Uncharacterized protein', 136, NULL, NULL, 60434),
(60435, '3.40.50.720-FF-002191', NULL, '3-hydroxyisobutyrate dehydrogenase', 35, NULL, NULL, 60435),
(60436, '2.30.42.10-FF-000203', NULL, 'DiSHevelled related', 102, NULL, NULL, 60436),
(60437, '1.50.10.10-FF-000064', NULL, 'alpha-1,2-Mannosidase', 145, NULL, NULL, 60437),
(60438, '1.25.40.10-FF-000568', NULL, 'Tetratricopeptide repeat domain 21A', 171, NULL, NULL, 60438),
(60439, '3.40.47.10-FF-000251', NULL, 'Uncharacterized protein', 401, NULL, NULL, 60439),
(60440, '3.90.230.10-FF-000046', NULL, 'Xaa-Pro aminopeptidase', 267, NULL, NULL, 60440),
(60441, '1.50.40.10-FF-000476', NULL, 'Predicted protein', 289, NULL, NULL, 60441),
(60442, '1.25.40.20-FF-000767', NULL, 'KN motif and ankyrin repeat domains 4', 243, NULL, NULL, 60442),
(60443, '3.40.50.300-FF-004762', NULL, 'Predicted protein', 111, NULL, NULL, 60443),
(60444, '2.160.20.10-FF-000208', NULL, 'Pectin lyase-like superfamily protein', 412, NULL, NULL, 60444),
(60445, '1.25.40.10-FF-004036', NULL, 'Uncharacterized protein', 180, NULL, NULL, 60445),
(60446, '1.25.10.10-FF-000156', NULL, 'Serine/threonine-protein phosphatase 4 regulatory subunit 1', 429, NULL, NULL, 60446),
(60447, '3.80.10.10-FF-004543', NULL, 'Uncharacterized protein', 97, NULL, NULL, 60447),
(60448, '3.40.630.10-FF-000060', NULL, 'Putative metallocarboxypeptidase ecm14', 323, NULL, NULL, 60448),
(60449, '3.40.50.670-FF-000005', NULL, 'DNA gyrase subunit B', 201, NULL, NULL, 60449),
(60450, '1.20.1250.20-FF-000376', NULL, '3-(3-hydroxy-phenyl)propionate transporter MhpT', 186, NULL, NULL, 60450),
(60451, '3.30.470.30-FF-000100', NULL, 'Uncharacterized protein', 118, NULL, NULL, 60451),
(60452, '1.20.210.10-FF-000012', NULL, 'Cytochrome c oxidase subunit I', 501, NULL, NULL, 60452),
(60453, '3.40.50.360-FF-000031', NULL, 'NADPH:quinone oxidoreductase', 194, NULL, NULL, 60453),
(60454, '3.10.450.320-FF-000003', NULL, 'Protein CBG23912', 106, NULL, NULL, 60454),
(60455, '3.80.10.10-FF-002082', NULL, 'MGC115736 protein', 114, NULL, NULL, 60455),
(60456, '3.60.10.10-FF-000328', NULL, 'DNA-(apurinic or apyrimidinic site) lyase', 248, NULL, NULL, 60456),
(60457, '3.30.160.60-FF-004357', NULL, NULL, 44, NULL, NULL, 60457),
(60458, '3.20.20.220-FF-000055', NULL, 'AGAP007479-PA', 286, NULL, NULL, 60458),
(60459, '2.40.30.10-FF-000462', NULL, 'Putative nitrate reductase', 94, NULL, NULL, 60459),
(60460, '2.40.37.20-FF-000014', NULL, NULL, 102, NULL, NULL, 60460),
(60461, '1.10.287.70-FF-000580', NULL, 'Uncharacterized protein', 206, NULL, NULL, 60461),
(60462, '2.60.120.200-FF-000478', NULL, 'Neurexin-1', 115, NULL, NULL, 60462),
(60463, '3.90.780.10-FF-000019', NULL, 'Bifunctional 5-nucleotidase/2,3-cyclic phosphodiesterase', 173, NULL, NULL, 60463),
(60464, '2.60.120.920-FF-000031', NULL, 'E3 ubiquitin-protein ligase RNF123', 180, NULL, NULL, 60464),
(60465, '3.40.50.720-FF-000043', NULL, 'Ketol-acid reductoisomerase (NADP(+))', 208, NULL, NULL, 60465),
(60466, '2.40.270.10-FF-000024', NULL, NULL, 61, NULL, NULL, 60466),
(60467, '3.40.50.740-FF-000049', NULL, 'NADH-ubiquinone reductase, putative', 125, NULL, NULL, 60467),
(60468, '3.30.200.20-FF-002174', NULL, 'Uncharacterized protein', 62, NULL, NULL, 60468),
(60469, '3.30.2350.20-FF-000071', NULL, NULL, 105, NULL, NULL, 60469),
(60470, '2.130.10.10-FF-005892', NULL, 'Uncharacterized protein', 294, NULL, NULL, 60470),
(60471, '1.20.58.60-FF-000701', NULL, 'Uncharacterized protein', 111, NULL, NULL, 60471),
(60472, '3.40.50.450-FF-000069', NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase', 185, NULL, NULL, 60472),
(60473, '1.25.40.10-FF-001282', NULL, 'Pentatricopeptide repeat-containing protein ATP4, chloroplastic', 116, NULL, NULL, 60473),
(60474, '3.30.457.60-FF-000016', NULL, 'Mdf-1', 81, NULL, NULL, 60474),
(60475, '3.20.20.70-FF-000051', NULL, 'tRNA-dihydrouridine synthase B', 242, NULL, NULL, 60475),
(60476, '1.25.40.20-FF-000458', NULL, 'NF-kappa-B inhibitor cactus', 237, NULL, NULL, 60476),
(60477, '3.30.160.60-FF-002148', NULL, 'Zinc finger protein 668', 24, NULL, NULL, 60477);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(60478, '2.30.29.30-FF-000881', NULL, 'Insulin receptor SubsTrate homolog', 114, NULL, NULL, 60478),
(60479, '2.60.40.60-FF-000971', NULL, 'Uncharacterized protein', 83, NULL, NULL, 60479),
(60480, '1.10.418.10-FF-000075', NULL, 'Transgelin', 156, NULL, NULL, 60480),
(60481, '2.40.50.140-FF-000087', NULL, 'Protein lin-28 homolog B', 90, NULL, NULL, 60481),
(60482, '3.40.50.300-FF-007516', NULL, 'Predicted protein', 213, NULL, NULL, 60482),
(60483, '1.20.920.30-FF-000072', NULL, 'Uncharacterized protein', 74, NULL, NULL, 60483),
(60484, '2.70.170.10-FF-000055', NULL, 'Proton-gated ion channel subunit pbo-6', 206, NULL, NULL, 60484),
(60485, '1.10.287.950-FF-000029', NULL, 'Methyl-accepting chemotaxis protein', 305, NULL, NULL, 60485),
(60486, '1.20.120.230-FF-000053', NULL, 'Talin-1-like Protein', 125, NULL, NULL, 60486),
(60487, '1.20.1070.10-FF-001910', NULL, 'Vomeronasal type-1 receptor', 285, NULL, NULL, 60487),
(60488, '1.10.287.70-FF-000271', NULL, 'Potassium channel subunit-like protein', 96, NULL, NULL, 60488),
(60489, '3.30.70.330-FF-002422', NULL, NULL, 91, NULL, NULL, 60489),
(60490, '1.10.510.40-FF-000006', NULL, 'Siderophore biosynthesis protein SbnF', 218, NULL, NULL, 60490),
(60491, '3.40.980.10-FF-000035', NULL, 'Molybdopterin molybdenumtransferase', 163, NULL, NULL, 60491),
(60492, '3.90.1150.10-FF-000123', NULL, 'Ornithine aminotransferase 1', 125, NULL, NULL, 60492),
(60493, '2.40.50.40-FF-000017', NULL, 'chromodomain-helicase-DNA-binding protein 3 isoform X3', 93, NULL, NULL, 60493),
(60494, '3.90.640.10-FF-000291', NULL, 'DnaK protein', 84, NULL, NULL, 60494),
(60495, '3.40.50.20-FF-000043', NULL, 'Carbamoyl-phosphate synthase large chain', 139, NULL, NULL, 60495),
(60496, '3.40.50.300-FF-000945', NULL, 'Dynein axonemal heavy chain 9', 181, NULL, NULL, 60496),
(60497, '1.25.40.10-FF-000877', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 107, NULL, NULL, 60497),
(60498, '2.60.40.10-FF-000546', NULL, 'Collagen alpha-1(XIV) chain isoform X2', 102, NULL, NULL, 60498),
(60499, '2.60.40.820-FF-000014', NULL, 'Optomotor-blind protein', 74, NULL, NULL, 60499),
(60500, '3.10.180.10-FF-000082', NULL, 'Glr1161 protein', 155, NULL, NULL, 60500),
(60501, '2.40.70.10-FF-000476', NULL, NULL, 157, NULL, NULL, 60501),
(60502, '3.30.70.260-FF-000136', NULL, 'Prephenate dehydratase', 93, NULL, NULL, 60502),
(60503, '2.30.33.40-FF-000017', NULL, 'Chaperonin 10 kd subunit', 87, NULL, NULL, 60503),
(60504, '2.10.220.10-FF-000039', NULL, 'Extracellular matrix protein FRAS1', 106, NULL, NULL, 60504),
(60505, '3.60.21.10-FF-000247', NULL, 'Vacuolar protein sorting-associated protein 29', 180, NULL, NULL, 60505),
(60506, '3.40.50.1910-FF-000034', NULL, 'Vacuolar protein sorting-associated protein 33B', 60, NULL, NULL, 60506),
(60507, '2.60.40.10-FF-001165', NULL, 'PKHD1 like 1', 88, NULL, NULL, 60507),
(60508, '2.60.40.10-FF-004969', NULL, NULL, 110, NULL, NULL, 60508),
(60509, '3.40.50.1820-FF-001423', NULL, 'Uncharacterized protein', 199, NULL, NULL, 60509),
(60510, '2.130.10.10-FF-005184', NULL, 'Uncharacterized protein', 121, NULL, NULL, 60510),
(60511, '1.10.1070.11-FF-000121', NULL, 'Uncharacterized PI3/PI4-kinase family protein C1F5.11c', 163, NULL, NULL, 60511),
(60512, '3.30.710.10-FF-000259', NULL, 'Protein maternal effect lethal 26', 132, NULL, NULL, 60512),
(60513, '2.40.70.10-FF-000537', NULL, NULL, 235, NULL, NULL, 60513),
(60514, '1.10.472.10-FF-000667', NULL, 'Uncharacterized protein', 77, NULL, NULL, 60514),
(60515, '3.40.1190.20-FF-000084', NULL, 'Bifunctional protein HldE', 300, NULL, NULL, 60515),
(60516, '1.20.1050.10-FF-000291', NULL, 'Uncharacterized protein', 39, NULL, NULL, 60516),
(60517, '2.60.40.10-FF-005217', NULL, NULL, 115, NULL, NULL, 60517),
(60518, '2.60.40.10-FF-004599', NULL, 'Synaptogenesis protein syg-2', 107, NULL, NULL, 60518),
(60519, '2.30.30.100-FF-000039', NULL, 'U7 snRNA-associated Sm-like protein LSm10', 88, NULL, NULL, 60519),
(60520, '3.30.930.10-FF-000006', NULL, 'Glycine--tRNA ligase alpha subunit', 214, NULL, NULL, 60520);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(60521, '2.60.200.20-FF-000125', NULL, 'Aprataxin', 49, NULL, NULL, 60521),
(60522, '3.30.200.20-FF-000521', NULL, 'Protein kinase superfamily protein', 99, NULL, NULL, 60522),
(60523, '2.30.42.10-FF-000411', NULL, NULL, 115, NULL, NULL, 60523),
(60524, '1.10.10.60-FF-000659', NULL, 'Myb domain protein 4r1', 49, NULL, NULL, 60524),
(60525, '3.40.50.10860-FF-000065', NULL, 'Uncharacterized protein', 39, NULL, NULL, 60525),
(60526, '3.40.1180.10-FF-000035', NULL, 'Alkyl transferase', 227, NULL, NULL, 60526),
(60527, '1.25.40.20-FF-000666', NULL, 'Zinc finger CCCH domain-containing protein 56', 193, NULL, NULL, 60527),
(60528, '3.30.420.10-FF-000512', NULL, NULL, 129, NULL, NULL, 60528),
(60529, '1.20.1270.60-FF-000029', NULL, 'Tyrosine-protein kinase', 269, NULL, NULL, 60529),
(60530, '1.20.920.10-FF-000223', NULL, 'Uncharacterized protein', 67, NULL, NULL, 60530),
(60531, '3.40.630.10-FF-000279', NULL, 'Zinc carboxypeptidase', 327, NULL, NULL, 60531),
(60532, '1.20.1250.20-FF-001702', NULL, 'Uncharacterized protein', 213, NULL, NULL, 60532),
(60533, '3.30.70.2000-FF-000002', NULL, 'BTB/POZ domain-containing protein KCTD5-like isoform X1', 32, NULL, NULL, 60533),
(60534, '1.20.1720.10-FF-000128', NULL, NULL, 153, NULL, NULL, 60534),
(60535, '3.40.50.2000-FF-000937', NULL, 'WbcN protein', 142, NULL, NULL, 60535),
(60536, '3.40.50.970-FF-000213', NULL, 'Uncharacterized protein', 129, NULL, NULL, 60536),
(60537, '1.10.472.10-FF-000329', NULL, 'Cyclin Dx', 111, NULL, NULL, 60537),
(60538, '3.40.50.300-FF-004099', NULL, 'ABC transporter, ATP binding protein', 255, NULL, NULL, 60538),
(60539, '3.40.50.720-FF-002090', NULL, 'Uncharacterized protein', 136, NULL, NULL, 60539),
(60540, '3.30.420.40-FF-000055', NULL, 'Glucokinase', 173, NULL, NULL, 60540),
(60541, '3.30.519.10-FF-000022', NULL, 'Rab proteins geranylgeranyltransferase component A', 179, NULL, NULL, 60541),
(60542, '3.90.25.10-FF-000018', NULL, 'Nucleoside-diphosphate-sugar epimerase family protein', 87, NULL, NULL, 60542),
(60543, '3.40.190.10-FF-000924', NULL, 'Predicted protein', 181, NULL, NULL, 60543),
(60544, '3.40.50.150-FF-001030', NULL, NULL, 169, NULL, NULL, 60544),
(60545, '1.25.10.10-FF-002882', NULL, 'Predicted protein', 147, NULL, NULL, 60545),
(60546, '3.40.50.1820-FF-001732', NULL, 'Predicted protein', 93, NULL, NULL, 60546),
(60547, '3.30.1520.10-FF-000188', NULL, 'Phospholipase', 81, NULL, NULL, 60547),
(60548, '2.60.120.260-FF-000283', NULL, 'Uncharacterized protein', 60, NULL, NULL, 60548),
(60549, '2.60.40.3470-FF-000003', NULL, NULL, 127, NULL, NULL, 60549),
(60550, '3.80.20.20-FF-000084', NULL, 'Predicted protein', 114, NULL, NULL, 60550),
(60551, '3.30.870.10-FF-000068', NULL, 'Phospholipase D/Transphosphatidylase', 132, NULL, NULL, 60551),
(60552, '1.10.10.1100-FF-000001', NULL, 'Bacterioferritin-associated ferredoxin', 57, NULL, NULL, 60552),
(60553, '1.20.144.10-FF-000009', NULL, 'Phosphatidate phosphatase PPAPDC1A', 239, NULL, NULL, 60553),
(60554, '3.20.20.70-FF-000360', NULL, 'N-(5''-phosphoribosyl)anthranilate isomerase', 206, NULL, NULL, 60554),
(60555, '1.20.1640.10-FF-000066', NULL, 'Protein-export membrane protein SecF', 199, NULL, NULL, 60555),
(60556, '1.20.1250.20-FF-000584', NULL, 'Putative integral membrane protein', 184, NULL, NULL, 60556),
(60557, '3.30.70.270-FF-000257', NULL, NULL, 174, NULL, NULL, 60557),
(60558, '3.20.20.140-FF-000227', NULL, 'Histidinol-phosphatase', 256, NULL, NULL, 60558),
(60559, '2.30.38.10-FF-000008', NULL, 'Benzoate-CoA ligase', 106, NULL, NULL, 60559),
(60560, '3.30.160.60-FF-002603', NULL, 'Uncharacterized protein', 24, NULL, NULL, 60560),
(60561, '1.25.40.20-FF-000975', NULL, 'Uncharacterized protein', 153, NULL, NULL, 60561),
(60562, '3.30.428.10-FF-000069', NULL, 'Predicted protein', 146, NULL, NULL, 60562),
(60563, '3.30.200.20-FF-000830', NULL, 'Uncharacterized protein, isoform B', 24, NULL, NULL, 60563),
(60564, '3.30.70.330-FF-000545', NULL, 'RNA-binding protein lark', 81, NULL, NULL, 60564),
(60565, '2.40.10.10-FF-000663', NULL, NULL, 67, NULL, NULL, 60565);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(60566, '3.30.420.40-FF-000807', NULL, 'DnaK protein', 119, NULL, NULL, 60566),
(60567, '3.80.10.10-FF-004190', NULL, 'Tubulin specific chaperone E', 268, NULL, NULL, 60567),
(60568, '1.20.1020.10-FF-000007', NULL, 'BTB/POZ and TAZ domain-containing protein 2', 128, NULL, NULL, 60568),
(60569, '3.40.1280.10-FF-000099', NULL, 'Uncharacterized protein', 176, NULL, NULL, 60569),
(60570, '2.60.120.10-FF-000189', NULL, 'Cysteine dioxygenase', 203, NULL, NULL, 60570),
(60571, '1.20.1280.20-FF-000001', NULL, 'Co-chaperone protein HscB', 91, NULL, NULL, 60571),
(60572, '2.30.42.10-FF-000512', NULL, NULL, 81, NULL, NULL, 60572),
(60573, '2.30.30.490-FF-000066', NULL, 'Origin recognition complex subunit 1', 149, NULL, NULL, 60573),
(60574, '3.30.230.70-FF-000004', NULL, 'Exosome complex component Rrp41', 238, NULL, NULL, 60574),
(60575, '3.90.550.10-FF-000637', NULL, 'Uncharacterized protein', 177, NULL, NULL, 60575),
(60576, '1.10.150.180-FF-000001', NULL, 'Gag polyprotein', 99, NULL, NULL, 60576),
(60577, '1.10.510.10-FF-002010', NULL, NULL, 120, NULL, NULL, 60577),
(60578, '2.60.40.150-FF-000353', NULL, 'Synaptotagmin 7, isoform I', 43, NULL, NULL, 60578),
(60579, '3.40.640.10-FF-000206', NULL, 'L-allo-threonine aldolase', 250, NULL, NULL, 60579),
(60580, '3.30.750.24-FF-000039', NULL, 'Putative anti-anti-sigma factor', 106, NULL, NULL, 60580),
(60581, '3.90.1720.10-FF-000032', NULL, 'Probable endopeptidase YddH', 127, NULL, NULL, 60581),
(60582, '3.40.50.300-FF-000283', NULL, 'DNA mismatch repair protein MutS', 254, NULL, NULL, 60582),
(60583, '1.10.20.10-FF-000274', NULL, NULL, 77, NULL, NULL, 60583),
(60584, '1.10.510.10-FF-000110', NULL, 'Tyrosine-protein kinase', 187, NULL, NULL, 60584),
(60585, '2.40.50.140-FF-000295', NULL, 'Nodulation efficiency protein NfeD', 68, NULL, NULL, 60585),
(60586, '1.10.940.10-FF-000030', NULL, 'Transcription antitermination protein NusB', 148, NULL, NULL, 60586),
(60587, '1.20.120.140-FF-000009', NULL, 'Signal sequence receptor alpha subunit', 115, NULL, NULL, 60587),
(60588, '1.20.120.1760-FF-000064', NULL, NULL, 188, NULL, NULL, 60588),
(60589, '1.20.58.60-FF-000656', NULL, 'Uncharacterized protein', 118, NULL, NULL, 60589),
(60590, '3.40.50.1220-FF-000012', NULL, 'NAD-dependent protein deacetylase sirtuin-6', 177, NULL, NULL, 60590),
(60591, '3.40.50.1240-FF-000018', NULL, 'Phosphoglycerate mutase', 205, NULL, NULL, 60591),
(60592, '3.90.1070.20-FF-000007', NULL, 'DNA-directed RNA polymerase I subunit RPA2', 82, NULL, NULL, 60592),
(60593, '3.40.50.300-FF-001564', NULL, 'DNA helicase Ercc3', 191, NULL, NULL, 60593),
(60594, '2.130.10.10-FF-001030', NULL, 'WD domain-containing protein', 275, NULL, NULL, 60594),
(60595, '2.60.40.10-FF-000445', NULL, 'Adhesion G protein-coupled receptor A3', 103, NULL, NULL, 60595),
(60596, '2.40.50.140-FF-000148', NULL, 'protein RRP5 homolog isoform X1', 75, NULL, NULL, 60596),
(60597, '3.40.630.30-FF-000127', NULL, 'RNA cytidine acetyltransferase', 114, NULL, NULL, 60597),
(60598, '3.90.226.10-FF-000250', NULL, 'Methylcrotonoyl-CoA carboxylase 2', 167, NULL, NULL, 60598),
(60599, '3.90.79.10-FF-000036', NULL, 'Nudix hydrolase 11', 184, NULL, NULL, 60599),
(60600, '3.40.50.150-FF-000069', NULL, 'tRNA (Guanine(10)-N2)-methyltransferase homolog isoform X2', 215, NULL, NULL, 60600),
(60601, '2.60.40.1500-FF-000002', NULL, 'Iduronidase alpha-L-', 151, NULL, NULL, 60601),
(60602, '1.10.10.60-FF-000558', NULL, 'Transcriptional regulator, AraC family', 113, NULL, NULL, 60602),
(60603, '3.30.2350.10-FF-000079', NULL, 'Uncharacterized protein', 73, NULL, NULL, 60603),
(60604, '3.30.40.10-FF-001843', NULL, 'RING finger protein, putative', 121, NULL, NULL, 60604),
(60605, '2.10.25.10-FF-000412', NULL, 'Usherin', 47, NULL, NULL, 60605),
(60606, '3.30.160.60-FF-006190', NULL, NULL, 55, NULL, NULL, 60606),
(60607, '3.80.10.10-FF-000148', NULL, 'Leucine rich repeat and coiled-coil centrosomal protein 1', 102, NULL, NULL, 60607),
(60608, '3.40.850.10-FF-000340', NULL, 'Kinesin-like protein', 60, NULL, NULL, 60608),
(60609, '1.20.120.850-FF-000031', NULL, 'Eukaryotic translation initiation factor 3 subunit E', 98, NULL, NULL, 60609);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(60610, '3.30.9.90-FF-000007', NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase', 200, NULL, NULL, 60610),
(60611, '1.10.220.100-FF-000005', NULL, 'Enhancer of mRNA decapping 4', 58, NULL, NULL, 60611),
(60612, '2.60.120.650-FF-000028', NULL, 'Lysine-specific demethylase lid', 279, NULL, NULL, 60612),
(60613, '1.20.1250.20-FF-001202', NULL, 'Transmembrane transport protein', 184, NULL, NULL, 60613),
(60614, '1.10.150.80-FF-000007', NULL, 'Ribonuclease D', 82, NULL, NULL, 60614),
(60615, '3.40.850.10-FF-000054', NULL, 'Kinesin-like protein', 341, NULL, NULL, 60615),
(60616, '3.90.1170.40-FF-000021', NULL, 'Uncharacterized protein', 91, NULL, NULL, 60616),
(60617, '3.30.830.10-FF-000105', NULL, 'Mitochondrial processing peptidase alpha subunit, putative', 213, NULL, NULL, 60617),
(60618, '1.10.510.10-FF-000773', NULL, 'MOK protein kinase', 228, NULL, NULL, 60618),
(60619, '3.80.10.10-FF-003571', NULL, 'Putative leucine-rich repeat protein', 145, NULL, NULL, 60619),
(60620, '2.10.260.10-FF-000002', NULL, 'Antitoxin MazE', 82, NULL, NULL, 60620),
(60621, '2.20.70.10-FF-000269', NULL, 'Rho GTPase activating protein 27', 38, NULL, NULL, 60621),
(60622, '1.20.1050.90-FF-000016', NULL, NULL, 186, NULL, NULL, 60622),
(60623, '2.40.50.140-FF-000750', NULL, NULL, 144, NULL, NULL, 60623),
(60624, '1.50.10.160-FF-000007', NULL, 'Ent-kaurene synthase-like 2', 147, NULL, NULL, 60624),
(60625, '3.90.226.10-FF-000295', NULL, 'Predicted protein', 166, NULL, NULL, 60625),
(60626, '1.10.390.10-FF-000021', NULL, 'M1 family aminopeptidase', 171, NULL, NULL, 60626),
(60627, '2.40.30.70-FF-000002', NULL, 'tRNA (Adenine(37)-N6)-methyltransferase isoform X1', 151, NULL, NULL, 60627),
(60628, '3.40.50.80-FF-000055', NULL, 'NADPH-dependent diflavin oxidoreductase 1', 105, NULL, NULL, 60628),
(60629, '3.30.360.50-FF-000002', NULL, 'S-adenosylmethionine decarboxylase proenzyme', 31, NULL, NULL, 60629),
(60630, '2.60.120.1040-FF-000022', NULL, NULL, 133, NULL, NULL, 60630),
(60631, '1.20.1250.10-FF-000064', NULL, 'Growth hormone d23', 192, NULL, NULL, 60631),
(60632, '3.30.420.10-FF-000703', NULL, NULL, 109, NULL, NULL, 60632),
(60633, '3.40.50.720-FF-001471', NULL, 'Uncharacterized protein', 197, NULL, NULL, 60633),
(60634, '1.10.533.10-FF-000146', NULL, 'Caspase recruitment domain family, member 6', 93, NULL, NULL, 60634),
(60635, '3.40.50.300-FF-006544', NULL, 'Rnd1 protein', 107, NULL, NULL, 60635),
(60636, '1.10.3120.10-FF-000006', NULL, 'Foldase protein PrsA', 107, NULL, NULL, 60636),
(60637, '1.10.220.20-FF-000012', NULL, 'Cytohesin 4a', 81, NULL, NULL, 60637),
(60638, '1.10.443.10-FF-000010', NULL, 'Tyrosine recombinase XerS', 197, NULL, NULL, 60638),
(60639, '3.40.390.10-FF-000113', NULL, 'Metalloendopeptidase', 217, NULL, NULL, 60639),
(60640, '2.30.40.10-FF-000025', NULL, 'Amidohydrolase family protein', 87, NULL, NULL, 60640),
(60641, '1.25.40.10-FF-002254', NULL, 'Uncharacterized protein', 145, NULL, NULL, 60641),
(60642, '1.20.58.1030-FF-000011', NULL, 'DNA replication complex GINS protein SLD5', 148, NULL, NULL, 60642),
(60643, '1.20.1510.10-FF-000085', NULL, NULL, 135, NULL, NULL, 60643),
(60644, '2.102.10.10-FF-000048', NULL, 'Benzene 1,2-dioxygenase system ferredoxin component, putative', 101, NULL, NULL, 60644),
(60645, '1.20.140.150-FF-000027', NULL, 'Claudin', 205, NULL, NULL, 60645),
(60646, '3.30.160.60-FF-001423', NULL, 'Zinc finger protein 518A', 77, NULL, NULL, 60646),
(60647, '1.10.150.60-FF-000001', NULL, 'Putative lysine-specific demethylase 5b', 120, NULL, NULL, 60647),
(60648, '2.60.40.10-FF-002816', NULL, 'High Incidence of Males (Increased X chromosome loss)', 88, NULL, NULL, 60648),
(60649, '3.30.450.20-FF-000652', NULL, 'Sensory transduction histidine kinase', 116, NULL, NULL, 60649),
(60650, '3.30.70.330-FF-001450', NULL, 'Protein painting of fourth', 172, NULL, NULL, 60650),
(60651, '2.10.25.10-FF-001480', NULL, 'Wall-associated receptor kinase 5 isoform A', 38, NULL, NULL, 60651),
(60652, '2.60.40.10-FF-001726', NULL, 'Signal-regulatory protein beta 3', 98, NULL, NULL, 60652);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(60653, '2.20.70.10-FF-000055', NULL, 'E3 ubiquitin-protein ligase NEDD4-like isoform X1', 52, NULL, NULL, 60653),
(60654, '3.30.70.1230-FF-000203', NULL, 'Guanylate cyclase', 176, NULL, NULL, 60654),
(60655, '1.20.1270.60-FF-000131', NULL, 'Variant sh3 domain containing protein', 281, NULL, NULL, 60655),
(60656, '3.30.160.60-FF-005329', NULL, NULL, 72, NULL, NULL, 60656),
(60657, '3.10.100.10-FF-000190', NULL, NULL, 173, NULL, NULL, 60657),
(60658, '2.60.40.1120-FF-000068', NULL, 'Uncharacterized protein', 54, NULL, NULL, 60658),
(60659, '3.30.950.10-FF-000024', NULL, 'Uroporphyrinogen-III C-methyltransferase', 120, NULL, NULL, 60659),
(60660, '1.20.5.170-FF-000002', NULL, 'Type I keratin KA11', 81, NULL, NULL, 60660),
(60661, '2.60.40.2660-FF-000002', NULL, 'Ankyrin-1 isoform B', 152, NULL, NULL, 60661),
(60662, '1.20.1110.10-FF-000245', NULL, NULL, 314, NULL, NULL, 60662),
(60663, '1.25.40.510-FF-000011', NULL, 'EMB1745', 249, NULL, NULL, 60663),
(60664, '1.10.287.470-FF-000099', NULL, 'Sll0180 protein', 59, NULL, NULL, 60664),
(60665, '3.40.250.10-FF-000042', NULL, 'Thiosulfate sulfurtransferase', 133, NULL, NULL, 60665),
(60666, '1.20.5.190-FF-000008', NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', 48, NULL, NULL, 60666),
(60667, '1.20.1070.10-FF-000157', NULL, 'C-X-C chemokine receptor type 2', 308, NULL, NULL, 60667),
(60668, '1.20.1250.20-FF-002321', NULL, 'Protein NRT1/ PTR FAMILY 7.1', 265, NULL, NULL, 60668),
(60669, '1.10.150.130-FF-000003', NULL, 'Lambda integrase', 103, NULL, NULL, 60669),
(60670, '2.140.10.10-FF-000006', NULL, 'Glucose dehydrogenase', 239, NULL, NULL, 60670),
(60671, '3.40.1360.10-FF-000055', NULL, 'Chromosome 12, whole genome shotgun sequence', 252, NULL, NULL, 60671),
(60672, '3.30.160.60-FF-000658', NULL, 'Zinc finger protein 652', 28, NULL, NULL, 60672),
(60673, '2.130.10.10-FF-000569', NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', 104, NULL, NULL, 60673),
(60674, '3.10.110.10-FF-000280', NULL, 'Uncharacterized protein', 123, NULL, NULL, 60674),
(60675, '2.60.120.200-FF-000372', NULL, 'Uncharacterized protein', 132, NULL, NULL, 60675),
(60676, '3.30.230.120-FF-000018', NULL, NULL, 364, NULL, NULL, 60676),
(60677, '3.30.40.10-FF-001388', NULL, 'Putative dna damage-responsive repressor gis1/rph1 jumonji superfamily protein', 121, NULL, NULL, 60677),
(60678, '2.40.128.20-FF-000034', NULL, 'Karl, isoform A', 175, NULL, NULL, 60678),
(60679, '1.20.1530.20-FF-000083', NULL, 'Uncharacterized protein', 331, NULL, NULL, 60679),
(60680, '1.20.1740.10-FF-000130', NULL, 'General amino-acid permease, putative', 468, NULL, NULL, 60680),
(60681, '2.40.50.140-FF-001003', NULL, NULL, 60, NULL, NULL, 60681),
(60682, '3.30.559.10-FF-000143', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 244, NULL, NULL, 60682),
(60683, '1.10.760.10-FF-000033', NULL, 'Cytochrome c5', 83, NULL, NULL, 60683),
(60684, '1.10.10.820-FF-000001', NULL, 'Myosin heavy chain', 58, NULL, NULL, 60684),
(60685, '2.40.50.140-FF-000603', NULL, '30S ribosomal protein S17', 88, NULL, NULL, 60685),
(60686, '3.40.50.1010-FF-000197', NULL, NULL, 202, NULL, NULL, 60686),
(60687, '2.60.40.1250-FF-000006', NULL, 'C-type cytochrome biogenesis protein', 137, NULL, NULL, 60687),
(60688, '3.30.200.20-FF-002275', NULL, 'Uncharacterized protein', 110, NULL, NULL, 60688),
(60689, '1.20.58.1480-FF-000028', NULL, 'Protein cereblon homolog', 60, NULL, NULL, 60689),
(60690, '2.60.40.10-FF-005689', NULL, NULL, 76, NULL, NULL, 60690),
(60691, '3.10.310.10-FF-000048', NULL, 'Diaminopimelate epimerase', 107, NULL, NULL, 60691),
(60692, '2.130.10.10-FF-004464', NULL, 'E3 ubiquitin-protein ligase RFWD3', 244, NULL, NULL, 60692),
(60693, '2.130.10.10-FF-002778', NULL, 'WD repeat-containing protein 76', 220, NULL, NULL, 60693),
(60694, '2.60.40.790-FF-000078', NULL, 'CS domain protein, putative', 122, NULL, NULL, 60694),
(60695, '3.40.228.10-FF-000012', NULL, 'DMSO reductase', 257, NULL, NULL, 60695),
(60696, '3.90.550.10-FF-000076', NULL, 'Beta-1,4 N-acetylgalactosaminyltransferase', 201, NULL, NULL, 60696); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(60697, '3.30.565.10-FF-000426', NULL, 'Bacteriophytochrome (Light-regulated signal transduction histidine kinase), PhyB2', 161, NULL, NULL, 60697),
(60698, '1.10.12.10-FF-000019', NULL, 'Enoyl-CoA hydratase', 58, NULL, NULL, 60698),
(60699, '1.25.40.530-FF-000022', NULL, 'Kinesin-like calmodulin binding protein', 171, NULL, NULL, 60699),
(60700, '1.20.58.60-FF-000095', NULL, 'microtubule-actin cross-linking factor 1 isoform X2', 110, NULL, NULL, 60700),
(60701, '3.40.1110.10-FF-000441', NULL, NULL, 132, NULL, NULL, 60701),
(60702, '3.40.50.720-FF-002044', NULL, 'Uncharacterized protein', 179, NULL, NULL, 60702),
(60703, '2.60.120.10-FF-000498', NULL, 'Predicted protein', 144, NULL, NULL, 60703),
(60704, '2.20.100.10-FF-000056', NULL, 'R-spondin 1', 51, NULL, NULL, 60704),
(60705, '1.10.3430.10-FF-000007', NULL, 'Ammonium transporter', 416, NULL, NULL, 60705),
(60706, '3.80.10.10-FF-001581', NULL, 'Transforming growth factor beta activator LRRC33', 127, NULL, NULL, 60706),
(60707, '3.40.50.300-FF-005263', NULL, 'Uncharacterized protein', 184, NULL, NULL, 60707),
(60708, '1.25.40.120-FF-000017', NULL, 'Protein prenylyltransferase superfamily protein', 187, NULL, NULL, 60708),
(60709, '3.30.200.20-FF-000066', NULL, 'Ribosomal protein S6 kinase', 47, NULL, NULL, 60709),
(60710, '1.25.40.10-FF-001074', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 95, NULL, NULL, 60710),
(60711, '1.25.40.10-FF-001849', NULL, 'Protein CBG05584', 278, NULL, NULL, 60711),
(60712, '3.10.660.10-FF-000012', NULL, 'AGAP010609-PA', 57, NULL, NULL, 60712),
(60713, '1.25.40.20-FF-001386', NULL, 'Uncharacterized protein', 60, NULL, NULL, 60713),
(60714, '2.60.40.640-FF-000084', NULL, 'Subunit of retromer complex', 156, NULL, NULL, 60714),
(60715, '1.25.40.180-FF-000131', NULL, NULL, 251, NULL, NULL, 60715),
(60716, '3.30.590.50-FF-000002', NULL, 'Glutamate--cysteine ligase catalytic subunit', 288, NULL, NULL, 60716),
(60717, '1.20.1070.10-FF-000718', NULL, 'Uncharacterized protein', 138, NULL, NULL, 60717),
(60718, '3.40.50.11210-FF-000018', NULL, NULL, 77, NULL, NULL, 60718),
(60719, '3.40.640.10-FF-000094', NULL, 'Probable cystathionine gamma-synthase', 214, NULL, NULL, 60719),
(60720, '3.40.50.620-FF-000362', NULL, 'Valyl-tRNA synthetase', 247, NULL, NULL, 60720),
(60721, '3.40.50.10090-FF-000053', NULL, 'Putative uroporphyrinogen-III synthase', 99, NULL, NULL, 60721),
(60722, '2.120.10.30-FF-000058', NULL, 'Low-density lipoprotein receptor-related protein 2', 320, NULL, NULL, 60722),
(60723, '1.20.140.100-FF-000018', NULL, 'Glutathione S-transferase class-mu 26 kDa isozyme', 165, NULL, NULL, 60723),
(60724, '3.90.215.10-FF-000022', NULL, 'Uncharacterized protein', 251, NULL, NULL, 60724),
(60725, '2.60.40.3440-FF-000005', NULL, 'Integrin beta-like protein A', 130, NULL, NULL, 60725),
(60726, '3.30.1370.110-FF-000005', NULL, 'Endonuclease MutS2', 122, NULL, NULL, 60726),
(60727, '3.40.50.960-FF-000014', NULL, '6,7-dimethyl-8-ribityllumazine synthase', 142, NULL, NULL, 60727),
(60728, '2.60.120.650-FF-000175', NULL, 'Uncharacterized protein', 145, NULL, NULL, 60728),
(60729, '3.40.50.300-FF-007988', NULL, 'Uncharacterized protein', 157, NULL, NULL, 60729),
(60730, '3.30.1330.10-FF-000033', NULL, 'Uncharacterized protein sll0787', 127, NULL, NULL, 60730),
(60731, '2.40.50.100-FF-000086', NULL, 'Molybdenum transport operon repressor MopB', 71, NULL, NULL, 60731),
(60732, '3.40.50.300-FF-007163', NULL, 'Uncharacterized protein MJECL43', 174, NULL, NULL, 60732),
(60733, '3.90.1280.20-FF-000017', NULL, NULL, 53, NULL, NULL, 60733),
(60734, '2.30.130.10-FF-000022', NULL, 'Glutamate 5-kinase', 98, NULL, NULL, 60734),
(60735, '3.40.50.1820-FF-001529', NULL, 'Uncharacterized protein', 144, NULL, NULL, 60735),
(60736, '1.20.1740.10-FF-000028', NULL, 'Inner membrane transporter YqeG', 400, NULL, NULL, 60736),
(60737, '2.60.40.10-FF-004863', NULL, NULL, 147, NULL, NULL, 60737),
(60738, '2.40.160.160-FF-000001', NULL, 'Intimin-like inverse autotransporter SinH', 245, NULL, NULL, 60738),
(60739, '3.90.226.10-FF-000148', NULL, 'Possible protease IV sppA (Endopeptidase IV)', 211, NULL, NULL, 60739);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(60740, '3.40.50.300-FF-000592', NULL, 'ATP-dependent helicase DinG', 271, NULL, NULL, 60740),
(60741, '3.40.50.1820-FF-000304', NULL, 'Haloalkane dehalogenase 3', 297, NULL, NULL, 60741),
(60742, '1.10.472.30-FF-000015', NULL, NULL, 103, NULL, NULL, 60742),
(60743, '2.10.109.10-FF-000084', NULL, 'Mitochondrial inner membrane protease subunit', 134, NULL, NULL, 60743),
(60744, '1.10.287.110-FF-000474', NULL, 'Predicted protein', 107, NULL, NULL, 60744),
(60745, '2.60.40.10-FF-005352', NULL, NULL, 66, NULL, NULL, 60745),
(60746, '3.40.50.80-FF-000032', NULL, 'NADPH-dependent diflavin oxidoreductase 1', 158, NULL, NULL, 60746),
(60747, '1.10.600.10-FF-000123', NULL, 'Putative vetispiradiene synthase', 104, NULL, NULL, 60747),
(60748, '3.30.160.60-FF-004273', NULL, NULL, 25, NULL, NULL, 60748),
(60749, '1.10.4160.10-FF-000037', NULL, NULL, 210, NULL, NULL, 60749),
(60750, '1.10.238.10-FF-000538', NULL, 'EF-hand calcium-binding domain-containing protein 6', 187, NULL, NULL, 60750),
(60751, '2.60.40.180-FF-000002', NULL, 'Transthyretin', 127, NULL, NULL, 60751),
(60752, '3.40.50.620-FF-000345', NULL, 'Protein CBG05149', 240, NULL, NULL, 60752),
(60753, '2.60.40.60-FF-001033', NULL, 'Uncharacterized protein', 102, NULL, NULL, 60753),
(60754, '3.80.10.10-FF-003262', NULL, 'Uncharacterized protein', 79, NULL, NULL, 60754),
(60755, '2.40.37.10-FF-000051', NULL, NULL, 127, NULL, NULL, 60755),
(60756, '3.30.450.20-FF-000433', NULL, 'Uncharacterized protein', 92, NULL, NULL, 60756),
(60757, '1.20.1250.20-FF-001657', NULL, 'Multidrug resistance protein B', 178, NULL, NULL, 60757),
(60758, '3.40.1110.10-FF-000132', NULL, 'Probable cobalt/nickel-exporting P-type ATPase', 118, NULL, NULL, 60758),
(60759, '3.40.50.1820-FF-000350', NULL, 'Alpha/beta hydrolase', 294, NULL, NULL, 60759),
(60760, '1.10.10.2660-FF-000019', NULL, 'Ubiquitin-activating enzyme e1 1 putative', 166, NULL, NULL, 60760),
(60761, '3.30.1520.10-FF-000008', NULL, 'Sorting nexin-17 isoform1', 110, NULL, NULL, 60761),
(60762, '1.20.1070.10-FF-000421', NULL, 'FMRFamide receptor', 319, NULL, NULL, 60762),
(60763, '3.90.870.10-FF-000021', NULL, 'Uncharacterized protein', 136, NULL, NULL, 60763),
(60764, '3.30.40.10-FF-000293', NULL, 'Histone-lysine N-methyltransferase', 129, NULL, NULL, 60764),
(60765, '4.10.70.10-FF-000006', NULL, 'ADAM like decysin 1', 50, NULL, NULL, 60765),
(60766, '2.60.40.10-FF-001081', NULL, 'Leucine-rich repeat and fibronectin type-III domain-containing protein 4', 87, NULL, NULL, 60766),
(60767, '1.25.10.10-FF-002527', NULL, 'Predicted protein', 189, NULL, NULL, 60767),
(60768, '2.40.30.10-FF-000018', NULL, 'Ferredoxin--NADP(+) reductase', 98, NULL, NULL, 60768),
(60769, '3.40.50.300-FF-006819', NULL, 'Uncharacterized protein', 38, NULL, NULL, 60769),
(60770, '2.10.220.10-FF-000011', NULL, 'Proprotein convertase subtilisin/kexin type 5', 77, NULL, NULL, 60770),
(60771, '3.40.850.10-FF-000031', NULL, 'Kinesin-like protein', 353, NULL, NULL, 60771),
(60772, '3.40.1190.20-FF-000213', NULL, NULL, 327, NULL, NULL, 60772),
(60773, '1.10.418.10-FF-000159', NULL, 'Actinin, alpha 2b', 96, NULL, NULL, 60773),
(60774, '2.70.98.10-FF-000105', NULL, 'Aldose 1-epimerase', 341, NULL, NULL, 60774),
(60775, '1.10.10.60-FF-001250', NULL, NULL, 102, NULL, NULL, 60775),
(60776, '1.10.10.60-FF-000631', NULL, 'Chitin synthase 6', 65, NULL, NULL, 60776),
(60777, '1.10.287.70-FF-000136', NULL, 'Voltage-dependent T-type calcium channel subunit alpha', 145, NULL, NULL, 60777),
(60778, '3.40.850.10-FF-000470', NULL, 'Kinesin-like protein', 361, NULL, NULL, 60778),
(60779, '2.30.42.10-FF-000439', NULL, NULL, 121, NULL, NULL, 60779),
(60780, '1.10.10.1700-FF-000001', NULL, 'Histone-lysine N-methyltransferase', 105, NULL, NULL, 60780),
(60781, '2.130.10.10-FF-000642', NULL, 'Cleavage and polyadenylation specificity factor (CPSF) A subunit protein', 170, NULL, NULL, 60781),
(60782, '3.80.10.10-FF-003790', NULL, 'Uncharacterized protein', 97, NULL, NULL, 60782),
(60783, '3.40.50.150-FF-001575', NULL, NULL, 57, NULL, NULL, 60783),
(60784, '3.40.1000.50-FF-000012', NULL, 'Repressor of RNA polymerase III transcription MAF1', 156, NULL, NULL, 60784);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(60785, '1.10.8.60-FF-000574', NULL, 'RuvB-like helicase', 57, NULL, NULL, 60785),
(60786, '2.40.10.230-FF-000010', NULL, 'Transporter, putative', 115, NULL, NULL, 60786),
(60787, '3.40.50.620-FF-000822', NULL, 'Diphthine--ammonia ligase', 154, NULL, NULL, 60787),
(60788, '1.20.1250.20-FF-001129', NULL, 'EmrB/QacA family drug resistance transporter', 241, NULL, NULL, 60788),
(60789, '3.40.20.10-FF-000083', NULL, 'Coronin', 94, NULL, NULL, 60789),
(60790, '1.10.10.10-FF-001858', NULL, 'Activating signal cointegrator 1 complex subunit 3, helc1, putative', 75, NULL, NULL, 60790),
(60791, '1.10.3450.40-FF-000006', NULL, 'Signal recognition particle subunit SRP68', 219, NULL, NULL, 60791),
(60792, '2.120.10.30-FF-000160', NULL, 'Uncharacterized protein, isoform B', 168, NULL, NULL, 60792),
(60793, '2.60.40.10-FF-004733', NULL, NULL, 105, NULL, NULL, 60793),
(60794, '3.30.160.60-FF-001530', NULL, 'Zinc finger protein 268', 31, NULL, NULL, 60794),
(60795, '2.40.70.10-FF-000453', NULL, NULL, 125, NULL, NULL, 60795),
(60796, '3.40.140.10-FF-000168', NULL, 'Uncharacterized protein', 135, NULL, NULL, 60796),
(60797, '1.10.238.10-FF-001157', NULL, 'Uncharacterized protein', 195, NULL, NULL, 60797),
(60798, '2.40.10.10-FF-000444', NULL, NULL, 120, NULL, NULL, 60798),
(60799, '1.10.520.10-FF-000066', NULL, 'Peroxidase', 50, NULL, NULL, 60799),
(60800, '1.10.10.10-FF-000077', NULL, 'DNA-binding transcriptional regulator CpxR', 102, NULL, NULL, 60800),
(60801, '3.30.40.10-FF-000770', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 149, NULL, NULL, 60801),
(60802, '1.20.58.1120-FF-000050', NULL, NULL, 137, NULL, NULL, 60802),
(60803, '1.10.400.10-FF-000012', NULL, 'G protein alpha subunit', 43, NULL, NULL, 60803),
(60804, '2.60.120.260-FF-000260', NULL, 'Beta-galactosidase', 205, NULL, NULL, 60804),
(60805, '3.30.390.110-FF-000011', NULL, 'Ribosomal L28e/Mak16', 125, NULL, NULL, 60805),
(60806, '3.90.180.10-FF-000165', NULL, 'Uncharacterized protein', 114, NULL, NULL, 60806),
(60807, '1.20.120.1900-FF-000038', NULL, 'Spindle pole body component', 316, NULL, NULL, 60807),
(60808, '1.10.1300.10-FF-000003', NULL, 'Phosphodiesterase', 327, NULL, NULL, 60808),
(60809, '3.30.70.3000-FF-000009', NULL, 'Uncharacterized protein', 241, NULL, NULL, 60809),
(60810, '3.80.10.10-FF-003947', NULL, 'Putative surface antigen protein', 71, NULL, NULL, 60810),
(60811, '2.60.120.380-FF-000043', NULL, 'Calpain 13', 161, NULL, NULL, 60811),
(60812, '2.10.110.10-FF-000019', NULL, 'Lim and senescent cell antigen-like-containing', 61, NULL, NULL, 60812),
(60813, '1.20.58.80-FF-000095', NULL, 'Serine/threonine protein kinase, putative', 43, NULL, NULL, 60813),
(60814, '2.60.40.150-FF-000145', NULL, 'Synaptotagmin 13', 131, NULL, NULL, 60814),
(60815, '3.40.50.10140-FF-000074', NULL, 'Myeloid differentiation factor 88', 72, NULL, NULL, 60815),
(60816, '3.40.50.410-FF-000080', NULL, 'X-ray repair-complementing defective repair in Chinese hamster cells 6', 217, NULL, NULL, 60816),
(60817, '3.30.70.330-FF-000961', NULL, 'OSJNBa0023J03.10 protein', 125, NULL, NULL, 60817),
(60818, '3.40.50.300-FF-005824', NULL, 'Uncharacterized protein', 159, NULL, NULL, 60818),
(60819, '1.20.120.230-FF-000036', NULL, 'Alpha-catenin-like protein hmp-1', 117, NULL, NULL, 60819),
(60820, '3.30.160.60-FF-005801', NULL, NULL, 25, NULL, NULL, 60820),
(60821, '1.10.8.10-FF-000025', NULL, 'TGF-beta-activated kinase 1 and MAP3K7-binding protein 3', 72, NULL, NULL, 60821),
(60822, '2.60.220.50-FF-000107', NULL, 'Uncharacterized protein', 132, NULL, NULL, 60822),
(60823, '2.60.40.10-FF-000462', NULL, 'Interleukin 1 receptor accessory protein', 118, NULL, NULL, 60823),
(60824, '1.25.10.10-FF-002966', NULL, 'Tubulin-specific chaperone D', 420, NULL, NULL, 60824),
(60825, '3.60.21.10-FF-000483', NULL, 'Serine/threonine-protein phosphatase', 220, NULL, NULL, 60825),
(60826, '3.40.1280.10-FF-000127', NULL, 'SPOUT domain-containing methyltransferase 1', 48, NULL, NULL, 60826),
(60827, '3.30.900.10-FF-000061', NULL, 'DNA polymerase zeta processivity subunit', 205, NULL, NULL, 60827);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(60828, '2.60.120.650-FF-000074', NULL, 'JmjC domain containing protein', 234, NULL, NULL, 60828),
(60829, '3.30.160.60-FF-002709', NULL, 'Zinc finger protein 724', 33, NULL, NULL, 60829),
(60830, '3.30.40.10-FF-001579', NULL, 'E3 ubiquitin-protein ligase RHA1B', 89, NULL, NULL, 60830),
(60831, '4.10.240.10-FF-000038', NULL, 'TY1 enhancer activator', 83, NULL, NULL, 60831),
(60832, '1.10.10.10-FF-000184', NULL, 'Response regulator receiver', 105, NULL, NULL, 60832),
(60833, '3.40.50.300-FF-008258', NULL, '10-formyltetrahydrofolate synthetase', 49, NULL, NULL, 60833),
(60834, '2.60.40.10-FF-004840', NULL, NULL, 87, NULL, NULL, 60834),
(60835, '1.20.58.1880-FF-000018', NULL, 'Chromosome 17 open reading frame 49', 58, NULL, NULL, 60835),
(60836, '1.20.1560.10-FF-000273', NULL, 'Putative ABC transporter ATP-binding protein', 324, NULL, NULL, 60836),
(60837, '2.60.40.2030-FF-000004', NULL, 'Integrin beta', 119, NULL, NULL, 60837),
(60838, '3.40.50.300-FF-003110', NULL, 'Uncharacterized protein', 149, NULL, NULL, 60838),
(60839, '1.10.20.10-FF-000358', NULL, NULL, 90, NULL, NULL, 60839),
(60840, '2.120.10.80-FF-000056', NULL, 'Kelch-like family member 14', 224, NULL, NULL, 60840),
(60841, '1.10.510.10-FF-001622', NULL, 'Serine/threonine-protein kinase PINK1, mitochondrial', 198, NULL, NULL, 60841),
(60842, '3.30.950.30-FF-000002', NULL, 'Schlafen family member 11', 131, NULL, NULL, 60842),
(60843, '3.30.160.60-FF-002339', NULL, 'Zinc finger protein 322', 33, NULL, NULL, 60843),
(60844, '3.30.70.330-FF-001034', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 144, NULL, NULL, 60844),
(60845, '1.25.40.10-FF-000540', NULL, 'Peptidylprolyl isomerase', 130, NULL, NULL, 60845),
(60846, '1.10.1070.11-FF-000019', NULL, 'Phosphatidylinositol 4-kinase beta 1', 202, NULL, NULL, 60846),
(60847, '3.30.710.10-FF-000361', NULL, 'Uncharacterized protein', 101, NULL, NULL, 60847),
(60848, '2.60.120.260-FF-000153', NULL, 'Uncharacterized conserved protein', 152, NULL, NULL, 60848),
(60849, '3.30.70.330-FF-001141', NULL, 'Ras GTPase-activating protein-binding protein 1', 127, NULL, NULL, 60849),
(60850, '2.120.10.30-FF-000513', NULL, 'Uncharacterized protein', 196, NULL, NULL, 60850),
(60851, '1.20.1560.10-FF-000582', NULL, 'Predicted protein', 74, NULL, NULL, 60851),
(60852, '2.30.29.30-FF-001084', NULL, 'Uncharacterized protein', 63, NULL, NULL, 60852),
(60853, '1.20.1510.10-FF-000062', NULL, NULL, 88, NULL, NULL, 60853),
(60854, '1.10.10.10-FF-001965', NULL, '30S ribosomal protein S25e', 71, NULL, NULL, 60854),
(60855, '2.160.20.10-FF-000017', NULL, 'F-box only protein 10', 132, NULL, NULL, 60855),
(60856, '3.40.50.300-FF-001772', NULL, 'DNA replication origin-binding helicase', 160, NULL, NULL, 60856),
(60857, '3.30.1360.10-FF-000006', NULL, 'DNA-directed RNA polymerases I and III subunit RPAC2', 103, NULL, NULL, 60857),
(60858, '1.10.510.10-FF-000790', NULL, 'Cyclin-dependent kinase G-1', 219, NULL, NULL, 60858),
(60859, '3.20.20.80-FF-000806', NULL, 'Predicted protein', 121, NULL, NULL, 60859),
(60860, '3.40.50.300-FF-004998', NULL, 'ARF-like GTPase ARLP2, atypical', 196, NULL, NULL, 60860),
(60861, '1.20.1280.50-FF-000229', NULL, 'F-box protein pof6', 98, NULL, NULL, 60861),
(60862, '3.90.1150.10-FF-000359', NULL, 'Nucleotide-sugar aminotransferase', 121, NULL, NULL, 60862),
(60863, '2.30.30.100-FF-000112', NULL, 'U6 snRNA-associated Sm family protein LSm2, putative', 59, NULL, NULL, 60863),
(60864, '3.30.565.10-FF-000281', NULL, 'Sensor histidine kinase YvrG', 155, NULL, NULL, 60864),
(60865, '3.40.390.10-FF-000321', NULL, NULL, 259, NULL, NULL, 60865),
(60866, '3.30.30.30-FF-000039', NULL, 'Uncharacterized protein', 56, NULL, NULL, 60866),
(60867, '3.10.20.90-FF-000467', NULL, 'ikappaB kinase isoform X1', 75, NULL, NULL, 60867),
(60868, '1.10.10.10-FF-000554', NULL, 'Anaphase-promoting complex subunit 2', 83, NULL, NULL, 60868),
(60869, '3.90.550.10-FF-000429', NULL, '2-C-methyl-D-erythritol 4-phosphate cytidylyltransferase', 234, NULL, NULL, 60869),
(60870, '3.30.310.80-FF-000025', NULL, 'SNF1-like protein kinase ssp2', 151, NULL, NULL, 60870);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(60871, '3.40.50.300-FF-005038', NULL, 'tRNA delta(2)-isopentenylpyrophosphate transferase, putative', 191, NULL, NULL, 60871),
(60872, '1.20.920.20-FF-000007', NULL, 'Cytoplasmic dynein 1 heavy chain 1-like', 109, NULL, NULL, 60872),
(60873, '3.40.50.12790-FF-000003', NULL, NULL, 98, NULL, NULL, 60873),
(60874, '2.130.10.10-FF-004481', NULL, 'Uncharacterized protein', 148, NULL, NULL, 60874),
(60875, '3.40.109.10-FF-000056', NULL, 'Uncharacterized protein', 124, NULL, NULL, 60875),
(60876, '2.10.25.10-FF-000384', NULL, 'Integrin subunit beta like 1', 48, NULL, NULL, 60876),
(60877, '3.40.50.720-FF-001690', NULL, 'Formate dehydrogenase chloroplastic/mitochondrial', 59, NULL, NULL, 60877),
(60878, '1.25.40.190-FF-000004', NULL, 'Actin-related protein 2/3 complex subunit 5', 151, NULL, NULL, 60878),
(60879, '3.40.630.30-FF-000498', NULL, 'Uncharacterized protein, isoform C', 128, NULL, NULL, 60879),
(60880, '2.130.10.10-FF-000333', NULL, 'WD repeat-containing protein 55', 219, NULL, NULL, 60880),
(60881, '3.30.800.10-FF-000002', NULL, 'Phosphatidylinositol 5-phosphate 4-kinase type-2 beta', 179, NULL, NULL, 60881),
(60882, '1.10.150.670-FF-000036', NULL, 'Uncharacterized protein', 76, NULL, NULL, 60882),
(60883, '3.40.50.1440-FF-000106', NULL, 'Uncharacterized protein', 72, NULL, NULL, 60883),
(60884, '1.25.40.10-FF-002355', NULL, 'Uncharacterized protein', 171, NULL, NULL, 60884),
(60885, '2.40.50.140-FF-000064', NULL, 'Replication protein A subunit', 133, NULL, NULL, 60885),
(60886, '3.40.630.30-FF-000043', NULL, 'Glucosamine 6-phosphate N-acetyltransferase', 151, NULL, NULL, 60886),
(60887, '1.20.272.10-FF-000082', NULL, NULL, 69, NULL, NULL, 60887),
(60888, '3.40.720.10-FF-000151', NULL, 'Predicted protein', 138, NULL, NULL, 60888),
(60889, '1.10.630.10-FF-000260', NULL, 'Putative cytochrome P450 superfamily protein', 501, NULL, NULL, 60889),
(60890, '1.20.1390.10-FF-000001', NULL, 'RNA-binding protein 26 isoform X2', 80, NULL, NULL, 60890),
(60891, '3.20.20.450-FF-000011', NULL, 'Cyclic di-GMP phosphodiesterase YfgF', 251, NULL, NULL, 60891),
(60892, '1.10.390.10-FF-000105', NULL, 'Aminopeptidase', 256, NULL, NULL, 60892),
(60893, '2.130.10.10-FF-001261', NULL, 'Chromatin assembly factor 1 P55 subunit, putative', 420, NULL, NULL, 60893),
(60894, '3.30.420.10-FF-000142', NULL, 'Ribonuclease HII', 201, NULL, NULL, 60894),
(60895, '3.30.413.10-FF-000030', NULL, 'Sulfite reductase, assimilatory', 142, NULL, NULL, 60895),
(60896, '3.40.850.10-FF-000363', NULL, 'Chitin synthase-domain-containing protein', 214, NULL, NULL, 60896),
(60897, '1.10.8.10-FF-000334', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 71, NULL, NULL, 60897),
(60898, '2.60.120.830-FF-000004', NULL, 'Lonely heart, isoform A', 140, NULL, NULL, 60898),
(60899, '1.10.3720.10-FF-000081', NULL, '2-aminoethylphosphonate ABC transport system, membrane component PhnV', 253, NULL, NULL, 60899),
(60900, '3.10.150.10-FF-000029', NULL, 'Proliferating cell nuclear antigen', 163, NULL, NULL, 60900),
(60901, '1.25.10.20-FF-000030', NULL, 'Uncharacterized protein', 335, NULL, NULL, 60901),
(60902, '3.40.50.2000-FF-000628', NULL, 'YALI0A10296p', 206, NULL, NULL, 60902),
(60903, '1.20.1410.10-FF-000026', NULL, 'Cyclin-D1-binding protein 1 homolog', 187, NULL, NULL, 60903),
(60904, '3.80.10.10-FF-002643', NULL, 'Transforming growth factor beta activator LRRC33', 71, NULL, NULL, 60904),
(60905, '1.20.5.10-FF-000002', NULL, 'adenomatous polyposis coli protein-like isoform X1', 54, NULL, NULL, 60905),
(60906, '1.10.287.110-FF-000249', NULL, 'DnaJ-like protein', 78, NULL, NULL, 60906),
(60907, '2.60.40.790-FF-000179', NULL, NULL, 123, NULL, NULL, 60907),
(60908, '3.20.20.140-FF-000126', NULL, 'Amidohydrolase', 274, NULL, NULL, 60908),
(60909, '3.40.50.720-FF-000066', NULL, 'Putative ubiquitin-like modifier-activating enzyme 5', 260, NULL, NULL, 60909),
(60910, '3.30.70.330-FF-000522', NULL, 'RNA recognition motif (RRM)-containing protein', 94, NULL, NULL, 60910),
(60911, '3.40.50.10810-FF-000191', NULL, 'Predicted protein', 195, NULL, NULL, 60911);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(60912, '3.40.190.80-FF-000080', NULL, 'Glr0190 protein', 118, NULL, NULL, 60912),
(60913, '3.10.180.20-FF-000006', NULL, NULL, 73, NULL, NULL, 60913),
(60914, '6.10.140.2220-FF-000023', NULL, 'SET_domain_containing_protein_-_putative', 64, NULL, NULL, 60914),
(60915, '3.80.10.10-FF-000721', NULL, 'Uncharacterized protein', 97, NULL, NULL, 60915),
(60916, '3.30.70.20-FF-000145', NULL, NULL, 36, NULL, NULL, 60916),
(60917, '1.10.510.10-FF-003527', NULL, NULL, 243, NULL, NULL, 60917),
(60918, '3.30.70.1660-FF-000006', NULL, 'Peptide chain release factor 1', 132, NULL, NULL, 60918),
(60919, '1.10.510.10-FF-000801', NULL, 'Guanylate cyclase', 256, NULL, NULL, 60919),
(60920, '1.20.970.10-FF-000041', NULL, 'Thymidine phosphorylase', 66, NULL, NULL, 60920),
(60921, '1.10.357.70-FF-000035', NULL, 'Uncharacterized protein', 97, NULL, NULL, 60921),
(60922, '3.30.70.360-FF-000065', NULL, 'Cytosolic non-specific dipeptidase', 38, NULL, NULL, 60922),
(60923, '3.40.50.300-FF-004419', NULL, 'Orc1/CDC6', 178, NULL, NULL, 60923),
(60924, '2.130.10.10-FF-005004', NULL, 'Uncharacterized protein', 60, NULL, NULL, 60924),
(60925, '2.70.20.60-FF-000003', NULL, 'Matrix protein', 161, NULL, NULL, 60925),
(60926, '1.25.10.10-FF-000392', NULL, 'RING-type E3 ubiquitin transferase', 141, NULL, NULL, 60926),
(60927, '2.60.40.4100-FF-000018', NULL, 'Zona pellucida glycoprotein 3c', 160, NULL, NULL, 60927),
(60928, '1.10.10.10-FF-001510', NULL, 'Predicted protein', 111, NULL, NULL, 60928),
(60929, '3.40.50.1970-FF-000029', NULL, 'Iron-containing alcohol dehydrogenase RfbM', 178, NULL, NULL, 60929),
(60930, '3.100.10.10-FF-000038', NULL, NULL, 86, NULL, NULL, 60930),
(60931, '3.30.559.10-FF-000221', NULL, 'Chondramide synthase cmdD', 185, NULL, NULL, 60931),
(60932, '1.10.418.10-FF-000266', NULL, 'Microtubule-associated protein', 150, NULL, NULL, 60932),
(60933, '2.170.120.12-FF-000030', NULL, 'Uncharacterized protein', 42, NULL, NULL, 60933),
(60934, '1.10.730.10-FF-000205', NULL, 'Protein CBR-LARS-2', 97, NULL, NULL, 60934),
(60935, '3.10.20.90-FF-000012', NULL, 'Serine/threonine-protein kinase WNK1 isoform 2', 91, NULL, NULL, 60935),
(60936, '1.25.10.10-FF-002174', NULL, 'Uncharacterized protein', 479, NULL, NULL, 60936),
(60937, '3.60.21.10-FF-000011', NULL, 'Double-strand break repair protein', 300, NULL, NULL, 60937),
(60938, '2.60.40.1170-FF-000049', NULL, 'Coatomer subunit delta', 105, NULL, NULL, 60938),
(60939, '3.40.50.300-FF-006443', NULL, 'Uncharacterized protein', 125, NULL, NULL, 60939),
(60940, '2.170.16.10-FF-000041', NULL, 'Vitamin B12-dependent ribonucleotide reductase', 142, NULL, NULL, 60940),
(60941, '3.30.160.60-FF-004020', NULL, 'Broad, isoform M', 95, NULL, NULL, 60941),
(60942, '3.30.200.160-FF-000007', NULL, 'GTF3C5 isoform 9', 86, NULL, NULL, 60942),
(60943, '3.80.10.10-FF-004083', NULL, 'Uncharacterized protein', 125, NULL, NULL, 60943),
(60944, '2.60.120.260-FF-000592', NULL, 'uncharacterized protein LOC100177071', 154, NULL, NULL, 60944),
(60945, '3.30.200.20-FF-000297', NULL, 'serine/threonine-protein kinase 16', 98, NULL, NULL, 60945),
(60946, '1.20.1310.10-FF-000081', NULL, 'Cullin family protein', 162, NULL, NULL, 60946),
(60947, '1.20.1060.20-FF-000013', NULL, 'Structural maintenance of chromosomes protein', 66, NULL, NULL, 60947),
(60948, '2.30.30.40-FF-000174', NULL, 'rho guanine nucleotide exchange factor 37', 65, NULL, NULL, 60948),
(60949, '1.20.58.60-FF-000881', NULL, 'Uncharacterized protein', 104, NULL, NULL, 60949),
(60950, '1.10.238.110-FF-000021', NULL, 'Diacylglycerol kinase', 49, NULL, NULL, 60950),
(60951, '1.25.40.10-FF-003890', NULL, 'Tetratricopeptide repeat domain 7A', 79, NULL, NULL, 60951),
(60952, '1.20.58.60-FF-000572', NULL, 'Spectrin beta chain', 99, NULL, NULL, 60952),
(60953, '2.60.40.1180-FF-000081', NULL, '1,4-alpha-glucan branching enzyme', 85, NULL, NULL, 60953),
(60954, '3.80.10.10-FF-003138', NULL, 'Leiomodin 1', 59, NULL, NULL, 60954),
(60955, '3.30.460.10-FF-000032', NULL, 'DNA-directed DNA/RNA polymerase mu', 137, NULL, NULL, 60955),
(60956, '2.30.29.30-FF-000572', NULL, 'Uncharacterized protein', 103, NULL, NULL, 60956);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(60957, '3.30.70.330-FF-002759', NULL, NULL, 80, NULL, NULL, 60957),
(60958, '3.80.10.10-FF-000412', NULL, 'Leucine-rich repeat receptor-like protein kinase PXL1', 155, NULL, NULL, 60958),
(60959, '3.40.50.300-FF-002637', NULL, 'Putative ATP-dependent RNA helicase', 232, NULL, NULL, 60959),
(60960, '3.90.640.10-FF-000212', NULL, 'Actin-Related Proteins', 87, NULL, NULL, 60960),
(60961, '1.10.150.240-FF-000053', NULL, 'Haloacid dehalogenase/epoxide hydrolase family protein', 69, NULL, NULL, 60961),
(60962, '2.30.30.550-FF-000005', NULL, 'Major vault protein', 57, NULL, NULL, 60962),
(60963, '2.10.25.10-FF-000075', NULL, 'Integrin beta', 41, NULL, NULL, 60963),
(60964, '3.20.20.150-FF-000039', NULL, 'AP endonuclease, family 2', 248, NULL, NULL, 60964),
(60965, '3.90.180.10-FF-000148', NULL, 'S or R-dihydroxypropanesulfonate-2-dehydrogenase', 172, NULL, NULL, 60965),
(60966, '3.20.10.10-FF-000004', NULL, 'Branched-chain-amino-acid aminotransferase', 181, NULL, NULL, 60966),
(60967, '1.20.1250.20-FF-002057', NULL, 'Uncharacterized protein', 304, NULL, NULL, 60967),
(60968, '3.40.50.300-FF-002946', NULL, 'Probable DNA repair protein RAD50', 288, NULL, NULL, 60968),
(60969, '3.10.180.10-FF-000110', NULL, '4-hydroxyphenylpyruvate dioxygenase', 82, NULL, NULL, 60969),
(60970, '1.10.640.10-FF-000013', NULL, 'Thyroid peroxidase', 393, NULL, NULL, 60970),
(60971, '3.30.160.60-FF-003637', NULL, 'Tripartite motif-containing 25', 72, NULL, NULL, 60971),
(60972, '3.30.420.140-FF-000023', NULL, 'Holliday-junction_resolvase-like_of_SPT6 /SH2_domain_containing_protein_-_putative', 143, NULL, NULL, 60972),
(60973, '3.40.50.10810-FF-000230', NULL, 'Uncharacterized ATP-dependent helicase MG018', 260, NULL, NULL, 60973),
(60974, '3.30.830.10-FF-000178', NULL, 'Processing protease', 209, NULL, NULL, 60974),
(60975, '3.30.160.20-FF-000214', NULL, 'Uncharacterized protein', 83, NULL, NULL, 60975),
(60976, '2.20.100.10-FF-000163', NULL, 'Uncharacterized protein', 58, NULL, NULL, 60976),
(60977, '4.10.400.10-FF-000175', NULL, 'GM20388', 55, NULL, NULL, 60977),
(60978, '1.10.287.2720-FF-000005', NULL, 'Oxysterol binding protein', 71, NULL, NULL, 60978),
(60979, '1.20.58.70-FF-000119', NULL, 'Syntaxin pep12', 116, NULL, NULL, 60979),
(60980, '3.30.40.10-FF-002113', NULL, 'Uncharacterized protein', 40, NULL, NULL, 60980),
(60981, '3.40.50.300-FF-007308', NULL, 'Uncharacterized protein', 148, NULL, NULL, 60981),
(60982, '1.25.40.10-FF-001490', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 115, NULL, NULL, 60982),
(60983, '1.20.1740.10-FF-000231', NULL, 'Na-K-Cl cotransporter', 419, NULL, NULL, 60983),
(60984, '2.130.10.10-FF-005313', NULL, 'Cleavage and polyadenylation specificity factor subunit 1', 206, NULL, NULL, 60984),
(60985, '3.10.100.10-FF-000318', NULL, NULL, 151, NULL, NULL, 60985),
(60986, '1.10.10.60-FF-000322', NULL, 'Transcription factor TFIIIB component B', 57, NULL, NULL, 60986),
(60987, '2.60.120.920-FF-000059', NULL, 'E3 ubiquitin-protein ligase RNF135', 181, NULL, NULL, 60987),
(60988, '1.10.1070.11-FF-000014', NULL, 'Phosphatidylinositol 3-kinase, root isoform', 200, NULL, NULL, 60988),
(60989, '1.20.58.1480-FF-000005', NULL, 'Lon protease homolog 2, peroxisomal', 126, NULL, NULL, 60989),
(60990, '1.25.40.20-FF-000689', NULL, 'Uncharacterized protein', 264, NULL, NULL, 60990),
(60991, '2.170.120.40-FF-000008', NULL, 'YbbR-like domain-containing protein', 88, NULL, NULL, 60991),
(60992, '2.130.10.10-FF-002547', NULL, 'Hybrid sensor histidine kinase/response regulator', 318, NULL, NULL, 60992),
(60993, '2.130.10.10-FF-004801', NULL, 'Eukaryotic translation initiation factor 2A', 146, NULL, NULL, 60993),
(60994, '1.20.1300.10-FF-000029', NULL, 'Succinate dehydrogenase hydrophobic membrane anchor subunit', 112, NULL, NULL, 60994),
(60995, '2.130.10.10-FF-003059', NULL, 'FI12409p', 138, NULL, NULL, 60995),
(60996, '1.25.40.990-FF-000031', NULL, 'Protein CBG17718', 286, NULL, NULL, 60996),
(60997, '1.10.1370.10-FF-000036', NULL, 'Uncharacterized protein', 225, NULL, NULL, 60997),
(60998, '1.10.287.80-FF-000009', NULL, 'ATP synthase gamma chain', 62, NULL, NULL, 60998);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(60999, '2.40.240.20-FF-000008', NULL, 'Ribosomal RNA small subunit methyltransferase E', 68, NULL, NULL, 60999),
(61000, '3.90.230.10-FF-000029', NULL, 'Methionine aminopeptidase 1c, putative', 158, NULL, NULL, 61000),
(61001, '2.40.70.10-FF-000583', NULL, NULL, 110, NULL, NULL, 61001),
(61002, '1.25.10.10-FF-000712', NULL, 'KAP122p Karyopherin beta', 1078, NULL, NULL, 61002),
(61003, '3.30.70.330-FF-003142', NULL, NULL, 79, NULL, NULL, 61003),
(61004, '3.40.140.10-FF-000292', NULL, 'tRNA-specific adenosine deaminase subunit tad2', 175, NULL, NULL, 61004),
(61005, '1.20.1560.10-FF-000610', NULL, 'Uncharacterized protein', 257, NULL, NULL, 61005),
(61006, '2.70.98.10-FF-000100', NULL, 'Uncharacterized protein', 75, NULL, NULL, 61006),
(61007, '2.60.40.1360-FF-000011', NULL, 'Alpha-mannosidase F', 126, NULL, NULL, 61007),
(61008, '1.10.20.10-FF-000375', NULL, NULL, 25, NULL, NULL, 61008),
(61009, '1.10.287.130-FF-000244', NULL, 'Uncharacterized protein', 109, NULL, NULL, 61009),
(61010, '3.40.50.150-FF-001159', NULL, NULL, 140, NULL, NULL, 61010),
(61011, '3.40.50.720-FF-001662', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 149, NULL, NULL, 61011),
(61012, '3.30.200.20-FF-002202', NULL, 'Uncharacterized protein', 48, NULL, NULL, 61012),
(61013, '3.30.505.10-FF-000209', NULL, NULL, 114, NULL, NULL, 61013),
(61014, '1.25.10.10-FF-000173', NULL, 'Tuberin isoform B', 282, NULL, NULL, 61014),
(61015, '1.10.10.60-FF-001120', NULL, NULL, 64, NULL, NULL, 61015),
(61016, '1.20.1250.20-FF-001438', NULL, 'AGAP000137-PA', 121, NULL, NULL, 61016),
(61017, '3.30.1300.10-FF-000014', NULL, NULL, 115, NULL, NULL, 61017),
(61018, '3.50.50.60-FF-000627', NULL, 'Glutathione reductase', 197, NULL, NULL, 61018),
(61019, '1.20.5.110-FF-000136', NULL, 'Vesicle transport v-SNARE 13', 81, NULL, NULL, 61019),
(61020, '2.60.120.260-FF-000136', NULL, 'Allantoicase, putative', 195, NULL, NULL, 61020),
(61021, '3.30.70.260-FF-000153', NULL, 'GTP pyrophosphokinase', 80, NULL, NULL, 61021),
(61022, '1.10.4100.10-FF-000005', NULL, 'Catabolic enzyme', 258, NULL, NULL, 61022),
(61023, '1.20.1280.50-FF-000100', NULL, 'F-box protein dre-1', 101, NULL, NULL, 61023),
(61024, '1.25.40.10-FF-005233', NULL, 'Uncharacterized protein', 177, NULL, NULL, 61024),
(61025, '3.40.30.10-FF-001218', NULL, '2-hydroxychromene-2-carboxylate isomerase, putative', 187, NULL, NULL, 61025),
(61026, '3.20.20.20-FF-000042', NULL, 'Corrinoid/iron-sulfur protein, large subunit', 318, NULL, NULL, 61026),
(61027, '3.40.50.300-FF-003565', NULL, 'ABC transporter ATP-binding protein', 246, NULL, NULL, 61027),
(61028, '3.30.1140.40-FF-000010', NULL, 'Flagellar outer dynein arm light chain 2', 99, NULL, NULL, 61028),
(61029, '3.90.1150.10-FF-000022', NULL, '4-aminobutyrate aminotransferase', 153, NULL, NULL, 61029),
(61030, '3.30.1490.120-FF-000029', NULL, 'Predicted protein', 74, NULL, NULL, 61030),
(61031, '1.10.287.70-FF-000355', NULL, 'Potassium voltage-gated channel, KQT-like subfamily, member 1.2', 51, NULL, NULL, 61031),
(61032, '1.10.510.10-FF-003191', NULL, NULL, 151, NULL, NULL, 61032),
(61033, '3.40.50.300-FF-003907', NULL, 'ABC transporter-like protein', 222, NULL, NULL, 61033),
(61034, '1.25.40.10-FF-000793', NULL, 'Pentatricopeptide repeat-containing protein', 106, NULL, NULL, 61034),
(61035, '3.55.50.30-FF-000006', NULL, 'TonB-dependent siderophore receptor', 68, NULL, NULL, 61035),
(61036, '1.10.510.10-FF-004039', NULL, NULL, 82, NULL, NULL, 61036),
(61037, '1.25.40.20-FF-000874', NULL, 'ATP-dependent RNA helicase, putative', 123, NULL, NULL, 61037),
(61038, '1.10.510.10-FF-001313', NULL, 'Mitogen-activated protein kinase kinase kinase 15', 209, NULL, NULL, 61038),
(61039, '3.50.50.60-FF-000863', NULL, 'Flavin-containing monooxygenase', 303, NULL, NULL, 61039),
(61040, '3.30.160.360-FF-000006', NULL, 'Histone-lysine N-methyltransferase', 84, NULL, NULL, 61040),
(61041, '3.30.1490.100-FF-000023', NULL, 'DNA polymerase IV', 118, NULL, NULL, 61041),
(61042, '2.60.120.290-FF-000016', NULL, 'neuropilin and tolloid-like protein 2', 120, NULL, NULL, 61042);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(61043, '2.10.25.10-FF-001828', NULL, 'Uncharacterized protein', 33, NULL, NULL, 61043),
(61044, '3.40.1410.10-FF-000037', NULL, 'GntR family transcriptional regulator', 167, NULL, NULL, 61044),
(61045, '3.90.1750.10-FF-000096', NULL, 'Predicted protein', 125, NULL, NULL, 61045),
(61046, '3.30.70.250-FF-000015', NULL, NULL, 71, NULL, NULL, 61046),
(61047, '2.40.50.100-FF-000187', NULL, 'Putative ABC transporter ATP-binding subunit', 71, NULL, NULL, 61047),
(61048, '3.80.10.10-FF-001682', NULL, 'MAP kinase phosphatase with leucine-rich repeats protein 3', 176, NULL, NULL, 61048),
(61049, '1.20.1730.10-FF-000101', NULL, 'Uncharacterized protein', 232, NULL, NULL, 61049),
(61050, '1.10.135.10-FF-000007', NULL, 'arginine kinase', 79, NULL, NULL, 61050),
(61051, '3.40.50.12470-FF-000008', NULL, '2-oxoglutarate dehydrogenase E1 component', 223, NULL, NULL, 61051),
(61052, '1.20.120.350-FF-000179', NULL, NULL, 124, NULL, NULL, 61052),
(61053, '1.10.2000.10-FF-000060', NULL, NULL, 64, NULL, NULL, 61053),
(61054, '2.10.25.10-FF-001800', NULL, 'Predicted protein', 26, NULL, NULL, 61054),
(61055, '2.60.120.620-FF-000076', NULL, 'Predicted protein', 214, NULL, NULL, 61055),
(61056, '2.40.70.10-FF-000436', NULL, NULL, 221, NULL, NULL, 61056),
(61057, '3.30.930.10-FF-000377', NULL, 'Uncharacterized protein', 145, NULL, NULL, 61057),
(61058, '3.40.50.1360-FF-000032', NULL, 'Deoxyribonucleoside regulator', 245, NULL, NULL, 61058),
(61059, '3.30.160.60-FF-004256', NULL, NULL, 77, NULL, NULL, 61059),
(61060, '1.10.510.10-FF-002111', NULL, 'Protein kinase, putative', 196, NULL, NULL, 61060),
(61061, '2.60.120.260-FF-000389', NULL, 'Cytosolic endo-beta-N-acetylglucosaminidase', 181, NULL, NULL, 61061),
(61062, '2.60.40.1080-FF-000011', NULL, 'Nuclear pore membrane glycoprotein 210-like', 71, NULL, NULL, 61062),
(61063, '3.40.50.11350-FF-000010', NULL, 'GDP-fucose protein O-fucosyltransferase 2, putative', 155, NULL, NULL, 61063),
(61064, '3.40.50.2300-FF-000623', NULL, 'Vomeronasal 2, receptor 3', 293, NULL, NULL, 61064),
(61065, '3.30.160.60-FF-000911', NULL, 'Zinc finger protein 641', 31, NULL, NULL, 61065),
(61066, '2.20.70.10-FF-000078', NULL, 'Formin binding protein (FNB3)', 45, NULL, NULL, 61066),
(61067, '3.30.200.20-FF-000752', NULL, 'Unplaced genomic scaffold supercont2.7, whole genome shotgun sequence', 120, NULL, NULL, 61067),
(61068, '3.40.190.10-FF-000351', NULL, 'Transcriptional regulator, LysR family', 104, NULL, NULL, 61068),
(61069, '3.50.50.60-FF-000644', NULL, 'H(2):CoB-CoM heterodisulfide,ferredoxin reductase subunit A', 113, NULL, NULL, 61069),
(61070, '3.40.50.10580-FF-000003', NULL, 'V-type proton ATPase subunit F', 114, NULL, NULL, 61070),
(61071, '3.30.830.10-FF-000206', NULL, 'Insulin degrading enzyme-like zinc peptidase, putative', 221, NULL, NULL, 61071),
(61072, '2.60.120.10-FF-000397', NULL, 'Oxalate-binding protein', 115, NULL, NULL, 61072),
(61073, '1.25.40.10-FF-004272', NULL, 'Uncharacterized protein', 214, NULL, NULL, 61073),
(61074, '2.160.10.10-FF-000062', NULL, 'Serine acetyltransferase', 109, NULL, NULL, 61074),
(61075, '2.170.130.10-FF-000062', NULL, NULL, 139, NULL, NULL, 61075),
(61076, '3.40.1830.10-FF-000001', NULL, 'Aminopeptidase', 163, NULL, NULL, 61076),
(61077, '1.20.1070.10-FF-001707', NULL, 'Olfactory receptor 1434', 106, NULL, NULL, 61077),
(61078, '3.40.50.150-FF-000625', NULL, 'Spermidine synthase', 180, NULL, NULL, 61078),
(61079, '3.40.630.30-FF-000026', NULL, 'Phosphinothricin acetyltransferase', 172, NULL, NULL, 61079),
(61080, '3.40.50.720-FF-000173', NULL, '3-oxoacyl-[acyl-carrier protein] reductase', 247, NULL, NULL, 61080),
(61081, '3.90.79.10-FF-000300', NULL, 'Chromosome 8, whole genome shotgun sequence', 88, NULL, NULL, 61081),
(61082, '3.10.20.90-FF-000670', NULL, 'Ubiquitin family, putative', 75, NULL, NULL, 61082),
(61083, '2.130.10.10-FF-002587', NULL, 'Conserved WD40 and TPR repeat-containing protein, putative', 362, NULL, NULL, 61083),
(61084, '3.40.50.300-FF-004526', NULL, 'Putative elongator complex protein 4', 186, NULL, NULL, 61084);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(61085, '3.30.200.20-FF-000257', NULL, '3-phosphoinositide-dependent protein kinase 1', 114, NULL, NULL, 61085),
(61086, '3.40.190.10-FF-000823', NULL, 'Uncharacterized protein', 55, NULL, NULL, 61086),
(61087, '3.30.420.110-FF-000025', NULL, 'Msh4p', 163, NULL, NULL, 61087),
(61088, '1.25.10.10-FF-000257', NULL, 'Conidiophore development protein hymA', 333, NULL, NULL, 61088),
(61089, '1.10.510.10-FF-004056', NULL, NULL, 225, NULL, NULL, 61089),
(61090, '3.30.250.20-FF-000013', NULL, 'Uncharacterized protein', 44, NULL, NULL, 61090),
(61091, '3.30.60.20-FF-000083', NULL, 'Thymidine kinase', 47, NULL, NULL, 61091),
(61092, '3.40.50.880-FF-000052', NULL, 'ThiJ/pfpI family protein', 210, NULL, NULL, 61092),
(61093, '3.30.70.660-FF-000060', NULL, 'tRNA pseudouridine synthase', 95, NULL, NULL, 61093),
(61094, '3.40.50.300-FF-005510', NULL, 'Uncharacterized protein', 159, NULL, NULL, 61094),
(61095, '3.55.10.10-FF-000004', NULL, 'Zinc finger and BTB domain containing 8 opposite strand', 100, NULL, NULL, 61095),
(61096, '3.10.620.30-FF-000004', NULL, 'Peptidase (PNG1)', 200, NULL, NULL, 61096),
(61097, '1.20.1270.10-FF-000054', NULL, 'Chaperone protein DnaK', 85, NULL, NULL, 61097),
(61098, '3.40.20.10-FF-000122', NULL, 'Drebrin-like protein', 141, NULL, NULL, 61098),
(61099, '3.30.2160.10-FF-000008', NULL, 'Apoptosis-resistant E3 ubiquitin protein ligase 1', 83, NULL, NULL, 61099),
(61100, '3.10.580.10-FF-000202', NULL, 'CBS domain containing protein', 143, NULL, NULL, 61100),
(61101, '1.20.58.1220-FF-000001', NULL, 'Exocyst complex component EXO84B', 105, NULL, NULL, 61101),
(61102, '2.130.10.10-FF-005420', NULL, 'Serine threonine protein kinase, putative', 174, NULL, NULL, 61102),
(61103, '3.30.413.10-FF-000035', NULL, 'Precorrin-3B synthase', 64, NULL, NULL, 61103),
(61104, '2.60.40.3510-FF-000021', NULL, 'Delta-like protein', 161, NULL, NULL, 61104),
(61105, '2.30.30.40-FF-000067', NULL, 'Growth factor receptor-bound protein 2', 50, NULL, NULL, 61105),
(61106, '3.40.50.1000-FF-000093', NULL, 'NLI interacting factor-like phosphatase family protein', 182, NULL, NULL, 61106),
(61107, '2.10.25.10-FF-000867', NULL, 'Aggrecan a', 45, NULL, NULL, 61107),
(61108, '3.30.70.2740-FF-000010', NULL, 'FAD-binding oxidoreductase', 81, NULL, NULL, 61108),
(61109, '2.40.50.140-FF-000194', NULL, 'Programmed cell death 11', 83, NULL, NULL, 61109),
(61110, '3.90.70.10-FF-000409', NULL, 'Uncharacterized protein', 350, NULL, NULL, 61110),
(61111, '3.40.50.1950-FF-000006', NULL, 'Flavin prenyltransferase UbiX', 199, NULL, NULL, 61111),
(61112, '3.90.470.10-FF-000047', NULL, '60S ribosomal protein L17-2', 63, NULL, NULL, 61112),
(61113, '2.60.40.60-FF-000555', NULL, 'cadherin EGF LAG seven-pass G-type receptor 2 isoform X2', 103, NULL, NULL, 61113),
(61114, '2.60.40.10-FF-003082', NULL, 'CD226 antigen (Predicted), isoform CRA_a', 107, NULL, NULL, 61114),
(61115, '2.30.29.30-FF-000100', NULL, 'Rho GTPase activating protein 12', 122, NULL, NULL, 61115),
(61116, '2.40.110.10-FF-000086', NULL, 'Uncharacterized protein', 73, NULL, NULL, 61116),
(61117, '3.40.50.410-FF-000052', NULL, 'collagen alpha-2(VI) chain isoform X1', 201, NULL, NULL, 61117),
(61118, '3.40.50.2300-FF-000128', NULL, 'Glutamate ionotropic receptor NMDA type subunit 3A', 162, NULL, NULL, 61118),
(61119, '3.40.1380.20-FF-000059', NULL, 'Pyruvate kinase', 49, NULL, NULL, 61119),
(61120, '2.30.39.10-FF-000044', NULL, 'Alaserpin', 155, NULL, NULL, 61120),
(61121, '1.50.10.130-FF-000010', NULL, 'Ent-kaurene synthase-like 3', 176, NULL, NULL, 61121),
(61122, '1.25.40.10-FF-004699', NULL, 'Os06g0228900 protein', 99, NULL, NULL, 61122),
(61123, '1.20.120.160-FF-000004', NULL, 'Phosphotransferase RcsD', 93, NULL, NULL, 61123),
(61124, '3.30.160.60-FF-004492', NULL, NULL, 41, NULL, NULL, 61124),
(61125, '2.10.25.10-FF-000491', NULL, 'Laminin subunit alpha 4', 51, NULL, NULL, 61125),
(61126, '3.40.50.2300-FF-000584', NULL, 'Uncharacterized protein C30A5.10', 137, NULL, NULL, 61126),
(61127, '3.40.50.10190-FF-000212', NULL, 'Uncharacterized protein', 89, NULL, NULL, 61127);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(61128, '1.20.910.10-FF-000032', NULL, 'Aminopyrimidine aminohydrolase', 217, NULL, NULL, 61128),
(61129, '1.10.10.520-FF-000001', NULL, 'NEDD8-activating enzyme E1 catalytic subunit', 75, NULL, NULL, 61129),
(61130, '3.40.630.10-FF-000357', NULL, 'Uncharacterized protein', 160, NULL, NULL, 61130),
(61131, '3.40.50.2300-FF-000932', NULL, NULL, 187, NULL, NULL, 61131),
(61132, '1.25.40.10-FF-001973', NULL, 'Pentatricopeptide repeat-containing protein', 112, NULL, NULL, 61132),
(61133, '2.20.80.10-FF-000011', NULL, 'Vitellogenin-6', 297, NULL, NULL, 61133),
(61134, '3.30.160.60-FF-003328', NULL, 'Zn finger homeodomain 2', 54, NULL, NULL, 61134),
(61135, '1.10.510.10-FF-003999', NULL, NULL, 191, NULL, NULL, 61135),
(61136, '1.20.140.150-FF-000128', NULL, 'Chromosome 9, whole genome shotgun sequence', 221, NULL, NULL, 61136),
(61137, '2.40.50.140-FF-000047', NULL, 'tyrosine--tRNA ligase, cytoplasmic isoform X2', 164, NULL, NULL, 61137),
(61138, '3.40.50.2300-FF-001112', NULL, NULL, 129, NULL, NULL, 61138),
(61139, '1.20.58.390-FF-000068', NULL, 'zinc-activated ligand-gated ion channel', 161, NULL, NULL, 61139),
(61140, '3.30.2130.30-FF-000046', NULL, 'Uncharacterized protein', 121, NULL, NULL, 61140),
(61141, '3.30.40.10-FF-001944', NULL, 'Os02g0528000 protein', 67, NULL, NULL, 61141),
(61142, '1.10.555.10-FF-000062', NULL, 'Uncharacterized protein, isoform B', 225, NULL, NULL, 61142),
(61143, '2.60.120.200-FF-000181', NULL, 'Crumbs, isoform D', 180, NULL, NULL, 61143),
(61144, '3.40.50.1240-FF-000125', NULL, 'Phosphoglycerate mutase protein, putative', 185, NULL, NULL, 61144),
(61145, '1.10.10.10-FF-001173', NULL, 'Predicted protein', 114, NULL, NULL, 61145),
(61146, '3.40.50.12780-FF-000129', NULL, '2-succinylbenzoate--CoA ligase, chloroplastic/peroxisomal', 433, NULL, NULL, 61146),
(61147, '1.25.40.20-FF-000559', NULL, 'Mann-cup, isoform B', 189, NULL, NULL, 61147),
(61148, '1.10.533.10-FF-000045', NULL, 'Nucleotide-binding oligomerization domain-containing protein 2', 96, NULL, NULL, 61148),
(61149, '3.10.450.40-FF-000050', NULL, NULL, 77, NULL, NULL, 61149),
(61150, '2.70.130.10-FF-000081', NULL, NULL, 141, NULL, NULL, 61150),
(61151, '3.40.50.300-FF-003115', NULL, 'FHA domain-containing protein', 303, NULL, NULL, 61151),
(61152, '3.30.390.50-FF-000021', NULL, 'Xanthine dehydrogenase/oxidase', 121, NULL, NULL, 61152),
(61153, '2.130.10.10-FF-003076', NULL, 'WD repeat domain 18', 116, NULL, NULL, 61153),
(61154, '3.40.47.10-FF-000015', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase, mitochondrial', 152, NULL, NULL, 61154),
(61155, '3.40.525.10-FF-000034', NULL, 'IRA2p GTPase-activating protein', 114, NULL, NULL, 61155),
(61156, '3.40.50.2300-FF-000275', NULL, 'Transcriptional regulator, LacI family', 115, NULL, NULL, 61156),
(61157, '3.40.50.1820-FF-001159', NULL, 'Prolylcarboxypeptidase, putative', 280, NULL, NULL, 61157),
(61158, '1.20.1540.10-FF-000047', NULL, 'Rhomboid like 3', 141, NULL, NULL, 61158),
(61159, '1.10.8.60-FF-000102', NULL, 'Cell division control protein', 102, NULL, NULL, 61159),
(61160, '3.40.50.1000-FF-000654', NULL, NULL, 142, NULL, NULL, 61160),
(61161, '1.25.10.10-FF-000965', NULL, 'Serine/threonine-protein kinase TOR', 321, NULL, NULL, 61161),
(61162, '1.20.1250.20-FF-000168', NULL, 'Transporter, major facilitator family', 192, NULL, NULL, 61162),
(61163, '1.10.455.10-FF-000026', NULL, 'Uncharacterized protein', 81, NULL, NULL, 61163),
(61164, '3.30.497.10-FF-000144', NULL, 'Uncharacterized protein', 50, NULL, NULL, 61164),
(61165, '3.30.1240.10-FF-000043', NULL, 'HAD family hydrolase', 102, NULL, NULL, 61165),
(61166, '1.25.70.10-FF-000058', NULL, NULL, 227, NULL, NULL, 61166),
(61167, '3.10.400.10-FF-000010', NULL, NULL, 134, NULL, NULL, 61167),
(61168, '2.40.50.140-FF-001031', NULL, NULL, 145, NULL, NULL, 61168),
(61169, '2.120.10.80-FF-000051', NULL, 'Multiple epidermal growth factor-like domains protein 8', 202, NULL, NULL, 61169),
(61170, '2.60.40.150-FF-000459', NULL, 'Bud/polarization protein, putative', 142, NULL, NULL, 61170),
(61171, '1.10.10.440-FF-000089', NULL, 'Chromosome 9, whole genome shotgun sequence', 68, NULL, NULL, 61171);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(61172, '1.10.238.10-FF-001230', NULL, 'Uncharacterized protein', 106, NULL, NULL, 61172),
(61173, '1.10.8.10-FF-000020', NULL, 'NSFL1 (p97) cofactor (p47)', 44, NULL, NULL, 61173),
(61174, '3.30.160.60-FF-001400', NULL, 'Zinc finger X-linked protein ZXDB', 28, NULL, NULL, 61174),
(61175, '3.40.50.10260-FF-000020', NULL, 'NAD(P)H-hydrate epimerase isoform X2', 129, NULL, NULL, 61175),
(61176, '3.30.70.60-FF-000028', NULL, 'Elongation factor 1-delta', 65, NULL, NULL, 61176),
(61177, '1.20.1410.10-FF-000043', NULL, 'Predicted protein', 182, NULL, NULL, 61177),
(61178, '3.30.60.30-FF-000176', NULL, 'Uncharacterized protein', 60, NULL, NULL, 61178),
(61179, '3.30.70.3290-FF-000012', NULL, 'Polyketide synthase type I', 125, NULL, NULL, 61179),
(61180, '2.20.70.10-FF-000263', NULL, 'Predicted protein', 42, NULL, NULL, 61180),
(61181, '3.40.50.720-FF-000482', NULL, 'Alcohol dehydrogenase D', 140, NULL, NULL, 61181),
(61182, '1.10.10.10-FF-001482', NULL, 'Histone acetyltransferase', 49, NULL, NULL, 61182),
(61183, '3.60.21.10-FF-000264', NULL, 'Phosphoesterase ykuE', 183, NULL, NULL, 61183),
(61184, '1.20.58.60-FF-000465', NULL, 'Protein CBG15811', 232, NULL, NULL, 61184),
(61185, '1.10.10.60-FF-000428', NULL, 'Transcription factor MYB39', 69, NULL, NULL, 61185),
(61186, '2.120.10.30-FF-000497', NULL, 'Uncharacterized protein', 228, NULL, NULL, 61186),
(61187, '4.10.800.30-FF-000003', NULL, 'Essential meiotic structure-specific endonuclease 1', 102, NULL, NULL, 61187),
(61188, '2.60.40.790-FF-000095', NULL, '18.5 kDa class I heat shock protein', 130, NULL, NULL, 61188),
(61189, '3.30.40.10-FF-000635', NULL, 'E3 ubiquitin-protein ligase DZIP3 isoform X1', 82, NULL, NULL, 61189),
(61190, '1.10.400.10-FF-000091', NULL, 'Guanine nucleotide-binding protein alpha-4 subunit', 69, NULL, NULL, 61190),
(61191, '1.20.1070.10-FF-000073', NULL, 'Adhesion G-protein coupled receptor D1', 285, NULL, NULL, 61191),
(61192, '3.40.50.720-FF-000251', NULL, 'Sterol-4-alpha-carboxylate 3-dehydrogenase, decarboxylating', 342, NULL, NULL, 61192),
(61193, '2.130.10.10-FF-003531', NULL, 'F-box/wd-repeat protein lin-23', 94, NULL, NULL, 61193),
(61194, '2.60.40.10-FF-002946', NULL, 'Neuron-glia cell adhesion molecule (Ng-CAM)', 121, NULL, NULL, 61194),
(61195, '2.10.25.10-FF-001036', NULL, 'Distracted, isoform B', 39, NULL, NULL, 61195),
(61196, '3.30.730.10-FF-000013', NULL, 'AINTEGUMENTA-like 6', 89, NULL, NULL, 61196),
(61197, '2.60.40.2750-FF-000001', NULL, 'Heparin and heparin-sulfate lyase', 96, NULL, NULL, 61197),
(61198, '3.40.50.300-FF-001800', NULL, 'Rab family GTPase', 201, NULL, NULL, 61198),
(61199, '1.10.238.10-FF-000196', NULL, 'Mitochondrial substrate carrier family protein', 151, NULL, NULL, 61199),
(61200, '3.80.10.10-FF-004116', NULL, 'Uncharacterized protein', 116, NULL, NULL, 61200),
(61201, '1.10.472.10-FF-000240', NULL, 'Cyclin', 28, NULL, NULL, 61201),
(61202, '3.40.630.10-FF-000048', NULL, 'carboxypeptidase D isoform X1', 304, NULL, NULL, 61202),
(61203, '1.10.10.10-FF-001038', NULL, 'Transcriptional regulator, LysR family', 85, NULL, NULL, 61203),
(61204, '3.30.310.50-FF-000027', NULL, 'Uncharacterized protein', 112, NULL, NULL, 61204),
(61205, '3.20.20.70-FF-000843', NULL, NULL, 89, NULL, NULL, 61205),
(61206, '1.20.120.1750-FF-000044', NULL, 'RBR-type E3 ubiquitin transferase', 104, NULL, NULL, 61206),
(61207, '1.20.58.70-FF-000013', NULL, 'Syntaxin 132', 130, NULL, NULL, 61207),
(61208, '1.10.287.70-FF-000372', NULL, 'cGMP-gated cation channel alpha-1', 243, NULL, NULL, 61208),
(61209, '3.80.10.10-FF-003610', NULL, 'Uncharacterized protein', 183, NULL, NULL, 61209),
(61210, '1.25.40.10-FF-000085', NULL, 'Cell division cycle 27 homolog (S. cerevisiae)', 171, NULL, NULL, 61210),
(61211, '3.90.1800.10-FF-000016', NULL, 'DNA-directed RNA polymerase subunit beta', 106, NULL, NULL, 61211),
(61212, '2.10.25.10-FF-001564', NULL, 'Uncharacterized protein', 31, NULL, NULL, 61212),
(61213, '1.25.40.20-FF-001723', NULL, 'Uncharacterized protein', 228, NULL, NULL, 61213),
(61214, '1.20.1070.10-FF-001691', NULL, 'Vomeronasal type-1 receptor', 112, NULL, NULL, 61214); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(61215, '1.20.1560.10-FF-000138', NULL, 'Competence factor transporting ATP-binding protein/permease ComA', 314, NULL, NULL, 61215),
(61216, '3.40.50.300-FF-003346', NULL, 'HSR1 MMR1 domain containing protein, putative', 147, NULL, NULL, 61216),
(61217, '3.10.50.40-FF-000050', NULL, 'Peptidylprolyl isomerase', 115, NULL, NULL, 61217),
(61218, '3.40.50.1240-FF-000142', NULL, NULL, 200, NULL, NULL, 61218),
(61219, '2.60.40.1180-FF-000187', NULL, '4-alpha-glucanotransferase', 50, NULL, NULL, 61219),
(61220, '3.40.640.10-FF-000077', NULL, 'Spore coat polysaccharide biosynthesis protein spsC', 277, NULL, NULL, 61220),
(61221, '2.30.42.10-FF-000642', NULL, NULL, 51, NULL, NULL, 61221),
(61222, '2.60.120.200-FF-000742', NULL, 'Calnexin, putative', 148, NULL, NULL, 61222),
(61223, '1.10.12.70-FF-000003', NULL, 'Serine/threonine-protein kinase 25', 77, NULL, NULL, 61223),
(61224, '3.40.50.300-FF-008236', NULL, 'Uncharacterized protein', 57, NULL, NULL, 61224),
(61225, '3.40.50.300-FF-007617', NULL, 'Replication protein 1a', 150, NULL, NULL, 61225),
(61226, '1.10.510.10-FF-004511', NULL, NULL, 159, NULL, NULL, 61226),
(61227, '1.25.40.10-FF-001181', NULL, 'PPR containing plant-like protein', 142, NULL, NULL, 61227),
(61228, '3.10.20.70-FF-000017', NULL, 'Probable glutamine synthetase glnA3', 93, NULL, NULL, 61228),
(61229, '3.40.50.12470-FF-000025', NULL, NULL, 273, NULL, NULL, 61229),
(61230, '2.120.10.80-FF-000034', NULL, 'Attractin', 163, NULL, NULL, 61230),
(61231, '2.60.420.10-FF-000015', NULL, 'Cyclic beta-(1,2)-glucan synthase NdvB', 63, NULL, NULL, 61231),
(61232, '2.30.130.40-FF-000042', NULL, 'Uncharacterized protein', 67, NULL, NULL, 61232),
(61233, '3.30.310.10-FF-000066', NULL, 'AP complex subunit beta', 143, NULL, NULL, 61233),
(61234, '1.25.40.10-FF-000562', NULL, 'SNAP protein (Soluble N-ethylmaleimide-sensitive factor attachment protein)', 284, NULL, NULL, 61234),
(61235, '1.10.1040.10-FF-000051', NULL, 'Glycerol-3-phosphate dehydrogenase (NAD(+))', 161, NULL, NULL, 61235),
(61236, '2.60.120.650-FF-000158', NULL, 'Predicted protein', 256, NULL, NULL, 61236),
(61237, '2.10.50.30-FF-000010', NULL, 'Uncharacterized protein', 43, NULL, NULL, 61237),
(61238, '3.40.50.720-FF-001246', NULL, 'Oxidoreductase domain protein', 124, NULL, NULL, 61238),
(61239, '2.60.40.790-FF-000106', NULL, 'CS_domain/TPR_repeat/Tetratricopeptide_repeat_-_putative', 103, NULL, NULL, 61239),
(61240, '3.40.1690.20-FF-000021', NULL, 'Predicted protein', 103, NULL, NULL, 61240),
(61241, '1.10.1670.10-FF-000076', NULL, NULL, 133, NULL, NULL, 61241),
(61242, '1.25.40.570-FF-000006', NULL, 'COP9 signalosome complex subunit 2', 369, NULL, NULL, 61242),
(61243, '2.60.40.10-FF-001951', NULL, 'Beta-galactosidase, putative', 121, NULL, NULL, 61243),
(61244, '1.10.472.80-FF-000199', NULL, NULL, 139, NULL, NULL, 61244),
(61245, '2.130.10.10-FF-001822', NULL, 'F-box and WD-40 domain-containing protein MET30', 47, NULL, NULL, 61245),
(61246, '1.10.10.60-FF-001047', NULL, NULL, 63, NULL, NULL, 61246),
(61247, '3.30.420.40-FF-000690', NULL, 'YALI0F10923p', 308, NULL, NULL, 61247),
(61248, '3.20.20.80-FF-000161', NULL, 'Heparanase', 201, NULL, NULL, 61248),
(61249, '3.40.1380.10-FF-000039', NULL, 'Uncharacterized protein', 125, NULL, NULL, 61249),
(61250, '3.30.750.200-FF-000002', NULL, NULL, 114, NULL, NULL, 61250),
(61251, '1.25.40.20-FF-000998', NULL, 'Uncharacterized protein', 126, NULL, NULL, 61251),
(61252, '3.10.129.10-FF-000093', NULL, 'Acyl-coenzyme A thioesterase PaaI', 129, NULL, NULL, 61252),
(61253, '3.40.1110.10-FF-000469', NULL, NULL, 79, NULL, NULL, 61253),
(61254, '3.40.120.10-FF-000077', NULL, 'Uncharacterized protein', 86, NULL, NULL, 61254),
(61255, '3.40.190.10-FF-000132', NULL, 'Lipoprotein', 127, NULL, NULL, 61255),
(61256, '3.30.420.60-FF-000010', NULL, 'Pelo protein', 132, NULL, NULL, 61256),
(61257, '3.90.960.10-FF-000011', NULL, 'Proline--tRNA ligase', 143, NULL, NULL, 61257),
(61258, '3.30.70.330-FF-001798', NULL, NULL, 175, NULL, NULL, 61258),
(61259, '3.40.50.2000-FF-000831', NULL, 'Uncharacterized protein', 141, NULL, NULL, 61259);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(61260, '1.10.630.10-FF-000821', NULL, 'Uncharacterized protein', 239, NULL, NULL, 61260),
(61261, '3.10.590.10-FF-000012', NULL, '30-kDa cleavage and polyadenylation specificity factor 30', 157, NULL, NULL, 61261),
(61262, '1.20.1420.30-FF-000078', NULL, 'Uncharacterized protein', 150, NULL, NULL, 61262),
(61263, '1.10.10.350-FF-000034', NULL, NULL, 93, NULL, NULL, 61263),
(61264, '3.40.630.10-FF-000487', NULL, 'Uncharacterized protein', 74, NULL, NULL, 61264),
(61265, '3.30.160.60-FF-005240', NULL, NULL, 46, NULL, NULL, 61265),
(61266, '3.40.605.10-FF-000052', NULL, 'Aldehyde dehydrogenase', 273, NULL, NULL, 61266),
(61267, '3.10.110.10-FF-000364', NULL, 'RBR-type E3 ubiquitin transferase', 135, NULL, NULL, 61267),
(61268, '1.10.720.30-FF-000042', NULL, 'Os11g0483600 protein', 55, NULL, NULL, 61268),
(61269, '3.30.70.660-FF-000020', NULL, 'tRNA pseudouridine synthase', 143, NULL, NULL, 61269),
(61270, '1.10.510.10-FF-000329', NULL, 'Titin a', 236, NULL, NULL, 61270),
(61271, '2.180.10.10-FF-000016', NULL, 'Teneurin transmembrane protein 3', 384, NULL, NULL, 61271),
(61272, '3.40.50.300-FF-006999', NULL, 'Ras-related protein Rab6-like Protein', 211, NULL, NULL, 61272),
(61273, '1.10.10.10-FF-000532', NULL, 'Cell division control protein', 90, NULL, NULL, 61273),
(61274, '3.90.79.10-FF-000261', NULL, 'NUDIX domain hydrolase1', 121, NULL, NULL, 61274),
(61275, '2.60.34.10-FF-000060', NULL, 'Protein CBG07033', 181, NULL, NULL, 61275),
(61276, '1.10.510.10-FF-001419', NULL, '3-phosphoinositide-dependent protein kinase', 202, NULL, NULL, 61276),
(61277, '3.30.760.10-FF-000094', NULL, 'Uncharacterized protein', 65, NULL, NULL, 61277),
(61278, '2.30.30.1150-FF-000011', NULL, 'E3 ubiquitin ligase Np95, putative', 163, NULL, NULL, 61278),
(61279, '3.30.70.330-FF-001809', NULL, NULL, 120, NULL, NULL, 61279),
(61280, '3.30.1360.30-FF-000001', NULL, 'Aspartate--tRNA ligase', 150, NULL, NULL, 61280),
(61281, '1.20.5.170-FF-000042', NULL, 'Cyclic AMP-responsive element-binding protein 3-like protein 3', 50, NULL, NULL, 61281),
(61282, '3.30.200.20-FF-000622', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 101, NULL, NULL, 61282),
(61283, '2.30.30.30-FF-000081', NULL, '60S ribosomal protein L40, mitochondrial', 105, NULL, NULL, 61283),
(61284, '3.40.50.880-FF-000158', NULL, 'ES1 protein homolog, mitochondrial isoform X2', 63, NULL, NULL, 61284),
(61285, '2.130.10.10-FF-002912', NULL, 'Uncharacterized protein', 177, NULL, NULL, 61285),
(61286, '1.25.40.10-FF-002119', NULL, 'Predicted protein', 149, NULL, NULL, 61286),
(61287, '3.30.1490.420-FF-000001', NULL, 'Ubiquitin C-terminal hydrolase L3', 76, NULL, NULL, 61287),
(61288, '3.40.50.1820-FF-001524', NULL, 'Uncharacterized protein', 146, NULL, NULL, 61288),
(61289, '1.10.30.10-FF-000095', NULL, 'High mobility group protein-like tdp-1, putative', 92, NULL, NULL, 61289),
(61290, '3.90.1640.10-FF-000014', NULL, 'Uncharacterized protein', 128, NULL, NULL, 61290),
(61291, '1.10.150.20-FF-000023', NULL, 'DNA integrity scanning protein DisA', 62, NULL, NULL, 61291),
(61292, '1.20.5.170-FF-000238', NULL, 'AP-1-like transcription factor YAP5', 67, NULL, NULL, 61292),
(61293, '1.25.10.10-FF-001353', NULL, 'Maestro heat-like repeat family member 4', 263, NULL, NULL, 61293),
(61294, '3.40.1110.10-FF-000216', NULL, 'Putative P-type cation-transporting ATPase', 119, NULL, NULL, 61294),
(61295, '4.10.70.30-FF-000001', NULL, 'ADAM 17-like protease', 57, NULL, NULL, 61295),
(61296, '3.30.70.330-FF-001489', NULL, 'Putative RNA binding protein', 111, NULL, NULL, 61296),
(61297, '1.20.1250.20-FF-001573', NULL, 'Uncharacterized protein', 378, NULL, NULL, 61297),
(61298, '1.10.238.20-FF-000053', NULL, 'AGAP012323-PA', 87, NULL, NULL, 61298),
(61299, '3.90.470.20-FF-000038', NULL, '4-phosphopantetheinyl transferase', 55, NULL, NULL, 61299),
(61300, '2.130.10.10-FF-001603', NULL, 'Fritz, isoform D', 189, NULL, NULL, 61300),
(61301, '3.30.710.10-FF-000158', NULL, 'Ankyrin repeat and BTB/POZ domain-containing protein', 140, NULL, NULL, 61301);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(61302, '1.10.510.10-FF-002566', NULL, 'Mitosis inhibitor protein kinase SWE1', 261, NULL, NULL, 61302),
(61303, '3.30.70.120-FF-000027', NULL, NULL, 100, NULL, NULL, 61303),
(61304, '3.30.1370.10-FF-000182', NULL, 'KH domain containing 4, pre-mRNA splicing factor', 87, NULL, NULL, 61304),
(61305, '1.10.10.1590-FF-000007', NULL, 'NAD-reducing hydrogenase, alpha subunit', 69, NULL, NULL, 61305),
(61306, '1.20.58.190-FF-000002', NULL, 'Translin-associated factor X', 155, NULL, NULL, 61306),
(61307, '1.10.287.410-FF-000002', NULL, 'Carboxypeptidase', 70, NULL, NULL, 61307),
(61308, '3.30.70.330-FF-002523', NULL, NULL, 152, NULL, NULL, 61308),
(61309, '3.30.190.20-FF-000042', NULL, 'Ribosomal protein', 72, NULL, NULL, 61309),
(61310, '3.30.300.180-FF-000002', NULL, 'Chromosomal replication initiator protein DnaA', 82, NULL, NULL, 61310),
(61311, '1.10.238.10-FF-000516', NULL, 'Caltractin', 150, NULL, NULL, 61311),
(61312, '2.60.40.760-FF-000002', NULL, 'Beta-expansin 3', 103, NULL, NULL, 61312),
(61313, '3.90.550.10-FF-000093', NULL, 'Colanic acid biosynthesis glycosyltransferase WcaE', 223, NULL, NULL, 61313),
(61314, '2.40.50.140-FF-000839', NULL, NULL, 76, NULL, NULL, 61314),
(61315, '1.25.40.10-FF-001866', NULL, 'Paraflagellar rod component', 292, NULL, NULL, 61315),
(61316, '1.20.50.70-FF-000001', NULL, 'CD109 molecule', 30, NULL, NULL, 61316),
(61317, '3.60.21.10-FF-000348', NULL, 'Protein CBG05769', 353, NULL, NULL, 61317),
(61318, '1.10.275.40-FF-000021', NULL, 'Fanconi anemia group J protein homolog', 18, NULL, NULL, 61318),
(61319, '3.30.40.10-FF-001927', NULL, 'Ubiquitin-protein ligase CIP8', 70, NULL, NULL, 61319),
(61320, '1.10.472.170-FF-000004', NULL, 'Transcription initiation factor TFIIB, putative', 187, NULL, NULL, 61320),
(61321, '3.90.70.10-FF-000516', NULL, 'Uncharacterized protein', 263, NULL, NULL, 61321),
(61322, '3.30.559.10-FF-000036', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 69, NULL, NULL, 61322),
(61323, '2.60.15.10-FF-000010', NULL, 'ATP synthase epsilon chain', 126, NULL, NULL, 61323),
(61324, '3.40.190.10-FF-000790', NULL, 'Putative solute binding transport lipoprotein', 136, NULL, NULL, 61324),
(61325, '3.80.10.10-FF-001210', NULL, 'Toll receptor', 207, NULL, NULL, 61325),
(61326, '1.10.510.10-FF-002802', NULL, NULL, 189, NULL, NULL, 61326),
(61327, '2.30.29.30-FF-000920', NULL, '3-phosphoinositide-dependent protein kinase 1', 57, NULL, NULL, 61327),
(61328, '1.10.20.140-FF-000029', NULL, NULL, 34, NULL, NULL, 61328),
(61329, '2.60.40.60-FF-000994', NULL, 'Protein CBR-CDH-12', 91, NULL, NULL, 61329),
(61330, '3.80.10.10-FF-001137', NULL, 'F-box domain containing protein, expressed', 269, NULL, NULL, 61330),
(61331, '3.30.70.100-FF-000021', NULL, 'Monooxygenase ydhR', 101, NULL, NULL, 61331),
(61332, '3.20.190.10-FF-000013', NULL, 'Endonuclease VIII', 131, NULL, NULL, 61332),
(61333, '1.20.930.60-FF-000014', NULL, 'Uncharacterized protein', 136, NULL, NULL, 61333),
(61334, '2.60.40.10-FF-004172', NULL, NULL, 87, NULL, NULL, 61334),
(61335, '3.40.50.720-FF-000627', NULL, 'Saccharopine dehydrogenase [NAD(+), L-lysine-forming]', 92, NULL, NULL, 61335),
(61336, '3.20.70.20-FF-000005', NULL, 'Ribonucleoside-diphosphate reductase', 481, NULL, NULL, 61336),
(61337, '1.10.10.10-FF-001257', NULL, 'FYVE finger-containing phosphoinositide kinase, fyv1, putative', 124, NULL, NULL, 61337),
(61338, '1.10.1450.10-FF-000115', NULL, 'Tetraspanin', 95, NULL, NULL, 61338),
(61339, '3.90.550.50-FF-000054', NULL, 'Hexosyltransferase', 279, NULL, NULL, 61339),
(61340, '3.40.50.620-FF-000367', NULL, 'Phosphoadenosine phosphosulfate reductase', 218, NULL, NULL, 61340),
(61341, '2.30.29.30-FF-001393', NULL, 'Uncharacterized protein', 80, NULL, NULL, 61341),
(61342, '1.20.1250.20-FF-000713', NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', 313, NULL, NULL, 61342),
(61343, '2.60.40.10-FF-002570', NULL, 'Protein-tyrosine-phosphatase', 97, NULL, NULL, 61343),
(61344, '2.40.160.110-FF-000020', NULL, 'Uncharacterized protein', 190, NULL, NULL, 61344);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(61345, '3.40.1480.10-FF-000002', NULL, 'Glycerate kinase', 163, NULL, NULL, 61345),
(61346, '3.80.10.10-FF-001665', NULL, 'Predicted protein', 129, NULL, NULL, 61346),
(61347, '3.40.50.300-FF-000367', NULL, 'ABC transporter G family member 24', 243, NULL, NULL, 61347),
(61348, '3.30.1370.110-FF-000022', NULL, 'Smr (Small MutS Related) domain-containing protein', 101, NULL, NULL, 61348),
(61349, '3.40.50.2000-FF-000292', NULL, 'Glycosyltransferase GtfE', 221, NULL, NULL, 61349),
(61350, '3.40.50.1380-FF-000026', NULL, 'Carbamoyl-phosphate synthase large chain', 133, NULL, NULL, 61350),
(61351, '2.30.30.140-FF-000220', NULL, 'Enhanced RNAI (RNA interference)', 101, NULL, NULL, 61351),
(61352, '3.60.21.10-FF-000039', NULL, 'Serine/threonine-protein phosphatase', 342, NULL, NULL, 61352),
(61353, '2.60.120.200-FF-000377', NULL, 'Protein S', 207, NULL, NULL, 61353),
(61354, '3.30.160.60-FF-004817', NULL, NULL, 61, NULL, NULL, 61354),
(61355, '3.80.10.10-FF-004335', NULL, 'Uncharacterized protein', 193, NULL, NULL, 61355),
(61356, '3.90.226.10-FF-000255', NULL, 'Carboxyl-terminal protease', 228, NULL, NULL, 61356),
(61357, '3.30.40.10-FF-000854', NULL, 'Transcription factor BYE1', 79, NULL, NULL, 61357),
(61358, '3.30.70.330-FF-002214', NULL, NULL, 100, NULL, NULL, 61358),
(61359, '1.25.40.20-FF-001414', NULL, 'Oxysterol-binding protein homolog C2F12.05c', 93, NULL, NULL, 61359),
(61360, '1.25.40.10-FF-001501', NULL, 'Pentatricopeptide repeat-containing protein At2g37230', 138, NULL, NULL, 61360),
(61361, '2.10.25.10-FF-000417', NULL, 'neural-cadherin isoform X1', 40, NULL, NULL, 61361),
(61362, '3.90.190.10-FF-000121', NULL, 'Corkscrew, isoform D', 113, NULL, NULL, 61362),
(61363, '3.30.465.10-FF-000037', NULL, 'Magnesium and cobalt transporter', 92, NULL, NULL, 61363),
(61364, '1.10.472.130-FF-000043', NULL, 'Putative dynein heavy chain, cytosolic', 162, NULL, NULL, 61364),
(61365, '1.20.90.10-FF-000019', NULL, 'AGAP004730-PA', 140, NULL, NULL, 61365),
(61366, '3.30.420.80-FF-000016', NULL, 'Mitochondrial Ribosomal Protein, Small', 132, NULL, NULL, 61366),
(61367, '2.130.10.10-FF-002694', NULL, 'WD40-repeat-containing domain protein', 326, NULL, NULL, 61367),
(61368, '3.10.100.10-FF-000335', NULL, NULL, 81, NULL, NULL, 61368),
(61369, '3.30.1640.10-FF-000051', NULL, 'DNA helicase', 92, NULL, NULL, 61369),
(61370, '1.20.5.420-FF-000004', NULL, 'Chromosome partition protein MukB', 40, NULL, NULL, 61370),
(61371, '1.10.640.10-FF-000086', NULL, 'Oxidase/peroxidase, putative', 115, NULL, NULL, 61371),
(61372, '3.30.40.10-FF-002080', NULL, 'Uncharacterized protein', 86, NULL, NULL, 61372),
(61373, '1.20.5.110-FF-000030', NULL, 'syntaxin-51 isoform X2', 63, NULL, NULL, 61373),
(61374, '2.130.10.10-FF-003840', NULL, 'Uncharacterized protein', 293, NULL, NULL, 61374),
(61375, '3.80.10.10-FF-000064', NULL, 'Scribbled planar cell polarity protein', 97, NULL, NULL, 61375),
(61376, '1.10.8.60-FF-000208', NULL, 'DNA polymerase epsilon subunit', 68, NULL, NULL, 61376),
(61377, '3.40.1280.10-FF-000094', NULL, 'rRNA methyltransferase 1, mitochondrial', 159, NULL, NULL, 61377),
(61378, '3.40.50.620-FF-000906', NULL, 'Predicted protein', 57, NULL, NULL, 61378),
(61379, '3.40.710.10-FF-000105', NULL, 'Penicillin-binding protein, putative', 347, NULL, NULL, 61379),
(61380, '2.40.30.30-FF-000013', NULL, 'Riboflavin kinase', 169, NULL, NULL, 61380),
(61381, '2.40.50.90-FF-000190', NULL, 'Uncharacterized protein', 64, NULL, NULL, 61381),
(61382, '3.10.20.90-FF-000776', NULL, 'YALI0D16335p', 109, NULL, NULL, 61382),
(61383, '3.40.50.300-FF-004970', NULL, 'Uncharacterized protein', 178, NULL, NULL, 61383),
(61384, '3.50.50.60-FF-000071', NULL, 'apoptosis-inducing factor 3 isoform X2', 180, NULL, NULL, 61384),
(61385, '3.40.50.1000-FF-000177', NULL, 'Putative Alpha,alpha-trehalose phosphate synthase subunit Tps3', 159, NULL, NULL, 61385),
(61386, '2.60.40.10-FF-002238', NULL, 'Titin, tandem duplicate 1', 92, NULL, NULL, 61386),
(61387, '1.10.20.10-FF-000139', NULL, 'AaceriACL158Wp', 80, NULL, NULL, 61387),
(61388, '3.10.620.30-FF-000021', NULL, 'Transglutaminase-like superfamily protein', 164, NULL, NULL, 61388);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(61389, '2.20.70.10-FF-000185', NULL, 'Peptidyl-prolyl cis-trans isomerase', 46, NULL, NULL, 61389),
(61390, '3.30.710.10-FF-000231', NULL, 'Inhibitor of Bruton tyrosine kinase', 151, NULL, NULL, 61390),
(61391, '2.170.120.30-FF-000011', NULL, 'YbbR-like domain-containing protein', 97, NULL, NULL, 61391),
(61392, '3.40.50.300-FF-003037', NULL, 'Predicted protein', 240, NULL, NULL, 61392),
(61393, '1.10.490.160-FF-000004', NULL, 'Ryanodine receptor, isoform J', 165, NULL, NULL, 61393),
(61394, '1.20.870.10-FF-000005', NULL, 'Rap guanine nucleotide exchange factor 4', 161, NULL, NULL, 61394),
(61395, '3.40.50.2300-FF-000168', NULL, 'Penicillin-binding protein activator LpoA', 151, NULL, NULL, 61395),
(61396, '3.40.50.1000-FF-000885', NULL, NULL, 64, NULL, NULL, 61396),
(61397, '1.25.10.10-FF-000734', NULL, 'Ubiquitin ligase e3', 436, NULL, NULL, 61397),
(61398, '3.80.10.10-FF-000373', NULL, 'T-complex-associated testis-expressed protein 1', 164, NULL, NULL, 61398),
(61399, '3.80.10.10-FF-003716', NULL, 'Uncharacterized protein', 149, NULL, NULL, 61399),
(61400, '2.60.200.20-FF-000108', NULL, 'FHA domain containing protein', 131, NULL, NULL, 61400),
(61401, '3.30.160.60-FF-002783', NULL, 'Zinc finger and SCAN domain containing 4', 29, NULL, NULL, 61401),
(61402, '3.30.9.10-FF-000001', NULL, 'Glycerol-3-phosphate dehydrogenase', 156, NULL, NULL, 61402),
(61403, '3.30.420.40-FF-000471', NULL, 'Glucokinase', 162, NULL, NULL, 61403),
(61404, '3.30.160.60-FF-003401', NULL, 'LD15405p', 26, NULL, NULL, 61404),
(61405, '3.90.190.10-FF-000430', NULL, 'Uncharacterized protein', 75, NULL, NULL, 61405),
(61406, '3.20.110.10-FF-000019', NULL, 'Alpha-mannosidase', 199, NULL, NULL, 61406),
(61407, '3.30.540.10-FF-000089', NULL, 'Inositol-1-monophosphatase', 53, NULL, NULL, 61407),
(61408, '3.90.70.10-FF-000196', NULL, 'Clan CA, family C1, cathepsin B-like cysteine peptidase', 283, NULL, NULL, 61408),
(61409, '3.20.20.80-FF-000380', NULL, 'RE12027p', 357, NULL, NULL, 61409),
(61410, '3.40.33.10-FF-000062', NULL, 'Predicted extracellular protein', 139, NULL, NULL, 61410),
(61411, '3.30.70.1730-FF-000022', NULL, '50S ribosomal protein L10', 130, NULL, NULL, 61411),
(61412, '3.30.160.60-FF-000889', NULL, 'Zinc finger protein', 28, NULL, NULL, 61412),
(61413, '1.10.287.970-FF-000001', NULL, 'Aerobic respiration control sensor protein', 89, NULL, NULL, 61413),
(61414, '3.30.70.330-FF-000197', NULL, 'Scaffold attachment factor B2', 180, NULL, NULL, 61414),
(61415, '3.30.70.1230-FF-000198', NULL, 'Predicted protein', 223, NULL, NULL, 61415),
(61416, '3.40.50.720-FF-002516', NULL, 'Uncharacterized protein', 120, NULL, NULL, 61416),
(61417, '3.30.760.10-FF-000072', NULL, 'Uncharacterized protein', 135, NULL, NULL, 61417),
(61418, '3.40.50.1820-FF-000220', NULL, '4,5:9,10-diseco-3-hydroxy-5,9,17-trioxoandrosta-1(10),2-diene-4-oate hydrolase', 290, NULL, NULL, 61418),
(61419, '1.20.1260.30-FF-000003', NULL, 'Type I restriction-modification system, M subunit', 158, NULL, NULL, 61419),
(61420, '3.40.50.300-FF-002076', NULL, 'Ras-related protein rab-5', 199, NULL, NULL, 61420),
(61421, '2.130.10.10-FF-005785', NULL, 'Uncharacterized protein', 100, NULL, NULL, 61421),
(61422, '3.40.50.150-FF-000647', NULL, 'S-adenosyl-L-methionine-dependent methyltransferase', 264, NULL, NULL, 61422),
(61423, '1.50.40.10-FF-000493', NULL, 'Mitochondrial carrier protein, putative', 274, NULL, NULL, 61423),
(61424, '3.40.50.720-FF-002174', NULL, 'Uncharacterized protein', 65, NULL, NULL, 61424),
(61425, '2.60.40.10-FF-000681', NULL, 'Centrosomal protein of 192 kDa', 99, NULL, NULL, 61425),
(61426, '3.90.190.10-FF-000227', NULL, 'Protein tyrosine phosphatase, receptor type E', 162, NULL, NULL, 61426),
(61427, '2.60.40.10-FF-004368', NULL, NULL, 106, NULL, NULL, 61427),
(61428, '3.40.50.150-FF-001266', NULL, NULL, 229, NULL, NULL, 61428),
(61429, '1.25.10.10-FF-002842', NULL, 'Uncharacterized protein', 174, NULL, NULL, 61429),
(61430, '1.25.10.10-FF-002657', NULL, 'HEAT repeatcontaining protein', 103, NULL, NULL, 61430),
(61431, '2.130.10.10-FF-004695', NULL, 'Uncharacterized protein', 175, NULL, NULL, 61431);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(61432, '1.10.287.990-FF-000007', NULL, 'Superoxide dismutase', 63, NULL, NULL, 61432),
(61433, '3.40.50.920-FF-000007', NULL, 'Pyruvate:ferredoxin (Flavodoxin) oxidoreductase', 155, NULL, NULL, 61433),
(61434, '1.10.630.10-FF-000512', NULL, 'Os01g0700500 protein', 420, NULL, NULL, 61434),
(61435, '1.10.10.10-FF-000638', NULL, 'Transcriptional regulator PtsJ', 70, NULL, NULL, 61435),
(61436, '3.30.2350.20-FF-000043', NULL, NULL, 239, NULL, NULL, 61436),
(61437, '3.10.20.10-FF-000045', NULL, 'Predicted protein', 34, NULL, NULL, 61437),
(61438, '3.60.40.10-FF-000151', NULL, 'Phosphoserine phosphatase RsbP', 246, NULL, NULL, 61438),
(61439, '3.50.50.60-FF-000380', NULL, 'Chromosome 1, whole genome shotgun sequence', 142, NULL, NULL, 61439),
(61440, '3.40.640.10-FF-000313', NULL, 'Uncharacterized protein', 274, NULL, NULL, 61440),
(61441, '3.30.40.10-FF-000326', NULL, 'Bassoon presynaptic cytomatrix protein', 121, NULL, NULL, 61441),
(61442, '3.40.50.360-FF-000014', NULL, 'NADPH-dependent FMN reductase', 188, NULL, NULL, 61442),
(61443, '3.20.20.70-FF-000135', NULL, 'Pentafunctional AROM polypeptide', 257, NULL, NULL, 61443),
(61444, '3.40.470.10-FF-000030', NULL, NULL, 225, NULL, NULL, 61444),
(61445, '3.30.530.20-FF-000158', NULL, 'Uncharacterized protein', 147, NULL, NULL, 61445),
(61446, '1.20.120.980-FF-000047', NULL, 'Uncharacterized protein', 13, NULL, NULL, 61446),
(61447, '2.70.40.10-FF-000012', NULL, 'Deoxyuridine 5''-triphosphate nucleotidohydrolase', 131, NULL, NULL, 61447),
(61448, '3.50.50.60-FF-001341', NULL, 'Mercuric reductase', 117, NULL, NULL, 61448),
(61449, '2.130.10.10-FF-003312', NULL, 'Transducin family protein / WD-40 repeat family protein', 178, NULL, NULL, 61449),
(61450, '2.30.30.190-FF-000010', NULL, 'centrosome-associated protein 350 isoform X2', 86, NULL, NULL, 61450),
(61451, '3.30.50.10-FF-000141', NULL, 'AGAP012222-PA', 64, NULL, NULL, 61451),
(61452, '4.10.60.10-FF-000202', NULL, 'Uncharacterized protein', 56, NULL, NULL, 61452),
(61453, '3.30.160.60-FF-005346', NULL, NULL, 66, NULL, NULL, 61453),
(61454, '3.30.60.90-FF-000042', NULL, 'Uncharacterized protein', 53, NULL, NULL, 61454),
(61455, '2.80.10.50-FF-000196', NULL, 'Inositol 1,4,5-trisphosphate receptor, type 3', 89, NULL, NULL, 61455),
(61456, '1.20.1250.20-FF-000404', NULL, 'Monocarboxylate transporter 6-like Protein', 388, NULL, NULL, 61456),
(61457, '2.10.25.10-FF-001345', NULL, 'Notch receptor 3', 40, NULL, NULL, 61457),
(61458, '2.60.40.10-FF-005133', NULL, NULL, 122, NULL, NULL, 61458),
(61459, '3.30.870.10-FF-000063', NULL, 'Nuclease', 188, NULL, NULL, 61459),
(61460, '3.30.420.40-FF-001090', NULL, 'Uncharacterized protein', 93, NULL, NULL, 61460),
(61461, '1.25.40.10-FF-002827', NULL, 'Putative pentatricopeptide repeat-containing protein', 145, NULL, NULL, 61461),
(61462, '3.30.200.20-FF-001477', NULL, 'Non-specific serine/threonine protein kinase', 35, NULL, NULL, 61462),
(61463, '2.60.200.30-FF-000010', NULL, 'NAD kinase 2, mitochondrial', 150, NULL, NULL, 61463),
(61464, '2.120.10.30-FF-000188', NULL, 'AGAP010610-PA', 162, NULL, NULL, 61464),
(61465, '1.25.10.10-FF-001662', NULL, 'Uncharacterized protein', 335, NULL, NULL, 61465),
(61466, '3.30.70.330-FF-000652', NULL, 'Eukaryotic translation initiation factor 4B', 98, NULL, NULL, 61466),
(61467, '3.30.450.20-FF-000208', NULL, 'Periplasmic [Fe] hydrogenase', 109, NULL, NULL, 61467),
(61468, '3.90.25.10-FF-000013', NULL, 'UDP-glucuronate decarboxylase 1', 72, NULL, NULL, 61468),
(61469, '3.90.70.80-FF-000065', NULL, 'Cysteine proteinases superfamily protein', 36, NULL, NULL, 61469),
(61470, '1.25.40.10-FF-005211', NULL, 'Uncharacterized protein', 201, NULL, NULL, 61470),
(61471, '1.25.40.10-FF-003103', NULL, 'AGAP003265-PA', 154, NULL, NULL, 61471),
(61472, '3.90.830.10-FF-000002', NULL, 'Vacuolar protein sorting-associated protein 45', 115, NULL, NULL, 61472),
(61473, '3.30.470.30-FF-000072', NULL, 'Multifunctional non-homologous end joining protein LigD', 116, NULL, NULL, 61473),
(61474, '1.20.1070.10-FF-000382', NULL, 'Uncharacterized protein', 307, NULL, NULL, 61474);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(61475, '1.25.40.10-FF-002485', NULL, 'Os11g0109800 protein', 116, NULL, NULL, 61475),
(61476, '2.70.150.10-FF-000278', NULL, 'Putative phospholipid-transporting ATPase C6C3.06c', 149, NULL, NULL, 61476),
(61477, '3.30.9.10-FF-000130', NULL, 'Monooxygenase, putative', 98, NULL, NULL, 61477),
(61478, '3.30.200.20-FF-002191', NULL, 'Uncharacterized protein', 55, NULL, NULL, 61478),
(61479, '2.10.110.10-FF-000126', NULL, 'Chromosome 23, whole genome shotgun sequence', 91, NULL, NULL, 61479),
(61480, '3.40.50.300-FF-001328', NULL, 'Dynein heavy chain 6, axonemal', 232, NULL, NULL, 61480),
(61481, '1.25.40.420-FF-000012', NULL, 'BTB/POZ and TAZ domain-containing protein 2', 71, NULL, NULL, 61481),
(61482, '1.20.58.1030-FF-000039', NULL, 'Uncharacterized protein', 86, NULL, NULL, 61482),
(61483, '2.130.10.10-FF-001367', NULL, 'Dynein, cytoplasmic 1, intermediate chain 2b', 161, NULL, NULL, 61483),
(61484, '3.30.420.40-FF-000139', NULL, 'Chromatin remodeling complex subunit (Arp5)', 132, NULL, NULL, 61484),
(61485, '3.30.160.60-FF-001075', NULL, 'Zinc finger, C2H2-type/integrase, DNA-binding protein', 35, NULL, NULL, 61485),
(61486, '2.60.40.10-FF-001619', NULL, 'Beta-glucosidase', 125, NULL, NULL, 61486),
(61487, '1.25.40.10-FF-003974', NULL, 'Uncharacterized protein', 226, NULL, NULL, 61487),
(61488, '1.20.1250.20-FF-001882', NULL, 'Uncharacterized protein', 95, NULL, NULL, 61488),
(61489, '3.40.50.300-FF-002418', NULL, 'ABC transporter PMR5, putative', 328, NULL, NULL, 61489),
(61490, '1.10.10.10-FF-000785', NULL, 'Heat-inducible transcription repressor HrcA', 90, NULL, NULL, 61490),
(61491, '2.60.120.290-FF-000151', NULL, 'Metalloendopeptidase', 59, NULL, NULL, 61491),
(61492, '2.120.10.80-FF-000287', NULL, 'Uncharacterized protein', 229, NULL, NULL, 61492),
(61493, '2.60.40.10-FF-003188', NULL, 'GM14906', 110, NULL, NULL, 61493),
(61494, '1.10.1450.10-FF-000082', NULL, 'Tetraspanin', 106, NULL, NULL, 61494),
(61495, '3.40.50.20-FF-000060', NULL, 'Trifunctional purine biosynthetic protein adenosine-3', 81, NULL, NULL, 61495),
(61496, '2.60.40.820-FF-000031', NULL, 'Uncharacterized protein', 147, NULL, NULL, 61496),
(61497, '3.30.10.30-FF-000004', NULL, 'dual specificity tyrosine-phosphorylation-regulated kinase 2', 70, NULL, NULL, 61497),
(61498, '1.50.40.10-FF-000021', NULL, 'SFC1p Mitochondrial succinate-fumarate transporter', 298, NULL, NULL, 61498),
(61499, '3.40.50.80-FF-000162', NULL, 'NADH-cytochrome b5 reductase-like', 89, NULL, NULL, 61499),
(61500, '3.10.110.10-FF-000055', NULL, 'ubiquitin-conjugating enzyme E2 Q2 isoform X2', 107, NULL, NULL, 61500),
(61501, '3.30.70.270-FF-000010', NULL, 'DNA repair protein REV1', 73, NULL, NULL, 61501),
(61502, '1.20.1530.20-FF-000066', NULL, 'Cation/H(+) antiporter 7', 406, NULL, NULL, 61502),
(61503, '1.10.20.70-FF-000005', NULL, 'Pti1p', 39, NULL, NULL, 61503),
(61504, '3.80.10.10-FF-002626', NULL, 'Transmembrane receptors / ATP binding protein', 171, NULL, NULL, 61504),
(61505, '1.20.900.10-FF-000076', NULL, 'Uncharacterized protein', 73, NULL, NULL, 61505),
(61506, '2.30.40.10-FF-000132', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 64, NULL, NULL, 61506),
(61507, '3.30.200.20-FF-001786', NULL, 'Protein kinase C', 28, NULL, NULL, 61507),
(61508, '3.40.50.300-FF-006128', NULL, 'ABC transporter ATP-binding protein RamA', 236, NULL, NULL, 61508),
(61509, '1.25.40.10-FF-002670', NULL, 'Pentatricopeptide repeat-containing protein At2g15690, mitochondrial', 255, NULL, NULL, 61509),
(61510, '1.20.1050.10-FF-000274', NULL, 'Uncharacterized protein', 95, NULL, NULL, 61510),
(61511, '3.20.20.140-FF-000143', NULL, 'Ribonuclease P protein subunit p30, putative', 206, NULL, NULL, 61511),
(61512, '3.30.420.40-FF-000847', NULL, 'Actin-related protein 3', 41, NULL, NULL, 61512),
(61513, '2.30.29.110-FF-000006', NULL, 'Uncharacterized protein', 167, NULL, NULL, 61513),
(61514, '3.40.50.2300-FF-001657', NULL, NULL, 195, NULL, NULL, 61514),
(61515, '3.40.50.1980-FF-000021', NULL, 'Iron-uptake system-binding protein', 125, NULL, NULL, 61515),
(61516, '3.30.70.330-FF-000505', NULL, 'Splicing factor 3B subunit 4', 92, NULL, NULL, 61516);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(61517, '3.30.450.40-FF-000219', NULL, 'Phytochrome-like protein cph2', 202, NULL, NULL, 61517),
(61518, '3.40.190.10-FF-000587', NULL, 'ABC transporter substrate-binding protein', 83, NULL, NULL, 61518),
(61519, '3.30.70.360-FF-000048', NULL, 'Amidohydrolase family protein', 116, NULL, NULL, 61519),
(61520, '1.10.8.270-FF-000091', NULL, 'TBC domain containing protein', 99, NULL, NULL, 61520),
(61521, '2.10.110.10-FF-000273', NULL, 'Four and a half LIM domains protein 5', 33, NULL, NULL, 61521),
(61522, '2.60.120.10-FF-000161', NULL, 'Acireductone dioxygenase', 169, NULL, NULL, 61522),
(61523, '2.40.160.50-FF-000022', NULL, 'SAM50-like protein gop-3', 332, NULL, NULL, 61523),
(61524, '3.60.20.10-FF-000149', NULL, 'Proteasome subunit beta', 213, NULL, NULL, 61524),
(61525, '3.60.130.10-FF-000017', NULL, 'Putative clavaminic acid synthetase', 272, NULL, NULL, 61525),
(61526, '3.40.50.1820-FF-000434', NULL, 'Related to FSH3-putative serine hydrolase', 231, NULL, NULL, 61526),
(61527, '1.20.58.60-FF-000100', NULL, 'spectrin alpha chain, non-erythrocytic 1 isoform X1', 142, NULL, NULL, 61527),
(61528, '2.40.10.10-FF-000219', NULL, 'Uncharacterized protein', 138, NULL, NULL, 61528),
(61529, '3.40.50.2000-FF-000145', NULL, 'Probable glycosyl transferase', 191, NULL, NULL, 61529),
(61530, '3.40.50.1010-FF-000202', NULL, NULL, 94, NULL, NULL, 61530),
(61531, '4.10.410.10-FF-000001', NULL, 'Amyloid beta A4 protein', 72, NULL, NULL, 61531),
(61532, '2.60.40.10-FF-001642', NULL, 'Jitterbug, isoform C', 101, NULL, NULL, 61532),
(61533, '3.30.1140.32-FF-000009', NULL, '30S ribosomal protein S3', 104, NULL, NULL, 61533),
(61534, '1.20.140.10-FF-000012', NULL, 'Acyl-CoA dehydrogenase fadE12', 149, NULL, NULL, 61534),
(61535, '2.160.20.10-FF-000091', NULL, 'Possible serine/threonine kinase', 241, NULL, NULL, 61535),
(61536, '1.20.5.2700-FF-000001', NULL, 'NADH-quinone oxidoreductase, L subunit', 77, NULL, NULL, 61536),
(61537, '3.30.930.10-FF-000141', NULL, 'Histidine--tRNA ligase', 326, NULL, NULL, 61537),
(61538, '3.40.140.10-FF-000185', NULL, 'Eukaryotic translation initiation factor 3 subunit H', 253, NULL, NULL, 61538),
(61539, '1.10.510.10-FF-002908', NULL, NULL, 116, NULL, NULL, 61539),
(61540, '2.40.50.40-FF-000124', NULL, 'CHD gene family protein containing chromodomain, helicase domain, and DNA-binding domain', 93, NULL, NULL, 61540),
(61541, '3.40.50.300-FF-001457', NULL, 'Ras-related protein Rab-5B', 185, NULL, NULL, 61541),
(61542, '3.50.50.60-FF-001009', NULL, 'Uncharacterized protein', 144, NULL, NULL, 61542),
(61543, '3.30.160.60-FF-001294', NULL, 'Zinc finger protein 770', 28, NULL, NULL, 61543),
(61544, '2.60.120.40-FF-000046', NULL, 'Predicted protein', 153, NULL, NULL, 61544),
(61545, '3.40.1000.30-FF-000017', NULL, 'F-box protein 7', 157, NULL, NULL, 61545),
(61546, '3.40.50.300-FF-003801', NULL, 'Ras-related protein RabY', 201, NULL, NULL, 61546),
(61547, '3.60.10.10-FF-000014', NULL, 'Type I inositol polyphosphate 5-phosphatase 1', 104, NULL, NULL, 61547),
(61548, '3.40.50.720-FF-001555', NULL, 'HesA/MoeB/ThiF family protein', 252, NULL, NULL, 61548),
(61549, '1.20.5.340-FF-000115', NULL, 'Uncharacterized protein', 90, NULL, NULL, 61549),
(61550, '2.60.200.10-FF-000015', NULL, 'Interferon regulatory factor 7', 217, NULL, NULL, 61550),
(61551, '1.25.40.20-FF-000110', NULL, 'Mindbomb E3 ubiquitin protein ligase 2', 179, NULL, NULL, 61551),
(61552, '3.80.10.10-FF-003155', NULL, 'Uncharacterized protein', 289, NULL, NULL, 61552),
(61553, '2.130.10.10-FF-001058', NULL, 'Rho guanine nucleotide exchange factor (GEF) 10-like a', 302, NULL, NULL, 61553),
(61554, '1.20.58.400-FF-000015', NULL, 'Uncharacterized protein', 83, NULL, NULL, 61554),
(61555, '3.40.50.2300-FF-001348', NULL, NULL, 56, NULL, NULL, 61555),
(61556, '2.60.120.10-FF-000503', NULL, 'cAMP/cGMP-dependent 3'',5''-cAMP/cGMP phosphodiesterase B', 168, NULL, NULL, 61556),
(61557, '1.10.1070.11-FF-000093', NULL, 'Serine/threonine-protein kinase TOR', 208, NULL, NULL, 61557),
(61558, '1.20.120.20-FF-000002', NULL, 'Apolipoprotein E', 182, NULL, NULL, 61558); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(61559, '1.25.40.10-FF-002794', NULL, 'Intraflagellar transport protein 56 homolog', 227, NULL, NULL, 61559),
(61560, '3.30.1360.120-FF-000079', NULL, 'Uncharacterized protein', 109, NULL, NULL, 61560),
(61561, '1.10.472.10-FF-000583', NULL, 'Predicted protein', 43, NULL, NULL, 61561),
(61562, '2.40.30.10-FF-000327', NULL, 'NADPH--cytochrome P450 reductase', 99, NULL, NULL, 61562),
(61563, '1.10.630.10-FF-000057', NULL, 'Cytochrome P450 724B1', 439, NULL, NULL, 61563),
(61564, '3.30.70.860-FF-000001', NULL, 'UPF0234 protein YajQ', 66, NULL, NULL, 61564),
(61565, '1.20.5.460-FF-000005', NULL, 'Formate dehydrogenase subunit alpha', 27, NULL, NULL, 61565),
(61566, '2.60.40.2380-FF-000002', NULL, 'Lost Adherence Sensor, LadS', 150, NULL, NULL, 61566),
(61567, '3.90.1150.10-FF-000128', NULL, '5-aminolevulinic acid synthase', 116, NULL, NULL, 61567),
(61568, '3.30.830.10-FF-000285', NULL, 'Predicted protein', 173, NULL, NULL, 61568),
(61569, '3.40.50.80-FF-000015', NULL, 'NADPH oxidase 4', 171, NULL, NULL, 61569),
(61570, '2.60.40.420-FF-000119', NULL, 'Cytochrome c oxidase subunit 2', 139, NULL, NULL, 61570),
(61571, '3.60.10.10-FF-000323', NULL, 'Predicted protein', 265, NULL, NULL, 61571),
(61572, '1.20.1280.290-FF-000023', NULL, 'Cystinosin homolog', 115, NULL, NULL, 61572),
(61573, '2.40.10.10-FF-000680', NULL, NULL, 76, NULL, NULL, 61573),
(61574, '3.10.310.10-FF-000020', NULL, 'Phenazine biosynthesis-like domain-containing protein 1', 128, NULL, NULL, 61574),
(61575, '3.30.70.1350-FF-000020', NULL, 'Os03g0346800 protein', 87, NULL, NULL, 61575),
(61576, '2.130.10.10-FF-000439', NULL, 'SH3KBP1 binding protein 1', 332, NULL, NULL, 61576),
(61577, '3.30.470.20-FF-000007', NULL, 'Carbamoyl-phosphate synthase large chain', 285, NULL, NULL, 61577),
(61578, '3.10.280.10-FF-000022', NULL, 'Complement C1q binding protein', 147, NULL, NULL, 61578),
(61579, '3.40.190.10-FF-000896', NULL, 'Predicted protein', 87, NULL, NULL, 61579),
(61580, '1.20.1560.10-FF-000357', NULL, 'p-GlycoProtein related', 22, NULL, NULL, 61580),
(61581, '2.160.20.10-FF-000124', NULL, 'SPbeta prophage-derived uncharacterized protein YorA', 178, NULL, NULL, 61581),
(61582, '1.10.8.270-FF-000068', NULL, 'Tbc domain containing protein', 109, NULL, NULL, 61582),
(61583, '3.40.50.1000-FF-000632', NULL, NULL, 99, NULL, NULL, 61583),
(61584, '3.30.160.60-FF-006274', NULL, NULL, 54, NULL, NULL, 61584),
(61585, '2.60.40.150-FF-000370', NULL, 'Unc-13 homolog B', 79, NULL, NULL, 61585),
(61586, '2.60.40.10-FF-005661', NULL, NULL, 88, NULL, NULL, 61586),
(61587, '1.10.510.10-FF-002347', NULL, NULL, 198, NULL, NULL, 61587),
(61588, '2.30.29.30-FF-000465', NULL, 'Adaptin ear-binding coat-associated protein 2', 130, NULL, NULL, 61588),
(61589, '3.40.720.10-FF-000134', NULL, 'Iduronate-2-sulfatase', 426, NULL, NULL, 61589),
(61590, '2.40.50.40-FF-000091', NULL, 'C-C motif chemokine', 82, NULL, NULL, 61590),
(61591, '1.10.8.10-FF-000109', NULL, 'Ubiquitin-like protein DSK2', 46, NULL, NULL, 61591),
(61592, '3.40.50.300-FF-006460', NULL, 'Uncharacterized protein', 120, NULL, NULL, 61592),
(61593, '2.70.170.10-FF-000280', NULL, 'Uncharacterized protein', 75, NULL, NULL, 61593),
(61594, '3.60.15.10-FF-000204', NULL, 'Chromosome 9, whole genome shotgun sequence', 400, NULL, NULL, 61594),
(61595, '3.90.1150.10-FF-000494', NULL, 'Putative diaminobutyrate-pyruvate aminotransferase', 35, NULL, NULL, 61595),
(61596, '1.25.40.10-FF-002338', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 274, NULL, NULL, 61596),
(61597, '1.25.10.10-FF-002281', NULL, 'Uncharacterized protein', 333, NULL, NULL, 61597),
(61598, '3.20.20.80-FF-000014', NULL, 'Alpha,alpha-phosphotrehalase', 399, NULL, NULL, 61598),
(61599, '3.40.50.720-FF-001807', NULL, 'Predicted protein', 123, NULL, NULL, 61599),
(61600, '3.30.1550.10-FF-000021', NULL, 'Mitochondrial ribosomal protein L11', 65, NULL, NULL, 61600),
(61601, '3.40.390.10-FF-000243', NULL, NULL, 52, NULL, NULL, 61601),
(61602, '3.30.1680.10-FF-000025', NULL, 'Sema domain, transmembrane domain (TM), and cytoplasmic domain, (semaphorin) 6D, like', 63, NULL, NULL, 61602);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(61603, '1.10.472.10-FF-000436', NULL, 'Cya-1', 128, NULL, NULL, 61603),
(61604, '1.20.1050.10-FF-000060', NULL, 'Glutamate-tRNA ligase, putative', 72, NULL, NULL, 61604),
(61605, '2.60.40.10-FF-000990', NULL, 'Hemicentin 1', 93, NULL, NULL, 61605),
(61606, '3.40.640.10-FF-000442', NULL, 'Uncharacterized protein', 168, NULL, NULL, 61606),
(61607, '3.30.420.40-FF-000162', NULL, 'Transcriptional regulator, ROK family', 125, NULL, NULL, 61607),
(61608, '3.40.50.150-FF-000086', NULL, 'Demethylmenaquinone methyltransferase', 220, NULL, NULL, 61608),
(61609, '1.10.10.60-FF-000086', NULL, 'transcriptional-regulating factor 1 isoform X1', 63, NULL, NULL, 61609),
(61610, '1.10.510.10-FF-002038', NULL, 'CK1 family protein kinase', 291, NULL, NULL, 61610),
(61611, '3.40.50.720-FF-002207', NULL, 'Uncharacterized protein', 305, NULL, NULL, 61611),
(61612, '1.10.287.470-FF-000071', NULL, 'Multidrug efflux RND transporter periplasmic adaptor subunit MexX', 74, NULL, NULL, 61612),
(61613, '3.40.50.300-FF-001081', NULL, 'Spermatogenesis-associated protein 5-like protein 1', 196, NULL, NULL, 61613),
(61614, '2.60.40.10-FF-001390', NULL, 'Usherin', 86, NULL, NULL, 61614),
(61615, '1.10.3730.20-FF-000056', NULL, 'Permease', 121, NULL, NULL, 61615),
(61616, '3.40.50.300-FF-000940', NULL, 'Nucleotide-binding oligomerization domain-containing protein 2', 225, NULL, NULL, 61616),
(61617, '1.20.90.10-FF-000008', NULL, 'Phospholipase A(2)', 131, NULL, NULL, 61617),
(61618, '3.40.50.10190-FF-000201', NULL, 'DNA ligase 4', 70, NULL, NULL, 61618),
(61619, '1.10.3430.10-FF-000002', NULL, 'urea transporter 2', 364, NULL, NULL, 61619),
(61620, '1.10.510.40-FF-000001', NULL, 'Aerobactin siderophore biosynthesis protein iucC', 199, NULL, NULL, 61620),
(61621, '3.20.20.70-FF-000495', NULL, NULL, 154, NULL, NULL, 61621),
(61622, '2.60.40.10-FF-002710', NULL, 'Flagellar-associated_PapD-like/Zeta_toxin_-_putative', 105, NULL, NULL, 61622),
(61623, '4.10.640.10-FF-000041', NULL, 'Uncharacterized protein', 71, NULL, NULL, 61623),
(61624, '1.10.472.20-FF-000001', NULL, 'Cobalt-containing nitrile hydratase subunit beta', 126, NULL, NULL, 61624),
(61625, '3.40.50.1820-FF-001384', NULL, 'GPI inositol-deacylase', 220, NULL, NULL, 61625),
(61626, '1.20.5.340-FF-000087', NULL, 'Transcriptional repressor tup12', 91, NULL, NULL, 61626),
(61627, '1.20.50.20-FF-000003', NULL, 'DNA primase', 57, NULL, NULL, 61627),
(61628, '2.20.70.10-FF-000050', NULL, 'pre-mRNA-processing factor 40 homolog B isoform X1', 53, NULL, NULL, 61628),
(61629, '3.40.50.720-FF-000493', NULL, 'Glutathione-dependent formaldehyde dehydrogenase', 162, NULL, NULL, 61629),
(61630, '2.40.10.240-FF-000007', NULL, 'S-adenosylmethionine:tRNA ribosyltransferase-isomerase', 101, NULL, NULL, 61630),
(61631, '2.10.25.10-FF-000176', NULL, 'Selectin P', 38, NULL, NULL, 61631),
(61632, '1.10.510.10-FF-003752', NULL, NULL, 143, NULL, NULL, 61632),
(61633, '3.30.9.10-FF-000113', NULL, 'FAD/NAD(P)-binding oxidoreductase', 155, NULL, NULL, 61633),
(61634, '3.30.40.10-FF-001383', NULL, 'Myotubularin-related protein 6', 68, NULL, NULL, 61634),
(61635, '3.30.559.30-FF-000126', NULL, 'Plipastatin synthase subunit C', 274, NULL, NULL, 61635),
(61636, '1.10.2000.10-FF-000071', NULL, NULL, 110, NULL, NULL, 61636),
(61637, '1.10.630.10-FF-000052', NULL, 'Ent-kaurenoic acid oxidase', 454, NULL, NULL, 61637),
(61638, '3.30.160.70-FF-000004', NULL, 'Methylated-DNA--protein-cysteine methyltransferase', 70, NULL, NULL, 61638),
(61639, '2.130.10.10-FF-001053', NULL, 'Mitochondrial division protein 1', 153, NULL, NULL, 61639),
(61640, '2.160.20.10-FF-000248', NULL, 'Uncharacterized protein', 103, NULL, NULL, 61640),
(61641, '2.40.50.140-FF-000272', NULL, 'exosome complex component RRP40', 51, NULL, NULL, 61641),
(61642, '3.40.630.30-FF-000251', NULL, 'Ss-alanyl conjugating enzyme', 210, NULL, NULL, 61642),
(61643, '3.30.160.60-FF-005902', NULL, NULL, 46, NULL, NULL, 61643),
(61644, '2.60.40.10-FF-002598', NULL, 'Muscle M-line assembly protein unc-89-like Protein', 98, NULL, NULL, 61644),
(61645, '3.40.50.300-FF-005723', NULL, 'Chromosomal replication initiator protein DnaA', 161, NULL, NULL, 61645);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(61646, '3.90.550.10-FF-000761', NULL, 'Uncharacterized protein', 106, NULL, NULL, 61646),
(61647, '3.40.640.10-FF-000425', NULL, 'Aspartate aminotransferase', 247, NULL, NULL, 61647),
(61648, '3.40.50.2000-FF-001000', NULL, 'Granule-bound starch synthase 1 chloroplastic/amyloplastic', 24, NULL, NULL, 61648),
(61649, '2.10.110.10-FF-000351', NULL, 'Uncharacterized protein', 82, NULL, NULL, 61649),
(61650, '3.30.1520.10-FF-000109', NULL, 'Vacuolar protein sorting-associated protein 17', 133, NULL, NULL, 61650),
(61651, '3.40.50.1910-FF-000011', NULL, 'SNARE-interacting protein KEULE', 199, NULL, NULL, 61651),
(61652, '1.10.730.10-FF-000099', NULL, 'LD44376p', 21, NULL, NULL, 61652),
(61653, '2.130.10.10-FF-004812', NULL, 'Uncharacterized protein', 141, NULL, NULL, 61653),
(61654, '1.25.40.10-FF-003075', NULL, 'YALI0B00528p', 190, NULL, NULL, 61654),
(61655, '3.30.559.10-FF-000120', NULL, 'Novel protein similar to vertebrate carnitine acetyltransferase (CRAT)', 95, NULL, NULL, 61655),
(61656, '1.25.40.180-FF-000215', NULL, NULL, 170, NULL, NULL, 61656),
(61657, '1.10.1420.10-FF-000158', NULL, 'Uncharacterized protein', 82, NULL, NULL, 61657),
(61658, '1.20.1250.20-FF-000718', NULL, 'Multidrug MFS transporter', 194, NULL, NULL, 61658),
(61659, '2.60.40.10-FF-005453', NULL, NULL, 131, NULL, NULL, 61659),
(61660, '2.30.29.30-FF-001297', NULL, 'Uncharacterized protein', 84, NULL, NULL, 61660),
(61661, '1.25.10.10-FF-000504', NULL, 'Splicing factor 3B subunit 1, putative', 148, NULL, NULL, 61661),
(61662, '3.90.1640.10-FF-000003', NULL, 'Prune homolog 2 with BCH domain', 223, NULL, NULL, 61662),
(61663, '1.50.10.20-FF-000106', NULL, 'Geranylgeranyl transferase type-2 subunit beta', 298, NULL, NULL, 61663),
(61664, '2.60.40.10-FF-004947', NULL, NULL, 105, NULL, NULL, 61664),
(61665, '3.30.70.330-FF-002658', NULL, NULL, 171, NULL, NULL, 61665),
(61666, '1.20.1250.20-FF-002282', NULL, 'Uncharacterized protein', 87, NULL, NULL, 61666),
(61667, '1.10.8.1070-FF-000003', NULL, 'Ribulose bisphosphate carboxylase/oxygenase activase, chloroplastic', 63, NULL, NULL, 61667),
(61668, '1.20.1020.10-FF-000002', NULL, 'E1A binding protein p300', 100, NULL, NULL, 61668),
(61669, '1.10.533.10-FF-000253', NULL, 'Uncharacterized protein', 91, NULL, NULL, 61669),
(61670, '2.60.40.10-FF-001979', NULL, 'Myosin binding protein C, slow type', 54, NULL, NULL, 61670),
(61671, '3.10.20.90-FF-000220', NULL, 'Ubiquitin-like protein DskB', 74, NULL, NULL, 61671),
(61672, '1.10.150.50-FF-000116', NULL, 'Endonuclease III homolog', 76, NULL, NULL, 61672),
(61673, '2.60.210.10-FF-000061', NULL, NULL, 99, NULL, NULL, 61673),
(61674, '3.80.10.10-FF-000513', NULL, 'Leucine-rich repeat receptor protein kinase EMS1', 247, NULL, NULL, 61674),
(61675, '1.20.1280.160-FF-000001', NULL, 'Dynein heavy chain, cytoplasmic', 96, NULL, NULL, 61675),
(61676, '3.10.110.10-FF-000286', NULL, 'Ubiquitin-conjugating enzyme, putative', 114, NULL, NULL, 61676),
(61677, '1.10.10.10-FF-001381', NULL, 'Predicted protein', 83, NULL, NULL, 61677),
(61678, '3.30.559.10-FF-000019', NULL, 'Carnitine acetyl transferase', 78, NULL, NULL, 61678),
(61679, '3.90.470.20-FF-000033', NULL, 'Biosurfactant biosynthesis protein', 103, NULL, NULL, 61679),
(61680, '1.10.590.10-FF-000008', NULL, 'Uncharacterized protein', 72, NULL, NULL, 61680),
(61681, '2.40.50.360-FF-000006', NULL, 'RuvB-like helicase', 43, NULL, NULL, 61681),
(61682, '3.30.200.20-FF-002308', NULL, 'Uncharacterized protein', 64, NULL, NULL, 61682),
(61683, '1.20.58.60-FF-000780', NULL, 'Nesprin-1', 223, NULL, NULL, 61683),
(61684, '3.30.160.60-FF-001619', NULL, 'zinc finger protein 133 isoform X2', 27, NULL, NULL, 61684),
(61685, '2.30.30.30-FF-000070', NULL, '60S ribosomal protein L6', 82, NULL, NULL, 61685),
(61686, '3.40.190.10-FF-000901', NULL, 'Probable sensor/response regulator hybrid', 102, NULL, NULL, 61686),
(61687, '3.30.420.180-FF-000001', NULL, 'Cobalamin biosynthesis domain protein', 119, NULL, NULL, 61687),
(61688, '1.10.287.70-FF-000035', NULL, 'Potassium voltage-gated channel, subfamily H (Eag-related), member 1', 257, NULL, NULL, 61688);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(61689, '3.20.20.140-FF-000351', NULL, 'Uncharacterized protein', 315, NULL, NULL, 61689),
(61690, '3.30.70.120-FF-000004', NULL, 'Divalent-cation tolerance protein CutA', 113, NULL, NULL, 61690),
(61691, '2.40.160.110-FF-000003', NULL, 'ATPase H+ transporting accessory protein 1', 168, NULL, NULL, 61691),
(61692, '3.50.50.60-FF-000852', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 60, NULL, NULL, 61692),
(61693, '3.10.330.20-FF-000024', NULL, 'tRNA (adenine(58)-N(1))-methyltransferase', 63, NULL, NULL, 61693),
(61694, '2.70.150.10-FF-000065', NULL, 'HAD ATPase, P-type, family IC', 190, NULL, NULL, 61694),
(61695, '2.40.180.10-FF-000040', NULL, 'Uncharacterized protein', 113, NULL, NULL, 61695),
(61696, '3.90.70.10-FF-000853', NULL, 'Uncharacterized protein', 109, NULL, NULL, 61696),
(61697, '3.60.110.10-FF-000010', NULL, 'Carbon-nitrogen hydrolase', 292, NULL, NULL, 61697),
(61698, '2.60.40.150-FF-000358', NULL, 'Rab-11 Family Interacting-Protein', 145, NULL, NULL, 61698),
(61699, '3.40.630.180-FF-000001', NULL, 'Uncharacterized protein', 126, NULL, NULL, 61699),
(61700, '2.20.25.10-FF-000086', NULL, 'Putative Trm112 family protein', 125, NULL, NULL, 61700),
(61701, '3.40.50.300-FF-007168', NULL, 'Small GTP-binding protein, putative', 174, NULL, NULL, 61701),
(61702, '1.25.40.10-FF-001630', NULL, 'Pentatricopeptide repeat-containing protein At5g43790', 160, NULL, NULL, 61702),
(61703, '3.40.640.10-FF-000330', NULL, 'Aromatic-amino-acid transaminase, hypothetical (Eurofung)', 271, NULL, NULL, 61703),
(61704, '1.20.120.1200-FF-000019', NULL, 'NADH-quinone oxidoreductase subunit J', 163, NULL, NULL, 61704),
(61705, '3.30.450.20-FF-000332', NULL, 'Sensory transduction histidine kinase', 131, NULL, NULL, 61705),
(61706, '2.60.40.640-FF-000073', NULL, 'Uncharacterized protein', 95, NULL, NULL, 61706),
(61707, '3.30.200.20-FF-002522', NULL, 'SRSF protein kinase 3', 88, NULL, NULL, 61707),
(61708, '2.60.40.10-FF-006072', NULL, NULL, 93, NULL, NULL, 61708),
(61709, '3.40.50.1110-FF-000002', NULL, 'isoamyl acetate-hydrolyzing esterase 1 homolog', 234, NULL, NULL, 61709),
(61710, '3.30.1330.90-FF-000023', NULL, 'D-3-phosphoglycerate dehydrogenase', 133, NULL, NULL, 61710),
(61711, '1.10.510.10-FF-001414', NULL, 'Probable inactive receptor-like kinase BSK12', 180, NULL, NULL, 61711),
(61712, '3.30.420.40-FF-000611', NULL, 'Chaperone protein dnaK', 195, NULL, NULL, 61712),
(61713, '2.130.10.10-FF-005105', NULL, 'Uncharacterized protein', 249, NULL, NULL, 61713),
(61714, '2.130.10.10-FF-005217', NULL, 'WD repeat-containing protein 91 homolog', 82, NULL, NULL, 61714),
(61715, '3.30.160.60-FF-002917', NULL, 'Zinc finger protein 324', 28, NULL, NULL, 61715),
(61716, '2.40.340.10-FF-000024', NULL, NULL, 67, NULL, NULL, 61716),
(61717, '3.40.50.720-FF-000279', NULL, '7-alpha-hydroxysteroid dehydrogenase', 255, NULL, NULL, 61717),
(61718, '1.25.10.10-FF-003247', NULL, 'Serine/threonine-protein kinase TOR', 230, NULL, NULL, 61718),
(61719, '3.30.1330.40-FF-000053', NULL, 'Uncharacterized protein', 123, NULL, NULL, 61719),
(61720, '2.10.90.10-FF-000023', NULL, 'Platelet-derived growth factor subunit B', 167, NULL, NULL, 61720),
(61721, '2.40.30.10-FF-000338', NULL, 'Uncharacterized protein', 97, NULL, NULL, 61721),
(61722, '2.10.25.10-FF-000968', NULL, 'Uncharacterized protein', 40, NULL, NULL, 61722),
(61723, '3.40.50.720-FF-001802', NULL, 'Uncharacterized protein', 134, NULL, NULL, 61723),
(61724, '4.10.60.10-FF-000073', NULL, 'Msl5p', 58, NULL, NULL, 61724),
(61725, '1.20.1070.10-FF-000151', NULL, 'olfactory receptor 10K1-like', 290, NULL, NULL, 61725),
(61726, '1.10.287.1060-FF-000018', NULL, 'Conserved oligomeric Golgi complex subunit 4', 86, NULL, NULL, 61726),
(61727, '3.40.50.80-FF-000240', NULL, 'Uncharacterized protein', 184, NULL, NULL, 61727),
(61728, '3.40.1190.20-FF-000005', NULL, 'Probable fructokinase-2', 320, NULL, NULL, 61728),
(61729, '1.10.260.30-FF-000001', NULL, 'Signal recognition particle protein', 124, NULL, NULL, 61729),
(61730, '3.30.1370.10-FF-000052', NULL, 'Kep1, isoform A', 185, NULL, NULL, 61730);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(61731, '3.30.70.270-FF-000021', NULL, 'Genome polyprotein', 81, NULL, NULL, 61731),
(61732, '3.40.50.620-FF-000137', NULL, 'Isoleucyl-tRNA synthetase 2, mitochondrial', 160, NULL, NULL, 61732),
(61733, '2.130.10.10-FF-000434', NULL, 'Aladin isoform A', 228, NULL, NULL, 61733),
(61734, '1.20.5.730-FF-000013', NULL, 'Uncharacterized protein', 58, NULL, NULL, 61734),
(61735, '2.60.40.790-FF-000090', NULL, 'uncharacterized protein CG16817', 124, NULL, NULL, 61735),
(61736, '3.40.50.300-FF-007640', NULL, 'Os11g0648500 protein', 140, NULL, NULL, 61736),
(61737, '1.20.1270.60-FF-000153', NULL, 'Uncharacterized protein', 227, NULL, NULL, 61737),
(61738, '3.30.160.60-FF-004481', NULL, NULL, 24, NULL, NULL, 61738),
(61739, '2.30.42.10-FF-000647', NULL, NULL, 99, NULL, NULL, 61739),
(61740, '2.60.260.20-FF-000112', NULL, 'DNAJB1 isoform 10', 40, NULL, NULL, 61740),
(61741, '3.40.50.11210-FF-000007', NULL, 'Tuberous sclerosis 2', 193, NULL, NULL, 61741),
(61742, '1.10.10.60-FF-000423', NULL, 'Slingshot protein phosphatase 1a', 63, NULL, NULL, 61742),
(61743, '1.10.150.20-FF-000332', NULL, 'Uncharacterized protein', 109, NULL, NULL, 61743),
(61744, '1.25.40.10-FF-001158', NULL, 'Pentatricopeptide repeat-containing protein At4g18840', 70, NULL, NULL, 61744),
(61745, '2.60.40.10-FF-004508', NULL, NULL, 101, NULL, NULL, 61745),
(61746, '3.30.160.60-FF-004593', NULL, NULL, 69, NULL, NULL, 61746),
(61747, '3.80.10.10-FF-003470', NULL, 'Predicted protein', 218, NULL, NULL, 61747),
(61748, '1.20.1250.20-FF-001449', NULL, 'Transporter, putative', 245, NULL, NULL, 61748),
(61749, '1.20.120.1920-FF-000011', NULL, 'Uncharacterized protein', 90, NULL, NULL, 61749),
(61750, '1.10.10.60-FF-000878', NULL, NULL, 74, NULL, NULL, 61750),
(61751, '1.20.5.170-FF-000025', NULL, 'nuclear factor interleukin-3-regulated protein-like', 73, NULL, NULL, 61751),
(61752, '1.20.120.420-FF-000026', NULL, 'Uncharacterized protein', 105, NULL, NULL, 61752),
(61753, '3.20.20.80-FF-000705', NULL, 'Endoglycoceramidase', 334, NULL, NULL, 61753),
(61754, '3.40.50.300-FF-001345', NULL, 'Related to ABC transporter', 261, NULL, NULL, 61754),
(61755, '3.30.1490.120-FF-000001', NULL, 'DNA-directed RNA polymerase II subunit RPB7', 79, NULL, NULL, 61755),
(61756, '1.10.357.10-FF-000040', NULL, 'TetR family transcriptional regulator', 199, NULL, NULL, 61756),
(61757, '1.10.510.10-FF-001869', NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', 317, NULL, NULL, 61757),
(61758, '3.30.420.10-FF-000164', NULL, 'DNA-directed DNA polymerase', 232, NULL, NULL, 61758),
(61759, '1.10.443.10-FF-000015', NULL, 'Prophage integrase IntF', 189, NULL, NULL, 61759),
(61760, '1.25.40.10-FF-003979', NULL, 'Uncharacterized protein', 221, NULL, NULL, 61760),
(61761, '1.10.8.80-FF-000001', NULL, 'Mg-protoporphyrin IX chelatase', 87, NULL, NULL, 61761),
(61762, '2.30.29.30-FF-001185', NULL, 'Uncharacterized PH domain-containing protein PB16A4.02c', 110, NULL, NULL, 61762),
(61763, '3.30.450.40-FF-000208', NULL, 'PAS sensor protein', 163, NULL, NULL, 61763),
(61764, '1.20.120.1750-FF-000049', NULL, 'Probable E3 ubiquitin-protein ligase ARI15', 246, NULL, NULL, 61764),
(61765, '3.40.190.10-FF-000582', NULL, 'Nickel ABC transporter, nickel/metallophore periplasmic binding protein', 214, NULL, NULL, 61765),
(61766, '3.30.60.30-FF-000187', NULL, 'cDNA FLJ59287, highly similar to Serine protease inhibitor Kazal-type 5', 33, NULL, NULL, 61766),
(61767, '1.25.40.820-FF-000008', NULL, 'putative RNA polymerase II subunit B1 CTD phosphatase RPAP2 homolog', 139, NULL, NULL, 61767),
(61768, '3.30.70.20-FF-000123', NULL, NULL, 62, NULL, NULL, 61768),
(61769, '2.10.109.10-FF-000073', NULL, 'Mitochondrial inner membrane protease subunit', 110, NULL, NULL, 61769),
(61770, '1.25.40.20-FF-001066', NULL, 'Uncharacterized protein', 149, NULL, NULL, 61770),
(61771, '1.25.40.10-FF-005003', NULL, 'Uncharacterized protein', 124, NULL, NULL, 61771),
(61772, '1.10.1140.10-FF-000013', NULL, 'ATP synthase subunit beta', 119, NULL, NULL, 61772),
(61773, '1.10.1410.10-FF-000091', NULL, 'U3 small nucleolar RNA-associated protein 22', 184, NULL, NULL, 61773);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(61774, '3.40.50.10470-FF-000066', NULL, 'Initiation factor 2 subunit family protein', 203, NULL, NULL, 61774),
(61775, '1.25.40.10-FF-000118', NULL, 'Lipopolysaccharide assembly protein B', 158, NULL, NULL, 61775),
(61776, '3.30.70.330-FF-000860', NULL, 'Heterogeneous nuclear ribonucleoprotein A1', 127, NULL, NULL, 61776),
(61777, '2.70.170.10-FF-000291', NULL, 'Uncharacterized protein', 199, NULL, NULL, 61777),
(61778, '4.10.800.10-FF-000025', NULL, 'Insulin-like growth factor binding protein 3', 55, NULL, NULL, 61778),
(61779, '3.40.50.300-FF-000709', NULL, 'Iron-sulfur protein NUBPL isoform X1', 259, NULL, NULL, 61779),
(61780, '1.10.238.10-FF-000876', NULL, 'Serine/threonine-protein phosphatase', 193, NULL, NULL, 61780),
(61781, '1.10.10.10-FF-000762', NULL, 'RPS19 isoform 5', 70, NULL, NULL, 61781),
(61782, '1.25.40.10-FF-000332', NULL, 'Putative tpr repeat-containing protein', 91, NULL, NULL, 61782),
(61783, '1.25.10.10-FF-002758', NULL, 'Coatomer subunit beta', 627, NULL, NULL, 61783),
(61784, '2.10.70.10-FF-000140', NULL, 'Sushi domain-containing protein 4', 55, NULL, NULL, 61784),
(61785, '3.40.50.300-FF-005370', NULL, 'Primosomal protein N''', 173, NULL, NULL, 61785),
(61786, '3.10.450.320-FF-000008', NULL, 'Mitochondrial import inner membrane translocase subunit TIM21', 122, NULL, NULL, 61786),
(61787, '3.40.50.620-FF-000007', NULL, 'Glutamate--tRNA ligase', 317, NULL, NULL, 61787),
(61788, '3.40.250.10-FF-000047', NULL, 'Rhodanese-like domain-containing protein 10', 145, NULL, NULL, 61788),
(61789, '3.40.50.300-FF-008466', NULL, 'Uncharacterized protein', 246, NULL, NULL, 61789),
(61790, '2.60.40.10-FF-000670', NULL, 'Myomesin 2', 99, NULL, NULL, 61790),
(61791, '3.30.40.10-FF-000085', NULL, 'E3 ubiquitin-protein ligase MIB1 isoform X1', 49, NULL, NULL, 61791),
(61792, '1.20.140.10-FF-000023', NULL, 'Acyl-CoA dehydrogenase family member 9', 124, NULL, NULL, 61792),
(61793, '3.30.450.20-FF-000202', NULL, 'Voltage-dependent calcium channel unc-36', 180, NULL, NULL, 61793),
(61794, '1.25.10.10-FF-001561', NULL, 'Importin beta-like SAD2', 128, NULL, NULL, 61794),
(61795, '1.20.1070.10-FF-000522', NULL, 'Muscarinic acetylcholine receptor', 146, NULL, NULL, 61795),
(61796, '3.40.50.2000-FF-000044', NULL, 'Sulfoquinovosyl transferase SQD2', 196, NULL, NULL, 61796),
(61797, '1.10.418.10-FF-000053', NULL, 'nesprin-2 isoform X3', 128, NULL, NULL, 61797),
(61798, '2.60.110.10-FF-000008', NULL, 'Osmotin-like protein', 186, NULL, NULL, 61798),
(61799, '1.20.930.40-FF-000036', NULL, 'Uncharacterized protein', 87, NULL, NULL, 61799),
(61800, '3.40.50.410-FF-000181', NULL, 'Uncharacterized protein', 76, NULL, NULL, 61800),
(61801, '1.20.58.830-FF-000037', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 128, NULL, NULL, 61801),
(61802, '1.20.140.100-FF-000029', NULL, 'Dynein gamma chain, flagellar outer arm', 154, NULL, NULL, 61802),
(61803, '3.90.215.10-FF-000011', NULL, 'Intelectin 1', 118, NULL, NULL, 61803),
(61804, '3.40.50.1820-FF-000439', NULL, 'Non-ribosomal peptide synthetase OfaC', 279, NULL, NULL, 61804),
(61805, '3.50.50.60-FF-000964', NULL, 'Uncharacterized protein', 156, NULL, NULL, 61805),
(61806, '3.40.50.2300-FF-000353', NULL, 'Branched-chain amino acid ABC transporter substrate-binding protein', 142, NULL, NULL, 61806),
(61807, '3.30.70.920-FF-000031', NULL, 'AsnC family transcriptional regulator', 84, NULL, NULL, 61807),
(61808, '2.40.160.50-FF-000039', NULL, 'AGR392Cp', 333, NULL, NULL, 61808),
(61809, '3.30.160.60-FF-006279', NULL, NULL, 51, NULL, NULL, 61809),
(61810, '1.10.238.10-FF-000084', NULL, 'ralBP1-associated Eps domain-containing protein 1 isoform X2', 100, NULL, NULL, 61810),
(61811, '1.25.40.10-FF-002586', NULL, 'Pentatricopeptide repeat-containing protein At2g44880', 93, NULL, NULL, 61811),
(61812, '3.40.50.300-FF-003806', NULL, 'Ras homolog family member Q', 60, NULL, NULL, 61812),
(61813, '2.60.120.200-FF-000034', NULL, 'pikachurin isoform X1', 179, NULL, NULL, 61813),
(61814, '3.30.70.330-FF-002203', NULL, NULL, 107, NULL, NULL, 61814),
(61815, '3.80.10.10-FF-000968', NULL, 'Receptor-like protein 6', 349, NULL, NULL, 61815);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(61816, '2.60.40.10-FF-001187', NULL, 'immunoglobulin superfamily member 10', 97, NULL, NULL, 61816),
(61817, '3.40.47.10-FF-000240', NULL, NULL, 46, NULL, NULL, 61817),
(61818, '3.30.160.60-FF-001507', NULL, 'Zinc finger and BTB domain containing 12', 44, NULL, NULL, 61818),
(61819, '1.10.287.1080-FF-000013', NULL, 'Nucleotide pyrophosphohydrolase', 110, NULL, NULL, 61819),
(61820, '2.60.40.10-FF-004964', NULL, NULL, 87, NULL, NULL, 61820),
(61821, '3.30.40.10-FF-000747', NULL, 'Histone deacetylase complex subunit, putative', 78, NULL, NULL, 61821),
(61822, '2.30.30.100-FF-000034', NULL, 'sm-like protein LSM7', 92, NULL, NULL, 61822),
(61823, '3.30.200.20-FF-000482', NULL, 'probable serine/threonine-protein kinase PBL7', 117, NULL, NULL, 61823),
(61824, '1.20.120.1080-FF-000051', NULL, 'ATP-dependent RNA helicase, putative', 95, NULL, NULL, 61824),
(61825, '3.40.390.10-FF-000119', NULL, 'Calmodulin-sensitive adenylate cyclase', 228, NULL, NULL, 61825),
(61826, '3.30.200.20-FF-000061', NULL, 'Dual specificity protein kinase CLK2', 110, NULL, NULL, 61826),
(61827, '1.25.40.800-FF-000002', NULL, 'CCR4-Not complex component, Not1', 220, NULL, NULL, 61827),
(61828, '2.60.40.60-FF-000786', NULL, 'Cadherin 13, H-cadherin (heart)', 76, NULL, NULL, 61828),
(61829, '3.40.1380.20-FF-000031', NULL, 'Pyruvate kinase', 149, NULL, NULL, 61829),
(61830, '3.30.2300.10-FF-000003', NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', 87, NULL, NULL, 61830),
(61831, '1.25.10.10-FF-001802', NULL, 'RING-type E3 ubiquitin transferase', 87, NULL, NULL, 61831),
(61832, '2.130.10.10-FF-004700', NULL, 'Predicted protein', 174, NULL, NULL, 61832),
(61833, '3.60.15.10-FF-000087', NULL, 'MBL fold metallo-hydrolase', 251, NULL, NULL, 61833),
(61834, '1.10.238.180-FF-000002', NULL, 'Stromal interaction molecule 2', 45, NULL, NULL, 61834),
(61835, '3.30.40.10-FF-001023', NULL, 'E3 ubiquitin-protein ligase ORTHRUS 2', 71, NULL, NULL, 61835),
(61836, '1.10.486.10-FF-000053', NULL, 'RecBCD enzyme subunit RecB', 163, NULL, NULL, 61836),
(61837, '1.25.10.10-FF-002421', NULL, 'ARM repeat superfamily protein', 248, NULL, NULL, 61837),
(61838, '3.90.45.10-FF-000008', NULL, 'Peptide deformylase', 174, NULL, NULL, 61838),
(61839, '1.20.80.10-FF-000053', NULL, 'Putative acyl-CoA binding protein', 101, NULL, NULL, 61839),
(61840, '3.30.70.2330-FF-000005', NULL, 'Uncharacterized protein', 96, NULL, NULL, 61840),
(61841, '1.10.287.1490-FF-000046', NULL, 'Similar to GTPase-activating protein GYP5', 139, NULL, NULL, 61841),
(61842, '3.40.30.10-FF-000179', NULL, 'NADH-ubiquinone oxidoreductase 10.5 kDa subunit', 91, NULL, NULL, 61842),
(61843, '3.30.160.60-FF-003295', NULL, 'Zinc finger protein 337', 29, NULL, NULL, 61843),
(61844, '3.30.160.60-FF-005009', NULL, NULL, 27, NULL, NULL, 61844),
(61845, '1.20.1070.10-FF-002079', NULL, 'Uncharacterized protein', 271, NULL, NULL, 61845),
(61846, '1.10.1420.10-FF-000046', NULL, 'DNA mismatch repair protein Msh1', 106, NULL, NULL, 61846),
(61847, '2.60.120.820-FF-000012', NULL, 'Uncharacterized protein', 152, NULL, NULL, 61847),
(61848, '2.60.40.820-FF-000037', NULL, 'Putative T-box protein 31', 175, NULL, NULL, 61848),
(61849, '1.10.510.10-FF-000346', NULL, 'Serine/threonine-protein kinase NIM1', 345, NULL, NULL, 61849),
(61850, '2.60.40.1910-FF-000013', NULL, 'Aminopeptidase', 93, NULL, NULL, 61850),
(61851, '2.120.10.30-FF-000614', NULL, 'Uncharacterized protein', 104, NULL, NULL, 61851),
(61852, '3.40.50.300-FF-004655', NULL, 'Methyl coenzyme M reductase system, component A2 homolog', 108, NULL, NULL, 61852),
(61853, '2.160.10.10-FF-000051', NULL, 'Glucose-1-phosphate adenylyltransferase (ADP-glucose pyrophosphorylase)', 111, NULL, NULL, 61853),
(61854, '3.30.470.20-FF-000215', NULL, 'Succinate-CoA ligase, ADP-forming, beta subunit', 63, NULL, NULL, 61854),
(61855, '2.40.50.90-FF-000195', NULL, 'Uncharacterized protein', 55, NULL, NULL, 61855),
(61856, '3.40.50.1820-FF-001737', NULL, 'Predicted protein', 85, NULL, NULL, 61856),
(61857, '1.25.40.10-FF-004143', NULL, 'Uncharacterized protein', 115, NULL, NULL, 61857);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(61858, '2.10.25.10-FF-001587', NULL, 'Uncharacterized protein', 39, NULL, NULL, 61858),
(61859, '3.20.200.10-FF-000009', NULL, 'Uncharacterized protein', 113, NULL, NULL, 61859),
(61860, '3.30.160.60-FF-004604', NULL, NULL, 56, NULL, NULL, 61860),
(61861, '3.30.40.10-FF-000404', NULL, 'RING-H2 finger protein ATL72-like', 82, NULL, NULL, 61861),
(61862, '1.10.238.10-FF-000960', NULL, 'Uncharacterized protein', 173, NULL, NULL, 61862),
(61863, '3.40.50.300-FF-004751', NULL, 'Helicase required for RNAi-mediated heterochromatin assembly 1', 315, NULL, NULL, 61863),
(61864, '3.30.1330.30-FF-000033', NULL, '40S ribosomal protein S12', 132, NULL, NULL, 61864),
(61865, '3.90.20.20-FF-000027', NULL, 'Protein GrpE', 97, NULL, NULL, 61865),
(61866, '3.40.50.1000-FF-000424', NULL, 'Trehalose 6-phosphate phosphatase', 127, NULL, NULL, 61866),
(61867, '1.25.40.530-FF-000028', NULL, NULL, 182, NULL, NULL, 61867),
(61868, '1.20.1070.10-FF-001674', NULL, 'Zgo8', 123, NULL, NULL, 61868),
(61869, '2.60.120.200-FF-000517', NULL, 'Mannose-specific lectin, putative', 238, NULL, NULL, 61869),
(61870, '3.30.1330.10-FF-000038', NULL, 'Thiamine-monophosphate kinase', 123, NULL, NULL, 61870),
(61871, '3.30.40.10-FF-001366', NULL, 'Predicted protein', 55, NULL, NULL, 61871),
(61872, '3.40.50.10330-FF-000041', NULL, 'NAD kinase', 115, NULL, NULL, 61872),
(61873, '3.80.10.10-FF-000485', NULL, 'Protein NSP-INTERACTING KINASE 2', 75, NULL, NULL, 61873),
(61874, '2.160.20.10-FF-000332', NULL, 'Uncharacterized protein', 352, NULL, NULL, 61874),
(61875, '3.40.1000.70-FF-000001', NULL, 'Conserved protein', 186, NULL, NULL, 61875),
(61876, '1.10.238.10-FF-000988', NULL, 'Calpain 8', 127, NULL, NULL, 61876),
(61877, '3.30.70.330-FF-000972', NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', 56, NULL, NULL, 61877),
(61878, '1.25.40.10-FF-004047', NULL, 'Uncharacterized protein', 175, NULL, NULL, 61878),
(61879, '3.10.20.310-FF-000039', NULL, 'ShlB/FhaC/HecB family hemolysin secretion/activation protein', 76, NULL, NULL, 61879),
(61880, '3.30.420.270-FF-000039', NULL, 'Tol-Pal system protein TolR', 75, NULL, NULL, 61880),
(61881, '2.60.40.10-FF-000782', NULL, 'Vascular cell adhesion molecule 1', 90, NULL, NULL, 61881),
(61882, '3.40.50.300-FF-008596', NULL, 'Origin recognition complex subunit 1', 90, NULL, NULL, 61882),
(61883, '3.40.50.1820-FF-000327', NULL, 'Alpha/beta hydrolase', 292, NULL, NULL, 61883),
(61884, '3.90.105.20-FF-000011', NULL, 'Ribosome assembly factor mrt4', 78, NULL, NULL, 61884),
(61885, '1.25.40.10-FF-003867', NULL, 'Tetratricopeptide repeatcontaining protein', 100, NULL, NULL, 61885),
(61886, '1.10.287.130-FF-000115', NULL, 'Histidine kinase', 114, NULL, NULL, 61886),
(61887, '3.30.70.2000-FF-000007', NULL, 'Uncharacterized protein', 57, NULL, NULL, 61887),
(61888, '1.20.1280.50-FF-000089', NULL, 'F-box and leucine-rich repeat protein 5', 52, NULL, NULL, 61888),
(61889, '2.120.10.80-FF-000394', NULL, 'Uncharacterized protein', 179, NULL, NULL, 61889),
(61890, '3.40.390.10-FF-000220', NULL, NULL, 167, NULL, NULL, 61890),
(61891, '3.30.420.40-FF-000370', NULL, 'Putative pantothenate kinase subunit', 145, NULL, NULL, 61891),
(61892, '3.30.565.10-FF-000421', NULL, 'Sensor histidine kinase', 153, NULL, NULL, 61892),
(61893, '3.30.160.60-FF-001850', NULL, 'Zinc finger protein 467', 34, NULL, NULL, 61893),
(61894, '1.10.3080.10-FF-000076', NULL, 'Chloride channel protein', 434, NULL, NULL, 61894),
(61895, '1.25.40.20-FF-000661', NULL, 'Protein accellerated cell death 6', 191, NULL, NULL, 61895),
(61896, '3.80.10.10-FF-003582', NULL, 'Leucine-rich repeat-containing 8 VRAC subunit C', 140, NULL, NULL, 61896),
(61897, '3.30.420.80-FF-000027', NULL, 'Uncharacterized protein', 105, NULL, NULL, 61897),
(61898, '2.40.10.10-FF-000343', NULL, NULL, 227, NULL, NULL, 61898),
(61899, '3.40.33.10-FF-000202', NULL, 'Uncharacterized protein', 50, NULL, NULL, 61899),
(61900, '3.30.70.560-FF-000001', NULL, '2-amino-4-hydroxy-6-hydroxymethyldihydropteridine pyrophosphokinase', 158, NULL, NULL, 61900);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(61901, '2.60.40.4100-FF-000007', NULL, 'oncoprotein-induced transcript 3 protein', 157, NULL, NULL, 61901),
(61902, '1.25.10.10-FF-000493', NULL, '26S proteasome non-ATPase regulatory subunit 5 isoform X1', 216, NULL, NULL, 61902),
(61903, '3.40.30.10-FF-001005', NULL, 'Predicted protein', 70, NULL, NULL, 61903),
(61904, '3.20.20.150-FF-000028', NULL, 'Probable AP endonuclease', 280, NULL, NULL, 61904),
(61905, '2.130.10.10-FF-003391', NULL, 'Semaphorin-5A', 458, NULL, NULL, 61905),
(61906, '1.25.40.20-FF-000891', NULL, 'Uncharacterized protein', 112, NULL, NULL, 61906),
(61907, '3.40.1110.10-FF-000340', NULL, NULL, 119, NULL, NULL, 61907),
(61908, '1.20.1070.10-FF-000281', NULL, 'Vomeronasal type-1 receptor', 298, NULL, NULL, 61908),
(61909, '1.20.120.980-FF-000042', NULL, 'Uncharacterized protein', 46, NULL, NULL, 61909),
(61910, '3.40.630.10-FF-000144', NULL, 'Succinylglutamate desuccinylase', 342, NULL, NULL, 61910),
(61911, '3.40.50.150-FF-000985', NULL, NULL, 217, NULL, NULL, 61911),
(61912, '3.40.309.10-FF-000032', NULL, 'Probable aldehyde dehydrogenase', 190, NULL, NULL, 61912),
(61913, '3.40.50.300-FF-002626', NULL, 'Adenylate kinase-like protein 2', 195, NULL, NULL, 61913),
(61914, '1.50.40.10-FF-000026', NULL, 'Putative mitochondrial glutamate carrier 2', 306, NULL, NULL, 61914),
(61915, '3.40.50.720-FF-000830', NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase, NAD-binding', 81, NULL, NULL, 61915),
(61916, '3.30.1250.10-FF-000004', NULL, NULL, 96, NULL, NULL, 61916),
(61917, '2.60.40.10-FF-003424', NULL, NULL, 107, NULL, NULL, 61917),
(61918, '3.80.10.10-FF-004324', NULL, 'Uncharacterized protein', 204, NULL, NULL, 61918),
(61919, '3.30.420.100-FF-000016', NULL, '50S ribosomal protein L18', 159, NULL, NULL, 61919),
(61920, '3.90.190.10-FF-000222', NULL, 'Protein-tyrosine phosphatase 1-like protein', 339, NULL, NULL, 61920),
(61921, '2.40.30.10-FF-000226', NULL, 'Elongation factor 2-like protein', 145, NULL, NULL, 61921),
(61922, '3.90.226.10-FF-000272', NULL, 'Uncharacterized protein', 206, NULL, NULL, 61922),
(61923, '2.70.98.10-FF-000089', NULL, 'Galactose mutarotase-like superfamily protein', 317, NULL, NULL, 61923),
(61924, '2.60.120.10-FF-000745', NULL, 'Uncharacterized protein', 104, NULL, NULL, 61924),
(61925, '1.10.10.60-FF-000766', NULL, NULL, 68, NULL, NULL, 61925),
(61926, '2.30.42.10-FF-000304', NULL, 'Endopeptidase La', 93, NULL, NULL, 61926),
(61927, '3.40.50.970-FF-000096', NULL, 'Pyruvate dehydrogenase E1 alpha 1 subunit', 154, NULL, NULL, 61927),
(61928, '3.40.50.300-FF-002497', NULL, 'DNA replication protein', 188, NULL, NULL, 61928),
(61929, '3.50.50.60-FF-000172', NULL, 'Protoporphyrinogen oxidase', 157, NULL, NULL, 61929),
(61930, '3.90.79.10-FF-000289', NULL, 'Uncharacterized protein', 210, NULL, NULL, 61930),
(61931, '1.10.10.60-FF-001042', NULL, NULL, 75, NULL, NULL, 61931),
(61932, '4.10.410.10-FF-000102', NULL, 'CG42827-PC, CG42827-PD', 95, NULL, NULL, 61932),
(61933, '1.10.287.110-FF-000452', NULL, 'Protein CBR-DNJ-9', 56, NULL, NULL, 61933),
(61934, '3.30.230.10-FF-000104', NULL, 'ATP-dependent protease La', 184, NULL, NULL, 61934),
(61935, '3.30.160.60-FF-000782', NULL, 'Zinc finger protein 33A', 29, NULL, NULL, 61935),
(61936, '3.40.50.150-FF-000855', NULL, 'CalS11', 257, NULL, NULL, 61936),
(61937, '3.40.50.150-FF-001474', NULL, NULL, 281, NULL, NULL, 61937),
(61938, '2.30.30.140-FF-000017', NULL, 'hepatoma-derived growth factor isoform X1', 99, NULL, NULL, 61938),
(61939, '3.90.190.10-FF-000435', NULL, 'DEP-1a', 69, NULL, NULL, 61939),
(61940, '3.30.200.20-FF-000605', NULL, 'Serine/threonine-protein kinase haspin-like protein', 136, NULL, NULL, 61940),
(61941, '3.30.930.10-FF-000017', NULL, 'Elongation factor P--(R)-beta-lysine ligase', 323, NULL, NULL, 61941),
(61942, '1.25.40.20-FF-001150', NULL, 'Uncharacterized protein', 142, NULL, NULL, 61942),
(61943, '1.10.418.10-FF-000070', NULL, 'Calmodulin regulated spectrin-associated protein 1b', 105, NULL, NULL, 61943),
(61944, '2.60.40.10-FF-002682', NULL, 'Transglutaminase 3, gene 1', 142, NULL, NULL, 61944);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(61945, '1.25.40.10-FF-001613', NULL, 'UT01249p', 224, NULL, NULL, 61945),
(61946, '1.20.5.190-FF-000132', NULL, NULL, 48, NULL, NULL, 61946),
(61947, '1.10.510.10-FF-004269', NULL, NULL, 186, NULL, NULL, 61947),
(61948, '3.30.1490.100-FF-000006', NULL, 'DNA polymerase eta', 125, NULL, NULL, 61948),
(61949, '3.40.50.300-FF-007185', NULL, 'ATP-dependent DNA helicase', 170, NULL, NULL, 61949),
(61950, '3.30.160.60-FF-002676', NULL, 'Zinc finger protein 426', 81, NULL, NULL, 61950),
(61951, '1.10.390.30-FF-000004', NULL, 'Family with sequence similarity 115, member C', 87, NULL, NULL, 61951),
(61952, '1.10.540.10-FF-000157', NULL, 'Uncharacterized protein', 83, NULL, NULL, 61952),
(61953, '3.40.50.1820-FF-001507', NULL, 'Uncharacterized protein', 155, NULL, NULL, 61953),
(61954, '3.30.750.24-FF-000016', NULL, 'Anion exchange transporter', 223, NULL, NULL, 61954),
(61955, '1.20.1070.10-FF-000494', NULL, 'Methuselah-like 15, isoform C', 304, NULL, NULL, 61955),
(61956, '3.20.110.10-FF-000002', NULL, 'alpha-mannosidase 2C1 isoform X1', 271, NULL, NULL, 61956),
(61957, '1.20.58.1480-FF-000022', NULL, 'Lon protease', 124, NULL, NULL, 61957),
(61958, '3.30.160.60-FF-005110', NULL, NULL, 23, NULL, NULL, 61958),
(61959, '1.10.510.10-FF-002807', NULL, NULL, 183, NULL, NULL, 61959),
(61960, '3.40.50.300-FF-006549', NULL, 'Uncharacterized protein', 105, NULL, NULL, 61960),
(61961, '3.40.50.2300-FF-000836', NULL, NULL, 92, NULL, NULL, 61961),
(61962, '2.130.10.130-FF-000037', NULL, NULL, 195, NULL, NULL, 61962),
(61963, '3.30.565.10-FF-000292', NULL, 'Anti-sigma factor antagonist', 142, NULL, NULL, 61963),
(61964, '3.30.870.10-FF-000175', NULL, 'Predicted protein', 178, NULL, NULL, 61964),
(61965, '3.30.160.60-FF-003424', NULL, 'Zinc finger protein', 26, NULL, NULL, 61965),
(61966, '3.30.200.20-FF-000965', NULL, 'Cell division protein kinase (Ctk1), putative', 84, NULL, NULL, 61966),
(61967, '3.40.50.720-FF-001010', NULL, 'Alanine dehydrogenase, truncation', 71, NULL, NULL, 61967),
(61968, '1.20.58.1070-FF-000017', NULL, 'Survival motor neuron interacting protein 1-domain-containing protein', 159, NULL, NULL, 61968),
(61969, '2.40.160.10-FF-000038', NULL, 'Uncharacterized protein', 149, NULL, NULL, 61969),
(61970, '3.60.20.10-FF-000060', NULL, 'Related to DUG3-probable glutamine amidotransferase', 296, NULL, NULL, 61970),
(61971, '3.30.70.270-FF-000246', NULL, NULL, 59, NULL, NULL, 61971),
(61972, '3.40.50.10800-FF-000002', NULL, 'Quinolinate synthase A', 100, NULL, NULL, 61972),
(61973, '1.20.1250.20-FF-000140', NULL, 'Putative MFS phospholipid transporter', 435, NULL, NULL, 61973),
(61974, '2.10.70.80-FF-000003', NULL, 'Sortilin', 57, NULL, NULL, 61974),
(61975, '1.10.10.10-FF-001830', NULL, 'Chromosome 8, whole genome shotgun sequence', 97, NULL, NULL, 61975),
(61976, '2.60.40.180-FF-000013', NULL, '5-hydroxyisourate hydrolase', 117, NULL, NULL, 61976),
(61977, '1.10.8.10-FF-000233', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 42, NULL, NULL, 61977),
(61978, '3.10.110.10-FF-000156', NULL, 'Putative ubiquitin-conjugating enzyme', 157, NULL, NULL, 61978),
(61979, '1.10.3120.10-FF-000029', NULL, NULL, 151, NULL, NULL, 61979),
(61980, '2.130.10.10-FF-002772', NULL, 'Cleavage and polyadenylation-specific factor 1', 230, NULL, NULL, 61980),
(61981, '1.10.472.10-FF-000009', NULL, 'cyclin-T2 isoform X1', 144, NULL, NULL, 61981),
(61982, '2.60.40.150-FF-000246', NULL, 'Non-specific serine/threonine protein kinase', 129, NULL, NULL, 61982),
(61983, '1.10.486.10-FF-000070', NULL, 'Predicted protein', 40, NULL, NULL, 61983),
(61984, '1.10.10.10-FF-000324', NULL, 'LuxR family transcriptional regulator', 98, NULL, NULL, 61984),
(61985, '2.120.10.80-FF-000264', NULL, 'Cellular morphogenesis protein (Rax2), putative (AFU_orthologue AFUA_7G05340)', 279, NULL, NULL, 61985),
(61986, '1.10.510.10-FF-004371', NULL, NULL, 102, NULL, NULL, 61986),
(61987, '1.20.1270.60-FF-000136', NULL, 'Uncharacterized protein', 198, NULL, NULL, 61987),
(61988, '2.60.120.290-FF-000252', NULL, 'Cubilin-like Protein', 122, NULL, NULL, 61988);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(61989, '1.20.1530.20-FF-000089', NULL, 'Uncharacterized protein', 308, NULL, NULL, 61989),
(61990, '1.20.210.10-FF-000017', NULL, 'Cytochrome c oxidase subunit I', 498, NULL, NULL, 61990),
(61991, '3.90.70.10-FF-000769', NULL, 'Uncharacterized protein', 70, NULL, NULL, 61991),
(61992, '3.40.50.1820-FF-001867', NULL, 'Carboxypeptidase', 245, NULL, NULL, 61992),
(61993, '3.30.230.70-FF-000083', NULL, 'Uncharacterized protein', 96, NULL, NULL, 61993),
(61994, '3.30.200.20-FF-001241', NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', 111, NULL, NULL, 61994),
(61995, '3.30.160.60-FF-004834', NULL, NULL, 78, NULL, NULL, 61995),
(61996, '3.50.50.100-FF-000035', NULL, 'Apoptosis-inducing factor-like A', 153, NULL, NULL, 61996),
(61997, '3.80.10.10-FF-000142', NULL, 'Ran GTPase activating protein 1', 346, NULL, NULL, 61997),
(61998, '3.90.70.10-FF-000741', NULL, 'Uncharacterized protein', 145, NULL, NULL, 61998),
(61999, '3.40.50.12780-FF-000101', NULL, 'Acetate-CoA ligase, putative', 556, NULL, NULL, 61999),
(62000, '2.70.150.10-FF-000177', NULL, 'Phospholipid-transporting ATPase', 136, NULL, NULL, 62000),
(62001, '1.10.8.50-FF-000003', NULL, 'Formamidopyrimidine-DNA glycosylase', 139, NULL, NULL, 62001),
(62002, '3.30.70.580-FF-000007', NULL, 'tRNA pseudouridine synthase', 138, NULL, NULL, 62002),
(62003, '3.20.20.70-FF-000040', NULL, 'Lipoyl synthase', 259, NULL, NULL, 62003),
(62004, '2.60.120.200-FF-000394', NULL, 'Galectin', 132, NULL, NULL, 62004),
(62005, '3.40.50.10540-FF-000014', NULL, 'Solute carrier family 45 member 2', 20, NULL, NULL, 62005),
(62006, '2.30.30.1150-FF-000016', NULL, 'Histone-lysine N-methyltransferase ATXR6', 72, NULL, NULL, 62006),
(62007, '3.20.20.80-FF-000256', NULL, 'Amino acid Transporter GlycoProtein subunit', 159, NULL, NULL, 62007),
(62008, '1.10.287.10-FF-000045', NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase', 39, NULL, NULL, 62008),
(62009, '1.25.40.10-FF-004486', NULL, 'Uncharacterized protein', 100, NULL, NULL, 62009),
(62010, '1.20.1560.10-FF-000481', NULL, 'Uncharacterized protein', 348, NULL, NULL, 62010),
(62011, '2.80.10.50-FF-000095', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 133, NULL, NULL, 62011),
(62012, '1.10.510.10-FF-000907', NULL, 'tyrosine-protein kinase RYK', 269, NULL, NULL, 62012),
(62013, '1.20.58.340-FF-000087', NULL, 'Mg2+ transporter protein, CorA-like protein', 103, NULL, NULL, 62013),
(62014, '3.40.366.10-FF-000018', NULL, 'Fatty acid synthase subunit beta', 126, NULL, NULL, 62014),
(62015, '3.10.100.10-FF-000442', NULL, NULL, 53, NULL, NULL, 62015),
(62016, '4.10.1000.10-FF-000102', NULL, 'Uncharacterized protein', 59, NULL, NULL, 62016),
(62017, '3.30.450.20-FF-000091', NULL, 'Neuronal PAS domain-containing protein 3', 162, NULL, NULL, 62017),
(62018, '3.30.420.10-FF-000147', NULL, 'DNA polymerase I', 212, NULL, NULL, 62018),
(62019, '3.30.1360.120-FF-000074', NULL, 'Aminomethyltransferase', 140, NULL, NULL, 62019),
(62020, '1.10.472.80-FF-000204', NULL, NULL, 77, NULL, NULL, 62020),
(62021, '3.30.70.1050-FF-000020', NULL, 'Peptidylprolyl isomerase', 114, NULL, NULL, 62021),
(62022, '3.40.50.620-FF-000581', NULL, 'Isoleucyl-tRNA synthetase', 230, NULL, NULL, 62022),
(62023, '3.30.470.30-FF-000089', NULL, 'DNA ligase', 222, NULL, NULL, 62023),
(62024, '3.30.50.10-FF-000124', NULL, 'Peroxisome proliferator-activated receptor alpha', 106, NULL, NULL, 62024),
(62025, '3.40.50.300-FF-006100', NULL, 'Uncharacterized protein', 110, NULL, NULL, 62025),
(62026, '3.40.50.300-FF-005482', NULL, 'ATP-dependent DNA helicase tlh2', 204, NULL, NULL, 62026),
(62027, '3.30.420.40-FF-000583', NULL, 'Actin', 166, NULL, NULL, 62027),
(62028, '3.30.40.10-FF-001719', NULL, 'E3 ubiquitin-protein ligase TRIM56', 55, NULL, NULL, 62028),
(62029, '3.30.160.60-FF-000338', NULL, 'zinc finger protein 383', 29, NULL, NULL, 62029),
(62030, '3.30.360.10-FF-000108', NULL, 'NADP(+) coupled glycerol dehydrogenase (Eurofung)', 189, NULL, NULL, 62030),
(62031, '2.60.120.200-FF-000164', NULL, 'Putative L-type lectin-domain containing receptor kinase S.5', 266, NULL, NULL, 62031);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(62032, '3.30.465.10-FF-000144', NULL, 'Uncharacterized protein', 153, NULL, NULL, 62032),
(62033, '2.30.29.30-FF-000128', NULL, 'arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 2', 96, NULL, NULL, 62033),
(62034, '3.60.15.10-FF-000199', NULL, 'Metallo-beta-lactamase superfamily protein', 255, NULL, NULL, 62034),
(62035, '3.10.20.90-FF-000462', NULL, 'Uncharacterized protein, isoform A', 168, NULL, NULL, 62035),
(62036, '3.80.10.10-FF-001457', NULL, 'Os06g0179800 protein', 262, NULL, NULL, 62036),
(62037, '1.20.1070.10-FF-001702', NULL, 'Uncharacterized protein', 107, NULL, NULL, 62037),
(62038, '3.40.50.720-FF-000734', NULL, 'Chloroplast envelope quinone oxidoreductase homolog', 139, NULL, NULL, 62038),
(62039, '1.20.1070.10-FF-001803', NULL, 'Predicted protein', 316, NULL, NULL, 62039),
(62040, '3.20.20.100-FF-000154', NULL, 'Uncharacterized protein', 260, NULL, NULL, 62040),
(62041, '3.30.160.60-FF-002468', NULL, 'Uncharacterized protein, isoform B', 29, NULL, NULL, 62041),
(62042, '3.30.200.20-FF-002067', NULL, 'Predicted protein', 86, NULL, NULL, 62042),
(62043, '3.90.640.10-FF-000072', NULL, 'Conserved hypothetical proline rich protein', 75, NULL, NULL, 62043),
(62044, '1.25.40.10-FF-000669', NULL, 'Pentatricopeptide repeat-containing protein At4g33990', 112, NULL, NULL, 62044),
(62045, '1.10.150.20-FF-000254', NULL, 'DNA polymerase IV', 73, NULL, NULL, 62045),
(62046, '3.40.109.10-FF-000051', NULL, 'Putative NAD(P)H nitroreductase', 99, NULL, NULL, 62046),
(62047, '3.40.50.300-FF-002289', NULL, 'DNA or RNA helicase of superfamily II', 171, NULL, NULL, 62047),
(62048, '1.20.144.10-FF-000133', NULL, 'Uncharacterized protein', 269, NULL, NULL, 62048),
(62049, '3.30.70.20-FF-000140', NULL, NULL, 72, NULL, NULL, 62049),
(62050, '2.130.10.10-FF-004037', NULL, 'Uncharacterized protein', 219, NULL, NULL, 62050),
(62051, '3.90.660.10-FF-000067', NULL, 'Polyamine oxidase', 240, NULL, NULL, 62051),
(62052, '2.130.10.10-FF-000777', NULL, 'Transducin/WD40 repeat-like superfamily protein', 405, NULL, NULL, 62052),
(62053, '3.90.550.10-FF-000418', NULL, 'ATP synthase subunit beta', 182, NULL, NULL, 62053),
(62054, '1.20.58.1040-FF-000025', NULL, '1,3-beta-glucanosyltransferase gas2', 105, NULL, NULL, 62054),
(62055, '3.40.630.30-FF-000493', NULL, 'Ribosomal-protein-alanine acetyltransferase', 141, NULL, NULL, 62055),
(62056, '2.60.40.150-FF-000807', NULL, 'Predicted protein', 137, NULL, NULL, 62056),
(62057, '2.30.110.10-FF-000032', NULL, 'PPOX class F420-dependent oxidoreductase', 131, NULL, NULL, 62057),
(62058, '3.40.50.300-FF-000159', NULL, 'Katanin p60 ATPase-containing subunit A1', 194, NULL, NULL, 62058),
(62059, '3.30.450.40-FF-000079', NULL, 'Heat-inducible transcription repressor HrcA', 127, NULL, NULL, 62059),
(62060, '1.25.40.10-FF-002698', NULL, 'Predicted protein', 130, NULL, NULL, 62060),
(62061, '1.25.40.10-FF-004839', NULL, 'Uncharacterized protein', 142, NULL, NULL, 62061),
(62062, '3.60.40.10-FF-000263', NULL, 'Protein phosphatase 2C-like domain-containing protein 1', 304, NULL, NULL, 62062),
(62063, '1.10.8.60-FF-000332', NULL, 'AAA family ATPase', 49, NULL, NULL, 62063),
(62064, '2.30.30.40-FF-000522', NULL, 'Disks large homolog 1', 72, NULL, NULL, 62064),
(62065, '1.25.40.10-FF-002810', NULL, 'Os07g0260000 protein', 135, NULL, NULL, 62065),
(62066, '1.10.238.10-FF-000297', NULL, 'Calcium-binding EF hand family protein', 80, NULL, NULL, 62066),
(62067, '1.10.45.10-FF-000005', NULL, 'L-gulono-1,4-lactone dehydrogenase', 37, NULL, NULL, 62067),
(62068, '1.10.150.110-FF-000020', NULL, 'Uncharacterized protein', 97, NULL, NULL, 62068),
(62069, '3.30.70.270-FF-000038', NULL, 'Diguanylate cyclase domain protein', 173, NULL, NULL, 62069),
(62070, '3.40.5.10-FF-000003', NULL, '50S ribosomal protein L9', 59, NULL, NULL, 62070),
(62071, '2.40.70.10-FF-000223', NULL, 'Uncharacterized protein', 188, NULL, NULL, 62071),
(62072, '3.10.28.10-FF-000023', NULL, 'Probable cell division protein WhiA', 201, NULL, NULL, 62072),
(62073, '2.120.10.30-FF-000390', NULL, 'Uncharacterized protein', 289, NULL, NULL, 62073);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(62074, '3.80.10.10-FF-002413', NULL, 'CCR4-NOT transcription complex subunit 6', 164, NULL, NULL, 62074),
(62075, '2.40.50.140-FF-000626', NULL, 'Transcription termination/antitermination protein NusA', 72, NULL, NULL, 62075),
(62076, '1.20.5.320-FF-000008', NULL, '6-phosphogluconate dehydrogenase, decarboxylating', 34, NULL, NULL, 62076),
(62077, '3.20.20.190-FF-000124', NULL, NULL, 185, NULL, NULL, 62077),
(62078, '3.30.342.10-FF-000044', NULL, 'DNA polymerase', 174, NULL, NULL, 62078),
(62079, '3.30.200.20-FF-000853', NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 185', 102, NULL, NULL, 62079),
(62080, '1.25.40.10-FF-002799', NULL, 'Pentatricopeptide repeat-containing protein At3g61360', 123, NULL, NULL, 62080),
(62081, '3.30.40.10-FF-001832', NULL, 'Predicted protein', 55, NULL, NULL, 62081),
(62082, '1.10.220.30-FF-000004', NULL, 'Flagellar motor switch protein FliG', 103, NULL, NULL, 62082),
(62083, '2.10.25.10-FF-000631', NULL, 'Vitamin K-dependent protein S', 46, NULL, NULL, 62083),
(62084, '3.40.1170.10-FF-000006', NULL, 'DNA mismatch repair protein', 145, NULL, NULL, 62084),
(62085, '2.40.33.10-FF-000036', NULL, 'Pyruvate kinase', 103, NULL, NULL, 62085),
(62086, '3.40.50.300-FF-000491', NULL, 'E3 ubiquitin-protein ligase RNF213', 166, NULL, NULL, 62086),
(62087, '2.60.40.10-FF-004385', NULL, NULL, 96, NULL, NULL, 62087),
(62088, '1.20.140.150-FF-000016', NULL, 'Epithelial membrane protein 3', 162, NULL, NULL, 62088),
(62089, '3.90.70.10-FF-000191', NULL, 'CYLinDromatosis (Human disease gene) homolog', 371, NULL, NULL, 62089),
(62090, '1.50.40.10-FF-000369', NULL, 'Mitochondrial folate carrier protein Flx1', 225, NULL, NULL, 62090),
(62091, '3.30.505.10-FF-000069', NULL, 'Signal transducer and activator of transcription', 87, NULL, NULL, 62091),
(62092, '3.30.310.80-FF-000042', NULL, 'CBL-interacting serine/threonine-protein kinase 11', 124, NULL, NULL, 62092),
(62093, '1.25.40.20-FF-001178', NULL, 'Ankyrin repeat family protein', 86, NULL, NULL, 62093),
(62094, '1.10.340.30-FF-000052', NULL, 'A/G specific adenine glycosylase, repair protein', 114, NULL, NULL, 62094),
(62095, '1.20.120.430-FF-000012', NULL, 'GTP binding protein 3 (Mitochondrial)', 93, NULL, NULL, 62095),
(62096, '3.30.1330.60-FF-000031', NULL, 'Peptidoglycan associated lipoprotein (Omp18)', 137, NULL, NULL, 62096),
(62097, '1.20.1740.10-FF-000236', NULL, 'Y+LAT1B, putative', 387, NULL, NULL, 62097),
(62098, '3.80.10.10-FF-000272', NULL, 'Leucine rich repeat containing 49', 155, NULL, NULL, 62098),
(62099, '1.20.5.300-FF-000002', NULL, 'Cyclic nucleotide-gated channel alpha 3', 50, NULL, NULL, 62099),
(62100, '3.90.1420.10-FF-000026', NULL, 'Uncharacterized protein', 172, NULL, NULL, 62100),
(62101, '2.60.120.650-FF-000152', NULL, 'Uncharacterized protein', 310, NULL, NULL, 62101),
(62102, '3.30.160.60-FF-005453', NULL, NULL, 16, NULL, NULL, 62102),
(62103, '1.25.40.10-FF-003316', NULL, 'Pentatricopeptide repeat-containing protein At5g55740, chloroplastic', 228, NULL, NULL, 62103),
(62104, '2.170.140.10-FF-000046', NULL, 'IP16275p', 64, NULL, NULL, 62104),
(62105, '3.30.420.270-FF-000011', NULL, 'Biopolymer transport protein ExbD', 73, NULL, NULL, 62105),
(62106, '1.10.510.10-FF-001526', NULL, 'BUB1 mitotic checkpoint serine/threonine kinase', 298, NULL, NULL, 62106),
(62107, '2.40.50.140-FF-001132', NULL, NULL, 71, NULL, NULL, 62107),
(62108, '3.40.50.300-FF-003245', NULL, 'ORC1-type DNA replication protein', 173, NULL, NULL, 62108),
(62109, '1.10.238.10-FF-001253', NULL, 'EF hand', 68, NULL, NULL, 62109),
(62110, '3.20.20.70-FF-000152', NULL, 'radical S-adenosyl methionine domain-containing protein 2', 260, NULL, NULL, 62110),
(62111, '3.40.50.300-FF-006679', NULL, 'Predicted protein', 82, NULL, NULL, 62111),
(62112, '3.90.320.10-FF-000031', NULL, 'CRISPR-associated exonuclease Csa1', 181, NULL, NULL, 62112),
(62113, '3.40.30.10-FF-000151', NULL, 'Glutathione peroxidase', 148, NULL, NULL, 62113),
(62114, '1.20.58.390-FF-000309', NULL, 'Uncharacterized protein', 120, NULL, NULL, 62114),
(62115, '3.40.1190.20-FF-000117', NULL, 'Pyridoxal kinase', 264, NULL, NULL, 62115);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(62116, '2.30.29.30-FF-000448', NULL, 'Syntrophin gamma 1', 114, NULL, NULL, 62116),
(62117, '3.40.630.10-FF-000256', NULL, 'Uncharacterized protein', 112, NULL, NULL, 62117),
(62118, '3.30.160.60-FF-003323', NULL, NULL, 29, NULL, NULL, 62118),
(62119, '1.25.40.10-FF-003524', NULL, 'Uncharacterized protein', 107, NULL, NULL, 62119),
(62120, '2.60.40.10-FF-000001', NULL, 'Filamin-C isoform b', 100, NULL, NULL, 62120),
(62121, '3.90.226.10-FF-000042', NULL, 'Enoyl-CoA hydratase EchA1', 199, NULL, NULL, 62121),
(62122, '3.80.10.10-FF-001570', NULL, 'Type III effector NopM1-1', 243, NULL, NULL, 62122),
(62123, '3.40.30.10-FF-000729', NULL, 'Uncharacterized protein', 167, NULL, NULL, 62123),
(62124, '3.40.50.150-FF-001715', NULL, NULL, 205, NULL, NULL, 62124),
(62125, '3.40.50.300-FF-005274', NULL, 'Origin recognition complex subunit 5', 180, NULL, NULL, 62125),
(62126, '2.130.10.10-FF-001715', NULL, 'WD repeat and HMG-box DNA-binding protein 1', 231, NULL, NULL, 62126),
(62127, '2.40.10.10-FF-000455', NULL, NULL, 239, NULL, NULL, 62127),
(62128, '3.40.50.1370-FF-000052', NULL, NULL, 92, NULL, NULL, 62128),
(62129, '1.20.1280.290-FF-000040', NULL, 'PQ loop repeat protein', 116, NULL, NULL, 62129),
(62130, '2.40.290.10-FF-000031', NULL, 'ATP-dependent DNA helicase 2 subunit KU70', 33, NULL, NULL, 62130),
(62131, '3.90.190.10-FF-000334', NULL, 'Uncharacterized protein', 256, NULL, NULL, 62131),
(62132, '1.10.600.10-FF-000095', NULL, 'Farnesyl-diphosphate farnesyltransferase', 344, NULL, NULL, 62132),
(62133, '3.40.50.720-FF-002067', NULL, 'YALI0E19789p', 155, NULL, NULL, 62133),
(62134, '1.25.10.10-FF-003135', NULL, 'Predicted protein', 120, NULL, NULL, 62134),
(62135, '3.90.1530.10-FF-000012', NULL, 'Sulfiredoxin-1, putative', 58, NULL, NULL, 62135),
(62136, '3.30.1010.10-FF-000014', NULL, 'Phosphatidylinositol 4-kinase STT4', 158, NULL, NULL, 62136),
(62137, '3.30.497.10-FF-000015', NULL, 'Serpin family B member 7', 221, NULL, NULL, 62137),
(62138, '1.20.58.60-FF-000212', NULL, 'Uncharacterized protein, isoform B', 215, NULL, NULL, 62138),
(62139, '2.60.60.20-FF-000005', NULL, 'Lipoxygenase homology domain-containing protein 1', 133, NULL, NULL, 62139),
(62140, '3.40.50.720-FF-002179', NULL, 'Uncharacterized protein', 57, NULL, NULL, 62140),
(62141, '1.10.560.10-FF-000057', NULL, '60 kDa chaperonin', 248, NULL, NULL, 62141),
(62142, '1.10.238.10-FF-001152', NULL, 'Uncharacterized protein', 123, NULL, NULL, 62142),
(62143, '2.60.40.10-FF-001530', NULL, 'Wide awake, isoform B', 109, NULL, NULL, 62143),
(62144, '3.90.550.10-FF-000317', NULL, 'LPS 1,3-galactosyltransferase', 263, NULL, NULL, 62144),
(62145, '3.30.1370.120-FF-000019', NULL, 'Type IV pilus secretin lipoprotein PilQ', 95, NULL, NULL, 62145),
(62146, '3.30.40.10-FF-000298', NULL, 'non-structural maintenance of chromosomes element 1 homolog', 58, NULL, NULL, 62146),
(62147, '1.25.40.1040-FF-000032', NULL, 'Uncharacterized protein', 322, NULL, NULL, 62147),
(62148, '3.40.47.10-FF-000032', NULL, 'Peroxisomal 3-ketoacyl-CoA thiolase', 416, NULL, NULL, 62148),
(62149, '3.40.47.10-FF-000144', NULL, NULL, 78, NULL, NULL, 62149),
(62150, '3.90.70.10-FF-000292', NULL, 'Predicted protein', 255, NULL, NULL, 62150),
(62151, '3.40.50.1220-FF-000035', NULL, 'Electron transfer flavoprotein alpha subunit apoprotein', 130, NULL, NULL, 62151),
(62152, '2.70.98.10-FF-000072', NULL, 'YALI0C09570p', 324, NULL, NULL, 62152),
(62153, '3.30.590.10-FF-000030', NULL, 'Arginine kinase, putative', 73, NULL, NULL, 62153),
(62154, '3.100.10.10-FF-000010', NULL, '50S ribosomal protein L15', 79, NULL, NULL, 62154),
(62155, '3.30.160.60-FF-003087', NULL, 'U-shaped, isoform D', 74, NULL, NULL, 62155),
(62156, '3.40.50.1820-FF-001288', NULL, 'Putative secreted protein', 284, NULL, NULL, 62156),
(62157, '3.30.230.130-FF-000044', NULL, 'Cullin-5', 160, NULL, NULL, 62157),
(62158, '1.20.1110.10-FF-000110', NULL, NULL, 137, NULL, NULL, 62158),
(62159, '3.30.70.330-FF-001017', NULL, 'La protein 2', 98, NULL, NULL, 62159),
(62160, '1.25.40.180-FF-000119', NULL, 'Eukaryotic translation initiation factor eif-5, putative', 163, NULL, NULL, 62160);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(62161, '3.90.1150.210-FF-000025', NULL, 'F-actin-capping protein subunit alpha', 134, NULL, NULL, 62161),
(62162, '1.20.58.60-FF-000336', NULL, 'SMAll', 103, NULL, NULL, 62162),
(62163, '3.30.200.20-FF-002298', NULL, 'Uncharacterized protein', 18, NULL, NULL, 62163),
(62164, '1.10.510.10-FF-000554', NULL, 'Predicted protein', 198, NULL, NULL, 62164),
(62165, '3.30.160.20-FF-000113', NULL, 'Dicer-like 4', 77, NULL, NULL, 62165),
(62166, '1.25.10.10-FF-001898', NULL, 'PDS5 cohesin-associated factor A', 248, NULL, NULL, 62166),
(62167, '1.10.10.60-FF-000535', NULL, 'Sigma-54 dependent transcriptional regulator', 56, NULL, NULL, 62167),
(62168, '1.10.110.10-FF-000006', NULL, '17kDa alpha-amylase/trypsin inhibitor 1', 128, NULL, NULL, 62168),
(62169, '2.60.40.60-FF-000443', NULL, 'AGAP003579-PA', 104, NULL, NULL, 62169),
(62170, '4.10.400.10-FF-000276', NULL, 'Serine protease nudel', 35, NULL, NULL, 62170),
(62171, '3.30.160.60-FF-000670', NULL, 'zinc finger protein 22', 28, NULL, NULL, 62171),
(62172, '1.10.8.710-FF-000037', NULL, NULL, 111, NULL, NULL, 62172),
(62173, '2.130.10.10-FF-000546', NULL, 'TLE family member 6, subcortical maternal complex member', 321, NULL, NULL, 62173),
(62174, '1.10.510.10-FF-003314', NULL, NULL, 72, NULL, NULL, 62174),
(62175, '3.30.1680.10-FF-000042', NULL, 'Semaphorin 3G', 64, NULL, NULL, 62175),
(62176, '3.10.450.50-FF-000070', NULL, 'mRNA export factor MEX67', 219, NULL, NULL, 62176),
(62177, '2.10.25.10-FF-001457', NULL, 'Uncharacterized protein, isoform B', 41, NULL, NULL, 62177),
(62178, '3.60.40.10-FF-000055', NULL, 'Adenylate cyclase AcyA', 281, NULL, NULL, 62178),
(62179, '3.40.50.360-FF-000019', NULL, 'Nitric oxide synthase', 168, NULL, NULL, 62179),
(62180, '1.20.1070.10-FF-001466', NULL, 'Uncharacterized protein', 214, NULL, NULL, 62180),
(62181, '2.30.42.10-FF-000535', NULL, NULL, 108, NULL, NULL, 62181),
(62182, '1.25.40.10-FF-004255', NULL, 'Uncharacterized protein', 227, NULL, NULL, 62182),
(62183, '2.60.40.10-FF-004593', NULL, NULL, 96, NULL, NULL, 62183),
(62184, '3.40.50.1970-FF-000001', NULL, '3-dehydroquinate synthase', 172, NULL, NULL, 62184),
(62185, '3.40.50.300-FF-004543', NULL, 'Deoxycytidine monophosphate deaminase', 176, NULL, NULL, 62185),
(62186, '3.30.950.10-FF-000013', NULL, 'Bifunctional S-adenosyl-L-methionine-precorrin-2 methyl transferase/precorrin-3 methylase', 138, NULL, NULL, 62186),
(62187, '1.10.472.10-FF-000661', NULL, 'Uncharacterized protein', 87, NULL, NULL, 62187),
(62188, '3.40.190.10-FF-000340', NULL, 'Phosphonate ABC transporter, phosphate-binding protein', 117, NULL, NULL, 62188),
(62189, '3.40.190.290-FF-000079', NULL, 'HTH-type transcriptional regulator PtxR', 205, NULL, NULL, 62189),
(62190, '1.10.150.60-FF-000007', NULL, 'AT-rich interactive domain-containing protein 3C', 125, NULL, NULL, 62190),
(62191, '3.40.50.10190-FF-000072', NULL, 'DNA ligase', 115, NULL, NULL, 62191),
(62192, '3.40.630.30-FF-000594', NULL, 'Uncharacterized protein', 85, NULL, NULL, 62192),
(62193, '1.10.10.980-FF-000009', NULL, 'Uncharacterized protein', 96, NULL, NULL, 62193),
(62194, '1.20.1540.10-FF-000030', NULL, 'Rhomboid protease ROM6, putative', 224, NULL, NULL, 62194),
(62195, '3.30.70.330-FF-002546', NULL, NULL, 39, NULL, NULL, 62195),
(62196, '2.40.30.20-FF-000004', NULL, 'Riboflavin synthase, alpha subunit', 104, NULL, NULL, 62196),
(62197, '3.30.160.60-FF-002704', NULL, 'Uncharacterized protein', 27, NULL, NULL, 62197),
(62198, '3.30.70.1730-FF-000027', NULL, '60S acidic ribosomal protein P0', 115, NULL, NULL, 62198),
(62199, '3.30.70.330-FF-000180', NULL, 'Deleted in azoospermia-like', 102, NULL, NULL, 62199),
(62200, '1.20.1050.10-FF-000167', NULL, 'Gtt11p', 142, NULL, NULL, 62200),
(62201, '3.30.559.10-FF-000249', NULL, 'Predicted protein', 70, NULL, NULL, 62201),
(62202, '1.10.287.70-FF-000147', NULL, 'Potassium channel, putative', 117, NULL, NULL, 62202),
(62203, '3.40.50.150-FF-000193', NULL, 'tRNA (guanine(37)-N1)-methyltransferase', 189, NULL, NULL, 62203),
(62204, '3.10.20.90-FF-000563', NULL, 'UV excision repair protein RAD23 homolog', 91, NULL, NULL, 62204);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(62205, '1.10.287.130-FF-000227', NULL, 'Two-component sensor kinase', 60, NULL, NULL, 62205),
(62206, '3.90.79.10-FF-000160', NULL, 'Uncharacterized protein', 70, NULL, NULL, 62206),
(62207, '1.10.1520.10-FF-000082', NULL, 'Dicer-like protein', 101, NULL, NULL, 62207),
(62208, '3.30.160.60-FF-005341', NULL, NULL, 68, NULL, NULL, 62208),
(62209, '1.10.150.40-FF-000001', NULL, 'Barrier-to-autointegration factor B', 88, NULL, NULL, 62209),
(62210, '3.40.50.300-FF-007977', NULL, 'Peroxisomal ATPase pex1', 159, NULL, NULL, 62210),
(62211, '3.90.870.10-FF-000004', NULL, 'Threonylcarbamoyl-AMP synthase', 188, NULL, NULL, 62211),
(62212, '1.10.10.1870-FF-000001', NULL, 'Metalloendopeptidase', 37, NULL, NULL, 62212),
(62213, '1.20.1250.20-FF-000157', NULL, 'Inorganic phosphate cotransporter', 194, NULL, NULL, 62213),
(62214, '2.40.50.100-FF-000075', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 105, NULL, NULL, 62214),
(62215, '2.130.10.10-FF-002334', NULL, 'Uncharacterized protein', 188, NULL, NULL, 62215),
(62216, '2.130.10.10-FF-005768', NULL, 'Uncharacterized protein', 108, NULL, NULL, 62216),
(62217, '3.30.1140.32-FF-000004', NULL, '40S ribosomal protein S3', 136, NULL, NULL, 62217),
(62218, '1.20.120.1900-FF-000033', NULL, 'Gamma-tubulin complex component', 309, NULL, NULL, 62218),
(62219, '1.20.120.230-FF-000059', NULL, 'Probable vinculin', 103, NULL, NULL, 62219),
(62220, '2.170.270.10-FF-000134', NULL, 'Uncharacterized protein', 157, NULL, NULL, 62220),
(62221, '2.130.10.10-FF-002800', NULL, 'WD domain, G-beta repeat, putative', 184, NULL, NULL, 62221),
(62222, '3.30.450.20-FF-000444', NULL, 'Two-component sensor histidine kinase', 124, NULL, NULL, 62222),
(62223, '2.60.40.2610-FF-000004', NULL, 'Putative fimbrial outer membrane usher', 93, NULL, NULL, 62223),
(62224, '1.20.58.1120-FF-000061', NULL, NULL, 134, NULL, NULL, 62224),
(62225, '3.20.20.80-FF-000144', NULL, 'Chitinase', 272, NULL, NULL, 62225),
(62226, '2.30.30.140-FF-000225', NULL, 'YALI0B03960p', 92, NULL, NULL, 62226),
(62227, '3.30.1240.10-FF-000048', NULL, 'Phosphatase YwpJ', 130, NULL, NULL, 62227),
(62228, '2.60.40.1170-FF-000066', NULL, NULL, 65, NULL, NULL, 62228),
(62229, '1.20.1250.20-FF-002051', NULL, 'Sugar transporter ERD6-like 9', 309, NULL, NULL, 62229),
(62230, '3.40.50.2300-FF-000483', NULL, 'Chemotaxis protein CheY', 136, NULL, NULL, 62230),
(62231, '3.40.50.720-FF-001459', NULL, 'Dehydrogenase/reductase SDR family protein 7-like', 182, NULL, NULL, 62231),
(62232, '2.60.40.10-FF-004716', NULL, NULL, 81, NULL, NULL, 62232),
(62233, '1.20.5.1200-FF-000006', NULL, 'Alpha tocopherol transfer protein', 37, NULL, NULL, 62233),
(62234, '3.40.50.2300-FF-001101', NULL, 'Metabotropic glutamate receptor 8', 296, NULL, NULL, 62234),
(62235, '3.10.450.10-FF-000086', NULL, 'Uncharacterized protein', 68, NULL, NULL, 62235),
(62236, '1.10.3380.20-FF-000006', NULL, 'helicase POLQ-like', 187, NULL, NULL, 62236),
(62237, '3.30.160.60-FF-004149', NULL, NULL, 30, NULL, NULL, 62237),
(62238, '3.60.15.10-FF-000093', NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', 131, NULL, NULL, 62238),
(62239, '3.40.50.1820-FF-001496', NULL, 'Zgc:174932 protein', 163, NULL, NULL, 62239),
(62240, '3.20.20.100-FF-000030', NULL, 'Aldo-keto reductase family 1 member E2', 300, NULL, NULL, 62240),
(62241, '3.30.70.1450-FF-000033', NULL, 'Trk system potassium uptake protein trkA', 83, NULL, NULL, 62241),
(62242, '1.10.3720.10-FF-000221', NULL, 'ABC transporter permease fused to pyrimidine biosynthesis enzyme', 195, NULL, NULL, 62242),
(62243, '3.40.30.10-FF-000960', NULL, 'Predicted protein', 100, NULL, NULL, 62243),
(62244, '3.80.10.10-FF-003368', NULL, 'Uncharacterized protein', 110, NULL, NULL, 62244),
(62245, '1.10.1370.10-FF-000030', NULL, 'Uncharacterized protein', 163, NULL, NULL, 62245),
(62246, '3.40.50.10190-FF-000313', NULL, 'Nibrin', 96, NULL, NULL, 62246),
(62247, '1.20.120.350-FF-000078', NULL, 'Cation channel sperm associated 1', 133, NULL, NULL, 62247),
(62248, '3.90.550.50-FF-000059', NULL, 'Glycoprotein-N-acetylgalactosamine 3-beta-galactosyltransferase 1', 194, NULL, NULL, 62248);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(62249, '1.10.287.70-FF-000248', NULL, 'KCNK3 isoform 1', 163, NULL, NULL, 62249),
(62250, '3.40.50.720-FF-000622', NULL, 'D-beta-hydroxybutyrate dehydrogenase, mitochondrial', 277, NULL, NULL, 62250),
(62251, '2.130.10.30-FF-000075', NULL, 'SCF-associated factor 1', 126, NULL, NULL, 62251),
(62252, '3.30.70.330-FF-001826', NULL, NULL, 134, NULL, NULL, 62252),
(62253, '2.130.10.10-FF-000889', NULL, 'CPSF (Cleavage and polyadenylation specific factor)', 15, NULL, NULL, 62253),
(62254, '3.40.50.2000-FF-001112', NULL, 'Glycosyltransferase', 238, NULL, NULL, 62254),
(62255, '1.10.630.10-FF-000164', NULL, 'Cytochrome P450 71A1 isoform A', 265, NULL, NULL, 62255),
(62256, '1.20.120.160-FF-000009', NULL, 'Hpt sensor hybrid histidine kinase', 113, NULL, NULL, 62256),
(62257, '1.50.10.20-FF-000078', NULL, 'Geranylgeranyl transferase type II beta subunit', 384, NULL, NULL, 62257),
(62258, '3.30.420.40-FF-000954', NULL, 'Actin-related protein 8', 40, NULL, NULL, 62258),
(62259, '1.10.555.10-FF-000202', NULL, NULL, 103, NULL, NULL, 62259),
(62260, '3.40.50.2000-FF-000836', NULL, 'Uncharacterized protein', 85, NULL, NULL, 62260),
(62261, '1.10.1050.10-FF-000006', NULL, '30S ribosomal protein S4', 104, NULL, NULL, 62261),
(62262, '1.10.472.10-FF-000453', NULL, 'Predicted protein', 123, NULL, NULL, 62262),
(62263, '3.30.70.330-FF-002445', NULL, NULL, 86, NULL, NULL, 62263),
(62264, '2.130.10.10-FF-004588', NULL, 'Predicted protein', 207, NULL, NULL, 62264),
(62265, '1.20.58.60-FF-000128', NULL, 'Dystrophin related protein 2', 129, NULL, NULL, 62265),
(62266, '1.10.1370.30-FF-000036', NULL, 'Angiotensin-converting enzyme', 139, NULL, NULL, 62266),
(62267, '2.60.40.2300-FF-000012', NULL, 'Chromosome 1, whole genome shotgun sequence', 147, NULL, NULL, 62267),
(62268, '3.40.250.10-FF-000053', NULL, 'Rhodanese like protein, putative', 162, NULL, NULL, 62268),
(62269, '1.25.40.180-FF-000327', NULL, NULL, 187, NULL, NULL, 62269),
(62270, '3.90.1200.10-FF-000032', NULL, 'Probable ethanolamine kinase', 247, NULL, NULL, 62270),
(62271, '1.20.1050.10-FF-000043', NULL, 'Failed axon connections, isoform B', 104, NULL, NULL, 62271),
(62272, '3.40.850.10-FF-000155', NULL, 'Chitin synthase 8', 241, NULL, NULL, 62272),
(62273, '3.90.1290.10-FF-000077', NULL, 'Uncharacterized protein', 99, NULL, NULL, 62273),
(62274, '2.60.40.1390-FF-000008', NULL, 'Myelin regulatory factor', 114, NULL, NULL, 62274),
(62275, '3.40.50.2300-FF-000724', NULL, NULL, 80, NULL, NULL, 62275),
(62276, '3.40.1190.20-FF-000218', NULL, NULL, 265, NULL, NULL, 62276),
(62277, '3.40.50.150-FF-001362', NULL, NULL, 184, NULL, NULL, 62277),
(62278, '3.30.160.390-FF-000004', NULL, 'Site-specific recombinase, phage integrase family', 85, NULL, NULL, 62278),
(62279, '1.20.5.170-FF-000255', NULL, 'AFL160Cp', 50, NULL, NULL, 62279),
(62280, '1.20.1250.20-FF-002186', NULL, 'Inositol transporter 4', 165, NULL, NULL, 62280),
(62281, '2.60.40.60-FF-000544', NULL, 'Cadherin 16, KSP-cadherin', 65, NULL, NULL, 62281),
(62282, '1.10.510.10-FF-004483', NULL, NULL, 249, NULL, NULL, 62282),
(62283, '2.40.70.10-FF-000329', NULL, NULL, 217, NULL, NULL, 62283),
(62284, '3.50.50.60-FF-001369', NULL, 'AER292Cp', 184, NULL, NULL, 62284),
(62285, '3.40.50.2300-FF-001000', NULL, NULL, 130, NULL, NULL, 62285),
(62286, '3.80.10.10-FF-002519', NULL, 'Uncharacterized protein', 237, NULL, NULL, 62286),
(62287, '1.10.238.10-FF-000533', NULL, 'Centrin', 77, NULL, NULL, 62287),
(62288, '2.60.40.10-FF-000102', NULL, 'filamin-B isoform X2', 97, NULL, NULL, 62288),
(62289, '3.50.7.10-FF-000064', NULL, NULL, 97, NULL, NULL, 62289),
(62290, '3.40.1280.10-FF-000110', NULL, 'tRNA (pseudouridine(54)-N(1))-methyltransferase', 102, NULL, NULL, 62290),
(62291, '1.10.10.10-FF-000892', NULL, 'RNA polymerase sigma factor', 78, NULL, NULL, 62291),
(62292, '2.30.29.30-FF-000780', NULL, 'Uncharacterized protein', 112, NULL, NULL, 62292),
(62293, '1.20.1070.10-FF-000730', NULL, 'Adhesion G protein-coupled receptor G3', 306, NULL, NULL, 62293),
(62294, '3.90.810.10-FF-000017', NULL, 'Wiskott-Aldrich syndrome (eczema-thrombocytopenia) b', 65, NULL, NULL, 62294);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(62295, '3.30.200.110-FF-000009', NULL, NULL, 149, NULL, NULL, 62295),
(62296, '2.60.40.1180-FF-000182', NULL, 'Alpha-glucosidase', 157, NULL, NULL, 62296),
(62297, '3.20.20.120-FF-000036', NULL, 'L-amino acid-D/L-Glu epimerase', 222, NULL, NULL, 62297),
(62298, '3.40.50.720-FF-001791', NULL, 'Shikimate dehydrogenase (NADP(+))', 128, NULL, NULL, 62298),
(62299, '1.25.40.20-FF-000447', NULL, 'synphilin-1 isoform X3', 136, NULL, NULL, 62299),
(62300, '1.10.10.1120-FF-000001', NULL, 'Lysin B', 69, NULL, NULL, 62300),
(62301, '3.40.50.720-FF-000381', NULL, 'Probable polyketide synthase pks17', 256, NULL, NULL, 62301),
(62302, '2.40.70.10-FF-000009', NULL, 'Aspartic proteinase A1', 211, NULL, NULL, 62302),
(62303, '3.80.10.10-FF-004088', NULL, 'Tubulin-specific chaperone E', 124, NULL, NULL, 62303),
(62304, '2.60.120.260-FF-000384', NULL, 'Beta-galactosidase (Eurofung)', 11, NULL, NULL, 62304),
(62305, '1.10.472.170-FF-000021', NULL, 'Uncharacterized protein', 192, NULL, NULL, 62305),
(62306, '3.15.10.20-FF-000003', NULL, 'Activator of Hsp90 ATPase', 158, NULL, NULL, 62306),
(62307, '2.10.50.10-FF-000032', NULL, 'Uncharacterized protein, isoform A', 61, NULL, NULL, 62307),
(62308, '1.20.1250.20-FF-000056', NULL, 'Enterobactin exporter EntS', 388, NULL, NULL, 62308),
(62309, '3.80.10.10-FF-003823', NULL, 'Uncharacterized protein', 73, NULL, NULL, 62309),
(62310, '1.10.150.530-FF-000016', NULL, 'Ribosomal RNA large subunit methyltransferase N', 65, NULL, NULL, 62310),
(62311, '3.40.50.300-FF-002525', NULL, 'mRNA cleavage and polyadenylation factor CLP1', 240, NULL, NULL, 62311),
(62312, '3.30.70.330-FF-000730', NULL, 'RNA-binding protein, putative', 98, NULL, NULL, 62312),
(62313, '2.30.40.10-FF-000036', NULL, 'Probable N-acetylglucosamine-6-phosphate deacetylase nagA', 74, NULL, NULL, 62313),
(62314, '2.60.40.1730-FF-000032', NULL, 'Uncharacterized protein', 208, NULL, NULL, 62314),
(62315, '3.40.190.10-FF-000008', NULL, 'ATP phosphoribosyltransferase', 84, NULL, NULL, 62315),
(62316, '3.30.559.70-FF-000008', NULL, 'carnitine O-palmitoyltransferase 1, brain isoform', 315, NULL, NULL, 62316),
(62317, '1.25.40.20-FF-001167', NULL, 'Kinase, NEK', 123, NULL, NULL, 62317),
(62318, '1.25.40.20-FF-000902', NULL, 'Predicted ankyrin repeat family protein', 165, NULL, NULL, 62318),
(62319, '3.40.1110.10-FF-000109', NULL, 'Phospholipid-transporting ATPase', 73, NULL, NULL, 62319),
(62320, '1.10.12.10-FF-000031', NULL, 'Putative enoyl-CoA hydratase', 58, NULL, NULL, 62320),
(62321, '3.40.50.10810-FF-000090', NULL, 'Similarity to HELICASE MOT1', 256, NULL, NULL, 62321),
(62322, '1.20.1250.20-FF-001337', NULL, 'Uncharacterized protein', 161, NULL, NULL, 62322),
(62323, '1.20.5.110-FF-000035', NULL, 'Syntaxin-22 like', 101, NULL, NULL, 62323),
(62324, '1.25.10.10-FF-000717', NULL, 'Ycg1p', 239, NULL, NULL, 62324),
(62325, '1.10.460.10-FF-000004', NULL, 'DNA topoisomerase 3', 160, NULL, NULL, 62325),
(62326, '3.40.50.300-FF-002868', NULL, 'Eukaryotic translation elongation factor 1 alpha 2', 250, NULL, NULL, 62326),
(62327, '2.130.10.10-FF-004245', NULL, 'Uncharacterized protein', 140, NULL, NULL, 62327),
(62328, '3.40.50.1820-FF-000670', NULL, 'Lipase', 383, NULL, NULL, 62328),
(62329, '3.30.160.60-FF-001951', NULL, 'Stp4p', 84, NULL, NULL, 62329),
(62330, '1.25.50.20-FF-000032', NULL, 'Aminopeptidase', 279, NULL, NULL, 62330),
(62331, '3.30.200.20-FF-002410', NULL, 'Uncharacterized protein', 88, NULL, NULL, 62331),
(62332, '1.10.510.10-FF-003544', NULL, NULL, 234, NULL, NULL, 62332),
(62333, '6.10.140.2220-FF-000012', NULL, 'zinc finger MYND domain-containing protein 15', 56, NULL, NULL, 62333),
(62334, '3.40.50.1110-FF-000114', NULL, 'Uncharacterized protein', 124, NULL, NULL, 62334),
(62335, '2.80.10.50-FF-000201', NULL, 'Predicted protein', 218, NULL, NULL, 62335),
(62336, '1.25.10.10-FF-001117', NULL, 'Coatomer subunit gamma', 142, NULL, NULL, 62336),
(62337, '1.20.120.1240-FF-000003', NULL, 'Dynamin-1 isoform 1', 203, NULL, NULL, 62337),
(62338, '3.30.70.1390-FF-000004', NULL, 'Leucine-rich repeat kinase, isoform C', 84, NULL, NULL, 62338);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(62339, '2.60.120.650-FF-000051', NULL, 'JmjC domain containing protein', 128, NULL, NULL, 62339),
(62340, '3.30.565.10-FF-000393', NULL, 'Sensor histidine kinase', 145, NULL, NULL, 62340),
(62341, '2.60.40.10-FF-003536', NULL, NULL, 95, NULL, NULL, 62341),
(62342, '2.160.20.10-FF-000220', NULL, 'Predicted protein', 295, NULL, NULL, 62342),
(62343, '3.90.740.10-FF-000023', NULL, 'Isoleucine--tRNA ligase, putative', 211, NULL, NULL, 62343),
(62344, '1.20.1310.10-FF-000221', NULL, NULL, 53, NULL, NULL, 62344),
(62345, '3.30.450.190-FF-000015', NULL, 'GTP-binding protein putative', 123, NULL, NULL, 62345),
(62346, '2.60.40.1940-FF-000005', NULL, 'Thioester-containing protein 3', 114, NULL, NULL, 62346),
(62347, '2.10.50.30-FF-000038', NULL, 'Uncharacterized protein', 79, NULL, NULL, 62347),
(62348, '2.60.40.10-FF-002255', NULL, 'Izumo sperm-egg fusion 1', 93, NULL, NULL, 62348),
(62349, '3.50.4.10-FF-000041', NULL, 'Glycosyltransferase family 31 protein', 71, NULL, NULL, 62349),
(62350, '2.30.30.40-FF-000191', NULL, 'E3 ubiquitin-protein ligase SH3RF2 isoform X2', 67, NULL, NULL, 62350),
(62351, '2.70.20.10-FF-000027', NULL, 'DNA topoisomerase', 60, NULL, NULL, 62351),
(62352, '3.30.160.60-FF-001058', NULL, 'zinc finger and BTB domain-containing protein 38', 42, NULL, NULL, 62352),
(62353, '3.30.160.60-FF-000439', NULL, 'Zinc finger RNA-binding protein 2', 51, NULL, NULL, 62353),
(62354, '3.40.50.720-FF-000942', NULL, 'Phosphoglycerate dehydrogenase-like enzyme', 90, NULL, NULL, 62354),
(62355, '2.130.10.10-FF-005998', NULL, 'Uncharacterized protein', 100, NULL, NULL, 62355),
(62356, '3.30.420.40-FF-000499', NULL, 'Fumble family protein', 173, NULL, NULL, 62356),
(62357, '3.90.1150.10-FF-000258', NULL, 'Aspartate aminotransferase', 140, NULL, NULL, 62357),
(62358, '1.20.5.420-FF-000021', NULL, 'Vta1 like, putative', 40, NULL, NULL, 62358),
(62359, '1.10.510.10-FF-001173', NULL, 'Mitogen-activated protein kinase, putative', 209, NULL, NULL, 62359),
(62360, '2.30.30.40-FF-000314', NULL, 'Unplaced genomic scaffold supercont1.257, whole genome shotgun sequence', 59, NULL, NULL, 62360),
(62361, '3.30.450.60-FF-000074', NULL, 'Uncharacterized protein', 143, NULL, NULL, 62361),
(62362, '1.25.40.20-FF-001728', NULL, 'Uncharacterized protein', 226, NULL, NULL, 62362),
(62363, '3.80.10.10-FF-002851', NULL, 'Uncharacterized protein', 93, NULL, NULL, 62363),
(62364, '3.50.50.60-FF-000739', NULL, 'Uncharacterized protein', 199, NULL, NULL, 62364),
(62365, '3.40.50.720-FF-000049', NULL, 'Alanine dehydrogenase', 176, NULL, NULL, 62365),
(62366, '2.10.110.10-FF-000143', NULL, 'Protein CBG21573', 74, NULL, NULL, 62366),
(62367, '2.150.10.10-FF-000023', NULL, NULL, 178, NULL, NULL, 62367),
(62368, '3.90.120.10-FF-000032', NULL, 'DNA (cytosine-5)-methyltransferase', 54, NULL, NULL, 62368),
(62369, '1.10.510.10-FF-000897', NULL, 'AGC protein kinase', 221, NULL, NULL, 62369),
(62370, '1.10.510.10-FF-002583', NULL, NULL, 224, NULL, NULL, 62370),
(62371, '1.10.220.150-FF-000071', NULL, 'ArfGAP with RhoGAP domain, ankyrin repeat and PH domain 1', 88, NULL, NULL, 62371),
(62372, '2.60.40.60-FF-000100', NULL, 'protocadherin Fat 2', 100, NULL, NULL, 62372),
(62373, '3.10.450.350-FF-000006', NULL, 'Peptidase M23', 97, NULL, NULL, 62373),
(62374, '3.30.160.60-FF-006178', NULL, NULL, 64, NULL, NULL, 62374),
(62375, '2.60.120.1030-FF-000007', NULL, 'Protein CLP1 homolog', 84, NULL, NULL, 62375),
(62376, '1.10.472.10-FF-000223', NULL, 'BRF2, RNA polymerase III transcription initiation factor subunit', 103, NULL, NULL, 62376),
(62377, '3.40.30.10-FF-000628', NULL, 'Glutaredoxin-like protein C5orf63 homolog', 77, NULL, NULL, 62377),
(62378, '3.30.160.60-FF-000990', NULL, 'zinc finger protein 629 isoform X2', 30, NULL, NULL, 62378),
(62379, '2.60.40.2030-FF-000009', NULL, 'adhesion G-protein coupled receptor V1', 134, NULL, NULL, 62379),
(62380, '3.90.180.10-FF-000053', NULL, 'Chloroplast envelope quinone oxidoreductase homolog', 176, NULL, NULL, 62380),
(62381, '3.30.379.10-FF-000022', NULL, NULL, 132, NULL, NULL, 62381),
(62382, '2.40.110.10-FF-000007', NULL, 'Medium-chain specific acyl-CoA dehydrogenase, mitochondrial', 117, NULL, NULL, 62382);
INSERT INTO "PUBLIC"."MODEL" VALUES
(62383, '3.30.160.60-FF-000097', NULL, 'Zinc finger protein', 29, NULL, NULL, 62383),
(62384, '3.40.50.300-FF-004863', NULL, 'MutS family protein', 293, NULL, NULL, 62384),
(62385, '1.20.1270.240-FF-000001', NULL, NULL, 88, NULL, NULL, 62385),
(62386, '2.120.10.30-FF-000502', NULL, 'Uncharacterized protein', 215, NULL, NULL, 62386),
(62387, '2.60.40.10-FF-003879', NULL, NULL, 91, NULL, NULL, 62387),
(62388, '1.10.565.10-FF-000141', NULL, 'Uncharacterized protein', 242, NULL, NULL, 62388),
(62389, '2.60.120.200-FF-000405', NULL, 'Metalloendopeptidase', 167, NULL, NULL, 62389),
(62390, '3.40.50.10240-FF-000014', NULL, 'AGAP002968-PA', 144, NULL, NULL, 62390),
(62391, '2.40.50.730-FF-000022', NULL, 'DNA polymerase', 74, NULL, NULL, 62391),
(62392, '3.60.10.10-FF-000227', NULL, 'Uncharacterized protein', 142, NULL, NULL, 62392),
(62393, '1.25.40.10-FF-004952', NULL, 'Predicted protein', 315, NULL, NULL, 62393),
(62394, '3.30.160.60-FF-005661', NULL, NULL, 30, NULL, NULL, 62394),
(62395, '3.40.50.2000-FF-000275', NULL, 'Sterol 3-beta-glucosyltransferase', 266, NULL, NULL, 62395),
(62396, '1.10.8.60-FF-000091', NULL, 'Lon protease homolog 2, peroxisomal', 101, NULL, NULL, 62396),
(62397, '2.60.40.10-FF-004155', NULL, NULL, 89, NULL, NULL, 62397),
(62398, '3.40.50.10860-FF-000076', NULL, 'Methylenetetrahydrofolate dehydrogenase/ methylenetetrahydrofolate cyclohydrolase', 32, NULL, NULL, 62398),
(62399, '3.30.2350.20-FF-000060', NULL, NULL, 157, NULL, NULL, 62399),
(62400, '3.40.50.10900-FF-000026', NULL, 'Predicted protein', 66, NULL, NULL, 62400),
(62401, '2.40.100.10-FF-000046', NULL, 'Peptidyl-prolyl cis-trans isomerase E', 179, NULL, NULL, 62401),
(62402, '3.30.710.10-FF-000153', NULL, 'rho-related BTB domain-containing protein 3', 119, NULL, NULL, 62402),
(62403, '3.30.200.20-FF-000510', NULL, 'serine/threonine-protein kinase D6PKL2', 86, NULL, NULL, 62403),
(62404, '3.30.519.10-FF-000011', NULL, 'Rab GDP dissociation inhibitor', 154, NULL, NULL, 62404),
(62405, '2.130.10.10-FF-000193', NULL, 'Protein transport protein SEC31, putative', 332, NULL, NULL, 62405),
(62406, '1.20.1560.10-FF-000705', NULL, 'Multidrug resistance ABC transporter ATP-binding and permease protein', 323, NULL, NULL, 62406),
(62407, '1.50.40.10-FF-000268', NULL, 'Mitochondrial dicarboxylate carrier', 277, NULL, NULL, 62407),
(62408, '3.80.10.10-FF-002290', NULL, 'AGAP001470-PA', 228, NULL, NULL, 62408),
(62409, '1.10.10.60-FF-000182', NULL, 'Paired like homeobox 2B', 71, NULL, NULL, 62409),
(62410, '3.30.830.10-FF-000072', NULL, 'Presequence protease', 272, NULL, NULL, 62410),
(62411, '2.30.30.180-FF-000001', NULL, 'Ribosome maturation factor RimP', 61, NULL, NULL, 62411),
(62412, '3.30.465.10-FF-000020', NULL, 'HlyC/CorC family transporter', 92, NULL, NULL, 62412),
(62413, '3.90.1150.220-FF-000011', NULL, 'AGAP005461-PA', 98, NULL, NULL, 62413),
(62414, '1.20.1250.20-FF-000617', NULL, 'YALI0F19118p', 208, NULL, NULL, 62414),
(62415, '3.40.50.300-FF-003582', NULL, 'Lipopolysaccharide/O-antigen transport protein', 215, NULL, NULL, 62415),
(62416, '1.25.40.10-FF-005216', NULL, 'Uncharacterized protein', 198, NULL, NULL, 62416),
(62417, '2.60.240.10-FF-000001', NULL, 'Chemokine binding protein', 257, NULL, NULL, 62417),
(62418, '2.30.29.30-FF-001398', NULL, 'Uncharacterized protein', 150, NULL, NULL, 62418),
(62419, '3.20.20.70-FF-000601', NULL, NULL, 163, NULL, NULL, 62419),
(62420, '1.20.1730.10-FF-000073', NULL, 'Uncharacterized protein', 67, NULL, NULL, 62420),
(62421, '1.10.8.710-FF-000032', NULL, NULL, 51, NULL, NULL, 62421),
(62422, '2.130.10.10-FF-002671', NULL, 'Uncharacterized protein', 274, NULL, NULL, 62422),
(62423, '3.40.50.1820-FF-001390', NULL, 'Carboxylesterase SOBER1', 217, NULL, NULL, 62423),
(62424, '1.10.3450.20-FF-000006', NULL, 'Nuclear pore complex protein', 137, NULL, NULL, 62424),
(62425, '3.80.10.10-FF-002750', NULL, 'Os08g0195900 protein', 97, NULL, NULL, 62425),
(62426, '3.30.200.20-FF-001230', NULL, 'Non-specific protein-tyrosine kinase', 95, NULL, NULL, 62426),
(62427, '3.10.105.10-FF-000077', NULL, 'ABC transporter substrate-binding protein', 216, NULL, NULL, 62427);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(62428, '2.60.40.10-FF-000557', NULL, 'Myosin binding protein Ha', 100, NULL, NULL, 62428),
(62429, '2.60.40.420-FF-000018', NULL, 'Lamin-like protein', 103, NULL, NULL, 62429),
(62430, '3.40.50.300-FF-006336', NULL, 'Uncharacterized protein', 100, NULL, NULL, 62430),
(62431, '3.30.160.60-FF-003761', NULL, 'GH19651p', 68, NULL, NULL, 62431),
(62432, '3.40.50.720-FF-001111', NULL, '2-hydroxyacid dehydrogenase family protein', 190, NULL, NULL, 62432),
(62433, '2.130.10.10-FF-003183', NULL, 'Polyadenylation factor subunit 2', 139, NULL, NULL, 62433),
(62434, '1.25.40.10-FF-002462', NULL, 'Pentatricopeptide repeat-containing protein At1g25360', 119, NULL, NULL, 62434),
(62435, '3.90.810.10-FF-000012', NULL, 'Non-specific serine/threonine protein kinase', 77, NULL, NULL, 62435),
(62436, '2.20.100.10-FF-000039', NULL, 'thrombospondin type-1 domain-containing protein 4', 54, NULL, NULL, 62436),
(62437, '1.50.10.10-FF-000204', NULL, 'Uncharacterized protein', 199, NULL, NULL, 62437),
(62438, '2.40.70.10-FF-000560', NULL, NULL, 120, NULL, NULL, 62438),
(62439, '3.10.20.90-FF-000804', NULL, 'Predicted protein', 43, NULL, NULL, 62439),
(62440, '3.40.50.80-FF-000038', NULL, 'Vibriobactin utilization protein ViuB', 143, NULL, NULL, 62440),
(62441, '1.20.920.10-FF-000206', NULL, 'Predicted protein', 117, NULL, NULL, 62441),
(62442, '1.20.120.550-FF-000031', NULL, 'Uncharacterized protein', 74, NULL, NULL, 62442),
(62443, '3.40.1000.30-FF-000012', NULL, 'Predicted protein', 165, NULL, NULL, 62443),
(62444, '1.20.90.10-FF-000014', NULL, 'Secretory phospholipase A2', 122, NULL, NULL, 62444),
(62445, '2.60.40.60-FF-000999', NULL, 'Uncharacterized protein', 42, NULL, NULL, 62445),
(62446, '2.60.40.3180-FF-000012', NULL, 'Uncharacterized protein', 55, NULL, NULL, 62446),
(62447, '3.90.1530.10-FF-000017', NULL, 'Uncharacterized protein', 80, NULL, NULL, 62447),
(62448, '1.10.10.250-FF-000021', NULL, 'Uncharacterized protein', 83, NULL, NULL, 62448),
(62449, '2.60.200.40-FF-000002', NULL, 'Diacylglycerol kinase', 169, NULL, NULL, 62449),
(62450, '1.25.40.180-FF-000114', NULL, 'Protein CBR-SMG-3', 308, NULL, NULL, 62450),
(62451, '3.40.50.1000-FF-000637', NULL, NULL, 159, NULL, NULL, 62451),
(62452, '3.40.140.10-FF-000180', NULL, 'Eukaryotic translation initiation factor 3 subunit F', 178, NULL, NULL, 62452),
(62453, '3.90.850.10-FF-000014', NULL, 'Uncharacterized mitochondrial hydrolase FMP41', 227, NULL, NULL, 62453),
(62454, '3.90.830.10-FF-000007', NULL, 'Vacuolar protein sorting-associated protein 45', 114, NULL, NULL, 62454),
(62455, '3.40.50.2300-FF-001449', NULL, NULL, 22, NULL, NULL, 62455),
(62456, '1.10.150.50-FF-000122', NULL, 'CG5272 protein', 68, NULL, NULL, 62456),
(62457, '3.90.550.50-FF-000189', NULL, 'Uncharacterized protein', 210, NULL, NULL, 62457),
(62458, '1.10.20.10-FF-000263', NULL, NULL, 148, NULL, NULL, 62458),
(62459, '3.30.830.10-FF-000313', NULL, 'Uncharacterized protein', 189, NULL, NULL, 62459),
(62460, '2.60.120.620-FF-000059', NULL, 'Proline-4-hydroxylase', 265, NULL, NULL, 62460),
(62461, '3.30.2290.10-FF-000012', NULL, 'PmbA/TldD related protein', 229, NULL, NULL, 62461),
(62462, '3.30.420.40-FF-000931', NULL, 'Actin-like protein arp10', 107, NULL, NULL, 62462),
(62463, '3.40.190.10-FF-000795', NULL, 'Arogenate dehydratase', 54, NULL, NULL, 62463),
(62464, '3.40.50.2300-FF-001556', NULL, NULL, 20, NULL, NULL, 62464),
(62465, '3.40.50.2300-FF-000937', NULL, NULL, 175, NULL, NULL, 62465),
(62466, '3.40.50.720-FF-001004', NULL, 'HesA/MoeB/ThiF family protein', 207, NULL, NULL, 62466),
(62467, '2.40.50.140-FF-000171', NULL, 'meiosis-specific with OB domain-containing protein isoform X1', 134, NULL, NULL, 62467),
(62468, '3.90.1150.10-FF-000027', NULL, 'Adenosylmethionine-8-amino-7-oxononanoate aminotransferase, probable', 152, NULL, NULL, 62468),
(62469, '1.10.150.20-FF-000012', NULL, 'Holliday junction ATP-dependent DNA helicase RuvA', 76, NULL, NULL, 62469),
(62470, '3.40.220.10-FF-000006', NULL, 'ganglioside-induced differentiation-associated protein 2 isoform X1', 228, NULL, NULL, 62470);
INSERT INTO "PUBLIC"."MODEL" VALUES
(62471, '3.10.350.10-FF-000022', NULL, 'Cell wall hydrolase', 67, NULL, NULL, 62471),
(62472, '1.10.510.10-FF-004163', NULL, NULL, 191, NULL, NULL, 62472),
(62473, '1.25.10.10-FF-003146', NULL, 'Uncharacterized protein', 91, NULL, NULL, 62473),
(62474, '3.30.2350.10-FF-000051', NULL, 'H/ACA ribonucleoprotein complex subunit DKC1', 136, NULL, NULL, 62474),
(62475, '2.70.160.11-FF-000016', NULL, 'Protein arginine methyltransferase RmtB', 193, NULL, NULL, 62475),
(62476, '3.30.1370.210-FF-000041', NULL, 'Uncharacterized protein', 64, NULL, NULL, 62476),
(62477, '1.25.40.10-FF-005109', NULL, 'Uncharacterized protein', 118, NULL, NULL, 62477),
(62478, '1.10.10.60-FF-000187', NULL, 'homeobox protein DBX2', 76, NULL, NULL, 62478),
(62479, '3.40.50.1820-FF-000771', NULL, 'Hydrolase, alpha/beta fold family-like protein', 286, NULL, NULL, 62479),
(62480, '3.40.190.10-FF-000688', NULL, 'Uncharacterized protein', 111, NULL, NULL, 62480),
(62481, '2.130.10.10-FF-002564', NULL, 'Uncharacterized protein', 232, NULL, NULL, 62481),
(62482, '2.40.160.50-FF-000045', NULL, 'Predicted protein', 92, NULL, NULL, 62482),
(62483, '2.10.110.10-FF-000250', NULL, 'Uncharacterized protein', 62, NULL, NULL, 62483),
(62484, '1.20.5.110-FF-000260', NULL, 'Synaptobrevin-domain-containing protein', 85, NULL, NULL, 62484),
(62485, '3.60.15.10-FF-000070', NULL, 'Glyoxylase, beta-lactamase superfamily II', 229, NULL, NULL, 62485),
(62486, '3.30.710.10-FF-000147', NULL, 'Predicted gene 4858', 124, NULL, NULL, 62486),
(62487, '1.20.1070.10-FF-001354', NULL, 'Vomeronasal type-1 receptor', 266, NULL, NULL, 62487),
(62488, '3.30.160.60-FF-004380', NULL, NULL, 32, NULL, NULL, 62488),
(62489, '2.130.10.10-FF-001047', NULL, 'Stress protein', 265, NULL, NULL, 62489),
(62490, '3.40.50.150-FF-000642', NULL, 'Fibrillarin putative', 178, NULL, NULL, 62490),
(62491, '3.30.200.20-FF-001797', NULL, 'Serine/threonine protein kinase', 96, NULL, NULL, 62491),
(62492, '1.20.900.10-FF-000104', NULL, 'Uncharacterized protein', 196, NULL, NULL, 62492),
(62493, '3.40.50.300-FF-008472', NULL, 'Uncharacterized protein', 232, NULL, NULL, 62493),
(62494, '3.30.200.20-FF-000274', NULL, 'Calcium/calmodulin-regulated receptor-like kinase 1', 103, NULL, NULL, 62494),
(62495, '2.40.30.10-FF-000451', NULL, 'Mitochondrial ribosomal protein L3', 55, NULL, NULL, 62495),
(62496, '1.25.40.10-FF-000326', NULL, 'ER membrane protein complex subunit 2', 262, NULL, NULL, 62496),
(62497, '2.40.50.140-FF-000856', NULL, NULL, 95, NULL, NULL, 62497),
(62498, '3.40.50.300-FF-002969', NULL, 'Putative ATP-dependent DNA helicase DDX11', 249, NULL, NULL, 62498),
(62499, '3.20.20.70-FF-000596', NULL, NULL, 111, NULL, NULL, 62499),
(62500, '1.20.1250.20-FF-000724', NULL, 'Monocarboxylate transporter, putative', 191, NULL, NULL, 62500),
(62501, '1.10.1370.10-FF-000053', NULL, 'Uncharacterized protein', 61, NULL, NULL, 62501),
(62502, '3.40.50.300-FF-000608', NULL, 'Mov10 RISC complex RNA helicase', 214, NULL, NULL, 62502),
(62503, '2.30.180.10-FF-000098', NULL, NULL, 136, NULL, NULL, 62503),
(62504, '3.10.20.90-FF-000799', NULL, 'Uncharacterized protein', 56, NULL, NULL, 62504),
(62505, '3.40.50.2300-FF-000252', NULL, 'Uncharacterized protein', 315, NULL, NULL, 62505),
(62506, '4.10.280.10-FF-000052', NULL, 'Protein atonal homolog 8', 66, NULL, NULL, 62506),
(62507, '3.10.450.350-FF-000001', NULL, 'Murein DD-endopeptidase MepM', 102, NULL, NULL, 62507),
(62508, '3.30.710.10-FF-000254', NULL, 'Potassium voltage-gated channel, putative', 116, NULL, NULL, 62508),
(62509, '1.10.490.10-FF-000057', NULL, 'GLoBin related', 154, NULL, NULL, 62509),
(62510, '2.60.40.10-FF-002699', NULL, 'Gingipain R2', 85, NULL, NULL, 62510),
(62511, '1.10.10.540-FF-000001', NULL, 'UV excision repair protein RAD23 B', 66, NULL, NULL, 62511),
(62512, '3.40.50.720-FF-002308', NULL, 'Uncharacterized protein', 139, NULL, NULL, 62512),
(62513, '1.10.238.10-FF-000977', NULL, 'Uncharacterized protein', 78, NULL, NULL, 62513),
(62514, '2.60.40.10-FF-003216', NULL, NULL, 102, NULL, NULL, 62514),
(62515, '3.90.70.10-FF-000533', NULL, 'Ubiquitinyl hydrolase 1', 350, NULL, NULL, 62515);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(62516, '3.30.70.60-FF-000005', NULL, 'Pilus assembly protein, PilO', 106, NULL, NULL, 62516),
(62517, '2.130.10.10-FF-000209', NULL, 'sterol regulatory element-binding protein cleavage-activating protein-like', 308, NULL, NULL, 62517),
(62518, '1.20.1250.20-FF-001562', NULL, 'Transport protein', 389, NULL, NULL, 62518),
(62519, '2.60.40.10-FF-003323', NULL, 'Uncharacterized protein', 87, NULL, NULL, 62519),
(62520, '2.60.120.200-FF-000506', NULL, 'Agrin', 181, NULL, NULL, 62520),
(62521, '3.30.160.60-FF-000102', NULL, 'zinc finger protein 850 isoform X1', 28, NULL, NULL, 62521),
(62522, '4.10.640.10-FF-000035', NULL, '28S ribosomal protein S18a, mitochondrial', 51, NULL, NULL, 62522),
(62523, '1.10.30.10-FF-000084', NULL, 'HMG type nucleosome/chromatin assembly factor', 70, NULL, NULL, 62523),
(62524, '1.10.287.820-FF-000007', NULL, 'Pickpocket 12', 85, NULL, NULL, 62524),
(62525, '2.130.10.10-FF-005318', NULL, 'Vegetative incompatibility WD repeat protein, putative', 202, NULL, NULL, 62525),
(62526, '3.40.30.10-FF-000387', NULL, 'Predicted protein', 112, NULL, NULL, 62526),
(62527, '1.20.1070.10-FF-001247', NULL, 'Adhesion G protein-coupled receptor G1', 288, NULL, NULL, 62527),
(62528, '2.60.120.260-FF-000159', NULL, 'Monopolar spindle', 205, NULL, NULL, 62528),
(62529, '3.30.1320.10-FF-000004', NULL, '28S ribosomal protein S16, mitochondrial', 131, NULL, NULL, 62529),
(62530, '1.10.3370.10-FF-000053', NULL, 'Preprotein translocase secY subunit', 459, NULL, NULL, 62530),
(62531, '1.10.510.10-FF-000796', NULL, 'Stress response kinase A', 134, NULL, NULL, 62531),
(62532, '2.130.10.10-FF-000198', NULL, 'VPS10 domain-containing receptor SorCS1 isoform X2', 149, NULL, NULL, 62532),
(62533, '2.60.40.60-FF-000095', NULL, 'Cadherin 13', 106, NULL, NULL, 62533),
(62534, '3.30.70.270-FF-000015', NULL, 'Genome polyprotein', 113, NULL, NULL, 62534),
(62535, '3.30.1010.10-FF-000138', NULL, 'Uncharacterized protein', 149, NULL, NULL, 62535),
(62536, '1.25.40.10-FF-003766', NULL, 'Uncharacterized protein', 162, NULL, NULL, 62536),
(62537, '1.10.238.10-FF-000292', NULL, 'Calcium-binding protein CML38', 72, NULL, NULL, 62537),
(62538, '1.25.10.10-FF-001229', NULL, 'Armadillo/beta-catenin-like_repeat_-_putative', 290, NULL, NULL, 62538),
(62539, '2.120.10.30-FF-000053', NULL, 'protein yellow', 340, NULL, NULL, 62539),
(62540, '2.60.40.10-FF-001395', NULL, 'Platelet-derived growth factor receptor-like protein', 108, NULL, NULL, 62540),
(62541, '3.90.1310.10-FF-000029', NULL, 'Penicillin-binding protein 2', 127, NULL, NULL, 62541),
(62542, '1.20.5.420-FF-000027', NULL, 'Ribonuclease P protein component 4', 51, NULL, NULL, 62542),
(62543, '3.40.50.300-FF-005032', NULL, 'Predicted protein', 135, NULL, NULL, 62543),
(62544, '1.10.10.60-FF-001036', NULL, NULL, 77, NULL, NULL, 62544),
(62545, '1.25.40.20-FF-001627', NULL, 'Poly [ADP-ribose] polymerase', 97, NULL, NULL, 62545),
(62546, '3.60.21.50-FF-000017', NULL, 'Uncharacterized protein', 290, NULL, NULL, 62546),
(62547, '1.20.58.390-FF-000085', NULL, 'Gamma-aminobutyric acid type A receptor pi subunit', 109, NULL, NULL, 62547),
(62548, '3.30.1330.20-FF-000047', NULL, 'Beta tubulin,putative', 119, NULL, NULL, 62548),
(62549, '1.20.1070.10-FF-000735', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 2', 170, NULL, NULL, 62549),
(62550, '3.40.50.12470-FF-000020', NULL, NULL, 291, NULL, NULL, 62550),
(62551, '3.30.40.10-FF-001591', NULL, 'Histone-lysine N-methyltransferase set-26', 78, NULL, NULL, 62551),
(62552, '1.25.40.570-FF-000017', NULL, '26S proteasome non-ATPase regulatory subunit 3', 324, NULL, NULL, 62552),
(62553, '3.30.60.20-FF-000066', NULL, 'Diacylglycerol kinase', 73, NULL, NULL, 62553),
(62554, '1.10.238.10-FF-000752', NULL, 'RAB11 family-interacting protein 3 (class II)', 99, NULL, NULL, 62554),
(62555, '1.20.58.1380-FF-000009', NULL, 'Uncharacterized protein', 92, NULL, NULL, 62555),
(62556, '3.30.497.10-FF-000127', NULL, 'Uncharacterized protein', 158, NULL, NULL, 62556),
(62557, '3.30.760.10-FF-000077', NULL, 'Predicted protein', 183, NULL, NULL, 62557);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(62558, '3.30.60.20-FF-000089', NULL, 'Diacylglycerol kinase', 61, NULL, NULL, 62558),
(62559, '2.10.50.30-FF-000015', NULL, 'Uncharacterized protein', 45, NULL, NULL, 62559),
(62560, '1.20.120.20-FF-000025', NULL, 'Uncharacterized protein', 116, NULL, NULL, 62560),
(62561, '3.40.50.1820-FF-001176', NULL, 'Predicted protein', 255, NULL, NULL, 62561),
(62562, '1.50.10.130-FF-000015', NULL, 'Acyclic sesquiterpene synthase', 223, NULL, NULL, 62562),
(62563, '2.40.50.730-FF-000027', NULL, 'Uncharacterized protein', 98, NULL, NULL, 62563),
(62564, '1.10.510.10-FF-000666', NULL, 'myosin light chain kinase, smooth muscle isoform X5', 168, NULL, NULL, 62564),
(62565, '4.10.60.10-FF-000174', NULL, 'mRNA-binding translational activator', 35, NULL, NULL, 62565),
(62566, '1.25.10.10-FF-002634', NULL, 'GH03057p', 123, NULL, NULL, 62566),
(62567, '1.20.1080.10-FF-000112', NULL, 'Aquaporin rerated protein', 138, NULL, NULL, 62567),
(62568, '2.60.120.200-FF-000169', NULL, 'Uncharacterized protein, isoform C', 190, NULL, NULL, 62568),
(62569, '3.30.428.10-FF-000041', NULL, 'HIT family hydrolase', 139, NULL, NULL, 62569),
(62570, '3.30.40.10-FF-000079', NULL, 'Peptidyl-prolyl cis-trans isomerase 2', 56, NULL, NULL, 62570),
(62571, '4.10.60.10-FF-000197', NULL, 'Uncharacterized protein', 29, NULL, NULL, 62571),
(62572, '3.40.630.10-FF-000043', NULL, 'Carboxypeptidase D', 315, NULL, NULL, 62572),
(62573, '3.30.70.960-FF-000020', NULL, 'Transmembrane protease serine', 110, NULL, NULL, 62573),
(62574, '1.20.58.60-FF-000448', NULL, 'Spectrin alpha chain, erythrocytic 1', 106, NULL, NULL, 62574),
(62575, '1.10.510.10-FF-001285', NULL, 'Guanylate cyclase', 318, NULL, NULL, 62575),
(62576, '3.30.70.330-FF-000528', NULL, 'RNA exonuclease 5', 87, NULL, NULL, 62576),
(62577, '3.10.50.40-FF-000078', NULL, 'Peptidyl-prolyl cis-trans isomerase', 114, NULL, NULL, 62577),
(62578, '2.60.40.10-FF-006066', NULL, NULL, 96, NULL, NULL, 62578),
(62579, '3.90.650.10-FF-000010', NULL, 'Selenide, water dikinase', 174, NULL, NULL, 62579),
(62580, '2.40.170.20-FF-000109', NULL, 'Outer membrane protein Omp121', 502, NULL, NULL, 62580),
(62581, '2.130.10.10-FF-003868', NULL, 'Uncharacterized protein', 281, NULL, NULL, 62581),
(62582, '3.10.20.90-FF-000911', NULL, 'Uncharacterized protein', 80, NULL, NULL, 62582),
(62583, '3.30.160.60-FF-001844', NULL, 'Zinc finger protein 33A', 25, NULL, NULL, 62583),
(62584, '2.60.40.1910-FF-000007', NULL, 'Aminopeptidase', 92, NULL, NULL, 62584),
(62585, '3.40.190.10-FF-000576', NULL, 'Extracellular solute-binding protein family 5', 301, NULL, NULL, 62585),
(62586, '3.30.420.40-FF-000824', NULL, 'Phosphotransferase', 38, NULL, NULL, 62586),
(62587, '3.50.50.60-FF-000751', NULL, 'Glycerol-3-phosphate dehydrogenase', 183, NULL, NULL, 62587),
(62588, '2.60.40.150-FF-000690', NULL, 'AAL103Wp', 186, NULL, NULL, 62588),
(62589, '3.40.190.10-FF-000800', NULL, 'Excitatory amino acid transporter, putative', 161, NULL, NULL, 62589),
(62590, '2.60.40.1090-FF-000031', NULL, 'Fimbrial protein SthD', 151, NULL, NULL, 62590),
(62591, '3.30.70.980-FF-000026', NULL, 'YGR021W-like protein', 95, NULL, NULL, 62591),
(62592, '3.30.420.110-FF-000008', NULL, 'DNA mismatch repair protein', 179, NULL, NULL, 62592),
(62593, '3.30.40.10-FF-001158', NULL, 'IP04788p', 90, NULL, NULL, 62593),
(62594, '2.60.120.200-FF-000725', NULL, 'Uncharacterized protein', 239, NULL, NULL, 62594),
(62595, '3.40.50.2000-FF-000168', NULL, 'Alpha-1,2-mannosyltransferase (Alg11), putative', 192, NULL, NULL, 62595),
(62596, '3.30.450.20-FF-000096', NULL, 'High affinity cAMP-specific and IBMX-insensitive 3'',5''-cyclic phosphodiesterase 8', 108, NULL, NULL, 62596),
(62597, '3.40.50.2300-FF-000140', NULL, 'Catabolite control protein A', 129, NULL, NULL, 62597),
(62598, '3.90.70.10-FF-000752', NULL, 'Clan CA, family C1, cathepsin L-like cysteine peptidase', 124, NULL, NULL, 62598),
(62599, '1.25.40.10-FF-003311', NULL, 'Pentatricopeptide repeat-containing protein At1g26900, mitochondrial', 139, NULL, NULL, 62599),
(62600, '1.10.1090.10-FF-000008', NULL, 'Cytochrome b-c1 complex subunit 7', 64, NULL, NULL, 62600);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(62601, '3.40.50.720-FF-002527', NULL, 'Uncharacterized protein', 98, NULL, NULL, 62601),
(62602, '1.25.40.10-FF-000545', NULL, 'Vacuolar protein sorting-associated protein 41 homolog', 266, NULL, NULL, 62602),
(62603, '1.10.287.80-FF-000026', NULL, 'ATP synthase gamma chain 1 chloroplastic', 17, NULL, NULL, 62603),
(62604, '3.40.50.300-FF-008253', NULL, 'Uncharacterized protein', 51, NULL, NULL, 62604),
(62605, '3.30.70.330-FF-002883', NULL, NULL, 62, NULL, NULL, 62605),
(62606, '3.30.70.660-FF-000043', NULL, 'tRNA pseudouridine synthase', 187, NULL, NULL, 62606),
(62607, '1.20.1250.20-FF-001781', NULL, 'Permease, putative', 182, NULL, NULL, 62607),
(62608, '2.30.30.100-FF-000135', NULL, 'Protein CBG17705', 102, NULL, NULL, 62608),
(62609, '1.10.150.170-FF-000009', NULL, 'Ribosomal RNA small subunit methyltransferase H', 105, NULL, NULL, 62609),
(62610, '1.10.2000.10-FF-000065', NULL, NULL, 122, NULL, NULL, 62610),
(62611, '2.10.25.10-FF-001805', NULL, 'Protein glp-1', 54, NULL, NULL, 62611),
(62612, '3.80.10.10-FF-000277', NULL, 'Leucine-rich repeat family protein', 79, NULL, NULL, 62612),
(62613, '1.20.1250.20-FF-002181', NULL, 'Uncharacterized protein', 168, NULL, NULL, 62613),
(62614, '3.60.90.10-FF-000002', NULL, 'S-adenosylmethionine decarboxylase proenzyme', 267, NULL, NULL, 62614),
(62615, '1.20.58.1360-FF-000003', NULL, 'Lysine-specific demethylase 7A', 90, NULL, NULL, 62615),
(62616, '2.60.40.10-FF-002704', NULL, 'Myosin, light chain kinase 5', 98, NULL, NULL, 62616),
(62617, '1.20.120.850-FF-000014', NULL, 'DNA repair and recombination protein RDH54', 95, NULL, NULL, 62617),
(62618, '2.30.180.10-FF-000093', NULL, 'Transforming growth factor-beta-induced protein Ig-H3', 131, NULL, NULL, 62618),
(62619, '3.30.420.580-FF-000008', NULL, 'Actin-related protein 8', 45, NULL, NULL, 62619),
(62620, '2.40.50.140-FF-001020', NULL, NULL, 52, NULL, NULL, 62620),
(62621, '3.40.1280.10-FF-000104', NULL, 'Uncharacterized protein', 150, NULL, NULL, 62621),
(62622, '3.10.450.10-FF-000081', NULL, 'Uncharacterized protein', 105, NULL, NULL, 62622),
(62623, '2.60.40.10-FF-003435', NULL, 'hydrocephalus-inducing protein homolog', 133, NULL, NULL, 62623),
(62624, '3.90.980.20-FF-000004', NULL, 'Cysteine-rich protein 2-binding protein-like', 157, NULL, NULL, 62624),
(62625, '1.10.510.10-FF-003651', NULL, NULL, 185, NULL, NULL, 62625),
(62626, '3.30.450.20-FF-000545', NULL, 'Uncharacterized protein DHKH', 161, NULL, NULL, 62626),
(62627, '3.20.20.70-FF-000719', NULL, NULL, 113, NULL, NULL, 62627),
(62628, '2.60.40.2080-FF-000002', NULL, NULL, 87, NULL, NULL, 62628),
(62629, '3.40.190.290-FF-000056', NULL, 'Transcriptional regulator, LysR family', 190, NULL, NULL, 62629),
(62630, '2.60.40.150-FF-000701', NULL, 'Predicted protein', 147, NULL, NULL, 62630),
(62631, '3.30.2090.10-FF-000019', NULL, 'Transporter, AcrB/D/F family', 91, NULL, NULL, 62631),
(62632, '1.20.1280.50-FF-000095', NULL, 'Predicted protein', 42, NULL, NULL, 62632),
(62633, '3.10.330.10-FF-000038', NULL, 'Uncharacterized protein', 113, NULL, NULL, 62633),
(62634, '1.10.287.80-FF-000021', NULL, 'ATP synthase subunit gamma, mitochondrial', 22, NULL, NULL, 62634),
(62635, '3.60.10.10-FF-000222', NULL, 'Uncharacterized protein', 257, NULL, NULL, 62635),
(62636, '3.30.70.330-FF-001585', NULL, 'U1 small nuclear ribonucleoprotein 70 kDa', 126, NULL, NULL, 62636),
(62637, '1.10.418.10-FF-000283', NULL, 'Actinin alpha 1', 54, NULL, NULL, 62637),
(62638, '2.60.40.10-FF-005228', NULL, NULL, 115, NULL, NULL, 62638),
(62639, '3.50.4.10-FF-000046', NULL, NULL, 84, NULL, NULL, 62639),
(62640, '1.25.10.10-FF-002415', NULL, 'Exportin-5', 251, NULL, NULL, 62640),
(62641, '3.30.40.10-FF-002119', NULL, 'Predicted protein', 101, NULL, NULL, 62641),
(62642, '3.40.50.1820-FF-000226', NULL, 'Carboxypeptidase', 334, NULL, NULL, 62642),
(62643, '1.10.287.3440-FF-000002', NULL, 'Biosynthetic arginine decarboxylase', 53, NULL, NULL, 62643),
(62644, '3.40.1110.10-FF-000008', NULL, 'Phospholipid-transporting ATPase', 253, NULL, NULL, 62644),
(62645, '3.30.559.10-FF-000244', NULL, 'Uncharacterized protein', 112, NULL, NULL, 62645);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(62646, '3.80.10.10-FF-001238', NULL, 'Toll-like receptor 2', 568, NULL, NULL, 62646),
(62647, '3.30.70.330-FF-001933', NULL, NULL, 142, NULL, NULL, 62647),
(62648, '2.130.10.10-FF-000647', NULL, 'Regulatory-associated protein of TOR 1', 123, NULL, NULL, 62648),
(62649, '3.30.300.130-FF-000004', NULL, 'cytosolic iron-sulfur assembly component 2A', 96, NULL, NULL, 62649),
(62650, '1.25.40.20-FF-000211', NULL, 'Integrin-linked protein kinase 1', 139, NULL, NULL, 62650),
(62651, '3.30.1600.10-FF-000037', NULL, 'Sirtuin type, putative', 114, NULL, NULL, 62651),
(62652, '3.30.1120.30-FF-000006', NULL, 'Polo like kinase 5', 20, NULL, NULL, 62652),
(62653, '3.40.50.970-FF-000219', NULL, 'Uncharacterized protein, isoform F', 68, NULL, NULL, 62653),
(62654, '2.130.10.10-FF-001266', NULL, 'AGAP007544-PA', 206, NULL, NULL, 62654),
(62655, '3.30.420.40-FF-000038', NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase', 163, NULL, NULL, 62655),
(62656, '3.30.450.40-FF-000214', NULL, 'Guanylate cyclase', 147, NULL, NULL, 62656),
(62657, '3.30.200.20-FF-001578', NULL, NULL, 117, NULL, NULL, 62657),
(62658, '3.30.40.10-FF-001596', NULL, 'Predicted protein', 87, NULL, NULL, 62658),
(62659, '3.40.50.300-FF-001665', NULL, 'DNA repair protein RAD51 4', 247, NULL, NULL, 62659),
(62660, '3.30.160.60-FF-002356', NULL, NULL, 29, NULL, NULL, 62660),
(62661, '1.10.10.60-FF-001255', NULL, NULL, 65, NULL, NULL, 62661),
(62662, '2.120.10.80-FF-000039', NULL, 'influenza virus NS1A-binding protein', 238, NULL, NULL, 62662),
(62663, '2.60.40.10-FF-000338', NULL, 'intercellular adhesion molecule 5', 108, NULL, NULL, 62663),
(62664, '3.40.228.10-FF-000018', NULL, 'Dimethyl sulfoxide reductase', 213, NULL, NULL, 62664),
(62665, '1.10.630.10-FF-000265', NULL, 'Uncharacterized protein', 470, NULL, NULL, 62665),
(62666, '3.10.100.10-FF-000330', NULL, NULL, 102, NULL, NULL, 62666),
(62667, '1.10.600.10-FF-000100', NULL, '(E,E)-geranyllinalool synthase', 218, NULL, NULL, 62667),
(62668, '3.40.50.2300-FF-001668', NULL, NULL, 169, NULL, NULL, 62668),
(62669, '1.20.1070.10-FF-000050', NULL, '5-hydroxytryptamine receptor 1B', 288, NULL, NULL, 62669),
(62670, '1.10.150.20-FF-000124', NULL, 'Exonuclease, putative', 75, NULL, NULL, 62670),
(62671, '1.10.287.70-FF-000703', NULL, 'Uncharacterized protein', 203, NULL, NULL, 62671),
(62672, '1.20.140.10-FF-000017', NULL, 'very long-chain specific acyl-CoA dehydrogenase, mitochondrial', 129, NULL, NULL, 62672),
(62673, '1.20.58.60-FF-000229', NULL, 'Spectrin beta chain', 214, NULL, NULL, 62673),
(62674, '3.30.930.10-FF-000242', NULL, 'Phenylalanine--tRNA ligase beta subunit', 211, NULL, NULL, 62674),
(62675, '3.30.230.10-FF-000228', NULL, 'DNA mismatch repair protein MutL', 122, NULL, NULL, 62675),
(62676, '3.30.450.20-FF-000438', NULL, 'Uncharacterized protein', 117, NULL, NULL, 62676),
(62677, '3.30.70.1230-FF-000097', NULL, 'Guanylate cyclase', 145, NULL, NULL, 62677),
(62678, '3.30.40.10-FF-000410', NULL, 'At1g47570', 111, NULL, NULL, 62678),
(62679, '2.60.40.10-FF-004609', NULL, NULL, 81, NULL, NULL, 62679),
(62680, '1.20.1050.10-FF-000279', NULL, 'Uncharacterized protein', 51, NULL, NULL, 62680),
(62681, '1.20.140.40-FF-000015', NULL, 'Pectinesterase 3', 150, NULL, NULL, 62681),
(62682, '3.30.200.20-FF-002197', NULL, 'Protein kinase MAPKKKK, MAP4K-like protein', 51, NULL, NULL, 62682),
(62683, '3.20.20.80-FF-000037', NULL, 'Putative family 31 glucosidase KIAA1161', 369, NULL, NULL, 62683),
(62684, '3.80.10.10-FF-000833', NULL, 'Protein TOO MANY MOUTHS', 143, NULL, NULL, 62684),
(62685, '2.60.200.10-FF-000004', NULL, 'Mothers against decapentaplegic homolog', 173, NULL, NULL, 62685),
(62686, '1.10.490.160-FF-000009', NULL, NULL, 177, NULL, NULL, 62686),
(62687, '1.25.40.10-FF-002243', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 173, NULL, NULL, 62687),
(62688, '1.10.510.10-FF-002139', NULL, 'Dual specificity protein phosphatase, putative', 214, NULL, NULL, 62688),
(62689, '3.60.10.10-FF-000115', NULL, 'DNAse I-like superfamily protein', 128, NULL, NULL, 62689);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(62690, '2.70.170.10-FF-000285', NULL, 'Uncharacterized protein', 64, NULL, NULL, 62690),
(62691, '3.90.226.10-FF-000047', NULL, 'Probable 3-hydroxyacyl-CoA dehydrogenase', 318, NULL, NULL, 62691),
(62692, '3.40.50.300-FF-006555', NULL, 'Uncharacterized protein', 104, NULL, NULL, 62692),
(62693, '3.40.5.50-FF-000004', NULL, 'Putative Psf2', 64, NULL, NULL, 62693),
(62694, '3.40.50.720-FF-001908', NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', 170, NULL, NULL, 62694),
(62695, '3.40.50.2000-FF-000387', NULL, 'Sucrose synthase 3', 114, NULL, NULL, 62695),
(62696, '2.30.42.10-FF-000086', NULL, 'Tyrosine-protein phosphatase non-receptor type 13', 121, NULL, NULL, 62696),
(62697, '3.30.70.270-FF-000252', NULL, NULL, 83, NULL, NULL, 62697),
(62698, '2.60.40.180-FF-000007', NULL, '5-hydroxyisourate hydrolase', 133, NULL, NULL, 62698),
(62699, '3.30.160.60-FF-001395', NULL, 'Krueppel-like factor 7', 27, NULL, NULL, 62699),
(62700, '2.60.120.40-FF-000057', NULL, 'Precerebellin-like protein', 149, NULL, NULL, 62700),
(62701, '3.40.50.300-FF-000597', NULL, 'ABC transporter ATP-binding protein', 237, NULL, NULL, 62701),
(62702, '1.20.920.10-FF-000083', NULL, 'WGS project CABT00000000 data, contig 2.8', 128, NULL, NULL, 62702),
(62703, '2.40.100.10-FF-000158', NULL, 'Uncharacterized protein', 122, NULL, NULL, 62703),
(62704, '2.40.50.40-FF-000096', NULL, 'Chromodomain Y-like protein', 76, NULL, NULL, 62704),
(62705, '2.130.10.10-FF-004829', NULL, 'Uncharacterized protein', 135, NULL, NULL, 62705),
(62706, '3.90.79.10-FF-000165', NULL, 'Uncharacterized protein', 160, NULL, NULL, 62706),
(62707, '1.10.510.10-FF-002246', NULL, NULL, 193, NULL, NULL, 62707),
(62708, '1.10.246.220-FF-000004', NULL, NULL, 71, NULL, NULL, 62708),
(62709, '3.40.710.10-FF-000100', NULL, 'Penicillin-binding protein 1A', 381, NULL, NULL, 62709),
(62710, '3.40.50.2300-FF-000145', NULL, 'Glutamate receptor, metabotropic', 154, NULL, NULL, 62710),
(62711, '3.30.420.10-FF-000372', NULL, NULL, 179, NULL, NULL, 62711),
(62712, '3.30.70.660-FF-000048', NULL, 'tRNA pseudouridine synthase A', 141, NULL, NULL, 62712),
(62713, '2.60.40.150-FF-000589', NULL, 'FAM62', 75, NULL, NULL, 62713),
(62714, '1.20.1250.20-FF-002293', NULL, 'Uncharacterized protein', 68, NULL, NULL, 62714),
(62715, '3.10.310.10-FF-000025', NULL, 'Diaminopimelate epimerase', 120, NULL, NULL, 62715),
(62716, '3.30.200.20-FF-002539', NULL, 'Mitogen-activated protein kinase', 21, NULL, NULL, 62716),
(62717, '1.10.10.60-FF-000294', NULL, 'NK1 transcription factor-related protein 1', 87, NULL, NULL, 62717),
(62718, '3.40.50.720-FF-002415', NULL, 'Uncharacterized protein', 53, NULL, NULL, 62718),
(62719, '1.10.150.170-FF-000004', NULL, 'Ribosomal RNA small subunit methyltransferase H', 107, NULL, NULL, 62719),
(62720, '3.80.10.10-FF-004200', NULL, 'Uncharacterized protein', 90, NULL, NULL, 62720),
(62721, '3.30.910.20-FF-000013', NULL, 'Putative outer membrane protein OmpH', 136, NULL, NULL, 62721),
(62722, '3.40.50.150-FF-001603', NULL, NULL, 259, NULL, NULL, 62722),
(62723, '3.60.40.10-FF-000156', NULL, 'Integrin-linked kinase-associated serine/threonine phosphatase 2C', 290, NULL, NULL, 62723),
(62724, '3.40.50.300-FF-002632', NULL, 'Primosomal protein N''', 143, NULL, NULL, 62724),
(62725, '3.40.850.10-FF-000475', NULL, 'Kinesin-like protein', 350, NULL, NULL, 62725),
(62726, '2.60.40.10-FF-003430', NULL, NULL, 106, NULL, NULL, 62726),
(62727, '2.60.120.560-FF-000024', NULL, 'Sucrose-6-phosphate hydrolase', 137, NULL, NULL, 62727),
(62728, '2.130.10.10-FF-004487', NULL, 'Uncharacterized protein', 212, NULL, NULL, 62728),
(62729, '2.120.10.30-FF-000401', NULL, 'Uncharacterized protein', 219, NULL, NULL, 62729),
(62730, '3.40.50.300-FF-005162', NULL, 'Sugar ABC transporter, ATP-binding protein', 225, NULL, NULL, 62730),
(62731, '3.30.2140.20-FF-000010', NULL, 'Arylamine N-acetyltransferase 1', 340, NULL, NULL, 62731),
(62732, '1.10.472.10-FF-000684', NULL, 'CYC2-like cyclin, putative', 154, NULL, NULL, 62732),
(62733, '3.80.10.10-FF-003924', NULL, 'Uncharacterized protein', 98, NULL, NULL, 62733);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(62734, '3.40.50.150-FF-000861', NULL, 'Protein-L-isoaspartate O-methyltransferase', 236, NULL, NULL, 62734),
(62735, '3.10.20.30-FF-000028', NULL, 'threonine--tRNA ligase, mitochondrial isoform X3', 62, NULL, NULL, 62735),
(62736, '2.10.25.10-FF-001356', NULL, 'Uncharacterized protein', 35, NULL, NULL, 62736),
(62737, '2.60.120.260-FF-000029', NULL, 'Beta-galactosidase 1', 171, NULL, NULL, 62737),
(62738, '3.80.10.10-FF-004330', NULL, 'Os04g0291900 protein', 197, NULL, NULL, 62738),
(62739, '3.20.20.140-FF-000019', NULL, 'Cytosine deaminase', 309, NULL, NULL, 62739),
(62740, '3.30.70.1230-FF-000102', NULL, 'Guanylate cyclase', 90, NULL, NULL, 62740),
(62741, '3.30.530.20-FF-000153', NULL, 'MLP-like protein 43', 158, NULL, NULL, 62741),
(62742, '3.40.50.300-FF-004886', NULL, 'Septin 5a', 57, NULL, NULL, 62742),
(62743, '3.40.50.150-FF-001261', NULL, NULL, 270, NULL, NULL, 62743),
(62744, '3.40.50.10140-FF-000091', NULL, 'Uncharacterized protein', 81, NULL, NULL, 62744),
(62745, '3.30.160.60-FF-002463', NULL, 'Zinc finger protein 16', 30, NULL, NULL, 62745),
(62746, '1.50.40.10-FF-000032', NULL, 'Solute carrier family 25 member 33', 191, NULL, NULL, 62746),
(62747, '3.50.7.10-FF-000087', NULL, NULL, 172, NULL, NULL, 62747),
(62748, '3.30.160.60-FF-001052', NULL, 'Zinc finger protein 668', 28, NULL, NULL, 62748),
(62749, '1.10.510.10-FF-001178', NULL, 'Uncharacterized protein', 166, NULL, NULL, 62749),
(62750, '3.20.20.60-FF-000031', NULL, 'HpcH/HpaI aldolase', 269, NULL, NULL, 62750),
(62751, '3.40.50.1000-FF-000418', NULL, 'D,D-heptose 1,7-bisphosphate phosphatase', 173, NULL, NULL, 62751),
(62752, '3.30.200.20-FF-001235', NULL, 'Uncharacterized protein', 65, NULL, NULL, 62752),
(62753, '3.40.50.150-FF-001131', NULL, NULL, 181, NULL, NULL, 62753),
(62754, '3.30.160.20-FF-000118', NULL, 'Uncharacterized protein', 84, NULL, NULL, 62754),
(62755, '1.10.3450.40-FF-000001', NULL, 'Signal recognition particle subunit SRP68', 198, NULL, NULL, 62755),
(62756, '1.20.1740.10-FF-000242', NULL, 'Uncharacterized protein', 346, NULL, NULL, 62756),
(62757, '4.10.860.10-FF-000029', NULL, NULL, 59, NULL, NULL, 62757),
(62758, '2.70.98.10-FF-000095', NULL, 'Uncharacterized protein', 249, NULL, NULL, 62758),
(62759, '3.10.20.10-FF-000022', NULL, 'Cell death-inducing DFFA-like effector b', 105, NULL, NULL, 62759),
(62760, '2.30.30.40-FF-000415', NULL, 'LIM and SH3 domain protein 2', 62, NULL, NULL, 62760),
(62761, '1.20.1560.10-FF-000149', NULL, 'ATP-binding cassette protein, putative', 325, NULL, NULL, 62761),
(62762, '3.30.160.60-FF-002811', NULL, 'Zinc finger protein 679', 28, NULL, NULL, 62762),
(62763, '1.20.1280.290-FF-000046', NULL, 'Sugar transporter SWEET', 89, NULL, NULL, 62763),
(62764, '2.60.40.1170-FF-000061', NULL, NULL, 93, NULL, NULL, 62764),
(62765, '3.30.1490.20-FF-000103', NULL, 'D-alanine--D-alanine ligase', 68, NULL, NULL, 62765),
(62766, '3.40.50.1820-FF-001395', NULL, 'Uncharacterized protein', 213, NULL, NULL, 62766),
(62767, '3.30.70.100-FF-000010', NULL, 'Small-conductance mechanosensitive channel MscS', 95, NULL, NULL, 62767),
(62768, '1.20.120.1240-FF-000026', NULL, 'Dynamin-related protein 1E', 259, NULL, NULL, 62768),
(62769, '3.30.260.10-FF-000056', NULL, 'Uncharacterized protein', 92, NULL, NULL, 62769),
(62770, '2.60.40.4100-FF-000013', NULL, 'Protein dyf-7', 151, NULL, NULL, 62770),
(62771, '3.30.70.330-FF-000281', NULL, 'la-related protein 7 isoform X1', 72, NULL, NULL, 62771),
(62772, '1.25.40.180-FF-000007', NULL, 'Eukaryotic translation initiation factor 4 gamma 2', 167, NULL, NULL, 62772),
(62773, '1.20.1640.10-FF-000083', NULL, 'Trehalose monomycolate exporter MmpL3', 186, NULL, NULL, 62773),
(62774, '3.40.640.10-FF-000105', NULL, 'Cysteine desulfurase, mitochondrial', 68, NULL, NULL, 62774),
(62775, '3.40.50.300-FF-002284', NULL, 'Rab family GTPase', 175, NULL, NULL, 62775),
(62776, '1.25.10.10-FF-003141', NULL, 'Uncharacterized protein', 107, NULL, NULL, 62776),
(62777, '3.40.1170.10-FF-000001', NULL, 'DNA mismatch repair protein MutS', 119, NULL, NULL, 62777),
(62778, '1.10.10.10-FF-000318', NULL, 'Transcriptional regulator, IclR family', 76, NULL, NULL, 62778);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(62779, '1.10.150.240-FF-000036', NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', 64, NULL, NULL, 62779),
(62780, '1.10.8.350-FF-000002', NULL, 'Lytic transglycosylase', 74, NULL, NULL, 62780),
(62781, '2.120.10.30-FF-000396', NULL, 'Uncharacterized protein', 248, NULL, NULL, 62781),
(62782, '1.20.120.1220-FF-000020', NULL, NULL, 125, NULL, NULL, 62782),
(62783, '1.10.510.10-FF-002589', NULL, NULL, 205, NULL, NULL, 62783),
(62784, '2.60.40.10-FF-004739', NULL, NULL, 101, NULL, NULL, 62784),
(62785, '3.15.30.10-FF-000001', NULL, 'Major capsid protein E', 178, NULL, NULL, 62785),
(62786, '1.10.1450.10-FF-000087', NULL, 'Tetraspanin', 81, NULL, NULL, 62786),
(62787, '2.40.10.10-FF-000556', NULL, NULL, 73, NULL, NULL, 62787),
(62788, '1.20.58.60-FF-000105', NULL, 'Spectrin beta chain', 104, NULL, NULL, 62788),
(62789, '3.30.950.30-FF-000007', NULL, 'Uncharacterized protein', 55, NULL, NULL, 62789),
(62790, '3.30.40.10-FF-000534', NULL, 'Toutatis, isoform G', 74, NULL, NULL, 62790),
(62791, '1.20.1250.20-FF-002074', NULL, 'Uncharacterized protein', 279, NULL, NULL, 62791),
(62792, '2.60.40.10-FF-002811', NULL, 'Tyrosine-protein kinase receptor', 110, NULL, NULL, 62792),
(62793, '2.130.10.10-FF-003520', NULL, 'Small nucleolar ribonucleoprotein complex subunit Dip2, putative', 101, NULL, NULL, 62793),
(62794, '3.90.190.10-FF-000441', NULL, 'Predicted protein', 280, NULL, NULL, 62794),
(62795, '1.10.630.10-FF-000613', NULL, 'Os03g0650200 protein', 256, NULL, NULL, 62795),
(62796, '1.10.10.990-FF-000001', NULL, 'RecBCD enzyme subunit RecC', 72, NULL, NULL, 62796),
(62797, '1.10.10.10-FF-000537', NULL, 'HMG-Y-related protein A', 84, NULL, NULL, 62797),
(62798, '3.30.70.330-FF-000966', NULL, 'Related to CWC2-involved in mRNA splicing', 88, NULL, NULL, 62798),
(62799, '2.40.50.40-FF-000101', NULL, 'Chromodomain helicase DNA-binding protein 5', 52, NULL, NULL, 62799),
(62800, '3.40.50.12780-FF-000225', NULL, 'Pantothenate kinase subunit, putative', 321, NULL, NULL, 62800),
(62801, '1.10.10.60-FF-000979', NULL, NULL, 94, NULL, NULL, 62801),
(62802, '1.20.1250.20-FF-000612', NULL, 'Peptide transporter 3', 387, NULL, NULL, 62802),
(62803, '1.10.150.20-FF-000248', NULL, 'DNA ligase', 90, NULL, NULL, 62803),
(62804, '3.40.50.2300-FF-000488', NULL, 'DNA-binding response regulator', 134, NULL, NULL, 62804),
(62805, '3.90.190.10-FF-000093', NULL, 'Initiator tRNA phosphoribosyl transferase family protein', 152, NULL, NULL, 62805),
(62806, '2.10.110.10-FF-000149', NULL, 'FHL1 isoform 27', 43, NULL, NULL, 62806),
(62807, '1.20.1070.10-FF-000842', NULL, 'G protein-coupled receptor EGL-6 isoform b', 389, NULL, NULL, 62807),
(62808, '1.10.4160.10-FF-000032', NULL, 'Purine-cytosine permease, putative', 433, NULL, NULL, 62808),
(62809, '1.20.140.80-FF-000004', NULL, 'Transcription factor-like protein DPA', 124, NULL, NULL, 62809),
(62810, '3.30.70.2460-FF-000010', NULL, NULL, 99, NULL, NULL, 62810),
(62811, '2.40.50.140-FF-000851', NULL, NULL, 161, NULL, NULL, 62811),
(62812, '3.30.1360.10-FF-000001', NULL, 'DNA-directed RNA polymerase subunit alpha', 87, NULL, NULL, 62812),
(62813, '3.50.50.60-FF-001133', NULL, 'Uncharacterized protein', 115, NULL, NULL, 62813),
(62814, '1.40.20.10-FF-000003', NULL, 'Uncharacterized protein', 331, NULL, NULL, 62814),
(62815, '3.80.10.10-FF-003711', NULL, 'Septation initiation network scaffold protein cdc11', 154, NULL, NULL, 62815),
(62816, '2.130.10.10-FF-001614', NULL, 'WD repeat protein', 170, NULL, NULL, 62816),
(62817, '2.30.30.100-FF-000028', NULL, 'N-alpha-acetyltransferase 38, NatC auxiliary subunit', 80, NULL, NULL, 62817),
(62818, '1.20.58.1030-FF-000034', NULL, 'Chromosome 15, whole genome shotgun sequence', 138, NULL, NULL, 62818),
(62819, '1.10.10.10-FF-000993', NULL, 'DNA-directed RNA polymerase III subunit RPC3, putative', 80, NULL, NULL, 62819),
(62820, '2.60.40.10-FF-001518', NULL, 'Enterochelin esterase', 144, NULL, NULL, 62820),
(62821, '3.90.70.80-FF-000060', NULL, 'Uncharacterized protein', 156, NULL, NULL, 62821),
(62822, '1.20.1250.20-FF-001674', NULL, 'Protein NRT1/ PTR FAMILY 5.1', 82, NULL, NULL, 62822);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(62823, '1.20.5.170-FF-000250', NULL, 'Predicted protein', 146, NULL, NULL, 62823),
(62824, '3.90.1600.10-FF-000012', NULL, 'DNA polymerase epsilon catalytic subunit A', 49, NULL, NULL, 62824),
(62825, '3.30.200.110-FF-000004', NULL, 'Ipk1, isoform B', 148, NULL, NULL, 62825),
(62826, '1.10.3210.10-FF-000019', NULL, 'Probable GTP diphosphokinase CRSH, chloroplastic', 185, NULL, NULL, 62826),
(62827, '1.10.12.10-FF-000036', NULL, 'Enoyl-CoA hydratase', 59, NULL, NULL, 62827),
(62828, '3.30.470.30-FF-000095', NULL, 'Uncharacterized protein', 245, NULL, NULL, 62828),
(62829, '2.90.10.10-FF-000026', NULL, 'Serine/threonine-protein kinase', 131, NULL, NULL, 62829),
(62830, '3.10.660.10-FF-000017', NULL, 'Predicted protein', 83, NULL, NULL, 62830),
(62831, '1.10.10.440-FF-000084', NULL, 'YALI0D02827p', 83, NULL, NULL, 62831),
(62832, '1.10.238.10-FF-000308', NULL, 'EF-hand domain family member B', 157, NULL, NULL, 62832),
(62833, '3.55.50.30-FF-000001', NULL, 'Type III secretion system outer membrane pore InvG', 84, NULL, NULL, 62833),
(62834, '3.40.50.12160-FF-000039', NULL, 'Predicted protein', 131, NULL, NULL, 62834),
(62835, '3.30.70.330-FF-001697', NULL, 'RNA Binding Motif protein homolog', 155, NULL, NULL, 62835),
(62836, '2.60.40.10-FF-005110', NULL, NULL, 98, NULL, NULL, 62836),
(62837, '3.30.70.20-FF-000128', NULL, NULL, 54, NULL, NULL, 62837),
(62838, '3.30.70.330-FF-002315', NULL, NULL, 94, NULL, NULL, 62838),
(62839, '3.30.390.30-FF-000043', NULL, 'Mercuric reductase, putative', 121, NULL, NULL, 62839),
(62840, '2.60.40.10-FF-004492', NULL, NULL, 98, NULL, NULL, 62840),
(62841, '2.60.200.20-FF-000232', NULL, 'Kinesin-like protein', 68, NULL, NULL, 62841),
(62842, '3.40.50.200-FF-000005', NULL, 'Proprotein convertase subtilisin/kexin type 7', 337, NULL, NULL, 62842),
(62843, '2.60.40.10-FF-001850', NULL, 'KETtiN (Drosophila actin-binding) homolog', 105, NULL, NULL, 62843),
(62844, '2.60.120.260-FF-000597', NULL, 'Uncharacterized protein', 148, NULL, NULL, 62844),
(62845, '3.30.450.30-FF-000082', NULL, 'Profilin', 87, NULL, NULL, 62845),
(62846, '3.40.50.10810-FF-000106', NULL, 'Probable global transcription activator SNF2L2', 177, NULL, NULL, 62846),
(62847, '1.20.1070.10-FF-001697', NULL, 'Uncharacterized protein', 109, NULL, NULL, 62847),
(62848, '1.20.58.1030-FF-000028', NULL, 'DNA replication complex GINS protein SLD5', 152, NULL, NULL, 62848),
(62849, '2.60.40.790-FF-000207', NULL, NULL, 158, NULL, NULL, 62849),
(62850, '2.60.40.1360-FF-000016', NULL, 'Alpha-mannosidase', 125, NULL, NULL, 62850),
(62851, '1.10.760.10-FF-000038', NULL, 'Cytochrome c6', 86, NULL, NULL, 62851),
(62852, '3.70.10.10-FF-000137', NULL, 'Uncharacterized protein', 274, NULL, NULL, 62852),
(62853, '1.10.101.10-FF-000042', NULL, 'Uncharacterized protein', 81, NULL, NULL, 62853),
(62854, '2.60.120.590-FF-000016', NULL, 'Alkylated DNA repair protein alkB 8', 203, NULL, NULL, 62854),
(62855, '2.60.40.10-FF-002362', NULL, 'CD4-like protein 2', 123, NULL, NULL, 62855),
(62856, '2.160.20.20-FF-000009', NULL, 'Protein CBG23155', 328, NULL, NULL, 62856),
(62857, '2.60.120.290-FF-000027', NULL, 'Transmembrane serine protease 6', 126, NULL, NULL, 62857),
(62858, '3.30.70.330-FF-000174', NULL, 'cold-inducible RNA-binding protein isoform X2', 103, NULL, NULL, 62858),
(62859, '3.30.70.260-FF-000029', NULL, 'Aspartokinase', 75, NULL, NULL, 62859),
(62860, '2.160.20.10-FF-000113', NULL, 'Os01g0172900 protein', 100, NULL, NULL, 62860),
(62861, '3.40.50.2300-FF-001213', NULL, NULL, 65, NULL, NULL, 62861),
(62862, '1.25.40.280-FF-000020', NULL, 'Enhancer of Glp-One (Glp-1)', 256, NULL, NULL, 62862),
(62863, '3.40.50.720-FF-001347', NULL, 'Oxidoreductase', 234, NULL, NULL, 62863),
(62864, '1.20.58.2220-FF-000065', NULL, 'Formin-J', 380, NULL, NULL, 62864),
(62865, '1.25.10.10-FF-002179', NULL, 'Uncharacterized protein', 472, NULL, NULL, 62865),
(62866, '2.60.40.1670-FF-000008', NULL, 'Protein transport protein SEC23', 157, NULL, NULL, 62866),
(62867, '1.20.1050.10-FF-000066', NULL, 'Gdap1, isoform B', 117, NULL, NULL, 62867);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(62868, '3.40.50.620-FF-000575', NULL, 'FAD synthase', 144, NULL, NULL, 62868),
(62869, '3.40.50.720-FF-000835', NULL, 'Putative hydroxyacid dehydrogenase', 210, NULL, NULL, 62869),
(62870, '2.70.20.10-FF-000022', NULL, 'DNA topoisomerase IA, putative', 159, NULL, NULL, 62870),
(62871, '3.40.50.10810-FF-000095', NULL, 'Helicase, putative', 263, NULL, NULL, 62871),
(62872, '2.60.40.2030-FF-000015', NULL, 'FRAS1-related extracellular matrix protein 1', 121, NULL, NULL, 62872),
(62873, '3.30.360.10-FF-000097', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase 2 (Gapdh)(Nad(P)-dependent glyceraldehyde-3-phosphate dehydrogenase)', 157, NULL, NULL, 62873),
(62874, '3.90.940.10-FF-000004', NULL, 'DNA-directed RNA polymerases I, II, and III subunit RPABC2', 139, NULL, NULL, 62874),
(62875, '3.30.70.860-FF-000007', NULL, 'UPF0234 protein D6716_11750', 68, NULL, NULL, 62875),
(62876, '3.30.70.1730-FF-000033', NULL, 'Uncharacterized protein', 31, NULL, NULL, 62876),
(62877, '3.40.50.300-FF-005375', NULL, 'Protein CLP1 homolog', 224, NULL, NULL, 62877),
(62878, '3.60.130.10-FF-000028', NULL, 'WGS project CABT00000000 data, contig 2.12', 286, NULL, NULL, 62878),
(62879, '2.60.120.200-FF-000057', NULL, 'Laminin subunit alpha 2', 192, NULL, NULL, 62879),
(62880, '3.30.160.60-FF-006066', NULL, NULL, 27, NULL, NULL, 62880),
(62881, '2.10.25.10-FF-000625', NULL, 'Notch receptor 4', 34, NULL, NULL, 62881),
(62882, '1.20.140.140-FF-000007', NULL, 'Predicted protein', 203, NULL, NULL, 62882),
(62883, '3.40.50.150-FF-001822', NULL, NULL, 86, NULL, NULL, 62883),
(62884, '3.30.565.10-FF-000286', NULL, 'Two-component hybrid sensor and regulator', 136, NULL, NULL, 62884),
(62885, '1.10.510.10-FF-002471', NULL, NULL, 219, NULL, NULL, 62885),
(62886, '2.30.30.140-FF-000012', NULL, 'AT-rich interactive domain-containing protein 4A', 69, NULL, NULL, 62886),
(62887, '2.130.10.10-FF-003632', NULL, 'Small nuclear ribonucleoprotein prp4', 209, NULL, NULL, 62887),
(62888, '2.130.10.10-FF-001502', NULL, 'Unplaced genomic scaffold supercont1.30, whole genome shotgun sequence', 259, NULL, NULL, 62888),
(62889, '3.40.50.300-FF-001901', NULL, 'U5 small nuclear ribonucleoprotein-specific protein', 72, NULL, NULL, 62889),
(62890, '3.80.10.10-FF-003599', NULL, 'Plekhe1 protein, putative', 128, NULL, NULL, 62890),
(62891, '3.40.50.1980-FF-000122', NULL, 'Iron(III) dicitrate transport system permease protein FecB', 168, NULL, NULL, 62891),
(62892, '3.40.190.10-FF-000452', NULL, 'Transcriptional regulator, LysR family', 95, NULL, NULL, 62892),
(62893, '2.140.10.10-FF-000001', NULL, 'Quinoprotein glucose dehydrogenase', 642, NULL, NULL, 62893),
(62894, '2.40.10.10-FF-000686', NULL, NULL, 46, NULL, NULL, 62894),
(62895, '3.40.920.10-FF-000020', NULL, NULL, 182, NULL, NULL, 62895),
(62896, '3.40.630.10-FF-000149', NULL, 'Aspartyl aminopeptidase, putative', 289, NULL, NULL, 62896),
(62897, '1.10.630.10-FF-000501', NULL, 'Probable cytochrome P450 T9E850', 448, NULL, NULL, 62897),
(62898, '2.40.50.770-FF-000011', NULL, 'Uncharacterized protein', 156, NULL, NULL, 62898),
(62899, '3.40.850.10-FF-000368', NULL, 'Myosin IHb', 56, NULL, NULL, 62899),
(62900, '3.10.110.10-FF-000044', NULL, 'protein PEROXIN-4 isoform X1', 152, NULL, NULL, 62900),
(62901, '3.40.50.720-FF-000150', NULL, 'UDP-glucuronic acid decarboxylase 6', 309, NULL, NULL, 62901),
(62902, '1.25.40.10-FF-003423', NULL, 'Co-chaperone', 76, NULL, NULL, 62902),
(62903, '1.25.40.120-FF-000012', NULL, 'Protein prenyltransferase alpha subunit repeat containing 1', 241, NULL, NULL, 62903),
(62904, '3.40.50.150-FF-000294', NULL, 'O-methyltransferase family protein', 247, NULL, NULL, 62904),
(62905, '3.40.630.150-FF-000003', NULL, 'MaLonyl CoA Decarboxylase', 291, NULL, NULL, 62905),
(62906, '3.40.50.300-FF-003014', NULL, 'Protein CHROMATIN REMODELING 19 isoform A', 52, NULL, NULL, 62906),
(62907, '3.60.21.10-FF-000472', NULL, 'Serine/threonine-protein phosphatase', 47, NULL, NULL, 62907),
(62908, '1.20.1540.10-FF-000024', NULL, 'Blast:Protein rhomboid', 188, NULL, NULL, 62908),
(62909, '1.25.10.10-FF-000049', NULL, 'Engulfment and cell motility 1 (Ced-12 homolog)', 287, NULL, NULL, 62909);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(62910, '1.10.472.10-FF-000228', NULL, 'D-type cyclin', 110, NULL, NULL, 62910),
(62911, '3.80.10.10-FF-002295', NULL, 'Leucine-rich repeat family protein', 217, NULL, NULL, 62911),
(62912, '1.20.910.10-FF-000037', NULL, 'Putative heme oxygenase 3', 200, NULL, NULL, 62912),
(62913, '2.60.120.260-FF-000608', NULL, 'Ferritin/ribonucleotide reductase-like family protein', 143, NULL, NULL, 62913),
(62914, '2.60.40.10-FF-005009', NULL, NULL, 106, NULL, NULL, 62914),
(62915, '1.20.1250.20-FF-000269', NULL, 'Uncharacterized MFS-type transporter YfcJ', 378, NULL, NULL, 62915),
(62916, '3.30.70.1390-FF-000009', NULL, 'Uncharacterized protein', 83, NULL, NULL, 62916),
(62917, '1.10.510.10-FF-003994', NULL, NULL, 212, NULL, NULL, 62917),
(62918, '3.10.580.10-FF-000197', NULL, 'Uncharacterized protein', 82, NULL, NULL, 62918),
(62919, '3.40.50.300-FF-007303', NULL, 'Dynein, axonemal, heavy chain 7', 150, NULL, NULL, 62919),
(62920, '2.130.10.10-FF-001491', NULL, 'Paralyzed_flagella_protein_20', 135, NULL, NULL, 62920),
(62921, '3.30.420.40-FF-000263', NULL, 'Type II pantothenate kinase', 182, NULL, NULL, 62921),
(62922, '1.20.120.140-FF-000026', NULL, 'Uncharacterized protein', 115, NULL, NULL, 62922),
(62923, '3.30.200.20-FF-000960', NULL, 'Tyrosine-protein kinase', 91, NULL, NULL, 62923),
(62924, '1.20.58.70-FF-000114', NULL, 'Syntaxin 2a', 127, NULL, NULL, 62924),
(62925, '2.20.70.10-FF-000286', NULL, 'Neural cell expressed, developmentally down-regulated 4-like', 40, NULL, NULL, 62925),
(62926, '2.60.120.290-FF-000140', NULL, 'Cubilin homolog', 116, NULL, NULL, 62926),
(62927, '3.30.160.60-FF-006173', NULL, NULL, 67, NULL, NULL, 62927),
(62928, '1.10.1820.10-FF-000026', NULL, 'Casein kinase II subunit beta', 95, NULL, NULL, 62928),
(62929, '3.30.70.2850-FF-000032', NULL, 'DNA-directed RNA polymerase subunit', 141, NULL, NULL, 62929),
(62930, '3.80.10.10-FF-000165', NULL, 'Centrosomal protein of 97 kDa', 160, NULL, NULL, 62930),
(62931, '1.20.58.1780-FF-000005', NULL, 'Nuclear pore complex subunit', 339, NULL, NULL, 62931),
(62932, '3.30.2230.10-FF-000008', NULL, 'Ubiquitin carboxyl-terminal hydrolase 11', 129, NULL, NULL, 62932),
(62933, '1.20.1070.10-FF-001011', NULL, 'Uncharacterized protein', 319, NULL, NULL, 62933),
(62934, '1.10.10.60-FF-001148', NULL, NULL, 55, NULL, NULL, 62934),
(62935, '1.20.1070.10-FF-000393', NULL, 'Predicted protein', 311, NULL, NULL, 62935),
(62936, '1.10.630.10-FF-000720', NULL, 'Uncharacterized protein', 103, NULL, NULL, 62936),
(62937, '1.25.40.10-FF-003530', NULL, 'Serine/threonine-protein kinase ATR-like Protein', 204, NULL, NULL, 62937),
(62938, '1.10.238.10-FF-001146', NULL, 'Uncharacterized protein', 136, NULL, NULL, 62938),
(62939, '1.10.10.10-FF-000088', NULL, 'Forkhead box protein J3', 108, NULL, NULL, 62939),
(62940, '2.10.25.10-FF-001244', NULL, 'Delta-like protein', 42, NULL, NULL, 62940),
(62941, '1.10.10.60-FF-000636', NULL, 'Protein CHROMATIN REMODELING 4', 103, NULL, NULL, 62941),
(62942, '3.30.40.10-FF-000427', NULL, 'Non-structural maintenance of chromosomes element 1', 57, NULL, NULL, 62942),
(62943, '3.80.10.10-FF-000041', NULL, 'LRR receptor-like serine/threonine-protein kinase ERECTA', 96, NULL, NULL, 62943),
(62944, '2.120.10.30-FF-000165', NULL, 'RT02937p', 309, NULL, NULL, 62944),
(62945, '3.30.160.60-FF-002575', NULL, 'Zinc finger protein 616', 32, NULL, NULL, 62945),
(62946, '2.10.70.10-FF-000258', NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', 61, NULL, NULL, 62946),
(62947, '2.130.10.10-FF-000086', NULL, 'target of rapamycin complex subunit LST8', 313, NULL, NULL, 62947),
(62948, '2.60.40.10-FF-005796', NULL, NULL, 82, NULL, NULL, 62948),
(62949, '2.60.40.10-FF-005902', NULL, NULL, 68, NULL, NULL, 62949),
(62950, '2.30.42.10-FF-000434', NULL, NULL, 103, NULL, NULL, 62950),
(62951, '3.30.457.50-FF-000007', NULL, NULL, 101, NULL, NULL, 62951),
(62952, '3.30.559.70-FF-000003', NULL, 'Carnitine acetyl transferase FacC', 318, NULL, NULL, 62952),
(62953, '1.20.1740.10-FF-000023', NULL, 'Amino acid permease', 462, NULL, NULL, 62953);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(62954, '3.60.40.10-FF-000050', NULL, 'probable protein phosphatase 2C 4', 434, NULL, NULL, 62954),
(62955, '3.40.50.1970-FF-000006', NULL, 'Probable multifunctional protein ADE2', 165, NULL, NULL, 62955),
(62956, '3.40.30.10-FF-000735', NULL, 'Predicted protein', 135, NULL, NULL, 62956),
(62957, '1.10.1600.10-FF-000032', NULL, 'DNA binding protein', 117, NULL, NULL, 62957),
(62958, '1.25.10.10-FF-002977', NULL, 'Uncharacterized protein', 399, NULL, NULL, 62958),
(62959, '1.10.238.10-FF-000640', NULL, 'Caltractin, putative', 89, NULL, NULL, 62959),
(62960, '3.40.50.720-FF-001454', NULL, 'Chromosome 7, whole genome shotgun sequence', 94, NULL, NULL, 62960),
(62961, '1.25.10.10-FF-002522', NULL, 'Uncharacterized protein', 191, NULL, NULL, 62961),
(62962, '3.40.50.2000-FF-001005', NULL, 'Glycosyltransferase', 256, NULL, NULL, 62962),
(62963, '2.60.120.10-FF-000402', NULL, 'UDP-2-acetamido-2,6-beta-L-arabino-hexul-4-ose reductase', 118, NULL, NULL, 62963),
(62964, '1.20.1560.10-FF-000037', NULL, 'ATP-binding cassette subfamily C member 10', 317, NULL, NULL, 62964),
(62965, '1.20.1310.10-FF-000215', NULL, NULL, 143, NULL, NULL, 62965),
(62966, '1.10.510.10-FF-001066', NULL, 'Probable serine/threonine-protein kinase irlE', 181, NULL, NULL, 62966),
(62967, '3.90.80.10-FF-000011', NULL, 'Pyrophosphatase (inorganic) 1', 176, NULL, NULL, 62967),
(62968, '3.30.420.40-FF-001100', NULL, 'Actin-related protein 8', 66, NULL, NULL, 62968),
(62969, '1.10.287.580-FF-000002', NULL, 'Serpin family E member 2', 52, NULL, NULL, 62969),
(62970, '3.30.160.20-FF-000225', NULL, 'Double-stranded RNA-activated protein kinase 2', 89, NULL, NULL, 62970),
(62971, '2.130.10.10-FF-004357', NULL, 'Anaphase-promoting complex subunit 4', 92, NULL, NULL, 62971),
(62972, '1.20.120.420-FF-000003', NULL, 'Methylthioribose-1-phosphate isomerase', 188, NULL, NULL, 62972),
(62973, '1.20.58.390-FF-000298', NULL, 'Hypothetical protein LOC100135106', 85, NULL, NULL, 62973),
(62974, '1.10.510.10-FF-002690', NULL, NULL, 176, NULL, NULL, 62974),
(62975, '3.40.50.720-FF-001566', NULL, 'Reticulon-like protein', 351, NULL, NULL, 62975),
(62976, '3.40.50.12780-FF-000118', NULL, 'Acetyl-coenzyme A synthetase', 235, NULL, NULL, 62976),
(62977, '3.30.40.10-FF-000303', NULL, 'Zinc finger CCCH domain-containing protein 19', 101, NULL, NULL, 62977),
(62978, '1.20.930.80-FF-000020', NULL, 'Uncharacterized protein', 106, NULL, NULL, 62978),
(62979, '2.60.40.10-FF-001743', NULL, 'filamin-A isoform X8', 100, NULL, NULL, 62979),
(62980, '3.40.50.300-FF-005268', NULL, 'Uncharacterized protein', 182, NULL, NULL, 62980),
(62981, '1.20.80.10-FF-000058', NULL, 'Uncharacterized protein', 72, NULL, NULL, 62981),
(62982, '3.20.20.80-FF-000481', NULL, 'Glycoside hydrolase superfamily', 193, NULL, NULL, 62982),
(62983, '3.30.160.60-FF-002699', NULL, 'Zinc finger protein 998', 28, NULL, NULL, 62983),
(62984, '1.20.1560.10-FF-000930', NULL, 'Uncharacterized protein', 54, NULL, NULL, 62984),
(62985, '1.10.10.1420-FF-000007', NULL, NULL, 137, NULL, NULL, 62985),
(62986, '3.80.10.10-FF-001688', NULL, 'GM20660', 221, NULL, NULL, 62986),
(62987, '1.10.510.10-FF-003090', NULL, NULL, 198, NULL, NULL, 62987),
(62988, '2.30.30.1190-FF-000017', NULL, 'Zinc finger nuclease 2', 49, NULL, NULL, 62988),
(62989, '2.60.40.60-FF-000656', NULL, 'Uncharacterized protein', 148, NULL, NULL, 62989),
(62990, '1.10.150.50-FF-000010', NULL, 'Fli-1 proto-oncogene, ETS transcription factor', 97, NULL, NULL, 62990),
(62991, '2.130.10.10-FF-002918', NULL, 'Uncharacterized protein', 93, NULL, NULL, 62991),
(62992, '3.60.20.10-FF-000048', NULL, 'Proteasome subunit alpha type-2', 250, NULL, NULL, 62992),
(62993, '1.25.40.10-FF-002911', NULL, 'PsbB mRNA maturation factor Mbb1, chloroplastic', 190, NULL, NULL, 62993),
(62994, '1.10.40.30-FF-000028', NULL, 'Argininosuccinate lyase', 44, NULL, NULL, 62994),
(62995, '1.10.510.10-FF-001627', NULL, 'Protein kinase, putative', 340, NULL, NULL, 62995),
(62996, '1.10.10.60-FF-000075', NULL, 'LIM/homeobox protein Lhx1', 84, NULL, NULL, 62996),
(62997, '3.30.505.10-FF-000075', NULL, 'SH2 domain containing 2A', 111, NULL, NULL, 62997);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(62998, '2.130.10.10-FF-001159', NULL, 'SIR4-interacting protein SIF2', 390, NULL, NULL, 62998),
(62999, '1.25.10.10-FF-003034', NULL, 'Uncharacterized protein', 308, NULL, NULL, 62999),
(63000, '3.30.50.10-FF-000017', NULL, 'Oxysterols receptor LXR-alpha isoform 1', 102, NULL, NULL, 63000),
(63001, '3.20.20.150-FF-000011', NULL, 'Putative hydroxypyruvate isomerase', 271, NULL, NULL, 63001),
(63002, '3.20.20.80-FF-000149', NULL, 'Chitinase, putative', 270, NULL, NULL, 63002),
(63003, '3.40.50.880-FF-000057', NULL, 'Protein/nucleic acid deglycase DJ-1', 189, NULL, NULL, 63003),
(63004, '3.40.50.150-FF-001710', NULL, NULL, 52, NULL, NULL, 63004),
(63005, '3.30.160.60-FF-002120', NULL, 'Zinc finger protein 554', 25, NULL, NULL, 63005),
(63006, '2.60.40.10-FF-005341', NULL, NULL, 73, NULL, NULL, 63006),
(63007, '4.10.270.10-FF-000001', NULL, 'Myosin heavy chain, non-muscle', 59, NULL, NULL, 63007),
(63008, '1.10.10.1400-FF-000001', NULL, NULL, 66, NULL, NULL, 63008),
(63009, '2.60.40.60-FF-001056', NULL, 'Cadherin-4', 76, NULL, NULL, 63009),
(63010, '3.40.50.11610-FF-000003', NULL, '2-oxoglutarate dehydrogenase, isoform X4', 139, NULL, NULL, 63010),
(63011, '3.30.200.20-FF-002303', NULL, 'Uncharacterized protein', 114, NULL, NULL, 63011),
(63012, '1.20.1740.10-FF-000135', NULL, 'Amino acid permease', 431, NULL, NULL, 63012),
(63013, '3.40.50.300-FF-006780', NULL, 'ATP-binding cassette, sub-family A (ABC1), member 2', 59, NULL, NULL, 63013),
(63014, '1.20.1070.10-FF-000174', NULL, 'beta-3 adrenergic receptor', 304, NULL, NULL, 63014),
(63015, '3.30.200.20-FF-001685', NULL, 'Pim-3 proto-oncogene, serine/threonine kinase', 68, NULL, NULL, 63015),
(63016, '3.90.1150.10-FF-000483', NULL, 'Phosphoserine aminotransferase, putative', 76, NULL, NULL, 63016),
(63017, '1.25.40.20-FF-001279', NULL, 'Uncharacterized protein', 178, NULL, NULL, 63017),
(63018, '1.10.150.110-FF-000014', NULL, 'DNA polymerase lambda subunit', 84, NULL, NULL, 63018),
(63019, '3.10.400.20-FF-000024', NULL, 'Uncharacterized protein', 99, NULL, NULL, 63019),
(63020, '1.25.40.10-FF-002018', NULL, 'Pentatricopeptide repeat-containing protein At2g13600', 139, NULL, NULL, 63020),
(63021, '1.10.10.10-FF-001162', NULL, 'EmrB/QacA subfamily drug resistance transporter', 138, NULL, NULL, 63021),
(63022, '3.90.1150.210-FF-000019', NULL, 'F-actin-capping protein subunit beta', 183, NULL, NULL, 63022),
(63023, '3.10.110.10-FF-000263', NULL, 'Ubiquitin-conjugating enzyme E2Z', 133, NULL, NULL, 63023),
(63024, '3.30.160.60-FF-001283', NULL, 'Uncharacterized protein', 29, NULL, NULL, 63024),
(63025, '3.30.300.30-FF-000094', NULL, 'Nonribosomal peptide synthase Pes1', 109, NULL, NULL, 63025),
(63026, '3.30.300.110-FF-000010', NULL, 'tRNA-dimethyltransferase protein', 81, NULL, NULL, 63026),
(63027, '2.40.10.10-FF-000449', NULL, NULL, 116, NULL, NULL, 63027),
(63028, '3.40.50.2300-FF-000595', NULL, 'DNA-binding response regulator', 80, NULL, NULL, 63028),
(63029, '3.30.160.60-FF-005554', NULL, NULL, 78, NULL, NULL, 63029),
(63030, '3.30.1050.10-FF-000005', NULL, 'hydroxysteroid dehydrogenase-like protein 2 isoform X1', 115, NULL, NULL, 63030),
(63031, '2.120.10.30-FF-000289', NULL, 'Uncharacterized protein', 77, NULL, NULL, 63031),
(63032, '3.30.160.60-FF-006285', NULL, NULL, 47, NULL, NULL, 63032),
(63033, '1.25.10.10-FF-000268', NULL, 'tubulin-specific chaperone D', 272, NULL, NULL, 63033),
(63034, '3.30.930.10-FF-000130', NULL, 'Phenylalanine--tRNA ligase beta subunit', 227, NULL, NULL, 63034),
(63035, '1.10.472.10-FF-000116', NULL, 'Cyclin', 25, NULL, NULL, 63035),
(63036, '3.30.540.10-FF-000083', NULL, 'Inositol monophosphatase family protein', 109, NULL, NULL, 63036),
(63037, '1.10.510.10-FF-002358', NULL, NULL, 187, NULL, NULL, 63037),
(63038, '3.30.160.60-FF-003317', NULL, 'Zinc finger protein 322', 29, NULL, NULL, 63038),
(63039, '3.40.1130.10-FF-000004', NULL, 'Acyl-phosphate glycerol 3-phosphate acyltransferase', 212, NULL, NULL, 63039),
(63040, '2.40.50.140-FF-000620', NULL, 'Protection of telomeres 1b protein', 128, NULL, NULL, 63040);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(63041, '3.30.420.40-FF-000482', NULL, 'Heat shock 70 kDa protein, putative', 88, NULL, NULL, 63041),
(63042, '1.20.1280.50-FF-000201', NULL, 'Predicted protein', 63, NULL, NULL, 63042),
(63043, '2.170.270.10-FF-000139', NULL, 'PR domain zinc finger protein 13', 127, NULL, NULL, 63043),
(63044, '3.30.465.10-FF-000014', NULL, 'D-lactate dehydrogenase (Cytochrome), putative', 228, NULL, NULL, 63044),
(63045, '3.30.70.330-FF-002097', NULL, NULL, 166, NULL, NULL, 63045),
(63046, '1.10.510.10-FF-004376', NULL, NULL, 99, NULL, NULL, 63046),
(63047, '2.130.10.10-FF-002795', NULL, 'Uncharacterized protein', 202, NULL, NULL, 63047),
(63048, '3.10.590.10-FF-000023', NULL, 'Uncharacterized protein', 86, NULL, NULL, 63048),
(63049, '1.20.1420.30-FF-000089', NULL, 'Uncharacterized protein', 108, NULL, NULL, 63049),
(63050, '3.30.40.10-FF-001607', NULL, 'Uncharacterized protein', 98, NULL, NULL, 63050),
(63051, '3.50.50.60-FF-001240', NULL, 'Uncharacterized protein', 173, NULL, NULL, 63051),
(63052, '2.130.10.10-FF-003071', NULL, 'WD domain', 124, NULL, NULL, 63052),
(63053, '3.40.50.300-FF-003470', NULL, 'DNA helicase', 165, NULL, NULL, 63053),
(63054, '3.40.50.300-FF-006448', NULL, 'Predicted protein', 123, NULL, NULL, 63054),
(63055, '1.25.40.90-FF-000081', NULL, 'CID domain-containing protein 1', 136, NULL, NULL, 63055),
(63056, '1.25.40.10-FF-004480', NULL, 'Uncharacterized protein', 102, NULL, NULL, 63056),
(63057, '2.20.70.10-FF-000162', NULL, 'Uncharacterized protein', 39, NULL, NULL, 63057),
(63058, '3.40.50.300-FF-004318', NULL, 'Exopolysaccharide export protein', 278, NULL, NULL, 63058),
(63059, '1.25.40.10-FF-002350', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 104, NULL, NULL, 63059),
(63060, '3.30.870.10-FF-000198', NULL, 'Uncharacterized protein', 89, NULL, NULL, 63060),
(63061, '3.30.70.330-FF-002439', NULL, NULL, 156, NULL, NULL, 63061),
(63062, '3.50.80.10-FF-000018', NULL, 'D-aminoacyl-tRNA deacylase', 117, NULL, NULL, 63062),
(63063, '2.60.40.10-FF-004380', NULL, NULL, 102, NULL, NULL, 63063),
(63064, '1.20.1250.20-FF-000505', NULL, 'Predicted protein', 191, NULL, NULL, 63064),
(63065, '3.40.50.1440-FF-000078', NULL, 'Uncharacterized protein', 118, NULL, NULL, 63065),
(63066, '3.40.50.300-FF-007741', NULL, 'Uncharacterized protein', 81, NULL, NULL, 63066),
(63067, '3.30.160.60-FF-000883', NULL, 'Zinc finger protein 142', 24, NULL, NULL, 63067),
(63068, '3.30.70.3290-FF-000023', NULL, '6-deoxyerythronolide-B synthase EryA1, modules 1 and 2', 73, NULL, NULL, 63068),
(63069, '3.90.290.10-FF-000038', NULL, 'Uncharacterized protein', 72, NULL, NULL, 63069),
(63070, '3.40.525.10-FF-000023', NULL, 'Csr1p', 324, NULL, NULL, 63070),
(63071, '3.30.710.10-FF-000366', NULL, 'Zinc finger and BTB domain-containing 25', 68, NULL, NULL, 63071),
(63072, '3.30.200.20-FF-001342', NULL, 'CAMK family protein kinase', 93, NULL, NULL, 63072),
(63073, '1.10.150.20-FF-000231', NULL, 'YALI0D12364p', 60, NULL, NULL, 63073),
(63074, '2.30.30.140-FF-000231', NULL, 'Uncharacterized protein', 81, NULL, NULL, 63074),
(63075, '3.30.1240.10-FF-000054', NULL, 'Haloacid dehalogenase-like hydrolase', 106, NULL, NULL, 63075),
(63076, '3.40.50.2300-FF-000831', NULL, NULL, 123, NULL, NULL, 63076),
(63077, '1.20.58.1120-FF-000055', NULL, NULL, 150, NULL, NULL, 63077),
(63078, '2.60.40.10-FF-003087', NULL, NULL, 98, NULL, NULL, 63078),
(63079, '2.10.25.10-FF-000064', NULL, 'Delta-like protein', 40, NULL, NULL, 63079),
(63080, '3.10.28.10-FF-000028', NULL, 'Laglidadg endonuclease', 162, NULL, NULL, 63080),
(63081, '3.90.180.10-FF-000160', NULL, 'Uncharacterized protein', 138, NULL, NULL, 63081),
(63082, '3.30.200.20-FF-000049', NULL, 'cyclin-dependent kinase-like 1 isoform X1', 84, NULL, NULL, 63082),
(63083, '3.30.565.10-FF-000409', NULL, 'Uncharacterized protein', 189, NULL, NULL, 63083),
(63084, '1.25.40.10-FF-001057', NULL, 'Vacuolar protein sorting-associated protein 41 homolog', 271, NULL, NULL, 63084),
(63085, '1.20.1250.20-FF-000163', NULL, 'Putative monocarboxylate transporter 13', 390, NULL, NULL, 63085);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(63086, '3.40.50.150-FF-000417', NULL, 'tRNA (Guanine(10)-N2)-methyltransferase', 185, NULL, NULL, 63086),
(63087, '4.10.240.10-FF-000162', NULL, 'YALI0C22990p', 68, NULL, NULL, 63087),
(63088, '3.90.640.10-FF-000184', NULL, 'Actin-related protein', 101, NULL, NULL, 63088),
(63089, '3.40.50.300-FF-002177', NULL, 'DEAD/DEAH box helicase, putative', 226, NULL, NULL, 63089),
(63090, '3.40.50.10990-FF-000008', NULL, '3,4-dihydroxy-2-butanone 4-phosphate synthase', 160, NULL, NULL, 63090),
(63091, '3.40.50.300-FF-005611', NULL, 'RING finger-containing protein, putative', 121, NULL, NULL, 63091),
(63092, '3.50.7.10-FF-000070', NULL, NULL, 151, NULL, NULL, 63092),
(63093, '2.60.40.60-FF-000550', NULL, 'Uncharacterized protein', 104, NULL, NULL, 63093),
(63094, '3.80.10.10-FF-001002', NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase IMK2', 139, NULL, NULL, 63094),
(63095, '1.20.1070.10-FF-001915', NULL, 'Uncharacterized protein', 284, NULL, NULL, 63095),
(63096, '1.10.220.30-FF-000009', NULL, 'Flagellar motor switch protein FliG', 85, NULL, NULL, 63096),
(63097, '3.40.1160.10-FF-000051', NULL, 'Isopentenyl phosphate kinase', 269, NULL, NULL, 63097),
(63098, '1.50.10.10-FF-000081', NULL, 'alpha-1,2-Mannosidase', 213, NULL, NULL, 63098),
(63099, '3.80.10.10-FF-001345', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 263, NULL, NULL, 63099),
(63100, '3.90.780.10-FF-000014', NULL, 'YHR202W-like protein', 90, NULL, NULL, 63100),
(63101, '1.20.58.400-FF-000026', NULL, 'Vesicle transport through interaction with t-SNAREs-like protein 1B', 91, NULL, NULL, 63101),
(63102, '3.90.550.50-FF-000065', NULL, 'Hexosyltransferase', 229, NULL, NULL, 63102),
(63103, '3.90.70.10-FF-000308', NULL, 'Similar to ubiquitin C-terminal hydrolase', 306, NULL, NULL, 63103),
(63104, '1.50.10.150-FF-000010', NULL, 'Tellurite resistance protein', 309, NULL, NULL, 63104),
(63105, '1.25.40.10-FF-004727', NULL, 'Uncharacterized protein', 85, NULL, NULL, 63105),
(63106, '3.40.50.11350-FF-000015', NULL, 'alpha-(1,6)-fucosyltransferase-like isoform X1', 165, NULL, NULL, 63106),
(63107, '3.40.1190.20-FF-000224', NULL, NULL, 66, NULL, NULL, 63107),
(63108, '3.80.10.10-FF-000726', NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase', 302, NULL, NULL, 63108),
(63109, '3.10.20.70-FF-000012', NULL, 'Glutamine synthetase, type I', 106, NULL, NULL, 63109),
(63110, '3.30.420.100-FF-000011', NULL, '60S ribosomal protein L5', 100, NULL, NULL, 63110),
(63111, '3.40.50.11660-FF-000007', NULL, 'alpha-(1,3)-fucosyltransferase 6-like', 218, NULL, NULL, 63111),
(63112, '1.10.238.10-FF-000185', NULL, 'Mitochondrial Rho GTPase', 105, NULL, NULL, 63112),
(63113, '3.30.70.330-FF-001478', NULL, NULL, 95, NULL, NULL, 63113),
(63114, '1.20.58.1040-FF-000020', NULL, '1,3-beta-glucanosyltransferase', 111, NULL, NULL, 63114),
(63115, '3.60.21.10-FF-000359', NULL, '5'' nucleotidase, putative', 144, NULL, NULL, 63115),
(63116, '3.30.710.10-FF-000023', NULL, 'Ectoderm-neural cortex protein 1', 130, NULL, NULL, 63116),
(63117, '1.10.10.10-FF-001049', NULL, 'Non-SMC element 1, isoform B', 97, NULL, NULL, 63117),
(63118, '3.30.310.50-FF-000038', NULL, 'YALI0F21373p', 85, NULL, NULL, 63118),
(63119, '2.60.40.10-FF-002923', NULL, 'Granulocyte-macrophage colony-stimulating factor receptor subunit alpha', 95, NULL, NULL, 63119),
(63120, '3.30.60.30-FF-000075', NULL, 'Agrin', 52, NULL, NULL, 63120),
(63121, '3.30.1370.120-FF-000014', NULL, 'Type II secretion system protein', 70, NULL, NULL, 63121),
(63122, '1.25.40.10-FF-000096', NULL, 'Tetratricopeptide repeat domain 28', 234, NULL, NULL, 63122),
(63123, '1.20.120.1530-FF-000006', NULL, 'Atypical/HisK protein kinase', 93, NULL, NULL, 63123),
(63124, '3.30.40.10-FF-000646', NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', 89, NULL, NULL, 63124),
(63125, '2.30.36.70-FF-000010', NULL, 'Actin-related protein 5', 37, NULL, NULL, 63125),
(63126, '1.25.40.540-FF-000019', NULL, 'PP2A regulatory subunit TAP46', 69, NULL, NULL, 63126);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(63127, '3.30.160.60-FF-003536', NULL, NULL, 28, NULL, NULL, 63127),
(63128, '3.80.10.10-FF-003475', NULL, 'Predicted protein', 210, NULL, NULL, 63128),
(63129, '3.50.50.60-FF-000621', NULL, '2-polyprenyl-6-methoxyphenol hydroxylase', 74, NULL, NULL, 63129),
(63130, '3.30.160.60-FF-001406', NULL, 'Zinc finger and BTB domain-containing protein 21', 30, NULL, NULL, 63130),
(63131, '2.130.10.10-FF-005212', NULL, 'ELongator complex Protein Component', 329, NULL, NULL, 63131),
(63132, '1.10.8.10-FF-000121', NULL, 'Ancient ubiquitous protein', 45, NULL, NULL, 63132),
(63133, '3.90.70.10-FF-000640', NULL, 'Predicted protein', 110, NULL, NULL, 63133),
(63134, '1.25.40.20-FF-000554', NULL, 'Os08g0401100 protein', 199, NULL, NULL, 63134),
(63135, '1.10.287.110-FF-000238', NULL, 'Chaperone protein DNAj, putative', 135, NULL, NULL, 63135),
(63136, '4.10.400.10-FF-000040', NULL, 'low-density lipoprotein receptor-related protein 3', 55, NULL, NULL, 63136),
(63137, '3.90.950.10-FF-000050', NULL, 'At2g25500', 97, NULL, NULL, 63137),
(63138, '3.40.20.10-FF-000111', NULL, 'Protein tyrosine kinase, putative', 144, NULL, NULL, 63138),
(63139, '1.10.240.10-FF-000016', NULL, 'Tyrosine--tRNA ligase', 100, NULL, NULL, 63139),
(63140, '2.60.40.10-FF-002468', NULL, 'High Incidence of Males (Increased X chromosome loss)', 86, NULL, NULL, 63140),
(63141, '3.90.79.10-FF-000272', NULL, 'Uncharacterized protein', 98, NULL, NULL, 63141),
(63142, '2.30.30.40-FF-000308', NULL, 'Bud site selection protein', 66, NULL, NULL, 63142),
(63143, '3.30.450.60-FF-000080', NULL, 'Adaptor-related protein complex 3 subunit sigma 2', 53, NULL, NULL, 63143),
(63144, '1.10.20.10-FF-000038', NULL, 'dr1-associated corepressor homolog', 86, NULL, NULL, 63144),
(63145, '3.40.50.1360-FF-000043', NULL, '6-phosphogluconolactonase', 237, NULL, NULL, 63145),
(63146, '2.130.10.10-FF-004936', NULL, 'Uncharacterized protein', 103, NULL, NULL, 63146),
(63147, '1.20.140.150-FF-000123', NULL, 'Uncharacterized protein', 105, NULL, NULL, 63147),
(63148, '3.10.20.90-FF-000675', NULL, 'UBX domain-containing protein 2', 158, NULL, NULL, 63148),
(63149, '2.30.180.10-FF-000109', NULL, NULL, 169, NULL, NULL, 63149),
(63150, '3.40.50.300-FF-004993', NULL, 'Uncharacterized protein', 237, NULL, NULL, 63150),
(63151, '1.10.238.10-FF-000746', NULL, 'Uncharacterized protein', 161, NULL, NULL, 63151),
(63152, '2.40.128.20-FF-000051', NULL, 'Sll0497 protein', 139, NULL, NULL, 63152),
(63153, '1.25.10.10-FF-000942', NULL, 'Nuclear transport receptor, putative', 897, NULL, NULL, 63153),
(63154, '3.80.10.10-FF-002306', NULL, 'Uncharacterized protein', 193, NULL, NULL, 63154),
(63155, '3.40.50.1000-FF-000862', NULL, NULL, 42, NULL, NULL, 63155),
(63156, '2.130.10.10-FF-006049', NULL, 'Uncharacterized protein', 201, NULL, NULL, 63156),
(63157, '2.40.70.10-FF-000116', NULL, 'Cathepsin D', 161, NULL, NULL, 63157),
(63158, '1.20.120.1750-FF-000055', NULL, 'RBR-type E3 ubiquitin transferase', 87, NULL, NULL, 63158),
(63159, '3.40.50.1820-FF-001844', NULL, 'Lypla1 protein', 74, NULL, NULL, 63159),
(63160, '3.40.50.2300-FF-000376', NULL, 'Response regulator BlpR', 139, NULL, NULL, 63160),
(63161, '1.10.3720.10-FF-000215', NULL, 'Hydroxymethylpyrimidine ABC transporter, transmembrane component', 199, NULL, NULL, 63161),
(63162, '3.30.70.270-FF-000145', NULL, 'Uncharacterized protein', 94, NULL, NULL, 63162),
(63163, '3.40.50.720-FF-000274', NULL, 'SUMO-activating enzyme subunit 1 isoform X1', 344, NULL, NULL, 63163),
(63164, '1.10.8.60-FF-000107', NULL, 'RuvB-like helicase', 91, NULL, NULL, 63164),
(63165, '1.10.20.10-FF-000370', NULL, NULL, 67, NULL, NULL, 63165),
(63166, '3.80.10.10-FF-004436', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 161, NULL, NULL, 63166),
(63167, '1.25.40.20-FF-000897', NULL, 'Uncharacterized protein', 110, NULL, NULL, 63167),
(63168, '1.10.238.10-FF-001022', NULL, 'Myosin regulatory light chain', 64, NULL, NULL, 63168),
(63169, '1.25.10.10-FF-000381', NULL, 'Serine/threonine-protein kinase TOR', 393, NULL, NULL, 63169),
(63170, '2.40.50.100-FF-000182', NULL, 'RND efflux system, membrane fusion protein CmeA', 35, NULL, NULL, 63170);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(63171, '1.10.510.10-FF-000560', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase isoform A', 205, NULL, NULL, 63171),
(63172, '3.80.10.10-FF-001906', NULL, 'Calmodulin-binding receptor kinase CaMRLK', 111, NULL, NULL, 63172),
(63173, '2.130.10.10-FF-004251', NULL, 'Predicted protein', 138, NULL, NULL, 63173),
(63174, '1.10.10.520-FF-000006', NULL, 'SUMO-activating enzyme subunit', 215, NULL, NULL, 63174),
(63175, '2.40.50.140-FF-000963', NULL, NULL, 95, NULL, NULL, 63175),
(63176, '3.90.226.10-FF-000278', NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', 429, NULL, NULL, 63176),
(63177, '1.10.110.10-FF-000012', NULL, 'F23N19.16', 77, NULL, NULL, 63177),
(63178, '1.10.420.10-FF-000002', NULL, 'Catalase-peroxidase', 200, NULL, NULL, 63178),
(63179, '3.30.200.20-FF-000628', NULL, 'AGC family protein kinase', 95, NULL, NULL, 63179),
(63180, '2.100.10.30-FF-000003', NULL, 'OSJNBa0016N04.16-like protein', 144, NULL, NULL, 63180),
(63181, '3.90.105.10-FF-000025', NULL, 'Molybdopterin molybdenumtransferase', 57, NULL, NULL, 63181),
(63182, '1.25.40.20-FF-001173', NULL, 'Transient receptor potential cation channel subfamily A member 1 homolog', 155, NULL, NULL, 63182),
(63183, '1.10.510.10-FF-003196', NULL, NULL, 149, NULL, NULL, 63183),
(63184, '3.10.129.10-FF-000070', NULL, 'Acyl-CoA thioesterase II', 144, NULL, NULL, 63184),
(63185, '3.40.50.300-FF-002738', NULL, 'Putative ATPase', 201, NULL, NULL, 63185),
(63186, '1.10.390.10-FF-000004', NULL, 'Aminopeptidase N', 245, NULL, NULL, 63186),
(63187, '3.90.740.10-FF-000017', NULL, 'Leucine--tRNA ligase', 195, NULL, NULL, 63187),
(63188, '1.25.40.10-FF-000770', NULL, 'pentatricopeptide repeat-containing protein At5g39980, chloroplastic', 158, NULL, NULL, 63188),
(63189, '1.10.1160.10-FF-000003', NULL, 'Glutamate--tRNA ligase 2', 84, NULL, NULL, 63189),
(63190, '3.30.390.110-FF-000016', NULL, 'Protein MAK16 homolog', 36, NULL, NULL, 63190),
(63191, '3.40.50.300-FF-003138', NULL, 'DEAD-box helicase 5', 272, NULL, NULL, 63191),
(63192, '3.30.40.10-FF-002321', NULL, 'BRCA1-associated RING domain protein 1', 101, NULL, NULL, 63192),
(63193, '2.130.10.10-FF-003975', NULL, 'Uncharacterized protein', 236, NULL, NULL, 63193),
(63194, '3.40.120.10-FF-000066', NULL, 'Putative phosphoglucosamine mutase protein', 87, NULL, NULL, 63194),
(63195, '1.25.40.20-FF-001515', NULL, 'Uncharacterized protein', 49, NULL, NULL, 63195),
(63196, '1.10.10.60-FF-000530', NULL, 'Sigma-54-dependent transcriptional response regulator PilR', 65, NULL, NULL, 63196),
(63197, '3.40.50.12710-FF-000013', NULL, 'SAM-dependent methyltransferase, MidA family', 365, NULL, NULL, 63197),
(63198, '2.40.100.10-FF-000052', NULL, 'Peptidyl-prolyl cis-trans isomerase', 219, NULL, NULL, 63198),
(63199, '3.30.70.100-FF-000122', NULL, NULL, 74, NULL, NULL, 63199),
(63200, '3.30.160.20-FF-000006', NULL, 'interleukin enhancer-binding factor 3 isoform X2', 74, NULL, NULL, 63200),
(63201, '3.30.1180.20-FF-000001', NULL, 'Dihydroxyacetone kinase 1', 157, NULL, NULL, 63201),
(63202, '3.30.200.20-FF-000381', NULL, 'tribbles homolog 1', 82, NULL, NULL, 63202),
(63203, '1.20.1250.10-FF-000047', NULL, 'Growth hormone d21', 202, NULL, NULL, 63203),
(63204, '3.50.50.60-FF-000060', NULL, 'L-aspartate oxidase', 281, NULL, NULL, 63204),
(63205, '2.30.30.40-FF-000527', NULL, 'Plectin', 67, NULL, NULL, 63205),
(63206, '3.90.70.10-FF-000185', NULL, 'Predicted protein', 303, NULL, NULL, 63206),
(63207, '3.40.50.300-FF-007409', NULL, 'ATP-binding cassette transporter, subfamily C, member 14, group MRP protein PpABCC14', 91, NULL, NULL, 63207),
(63208, '3.40.50.300-FF-008028', NULL, 'Uncharacterized protein', 138, NULL, NULL, 63208),
(63209, '1.20.272.10-FF-000071', NULL, NULL, 113, NULL, NULL, 63209),
(63210, '3.30.565.10-FF-000180', NULL, 'Histidine kinase sensor protein', 155, NULL, NULL, 63210),
(63211, '3.90.1290.10-FF-000083', NULL, 'Dystonin', 68, NULL, NULL, 63211),
(63212, '3.40.50.11370-FF-000010', NULL, 'Inositol-tetrakisphosphate 1-kinase', 108, NULL, NULL, 63212),
(63213, '3.80.10.10-FF-004094', NULL, 'N-CAM Ig domain-containing protein, putative', 122, NULL, NULL, 63213);
INSERT INTO "PUBLIC"."MODEL" VALUES
(63214, '3.30.1010.10-FF-000008', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit gamma', 152, NULL, NULL, 63214),
(63215, '3.40.50.1820-FF-001283', NULL, 'Predicted protein', 289, NULL, NULL, 63215),
(63216, '3.40.50.1820-FF-000664', NULL, 'Uncharacterized protein', 344, NULL, NULL, 63216),
(63217, '2.40.50.120-FF-000064', NULL, 'Predicted protein', 94, NULL, NULL, 63217),
(63218, '3.30.70.360-FF-000060', NULL, 'Uncharacterized protein', 53, NULL, NULL, 63218),
(63219, '3.20.20.190-FF-000012', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', 194, NULL, NULL, 63219),
(63220, '1.10.30.10-FF-000196', NULL, 'Uncharacterized protein', 59, NULL, NULL, 63220),
(63221, '2.20.100.10-FF-000152', NULL, 'SCO-spondin isoform X3', 65, NULL, NULL, 63221),
(63222, '2.40.70.10-FF-000459', NULL, NULL, 287, NULL, NULL, 63222),
(63223, '3.40.1090.10-FF-000056', NULL, 'Lysophospholipase', 499, NULL, NULL, 63223),
(63224, '3.30.160.60-FF-005116', NULL, NULL, 47, NULL, NULL, 63224),
(63225, '1.20.58.390-FF-000192', NULL, 'Predicted protein', 87, NULL, NULL, 63225),
(63226, '1.10.1370.30-FF-000042', NULL, 'Angiotensin-converting enzyme', 159, NULL, NULL, 63226),
(63227, '3.90.470.10-FF-000024', NULL, 'Ribosomal protein L22', 155, NULL, NULL, 63227),
(63228, '3.40.50.20-FF-000048', NULL, 'D-alanine--D-alanine ligase', 101, NULL, NULL, 63228),
(63229, '3.40.50.2000-FF-000623', NULL, 'Uncharacterized protein', 265, NULL, NULL, 63229),
(63230, '1.25.40.20-FF-001734', NULL, 'Poly [ADP-ribose] polymerase', 222, NULL, NULL, 63230),
(63231, '2.40.20.10-FF-000057', NULL, 'Uncharacterized protein', 81, NULL, NULL, 63231),
(63232, '1.10.560.10-FF-000164', NULL, '60 kDa heat shock protein, mitochondrial', 47, NULL, NULL, 63232),
(63233, '3.40.50.300-FF-008360', NULL, 'Uncharacterized protein', 50, NULL, NULL, 63233),
(63234, '1.25.40.10-FF-000438', NULL, 'Zinc finger MYND-type containing 12', 210, NULL, NULL, 63234),
(63235, '3.40.630.10-FF-000481', NULL, 'Uncharacterized protein', 120, NULL, NULL, 63235),
(63236, '2.40.180.10-FF-000045', NULL, 'Catalase', 157, NULL, NULL, 63236),
(63237, '1.10.510.10-FF-001521', NULL, 'Serine/threonine protein kinase', 351, NULL, NULL, 63237),
(63238, '2.60.120.1030-FF-000013', NULL, 'Uncharacterized protein', 79, NULL, NULL, 63238),
(63239, '1.10.1050.10-FF-000012', NULL, 'Ribosomal protein S4, mitochondrial', 49, NULL, NULL, 63239),
(63240, '1.10.274.100-FF-000012', NULL, 'DNA-directed RNA polymerase subunit', 178, NULL, NULL, 63240),
(63241, '3.30.160.60-FF-000445', NULL, 'Vascular endothelial zinc finger 1', 32, NULL, NULL, 63241),
(63242, '3.30.70.3160-FF-000001', NULL, 'Probable tRNA pseudouridine synthase D', 83, NULL, NULL, 63242),
(63243, '1.10.260.30-FF-000006', NULL, 'Signal recognition particle subunit SRP54', 134, NULL, NULL, 63243),
(63244, '3.80.10.10-FF-000384', NULL, 'Nuclear RNA export factor 1', 159, NULL, NULL, 63244),
(63245, '3.40.630.30-FF-000487', NULL, 'GNAT family acetyltransferase', 148, NULL, NULL, 63245),
(63246, '3.90.79.10-FF-000053', NULL, 'Coenzyme A diphosphatase', 225, NULL, NULL, 63246),
(63247, '3.90.550.10-FF-000424', NULL, 'Predicted protein', 441, NULL, NULL, 63247),
(63248, '2.30.42.10-FF-000198', NULL, 'E3 ubiquitin-protein ligase LNX isoform X1', 97, NULL, NULL, 63248),
(63249, '3.40.50.1100-FF-000229', NULL, 'Cysteine synthase, putative', 76, NULL, NULL, 63249),
(63250, '3.40.50.300-FF-003357', NULL, 'Regulator of telomere elongation helicase 1 homolog', 253, NULL, NULL, 63250),
(63251, '3.40.50.1000-FF-000188', NULL, 'Trehalose-phosphatase', 178, NULL, NULL, 63251),
(63252, '1.25.40.10-FF-004148', NULL, 'Probable mitochondrial import receptor subunit tom70', 112, NULL, NULL, 63252),
(63253, '3.10.25.10-FF-000005', NULL, 'Methionyl-tRNA formyltransferase', 111, NULL, NULL, 63253),
(63254, '2.60.120.200-FF-000618', NULL, 'Uncharacterized protein', 143, NULL, NULL, 63254),
(63255, '3.40.30.10-FF-001117', NULL, 'Uncharacterized protein', 12, NULL, NULL, 63255),
(63256, '3.30.70.330-FF-002990', NULL, NULL, 87, NULL, NULL, 63256);
INSERT INTO "PUBLIC"."MODEL" VALUES
(63257, '3.40.50.300-FF-004650', NULL, 'Helicase SEN1', 259, NULL, NULL, 63257),
(63258, '3.30.160.60-FF-003879', NULL, NULL, 22, NULL, NULL, 63258),
(63259, '3.100.10.10-FF-000027', NULL, '50S ribosomal protein L15', 68, NULL, NULL, 63259),
(63260, '3.10.20.90-FF-000456', NULL, 'Rad60, isoform F', 96, NULL, NULL, 63260),
(63261, '2.110.10.10-FF-000036', NULL, 'Matrix metalloproteinase 16', 196, NULL, NULL, 63261),
(63262, '1.25.40.20-FF-000863', NULL, 'Ankyrin repeat protein, putative', 60, NULL, NULL, 63262),
(63263, '3.80.10.10-FF-001660', NULL, 'Predicted protein', 159, NULL, NULL, 63263),
(63264, '1.20.1730.10-FF-000123', NULL, 'Putative symporter ywcA', 221, NULL, NULL, 63264),
(63265, '2.40.37.10-FF-000045', NULL, 'Uncharacterized protein', 75, NULL, NULL, 63265),
(63266, '2.130.10.10-FF-004335', NULL, 'Uncharacterized protein', 99, NULL, NULL, 63266),
(63267, '3.40.50.2300-FF-000943', NULL, NULL, 164, NULL, NULL, 63267),
(63268, '1.20.1070.10-FF-000415', NULL, 'Si:dkey-117a8.1', 281, NULL, NULL, 63268),
(63269, '3.40.30.10-FF-000061', NULL, 'Fas associated factor 1', 177, NULL, NULL, 63269),
(63270, '3.40.50.300-FF-003060', NULL, 'Cytidylate kinase', 224, NULL, NULL, 63270),
(63271, '3.40.190.10-FF-000845', NULL, 'Gll3456 protein', 97, NULL, NULL, 63271),
(63272, '1.25.10.10-FF-002477', NULL, 'Uncharacterized protein', 213, NULL, NULL, 63272),
(63273, '2.60.40.10-FF-005346', NULL, NULL, 70, NULL, NULL, 63273),
(63274, '1.50.10.20-FF-000151', NULL, 'Terpene cyclase/mutase family member', 138, NULL, NULL, 63274),
(63275, '1.10.510.10-FF-003224', NULL, NULL, 133, NULL, NULL, 63275),
(63276, '3.80.10.10-FF-003784', NULL, 'AGAP007451-PA', 100, NULL, NULL, 63276),
(63277, '3.40.30.10-FF-001163', NULL, 'Predicted protein', 100, NULL, NULL, 63277),
(63278, '1.10.600.10-FF-000117', NULL, 'Predicted protein', 195, NULL, NULL, 63278),
(63279, '3.30.70.270-FF-000223', NULL, NULL, 83, NULL, NULL, 63279),
(63280, '1.10.238.10-FF-000983', NULL, 'Uncharacterized protein', 70, NULL, NULL, 63280),
(63281, '3.40.367.20-FF-000040', NULL, 'Phosphotransferase', 68, NULL, NULL, 63281),
(63282, '2.60.40.10-FF-003222', NULL, NULL, 81, NULL, NULL, 63282),
(63283, '3.40.50.170-FF-000013', NULL, 'Phosphoribosylamine-glycine ligase', 209, NULL, NULL, 63283),
(63284, '3.20.20.80-FF-000020', NULL, 'Beta-glucosidase 12', 488, NULL, NULL, 63284),
(63285, '3.40.50.300-FF-005184', NULL, 'ABC-transporter ATP-binding protein', 217, NULL, NULL, 63285),
(63286, '2.40.10.200-FF-000001', NULL, 'Integrating conjugative element relaxase, PFGI-1 class', 57, NULL, NULL, 63286),
(63287, '3.40.140.10-FF-000281', NULL, 'Uncharacterized protein', 48, NULL, NULL, 63287),
(63288, '2.40.180.10-FF-000028', NULL, 'Catalase', 198, NULL, NULL, 63288),
(63289, '3.40.50.2300-FF-001399', NULL, NULL, 131, NULL, NULL, 63289),
(63290, '2.60.120.200-FF-000512', NULL, 'Glycosyl hydrolases family 16 protein', 277, NULL, NULL, 63290),
(63291, '3.10.129.110-FF-000006', NULL, 'Aspergillus niger contig An11c0010, genomic contig', 330, NULL, NULL, 63291),
(63292, '3.60.15.10-FF-000064', NULL, 'Probable 3'',5''-cyclic-nucleotide phosphodiesterase', 331, NULL, NULL, 63292),
(63293, '1.10.10.60-FF-000581', NULL, 'Homeobox protein six1a', 62, NULL, NULL, 63293),
(63294, '1.20.140.150-FF-000106', NULL, 'Uncharacterized protein', 172, NULL, NULL, 63294),
(63295, '2.30.180.10-FF-000199', NULL, NULL, 145, NULL, NULL, 63295),
(63296, '3.50.50.60-FF-000357', NULL, 'Hydrogen cyanide synthase HcnC', 62, NULL, NULL, 63296),
(63297, '3.30.70.1290-FF-000002', NULL, 'IS1004 transposase', 133, NULL, NULL, 63297),
(63298, '1.20.58.1880-FF-000024', NULL, 'Protein CBR-SPR-1', 130, NULL, NULL, 63298),
(63299, '2.130.10.30-FF-000013', NULL, 'Retinitis pigmentosa GTPase regulator isoform 1', 368, NULL, NULL, 63299),
(63300, '1.10.10.10-FF-001223', NULL, 'LysR family transcriptional regulator', 83, NULL, NULL, 63300),
(63301, '1.20.1070.10-FF-001876', NULL, 'Uncharacterized protein', 346, NULL, NULL, 63301),
(63302, '2.60.40.10-FF-001131', NULL, 'Hemicentin 1', 92, NULL, NULL, 63302);
INSERT INTO "PUBLIC"."MODEL" VALUES
(63303, '2.130.10.10-FF-003233', NULL, 'WD repeat-containing protein 11', 257, NULL, NULL, 63303),
(63304, '3.40.640.10-FF-000274', NULL, 'Taurine--pyruvate aminotransferase', 281, NULL, NULL, 63304),
(63305, '1.10.8.270-FF-000080', NULL, 'Rab GTPase activating protein putative', 97, NULL, NULL, 63305),
(63306, '3.90.550.50-FF-000088', NULL, 'Uncharacterized protein', 225, NULL, NULL, 63306),
(63307, '3.80.10.10-FF-002323', NULL, 'Leucine-rich repeat containing protein', 137, NULL, NULL, 63307),
(63308, '2.40.10.10-FF-000450', NULL, NULL, 116, NULL, NULL, 63308),
(63309, '3.40.1190.20-FF-000050', NULL, 'ketohexokinase isoform X1', 230, NULL, NULL, 63309),
(63310, '3.40.50.2300-FF-000297', NULL, 'Phosphate regulon transcriptional regulatory protein PhoB', 84, NULL, NULL, 63310),
(63311, '4.10.60.10-FF-000028', NULL, 'Gag polyprotein', 56, NULL, NULL, 63311),
(63312, '2.60.40.10-FF-004357', NULL, NULL, 106, NULL, NULL, 63312),
(63313, '3.80.10.10-FF-004301', NULL, 'NACHT, LRR and PYD domains-containing protein 15', 224, NULL, NULL, 63313),
(63314, '2.60.40.10-FF-004683', NULL, NULL, 87, NULL, NULL, 63314),
(63315, '1.10.510.10-FF-004359', NULL, NULL, 112, NULL, NULL, 63315),
(63316, '3.40.1090.10-FF-000096', NULL, 'Lysophospholipase', 473, NULL, NULL, 63316),
(63317, '1.10.238.10-FF-001207', NULL, 'Uncharacterized protein', 73, NULL, NULL, 63317),
(63318, '3.30.40.10-FF-000820', NULL, 'TRIM49 isoform 1', 83, NULL, NULL, 63318),
(63319, '2.40.10.10-FF-000596', NULL, NULL, 18, NULL, NULL, 63319),
(63320, '3.40.50.150-FF-000592', NULL, 'Mediator of RNA polymerase II transcription subunit 36a', 52, NULL, NULL, 63320),
(63321, '3.50.50.60-FF-001459', NULL, 'Predicted protein', 75, NULL, NULL, 63321),
(63322, '3.30.1490.100-FF-000001', NULL, 'DNA repair protein REV1', 123, NULL, NULL, 63322),
(63323, '2.170.270.10-FF-000218', NULL, 'Histone-lysine N-methyltransferase', 118, NULL, NULL, 63323),
(63324, '1.20.1250.20-FF-002080', NULL, 'Uncharacterized protein', 271, NULL, NULL, 63324),
(63325, '1.25.40.10-FF-002951', NULL, 'Predicted protein', 239, NULL, NULL, 63325),
(63326, '3.90.480.10-FF-000008', NULL, 'Anaerobic sulfite reductase, subunit C', 82, NULL, NULL, 63326),
(63327, '1.25.40.10-FF-001523', NULL, 'Clustered mitochondria protein homolog', 119, NULL, NULL, 63327),
(63328, '1.20.1560.10-FF-000323', NULL, 'ABC transporter ATP-binding protein', 313, NULL, NULL, 63328),
(63329, '3.40.850.10-FF-000520', NULL, 'Uncharacterized protein', 113, NULL, NULL, 63329),
(63330, '3.30.200.20-FF-000128', NULL, 'Serine/threonine-protein kinase ksg1', 92, NULL, NULL, 63330),
(63331, '2.60.120.650-FF-000124', NULL, 'YALI0F28105p', 238, NULL, NULL, 63331),
(63332, '3.90.70.10-FF-000746', NULL, 'Clan CA, family C1, cathepsin F-like cysteine peptidase', 133, NULL, NULL, 63332),
(63333, '2.60.40.150-FF-000465', NULL, 'PDZ/DHR/GLGF domaincontaining protein', 98, NULL, NULL, 63333),
(63334, '3.40.1410.10-FF-000020', NULL, 'Chorismate pyruvate-lyase', 161, NULL, NULL, 63334),
(63335, '2.160.20.10-FF-000293', NULL, 'Cell surface protein', 173, NULL, NULL, 63335),
(63336, '3.20.140.10-FF-000032', NULL, 'Nicotinate phosphoribosyltransferase', 164, NULL, NULL, 63336),
(63337, '1.10.150.170-FF-000015', NULL, NULL, 124, NULL, NULL, 63337),
(63338, '1.20.1070.10-FF-000741', NULL, 'Vomeronasal type-1 receptor', 271, NULL, NULL, 63338),
(63339, '1.10.1580.10-FF-000012', NULL, 'Nucleolar GTP-binding protein 2', 96, NULL, NULL, 63339),
(63340, '2.60.120.260-FF-000423', NULL, 'Lipase/acylhydrolase, GDSL family', 114, NULL, NULL, 63340),
(63341, '3.30.70.141-FF-000040', NULL, NULL, 183, NULL, NULL, 63341),
(63342, '1.10.150.20-FF-000164', NULL, 'DNA ligase', 81, NULL, NULL, 63342),
(63343, '3.30.230.10-FF-000306', NULL, 'U5 snRNP GTPase', 177, NULL, NULL, 63343),
(63344, '3.30.750.24-FF-000106', NULL, 'Anti-sigma factor antagonist', 107, NULL, NULL, 63344),
(63345, '3.30.200.20-FF-000807', NULL, 'Serine/threonine-protein kinase UCNL', 90, NULL, NULL, 63345),
(63346, '1.25.40.20-FF-001526', NULL, 'Kinase, NEK', 103, NULL, NULL, 63346);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(63347, '3.10.100.10-FF-000105', NULL, 'Lectin', 136, NULL, NULL, 63347),
(63348, '1.25.40.10-FF-000860', NULL, 'Putative Heat shock protein STI', 144, NULL, NULL, 63348),
(63349, '2.60.40.2810-FF-000002', NULL, 'Uncharacterized protein', 88, NULL, NULL, 63349),
(63350, '1.10.1660.10-FF-000013', NULL, 'First ORF in transposon ISC1904', 55, NULL, NULL, 63350),
(63351, '2.60.40.10-FF-002912', NULL, 'Uncharacterized protein', 79, NULL, NULL, 63351),
(63352, '3.40.50.80-FF-000184', NULL, 'Frp1p', 177, NULL, NULL, 63352),
(63353, '3.10.129.10-FF-000008', NULL, 'Acyl-CoA thioester hydrolase', 136, NULL, NULL, 63353),
(63354, '2.60.120.200-FF-000192', NULL, 'Crumbs, isoform D', 195, NULL, NULL, 63354),
(63355, '1.20.1050.10-FF-000206', NULL, 'YALI0E03432p', 114, NULL, NULL, 63355),
(63356, '3.40.190.10-FF-000519', NULL, 'Transferrin-a', 70, NULL, NULL, 63356),
(63357, '1.10.10.60-FF-000288', NULL, 'Sex combs reduced', 87, NULL, NULL, 63357),
(63358, '4.10.1000.10-FF-000012', NULL, 'cleavage and polyadenylation specificity factor subunit 4', 59, NULL, NULL, 63358),
(63359, '3.30.160.60-FF-000737', NULL, 'Zinc finger protein 565', 32, NULL, NULL, 63359),
(63360, '3.30.1520.10-FF-000154', NULL, 'Sorting nexin 1', 109, NULL, NULL, 63360),
(63361, '3.30.40.10-FF-002265', NULL, 'Putative postmeiotic segregation increased 2-like protein 11', 55, NULL, NULL, 63361),
(63362, '2.60.40.4060-FF-000012', NULL, 'Uncharacterized protein', 117, NULL, NULL, 63362),
(63363, '3.40.50.720-FF-000223', NULL, 'Chlorophyll(Ide) b reductase NOL, chloroplastic', 254, NULL, NULL, 63363),
(63364, '1.10.472.10-FF-000690', NULL, 'Uncharacterized protein', 77, NULL, NULL, 63364),
(63365, '3.30.1300.30-FF-000003', NULL, 'General secretion pathway protein I', 88, NULL, NULL, 63365),
(63366, '1.10.287.4280-FF-000001', NULL, 'transcription factor COE1 isoform X2', 67, NULL, NULL, 63366),
(63367, '3.30.465.10-FF-000104', NULL, 'FAD linked oxidase domain protein', 211, NULL, NULL, 63367),
(63368, '1.10.1390.10-FF-000003', NULL, 'Glucose-6-phosphate isomerase', 44, NULL, NULL, 63368),
(63369, '3.30.830.10-FF-000156', NULL, 'Insulinase family metalloprotease', 207, NULL, NULL, 63369),
(63370, '1.25.40.180-FF-000260', NULL, NULL, 239, NULL, NULL, 63370),
(63371, '3.40.50.620-FF-000491', NULL, 'Glutamine--tRNA ligase', 35, NULL, NULL, 63371),
(63372, '1.10.1520.10-FF-000003', NULL, 'Drosha ribonuclease III', 146, NULL, NULL, 63372),
(63373, '3.40.50.300-FF-005504', NULL, 'Uncharacterized protein', 296, NULL, NULL, 63373),
(63374, '2.30.30.790-FF-000015', NULL, 'Uncharacterized protein', 140, NULL, NULL, 63374),
(63375, '1.20.120.610-FF-000021', NULL, 'Predicted protein', 53, NULL, NULL, 63375),
(63376, '3.80.10.10-FF-000406', NULL, 'Leucine-rich repeat (LRR) family protein', 158, NULL, NULL, 63376),
(63377, '1.20.120.350-FF-000100', NULL, 'Voltage-gated Ion Channel (VIC) Superfamily', 115, NULL, NULL, 63377),
(63378, '2.10.25.10-FF-000069', NULL, 'Laminin subunit alpha 1', 108, NULL, NULL, 63378),
(63379, '2.70.70.10-FF-000036', NULL, 'Membrane-bound metallopeptidase', 136, NULL, NULL, 63379),
(63380, '2.30.30.490-FF-000015', NULL, 'Chromatin structure-remodeling complex subunit RSC1', 219, NULL, NULL, 63380),
(63381, '2.70.170.10-FF-000167', NULL, 'Uncharacterized protein', 89, NULL, NULL, 63381),
(63382, '1.10.510.10-FF-002914', NULL, NULL, 108, NULL, NULL, 63382),
(63383, '1.20.120.310-FF-000021', NULL, NULL, 77, NULL, NULL, 63383),
(63384, '1.20.120.720-FF-000054', NULL, 'Uncharacterized protein', 164, NULL, NULL, 63384),
(63385, '4.10.830.40-FF-000002', NULL, 'probable E3 ubiquitin-protein ligase MID2', 68, NULL, NULL, 63385),
(63386, '1.20.91.20-FF-000013', NULL, 'Uncharacterized protein', 82, NULL, NULL, 63386),
(63387, '3.40.50.300-FF-002924', NULL, 'ABC transporter ATP-binding protein', 229, NULL, NULL, 63387),
(63388, '1.25.40.10-FF-000708', NULL, 'Peptidylprolyl isomerase', 129, NULL, NULL, 63388),
(63389, '2.40.50.100-FF-000165', NULL, 'Efflux pump, RND family, membrane fusion lipoprotein', 72, NULL, NULL, 63389),
(63390, '3.30.200.20-FF-000454', NULL, 'Leucine-rich repeat receptor-like tyrosine-protein kinase PXC3', 109, NULL, NULL, 63390);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(63391, '2.130.10.10-FF-004661', NULL, 'Uncharacterized protein', 188, NULL, NULL, 63391),
(63392, '1.20.58.760-FF-000050', NULL, 'Uncharacterized protein', 78, NULL, NULL, 63392),
(63393, '1.10.418.30-FF-000002', NULL, 'NDC80, kinetochore complex component', 118, NULL, NULL, 63393),
(63394, '2.60.260.20-FF-000168', NULL, 'Chaperone protein DnaJ', 115, NULL, NULL, 63394),
(63395, '3.30.390.110-FF-000005', NULL, '60S ribosomal protein L28', 126, NULL, NULL, 63395),
(63396, '3.30.420.40-FF-000976', NULL, 'Protein CBG02160', 137, NULL, NULL, 63396),
(63397, '2.130.10.10-FF-005150', NULL, 'Uncharacterized protein', 143, NULL, NULL, 63397),
(63398, '3.60.20.10-FF-000014', NULL, 'Proteasome subunit beta type-7', 225, NULL, NULL, 63398),
(63399, '3.30.70.330-FF-000674', NULL, 'RNA-binding protein, putative', 107, NULL, NULL, 63399),
(63400, '1.25.10.10-FF-001016', NULL, 'Importin subunit alpha', 398, NULL, NULL, 63400),
(63401, '1.25.40.10-FF-004749', NULL, 'Uncharacterized protein', 66, NULL, NULL, 63401),
(63402, '3.40.630.10-FF-000037', NULL, 'Peptidase B', 330, NULL, NULL, 63402),
(63403, '2.60.40.10-FF-003901', NULL, NULL, 108, NULL, NULL, 63403),
(63404, '3.30.50.10-FF-000113', NULL, 'LD32549p', 71, NULL, NULL, 63404),
(63405, '6.10.140.2220-FF-000017', NULL, 'Histone-lysine N-methyltransferase SMYD3', 49, NULL, NULL, 63405),
(63406, '2.130.10.10-FF-000299', NULL, 'NACHT and WD repeat domain containing 2', 252, NULL, NULL, 63406),
(63407, '2.40.50.140-FF-000862', NULL, NULL, 72, NULL, NULL, 63407),
(63408, '3.30.200.20-FF-002545', NULL, 'Serine/threonine-protein kinase ppk31', 11, NULL, NULL, 63408),
(63409, '1.20.1250.20-FF-000342', NULL, 'Major facilitator superfamily domain-containing 8', 416, NULL, NULL, 63409),
(63410, '3.30.428.10-FF-000018', NULL, 'Zinc finger CCCH domain-containing protein 59', 124, NULL, NULL, 63410),
(63411, '2.60.40.60-FF-000196', NULL, 'Si:dkey-22o22.2', 100, NULL, NULL, 63411),
(63412, '3.10.100.10-FF-000431', NULL, NULL, 81, NULL, NULL, 63412),
(63413, '2.20.70.10-FF-000089', NULL, 'Blast:WW domain-containing adapter protein with coiled-coil', 68, NULL, NULL, 63413),
(63414, '3.90.550.10-FF-000396', NULL, 'Glycosyltransferase', 255, NULL, NULL, 63414),
(63415, '3.40.50.300-FF-004195', NULL, 'Midasin', 163, NULL, NULL, 63415),
(63416, '3.30.497.10-FF-000094', NULL, 'Serpin 7', 192, NULL, NULL, 63416),
(63417, '3.30.70.360-FF-000071', NULL, 'D-alanine--D-alanine ligase', 108, NULL, NULL, 63417),
(63418, '3.30.70.330-FF-001776', NULL, NULL, 171, NULL, NULL, 63418),
(63419, '1.10.418.40-FF-000005', NULL, 'Autophagy protein Apg6, putative', 206, NULL, NULL, 63419),
(63420, '1.25.10.10-FF-000706', NULL, 'Proteasome (Prosome, macropain) 26S subunit, non-ATPase, 5', 260, NULL, NULL, 63420),
(63421, '1.10.472.10-FF-000425', NULL, 'Putative cyclin-A3-1', 69, NULL, NULL, 63421),
(63422, '3.40.50.300-FF-000979', NULL, 'Ribose 1,5-bisphosphate phosphokinase PhnN', 183, NULL, NULL, 63422),
(63423, '3.30.200.20-FF-001909', NULL, 'Uncharacterized protein', 146, NULL, NULL, 63423),
(63424, '3.10.20.80-FF-000009', NULL, 'Translation initiation factor 3 (IF-3) family protein', 77, NULL, NULL, 63424),
(63425, '3.40.50.300-FF-006965', NULL, 'Uncharacterized protein racV', 221, NULL, NULL, 63425),
(63426, '1.10.245.10-FF-000010', NULL, 'MDM4 isoform 5', 46, NULL, NULL, 63426),
(63427, '3.40.50.720-FF-002314', NULL, 'Uncharacterized protein', 130, NULL, NULL, 63427),
(63428, '1.20.1250.20-FF-001944', NULL, 'Uncharacterized protein', 452, NULL, NULL, 63428),
(63429, '3.40.50.2000-FF-000325', NULL, 'Digalactosyldiacylglycerol synthase 1, chloroplastic', 159, NULL, NULL, 63429),
(63430, '3.30.70.330-FF-000056', NULL, 'epithelial splicing regulatory protein 1 isoform X1', 114, NULL, NULL, 63430),
(63431, '2.70.150.10-FF-000284', NULL, 'Phospholipid-transporting ATPase', 136, NULL, NULL, 63431),
(63432, '3.90.70.80-FF-000014', NULL, 'Cysteine proteinases superfamily protein', 159, NULL, NULL, 63432),
(63433, '3.10.20.70-FF-000006', NULL, 'Glutamine synthetase', 105, NULL, NULL, 63433);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(63434, '3.90.550.10-FF-000716', NULL, 'Putative transferase', 264, NULL, NULL, 63434),
(63435, '3.30.413.10-FF-000024', NULL, 'Nitrite reductase', 103, NULL, NULL, 63435),
(63436, '3.40.50.300-FF-006286', NULL, 'Elongation factor G, mitochondrial', 270, NULL, NULL, 63436),
(63437, '1.10.3630.10-FF-000006', NULL, 'Golgi phosphoprotein 3-like', 146, NULL, NULL, 63437),
(63438, '3.30.710.10-FF-000416', NULL, 'Ankyrin repeat containing protein', 128, NULL, NULL, 63438),
(63439, '1.10.238.10-FF-001180', NULL, 'Uncharacterized protein', 89, NULL, NULL, 63439),
(63440, '2.60.120.430-FF-000030', NULL, 'Di-glucose binding protein with Kinesin motor domain-containing protein', 143, NULL, NULL, 63440),
(63441, '2.10.25.10-FF-000541', NULL, 'Notch homolog 4, [Drosophila]', 38, NULL, NULL, 63441),
(63442, '1.10.510.10-FF-001133', NULL, 'Uncharacterized protein', 352, NULL, NULL, 63442),
(63443, '3.30.420.40-FF-000297', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', 146, NULL, NULL, 63443),
(63444, '1.20.1070.10-FF-000241', NULL, 'Hydroxycarboxylic acid receptor 1', 297, NULL, NULL, 63444),
(63445, '1.20.1250.20-FF-002107', NULL, 'Uncharacterized protein', 237, NULL, NULL, 63445),
(63446, '1.25.40.10-FF-003440', NULL, 'Pentatricopeptide repeat-containing protein At5g12100, mitochondrial', 158, NULL, NULL, 63446),
(63447, '1.10.510.10-FF-000644', NULL, 'Poly(A) specific ribonuclease subunit PAN3', 185, NULL, NULL, 63447),
(63448, '1.20.200.10-FF-000017', NULL, 'argininosuccinate lyase isoform X2', 143, NULL, NULL, 63448),
(63449, '3.30.60.30-FF-000182', NULL, 'Kazal type serine peptidase inhibitor domain 1', 43, NULL, NULL, 63449),
(63450, '3.30.160.60-FF-003351', NULL, 'Regulator of sex limited protein 1', 24, NULL, NULL, 63450),
(63451, '3.40.50.300-FF-002896', NULL, 'ras-related protein RABA2a-like', 187, NULL, NULL, 63451),
(63452, '3.40.1090.10-FF-000157', NULL, 'Uncharacterized protein', 119, NULL, NULL, 63452),
(63453, '1.20.920.20-FF-000029', NULL, 'Dynein heavy chain, putative', 357, NULL, NULL, 63453),
(63454, '3.40.220.10-FF-000017', NULL, 'ORF1a polyprotein', 167, NULL, NULL, 63454),
(63455, '3.40.50.150-FF-000945', NULL, NULL, 191, NULL, NULL, 63455),
(63456, '3.20.20.140-FF-000469', NULL, 'Uncharacterized protein', 351, NULL, NULL, 63456),
(63457, '2.130.10.10-FF-000945', NULL, 'Protein transport protein SEC31', 331, NULL, NULL, 63457),
(63458, '2.10.25.140-FF-000006', NULL, 'Delta-like protein', 46, NULL, NULL, 63458),
(63459, '3.40.640.10-FF-000448', NULL, 'Alanine aminotransferase, putative', 50, NULL, NULL, 63459),
(63460, '1.20.1560.10-FF-000262', NULL, 'Multidrug resistance protein pgp-1', 19, NULL, NULL, 63460),
(63461, '3.40.50.300-FF-000041', NULL, 'Guanine nucleotide-binding protein G(I) subunit alpha', 190, NULL, NULL, 63461),
(63462, '2.60.120.20-FF-000012', NULL, 'Genome polyprotein', 212, NULL, NULL, 63462),
(63463, '1.10.3520.10-FF-000003', NULL, 'glycolipid transfer protein', 185, NULL, NULL, 63463),
(63464, '1.10.238.10-FF-001000', NULL, 'Uncharacterized protein', 83, NULL, NULL, 63464),
(63465, '2.60.120.10-FF-000301', NULL, 'cGMP-dependent protein kinase 2', 136, NULL, NULL, 63465),
(63466, '3.40.30.10-FF-000999', NULL, 'Uncharacterized protein', 75, NULL, NULL, 63466),
(63467, '2.60.40.10-FF-002766', NULL, 'AGAP002708-PB', 94, NULL, NULL, 63467),
(63468, '3.40.50.2000-FF-000297', NULL, 'G protein-coupled receptor', 67, NULL, NULL, 63468),
(63469, '3.40.50.720-FF-000077', NULL, 'L-threonine 3-dehydrogenase, mitochondrial', 323, NULL, NULL, 63469),
(63470, '1.10.238.10-FF-000718', NULL, 'Cta3p', 115, NULL, NULL, 63470),
(63471, '2.60.40.10-FF-001305', NULL, 'Cell adhesion molecule-related/down-regulated by oncogenes', 95, NULL, NULL, 63471),
(63472, '3.40.50.620-FF-000811', NULL, 'Uncharacterized protein', 210, NULL, NULL, 63472),
(63473, '3.40.50.300-FF-001322', NULL, 'Schlafen family member 11', 125, NULL, NULL, 63473),
(63474, '3.40.630.30-FF-000369', NULL, 'AGAP006447-PA', 200, NULL, NULL, 63474),
(63475, '3.80.10.10-FF-001188', NULL, 'F-box/LRR-repeat protein 15 isoform A', 77, NULL, NULL, 63475);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(63476, '3.30.70.920-FF-000019', NULL, 'Transcriptional regulatory protein, asnC family', 74, NULL, NULL, 63476),
(63477, '3.90.70.10-FF-000685', NULL, 'Uncharacterized protein', 242, NULL, NULL, 63477),
(63478, '3.90.70.200-FF-000026', NULL, 'Uncharacterized protein', 86, NULL, NULL, 63478),
(63479, '3.30.310.80-FF-000047', NULL, 'Non-specific serine/threonine protein kinase', 96, NULL, NULL, 63479),
(63480, '3.90.70.10-FF-000393', NULL, 'Ubiquitin carboxyl-terminal hydrolase, putative', 202, NULL, NULL, 63480),
(63481, '1.10.8.10-FF-000014', NULL, 'Non-specific serine/threonine protein kinase', 60, NULL, NULL, 63481),
(63482, '3.40.630.10-FF-000363', NULL, 'Glutamate carboxypeptidase, putative', 134, NULL, NULL, 63482),
(63483, '3.30.9.30-FF-000001', NULL, 'Probable FAD-dependent monooxygenase', 197, NULL, NULL, 63483),
(63484, '1.20.1070.10-FF-002040', NULL, 'Uncharacterized protein', 115, NULL, NULL, 63484),
(63485, '3.20.20.300-FF-000039', NULL, 'Putative beta-glucosidase', 318, NULL, NULL, 63485),
(63486, '3.40.50.300-FF-006639', NULL, 'Predicted protein', 90, NULL, NULL, 63486),
(63487, '1.25.40.10-FF-000388', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 218, NULL, NULL, 63487),
(63488, '1.10.196.10-FF-000002', NULL, 'Axin 1', 35, NULL, NULL, 63488),
(63489, '2.170.140.10-FF-000006', NULL, 'Mucin related 89F, isoform B', 70, NULL, NULL, 63489),
(63490, '1.25.10.10-FF-000886', NULL, 'HEAT repeat protein', 381, NULL, NULL, 63490),
(63491, '3.80.10.10-FF-004240', NULL, 'Uncharacterized protein', 261, NULL, NULL, 63491),
(63492, '3.30.450.20-FF-000500', NULL, 'PleD-like-protein', 120, NULL, NULL, 63492),
(63493, '1.10.472.130-FF-000094', NULL, 'Uncharacterized protein', 150, NULL, NULL, 63493),
(63494, '2.20.100.10-FF-000213', NULL, 'Thrombospondin type-1 domain-containing protein 7B', 49, NULL, NULL, 63494),
(63495, '2.30.30.30-FF-000160', NULL, 'SPT5 homolog, DSIF elongation factor subunit', 36, NULL, NULL, 63495),
(63496, '3.40.50.11260-FF-000005', NULL, 'Heat shock protein 90', 87, NULL, NULL, 63496),
(63497, '1.25.40.10-FF-004542', NULL, 'Uncharacterized protein', 231, NULL, NULL, 63497),
(63498, '1.10.510.10-FF-002768', NULL, NULL, 118, NULL, NULL, 63498),
(63499, '1.10.510.10-FF-001633', NULL, 'CAMK family protein kinase', 289, NULL, NULL, 63499),
(63500, '3.30.160.60-FF-004778', NULL, NULL, 30, NULL, NULL, 63500),
(63501, '2.60.40.420-FF-000243', NULL, 'Uncharacterized protein', 57, NULL, NULL, 63501),
(63502, '3.80.10.10-FF-000086', NULL, 'F-box/LRR-repeat protein 5 isoform X1', 91, NULL, NULL, 63502),
(63503, '3.40.50.1700-FF-000010', NULL, 'Glycoside hydrolase, putative', 246, NULL, NULL, 63503),
(63504, '3.40.190.10-FF-000492', NULL, 'Transcriptional regulator, LysR family', 83, NULL, NULL, 63504),
(63505, '3.40.50.2000-FF-000651', NULL, 'UDP-glucuronosyltransferase', 250, NULL, NULL, 63505),
(63506, '2.60.40.10-FF-000288', NULL, 'target of Nesh-SH3 isoform X5', 103, NULL, NULL, 63506),
(63507, '2.10.25.10-FF-001497', NULL, 'Faulty attraction, isoform F', 34, NULL, NULL, 63507),
(63508, '3.30.505.10-FF-000159', NULL, NULL, 140, NULL, NULL, 63508),
(63509, '1.20.1250.20-FF-001444', NULL, 'MFS multidrug transporter, putative (AFU_orthologue AFUA_3G14560)', 80, NULL, NULL, 63509),
(63510, '3.40.50.300-FF-003121', NULL, 'Polyphosphate:AMP phosphotransferase', 258, NULL, NULL, 63510),
(63511, '1.20.58.60-FF-000235', NULL, 'Spectrin repeat containing nuclear envelope protein 1', 290, NULL, NULL, 63511),
(63512, '2.60.40.60-FF-000696', NULL, 'Cadherin-4', 103, NULL, NULL, 63512),
(63513, '2.40.30.10-FF-000187', NULL, 'Translation factor GUF1 homolog, mitochondrial', 84, NULL, NULL, 63513),
(63514, '3.30.70.330-FF-000702', NULL, 'Putative RNA-binding protein', 90, NULL, NULL, 63514),
(63515, '2.40.50.140-FF-000536', NULL, 'Lysine--tRNA ligase', 73, NULL, NULL, 63515),
(63516, '2.40.50.90-FF-000021', NULL, 'putative ATP-dependent RNA helicase TDRD12', 125, NULL, NULL, 63516),
(63517, '1.20.120.330-FF-000027', NULL, 'Tyrosine-protein kinase', 113, NULL, NULL, 63517);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(63518, '2.10.25.10-FF-000215', NULL, 'Integrin beta', 39, NULL, NULL, 63518),
(63519, '3.30.1360.40-FF-000015', NULL, 'Ribosome-recycling factor', 77, NULL, NULL, 63519),
(63520, '1.20.58.1610-FF-000022', NULL, NULL, 117, NULL, NULL, 63520),
(63521, '2.30.42.10-FF-000136', NULL, 'Caspase recruitment domain family member 11', 104, NULL, NULL, 63521),
(63522, '1.10.10.60-FF-000934', NULL, NULL, 69, NULL, NULL, 63522),
(63523, '3.40.50.150-FF-000799', NULL, NULL, 104, NULL, NULL, 63523),
(63524, '3.40.50.1820-FF-001389', NULL, 'FAM172 family protein homolog Y75B8A.31', 218, NULL, NULL, 63524),
(63525, '2.60.40.150-FF-000639', NULL, 'Meiotically up-regulated gene 190 protein', 171, NULL, NULL, 63525),
(63526, '1.25.10.10-FF-003320', NULL, 'Serine/threonine-protein kinase TOR', 453, NULL, NULL, 63526),
(63527, '3.30.500.40-FF-000005', NULL, 'A kinase anchor protein', 153, NULL, NULL, 63527),
(63528, '3.40.50.300-FF-001143', NULL, 'Dynein axonemal heavy chain 6', 254, NULL, NULL, 63528),
(63529, '1.10.10.10-FF-000408', NULL, 'AsnC family transcriptional regulator', 52, NULL, NULL, 63529),
(63530, '1.20.1250.20-FF-000842', NULL, 'Putative efflux transporter', 193, NULL, NULL, 63530),
(63531, '3.30.54.20-FF-000001', NULL, 'Alanine--tRNA ligase', 54, NULL, NULL, 63531),
(63532, '3.40.50.80-FF-000212', NULL, 'Uncharacterized protein', 110, NULL, NULL, 63532),
(63533, '3.90.70.10-FF-000067', NULL, 'Senescence-specific cysteine protease', 324, NULL, NULL, 63533),
(63534, '3.40.50.10190-FF-000206', NULL, 'DNA polymerase', 102, NULL, NULL, 63534),
(63535, '1.10.150.50-FF-000240', NULL, 'Predicted protein', 61, NULL, NULL, 63535),
(63536, '1.10.238.10-FF-000483', NULL, 'Probable calcium-binding protein CML9', 83, NULL, NULL, 63536),
(63537, '3.40.850.10-FF-000492', NULL, 'Kinesin-like protein', 62, NULL, NULL, 63537),
(63538, '3.40.50.620-FF-000165', NULL, 'Phosphoadenosine phosphosulfate reductase', 242, NULL, NULL, 63538),
(63539, '3.80.10.10-FF-003958', NULL, 'Uncharacterized protein', 214, NULL, NULL, 63539),
(63540, '2.40.30.10-FF-000479', NULL, 'Uncharacterized protein', 45, NULL, NULL, 63540),
(63541, '2.60.40.1170-FF-000038', NULL, 'AP-4 complex subunit mu,putative', 115, NULL, NULL, 63541),
(63542, '1.20.1070.10-FF-001197', NULL, 'Uncharacterized protein', 144, NULL, NULL, 63542),
(63543, '1.25.40.10-FF-004396', NULL, 'TPR repeat protein', 139, NULL, NULL, 63543),
(63544, '3.40.640.10-FF-000420', NULL, 'Serine hydroxymethyltransferase, mitochondrial', 39, NULL, NULL, 63544),
(63545, '1.25.10.10-FF-001403', NULL, 'ARM repeat superfamily protein', 192, NULL, NULL, 63545),
(63546, '3.60.21.10-FF-000298', NULL, 'Serine/threonine-protein phosphatase', 143, NULL, NULL, 63546),
(63547, '1.10.620.20-FF-000037', NULL, 'Uncharacterized protein', 178, NULL, NULL, 63547),
(63548, '2.30.30.10-FF-000002', NULL, 'Endogenous retrovirus group K member 6 Pol protein', 55, NULL, NULL, 63548),
(63549, '1.10.510.10-FF-000970', NULL, 'Discs overgrown, isoform D', 344, NULL, NULL, 63549),
(63550, '3.30.230.70-FF-000156', NULL, 'Exosome complex exonuclease RRP46-like protein', 69, NULL, NULL, 63550),
(63551, '3.40.50.300-FF-005330', NULL, 'ATPases and helicase subunits involved in DNA replication', 148, NULL, NULL, 63551),
(63552, '3.30.40.10-FF-000141', NULL, 'Ubiquitinyl hydrolase 1', 121, NULL, NULL, 63552),
(63553, '1.10.418.10-FF-000137', NULL, 'PLS3 isoform 7', 97, NULL, NULL, 63553),
(63554, '3.20.20.80-FF-000166', NULL, 'Exo-beta-D-glucosaminidase', 338, NULL, NULL, 63554),
(63555, '3.50.50.60-FF-000296', NULL, 'Salicylate hydroxylase, putative', 380, NULL, NULL, 63555),
(63556, '3.30.450.70-FF-000021', NULL, 'YEL048C-like protein', 152, NULL, NULL, 63556),
(63557, '1.20.1280.50-FF-000179', NULL, 'F-box-like, putative', 90, NULL, NULL, 63557),
(63558, '2.30.130.40-FF-000031', NULL, 'Lon protease homolog', 128, NULL, NULL, 63558),
(63559, '3.30.70.330-FF-002473', NULL, NULL, 154, NULL, NULL, 63559),
(63560, '2.60.200.40-FF-000024', NULL, 'Sphingosine kinase A', 215, NULL, NULL, 63560),
(63561, '2.100.10.50-FF-000003', NULL, 'Multivesicular body subunit 12A', 146, NULL, NULL, 63561);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(63562, '1.20.1070.10-FF-000095', NULL, 'G-protein coupled receptor 26', 329, NULL, NULL, 63562),
(63563, '3.60.160.10-FF-000002', NULL, 'BnaA02g25390D protein', 238, NULL, NULL, 63563),
(63564, '3.10.20.90-FF-000956', NULL, 'Uncharacterized protein', 60, NULL, NULL, 63564),
(63565, '3.40.1640.10-FF-000003', NULL, 'Uncharacterized protein', 74, NULL, NULL, 63565),
(63566, '1.20.1050.10-FF-000032', NULL, 'Eukaryotic translation elongation factor 1 epsilon-1', 107, NULL, NULL, 63566),
(63567, '3.40.50.1820-FF-000900', NULL, 'Yolk polypeptide 2, putative', 124, NULL, NULL, 63567),
(63568, '3.30.200.20-FF-000746', NULL, 'Cyclin-dependent kinase-like 5', 64, NULL, NULL, 63568),
(63569, '1.10.3380.30-FF-000037', NULL, 'Uncharacterized protein', 138, NULL, NULL, 63569),
(63570, '3.30.230.10-FF-000245', NULL, 'Uncharacterized protein', 168, NULL, NULL, 63570),
(63571, '1.25.40.420-FF-000023', NULL, 'BTB-POZ and math domain 1', 76, NULL, NULL, 63571),
(63572, '1.10.3130.10-FF-000013', NULL, 'Serine acetyltransferase', 144, NULL, NULL, 63572),
(63573, '3.30.160.60-FF-003025', NULL, NULL, 30, NULL, NULL, 63573),
(63574, '1.20.1110.10-FF-000003', NULL, 'Calcium-transporting ATPase', 407, NULL, NULL, 63574),
(63575, '3.60.40.10-FF-000162', NULL, 'Protein serine/threonine phosphatase 2C', 312, NULL, NULL, 63575),
(63576, '1.20.1540.10-FF-000053', NULL, 'Rhomboid family protein', 199, NULL, NULL, 63576),
(63577, '2.130.10.10-FF-002098', NULL, 'MGC78960 protein, putative', 305, NULL, NULL, 63577),
(63578, '3.40.50.1440-FF-000056', NULL, 'Tubulin beta chain', 85, NULL, NULL, 63578),
(63579, '3.30.470.20-FF-000029', NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', 188, NULL, NULL, 63579),
(63580, '3.40.50.2300-FF-001106', NULL, 'Extracellular calcium-sensing receptor', 277, NULL, NULL, 63580),
(63581, '1.20.5.190-FF-000093', NULL, 'Abnormal spindle microtubule assembly', 51, NULL, NULL, 63581),
(63582, '3.40.50.300-FF-004841', NULL, 'Replication factor C subunit 2', 163, NULL, NULL, 63582),
(63583, '3.80.10.10-FF-000232', NULL, 'Si:dkey-16p6.1', 104, NULL, NULL, 63583),
(63584, '3.30.530.20-FF-000147', NULL, 'Uncharacterized protein', 197, NULL, NULL, 63584),
(63585, '3.30.559.10-FF-000081', NULL, 'Aspergillus niger contig An11c0010, genomic contig', 198, NULL, NULL, 63585),
(63586, '3.30.450.20-FF-000146', NULL, 'PAS domain S-box protein', 117, NULL, NULL, 63586),
(63587, '3.50.7.10-FF-000093', NULL, NULL, 96, NULL, NULL, 63587),
(63588, '3.10.110.10-FF-000342', NULL, 'Ubiquitin-conjugating enzyme family protein', 152, NULL, NULL, 63588),
(63589, '1.25.40.430-FF-000026', NULL, 'Uncharacterized protein', 144, NULL, NULL, 63589),
(63590, '3.30.70.1590-FF-000002', NULL, 'unconventional myosin-VI isoform X1', 66, NULL, NULL, 63590),
(63591, '3.20.20.100-FF-000131', NULL, 'NADP(+) coupled glycerol dehydrogenase (Eurofung)', 129, NULL, NULL, 63591),
(63592, '2.130.10.10-FF-004835', NULL, 'Uncharacterized protein', 322, NULL, NULL, 63592),
(63593, '2.60.40.10-FF-004711', NULL, NULL, 87, NULL, NULL, 63593),
(63594, '1.25.40.10-FF-003114', NULL, 'Uncharacterized protein', 141, NULL, NULL, 63594),
(63595, '1.20.58.2140-FF-000001', NULL, 'Haloacid dehalogenase', 191, NULL, NULL, 63595),
(63596, '2.120.10.80-FF-000354', NULL, 'Multiple EGF like domains 8', 302, NULL, NULL, 63596),
(63597, '3.50.50.60-FF-000650', NULL, 'Styrene monooxygenase StyA', 89, NULL, NULL, 63597),
(63598, '3.30.70.3030-FF-000018', NULL, 'Uncharacterized protein', 129, NULL, NULL, 63598),
(63599, '1.10.8.100-FF-000017', NULL, 'Probable ribosomal RNA small subunit methyltransferase A', 89, NULL, NULL, 63599),
(63600, '2.60.40.150-FF-000791', NULL, 'Predicted protein', 78, NULL, NULL, 63600),
(63601, '3.80.10.10-FF-003397', NULL, 'Uncharacterized protein', 96, NULL, NULL, 63601),
(63602, '3.40.50.2300-FF-000617', NULL, 'Sensor histidine kinase/response regulator', 120, NULL, NULL, 63602),
(63603, '2.60.40.10-FF-005200', NULL, NULL, 92, NULL, NULL, 63603),
(63604, '3.40.50.12230-FF-000015', NULL, 'YALI0F06820p', 323, NULL, NULL, 63604),
(63605, '2.40.70.10-FF-000307', NULL, NULL, 172, NULL, NULL, 63605);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(63606, '2.20.28.200-FF-000001', NULL, 'NAD-dependent protein deacetylase sirtuin-6', 56, NULL, NULL, 63606),
(63607, '1.25.40.10-FF-002625', NULL, 'Transcription Factor ThreeC subunit (GTF3C homolog)', 279, NULL, NULL, 63607),
(63608, '3.40.50.11660-FF-000035', NULL, NULL, 221, NULL, NULL, 63608),
(63609, '1.10.472.10-FF-000717', NULL, 'Uncharacterized protein', 199, NULL, NULL, 63609),
(63610, '1.20.1250.20-FF-000516', NULL, 'Alternative sulfate transporter', 197, NULL, NULL, 63610),
(63611, '2.20.70.10-FF-000117', NULL, 'Pre-mRNA-processing protein 40B', 53, NULL, NULL, 63611),
(63612, '1.20.1280.20-FF-000018', NULL, 'Chaperone protein DNAJ, putative', 85, NULL, NULL, 63612),
(63613, '2.130.10.10-FF-005324', NULL, 'Periodic tryptophan protein 2 homolog-related protein', 197, NULL, NULL, 63613),
(63614, '3.40.225.10-FF-000039', NULL, 'Putative hu li tai shao', 262, NULL, NULL, 63614),
(63615, '1.20.1560.10-FF-000823', NULL, 'AGAP001777-PA', 357, NULL, NULL, 63615),
(63616, '3.50.50.60-FF-000857', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 22, NULL, NULL, 63616),
(63617, '3.40.1390.30-FF-000001', NULL, 'GTP cyclohydrolase 1 type 2', 119, NULL, NULL, 63617),
(63618, '3.10.20.90-FF-000338', NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', 87, NULL, NULL, 63618),
(63619, '3.30.70.330-FF-000348', NULL, 'Peptidyl-prolyl cis-trans isomerase E', 130, NULL, NULL, 63619),
(63620, '3.30.710.10-FF-000181', NULL, 'Uncharacterized protein, isoform B', 164, NULL, NULL, 63620),
(63621, '3.40.190.10-FF-000166', NULL, 'Nitrate ABC transporter substrate-binding protein', 107, NULL, NULL, 63621),
(63622, '3.30.559.30-FF-000087', NULL, 'Nonribosomal peptide synthase, putative (JCVI)', 106, NULL, NULL, 63622),
(63623, '3.40.850.10-FF-000166', NULL, 'Kinesin family member 21B', 145, NULL, NULL, 63623),
(63624, '1.10.287.70-FF-000321', NULL, 'Voltage-dependent calcium channel subunit, putative', 131, NULL, NULL, 63624),
(63625, '1.25.40.20-FF-001852', NULL, 'Uncharacterized protein', 138, NULL, NULL, 63625),
(63626, '3.30.1010.10-FF-000037', NULL, 'MEC1p protein', 161, NULL, NULL, 63626),
(63627, '1.10.357.10-FF-000028', NULL, 'TetR family transcriptional regulator', 128, NULL, NULL, 63627),
(63628, '1.20.1250.20-FF-001770', NULL, 'Putative inorganic phosphate cotransporter-like Protein', 187, NULL, NULL, 63628),
(63629, '3.40.50.300-FF-002278', NULL, 'Ras like without CAAX 2', 79, NULL, NULL, 63629),
(63630, '1.20.900.10-FF-000110', NULL, 'GH01987p', 121, NULL, NULL, 63630),
(63631, '1.10.3460.10-FF-000032', NULL, 'Uncharacterized protein', 123, NULL, NULL, 63631),
(63632, '1.10.630.10-FF-000271', NULL, 'Cytochrome P450 monooxygenase PikC', 405, NULL, NULL, 63632),
(63633, '3.30.40.10-FF-000348', NULL, 'E3 ubiquitin-protein ligase', 68, NULL, NULL, 63633),
(63634, '3.40.50.2000-FF-000090', NULL, 'Starch synthase, chloroplastic/amyloplastic', 281, NULL, NULL, 63634),
(63635, '2.60.40.1360-FF-000005', NULL, 'Alpha-mannosidase', 130, NULL, NULL, 63635),
(63636, '3.40.50.150-FF-000619', NULL, 'Uncharacterized protein', 189, NULL, NULL, 63636),
(63637, '1.25.10.10-FF-002505', NULL, 'Uncharacterized protein', 201, NULL, NULL, 63637),
(63638, '1.20.80.10-FF-000013', NULL, 'Unconventional myosin-VIIa', 117, NULL, NULL, 63638),
(63639, '3.60.10.10-FF-000042', NULL, 'DNA-(apurinic or apyrimidinic site) lyase', 338, NULL, NULL, 63639),
(63640, '1.10.510.10-FF-002561', NULL, 'Predicted protein', 265, NULL, NULL, 63640),
(63641, '3.30.70.1050-FF-000014', NULL, 'Trigger factor', 115, NULL, NULL, 63641),
(63642, '1.10.510.10-FF-001307', NULL, 'Protein NSP-INTERACTING KINASE 2', 87, NULL, NULL, 63642),
(63643, '3.40.20.10-FF-000116', NULL, 'Coactosin like F-actin binding protein 1', 89, NULL, NULL, 63643),
(63644, '2.30.29.30-FF-000622', NULL, 'WGS project CABT00000000 data, contig 2.5', 187, NULL, NULL, 63644),
(63645, '1.10.437.10-FF-000001', NULL, 'Bcl-2-like protein 2', 183, NULL, NULL, 63645),
(63646, '3.40.50.460-FF-000010', NULL, 'ATP-dependent 6-phosphofructokinase', 110, NULL, NULL, 63646);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(63647, '1.10.3380.10-FF-000031', NULL, 'DNaJ domain (Prokaryotic heat shock protein)', 158, NULL, NULL, 63647),
(63648, '2.40.170.20-FF-000059', NULL, 'Ferric siderophore receptor protein', 593, NULL, NULL, 63648),
(63649, '1.10.730.10-FF-000155', NULL, 'Leucyl-tRNA synthetase (AFU_orthologue AFUA_6G04910)', 33, NULL, NULL, 63649),
(63650, '2.10.110.10-FF-000295', NULL, 'Uncharacterized protein', 69, NULL, NULL, 63650),
(63651, '3.40.50.1000-FF-000508', NULL, NULL, 119, NULL, NULL, 63651),
(63652, '3.40.50.720-FF-002022', NULL, 'Os10g0477900 protein', 205, NULL, NULL, 63652),
(63653, '3.40.50.1820-FF-000080', NULL, 'Alpha/beta hydrolase', 277, NULL, NULL, 63653),
(63654, '1.10.1040.10-FF-000073', NULL, 'Putative 3-hydroxyisobutyrate dehydrogenase', 128, NULL, NULL, 63654),
(63655, '1.10.510.10-FF-003050', NULL, NULL, 211, NULL, NULL, 63655),
(63656, '3.40.50.880-FF-000046', NULL, 'Protein/nucleic acid deglycase DJ-1', 189, NULL, NULL, 63656),
(63657, '2.10.25.10-FF-001558', NULL, 'Lrp1 protein', 42, NULL, NULL, 63657),
(63658, '1.10.510.10-FF-000762', NULL, 'Serine/threonine-protein kinase', 296, NULL, NULL, 63658),
(63659, '3.10.129.10-FF-000042', NULL, 'MaoC domain protein dehydratase', 141, NULL, NULL, 63659),
(63660, '1.20.1070.10-FF-000123', NULL, 'cadherin EGF LAG seven-pass G-type receptor 1 isoform X2', 280, NULL, NULL, 63660),
(63661, '1.20.1420.30-FF-000027', NULL, 'Vacuolar calcium ion transporter', 151, NULL, NULL, 63661),
(63662, '3.40.50.200-FF-000011', NULL, 'subtilisin-like protease SBT6.1', 295, NULL, NULL, 63662),
(63663, '3.40.50.1820-FF-000580', NULL, 'Carboxylic ester hydrolase', 534, NULL, NULL, 63663),
(63664, '3.90.180.10-FF-000030', NULL, 'Synaptic vesicle membrane protein VAT-1 homolog', 176, NULL, NULL, 63664),
(63665, '3.80.10.10-FF-004122', NULL, 'Uncharacterized protein', 114, NULL, NULL, 63665),
(63666, '1.10.8.500-FF-000014', NULL, 'Chemotaxis protein', 53, NULL, NULL, 63666),
(63667, '3.90.120.10-FF-000021', NULL, 'Cytosine-C5 specific DNA methyltransferase', 77, NULL, NULL, 63667),
(63668, '3.40.50.300-FF-002778', NULL, 'Pre-mRNA-processing ATP-dependent RNA helicase PRP5, putative', 258, NULL, NULL, 63668),
(63669, '3.30.1370.10-FF-000030', NULL, 'KH domain-containing, RNA-binding, signal transduction-associated protein 3 isoformX2', 185, NULL, NULL, 63669),
(63670, '3.30.1330.60-FF-000019', NULL, 'Outer membrane protein OmpA', 159, NULL, NULL, 63670),
(63671, '3.40.50.1400-FF-000010', NULL, 'Sirohydrochlorin cobaltochelatase', 128, NULL, NULL, 63671),
(63672, '2.60.40.790-FF-000157', NULL, NULL, 69, NULL, NULL, 63672),
(63673, '2.30.42.10-FF-000580', NULL, NULL, 112, NULL, NULL, 63673),
(63674, '2.60.40.10-FF-002884', NULL, 'Neurolin-like cell adhesion molecule', 103, NULL, NULL, 63674),
(63675, '3.40.50.720-FF-001297', NULL, 'Tissue-specific transplantation antigen P35B', 143, NULL, NULL, 63675),
(63676, '1.20.1420.10-FF-000021', NULL, 'TaLiN', 170, NULL, NULL, 63676),
(63677, '2.60.40.10-FF-005700', NULL, NULL, 60, NULL, NULL, 63677),
(63678, '1.10.1410.20-FF-000003', NULL, '2''-5'' oligoadenylate synthetase 1E', 190, NULL, NULL, 63678),
(63679, '2.30.30.190-FF-000015', NULL, 'Kinesin family member 13A', 77, NULL, NULL, 63679),
(63680, '1.10.12.10-FF-000042', NULL, 'Enoyl-CoA hydratase domain-containing protein 3, mitochondrial', 57, NULL, NULL, 63680),
(63681, '3.40.50.1240-FF-000086', NULL, 'Protein CBG23268', 236, NULL, NULL, 63681),
(63682, '2.30.170.40-FF-000005', NULL, '50S ribosomal L28, chloroplastic', 77, NULL, NULL, 63682),
(63683, '3.30.160.60-FF-000771', NULL, 'zinc finger protein 648', 28, NULL, NULL, 63683),
(63684, '3.80.10.10-FF-000850', NULL, 'Os03g0773300 protein', 186, NULL, NULL, 63684),
(63685, '2.130.10.10-FF-003525', NULL, 'WD repeat domain 90', 197, NULL, NULL, 63685),
(63686, '3.40.50.300-FF-006578', NULL, 'ABC transporter, putative', 100, NULL, NULL, 63686),
(63687, '1.10.1040.10-FF-000101', NULL, 'Oxidoreductase subunit', 69, NULL, NULL, 63687),
(63688, '3.10.20.90-FF-000990', NULL, 'Myosin-I heavy chain', 91, NULL, NULL, 63688);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(63689, '3.90.70.10-FF-000567', NULL, 'Uncharacterized protein', 44, NULL, NULL, 63689),
(63690, '3.30.70.330-FF-002265', NULL, NULL, 147, NULL, NULL, 63690),
(63691, '2.120.10.80-FF-000028', NULL, 'Kelch repeat and BTB (POZ) domain-containing 7', 294, NULL, NULL, 63691),
(63692, '1.10.10.10-FF-001515', NULL, 'Uncharacterized protein', 91, NULL, NULL, 63692),
(63693, '3.40.50.2300-FF-000117', NULL, 'Glutamate receptor', 201, NULL, NULL, 63693),
(63694, '3.40.50.1220-FF-000080', NULL, 'Electron transfer flavoprotein subunit alpha, mitochondrial', 101, NULL, NULL, 63694),
(63695, '2.30.170.30-FF-000002', NULL, 'Ethanolamine ammonia-lyase large subunit', 53, NULL, NULL, 63695),
(63696, '1.10.472.10-FF-000279', NULL, 'Cyclin, N-terminal domain containing protein', 115, NULL, NULL, 63696),
(63697, '2.170.300.10-FF-000042', NULL, 'Platelet endothelial aggregation receptor 1', 131, NULL, NULL, 63697),
(63698, '1.25.10.10-FF-002769', NULL, 'AER055Wp', 591, NULL, NULL, 63698),
(63699, '2.60.120.260-FF-000131', NULL, 'Beta-galactosidase, putative', 185, NULL, NULL, 63699),
(63700, '3.90.1300.10-FF-000017', NULL, 'General amidase', 524, NULL, NULL, 63700),
(63701, '3.30.70.330-FF-002911', NULL, NULL, 11, NULL, NULL, 63701),
(63702, '3.10.50.10-FF-000041', NULL, 'Predicted protein', 56, NULL, NULL, 63702),
(63703, '3.90.190.10-FF-000115', NULL, 'Tyrosine-protein phosphatase 1', 317, NULL, NULL, 63703),
(63704, '2.130.10.10-FF-002536', NULL, 'GM17963', 77, NULL, NULL, 63704),
(63705, '1.10.510.10-FF-003988', NULL, NULL, 95, NULL, NULL, 63705),
(63706, '3.40.1770.10-FF-000007', NULL, 'Predicted protein', 87, NULL, NULL, 63706),
(63707, '3.55.40.20-FF-000008', NULL, 'Superoxide dismutase', 123, NULL, NULL, 63707),
(63708, '3.30.310.50-FF-000033', NULL, 'Phosphomannomutase (Pmm)', 79, NULL, NULL, 63708),
(63709, '1.10.10.10-FF-000526', NULL, 'Histone acetyltransferase', 81, NULL, NULL, 63709),
(63710, '3.30.780.10-FF-000011', NULL, 'Translation machinery-associated protein 22', 111, NULL, NULL, 63710),
(63711, '3.30.160.60-FF-004986', NULL, NULL, 80, NULL, NULL, 63711),
(63712, '3.30.1370.10-FF-000119', NULL, 'KH type 1 domain protein', 81, NULL, NULL, 63712),
(63713, '1.10.472.10-FF-000190', NULL, 'Cyclin-D5-1', 103, NULL, NULL, 63713),
(63714, '2.60.120.650-FF-000096', NULL, 'Uncharacterized protein', 244, NULL, NULL, 63714),
(63715, '3.30.1010.10-FF-000071', NULL, 'Phosphatidylinositol 3-kinase 1 putative', 101, NULL, NULL, 63715),
(63716, '3.20.20.150-FF-000005', NULL, 'Mannonate dehydratase', 171, NULL, NULL, 63716),
(63717, '1.20.1560.10-FF-000615', NULL, 'P-glycoprotein 2', 104, NULL, NULL, 63717),
(63718, '1.25.10.10-FF-001050', NULL, 'VAC (Yeast VACuole morphology)-Like', 212, NULL, NULL, 63718),
(63719, '3.40.50.1000-FF-000834', NULL, NULL, 79, NULL, NULL, 63719),
(63720, '3.30.40.10-FF-001568', NULL, 'Uncharacterized protein', 133, NULL, NULL, 63720),
(63721, '2.130.10.10-FF-002862', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One component system)', 185, NULL, NULL, 63721),
(63722, '2.60.200.20-FF-000277', NULL, 'AGAP005804-PA', 99, NULL, NULL, 63722),
(63723, '1.10.8.270-FF-000046', NULL, 'TBC1 domain family member 25', 102, NULL, NULL, 63723),
(63724, '4.10.60.10-FF-000062', NULL, 'zinc finger CCHC-type and RNA-binding motif-containing protein 1 isoform X2', 52, NULL, NULL, 63724),
(63725, '1.10.630.10-FF-000006', NULL, 'Cytochrome P450 302a1, mitochondrial', 489, NULL, NULL, 63725),
(63726, '3.40.850.10-FF-000374', NULL, 'Kinesin-like protein', 189, NULL, NULL, 63726),
(63727, '2.40.170.20-FF-000093', NULL, 'Transporter, outer membrane receptor (OMR) family', 716, NULL, NULL, 63727),
(63728, '3.90.79.10-FF-000148', NULL, 'Adenine DNA glycosylase', 117, NULL, NULL, 63728),
(63729, '2.60.40.60-FF-000078', NULL, 'Protocadherin 1', 105, NULL, NULL, 63729),
(63730, '3.40.50.1260-FF-000041', NULL, 'Phosphoglycerate kinase', 180, NULL, NULL, 63730),
(63731, '1.25.40.10-FF-002333', NULL, 'Os02g0818800 protein', 194, NULL, NULL, 63731),
(63732, '3.90.640.10-FF-000015', NULL, 'Actin-like protein', 95, NULL, NULL, 63732);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(63733, '1.20.58.60-FF-000061', NULL, 'microtubule-actin cross-linking factor 1 isoform X3', 115, NULL, NULL, 63733),
(63734, '3.30.160.60-FF-005560', NULL, NULL, 94, NULL, NULL, 63734),
(63735, '3.30.70.330-FF-000556', NULL, 'Os06g0220600 protein', 122, NULL, NULL, 63735),
(63736, '3.40.390.10-FF-000181', NULL, NULL, 192, NULL, NULL, 63736),
(63737, '3.60.10.10-FF-000008', NULL, 'Synaptojanin 2', 378, NULL, NULL, 63737),
(63738, '1.10.1410.40-FF-000009', NULL, 'Transmembrane protein 102', 149, NULL, NULL, 63738),
(63739, '3.80.10.10-FF-000524', NULL, 'Predicted gene 16427', 233, NULL, NULL, 63739),
(63740, '3.30.160.60-FF-001434', NULL, 'zinc finger protein 286A isoform X1', 26, NULL, NULL, 63740),
(63741, '1.10.10.10-FF-000998', NULL, 'Uncharacterized protein', 148, NULL, NULL, 63741),
(63742, '2.60.40.10-FF-003401', NULL, NULL, 93, NULL, NULL, 63742),
(63743, '3.90.1860.10-FF-000019', NULL, 'Predicted protein', 65, NULL, NULL, 63743),
(63744, '3.40.50.720-FF-001976', NULL, 'Fatty acyl-CoA reductase', 250, NULL, NULL, 63744),
(63745, '3.30.9.10-FF-000023', NULL, 'Sarcosine dehydrogenase', 159, NULL, NULL, 63745),
(63746, '2.130.10.10-FF-004189', NULL, 'Uncharacterized protein', 449, NULL, NULL, 63746),
(63747, '3.50.50.60-FF-000649', NULL, 'Glycerol-3-phosphate dehydrogenase-like protein', 131, NULL, NULL, 63747),
(63748, '3.30.465.10-FF-000043', NULL, 'Gliding motility-associated protein GldE', 88, NULL, NULL, 63748),
(63749, '1.20.58.70-FF-000064', NULL, 'Target SNARE, putative', 135, NULL, NULL, 63749),
(63750, '2.60.120.260-FF-000395', NULL, 'Protein-L-isoaspartate O-methyltransferase', 164, NULL, NULL, 63750),
(63751, '2.40.50.140-FF-000362', NULL, 'Ribonuclease R', 106, NULL, NULL, 63751),
(63752, '3.40.1410.10-FF-000048', NULL, 'HTH-type transcriptional repressor YvoA', 162, NULL, NULL, 63752),
(63753, '3.30.420.80-FF-000022', NULL, 'Structural constituent of ribosome', 148, NULL, NULL, 63753),
(63754, '2.40.160.50-FF-000016', NULL, 'Sorting and assembly machinery component 50', 352, NULL, NULL, 63754),
(63755, '2.60.40.60-FF-001005', NULL, 'Uncharacterized protein', 121, NULL, NULL, 63755),
(63756, '3.30.40.10-FF-000433', NULL, 'Putative homeodomain-like transcription factor superfamily protein', 121, NULL, NULL, 63756),
(63757, '2.30.30.1150-FF-000005', NULL, 'PHD finger protein EHD3 isoform A', 162, NULL, NULL, 63757),
(63758, '3.30.230.70-FF-000038', NULL, 'Unplaced genomic scaffold supercont2.9, whole genome shotgun sequence', 260, NULL, NULL, 63758),
(63759, '3.30.160.60-FF-005503', NULL, NULL, 31, NULL, NULL, 63759),
(63760, '1.10.510.10-FF-001072', NULL, 'Uncharacterized protein', 253, NULL, NULL, 63760),
(63761, '3.30.160.20-FF-000012', NULL, 'Drosha ribonuclease III', 85, NULL, NULL, 63761),
(63762, '3.30.110.20-FF-000008', NULL, 'DNA/RNA-binding protein Alba 1', 97, NULL, NULL, 63762),
(63763, '3.90.550.10-FF-000750', NULL, 'Putative mannan synthase 7', 52, NULL, NULL, 63763),
(63764, '3.30.160.70-FF-000009', NULL, 'Uncharacterized protein', 31, NULL, NULL, 63764),
(63765, '3.30.230.10-FF-000071', NULL, 'DNA mismatch repair protein MutL', 112, NULL, NULL, 63765),
(63766, '2.40.30.130-FF-000052', NULL, 'Uncharacterized protein', 114, NULL, NULL, 63766),
(63767, '1.10.640.10-FF-000035', NULL, 'Uncharacterized protein', 153, NULL, NULL, 63767),
(63768, '3.40.50.10810-FF-000196', NULL, 'Predicted protein', 216, NULL, NULL, 63768),
(63769, '2.10.110.10-FF-000323', NULL, 'Uncharacterized protein', 47, NULL, NULL, 63769),
(63770, '3.90.1030.10-FF-000007', NULL, '39S ribosomal protein L17, mitochondrial', 124, NULL, NULL, 63770),
(63771, '3.30.420.140-FF-000045', NULL, 'Uncharacterized protein', 89, NULL, NULL, 63771),
(63772, '3.10.20.90-FF-000782', NULL, 'Uncharacterized protein', 75, NULL, NULL, 63772),
(63773, '3.40.50.2300-FF-000325', NULL, 'Uncharacterized protein', 172, NULL, NULL, 63773),
(63774, '1.10.486.10-FF-000075', NULL, 'Uncharacterized protein', 100, NULL, NULL, 63774),
(63775, '2.30.29.30-FF-000914', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 128, NULL, NULL, 63775);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(63776, '3.90.950.10-FF-000033', NULL, 'Inosine triphosphate pyrophosphatase', 103, NULL, NULL, 63776),
(63777, '3.40.50.1820-FF-000372', NULL, 'Protein phosphatase methylesterase 1', 320, NULL, NULL, 63777),
(63778, '1.20.5.340-FF-000065', NULL, 'E3 ubiquitin protein ligase', 126, NULL, NULL, 63778),
(63779, '1.25.40.180-FF-000142', NULL, NULL, 154, NULL, NULL, 63779),
(63780, '3.30.70.1450-FF-000011', NULL, 'Sulfur deprivation response regulator', 74, NULL, NULL, 63780),
(63781, '3.30.160.60-FF-002569', NULL, 'Zinc finger protein 562', 27, NULL, NULL, 63781),
(63782, '3.30.420.40-FF-000476', NULL, 'RE20574p', 276, NULL, NULL, 63782),
(63783, '1.10.10.10-FF-000734', NULL, 'RNA polymerase Rpc34 subunit, putative', 65, NULL, NULL, 63783),
(63784, '2.160.20.10-FF-000321', NULL, 'Uncharacterized protein', 160, NULL, NULL, 63784),
(63785, '2.30.40.10-FF-000154', NULL, 'Uncharacterized protein', 20, NULL, NULL, 63785),
(63786, '3.30.70.270-FF-000162', NULL, 'Uncharacterized protein', 103, NULL, NULL, 63786),
(63787, '3.20.20.80-FF-000520', NULL, 'Endoglucanase H', 312, NULL, NULL, 63787),
(63788, '3.40.50.300-FF-000479', NULL, 'Multidrug resistance protein 1A', 249, NULL, NULL, 63788),
(63789, '3.10.110.10-FF-000257', NULL, 'Uncharacterized protein', 173, NULL, NULL, 63789),
(63790, '3.30.1520.10-FF-000036', NULL, 'HCLS1 binding protein 3', 135, NULL, NULL, 63790),
(63791, '1.25.40.10-FF-002479', NULL, 'LP07472p', 152, NULL, NULL, 63791),
(63792, '2.130.10.10-FF-001108', NULL, 'WD_domain_-_G-beta_repeat/Utp21_specific_WD40_ass ociated_putative_domain_containing_protein_-_putative', 331, NULL, NULL, 63792),
(63793, '1.20.120.1530-FF-000012', NULL, 'Methyl-accepting chemotaxis protein', 93, NULL, NULL, 63793),
(63794, '3.30.1370.10-FF-000176', NULL, 'Uncharacterized protein', 70, NULL, NULL, 63794),
(63795, '3.40.50.1820-FF-001827', NULL, 'Predicted protein', 317, NULL, NULL, 63795),
(63796, '3.40.50.300-FF-001530', NULL, 'ABC multidrug transporter (Eurofung)', 271, NULL, NULL, 63796),
(63797, '1.10.472.10-FF-000543', NULL, 'Uncharacterized protein', 78, NULL, NULL, 63797),
(63798, '1.20.930.20-FF-000002', NULL, 'RING-type E3 ubiquitin transferase', 114, NULL, NULL, 63798),
(63799, '2.40.10.10-FF-000478', NULL, NULL, 53, NULL, NULL, 63799),
(63800, '3.40.1110.10-FF-000121', NULL, 'Cation-transporting ATPase', 171, NULL, NULL, 63800),
(63801, '2.10.25.10-FF-000423', NULL, 'Neurogenic locus notch homolog protein 2', 40, NULL, NULL, 63801),
(63802, '3.40.30.10-FF-001224', NULL, 'Uncharacterized protein', 123, NULL, NULL, 63802),
(63803, '1.10.20.10-FF-000353', NULL, NULL, 91, NULL, NULL, 63803),
(63804, '3.30.40.10-FF-001776', NULL, 'Uncharacterized protein', 71, NULL, NULL, 63804),
(63805, '1.20.1070.10-FF-000180', NULL, 'neuropeptide Y receptor type 5', 331, NULL, NULL, 63805),
(63806, '2.120.10.30-FF-000328', NULL, 'Uncharacterized protein', 137, NULL, NULL, 63806),
(63807, '2.60.40.420-FF-000035', NULL, 'Coagulation factor VIII (Predicted)', 189, NULL, NULL, 63807),
(63808, '3.40.50.410-FF-000102', NULL, 'ATP-dependent DNA helicase 2 subunit KU80', 198, NULL, NULL, 63808),
(63809, '2.60.420.10-FF-000021', NULL, 'Uncharacterized protein', 111, NULL, NULL, 63809),
(63810, '3.40.50.2300-FF-000382', NULL, 'Vomeronasal 2, receptor 55', 263, NULL, NULL, 63810),
(63811, '3.10.20.230-FF-000015', NULL, 'Doublecortin domain containing 2C', 99, NULL, NULL, 63811),
(63812, '1.10.510.10-FF-002853', NULL, NULL, 240, NULL, NULL, 63812),
(63813, '1.25.40.10-FF-002597', NULL, 'Pentatricopeptide repeat-containing protein At3g26630, chloroplastic', 118, NULL, NULL, 63813),
(63814, '1.20.1270.220-FF-000006', NULL, 'Transcription factor GTE1', 77, NULL, NULL, 63814),
(63815, '2.120.10.30-FF-000446', NULL, 'Uncharacterized protein', 113, NULL, NULL, 63815),
(63816, '3.10.110.10-FF-000196', NULL, 'Ubiquitin-conjugating enzyme E2', 153, NULL, NULL, 63816),
(63817, '1.20.120.1750-FF-000139', NULL, 'RBR-type E3 ubiquitin transferase', 38, NULL, NULL, 63817),
(63818, '1.20.1270.10-FF-000104', NULL, 'Heat shock 70 kDa protein 18', 74, NULL, NULL, 63818);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(63819, '3.80.10.10-FF-001659', NULL, 'RNI-like protein', 162, NULL, NULL, 63819),
(63820, '2.60.120.10-FF-000829', NULL, 'Gll3293 protein', 145, NULL, NULL, 63820),
(63821, '1.10.287.860-FF-000002', NULL, 'GTP pyrophosphokinase YwaC', 56, NULL, NULL, 63821),
(63822, '1.25.10.10-FF-001988', NULL, 'Predicted protein', 211, NULL, NULL, 63822),
(63823, '1.10.167.10-FF-000076', NULL, 'Uncharacterized protein', 92, NULL, NULL, 63823),
(63824, '1.10.555.10-FF-000112', NULL, 'SLIT-ROBO Rho GTPase-activating protein 3', 199, NULL, NULL, 63824),
(63825, '3.30.260.10-FF-000073', NULL, NULL, 72, NULL, NULL, 63825),
(63826, '3.30.70.660-FF-000071', NULL, 'Pseudouridylate synthase-like protein', 149, NULL, NULL, 63826),
(63827, '3.40.50.720-FF-000841', NULL, 'NADPH:quinone reductase', 145, NULL, NULL, 63827),
(63828, '3.30.160.60-FF-004571', NULL, NULL, 46, NULL, NULL, 63828),
(63829, '2.40.240.20-FF-000003', NULL, 'Ribosomal RNA small subunit methyltransferase E', 71, NULL, NULL, 63829),
(63830, '3.40.250.10-FF-000171', NULL, 'Uncharacterized protein', 141, NULL, NULL, 63830),
(63831, '2.60.34.10-FF-000083', NULL, 'DnaK protein', 174, NULL, NULL, 63831),
(63832, '1.50.40.10-FF-000588', NULL, 'Uncharacterized protein', 207, NULL, NULL, 63832),
(63833, '1.10.150.60-FF-000035', NULL, NULL, 117, NULL, NULL, 63833),
(63834, '2.130.10.30-FF-000131', NULL, NULL, 299, NULL, NULL, 63834),
(63835, '3.40.50.620-FF-000373', NULL, 'ATP-binding region containing protein, putative', 172, NULL, NULL, 63835),
(63836, '1.10.150.50-FF-000032', NULL, 'caskin-1 isoform X1', 75, NULL, NULL, 63836),
(63837, '3.30.565.10-FF-000494', NULL, 'Uncharacterized protein', 212, NULL, NULL, 63837),
(63838, '1.10.238.10-FF-000691', NULL, '45 kDa calcium-binding protein', 60, NULL, NULL, 63838),
(63839, '1.25.40.20-FF-001560', NULL, 'Ankyrin repeat domain 31', 92, NULL, NULL, 63839),
(63840, '3.40.50.720-FF-000105', NULL, 'Pyrroline-5-carboxylate reductase', 164, NULL, NULL, 63840),
(63841, '3.30.70.330-FF-002147', NULL, NULL, 148, NULL, NULL, 63841),
(63842, '3.30.200.20-FF-000600', NULL, 'Serine/threonine-protein kinase PLK', 90, NULL, NULL, 63842),
(63843, '2.10.25.10-FF-000070', NULL, 'Thrombospondin 2', 39, NULL, NULL, 63843),
(63844, '3.30.70.3490-FF-000044', NULL, NULL, 170, NULL, NULL, 63844),
(63845, '3.50.50.60-FF-000442', NULL, 'Putative GMC-type oxidoreductase', 193, NULL, NULL, 63845),
(63846, '1.10.560.10-FF-000147', NULL, 'RING-type E3 ubiquitin transferase', 17, NULL, NULL, 63846),
(63847, '3.20.20.80-FF-000374', NULL, 'Glycoprotein endo-alpha-1,2-mannosidase', 93, NULL, NULL, 63847),
(63848, '3.30.70.3290-FF-000017', NULL, 'Non-ribosomal peptide synthase', 103, NULL, NULL, 63848),
(63849, '1.10.510.10-FF-003106', NULL, NULL, 195, NULL, NULL, 63849),
(63850, '1.10.150.20-FF-000225', NULL, 'UPF0758 protein SPO0054', 47, NULL, NULL, 63850),
(63851, '1.10.287.70-FF-000260', NULL, 'Outward-rectifier potassium channel TOK1', 101, NULL, NULL, 63851),
(63852, '3.80.10.10-FF-000732', NULL, 'GD11101', 78, NULL, NULL, 63852),
(63853, '1.20.900.10-FF-000025', NULL, 'Rho guanine nucleotide exchange factor 17', 196, NULL, NULL, 63853),
(63854, '1.10.10.60-FF-000788', NULL, NULL, 63, NULL, NULL, 63854),
(63855, '1.10.3500.10-FF-000002', NULL, 'RNA-binding transcriptional accessory protein', 258, NULL, NULL, 63855),
(63856, '2.20.110.10-FF-000006', NULL, 'Histone-lysine N-methyltransferase SETD7', 84, NULL, NULL, 63856),
(63857, '2.30.42.10-FF-000170', NULL, 'tight junction protein ZO-1 isoform X2', 101, NULL, NULL, 63857),
(63858, '3.20.110.10-FF-000025', NULL, 'NADPH--cytochrome P450 reductase 2', 70, NULL, NULL, 63858),
(63859, '2.120.10.80-FF-000293', NULL, 'Flagellar outer dynein arm heavy chain alpha', 217, NULL, NULL, 63859),
(63860, '1.25.40.10-FF-003968', NULL, 'Tetratricopeptide repeatcontaining protein', 234, NULL, NULL, 63860),
(63861, '2.60.120.290-FF-000145', NULL, 'Suppressor of tumorigenicity 14 protein homolog', 107, NULL, NULL, 63861),
(63862, '3.30.200.20-FF-000246', NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 152', 95, NULL, NULL, 63862);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(63863, '3.10.170.20-FF-000028', NULL, NULL, 127, NULL, NULL, 63863),
(63864, '2.40.100.10-FF-000136', NULL, '26S proteasome non-ATPase regulatory subunit 4-like protein', 86, NULL, NULL, 63864),
(63865, '3.100.10.10-FF-000033', NULL, NULL, 91, NULL, NULL, 63865),
(63866, '3.30.1490.100-FF-000029', NULL, 'DNA polymerase IV', 111, NULL, NULL, 63866),
(63867, '3.40.1160.10-FF-000101', NULL, 'Carbamate kinase, putative', 119, NULL, NULL, 63867),
(63868, '3.20.80.10-FF-000048', NULL, 'Uncharacterized protein', 67, NULL, NULL, 63868),
(63869, '3.60.130.20-FF-000003', NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', 333, NULL, NULL, 63869),
(63870, '2.10.110.10-FF-000177', NULL, 'LIM homeobox 9', 72, NULL, NULL, 63870),
(63871, '3.40.1080.10-FF-000005', NULL, '3-oxoacid CoA-transferase subunit A', 226, NULL, NULL, 63871),
(63872, '3.40.50.1000-FF-000626', NULL, NULL, 146, NULL, NULL, 63872),
(63873, '1.25.40.10-FF-002833', NULL, 'RNA_polymerase-associated_protein_CTR9_-_putative', 137, NULL, NULL, 63873),
(63874, '2.130.10.10-FF-002598', NULL, 'NACHT and WD repeat domain containing 2', 127, NULL, NULL, 63874),
(63875, '3.30.160.60-FF-001552', NULL, 'Zinc finger protein 425', 27, NULL, NULL, 63875),
(63876, '2.10.25.10-FF-001351', NULL, 'Uncharacterized protein', 42, NULL, NULL, 63876),
(63877, '1.25.40.20-FF-001408', NULL, 'Uncharacterized protein', 120, NULL, NULL, 63877),
(63878, '3.40.50.850-FF-000003', NULL, 'Isochorismatase hydrolase', 208, NULL, NULL, 63878),
(63879, '2.60.40.10-FF-003137', NULL, 'Plexin C1', 101, NULL, NULL, 63879),
(63880, '1.10.10.10-FF-000791', NULL, 'IclR family transcriptional regulator', 63, NULL, NULL, 63880),
(63881, '1.10.10.60-FF-001305', NULL, NULL, 77, NULL, NULL, 63881),
(63882, '1.25.40.10-FF-004188', NULL, 'MSHA biogenesis protein MshN', 81, NULL, NULL, 63882),
(63883, '3.30.160.60-FF-002980', NULL, 'Si:ch73-299h12.8', 27, NULL, NULL, 63883),
(63884, '1.20.1050.10-FF-000178', NULL, 'Glutathione S-transferase', 123, NULL, NULL, 63884),
(63885, '2.10.22.10-FF-000001', NULL, 'Cysteine-rich motor neuron 1 protein-like protein', 31, NULL, NULL, 63885),
(63886, '1.25.40.10-FF-001405', NULL, 'Putative beta-barrel assembly-enhancing protease', 295, NULL, NULL, 63886),
(63887, '3.60.10.10-FF-000160', NULL, 'Uncharacterized protein', 310, NULL, NULL, 63887),
(63888, '3.40.109.10-FF-000028', NULL, 'Nitroreductase family protein', 179, NULL, NULL, 63888),
(63889, '2.130.10.10-FF-001316', NULL, 'Semaphorin 7A', 423, NULL, NULL, 63889),
(63890, '2.160.20.10-FF-000175', NULL, 'Zinc finger protein', 156, NULL, NULL, 63890),
(63891, '3.40.1440.10-FF-000022', NULL, NULL, 97, NULL, NULL, 63891),
(63892, '3.90.105.10-FF-000008', NULL, 'Molybdopterin molybdenumtransferase', 24, NULL, NULL, 63892),
(63893, '3.40.50.1820-FF-001709', NULL, 'GPI inositol-deacylase', 159, NULL, NULL, 63893),
(63894, '2.130.10.10-FF-002744', NULL, 'Protein CBR-EPG-6', 272, NULL, NULL, 63894),
(63895, '2.60.200.20-FF-000159', NULL, 'Predicted protein', 128, NULL, NULL, 63895),
(63896, '1.10.510.10-FF-002353', NULL, NULL, 192, NULL, NULL, 63896),
(63897, '3.30.70.940-FF-000031', NULL, 'Transcription elongation factor SPT5', 73, NULL, NULL, 63897),
(63898, '1.20.120.1240-FF-000048', NULL, 'Uncharacterized protein', 204, NULL, NULL, 63898),
(63899, '2.120.10.30-FF-000480', NULL, 'Similar to peptidylglycine monooxygenase', 303, NULL, NULL, 63899),
(63900, '3.80.10.10-FF-004329', NULL, 'Predicted protein', 198, NULL, NULL, 63900),
(63901, '2.130.10.10-FF-005116', NULL, 'Striatin', 162, NULL, NULL, 63901),
(63902, '2.40.30.10-FF-000333', NULL, 'GTP-binding protein', 89, NULL, NULL, 63902),
(63903, '3.30.450.20-FF-000354', NULL, 'Nitrogen fixation negative regulator NifL', 135, NULL, NULL, 63903),
(63904, '1.20.1250.20-FF-000550', NULL, 'Inner membrane protein YbjJ', 184, NULL, NULL, 63904),
(63905, '3.80.10.10-FF-001867', NULL, 'Peroxidasin homolog', 100, NULL, NULL, 63905),
(63906, '1.20.1250.20-FF-000308', NULL, 'MFS efflux transporter', 186, NULL, NULL, 63906),
(63907, '1.10.150.20-FF-000282', NULL, 'Uncharacterized protein', 54, NULL, NULL, 63907);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(63908, '3.90.70.10-FF-000359', NULL, 'Ubiquitinyl hydrolase 1', 234, NULL, NULL, 63908),
(63909, '3.30.200.20-FF-002045', NULL, 'Serine/threonine-protein kinase ppk22', 89, NULL, NULL, 63909),
(63910, '3.10.100.10-FF-000077', NULL, 'Killer cell lectin-like receptor subfamily B member 1A', 134, NULL, NULL, 63910),
(63911, '3.40.1740.10-FF-000005', NULL, 'AT3g29240/MXO21_9', 188, NULL, NULL, 63911),
(63912, '1.25.10.10-FF-000594', NULL, 'WAPL cohesin release factor a', 457, NULL, NULL, 63912),
(63913, '1.10.20.10-FF-000145', NULL, 'Chromatin accessibility complex protein 1-like Protein', 85, NULL, NULL, 63913),
(63914, '3.40.50.300-FF-000715', NULL, 'ATP-dependent DNA helicase RecG', 243, NULL, NULL, 63914),
(63915, '2.130.10.10-FF-000799', NULL, 'Probable cytosolic iron-sulfur protein assembly protein CIAO1 homolog', 62, NULL, NULL, 63915),
(63916, '2.60.220.50-FF-000118', NULL, 'Uncharacterized protein', 48, NULL, NULL, 63916),
(63917, '3.40.50.2000-FF-001022', NULL, 'Os02g0210800 protein', 177, NULL, NULL, 63917),
(63918, '3.40.50.720-FF-001858', NULL, 'Non-ribosomal peptide synthase', 383, NULL, NULL, 63918),
(63919, '3.30.70.330-FF-002501', NULL, NULL, 72, NULL, NULL, 63919),
(63920, '3.40.50.150-FF-001316', NULL, NULL, 297, NULL, NULL, 63920),
(63921, '3.30.1370.10-FF-000237', NULL, 'Uncharacterized protein', 53, NULL, NULL, 63921),
(63922, '1.20.20.10-FF-000004', NULL, 'ATP synthase subunit c', 72, NULL, NULL, 63922),
(63923, '2.60.40.60-FF-000842', NULL, 'Uncharacterized protein', 73, NULL, NULL, 63923),
(63924, '1.10.630.10-FF-000063', NULL, 'Cytochrome P450 monooxygenase', 472, NULL, NULL, 63924),
(63925, '3.90.550.50-FF-000149', NULL, 'Chromosome 10, whole genome shotgun sequence', 145, NULL, NULL, 63925),
(63926, '3.90.550.10-FF-000508', NULL, 'Glycosyl transferase family 2', 259, NULL, NULL, 63926),
(63927, '1.20.1250.20-FF-001736', NULL, 'Predicted protein', 201, NULL, NULL, 63927),
(63928, '3.10.20.90-FF-000838', NULL, 'Uncharacterized protein', 126, NULL, NULL, 63928),
(63929, '3.80.10.10-FF-003812', NULL, 'Uncharacterized protein', 82, NULL, NULL, 63929),
(63930, '3.30.430.20-FF-000055', NULL, 'Cysteine-rich repeat secretory protein 38', 108, NULL, NULL, 63930),
(63931, '1.25.40.20-FF-001352', NULL, 'Uncharacterized protein', 102, NULL, NULL, 63931),
(63932, '3.90.190.10-FF-000233', NULL, 'Protein Tyrosine Phosphatase', 280, NULL, NULL, 63932),
(63933, '1.10.510.10-FF-003016', NULL, NULL, 123, NULL, NULL, 63933),
(63934, '3.30.160.60-FF-001288', NULL, 'Zinc finger protein 35', 31, NULL, NULL, 63934),
(63935, '3.90.930.12-FF-000017', NULL, NULL, 101, NULL, NULL, 63935),
(63936, '2.30.30.40-FF-000578', NULL, 'Chemotaxis signal transduction protein', 60, NULL, NULL, 63936),
(63937, '3.40.50.10810-FF-000078', NULL, 'Helicase domain containing protein', 247, NULL, NULL, 63937),
(63938, '2.10.110.10-FF-000087', NULL, 'LIM zinc-binding domain-containing Nebulette', 124, NULL, NULL, 63938),
(63939, '2.30.30.100-FF-000062', NULL, 'Probable U6 snRNA-associated Sm-like protein LSm7', 99, NULL, NULL, 63939),
(63940, '3.40.50.80-FF-000066', NULL, 'Vanillate O-demethylase oxidoreductase', 122, NULL, NULL, 63940),
(63941, '4.10.1000.10-FF-000130', NULL, 'Uncharacterized protein', 93, NULL, NULL, 63941),
(63942, '1.25.40.10-FF-004278', NULL, 'Pre-mRNA-splicing factor SYF1', 209, NULL, NULL, 63942),
(63943, '3.40.50.2300-FF-000735', NULL, 'Two component response regulator', 130, NULL, NULL, 63943),
(63944, '3.40.50.12780-FF-000124', NULL, 'Isocyanide synthase-NRPS hybrid crmA', 384, NULL, NULL, 63944),
(63945, '3.30.930.10-FF-000135', NULL, 'GCN2p Protein kinase', 338, NULL, NULL, 63945),
(63946, '1.10.510.10-FF-004298', NULL, NULL, 159, NULL, NULL, 63946),
(63947, '3.30.60.20-FF-000145', NULL, 'Kinase suppressor of Ras B', 70, NULL, NULL, 63947),
(63948, '1.10.418.10-FF-000255', NULL, 'Uncharacterized protein', 86, NULL, NULL, 63948),
(63949, '2.160.20.10-FF-000085', NULL, 'Glycoside hydrolase family 55 protein', 343, NULL, NULL, 63949),
(63950, '3.30.230.10-FF-000127', NULL, 'Mevalonate kinase', 178, NULL, NULL, 63950);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(63951, '2.10.109.10-FF-000050', NULL, 'Signal peptidase I', 144, NULL, NULL, 63951),
(63952, '2.60.40.150-FF-000673', NULL, 'Predicted protein', 57, NULL, NULL, 63952),
(63953, '1.25.40.20-FF-000537', NULL, 'Rab GTPase activating protein putative', 164, NULL, NULL, 63953),
(63954, '3.40.50.150-FF-001373', NULL, NULL, 177, NULL, NULL, 63954),
(63955, '3.80.10.10-FF-003458', NULL, 'Uncharacterized protein', 236, NULL, NULL, 63955),
(63956, '2.30.29.30-FF-000504', NULL, 'FACT complex subunit SSRP1', 118, NULL, NULL, 63956),
(63957, '3.90.1150.10-FF-000191', NULL, '4-aminobutyrate aminotransferase, mitochondrial', 168, NULL, NULL, 63957),
(63958, '1.20.58.60-FF-000622', NULL, 'Uncharacterized protein', 122, NULL, NULL, 63958),
(63959, '1.10.238.10-FF-000398', NULL, 'Calmodulin-like protein 3', 86, NULL, NULL, 63959),
(63960, '3.90.640.10-FF-000223', NULL, 'Actin-related protein 8', 70, NULL, NULL, 63960),
(63961, '2.30.30.40-FF-000488', NULL, 'Protein CBR-CED-5', 64, NULL, NULL, 63961),
(63962, '3.30.760.10-FF-000009', NULL, 'eukaryotic translation initiation factor 4E type 2', 170, NULL, NULL, 63962),
(63963, '3.40.50.11550-FF-000002', NULL, 'Dermonecrotic toxin', 250, NULL, NULL, 63963),
(63964, '2.130.10.10-FF-004953', NULL, 'Uncharacterized protein', 96, NULL, NULL, 63964),
(63965, '1.25.40.10-FF-000534', NULL, 'TPR repeat-containing thioredoxin TTL4', 360, NULL, NULL, 63965),
(63966, '2.60.40.1510-FF-000039', NULL, 'Integrin beta', 111, NULL, NULL, 63966),
(63967, '3.40.50.880-FF-000164', NULL, 'Uncharacterized protein', 207, NULL, NULL, 63967),
(63968, '3.30.70.330-FF-002411', NULL, NULL, 92, NULL, NULL, 63968),
(63969, '3.40.50.10130-FF-000003', NULL, 'Crossover junction endonuclease MUS81', 154, NULL, NULL, 63969),
(63970, '1.25.40.10-FF-002125', NULL, 'Pentatricopeptide repeat-containing protein At3g53700, chloroplastic', 148, NULL, NULL, 63970),
(63971, '1.20.920.20-FF-000030', NULL, 'Dynein heavy chain', 340, NULL, NULL, 63971),
(63972, '1.10.287.70-FF-000203', NULL, 'Potassium channel subfamily K member 1', 175, NULL, NULL, 63972),
(63973, '1.10.510.10-FF-002089', NULL, NULL, 117, NULL, NULL, 63973),
(63974, '2.60.40.3500-FF-000018', NULL, NULL, 108, NULL, NULL, 63974),
(63975, '3.80.10.10-FF-000171', NULL, 'Leucine rich repeat and coiled-coil centrosomal protein 1', 82, NULL, NULL, 63975),
(63976, '3.80.10.10-FF-000114', NULL, 'leucine-rich repeat-containing protein 41 isoform X1', 200, NULL, NULL, 63976),
(63977, '3.40.570.10-FF-000004', NULL, 'Nuclease 1, mitochondrial', 257, NULL, NULL, 63977),
(63978, '2.40.50.140-FF-000418', NULL, 'Single-stranded DNA-binding protein', 160, NULL, NULL, 63978),
(63979, '3.40.50.2020-FF-000157', NULL, 'Uncharacterized protein', 98, NULL, NULL, 63979),
(63980, '3.40.50.10140-FF-000006', NULL, 'Toll-like receptor 4', 146, NULL, NULL, 63980),
(63981, '3.40.190.290-FF-000034', NULL, 'Transcriptional regulator, LysR family', 201, NULL, NULL, 63981),
(63982, '3.30.710.10-FF-000063', NULL, 'Ankyrin repeat and BTB/POZ domain-containing protein 1', 120, NULL, NULL, 63982),
(63983, '1.20.1250.20-FF-002141', NULL, 'Uncharacterized protein', 203, NULL, NULL, 63983),
(63984, '3.30.160.60-FF-001081', NULL, 'Combgap, isoform F', 28, NULL, NULL, 63984),
(63985, '1.10.10.160-FF-000016', NULL, 'DNA helicase', 113, NULL, NULL, 63985),
(63986, '2.60.40.60-FF-000578', NULL, 'Desmocollin 2 like', 106, NULL, NULL, 63986),
(63987, '1.25.40.720-FF-000023', NULL, 'Uncharacterized protein', 126, NULL, NULL, 63987),
(63988, '1.50.10.20-FF-000090', NULL, 'Complement component 4A (Rodgers blood group)', 278, NULL, NULL, 63988),
(63989, '3.40.850.10-FF-000020', NULL, 'unconventional myosin-XVIIIa isoform X1', 213, NULL, NULL, 63989),
(63990, '3.90.1150.10-FF-000134', NULL, 'HISTIDINE BIOSYNTHESIS 6B', 114, NULL, NULL, 63990),
(63991, '3.40.190.10-FF-000284', NULL, 'Glutamate receptor ionotropic, kainate 3-like Protein', 129, NULL, NULL, 63991),
(63992, '3.30.2430.10-FF-000001', NULL, 'Type III effector phosphothreonine lyase', 201, NULL, NULL, 63992),
(63993, '2.40.50.140-FF-000570', NULL, 'WGS project CABT00000000 data, contig 2.1', 89, NULL, NULL, 63993);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(63994, '3.60.110.10-FF-000055', NULL, 'Carbon-nitrogen hydrolase', 246, NULL, NULL, 63994),
(63995, '2.60.40.60-FF-000488', NULL, 'Cadherin 17, LI cadherin (Liver-intestine)', 104, NULL, NULL, 63995),
(63996, '3.40.50.300-FF-003705', NULL, 'Uncharacterized protein', 261, NULL, NULL, 63996),
(63997, '3.30.420.40-FF-000684', NULL, 'cDNA clone:002-183-D01, full insert sequence', 129, NULL, NULL, 63997),
(63998, '1.25.40.10-FF-002743', NULL, 'Uncharacterized protein', 222, NULL, NULL, 63998),
(63999, '2.20.70.10-FF-000235', NULL, 'WW domain containing protein', 39, NULL, NULL, 63999),
(64000, '2.130.10.10-FF-000592', NULL, 'UV-damaged DNA binding protein', 340, NULL, NULL, 64000),
(64001, '2.120.10.80-FF-000236', NULL, 'Uncharacterized protein', 177, NULL, NULL, 64001),
(64002, '3.90.79.10-FF-000266', NULL, 'Nudix hydrolase 17 mitochondrial', 113, NULL, NULL, 64002),
(64003, '1.10.420.10-FF-000053', NULL, 'Uncharacterized protein', 114, NULL, NULL, 64003),
(64004, '3.30.70.330-FF-000820', NULL, 'RNA recognition motif-containing protein', 75, NULL, NULL, 64004),
(64005, '1.20.144.10-FF-000077', NULL, 'Phospholipid phosphatase-related 4', 174, NULL, NULL, 64005),
(64006, '2.60.40.1390-FF-000020', NULL, 'Uncharacterized protein', 181, NULL, NULL, 64006),
(64007, '4.10.520.10-FF-000032', NULL, NULL, 85, NULL, NULL, 64007),
(64008, '1.25.10.10-FF-003112', NULL, 'AGAP005033-PA', 214, NULL, NULL, 64008),
(64009, '1.10.510.10-FF-001425', NULL, 'Predicted protein', 185, NULL, NULL, 64009),
(64010, '3.80.10.10-FF-000024', NULL, 'Somatic embryogenesis receptor kinase 1', 188, NULL, NULL, 64010),
(64011, '1.20.1280.290-FF-000017', NULL, 'lysosomal amino acid transporter 1 homolog', 102, NULL, NULL, 64011),
(64012, '3.30.1140.32-FF-000015', NULL, '30S ribosomal protein S3, chloroplastic', 98, NULL, NULL, 64012),
(64013, '1.10.132.60-FF-000049', NULL, 'DNA polymerase', 174, NULL, NULL, 64013),
(64014, '1.50.10.10-FF-000030', NULL, 'Glucosidase YgjK', 450, NULL, NULL, 64014),
(64015, '3.40.50.2000-FF-000151', NULL, 'UDP-glycosyltransferase 76E9', 242, NULL, NULL, 64015),
(64016, '3.30.40.10-FF-001922', NULL, 'Uncharacterized protein', 71, NULL, NULL, 64016),
(64017, '1.25.40.10-FF-000798', NULL, 'Pentatricopeptide repeat-containing protein At3g49170, chloroplastic', 140, NULL, NULL, 64017),
(64018, '3.40.190.10-FF-000227', NULL, 'Peptide ABC transporter substrate-binding protein', 127, NULL, NULL, 64018),
(64019, '1.10.8.1310-FF-000002', NULL, 'Uncharacterized protein', 116, NULL, NULL, 64019),
(64020, '3.40.30.10-FF-001078', NULL, 'Predicted protein', 143, NULL, NULL, 64020),
(64021, '3.40.50.11350-FF-000032', NULL, 'Predicted protein', 143, NULL, NULL, 64021),
(64022, '3.30.470.30-FF-000066', NULL, 'RNA capping enzyme, nuclear', 182, NULL, NULL, 64022),
(64023, '1.20.1510.10-FF-000051', NULL, 'Cation efflux family protein', 199, NULL, NULL, 64023),
(64024, '3.30.160.60-FF-003143', NULL, 'ZNF749 isoform 1', 32, NULL, NULL, 64024),
(64025, '1.10.472.10-FF-000397', NULL, 'Cyclin domain-containing protein', 145, NULL, NULL, 64025),
(64026, '2.130.10.10-FF-004806', NULL, 'Uncharacterized protein', 145, NULL, NULL, 64026),
(64027, '2.60.40.2470-FF-000001', NULL, 'Thiosulfate oxidation carrier protein SoxY', 117, NULL, NULL, 64027),
(64028, '4.10.1240.30-FF-000007', NULL, 'Integrin beta', 79, NULL, NULL, 64028),
(64029, '1.50.10.20-FF-000033', NULL, 'Mannan endo-1,6-alpha-mannosidase', 354, NULL, NULL, 64029),
(64030, '3.30.387.10-FF-000001', NULL, 'Envelope glycoprotein', 80, NULL, NULL, 64030),
(64031, '3.30.160.60-FF-004368', NULL, NULL, 39, NULL, NULL, 64031),
(64032, '1.10.510.10-FF-000498', NULL, 'U-box domain-containing protein 51', 200, NULL, NULL, 64032),
(64033, '2.60.120.40-FF-000052', NULL, 'Uncharacterized protein', 158, NULL, NULL, 64033),
(64034, '1.25.40.820-FF-000019', NULL, 'Putative RNA polymerase II subunit B1 CTD phosphatase rpap2', 178, NULL, NULL, 64034),
(64035, '3.40.50.300-FF-004369', NULL, 'ABC transporter, ATP-binding protein', 219, NULL, NULL, 64035),
(64036, '3.40.390.10-FF-000147', NULL, 'Lethal factor', 225, NULL, NULL, 64036);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(64037, '3.30.479.30-FF-000024', NULL, 'Prohibitin-1, mitochondrial', 94, NULL, NULL, 64037),
(64038, '1.20.1560.10-FF-000380', NULL, 'ABC transporter HlyB/MsbA family', 326, NULL, NULL, 64038),
(64039, '1.10.150.20-FF-000107', NULL, 'DNA repair endonuclease XPF', 90, NULL, NULL, 64039),
(64040, '2.30.29.30-FF-000414', NULL, 'Uncharacterized protein, isoform D', 136, NULL, NULL, 64040),
(64041, '3.30.70.330-FF-002029', NULL, NULL, 90, NULL, NULL, 64041),
(64042, '3.40.50.620-FF-000401', NULL, 'Isoleucyl-tRNA synthetase (Mitochondrial)', 279, NULL, NULL, 64042),
(64043, '3.90.226.10-FF-000126', NULL, 'Enoyl-CoA hydratase', 244, NULL, NULL, 64043),
(64044, '1.20.1250.20-FF-002225', NULL, 'Uncharacterized protein', 129, NULL, NULL, 64044),
(64045, '3.80.20.20-FF-000062', NULL, 'Sporulation-specific protein 22', 124, NULL, NULL, 64045),
(64046, '3.30.230.70-FF-000072', NULL, 'Exosome complex exonuclease RRP46-like protein', 153, NULL, NULL, 64046),
(64047, '3.40.309.10-FF-000072', NULL, 'Aldehyde dehydrogenase', 194, NULL, NULL, 64047),
(64048, '3.30.479.20-FF-000021', NULL, 'Elongation factor Ts', 96, NULL, NULL, 64048),
(64049, '2.40.50.140-FF-000805', NULL, NULL, 183, NULL, NULL, 64049),
(64050, '2.30.29.30-FF-000358', NULL, 'Inner membrane complex sub-compartment protein 1 (ISP1)', 122, NULL, NULL, 64050),
(64051, '3.40.50.10900-FF-000015', NULL, 'Predicted protein', 151, NULL, NULL, 64051),
(64052, '1.25.40.10-FF-003030', NULL, 'ERAD-associated E3 ubiquitin-protein ligase component HRD3A', 103, NULL, NULL, 64052),
(64053, '1.20.1050.10-FF-000296', NULL, 'Uncharacterized protein', 90, NULL, NULL, 64053),
(64054, '3.30.1120.30-FF-000023', NULL, 'Serine/threonine-protein kinase PLK', 97, NULL, NULL, 64054),
(64055, '2.60.40.60-FF-000960', NULL, 'Uncharacterized protein', 90, NULL, NULL, 64055),
(64056, '2.40.50.40-FF-000028', NULL, 'LytR family transcriptional regulator', 71, NULL, NULL, 64056),
(64057, '3.30.160.60-FF-003233', NULL, NULL, 29, NULL, NULL, 64057),
(64058, '2.80.10.70-FF-000005', NULL, 'Uncharacterized protein', 112, NULL, NULL, 64058),
(64059, '3.30.70.120-FF-000049', NULL, NULL, 119, NULL, NULL, 64059),
(64060, '1.20.1250.20-FF-000078', NULL, 'MFS maltose transporter, putative', 469, NULL, NULL, 64060),
(64061, '1.10.10.10-FF-001280', NULL, 'Uncharacterized protein', 75, NULL, NULL, 64061),
(64062, '3.30.900.10-FF-000010', NULL, 'Autophagy-related protein 13', 251, NULL, NULL, 64062),
(64063, '1.10.10.10-FF-000818', NULL, 'LysR family transcriptional regulator', 84, NULL, NULL, 64063),
(64064, '3.30.420.10-FF-000400', NULL, NULL, 199, NULL, NULL, 64064),
(64065, '3.30.300.130-FF-000027', NULL, NULL, 81, NULL, NULL, 64065),
(64066, '1.20.272.10-FF-000037', NULL, 'DNA polymerase III, delta prime subunit', 111, NULL, NULL, 64066),
(64067, '1.10.1290.10-FF-000001', NULL, 'Tegument protein VP16', 318, NULL, NULL, 64067),
(64068, '3.10.100.10-FF-000195', NULL, NULL, 146, NULL, NULL, 64068),
(64069, '1.10.1450.10-FF-000149', NULL, 'Tetraspanin, putative', 86, NULL, NULL, 64069),
(64070, '3.30.70.330-FF-002557', NULL, NULL, 149, NULL, NULL, 64070),
(64071, '3.40.800.10-FF-000045', NULL, NULL, 258, NULL, NULL, 64071),
(64072, '1.10.1300.10-FF-000054', NULL, 'Phosphodiesterase', 291, NULL, NULL, 64072),
(64073, '1.20.58.60-FF-000151', NULL, 'dystrophin, isoforms A/C/F/G/H isoform X2', 133, NULL, NULL, 64073),
(64074, '1.20.5.170-FF-000171', NULL, 'Related to spindle assembly checkpoint protein', 37, NULL, NULL, 64074),
(64075, '3.40.50.300-FF-003205', NULL, 'CTP synthase', 185, NULL, NULL, 64075),
(64076, '2.40.30.10-FF-000069', NULL, 'NADH-cytochrome b5 reductase', 105, NULL, NULL, 64076),
(64077, '1.20.120.1900-FF-000089', NULL, 'Spindle pole body component', 114, NULL, NULL, 64077),
(64078, '3.40.800.20-FF-000048', NULL, 'Histone deacetylase 6', 361, NULL, NULL, 64078),
(64079, '1.10.287.2620-FF-000020', NULL, 'Dynein heavy chain 2', 65, NULL, NULL, 64079),
(64080, '3.30.200.20-FF-000662', NULL, 'Cyclin-dependent kinase C-3', 108, NULL, NULL, 64080),
(64081, '1.25.40.10-FF-000916', NULL, 'Hat1 interacting factor', 119, NULL, NULL, 64081); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(64082, '1.10.533.10-FF-000298', NULL, 'Uncharacterized protein', 75, NULL, NULL, 64082),
(64083, '3.40.50.720-FF-001589', NULL, 'Very-long-chain 3-oxoacyl-CoA reductase', 217, NULL, NULL, 64083),
(64084, '3.40.50.150-FF-001047', NULL, NULL, 117, NULL, NULL, 64084),
(64085, '2.60.40.3620-FF-000003', NULL, NULL, 110, NULL, NULL, 64085),
(64086, '2.40.230.20-FF-000002', NULL, 'Nucleoside-specific outer membrane porin OmpK', 243, NULL, NULL, 64086),
(64087, '2.30.31.20-FF-000001', NULL, 'SsgA family sporulation/cell division regulator', 135, NULL, NULL, 64087),
(64088, '3.40.50.300-FF-001058', NULL, 'ATP-dependent DNA helicase DinG', 282, NULL, NULL, 64088),
(64089, '1.10.1670.10-FF-000042', NULL, NULL, 84, NULL, NULL, 64089),
(64090, '1.10.472.10-FF-000633', NULL, 'Predicted protein', 120, NULL, NULL, 64090),
(64091, '3.60.20.10-FF-000222', NULL, NULL, 136, NULL, NULL, 64091),
(64092, '1.25.10.10-FF-000768', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 258, NULL, NULL, 64092),
(64093, '3.30.70.330-FF-000466', NULL, 'Heterogeneous nuclear ribonucleoprotein HRP1', 123, NULL, NULL, 64093),
(64094, '3.30.160.60-FF-002570', NULL, 'Molting defective, isoform F', 59, NULL, NULL, 64094),
(64095, '1.20.1280.290-FF-000107', NULL, 'Sugar transporter SemiSWEET', 97, NULL, NULL, 64095),
(64096, '1.25.10.10-FF-000824', NULL, 'Importin beta-3 family protein', 1064, NULL, NULL, 64096),
(64097, '1.20.1260.10-FF-000014', NULL, 'Bacterioferritin', 156, NULL, NULL, 64097),
(64098, '1.20.120.1880-FF-000009', NULL, 'Nuclear Pore complex Protein', 217, NULL, NULL, 64098),
(64099, '3.10.450.10-FF-000069', NULL, 'Uncharacterized protein', 89, NULL, NULL, 64099),
(64100, '3.20.20.100-FF-000013', NULL, 'NADPH-dependent codeinone reductase 1-1', 314, NULL, NULL, 64100),
(64101, '3.40.20.10-FF-000032', NULL, 'Drebrin 1', 134, NULL, NULL, 64101),
(64102, '3.40.50.1000-FF-000744', NULL, NULL, 85, NULL, NULL, 64102),
(64103, '3.30.70.870-FF-000044', NULL, 'Ribosome-releasing factor 2, mitochondrial', 50, NULL, NULL, 64103),
(64104, '1.25.10.10-FF-003202', NULL, 'Uncharacterized protein', 286, NULL, NULL, 64104),
(64105, '1.20.1070.10-FF-002124', NULL, 'Uncharacterized protein', 335, NULL, NULL, 64105),
(64106, '3.80.10.10-FF-001749', NULL, 'FBXL3 isoform 1', 189, NULL, NULL, 64106),
(64107, '3.50.80.10-FF-000013', NULL, 'Uncharacterized protein', 73, NULL, NULL, 64107),
(64108, '3.40.50.1000-FF-000688', NULL, NULL, 143, NULL, NULL, 64108),
(64109, '3.30.160.60-FF-004694', NULL, NULL, 36, NULL, NULL, 64109),
(64110, '1.25.40.10-FF-004811', NULL, 'Uncharacterized protein', 158, NULL, NULL, 64110),
(64111, '3.40.630.10-FF-000447', NULL, 'Uncharacterized protein', 177, NULL, NULL, 64111),
(64112, '3.50.4.10-FF-000029', NULL, 'Merozoite adhesive erythrocytic binding protein', 119, NULL, NULL, 64112),
(64113, '2.60.260.20-FF-000106', NULL, 'DnaJ heat shock protein family (Hsp40) member B1', 81, NULL, NULL, 64113),
(64114, '1.20.58.60-FF-000830', NULL, 'Uncharacterized protein', 169, NULL, NULL, 64114),
(64115, '2.10.25.10-FF-001761', NULL, 'Uncharacterized protein', 36, NULL, NULL, 64115),
(64116, '3.40.720.10-FF-000100', NULL, 'YhbX/YhjW/YijP/YjdB family protein', 287, NULL, NULL, 64116),
(64117, '3.40.50.300-FF-003149', NULL, 'Predicted protein', 203, NULL, NULL, 64117),
(64118, '3.30.559.10-FF-000165', NULL, 'Uncharacterized protein', 172, NULL, NULL, 64118),
(64119, '3.90.1150.10-FF-000460', NULL, 'Kynureninase', 123, NULL, NULL, 64119),
(64120, '3.40.50.2300-FF-001022', NULL, NULL, 111, NULL, NULL, 64120),
(64121, '3.40.640.10-FF-000419', NULL, 'Predicted protein', 56, NULL, NULL, 64121),
(64122, '1.20.920.10-FF-000111', NULL, 'Bromodomain-containing protein, 140kD, isoform A', 131, NULL, NULL, 64122),
(64123, '3.10.450.50-FF-000087', NULL, 'RNA-binding (RRM-RBD-RNP motif) domain nuclear transport factor 2 family protein', 126, NULL, NULL, 64123),
(64124, '3.60.70.12-FF-000003', NULL, 'Putative cysteine transferase', 350, NULL, NULL, 64124),
(64125, '3.40.50.300-FF-003003', NULL, 'Si:dkey-7i4.1', 230, NULL, NULL, 64125);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(64126, '2.30.42.10-FF-000018', NULL, 'SH3 and multiple ankyrin repeat domains protein 2', 109, NULL, NULL, 64126),
(64127, '3.40.50.12780-FF-000039', NULL, 'Peroxisomal-coenzyme A synthetase', 424, NULL, NULL, 64127),
(64128, '2.30.30.110-FF-000008', NULL, 'Endoribonuclease MazF3', 103, NULL, NULL, 64128),
(64129, '2.20.70.10-FF-000151', NULL, 'E3 ubiquitin-protein ligase', 28, NULL, NULL, 64129),
(64130, '3.60.10.10-FF-000250', NULL, 'Putative neutral sphingomyelinase', 264, NULL, NULL, 64130),
(64131, '1.20.1070.10-FF-000033', NULL, 'Vomeronasal type-1 receptor', 313, NULL, NULL, 64131),
(64132, '2.40.70.10-FF-000397', NULL, NULL, 181, NULL, NULL, 64132),
(64133, '1.20.1090.10-FF-000040', NULL, '3-dehydroquinate synthase', 187, NULL, NULL, 64133),
(64134, '1.20.1250.20-FF-000134', NULL, 'MFS sugar transporter protein', 459, NULL, NULL, 64134),
(64135, '1.10.8.10-FF-000132', NULL, 'RBR-type E3 ubiquitin transferase', 49, NULL, NULL, 64135),
(64136, '3.30.750.24-FF-000163', NULL, 'Sulfate transporter', 105, NULL, NULL, 64136),
(64137, '1.20.1420.30-FF-000061', NULL, 'Na+/Ca+ antiporter, CaCA family', 153, NULL, NULL, 64137),
(64138, '3.40.50.800-FF-000011', NULL, 'Proline--tRNA ligase', 110, NULL, NULL, 64138),
(64139, '1.20.58.60-FF-000353', NULL, 'VAB-10B protein', 107, NULL, NULL, 64139),
(64140, '1.20.80.10-FF-000075', NULL, 'Uncharacterized protein', 108, NULL, NULL, 64140),
(64141, '2.30.30.100-FF-000005', NULL, 'U6 snRNA-associated Sm-like protein LSm4', 83, NULL, NULL, 64141),
(64142, '3.30.40.10-FF-000551', NULL, 'RING-H2 finger protein ATL3', 84, NULL, NULL, 64142),
(64143, '2.130.10.10-FF-004599', NULL, 'Uncharacterized protein', 204, NULL, NULL, 64143),
(64144, '3.10.129.10-FF-000126', NULL, 'Itaconyl-CoA hydratase', 142, NULL, NULL, 64144),
(64145, '2.30.29.30-FF-000212', NULL, 'Dynamin-2A', 134, NULL, NULL, 64145),
(64146, '3.40.50.300-FF-006078', NULL, 'Uncharacterized protein', 117, NULL, NULL, 64146),
(64147, '3.30.450.20-FF-000231', NULL, 'PAS domain-containing sensor histidine kinase', 124, NULL, NULL, 64147),
(64148, '3.80.10.10-FF-004032', NULL, 'Uncharacterized protein', 144, NULL, NULL, 64148),
(64149, '3.40.190.10-FF-000637', NULL, 'LysR family transcriptional regulator', 100, NULL, NULL, 64149),
(64150, '3.30.160.60-FF-003435', NULL, 'AGAP007883-PA', 30, NULL, NULL, 64150),
(64151, '2.130.10.10-FF-003441', NULL, 'Predicted protein', 144, NULL, NULL, 64151),
(64152, '3.40.640.10-FF-000482', NULL, 'Uncharacterized protein', 66, NULL, NULL, 64152),
(64153, '3.40.50.720-FF-000285', NULL, 'Carbonyl reductase family member 4', 237, NULL, NULL, 64153),
(64154, '1.20.190.20-FF-000001', NULL, '14-3-3 gamma 1', 242, NULL, NULL, 64154),
(64155, '3.40.50.300-FF-007218', NULL, 'Uncharacterized protein', 164, NULL, NULL, 64155),
(64156, '3.30.40.10-FF-002203', NULL, 'Uncharacterized protein', 125, NULL, NULL, 64156),
(64157, '3.40.50.10740-FF-000001', NULL, 'Murein tetrapeptide carboxypeptidase', 150, NULL, NULL, 64157),
(64158, '2.130.10.10-FF-000861', NULL, 'WD repeat domain 45B', 165, NULL, NULL, 64158),
(64159, '3.40.50.720-FF-000341', NULL, 'very-long-chain 3-oxoacyl-CoA reductase 1', 230, NULL, NULL, 64159),
(64160, '2.130.10.110-FF-000020', NULL, 'Uncharacterized protein', 340, NULL, NULL, 64160),
(64161, '1.10.1040.10-FF-000011', NULL, 'putative oxidoreductase GLYR1 isoform X1', 123, NULL, NULL, 64161),
(64162, '3.30.1490.80-FF-000014', NULL, 'Glutathione synthetase', 91, NULL, NULL, 64162),
(64163, '2.60.120.10-FF-000739', NULL, 'Uncharacterized protein', 122, NULL, NULL, 64163),
(64164, '3.40.50.620-FF-000603', NULL, 'Isoleucine--tRNA ligase', 216, NULL, NULL, 64164),
(64165, '2.30.30.40-FF-000606', NULL, 'Uncharacterized protein', 55, NULL, NULL, 64165),
(64166, '3.40.50.300-FF-005392', NULL, 'ABC transporter G family member 16', 301, NULL, NULL, 64166),
(64167, '2.130.10.120-FF-000023', NULL, 'Predicted protein', 341, NULL, NULL, 64167),
(64168, '2.30.30.140-FF-000023', NULL, 'Hydrogenase assembly chaperone protein HypC', 59, NULL, NULL, 64168),
(64169, '3.30.160.60-FF-001344', NULL, 'Zinc finger protein 16 like', 29, NULL, NULL, 64169);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(64170, '1.25.40.10-FF-000596', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 90, NULL, NULL, 64170),
(64171, '3.40.47.10-FF-000268', NULL, NULL, 135, NULL, NULL, 64171),
(64172, '3.30.1490.70-FF-000011', NULL, 'LIG3 isoform 10', 25, NULL, NULL, 64172),
(64173, '3.90.70.10-FF-000628', NULL, 'Protein CBR-DUO-3', 127, NULL, NULL, 64173),
(64174, '1.10.150.240-FF-000059', NULL, 'Predicted phosphatase/phosphohexomutase', 73, NULL, NULL, 64174),
(64175, '1.25.40.20-FF-001088', NULL, 'Predicted protein', 255, NULL, NULL, 64175),
(64176, '3.40.50.300-FF-005622', NULL, 'Histone-lysine N-methyltransferase', 216, NULL, NULL, 64176),
(64177, '1.25.40.20-FF-000599', NULL, 'Expressed protein', 166, NULL, NULL, 64177),
(64178, '2.60.120.590-FF-000027', NULL, 'Alkylated DNA repair protein', 195, NULL, NULL, 64178),
(64179, '3.90.1150.10-FF-000308', NULL, 'Aspartate aminotransferase family protein', 133, NULL, NULL, 64179),
(64180, '1.10.287.380-FF-000010', NULL, 'Macrolide-transport ATP-binding protein ABC transporter', 77, NULL, NULL, 64180),
(64181, '2.130.10.10-FF-002952', NULL, 'Transducin family protein / WD-40 repeat family protein', 272, NULL, NULL, 64181),
(64182, '2.60.120.200-FF-000304', NULL, 'Metalloendopeptidase', 207, NULL, NULL, 64182),
(64183, '2.40.33.40-FF-000005', NULL, NULL, 120, NULL, NULL, 64183),
(64184, '3.40.50.300-FF-004779', NULL, 'DExH-box ATP-dependent RNA helicase DExH18 mitochondrial', 77, NULL, NULL, 64184),
(64185, '3.30.70.20-FF-000117', NULL, NULL, 66, NULL, NULL, 64185),
(64186, '3.30.40.10-FF-000056', NULL, 'Putative E3 ubiquitin-protein ligase NEURL1B', 61, NULL, NULL, 64186),
(64187, '3.40.532.10-FF-000017', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 226, NULL, NULL, 64187),
(64188, '3.30.40.10-FF-002147', NULL, 'Uncharacterized protein', 70, NULL, NULL, 64188),
(64189, '3.10.180.10-FF-000059', NULL, 'Glyoxalase-like domain-containing protein', 110, NULL, NULL, 64189),
(64190, '3.90.180.10-FF-000058', NULL, 'Alcohol dehydrogenase 2', 185, NULL, NULL, 64190),
(64191, '1.25.10.10-FF-002915', NULL, 'Uncharacterized protein', 116, NULL, NULL, 64191),
(64192, '3.40.50.720-FF-002432', NULL, 'Chromosome 1, whole genome shotgun sequence', 191, NULL, NULL, 64192),
(64193, '3.30.470.20-FF-000114', NULL, 'Putative RimK-like ATP-grasp domain protein', 219, NULL, NULL, 64193),
(64194, '3.30.160.60-FF-000855', NULL, 'CDKN1A interacting zinc finger protein 1', 50, NULL, NULL, 64194),
(64195, '1.20.5.1940-FF-000003', NULL, 'Hepatocyte growth factor-regulated tyrosine kinase substrate', 98, NULL, NULL, 64195),
(64196, '1.10.510.10-FF-004477', NULL, NULL, 258, NULL, NULL, 64196),
(64197, '1.25.10.10-FF-001134', NULL, 'Importin-13 homolog A', 984, NULL, NULL, 64197),
(64198, '4.10.60.10-FF-000236', NULL, 'Uncharacterized protein', 49, NULL, NULL, 64198),
(64199, '1.20.58.60-FF-000027', NULL, 'Microtubule-actin cross-linking factor 1', 119, NULL, NULL, 64199),
(64200, '2.60.40.10-FF-004565', NULL, NULL, 103, NULL, NULL, 64200),
(64201, '3.30.160.60-FF-005060', NULL, NULL, 31, NULL, NULL, 64201),
(64202, '4.10.60.10-FF-000146', NULL, 'Nucleic acid binding protein, putative', 38, NULL, NULL, 64202),
(64203, '1.10.510.10-FF-002297', NULL, NULL, 190, NULL, NULL, 64203),
(64204, '1.10.460.10-FF-000027', NULL, 'DNA topoisomerase', 166, NULL, NULL, 64204),
(64205, '3.90.260.10-FF-000059', NULL, 'Predicted protein', 298, NULL, NULL, 64205),
(64206, '3.40.50.1820-FF-001597', NULL, 'Predicted protein', 85, NULL, NULL, 64206),
(64207, '1.10.1410.10-FF-000085', NULL, 'Nucleolar protein 6', 143, NULL, NULL, 64207),
(64208, '3.40.30.10-FF-001106', NULL, 'Glutathione S-transferase family protein', 46, NULL, NULL, 64208),
(64209, '2.10.25.10-FF-001435', NULL, 'LP19846p', 48, NULL, NULL, 64209),
(64210, '3.30.160.60-FF-002946', NULL, NULL, 30, NULL, NULL, 64210),
(64211, '3.40.50.150-FF-001524', NULL, NULL, 105, NULL, NULL, 64211),
(64212, '3.40.50.300-FF-001351', NULL, 'Heat shock protein 101, putative', 193, NULL, NULL, 64212),
(64213, '2.60.40.10-FF-004475', NULL, NULL, 77, NULL, NULL, 64213);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(64214, '2.130.10.10-FF-006044', NULL, 'Uncharacterized protein', 228, NULL, NULL, 64214),
(64215, '3.60.150.10-FF-000001', NULL, 'Chorismate synthase', 361, NULL, NULL, 64215),
(64216, '1.10.472.10-FF-000689', NULL, 'Transcription initiation factor IIB (TFIIB)', 100, NULL, NULL, 64216),
(64217, '1.25.40.180-FF-000052', NULL, 'Nonsense-mediated mRNA decay factor', 239, NULL, NULL, 64217),
(64218, '2.40.10.10-FF-000388', NULL, NULL, 65, NULL, NULL, 64218),
(64219, '3.40.1170.60-FF-000004', NULL, 'DNA repair protein REV1', 55, NULL, NULL, 64219),
(64220, '2.70.150.10-FF-000166', NULL, 'Phospholipid-transporting ATPase', 135, NULL, NULL, 64220),
(64221, '3.40.50.300-FF-003531', NULL, 'Midasin', 224, NULL, NULL, 64221),
(64222, '1.10.10.2130-FF-000001', NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase', 44, NULL, NULL, 64222),
(64223, '2.60.40.10-FF-000883', NULL, 'tenascin-X', 93, NULL, NULL, 64223),
(64224, '3.90.70.80-FF-000071', NULL, 'Uncharacterized protein', 147, NULL, NULL, 64224),
(64225, '1.10.630.10-FF-000506', NULL, 'Uncharacterized protein', 431, NULL, NULL, 64225),
(64226, '1.10.10.10-FF-000616', NULL, 'Developmental regulator FlbA', 99, NULL, NULL, 64226),
(64227, '3.90.190.10-FF-000025', NULL, 'Tyrosine-protein phosphatase non-receptor type 1', 298, NULL, NULL, 64227),
(64228, '1.20.5.190-FF-000177', NULL, NULL, 40, NULL, NULL, 64228),
(64229, '1.10.10.60-FF-000996', NULL, NULL, 54, NULL, NULL, 64229),
(64230, '3.30.590.10-FF-000058', NULL, 'Uncharacterized protein', 81, NULL, NULL, 64230),
(64231, '3.30.1370.10-FF-000029', NULL, 'ankyrin repeat and KH domain-containing protein 1 isoform X2', 92, NULL, NULL, 64231),
(64232, '3.90.290.10-FF-000033', NULL, 'Follistatin-like protein', 97, NULL, NULL, 64232),
(64233, '1.20.120.1750-FF-000078', NULL, 'RBR-type E3 ubiquitin transferase', 73, NULL, NULL, 64233),
(64234, '3.80.10.10-FF-003992', NULL, 'Uncharacterized protein', 156, NULL, NULL, 64234),
(64235, '1.10.1900.40-FF-000002', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 74, NULL, NULL, 64235),
(64236, '3.30.260.10-FF-000016', NULL, 'McKusick-Kaufman syndrome', 115, NULL, NULL, 64236),
(64237, '3.90.190.20-FF-000028', NULL, 'Folylpolyglutamate synthase', 190, NULL, NULL, 64237),
(64238, '1.25.40.10-FF-005121', NULL, 'Uncharacterized protein', 112, NULL, NULL, 64238),
(64239, '1.10.530.10-FF-000089', NULL, 'Lysozyme g', 199, NULL, NULL, 64239),
(64240, '3.30.200.20-FF-002516', NULL, NULL, 109, NULL, NULL, 64240),
(64241, '1.10.510.10-FF-001190', NULL, 'Uncharacterized protein', 351, NULL, NULL, 64241),
(64242, '2.40.30.110-FF-000012', NULL, 'Aminomethyltransferase', 83, NULL, NULL, 64242),
(64243, '3.40.50.300-FF-001906', NULL, 'Uncharacterized protein', 128, NULL, NULL, 64243),
(64244, '3.10.100.10-FF-000313', NULL, NULL, 93, NULL, NULL, 64244),
(64245, '3.80.10.10-FF-003666', NULL, 'Predicted protein', 70, NULL, NULL, 64245),
(64246, '3.40.190.10-FF-000727', NULL, 'Glutamate receptor, ionotropic, AMPA 3a', 32, NULL, NULL, 64246),
(64247, '2.60.40.2030-FF-000038', NULL, 'Adhesion G-protein coupled receptor V1', 95, NULL, NULL, 64247),
(64248, '1.25.40.20-FF-000981', NULL, 'Uncharacterized protein', 239, NULL, NULL, 64248),
(64249, '1.20.1730.10-FF-000005', NULL, 'sodium/glucose cotransporter 1 isoform X1', 525, NULL, NULL, 64249),
(64250, '2.30.29.30-FF-001286', NULL, 'Histonearginine N-methyltransferase', 91, NULL, NULL, 64250),
(64251, '3.30.70.330-FF-002383', NULL, NULL, 161, NULL, NULL, 64251),
(64252, '1.25.40.470-FF-000015', NULL, 'Intraflagellar transport particle protein 140', 157, NULL, NULL, 64252),
(64253, '3.30.420.110-FF-000059', NULL, 'DNA mismatch repair protein MutS', 117, NULL, NULL, 64253),
(64254, '3.30.160.60-FF-000945', NULL, 'POZ-, AT hook-, and zinc finger-containing protein 1 isoform X3', 62, NULL, NULL, 64254),
(64255, '1.25.40.10-FF-000742', NULL, 'Tetratricopeptide repeat domain 37', 161, NULL, NULL, 64255),
(64256, '2.60.40.10-FF-001193', NULL, 'Jitterbug, isoform M', 96, NULL, NULL, 64256),
(64257, '1.10.10.10-FF-000588', NULL, 'Ribokinase', 50, NULL, NULL, 64257);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(64258, '3.40.640.10-FF-000392', NULL, 'Glutamic-oxaloacetic transaminase 1-like 1', 149, NULL, NULL, 64258),
(64259, '2.30.30.30-FF-000098', NULL, '50S ribosomal protein L24', 101, NULL, NULL, 64259),
(64260, '3.40.50.300-FF-008495', NULL, 'Uncharacterized protein', 62, NULL, NULL, 64260),
(64261, '3.40.50.720-FF-000431', NULL, 'SUMO-activating enzyme subunit', 142, NULL, NULL, 64261),
(64262, '1.20.58.900-FF-000024', NULL, 'Small G protein-signaling modulator 2', 147, NULL, NULL, 64262),
(64263, '1.10.720.180-FF-000002', NULL, 'Decaheme cytochrome c MtrF', 46, NULL, NULL, 64263),
(64264, '3.10.180.10-FF-000054', NULL, 'Catechol 2,3-dioxygenase', 136, NULL, NULL, 64264),
(64265, '2.130.10.10-FF-000709', NULL, 'U3 small nucleolar RNA-associated protein 7', 276, NULL, NULL, 64265),
(64266, '1.10.510.10-FF-000880', NULL, 'WEE protein kinase', 173, NULL, NULL, 64266),
(64267, '2.130.10.10-FF-004745', NULL, 'Uncharacterized protein', 161, NULL, NULL, 64267),
(64268, '3.30.710.10-FF-000124', NULL, 'Protein CBG09126', 158, NULL, NULL, 64268),
(64269, '1.20.960.20-FF-000004', NULL, 'Genome polyprotein', 65, NULL, NULL, 64269),
(64270, '3.40.50.2300-FF-000533', NULL, 'Chromosome 16 SCAF15113, whole genome shotgun sequence', 98, NULL, NULL, 64270),
(64271, '1.25.40.20-FF-000745', NULL, 'Uncharacterized protein', 162, NULL, NULL, 64271),
(64272, '3.40.50.300-FF-006696', NULL, 'Elongation factor EF-3', 80, NULL, NULL, 64272),
(64273, '3.40.50.1820-FF-000164', NULL, 'Mycophenolic acid acyl-glucuronide esterase, mitochondrial', 241, NULL, NULL, 64273),
(64274, '3.30.1430.10-FF-000001', NULL, '60S ribosomal protein L3', 124, NULL, NULL, 64274),
(64275, '3.40.50.2000-FF-000409', NULL, 'GDP-mannose-dependent alpha-(1-6)-phosphatidylinositol dimannoside mannosyltransferase', 158, NULL, NULL, 64275),
(64276, '1.10.418.10-FF-000047', NULL, 'Growth arrest specific 2 like 1', 147, NULL, NULL, 64276),
(64277, '3.40.50.300-FF-006881', NULL, 'ATP-binding cassette transporter, subfamily G, member 8, group WBC protein PpABCG8', 246, NULL, NULL, 64277),
(64278, '3.40.190.10-FF-000930', NULL, 'Predicted protein', 59, NULL, NULL, 64278),
(64279, '3.30.200.20-FF-001151', NULL, 'Glycogen Synthase Kinase Alpha subunit', 75, NULL, NULL, 64279),
(64280, '3.30.470.20-FF-000119', NULL, 'Carbamoyl-phosphate synthase L chain, ATP-binding', 466, NULL, NULL, 64280),
(64281, '3.30.160.60-FF-004924', NULL, NULL, 24, NULL, NULL, 64281),
(64282, '3.30.710.10-FF-000271', NULL, 'BTB-V protein domain', 120, NULL, NULL, 64282),
(64283, '3.90.660.10-FF-000140', NULL, NULL, 176, NULL, NULL, 64283),
(64284, '3.40.50.1100-FF-000095', NULL, 'serine racemase isoform X2', 200, NULL, NULL, 64284),
(64285, '1.20.1560.10-FF-000407', NULL, 'ABC transporter protein AtrC', 643, NULL, NULL, 64285),
(64286, '1.10.238.10-FF-000898', NULL, 'AGAP006116-PA', 139, NULL, NULL, 64286),
(64287, '2.40.37.20-FF-000019', NULL, NULL, 42, NULL, NULL, 64287),
(64288, '1.10.100.10-FF-000006', NULL, 'Probable insulin-like peptide beta-type 4', 50, NULL, NULL, 64288),
(64289, '3.30.1520.10-FF-000070', NULL, 'YPR097W-like protein', 161, NULL, NULL, 64289),
(64290, '3.10.100.10-FF-000369', NULL, NULL, 143, NULL, NULL, 64290),
(64291, '2.40.50.140-FF-000098', NULL, 'Transcription termination/antitermination protein NusA', 80, NULL, NULL, 64291),
(64292, '3.30.450.20-FF-000410', NULL, 'Histidine kinase', 124, NULL, NULL, 64292),
(64293, '3.30.420.40-FF-000892', NULL, 'Uncharacterized protein', 219, NULL, NULL, 64293),
(64294, '3.30.420.10-FF-000080', NULL, 'Small RNA degrading nuclease 3', 175, NULL, NULL, 64294),
(64295, '2.60.40.1400-FF-000006', NULL, 'G protein-activated inward rectifier potassium channel 1', 207, NULL, NULL, 64295),
(64296, '3.30.1560.10-FF-000005', NULL, 'Uncharacterized protein', 119, NULL, NULL, 64296),
(64297, '3.30.70.20-FF-000089', NULL, 'Indolepyruvate oxidoreductase subunit IorA', 75, NULL, NULL, 64297),
(64298, '3.30.750.60-FF-000001', NULL, 'Catalytic beta propeller domain of endosialidase', 72, NULL, NULL, 64298),
(64299, '3.30.1490.480-FF-000013', NULL, NULL, 69, NULL, NULL, 64299);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(64300, '3.40.50.410-FF-000310', NULL, 'Mesocentin', 134, NULL, NULL, 64300),
(64301, '1.20.1070.10-FF-001668', NULL, 'Uncharacterized protein', 125, NULL, NULL, 64301),
(64302, '1.25.40.10-FF-004665', NULL, 'Uncharacterized protein', 114, NULL, NULL, 64302),
(64303, '3.20.20.100-FF-000159', NULL, 'Uncharacterized protein', 242, NULL, NULL, 64303),
(64304, '2.40.70.10-FF-000543', NULL, NULL, 186, NULL, NULL, 64304),
(64305, '2.60.120.200-FF-000427', NULL, 'Laminin, alpha 5', 178, NULL, NULL, 64305),
(64306, '1.25.40.10-FF-004339', NULL, 'Pentatricopeptide repeat-containing protein', 164, NULL, NULL, 64306),
(64307, '2.10.25.10-FF-000305', NULL, 'Integrin beta', 44, NULL, NULL, 64307),
(64308, '3.30.160.60-FF-004868', NULL, NULL, 40, NULL, NULL, 64308),
(64309, '3.40.50.1100-FF-000010', NULL, 'Cystathionine beta-synthase', 185, NULL, NULL, 64309),
(64310, '1.25.10.10-FF-001460', NULL, 'Serine/threonine-protein kinase TOR', 169, NULL, NULL, 64310),
(64311, '3.30.40.10-FF-001984', NULL, 'Uncharacterized protein', 59, NULL, NULL, 64311),
(64312, '3.80.10.10-FF-001098', NULL, 'Leucine rich repeat and phosphatase domain containing protein', 129, NULL, NULL, 64312),
(64313, '3.30.420.10-FF-000170', NULL, 'Possible transposase', 171, NULL, NULL, 64313),
(64314, '1.20.144.10-FF-000015', NULL, 'Aureobasidin resistance protein Aur1', 87, NULL, NULL, 64314),
(64315, '1.10.1420.10-FF-000147', NULL, 'DNA mismatch repair protein msh3', 161, NULL, NULL, 64315),
(64316, '1.10.287.20-FF-000003', NULL, 'Cytochrome b-c1 complex subunit 6', 72, NULL, NULL, 64316),
(64317, '3.30.160.60-FF-005150', NULL, NULL, 35, NULL, NULL, 64317),
(64318, '1.25.10.10-FF-000914', NULL, 'Protein CBG03194', 624, NULL, NULL, 64318),
(64319, '3.40.718.10-FF-000005', NULL, 'Isocitrate dehydrogenase [NADP]', 416, NULL, NULL, 64319),
(64320, '1.20.58.760-FF-000016', NULL, 'Transmembrane protein', 152, NULL, NULL, 64320),
(64321, '2.40.160.210-FF-000027', NULL, 'Uncharacterized protein', 196, NULL, NULL, 64321),
(64322, '3.40.50.1110-FF-000013', NULL, 'Putative lipase/acylhydrolase', 235, NULL, NULL, 64322),
(64323, '2.30.29.30-FF-000353', NULL, 'Nuclear pore complex protein NUP50A', 182, NULL, NULL, 64323),
(64324, '1.10.220.10-FF-000009', NULL, 'Annexin', 75, NULL, NULL, 64324),
(64325, '1.20.1720.10-FF-000033', NULL, 'Multidrug transporter, putative', 228, NULL, NULL, 64325),
(64326, '1.10.533.10-FF-000096', NULL, 'Neurotrophin receptor associated death domain', 94, NULL, NULL, 64326),
(64327, '3.40.50.620-FF-000108', NULL, 'Ethanolamine-phosphate cytidylyltransferase isoform 2', 169, NULL, NULL, 64327),
(64328, '3.30.565.10-FF-000371', NULL, 'Sensory box histidine kinase/response regulator', 169, NULL, NULL, 64328),
(64329, '1.20.1310.10-FF-000193', NULL, NULL, 91, NULL, NULL, 64329),
(64330, '2.30.30.40-FF-000286', NULL, 'Uncharacterized protein, isoform D', 66, NULL, NULL, 64330),
(64331, '3.30.420.40-FF-000089', NULL, 'Actin, alpha skeletal muscle', 124, NULL, NULL, 64331),
(64332, '1.10.150.240-FF-000115', NULL, 'Uncharacterized protein', 68, NULL, NULL, 64332),
(64333, '1.10.150.240-FF-000087', NULL, 'Phosphoglycolate phosphatase', 75, NULL, NULL, 64333),
(64334, '3.90.830.10-FF-000024', NULL, 'Vacuolar protein sorting-associated protein 33', 121, NULL, NULL, 64334),
(64335, '3.40.50.920-FF-000047', NULL, 'Pyruvate ferredoxin oxidoreductase D', 148, NULL, NULL, 64335),
(64336, '1.20.1070.10-FF-000179', NULL, 'Probable G-protein coupled receptor 75', 338, NULL, NULL, 64336),
(64337, '3.20.20.100-FF-000215', NULL, 'Sorting nexin 2B', 71, NULL, NULL, 64337),
(64338, '1.20.960.10-FF-000001', NULL, 'Mitochondrial import receptor subunit TOM20 homolog', 95, NULL, NULL, 64338),
(64339, '2.40.420.20-FF-000011', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 93, NULL, NULL, 64339),
(64340, '1.10.10.60-FF-000991', NULL, NULL, 78, NULL, NULL, 64340),
(64341, '3.30.160.60-FF-000653', NULL, 'Zinc finger protein Pegasus', 29, NULL, NULL, 64341),
(64342, '1.25.40.10-FF-004957', NULL, 'Developmental protein DG1091', 164, NULL, NULL, 64342);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(64343, '3.40.50.11210-FF-000013', NULL, 'Rap/Ran GTPase activating protein, putative', 167, NULL, NULL, 64343),
(64344, '3.30.750.70-FF-000004', NULL, 'Acetyl-CoA hydrolase/transferase', 104, NULL, NULL, 64344),
(64345, '3.30.70.330-FF-002181', NULL, NULL, 78, NULL, NULL, 64345),
(64346, '3.30.497.10-FF-000178', NULL, 'Uncharacterized protein', 180, NULL, NULL, 64346),
(64347, '3.20.20.140-FF-000031', NULL, 'ribonuclease P protein subunit p30', 208, NULL, NULL, 64347),
(64348, '3.30.70.330-FF-001692', NULL, 'LD21345p', 170, NULL, NULL, 64348),
(64349, '3.30.160.60-FF-003109', NULL, NULL, 31, NULL, NULL, 64349),
(64350, '3.90.180.10-FF-000114', NULL, 'Uncharacterized protein', 178, NULL, NULL, 64350),
(64351, '1.20.1250.20-FF-002023', NULL, 'Uncharacterized protein', 357, NULL, NULL, 64351),
(64352, '3.90.226.10-FF-000036', NULL, 'p-hydroxycinnamoyl CoA hydratase/lyase', 211, NULL, NULL, 64352),
(64353, '3.90.70.10-FF-000831', NULL, 'Uncharacterized protein', 160, NULL, NULL, 64353),
(64354, '3.90.550.50-FF-000060', NULL, 'Hexosyltransferase', 228, NULL, NULL, 64354),
(64355, '3.40.50.1240-FF-000176', NULL, NULL, 200, NULL, NULL, 64355),
(64356, '3.80.10.10-FF-003576', NULL, 'Predicted protein', 142, NULL, NULL, 64356),
(64357, '3.40.50.360-FF-000036', NULL, 'NADPH--cytochrome P450 reductase', 177, NULL, NULL, 64357),
(64358, '3.40.50.720-FF-002229', NULL, 'Uncharacterized protein', 101, NULL, NULL, 64358),
(64359, '1.10.510.10-FF-000728', NULL, 'Serine/threonine protein kinase, putative', 192, NULL, NULL, 64359),
(64360, '3.10.250.10-FF-000088', NULL, NULL, 98, NULL, NULL, 64360),
(64361, '4.10.400.10-FF-000259', NULL, 'LDL receptor protein 1, isoform F', 40, NULL, NULL, 64361),
(64362, '1.25.10.10-FF-002393', NULL, 'Uncharacterized protein', 260, NULL, NULL, 64362),
(64363, '3.30.160.20-FF-000130', NULL, 'Endoribonuclease Dicer-like 2 isoform B', 79, NULL, NULL, 64363),
(64364, '1.25.40.20-FF-000655', NULL, 'GM18187', 52, NULL, NULL, 64364),
(64365, '3.10.10.10-FF-000038', NULL, NULL, 12, NULL, NULL, 64365),
(64366, '3.20.20.220-FF-000049', NULL, 'Proline dehydrogenase', 326, NULL, NULL, 64366),
(64367, '2.60.40.2170-FF-000001', NULL, 'WNT inhibitory factor 1', 151, NULL, NULL, 64367),
(64368, '3.90.70.10-FF-000775', NULL, 'Predicted protein', 51, NULL, NULL, 64368),
(64369, '3.40.190.180-FF-000001', NULL, 'High affinity transport system protein p37', 161, NULL, NULL, 64369),
(64370, '3.90.1150.10-FF-000073', NULL, 'Cystathionine gamma-synthase', 118, NULL, NULL, 64370),
(64371, '3.20.20.150-FF-000034', NULL, 'Protein arginine N-methyltransferase', 249, NULL, NULL, 64371),
(64372, '3.40.50.620-FF-000081', NULL, 'Asparagine synthetase (Glutamine-hydrolyzing)', 287, NULL, NULL, 64372),
(64373, '3.30.2230.10-FF-000020', NULL, 'Probable ubiquitin carboxyl-terminal hydrolase 1', 127, NULL, NULL, 64373),
(64374, '1.10.357.10-FF-000085', NULL, 'TetR family transcriptional regulatory protein', 202, NULL, NULL, 64374),
(64375, '2.130.10.10-FF-004127', NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', 377, NULL, NULL, 64375),
(64376, '3.40.50.300-FF-002986', NULL, 'AAA family ATPase, putative', 181, NULL, NULL, 64376),
(64377, '1.25.40.20-FF-001291', NULL, 'Uncharacterized protein', 168, NULL, NULL, 64377),
(64378, '3.40.190.10-FF-000109', NULL, 'Glutamate receptor', 36, NULL, NULL, 64378),
(64379, '1.10.10.10-FF-000498', NULL, 'Telomere repeat-binding factor 1', 82, NULL, NULL, 64379),
(64380, '3.40.50.10440-FF-000006', NULL, 'Uncharacterized protein', 119, NULL, NULL, 64380),
(64381, '1.10.238.10-FF-001264', NULL, 'Uncharacterized protein', 57, NULL, NULL, 64381),
(64382, '2.60.40.150-FF-000549', NULL, 'Phosphoinositide phospholipase C', 59, NULL, NULL, 64382),
(64383, '3.40.390.10-FF-000265', NULL, NULL, 177, NULL, NULL, 64383),
(64384, '1.10.8.60-FF-000012', NULL, 'Replication factor C subunit 4', 64, NULL, NULL, 64384),
(64385, '1.10.238.10-FF-000775', NULL, 'Calcium-binding EF hand family protein', 78, NULL, NULL, 64385),
(64386, '2.30.30.110-FF-000003', NULL, 'mRNA interferase', 114, NULL, NULL, 64386);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(64387, '2.130.10.10-FF-003025', NULL, 'WD40-repeat-containing domain protein', 162, NULL, NULL, 64387),
(64388, '3.50.7.10-FF-000036', NULL, NULL, 19, NULL, NULL, 64388),
(64389, '1.10.510.10-FF-001217', NULL, 'Mitogen-activated protein kinase', 68, NULL, NULL, 64389),
(64390, '1.10.1370.10-FF-000002', NULL, 'Oligopeptidase A', 371, NULL, NULL, 64390),
(64391, '3.80.10.10-FF-002115', NULL, 'Uncharacterized protein', 222, NULL, NULL, 64391),
(64392, '2.130.10.10-FF-000384', NULL, 'WD repeat containing, antisense to TP73', 111, NULL, NULL, 64392),
(64393, '3.30.460.10-FF-000200', NULL, 'Predicted protein', 90, NULL, NULL, 64393),
(64394, '3.40.50.1980-FF-000077', NULL, 'Probable FeIII-dicitrate-binding periplasmic lipoprotein fecB', 104, NULL, NULL, 64394),
(64395, '1.10.10.60-FF-000373', NULL, 'Blast:Brain-specific homeobox protein', 81, NULL, NULL, 64395),
(64396, '3.30.160.60-FF-003261', NULL, 'Zinc finger protein 860', 34, NULL, NULL, 64396),
(64397, '3.30.565.10-FF-000404', NULL, 'Sensor protein', 152, NULL, NULL, 64397),
(64398, '3.30.40.10-FF-002350', NULL, 'Peroxisome biogenesis factor 10-like Protein', 152, NULL, NULL, 64398),
(64399, '3.40.50.720-FF-000515', NULL, 'Ubiquitin-activating enzyme E1', 240, NULL, NULL, 64399),
(64400, '2.60.40.10-FF-002497', NULL, 'Beat-VII', 99, NULL, NULL, 64400),
(64401, '2.10.25.10-FF-000131', NULL, 'Fibrillin 2', 42, NULL, NULL, 64401),
(64402, '1.20.58.1070-FF-000023', NULL, 'Uncharacterized protein', 178, NULL, NULL, 64402),
(64403, '2.40.70.10-FF-000487', NULL, NULL, 138, NULL, NULL, 64403),
(64404, '1.10.132.60-FF-000050', NULL, 'DNA polymerase', 164, NULL, NULL, 64404),
(64405, '1.10.400.10-FF-000046', NULL, 'Guanine nucleotide-binding protein G(O) subunit alpha', 120, NULL, NULL, 64405),
(64406, '2.40.70.10-FF-000217', NULL, 'Chromosome 16, whole genome shotgun sequence', 137, NULL, NULL, 64406),
(64407, '3.40.50.10140-FF-000040', NULL, 'Uncharacterized protein', 148, NULL, NULL, 64407),
(64408, '3.30.1360.120-FF-000057', NULL, 'Uncharacterized protein', 312, NULL, NULL, 64408),
(64409, '3.60.130.10-FF-000062', NULL, 'Predicted protein', 266, NULL, NULL, 64409),
(64410, '3.40.50.1760-FF-000011', NULL, NULL, 135, NULL, NULL, 64410),
(64411, '3.40.50.1780-FF-000017', NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', 128, NULL, NULL, 64411),
(64412, '3.40.50.300-FF-002839', NULL, 'p-glycoprotein 6, putative', 195, NULL, NULL, 64412),
(64413, '1.20.80.10-FF-000070', NULL, 'E3 ubiquitin-protein ligase MYLIP', 112, NULL, NULL, 64413),
(64414, '3.80.10.10-FF-002205', NULL, 'NLR family CARD domain-containing 6', 187, NULL, NULL, 64414),
(64415, '1.10.287.70-FF-000411', NULL, 'TWiK family of potassium channels', 323, NULL, NULL, 64415),
(64416, '1.10.287.110-FF-000446', NULL, 'Uncharacterized protein', 65, NULL, NULL, 64416),
(64417, '3.40.50.300-FF-003475', NULL, 'Predicted protein', 187, NULL, NULL, 64417),
(64418, '3.10.100.10-FF-000285', NULL, NULL, 78, NULL, NULL, 64418),
(64419, '3.30.70.3460-FF-000001', NULL, 'Heme d1 biosynthesis protein NirG', 83, NULL, NULL, 64419),
(64420, '1.25.40.20-FF-001144', NULL, 'Serine/threonine protein kinase', 149, NULL, NULL, 64420),
(64421, '3.30.470.160-FF-000016', NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta mitochondrial', 84, NULL, NULL, 64421),
(64422, '2.60.40.10-FF-002676', NULL, 'Receptor-type tyrosine-protein phosphatase dep-1', 111, NULL, NULL, 64422),
(64423, '3.30.200.20-FF-000044', NULL, 'Receptor protein-tyrosine kinase', 97, NULL, NULL, 64423),
(64424, '1.10.238.10-FF-000954', NULL, 'EF-hand domain-containing protein', 60, NULL, NULL, 64424),
(64425, '1.10.800.10-FF-000014', NULL, 'Tyrosine/tryptophan monooxygenase, putative', 120, NULL, NULL, 64425),
(64426, '3.40.50.300-FF-007191', NULL, 'Uncharacterized protein', 169, NULL, NULL, 64426),
(64427, '2.120.10.80-FF-000118', NULL, 'F-box/kelch-repeat protein At1g55270', 279, NULL, NULL, 64427),
(64428, '3.30.46.10-FF-000007', NULL, 'Uncharacterized protein', 16, NULL, NULL, 64428),
(64429, '1.25.40.80-FF-000010', NULL, 'Phr1p', 127, NULL, NULL, 64429);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(64430, '4.10.800.10-FF-000014', NULL, 'Thyroglobulin', 61, NULL, NULL, 64430),
(64431, '2.40.30.10-FF-000097', NULL, 'Ribosomal protein', 24, NULL, NULL, 64431),
(64432, '3.40.50.2000-FF-000033', NULL, '2-hydroxyacylsphingosine 1-beta-galactosyltransferase', 250, NULL, NULL, 64432),
(64433, '2.130.10.10-FF-003115', NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', 270, NULL, NULL, 64433),
(64434, '1.10.8.540-FF-000003', NULL, 'Flagellar biosynthesis protein FlhA', 94, NULL, NULL, 64434),
(64435, '3.40.140.10-FF-000163', NULL, 'Apolipoprotein B mRNA editing enzyme catalytic subunit 3B', 60, NULL, NULL, 64435),
(64436, '1.20.1070.10-FF-001758', NULL, 'Beta-1 adrenergic receptor', 73, NULL, NULL, 64436),
(64437, '2.60.40.10-FF-003019', NULL, 'B6.2', 100, NULL, NULL, 64437),
(64438, '1.25.40.90-FF-000013', NULL, 'U2 snRNP-associated SURP motif-containing protein isoform X1', 140, NULL, NULL, 64438),
(64439, '4.10.800.20-FF-000017', NULL, 'ADR119Wp', 40, NULL, NULL, 64439),
(64440, '2.60.40.1120-FF-000046', NULL, 'Carboxypeptidase A', 82, NULL, NULL, 64440),
(64441, '3.30.160.60-FF-005234', NULL, NULL, 48, NULL, NULL, 64441),
(64442, '1.10.486.10-FF-000013', NULL, 'ATP-dependent DNA helicase Rep', 169, NULL, NULL, 64442),
(64443, '3.40.50.300-FF-005420', NULL, 'Atlastin-2', 64, NULL, NULL, 64443),
(64444, '3.75.10.10-FF-000014', NULL, 'N-dimethylarginine dimethylaminohydrolase', 247, NULL, NULL, 64444),
(64445, '3.40.50.300-FF-003823', NULL, 'SNF2 family helicase, putative', 203, NULL, NULL, 64445),
(64446, '1.25.40.10-FF-000652', NULL, 'Bacterial transcriptional activator domain protein', 155, NULL, NULL, 64446),
(64447, '3.90.79.10-FF-000295', NULL, 'Adenine DNA glycosylase', 130, NULL, NULL, 64447),
(64448, '3.30.1490.190-FF-000011', NULL, 'Fur family transcriptional regulator', 59, NULL, NULL, 64448),
(64449, '3.30.830.10-FF-000066', NULL, 'Putative zinc protease mug138', 236, NULL, NULL, 64449),
(64450, '2.60.120.10-FF-000071', NULL, 'XRE family transcriptional regulator', 95, NULL, NULL, 64450),
(64451, '1.20.1250.20-FF-000281', NULL, 'MFS transporter', 194, NULL, NULL, 64451),
(64452, '3.40.570.10-FF-000009', NULL, 'Endonuclease domain containing 1', 236, NULL, NULL, 64452),
(64453, '3.40.50.10140-FF-000001', NULL, 'Toll-like receptor 2', 155, NULL, NULL, 64453),
(64454, '3.10.600.10-FF-000008', NULL, 'Pyruvate carboxylase b', 39, NULL, NULL, 64454),
(64455, '1.25.40.10-FF-003322', NULL, 'Pentatricopeptide repeat-containing protein At5g16860', 103, NULL, NULL, 64455),
(64456, '3.40.50.300-FF-005004', NULL, 'Uncharacterized protein', 153, NULL, NULL, 64456),
(64457, '3.40.50.720-FF-000195', NULL, 'Glyoxylate reductase/hydroxypyruvate reductase b', 123, NULL, NULL, 64457),
(64458, '3.30.730.10-FF-000007', NULL, 'ethylene-responsive transcription factor-like protein At4g13040', 52, NULL, NULL, 64458),
(64459, '3.40.190.10-FF-000553', NULL, 'DNA-binding transcriptional activator GcvA', 93, NULL, NULL, 64459),
(64460, '3.20.20.190-FF-000023', NULL, 'Glycerophosphodiester phosphodiesterase GDPD5', 320, NULL, NULL, 64460),
(64461, '2.60.40.60-FF-000757', NULL, 'Uncharacterized protein', 107, NULL, NULL, 64461),
(64462, '2.130.10.10-FF-004571', NULL, 'Uncharacterized protein', 211, NULL, NULL, 64462),
(64463, '2.60.40.10-FF-003986', NULL, NULL, 129, NULL, NULL, 64463),
(64464, '3.30.60.20-FF-000061', NULL, 'Kinase suppressor of Ras', 50, NULL, NULL, 64464),
(64465, '1.10.8.1220-FF-000003', NULL, 'Dynein cytoplasmic 2 heavy chain 1', 89, NULL, NULL, 64465),
(64466, '2.60.470.10-FF-000001', NULL, 'Acid-sensing (proton-gated) ion channel family member 4a', 171, NULL, NULL, 64466),
(64467, '3.40.50.300-FF-002840', NULL, 'Pre-mRNA splicing factor ATP-dependent RNA helicase, putative', 189, NULL, NULL, 64467),
(64468, '3.30.200.20-FF-000370', NULL, 'Receptor-like protein kinase 4', 107, NULL, NULL, 64468),
(64469, '2.30.30.100-FF-000146', NULL, 'SnRNP Sm-like protein, putative', 77, NULL, NULL, 64469),
(64470, '2.60.490.10-FF-000002', NULL, 'P2X purinoceptor', 274, NULL, NULL, 64470);
INSERT INTO "PUBLIC"."MODEL" VALUES
(64471, '3.40.50.150-FF-000827', NULL, 'Magnesium-protoporphyrin O-methyltransferase', 221, NULL, NULL, 64471),
(64472, '2.30.30.40-FF-000516', NULL, 'zinc finger protein (ZZ-type)-2 isoform X1', 88, NULL, NULL, 64472),
(64473, '3.50.50.60-FF-000560', NULL, 'Opine oxidase subunit B', 199, NULL, NULL, 64473),
(64474, '2.130.10.10-FF-001401', NULL, 'Dug2p', 148, NULL, NULL, 64474),
(64475, '2.40.340.10-FF-000002', NULL, 'Molybdopterin molybdenumtransferase', 70, NULL, NULL, 64475),
(64476, '1.25.10.10-FF-002680', NULL, 'Uncharacterized protein', 82, NULL, NULL, 64476),
(64477, '3.30.710.10-FF-000501', NULL, 'Predicted protein', 120, NULL, NULL, 64477),
(64478, '2.60.40.10-FF-001423', NULL, 'Ig heavy chain V region 5-84', 118, NULL, NULL, 64478),
(64479, '1.25.40.10-FF-001231', NULL, 'Pentatricopeptide repeat-containing protein ELI1, chloroplastic', 112, NULL, NULL, 64479),
(64480, '3.40.50.2000-FF-000235', NULL, 'Lipopolysaccharide core biosynthesis protein', 152, NULL, NULL, 64480),
(64481, '3.30.70.240-FF-000029', NULL, 'CRISPR-associated endoribonuclease Cas2', 77, NULL, NULL, 64481),
(64482, '3.40.50.300-FF-004925', NULL, 'Predicted protein', 316, NULL, NULL, 64482),
(64483, '1.10.150.240-FF-000031', NULL, 'HAD hydrolase, family IA, variant 3', 72, NULL, NULL, 64483),
(64484, '3.80.10.10-FF-002031', NULL, 'Leucine-rich repeat protein (LRRP), putative', 101, NULL, NULL, 64484),
(64485, '2.30.29.30-FF-000066', NULL, 'FERM and PDZ domain-containing protein 4', 106, NULL, NULL, 64485),
(64486, '2.160.10.10-FF-000079', NULL, 'Nucleotidyl transferase', 188, NULL, NULL, 64486),
(64487, '1.20.142.10-FF-000033', NULL, 'Poly [ADP-ribose] polymerase tankyrase', 153, NULL, NULL, 64487),
(64488, '3.30.200.20-FF-002129', NULL, NULL, 72, NULL, NULL, 64488),
(64489, '1.10.510.10-FF-003460', NULL, NULL, 274, NULL, NULL, 64489),
(64490, '3.40.190.10-FF-000082', NULL, 'ATP phosphoribosyltransferase', 115, NULL, NULL, 64490),
(64491, '1.20.1250.20-FF-001860', NULL, 'Uncharacterized protein', 123, NULL, NULL, 64491),
(64492, '1.25.10.10-FF-000678', NULL, 'RING-type E3 ubiquitin transferase', 134, NULL, NULL, 64492),
(64493, '3.40.50.720-FF-001774', NULL, 'Ketopantoate reductase PanE/ApbA-domain-containing protein', 195, NULL, NULL, 64493),
(64494, '3.90.45.10-FF-000031', NULL, 'Peptide deformylase', 201, NULL, NULL, 64494),
(64495, '2.60.200.20-FF-000075', NULL, 'Kinesin-like protein', 135, NULL, NULL, 64495),
(64496, '1.10.287.130-FF-000132', NULL, 'Sensory transduction histidine kinase', 78, NULL, NULL, 64496),
(64497, '3.40.1190.20-FF-000016', NULL, 'Sulfofructose kinase', 296, NULL, NULL, 64497),
(64498, '3.30.70.330-FF-000758', NULL, 'CUGBP Elav-like family member 1', 169, NULL, NULL, 64498),
(64499, '3.30.50.10-FF-000175', NULL, 'Uncharacterized protein', 66, NULL, NULL, 64499),
(64500, '2.30.29.30-FF-000027', NULL, 'Non-specific serine/threonine protein kinase', 120, NULL, NULL, 64500),
(64501, '3.40.50.150-FF-000884', NULL, 'tRNA (Uracil-5-)-methyltransferase, putative', 224, NULL, NULL, 64501),
(64502, '1.25.40.10-FF-005031', NULL, 'Uncharacterized protein', 150, NULL, NULL, 64502),
(64503, '3.40.1170.10-FF-000012', NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', 139, NULL, NULL, 64503),
(64504, '2.80.10.50-FF-000286', NULL, 'Uncharacterized protein', 173, NULL, NULL, 64504),
(64505, '3.30.70.330-FF-002416', NULL, NULL, 92, NULL, NULL, 64505),
(64506, '3.90.1150.10-FF-000218', NULL, 'Ornithine--oxo-acid transaminase', 127, NULL, NULL, 64506),
(64507, '2.170.270.10-FF-000128', NULL, 'SMYD family member 5', 107, NULL, NULL, 64507),
(64508, '3.40.1190.10-FF-000013', NULL, 'UDP-N-acetylmuramoyl-L-alanyl-D-glutamate--2,6-diaminopimelate ligase', 240, NULL, NULL, 64508),
(64509, '3.30.200.20-FF-002461', NULL, 'Myosin, light chain kinase 5', 54, NULL, NULL, 64509),
(64510, '2.10.25.10-FF-000041', NULL, 'matrilin-2 isoform X1', 41, NULL, NULL, 64510),
(64511, '3.50.50.60-FF-000447', NULL, 'Guanosine nucleotide diphosphate dissociation inhibitor', 42, NULL, NULL, 64511),
(64512, '1.10.510.10-FF-001223', NULL, 'Predicted protein', 198, NULL, NULL, 64512);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(64513, '1.25.40.20-FF-001234', NULL, 'Uncharacterized protein', 260, NULL, NULL, 64513),
(64514, '3.60.40.10-FF-000313', NULL, 'Uncharacterized protein', 234, NULL, NULL, 64514),
(64515, '1.20.1250.20-FF-000426', NULL, 'Sugar baby, isoform C', 203, NULL, NULL, 64515),
(64516, '3.40.50.300-FF-001261', NULL, 'ABC transporter ATP-binding protein', 239, NULL, NULL, 64516),
(64517, '3.50.50.60-FF-000503', NULL, 'Putative malatequinone oxidoreductase protein', 196, NULL, NULL, 64517),
(64518, '1.25.10.10-FF-000971', NULL, 'Protein CELLULOSE SYNTHASE INTERACTIVE 1', 328, NULL, NULL, 64518),
(64519, '3.10.310.10-FF-000054', NULL, 'Trans-L-3-hydroxyproline dehydratase', 154, NULL, NULL, 64519),
(64520, '1.25.40.10-FF-004249', NULL, 'Uncharacterized protein', 234, NULL, NULL, 64520),
(64521, '2.10.70.20-FF-000002', NULL, 'General secretion pathway protein J', 57, NULL, NULL, 64521),
(64522, '3.10.20.90-FF-000664', NULL, 'Uncharacterized protein', 81, NULL, NULL, 64522),
(64523, '2.40.50.140-FF-001025', NULL, NULL, 42, NULL, NULL, 64523),
(64524, '3.40.30.10-FF-000943', NULL, 'Peroxiredoxin', 110, NULL, NULL, 64524),
(64525, '3.40.50.300-FF-001204', NULL, 'Small GTP-binding protein, putative', 192, NULL, NULL, 64525),
(64526, '3.30.70.20-FF-000090', NULL, NULL, 58, NULL, NULL, 64526),
(64527, '1.10.150.20-FF-000310', NULL, 'DNA topoisomerase 1', 54, NULL, NULL, 64527),
(64528, '3.30.160.60-FF-006493', NULL, NULL, 61, NULL, NULL, 64528),
(64529, '3.90.550.10-FF-000632', NULL, 'Predicted protein', 186, NULL, NULL, 64529),
(64530, '1.10.510.10-FF-000436', NULL, 'NIMA related kinase 11', 202, NULL, NULL, 64530),
(64531, '3.90.1150.10-FF-000275', NULL, 'kynurenine--oxoglutarate transaminase 1', 73, NULL, NULL, 64531),
(64532, '3.80.10.10-FF-001952', NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3', 90, NULL, NULL, 64532),
(64533, '3.100.10.10-FF-000004', NULL, '50S ribosomal protein L15', 81, NULL, NULL, 64533),
(64534, '3.40.50.10860-FF-000071', NULL, 'Uncharacterized protein', 79, NULL, NULL, 64534),
(64535, '2.40.280.10-FF-000002', NULL, 'SsrA-binding protein', 127, NULL, NULL, 64535),
(64536, '2.70.170.10-FF-000257', NULL, 'Protein CBG01602', 181, NULL, NULL, 64536),
(64537, '3.40.630.30-FF-000695', NULL, 'Uncharacterized protein', 48, NULL, NULL, 64537),
(64538, '3.40.50.1000-FF-000396', NULL, 'GH10306p', 143, NULL, NULL, 64538),
(64539, '1.10.287.130-FF-000019', NULL, 'Sensor histidine kinase RcsC', 87, NULL, NULL, 64539),
(64540, '3.40.50.300-FF-004638', NULL, 'DNA helicase', 205, NULL, NULL, 64540),
(64541, '3.40.50.10310-FF-000018', NULL, 'Creatininase', 229, NULL, NULL, 64541),
(64542, '1.25.10.10-FF-002387', NULL, 'Sister chromatid cohesion protein PDS5 homolog B-like Protein', 266, NULL, NULL, 64542),
(64543, '3.30.710.10-FF-000208', NULL, 'Ethylene-overproduction protein 1', 148, NULL, NULL, 64543),
(64544, '2.130.10.10-FF-004419', NULL, 'Predicted protein', 366, NULL, NULL, 64544),
(64545, '3.40.50.1820-FF-001474', NULL, 'Uncharacterized protein', 174, NULL, NULL, 64545),
(64546, '3.30.56.10-FF-000036', NULL, 'Uncharacterized protein', 72, NULL, NULL, 64546),
(64547, '2.60.120.340-FF-000003', NULL, 'Nucleoplasmin 2', 123, NULL, NULL, 64547),
(64548, '2.60.40.60-FF-001123', NULL, 'Predicted protein', 43, NULL, NULL, 64548),
(64549, '3.30.420.390-FF-000007', NULL, 'DNA polymerase gamma', 188, NULL, NULL, 64549),
(64550, '1.20.5.370-FF-000023', NULL, NULL, 90, NULL, NULL, 64550),
(64551, '4.10.1240.30-FF-000002', NULL, 'Integrin beta', 87, NULL, NULL, 64551),
(64552, '1.10.238.10-FF-001090', NULL, 'Uncharacterized protein', 178, NULL, NULL, 64552),
(64553, '3.30.160.60-FF-004363', NULL, NULL, 81, NULL, NULL, 64553),
(64554, '1.10.238.10-FF-000628', NULL, 'Serine/threonine-protein phosphatase 2A regulatory subunit B'''' subunit beta', 169, NULL, NULL, 64554),
(64555, '1.20.58.60-FF-000206', NULL, 'Uncharacterized protein, isoform C', 108, NULL, NULL, 64555),
(64556, '1.20.1250.20-FF-002079', NULL, 'Uncharacterized protein', 272, NULL, NULL, 64556),
(64557, '3.30.200.20-FF-000572', NULL, 'Interleukin-1 receptor-associated kinase', 103, NULL, NULL, 64557);
INSERT INTO "PUBLIC"."MODEL" VALUES
(64558, '2.130.10.30-FF-000103', NULL, NULL, 201, NULL, NULL, 64558),
(64559, '2.60.210.10-FF-000044', NULL, NULL, 144, NULL, NULL, 64559),
(64560, '3.30.160.60-FF-001108', NULL, 'GLI family zinc finger 4', 27, NULL, NULL, 64560),
(64561, '1.10.287.70-FF-000698', NULL, 'Uncharacterized protein', 134, NULL, NULL, 64561),
(64562, '3.30.540.10-FF-000055', NULL, 'WGS project CABT00000000 data, contig 2.2', 186, NULL, NULL, 64562),
(64563, '1.25.40.10-FF-004626', NULL, 'Predicted protein', 130, NULL, NULL, 64563),
(64564, '3.40.30.10-FF-001073', NULL, 'Predicted protein', 151, NULL, NULL, 64564),
(64565, '1.25.10.10-FF-002567', NULL, 'DNA repair/transcription protein met18/mms19, putative', 168, NULL, NULL, 64565),
(64566, '3.30.1510.10-FF-000002', NULL, 'C-1-tetrahydrofolate synthase, cytoplasmic', 106, NULL, NULL, 64566),
(64567, '1.20.1070.10-FF-001489', NULL, 'Uncharacterized protein', 202, NULL, NULL, 64567),
(64568, '2.60.120.260-FF-000277', NULL, 'Arabinogalactan endo-beta-1,4-galactanase', 151, NULL, NULL, 64568),
(64569, '3.40.50.1910-FF-000039', NULL, 'Syntaxin-binding protein 2', 32, NULL, NULL, 64569),
(64570, '3.30.200.20-FF-002168', NULL, 'Serine/threonine protein kinase domain protein', 63, NULL, NULL, 64570),
(64571, '1.10.510.10-FF-001043', NULL, 'YMR291W-like protein', 390, NULL, NULL, 64571),
(64572, '1.10.10.60-FF-000665', NULL, 'Myb domain protein 101', 70, NULL, NULL, 64572),
(64573, '2.130.10.10-FF-000619', NULL, 'U3 snoRNA-associated small subunit rRNA processing protein, putative', 124, NULL, NULL, 64573),
(64574, '1.20.120.350-FF-000185', NULL, NULL, 123, NULL, NULL, 64574),
(64575, '3.30.70.330-FF-002703', NULL, NULL, 164, NULL, NULL, 64575),
(64576, '3.30.420.40-FF-000358', NULL, 'Acetate kinase', 203, NULL, NULL, 64576),
(64577, '2.130.10.10-FF-002328', NULL, 'Flagellar outer dynein arm intermediate chain 2', 146, NULL, NULL, 64577),
(64578, '2.60.40.10-FF-003132', NULL, 'Usher syndrome 2A (autosomal recessive, mild)', 117, NULL, NULL, 64578),
(64579, '3.40.50.300-FF-003059', NULL, 'GTP-binding nuclear protein', 225, NULL, NULL, 64579),
(64580, '1.20.920.30-FF-000066', NULL, 'Dynein heavy chain 3', 112, NULL, NULL, 64580),
(64581, '2.40.50.140-FF-000244', NULL, 'Single-stranded DNA-binding protein', 145, NULL, NULL, 64581),
(64582, '1.20.140.150-FF-000078', NULL, 'Potential membrane protein', 187, NULL, NULL, 64582),
(64583, '3.30.70.1230-FF-000001', NULL, 'Adenylate cyclase', 206, NULL, NULL, 64583),
(64584, '3.60.15.10-FF-000148', NULL, 'Beta-lactamase', 227, NULL, NULL, 64584),
(64585, '2.40.260.10-FF-000001', NULL, 'Class A sortase SrtA', 145, NULL, NULL, 64585),
(64586, '3.40.50.2300-FF-000443', NULL, 'Glutamate ionotropic receptor NMDA type subunit 1', 95, NULL, NULL, 64586),
(64587, '2.130.10.10-FF-000676', NULL, 'Sortilin', 149, NULL, NULL, 64587),
(64588, '3.40.50.1000-FF-000598', NULL, NULL, 135, NULL, NULL, 64588),
(64589, '3.40.50.620-FF-000255', NULL, 'Probable nicotinate-nucleotide adenylyltransferase', 199, NULL, NULL, 64589),
(64590, '1.20.1250.20-FF-000224', NULL, 'MFS transporter, putative', 454, NULL, NULL, 64590),
(64591, '3.30.559.10-FF-000255', NULL, 'Chromosome 19, whole genome shotgun sequence', 25, NULL, NULL, 64591),
(64592, '3.10.20.10-FF-000011', NULL, '60S ribosomal protein L18a', 43, NULL, NULL, 64592),
(64593, '1.20.1250.20-FF-002315', NULL, 'Multidrug resistance protein', 204, NULL, NULL, 64593),
(64594, '1.20.90.10-FF-000042', NULL, NULL, 62, NULL, NULL, 64594),
(64595, '1.10.3720.10-FF-000193', NULL, 'Osmoprotection protein (ProWX)', 194, NULL, NULL, 64595),
(64596, '2.30.42.10-FF-000405', NULL, NULL, 98, NULL, NULL, 64596),
(64597, '1.10.20.10-FF-000229', NULL, NULL, 65, NULL, NULL, 64597),
(64598, '2.40.50.140-FF-000772', NULL, NULL, 132, NULL, NULL, 64598),
(64599, '3.30.460.10-FF-000054', NULL, 'Iojap-like ribosome-associated protein', 116, NULL, NULL, 64599),
(64600, '3.30.110.70-FF-000001', NULL, 'Outer membrane lipoprotein RcsF', 105, NULL, NULL, 64600),
(64601, '3.30.70.260-FF-000041', NULL, 'Phosphoserine phosphatase SerB', 83, NULL, NULL, 64601);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(64602, '2.30.30.40-FF-000573', NULL, 'Uncharacterized protein', 82, NULL, NULL, 64602),
(64603, '1.10.238.10-FF-001123', NULL, 'Uncharacterized protein', 32, NULL, NULL, 64603),
(64604, '2.60.40.820-FF-000008', NULL, 'T-box transcription factor TBX20', 195, NULL, NULL, 64604),
(64605, '1.10.510.10-FF-001751', NULL, 'Os04g0517500 protein', 113, NULL, NULL, 64605),
(64606, '1.20.1560.10-FF-000413', NULL, 'Multidrug resistance-associated protein 1', 380, NULL, NULL, 64606),
(64607, '3.40.50.300-FF-003621', NULL, 'DNA repair helicase XPB-R', 208, NULL, NULL, 64607),
(64608, '3.40.50.300-FF-005061', NULL, 'DNA repair protein XRCC3', 137, NULL, NULL, 64608),
(64609, '3.30.40.10-FF-001894', NULL, 'Os07g0497100 protein', 74, NULL, NULL, 64609),
(64610, '1.25.40.10-FF-002451', NULL, 'Pentatricopeptide repeat-containing protein At1g13040, mitochondrial', 69, NULL, NULL, 64610),
(64611, '3.40.50.1910-FF-000040', NULL, 'Putative Sec1/Munc18 related protein', 153, NULL, NULL, 64611),
(64612, '3.30.70.3490-FF-000049', NULL, NULL, 69, NULL, NULL, 64612),
(64613, '3.40.50.300-FF-004077', NULL, 'Probable second part of macrolide-transport ATP-binding protein ABC transporter', 135, NULL, NULL, 64613),
(64614, '1.10.274.30-FF-000027', NULL, 'Uncharacterized protein', 180, NULL, NULL, 64614),
(64615, '1.20.1070.10-FF-001961', NULL, 'Uncharacterized protein', 192, NULL, NULL, 64615),
(64616, '2.60.40.10-FF-004913', NULL, NULL, 64, NULL, NULL, 64616),
(64617, '3.30.540.30-FF-000010', NULL, 'Dipeptidyl peptidase 3', 70, NULL, NULL, 64617),
(64618, '1.20.1700.10-FF-000003', NULL, 'Pantothenate kinase 4', 90, NULL, NULL, 64618),
(64619, '1.10.150.20-FF-000080', NULL, 'Meiotic recombination protein DMC1', 81, NULL, NULL, 64619),
(64620, '3.30.70.270-FF-000044', NULL, 'Diguanylate cyclase (GGDEF)-like protein', 163, NULL, NULL, 64620),
(64621, '1.20.5.170-FF-000261', NULL, 'cGMP-dependent protein kinase', 30, NULL, NULL, 64621),
(64622, '1.25.40.20-FF-001436', NULL, 'Uncharacterized protein', 159, NULL, NULL, 64622),
(64623, '1.20.140.10-FF-000141', NULL, 'Acyl-coenzyme A oxidase', 111, NULL, NULL, 64623),
(64624, '2.60.40.60-FF-000286', NULL, 'Cadherin-related tumor suppressor', 113, NULL, NULL, 64624),
(64625, '1.25.40.10-FF-002541', NULL, 'Uncharacterized protein', 157, NULL, NULL, 64625),
(64626, '2.60.40.10-FF-000552', NULL, 'Related to glucoamylase', 105, NULL, NULL, 64626),
(64627, '2.40.50.140-FF-000154', NULL, 'nucleolar protein of 40 kDa', 92, NULL, NULL, 64627),
(64628, '3.40.50.300-FF-008438', NULL, 'Uncharacterized protein', 81, NULL, NULL, 64628),
(64629, '1.10.287.70-FF-000265', NULL, 'TWiK family of potassium channels', 165, NULL, NULL, 64629),
(64630, '3.30.160.60-FF-005711', NULL, NULL, 51, NULL, NULL, 64630),
(64631, '2.30.42.10-FF-000372', NULL, NULL, 115, NULL, NULL, 64631),
(64632, '3.40.50.1820-FF-000254', NULL, 'Phospholipase A1 PLIP3, chloroplastic', 232, NULL, NULL, 64632),
(64633, '3.30.40.10-FF-001040', NULL, 'Uncharacterized protein, isoform A', 54, NULL, NULL, 64633),
(64634, '1.20.1070.10-FF-001904', NULL, 'Olfactory receptor', 287, NULL, NULL, 64634),
(64635, '1.25.40.10-FF-000826', NULL, 'Ubiquitin-protein ligase', 130, NULL, NULL, 64635),
(64636, '1.10.287.1490-FF-000029', NULL, 'Epidermal growth factor receptor substrate 15', 119, NULL, NULL, 64636),
(64637, '1.10.287.770-FF-000003', NULL, 'acid-sensing ion channel 1 isoform X2', 31, NULL, NULL, 64637),
(64638, '3.80.10.10-FF-000316', NULL, 'Baculoviral IAP repeat-containing protein 1', 430, NULL, NULL, 64638),
(64639, '1.10.287.1260-FF-000016', NULL, NULL, 81, NULL, NULL, 64639),
(64640, '1.25.40.20-FF-000829', NULL, 'Uncharacterized protein', 99, NULL, NULL, 64640),
(64641, '3.30.1450.10-FF-000002', NULL, 'Osmotically inducible lipoprotein E', 92, NULL, NULL, 64641),
(64642, '3.40.50.410-FF-000220', NULL, 'von Willebrand factor', 175, NULL, NULL, 64642),
(64643, '3.40.50.300-FF-001912', NULL, 'Replication factor C subunit 4', 166, NULL, NULL, 64643),
(64644, '2.10.109.10-FF-000078', NULL, 'Peptidase S24/S26A/S26B/S26C family protein', 89, NULL, NULL, 64644);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(64645, '3.30.70.360-FF-000014', NULL, 'N-acyl-L-amino acid amidohydrolase', 115, NULL, NULL, 64645),
(64646, '1.20.5.170-FF-000204', NULL, 'tropomyosin, smooth muscle/fibroblast CTM1-like isoform X1', 45, NULL, NULL, 64646),
(64647, '3.90.10.10-FF-000001', NULL, 'Cytochrome C', 71, NULL, NULL, 64647),
(64648, '3.30.230.10-FF-000043', NULL, 'DNA topoisomerase (ATP-hydrolyzing)', 193, NULL, NULL, 64648),
(64649, '1.10.10.10-FF-000296', NULL, 'Peroxisomal membrane protein PEX14', 67, NULL, NULL, 64649),
(64650, '3.40.50.12780-FF-000040', NULL, 'Acyl-CoA synthetase', 407, NULL, NULL, 64650),
(64651, '2.60.120.260-FF-000187', NULL, 'Cytochrome C biogenesis protein DipZ', 131, NULL, NULL, 64651),
(64652, '1.10.10.60-FF-001070', NULL, NULL, 53, NULL, NULL, 64652),
(64653, '3.90.76.10-FF-000018', NULL, 'Peptide ABC transporter, periplasmic peptide-binding protein', 110, NULL, NULL, 64653),
(64654, '3.30.160.60-FF-001018', NULL, 'Combgap, isoform F', 27, NULL, NULL, 64654),
(64655, '2.130.10.10-FF-001024', NULL, 'Protein transport protein Sec13, putative', 320, NULL, NULL, 64655),
(64656, '3.30.70.370-FF-000017', NULL, 'Predicted protein', 43, NULL, NULL, 64656),
(64657, '1.10.10.60-FF-000608', NULL, 'DDE-recombinase A', 89, NULL, NULL, 64657),
(64658, '3.40.50.12370-FF-000001', NULL, 'Universal stress protein E', 315, NULL, NULL, 64658),
(64659, '2.70.160.11-FF-000027', NULL, 'Protein arginine N-methyltransferase 7', 174, NULL, NULL, 64659),
(64660, '3.40.190.290-FF-000118', NULL, 'Transcriptional regulator LysR family', 204, NULL, NULL, 64660),
(64661, '3.40.50.10240-FF-000031', NULL, 'Uncharacterized protein', 214, NULL, NULL, 64661),
(64662, '2.60.40.10-FF-000439', NULL, 'Down syndrome cell adhesion molecule, isoform J', 100, NULL, NULL, 64662),
(64663, '3.10.129.10-FF-000216', NULL, 'Thioesterase-like superfamily, putative', 117, NULL, NULL, 64663),
(64664, '1.25.40.10-FF-004250', NULL, 'Uncharacterized protein', 233, NULL, NULL, 64664),
(64665, '1.10.220.30-FF-000021', NULL, 'Flagellar motor switch protein fliG', 98, NULL, NULL, 64665),
(64666, '1.20.1050.10-FF-000240', NULL, 'Uncharacterized protein', 72, NULL, NULL, 64666),
(64667, '3.30.1370.10-FF-000092', NULL, 'PRE-binding protein', 78, NULL, NULL, 64667),
(64668, '3.30.470.20-FF-000030', NULL, 'Carbamoyl-phosphate synthase 1, mitochondrial', 202, NULL, NULL, 64668),
(64669, '2.40.30.270-FF-000009', NULL, 'DNA helicase A', 126, NULL, NULL, 64669),
(64670, '1.20.1740.10-FF-000034', NULL, 'cationic amino acid transporter 2 isoform X2', 142, NULL, NULL, 64670),
(64671, '3.40.50.150-FF-000176', NULL, 'tRNA (cytidine(32)/guanosine(34)-2''-O)-methyltransferase', 211, NULL, NULL, 64671),
(64672, '3.20.180.10-FF-000006', NULL, 'Iron-chelator utilization protein, putative', 89, NULL, NULL, 64672),
(64673, '1.10.10.60-FF-000850', NULL, NULL, 60, NULL, NULL, 64673),
(64674, '1.25.40.10-FF-002209', NULL, 'Pentatricopeptide repeat-containing protein At1g06270', 166, NULL, NULL, 64674),
(64675, '3.30.160.20-FF-000017', NULL, 'ATP-dependent RNA helicase DHX30 isoform X1', 92, NULL, NULL, 64675),
(64676, '1.25.40.10-FF-000208', NULL, 'Protein sel-1 homolog 1', 176, NULL, NULL, 64676),
(64677, '1.20.1280.290-FF-000080', NULL, 'Uncharacterized protein', 91, NULL, NULL, 64677),
(64678, '2.30.42.10-FF-000462', NULL, NULL, 92, NULL, NULL, 64678),
(64679, '1.25.10.10-FF-003404', NULL, 'Uncharacterized protein', 104, NULL, NULL, 64679),
(64680, '3.80.10.10-FF-003189', NULL, 'Uncharacterized protein', 234, NULL, NULL, 64680),
(64681, '3.20.180.20-FF-000009', NULL, 'Dynein beta chain, putative', 96, NULL, NULL, 64681),
(64682, '3.40.50.300-FF-008348', NULL, 'Inner dynein arm 1 heavy chain 1-ALPHa', 121, NULL, NULL, 64682),
(64683, '1.20.1250.20-FF-001298', NULL, 'Monocarboxylate transporter, putative', 222, NULL, NULL, 64683),
(64684, '3.30.420.140-FF-000017', NULL, 'Transcription elongation factor Spt6', 164, NULL, NULL, 64684),
(64685, '1.20.1250.20-FF-001388', NULL, 'Major facilitator superfamily transport protein', 191, NULL, NULL, 64685),
(64686, '3.30.565.10-FF-000258', NULL, 'Histidine kinase', 162, NULL, NULL, 64686);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(64687, '3.40.850.10-FF-000104', NULL, 'Myosin C', 191, NULL, NULL, 64687),
(64688, '2.60.40.10-FF-004857', NULL, NULL, 141, NULL, NULL, 64688),
(64689, '3.90.190.20-FF-000034', NULL, 'Putative folylpolyglutamate synthase', 185, NULL, NULL, 64689),
(64690, '3.30.70.330-FF-000382', NULL, 'G-patch domain-containing protein', 85, NULL, NULL, 64690),
(64691, '3.30.160.60-FF-002598', NULL, 'zinc finger protein 582 isoform X2', 30, NULL, NULL, 64691),
(64692, '3.30.1360.10-FF-000063', NULL, 'RNA polymerase Rpb3/Rpb11 dimerisation domain containing protein', 147, NULL, NULL, 64692),
(64693, '2.120.10.30-FF-000244', NULL, 'Probable L-sorbosone dehydrogenase', 324, NULL, NULL, 64693),
(64694, '2.60.120.650-FF-000034', NULL, 'Transcription factor jumonji (JmjC) domain-containing protein', 256, NULL, NULL, 64694),
(64695, '3.20.20.240-FF-000004', NULL, 'Probable methylmalonyl-CoA mutase small subunit', 431, NULL, NULL, 64695),
(64696, '3.40.850.10-FF-000290', NULL, 'Uncharacterized protein', 384, NULL, NULL, 64696),
(64697, '1.10.472.10-FF-000307', NULL, 'Uncharacterized protein', 50, NULL, NULL, 64697),
(64698, '3.30.70.1400-FF-000018', NULL, 'Dimethylglycine dehydrogenase', 26, NULL, NULL, 64698),
(64699, '2.130.10.10-FF-002418', NULL, 'THO complex subunit 3', 85, NULL, NULL, 64699),
(64700, '1.10.630.10-FF-000799', NULL, 'Uncharacterized protein', 85, NULL, NULL, 64700),
(64701, '3.40.850.10-FF-000048', NULL, 'Kinesin-like protein', 395, NULL, NULL, 64701),
(64702, '3.40.50.720-FF-002084', NULL, 'Uncharacterized protein', 140, NULL, NULL, 64702),
(64703, '3.30.160.60-FF-001636', NULL, 'CLUMA_CG004886, isoform A', 24, NULL, NULL, 64703),
(64704, '3.40.50.300-FF-004695', NULL, 'Uncharacterized protein', 237, NULL, NULL, 64704),
(64705, '2.130.10.10-FF-005442', NULL, 'WD repeat domain 3', 209, NULL, NULL, 64705),
(64706, '3.90.190.10-FF-000031', NULL, 'dual specificity protein phosphatase CDC14B isoform X1', 147, NULL, NULL, 64706),
(64707, '3.30.160.100-FF-000013', NULL, 'Ribosome hibernation promoting factor', 106, NULL, NULL, 64707),
(64708, '3.30.565.10-FF-000168', NULL, 'Autoinducer 1 sensor kinase/phosphatase LuxN', 154, NULL, NULL, 64708),
(64709, '2.60.120.650-FF-000181', NULL, 'Predicted protein', 109, NULL, NULL, 64709),
(64710, '3.30.70.120-FF-000050', NULL, NULL, 60, NULL, NULL, 64710),
(64711, '1.10.510.10-FF-000767', NULL, 'Non-specific serine/threonine protein kinase', 194, NULL, NULL, 64711),
(64712, '2.60.120.200-FF-000630', NULL, 'Uncharacterized protein', 127, NULL, NULL, 64712),
(64713, '2.130.10.10-FF-002660', NULL, 'Uncharacterized protein', 205, NULL, NULL, 64713),
(64714, '1.10.472.10-FF-000217', NULL, 'TFIIB zinc-binding, putative', 94, NULL, NULL, 64714),
(64715, '3.60.15.10-FF-000238', NULL, 'Uncharacterized protein', 164, NULL, NULL, 64715),
(64716, '3.40.390.10-FF-000063', NULL, 'Putative cytosolic oligopeptidase A-like Protein', 151, NULL, NULL, 64716),
(64717, '2.30.29.30-FF-000830', NULL, 'Uncharacterized protein', 109, NULL, NULL, 64717),
(64718, '3.30.1370.10-FF-000035', NULL, 'KH domain-containing 4, pre-mRNA-splicing factor', 103, NULL, NULL, 64718),
(64719, '3.20.20.70-FF-000045', NULL, '2-isopropylmalate synthase', 377, NULL, NULL, 64719),
(64720, '3.40.50.2300-FF-000387', NULL, 'Argonaute (Plant)-Like protein', 175, NULL, NULL, 64720),
(64721, '2.60.40.10-FF-000967', NULL, 'Uncharacterized protein, isoform D', 104, NULL, NULL, 64721),
(64722, '3.30.1330.200-FF-000002', NULL, 'Probable chemoreceptor glutamine deamidase CheD', 164, NULL, NULL, 64722),
(64723, '3.30.40.10-FF-002057', NULL, 'Uncharacterized protein', 90, NULL, NULL, 64723),
(64724, '3.30.160.60-FF-001260', NULL, 'zinc finger protein 629 isoform X2', 31, NULL, NULL, 64724),
(64725, '3.40.50.300-FF-006494', NULL, 'Uncharacterized protein', 114, NULL, NULL, 64725),
(64726, '3.40.47.10-FF-000184', NULL, 'Acetoacetyl CoA synthase NphT7', 330, NULL, NULL, 64726),
(64727, '3.40.47.10-FF-000127', NULL, 'Acetyl-CoA acetyltransferase, putative', 135, NULL, NULL, 64727),
(64728, '2.130.10.10-FF-001171', NULL, 'U3 small nucleolar RNA-associated protein 15,putative', 324, NULL, NULL, 64728);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(64729, '3.40.50.720-FF-002230', NULL, 'Uncharacterized protein', 98, NULL, NULL, 64729),
(64730, '2.60.40.10-FF-004239', NULL, NULL, 111, NULL, NULL, 64730),
(64731, '3.30.460.20-FF-000001', NULL, 'Zinc transport protein ZntB', 138, NULL, NULL, 64731),
(64732, '2.60.40.150-FF-000347', NULL, 'C2 domain containing protein', 162, NULL, NULL, 64732),
(64733, '1.25.10.10-FF-002713', NULL, 'Uncharacterized protein', 979, NULL, NULL, 64733),
(64734, '1.20.59.10-FF-000003', NULL, 'Bifunctional 3-deoxy-7-phosphoheptulonate synthase/chorismate mutase', 94, NULL, NULL, 64734),
(64735, '1.10.10.10-FF-000970', NULL, 'LysR family transcriptional regulator', 83, NULL, NULL, 64735),
(64736, '1.10.10.60-FF-001160', NULL, NULL, 51, NULL, NULL, 64736),
(64737, '1.25.40.120-FF-000023', NULL, 'Ecm9p', 215, NULL, NULL, 64737),
(64738, '3.20.20.80-FF-000048', NULL, 'Brain chitinase and chia', 285, NULL, NULL, 64738),
(64739, '3.30.160.60-FF-000799', NULL, 'myeloid zinc finger 1 isoform X1', 28, NULL, NULL, 64739),
(64740, '3.40.50.150-FF-001608', NULL, NULL, 256, NULL, NULL, 64740),
(64741, '2.40.10.10-FF-000657', NULL, NULL, 97, NULL, NULL, 64741),
(64742, '1.10.10.10-FF-001313', NULL, 'RNA polymerase sigma factor', 64, NULL, NULL, 64742),
(64743, '3.40.50.12670-FF-000006', NULL, 'Serine carboxypeptidase-like 18', 148, NULL, NULL, 64743),
(64744, '3.10.390.10-FF-000013', NULL, 'Uncharacterized protein', 74, NULL, NULL, 64744),
(64745, '2.60.40.60-FF-001067', NULL, 'Fat1 protein', 59, NULL, NULL, 64745),
(64746, '3.40.50.620-FF-000311', NULL, 'Nicotinamide nucleotide adenylyltransferase 1', 146, NULL, NULL, 64746),
(64747, '3.30.420.40-FF-000561', NULL, 'Actin-related protein 6', 32, NULL, NULL, 64747),
(64748, '1.10.150.20-FF-000309', NULL, 'Uncharacterized protein', 56, NULL, NULL, 64748),
(64749, '1.20.1070.10-FF-000325', NULL, 'Predicted protein', 303, NULL, NULL, 64749),
(64750, '1.10.600.10-FF-000033', NULL, 'Farnesyl pyrophosphate synthase', 365, NULL, NULL, 64750),
(64751, '3.40.190.10-FF-000929', NULL, 'Uncharacterized protein', 62, NULL, NULL, 64751),
(64752, '3.40.50.2000-FF-000089', NULL, 'Glycosyltransferase', 244, NULL, NULL, 64752),
(64753, '1.20.900.10-FF-000109', NULL, 'Uncharacterized protein', 135, NULL, NULL, 64753),
(64754, '2.30.42.10-FF-000552', NULL, NULL, 69, NULL, NULL, 64754),
(64755, '1.20.1050.10-FF-000150', NULL, 'Predicted protein', 111, NULL, NULL, 64755),
(64756, '3.40.50.1820-FF-000310', NULL, 'Phosphatidylcholine-sterol O-acyltransferase', 164, NULL, NULL, 64756),
(64757, '2.60.40.10-FF-005262', NULL, NULL, 87, NULL, NULL, 64757),
(64758, '1.20.1050.10-FF-000094', NULL, 'Glutathione S-transferase 1', 130, NULL, NULL, 64758),
(64759, '2.60.120.260-FF-000333', NULL, 'Sun domain-containing protein 1', 231, NULL, NULL, 64759),
(64760, '3.40.640.10-FF-000190', NULL, '7-keto-8-aminopelargonate synthetase', 235, NULL, NULL, 64760),
(64761, '1.25.40.10-FF-003232', NULL, 'YALI0A15686p', 305, NULL, NULL, 64761),
(64762, '3.40.50.150-FF-000737', NULL, 'Methyltransferase like 7A', 139, NULL, NULL, 64762),
(64763, '3.40.50.1470-FF-000008', NULL, 'Peptidyl-tRNA hydrolase', 194, NULL, NULL, 64763),
(64764, '1.10.510.10-FF-003550', NULL, NULL, 229, NULL, NULL, 64764),
(64765, '2.60.120.200-FF-000012', NULL, 'neuronal pentraxin receptor', 198, NULL, NULL, 64765),
(64766, '3.40.50.300-FF-007421', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', 341, NULL, NULL, 64766),
(64767, '3.40.50.300-FF-001822', NULL, 'RAB family', 178, NULL, NULL, 64767),
(64768, '1.10.472.10-FF-000274', NULL, 'CYCLIN B15', 33, NULL, NULL, 64768),
(64769, '3.30.1460.50-FF-000026', NULL, 'Uncharacterized protein', 141, NULL, NULL, 64769),
(64770, '1.25.70.10-FF-000036', NULL, 'Mitochondrial transcription termination factor 4', 152, NULL, NULL, 64770),
(64771, '1.25.10.10-FF-002623', NULL, 'Uncharacterized protein', 130, NULL, NULL, 64771),
(64772, '3.40.50.720-FF-002140', NULL, 'D-beta-hydroxybutyrate dehydrogenase, mitochondrial', 96, NULL, NULL, 64772),
(64773, '2.60.40.10-FF-004149', NULL, NULL, 89, NULL, NULL, 64773);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(64774, '1.20.5.1160-FF-000016', NULL, 'Intermediate filament protein A', 85, NULL, NULL, 64774),
(64775, '3.30.160.60-FF-005998', NULL, NULL, 44, NULL, NULL, 64775),
(64776, '2.60.120.290-FF-000061', NULL, 'cubilin', 113, NULL, NULL, 64776),
(64777, '1.10.3810.10-FF-000020', NULL, 'Penicillin-binding protein 4', 195, NULL, NULL, 64777),
(64778, '3.30.559.70-FF-000048', NULL, 'Choline O-acetyltransferase', 194, NULL, NULL, 64778),
(64779, '3.40.47.10-FF-000094', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 2', 423, NULL, NULL, 64779),
(64780, '3.20.20.100-FF-000070', NULL, 'Aldo/keto reductase', 273, NULL, NULL, 64780),
(64781, '2.130.10.10-FF-001081', NULL, 'TAF5-like protein', 197, NULL, NULL, 64781),
(64782, '3.40.50.300-FF-006550', NULL, 'Uncharacterized protein', 105, NULL, NULL, 64782),
(64783, '2.70.98.10-FF-000066', NULL, 'Transglycolase epimerase', 299, NULL, NULL, 64783),
(64784, '3.40.190.120-FF-000005', NULL, 'Lipoprotein LPQZ', 41, NULL, NULL, 64784),
(64785, '2.60.40.1180-FF-000165', NULL, 'Alpha-L-fucosidase', 89, NULL, NULL, 64785),
(64786, '3.20.20.70-FF-000101', NULL, 'Delta-aminolevulinic acid dehydratase', 336, NULL, NULL, 64786),
(64787, '3.90.550.10-FF-000688', NULL, 'Uncharacterized protein', 73, NULL, NULL, 64787),
(64788, '3.40.50.960-FF-000008', NULL, '6,7-dimethyl-8-ribityllumazine synthase', 91, NULL, NULL, 64788),
(64789, '3.40.50.300-FF-002508', NULL, 'Tetronasin ABC transporter ATP-binding protein', 234, NULL, NULL, 64789),
(64790, '3.40.50.300-FF-000895', NULL, 'probable ATP-dependent RNA helicase DHX37', 208, NULL, NULL, 64790),
(64791, '3.40.50.1460-FF-000005', NULL, 'Vacuolar-processing enzyme beta-isozyme', 298, NULL, NULL, 64791),
(64792, '3.40.50.10090-FF-000002', NULL, 'Bifunctional uroporphyrinogen-III C-methyltransferase/uroporphyrinogen-III synthase', 126, NULL, NULL, 64792),
(64793, '1.50.40.10-FF-000150', NULL, 'Adenine nucleotide transporter BT1, chloroplastic/mitochondrial', 285, NULL, NULL, 64793),
(64794, '3.30.497.10-FF-000122', NULL, 'Uncharacterized protein', 204, NULL, NULL, 64794),
(64795, '3.20.20.120-FF-000019', NULL, 'Dipeptide epimerase', 229, NULL, NULL, 64795),
(64796, '3.30.160.60-FF-002564', NULL, 'Uncharacterized protein, isoform D', 65, NULL, NULL, 64796),
(64797, '3.90.810.10-FF-000023', NULL, 'p21-activated kinase, putative', 66, NULL, NULL, 64797),
(64798, '2.40.10.10-FF-000096', NULL, 'Glyoxysomal processing protease glyoxysomal', 120, NULL, NULL, 64798),
(64799, '3.20.20.80-FF-000104', NULL, 'Endo-1,4-beta-xylanase A', 303, NULL, NULL, 64799),
(64800, '3.40.50.150-FF-001232', NULL, NULL, 175, NULL, NULL, 64800),
(64801, '3.40.720.10-FF-000044', NULL, 'Arylsulfatase', 457, NULL, NULL, 64801),
(64802, '3.40.50.970-FF-000073', NULL, '2-oxoisovalerate dehydrogenase subunit alpha', 407, NULL, NULL, 64802),
(64803, '3.30.1520.10-FF-000031', NULL, 'Sorting nexin 4', 143, NULL, NULL, 64803),
(64804, '3.30.200.20-FF-002371', NULL, 'Uncharacterized protein', 67, NULL, NULL, 64804),
(64805, '3.90.1170.10-FF-000017', NULL, 'Ribosomal protein L10e/L16', 192, NULL, NULL, 64805),
(64806, '3.30.70.330-FF-000472', NULL, 'Cold inducible RNA binding protein a', 101, NULL, NULL, 64806),
(64807, '3.30.450.40-FF-000186', NULL, 'Diguanylate cyclase', 160, NULL, NULL, 64807),
(64808, '1.10.10.60-FF-001013', NULL, NULL, 40, NULL, NULL, 64808),
(64809, '2.10.25.10-FF-001289', NULL, 'Uncharacterized protein', 45, NULL, NULL, 64809),
(64810, '2.10.25.10-FF-001379', NULL, 'C901 protein', 39, NULL, NULL, 64810),
(64811, '2.60.40.10-FF-004767', NULL, NULL, 96, NULL, NULL, 64811),
(64812, '3.30.50.10-FF-000085', NULL, 'Diphosphomevalonate decarboxylase MVD2', 83, NULL, NULL, 64812),
(64813, '3.30.200.20-FF-002281', NULL, 'Receptor protein-tyrosine kinase', 108, NULL, NULL, 64813),
(64814, '2.40.30.10-FF-000417', NULL, 'Uncharacterized protein', 94, NULL, NULL, 64814),
(64815, '3.30.160.60-FF-002654', NULL, 'Related to epithelial zinc-finger ezf protein', 35, NULL, NULL, 64815),
(64816, '2.130.10.10-FF-004458', NULL, 'Uncharacterized protein', 342, NULL, NULL, 64816);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(64817, '3.80.10.10-FF-002969', NULL, 'Uncharacterized protein', 117, NULL, NULL, 64817),
(64818, '2.40.10.10-FF-000186', NULL, 'Serine protease PepA', 113, NULL, NULL, 64818),
(64819, '1.25.40.10-FF-002395', NULL, 'Pre-mRNA-splicing factor CLF1', 166, NULL, NULL, 64819),
(64820, '3.90.55.10-FF-000003', NULL, 'Probable biotin sulfoxide reductase bisC', 59, NULL, NULL, 64820),
(64821, '3.30.40.10-FF-000910', NULL, 'Bloodthirsty-related gene family, member 1', 82, NULL, NULL, 64821),
(64822, '3.30.70.270-FF-000100', NULL, 'Uncharacterized protein', 65, NULL, NULL, 64822),
(64823, '1.10.10.10-FF-000908', NULL, 'ForKHead transcription factor family', 107, NULL, NULL, 64823),
(64824, '3.40.640.10-FF-000509', NULL, 'Aminotransferase, conjectural', 59, NULL, NULL, 64824),
(64825, '2.60.40.10-FF-000496', NULL, 'Adhesion G protein-coupled receptor A2', 99, NULL, NULL, 64825),
(64826, '3.40.50.720-FF-002050', NULL, 'Hsd17b14 protein', 176, NULL, NULL, 64826),
(64827, '3.90.1860.10-FF-000014', NULL, 'Putative RctB family protein', 226, NULL, NULL, 64827),
(64828, '1.20.1260.10-FF-000008', NULL, 'YciF protein', 166, NULL, NULL, 64828),
(64829, '1.20.58.1030-FF-000005', NULL, 'DNA replication complex GINS protein SLD5', 204, NULL, NULL, 64829),
(64830, '3.90.550.10-FF-000598', NULL, 'Cytidylyltransferase', 224, NULL, NULL, 64830),
(64831, '3.30.70.2190-FF-000019', NULL, 'Uncharacterized protein', 64, NULL, NULL, 64831),
(64832, '1.10.490.10-FF-000034', NULL, 'Uncharacterized protein', 141, NULL, NULL, 64832),
(64833, '1.25.40.180-FF-000344', NULL, NULL, 113, NULL, NULL, 64833),
(64834, '2.60.220.50-FF-000034', NULL, 'Adhesion G protein-coupled receptor D2', 134, NULL, NULL, 64834),
(64835, '3.30.450.20-FF-000028', NULL, 'Aryl hydrocarbon receptor nuclear translocator 1', 131, NULL, NULL, 64835),
(64836, '3.30.519.10-FF-000039', NULL, NULL, 130, NULL, NULL, 64836),
(64837, '3.20.20.100-FF-000160', NULL, 'AGAP012851-PA', 232, NULL, NULL, 64837),
(64838, '3.40.50.970-FF-000163', NULL, 'Transketolase putative', 148, NULL, NULL, 64838),
(64839, '2.40.30.130-FF-000057', NULL, 'Uncharacterized protein', 71, NULL, NULL, 64839),
(64840, '3.90.1030.10-FF-000002', NULL, '50S ribosomal protein L17', 121, NULL, NULL, 64840),
(64841, '3.40.50.410-FF-000074', NULL, 'Mediator complex subunit 25', 192, NULL, NULL, 64841),
(64842, '1.20.58.1040-FF-000008', NULL, 'Glucan endo-1,3-beta-glucosidase 13', 106, NULL, NULL, 64842),
(64843, '2.60.120.650-FF-000214', NULL, 'Uncharacterized protein', 298, NULL, NULL, 64843),
(64844, '3.40.50.2000-FF-000179', NULL, 'Glycosyltransferase', 260, NULL, NULL, 64844),
(64845, '3.20.20.80-FF-000722', NULL, 'Uncharacterized protein', 152, NULL, NULL, 64845),
(64846, '3.60.40.10-FF-000280', NULL, 'Putative protein phosphatase 2C-like protein 45', 124, NULL, NULL, 64846),
(64847, '1.10.1450.10-FF-000059', NULL, 'Tetraspanin', 80, NULL, NULL, 64847),
(64848, '1.20.1250.20-FF-001859', NULL, 'Major facilitator superfamily protein', 123, NULL, NULL, 64848),
(64849, '2.120.10.30-FF-000154', NULL, 'AGAP011034-PA', 90, NULL, NULL, 64849),
(64850, '2.50.20.10-FF-000017', NULL, 'Outer-membrane lipoprotein carrier protein', 214, NULL, NULL, 64850),
(64851, '3.40.50.1820-FF-000400', NULL, 'YOR059C-like protein', 191, NULL, NULL, 64851),
(64852, '3.30.530.20-FF-000029', NULL, 'START domain-containing protein 10', 207, NULL, NULL, 64852),
(64853, '2.60.120.340-FF-000031', NULL, 'Uncharacterized protein', 55, NULL, NULL, 64853),
(64854, '1.10.238.10-FF-001056', NULL, 'Polcalcin Cup a 4', 88, NULL, NULL, 64854),
(64855, '1.20.120.1530-FF-000017', NULL, NULL, 128, NULL, NULL, 64855),
(64856, '1.25.40.10-FF-004126', NULL, 'Pentatricopeptide repeat-containing protein At5g14080', 123, NULL, NULL, 64856),
(64857, '2.40.30.20-FF-000021', NULL, 'ATP synthase subunit alpha', 30, NULL, NULL, 64857),
(64858, '2.40.30.30-FF-000024', NULL, 'Riboflavin kinase', 175, NULL, NULL, 64858),
(64859, '2.60.40.1150-FF-000004', NULL, 'AP complex subunit beta', 56, NULL, NULL, 64859),
(64860, '3.40.50.720-FF-002145', NULL, 'Nicotinamide nucleotide transhydrogenase 2', 90, NULL, NULL, 64860);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(64861, '1.10.238.10-FF-000488', NULL, 'GTPase activating protein (Gyp2)', 259, NULL, NULL, 64861),
(64862, '1.10.8.1190-FF-000005', NULL, 'Polyprotein 1a', 97, NULL, NULL, 64862),
(64863, '3.60.40.10-FF-000072', NULL, 'Stage II sporulation protein E', 244, NULL, NULL, 64863),
(64864, '3.30.70.270-FF-000167', NULL, 'Response regulator PleD', 171, NULL, NULL, 64864),
(64865, '3.40.50.1380-FF-000021', NULL, 'Carbamoyl-phosphate synthase large chain', 137, NULL, NULL, 64865),
(64866, '3.30.479.30-FF-000030', NULL, 'Stomatin family protein', 150, NULL, NULL, 64866),
(64867, '3.40.50.300-FF-005302', NULL, 'Shikimate kinase', 171, NULL, NULL, 64867),
(64868, '1.10.4160.10-FF-000043', NULL, 'Probable transporter', 441, NULL, NULL, 64868),
(64869, '3.40.50.300-FF-001019', NULL, 'Cell division protein ZapE', 189, NULL, NULL, 64869),
(64870, '1.10.287.1260-FF-000011', NULL, 'Mechanosensitive ion channel protein', 117, NULL, NULL, 64870),
(64871, '3.40.50.20-FF-000071', NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', 108, NULL, NULL, 64871),
(64872, '3.40.50.720-FF-000021', NULL, 'D-3-phosphoglycerate dehydrogenase', 182, NULL, NULL, 64872),
(64873, '2.130.10.10-FF-004279', NULL, 'Uncharacterized protein', 129, NULL, NULL, 64873),
(64874, '3.80.10.10-FF-000081', NULL, 'leucine-rich repeat and calponin homology domain-containing protein 4 isoform X2', 106, NULL, NULL, 64874),
(64875, '1.10.10.10-FF-000178', NULL, 'Putative Transcription factor RFX4', 76, NULL, NULL, 64875),
(64876, '3.40.190.10-FF-000317', NULL, 'LysR family transcriptional regulator', 82, NULL, NULL, 64876),
(64877, '3.40.309.10-FF-000066', NULL, 'Aldehyde dehydrogenase', 197, NULL, NULL, 64877),
(64878, '3.40.50.300-FF-005240', NULL, 'ABC transporter G family member 35', 196, NULL, NULL, 64878),
(64879, '3.40.50.300-FF-007331', NULL, 'Uncharacterized protein', 143, NULL, NULL, 64879),
(64880, '3.30.230.120-FF-000007', NULL, 'GHMP kinase', 324, NULL, NULL, 64880),
(64881, '1.10.10.60-FF-001300', NULL, NULL, 46, NULL, NULL, 64881),
(64882, '1.10.10.60-FF-000732', NULL, 'Homeobox protein ceh-8', 68, NULL, NULL, 64882),
(64883, '1.20.1270.60-FF-000102', NULL, 'WGS project CABT00000000 data, contig 2.23', 254, NULL, NULL, 64883),
(64884, '1.10.510.10-FF-001077', NULL, 'Phytosulfokine receptor 2', 207, NULL, NULL, 64884),
(64885, '3.40.50.2000-FF-000527', NULL, 'Uncharacterized protein', 260, NULL, NULL, 64885),
(64886, '3.30.40.10-FF-000438', NULL, 'Bloodthirsty-related gene family, member 25', 77, NULL, NULL, 64886),
(64887, '3.90.1180.10-FF-000018', NULL, '50S ribosomal protein L13', 149, NULL, NULL, 64887),
(64888, '2.130.10.10-FF-002093', NULL, 'WD repeat-containing protein 6', 312, NULL, NULL, 64888),
(64889, '3.30.420.40-FF-001016', NULL, 'Uncharacterized protein', 51, NULL, NULL, 64889),
(64890, '1.20.85.10-FF-000007', NULL, 'Photosynthetic reaction center subunit M', 130, NULL, NULL, 64890),
(64891, '3.30.1540.10-FF-000009', NULL, 'Probable CoA-transferase Rv1866', 94, NULL, NULL, 64891),
(64892, '3.30.160.60-FF-003227', NULL, 'Zinc finger protein 236', 30, NULL, NULL, 64892),
(64893, '1.20.1310.10-FF-000075', NULL, 'Ubiquitin ligase subunit CulD', 103, NULL, NULL, 64893),
(64894, '2.30.29.30-FF-000420', NULL, 'CLNS1A isoform 4', 25, NULL, NULL, 64894),
(64895, '3.40.1110.10-FF-000126', NULL, 'Phospholipid-transporting ATPase', 141, NULL, NULL, 64895),
(64896, '3.40.50.10900-FF-000009', NULL, 'Proteasome assembly chaperone 2', 85, NULL, NULL, 64896),
(64897, '3.80.30.20-FF-000028', NULL, 'Oxygen-independent coproporphyrinogen III oxidase', 200, NULL, NULL, 64897),
(64898, '1.10.238.10-FF-000393', NULL, 'Calcium-dependent protein kinase 2', 79, NULL, NULL, 64898),
(64899, '2.130.10.10-FF-001732', NULL, 'WD repeat-containing protein 74', 312, NULL, NULL, 64899),
(64900, '3.40.50.1970-FF-000035', NULL, '3-dehydroquinate synthase', 172, NULL, NULL, 64900),
(64901, '3.30.40.10-FF-001866', NULL, 'Uncharacterized protein', 78, NULL, NULL, 64901),
(64902, '2.30.30.40-FF-000168', NULL, 'SH3 domain protein (Cyk3)', 61, NULL, NULL, 64902);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(64903, '2.60.40.1140-FF-000001', NULL, 'Collagen adhesin', 100, NULL, NULL, 64903),
(64904, '3.80.10.10-FF-003902', NULL, 'Uncharacterized protein', 133, NULL, NULL, 64904),
(64905, '3.30.160.60-FF-001136', NULL, 'Zinc finger protein 408', 27, NULL, NULL, 64905),
(64906, '3.30.230.70-FF-000066', NULL, 'GD11151', 290, NULL, NULL, 64906),
(64907, '2.40.50.140-FF-000660', NULL, 'Recombination-defective, isoform B', 123, NULL, NULL, 64907),
(64908, '3.90.1150.10-FF-000516', NULL, 'Predicted protein', 92, NULL, NULL, 64908),
(64909, '3.30.420.40-FF-000353', NULL, 'Actin-related protein 9', 72, NULL, NULL, 64909),
(64910, '1.20.920.30-FF-000061', NULL, 'Predicted protein', 138, NULL, NULL, 64910),
(64911, '3.40.190.10-FF-000222', NULL, 'LysR family transcriptional regulator', 91, NULL, NULL, 64911),
(64912, '2.10.25.10-FF-001227', NULL, 'Fibulin 1', 46, NULL, NULL, 64912),
(64913, '1.10.506.10-FF-000095', NULL, 'Uncharacterized protein', 83, NULL, NULL, 64913),
(64914, '3.40.50.150-FF-001732', NULL, NULL, 183, NULL, NULL, 64914),
(64915, '3.30.260.10-FF-000078', NULL, NULL, 91, NULL, NULL, 64915),
(64916, '3.30.70.870-FF-000038', NULL, 'Elongation factor G', 74, NULL, NULL, 64916),
(64917, '3.40.190.10-FF-000368', NULL, 'Serotransferrin', 145, NULL, NULL, 64917),
(64918, '3.40.1110.10-FF-000031', NULL, 'Calcium-transporting ATPase', 230, NULL, NULL, 64918),
(64919, '3.30.710.10-FF-000091', NULL, 'Lola, isoform F', 128, NULL, NULL, 64919),
(64920, '3.10.100.10-FF-000307', NULL, NULL, 183, NULL, NULL, 64920),
(64921, '2.130.10.10-FF-002834', NULL, 'Prolactin regulatory element-binding protein', 366, NULL, NULL, 64921),
(64922, '3.40.50.720-FF-000072', NULL, 'Saccharopine dehydrogenase [NADP(+), L-glutamate-forming]', 174, NULL, NULL, 64922),
(64923, '2.60.120.200-FF-000343', NULL, 'LAMinin related. See also lmb', 165, NULL, NULL, 64923),
(64924, '3.40.50.410-FF-000130', NULL, 'Inverted repeat-binding protein', 219, NULL, NULL, 64924),
(64925, '3.80.10.10-FF-004245', NULL, 'Tubulin-specific chaperone E', 73, NULL, NULL, 64925),
(64926, '1.10.287.2620-FF-000014', NULL, 'Dynein heavy chain, putative', 66, NULL, NULL, 64926),
(64927, '3.80.10.10-FF-000176', NULL, 'Thyrotropin receptor', 239, NULL, NULL, 64927),
(64928, '3.40.710.10-FF-000015', NULL, 'Serine beta-lactamase-like protein LACTB, mitochondrial', 150, NULL, NULL, 64928),
(64929, '2.40.50.140-FF-000334', NULL, 'Translation initiation factor 5A', 62, NULL, NULL, 64929),
(64930, '1.25.40.10-FF-001321', NULL, 'Pentatricopeptide repeat-containing protein At3g57430, chloroplastic', 101, NULL, NULL, 64930),
(64931, '1.10.357.150-FF-000014', NULL, 'Uncharacterized protein', 199, NULL, NULL, 64931),
(64932, '1.25.40.20-FF-001324', NULL, 'Predicted protein', 136, NULL, NULL, 64932),
(64933, '3.90.70.10-FF-000269', NULL, 'Cysteine protease, putative', 302, NULL, NULL, 64933),
(64934, '1.10.287.3810-FF-000006', NULL, 'Uncharacterized protein', 25, NULL, NULL, 64934),
(64935, '3.40.50.1820-FF-000018', NULL, 'Carboxypeptidase', 329, NULL, NULL, 64935),
(64936, '2.30.42.10-FF-000338', NULL, 'Syndecan binding protein', 86, NULL, NULL, 64936),
(64937, '1.10.357.140-FF-000011', NULL, 'Homogentisate phytyltransferase 1', 158, NULL, NULL, 64937),
(64938, '2.60.40.150-FF-000667', NULL, 'Predicted protein', 80, NULL, NULL, 64938),
(64939, '3.50.50.60-FF-000155', NULL, 'Monodehydroascorbate reductase 3', 132, NULL, NULL, 64939),
(64940, '1.10.287.940-FF-000015', NULL, 'C12orf76 isoform 1', 11, NULL, NULL, 64940),
(64941, '2.60.40.10-FF-003053', NULL, 'Uncharacterized protein', 123, NULL, NULL, 64941),
(64942, '2.60.40.10-FF-005987', NULL, NULL, 92, NULL, NULL, 64942),
(64943, '1.50.10.20-FF-000095', NULL, 'Terpene cyclase/mutase family member', 355, NULL, NULL, 64943),
(64944, '3.40.50.150-FF-001053', NULL, NULL, 49, NULL, NULL, 64944),
(64945, '2.70.130.10-FF-000165', NULL, NULL, 88, NULL, NULL, 64945),
(64946, '3.80.10.10-FF-000030', NULL, 'C-Maf-inducing protein-like protein', 221, NULL, NULL, 64946),
(64947, '2.60.34.10-FF-000138', NULL, 'Heat shock 70 kDa protein 14', 70, NULL, NULL, 64947);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(64948, '3.30.710.10-FF-000411', NULL, 'Uncharacterized protein', 152, NULL, NULL, 64948),
(64949, '3.30.450.40-FF-000181', NULL, 'IclR family transcriptional regulator', 174, NULL, NULL, 64949),
(64950, '3.30.1370.10-FF-000209', NULL, 'KRR1 small subunit processome component homolog-like protein', 48, NULL, NULL, 64950),
(64951, '3.40.50.300-FF-006437', NULL, 'Uncharacterized protein', 126, NULL, NULL, 64951),
(64952, '3.30.160.60-FF-002659', NULL, 'Zinc finger protein 526', 27, NULL, NULL, 64952),
(64953, '3.30.1050.10-FF-000039', NULL, 'Putative stomatin-like 1', 127, NULL, NULL, 64953),
(64954, '2.40.70.10-FF-000077', NULL, 'Aspartic proteinase nepenthesin-2', 200, NULL, NULL, 64954),
(64955, '2.30.29.30-FF-000471', NULL, 'Serine threonine protein phosphatase 2a 59 kDa regulatory subunit b', 112, NULL, NULL, 64955),
(64956, '3.40.640.10-FF-000476', NULL, 'Putative serine/threonine-protein phosphatase 2A regulatory subunit B'''' subunit TON2', 84, NULL, NULL, 64956),
(64957, '3.40.50.2300-FF-000415', NULL, 'Chemotactic response regulator', 118, NULL, NULL, 64957),
(64958, '3.30.40.10-FF-000343', NULL, 'E3 SUMO-protein ligase NSE2 isoform X1', 87, NULL, NULL, 64958),
(64959, '1.20.5.1500-FF-000012', NULL, 'Gag polyprotein', 41, NULL, NULL, 64959),
(64960, '1.20.1250.20-FF-000191', NULL, 'Transporter, major facilitator family', 213, NULL, NULL, 64960),
(64961, '3.40.50.2000-FF-000853', NULL, 'Glycosyltransferase', 230, NULL, NULL, 64961),
(64962, '2.60.40.60-FF-000426', NULL, 'Protocadherin-15', 108, NULL, NULL, 64962),
(64963, '1.20.930.80-FF-000003', NULL, 'DNA primase large subunit', 261, NULL, NULL, 64963),
(64964, '3.30.420.10-FF-000113', NULL, 'Ribonuclease HII', 209, NULL, NULL, 64964),
(64965, '3.30.160.60-FF-003553', NULL, NULL, 25, NULL, NULL, 64965),
(64966, '3.30.200.20-FF-000982', NULL, 'CBN-JKK-1 protein', 95, NULL, NULL, 64966),
(64967, '3.30.160.60-FF-000861', NULL, 'zinc finger protein 358', 28, NULL, NULL, 64967),
(64968, '3.30.470.20-FF-000232', NULL, 'Inositol-tetrakisphosphate 1-kinase', 87, NULL, NULL, 64968),
(64969, '3.30.870.10-FF-000158', NULL, 'Uncharacterized protein', 125, NULL, NULL, 64969),
(64970, '3.30.470.30-FF-000061', NULL, 'DNA ligase 4', 231, NULL, NULL, 64970),
(64971, '1.10.3720.10-FF-000075', NULL, 'Peptide ABC transporter permease component', 231, NULL, NULL, 64971),
(64972, '1.20.1070.10-FF-000213', NULL, 'Vomeronasal type-1 receptor', 296, NULL, NULL, 64972),
(64973, '1.20.1510.10-FF-000056', NULL, NULL, 89, NULL, NULL, 64973),
(64974, '1.20.1420.30-FF-000055', NULL, 'Uncharacterized protein, isoform F', 120, NULL, NULL, 64974),
(64975, '3.40.50.800-FF-000005', NULL, 'bifunctional glutamate/proline--tRNA ligase', 123, NULL, NULL, 64975),
(64976, '3.30.160.60-FF-003441', NULL, NULL, 27, NULL, NULL, 64976),
(64977, '3.30.870.10-FF-000046', NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', 239, NULL, NULL, 64977),
(64978, '3.40.50.620-FF-000721', NULL, 'Predicted protein', 207, NULL, NULL, 64978),
(64979, '3.30.70.330-FF-002175', NULL, NULL, 82, NULL, NULL, 64979),
(64980, '3.30.565.10-FF-000163', NULL, 'Histidine kinase', 134, NULL, NULL, 64980),
(64981, '2.30.29.30-FF-000206', NULL, 'Rho GTPase activating protein 27', 123, NULL, NULL, 64981),
(64982, '2.130.10.10-FF-000743', NULL, 'U3 small nucleolar RNA associated protein', 198, NULL, NULL, 64982),
(64983, '2.60.40.150-FF-000729', NULL, 'Uncharacterized protein', 113, NULL, NULL, 64983),
(64984, '2.60.40.60-FF-000847', NULL, 'Uncharacterized protein', 55, NULL, NULL, 64984),
(64985, '1.10.225.10-FF-000003', NULL, 'Mesencephalic astrocyte-derived neurotrophic factor', 101, NULL, NULL, 64985),
(64986, '3.40.47.10-FF-000274', NULL, NULL, 88, NULL, NULL, 64986),
(64987, '2.60.120.10-FF-000211', NULL, 'Protein kinase A regulatory subunit', 133, NULL, NULL, 64987),
(64988, '3.30.70.1350-FF-000037', NULL, NULL, 71, NULL, NULL, 64988),
(64989, '2.130.10.10-FF-000855', NULL, '3-carboxy-cis,cis-mucoante lactonizing enzyme', 369, NULL, NULL, 64989),
(64990, '3.10.350.10-FF-000067', NULL, 'Putative lipoprotein', 66, NULL, NULL, 64990);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(64991, '2.60.120.200-FF-000068', NULL, 'collagen alpha-1(XXI) chain isoform X1', 210, NULL, NULL, 64991),
(64992, '3.60.10.10-FF-000244', NULL, 'DNA-(apurinic or apyrimidinic site) lyase', 286, NULL, NULL, 64992),
(64993, '3.30.1490.80-FF-000008', NULL, 'Glutathione synthetase', 75, NULL, NULL, 64993),
(64994, '2.60.120.260-FF-000625', NULL, 'Predicted protein', 126, NULL, NULL, 64994),
(64995, '2.130.10.110-FF-000014', NULL, 'Clathrin heavy chain-related protein', 353, NULL, NULL, 64995),
(64996, '2.60.40.60-FF-000752', NULL, 'Cadherin-4', 107, NULL, NULL, 64996),
(64997, '3.30.740.10-FF-000008', NULL, 'Dynein light chain', 90, NULL, NULL, 64997),
(64998, '1.20.1050.130-FF-000042', NULL, 'Elongation factor 1-beta', 78, NULL, NULL, 64998),
(64999, '1.10.510.10-FF-000088', NULL, 'cyclin-dependent kinase 8 isoform X1', 254, NULL, NULL, 64999),
(65000, '1.10.472.10-FF-000195', NULL, 'Putative Cyclin-L1', 129, NULL, NULL, 65000),
(65001, '3.30.710.10-FF-000506', NULL, 'Uncharacterized protein', 115, NULL, NULL, 65001),
(65002, '1.10.10.1270-FF-000001', NULL, 'Fibrinogen-binding protein', 61, NULL, NULL, 65002),
(65003, '2.60.40.10-FF-000765', NULL, 'CD86 isoform 1', 95, NULL, NULL, 65003),
(65004, '1.10.238.10-FF-001270', NULL, 'Uncharacterized protein', 42, NULL, NULL, 65004),
(65005, '3.40.50.150-FF-001406', NULL, NULL, 164, NULL, NULL, 65005),
(65006, '1.20.1090.10-FF-000034', NULL, '3-dehydroquinate synthase', 191, NULL, NULL, 65006),
(65007, '1.10.10.10-FF-001072', NULL, 'Fur family zinc uptake transcriptional regulator', 87, NULL, NULL, 65007),
(65008, '2.60.40.10-FF-002856', NULL, 'Iron-sulfur cluster binding protein', 123, NULL, NULL, 65008),
(65009, '2.130.10.120-FF-000017', NULL, 'Oligopeptidase B protein, putative', 377, NULL, NULL, 65009),
(65010, '4.10.430.10-FF-000002', NULL, 'DNA-binding protein', 42, NULL, NULL, 65010),
(65011, '3.90.780.10-FF-000048', NULL, 'Predicted protein', 162, NULL, NULL, 65011),
(65012, '3.90.290.10-FF-000027', NULL, 'Fibrillin-1', 74, NULL, NULL, 65012),
(65013, '3.30.70.330-FF-002237', NULL, NULL, 96, NULL, NULL, 65013),
(65014, '1.20.1260.140-FF-000008', NULL, NULL, 258, NULL, NULL, 65014),
(65015, '2.120.10.30-FF-000098', NULL, 'LDL receptor protein 1, isoform F', 297, NULL, NULL, 65015),
(65016, '3.50.50.100-FF-000018', NULL, 'Pyridine nucleotide-disulphide oxidoreductase AMID-like, putative', 369, NULL, NULL, 65016),
(65017, '3.40.390.10-FF-000203', NULL, NULL, 179, NULL, NULL, 65017),
(65018, '2.30.29.30-FF-000145', NULL, 'Sorting nexin-17 isoform1', 118, NULL, NULL, 65018),
(65019, '3.30.70.330-FF-001040', NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', 130, NULL, NULL, 65019),
(65020, '1.20.58.410-FF-000001', NULL, 'Peptide chain release factor 2', 116, NULL, NULL, 65020),
(65021, '1.10.238.10-FF-001005', NULL, 'DCN1-like protein 2', 109, NULL, NULL, 65021),
(65022, '3.60.40.10-FF-000021', NULL, 'Protein phosphatase, Mg2+/Mn2+-dependent, 1E', 281, NULL, NULL, 65022),
(65023, '1.10.472.10-FF-000695', NULL, 'Cyclin-D2-1', 145, NULL, NULL, 65023),
(65024, '1.20.5.110-FF-000052', NULL, 'synaptosomal-associated protein 47', 70, NULL, NULL, 65024),
(65025, '3.40.309.10-FF-000015', NULL, 'Delta-1-pyrroline-5-carboxylate synthase', 147, NULL, NULL, 65025),
(65026, '1.20.1250.20-FF-000314', NULL, 'Transporter, MFS superfamily', 181, NULL, NULL, 65026),
(65027, '3.30.60.190-FF-000017', NULL, 'Zinc finger domain-containing protein', 43, NULL, NULL, 65027),
(65028, '1.20.58.420-FF-000004', NULL, NULL, 111, NULL, NULL, 65028),
(65029, '2.130.10.10-FF-002946', NULL, 'Uncharacterized protein', 305, NULL, NULL, 65029),
(65030, '2.120.10.30-FF-000356', NULL, 'Protein STRICTOSIDINE SYNTHASE-LIKE 2', 60, NULL, NULL, 65030),
(65031, '3.40.50.10810-FF-000073', NULL, 'DNA helicase, putative', 232, NULL, NULL, 65031),
(65032, '3.40.1170.60-FF-000010', NULL, 'DNA polymerase V subunit', 64, NULL, NULL, 65032),
(65033, '1.20.120.980-FF-000025', NULL, 'AGAP004015-PA', 141, NULL, NULL, 65033),
(65034, '2.30.30.30-FF-000165', NULL, 'Uncharacterized protein', 115, NULL, NULL, 65034);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(65035, '3.30.70.330-FF-001686', NULL, NULL, 81, NULL, NULL, 65035),
(65036, '3.90.660.10-FF-000101', NULL, NULL, 15, NULL, NULL, 65036),
(65037, '3.40.50.1820-FF-001479', NULL, 'Uncharacterized protein', 170, NULL, NULL, 65037),
(65038, '6.20.250.70-FF-000002', NULL, 'RNA polymerase A', 127, NULL, NULL, 65038),
(65039, '3.30.230.100-FF-000001', NULL, 'Proteasome chaperone 4', 148, NULL, NULL, 65039),
(65040, '3.30.160.60-FF-001350', NULL, 'zinc finger protein 483 isoform X1', 27, NULL, NULL, 65040),
(65041, '3.40.350.10-FF-000083', NULL, 'Uncharacterized protein', 171, NULL, NULL, 65041),
(65042, '3.10.50.10-FF-000013', NULL, 'Probable chitinase 2', 80, NULL, NULL, 65042),
(65043, '1.20.142.10-FF-000005', NULL, 'Poly [ADP-ribose] polymerase', 144, NULL, NULL, 65043),
(65044, '2.60.200.20-FF-000215', NULL, 'Kinesin-like protein', 118, NULL, NULL, 65044),
(65045, '3.90.70.10-FF-000595', NULL, 'Ubiquitinyl hydrolase 1', 200, NULL, NULL, 65045),
(65046, '1.20.1540.10-FF-000058', NULL, 'Rhomboid family intramembrane serine protease', 208, NULL, NULL, 65046),
(65047, '1.10.3450.40-FF-000012', NULL, NULL, 220, NULL, NULL, 65047),
(65048, '2.60.34.10-FF-000026', NULL, 'Heat shock 70 kDa protein 14', 179, NULL, NULL, 65048),
(65049, '3.30.1370.10-FF-000086', NULL, 'Oocyte-expressed protein homolog', 112, NULL, NULL, 65049),
(65050, '1.20.58.530-FF-000037', NULL, 'Chitin synthase', 235, NULL, NULL, 65050),
(65051, '1.25.40.10-FF-000478', NULL, 'GG16802', 255, NULL, NULL, 65051),
(65052, '2.40.70.10-FF-000189', NULL, 'Uncharacterized protein', 133, NULL, NULL, 65052),
(65053, '2.30.42.10-FF-000226', NULL, 'Golgi reassembly-stacking protein 2', 107, NULL, NULL, 65053),
(65054, '3.40.50.1860-FF-000002', NULL, 'Glutamate racemase', 135, NULL, NULL, 65054),
(65055, '2.10.25.10-FF-001553', NULL, 'Uncharacterized protein', 60, NULL, NULL, 65055),
(65056, '3.40.109.10-FF-000034', NULL, 'Nitroreductase', 167, NULL, NULL, 65056),
(65057, '1.25.10.10-FF-000976', NULL, 'Serine/threonine-protein kinase TOR', 239, NULL, NULL, 65057),
(65058, '2.60.120.200-FF-000017', NULL, 'Vesicular integral-membrane protein VIP36', 230, NULL, NULL, 65058),
(65059, '2.60.40.3070-FF-000001', NULL, 'Lactonase, 7-bladed beta-propeller domain protein', 84, NULL, NULL, 65059),
(65060, '2.130.10.10-FF-000794', NULL, 'Transducin family protein / WD-40 repeat family protein', 190, NULL, NULL, 65060),
(65061, '3.40.50.300-FF-007426', NULL, 'ABC transporter protein family', 262, NULL, NULL, 65061),
(65062, '3.40.50.300-FF-004785', NULL, 'ATPase involved in chromosome partitioning, ParA/MinD family', 243, NULL, NULL, 65062),
(65063, '3.40.190.10-FF-000643', NULL, 'Prephenate dehydratase / chorismate mutase', 86, NULL, NULL, 65063),
(65064, '1.20.58.60-FF-000145', NULL, 'Spectrin beta chain, non-erythrocytic', 255, NULL, NULL, 65064),
(65065, '1.10.10.60-FF-000783', NULL, 'AraC family transcriptional regulator', 106, NULL, NULL, 65065),
(65066, '3.30.160.60-FF-003502', NULL, NULL, 26, NULL, NULL, 65066),
(65067, '1.20.58.70-FF-000069', NULL, 'Uncharacterized protein', 205, NULL, NULL, 65067),
(65068, '1.25.40.10-FF-004194', NULL, 'Uncharacterized protein', 76, NULL, NULL, 65068),
(65069, '3.40.50.1820-FF-001558', NULL, 'Uncharacterized membrane protein C6F6.13c', 119, NULL, NULL, 65069),
(65070, '1.10.10.1020-FF-000005', NULL, 'RecBCD enzyme subunit RecD', 113, NULL, NULL, 65070),
(65071, '2.60.120.650-FF-000129', NULL, 'lysine-specific demethylase 3B', 352, NULL, NULL, 65071),
(65072, '3.40.50.720-FF-000133', NULL, 'Methionine adenosyltransferase 2 subunit beta', 298, NULL, NULL, 65072),
(65073, '2.60.40.10-FF-005470', NULL, NULL, 103, NULL, NULL, 65073),
(65074, '3.40.30.10-FF-001039', NULL, 'AhpC/TSA family protein', 195, NULL, NULL, 65074),
(65075, '2.60.120.330-FF-000202', NULL, 'Uncharacterized protein', 132, NULL, NULL, 65075),
(65076, '3.10.180.10-FF-000060', NULL, 'Putative enzyme related to lactoylglutathione lyase', 121, NULL, NULL, 65076),
(65077, '1.10.287.690-FF-000018', NULL, 'DNA polymerase epsilon catalytic subunit', 35, NULL, NULL, 65077);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(65078, '3.40.50.300-FF-005414', NULL, 'Putative RNA helicase armi-like Protein', 225, NULL, NULL, 65078),
(65079, '1.20.58.120-FF-000004', NULL, 'BAG family molecular chaperone regulator 5', 85, NULL, NULL, 65079),
(65080, '3.30.160.60-FF-003115', NULL, 'Uncharacterized protein', 28, NULL, NULL, 65080),
(65081, '1.20.58.60-FF-000066', NULL, 'Short stop, isoform K', 220, NULL, NULL, 65081),
(65082, '3.40.50.150-FF-000889', NULL, 'Slr0907 protein', 186, NULL, NULL, 65082),
(65083, '1.10.8.10-FF-000250', NULL, 'Uncharacterized protein', 56, NULL, NULL, 65083),
(65084, '3.30.160.60-FF-000939', NULL, 'zinc finger protein 8 isoform X1', 27, NULL, NULL, 65084),
(65085, '1.10.287.470-FF-000003', NULL, 'UPF0194 membrane protein YbhG', 23, NULL, NULL, 65085),
(65086, '1.10.287.130-FF-000250', NULL, 'Response receiver histidine kinase', 79, NULL, NULL, 65086),
(65087, '3.20.10.10-FF-000010', NULL, 'Branched-chain amino acid aminotransferase', 180, NULL, NULL, 65087),
(65088, '3.30.200.20-FF-002376', NULL, NULL, 80, NULL, NULL, 65088),
(65089, '3.30.450.20-FF-000023', NULL, 'Phosphodiesterase', 112, NULL, NULL, 65089),
(65090, '3.90.1150.10-FF-000393', NULL, 'Serine--pyruvate aminotransferase', 145, NULL, NULL, 65090),
(65091, '1.20.5.320-FF-000031', NULL, 'Si:ch1073-184j22.1', 36, NULL, NULL, 65091),
(65092, '1.10.10.1010-FF-000002', NULL, 'DNA polymerase', 146, NULL, NULL, 65092),
(65093, '3.40.50.300-FF-002368', NULL, 'DNA replication factor, putative', 325, NULL, NULL, 65093),
(65094, '1.20.58.110-FF-000001', NULL, '30S ribosomal protein S20', 87, NULL, NULL, 65094),
(65095, '2.40.33.10-FF-000019', NULL, 'Pyruvate kinase', 104, NULL, NULL, 65095),
(65096, '3.40.190.10-FF-000429', NULL, 'Predicted protein', 105, NULL, NULL, 65096),
(65097, '3.30.40.10-FF-000264', NULL, 'RBR-type E3 ubiquitin transferase', 81, NULL, NULL, 65097),
(65098, '2.130.10.10-FF-000468', NULL, 'WD repeat domain 43', 257, NULL, NULL, 65098),
(65099, '3.10.110.10-FF-000252', NULL, 'RBR-type E3 ubiquitin transferase', 124, NULL, NULL, 65099),
(65100, '3.80.10.10-FF-002328', NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', 117, NULL, NULL, 65100),
(65101, '3.40.50.150-FF-000597', NULL, 'O-methyltransferase', 264, NULL, NULL, 65101),
(65102, '3.10.20.90-FF-000866', NULL, 'Uncharacterized protein', 71, NULL, NULL, 65102),
(65103, '3.30.160.60-FF-004981', NULL, NULL, 57, NULL, NULL, 65103),
(65104, '1.20.58.60-FF-000420', NULL, 'AGAP009554-PA', 292, NULL, NULL, 65104),
(65105, '1.10.10.60-FF-000844', NULL, NULL, 66, NULL, NULL, 65105),
(65106, '3.40.50.1240-FF-000119', NULL, 'Thiamine-repressible acid phosphatase SPBC21H7.03c', 382, NULL, NULL, 65106),
(65107, '3.40.50.1820-FF-000170', NULL, 'Alpha/beta-Hydrolases superfamily protein', 263, NULL, NULL, 65107),
(65108, '3.90.1150.10-FF-000342', NULL, 'Serine-pyruvate aminotransferase', 117, NULL, NULL, 65108),
(65109, '1.20.1310.10-FF-000187', NULL, NULL, 112, NULL, NULL, 65109),
(65110, '3.90.470.10-FF-000013', NULL, '50S ribosomal protein L22', 158, NULL, NULL, 65110),
(65111, '2.30.42.10-FF-000613', NULL, NULL, 124, NULL, NULL, 65111),
(65112, '1.20.1560.10-FF-000121', NULL, 'ABC transporter B family member 9', 311, NULL, NULL, 65112),
(65113, '1.20.1280.50-FF-000010', NULL, 'F-box only protein 7', 76, NULL, NULL, 65113),
(65114, '1.20.1060.10-FF-000027', NULL, 'Predicted protein', 111, NULL, NULL, 65114),
(65115, '1.20.1070.10-FF-000185', NULL, 'Alpha-2B adrenergic receptor', 258, NULL, NULL, 65115),
(65116, '2.60.40.10-FF-001428', NULL, 'CD166 antigen', 85, NULL, NULL, 65116),
(65117, '3.30.40.10-FF-001692', NULL, 'Uncharacterized protein', 70, NULL, NULL, 65117),
(65118, '3.30.160.60-FF-000647', NULL, 'myeloid zinc finger 1 isoform X1', 28, NULL, NULL, 65118),
(65119, '3.40.630.10-FF-000178', NULL, 'M20 domain-containing peptidase, putative', 159, NULL, NULL, 65119),
(65120, '3.90.470.20-FF-000016', NULL, '4-phosphopantetheinyl transferase', 88, NULL, NULL, 65120),
(65121, '3.40.140.10-FF-000157', NULL, 'Pre-mRNA splicing factor Prp8, putative', 278, NULL, NULL, 65121);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(65122, '2.60.34.10-FF-000077', NULL, 'Hsp70 protein, putative', 156, NULL, NULL, 65122),
(65123, '3.40.50.1820-FF-000456', NULL, 'Homoserine O-succinyltransferase', 303, NULL, NULL, 65123),
(65124, '1.20.1270.10-FF-000020', NULL, 'Phosphorylated CTD-interacting factor 1', 78, NULL, NULL, 65124),
(65125, '1.10.287.3510-FF-000006', NULL, 'NADH-quinone oxidoreductase subunit K', 101, NULL, NULL, 65125),
(65126, '2.30.230.10-FF-000024', NULL, 'Vitellogenin', 236, NULL, NULL, 65126),
(65127, '1.20.1230.10-FF-000006', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 250, NULL, NULL, 65127),
(65128, '2.60.40.10-FF-000198', NULL, 'Tripartite motif-containing protein 2', 106, NULL, NULL, 65128),
(65129, '1.10.3470.10-FF-000027', NULL, 'Iron ABC transporter permease', 336, NULL, NULL, 65129),
(65130, '3.40.50.11610-FF-000037', NULL, NULL, 74, NULL, NULL, 65130),
(65131, '3.50.50.60-FF-000773', NULL, 'Flavin-containing monooxygenase, putative', 156, NULL, NULL, 65131),
(65132, '3.30.160.60-FF-005144', NULL, NULL, 30, NULL, NULL, 65132),
(65133, '2.60.40.10-FF-001136', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', 87, NULL, NULL, 65133),
(65134, '4.10.60.10-FF-000152', NULL, 'Cold shock domain-containing protein 3', 26, NULL, NULL, 65134),
(65135, '3.90.1150.10-FF-000016', NULL, 'Lysine decarboxylase, inducible', 166, NULL, NULL, 65135),
(65136, '3.30.160.60-FF-004576', NULL, NULL, 39, NULL, NULL, 65136),
(65137, '1.10.150.60-FF-000041', NULL, NULL, 118, NULL, NULL, 65137),
(65138, '3.40.630.10-FF-000127', NULL, 'Nicastrin, isoform E', 300, NULL, NULL, 65138),
(65139, '1.20.1250.20-FF-001096', NULL, 'MFS general substrate transporter', 447, NULL, NULL, 65139),
(65140, '3.30.40.10-FF-001978', NULL, 'Uncharacterized protein', 61, NULL, NULL, 65140),
(65141, '1.25.10.10-FF-001370', NULL, 'Resistance to inhibitor of cholinesterase 8', 125, NULL, NULL, 65141),
(65142, '2.30.180.10-FF-000194', NULL, NULL, 104, NULL, NULL, 65142),
(65143, '2.20.70.10-FF-000033', NULL, 'Growth arrest specific 7', 49, NULL, NULL, 65143),
(65144, '2.40.10.10-FF-000326', NULL, NULL, 83, NULL, NULL, 65144),
(65145, '1.10.10.60-FF-000457', NULL, 'Trihelix transcription factor GTL2', 66, NULL, NULL, 65145),
(65146, '2.40.15.10-FF-000005', NULL, 'Uncharacterized protein', 74, NULL, NULL, 65146),
(65147, '1.10.10.60-FF-001221', NULL, NULL, 108, NULL, NULL, 65147),
(65148, '3.40.50.2000-FF-000415', NULL, 'Asparagine Linked Glycosylation (ALG) homolog, Nematode', 175, NULL, NULL, 65148),
(65149, '2.40.160.180-FF-000001', NULL, 'Porin', 405, NULL, NULL, 65149),
(65150, '2.40.30.170-FF-000041', NULL, 'Cation efflux system (CzcB-like)', 62, NULL, NULL, 65150),
(65151, '1.20.120.220-FF-000022', NULL, 'ATP synthase F0, A subunit', 116, NULL, NULL, 65151),
(65152, '3.30.200.20-FF-000931', NULL, 'tyrosine-protein kinase receptor torso', 124, NULL, NULL, 65152),
(65153, '2.130.10.10-FF-003109', NULL, 'WD domain, G-beta repeat, putative', 280, NULL, NULL, 65153),
(65154, '3.40.50.720-FF-000751', NULL, 'Fatty acyl-CoA reductase', 352, NULL, NULL, 65154),
(65155, '3.40.50.150-FF-001114', NULL, NULL, 111, NULL, NULL, 65155),
(65156, '3.90.1750.20-FF-000014', NULL, 'Site-specific recombinase', 173, NULL, NULL, 65156),
(65157, '1.20.5.190-FF-000115', NULL, NULL, 39, NULL, NULL, 65157),
(65158, '3.80.10.10-FF-002093', NULL, 'Uncharacterized protein', 324, NULL, NULL, 65158),
(65159, '1.10.10.10-FF-000678', NULL, 'Ribosomal protein S25', 86, NULL, NULL, 65159),
(65160, '3.40.190.10-FF-000840', NULL, 'Predicted protein', 100, NULL, NULL, 65160),
(65161, '3.40.50.720-FF-001656', NULL, 'Probable arogenate/prephenate dehydrogenase', 173, NULL, NULL, 65161),
(65162, '1.20.1270.10-FF-000071', NULL, 'Cytosol-type hsp70', 103, NULL, NULL, 65162),
(65163, '3.40.50.300-FF-005009', NULL, 'Septin 6', 64, NULL, NULL, 65163),
(65164, '3.30.200.160-FF-000013', NULL, 'Uncharacterized protein', 121, NULL, NULL, 65164),
(65165, '3.30.40.10-FF-002029', NULL, 'Uncharacterized protein', 101, NULL, NULL, 65165),
(65166, '3.40.50.1820-FF-000405', NULL, 'Related to CLD1-mitochondrial cardiolipin-specific phospholipase', 163, NULL, NULL, 65166);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(65167, '3.90.1170.10-FF-000012', NULL, 'Unplaced genomic scaffold supercont2.7, whole genome shotgun sequence', 177, NULL, NULL, 65167),
(65168, '2.130.10.10-FF-003031', NULL, 'Uncharacterized protein', 158, NULL, NULL, 65168),
(65169, '1.20.120.230-FF-000025', NULL, 'Vinculin, isoform B', 116, NULL, NULL, 65169),
(65170, '2.60.40.10-FF-005144', NULL, NULL, 120, NULL, NULL, 65170),
(65171, '2.30.29.30-FF-001376', NULL, 'Predicted protein', 123, NULL, NULL, 65171),
(65172, '3.80.10.10-FF-001536', NULL, 'F-box/leucine rich repeat protein, putative', 113, NULL, NULL, 65172),
(65173, '3.40.50.720-FF-002319', NULL, 'Predicted protein', 123, NULL, NULL, 65173),
(65174, '3.30.428.10-FF-000081', NULL, 'Uncharacterized protein', 76, NULL, NULL, 65174),
(65175, '1.25.40.180-FF-000136', NULL, 'Eukaryotic initiation factor', 168, NULL, NULL, 65175),
(65176, '1.25.40.10-FF-003092', NULL, 'AGAP010426-PA', 160, NULL, NULL, 65176),
(65177, '1.10.287.70-FF-000405', NULL, 'Uncharacterized protein', 237, NULL, NULL, 65177),
(65178, '3.30.1520.10-FF-000126', NULL, 'Rho GTPase activator (Bem3), putative (AFU_orthologue AFUA_6G06400)', 123, NULL, NULL, 65178),
(65179, '3.30.830.10-FF-000280', NULL, 'FI23714p1', 216, NULL, NULL, 65179),
(65180, '3.50.50.60-FF-000329', NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase', 248, NULL, NULL, 65180),
(65181, '3.40.50.2300-FF-000241', NULL, 'Guanylate cyclase', 206, NULL, NULL, 65181),
(65182, '1.10.132.60-FF-000044', NULL, 'Uncharacterized protein', 77, NULL, NULL, 65182),
(65183, '2.130.10.10-FF-002593', NULL, 'Predicted protein', 281, NULL, NULL, 65183),
(65184, '3.30.160.60-FF-002985', NULL, 'Zinc finger protein 567', 23, NULL, NULL, 65184),
(65185, '1.10.3720.10-FF-000187', NULL, 'Binding-protein-dependent transport systems inner membrane component', 199, NULL, NULL, 65185),
(65186, '3.40.190.290-FF-000096', NULL, 'LysR family transcriptional regulator', 196, NULL, NULL, 65186),
(65187, '3.20.20.80-FF-000222', NULL, 'Hexosaminidase', 314, NULL, NULL, 65187),
(65188, '3.60.15.10-FF-000233', NULL, 'YALI0E32527p', 234, NULL, NULL, 65188),
(65189, '1.25.40.10-FF-004452', NULL, 'Uncharacterized protein', 114, NULL, NULL, 65189),
(65190, '3.10.330.20-FF-000007', NULL, 'tRNA (adenine(58)-N(1))-methyltransferase catalytic subunit TRM61', 71, NULL, NULL, 65190),
(65191, '3.30.710.10-FF-000214', NULL, 'Potassium voltage-gated channel protein shk-1', 116, NULL, NULL, 65191),
(65192, '2.130.10.10-FF-001311', NULL, 'Bromodomain and WD repeat domain containing 2', 286, NULL, NULL, 65192),
(65193, '2.20.70.10-FF-000084', NULL, 'E3 ubiquitin-protein ligase', 39, NULL, NULL, 65193),
(65194, '2.40.50.40-FF-000062', NULL, 'Chromodomain-helicase-DNA-binding protein 1, isoform C', 132, NULL, NULL, 65194),
(65195, '2.60.40.790-FF-000073', NULL, 'Heat shock protein', 140, NULL, NULL, 65195),
(65196, '3.40.50.360-FF-000042', NULL, 'Multimeric flavodoxin WrbA', 149, NULL, NULL, 65196),
(65197, '3.40.47.10-FF-000009', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 2', 414, NULL, NULL, 65197),
(65198, '1.10.1070.11-FF-000048', NULL, 'Phosphatidylinositol 3-kinase, putative', 189, NULL, NULL, 65198),
(65199, '3.90.180.10-FF-000120', NULL, 'Quinone oxidoreductase-like protein 2', 159, NULL, NULL, 65199),
(65200, '3.30.390.50-FF-000015', NULL, 'Lipoyltransferase 1', 102, NULL, NULL, 65200),
(65201, '3.30.70.330-FF-000051', NULL, 'Heterogeneous nuclear ribonucleoprotein 1', 83, NULL, NULL, 65201),
(65202, '2.120.10.80-FF-000085', NULL, 'host cell factor 1 isoform X4', 301, NULL, NULL, 65202),
(65203, '2.130.10.10-FF-003205', NULL, 'WD repeat-containing protein 38', 85, NULL, NULL, 65203),
(65204, '3.30.70.1290-FF-000007', NULL, 'Transposase', 140, NULL, NULL, 65204),
(65205, '3.60.10.10-FF-000132', NULL, 'Inositol 5-phosphatase, putative (AFU_orthologue AFUA_5G07600)', 387, NULL, NULL, 65205),
(65206, '3.10.330.10-FF-000004', NULL, 'Peroxisome biogenesis factor 1', 82, NULL, NULL, 65206),
(65207, '1.20.1560.10-FF-000172', NULL, 'p-GlycoProtein related', 22, NULL, NULL, 65207);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(65208, '1.20.1070.10-FF-001545', NULL, 'Dopamine receptor D4a', 177, NULL, NULL, 65208),
(65209, '1.10.340.30-FF-000086', NULL, 'Predicted protein', 34, NULL, NULL, 65209),
(65210, '2.60.40.10-FF-000939', NULL, 'Tenascin C', 93, NULL, NULL, 65210),
(65211, '2.70.170.10-FF-000162', NULL, 'Neurotransmitter gated ion channel, putative', 202, NULL, NULL, 65211),
(65212, '3.40.640.10-FF-000279', NULL, 'Uncharacterized protein', 249, NULL, NULL, 65212),
(65213, '2.10.22.10-FF-000006', NULL, NULL, 57, NULL, NULL, 65213),
(65214, '3.40.50.720-FF-000700', NULL, 'Calcium-activated potassium channel subunit alpha-1', 139, NULL, NULL, 65214),
(65215, '1.10.340.30-FF-000035', NULL, 'Base excision DNA repair protein, HhH-GPD family', 110, NULL, NULL, 65215),
(65216, '2.40.180.10-FF-000023', NULL, 'Predicted protein', 120, NULL, NULL, 65216),
(65217, '3.30.70.330-FF-000258', NULL, 'Split ends, isoform D', 76, NULL, NULL, 65217),
(65218, '3.30.430.20-FF-000027', NULL, 'Cysteine-rich repeat secretory protein 55', 107, NULL, NULL, 65218),
(65219, '1.20.1070.10-FF-001848', NULL, 'Arginine vasopressin receptor 2,-like', 299, NULL, NULL, 65219),
(65220, '1.20.58.60-FF-000471', NULL, 'AGAP009554-PA', 136, NULL, NULL, 65220),
(65221, '1.20.120.1780-FF-000013', NULL, '4-hydroxybenzoate polyprenyltransferase, mitochondrial', 86, NULL, NULL, 65221),
(65222, '3.30.160.60-FF-005470', NULL, NULL, 29, NULL, NULL, 65222),
(65223, '1.10.10.160-FF-000011', NULL, 'DNA helicase', 73, NULL, NULL, 65223),
(65224, '2.60.40.820-FF-000003', NULL, 'T-box transcription factor TBX3', 195, NULL, NULL, 65224),
(65225, '2.130.10.10-FF-003082', NULL, 'UTP15 C terminal, putative', 98, NULL, NULL, 65225),
(65226, '3.40.50.720-FF-001982', NULL, 'Oxidoreductase, putative', 248, NULL, NULL, 65226),
(65227, '3.40.50.1170-FF-000008', NULL, 'L-asparaginase 1, putative', 176, NULL, NULL, 65227),
(65228, '3.30.200.20-FF-000038', NULL, 'LIM domain kinase 2', 88, NULL, NULL, 65228),
(65229, '3.40.50.170-FF-000041', NULL, 'Phosphoribosylglycinamide formyltransferase', 195, NULL, NULL, 65229),
(65230, '2.60.120.260-FF-000451', NULL, 'Beta-glucuronidase', 98, NULL, NULL, 65230),
(65231, '3.30.300.20-FF-000023', NULL, 'GTPase Der', 87, NULL, NULL, 65231),
(65232, '2.130.10.10-FF-004958', NULL, 'Uncharacterized protein', 91, NULL, NULL, 65232),
(65233, '1.10.730.10-FF-000065', NULL, 'Leucyl-tRNA synthetase', 263, NULL, NULL, 65233),
(65234, '1.20.900.10-FF-000020', NULL, 'FERM, RhoGEF and pleckstrin domain-containing protein 2', 207, NULL, NULL, 65234),
(65235, '3.40.50.300-FF-003262', NULL, 'CTP synthase', 156, NULL, NULL, 65235),
(65236, '1.10.150.20-FF-000220', NULL, 'UvrABC system protein C', 54, NULL, NULL, 65236),
(65237, '3.40.50.2000-FF-000027', NULL, 'Glycosyltransferase', 179, NULL, NULL, 65237),
(65238, '2.60.200.20-FF-000187', NULL, 'Uncharacterized protein', 95, NULL, NULL, 65238),
(65239, '4.10.800.10-FF-000008', NULL, 'tumor-associated calcium signal transducer 2', 71, NULL, NULL, 65239),
(65240, '2.20.100.10-FF-000180', NULL, 'Uncharacterized protein, isoform D', 57, NULL, NULL, 65240),
(65241, '2.130.10.10-FF-005234', NULL, 'Uncharacterized protein', 19, NULL, NULL, 65241),
(65242, '1.10.472.80-FF-000221', NULL, NULL, 134, NULL, NULL, 65242),
(65243, '3.30.50.10-FF-000057', NULL, 'Gat2p', 43, NULL, NULL, 65243),
(65244, '4.10.470.20-FF-000002', NULL, 'FI02838p', 108, NULL, NULL, 65244),
(65245, '3.50.50.60-FF-000481', NULL, '2-polyprenyl-6-methoxyphenol hydroxylase', 183, NULL, NULL, 65245),
(65246, '3.10.150.10-FF-000018', NULL, 'DNA polymerase III subunit beta', 120, NULL, NULL, 65246),
(65247, '2.40.10.10-FF-000652', NULL, NULL, 111, NULL, NULL, 65247),
(65248, '1.10.472.10-FF-000369', NULL, 'Uncharacterized protein', 79, NULL, NULL, 65248),
(65249, '1.20.80.60-FF-000005', NULL, 'Sorting NeXin', 48, NULL, NULL, 65249),
(65250, '1.25.40.10-FF-002277', NULL, 'Chitin biosynthesis effector, putative', 310, NULL, NULL, 65250),
(65251, '3.40.50.720-FF-002196', NULL, 'Uncharacterized protein', 367, NULL, NULL, 65251),
(65252, '1.25.10.10-FF-003264', NULL, 'Serine/threonine-protein kinase ppk19', 211, NULL, NULL, 65252);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(65253, '3.30.300.30-FF-000026', NULL, 'Short-chain-fatty-acid--CoA ligase', 106, NULL, NULL, 65253),
(65254, '1.50.10.130-FF-000004', NULL, 'Carene synthase, chloroplastic', 240, NULL, NULL, 65254),
(65255, '3.40.50.300-FF-004397', NULL, 'AAA+-type ATPase, putative', 196, NULL, NULL, 65255),
(65256, '3.40.50.300-FF-003211', NULL, 'Elongator complex protein, putative', 323, NULL, NULL, 65256),
(65257, '1.10.10.10-FF-002095', NULL, 'Uncharacterized protein', 56, NULL, NULL, 65257),
(65258, '3.40.50.300-FF-002929', NULL, 'Helicase-like protein', 201, NULL, NULL, 65258),
(65259, '3.30.460.10-FF-000110', NULL, 'DNA-directed DNA/RNA polymerase mu', 123, NULL, NULL, 65259),
(65260, '2.130.10.10-FF-002188', NULL, 'Predicted protein', 177, NULL, NULL, 65260),
(65261, '2.130.10.10-FF-000417', NULL, 'Endoplasmic reticulum to nucleus signaling 2', 240, NULL, NULL, 65261),
(65262, '1.20.1530.20-FF-000061', NULL, 'Arsenical-resistance protein ACR3', 313, NULL, NULL, 65262),
(65263, '3.40.50.720-FF-000521', NULL, 'NAD(P)H-dependent glutamate synthase, putative', 106, NULL, NULL, 65263),
(65264, '2.30.42.10-FF-000052', NULL, 'Syntrophin beta 1', 93, NULL, NULL, 65264),
(65265, '3.40.50.150-FF-001165', NULL, 'Probable polyketide synthase 31', 337, NULL, NULL, 65265),
(65266, '3.30.70.330-FF-002563', NULL, NULL, 147, NULL, NULL, 65266),
(65267, '3.90.1100.10-FF-000064', NULL, 'DNA-directed RNA polymerase subunit beta', 121, NULL, NULL, 65267),
(65268, '3.40.630.10-FF-000453', NULL, 'Uncharacterized protein', 158, NULL, NULL, 65268),
(65269, '3.40.50.1220-FF-000113', NULL, 'NAD-dependent histone deacetylase sir2', 139, NULL, NULL, 65269),
(65270, '3.30.450.30-FF-000059', NULL, 'Uncharacterized protein', 59, NULL, NULL, 65270),
(65271, '2.60.40.150-FF-000555', NULL, 'Uncharacterized protein', 134, NULL, NULL, 65271),
(65272, '3.40.50.2300-FF-000527', NULL, 'GLutamate Receptor family (AMPA)', 164, NULL, NULL, 65272),
(65273, '1.20.1580.10-FF-000004', NULL, 'UvrABC system protein A', 158, NULL, NULL, 65273),
(65274, '1.10.260.40-FF-000037', NULL, 'Type II toxin-antitoxin system HigA family antitoxin', 73, NULL, NULL, 65274),
(65275, '3.40.640.10-FF-000072', NULL, 'Putative cystathionine beta-lyase', 248, NULL, NULL, 65275),
(65276, '3.30.200.20-FF-000656', NULL, 'Serine/threonine protein kinase', 109, NULL, NULL, 65276),
(65277, '1.10.10.60-FF-000406', NULL, 'TetR family transcriptional regulator', 63, NULL, NULL, 65277),
(65278, '1.25.40.20-FF-000868', NULL, 'Uncharacterized protein', 98, NULL, NULL, 65278),
(65279, '3.90.180.10-FF-000171', NULL, 'Uncharacterized protein', 49, NULL, NULL, 65279),
(65280, '2.120.10.10-FF-000024', NULL, 'Laminin G', 379, NULL, NULL, 65280),
(65281, '2.30.30.100-FF-000213', NULL, 'Gem-associated protein 7 homolog', 83, NULL, NULL, 65281),
(65282, '3.50.80.10-FF-000007', NULL, 'D-aminoacyl-tRNA deacylase', 148, NULL, NULL, 65282),
(65283, '3.40.50.720-FF-000425', NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', 331, NULL, NULL, 65283),
(65284, '3.30.70.20-FF-000095', NULL, NULL, 67, NULL, NULL, 65284),
(65285, '3.90.1150.10-FF-000067', NULL, 'Maltose regulon modulator MalY', 145, NULL, NULL, 65285),
(65286, '3.30.710.10-FF-000006', NULL, 'Kelch repeat and BTB domain-containing 6', 123, NULL, NULL, 65286),
(65287, '1.10.10.60-FF-000378', NULL, 'Notochord homeobox', 86, NULL, NULL, 65287),
(65288, '3.30.420.40-FF-000645', NULL, 'Phosphotransferase', 46, NULL, NULL, 65288),
(65289, '1.25.10.10-FF-001201', NULL, 'Putative tubulin folding cofactor D', 415, NULL, NULL, 65289),
(65290, '2.30.29.30-FF-001168', NULL, 'Uncharacterized protein', 98, NULL, NULL, 65290),
(65291, '3.40.50.11950-FF-000004', NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', 103, NULL, NULL, 65291),
(65292, '3.40.50.300-FF-002834', NULL, 'GPN-loop GTPase 2', 260, NULL, NULL, 65292),
(65293, '3.40.50.11960-FF-000007', NULL, 'Uncharacterized protein C19A8.11c', 171, NULL, NULL, 65293),
(65294, '3.40.140.10-FF-000039', NULL, 'tRNA-specific adenosine deaminase', 164, NULL, NULL, 65294); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(65295, '3.30.70.330-FF-000707', NULL, 'RNA binding protein, putative', 102, NULL, NULL, 65295),
(65296, '3.40.50.300-FF-005010', NULL, 'DUF2431 domain protein', 56, NULL, NULL, 65296),
(65297, '3.90.25.10-FF-000030', NULL, 'NAD(P)-binding protein', 101, NULL, NULL, 65297),
(65298, '3.30.1390.20-FF-000034', NULL, 'Predicted protein', 47, NULL, NULL, 65298),
(65299, '3.30.70.60-FF-000045', NULL, 'Chromosome 1, whole genome shotgun sequence', 66, NULL, NULL, 65299),
(65300, '2.60.120.260-FF-000075', NULL, 'Retinoschisin 1', 161, NULL, NULL, 65300),
(65301, '3.30.60.30-FF-000058', NULL, 'agrin isoform X9', 34, NULL, NULL, 65301),
(65302, '2.10.110.10-FF-000121', NULL, 'Rho GTPase activator Rga', 86, NULL, NULL, 65302),
(65303, '3.30.1360.40-FF-000010', NULL, 'DNA topoisomerase (ATP-hydrolyzing)', 93, NULL, NULL, 65303),
(65304, '2.160.10.10-FF-000028', NULL, 'Bifunctional protein GlmU', 189, NULL, NULL, 65304),
(65305, '3.90.20.20-FF-000044', NULL, 'Uncharacterized protein', 111, NULL, NULL, 65305),
(65306, '1.10.510.10-FF-002892', NULL, 'Uncharacterized protein', 271, NULL, NULL, 65306),
(65307, '3.30.200.20-FF-001027', NULL, 'Protein kinase, putative', 93, NULL, NULL, 65307),
(65308, '1.10.400.10-FF-000085', NULL, 'Heterotrimeric G protein alpha subunit 1', 122, NULL, NULL, 65308),
(65309, '2.130.10.10-FF-000294', NULL, 'WD repeat-containing protein 70', 247, NULL, NULL, 65309),
(65310, '3.90.70.10-FF-000623', NULL, 'Calpain, putative cysteine peptidase, Clan CA, family C2, putative', 134, NULL, NULL, 65310),
(65311, '3.90.1150.10-FF-000281', NULL, 'Uncharacterized protein', 105, NULL, NULL, 65311),
(65312, '1.10.1510.30-FF-000014', NULL, 'Uncharacterized protein', 26, NULL, NULL, 65312),
(65313, '2.10.110.10-FF-000059', NULL, 'LIM domain only 2', 78, NULL, NULL, 65313),
(65314, '1.25.10.10-FF-002775', NULL, 'Beta subunit of clathrin adaptor protein AP3', 585, NULL, NULL, 65314),
(65315, '3.40.50.10180-FF-000001', NULL, 'Glycerate kinase', 235, NULL, NULL, 65315),
(65316, '3.40.50.11500-FF-000004', NULL, 'DENN domain-containing protein 2C isoform X1', 175, NULL, NULL, 65316),
(65317, '1.10.150.240-FF-000025', NULL, 'Haloacid dehalogenase-like hydrolase', 75, NULL, NULL, 65317),
(65318, '3.30.760.10-FF-000043', NULL, 'Predicted protein', 162, NULL, NULL, 65318),
(65319, '2.30.42.10-FF-000046', NULL, 'MAGUK p55 subfamily member 7', 89, NULL, NULL, 65319),
(65320, '3.40.50.2300-FF-000174', NULL, 'Acetoacetate metabolism regulatory protein AtoC', 133, NULL, NULL, 65320),
(65321, '2.30.29.30-FF-000712', NULL, 'Virus Induced Reporter Off', 140, NULL, NULL, 65321),
(65322, '2.30.30.100-FF-000152', NULL, 'Gem nuclear organelle associated protein 6', 45, NULL, NULL, 65322),
(65323, '3.30.710.10-FF-000383', NULL, 'Uncharacterized protein', 130, NULL, NULL, 65323),
(65324, '1.25.40.180-FF-000350', NULL, NULL, 81, NULL, NULL, 65324),
(65325, '1.25.40.70-FF-000001', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', 217, NULL, NULL, 65325),
(65326, '2.60.40.10-FF-004981', NULL, NULL, 109, NULL, NULL, 65326),
(65327, '1.25.40.90-FF-000007', NULL, 'Regulation of nuclear pre-mRNA domain-containing protein 1B', 137, NULL, NULL, 65327),
(65328, '1.20.140.30-FF-000001', NULL, 'MOB kinase activator 1A', 214, NULL, NULL, 65328),
(65329, '1.20.1070.10-FF-000651', NULL, 'Uncharacterized protein', 68, NULL, NULL, 65329),
(65330, '2.60.120.200-FF-000635', NULL, 'Uncharacterized protein', 120, NULL, NULL, 65330),
(65331, '1.20.1050.130-FF-000008', NULL, 'Glutamate-tRNA ligase', 157, NULL, NULL, 65331),
(65332, '3.40.50.300-FF-004964', NULL, 'Zgc:136870 protein', 108, NULL, NULL, 65332),
(65333, '3.40.50.10190-FF-000004', NULL, 'DNA ligase', 83, NULL, NULL, 65333),
(65334, '2.60.120.10-FF-000599', NULL, 'Mannose-6-phosphate isomerase', 106, NULL, NULL, 65334),
(65335, '3.90.1410.10-FF-000048', NULL, 'SET domain-containing protein', 294, NULL, NULL, 65335),
(65336, '4.10.1000.10-FF-000040', NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', 60, NULL, NULL, 65336),
(65337, '3.50.50.60-FF-000981', NULL, 'Uncharacterized protein', 88, NULL, NULL, 65337);
INSERT INTO "PUBLIC"."MODEL" VALUES
(65338, '1.20.1050.120-FF-000005', NULL, NULL, 132, NULL, NULL, 65338),
(65339, '2.60.120.650-FF-000208', NULL, 'ABR167Cp', 99, NULL, NULL, 65339),
(65340, '3.30.60.20-FF-000055', NULL, 'PDZ domain-containing protein 8', 75, NULL, NULL, 65340),
(65341, '3.30.40.10-FF-002181', NULL, 'RING finger-containing protein, putative', 81, NULL, NULL, 65341),
(65342, '1.25.40.80-FF-000004', NULL, 'Deoxyribodipyrimidine photolyase', 165, NULL, NULL, 65342),
(65343, '3.30.2350.10-FF-000023', NULL, 'Pseudouridine synthase', 224, NULL, NULL, 65343),
(65344, '3.80.10.10-FF-001991', NULL, 'Uncharacterized protein', 149, NULL, NULL, 65344),
(65345, '3.30.160.60-FF-004458', NULL, NULL, 81, NULL, NULL, 65345),
(65346, '3.30.40.10-FF-002142', NULL, 'RBR-type E3 ubiquitin transferase', 76, NULL, NULL, 65346),
(65347, '2.60.120.560-FF-000007', NULL, 'Alpha-N-arabinofuranosidase 1', 150, NULL, NULL, 65347),
(65348, '2.60.40.10-FF-004705', NULL, NULL, 98, NULL, NULL, 65348),
(65349, '2.60.260.20-FF-000084', NULL, 'Chaperone protein DnaJ', 70, NULL, NULL, 65349),
(65350, '2.60.40.10-FF-004655', NULL, NULL, 96, NULL, NULL, 65350),
(65351, '1.20.1070.10-FF-002096', NULL, 'Uncharacterized protein', 67, NULL, NULL, 65351),
(65352, '2.130.10.10-FF-003110', NULL, 'YALI0E00506p', 279, NULL, NULL, 65352),
(65353, '1.25.10.10-FF-000476', NULL, 'Armadillo repeat only 2', 255, NULL, NULL, 65353),
(65354, '3.10.250.10-FF-000003', NULL, 'Deleted in malignant brain tumors 1', 106, NULL, NULL, 65354),
(65355, '3.20.20.70-FF-000686', NULL, NULL, 188, NULL, NULL, 65355),
(65356, '3.90.226.10-FF-000249', NULL, 'probable methylcrotonoyl-CoA carboxylase beta chain, mitochondrial', 249, NULL, NULL, 65356),
(65357, '1.10.10.1320-FF-000005', NULL, 'Anti-sigma-K factor RskA', 72, NULL, NULL, 65357),
(65358, '1.25.40.180-FF-000018', NULL, 'eukaryotic translation initiation factor 5', 179, NULL, NULL, 65358),
(65359, '3.40.50.300-FF-002891', NULL, 'GTPBP2 isoform 12', 69, NULL, NULL, 65359),
(65360, '1.10.20.10-FF-000297', NULL, NULL, 62, NULL, NULL, 65360),
(65361, '1.10.472.10-FF-000723', NULL, 'Uncharacterized protein', 105, NULL, NULL, 65361),
(65362, '1.10.1450.10-FF-000065', NULL, 'Tetraspanin', 107, NULL, NULL, 65362),
(65363, '1.10.10.60-FF-000283', NULL, 'Transcription factor RAX3', 74, NULL, NULL, 65363),
(65364, '1.10.150.20-FF-000192', NULL, '5'' flap endonuclease, putative', 79, NULL, NULL, 65364),
(65365, '3.40.1190.20-FF-000022', NULL, 'Ribokinase', 322, NULL, NULL, 65365),
(65366, '3.30.50.10-FF-000169', NULL, 'Estrogen receptor-related receptor', 78, NULL, NULL, 65366),
(65367, '3.40.50.2000-FF-000241', NULL, 'Glycosyltransferase', 242, NULL, NULL, 65367),
(65368, '3.30.70.330-FF-000612', NULL, 'Glycine-rich RNA-binding protein 2', 123, NULL, NULL, 65368),
(65369, '1.25.40.10-FF-002653', NULL, 'Trafficking protein particle complex 12', 242, NULL, NULL, 65369),
(65370, '2.60.40.10-FF-001221', NULL, 'T-cell surface glycoprotein CD4', 75, NULL, NULL, 65370),
(65371, '3.40.50.300-FF-008287', NULL, 'Katanin p60 ATPase-containing subunit A1', 31, NULL, NULL, 65371),
(65372, '1.10.238.10-FF-000842', NULL, 'Uncharacterized protein', 76, NULL, NULL, 65372),
(65373, '3.40.50.300-FF-001406', NULL, 'Putative vesicular transport protein (CDC48)', 179, NULL, NULL, 65373),
(65374, '2.60.40.2130-FF-000017', NULL, 'Uncharacterized protein', 66, NULL, NULL, 65374),
(65375, '1.25.40.10-FF-004744', NULL, 'Uncharacterized protein', 73, NULL, NULL, 65375),
(65376, '1.10.510.10-FF-000649', NULL, 'Si:dkey-34d22.3', 181, NULL, NULL, 65376),
(65377, '3.10.20.10-FF-000005', NULL, 'Cell death activator CIDE-B', 119, NULL, NULL, 65377),
(65378, '1.25.40.20-FF-001032', NULL, 'Uncharacterized protein', 134, NULL, NULL, 65378),
(65379, '3.40.50.720-FF-000633', NULL, 'Pentafunctional AROM polypeptide', 142, NULL, NULL, 65379),
(65380, '3.40.640.10-FF-000184', NULL, 'Putative threonine aldolase', 247, NULL, NULL, 65380),
(65381, '2.40.10.10-FF-000298', NULL, NULL, 90, NULL, NULL, 65381),
(65382, '2.130.10.10-FF-005240', NULL, 'CPSF A subunit region family protein', 313, NULL, NULL, 65382);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(65383, '2.10.25.10-FF-001519', NULL, 'Integrin beta', 37, NULL, NULL, 65383),
(65384, '3.40.50.720-FF-000313', NULL, 'Chloroplast stem-loop binding protein of 41 kDa b, chloroplastic', 300, NULL, NULL, 65384),
(65385, '1.10.1420.10-FF-000029', NULL, 'DNA mismatch repair protein MSH2', 247, NULL, NULL, 65385),
(65386, '3.90.650.10-FF-000050', NULL, 'Uncharacterized protein', 168, NULL, NULL, 65386),
(65387, '2.40.50.140-FF-000042', NULL, 'Methionine--tRNA ligase', 111, NULL, NULL, 65387),
(65388, '3.30.2350.20-FF-000026', NULL, 'tRNA pseudouridine synthase D (TruD), variant', 221, NULL, NULL, 65388),
(65389, '2.60.200.40-FF-000030', NULL, 'Diacylglycerol kinase', 172, NULL, NULL, 65389),
(65390, '2.60.40.420-FF-000102', NULL, 'Multi-copper oxidase type I family protein', 180, NULL, NULL, 65390),
(65391, '3.40.50.2300-FF-000853', NULL, NULL, 138, NULL, NULL, 65391),
(65392, '3.30.540.10-FF-000061', NULL, 'Uncharacterized protein', 194, NULL, NULL, 65392),
(65393, '3.30.230.10-FF-000301', NULL, 'AFR226Cp', 116, NULL, NULL, 65393),
(65394, '1.20.1250.20-FF-002085', NULL, 'Uncharacterized protein', 267, NULL, NULL, 65394),
(65395, '2.60.120.990-FF-000001', NULL, 'Aldos-2-ulose dehydratase', 301, NULL, NULL, 65395),
(65396, '2.60.210.10-FF-000038', NULL, 'E3 ubiquitin-protein ligase', 131, NULL, NULL, 65396),
(65397, '3.40.30.10-FF-001191', NULL, 'Uncharacterized protein', 141, NULL, NULL, 65397),
(65398, '3.40.640.10-FF-000364', NULL, 'Aminotransferase', 364, NULL, NULL, 65398),
(65399, '2.20.100.10-FF-000011', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 3', 60, NULL, NULL, 65399),
(65400, '1.25.40.10-FF-003120', NULL, 'Os04g0488200 protein', 60, NULL, NULL, 65400),
(65401, '3.10.310.10-FF-000003', NULL, 'Proline racemase', 158, NULL, NULL, 65401),
(65402, '3.40.50.150-FF-001491', NULL, NULL, 120, NULL, NULL, 65402),
(65403, '3.30.420.40-FF-000853', NULL, 'Uncharacterized protein', 147, NULL, NULL, 65403),
(65404, '3.10.28.10-FF-000068', NULL, 'DNA polymerase', 105, NULL, NULL, 65404),
(65405, '2.30.30.40-FF-000668', NULL, 'Uncharacterized protein', 93, NULL, NULL, 65405),
(65406, '3.30.559.10-FF-000042', NULL, 'Carnitine Palmitoyl Transferase', 278, NULL, NULL, 65406),
(65407, '3.30.420.390-FF-000013', NULL, NULL, 92, NULL, NULL, 65407),
(65408, '1.10.510.10-FF-004354', NULL, NULL, 117, NULL, NULL, 65408),
(65409, '1.10.3810.10-FF-000014', NULL, 'Penicillin-binding protein 2', 194, NULL, NULL, 65409),
(65410, '3.30.70.330-FF-002057', NULL, NULL, 92, NULL, NULL, 65410),
(65411, '1.20.1250.20-FF-000011', NULL, 'MFS multidrug transporter, putative', 429, NULL, NULL, 65411),
(65412, '3.10.110.10-FF-000139', NULL, 'Uncharacterized protein', 150, NULL, NULL, 65412),
(65413, '2.60.40.10-FF-001041', NULL, 'Erythropoietin receptor', 108, NULL, NULL, 65413),
(65414, '2.130.10.10-FF-003317', NULL, 'WD40-repeat-containing domain protein', 152, NULL, NULL, 65414),
(65415, '1.10.287.70-FF-000170', NULL, 'Outward-rectifier potassium channel TOK1', 127, NULL, NULL, 65415),
(65416, '1.20.140.40-FF-000088', NULL, NULL, 108, NULL, NULL, 65416),
(65417, '3.60.90.10-FF-000024', NULL, 'Putative S-adenosylmethionine decarboxylase proenzyme-like', 137, NULL, NULL, 65417),
(65418, '2.60.40.10-FF-003345', NULL, 'Uncharacterized protein', 100, NULL, NULL, 65418),
(65419, '3.60.10.10-FF-000126', NULL, 'Inositol phosphorylsphingolipid-phospholipase C', 294, NULL, NULL, 65419),
(65420, '2.130.10.30-FF-000041', NULL, 'Guanine nucleotide exchange factor SRM1', 464, NULL, NULL, 65420),
(65421, '3.40.50.1820-FF-000248', NULL, 'Serine esterase, putative', 174, NULL, NULL, 65421),
(65422, '3.10.20.90-FF-000658', NULL, 'Cordon-bleu WH2 repeat protein-like 1b', 87, NULL, NULL, 65422),
(65423, '3.40.630.30-FF-000689', NULL, 'N-acetyl-transferase-like protein', 67, NULL, NULL, 65423),
(65424, '1.10.287.70-FF-000052', NULL, 'Sodium channel protein', 157, NULL, NULL, 65424),
(65425, '1.10.575.10-FF-000001', NULL, 'Phospholipase C', 245, NULL, NULL, 65425),
(65426, '3.40.50.12620-FF-000003', NULL, NULL, 141, NULL, NULL, 65426);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(65427, '4.10.860.120-FF-000018', NULL, 'DNA-directed RNA polymerase subunit', 127, NULL, NULL, 65427),
(65428, '1.20.120.1880-FF-000010', NULL, 'Nuclear pore complex protein Nup155', 199, NULL, NULL, 65428),
(65429, '3.40.50.80-FF-000010', NULL, 'Flavohemoprotein', 143, NULL, NULL, 65429),
(65430, '3.30.1550.10-FF-000004', NULL, 'Mitochondrial 54S ribosomal protein YmL19', 68, NULL, NULL, 65430),
(65431, '2.40.50.140-FF-000249', NULL, '30S ribosomal protein S1', 87, NULL, NULL, 65431),
(65432, '3.30.56.10-FF-000042', NULL, 'Uncharacterized protein', 73, NULL, NULL, 65432),
(65433, '1.25.40.1050-FF-000006', NULL, '5''-3'' exoribonuclease', 164, NULL, NULL, 65433),
(65434, '1.10.10.10-FF-000583', NULL, 'NUDIX hydrolase', 78, NULL, NULL, 65434),
(65435, '2.10.25.10-FF-001671', NULL, 'Uncharacterized protein', 45, NULL, NULL, 65435),
(65436, '3.40.50.80-FF-000122', NULL, 'Repressed by TUP1 protein 2', 184, NULL, NULL, 65436),
(65437, '3.30.70.330-FF-001899', NULL, NULL, 80, NULL, NULL, 65437),
(65438, '3.90.550.10-FF-000683', NULL, 'Predicted protein', 81, NULL, NULL, 65438),
(65439, '1.10.630.10-FF-000130', NULL, 'Uncharacterized protein', 472, NULL, NULL, 65439),
(65440, '3.90.550.10-FF-000626', NULL, 'Adenosylcobinamide-phosphate guanylyltransferase', 196, NULL, NULL, 65440),
(65441, '1.20.5.370-FF-000017', NULL, NULL, 54, NULL, NULL, 65441),
(65442, '1.10.10.850-FF-000004', NULL, NULL, 105, NULL, NULL, 65442),
(65443, '3.40.50.80-FF-000217', NULL, 'Uncharacterized protein', 128, NULL, NULL, 65443),
(65444, '1.20.1260.60-FF-000012', NULL, 'Uncharacterized protein', 72, NULL, NULL, 65444),
(65445, '1.10.1670.10-FF-000008', NULL, 'Endonuclease III', 72, NULL, NULL, 65445),
(65446, '3.40.50.300-FF-004689', NULL, 'ATPase, AAA family protein', 158, NULL, NULL, 65446),
(65447, '2.40.110.10-FF-000075', NULL, 'Acyl-coenzyme A oxidase', 137, NULL, NULL, 65447),
(65448, '3.40.50.300-FF-000923', NULL, 'ABC transporter C family member 10', 253, NULL, NULL, 65448),
(65449, '2.160.10.10-FF-000085', NULL, 'Translation initiation factor eif-2b epsilon subunit', 106, NULL, NULL, 65449),
(65450, '3.30.450.20-FF-000562', NULL, 'Two-component sensor histidine kinase', 92, NULL, NULL, 65450),
(65451, '1.25.40.1010-FF-000023', NULL, 'Uncharacterized protein', 85, NULL, NULL, 65451),
(65452, '4.10.60.10-FF-000264', NULL, 'Uncharacterized protein', 58, NULL, NULL, 65452),
(65453, '1.20.1080.10-FF-000039', NULL, 'Formate-nitrite transporter, putative', 270, NULL, NULL, 65453),
(65454, '3.30.160.60-FF-005032', NULL, NULL, 38, NULL, NULL, 65454),
(65455, '3.40.50.150-FF-001614', NULL, NULL, 251, NULL, NULL, 65455),
(65456, '3.30.460.10-FF-000060', NULL, 'DNA polymerase', 40, NULL, NULL, 65456),
(65457, '3.30.70.660-FF-000014', NULL, 'tRNA pseudouridine synthase', 136, NULL, NULL, 65457),
(65458, '2.130.10.10-FF-000389', NULL, 'WD repeat-containing protein 55', 103, NULL, NULL, 65458),
(65459, '3.30.70.330-FF-000500', NULL, 'Polyadenylate-binding protein', 95, NULL, NULL, 65459),
(65460, '3.30.420.40-FF-000920', NULL, 'Uncharacterized protein', 159, NULL, NULL, 65460),
(65461, '3.40.50.300-FF-008562', NULL, 'Blr8088 protein', 195, NULL, NULL, 65461),
(65462, '3.30.70.330-FF-000764', NULL, 'Poly(A) binding protein', 120, NULL, NULL, 65462),
(65463, '1.10.238.10-FF-000567', NULL, 'AT10229p', 76, NULL, NULL, 65463),
(65464, '3.40.50.2300-FF-000292', NULL, 'Low molecular weight phosphotyrosine protein phosphatase', 142, NULL, NULL, 65464),
(65465, '4.10.400.20-FF-000003', NULL, 'Uncharacterized protein', 47, NULL, NULL, 65465),
(65466, '1.10.510.10-FF-001105', NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase', 195, NULL, NULL, 65466),
(65467, '1.20.1160.11-FF-000013', NULL, 'Uncharacterized protein', 71, NULL, NULL, 65467),
(65468, '1.10.950.10-FF-000014', NULL, 'Uncharacterized protein', 42, NULL, NULL, 65468),
(65469, '3.90.1640.10-FF-000037', NULL, 'Probable manganese-dependent inorganic pyrophosphatase', 108, NULL, NULL, 65469),
(65470, '3.30.200.20-FF-002455', NULL, 'Uncharacterized protein', 56, NULL, NULL, 65470);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(65471, '1.25.10.10-FF-002825', NULL, 'Uncharacterized protein', 189, NULL, NULL, 65471),
(65472, '2.130.10.10-FF-001283', NULL, 'Pre-mRNA-splicing factor RSE1', 388, NULL, NULL, 65472),
(65473, '3.90.470.20-FF-000067', NULL, 'Uncharacterized protein', 35, NULL, NULL, 65473),
(65474, '3.40.50.300-FF-002598', NULL, 'GTPase Der', 163, NULL, NULL, 65474),
(65475, '3.90.45.10-FF-000025', NULL, 'Peptide deformylase', 167, NULL, NULL, 65475),
(65476, '2.60.40.10-FF-000698', NULL, 'brevican core protein', 122, NULL, NULL, 65476),
(65477, '2.30.40.10-FF-000002', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 80, NULL, NULL, 65477),
(65478, '3.40.47.10-FF-000178', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase', 424, NULL, NULL, 65478),
(65479, '1.10.418.10-FF-000199', NULL, 'Interaptin', 113, NULL, NULL, 65479),
(65480, '3.80.10.10-FF-002087', NULL, 'Uncharacterized protein', 138, NULL, NULL, 65480),
(65481, '3.40.50.620-FF-000316', NULL, 'Methionyl-tRNA synthetase', 352, NULL, NULL, 65481),
(65482, '3.30.200.20-FF-000364', NULL, 'Interleukin 1 receptor associated kinase 3', 99, NULL, NULL, 65482),
(65483, '1.20.5.1700-FF-000015', NULL, 'Viral A-type inclusion protein, putative', 81, NULL, NULL, 65483),
(65484, '3.30.1120.100-FF-000003', NULL, 'Putative sterigmatocystin biosynthesis fatty acid synthase subunit beta', 116, NULL, NULL, 65484),
(65485, '1.10.10.60-FF-001272', NULL, NULL, 81, NULL, NULL, 65485),
(65486, '3.10.20.90-FF-000872', NULL, 'PARKIN', 68, NULL, NULL, 65486),
(65487, '3.30.470.20-FF-000024', NULL, 'Glutathione synthetase', 108, NULL, NULL, 65487),
(65488, '2.70.150.10-FF-000099', NULL, 'Cation-transporting ATPase', 170, NULL, NULL, 65488),
(65489, '3.90.1010.10-FF-000006', NULL, 'NifU-like N terminal domain protein', 99, NULL, NULL, 65489),
(65490, '3.40.640.10-FF-000307', NULL, 'Aminotransferase, class III', 226, NULL, NULL, 65490),
(65491, '2.10.25.10-FF-001766', NULL, 'Laminin subunit alpha 5', 35, NULL, NULL, 65491),
(65492, '3.60.15.10-FF-000154', NULL, 'Cleavage and polyadenylation specificity factor subunit 2', 200, NULL, NULL, 65492),
(65493, '3.30.470.30-FF-000027', NULL, 'DNA ligase', 126, NULL, NULL, 65493),
(65494, '1.10.472.10-FF-000077', NULL, 'RNA polymerase II holoenzyme cyclin-like subunit', 122, NULL, NULL, 65494),
(65495, '1.25.40.10-FF-004244', NULL, 'Chromosome 1 SCAF14751, whole genome shotgun sequence', 235, NULL, NULL, 65495),
(65496, '2.60.120.260-FF-000007', NULL, 'Discoidin domain receptor tyrosine kinase 1', 171, NULL, NULL, 65496),
(65497, '3.40.50.1460-FF-000101', NULL, 'Uncharacterized protein', 156, NULL, NULL, 65497),
(65498, '3.30.2350.20-FF-000037', NULL, NULL, 139, NULL, NULL, 65498),
(65499, '1.20.5.110-FF-000001', NULL, 'syntaxin-binding protein 5 isoform X1', 62, NULL, NULL, 65499),
(65500, '1.20.58.60-FF-000358', NULL, 'SMAll', 95, NULL, NULL, 65500),
(65501, '3.40.50.1980-FF-000105', NULL, 'Nitrogenase MoFe cofactor biosynthesis protein NifN', 122, NULL, NULL, 65501),
(65502, '3.30.160.60-FF-006049', NULL, NULL, 39, NULL, NULL, 65502),
(65503, '3.90.470.10-FF-000007', NULL, '50S ribosomal protein L22', 121, NULL, NULL, 65503),
(65504, '3.90.226.10-FF-000238', NULL, 'Tail-specific protease', 153, NULL, NULL, 65504),
(65505, '3.30.2350.10-FF-000034', NULL, 'Pseudouridine synthase', 211, NULL, NULL, 65505),
(65506, '1.20.5.120-FF-000004', NULL, 'Proteasome activator complex subunit', 58, NULL, NULL, 65506),
(65507, '3.40.1390.30-FF-000006', NULL, 'Dinuclear metal center protein, YbgI family', 131, NULL, NULL, 65507),
(65508, '3.30.200.20-FF-000544', NULL, 'Calmodulin-binding receptor-like cytoplasmic kinase 1', 114, NULL, NULL, 65508),
(65509, '1.20.1080.10-FF-000028', NULL, 'Probable formate transporter 2', 265, NULL, NULL, 65509),
(65510, '3.40.50.12780-FF-000034', NULL, '2-succinylbenzoate--CoA ligase', 343, NULL, NULL, 65510),
(65511, '3.30.40.10-FF-002063', NULL, 'Uncharacterized protein', 128, NULL, NULL, 65511),
(65512, '1.10.220.150-FF-000048', NULL, 'Uncharacterized protein', 74, NULL, NULL, 65512),
(65513, '1.10.760.10-FF-000067', NULL, '10S-dioxygenase', 152, NULL, NULL, 65513); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(65514, '2.170.140.10-FF-000012', NULL, 'peritrophin-1 isoform X1', 70, NULL, NULL, 65514),
(65515, '3.30.70.330-FF-002675', NULL, NULL, 104, NULL, NULL, 65515),
(65516, '2.60.120.240-FF-000001', NULL, 'Protective antigen', 229, NULL, NULL, 65516),
(65517, '3.30.160.60-FF-002777', NULL, 'Transcription factor Ken 2', 30, NULL, NULL, 65517),
(65518, '1.10.1670.10-FF-000047', NULL, NULL, 91, NULL, NULL, 65518),
(65519, '3.10.110.10-FF-000347', NULL, 'Uncharacterized protein', 149, NULL, NULL, 65519),
(65520, '1.25.10.10-FF-000763', NULL, 'Suppressor protein MPT5', 400, NULL, NULL, 65520),
(65521, '3.30.160.60-FF-005239', NULL, NULL, 29, NULL, NULL, 65521),
(65522, '3.30.470.10-FF-000021', NULL, 'Branched-chain amino acid aminotransferase', 145, NULL, NULL, 65522),
(65523, '1.20.1280.290-FF-000074', NULL, 'YALI0D02046p', 84, NULL, NULL, 65523),
(65524, '3.80.10.10-FF-001828', NULL, 'Reduced ocelli, isoform B', 126, NULL, NULL, 65524),
(65525, '3.30.230.10-FF-000037', NULL, 'L-arabinokinase', 240, NULL, NULL, 65525),
(65526, '3.30.230.130-FF-000078', NULL, 'Uncharacterized protein', 144, NULL, NULL, 65526),
(65527, '1.10.287.70-FF-000113', NULL, 'Potassium voltage-gated channel subfamily KQT member 1', 229, NULL, NULL, 65527),
(65528, '3.50.50.60-FF-000088', NULL, '3-phenylpropionate/cinnamic acid dioxygenase ferredoxin--NAD(+) reductase component', 126, NULL, NULL, 65528),
(65529, '3.40.50.720-FF-002224', NULL, 'Glyoxylate/hydroxypyruvate reductase, putative', 104, NULL, NULL, 65529),
(65530, '1.25.40.20-FF-001296', NULL, 'Uncharacterized protein', 160, NULL, NULL, 65530),
(65531, '3.40.50.720-FF-001948', NULL, 'Uncharacterized protein', 266, NULL, NULL, 65531),
(65532, '1.10.533.10-FF-000236', NULL, 'Predicted protein', 100, NULL, NULL, 65532),
(65533, '2.60.40.10-FF-002289', NULL, 'Protein sidekick homolog', 111, NULL, NULL, 65533),
(65534, '3.30.70.330-FF-002916', NULL, NULL, 129, NULL, NULL, 65534),
(65535, '3.40.190.10-FF-000194', NULL, 'Prephenate dehydratase', 86, NULL, NULL, 65535),
(65536, '1.10.510.10-FF-000588', NULL, 'Calcium-dependent protein kinase 7', 332, NULL, NULL, 65536),
(65537, '2.130.10.10-FF-004099', NULL, 'Predicted protein', 197, NULL, NULL, 65537),
(65538, '2.60.40.10-FF-000973', NULL, 'Hemicentin 1', 91, NULL, NULL, 65538),
(65539, '3.30.160.60-FF-003053', NULL, 'GM22706', 38, NULL, NULL, 65539),
(65540, '3.30.2230.10-FF-000025', NULL, 'Ubiquitin specific peptidase 15', 104, NULL, NULL, 65540),
(65541, '2.60.40.3330-FF-000001', NULL, 'Tyrosine-protein kinase', 112, NULL, NULL, 65541),
(65542, '3.30.830.10-FF-000279', NULL, 'Uncharacterized protein', 218, NULL, NULL, 65542),
(65543, '3.30.160.60-FF-001024', NULL, 'Zinc finger and SCAN domain-containing protein 20', 36, NULL, NULL, 65543),
(65544, '3.10.450.50-FF-000109', NULL, 'Uncharacterized protein', 80, NULL, NULL, 65544),
(65545, '1.20.1250.20-FF-000640', NULL, 'Protein NUCLEAR FUSION DEFECTIVE 4', 220, NULL, NULL, 65545),
(65546, '1.20.1070.10-FF-000090', NULL, 'Long-wave-sensitive opsin 1', 344, NULL, NULL, 65546),
(65547, '1.25.10.10-FF-003056', NULL, 'Predicted protein', 270, NULL, NULL, 65547),
(65548, '1.20.1730.10-FF-000090', NULL, 'Uncharacterized protein', 375, NULL, NULL, 65548),
(65549, '3.30.160.60-FF-002738', NULL, 'ras-responsive element-binding protein 1 isoform X4', 30, NULL, NULL, 65549),
(65550, '2.120.10.30-FF-000536', NULL, 'Protein STRICTOSIDINE SYNTHASE-LIKE 11', 114, NULL, NULL, 65550),
(65551, '1.10.510.10-FF-002729', NULL, NULL, 235, NULL, NULL, 65551),
(65552, '2.10.110.10-FF-000290', NULL, 'Uncharacterized protein', 38, NULL, NULL, 65552),
(65553, '2.40.340.10-FF-000007', NULL, 'Molybdopterin molybdenumtransferase', 79, NULL, NULL, 65553),
(65554, '3.30.2350.10-FF-000091', NULL, 'Zinc finger protein, putative', 85, NULL, NULL, 65554),
(65555, '2.40.128.80-FF-000001', NULL, 'Dipeptidyl peptidase 1', 117, NULL, NULL, 65555),
(65556, '1.25.40.20-FF-001650', NULL, 'Uncharacterized protein', 88, NULL, NULL, 65556),
(65557, '3.30.70.330-FF-000146', NULL, 'RNA-binding protein 47 isoform X1', 75, NULL, NULL, 65557);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(65558, '3.40.1190.20-FF-000140', NULL, NULL, 86, NULL, NULL, 65558),
(65559, '1.10.10.10-FF-001021', NULL, 'Probable transcriptional regulator', 88, NULL, NULL, 65559),
(65560, '3.30.160.60-FF-002890', NULL, NULL, 60, NULL, NULL, 65560),
(65561, '1.20.1740.10-FF-000040', NULL, 'Solute carrier family 12 member 6', 300, NULL, NULL, 65561),
(65562, '2.40.50.140-FF-000480', NULL, 'Single-stranded DNA-binding protein', 134, NULL, NULL, 65562),
(65563, '3.30.1550.10-FF-000015', NULL, '60S ribosomal protein L12, putative', 74, NULL, NULL, 65563),
(65564, '3.30.50.10-FF-000091', NULL, 'Peroxisome proliferator-activated receptor gamma', 40, NULL, NULL, 65564),
(65565, '1.25.10.10-FF-001140', NULL, 'Protein CBG09896', 347, NULL, NULL, 65565),
(65566, '2.60.40.60-FF-000398', NULL, 'Protocadherin cluster 1 gamma 26a', 67, NULL, NULL, 65566),
(65567, '2.160.20.10-FF-000265', NULL, 'Pectinesterase 31', 84, NULL, NULL, 65567),
(65568, '3.80.10.10-FF-000204', NULL, 'Scribbled, isoform O', 66, NULL, NULL, 65568),
(65569, '1.20.140.150-FF-000084', NULL, 'Uncharacterized protein', 210, NULL, NULL, 65569),
(65570, '1.10.1070.11-FF-000087', NULL, 'Uncharacterized protein', 192, NULL, NULL, 65570),
(65571, '2.30.29.70-FF-000016', NULL, 'Protein CBG15320', 123, NULL, NULL, 65571),
(65572, '3.40.50.300-FF-001474', NULL, 'Putative AAA family ATPase', 177, NULL, NULL, 65572),
(65573, '1.20.58.60-FF-000712', NULL, 'Uncharacterized protein', 109, NULL, NULL, 65573),
(65574, '1.25.40.860-FF-000014', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 86, NULL, NULL, 65574),
(65575, '3.40.1470.10-FF-000001', NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit beta 1', 119, NULL, NULL, 65575),
(65576, '2.60.40.10-FF-003227', NULL, 'Novel immune-type receptor 9', 51, NULL, NULL, 65576),
(65577, '1.25.40.10-FF-002389', NULL, 'Pentatricopeptide_repeat_domain/PPR_repeat /PPR_repeat_family_-_putative', 190, NULL, NULL, 65577),
(65578, '2.30.42.10-FF-000456', NULL, NULL, 89, NULL, NULL, 65578),
(65579, '3.30.519.10-FF-000045', NULL, NULL, 79, NULL, NULL, 65579),
(65580, '3.10.290.70-FF-000001', NULL, '40S ribosomal protein S8', 118, NULL, NULL, 65580),
(65581, '3.90.370.10-FF-000011', NULL, 'Uncharacterized protein', 83, NULL, NULL, 65581),
(65582, '3.40.50.300-FF-000569', NULL, 'Rho-related GTP-binding protein Rho6', 185, NULL, NULL, 65582),
(65583, '3.40.50.300-FF-001463', NULL, 'ABC transporter ATP-binding protein', 231, NULL, NULL, 65583),
(65584, '2.130.10.10-FF-001406', NULL, 'Related to pyrimidine 5-nucleotidase', 235, NULL, NULL, 65584),
(65585, '3.40.50.12710-FF-000030', NULL, 'Protein arginine methyltransferase NDUFAF7', 310, NULL, NULL, 65585),
(65586, '3.10.580.10-FF-000101', NULL, 'Predicted protein', 133, NULL, NULL, 65586),
(65587, '3.40.367.20-FF-000012', NULL, 'Phosphotransferase', 272, NULL, NULL, 65587),
(65588, '2.10.110.10-FF-000233', NULL, 'LIM and PET domains protein', 59, NULL, NULL, 65588),
(65589, '3.40.50.300-FF-004897', NULL, 'Sulfotransferase', 180, NULL, NULL, 65589),
(65590, '3.30.40.10-FF-002349', NULL, 'Uncharacterized protein', 88, NULL, NULL, 65590),
(65591, '1.20.900.10-FF-000115', NULL, 'Phosphatidylinositol-3,4,5-trisphosphate-dependent Rac exchange factor 1', 56, NULL, NULL, 65591),
(65592, '3.40.50.80-FF-000009', NULL, 'NADH-cytochrome b5 reductase', 150, NULL, NULL, 65592),
(65593, '3.40.1390.20-FF-000003', NULL, 'HPr kinase/phosphorylase', 135, NULL, NULL, 65593),
(65594, '2.130.10.10-FF-000625', NULL, 'mRNA cleavage and polyadenylation factor subunit', 406, NULL, NULL, 65594),
(65595, '3.30.70.260-FF-000046', NULL, 'Protein MgtC', 91, NULL, NULL, 65595),
(65596, '3.30.70.270-FF-000049', NULL, 'Gag-Pol polyprotein', 80, NULL, NULL, 65596),
(65597, '3.40.50.300-FF-003615', NULL, 'Uncharacterized protein', 204, NULL, NULL, 65597),
(65598, '1.10.10.60-FF-000614', NULL, 'Uncharacterized protein', 66, NULL, NULL, 65598),
(65599, '3.20.20.80-FF-000110', NULL, 'Alpha-L-arabinofuranosidase C', 359, NULL, NULL, 65599),
(65600, '2.60.40.1760-FF-000007', NULL, 'Alpha-glucosidase yihQ', 180, NULL, NULL, 65600);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(65601, '1.10.357.10-FF-000023', NULL, 'Coenzyme Q9', 79, NULL, NULL, 65601),
(65602, '3.20.20.30-FF-000022', NULL, 'Possible oxidoreductase', 302, NULL, NULL, 65602),
(65603, '1.50.10.20-FF-000123', NULL, 'Uncharacterized protein', 100, NULL, NULL, 65603),
(65604, '3.30.450.30-FF-000060', NULL, 'Ragulator complex protein LAMTOR3', 121, NULL, NULL, 65604),
(65605, '3.80.10.10-FF-001980', NULL, 'Si:ch211-256e16.11', 153, NULL, NULL, 65605),
(65606, '3.40.50.1000-FF-000683', NULL, NULL, 157, NULL, NULL, 65606),
(65607, '3.40.50.300-FF-000682', NULL, 'Dynein axonemal heavy chain 17', 181, NULL, NULL, 65607),
(65608, '3.40.190.10-FF-000935', NULL, 'Glutamate receptor, putative', 43, NULL, NULL, 65608),
(65609, '1.25.40.90-FF-000041', NULL, 'Regulator of Ty1 transposition', 137, NULL, NULL, 65609),
(65610, '3.40.50.2000-FF-000802', NULL, 'Protein CBR-UGT-32', 110, NULL, NULL, 65610),
(65611, '3.90.70.10-FF-000887', NULL, 'Uncharacterized protein', 227, NULL, NULL, 65611),
(65612, '3.80.10.10-FF-000642', NULL, 'Leucine-rich receptor-like protein kinase family protein', 239, NULL, NULL, 65612),
(65613, '1.25.10.10-FF-001701', NULL, 'Nipped-B protein', 262, NULL, NULL, 65613),
(65614, '2.60.40.10-FF-002564', NULL, 'AGAP003610-PA', 89, NULL, NULL, 65614),
(65615, '1.10.3110.10-FF-000006', NULL, 'Protoporphyrinogen oxidase', 80, NULL, NULL, 65615),
(65616, '1.10.8.750-FF-000004', NULL, 'Phosphoribosylformylglycinamidine synthase', 60, NULL, NULL, 65616),
(65617, '2.120.10.30-FF-000148', NULL, 'Bll2172 protein', 293, NULL, NULL, 65617),
(65618, '3.100.10.20-FF-000002', NULL, 'CRISPR-associated endonuclease Cas1', 103, NULL, NULL, 65618),
(65619, '3.30.465.10-FF-000110', NULL, 'Oxidoreductase, oxygen dependent, FAD-dependent protein', 128, NULL, NULL, 65619),
(65620, '3.30.1680.10-FF-000019', NULL, 'Semaphorin 4A', 66, NULL, NULL, 65620),
(65621, '1.25.40.10-FF-004805', NULL, 'Uncharacterized protein', 164, NULL, NULL, 65621),
(65622, '3.40.50.300-FF-006488', NULL, 'Uncharacterized protein', 115, NULL, NULL, 65622),
(65623, '3.40.50.300-FF-004279', NULL, 'Uncharacterized protein', 240, NULL, NULL, 65623),
(65624, '1.10.472.10-FF-000487', NULL, 'Cyclin, cyclin d, cell cycle control', 145, NULL, NULL, 65624),
(65625, '1.20.1250.20-FF-000286', NULL, 'MFS efflux transporter', 189, NULL, NULL, 65625),
(65626, '3.30.160.60-FF-006487', NULL, NULL, 30, NULL, NULL, 65626),
(65627, '2.60.220.50-FF-000028', NULL, 'Adhesion G protein-coupled receptor A2', 184, NULL, NULL, 65627),
(65628, '1.50.10.10-FF-000120', NULL, 'Six-hairpin glycosidase-like protein', 205, NULL, NULL, 65628),
(65629, '3.40.50.150-FF-000389', NULL, 'NOL1/NOP2/sun family, putative', 225, NULL, NULL, 65629),
(65630, '3.40.50.360-FF-000160', NULL, 'Uncharacterized protein', 190, NULL, NULL, 65630),
(65631, '1.10.1380.10-FF-000025', NULL, 'Endothelin-converting enzyme 1', 11, NULL, NULL, 65631),
(65632, '1.10.8.740-FF-000001', NULL, 'Dynein heavy chain, cytoplasmic', 93, NULL, NULL, 65632),
(65633, '1.25.10.10-FF-002275', NULL, 'Uncharacterized protein', 336, NULL, NULL, 65633),
(65634, '1.10.8.60-FF-000124', NULL, 'Putative replication factor C3', 64, NULL, NULL, 65634),
(65635, '1.10.600.10-FF-000027', NULL, 'GM22336', 327, NULL, NULL, 65635),
(65636, '3.40.50.1220-FF-000046', NULL, 'Putative indole-3-pyruvate decarboxylase', 153, NULL, NULL, 65636),
(65637, '1.10.10.440-FF-000067', NULL, 'Pre-mRNA processing protein, putative', 70, NULL, NULL, 65637),
(65638, '3.30.40.10-FF-000904', NULL, 'Uncharacterized protein', 79, NULL, NULL, 65638),
(65639, '3.20.20.100-FF-000007', NULL, 'NAD(P)H-dependent D-xylose reductase xyl1', 308, NULL, NULL, 65639),
(65640, '3.40.850.10-FF-000110', NULL, 'Neither inactivation nor afterpotential protein C', 241, NULL, NULL, 65640),
(65641, '3.30.1510.10-FF-000007', NULL, 'Formate--tetrahydrofolate ligase', 97, NULL, NULL, 65641),
(65642, '3.30.1330.40-FF-000070', NULL, 'Predicted protein', 73, NULL, NULL, 65642),
(65643, '2.130.10.10-FF-002654', NULL, 'Uncharacterized protein', 364, NULL, NULL, 65643),
(65644, '2.60.40.10-FF-005779', NULL, NULL, 192, NULL, NULL, 65644);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(65645, '3.30.200.20-FF-001999', NULL, 'Uncharacterized protein', 96, NULL, NULL, 65645),
(65646, '2.170.140.10-FF-000001', NULL, 'Acidic mammalian chitinase', 50, NULL, NULL, 65646),
(65647, '3.50.50.60-FF-000705', NULL, 'Protoporphyrinogen oxidase', 453, NULL, NULL, 65647),
(65648, '3.30.300.160-FF-000013', NULL, 'Type II secretion system protein GspE', 75, NULL, NULL, 65648),
(65649, '2.70.40.10-FF-000006', NULL, 'dCTP deaminase', 158, NULL, NULL, 65649),
(65650, '3.90.1860.10-FF-000020', NULL, 'Uncharacterized protein', 181, NULL, NULL, 65650),
(65651, '3.30.300.180-FF-000019', NULL, 'Chromosomal replication initiator protein DnaA', 80, NULL, NULL, 65651),
(65652, '3.30.230.10-FF-000312', NULL, 'AGAP012568-PA', 114, NULL, NULL, 65652),
(65653, '2.20.70.10-FF-000145', NULL, 'E3 ubiquitin-protein ligase', 47, NULL, NULL, 65653),
(65654, '1.25.10.10-FF-000684', NULL, 'Nucleolar protein 9', 202, NULL, NULL, 65654),
(65655, '1.20.1250.20-FF-001646', NULL, 'Predicted protein', 546, NULL, NULL, 65655),
(65656, '3.40.50.2300-FF-001230', NULL, NULL, 145, NULL, NULL, 65656),
(65657, '3.30.160.60-FF-005352', NULL, NULL, 89, NULL, NULL, 65657),
(65658, '1.10.10.10-FF-001307', NULL, 'Putative HTH-type transcriptional regulator', 89, NULL, NULL, 65658),
(65659, '2.40.70.10-FF-000431', NULL, NULL, 43, NULL, NULL, 65659),
(65660, '1.10.730.10-FF-000183', NULL, 'Uncharacterized protein', 22, NULL, NULL, 65660),
(65661, '3.90.1150.10-FF-000224', NULL, 'Glutamate-1-semialdehyde aminotransferase', 153, NULL, NULL, 65661),
(65662, '2.40.10.10-FF-000534', NULL, NULL, 95, NULL, NULL, 65662),
(65663, '1.25.40.10-FF-000591', NULL, 'Uncharacterized protein', 209, NULL, NULL, 65663),
(65664, '1.10.8.270-FF-000164', NULL, 'Uncharacterized protein', 83, NULL, NULL, 65664),
(65665, '1.10.10.60-FF-000491', NULL, 'Imitation switch isoform alias nucleosome remodeling factor 140 kDa subunit', 109, NULL, NULL, 65665),
(65666, '1.10.287.380-FF-000015', NULL, 'Valine--tRNA ligase', 67, NULL, NULL, 65666),
(65667, '1.10.357.150-FF-000008', NULL, 'Centromere/kinetochore protein zw10-like protein', 200, NULL, NULL, 65667),
(65668, '1.20.1540.10-FF-000108', NULL, 'Uncharacterized protein', 142, NULL, NULL, 65668),
(65669, '3.40.50.300-FF-006763', NULL, 'Uncharacterized protein', 62, NULL, NULL, 65669),
(65670, '2.10.50.30-FF-000004', NULL, 'Taste receptor type 1 member 3-like protein', 76, NULL, NULL, 65670),
(65671, '1.25.10.10-FF-002893', NULL, 'Uncharacterized protein', 482, NULL, NULL, 65671),
(65672, '1.20.1050.10-FF-000088', NULL, 'Glutathione S-transferase', 123, NULL, NULL, 65672),
(65673, '2.40.50.140-FF-000328', NULL, 'Proteasome regulatory ATPase subunit 1', 126, NULL, NULL, 65673),
(65674, '3.40.50.720-FF-001768', NULL, 'GDP-D-mannose dehydratase', 226, NULL, NULL, 65674),
(65675, '1.10.8.240-FF-000003', NULL, 'LPPG domain protein containing protein', 88, NULL, NULL, 65675),
(65676, '3.40.50.150-FF-001283', NULL, NULL, 221, NULL, NULL, 65676),
(65677, '3.40.30.10-FF-000937', NULL, 'Thioredoxin', 112, NULL, NULL, 65677),
(65678, '3.30.559.10-FF-000053', NULL, 'Nonribosomal peptide synthase GliP', 180, NULL, NULL, 65678),
(65679, '3.20.70.20-FF-000022', NULL, 'Vitamin B12-dependent ribonucleotide reductase', 616, NULL, NULL, 65679),
(65680, '3.40.30.10-FF-000994', NULL, 'Uncharacterized protein', 79, NULL, NULL, 65680),
(65681, '3.30.497.10-FF-000116', NULL, 'Serpin peptidase inhibitor 30', 218, NULL, NULL, 65681),
(65682, '1.10.150.20-FF-000315', NULL, 'Uncharacterized protein', 21, NULL, NULL, 65682),
(65683, '2.30.30.40-FF-000281', NULL, 'uncharacterized protein LOC108099255 isoform X3', 71, NULL, NULL, 65683),
(65684, '1.20.1560.10-FF-000054', NULL, 'ABC bile acid transporter', 333, NULL, NULL, 65684),
(65685, '3.50.50.60-FF-000363', NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', 144, NULL, NULL, 65685),
(65686, '1.20.1250.20-FF-000022', NULL, 'Multidrug resistance protein MdtG', 195, NULL, NULL, 65686),
(65687, '3.10.129.10-FF-000098', NULL, 'YER182W-like protein', 174, NULL, NULL, 65687);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(65688, '3.40.1090.10-FF-000152', NULL, 'Phospholipase A2', 418, NULL, NULL, 65688),
(65689, '1.20.5.1160-FF-000022', NULL, 'Lamin A', 51, NULL, NULL, 65689),
(65690, '3.30.1360.230-FF-000005', NULL, NULL, 35, NULL, NULL, 65690),
(65691, '2.60.40.1180-FF-000159', NULL, 'Alpha-L-fucosidase', 116, NULL, NULL, 65691),
(65692, '1.25.10.10-FF-002836', NULL, 'Predicted protein', 180, NULL, NULL, 65692),
(65693, '3.30.160.60-FF-001642', NULL, 'Zinc finger protein 628', 31, NULL, NULL, 65693),
(65694, '3.40.850.10-FF-000284', NULL, 'Kinesin family member 18A', 231, NULL, NULL, 65694),
(65695, '2.10.25.10-FF-001727', NULL, 'Integrin beta', 39, NULL, NULL, 65695),
(65696, '3.20.20.450-FF-000028', NULL, 'Cyclic diguanylate phosphodiesterase', 253, NULL, NULL, 65696),
(65697, '1.20.58.2220-FF-000048', NULL, 'GH12052p', 290, NULL, NULL, 65697),
(65698, '1.10.30.10-FF-000179', NULL, 'Uncharacterized protein', 73, NULL, NULL, 65698),
(65699, '3.40.30.10-FF-001157', NULL, 'Uncharacterized protein', 178, NULL, NULL, 65699),
(65700, '3.40.30.10-FF-000589', NULL, 'Uncharacterized protein', 85, NULL, NULL, 65700),
(65701, '3.30.1490.190-FF-000016', NULL, 'Ferric uptake regulation protein', 49, NULL, NULL, 65701),
(65702, '3.40.50.20-FF-000065', NULL, 'UDP-2,3-diacylglucosamine pyrophosphatase LpxI', 129, NULL, NULL, 65702),
(65703, '1.25.10.10-FF-000919', NULL, 'Protein CBR-TAG-184', 516, NULL, NULL, 65703),
(65704, '2.40.10.10-FF-000539', NULL, NULL, 93, NULL, NULL, 65704),
(65705, '2.30.42.10-FF-000400', NULL, NULL, 87, NULL, NULL, 65705),
(65706, '2.40.30.30-FF-000018', NULL, 'Riboflavin biosynthesis protein', 121, NULL, NULL, 65706),
(65707, '3.40.50.1390-FF-000018', NULL, 'Recombinase family protein', 127, NULL, NULL, 65707),
(65708, '1.10.238.10-FF-001062', NULL, 'Uncharacterized protein', 82, NULL, NULL, 65708),
(65709, '1.10.1070.11-FF-000082', NULL, 'Non-specific serine/threonine protein kinase', 184, NULL, NULL, 65709),
(65710, '3.40.50.720-FF-000015', NULL, 'Ubiquitin-activating enzyme E1 1', 204, NULL, NULL, 65710),
(65711, '3.80.10.10-FF-001654', NULL, 'Leucine-rich repeats and immunoglobulin-like domains 2', 126, NULL, NULL, 65711),
(65712, '1.10.630.10-FF-000630', NULL, 'Uncharacterized protein', 228, NULL, NULL, 65712),
(65713, '3.40.50.1380-FF-000015', NULL, 'Carbamoyl-phosphate synthase arginine-specific large chain', 138, NULL, NULL, 65713),
(65714, '3.40.47.10-FF-000122', NULL, 'Nonspecific lipid-transfer protein, putative', 407, NULL, NULL, 65714),
(65715, '2.30.42.10-FF-000344', NULL, 'Uncharacterized protein, isoform A', 88, NULL, NULL, 65715),
(65716, '3.40.630.10-FF-000296', NULL, 'Uncharacterized protein', 249, NULL, NULL, 65716),
(65717, '1.25.40.20-FF-000857', NULL, 'Kinase, NEK-like', 119, NULL, NULL, 65717),
(65718, '1.10.472.10-FF-000482', NULL, 'Cyclin J-like', 59, NULL, NULL, 65718),
(65719, '3.30.1490.180-FF-000013', NULL, 'DNA-directed RNA polymerase subunit', 55, NULL, NULL, 65719),
(65720, '3.30.720.210-FF-000027', NULL, 'ATP-dependent zinc metalloprotease FtsH', 69, NULL, NULL, 65720),
(65721, '3.30.230.120-FF-000013', NULL, 'Uncharacterized protein', 359, NULL, NULL, 65721),
(65722, '1.10.150.60-FF-000030', NULL, 'Arid/bright domain-containing protein', 125, NULL, NULL, 65722),
(65723, '1.10.510.10-FF-003230', NULL, NULL, 126, NULL, NULL, 65723),
(65724, '1.10.357.140-FF-000005', NULL, 'UbiA prenyltransferase domain-containing protein 1', 158, NULL, NULL, 65724),
(65725, '1.20.1070.10-FF-001882', NULL, 'Predicted protein', 344, NULL, NULL, 65725),
(65726, '3.30.160.60-FF-004812', NULL, NULL, 30, NULL, NULL, 65726),
(65727, '2.110.10.10-FF-000019', NULL, 'Matrix metallopeptidase 28', 79, NULL, NULL, 65727),
(65728, '2.60.34.10-FF-000088', NULL, 'Os01g0688900 protein', 99, NULL, NULL, 65728),
(65729, '3.30.160.60-FF-004863', NULL, NULL, 37, NULL, NULL, 65729),
(65730, '3.40.50.2300-FF-000409', NULL, 'Low molecular weight phosphotyrosine protein phosphatase, putative', 144, NULL, NULL, 65730),
(65731, '1.10.1660.10-FF-000007', NULL, 'HTH-type transcriptional regulator MlrA', 73, NULL, NULL, 65731);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(65732, '2.40.160.10-FF-000027', NULL, 'Mitochondrial import receptor subunit tom-40', 131, NULL, NULL, 65732),
(65733, '3.10.129.110-FF-000012', NULL, 'PKS-NRPS hybrid synthetase psoA', 319, NULL, NULL, 65733),
(65734, '3.30.70.330-FF-001894', NULL, NULL, 85, NULL, NULL, 65734),
(65735, '3.10.110.10-FF-000134', NULL, 'Baculoviral IAP repeat-containing 6', 140, NULL, NULL, 65735),
(65736, '3.30.160.60-FF-001086', NULL, 'zinc finger and BTB domain-containing protein 11', 82, NULL, NULL, 65736),
(65737, '1.25.40.10-FF-000854', NULL, 'Putative pentatricopeptide repeat-containing protein', 96, NULL, NULL, 65737),
(65738, '1.20.1280.290-FF-000012', NULL, 'Vacuolar membrane PQ loop repeat protein', 99, NULL, NULL, 65738),
(65739, '1.10.510.10-FF-002229', NULL, NULL, 236, NULL, NULL, 65739),
(65740, '3.40.50.300-FF-004633', NULL, 'P-loop containing nucleoside triphosphate hydrolases superfamily protein', 71, NULL, NULL, 65740),
(65741, '1.10.600.10-FF-000061', NULL, 'Probable phytoene synthase', 305, NULL, NULL, 65741),
(65742, '3.40.50.12670-FF-000001', NULL, 'Carboxypeptidase', 146, NULL, NULL, 65742),
(65743, '3.40.1090.10-FF-000039', NULL, 'Patatin', 83, NULL, NULL, 65743),
(65744, '3.30.40.10-FF-001916', NULL, 'Peroxisome assembly protein, putative', 72, NULL, NULL, 65744),
(65745, '1.10.3460.10-FF-000026', NULL, 'Chlorophyll a-b binding protein, chloroplastic', 65, NULL, NULL, 65745),
(65746, '1.25.40.10-FF-002945', NULL, 'Uncharacterized protein', 249, NULL, NULL, 65746),
(65747, '3.30.590.10-FF-000007', NULL, 'Protein-arginine kinase', 252, NULL, NULL, 65747),
(65748, '3.60.20.10-FF-000071', NULL, 'Proteasome subunit beta', 241, NULL, NULL, 65748),
(65749, '1.10.8.270-FF-000169', NULL, 'Uncharacterized protein', 74, NULL, NULL, 65749),
(65750, '3.40.50.300-FF-003054', NULL, 'GTP-binding protein RAD', 107, NULL, NULL, 65750),
(65751, '2.70.98.10-FF-000061', NULL, 'Alpha-1,2-mannosidase family protein', 290, NULL, NULL, 65751),
(65752, '2.120.10.30-FF-000362', NULL, 'Uncharacterized protein', 183, NULL, NULL, 65752),
(65753, '3.40.33.10-FF-000101', NULL, 'Predicted protein', 145, NULL, NULL, 65753),
(65754, '3.30.930.10-FF-000040', NULL, 'Asparagine--tRNA ligase, cytoplasmic', 330, NULL, NULL, 65754),
(65755, '1.10.510.10-FF-002555', NULL, 'Uncharacterized protein', 276, NULL, NULL, 65755),
(65756, '3.40.50.12370-FF-000006', NULL, 'Cation/H(+) antiporter 28', 301, NULL, NULL, 65756),
(65757, '1.10.472.10-FF-000431', NULL, 'Cyclin-like protein', 136, NULL, NULL, 65757),
(65758, '1.25.40.690-FF-000019', NULL, 'Uncharacterized protein', 91, NULL, NULL, 65758),
(65759, '2.60.40.10-FF-004363', NULL, NULL, 100, NULL, NULL, 65759),
(65760, '2.40.50.140-FF-000654', NULL, 'Transcription termination/antitermination protein NusA', 63, NULL, NULL, 65760),
(65761, '1.20.1510.10-FF-000017', NULL, 'zinc transporter 4 isoform X1', 222, NULL, NULL, 65761),
(65762, '3.30.70.330-FF-001568', NULL, NULL, 147, NULL, NULL, 65762),
(65763, '3.40.190.290-FF-000039', NULL, 'Iron-regulated virulence regulatory protein IrgB', 203, NULL, NULL, 65763),
(65764, '1.20.1250.20-FF-000522', NULL, 'Chloramphenicol resistance protein DHA1', 386, NULL, NULL, 65764),
(65765, '3.40.850.10-FF-000514', NULL, 'Kinesin-like protein', 118, NULL, NULL, 65765),
(65766, '3.40.630.10-FF-000245', NULL, 'Amidohydrolase family protein', 242, NULL, NULL, 65766),
(65767, '1.10.472.80-FF-000013', NULL, 'TBC1 domain family member 8B', 141, NULL, NULL, 65767),
(65768, '2.40.50.140-FF-000710', NULL, NULL, 112, NULL, NULL, 65768),
(65769, '3.20.10.10-FF-000021', NULL, 'Unplaced genomic scaffold supercont1.114, whole genome shotgun sequence', 133, NULL, NULL, 65769),
(65770, '2.40.50.100-FF-000159', NULL, 'Uncharacterized protein', 51, NULL, NULL, 65770),
(65771, '3.40.309.10-FF-000009', NULL, 'Aldehyde dehydrogenase A', 193, NULL, NULL, 65771),
(65772, '1.25.10.10-FF-003000', NULL, 'Uncharacterized protein', 350, NULL, NULL, 65772),
(65773, '3.80.10.10-FF-003745', NULL, 'Predicted protein', 380, NULL, NULL, 65773),
(65774, '3.30.420.40-FF-001022', NULL, 'Uncharacterized protein', 43, NULL, NULL, 65774);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(65775, '3.40.50.720-FF-002106', NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', 123, NULL, NULL, 65775),
(65776, '3.40.50.20-FF-000014', NULL, 'beta-citrylglutamate synthase B isoform X1', 118, NULL, NULL, 65776),
(65777, '1.10.510.10-FF-002499', NULL, NULL, 200, NULL, NULL, 65777),
(65778, '1.20.120.980-FF-000019', NULL, 'Protein CBG01710', 158, NULL, NULL, 65778),
(65779, '3.80.10.10-FF-001547', NULL, 'NLR family CARD domain containing 5', 295, NULL, NULL, 65779),
(65780, '3.40.190.10-FF-000374', NULL, 'Osmoprotectant transport system substrate-binding protein', 156, NULL, NULL, 65780),
(65781, '1.20.1310.10-FF-000069', NULL, 'Cul3p', 113, NULL, NULL, 65781),
(65782, '1.10.10.10-FF-000291', NULL, 'LysR family transcriptional regulator', 88, NULL, NULL, 65782),
(65783, '3.90.190.10-FF-000351', NULL, 'Putative dual-specificity protein phosphatase', 151, NULL, NULL, 65783),
(65784, '3.30.40.10-FF-000500', NULL, 'SNF2 family domain-containing protein', 61, NULL, NULL, 65784),
(65785, '1.20.1560.10-FF-000003', NULL, 'ABC transporter C family member 10', 314, NULL, NULL, 65785),
(65786, '1.20.1280.20-FF-000024', NULL, 'J-type co-chaperone jac1, mitochondrial', 82, NULL, NULL, 65786),
(65787, '3.30.160.60-FF-001142', NULL, 'Uncharacterized protein', 25, NULL, NULL, 65787),
(65788, '1.10.220.30-FF-000026', NULL, 'Type III secretion system protein', 62, NULL, NULL, 65788),
(65789, '1.10.3890.10-FF-000002', NULL, 'High frequency lysogenization protein HflD homolog', 204, NULL, NULL, 65789),
(65790, '3.40.47.10-FF-000066', NULL, 'Fatty acid synthase subunit alpha, fungi type', 483, NULL, NULL, 65790),
(65791, '3.40.50.970-FF-000129', NULL, 'Transketolase', 180, NULL, NULL, 65791),
(65792, '3.30.160.60-FF-000529', NULL, 'Zinc finger with KRAB and SCAN domains 8', 30, NULL, NULL, 65792),
(65793, '1.10.3970.10-FF-000003', NULL, 'Dos2p', 95, NULL, NULL, 65793),
(65794, '3.30.70.270-FF-000280', NULL, NULL, 107, NULL, NULL, 65794),
(65795, '3.40.50.300-FF-002486', NULL, 'DNA repair protein (Rad57), putative', 223, NULL, NULL, 65795),
(65796, '3.40.50.300-FF-006757', NULL, 'Uncharacterized protein', 65, NULL, NULL, 65796),
(65797, '1.20.1740.10-FF-000101', NULL, 'Uncharacterized protein, isoform A', 146, NULL, NULL, 65797),
(65798, '3.40.50.2300-FF-000561', NULL, 'Protein argonaute 2', 149, NULL, NULL, 65798),
(65799, '2.170.150.10-FF-000007', NULL, 'Putative IgE-dependent histamine-releasing factor', 170, NULL, NULL, 65799),
(65800, '4.10.280.110-FF-000001', NULL, 'pre-mRNA-splicing factor 18 isoform X2', 73, NULL, NULL, 65800),
(65801, '3.40.50.2000-FF-000533', NULL, 'UDP-glucuronosyltransferase', 102, NULL, NULL, 65801),
(65802, '1.20.1050.10-FF-000026', NULL, 'Methionine--tRNA ligase, cytoplasmic', 105, NULL, NULL, 65802),
(65803, '3.40.50.300-FF-004577', NULL, 'DNA helicase', 305, NULL, NULL, 65803),
(65804, '3.30.46.10-FF-000002', NULL, 'Glycine N-methyltransferase', 75, NULL, NULL, 65804),
(65805, '3.30.70.330-FF-000264', NULL, 'nucleolin', 89, NULL, NULL, 65805),
(65806, '2.30.30.30-FF-000159', NULL, 'Global transcription factor', 83, NULL, NULL, 65806),
(65807, '3.30.230.10-FF-000363', NULL, 'Uncharacterized protein', 104, NULL, NULL, 65807),
(65808, '3.30.40.10-FF-001809', NULL, 'E3 ubiquitin-protein ligase', 71, NULL, NULL, 65808),
(65809, '1.20.58.1040-FF-000003', NULL, 'glucan endo-1,3-beta-glucosidase 7', 90, NULL, NULL, 65809),
(65810, '2.60.120.200-FF-000074', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', 191, NULL, NULL, 65810),
(65811, '1.25.10.10-FF-002269', NULL, 'Uncharacterized protein', 341, NULL, NULL, 65811),
(65812, '3.30.200.20-FF-000864', NULL, 'Raf homolog serine/threonine-protein kinase', 90, NULL, NULL, 65812),
(65813, '3.30.200.20-FF-000920', NULL, 'Os12g0432000 protein', 98, NULL, NULL, 65813),
(65814, '3.10.100.10-FF-000364', NULL, NULL, 150, NULL, NULL, 65814),
(65815, '1.10.3720.10-FF-000069', NULL, 'Iron ABC transporter permease', 258, NULL, NULL, 65815),
(65816, '3.10.310.10-FF-000059', NULL, 'Predicted protein', 110, NULL, NULL, 65816),
(65817, '1.20.1070.10-FF-000207', NULL, 'Probable G-protein coupled receptor 149', 275, NULL, NULL, 65817);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(65818, '2.40.70.10-FF-000190', NULL, 'Uncharacterized protein', 138, NULL, NULL, 65818),
(65819, '3.10.260.20-FF-000001', NULL, 'Dachshund homolog 1', 100, NULL, NULL, 65819),
(65820, '1.20.1560.10-FF-000110', NULL, 'Multidrug ABC transporter permease', 319, NULL, NULL, 65820),
(65821, '3.30.390.50-FF-000009', NULL, 'Lipoate-protein ligase A', 89, NULL, NULL, 65821),
(65822, '3.30.70.330-FF-002355', NULL, NULL, 106, NULL, NULL, 65822),
(65823, '2.60.40.10-FF-000759', NULL, 'Immunoglobulin superfamily DCC subclass member 4', 107, NULL, NULL, 65823),
(65824, '3.40.50.1000-FF-000391', NULL, 'Nuclear LIM interactor-interacting factor 3, putative', 177, NULL, NULL, 65824),
(65825, '3.40.50.1240-FF-000108', NULL, 'Histidine phosphatase superfamily (Branch 1), putative', 120, NULL, NULL, 65825),
(65826, '3.30.50.10-FF-000170', NULL, 'Uncharacterized protein', 75, NULL, NULL, 65826),
(65827, '3.40.50.1820-FF-001766', NULL, 'Uncharacterized protein', 219, NULL, NULL, 65827),
(65828, '2.60.200.20-FF-000198', NULL, 'DUF2662 domain-containing protein', 116, NULL, NULL, 65828),
(65829, '2.60.40.3980-FF-000004', NULL, NULL, 77, NULL, NULL, 65829),
(65830, '3.20.20.80-FF-000172', NULL, 'Chitinase', 27, NULL, NULL, 65830),
(65831, '2.60.40.10-FF-003014', NULL, 'Immunoglobulin lambda variable 3-22', 94, NULL, NULL, 65831),
(65832, '3.50.50.60-FF-000037', NULL, 'Dihydrolipoyl dehydrogenase', 122, NULL, NULL, 65832),
(65833, '3.40.50.2000-FF-000207', NULL, 'Phosphatidyl-myo-inositol mannosyltransferase', 177, NULL, NULL, 65833),
(65834, '3.30.1330.60-FF-000014', NULL, 'Flagellar motor protein MotB', 180, NULL, NULL, 65834),
(65835, '3.10.20.90-FF-000597', NULL, 'MGC80376 protein', 86, NULL, NULL, 65835),
(65836, '3.30.160.60-FF-001193', NULL, 'Zinc finger protein 18', 24, NULL, NULL, 65836),
(65837, '1.20.1070.10-FF-001837', NULL, 'Putative neuropeptide receptor', 304, NULL, NULL, 65837),
(65838, '1.10.287.130-FF-000137', NULL, 'Sensor histidine kinase YbdK', 63, NULL, NULL, 65838),
(65839, '2.170.300.10-FF-000103', NULL, 'Uncharacterized protein', 128, NULL, NULL, 65839),
(65840, '3.40.250.10-FF-000204', NULL, 'YALI0F24585p', 140, NULL, NULL, 65840),
(65841, '3.40.50.1820-FF-000136', NULL, 'Pheophytinase, chloroplastic', 326, NULL, NULL, 65841),
(65842, '1.10.1540.10-FF-000004', NULL, 'Neutral sphingomyelinase (N-SMase) activation-associated factor', 123, NULL, NULL, 65842),
(65843, '1.10.510.10-FF-004472', NULL, NULL, 266, NULL, NULL, 65843),
(65844, '3.40.50.11030-FF-000015', NULL, NULL, 149, NULL, NULL, 65844),
(65845, '3.40.50.1820-FF-001822', NULL, 'Protein phosphatase methylesterase 1', 96, NULL, NULL, 65845),
(65846, '3.40.50.150-FF-000384', NULL, 'Protein arginine methyltransferase 9', 163, NULL, NULL, 65846),
(65847, '3.30.1340.30-FF-000011', NULL, 'Type III export protein PscD', 64, NULL, NULL, 65847),
(65848, '3.30.300.20-FF-000012', NULL, 'Ribosome-binding factor A', 115, NULL, NULL, 65848),
(65849, '2.40.50.140-FF-000980', NULL, NULL, 95, NULL, NULL, 65849),
(65850, '1.10.630.10-FF-000411', NULL, 'LOC100145642 protein', 478, NULL, NULL, 65850),
(65851, '1.20.1070.10-FF-001556', NULL, 'Predicted protein', 173, NULL, NULL, 65851),
(65852, '1.10.510.10-FF-002448', NULL, NULL, 245, NULL, NULL, 65852),
(65853, '1.20.1250.20-FF-001938', NULL, 'Predicted protein', 539, NULL, NULL, 65853),
(65854, '2.60.40.790-FF-000067', NULL, 'Tudor domain-containing 12', 113, NULL, NULL, 65854),
(65855, '3.30.40.110-FF-000001', NULL, 'Type III effector hopAB3', 122, NULL, NULL, 65855),
(65856, '1.10.340.30-FF-000024', NULL, 'DNA-3-methyladenine glycosylase', 122, NULL, NULL, 65856),
(65857, '3.90.70.80-FF-000020', NULL, 'OTU-like cysteine protease, putative', 168, NULL, NULL, 65857),
(65858, '1.20.1080.10-FF-000073', NULL, 'Aquaporin 5', 120, NULL, NULL, 65858),
(65859, '3.30.300.30-FF-000015', NULL, 'Nonribosomal peptide synthase SidD', 133, NULL, NULL, 65859),
(65860, '3.40.630.10-FF-000189', NULL, 'Cytosolic non-specific dipeptidase', 76, NULL, NULL, 65860),
(65861, '2.130.10.10-FF-002828', NULL, 'Anaphase-promoting complex subunit 4', 111, NULL, NULL, 65861);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(65862, '1.25.40.20-FF-001532', NULL, 'Kinase, NEK-frag', 149, NULL, NULL, 65862),
(65863, '3.80.10.10-FF-004453', NULL, 'Uncharacterized protein', 103, NULL, NULL, 65863),
(65864, '3.30.50.10-FF-000107', NULL, 'GATA transcription factor 29', 49, NULL, NULL, 65864),
(65865, '3.30.565.10-FF-000376', NULL, 'Hybrid sensory kinase', 152, NULL, NULL, 65865),
(65866, '2.60.120.200-FF-000135', NULL, 'Related to KRE6-glucan synthase subunit', 164, NULL, NULL, 65866),
(65867, '3.40.50.10440-FF-000001', NULL, 'Dihydroxyacetone kinase, DhaK subunit', 171, NULL, NULL, 65867),
(65868, '1.10.287.70-FF-000613', NULL, 'Uncharacterized protein', 247, NULL, NULL, 65868),
(65869, '1.20.5.170-FF-000047', NULL, 'male-specific lethal 1 homolog isoform X1', 58, NULL, NULL, 65869),
(65870, '3.10.50.10-FF-000007', NULL, 'chitinase-like protein Idgf4', 94, NULL, NULL, 65870),
(65871, '3.40.50.720-FF-000190', NULL, 'Pyrroline-5-carboxylate reductase', 167, NULL, NULL, 65871),
(65872, '3.30.160.60-FF-000299', NULL, 'Zinc finger protein 593', 64, NULL, NULL, 65872),
(65873, '2.30.230.10-FF-000013', NULL, 'Hemelipoglyco-carrier protein CP3', 263, NULL, NULL, 65873),
(65874, '3.60.15.10-FF-000272', NULL, 'Uncharacterized protein', 229, NULL, NULL, 65874),
(65875, '2.60.120.260-FF-000631', NULL, 'Similar to c-type cytochrome', 116, NULL, NULL, 65875),
(65876, '3.90.550.10-FF-000278', NULL, 'Alpha-1,6-mannosyl-glycoprotein beta-1,2-N-acetylglucosaminyltransferase', 110, NULL, NULL, 65876),
(65877, '3.60.20.10-FF-000020', NULL, 'Proteasome subunit alpha type', 246, NULL, NULL, 65877),
(65878, '3.40.50.300-FF-007213', NULL, 'ADP ribosylation factor like GTPase 3', 165, NULL, NULL, 65878),
(65879, '3.40.190.10-FF-000486', NULL, 'Transcriptional regulator, LysR family', 95, NULL, NULL, 65879),
(65880, '2.160.20.10-FF-000203', NULL, 'Pectinesterase', 221, NULL, NULL, 65880),
(65881, '2.70.130.10-FF-000159', NULL, NULL, 113, NULL, NULL, 65881),
(65882, '3.40.190.10-FF-000430', NULL, 'Sensor domain-containing diguanylate cyclase', 124, NULL, NULL, 65882),
(65883, '2.130.10.30-FF-000007', NULL, 'E3 ubiquitin-protein ligase UBR5 isoform X2', 207, NULL, NULL, 65883),
(65884, '3.30.40.10-FF-000612', NULL, 'Uncharacterized protein', 86, NULL, NULL, 65884),
(65885, '1.25.40.10-FF-001315', NULL, 'Signal peptidase I', 104, NULL, NULL, 65885),
(65886, '4.10.530.10-FF-000004', NULL, 'Fibrinogen beta chain', 99, NULL, NULL, 65886),
(65887, '3.40.50.1220-FF-000102', NULL, 'Uncharacterized protein', 140, NULL, NULL, 65887),
(65888, '3.30.160.20-FF-000135', NULL, 'Double-stranded RNA-specific editase Adar-like Protein', 90, NULL, NULL, 65888),
(65889, '3.80.10.10-FF-001328', NULL, 'Leucine-rich repeat receptor-like protein kinase PEPR1', 306, NULL, NULL, 65889),
(65890, '2.130.10.10-FF-000737', NULL, 'Elongator complex protein 1', 264, NULL, NULL, 65890),
(65891, '2.30.29.30-FF-000999', NULL, 'EAP30/Vps36 family-domain-containing protein', 130, NULL, NULL, 65891),
(65892, '3.10.290.20-FF-000003', NULL, 'Ubiquitin-activating enzyme E1 C', 89, NULL, NULL, 65892),
(65893, '1.20.120.1240-FF-000043', NULL, 'Uncharacterized protein', 219, NULL, NULL, 65893),
(65894, '3.80.10.10-FF-001598', NULL, 'Predicted protein', 118, NULL, NULL, 65894),
(65895, '3.40.1410.10-FF-000014', NULL, 'GntR family transcriptional regulator', 160, NULL, NULL, 65895),
(65896, '1.20.1440.180-FF-000016', NULL, 'Serine/threonine-protein kinase/endoribonuclease IRE1a', 86, NULL, NULL, 65896),
(65897, '2.60.120.650-FF-000186', NULL, 'Uncharacterized protein', 88, NULL, NULL, 65897),
(65898, '1.10.1520.10-FF-000121', NULL, 'Dicer-like protein', 92, NULL, NULL, 65898),
(65899, '1.10.760.10-FF-000016', NULL, 'Cytochrome c4', 82, NULL, NULL, 65899),
(65900, '3.40.366.10-FF-000041', NULL, 'Putative acyltransferase', 216, NULL, NULL, 65900),
(65901, '3.10.110.10-FF-000078', NULL, 'ubiquitin-conjugating enzyme E2 H isoform X2', 157, NULL, NULL, 65901),
(65902, '3.20.20.80-FF-000402', NULL, 'Predicted protein', 325, NULL, NULL, 65902),
(65903, '3.30.870.10-FF-000164', NULL, 'Uncharacterized protein', 68, NULL, NULL, 65903);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(65904, '2.170.120.20-FF-000008', NULL, '50S ribosomal protein L25', 82, NULL, NULL, 65904),
(65905, '2.60.40.60-FF-000634', NULL, 'Uncharacterized protein', 102, NULL, NULL, 65905),
(65906, '1.25.40.20-FF-001318', NULL, 'Uncharacterized protein', 139, NULL, NULL, 65906),
(65907, '3.30.720.10-FF-000007', NULL, 'Signal recognition particle subunit SRP14', 104, NULL, NULL, 65907),
(65908, '3.60.20.30-FF-000026', NULL, NULL, 138, NULL, NULL, 65908),
(65909, '2.120.10.30-FF-000474', NULL, 'Low density lipoprotein receptor', 57, NULL, NULL, 65909),
(65910, '2.30.30.30-FF-000047', NULL, '60S ribosomal protein L2, mitochondrial', 77, NULL, NULL, 65910),
(65911, '3.40.50.1820-FF-001266', NULL, 'Uncharacterized protein', 305, NULL, NULL, 65911),
(65912, '1.10.10.60-FF-000726', NULL, 'Oocyte-specific homeobox 3', 81, NULL, NULL, 65912),
(65913, '3.40.50.300-FF-002716', NULL, 'Elongation factor G2-like protein', 315, NULL, NULL, 65913),
(65914, '3.90.220.20-FF-000003', NULL, 'Type I restriction-modification system, S subunit', 150, NULL, NULL, 65914),
(65915, '3.30.56.10-FF-000008', NULL, 'Phenylalanyl-tRNA synthetase subunit beta', 89, NULL, NULL, 65915),
(65916, '3.30.70.270-FF-000105', NULL, 'Polyprotein', 119, NULL, NULL, 65916),
(65917, '2.60.40.60-FF-000639', NULL, 'AGAP002828-PA', 128, NULL, NULL, 65917),
(65918, '1.20.5.320-FF-000025', NULL, 'COL1A1 isoform 2', 60, NULL, NULL, 65918),
(65919, '2.130.10.10-FF-004397', NULL, 'Uncharacterized protein', 58, NULL, NULL, 65919),
(65920, '3.30.428.10-FF-000075', NULL, 'Hit family protein 1', 133, NULL, NULL, 65920),
(65921, '3.80.10.10-FF-004234', NULL, 'Uncharacterized protein', 78, NULL, NULL, 65921),
(65922, '3.40.50.1820-FF-000462', NULL, 'S-formylglutathione hydrolase FrmB', 266, NULL, NULL, 65922),
(65923, '1.10.510.10-FF-002774', NULL, NULL, 222, NULL, NULL, 65923),
(65924, '3.30.70.260-FF-000102', NULL, 'Glycine cleavage system transcriptional repressor', 84, NULL, NULL, 65924),
(65925, '1.20.1070.10-FF-000533', NULL, 'MAS1 proto-oncogene-like, G protein-coupled receptor', 286, NULL, NULL, 65925),
(65926, '2.30.230.10-FF-000018', NULL, 'Apolipoprotein B-like protein', 240, NULL, NULL, 65926),
(65927, '3.40.190.10-FF-000435', NULL, 'Peptide ABC transporter, periplasmic peptide-binding protein', 91, NULL, NULL, 65927),
(65928, '1.25.40.20-FF-001313', NULL, 'Uncharacterized protein', 141, NULL, NULL, 65928),
(65929, '1.10.10.60-FF-000496', NULL, 'GL13020', 62, NULL, NULL, 65929),
(65930, '2.120.10.30-FF-000087', NULL, 'Megalin, isoform A', 325, NULL, NULL, 65930),
(65931, '3.40.50.11260-FF-000011', NULL, 'Cation-transporting ATPase, putative', 88, NULL, NULL, 65931),
(65932, '1.20.58.60-FF-000414', NULL, 'AGAP009554-PA', 204, NULL, NULL, 65932),
(65933, '3.60.70.12-FF-000008', NULL, 'S58 family peptidase', 365, NULL, NULL, 65933),
(65934, '1.20.930.20-FF-000007', NULL, 'Cbl proto-oncogene C, E3 ubiquitin protein ligase', 130, NULL, NULL, 65934),
(65935, '3.40.50.150-FF-001171', NULL, NULL, 182, NULL, NULL, 65935),
(65936, '1.10.510.10-FF-003342', NULL, NULL, 41, NULL, NULL, 65936),
(65937, '3.30.1490.20-FF-000013', NULL, 'Formate-dependent phosphoribosylglycinamide formyltransferase', 73, NULL, NULL, 65937),
(65938, '1.20.1560.10-FF-000059', NULL, 'ABC transporter B family member 26, chloroplastic', 320, NULL, NULL, 65938),
(65939, '1.10.287.70-FF-000057', NULL, 'Potassium channel subfamily K member', 268, NULL, NULL, 65939),
(65940, '2.60.120.740-FF-000005', NULL, 'polycystic kidney disease protein 1-like 2', 103, NULL, NULL, 65940),
(65941, '3.40.50.2300-FF-000235', NULL, 'Probable nik-1 protein (Os-1p protein)', 135, NULL, NULL, 65941),
(65942, '1.10.238.10-FF-000724', NULL, 'Probable calcium-binding protein CML34', 66, NULL, NULL, 65942),
(65943, '1.20.20.10-FF-000032', NULL, 'ATP synthase subunit 9, mitochondrial', 72, NULL, NULL, 65943),
(65944, '3.30.70.1530-FF-000001', NULL, 'Lipoprotein', 72, NULL, NULL, 65944),
(65945, '1.25.40.10-FF-002097', NULL, 'Pentatricopeptide repeat-containing protein isoform A', 104, NULL, NULL, 65945),
(65946, '2.10.25.10-FF-000209', NULL, 'Laminin subunit alpha 5', 47, NULL, NULL, 65946);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(65947, '3.40.50.620-FF-000159', NULL, 'Putative receptor-like serine/threonine-protein kinase', 138, NULL, NULL, 65947),
(65948, '3.40.630.150-FF-000020', NULL, 'Predicted protein', 119, NULL, NULL, 65948),
(65949, '3.30.40.10-FF-000225', NULL, 'Death-inducer obliterator 1', 71, NULL, NULL, 65949),
(65950, '3.80.10.10-FF-003964', NULL, 'Si:dkey-31n13.4', 264, NULL, NULL, 65950),
(65951, '3.40.190.10-FF-000379', NULL, 'D-methionine-binding lipoprotein MetQ', 113, NULL, NULL, 65951),
(65952, '2.40.70.10-FF-000195', NULL, 'Aspartic peptidase domain-containing protein', 155, NULL, NULL, 65952),
(65953, '2.60.40.10-FF-003340', NULL, 'Mast/stem cell growth factor receptor kita', 99, NULL, NULL, 65953),
(65954, '3.90.1750.20-FF-000020', NULL, NULL, 127, NULL, NULL, 65954),
(65955, '2.40.50.90-FF-000015', NULL, 'Ribonuclease', 189, NULL, NULL, 65955),
(65956, '3.40.50.1820-FF-000810', NULL, 'Carboxypeptidase', 457, NULL, NULL, 65956),
(65957, '2.60.120.730-FF-000002', NULL, 'Major capsid protein P2', 128, NULL, NULL, 65957),
(65958, '3.60.110.10-FF-000050', NULL, NULL, 102, NULL, NULL, 65958),
(65959, '3.40.50.300-FF-001137', NULL, 'DEAD/DEAH box helicase', 150, NULL, NULL, 65959),
(65960, '2.130.10.10-FF-004453', NULL, 'Ribosome biogenesis protein WDR12 homolog', 346, NULL, NULL, 65960),
(65961, '3.40.30.10-FF-000819', NULL, 'Glutathione S-Transferase', 83, NULL, NULL, 65961),
(65962, '3.40.50.1010-FF-000101', NULL, 'Exonuclease I, putative', 205, NULL, NULL, 65962),
(65963, '2.170.140.10-FF-000063', NULL, 'Uncharacterized protein', 60, NULL, NULL, 65963),
(65964, '3.40.50.150-FF-000951', NULL, 'Small RNA 2''-O-methyltransferase', 300, NULL, NULL, 65964),
(65965, '1.25.10.10-FF-002595', NULL, 'Uncharacterized protein', 151, NULL, NULL, 65965),
(65966, '2.90.10.10-FF-000009', NULL, 'Receptor-like serine/threonine-protein kinase SD1-8', 130, NULL, NULL, 65966),
(65967, '2.20.70.10-FF-000027', NULL, 'pleckstrin homology domain-containing family A member 5 isoform X1', 41, NULL, NULL, 65967),
(65968, '3.90.1110.10-FF-000008', NULL, 'DNA-directed RNA polymerase subunit beta', 177, NULL, NULL, 65968),
(65969, '3.30.559.30-FF-000093', NULL, 'Enniatin synthase', 256, NULL, NULL, 65969),
(65970, '3.30.40.10-FF-001686', NULL, 'Zinc finger protein', 72, NULL, NULL, 65970),
(65971, '2.60.120.260-FF-000338', NULL, 'Uncharacterized protein', 102, NULL, NULL, 65971),
(65972, '1.10.287.110-FF-000098', NULL, 'Chaperone protein dnaJ 20, chloroplastic', 104, NULL, NULL, 65972),
(65973, '1.10.510.10-FF-001543', NULL, 'Cysteine-rich receptor-like protein kinase 41', 201, NULL, NULL, 65973),
(65974, '3.30.200.20-FF-002337', NULL, 'Uncharacterized protein', 69, NULL, NULL, 65974),
(65975, '3.80.10.10-FF-002441', NULL, 'Leucine-rich repeat protein (LRRP)', 135, NULL, NULL, 65975),
(65976, '3.30.70.330-FF-000438', NULL, 'RNA-binding motif protein 15B', 91, NULL, NULL, 65976),
(65977, '2.30.29.30-FF-000151', NULL, 'Rho guanine nucleotide exchange factor 3', 134, NULL, NULL, 65977),
(65978, '3.30.450.40-FF-000068', NULL, 'Diguanylate cyclase (GGDEF) domain protein', 164, NULL, NULL, 65978),
(65979, '3.30.360.10-FF-000075', NULL, 'Aspartate-semialdehyde dehydrogenase', 182, NULL, NULL, 65979),
(65980, '3.30.420.40-FF-000566', NULL, 'Actin 12', 26, NULL, NULL, 65980),
(65981, '3.30.160.60-FF-002446', NULL, 'Uncharacterized protein', 30, NULL, NULL, 65981),
(65982, '3.40.50.300-FF-001182', NULL, 'DExH-box ATP-dependent RNA helicase DExH15 chloroplastic', 270, NULL, NULL, 65982),
(65983, '3.30.450.30-FF-000065', NULL, 'Profilin', 128, NULL, NULL, 65983),
(65984, '3.90.1150.10-FF-000336', NULL, 'Capreomycidine synthase', 125, NULL, NULL, 65984),
(65985, '2.160.20.10-FF-000080', NULL, 'F-box protein 11a', 210, NULL, NULL, 65985),
(65986, '1.10.510.10-FF-001195', NULL, 'VRK serine/threonine kinase 2', 370, NULL, NULL, 65986),
(65987, '2.60.110.10-FF-000031', NULL, 'Os10g0147200 protein', 39, NULL, NULL, 65987),
(65988, '1.20.1110.10-FF-000088', NULL, 'Plasma membrane ATPase', 264, NULL, NULL, 65988),
(65989, '2.60.40.10-FF-001541', NULL, 'Glycoside hydrolase family 2 protein', 129, NULL, NULL, 65989); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(65990, '3.80.10.10-FF-002036', NULL, 'Uncharacterized protein', 91, NULL, NULL, 65990),
(65991, '3.30.1330.50-FF-000011', NULL, 'Uncharacterized protein MG459', 167, NULL, NULL, 65991),
(65992, '3.30.450.20-FF-000062', NULL, 'Diguanylate cyclase (GGDEF) domain protein', 113, NULL, NULL, 65992),
(65993, '2.60.40.10-FF-002446', NULL, 'Titin homolog', 103, NULL, NULL, 65993),
(65994, '3.40.50.11660-FF-000029', NULL, 'Alpha 1,3 fucosyltransferase', 210, NULL, NULL, 65994),
(65995, '3.90.70.10-FF-000387', NULL, 'GM22024', 415, NULL, NULL, 65995),
(65996, '1.25.40.10-FF-000298', NULL, 'N-lysine methyltransferase SMYD2', 68, NULL, NULL, 65996),
(65997, '2.60.120.200-FF-000079', NULL, 'Hydroxyproline O-galactosyltransferase GALT6', 158, NULL, NULL, 65997),
(65998, '3.30.310.80-FF-000053', NULL, 'Non-specific serine/threonine protein kinase', 148, NULL, NULL, 65998),
(65999, '3.40.50.300-FF-005066', NULL, 'Os01g0229400 protein', 128, NULL, NULL, 65999),
(66000, '2.70.20.10-FF-000005', NULL, 'DNA topoisomerase III', 145, NULL, NULL, 66000),
(66001, '3.40.710.10-FF-000004', NULL, 'Peptidoglycan D,D-transpeptidase MrdA', 373, NULL, NULL, 66001),
(66002, '3.30.1490.40-FF-000019', NULL, NULL, 91, NULL, NULL, 66002),
(66003, '1.25.40.10-FF-001310', NULL, 'XPA binding protein 2', 121, NULL, NULL, 66003),
(66004, '3.30.428.10-FF-000024', NULL, 'CWF19-like cell cycle control factor 1', 140, NULL, NULL, 66004),
(66005, '2.130.10.10-FF-005976', NULL, 'Sortilin', 235, NULL, NULL, 66005),
(66006, '2.60.40.10-FF-004918', NULL, NULL, 112, NULL, NULL, 66006),
(66007, '3.30.420.40-FF-000914', NULL, 'Uncharacterized protein', 30, NULL, NULL, 66007),
(66008, '1.10.472.10-FF-000189', NULL, 'Hypothetical_protein', 105, NULL, NULL, 66008),
(66009, '3.40.50.720-FF-001089', NULL, 'Thiamine biosynthesis protein ThiF', 241, NULL, NULL, 66009),
(66010, '1.25.10.10-FF-002157', NULL, 'Uncharacterized protein', 519, NULL, NULL, 66010),
(66011, '3.20.20.80-FF-000514', NULL, 'Uncharacterized protein', 478, NULL, NULL, 66011),
(66012, '3.30.70.1350-FF-000043', NULL, NULL, 74, NULL, NULL, 66012),
(66013, '3.10.100.10-FF-000072', NULL, 'Narrow, isoform B', 163, NULL, NULL, 66013),
(66014, '1.25.40.10-FF-002838', NULL, 'Tetratricopeptide repeat domain 25', 133, NULL, NULL, 66014),
(66015, '3.30.230.10-FF-000251', NULL, 'Lon protease homolog 2, peroxisomal', 257, NULL, NULL, 66015),
(66016, '3.10.28.10-FF-000006', NULL, 'FeS assembly protein SufB', 176, NULL, NULL, 66016),
(66017, '1.20.920.10-FF-000116', NULL, 'SP110 nuclear body protein, tandem duplicate 3', 111, NULL, NULL, 66017),
(66018, '3.40.50.300-FF-001704', NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', 159, NULL, NULL, 66018),
(66019, '1.50.10.20-FF-000005', NULL, 'Geranylgeranyl transferase type-1 subunit beta', 354, NULL, NULL, 66019),
(66020, '3.40.50.150-FF-001108', NULL, NULL, 153, NULL, NULL, 66020),
(66021, '3.40.640.10-FF-000414', NULL, 'Os09g0278300 protein', 82, NULL, NULL, 66021),
(66022, '3.40.50.300-FF-006426', NULL, 'Uncharacterized protein', 128, NULL, NULL, 66022),
(66023, '3.30.160.60-FF-006369', NULL, NULL, 80, NULL, NULL, 66023),
(66024, '3.50.50.60-FF-000149', NULL, 'Dimethylglycine dehydrogenase, mitochondrial', 212, NULL, NULL, 66024),
(66025, '1.20.1250.20-FF-001983', NULL, 'Solute carrier organic anion transporter family member', 392, NULL, NULL, 66025),
(66026, '1.50.10.10-FF-000002', NULL, 'alpha-1,2-Mannosidase', 473, NULL, NULL, 66026),
(66027, '2.160.20.10-FF-000147', NULL, 'Polygalacturonase', 310, NULL, NULL, 66027),
(66028, '2.160.20.10-FF-000315', NULL, 'F-box only protein 11-like Protein', 195, NULL, NULL, 66028),
(66029, '2.30.40.10-FF-000160', NULL, 'Uncharacterized protein', 84, NULL, NULL, 66029),
(66030, '1.10.630.10-FF-000304', NULL, '25-hydroxycholesterol 7-alpha-hydroxylase-like isoform X1', 481, NULL, NULL, 66030),
(66031, '3.40.1490.10-FF-000002', NULL, 'Peptidyl-tRNA hydrolase 2, mitochondrial', 116, NULL, NULL, 66031),
(66032, '1.10.10.10-FF-000846', NULL, 'RNA polymerase sigma factor', 77, NULL, NULL, 66032),
(66033, '3.30.160.60-FF-002098', NULL, 'Zinc finger protein 236', 45, NULL, NULL, 66033);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(66034, '3.40.640.10-FF-000066', NULL, 'Aspartate aminotransferase', 242, NULL, NULL, 66034),
(66035, '1.25.40.10-FF-000416', NULL, 'Tetratricopeptide repeat protein 28', 162, NULL, NULL, 66035),
(66036, '2.120.10.10-FF-000030', NULL, 'Trans-sialidase, putative', 295, NULL, NULL, 66036),
(66037, '2.60.40.10-FF-005138', NULL, NULL, 96, NULL, NULL, 66037),
(66038, '3.40.50.300-FF-001356', NULL, 'ADP ribosylation factor like GTPase 8B', 144, NULL, NULL, 66038),
(66039, '3.40.390.10-FF-000029', NULL, 'Mitochondrial intermediate peptidase 1', 155, NULL, NULL, 66039),
(66040, '3.40.850.10-FF-000109', NULL, 'Transcription initiation factor TFIID subunit 13', 433, NULL, NULL, 66040),
(66041, '2.60.120.650-FF-000242', NULL, 'Uncharacterized protein', 73, NULL, NULL, 66041),
(66042, '2.60.40.10-FF-001215', NULL, 'Uncharacterized protein, isoform F', 105, NULL, NULL, 66042),
(66043, '2.60.120.200-FF-000130', NULL, 'Crumbs 2, cell polarity complex component', 154, NULL, NULL, 66043),
(66044, '1.20.1250.20-FF-001764', NULL, 'Transport protein, putative', 190, NULL, NULL, 66044),
(66045, '1.10.30.10-FF-000174', NULL, 'Predicted protein', 88, NULL, NULL, 66045),
(66046, '3.30.710.10-FF-000001', NULL, 'Kelch-like family member 20', 129, NULL, NULL, 66046),
(66047, '3.40.80.10-FF-000013', NULL, 'Autolysin amidase', 212, NULL, NULL, 66047),
(66048, '3.30.160.60-FF-002772', NULL, 'Zinc finger protein 142', 24, NULL, NULL, 66048),
(66049, '2.30.29.240-FF-000023', NULL, 'Phosphoinositide phospholipase C', 113, NULL, NULL, 66049),
(66050, '2.130.10.10-FF-001524', NULL, 'CPSF A subunit region protein, putative', 314, NULL, NULL, 66050),
(66051, '3.30.420.10-FF-000405', NULL, NULL, 187, NULL, NULL, 66051),
(66052, '3.30.200.20-FF-002163', NULL, 'Predicted protein', 64, NULL, NULL, 66052),
(66053, '3.10.450.10-FF-000064', NULL, 'AGAP002879-PB', 121, NULL, NULL, 66053),
(66054, '4.10.1000.10-FF-000006', NULL, 'Putative pre-mrna-splicing factor rbm22', 71, NULL, NULL, 66054),
(66055, '2.40.50.140-FF-000542', NULL, 'mRNA-capping enzyme subunit alpha', 138, NULL, NULL, 66055),
(66056, '2.30.29.230-FF-000020', NULL, 'Uncharacterized protein', 196, NULL, NULL, 66056),
(66057, '3.30.1360.10-FF-000029', NULL, 'Uncharacterized protein', 127, NULL, NULL, 66057),
(66058, '1.25.40.10-FF-002771', NULL, 'Uncharacterized protein', 126, NULL, NULL, 66058),
(66059, '3.30.1050.10-FF-000045', NULL, 'Predicted protein', 117, NULL, NULL, 66059),
(66060, '3.30.70.330-FF-000590', NULL, 'Polyadenylate-binding protein 5', 98, NULL, NULL, 66060),
(66061, '3.40.50.1170-FF-000014', NULL, 'Predicted protein', 115, NULL, NULL, 66061),
(66062, '2.60.200.20-FF-000193', NULL, 'ABC transporter', 94, NULL, NULL, 66062),
(66063, '3.80.20.20-FF-000067', NULL, 'Cell wall protein ecm33', 193, NULL, NULL, 66063),
(66064, '3.30.160.60-FF-001760', NULL, 'Zinc finger protein 1057', 22, NULL, NULL, 66064),
(66065, '1.10.10.10-FF-002089', NULL, 'Uncharacterized protein', 68, NULL, NULL, 66065),
(66066, '3.40.50.10240-FF-000036', NULL, 'Uncharacterized protein', 223, NULL, NULL, 66066),
(66067, '1.10.150.20-FF-000158', NULL, 'DNA integrity scanning protein DisA', 65, NULL, NULL, 66067),
(66068, '2.40.30.10-FF-000193', NULL, 'Possible oxygenase', 97, NULL, NULL, 66068),
(66069, '3.40.50.150-FF-000676', NULL, 'Uncharacterized protein', 280, NULL, NULL, 66069),
(66070, '2.60.40.1170-FF-000095', NULL, NULL, 112, NULL, NULL, 66070),
(66071, '2.120.10.30-FF-000036', NULL, 'Pro-epidermal growth factor', 314, NULL, NULL, 66071),
(66072, '1.10.340.30-FF-000029', NULL, 'AGAP001854-PA', 125, NULL, NULL, 66072),
(66073, '1.10.1450.10-FF-000177', NULL, 'Tetraspanin', 117, NULL, NULL, 66073),
(66074, '2.60.200.10-FF-000038', NULL, 'Predicted protein', 208, NULL, NULL, 66074),
(66075, '3.40.50.2300-FF-000179', NULL, 'Transcriptional regulator, LuxR family', 203, NULL, NULL, 66075),
(66076, '1.25.40.10-FF-002619', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 159, NULL, NULL, 66076),
(66077, '3.40.1090.10-FF-000034', NULL, 'Patatin', 374, NULL, NULL, 66077);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(66078, '3.40.50.10390-FF-000002', NULL, 'Gingipain R2', 117, NULL, NULL, 66078),
(66079, '1.20.1560.10-FF-000115', NULL, 'multidrug resistance-associated protein 4 isoform X4', 234, NULL, NULL, 66079),
(66080, '2.60.40.10-FF-004649', NULL, NULL, 102, NULL, NULL, 66080),
(66081, '3.10.150.10-FF-000024', NULL, 'Beta sliding clamp', 128, NULL, NULL, 66081),
(66082, '1.10.720.50-FF-000003', NULL, 'DNA (cytosine-5-)-methyltransferase 3 beta, duplicate b.2', 68, NULL, NULL, 66082),
(66083, '3.30.1370.240-FF-000016', NULL, 'Uncharacterized protein', 74, NULL, NULL, 66083),
(66084, '1.20.1740.10-FF-000152', NULL, 'Uncharacterized protein', 240, NULL, NULL, 66084),
(66085, '3.90.640.10-FF-000105', NULL, 'Heat shock protein 70, putative', 90, NULL, NULL, 66085),
(66086, '1.20.1230.10-FF-000012', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 249, NULL, NULL, 66086),
(66087, '1.25.40.10-FF-003108', NULL, 'Uncharacterized protein', 95, NULL, NULL, 66087),
(66088, '1.25.10.10-FF-003051', NULL, 'Uncharacterized protein', 278, NULL, NULL, 66088),
(66089, '3.40.50.300-FF-006645', NULL, 'Uncharacterized protein', 89, NULL, NULL, 66089),
(66090, '1.25.40.420-FF-000017', NULL, 'Influenza virus NS1A-binding protein-like protein', 90, NULL, NULL, 66090),
(66091, '1.20.1050.10-FF-000245', NULL, 'Uncharacterized protein', 61, NULL, NULL, 66091),
(66092, '3.30.342.10-FF-000010', NULL, 'DNA polymerase epsilon catalytic subunit', 115, NULL, NULL, 66092),
(66093, '1.10.10.10-FF-001521', NULL, 'Histone acetyltransferase', 80, NULL, NULL, 66093),
(66094, '3.40.50.2000-FF-000645', NULL, 'Alphaalpha-trehalose-phosphate synthase [UDP-forming] 5', 108, NULL, NULL, 66094),
(66095, '1.20.1250.20-FF-000303', NULL, 'Inner membrane protein YqcE', 206, NULL, NULL, 66095),
(66096, '3.40.50.2300-FF-001539', NULL, NULL, 56, NULL, NULL, 66096),
(66097, '3.40.50.150-FF-001401', NULL, NULL, 166, NULL, NULL, 66097),
(66098, '3.40.190.10-FF-000609', NULL, 'Twin-arginine translocation pathway signal protein', 187, NULL, NULL, 66098),
(66099, '3.30.450.380-FF-000011', NULL, NULL, 227, NULL, NULL, 66099),
(66100, '2.30.30.490-FF-000010', NULL, 'Origin recognition complex subunit 1', 165, NULL, NULL, 66100),
(66101, '1.25.40.10-FF-004418', NULL, 'Uncharacterized protein', 129, NULL, NULL, 66101),
(66102, '2.30.30.190-FF-000021', NULL, 'Cylindromatosis (turban tumor syndrome), like', 91, NULL, NULL, 66102),
(66103, '3.40.50.720-FF-000307', NULL, '2-dehydropantoate 2-reductase', 176, NULL, NULL, 66103),
(66104, '2.30.170.40-FF-000011', NULL, '50S ribosomal protein L28', 77, NULL, NULL, 66104),
(66105, '1.10.8.500-FF-000008', NULL, 'Methyl-accepting chemotaxis protein', 51, NULL, NULL, 66105),
(66106, '2.40.50.120-FF-000030', NULL, 'AGAP003319-PA', 86, NULL, NULL, 66106),
(66107, '3.90.650.10-FF-000044', NULL, 'Phosphoribosylformylglycinamidine synthase', 184, NULL, NULL, 66107),
(66108, '3.90.190.10-FF-000020', NULL, 'Tyrosine-protein phosphatase non-receptor type 5', 299, NULL, NULL, 66108),
(66109, '3.30.780.10-FF-000005', NULL, 'Sui1 translation initiation factor', 115, NULL, NULL, 66109),
(66110, '2.30.29.30-FF-000706', NULL, 'Amyloid beta (A4) precursor protein-binding, family B, member 2b', 101, NULL, NULL, 66110),
(66111, '1.10.30.20-FF-000002', NULL, 'DNA repair helicase RAD3, putative', 75, NULL, NULL, 66111),
(66112, '3.80.10.10-FF-004060', NULL, 'Uncharacterized protein', 134, NULL, NULL, 66112),
(66113, '2.10.110.10-FF-000115', NULL, 'Rho GTPase-activating protein', 61, NULL, NULL, 66113),
(66114, '2.60.120.260-FF-000069', NULL, 'Usherin', 225, NULL, NULL, 66114),
(66115, '2.60.120.260-FF-000125', NULL, 'Intracellular beta-galactosidase BgaD', 207, NULL, NULL, 66115),
(66116, '1.25.40.20-FF-001083', NULL, 'Kinase, NEK', 114, NULL, NULL, 66116),
(66117, '1.25.10.10-FF-001139', NULL, 'HEAT repeat containing 5a', 561, NULL, NULL, 66117),
(66118, '3.30.40.10-FF-000051', NULL, 'RBR-type E3 ubiquitin transferase', 88, NULL, NULL, 66118),
(66119, '2.60.40.10-FF-000760', NULL, 'tenascin-X', 105, NULL, NULL, 66119);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(66120, '3.40.50.300-FF-000687', NULL, 'Ras-related protein RABF2b', 190, NULL, NULL, 66120),
(66121, '3.30.160.60-FF-001428', NULL, 'zinc finger and BTB domain-containing protein 38', 33, NULL, NULL, 66121),
(66122, '1.25.40.10-FF-001080', NULL, 'Pentatricopeptide repeat-containing protein', 157, NULL, NULL, 66122),
(66123, '3.40.50.2300-FF-000123', NULL, 'Vomeronasal 2, receptor 105', 304, NULL, NULL, 66123),
(66124, '1.10.238.10-FF-000836', NULL, 'Uncharacterized calcium-binding protein B0563.7', 83, NULL, NULL, 66124),
(66125, '3.30.43.10-FF-000029', NULL, 'FAD-binding oxidoreductase', 88, NULL, NULL, 66125),
(66126, '2.40.50.140-FF-000036', NULL, '30S ribosomal protein S1', 85, NULL, NULL, 66126),
(66127, '3.40.50.620-FF-000047', NULL, 'Isoleucine--tRNA ligase', 216, NULL, NULL, 66127),
(66128, '1.10.1510.30-FF-000008', NULL, 'Probable tRNA pseudouridine synthase D', 89, NULL, NULL, 66128),
(66129, '3.40.50.720-FF-002437', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', 177, NULL, NULL, 66129),
(66130, '2.130.10.10-FF-004627', NULL, 'Uncharacterized protein', 198, NULL, NULL, 66130),
(66131, '3.40.50.11660-FF-000030', NULL, NULL, 209, NULL, NULL, 66131),
(66132, '3.40.50.10240-FF-000042', NULL, 'Thiamin pyrophosphokinase 1', 70, NULL, NULL, 66132),
(66133, '1.10.10.2430-FF-000001', NULL, 'Nuclear factor related to kappaB binding protein', 127, NULL, NULL, 66133),
(66134, '2.30.180.10-FF-000076', NULL, 'Stabilin 2', 136, NULL, NULL, 66134),
(66135, '3.40.50.150-FF-001440', NULL, NULL, 145, NULL, NULL, 66135),
(66136, '3.40.50.410-FF-000315', NULL, 'Integrin beta', 241, NULL, NULL, 66136),
(66137, '3.30.70.660-FF-000065', NULL, 'tRNA pseudouridine synthase', 181, NULL, NULL, 66137),
(66138, '2.60.40.150-FF-000229', NULL, 'Translocation protein SEC63', 121, NULL, NULL, 66138),
(66139, '3.30.200.20-FF-001994', NULL, 'Uncharacterized protein', 97, NULL, NULL, 66139),
(66140, '2.60.40.10-FF-002890', NULL, 'Alpha-1-B glycoprotein', 101, NULL, NULL, 66140),
(66141, '3.30.760.10-FF-000004', NULL, 'Eukaryotic translation initiation factor 4E-1', 213, NULL, NULL, 66141),
(66142, '3.90.25.10-FF-000024', NULL, 'GAL10p UDP-glucose-4-epimerase', 65, NULL, NULL, 66142),
(66143, '2.130.10.10-FF-002542', NULL, 'Hybrid sensor histidine kinase/response regulator', 305, NULL, NULL, 66143),
(66144, '3.40.850.10-FF-000222', NULL, 'Kinesin-like protein', 350, NULL, NULL, 66144),
(66145, '3.40.30.10-FF-000302', NULL, 'Oligosaccharyl transferase subunit (Gamma), putative', 163, NULL, NULL, 66145),
(66146, '3.30.200.20-FF-001887', NULL, 'cAMP-dependent protein kinase catalytic subunit, putative', 58, NULL, NULL, 66146),
(66147, '3.40.850.10-FF-000172', NULL, 'Kinesin protein kif7', 353, NULL, NULL, 66147),
(66148, '1.10.1510.10-FF-000002', NULL, 'Altered inheritance of mitochondria protein 41, mitochondrial', 88, NULL, NULL, 66148),
(66149, '2.130.10.10-FF-004666', NULL, 'Protein CBR-ELP-1', 185, NULL, NULL, 66149),
(66150, '2.40.70.10-FF-000369', NULL, NULL, 207, NULL, NULL, 66150),
(66151, '2.40.70.10-FF-000425', NULL, NULL, 82, NULL, NULL, 66151),
(66152, '3.40.50.1000-FF-000840', NULL, NULL, 73, NULL, NULL, 66152),
(66153, '3.40.50.1860-FF-000007', NULL, 'Glutamate racemase', 117, NULL, NULL, 66153),
(66154, '1.20.5.1940-FF-000008', NULL, 'Class E vacuolar protein-sorting machinery protein hse1', 83, NULL, NULL, 66154),
(66155, '3.90.190.20-FF-000062', NULL, 'Folylpolyglutamate synthetase', 131, NULL, NULL, 66155),
(66156, '1.20.950.20-FF-000003', NULL, 'Ni/Fe-hydrogenase 1 b-type cytochrome subunit', 204, NULL, NULL, 66156),
(66157, '3.40.50.1110-FF-000131', NULL, 'Uncharacterized protein', 228, NULL, NULL, 66157),
(66158, '3.40.390.10-FF-000142', NULL, 'Astacin', 200, NULL, NULL, 66158),
(66159, '3.40.50.300-FF-001581', NULL, 'Blast:Protein scarlet', 239, NULL, NULL, 66159),
(66160, '1.10.20.10-FF-000347', NULL, NULL, 96, NULL, NULL, 66160),
(66161, '2.60.120.260-FF-000182', NULL, 'Exo-beta-D-glucosaminidase', 184, NULL, NULL, 66161),
(66162, '3.30.1880.10-FF-000001', NULL, NULL, 64, NULL, NULL, 66162);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(66163, '1.25.10.10-FF-002831', NULL, 'Beta-tubulin cofactor D family protein', 186, NULL, NULL, 66163),
(66164, '2.40.30.10-FF-000209', NULL, 'GTP-binding protein, putative', 94, NULL, NULL, 66164),
(66165, '2.10.110.10-FF-000172', NULL, 'Protein CBG11874', 67, NULL, NULL, 66165),
(66166, '1.10.730.10-FF-000071', NULL, 'Arginine--tRNA ligase', 119, NULL, NULL, 66166),
(66167, '1.20.1560.10-FF-000621', NULL, 'Predicted protein', 323, NULL, NULL, 66167),
(66168, '1.10.10.10-FF-000852', NULL, 'Nse1p', 128, NULL, NULL, 66168),
(66169, '3.40.50.10190-FF-000330', NULL, 'Uncharacterized protein', 57, NULL, NULL, 66169),
(66170, '1.20.1530.20-FF-000055', NULL, 'Predicted protein', 329, NULL, NULL, 66170),
(66171, '2.60.40.420-FF-000153', NULL, 'Coagulation factor V', 105, NULL, NULL, 66171),
(66172, '3.40.50.300-FF-004285', NULL, 'Uncharacterized protein', 197, NULL, NULL, 66172),
(66173, '1.20.58.90-FF-000013', NULL, 'Type III secretion system effector protein-E3 Ubiquitin ligase', 72, NULL, NULL, 66173),
(66174, '3.30.200.20-FF-001033', NULL, 'PK3', 80, NULL, NULL, 66174),
(66175, '1.50.10.10-FF-000114', NULL, 'Putative 4-alpha-glucanotransferase / amylo-1,6-glucosidase (Glycogen-debranching enzyme)', 222, NULL, NULL, 66175),
(66176, '2.120.10.80-FF-000348', NULL, 'RING finger protein B', 82, NULL, NULL, 66176),
(66177, '1.10.630.10-FF-000181', NULL, 'Cytochrome P450', 497, NULL, NULL, 66177),
(66178, '2.120.10.80-FF-000298', NULL, 'Uncharacterized protein', 202, NULL, NULL, 66178),
(66179, '3.10.20.230-FF-000021', NULL, 'Serine/threonine-protein kinase GA29083', 115, NULL, NULL, 66179),
(66180, '2.70.70.10-FF-000008', NULL, 'Stage II sporulation protein', 158, NULL, NULL, 66180),
(66181, '3.10.20.90-FF-000984', NULL, 'Uncharacterized protein', 144, NULL, NULL, 66181),
(66182, '3.90.640.10-FF-000217', NULL, 'Uncharacterized protein', 83, NULL, NULL, 66182),
(66183, '2.10.50.30-FF-000055', NULL, 'Uncharacterized protein', 68, NULL, NULL, 66183),
(66184, '3.40.50.720-FF-002550', NULL, 'D-3-phosphoglycerate dehydrogenase', 68, NULL, NULL, 66184),
(66185, '1.10.510.10-FF-002847', NULL, 'Kinase, NEK', 331, NULL, NULL, 66185),
(66186, '3.40.50.11500-FF-000010', NULL, 'Protein CBR-AEX-3', 170, NULL, NULL, 66186),
(66187, '3.30.450.20-FF-000236', NULL, 'Histidine kinase', 101, NULL, NULL, 66187),
(66188, '2.60.40.1170-FF-000044', NULL, 'AP-4 complex subunit mu', 116, NULL, NULL, 66188),
(66189, '1.10.510.10-FF-000756', NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 168', 170, NULL, NULL, 66189),
(66190, '3.30.1370.10-FF-000024', NULL, 'Branchpoint-bridging protein-like protein', 125, NULL, NULL, 66190),
(66191, '3.30.420.40-FF-000971', NULL, 'Heat shock protein 70 (HSP70), putative', 17, NULL, NULL, 66191),
(66192, '2.60.40.10-FF-004975', NULL, NULL, 110, NULL, NULL, 66192),
(66193, '3.80.10.10-FF-003453', NULL, 'LOC100170560 protein', 243, NULL, NULL, 66193),
(66194, '3.30.160.60-FF-005026', NULL, NULL, 37, NULL, NULL, 66194),
(66195, '1.10.418.10-FF-000261', NULL, 'Uncharacterized protein', 64, NULL, NULL, 66195),
(66196, '1.20.120.1870-FF-000001', NULL, 'Death on curing protein, Doc toxin', 126, NULL, NULL, 66196),
(66197, '3.40.710.10-FF-000010', NULL, 'Penicillin-binding protein 1A', 437, NULL, NULL, 66197),
(66198, '2.130.10.10-FF-003323', NULL, 'Uncharacterized protein', 114, NULL, NULL, 66198),
(66199, '3.30.379.10-FF-000005', NULL, 'N-acetyl-alpha-glucosaminidase', 104, NULL, NULL, 66199),
(66200, '3.40.50.10190-FF-000111', NULL, 'DNA polymerase II complex', 131, NULL, NULL, 66200),
(66201, '3.80.10.10-FF-003346', NULL, 'Leucine-rich repeat and transmembrane domain-containing protein 2', 119, NULL, NULL, 66201),
(66202, '2.10.25.10-FF-000210', NULL, 'Hemicentin 1', 41, NULL, NULL, 66202),
(66203, '3.30.160.60-FF-000973', NULL, 'Zinc finger protein 668', 28, NULL, NULL, 66203),
(66204, '1.20.1070.10-FF-002045', NULL, 'Protein CBR-NPR-17', 109, NULL, NULL, 66204),
(66205, '3.40.190.10-FF-000761', NULL, 'Glutamate receptor', 33, NULL, NULL, 66205),
(66206, '3.40.50.300-FF-000974', NULL, 'DNA helicase', 198, NULL, NULL, 66206);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(66207, '3.30.830.10-FF-000274', NULL, 'Insulin-degrading enzyme homolog', 231, NULL, NULL, 66207),
(66208, '3.40.50.80-FF-000004', NULL, 'NADPH oxidase isoform 2', 185, NULL, NULL, 66208),
(66209, '3.40.50.300-FF-006196', NULL, 'Uncharacterized protein', 51, NULL, NULL, 66209),
(66210, '3.80.10.10-FF-000530', NULL, 'Receptor-like protein 2', 104, NULL, NULL, 66210),
(66211, '1.25.40.10-FF-004570', NULL, 'Pentatricopeptide repeat-containing protein 4, mitochondrial', 191, NULL, NULL, 66211),
(66212, '1.50.10.20-FF-000117', NULL, 'Uncharacterized protein', 137, NULL, NULL, 66212),
(66213, '2.60.120.200-FF-000422', NULL, 'Adhesion G-protein-coupled receptor G6', 200, NULL, NULL, 66213),
(66214, '3.40.367.20-FF-000006', NULL, 'Phosphotransferase', 290, NULL, NULL, 66214),
(66215, '1.20.120.1880-FF-000004', NULL, 'Non-repetitive nucleoporin, putative', 227, NULL, NULL, 66215),
(66216, '2.160.20.10-FF-000259', NULL, 'Pectinesterase 31', 130, NULL, NULL, 66216),
(66217, '1.10.150.670-FF-000013', NULL, 'Endonuclease, putative', 99, NULL, NULL, 66217),
(66218, '3.40.640.10-FF-000358', NULL, 'Uncharacterized protein', 233, NULL, NULL, 66218),
(66219, '2.130.10.10-FF-001232', NULL, 'WD domain, G-beta repeat, putative', 299, NULL, NULL, 66219),
(66220, '2.60.40.10-FF-000647', NULL, 'Semaphorin-4D', 88, NULL, NULL, 66220),
(66221, '3.30.70.890-FF-000078', NULL, 'Diphosphomevalonate decarboxylase', 95, NULL, NULL, 66221),
(66222, '1.10.10.10-FF-000796', NULL, 'Unplaced genomic scaffold supercont2.3, whole genome shotgun sequence', 101, NULL, NULL, 66222),
(66223, '1.25.40.10-FF-004750', NULL, 'Putative pentatricopeptide repeat-containing protein', 66, NULL, NULL, 66223),
(66224, '3.40.50.1440-FF-000168', NULL, 'Uncharacterized protein', 80, NULL, NULL, 66224),
(66225, '2.40.50.140-FF-000093', NULL, 'cold shock domain-containing protein E1 isoform X1', 70, NULL, NULL, 66225),
(66226, '3.90.950.10-FF-000027', NULL, 'dTTP/UTP pyrophosphatase', 194, NULL, NULL, 66226),
(66227, '3.30.70.330-FF-000882', NULL, 'Polypyrimidine tract-binding protein 3', 96, NULL, NULL, 66227),
(66228, '2.70.150.10-FF-000048', NULL, 'Phospholipid-transporting ATPase', 134, NULL, NULL, 66228),
(66229, '2.40.128.320-FF-000001', NULL, 'Protein HRI1', 149, NULL, NULL, 66229),
(66230, '1.20.120.1750-FF-000145', NULL, 'Uncharacterized protein', 116, NULL, NULL, 66230),
(66231, '3.40.50.300-FF-006319', NULL, 'RecBCD enzyme subunit RecC', 224, NULL, NULL, 66231),
(66232, '3.30.160.60-FF-006375', NULL, NULL, 29, NULL, NULL, 66232),
(66233, '1.25.10.10-FF-000358', NULL, 'Serine/threonine-protein phosphatase 4 regulatory subunit 1', 106, NULL, NULL, 66233),
(66234, '1.25.10.10-FF-002449', NULL, 'Predicted protein', 229, NULL, NULL, 66234),
(66235, '3.90.320.10-FF-000002', NULL, 'DNA replication ATP-dependent helicase/nuclease DNA2', 202, NULL, NULL, 66235),
(66236, '2.80.10.50-FF-000078', NULL, 'Interleukin 36 beta', 105, NULL, NULL, 66236),
(66237, '2.60.260.20-FF-000078', NULL, 'Chaperone protein dnaJ', 67, NULL, NULL, 66237),
(66238, '2.170.30.10-FF-000001', NULL, 'Minor capsid protein VP1', 534, NULL, NULL, 66238),
(66239, '4.10.60.10-FF-000270', NULL, 'Uncharacterized protein', 52, NULL, NULL, 66239),
(66240, '3.30.750.24-FF-000084', NULL, 'Uncharacterized protein', 158, NULL, NULL, 66240),
(66241, '2.40.128.330-FF-000004', NULL, 'Magnesium transporter MRS2-11, chloroplastic', 82, NULL, NULL, 66241),
(66242, '2.20.25.10-FF-000069', NULL, 'TRMT112 isoform 1', 81, NULL, NULL, 66242),
(66243, '3.40.50.300-FF-008556', NULL, 'ATP-dependent DNA helicase', 181, NULL, NULL, 66243),
(66244, '3.90.370.10-FF-000005', NULL, 'Tissue inhibitor of metalloproteinase', 73, NULL, NULL, 66244),
(66245, '1.25.40.10-FF-003002', NULL, 'Pentatricopeptide repeat-containing protein', 125, NULL, NULL, 66245),
(66246, '2.40.110.10-FF-000081', NULL, 'Uncharacterized protein', 112, NULL, NULL, 66246),
(66247, '2.40.30.10-FF-000485', NULL, 'Uncharacterized protein', 40, NULL, NULL, 66247),
(66248, '2.60.120.260-FF-000344', NULL, 'Alpha-1,3-mannosyl-glycoprotein 4-beta-N-acetylglucosaminyltransferase C', 144, NULL, NULL, 66248);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(66249, '3.10.390.10-FF-000002', NULL, 'Putative ski oncogene', 99, NULL, NULL, 66249),
(66250, '3.40.50.620-FF-000160', NULL, 'Pantoate--beta-alanine ligase', 202, NULL, NULL, 66250),
(66251, '1.10.287.80-FF-000004', NULL, 'ATP synthase gamma chain, chloroplastic', 104, NULL, NULL, 66251),
(66252, '3.40.50.80-FF-000061', NULL, 'Metalloreductase transmembrane component, putative', 204, NULL, NULL, 66252),
(66253, '1.10.10.10-FF-000740', NULL, 'Transcriptional regulator, MarR family', 139, NULL, NULL, 66253),
(66254, '2.10.25.10-FF-000193', NULL, 'Laminin subunit gamma 1', 50, NULL, NULL, 66254),
(66255, '1.10.1410.40-FF-000015', NULL, 'Uncharacterized protein', 122, NULL, NULL, 66255),
(66256, '2.40.160.50-FF-000011', NULL, 'Sorting assembly machinery 50 kDa subunit,putative', 360, NULL, NULL, 66256),
(66257, '3.30.470.20-FF-000237', NULL, 'Pyruvate carboxylase', 77, NULL, NULL, 66257),
(66258, '3.30.1370.10-FF-000243', NULL, 'Uncharacterized protein', 202, NULL, NULL, 66258),
(66259, '1.10.630.10-FF-000012', NULL, 'Cytochrome P450 family protein', 486, NULL, NULL, 66259),
(66260, '3.30.70.2660-FF-000003', NULL, 'CRISPR-associated protein Cas5', 191, NULL, NULL, 66260),
(66261, '1.10.287.70-FF-000001', NULL, 'Sodium channel protein', 135, NULL, NULL, 66261),
(66262, '1.20.120.230-FF-000031', NULL, 'catenin alpha-2', 69, NULL, NULL, 66262),
(66263, '3.30.559.30-FF-000109', NULL, 'Uncharacterized protein', 236, NULL, NULL, 66263),
(66264, '1.10.510.10-FF-000975', NULL, 'Poly(A) specific ribonuclease subunit PAN3', 112, NULL, NULL, 66264),
(66265, '3.50.50.60-FF-000655', NULL, 'Amino acid dehydrogenase', 81, NULL, NULL, 66265),
(66266, '1.25.10.10-FF-001252', NULL, 'Sterile alpha and TIR motif-containing protein tir-1', 265, NULL, NULL, 66266),
(66267, '2.60.40.420-FF-000041', NULL, 'Blue copper oxidase CueO', 172, NULL, NULL, 66267),
(66268, '2.40.50.150-FF-000039', NULL, 'Predicted protein', 24, NULL, NULL, 66268),
(66269, '1.10.287.690-FF-000013', NULL, 'DNA polymerase', 51, NULL, NULL, 66269),
(66270, '2.40.50.730-FF-000005', NULL, 'DNA polymerase', 117, NULL, NULL, 66270),
(66271, '3.40.50.2000-FF-000353', NULL, 'Glycosyl transferase', 173, NULL, NULL, 66271),
(66272, '3.50.4.10-FF-000024', NULL, 'Uncharacterized protein, isoform B', 91, NULL, NULL, 66272),
(66273, '3.30.750.24-FF-000101', NULL, 'Sodium-independent anion transporter', 136, NULL, NULL, 66273),
(66274, '2.40.30.130-FF-000046', NULL, 'Alanine--tRNA ligase, mitochondrial', 106, NULL, NULL, 66274),
(66275, '1.25.10.10-FF-002943', NULL, 'Cellular apoptosis susceptibility protein', 75, NULL, NULL, 66275),
(66276, '3.40.50.300-FF-005740', NULL, 'Tight junction protein 3', 147, NULL, NULL, 66276),
(66277, '3.30.1550.10-FF-000010', NULL, 'Ribosomal protein', 57, NULL, NULL, 66277),
(66278, '2.60.40.60-FF-000965', NULL, 'Predicted protein', 62, NULL, NULL, 66278),
(66279, '3.40.50.300-FF-001412', NULL, 'Peptidase domain-containing ABC transporter', 230, NULL, NULL, 66279),
(66280, '3.40.50.300-FF-006937', NULL, 'Predicted protein', 229, NULL, NULL, 66280),
(66281, '1.25.40.180-FF-000024', NULL, 'Eukaryotic translation initiation factor 4G', 237, NULL, NULL, 66281),
(66282, '2.40.50.40-FF-000023', NULL, 'Lymphotactin isoform X1', 93, NULL, NULL, 66282),
(66283, '3.40.50.620-FF-000103', NULL, 'tyrosine--tRNA ligase 1, cytoplasmic', 193, NULL, NULL, 66283),
(66284, '2.60.40.10-FF-000428', NULL, 'striated muscle preferentially expressed protein kinase', 95, NULL, NULL, 66284),
(66285, '1.20.1250.20-FF-001596', NULL, 'MFS general substrate transporter', 263, NULL, NULL, 66285),
(66286, '3.90.1030.10-FF-000013', NULL, '50S ribosomal protein L17', 116, NULL, NULL, 66286),
(66287, '1.20.1260.10-FF-000019', NULL, 'Ferritin', 174, NULL, NULL, 66287),
(66288, '2.70.170.10-FF-000049', NULL, 'Ligand-Gated ion Channel', 220, NULL, NULL, 66288),
(66289, '1.25.40.10-FF-002327', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 68, NULL, NULL, 66289),
(66290, '3.30.559.10-FF-000103', NULL, 'Nonribosomal peptide synthetase 13', 171, NULL, NULL, 66290);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(66291, '1.25.40.10-FF-002384', NULL, 'transmembrane and TPR repeat-containing protein CG5038', 69, NULL, NULL, 66291),
(66292, '3.40.50.300-FF-003503', NULL, 'P. aerophilum family 417, putative ATP binding', 182, NULL, NULL, 66292),
(66293, '3.90.120.10-FF-000015', NULL, 'DNA (cytosine-5)-methyltransferase', 25, NULL, NULL, 66293),
(66294, '3.30.559.10-FF-000160', NULL, 'Nonribosomal peptide synthase inpB', 182, NULL, NULL, 66294),
(66295, '3.30.420.40-FF-000802', NULL, 'Predicted protein', 239, NULL, NULL, 66295),
(66296, '3.90.226.10-FF-000188', NULL, 'Carboxyl-terminal protease', 156, NULL, NULL, 66296),
(66297, '3.40.50.300-FF-005122', NULL, 'Uncharacterized protein', 329, NULL, NULL, 66297),
(66298, '1.20.1250.20-FF-001539', NULL, 'MFS general substrate transporter', 427, NULL, NULL, 66298),
(66299, '3.20.20.190-FF-000141', NULL, NULL, 197, NULL, NULL, 66299),
(66300, '2.40.10.350-FF-000001', NULL, 'Cell shape-determining protein MreC', 72, NULL, NULL, 66300),
(66301, '2.130.10.10-FF-004447', NULL, 'Uncharacterized protein', 348, NULL, NULL, 66301),
(66302, '1.10.510.10-FF-000936', NULL, 'Tyrosine-protein kinase', 267, NULL, NULL, 66302),
(66303, '1.10.260.40-FF-000032', NULL, 'Transcriptional regulator ClgR', 84, NULL, NULL, 66303),
(66304, '3.50.50.60-FF-000436', NULL, 'Putative dihydrolipoamide dehydrogenase', 205, NULL, NULL, 66304),
(66305, '3.30.40.10-FF-002355', NULL, 'Pleckstrin homology domain-containing, family F (with FYVE domain) member 1', 86, NULL, NULL, 66305),
(66306, '1.20.5.190-FF-000098', NULL, NULL, 33, NULL, NULL, 66306),
(66307, '3.30.70.270-FF-000111', NULL, 'Genome polyprotein', 125, NULL, NULL, 66307),
(66308, '1.10.8.60-FF-000017', NULL, 'ATP-dependent chaperone ClpB', 92, NULL, NULL, 66308),
(66309, '3.30.160.60-FF-005301', NULL, NULL, 51, NULL, NULL, 66309),
(66310, '3.40.50.10470-FF-000049', NULL, 'Translation initiation factor eIF-2B subunit delta', 178, NULL, NULL, 66310),
(66311, '3.50.50.60-FF-000150', NULL, 'Polyamine oxidase 1', 226, NULL, NULL, 66311),
(66312, '1.20.5.1700-FF-000010', NULL, 'Bone marrow stromal antigen 2 type B', 100, NULL, NULL, 66312),
(66313, '3.10.129.10-FF-000160', NULL, '4-hydroxybenzoyl-CoA thioesterase', 141, NULL, NULL, 66313),
(66314, '1.25.10.10-FF-002887', NULL, 'Uncharacterized protein', 486, NULL, NULL, 66314),
(66315, '3.30.200.20-FF-000538', NULL, 'Putative Casein kinase I', 85, NULL, NULL, 66315),
(66316, '3.30.2350.10-FF-000028', NULL, 'RluA family pseudouridine synthase', 212, NULL, NULL, 66316),
(66317, '3.40.50.300-FF-004846', NULL, 'Putative DNA helicase', 199, NULL, NULL, 66317),
(66318, '3.50.50.60-FF-000094', NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', 146, NULL, NULL, 66318),
(66319, '3.40.309.10-FF-000010', NULL, 'Gamma-aminobutyraldehyde dehydrogenase', 192, NULL, NULL, 66319),
(66320, '1.20.120.720-FF-000026', NULL, 'Myosin C', 144, NULL, NULL, 66320),
(66321, '3.30.70.1990-FF-000004', NULL, 'Uncharacterized protein', 120, NULL, NULL, 66321),
(66322, '2.30.280.10-FF-000004', NULL, 'E3 ubiquitin-protein ligase UHRF2', 229, NULL, NULL, 66322),
(66323, '3.90.79.10-FF-000143', NULL, 'DNA mismatch repair protein MutT', 161, NULL, NULL, 66323),
(66324, '1.20.1080.10-FF-000034', NULL, 'Aquaglyceroporin', 258, NULL, NULL, 66324),
(66325, '3.40.50.300-FF-003267', NULL, 'ADP-ribosylation factor-related', 172, NULL, NULL, 66325),
(66326, '1.10.1520.10-FF-000008', NULL, 'Dicer-like 104', 187, NULL, NULL, 66326),
(66327, '3.40.50.1000-FF-000278', NULL, 'RNA polymerase II subunit A domain phosphatase', 142, NULL, NULL, 66327),
(66328, '3.90.930.12-FF-000023', NULL, NULL, 90, NULL, NULL, 66328),
(66329, '3.30.750.24-FF-000045', NULL, 'Unplaced genomic scaffold supercont2.6, whole genome shotgun sequence', 151, NULL, NULL, 66329),
(66330, '1.10.510.10-FF-001251', NULL, 'Inactive serine/threonine-protein kinase At1g67470', 217, NULL, NULL, 66330),
(66331, '1.20.1250.20-FF-000016', NULL, 'Glycerol-3-phosphate transporter', 211, NULL, NULL, 66331),
(66332, '3.30.430.20-FF-000061', NULL, 'Putative DUF26-domain protein kinase', 101, NULL, NULL, 66332);
INSERT INTO "PUBLIC"."MODEL" VALUES
(66333, '3.40.850.10-FF-000402', NULL, 'Kinesin-like protein', 270, NULL, NULL, 66333),
(66334, '1.10.1600.10-FF-000009', NULL, 'ATP-dependent DNA helicase II subunit 2', 107, NULL, NULL, 66334),
(66335, '3.30.70.330-FF-000551', NULL, 'U2 snRNP auxiliary factor large subunit', 133, NULL, NULL, 66335),
(66336, '1.20.1540.10-FF-000114', NULL, 'Uncharacterized protein', 209, NULL, NULL, 66336),
(66337, '3.40.190.170-FF-000003', NULL, 'Lactate-binding periplasmic protein TTHA0766', 304, NULL, NULL, 66337),
(66338, '1.20.58.60-FF-000706', NULL, 'Uncharacterized protein', 110, NULL, NULL, 66338),
(66339, '2.130.10.10-FF-000176', NULL, 'Intraflagellar transport protein 122 homolog', 291, NULL, NULL, 66339),
(66340, '3.90.70.10-FF-000836', NULL, 'Uncharacterized protein', 146, NULL, NULL, 66340),
(66341, '1.10.510.10-FF-001212', NULL, 'Protein tyrosine kinase 2 beta, b', 207, NULL, NULL, 66341),
(66342, '1.20.5.190-FF-000059', NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', 48, NULL, NULL, 66342),
(66343, '3.30.420.40-FF-000858', NULL, 'ROK family protein', 121, NULL, NULL, 66343),
(66344, '2.60.210.10-FF-000033', NULL, 'TNF receptor-associated factor', 134, NULL, NULL, 66344),
(66345, '1.10.220.150-FF-000054', NULL, 'Un-named sa1614', 129, NULL, NULL, 66345),
(66346, '3.80.10.10-FF-001873', NULL, 'At1g04210', 91, NULL, NULL, 66346),
(66347, '3.60.40.10-FF-000302', NULL, 'Amino-acid permease BAT1', 88, NULL, NULL, 66347),
(66348, '3.30.559.10-FF-000047', NULL, 'Phthiocerol/phthiodiolone dimycocerosyl transferase', 220, NULL, NULL, 66348),
(66349, '1.20.1250.10-FF-000013', NULL, 'Erythropoietin', 166, NULL, NULL, 66349),
(66350, '1.10.10.60-FF-000165', NULL, 'Two-component system nitrogen regulation response regulator NtrX', 59, NULL, NULL, 66350),
(66351, '3.40.30.10-FF-001084', NULL, 'Uncharacterized protein', 115, NULL, NULL, 66351),
(66352, '3.40.366.10-FF-000035', NULL, 'Yersiniabactin polyketide/non-ribosomal peptide synthetase', 298, NULL, NULL, 66352),
(66353, '2.60.40.2170-FF-000006', NULL, 'Inactive tyrosine-protein kinase RYK', 137, NULL, NULL, 66353),
(66354, '1.10.10.10-FF-001015', NULL, 'ArsR family transcriptional regulator', 112, NULL, NULL, 66354),
(66355, '2.60.40.1400-FF-000034', NULL, NULL, 41, NULL, NULL, 66355),
(66356, '1.10.8.710-FF-000015', NULL, NULL, 50, NULL, NULL, 66356),
(66357, '3.40.1440.10-FF-000016', NULL, NULL, 97, NULL, NULL, 66357),
(66358, '1.10.150.20-FF-000046', NULL, 'Fanconi anemia core complex-associated protein 24', 71, NULL, NULL, 66358),
(66359, '1.10.400.10-FF-000080', NULL, 'G protein subunit alpha transducin 2', 93, NULL, NULL, 66359),
(66360, '2.60.40.10-FF-002671', NULL, 'Connectin', 105, NULL, NULL, 66360),
(66361, '3.30.730.10-FF-000002', NULL, 'AP2-like ethylene-responsive transcription factor', 62, NULL, NULL, 66361),
(66362, '1.10.510.10-FF-003229', NULL, NULL, 127, NULL, NULL, 66362),
(66363, '3.90.850.10-FF-000031', NULL, 'Putative hydratase', 260, NULL, NULL, 66363),
(66364, '3.10.129.10-FF-000047', NULL, 'Acyl-CoA thioester hydrolase', 136, NULL, NULL, 66364),
(66365, '1.10.340.30-FF-000030', NULL, 'Ada regulatory protein', 101, NULL, NULL, 66365),
(66366, '3.40.50.300-FF-000917', NULL, 'DNA mismatch repair protein', 289, NULL, NULL, 66366),
(66367, '3.40.50.300-FF-003323', NULL, 'Rab family GTPase', 189, NULL, NULL, 66367),
(66368, '2.130.10.10-FF-002980', NULL, 'WD40-repeat-containing domain protein', 210, NULL, NULL, 66368),
(66369, '1.20.1260.60-FF-000006', NULL, 'Uncharacterized protein', 175, NULL, NULL, 66369),
(66370, '3.50.30.30-FF-000100', NULL, 'Glutamate carboxypeptidase, putative', 130, NULL, NULL, 66370),
(66371, '1.20.5.170-FF-000053', NULL, 'BZIP transcription factor AtfA', 63, NULL, NULL, 66371),
(66372, '3.30.300.180-FF-000025', NULL, 'Chromosomal replication initiator protein DnaA', 103, NULL, NULL, 66372),
(66373, '2.130.10.10-FF-005122', NULL, 'Predicted protein', 99, NULL, NULL, 66373),
(66374, '1.10.10.60-FF-000906', NULL, NULL, 40, NULL, NULL, 66374),
(66375, '1.25.40.20-FF-001644', NULL, 'Poly [ADP-ribose] polymerase', 252, NULL, NULL, 66375);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(66376, '3.30.40.10-FF-000556', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-4 specific', 66, NULL, NULL, 66376),
(66377, '1.10.10.10-FF-000739', NULL, 'Related to RFX1-major transcriptional repressor of DNA-damage-regulated genes', 75, NULL, NULL, 66377),
(66378, '1.10.150.60-FF-000029', NULL, 'Brahma associated protein 170kD', 124, NULL, NULL, 66378),
(66379, '3.30.300.30-FF-000060', NULL, 'Nonribosomal peptide synthase SidE', 105, NULL, NULL, 66379),
(66380, '1.25.40.20-FF-001700', NULL, 'Predicted protein', 62, NULL, NULL, 66380),
(66381, '3.30.160.60-FF-001316', NULL, 'PR domain zinc finger protein 10', 27, NULL, NULL, 66381),
(66382, '3.80.10.10-FF-000350', NULL, 'volume-regulated anion channel subunit LRRC8A', 155, NULL, NULL, 66382),
(66383, '2.30.42.10-FF-000164', NULL, 'Ligand of numb-protein X 2', 102, NULL, NULL, 66383),
(66384, '1.10.287.4070-FF-000022', NULL, 'Uncharacterized protein', 81, NULL, NULL, 66384),
(66385, '3.30.300.30-FF-000021', NULL, 'Enterobactin synthase component E', 105, NULL, NULL, 66385),
(66386, '3.30.200.20-FF-000252', NULL, 'Serine/threonine-protein kinase 26', 101, NULL, NULL, 66386),
(66387, '3.90.980.20-FF-000038', NULL, NULL, 130, NULL, NULL, 66387),
(66388, '1.25.40.10-FF-001203', NULL, 'Putative pentatricopeptide repeat-containing protein', 126, NULL, NULL, 66388),
(66389, '1.25.40.20-FF-001206', NULL, 'Predicted protein', 173, NULL, NULL, 66389),
(66390, '2.60.40.10-FF-002738', NULL, 'Titin homolog', 87, NULL, NULL, 66390),
(66391, '3.80.10.10-FF-004127', NULL, 'Uncharacterized protein', 112, NULL, NULL, 66391),
(66392, '3.40.630.10-FF-000419', NULL, 'Predicted protein', 296, NULL, NULL, 66392),
(66393, '1.25.40.1010-FF-000017', NULL, 'Uncharacterized protein', 106, NULL, NULL, 66393),
(66394, '1.25.40.10-FF-004637', NULL, 'Peptidyl-prolyl cis-trans isomerase, cyclophilin-type', 156, NULL, NULL, 66394),
(66395, '3.90.79.10-FF-000087', NULL, 'Nudix (nucleoside diphosphate linked moiety X)-type motif 22', 167, NULL, NULL, 66395),
(66396, '3.30.1120.30-FF-000028', NULL, 'Serine/threonine-protein kinase', 92, NULL, NULL, 66396),
(66397, '1.10.8.270-FF-000170', NULL, 'Uncharacterized protein', 69, NULL, NULL, 66397),
(66398, '2.60.40.10-FF-004470', NULL, NULL, 95, NULL, NULL, 66398),
(66399, '3.30.465.10-FF-000048', NULL, 'FAD-binding oxidoreductase', 193, NULL, NULL, 66399),
(66400, '3.10.350.10-FF-000005', NULL, 'L,D-transpeptidase YnhG', 47, NULL, NULL, 66400),
(66401, '2.30.30.140-FF-000141', NULL, 'DNA damage repair protein (Rad9)', 61, NULL, NULL, 66401),
(66402, '3.30.70.330-FF-002349', NULL, NULL, 107, NULL, NULL, 66402),
(66403, '2.60.40.1110-FF-000009', NULL, 'Type I pullulanase', 115, NULL, NULL, 66403),
(66404, '3.40.50.2300-FF-000741', NULL, 'Vomeronasal 2 receptor, 57', 268, NULL, NULL, 66404),
(66405, '3.40.50.300-FF-003380', NULL, 'Rad25/xp-B DNA repair helicase, putative', 182, NULL, NULL, 66405),
(66406, '2.130.10.10-FF-000917', NULL, 'Dynein intermediate chain, putative', 166, NULL, NULL, 66406),
(66407, '3.30.200.20-FF-000870', NULL, 'Inactive tyrosine-protein kinase kin-32', 91, NULL, NULL, 66407),
(66408, '2.60.120.200-FF-000186', NULL, 'Contactin-associated protein-like 4', 199, NULL, NULL, 66408),
(66409, '3.60.140.10-FF-000001', NULL, 'Polyphenol oxidase', 243, NULL, NULL, 66409),
(66410, '1.20.1250.20-FF-000073', NULL, 'MFS myo-inositol transporter, putative', 467, NULL, NULL, 66410),
(66411, '3.30.70.330-FF-002063', NULL, NULL, 141, NULL, NULL, 66411),
(66412, '1.20.1560.10-FF-000402', NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 4', 307, NULL, NULL, 66412),
(66413, '3.40.630.30-FF-000577', NULL, 'Uncharacterized N-acetyltransferase C550.08', 209, NULL, NULL, 66413),
(66414, '1.10.3260.10-FF-000045', NULL, 'Uncharacterized protein', 178, NULL, NULL, 66414),
(66415, '3.40.525.10-FF-000057', NULL, 'Retinaldehyde binding protein 1, like', 89, NULL, NULL, 66415),
(66416, '2.170.300.10-FF-000047', NULL, 'Scavenger receptor class F member 1 isoform 1', 115, NULL, NULL, 66416),
(66417, '3.30.710.10-FF-000332', NULL, 'Uncharacterized protein', 92, NULL, NULL, 66417);
INSERT INTO "PUBLIC"."MODEL" VALUES
(66418, '2.40.70.10-FF-000482', NULL, NULL, 213, NULL, NULL, 66418),
(66419, '3.30.200.20-FF-000690', NULL, 'Receptor tyrosine kinase', 105, NULL, NULL, 66419),
(66420, '3.30.1240.10-FF-000020', NULL, 'HAD family hydrolase', 128, NULL, NULL, 66420),
(66421, '3.40.50.1820-FF-001592', NULL, 'Uncharacterized protein', 89, NULL, NULL, 66421),
(66422, '3.30.710.10-FF-000276', NULL, 'Phototropic-responsive NPH3 family protein', 105, NULL, NULL, 66422),
(66423, '1.10.443.10-FF-000004', NULL, 'Integrase', 179, NULL, NULL, 66423),
(66424, '2.30.30.40-FF-000494', NULL, 'Predicted protein', 62, NULL, NULL, 66424),
(66425, '1.20.1560.10-FF-000060', NULL, 'Cysteine/glutathione ABC transporter ATP-binding protein/permease CydC', 322, NULL, NULL, 66425),
(66426, '1.25.40.20-FF-001026', NULL, 'Putative ankyrin repeat protein', 189, NULL, NULL, 66426),
(66427, '1.10.1300.10-FF-000026', NULL, 'Phosphodiesterase', 364, NULL, NULL, 66427),
(66428, '3.90.1300.10-FF-000045', NULL, 'Uncharacterized protein', 205, NULL, NULL, 66428),
(66429, '3.90.550.10-FF-000391', NULL, 'Beta-1,3-N-acetylglucosaminyltransferase', 255, NULL, NULL, 66429),
(66430, '3.30.160.750-FF-000005', NULL, NULL, 54, NULL, NULL, 66430),
(66431, '1.25.40.10-FF-000747', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 156, NULL, NULL, 66431),
(66432, '1.20.1070.10-FF-001663', NULL, 'Uncharacterized protein', 126, NULL, NULL, 66432),
(66433, '1.25.40.10-FF-000528', NULL, 'Transmembrane and TPR repeat-containing protein 3', 128, NULL, NULL, 66433),
(66434, '3.30.1330.10-FF-000027', NULL, 'Thiamine monophosphate kinase', 142, NULL, NULL, 66434),
(66435, '3.90.660.10-FF-000106', NULL, NULL, 229, NULL, NULL, 66435),
(66436, '1.10.287.130-FF-000143', NULL, 'Two-component system sensor histidine kinase', 87, NULL, NULL, 66436),
(66437, '3.30.160.740-FF-000002', NULL, '2-isopropylmalate synthase', 54, NULL, NULL, 66437),
(66438, '3.30.70.3030-FF-000013', NULL, 'Nucleolar protein 6', 137, NULL, NULL, 66438),
(66439, '1.20.1250.20-FF-001652', NULL, 'MFS transporter, DHA2 family, multidrug resistance protein', 196, NULL, NULL, 66439),
(66440, '1.25.40.10-FF-001023', NULL, 'Cell division cycle 16', 371, NULL, NULL, 66440),
(66441, '3.10.20.90-FF-000546', NULL, 'UBA/TS-N domain containing protein', 82, NULL, NULL, 66441),
(66442, '1.10.238.10-FF-000893', NULL, 'Dual oxidase 1', 215, NULL, NULL, 66442),
(66443, '3.30.160.60-FF-000012', NULL, 'RB-associated KRAB zinc finger protein-like', 28, NULL, NULL, 66443),
(66444, '3.30.70.920-FF-000014', NULL, 'Lrp/AsnC family transcriptional regulator', 97, NULL, NULL, 66444),
(66445, '2.20.100.10-FF-000005', NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 9', 57, NULL, NULL, 66445),
(66446, '3.80.10.10-FF-000294', NULL, 'Leucine-rich repeat-containing 8 VRAC subunit B', 121, NULL, NULL, 66446),
(66447, '1.25.10.10-FF-000139', NULL, 'protein EFR3 homolog B', 342, NULL, NULL, 66447),
(66448, '3.90.70.10-FF-000893', NULL, 'Ubiquitinyl hydrolase 1', 334, NULL, NULL, 66448),
(66449, '2.120.10.80-FF-000242', NULL, 'Development protein DG1106', 131, NULL, NULL, 66449),
(66450, '3.40.190.10-FF-000722', NULL, 'Protein CBR-NMR-2', 29, NULL, NULL, 66450),
(66451, '1.20.1070.10-FF-002006', NULL, 'Uncharacterized protein', 141, NULL, NULL, 66451),
(66452, '1.20.1250.10-FF-000070', NULL, 'Uncharacterized protein', 179, NULL, NULL, 66452),
(66453, '3.40.50.1820-FF-001715', NULL, 'Predicted protein', 142, NULL, NULL, 66453),
(66454, '3.30.1140.32-FF-000021', NULL, '30S ribosomal protein S3', 119, NULL, NULL, 66454),
(66455, '3.40.630.10-FF-000239', NULL, 'Putative carboxypeptidase PM20D1', 200, NULL, NULL, 66455),
(66456, '1.10.510.10-FF-001431', NULL, 'Protein kinase, putative', 220, NULL, NULL, 66456),
(66457, '3.30.70.1440-FF-000013', NULL, NULL, 99, NULL, NULL, 66457),
(66458, '3.30.710.10-FF-000057', NULL, 'SKP1-like protein 1A', 157, NULL, NULL, 66458),
(66459, '3.80.10.10-FF-000018', NULL, 'Reticulon 4 receptor', 289, NULL, NULL, 66459),
(66460, '2.20.100.10-FF-000062', NULL, 'Thrombospondin type 1 domain containing 7B', 51, NULL, NULL, 66460);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(66461, '3.30.40.10-FF-001574', NULL, 'RING-H2 finger protein ATL33', 92, NULL, NULL, 66461),
(66462, '3.40.1190.20-FF-000134', NULL, 'Bifunctional NAD(P)H-hydrate repair enzyme Nnr', 285, NULL, NULL, 66462),
(66463, '2.60.120.200-FF-000309', NULL, 'Sialidase', 187, NULL, NULL, 66463),
(66464, '1.10.510.10-FF-004247', NULL, NULL, 195, NULL, NULL, 66464),
(66465, '1.10.238.10-FF-000275', NULL, 'Probable calcium-binding protein CML27', 76, NULL, NULL, 66465),
(66466, '1.10.3660.10-FF-000013', NULL, 'Prephenate dehydrogenase', 100, NULL, NULL, 66466),
(66467, '3.30.70.1450-FF-000016', NULL, 'Potassium uptake protein, Trk family', 85, NULL, NULL, 66467),
(66468, '3.30.200.20-FF-000813', NULL, 'Mitogen-activated protein kinase kinase 9', 97, NULL, NULL, 66468),
(66469, '1.20.1250.20-FF-000634', NULL, 'Fosmidomycin resistance protein', 186, NULL, NULL, 66469),
(66470, '3.40.50.10140-FF-000012', NULL, 'Sterile alpha and TIR motif-containing protein', 123, NULL, NULL, 66470),
(66471, '3.40.50.620-FF-000608', NULL, 'Arginine--tRNA ligase, cytoplasmic', 340, NULL, NULL, 66471),
(66472, '1.10.3720.10-FF-000182', NULL, 'Amino acid ABC transporter permease protein', 213, NULL, NULL, 66472),
(66473, '3.30.70.330-FF-002624', NULL, NULL, 127, NULL, NULL, 66473),
(66474, '3.30.160.60-FF-004806', NULL, NULL, 32, NULL, NULL, 66474),
(66475, '3.50.50.60-FF-000711', NULL, 'Monooxygenase 1', 364, NULL, NULL, 66475),
(66476, '3.30.420.10-FF-000698', NULL, NULL, 117, NULL, NULL, 66476),
(66477, '1.25.40.10-FF-004457', NULL, 'Uncharacterized protein', 112, NULL, NULL, 66477),
(66478, '3.30.2350.10-FF-000085', NULL, 'tRNA pseudouridine synthase B', 220, NULL, NULL, 66478),
(66479, '3.90.550.50-FF-000155', NULL, 'Os10g0551000 protein', 36, NULL, NULL, 66479),
(66480, '1.20.1050.130-FF-000003', NULL, 'Cysteinyl-tRNA synthetase, cytoplasmic', 70, NULL, NULL, 66480),
(66481, '2.130.10.10-FF-004902', NULL, 'Uncharacterized protein', 112, NULL, NULL, 66481),
(66482, '2.60.11.10-FF-000007', NULL, 'Uncharacterized protein', 89, NULL, NULL, 66482),
(66483, '3.30.70.330-FF-002681', NULL, NULL, 74, NULL, NULL, 66483),
(66484, '3.40.50.1220-FF-000052', NULL, 'Putative 2-hydroxyacyl-CoA lyase', 154, NULL, NULL, 66484),
(66485, '2.60.40.60-FF-000926', NULL, 'Protocadherin 1 gamma 9', 58, NULL, NULL, 66485),
(66486, '1.25.40.20-FF-000189', NULL, 'Protein phosphatase 1 regulatory subunit 27', 144, NULL, NULL, 66486),
(66487, '3.90.132.10-FF-000026', NULL, 'GP63-like', 131, NULL, NULL, 66487),
(66488, '3.40.50.1000-FF-000839', NULL, NULL, 75, NULL, NULL, 66488),
(66489, '3.40.50.1370-FF-000012', NULL, 'Aspartate carbamoyltransferase', 140, NULL, NULL, 66489),
(66490, '1.10.150.20-FF-000102', NULL, 'UvrABC system protein C', 59, NULL, NULL, 66490),
(66491, '1.10.8.60-FF-000130', NULL, 'Replication factor C subunit 2', 58, NULL, NULL, 66491),
(66492, '2.60.40.10-FF-002558', NULL, 'Interleukin-1 receptor accessory protein-like 1', 65, NULL, NULL, 66492),
(66493, '1.25.40.480-FF-000013', NULL, 'Uncharacterized protein', 256, NULL, NULL, 66493),
(66494, '3.40.1620.10-FF-000002', NULL, 'Antitoxin', 42, NULL, NULL, 66494),
(66495, '1.25.40.10-FF-000186', NULL, 'Tetratricopeptide repeat domain 30A', 224, NULL, NULL, 66495),
(66496, '3.40.1700.10-FF-000003', NULL, 'Diadenylate cyclase', 132, NULL, NULL, 66496),
(66497, '3.60.21.10-FF-000449', NULL, 'Uncharacterized protein', 192, NULL, NULL, 66497),
(66498, '1.25.10.10-FF-000471', NULL, 'ARM repeat superfamily protein', 118, NULL, NULL, 66498),
(66499, '3.10.350.10-FF-000062', NULL, 'Chlorophenol reductase', 77, NULL, NULL, 66499),
(66500, '1.10.287.110-FF-000328', NULL, 'Chaperone protein DNAJ, putative', 88, NULL, NULL, 66500),
(66501, '1.20.910.10-FF-000003', NULL, 'Hydroxymethylpyrimidine/phosphomethylpyrimidine kinase THI20', 225, NULL, NULL, 66501),
(66502, '1.20.960.10-FF-000006', NULL, 'Mitochondrial outer membrane translocase complex, subunit Tom20 domain-containing protein', 88, NULL, NULL, 66502),
(66503, '3.90.226.10-FF-000244', NULL, 'Uncharacterized protein', 180, NULL, NULL, 66503);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(66504, '3.90.70.10-FF-000275', NULL, 'Cysteine protease 13', 323, NULL, NULL, 66504),
(66505, '3.30.160.60-FF-005700', NULL, NULL, 92, NULL, NULL, 66505),
(66506, '1.25.40.470-FF-000010', NULL, 'Intraflagellar transport 140 homolog (Chlamydomonas)', 191, NULL, NULL, 66506),
(66507, '1.25.40.20-FF-001431', NULL, 'Uncharacterized protein', 169, NULL, NULL, 66507),
(66508, '1.10.10.820-FF-000029', NULL, 'Type II myosin heavy chain, putative', 55, NULL, NULL, 66508),
(66509, '3.80.10.10-FF-004352', NULL, 'Uncharacterized protein', 181, NULL, NULL, 66509),
(66510, '2.20.100.10-FF-000101', NULL, 'No long nerve cord, isoform F', 59, NULL, NULL, 66510),
(66511, '1.10.1300.10-FF-000060', NULL, 'Uncharacterized protein', 218, NULL, NULL, 66511),
(66512, '2.40.50.140-FF-000811', NULL, NULL, 132, NULL, NULL, 66512),
(66513, '3.30.420.40-FF-000881', NULL, 'Actin-related protein 6', 40, NULL, NULL, 66513),
(66514, '1.20.120.1900-FF-000095', NULL, 'Gamma-tubulin complex component', 98, NULL, NULL, 66514),
(66515, '3.30.750.24-FF-000157', NULL, 'Uncharacterized protein', 113, NULL, NULL, 66515),
(66516, '3.30.1490.100-FF-000052', NULL, 'Uncharacterized protein', 115, NULL, NULL, 66516),
(66517, '3.90.79.10-FF-000019', NULL, 'Thiamin pyrophosphokinase, putative', 181, NULL, NULL, 66517),
(66518, '2.60.40.10-FF-002654', NULL, NULL, 106, NULL, NULL, 66518),
(66519, '3.30.1490.190-FF-000022', NULL, 'Transcriptional regulator, Fur family', 54, NULL, NULL, 66519),
(66520, '3.30.479.30-FF-000018', NULL, 'STOM isoform 1', 86, NULL, NULL, 66520),
(66521, '3.90.176.10-FF-000003', NULL, 'NAD(P)(+)--arginine ADP-ribosyltransferase', 231, NULL, NULL, 66521),
(66522, '3.40.50.410-FF-000023', NULL, 'Collagen type VI alpha 3 chain', 201, NULL, NULL, 66522),
(66523, '3.10.100.10-FF-000156', NULL, 'GD24202', 129, NULL, NULL, 66523),
(66524, '1.10.238.10-FF-001112', NULL, 'Uncharacterized protein', 48, NULL, NULL, 66524),
(66525, '3.40.50.300-FF-000884', NULL, 'Dynein axonemal heavy chain 10', 183, NULL, NULL, 66525),
(66526, '2.60.40.10-FF-004778', NULL, NULL, 84, NULL, NULL, 66526),
(66527, '4.10.240.10-FF-000100', NULL, 'YKL222C-like protein', 90, NULL, NULL, 66527),
(66528, '3.40.800.10-FF-000051', NULL, NULL, 78, NULL, NULL, 66528),
(66529, '3.40.50.300-FF-001390', NULL, 'ABC transporter, ATP-binding protein', 249, NULL, NULL, 66529),
(66530, '3.30.1490.480-FF-000002', NULL, 'Endolytic murein transglycosylase', 70, NULL, NULL, 66530),
(66531, '1.10.287.4070-FF-000005', NULL, 'SnoRNA binding domain containing protein', 160, NULL, NULL, 66531),
(66532, '1.10.630.10-FF-000203', NULL, 'Cytochrome P450 81D1', 223, NULL, NULL, 66532),
(66533, '2.20.25.420-FF-000009', NULL, 'Uncharacterized protein', 55, NULL, NULL, 66533),
(66534, '1.20.1640.10-FF-000049', NULL, 'Transmembrane transport protein MmpL11', 198, NULL, NULL, 66534),
(66535, '1.10.1740.140-FF-000003', NULL, NULL, 43, NULL, NULL, 66535),
(66536, '3.90.70.10-FF-000797', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 323, NULL, NULL, 66536),
(66537, '2.130.10.10-FF-001204', NULL, 'Vacuolar protein sorting-associated protein 41 homolog', 264, NULL, NULL, 66537),
(66538, '1.20.1720.10-FF-000100', NULL, NULL, 212, NULL, NULL, 66538),
(66539, '1.20.1250.10-FF-000081', NULL, NULL, 156, NULL, NULL, 66539),
(66540, '2.60.40.10-FF-003160', NULL, 'Sortilin-related receptor, L(DLR class) A repeats containing', 100, NULL, NULL, 66540),
(66541, '3.40.50.1010-FF-000112', NULL, 'ERCC excision repair 5, endonuclease', 142, NULL, NULL, 66541),
(66542, '1.25.40.10-FF-000276', NULL, 'Mitochondrial ribonuclease P catalytic subunit', 225, NULL, NULL, 66542),
(66543, '3.40.390.10-FF-000052', NULL, 'Matrix metallopeptidase 26', 236, NULL, NULL, 66543),
(66544, '2.115.10.20-FF-000012', NULL, 'Probable sucrose-6-phosphate hydrolase', 350, NULL, NULL, 66544),
(66545, '1.20.1250.70-FF-000003', NULL, 'Interleukin', 118, NULL, NULL, 66545),
(66546, '3.30.40.10-FF-001973', NULL, 'Cellulose synthase/ transferase transferring glycosyl groups', 62, NULL, NULL, 66546),
(66547, '1.10.470.10-FF-000005', NULL, 'Variant surface glycoprotein (VSG, atypical), putative', 156, NULL, NULL, 66547);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(66548, '3.60.10.10-FF-000137', NULL, 'Metal-dependent hydrolase, endonuclease/exonuclease/phosphatase family', 232, NULL, NULL, 66548),
(66549, '1.25.40.10-FF-004654', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 231, NULL, NULL, 66549),
(66550, '1.25.40.10-FF-000955', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 105, NULL, NULL, 66550),
(66551, '1.25.10.10-FF-000774', NULL, 'Adapter-related protein complex 3 (AP-3) subunit, putative', 583, NULL, NULL, 66551),
(66552, '2.60.120.200-FF-000450', NULL, 'Uncharacterized protein', 64, NULL, NULL, 66552),
(66553, '3.40.50.1000-FF-000694', NULL, NULL, 135, NULL, NULL, 66553),
(66554, '1.20.1540.10-FF-000002', NULL, 'Rhomboid, veinlet-like 3 (Drosophila)', 208, NULL, NULL, 66554),
(66555, '3.30.160.60-FF-005363', NULL, NULL, 58, NULL, NULL, 66555),
(66556, '1.25.40.20-FF-000958', NULL, 'Uncharacterized protein', 106, NULL, NULL, 66556),
(66557, '1.20.1250.20-FF-002219', NULL, 'Solute carrier family 22 member 18', 133, NULL, NULL, 66557),
(66558, '2.120.10.30-FF-000249', NULL, 'Uncharacterized protein', 270, NULL, NULL, 66558),
(66559, '2.30.42.10-FF-000350', NULL, 'MAGI (Membrane Associated Guanylate kinase Inverted) homolog', 92, NULL, NULL, 66559),
(66560, '3.40.50.12370-FF-000012', NULL, 'Uncharacterized protein', 241, NULL, NULL, 66560),
(66561, '1.10.510.10-FF-002656', NULL, NULL, 113, NULL, NULL, 66561),
(66562, '1.20.90.10-FF-000053', NULL, NULL, 83, NULL, NULL, 66562),
(66563, '2.60.40.770-FF-000022', NULL, 'Putative phosphatidylglycerol/phosphatidylinositol transfer protein', 125, NULL, NULL, 66563),
(66564, '1.20.1070.10-FF-002118', NULL, 'Predicted protein', 169, NULL, NULL, 66564),
(66565, '3.40.190.10-FF-000424', NULL, 'Transcriptional regulator, LysR family', 104, NULL, NULL, 66565),
(66566, '3.40.50.150-FF-001530', NULL, NULL, 97, NULL, NULL, 66566),
(66567, '1.25.10.10-FF-000448', NULL, 'Calcium binding protein 39', 324, NULL, NULL, 66567),
(66568, '3.40.50.2300-FF-000522', NULL, 'Uncharacterized protein', 178, NULL, NULL, 66568),
(66569, '2.60.260.20-FF-000056', NULL, 'Chaperone protein DnaJ', 69, NULL, NULL, 66569),
(66570, '2.40.30.110-FF-000006', NULL, 'Sarcosine dehydrogenase, mitochondrial', 83, NULL, NULL, 66570),
(66571, '3.40.50.300-FF-004627', NULL, 'ABC transporter, ATP-binding/permease protein', 241, NULL, NULL, 66571),
(66572, '2.60.40.60-FF-001090', NULL, 'Uncharacterized protein', 107, NULL, NULL, 66572),
(66573, '1.10.3470.10-FF-000055', NULL, 'Probable metal transport system membrane protein CT_417', 268, NULL, NULL, 66573),
(66574, '2.20.120.10-FF-000001', NULL, 'Lysozyme', 58, NULL, NULL, 66574),
(66575, '2.60.40.60-FF-000628', NULL, 'Cadherin-related neuronal receptor 10', 112, NULL, NULL, 66575),
(66576, '2.40.128.620-FF-000001', NULL, 'neuropilin and tolloid-like protein 1', 96, NULL, NULL, 66576),
(66577, '3.30.160.60-FF-002766', NULL, 'Zinc finger protein 227-like Protein', 26, NULL, NULL, 66577),
(66578, '2.30.29.240-FF-000017', NULL, 'Phosphoinositide phospholipase C', 155, NULL, NULL, 66578),
(66579, '3.30.56.10-FF-000031', NULL, 'Putative phenylalanyl-tRNA synthetase', 74, NULL, NULL, 66579),
(66580, '3.30.70.330-FF-001888', NULL, NULL, 89, NULL, NULL, 66580),
(66581, '2.60.40.2860-FF-000005', NULL, 'Transmission-blocking target antigen s230', 137, NULL, NULL, 66581),
(66582, '1.20.1250.20-FF-000084', NULL, 'Synaptic vesicle 2-related protein', 434, NULL, NULL, 66582),
(66583, '2.130.10.10-FF-001530', NULL, 'Splicing factor 3b subunit 3, putative', 356, NULL, NULL, 66583),
(66584, '3.30.160.20-FF-000141', NULL, 'Double-stranded RNA-binding domain (DsRBD)-containing protein', 70, NULL, NULL, 66584),
(66585, '3.20.100.10-FF-000018', NULL, 'Uncharacterized protein', 345, NULL, NULL, 66585),
(66586, '3.40.50.720-FF-002252', NULL, 'Uncharacterized protein', 69, NULL, NULL, 66586),
(66587, '3.40.1440.60-FF-000008', NULL, 'Primosomal protein N''', 90, NULL, NULL, 66587),
(66588, '3.30.70.330-FF-002714', NULL, NULL, 103, NULL, NULL, 66588),
(66589, '3.40.50.1820-FF-000821', NULL, 'Protein-tyrosine phosphatase-like protein', 301, NULL, NULL, 66589);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(66590, '2.40.128.630-FF-000004', NULL, 'Serine/threonine protein kinase', 77, NULL, NULL, 66590),
(66591, '3.40.47.10-FF-000116', NULL, 'GumO', 158, NULL, NULL, 66591),
(66592, '3.40.50.300-FF-006718', NULL, 'Uncharacterized protein', 74, NULL, NULL, 66592),
(66593, '3.40.50.300-FF-000558', NULL, 'Elongation factor G, mitochondrial', 292, NULL, NULL, 66593),
(66594, '3.40.50.1370-FF-000006', NULL, 'Aspartate carbamoyltransferase', 140, NULL, NULL, 66594),
(66595, '3.40.640.10-FF-000369', NULL, 'Ornithine aminotransferase', 98, NULL, NULL, 66595),
(66596, '3.30.160.60-FF-006465', NULL, NULL, 55, NULL, NULL, 66596),
(66597, '3.30.40.10-FF-000236', NULL, 'Lysine-specific demethylase 4A', 48, NULL, NULL, 66597),
(66598, '3.10.520.10-FF-000002', NULL, 'NADH-dependent fumarate reductase', 324, NULL, NULL, 66598),
(66599, '3.40.50.1380-FF-000009', NULL, 'Carbamoyl-phosphate synthase, large subunit', 145, NULL, NULL, 66599),
(66600, '3.30.900.10-FF-000004', NULL, 'Mitotic spindle checkpoint protein MAD2', 203, NULL, NULL, 66600),
(66601, '1.10.286.10-FF-000009', NULL, 'GTP cyclohydrolase 1', 50, NULL, NULL, 66601),
(66602, '1.10.760.10-FF-000078', NULL, 'Similar to c-type cytochrome', 105, NULL, NULL, 66602),
(66603, '1.25.10.10-FF-002909', NULL, 'Armadillo repeat-containing protein, putative', 122, NULL, NULL, 66603),
(66604, '2.60.40.10-FF-001552', NULL, 'PKHD1 like 1', 87, NULL, NULL, 66604),
(66605, '3.90.228.20-FF-000021', NULL, NULL, 114, NULL, NULL, 66605),
(66606, '3.40.50.720-FF-000644', NULL, 'NAD dependent epimerase/dehydratase family, putative', 357, NULL, NULL, 66606),
(66607, '3.30.450.20-FF-000051', NULL, 'Cell wall metabolism sensor histidine kinase', 157, NULL, NULL, 66607),
(66608, '3.10.180.10-FF-000065', NULL, 'Methylmalonyl-CoA epimerase', 130, NULL, NULL, 66608),
(66609, '2.60.120.10-FF-000689', NULL, 'Uncharacterized protein', 73, NULL, NULL, 66609),
(66610, '2.60.40.420-FF-000164', NULL, 'Coagulation factor VIII, procoagulant component', 346, NULL, NULL, 66610),
(66611, '3.30.710.10-FF-000304', NULL, 'SKp1 Related (Ubiquitin ligase complex component)', 149, NULL, NULL, 66611),
(66612, '1.10.1070.11-FF-000076', NULL, 'Phosphatidylinositol 4-kinase', 179, NULL, NULL, 66612),
(66613, '3.40.50.10050-FF-000018', NULL, 'Translational initiation factor IF2, putative', 82, NULL, NULL, 66613),
(66614, '2.30.29.230-FF-000014', NULL, 'TBC1 domain family, member 17', 129, NULL, NULL, 66614),
(66615, '2.40.50.140-FF-000441', NULL, 'ATP-dependent DNA helicase RecG', 95, NULL, NULL, 66615),
(66616, '3.40.630.10-FF-000088', NULL, 'Peptidase M20', 276, NULL, NULL, 66616),
(66617, '1.10.1870.10-FF-000001', NULL, 'Alpha-aminoadipic semialdehyde synthase, mitochondrial', 99, NULL, NULL, 66617),
(66618, '1.10.287.70-FF-000400', NULL, 'Uncharacterized protein', 124, NULL, NULL, 66618),
(66619, '1.10.220.150-FF-000026', NULL, 'GTPase activating protein for Arf, putative', 132, NULL, NULL, 66619),
(66620, '3.30.450.30-FF-000054', NULL, 'Dynein light chain roadblock', 94, NULL, NULL, 66620),
(66621, '3.30.450.40-FF-000057', NULL, 'Two-component system sensor molecule', 145, NULL, NULL, 66621),
(66622, '1.10.10.10-FF-000931', NULL, 'Cullin family protein', 85, NULL, NULL, 66622),
(66623, '3.10.310.10-FF-000065', NULL, 'Proline racemase', 166, NULL, NULL, 66623),
(66624, '1.10.287.370-FF-000001', NULL, 'Prefoldin subunit 3', 144, NULL, NULL, 66624),
(66625, '1.10.1040.10-FF-000005', NULL, 'Ketol-acid reductoisomerase, mitochondrial', 30, NULL, NULL, 66625),
(66626, '1.25.40.10-FF-004328', NULL, 'Uncharacterized protein', 319, NULL, NULL, 66626),
(66627, '1.10.287.380-FF-000004', NULL, 'Valine--tRNA ligase mitochondrial 1', 72, NULL, NULL, 66627),
(66628, '3.40.50.1980-FF-000083', NULL, 'ABC transporter substrate-binding protein', 99, NULL, NULL, 66628),
(66629, '3.30.1490.80-FF-000020', NULL, 'Glutathione synthetase', 38, NULL, NULL, 66629),
(66630, '3.30.420.40-FF-000555', NULL, 'Hexokinase-1', 187, NULL, NULL, 66630),
(66631, '3.90.1150.160-FF-000009', NULL, 'Glutamate decarboxylase', 87, NULL, NULL, 66631);
INSERT INTO "PUBLIC"."MODEL" VALUES
(66632, '2.60.40.10-FF-002980', NULL, 'AGAP011650-PA', 132, NULL, NULL, 66632),
(66633, '1.10.287.110-FF-000087', NULL, 'DnaJ homolog subfamily C member 4', 98, NULL, NULL, 66633),
(66634, '3.80.10.10-FF-004026', NULL, 'Uncharacterized protein', 145, NULL, NULL, 66634),
(66635, '2.60.120.650-FF-000219', NULL, 'Predicted protein', 221, NULL, NULL, 66635),
(66636, '1.25.40.20-FF-001105', NULL, 'Uncharacterized protein', 58, NULL, NULL, 66636),
(66637, '3.30.160.60-FF-005037', NULL, NULL, 57, NULL, NULL, 66637),
(66638, '3.30.70.330-FF-002361', NULL, NULL, 105, NULL, NULL, 66638),
(66639, '1.10.287.130-FF-000160', NULL, 'Two-component system, OmpR family, sensor kinase', 67, NULL, NULL, 66639),
(66640, '3.30.1360.10-FF-000068', NULL, 'DNA-directed RNA polymerases II IV and V subunit 11', 46, NULL, NULL, 66640),
(66641, '3.40.50.150-FF-000378', NULL, 'Phosphoethanolamine N-methyltransferase', 266, NULL, NULL, 66641),
(66642, '3.10.20.580-FF-000002', NULL, 'Ribonuclease J', 99, NULL, NULL, 66642),
(66643, '2.60.40.10-FF-004099', NULL, NULL, 94, NULL, NULL, 66643),
(66644, '3.40.50.1000-FF-000368', NULL, 'Putative Alpha,alpha-trehalose-phosphate synthase', 146, NULL, NULL, 66644),
(66645, '2.60.120.650-FF-000192', NULL, 'Uncharacterized protein', 63, NULL, NULL, 66645),
(66646, '1.25.10.10-FF-002691', NULL, 'Beta-adaptin-like protein C', 71, NULL, NULL, 66646),
(66647, '2.160.20.80-FF-000010', NULL, 'Synaptic vesicle glycoprotein 2C', 90, NULL, NULL, 66647),
(66648, '3.90.190.10-FF-000019', NULL, 'receptor-type tyrosine-protein phosphatase U isoform X1', 292, NULL, NULL, 66648),
(66649, '3.50.50.60-FF-000099', NULL, 'Flavin-containing monooxygenase', 104, NULL, NULL, 66649),
(66650, '3.30.420.40-FF-001061', NULL, 'Uncharacterized protein', 46, NULL, NULL, 66650),
(66651, '1.10.10.2740-FF-000009', NULL, 'Transcription elongation factor spt6', 63, NULL, NULL, 66651),
(66652, '3.50.7.10-FF-000025', NULL, 'TCP-1 chaperonin subunit zeta protein', 171, NULL, NULL, 66652),
(66653, '2.30.30.60-FF-000005', NULL, 'Mechanosensitive ion channel protein', 50, NULL, NULL, 66653),
(66654, '3.40.50.2000-FF-000230', NULL, 'Glycosyltransferase', 259, NULL, NULL, 66654),
(66655, '1.25.40.10-FF-002193', NULL, 'Transcriptional activator CadC, putative', 159, NULL, NULL, 66655),
(66656, '3.40.50.300-FF-001064', NULL, 'Selenocysteine-specific translation elongation factor', 163, NULL, NULL, 66656),
(66657, '1.10.220.30-FF-000032', NULL, 'Flagellar motor switch protein FliG', 91, NULL, NULL, 66657),
(66658, '2.60.120.200-FF-000080', NULL, 'neurexin 3 isoform X1', 157, NULL, NULL, 66658),
(66659, '2.160.10.10-FF-000118', NULL, 'Kinesin-8, putative', 146, NULL, NULL, 66659),
(66660, '3.40.50.12780-FF-000045', NULL, 'Acetyl-CoA synthetase, putative', 315, NULL, NULL, 66660),
(66661, '2.30.30.50-FF-000002', NULL, 'Ferredoxin-thioredoxin reductase, variable chain', 81, NULL, NULL, 66661),
(66662, '3.40.50.620-FF-000070', NULL, 'Bifunctional glutamate/proline--tRNA ligase', 336, NULL, NULL, 66662),
(66663, '3.30.428.70-FF-000008', NULL, 'Predicted protein', 160, NULL, NULL, 66663),
(66664, '1.10.400.10-FF-000057', NULL, 'Guanine nucleotide-binding protein subunit alpha-13', 121, NULL, NULL, 66664),
(66665, '2.60.120.590-FF-000050', NULL, 'Alkylated DNA repair protein AlkB', 214, NULL, NULL, 66665),
(66666, '1.10.510.10-FF-001228', NULL, 'Kinase, NEK', 192, NULL, NULL, 66666),
(66667, '3.90.260.10-FF-000065', NULL, 'Chromosome 15, whole genome shotgun sequence', 197, NULL, NULL, 66667),
(66668, '3.40.50.720-FF-000318', NULL, 'ADP-ribosyl cyclase/cyclic ADP-ribose hydrolase 2', 125, NULL, NULL, 66668),
(66669, '2.10.25.10-FF-001429', NULL, 'Uncharacterized protein', 50, NULL, NULL, 66669),
(66670, '3.30.40.10-FF-002170', NULL, 'Uncharacterized protein', 84, NULL, NULL, 66670),
(66671, '3.40.850.10-FF-000306', NULL, 'Uncharacterized protein', 189, NULL, NULL, 66671),
(66672, '3.80.10.10-FF-001755', NULL, 'Disease resistance protein RPS5', 120, NULL, NULL, 66672),
(66673, '3.40.50.1470-FF-000003', NULL, 'Peptidyl-tRNA hydrolase 1 homolog', 184, NULL, NULL, 66673);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(66674, '2.60.40.10-FF-001226', NULL, 'protein turtle isoform X1', 106, NULL, NULL, 66674),
(66675, '3.40.50.2300-FF-000229', NULL, 'Receptor-type adenylate cyclase GRESAG 4, putative', 138, NULL, NULL, 66675),
(66676, '1.20.120.1490-FF-000005', NULL, 'Periplasmic protein cpxP, putative', 120, NULL, NULL, 66676),
(66677, '2.60.40.10-FF-004571', NULL, NULL, 100, NULL, NULL, 66677),
(66678, '2.30.42.10-FF-000041', NULL, 'protein scribble homolog isoform X1', 98, NULL, NULL, 66678),
(66679, '3.80.10.10-FF-003537', NULL, 'Uncharacterized protein', 164, NULL, NULL, 66679),
(66680, '1.10.441.10-FF-000011', NULL, 'Mannose-6-phosphate isomerase', 119, NULL, NULL, 66680),
(66681, '3.60.15.10-FF-000126', NULL, 'Glyoxylase, beta-lactamase superfamily II', 248, NULL, NULL, 66681),
(66682, '3.40.50.300-FF-007550', NULL, 'Uncharacterized protein', 193, NULL, NULL, 66682),
(66683, '2.40.50.180-FF-000020', NULL, 'Chemotaxis protein CheZ', 73, NULL, NULL, 66683),
(66684, '2.60.40.10-FF-000737', NULL, 'brother of CDO isoform X1', 96, NULL, NULL, 66684),
(66685, '2.10.25.10-FF-000018', NULL, 'Delta-like 1', 63, NULL, NULL, 66685),
(66686, '3.30.300.30-FF-000133', NULL, 'Ferrichrome siderophore peptide synthetase', 135, NULL, NULL, 66686),
(66687, '3.30.200.20-FF-000549', NULL, 'hydroxylysine kinase', 106, NULL, NULL, 66687),
(66688, '1.25.40.20-FF-001094', NULL, 'Kinase, NEK', 90, NULL, NULL, 66688),
(66689, '1.25.40.10-FF-001102', NULL, 'Pentatricopeptide repeat domain 1', 145, NULL, NULL, 66689),
(66690, '3.30.230.10-FF-000048', NULL, 'AAA family ATPase', 172, NULL, NULL, 66690),
(66691, '1.20.1560.10-FF-000065', NULL, 'ABC transporter ATP-binding protein/permease', 320, NULL, NULL, 66691),
(66692, '1.25.40.10-FF-001091', NULL, 'Os11g0213500 protein', 103, NULL, NULL, 66692),
(66693, '1.25.40.990-FF-000059', NULL, 'Uncharacterized protein', 208, NULL, NULL, 66693),
(66694, '1.10.287.70-FF-000080', NULL, 'Glutamate receptor ionotropic, kainate', 156, NULL, NULL, 66694),
(66695, '3.30.1060.10-FF-000023', NULL, NULL, 53, NULL, NULL, 66695),
(66696, '1.10.238.10-FF-000595', NULL, 'Phosphoinositide phospholipase C', 51, NULL, NULL, 66696),
(66697, '3.30.160.60-FF-001322', NULL, 'GLI family zinc finger 4', 32, NULL, NULL, 66697),
(66698, '3.90.550.20-FF-000011', NULL, 'Mannosyl phosphorylinositol ceramide synthase SUR1', 193, NULL, NULL, 66698),
(66699, '3.10.120.10-FF-000039', NULL, 'Nitrate reductase', 83, NULL, NULL, 66699),
(66700, '3.40.50.720-FF-000009', NULL, 'Fatty oxidation complex, alpha subunit', 186, NULL, NULL, 66700),
(66701, '2.130.10.10-FF-004756', NULL, 'Uncharacterized protein', 158, NULL, NULL, 66701),
(66702, '3.40.50.150-FF-000687', NULL, 'Methyltransferase, putative', 188, NULL, NULL, 66702),
(66703, '2.60.210.10-FF-000016', NULL, 'Ubiquitin-specific protease', 161, NULL, NULL, 66703),
(66704, '1.25.10.10-FF-001600', NULL, 'Uncharacterized protein', 1065, NULL, NULL, 66704),
(66705, '1.10.238.10-FF-000915', NULL, 'Phosphoinositide phospholipase C', 82, NULL, NULL, 66705),
(66706, '2.160.20.10-FF-000046', NULL, 'Polygalacturonase QRT3', 406, NULL, NULL, 66706),
(66707, '2.130.10.10-FF-002295', NULL, 'Vacuolar protein sorting-associated protein 39 homolog', 178, NULL, NULL, 66707),
(66708, '1.10.1670.10-FF-000036', NULL, 'Endonuclease III homolog', 83, NULL, NULL, 66708),
(66709, '3.40.1110.10-FF-000250', NULL, NULL, 137, NULL, NULL, 66709),
(66710, '3.40.50.300-FF-005072', NULL, 'Ras-related protein Rab-6A', 108, NULL, NULL, 66710),
(66711, '2.170.150.10-FF-000029', NULL, 'Predicted protein', 59, NULL, NULL, 66711),
(66712, '1.20.1730.10-FF-000011', NULL, 'sodium-dependent multivitamin transporter isoform X1', 500, NULL, NULL, 66712),
(66713, '3.60.60.10-FF-000011', NULL, 'Bile salt hydrolase', 312, NULL, NULL, 66713),
(66714, '3.40.850.10-FF-000441', NULL, 'Predicted protein', 133, NULL, NULL, 66714),
(66715, '2.130.10.10-FF-004739', NULL, 'Uncharacterized protein', 163, NULL, NULL, 66715),
(66716, '3.80.10.10-FF-003672', NULL, 'Uncharacterized protein', 217, NULL, NULL, 66716),
(66717, '2.60.260.20-FF-000073', NULL, 'DnaJ homolog, isoform A', 69, NULL, NULL, 66717);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(66718, '3.40.30.10-FF-001275', NULL, 'AGAP000044-PA', 130, NULL, NULL, 66718),
(66719, '3.40.50.300-FF-003508', NULL, 'Chromosome 7, whole genome shotgun sequence', 259, NULL, NULL, 66719),
(66720, '3.30.70.2510-FF-000008', NULL, NULL, 63, NULL, NULL, 66720),
(66721, '3.10.180.10-FF-000048', NULL, '4-hydroxyphenylpyruvate dioxygenase', 166, NULL, NULL, 66721),
(66722, '1.20.1250.20-FF-001495', NULL, 'Zgc:171501', 222, NULL, NULL, 66722),
(66723, '3.40.190.10-FF-000733', NULL, 'Proline/glycine betaine ABC superfamily ATP binding cassette transporter, membrane protein', 156, NULL, NULL, 66723),
(66724, '1.20.900.10-FF-000031', NULL, 'Uncharacterized protein, isoform B', 191, NULL, NULL, 66724),
(66725, '3.60.15.10-FF-000143', NULL, 'MBL fold metallo-hydrolase', 244, NULL, NULL, 66725),
(66726, '3.40.50.300-FF-003172', NULL, 'Katanin p60 ATPase-containing subunit A1', 169, NULL, NULL, 66726),
(66727, '3.10.20.90-FF-000389', NULL, 'Os10g0200000 protein', 80, NULL, NULL, 66727),
(66728, '2.10.25.10-FF-001738', NULL, 'FEEL-1', 38, NULL, NULL, 66728),
(66729, '2.60.120.260-FF-000535', NULL, 'Uncharacterized protein', 87, NULL, NULL, 66729),
(66730, '3.60.130.10-FF-000051', NULL, 'Uncharacterized protein', 159, NULL, NULL, 66730),
(66731, '3.30.70.660-FF-000003', NULL, 'tRNA pseudouridine synthase A', 142, NULL, NULL, 66731),
(66732, '3.40.50.1220-FF-000057', NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit epsilon', 159, NULL, NULL, 66732),
(66733, '3.40.50.150-FF-001221', NULL, NULL, 191, NULL, NULL, 66733),
(66734, '1.10.3170.10-FF-000010', NULL, 'RecBCD enzyme subunit RecB', 196, NULL, NULL, 66734),
(66735, '3.30.70.330-FF-002731', NULL, NULL, 97, NULL, NULL, 66735),
(66736, '1.10.10.10-FF-000594', NULL, 'ArsR family transcriptional regulator', 99, NULL, NULL, 66736),
(66737, '3.90.1300.10-FF-000040', NULL, 'Uncharacterized protein', 169, NULL, NULL, 66737),
(66738, '3.40.50.2300-FF-000185', NULL, 'Guanylate cyclase', 178, NULL, NULL, 66738),
(66739, '3.30.160.60-FF-006482', NULL, NULL, 34, NULL, NULL, 66739),
(66740, '1.10.287.70-FF-000063', NULL, 'ATP-sensitive inward rectifier potassium channel 14', 129, NULL, NULL, 66740),
(66741, '2.120.10.80-FF-000096', NULL, 'Dynein heavy chain-like protein', 200, NULL, NULL, 66741),
(66742, '2.130.10.30-FF-000125', NULL, NULL, 148, NULL, NULL, 66742),
(66743, '2.60.120.260-FF-000670', NULL, 'Beta-mannanase', 151, NULL, NULL, 66743),
(66744, '1.10.600.10-FF-000038', NULL, '(2E,6E)-farnesyl diphosphate synthase', 336, NULL, NULL, 66744),
(66745, '3.40.50.410-FF-000006', NULL, 'voltage-dependent calcium channel subunit alpha-2/delta-1 isoform X1', 173, NULL, NULL, 66745),
(66746, '1.10.800.10-FF-000020', NULL, 'Tyrosine 3-monooxygenase-like Protein', 136, NULL, NULL, 66746),
(66747, '1.10.10.60-FF-000693', NULL, 'Reproductive homeobox 3A', 76, NULL, NULL, 66747),
(66748, '2.60.40.60-FF-000937', NULL, 'Uncharacterized protein', 103, NULL, NULL, 66748),
(66749, '4.10.80.100-FF-000001', NULL, 'Nucleoside diphosphate-linked moiety X motif 6', 34, NULL, NULL, 66749),
(66750, '3.40.250.10-FF-000103', NULL, 'Rodhanase family domain containing protein', 165, NULL, NULL, 66750),
(66751, '3.40.190.10-FF-000087', NULL, 'glutamate receptor 4 isoform X2', 81, NULL, NULL, 66751),
(66752, '1.20.1070.10-FF-001764', NULL, 'Olfactory receptor 61', 68, NULL, NULL, 66752),
(66753, '3.30.565.10-FF-000365', NULL, 'Heat shock protein 75 kDa, mitochondrial', 85, NULL, NULL, 66753),
(66754, '1.10.510.10-FF-004438', NULL, NULL, 55, NULL, NULL, 66754),
(66755, '1.10.510.10-FF-000739', NULL, 'CAMK/CDPK protein kinase', 196, NULL, NULL, 66755),
(66756, '3.30.70.1230-FF-000012', NULL, 'Adenylate cyclase', 197, NULL, NULL, 66756),
(66757, '3.30.260.10-FF-000022', NULL, 'T-complex protein 1 subunit eta', 36, NULL, NULL, 66757),
(66758, '3.40.50.150-FF-001513', NULL, NULL, 110, NULL, NULL, 66758),
(66759, '3.30.200.20-FF-002483', NULL, 'Myosin light chain kinase b', 34, NULL, NULL, 66759),
(66760, '2.30.30.100-FF-000157', NULL, 'Small nuclear ribonucleoprotein E', 86, NULL, NULL, 66760);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(66761, '3.60.140.10-FF-000023', NULL, 'Uncharacterized protein', 140, NULL, NULL, 66761),
(66762, '3.30.160.60-FF-004874', NULL, NULL, 50, NULL, NULL, 66762),
(66763, '3.30.1370.10-FF-000007', NULL, 'far upstream element-binding protein 1 isoform X1', 80, NULL, NULL, 66763),
(66764, '1.20.1070.10-FF-001629', NULL, 'Predicted protein', 141, NULL, NULL, 66764),
(66765, '1.10.1070.11-FF-000059', NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', 197, NULL, NULL, 66765),
(66766, '2.130.10.10-FF-003121', NULL, 'Eukaryotic translation initiation factor 2A', 265, NULL, NULL, 66766),
(66767, '3.90.226.10-FF-000339', NULL, 'Uncharacterized protein', 227, NULL, NULL, 66767),
(66768, '3.50.50.60-FF-000571', NULL, 'Rab geranylgeranyl transferase component A, putative', 141, NULL, NULL, 66768),
(66769, '1.25.40.10-FF-004345', NULL, 'Predicted protein', 162, NULL, NULL, 66769),
(66770, '1.20.120.1900-FF-000078', NULL, 'Uncharacterized protein', 273, NULL, NULL, 66770),
(66771, '3.30.360.10-FF-000069', NULL, 'Saccharopine dehydrogenase', 191, NULL, NULL, 66771),
(66772, '3.40.309.10-FF-000105', NULL, 'Aldehyde dehydrogenase', 228, NULL, NULL, 66772),
(66773, '1.10.1040.10-FF-000022', NULL, '3-sulfolactaldehyde reductase', 132, NULL, NULL, 66773),
(66774, '1.20.1560.10-FF-000391', NULL, 'Lipid A export ATP-binding/permease protein MsbA', 345, NULL, NULL, 66774),
(66775, '3.90.1150.10-FF-000286', NULL, 'Gamma-aminobutyrate transaminase POP2 mitochondrial', 95, NULL, NULL, 66775),
(66776, '3.90.660.20-FF-000014', NULL, 'Amine oxidase', 204, NULL, NULL, 66776),
(66777, '3.40.50.300-FF-000867', NULL, 'Caspase recruitment domain family member 10', 192, NULL, NULL, 66777),
(66778, '3.40.50.720-FF-001763', NULL, 'Uncharacterized protein', 187, NULL, NULL, 66778),
(66779, '2.30.29.30-FF-000055', NULL, 'Phosphatidylinositol 3,4,5-trisphosphate-dependent Rac exchanger 1 protein-like', 161, NULL, NULL, 66779),
(66780, '3.40.50.880-FF-000097', NULL, 'Imidazole glycerol phosphate synthase subunit HisH', 196, NULL, NULL, 66780),
(66781, '2.120.10.30-FF-000558', NULL, 'Uncharacterized protein', 71, NULL, NULL, 66781),
(66782, '3.30.70.270-FF-000302', NULL, NULL, 54, NULL, NULL, 66782),
(66783, '3.30.230.10-FF-000374', NULL, 'Uncharacterized protein', 58, NULL, NULL, 66783),
(66784, '3.40.1230.10-FF-000017', NULL, 'Uncharacterized protein', 117, NULL, NULL, 66784),
(66785, '3.40.800.10-FF-000034', NULL, NULL, 269, NULL, NULL, 66785),
(66786, '3.30.160.60-FF-005054', NULL, NULL, 37, NULL, NULL, 66786),
(66787, '3.30.479.30-FF-000035', NULL, 'Flotillin 2', 54, NULL, NULL, 66787),
(66788, '1.20.5.4010-FF-000006', NULL, 'Uncharacterized protein', 45, NULL, NULL, 66788),
(66789, '3.40.630.50-FF-000004', NULL, 'D-aminoacyl-tRNA deacylase', 170, NULL, NULL, 66789),
(66790, '3.30.200.20-FF-000875', NULL, 'Protein kinase-like protein', 122, NULL, NULL, 66790),
(66791, '2.70.170.10-FF-000246', NULL, 'Uncharacterized protein', 157, NULL, NULL, 66791),
(66792, '3.90.550.10-FF-000593', NULL, 'Uncharacterized protein', 232, NULL, NULL, 66792),
(66793, '3.60.70.12-FF-000014', NULL, 'Glutamate N-acetyltransferase', 182, NULL, NULL, 66793),
(66794, '1.10.8.10-FF-000143', NULL, 'Protein Gawky', 40, NULL, NULL, 66794),
(66795, '3.40.50.1000-FF-000385', NULL, 'Uncharacterized protein', 195, NULL, NULL, 66795),
(66796, '3.40.50.720-FF-002561', NULL, 'Uncharacterized protein', 47, NULL, NULL, 66796),
(66797, '3.30.70.3250-FF-000017', NULL, NULL, 124, NULL, NULL, 66797),
(66798, '2.130.10.10-FF-001221', NULL, 'Tusp, isoform G', 318, NULL, NULL, 66798),
(66799, '3.90.660.10-FF-000011', NULL, 'Amine oxidase', 38, NULL, NULL, 66799),
(66800, '3.50.7.10-FF-000042', NULL, NULL, 74, NULL, NULL, 66800),
(66801, '3.40.50.1580-FF-000053', NULL, 'Purine nucleoside phosphorylase 4b', 110, NULL, NULL, 66801),
(66802, '3.30.160.60-FF-000849', NULL, 'Zinc finger protein 408', 27, NULL, NULL, 66802),
(66803, '3.40.630.40-FF-000001', NULL, 'N-acetylmuramoyl-L-alanine amidase', 235, NULL, NULL, 66803),
(66804, '1.25.40.10-FF-000938', NULL, 'Pentatricopeptide repeat-containing protein', 93, NULL, NULL, 66804);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(66805, '1.10.630.10-FF-000220', NULL, 'Uncharacterized protein', 204, NULL, NULL, 66805),
(66806, '3.80.10.10-FF-000311', NULL, 'Chondroadherin-like a', 144, NULL, NULL, 66806),
(66807, '3.30.420.10-FF-000411', NULL, NULL, 179, NULL, NULL, 66807),
(66808, '1.25.40.10-FF-000629', NULL, 'Putative pentatricopeptide repeat-containing protein', 131, NULL, NULL, 66808),
(66809, '1.10.10.60-FF-001210', NULL, NULL, 81, NULL, NULL, 66809),
(66810, '1.10.510.10-FF-001021', NULL, 'Serine/threonine protein kinase', 330, NULL, NULL, 66810),
(66811, '3.10.290.70-FF-000012', NULL, '40S ribosomal protein S8', 87, NULL, NULL, 66811),
(66812, '1.25.40.10-FF-002546', NULL, 'Os08g0340900 protein', 133, NULL, NULL, 66812),
(66813, '3.60.40.10-FF-000111', NULL, 'Probable protein phosphatase 2C 75', 326, NULL, NULL, 66813),
(66814, '3.40.630.10-FF-000234', NULL, 'Os07g0249900 protein', 87, NULL, NULL, 66814),
(66815, '3.10.10.10-FF-000044', NULL, NULL, 44, NULL, NULL, 66815),
(66816, '2.40.70.10-FF-000493', NULL, NULL, 131, NULL, NULL, 66816),
(66817, '3.40.390.10-FF-000035', NULL, 'Matrix metallopeptidase 27', 248, NULL, NULL, 66817),
(66818, '3.40.50.1240-FF-000209', NULL, NULL, 221, NULL, NULL, 66818),
(66819, '3.30.530.20-FF-000198', NULL, 'Protein retinal degeneration B-like Protein', 130, NULL, NULL, 66819),
(66820, '1.20.1250.20-FF-002236', NULL, 'Os03g0235300 protein', 119, NULL, NULL, 66820),
(66821, '3.40.50.1820-FF-000512', NULL, 'Probable serine hydrolase', 286, NULL, NULL, 66821),
(66822, '1.20.920.10-FF-000122', NULL, 'Polybromo 1', 101, NULL, NULL, 66822),
(66823, '3.40.50.300-FF-001710', NULL, 'RNA helicase', 80, NULL, NULL, 66823),
(66824, '2.60.120.200-FF-000124', NULL, 'Galectin-4', 144, NULL, NULL, 66824),
(66825, '2.60.410.10-FF-000014', NULL, NULL, 90, NULL, NULL, 66825),
(66826, '2.60.120.260-FF-000209', NULL, 'E3 ubiquitin-protein ligase highwire', 146, NULL, NULL, 66826),
(66827, '1.10.486.10-FF-000007', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', 196, NULL, NULL, 66827),
(66828, '3.50.50.60-FF-000806', NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', 236, NULL, NULL, 66828),
(66829, '3.40.50.720-FF-000335', NULL, 'Peroxisomal trans-2-enoyl-CoA reductase', 299, NULL, NULL, 66829),
(66830, '1.10.150.20-FF-000085', NULL, 'DNA polymerase I', 172, NULL, NULL, 66830),
(66831, '1.25.40.20-FF-001801', NULL, 'Uncharacterized protein', 167, NULL, NULL, 66831),
(66832, '3.30.160.60-FF-002749', NULL, 'Zinc finger protein 518A', 86, NULL, NULL, 66832),
(66833, '2.30.29.30-FF-000038', NULL, 'Myotubularin 1, isoform CRA_a', 101, NULL, NULL, 66833),
(66834, '1.10.287.770-FF-000014', NULL, 'Nach, isoform A', 59, NULL, NULL, 66834),
(66835, '2.40.50.140-FF-000665', NULL, NULL, 64, NULL, NULL, 66835),
(66836, '2.40.30.110-FF-000023', NULL, NULL, 83, NULL, NULL, 66836),
(66837, '3.30.40.10-FF-000371', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 100, NULL, NULL, 66837),
(66838, '1.20.1050.10-FF-000318', NULL, 'tRNA binding domain containing protein', 99, NULL, NULL, 66838),
(66839, '3.20.20.100-FF-000182', NULL, 'Uncharacterized protein', 137, NULL, NULL, 66839),
(66840, '3.40.50.720-FF-001746', NULL, 'Predicted protein', 175, NULL, NULL, 66840),
(66841, '2.130.10.10-FF-002941', NULL, 'Uncharacterized protein', 171, NULL, NULL, 66841),
(66842, '2.20.70.10-FF-000140', NULL, 'GL18629', 77, NULL, NULL, 66842),
(66843, '2.120.10.30-FF-000575', NULL, 'Uncharacterized protein', 195, NULL, NULL, 66843),
(66844, '2.40.70.10-FF-000184', NULL, 'Peptidase, putative', 193, NULL, NULL, 66844),
(66845, '3.80.10.10-FF-002109', NULL, 'Si:dkey-1h4.4', 242, NULL, NULL, 66845),
(66846, '3.40.50.720-FF-002235', NULL, 'uncharacterized protein LOC100178832', 92, NULL, NULL, 66846),
(66847, '3.90.190.20-FF-000039', NULL, 'Uncharacterized protein', 202, NULL, NULL, 66847),
(66848, '3.50.50.60-FF-000880', NULL, 'FAD-dependent oxidoreductase domain-containing protein 2', 361, NULL, NULL, 66848),
(66849, '1.20.58.1420-FF-000004', NULL, 'COPI vesicle fusion protein, putative', 115, NULL, NULL, 66849);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(66850, '3.90.640.10-FF-000111', NULL, 'Heat shock protein, putative', 92, NULL, NULL, 66850),
(66851, '1.20.58.60-FF-000510', NULL, 'Uncharacterized protein', 117, NULL, NULL, 66851),
(66852, '1.25.40.10-FF-004800', NULL, 'Uncharacterized protein', 167, NULL, NULL, 66852),
(66853, '3.30.1060.10-FF-000006', NULL, 'Peptide methionine sulfoxide reductase', 180, NULL, NULL, 66853),
(66854, '1.10.150.240-FF-000109', NULL, 'HAD superfamily hydrolase', 74, NULL, NULL, 66854),
(66855, '2.40.30.130-FF-000029', NULL, 'Alanine--tRNA ligase', 106, NULL, NULL, 66855),
(66856, '1.25.40.990-FF-000076', NULL, 'Uncharacterized protein', 276, NULL, NULL, 66856),
(66857, '3.40.50.970-FF-000135', NULL, 'Uncharacterized protein', 130, NULL, NULL, 66857),
(66858, '3.40.50.1580-FF-000070', NULL, 'Purine nucleoside phosphorylase', 284, NULL, NULL, 66858),
(66859, '3.90.550.10-FF-000267', NULL, 'Probable glycosyltransferase', 229, NULL, NULL, 66859),
(66860, '1.25.40.570-FF-000040', NULL, 'Uncharacterized protein', 255, NULL, NULL, 66860),
(66861, '3.40.50.300-FF-007224', NULL, 'Uncharacterized protein', 163, NULL, NULL, 66861),
(66862, '1.10.357.10-FF-000079', NULL, 'TetR/AcrR family transcriptional regulator', 146, NULL, NULL, 66862),
(66863, '2.130.10.10-FF-002278', NULL, 'General transcription factor IIIC, polypeptide 2, beta', 240, NULL, NULL, 66863),
(66864, '3.30.230.10-FF-000065', NULL, 'Elongation factor G, mitochondrial', 136, NULL, NULL, 66864),
(66865, '1.10.1670.10-FF-000019', NULL, 'Endonuclease III', 72, NULL, NULL, 66865),
(66866, '3.30.200.20-FF-000566', NULL, 'Phytosulfokine receptor 1', 113, NULL, NULL, 66866),
(66867, '3.90.70.40-FF-000014', NULL, 'Chromosome 8, whole genome shotgun sequence', 109, NULL, NULL, 66867),
(66868, '3.40.30.10-FF-000010', NULL, 'Glutathione peroxidase', 163, NULL, NULL, 66868),
(66869, '3.40.50.300-FF-006735', NULL, 'Uncharacterized protein', 70, NULL, NULL, 66869),
(66870, '3.40.50.10810-FF-000275', NULL, 'Uncharacterized protein', 80, NULL, NULL, 66870),
(66871, '1.20.120.1880-FF-000015', NULL, 'Uncharacterized protein', 172, NULL, NULL, 66871),
(66872, '3.40.50.300-FF-003301', NULL, 'Helicase/secretion CpaE-like protein', 222, NULL, NULL, 66872),
(66873, '3.10.100.10-FF-000291', NULL, NULL, 142, NULL, NULL, 66873),
(66874, '3.10.129.10-FF-000255', NULL, 'Hydroxyacyl-thioester dehydratase type 2, mitochondrial', 104, NULL, NULL, 66874),
(66875, '1.10.220.150-FF-000043', NULL, 'ARF GAP', 124, NULL, NULL, 66875),
(66876, '1.20.1560.10-FF-000211', NULL, 'Ste6p', 620, NULL, NULL, 66876),
(66877, '2.60.40.2960-FF-000002', NULL, 'Type 2 DNA topoisomerase 6 subunit B', 111, NULL, NULL, 66877),
(66878, '1.10.10.60-FF-000367', NULL, 'homeobox even-skipped homolog protein 2', 77, NULL, NULL, 66878),
(66879, '3.30.420.40-FF-000908', NULL, 'Uncharacterized protein', 86, NULL, NULL, 66879),
(66880, '2.130.10.10-FF-004094', NULL, 'WD repeat-containing protein 6', 197, NULL, NULL, 66880),
(66881, '3.30.450.20-FF-000242', NULL, 'Cyclic di-GMP phosphodiesterase Gmr', 140, NULL, NULL, 66881),
(66882, '3.40.1090.10-FF-000028', NULL, 'Patatin', 102, NULL, NULL, 66882),
(66883, '1.20.1070.10-FF-000320', NULL, 'Pteropsin4', 331, NULL, NULL, 66883),
(66884, '3.40.50.300-FF-005633', NULL, 'YTH domain-containing 2', 225, NULL, NULL, 66884),
(66885, '3.40.50.920-FF-000053', NULL, 'Protein CBR-TAG-173', 87, NULL, NULL, 66885),
(66886, '1.25.10.10-FF-002718', NULL, 'Protein CBG09629', 970, NULL, NULL, 66886),
(66887, '3.40.190.10-FF-000750', NULL, 'Predicted protein', 238, NULL, NULL, 66887),
(66888, '3.90.70.10-FF-000808', NULL, 'Uncharacterized protein', 312, NULL, NULL, 66888),
(66889, '3.50.50.60-FF-000245', NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', 280, NULL, NULL, 66889),
(66890, '3.30.1050.10-FF-000051', NULL, 'Predicted protein', 111, NULL, NULL, 66890),
(66891, '1.10.30.10-FF-000168', NULL, 'Uncharacterized protein', 45, NULL, NULL, 66891),
(66892, '3.10.490.10-FF-000049', NULL, 'Putative gamma-glutamylcyclotransferase MJ1514', 120, NULL, NULL, 66892),
(66893, '2.60.40.1400-FF-000012', NULL, 'Inward rectifier potassium channel 16', 180, NULL, NULL, 66893);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(66894, '3.40.50.150-FF-001204', NULL, NULL, 172, NULL, NULL, 66894),
(66895, '3.30.420.110-FF-000082', NULL, 'Uncharacterized protein', 128, NULL, NULL, 66895),
(66896, '1.10.10.1760-FF-000013', NULL, '60S ribosomal protein L36', 101, NULL, NULL, 66896),
(66897, '2.10.25.10-FF-001755', NULL, 'Uncharacterized protein', 36, NULL, NULL, 66897),
(66898, '3.30.70.330-FF-000444', NULL, 'Zinc finger CCCH domain-containing protein 27', 76, NULL, NULL, 66898),
(66899, '3.40.640.10-FF-000471', NULL, 'Predicted protein', 112, NULL, NULL, 66899),
(66900, '2.60.120.650-FF-000236', NULL, 'Predicted protein', 117, NULL, NULL, 66900),
(66901, '2.60.40.60-FF-000954', NULL, 'Predicted protein', 103, NULL, NULL, 66901),
(66902, '1.25.40.10-FF-004980', NULL, 'Developmental protein DG1091', 405, NULL, NULL, 66902),
(66903, '2.130.10.10-FF-000687', NULL, 'WD repeat domain 75', 216, NULL, NULL, 66903),
(66904, '3.30.200.20-FF-002157', NULL, 'Uncharacterized protein', 66, NULL, NULL, 66904),
(66905, '1.10.10.60-FF-000676', NULL, 'Phosphoglycerate transport system transcriptional regulatory protein PgtA', 64, NULL, NULL, 66905),
(66906, '3.40.50.10860-FF-000048', NULL, 'Bifunctional protein FolD', 150, NULL, NULL, 66906),
(66907, '3.90.1140.10-FF-000049', NULL, 'Uncharacterized protein', 213, NULL, NULL, 66907),
(66908, '3.80.10.10-FF-003981', NULL, 'Uncharacterized protein', 159, NULL, NULL, 66908),
(66909, '3.90.190.10-FF-000036', NULL, 'Serine/threonine/tyrosine-interacting protein a', 153, NULL, NULL, 66909),
(66910, '3.40.50.11500-FF-000015', NULL, 'DENN domain containing protein 2D', 172, NULL, NULL, 66910),
(66911, '3.90.550.50-FF-000037', NULL, 'Hexosyltransferase', 193, NULL, NULL, 66911),
(66912, '3.40.50.300-FF-001401', NULL, 'Dynein, axonemal, heavy chain 7', 193, NULL, NULL, 66912),
(66913, '1.10.10.10-FF-000285', NULL, 'RNA polymerase sigma factor RpoH', 70, NULL, NULL, 66913),
(66914, '3.90.79.10-FF-000199', NULL, 'diphosphoinositol polyphosphate phosphohydrolase 1-like', 146, NULL, NULL, 66914),
(66915, '3.40.50.1860-FF-000013', NULL, 'Glutamate racemase', 102, NULL, NULL, 66915),
(66916, '1.25.40.10-FF-004671', NULL, 'Uncharacterized protein', 225, NULL, NULL, 66916),
(66917, '3.40.50.620-FF-000423', NULL, 'Electron transfer flavoprotein alpha subunit', 194, NULL, NULL, 66917),
(66918, '3.30.200.20-FF-002466', NULL, 'Receptor tyrosine-protein kinase erbB-4', 52, NULL, NULL, 66918),
(66919, '2.130.10.10-FF-002839', NULL, 'Protein HIRA', 360, NULL, NULL, 66919),
(66920, '2.130.10.10-FF-000378', NULL, 'U3 small nucleolar RNA-associated protein 7', 286, NULL, NULL, 66920),
(66921, '2.20.25.100-FF-000003', NULL, '40S ribosomal protein S27', 52, NULL, NULL, 66921),
(66922, '3.40.220.10-FF-000040', NULL, 'SNF2 family DNA-dependent ATPase', 162, NULL, NULL, 66922),
(66923, '3.30.200.20-FF-001977', NULL, 'Uncharacterized protein', 125, NULL, NULL, 66923),
(66924, '1.20.1560.10-FF-000520', NULL, 'Uncharacterized protein', 310, NULL, NULL, 66924),
(66925, '3.40.50.12780-FF-000062', NULL, 'Nonribosomal peptide synthetase gliP', 395, NULL, NULL, 66925),
(66926, '2.60.34.10-FF-000133', NULL, 'Uncharacterized protein', 78, NULL, NULL, 66926),
(66927, '2.60.120.200-FF-000433', NULL, 'Lectin family integral membrane protein, putative', 232, NULL, NULL, 66927),
(66928, '3.80.10.10-FF-001946', NULL, 'Phytosulfokine receptor 1', 306, NULL, NULL, 66928),
(66929, '3.40.50.150-FF-000833', NULL, 'Protein-L-isoaspartate O-methyltransferase', 209, NULL, NULL, 66929),
(66930, '2.10.25.10-FF-000002', NULL, 'Latent-transforming growth factor beta-binding protein 3', 86, NULL, NULL, 66930),
(66931, '3.50.50.60-FF-000554', NULL, 'Glutamate synthase beta subunit, putative', 103, NULL, NULL, 66931),
(66932, '1.25.40.10-FF-002754', NULL, 'CCR4-NOT transcription complex subunit 10, putative', 195, NULL, NULL, 66932),
(66933, '1.25.10.10-FF-001145', NULL, 'Uncharacterized protein', 1024, NULL, NULL, 66933),
(66934, '3.20.20.80-FF-000306', NULL, 'Solute carrier family 3 member 2a', 304, NULL, NULL, 66934),
(66935, '3.30.420.10-FF-000203', NULL, 'CAF1 family ribonuclease containing protein', 296, NULL, NULL, 66935);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(66936, '3.40.50.300-FF-004392', NULL, 'Small GTPase EhRabX16, putative', 199, NULL, NULL, 66936),
(66937, '3.30.460.10-FF-000211', NULL, 'Uncharacterized protein', 49, NULL, NULL, 66937),
(66938, '2.130.10.10-FF-000833', NULL, 'WD repeat-containing protein 3', 217, NULL, NULL, 66938),
(66939, '3.75.10.10-FF-000008', NULL, 'Eukaryotic translation initiation factor 6', 113, NULL, NULL, 66939),
(66940, '3.30.497.10-FF-000173', NULL, 'Serpin peptidase inhibitor 26', 196, NULL, NULL, 66940),
(66941, '3.30.70.20-FF-000084', NULL, NULL, 67, NULL, NULL, 66941),
(66942, '3.30.40.10-FF-001681', NULL, 'Histone-lysine N-methyltransferase', 73, NULL, NULL, 66942),
(66943, '2.60.200.20-FF-000182', NULL, 'Uncharacterized protein', 127, NULL, NULL, 66943),
(66944, '2.40.50.180-FF-000003', NULL, 'Chemotaxis protein CheV', 68, NULL, NULL, 66944),
(66945, '3.40.190.10-FF-000615', NULL, 'Molybdate transport system substrate-binding protein', 113, NULL, NULL, 66945),
(66946, '3.30.470.20-FF-000142', NULL, 'Ribosomal protein S6 glutaminyl transferase', 118, NULL, NULL, 66946),
(66947, '2.80.10.50-FF-000179', NULL, 'Fascin', 65, NULL, NULL, 66947),
(66948, '2.30.29.30-FF-000072', NULL, 'Rho guanine nucleotide exchange factor 1', 142, NULL, NULL, 66948),
(66949, '2.60.40.10-FF-004554', NULL, NULL, 110, NULL, NULL, 66949),
(66950, '2.60.40.10-FF-005060', NULL, NULL, 101, NULL, NULL, 66950),
(66951, '1.10.3640.10-FF-000001', NULL, 'Putative oxidoreductase', 102, NULL, NULL, 66951),
(66952, '1.10.10.10-FF-002084', NULL, 'Histone acetyltransferase', 43, NULL, NULL, 66952),
(66953, '2.60.40.10-FF-000754', NULL, 'Cytokine receptor common subunit gamma', 102, NULL, NULL, 66953),
(66954, '3.40.50.720-FF-002443', NULL, 'Uncharacterized protein', 136, NULL, NULL, 66954),
(66955, '3.90.550.10-FF-000475', NULL, 'Flagellin modification protein', 214, NULL, NULL, 66955),
(66956, '3.40.50.1580-FF-000036', NULL, 'Possible DNA repair photolyase', 198, NULL, NULL, 66956),
(66957, '2.10.110.10-FF-000109', NULL, 'Lipoma preferred partner', 61, NULL, NULL, 66957),
(66958, '3.30.43.10-FF-000035', NULL, 'FAD-linked oxidoreductase', 65, NULL, NULL, 66958),
(66959, '3.30.160.60-FF-000288', NULL, 'Putative zinc finger protein 143', 29, NULL, NULL, 66959),
(66960, '2.60.34.10-FF-000015', NULL, 'Molecular chaperone HscC', 181, NULL, NULL, 66960),
(66961, '3.30.40.10-FF-000045', NULL, 'RING finger protein 113A', 60, NULL, NULL, 66961),
(66962, '3.10.20.90-FF-001024', NULL, 'Uncharacterized protein', 75, NULL, NULL, 66962),
(66963, '2.70.170.10-FF-000263', NULL, 'Acetylcholine receptor subunit delta', 151, NULL, NULL, 66963),
(66964, '2.40.50.140-FF-000457', NULL, 'Polyribonucleotide nucleotidyltransferase', 65, NULL, NULL, 66964),
(66965, '1.25.10.10-FF-003180', NULL, 'Uncharacterized protein', 318, NULL, NULL, 66965),
(66966, '1.20.120.1780-FF-000002', NULL, '1,4-dihydroxy-2-naphthoate octaprenyltransferase', 120, NULL, NULL, 66966),
(66967, '2.130.10.10-FF-005127', NULL, 'Uncharacterized protein', 218, NULL, NULL, 66967),
(66968, '3.30.60.30-FF-000159', NULL, 'Follistatin', 54, NULL, NULL, 66968),
(66969, '1.20.1560.10-FF-000183', NULL, 'Cytochrome biosyntheisis ABC transporter ATP-binding protein/permease CydD', 302, NULL, NULL, 66969),
(66970, '3.30.160.60-FF-002957', NULL, 'Zinc finger protein 625', 28, NULL, NULL, 66970),
(66971, '3.30.70.330-FF-000135', NULL, 'RNA-binding protein 39 isoform X2', 86, NULL, NULL, 66971),
(66972, '1.20.1070.10-FF-002152', NULL, 'Adhesion G protein-coupled receptor E1', 169, NULL, NULL, 66972),
(66973, '1.10.238.10-FF-000786', NULL, 'Mitochondrial substrate carrier family protein', 149, NULL, NULL, 66973),
(66974, '2.40.70.10-FF-000419', NULL, NULL, 171, NULL, NULL, 66974),
(66975, '2.30.29.30-FF-000173', NULL, 'Arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 1', 130, NULL, NULL, 66975),
(66976, '3.90.15.10-FF-000001', NULL, 'DNA topoisomerase I', 155, NULL, NULL, 66976),
(66977, '3.40.50.2000-FF-000084', NULL, 'Digalactosyldiacylglycerol synthase 2 chloroplastic', 152, NULL, NULL, 66977); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(66978, '1.10.150.20-FF-000293', NULL, 'DNA-directed RNA polymerase', 250, NULL, NULL, 66978),
(66979, '1.20.1250.20-FF-000230', NULL, 'Solute carrier family 45 member 3', 140, NULL, NULL, 66979),
(66980, '3.40.50.300-FF-005425', NULL, 'Chromosome 10, whole genome shotgun sequence', 182, NULL, NULL, 66980),
(66981, '1.20.5.1930-FF-000011', NULL, 'GAF sensor signal transduction histidine kinase', 64, NULL, NULL, 66981),
(66982, '2.60.120.200-FF-000107', NULL, 'Sex hormone-binding globulin', 176, NULL, NULL, 66982),
(66983, '2.40.70.10-FF-000375', NULL, NULL, 199, NULL, NULL, 66983),
(66984, '3.20.20.80-FF-000407', NULL, 'Beta-glucosidase 47', 61, NULL, NULL, 66984),
(66985, '1.20.1530.20-FF-000049', NULL, 'Na(+)/H(+) antiporter', 381, NULL, NULL, 66985),
(66986, '3.40.50.10810-FF-000157', NULL, 'Putative SNF2 family helicase', 251, NULL, NULL, 66986),
(66987, '3.50.50.60-FF-000453', NULL, 'Putative oxidoreductase TDA3', 63, NULL, NULL, 66987),
(66988, '1.10.1370.10-FF-000007', NULL, 'Mitochondrial intermediate peptidase, mitochondrial, putative', 349, NULL, NULL, 66988),
(66989, '3.40.50.410-FF-000214', NULL, 'ATP-dependent DNA helicase II subunit 1', 189, NULL, NULL, 66989),
(66990, '3.40.50.1820-FF-001777', NULL, 'Uncharacterized protein', 184, NULL, NULL, 66990),
(66991, '4.10.1000.10-FF-000141', NULL, 'tRNA-dihydrouridine(47) synthase [NAD(P)(+)]', 61, NULL, NULL, 66991),
(66992, '3.40.50.2000-FF-000128', NULL, 'Glycosyltransferase', 183, NULL, NULL, 66992),
(66993, '3.30.70.330-FF-002170', NULL, NULL, 86, NULL, NULL, 66993),
(66994, '1.20.940.10-FF-000022', NULL, 'Uncharacterized protein', 108, NULL, NULL, 66994),
(66995, '2.30.30.40-FF-000567', NULL, 'Rho GTPase-activating protein 10', 29, NULL, NULL, 66995),
(66996, '1.20.58.60-FF-000381', NULL, 'VAB-10B protein', 205, NULL, NULL, 66996),
(66997, '2.30.230.10-FF-000029', NULL, 'Vitellogenin', 262, NULL, NULL, 66997),
(66998, '1.20.200.10-FF-000040', NULL, 'Uncharacterized protein', 18, NULL, NULL, 66998),
(66999, '3.40.50.300-FF-004919', NULL, 'Ras-related protein RabT2', 201, NULL, NULL, 66999),
(67000, '3.40.50.2300-FF-000230', NULL, 'Unplaced genomic scaffold supercont1.240, whole genome shotgun sequence', 131, NULL, NULL, 67000),
(67001, '3.90.470.10-FF-000002', NULL, '50S ribosomal protein L22', 115, NULL, NULL, 67001),
(67002, '3.30.70.330-FF-000236', NULL, 'Polyadenylate-binding protein RBP45C', 94, NULL, NULL, 67002),
(67003, '3.90.1150.10-FF-000432', NULL, 'Sphingosine-1-phosphate lyase 1', 31, NULL, NULL, 67003),
(67004, '1.25.10.10-FF-002674', NULL, 'Uncharacterized protein', 85, NULL, NULL, 67004),
(67005, '1.20.58.1520-FF-000001', NULL, 'Protein regulator of cytokinesis 1', 129, NULL, NULL, 67005),
(67006, '1.10.8.100-FF-000023', NULL, 'Probable ribosomal RNA small subunit methyltransferase A', 71, NULL, NULL, 67006),
(67007, '1.10.1170.10-FF-000026', NULL, 'Baculoviral IAP repeat containing 6', 91, NULL, NULL, 67007),
(67008, '3.40.30.10-FF-000786', NULL, 'Sulfhydryl oxidase', 165, NULL, NULL, 67008),
(67009, '1.10.10.10-FF-001420', NULL, 'LysR family transcriptional regulator', 86, NULL, NULL, 67009),
(67010, '2.60.120.1560-FF-000003', NULL, 'Epa1p', 233, NULL, NULL, 67010),
(67011, '3.80.10.10-FF-003880', NULL, 'Uncharacterized protein', 165, NULL, NULL, 67011),
(67012, '2.60.220.50-FF-000040', NULL, 'Uncharacterized protein', 42, NULL, NULL, 67012),
(67013, '1.10.510.10-FF-003027', NULL, NULL, 224, NULL, NULL, 67013),
(67014, '1.20.1070.10-FF-000218', NULL, 'melanin-concentrating hormone receptor 2', 305, NULL, NULL, 67014),
(67015, '3.40.50.2300-FF-000746', NULL, 'Metabotropic glutamate receptor 3', 155, NULL, NULL, 67015),
(67016, '1.20.1250.20-FF-001747', NULL, 'Uncharacterized protein', 277, NULL, NULL, 67016),
(67017, '3.40.50.1110-FF-000024', NULL, 'GDSL esterase/lipase At1g31550', 341, NULL, NULL, 67017),
(67018, '3.80.10.10-FF-002452', NULL, 'Uncharacterized protein', 81, NULL, NULL, 67018),
(67019, '1.10.3110.10-FF-000017', NULL, 'Uncharacterized protein', 64, NULL, NULL, 67019),
(67020, '1.20.1070.10-FF-001646', NULL, 'Uncharacterized protein', 137, NULL, NULL, 67020);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(67021, '3.40.640.10-FF-000515', NULL, 'Serine hydroxymethyltransferase', 248, NULL, NULL, 67021),
(67022, '3.30.470.20-FF-000243', NULL, 'Uncharacterized protein', 54, NULL, NULL, 67022),
(67023, '1.20.1250.20-FF-000319', NULL, 'MFS transporter, putative', 461, NULL, NULL, 67023),
(67024, '3.60.140.10-FF-000006', NULL, 'YfiH family protein', 180, NULL, NULL, 67024),
(67025, '3.30.230.10-FF-000402', NULL, 'Uncharacterized protein', 199, NULL, NULL, 67025),
(67026, '3.40.50.300-FF-003200', NULL, 'DNA clamp loader, putative', 162, NULL, NULL, 67026),
(67027, '3.30.830.10-FF-000268', NULL, 'Uncharacterized protein', 246, NULL, NULL, 67027),
(67028, '3.40.50.10810-FF-000258', NULL, 'Excision repair cross-complementing rodent repair deficiency, complementation group 6', 46, NULL, NULL, 67028),
(67029, '2.60.40.60-FF-000499', NULL, 'Desmocollin 2-like', 103, NULL, NULL, 67029),
(67030, '3.40.30.10-FF-001067', NULL, 'Chromosome 8, whole genome shotgun sequence', 160, NULL, NULL, 67030),
(67031, '3.30.70.580-FF-000069', NULL, 'tRNA pseudouridine synthase', 147, NULL, NULL, 67031),
(67032, '3.90.180.10-FF-000182', NULL, 'Uncharacterized protein', 192, NULL, NULL, 67032),
(67033, '2.40.70.10-FF-000066', NULL, 'Napsin A aspartic peptidase', 162, NULL, NULL, 67033),
(67034, '1.10.3470.10-FF-000038', NULL, 'Ferrichrome transport system permease protein', 329, NULL, NULL, 67034),
(67035, '2.60.40.60-FF-001117', NULL, 'Uncharacterized protein', 117, NULL, NULL, 67035),
(67036, '3.90.1150.10-FF-000005', NULL, 'Serine hydroxymethyltransferase', 175, NULL, NULL, 67036),
(67037, '3.30.460.10-FF-000003', NULL, 'interleukin enhancer-binding factor 3 isoform X2', 170, NULL, NULL, 67037),
(67038, '3.40.190.10-FF-000407', NULL, 'ABC transporter substrate-binding protein', 96, NULL, NULL, 67038),
(67039, '3.90.820.10-FF-000001', NULL, 'MbtH family protein', 72, NULL, NULL, 67039),
(67040, '2.20.25.30-FF-000018', NULL, '60S ribosomal protein L37, putative', 49, NULL, NULL, 67040),
(67041, '2.60.40.10-FF-004762', NULL, NULL, 97, NULL, NULL, 67041),
(67042, '3.60.20.10-FF-000211', NULL, NULL, 178, NULL, NULL, 67042),
(67043, '3.40.190.10-FF-000295', NULL, 'PROBABLE SUGAR-BINDING LIPOPROTEIN LPQY', 60, NULL, NULL, 67043),
(67044, '2.130.10.10-FF-003093', NULL, 'Probable cytosolic iron-sulfur protein assembly protein CIAO1 homolog', 76, NULL, NULL, 67044),
(67045, '2.120.10.30-FF-000351', NULL, 'Uncharacterized protein', 174, NULL, NULL, 67045),
(67046, '3.40.50.150-FF-000569', NULL, 'Methyltransferase', 216, NULL, NULL, 67046),
(67047, '3.40.50.12670-FF-000012', NULL, 'Carboxypeptidase', 89, NULL, NULL, 67047),
(67048, '3.40.50.1820-FF-000260', NULL, 'Feruloyl esterase A', 260, NULL, NULL, 67048),
(67049, '1.20.5.520-FF-000006', NULL, 'thymosin beta-12', 39, NULL, NULL, 67049),
(67050, '3.30.460.20-FF-000006', NULL, 'Chromosome 1, whole genome shotgun sequence', 118, NULL, NULL, 67050),
(67051, '2.60.40.1150-FF-000009', NULL, 'AP complex subunit beta', 117, NULL, NULL, 67051),
(67052, '1.25.10.10-FF-000920', NULL, 'Condensin complex subunit 1', 185, NULL, NULL, 67052),
(67053, '3.30.160.60-FF-001013', NULL, 'Zinc finger and BTB domain-containing protein 16', 54, NULL, NULL, 67053),
(67054, '2.160.20.10-FF-000164', NULL, 'Pectin lyase domain protein', 226, NULL, NULL, 67054),
(67055, '1.25.40.180-FF-000030', NULL, 'Regulator of nonsense transcripts UPF2', 233, NULL, NULL, 67055),
(67056, '1.10.455.10-FF-000009', NULL, 'Ribosomal protein S7', 162, NULL, NULL, 67056),
(67057, '3.30.160.60-FF-006448', NULL, NULL, 73, NULL, NULL, 67057),
(67058, '1.20.1230.10-FF-000001', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 277, NULL, NULL, 67058),
(67059, '1.20.5.510-FF-000003', NULL, 'Ubiquinol-cytochrome c reductase iron-sulfur subunit', 40, NULL, NULL, 67059),
(67060, '2.30.30.30-FF-000137', NULL, 'Uncharacterized protein', 69, NULL, NULL, 67060),
(67061, '3.30.160.100-FF-000007', NULL, 'Ribosomal subunit interface protein', 99, NULL, NULL, 67061),
(67062, '3.60.20.10-FF-000110', NULL, 'Proteasome subunit beta type-6, putative', 205, NULL, NULL, 67062);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(67063, '4.10.520.10-FF-000021', NULL, 'Non-specific DNA-binding protein HU-1', 95, NULL, NULL, 67063),
(67064, '1.10.287.690-FF-000007', NULL, 'DNA-directed DNA polymerase', 104, NULL, NULL, 67064),
(67065, '3.40.50.620-FF-000406', NULL, 'Cytidylyltransferase, putative', 148, NULL, NULL, 67065),
(67066, '1.25.40.10-FF-003957', NULL, 'Uncharacterized protein', 256, NULL, NULL, 67066),
(67067, '3.30.160.60-FF-004666', NULL, NULL, 36, NULL, NULL, 67067),
(67068, '3.50.4.10-FF-000018', NULL, 'No-mechanoreceptor potential A short isoform', 101, NULL, NULL, 67068),
(67069, '2.60.40.10-FF-001108', NULL, 'palladin isoform X2', 101, NULL, NULL, 67069),
(67070, '3.30.160.60-FF-004239', NULL, NULL, 61, NULL, NULL, 67070),
(67071, '2.60.34.10-FF-000116', NULL, 'DnaK protein', 128, NULL, NULL, 67071),
(67072, '3.40.50.300-FF-008444', NULL, 'Uncharacterized protein', 72, NULL, NULL, 67072),
(67073, '3.40.50.300-FF-005307', NULL, 'Cobinamide kinase/cobinamide phosphate guanylyltransferase', 170, NULL, NULL, 67073),
(67074, '3.40.366.10-FF-000063', NULL, 'Probable polyketide synthase 37', 329, NULL, NULL, 67074),
(67075, '1.10.510.10-FF-002639', NULL, NULL, 38, NULL, NULL, 67075),
(67076, '3.40.50.10490-FF-000111', NULL, NULL, 182, NULL, NULL, 67076),
(67077, '1.20.1280.290-FF-000085', NULL, 'Uncharacterized membrane protein YOL092W homologue, putative', 90, NULL, NULL, 67077),
(67078, '2.60.120.260-FF-000226', NULL, 'Zgc:114081', 92, NULL, NULL, 67078),
(67079, '3.30.70.2570-FF-000004', NULL, NULL, 37, NULL, NULL, 67079),
(67080, '1.25.10.30-FF-000004', NULL, NULL, 115, NULL, NULL, 67080),
(67081, '1.25.40.10-FF-005025', NULL, 'Uncharacterized protein', 168, NULL, NULL, 67081),
(67082, '3.40.50.10350-FF-000002', NULL, 'Glycerate kinase', 130, NULL, NULL, 67082),
(67083, '3.30.70.3490-FF-000055', NULL, NULL, 69, NULL, NULL, 67083),
(67084, '1.20.1070.10-FF-001438', NULL, 'Uncharacterized protein', 223, NULL, NULL, 67084),
(67085, '1.20.142.10-FF-000027', NULL, 'Poly', 79, NULL, NULL, 67085),
(67086, '1.50.10.20-FF-000022', NULL, 'Terpene cyclase/mutase family member', 241, NULL, NULL, 67086),
(67087, '2.130.10.10-FF-004874', NULL, 'AGAP007423-PA', 120, NULL, NULL, 67087),
(67088, '1.10.510.10-FF-000487', NULL, 'Anti-Muellerian hormone type-2 receptor', 230, NULL, NULL, 67088),
(67089, '2.60.40.150-FF-000544', NULL, 'Toll-interacting protein A', 125, NULL, NULL, 67089),
(67090, '3.40.525.10-FF-000074', NULL, 'Phosphatidylinositol phosphatidylcholine transfer protein', 91, NULL, NULL, 67090),
(67091, '3.80.10.10-FF-001637', NULL, 'Uncharacterized protein', 206, NULL, NULL, 67091),
(67092, '3.60.120.10-FF-000005', NULL, 'isochorismate synthase, chloroplastic-like isoform X1', 477, NULL, NULL, 67092),
(67093, '1.10.238.10-FF-000477', NULL, 'Myosin 1 light chain cam2', 68, NULL, NULL, 67093),
(67094, '1.10.150.240-FF-000082', NULL, 'HAD-superfamily hydrolase, subfamily IA, variant 3 containing protein', 65, NULL, NULL, 67094),
(67095, '3.90.730.10-FF-000039', NULL, 'Uncharacterized protein', 84, NULL, NULL, 67095),
(67096, '3.30.60.20-FF-000156', NULL, 'Probable Rho-type GTPase-activating protein 3', 56, NULL, NULL, 67096),
(67097, '1.10.8.710-FF-000009', NULL, 'Dynein heavy chain-like protein', 138, NULL, NULL, 67097),
(67098, '3.90.190.20-FF-000056', NULL, 'Dihydrofolate synthetase', 145, NULL, NULL, 67098),
(67099, '1.25.40.20-FF-000296', NULL, 'Ankyrin repeat and fibronectin type III domain containing 1', 156, NULL, NULL, 67099),
(67100, '1.10.150.20-FF-000304', NULL, 'NADH:ubiquinone oxidoreductase 41 kD complex I subunit', 65, NULL, NULL, 67100),
(67101, '3.30.230.10-FF-000166', NULL, 'Ribosome assembly protein 1', 162, NULL, NULL, 67101),
(67102, '2.40.70.10-FF-000167', NULL, 'Uncharacterized protein', 156, NULL, NULL, 67102),
(67103, '2.30.42.10-FF-000248', NULL, 'Protease Do-like 7', 99, NULL, NULL, 67103),
(67104, '3.30.160.60-FF-003154', NULL, 'Histone-lysine N-methyltransferase PRDM9-like Protein', 28, NULL, NULL, 67104),
(67105, '1.25.40.240-FF-000008', NULL, NULL, 152, NULL, NULL, 67105),
(67106, '2.40.30.10-FF-000299', NULL, 'GTP-binding elongation factor', 108, NULL, NULL, 67106);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(67107, '2.60.40.10-FF-003126', NULL, 'Tyrosine-protein phosphatase 4', 114, NULL, NULL, 67107),
(67108, '3.40.50.720-FF-001729', NULL, 'Homoserine dehydrogenase', 154, NULL, NULL, 67108),
(67109, '3.30.70.1150-FF-000005', NULL, 'Acetolactate synthase 3 regulatory subunit', 81, NULL, NULL, 67109),
(67110, '2.40.50.140-FF-000339', NULL, 'mRNA-capping enzyme isoform A', 73, NULL, NULL, 67110),
(67111, '3.40.50.2000-FF-000538', NULL, 'Probable UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SPINDLY', 174, NULL, NULL, 67111),
(67112, '2.170.150.10-FF-000030', NULL, 'Uncharacterized protein', 181, NULL, NULL, 67112),
(67113, '3.40.50.300-FF-001373', NULL, 'Helicase with zinc finger domain 2', 263, NULL, NULL, 67113),
(67114, '2.60.40.10-FF-000855', NULL, 'Interleukin-6 receptor subunit beta', 88, NULL, NULL, 67114),
(67115, '3.20.20.100-FF-000210', NULL, 'Bifunctional protein STORR', 315, NULL, NULL, 67115),
(67116, '3.80.10.10-FF-000103', NULL, 'Immunoglobulin superfamily member 10', 159, NULL, NULL, 67116),
(67117, '3.40.47.10-FF-000296', NULL, NULL, 92, NULL, NULL, 67117),
(67118, '1.20.1070.10-FF-001747', NULL, 'Uncharacterized protein', 80, NULL, NULL, 67118),
(67119, '1.10.1760.20-FF-000001', NULL, 'Cobalt transport protein CbiM', 210, NULL, NULL, 67119),
(67120, '1.20.58.810-FF-000003', NULL, 'Uncharacterized protein', 110, NULL, NULL, 67120),
(67121, '2.40.50.810-FF-000001', NULL, 'Single-stranded TG1-3 telomere G-tails binding protein', 152, NULL, NULL, 67121),
(67122, '3.80.10.10-FF-002244', NULL, 'Predicted protein', 230, NULL, NULL, 67122),
(67123, '3.40.50.300-FF-001255', NULL, 'DNA polymerase III subunit delta', 163, NULL, NULL, 67123),
(67124, '1.25.40.10-FF-000293', NULL, 'Clustered mitochondria protein homolog', 118, NULL, NULL, 67124),
(67125, '1.25.10.10-FF-002573', NULL, 'Uncharacterized protein', 164, NULL, NULL, 67125),
(67126, '3.30.40.10-FF-001990', NULL, 'Uncharacterized protein', 55, NULL, NULL, 67126),
(67127, '1.20.1250.20-FF-002028', NULL, 'Uncharacterized protein', 350, NULL, NULL, 67127),
(67128, '3.40.50.2000-FF-000229', NULL, 'Trehalose-phosphatase, putative', 282, NULL, NULL, 67128),
(67129, '2.60.40.10-FF-002199', NULL, 'Scs2p', 126, NULL, NULL, 67129),
(67130, '3.80.10.10-FF-000092', NULL, 'keratocan isoform X1', 143, NULL, NULL, 67130),
(67131, '2.40.50.140-FF-000250', NULL, 'Elongation factor Ts, mitochondrial', 85, NULL, NULL, 67131),
(67132, '2.60.220.50-FF-000141', NULL, 'Uncharacterized protein', 151, NULL, NULL, 67132),
(67133, '1.10.357.140-FF-000016', NULL, '1,4-dihydroxy-2-naphthoate octaprenyltransferase', 148, NULL, NULL, 67133),
(67134, '3.40.50.10050-FF-000002', NULL, 'Eukaryotic translation initiation factor 5B', 105, NULL, NULL, 67134),
(67135, '2.60.40.150-FF-000662', NULL, 'Uncharacterized protein', 91, NULL, NULL, 67135),
(67136, '2.60.40.60-FF-000819', NULL, 'Uncharacterized protein', 116, NULL, NULL, 67136),
(67137, '1.20.1250.20-FF-002220', NULL, 'Uncharacterized protein', 133, NULL, NULL, 67137),
(67138, '3.40.50.300-FF-006752', NULL, 'Uncharacterized protein', 66, NULL, NULL, 67138),
(67139, '1.10.10.60-FF-000822', NULL, 'MIS18-binding protein 1', 76, NULL, NULL, 67139),
(67140, '1.10.600.10-FF-000140', NULL, 'Uncharacterized protein', 356, NULL, NULL, 67140),
(67141, '1.25.10.10-FF-000465', NULL, 'Putative exportin-1', 1074, NULL, NULL, 67141),
(67142, '1.20.1510.10-FF-000028', NULL, 'Zrc1p', 199, NULL, NULL, 67142),
(67143, '2.170.130.10-FF-000028', NULL, 'TonB-dependent siderophore receptor', 129, NULL, NULL, 67143),
(67144, '3.10.50.10-FF-000018', NULL, 'Chitodextrinase', 62, NULL, NULL, 67144),
(67145, '3.30.420.40-FF-000763', NULL, 'Transcriptional regulator', 135, NULL, NULL, 67145),
(67146, '3.40.50.1980-FF-000049', NULL, 'Manganese ABC transporter substrate-binding lipoprotein', 152, NULL, NULL, 67146),
(67147, '1.25.40.180-FF-000029', NULL, 'Nuclear cap-binding protein', 186, NULL, NULL, 67147),
(67148, '3.10.129.10-FF-000154', NULL, 'PaaI family thioesterase', 139, NULL, NULL, 67148),
(67149, '3.20.180.20-FF-000015', NULL, 'Dynein heavy chain', 77, NULL, NULL, 67149);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(67150, '3.40.309.10-FF-000004', NULL, 'Succinate-semialdehyde dehydrogenase I', 190, NULL, NULL, 67150),
(67151, '1.25.40.10-FF-002872', NULL, 'YALI0B10362p', 397, NULL, NULL, 67151),
(67152, '3.90.199.10-FF-000011', NULL, 'DNA topoisomerase 2', 88, NULL, NULL, 67152),
(67153, '1.25.10.10-FF-002365', NULL, 'Hsp70 nucleotide exchange factor FES1', 278, NULL, NULL, 67153),
(67154, '3.30.56.10-FF-000014', NULL, 'Phenylalanine--tRNA ligase beta subunit', 72, NULL, NULL, 67154),
(67155, '1.25.40.10-FF-004772', NULL, 'Uncharacterized protein', 201, NULL, NULL, 67155),
(67156, '1.10.3720.10-FF-000165', NULL, 'Glycine betaine/proline ABC transporter, permease protein', 196, NULL, NULL, 67156),
(67157, '3.90.70.10-FF-000488', NULL, 'At5g05930', 169, NULL, NULL, 67157),
(67158, '2.30.29.30-FF-000482', NULL, 'mRNA-decapping enzyme subunit 1', 171, NULL, NULL, 67158),
(67159, '3.60.40.10-FF-000010', NULL, 'Probable protein phosphatase 2C 39', 257, NULL, NULL, 67159),
(67160, '1.10.3430.10-FF-000064', NULL, 'Uncharacterized protein', 89, NULL, NULL, 67160),
(67161, '1.20.1090.10-FF-000012', NULL, '3-dehydroquinate synthase', 183, NULL, NULL, 67161),
(67162, '1.20.1440.170-FF-000013', NULL, NULL, 115, NULL, NULL, 67162),
(67163, '3.40.50.1970-FF-000046', NULL, '3-dehydroquinate synthase', 160, NULL, NULL, 67163),
(67164, '2.60.40.150-FF-000398', NULL, 'Unc-13, isoform F', 84, NULL, NULL, 67164),
(67165, '2.120.10.10-FF-000002', NULL, 'Neuraminidase 3', 381, NULL, NULL, 67165),
(67166, '3.40.50.2000-FF-000022', NULL, 'ADP-heptose--LPS heptosyltransferase II', 149, NULL, NULL, 67166),
(67167, '3.30.420.40-FF-001027', NULL, 'Uncharacterized protein', 37, NULL, NULL, 67167),
(67168, '3.80.10.10-FF-002143', NULL, 'Outer arm dynein light chain 1 protein', 113, NULL, NULL, 67168),
(67169, '1.25.40.1040-FF-000060', NULL, 'Uncharacterized protein', 151, NULL, NULL, 67169),
(67170, '3.30.70.1400-FF-000024', NULL, 'Uncharacterized protein', 57, NULL, NULL, 67170),
(67171, '1.20.58.900-FF-000030', NULL, 'Zinc finger protein', 169, NULL, NULL, 67171),
(67172, '1.20.225.30-FF-000001', NULL, 'tRNA-dihydrouridine(16) synthase', 73, NULL, NULL, 67172),
(67173, '2.40.50.40-FF-000051', NULL, 'Histone-lysine N-methyltransferase', 79, NULL, NULL, 67173),
(67174, '3.40.50.300-FF-008298', NULL, 'Uncharacterized protein', 16, NULL, NULL, 67174),
(67175, '3.30.420.390-FF-000002', NULL, 'DNA polymerase gamma, catalytic subunit', 206, NULL, NULL, 67175),
(67176, '3.30.900.10-FF-000021', NULL, 'Rev7, putative', 200, NULL, NULL, 67176),
(67177, '1.10.10.10-FF-001111', NULL, 'Transcriptional regulator', 107, NULL, NULL, 67177),
(67178, '3.20.20.330-FF-000003', NULL, 'Betaine--homocysteine S-methyltransferase 1', 369, NULL, NULL, 67178),
(67179, '1.10.472.10-FF-000167', NULL, 'Mitotic cyclin 6', 101, NULL, NULL, 67179),
(67180, '3.40.47.10-FF-000190', NULL, '3-hydroxy-3-methylglutaryl coenzyme A synthase', 447, NULL, NULL, 67180),
(67181, '2.10.25.10-FF-001637', NULL, 'Integrin beta', 48, NULL, NULL, 67181),
(67182, '3.60.15.10-FF-000244', NULL, 'Predicted protein', 69, NULL, NULL, 67182),
(67183, '1.10.510.10-FF-003145', NULL, NULL, 180, NULL, NULL, 67183),
(67184, '3.30.1680.10-FF-000008', NULL, 'semaphorin-3B isoform X1', 65, NULL, NULL, 67184),
(67185, '2.60.40.1510-FF-000062', NULL, 'Integrin beta', 142, NULL, NULL, 67185),
(67186, '3.30.70.330-FF-001051', NULL, 'Ribonucleoprotein 1', 109, NULL, NULL, 67186),
(67187, '2.30.29.30-FF-000381', NULL, 'FERM domain-containing protein', 97, NULL, NULL, 67187),
(67188, '3.40.50.300-FF-004498', NULL, 'Cobalt ABC transporter ATP-binding protein', 228, NULL, NULL, 67188),
(67189, '3.20.20.80-FF-000200', NULL, 'Alpha-amylase', 190, NULL, NULL, 67189),
(67190, '3.70.10.10-FF-000098', NULL, 'Beta sliding clamp', 188, NULL, NULL, 67190),
(67191, '3.40.50.300-FF-007016', NULL, 'DNA repair protein rlp1', 207, NULL, NULL, 67191),
(67192, '3.40.50.620-FF-000614', NULL, 'Glutamate--tRNA ligase', 318, NULL, NULL, 67192),
(67193, '1.20.58.390-FF-000276', NULL, 'SD09326p', 64, NULL, NULL, 67193),
(67194, '3.20.20.150-FF-000073', NULL, 'Uncharacterized protein', 102, NULL, NULL, 67194);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(67195, '3.40.190.10-FF-000306', NULL, 'Probable molybdate-binding lipoprotein modA', 103, NULL, NULL, 67195),
(67196, '3.30.420.40-FF-000864', NULL, 'Actin related protein 10 homolog', 99, NULL, NULL, 67196),
(67197, '3.10.20.90-FF-000198', NULL, 'Ubiquilin 3', 91, NULL, NULL, 67197),
(67198, '3.40.50.300-FF-004599', NULL, 'Uncharacterized protein', 144, NULL, NULL, 67198),
(67199, '3.30.70.120-FF-000044', NULL, NULL, 71, NULL, NULL, 67199),
(67200, '1.20.1250.20-FF-000112', NULL, 'glucose-6-phosphate exchanger SLC37A4 isoform X1', 213, NULL, NULL, 67200),
(67201, '3.90.70.10-FF-000590', NULL, 'Uncharacterized protein', 220, NULL, NULL, 67201),
(67202, '1.20.1070.10-FF-000112', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 2', 271, NULL, NULL, 67202),
(67203, '1.10.10.60-FF-000159', NULL, 'Homeobox-leucine zipper protein HAT5', 65, NULL, NULL, 67203),
(67204, '3.40.47.10-FF-000088', NULL, 'Putative chalcone synthase', 220, NULL, NULL, 67204),
(67205, '3.40.50.300-FF-003273', NULL, 'Probable LSG1-Large-Subunit GTPase involved in 60S ribosomal subunit biogenesis', 166, NULL, NULL, 67205),
(67206, '1.20.1420.30-FF-000050', NULL, 'Hypothetical_protein_-_conserved', 229, NULL, NULL, 67206),
(67207, '3.40.140.10-FF-000258', NULL, 'Uncharacterized protein', 123, NULL, NULL, 67207),
(67208, '2.130.10.10-FF-003020', NULL, 'Uncharacterized protein', 329, NULL, NULL, 67208),
(67209, '3.40.50.12780-FF-000163', NULL, 'Nonribosomal peptide synthase nlsA', 405, NULL, NULL, 67209),
(67210, '3.30.565.10-FF-000264', NULL, 'Sensory histidine protein kinase', 185, NULL, NULL, 67210),
(67211, '3.80.10.10-FF-003329', NULL, 'Predicted protein', 125, NULL, NULL, 67211),
(67212, '3.30.160.60-FF-002648', NULL, 'C2H2 finger domain protein, putative (AFU_orthologue AFUA_4G11480)', 28, NULL, NULL, 67212),
(67213, '2.10.25.10-FF-001547', NULL, 'Adhesion G protein-coupled receptor E5a', 49, NULL, NULL, 67213),
(67214, '3.30.160.60-FF-004548', NULL, NULL, 20, NULL, NULL, 67214),
(67215, '1.10.1300.10-FF-000043', NULL, 'Uncharacterized protein', 340, NULL, NULL, 67215),
(67216, '3.10.450.40-FF-000016', NULL, 'Predicted protein', 99, NULL, NULL, 67216),
(67217, '1.10.238.10-FF-000269', NULL, 'Defective in cullin neddylation protein', 90, NULL, NULL, 67217),
(67218, '3.30.230.10-FF-000150', NULL, 'DNA repair protein RadA', 162, NULL, NULL, 67218),
(67219, '3.30.450.150-FF-000009', NULL, 'Slr1406 protein', 151, NULL, NULL, 67219),
(67220, '1.20.1310.10-FF-000165', NULL, NULL, 108, NULL, NULL, 67220),
(67221, '2.30.30.40-FF-000258', NULL, 'Chemotaxis protein CheW', 58, NULL, NULL, 67221),
(67222, '3.30.720.200-FF-000002', NULL, 'Isoleucine--tRNA ligase', 62, NULL, NULL, 67222),
(67223, '3.40.50.2000-FF-000437', NULL, 'Alpha-1,3/1,6-mannosyltransferase alg2', 205, NULL, NULL, 67223),
(67224, '1.20.1070.10-FF-001955', NULL, 'Uncharacterized protein', 204, NULL, NULL, 67224),
(67225, '3.90.79.10-FF-000137', NULL, 'Translation initiation factor eIF-2B subunit family protein', 219, NULL, NULL, 67225),
(67226, '3.40.50.300-FF-002699', NULL, 'ATP-binding cassette protein putative', 290, NULL, NULL, 67226),
(67227, '3.40.50.300-FF-006853', NULL, 'Uncharacterized protein', 335, NULL, NULL, 67227),
(67228, '3.30.720.210-FF-000005', NULL, 'ATP-dependent zinc metalloprotease FtsH', 84, NULL, NULL, 67228),
(67229, '3.90.1150.10-FF-000314', NULL, 'Serine hydroxymethyltransferase', 176, NULL, NULL, 67229),
(67230, '3.40.390.10-FF-000170', NULL, NULL, 226, NULL, NULL, 67230),
(67231, '6.10.250.3370-FF-000002', NULL, 'Siderophore staphylobactin biosynthesis protein SbnE', 39, NULL, NULL, 67231),
(67232, '3.30.559.70-FF-000054', NULL, 'Carnitine O-palmitoyltransferase, putative', 139, NULL, NULL, 67232),
(67233, '3.30.160.60-FF-001114', NULL, 'Zinc finger protein SNAI2', 90, NULL, NULL, 67233),
(67234, '3.30.70.370-FF-000023', NULL, NULL, 100, NULL, NULL, 67234),
(67235, '3.50.50.60-FF-000144', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 31, NULL, NULL, 67235),
(67236, '3.10.450.50-FF-000019', NULL, 'Nuclear transport factor 2 (NTF2), putative', 159, NULL, NULL, 67236);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(67237, '3.80.10.10-FF-001429', NULL, 'Probable disease resistance protein At1g61190', 187, NULL, NULL, 67237),
(67238, '1.10.10.10-FF-000493', NULL, 'HMG-Y-related protein A', 83, NULL, NULL, 67238),
(67239, '1.10.630.10-FF-000074', NULL, '25-hydroxycholesterol 7-alpha-hydroxylase', 474, NULL, NULL, 67239),
(67240, '3.40.50.1820-FF-000142', NULL, 'Enterobactin synthetase component F', 328, NULL, NULL, 67240),
(67241, '2.130.10.10-FF-001075', NULL, 'Uncharacterized protein', 426, NULL, NULL, 67241),
(67242, '3.40.50.720-FF-002134', NULL, 'Hydroxy-delta-5-steroid dehydrogenase, 3 beta- and steroid delta-isomerase 7', 102, NULL, NULL, 67242),
(67243, '3.30.70.270-FF-000291', NULL, NULL, 71, NULL, NULL, 67243),
(67244, '3.40.50.300-FF-005116', NULL, 'DNA repair protein RAD51 homolog 3-like isoform X1', 256, NULL, NULL, 67244),
(67245, '1.25.40.10-FF-000259', NULL, 'Protein SGT1 homolog', 134, NULL, NULL, 67245),
(67246, '3.40.50.300-FF-006398', NULL, 'Uncharacterized protein', 133, NULL, NULL, 67246),
(67247, '3.30.200.20-FF-001769', NULL, 'Serine/threonine protein kinase, putative', 95, NULL, NULL, 67247),
(67248, '3.30.70.360-FF-000020', NULL, 'Peptidase, M20/M25/M40 family', 115, NULL, NULL, 67248),
(67249, '1.20.1250.20-FF-002012', NULL, 'Transporter belonging to the MFS superfamily', 371, NULL, NULL, 67249),
(67250, '1.10.10.60-FF-001064', NULL, NULL, 64, NULL, NULL, 67250),
(67251, '3.40.718.10-FF-000033', NULL, 'Isocitrate dehydrogenase [NADP]', 389, NULL, NULL, 67251),
(67252, '3.40.50.12280-FF-000002', NULL, 'NADH-quinone oxidoreductase subunit B', 165, NULL, NULL, 67252),
(67253, '3.40.50.1820-FF-001586', NULL, 'Uncharacterized protein', 91, NULL, NULL, 67253),
(67254, '3.10.20.30-FF-000096', NULL, NULL, 81, NULL, NULL, 67254),
(67255, '3.40.710.10-FF-000122', NULL, 'Serine-type D-Ala-D-Ala carboxypeptidase', 272, NULL, NULL, 67255),
(67256, '3.90.550.50-FF-000228', NULL, 'Uncharacterized protein', 121, NULL, NULL, 67256),
(67257, '1.20.1250.20-FF-000421', NULL, 'Inorganic phosphate transporter', 246, NULL, NULL, 67257),
(67258, '3.30.465.10-FF-000054', NULL, 'FAD linked oxidase, C-terminal domain protein', 201, NULL, NULL, 67258),
(67259, '1.20.58.60-FF-000038', NULL, 'Short stop, isoform N', 111, NULL, NULL, 67259),
(67260, '2.60.120.200-FF-000006', NULL, 'receptor-type tyrosine-protein phosphatase T isoform X1', 161, NULL, NULL, 67260),
(67261, '1.10.510.10-FF-001700', NULL, 'Tyrosine-protein kinase', 205, NULL, NULL, 67261),
(67262, '3.80.10.10-FF-001738', NULL, 'F-box protein YLR352W', 314, NULL, NULL, 67262),
(67263, '1.20.90.10-FF-000036', NULL, NULL, 86, NULL, NULL, 67263),
(67264, '2.60.120.260-FF-000327', NULL, 'EPH receptor B4', 86, NULL, NULL, 67264),
(67265, '3.40.50.300-FF-007106', NULL, 'Predicted protein', 187, NULL, NULL, 67265),
(67266, '3.30.760.10-FF-000032', NULL, 'Chromosome 7, whole genome shotgun sequence', 210, NULL, NULL, 67266),
(67267, '1.10.150.240-FF-000098', NULL, 'Phosphoglycolate phosphatase', 68, NULL, NULL, 67267),
(67268, '3.40.1110.10-FF-000042', NULL, 'Phospholipid-transporting ATPase', 159, NULL, NULL, 67268),
(67269, '1.20.1070.10-FF-000319', NULL, 'Drm corazonin receptor', 318, NULL, NULL, 67269),
(67270, '3.40.50.620-FF-000305', NULL, 'Isoleucine--tRNA ligase', 203, NULL, NULL, 67270),
(67271, '1.10.510.10-FF-002982', NULL, NULL, 68, NULL, NULL, 67271),
(67272, '3.30.40.10-FF-002153', NULL, 'Structure-specific endonuclease subunit SLX1', 92, NULL, NULL, 67272),
(67273, '1.10.150.60-FF-000046', NULL, NULL, 64, NULL, NULL, 67273),
(67274, '3.10.580.10-FF-000011', NULL, 'TerC family inner membrane protein', 152, NULL, NULL, 67274),
(67275, '1.25.40.10-FF-002092', NULL, 'Pentatricopeptide repeat-containing protein', 114, NULL, NULL, 67275),
(67276, '3.40.50.2300-FF-000084', NULL, 'Lysine decarboxylase, inducible', 129, NULL, NULL, 67276),
(67277, '1.25.10.10-FF-002926', NULL, 'Protein HEATR9', 100, NULL, NULL, 67277),
(67278, '2.70.150.10-FF-000155', NULL, 'Proton motive ATPase, putative', 85, NULL, NULL, 67278),
(67279, '1.25.40.10-FF-004862', NULL, 'Vacuolar protein sorting-associated protein 41 homolog', 177, NULL, NULL, 67279);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(67280, '3.30.1370.10-FF-000108', NULL, 'DEAD box polypeptide 43 (Predicted)', 64, NULL, NULL, 67280),
(67281, '3.30.160.60-FF-000496', NULL, 'Zinc finger with KRAB and SCAN domains 1', 27, NULL, NULL, 67281),
(67282, '3.90.70.80-FF-000082', NULL, 'Uncharacterized protein', 110, NULL, NULL, 67282),
(67283, '3.30.40.10-FF-000253', NULL, 'E3 ubiquitin-protein ligase RNF126', 75, NULL, NULL, 67283),
(67284, '3.10.20.90-FF-000759', NULL, 'Ubiquitin-associated /TS-N domain-containing protein', 89, NULL, NULL, 67284),
(67285, '3.40.50.300-FF-004953', NULL, 'Uncharacterized protein', 120, NULL, NULL, 67285),
(67286, '1.20.1250.20-FF-001865', NULL, 'Predicted protein', 115, NULL, NULL, 67286),
(67287, '2.60.120.260-FF-000636', NULL, 'Putative Pol polyprotein from transposon element Bs1', 109, NULL, NULL, 67287),
(67288, '3.30.1120.30-FF-000034', NULL, 'Serine/threonine-protein kinase PLK', 94, NULL, NULL, 67288),
(67289, '1.25.40.10-FF-004199', NULL, 'Alpha-soluble NSF attachment protein 1', 72, NULL, NULL, 67289),
(67290, '2.130.10.10-FF-004773', NULL, 'Uncharacterized protein', 154, NULL, NULL, 67290),
(67291, '3.30.450.20-FF-000034', NULL, 'Phytochrome', 109, NULL, NULL, 67291),
(67292, '1.10.300.10-FF-000010', NULL, 'Adenylosuccinate synthetase', 110, NULL, NULL, 67292),
(67293, '1.10.472.10-FF-000622', NULL, 'Uncharacterized protein', 128, NULL, NULL, 67293),
(67294, '2.60.40.420-FF-000046', NULL, 'Multicopper oxidase', 199, NULL, NULL, 67294),
(67295, '1.20.58.1120-FF-000004', NULL, 'Dynein axonemal heavy chain 5', 142, NULL, NULL, 67295),
(67296, '3.10.120.10-FF-000056', NULL, 'Predicted protein', 55, NULL, NULL, 67296),
(67297, '1.20.970.30-FF-000002', NULL, 'Translation initiation factor eIF4G', 69, NULL, NULL, 67297),
(67298, '1.25.70.10-FF-000087', NULL, NULL, 142, NULL, NULL, 67298),
(67299, '1.10.238.10-FF-000932', NULL, 'EF hand family protein', 162, NULL, NULL, 67299),
(67300, '2.120.10.30-FF-000457', NULL, 'Uncharacterized protein', 90, NULL, NULL, 67300),
(67301, '3.30.450.30-FF-000037', NULL, 'Roadblock/LC7 family protein', 131, NULL, NULL, 67301),
(67302, '3.90.1600.10-FF-000068', NULL, 'DNA polymerase delta subunit 1', 66, NULL, NULL, 67302),
(67303, '1.10.238.10-FF-000578', NULL, 'p25-alpha_-_putative', 83, NULL, NULL, 67303),
(67304, '3.30.160.60-FF-000967', NULL, 'zinc finger protein 436 isoform X1', 26, NULL, NULL, 67304),
(67305, '3.30.230.70-FF-000061', NULL, 'Exosome complex component rrp42', 286, NULL, NULL, 67305),
(67306, '2.10.110.10-FF-000312', NULL, 'Uncharacterized protein', 73, NULL, NULL, 67306),
(67307, '2.10.109.10-FF-000027', NULL, 'Signal peptidase I', 148, NULL, NULL, 67307),
(67308, '3.40.50.1820-FF-000703', NULL, 'Hydrolase', 337, NULL, NULL, 67308),
(67309, '2.60.40.10-FF-002963', NULL, 'Uncharacterized protein', 97, NULL, NULL, 67309),
(67310, '1.10.400.10-FF-000074', NULL, 'Guanine nucleotide binding protein, alpha activating activity polypeptide O', 119, NULL, NULL, 67310),
(67311, '2.70.98.90-FF-000011', NULL, 'Membrane protein insertase YidC', 237, NULL, NULL, 67311),
(67312, '3.30.70.330-FF-002276', NULL, NULL, 79, NULL, NULL, 67312),
(67313, '3.30.40.10-FF-000562', NULL, 'RING-type E3 ubiquitin transferase', 75, NULL, NULL, 67313),
(67314, '2.60.120.200-FF-000315', NULL, 'Anaplastic lymphoma kinase, isoform A', 188, NULL, NULL, 67314),
(67315, '2.60.120.650-FF-000118', NULL, 'Uncharacterized protein', 216, NULL, NULL, 67315),
(67316, '3.30.50.10-FF-000181', NULL, 'Uncharacterized protein', 57, NULL, NULL, 67316),
(67317, '3.40.1280.10-FF-000054', NULL, 'rRNA methylase, putative', 173, NULL, NULL, 67317),
(67318, '2.60.40.150-FF-000089', NULL, 'otoferlin isoform X1', 120, NULL, NULL, 67318),
(67319, '3.30.110.110-FF-000017', NULL, 'Uncharacterized protein', 104, NULL, NULL, 67319),
(67320, '1.25.40.20-FF-001122', NULL, 'UPF0507 protein C2_02840C_A', 196, NULL, NULL, 67320),
(67321, '3.40.50.1820-FF-000613', NULL, 'N-myc downstream-regulated gene 1b', 290, NULL, NULL, 67321),
(67322, '3.10.20.90-FF-000861', NULL, 'Uncharacterized protein', 75, NULL, NULL, 67322);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(67323, '2.60.40.60-FF-001016', NULL, 'Uncharacterized protein', 46, NULL, NULL, 67323),
(67324, '4.10.260.20-FF-000003', NULL, 'Uncharacterized protein', 66, NULL, NULL, 67324),
(67325, '1.10.246.10-FF-000018', NULL, 'Serum albumin', 77, NULL, NULL, 67325),
(67326, '2.10.25.10-FF-000103', NULL, 'Fibrillin 2', 69, NULL, NULL, 67326),
(67327, '3.80.10.10-FF-004043', NULL, 'Uncharacterized protein', 141, NULL, NULL, 67327),
(67328, '1.10.10.60-FF-000249', NULL, 'H2.0-like homeobox protein', 81, NULL, NULL, 67328),
(67329, '3.30.1520.10-FF-000025', NULL, 'Sorting nexin 20', 133, NULL, NULL, 67329),
(67330, '1.25.40.20-FF-001329', NULL, 'Uncharacterized protein', 129, NULL, NULL, 67330),
(67331, '1.10.2020.20-FF-000007', NULL, '26S proteasome regulatory subunit RPN13,putative', 113, NULL, NULL, 67331),
(67332, '3.90.660.10-FF-000112', NULL, NULL, 259, NULL, NULL, 67332),
(67333, '1.10.530.10-FF-000078', NULL, 'Uncharacterized protein', 79, NULL, NULL, 67333),
(67334, '2.40.10.10-FF-000399', NULL, NULL, 114, NULL, NULL, 67334),
(67335, '3.40.50.620-FF-000053', NULL, 'Probable tRNA sulfurtransferase', 225, NULL, NULL, 67335),
(67336, '3.10.110.10-FF-000128', NULL, 'YLR419Wp putative helicase', 119, NULL, NULL, 67336),
(67337, '3.10.20.230-FF-000026', NULL, 'Protein doublecortin', 95, NULL, NULL, 67337),
(67338, '3.20.20.100-FF-000064', NULL, 'Aldo-keto reductase 1a', 306, NULL, NULL, 67338),
(67339, '3.90.640.60-FF-000002', NULL, 'Actin-like protein ARP9', 112, NULL, NULL, 67339),
(67340, '2.60.40.10-FF-004806', NULL, NULL, 116, NULL, NULL, 67340),
(67341, '1.20.1070.10-FF-002017', NULL, 'Uncharacterized protein', 133, NULL, NULL, 67341),
(67342, '2.10.25.10-FF-001328', NULL, 'Protein eyes shut homolog', 38, NULL, NULL, 67342),
(67343, '3.80.10.10-FF-000119', NULL, 'Leucine-rich repeat-containing 14 isoform b', 256, NULL, NULL, 67343),
(67344, '3.40.640.10-FF-000280', NULL, 'Acetylornithine aminotransferase, mitochondrial', 227, NULL, NULL, 67344),
(67345, '2.40.160.110-FF-000048', NULL, 'Uncharacterized protein', 119, NULL, NULL, 67345),
(67346, '3.40.50.12230-FF-000004', NULL, 'Methionyl-tRNA formyltransferase family protein, putative', 344, NULL, NULL, 67346),
(67347, '2.130.10.10-FF-004329', NULL, 'LLGL1, scribble cell polarity complex component', 102, NULL, NULL, 67347),
(67348, '3.40.50.300-FF-004728', NULL, 'Uncharacterized protein', 60, NULL, NULL, 67348),
(67349, '2.130.10.10-FF-002733', NULL, 'DDB1- and CUL4-associated factor 7 homolog', 294, NULL, NULL, 67349),
(67350, '3.40.50.150-FF-001631', NULL, NULL, 238, NULL, NULL, 67350),
(67351, '2.40.30.170-FF-000018', NULL, 'Hemolysin D', 69, NULL, NULL, 67351),
(67352, '1.25.10.10-FF-000347', NULL, 'EFR3 homolog A (S. cerevisiae)', 280, NULL, NULL, 67352),
(67353, '3.30.70.260-FF-000170', NULL, 'Uncharacterized protein', 92, NULL, NULL, 67353),
(67354, '3.40.50.300-FF-005190', NULL, 'Female sterile (1) Yb', 214, NULL, NULL, 67354),
(67355, '1.25.10.10-FF-000875', NULL, 'Protein CELLULOSE SYNTHASE INTERACTIVE 1', 235, NULL, NULL, 67355),
(67356, '2.40.30.30-FF-000030', NULL, 'Riboflavin kinase', 180, NULL, NULL, 67356),
(67357, '3.40.50.12240-FF-000007', NULL, 'V-type proton ATPase subunit B, brain isoform', 154, NULL, NULL, 67357),
(67358, '1.20.58.60-FF-000302', NULL, 'Spectrin beta, non-erythrocytic 5', 102, NULL, NULL, 67358),
(67359, '3.10.110.10-FF-000229', NULL, 'Ubiquitin-conjugating enzyme E2 Q2', 169, NULL, NULL, 67359),
(67360, '3.30.565.10-FF-000483', NULL, 'Uncharacterized protein', 70, NULL, NULL, 67360),
(67361, '3.30.70.270-FF-000173', NULL, NULL, 107, NULL, NULL, 67361),
(67362, '1.20.272.40-FF-000001', NULL, 'ATP-dependent RNA helicase SUPV3L1, mitochondrial', 80, NULL, NULL, 67362),
(67363, '3.40.50.12780-FF-000146', NULL, 'Uncharacterized protein', 391, NULL, NULL, 67363),
(67364, '3.30.920.10-FF-000005', NULL, 'Iron-sulfur cluster assembly protein CyaY', 109, NULL, NULL, 67364),
(67365, '2.130.10.10-FF-004857', NULL, 'Uncharacterized protein', 126, NULL, NULL, 67365),
(67366, '3.40.50.150-FF-001092', NULL, NULL, 209, NULL, NULL, 67366);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(67367, '3.30.230.10-FF-000149', NULL, 'Lon protease', 190, NULL, NULL, 67367),
(67368, '3.90.70.10-FF-000898', NULL, 'Uncharacterized protein', 125, NULL, NULL, 67368),
(67369, '2.130.10.10-FF-005959', NULL, 'Uncharacterized protein', 246, NULL, NULL, 67369),
(67370, '1.10.510.10-FF-001127', NULL, 'NEK protein kinase', 208, NULL, NULL, 67370),
(67371, '3.10.450.40-FF-000033', NULL, 'Baseplate assembly protein W', 105, NULL, NULL, 67371),
(67372, '4.10.240.10-FF-000201', NULL, 'Uncharacterized protein', 74, NULL, NULL, 67372),
(67373, '3.10.450.50-FF-000036', NULL, 'Putative transcriptional regulator', 120, NULL, NULL, 67373),
(67374, '1.25.40.10-FF-003125', NULL, 'Paf1 complex component', 94, NULL, NULL, 67374),
(67375, '3.30.160.60-FF-006364', NULL, NULL, 33, NULL, NULL, 67375),
(67376, '1.25.40.10-FF-000377', NULL, 'Tetratricopeptide repeat domain 21B', 227, NULL, NULL, 67376),
(67377, '3.90.1750.10-FF-000079', NULL, 'E3 ubiquitin-protein ligase', 181, NULL, NULL, 67377),
(67378, '3.60.15.10-FF-000025', NULL, 'Inactive cytidine monophosphate-N-acetylneuraminic acid hydroxylase', 152, NULL, NULL, 67378),
(67379, '1.20.58.1180-FF-000005', NULL, 'AGR361Wp', 129, NULL, NULL, 67379),
(67380, '3.30.70.330-FF-000359', NULL, 'CUGBP Elav-like family member 2', 97, NULL, NULL, 67380),
(67381, '3.10.100.10-FF-000257', NULL, NULL, 82, NULL, NULL, 67381),
(67382, '3.30.160.20-FF-000040', NULL, 'Peptide chain release factor 2', 104, NULL, NULL, 67382),
(67383, '3.40.710.10-FF-000021', NULL, 'Penicillin-binding protein 1C', 341, NULL, NULL, 67383),
(67384, '1.25.10.10-FF-002483', NULL, 'Chromosome 1, whole genome shotgun sequence', 210, NULL, NULL, 67384),
(67385, '2.60.120.260-FF-000417', NULL, 'Periplasmic beta-glucosidase', 133, NULL, NULL, 67385),
(67386, '1.25.40.20-FF-001330', NULL, 'Ankyrin repeat domain 6a', 128, NULL, NULL, 67386),
(67387, '3.80.10.10-FF-004251', NULL, 'Leucine-rich repeat protein (LRRP), putative', 70, NULL, NULL, 67387),
(67388, '3.30.70.270-FF-000066', NULL, 'Endogenous retrovirus group K member 6 Pol protein', 82, NULL, NULL, 67388),
(67389, '3.40.50.12580-FF-000002', NULL, 'Minor teichoic acid biosynthesis protein GgaB', 192, NULL, NULL, 67389),
(67390, '2.40.50.90-FF-000043', NULL, 'Tudor staphylococcal nuclease', 126, NULL, NULL, 67390),
(67391, '1.20.1250.20-FF-002118', NULL, 'Uncharacterized protein', 220, NULL, NULL, 67391),
(67392, '3.30.420.140-FF-000040', NULL, 'Transcription elongation factor spt6', 177, NULL, NULL, 67392),
(67393, '1.20.140.40-FF-000083', NULL, NULL, 164, NULL, NULL, 67393),
(67394, '3.30.200.20-FF-002365', NULL, 'Uncharacterized protein', 99, NULL, NULL, 67394),
(67395, '2.60.40.10-FF-001018', NULL, 'Tyrosine-protein kinase receptor', 120, NULL, NULL, 67395),
(67396, '3.80.10.10-FF-000226', NULL, 'leucine-rich repeat-containing protein 32 isoform X1', 197, NULL, NULL, 67396),
(67397, '1.25.40.10-FF-004755', NULL, 'Uncharacterized protein', 64, NULL, NULL, 67397),
(67398, '3.40.50.300-FF-005201', NULL, 'Thymidylate kinase', 211, NULL, NULL, 67398),
(67399, '3.40.50.10490-FF-000021', NULL, 'Glucose-6-phosphate isomerase', 193, NULL, NULL, 67399),
(67400, '3.30.420.40-FF-000982', NULL, 'Actin-related protein 8', 123, NULL, NULL, 67400),
(67401, '1.10.730.10-FF-000149', NULL, 'Valyl tRNA Synthetase', 65, NULL, NULL, 67401),
(67402, '1.10.601.10-FF-000001', NULL, 'RNA polymerase sigma factor SigA', 81, NULL, NULL, 67402),
(67403, '2.60.40.10-FF-000945', NULL, 'Neural cell adhesion molecule L1', 95, NULL, NULL, 67403),
(67404, '1.10.10.160-FF-000022', NULL, 'RecBCD enzyme subunit RecC', 102, NULL, NULL, 67404),
(67405, '3.30.750.24-FF-000056', NULL, 'YPR003C-like protein', 169, NULL, NULL, 67405),
(67406, '3.30.559.10-FF-000058', NULL, 'Carnitine palmitoyltransferase 2', 213, NULL, NULL, 67406),
(67407, '3.30.230.70-FF-000167', NULL, 'Uncharacterized protein', 145, NULL, NULL, 67407),
(67408, '3.60.10.10-FF-000036', NULL, 'Inositol polyphosphate phosphatase, putative', 387, NULL, NULL, 67408),
(67409, '1.10.260.40-FF-000043', NULL, 'DNA-binding protein', 71, NULL, NULL, 67409);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(67410, '3.30.870.30-FF-000001', NULL, 'MIT domain-containing protein 1', 159, NULL, NULL, 67410),
(67411, '3.40.50.150-FF-000479', NULL, 'Protein-lysine N-methyltransferase EFM6', 215, NULL, NULL, 67411),
(67412, '3.90.70.200-FF-000015', NULL, 'Uncharacterized protein', 132, NULL, NULL, 67412),
(67413, '3.10.580.10-FF-000112', NULL, 'Chloride channel protein', 186, NULL, NULL, 67413),
(67414, '3.30.450.70-FF-000015', NULL, 'Component of TRAPP complex', 159, NULL, NULL, 67414),
(67415, '3.90.190.10-FF-000244', NULL, 'Tyrosine-protein phosphatase', 294, NULL, NULL, 67415),
(67416, '2.130.10.10-FF-004964', NULL, 'Transducin/WD40 repeat-like superfamily protein', 89, NULL, NULL, 67416),
(67417, '2.130.10.10-FF-000479', NULL, 'Topless-related protein 3', 235, NULL, NULL, 67417),
(67418, '3.40.50.720-FF-001538', NULL, 'YALI0E27764p', 263, NULL, NULL, 67418),
(67419, '1.20.1260.60-FF-000017', NULL, 'Vacuolar protein sorting-associated protein ist1', 174, NULL, NULL, 67419),
(67420, '2.60.40.10-FF-002553', NULL, 'Titin homolog', 98, NULL, NULL, 67420),
(67421, '2.10.25.10-FF-001654', NULL, 'Uncharacterized protein', 73, NULL, NULL, 67421),
(67422, '3.30.160.60-FF-003710', NULL, NULL, 30, NULL, NULL, 67422),
(67423, '3.40.50.300-FF-000985', NULL, 'Guanine nucleotide-binding protein subunit alpha-15', 200, NULL, NULL, 67423),
(67424, '1.10.10.60-FF-000575', NULL, 'Transcription factor MYB30', 74, NULL, NULL, 67424),
(67425, '3.40.50.150-FF-001103', NULL, NULL, 190, NULL, NULL, 67425),
(67426, '3.30.200.20-FF-002258', NULL, 'CAMK protein kinase', 115, NULL, NULL, 67426),
(67427, '1.10.287.130-FF-000261', NULL, 'Phosphate regulon sensor protein PhoR', 70, NULL, NULL, 67427),
(67428, '2.130.10.10-FF-000586', NULL, 'Pre-mRNA-splicing factor rse1', 383, NULL, NULL, 67428),
(67429, '3.30.300.320-FF-000005', NULL, 'Uncharacterized protein', 97, NULL, NULL, 67429),
(67430, '1.20.20.10-FF-000015', NULL, 'ATP synthase subunit c', 74, NULL, NULL, 67430),
(67431, '3.40.50.720-FF-001645', NULL, 'NAD-dependent epimerase/dehydratase family protein', 308, NULL, NULL, 67431),
(67432, '2.30.30.790-FF-000021', NULL, '54S ribosomal protein subunit img1, mitochondrial', 136, NULL, NULL, 67432),
(67433, '3.40.850.10-FF-000407', NULL, 'Predicted protein', 259, NULL, NULL, 67433),
(67434, '2.60.40.10-FF-000299', NULL, 'protogenin isoform X2', 92, NULL, NULL, 67434),
(67435, '1.25.40.10-FF-004446', NULL, 'Uncharacterized protein', 115, NULL, NULL, 67435),
(67436, '3.10.100.10-FF-000408', NULL, NULL, 109, NULL, NULL, 67436),
(67437, '3.80.10.10-FF-003638', NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g56140', 211, NULL, NULL, 67437),
(67438, '3.40.225.10-FF-000028', NULL, 'Putative aldolase', 208, NULL, NULL, 67438),
(67439, '3.30.420.40-FF-000673', NULL, 'Uncharacterized protein', 66, NULL, NULL, 67439),
(67440, '3.50.50.60-FF-000470', NULL, 'Monooxygenase', 358, NULL, NULL, 67440),
(67441, '3.30.200.20-FF-000460', NULL, 'CMGC/MAPK protein kinase', 90, NULL, NULL, 67441),
(67442, '1.10.10.60-FF-000468', NULL, 'Distal-less homeobox 6', 82, NULL, NULL, 67442),
(67443, '3.40.50.1000-FF-000795', NULL, NULL, 165, NULL, NULL, 67443),
(67444, '1.20.1540.10-FF-000103', NULL, 'Uncharacterized protein', 185, NULL, NULL, 67444),
(67445, '2.60.40.10-FF-005150', NULL, NULL, 95, NULL, NULL, 67445),
(67446, '3.30.1520.10-FF-000160', NULL, 'Uncharacterized protein', 136, NULL, NULL, 67446),
(67447, '3.10.350.10-FF-000073', NULL, 'Cell wall endopeptidase family M23/M37', 62, NULL, NULL, 67447),
(67448, '3.30.160.60-FF-006257', NULL, NULL, 24, NULL, NULL, 67448),
(67449, '3.40.50.300-FF-006971', NULL, 'Uncharacterized protein', 220, NULL, NULL, 67449),
(67450, '1.10.10.10-FF-000386', NULL, 'Response regulator receiver domain protein', 110, NULL, NULL, 67450),
(67451, '1.10.510.10-FF-003600', NULL, NULL, 203, NULL, NULL, 67451),
(67452, '3.30.1010.10-FF-000076', NULL, 'Uncharacterized protein', 177, NULL, NULL, 67452),
(67453, '1.25.40.80-FF-000015', NULL, 'DNA photolyase (Eurofung)', 121, NULL, NULL, 67453),
(67454, '3.40.50.300-FF-000676', NULL, 'Ras homolog family member F', 197, NULL, NULL, 67454);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(67455, '3.30.470.30-FF-000055', NULL, 'DNA ligase 4', 229, NULL, NULL, 67455),
(67456, '3.40.50.2000-FF-000319', NULL, '3-deoxy-D-manno-octulosonic acid transferase', 172, NULL, NULL, 67456),
(67457, '2.30.42.10-FF-000602', NULL, NULL, 100, NULL, NULL, 67457),
(67458, '1.25.40.10-FF-000175', NULL, 'transmembrane and TPR repeat-containing protein 3', 98, NULL, NULL, 67458),
(67459, '2.40.10.10-FF-000293', NULL, NULL, 112, NULL, NULL, 67459),
(67460, '3.40.50.300-FF-001165', NULL, 'RNA cytidine acetyltransferase', 148, NULL, NULL, 67460),
(67461, '1.10.3170.10-FF-000009', NULL, 'RecBCD enzyme subunit RecB', 197, NULL, NULL, 67461),
(67462, '1.10.8.100-FF-000006', NULL, 'rRNA adenine N(6)-methyltransferase', 88, NULL, NULL, 67462),
(67463, '3.40.50.1000-FF-000267', NULL, 'Cation-transporting ATPase', 175, NULL, NULL, 67463),
(67464, '2.60.120.650-FF-000130', NULL, 'Uncharacterized protein', 195, NULL, NULL, 67464),
(67465, '3.80.10.10-FF-002008', NULL, 'Uncharacterized protein', 110, NULL, NULL, 67465),
(67466, '3.30.1360.150-FF-000004', NULL, 'Alkaline phosphatase PhoV', 115, NULL, NULL, 67466),
(67467, '1.10.150.20-FF-000170', NULL, 'UvrABC system protein C', 66, NULL, NULL, 67467),
(67468, '3.40.50.720-FF-001847', NULL, 'Uncharacterized protein', 52, NULL, NULL, 67468),
(67469, '3.40.970.40-FF-000004', NULL, 'Fibronectin/fibrinogen-binding protein', 46, NULL, NULL, 67469),
(67470, '3.40.50.970-FF-000034', NULL, 'Probable 2-oxoglutarate dehydrogenase E1 component DHKTD1, mitochondrial', 376, NULL, NULL, 67470),
(67471, '3.40.50.150-FF-001305', NULL, NULL, 301, NULL, NULL, 67471),
(67472, '3.30.1140.32-FF-000026', NULL, 'Predicted protein', 100, NULL, NULL, 67472),
(67473, '1.10.10.10-FF-001010', NULL, 'Putative transcriptional regulator', 141, NULL, NULL, 67473),
(67474, '3.90.70.10-FF-000589', NULL, 'Uncharacterized protein', 232, NULL, NULL, 67474),
(67475, '3.40.50.1000-FF-000486', NULL, NULL, 134, NULL, NULL, 67475),
(67476, '3.30.470.20-FF-000052', NULL, 'Ribosomal protein S6 modification enzyme', 117, NULL, NULL, 67476),
(67477, '3.50.50.60-FF-000700', NULL, 'sarcosine dehydrogenase, mitochondrial-like isoform X1', 217, NULL, NULL, 67477),
(67478, '1.10.472.10-FF-000268', NULL, 'WGS project CABT00000000 data, contig 2.8', 116, NULL, NULL, 67478),
(67479, '3.90.640.10-FF-000026', NULL, 'Actin-related protein 7', 88, NULL, NULL, 67479),
(67480, '2.40.30.270-FF-000032', NULL, 'Protein CBR-DNA-2', 100, NULL, NULL, 67480),
(67481, '2.30.30.40-FF-000483', NULL, 'Protein app1', 83, NULL, NULL, 67481),
(67482, '3.30.1370.10-FF-000215', NULL, 'ATP-dependent RNA helicase p62-like Protein', 98, NULL, NULL, 67482),
(67483, '3.30.160.60-FF-003014', NULL, 'Uncharacterized protein', 28, NULL, NULL, 67483),
(67484, '1.10.238.10-FF-001213', NULL, 'Kv channel-interacting protein 3b, calsenilin', 156, NULL, NULL, 67484),
(67485, '1.10.3130.10-FF-000007', NULL, 'serine acetyltransferase 1, chloroplastic', 150, NULL, NULL, 67485),
(67486, '2.20.70.10-FF-000095', NULL, 'Pre-mRNA-processing factor 40', 44, NULL, NULL, 67486),
(67487, '1.25.40.10-FF-000484', NULL, 'Glycosyltransferase family 41 protein', 158, NULL, NULL, 67487),
(67488, '1.10.840.10-FF-000011', NULL, 'Phosphoinositide phospholipase C', 253, NULL, NULL, 67488),
(67489, '2.60.120.20-FF-000001', NULL, 'Genome polyprotein', 281, NULL, NULL, 67489),
(67490, '1.20.1250.20-FF-000320', NULL, 'Monocarboxylate transporter', 197, NULL, NULL, 67490),
(67491, '3.30.1360.40-FF-000021', NULL, 'Ribosome recycling factor', 75, NULL, NULL, 67491),
(67492, '3.30.1360.140-FF-000001', NULL, 'DNA-directed RNA polymerase subunit', 139, NULL, NULL, 67492),
(67493, '2.60.120.260-FF-000097', NULL, 'Beta-galactosidase', 91, NULL, NULL, 67493),
(67494, '3.40.390.10-FF-000260', NULL, NULL, 187, NULL, NULL, 67494),
(67495, '1.10.510.10-FF-000947', NULL, 'serine/threonine-protein kinase OSR1', 204, NULL, NULL, 67495),
(67496, '2.60.120.260-FF-000108', NULL, 'Beta-galactosidase', 227, NULL, NULL, 67496),
(67497, '1.10.640.10-FF-000030', NULL, 'Myeloperoxidase', 466, NULL, NULL, 67497);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(67498, '3.90.1150.10-FF-000078', NULL, 'Kynureninase', 129, NULL, NULL, 67498),
(67499, '2.130.10.10-FF-004638', NULL, 'Dynein intermediate chain 1', 194, NULL, NULL, 67499),
(67500, '2.170.130.10-FF-000045', NULL, 'Iron(III) compound receptor', 134, NULL, NULL, 67500),
(67501, '2.30.30.490-FF-000021', NULL, 'Winged eye, isoform E', 168, NULL, NULL, 67501),
(67502, '2.30.29.30-FF-000263', NULL, 'Stress activated MAP kinase interacting protein', 87, NULL, NULL, 67502),
(67503, '1.25.40.10-FF-004227', NULL, 'Pre-mRNA-splicing factor SYF1', 262, NULL, NULL, 67503),
(67504, '1.10.472.10-FF-000419', NULL, 'Cyclin-D2-1', 73, NULL, NULL, 67504),
(67505, '1.10.10.60-FF-000940', NULL, NULL, 77, NULL, NULL, 67505),
(67506, '1.25.10.10-FF-002264', NULL, 'Importin, putative', 348, NULL, NULL, 67506),
(67507, '3.90.226.10-FF-000233', NULL, 'ATP-dependent Clp protease proteolytic subunit', 179, NULL, NULL, 67507),
(67508, '1.20.1250.20-FF-001966', NULL, 'Uncharacterized protein', 413, NULL, NULL, 67508),
(67509, '3.30.420.40-FF-000454', NULL, 'Actin, putative', 104, NULL, NULL, 67509),
(67510, '3.40.50.720-FF-001971', NULL, 'Uncharacterized protein', 422, NULL, NULL, 67510),
(67511, '3.30.70.141-FF-000034', NULL, NULL, 153, NULL, NULL, 67511),
(67512, '1.10.3430.10-FF-000047', NULL, 'Uncharacterized protein', 379, NULL, NULL, 67512),
(67513, '2.70.70.10-FF-000042', NULL, 'M23 family peptidase', 151, NULL, NULL, 67513),
(67514, '3.40.47.10-FF-000217', NULL, NULL, 148, NULL, NULL, 67514),
(67515, '3.90.550.10-FF-000492', NULL, 'Uncharacterized protein', 137, NULL, NULL, 67515),
(67516, '3.30.1390.10-FF-000008', NULL, '50S ribosomal protein L7/L12', 71, NULL, NULL, 67516),
(67517, '1.20.58.60-FF-000611', NULL, 'Spectrin beta chain', 136, NULL, NULL, 67517),
(67518, '1.20.120.720-FF-000060', NULL, 'Uncharacterized protein', 158, NULL, NULL, 67518),
(67519, '3.80.10.10-FF-003099', NULL, 'NACHT, LRR and PYD domains-containing protein 2', 113, NULL, NULL, 67519),
(67520, '1.10.437.10-FF-000012', NULL, 'Bcl-2-related protein A1', 152, NULL, NULL, 67520),
(67521, '3.90.1380.10-FF-000005', NULL, 'Putative threonine synthase', 94, NULL, NULL, 67521),
(67522, '3.60.21.10-FF-000438', NULL, 'Uncharacterized protein', 231, NULL, NULL, 67522),
(67523, '1.10.287.130-FF-000042', NULL, 'Sensor protein', 116, NULL, NULL, 67523),
(67524, '3.40.850.10-FF-000177', NULL, 'Kinesin-like protein', 350, NULL, NULL, 67524),
(67525, '3.30.740.10-FF-000014', NULL, 'Dynein light chain', 119, NULL, NULL, 67525),
(67526, '3.40.50.300-FF-000766', NULL, 'Recombination factor protein RarA', 148, NULL, NULL, 67526),
(67527, '3.40.50.1820-FF-000041', NULL, 'Mesoderm-specific transcript homolog protein', 295, NULL, NULL, 67527),
(67528, '3.60.10.10-FF-000401', NULL, 'Uncharacterized protein', 334, NULL, NULL, 67528),
(67529, '3.30.60.20-FF-000038', NULL, 'A-kinase anchor protein 13 isoform X1', 75, NULL, NULL, 67529),
(67530, '3.30.70.330-FF-002613', NULL, NULL, 180, NULL, NULL, 67530),
(67531, '1.25.10.10-FF-000549', NULL, 'ARM repeat superfamily protein', 190, NULL, NULL, 67531),
(67532, '1.10.510.10-FF-002881', NULL, NULL, 204, NULL, NULL, 67532),
(67533, '1.10.472.10-FF-000414', NULL, 'Putative cyclin L1 variant 2', 142, NULL, NULL, 67533),
(67534, '3.40.50.720-FF-000083', NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase', 177, NULL, NULL, 67534),
(67535, '3.40.50.620-FF-000513', NULL, 'Valine--tRNA ligase', 218, NULL, NULL, 67535),
(67536, '2.60.40.10-FF-002772', NULL, 'Amalgam, isoform C', 114, NULL, NULL, 67536),
(67537, '2.130.10.10-FF-005021', NULL, 'Transducin/WD40 repeat-like superfamily protein', 310, NULL, NULL, 67537),
(67538, '3.30.1010.10-FF-000060', NULL, 'Phosphatidylinositol 4-kinase, putative', 172, NULL, NULL, 67538),
(67539, '3.40.50.300-FF-008551', NULL, 'Uncharacterized protein', 85, NULL, NULL, 67539),
(67540, '3.30.70.2260-FF-000001', NULL, 'Exopolyphosphatase', 57, NULL, NULL, 67540),
(67541, '1.10.238.10-FF-001174', NULL, 'Flagellar protofilament ribbon protein rib74; Uncharacterized protein', 93, NULL, NULL, 67541);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(67542, '3.10.20.90-FF-001007', NULL, 'FERM domain-containing protein B', 100, NULL, NULL, 67542),
(67543, '3.30.160.60-FF-001221', NULL, 'putative transcription factor Ovo-like 1', 46, NULL, NULL, 67543),
(67544, '1.10.510.10-FF-000638', NULL, 'Serine/threonine-protein kinase NEK', 200, NULL, NULL, 67544),
(67545, '2.30.230.10-FF-000030', NULL, 'Microsomal triglyceride transfer protein large subunit', 228, NULL, NULL, 67545),
(67546, '1.20.140.40-FF-000066', NULL, NULL, 139, NULL, NULL, 67546),
(67547, '1.10.510.10-FF-003044', NULL, NULL, 214, NULL, NULL, 67547),
(67548, '3.30.160.60-FF-003345', NULL, 'Zinc finger protein 544', 29, NULL, NULL, 67548),
(67549, '4.10.60.10-FF-000039', NULL, 'Universal minicircle sequence binding protein, putative', 30, NULL, NULL, 67549),
(67550, '3.40.50.620-FF-000171', NULL, 'Isoleucine--tRNA ligase', 213, NULL, NULL, 67550),
(67551, '1.20.1250.20-FF-002113', NULL, 'Solute carrier organic anion transporter family, member 6d1', 230, NULL, NULL, 67551),
(67552, '3.40.50.150-FF-000939', NULL, 'Uncharacterized protein', 235, NULL, NULL, 67552),
(67553, '3.30.40.10-FF-000461', NULL, 'RING-H2 finger protein ATL66', 86, NULL, NULL, 67553),
(67554, '3.30.70.330-FF-002922', NULL, NULL, 126, NULL, NULL, 67554),
(67555, '3.30.710.10-FF-000068', NULL, 'Influenza virus NS1A-binding protein-like protein', 128, NULL, NULL, 67555),
(67556, '3.20.20.300-FF-000045', NULL, NULL, 194, NULL, NULL, 67556),
(67557, '3.60.20.10-FF-000003', NULL, 'Proteasome subunit beta type-3', 205, NULL, NULL, 67557),
(67558, '2.30.42.10-FF-000265', NULL, 'Tail-specific protease', 86, NULL, NULL, 67558),
(67559, '1.25.10.10-FF-002792', NULL, 'Ubiquitin homeostasis protein lub1', 252, NULL, NULL, 67559),
(67560, '3.80.10.10-FF-002334', NULL, 'OSJNBa0093O08.1 protein', 106, NULL, NULL, 67560),
(67561, '2.130.10.10-FF-000951', NULL, 'intraflagellar transport protein 172 homolog', 135, NULL, NULL, 67561),
(67562, '3.30.497.10-FF-000088', NULL, 'IP10416p', 224, NULL, NULL, 67562),
(67563, '2.30.30.40-FF-000157', NULL, 'adapter molecule crk isoform X1', 61, NULL, NULL, 67563),
(67564, '1.20.120.230-FF-000019', NULL, 'Catenin alpha 3', 112, NULL, NULL, 67564),
(67565, '2.10.110.10-FF-000328', NULL, 'Uncharacterized protein', 74, NULL, NULL, 67565),
(67566, '1.20.1310.10-FF-000064', NULL, 'Cullin 4B', 66, NULL, NULL, 67566),
(67567, '1.10.10.60-FF-000805', NULL, NULL, 55, NULL, NULL, 67567),
(67568, '1.20.120.220-FF-000016', NULL, 'ATP synthase subunit a', 169, NULL, NULL, 67568),
(67569, '3.30.160.60-FF-000597', NULL, 'zinc finger protein 236 isoform X3', 28, NULL, NULL, 67569),
(67570, '1.10.418.40-FF-000011', NULL, 'Beclin 2', 91, NULL, NULL, 67570),
(67571, '1.10.510.10-FF-000296', NULL, 'Dual specificity mitogen-activated protein kinase kinase 5', 201, NULL, NULL, 67571),
(67572, '1.20.150.10-FF-000001', NULL, 'Egg-lysin', 138, NULL, NULL, 67572),
(67573, '1.20.5.170-FF-000210', NULL, 'Male-specific lethal 1-like protein', 58, NULL, NULL, 67573),
(67574, '1.10.510.10-FF-001436', NULL, 'Uncharacterized protein', 235, NULL, NULL, 67574),
(67575, '2.40.320.10-FF-000006', NULL, 'Phosphoribulokinase / Uridine kinase family', 161, NULL, NULL, 67575),
(67576, '3.10.129.10-FF-000019', NULL, 'peroxisomal multifunctional enzyme type 2', 160, NULL, NULL, 67576),
(67577, '1.10.472.10-FF-000638', NULL, 'Uncharacterized protein', 116, NULL, NULL, 67577),
(67578, '1.50.10.20-FF-000128', NULL, 'Protein farnesyltransferase subunit beta', 410, NULL, NULL, 67578),
(67579, '3.60.20.30-FF-000009', NULL, 'TASPase homolog', 160, NULL, NULL, 67579),
(67580, '2.60.450.10-FF-000005', NULL, 'LPS export ABC transporter periplasmic protein LptC', 128, NULL, NULL, 67580),
(67581, '3.30.310.40-FF-000007', NULL, 'DNA glycosylase', 89, NULL, NULL, 67581),
(67582, '2.60.40.1450-FF-000010', NULL, 'Uncharacterized protein', 28, NULL, NULL, 67582),
(67583, '3.40.50.2300-FF-000640', NULL, 'Hybrid sensor histidine kinase/response regulator', 138, NULL, NULL, 67583),
(67584, '2.60.40.10-FF-004907', NULL, NULL, 92, NULL, NULL, 67584);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(67585, '3.30.40.10-FF-001888', NULL, 'RING/U-box superfamily protein', 74, NULL, NULL, 67585),
(67586, '1.20.120.610-FF-000010', NULL, 'V-type proton ATPase subunit c''''1', 46, NULL, NULL, 67586),
(67587, '2.40.30.10-FF-000529', NULL, 'Uncharacterized protein', 89, NULL, NULL, 67587),
(67588, '1.10.1040.10-FF-000106', NULL, 'Uncharacterized protein', 65, NULL, NULL, 67588),
(67589, '1.10.287.630-FF-000006', NULL, 'Cyclic Nucleotide Gated channel', 61, NULL, NULL, 67589),
(67590, '3.90.120.10-FF-000010', NULL, 'Cytosine-specific DNA methyltransferase', 162, NULL, NULL, 67590),
(67591, '3.30.310.20-FF-000001', NULL, 'DNA-3-methyladenine glycosylase 2', 116, NULL, NULL, 67591),
(67592, '3.30.70.270-FF-000212', NULL, NULL, 112, NULL, NULL, 67592),
(67593, '3.30.920.10-FF-000022', NULL, 'Uncharacterized protein', 115, NULL, NULL, 67593),
(67594, '3.40.50.300-FF-004509', NULL, 'Putative elongator complex protein 4', 222, NULL, NULL, 67594),
(67595, '3.40.50.1820-FF-001687', NULL, 'Uncharacterized protein', 219, NULL, NULL, 67595),
(67596, '3.90.70.10-FF-000679', NULL, 'Uncharacterized protein', 379, NULL, NULL, 67596),
(67597, '1.20.120.1750-FF-000027', NULL, 'RBR-type E3 ubiquitin transferase', 247, NULL, NULL, 67597),
(67598, '1.25.40.10-FF-000394', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 188, NULL, NULL, 67598),
(67599, '2.60.40.10-FF-003042', NULL, '1,4-alpha-glucan branching enzyme GlgB', 112, NULL, NULL, 67599),
(67600, '3.30.70.330-FF-002832', NULL, NULL, 87, NULL, NULL, 67600),
(67601, '3.30.300.30-FF-000032', NULL, 'Fatty-acid-CoA ligase FadD19', 109, NULL, NULL, 67601),
(67602, '2.60.40.10-FF-000636', NULL, 'Neural cell adhesion molecule 2', 94, NULL, NULL, 67602),
(67603, '1.20.120.310-FF-000015', NULL, NULL, 122, NULL, NULL, 67603),
(67604, '1.10.10.60-FF-000721', NULL, 'Hematopoietically-expressed homeobox protein HHEX', 48, NULL, NULL, 67604),
(67605, '3.30.780.10-FF-000033', NULL, 'Density-regulated protein, putative', 86, NULL, NULL, 67605),
(67606, '3.40.50.1820-FF-000057', NULL, 'Lipase', 373, NULL, NULL, 67606),
(67607, '1.20.1270.10-FF-000110', NULL, 'Chaperone protein DnaK', 89, NULL, NULL, 67607),
(67608, '3.30.540.10-FF-000049', NULL, 'Uncharacterized protein', 180, NULL, NULL, 67608),
(67609, '3.80.10.10-FF-000535', NULL, 'Leucine Rich Repeat family protein', 152, NULL, NULL, 67609),
(67610, '1.20.190.20-FF-000006', NULL, 'Poly [ADP-ribose] polymerase', 249, NULL, NULL, 67610),
(67611, '1.25.40.20-FF-001021', NULL, 'Ankyrin repeat protein', 128, NULL, NULL, 67611),
(67612, '3.40.309.10-FF-000077', NULL, 'Aldehyde dehydrogenase', 194, NULL, NULL, 67612),
(67613, '2.70.50.50-FF-000002', NULL, 'Chitin binding domain protein', 166, NULL, NULL, 67613),
(67614, '1.25.40.20-FF-000397', NULL, 'ATP binding', 224, NULL, NULL, 67614),
(67615, '2.70.98.10-FF-000044', NULL, 'Aldose 1-epimerase', 334, NULL, NULL, 67615),
(67616, '2.60.450.20-FF-000008', NULL, 'T complex protein-10 (Tcp-10b) mRNA', 157, NULL, NULL, 67616),
(67617, '2.30.42.10-FF-000349', NULL, 'Periplasmic serine endoprotease DegP-like', 94, NULL, NULL, 67617),
(67618, '1.25.10.10-FF-002820', NULL, 'Uncharacterized protein', 525, NULL, NULL, 67618),
(67619, '3.40.1090.10-FF-000118', NULL, 'Predicted protein', 284, NULL, NULL, 67619),
(67620, '1.20.5.170-FF-000064', NULL, 'fibronectin type III and SPRY domain-containing protein 1', 59, NULL, NULL, 67620),
(67621, '1.20.58.60-FF-000156', NULL, 'Spectrin beta chain, non-erythrocytic', 257, NULL, NULL, 67621),
(67622, '2.60.40.10-FF-002862', NULL, 'Cytotoxic and regulatory T-cell molecule', 88, NULL, NULL, 67622),
(67623, '1.10.510.10-FF-000964', NULL, 'CMGC/CDK protein kinase', 201, NULL, NULL, 67623),
(67624, '1.10.3380.30-FF-000043', NULL, 'Uncharacterized protein', 67, NULL, NULL, 67624),
(67625, '3.30.70.330-FF-002467', NULL, NULL, 81, NULL, NULL, 67625),
(67626, '2.60.260.20-FF-000157', NULL, 'AGAP007565-PB', 85, NULL, NULL, 67626),
(67627, '3.40.50.1820-FF-001468', NULL, 'Baculoviral IAP repeat-containing protein 5', 177, NULL, NULL, 67627);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(67628, '2.130.10.10-FF-004655', NULL, 'Uncharacterized protein', 188, NULL, NULL, 67628),
(67629, '1.20.1070.10-FF-001539', NULL, 'Predicted protein', 179, NULL, NULL, 67629),
(67630, '3.30.40.10-FF-001765', NULL, 'Receptor homology region transmembrane domain-and RING domain-containing protein 2', 64, NULL, NULL, 67630),
(67631, '3.30.70.270-FF-000083', NULL, 'Genome polyprotein', 90, NULL, NULL, 67631),
(67632, '2.130.10.10-FF-002749', NULL, 'YALI0E03542p', 267, NULL, NULL, 67632),
(67633, '3.100.10.10-FF-000055', NULL, NULL, 82, NULL, NULL, 67633),
(67634, '3.30.750.24-FF-000073', NULL, 'Anti-sigma factor antagonist', 110, NULL, NULL, 67634),
(67635, '2.30.180.10-FF-000177', NULL, NULL, 137, NULL, NULL, 67635),
(67636, '3.80.10.10-FF-000209', NULL, 'leucine-rich repeat and fibronectin type-III domain-containing protein 3', 127, NULL, NULL, 67636),
(67637, '2.40.50.90-FF-000150', NULL, 'Uncharacterized protein', 152, NULL, NULL, 67637),
(67638, '2.60.40.10-FF-004346', NULL, NULL, 117, NULL, NULL, 67638),
(67639, '3.30.430.20-FF-000050', NULL, 'Putative cysteine-rich receptor-like protein kinase 43', 103, NULL, NULL, 67639),
(67640, '3.40.50.300-FF-003082', NULL, 'PhoH family protein', 185, NULL, NULL, 67640),
(67641, '3.10.20.90-FF-000299', NULL, 'Rad23p', 74, NULL, NULL, 67641),
(67642, '3.30.559.10-FF-000204', NULL, 'Carnitine O-palmitoyltransferase 2, mitochondrial-like Protein', 36, NULL, NULL, 67642),
(67643, '1.10.238.10-FF-001320', NULL, 'Uncharacterized protein', 191, NULL, NULL, 67643),
(67644, '1.10.260.40-FF-000060', NULL, 'LacI family DNA-binding transcriptional regulator', 65, NULL, NULL, 67644),
(67645, '4.10.280.10-FF-000001', NULL, 'Putative transcription factor 12', 82, NULL, NULL, 67645),
(67646, '1.10.238.10-FF-000831', NULL, 'GD19277', 159, NULL, NULL, 67646),
(67647, '3.30.200.20-FF-000095', NULL, 'Mitogen-activated protein kinase kinase kinase 12', 83, NULL, NULL, 67647),
(67648, '1.20.1050.130-FF-000031', NULL, 'Uncharacterized protein', 73, NULL, NULL, 67648),
(67649, '3.40.50.460-FF-000004', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit alpha', 173, NULL, NULL, 67649),
(67650, '3.40.50.2300-FF-000437', NULL, 'LuxR family transcriptional regulator', 180, NULL, NULL, 67650),
(67651, '3.30.160.60-FF-003019', NULL, 'Uncharacterized protein', 24, NULL, NULL, 67651),
(67652, '3.30.70.1990-FF-000009', NULL, NULL, 95, NULL, NULL, 67652),
(67653, '3.90.79.10-FF-000244', NULL, 'Uncharacterized protein', 167, NULL, NULL, 67653),
(67654, '2.40.50.140-FF-000356', NULL, 'Single-stranded DNA-binding protein', 164, NULL, NULL, 67654),
(67655, '3.10.110.10-FF-000319', NULL, 'Uncharacterized protein', 181, NULL, NULL, 67655),
(67656, '3.30.70.330-FF-002815', NULL, NULL, 92, NULL, NULL, 67656),
(67657, '3.90.1150.10-FF-000415', NULL, 'Uncharacterized protein', 53, NULL, NULL, 67657),
(67658, '3.90.25.10-FF-000035', NULL, 'Uncharacterized protein', 73, NULL, NULL, 67658),
(67659, '3.30.450.60-FF-000012', NULL, 'AP-3 complex subunit mu-1 isoform X1', 140, NULL, NULL, 67659),
(67660, '3.30.160.60-FF-003238', NULL, 'Zinc finger protein 341', 32, NULL, NULL, 67660),
(67661, '2.30.30.40-FF-000376', NULL, 'N-acetylmuramoyl-L-alanine amidase', 72, NULL, NULL, 67661),
(67662, '3.30.780.10-FF-000016', NULL, 'eukaryotic translation initiation factor 2D', 86, NULL, NULL, 67662),
(67663, '1.20.1070.10-FF-000128', NULL, 'Seven TM Receptor', 319, NULL, NULL, 67663),
(67664, '4.10.80.160-FF-000002', NULL, 'Putative regulator of nonsense transcripts 2', 32, NULL, NULL, 67664),
(67665, '2.60.40.4060-FF-000006', NULL, 'Reelin', 67, NULL, NULL, 67665),
(67666, '3.30.2310.40-FF-000001', NULL, 'mRNA interferase toxin MqsR', 98, NULL, NULL, 67666),
(67667, '2.60.40.150-FF-000768', NULL, 'Uncharacterized protein', 124, NULL, NULL, 67667),
(67668, '3.90.550.10-FF-000576', NULL, 'Uncharacterized protein', 282, NULL, NULL, 67668),
(67669, '2.60.40.60-FF-000393', NULL, 'Cadherin-23', 102, NULL, NULL, 67669),
(67670, '2.60.40.4070-FF-000009', NULL, 'OmpA family protein', 85, NULL, NULL, 67670);
INSERT INTO "PUBLIC"."MODEL" VALUES
(67671, '2.10.25.10-FF-000092', NULL, 'Neurogenic locus notch protein 1', 38, NULL, NULL, 67671),
(67672, '1.10.132.60-FF-000027', NULL, 'DNA polymerase', 221, NULL, NULL, 67672),
(67673, '3.40.50.300-FF-003424', NULL, 'Developmentally-regulated GTP-binding protein, putative', 89, NULL, NULL, 67673),
(67674, '3.40.50.300-FF-000783', NULL, 'DEAD-box ATP-dependent RNA helicase CshA', 226, NULL, NULL, 67674),
(67675, '3.30.40.10-FF-002035', NULL, 'Uncharacterized protein', 98, NULL, NULL, 67675),
(67676, '3.90.950.10-FF-000022', NULL, 'Inosine triphosphate pyrophosphatase', 223, NULL, NULL, 67676),
(67677, '3.80.10.10-FF-001839', NULL, '2mit, isoform B', 116, NULL, NULL, 67677),
(67678, '3.30.50.10-FF-000063', NULL, 'CRE-NHR-48 protein', 111, NULL, NULL, 67678),
(67679, '2.170.270.10-FF-000078', NULL, 'SMYD family member 5', 116, NULL, NULL, 67679),
(67680, '3.40.50.12230-FF-000009', NULL, '10-formyltetrahydrofolate dehydrogenase', 195, NULL, NULL, 67680),
(67681, '1.10.510.10-FF-001004', NULL, 'Serine/threonine protein kinase', 310, NULL, NULL, 67681),
(67682, '3.30.50.10-FF-000102', NULL, 'Nuclear Hormone Receptor family', 95, NULL, NULL, 67682),
(67683, '3.40.190.10-FF-000508', NULL, 'Dipeptide ABC transporter (Dipeptide-binding protein)', 131, NULL, NULL, 67683),
(67684, '1.10.510.10-FF-003353', NULL, NULL, 271, NULL, NULL, 67684),
(67685, '3.40.367.20-FF-000017', NULL, 'Phosphotransferase', 228, NULL, NULL, 67685),
(67686, '1.25.10.10-FF-000566', NULL, 'Condensin complex subunit 1', 178, NULL, NULL, 67686),
(67687, '2.10.25.10-FF-000221', NULL, 'Protein kinase C-binding protein NELL1', 31, NULL, NULL, 67687),
(67688, '3.40.225.10-FF-000045', NULL, NULL, 245, NULL, NULL, 67688),
(67689, '1.10.730.10-FF-000059', NULL, 'Arginine-tRNA ligase', 121, NULL, NULL, 67689),
(67690, '3.30.40.10-FF-000680', NULL, 'Putative RING zinc finger domain superfamily protein', 64, NULL, NULL, 67690),
(67691, '1.20.1070.10-FF-002034', NULL, 'Uncharacterized protein', 118, NULL, NULL, 67691),
(67692, '3.40.50.620-FF-000732', NULL, 'Uncharacterized protein', 174, NULL, NULL, 67692),
(67693, '3.40.50.300-FF-006297', NULL, 'Uncharacterized protein', 173, NULL, NULL, 67693),
(67694, '3.40.50.11660-FF-000041', NULL, NULL, 155, NULL, NULL, 67694),
(67695, '3.30.710.10-FF-000175', NULL, 'Bric-a-brac', 121, NULL, NULL, 67695),
(67696, '3.80.10.10-FF-004161', NULL, 'Uncharacterized protein', 100, NULL, NULL, 67696),
(67697, '1.25.10.10-FF-000656', NULL, 'AP-1 complex subunit gamma', 632, NULL, NULL, 67697),
(67698, '3.30.40.10-FF-002254', NULL, 'Predicted protein', 57, NULL, NULL, 67698),
(67699, '3.10.350.10-FF-000090', NULL, 'Os01g0546000 protein', 57, NULL, NULL, 67699),
(67700, '1.10.10.10-FF-001083', NULL, 'DNA-directed RNA polymerase III subunit RPC6', 87, NULL, NULL, 67700),
(67701, '1.25.40.10-FF-000068', NULL, 'Anaphase promoting complex subunit 7', 80, NULL, NULL, 67701),
(67702, '3.30.1540.20-FF-000035', NULL, NULL, 75, NULL, NULL, 67702),
(67703, '2.130.10.10-FF-000816', NULL, 'Probable cytosolic iron-sulfur protein assembly protein 1', 411, NULL, NULL, 67703),
(67704, '1.25.40.10-FF-001208', NULL, 'Tetratricopeptide repeat domain-containing protein', 293, NULL, NULL, 67704),
(67705, '3.60.40.10-FF-000201', NULL, 'Protein phosphatase, Mg2+/Mn2+-dependent, 1K', 106, NULL, NULL, 67705),
(67706, '3.30.200.20-FF-000443', NULL, 'Serine/threonine-protein kinase/endoribonuclease IRE1', 85, NULL, NULL, 67706),
(67707, '3.30.980.20-FF-000001', NULL, 'Glucosyl-3-phosphoglycerate/mannosyl-3-phosphoglycerate phosphatase', 89, NULL, NULL, 67707),
(67708, '3.30.70.330-FF-002506', NULL, NULL, 71, NULL, NULL, 67708),
(67709, '3.50.50.60-FF-000335', NULL, 'Nitrite reductase large subunit', 125, NULL, NULL, 67709),
(67710, '3.30.2080.10-FF-000007', NULL, 'Alpha-1,2-mannosidase, putative', 153, NULL, NULL, 67710),
(67711, '1.20.150.20-FF-000004', NULL, 'ATP synthase subunit alpha, mitochondrial', 131, NULL, NULL, 67711),
(67712, '3.90.320.10-FF-000070', NULL, 'Superfamily I DNA and RNA helicase and helicase subunits-like protein', 240, NULL, NULL, 67712);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(67713, '1.10.8.440-FF-000001', NULL, 'Phosphoprotein', 86, NULL, NULL, 67713),
(67714, '3.90.226.10-FF-000087', NULL, 'Si:ch211-198n5.11', 259, NULL, NULL, 67714),
(67715, '1.25.40.10-FF-000719', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 135, NULL, NULL, 67715),
(67716, '3.10.20.820-FF-000001', NULL, 'Succinate dehydrogenase flavoprotein subunit', 59, NULL, NULL, 67716),
(67717, '1.25.40.770-FF-000010', NULL, 'Transcription initiation factor TFIID subunit 6', 43, NULL, NULL, 67717),
(67718, '3.40.50.1000-FF-000469', NULL, 'AT02326p', 194, NULL, NULL, 67718),
(67719, '2.60.120.740-FF-000022', NULL, 'Uncharacterized protein', 84, NULL, NULL, 67719),
(67720, '2.40.180.10-FF-000017', NULL, 'Catalase-related peroxidase', 207, NULL, NULL, 67720),
(67721, '3.30.160.60-FF-004891', NULL, NULL, 31, NULL, NULL, 67721),
(67722, '2.30.30.30-FF-000154', NULL, '54S ribosomal protein L40, mitochondrial', 113, NULL, NULL, 67722),
(67723, '3.30.565.10-FF-000455', NULL, 'Flagellar sensor histidine kinase FleS', 153, NULL, NULL, 67723),
(67724, '3.40.1770.10-FF-000013', NULL, 'Uncharacterized protein', 86, NULL, NULL, 67724),
(67725, '3.40.50.720-FF-000212', NULL, 'Glutamate dehydrogenase', 235, NULL, NULL, 67725),
(67726, '2.60.40.10-FF-003261', NULL, 'GM10182', 94, NULL, NULL, 67726),
(67727, '3.40.350.10-FF-000044', NULL, 'Metallopeptidase, family M24', 150, NULL, NULL, 67727),
(67728, '2.130.10.30-FF-000142', NULL, NULL, 240, NULL, NULL, 67728),
(67729, '3.10.290.20-FF-000014', NULL, 'Ubiquitin-activating enzyme E1-like', 121, NULL, NULL, 67729),
(67730, '2.30.30.40-FF-000466', NULL, 'Uncharacterized protein', 77, NULL, NULL, 67730),
(67731, '3.40.50.2300-FF-000314', NULL, 'Multi-sensor hybrid histidine kinase', 123, NULL, NULL, 67731),
(67732, '3.40.570.10-FF-000032', NULL, 'Uncharacterized protein', 290, NULL, NULL, 67732),
(67733, '3.90.1150.10-FF-000106', NULL, 'Related to acetylornithine aminotransferase', 117, NULL, NULL, 67733),
(67734, '3.40.50.300-FF-004835', NULL, 'Mitochondrial Rho GTPase 1', 176, NULL, NULL, 67734),
(67735, '3.90.640.10-FF-000009', NULL, 'Actin-like 6A, isoform CRA_a', 122, NULL, NULL, 67735),
(67736, '1.25.40.20-FF-001240', NULL, 'Uncharacterized protein', 252, NULL, NULL, 67736),
(67737, '1.10.3720.10-FF-000064', NULL, 'ABC transporter, permease protein', 196, NULL, NULL, 67737),
(67738, '3.30.160.60-FF-004649', NULL, NULL, 34, NULL, NULL, 67738),
(67739, '3.30.1370.10-FF-000232', NULL, 'Predicted protein', 76, NULL, NULL, 67739),
(67740, '1.20.1070.10-FF-001854', NULL, 'Uncharacterized protein', 297, NULL, NULL, 67740),
(67741, '1.25.40.10-FF-004429', NULL, 'Uncharacterized protein', 123, NULL, NULL, 67741),
(67742, '3.40.850.10-FF-000323', NULL, 'Kinesin-like protein KLP1', 375, NULL, NULL, 67742),
(67743, '3.20.20.150-FF-000056', NULL, 'Probable ketose 3-epimerase', 281, NULL, NULL, 67743),
(67744, '3.40.50.300-FF-003402', NULL, 'Dynein heavy chain', 226, NULL, NULL, 67744),
(67745, '1.20.5.2120-FF-000001', NULL, 'Integrin alpha L', 54, NULL, NULL, 67745),
(67746, '3.30.450.20-FF-000141', NULL, 'Similar, isoform D', 147, NULL, NULL, 67746),
(67747, '2.170.260.40-FF-000007', NULL, '5''-3'' exoribonuclease 1', 184, NULL, NULL, 67747),
(67748, '3.55.40.20-FF-000014', NULL, 'Superoxide dismutase', 110, NULL, NULL, 67748),
(67749, '3.40.50.300-FF-002784', NULL, 'Structural maintenance of chromosomes', 219, NULL, NULL, 67749),
(67750, '3.20.20.70-FF-000787', NULL, NULL, 63, NULL, NULL, 67750),
(67751, '1.10.510.10-FF-001330', NULL, 'Uncharacterized protein', 181, NULL, NULL, 67751),
(67752, '3.40.50.300-FF-007134', NULL, 'Unclassified GTPase', 181, NULL, NULL, 67752),
(67753, '3.40.50.1240-FF-000092', NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', 439, NULL, NULL, 67753),
(67754, '3.10.100.10-FF-000392', NULL, NULL, 123, NULL, NULL, 67754),
(67755, '2.40.70.10-FF-000274', NULL, 'Putative aspartic endopeptidase', 203, NULL, NULL, 67755),
(67756, '3.60.15.10-FF-000261', NULL, 'Ribonuclease Z, putative', 182, NULL, NULL, 67756);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(67757, '2.130.10.10-FF-002385', NULL, 'Rtt10p', 258, NULL, NULL, 67757),
(67758, '3.30.465.10-FF-000082', NULL, 'Hemolysins-related protein containing CBS domains', 85, NULL, NULL, 67758),
(67759, '1.10.472.10-FF-000184', NULL, 'CTD kinase subunit beta', 111, NULL, NULL, 67759),
(67760, '3.75.10.10-FF-000020', NULL, 'Glycine amidinotransferase', 298, NULL, NULL, 67760),
(67761, '2.130.10.10-FF-003003', NULL, 'WD repeat domain 60', 188, NULL, NULL, 67761),
(67762, '1.20.1250.20-FF-001949', NULL, 'Facilitated trehalose transporter Tret1-2 homolog-like Protein', 442, NULL, NULL, 67762),
(67763, '2.60.40.1930-FF-000030', NULL, 'Cpras2, large protein with the cpRAS domain', 130, NULL, NULL, 67763),
(67764, '3.30.428.10-FF-000013', NULL, 'Hit family protein 1', 138, NULL, NULL, 67764),
(67765, '3.80.10.10-FF-003554', NULL, 'Si:zfos-323e3.4', 290, NULL, NULL, 67765),
(67766, '2.60.260.20-FF-000179', NULL, 'Predicted protein', 109, NULL, NULL, 67766),
(67767, '3.40.30.10-FF-000887', NULL, 'Predicted protein', 218, NULL, NULL, 67767),
(67768, '2.30.30.100-FF-000202', NULL, 'Uncharacterized protein', 139, NULL, NULL, 67768),
(67769, '3.40.1280.10-FF-000037', NULL, 'RNA methyltransferase, putative', 160, NULL, NULL, 67769),
(67770, '3.30.160.60-FF-004565', NULL, NULL, 28, NULL, NULL, 67770),
(67771, '3.90.660.10-FF-000117', NULL, NULL, 130, NULL, NULL, 67771),
(67772, '3.30.390.50-FF-000004', NULL, 'Xanthine dehydrogenase, FAD binding subunit', 108, NULL, NULL, 67772),
(67773, '3.10.290.20-FF-000020', NULL, 'Ubiquitin-activating enzyme E1b, putative', 85, NULL, NULL, 67773),
(67774, '2.60.40.10-FF-003025', NULL, NULL, 51, NULL, NULL, 67774),
(67775, '3.90.1150.10-FF-000331', NULL, 'Adenosylmethionine-8-amino-7-oxononanoate aminotransferase family protein', 132, NULL, NULL, 67775),
(67776, '1.10.238.10-FF-000685', NULL, 'Phosphoinositide phospholipase C', 95, NULL, NULL, 67776),
(67777, '2.40.100.10-FF-000097', NULL, 'Uncharacterized protein', 174, NULL, NULL, 67777),
(67778, '3.30.200.20-FF-000459', NULL, 'Wall-associated receptor kinase-like 8', 102, NULL, NULL, 67778),
(67779, '2.20.70.10-FF-000241', NULL, 'Peptidyl-prolyl cis-trans isomerase', 33, NULL, NULL, 67779),
(67780, '1.10.10.10-FF-000476', NULL, 'Histone acetyltransferase', 83, NULL, NULL, 67780),
(67781, '1.25.40.10-FF-004901', NULL, 'Uncharacterized protein', 80, NULL, NULL, 67781),
(67782, '3.30.1330.10-FF-000016', NULL, 'Phosphoribosylformylglycinamidine synthase', 191, NULL, NULL, 67782),
(67783, '2.60.120.260-FF-000552', NULL, 'Uncharacterized protein', 55, NULL, NULL, 67783),
(67784, '3.30.70.330-FF-002271', NULL, NULL, 80, NULL, NULL, 67784),
(67785, '1.20.58.60-FF-000482', NULL, 'Spectrin repeat containing, nuclear envelope 1a', 309, NULL, NULL, 67785),
(67786, '3.30.2350.10-FF-000017', NULL, 'Pseudouridine synthase', 256, NULL, NULL, 67786),
(67787, '3.40.50.720-FF-002336', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', 170, NULL, NULL, 67787),
(67788, '3.30.160.60-FF-001440', NULL, 'Zinc finger homeobox protein 4', 93, NULL, NULL, 67788),
(67789, '3.50.50.60-FF-000026', NULL, 'Succinate dehydrogenase flavoprotein subunit', 273, NULL, NULL, 67789),
(67790, '3.40.50.300-FF-006527', NULL, 'Uncharacterized protein', 110, NULL, NULL, 67790),
(67791, '2.40.70.10-FF-000268', NULL, 'Aspartic peptidase domain-containing protein', 169, NULL, NULL, 67791),
(67792, '3.40.190.10-FF-000514', NULL, 'Glutamate receptor', 121, NULL, NULL, 67792),
(67793, '1.25.10.10-FF-002819', NULL, 'Uncharacterized protein', 193, NULL, NULL, 67793),
(67794, '2.60.120.200-FF-000208', NULL, 'Blast:Protein eyes shut', 196, NULL, NULL, 67794),
(67795, '3.40.1390.30-FF-000023', NULL, 'GTP cyclohydrolase 1 type 2 homolog', 122, NULL, NULL, 67795),
(67796, '3.80.10.10-FF-001845', NULL, 'PH domain leucine-rich repeat-containing protein phosphatase 1 isoform A', 190, NULL, NULL, 67796),
(67797, '1.20.1440.180-FF-000011', NULL, 'Uncharacterized protein', 138, NULL, NULL, 67797),
(67798, '1.10.420.10-FF-000047', NULL, 'Putative L-ascorbate peroxidase 6', 40, NULL, NULL, 67798);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(67799, '3.80.10.10-FF-003969', NULL, 'Toll-like receptor 1-like protein b', 342, NULL, NULL, 67799),
(67800, '1.20.1560.10-FF-000301', NULL, 'AGAP009835-PA', 77, NULL, NULL, 67800),
(67801, '1.20.1160.11-FF-000007', NULL, 'paired amphipathic helix protein Sin3b', 37, NULL, NULL, 67801),
(67802, '3.90.180.10-FF-000081', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 109, NULL, NULL, 67802),
(67803, '2.130.10.10-FF-000732', NULL, 'EARP-interacting protein homolog', 367, NULL, NULL, 67803),
(67804, '3.30.70.330-FF-000562', NULL, 'Heterogeneous nuclear ribonucleoprotein 1', 84, NULL, NULL, 67804),
(67805, '1.20.1510.10-FF-000045', NULL, 'Cation diffusion facilitator family protein 1', 162, NULL, NULL, 67805),
(67806, '3.30.40.10-FF-001782', NULL, 'Tnf receptor-associated factor 5', 63, NULL, NULL, 67806),
(67807, '4.10.60.10-FF-000258', NULL, 'Uncharacterized protein', 27, NULL, NULL, 67807),
(67808, '3.90.79.10-FF-000098', NULL, 'MutT/nudix family protein', 140, NULL, NULL, 67808),
(67809, '1.20.5.190-FF-000087', NULL, NULL, 56, NULL, NULL, 67809),
(67810, '1.10.238.10-FF-001303', NULL, 'Uncharacterized protein', 56, NULL, NULL, 67810),
(67811, '1.25.10.10-FF-001044', NULL, 'RING-type E3 ubiquitin transferase', 189, NULL, NULL, 67811),
(67812, '3.40.50.10190-FF-000010', NULL, 'DNA topoisomerase II binding protein 1', 93, NULL, NULL, 67812),
(67813, '3.20.20.300-FF-000028', NULL, 'Thermostable beta-glucosidase B', 296, NULL, NULL, 67813),
(67814, '1.10.3720.10-FF-000148', NULL, 'Amino acid ABC transporter permease', 215, NULL, NULL, 67814),
(67815, '3.30.430.20-FF-000033', NULL, 'Uncharacterized protein', 114, NULL, NULL, 67815),
(67816, '2.60.40.10-FF-003351', NULL, NULL, 101, NULL, NULL, 67816),
(67817, '2.60.40.60-FF-000718', NULL, 'Cdh-4', 99, NULL, NULL, 67817),
(67818, '1.20.58.670-FF-000028', NULL, NULL, 147, NULL, NULL, 67818),
(67819, '3.30.720.50-FF-000002', NULL, 'Putative e3 ubiquitin-protein ligase huwe1 isoform x2', 83, NULL, NULL, 67819),
(67820, '3.90.70.10-FF-000718', NULL, 'AGAP001960-PA', 194, NULL, NULL, 67820),
(67821, '3.40.250.10-FF-000120', NULL, 'Adenylyltransferase and sulfurtransferase MOCS3 homolog', 156, NULL, NULL, 67821),
(67822, '3.10.100.10-FF-000279', NULL, NULL, 85, NULL, NULL, 67822),
(67823, '1.10.510.10-FF-004455', NULL, NULL, 287, NULL, NULL, 67823),
(67824, '3.30.2060.10-FF-000006', NULL, 'Penicillin-binding protein 1B', 89, NULL, NULL, 67824),
(67825, '2.40.110.10-FF-000069', NULL, 'Acyl-CoA oxidase, putative', 127, NULL, NULL, 67825),
(67826, '3.40.50.300-FF-005532', NULL, 'RNA polymerase II elongator complex subunit', 81, NULL, NULL, 67826),
(67827, '1.10.150.20-FF-000203', NULL, 'Flap endonuclease 1', 57, NULL, NULL, 67827),
(67828, '3.10.129.10-FF-000036', NULL, 'Acyl-ACP thioesterase', 148, NULL, NULL, 67828),
(67829, '2.60.40.640-FF-000039', NULL, 'GM14300', 147, NULL, NULL, 67829),
(67830, '1.10.510.10-FF-004348', NULL, NULL, 292, NULL, NULL, 67830),
(67831, '1.10.2020.20-FF-000002', NULL, '26S proteasome regulatory subunit RPN13', 110, NULL, NULL, 67831),
(67832, '1.10.10.60-FF-001103', NULL, NULL, 68, NULL, NULL, 67832),
(67833, '1.25.40.10-FF-002176', NULL, 'Pentatricopeptide repeat-containing protein', 199, NULL, NULL, 67833),
(67834, '3.40.50.300-FF-003391', NULL, 'ATP-dependent RNA helicase MAK5', 273, NULL, NULL, 67834),
(67835, '3.50.30.30-FF-000111', NULL, 'Uncharacterized protein', 131, NULL, NULL, 67835),
(67836, '2.20.70.10-FF-000128', NULL, 'WW domain-containing protein tag-325', 71, NULL, NULL, 67836),
(67837, '3.40.190.290-FF-000028', NULL, 'Transcriptional regulator, LysR family', 199, NULL, NULL, 67837),
(67838, '3.30.200.20-FF-000802', NULL, 'Ephrin receptor 1', 111, NULL, NULL, 67838),
(67839, '3.30.70.330-FF-000343', NULL, 'RNA-binding domain-containing protein', 152, NULL, NULL, 67839),
(67840, '3.30.110.20-FF-000014', NULL, 'Uncharacterized protein', 124, NULL, NULL, 67840),
(67841, '3.30.565.10-FF-000039', NULL, 'Sensor histidine kinase BtsS', 135, NULL, NULL, 67841),
(67842, '3.30.70.1440-FF-000002', NULL, 'Multidrug resistance protein MdtC', 102, NULL, NULL, 67842);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(67843, '3.10.129.10-FF-000238', NULL, 'Uncharacterized protein', 144, NULL, NULL, 67843),
(67844, '1.20.5.340-FF-000059', NULL, 'Myosin-3', 85, NULL, NULL, 67844),
(67845, '3.40.50.2300-FF-000331', NULL, 'Guanylate cyclase', 176, NULL, NULL, 67845),
(67846, '1.10.730.10-FF-000166', NULL, 'Methionine--tRNA ligase', 146, NULL, NULL, 67846),
(67847, '3.90.70.10-FF-000825', NULL, 'Ubiquitin-specific protease', 171, NULL, NULL, 67847),
(67848, '3.40.630.10-FF-000318', NULL, 'Uncharacterized protein', 272, NULL, NULL, 67848),
(67849, '3.30.60.190-FF-000012', NULL, 'Putative box C/D snoRNA protein SPCC613.07', 49, NULL, NULL, 67849),
(67850, '3.30.56.50-FF-000003', NULL, 'Translation initiation factor IF-2', 50, NULL, NULL, 67850),
(67851, '2.170.270.10-FF-000185', NULL, 'Uncharacterized protein', 300, NULL, NULL, 67851),
(67852, '1.10.10.10-FF-001190', NULL, 'HTH-type transcriptional regulator NsrR', 142, NULL, NULL, 67852),
(67853, '1.10.3460.10-FF-000021', NULL, 'Chlorophyll a-b binding protein, chloroplastic', 94, NULL, NULL, 67853),
(67854, '2.20.100.10-FF-000073', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 9 isoform X2', 56, NULL, NULL, 67854),
(67855, '3.40.30.10-FF-001185', NULL, 'Uncharacterized protein', 109, NULL, NULL, 67855),
(67856, '3.60.90.10-FF-000030', NULL, 'S-adenosylmethionine decarboxylase proenzyme', 126, NULL, NULL, 67856),
(67857, '1.10.1450.10-FF-000172', NULL, 'Tetraspanin', 52, NULL, NULL, 67857),
(67858, '1.10.10.10-FF-000695', NULL, 'DNA-directed RNA polymerase III subunit RPC3', 78, NULL, NULL, 67858),
(67859, '2.60.40.10-FF-003244', NULL, 'Defective proboscis extension response', 108, NULL, NULL, 67859),
(67860, '1.20.5.220-FF-000006', NULL, 'Transcriptional regulator, MarR family', 26, NULL, NULL, 67860),
(67861, '2.60.40.1450-FF-000009', NULL, 'Uncharacterized protein', 34, NULL, NULL, 67861),
(67862, '3.60.10.10-FF-000053', NULL, 'Type IV inositol polyphosphate 5-phosphatase 9', 363, NULL, NULL, 67862),
(67863, '1.20.1310.10-FF-000148', NULL, NULL, 107, NULL, NULL, 67863),
(67864, '1.20.1250.10-FF-000002', NULL, 'Growth hormone', 190, NULL, NULL, 67864),
(67865, '2.70.98.10-FF-000027', NULL, 'Aldose 1-epimerase', 337, NULL, NULL, 67865),
(67866, '3.30.160.60-FF-001131', NULL, 'Zinc finger protein 462', 87, NULL, NULL, 67866),
(67867, '3.40.47.10-FF-000307', NULL, 'Polyketide synthase RzxD', 479, NULL, NULL, 67867),
(67868, '1.20.5.210-FF-000003', NULL, NULL, 83, NULL, NULL, 67868),
(67869, '1.10.3430.10-FF-000069', NULL, 'Uncharacterized protein', 216, NULL, NULL, 67869),
(67870, '3.40.50.300-FF-004818', NULL, 'Uncharacterized protein', 184, NULL, NULL, 67870),
(67871, '3.30.110.10-FF-000011', NULL, 'Translation initiation factor IF-3', 93, NULL, NULL, 67871),
(67872, '2.60.40.10-FF-004880', NULL, NULL, 108, NULL, NULL, 67872),
(67873, '1.20.1250.20-FF-000005', NULL, 'vesicular glutamate transporter 2 isoform X1', 208, NULL, NULL, 67873),
(67874, '3.40.1090.10-FF-000135', NULL, 'Uncharacterized protein', 100, NULL, NULL, 67874),
(67875, '2.130.10.10-FF-002856', NULL, 'WD domain, G-beta repeat, putative', 342, NULL, NULL, 67875),
(67876, '1.25.40.320-FF-000004', NULL, 'Peptidase M1 family protein', 142, NULL, NULL, 67876),
(67877, '4.10.1060.10-FF-000010', NULL, 'Calpain 15', 38, NULL, NULL, 67877),
(67878, '2.60.120.690-FF-000001', NULL, 'Proprotein convertase subtilisin/kexin type 9', 223, NULL, NULL, 67878),
(67879, '1.20.1070.10-FF-000544', NULL, 'Predicted protein', 347, NULL, NULL, 67879),
(67880, '1.20.58.60-FF-000173', NULL, 'Spectrin repeat containing nuclear envelope protein 2', 216, NULL, NULL, 67880),
(67881, '3.40.50.620-FF-000530', NULL, 'Arginyl-tRNA synthetase 2, mitochondrial (putative)', 91, NULL, NULL, 67881),
(67882, '3.40.50.170-FF-000002', NULL, '10-formyltetrahydrofolate dehydrogenase', 205, NULL, NULL, 67882),
(67883, '3.10.50.10-FF-000035', NULL, 'Protein CBG22612', 25, NULL, NULL, 67883),
(67884, '1.20.58.60-FF-000263', NULL, 'Alpha spectrin, isoform C', 110, NULL, NULL, 67884),
(67885, '1.10.510.10-FF-000857', NULL, 'NEK protein kinase', 130, NULL, NULL, 67885);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(67886, '1.20.1050.10-FF-000021', NULL, 'Elongation factor 1-gamma', 138, NULL, NULL, 67886),
(67887, '2.60.40.10-FF-002637', NULL, 'Zwei Ig domain protein zig-8', 94, NULL, NULL, 67887),
(67888, '3.40.50.150-FF-000608', NULL, 'Putative s-adenosylmethionine-dependent methyltransferase superfamily domain-containing protein', 294, NULL, NULL, 67888),
(67889, '2.40.50.90-FF-000133', NULL, 'FI02030p', 103, NULL, NULL, 67889),
(67890, '3.40.50.150-FF-000940', NULL, NULL, 94, NULL, NULL, 67890),
(67891, '3.40.50.720-FF-000560', NULL, 'SUMO activating enzyme (AosA), putative', 352, NULL, NULL, 67891),
(67892, '2.130.10.10-FF-003222', NULL, 'WD-repeat membrane protein, putative', 308, NULL, NULL, 67892),
(67893, '1.20.1080.10-FF-000045', NULL, 'Formate/nitrite transporter family protein, putative', 255, NULL, NULL, 67893),
(67894, '3.90.1410.10-FF-000149', NULL, 'Predicted protein', 337, NULL, NULL, 67894),
(67895, '3.40.50.1000-FF-000576', NULL, NULL, 131, NULL, NULL, 67895),
(67896, '1.25.40.310-FF-000001', NULL, 'Aconitate hydratase B', 161, NULL, NULL, 67896),
(67897, '1.10.10.10-FF-000947', NULL, 'WGS project CABT00000000 data, contig 2.2', 144, NULL, NULL, 67897),
(67898, '3.30.160.60-FF-003036', NULL, NULL, 29, NULL, NULL, 67898),
(67899, '3.30.40.10-FF-000146', NULL, 'RING/FYVE/PHD zinc finger protein', 69, NULL, NULL, 67899),
(67900, '1.20.1050.130-FF-000014', NULL, 'Putative glutathione S-transferase alpha-5', 195, NULL, NULL, 67900),
(67901, '2.30.29.30-FF-000611', NULL, 'Motor AXon guidance', 124, NULL, NULL, 67901),
(67902, '3.50.50.60-FF-000228', NULL, 'FAD-containing monooxygenase EthA', 153, NULL, NULL, 67902),
(67903, '3.30.1370.10-FF-000125', NULL, 'Scp160p', 75, NULL, NULL, 67903),
(67904, '1.10.287.110-FF-000396', NULL, 'Predicted protein', 48, NULL, NULL, 67904),
(67905, '2.60.120.200-FF-000540', NULL, 'Sex hormone-binding globulin', 161, NULL, NULL, 67905),
(67906, '3.40.50.1000-FF-000828', NULL, NULL, 205, NULL, NULL, 67906),
(67907, '3.30.497.10-FF-000066', NULL, 'Uncharacterized protein', 220, NULL, NULL, 67907),
(67908, '1.10.20.10-FF-000196', NULL, NULL, 49, NULL, NULL, 67908),
(67909, '1.10.246.90-FF-000002', NULL, 'U4/U6 small nuclear ribonucleoprotein Prp31', 126, NULL, NULL, 67909),
(67910, '1.10.10.1320-FF-000011', NULL, 'Glr1159 protein', 58, NULL, NULL, 67910),
(67911, '1.10.3660.10-FF-000002', NULL, 'Prephenate dehydrogenase [NADP(+)]', 120, NULL, NULL, 67911),
(67912, '1.25.10.10-FF-000791', NULL, 'SERAC1 isoform 1', 124, NULL, NULL, 67912),
(67913, '3.30.160.60-FF-004784', NULL, NULL, 40, NULL, NULL, 67913),
(67914, '3.30.70.1450-FF-000005', NULL, 'Citrate transporter protein', 77, NULL, NULL, 67914),
(67915, '1.25.10.10-FF-003062', NULL, 'Uncharacterized protein', 266, NULL, NULL, 67915),
(67916, '2.30.29.30-FF-000302', NULL, 'Rho GTPase-activating protein 7', 119, NULL, NULL, 67916),
(67917, '3.40.50.1100-FF-000297', NULL, 'Uncharacterized protein', 162, NULL, NULL, 67917),
(67918, '2.170.270.10-FF-000095', NULL, 'Uncharacterized protein', 46, NULL, NULL, 67918),
(67919, '3.20.140.10-FF-000009', NULL, 'Nicotinate phosphoribosyltransferase', 427, NULL, NULL, 67919),
(67920, '3.30.565.10-FF-000348', NULL, 'Lost Adherence Sensor, LadS', 166, NULL, NULL, 67920),
(67921, '3.10.450.40-FF-000011', NULL, 'Amine oxidase', 103, NULL, NULL, 67921),
(67922, '1.10.510.10-FF-003128', NULL, NULL, 186, NULL, NULL, 67922),
(67923, '1.25.40.330-FF-000007', NULL, 'Adenylyl cyclase-associated protein', 51, NULL, NULL, 67923),
(67924, '3.40.50.12230-FF-000026', NULL, 'Predicted protein', 223, NULL, NULL, 67924),
(67925, '2.170.130.10-FF-000023', NULL, 'SusC/RagA family TonB-linked outer membrane protein', 151, NULL, NULL, 67925),
(67926, '3.40.50.170-FF-000024', NULL, 'Methionyl-tRNA formyltransferase', 207, NULL, NULL, 67926),
(67927, '3.40.30.10-FF-000578', NULL, '[Fe] hydrogenase, HymA subunit', 85, NULL, NULL, 67927),
(67928, '3.40.50.150-FF-001176', NULL, 'RNA capping enzyme, nuclear', 304, NULL, NULL, 67928),
(67929, '3.30.40.10-FF-000455', NULL, 'RING-type E3 ubiquitin transferase', 76, NULL, NULL, 67929);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(67930, '3.40.50.300-FF-007241', NULL, 'Uncharacterized protein', 160, NULL, NULL, 67930),
(67931, '3.30.200.20-FF-000791', NULL, 'Serine/threonine-protein kinase RIO3', 124, NULL, NULL, 67931),
(67932, '3.40.50.12820-FF-000001', NULL, 'Acetyl-CoA synthetase', 72, NULL, NULL, 67932),
(67933, '1.10.1420.10-FF-000198', NULL, 'Predicted protein', 113, NULL, NULL, 67933),
(67934, '3.40.50.20-FF-000003', NULL, 'Carbamoyl-phosphate synthase large chain', 109, NULL, NULL, 67934),
(67935, '3.90.1150.10-FF-000095', NULL, 'Aminotransferase', 114, NULL, NULL, 67935),
(67936, '3.30.70.330-FF-000253', NULL, 'splicing factor 3B subunit 6-like protein', 104, NULL, NULL, 67936),
(67937, '1.25.10.10-FF-001263', NULL, 'Testis-expressed sequence 10 protein', 187, NULL, NULL, 67937),
(67938, '3.40.50.10810-FF-000174', NULL, 'Uncharacterized protein, isoform E', 152, NULL, NULL, 67938),
(67939, '3.30.200.20-FF-001876', NULL, 'Non-specific serine/threonine protein kinase', 49, NULL, NULL, 67939),
(67940, '2.60.40.1840-FF-000003', NULL, 'Peptidase M1 family protein', 88, NULL, NULL, 67940),
(67941, '1.25.40.10-FF-004536', NULL, 'Uncharacterized protein', 234, NULL, NULL, 67941),
(67942, '3.30.930.10-FF-000051', NULL, 'Lysine--tRNA ligase', 361, NULL, NULL, 67942),
(67943, '2.60.40.10-FF-001243', NULL, 'Protein turtle homolog A', 99, NULL, NULL, 67943),
(67944, '3.30.70.2820-FF-000006', NULL, 'DNA polymerase', 108, NULL, NULL, 67944),
(67945, '3.40.50.40-FF-000009', NULL, 'L-asparaginase', 134, NULL, NULL, 67945),
(67946, '3.30.70.3490-FF-000050', NULL, NULL, 76, NULL, NULL, 67946),
(67947, '3.40.50.1240-FF-000198', NULL, NULL, 116, NULL, NULL, 67947),
(67948, '1.10.10.60-FF-000266', NULL, 'Distal-less homeobox 4a', 72, NULL, NULL, 67948),
(67949, '3.40.50.720-FF-002027', NULL, '3-hydroxybutyrate dehydrogenase 2', 196, NULL, NULL, 67949),
(67950, '3.40.1800.20-FF-000002', NULL, 'Weckle, isoform B', 82, NULL, NULL, 67950),
(67951, '1.10.150.240-FF-000008', NULL, 'Pyrophosphatase PpaX', 64, NULL, NULL, 67951),
(67952, '3.40.50.720-FF-001954', NULL, 'Fatty acyl-CoA reductase', 356, NULL, NULL, 67952),
(67953, '1.20.1250.20-FF-001972', NULL, 'Uncharacterized protein', 404, NULL, NULL, 67953),
(67954, '2.60.120.650-FF-000091', NULL, 'Chromosome 10, whole genome shotgun sequence', 257, NULL, NULL, 67954),
(67955, '1.20.58.760-FF-000055', NULL, 'Glr2649 protein', 196, NULL, NULL, 67955),
(67956, '3.30.420.10-FF-000220', NULL, 'ISDet2, transposase orfB', 165, NULL, NULL, 67956),
(67957, '1.10.10.10-FF-000841', NULL, 'Listeriolysin regulatory protein', 101, NULL, NULL, 67957),
(67958, '3.20.140.10-FF-000010', NULL, 'Nicotinate phosphoribosyltransferase', 388, NULL, NULL, 67958),
(67959, '3.30.70.330-FF-002052', NULL, NULL, 95, NULL, NULL, 67959),
(67960, '3.90.640.10-FF-000010', NULL, 'heat shock 70 kDa protein 14', 84, NULL, NULL, 67960),
(67961, '1.20.1070.10-FF-000235', NULL, 'mas-related G-protein coupled receptor member F', 275, NULL, NULL, 67961),
(67962, '3.80.10.10-FF-003863', NULL, 'Uncharacterized protein', 64, NULL, NULL, 67962),
(67963, '2.40.30.10-FF-000384', NULL, 'Translation elongation factor G, Ef-G', 113, NULL, NULL, 67963),
(67964, '3.40.640.10-FF-000386', NULL, 'Serine--pyruvate aminotransferase', 233, NULL, NULL, 67964),
(67965, '1.10.150.220-FF-000002', NULL, 'protein phosphatase 1 regulatory subunit 14A', 86, NULL, NULL, 67965),
(67966, '3.30.710.10-FF-000321', NULL, 'Uncharacterized protein', 149, NULL, NULL, 67966),
(67967, '1.25.40.10-FF-002737', NULL, 'Uncharacterized protein', 236, NULL, NULL, 67967),
(67968, '3.40.50.300-FF-005223', NULL, 'Uncharacterized protein', 204, NULL, NULL, 67968),
(67969, '3.60.20.10-FF-000082', NULL, 'Glutamate synthase, large subunit', 408, NULL, NULL, 67969),
(67970, '3.30.450.20-FF-000360', NULL, 'Two-component sensor histidine kinase', 116, NULL, NULL, 67970),
(67971, '2.60.270.50-FF-000003', NULL, 'Uncharacterized protein DDB_G0272682', 150, NULL, NULL, 67971),
(67972, '2.60.40.420-FF-000271', NULL, 'Cytochrome c oxidase subunit II', 146, NULL, NULL, 67972),
(67973, '2.30.30.790-FF-000004', NULL, '50S ribosomal protein L19, chloroplastic', 113, NULL, NULL, 67973);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(67974, '3.30.230.70-FF-000145', NULL, 'Exosome complex component RRP46', 109, NULL, NULL, 67974),
(67975, '3.80.20.20-FF-000039', NULL, 'Receptor protein-tyrosine kinase', 210, NULL, NULL, 67975),
(67976, '3.40.50.720-FF-000228', NULL, 'Putative oxidoreductase yhhX', 144, NULL, NULL, 67976),
(67977, '1.10.520.20-FF-000001', NULL, 'ATP synthase subunit delta', 105, NULL, NULL, 67977),
(67978, '2.40.10.10-FF-000618', NULL, NULL, 146, NULL, NULL, 67978),
(67979, '1.25.40.20-FF-000852', NULL, 'Kinase, NEK', 180, NULL, NULL, 67979),
(67980, '1.10.510.10-FF-002875', NULL, NULL, 212, NULL, NULL, 67980),
(67981, '1.20.58.560-FF-000001', NULL, 'CCA-adding enzyme', 95, NULL, NULL, 67981),
(67982, '3.30.760.10-FF-000015', NULL, 'Translation initiation factor eIF4E3, putative', 202, NULL, NULL, 67982),
(67983, '3.40.190.10-FF-000278', NULL, 'Serotransferrin', 149, NULL, NULL, 67983),
(67984, '2.130.10.10-FF-000277', NULL, 'transcription initiation factor TFIID subunit 5', 210, NULL, NULL, 67984),
(67985, '3.40.50.300-FF-006836', NULL, 'Uncharacterized protein', 266, NULL, NULL, 67985),
(67986, '3.40.50.150-FF-001412', NULL, NULL, 162, NULL, NULL, 67986),
(67987, '1.10.510.10-FF-002965', NULL, NULL, 185, NULL, NULL, 67987),
(67988, '2.60.40.150-FF-000746', NULL, 'Predicted protein', 94, NULL, NULL, 67988),
(67989, '3.40.50.1820-FF-000035', NULL, 'Acetyl esterase', 315, NULL, NULL, 67989),
(67990, '2.130.10.10-FF-004296', NULL, 'Uncharacterized protein', 121, NULL, NULL, 67990),
(67991, '3.10.100.10-FF-000173', NULL, NULL, 138, NULL, NULL, 67991),
(67992, '2.130.10.10-FF-000838', NULL, 'Mitochondrial division protein 1', 116, NULL, NULL, 67992),
(67993, '2.40.160.200-FF-000002', NULL, 'Protein LURP-one-related 7', 170, NULL, NULL, 67993),
(67994, '1.10.10.10-FF-000728', NULL, 'Uncharacterized protein', 84, NULL, NULL, 67994),
(67995, '1.20.1540.10-FF-000092', NULL, 'Rhomboid family serine protease', 207, NULL, NULL, 67995),
(67996, '2.130.10.10-FF-001114', NULL, 'p21-activated protein kinase-interacting protein 1', 126, NULL, NULL, 67996),
(67997, '2.70.150.10-FF-000239', NULL, 'Cation-transporting ATPase', 110, NULL, NULL, 67997),
(67998, '3.40.50.720-FF-001499', NULL, 'Short-chain dehydrogenase/reductase pkfC', 305, NULL, NULL, 67998),
(67999, '2.10.110.10-FF-000183', NULL, 'Chromosome 10, whole genome shotgun sequence', 73, NULL, NULL, 67999),
(68000, '3.60.15.10-FF-000042', NULL, 'Cleavage and polyadenylation specificity factor,putative', 217, NULL, NULL, 68000),
(68001, '2.60.40.10-FF-000529', NULL, 'Tenascin C', 90, NULL, NULL, 68001),
(68002, '2.10.25.10-FF-001199', NULL, 'Multiple epidermal growth factor-like domains protein 8', 51, NULL, NULL, 68002),
(68003, '3.80.10.10-FF-003773', NULL, 'Uncharacterized protein', 107, NULL, NULL, 68003),
(68004, '3.40.1620.70-FF-000003', NULL, 'Collagen type XVIII alpha 1', 54, NULL, NULL, 68004),
(68005, '3.40.50.300-FF-002475', NULL, 'DNA helicase related protein', 205, NULL, NULL, 68005),
(68006, '1.25.40.90-FF-000125', NULL, 'Huntingtin interacting protein 1', 166, NULL, NULL, 68006),
(68007, '3.90.180.10-FF-000002', NULL, 'Alcohol dehydrogenase AdhP', 181, NULL, NULL, 68007),
(68008, '3.40.50.11850-FF-000013', NULL, 'Uncharacterized protein', 23, NULL, NULL, 68008),
(68009, '1.25.40.20-FF-000020', NULL, 'Arf-GAP with coiled-coil, ANK repeat and PH domain-containing protein 2', 156, NULL, NULL, 68009),
(68010, '2.130.10.10-FF-004548', NULL, 'Uncharacterized protein', 219, NULL, NULL, 68010),
(68011, '1.10.630.10-FF-000113', NULL, 'Cytochrome P450 monooxygenase, putative', 478, NULL, NULL, 68011),
(68012, '3.20.20.80-FF-000290', NULL, 'Alpha-glucosidase', 380, NULL, NULL, 68012),
(68013, '3.40.30.10-FF-000201', NULL, 'Protein disulfide isomerase-like 1-5', 117, NULL, NULL, 68013),
(68014, '3.40.850.10-FF-000071', NULL, 'Kinesin-like KIF24', 147, NULL, NULL, 68014),
(68015, '1.25.40.10-FF-002956', NULL, 'Pentatricopeptide repeat-containing protein', 86, NULL, NULL, 68015),
(68016, '1.10.510.10-FF-003022', NULL, NULL, 266, NULL, NULL, 68016),
(68017, '2.60.40.10-FF-004986', NULL, NULL, 138, NULL, NULL, 68017);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(68018, '1.20.120.2010-FF-000004', NULL, 'Uncharacterized protein', 93, NULL, NULL, 68018),
(68019, '1.20.1250.20-FF-002135', NULL, 'Uncharacterized protein', 205, NULL, NULL, 68019),
(68020, '3.30.420.10-FF-000001', NULL, 'Protein argonaute-2', 278, NULL, NULL, 68020),
(68021, '2.30.30.100-FF-000056', NULL, 'Small nuclear ribonucleoprotein E', 87, NULL, NULL, 68021),
(68022, '1.20.1560.10-FF-000290', NULL, 'ABC transporter B family member 20', 48, NULL, NULL, 68022),
(68023, '3.40.50.80-FF-000072', NULL, 'Ferric reductase', 174, NULL, NULL, 68023),
(68024, '3.40.366.10-FF-000046', NULL, 'AaceriACR108Cp', 168, NULL, NULL, 68024),
(68025, '1.10.510.10-FF-002746', NULL, 'Predicted protein', 235, NULL, NULL, 68025),
(68026, '3.90.1150.10-FF-000185', NULL, 'Cysteine desulfurase', 47, NULL, NULL, 68026),
(68027, '4.10.1000.10-FF-000124', NULL, 'Uncharacterized protein', 51, NULL, NULL, 68027),
(68028, '2.130.10.10-FF-005043', NULL, 'SOF1 protein-related protein', 288, NULL, NULL, 68028),
(68029, '1.10.418.10-FF-000249', NULL, 'Uncharacterized protein', 100, NULL, NULL, 68029),
(68030, '3.30.160.60-FF-002873', NULL, 'GD16882', 26, NULL, NULL, 68030),
(68031, '3.90.1720.30-FF-000010', NULL, NULL, 68, NULL, NULL, 68031),
(68032, '2.120.10.80-FF-000197', NULL, 'Kelch domain-containing protein 8B', 210, NULL, NULL, 68032),
(68033, '1.25.40.10-FF-002428', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 140, NULL, NULL, 68033),
(68034, '3.40.350.10-FF-000066', NULL, 'Xaa-Pro aminopeptidase 1', 156, NULL, NULL, 68034),
(68035, '1.10.630.10-FF-000422', NULL, 'Putative cytochrome P450 superfamily protein', 275, NULL, NULL, 68035),
(68036, '3.40.50.300-FF-001171', NULL, 'DNA-binding protein SMUBP-2', 308, NULL, NULL, 68036),
(68037, '3.30.40.10-FF-000017', NULL, 'Protein kinase C-binding protein 1 isoform C', 67, NULL, NULL, 68037),
(68038, '2.60.40.10-FF-000838', NULL, 'Uncharacterized protein, isoform F', 99, NULL, NULL, 68038),
(68039, '2.40.160.10-FF-000016', NULL, 'Por1p', 281, NULL, NULL, 68039),
(68040, '3.40.50.2000-FF-000454', NULL, 'Glycosyltransferase, group 1 family', 159, NULL, NULL, 68040),
(68041, '1.25.40.90-FF-000035', NULL, 'Putative clathrin assembly protein At4g40080', 158, NULL, NULL, 68041),
(68042, '1.10.8.10-FF-000042', NULL, 'Ubiquitin domain-containing protein DSK2b', 59, NULL, NULL, 68042),
(68043, '3.80.10.10-FF-002227', NULL, 'Uncharacterized protein', 180, NULL, NULL, 68043),
(68044, '3.30.1740.10-FF-000013', NULL, 'Poly [ADP-ribose] polymerase', 55, NULL, NULL, 68044),
(68045, '3.80.10.10-FF-000120', NULL, 'PH domain and leucine rich repeat protein phosphatase 2', 233, NULL, NULL, 68045),
(68046, '1.25.10.10-FF-002590', NULL, 'Uncharacterized protein', 154, NULL, NULL, 68046),
(68047, '2.40.50.140-FF-000025', NULL, '40S ribosomal protein S28', 68, NULL, NULL, 68047),
(68048, '1.20.920.20-FF-000024', NULL, 'Dynein heavy chain', 340, NULL, NULL, 68048),
(68049, '3.40.390.10-FF-000153', NULL, NULL, 95, NULL, NULL, 68049),
(68050, '1.20.920.30-FF-000027', NULL, 'GM17107', 186, NULL, NULL, 68050),
(68051, '2.130.10.10-FF-001423', NULL, 'Damaged DNA binding protein', 316, NULL, NULL, 68051),
(68052, '1.20.120.1750-FF-000134', NULL, 'RBR-type E3 ubiquitin transferase', 71, NULL, NULL, 68052),
(68053, '2.130.10.10-FF-000496', NULL, 'LLGL2, scribble cell polarity complex component', 199, NULL, NULL, 68053),
(68054, '2.30.42.10-FF-000243', NULL, 'Uncharacterized protein', 103, NULL, NULL, 68054),
(68055, '3.40.50.150-FF-001070', NULL, 'Uncharacterized protein', 242, NULL, NULL, 68055),
(68056, '3.40.50.300-FF-001480', NULL, 'ABC transporter', 245, NULL, NULL, 68056),
(68057, '3.40.50.720-FF-002117', NULL, 'Uncharacterized protein', 115, NULL, NULL, 68057),
(68058, '3.30.200.20-FF-002348', NULL, 'Oncogene tyrosine protein kinase receptor', 52, NULL, NULL, 68058),
(68059, '1.20.900.10-FF-000132', NULL, 'Predicted protein', 232, NULL, NULL, 68059),
(68060, '2.160.20.10-FF-000271', NULL, 'Uncharacterized protein', 299, NULL, NULL, 68060),
(68061, '2.30.30.780-FF-000001', NULL, 'Dda DNA helicase', 131, NULL, NULL, 68061);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(68062, '2.60.40.10-FF-004677', NULL, NULL, 90, NULL, NULL, 68062),
(68063, '1.10.10.10-FF-000167', NULL, 'forkhead box protein N3 isoform X1', 100, NULL, NULL, 68063),
(68064, '3.30.160.60-FF-003800', NULL, NULL, 29, NULL, NULL, 68064),
(68065, '3.30.420.40-FF-000538', NULL, 'Actin-related protein 2', 161, NULL, NULL, 68065),
(68066, '1.10.10.60-FF-000485', NULL, 'Rhox homeobox family member 1', 83, NULL, NULL, 68066),
(68067, '3.30.720.210-FF-000022', NULL, 'ATP-dependent zinc metalloprotease FtsH', 90, NULL, NULL, 68067),
(68068, '3.40.718.10-FF-000050', NULL, 'Isocitrate dehydrogenase [NADP]', 407, NULL, NULL, 68068),
(68069, '1.10.238.10-FF-001067', NULL, 'Uncharacterized protein', 77, NULL, NULL, 68069),
(68070, '3.40.50.410-FF-000107', NULL, 'Putative ribonucleoprotein related-protein', 202, NULL, NULL, 68070),
(68071, '2.60.40.150-FF-000437', NULL, 'Phosphatidylinositol 3-kinase piki-1', 133, NULL, NULL, 68071),
(68072, '1.10.510.10-FF-002437', NULL, NULL, 208, NULL, NULL, 68072),
(68073, '2.40.50.180-FF-000008', NULL, 'Chemotaxis protein CheV', 75, NULL, NULL, 68073),
(68074, '2.40.10.10-FF-000528', NULL, NULL, 99, NULL, NULL, 68074),
(68075, '1.10.472.10-FF-000493', NULL, 'Cyclin puc1', 109, NULL, NULL, 68075),
(68076, '1.10.8.270-FF-000158', NULL, 'GTPase activating protein Gyp51', 103, NULL, NULL, 68076),
(68077, '2.60.120.20-FF-000017', NULL, 'Genome polyprotein', 246, NULL, NULL, 68077),
(68078, '2.60.120.10-FF-000104', NULL, 'Protein phosphatase 2C and cyclic nucleotide-binding/kinase domain-containing protein', 150, NULL, NULL, 68078),
(68079, '3.30.200.60-FF-000005', NULL, 'Ubiquitin thioesterase', 87, NULL, NULL, 68079),
(68080, '3.30.450.20-FF-000270', NULL, 'Sensor histidine kinase RcsC', 129, NULL, NULL, 68080),
(68081, '3.20.20.80-FF-000071', NULL, 'Imaginal disc growth factor', 313, NULL, NULL, 68081),
(68082, '3.30.420.40-FF-000780', NULL, 'Heat shock protein 70 putative', 50, NULL, NULL, 68082),
(68083, '3.20.20.80-FF-000323', NULL, 'Glucosylceramidase, putative', 199, NULL, NULL, 68083),
(68084, '3.30.450.40-FF-000276', NULL, 'Receptor-like histidine kinase BpdS', 149, NULL, NULL, 68084),
(68085, '1.20.1270.280-FF-000069', NULL, 'Uncharacterized protein', 121, NULL, NULL, 68085),
(68086, '4.10.520.10-FF-000026', NULL, NULL, 88, NULL, NULL, 68086),
(68087, '1.25.10.10-FF-002348', NULL, 'Uncharacterized protein', 286, NULL, NULL, 68087),
(68088, '1.20.1050.10-FF-000217', NULL, 'Uncharacterized protein', 112, NULL, NULL, 68088),
(68089, '2.130.10.10-FF-002750', NULL, 'Transducin-like enhancer of split 3 (E(Sp1) homolog, Drosophila)', 263, NULL, NULL, 68089),
(68090, '3.60.110.10-FF-000061', NULL, NULL, 78, NULL, NULL, 68090),
(68091, '2.60.40.10-FF-005043', NULL, NULL, 102, NULL, NULL, 68091),
(68092, '3.40.50.300-FF-001148', NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase DHX15/PRP43', 219, NULL, NULL, 68092),
(68093, '1.20.120.1240-FF-000054', NULL, 'Uncharacterized protein', 278, NULL, NULL, 68093),
(68094, '1.25.40.720-FF-000017', NULL, 'YALI0D22979p', 137, NULL, NULL, 68094),
(68095, '3.30.70.330-FF-000814', NULL, 'Polyadenylate-binding protein, putative', 81, NULL, NULL, 68095),
(68096, '3.30.70.20-FF-000067', NULL, 'Long irondependent hydrogenase, putative', 59, NULL, NULL, 68096),
(68097, '3.90.650.10-FF-000055', NULL, 'Uncharacterized protein', 216, NULL, NULL, 68097),
(68098, '3.30.160.60-FF-001237', NULL, 'zinc finger protein 660', 23, NULL, NULL, 68098),
(68099, '1.20.920.10-FF-000021', NULL, 'ATPase family AAA domain-containing protein 2', 136, NULL, NULL, 68099),
(68100, '2.70.160.11-FF-000050', NULL, 'Protein arginine N-methyltransferase', 177, NULL, NULL, 68100),
(68101, '3.40.50.150-FF-000794', NULL, 'Jasmonate O-methyltransferase, putative', 132, NULL, NULL, 68101),
(68102, '3.30.870.10-FF-000153', NULL, 'Uncharacterized protein', 160, NULL, NULL, 68102),
(68103, '1.20.1050.10-FF-000127', NULL, 'Os05g0148900 protein', 109, NULL, NULL, 68103),
(68104, '3.60.15.10-FF-000019', NULL, 'Hydroxyacylglutathione hydrolase, mitochondrial', 257, NULL, NULL, 68104);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(68105, '2.160.20.10-FF-000181', NULL, 'Cell surface protein', 234, NULL, NULL, 68105),
(68106, '1.10.10.60-FF-000794', NULL, NULL, 39, NULL, NULL, 68106),
(68107, '3.30.200.20-FF-002039', NULL, 'Serine/threonine-protein kinase srk1', 90, NULL, NULL, 68107),
(68108, '3.40.190.10-FF-000188', NULL, 'Ionotropic receptor 64a', 125, NULL, NULL, 68108),
(68109, '3.30.420.40-FF-000229', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', 155, NULL, NULL, 68109),
(68110, '3.20.20.100-FF-000103', NULL, 'Putative oxidoreductase', 313, NULL, NULL, 68110),
(68111, '2.70.170.10-FF-000038', NULL, 'Glutamate-gated chloride channel alpha', 214, NULL, NULL, 68111),
(68112, '3.40.50.720-FF-001864', NULL, 'Malate dehydrogenase', 99, NULL, NULL, 68112),
(68113, '3.40.50.150-FF-001322', NULL, NULL, 205, NULL, NULL, 68113),
(68114, '1.25.40.10-FF-002647', NULL, 'Small glutamine-rich tetratricopeptide repeat-containing protein alpha-like Protein', 118, NULL, NULL, 68114),
(68115, '3.30.420.10-FF-000310', NULL, 'Uncharacterized protein', 195, NULL, NULL, 68115),
(68116, '3.90.1150.10-FF-000437', NULL, 'RE16411p', 17, NULL, NULL, 68116),
(68117, '3.40.190.10-FF-000497', NULL, 'ABC transporter amino acid permease', 149, NULL, NULL, 68117),
(68118, '2.40.50.40-FF-000034', NULL, 'C-C motif chemokine', 77, NULL, NULL, 68118),
(68119, '2.30.29.30-FF-000156', NULL, 'PTB-containing, cubilin and LRP1-interacting protein', 148, NULL, NULL, 68119),
(68120, '2.60.40.10-FF-001333', NULL, 'collagen alpha-1(VII) chain isoform X2', 102, NULL, NULL, 68120),
(68121, '1.10.150.20-FF-000276', NULL, 'ERCC4 domain containing protein', 71, NULL, NULL, 68121),
(68122, '1.10.287.470-FF-000014', NULL, 'RND family efflux transporter, MFP subunit', 74, NULL, NULL, 68122),
(68123, '2.60.40.10-FF-001119', NULL, 'Immunoglobulin heavy variable 4-30-4', 122, NULL, NULL, 68123),
(68124, '3.40.50.300-FF-003632', NULL, 'ABC multidrug transporter (Eurofung)', 329, NULL, NULL, 68124),
(68125, '2.60.120.390-FF-000001', NULL, 'Olfactory marker protein', 162, NULL, NULL, 68125),
(68126, '1.20.1560.10-FF-000430', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 520, NULL, NULL, 68126),
(68127, '3.80.20.20-FF-000056', NULL, 'Fibronectin domain-containing protein', 166, NULL, NULL, 68127),
(68128, '1.25.40.620-FF-000004', NULL, 'Ycf53-like protein', 154, NULL, NULL, 68128),
(68129, '1.10.150.20-FF-000057', NULL, 'RAD2p Single-stranded DNA endonuclease', 67, NULL, NULL, 68129),
(68130, '3.90.550.50-FF-000144', NULL, 'Hexosyltransferase', 195, NULL, NULL, 68130),
(68131, '3.40.800.10-FF-000039', NULL, NULL, 297, NULL, NULL, 68131),
(68132, '2.40.70.10-FF-000498', NULL, NULL, 117, NULL, NULL, 68132),
(68133, '1.20.1070.10-FF-001399', NULL, 'Uncharacterized protein', 239, NULL, NULL, 68133),
(68134, '2.60.40.1400-FF-000017', NULL, NULL, 126, NULL, NULL, 68134),
(68135, '1.25.40.10-FF-002518', NULL, 'GM14768', 173, NULL, NULL, 68135),
(68136, '3.40.50.12780-FF-000152', NULL, 'NRPS-like enzyme, putative (JCVI)', 358, NULL, NULL, 68136),
(68137, '2.60.40.10-FF-005402', NULL, NULL, 44, NULL, NULL, 68137),
(68138, '1.20.1250.20-FF-002231', NULL, 'Transporter, putative', 125, NULL, NULL, 68138),
(68139, '1.20.20.10-FF-000009', NULL, 'ATP synthase subunit 9, mitochondrial', 73, NULL, NULL, 68139),
(68140, '3.30.420.40-FF-000869', NULL, 'Uncharacterized protein', 76, NULL, NULL, 68140),
(68141, '1.20.5.260-FF-000001', NULL, 'Cytochrome b-c1 complex subunit 9', 60, NULL, NULL, 68141),
(68142, '1.25.40.630-FF-000007', NULL, NULL, 101, NULL, NULL, 68142),
(68143, '3.80.10.10-FF-002800', NULL, 'Toll-like receptor 4a', 162, NULL, NULL, 68143),
(68144, '1.10.1200.10-FF-000001', NULL, 'Acyl carrier protein', 78, NULL, NULL, 68144),
(68145, '3.90.1560.10-FF-000002', NULL, '2-phosphosulfolactate phosphatase, putative', 224, NULL, NULL, 68145),
(68146, '1.10.10.10-FF-001330', NULL, 'Heme response regulator HssR', 92, NULL, NULL, 68146),
(68147, '2.60.40.2950-FF-000004', NULL, 'Thioester-containing protein 3', 90, NULL, NULL, 68147),
(68148, '3.30.2130.30-FF-000001', NULL, 'Ribosomal RNA large subunit methyltransferase K/L', 186, NULL, NULL, 68148);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(68149, '1.20.5.270-FF-000004', NULL, 'Cytochrome b-c1 complex subunit Rieske, mitochondrial', 56, NULL, NULL, 68149),
(68150, '3.30.70.330-FF-001995', NULL, NULL, 134, NULL, NULL, 68150),
(68151, '3.40.50.1000-FF-000587', NULL, NULL, 155, NULL, NULL, 68151),
(68152, '3.30.200.20-FF-000235', NULL, 'serine/threonine-protein kinase STK11', 98, NULL, NULL, 68152),
(68153, '1.25.40.180-FF-000153', NULL, 'Uncharacterized protein', 174, NULL, NULL, 68153),
(68154, '1.25.40.770-FF-000021', NULL, 'Uncharacterized protein', 138, NULL, NULL, 68154),
(68155, '1.25.10.10-FF-000881', NULL, 'Uncharacterized protein', 263, NULL, NULL, 68155),
(68156, '3.40.50.720-FF-001639', NULL, 'Uncharacterized protein', 319, NULL, NULL, 68156),
(68157, '3.30.70.1400-FF-000013', NULL, 'Pyruvate Dehydrogenase Phosphatase Regulatory subunit', 111, NULL, NULL, 68157),
(68158, '3.30.40.10-FF-002046', NULL, 'putative E3 ubiquitin-protein ligase RING1a', 93, NULL, NULL, 68158),
(68159, '3.40.50.880-FF-000136', NULL, 'Cobyric acid synthase', 170, NULL, NULL, 68159),
(68160, '3.30.1520.10-FF-000047', NULL, 'Sorting nexin', 147, NULL, NULL, 68160),
(68161, '3.30.70.330-FF-002607', NULL, NULL, 131, NULL, NULL, 68161),
(68162, '3.40.50.720-FF-000442', NULL, 'NAD-dependent dehydratase', 319, NULL, NULL, 68162),
(68163, '3.90.550.50-FF-000239', NULL, 'Predicted protein', 208, NULL, NULL, 68163),
(68164, '1.10.490.10-FF-000012', NULL, 'Flavohemoprotein', 136, NULL, NULL, 68164),
(68165, '3.40.50.300-FF-001603', NULL, 'GPN-loop GTPase', 174, NULL, NULL, 68165),
(68166, '3.20.180.10-FF-000001', NULL, 'Glutamyl-tRNA reductase-binding protein chloroplastic', 113, NULL, NULL, 68166),
(68167, '3.10.20.90-FF-000754', NULL, 'Predicted protein', 94, NULL, NULL, 68167),
(68168, '3.30.830.10-FF-000263', NULL, 'Uncharacterized protein', 22, NULL, NULL, 68168),
(68169, '1.10.10.10-FF-000599', NULL, 'Crp family transcriptional regulator', 64, NULL, NULL, 68169),
(68170, '3.90.1100.10-FF-000047', NULL, 'DNA-directed RNA polymerase subunit beta', 100, NULL, NULL, 68170),
(68171, '2.30.29.30-FF-001359', NULL, 'Uncharacterized protein', 132, NULL, NULL, 68171),
(68172, '3.90.70.200-FF-000021', NULL, 'Chromosome 19, whole genome shotgun sequence', 145, NULL, NULL, 68172),
(68173, '1.10.472.10-FF-000627', NULL, 'Uncharacterized protein', 122, NULL, NULL, 68173),
(68174, '2.40.10.10-FF-000394', NULL, NULL, 124, NULL, NULL, 68174),
(68175, '3.40.50.80-FF-000077', NULL, 'Putative nitrate reductase', 149, NULL, NULL, 68175),
(68176, '3.30.56.10-FF-000019', NULL, 'Phenylalanine--tRNA ligase beta subunit', 63, NULL, NULL, 68176),
(68177, '3.30.200.20-FF-000561', NULL, 'Calcium/calmodulin-dependent protein kinase type 1D', 69, NULL, NULL, 68177),
(68178, '3.30.70.2510-FF-000003', NULL, NULL, 123, NULL, NULL, 68178),
(68179, '3.40.50.620-FF-000300', NULL, 'Electron transfer flavoprotein alpha subunit', 165, NULL, NULL, 68179),
(68180, '2.130.10.10-FF-003340', NULL, 'Protein tipD', 84, NULL, NULL, 68180),
(68181, '3.30.230.10-FF-000060', NULL, '30S ribosomal protein S9', 131, NULL, NULL, 68181),
(68182, '3.30.70.580-FF-000058', NULL, 'Pseudouridine synthase', 84, NULL, NULL, 68182),
(68183, '1.20.1730.10-FF-000016', NULL, 'Sodium symporter family protein', 495, NULL, NULL, 68183),
(68184, '3.20.20.20-FF-000002', NULL, 'Methionine synthase', 296, NULL, NULL, 68184),
(68185, '2.120.10.80-FF-000326', NULL, 'Adagio protein 2', 142, NULL, NULL, 68185),
(68186, '2.60.120.260-FF-000316', NULL, 'Beta-galactosidase', 208, NULL, NULL, 68186),
(68187, '3.40.50.300-FF-007005', NULL, 'Uncharacterized protein', 209, NULL, NULL, 68187),
(68188, '3.30.160.60-FF-000956', NULL, 'DNA polymerase kappa', 31, NULL, NULL, 68188),
(68189, '1.25.40.10-FF-000383', NULL, 'Rna polymerase-associated protein ctr9', 186, NULL, NULL, 68189),
(68190, '3.20.20.30-FF-000005', NULL, '5,10-methylene tetrahydromethanopterin reductase', 342, NULL, NULL, 68190),
(68191, '3.40.50.12280-FF-000013', NULL, 'YALI0F06050p', 130, NULL, NULL, 68191),
(68192, '3.30.70.3490-FF-000033', NULL, NULL, 88, NULL, NULL, 68192);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(68193, '3.40.50.300-FF-008528', NULL, 'Uncharacterized protein', 185, NULL, NULL, 68193),
(68194, '3.40.50.300-FF-004829', NULL, 'Protein CHROMATIN REMODELING 24', 329, NULL, NULL, 68194),
(68195, '3.40.50.2000-FF-000106', NULL, 'Lipopolysaccharide heptosyltransferase 1', 155, NULL, NULL, 68195),
(68196, '3.30.920.10-FF-000011', NULL, 'Frataxin, mitochondrial', 120, NULL, NULL, 68196),
(68197, '2.30.30.40-FF-000589', NULL, 'CD2-associated protein like', 29, NULL, NULL, 68197),
(68198, '3.10.20.90-FF-000849', NULL, 'Uncharacterized protein', 82, NULL, NULL, 68198),
(68199, '2.60.120.10-FF-000796', NULL, 'Uncharacterized protein', 137, NULL, NULL, 68199),
(68200, '1.20.58.760-FF-000038', NULL, 'Uncharacterized protein', 169, NULL, NULL, 68200),
(68201, '1.20.5.190-FF-000183', NULL, NULL, 52, NULL, NULL, 68201),
(68202, '1.20.58.60-FF-000403', NULL, 'Uncharacterized protein', 114, NULL, NULL, 68202),
(68203, '2.10.109.10-FF-000022', NULL, 'Signal peptidase I', 131, NULL, NULL, 68203),
(68204, '1.25.40.10-FF-003024', NULL, 'Pentatricopeptide repeat-containing protein At5g10690', 108, NULL, NULL, 68204),
(68205, '3.30.160.60-FF-006358', NULL, NULL, 42, NULL, NULL, 68205),
(68206, '1.10.10.10-FF-000824', NULL, 'RNA polymerase sigma factor', 71, NULL, NULL, 68206),
(68207, '3.80.10.10-FF-002121', NULL, 'Uncharacterized protein', 92, NULL, NULL, 68207),
(68208, '3.30.430.20-FF-000044', NULL, 'CRK1', 106, NULL, NULL, 68208),
(68209, '3.10.450.40-FF-000027', NULL, 'Primary amine oxidase', 106, NULL, NULL, 68209),
(68210, '3.30.70.330-FF-000904', NULL, 'RNA-binding protein RBP6, putative', 118, NULL, NULL, 68210),
(68211, '3.30.420.40-FF-000448', NULL, 'GM21720', 157, NULL, NULL, 68211),
(68212, '1.10.274.60-FF-000002', NULL, 'Minor ampullate spidroin', 130, NULL, NULL, 68212),
(68213, '3.40.850.10-FF-000076', NULL, 'MYH7', 39, NULL, NULL, 68213),
(68214, '3.40.50.720-FF-001965', NULL, 'Predicted protein', 256, NULL, NULL, 68214),
(68215, '3.90.1150.10-FF-000421', NULL, 'Ornithine aminotransferase', 97, NULL, NULL, 68215),
(68216, '3.40.50.12230-FF-000010', NULL, 'Methionyl-tRNA formyltransferase', 300, NULL, NULL, 68216),
(68217, '3.10.129.10-FF-000132', NULL, 'PaaI family thioesterase', 125, NULL, NULL, 68217),
(68218, '2.170.130.10-FF-000039', NULL, 'Colicin I receptor', 132, NULL, NULL, 68218),
(68219, '3.90.70.10-FF-000483', NULL, 'Cathepsin l-like protease', 291, NULL, NULL, 68219),
(68220, '3.40.50.1820-FF-000602', NULL, 'Carboxylic ester hydrolase', 362, NULL, NULL, 68220),
(68221, '3.80.10.10-FF-004150', NULL, 'Uncharacterized protein', 106, NULL, NULL, 68221),
(68222, '1.25.10.10-FF-000667', NULL, 'AP-3 complex subunit delta', 619, NULL, NULL, 68222),
(68223, '3.90.190.20-FF-000051', NULL, 'Tetrahydrofolylpolyglutamate synthase, putative', 104, NULL, NULL, 68223),
(68224, '3.40.718.10-FF-000044', NULL, 'Peroxisomal isocitrate dehydrogenase [NADP]', 95, NULL, NULL, 68224),
(68225, '3.40.50.300-FF-002694', NULL, 'HAlF transporter (PGP related)', 149, NULL, NULL, 68225),
(68226, '2.130.10.10-FF-004537', NULL, 'Uncharacterized protein', 225, NULL, NULL, 68226),
(68227, '2.40.30.10-FF-000294', NULL, 'GTP-binding protein 2', 66, NULL, NULL, 68227),
(68228, '3.40.50.150-FF-000917', NULL, NULL, 144, NULL, NULL, 68228),
(68229, '1.10.510.10-FF-002858', NULL, NULL, 141, NULL, NULL, 68229),
(68230, '3.40.50.300-FF-004476', NULL, 'Protein CBR-RAB-21', 63, NULL, NULL, 68230),
(68231, '1.25.10.10-FF-000555', NULL, 'RING-type E3 ubiquitin transferase', 112, NULL, NULL, 68231),
(68232, '2.10.25.10-FF-001648', NULL, 'Neurocan b', 74, NULL, NULL, 68232),
(68233, '1.10.730.10-FF-000048', NULL, 'Arginine--tRNA ligase, putative', 139, NULL, NULL, 68233),
(68234, '2.30.29.30-FF-000050', NULL, 'Vav guanine nucleotide exchange factor 2', 129, NULL, NULL, 68234),
(68235, '1.25.10.10-FF-001061', NULL, 'Deoxyhypusine hydroxylase', 151, NULL, NULL, 68235),
(68236, '2.40.70.10-FF-000414', NULL, NULL, 91, NULL, NULL, 68236),
(68237, '1.10.238.10-FF-001314', NULL, 'Solute carrier family 25 member 24', 45, NULL, NULL, 68237);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(68238, '2.130.10.10-FF-002525', NULL, 'Polyubiquitin binding protein, putative', 236, NULL, NULL, 68238),
(68239, '1.20.144.10-FF-000088', NULL, 'Uncharacterized protein', 187, NULL, NULL, 68239),
(68240, '1.10.1450.10-FF-000048', NULL, 'Tetraspanin', 81, NULL, NULL, 68240),
(68241, '2.40.50.120-FF-000002', NULL, 'netrin-4 isoform X1', 127, NULL, NULL, 68241),
(68242, '3.50.50.60-FF-000464', NULL, 'Protein MTO1 homolog, mitochondrial', 221, NULL, NULL, 68242),
(68243, '1.10.1060.10-FF-000012', NULL, 'Glycolate oxidase iron-sulfur subunit', 109, NULL, NULL, 68243),
(68244, '3.40.50.2000-FF-000095', NULL, 'Glycosyltransferase', 243, NULL, NULL, 68244),
(68245, '3.40.570.10-FF-000043', NULL, 'Uncharacterized protein', 128, NULL, NULL, 68245),
(68246, '1.10.10.60-FF-000474', NULL, 'Blast:Protein gooseberry-neuro', 80, NULL, NULL, 68246),
(68247, '1.10.238.10-FF-000825', NULL, 'Mitochondrial calcium uptake 1', 55, NULL, NULL, 68247),
(68248, '2.60.120.650-FF-000231', NULL, 'Uncharacterized protein', 159, NULL, NULL, 68248),
(68249, '2.130.10.10-FF-003126', NULL, 'Membrane glycoprotein spo14, putative', 252, NULL, NULL, 68249),
(68250, '2.60.220.50-FF-000051', NULL, 'Adhesion G protein-coupled receptor G1', 82, NULL, NULL, 68250),
(68251, '2.60.40.10-FF-002547', NULL, 'Cell surface glycoprotein CD200 receptor 1-A', 85, NULL, NULL, 68251),
(68252, '3.40.190.10-FF-000059', NULL, 'LysR family transcriptional regulator', 79, NULL, NULL, 68252),
(68253, '2.130.10.10-FF-003014', NULL, 'PWP2, small subunit processome component', 171, NULL, NULL, 68253),
(68254, '3.40.640.10-FF-000055', NULL, 'Alanine--glyoxylate aminotransferase 2, mitochondrial', 282, NULL, NULL, 68254),
(68255, '3.40.630.30-FF-000200', NULL, 'N-alpha-acetyltransferase', 166, NULL, NULL, 68255),
(68256, '1.25.40.10-FF-004873', NULL, 'Uncharacterized protein', 109, NULL, NULL, 68256),
(68257, '3.40.50.2300-FF-000078', NULL, 'D-xylose ABC transporter substrate-binding protein', 155, NULL, NULL, 68257),
(68258, '2.10.110.10-FF-000093', NULL, 'prickle-like protein 4 isoform X3', 69, NULL, NULL, 68258),
(68259, '3.40.50.300-FF-002789', NULL, 'DEAD-box ATP-dependent RNA helicase 22', 184, NULL, NULL, 68259),
(68260, '1.20.58.60-FF-000050', NULL, 'Short stop, isoform N', 117, NULL, NULL, 68260),
(68261, '1.25.40.10-FF-000169', NULL, 'tetratricopeptide repeat protein 8 isoform X1', 154, NULL, NULL, 68261),
(68262, '2.60.40.10-FF-002968', NULL, 'GP63-like', 84, NULL, NULL, 68262),
(68263, '3.40.225.10-FF-000034', NULL, NULL, 215, NULL, NULL, 68263),
(68264, '3.90.1150.10-FF-000084', NULL, 'Phosphoserine aminotransferase', 99, NULL, NULL, 68264),
(68265, '3.90.1150.10-FF-000196', NULL, 'Aminotransferase', 143, NULL, NULL, 68265),
(68266, '1.10.420.10-FF-000064', NULL, 'Catalase/peroxidase', 135, NULL, NULL, 68266),
(68267, '2.60.40.10-FF-001350', NULL, 'titin isoform X1', 94, NULL, NULL, 68267),
(68268, '3.40.190.10-FF-000738', NULL, 'Transcriptional regulatory protein', 102, NULL, NULL, 68268),
(68269, '2.60.40.10-FF-002761', NULL, NULL, 91, NULL, NULL, 68269),
(68270, '2.40.70.10-FF-000509', NULL, NULL, 91, NULL, NULL, 68270),
(68271, '3.20.180.20-FF-000004', NULL, 'Dynein axonemal heavy chain 6', 115, NULL, NULL, 68271),
(68272, '1.10.3430.10-FF-000053', NULL, 'Uncharacterized protein', 247, NULL, NULL, 68272),
(68273, '3.60.15.10-FF-000250', NULL, 'Predicted protein', 288, NULL, NULL, 68273),
(68274, '3.40.50.300-FF-007117', NULL, 'Probable thymidylate kinase', 185, NULL, NULL, 68274),
(68275, '3.30.70.270-FF-000072', NULL, 'DNA polymerase IV', 110, NULL, NULL, 68275),
(68276, '3.30.160.60-FF-003132', NULL, 'Uncharacterized protein', 28, NULL, NULL, 68276),
(68277, '3.20.20.100-FF-000075', NULL, 'GD18440', 194, NULL, NULL, 68277),
(68278, '2.60.120.200-FF-000231', NULL, 'Eyes shut homolog', 189, NULL, NULL, 68278),
(68279, '1.20.58.60-FF-000515', NULL, 'Spectrin repeat containing, nuclear envelope 1a', 290, NULL, NULL, 68279),
(68280, '2.40.30.10-FF-000389', NULL, 'Probable translation initiation factor IF-2', 122, NULL, NULL, 68280),
(68281, '2.30.29.30-FF-000515', NULL, 'AT4g11790/T5C23_220', 239, NULL, NULL, 68281);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(68282, '3.40.50.1240-FF-000075', NULL, 'Blast:Lysosomal acid phosphatase', 353, NULL, NULL, 68282),
(68283, '3.30.50.10-FF-000203', NULL, 'Nuclear receptor subfamily 1 group I member 3', 45, NULL, NULL, 68283),
(68284, '3.75.10.10-FF-000003', NULL, 'Protein-arginine deiminase type-2', 371, NULL, NULL, 68284),
(68285, '1.10.510.10-FF-002763', NULL, NULL, 91, NULL, NULL, 68285),
(68286, '1.10.100.10-FF-000017', NULL, NULL, 65, NULL, NULL, 68286),
(68287, '3.30.497.10-FF-000184', NULL, 'Uncharacterized protein', 104, NULL, NULL, 68287),
(68288, '1.25.10.10-FF-002921', NULL, 'Uncharacterized protein', 105, NULL, NULL, 68288),
(68289, '3.40.190.10-FF-000952', NULL, '4-phytase', 120, NULL, NULL, 68289),
(68290, '3.90.190.10-FF-000143', NULL, 'Inositol_hexakisphosphate', 233, NULL, NULL, 68290),
(68291, '2.30.30.40-FF-000477', NULL, 'Scaffold protein CheW associated with MCPs of classes 40H and 40+24H', 57, NULL, NULL, 68291),
(68292, '3.30.200.20-FF-002359', NULL, 'Uncharacterized protein', 34, NULL, NULL, 68292),
(68293, '3.30.450.20-FF-000039', NULL, 'Phytochrome', 133, NULL, NULL, 68293),
(68294, '3.90.180.10-FF-000103', NULL, 'IMP dehydrogenase', 195, NULL, NULL, 68294),
(68295, '1.10.486.10-FF-000002', NULL, 'ATP-dependent DNA helicase Rep', 168, NULL, NULL, 68295),
(68296, '1.25.40.80-FF-000021', NULL, 'DNA photolyase, putative', 204, NULL, NULL, 68296),
(68297, '1.25.10.10-FF-003410', NULL, 'Protein Mo25', 44, NULL, NULL, 68297),
(68298, '2.10.110.10-FF-000188', NULL, 'PDZ and LIM domain protein Zasp-like Protein', 59, NULL, NULL, 68298),
(68299, '2.130.10.10-FF-000485', NULL, 'Putative WD repeat-containing protein C17D11.16', 143, NULL, NULL, 68299),
(68300, '1.10.8.60-FF-000141', NULL, 'AAA family ATPase, CDC48 subfamily', 80, NULL, NULL, 68300),
(68301, '1.25.40.90-FF-000024', NULL, 'Calcium homeostasis endoplasmic reticulum protein', 145, NULL, NULL, 68301),
(68302, '3.40.50.1580-FF-000058', NULL, 'Purine nucleoside phosphorylase', 243, NULL, NULL, 68302),
(68303, '3.40.50.720-FF-001853', NULL, 'Uncharacterized protein', 81, NULL, NULL, 68303),
(68304, '2.120.10.30-FF-000570', NULL, 'Uncharacterized protein', 43, NULL, NULL, 68304),
(68305, '3.40.50.150-FF-001311', NULL, NULL, 210, NULL, NULL, 68305),
(68306, '2.20.70.10-FF-000224', NULL, 'E3 ubiquitin-protein ligase', 75, NULL, NULL, 68306),
(68307, '1.25.40.610-FF-000001', NULL, 'Adhesion G protein-coupled receptor L2', 106, NULL, NULL, 68307),
(68308, '2.40.50.430-FF-000005', NULL, 'DNA polymerase delta small subunit, putative', 123, NULL, NULL, 68308),
(68309, '1.10.2020.20-FF-000018', NULL, NULL, 115, NULL, NULL, 68309),
(68310, '3.40.640.10-FF-000504', NULL, 'Uncharacterized protein', 75, NULL, NULL, 68310),
(68311, '3.30.70.141-FF-000045', NULL, NULL, 96, NULL, NULL, 68311),
(68312, '3.30.50.10-FF-000192', NULL, 'C2C2-GATA transcription factor', 86, NULL, NULL, 68312),
(68313, '1.10.150.20-FF-000169', NULL, 'DNA repair protein Rad1 homologue, putative', 66, NULL, NULL, 68313),
(68314, '3.40.50.300-FF-003520', NULL, 'Helicase putative', 281, NULL, NULL, 68314),
(68315, '3.40.50.1820-FF-001788', NULL, 'Uncharacterized protein', 357, NULL, NULL, 68315),
(68316, '1.10.260.170-FF-000006', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', 78, NULL, NULL, 68316),
(68317, '1.20.1250.20-FF-002343', NULL, 'Uncharacterized protein', 92, NULL, NULL, 68317),
(68318, '2.60.120.780-FF-000011', NULL, 'E3 SUMO-protein ligase PIAS2', 156, NULL, NULL, 68318),
(68319, '2.60.98.20-FF-000002', NULL, 'Flagellar hook protein FlgE', 139, NULL, NULL, 68319),
(68320, '1.20.58.1520-FF-000006', NULL, 'Microtubule_associated_protein_(MAP65/ASE1_family )_-_putative', 76, NULL, NULL, 68320),
(68321, '3.40.50.300-FF-001620', NULL, 'Peroxisome biogenesis protein 1', 196, NULL, NULL, 68321),
(68322, '2.130.10.10-FF-002851', NULL, 'Uncharacterized protein', 422, NULL, NULL, 68322),
(68323, '1.20.1530.20-FF-000038', NULL, 'Glutathione-regulated potassium-efflux system protein KefKL', 383, NULL, NULL, 68323),
(68324, '1.10.287.1490-FF-000097', NULL, 'Elastin microfibril interfacer 3', 212, NULL, NULL, 68324);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(68325, '2.60.40.770-FF-000027', NULL, 'Uncharacterized protein', 47, NULL, NULL, 68325),
(68326, '2.30.30.30-FF-000148', NULL, 'Mitochondrial ribosomal protein L24', 85, NULL, NULL, 68326),
(68327, '3.40.50.300-FF-008545', NULL, 'Mitochondrial GTPase 1', 195, NULL, NULL, 68327),
(68328, '1.25.40.470-FF-000021', NULL, 'Intraflagellar transport protein osm-1', 168, NULL, NULL, 68328),
(68329, '1.10.510.10-FF-002196', NULL, 'Sulfhydryl oxidase', 199, NULL, NULL, 68329),
(68330, '1.20.142.10-FF-000022', NULL, 'Poly [ADP-ribose] polymerase', 65, NULL, NULL, 68330),
(68331, '1.20.1510.10-FF-000040', NULL, 'Blast:Zinc transporter 2', 166, NULL, NULL, 68331),
(68332, '2.60.120.290-FF-000201', NULL, 'Uncharacterized protein', 133, NULL, NULL, 68332),
(68333, '1.25.40.10-FF-000736', NULL, 'Zinc finger C3H1-type containing', 187, NULL, NULL, 68333),
(68334, '3.40.50.1000-FF-000699', NULL, NULL, 118, NULL, NULL, 68334),
(68335, '1.20.120.350-FF-000269', NULL, NULL, 96, NULL, NULL, 68335),
(68336, '3.30.200.20-FF-000347', NULL, 'serine/threonine-protein kinase 32A isoform X2', 94, NULL, NULL, 68336),
(68337, '2.40.128.620-FF-000006', NULL, 'Lipoprotein receptor', 57, NULL, NULL, 68337),
(68338, '3.30.160.60-FF-001445', NULL, 'Zinc finger protein 142', 59, NULL, NULL, 68338),
(68339, '3.40.50.2000-FF-000123', NULL, 'D-inositol-3-phosphate glycosyltransferase', 214, NULL, NULL, 68339),
(68340, '1.25.40.10-FF-001012', NULL, 'Protein RMD9, mitochondrial', 171, NULL, NULL, 68340),
(68341, '1.25.40.20-FF-001015', NULL, 'Ankyrin repeat family protein', 293, NULL, NULL, 68341),
(68342, '3.80.10.10-FF-000434', NULL, 'Relaxin family peptide receptor 1', 157, NULL, NULL, 68342),
(68343, '4.10.1000.10-FF-000017', NULL, 'Cleavage and polyadenylation specificity factor 30 kDa subunit', 62, NULL, NULL, 68343),
(68344, '3.90.640.10-FF-000234', NULL, 'ALP3', 44, NULL, NULL, 68344),
(68345, '2.10.25.10-FF-000108', NULL, 'Fibulin-1', 41, NULL, NULL, 68345),
(68346, '2.40.128.630-FF-000009', NULL, 'Cell surface protein', 114, NULL, NULL, 68346),
(68347, '2.60.40.10-FF-003036', NULL, 'Uncharacterized protein', 115, NULL, NULL, 68347),
(68348, '3.30.40.10-FF-002158', NULL, 'Structure-specific endonuclease subunit SLX1 homolog', 73, NULL, NULL, 68348),
(68349, '2.130.10.10-FF-002497', NULL, 'Uncharacterized protein', 143, NULL, NULL, 68349),
(68350, '2.70.98.10-FF-000038', NULL, 'Carbohydrate-binding protein', 305, NULL, NULL, 68350),
(68351, '2.10.110.10-FF-000104', NULL, 'Ras association domain-containing protein 2', 74, NULL, NULL, 68351),
(68352, '1.25.40.20-FF-000739', NULL, 'Ankyrin repeat domain 50', 65, NULL, NULL, 68352),
(68353, '3.40.50.1000-FF-000475', NULL, NULL, 124, NULL, NULL, 68353),
(68354, '1.20.1070.10-FF-001871', NULL, 'Uncharacterized protein', 294, NULL, NULL, 68354),
(68355, '2.60.120.260-FF-000193', NULL, 'Hemolectin, isoform A', 156, NULL, NULL, 68355),
(68356, '3.80.10.10-FF-001295', NULL, 'Malignant fibrous histiocytoma-amplified sequence 1 homolog', 94, NULL, NULL, 68356),
(68357, '1.10.150.240-FF-000093', NULL, 'HAD-superfamily hydrolase, subfamily IA, variant 3', 64, NULL, NULL, 68357),
(68358, '2.60.40.10-FF-000395', NULL, 'Protein tyrosine kinase 7 (inactive)', 100, NULL, NULL, 68358),
(68359, '1.20.58.2240-FF-000003', NULL, 'MPA43p protein', 151, NULL, NULL, 68359),
(68360, '3.10.100.10-FF-000375', NULL, NULL, 139, NULL, NULL, 68360),
(68361, '3.90.1520.10-FF-000005', NULL, 'Soluble guanylate cyclase gcy-36', 199, NULL, NULL, 68361),
(68362, '3.30.160.60-FF-002968', NULL, 'Uncharacterized protein', 30, NULL, NULL, 68362),
(68363, '1.10.3720.10-FF-000058', NULL, 'D,D-dipeptide ABC transporter permease', 204, NULL, NULL, 68363),
(68364, '2.40.50.40-FF-000039', NULL, 'RE36324p', 70, NULL, NULL, 68364),
(68365, '3.90.1600.10-FF-000057', NULL, 'Predicted protein', 149, NULL, NULL, 68365),
(68366, '1.10.418.10-FF-000244', NULL, 'Uncharacterized protein', 164, NULL, NULL, 68366),
(68367, '3.30.40.10-FF-002260', NULL, 'PHD finger protein, putative', 56, NULL, NULL, 68367),
(68368, '3.20.20.80-FF-000531', NULL, 'Blood-group-substance endo-1,4-beta-galactosidase', 363, NULL, NULL, 68368); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(68369, '1.20.1070.10-FF-002028', NULL, 'Uncharacterized protein', 121, NULL, NULL, 68369),
(68370, '3.90.226.10-FF-000093', NULL, 'Biotin carboxylase subunit of acetyl CoA carboxylase', 191, NULL, NULL, 68370),
(68371, '1.25.40.10-FF-004435', NULL, 'Slr2048 protein', 121, NULL, NULL, 68371),
(68372, '2.40.70.10-FF-000291', NULL, NULL, 55, NULL, NULL, 68372),
(68373, '3.50.50.60-FF-000913', NULL, 'Amine oxidase-like protein', 442, NULL, NULL, 68373),
(68374, '1.25.40.10-FF-002535', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 132, NULL, NULL, 68374),
(68375, '3.30.70.330-FF-002484', NULL, NULL, 77, NULL, NULL, 68375),
(68376, '2.40.30.10-FF-000277', NULL, 'Elongation factor 1-alpha', 107, NULL, NULL, 68376),
(68377, '2.30.29.30-FF-000403', NULL, 'Unplaced genomic scaffold supercont1.125, whole genome shotgun sequence', 121, NULL, NULL, 68377),
(68378, '3.40.30.10-FF-000100', NULL, 'Glutathione S-transferase Z1', 85, NULL, NULL, 68378),
(68379, '1.25.10.10-FF-002696', NULL, 'Uncharacterized protein', 65, NULL, NULL, 68379),
(68380, '3.30.200.20-FF-002247', NULL, 'Uncharacterized protein', 29, NULL, NULL, 68380),
(68381, '1.25.10.10-FF-001510', NULL, 'Condensin-2 complex subunit', 431, NULL, NULL, 68381),
(68382, '3.30.780.10-FF-000022', NULL, 'Mitochondrial ribosomal protein L49', 55, NULL, NULL, 68382),
(68383, '2.70.170.10-FF-000139', NULL, 'Nicotinic acetylcholine receptor a10 subunit splice variant', 216, NULL, NULL, 68383),
(68384, '1.10.1240.20-FF-000001', NULL, 'Soluble lytic murein transglycosylase', 70, NULL, NULL, 68384),
(68385, '1.10.1420.10-FF-000097', NULL, 'DNA mismatch repair protein MutS', 243, NULL, NULL, 68385),
(68386, '2.60.260.20-FF-000180', NULL, 'Uncharacterized protein', 47, NULL, NULL, 68386),
(68387, '3.60.10.10-FF-000261', NULL, 'Uncharacterized protein', 210, NULL, NULL, 68387),
(68388, '3.90.550.10-FF-000486', NULL, 'Glycosyl transferase family 2', 183, NULL, NULL, 68388),
(68389, '3.30.420.40-FF-000662', NULL, 'Phosphotransferase', 170, NULL, NULL, 68389),
(68390, '2.60.40.150-FF-000297', NULL, 'YOR296W', 132, NULL, NULL, 68390),
(68391, '2.130.10.10-FF-004751', NULL, 'Uncharacterized protein', 328, NULL, NULL, 68391),
(68392, '1.10.2000.10-FF-000003', NULL, 'Frizzled class receptor 2', 126, NULL, NULL, 68392),
(68393, '2.10.110.10-FF-000076', NULL, 'Zyxin', 63, NULL, NULL, 68393),
(68394, '3.100.10.10-FF-000061', NULL, NULL, 68, NULL, NULL, 68394),
(68395, '3.40.50.620-FF-000058', NULL, 'Mitochondrial arginyl-tRNA synthetase', 336, NULL, NULL, 68395),
(68396, '2.130.10.10-FF-000597', NULL, 'Guanine nucleotide-exchange factor SEC12', 340, NULL, NULL, 68396),
(68397, '1.10.1240.40-FF-000007', NULL, 'Uncharacterized protein', 93, NULL, NULL, 68397),
(68398, '3.40.50.2300-FF-000095', NULL, 'Positive transcription regulator evgA', 131, NULL, NULL, 68398),
(68399, '1.10.510.10-FF-000397', NULL, 'Serine/threonine-protein kinase KIN4', 327, NULL, NULL, 68399),
(68400, '3.30.70.330-FF-002821', NULL, NULL, 144, NULL, NULL, 68400),
(68401, '3.40.50.880-FF-000119', NULL, 'Glutamine amidotransferase', 209, NULL, NULL, 68401),
(68402, '3.40.50.150-FF-001423', NULL, NULL, 154, NULL, NULL, 68402),
(68403, '2.60.40.10-FF-004559', NULL, NULL, 106, NULL, NULL, 68403),
(68404, '3.40.30.10-FF-000797', NULL, 'Uncharacterized protein', 54, NULL, NULL, 68404),
(68405, '3.30.160.60-FF-003244', NULL, 'Uncharacterized protein, isoform A', 86, NULL, NULL, 68405),
(68406, '2.30.42.10-FF-000029', NULL, 'tight junction protein ZO-1 isoform X1', 101, NULL, NULL, 68406),
(68407, '3.10.20.870-FF-000010', NULL, NULL, 85, NULL, NULL, 68407),
(68408, '1.20.1310.10-FF-000058', NULL, 'Anaphase-promoting complex subunit', 98, NULL, NULL, 68408),
(68409, '2.60.40.60-FF-001011', NULL, 'Uncharacterized protein', 100, NULL, NULL, 68409),
(68410, '3.40.190.10-FF-000531', NULL, 'ABC-type phosphate transport system, periplasmic component', 124, NULL, NULL, 68410),
(68411, '3.30.70.330-FF-000360', NULL, 'RNA-binding motif protein 15B', 87, NULL, NULL, 68411),
(68412, '3.40.50.10490-FF-000010', NULL, '40S ribosomal protein S0', 207, NULL, NULL, 68412);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(68413, '3.30.750.24-FF-000067', NULL, 'Sulfate permease family protein 3', 141, NULL, NULL, 68413),
(68414, '3.40.190.10-FF-000289', NULL, 'Ionotropic receptor 10a', 133, NULL, NULL, 68414),
(68415, '2.130.10.10-FF-004649', NULL, 'Uncharacterized protein', 191, NULL, NULL, 68415),
(68416, '4.10.60.10-FF-000135', NULL, 'Putative poly-zinc finger protein 2', 25, NULL, NULL, 68416),
(68417, '1.20.1070.10-FF-000443', NULL, 'Integral membrane protein', 282, NULL, NULL, 68417),
(68418, '1.10.357.10-FF-000091', NULL, 'Probable transcriptional regulator', 132, NULL, NULL, 68418),
(68419, '1.25.10.10-FF-000779', NULL, 'Proteasome component ECM29', 521, NULL, NULL, 68419),
(68420, '2.30.29.30-FF-000274', NULL, 'Rhotekin 2', 112, NULL, NULL, 68420),
(68421, '3.80.10.10-FF-001862', NULL, 'Internalin-I', 104, NULL, NULL, 68421),
(68422, '1.20.1250.20-FF-002017', NULL, 'Monocarboxylate transporter, putative', 367, NULL, NULL, 68422),
(68423, '1.20.58.60-FF-000162', NULL, 'dystrophin isoform X2', 111, NULL, NULL, 68423),
(68424, '3.30.160.60-FF-005161', NULL, NULL, 64, NULL, NULL, 68424),
(68425, '1.10.1670.10-FF-000031', NULL, 'Endonuclease III, putative', 85, NULL, NULL, 68425),
(68426, '1.10.600.10-FF-000145', NULL, 'Terpene cyclase, putative', 40, NULL, NULL, 68426),
(68427, '3.30.160.60-FF-004885', NULL, NULL, 27, NULL, NULL, 68427),
(68428, '3.30.1640.10-FF-000096', NULL, 'DNA helicase', 118, NULL, NULL, 68428),
(68429, '3.90.930.12-FF-000012', NULL, 'Large subunit ribosomal protein L6', 99, NULL, NULL, 68429),
(68430, '3.40.390.10-FF-000271', NULL, NULL, 152, NULL, NULL, 68430),
(68431, '1.10.510.10-FF-001240', NULL, 'Kinase, ULK', 328, NULL, NULL, 68431),
(68432, '1.20.1080.10-FF-000062', NULL, 'Aquaporin A', 251, NULL, NULL, 68432),
(68433, '1.10.510.10-FF-000958', NULL, 'Non-specific serine/threonine protein kinase', 341, NULL, NULL, 68433),
(68434, '3.30.740.10-FF-000025', NULL, NULL, 89, NULL, NULL, 68434),
(68435, '2.60.40.60-FF-000735', NULL, 'Cadherin-4', 111, NULL, NULL, 68435),
(68436, '2.60.260.20-FF-000163', NULL, 'Molecular chaperone, putative', 71, NULL, NULL, 68436),
(68437, '1.25.10.10-FF-002679', NULL, 'Uncharacterized protein', 83, NULL, NULL, 68437),
(68438, '1.10.10.60-FF-000586', NULL, 'LIM domain family', 61, NULL, NULL, 68438),
(68439, '3.40.50.620-FF-000075', NULL, 'Isoleucine--tRNA ligase', 275, NULL, NULL, 68439),
(68440, '3.90.70.10-FF-000466', NULL, 'Uncharacterized protein', 157, NULL, NULL, 68440),
(68441, '3.30.160.20-FF-000051', NULL, 'Microprocessor complex subunit DGCR8', 57, NULL, NULL, 68441),
(68442, '1.10.2000.10-FF-000020', NULL, 'Uncharacterized protein', 121, NULL, NULL, 68442),
(68443, '1.25.10.10-FF-002472', NULL, 'Uncharacterized protein', 215, NULL, NULL, 68443),
(68444, '3.30.40.10-FF-000129', NULL, 'RBR-type E3 ubiquitin transferase', 89, NULL, NULL, 68444),
(68445, '3.30.1370.10-FF-000226', NULL, 'Uncharacterized protein', 60, NULL, NULL, 68445),
(68446, '1.25.40.10-FF-004761', NULL, 'Uncharacterized protein', 57, NULL, NULL, 68446),
(68447, '2.30.42.10-FF-000355', NULL, 'protein lin-7 homolog B', 98, NULL, NULL, 68447),
(68448, '3.30.160.60-FF-004655', NULL, NULL, 37, NULL, NULL, 68448),
(68449, '3.40.47.10-FF-000195', NULL, 'Amino acid adenylation domain protein', 461, NULL, NULL, 68449),
(68450, '2.10.109.10-FF-000005', NULL, 'Mitochondrial inner membrane protease subunit', 136, NULL, NULL, 68450),
(68451, '2.10.25.10-FF-001536', NULL, 'Neurogenic locus notch homolog protein 1', 33, NULL, NULL, 68451),
(68452, '2.70.130.10-FF-000148', NULL, NULL, 141, NULL, NULL, 68452),
(68453, '3.10.100.10-FF-000049', NULL, 'Lymphocyte antigen 75 variant', 145, NULL, NULL, 68453),
(68454, '3.30.70.330-FF-000567', NULL, 'RNA-binding protein musashi, putative', 92, NULL, NULL, 68454),
(68455, '3.30.470.20-FF-000041', NULL, 'Protein lysine acetyltransferase', 134, NULL, NULL, 68455),
(68456, '3.40.50.300-FF-002677', NULL, 'DNA mismatch repair protein', 279, NULL, NULL, 68456),
(68457, '3.40.30.10-FF-001056', NULL, 'Peroxiredoxin, probable', 176, NULL, NULL, 68457);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(68458, '3.30.470.30-FF-000044', NULL, 'mRNA-capping enzyme', 162, NULL, NULL, 68458),
(68459, '3.40.309.10-FF-000083', NULL, 'Uncharacterized protein', 187, NULL, NULL, 68459),
(68460, '2.60.40.1460-FF-000007', NULL, 'Integrin subunit alpha 9', 161, NULL, NULL, 68460),
(68461, '2.60.40.10-FF-004885', NULL, NULL, 77, NULL, NULL, 68461),
(68462, '3.30.870.10-FF-000029', NULL, 'Cardiolipin synthase C', 194, NULL, NULL, 68462),
(68463, '3.30.160.60-FF-003570', NULL, 'LD24968p', 66, NULL, NULL, 68463),
(68464, '1.10.1070.11-FF-000071', NULL, 'PIKK family atypical protein kinase', 198, NULL, NULL, 68464),
(68465, '2.60.120.260-FF-000428', NULL, 'Reelin', 104, NULL, NULL, 68465),
(68466, '3.40.50.720-FF-000116', NULL, 'Glyoxylate/hydroxypyruvate reductase A', 108, NULL, NULL, 68466),
(68467, '2.60.40.1450-FF-000004', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 39, NULL, NULL, 68467),
(68468, '3.30.70.330-FF-002158', NULL, NULL, 93, NULL, NULL, 68468),
(68469, '1.10.238.10-FF-001191', NULL, 'Uncharacterized protein', 82, NULL, NULL, 68469),
(68470, '1.20.1250.20-FF-001528', NULL, 'General substrate transporter', 451, NULL, NULL, 68470),
(68471, '1.25.10.10-FF-000908', NULL, 'Coatomer subunit gamma', 188, NULL, NULL, 68471),
(68472, '3.40.640.10-FF-000381', NULL, 'Glycine dehydrogenase (Decarboxylating)', 233, NULL, NULL, 68472),
(68473, '2.130.10.10-FF-001209', NULL, 'Periodic tryptophan protein 2', 296, NULL, NULL, 68473),
(68474, '3.40.50.10190-FF-000122', NULL, 'Pescadillo homolog', 64, NULL, NULL, 68474),
(68475, '3.30.2160.10-FF-000065', NULL, 'Uncharacterized protein', 44, NULL, NULL, 68475),
(68476, '3.80.10.10-FF-002351', NULL, 'Uncharacterized protein', 307, NULL, NULL, 68476),
(68477, '3.40.50.300-FF-004493', NULL, 'ATP-dependent DEAD/H RNA helicase, putative', 246, NULL, NULL, 68477),
(68478, '1.25.40.10-FF-002861', NULL, 'CCR4-NOT transcription complex subunit', 92, NULL, NULL, 68478),
(68479, '2.40.50.140-FF-000446', NULL, 'Eukaryotic translation initiation factor 5A', 71, NULL, NULL, 68479),
(68480, '3.20.20.140-FF-000300', NULL, 'Uncharacterized protein', 276, NULL, NULL, 68480),
(68481, '3.30.559.10-FF-000171', NULL, 'HC-toxin synthetase', 166, NULL, NULL, 68481),
(68482, '2.70.70.10-FF-000031', NULL, 'Peptidase M23B', 127, NULL, NULL, 68482),
(68483, '1.20.1070.10-FF-000230', NULL, 'F2R-like thrombin or trypsin receptor 3', 293, NULL, NULL, 68483),
(68484, '2.130.10.10-FF-000726', NULL, 'Neural precursor cell-expressed, developmentally down-regulated 1', 162, NULL, NULL, 68484),
(68485, '2.130.10.10-FF-001002', NULL, 'A/G-specific adenine DNA glycosylase', 140, NULL, NULL, 68485),
(68486, '3.40.50.970-FF-000045', NULL, 'Transketolase', 201, NULL, NULL, 68486),
(68487, '3.40.720.10-FF-000201', NULL, 'Arylsulfatase', 434, NULL, NULL, 68487),
(68488, '1.10.10.60-FF-000715', NULL, 'One cut domain family member', 69, NULL, NULL, 68488),
(68489, '3.40.50.300-FF-000777', NULL, 'tRNA (N6-adenosine(37)-N6)-threonylcarbamoyltransferase complex ATPase TsaE', 147, NULL, NULL, 68489),
(68490, '1.20.1070.10-FF-002130', NULL, 'Uncharacterized protein', 272, NULL, NULL, 68490),
(68491, '3.30.70.330-FF-001978', NULL, NULL, 172, NULL, NULL, 68491),
(68492, '3.40.50.980-FF-000048', NULL, 'CDA peptide synthetase III', 169, NULL, NULL, 68492),
(68493, '2.10.25.10-FF-000125', NULL, 'Neurogenic locus notch protein-like', 41, NULL, NULL, 68493),
(68494, '3.40.50.300-FF-006393', NULL, 'Uncharacterized protein', 134, NULL, NULL, 68494),
(68495, '3.40.50.2300-FF-000218', NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase SSU72', 49, NULL, NULL, 68495),
(68496, '2.30.40.10-FF-000070', NULL, 'Amidohydrolase', 86, NULL, NULL, 68496),
(68497, '1.10.1300.10-FF-000048', NULL, 'cGMP-specific 3'',5''-cyclic phosphodiesterase', 197, NULL, NULL, 68497),
(68498, '1.20.1050.130-FF-000025', NULL, 'Predicted protein', 115, NULL, NULL, 68498),
(68499, '1.10.510.10-FF-003701', NULL, NULL, 164, NULL, NULL, 68499),
(68500, '1.10.238.10-FF-000808', NULL, 'Mitochondrial carrier domain-containing protein', 183, NULL, NULL, 68500);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(68501, '1.10.3470.10-FF-000050', NULL, 'Manganese ABC transporter, inner membrane permease protein SitC', 285, NULL, NULL, 68501),
(68502, '3.30.160.60-FF-001119', NULL, 'zinc finger protein 408', 31, NULL, NULL, 68502),
(68503, '2.60.40.10-FF-002985', NULL, 'Beta-galactosidase', 100, NULL, NULL, 68503),
(68504, '3.30.230.10-FF-000155', NULL, 'Ribonuclease P protein component', 117, NULL, NULL, 68504),
(68505, '2.120.10.30-FF-000339', NULL, 'Alanyl dipeptidyl peptidase', 153, NULL, NULL, 68505),
(68506, '3.40.50.720-FF-001398', NULL, 'Zinc-binding oxidoreductase, putative', 188, NULL, NULL, 68506),
(68507, '1.10.1040.10-FF-000112', NULL, 'Ketopantoate reductase', 107, NULL, NULL, 68507),
(68508, '3.40.50.300-FF-001266', NULL, 'Dynein heavy chain, putative', 125, NULL, NULL, 68508),
(68509, '3.30.70.330-FF-002254', NULL, NULL, 90, NULL, NULL, 68509),
(68510, '3.90.79.10-FF-000238', NULL, 'Hydrolase, NUDIX family protein', 191, NULL, NULL, 68510),
(68511, '3.10.20.90-FF-000737', NULL, 'Plexin-A2', 116, NULL, NULL, 68511),
(68512, '2.40.50.90-FF-000144', NULL, 'YALI0B03960p', 139, NULL, NULL, 68512),
(68513, '3.90.550.10-FF-000609', NULL, 'Similar to glycosyl transferase', 216, NULL, NULL, 68513),
(68514, '1.10.10.10-FF-000936', NULL, 'Forkhead box protein O', 46, NULL, NULL, 68514),
(68515, '3.30.1490.80-FF-000025', NULL, 'Glutathione synthetase', 66, NULL, NULL, 68515),
(68516, '1.10.630.10-FF-000001', NULL, 'Cytochrome P450, family 2', 471, NULL, NULL, 68516),
(68517, '1.20.1050.10-FF-000122', NULL, 'Predicted protein', 110, NULL, NULL, 68517),
(68518, '1.20.1250.20-FF-000331', NULL, 'Protein NRT1/ PTR FAMILY 4.2', 551, NULL, NULL, 68518),
(68519, '3.30.160.60-FF-004559', NULL, NULL, 36, NULL, NULL, 68519),
(68520, '3.30.428.10-FF-000007', NULL, 'HIT family protein', 117, NULL, NULL, 68520),
(68521, '3.40.50.10890-FF-000017', NULL, 'Uncharacterized protein', 77, NULL, NULL, 68521),
(68522, '3.80.10.10-FF-003548', NULL, 'Leucine Rich Repeat family protein', 156, NULL, NULL, 68522),
(68523, '3.40.50.1820-FF-001676', NULL, 'Predicted protein', 243, NULL, NULL, 68523),
(68524, '3.30.40.10-FF-001669', NULL, 'Kinase', 83, NULL, NULL, 68524),
(68525, '2.130.10.10-FF-002963', NULL, 'AGAP006735-PA', 232, NULL, NULL, 68525),
(68526, '2.60.120.200-FF-000214', NULL, 'DE cadherin-like protein', 186, NULL, NULL, 68526),
(68527, '3.20.20.150-FF-000062', NULL, 'Protein arginine N-methyltransferase', 104, NULL, NULL, 68527),
(68528, '3.30.1360.10-FF-000046', NULL, 'DNA-directed RNA polymerases II IV and V subunit 11', 48, NULL, NULL, 68528),
(68529, '3.40.850.10-FF-000317', NULL, 'Kinesin, putative', 422, NULL, NULL, 68529),
(68530, '3.40.50.2300-FF-000645', NULL, 'Glutamate receptor', 165, NULL, NULL, 68530),
(68531, '1.25.40.10-FF-000624', NULL, 'Putative pentatricopeptide repeat-containing protein', 114, NULL, NULL, 68531),
(68532, '2.60.40.10-FF-001900', NULL, 'Myotactin form B', 105, NULL, NULL, 68532),
(68533, '2.30.30.30-FF-000036', NULL, 'Elongation factor P-like protein', 62, NULL, NULL, 68533),
(68534, '2.60.40.150-FF-000763', NULL, 'Ingression protein fic1', 129, NULL, NULL, 68534),
(68535, '3.40.50.1820-FF-000052', NULL, 'Putative aminoacrylate hydrolase RutD', 266, NULL, NULL, 68535),
(68536, '3.30.300.30-FF-000043', NULL, 'Lipoprotein', 106, NULL, NULL, 68536),
(68537, '3.30.160.60-FF-001333', NULL, 'Zinc finger with KRAB and SCAN domains 4', 27, NULL, NULL, 68537),
(68538, '1.10.10.60-FF-000923', NULL, NULL, 80, NULL, NULL, 68538),
(68539, '3.30.260.10-FF-000011', NULL, 'T-complex protein 1 subunit zeta', 104, NULL, NULL, 68539),
(68540, '3.90.660.10-FF-000022', NULL, 'Flavin containing polyamine oxidase, putative', 214, NULL, NULL, 68540),
(68541, '1.25.40.20-FF-001228', NULL, 'Mechanosensory transduction channel NOMPC', 110, NULL, NULL, 68541),
(68542, '1.10.1200.150-FF-000003', NULL, 'Transcriptional regulator CtsR', 77, NULL, NULL, 68542),
(68543, '2.60.40.4060-FF-000017', NULL, 'Spondin-1-like Protein', 154, NULL, NULL, 68543),
(68544, '3.30.60.60-FF-000022', NULL, 'Histone acetyltransferase', 64, NULL, NULL, 68544);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(68545, '3.80.10.10-FF-000322', NULL, 'Matrix remodeling associated 5', 97, NULL, NULL, 68545),
(68546, '2.60.120.590-FF-000061', NULL, 'Uncharacterized protein', 234, NULL, NULL, 68546),
(68547, '3.90.640.10-FF-000122', NULL, 'WGS project CABT00000000 data, contig 2.6', 123, NULL, NULL, 68547),
(68548, '3.40.50.300-FF-006634', NULL, 'Predicted protein', 91, NULL, NULL, 68548),
(68549, '3.40.1280.10-FF-000043', NULL, 'EMG1/NEP1 methyltransferase, putative', 198, NULL, NULL, 68549),
(68550, '1.10.287.470-FF-000020', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 74, NULL, NULL, 68550),
(68551, '3.90.660.20-FF-000025', NULL, 'Protoporphyrinogen oxidase', 77, NULL, NULL, 68551),
(68552, '2.30.42.10-FF-000147', NULL, 'Pro-interleukin-16', 126, NULL, NULL, 68552),
(68553, '3.90.110.10-FF-000037', NULL, NULL, 78, NULL, NULL, 68553),
(68554, '2.70.150.10-FF-000256', NULL, 'Uncharacterized protein', 31, NULL, NULL, 68554),
(68555, '1.20.1540.10-FF-000075', NULL, 'Uncharacterized protein', 197, NULL, NULL, 68555),
(68556, '3.40.605.10-FF-000001', NULL, 'Aldehyde dehydrogenase 1', 266, NULL, NULL, 68556),
(68557, '1.10.287.70-FF-000422', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 146, NULL, NULL, 68557),
(68558, '3.90.740.10-FF-000068', NULL, 'Os05g0241100 protein', 44, NULL, NULL, 68558),
(68559, '1.20.1250.20-FF-000432', NULL, 'MFS transporter permease', 195, NULL, NULL, 68559),
(68560, '3.10.180.10-FF-000043', NULL, '27 kDa antigen Cfp30B', 124, NULL, NULL, 68560),
(68561, '3.40.50.150-FF-000934', NULL, 'Uncharacterized protein', 321, NULL, NULL, 68561),
(68562, '3.20.20.300-FF-000034', NULL, 'Beta-glucosidase-like glycosyl hydrolase', 329, NULL, NULL, 68562),
(68563, '2.130.10.10-FF-000934', NULL, 'sperm-associated antigen 16 protein', 69, NULL, NULL, 68563),
(68564, '3.30.70.330-FF-002366', NULL, NULL, 104, NULL, NULL, 68564),
(68565, '1.10.1870.10-FF-000012', NULL, 'Predicted protein', 127, NULL, NULL, 68565),
(68566, '3.30.1520.10-FF-000143', NULL, 'Uncharacterized protein', 137, NULL, NULL, 68566),
(68567, '3.10.430.100-FF-000012', NULL, '50S ribosomal protein L9', 88, NULL, NULL, 68567),
(68568, '3.30.2080.10-FF-000013', NULL, 'Uncharacterized protein', 68, NULL, NULL, 68568),
(68569, '3.40.50.300-FF-005105', NULL, 'Septation protein 7', 340, NULL, NULL, 68569),
(68570, '3.40.50.620-FF-000524', NULL, 'Uncharacterized protein', 274, NULL, NULL, 68570),
(68571, '1.10.238.10-FF-000359', NULL, 'Dystrophin-1', 81, NULL, NULL, 68571),
(68572, '3.40.50.1760-FF-000005', NULL, 'Glutathione synthetase', 70, NULL, NULL, 68572),
(68573, '3.10.10.10-FF-000033', NULL, NULL, 48, NULL, NULL, 68573),
(68574, '3.40.190.10-FF-000076', NULL, 'LysR family transcriptional regulator', 104, NULL, NULL, 68574),
(68575, '3.30.260.10-FF-000106', NULL, NULL, 36, NULL, NULL, 68575),
(68576, '1.10.10.10-FF-000369', NULL, 'Werner syndrome ATP-dependent helicase', 134, NULL, NULL, 68576),
(68577, '3.20.20.380-FF-000001', NULL, 'Copper homeostasis protein CutC', 248, NULL, NULL, 68577),
(68578, '1.20.1510.10-FF-000039', NULL, 'Related to zinc transporter', 221, NULL, NULL, 68578),
(68579, '2.130.10.10-FF-005026', NULL, 'Uncharacterized protein', 305, NULL, NULL, 68579),
(68580, '3.40.50.1980-FF-000072', NULL, 'ABC transporter substrate-binding protein', 149, NULL, NULL, 68580),
(68581, '3.30.160.60-FF-003362', NULL, NULL, 30, NULL, NULL, 68581),
(68582, '3.40.50.2000-FF-000561', NULL, 'Putative glucosyltransferase', 221, NULL, NULL, 68582),
(68583, '3.80.10.10-FF-002025', NULL, 'F-box family protein', 88, NULL, NULL, 68583),
(68584, '1.25.40.10-FF-002069', NULL, 'Putative ATPase', 215, NULL, NULL, 68584),
(68585, '1.10.510.10-FF-000279', NULL, 'Non-specific serine/threonine protein kinase', 300, NULL, NULL, 68585),
(68586, '1.10.760.10-FF-000089', NULL, 'Cytochrome c, mono-and diheme variants', 124, NULL, NULL, 68586),
(68587, '1.10.238.10-FF-000590', NULL, 'Diacylglycerol kinase', 108, NULL, NULL, 68587),
(68588, '1.10.10.10-FF-001100', NULL, 'Regulatory protein', 82, NULL, NULL, 68588);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(68589, '1.20.1250.20-FF-001854', NULL, 'Uncharacterized protein', 129, NULL, NULL, 68589),
(68590, '3.40.50.300-FF-001154', NULL, 'RAS (RAD and GEM)-like GTP-binding 2', 157, NULL, NULL, 68590),
(68591, '1.10.472.10-FF-000178', NULL, 'Unplaced genomic scaffold supercont2.7, whole genome shotgun sequence', 124, NULL, NULL, 68591),
(68592, '3.40.50.1820-FF-000153', NULL, 'Surfactin synthase thioesterase subunit', 238, NULL, NULL, 68592),
(68593, '3.40.50.300-FF-006729', NULL, 'DNA replication licensing factor MCM7', 71, NULL, NULL, 68593),
(68594, '3.40.50.970-FF-000051', NULL, 'Sulfite reductase beta subunit', 317, NULL, NULL, 68594),
(68595, '2.30.42.10-FF-000260', NULL, 'membrane-associated guanylate kinase, WW and PDZ domain-containing protein 1-like isoform X3', 119, NULL, NULL, 68595),
(68596, '3.90.1150.10-FF-000325', NULL, '(S)-3,5-dihydroxyphenylglycine transaminase', 155, NULL, NULL, 68596),
(68597, '3.30.50.10-FF-000080', NULL, 'Uncharacterized protein', 100, NULL, NULL, 68597),
(68598, '3.40.630.10-FF-000099', NULL, 'Cytosolic non-specific dipeptidase', 115, NULL, NULL, 68598),
(68599, '1.10.220.150-FF-000037', NULL, 'Uncharacterized protein', 128, NULL, NULL, 68599),
(68600, '3.30.40.10-FF-001995', NULL, 'Uncharacterized protein', 53, NULL, NULL, 68600),
(68601, '3.30.230.70-FF-000162', NULL, 'Exosomal 3''-5'' exoribonuclease complex, subunit Rrp42, putative', 286, NULL, NULL, 68601),
(68602, '1.25.40.20-FF-000947', NULL, 'Uncharacterized protein', 128, NULL, NULL, 68602),
(68603, '2.160.20.120-FF-000001', NULL, 'Protein FAM185A', 175, NULL, NULL, 68603),
(68604, '3.80.10.10-FF-003868', NULL, 'Endonuclease/Exonuclease/phosphatase family protein', 102, NULL, NULL, 68604),
(68605, '3.40.850.10-FF-000525', NULL, 'Predicted protein', 97, NULL, NULL, 68605),
(68606, '3.30.70.330-FF-000455', NULL, 'Peptidyl-prolyl cis-trans isomerase', 142, NULL, NULL, 68606),
(68607, '2.30.29.230-FF-000003', NULL, 'Uncharacterized protein, isoform C', 180, NULL, NULL, 68607),
(68608, '1.25.40.20-FF-001341', NULL, 'Uncharacterized protein', 118, NULL, NULL, 68608),
(68609, '1.25.10.10-FF-000785', NULL, 'Adaptor related protein complex 3 subunit delta 1', 299, NULL, NULL, 68609),
(68610, '2.20.70.10-FF-000016', NULL, 'Transcription elongation regulator 1 (CA150)', 33, NULL, NULL, 68610),
(68611, '3.50.50.60-FF-000352', NULL, 'Mycothione reductase', 118, NULL, NULL, 68611),
(68612, '3.80.10.10-FF-003756', NULL, 'Receptor-like protein 33', 121, NULL, NULL, 68612),
(68613, '2.40.10.10-FF-000635', NULL, NULL, 222, NULL, NULL, 68613),
(68614, '3.30.160.60-FF-002761', NULL, 'Zinc finger protein 845', 23, NULL, NULL, 68614),
(68615, '1.20.120.1240-FF-000071', NULL, 'Uncharacterized protein', 160, NULL, NULL, 68615),
(68616, '1.25.40.10-FF-004098', NULL, 'Uncharacterized protein', 148, NULL, NULL, 68616),
(68617, '1.25.40.10-FF-000944', NULL, 'BnaC07g00040D protein', 74, NULL, NULL, 68617),
(68618, '1.10.510.10-FF-003134', NULL, NULL, 183, NULL, NULL, 68618),
(68619, '1.10.472.10-FF-000386', NULL, 'Predicted protein', 161, NULL, NULL, 68619),
(68620, '1.10.472.10-FF-000498', NULL, 'Uncharacterized protein', 144, NULL, NULL, 68620),
(68621, '2.20.110.10-FF-000040', NULL, 'Phosphatidylinositol 4-phosphate 5-kinase 6', 80, NULL, NULL, 68621),
(68622, '3.40.50.1070-FF-000001', NULL, 'L-fucose isomerase', 175, NULL, NULL, 68622),
(68623, '3.40.50.1100-FF-000179', NULL, 'Pyridoxal-phosphate dependent enzyme family protein', 190, NULL, NULL, 68623),
(68624, '1.25.40.10-FF-000832', NULL, 'Putative pentatricopeptide repeat-containing protein', 160, NULL, NULL, 68624),
(68625, '3.40.50.970-FF-000146', NULL, '2-hydroxyacyl-CoA lyase', 92, NULL, NULL, 68625),
(68626, '3.40.50.300-FF-003065', NULL, 'GTP-binding nuclear protein', 202, NULL, NULL, 68626),
(68627, '3.40.50.170-FF-000018', NULL, '10-formyltetrahydrofolate dehydrogenase', 209, NULL, NULL, 68627),
(68628, '1.10.10.60-FF-000592', NULL, 'AraC/XylS family transcriptional regulator', 42, NULL, NULL, 68628),
(68629, '3.30.70.330-FF-000028', NULL, 'Putative serine/arginine-rich splicing factor 4', 74, NULL, NULL, 68629);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(68630, '3.60.15.10-FF-000036', NULL, 'DNA internalization-related competence protein ComEC/Rec2', 236, NULL, NULL, 68630),
(68631, '3.30.565.10-FF-000472', NULL, 'Hybrid sensory kinase', 156, NULL, NULL, 68631),
(68632, '3.40.50.300-FF-001507', NULL, 'X-ray repair cross complementing 2', 240, NULL, NULL, 68632),
(68633, '3.40.50.150-FF-001182', NULL, NULL, 136, NULL, NULL, 68633),
(68634, '3.40.50.720-FF-000088', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', 193, NULL, NULL, 68634),
(68635, '3.10.129.110-FF-000001', NULL, 'Sterigmatocystin biosynthesis polyketide synthase', 319, NULL, NULL, 68635),
(68636, '1.25.40.420-FF-000034', NULL, 'Os01g0968600 protein', 119, NULL, NULL, 68636),
(68637, '3.40.630.10-FF-000436', NULL, 'Uncharacterized protein', 245, NULL, NULL, 68637),
(68638, '2.40.37.10-FF-000073', NULL, NULL, 17, NULL, NULL, 68638),
(68639, '3.40.50.2300-FF-000544', NULL, 'Two component response regulator', 84, NULL, NULL, 68639),
(68640, '3.30.70.330-FF-000921', NULL, 'Clustered-asparagine-rich protein', 128, NULL, NULL, 68640),
(68641, '3.30.160.60-FF-001232', NULL, 'zinc finger protein 62 homolog isoform X1', 27, NULL, NULL, 68641),
(68642, '1.20.1070.10-FF-000331', NULL, 'Opioid receptor delta 1', 172, NULL, NULL, 68642),
(68643, '1.20.1720.10-FF-000061', NULL, 'Uncharacterized protein', 199, NULL, NULL, 68643),
(68644, '3.50.50.60-FF-000234', NULL, 'Flavocytochrome C sulfide dehydrogenase', 134, NULL, NULL, 68644),
(68645, '3.90.245.10-FF-000001', NULL, 'Pyrimidine-specific ribonucleoside hydrolase RihA', 311, NULL, NULL, 68645),
(68646, '1.10.8.270-FF-000153', NULL, 'Uncharacterized protein', 136, NULL, NULL, 68646),
(68647, '3.40.50.1480-FF-000028', NULL, NULL, 143, NULL, NULL, 68647),
(68648, '2.40.30.160-FF-000004', NULL, 'Glycine cleavage T-protein', 107, NULL, NULL, 68648),
(68649, '3.40.50.1240-FF-000193', NULL, 'Chromosome 23, whole genome shotgun sequence', 375, NULL, NULL, 68649),
(68650, '1.10.472.10-FF-000291', NULL, 'Putative cyclin-A3-1', 106, NULL, NULL, 68650),
(68651, '1.25.40.20-FF-001442', NULL, 'Uncharacterized protein', 145, NULL, NULL, 68651),
(68652, '2.10.25.10-FF-001087', NULL, 'LP19846p', 52, NULL, NULL, 68652),
(68653, '1.10.150.20-FF-000074', NULL, 'DNA-directed RNA polymerase', 237, NULL, NULL, 68653),
(68654, '3.40.850.10-FF-000430', NULL, 'Predicted protein', 156, NULL, NULL, 68654),
(68655, '3.40.50.300-FF-005217', NULL, 'Phage protein', 207, NULL, NULL, 68655),
(68656, '3.30.200.20-FF-000673', NULL, 'cyclin-dependent kinase 9', 78, NULL, NULL, 68656),
(68657, '2.130.10.10-FF-001440', NULL, 'WD domain containing protein', 318, NULL, NULL, 68657),
(68658, '2.40.30.170-FF-000007', NULL, 'Macrolide transporter subunit MacA', 80, NULL, NULL, 68658),
(68659, '2.60.40.60-FF-000943', NULL, 'Protocadherin gamma subfamily C, 3', 41, NULL, NULL, 68659),
(68660, '1.25.40.570-FF-000051', NULL, '26S proteasome regulatory complex component', 140, NULL, NULL, 68660),
(68661, '1.20.1250.20-FF-000218', NULL, 'facilitated trehalose transporter Tret1', 450, NULL, NULL, 68661),
(68662, '1.10.510.10-FF-004449', NULL, NULL, 36, NULL, NULL, 68662),
(68663, '3.30.70.270-FF-000190', NULL, NULL, 75, NULL, NULL, 68663),
(68664, '3.40.50.1820-FF-001575', NULL, 'Carboxypeptidase', 105, NULL, NULL, 68664),
(68665, '3.30.160.60-FF-002856', NULL, NULL, 29, NULL, NULL, 68665),
(68666, '1.20.920.20-FF-000041', NULL, 'Uncharacterized protein', 145, NULL, NULL, 68666),
(68667, '3.40.50.720-FF-002342', NULL, 'Uncharacterized protein', 140, NULL, NULL, 68667),
(68668, '2.30.30.40-FF-000359', NULL, 'Tyrosine-protein kinase', 91, NULL, NULL, 68668),
(68669, '1.20.1070.10-FF-001865', NULL, 'Uncharacterized protein', 294, NULL, NULL, 68669),
(68670, '3.40.395.10-FF-000046', NULL, 'Predicted protein', 209, NULL, NULL, 68670),
(68671, '1.20.5.170-FF-000300', NULL, 'Uncharacterized protein', 83, NULL, NULL, 68671),
(68672, '1.10.1450.10-FF-000166', NULL, 'Uncharacterized protein', 60, NULL, NULL, 68672),
(68673, '3.40.50.1460-FF-000022', NULL, 'GPI8p transamidase', 297, NULL, NULL, 68673);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(68674, '1.10.10.60-FF-000687', NULL, 'Middle operon regulator', 43, NULL, NULL, 68674),
(68675, '1.20.58.60-FF-000049', NULL, 'Spectrin beta chain', 110, NULL, NULL, 68675),
(68676, '3.80.10.10-FF-003661', NULL, 'Uncharacterized protein', 92, NULL, NULL, 68676),
(68677, '1.20.80.10-FF-000002', NULL, 'radixin isoform X1', 117, NULL, NULL, 68677),
(68678, '2.60.40.10-FF-003250', NULL, NULL, 74, NULL, NULL, 68678),
(68679, '2.40.50.140-FF-000901', NULL, NULL, 101, NULL, NULL, 68679),
(68680, '2.30.230.10-FF-000041', NULL, 'Vitellogenin-3', 102, NULL, NULL, 68680),
(68681, '3.40.50.300-FF-003183', NULL, 'Lon protease homolog, mitochondrial', 179, NULL, NULL, 68681),
(68682, '1.20.920.30-FF-000044', NULL, 'Uncharacterized protein', 176, NULL, NULL, 68682),
(68683, '3.10.129.10-FF-000244', NULL, 'Acyl-CoA thioesterase', 136, NULL, NULL, 68683),
(68684, '1.20.1560.10-FF-000200', NULL, 'HlyB/MsbA family ABC transporter', 327, NULL, NULL, 68684),
(68685, '3.90.70.10-FF-000819', NULL, 'Ubiquitin carboxyl-terminal hydrolase 30 homolog', 196, NULL, NULL, 68685),
(68686, '3.30.1740.10-FF-000030', NULL, 'Poly [ADP-ribose] polymerase 1', 102, NULL, NULL, 68686),
(68687, '3.30.40.10-FF-001557', NULL, 'MNAT1, CDK activating kinase assembly factor', 35, NULL, NULL, 68687),
(68688, '2.30.30.40-FF-000590', NULL, 'Predicted protein', 68, NULL, NULL, 68688),
(68689, '3.50.50.60-FF-000672', NULL, 'Flavin-containing monooxygenase', 159, NULL, NULL, 68689),
(68690, '2.60.120.200-FF-000326', NULL, 'Vesicular integral membrane protein VIP36, putative', 210, NULL, NULL, 68690),
(68691, '2.60.40.10-FF-001007', NULL, 'nectin-4 isoform X2', 124, NULL, NULL, 68691),
(68692, '3.30.450.40-FF-000259', NULL, 'Transcriptional regulatory protein', 170, NULL, NULL, 68692),
(68693, '1.20.1050.10-FF-000234', NULL, 'Glutathione S-transferase, putative', 87, NULL, NULL, 68693),
(68694, '3.30.160.60-FF-004447', NULL, NULL, 36, NULL, NULL, 68694),
(68695, '2.60.40.10-FF-000389', NULL, 'Immunoglobulin superfamily member 9B', 114, NULL, NULL, 68695),
(68696, '1.20.1070.10-FF-002129', NULL, 'Uncharacterized protein', 277, NULL, NULL, 68696),
(68697, '3.10.100.10-FF-000280', NULL, NULL, 143, NULL, NULL, 68697),
(68698, '2.40.70.10-FF-000386', NULL, NULL, 188, NULL, NULL, 68698),
(68699, '3.30.710.10-FF-000074', NULL, 'Zinc finger and BTB domain-containing 48', 117, NULL, NULL, 68699),
(68700, '1.25.10.10-FF-001611', NULL, 'Uncharacterized protein', 397, NULL, NULL, 68700),
(68701, '3.20.20.80-FF-000430', NULL, 'Glucosylceramidase', 107, NULL, NULL, 68701),
(68702, '3.30.190.20-FF-000002', NULL, 'Ribosomal protein', 102, NULL, NULL, 68702),
(68703, '3.40.50.970-FF-000157', NULL, 'Predicted protein', 365, NULL, NULL, 68703),
(68704, '3.10.50.10-FF-000030', NULL, 'Uncharacterized protein', 60, NULL, NULL, 68704),
(68705, '2.40.50.140-FF-000351', NULL, 'ATP-dependent DNA helicase RecG', 94, NULL, NULL, 68705),
(68706, '1.10.510.10-FF-002971', NULL, NULL, 193, NULL, NULL, 68706),
(68707, '3.90.70.40-FF-000019', NULL, 'Uncharacterized protein', 112, NULL, NULL, 68707),
(68708, '1.20.58.90-FF-000030', NULL, NULL, 99, NULL, NULL, 68708),
(68709, '3.30.70.330-FF-001883', NULL, NULL, 92, NULL, NULL, 68709),
(68710, '3.30.450.70-FF-000032', NULL, NULL, 189, NULL, NULL, 68710),
(68711, '3.10.10.10-FF-000022', NULL, NULL, 30, NULL, NULL, 68711),
(68712, '1.20.120.1240-FF-000060', NULL, 'Interferon-induced GTP-binding protein Mx1', 181, NULL, NULL, 68712),
(68713, '3.40.390.10-FF-000057', NULL, 'Zinc metalloproteinase', 252, NULL, NULL, 68713),
(68714, '1.25.10.10-FF-000993', NULL, 'Protein CBG22497', 460, NULL, NULL, 68714),
(68715, '3.90.640.10-FF-000133', NULL, 'SWI/SNF and RSC complexes subunit arp42', 76, NULL, NULL, 68715),
(68716, '3.30.200.20-FF-001050', NULL, 'Elongation factor 2 kinase', 149, NULL, NULL, 68716),
(68717, '1.25.40.180-FF-000041', NULL, 'Nuclear cap-binding protein subunit 1', 289, NULL, NULL, 68717),
(68718, '2.60.120.340-FF-000008', NULL, 'FK506-binding protein, putative', 109, NULL, NULL, 68718),
(68719, '3.40.50.10810-FF-000168', NULL, 'DNA repair and recombination protein RAD54B, putative', 282, NULL, NULL, 68719);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(68720, '3.40.50.300-FF-001715', NULL, 'ATP-dependent helicase/nuclease subunit A', 168, NULL, NULL, 68720),
(68721, '3.30.200.20-FF-000774', NULL, 'Serine/threonine-protein kinase SSN3', 60, NULL, NULL, 68721),
(68722, '3.30.450.20-FF-000253', NULL, 'Phytochrome-like protein', 162, NULL, NULL, 68722),
(68723, '3.40.50.2000-FF-000550', NULL, 'Uncharacterized protein', 167, NULL, NULL, 68723),
(68724, '2.60.410.10-FF-000003', NULL, 'D-alanyl-D-alanine carboxypeptidase DacF', 91, NULL, NULL, 68724),
(68725, '2.40.128.30-FF-000003', NULL, NULL, 126, NULL, NULL, 68725),
(68726, '2.40.30.150-FF-000001', NULL, 'Phage baseplate hub subunit', 93, NULL, NULL, 68726),
(68727, '3.60.120.10-FF-000016', NULL, 'Aminodeoxychorismate synthase, chloroplastic', 495, NULL, NULL, 68727),
(68728, '1.25.10.10-FF-002707', NULL, 'Uncharacterized protein', 51, NULL, NULL, 68728),
(68729, '2.170.130.10-FF-000040', NULL, 'Transporter, outer membrane receptor (OMR) family', 144, NULL, NULL, 68729),
(68730, '3.40.190.10-FF-000626', NULL, 'N-methyl-D-aspartate receptor subunit 2D variant', 45, NULL, NULL, 68730),
(68731, '3.30.70.330-FF-002046', NULL, NULL, 130, NULL, NULL, 68731),
(68732, '3.90.650.10-FF-000061', NULL, 'Phosphoribosylformylglycinamidine synthase', 166, NULL, NULL, 68732),
(68733, '3.30.40.10-FF-001658', NULL, 'Uncharacterized protein', 62, NULL, NULL, 68733),
(68734, '3.30.479.20-FF-000010', NULL, 'Elongation factor Ts', 94, NULL, NULL, 68734),
(68735, '1.20.1070.10-FF-000342', NULL, 'Opioid receptor delta 1', 75, NULL, NULL, 68735),
(68736, '2.60.40.150-FF-000752', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit, putative', 67, NULL, NULL, 68736),
(68737, '2.60.120.200-FF-000225', NULL, 'MAM and LDL receptor class A domain-containing 1', 157, NULL, NULL, 68737),
(68738, '3.30.465.10-FF-000065', NULL, 'CBS domain protein', 78, NULL, NULL, 68738),
(68739, '3.40.50.720-FF-000004', NULL, 'Adenosylhomocysteinase', 160, NULL, NULL, 68739),
(68740, '1.10.10.2740-FF-000004', NULL, 'Uncharacterized protein', 78, NULL, NULL, 68740),
(68741, '3.90.100.10-FF-000003', NULL, 'Orn/Arg/Lys decarboxylase, putative', 113, NULL, NULL, 68741),
(68742, '3.40.462.20-FF-000003', NULL, 'FAD-binding domain-containing protein', 63, NULL, NULL, 68742),
(68743, '3.30.479.30-FF-000013', NULL, 'Hypersensitive-induced response protein 1', 127, NULL, NULL, 68743),
(68744, '2.60.40.1170-FF-000027', NULL, 'Adaptor complexes medium subunit family protein', 95, NULL, NULL, 68744),
(68745, '2.60.40.10-FF-004773', NULL, NULL, 121, NULL, NULL, 68745),
(68746, '2.10.25.10-FF-000013', NULL, 'Teneurin transmembrane protein 4', 31, NULL, NULL, 68746),
(68747, '1.10.600.10-FF-000050', NULL, 'Squalene synthase HpnC', 247, NULL, NULL, 68747),
(68748, '3.40.50.720-FF-000324', NULL, 'uncharacterized protein ycf39 isoform X1', 291, NULL, NULL, 68748),
(68749, '3.40.640.10-FF-000493', NULL, 'Uncharacterized protein', 299, NULL, NULL, 68749),
(68750, '3.30.710.10-FF-000315', NULL, 'Uncharacterized protein', 72, NULL, NULL, 68750),
(68751, '3.40.350.10-FF-000049', NULL, 'GD20570', 187, NULL, NULL, 68751),
(68752, '2.120.10.30-FF-000238', NULL, 'Haloacid dehalogenase-like hydrolase domain-containing protein Sgpp', 151, NULL, NULL, 68752),
(68753, '2.30.29.30-FF-000723', NULL, 'RAN binding protein 1', 139, NULL, NULL, 68753),
(68754, '3.40.50.300-FF-006842', NULL, 'Heparan-sulfate 6-O-sulfotransferase', 263, NULL, NULL, 68754),
(68755, '1.20.1440.120-FF-000004', NULL, NULL, 107, NULL, NULL, 68755),
(68756, '2.60.40.630-FF-000019', NULL, 'Uncharacterized protein', 49, NULL, NULL, 68756),
(68757, '2.30.30.100-FF-000073', NULL, 'LSM2 homolog, U6 small nuclear RNA and mRNA degradation associated', 40, NULL, NULL, 68757),
(68758, '1.10.620.20-FF-000048', NULL, 'Uncharacterized protein', 213, NULL, NULL, 68758),
(68759, '3.40.640.10-FF-000263', NULL, 'Kynurenine aminotransferase, putative', 131, NULL, NULL, 68759),
(68760, '1.20.140.150-FF-000073', NULL, 'Calcium channel, voltage-dependent, gamma subunit 3a', 117, NULL, NULL, 68760),
(68761, '3.40.30.10-FF-001168', NULL, 'Uncharacterized protein', 88, NULL, NULL, 68761);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(68762, '3.90.1300.10-FF-000028', NULL, 'Uncharacterized protein', 209, NULL, NULL, 68762),
(68763, '1.20.1440.130-FF-000007', NULL, 'vitamin K epoxide reductase complex subunit 1-like protein 1', 157, NULL, NULL, 68763),
(68764, '3.40.50.920-FF-000058', NULL, 'Predicted protein', 133, NULL, NULL, 68764),
(68765, '3.40.50.300-FF-000889', NULL, 'Cobalamin synthesis protein P47K', 192, NULL, NULL, 68765),
(68766, '3.30.720.210-FF-000016', NULL, 'ATP-dependent zinc metalloprotease FtsH', 79, NULL, NULL, 68766),
(68767, '3.30.40.10-FF-000034', NULL, 'Histone acetyltransferase p300', 45, NULL, NULL, 68767),
(68768, '3.30.559.70-FF-000065', NULL, 'Uncharacterized protein', 52, NULL, NULL, 68768),
(68769, '1.25.40.90-FF-000018', NULL, 'ENTH/VHS family protein isoform 1', 129, NULL, NULL, 68769),
(68770, '3.20.140.10-FF-000004', NULL, 'Nicotinate phosphoribosyltransferase', 145, NULL, NULL, 68770),
(68771, '3.40.50.150-FF-000468', NULL, 'SD03208p', 201, NULL, NULL, 68771),
(68772, '3.30.980.10-FF-000003', NULL, 'Threonine--tRNA ligase, cytoplasmic', 157, NULL, NULL, 68772),
(68773, '2.10.25.10-FF-001750', NULL, 'Predicted protein', 37, NULL, NULL, 68773),
(68774, '3.60.40.10-FF-000100', NULL, 'Stage II sporulation protein E', 237, NULL, NULL, 68774),
(68775, '3.40.50.2300-FF-000106', NULL, 'Glutamate receptor ionotropic, kainate', 158, NULL, NULL, 68775),
(68776, '3.30.160.60-FF-000838', NULL, 'Zinc finger protein 14', 28, NULL, NULL, 68776),
(68777, '1.25.40.10-FF-001107', NULL, 'Protein NRDE2-like protein', 196, NULL, NULL, 68777),
(68778, '2.60.40.10-FF-005610', NULL, NULL, 119, NULL, NULL, 68778),
(68779, '2.10.25.10-FF-001295', NULL, 'Uncharacterized protein, isoform B', 61, NULL, NULL, 68779),
(68780, '2.60.40.10-FF-002873', NULL, 'Interleukin 13 receptor, alpha 2', 92, NULL, NULL, 68780),
(68781, '3.40.47.10-FF-000077', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 2', 411, NULL, NULL, 68781),
(68782, '3.30.230.70-FF-000049', NULL, 'Polyribonucleotide nucleotidyltransferase', 316, NULL, NULL, 68782),
(68783, '1.10.472.10-FF-000509', NULL, 'Uncharacterized protein', 187, NULL, NULL, 68783),
(68784, '3.40.190.10-FF-000065', NULL, 'Sulfate ABC transporter', 147, NULL, NULL, 68784),
(68785, '1.25.40.10-FF-002962', NULL, 'Anaphase promoting complex subunit 7, isoform A', 155, NULL, NULL, 68785),
(68786, '1.10.1170.10-FF-000015', NULL, 'Baculoviral IAP repeat-containing protein 2', 69, NULL, NULL, 68786),
(68787, '3.90.1140.10-FF-000044', NULL, 'Uncharacterized protein', 126, NULL, NULL, 68787),
(68788, '3.40.50.1000-FF-000716', NULL, NULL, 96, NULL, NULL, 68788),
(68789, '1.20.1070.10-FF-001966', NULL, 'Uncharacterized protein', 187, NULL, NULL, 68789),
(68790, '2.60.40.60-FF-000269', NULL, 'Dachsous cadherin-related 2', 109, NULL, NULL, 68790),
(68791, '3.40.50.1470-FF-000014', NULL, 'Peptidyl-tRNA hydrolase mitochondrial', 98, NULL, NULL, 68791),
(68792, '3.30.160.60-FF-005043', NULL, NULL, 27, NULL, NULL, 68792),
(68793, '3.40.50.300-FF-004588', NULL, 'Dynein heavy chain, cytosolic, putative', 170, NULL, NULL, 68793),
(68794, '2.30.29.30-FF-000162', NULL, 'protein ECT2 isoform X2', 128, NULL, NULL, 68794),
(68795, '3.40.1090.10-FF-000129', NULL, 'Uncharacterized protein', 130, NULL, NULL, 68795),
(68796, '3.40.50.300-FF-005206', NULL, 'Ypt7p', 210, NULL, NULL, 68796),
(68797, '3.30.160.60-FF-002867', NULL, 'Zinc finger protein 715', 30, NULL, NULL, 68797),
(68798, '3.40.50.1460-FF-000011', NULL, 'Caspase-7', 147, NULL, NULL, 68798),
(68799, '3.40.50.1480-FF-000017', NULL, 'Adenosylhomocysteinase', 132, NULL, NULL, 68799),
(68800, '2.120.10.30-FF-000227', NULL, 'Blr7870 protein', 180, NULL, NULL, 68800),
(68801, '2.40.50.90-FF-000026', NULL, 'Tudor domain containing 1', 91, NULL, NULL, 68801),
(68802, '3.30.160.60-FF-004767', NULL, NULL, 32, NULL, NULL, 68802),
(68803, '3.40.50.410-FF-000113', NULL, 'Protein CBR-CUT-6', 183, NULL, NULL, 68803),
(68804, '3.40.366.10-FF-000052', NULL, 'Acyl transferase domain-containing protein', 238, NULL, NULL, 68804),
(68805, '3.80.10.10-FF-001396', NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', 143, NULL, NULL, 68805);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(68806, '3.40.50.300-FF-003306', NULL, 'ATP-dependent dethiobiotin synthetase BioD', 224, NULL, NULL, 68806),
(68807, '2.40.50.140-FF-000238', NULL, '30S ribosomal protein S1', 87, NULL, NULL, 68807),
(68808, '3.30.420.340-FF-000004', NULL, 'UvrABC system protein C', 160, NULL, NULL, 68808),
(68809, '3.90.550.10-FF-000694', NULL, 'Galactosylgalactosylxylosylprotein 3beta-glucuronosyltransferase, putative', 50, NULL, NULL, 68809),
(68810, '3.90.70.10-FF-000578', NULL, 'Predicted protein', 320, NULL, NULL, 68810),
(68811, '1.10.510.10-FF-001335', NULL, 'Uncharacterized protein', 334, NULL, NULL, 68811),
(68812, '3.10.110.10-FF-000218', NULL, 'Uncharacterized protein', 149, NULL, NULL, 68812),
(68813, '1.10.8.100-FF-000012', NULL, 'Ribosomal RNA small subunit methyltransferase A', 64, NULL, NULL, 68813),
(68814, '3.20.100.10-FF-000007', NULL, 'mRNA capping enzyme, beta chain, putative', 283, NULL, NULL, 68814),
(68815, '3.30.70.270-FF-000313', NULL, NULL, 32, NULL, NULL, 68815),
(68816, '3.30.470.20-FF-000153', NULL, 'Tubulin tyrosine ligase protein, putative', 228, NULL, NULL, 68816),
(68817, '3.40.1120.10-FF-000003', NULL, 'Ribosomal protein L15', 205, NULL, NULL, 68817),
(68818, '3.30.420.40-FF-001050', NULL, 'Uncharacterized protein', 169, NULL, NULL, 68818),
(68819, '3.10.110.10-FF-000095', NULL, 'NEDD8-conjugating enzyme UBC12, putative', 144, NULL, NULL, 68819),
(68820, '2.130.10.30-FF-000018', NULL, 'probable E3 ubiquitin-protein ligase HERC3 isoform X1', 122, NULL, NULL, 68820),
(68821, '3.30.420.330-FF-000001', NULL, 'Non-structural protein 1', 154, NULL, NULL, 68821),
(68822, '1.25.40.10-FF-004334', NULL, 'Pentatricopeptide repeat-containing protein', 165, NULL, NULL, 68822),
(68823, '3.30.497.10-FF-000083', NULL, 'Uncharacterized protein', 232, NULL, NULL, 68823),
(68824, '3.80.10.10-FF-000333', NULL, 'LRR receptor-like serine/threonine-protein kinase RCH1', 287, NULL, NULL, 68824),
(68825, '3.30.40.10-FF-000472', NULL, 'E3 ubiquitin-protein ligase ORTHRUS 2', 117, NULL, NULL, 68825),
(68826, '1.10.760.10-FF-000090', NULL, 'Fructose dehydrogenase cytochrome subunit', 145, NULL, NULL, 68826),
(68827, '3.40.50.300-FF-000991', NULL, 'Dephospho-CoA kinase', 202, NULL, NULL, 68827),
(68828, '2.60.40.60-FF-001106', NULL, 'Uncharacterized protein', 98, NULL, NULL, 68828),
(68829, '3.40.50.300-FF-006179', NULL, 'Uncharacterized protein', 131, NULL, NULL, 68829),
(68830, '1.10.238.10-FF-001073', NULL, 'troponin C, skeletal muscle', 74, NULL, NULL, 68830),
(68831, '3.30.1360.10-FF-000057', NULL, 'Uncharacterized protein', 49, NULL, NULL, 68831),
(68832, '3.30.750.24-FF-000168', NULL, 'Sulfate transporter', 93, NULL, NULL, 68832),
(68833, '3.30.40.10-FF-002372', NULL, 'Uncharacterized protein', 65, NULL, NULL, 68833),
(68834, '2.30.30.790-FF-000010', NULL, 'Mitochondrial ribosomal protein', 135, NULL, NULL, 68834),
(68835, '3.30.720.50-FF-000007', NULL, 'CCCH-type zinc finger antiviral protein', 100, NULL, NULL, 68835),
(68836, '3.30.160.60-FF-005262', NULL, NULL, 56, NULL, NULL, 68836),
(68837, '2.60.200.20-FF-000069', NULL, 'AGAP000662-PA-like protein', 105, NULL, NULL, 68837),
(68838, '1.20.1420.30-FF-000038', NULL, 'Solute carrier family 24 member 6a', 127, NULL, NULL, 68838),
(68839, '2.160.10.10-FF-000017', NULL, 'Mannose-1-phosphate guanyltransferase', 130, NULL, NULL, 68839),
(68840, '1.20.58.200-FF-000005', NULL, 'Translin, putative', 98, NULL, NULL, 68840),
(68841, '1.10.238.10-FF-000797', NULL, 'Uncharacterized protein', 55, NULL, NULL, 68841),
(68842, '2.60.40.4370-FF-000009', NULL, NULL, 135, NULL, NULL, 68842),
(68843, '1.25.10.10-FF-002584', NULL, 'CLIP-associating protein 2', 157, NULL, NULL, 68843),
(68844, '1.25.40.10-FF-004553', NULL, 'Pentatricopeptide repeat-containing protein 4, mitochondrial', 219, NULL, NULL, 68844),
(68845, '3.80.10.10-FF-001957', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase isoform A', 216, NULL, NULL, 68845),
(68846, '1.20.120.720-FF-000043', NULL, 'FI20293p1', 144, NULL, NULL, 68846),
(68847, '3.40.50.300-FF-008079', NULL, 'Deoxyuridine 5''-triphosphate nucleotidohydrolase, mitochondrial, putative', 117, NULL, NULL, 68847);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(68848, '3.40.50.300-FF-000659', NULL, 'Deoxyguanosine kinase', 202, NULL, NULL, 68848),
(68849, '2.60.120.10-FF-000588', NULL, 'Cupin superfamily barrel domain helix-turn-helix transcriptional regulator, AraC/XylS family', 81, NULL, NULL, 68849),
(68850, '3.40.630.10-FF-000335', NULL, 'Carboxypeptidase, putative', 226, NULL, NULL, 68850),
(68851, '1.10.20.10-FF-000089', NULL, 'Histone H2A', 132, NULL, NULL, 68851),
(68852, '3.40.50.150-FF-000698', NULL, 'Putative methyltransferase', 167, NULL, NULL, 68852),
(68853, '2.40.50.140-FF-000912', NULL, NULL, 121, NULL, NULL, 68853),
(68854, '3.30.420.40-FF-000774', NULL, 'Actin-related protein 8', 94, NULL, NULL, 68854),
(68855, '2.115.10.20-FF-000023', NULL, 'Predicted protein', 47, NULL, NULL, 68855),
(68856, '3.90.1150.10-FF-000533', NULL, 'Uncharacterized protein', 53, NULL, NULL, 68856),
(68857, '1.10.1350.10-FF-000001', NULL, 'Intermediate capsid protein VP6', 227, NULL, NULL, 68857),
(68858, '1.25.40.10-FF-002299', NULL, 'Putative pentatricopeptide repeat-containing protein isoform A', 164, NULL, NULL, 68858),
(68859, '4.10.240.10-FF-000111', NULL, 'Related to PPR1-Zinc finger transcription factor', 58, NULL, NULL, 68859),
(68860, '2.60.40.10-FF-001120', NULL, 'Major sperm protein 19/31/40/45/50/51/53/59/61/65/81/113/142', 126, NULL, NULL, 68860),
(68861, '3.30.70.330-FF-002720', NULL, NULL, 101, NULL, NULL, 68861),
(68862, '2.130.10.10-FF-004863', NULL, 'Protein CBR-GAD-1', 124, NULL, NULL, 68862),
(68863, '3.40.50.2000-FF-000218', NULL, 'Digalactosyldiacylglycerol synthase 1, chloroplastic-like', 111, NULL, NULL, 68863),
(68864, '3.30.1010.10-FF-000059', NULL, 'Non-specific serine/threonine protein kinase', 160, NULL, NULL, 68864),
(68865, '3.40.50.720-FF-002353', NULL, 'Uncharacterized protein', 65, NULL, NULL, 68865),
(68866, '3.10.350.10-FF-000101', NULL, 'Gll1142 protein', 55, NULL, NULL, 68866),
(68867, '2.60.450.20-FF-000003', NULL, 'T-complex protein 10b', 181, NULL, NULL, 68867),
(68868, '3.40.50.10050-FF-000013', NULL, 'Mitochondrial translational initiation factor 2', 109, NULL, NULL, 68868),
(68869, '1.20.58.60-FF-000280', NULL, 'Spectrin beta, non-erythrocytic 5', 263, NULL, NULL, 68869),
(68870, '1.10.287.110-FF-000289', NULL, 'DnaJ homolog subfamily C member 7 homolog', 106, NULL, NULL, 68870),
(68871, '3.30.70.660-FF-000082', NULL, 'tRNA pseudouridine synthase', 193, NULL, NULL, 68871),
(68872, '3.10.100.10-FF-000167', NULL, 'Phospholipase A2 receptor 1', 135, NULL, NULL, 68872),
(68873, '3.80.10.10-FF-002233', NULL, 'Uncharacterized protein', 340, NULL, NULL, 68873),
(68874, '1.20.120.1750-FF-000128', NULL, 'RBR-type E3 ubiquitin transferase', 90, NULL, NULL, 68874),
(68875, '3.40.33.10-FF-000011', NULL, 'Peptidase inhibitor 16', 178, NULL, NULL, 68875),
(68876, '3.30.300.30-FF-000144', NULL, 'HC-toxin synthetase', 117, NULL, NULL, 68876),
(68877, '2.60.40.10-FF-000844', NULL, 'roundabout homolog 4 isoform X1', 108, NULL, NULL, 68877),
(68878, '3.40.50.10490-FF-000122', NULL, NULL, 71, NULL, NULL, 68878),
(68879, '2.60.120.260-FF-000546', NULL, 'Zgc:153722', 65, NULL, NULL, 68879),
(68880, '1.20.200.10-FF-000028', NULL, 'Argininosuccinate lyase', 76, NULL, NULL, 68880),
(68881, '4.10.60.10-FF-000253', NULL, 'Uncharacterized protein', 47, NULL, NULL, 68881),
(68882, '1.20.1250.20-FF-001955', NULL, 'Major facilitator superfamily protein', 428, NULL, NULL, 68882),
(68883, '3.30.420.40-FF-000875', NULL, 'Uncharacterized protein', 50, NULL, NULL, 68883),
(68884, '3.10.490.10-FF-000038', NULL, 'Uncharacterized protein', 146, NULL, NULL, 68884),
(68885, '3.40.50.300-FF-000890', NULL, 'DNA polymerase III subunit delta', 167, NULL, NULL, 68885),
(68886, '1.25.40.10-FF-002524', NULL, 'Transducin family protein / WD-40 repeat family protein', 151, NULL, NULL, 68886),
(68887, '3.30.230.10-FF-000161', NULL, 'G elongation factor, mitochondrial 2', 130, NULL, NULL, 68887),
(68888, '3.40.1190.20-FF-000151', NULL, 'ketohexokinase isoform X1', 304, NULL, NULL, 68888),
(68889, '1.10.510.10-FF-001560', NULL, 'Mitogen-activated protein kinase kinase kinase 19', 116, NULL, NULL, 68889);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(68890, '3.30.559.30-FF-000076', NULL, 'HC-toxin synthetase', 237, NULL, NULL, 68890),
(68891, '1.10.10.10-FF-000723', NULL, 'Arsenical resistance operon repressor', 95, NULL, NULL, 68891),
(68892, '3.90.550.50-FF-000138', NULL, 'Uncharacterized protein', 220, NULL, NULL, 68892),
(68893, '3.20.20.210-FF-000018', NULL, '5-methyltetrahydropteroyltriglutamate--homocysteine methyltransferase 2', 103, NULL, NULL, 68893),
(68894, '3.40.50.300-FF-001502', NULL, 'Transcription termination factor 2', 325, NULL, NULL, 68894),
(68895, '3.40.50.720-FF-000543', NULL, 'SLOwpoke potassium channel family', 142, NULL, NULL, 68895),
(68896, '3.30.160.60-FF-006459', NULL, NULL, 43, NULL, NULL, 68896),
(68897, '3.40.50.1000-FF-000593', NULL, NULL, 142, NULL, NULL, 68897),
(68898, '3.40.50.620-FF-000283', NULL, 'Kinase family protein', 134, NULL, NULL, 68898),
(68899, '1.10.10.10-FF-001324', NULL, 'OmpR family transcriptional regulator', 99, NULL, NULL, 68899),
(68900, '1.10.150.20-FF-000063', NULL, 'DNA repair protein RAD1', 72, NULL, NULL, 68900),
(68901, '2.10.109.10-FF-000016', NULL, 'HTH-type transcriptional regulator prtR', 133, NULL, NULL, 68901),
(68902, '3.30.160.150-FF-000005', NULL, 'LPS-assembly lipoprotein LptE', 149, NULL, NULL, 68902),
(68903, '3.30.1060.10-FF-000017', NULL, NULL, 221, NULL, NULL, 68903),
(68904, '3.30.70.330-FF-000910', NULL, 'RNA-binding protein 8A', 130, NULL, NULL, 68904),
(68905, '2.130.10.10-FF-001103', NULL, 'WD repeat domain 90', 214, NULL, NULL, 68905),
(68906, '3.30.710.10-FF-000310', NULL, 'Uncharacterized protein', 90, NULL, NULL, 68906),
(68907, '3.90.470.20-FF-000078', NULL, 'Phosphopantetheinyl transferase-like protein', 100, NULL, NULL, 68907),
(68908, '3.30.559.10-FF-000070', NULL, 'Hydroxamate-type ferrichrome siderophore peptide synthetase', 187, NULL, NULL, 68908),
(68909, '3.10.20.90-FF-000855', NULL, 'Ubiquitin-like protein, putative', 78, NULL, NULL, 68909),
(68910, '3.40.50.12280-FF-000007', NULL, 'NADH:ubiquinone oxidoreductase core subunit S7', 136, NULL, NULL, 68910),
(68911, '2.130.10.10-FF-000491', NULL, 'Syntaxin binding protein 5', 118, NULL, NULL, 68911),
(68912, '2.40.50.140-FF-000233', NULL, 'Elongation factor P-like protein', 63, NULL, NULL, 68912),
(68913, '2.60.40.60-FF-000948', NULL, 'Uncharacterized protein', 113, NULL, NULL, 68913),
(68914, '1.20.58.760-FF-000044', NULL, 'Uncharacterized protein', 185, NULL, NULL, 68914),
(68915, '2.40.70.10-FF-000515', NULL, NULL, 70, NULL, NULL, 68915),
(68916, '3.90.550.10-FF-000699', NULL, 'Uncharacterized protein', 292, NULL, NULL, 68916),
(68917, '2.60.40.10-FF-002648', NULL, 'Neurotrimin', 80, NULL, NULL, 68917),
(68918, '3.30.420.340-FF-000009', NULL, 'UvrABC system protein C', 156, NULL, NULL, 68918),
(68919, '3.40.50.170-FF-000007', NULL, 'Phosphoribosylglycinamide formyltransferase', 202, NULL, NULL, 68919),
(68920, '3.30.110.20-FF-000003', NULL, 'DNA/RNA-binding protein Alba 1', 103, NULL, NULL, 68920),
(68921, '2.130.10.10-FF-001092', NULL, 'Protein transport protein sec13', 299, NULL, NULL, 68921),
(68922, '2.60.40.10-FF-005503', NULL, NULL, 92, NULL, NULL, 68922),
(68923, '3.40.50.10300-FF-000004', NULL, 'DNA / pantothenate metabolism flavoprotein, putative', 287, NULL, NULL, 68923),
(68924, '3.40.50.80-FF-000083', NULL, 'Ferric reduction oxidase 2', 122, NULL, NULL, 68924),
(68925, '1.20.1070.10-FF-001298', NULL, 'Long wavelength opsin B14', 190, NULL, NULL, 68925),
(68926, '3.40.50.1820-FF-000501', NULL, 'Predicted protein', 263, NULL, NULL, 68926),
(68927, '1.10.10.60-FF-001081', NULL, NULL, 41, NULL, NULL, 68927),
(68928, '3.40.190.10-FF-000744', NULL, 'Uncharacterized protein', 71, NULL, NULL, 68928),
(68929, '1.20.1730.10-FF-000022', NULL, 'Sensor histidine kinase', 520, NULL, NULL, 68929),
(68930, '2.10.25.10-FF-000333', NULL, 'netrin-4 isoform X2', 103, NULL, NULL, 68930),
(68931, '2.60.40.10-FF-002755', NULL, 'Suppressor of choline sensitivity', 128, NULL, NULL, 68931),
(68932, '1.10.8.400-FF-000001', NULL, 'Enoyl-[acyl-carrier-protein] reductase [NADH]', 56, NULL, NULL, 68932),
(68933, '3.90.550.50-FF-000245', NULL, 'Predicted protein', 121, NULL, NULL, 68933);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(68934, '1.20.1250.20-FF-002130', NULL, 'Uncharacterized protein', 212, NULL, NULL, 68934),
(68935, '3.30.230.10-FF-000054', NULL, 'DNA mismatch repair protein PMS1', 120, NULL, NULL, 68935),
(68936, '3.30.200.20-FF-000555', NULL, 'Protein kinase C', 113, NULL, NULL, 68936),
(68937, '1.20.58.900-FF-000007', NULL, 'DENN domain-containing protein 5B', 101, NULL, NULL, 68937),
(68938, '2.130.10.10-FF-004762', NULL, 'Uncharacterized protein', 157, NULL, NULL, 68938),
(68939, '2.70.98.40-FF-000013', NULL, 'Glycoside hydrolase family 65 protein', 256, NULL, NULL, 68939),
(68940, '3.40.50.150-FF-000586', NULL, 'tRNA (adenine(58)-N(1))-methyltransferase catalytic subunit TRMT61A', 189, NULL, NULL, 68940),
(68941, '1.25.40.10-FF-001001', NULL, 'Hypothetical_protein_-_conserved', 275, NULL, NULL, 68941),
(68942, '1.10.8.60-FF-000040', NULL, 'caseinolytic peptidase B protein homolog isoform X1', 91, NULL, NULL, 68942),
(68943, '1.10.287.370-FF-000102', NULL, 'Prefoldin subunit 6', 35, NULL, NULL, 68943),
(68944, '3.90.70.10-FF-000696', NULL, 'Ubiquitin specific peptidase 50', 225, NULL, NULL, 68944),
(68945, '3.90.930.12-FF-000006', NULL, '50S ribosomal protein L6', 97, NULL, NULL, 68945),
(68946, '3.40.50.620-FF-000176', NULL, 'Isoleucine-tRNA ligase, putative', 284, NULL, NULL, 68946),
(68947, '3.40.50.1010-FF-000011', NULL, 'Flap endonuclease Xni', 161, NULL, NULL, 68947),
(68948, '3.30.70.370-FF-000012', NULL, 'DNA polymerase I', 119, NULL, NULL, 68948),
(68949, '1.10.238.10-FF-000707', NULL, 'CALmodulin related genes', 42, NULL, NULL, 68949),
(68950, '1.10.630.10-FF-000102', NULL, 'Cytochrome P450 52A5', 463, NULL, NULL, 68950),
(68951, '1.10.287.70-FF-000181', NULL, 'Cyclic nucleotide-gated potassium channel mll3241', 106, NULL, NULL, 68951),
(68952, '2.60.40.10-FF-001232', NULL, 'Immunoglobulin-like and fibronectin type III domain-containing 1', 97, NULL, NULL, 68952),
(68953, '2.10.110.10-FF-000194', NULL, 'LIM domain-containing protein PLIM2c', 96, NULL, NULL, 68953),
(68954, '3.30.1120.160-FF-000004', NULL, 'Calcium channel, voltage-dependent, L type, alpha 1D subunit', 95, NULL, NULL, 68954),
(68955, '1.10.510.10-FF-001234', NULL, 'Serine/threonine-protein kinase par-4', 182, NULL, NULL, 68955),
(68956, '3.40.50.80-FF-000201', NULL, 'Uncharacterized protein', 105, NULL, NULL, 68956),
(68957, '1.20.58.60-FF-000723', NULL, 'Uncharacterized protein', 108, NULL, NULL, 68957),
(68958, '3.90.1150.10-FF-000090', NULL, 'Bifunctional dethiobiotin synthetase/7,8-diamino-pelargonic acid aminotransferase, mitochondrial', 107, NULL, NULL, 68958),
(68959, '2.130.10.10-FF-001210', NULL, 'Probable cytosolic iron-sulfur protein assembly protein CIAO1 homolog', 180, NULL, NULL, 68959),
(68960, '3.30.1120.150-FF-000001', NULL, 'N-hydroxyarylamine O-acetyltransferase', 83, NULL, NULL, 68960),
(68961, '3.30.420.40-FF-000768', NULL, 'Uncharacterized protein', 153, NULL, NULL, 68961),
(68962, '1.10.220.10-FF-000077', NULL, 'Uncharacterized protein', 38, NULL, NULL, 68962),
(68963, '3.40.30.10-FF-001062', NULL, 'Uncharacterized protein', 165, NULL, NULL, 68963),
(68964, '1.25.10.10-FF-002578', NULL, 'Uncharacterized protein', 161, NULL, NULL, 68964),
(68965, '2.10.25.10-FF-000226', NULL, 'EGF-like repeat and discoidin I-like domain-containing protein 3', 95, NULL, NULL, 68965),
(68966, '1.25.40.770-FF-000015', NULL, 'Uncharacterized protein', 215, NULL, NULL, 68966),
(68967, '3.30.70.1400-FF-000007', NULL, 'Glycine cleavage system aminomethyltransferase T', 90, NULL, NULL, 68967),
(68968, '3.80.10.10-FF-001856', NULL, 'Gp150 protein', 72, NULL, NULL, 68968),
(68969, '1.10.510.10-FF-000852', NULL, 'Mitogen-activated protein kinase kinase kinase 17', 306, NULL, NULL, 68969),
(68970, '2.60.40.10-FF-001125', NULL, 'Ephrin type-A receptor 10', 101, NULL, NULL, 68970),
(68971, '3.40.190.10-FF-000851', NULL, 'Ionotropic glutamate receptor, putative', 75, NULL, NULL, 68971),
(68972, '3.10.110.10-FF-000336', NULL, 'Uncharacterized protein', 241, NULL, NULL, 68972),
(68973, '3.40.50.720-FF-000217', NULL, 'Saccharopine dehydrogenase [NAD(+), L-lysine-forming]', 191, NULL, NULL, 68973);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(68974, '3.40.50.300-FF-002918', NULL, 'CobQ/CobB/MinD/ParA family nucleotide binding protein', 153, NULL, NULL, 68974),
(68975, '1.20.1250.20-FF-001287', NULL, 'Uncharacterized protein', 354, NULL, NULL, 68975),
(68976, '3.30.70.330-FF-000573', NULL, 'Nop6p', 82, NULL, NULL, 68976),
(68977, '1.10.238.10-FF-001308', NULL, 'Uncharacterized protein', 92, NULL, NULL, 68977),
(68978, '3.40.190.10-FF-000525', NULL, 'Uncharacterized protein', 133, NULL, NULL, 68978),
(68979, '3.40.50.1820-FF-000720', NULL, 'Phosphatidylcholine-sterol acyltransferase', 226, NULL, NULL, 68979),
(68980, '3.40.50.150-FF-000693', NULL, 'Methyltransferase', 250, NULL, NULL, 68980),
(68981, '1.10.400.10-FF-000063', NULL, 'G-protein subunit alpha 3', 41, NULL, NULL, 68981),
(68982, '2.40.30.10-FF-000176', NULL, 'Ring-1,2-phenylacetyl-CoA epoxidase subunit PaaE', 102, NULL, NULL, 68982),
(68983, '1.10.1020.10-FF-000004', NULL, 'Site-specific DNA-methyltransferase (adenine-specific)', 107, NULL, NULL, 68983),
(68984, '3.30.40.10-FF-002271', NULL, 'Protein CBG15729', 54, NULL, NULL, 68984),
(68985, '3.40.50.300-FF-002688', NULL, 'F-box DNA helicase 1', 228, NULL, NULL, 68985),
(68986, '2.130.10.10-FF-004543', NULL, 'Axonemal inner arm I1 intermediate chain dynein IC138', 222, NULL, NULL, 68986),
(68987, '3.40.630.10-FF-000094', NULL, 'Transferrrin receptor-like protein', 193, NULL, NULL, 68987),
(68988, '1.25.10.10-FF-000673', NULL, 'Adapter protein complex 3 subunit beta 2', 400, NULL, NULL, 68988),
(68989, '3.90.226.10-FF-000328', NULL, 'Uncharacterized protein', 138, NULL, NULL, 68989),
(68990, '3.40.50.2300-FF-000196', NULL, 'Glutamate metabotropic receptor 7', 143, NULL, NULL, 68990),
(68991, '2.60.40.10-FF-002974', NULL, 'Stretchin-Mlck, isoform V', 110, NULL, NULL, 68991),
(68992, '1.10.2000.10-FF-000014', NULL, 'frizzled-6 isoform X1', 118, NULL, NULL, 68992),
(68993, '3.30.420.40-FF-000549', NULL, 'Glucokinase', 110, NULL, NULL, 68993),
(68994, '1.10.300.10-FF-000004', NULL, 'Adenylosuccinate synthetase', 98, NULL, NULL, 68994),
(68995, '2.130.10.10-FF-002289', NULL, 'RIC1-domain-containing protein', 207, NULL, NULL, 68995),
(68996, '1.10.10.60-FF-000480', NULL, 'Si:ch73-376l24.4', 74, NULL, NULL, 68996),
(68997, '3.30.430.20-FF-000038', NULL, 'Uncharacterized protein', 105, NULL, NULL, 68997),
(68998, '2.60.40.10-FF-002429', NULL, 'KETtiN (Drosophila actin-binding) homolog', 110, NULL, NULL, 68998),
(68999, '1.20.5.190-FF-000082', NULL, 'Myosin IIIB', 46, NULL, NULL, 68999),
(69000, '1.20.1270.60-FF-000310', NULL, 'Uncharacterized protein', 60, NULL, NULL, 69000),
(69001, '1.25.40.10-FF-001220', NULL, 'Pentatricopeptide repeat-containing protein At2g35030, mitochondrial', 114, NULL, NULL, 69001),
(69002, '3.90.70.10-FF-000477', NULL, 'Uncharacterized protein', 221, NULL, NULL, 69002),
(69003, '1.10.246.60-FF-000016', NULL, NULL, 79, NULL, NULL, 69003),
(69004, '1.25.70.10-FF-000098', NULL, NULL, 197, NULL, NULL, 69004),
(69005, '3.40.50.2000-FF-000331', NULL, 'Trehalose-6-phosphate synthase', 229, NULL, NULL, 69005),
(69006, '3.30.70.330-FF-002708', NULL, NULL, 106, NULL, NULL, 69006),
(69007, '2.10.110.10-FF-000205', NULL, 'Uncharacterized protein', 59, NULL, NULL, 69007),
(69008, '1.10.510.10-FF-002976', NULL, NULL, 129, NULL, NULL, 69008),
(69009, '1.25.40.10-FF-002417', NULL, 'Pentatricopeptide repeat-containing protein At1g18485', 146, NULL, NULL, 69009),
(69010, '2.60.260.20-FF-000174', NULL, 'Uncharacterized protein', 69, NULL, NULL, 69010),
(69011, '1.10.132.30-FF-000001', NULL, 'DNA-directed RNA polymerase subunit', 116, NULL, NULL, 69011),
(69012, '3.80.10.10-FF-004144', NULL, 'Predicted protein', 108, NULL, NULL, 69012),
(69013, '2.60.40.60-FF-000729', NULL, 'Cadherin-4', 96, NULL, NULL, 69013),
(69014, '3.10.20.90-FF-000962', NULL, 'Uncharacterized protein', 46, NULL, NULL, 69014),
(69015, '3.30.160.60-FF-005155', NULL, NULL, 71, NULL, NULL, 69015),
(69016, '1.25.40.20-FF-001223', NULL, 'Espin like a', 65, NULL, NULL, 69016),
(69017, '3.40.50.11660-FF-000046', NULL, NULL, 113, NULL, NULL, 69017),
(69018, '1.25.40.90-FF-000030', NULL, 'DUF618 domain protein', 137, NULL, NULL, 69018);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(69019, '3.20.20.100-FF-000081', NULL, 'Uncharacterized oxidoreductase MSMEG_2408', 306, NULL, NULL, 69019),
(69020, '2.40.30.10-FF-000395', NULL, 'NADPH-dependent diflavin oxidoreductase 1', 115, NULL, NULL, 69020),
(69021, '3.10.20.30-FF-000079', NULL, NULL, 84, NULL, NULL, 69021),
(69022, '1.20.1560.10-FF-000531', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 23, NULL, NULL, 69022),
(69023, '2.20.100.10-FF-000202', NULL, 'Thrombospondin type-1 domain-containing protein 7B', 56, NULL, NULL, 69023),
(69024, '2.40.70.10-FF-000285', NULL, NULL, 106, NULL, NULL, 69024),
(69025, '1.10.510.10-FF-002757', NULL, NULL, 123, NULL, NULL, 69025),
(69026, '2.20.25.90-FF-000014', NULL, 'Probable oxidoreductase YyaE', 62, NULL, NULL, 69026),
(69027, '3.10.20.870-FF-000004', NULL, 'Phospholipase A-2-activating protein', 72, NULL, NULL, 69027),
(69028, '3.40.50.300-FF-001721', NULL, 'AAA family ATPase, putative', 188, NULL, NULL, 69028),
(69029, '1.20.1250.20-FF-000090', NULL, 'MFS sugar transporter, putative', 463, NULL, NULL, 69029),
(69030, '3.40.850.10-FF-000082', NULL, 'OSM3-like kinesin', 363, NULL, NULL, 69030),
(69031, '3.30.1240.10-FF-000003', NULL, 'HAD family hydrolase', 107, NULL, NULL, 69031),
(69032, '3.30.160.60-FF-002974', NULL, NULL, 29, NULL, NULL, 69032),
(69033, '3.50.50.60-FF-000565', NULL, 'Flavin-containing monooxygenase', 178, NULL, NULL, 69033),
(69034, '1.25.10.10-FF-001162', NULL, 'AGAP008392-PA', 259, NULL, NULL, 69034),
(69035, '1.10.3370.10-FF-000002', NULL, 'Transport Sec61 subunit alpha isoform 2', 465, NULL, NULL, 69035),
(69036, '2.60.40.420-FF-000063', NULL, 'Cytochrome c oxidase subunit 2, putative', 106, NULL, NULL, 69036),
(69037, '3.40.50.720-FF-000436', NULL, 'ADP-ribosyl cyclase/cyclic ADP-ribose hydrolase 1', 124, NULL, NULL, 69037),
(69038, '2.60.40.10-FF-001344', NULL, 'titin isoform X1', 91, NULL, NULL, 69038),
(69039, '3.40.50.300-FF-007123', NULL, 'ATP-dependent DNA helicase', 184, NULL, NULL, 69039),
(69040, '3.40.50.12780-FF-000051', NULL, 'Acyl-CoA synthetase', 209, NULL, NULL, 69040),
(69041, '3.30.710.10-FF-000203', NULL, 'Leucine-zipper-like transcription regulator 1', 158, NULL, NULL, 69041),
(69042, '1.10.3470.10-FF-000061', NULL, 'Uncharacterized protein', 91, NULL, NULL, 69042),
(69043, '3.40.850.10-FF-000312', NULL, 'Os04g0442800 protein', 99, NULL, NULL, 69043),
(69044, '3.40.50.300-FF-006499', NULL, 'Uncharacterized protein', 114, NULL, NULL, 69044),
(69045, '3.10.129.10-FF-000031', NULL, 'Acyl-coenzyme A thioesterase 9, mitochondrial', 169, NULL, NULL, 69045),
(69046, '2.40.50.140-FF-000126', NULL, '30S ribosomal protein S1', 86, NULL, NULL, 69046),
(69047, '2.20.25.80-FF-000011', NULL, 'Disease resistance protein RRS1', 73, NULL, NULL, 69047),
(69048, '2.60.270.60-FF-000001', NULL, 'Cik1 suppressing-related protein', 196, NULL, NULL, 69048),
(69049, '3.90.79.10-FF-000227', NULL, 'Uncharacterized protein', 110, NULL, NULL, 69049),
(69050, '3.10.20.90-FF-000748', NULL, 'KRIT 1 (Krev interaction trapped/cerebral cavernous malformation 1) homolog', 100, NULL, NULL, 69050),
(69051, '3.40.50.300-FF-004942', NULL, 'Uncharacterized protein', 172, NULL, NULL, 69051),
(69052, '3.40.50.2300-FF-000207', NULL, 'Two-component osmosensing histidine kinase', 165, NULL, NULL, 69052),
(69053, '3.30.530.20-FF-000097', NULL, 'Carbon monoxide dehydrogenase operon G protein', 157, NULL, NULL, 69053),
(69054, '1.10.630.10-FF-000321', NULL, 'Chromosome 23, whole genome shotgun sequence', 515, NULL, NULL, 69054),
(69055, '2.60.40.150-FF-000196', NULL, 'Protein fantom', 197, NULL, NULL, 69055),
(69056, '1.10.132.50-FF-000007', NULL, 'Uncharacterized protein', 116, NULL, NULL, 69056),
(69057, '3.30.40.10-FF-000028', NULL, 'Putative hepatocyte growth factor-regulated tyrosine kinase substrate', 70, NULL, NULL, 69057),
(69058, '2.130.10.10-FF-001322', NULL, 'Echinoderm microtubule-associated protein-like CG42247', 317, NULL, NULL, 69058),
(69059, '3.40.50.620-FF-000064', NULL, 'Cryptochrome circadian regulator 2', 168, NULL, NULL, 69059),
(69060, '3.30.200.20-FF-000336', NULL, 'Eukaryotic elongation factor 2 kinase', 50, NULL, NULL, 69060);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(69061, '3.30.2160.10-FF-000076', NULL, 'Uncharacterized protein', 85, NULL, NULL, 69061),
(69062, '1.25.40.10-FF-004660', NULL, 'Pentatricopeptide repeat-containing protein At5g61800', 114, NULL, NULL, 69062),
(69063, '3.90.1150.10-FF-000213', NULL, 'DegT/DnrJ/EryC1/StrS aminotransferase family protein', 125, NULL, NULL, 69063),
(69064, '3.30.70.330-FF-000803', NULL, 'Nam8p', 92, NULL, NULL, 69064),
(69065, '3.40.640.10-FF-000268', NULL, 'Glutamic-oxaloacetic transaminase 1, soluble', 115, NULL, NULL, 69065),
(69066, '3.80.10.10-FF-001289', NULL, 'Toll-like receptor Tollo', 123, NULL, NULL, 69066),
(69067, '1.10.10.10-FF-001105', NULL, 'MarR family transcriptional regulator', 137, NULL, NULL, 69067),
(69068, '2.130.10.10-FF-002519', NULL, 'follistatin-related protein 4 isoform X2', 274, NULL, NULL, 69068),
(69069, '2.70.160.11-FF-000061', NULL, 'YALI0E00660p', 191, NULL, NULL, 69069),
(69070, '3.30.70.330-FF-001989', NULL, NULL, 97, NULL, NULL, 69070),
(69071, '2.10.25.10-FF-000114', NULL, 'Multiple epidermal growth factor-like domains protein 11', 64, NULL, NULL, 69071),
(69072, '3.90.70.10-FF-000691', NULL, 'Uncharacterized protein', 232, NULL, NULL, 69072),
(69073, '1.10.238.10-FF-000819', NULL, 'Reticulocalbin 3', 111, NULL, NULL, 69073),
(69074, '2.60.120.650-FF-000225', NULL, '40S ribosomal protein S4-3', 179, NULL, NULL, 69074),
(69075, '3.40.50.300-FF-003407', NULL, 'GD20873', 183, NULL, NULL, 69075),
(69076, '3.30.40.10-FF-002052', NULL, 'Uncharacterized protein', 130, NULL, NULL, 69076),
(69077, '2.60.120.260-FF-000322', NULL, 'Predicted protein', 100, NULL, NULL, 69077),
(69078, '3.30.710.10-FF-000192', NULL, 'Non-expressor of PR1', 187, NULL, NULL, 69078),
(69079, '2.60.220.50-FF-000045', NULL, 'Adhesion G protein-coupled receptor G1', 159, NULL, NULL, 69079),
(69080, '3.90.950.10-FF-000005', NULL, '7-methyl-GTP pyrophosphatase', 188, NULL, NULL, 69080),
(69081, '2.120.10.80-FF-000225', NULL, 'Epithiospecifier protein', 204, NULL, NULL, 69081),
(69082, '3.30.40.10-FF-000921', NULL, 'U-box domain containing protein', 92, NULL, NULL, 69082),
(69083, '2.130.10.10-FF-003008', NULL, 'Oligoxyloglucan-reducing end-specific xyloglucanase', 335, NULL, NULL, 69083),
(69084, '1.10.510.10-FF-002538', NULL, 'Kinase, NEK', 304, NULL, NULL, 69084),
(69085, '2.130.10.10-FF-002845', NULL, 'WD40 repeat protein', 353, NULL, NULL, 69085),
(69086, '3.10.100.10-FF-000274', NULL, NULL, 133, NULL, NULL, 69086),
(69087, '1.10.150.20-FF-000175', NULL, 'ATP-dependent DNA helicase Hel308', 57, NULL, NULL, 69087),
(69088, '1.10.3330.10-FF-000005', NULL, 'Urate oxidase', 163, NULL, NULL, 69088),
(69089, '2.60.40.10-FF-004672', NULL, NULL, 96, NULL, NULL, 69089),
(69090, '3.40.50.1820-FF-001794', NULL, 'Carboxypeptidase', 152, NULL, NULL, 69090),
(69091, '1.20.1250.20-FF-000213', NULL, 'Probable anion transporter 6, chloroplastic', 201, NULL, NULL, 69091),
(69092, '3.40.50.1000-FF-000823', NULL, NULL, 97, NULL, NULL, 69092),
(69093, '2.60.120.20-FF-000006', NULL, 'Genome polyprotein', 220, NULL, NULL, 69093),
(69094, '3.30.565.10-FF-000359', NULL, 'MutL DNA mismatch repair protein', 220, NULL, NULL, 69094),
(69095, '1.20.5.1160-FF-000011', NULL, 'protein enabled isoform X5', 40, NULL, NULL, 69095),
(69096, '3.40.850.10-FF-000205', NULL, 'Uncharacterized protein, isoform D', 365, NULL, NULL, 69096),
(69097, '1.20.920.10-FF-000032', NULL, 'Transcriptional activator spt7', 134, NULL, NULL, 69097),
(69098, '1.10.10.750-FF-000002', NULL, 'Ecotropic viral integration site 5', 43, NULL, NULL, 69098),
(69099, '3.40.50.10490-FF-000004', NULL, 'Glucose-6-phosphate isomerase', 195, NULL, NULL, 69099),
(69100, '1.25.40.10-FF-002294', NULL, 'Pentatricopeptide (PPR) repeat-containing protein-like', 172, NULL, NULL, 69100),
(69101, '2.170.150.10-FF-000035', NULL, 'Uncharacterized protein', 126, NULL, NULL, 69101),
(69102, '3.30.70.141-FF-000051', NULL, NULL, 149, NULL, NULL, 69102),
(69103, '2.20.25.90-FF-000019', NULL, NULL, 58, NULL, NULL, 69103),
(69104, '3.40.390.10-FF-000158', NULL, 'Matrix metallopeptidase 15a', 262, NULL, NULL, 69104);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(69105, '1.10.472.130-FF-000088', NULL, 'Dynein heavy chain, putative', 175, NULL, NULL, 69105),
(69106, '1.10.472.10-FF-000066', NULL, 'Transcription factor IIIB subunit', 91, NULL, NULL, 69106),
(69107, '3.40.50.80-FF-000206', NULL, 'Benzoyl-CoA oxygenase, A subunit', 154, NULL, NULL, 69107),
(69108, '3.30.50.10-FF-000186', NULL, 'Glucocorticoid receptor', 38, NULL, NULL, 69108),
(69109, '3.10.430.100-FF-000017', NULL, '50S ribosomal protein L9', 85, NULL, NULL, 69109),
(69110, '3.40.50.300-FF-004268', NULL, 'Protein CBR-TAG-343', 230, NULL, NULL, 69110),
(69111, '3.40.50.300-FF-001614', NULL, 'ABC transporter ATP-binding protein', 259, NULL, NULL, 69111),
(69112, '1.25.40.10-FF-002636', NULL, 'Rab GTPase domain-containing protein', 158, NULL, NULL, 69112),
(69113, '2.60.120.10-FF-000003', NULL, 'Crp/Fnr family transcriptional regulator', 146, NULL, NULL, 69113),
(69114, '2.130.10.10-FF-005251', NULL, 'Uncharacterized protein', 279, NULL, NULL, 69114),
(69115, '3.30.420.10-FF-000321', NULL, '3''-5'' exonuclease domain-containing protein', 198, NULL, NULL, 69115),
(69116, '3.40.50.720-FF-002460', NULL, 'Uncharacterized protein', 98, NULL, NULL, 69116),
(69117, '1.20.1070.10-FF-000005', NULL, 'Olfactory receptor', 288, NULL, NULL, 69117),
(69118, '2.30.42.10-FF-000035', NULL, 'Glutamate receptor interacting protein 1', 91, NULL, NULL, 69118),
(69119, '1.20.920.30-FF-000038', NULL, 'Predicted protein', 58, NULL, NULL, 69119),
(69120, '3.40.50.300-FF-001272', NULL, 'SMG9 isoform 2', 228, NULL, NULL, 69120),
(69121, '3.50.50.60-FF-000239', NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', 267, NULL, NULL, 69121),
(69122, '1.10.510.10-FF-001015', NULL, 'Pab1p-dependent poly(A) ribonuclease subunit, putative', 274, NULL, NULL, 69122),
(69123, '3.60.15.10-FF-000137', NULL, 'Putative metallo-beta-lactamase', 230, NULL, NULL, 69123),
(69124, '2.130.10.10-FF-004981', NULL, 'Os01g0607600 protein', 79, NULL, NULL, 69124),
(69125, '3.40.50.10480-FF-000001', NULL, 'IMP4, U3 small nucleolar ribonucleoprotein', 172, NULL, NULL, 69125),
(69126, '3.40.350.10-FF-000061', NULL, 'Xaa-Pro aminopeptidase', 151, NULL, NULL, 69126),
(69127, '3.40.50.300-FF-008197', NULL, 'Glucose-6-phosphate 1-dehydrogenase 4 chloroplastic', 76, NULL, NULL, 69127),
(69128, '3.10.20.90-FF-000967', NULL, 'STE protein kinase', 115, NULL, NULL, 69128),
(69129, '3.30.160.60-FF-001451', NULL, 'zinc finger protein 41 homolog', 28, NULL, NULL, 69129),
(69130, '3.40.50.150-FF-000709', NULL, 'Enniatin synthase', 164, NULL, NULL, 69130),
(69131, '2.60.40.150-FF-000645', NULL, 'Predicted protein', 126, NULL, NULL, 69131),
(69132, '2.20.25.80-FF-000016', NULL, NULL, 67, NULL, NULL, 69132),
(69133, '3.90.550.10-FF-000587', NULL, 'Dolichol-phosphate mannosyltransferase', 237, NULL, NULL, 69133),
(69134, '1.20.1050.10-FF-000228', NULL, 'Glutathione S-transferase theta 1a', 97, NULL, NULL, 69134),
(69135, '2.130.10.10-FF-000939', NULL, 'Periodic tryptophan protein 2', 235, NULL, NULL, 69135),
(69136, '2.40.50.140-FF-000452', NULL, 'Putative ABC sugar transporter, ATP-binding subunit', 28, NULL, NULL, 69136),
(69137, '1.20.920.20-FF-000035', NULL, 'Dynein, axonemal, heavy chain 2', 264, NULL, NULL, 69137),
(69138, '1.25.40.10-FF-004093', NULL, 'Uncharacterized protein', 152, NULL, NULL, 69138),
(69139, '3.30.40.10-FF-000702', NULL, 'Ssm4p', 83, NULL, NULL, 69139),
(69140, '1.20.1260.10-FF-000042', NULL, 'Ferritin', 174, NULL, NULL, 69140),
(69141, '3.30.230.10-FF-000380', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 194, NULL, NULL, 69141),
(69142, '2.30.29.30-FF-000061', NULL, 'Oxysterol binding protein 1', 105, NULL, NULL, 69142),
(69143, '2.120.10.30-FF-000564', NULL, 'Uncharacterized protein', 63, NULL, NULL, 69143),
(69144, '3.90.1600.10-FF-000063', NULL, 'DNA polymerase', 94, NULL, NULL, 69144),
(69145, '2.60.120.260-FF-000092', NULL, 'Laminin subunit alpha-3', 284, NULL, NULL, 69145),
(69146, '1.10.10.10-FF-000942', NULL, 'Sugar-binding transcriptional regulator', 57, NULL, NULL, 69146),
(69147, '1.20.272.40-FF-000006', NULL, 'SUV3p ATP-dependent RNA helicase', 60, NULL, NULL, 69147);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(69148, '3.55.40.20-FF-000003', NULL, 'Superoxide dismutase [Mn], mitochondrial', 116, NULL, NULL, 69148),
(69149, '1.20.1560.10-FF-000205', NULL, 'ABC transporter, ATP-binding protein', 300, NULL, NULL, 69149),
(69150, '1.10.1070.11-FF-000065', NULL, 'PIKK family atypical protein kinase', 186, NULL, NULL, 69150),
(69151, '1.10.238.220-FF-000003', NULL, 'Phosphoprotein phosphatase 2A regulatory subunit', 111, NULL, NULL, 69151),
(69152, '3.40.50.12230-FF-000021', NULL, 'Uncharacterized protein', 326, NULL, NULL, 69152),
(69153, '1.25.10.10-FF-000892', NULL, 'RING-type E3 ubiquitin transferase', 277, NULL, NULL, 69153),
(69154, '1.20.120.1900-FF-000084', NULL, 'Gamma-tubulin complex component', 173, NULL, NULL, 69154),
(69155, '1.25.40.10-FF-004441', NULL, 'Uncharacterized protein', 118, NULL, NULL, 69155),
(69156, '1.10.510.10-FF-002645', NULL, 'Uncharacterized protein', 326, NULL, NULL, 69156),
(69157, '1.10.287.110-FF-000188', NULL, 'AGAP010609-PA', 84, NULL, NULL, 69157),
(69158, '1.20.80.10-FF-000007', NULL, 'Talin 2', 111, NULL, NULL, 69158),
(69159, '3.40.50.150-FF-001075', NULL, NULL, 240, NULL, NULL, 69159),
(69160, '1.10.238.230-FF-000006', NULL, 'Uncharacterized protein', 109, NULL, NULL, 69160),
(69161, '2.40.50.140-FF-000800', NULL, NULL, 148, NULL, NULL, 69161),
(69162, '2.60.40.2130-FF-000006', NULL, 'Spondin-1', 199, NULL, NULL, 69162),
(69163, '1.10.3480.10-FF-000005', NULL, 'Respiratory nitrate reductase delta chain NarJ', 164, NULL, NULL, 69163),
(69164, '3.40.50.300-FF-008539', NULL, 'Chromosome 7, whole genome shotgun sequence', 321, NULL, NULL, 69164),
(69165, '1.10.1670.40-FF-000011', NULL, 'DNA-3-methyladenine glycosylase 2 family protein', 76, NULL, NULL, 69165),
(69166, '1.25.40.10-FF-002187', NULL, 'Pentatricopeptide repeat-containing protein At3g18110, chloroplastic', 106, NULL, NULL, 69166),
(69167, '2.10.109.10-FF-000011', NULL, 'Signal peptidase I W', 101, NULL, NULL, 69167),
(69168, '1.10.8.590-FF-000001', NULL, 'tRNA:Cm32/Um32 methyltransferase', 80, NULL, NULL, 69168),
(69169, '2.60.120.260-FF-000541', NULL, 'Uncharacterized protein', 74, NULL, NULL, 69169),
(69170, '1.10.1900.40-FF-000007', NULL, 'Erythrocyte membrane protein 1', 63, NULL, NULL, 69170),
(69171, '3.40.50.2000-FF-000117', NULL, 'Glycosyltransferase', 255, NULL, NULL, 69171),
(69172, '1.25.10.10-FF-002685', NULL, 'Uncharacterized protein', 77, NULL, NULL, 69172),
(69173, '3.30.40.10-FF-000354', NULL, 'RING-type E3 ubiquitin transferase', 76, NULL, NULL, 69173),
(69174, '3.40.640.10-FF-000156', NULL, 'Uncharacterized protein, isoform A', 246, NULL, NULL, 69174),
(69175, '3.40.140.10-FF-000247', NULL, 'Uncharacterized protein', 149, NULL, NULL, 69175),
(69176, '1.20.120.1080-FF-000101', NULL, 'RNA helicase', 114, NULL, NULL, 69176),
(69177, '3.40.850.10-FF-000531', NULL, 'Uncharacterized protein', 162, NULL, NULL, 69177),
(69178, '2.60.120.650-FF-000006', NULL, 'histone lysine demethylase PHF8 isoform X1', 361, NULL, NULL, 69178),
(69179, '3.40.50.410-FF-000012', NULL, 'Integrin, alpha 10', 191, NULL, NULL, 69179),
(69180, '2.60.120.260-FF-000434', NULL, 'Beta-1,4-mannosidase (Eurofung)', 180, NULL, NULL, 69180),
(69181, '4.10.1000.10-FF-000023', NULL, 'Zinc finger CCCH domain-containing protein 18', 58, NULL, NULL, 69181),
(69182, '3.30.70.330-FF-000680', NULL, 'NOP4p Nucleolar protein', 125, NULL, NULL, 69182),
(69183, '2.30.30.60-FF-000011', NULL, 'Predicted protein', 50, NULL, NULL, 69183),
(69184, '1.20.58.670-FF-000017', NULL, NULL, 144, NULL, NULL, 69184),
(69185, '1.10.3460.10-FF-000009', NULL, 'Chlorophyll a-b binding protein, chloroplastic', 213, NULL, NULL, 69185),
(69186, '1.10.150.20-FF-000068', NULL, 'DNA polymerase IV', 69, NULL, NULL, 69186),
(69187, '2.20.25.160-FF-000004', NULL, 'Uncharacterized protein', 30, NULL, NULL, 69187),
(69188, '3.40.640.10-FF-000049', NULL, 'serine palmitoyltransferase 1 isoform X1', 246, NULL, NULL, 69188),
(69189, '2.40.30.110-FF-000017', NULL, 'Pyruvate Dehydrogenase Phosphatase Regulatory subunit', 85, NULL, NULL, 69189),
(69190, '2.40.10.10-FF-000629', NULL, NULL, 235, NULL, NULL, 69190);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(69191, '3.30.200.20-FF-002472', NULL, 'Uncharacterized protein', 48, NULL, NULL, 69191),
(69192, '3.40.50.300-FF-005324', NULL, 'tRNA (Adenosine(37)-N6)-threonylcarbamoyltransferase complex ATPase subunit type 1 TsaE', 156, NULL, NULL, 69192),
(69193, '2.60.40.420-FF-000170', NULL, 'Laccase 2', 197, NULL, NULL, 69193),
(69194, '1.20.120.330-FF-000038', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 169, NULL, NULL, 69194),
(69195, '2.120.10.30-FF-000345', NULL, 'Chloroplast protein HCF243', 151, NULL, NULL, 69195),
(69196, '2.30.29.30-FF-000280', NULL, 'Uncharacterized protein, isoform B', 106, NULL, NULL, 69196),
(69197, '3.30.160.60-FF-003031', NULL, NULL, 28, NULL, NULL, 69197),
(69198, '1.10.420.10-FF-000058', NULL, 'Uncharacterized protein', 54, NULL, NULL, 69198),
(69199, '1.20.1250.20-FF-001399', NULL, 'Major facilitator superfamily MFS_1', 189, NULL, NULL, 69199),
(69200, '3.30.2350.10-FF-000006', NULL, 'Pseudouridine synthase', 235, NULL, NULL, 69200),
(69201, '2.20.25.20-FF-000021', NULL, NULL, 52, NULL, NULL, 69201),
(69202, '2.60.120.260-FF-000215', NULL, 'Anaphase-promoting complex subunit 10', 60, NULL, NULL, 69202),
(69203, '3.30.70.330-FF-000915', NULL, 'Uncharacterized protein', 132, NULL, NULL, 69203),
(69204, '1.10.510.10-FF-003140', NULL, NULL, 181, NULL, NULL, 69204),
(69205, '1.20.120.720-FF-000048', NULL, 'Myosin-2 heavy chain', 137, NULL, NULL, 69205),
(69206, '3.30.70.600-FF-000002', NULL, '40S ribosomal protein S20', 115, NULL, NULL, 69206),
(69207, '3.40.50.80-FF-000190', NULL, 'Dihydroorotate dehydrogenase B (NAD(+)), electron transfer subunit', 108, NULL, NULL, 69207),
(69208, '1.10.238.10-FF-000696', NULL, 'Hypothetical_protein_-_conserved', 101, NULL, NULL, 69208),
(69209, '2.60.40.10-FF-000962', NULL, 'titin isoform X1', 102, NULL, NULL, 69209),
(69210, '3.40.50.410-FF-000231', NULL, 'Predicted protein', 47, NULL, NULL, 69210),
(69211, '3.40.50.11860-FF-000011', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', 72, NULL, NULL, 69211),
(69212, '1.20.1050.130-FF-000019', NULL, 'Uncharacterized protein', 44, NULL, NULL, 69212),
(69213, '3.40.50.300-FF-001053', NULL, 'Midasin', 168, NULL, NULL, 69213),
(69214, '1.10.10.60-FF-001204', NULL, NULL, 83, NULL, NULL, 69214),
(69215, '3.80.10.10-FF-003762', NULL, 'Leucine Rich Repeat family protein', 115, NULL, NULL, 69215),
(69216, '3.40.50.1580-FF-000047', NULL, 'Purine nucleoside phosphorylase', 311, NULL, NULL, 69216),
(69217, '3.30.420.40-FF-000437', NULL, 'Heat shock protein 70, putative', 101, NULL, NULL, 69217),
(69218, '3.30.70.330-FF-001984', NULL, NULL, 150, NULL, NULL, 69218),
(69219, '2.10.25.10-FF-001194', NULL, 'Delta/notch-like EGF repeat-containing', 41, NULL, NULL, 69219),
(69220, '3.30.750.140-FF-000001', NULL, 'Flagellar hook-length control protein', 114, NULL, NULL, 69220),
(69221, '3.40.50.720-FF-001959', NULL, '1-deoxy-11-beta-hydroxypentalenate dehydrogenase', 258, NULL, NULL, 69221),
(69222, '1.10.10.10-FF-001431', NULL, 'Origin recognition complex subunit 1', 97, NULL, NULL, 69222),
(69223, '3.40.50.150-FF-001417', NULL, NULL, 157, NULL, NULL, 69223),
(69224, '2.70.70.10-FF-000025', NULL, 'M23 family peptidase', 135, NULL, NULL, 69224),
(69225, '1.25.10.10-FF-002808', NULL, 'Uncharacterized protein', 201, NULL, NULL, 69225),
(69226, '2.60.40.10-FF-001451', NULL, 'immunoglobulin superfamily member 22', 104, NULL, NULL, 69226),
(69227, '1.20.1050.10-FF-000009', NULL, 'Glutathione S-transferase omega-1', 121, NULL, NULL, 69227),
(69228, '3.30.70.330-FF-002260', NULL, NULL, 97, NULL, NULL, 69228),
(69229, '2.30.30.100-FF-000180', NULL, 'Uncharacterized protein', 80, NULL, NULL, 69229),
(69230, '1.10.10.60-FF-000928', NULL, NULL, 42, NULL, NULL, 69230),
(69231, '3.40.50.300-FF-007011', NULL, 'Uncharacterized protein', 208, NULL, NULL, 69231),
(69232, '3.40.50.300-FF-006954', NULL, 'ABC transporter, ATP-binding protein', 223, NULL, NULL, 69232),
(69233, '3.90.190.20-FF-000045', NULL, 'Dihydrofolate synthase', 125, NULL, NULL, 69233),
(69234, '3.40.50.720-FF-002016', NULL, 'Probable UDP-glucose epimerase', 347, NULL, NULL, 69234);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(69235, '1.10.510.10-FF-002864', NULL, NULL, 196, NULL, NULL, 69235),
(69236, '1.10.10.60-FF-000709', NULL, 'GG10235', 102, NULL, NULL, 69236),
(69237, '2.30.42.10-FF-000142', NULL, 'Serine protease HTRA1', 103, NULL, NULL, 69237),
(69238, '3.40.50.2300-FF-000089', NULL, 'Sporulation initiation phosphotransferase F', 122, NULL, NULL, 69238),
(69239, '3.30.740.10-FF-000031', NULL, NULL, 53, NULL, NULL, 69239),
(69240, '1.25.40.10-FF-002529', NULL, 'DNAJ heat shock N-terminal domain-containing protein', 131, NULL, NULL, 69240),
(69241, '3.30.160.100-FF-000018', NULL, 'Ribosome hibernation promoting factor', 104, NULL, NULL, 69241),
(69242, '3.50.50.60-FF-000458', NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', 133, NULL, NULL, 69242),
(69243, '3.90.190.10-FF-000042', NULL, 'receptor-type tyrosine-protein phosphatase C isoform X1', 315, NULL, NULL, 69243),
(69244, '1.25.10.10-FF-001055', NULL, 'Tubulin-specific chaperone d', 178, NULL, NULL, 69244),
(69245, '3.60.40.10-FF-000105', NULL, 'Protein phosphatase 2C like domain containing 1', 327, NULL, NULL, 69245),
(69246, '3.40.50.300-FF-004487', NULL, 'ATPase involved in DNA repair', 258, NULL, NULL, 69246),
(69247, '2.130.10.10-FF-002626', NULL, 'Uncharacterized protein', 128, NULL, NULL, 69247),
(69248, '3.30.420.40-FF-000656', NULL, 'Actin-related protein 5', 49, NULL, NULL, 69248),
(69249, '3.90.1520.10-FF-000011', NULL, 'Soluble guanylate cyclase gcy-31', 188, NULL, NULL, 69249),
(69250, '2.10.25.10-FF-001749', NULL, 'Protein crumbs-like Protein', 37, NULL, NULL, 69250),
(69251, '3.30.830.10-FF-000257', NULL, 'Putative mitochondrial-processing peptidase subunit alpha-2 chloroplastic/mitochondrial', 95, NULL, NULL, 69251),
(69252, '3.40.50.10810-FF-000269', NULL, 'Uncharacterized protein', 213, NULL, NULL, 69252),
(69253, '3.30.70.330-FF-000354', NULL, 'RNA splicing factor Pad-1', 102, NULL, NULL, 69253),
(69254, '3.40.50.300-FF-002683', NULL, 'ABC Transporter, Mitochondrial', 260, NULL, NULL, 69254),
(69255, '3.30.200.20-FF-002253', NULL, 'AGC family protein kinase', 16, NULL, NULL, 69255),
(69256, '1.20.1070.10-FF-000224', NULL, 'Tachykinin receptor 2', 355, NULL, NULL, 69256),
(69257, '1.25.40.470-FF-000032', NULL, 'Coatomer alpha subunit, putative', 177, NULL, NULL, 69257),
(69258, '3.40.50.150-FF-000928', NULL, NULL, 265, NULL, NULL, 69258),
(69259, '3.40.640.10-FF-000375', NULL, 'Os01g0711400 protein', 146, NULL, NULL, 69259),
(69260, '2.130.10.10-FF-004088', NULL, 'Chromatin assembly factor I P60 subunit, putative', 200, NULL, NULL, 69260),
(69261, '2.30.42.10-FF-000361', NULL, 'LIM domain kinase 1 isoform X3', 62, NULL, NULL, 69261),
(69262, '3.30.1200.10-FF-000001', NULL, 'UPF0235 protein isoform X1', 100, NULL, NULL, 69262),
(69263, '3.30.70.3370-FF-000002', NULL, '40S ribosomal protein S24', 98, NULL, NULL, 69263),
(69264, '3.30.470.30-FF-000038', NULL, 'Uncharacterized protein', 167, NULL, NULL, 69264),
(69265, '3.10.100.10-FF-000381', NULL, NULL, 134, NULL, NULL, 69265),
(69266, '2.10.110.10-FF-000082', NULL, 'LIM domain kinase 1', 71, NULL, NULL, 69266),
(69267, '1.10.630.10-FF-000214', NULL, 'Os06g0640800 protein', 208, NULL, NULL, 69267),
(69268, '2.130.10.10-FF-001215', NULL, 'phosphoinositide 3-kinase regulatory subunit 4', 214, NULL, NULL, 69268),
(69269, '3.30.450.20-FF-000152', NULL, 'Phosphodiesterase', 136, NULL, NULL, 69269),
(69270, '2.60.40.10-FF-004891', NULL, NULL, 101, NULL, NULL, 69270),
(69271, '3.40.50.2000-FF-000336', NULL, 'Lipopolysaccharide biosynthesis protein', 153, NULL, NULL, 69271),
(69272, '1.10.490.10-FF-000006', NULL, 'Neuroglobin', 151, NULL, NULL, 69272),
(69273, '3.30.470.10-FF-000032', NULL, 'Branched-chain-amino-acid aminotransferase', 152, NULL, NULL, 69273),
(69274, '3.90.70.80-FF-000003', NULL, 'OTU domain-containing protein 6B', 152, NULL, NULL, 69274),
(69275, '3.30.70.580-FF-000064', NULL, 'tRNA pseudouridine synthase', 99, NULL, NULL, 69275),
(69276, '1.10.10.10-FF-001212', NULL, 'Transcriptional regulator ahyR/asaR family', 73, NULL, NULL, 69276),
(69277, '3.40.50.300-FF-007230', NULL, 'Predicted protein', 162, NULL, NULL, 69277);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(69278, '3.30.1060.10-FF-000012', NULL, 'Putative methionine-S-sulfoxide reductase', 210, NULL, NULL, 69278),
(69279, '3.30.470.20-FF-000035', NULL, 'Formate-dependent phosphoribosylglycinamide formyltransferase', 201, NULL, NULL, 69279),
(69280, '3.30.1370.10-FF-000097', NULL, 'Splicing factor-like protein 1 isoform A', 104, NULL, NULL, 69280),
(69281, '3.30.260.10-FF-000005', NULL, 'T-complex protein 1 subunit alpha', 111, NULL, NULL, 69281),
(69282, '3.90.1300.10-FF-000023', NULL, 'Amidase family protein', 487, NULL, NULL, 69282),
(69283, '1.20.120.660-FF-000002', NULL, 'Cag pathogenicity island protein', 33, NULL, NULL, 69283),
(69284, '2.60.220.50-FF-000152', NULL, 'Uncharacterized protein', 179, NULL, NULL, 69284),
(69285, '3.40.47.10-FF-000189', NULL, NULL, 70, NULL, NULL, 69285),
(69286, '1.25.10.10-FF-002466', NULL, 'Uncharacterized protein', 218, NULL, NULL, 69286),
(69287, '1.20.1080.10-FF-000056', NULL, 'MIP family channel protein', 266, NULL, NULL, 69287),
(69288, '1.20.58.60-FF-000504', NULL, 'Spectrin repeat-containing, nuclear envelope family member 3', 139, NULL, NULL, 69288),
(69289, '1.10.620.20-FF-000043', NULL, 'Uncharacterized protein', 326, NULL, NULL, 69289),
(69290, '3.30.56.10-FF-000025', NULL, 'Phenylalanine--tRNA ligase beta subunit', 71, NULL, NULL, 69290),
(69291, '3.40.190.290-FF-000129', NULL, 'Transcriptional regulator LysR family', 202, NULL, NULL, 69291),
(69292, '3.30.40.10-FF-000135', NULL, 'E3 ubiquitin-protein ligase mib1 isoform X1', 66, NULL, NULL, 69292),
(69293, '3.30.450.40-FF-000158', NULL, 'Stage II sporulation E family protein', 166, NULL, NULL, 69293),
(69294, '1.20.1560.10-FF-000424', NULL, 'ATP-dependent permease, mitochondrial, putative', 211, NULL, NULL, 69294),
(69295, '3.30.50.10-FF-000074', NULL, 'Nuclear receptor 1', 102, NULL, NULL, 69295),
(69296, '3.20.20.80-FF-000312', NULL, 'Uncharacterized protein', 261, NULL, NULL, 69296),
(69297, '3.30.9.10-FF-000299', NULL, 'Uncharacterized protein', 176, NULL, NULL, 69297),
(69298, '2.130.10.10-FF-002957', NULL, 'Dynein intermediate chain', 242, NULL, NULL, 69298),
(69299, '2.60.200.20-FF-000176', NULL, 'MAP kinase phosphatase 5', 127, NULL, NULL, 69299),
(69300, '3.30.70.330-FF-002259', NULL, NULL, 151, NULL, NULL, 69300),
(69301, '3.40.50.2300-FF-000651', NULL, 'Two-component response regulator', 80, NULL, NULL, 69301),
(69302, '3.30.565.10-FF-000247', NULL, 'Development and carotenogenesis control-1 protein', 197, NULL, NULL, 69302),
(69303, '1.20.1250.20-FF-000325', NULL, 'Transporter, major facilitator family protein', 192, NULL, NULL, 69303),
(69304, '2.70.50.40-FF-000010', NULL, 'protein unc-119 homolog B', 194, NULL, NULL, 69304),
(69305, '2.10.220.10-FF-000197', NULL, 'Erb-b2 receptor tyrosine kinase 3a', 61, NULL, NULL, 69305),
(69306, '3.30.300.30-FF-000037', NULL, 'acetoacetyl-CoA synthetase', 122, NULL, NULL, 69306),
(69307, '1.20.1070.10-FF-000117', NULL, 'adhesion G-protein coupled receptor G1', 274, NULL, NULL, 69307),
(69308, '3.30.1360.10-FF-000052', NULL, 'Uncharacterized protein', 78, NULL, NULL, 69308),
(69309, '2.160.20.10-FF-000057', NULL, 'Poly(Beta-D-mannuronate) C5 epimerase 3', 373, NULL, NULL, 69309),
(69310, '1.25.40.10-FF-002748', NULL, 'rRNA biogenesis protein, putative', 202, NULL, NULL, 69310),
(69311, '2.60.120.200-FF-000220', NULL, 'Collagen type XII alpha 1 chain', 143, NULL, NULL, 69311),
(69312, '3.40.50.300-FF-003290', NULL, 'Uncharacterized protein', 209, NULL, NULL, 69312),
(69313, '1.20.1420.30-FF-000033', NULL, 'YDL206W-like protein', 198, NULL, NULL, 69313),
(69314, '3.90.1150.10-FF-000319', NULL, 'Probable L-aspartate decarboxylase', 88, NULL, NULL, 69314),
(69315, '1.10.10.2480-FF-000004', NULL, 'Translation initiation factor IF-2', 67, NULL, NULL, 69315),
(69316, '1.10.287.630-FF-000001', NULL, 'Cyclic nucleotide-gated channel alpha 3', 66, NULL, NULL, 69316),
(69317, '3.20.20.100-FF-000204', NULL, 'Uncharacterized protein', 62, NULL, NULL, 69317),
(69318, '2.60.34.10-FF-000009', NULL, 'Hypoxia up-regulated protein 1', 151, NULL, NULL, 69318);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(69319, '3.60.15.10-FF-000249', NULL, '7,8-dihydropterin-6-methyl-4-(beta-D-ribofuranosyl)-aminobenzene-5''-phosphate synthase', 291, NULL, NULL, 69319),
(69320, '3.40.50.300-FF-001160', NULL, 'DNA helicase', 186, NULL, NULL, 69320),
(69321, '3.50.30.50-FF-000016', NULL, 'Uncharacterized protein', 247, NULL, NULL, 69321),
(69322, '3.40.50.970-FF-000039', NULL, 'Indolepyruvate oxidoreductase subunit IorA', 178, NULL, NULL, 69322),
(69323, '2.60.40.10-FF-005054', NULL, NULL, 101, NULL, NULL, 69323),
(69324, '3.50.50.60-FF-000127', NULL, 'Glucose-methanol-choline oxidoreductase', 301, NULL, NULL, 69324),
(69325, '3.40.50.300-FF-006628', NULL, 'ABC transporter, putative', 92, NULL, NULL, 69325),
(69326, '1.20.1250.20-FF-001961', NULL, 'Predicted protein', 423, NULL, NULL, 69326),
(69327, '3.80.10.10-FF-002019', NULL, 'Protein CBG18939', 137, NULL, NULL, 69327),
(69328, '3.30.160.60-FF-005610', NULL, NULL, 22, NULL, NULL, 69328),
(69329, '3.90.640.10-FF-000021', NULL, 'Heat shock protein 14', 84, NULL, NULL, 69329),
(69330, '1.20.1560.10-FF-000082', NULL, 'ABC transporter, multidrug resistance associated protein', 320, NULL, NULL, 69330),
(69331, '3.30.1310.10-FF-000009', NULL, 'Nucleoid-associated protein TC_0612', 94, NULL, NULL, 69331),
(69332, '1.10.8.840-FF-000003', NULL, 'DNaJ domain (Prokaryotic heat shock protein)', 93, NULL, NULL, 69332),
(69333, '3.40.50.1240-FF-000187', NULL, NULL, 93, NULL, NULL, 69333),
(69334, '3.40.50.2000-FF-000662', NULL, 'Glycosyl transferase group 1', 229, NULL, NULL, 69334),
(69335, '2.40.50.140-FF-000564', NULL, '30S ribosomal protein S1', 83, NULL, NULL, 69335),
(69336, '3.90.550.10-FF-000368', NULL, 'Protein with potential galactosyl transferase activity', 175, NULL, NULL, 69336),
(69337, '3.40.1230.10-FF-000006', NULL, 'Protein_of_uncharacterized_function_(DUF498/DUF59 8)_-_putative', 116, NULL, NULL, 69337),
(69338, '2.60.40.150-FF-000757', NULL, 'Predicted protein', 143, NULL, NULL, 69338),
(69339, '1.20.1050.10-FF-000116', NULL, 'Thiol-dependent reductase 1', 139, NULL, NULL, 69339),
(69340, '2.60.40.10-FF-005161', NULL, NULL, 119, NULL, NULL, 69340),
(69341, '2.130.10.10-FF-000827', NULL, 'Protein HIRA', 231, NULL, NULL, 69341),
(69342, '2.120.10.10-FF-000007', NULL, 'Hemagglutinin glycoprotein', 472, NULL, NULL, 69342),
(69343, '1.10.10.10-FF-000375', NULL, 'Interferon regulatory factor 7', 118, NULL, NULL, 69343),
(69344, '1.10.510.10-FF-003033', NULL, NULL, 221, NULL, NULL, 69344),
(69345, '1.20.144.10-FF-000083', NULL, 'Uncharacterized protein', 261, NULL, NULL, 69345),
(69346, '3.30.70.20-FF-000078', NULL, 'ABC transporter related', 75, NULL, NULL, 69346),
(69347, '2.160.20.10-FF-000063', NULL, 'Pectin esterase', 318, NULL, NULL, 69347),
(69348, '3.30.1380.20-FF-000056', NULL, 'Predicted protein', 129, NULL, NULL, 69348),
(69349, '1.10.1520.10-FF-000031', NULL, 'Dicer-like protein 4', 165, NULL, NULL, 69349),
(69350, '1.25.40.10-FF-002855', NULL, 'Putative pentatricopeptide repeat-containing protein', 108, NULL, NULL, 69350),
(69351, '3.40.850.10-FF-000424', NULL, 'Di-glucose binding with Kinesin motor domain-like protein', 171, NULL, NULL, 69351),
(69352, '3.40.50.800-FF-000022', NULL, 'Histidine--tRNA ligase', 97, NULL, NULL, 69352),
(69353, '2.30.230.10-FF-000035', NULL, 'Uncharacterized protein (Fragment)', 177, NULL, NULL, 69353),
(69354, '3.10.10.10-FF-000027', NULL, NULL, 78, NULL, NULL, 69354),
(69355, '1.20.58.60-FF-000055', NULL, 'Short stop, isoform K', 210, NULL, NULL, 69355),
(69356, '3.30.420.10-FF-000102', NULL, 'Gag-Pol polyprotein', 176, NULL, NULL, 69356),
(69357, '3.80.10.10-FF-003655', NULL, 'F-box/leucine rich repeat protein, putative', 111, NULL, NULL, 69357),
(69358, '2.20.70.10-FF-000229', NULL, 'Predicted protein', 61, NULL, NULL, 69358),
(69359, '3.40.50.1980-FF-000066', NULL, 'Vibriobactin and enterobactin ABC transporter, periplasmic ferric vibriobactin/enterobactin-binding protein', 181, NULL, NULL, 69359),
(69360, '3.40.190.10-FF-000396', NULL, 'Glutamate receptor', 115, NULL, NULL, 69360),
(69361, '3.40.50.10730-FF-000003', NULL, 'Urocanate hydratase 1', 139, NULL, NULL, 69361);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(69362, '3.40.50.1970-FF-000063', NULL, NULL, 70, NULL, NULL, 69362),
(69363, '3.20.20.70-FF-000202', NULL, 'Alpha-galactosidase', 295, NULL, NULL, 69363),
(69364, '3.20.20.80-FF-000205', NULL, 'Unplaced genomic scaffold supercont1.19, whole genome shotgun sequence', 170, NULL, NULL, 69364),
(69365, '3.30.450.20-FF-000040', NULL, 'Phosphodiesterase', 152, NULL, NULL, 69365),
(69366, '2.30.42.10-FF-000473', NULL, NULL, 118, NULL, NULL, 69366),
(69367, '3.30.60.60-FF-000016', NULL, 'Histone acetyltransferase', 49, NULL, NULL, 69367),
(69368, '2.30.30.40-FF-000365', NULL, 'Endophilin-A homolog', 69, NULL, NULL, 69368),
(69369, '3.30.160.60-FF-004992', NULL, NULL, 62, NULL, NULL, 69369),
(69370, '1.20.120.220-FF-000005', NULL, 'ATP synthase subunit a', 166, NULL, NULL, 69370),
(69371, '3.40.50.720-FF-002241', NULL, 'Chromosome 15, whole genome shotgun sequence', 87, NULL, NULL, 69371),
(69372, '3.40.50.11850-FF-000002', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', 117, NULL, NULL, 69372),
(69373, '3.40.50.1820-FF-000046', NULL, 'Putative lysophospholipase', 339, NULL, NULL, 69373),
(69374, '1.20.1070.10-FF-001753', NULL, 'Predicted protein', 78, NULL, NULL, 69374),
(69375, '2.60.120.650-FF-000113', NULL, 'JmjC domain containing protein, expressed', 340, NULL, NULL, 69375),
(69376, '3.30.420.40-FF-001044', NULL, 'Uncharacterized protein', 15, NULL, NULL, 69376),
(69377, '3.40.50.2300-FF-000319', NULL, 'HTH-type transcriptional repressor PurR', 131, NULL, NULL, 69377),
(69378, '1.25.40.10-FF-000618', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 212, NULL, NULL, 69378),
(69379, '1.25.40.420-FF-000040', NULL, 'Kelch-like ECH-associated protein 1', 34, NULL, NULL, 69379),
(69380, '2.60.40.10-FF-000849', NULL, 'Uncharacterized protein, isoform F', 100, NULL, NULL, 69380),
(69381, '3.30.70.330-FF-000129', NULL, 'DAZ-associated protein 1 isoform X1', 129, NULL, NULL, 69381),
(69382, '3.40.50.1470-FF-000019', NULL, 'Peptidyl-tRNA hydrolase chloroplastic', 86, NULL, NULL, 69382),
(69383, '3.40.50.300-FF-001047', NULL, 'DExH-box ATP-dependent RNA helicase DExH11', 283, NULL, NULL, 69383),
(69384, '2.40.50.90-FF-000032', NULL, 'Tudor domain containing 1', 104, NULL, NULL, 69384),
(69385, '1.20.1540.10-FF-000081', NULL, 'Rhomboid protein 2', 188, NULL, NULL, 69385),
(69386, '3.30.160.60-FF-002862', NULL, 'STP2p Transcription factor', 62, NULL, NULL, 69386),
(69387, '3.30.2310.10-FF-000009', NULL, 'Predicted protein', 109, NULL, NULL, 69387),
(69388, '1.10.472.10-FF-000285', NULL, 'Cyclin I family member 2', 93, NULL, NULL, 69388),
(69389, '3.40.50.11860-FF-000005', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', 105, NULL, NULL, 69389),
(69390, '3.30.160.60-FF-001007', NULL, 'Zinc finger protein 1184', 28, NULL, NULL, 69390),
(69391, '3.10.20.90-FF-001018', NULL, 'Uncharacterized protein', 116, NULL, NULL, 69391),
(69392, '3.40.50.300-FF-006960', NULL, 'Sulfotransferase', 222, NULL, NULL, 69392),
(69393, '2.30.29.30-FF-000510', NULL, 'Switch-associated protein 70', 111, NULL, NULL, 69393),
(69394, '3.40.50.620-FF-000631', NULL, 'Electron transfer flavoprotein subunit alpha/FixB family protein', 157, NULL, NULL, 69394),
(69395, '3.30.200.20-FF-000903', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 51, NULL, NULL, 69395),
(69396, '2.60.40.10-FF-000956', NULL, 'T-cell surface glycoprotein CD8 alpha chain', 123, NULL, NULL, 69396),
(69397, '3.30.40.10-FF-000247', NULL, 'Uncharacterized protein, isoform B', 129, NULL, NULL, 69397),
(69398, '3.30.40.10-FF-001989', NULL, 'Uncharacterized protein', 55, NULL, NULL, 69398),
(69399, '1.10.472.10-FF-000392', NULL, 'Uncharacterized protein', 108, NULL, NULL, 69399),
(69400, '1.10.286.40-FF-000001', NULL, 'Photosystem I reaction center subunit psaK', 84, NULL, NULL, 69400),
(69401, '1.25.40.10-FF-000950', NULL, 'Pentatricopeptide repeat-containing protein', 151, NULL, NULL, 69401),
(69402, '2.130.10.10-FF-004195', NULL, 'Chromosome 10, whole genome shotgun sequence', 159, NULL, NULL, 69402);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(69403, '2.40.30.10-FF-000518', NULL, 'Ribosome-releasing factor 2, mitochondrial', 108, NULL, NULL, 69403),
(69404, '3.30.160.60-FF-002755', NULL, 'Uncharacterized protein', 31, NULL, NULL, 69404),
(69405, '1.20.58.1560-FF-000001', NULL, 'Malate synthase', 101, NULL, NULL, 69405),
(69406, '3.60.110.10-FF-000072', NULL, NULL, 125, NULL, NULL, 69406),
(69407, '3.30.160.60-FF-004879', NULL, NULL, 30, NULL, NULL, 69407),
(69408, '3.90.840.10-FF-000002', NULL, 'Thiol-activated cytolysin', 177, NULL, NULL, 69408),
(69409, '1.10.8.270-FF-000147', NULL, 'GTPase-activating protein gyp2', 100, NULL, NULL, 69409),
(69410, '3.60.40.10-FF-000212', NULL, 'Unplaced genomic scaffold supercont2.2, whole genome shotgun sequence', 279, NULL, NULL, 69410),
(69411, '1.10.10.10-FF-000268', NULL, 'DNA translocase FtsK', 65, NULL, NULL, 69411),
(69412, '1.10.510.10-FF-003252', NULL, NULL, 114, NULL, NULL, 69412),
(69413, '3.10.129.10-FF-000250', NULL, 'Putative esterase aq_1494', 128, NULL, NULL, 69413),
(69414, '1.25.40.20-FF-000953', NULL, 'Predicted protein', 117, NULL, NULL, 69414),
(69415, '1.20.1250.20-FF-001629', NULL, 'Sugar phosphate exchanger 3', 110, NULL, NULL, 69415),
(69416, '3.40.50.300-FF-002576', NULL, 'ABC transporter, putative', 244, NULL, NULL, 69416),
(69417, '3.30.1520.10-FF-000042', NULL, 'Sorting nexin mvp1', 131, NULL, NULL, 69417),
(69418, '3.30.200.20-FF-002360', NULL, 'Zgc:112307 protein', 30, NULL, NULL, 69418),
(69419, '3.30.70.330-FF-000461', NULL, 'Serine/arginine-rich splicing factor SR45', 174, NULL, NULL, 69419),
(69420, '2.60.40.1890-FF-000001', NULL, NULL, 107, NULL, NULL, 69420),
(69421, '3.80.10.10-FF-003874', NULL, 'Leucine rich repeat containing 1', 109, NULL, NULL, 69421),
(69422, '2.40.30.270-FF-000037', NULL, 'Immunoglobulin mu DNA binding protein 2', 54, NULL, NULL, 69422),
(69423, '3.40.50.300-FF-006847', NULL, 'Sulfotransferase', 262, NULL, NULL, 69423),
(69424, '1.10.10.60-FF-000816', NULL, NULL, 84, NULL, NULL, 69424),
(69425, '3.90.1140.10-FF-000038', NULL, 'Uncharacterized protein', 78, NULL, NULL, 69425),
(69426, '2.30.42.10-FF-000254', NULL, 'Caspase recruitment domain family, member 14', 93, NULL, NULL, 69426),
(69427, '3.40.50.150-FF-001081', NULL, 'Ubiquinone biosynthesis O-methyltransferase, mitochondrial', 236, NULL, NULL, 69427),
(69428, '3.30.200.20-FF-000667', NULL, 'PTI1-like tyrosine-protein kinase 3', 99, NULL, NULL, 69428),
(69429, '2.130.10.10-FF-002177', NULL, 'Hybrid sensor histidine kinase/response regulator', 319, NULL, NULL, 69429),
(69430, '3.40.50.2000-FF-000443', NULL, 'Uncharacterized UDP-glucosyltransferase YjiC', 212, NULL, NULL, 69430),
(69431, '1.20.120.230-FF-000008', NULL, 'Catenin alpha 1', 119, NULL, NULL, 69431),
(69432, '2.160.20.10-FF-000170', NULL, 'Cell surface protein', 136, NULL, NULL, 69432),
(69433, '2.10.110.10-FF-000317', NULL, 'Uncharacterized protein', 40, NULL, NULL, 69433),
(69434, '2.160.20.10-FF-000282', NULL, 'Uncharacterized protein', 197, NULL, NULL, 69434),
(69435, '3.40.47.10-FF-000083', NULL, 'Probable acyl-CoA thiolase', 214, NULL, NULL, 69435),
(69436, '3.40.1010.30-FF-000001', NULL, 'Chromo domain-containing protein 1', 145, NULL, NULL, 69436),
(69437, '1.10.760.10-FF-000095', NULL, 'Nitrite reductase protein N', 94, NULL, NULL, 69437),
(69438, '3.30.500.10-FF-000047', NULL, NULL, 105, NULL, NULL, 69438),
(69439, '3.40.50.261-FF-000047', NULL, 'Uncharacterized protein', 55, NULL, NULL, 69439),
(69440, '1.20.58.70-FF-000058', NULL, 'Syntaxin 19', 124, NULL, NULL, 69440),
(69441, '1.20.120.1240-FF-000065', NULL, 'Dynamin-related GTPase', 82, NULL, NULL, 69441),
(69442, '3.30.160.60-FF-000389', NULL, 'Zinc finger protein', 28, NULL, NULL, 69442),
(69443, '3.80.10.10-FF-000221', NULL, 'Leucine-rich repeat receptor-like protein kinase PXL1', 99, NULL, NULL, 69443),
(69444, '3.40.50.300-FF-004594', NULL, 'ATP-dependent 3''-5'' DNA helicase', 158, NULL, NULL, 69444),
(69445, '3.30.40.10-FF-000360', NULL, 'E3 ubiquitin-protein ligase, putative', 84, NULL, NULL, 69445),
(69446, '3.30.70.270-FF-000201', NULL, NULL, 106, NULL, NULL, 69446);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(69447, '3.30.70.870-FF-000049', NULL, 'Uncharacterized protein', 73, NULL, NULL, 69447),
(69448, '3.50.50.60-FF-000346', NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', 253, NULL, NULL, 69448),
(69449, '2.130.10.10-FF-005032', NULL, 'Uncharacterized protein', 301, NULL, NULL, 69449),
(69450, '1.10.472.10-FF-000515', NULL, 'Uncharacterized protein', 98, NULL, NULL, 69450),
(69451, '1.50.10.20-FF-000140', NULL, 'Alpha-onocerin synthase LCD', 354, NULL, NULL, 69451),
(69452, '1.25.40.10-FF-000731', NULL, 'Pentatricopeptide repeat-containing protein', 153, NULL, NULL, 69452),
(69453, '2.60.40.10-FF-004447', NULL, NULL, 112, NULL, NULL, 69453),
(69454, '2.40.128.680-FF-000002', NULL, 'Ribonuclease H2 non-catalytic subunit (Ylr154p-like), putative', 153, NULL, NULL, 69454),
(69455, '3.40.50.720-FF-002128', NULL, 'Carbon monoxide dehydrogenase F protein', 106, NULL, NULL, 69455),
(69456, '3.40.50.1820-FF-001569', NULL, 'Uncharacterized protein', 112, NULL, NULL, 69456),
(69457, '2.120.10.30-FF-000452', NULL, 'Uncharacterized protein', 100, NULL, NULL, 69457),
(69458, '3.40.50.620-FF-000412', NULL, 'Leucine--tRNA ligase', 192, NULL, NULL, 69458),
(69459, '3.30.720.200-FF-000007', NULL, 'Uncharacterized protein', 67, NULL, NULL, 69459),
(69460, '3.40.50.300-FF-005431', NULL, 'Predicted protein', 219, NULL, NULL, 69460),
(69461, '3.30.565.10-FF-000466', NULL, 'Putative heat shock protein HSP 90-beta 4', 210, NULL, NULL, 69461),
(69462, '1.20.1250.20-FF-001848', NULL, 'Protein CBG12247', 133, NULL, NULL, 69462),
(69463, '1.20.1280.290-FF-000091', NULL, 'Predicted protein', 115, NULL, NULL, 69463),
(69464, '2.60.40.150-FF-000538', NULL, 'ER-targeted preprotein translocase subunit', 139, NULL, NULL, 69464),
(69465, '3.90.640.10-FF-000240', NULL, 'Uncharacterized protein', 32, NULL, NULL, 69465),
(69466, '3.30.559.70-FF-000059', NULL, 'Choline O-acetyltransferase', 97, NULL, NULL, 69466),
(69467, '3.40.50.720-FF-000094', NULL, 'Bifunctional protein FolD', 122, NULL, NULL, 69467),
(69468, '3.30.160.60-FF-003250', NULL, 'zinc finger protein 579', 25, NULL, NULL, 69468),
(69469, '2.40.50.40-FF-000045', NULL, 'Chromo domain-containing protein 1', 56, NULL, NULL, 69469),
(69470, '3.30.260.10-FF-000112', NULL, NULL, 21, NULL, NULL, 69470),
(69471, '3.40.630.10-FF-000442', NULL, 'Uncharacterized protein', 219, NULL, NULL, 69471),
(69472, '3.80.10.10-FF-002126', NULL, 'Uncharacterized protein', 147, NULL, NULL, 69472),
(69473, '3.40.50.2300-FF-000538', NULL, 'Trehalose operon transcriptional repressor', 117, NULL, NULL, 69473),
(69474, '3.40.350.10-FF-000055', NULL, 'Uncharacterized protein', 152, NULL, NULL, 69474),
(69475, '2.60.120.260-FF-000653', NULL, 'Beta-galactosidase', 133, NULL, NULL, 69475),
(69476, '1.10.10.60-FF-001311', NULL, NULL, 61, NULL, NULL, 69476),
(69477, '3.30.1120.30-FF-000051', NULL, 'Serine/threonine-protein kinase', 61, NULL, NULL, 69477),
(69478, '1.10.10.10-FF-000829', NULL, 'LysR family transcriptional regulator', 91, NULL, NULL, 69478),
(69479, '3.90.1150.10-FF-000426', NULL, 'Serine--pyruvate aminotransferase', 61, NULL, NULL, 69479),
(69480, '3.30.160.60-FF-001226', NULL, 'Combgap, isoform F', 27, NULL, NULL, 69480),
(69481, '1.10.600.10-FF-000044', NULL, '(2Z,6E)-hedycaryol synthase', 316, NULL, NULL, 69481),
(69482, '3.40.50.970-FF-000152', NULL, 'Indolepyruvate oxidoreductase subunit IorA', 169, NULL, NULL, 69482),
(69483, '1.10.418.10-FF-000238', NULL, 'Uncharacterized protein', 56, NULL, NULL, 69483),
(69484, '3.20.20.80-FF-000082', NULL, '4-alpha-glucanotransferase', 521, NULL, NULL, 69484),
(69485, '2.20.110.10-FF-000034', NULL, NULL, 55, NULL, NULL, 69485),
(69486, '2.60.40.10-FF-001013', NULL, 'Complement C3', 101, NULL, NULL, 69486),
(69487, '1.20.1090.10-FF-000006', NULL, '3-dehydroquinate synthase', 187, NULL, NULL, 69487),
(69488, '3.90.226.10-FF-000098', NULL, 'GD18835', 207, NULL, NULL, 69488),
(69489, '2.60.120.200-FF-000113', NULL, 'Calreticulin 3', 33, NULL, NULL, 69489),
(69490, '1.20.1280.290-FF-000102', NULL, 'Uncharacterized protein', 123, NULL, NULL, 69490);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(69491, '3.40.190.10-FF-000177', NULL, 'Glutamate [NMDA] receptor subunit 1', 171, NULL, NULL, 69491),
(69492, '1.25.10.10-FF-001504', NULL, 'Formin-E', 331, NULL, NULL, 69492),
(69493, '3.10.450.120-FF-000005', NULL, 'PUA domain protein', 47, NULL, NULL, 69493),
(69494, '2.10.25.10-FF-000120', NULL, 'Protein kinase C-binding protein NELL1', 44, NULL, NULL, 69494),
(69495, '1.10.3720.10-FF-000159', NULL, 'Putative oligopeptide ABC transporter permease protein', 212, NULL, NULL, 69495),
(69496, '1.10.260.170-FF-000012', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', 138, NULL, NULL, 69496),
(69497, '1.25.10.10-FF-002359', NULL, 'Rapamycin-insensitive companion of mTOR, putative', 281, NULL, NULL, 69497),
(69498, '3.30.1360.140-FF-000006', NULL, 'DNA-directed RNA polymerase subunit', 130, NULL, NULL, 69498),
(69499, '3.30.200.20-FF-000780', NULL, 'Tyrosine-protein kinase PR2', 92, NULL, NULL, 69499),
(69500, '3.30.70.3490-FF-000038', NULL, NULL, 44, NULL, NULL, 69500),
(69501, '1.10.472.80-FF-000030', NULL, 'TBC1 domain family member 8 isoform X2', 163, NULL, NULL, 69501),
(69502, '2.30.30.40-FF-000584', NULL, 'Uncharacterized protein', 90, NULL, NULL, 69502),
(69503, '2.160.20.10-FF-000169', NULL, 'Protein CBG15150', 170, NULL, NULL, 69503),
(69504, '1.25.40.10-FF-005042', NULL, 'Uncharacterized protein', 126, NULL, NULL, 69504),
(69505, '1.20.1070.10-FF-001859', NULL, 'Tachykinin receptor 2', 296, NULL, NULL, 69505),
(69506, '2.170.130.10-FF-000034', NULL, 'TonB-dependent receptor', 117, NULL, NULL, 69506),
(69507, '1.10.2020.20-FF-000013', NULL, NULL, 82, NULL, NULL, 69507),
(69508, '3.30.160.60-FF-004099', NULL, NULL, 44, NULL, NULL, 69508),
(69509, '3.30.450.40-FF-000265', NULL, 'Uncharacterized protein', 42, NULL, NULL, 69509),
(69510, '2.60.120.200-FF-000332', NULL, 'LAMinin related. See also lmb', 210, NULL, NULL, 69510),
(69511, '2.40.110.10-FF-000058', NULL, 'Pimeloyl-CoA dehydrogenase small subunit', 114, NULL, NULL, 69511),
(69512, '3.30.43.10-FF-000052', NULL, 'Predicted protein', 59, NULL, NULL, 69512),
(69513, '2.40.70.10-FF-000392', NULL, NULL, 184, NULL, NULL, 69513),
(69514, '3.30.450.20-FF-000601', NULL, 'Uncharacterized protein', 147, NULL, NULL, 69514),
(69515, '3.30.70.330-FF-002153', NULL, NULL, 108, NULL, NULL, 69515),
(69516, '1.25.40.10-FF-001113', NULL, 'Ypp1p', 144, NULL, NULL, 69516),
(69517, '3.90.1150.10-FF-000207', NULL, 'Serine hydroxymethyltransferase', 154, NULL, NULL, 69517),
(69518, '3.40.390.10-FF-000164', NULL, NULL, 89, NULL, NULL, 69518),
(69519, '1.20.5.1150-FF-000002', NULL, '28S ribosomal protein S21, mitochondrial', 36, NULL, NULL, 69519),
(69520, '1.25.40.10-FF-000495', NULL, 'AAA family ATPase', 239, NULL, NULL, 69520),
(69521, '1.10.1170.10-FF-000009', NULL, 'Baculoviral IAP repeat-containing protein 5', 141, NULL, NULL, 69521),
(69522, '3.30.710.10-FF-000422', NULL, 'Uncharacterized protein', 111, NULL, NULL, 69522),
(69523, '1.50.10.20-FF-000027', NULL, 'Terpene cyclase/mutase family member', 287, NULL, NULL, 69523),
(69524, '2.130.10.10-FF-004650', NULL, 'Uncharacterized protein', 190, NULL, NULL, 69524),
(69525, '3.80.10.10-FF-000440', NULL, 'Ribonuclease inhibitor', 457, NULL, NULL, 69525),
(69526, '3.80.10.10-FF-004037', NULL, 'F-box/LRR-repeat protein 4-like Protein', 144, NULL, NULL, 69526),
(69527, '1.10.510.10-FF-001009', NULL, 'Atypical/RIO/RIO2 protein kinase', 97, NULL, NULL, 69527),
(69528, '2.60.40.60-FF-000836', NULL, 'Uncharacterized protein', 109, NULL, NULL, 69528),
(69529, '1.10.287.110-FF-000295', NULL, 'ER organization and biogenesis-related protein, putative', 102, NULL, NULL, 69529),
(69530, '2.40.50.140-FF-000345', NULL, 'RecQ-mediated genome instability-like protein', 128, NULL, NULL, 69530),
(69531, '2.60.40.10-FF-002867', NULL, 'T-cell surface antigen CD2', 103, NULL, NULL, 69531),
(69532, '1.25.40.20-FF-001116', NULL, 'Predicted protein', 220, NULL, NULL, 69532),
(69533, '1.10.3430.10-FF-000058', NULL, 'Uncharacterized protein', 146, NULL, NULL, 69533),
(69534, '1.10.10.10-FF-000487', NULL, 'Meiotic recombination protein SPO11-2', 146, NULL, NULL, 69534);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(69535, '2.30.30.1230-FF-000001', NULL, 'Envelope glycoprotein B', 98, NULL, NULL, 69535),
(69536, '2.115.10.20-FF-000017', NULL, 'Uncharacterized protein', 112, NULL, NULL, 69536),
(69537, '1.20.1510.10-FF-000034', NULL, 'Protein CBG00606', 204, NULL, NULL, 69537),
(69538, '3.30.230.10-FF-000273', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 162, NULL, NULL, 69538),
(69539, '3.40.50.720-FF-000330', NULL, 'UDP-glucose lipid carrier transferase', 120, NULL, NULL, 69539),
(69540, '1.20.5.1160-FF-000005', NULL, 'vasodilator-stimulated phosphoprotein isoform X2', 45, NULL, NULL, 69540),
(69541, '2.40.50.120-FF-000007', NULL, 'Metalloproteinase inhibitor 2', 94, NULL, NULL, 69541),
(69542, '3.40.190.10-FF-000290', NULL, 'Putative ABC transporter substrate-binding protein', 85, NULL, NULL, 69542),
(69543, '1.10.287.70-FF-000310', NULL, 'Uncharacterized protein', 129, NULL, NULL, 69543),
(69544, '3.55.60.10-FF-000001', NULL, 'Outer capsid protein lambda-2', 142, NULL, NULL, 69544),
(69545, '4.10.1240.30-FF-000013', NULL, NULL, 82, NULL, NULL, 69545),
(69546, '3.40.50.2300-FF-000870', NULL, NULL, 45, NULL, NULL, 69546),
(69547, '3.60.20.10-FF-000104', NULL, 'YML096W-like protein', 161, NULL, NULL, 69547),
(69548, '2.130.10.10-FF-002738', NULL, 'Sec13', 279, NULL, NULL, 69548),
(69549, '3.40.50.300-FF-003413', NULL, 'OSJNBb0016D16.17 protein', 170, NULL, NULL, 69549),
(69550, '2.60.120.330-FF-000011', NULL, 'Aspartate beta-hydroxylase domain-containing protein 2', 198, NULL, NULL, 69550),
(69551, '3.30.160.60-FF-001900', NULL, 'ZFP30 zinc finger protein', 33, NULL, NULL, 69551),
(69552, '3.40.50.150-FF-000816', NULL, NULL, 109, NULL, NULL, 69552),
(69553, '2.170.270.10-FF-000196', NULL, 'Uncharacterized protein', 283, NULL, NULL, 69553),
(69554, '3.80.10.10-FF-001963', NULL, 'Putative F-box/LRR-repeat protein 19', 210, NULL, NULL, 69554),
(69555, '3.40.50.300-FF-002795', NULL, 'RecBCD enzyme subunit RecD', 274, NULL, NULL, 69555),
(69556, '1.20.1070.10-FF-000336', NULL, 'Probable G-protein coupled receptor 160', 280, NULL, NULL, 69556),
(69557, '1.20.1250.20-FF-000106', NULL, 'MFS transporter, putative', 202, NULL, NULL, 69557),
(69558, '2.60.40.60-FF-000494', NULL, 'Uncharacterized protein', 67, NULL, NULL, 69558),
(69559, '3.30.900.10-FF-000015', NULL, 'DNA polymerase zeta subunit', 218, NULL, NULL, 69559),
(69560, '2.40.70.10-FF-000279', NULL, 'Pepsin A', 186, NULL, NULL, 69560),
(69561, '3.30.750.24-FF-000174', NULL, 'Sulfate permease', 77, NULL, NULL, 69561),
(69562, '2.130.10.10-FF-002396', NULL, 'U4/U6-U5 snRNP complex subunit', 63, NULL, NULL, 69562),
(69563, '3.30.465.10-FF-000071', NULL, 'CBS domain containing protein', 80, NULL, NULL, 69563),
(69564, '3.40.640.10-FF-000487', NULL, 'Alanine aminotransferase 2 mitochondrial', 49, NULL, NULL, 69564),
(69565, '1.25.40.370-FF-000002', NULL, 'Telomerase associated protein 1', 138, NULL, NULL, 69565),
(69566, '1.10.357.140-FF-000022', NULL, 'Protoheme IX farnesyltransferase', 163, NULL, NULL, 69566),
(69567, '2.60.120.340-FF-000014', NULL, 'Uncharacterized protein', 115, NULL, NULL, 69567),
(69568, '2.10.25.10-FF-001643', NULL, 'Uncharacterized protein', 75, NULL, NULL, 69568),
(69569, '1.25.10.10-FF-000903', NULL, 'Exportin-4 protein', 435, NULL, NULL, 69569),
(69570, '2.170.300.10-FF-000070', NULL, 'Uncharacterized protein', 63, NULL, NULL, 69570),
(69571, '3.30.200.20-FF-000448', NULL, 'cyclin-dependent kinase 19 isoform X2', 39, NULL, NULL, 69571),
(69572, '3.40.50.10050-FF-000007', NULL, 'Sporozoite surface antigen MB2', 106, NULL, NULL, 69572),
(69573, '3.40.250.10-FF-000002', NULL, 'TBC1 domain family member 23', 128, NULL, NULL, 69573),
(69574, '3.30.70.330-FF-001877', NULL, NULL, 99, NULL, NULL, 69574),
(69575, '3.40.225.10-FF-000040', NULL, NULL, 199, NULL, NULL, 69575),
(69576, '3.30.760.10-FF-000026', NULL, 'Eukaryotic translation initiation factor 4E', 166, NULL, NULL, 69576),
(69577, '3.30.450.60-FF-000023', NULL, 'Signal sequence receptor alpha subunit', 132, NULL, NULL, 69577),
(69578, '3.40.50.300-FF-004936', NULL, 'Uncharacterized protein', 172, NULL, NULL, 69578);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(69579, '1.20.1250.10-FF-000103', NULL, NULL, 156, NULL, NULL, 69579),
(69580, '3.40.50.10190-FF-000021', NULL, 'DNA topoisomerase II binding protein 1', 103, NULL, NULL, 69580),
(69581, '3.40.50.300-FF-003071', NULL, 'Uncharacterized protein', 358, NULL, NULL, 69581),
(69582, '3.30.710.10-FF-000080', NULL, 'kelch-like protein 7 isoform X1', 161, NULL, NULL, 69582),
(69583, '2.40.30.160-FF-000010', NULL, 'Uncharacterized protein', 107, NULL, NULL, 69583),
(69584, '2.40.30.170-FF-000013', NULL, 'Glycoside hydrolase family 43', 99, NULL, NULL, 69584),
(69585, '3.40.50.300-FF-005212', NULL, 'Uncharacterized protein', 209, NULL, NULL, 69585),
(69586, '3.40.190.290-FF-000017', NULL, 'LysR family transcriptional regulator', 197, NULL, NULL, 69586),
(69587, '3.80.10.10-FF-000108', NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3', 287, NULL, NULL, 69587),
(69588, '3.30.720.50-FF-000013', NULL, 'Protein deltex', 68, NULL, NULL, 69588),
(69589, '1.20.1070.10-FF-002135', NULL, 'Uncharacterized protein', 254, NULL, NULL, 69589),
(69590, '3.90.70.10-FF-000707', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 210, NULL, NULL, 69590),
(69591, '1.20.1560.10-FF-000312', NULL, 'ATP-binding cassette sub-family D member 2', 354, NULL, NULL, 69591),
(69592, '3.30.1220.10-FF-000002', NULL, 'At1g80480', 142, NULL, NULL, 69592),
(69593, '3.30.450.70-FF-000026', NULL, 'TRansport Protein Particle', 139, NULL, NULL, 69593),
(69594, '1.10.510.10-FF-001341', NULL, 'Uncharacterized protein', 336, NULL, NULL, 69594),
(69595, '3.80.10.10-FF-001744', NULL, 'GD14831', 385, NULL, NULL, 69595),
(69596, '1.20.58.390-FF-000259', NULL, 'Uncharacterized protein', 97, NULL, NULL, 69596),
(69597, '3.90.260.10-FF-000048', NULL, 'AGAP001967-PA', 263, NULL, NULL, 69597),
(69598, '1.20.58.60-FF-000274', NULL, 'dystrophin isoform X2', 135, NULL, NULL, 69598),
(69599, '1.10.510.10-FF-000846', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase SD3-1', 79, NULL, NULL, 69599),
(69600, '4.10.60.10-FF-000247', NULL, 'ATP-dependent RNA helicase glh-3', 109, NULL, NULL, 69600),
(69601, '4.10.1060.10-FF-000021', NULL, 'MUTL protein homolog 3', 36, NULL, NULL, 69601),
(69602, '1.10.150.60-FF-000052', NULL, NULL, 58, NULL, NULL, 69602),
(69603, '3.40.50.1470-FF-000020', NULL, 'Uncharacterized protein', 81, NULL, NULL, 69603),
(69604, '3.30.70.270-FF-000307', NULL, NULL, 44, NULL, NULL, 69604),
(69605, '3.10.450.50-FF-000025', NULL, 'Conserved protein', 126, NULL, NULL, 69605),
(69606, '3.80.10.10-FF-000327', NULL, 'leucine-rich repeat protein SHOC-2 isoform X2', 219, NULL, NULL, 69606),
(69607, '1.10.510.10-FF-001122', NULL, 'Receptor-like tyrosine-protein kinase kin-15', 208, NULL, NULL, 69607),
(69608, '3.30.1370.10-FF-000114', NULL, 'Exosome complex component RRP40', 84, NULL, NULL, 69608),
(69609, '3.90.226.10-FF-000334', NULL, 'Uncharacterized protein', 74, NULL, NULL, 69609),
(69610, '3.80.10.10-FF-002020', NULL, 'Leucine-rich repeat protein (LRRP), putative', 139, NULL, NULL, 69610),
(69611, '1.10.8.1290-FF-000007', NULL, NULL, 114, NULL, NULL, 69611),
(69612, '3.40.50.300-FF-007342', NULL, 'ERCC2/XPD/Rad3-related DNA repair helicase', 162, NULL, NULL, 69612),
(69613, '3.30.60.20-FF-000139', NULL, 'Uncharacterized protein', 114, NULL, NULL, 69613),
(69614, '3.30.160.60-FF-004773', NULL, NULL, 31, NULL, NULL, 69614),
(69615, '3.40.30.10-FF-000679', NULL, 'Glutathione S-transferase D7-like Protein', 81, NULL, NULL, 69615),
(69616, '3.40.50.2000-FF-000224', NULL, 'Trehalose-phosphatase, variant', 293, NULL, NULL, 69616),
(69617, '3.30.160.60-FF-003137', NULL, 'Zinc finger protein 433', 31, NULL, NULL, 69617),
(69618, '3.30.70.380-FF-000009', NULL, NULL, 96, NULL, NULL, 69618),
(69619, '1.20.140.150-FF-000067', NULL, 'Transmembrane protein 225', 167, NULL, NULL, 69619),
(69620, '1.10.533.10-FF-000197', NULL, 'V-FLIP', 85, NULL, NULL, 69620),
(69621, '3.40.47.10-FF-000206', NULL, NULL, 202, NULL, NULL, 69621),
(69622, '3.30.70.370-FF-000006', NULL, 'DNA polymerase I type A', 133, NULL, NULL, 69622);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(69623, '1.20.1070.10-FF-001972', NULL, 'Uncharacterized protein', 178, NULL, NULL, 69623),
(69624, '2.130.10.10-FF-000608', NULL, 'F-box/WD repeat-containing protein 9 isoform X2', 115, NULL, NULL, 69624),
(69625, '1.20.120.610-FF-000015', NULL, 'ATP synthase subunit K', 156, NULL, NULL, 69625),
(69626, '1.25.40.10-FF-001332', NULL, 'pentatricopeptide repeat-containing protein At5g55740, chloroplastic', 79, NULL, NULL, 69626),
(69627, '3.30.428.10-FF-000002', NULL, 'Galactose-1-phosphate uridylyltransferase', 141, NULL, NULL, 69627),
(69628, '1.10.238.10-FF-001202', NULL, 'Uncharacterized protein', 77, NULL, NULL, 69628),
(69629, '3.30.300.30-FF-000150', NULL, 'Acetyl-coenzyme A synthetase', 42, NULL, NULL, 69629),
(69630, '3.30.70.360-FF-000003', NULL, 'Acetylornithine deacetylase', 116, NULL, NULL, 69630),
(69631, '3.30.70.330-FF-002372', NULL, NULL, 102, NULL, NULL, 69631),
(69632, '3.40.50.2300-FF-000432', NULL, 'Glutamate receptor', 179, NULL, NULL, 69632),
(69633, '3.30.70.1590-FF-000007', NULL, NULL, 66, NULL, NULL, 69633),
(69634, '3.30.70.330-FF-002591', NULL, NULL, 135, NULL, NULL, 69634),
(69635, '1.10.640.10-FF-000041', NULL, 'Uncharacterized protein', 597, NULL, NULL, 69635),
(69636, '1.25.40.20-FF-001335', NULL, 'Uncharacterized protein', 126, NULL, NULL, 69636),
(69637, '3.30.1010.10-FF-000065', NULL, 'NUC194_domain/Phosphatidylinositol_3-_and_4 -kinase_-_putative', 177, NULL, NULL, 69637),
(69638, '1.10.196.10-FF-000013', NULL, 'Regulator of G-protein signaling 13', 48, NULL, NULL, 69638),
(69639, '3.90.800.10-FF-000005', NULL, 'Glutamate--tRNA ligase 2', 123, NULL, NULL, 69639),
(69640, '1.25.40.10-FF-004547', NULL, 'ABL100Wp', 225, NULL, NULL, 69640),
(69641, '3.30.540.10-FF-000044', NULL, 'Inositol monophosphatase family protein', 153, NULL, NULL, 69641),
(69642, '1.20.58.200-FF-000011', NULL, NULL, 54, NULL, NULL, 69642),
(69643, '3.40.1280.10-FF-000048', NULL, '23S rRNA methyltransferase', 168, NULL, NULL, 69643),
(69644, '3.30.710.10-FF-000309', NULL, 'CG10830', 105, NULL, NULL, 69644),
(69645, '3.30.160.60-FF-000844', NULL, 'Transcription factor Ovo 2', 28, NULL, NULL, 69645),
(69646, '3.40.30.10-FF-001174', NULL, 'Glutathione S-transferase, putative', 84, NULL, NULL, 69646),
(69647, '3.50.30.30-FF-000010', NULL, 'Transferrin receptor protein 1', 188, NULL, NULL, 69647),
(69648, '2.130.10.10-FF-000940', NULL, 'WD repeat domain 37', 116, NULL, NULL, 69648),
(69649, '1.20.1440.130-FF-000013', NULL, 'Uncharacterized protein', 146, NULL, NULL, 69649),
(69650, '3.40.630.10-FF-000329', NULL, 'Uncharacterized protein', 289, NULL, NULL, 69650),
(69651, '3.10.129.10-FF-000137', NULL, 'Protein CBG14719', 147, NULL, NULL, 69651),
(69652, '3.30.110.30-FF-000006', NULL, 'Prolyl-tRNA synthetase', 78, NULL, NULL, 69652),
(69653, '1.10.3130.10-FF-000018', NULL, 'Serine acetyltransferase', 77, NULL, NULL, 69653),
(69654, '3.40.190.10-FF-000632', NULL, 'LysR family transcriptional regulator', 92, NULL, NULL, 69654),
(69655, '3.50.50.60-FF-000801', NULL, 'Uncharacterized protein', 267, NULL, NULL, 69655),
(69656, '1.10.1080.10-FF-000002', NULL, 'Glutathione synthetase', 81, NULL, NULL, 69656),
(69657, '3.40.50.300-FF-004717', NULL, 'ATLastiN (Endoplasmic reticulum GTPase) related', 73, NULL, NULL, 69657),
(69658, '2.60.120.200-FF-000551', NULL, 'Uncharacterized protein', 196, NULL, NULL, 69658),
(69659, '3.60.21.10-FF-000197', NULL, 'Purple acid phosphatase', 315, NULL, NULL, 69659),
(69660, '2.60.120.200-FF-000219', NULL, 'Wing blister, isoform B', 186, NULL, NULL, 69660),
(69661, '2.60.120.260-FF-000198', NULL, 'Beta-glucuronidase', 205, NULL, NULL, 69661),
(69662, '3.90.70.10-FF-000584', NULL, 'Predicted protein', 267, NULL, NULL, 69662),
(69663, '2.10.25.10-FF-000007', NULL, 'Delta-like protein', 37, NULL, NULL, 69663),
(69664, '2.60.40.60-FF-001112', NULL, 'Uncharacterized protein', 50, NULL, NULL, 69664),
(69665, '1.20.58.900-FF-000013', NULL, 'pleckstrin homology domain-containing family M member 1 isoform X1', 174, NULL, NULL, 69665),
(69666, '2.60.40.10-FF-003143', NULL, NULL, 92, NULL, NULL, 69666);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(69667, '1.10.238.10-FF-000926', NULL, 'Uncharacterized protein', 170, NULL, NULL, 69667),
(69668, '1.10.340.30-FF-000007', NULL, 'Methyl-CpG-binding domain protein 4', 152, NULL, NULL, 69668),
(69669, '3.40.50.11260-FF-000033', NULL, 'Uncharacterized protein', 62, NULL, NULL, 69669),
(69670, '2.130.10.30-FF-000024', NULL, 'RCC1-like G exchanging factor-like protein', 279, NULL, NULL, 69670),
(69671, '3.40.50.1820-FF-000265', NULL, 'Lysosomal Pro-X carboxypeptidase', 299, NULL, NULL, 69671),
(69672, '1.10.287.130-FF-000053', NULL, 'Two-component sensor histidine kinase', 64, NULL, NULL, 69672),
(69673, '3.90.660.20-FF-000019', NULL, 'Protoporphyrinogen oxidase', 201, NULL, NULL, 69673),
(69674, '3.30.497.10-FF-000077', NULL, 'Putative serpin A13', 61, NULL, NULL, 69674),
(69675, '1.10.238.10-FF-000584', NULL, 'Nuclear receptor coactivator 5', 86, NULL, NULL, 69675),
(69676, '1.25.40.20-FF-000498', NULL, 'E3 ubiquitin-protein ligase HACE1 isoform X4', 33, NULL, NULL, 69676),
(69677, '1.25.40.10-FF-000837', NULL, 'Tetratricopeptide repeat protein 30 homolog', 140, NULL, NULL, 69677),
(69678, '1.25.10.10-FF-000780', NULL, 'BP28CT domain containing protein', 161, NULL, NULL, 69678),
(69679, '3.90.740.10-FF-000074', NULL, 'Leucyl-tRNA synthetase b', 78, NULL, NULL, 69679),
(69680, '3.90.1180.10-FF-000035', NULL, NULL, 165, NULL, NULL, 69680),
(69681, '1.20.1310.10-FF-000159', NULL, NULL, 140, NULL, NULL, 69681),
(69682, '3.60.120.10-FF-000022', NULL, 'Isochorismate synthase EntC', 297, NULL, NULL, 69682),
(69683, '3.10.450.40-FF-000022', NULL, 'Amine oxidase', 112, NULL, NULL, 69683),
(69684, '3.20.20.300-FF-000040', NULL, 'Periplasmic beta-glucosidase', 317, NULL, NULL, 69684),
(69685, '1.10.8.140-FF-000001', NULL, 'Programmed cell death protein 5', 104, NULL, NULL, 69685),
(69686, '3.30.40.10-FF-001883', NULL, 'Uncharacterized protein', 75, NULL, NULL, 69686),
(69687, '3.40.30.10-FF-000898', NULL, 'Protein disulfide-isomerase', 112, NULL, NULL, 69687),
(69688, '3.40.50.1820-FF-001682', NULL, 'Carboxypeptidase', 232, NULL, NULL, 69688),
(69689, '3.10.50.10-FF-000024', NULL, 'Chitinase', 86, NULL, NULL, 69689),
(69690, '3.40.50.2300-FF-000090', NULL, 'Transcriptional regulator, AraC family', 128, NULL, NULL, 69690),
(69691, '3.90.660.10-FF-000016', NULL, 'L-amino acid oxidase LaoA', 197, NULL, NULL, 69691),
(69692, '2.60.40.10-FF-004902', NULL, NULL, 104, NULL, NULL, 69692),
(69693, '3.40.50.300-FF-008427', NULL, 'Predicted protein', 105, NULL, NULL, 69693),
(69694, '3.30.200.20-FF-000229', NULL, 'Serine/threonine-protein kinase Chk1', 96, NULL, NULL, 69694),
(69695, '3.30.420.340-FF-000010', NULL, 'UvrABC system protein C', 182, NULL, NULL, 69695),
(69696, '2.60.40.1510-FF-000045', NULL, 'Integrin beta', 115, NULL, NULL, 69696),
(69697, '2.60.40.10-FF-002716', NULL, 'Pullulanase 1, chloroplastic', 106, NULL, NULL, 69697),
(69698, '3.40.50.1380-FF-000027', NULL, 'Uncharacterized protein', 103, NULL, NULL, 69698),
(69699, '1.10.1070.11-FF-000094', NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', 189, NULL, NULL, 69699),
(69700, '1.10.600.10-FF-000073', NULL, 'Ent-copalyl diphosphate synthase, chloroplastic', 279, NULL, NULL, 69700),
(69701, '3.40.50.620-FF-000295', NULL, 'Glutamate-tRNA ligase', 331, NULL, NULL, 69701),
(69702, '2.130.10.10-FF-000603', NULL, 'U3 snoRNA-associated small subunit rRNA processing protein, putative', 323, NULL, NULL, 69702),
(69703, '3.40.50.150-FF-000603', NULL, 'Predicted protein', 205, NULL, NULL, 69703),
(69704, '3.30.1120.30-FF-000035', NULL, 'Polo kinase-like protein, copy C', 91, NULL, NULL, 69704),
(69705, '2.30.42.10-FF-000412', NULL, NULL, 73, NULL, NULL, 69705),
(69706, '1.10.3430.10-FF-000008', NULL, 'Ammonium transporter', 425, NULL, NULL, 69706),
(69707, '1.10.10.10-FF-001819', NULL, 'Transcriptional adapter', 46, NULL, NULL, 69707),
(69708, '3.30.479.20-FF-000033', NULL, 'Elongation factor Ts, mitochondrial', 96, NULL, NULL, 69708),
(69709, '3.40.50.300-FF-002554', NULL, 'NLR family pyrin domain containing 11', 197, NULL, NULL, 69709),
(69710, '3.50.50.60-FF-000280', NULL, 'Tryptophan halogenase', 497, NULL, NULL, 69710);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(69711, '3.40.50.720-FF-000027', NULL, 'Trk system potassium transporter TrkA', 141, NULL, NULL, 69711),
(69712, '3.30.9.10-FF-000119', NULL, 'D-amino acid oxidase family', 146, NULL, NULL, 69712),
(69713, '2.10.25.10-FF-001773', NULL, 'Predicted protein', 35, NULL, NULL, 69713),
(69714, '2.30.29.30-FF-000426', NULL, 'Ysp1p', 134, NULL, NULL, 69714),
(69715, '2.130.10.10-FF-003829', NULL, 'Uncharacterized protein', 300, NULL, NULL, 69715),
(69716, '4.10.280.10-FF-000064', NULL, 'Transcription factor MUTE', 67, NULL, NULL, 69716),
(69717, '3.20.20.70-FF-000613', NULL, NULL, 160, NULL, NULL, 69717),
(69718, '3.30.200.20-FF-000730', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 101, NULL, NULL, 69718),
(69719, '3.40.50.11730-FF-000001', NULL, 'Pex22p', 130, NULL, NULL, 69719),
(69720, '3.40.50.1360-FF-000021', NULL, '6-phosphogluconolactonase', 231, NULL, NULL, 69720),
(69721, '3.40.50.20-FF-000077', NULL, 'D-alanine--D-alanine ligase B', 126, NULL, NULL, 69721),
(69722, '2.60.120.380-FF-000004', NULL, 'Inhibitor of g-type lysozyme', 111, NULL, NULL, 69722),
(69723, '1.10.238.20-FF-000031', NULL, 'Odorant-binding protein 83cd', 99, NULL, NULL, 69723),
(69724, '3.40.50.150-FF-001059', NULL, 'Uncharacterized protein', 260, NULL, NULL, 69724),
(69725, '2.60.120.620-FF-000032', NULL, 'Unplaced genomic scaffold supercont1.16, whole genome shotgun sequence', 200, NULL, NULL, 69725),
(69726, '2.40.50.90-FF-000004', NULL, 'Staphylococcal nuclease domain-containing protein', 170, NULL, NULL, 69726),
(69727, '1.20.1250.20-FF-001574', NULL, 'Thiamine transporter 2', 377, NULL, NULL, 69727),
(69728, '3.30.70.1820-FF-000010', NULL, NULL, 53, NULL, NULL, 69728),
(69729, '3.30.160.60-FF-004762', NULL, NULL, 87, NULL, NULL, 69729),
(69730, '1.25.10.10-FF-003063', NULL, 'Importin beta', 266, NULL, NULL, 69730),
(69731, '2.60.40.1170-FF-000022', NULL, 'AP-1 complex subunit mu', 150, NULL, NULL, 69731),
(69732, '1.25.40.180-FF-000064', NULL, 'Translation initiation factor 4G', 178, NULL, NULL, 69732),
(69733, '3.40.50.720-FF-001488', NULL, 'dTDP-fucopyranose mutase', 72, NULL, NULL, 69733),
(69734, '3.40.50.12670-FF-000013', NULL, 'Carboxypeptidase', 151, NULL, NULL, 69734),
(69735, '1.20.5.170-FF-000183', NULL, 'Desiccation-related protein At2g46140', 30, NULL, NULL, 69735),
(69736, '1.20.1250.20-FF-000585', NULL, 'BSC6p protein', 183, NULL, NULL, 69736),
(69737, '1.50.40.10-FF-000246', NULL, 'Putative mitochondrial carrier protein', 158, NULL, NULL, 69737),
(69738, '3.30.190.20-FF-000031', NULL, 'Ribosomal protein L1-like protein', 109, NULL, NULL, 69738),
(69739, '1.25.40.10-FF-004672', NULL, 'Uncharacterized protein', 111, NULL, NULL, 69739),
(69740, '1.20.1560.10-FF-000919', NULL, 'Protein CBR-HMT-1', 96, NULL, NULL, 69740),
(69741, '1.20.120.1080-FF-000136', NULL, 'Helicase, putative', 153, NULL, NULL, 69741),
(69742, '1.10.2000.10-FF-000077', NULL, NULL, 139, NULL, NULL, 69742),
(69743, '3.40.630.10-FF-000313', NULL, 'Predicted protein', 164, NULL, NULL, 69743),
(69744, '3.40.50.300-FF-006769', NULL, 'Uncharacterized protein', 62, NULL, NULL, 69744),
(69745, '3.30.160.60-FF-003773', NULL, 'Predicted protein', 25, NULL, NULL, 69745),
(69746, '3.40.30.10-FF-000657', NULL, 'Peroxiredoxin', 173, NULL, NULL, 69746),
(69747, '1.10.10.1100-FF-000002', NULL, 'Nitrite reductase large subunit', 53, NULL, NULL, 69747),
(69748, '2.60.40.3470-FF-000004', NULL, NULL, 123, NULL, NULL, 69748),
(69749, '3.30.559.10-FF-000177', NULL, 'Nonribosomal peptide synthase nlsA', 129, NULL, NULL, 69749),
(69750, '3.30.420.10-FF-000412', NULL, NULL, 177, NULL, NULL, 69750),
(69751, '1.20.920.10-FF-000123', NULL, 'Transcription factor GTE7', 156, NULL, NULL, 69751),
(69752, '1.20.1740.10-FF-000164', NULL, 'Uncharacterized protein', 317, NULL, NULL, 69752),
(69753, '2.40.160.110-FF-000009', NULL, 'Blast:Lysosome-associated membrane glycoprotein 5', 186, NULL, NULL, 69753),
(69754, '3.40.50.720-FF-000499', NULL, 'Protein TIC 62, chloroplastic', 248, NULL, NULL, 69754),
(69755, '1.25.40.10-FF-000338', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 98, NULL, NULL, 69755);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(69756, '3.30.710.10-FF-000159', NULL, 'Speckle-type POZ protein B', 121, NULL, NULL, 69756),
(69757, '3.10.580.10-FF-000175', NULL, 'Chloride channel protein', 76, NULL, NULL, 69757),
(69758, '3.30.1370.110-FF-000006', NULL, 'Endonuclease MutS2', 123, NULL, NULL, 69758),
(69759, '3.40.50.300-FF-003543', NULL, 'Predicted protein', 247, NULL, NULL, 69759),
(69760, '2.20.20.100-FF-000001', NULL, 'Sensor histidine kinase LuxQ', 64, NULL, NULL, 69760),
(69761, '1.10.472.10-FF-000381', NULL, 'Retinoblastoma susceptibility protein', 116, NULL, NULL, 69761),
(69762, '1.10.287.70-FF-000625', NULL, 'Voltage-gated potassium channel', 218, NULL, NULL, 69762),
(69763, '3.40.50.1000-FF-000610', NULL, NULL, 234, NULL, NULL, 69763),
(69764, '3.30.70.330-FF-000478', NULL, 'heterogeneous nuclear ribonucleoprotein 1', 119, NULL, NULL, 69764),
(69765, '1.10.630.10-FF-000693', NULL, 'Uncharacterized protein', 146, NULL, NULL, 69765),
(69766, '3.40.50.12780-FF-000107', NULL, 'Putative fatty-acid--CoA ligase fadD11', 131, NULL, NULL, 69766),
(69767, '3.30.565.10-FF-000118', NULL, 'Two-component sensor histidine kinase', 153, NULL, NULL, 69767),
(69768, '3.30.900.10-FF-000022', NULL, 'IP20312p', 196, NULL, NULL, 69768),
(69769, '3.60.110.10-FF-000067', NULL, 'Glutamine-dependent NAD(+) synthetase', 307, NULL, NULL, 69769),
(69770, '3.40.50.2000-FF-000281', NULL, 'Alanine-rich transferase', 150, NULL, NULL, 69770),
(69771, '3.40.50.720-FF-001016', NULL, 'Formate dehydrogenase 1, mitochondrial', 93, NULL, NULL, 69771),
(69772, '3.30.160.60-FF-002784', NULL, NULL, 24, NULL, NULL, 69772),
(69773, '1.25.10.10-FF-002927', NULL, 'Uncharacterized protein', 474, NULL, NULL, 69773),
(69774, '2.120.10.30-FF-000430', NULL, 'Uncharacterized protein', 139, NULL, NULL, 69774),
(69775, '1.20.58.400-FF-000004', NULL, 'Golgi SNAP receptor complex member 2 isoform X1', 92, NULL, NULL, 69775),
(69776, '1.10.940.10-FF-000031', NULL, 'Transcription antitermination protein NusB', 133, NULL, NULL, 69776),
(69777, '1.20.1020.10-FF-000008', NULL, 'BTB/POZ and TAZ domain-containing protein 2', 119, NULL, NULL, 69777),
(69778, '3.40.50.2000-FF-000601', NULL, 'Glycosyl transferase group 1', 156, NULL, NULL, 69778),
(69779, '3.20.110.10-FF-000008', NULL, 'Alpha-mannosidase', 270, NULL, NULL, 69779),
(69780, '3.80.10.10-FF-003908', NULL, 'Uncharacterized protein', 125, NULL, NULL, 69780),
(69781, '2.40.30.110-FF-000024', NULL, NULL, 81, NULL, NULL, 69781),
(69782, '1.10.472.10-FF-000701', NULL, 'Cyclin9', 14, NULL, NULL, 69782),
(69783, '2.40.100.10-FF-000119', NULL, 'Peptidyl-prolyl isomerase CWC27', 163, NULL, NULL, 69783),
(69784, '3.30.160.60-FF-005538', NULL, NULL, 29, NULL, NULL, 69784),
(69785, '3.10.105.10-FF-000050', NULL, 'Oligopeptide ABC transporter periplasmic oligopeptide-binding protein OppA', 203, NULL, NULL, 69785),
(69786, '3.30.70.330-FF-002423', NULL, NULL, 91, NULL, NULL, 69786),
(69787, '1.10.1410.10-FF-000097', NULL, 'Uncharacterized protein', 43, NULL, NULL, 69787),
(69788, '2.130.10.10-FF-004818', NULL, 'Uncharacterized protein', 138, NULL, NULL, 69788),
(69789, '3.10.50.10-FF-000019', NULL, 'Glycoside hydrolase', 66, NULL, NULL, 69789),
(69790, '2.130.10.10-FF-002048', NULL, 'WD repeat domain 43', 190, NULL, NULL, 69790),
(69791, '3.10.20.90-FF-000440', NULL, 'Inhibitor of nuclear factor kappa-B kinase subunit epsilon', 74, NULL, NULL, 69791),
(69792, '1.10.510.10-FF-003180', NULL, NULL, 157, NULL, NULL, 69792),
(69793, '1.10.10.10-FF-000038', NULL, 'Glycine cleavage system transcriptional activator', 84, NULL, NULL, 69793),
(69794, '1.20.1070.10-FF-000371', NULL, 'Predicted protein', 305, NULL, NULL, 69794),
(69795, '3.30.160.60-FF-003301', NULL, 'Zinc finger and BTB domain containing 41', 23, NULL, NULL, 69795),
(69796, '3.40.20.10-FF-000100', NULL, 'Uncharacterized protein', 131, NULL, NULL, 69796),
(69797, '3.40.50.300-FF-005308', NULL, 'Ras-related protein Rap-1b', 169, NULL, NULL, 69797),
(69798, '3.40.1170.60-FF-000016', NULL, 'DNA damage repair protein', 52, NULL, NULL, 69798),
(69799, '3.30.310.210-FF-000008', NULL, 'Heterogeneous nuclear RibonucleoProtein (HnRNP) K homolog', 56, NULL, NULL, 69799);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(69800, '1.10.472.130-FF-000077', NULL, 'Dynein heavy chain family protein', 145, NULL, NULL, 69800),
(69801, '3.40.50.2300-FF-000573', NULL, 'Cellobiose-specific PTS system IIC component', 106, NULL, NULL, 69801),
(69802, '1.20.1560.10-FF-000066', NULL, 'ABC multidrug transporter (Eurofung)', 326, NULL, NULL, 69802),
(69803, '3.90.1410.10-FF-000094', NULL, 'Predicted protein', 275, NULL, NULL, 69803),
(69804, '1.25.40.10-FF-003244', NULL, 'Pentatricopeptide repeat-containing protein', 177, NULL, NULL, 69804),
(69805, '3.20.20.140-FF-000099', NULL, 'Amidohydrolase 2', 317, NULL, NULL, 69805),
(69806, '1.10.860.10-FF-000030', NULL, 'Uncharacterized protein', 89, NULL, NULL, 69806),
(69807, '3.40.50.1820-FF-000204', NULL, 'Tripeptidyl aminopeptidase', 274, NULL, NULL, 69807),
(69808, '3.80.10.10-FF-003588', NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', 133, NULL, NULL, 69808),
(69809, '1.20.1070.10-FF-000219', NULL, 'Opsin 5-like 2', 315, NULL, NULL, 69809),
(69810, '1.20.58.900-FF-000031', NULL, 'AGAP004080-PA', 158, NULL, NULL, 69810),
(69811, '2.10.80.10-FF-000006', NULL, 'Colipase-like protein 2', 75, NULL, NULL, 69811),
(69812, '2.30.30.40-FF-000500', NULL, 'Uncharacterized protein', 60, NULL, NULL, 69812),
(69813, '3.30.760.10-FF-000050', NULL, 'Eukaryotic translation initiation factor 4E type 5', 193, NULL, NULL, 69813),
(69814, '3.80.10.10-FF-001290', NULL, 'Leucine rich repeat and phosphatase domain containing protein', 122, NULL, NULL, 69814),
(69815, '3.30.40.100-FF-000010', NULL, 'SNF2 domain-containing protein', 57, NULL, NULL, 69815),
(69816, '3.20.20.300-FF-000023', NULL, 'Probable conserved lipoprotein LpqI', 342, NULL, NULL, 69816),
(69817, '1.25.40.20-FF-000667', NULL, 'Predicted protein', 102, NULL, NULL, 69817),
(69818, '2.130.10.10-FF-003037', NULL, 'Uncharacterized WD repeat-containing protein slr1410', 153, NULL, NULL, 69818),
(69819, '1.10.8.530-FF-000012', NULL, 'DNA polymerase alpha subunit B', 79, NULL, NULL, 69819),
(69820, '3.30.930.10-FF-000203', NULL, 'ATP phosphoribosyltransferase regulatory subunit', 311, NULL, NULL, 69820),
(69821, '1.25.40.20-FF-001595', NULL, 'Uncharacterized protein', 262, NULL, NULL, 69821),
(69822, '3.90.180.10-FF-000126', NULL, 'Uncharacterized protein', 151, NULL, NULL, 69822),
(69823, '2.10.50.30-FF-000044', NULL, 'Uncharacterized protein', 71, NULL, NULL, 69823),
(69824, '3.40.50.720-FF-002444', NULL, 'Chromosome 1, whole genome shotgun sequence', 132, NULL, NULL, 69824),
(69825, '3.40.50.1240-FF-000070', NULL, 'Probable phosphoglycerate mutase', 197, NULL, NULL, 69825),
(69826, '2.10.110.10-FF-000099', NULL, 'Uncoordinated 115a, isoform B', 66, NULL, NULL, 69826),
(69827, '2.30.30.40-FF-000028', NULL, 'endophilin-B2 isoform X1', 61, NULL, NULL, 69827),
(69828, '2.60.40.10-FF-006078', NULL, NULL, 78, NULL, NULL, 69828),
(69829, '3.30.160.60-FF-000867', NULL, 'Zinc finger protein 341', 65, NULL, NULL, 69829),
(69830, '1.20.58.60-FF-000365', NULL, 'SMAll', 110, NULL, NULL, 69830),
(69831, '4.10.400.10-FF-000153', NULL, 'LDL receptor related protein 2', 39, NULL, NULL, 69831),
(69832, '2.60.40.2170-FF-000013', NULL, 'Uncharacterized protein', 126, NULL, NULL, 69832),
(69833, '1.20.5.470-FF-000003', NULL, 'Argininosuccinate synthase 1', 41, NULL, NULL, 69833),
(69834, '3.30.280.10-FF-000001', NULL, 'Urease subunit alpha', 121, NULL, NULL, 69834),
(69835, '3.40.50.300-FF-005460', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 232, NULL, NULL, 69835),
(69836, '1.10.30.10-FF-000101', NULL, 'Testis-enriched HMG-box-containing protein 1', 85, NULL, NULL, 69836),
(69837, '3.40.1110.10-FF-000425', NULL, NULL, 11, NULL, NULL, 69837),
(69838, '3.40.50.720-FF-002005', NULL, 'Predicted protein', 226, NULL, NULL, 69838),
(69839, '2.60.120.200-FF-000142', NULL, 'MAM domain-containing protein 2', 169, NULL, NULL, 69839),
(69840, '1.20.120.1900-FF-000011', NULL, 'Spindle pole body component', 338, NULL, NULL, 69840),
(69841, '3.30.70.360-FF-000021', NULL, 'ACY1-like metalloprotease', 122, NULL, NULL, 69841),
(69842, '2.160.20.10-FF-000097', NULL, 'Endo-xylogalacturonan hydrolase A', 372, NULL, NULL, 69842);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(69843, '2.80.10.50-FF-000213', NULL, 'Uncharacterized protein', 86, NULL, NULL, 69843),
(69844, '1.25.40.10-FF-002755', NULL, 'Uncharacterized protein', 191, NULL, NULL, 69844),
(69845, '3.40.50.360-FF-000048', NULL, 'Bifunctional cytochrome P450/NADPH--P450 reductase', 152, NULL, NULL, 69845),
(69846, '3.40.50.720-FF-000819', NULL, 'Short-chain dehydrogenase/reductase SDR', 244, NULL, NULL, 69846),
(69847, '1.10.287.130-FF-000205', NULL, 'Two-component sensor histidine kinase', 73, NULL, NULL, 69847),
(69848, '2.30.42.10-FF-000092', NULL, 'PDZ domain containing 7', 117, NULL, NULL, 69848),
(69849, '3.30.70.890-FF-000005', NULL, 'Diphosphomevalonate decarboxylase', 197, NULL, NULL, 69849),
(69850, '3.40.190.10-FF-000649', NULL, 'Probable porphobilinogen deaminase', 97, NULL, NULL, 69850),
(69851, '2.40.10.10-FF-000080', NULL, 'peroxisomal leader peptide-processing protease', 110, NULL, NULL, 69851),
(69852, '3.80.10.10-FF-003116', NULL, 'Uncharacterized protein', 96, NULL, NULL, 69852),
(69853, '3.40.50.300-FF-004971', NULL, 'Uncharacterized protein', 80, NULL, NULL, 69853),
(69854, '2.70.170.10-FF-000297', NULL, 'Uncharacterized protein', 144, NULL, NULL, 69854),
(69855, '3.90.110.10-FF-000032', NULL, NULL, 185, NULL, NULL, 69855),
(69856, '3.30.497.10-FF-000044', NULL, 'GM22272', 189, NULL, NULL, 69856),
(69857, '3.40.50.300-FF-001565', NULL, 'Orc1-type DNA replication protein', 166, NULL, NULL, 69857),
(69858, '2.40.50.140-FF-000492', NULL, 'S1 RNA-binding domain-containing protein', 89, NULL, NULL, 69858),
(69859, '3.30.200.20-FF-002175', NULL, 'Cyclin-dependent kinase C-2', 61, NULL, NULL, 69859),
(69860, '3.60.90.10-FF-000031', NULL, 'Uncharacterized protein', 94, NULL, NULL, 69860),
(69861, '2.60.40.10-FF-001727', NULL, 'Protein tyrosine phosphatase, receptor type B', 90, NULL, NULL, 69861),
(69862, '3.30.160.20-FF-000203', NULL, 'STAUfen (DsRNA binding protein) homolog', 82, NULL, NULL, 69862),
(69863, '3.30.200.20-FF-001539', NULL, 'Probable protein kinase DDB_G0291842', 107, NULL, NULL, 69863),
(69864, '3.30.1370.10-FF-000221', NULL, 'Uncharacterized protein', 171, NULL, NULL, 69864),
(69865, '2.60.40.10-FF-000951', NULL, 'Terribly reduced optic lobes, isoform AI', 88, NULL, NULL, 69865),
(69866, '2.70.160.11-FF-000096', NULL, 'Protein arginine N-methyltransferase', 113, NULL, NULL, 69866),
(69867, '3.40.50.300-FF-005960', NULL, 'Ribosome biogenesis GTPase A', 156, NULL, NULL, 69867),
(69868, '3.50.50.60-FF-000633', NULL, 'D-proline dehydrogenase', 202, NULL, NULL, 69868),
(69869, '3.30.70.260-FF-000137', NULL, 'Prephenate dehydratase', 89, NULL, NULL, 69869),
(69870, '3.80.10.10-FF-002127', NULL, 'Uncharacterized protein', 226, NULL, NULL, 69870),
(69871, '1.10.10.10-FF-000982', NULL, 'EAP30/Vps36 family, putative', 84, NULL, NULL, 69871),
(69872, '2.60.40.10-FF-005089', NULL, NULL, 100, NULL, NULL, 69872),
(69873, '3.40.50.1820-FF-001665', NULL, 'Acetoin dehydrogenase complex, E2 component, dihydrolipoamide acetyltransferase', 272, NULL, NULL, 69873),
(69874, '3.90.1310.10-FF-000030', NULL, 'Cell division protein FtsI [Peptidoglycan synthetase]', 119, NULL, NULL, 69874),
(69875, '3.30.40.10-FF-000124', NULL, 'STIP1 homology and U box-containing protein 1', 80, NULL, NULL, 69875),
(69876, '3.30.70.660-FF-000021', NULL, 'tRNA pseudouridine synthase A-like protein', 120, NULL, NULL, 69876),
(69877, '3.30.420.40-FF-000308', NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', 122, NULL, NULL, 69877),
(69878, '3.30.70.100-FF-000022', NULL, 'Putative cadmium/zinc-transporting ATPase 3', 74, NULL, NULL, 69878),
(69879, '2.120.10.80-FF-000012', NULL, 'Kelch domain-containing protein 2', 190, NULL, NULL, 69879),
(69880, '3.90.550.10-FF-000346', NULL, 'Glycosyltransferase', 251, NULL, NULL, 69880),
(69881, '1.20.5.110-FF-000272', NULL, 'Vesicle transport v-SNARE protein N-terminus, putative', 80, NULL, NULL, 69881),
(69882, '1.10.287.1130-FF-000012', NULL, 'Unplaced genomic scaffold supercont1.28, whole genome shotgun sequence', 71, NULL, NULL, 69882),
(69883, '1.25.40.770-FF-000027', NULL, 'Uncharacterized protein', 61, NULL, NULL, 69883);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(69884, '2.60.120.10-FF-000431', NULL, 'Crp/Fnr family transcriptional regulator', 130, NULL, NULL, 69884),
(69885, '3.30.2130.30-FF-000007', NULL, 'THUMP domain-containing protein 3 isoform X1', 93, NULL, NULL, 69885),
(69886, '3.50.7.10-FF-000076', NULL, NULL, 65, NULL, NULL, 69886),
(69887, '1.20.1560.10-FF-000566', NULL, 'Uncharacterized protein', 245, NULL, NULL, 69887),
(69888, '2.60.40.10-FF-005622', NULL, NULL, 99, NULL, NULL, 69888),
(69889, '1.20.58.60-FF-000426', NULL, 'Spectrin repeat containing nuclear envelope protein 1', 258, NULL, NULL, 69889),
(69890, '3.30.160.60-FF-000367', NULL, 'Zinc finger protein 572', 28, NULL, NULL, 69890),
(69891, '1.10.400.10-FF-000092', NULL, 'Uncharacterized protein', 65, NULL, NULL, 69891),
(69892, '1.20.920.20-FF-000013', NULL, 'Dynein Heavy Chain', 351, NULL, NULL, 69892),
(69893, '2.30.30.100-FF-000192', NULL, 'Uncharacterized protein', 101, NULL, NULL, 69893),
(69894, '1.10.238.10-FF-001130', NULL, 'Uncharacterized protein', 159, NULL, NULL, 69894),
(69895, '3.30.230.70-FF-000140', NULL, 'Uncharacterized protein', 147, NULL, NULL, 69895),
(69896, '1.20.5.210-FF-000004', NULL, NULL, 71, NULL, NULL, 69896),
(69897, '3.30.430.20-FF-000067', NULL, 'Uncharacterized protein', 106, NULL, NULL, 69897),
(69898, '3.40.50.300-FF-003190', NULL, 'ABC transporter putative', 226, NULL, NULL, 69898),
(69899, '2.40.30.10-FF-000463', NULL, 'Iron-chelator utilization protein, putative', 93, NULL, NULL, 69899),
(69900, '1.25.40.10-FF-001799', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 92, NULL, NULL, 69900),
(69901, '1.20.1080.10-FF-000017', NULL, 'Probable aquaporin TIP5-1', 243, NULL, NULL, 69901),
(69902, '3.30.70.330-FF-000006', NULL, 'ELAV-like 3', 96, NULL, NULL, 69902),
(69903, '1.10.8.60-FF-000052', NULL, 'Nuclear valosin-containing protein-like', 85, NULL, NULL, 69903),
(69904, '2.60.40.60-FF-000972', NULL, 'AGAP004166-PA', 58, NULL, NULL, 69904),
(69905, '1.25.40.20-FF-001656', NULL, 'Kinase, NEK', 87, NULL, NULL, 69905),
(69906, '2.10.60.10-FF-000062', NULL, 'Receptor protein serine/threonine kinase', 74, NULL, NULL, 69906),
(69907, '3.40.140.10-FF-000085', NULL, 'Mov34/MPN/PAD-1 family protein', 136, NULL, NULL, 69907),
(69908, '3.90.190.10-FF-000363', NULL, 'Uncharacterized protein', 128, NULL, NULL, 69908),
(69909, '1.10.510.10-FF-000274', NULL, 'Stress response kinase A', 134, NULL, NULL, 69909),
(69910, '2.60.260.20-FF-000118', NULL, 'Chaperone protein DnaJ', 101, NULL, NULL, 69910),
(69911, '2.70.150.10-FF-000234', NULL, 'Cation-transporting ATPase', 127, NULL, NULL, 69911),
(69912, '3.40.50.12780-FF-000046', NULL, 'L-2-aminoadipate reductase', 462, NULL, NULL, 69912),
(69913, '1.10.8.10-FF-000318', NULL, 'Uncharacterized protein', 56, NULL, NULL, 69913),
(69914, '1.20.58.1120-FF-000067', NULL, NULL, 148, NULL, NULL, 69914),
(69915, '2.60.40.10-FF-000890', NULL, 'Hemicentin 1', 93, NULL, NULL, 69915),
(69916, '1.10.220.30-FF-000033', NULL, 'Flagellar motor switch protein FliG', 85, NULL, NULL, 69916),
(69917, '2.60.40.10-FF-003352', NULL, 'Usherin', 79, NULL, NULL, 69917),
(69918, '3.90.1490.10-FF-000014', NULL, 'Transcriptional regulator, putative', 88, NULL, NULL, 69918),
(69919, '2.130.10.10-FF-001531', NULL, 'Similar to periodic tryptophan protein 2', 92, NULL, NULL, 69919),
(69920, '2.60.40.150-FF-000415', NULL, 'Tb-292 membrane associated protein', 189, NULL, NULL, 69920),
(69921, '2.30.30.140-FF-000237', NULL, 'MutS 6 isoform 1 family protein', 126, NULL, NULL, 69921),
(69922, '1.10.555.10-FF-000063', NULL, 'Lrg1p', 277, NULL, NULL, 69922),
(69923, '1.10.287.70-FF-000272', NULL, 'Potassium channel protein kcv', 92, NULL, NULL, 69923),
(69924, '3.30.160.60-FF-005690', NULL, NULL, 67, NULL, NULL, 69924),
(69925, '3.40.50.150-FF-001531', NULL, NULL, 97, NULL, NULL, 69925),
(69926, '3.40.190.10-FF-000149', NULL, 'LysR family transcriptional regulator', 109, NULL, NULL, 69926),
(69927, '3.30.70.3490-FF-000056', NULL, NULL, 117, NULL, NULL, 69927),
(69928, '2.40.50.1000-FF-000009', NULL, '40S ribosomal protein S11', 110, NULL, NULL, 69928);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(69929, '2.60.40.150-FF-000595', NULL, 'Type III restriction enzyme, res subunit family protein', 109, NULL, NULL, 69929),
(69930, '1.25.40.20-FF-000167', NULL, 'peroxisomal NADH pyrophosphatase NUDT12', 100, NULL, NULL, 69930),
(69931, '3.40.50.300-FF-003482', NULL, 'Ring finger protein 112, gene 2', 304, NULL, NULL, 69931),
(69932, '3.80.10.10-FF-001790', NULL, 'Cytoplasmic membrane protein', 128, NULL, NULL, 69932),
(69933, '3.30.200.20-FF-000258', NULL, 'Ethanolamine kinase 1', 51, NULL, NULL, 69933),
(69934, '1.25.40.10-FF-001266', NULL, 'Hypothetical_protein', 282, NULL, NULL, 69934),
(69935, '3.60.10.10-FF-000172', NULL, 'Uncharacterized protein', 164, NULL, NULL, 69935),
(69936, '3.60.21.60-FF-000010', NULL, 'DNA polymerase alpha subunit B', 132, NULL, NULL, 69936),
(69937, '1.25.40.10-FF-003744', NULL, 'Pentatricopeptide repeat-containing protein', 235, NULL, NULL, 69937),
(69938, '1.10.3720.10-FF-000227', NULL, 'ABC transporter, permease protein, HisMQ family', 220, NULL, NULL, 69938),
(69939, '3.40.50.300-FF-001918', NULL, 'Small GTP-binding protein Rab18', 191, NULL, NULL, 69939),
(69940, '3.80.10.10-FF-003088', NULL, 'Uncharacterized protein', 122, NULL, NULL, 69940),
(69941, '2.40.10.10-FF-000580', NULL, NULL, 49, NULL, NULL, 69941),
(69942, '3.30.505.10-FF-000261', NULL, NULL, 91, NULL, NULL, 69942),
(69943, '3.40.1280.10-FF-000116', NULL, 'Predicted protein', 206, NULL, NULL, 69943),
(69944, '1.10.150.40-FF-000007', NULL, 'Uncharacterized protein', 40, NULL, NULL, 69944),
(69945, '2.130.10.10-FF-005454', NULL, 'Uncharacterized protein', 192, NULL, NULL, 69945),
(69946, '1.20.58.60-FF-000718', NULL, 'Uncharacterized protein', 109, NULL, NULL, 69946),
(69947, '3.30.70.330-FF-002395', NULL, NULL, 95, NULL, NULL, 69947),
(69948, '1.25.40.470-FF-000027', NULL, 'Intraflagellar transport protein 172 homolog', 181, NULL, NULL, 69948),
(69949, '3.90.180.10-FF-000065', NULL, 'Zinc-binding dehydrogenase family protein', 171, NULL, NULL, 69949),
(69950, '3.90.640.10-FF-000145', NULL, 'Actin, putative', 109, NULL, NULL, 69950),
(69951, '3.30.360.10-FF-000002', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', 166, NULL, NULL, 69951),
(69952, '2.60.40.10-FF-003644', NULL, NULL, 100, NULL, NULL, 69952),
(69953, '3.40.50.300-FF-007697', NULL, 'Septin 1', 105, NULL, NULL, 69953),
(69954, '3.30.40.10-FF-002069', NULL, 'Uncharacterized protein', 88, NULL, NULL, 69954),
(69955, '2.30.30.1020-FF-000001', NULL, 'Putative CCR4-NOT transcription complex subunit 2', 194, NULL, NULL, 69955),
(69956, '2.30.29.30-FF-001062', NULL, 'Uncharacterized protein', 78, NULL, NULL, 69956),
(69957, '3.30.160.60-FF-002845', NULL, NULL, 29, NULL, NULL, 69957),
(69958, '3.30.1490.20-FF-000025', NULL, 'Alpha-aminoadipate--LysW ligase LysX protein', 69, NULL, NULL, 69958),
(69959, '1.10.418.10-FF-000059', NULL, 'RIKEN cDNA 6430531B16 gene', 113, NULL, NULL, 69959),
(69960, '3.20.20.80-FF-000442', NULL, 'Uncharacterized protein', 486, NULL, NULL, 69960),
(69961, '1.25.10.10-FF-002899', NULL, 'Predicted protein', 136, NULL, NULL, 69961),
(69962, '3.40.50.970-FF-000169', NULL, 'Pyruvate dehydrogenase E1 component beta subunit', 194, NULL, NULL, 69962),
(69963, '3.10.180.10-FF-000066', NULL, 'Methylglyoxalase', 127, NULL, NULL, 69963),
(69964, '3.80.10.10-FF-004544', NULL, 'Uncharacterized protein', 93, NULL, NULL, 69964),
(69965, '3.30.230.10-FF-000049', NULL, 'DNA repair protein RadA', 165, NULL, NULL, 69965),
(69966, '1.10.730.10-FF-000138', NULL, 'Leucine--tRNA ligase', 245, NULL, NULL, 69966),
(69967, '1.10.472.10-FF-000229', NULL, 'CYclin B', 143, NULL, NULL, 69967),
(69968, '1.25.10.10-FF-000662', NULL, 'rRNA-processing protein FCF1', 542, NULL, NULL, 69968),
(69969, '3.30.1370.10-FF-000160', NULL, 'Branchpoint-bridging protein, putative', 130, NULL, NULL, 69969),
(69970, '3.30.559.10-FF-000205', NULL, 'N-(5-amino-5-carboxypentanoyl)-L-cysteinyl-D-valine synthase', 201, NULL, NULL, 69970),
(69971, '3.90.640.10-FF-000292', NULL, 'Uncharacterized protein', 96, NULL, NULL, 69971),
(69972, '3.30.70.60-FF-000034', NULL, 'Putative fimbrial assembly protein PilO-like protein', 111, NULL, NULL, 69972);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(69973, '1.20.1560.10-FF-000419', NULL, 'ABC transporter B family member 9', 108, NULL, NULL, 69973),
(69974, '3.80.10.10-FF-004105', NULL, 'PeroXidasiN (Drosophila peroxidase) homolog', 119, NULL, NULL, 69974),
(69975, '3.50.50.60-FF-001117', NULL, 'Zeta-carotene desaturase', 151, NULL, NULL, 69975),
(69976, '3.40.50.720-FF-000971', NULL, 'Putative daunorubicin C-13 ketoreductase DnrU', 273, NULL, NULL, 69976),
(69977, '2.120.10.80-FF-000192', NULL, 'Kelch like family member 42', 116, NULL, NULL, 69977),
(69978, '2.40.50.140-FF-000020', NULL, '60S ribosomal protein L2', 86, NULL, NULL, 69978),
(69979, '3.40.190.10-FF-000296', NULL, 'Chorismate mutase', 85, NULL, NULL, 69979),
(69980, '3.10.670.10-FF-000002', NULL, 'Toxin PAU_02230', 181, NULL, NULL, 69980),
(69981, '1.25.40.10-FF-005009', NULL, 'Uncharacterized protein', 116, NULL, NULL, 69981),
(69982, '3.40.50.300-FF-000637', NULL, 'ATP-dependent RNA helicase DHX37/DHR1', 236, NULL, NULL, 69982),
(69983, '3.30.160.60-FF-001356', NULL, 'Human immunodeficiency virus type I enhancer-binding protein 1', 25, NULL, NULL, 69983),
(69984, '3.30.40.10-FF-000916', NULL, 'E3 ubiquitin-protein ligase RFI2', 59, NULL, NULL, 69984),
(69985, '1.20.140.10-FF-000029', NULL, 'Acyl-CoA dehydrogenase FadE6', 149, NULL, NULL, 69985),
(69986, '2.60.120.200-FF-000203', NULL, 'Thrombospondin type laminin G domain and EAR repeats', 207, NULL, NULL, 69986),
(69987, '3.40.50.300-FF-003043', NULL, 'Uncharacterized protein', 256, NULL, NULL, 69987),
(69988, '1.25.10.10-FF-001146', NULL, 'PDS5 cohesin associated factor B', 520, NULL, NULL, 69988),
(69989, '2.60.40.10-FF-003205', NULL, 'T cell receptor alpha variable 2', 100, NULL, NULL, 69989),
(69990, '3.50.50.60-FF-001089', NULL, 'Predicted protein', 80, NULL, NULL, 69990),
(69991, '2.170.16.10-FF-000025', NULL, 'Hedgehog protein', 183, NULL, NULL, 69991),
(69992, '2.40.50.140-FF-000992', NULL, NULL, 89, NULL, NULL, 69992),
(69993, '1.10.1370.30-FF-000048', NULL, 'Angiotensin-converting enzyme', 134, NULL, NULL, 69993),
(69994, '3.40.850.10-FF-000296', NULL, 'Kinesin-like protein', 368, NULL, NULL, 69994),
(69995, '3.30.70.20-FF-000129', NULL, NULL, 50, NULL, NULL, 69995),
(69996, '3.10.250.10-FF-000010', NULL, 'T-cell differentiation antigen CD6', 105, NULL, NULL, 69996),
(69997, '3.40.50.720-FF-000999', NULL, 'Oxidoreductase, short-chain dehydrogenase/reductase family', 242, NULL, NULL, 69997),
(69998, '2.60.40.60-FF-000472', NULL, 'Protein CBR-CDH-12', 99, NULL, NULL, 69998),
(69999, '3.60.40.10-FF-000292', NULL, 'Predicted protein', 214, NULL, NULL, 69999),
(70000, '1.50.10.150-FF-000022', NULL, 'Uncharacterized protein', 98, NULL, NULL, 70000),
(70001, '3.40.50.12370-FF-000013', NULL, 'Uncharacterized protein', 224, NULL, NULL, 70001),
(70002, '1.10.510.10-FF-002691', NULL, NULL, 175, NULL, NULL, 70002),
(70003, '1.10.1450.10-FF-000043', NULL, 'Tetraspanin', 116, NULL, NULL, 70003),
(70004, '1.25.10.10-FF-001438', NULL, 'Serine/threonine-protein kinase tor', 143, NULL, NULL, 70004),
(70005, '2.60.40.150-FF-000123', NULL, 'protein unc-13 homolog D', 186, NULL, NULL, 70005),
(70006, '3.60.20.10-FF-000257', NULL, NULL, 65, NULL, NULL, 70006),
(70007, '1.20.1250.20-FF-000646', NULL, 'High-affinity glucose transporter SNF3, variant', 472, NULL, NULL, 70007),
(70008, '2.60.40.1730-FF-000089', NULL, NULL, 174, NULL, NULL, 70008),
(70009, '1.10.510.10-FF-004309', NULL, NULL, 154, NULL, NULL, 70009),
(70010, '1.20.58.150-FF-000025', NULL, NULL, 149, NULL, NULL, 70010),
(70011, '1.10.10.10-FF-001466', NULL, 'Aliphatic amidase regulator', 52, NULL, NULL, 70011),
(70012, '1.10.1370.10-FF-000042', NULL, 'Uncharacterized protein', 150, NULL, NULL, 70012),
(70013, '1.10.238.10-FF-000202', NULL, 'Calmodulin-like protein 8', 74, NULL, NULL, 70013),
(70014, '1.25.10.10-FF-003124', NULL, 'Uncharacterized protein', 205, NULL, NULL, 70014),
(70015, '3.40.50.300-FF-007225', NULL, 'Uncharacterized protein', 163, NULL, NULL, 70015),
(70016, '1.20.1280.290-FF-000029', NULL, 'Integral to membrane protein, putative', 90, NULL, NULL, 70016);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(70017, '2.60.120.680-FF-000004', NULL, 'FYVE and coiled-coil domain containing 1', 117, NULL, NULL, 70017),
(70018, '3.30.40.10-FF-000624', NULL, 'RING-H2 finger protein ATL47', 82, NULL, NULL, 70018),
(70019, '2.30.29.30-FF-000926', NULL, 'Predicted protein', 123, NULL, NULL, 70019),
(70020, '3.40.50.2000-FF-001118', NULL, 'Chromosome 8, whole genome shotgun sequence', 246, NULL, NULL, 70020),
(70021, '3.30.40.10-FF-002041', NULL, 'GEO12067p1', 96, NULL, NULL, 70021),
(70022, '1.10.800.10-FF-000021', NULL, 'Uncharacterized protein', 116, NULL, NULL, 70022),
(70023, '2.30.180.10-FF-000003', NULL, 'periostin isoform X1', 138, NULL, NULL, 70023),
(70024, '1.20.1250.20-FF-000085', NULL, 'MFS peptide transporter Ptr2', 531, NULL, NULL, 70024),
(70025, '1.10.510.10-FF-000566', NULL, 'Serine/threonine-protein kinase rio2', 147, NULL, NULL, 70025),
(70026, '3.40.630.30-FF-000471', NULL, 'GNAT family N-acetyltransferase', 160, NULL, NULL, 70026),
(70027, '1.10.510.10-FF-003028', NULL, NULL, 224, NULL, NULL, 70027),
(70028, '2.60.220.50-FF-000187', NULL, 'Predicted protein', 39, NULL, NULL, 70028),
(70029, '1.10.640.10-FF-000047', NULL, 'Peroxidase', 100, NULL, NULL, 70029),
(70030, '1.10.10.650-FF-000018', NULL, 'Transcription elongation factor SPT6', 194, NULL, NULL, 70030),
(70031, '3.30.70.270-FF-000027', NULL, 'RNase E specificity factor CsrD', 180, NULL, NULL, 70031),
(70032, '3.20.20.70-FF-000113', NULL, 'Nicotinate phosphoribosyltransferase', 145, NULL, NULL, 70032),
(70033, '1.25.40.10-FF-000490', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 232, NULL, NULL, 70033),
(70034, '3.30.230.130-FF-000056', NULL, 'Uncharacterized protein', 148, NULL, NULL, 70034),
(70035, '1.20.1070.10-FF-001860', NULL, 'Serpentine receptor class gamma-47', 295, NULL, NULL, 70035),
(70036, '3.40.720.10-FF-000112', NULL, 'Uncharacterized protein', 295, NULL, NULL, 70036),
(70037, '3.10.590.10-FF-000001', NULL, 'YTH domain family 1, isoform CRA_a', 171, NULL, NULL, 70037),
(70038, '3.80.10.10-FF-000362', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase IRK', 279, NULL, NULL, 70038),
(70039, '3.40.50.2300-FF-000101', NULL, 'Guanylate cyclase', 109, NULL, NULL, 70039),
(70040, '3.40.50.1820-FF-000676', NULL, 'Alpha/beta hydrolase', 289, NULL, NULL, 70040),
(70041, '3.20.90.10-FF-000004', NULL, 'Uncharacterized protein', 253, NULL, NULL, 70041),
(70042, '2.60.120.260-FF-000053', NULL, 'Reelin', 145, NULL, NULL, 70042),
(70043, '3.40.50.300-FF-001126', NULL, 'Baculoviral IAP repeat-containing protein 1', 204, NULL, NULL, 70043),
(70044, '2.60.120.650-FF-000080', NULL, 'JmjC domain-containing protein A', 252, NULL, NULL, 70044),
(70045, '1.20.1250.20-FF-001927', NULL, 'Uncharacterized MFS-type transporter C18.02', 217, NULL, NULL, 70045),
(70046, '3.40.50.200-FF-000080', NULL, 'Peptidase, S8/S53 family', 427, NULL, NULL, 70046),
(70047, '3.40.50.11040-FF-000007', NULL, 'RNA cytidine acetyltransferase', 219, NULL, NULL, 70047),
(70048, '2.60.220.30-FF-000001', NULL, 'Ankyrin-3 isoform 2', 166, NULL, NULL, 70048),
(70049, '3.40.50.150-FF-000103', NULL, 'SABATH methyltransferase 1', 195, NULL, NULL, 70049),
(70050, '3.30.70.2820-FF-000001', NULL, 'DNA polymerase', 108, NULL, NULL, 70050),
(70051, '2.60.40.60-FF-000180', NULL, 'FAT atypical cadherin 4', 100, NULL, NULL, 70051),
(70052, '2.60.40.10-FF-005330', NULL, NULL, 76, NULL, NULL, 70052),
(70053, '3.30.30.30-FF-000012', NULL, 'Heat shock 70 kDa protein 17', 54, NULL, NULL, 70053),
(70054, '3.40.50.1010-FF-000259', NULL, NULL, 236, NULL, NULL, 70054),
(70055, '2.40.70.10-FF-000437', NULL, NULL, 114, NULL, NULL, 70055),
(70056, '1.25.40.10-FF-005161', NULL, 'Signal peptidase I', 82, NULL, NULL, 70056),
(70057, '1.10.268.10-FF-000030', NULL, NULL, 89, NULL, NULL, 70057),
(70058, '1.10.10.10-FF-000510', NULL, 'ATP-dependent DNA helicase', 101, NULL, NULL, 70058),
(70059, '1.20.58.60-FF-000073', NULL, 'Nesprin-1 isoform 1', 180, NULL, NULL, 70059),
(70060, '3.40.50.450-FF-000042', NULL, '6-phosphofructokinase', 72, NULL, NULL, 70060);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(70061, '3.30.200.20-FF-000230', NULL, 'Eukaryotic elongation factor 2 kinase', 75, NULL, NULL, 70061),
(70062, '1.10.510.10-FF-003972', NULL, 'Uncharacterized protein', 382, NULL, NULL, 70062),
(70063, '2.130.10.10-FF-003329', NULL, 'YALI0C23386p', 88, NULL, NULL, 70063),
(70064, '3.10.290.60-FF-000010', NULL, 'Ubiquitin-like modifier-activating enzyme 1', 58, NULL, NULL, 70064),
(70065, '3.40.50.2300-FF-000281', NULL, 'Metabotropic glutamate receptor 4', 144, NULL, NULL, 70065),
(70066, '3.80.10.10-FF-002599', NULL, 'Vasorin a', 70, NULL, NULL, 70066),
(70067, '3.30.160.60-FF-002020', NULL, 'Odd skipped', 34, NULL, NULL, 70067),
(70068, '3.50.50.60-FF-000341', NULL, 'Baeyer-Villiger monooxygenase', 171, NULL, NULL, 70068),
(70069, '3.30.160.60-FF-002284', NULL, 'Zinc finger protein, putative', 28, NULL, NULL, 70069),
(70070, '1.25.40.10-FF-001827', NULL, 'Os02g0167200 protein', 68, NULL, NULL, 70070),
(70071, '2.10.25.10-FF-000345', NULL, 'Pro-epidermal growth factor', 38, NULL, NULL, 70071),
(70072, '3.40.30.10-FF-001146', NULL, 'Uncharacterized protein', 50, NULL, NULL, 70072),
(70073, '1.20.930.80-FF-000009', NULL, 'DNA primase large subunit', 264, NULL, NULL, 70073),
(70074, '1.25.40.10-FF-005189', NULL, 'Tetratricopeptide repeat protein 21B-like Protein', 230, NULL, NULL, 70074),
(70075, '3.10.100.10-FF-000235', NULL, 'Uncharacterized protein', 144, NULL, NULL, 70075),
(70076, '1.10.10.10-FF-000690', NULL, 'LysR family transcriptional regulator', 83, NULL, NULL, 70076),
(70077, '1.10.10.60-FF-001109', NULL, NULL, 66, NULL, NULL, 70077),
(70078, '2.30.30.100-FF-000220', NULL, 'Predicted protein', 73, NULL, NULL, 70078),
(70079, '2.20.100.10-FF-000248', NULL, 'Uncharacterized protein', 53, NULL, NULL, 70079),
(70080, '2.150.10.10-FF-000001', NULL, 'Serralysin', 223, NULL, NULL, 70080),
(70081, '3.20.20.70-FF-000260', NULL, 'Quinate repressor protein', 246, NULL, NULL, 70081),
(70082, '2.60.40.10-FF-001699', NULL, 'Serine peptidase inhibitor, Kunitz type 1', 56, NULL, NULL, 70082),
(70083, '3.30.40.10-FF-001552', NULL, 'Uncharacterized protein, isoform C', 52, NULL, NULL, 70083),
(70084, '1.20.1250.20-FF-001102', NULL, 'MFS transporter, putative', 417, NULL, NULL, 70084),
(70085, '3.90.550.10-FF-000054', NULL, 'UDP-glucose:glycoprotein glucosyltransferase 1', 246, NULL, NULL, 70085),
(70086, '3.30.1120.90-FF-000007', NULL, 'NAP1-related protein 1', 149, NULL, NULL, 70086),
(70087, '1.20.930.60-FF-000003', NULL, 'DUF89-domain-containing protein', 117, NULL, NULL, 70087),
(70088, '1.10.10.10-FF-001027', NULL, 'RNA polymerase sigma factor', 65, NULL, NULL, 70088),
(70089, '1.10.10.10-FF-000538', NULL, 'Checkpoint suppressor homologue', 98, NULL, NULL, 70089),
(70090, '1.10.472.10-FF-000201', NULL, 'Cyclin pch1', 108, NULL, NULL, 70090),
(70091, '1.10.720.30-FF-000026', NULL, 'Uncharacterized protein, isoform B', 55, NULL, NULL, 70091),
(70092, '1.10.630.10-FF-000221', NULL, 'Uncharacterized protein', 128, NULL, NULL, 70092),
(70093, '1.10.510.10-FF-004489', NULL, NULL, 373, NULL, NULL, 70093),
(70094, '3.10.580.10-FF-000203', NULL, 'Uncharacterized protein', 142, NULL, NULL, 70094),
(70095, '1.10.10.41-FF-000003', NULL, 'DNA topoisomerase I, mitochondrial', 57, NULL, NULL, 70095),
(70096, '1.20.120.1240-FF-000032', NULL, 'Dynamin-1 family protein, putative', 253, NULL, NULL, 70096),
(70097, '3.30.160.60-FF-000075', NULL, 'Putative zinc finger protein 536', 27, NULL, NULL, 70097),
(70098, '3.30.70.80-FF-000012', NULL, 'Os01g0795400 protein', 85, NULL, NULL, 70098),
(70099, '1.10.3810.10-FF-000026', NULL, 'Penicillin-binding protein, class 1A', 183, NULL, NULL, 70099),
(70100, '3.90.470.10-FF-000053', NULL, 'Uncharacterized protein', 166, NULL, NULL, 70100),
(70101, '2.40.50.120-FF-000042', NULL, 'uncharacterized protein YBL113C-like', 124, NULL, NULL, 70101),
(70102, '1.20.940.10-FF-000006', NULL, 'steroid receptor RNA activator 1', 114, NULL, NULL, 70102),
(70103, '1.20.1310.10-FF-000227', NULL, NULL, 131, NULL, NULL, 70103),
(70104, '1.10.600.10-FF-000101', NULL, 'Pentatricopeptide repeat-containing protein', 106, NULL, NULL, 70104);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(70105, '3.90.550.50-FF-000190', NULL, 'Predicted protein', 208, NULL, NULL, 70105),
(70106, '1.50.10.10-FF-000126', NULL, 'Phosphorylase b kinase regulatory subunit', 208, NULL, NULL, 70106),
(70107, '1.20.50.30-FF-000001', NULL, 'DNA primase', 57, NULL, NULL, 70107),
(70108, '2.60.40.1530-FF-000001', NULL, 'Integrin subunit alpha 7', 218, NULL, NULL, 70108),
(70109, '2.40.240.50-FF-000001', NULL, 'Membrane-bound lytic murein transglycosylase A', 138, NULL, NULL, 70109),
(70110, '1.20.810.10-FF-000002', NULL, 'Cytochrome b', 379, NULL, NULL, 70110),
(70111, '3.40.50.300-FF-001273', NULL, 'Aliphatic sulfonates import ATP-binding protein SsuB', 241, NULL, NULL, 70111),
(70112, '2.130.10.10-FF-002992', NULL, 'WD domain, G-beta repeat, putative', 199, NULL, NULL, 70112),
(70113, '2.30.30.1190-FF-000006', NULL, 'Zinc finger CCCH domain-containing protein 58', 51, NULL, NULL, 70113),
(70114, '3.30.450.20-FF-000097', NULL, 'Aryl hydrocarbon receptor repressor', 142, NULL, NULL, 70114),
(70115, '1.20.1050.10-FF-000128', NULL, 'Glutathione S-transferase', 107, NULL, NULL, 70115),
(70116, '2.30.30.40-FF-000528', NULL, 'Tyrosine-protein kinase', 66, NULL, NULL, 70116),
(70117, '2.30.42.10-FF-000120', NULL, 'Ligand of numb-protein X 2', 93, NULL, NULL, 70117),
(70118, '2.30.30.190-FF-000027', NULL, 'Similar to tubulin-specific chaperone E', 84, NULL, NULL, 70118),
(70119, '3.40.50.1240-FF-000098', NULL, 'Phytase', 416, NULL, NULL, 70119),
(70120, '4.10.60.10-FF-000219', NULL, 'Uncharacterized protein', 30, NULL, NULL, 70120),
(70121, '3.20.20.70-FF-000321', NULL, 'tRNA-dihydrouridine synthase', 245, NULL, NULL, 70121),
(70122, '3.40.50.12710-FF-000014', NULL, 'Class I SAM-dependent methyltransferase', 336, NULL, NULL, 70122),
(70123, '2.30.29.30-FF-000134', NULL, 'Putative FERM domain-containing protein 6', 101, NULL, NULL, 70123),
(70124, '3.40.50.10130-FF-000010', NULL, 'Crossover junction endonuclease eme1', 226, NULL, NULL, 70124),
(70125, '2.30.30.40-FF-000472', NULL, 'Uncharacterized protein', 61, NULL, NULL, 70125),
(70126, '3.30.160.60-FF-001295', NULL, 'Zinc finger and BTB domain containing 47', 70, NULL, NULL, 70126),
(70127, '4.10.860.10-FF-000030', NULL, NULL, 51, NULL, NULL, 70127),
(70128, '3.40.50.300-FF-002262', NULL, 'Translation initiation factor IF-2', 62, NULL, NULL, 70128),
(70129, '3.40.1280.30-FF-000010', NULL, 'Protein CBG14899', 202, NULL, NULL, 70129),
(70130, '3.40.390.10-FF-000305', NULL, NULL, 244, NULL, NULL, 70130),
(70131, '2.30.42.10-FF-000592', NULL, NULL, 106, NULL, NULL, 70131),
(70132, '3.40.30.10-FF-000365', NULL, 'Phosducin-like protein 2', 128, NULL, NULL, 70132),
(70133, '1.20.1250.20-FF-000293', NULL, 'Inner membrane protein YqcE', 201, NULL, NULL, 70133),
(70134, '3.30.470.20-FF-000160', NULL, 'Glutathione synthetase', 111, NULL, NULL, 70134),
(70135, '3.80.10.10-FF-003616', NULL, 'Predicted protein', 137, NULL, NULL, 70135),
(70136, '3.40.630.30-FF-000499', NULL, 'Beta-N-acetylglucosaminidase, putative (AFU_orthologue AFUA_3G11780)', 121, NULL, NULL, 70136),
(70137, '3.40.50.1220-FF-000092', NULL, 'DHS-like NAD/FAD-binding domain-containing protein', 142, NULL, NULL, 70137),
(70138, '2.60.40.60-FF-000680', NULL, 'Uncharacterized protein', 105, NULL, NULL, 70138),
(70139, '2.40.10.170-FF-000015', NULL, 'ATP-dependent DNA helicase chloroplastic', 55, NULL, NULL, 70139),
(70140, '1.10.490.160-FF-000010', NULL, NULL, 166, NULL, NULL, 70140),
(70141, '3.40.50.620-FF-000587', NULL, 'Arginyl-tRNA synthetase, putative', 87, NULL, NULL, 70141),
(70142, '2.10.25.10-FF-001626', NULL, 'Uncharacterized protein', 50, NULL, NULL, 70142),
(70143, '2.10.220.10-FF-000220', NULL, 'Proprotein convertase subtilisin/kexin type 4, furin, putative', 113, NULL, NULL, 70143),
(70144, '2.60.120.260-FF-000614', NULL, 'Predicted protein', 138, NULL, NULL, 70144),
(70145, '3.40.50.300-FF-005488', NULL, 'ATP-dependent DNA helicase tlh2', 199, NULL, NULL, 70145),
(70146, '3.30.70.330-FF-001759', NULL, NULL, 116, NULL, NULL, 70146),
(70147, '1.10.10.10-FF-000010', NULL, 'Forkhead box P2 isoform B', 93, NULL, NULL, 70147);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(70148, '2.130.10.10-FF-000783', NULL, 'WD repeat protein', 228, NULL, NULL, 70148),
(70149, '3.10.20.90-FF-000468', NULL, 'Autophagy protein 5', 113, NULL, NULL, 70149),
(70150, '1.10.10.2420-FF-000004', NULL, 'Glutamine--tRNA ligase', 55, NULL, NULL, 70150),
(70151, '1.10.287.130-FF-000144', NULL, 'Two-component sensor histidine kinase', 82, NULL, NULL, 70151),
(70152, '2.60.450.20-FF-000009', NULL, 'Uncharacterized protein', 183, NULL, NULL, 70152),
(70153, '2.10.25.10-FF-000492', NULL, 'agrin isoform X5', 36, NULL, NULL, 70153),
(70154, '3.90.660.10-FF-000028', NULL, 'Flavin containing amine oxidase, putative', 233, NULL, NULL, 70154),
(70155, '3.90.1150.10-FF-000287', NULL, 'Nucleotide-sugar aminotransferase', 128, NULL, NULL, 70155),
(70156, '3.40.630.10-FF-000493', NULL, 'Clan MH, family M18, aspartyl aminopeptidase-like metallopeptidase', 270, NULL, NULL, 70156),
(70157, '2.20.70.10-FF-000191', NULL, 'Predicted protein', 62, NULL, NULL, 70157),
(70158, '3.30.300.30-FF-000004', NULL, 'Acetyl-coenzyme A synthetase', 132, NULL, NULL, 70158),
(70159, '1.10.10.10-FF-000482', NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', 100, NULL, NULL, 70159),
(70160, '3.10.350.10-FF-000074', NULL, 'Putative lipoprotein', 60, NULL, NULL, 70160),
(70161, '3.40.50.720-FF-000319', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', 167, NULL, NULL, 70161),
(70162, '1.20.144.10-FF-000145', NULL, 'Amine oxidase', 154, NULL, NULL, 70162),
(70163, '1.10.510.10-FF-003472', NULL, NULL, 271, NULL, NULL, 70163),
(70164, '3.40.50.300-FF-006477', NULL, 'Uncharacterized protein', 117, NULL, NULL, 70164),
(70165, '3.30.70.360-FF-000049', NULL, 'Acetylornithine deacetylase/Succinyl-diaminopimelate desuccinylase', 171, NULL, NULL, 70165),
(70166, '2.160.20.10-FF-000125', NULL, 'Predicted protein', 135, NULL, NULL, 70166),
(70167, '3.30.60.90-FF-000043', NULL, 'SeQueSTosome related', 53, NULL, NULL, 70167),
(70168, '1.25.40.10-FF-004380', NULL, 'Uncharacterized protein', 145, NULL, NULL, 70168),
(70169, '2.40.50.140-FF-001037', NULL, NULL, 138, NULL, NULL, 70169),
(70170, '6.10.140.2220-FF-000001', NULL, 'CBFA2/RUNX1 translocation partner 3', 57, NULL, NULL, 70170),
(70171, '3.30.210.10-FF-000019', NULL, 'Uncharacterized protein', 65, NULL, NULL, 70171),
(70172, '3.30.830.10-FF-000078', NULL, 'Putative insulinase', 234, NULL, NULL, 70172),
(70173, '2.10.110.10-FF-000127', NULL, 'LIM domain protein', 88, NULL, NULL, 70173),
(70174, '3.40.50.2300-FF-000073', NULL, 'DNA-binding response regulator RprY', 81, NULL, NULL, 70174),
(70175, '1.25.40.20-FF-001095', NULL, 'Serine/threonine-protein kinase NEK', 89, NULL, NULL, 70175),
(70176, '3.40.50.720-FF-001308', NULL, 'UDP-galactopyranose mutase', 64, NULL, NULL, 70176),
(70177, '3.30.200.20-FF-002467', NULL, 'Non-specific serine/threonine protein kinase', 51, NULL, NULL, 70177),
(70178, '2.60.40.10-FF-005561', NULL, NULL, 112, NULL, NULL, 70178),
(70179, '1.20.1530.20-FF-000067', NULL, 'Cation/H(+) antiporter 15', 403, NULL, NULL, 70179),
(70180, '2.60.40.10-FF-002424', NULL, 'Protein CBG19196', 98, NULL, NULL, 70180),
(70181, '1.20.272.10-FF-000083', NULL, NULL, 68, NULL, NULL, 70181),
(70182, '1.20.80.10-FF-000082', NULL, 'Predicted protein', 116, NULL, NULL, 70182),
(70183, '2.130.10.10-FF-002492', NULL, 'Histidine kinase/response regulator hybrid protein', 174, NULL, NULL, 70183),
(70184, '2.60.120.970-FF-000114', NULL, 'Glass bottom boat2', 93, NULL, NULL, 70184),
(70185, '3.10.100.10-FF-000027', NULL, 'Mannose receptor, C type 1', 137, NULL, NULL, 70185),
(70186, '2.130.10.10-FF-002020', NULL, 'Autophagic-related protein 16.1', 168, NULL, NULL, 70186),
(70187, '3.30.40.10-FF-001052', NULL, 'TNF receptor-associated factor 6', 52, NULL, NULL, 70187),
(70188, '1.25.40.10-FF-001619', NULL, 'Stress-induced-phosphoprotein 1', 116, NULL, NULL, 70188),
(70189, '1.25.40.530-FF-000006', NULL, 'MYO7B isoform 7', 104, NULL, NULL, 70189),
(70190, '1.10.357.20-FF-000015', NULL, 'Solute carrier family 41 member 1', 186, NULL, NULL, 70190),
(70191, '2.60.40.10-FF-001435', NULL, 'Immunoglobulin-like and fibronectin type III domain-containing 1', 98, NULL, NULL, 70191);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(70192, '1.20.960.50-FF-000002', NULL, 'Uncharacterized protein', 55, NULL, NULL, 70192),
(70193, '3.30.70.330-FF-002715', NULL, NULL, 103, NULL, NULL, 70193),
(70194, '3.40.225.10-FF-000023', NULL, 'Fuculose phosphate aldolase', 214, NULL, NULL, 70194),
(70195, '2.40.10.10-FF-000372', NULL, 'Myeloblastin', 108, NULL, NULL, 70195),
(70196, '1.25.40.10-FF-003391', NULL, 'Pentatricopeptide repeat-containing protein', 263, NULL, NULL, 70196),
(70197, '3.30.160.60-FF-005246', NULL, NULL, 43, NULL, NULL, 70197),
(70198, '3.40.910.10-FF-000003', NULL, 'Deoxyhypusine synthase', 353, NULL, NULL, 70198),
(70199, '3.40.50.300-FF-007197', NULL, 'Uncharacterized protein', 168, NULL, NULL, 70199),
(70200, '1.25.40.20-FF-000728', NULL, 'Tumor protein p53-binding protein, 2b', 155, NULL, NULL, 70200),
(70201, '2.60.40.1730-FF-000061', NULL, NULL, 125, NULL, NULL, 70201),
(70202, '3.50.30.10-FF-000016', NULL, NULL, 105, NULL, NULL, 70202),
(70203, '1.20.1270.280-FF-000047', NULL, 'Dynein heavy chain family protein', 161, NULL, NULL, 70203),
(70204, '1.10.510.10-FF-000919', NULL, 'NPR1p Protein kinase', 230, NULL, NULL, 70204),
(70205, '3.60.21.10-FF-000220', NULL, 'Serine/threonine-protein phosphatase', 327, NULL, NULL, 70205),
(70206, '3.30.420.10-FF-000120', NULL, 'Poly(A)-specific ribonuclease PARN', 221, NULL, NULL, 70206),
(70207, '2.10.50.10-FF-000117', NULL, 'Uncharacterized protein', 41, NULL, NULL, 70207),
(70208, '3.30.930.10-FF-000142', NULL, 'Proline--tRNA ligase', 115, NULL, NULL, 70208),
(70209, '2.160.20.70-FF-000036', NULL, 'Tubulin-specific chaperone C', 188, NULL, NULL, 70209),
(70210, '2.30.30.100-FF-000012', NULL, 'RNA-binding protein Hfq', 74, NULL, NULL, 70210),
(70211, '3.30.160.60-FF-005190', NULL, NULL, 27, NULL, NULL, 70211),
(70212, '3.90.150.10-FF-000006', NULL, 'Variant surface glycoprotein (VSG), putative', 191, NULL, NULL, 70212),
(70213, '1.10.8.50-FF-000015', NULL, '30S ribosomal protein-like protein S13', 70, NULL, NULL, 70213),
(70214, '1.10.510.10-FF-003528', NULL, NULL, 242, NULL, NULL, 70214),
(70215, '1.10.8.1220-FF-000015', NULL, 'Dynein heavy chain 6, axonemal', 92, NULL, NULL, 70215),
(70216, '1.10.540.10-FF-000130', NULL, 'Cyclohexane-1-carbonyl-CoA dehydrogenase', 109, NULL, NULL, 70216),
(70217, '3.40.50.300-FF-003690', NULL, 'Origin recognition complex subunit 1', 169, NULL, NULL, 70217),
(70218, '2.60.40.650-FF-000003', NULL, 'Sulfite oxidase, mitochondrial', 123, NULL, NULL, 70218),
(70219, '3.30.750.24-FF-000028', NULL, 'Sulfate transporter, putative', 101, NULL, NULL, 70219),
(70220, '3.30.160.60-FF-006027', NULL, NULL, 28, NULL, NULL, 70220),
(70221, '3.30.70.270-FF-000319', NULL, NULL, 11, NULL, NULL, 70221),
(70222, '1.10.150.110-FF-000026', NULL, 'Crossover junction endonuclease MUS81', 71, NULL, NULL, 70222),
(70223, '4.10.80.100-FF-000002', NULL, 'Uncharacterized protein', 26, NULL, NULL, 70223),
(70224, '1.25.10.10-FF-002635', NULL, 'Uncharacterized protein', 122, NULL, NULL, 70224),
(70225, '1.20.120.20-FF-000003', NULL, 'Apolipoprotein E', 101, NULL, NULL, 70225),
(70226, '3.90.230.10-FF-000007', NULL, 'Xaa-Pro aminopeptidase P', 300, NULL, NULL, 70226),
(70227, '1.10.472.100-FF-000001', NULL, 'Presenilin', 105, NULL, NULL, 70227),
(70228, '3.60.10.10-FF-000200', NULL, 'Endonuclease/exonuclease/phosphatase family protein', 233, NULL, NULL, 70228),
(70229, '1.25.10.10-FF-001207', NULL, 'HEAT-like_repeat_-_putative', 286, NULL, NULL, 70229),
(70230, '1.10.533.10-FF-000282', NULL, 'Uncharacterized protein', 121, NULL, NULL, 70230),
(70231, '3.30.160.60-FF-002637', NULL, 'Zinc finger protein 732', 28, NULL, NULL, 70231),
(70232, '3.30.40.10-FF-000271', NULL, 'helicase-like transcription factor isoform X2', 73, NULL, NULL, 70232),
(70233, '1.10.287.3240-FF-000027', NULL, 'V-type ATP synthase subunit D', 210, NULL, NULL, 70233),
(70234, '3.30.70.120-FF-000033', NULL, NULL, 104, NULL, NULL, 70234),
(70235, '2.20.100.10-FF-000017', NULL, 'Thrombospondin type 1 domain containing 7A', 51, NULL, NULL, 70235),
(70236, '3.40.30.10-FF-000157', NULL, 'DOT5p Nuclear thiol peroxidase', 144, NULL, NULL, 70236);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(70237, '3.10.20.90-FF-000732', NULL, 'NAD(P)(+)--arginine ADP-ribosyltransferase', 65, NULL, NULL, 70237),
(70238, '1.10.287.70-FF-000064', NULL, 'Glutamate receptor ionotropic, kainate', 158, NULL, NULL, 70238),
(70239, '3.30.200.20-FF-002236', NULL, 'Uncharacterized protein', 34, NULL, NULL, 70239),
(70240, '1.10.150.20-FF-000029', NULL, 'DNA repair protein RAD51 homolog', 85, NULL, NULL, 70240),
(70241, '2.60.40.10-FF-000007', NULL, 'Filamin-B isoform C', 95, NULL, NULL, 70241),
(70242, '1.20.58.60-FF-000218', NULL, 'Uncharacterized protein, isoform B', 274, NULL, NULL, 70242),
(70243, '1.25.40.20-FF-000959', NULL, 'transient receptor potential cation channel subfamily V member 5 isoform X1', 287, NULL, NULL, 70243),
(70244, '3.10.450.40-FF-000034', NULL, 'DCL protein', 65, NULL, NULL, 70244),
(70245, '3.60.20.10-FF-000049', NULL, 'Proteasome subunit beta', 204, NULL, NULL, 70245),
(70246, '3.40.50.300-FF-002054', NULL, 'DNA mismatch repair protein MSH4', 297, NULL, NULL, 70246),
(70247, '3.10.105.10-FF-000111', NULL, 'ABC-type transport system periplasmic substrate-binding protein (Probable substrate dipeptide/oligopeptide)', 208, NULL, NULL, 70247),
(70248, '2.60.40.10-FF-000479', NULL, 'Vascular endothelial growth factor receptor 3', 87, NULL, NULL, 70248),
(70249, '3.40.50.620-FF-000323', NULL, 'tRNA-specific 2-thiouridylase MnmA', 202, NULL, NULL, 70249),
(70250, '3.30.300.180-FF-000008', NULL, 'Chromosomal replication initiator protein DnaA', 98, NULL, NULL, 70250),
(70251, '2.60.120.10-FF-000459', NULL, 'Uncharacterized protein', 153, NULL, NULL, 70251),
(70252, '1.20.900.10-FF-000032', NULL, 'rho guanine nucleotide exchange factor 38', 236, NULL, NULL, 70252),
(70253, '3.30.930.10-FF-000350', NULL, 'Uncharacterized protein', 62, NULL, NULL, 70253),
(70254, '3.30.450.20-FF-000361', NULL, 'Two-component hybrid sensor and regulator', 110, NULL, NULL, 70254),
(70255, '3.30.1370.10-FF-000188', NULL, 'Protein CBG16603', 201, NULL, NULL, 70255),
(70256, '3.90.320.10-FF-000037', NULL, 'Putative helicase 2', 193, NULL, NULL, 70256),
(70257, '3.40.50.620-FF-000907', NULL, 'Isoleucine--tRNA ligase chloroplastic/mitochondrial', 57, NULL, NULL, 70257),
(70258, '3.80.10.10-FF-000070', NULL, 'Centrosomal protein of 78 kDa', 204, NULL, NULL, 70258),
(70259, '3.30.2230.10-FF-000032', NULL, 'Uncharacterized protein', 104, NULL, NULL, 70259),
(70260, '3.40.50.300-FF-000429', NULL, 'Preprotein translocase subunit SecA', 174, NULL, NULL, 70260),
(70261, '3.30.70.270-FF-000174', NULL, 'DNA polymerase kappa', 148, NULL, NULL, 70261),
(70262, '3.30.420.10-FF-000384', NULL, NULL, 119, NULL, NULL, 70262),
(70263, '1.10.238.10-FF-001158', NULL, 'rab11 family-interacting protein 3-like', 112, NULL, NULL, 70263),
(70264, '2.60.40.150-FF-000387', NULL, 'PI-3 kinase', 171, NULL, NULL, 70264),
(70265, '3.50.30.30-FF-000174', NULL, 'Uncharacterized protein', 112, NULL, NULL, 70265),
(70266, '1.25.40.10-FF-001035', NULL, 'Selenium-binding protein-like', 173, NULL, NULL, 70266),
(70267, '2.60.120.10-FF-000370', NULL, 'Crp/Fnr family transcriptional regulator', 133, NULL, NULL, 70267),
(70268, '3.30.450.70-FF-000004', NULL, 'Trafficking protein particle complex 1', 145, NULL, NULL, 70268),
(70269, '3.30.160.60-FF-000103', NULL, 'FEZ family zinc finger 1', 26, NULL, NULL, 70269),
(70270, '1.20.120.720-FF-000004', NULL, 'unconventional myosin-Ib isoform X1', 112, NULL, NULL, 70270),
(70271, '3.90.740.10-FF-000029', NULL, 'Mitochondrial isoleucyl-tRNA synthetase', 157, NULL, NULL, 70271),
(70272, '1.25.40.10-FF-004172', NULL, 'Predicted protein', 98, NULL, NULL, 70272),
(70273, '3.80.10.10-FF-002627', NULL, 'Putative RAN GTPase activating family protein', 171, NULL, NULL, 70273),
(70274, '2.30.30.550-FF-000006', NULL, 'Major vault protein beta', 60, NULL, NULL, 70274),
(70275, '1.10.357.140-FF-000051', NULL, 'Uncharacterized protein', 150, NULL, NULL, 70275),
(70276, '3.40.1190.20-FF-000146', NULL, 'Ribokinase', 311, NULL, NULL, 70276),
(70277, '3.30.420.40-FF-000488', NULL, 'Chaperone protein DNAK, putative', 99, NULL, NULL, 70277);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(70278, '2.60.120.330-FF-000130', NULL, 'Uncharacterized protein', 107, NULL, NULL, 70278),
(70279, '3.80.10.10-FF-004336', NULL, 'Uncharacterized protein', 193, NULL, NULL, 70279),
(70280, '2.60.40.10-FF-002216', NULL, 'Paired immunoglobulin-like receptor B', 95, NULL, NULL, 70280),
(70281, '2.130.10.10-FF-001300', NULL, 'U4/U6 small nuclear ribonucleoprotein Prp4', 182, NULL, NULL, 70281),
(70282, '1.20.1250.20-FF-001074', NULL, 'Uncharacterized protein', 214, NULL, NULL, 70282),
(70283, '3.40.109.10-FF-000012', NULL, 'Nitroreductase family protein', 170, NULL, NULL, 70283),
(70284, '3.40.50.2000-FF-000573', NULL, 'Glycosyltransferase WbuB', 177, NULL, NULL, 70284),
(70285, '3.50.50.60-FF-000780', NULL, 'Fumarate reductase flavoprotein subunit', 291, NULL, NULL, 70285),
(70286, '2.30.29.30-FF-000365', NULL, 'Related to CDC24-GTP/GDP exchange factor for Cdc42p', 170, NULL, NULL, 70286),
(70287, '2.60.40.1120-FF-000029', NULL, 'Carboxypeptidase D, b', 87, NULL, NULL, 70287),
(70288, '1.25.40.1040-FF-000044', NULL, 'Uncharacterized protein', 298, NULL, NULL, 70288),
(70289, '3.40.50.2060-FF-000012', NULL, 'Syntaxin binding protein, putative', 130, NULL, NULL, 70289),
(70290, '1.25.40.430-FF-000010', NULL, 'BUB1 mitotic checkpoint serine/threonine kinase Bb', 79, NULL, NULL, 70290),
(70291, '3.30.70.330-FF-002923', NULL, NULL, 126, NULL, NULL, 70291),
(70292, '3.80.10.10-FF-000593', NULL, 'Tubulin-specific chaperone E', 136, NULL, NULL, 70292),
(70293, '3.90.226.10-FF-000109', NULL, 'Enoyl-CoA hydratase, putative', 247, NULL, NULL, 70293),
(70294, '1.10.630.10-FF-000513', NULL, 'Uncharacterized protein', 416, NULL, NULL, 70294),
(70295, '3.40.190.10-FF-000088', NULL, 'HTH-type transcriptional regulator LeuO', 105, NULL, NULL, 70295),
(70296, '2.130.10.10-FF-002548', NULL, 'QUInine non-avoider', 198, NULL, NULL, 70296),
(70297, '3.30.40.10-FF-001260', NULL, 'E3 ubiquitin-protein ligase', 69, NULL, NULL, 70297),
(70298, '1.25.40.10-FF-002547', NULL, 'Os05g0574800 protein', 121, NULL, NULL, 70298),
(70299, '3.40.50.1000-FF-000582', NULL, NULL, 106, NULL, NULL, 70299),
(70300, '3.30.160.60-FF-000928', NULL, 'Uncharacterized protein', 28, NULL, NULL, 70300),
(70301, '3.80.10.10-FF-001851', NULL, 'Adenylate cyclase', 150, NULL, NULL, 70301),
(70302, '3.40.50.300-FF-000929', NULL, 'DNA helicase', 352, NULL, NULL, 70302),
(70303, '3.30.450.20-FF-000422', NULL, 'Sensory transduction histidine kinase', 60, NULL, NULL, 70303),
(70304, '1.10.238.10-FF-000702', NULL, 'Reticulocalbin 3, EF-hand calcium-binding domain', 60, NULL, NULL, 70304),
(70305, '1.20.1540.10-FF-000036', NULL, 'Rhomboid family serine protease', 189, NULL, NULL, 70305),
(70306, '1.25.40.120-FF-000092', NULL, 'Uncharacterized protein', 202, NULL, NULL, 70306),
(70307, '1.10.510.10-FF-003680', NULL, NULL, 171, NULL, NULL, 70307),
(70308, '2.102.10.10-FF-000021', NULL, 'Ferredoxin, Rieske superfamily', 105, NULL, NULL, 70308),
(70309, '3.30.160.60-FF-005038', NULL, NULL, 32, NULL, NULL, 70309),
(70310, '3.50.50.60-FF-001297', NULL, 'Dihydrolipoyl dehydrogenase', 201, NULL, NULL, 70310),
(70311, '3.40.50.300-FF-005808', NULL, 'Hydin', 254, NULL, NULL, 70311),
(70312, '1.20.120.980-FF-000003', NULL, 'Serine protease 16', 155, NULL, NULL, 70312),
(70313, '3.40.1110.10-FF-000217', NULL, 'Cation transporter P-type ATPase A', 117, NULL, NULL, 70313),
(70314, '3.40.1550.10-FF-000008', NULL, 'Chemotaxis operon protein', 161, NULL, NULL, 70314),
(70315, '3.40.50.720-FF-000471', NULL, 'epimerase family protein SDR39U1 isoform X1', 292, NULL, NULL, 70315),
(70316, '3.40.190.10-FF-000796', NULL, 'Prephenate dehydratase', 91, NULL, NULL, 70316),
(70317, '3.90.148.10-FF-000001', NULL, 'DNA-binding protein', 41, NULL, NULL, 70317),
(70318, '1.10.730.10-FF-000077', NULL, 'Arginine--tRNA ligase', 121, NULL, NULL, 70318),
(70319, '3.90.70.10-FF-000197', NULL, 'Ubiquitin carboxyl-terminal hydrolase 17-like protein E', 311, NULL, NULL, 70319),
(70320, '1.20.920.10-FF-000095', NULL, 'PolyBRoMo domain containing', 119, NULL, NULL, 70320),
(70321, '1.50.40.10-FF-000538', NULL, 'Uncharacterized protein', 153, NULL, NULL, 70321);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(70322, '2.70.98.10-FF-000078', NULL, 'Beta-galactosidase', 296, NULL, NULL, 70322),
(70323, '1.10.10.10-FF-001258', NULL, 'Predicted protein', 80, NULL, NULL, 70323),
(70324, '2.60.120.200-FF-000703', NULL, 'Uncharacterized protein', 185, NULL, NULL, 70324),
(70325, '3.90.228.10-FF-000002', NULL, 'Poly [ADP-ribose] polymerase', 215, NULL, NULL, 70325),
(70326, '1.20.120.420-FF-000004', NULL, 'Methylthioribose-1-phosphate isomerase', 144, NULL, NULL, 70326),
(70327, '3.40.50.300-FF-004824', NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily-related, putative', 337, NULL, NULL, 70327),
(70328, '2.20.70.10-FF-000039', NULL, 'E3 ubiquitin-protein ligase', 38, NULL, NULL, 70328),
(70329, '3.30.70.960-FF-000021', NULL, 'Uncharacterized protein', 97, NULL, NULL, 70329),
(70330, '1.20.1110.10-FF-000015', NULL, 'Sodium ion P-type ATPase', 336, NULL, NULL, 70330),
(70331, '2.130.10.10-FF-004173', NULL, 'Predicted protein', 167, NULL, NULL, 70331),
(70332, '3.90.640.10-FF-000084', NULL, 'Related to ARP5-Actin-related protein', 59, NULL, NULL, 70332),
(70333, '2.60.40.10-FF-000979', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', 92, NULL, NULL, 70333),
(70334, '2.10.25.10-FF-000637', NULL, 'Weary, isoform B', 50, NULL, NULL, 70334),
(70335, '1.10.510.10-FF-004197', NULL, NULL, 225, NULL, NULL, 70335),
(70336, '3.40.50.300-FF-007433', NULL, 'Predicted protein', 332, NULL, NULL, 70336),
(70337, '3.90.226.10-FF-000020', NULL, 'ATP-dependent Clp protease proteolytic subunit', 211, NULL, NULL, 70337),
(70338, '1.10.3720.10-FF-000199', NULL, 'ABC-type peptide uptake system permease component 1 SapB', 203, NULL, NULL, 70338),
(70339, '2.10.110.10-FF-000071', NULL, 'nebulin-related-anchoring protein isoform X1', 66, NULL, NULL, 70339),
(70340, '3.10.310.10-FF-000009', NULL, 'Diaminopimelate epimerase chloroplastic', 148, NULL, NULL, 70340),
(70341, '3.30.1490.40-FF-000003', NULL, 'Zinc finger CCCH domain-containing protein 19', 55, NULL, NULL, 70341),
(70342, '3.40.50.720-FF-001960', NULL, 'Uncharacterized protein', 258, NULL, NULL, 70342),
(70343, '3.40.720.10-FF-000320', NULL, 'Arylsulfatase G', 176, NULL, NULL, 70343),
(70344, '1.10.8.10-FF-000262', NULL, 'Similar to putative TRAF and TNF receptor associated protein, isoform CRA_c', 92, NULL, NULL, 70344),
(70345, '3.10.20.90-FF-000940', NULL, 'U-box domain-containing protein 57', 75, NULL, NULL, 70345),
(70346, '3.90.70.10-FF-000461', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 344, NULL, NULL, 70346),
(70347, '3.30.2160.10-FF-000060', NULL, 'Uncharacterized protein', 63, NULL, NULL, 70347),
(70348, '1.20.58.60-FF-000573', NULL, 'Plectin', 262, NULL, NULL, 70348),
(70349, '1.10.287.70-FF-000564', NULL, 'Uncharacterized protein', 37, NULL, NULL, 70349),
(70350, '3.40.710.10-FF-000106', NULL, 'Penicillin-binding protein 2X', 221, NULL, NULL, 70350),
(70351, '1.10.30.10-FF-000129', NULL, 'High mobility group-T protein', 85, NULL, NULL, 70351),
(70352, '3.20.20.190-FF-000153', NULL, NULL, 226, NULL, NULL, 70352),
(70353, '3.40.570.10-FF-000050', NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase 3', 150, NULL, NULL, 70353),
(70354, '1.25.10.10-FF-002135', NULL, 'V-type proton ATPase subunit H', 317, NULL, NULL, 70354),
(70355, '3.40.50.300-FF-001334', NULL, 'ATP-dependent DNA helicase Q-like 5', 192, NULL, NULL, 70355),
(70356, '1.10.3380.30-FF-000021', NULL, 'SKI (Yeast SuperKIller) Helicase homolog', 68, NULL, NULL, 70356),
(70357, '3.40.50.2300-FF-000781', NULL, NULL, 106, NULL, NULL, 70357),
(70358, '3.30.565.10-FF-000562', NULL, 'Uncharacterized protein', 157, NULL, NULL, 70358),
(70359, '2.40.50.140-FF-000109', NULL, 'AAA ATPase forming ring-shaped complexes', 60, NULL, NULL, 70359),
(70360, '2.130.10.10-FF-004757', NULL, 'Histone transcription regulator slm9', 158, NULL, NULL, 70360),
(70361, '2.60.40.790-FF-000051', NULL, 'nudC domain-containing protein 2', 87, NULL, NULL, 70361),
(70362, '1.25.10.10-FF-000954', NULL, 'Spindle pole body protein, putative', 191, NULL, NULL, 70362);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(70363, '3.30.70.330-FF-000978', NULL, 'UBP1-associated protein 2A', 128, NULL, NULL, 70363),
(70364, '3.40.50.300-FF-004471', NULL, 'Predicted protein', 231, NULL, NULL, 70364),
(70365, '3.40.1090.10-FF-000080', NULL, 'MGC108045 protein', 63, NULL, NULL, 70365),
(70366, '1.10.3370.10-FF-000037', NULL, 'Os12g0612600 protein', 334, NULL, NULL, 70366),
(70367, '1.10.620.20-FF-000021', NULL, 'Ribonucleoside-diphosphate reductase small subunit', 304, NULL, NULL, 70367),
(70368, '2.60.40.10-FF-001199', NULL, 'B-cell receptor CD22', 86, NULL, NULL, 70368),
(70369, '2.130.10.10-FF-001823', NULL, 'Tricorn protease', 350, NULL, NULL, 70369),
(70370, '1.20.1310.10-FF-000199', NULL, NULL, 135, NULL, NULL, 70370),
(70371, '3.10.110.10-FF-000264', NULL, 'Ubiquitin-conjugating enzyme family protein', 155, NULL, NULL, 70371),
(70372, '1.25.40.10-FF-003452', NULL, 'AGAP000136-PA', 232, NULL, NULL, 70372),
(70373, '3.30.1310.10-FF-000004', NULL, 'Nucleoid-associated protein, chloroplastic', 108, NULL, NULL, 70373),
(70374, '1.10.8.100-FF-000001', NULL, 'Ribosomal RNA small subunit methyltransferase A', 66, NULL, NULL, 70374),
(70375, '2.60.120.200-FF-000642', NULL, 'Tyrosine-protein kinase receptor', 111, NULL, NULL, 70375),
(70376, '3.30.160.60-FF-004993', NULL, NULL, 59, NULL, NULL, 70376),
(70377, '2.70.170.10-FF-000089', NULL, 'Uncharacterized protein', 205, NULL, NULL, 70377),
(70378, '3.40.50.1820-FF-001457', NULL, 'Alpha/beta-Hydrolases superfamily protein', 182, NULL, NULL, 70378),
(70379, '2.30.30.490-FF-000027', NULL, 'DNA (cytosine-5)-methyltransferase', 176, NULL, NULL, 70379),
(70380, '3.40.50.12650-FF-000035', NULL, 'ADR250Cp', 136, NULL, NULL, 70380),
(70381, '1.10.510.10-FF-001263', NULL, 'Protein kinase, putative', 294, NULL, NULL, 70381),
(70382, '4.10.60.10-FF-000158', NULL, 'RNA binding motif protein 4 [', 33, NULL, NULL, 70382),
(70383, '3.90.1150.10-FF-000495', NULL, 'Uncharacterized protein', 33, NULL, NULL, 70383),
(70384, '3.10.20.30-FF-000057', NULL, 'Threonine--tRNA ligase', 63, NULL, NULL, 70384),
(70385, '1.25.40.20-FF-001156', NULL, 'L-asparaginase', 138, NULL, NULL, 70385),
(70386, '3.30.559.30-FF-000071', NULL, 'Uncharacterized protein', 243, NULL, NULL, 70386),
(70387, '3.40.50.300-FF-005752', NULL, 'Dicer-like protein', 131, NULL, NULL, 70387),
(70388, '3.40.50.150-FF-000042', NULL, '50S ribosomal protein L3 glutamine methyltransferase', 175, NULL, NULL, 70388),
(70389, '3.10.450.50-FF-000008', NULL, '3-phenylpropionate/cinnamic acid dioxygenase subunit beta', 172, NULL, NULL, 70389),
(70390, '2.60.40.10-FF-004633', NULL, NULL, 138, NULL, NULL, 70390),
(70391, '1.10.238.10-FF-000966', NULL, 'reticulocalbin-2-like', 102, NULL, NULL, 70391),
(70392, '2.60.120.260-FF-000406', NULL, 'Beta-xylanase', 155, NULL, NULL, 70392),
(70393, '3.30.450.20-FF-000158', NULL, 'Circadian locomoter output cycles protein kaput', 154, NULL, NULL, 70393),
(70394, '1.20.1610.10-FF-000008', NULL, 'Glycoside hydrolase family 92 protein', 177, NULL, NULL, 70394),
(70395, '3.40.960.10-FF-000006', NULL, 'Cullin, a subunit of E3 ubiquitin ligase', 87, NULL, NULL, 70395),
(70396, '3.30.40.10-FF-000332', NULL, 'Peroxisome biogenesis factor 10', 82, NULL, NULL, 70396),
(70397, '1.20.1070.10-FF-001208', NULL, 'Chemokine (C-X-C motif) receptor 3, tandem duplicate 1', 194, NULL, NULL, 70397),
(70398, '1.25.40.860-FF-000021', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 132, NULL, NULL, 70398),
(70399, '1.25.40.10-FF-004733', NULL, 'Tetratricopeptide repeat protein 21 homolog', 378, NULL, NULL, 70399),
(70400, '3.30.40.10-FF-001760', NULL, 'Chromatin modification-related protein', 67, NULL, NULL, 70400),
(70401, '2.10.25.10-FF-001565', NULL, 'Uncharacterized protein', 63, NULL, NULL, 70401),
(70402, '3.40.50.360-FF-000020', NULL, 'Flavodoxin_1, Flavodoxin', 148, NULL, NULL, 70402),
(70403, '2.10.25.10-FF-000845', NULL, 'laminin subunit alpha', 42, NULL, NULL, 70403),
(70404, '1.25.10.10-FF-003416', NULL, 'Predicted protein', 333, NULL, NULL, 70404),
(70405, '3.30.310.260-FF-000001', NULL, '8-oxoguanine DNA glycosylase', 97, NULL, NULL, 70405);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(70406, '3.60.150.10-FF-000013', NULL, 'Chorismate synthase', 368, NULL, NULL, 70406),
(70407, '1.20.1420.30-FF-000011', NULL, 'Vacuolar calcium ion transporter', 158, NULL, NULL, 70407),
(70408, '3.30.40.10-FF-000855', NULL, 'Pre-mRNA-splicing factor CWC24', 93, NULL, NULL, 70408),
(70409, '3.30.2020.30-FF-000033', NULL, 'Uncharacterized protein', 67, NULL, NULL, 70409),
(70410, '3.50.50.60-FF-000841', NULL, 'Zgc:77439', 51, NULL, NULL, 70410),
(70411, '1.20.1250.40-FF-000040', NULL, 'Uncharacterized protein', 148, NULL, NULL, 70411),
(70412, '3.30.70.330-FF-000506', NULL, 'Heterogeneous nuclear ribonucleoprotein 1', 114, NULL, NULL, 70412),
(70413, '3.40.50.80-FF-000016', NULL, 'NAD(P)H-flavin reductase', 135, NULL, NULL, 70413),
(70414, '3.40.190.10-FF-000588', NULL, 'Oligopeptide ABC transporter, periplasmic oligopeptide-binding protein', 98, NULL, NULL, 70414),
(70415, '3.40.718.10-FF-000051', NULL, 'Isocitrate dehydrogenase, putative', 207, NULL, NULL, 70415),
(70416, '3.40.20.10-FF-000128', NULL, 'SD03793p', 65, NULL, NULL, 70416),
(70417, '3.40.50.620-FF-000087', NULL, 'Leucine--tRNA ligase', 82, NULL, NULL, 70417),
(70418, '3.30.920.20-FF-000003', NULL, 'Growth arrest-specific 2 like 3', 95, NULL, NULL, 70418),
(70419, '1.10.630.10-FF-000721', NULL, 'Cytochrome P450, putative', 103, NULL, NULL, 70419),
(70420, '2.60.40.10-FF-002688', NULL, NULL, 98, NULL, NULL, 70420),
(70421, '3.40.50.410-FF-000350', NULL, 'Uncharacterized protein', 96, NULL, NULL, 70421),
(70422, '1.20.58.100-FF-000004', NULL, 'Succinate dehydrogenase flavoprotein subunit', 116, NULL, NULL, 70422),
(70423, '3.30.160.60-FF-000575', NULL, 'Zinc finger protein OZF', 28, NULL, NULL, 70423),
(70424, '1.20.1720.10-FF-000101', NULL, NULL, 204, NULL, NULL, 70424),
(70425, '1.20.120.350-FF-000051', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 75, NULL, NULL, 70425),
(70426, '1.10.287.110-FF-000458', NULL, 'Uncharacterized protein', 121, NULL, NULL, 70426),
(70427, '3.30.70.1230-FF-000075', NULL, 'Adenylate/guanylate cyclase domain-containing protein', 196, NULL, NULL, 70427),
(70428, '1.10.575.10-FF-000007', NULL, 'p1/s1 nuclease, putative', 299, NULL, NULL, 70428),
(70429, '3.90.550.10-FF-000554', NULL, 'Uncharacterized protein', 218, NULL, NULL, 70429),
(70430, '3.40.50.150-FF-000867', NULL, 'Predicted protein', 178, NULL, NULL, 70430),
(70431, '3.40.50.2300-FF-000629', NULL, 'Glutamate receptor 1.3', 172, NULL, NULL, 70431),
(70432, '1.25.40.10-FF-000838', NULL, 'Unplaced genomic scaffold supercont1.20, whole genome shotgun sequence', 390, NULL, NULL, 70432),
(70433, '2.60.40.150-FF-000623', NULL, 'Uncharacterized protein', 145, NULL, NULL, 70433),
(70434, '1.20.58.1710-FF-000002', NULL, 'Mediator of RNA polymerase II transcription subunit 8', 69, NULL, NULL, 70434),
(70435, '3.30.310.80-FF-000031', NULL, 'Non-specific serine/threonine protein kinase', 81, NULL, NULL, 70435),
(70436, '2.30.30.40-FF-000680', NULL, 'Uncharacterized protein', 70, NULL, NULL, 70436),
(70437, '1.25.40.20-FF-000375', NULL, 'ankyrin repeat domain-containing protein 42', 109, NULL, NULL, 70437),
(70438, '2.30.42.10-FF-000384', NULL, NULL, 103, NULL, NULL, 70438),
(70439, '1.20.1560.10-FF-000358', NULL, 'ABC multidrug transporter, putative', 31, NULL, NULL, 70439),
(70440, '3.30.420.10-FF-000620', NULL, NULL, 173, NULL, NULL, 70440),
(70441, '3.40.50.10810-FF-000028', NULL, 'Chromatin-remodeling complex ATPase', 216, NULL, NULL, 70441),
(70442, '1.20.1640.10-FF-000100', NULL, NULL, 201, NULL, NULL, 70442),
(70443, '2.60.40.10-FF-003144', NULL, 'Protein tyrosine phosphatase receptor type b', 94, NULL, NULL, 70443),
(70444, '3.40.1050.10-FF-000015', NULL, 'Carbonic anhydrase', 188, NULL, NULL, 70444),
(70445, '1.10.260.30-FF-000007', NULL, 'Chorismate mutase', 117, NULL, NULL, 70445),
(70446, '3.40.640.10-FF-000078', NULL, 'Adenosylmethionine-8-amino-7-oxononanoate aminotransferase', 278, NULL, NULL, 70446),
(70447, '1.25.10.10-FF-002399', NULL, 'Uncharacterized protein', 258, NULL, NULL, 70447),
(70448, '3.40.50.720-FF-001808', NULL, 'Uncharacterized protein', 34, NULL, NULL, 70448);
INSERT INTO "PUBLIC"."MODEL" VALUES
(70449, '3.80.10.10-FF-003408', NULL, 'Uncharacterized protein', 88, NULL, NULL, 70449),
(70450, '3.40.50.150-FF-001267', NULL, NULL, 221, NULL, NULL, 70450),
(70451, '3.80.10.10-FF-003296', NULL, 'Uncharacterized protein', 221, NULL, NULL, 70451),
(70452, '3.40.50.10090-FF-000037', NULL, 'Uroporphyrinogen-III synthase HemD', 108, NULL, NULL, 70452),
(70453, '3.80.10.10-FF-000946', NULL, 'AGAP011229-PA', 174, NULL, NULL, 70453),
(70454, '3.40.50.620-FF-000795', NULL, 'Uncharacterized protein', 39, NULL, NULL, 70454),
(70455, '3.30.70.1070-FF-000004', NULL, 'Cell division protein DamX', 101, NULL, NULL, 70455),
(70456, '1.20.1050.10-FF-000280', NULL, 'Glutathione stransferase, putative', 44, NULL, NULL, 70456),
(70457, '3.70.10.10-FF-000059', NULL, 'Cell cycle checkpoint protein RAD1 homolog mrt-2', 256, NULL, NULL, 70457),
(70458, '3.40.50.720-FF-000527', NULL, '4-hydroxy-tetrahydrodipicolinate reductase 1, chloroplastic', 159, NULL, NULL, 70458),
(70459, '3.40.50.10330-FF-000098', NULL, 'Uncharacterized protein', 181, NULL, NULL, 70459),
(70460, '1.20.1070.10-FF-002136', NULL, 'Uncharacterized protein', 253, NULL, NULL, 70460),
(70461, '3.30.70.330-FF-001698', NULL, 'Polynucleotide adenylyltransferase domain/RNA recognition motif protein', 154, NULL, NULL, 70461),
(70462, '3.30.70.20-FF-000073', NULL, 'H(2):CoB-CoM heterodisulfide,ferredoxin reductase subunit A', 71, NULL, NULL, 70462),
(70463, '3.30.710.10-FF-000367', NULL, 'Uncharacterized protein', 66, NULL, NULL, 70463),
(70464, '3.30.830.10-FF-000286', NULL, 'Uncharacterized protein', 165, NULL, NULL, 70464),
(70465, '3.40.50.300-FF-006977', NULL, 'Uncharacterized protein', 218, NULL, NULL, 70465),
(70466, '2.10.25.10-FF-000284', NULL, 'von Willebrand factor', 55, NULL, NULL, 70466),
(70467, '3.40.50.300-FF-006269', NULL, 'Predicted protein', 117, NULL, NULL, 70467),
(70468, '1.20.120.1150-FF-000005', NULL, 'Serine/threonine-protein phosphatase 2A activator', 108, NULL, NULL, 70468),
(70469, '3.10.129.10-FF-000138', NULL, 'Putative thioesterase', 136, NULL, NULL, 70469),
(70470, '3.40.850.10-FF-000324', NULL, 'Uncharacterized protein', 374, NULL, NULL, 70470),
(70471, '3.30.420.40-FF-000691', NULL, 'Uncharacterized protein', 249, NULL, NULL, 70471),
(70472, '3.40.50.300-FF-006680', NULL, 'Uncharacterized protein', 82, NULL, NULL, 70472),
(70473, '1.10.510.10-FF-002752', NULL, 'Mitogen-activated protein kinase kinase kinase mlk-1', 336, NULL, NULL, 70473),
(70474, '1.10.150.670-FF-000025', NULL, 'Uncharacterized protein', 81, NULL, NULL, 70474),
(70475, '2.60.40.10-FF-003852', NULL, NULL, 98, NULL, NULL, 70475),
(70476, '3.30.1120.10-FF-000057', NULL, 'N-acetylgalactosamine 6-sulfatase (GALNS)', 65, NULL, NULL, 70476),
(70477, '3.30.200.20-FF-000758', NULL, 'cyclin-dependent kinase-like 5 isoform X3', 31, NULL, NULL, 70477),
(70478, '3.90.1300.10-FF-000001', NULL, 'Fatty-acid amide hydrolase 1', 549, NULL, NULL, 70478),
(70479, '2.130.10.10-FF-003268', NULL, 'Uncharacterized protein', 175, NULL, NULL, 70479),
(70480, '3.30.300.30-FF-000151', NULL, 'Predicted protein', 20, NULL, NULL, 70480),
(70481, '3.40.1810.10-FF-000079', NULL, NULL, 59, NULL, NULL, 70481),
(70482, '1.10.20.70-FF-000006', NULL, NULL, 42, NULL, NULL, 70482),
(70483, '3.30.160.60-FF-001856', NULL, 'Zinc finger protein 655', 35, NULL, NULL, 70483),
(70484, '1.20.58.390-FF-000046', NULL, 'AcetylCholine Receptor', 116, NULL, NULL, 70484),
(70485, '3.30.160.60-FF-004318', NULL, NULL, 27, NULL, NULL, 70485),
(70486, '2.60.40.10-FF-003705', NULL, NULL, 95, NULL, NULL, 70486),
(70487, '3.90.80.10-FF-000023', NULL, 'Inorganic pyrophosphatase (Eurofung)', 288, NULL, NULL, 70487),
(70488, '3.40.50.1700-FF-000022', NULL, 'Thermostable beta-glucosidase B, putative', 274, NULL, NULL, 70488),
(70489, '4.10.1060.10-FF-000056', NULL, 'Putative nf-kappa b regulator ap20/cezanne', 34, NULL, NULL, 70489),
(70490, '2.60.120.10-FF-000723', NULL, 'Protein CBG15463', 198, NULL, NULL, 70490),
(70491, '2.40.50.140-FF-000520', NULL, 'DNA helicase', 87, NULL, NULL, 70491),
(70492, '3.40.50.1000-FF-000110', NULL, 'Phospholipid-transporting ATPase', 208, NULL, NULL, 70492);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(70493, '3.40.50.300-FF-008214', NULL, 'MutS homolog 6 (E. coli)', 68, NULL, NULL, 70493),
(70494, '2.60.40.1830-FF-000001', NULL, 'BPP', 114, NULL, NULL, 70494),
(70495, '2.60.40.180-FF-000019', NULL, 'Uncharacterized protein', 47, NULL, NULL, 70495),
(70496, '3.30.565.10-FF-000298', NULL, 'DNA mismatch repair protein pms2, putative', 205, NULL, NULL, 70496),
(70497, '3.90.1150.170-FF-000002', NULL, 'pyridoxal-dependent decarboxylase domain-containing protein 1 isoform X2', 114, NULL, NULL, 70497),
(70498, '3.90.190.10-FF-000071', NULL, 'Dual specificity protein phosphatase 19', 145, NULL, NULL, 70498),
(70499, '3.30.750.24-FF-000175', NULL, 'Sulfate transporter 1.2', 76, NULL, NULL, 70499),
(70500, '1.10.287.70-FF-000417', NULL, 'Uncharacterized protein', 126, NULL, NULL, 70500),
(70501, '3.30.470.20-FF-000013', NULL, 'Carbamoyl-phosphate synthase large chain', 271, NULL, NULL, 70501),
(70502, '1.20.1250.20-FF-000146', NULL, 'Amino acid/peptide transporter', 237, NULL, NULL, 70502),
(70503, '2.60.40.10-FF-004369', NULL, NULL, 106, NULL, NULL, 70503),
(70504, '2.40.50.140-FF-000784', NULL, NULL, 74, NULL, NULL, 70504),
(70505, '1.10.390.10-FF-000005', NULL, 'transcription initiation factor TFIID subunit 2 isoform X1', 267, NULL, NULL, 70505),
(70506, '3.20.20.80-FF-000381', NULL, 'Glucosylceramidase, putative', 138, NULL, NULL, 70506),
(70507, '3.40.50.880-FF-000114', NULL, 'ThiJ/PfpI family protein', 233, NULL, NULL, 70507),
(70508, '2.40.30.10-FF-000171', NULL, 'Mrpl9p', 103, NULL, NULL, 70508),
(70509, '3.30.830.10-FF-000139', NULL, 'Processing protease', 191, NULL, NULL, 70509),
(70510, '1.10.287.380-FF-000022', NULL, 'Hypothetical ABC transporter ATP-binding protein ybiT', 76, NULL, NULL, 70510),
(70511, '2.40.420.20-FF-000023', NULL, 'Multidrug resistance protein', 93, NULL, NULL, 70511),
(70512, '2.60.200.20-FF-000261', NULL, 'Uncharacterized protein', 74, NULL, NULL, 70512),
(70513, '3.30.70.330-FF-003120', NULL, NULL, 22, NULL, NULL, 70513),
(70514, '2.40.160.10-FF-000067', NULL, 'Uncharacterized protein', 140, NULL, NULL, 70514),
(70515, '2.60.40.10-FF-005914', NULL, NULL, 114, NULL, NULL, 70515),
(70516, '2.30.29.30-FF-000718', NULL, 'Si:ch73-111k22.3', 103, NULL, NULL, 70516),
(70517, '1.20.1250.20-FF-002355', NULL, 'Predicted protein', 118, NULL, NULL, 70517),
(70518, '1.10.1670.10-FF-000054', NULL, NULL, 58, NULL, NULL, 70518),
(70519, '3.10.129.10-FF-000290', NULL, 'Uncharacterized protein', 63, NULL, NULL, 70519),
(70520, '1.20.1730.10-FF-000074', NULL, 'High-affinity choline transporter, putative', 62, NULL, NULL, 70520),
(70521, '3.30.160.60-FF-003801', NULL, NULL, 37, NULL, NULL, 70521),
(70522, '3.40.1380.20-FF-000037', NULL, 'Pyruvate kinase', 89, NULL, NULL, 70522),
(70523, '3.40.50.450-FF-000103', NULL, 'Phosphofructokinase', 123, NULL, NULL, 70523),
(70524, '3.40.50.300-FF-006005', NULL, 'Disease resistance protein RGA4', 167, NULL, NULL, 70524),
(70525, '3.40.50.1820-FF-000176', NULL, 'Cutinase Cut4', 219, NULL, NULL, 70525),
(70526, '2.170.150.20-FF-000022', NULL, 'Peptide methionine sulfoxide reductase MsrA', 117, NULL, NULL, 70526),
(70527, '3.40.30.10-FF-001085', NULL, 'Putative SCO1/SenC family protein/methylamine utilization protein MauG', 175, NULL, NULL, 70527),
(70528, '1.25.40.10-FF-000990', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 121, NULL, NULL, 70528),
(70529, '3.40.50.2000-FF-000101', NULL, 'Glycosyltransferase', 254, NULL, NULL, 70529),
(70530, '1.10.10.60-FF-001048', NULL, NULL, 63, NULL, NULL, 70530),
(70531, '2.60.120.260-FF-000553', NULL, 'Uncharacterized protein', 52, NULL, NULL, 70531),
(70532, '1.10.510.10-FF-002191', NULL, 'Uncharacterized protein', 253, NULL, NULL, 70532),
(70533, '2.40.50.40-FF-000130', NULL, 'Chromodomain Y like 2', 56, NULL, NULL, 70533),
(70534, '3.90.1150.10-FF-000348', NULL, 'Pleiotropic regulatory protein', 135, NULL, NULL, 70534),
(70535, '3.30.420.40-FF-000016', NULL, 'Rod shape-determining protein mreB', 83, NULL, NULL, 70535),
(70536, '3.80.20.20-FF-000045', NULL, 'Receptor protein-tyrosine kinase', 197, NULL, NULL, 70536);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(70537, '1.20.1070.10-FF-000899', NULL, 'Olfactory receptor 1260', 83, NULL, NULL, 70537),
(70538, '3.90.960.10-FF-000012', NULL, 'Probable proline-tRNA ligase', 177, NULL, NULL, 70538),
(70539, '2.130.10.10-FF-001059', NULL, 'WD repeat and HMG-box DNA binding protein 1', 117, NULL, NULL, 70539),
(70540, '3.40.50.1910-FF-000023', NULL, 'GM10243', 103, NULL, NULL, 70540),
(70541, '1.20.1270.10-FF-000111', NULL, 'Uncharacterized protein', 57, NULL, NULL, 70541),
(70542, '3.40.30.10-FF-000073', NULL, 'Sulfhydryl oxidase', 133, NULL, NULL, 70542),
(70543, '2.130.10.30-FF-000025', NULL, 'HECT and RLD domain containing E3 ubiquitin protein ligase 5', 336, NULL, NULL, 70543),
(70544, '3.60.20.40-FF-000041', NULL, 'Uncharacterized protein', 137, NULL, NULL, 70544),
(70545, '3.40.50.1820-FF-001396', NULL, 'Initiation factor 4F subunit (DUF1350)', 213, NULL, NULL, 70545),
(70546, '1.20.870.10-FF-000039', NULL, 'YALI0F32043p', 177, NULL, NULL, 70546),
(70547, '3.40.50.300-FF-005691', NULL, 'Chromosomal replication initiator protein DnaA', 180, NULL, NULL, 70547),
(70548, '1.10.3080.10-FF-000054', NULL, 'Chloride channel protein', 272, NULL, NULL, 70548),
(70549, '3.80.10.10-FF-001082', NULL, 'Receptor-like protein Cf-9', 214, NULL, NULL, 70549),
(70550, '3.40.1160.10-FF-000080', NULL, 'Molybdenum storage protein subunit alpha', 245, NULL, NULL, 70550),
(70551, '1.20.1250.10-FF-000048', NULL, 'Kit ligand b', 135, NULL, NULL, 70551),
(70552, '3.40.50.2300-FF-000365', NULL, 'Guanylate cyclase', 193, NULL, NULL, 70552),
(70553, '1.20.1280.50-FF-000101', NULL, 'Uncharacterized protein', 51, NULL, NULL, 70553),
(70554, '1.10.510.10-FF-003236', NULL, NULL, 121, NULL, NULL, 70554),
(70555, '2.40.240.10-FF-000040', NULL, 'Ribosomal protein L25/Gln-tRNA synthetase, anti-codon-binding domain-containing protein', 41, NULL, NULL, 70555),
(70556, '3.30.230.120-FF-000019', NULL, NULL, 364, NULL, NULL, 70556),
(70557, '3.40.50.1820-FF-000884', NULL, 'Uncharacterized protein', 335, NULL, NULL, 70557),
(70558, '2.60.40.10-FF-002132', NULL, 'Muscle M-line assembly protein unc-89', 102, NULL, NULL, 70558),
(70559, '1.20.1270.10-FF-000055', NULL, 'Heat shock 70 kDa protein', 113, NULL, NULL, 70559),
(70560, '3.40.50.1820-FF-000412', NULL, 'Protein phosphatase methylesterase 1', 337, NULL, NULL, 70560),
(70561, '3.80.10.10-FF-000570', NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM1', 244, NULL, NULL, 70561),
(70562, '3.30.70.1230-FF-000103', NULL, 'Adenylate cyclase', 201, NULL, NULL, 70562),
(70563, '1.10.287.110-FF-000374', NULL, 'Uncharacterized protein', 100, NULL, NULL, 70563),
(70564, '3.20.20.140-FF-000363', NULL, 'Amidohydrolase family protein, putative', 262, NULL, NULL, 70564),
(70565, '1.10.287.110-FF-000430', NULL, 'Uncharacterized protein', 86, NULL, NULL, 70565),
(70566, '3.40.50.1820-FF-000940', NULL, 'Uncharacterized protein', 313, NULL, NULL, 70566),
(70567, '1.20.5.3730-FF-000001', NULL, 'Zona pellucida sperm-binding protein 3 receptor', 60, NULL, NULL, 70567),
(70568, '3.40.367.20-FF-000052', NULL, 'Uncharacterized protein', 62, NULL, NULL, 70568),
(70569, '1.20.58.390-FF-000310', NULL, 'Uncharacterized protein', 142, NULL, NULL, 70569),
(70570, '3.90.1520.10-FF-000012', NULL, 'Chromosome undetermined SCAF14725, whole genome shotgun sequence', 136, NULL, NULL, 70570),
(70571, '1.25.40.20-FF-001920', NULL, 'Ankyrin-repeat protein, putative', 130, NULL, NULL, 70571),
(70572, '3.40.50.1820-FF-001873', NULL, 'Predicted protein', 94, NULL, NULL, 70572),
(70573, '1.10.510.10-FF-003764', NULL, NULL, 139, NULL, NULL, 70573),
(70574, '3.40.190.10-FF-000857', NULL, 'Uncharacterized protein', 58, NULL, NULL, 70574),
(70575, '1.25.10.10-FF-000893', NULL, 'RING-type E3 ubiquitin transferase', 228, NULL, NULL, 70575),
(70576, '3.40.50.720-FF-002213', NULL, 'Uncharacterized protein', 294, NULL, NULL, 70576),
(70577, '1.20.1070.10-FF-001944', NULL, 'Uncharacterized protein', 228, NULL, NULL, 70577),
(70578, '2.60.120.200-FF-000411', NULL, 'FAT atypical cadherin 1b', 173, NULL, NULL, 70578);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(70579, '3.30.110.110-FF-000012', NULL, 'Uncharacterized protein', 108, NULL, NULL, 70579),
(70580, '3.40.50.10330-FF-000070', NULL, 'Diacylglycerol kinase', 68, NULL, NULL, 70580),
(70581, '3.80.10.10-FF-004313', NULL, 'Si:ch211-213a13.2', 210, NULL, NULL, 70581),
(70582, '1.25.40.10-FF-002047', NULL, 'Pentatricopeptide repeat-containing protein At4g21300', 103, NULL, NULL, 70582),
(70583, '2.60.220.50-FF-000012', NULL, 'Adhesion G protein-coupled receptor A2', 162, NULL, NULL, 70583),
(70584, '3.30.70.260-FF-000081', NULL, 'D-3-phosphoglycerate dehydrogenase', 75, NULL, NULL, 70584),
(70585, '1.10.150.390-FF-000008', NULL, 'DNA-directed RNA polymerase subunit', 61, NULL, NULL, 70585),
(70586, '3.50.50.60-FF-000369', NULL, 'FAD-dependent oxidoreductase', 204, NULL, NULL, 70586),
(70587, '1.20.1070.10-FF-000427', NULL, 'Leucine-rich repeat containing G protein-coupled receptor 4', 319, NULL, NULL, 70587),
(70588, '3.10.20.90-FF-000176', NULL, 'Rho guanyl nucleotide exchange factor', 86, NULL, NULL, 70588),
(70589, '1.20.1070.10-FF-000955', NULL, 'GoNadotropin-Releasing hormone Receptor (GnRHR) related', 365, NULL, NULL, 70589),
(70590, '3.30.70.1710-FF-000005', NULL, 'Ethanolamine utilization microcompartment protein EutK', 103, NULL, NULL, 70590),
(70591, '3.10.400.10-FF-000011', NULL, NULL, 48, NULL, NULL, 70591),
(70592, '3.40.50.880-FF-000086', NULL, 'Carbamoyl-phosphate synthase small chain', 183, NULL, NULL, 70592),
(70593, '1.10.10.10-FF-001730', NULL, 'Response regulator receiver', 105, NULL, NULL, 70593),
(70594, '3.40.50.790-FF-000003', NULL, '39S ribosomal protein L1, mitochondrial', 92, NULL, NULL, 70594),
(70595, '3.30.160.60-FF-002104', NULL, 'Si:ch211-266d19.4', 29, NULL, NULL, 70595),
(70596, '3.50.50.60-FF-000425', NULL, 'Protoporphyrinogen oxidase', 137, NULL, NULL, 70596),
(70597, '2.120.10.30-FF-000166', NULL, 'Exported gluconolactonase', 310, NULL, NULL, 70597),
(70598, '3.80.10.10-FF-002335', NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g56140', 135, NULL, NULL, 70598),
(70599, '3.30.420.40-FF-000516', NULL, 'Glycerol kinase', 233, NULL, NULL, 70599),
(70600, '3.30.450.30-FF-000015', NULL, 'Profilin', 127, NULL, NULL, 70600),
(70601, '1.10.8.100-FF-000024', NULL, 'rRNA adenine N(6)-methyltransferase', 71, NULL, NULL, 70601),
(70602, '3.40.250.10-FF-000003', NULL, 'tRNA sulfurtransferase', 86, NULL, NULL, 70602),
(70603, '2.40.128.180-FF-000004', NULL, 'Fas apoptotic inhibitory molecule', 82, NULL, NULL, 70603),
(70604, '2.40.70.10-FF-000145', NULL, 'Aspartic protease', 216, NULL, NULL, 70604),
(70605, '3.40.50.410-FF-000086', NULL, 'Circumsporozoite-and TRAP-related protein', 165, NULL, NULL, 70605),
(70606, '1.10.20.10-FF-000067', NULL, 'Transcription initiation factor TFIID subunit 13', 44, NULL, NULL, 70606),
(70607, '3.60.21.10-FF-000017', NULL, 'Serine/threonine-protein phosphatase', 319, NULL, NULL, 70607),
(70608, '3.30.40.10-FF-001288', NULL, 'Putative RING zinc finger domain superfamily protein', 57, NULL, NULL, 70608),
(70609, '3.30.420.40-FF-000988', NULL, 'Uncharacterized protein', 92, NULL, NULL, 70609),
(70610, '3.30.40.10-FF-001344', NULL, 'E3 ubiquitin-protein ligase LubX', 70, NULL, NULL, 70610),
(70611, '1.20.120.350-FF-000112', NULL, 'Voltage-gated Ca2+ channel, alpha subunit', 121, NULL, NULL, 70611),
(70612, '2.60.40.10-FF-004897', NULL, NULL, 121, NULL, NULL, 70612),
(70613, '3.30.200.20-FF-002383', NULL, 'Uncharacterized protein', 143, NULL, NULL, 70613),
(70614, '2.130.10.10-FF-001800', NULL, 'Similar to WD repeat-containing protein', 189, NULL, NULL, 70614),
(70615, '1.20.58.1480-FF-000006', NULL, 'Lon protease homolog, mitochondrial', 126, NULL, NULL, 70615),
(70616, '1.20.58.390-FF-000254', NULL, 'Uncharacterized protein', 108, NULL, NULL, 70616),
(70617, '3.30.420.40-FF-000196', NULL, 'Cell division protein FtsA', 160, NULL, NULL, 70617),
(70618, '2.60.40.10-FF-003913', NULL, NULL, 110, NULL, NULL, 70618),
(70619, '2.40.70.10-FF-000201', NULL, 'Uncharacterized protein', 184, NULL, NULL, 70619),
(70620, '3.40.50.2000-FF-000337', NULL, 'Lipopolysaccharide biosynthesis protein', 152, NULL, NULL, 70620);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(70621, '3.40.50.1460-FF-000080', NULL, 'GPI-anchor transamidase', 249, NULL, NULL, 70621),
(70622, '3.30.519.10-FF-000023', NULL, NULL, 187, NULL, NULL, 70622),
(70623, '1.25.40.10-FF-003952', NULL, 'Uncharacterized protein', 259, NULL, NULL, 70623),
(70624, '2.130.10.10-FF-004673', NULL, 'TNF receptor-associated factor 7', 184, NULL, NULL, 70624),
(70625, '1.10.10.10-FF-001235', NULL, 'Two-component response regulator', 62, NULL, NULL, 70625),
(70626, '1.10.225.10-FF-000015', NULL, 'Sphingomyelin phosphodiesterase', 75, NULL, NULL, 70626),
(70627, '3.90.1170.20-FF-000004', NULL, 'Nicotinate-nucleotide pyrophosphorylase [carboxylating]', 117, NULL, NULL, 70627),
(70628, '2.60.120.430-FF-000042', NULL, 'Cellulase', 147, NULL, NULL, 70628),
(70629, '3.40.50.300-FF-006505', NULL, 'Predicted protein', 113, NULL, NULL, 70629),
(70630, '3.20.70.20-FF-000006', NULL, 'Anaerobic ribonucleoside-triphosphate reductase NrdD', 567, NULL, NULL, 70630),
(70631, '1.20.1070.10-FF-001888', NULL, 'Uncharacterized protein', 290, NULL, NULL, 70631),
(70632, '3.30.365.10-FF-000081', NULL, 'Predicted protein', 39, NULL, NULL, 70632),
(70633, '2.60.200.20-FF-000053', NULL, 'Os06g0275900 protein', 131, NULL, NULL, 70633),
(70634, '3.30.160.60-FF-000159', NULL, 'Mds1 and evi1 complex locus protein', 37, NULL, NULL, 70634),
(70635, '3.30.160.60-FF-006319', NULL, NULL, 34, NULL, NULL, 70635),
(70636, '1.10.246.10-FF-000013', NULL, 'Serum albumin', 34, NULL, NULL, 70636),
(70637, '3.90.550.10-FF-000138', NULL, 'Cellulose synthase isolog', 99, NULL, NULL, 70637),
(70638, '3.30.530.20-FF-000159', NULL, 'Uncharacterized protein', 144, NULL, NULL, 70638),
(70639, '2.40.50.140-FF-000284', NULL, 'Single-stranded DNA-binding protein', 115, NULL, NULL, 70639),
(70640, '1.10.287.70-FF-000480', NULL, 'Uncharacterized protein', 143, NULL, NULL, 70640),
(70641, '3.90.190.10-FF-000155', NULL, 'Dual specificity protein phosphatase PPS1', 110, NULL, NULL, 70641),
(70642, '3.30.70.330-FF-003143', NULL, NULL, 75, NULL, NULL, 70642),
(70643, '3.40.50.2020-FF-000023', NULL, 'Probable uracil phosphoribosyltransferase', 218, NULL, NULL, 70643),
(70644, '1.20.120.1080-FF-000080', NULL, 'Putative DEAH-box RNA helicase', 101, NULL, NULL, 70644),
(70645, '2.130.10.10-FF-002784', NULL, 'Uncharacterized protein', 214, NULL, NULL, 70645),
(70646, '2.60.40.200-FF-000037', NULL, 'Uncharacterized protein', 200, NULL, NULL, 70646),
(70647, '1.25.40.280-FF-000004', NULL, 'BRO1 domain-containing protein BROX', 374, NULL, NULL, 70647),
(70648, '1.10.418.10-FF-000031', NULL, 'Fimbrin-2 like', 127, NULL, NULL, 70648),
(70649, '2.30.130.40-FF-000043', NULL, 'Lon protease homolog', 144, NULL, NULL, 70649),
(70650, '2.60.40.10-FF-003436', NULL, NULL, 104, NULL, NULL, 70650),
(70651, '3.10.20.90-FF-000968', NULL, 'Uncharacterized protein', 112, NULL, NULL, 70651),
(70652, '1.10.8.270-FF-000029', NULL, 'TBC1 domain family member 21', 106, NULL, NULL, 70652),
(70653, '2.60.40.150-FF-000331', NULL, 'Uncharacterized protein, isoform A', 141, NULL, NULL, 70653),
(70654, '2.60.34.20-FF-000007', NULL, NULL, 140, NULL, NULL, 70654),
(70655, '3.40.50.150-FF-001795', NULL, NULL, 153, NULL, NULL, 70655),
(70656, '3.30.470.20-FF-000244', NULL, 'Glutathione synthetase-like Protein', 54, NULL, NULL, 70656),
(70657, '1.50.40.10-FF-000038', NULL, 'S-adenosylmethionine carrier 1 chloroplastic/mitochondrial', 268, NULL, NULL, 70657),
(70658, '3.20.20.70-FF-000405', NULL, NULL, 69, NULL, NULL, 70658),
(70659, '3.20.20.80-FF-000178', NULL, '1,3-beta-glucanosyltransferase', 328, NULL, NULL, 70659),
(70660, '3.80.10.10-FF-000418', NULL, 'protein toll', 217, NULL, NULL, 70660),
(70661, '3.40.50.1820-FF-000092', NULL, 'Carboxylic ester hydrolase', 560, NULL, NULL, 70661),
(70662, '3.30.160.60-FF-004021', NULL, 'Uncharacterized protein, isoform A', 63, NULL, NULL, 70662),
(70663, '3.30.1490.20-FF-000109', NULL, 'Uncharacterized protein', 49, NULL, NULL, 70663),
(70664, '2.60.40.10-FF-002924', NULL, 'Sensory AXon guidance', 92, NULL, NULL, 70664),
(70665, '3.40.50.300-FF-002762', NULL, 'GTP-binding protein YqeH', 169, NULL, NULL, 70665);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(70666, '3.30.2310.20-FF-000007', NULL, 'Toxin', 98, NULL, NULL, 70666),
(70667, '3.30.230.10-FF-000021', NULL, 'Ribonuclease P protein component', 115, NULL, NULL, 70667),
(70668, '3.30.450.60-FF-000030', NULL, 'APM2p protein', 141, NULL, NULL, 70668),
(70669, '1.10.1040.10-FF-000085', NULL, 'Putative 2-dehydropantoate 2-reductase', 132, NULL, NULL, 70669),
(70670, '2.170.120.12-FF-000031', NULL, 'DNA-directed RNA polymerase subunit alpha', 134, NULL, NULL, 70670),
(70671, '1.20.1250.20-FF-001310', NULL, 'Uncharacterized protein', 340, NULL, NULL, 70671),
(70672, '1.10.3720.10-FF-000019', NULL, 'Antimicrobial peptide ABC transporter permease SapC', 208, NULL, NULL, 70672),
(70673, '3.30.70.660-FF-000049', NULL, 'tRNA pseudouridine synthase', 118, NULL, NULL, 70673),
(70674, '1.25.40.990-FF-000065', NULL, 'Uncharacterized protein', 118, NULL, NULL, 70674),
(70675, '2.60.40.1090-FF-000032', NULL, 'Fimbrial protein StdA', 158, NULL, NULL, 70675),
(70676, '1.10.287.1490-FF-000007', NULL, 'Golgin B1', 166, NULL, NULL, 70676),
(70677, '3.30.450.60-FF-000086', NULL, 'Uncharacterized protein', 154, NULL, NULL, 70677),
(70678, '2.160.20.10-FF-000209', NULL, 'Polygalacturonase QRT2', 353, NULL, NULL, 70678),
(70679, '2.30.30.30-FF-000082', NULL, '50S ribosomal protein L24', 98, NULL, NULL, 70679),
(70680, '3.40.50.720-FF-001696', NULL, 'GDP-mannose dehydrogenase', 231, NULL, NULL, 70680),
(70681, '6.10.140.2220-FF-000024', NULL, 'Uncharacterized protein, isoform A', 50, NULL, NULL, 70681),
(70682, '3.40.30.10-FF-000865', NULL, 'Uncharacterized protein', 115, NULL, NULL, 70682),
(70683, '3.30.1380.20-FF-000051', NULL, 'Predicted protein', 100, NULL, NULL, 70683),
(70684, '1.20.1250.20-FF-000910', NULL, 'Sugar transport protein 1', 476, NULL, NULL, 70684),
(70685, '3.20.20.100-FF-000143', NULL, 'Uncharacterized protein', 349, NULL, NULL, 70685),
(70686, '3.30.60.20-FF-000128', NULL, 'Diacylglycerol kinase', 63, NULL, NULL, 70686),
(70687, '3.30.160.60-FF-003565', NULL, NULL, 28, NULL, NULL, 70687),
(70688, '1.25.40.180-FF-000272', NULL, NULL, 190, NULL, NULL, 70688),
(70689, '1.20.120.680-FF-000003', NULL, NULL, 201, NULL, NULL, 70689),
(70690, '2.20.28.200-FF-000013', NULL, 'Class IV sirtuin', 31, NULL, NULL, 70690),
(70691, '3.20.140.10-FF-000044', NULL, 'Uncharacterized protein', 91, NULL, NULL, 70691),
(70692, '1.20.58.530-FF-000015', NULL, 'Unconventional myosin-IXa', 54, NULL, NULL, 70692),
(70693, '2.40.10.10-FF-000169', NULL, 'Genome polyprotein', 100, NULL, NULL, 70693),
(70694, '1.10.238.10-FF-000882', NULL, 'EFHC2', 69, NULL, NULL, 70694),
(70695, '3.40.630.10-FF-000105', NULL, 'Nicalin', 267, NULL, NULL, 70695),
(70696, '1.25.40.10-FF-004880', NULL, 'Uncharacterized protein', 103, NULL, NULL, 70696),
(70697, '2.10.220.10-FF-000192', NULL, 'Uncharacterized protein', 63, NULL, NULL, 70697),
(70698, '3.40.50.300-FF-003751', NULL, 'Dynamin-related GTPase', 312, NULL, NULL, 70698),
(70699, '2.30.42.10-FF-000204', NULL, 'Fife, isoform B', 104, NULL, NULL, 70699),
(70700, '3.30.160.60-FF-003037', NULL, 'Uncharacterized protein, isoform B', 25, NULL, NULL, 70700),
(70701, '3.60.21.10-FF-000192', NULL, 'Protein phosphatase 3 catalytic subunit gamma', 127, NULL, NULL, 70701),
(70702, '3.30.1520.10-FF-000189', NULL, 'Uncharacterized protein', 73, NULL, NULL, 70702),
(70703, '3.40.50.300-FF-007489', NULL, 'Uncharacterized protein ABCG33', 228, NULL, NULL, 70703),
(70704, '3.30.70.250-FF-000016', NULL, NULL, 69, NULL, NULL, 70704),
(70705, '3.80.10.10-FF-001879', NULL, 'Leucine Rich Repeat family protein', 135, NULL, NULL, 70705),
(70706, '3.30.40.10-FF-000708', NULL, 'E3 ubiquitin-protein ligase', 58, NULL, NULL, 70706),
(70707, '3.40.1500.10-FF-000005', NULL, 'Oxygen-dependent coproporphyrinogen-III oxidase', 296, NULL, NULL, 70707),
(70708, '2.130.10.10-FF-002312', NULL, 'Uncharacterized protein', 329, NULL, NULL, 70708),
(70709, '3.40.850.10-FF-000088', NULL, 'Myosin C', 54, NULL, NULL, 70709),
(70710, '1.25.40.10-FF-001535', NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', 156, NULL, NULL, 70710);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(70711, '1.10.287.2620-FF-000026', NULL, 'Uncharacterized protein', 65, NULL, NULL, 70711),
(70712, '3.40.190.10-FF-000060', NULL, 'Glutamate receptor ionotropic, kainate 1', 105, NULL, NULL, 70712),
(70713, '3.40.50.2300-FF-001618', NULL, NULL, 298, NULL, NULL, 70713),
(70714, '2.60.40.10-FF-005061', NULL, NULL, 101, NULL, NULL, 70714),
(70715, '3.60.15.10-FF-000132', NULL, 'MBL fold metallo-hydrolase', 282, NULL, NULL, 70715),
(70716, '1.10.510.10-FF-001347', NULL, 'Actin-regulating kinase, putative', 303, NULL, NULL, 70716),
(70717, '1.10.287.600-FF-000009', NULL, 'Tubulin alpha chain', 53, NULL, NULL, 70717),
(70718, '1.20.1110.10-FF-000190', NULL, NULL, 147, NULL, NULL, 70718),
(70719, '3.30.200.20-FF-001511', NULL, 'Uncharacterized protein', 74, NULL, NULL, 70719),
(70720, '3.30.450.20-FF-000658', NULL, 'Histidine kinase response regulator hybrid protein', 113, NULL, NULL, 70720),
(70721, '1.20.1250.20-FF-000410', NULL, 'POT family protein', 516, NULL, NULL, 70721),
(70722, '2.60.40.420-FF-000283', NULL, 'Uncharacterized protein', 127, NULL, NULL, 70722),
(70723, '2.40.50.140-FF-001240', NULL, NULL, 134, NULL, NULL, 70723),
(70724, '3.30.40.10-FF-002272', NULL, 'Uncharacterized protein', 53, NULL, NULL, 70724),
(70725, '3.40.850.10-FF-000408', NULL, 'Kinesin-like protein', 258, NULL, NULL, 70725),
(70726, '3.80.10.10-FF-002863', NULL, 'N-CAM Ig domain-containing protein, putative', 156, NULL, NULL, 70726),
(70727, '1.20.1070.10-FF-001416', NULL, 'Uncharacterized protein', 231, NULL, NULL, 70727),
(70728, '3.30.160.60-FF-002576', NULL, 'zinc finger protein 473 isoform X2', 29, NULL, NULL, 70728),
(70729, '3.40.50.970-FF-000085', NULL, 'Sulfite reductase [NADPH] subunit beta', 295, NULL, NULL, 70729),
(70730, '2.130.10.10-FF-000367', NULL, 'U3 small nucleolar RNA-associated protein 4 homolog', 240, NULL, NULL, 70730),
(70731, '3.30.70.330-FF-000742', NULL, 'Telomere maintenance protein, putative', 91, NULL, NULL, 70731),
(70732, '2.130.10.10-FF-005185', NULL, 'Uncharacterized protein', 120, NULL, NULL, 70732),
(70733, '3.30.70.330-FF-002215', NULL, NULL, 100, NULL, NULL, 70733),
(70734, '1.20.5.170-FF-000239', NULL, 'nuclear pore glycoprotein p62-like', 63, NULL, NULL, 70734),
(70735, '2.60.40.60-FF-000264', NULL, 'Cadherin-related family member 2', 99, NULL, NULL, 70735),
(70736, '3.90.1640.10-FF-000015', NULL, 'Putative acidocalcisomal exopolyphosphatase', 230, NULL, NULL, 70736),
(70737, '1.25.40.10-FF-004941', NULL, 'Intraflagellar transport protein', 192, NULL, NULL, 70737),
(70738, '1.10.10.60-FF-000356', NULL, 'MYB transcription factor', 72, NULL, NULL, 70738),
(70739, '3.30.710.10-FF-000423', NULL, 'Protein CBG11420', 111, NULL, NULL, 70739),
(70740, '3.30.40.10-FF-000832', NULL, 'E3 ubiquitin-protein ligase RFWD3', 74, NULL, NULL, 70740),
(70741, '1.50.40.10-FF-000510', NULL, 'Uncharacterized protein', 202, NULL, NULL, 70741),
(70742, '3.20.20.220-FF-000033', NULL, 'Proline dehydrogenase', 67, NULL, NULL, 70742),
(70743, '3.40.50.1820-FF-001401', NULL, 'Esterase', 211, NULL, NULL, 70743),
(70744, '3.40.630.30-FF-000263', NULL, 'Acyl-homoserine-lactone synthase', 189, NULL, NULL, 70744),
(70745, '3.20.20.100-FF-000082', NULL, 'Oxidoreductase, aldo/keto reductase family', 327, NULL, NULL, 70745),
(70746, '1.10.150.20-FF-000237', NULL, 'Cytosolic Fe-S cluster assembly factor NUBP1 homolog', 89, NULL, NULL, 70746),
(70747, '2.60.120.650-FF-000136', NULL, 'AaceriAFL127Cp', 307, NULL, NULL, 70747),
(70748, '3.10.20.90-FF-000232', NULL, 'Serine/threonine-protein kinase WNK8', 95, NULL, NULL, 70748),
(70749, '3.40.50.850-FF-000015', NULL, 'Phenazine biosynthesis protein PhzD', 207, NULL, NULL, 70749),
(70750, '3.40.50.2300-FF-001293', NULL, NULL, 141, NULL, NULL, 70750),
(70751, '2.60.120.330-FF-000158', NULL, 'Predicted protein', 346, NULL, NULL, 70751),
(70752, '2.60.200.20-FF-000058', NULL, 'GM26347', 101, NULL, NULL, 70752),
(70753, '3.30.160.60-FF-005982', NULL, NULL, 60, NULL, NULL, 70753),
(70754, '3.40.47.10-FF-000252', NULL, 'Acetyl-CoA C-acyltransferase', 380, NULL, NULL, 70754);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(70755, '3.30.160.60-FF-005015', NULL, NULL, 30, NULL, NULL, 70755),
(70756, '3.90.70.10-FF-000697', NULL, 'Cathepsin B endopeptidase, putative', 223, NULL, NULL, 70756),
(70757, '3.30.1460.50-FF-000004', NULL, 'Autophagy-related protein 3', 160, NULL, NULL, 70757),
(70758, '3.20.20.80-FF-000206', NULL, 'Amylo-alpha-1, 6-glucosidase, 4-alpha-glucanotransferase b', 232, NULL, NULL, 70758),
(70759, '2.70.150.10-FF-000150', NULL, 'Phospholipid-transporting ATPase', 17, NULL, NULL, 70759),
(70760, '3.30.70.330-FF-002159', NULL, NULL, 90, NULL, NULL, 70760),
(70761, '1.20.970.10-FF-000042', NULL, 'Thymidine phosphorylase', 43, NULL, NULL, 70761),
(70762, '3.30.160.60-FF-005510', NULL, NULL, 73, NULL, NULL, 70762),
(70763, '3.40.50.10140-FF-000075', NULL, 'Uncharacterized protein', 70, NULL, NULL, 70763),
(70764, '1.10.10.200-FF-000001', NULL, 'Probable transcriptional regulatory protein YebC', 81, NULL, NULL, 70764),
(70765, '3.40.50.300-FF-004999', NULL, 'Novel protein similar to Rho GTP-binding proteins', 75, NULL, NULL, 70765),
(70766, '3.30.710.10-FF-000428', NULL, 'Uncharacterized protein', 102, NULL, NULL, 70766),
(70767, '3.90.105.20-FF-000023', NULL, 'Ribosomal protein L10 family protein', 12, NULL, NULL, 70767),
(70768, '1.25.40.10-FF-001119', NULL, 'Protein THYLAKOID ASSEMBLY 8-like, chloroplastic', 187, NULL, NULL, 70768),
(70769, '2.10.90.10-FF-000007', NULL, 'Luteinizing hormone beta subunit', 109, NULL, NULL, 70769),
(70770, '3.90.79.10-FF-000278', NULL, 'Uncharacterized protein', 68, NULL, NULL, 70770),
(70771, '2.60.40.10-FF-000507', NULL, 'Muscle M-line assembly protein unc-89', 95, NULL, NULL, 70771),
(70772, '3.40.50.2000-FF-000073', NULL, 'Starch synthase, chloroplastic/amyloplastic', 211, NULL, NULL, 70772),
(70773, '3.30.565.10-FF-000326', NULL, 'Putative histidine kinase', 151, NULL, NULL, 70773),
(70774, '3.30.70.330-FF-002687', NULL, NULL, 153, NULL, NULL, 70774),
(70775, '3.40.50.300-FF-004763', NULL, 'Uncharacterized protein', 194, NULL, NULL, 70775),
(70776, '3.40.47.10-FF-000049', NULL, '3-oxoacyl-Acyl-carrier-protein synthase III', 155, NULL, NULL, 70776),
(70777, '3.30.160.60-FF-005454', NULL, NULL, 36, NULL, NULL, 70777),
(70778, '3.10.300.10-FF-000008', NULL, 'Putative 3-methyladenine DNA glycosylase', 188, NULL, NULL, 70778),
(70779, '3.80.10.10-FF-000098', NULL, 'leucine-rich repeat-containing protein 17', 168, NULL, NULL, 70779),
(70780, '3.30.70.330-FF-000450', NULL, 'RNA binding motif, single stranded interacting protein 1a', 102, NULL, NULL, 70780),
(70781, '2.160.10.10-FF-000063', NULL, 'Antibiotic acetyltransferase', 104, NULL, NULL, 70781),
(70782, '1.25.40.20-FF-001072', NULL, 'Kinase, NEK', 92, NULL, NULL, 70782),
(70783, '3.40.50.2020-FF-000079', NULL, 'Ribose-phosphate pyrophosphokinase, putative', 147, NULL, NULL, 70783),
(70784, '3.40.50.720-FF-002528', NULL, 'Fatty acid synthase subunit alpha', 341, NULL, NULL, 70784),
(70785, '2.60.40.10-FF-004869', NULL, NULL, 112, NULL, NULL, 70785),
(70786, '2.30.30.140-FF-000092', NULL, 'DNA/RNA-binding protein KIN17', 54, NULL, NULL, 70786),
(70787, '3.80.10.10-FF-001407', NULL, 'uncharacterized protein LOC100179784', 172, NULL, NULL, 70787),
(70788, '1.10.510.10-FF-000835', NULL, 'Serine/threonine-protein kinase BLUS1', 236, NULL, NULL, 70788),
(70789, '1.10.10.10-FF-000802', NULL, 'Transcriptional regulator', 76, NULL, NULL, 70789),
(70790, '2.40.50.140-FF-000312', NULL, 'Exosome complex component CSL4', 167, NULL, NULL, 70790),
(70791, '3.30.160.60-FF-001648', NULL, 'zinc finger protein 527 isoform X2', 22, NULL, NULL, 70791),
(70792, '1.25.40.20-FF-001448', NULL, 'Uncharacterized protein', 136, NULL, NULL, 70792),
(70793, '3.30.50.10-FF-000097', NULL, 'Nuclear receptor subfamily 2 group E member 1', 78, NULL, NULL, 70793),
(70794, '1.20.1250.20-FF-000354', NULL, 'MFS general substrate transporter', 418, NULL, NULL, 70794),
(70795, '3.30.70.330-FF-000214', NULL, 'Serine/arginine-rich splicing factor 7', 68, NULL, NULL, 70795),
(70796, '3.80.10.10-FF-001935', NULL, 'Leucine-rich repeat protein kinase family protein', 142, NULL, NULL, 70796);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(70797, '3.40.50.1240-FF-000159', NULL, NULL, 191, NULL, NULL, 70797),
(70798, '1.20.1050.10-FF-000105', NULL, 'Maleylacetoacetate isomerase', 134, NULL, NULL, 70798),
(70799, '3.40.50.300-FF-008422', NULL, 'Uncharacterized protein', 118, NULL, NULL, 70799),
(70800, '3.10.20.70-FF-000018', NULL, 'Glutamine synthetase', 95, NULL, NULL, 70800),
(70801, '3.30.200.20-FF-001747', NULL, 'Serine/threonine-protein kinase Nek5', 20, NULL, NULL, 70801),
(70802, '3.30.310.10-FF-000022', NULL, 'Transcription initiation factor-like protein (TFIID-like protein)', 88, NULL, NULL, 70802),
(70803, '1.10.472.80-FF-000177', NULL, NULL, 75, NULL, NULL, 70803),
(70804, '3.30.590.10-FF-000042', NULL, 'Glutamate-ligase like protein', 316, NULL, NULL, 70804),
(70805, '1.20.1250.20-FF-001366', NULL, 'MFS transporter of unkown specificity (AFU_orthologue AFUA_5G09940)', 197, NULL, NULL, 70805),
(70806, '2.60.34.10-FF-000089', NULL, 'Galactosyltransferase, putative', 69, NULL, NULL, 70806),
(70807, '2.30.330.10-FF-000004', NULL, 'Flagellar motor switch protein FliM', 84, NULL, NULL, 70807),
(70808, '3.30.60.90-FF-000020', NULL, 'Transcriptional adapter', 53, NULL, NULL, 70808),
(70809, '3.40.30.10-FF-000921', NULL, 'Predicted protein', 126, NULL, NULL, 70809),
(70810, '2.30.30.790-FF-000022', NULL, 'Mitochondrial ribosomal protein L19', 118, NULL, NULL, 70810),
(70811, '1.25.40.20-FF-001420', NULL, 'Ankyrin repeat and SOCS box-containing 5a', 111, NULL, NULL, 70811),
(70812, '2.40.128.80-FF-000007', NULL, 'Dipeptidyl-peptidase I', 127, NULL, NULL, 70812),
(70813, '2.60.260.20-FF-000034', NULL, 'Chaperone protein DnaJ', 63, NULL, NULL, 70813),
(70814, '2.90.10.10-FF-000055', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase LECRK3', 126, NULL, NULL, 70814),
(70815, '1.20.120.790-FF-000036', NULL, 'Uncharacterized protein', 62, NULL, NULL, 70815),
(70816, '3.30.70.330-FF-001198', NULL, 'RNA recognition motif domain containing protein', 80, NULL, NULL, 70816),
(70817, '3.10.450.540-FF-000002', NULL, 'ORF13-like protein', 117, NULL, NULL, 70817),
(70818, '3.20.20.80-FF-000734', NULL, 'Uncharacterized protein', 88, NULL, NULL, 70818),
(70819, '2.60.120.260-FF-000345', NULL, 'Uncharacterized protein', 143, NULL, NULL, 70819),
(70820, '2.60.40.10-FF-004925', NULL, NULL, 71, NULL, NULL, 70820),
(70821, '1.20.5.110-FF-000356', NULL, 'Syntaxin 1A (brain)', 106, NULL, NULL, 70821),
(70822, '3.40.250.10-FF-000059', NULL, 'Thiosulfate sulfurtransferase', 141, NULL, NULL, 70822),
(70823, '3.40.50.300-FF-000345', NULL, 'AAA family ATPase', 161, NULL, NULL, 70823),
(70824, '3.50.30.30-FF-000090', NULL, 'Ring finger protein 215', 173, NULL, NULL, 70824),
(70825, '2.120.10.10-FF-000008', NULL, 'Exo-alpha-sialidase', 371, NULL, NULL, 70825),
(70826, '1.10.287.370-FF-000081', NULL, 'Predicted protein', 118, NULL, NULL, 70826),
(70827, '3.40.50.150-FF-000991', NULL, NULL, 213, NULL, NULL, 70827),
(70828, '1.10.510.10-FF-001494', NULL, 'Kinase, NAK', 330, NULL, NULL, 70828),
(70829, '1.10.530.10-FF-000073', NULL, 'Basic endochitinase B', 40, NULL, NULL, 70829),
(70830, '1.20.5.110-FF-000064', NULL, 'Vesicle associated membrane protein 5', 90, NULL, NULL, 70830),
(70831, '2.60.40.350-FF-000003', NULL, 'Genome polyprotein', 99, NULL, NULL, 70831),
(70832, '3.90.190.10-FF-000571', NULL, 'Predicted protein', 296, NULL, NULL, 70832),
(70833, '3.30.160.60-FF-005307', NULL, NULL, 38, NULL, NULL, 70833),
(70834, '3.40.630.10-FF-000049', NULL, 'cytosolic carboxypeptidase-like protein 5 isoform X1', 125, NULL, NULL, 70834),
(70835, '3.80.10.10-FF-000446', NULL, 'Protein phosphatase 1 regulatory subunit SDS22', 180, NULL, NULL, 70835),
(70836, '3.40.50.720-FF-002152', NULL, 'Os03g0147150 protein', 83, NULL, NULL, 70836),
(70837, '1.10.287.950-FF-000007', NULL, 'HAMP domain-containing protein', 304, NULL, NULL, 70837),
(70838, '3.90.190.20-FF-000012', NULL, 'Folylpolyglutamate synthase', 145, NULL, NULL, 70838),
(70839, '2.120.10.80-FF-000248', NULL, 'leucine-zipper-like transcriptional regulator 1 isoform X5', 251, NULL, NULL, 70839);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(70840, '2.60.40.1180-FF-000143', NULL, 'Oligo-1,6-glucosidase IMA1', 71, NULL, NULL, 70840),
(70841, '3.30.70.330-FF-001226', NULL, 'SRA stem-loop interacting RNA binding protein', 100, NULL, NULL, 70841),
(70842, '1.20.1320.30-FF-000003', NULL, 'Probable ATP-dependent RNA helicase DHX58', 122, NULL, NULL, 70842),
(70843, '1.20.1250.20-FF-001843', NULL, 'Transporter', 136, NULL, NULL, 70843),
(70844, '3.30.200.20-FF-000494', NULL, 'serine/threonine-protein kinase WNK2 isoform X2', 98, NULL, NULL, 70844),
(70845, '3.40.50.1820-FF-000384', NULL, 'YGR031W-like protein', 310, NULL, NULL, 70845),
(70846, '1.20.1250.20-FF-001658', NULL, 'Unplaced genomic scaffold supercont2.10, whole genome shotgun sequence', 174, NULL, NULL, 70846),
(70847, '1.10.150.390-FF-000003', NULL, 'DNA-directed RNA polymerase subunit', 45, NULL, NULL, 70847),
(70848, '1.10.110.10-FF-000018', NULL, '2S seed storage protein 5', 125, NULL, NULL, 70848),
(70849, '1.10.150.130-FF-000009', NULL, 'Tyrosine recombinase XerC', 95, NULL, NULL, 70849),
(70850, '3.60.140.10-FF-000007', NULL, 'Polyphenol oxidase', 212, NULL, NULL, 70850),
(70851, '1.20.1070.10-FF-000399', NULL, 'KISS1 receptor', 142, NULL, NULL, 70851),
(70852, '2.130.10.10-FF-004257', NULL, 'Uncharacterized protein', 137, NULL, NULL, 70852),
(70853, '3.40.50.1460-FF-000017', NULL, 'Caspase-12', 178, NULL, NULL, 70853),
(70854, '2.30.250.10-FF-000003', NULL, 'Probable M18 family aminopeptidase 2', 133, NULL, NULL, 70854),
(70855, '3.40.50.150-FF-000811', NULL, 'F16P17.4 protein', 168, NULL, NULL, 70855),
(70856, '1.20.120.1080-FF-000052', NULL, 'Probable ATP-dependent RNA helicase spindle-E', 111, NULL, NULL, 70856),
(70857, '1.20.140.80-FF-000005', NULL, 'Transcription factor', 150, NULL, NULL, 70857),
(70858, '2.10.50.10-FF-000089', NULL, 'Neurotrophin receptor associated death domain', 33, NULL, NULL, 70858),
(70859, '1.10.8.60-FF-000136', NULL, 'Fis family transcriptional regulator', 67, NULL, NULL, 70859),
(70860, '3.40.225.10-FF-000046', NULL, NULL, 99, NULL, NULL, 70860),
(70861, '3.90.1440.10-FF-000011', NULL, 'Uncharacterized protein', 85, NULL, NULL, 70861),
(70862, '2.30.29.30-FF-000657', NULL, 'Rho GTPase Activating protein', 136, NULL, NULL, 70862),
(70863, '3.30.160.60-FF-004493', NULL, NULL, 25, NULL, NULL, 70863),
(70864, '3.20.20.70-FF-000821', NULL, NULL, 220, NULL, NULL, 70864),
(70865, '1.10.533.10-FF-000079', NULL, 'IGF like family receptor 1', 113, NULL, NULL, 70865),
(70866, '2.60.40.10-FF-004841', NULL, NULL, 85, NULL, NULL, 70866),
(70867, '3.60.40.10-FF-000112', NULL, 'Ptc6p', 337, NULL, NULL, 70867),
(70868, '1.20.1250.20-FF-002294', NULL, 'Uncharacterized protein', 67, NULL, NULL, 70868),
(70869, '1.25.40.10-FF-002991', NULL, 'Pentatricopeptide repeat-containing protein At5g13770, chloroplastic', 135, NULL, NULL, 70869),
(70870, '2.40.50.90-FF-000179', NULL, 'Tudor domain-containing protein 1', 96, NULL, NULL, 70870),
(70871, '2.30.42.10-FF-000620', NULL, NULL, 87, NULL, NULL, 70871),
(70872, '3.30.830.10-FF-000050', NULL, 'Mitochondrial processing peptidase, beta subunit, putative', 238, NULL, NULL, 70872),
(70873, '2.10.109.10-FF-000062', NULL, 'Mitochondrial inner membrane protease subunit', 154, NULL, NULL, 70873),
(70874, '2.130.10.10-FF-004965', NULL, 'Uncharacterized protein', 87, NULL, NULL, 70874),
(70875, '1.20.1440.370-FF-000001', NULL, 'Multifunctional virulence effector protein DrrA', 73, NULL, NULL, 70875),
(70876, '2.60.120.40-FF-000058', NULL, 'Uncharacterized protein', 138, NULL, NULL, 70876),
(70877, '3.40.1620.10-FF-000008', NULL, 'Antitoxin', 40, NULL, NULL, 70877),
(70878, '2.40.30.170-FF-000019', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 75, NULL, NULL, 70878),
(70879, '1.20.1250.10-FF-000109', NULL, NULL, 150, NULL, NULL, 70879),
(70880, '1.10.630.10-FF-000249', NULL, 'Cholesterol side-chain cleavage enzyme, mitochondrial', 212, NULL, NULL, 70880),
(70881, '1.10.238.10-FF-000466', NULL, 'Sorting nexin Mvp1', 96, NULL, NULL, 70881),
(70882, '2.40.50.140-FF-001245', NULL, NULL, 120, NULL, NULL, 70882);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(70883, '3.40.50.300-FF-001834', NULL, 'ATP-dependent DNA helicase', 220, NULL, NULL, 70883),
(70884, '3.30.200.20-FF-001455', NULL, 'Calcium and calcium/calmodulin-dependent serine/threonine-protein kinase DMI-3 isoform A', 55, NULL, NULL, 70884),
(70885, '2.120.10.80-FF-000304', NULL, 'Uncharacterized protein', 187, NULL, NULL, 70885),
(70886, '3.40.50.300-FF-000873', NULL, 'p-loop nucleoside triphosphate hydrolase superfamily protein', 164, NULL, NULL, 70886),
(70887, '3.40.50.2300-FF-001326', NULL, NULL, 89, NULL, NULL, 70887),
(70888, '1.20.1560.10-FF-000335', NULL, 'Multiple drug resistance-associated protein-like transporter 1', 349, NULL, NULL, 70888),
(70889, '1.25.40.20-FF-001364', NULL, 'Uncharacterized protein', 95, NULL, NULL, 70889),
(70890, '3.30.200.20-FF-000819', NULL, 'Uncharacterized protein', 96, NULL, NULL, 70890),
(70891, '3.90.190.10-FF-000419', NULL, 'Uncharacterized protein', 93, NULL, NULL, 70891),
(70892, '3.30.160.60-FF-001620', NULL, 'Uncharacterized protein', 29, NULL, NULL, 70892),
(70893, '1.25.40.10-FF-002463', NULL, 'Pentatricopeptide (PPR) domain protein 40', 113, NULL, NULL, 70893),
(70894, '3.40.850.10-FF-000116', NULL, 'Putative kinesin', 351, NULL, NULL, 70894),
(70895, '3.40.50.410-FF-000142', NULL, 'Integrator complex subunit 6', 150, NULL, NULL, 70895),
(70896, '3.20.20.60-FF-000015', NULL, 'Oxaloacetate decarboxylase', 288, NULL, NULL, 70896),
(70897, '3.30.200.210-FF-000006', NULL, 'Formate dehydrogenase 2 subunit alpha (cytochrome c-553)', 124, NULL, NULL, 70897),
(70898, '3.30.50.10-FF-000153', NULL, 'Protein CBG13679', 71, NULL, NULL, 70898),
(70899, '1.20.1560.10-FF-000830', NULL, 'Uncharacterized protein', 350, NULL, NULL, 70899),
(70900, '1.10.420.10-FF-000059', NULL, 'Uncharacterized protein', 36, NULL, NULL, 70900),
(70901, '3.40.50.720-FF-000735', NULL, '(R,R)-butanediol dehydrogenase', 136, NULL, NULL, 70901),
(70902, '1.10.510.10-FF-001763', NULL, 'Serine-threonine kinase Stk1', 181, NULL, NULL, 70902),
(70903, '1.10.10.60-FF-000772', NULL, NULL, 49, NULL, NULL, 70903),
(70904, '1.10.510.10-FF-001055', NULL, 'Guanylate cyclase', 288, NULL, NULL, 70904),
(70905, '3.40.50.970-FF-000141', NULL, 'Acetolactate synthase-1/2/3 large subunit', 179, NULL, NULL, 70905),
(70906, '3.40.50.2000-FF-000865', NULL, 'Predicted protein', 198, NULL, NULL, 70906),
(70907, '3.30.390.30-FF-000044', NULL, 'Glutathione reductase', 118, NULL, NULL, 70907),
(70908, '2.60.40.10-FF-002188', NULL, 'Muscle M-line assembly protein unc-89', 96, NULL, NULL, 70908),
(70909, '2.120.10.30-FF-000222', NULL, 'Dopachrome conversion enzyme', 388, NULL, NULL, 70909),
(70910, '2.30.29.30-FF-000281', NULL, 'Actin associated protein', 133, NULL, NULL, 70910),
(70911, '3.40.50.150-FF-001300', NULL, NULL, 214, NULL, NULL, 70911),
(70912, '2.40.10.10-FF-000164', NULL, 'Jonah 66Cii', 234, NULL, NULL, 70912),
(70913, '3.50.50.60-FF-001353', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 105, NULL, NULL, 70913),
(70914, '3.50.50.60-FF-000864', NULL, 'Uncharacterized protein', 93, NULL, NULL, 70914),
(70915, '3.40.50.800-FF-000080', NULL, 'Prolyl Amino-acyl tRNA Synthetase', 121, NULL, NULL, 70915),
(70916, '3.40.50.720-FF-001224', NULL, 'RE17220p', 311, NULL, NULL, 70916),
(70917, '3.20.20.140-FF-000335', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 42, NULL, NULL, 70917),
(70918, '3.40.190.10-FF-000913', NULL, 'Predicted protein', 200, NULL, NULL, 70918),
(70919, '3.40.50.10240-FF-000043', NULL, 'Uncharacterized protein', 51, NULL, NULL, 70919),
(70920, '1.25.10.10-FF-001707', NULL, 'Uncharacterized protein', 1016, NULL, NULL, 70920),
(70921, '2.60.40.60-FF-000769', NULL, 'Uncharacterized protein', 113, NULL, NULL, 70921),
(70922, '3.30.70.1970-FF-000004', NULL, 'Terminal uridylyltransferase 3, putative', 83, NULL, NULL, 70922),
(70923, '3.30.70.2740-FF-000011', NULL, 'FAD-binding oxidoreductase', 83, NULL, NULL, 70923),
(70924, '2.60.490.10-FF-000014', NULL, 'Purinergic receptor P2X 7', 61, NULL, NULL, 70924),
(70925, '3.40.50.2300-FF-000129', NULL, 'Lactose operon repressor', 133, NULL, NULL, 70925);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(70926, '3.30.70.141-FF-000052', NULL, NULL, 169, NULL, NULL, 70926),
(70927, '3.30.710.10-FF-000395', NULL, 'BTB/POZ domain-containing protein 3', 138, NULL, NULL, 70927),
(70928, '2.40.50.90-FF-000151', NULL, 'Protein C3orf33 homolog-like Protein', 146, NULL, NULL, 70928),
(70929, '3.30.200.20-FF-001803', NULL, 'Serine/threonine-protein kinase RAD53', 89, NULL, NULL, 70929),
(70930, '3.40.50.150-FF-001823', NULL, NULL, 84, NULL, NULL, 70930),
(70931, '3.30.160.60-FF-001272', NULL, 'Zinc finger protein 683', 30, NULL, NULL, 70931),
(70932, '1.25.40.10-FF-002839', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 133, NULL, NULL, 70932),
(70933, '1.10.510.10-FF-003000', NULL, NULL, 94, NULL, NULL, 70933),
(70934, '2.130.10.30-FF-000053', NULL, 'Regulator of chromosome condensation', 395, NULL, NULL, 70934),
(70935, '3.40.47.10-FF-000196', NULL, 'Polyketide synthase, putative (JCVI)', 447, NULL, NULL, 70935),
(70936, '3.30.160.60-FF-001087', NULL, 'Zinc finger and SCAN domain-containing protein 26', 29, NULL, NULL, 70936),
(70937, '3.30.70.1220-FF-000010', NULL, 'Uncharacterized protein', 47, NULL, NULL, 70937),
(70938, '3.40.33.10-FF-000107', NULL, 'Uncharacterized protein', 133, NULL, NULL, 70938),
(70939, '3.80.10.10-FF-002571', NULL, 'Transmembrane receptors / ATP binding protein', 291, NULL, NULL, 70939),
(70940, '3.30.160.60-FF-000783', NULL, 'Zinc finger and BTB domain-containing protein 16', 30, NULL, NULL, 70940),
(70941, '1.20.1110.10-FF-000223', NULL, NULL, 29, NULL, NULL, 70941),
(70942, '1.20.58.1080-FF-000010', NULL, 'ATP-dependent RNA and DNA helicase, mitochondrial, putative', 106, NULL, NULL, 70942),
(70943, '2.60.40.10-FF-002896', NULL, 'Ig and fibronectin type-III', 106, NULL, NULL, 70943),
(70944, '1.20.1420.10-FF-000033', NULL, NULL, 158, NULL, NULL, 70944),
(70945, '3.30.1360.40-FF-000022', NULL, 'DNA topoisomerase 2', 96, NULL, NULL, 70945),
(70946, '4.10.1000.10-FF-000052', NULL, 'Zinc finger CCCH domain-containing protein 33', 72, NULL, NULL, 70946),
(70947, '2.40.128.20-FF-000035', NULL, 'Pufferfish saxitoxin and tetrodotoxin binding protein type 2_1', 181, NULL, NULL, 70947),
(70948, '3.30.420.10-FF-000704', NULL, NULL, 108, NULL, NULL, 70948),
(70949, '3.80.10.10-FF-001374', NULL, 'RNI-like superfamily protein', 82, NULL, NULL, 70949),
(70950, '3.30.450.20-FF-000153', NULL, 'Protein TWIN LOV 1 isoform D', 178, NULL, NULL, 70950),
(70951, '3.40.50.300-FF-005016', NULL, 'DNA repair protein RAD51 homolog 1', 132, NULL, NULL, 70951),
(70952, '1.20.190.60-FF-000002', NULL, 'Protein CBR-SMG-7', 116, NULL, NULL, 70952),
(70953, '2.170.300.10-FF-000054', NULL, 'Uncharacterized protein', 107, NULL, NULL, 70953),
(70954, '1.10.720.30-FF-000003', NULL, 'Mesencephalic astrocyte-derived neurotrophic factor', 57, NULL, NULL, 70954),
(70955, '3.30.40.10-FF-002305', NULL, 'Uncharacterized protein', 115, NULL, NULL, 70955),
(70956, '3.10.129.10-FF-000054', NULL, 'Putative tol-pal system-associated acyl-CoA thioesterase', 133, NULL, NULL, 70956),
(70957, '2.130.10.10-FF-000311', NULL, 'general transcription factor 3C polypeptide 2', 307, NULL, NULL, 70957),
(70958, '1.25.40.10-FF-000574', NULL, 'Tetratricopeptide repeat domain 37', 176, NULL, NULL, 70958),
(70959, '1.20.1420.30-FF-000039', NULL, 'WGS project CABT00000000 data, contig 2.3', 154, NULL, NULL, 70959),
(70960, '3.40.50.1820-FF-001688', NULL, 'N-(5-amino-5-carboxypentanoyl)-L-cysteinyl-D-valine synthase', 218, NULL, NULL, 70960),
(70961, '2.130.10.10-FF-001295', NULL, 'Putative ubiquitin hydrolase', 306, NULL, NULL, 70961),
(70962, '3.40.50.720-FF-000263', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 163, NULL, NULL, 70962),
(70963, '3.40.190.10-FF-000565', NULL, 'GH25591p', 84, NULL, NULL, 70963),
(70964, '1.25.40.10-FF-000102', NULL, 'hsp70-Hsp90 organizing protein 3-like', 115, NULL, NULL, 70964),
(70965, '1.10.10.10-FF-001999', NULL, 'Glr1369 protein', 138, NULL, NULL, 70965),
(70966, '3.10.250.10-FF-000066', NULL, 'Uncharacterized protein', 111, NULL, NULL, 70966),
(70967, '3.40.50.11350-FF-000044', NULL, 'Uncharacterized protein', 169, NULL, NULL, 70967);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(70968, '3.90.1300.10-FF-000029', NULL, 'Uncharacterized protein', 343, NULL, NULL, 70968),
(70969, '3.40.50.300-FF-008186', NULL, 'GTP-binding protein-related', 81, NULL, NULL, 70969),
(70970, '1.20.1510.10-FF-000063', NULL, NULL, 107, NULL, NULL, 70970),
(70971, '2.60.40.60-FF-000825', NULL, 'Uncharacterized protein', 112, NULL, NULL, 70971),
(70972, '3.30.160.60-FF-004998', NULL, NULL, 50, NULL, NULL, 70972),
(70973, '3.30.450.20-FF-000630', NULL, 'Uncharacterized protein', 68, NULL, NULL, 70973),
(70974, '1.25.10.10-FF-001590', NULL, 'Sister chromatid cohesion protein', 193, NULL, NULL, 70974),
(70975, '3.30.428.10-FF-000025', NULL, 'Histidine triad protein, putative', 145, NULL, NULL, 70975),
(70976, '3.40.140.20-FF-000003', NULL, 'Bifunctional purine biosynthesis protein', 147, NULL, NULL, 70976),
(70977, '3.40.1110.10-FF-000341', NULL, NULL, 117, NULL, NULL, 70977),
(70978, '3.30.70.20-FF-000101', NULL, NULL, 75, NULL, NULL, 70978),
(70979, '1.10.238.10-FF-000697', NULL, 'EF-hand domain pair/EF-hand domain containing protein, putative', 98, NULL, NULL, 70979),
(70980, '2.60.120.200-FF-000226', NULL, 'Multidomain scavenger receptor', 159, NULL, NULL, 70980),
(70981, '3.40.190.10-FF-000621', NULL, 'Sulfonate transport system substrate-binding protein', 169, NULL, NULL, 70981),
(70982, '3.40.50.12160-FF-000012', NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase', 134, NULL, NULL, 70982),
(70983, '3.30.70.330-FF-001670', NULL, NULL, 118, NULL, NULL, 70983),
(70984, '3.30.2340.10-FF-000006', NULL, 'tRNA pseudouridine synthase D', 132, NULL, NULL, 70984),
(70985, '3.10.129.10-FF-000110', NULL, 'Bifunctional hydroxyacyl-CoA dehydrogenase/enoyl-CoA hydratase fox2', 147, NULL, NULL, 70985),
(70986, '3.40.1280.10-FF-000055', NULL, 'Ribosomal RNA small subunit methyltransferase E', 230, NULL, NULL, 70986),
(70987, '1.20.1440.90-FF-000013', NULL, NULL, 154, NULL, NULL, 70987),
(70988, '1.10.10.10-FF-001527', NULL, 'Amx-1', 101, NULL, NULL, 70988),
(70989, '1.25.10.10-FF-001062', NULL, 'Exportin 4', 147, NULL, NULL, 70989),
(70990, '1.20.1070.10-FF-001124', NULL, 'Neuropeptide FF receptor 2', 352, NULL, NULL, 70990),
(70991, '3.30.200.20-FF-000527', NULL, 'mitogen-activated protein kinase kinase 3', 109, NULL, NULL, 70991),
(70992, '1.10.220.150-FF-000004', NULL, 'Putative ADP-ribosylation factor GTPase-activating protein 2', 141, NULL, NULL, 70992),
(70993, '3.50.50.60-FF-000572', NULL, 'Tryptophan 2-monooxygenase oxidoreductase', 354, NULL, NULL, 70993),
(70994, '3.30.460.10-FF-000122', NULL, 'YALI0D12364p', 119, NULL, NULL, 70994),
(70995, '3.50.7.10-FF-000020', NULL, 'Chaperonin 1 60 kDa', 181, NULL, NULL, 70995),
(70996, '2.120.10.30-FF-000514', NULL, 'Uncharacterized protein', 195, NULL, NULL, 70996),
(70997, '2.30.29.30-FF-000573', NULL, 'Oxysterol-binding family protein', 98, NULL, NULL, 70997),
(70998, '3.10.20.230-FF-000027', NULL, 'Uncharacterized protein', 69, NULL, NULL, 70998),
(70999, '2.60.40.10-FF-004133', NULL, NULL, 91, NULL, NULL, 70999),
(71000, '3.40.366.10-FF-000024', NULL, 'Phenolpthiocerol synthesis type-I polyketide synthase PPSE', 301, NULL, NULL, 71000),
(71001, '3.30.160.60-FF-002868', NULL, 'GD16882', 28, NULL, NULL, 71001),
(71002, '1.10.357.50-FF-000030', NULL, 'Uncharacterized protein', 93, NULL, NULL, 71002),
(71003, '3.20.20.140-FF-000071', NULL, 'Dihydroorotase, homodimeric type, variant', 361, NULL, NULL, 71003),
(71004, '1.20.1250.20-FF-001282', NULL, 'Basic amino acid transporter', 202, NULL, NULL, 71004),
(71005, '3.30.200.20-FF-001039', NULL, 'Protein kinase, putative', 97, NULL, NULL, 71005),
(71006, '3.40.1110.10-FF-000009', NULL, 'Phospholipid-transporting ATPase', 168, NULL, NULL, 71006),
(71007, '3.80.10.10-FF-002419', NULL, 'Extracellular matrix protein 2, female organ and adipocyte-specific, gene 2', 149, NULL, NULL, 71007),
(71008, '3.40.50.2000-FF-000629', NULL, 'Protein CBR-UGT-50', 177, NULL, NULL, 71008),
(71009, '2.60.40.10-FF-003621', NULL, NULL, 101, NULL, NULL, 71009),
(71010, '4.10.60.10-FF-000074', NULL, 'Cleavage polyadenylation factor subunit', 51, NULL, NULL, 71010);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(71011, '3.50.50.60-FF-000717', NULL, 'Glutamate synthase, small subunit', 95, NULL, NULL, 71011),
(71012, '3.80.10.10-FF-002043', NULL, 'Acid labile subunit', 85, NULL, NULL, 71012),
(71013, '1.10.275.10-FF-000018', NULL, 'Argininosuccinate lyase', 125, NULL, NULL, 71013),
(71014, '3.40.50.410-FF-000378', NULL, 'Uncharacterized protein', 88, NULL, NULL, 71014),
(71015, '2.10.25.10-FF-000429', NULL, 'Cubilin', 46, NULL, NULL, 71015),
(71016, '2.130.10.10-FF-004526', NULL, 'Protein CBG07276', 229, NULL, NULL, 71016),
(71017, '2.40.70.10-FF-000229', NULL, 'Uncharacterized protein', 179, NULL, NULL, 71017),
(71018, '3.20.20.300-FF-000046', NULL, NULL, 112, NULL, NULL, 71018),
(71019, '1.10.472.10-FF-000673', NULL, 'Uncharacterized protein', 57, NULL, NULL, 71019),
(71020, '4.10.60.10-FF-000130', NULL, 'Cellular nucleic acid binding protein, putative', 34, NULL, NULL, 71020),
(71021, '3.40.50.300-FF-003835', NULL, 'Twitching motility pilus retraction ATPase', 260, NULL, NULL, 71021),
(71022, '1.10.510.10-FF-002275', NULL, NULL, 94, NULL, NULL, 71022),
(71023, '1.20.930.10-FF-000005', NULL, 'PC4 and SFRS1-interacting protein-like isoform X1', 94, NULL, NULL, 71023),
(71024, '1.25.10.10-FF-000746', NULL, 'Dynein assembly factor 5, axonemal', 210, NULL, NULL, 71024),
(71025, '1.20.5.320-FF-000014', NULL, 'Fibritin', 113, NULL, NULL, 71025),
(71026, '2.170.150.20-FF-000027', NULL, 'Uncharacterized protein', 61, NULL, NULL, 71026),
(71027, '2.40.100.10-FF-000058', NULL, 'Peptidyl-prolyl cis-trans isomerase', 121, NULL, NULL, 71027),
(71028, '3.40.50.300-FF-003779', NULL, '6-phosphofructo 2-kinase/fructose 2,6-bisphosphatase short form', 91, NULL, NULL, 71028),
(71029, '1.25.40.10-FF-000046', NULL, 'Prolyl 3-hydroxylase 1', 95, NULL, NULL, 71029),
(71030, '2.60.40.10-FF-001171', NULL, 'PKHD1, fibrocystin/polyductin', 96, NULL, NULL, 71030),
(71031, '2.50.20.10-FF-000001', NULL, 'Outer-membrane lipoprotein carrier protein', 182, NULL, NULL, 71031),
(71032, '1.20.1070.10-FF-000719', NULL, 'Uncharacterized protein', 139, NULL, NULL, 71032),
(71033, '2.60.120.200-FF-000698', NULL, 'Uncharacterized protein', 190, NULL, NULL, 71033),
(71034, '3.10.110.10-FF-000325', NULL, 'Uncharacterized protein', 157, NULL, NULL, 71034),
(71035, '1.20.144.10-FF-000089', NULL, 'Uncharacterized protein', 111, NULL, NULL, 71035),
(71036, '1.20.1070.10-FF-001596', NULL, 'Uncharacterized protein', 153, NULL, NULL, 71036),
(71037, '3.30.1180.20-FF-000007', NULL, 'Dihydroxyacetone kinase', 156, NULL, NULL, 71037),
(71038, '1.20.5.170-FF-000003', NULL, 'cAMP-responsive element modulator isoform X2', 55, NULL, NULL, 71038),
(71039, '2.130.10.130-FF-000010', NULL, 'Glycosylphosphatidylinositol specific phospholipase D1', 285, NULL, NULL, 71039),
(71040, '1.20.120.1750-FF-000005', NULL, 'RBR-type E3 ubiquitin transferase', 251, NULL, NULL, 71040),
(71041, '1.20.120.420-FF-000009', NULL, 'Gcd7p', 119, NULL, NULL, 71041),
(71042, '3.30.230.10-FF-000313', NULL, 'GHMP kinases putative ATP-binding protein', 81, NULL, NULL, 71042),
(71043, '3.30.460.10-FF-000066', NULL, 'Dephospho-CoA kinase', 194, NULL, NULL, 71043),
(71044, '3.30.540.10-FF-000067', NULL, 'Inositol-1-monophosphatase', 211, NULL, NULL, 71044),
(71045, '3.40.50.1820-FF-000704', NULL, 'Peptide synthetase ORF5', 157, NULL, NULL, 71045),
(71046, '1.10.630.10-FF-000305', NULL, 'Cytochrome P450, putative', 345, NULL, NULL, 71046),
(71047, '3.30.160.60-FF-002492', NULL, 'ZNF683 isoform 2', 48, NULL, NULL, 71047),
(71048, '3.80.10.10-FF-000862', NULL, 'NACHT, LRR and PYD domains-containing protein 14', 403, NULL, NULL, 71048),
(71049, '2.120.10.30-FF-000458', NULL, 'Nhl repeat-containing protein, putative', 89, NULL, NULL, 71049),
(71050, '1.25.40.10-FF-004317', NULL, 'Uncharacterized protein', 176, NULL, NULL, 71050),
(71051, '3.40.50.2300-FF-000657', NULL, 'Two-component system response regulator', 131, NULL, NULL, 71051),
(71052, '4.10.1240.10-FF-000070', NULL, 'Uncharacterized protein', 84, NULL, NULL, 71052),
(71053, '1.10.1760.20-FF-000002', NULL, 'Sensor histidine kinase YpdA', 156, NULL, NULL, 71053);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(71054, '1.10.418.10-FF-000267', NULL, 'Uncharacterized protein', 148, NULL, NULL, 71054),
(71055, '1.10.8.60-FF-000552', NULL, 'Uncharacterized protein', 56, NULL, NULL, 71055),
(71056, '1.25.10.10-FF-001910', NULL, 'Probable serine/threonine-protein kinase vps15', 187, NULL, NULL, 71056),
(71057, '3.90.226.10-FF-000048', NULL, '3,2-trans-enoyl-CoA isomerase', 262, NULL, NULL, 71057),
(71058, '1.25.40.10-FF-003008', NULL, 'Putative pentatricopeptide repeat-containing protein At3g15130', 121, NULL, NULL, 71058),
(71059, '3.40.50.620-FF-000379', NULL, 'RE11660p', 174, NULL, NULL, 71059),
(71060, '3.30.160.20-FF-000142', NULL, 'Tapas, isoform B', 91, NULL, NULL, 71060),
(71061, '4.10.240.10-FF-000202', NULL, 'Uncharacterized transcriptional regulatory protein C1773.16c', 92, NULL, NULL, 71061),
(71062, '3.10.110.10-FF-000180', NULL, 'Ubiquitin-conjugating enzyme family protein', 173, NULL, NULL, 71062),
(71063, '2.30.39.10-FF-000005', NULL, 'neuroserpin isoform X1', 168, NULL, NULL, 71063),
(71064, '3.80.20.20-FF-000040', NULL, 'Cell surface GPI-anchored protein ECM33', 184, NULL, NULL, 71064),
(71065, '3.30.2350.20-FF-000077', NULL, NULL, 60, NULL, NULL, 71065),
(71066, '3.90.550.10-FF-000582', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 248, NULL, NULL, 71066),
(71067, '3.40.1190.20-FF-000085', NULL, 'Carbohydrate kinase, PfkB family', 311, NULL, NULL, 71067),
(71068, '2.10.25.10-FF-000761', NULL, 'Protein lin-3', 54, NULL, NULL, 71068),
(71069, '3.40.50.2000-FF-001034', NULL, 'Uncharacterized protein', 169, NULL, NULL, 71069),
(71070, '3.80.10.10-FF-003824', NULL, 'F-box/LRR-repeat protein, putative', 73, NULL, NULL, 71070),
(71071, '3.30.70.870-FF-000022', NULL, 'Elongation factor G, mitochondrial', 51, NULL, NULL, 71071),
(71072, '1.10.10.60-FF-000300', NULL, 'Myb transcription factor', 63, NULL, NULL, 71072),
(71073, '3.40.50.1360-FF-000049', NULL, '6-phosphogluconolactonase', 220, NULL, NULL, 71073),
(71074, '3.10.110.10-FF-000269', NULL, 'Uncharacterized protein', 146, NULL, NULL, 71074),
(71075, '1.10.8.270-FF-000176', NULL, 'Uncharacterized protein', 160, NULL, NULL, 71075),
(71076, '1.20.120.550-FF-000015', NULL, 'Uncharacterized protein', 143, NULL, NULL, 71076),
(71077, '2.60.40.10-FF-000390', NULL, 'Protein tyrosine kinase 7 (inactive)', 100, NULL, NULL, 71077),
(71078, '1.10.630.10-FF-000018', NULL, 'Cytochrome P450 monooxygenase', 400, NULL, NULL, 71078),
(71079, '2.10.25.10-FF-001273', NULL, 'Delta-like protein', 35, NULL, NULL, 71079),
(71080, '1.25.40.620-FF-000005', NULL, 'Slr1958 protein', 108, NULL, NULL, 71080),
(71081, '3.20.20.190-FF-000092', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', 111, NULL, NULL, 71081),
(71082, '3.30.1490.180-FF-000020', NULL, 'DNA-directed RNA polymerase subunit', 43, NULL, NULL, 71082),
(71083, '3.40.630.10-FF-000285', NULL, 'Putative aminopeptidase C13A11.05', 321, NULL, NULL, 71083),
(71084, '3.90.370.10-FF-000012', NULL, 'AGAP003319-PA', 71, NULL, NULL, 71084),
(71085, '3.30.420.40-FF-000808', NULL, 'Uncharacterized protein', 108, NULL, NULL, 71085),
(71086, '1.25.40.340-FF-000011', NULL, NULL, 82, NULL, NULL, 71086),
(71087, '3.40.50.300-FF-003127', NULL, 'Polyphosphate:AMP phosphotransferase', 237, NULL, NULL, 71087),
(71088, '3.30.70.3270-FF-000018', NULL, 'NADH-quinone oxidoreductase subunit I 2', 160, NULL, NULL, 71088),
(71089, '3.30.750.24-FF-000091', NULL, 'GM25771', 111, NULL, NULL, 71089),
(71090, '3.40.50.300-FF-001418', NULL, 'Heparan sulfate 2-o-sulfotransferase', 280, NULL, NULL, 71090),
(71091, '2.130.10.10-FF-003745', NULL, 'Uncharacterized WD repeat-containing protein C2A9.03', 330, NULL, NULL, 71091),
(71092, '3.40.50.10810-FF-000264', NULL, 'Uncharacterized protein', 260, NULL, NULL, 71092),
(71093, '1.10.472.130-FF-000021', NULL, 'Dynein beta chain, ciliary', 81, NULL, NULL, 71093),
(71094, '3.40.50.2000-FF-000781', NULL, 'Os04g0271800 protein', 118, NULL, NULL, 71094),
(71095, '3.40.50.720-FF-001516', NULL, 'Predicted protein', 77, NULL, NULL, 71095),
(71096, '3.40.50.150-FF-001031', NULL, NULL, 169, NULL, NULL, 71096); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(71097, '3.30.1640.10-FF-000085', NULL, 'DNA helicase', 74, NULL, NULL, 71097),
(71098, '3.20.20.80-FF-000650', NULL, 'Uncharacterized protein', 84, NULL, NULL, 71098),
(71099, '1.25.40.180-FF-000087', NULL, 'Putative eukaryotic translation initation factor 4 gamma', 232, NULL, NULL, 71099),
(71100, '1.25.10.10-FF-000218', NULL, 'lisH domain and HEAT repeat-containing protein KIAA1468 homolog isoform X1', 361, NULL, NULL, 71100),
(71101, '2.130.10.10-FF-005038', NULL, 'Uncharacterized protein', 293, NULL, NULL, 71101),
(71102, '1.20.1250.20-FF-000438', NULL, 'Major facilitator transporter', 176, NULL, NULL, 71102),
(71103, '3.40.50.1820-FF-001429', NULL, 'Uncharacterized protein', 196, NULL, NULL, 71103),
(71104, '1.10.287.70-FF-000333', NULL, 'Uncharacterized protein', 137, NULL, NULL, 71104),
(71105, '1.20.1250.20-FF-000062', NULL, 'Protein NRT1/ PTR FAMILY 1.2', 529, NULL, NULL, 71105),
(71106, '1.10.287.70-FF-000709', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 158, NULL, NULL, 71106),
(71107, '1.10.1420.10-FF-000215', NULL, 'Uncharacterized protein', 134, NULL, NULL, 71107),
(71108, '3.30.160.60-FF-001564', NULL, 'zinc finger protein 827 isoform X1', 29, NULL, NULL, 71108),
(71109, '3.40.50.300-FF-008506', NULL, 'UvrD/REP helicase domain protein, putative', 215, NULL, NULL, 71109),
(71110, '3.30.70.3250-FF-000012', NULL, NULL, 116, NULL, NULL, 71110),
(71111, '3.30.300.160-FF-000025', NULL, 'General secretion pathway protein E', 79, NULL, NULL, 71111),
(71112, '3.40.1190.10-FF-000025', NULL, 'Folylpolyglutamate synthase', 117, NULL, NULL, 71112),
(71113, '3.20.20.150-FF-000017', NULL, 'Endonuclease IV related protein', 270, NULL, NULL, 71113),
(71114, '1.20.120.810-FF-000003', NULL, 'Vinculin b', 236, NULL, NULL, 71114),
(71115, '2.10.25.10-FF-000053', NULL, 'Slit guidance ligand 2', 40, NULL, NULL, 71115),
(71116, '1.10.472.20-FF-000002', NULL, 'Nitrile hydratase subunit beta', 119, NULL, NULL, 71116),
(71117, '3.30.559.10-FF-000093', NULL, 'Carnitine acyltransferase, putative', 204, NULL, NULL, 71117),
(71118, '1.20.5.510-FF-000004', NULL, 'Ephrin type-A receptor 2', 36, NULL, NULL, 71118),
(71119, '1.25.40.10-FF-005245', NULL, 'Uncharacterized protein', 167, NULL, NULL, 71119),
(71120, '3.90.1150.10-FF-000056', NULL, 'Kynureninase', 151, NULL, NULL, 71120),
(71121, '1.20.1560.10-FF-000627', NULL, 'Uncharacterized protein', 265, NULL, NULL, 71121),
(71122, '3.40.850.10-FF-000032', NULL, 'kinesin-like protein KIN-4A isoform X1', 392, NULL, NULL, 71122),
(71123, '3.80.10.10-FF-001115', NULL, 'Protein phosphatase 2C, putative', 67, NULL, NULL, 71123),
(71124, '1.10.472.10-FF-000145', NULL, 'Plant-specific TFIIB-related protein PTF2', 102, NULL, NULL, 71124),
(71125, '3.30.70.330-FF-001142', NULL, 'Uncharacterized protein', 89, NULL, NULL, 71125),
(71126, '3.30.1240.10-FF-000004', NULL, 'Cof-like hydrolase', 106, NULL, NULL, 71126),
(71127, '3.40.50.150-FF-000047', NULL, 'Ribosomal RNA large subunit methyltransferase G', 175, NULL, NULL, 71127),
(71128, '2.130.10.10-FF-005370', NULL, 'Uncharacterized protein', 166, NULL, NULL, 71128),
(71129, '3.30.160.60-FF-006235', NULL, NULL, 50, NULL, NULL, 71129),
(71130, '3.30.930.10-FF-000411', NULL, 'Uncharacterized protein', 331, NULL, NULL, 71130),
(71131, '3.100.10.10-FF-000016', NULL, '50S ribosomal protein L15', 77, NULL, NULL, 71131),
(71132, '3.40.50.300-FF-001042', NULL, 'DNA repair protein RAD51 homolog 4', 253, NULL, NULL, 71132),
(71133, '2.10.10.20-FF-000005', NULL, 'Chitodextrinase', 70, NULL, NULL, 71133),
(71134, '2.60.40.1190-FF-000005', NULL, 'Glycoside hydrolase family 93', 144, NULL, NULL, 71134),
(71135, '1.10.472.100-FF-000006', NULL, NULL, 99, NULL, NULL, 71135),
(71136, '3.60.40.10-FF-000056', NULL, 'Probable protein phosphatase 2C 18', 332, NULL, NULL, 71136),
(71137, '1.10.1790.10-FF-000001', NULL, 'Cryptic beta-glucoside bgl operon antiterminator', 100, NULL, NULL, 71137),
(71138, '1.10.510.10-FF-000982', NULL, 'AGC protein kinase', 189, NULL, NULL, 71138),
(71139, '6.10.140.2150-FF-000008', NULL, 'Uncharacterized protein', 47, NULL, NULL, 71139);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(71140, '2.40.70.10-FF-000381', NULL, NULL, 193, NULL, NULL, 71140),
(71141, '2.60.40.10-FF-004077', NULL, NULL, 95, NULL, NULL, 71141),
(71142, '3.40.50.720-FF-000443', NULL, 'FAD dependent oxidoreductase superfamily', 163, NULL, NULL, 71142),
(71143, '1.25.40.10-FF-002608', NULL, 'Os03g0582100 protein', 144, NULL, NULL, 71143),
(71144, '1.25.10.10-FF-000926', NULL, '26S proteasome regulatory subunit, putative', 439, NULL, NULL, 71144),
(71145, '2.130.10.10-FF-001475', NULL, 'Predicted protein', 168, NULL, NULL, 71145),
(71146, '2.60.40.150-FF-000707', NULL, 'Phosphoinositide phospholipase C', 143, NULL, NULL, 71146),
(71147, '3.90.70.10-FF-000753', NULL, 'Cathepsin 3', 119, NULL, NULL, 71147),
(71148, '1.25.40.10-FF-003160', NULL, 'Pentatricopeptide repeat-containing protein At4g30700', 118, NULL, NULL, 71148),
(71149, '3.40.50.1980-FF-000055', NULL, 'Putative iron ABC transporter, substrate-binding protein', 129, NULL, NULL, 71149),
(71150, '1.10.510.10-FF-002308', NULL, NULL, 222, NULL, NULL, 71150),
(71151, '3.10.450.50-FF-000071', NULL, 'Protein translocase subunit SecA 1', 86, NULL, NULL, 71151),
(71152, '3.30.310.80-FF-000059', NULL, 'Non-specific serine/threonine protein kinase', 61, NULL, NULL, 71152),
(71153, '2.60.40.10-FF-003060', NULL, 'Interleukin 12 receptor subunit beta 2', 93, NULL, NULL, 71153),
(71154, '1.25.40.10-FF-000754', NULL, 'TPR repeat-containing protein', 207, NULL, NULL, 71154),
(71155, '2.30.30.140-FF-000001', NULL, 'Fragile X mental retardation 1, isoform CRA_e', 82, NULL, NULL, 71155),
(71156, '1.25.40.10-FF-000810', NULL, 'protein SMG5', 209, NULL, NULL, 71156),
(71157, '3.40.50.200-FF-000141', NULL, 'Subtilisin-like serine endopeptidase family protein', 87, NULL, NULL, 71157),
(71158, '1.20.1270.60-FF-000081', NULL, 'Sorting nexin 2B', 236, NULL, NULL, 71158),
(71159, '1.20.58.60-FF-000134', NULL, 'microtubule-actin cross-linking factor 1 isoform X4', 321, NULL, NULL, 71159),
(71160, '2.60.120.230-FF-000010', NULL, NULL, 153, NULL, NULL, 71160),
(71161, '2.60.120.330-FF-000214', NULL, 'Uncharacterized protein', 91, NULL, NULL, 71161),
(71162, '3.40.50.2300-FF-001585', NULL, NULL, 135, NULL, NULL, 71162),
(71163, '2.30.29.30-FF-001298', NULL, 'Uncharacterized protein', 84, NULL, NULL, 71163),
(71164, '4.10.260.10-FF-000001', NULL, 'Guanine nucleotide-binding protein subunit gamma', 70, NULL, NULL, 71164),
(71165, '1.20.58.1800-FF-000001', NULL, 'Alpha,alpha-trehalose-phosphate synthase [UDP-forming] 1', 108, NULL, NULL, 71165),
(71166, '1.20.1250.20-FF-002063', NULL, 'Solute carrier family 2, facilitated glucose transporter member 5', 291, NULL, NULL, 71166),
(71167, '3.30.870.10-FF-000024', NULL, 'Cardiolipin synthase C', 189, NULL, NULL, 71167),
(71168, '1.10.510.10-FF-002836', NULL, NULL, 60, NULL, NULL, 71168),
(71169, '3.40.50.1820-FF-000468', NULL, 'Esterase family protein', 252, NULL, NULL, 71169),
(71170, '3.60.10.10-FF-000228', NULL, 'Predicted protein', 369, NULL, NULL, 71170),
(71171, '3.40.50.11260-FF-000017', NULL, 'Chaperone protein HtpG', 89, NULL, NULL, 71171),
(71172, '2.60.120.260-FF-000261', NULL, 'Beta-galactosidase', 131, NULL, NULL, 71172),
(71173, '2.30.29.30-FF-001354', NULL, 'Uncharacterized protein', 167, NULL, NULL, 71173),
(71174, '2.60.40.10-FF-001204', NULL, 'T-cell surface glycoprotein CD4', 72, NULL, NULL, 71174),
(71175, '3.30.70.270-FF-000258', NULL, NULL, 168, NULL, NULL, 71175),
(71176, '1.20.1070.10-FF-002052', NULL, 'Uncharacterized protein', 99, NULL, NULL, 71176),
(71177, '2.130.10.10-FF-005746', NULL, 'Predicted protein', 122, NULL, NULL, 71177),
(71178, '2.10.25.10-FF-000609', NULL, 'delta and Notch-like epidermal growth factor-related receptor', 39, NULL, NULL, 71178),
(71179, '3.80.10.10-FF-002099', NULL, 'Predicted protein', 216, NULL, NULL, 71179),
(71180, '3.30.70.590-FF-000005', NULL, 'Nuclear poly(A) polymerase 3', 107, NULL, NULL, 71180),
(71181, '2.170.270.10-FF-000112', NULL, 'ATP-grasp domain containing protein, putative', 152, NULL, NULL, 71181),
(71182, '3.60.20.10-FF-000021', NULL, 'glutamine--fructose-6-phosphate aminotransferase [isomerizing] 1', 264, NULL, NULL, 71182);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(71183, '1.10.510.10-FF-002983', NULL, NULL, 183, NULL, NULL, 71183),
(71184, '3.30.70.3030-FF-000002', NULL, 'U3 small nucleolar RNA-associated protein 22', 142, NULL, NULL, 71184),
(71185, '1.10.472.80-FF-000233', NULL, NULL, 147, NULL, NULL, 71185),
(71186, '3.40.50.2300-FF-000601', NULL, 'Uncharacterized protein', 52, NULL, NULL, 71186),
(71187, '3.30.750.44-FF-000006', NULL, 'retinol-binding protein 3', 80, NULL, NULL, 71187),
(71188, '1.25.40.10-FF-001030', NULL, 'Pentatricopeptide repeat-containing protein At1g09190', 137, NULL, NULL, 71188),
(71189, '2.60.40.10-FF-001019', NULL, 'Sallimus, isoform P', 101, NULL, NULL, 71189),
(71190, '3.30.200.20-FF-000022', NULL, 'Homeodomain-interacting protein kinase 2 isoform 1', 105, NULL, NULL, 71190),
(71191, '1.10.460.10-FF-000005', NULL, 'DNA topoisomerase', 166, NULL, NULL, 71191),
(71192, '1.10.8.590-FF-000007', NULL, NULL, 78, NULL, NULL, 71192),
(71193, '3.30.70.100-FF-000106', NULL, NULL, 68, NULL, NULL, 71193),
(71194, '2.160.20.120-FF-000002', NULL, NULL, 209, NULL, NULL, 71194),
(71195, '3.30.710.10-FF-000136', NULL, 'BTB-POZ and math domain 1', 128, NULL, NULL, 71195),
(71196, '3.30.1330.30-FF-000045', NULL, 'Predicted protein', 146, NULL, NULL, 71196),
(71197, '3.90.290.10-FF-000011', NULL, 'Fibrillin 2', 70, NULL, NULL, 71197),
(71198, '1.20.58.60-FF-000281', NULL, 'Utrophin', 113, NULL, NULL, 71198),
(71199, '3.40.50.1100-FF-000022', NULL, 'Threonine synthase', 122, NULL, NULL, 71199),
(71200, '3.30.559.30-FF-000099', NULL, 'Uncharacterized protein', 246, NULL, NULL, 71200),
(71201, '4.10.800.10-FF-000026', NULL, 'Insulin-like growth factor binding protein 5', 78, NULL, NULL, 71201),
(71202, '2.60.40.420-FF-000047', NULL, 'Coagulation factor VIII', 176, NULL, NULL, 71202),
(71203, '2.130.10.10-FF-003184', NULL, 'NLE (NUC135) domain/WD domain, G-beta repeat, putative', 138, NULL, NULL, 71203),
(71204, '2.60.120.970-FF-000086', NULL, 'Growth differentiation factor 9', 210, NULL, NULL, 71204),
(71205, '3.40.50.1000-FF-000666', NULL, NULL, 206, NULL, NULL, 71205),
(71206, '1.10.10.250-FF-000022', NULL, 'Uncharacterized protein', 74, NULL, NULL, 71206),
(71207, '1.10.510.10-FF-004017', NULL, NULL, 124, NULL, NULL, 71207),
(71208, '3.30.740.10-FF-000020', NULL, NULL, 93, NULL, NULL, 71208),
(71209, '3.40.50.300-FF-000401', NULL, 'UvrABC system protein B', 230, NULL, NULL, 71209),
(71210, '3.30.479.20-FF-000056', NULL, 'Elongation factor Ts', 79, NULL, NULL, 71210),
(71211, '3.30.950.10-FF-000025', NULL, 'Uroporphyrinogen-III C-methyltransferase', 139, NULL, NULL, 71211),
(71212, '1.10.10.10-FF-000746', NULL, 'Arabinose metabolism transcriptional repressor', 69, NULL, NULL, 71212),
(71213, '3.90.215.10-FF-000023', NULL, 'Angiopoietin-like 3', 80, NULL, NULL, 71213),
(71214, '3.30.2010.10-FF-000021', NULL, 'Uncharacterized protein', 95, NULL, NULL, 71214),
(71215, '2.130.10.10-FF-001328', NULL, 'Ribosome biogenesis protein WDR12 homolog', 325, NULL, NULL, 71215),
(71216, '1.20.1720.10-FF-000073', NULL, 'Efflux pump protein', 194, NULL, NULL, 71216),
(71217, '2.60.120.260-FF-000637', NULL, 'Uncharacterized protein', 108, NULL, NULL, 71217),
(71218, '2.20.70.10-FF-000275', NULL, 'Uncharacterized protein', 30, NULL, NULL, 71218),
(71219, '3.30.70.1620-FF-000006', NULL, 'Structural maintenance of chromosomes protein', 90, NULL, NULL, 71219),
(71220, '4.10.830.40-FF-000014', NULL, NULL, 60, NULL, NULL, 71220),
(71221, '3.30.70.330-FF-001703', NULL, NULL, 121, NULL, NULL, 71221),
(71222, '1.25.40.10-FF-000607', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 77, NULL, NULL, 71222),
(71223, '3.30.590.50-FF-000003', NULL, 'Glutamate--cysteine ligase catalytic subunit', 133, NULL, NULL, 71223),
(71224, '3.80.10.10-FF-000154', NULL, 'Follicle-stimulating hormone receptor', 313, NULL, NULL, 71224),
(71225, '1.20.1310.10-FF-000019', NULL, 'Cullin 1', 115, NULL, NULL, 71225),
(71226, '3.40.850.10-FF-000560', NULL, 'Kinesin, putative', 89, NULL, NULL, 71226),
(71227, '3.90.70.80-FF-000026', NULL, 'Ovarian tumor-like cysteine protease', 133, NULL, NULL, 71227);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(71228, '2.10.70.80-FF-000009', NULL, 'Vacuolar protein sorting/targeting protein 10', 57, NULL, NULL, 71228),
(71229, '1.20.920.10-FF-000179', NULL, 'Bromodomain-containing protein', 145, NULL, NULL, 71229),
(71230, '3.40.50.20-FF-000021', NULL, 'Biotin carboxylase', 85, NULL, NULL, 71230),
(71231, '3.30.420.40-FF-000960', NULL, 'Uncharacterized protein', 23, NULL, NULL, 71231),
(71232, '3.80.10.10-FF-003791', NULL, 'Uncharacterized protein', 97, NULL, NULL, 71232),
(71233, '2.20.110.10-FF-000018', NULL, 'MORN repeat-containing protein 3', 70, NULL, NULL, 71233),
(71234, '2.30.39.10-FF-000152', NULL, 'Serpin peptidase inhibitor, clade B (ovalbumin), member 1', 116, NULL, NULL, 71234),
(71235, '3.30.60.60-FF-000005', NULL, 'Histone acetyltransferase', 61, NULL, NULL, 71235),
(71236, '3.10.100.10-FF-000443', NULL, NULL, 52, NULL, NULL, 71236),
(71237, '3.30.260.10-FF-000085', NULL, NULL, 105, NULL, NULL, 71237),
(71238, '3.30.56.10-FF-000020', NULL, 'Phenylalanine--tRNA ligase beta subunit', 58, NULL, NULL, 71238),
(71239, '1.20.900.10-FF-000037', NULL, 'Protostome-specific GEF, isoform C', 207, NULL, NULL, 71239),
(71240, '1.20.1070.10-FF-001091', NULL, 'Dopamine receptor D6b', 319, NULL, NULL, 71240),
(71241, '3.30.1680.10-FF-000059', NULL, 'Uncharacterized protein', 47, NULL, NULL, 71241),
(71242, '3.40.390.10-FF-000277', NULL, NULL, 120, NULL, NULL, 71242),
(71243, '3.40.50.880-FF-000030', NULL, 'Gamma-glutamyl-gamma-aminobutyrate hydrolase PuuD', 248, NULL, NULL, 71243),
(71244, '1.25.10.10-FF-002219', NULL, 'Uncharacterized protein', 409, NULL, NULL, 71244),
(71245, '3.40.50.300-FF-008130', NULL, 'Predicted protein', 105, NULL, NULL, 71245),
(71246, '3.40.50.150-FF-000575', NULL, 'Type 11 methyltransferase', 191, NULL, NULL, 71246),
(71247, '1.10.8.720-FF-000007', NULL, 'Dynein axonemal heavy chain 6', 163, NULL, NULL, 71247),
(71248, '3.75.10.20-FF-000001', NULL, 'N-succinylarginine dihydrolase', 447, NULL, NULL, 71248),
(71249, '2.40.50.140-FF-000604', NULL, 'Ribosomal protein S28-like', 62, NULL, NULL, 71249),
(71250, '3.40.1110.10-FF-000397', NULL, NULL, 98, NULL, NULL, 71250),
(71251, '3.30.420.10-FF-000468', NULL, NULL, 113, NULL, NULL, 71251),
(71252, '2.40.30.10-FF-000255', NULL, 'Siderophore-interacting protein', 100, NULL, NULL, 71252),
(71253, '1.10.510.10-FF-000330', NULL, '3-phosphoinositide-dependent protein kinase 2-like', 199, NULL, NULL, 71253),
(71254, '2.30.30.40-FF-000444', NULL, 'neutrophil cytosolic factor 1 isoform X1', 74, NULL, NULL, 71254),
(71255, '3.30.9.10-FF-000035', NULL, 'Putative oxidoreductase TDA3', 105, NULL, NULL, 71255),
(71256, '1.20.1250.10-FF-000020', NULL, 'Interleukin-12 subunit alpha', 178, NULL, NULL, 71256),
(71257, '1.10.287.130-FF-000060', NULL, 'ATPase/histidine kinase/DNA gyrase B/HSP90 domain protein', 74, NULL, NULL, 71257),
(71258, '2.170.16.10-FF-000002', NULL, 'Desert hedgehog', 148, NULL, NULL, 71258),
(71259, '3.40.50.300-FF-007725', NULL, 'Uncharacterized protein', 91, NULL, NULL, 71259),
(71260, '3.40.50.10190-FF-000005', NULL, 'Tumor suppressor p53-binding protein 1', 118, NULL, NULL, 71260),
(71261, '3.90.25.10-FF-000070', NULL, 'Uncharacterized protein', 72, NULL, NULL, 71261),
(71262, '1.20.140.40-FF-000044', NULL, 'Expressed protein', 176, NULL, NULL, 71262),
(71263, '3.30.160.60-FF-003273', NULL, NULL, 26, NULL, NULL, 71263),
(71264, '3.30.200.20-FF-002528', NULL, 'Protein kinase superfamily protein', 70, NULL, NULL, 71264),
(71265, '2.40.37.10-FF-000085', NULL, NULL, 54, NULL, NULL, 71265),
(71266, '3.60.10.10-FF-000380', NULL, 'DNA-(Apurinic or apyrimidinic site) lyase chloroplastic', 82, NULL, NULL, 71266),
(71267, '1.20.1070.10-FF-000163', NULL, 'Thromboxane A2 receptor', 316, NULL, NULL, 71267),
(71268, '2.170.140.10-FF-000052', NULL, 'Prion-like-(Q/N-rich)-domain-bearing protein', 70, NULL, NULL, 71268),
(71269, '2.130.10.10-FF-002817', NULL, 'Chromatin assembly factor 1 subunit B, putative', 144, NULL, NULL, 71269),
(71270, '2.80.10.50-FF-000157', NULL, 'Uncharacterized protein', 172, NULL, NULL, 71270),
(71271, '3.40.50.300-FF-002346', NULL, 'DNA2/NAM7 helicase', 149, NULL, NULL, 71271);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(71272, '3.80.10.10-FF-004044', NULL, 'Predicted protein', 140, NULL, NULL, 71272),
(71273, '1.10.620.20-FF-000049', NULL, 'Uncharacterized protein', 97, NULL, NULL, 71273),
(71274, '3.30.470.20-FF-000188', NULL, 'Predicted protein', 125, NULL, NULL, 71274),
(71275, '3.20.20.70-FF-000349', NULL, 'Putative glutamate synthase [NADPH], large subunit', 345, NULL, NULL, 71275),
(71276, '2.40.290.10-FF-000043', NULL, 'X-ray repair complementing defective repair in Chinese hamster cells 6', 78, NULL, NULL, 71276),
(71277, '3.40.50.720-FF-001988', NULL, '3-oxoacyl-(Acyl-carrier-protein) reductase', 242, NULL, NULL, 71277),
(71278, '1.25.40.20-FF-000723', NULL, 'Uncharacterized protein, isoform B', 77, NULL, NULL, 71278),
(71279, '1.20.58.70-FF-000047', NULL, 'Related to PEP12 syntaxin (t-SNARE), vacuolar', 129, NULL, NULL, 71279),
(71280, '2.60.40.10-FF-005566', NULL, NULL, 110, NULL, NULL, 71280),
(71281, '4.10.240.10-FF-000146', NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', 76, NULL, NULL, 71281),
(71282, '1.20.5.110-FF-000300', NULL, 'Vesicle-associated membrane protein 4', 70, NULL, NULL, 71282),
(71283, '3.90.226.10-FF-000104', NULL, 'Related to enoyl-CoA hydratase', 265, NULL, NULL, 71283),
(71284, '1.25.40.10-FF-003536', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 112, NULL, NULL, 71284),
(71285, '3.30.40.10-FF-000563', NULL, 'Piccolo presynaptic cytomatrix protein', 127, NULL, NULL, 71285),
(71286, '3.10.450.330-FF-000001', NULL, 'Sucrose synthase', 136, NULL, NULL, 71286),
(71287, '3.40.50.300-FF-003274', NULL, 'DDX39A isoform 12', 101, NULL, NULL, 71287),
(71288, '3.40.50.10880-FF-000004', NULL, 'Pantothenate kinase', 169, NULL, NULL, 71288),
(71289, '1.20.5.190-FF-000161', NULL, NULL, 69, NULL, NULL, 71289),
(71290, '2.60.40.10-FF-002508', NULL, 'Synaptogenesis protein syg-1', 138, NULL, NULL, 71290),
(71291, '3.40.50.11850-FF-000008', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase', 113, NULL, NULL, 71291),
(71292, '1.10.10.60-FF-001284', NULL, NULL, 136, NULL, NULL, 71292),
(71293, '2.60.40.1120-FF-000024', NULL, 'Carboxypeptidase D', 99, NULL, NULL, 71293),
(71294, '1.10.10.2170-FF-000002', NULL, 'DNA-binding protein RAP1', 50, NULL, NULL, 71294),
(71295, '2.10.50.10-FF-000033', NULL, 'CD27 molecule', 47, NULL, NULL, 71295),
(71296, '3.60.21.10-FF-000309', NULL, 'Serine/threonine-protein phosphatase', 270, NULL, NULL, 71296),
(71297, '3.30.160.60-FF-003981', NULL, NULL, 28, NULL, NULL, 71297),
(71298, '1.25.40.10-FF-004464', NULL, 'Intraflagellar transport protein', 109, NULL, NULL, 71298),
(71299, '3.80.10.10-FF-003644', NULL, 'Uncharacterized protein', 104, NULL, NULL, 71299),
(71300, '3.40.720.10-FF-000348', NULL, 'Iduronate 2-sulfatase, putative', 44, NULL, NULL, 71300),
(71301, '3.90.1750.10-FF-000113', NULL, 'Uncharacterized protein', 26, NULL, NULL, 71301),
(71302, '3.30.420.10-FF-000092', NULL, '3''-5'' exonuclease', 201, NULL, NULL, 71302),
(71303, '1.10.10.990-FF-000007', NULL, 'RecBCD enzyme subunit RecC', 68, NULL, NULL, 71303),
(71304, '2.130.10.10-FF-003240', NULL, 'Uncharacterized protein', 388, NULL, NULL, 71304),
(71305, '3.90.190.10-FF-000099', NULL, 'Blast:Cyclin-G-associated kinase', 175, NULL, NULL, 71305),
(71306, '3.40.30.10-FF-000449', NULL, 'Protein disulfide isomerase', 90, NULL, NULL, 71306),
(71307, '3.40.640.10-FF-000347', NULL, 'Cys/Met metabolism pyridoxal-phosphate-dependent protein', 234, NULL, NULL, 71307),
(71308, '3.40.50.1110-FF-000082', NULL, 'GDSL esterase/lipase At4g30140', 312, NULL, NULL, 71308),
(71309, '1.50.40.10-FF-000454', NULL, 'Uncharacterized protein', 104, NULL, NULL, 71309),
(71310, '2.60.40.3120-FF-000006', NULL, 'Cytosolic carboxypeptidase 1', 152, NULL, NULL, 71310),
(71311, '3.40.190.170-FF-000010', NULL, 'Alpha-keto acid-binding periplasmic protein TakP', 187, NULL, NULL, 71311),
(71312, '3.90.1140.10-FF-000027', NULL, 'RNA ligase/cyclic nucleotide phosphodiesterase family protein', 179, NULL, NULL, 71312),
(71313, '3.10.450.350-FF-000007', NULL, 'Lysine transporter LysM', 93, NULL, NULL, 71313);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(71314, '3.30.230.10-FF-000257', NULL, 'Phosphomevalonate kinase', 317, NULL, NULL, 71314),
(71315, '1.10.1520.10-FF-000015', NULL, 'Dicer-like protein 1', 163, NULL, NULL, 71315),
(71316, '2.30.130.10-FF-000023', NULL, 'Glutamate 5-kinase', 97, NULL, NULL, 71316),
(71317, '2.40.30.10-FF-000199', NULL, 'Ferredoxin--NADP reductase', 137, NULL, NULL, 71317),
(71318, '1.10.10.430-FF-000008', NULL, 'protein phosphatase 1A-like isoform X2', 78, NULL, NULL, 71318),
(71319, '3.90.550.50-FF-000015', NULL, 'Beta-1,3-galactosyltransferase GALT1', 230, NULL, NULL, 71319),
(71320, '1.20.1270.340-FF-000003', NULL, NULL, 106, NULL, NULL, 71320),
(71321, '3.40.50.300-FF-003307', NULL, 'Putative metal ion ABC transporter, ATP-binding protein', 217, NULL, NULL, 71321),
(71322, '3.10.50.40-FF-000011', NULL, 'Peptidylprolyl isomerase', 122, NULL, NULL, 71322),
(71323, '2.40.50.140-FF-000548', NULL, 'Protein CBG11069', 116, NULL, NULL, 71323),
(71324, '3.60.10.10-FF-000195', NULL, 'Endonuclease', 288, NULL, NULL, 71324),
(71325, '2.130.10.10-FF-002256', NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', 310, NULL, NULL, 71325),
(71326, '3.30.420.40-FF-001028', NULL, 'Uncharacterized protein', 37, NULL, NULL, 71326),
(71327, '3.10.20.770-FF-000020', NULL, 'Phosphatidylinositol 3-kinase class, putative', 157, NULL, NULL, 71327),
(71328, '3.90.1600.10-FF-000069', NULL, 'DNA polymerase', 63, NULL, NULL, 71328),
(71329, '1.50.10.10-FF-000065', NULL, 'Phosphorylase b kinase regulatory subunit', 383, NULL, NULL, 71329),
(71330, '1.10.1420.10-FF-000159', NULL, 'MutS domain III family protein', 183, NULL, NULL, 71330),
(71331, '3.40.50.300-FF-002907', NULL, 'Protein CBG02097', 209, NULL, NULL, 71331),
(71332, '3.40.50.1000-FF-000846', NULL, NULL, 64, NULL, NULL, 71332),
(71333, '3.40.50.920-FF-000059', NULL, '2-oxoacid ferredoxin oxidoreductase alpha subunit', 98, NULL, NULL, 71333),
(71334, '1.10.20.10-FF-000011', NULL, 'Transcription initiation factor TFIID subunit 12', 76, NULL, NULL, 71334),
(71335, '2.60.40.1230-FF-000001', NULL, 'ADP-ribosylation factor-binding protein GGA1 isoform 1', 153, NULL, NULL, 71335),
(71336, '3.40.50.1110-FF-000115', NULL, 'Uncharacterized protein', 104, NULL, NULL, 71336),
(71337, '3.30.70.330-FF-000686', NULL, 'RNA-binding protein, putative', 96, NULL, NULL, 71337),
(71338, '1.20.1740.10-FF-000248', NULL, 'Uncharacterized protein', 323, NULL, NULL, 71338),
(71339, '2.60.40.1400-FF-000018', NULL, NULL, 61, NULL, NULL, 71339),
(71340, '1.20.1070.10-FF-000871', NULL, 'Uncharacterized protein', 81, NULL, NULL, 71340),
(71341, '3.30.2350.10-FF-000035', NULL, 'tRNA pseudouridine synthase B', 221, NULL, NULL, 71341),
(71342, '3.40.50.10490-FF-000157', NULL, NULL, 54, NULL, NULL, 71342),
(71343, '1.10.287.550-FF-000011', NULL, 'Steroid sulfatase (microsomal), isozyme S', 55, NULL, NULL, 71343),
(71344, '3.30.70.1230-FF-000159', NULL, 'Uncharacterized protein', 63, NULL, NULL, 71344),
(71345, '1.10.150.180-FF-000002', NULL, 'Natural cytotoxicity triggering receptor 3 ligand 1', 94, NULL, NULL, 71345),
(71346, '1.10.287.4070-FF-000006', NULL, 'U4/U6 small nuclear ribonucleoprotein PRP31', 140, NULL, NULL, 71346),
(71347, '3.30.390.150-FF-000006', NULL, 'Pulmonary surfactant-associated protein C', 109, NULL, NULL, 71347),
(71348, '1.10.10.410-FF-000002', NULL, 'Aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase subunit B', 62, NULL, NULL, 71348),
(71349, '3.30.70.2520-FF-000001', NULL, 'L-gulonolactone oxidase', 96, NULL, NULL, 71349),
(71350, '1.25.10.10-FF-003147', NULL, 'Diguanylate cyclase', 78, NULL, NULL, 71350),
(71351, '2.130.10.10-FF-003801', NULL, 'Uncharacterized protein', 310, NULL, NULL, 71351),
(71352, '3.40.50.300-FF-007017', NULL, 'Uncharacterized protein', 305, NULL, NULL, 71352),
(71353, '3.40.50.300-FF-007202', NULL, 'Putative ATP-dependent RNA helicase C25D12.06', 285, NULL, NULL, 71353),
(71354, '3.40.50.1000-FF-000138', NULL, 'HAD-superfamily hydrolase, subfamily IIA', 159, NULL, NULL, 71354),
(71355, '1.10.10.10-FF-000566', NULL, 'Response regulator receiver domain protein', 105, NULL, NULL, 71355);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(71356, '1.25.10.10-FF-003332', NULL, 'Uncharacterized protein', 279, NULL, NULL, 71356),
(71357, '2.170.270.10-FF-000056', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-4 specific', 254, NULL, NULL, 71357),
(71358, '1.10.1200.10-FF-000143', NULL, 'Acyl carrier protein', 88, NULL, NULL, 71358),
(71359, '2.30.40.10-FF-000166', NULL, 'Uncharacterized protein', 65, NULL, NULL, 71359),
(71360, '3.40.920.10-FF-000004', NULL, 'Sulfite reductase [NADPH] flavoprotein component', 197, NULL, NULL, 71360),
(71361, '3.40.50.10330-FF-000103', NULL, 'Ceramide kinase-like isoform 2', 58, NULL, NULL, 71361),
(71362, '3.60.15.10-FF-000076', NULL, 'Cleavage and polyadenylation specificity factor,putative', 224, NULL, NULL, 71362),
(71363, '3.40.50.80-FF-000196', NULL, 'Ferric reduction oxidase 8, mitochondrial', 116, NULL, NULL, 71363),
(71364, '3.30.70.330-FF-002631', NULL, NULL, 177, NULL, NULL, 71364),
(71365, '3.40.50.620-FF-000615', NULL, 'FAD synthase', 248, NULL, NULL, 71365),
(71366, '3.10.129.110-FF-000018', NULL, 'Polyketide synthase RzxE', 304, NULL, NULL, 71366),
(71367, '3.30.40.10-FF-000416', NULL, 'RBR-type E3 ubiquitin transferase', 103, NULL, NULL, 71367),
(71368, '1.10.238.10-FF-000410', NULL, 'Secretory pathway protein Ssp120, putative', 89, NULL, NULL, 71368),
(71369, '1.10.3660.10-FF-000020', NULL, 'Prephenate dehydrogenase', 100, NULL, NULL, 71369),
(71370, '1.20.58.60-FF-000657', NULL, 'Uncharacterized protein', 116, NULL, NULL, 71370),
(71371, '2.30.42.10-FF-000148', NULL, 'membrane-associated guanylate kinase, WW and PDZ domain-containing protein 3 isoform X1', 92, NULL, NULL, 71371),
(71372, '1.20.58.60-FF-000842', NULL, 'Uncharacterized protein', 305, NULL, NULL, 71372),
(71373, '3.40.50.150-FF-001587', NULL, NULL, 39, NULL, NULL, 71373),
(71374, '3.90.1170.40-FF-000010', NULL, 'Molybdopterin synthase, large subunit', 127, NULL, NULL, 71374),
(71375, '3.40.190.10-FF-000273', NULL, 'Oligopeptide ABC transporter, oligopeptide-binding protein AliB', 302, NULL, NULL, 71375),
(71376, '2.30.42.10-FF-000356', NULL, 'Uncharacterized protein', 68, NULL, NULL, 71376),
(71377, '3.90.226.10-FF-000076', NULL, 'Enoyl-CoA hydratase', 216, NULL, NULL, 71377),
(71378, '3.30.1520.10-FF-000014', NULL, 'Sorting nexin 13', 126, NULL, NULL, 71378),
(71379, '2.130.10.10-FF-005870', NULL, 'Two-component system sensor histidine kinase', 307, NULL, NULL, 71379),
(71380, '3.30.1640.10-FF-000080', NULL, 'DNA helicase', 91, NULL, NULL, 71380),
(71381, '2.60.40.180-FF-000014', NULL, 'Uncharacterized protein', 160, NULL, NULL, 71381),
(71382, '3.20.20.80-FF-000026', NULL, 'galactocerebrosidase precursor', 248, NULL, NULL, 71382),
(71383, '2.130.10.10-FF-001587', NULL, 'Uncharacterized protein, isoform A', 331, NULL, NULL, 71383),
(71384, '1.25.40.10-FF-000866', NULL, 'Uncharacterized protein, isoform A', 201, NULL, NULL, 71384),
(71385, '3.30.230.70-FF-000084', NULL, 'Predicted protein', 134, NULL, NULL, 71385),
(71386, '3.80.10.10-FF-001666', NULL, 'Receptor kinase-like protein Xa21', 126, NULL, NULL, 71386),
(71387, '3.40.50.300-FF-002498', NULL, 'Uncharacterized protein', 265, NULL, NULL, 71387),
(71388, '3.90.380.10-FF-000018', NULL, 'Benzoate 1,2-dioxygenase large subunit', 244, NULL, NULL, 71388),
(71389, '3.30.70.330-FF-001962', NULL, NULL, 119, NULL, NULL, 71389),
(71390, '3.40.30.10-FF-001169', NULL, 'Uncharacterized protein', 87, NULL, NULL, 71390),
(71391, '3.40.50.300-FF-002610', NULL, 'Deoxyguanosine kinase/deoxyadenosine kinase subunit, putative', 203, NULL, NULL, 71391),
(71392, '2.60.40.60-FF-000477', NULL, 'Cadherin-87A', 127, NULL, NULL, 71392),
(71393, '1.10.560.10-FF-000041', NULL, 'T-complex protein 1 subunit delta', 180, NULL, NULL, 71393),
(71394, '3.30.200.20-FF-000674', NULL, 'BUD32 protein kinase', 73, NULL, NULL, 71394),
(71395, '3.30.160.60-FF-000491', NULL, 'zinc finger matrin-type protein 2-like', 39, NULL, NULL, 71395),
(71396, '3.90.1150.10-FF-000472', NULL, 'Perosamine synthetase-related protein', 112, NULL, NULL, 71396),
(71397, '3.40.50.300-FF-003066', NULL, 'Small GTPase EhRabX2, putative', 203, NULL, NULL, 71397);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(71398, '2.70.98.10-FF-000073', NULL, 'Uncharacterized protein', 389, NULL, NULL, 71398),
(71399, '2.60.120.260-FF-000429', NULL, 'Probable beta-galactosidase 2', 158, NULL, NULL, 71399),
(71400, '4.10.280.110-FF-000013', NULL, 'WD domain, G-beta repeat-containing protein', 68, NULL, NULL, 71400),
(71401, '1.25.40.120-FF-000097', NULL, 'Uncharacterized protein', 142, NULL, NULL, 71401),
(71402, '3.40.20.10-FF-000044', NULL, 'Cofilin/actin-depolymerizing factor homolog', 148, NULL, NULL, 71402),
(71403, '3.30.40.10-FF-001928', NULL, 'Uncharacterized protein', 110, NULL, NULL, 71403),
(71404, '2.40.160.10-FF-000039', NULL, 'Porin', 414, NULL, NULL, 71404),
(71405, '3.40.50.620-FF-000790', NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', 331, NULL, NULL, 71405),
(71406, '3.40.50.450-FF-000047', NULL, '6-phosphofructokinase', 275, NULL, NULL, 71406),
(71407, '1.10.238.10-FF-001074', NULL, 'Uncharacterized protein', 121, NULL, NULL, 71407),
(71408, '3.40.1410.10-FF-000026', NULL, 'GntR family transcriptional regulator', 159, NULL, NULL, 71408),
(71409, '1.10.1670.40-FF-000006', NULL, 'DNA-3-methyladenine glycosylase', 84, NULL, NULL, 71409),
(71410, '1.10.510.10-FF-002567', NULL, 'Protein kinase domain-containing protein (AFU_orthologue AFUA_3G08710)', 259, NULL, NULL, 71410),
(71411, '1.10.287.70-FF-000148', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 183, NULL, NULL, 71411),
(71412, '3.30.1490.180-FF-000025', NULL, 'DNA-directed RNA polymerase subunit', 53, NULL, NULL, 71412),
(71413, '3.30.160.60-FF-003245', NULL, 'Oocyte zinc finger protein XlCOF28', 30, NULL, NULL, 71413),
(71414, '3.60.10.10-FF-000048', NULL, 'Type I inositol polyphosphate 5-phosphatase 2', 314, NULL, NULL, 71414),
(71415, '2.60.120.10-FF-000375', NULL, 'Cyclic Nucleotide Gated channel', 139, NULL, NULL, 71415),
(71416, '3.20.20.80-FF-000465', NULL, 'Carbohydrate hydrolase-related protein', 378, NULL, NULL, 71416),
(71417, '2.60.40.10-FF-000002', NULL, 'Titin a', 97, NULL, NULL, 71417),
(71418, '2.10.25.10-FF-001278', NULL, 'Low-density lipoprotein RecePtor related', 42, NULL, NULL, 71418),
(71419, '3.30.160.60-FF-001480', NULL, 'Si:cabz01071911.3', 30, NULL, NULL, 71419),
(71420, '3.30.40.10-FF-001024', NULL, 'Uncharacterized protein', 85, NULL, NULL, 71420),
(71421, '3.40.50.720-FF-000943', NULL, 'Oxidoreductase-like protein', 155, NULL, NULL, 71421),
(71422, '3.30.1490.40-FF-000008', NULL, 'Lin1p', 66, NULL, NULL, 71422),
(71423, '3.80.10.10-FF-001615', NULL, 'F-box protein SKP2A isoform A', 217, NULL, NULL, 71423),
(71424, '3.30.559.10-FF-000233', NULL, 'Uncharacterized protein', 167, NULL, NULL, 71424),
(71425, '1.20.1250.20-FF-000202', NULL, 'Solute carrier organic anion transporter family member', 378, NULL, NULL, 71425),
(71426, '1.10.287.70-FF-000569', NULL, 'Uncharacterized protein', 150, NULL, NULL, 71426),
(71427, '2.60.120.970-FF-000030', NULL, 'Glass bottom boat', 265, NULL, NULL, 71427),
(71428, '2.70.98.10-FF-000022', NULL, 'Glucose-6-phosphate 1-epimerase', 286, NULL, NULL, 71428),
(71429, '3.30.200.20-FF-001663', NULL, 'Kinase, NEK', 85, NULL, NULL, 71429),
(71430, '3.40.30.10-FF-001118', NULL, 'Uncharacterized protein', 11, NULL, NULL, 71430),
(71431, '1.20.1500.20-FF-000003', NULL, 'Antiviral helicase SKI2', 83, NULL, NULL, 71431),
(71432, '1.50.10.10-FF-000121', NULL, 'Putative large secreted protein', 164, NULL, NULL, 71432),
(71433, '2.130.10.10-FF-002104', NULL, 'WD repeat protein', 109, NULL, NULL, 71433),
(71434, '3.30.160.20-FF-000147', NULL, 'Predicted protein', 111, NULL, NULL, 71434),
(71435, '3.30.70.1730-FF-000011', NULL, '50S ribosomal protein L10, putative', 133, NULL, NULL, 71435),
(71436, '3.30.1490.20-FF-000020', NULL, 'Protein lysine acetyltransferase', 78, NULL, NULL, 71436),
(71437, '2.60.40.10-FF-004217', NULL, NULL, 72, NULL, NULL, 71437),
(71438, '2.60.40.10-FF-000423', NULL, 'Fibroblast growth factor receptor', 89, NULL, NULL, 71438),
(71439, '2.60.40.3170-FF-000009', NULL, 'Tripeptidyl-peptidase 2', 127, NULL, NULL, 71439),
(71440, '3.30.565.10-FF-000293', NULL, 'Histidine kinase', 133, NULL, NULL, 71440);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(71441, '1.10.3210.10-FF-000121', NULL, 'Predicted protein', 55, NULL, NULL, 71441),
(71442, '4.10.10.10-FF-000003', NULL, 'Metallothionein', 34, NULL, NULL, 71442),
(71443, '3.40.50.450-FF-000098', NULL, 'Uncharacterized protein', 75, NULL, NULL, 71443),
(71444, '1.50.40.10-FF-000302', NULL, 'Mitochondrial substrate carrier family protein S', 278, NULL, NULL, 71444),
(71445, '3.40.1190.20-FF-000118', NULL, 'Multifunctional fusion protein', 281, NULL, NULL, 71445),
(71446, '2.30.30.1190-FF-000001', NULL, 'zinc finger CCCH-type with G patch domain-containing protein', 86, NULL, NULL, 71446),
(71447, '3.40.309.10-FF-000084', NULL, 'Uncharacterized protein', 170, NULL, NULL, 71447),
(71448, '3.20.20.80-FF-000414', NULL, 'Beta-galactosidase BoGH2A', 319, NULL, NULL, 71448),
(71449, '3.60.130.10-FF-000074', NULL, 'Predicted protein', 56, NULL, NULL, 71449),
(71450, '1.20.58.340-FF-000020', NULL, 'Magnesium transport protein CorA', 115, NULL, NULL, 71450),
(71451, '3.30.160.60-FF-002289', NULL, 'Zinc finger protein 813', 63, NULL, NULL, 71451),
(71452, '1.20.120.1240-FF-000055', NULL, 'Dynamin-A', 262, NULL, NULL, 71452),
(71453, '3.100.10.10-FF-000011', NULL, '50S ribosomal subunit protein L15', 86, NULL, NULL, 71453),
(71454, '3.40.190.80-FF-000092', NULL, 'Inositol-1-monophosphatase', 85, NULL, NULL, 71454),
(71455, '1.10.640.10-FF-000042', NULL, 'Protein CBR-PXN-2', 280, NULL, NULL, 71455),
(71456, '2.60.200.20-FF-000266', NULL, 'Zgc:165656', 30, NULL, NULL, 71456),
(71457, '3.40.50.300-FF-006825', NULL, 'Sulfotransferase', 275, NULL, NULL, 71457),
(71458, '1.25.40.180-FF-000328', NULL, NULL, 176, NULL, NULL, 71458),
(71459, '1.10.510.10-FF-001999', NULL, 'Serine/threonine protein kinase', 192, NULL, NULL, 71459),
(71460, '2.60.40.2030-FF-000061', NULL, 'Predicted protein', 127, NULL, NULL, 71460),
(71461, '2.60.120.290-FF-000005', NULL, 'Procollagen C-endopeptidase enhancer 1', 112, NULL, NULL, 71461),
(71462, '3.40.50.300-FF-003807', NULL, 'Predicted protein', 81, NULL, NULL, 71462),
(71463, '3.40.50.1820-FF-000199', NULL, 'Hormone-sensitive lipase', 136, NULL, NULL, 71463),
(71464, '2.60.120.260-FF-000530', NULL, 'AE binding protein 1', 90, NULL, NULL, 71464),
(71465, '2.60.40.10-FF-004638', NULL, NULL, 97, NULL, NULL, 71465),
(71466, '1.10.45.10-FF-000006', NULL, 'FAD-linked oxidoreductase', 37, NULL, NULL, 71466),
(71467, '3.40.50.2000-FF-000596', NULL, 'UDP-GlucuronosylTransferase', 171, NULL, NULL, 71467),
(71468, '2.60.120.200-FF-000198', NULL, 'Probable L-type lectin-domain containing receptor kinase S.5', 241, NULL, NULL, 71468),
(71469, '1.25.40.10-FF-003188', NULL, 'Putative pentatricopeptide repeat family protein', 96, NULL, NULL, 71469),
(71470, '3.90.132.10-FF-000021', NULL, 'GP63-like', 120, NULL, NULL, 71470),
(71471, '2.130.10.10-FF-004021', NULL, 'Uncharacterized protein', 222, NULL, NULL, 71471),
(71472, '3.40.50.2300-FF-001085', NULL, 'Uncharacterized protein', 298, NULL, NULL, 71472),
(71473, '3.90.640.10-FF-000117', NULL, 'Heat shock protein 70, putative', 92, NULL, NULL, 71473),
(71474, '3.90.550.10-FF-000470', NULL, 'Glycosyl transferase family 2', 218, NULL, NULL, 71474),
(71475, '3.30.800.10-FF-000014', NULL, 'Putative phosphatidylinositol (3,5) kinase', 160, NULL, NULL, 71475),
(71476, '1.10.510.10-FF-002516', NULL, 'Uncharacterized protein', 299, NULL, NULL, 71476),
(71477, '1.20.1560.10-FF-000190', NULL, 'ABC multidrug transporter, putative', 333, NULL, NULL, 71477),
(71478, '1.10.287.110-FF-000110', NULL, 'DnaJ domain protein (AFU_orthologue AFUA_2G13210)', 100, NULL, NULL, 71478),
(71479, '3.40.1380.20-FF-000032', NULL, 'Pyruvate kinase', 129, NULL, NULL, 71479),
(71480, '3.40.1810.10-FF-000074', NULL, NULL, 92, NULL, NULL, 71480),
(71481, '3.30.160.60-FF-001379', NULL, 'zinc finger X-linked protein ZXDB', 28, NULL, NULL, 71481),
(71482, '1.25.40.10-FF-002732', NULL, 'Uncharacterized protein', 273, NULL, NULL, 71482),
(71483, '2.60.40.10-FF-002340', NULL, 'Unc-5 netrin receptor A', 48, NULL, NULL, 71483),
(71484, '1.10.287.110-FF-000222', NULL, 'HscB mitochondrial iron-sulfur cluster cochaperone', 78, NULL, NULL, 71484);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(71485, '1.10.840.10-FF-000023', NULL, 'Rho GTPase-activating protein', 224, NULL, NULL, 71485),
(71486, '3.30.720.150-FF-000004', NULL, 'UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase 110 kDa subunit', 113, NULL, NULL, 71486),
(71487, '3.40.50.720-FF-002500', NULL, 'Protein CLP1 homolog', 146, NULL, NULL, 71487),
(71488, '2.60.40.790-FF-000135', NULL, NULL, 135, NULL, NULL, 71488),
(71489, '2.20.70.10-FF-000163', NULL, 'Histone-lysine N-methyltransferase', 38, NULL, NULL, 71489),
(71490, '1.10.274.30-FF-000005', NULL, 'Chromatin modification-related protein EAF3', 164, NULL, NULL, 71490),
(71491, '3.10.20.90-FF-000496', NULL, 'Ubiquitin family protein', 73, NULL, NULL, 71491),
(71492, '3.10.20.30-FF-000001', NULL, 'Ribosome-binding ATPase YchF', 102, NULL, NULL, 71492),
(71493, '3.30.160.60-FF-001851', NULL, 'Zinc finger protein 418', 29, NULL, NULL, 71493),
(71494, '3.80.10.10-FF-004521', NULL, 'F-box only protein 39-like Protein', 333, NULL, NULL, 71494),
(71495, '1.20.1050.80-FF-000020', NULL, 'Vacuolar protein sorting-associated protein 9b', 185, NULL, NULL, 71495),
(71496, '1.10.510.10-FF-004484', NULL, NULL, 325, NULL, NULL, 71496),
(71497, '3.40.50.360-FF-000172', NULL, 'NAD(P)H dehydrogenase, quinone 1', 178, NULL, NULL, 71497),
(71498, '1.25.40.420-FF-000029', NULL, 'KLHL34 isoform 1', 105, NULL, NULL, 71498),
(71499, '1.10.10.10-FF-001022', NULL, 'Transcriptional regulator, LysR family', 88, NULL, NULL, 71499),
(71500, '1.20.1070.10-FF-001624', NULL, 'Corticotropin releasing factor receptor, putative', 143, NULL, NULL, 71500),
(71501, '1.25.40.860-FF-000026', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 69, NULL, NULL, 71501),
(71502, '1.25.10.10-FF-001562', NULL, 'Uncharacterized protein', 148, NULL, NULL, 71502),
(71503, '3.30.70.330-FF-002367', NULL, NULL, 104, NULL, NULL, 71503),
(71504, '3.10.20.30-FF-000113', NULL, NULL, 39, NULL, NULL, 71504),
(71505, '3.30.300.30-FF-000095', NULL, 'Probable non-ribosomal peptide synthetase', 107, NULL, NULL, 71505),
(71506, '3.30.70.330-FF-001170', NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', 99, NULL, NULL, 71506),
(71507, '3.30.160.20-FF-000198', NULL, 'Uncharacterized protein', 65, NULL, NULL, 71507),
(71508, '3.30.450.200-FF-000025', NULL, NULL, 140, NULL, NULL, 71508),
(71509, '3.30.460.90-FF-000011', NULL, 'Mitochondrial elongation factor 2', 105, NULL, NULL, 71509),
(71510, '2.30.30.100-FF-000068', NULL, 'Small nuclear ribonucleoprotein Sm D1', 88, NULL, NULL, 71510),
(71511, '4.10.400.10-FF-000029', NULL, 'prolow-density lipoprotein receptor-related protein 1', 38, NULL, NULL, 71511),
(71512, '2.60.40.10-FF-000827', NULL, 'Immunoglobulin superfamily member 3', 115, NULL, NULL, 71512),
(71513, '1.10.443.10-FF-000016', NULL, 'Integrase', 141, NULL, NULL, 71513),
(71514, '1.20.1420.20-FF-000002', NULL, 'Iron-regulated protein A', 393, NULL, NULL, 71514),
(71515, '1.25.40.20-FF-001600', NULL, 'Ankyrin repeat and LEM domain-containing protein 1 homolog', 112, NULL, NULL, 71515),
(71516, '1.10.287.130-FF-000228', NULL, 'Sensory transduction histidine kinase', 68, NULL, NULL, 71516),
(71517, '1.10.8.60-FF-000428', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 83, NULL, NULL, 71517),
(71518, '3.10.20.90-FF-000384', NULL, 'Partitioning defective protein 3', 89, NULL, NULL, 71518),
(71519, '1.20.140.10-FF-000024', NULL, 'Flavin-dependent monooxygenase', 185, NULL, NULL, 71519),
(71520, '3.40.50.2000-FF-000545', NULL, 'Alpha-1,4 glucan phosphorylase', 281, NULL, NULL, 71520),
(71521, '3.30.40.10-FF-001136', NULL, 'PHd Finger family', 61, NULL, NULL, 71521),
(71522, '3.40.250.10-FF-000211', NULL, 'Uncharacterized protein', 100, NULL, NULL, 71522),
(71523, '2.60.40.10-FF-002391', NULL, 'Muscle M-line assembly protein unc-89', 94, NULL, NULL, 71523),
(71524, '3.40.50.300-FF-003015', NULL, 'Origin recognition complex subunit 4', 179, NULL, NULL, 71524),
(71525, '3.30.450.20-FF-000074', NULL, 'Aryl hydrocarbon receptor', 145, NULL, NULL, 71525),
(71526, '1.10.472.80-FF-000025', NULL, 'TBC1 domain family member 15', 130, NULL, NULL, 71526);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(71527, '2.60.40.10-FF-003649', NULL, NULL, 97, NULL, NULL, 71527),
(71528, '3.20.20.140-FF-000104', NULL, 'Hydrolase', 303, NULL, NULL, 71528),
(71529, '1.10.357.10-FF-000074', NULL, 'Transcriptional repressor, TetR family', 187, NULL, NULL, 71529),
(71530, '1.25.40.10-FF-002783', NULL, 'Intraflagellar transport particle protein IFT88', 229, NULL, NULL, 71530),
(71531, '2.130.10.10-FF-005010', NULL, 'Uncharacterized protein', 42, NULL, NULL, 71531),
(71532, '1.20.5.110-FF-000148', NULL, 'Molecular chaperone HscB', 65, NULL, NULL, 71532),
(71533, '3.30.160.60-FF-004638', NULL, NULL, 24, NULL, NULL, 71533),
(71534, '2.170.260.10-FF-000027', NULL, 'Endoribonuclease Dicer-like Protein', 116, NULL, NULL, 71534),
(71535, '3.30.70.330-FF-001911', NULL, NULL, 72, NULL, NULL, 71535),
(71536, '2.120.10.80-FF-000068', NULL, 'Kelch-like 6 (Drosophila) (Predicted)', 286, NULL, NULL, 71536),
(71537, '1.10.357.70-FF-000013', NULL, 'Exocyst complex component 3', 178, NULL, NULL, 71537),
(71538, '2.40.30.10-FF-000339', NULL, 'Uncharacterized protein', 87, NULL, NULL, 71538),
(71539, '2.130.10.10-FF-001536', NULL, 'Phosphoinositide 3-kinase regulatory subunit 4', 112, NULL, NULL, 71539),
(71540, '3.40.20.10-FF-000095', NULL, 'Twinfilin', 133, NULL, NULL, 71540),
(71541, '1.25.10.10-FF-002551', NULL, 'Sister chromatid cohesion protein', 177, NULL, NULL, 71541),
(71542, '2.90.10.30-FF-000010', NULL, 'Uncharacterized protein', 87, NULL, NULL, 71542),
(71543, '3.50.30.50-FF-000005', NULL, 'Cyclase family protein', 226, NULL, NULL, 71543),
(71544, '2.130.10.10-FF-004521', NULL, 'Uncharacterized protein', 231, NULL, NULL, 71544),
(71545, '3.30.70.270-FF-000022', NULL, 'DNA polymerase eta', 178, NULL, NULL, 71545),
(71546, '3.30.1240.10-FF-000032', NULL, 'Cof-type HAD-IIB family hydrolase', 128, NULL, NULL, 71546),
(71547, '3.30.930.10-FF-000226', NULL, 'Biotin--[acetyl-CoA-carboxylase] ligase', 233, NULL, NULL, 71547),
(71548, '3.60.21.10-FF-000225', NULL, 'Serine/threonine-protein phosphatase', 302, NULL, NULL, 71548),
(71549, '3.40.630.10-FF-000257', NULL, 'Uncharacterized protein', 120, NULL, NULL, 71549),
(71550, '3.30.310.50-FF-000011', NULL, 'Transcription factor Pcc1', 105, NULL, NULL, 71550),
(71551, '1.20.1260.10-FF-000026', NULL, 'Ring oxydation complex/ phenylacetic acid degradation', 234, NULL, NULL, 71551),
(71552, '3.40.30.10-FF-000713', NULL, 'Eef-1G', 68, NULL, NULL, 71552),
(71553, '1.10.220.30-FF-000038', NULL, 'Flagellar motor switch protein FliG', 81, NULL, NULL, 71553),
(71554, '1.20.1720.10-FF-000106', NULL, NULL, 167, NULL, NULL, 71554),
(71555, '3.20.20.190-FF-000125', NULL, NULL, 230, NULL, NULL, 71555),
(71556, '3.40.50.2300-FF-001034', NULL, NULL, 217, NULL, NULL, 71556),
(71557, '3.30.1600.10-FF-000015', NULL, 'NAD-dependent protein deacylase', 140, NULL, NULL, 71557),
(71558, '1.10.10.10-FF-001994', NULL, 'Uncharacterized protein', 35, NULL, NULL, 71558),
(71559, '3.40.50.2300-FF-000545', NULL, 'Sensor histidine kinase', 122, NULL, NULL, 71559),
(71560, '2.60.120.740-FF-000011', NULL, 'Beta-galactosidase 7', 92, NULL, NULL, 71560),
(71561, '1.10.287.1040-FF-000013', NULL, 'Exodeoxyribonuclease 7 small subunit', 65, NULL, NULL, 71561),
(71562, '3.30.70.980-FF-000055', NULL, 'Probable transcriptional regulatory protein BEST7613_5720', 76, NULL, NULL, 71562),
(71563, '2.40.10.10-FF-000377', NULL, NULL, 100, NULL, NULL, 71563),
(71564, '3.30.230.70-FF-000016', NULL, 'Exosome complex component RRP42', 284, NULL, NULL, 71564),
(71565, '1.25.40.20-FF-000695', NULL, 'Multiple ankyrin repeats single KH domain, isoform E', 174, NULL, NULL, 71565),
(71566, '1.10.400.10-FF-000029', NULL, 'guanine nucleotide-binding protein G(Olf) subunit alpha', 61, NULL, NULL, 71566),
(71567, '3.30.470.20-FF-000036', NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', 204, NULL, NULL, 71567),
(71568, '1.25.40.10-FF-001322', NULL, 'Pentatricopeptide repeat-containing protein At3g16610', 120, NULL, NULL, 71568),
(71569, '3.40.50.150-FF-001183', NULL, NULL, 119, NULL, NULL, 71569),
(71570, '3.30.160.60-FF-002789', NULL, 'tRNA dimethylallyltransferase', 46, NULL, NULL, 71570);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(71571, '1.10.1670.10-FF-000059', NULL, NULL, 84, NULL, NULL, 71571),
(71572, '2.120.10.30-FF-000435', NULL, 'Predicted protein', 127, NULL, NULL, 71572),
(71573, '3.10.20.90-FF-000884', NULL, 'Uncharacterized protein', 57, NULL, NULL, 71573),
(71574, '1.10.510.10-FF-002016', NULL, 'Uncharacterized protein', 216, NULL, NULL, 71574),
(71575, '3.40.33.10-FF-000074', NULL, 'Si:dkey-2n12.1 protein', 144, NULL, NULL, 71575),
(71576, '3.40.50.150-FF-001475', NULL, NULL, 129, NULL, NULL, 71576),
(71577, '3.30.70.260-FF-000114', NULL, 'Glycine cleavage system regulatory protein', 87, NULL, NULL, 71577),
(71578, '3.10.129.10-FF-000166', NULL, 'PaaI family thioesterase', 131, NULL, NULL, 71578),
(71579, '3.50.50.60-FF-000156', NULL, 'Salicylate hydroxylase, putative', 373, NULL, NULL, 71579),
(71580, '2.60.40.10-FF-003296', NULL, 'Immunoglobulin superfamily, member 3', 130, NULL, NULL, 71580),
(71581, '3.30.420.40-FF-000483', NULL, 'DnaK protein', 118, NULL, NULL, 71581),
(71582, '1.20.1250.20-FF-001990', NULL, 'Major facilitator superfamily domain-containing protein 12-like Protein', 388, NULL, NULL, 71582),
(71583, '2.40.10.340-FF-000004', NULL, 'Cell shape-determining protein MreC', 60, NULL, NULL, 71583),
(71584, '2.30.18.10-FF-000007', NULL, 'TOA1p TFIIA large subunit', 63, NULL, NULL, 71584),
(71585, '3.30.300.360-FF-000001', NULL, 'DUF2498 family protein', 69, NULL, NULL, 71585),
(71586, '1.25.40.10-FF-003688', NULL, 'TPR Domain containing protein', 227, NULL, NULL, 71586),
(71587, '1.25.10.10-FF-002904', NULL, 'ARM repeat superfamily protein', 127, NULL, NULL, 71587),
(71588, '2.130.10.10-FF-005802', NULL, 'Uncharacterized protein', 88, NULL, NULL, 71588),
(71589, '3.40.309.10-FF-000016', NULL, 'NADP-dependent glyceraldehyde-3-phosphate dehydrogenase', 191, NULL, NULL, 71589),
(71590, '1.10.10.60-FF-001076', NULL, NULL, 55, NULL, NULL, 71590),
(71591, '3.30.530.20-FF-000075', NULL, 'Phosphatidylinositol transfer protein 2', 277, NULL, NULL, 71591),
(71592, '1.25.40.10-FF-004256', NULL, 'Uncharacterized protein', 227, NULL, NULL, 71592),
(71593, '3.30.200.20-FF-000314', NULL, 'Serine/threonine protein kinase', 107, NULL, NULL, 71593),
(71594, '1.10.287.1060-FF-000019', NULL, 'Snf7, putative', 79, NULL, NULL, 71594),
(71595, '2.60.40.150-FF-000067', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', 154, NULL, NULL, 71595),
(71596, '3.30.342.10-FF-000045', NULL, 'Predicted protein', 185, NULL, NULL, 71596),
(71597, '3.40.50.300-FF-007169', NULL, 'Ras family protein', 173, NULL, NULL, 71597),
(71598, '2.30.29.30-FF-000550', NULL, 'Vacuolar protein-sorting-associated protein 36', 143, NULL, NULL, 71598),
(71599, '3.30.40.10-FF-001996', NULL, 'Uncharacterized protein', 53, NULL, NULL, 71599),
(71600, '3.30.160.60-FF-005162', NULL, NULL, 31, NULL, NULL, 71600),
(71601, '3.10.290.10-FF-000012', NULL, 'Tyrosine--tRNA ligase', 93, NULL, NULL, 71601),
(71602, '2.60.120.10-FF-000779', NULL, 'Uncharacterized protein', 161, NULL, NULL, 71602),
(71603, '3.30.160.60-FF-000131', NULL, 'protein indeterminate-domain 5, chloroplastic-like', 80, NULL, NULL, 71603),
(71604, '2.130.10.10-FF-003953', NULL, 'Protein CBG00124', 243, NULL, NULL, 71604),
(71605, '1.20.1250.20-FF-000702', NULL, 'Sugar transporter family protein', 464, NULL, NULL, 71605),
(71606, '1.10.238.10-FF-001186', NULL, 'Uncharacterized protein', 84, NULL, NULL, 71606),
(71607, '2.60.40.420-FF-000103', NULL, 'H0303G06.17 protein', 106, NULL, NULL, 71607),
(71608, '1.20.1280.290-FF-000092', NULL, 'Seven transmembrane protein 1', 93, NULL, NULL, 71608),
(71609, '1.20.5.190-FF-000166', NULL, NULL, 65, NULL, NULL, 71609),
(71610, '2.70.160.11-FF-000101', NULL, 'Uncharacterized protein', 55, NULL, NULL, 71610),
(71611, '1.20.58.1030-FF-000017', NULL, 'Uncharacterized protein', 196, NULL, NULL, 71611),
(71612, '2.60.200.40-FF-000031', NULL, 'Diacylglycerol kinase', 171, NULL, NULL, 71612),
(71613, '3.30.497.10-FF-000049', NULL, 'GM12900', 78, NULL, NULL, 71613),
(71614, '2.10.25.10-FF-000789', NULL, 'Teratocarcinoma-derived growth factor 1', 36, NULL, NULL, 71614);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(71615, '3.30.160.60-FF-000423', NULL, 'Uncharacterized protein', 28, NULL, NULL, 71615),
(71616, '3.10.129.10-FF-000115', NULL, 'Hydroxyacyl-thioester dehydratase', 115, NULL, NULL, 71616),
(71617, '3.30.40.10-FF-000568', NULL, 'Os12g0140700 protein', 83, NULL, NULL, 71617),
(71618, '3.40.50.12780-FF-000102', NULL, 'ATP-dependent acyl-CoA ligase', 402, NULL, NULL, 71618),
(71619, '3.30.559.70-FF-000032', NULL, 'Uncharacterized protein', 28, NULL, NULL, 71619),
(71620, '1.10.1760.20-FF-000007', NULL, 'Riboflavin transporter', 181, NULL, NULL, 71620),
(71621, '3.90.550.50-FF-000223', NULL, 'Uncharacterized protein, isoform B', 130, NULL, NULL, 71621),
(71622, '1.25.10.10-FF-000134', NULL, 'Integrator complex subunit 4', 186, NULL, NULL, 71622),
(71623, '3.30.70.980-FF-000004', NULL, 'Probable transcriptional regulatory protein YeeN', 71, NULL, NULL, 71623),
(71624, '2.60.120.620-FF-000037', NULL, 'Phytanoyl-CoA_dioxygenase_(PhyH)/2OG-Fe(II )_oxygenase_superfamily_-_putative', 220, NULL, NULL, 71624),
(71625, '1.20.5.170-FF-000059', NULL, 'unconventional myosin-X', 51, NULL, NULL, 71625),
(71626, '3.30.70.2850-FF-000021', NULL, 'DNA-directed RNA polymerase subunit', 159, NULL, NULL, 71626),
(71627, '3.30.720.10-FF-000013', NULL, 'Signal recognition particle 9', 39, NULL, NULL, 71627),
(71628, '1.20.1250.80-FF-000001', NULL, 'Interleukin-34', 186, NULL, NULL, 71628),
(71629, '3.10.100.10-FF-000151', NULL, NULL, 90, NULL, NULL, 71629),
(71630, '1.10.238.10-FF-001135', NULL, 'Uncharacterized protein', 155, NULL, NULL, 71630),
(71631, '3.30.1330.10-FF-000039', NULL, 'Uncharacterized protein', 105, NULL, NULL, 71631),
(71632, '3.30.960.10-FF-000003', NULL, 'Peptide chain release factor subunit 1', 134, NULL, NULL, 71632),
(71633, '1.20.1740.10-FF-000136', NULL, 'Neutral amino acid transporter, putative', 417, NULL, NULL, 71633),
(71634, '1.10.520.10-FF-000044', NULL, 'Peroxidase', 131, NULL, NULL, 71634),
(71635, '2.70.170.10-FF-000292', NULL, 'Uncharacterized protein', 192, NULL, NULL, 71635),
(71636, '3.40.50.10130-FF-000015', NULL, 'SsDNA endonuclease', 120, NULL, NULL, 71636),
(71637, '1.10.600.10-FF-000096', NULL, 'Farnesyl-diphosphate farnesyltransferase', 344, NULL, NULL, 71637),
(71638, '2.120.10.30-FF-000486', NULL, 'Gll2869 protein', 284, NULL, NULL, 71638),
(71639, '2.60.40.10-FF-001851', NULL, 'Peroxidasin', 98, NULL, NULL, 71639),
(71640, '2.60.120.590-FF-000005', NULL, 'Alpha-ketoglutarate-dependent dioxygenase AlkB', 206, NULL, NULL, 71640),
(71641, '2.130.10.10-FF-001036', NULL, 'DDB1-and CUL4-associated factor 13', 110, NULL, NULL, 71641),
(71642, '3.30.750.24-FF-000152', NULL, 'Uncharacterized protein', 125, NULL, NULL, 71642),
(71643, '1.10.287.2480-FF-000001', NULL, 'Fusion glycoprotein F0', 127, NULL, NULL, 71643),
(71644, '3.40.980.10-FF-000013', NULL, 'Molybdopterin molybdenumtransferase', 209, NULL, NULL, 71644),
(71645, '3.40.50.720-FF-001140', NULL, 'dTDP-4-dehydrorhamnose reductase', 218, NULL, NULL, 71645),
(71646, '1.10.510.10-FF-004192', NULL, NULL, 164, NULL, NULL, 71646),
(71647, '3.40.800.20-FF-000026', NULL, 'Acetoin utilization protein AcuC', 348, NULL, NULL, 71647),
(71648, '3.40.50.300-FF-004908', NULL, 'Uncharacterized protein', 323, NULL, NULL, 71648),
(71649, '3.40.50.300-FF-006000', NULL, 'AGAP011652-PA', 175, NULL, NULL, 71649),
(71650, '1.25.40.720-FF-000001', NULL, 'Telomere length regulation protein TEL2', 130, NULL, NULL, 71650),
(71651, '1.20.1070.10-FF-001383', NULL, 'Uncharacterized protein', 250, NULL, NULL, 71651),
(71652, '3.40.50.300-FF-005724', NULL, 'Dynein heavy chain', 161, NULL, NULL, 71652),
(71653, '1.10.10.60-FF-001025', NULL, NULL, 61, NULL, NULL, 71653),
(71654, '1.25.10.10-FF-002955', NULL, 'Uncharacterized protein', 449, NULL, NULL, 71654),
(71655, '3.60.130.10-FF-000006', NULL, 'Clavaminate synthase-like protein At3g21360', 323, NULL, NULL, 71655),
(71656, '1.20.1730.10-FF-000051', NULL, 'Low affinity sodium-glucose cotransporter-like', 411, NULL, NULL, 71656),
(71657, '3.30.2130.30-FF-000002', NULL, 'tRNA sulfurtransferase', 174, NULL, NULL, 71657);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(71658, '3.50.50.60-FF-000105', NULL, 'Kynurenine 3-monooxygenase', 369, NULL, NULL, 71658),
(71659, '2.60.40.10-FF-003700', NULL, NULL, 99, NULL, NULL, 71659),
(71660, '3.40.50.1950-FF-000007', NULL, 'Flavin prenyltransferase UbiX', 214, NULL, NULL, 71660),
(71661, '3.30.70.330-FF-001411', NULL, 'Uncharacterized protein, isoform K', 81, NULL, NULL, 71661),
(71662, '3.40.50.2000-FF-000949', NULL, 'UDP-glycosyltransferase 73C4', 117, NULL, NULL, 71662),
(71663, '3.10.580.10-FF-000170', NULL, 'Chloride channel protein', 69, NULL, NULL, 71663),
(71664, '3.40.390.10-FF-000221', NULL, NULL, 166, NULL, NULL, 71664),
(71665, '1.10.8.10-FF-000234', NULL, 'ATP-dependent protease ATPase subunit HslU2', 20, NULL, NULL, 71665),
(71666, '1.10.3430.10-FF-000036', NULL, 'YALI0A02244p', 437, NULL, NULL, 71666),
(71667, '1.20.58.60-FF-000781', NULL, 'Uncharacterized protein', 222, NULL, NULL, 71667),
(71668, '1.50.10.20-FF-000011', NULL, 'Terpene cyclase/mutase family member', 365, NULL, NULL, 71668),
(71669, '2.30.30.40-FF-000556', NULL, 'Cortactin, putative', 66, NULL, NULL, 71669),
(71670, '2.130.10.10-FF-001615', NULL, 'Protein CBG22378', 328, NULL, NULL, 71670),
(71671, '2.10.60.10-FF-000067', NULL, 'Serine/threonine-protein kinase receptor', 88, NULL, NULL, 71671),
(71672, '3.40.50.300-FF-002110', NULL, 'tRNA dimethylallyltransferase 2', 298, NULL, NULL, 71672),
(71673, '1.20.1560.10-FF-000122', NULL, 'Multidrug ABC transporter ATP-binding protein', 323, NULL, NULL, 71673),
(71674, '1.20.1250.20-FF-000141', NULL, 'Solute carrier family 16, member 4', 196, NULL, NULL, 71674),
(71675, '1.10.238.180-FF-000003', NULL, 'stromal interaction molecule homolog isoform X3', 76, NULL, NULL, 71675),
(71676, '3.40.1030.10-FF-000008', NULL, 'Anthranilate phosphoribosyltransferase, putative', 320, NULL, NULL, 71676),
(71677, '2.60.120.290-FF-000073', NULL, 'Protein bark beetle', 104, NULL, NULL, 71677),
(71678, '2.60.120.200-FF-000086', NULL, 'L-type lectin-domain containing receptor kinase S.4', 247, NULL, NULL, 71678),
(71679, '3.30.1740.10-FF-000025', NULL, 'Poly [ADP-ribose] polymerase', 94, NULL, NULL, 71679),
(71680, '3.40.50.1820-FF-000148', NULL, 'Serine carboxypeptidase-like 11', 420, NULL, NULL, 71680),
(71681, '1.10.8.60-FF-000496', NULL, 'Spastin-like Protein', 84, NULL, NULL, 71681),
(71682, '3.30.870.10-FF-000176', NULL, 'Uncharacterized protein', 176, NULL, NULL, 71682),
(71683, '3.10.20.90-FF-000788', NULL, 'Uncharacterized protein', 58, NULL, NULL, 71683),
(71684, '1.10.510.10-FF-002628', NULL, NULL, 62, NULL, NULL, 71684),
(71685, '3.30.559.10-FF-000172', NULL, 'HC-toxin synthetase', 165, NULL, NULL, 71685),
(71686, '4.10.400.10-FF-000097', NULL, 'Transmembrane serine protease 6', 41, NULL, NULL, 71686),
(71687, '3.40.50.300-FF-004004', NULL, 'DNA repair protein RAD50', 304, NULL, NULL, 71687),
(71688, '1.25.10.10-FF-001674', NULL, 'Protein CBR-EVL-14', 308, NULL, NULL, 71688),
(71689, '2.130.10.10-FF-001087', NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', 333, NULL, NULL, 71689),
(71690, '3.40.50.1820-FF-001660', NULL, 'Serine carboxypeptidase-like 19', 62, NULL, NULL, 71690),
(71691, '3.40.50.2000-FF-000157', NULL, 'Alpha-1,3-glucan synthase, variant', 249, NULL, NULL, 71691),
(71692, '1.20.1070.10-FF-001332', NULL, 'Vomeronasal type-1 receptor', 221, NULL, NULL, 71692),
(71693, '3.30.70.330-FF-001462', NULL, 'AlkB homolog 8, tRNA methyltransferase', 96, NULL, NULL, 71693),
(71694, '2.30.30.1150-FF-000017', NULL, 'Uncharacterized protein', 39, NULL, NULL, 71694),
(71695, '3.90.180.10-FF-000149', NULL, 'Uncharacterized protein', 168, NULL, NULL, 71695),
(71696, '2.60.120.260-FF-000581', NULL, 'Predicted protein', 169, NULL, NULL, 71696),
(71697, '3.80.10.10-FF-003532', NULL, 'Uncharacterized protein', 166, NULL, NULL, 71697),
(71698, '1.20.1560.10-FF-000482', NULL, 'ABC transporter, ATP-binding/membrane protein', 309, NULL, NULL, 71698),
(71699, '3.90.640.10-FF-000229', NULL, 'Uncharacterized protein', 57, NULL, NULL, 71699),
(71700, '1.20.1070.10-FF-001675', NULL, 'Olfactory receptor 541', 122, NULL, NULL, 71700);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(71701, '1.20.58.190-FF-000014', NULL, NULL, 126, NULL, NULL, 71701),
(71702, '3.40.1690.10-FF-000013', NULL, 'EscU/YscU/HrcU family type III secretion system export apparatus switch protein', 130, NULL, NULL, 71702),
(71703, '2.30.29.30-FF-000893', NULL, 'uncharacterized protein LOC778851 isoform X2', 112, NULL, NULL, 71703),
(71704, '3.40.850.10-FF-000301', NULL, 'Uncharacterized protein', 211, NULL, NULL, 71704),
(71705, '3.30.2010.30-FF-000004', NULL, 'Arginyl aminopeptidase', 61, NULL, NULL, 71705),
(71706, '2.60.15.10-FF-000022', NULL, 'ATP synthase epsilon chain, chloroplastic', 85, NULL, NULL, 71706),
(71707, '3.40.50.10810-FF-000152', NULL, 'Protein CBG00336', 107, NULL, NULL, 71707),
(71708, '1.10.10.10-FF-001090', NULL, 'Vacuolar membrane-associated protein iml1', 156, NULL, NULL, 71708),
(71709, '1.20.58.390-FF-000170', NULL, 'Predicted protein', 80, NULL, NULL, 71709),
(71710, '1.10.8.60-FF-000316', NULL, 'Peroxin-1', 124, NULL, NULL, 71710),
(71711, '3.90.550.10-FF-000402', NULL, 'Glycosyltransferase family 2 protein', 243, NULL, NULL, 71711),
(71712, '3.90.1290.10-FF-000010', NULL, 'Envoplakin a', 193, NULL, NULL, 71712),
(71713, '2.70.150.10-FF-000178', NULL, 'Phospholipid-transporting ATPase', 145, NULL, NULL, 71713),
(71714, '3.80.10.10-FF-000710', NULL, 'MDIS1-interacting receptor like kinase 2 isoform A', 156, NULL, NULL, 71714),
(71715, '3.30.420.10-FF-000709', NULL, NULL, 96, NULL, NULL, 71715),
(71716, '1.25.40.20-FF-001712', NULL, 'Kinase, NEK', 50, NULL, NULL, 71716),
(71717, '2.60.40.1910-FF-000047', NULL, NULL, 81, NULL, NULL, 71717),
(71718, '3.40.50.11500-FF-000022', NULL, 'DENN/MADD domain-containing 1B', 154, NULL, NULL, 71718),
(71719, '3.40.50.1100-FF-000258', NULL, 'Uncharacterized protein', 161, NULL, NULL, 71719),
(71720, '3.30.60.90-FF-000048', NULL, 'zinc finger protein (ZZ-type)-2 isoform X1', 57, NULL, NULL, 71720),
(71721, '3.30.559.10-FF-000121', NULL, 'NonRibosomal Peptide Synthetase', 176, NULL, NULL, 71721),
(71722, '2.130.10.10-FF-001828', NULL, 'Predicted protein', 201, NULL, NULL, 71722),
(71723, '3.40.390.10-FF-000272', NULL, NULL, 145, NULL, NULL, 71723),
(71724, '1.20.58.2240-FF-000004', NULL, 'Putative phosphotransferase', 151, NULL, NULL, 71724),
(71725, '2.40.30.10-FF-000047', NULL, '50S ribosomal protein L3', 77, NULL, NULL, 71725),
(71726, '3.90.850.10-FF-000043', NULL, NULL, 51, NULL, NULL, 71726),
(71727, '3.30.420.60-FF-000022', NULL, 'Eukaryotic peptide chain release factor subunit 1-2', 38, NULL, NULL, 71727),
(71728, '3.30.160.60-FF-003296', NULL, 'Zinc finger protein 844', 30, NULL, NULL, 71728),
(71729, '2.60.120.40-FF-000030', NULL, 'Lymphotoxin-beta', 158, NULL, NULL, 71729),
(71730, '3.30.450.20-FF-000366', NULL, 'Neuronal PAS domain protein 4', 108, NULL, NULL, 71730),
(71731, '3.90.810.10-FF-000001', NULL, 'Non-specific serine/threonine protein kinase', 80, NULL, NULL, 71731),
(71732, '3.40.50.300-FF-004347', NULL, 'Torsin-2A', 229, NULL, NULL, 71732),
(71733, '2.10.70.80-FF-000004', NULL, 'Sortilin', 53, NULL, NULL, 71733),
(71734, '3.30.70.330-FF-000973', NULL, 'Os02g0602600 protein', 96, NULL, NULL, 71734),
(71735, '2.10.25.10-FF-000840', NULL, 'Latent transforming growth factor beta binding protein 3', 31, NULL, NULL, 71735),
(71736, '3.40.1110.10-FF-000161', NULL, 'Copper resistance-associated P-type ATPase, putative', 127, NULL, NULL, 71736),
(71737, '1.20.140.40-FF-000049', NULL, NULL, 166, NULL, NULL, 71737),
(71738, '2.60.40.1180-FF-000227', NULL, 'Alpha-galactosidase', 84, NULL, NULL, 71738),
(71739, '1.10.510.10-FF-002067', NULL, 'MAP/microtubule affinity-regulating kinase 4-like', 218, NULL, NULL, 71739),
(71740, '1.25.40.10-FF-000815', NULL, 'Nuclear autoantigenic sperm protein', 268, NULL, NULL, 71740),
(71741, '2.130.10.10-FF-000598', NULL, 'E3 ubiquitin-protein ligase RFWD3 isoform X2', 280, NULL, NULL, 71741),
(71742, '3.30.300.30-FF-000027', NULL, '2-succinylbenzoate--CoA ligase', 100, NULL, NULL, 71742),
(71743, '3.40.850.10-FF-000352', NULL, 'Gamma-soluble NSF attachment protein', 128, NULL, NULL, 71743);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(71744, '1.10.340.30-FF-000036', NULL, '8-oxoguanine DNA glycosylase', 118, NULL, NULL, 71744),
(71745, '3.55.50.30-FF-000030', NULL, 'Fec operon regulator FecR', 75, NULL, NULL, 71745),
(71746, '1.25.40.10-FF-004177', NULL, 'Uncharacterized protein', 281, NULL, NULL, 71746),
(71747, '2.30.29.30-FF-000842', NULL, 'Uncharacterized protein', 120, NULL, NULL, 71747),
(71748, '3.40.50.10490-FF-000005', NULL, '30S ribosomal protein S2', 188, NULL, NULL, 71748),
(71749, '1.10.420.10-FF-000031', NULL, 'Peroxidase', 85, NULL, NULL, 71749),
(71750, '1.10.10.60-FF-000587', NULL, 'SWITCH/sucrose nonfermenting 3A', 50, NULL, NULL, 71750),
(71751, '3.90.1290.10-FF-000061', NULL, 'Uncharacterized protein', 139, NULL, NULL, 71751),
(71752, '3.20.20.80-FF-000818', NULL, 'Glucosidase, alpha; acid (Pompe disease, glycogen storage disease type II)', 84, NULL, NULL, 71752),
(71753, '3.40.1190.20-FF-000202', NULL, NULL, 163, NULL, NULL, 71753),
(71754, '3.80.10.10-FF-003583', NULL, 'Uncharacterized protein', 138, NULL, NULL, 71754),
(71755, '1.10.287.130-FF-000149', NULL, 'Sensor histidine kinase', 96, NULL, NULL, 71755),
(71756, '2.130.10.10-FF-003392', NULL, 'YALI0E33774p', 220, NULL, NULL, 71756),
(71757, '3.60.40.10-FF-000376', NULL, 'Uncharacterized protein', 88, NULL, NULL, 71757),
(71758, '2.160.20.10-FF-000153', NULL, 'Pectinesterase 31', 150, NULL, NULL, 71758),
(71759, '3.90.1410.10-FF-000099', NULL, 'Uncharacterized protein', 92, NULL, NULL, 71759),
(71760, '3.40.50.720-FF-002449', NULL, 'Uncharacterized protein', 195, NULL, NULL, 71760),
(71761, '1.10.40.60-FF-000004', NULL, 'Type II secretion system protein K', 60, NULL, NULL, 71761),
(71762, '4.10.280.10-FF-000036', NULL, 'Transcription factor AP-4', 82, NULL, NULL, 71762),
(71763, '1.10.1070.11-FF-000099', NULL, 'Uncharacterized protein', 180, NULL, NULL, 71763),
(71764, '3.30.1490.100-FF-000007', NULL, 'DNA polymerase eta', 123, NULL, NULL, 71764),
(71765, '3.40.50.12710-FF-000042', NULL, 'Protein arginine methyltransferase NDUFAF7', 79, NULL, NULL, 71765),
(71766, '3.30.70.1050-FF-000021', NULL, 'Trigger factor-like protein TIG Chloroplastic', 72, NULL, NULL, 71766),
(71767, '3.30.43.10-FF-000041', NULL, 'UDP-N-acetylenolpyruvoylglucosamine reductase', 72, NULL, NULL, 71767),
(71768, '2.10.25.10-FF-001357', NULL, 'GM19112', 63, NULL, NULL, 71768),
(71769, '1.25.40.10-FF-003300', NULL, 'Pentatricopeptide repeat-containing protein At1g62590', 148, NULL, NULL, 71769),
(71770, '2.60.40.60-FF-001045', NULL, 'Uncharacterized protein', 95, NULL, NULL, 71770),
(71771, '1.20.5.170-FF-000008', NULL, 'probable global transcription activator SNF2L2 isoform X1', 76, NULL, NULL, 71771),
(71772, '3.30.300.10-FF-000021', NULL, 'S-adenosylmethionine synthetase 1', 106, NULL, NULL, 71772),
(71773, '3.30.200.20-FF-000606', NULL, 'Mitogen-activated protein kinase', 67, NULL, NULL, 71773),
(71774, '3.90.1150.210-FF-000008', NULL, 'F-actin-capping protein subunit beta', 202, NULL, NULL, 71774),
(71775, '3.30.230.10-FF-000105', NULL, 'Ribonuclease P protein component', 118, NULL, NULL, 71775),
(71776, '1.10.3200.20-FF-000005', NULL, 'DNA polymerase', 167, NULL, NULL, 71776),
(71777, '1.10.510.10-FF-001286', NULL, 'Possible serine/threonine kinase', 215, NULL, NULL, 71777),
(71778, '3.30.160.60-FF-000311', NULL, 'protein odd-skipped-related 2 isoform X1', 35, NULL, NULL, 71778),
(71779, '3.30.780.10-FF-000017', NULL, 'Protein translation factor SUI1 homolog', 83, NULL, NULL, 71779),
(71780, '3.40.50.1820-FF-001160', NULL, 'Homoserine O-acetyltransferase', 348, NULL, NULL, 71780),
(71781, '1.25.40.80-FF-000022', NULL, 'Cryptochrome photolyase family 1', 129, NULL, NULL, 71781),
(71782, '3.10.20.90-FF-000996', NULL, 'Predicted protein', 87, NULL, NULL, 71782),
(71783, '1.20.1440.80-FF-000004', NULL, 'Gap junction epsilon-1 protein', 109, NULL, NULL, 71783),
(71784, '2.60.40.10-FF-002952', NULL, 'High Incidence of Males (Increased X chromosome loss)', 98, NULL, NULL, 71784),
(71785, '3.90.190.20-FF-000017', NULL, 'Folylpolyglutamate synthase', 182, NULL, NULL, 71785);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(71786, '3.40.50.620-FF-000059', NULL, 'Universal stress protein F', 144, NULL, NULL, 71786),
(71787, '3.30.420.580-FF-000009', NULL, 'Actin-related protein 8', 132, NULL, NULL, 71787),
(71788, '1.25.40.20-FF-000583', NULL, 'Os11g0435300 protein', 164, NULL, NULL, 71788),
(71789, '1.10.3730.20-FF-000034', NULL, 'DMT family transporter', 103, NULL, NULL, 71789),
(71790, '2.30.42.10-FF-000064', NULL, 'protein lap4 isoform X1', 105, NULL, NULL, 71790),
(71791, '1.20.1070.10-FF-001175', NULL, 'Prostaglandin E2 receptor EP4 subtype', 337, NULL, NULL, 71791),
(71792, '2.30.39.10-FF-000157', NULL, 'Uncharacterized protein', 102, NULL, NULL, 71792),
(71793, '3.40.390.10-FF-000193', NULL, NULL, 236, NULL, NULL, 71793),
(71794, '3.30.420.10-FF-000209', NULL, 'DNA polymerase', 220, NULL, NULL, 71794),
(71795, '3.30.160.60-FF-003537', NULL, NULL, 28, NULL, NULL, 71795),
(71796, '3.30.1370.10-FF-000036', NULL, 'KH RNA binding domain containing, signal transduction associated 1', 190, NULL, NULL, 71796),
(71797, '1.10.10.790-FF-000043', NULL, NULL, 58, NULL, NULL, 71797),
(71798, '3.30.300.10-FF-000049', NULL, 'S-adenosylmethionine synthetase', 93, NULL, NULL, 71798),
(71799, '3.40.50.10860-FF-000026', NULL, 'Pentafunctional AROM polypeptide', 94, NULL, NULL, 71799),
(71800, '1.10.510.10-FF-000190', NULL, 'Proto-oncogene tyrosine-protein kinase receptor Ret', 200, NULL, NULL, 71800),
(71801, '2.70.70.10-FF-000014', NULL, 'Peptidase, M23 family', 149, NULL, NULL, 71801),
(71802, '3.40.50.300-FF-005544', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily', 287, NULL, NULL, 71802),
(71803, '3.40.50.80-FF-000191', NULL, 'Superoxide-generating NADPH oxidase heavy chain subunit C', 218, NULL, NULL, 71803),
(71804, '3.40.50.300-FF-004976', NULL, 'Uncharacterized protein', 109, NULL, NULL, 71804),
(71805, '2.60.120.200-FF-000647', NULL, 'Laminin subunit alpha-3', 105, NULL, NULL, 71805),
(71806, '2.10.50.10-FF-000061', NULL, 'Cysteine repeat modular protein 3', 59, NULL, NULL, 71806),
(71807, '1.10.10.10-FF-002039', NULL, 'Uncharacterized protein', 97, NULL, NULL, 71807),
(71808, '3.60.40.10-FF-000325', NULL, 'Os05g0111800 protein', 189, NULL, NULL, 71808),
(71809, '3.30.70.660-FF-000077', NULL, 'tRNA pseudouridine synthase', 96, NULL, NULL, 71809),
(71810, '2.30.40.10-FF-000014', NULL, 'Cytosine deaminase', 93, NULL, NULL, 71810),
(71811, '2.60.120.10-FF-000667', NULL, 'Uncharacterized protein', 112, NULL, NULL, 71811),
(71812, '1.10.510.10-FF-002960', NULL, NULL, 98, NULL, NULL, 71812),
(71813, '1.25.40.10-FF-002671', NULL, 'Peroxisomal targeting signal 1 receptor', 298, NULL, NULL, 71813),
(71814, '1.20.5.1300-FF-000003', NULL, 'Histidinol dehydrogenase', 53, NULL, NULL, 71814),
(71815, '2.30.170.20-FF-000011', NULL, '60S ribosomal protein L24, putative', 68, NULL, NULL, 71815),
(71816, '2.60.40.150-FF-000179', NULL, 'synaptotagmin-5 isoform X2', 133, NULL, NULL, 71816),
(71817, '1.10.10.60-FF-000295', NULL, 'Distal-less homeobox 4', 74, NULL, NULL, 71817),
(71818, '3.40.30.10-FF-000421', NULL, 'Thioredoxin related transmembrane protein 3', 105, NULL, NULL, 71818),
(71819, '3.40.50.1820-FF-000209', NULL, 'Protein phosphatase methylesterase 1', 314, NULL, NULL, 71819),
(71820, '3.30.70.2450-FF-000008', NULL, 'Uncharacterized protein', 37, NULL, NULL, 71820),
(71821, '1.10.3270.10-FF-000001', NULL, '3-hydroxy-3-methylglutaryl coenzyme A reductase', 87, NULL, NULL, 71821),
(71822, '3.40.50.300-FF-000132', NULL, 'Phosphate import ATP-binding protein PstB', 250, NULL, NULL, 71822),
(71823, '3.30.310.10-FF-000027', NULL, 'TBP-like factor', 89, NULL, NULL, 71823),
(71824, '3.40.50.720-FF-001836', NULL, 'Myo-inositol-1-phosphate synthase', 104, NULL, NULL, 71824),
(71825, '1.10.533.10-FF-000074', NULL, 'NLR family pyrin domain containing 7', 102, NULL, NULL, 71825),
(71826, '3.30.70.2430-FF-000002', NULL, 'Acyl transferase-like protein', 67, NULL, NULL, 71826),
(71827, '3.30.230.10-FF-000026', NULL, 'DNA repair protein RadA', 169, NULL, NULL, 71827),
(71828, '1.10.1040.10-FF-000113', NULL, 'Uncharacterized protein', 90, NULL, NULL, 71828);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(71829, '1.20.1560.10-FF-000690', NULL, 'Uncharacterized protein ABCC16', 339, NULL, NULL, 71829),
(71830, '3.30.160.60-FF-002340', NULL, 'Zinc finger protein 7', 33, NULL, NULL, 71830),
(71831, '3.90.1800.10-FF-000022', NULL, 'Predicted protein', 52, NULL, NULL, 71831),
(71832, '3.40.50.300-FF-003358', NULL, 'Helicase-like protein', 197, NULL, NULL, 71832),
(71833, '2.40.50.140-FF-000964', NULL, NULL, 154, NULL, NULL, 71833),
(71834, '3.90.1150.10-FF-000180', NULL, 'Aspartate aminotransferase, cytoplasmic', 111, NULL, NULL, 71834),
(71835, '3.10.50.40-FF-000062', NULL, 'Trigger factor', 99, NULL, NULL, 71835),
(71836, '3.30.70.330-FF-000681', NULL, 'X16 splicing factor, isoform B', 117, NULL, NULL, 71836),
(71837, '1.10.10.350-FF-000046', NULL, NULL, 92, NULL, NULL, 71837),
(71838, '2.10.25.10-FF-000109', NULL, 'Notch homolog 4, [Drosophila]', 38, NULL, NULL, 71838),
(71839, '4.10.1000.10-FF-000001', NULL, 'zinc finger CCCH domain-containing protein 15-like', 40, NULL, NULL, 71839),
(71840, '3.40.50.410-FF-000226', NULL, 'AGAP009043-PA', 118, NULL, NULL, 71840),
(71841, '3.40.50.11340-FF-000002', NULL, 'GDP-fucose protein O-fucosyltransferase 2', 200, NULL, NULL, 71841),
(71842, '3.40.930.10-FF-000010', NULL, 'Mannitol-specific cryptic phosphotransferase enzyme IIA component', 147, NULL, NULL, 71842),
(71843, '3.40.50.300-FF-000761', NULL, 'Thymidine kinase', 133, NULL, NULL, 71843),
(71844, '1.10.1200.10-FF-000148', NULL, 'Hydroxamate-type ferrichrome siderophore peptide synthetase', 82, NULL, NULL, 71844),
(71845, '1.25.40.10-FF-002283', NULL, 'Pentatricopeptide repeat-containing protein', 93, NULL, NULL, 71845),
(71846, '2.40.110.10-FF-000087', NULL, 'Uncharacterized protein', 43, NULL, NULL, 71846),
(71847, '3.40.250.10-FF-000031', NULL, 'Thiosulfate sulfurtransferase like domain containing 1', 111, NULL, NULL, 71847),
(71848, '1.10.490.10-FF-000046', NULL, 'Predicted protein', 149, NULL, NULL, 71848),
(71849, '1.20.930.20-FF-000014', NULL, 'E3 ubiquitin-protein ligase CBL-B', 28, NULL, NULL, 71849),
(71850, '3.30.20.10-FF-000005', NULL, NULL, 30, NULL, NULL, 71850),
(71851, '2.20.100.10-FF-000192', NULL, 'Thrombospondin type-1 domain-containing protein 7B', 68, NULL, NULL, 71851),
(71852, '3.30.760.10-FF-000055', NULL, 'Eukaryotic translation initiation factor 4E; Uncharacterized protein', 190, NULL, NULL, 71852),
(71853, '1.10.238.110-FF-000022', NULL, 'Diacylglycerol kinase', 46, NULL, NULL, 71853),
(71854, '3.30.70.330-FF-002867', NULL, NULL, 76, NULL, NULL, 71854),
(71855, '3.80.10.10-FF-001323', NULL, 'F-box family protein', 94, NULL, NULL, 71855),
(71856, '1.25.40.10-FF-002339', NULL, 'Pentatricopeptide repeat-containing protein', 163, NULL, NULL, 71856),
(71857, '3.50.7.10-FF-000071', NULL, NULL, 123, NULL, NULL, 71857),
(71858, '3.10.290.10-FF-000080', NULL, 'tRNA pseudouridine synthase A', 56, NULL, NULL, 71858),
(71859, '3.80.10.10-FF-000385', NULL, 'Leucine-rich repeat family protein', 287, NULL, NULL, 71859),
(71860, '3.50.50.60-FF-001241', NULL, 'Uncharacterized protein', 172, NULL, NULL, 71860),
(71861, '3.10.20.90-FF-000092', NULL, 'Small ubiquitin-related modifier', 97, NULL, NULL, 71861),
(71862, '1.10.8.1070-FF-000004', NULL, 'Os11g0707100 protein', 50, NULL, NULL, 71862),
(71863, '1.10.10.10-FF-001590', NULL, 'Uncharacterized protein', 92, NULL, NULL, 71863),
(71864, '1.10.287.690-FF-000019', NULL, 'DNA polymerase', 53, NULL, NULL, 71864),
(71865, '2.60.120.10-FF-000515', NULL, 'Predicted protein', 148, NULL, NULL, 71865),
(71866, '1.25.40.720-FF-000029', NULL, 'Uncharacterized protein', 79, NULL, NULL, 71866),
(71867, '3.40.50.300-FF-002902', NULL, 'ABC transporter, ATP-binding protein, putative', 260, NULL, NULL, 71867),
(71868, '3.40.50.300-FF-006213', NULL, 'Uncharacterized protein', 240, NULL, NULL, 71868),
(71869, '2.60.40.420-FF-000171', NULL, 'Multicopper oxidase family protein', 192, NULL, NULL, 71869),
(71870, '3.90.950.10-FF-000039', NULL, 'Probable inosine/xanthosine triphosphatase', 173, NULL, NULL, 71870),
(71871, '3.30.2070.10-FF-000002', NULL, 'Probable oxidoreductase YyaE', 62, NULL, NULL, 71871);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(71872, '3.30.200.20-FF-000106', NULL, 'serine/threonine-protein kinase TBK1 isoform X1', 88, NULL, NULL, 71872),
(71873, '3.30.160.60-FF-004526', NULL, NULL, 30, NULL, NULL, 71873),
(71874, '1.25.40.180-FF-000036', NULL, 'Eukaryotic translation initiation factor isoform 4G-2', 163, NULL, NULL, 71874),
(71875, '1.20.930.40-FF-000020', NULL, 'Predicted protein', 74, NULL, NULL, 71875),
(71876, '2.60.40.10-FF-003088', NULL, 'Uncharacterized protein', 82, NULL, NULL, 71876),
(71877, '4.10.1000.30-FF-000007', NULL, 'Predicted protein', 42, NULL, NULL, 71877),
(71878, '1.20.58.1070-FF-000001', NULL, 'Gem-associated protein 2', 186, NULL, NULL, 71878),
(71879, '1.10.8.10-FF-000054', NULL, 'E3 ubiquitin protein ligase RIN2', 41, NULL, NULL, 71879),
(71880, '3.30.40.10-FF-001636', NULL, 'Uncharacterized protein', 80, NULL, NULL, 71880),
(71881, '3.90.226.10-FF-000317', NULL, 'Uncharacterized protein', 67, NULL, NULL, 71881),
(71882, '3.70.10.10-FF-000003', NULL, 'Beta sliding clamp', 191, NULL, NULL, 71882),
(71883, '1.20.1070.10-FF-001916', NULL, 'Uncharacterized protein', 284, NULL, NULL, 71883),
(71884, '1.10.150.240-FF-000037', NULL, 'Phosphatase, putative', 71, NULL, NULL, 71884),
(71885, '4.10.1090.10-FF-000001', NULL, 'Tail spike protein', 155, NULL, NULL, 71885),
(71886, '1.20.920.20-FF-000036', NULL, 'Dynein heavy chain, cytoplasmic', 342, NULL, NULL, 71886),
(71887, '2.10.70.10-FF-000124', NULL, 'Complement factor H related 4', 60, NULL, NULL, 71887),
(71888, '1.10.400.10-FF-000097', NULL, 'Uncharacterized protein', 28, NULL, NULL, 71888),
(71889, '2.10.25.10-FF-000340', NULL, 'Terribly reduced optic lobes, isoform AT', 40, NULL, NULL, 71889),
(71890, '3.40.50.720-FF-000651', NULL, 'Glutathione-regulated potassium-efflux system protein KefB', 150, NULL, NULL, 71890),
(71891, '1.20.140.20-FF-000010', NULL, '[Pyruvate dehydrogenase (Acetyl-transferring)] kinase mitochondrial', 79, NULL, NULL, 71891),
(71892, '1.10.510.10-FF-002808', NULL, NULL, 183, NULL, NULL, 71892),
(71893, '3.30.1120.10-FF-000001', NULL, 'Arylsulfatase E', 112, NULL, NULL, 71893),
(71894, '1.20.58.400-FF-000027', NULL, 'Uncharacterized protein', 90, NULL, NULL, 71894),
(71895, '3.60.15.10-FF-000071', NULL, 'Ribonuclease J', 262, NULL, NULL, 71895),
(71896, '1.10.287.70-FF-000120', NULL, 'Voltage-dependent T-type calcium channel subunit alpha', 157, NULL, NULL, 71896),
(71897, '2.60.40.10-FF-003200', NULL, 'Plexin A, putative', 90, NULL, NULL, 71897),
(71898, '2.60.120.920-FF-000037', NULL, 'Si:dkey-191j3.2', 182, NULL, NULL, 71898),
(71899, '2.70.160.11-FF-000005', NULL, 'protein arginine N-methyltransferase 3 isoform X2', 170, NULL, NULL, 71899),
(71900, '3.30.390.150-FF-000001', NULL, 'leukocyte cell-derived chemotaxin 1', 105, NULL, NULL, 71900),
(71901, '1.20.120.1900-FF-000067', NULL, 'Gamma-tubulin complex component', 170, NULL, NULL, 71901),
(71902, '2.60.40.150-FF-000567', NULL, 'Ca2+dependent plant phosphoribosyltransferase family protein', 124, NULL, NULL, 71902),
(71903, '1.10.472.130-FF-000072', NULL, 'YALI0E32857p', 156, NULL, NULL, 71903),
(71904, '2.60.40.10-FF-005274', NULL, NULL, 85, NULL, NULL, 71904),
(71905, '1.25.40.20-FF-000431', NULL, 'Transient receptor potential cation channel subfamily V member 4', 167, NULL, NULL, 71905),
(71906, '2.40.128.330-FF-000010', NULL, 'Magnesium transporter MRS2-6, mitochondrial', 89, NULL, NULL, 71906),
(71907, '1.10.600.10-FF-000045', NULL, 'Chromosome 1, whole genome shotgun sequence', 289, NULL, NULL, 71907),
(71908, '2.40.50.140-FF-000317', NULL, 'Replication protein A2', 132, NULL, NULL, 71908),
(71909, '3.80.10.10-FF-003240', NULL, 'Uncharacterized protein', 184, NULL, NULL, 71909),
(71910, '3.40.30.10-FF-000101', NULL, '2-cys peroxiredoxin', 180, NULL, NULL, 71910),
(71911, '2.60.120.340-FF-000015', NULL, 'Uncharacterized protein', 95, NULL, NULL, 71911),
(71912, '3.40.30.10-FF-000213', NULL, 'APD1p protein', 100, NULL, NULL, 71912),
(71913, '3.30.70.270-FF-000230', NULL, NULL, 163, NULL, NULL, 71913),
(71914, '3.30.420.10-FF-000417', NULL, NULL, 165, NULL, NULL, 71914);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(71915, '1.10.238.220-FF-000004', NULL, 'Putative phosphatase 2A regulatory subunit-related protein', 108, NULL, NULL, 71915),
(71916, '1.25.10.10-FF-002455', NULL, 'Predicted protein', 225, NULL, NULL, 71916),
(71917, '3.40.50.720-FF-000494', NULL, 'Adenylate kinase 7', 251, NULL, NULL, 71917),
(71918, '3.40.50.300-FF-001542', NULL, 'Thiol reductant ABC exporter subunit CydD', 249, NULL, NULL, 71918),
(71919, '1.25.40.470-FF-000022', NULL, 'Intraflagellar transport protein 172', 138, NULL, NULL, 71919),
(71920, '3.30.70.3290-FF-000024', NULL, 'Probable polyketide synthase 37', 135, NULL, NULL, 71920),
(71921, '6.10.250.3420-FF-000001', NULL, 'Hsc70-interacting protein-like protein', 43, NULL, NULL, 71921),
(71922, '2.40.50.40-FF-000074', NULL, 'C-C motif chemokine', 77, NULL, NULL, 71922),
(71923, '3.90.550.10-FF-000110', NULL, 'Hexosyltransferase', 283, NULL, NULL, 71923),
(71924, '3.30.160.60-FF-003745', NULL, 'Zinc finger protein 1143', 28, NULL, NULL, 71924),
(71925, '1.25.10.10-FF-002579', NULL, 'Proteasome activator complex subunit, putative', 161, NULL, NULL, 71925),
(71926, '1.20.120.850-FF-000015', NULL, 'Rad5p', 104, NULL, NULL, 71926),
(71927, '2.130.10.10-FF-004734', NULL, 'Predicted protein', 164, NULL, NULL, 71927),
(71928, '2.10.220.10-FF-000012', NULL, 'R-spondin 4', 115, NULL, NULL, 71928),
(71929, '3.40.50.2000-FF-000045', NULL, 'Glycogen [starch] synthase', 298, NULL, NULL, 71929),
(71930, '3.20.20.30-FF-000040', NULL, 'Predicted protein', 66, NULL, NULL, 71930),
(71931, '1.25.10.10-FF-001382', NULL, 'AP complex subunit beta', 599, NULL, NULL, 71931),
(71932, '3.30.160.60-FF-005370', NULL, NULL, 54, NULL, NULL, 71932),
(71933, '1.20.920.10-FF-000128', NULL, 'PolyBRoMo domain containing', 128, NULL, NULL, 71933),
(71934, '1.20.1070.10-FF-002113', NULL, 'Uncharacterized protein', 72, NULL, NULL, 71934),
(71935, '1.20.1560.10-FF-000414', NULL, 'Cystic Fibrosis Transmembrane conductance regulator homolog', 316, NULL, NULL, 71935),
(71936, '2.170.130.10-FF-000074', NULL, NULL, 130, NULL, NULL, 71936),
(71937, '3.30.160.60-FF-005774', NULL, NULL, 64, NULL, NULL, 71937),
(71938, '3.40.390.10-FF-000041', NULL, 'Kuzbanian-like, isoform A', 235, NULL, NULL, 71938),
(71939, '3.30.70.330-FF-002479', NULL, NULL, 78, NULL, NULL, 71939),
(71940, '1.20.1730.10-FF-000130', NULL, 'Uncharacterized protein', 408, NULL, NULL, 71940),
(71941, '2.60.40.10-FF-000715', NULL, 'Platelet-derived growth factor receptor beta', 102, NULL, NULL, 71941),
(71942, '3.40.50.300-FF-003566', NULL, 'Sulfotransferase family protein', 247, NULL, NULL, 71942),
(71943, '1.25.40.320-FF-000005', NULL, 'Aminopeptidase ltah-1.1', 145, NULL, NULL, 71943),
(71944, '1.25.40.10-FF-004469', NULL, 'Uncharacterized protein', 107, NULL, NULL, 71944),
(71945, '1.10.630.10-FF-000777', NULL, 'Uncharacterized protein', 157, NULL, NULL, 71945),
(71946, '3.20.20.330-FF-000010', NULL, 'Bifunctional homocysteine S-methyltransferase/methylenetetrahydrofolate reductase', 291, NULL, NULL, 71946),
(71947, '1.10.20.10-FF-000359', NULL, NULL, 90, NULL, NULL, 71947),
(71948, '3.40.50.1110-FF-000087', NULL, 'Protein CBG02607', 255, NULL, NULL, 71948),
(71949, '1.20.5.100-FF-000027', NULL, 'Integrin beta', 77, NULL, NULL, 71949),
(71950, '3.80.10.10-FF-001727', NULL, 'F-box/LRR-repeat protein', 222, NULL, NULL, 71950),
(71951, '3.50.50.60-FF-000509', NULL, 'Steroid monooxygenase, putative', 204, NULL, NULL, 71951),
(71952, '3.40.50.300-FF-005932', NULL, 'Uncharacterized protein', 168, NULL, NULL, 71952),
(71953, '3.40.50.12780-FF-000023', NULL, 'Long-chain-fatty-acid--CoA ligase ACSBG1 isoform 1', 316, NULL, NULL, 71953),
(71954, '3.40.50.261-FF-000025', NULL, 'Succinyl-CoA ligase [GDP-forming] subunit beta, mitochondrial', 74, NULL, NULL, 71954),
(71955, '3.30.60.20-FF-000016', NULL, 'Diacylglycerol kinase', 60, NULL, NULL, 71955),
(71956, '1.20.120.230-FF-000037', NULL, 'Alpha-catenin-like protein hmp-1', 146, NULL, NULL, 71956),
(71957, '1.25.40.90-FF-000120', NULL, 'Uncharacterized protein', 42, NULL, NULL, 71957),
(71958, '3.30.70.330-FF-000394', NULL, 'Nucleolysin tiar isoform 1', 50, NULL, NULL, 71958);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(71959, '1.10.1410.40-FF-000021', NULL, 'Uncharacterized protein', 63, NULL, NULL, 71959),
(71960, '1.20.1250.20-FF-000933', NULL, 'Solute carrier organic anion transporter family member', 364, NULL, NULL, 71960),
(71961, '2.60.260.20-FF-000146', NULL, 'DnaJ-like protein subfamily B member 1', 79, NULL, NULL, 71961),
(71962, '3.10.590.10-FF-000024', NULL, 'Uncharacterized protein', 76, NULL, NULL, 71962),
(71963, '2.40.30.10-FF-000491', NULL, 'Uncharacterized protein', 19, NULL, NULL, 71963),
(71964, '3.30.70.330-FF-002979', NULL, NULL, 91, NULL, NULL, 71964),
(71965, '3.30.870.30-FF-000002', NULL, 'MIT domain-containing protein 1 isoform X2', 42, NULL, NULL, 71965),
(71966, '3.30.430.20-FF-000039', NULL, 'Antifungal protein ginkbilobin-2', 108, NULL, NULL, 71966),
(71967, '1.20.900.10-FF-000088', NULL, 'Putative rho guanine nucleotide exchange factor cdep', 209, NULL, NULL, 71967),
(71968, '1.10.10.10-FF-000858', NULL, 'Transcriptional regulator, GntR family', 80, NULL, NULL, 71968),
(71969, '1.20.870.10-FF-000034', NULL, 'Ral guanine nucleotide dissociation stimulator-like 3', 195, NULL, NULL, 71969),
(71970, '3.30.200.20-FF-001163', NULL, 'Serine/threonine-protein kinase cbk1', 152, NULL, NULL, 71970),
(71971, '3.40.50.150-FF-000570', NULL, 'MTQ1p S-adenosylmethionine-dependent methyltransferase', 208, NULL, NULL, 71971),
(71972, '2.40.50.140-FF-000840', NULL, NULL, 162, NULL, NULL, 71972),
(71973, '1.20.58.60-FF-000550', NULL, 'Uncharacterized protein', 111, NULL, NULL, 71973),
(71974, '1.10.10.10-FF-001382', NULL, 'Si:rp71-45k5.2', 100, NULL, NULL, 71974),
(71975, '2.60.120.10-FF-000403', NULL, 'Predicted protein', 163, NULL, NULL, 71975),
(71976, '3.40.470.10-FF-000042', NULL, NULL, 84, NULL, NULL, 71976),
(71977, '2.60.40.10-FF-001963', NULL, 'GH11366', 110, NULL, NULL, 71977),
(71978, '3.40.50.150-FF-001244', NULL, NULL, 65, NULL, NULL, 71978),
(71979, '1.10.238.20-FF-000054', NULL, 'Odorant binding protein b', 62, NULL, NULL, 71979),
(71980, '2.10.70.10-FF-000236', NULL, 'Uncharacterized protein', 62, NULL, NULL, 71980),
(71981, '1.10.286.40-FF-000002', NULL, 'Photosystem I reaction center subunit V', 96, NULL, NULL, 71981),
(71982, '3.10.250.10-FF-000015', NULL, 'Scavenger receptor cysteine-rich type 1 protein M130', 108, NULL, NULL, 71982),
(71983, '3.30.310.50-FF-000039', NULL, 'Phosphoacetylglucosamine mutase', 92, NULL, NULL, 71983),
(71984, '1.25.40.10-FF-004756', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 61, NULL, NULL, 71984),
(71985, '3.90.1150.10-FF-000028', NULL, 'Putrescine aminotransferase', 159, NULL, NULL, 71985),
(71986, '3.30.40.10-FF-000647', NULL, 'Os06g0540200 protein', 64, NULL, NULL, 71986),
(71987, '3.40.630.20-FF-000018', NULL, 'Uncharacterized protein', 211, NULL, NULL, 71987),
(71988, '3.10.20.310-FF-000012', NULL, 'Outer envelope protein 80, chloroplastic', 81, NULL, NULL, 71988),
(71989, '3.30.200.20-FF-002523', NULL, NULL, 157, NULL, NULL, 71989),
(71990, '1.20.1070.10-FF-000394', NULL, 'Opsin 1, putative', 250, NULL, NULL, 71990),
(71991, '3.10.330.10-FF-000016', NULL, 'AAA ATPase', 81, NULL, NULL, 71991),
(71992, '1.25.40.10-FF-004205', NULL, 'Uncharacterized protein', 69, NULL, NULL, 71992),
(71993, '2.130.10.10-FF-002672', NULL, 'Uncharacterized protein', 316, NULL, NULL, 71993),
(71994, '3.20.20.190-FF-000097', NULL, NULL, 155, NULL, NULL, 71994),
(71995, '1.10.418.10-FF-000115', NULL, 'Plastin 1', 116, NULL, NULL, 71995),
(71996, '3.30.1520.10-FF-000082', NULL, 'Non-specific serine/threonine protein kinase', 51, NULL, NULL, 71996),
(71997, '2.20.25.10-FF-000120', NULL, 'Uncharacterized protein', 43, NULL, NULL, 71997),
(71998, '3.30.160.20-FF-000226', NULL, 'Predicted protein', 69, NULL, NULL, 71998),
(71999, '3.30.160.60-FF-003357', NULL, 'Uncharacterized protein', 28, NULL, NULL, 71999),
(72000, '3.30.70.1990-FF-000010', NULL, NULL, 82, NULL, NULL, 72000),
(72001, '3.30.200.20-FF-002444', NULL, 'Uncharacterized protein', 64, NULL, NULL, 72001),
(72002, '1.25.40.10-FF-003396', NULL, 'Pentatricopeptide repeat-containing protein At3g04760, chloroplastic', 135, NULL, NULL, 72002); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(72003, '2.170.130.30-FF-000001', NULL, 'Cobalamin binding intrinsic factor', 108, NULL, NULL, 72003),
(72004, '3.40.50.2000-FF-000606', NULL, 'Alpha-1,4 glucan phosphorylase', 223, NULL, NULL, 72004),
(72005, '2.60.220.50-FF-000035', NULL, 'Uncharacterized protein', 79, NULL, NULL, 72005),
(72006, '3.40.50.410-FF-000165', NULL, 'Predicted protein', 197, NULL, NULL, 72006),
(72007, '3.40.50.300-FF-006713', NULL, 'Predicted protein', 76, NULL, NULL, 72007),
(72008, '3.50.50.60-FF-000448', NULL, 'Putative polyamine oxidase 5 isoform A', 57, NULL, NULL, 72008),
(72009, '2.160.20.10-FF-000092', NULL, 'Putative pectinesterase 57', 201, NULL, NULL, 72009),
(72010, '3.40.50.720-FF-001432', NULL, 'Multifunctional fusion protein', 174, NULL, NULL, 72010),
(72011, '2.60.40.10-FF-000215', NULL, 'Down syndrome cell adhesion molecule a', 85, NULL, NULL, 72011),
(72012, '3.30.60.10-FF-000002', NULL, 'Chitinase B', 40, NULL, NULL, 72012),
(72013, '3.10.310.40-FF-000001', NULL, 'Alanine--tRNA ligase', 109, NULL, NULL, 72013),
(72014, '1.10.3810.10-FF-000021', NULL, 'Penicillin-binding protein PbpC', 195, NULL, NULL, 72014),
(72015, '1.10.10.10-FF-001943', NULL, 'General transcription factor IIE, polypeptide 1, alpha', 85, NULL, NULL, 72015),
(72016, '2.30.30.40-FF-000348', NULL, 'Unconventional myosin heavy chain 6', 79, NULL, NULL, 72016),
(72017, '3.40.50.2300-FF-000253', NULL, 'Extracellular calcium-sensing receptor', 156, NULL, NULL, 72017),
(72018, '2.30.30.30-FF-000115', NULL, 'Transcription elongation factor SPT5', 63, NULL, NULL, 72018),
(72019, '2.40.10.10-FF-000669', NULL, NULL, 48, NULL, NULL, 72019),
(72020, '1.20.58.610-FF-000005', NULL, 'Uncharacterized protein', 130, NULL, NULL, 72020),
(72021, '2.60.120.10-FF-000162', NULL, 'Beta-conglycinin beta subunit 1', 189, NULL, NULL, 72021),
(72022, '1.10.1820.10-FF-000004', NULL, 'Casein kinase II subunit beta', 105, NULL, NULL, 72022),
(72023, '1.20.5.420-FF-000005', NULL, 'Hsc70 cochaperone (SGT), putative', 69, NULL, NULL, 72023),
(72024, '3.60.110.10-FF-000062', NULL, 'Carbon-nitrogen hydrolase, putative', 276, NULL, NULL, 72024),
(72025, '3.40.50.1000-FF-000054', NULL, 'alpha,alpha-trehalose-phosphate synthase [UDP-forming] 6', 118, NULL, NULL, 72025),
(72026, '3.90.740.10-FF-000057', NULL, 'Valyl tRNA Synthetase', 87, NULL, NULL, 72026),
(72027, '3.80.10.10-FF-003740', NULL, 'Uncharacterized protein', 130, NULL, NULL, 72027),
(72028, '2.60.40.150-FF-000359', NULL, 'DNAJ domain containing protein', 121, NULL, NULL, 72028),
(72029, '3.40.140.10-FF-000118', NULL, 'tRNA-specific adenosine deaminase subunit TAD3, putative', 128, NULL, NULL, 72029),
(72030, '3.80.10.10-FF-002104', NULL, 'Uncharacterized protein', 382, NULL, NULL, 72030),
(72031, '3.40.50.2000-FF-000365', NULL, 'Glycosyl transferase', 162, NULL, NULL, 72031),
(72032, '3.30.160.60-FF-006494', NULL, NULL, 60, NULL, NULL, 72032),
(72033, '2.10.25.10-FF-001806', NULL, 'Predicted protein', 54, NULL, NULL, 72033),
(72034, '3.40.366.10-FF-000047', NULL, 'Polyketide synthase, putative (JCVI)', 183, NULL, NULL, 72034),
(72035, '1.20.58.1780-FF-000006', NULL, 'Nuclear pore complex protein Nup155', 312, NULL, NULL, 72035),
(72036, '1.10.10.60-FF-000912', NULL, NULL, 75, NULL, NULL, 72036),
(72037, '2.30.29.30-FF-000157', NULL, 'Putative rho GTPase-activating protein 10', 115, NULL, NULL, 72037),
(72038, '3.90.1150.10-FF-000404', NULL, 'Uncharacterized protein', 28, NULL, NULL, 72038),
(72039, '3.30.160.60-FF-001328', NULL, 'paternally-expressed gene 3 protein', 72, NULL, NULL, 72039),
(72040, '2.10.25.10-FF-000901', NULL, 'Uncharacterized protein', 38, NULL, NULL, 72040),
(72041, '2.120.10.30-FF-000194', NULL, 'Uncharacterized protein', 272, NULL, NULL, 72041),
(72042, '3.30.70.120-FF-000005', NULL, 'CUTA isoform 1', 117, NULL, NULL, 72042),
(72043, '1.10.20.10-FF-000191', NULL, NULL, 66, NULL, NULL, 72043),
(72044, '3.40.50.300-FF-001481', NULL, 'Centromere protein M', 157, NULL, NULL, 72044),
(72045, '3.40.50.1100-FF-000106', NULL, 'L-serine dehydratase/L-threonine deaminase', 30, NULL, NULL, 72045); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(72046, '3.40.50.2300-FF-000596', NULL, 'Two-component system response regulator', 88, NULL, NULL, 72046),
(72047, '2.60.40.1360-FF-000017', NULL, 'Alpha-mannosidase', 99, NULL, NULL, 72047),
(72048, '3.40.50.2300-FF-001534', NULL, NULL, 69, NULL, NULL, 72048),
(72049, '2.60.40.4070-FF-000004', NULL, 'Basal-body rod modification protein FlgD', 87, NULL, NULL, 72049),
(72050, '3.40.50.620-FF-000290', NULL, 'Isoleucyl-tRNA synthetase (Mitochondrial)', 181, NULL, NULL, 72050),
(72051, '1.20.1270.10-FF-000032', NULL, 'Heat shock 70 kDa protein 1', 74, NULL, NULL, 72051),
(72052, '2.60.40.2170-FF-000018', NULL, 'Uncharacterized protein', 58, NULL, NULL, 72052),
(72053, '3.40.720.10-FF-000135', NULL, 'Protein CBG05971', 396, NULL, NULL, 72053),
(72054, '1.10.287.3290-FF-000002', NULL, 'AFR652Wp', 102, NULL, NULL, 72054),
(72055, '1.10.10.2210-FF-000003', NULL, 'Telomerase reverse transcriptase', 47, NULL, NULL, 72055),
(72056, '3.30.1550.10-FF-000022', NULL, 'Uncharacterized protein', 65, NULL, NULL, 72056),
(72057, '3.30.710.10-FF-000187', NULL, 'Protein CBR-EXP-2', 129, NULL, NULL, 72057),
(72058, '1.10.1740.10-FF-000003', NULL, 'RNA polymerase sigma factor', 86, NULL, NULL, 72058),
(72059, '1.10.472.10-FF-000257', NULL, 'cyclin-L1-like', 146, NULL, NULL, 72059),
(72060, '1.25.10.10-FF-002663', NULL, 'Uncharacterized protein', 97, NULL, NULL, 72060),
(72061, '1.10.268.10-FF-000002', NULL, 'DNA topoisomerase 2', 177, NULL, NULL, 72061),
(72062, '2.30.42.10-FF-000417', NULL, NULL, 108, NULL, NULL, 72062),
(72063, '1.10.101.10-FF-000043', NULL, 'General secretion pathway protein A', 63, NULL, NULL, 72063),
(72064, '3.40.50.300-FF-005432', NULL, 'ATP-dependent DNA helicase', 54, NULL, NULL, 72064),
(72065, '1.10.510.10-FF-003005', NULL, NULL, 109, NULL, NULL, 72065),
(72066, '2.120.10.10-FF-000036', NULL, 'Glycoside hydrolase family 93', 298, NULL, NULL, 72066),
(72067, '2.40.50.120-FF-000065', NULL, 'Secreted frizzled-related protein', 91, NULL, NULL, 72067),
(72068, '3.20.20.150-FF-000012', NULL, 'Related to UV-endonuclease UVE-1', 299, NULL, NULL, 72068),
(72069, '3.40.50.880-FF-000058', NULL, 'GMP synthase [glutamine-hydrolyzing]', 232, NULL, NULL, 72069),
(72070, '4.10.1250.10-FF-000003', NULL, 'Aminomethyltransferase', 42, NULL, NULL, 72070),
(72071, '2.40.160.50-FF-000023', NULL, 'ShlB/FhaC/HecB family hemolysin secretion/activation protein', 390, NULL, NULL, 72071),
(72072, '3.40.50.300-FF-005696', NULL, 'AGAP010924-PA', 178, NULL, NULL, 72072),
(72073, '1.10.510.10-FF-001903', NULL, 'Guanylate cyclase', 220, NULL, NULL, 72073),
(72074, '3.90.79.10-FF-000194', NULL, 'Uncharacterized protein', 156, NULL, NULL, 72074),
(72075, '3.40.50.300-FF-005191', NULL, 'Elongator complex protein 5', 214, NULL, NULL, 72075),
(72076, '2.130.10.10-FF-003796', NULL, 'LD30439p', 312, NULL, NULL, 72076),
(72077, '3.40.50.1980-FF-000151', NULL, 'Iron ABC transporter, periplasmic iron-binding protein, putative', 149, NULL, NULL, 72077),
(72078, '1.20.5.260-FF-000002', NULL, 'cytochrome b-c1 complex subunit 9', 55, NULL, NULL, 72078),
(72079, '3.40.190.10-FF-000773', NULL, 'Tripartite tricarboxylate transporter family receptor', 121, NULL, NULL, 72079),
(72080, '1.25.40.10-FF-004548', NULL, 'Uncharacterized protein', 223, NULL, NULL, 72080),
(72081, '1.20.920.30-FF-000078', NULL, 'Dynein, axonemal, heavy chain 11', 198, NULL, NULL, 72081),
(72082, '3.90.640.10-FF-000061', NULL, 'Actin-related protein 4', 113, NULL, NULL, 72082),
(72083, '3.30.30.30-FF-000068', NULL, 'ADR128Cp', 52, NULL, NULL, 72083),
(72084, '3.40.30.10-FF-000601', NULL, 'Nucleoredoxin-like 2', 145, NULL, NULL, 72084),
(72085, '2.60.40.60-FF-000977', NULL, 'Uncharacterized protein', 111, NULL, NULL, 72085),
(72086, '3.40.50.11990-FF-000005', NULL, 'Cell division cycle-related protein', 168, NULL, NULL, 72086),
(72087, '3.40.630.10-FF-000369', NULL, 'Leucine aminopeptidase 2 chloroplastic', 121, NULL, NULL, 72087),
(72088, '3.80.10.10-FF-001166', NULL, 'Cf2-like protein', 94, NULL, NULL, 72088),
(72089, '4.10.800.30-FF-000004', NULL, 'Essential meiotic structure-specific endonuclease 1', 67, NULL, NULL, 72089);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(72090, '4.10.1170.10-FF-000002', NULL, 'MAP kinase-activated protein kinase 5', 58, NULL, NULL, 72090),
(72091, '2.60.40.10-FF-004189', NULL, NULL, 113, NULL, NULL, 72091),
(72092, '3.90.70.200-FF-000004', NULL, 'Zinc knuckle (CCHC-type) family protein', 117, NULL, NULL, 72092),
(72093, '4.10.280.10-FF-000148', NULL, 'Basic helix-loop-helix (BHLH) DNA-binding superfamily protein', 88, NULL, NULL, 72093),
(72094, '1.50.10.130-FF-000016', NULL, NULL, 211, NULL, NULL, 72094),
(72095, '3.40.50.20-FF-000049', NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', 96, NULL, NULL, 72095),
(72096, '3.40.50.10190-FF-000185', NULL, 'DNA-repair protein xrcc1, putative', 48, NULL, NULL, 72096),
(72097, '2.60.40.10-FF-005206', NULL, NULL, 91, NULL, NULL, 72097),
(72098, '3.40.50.200-FF-000169', NULL, 'Uncharacterized protein', 92, NULL, NULL, 72098),
(72099, '1.10.1870.10-FF-000007', NULL, 'Uncharacterized protein', 30, NULL, NULL, 72099),
(72100, '3.40.50.11350-FF-000016', NULL, 'Uncharacterized protein', 168, NULL, NULL, 72100),
(72101, '1.10.1300.10-FF-000032', NULL, 'Phosphodiesterase', 129, NULL, NULL, 72101),
(72102, '3.90.550.50-FF-000066', NULL, 'Lactosylceramide', 261, NULL, NULL, 72102),
(72103, '2.60.40.10-FF-002744', NULL, 'Glycogen debranching enzyme GlgX', 113, NULL, NULL, 72103),
(72104, '2.60.40.10-FF-002868', NULL, 'CD276 molecule', 120, NULL, NULL, 72104),
(72105, '3.10.430.100-FF-000001', NULL, '50S ribosomal protein L9', 89, NULL, NULL, 72105),
(72106, '1.10.510.10-FF-002224', NULL, NULL, 187, NULL, NULL, 72106),
(72107, '3.20.20.80-FF-000234', NULL, 'Glucuronoxylanase XynC', 283, NULL, NULL, 72107),
(72108, '1.20.58.60-FF-000893', NULL, 'BIV spectrin', 131, NULL, NULL, 72108),
(72109, '1.20.1090.10-FF-000046', NULL, 'Iron-containing alcohol dehydrogenase', 186, NULL, NULL, 72109),
(72110, '3.40.50.300-FF-007961', NULL, 'Uncharacterized protein', 166, NULL, NULL, 72110),
(72111, '1.20.1250.20-FF-001107', NULL, 'MFS multidrug transporter, putative', 399, NULL, NULL, 72111),
(72112, '3.40.525.10-FF-000063', NULL, 'Uncharacterized protein', 226, NULL, NULL, 72112),
(72113, '3.40.1160.10-FF-000052', NULL, 'Delta-1-pyrroline-5-carboxylate synthase', 57, NULL, NULL, 72113),
(72114, '2.40.30.130-FF-000058', NULL, 'Alanine--tRNA ligase, mitochondrial-like Protein', 109, NULL, NULL, 72114),
(72115, '1.10.10.60-FF-000795', NULL, NULL, 63, NULL, NULL, 72115),
(72116, '3.30.470.30-FF-000073', NULL, 'Predicted protein', 156, NULL, NULL, 72116),
(72117, '3.10.20.90-FF-000676', NULL, 'Uncharacterized protein', 70, NULL, NULL, 72117),
(72118, '3.30.160.60-FF-002109', NULL, 'ras-responsive element-binding protein 1 isoform X1', 36, NULL, NULL, 72118),
(72119, '2.130.10.10-FF-003453', NULL, 'Cell surface protein', 116, NULL, NULL, 72119),
(72120, '3.40.50.720-FF-000712', NULL, 'Probable short-chain type dehydrogenase/reductase', 277, NULL, NULL, 72120),
(72121, '1.10.150.20-FF-000232', NULL, 'DNA polymerase', 59, NULL, NULL, 72121),
(72122, '3.40.50.1010-FF-000170', NULL, NULL, 138, NULL, NULL, 72122),
(72123, '1.10.150.20-FF-000153', NULL, 'UvrABC system protein C', 61, NULL, NULL, 72123),
(72124, '3.60.10.10-FF-000020', NULL, 'Endonuclease/exonuclease/phosphatase family protein', 244, NULL, NULL, 72124),
(72125, '3.10.105.10-FF-000055', NULL, 'Extracellular solute-binding protein family 5', 243, NULL, NULL, 72125),
(72126, '1.10.510.10-FF-004433', NULL, NULL, 58, NULL, NULL, 72126),
(72127, '3.40.640.10-FF-000134', NULL, 'Serine hydroxymethyltransferase, putative', 258, NULL, NULL, 72127),
(72128, '1.50.40.10-FF-000241', NULL, 'Putative mitochondrial carrier protein', 141, NULL, NULL, 72128),
(72129, '1.20.1070.10-FF-001736', NULL, 'Uncharacterized protein', 89, NULL, NULL, 72129),
(72130, '3.40.50.620-FF-000851', NULL, 'FAD synthase-like Protein', 246, NULL, NULL, 72130),
(72131, '2.30.30.140-FF-000232', NULL, 'FI02030p', 76, NULL, NULL, 72131),
(72132, '3.30.160.60-FF-006151', NULL, NULL, 99, NULL, NULL, 72132),
(72133, '3.30.450.50-FF-000021', NULL, 'SNARE protein, putative', 147, NULL, NULL, 72133);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(72134, '3.30.540.30-FF-000022', NULL, 'Dipeptidyl peptidase 3', 126, NULL, NULL, 72134),
(72135, '3.30.160.60-FF-002840', NULL, 'Spalt-like transcription factor 1', 33, NULL, NULL, 72135),
(72136, '3.30.40.10-FF-000068', NULL, 'U4/U6.U5 tri-snRNP-associated protein 2', 89, NULL, NULL, 72136),
(72137, '1.10.565.10-FF-000125', NULL, 'nuclear receptor isoform X1', 272, NULL, NULL, 72137),
(72138, '3.30.10.30-FF-000005', NULL, 'Dual-specificity protein kinase, putative', 40, NULL, NULL, 72138),
(72139, '1.10.730.10-FF-000133', NULL, 'Probable methionine--tRNA ligase, mitochondrial', 183, NULL, NULL, 72139),
(72140, '1.10.10.160-FF-000023', NULL, 'ATP-dependent DNA helicase Rep', 76, NULL, NULL, 72140),
(72141, '1.25.40.10-FF-001058', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 94, NULL, NULL, 72141),
(72142, '3.60.20.10-FF-000105', NULL, 'Proteasome subunit beta', 214, NULL, NULL, 72142),
(72143, '3.30.40.10-FF-000911', NULL, 'Chromatin accessibility complex (CHRAC)', 85, NULL, NULL, 72143),
(72144, '2.30.29.30-FF-001270', NULL, 'Predicted protein', 100, NULL, NULL, 72144),
(72145, '3.40.50.150-FF-000339', NULL, 'Nuclear transcription factor Y subunit gamma', 247, NULL, NULL, 72145),
(72146, '1.25.40.10-FF-000658', NULL, 'Hsp70-Hsp90 organizing protein 3', 135, NULL, NULL, 72146),
(72147, '1.10.287.470-FF-000072', NULL, 'Multidrug resistance protein', 74, NULL, NULL, 72147),
(72148, '2.60.120.200-FF-000439', NULL, 'EGFLAM isoform 11', 112, NULL, NULL, 72148),
(72149, '3.90.1200.10-FF-000016', NULL, 'Possible aminoglycoside phosphotransferase', 203, NULL, NULL, 72149),
(72150, '3.30.450.70-FF-000027', NULL, 'Trafficking protein particle complex subunit 2/Sedlin, putative (Eurofung)', 147, NULL, NULL, 72150),
(72151, '3.40.50.300-FF-008181', NULL, 'Ras homolog family member T2', 82, NULL, NULL, 72151),
(72152, '3.40.190.10-FF-000852', NULL, 'Uncharacterized protein', 72, NULL, NULL, 72152),
(72153, '1.10.10.10-FF-001314', NULL, 'DNA-directed RNA polymerase sigma-70 factor', 88, NULL, NULL, 72153),
(72154, '1.25.40.1040-FF-000021', NULL, 'N-terminal acetyltransferase B complex subunit NAA25 homolog', 418, NULL, NULL, 72154),
(72155, '3.30.70.1230-FF-000131', NULL, 'Protein kinase, putative', 185, NULL, NULL, 72155),
(72156, '3.60.10.10-FF-000144', NULL, 'DNA-(apurinic or apyrimidinic site) lyase', 313, NULL, NULL, 72156),
(72157, '3.40.50.850-FF-000010', NULL, 'Nicotinamidase', 216, NULL, NULL, 72157),
(72158, '1.10.10.500-FF-000001', NULL, 'Prospero homeobox protein 1', 171, NULL, NULL, 72158),
(72159, '1.25.40.10-FF-001951', NULL, 'PPR2', 172, NULL, NULL, 72159),
(72160, '3.40.710.10-FF-000027', NULL, 'Penicillin-binding protein 2', 381, NULL, NULL, 72160),
(72161, '3.40.1620.60-FF-000001', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 3', 93, NULL, NULL, 72161),
(72162, '2.60.40.1140-FF-000002', NULL, 'Collagen adhesin', 65, NULL, NULL, 72162),
(72163, '3.20.20.70-FF-000136', NULL, 'Multifunctional tryptophan biosynthesis protein', 283, NULL, NULL, 72163),
(72164, '3.30.70.330-FF-000326', NULL, 'RNA-binding protein 39 isoform X1', 93, NULL, NULL, 72164),
(72165, '1.25.40.20-FF-001212', NULL, 'Uncharacterized protein', 227, NULL, NULL, 72165),
(72166, '3.40.50.920-FF-000031', NULL, 'Pyruvate dehydrogenase E1 component subunit beta', 132, NULL, NULL, 72166),
(72167, '3.30.70.60-FF-000006', NULL, '30S ribosomal protein S6 alpha, chloroplastic', 110, NULL, NULL, 72167),
(72168, '3.80.10.10-FF-002447', NULL, 'Receptor-like protein 6', 250, NULL, NULL, 72168),
(72169, '1.25.40.20-FF-000936', NULL, 'Phytochrome-interacting ankyrin-repeat protein 1', 149, NULL, NULL, 72169),
(72170, '1.20.1280.120-FF-000001', NULL, 'Catalase-related peroxidase', 84, NULL, NULL, 72170),
(72171, '3.40.50.720-FF-001775', NULL, '2-dehydropantoate 2-reductase', 188, NULL, NULL, 72171),
(72172, '1.20.1050.10-FF-000313', NULL, 'Uncharacterized protein', 119, NULL, NULL, 72172),
(72173, '3.30.40.10-FF-001428', NULL, 'Sister chromatid cohesion protein', 69, NULL, NULL, 72173),
(72174, '4.10.375.10-FF-000003', NULL, 'Lipoxygenase', 102, NULL, NULL, 72174);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(72175, '3.40.50.12660-FF-000004', NULL, 'Putative metacaspase family protein', 303, NULL, NULL, 72175),
(72176, '3.90.79.10-FF-000273', NULL, 'Uncharacterized protein', 96, NULL, NULL, 72176),
(72177, '1.25.40.10-FF-002491', NULL, 'Os01g0101150 protein', 92, NULL, NULL, 72177),
(72178, '2.40.160.110-FF-000037', NULL, 'Uncharacterized protein', 177, NULL, NULL, 72178),
(72179, '2.120.10.30-FF-000374', NULL, 'Predicted protein', 98, NULL, NULL, 72179),
(72180, '1.10.10.2260-FF-000001', NULL, 'Chromosome partition protein MukE', 107, NULL, NULL, 72180),
(72181, '3.40.50.300-FF-002559', NULL, 'Death-associated protein kinase dapk-1', 164, NULL, NULL, 72181),
(72182, '2.130.10.10-FF-002604', NULL, 'WD40-repeat-containing domain protein', 411, NULL, NULL, 72182),
(72183, '3.80.10.10-FF-001907', NULL, 'Uncharacterized protein', 108, NULL, NULL, 72183),
(72184, '1.20.58.90-FF-000025', NULL, NULL, 75, NULL, NULL, 72184),
(72185, '3.30.460.10-FF-000206', NULL, 'Uncharacterized protein', 164, NULL, NULL, 72185),
(72186, '3.30.70.330-FF-002136', NULL, NULL, 101, NULL, NULL, 72186),
(72187, '3.40.50.300-FF-001149', NULL, 'Rab40, isoform A', 183, NULL, NULL, 72187),
(72188, '3.90.1600.10-FF-000041', NULL, 'DNA polymerase', 96, NULL, NULL, 72188),
(72189, '1.10.1420.10-FF-000131', NULL, 'Uncharacterized protein', 126, NULL, NULL, 72189),
(72190, '3.10.490.20-FF-000002', NULL, 'Dynein axonemal heavy chain 17', 135, NULL, NULL, 72190),
(72191, '3.40.50.1360-FF-000044', NULL, 'Probable ribose-5-phosphate isomerase 4, chloroplastic', 141, NULL, NULL, 72191),
(72192, '3.30.1180.20-FF-000002', NULL, 'Dihydroxyacetone kinase subunit DhaK', 148, NULL, NULL, 72192),
(72193, '1.10.10.520-FF-000007', NULL, 'UBA3p', 65, NULL, NULL, 72193),
(72194, '1.20.1280.290-FF-000024', NULL, 'Putative membrane protein', 86, NULL, NULL, 72194),
(72195, '3.40.50.720-FF-000151', NULL, '3-phenylpropionate-dihydrodiol/cinnamic acid-dihydrodiol dehydrogenase', 267, NULL, NULL, 72195),
(72196, '3.40.850.10-FF-000291', NULL, 'Kinesin-like protein', 389, NULL, NULL, 72196),
(72197, '3.90.470.10-FF-000025', NULL, '50S ribosomal protein L22', 111, NULL, NULL, 72197),
(72198, '3.10.110.10-FF-000185', NULL, 'Uncharacterized protein', 134, NULL, NULL, 72198),
(72199, '1.10.3130.10-FF-000019', NULL, 'Uncharacterized protein', 52, NULL, NULL, 72199),
(72200, '1.10.10.60-FF-001233', NULL, NULL, 120, NULL, NULL, 72200),
(72201, '1.20.120.70-FF-000001', NULL, 'Capsid protein', 178, NULL, NULL, 72201),
(72202, '3.30.70.330-FF-002659', NULL, NULL, 118, NULL, NULL, 72202),
(72203, '2.60.40.1170-FF-000106', NULL, NULL, 121, NULL, NULL, 72203),
(72204, '1.10.2050.10-FF-000001', NULL, 'Outer capsid protein mu-1', 157, NULL, NULL, 72204),
(72205, '1.20.58.150-FF-000002', NULL, 'clathrin coat assembly protein AP180', 148, NULL, NULL, 72205),
(72206, '3.30.479.20-FF-000005', NULL, 'Elongation factor Ts', 91, NULL, NULL, 72206),
(72207, '3.40.605.10-FF-000064', NULL, 'Uncharacterized protein', 51, NULL, NULL, 72207),
(72208, '3.40.30.10-FF-001270', NULL, 'Predicted protein', 65, NULL, NULL, 72208),
(72209, '1.25.40.10-FF-001390', NULL, 'Pentatricopeptide repeat-containing protein', 126, NULL, NULL, 72209),
(72210, '3.10.110.10-FF-000320', NULL, 'Predicted protein', 165, NULL, NULL, 72210),
(72211, '1.20.1740.10-FF-000220', NULL, 'Uncharacterized protein', 75, NULL, NULL, 72211),
(72212, '1.25.10.10-FF-002843', NULL, 'Uncharacterized protein', 512, NULL, NULL, 72212),
(72213, '2.130.10.10-FF-001244', NULL, 'Mitotic checkpoint protein BUB3.3', 316, NULL, NULL, 72213),
(72214, '2.130.10.10-FF-004813', NULL, 'Uncharacterized protein', 140, NULL, NULL, 72214),
(72215, '3.40.50.300-FF-003919', NULL, 'Uncharacterized protein', 205, NULL, NULL, 72215),
(72216, '3.30.200.20-FF-000382', NULL, 'homeodomain-interacting protein kinase 4', 88, NULL, NULL, 72216),
(72217, '3.30.40.10-FF-000355', NULL, 'rabenosyn-5 isoform X1', 80, NULL, NULL, 72217),
(72218, '3.10.450.50-FF-000003', NULL, 'Nuclear transport factor 2 family protein', 129, NULL, NULL, 72218),
(72219, '4.10.860.120-FF-000013', NULL, 'DNA-directed RNA polymerase subunit', 125, NULL, NULL, 72219);
INSERT INTO "PUBLIC"."MODEL" VALUES
(72220, '3.30.1540.20-FF-000018', NULL, 'DNA mismatch repair protein mutL, putative', 73, NULL, NULL, 72220),
(72221, '1.10.510.10-FF-001050', NULL, 'Serine/threonine-protein kinase CTR1', 184, NULL, NULL, 72221),
(72222, '1.10.510.10-FF-000482', NULL, 'MAP kinase kinase kinase', 296, NULL, NULL, 72222),
(72223, '1.10.150.340-FF-000005', NULL, 'Uncharacterized protein', 64, NULL, NULL, 72223),
(72224, '2.130.10.10-FF-004285', NULL, 'Embryo sac development arrest 7', 127, NULL, NULL, 72224),
(72225, '2.60.120.1000-FF-000011', NULL, 'Collagen alpha-1(XXVII) chain', 202, NULL, NULL, 72225),
(72226, '2.10.220.10-FF-000017', NULL, 'Proprotein convertase subtilisin/kexin type 6', 50, NULL, NULL, 72226),
(72227, '3.40.50.620-FF-000407', NULL, 'Membrane protein', 139, NULL, NULL, 72227),
(72228, '3.30.70.270-FF-000179', NULL, NULL, 73, NULL, NULL, 72228),
(72229, '3.90.1600.10-FF-000046', NULL, 'DNA polymerase', 186, NULL, NULL, 72229),
(72230, '3.30.160.110-FF-000005', NULL, 'Spermine synthase', 99, NULL, NULL, 72230),
(72231, '3.90.1140.10-FF-000022', NULL, 'U6 snRNA phosphodiesterase', 238, NULL, NULL, 72231),
(72232, '3.90.1200.10-FF-000061', NULL, 'Hydroxylysine kinase', 221, NULL, NULL, 72232),
(72233, '3.10.440.10-FF-000013', NULL, 'Uncharacterized protein', 65, NULL, NULL, 72233),
(72234, '1.25.40.20-FF-001443', NULL, 'Uncharacterized protein', 144, NULL, NULL, 72234),
(72235, '1.20.1310.10-FF-000143', NULL, NULL, 138, NULL, NULL, 72235),
(72236, '3.30.200.20-FF-000090', NULL, 'Ribosomal protein S6 kinase', 119, NULL, NULL, 72236),
(72237, '3.80.10.10-FF-004364', NULL, 'Uncharacterized protein', 370, NULL, NULL, 72237),
(72238, '1.25.40.20-FF-000875', NULL, 'Uncharacterized protein', 163, NULL, NULL, 72238),
(72239, '2.30.30.40-FF-000236', NULL, 'N-acetylmuramoyl-L-alanine amidase', 106, NULL, NULL, 72239),
(72240, '1.20.1250.20-FF-001719', NULL, 'Uncharacterized protein', 174, NULL, NULL, 72240),
(72241, '1.10.10.820-FF-000035', NULL, 'Unconventional myosin-IXAb', 50, NULL, NULL, 72241),
(72242, '3.30.950.10-FF-000002', NULL, 'Ribosomal RNA small subunit methyltransferase I', 117, NULL, NULL, 72242),
(72243, '3.90.360.10-FF-000011', NULL, 'Histone acetyltransferase type B catalytic subunit DDB_G0275159', 112, NULL, NULL, 72243),
(72244, '3.30.40.10-FF-000411', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 104, NULL, NULL, 72244),
(72245, '1.20.272.40-FF-000007', NULL, 'Unplaced genomic scaffold supercont1.245, whole genome shotgun sequence', 76, NULL, NULL, 72245),
(72246, '3.30.565.10-FF-000450', NULL, 'Mismatch repair protein', 203, NULL, NULL, 72246),
(72247, '1.25.40.20-FF-001387', NULL, 'Uncharacterized protein', 58, NULL, NULL, 72247),
(72248, '1.20.920.30-FF-000073', NULL, 'Uncharacterized protein', 60, NULL, NULL, 72248),
(72249, '3.40.50.1370-FF-000030', NULL, 'Aspartate carbamoyltransferase', 143, NULL, NULL, 72249),
(72250, '3.90.1150.10-FF-000528', NULL, 'Uncharacterized protein', 115, NULL, NULL, 72250),
(72251, '3.40.47.10-FF-000128', NULL, 'Fatty acid synthase subunit beta', 389, NULL, NULL, 72251),
(72252, '2.40.10.10-FF-000613', NULL, NULL, 109, NULL, NULL, 72252),
(72253, '2.30.30.380-FF-000045', NULL, 'Endonuclease/exonuclease/phosphatase family protein', 63, NULL, NULL, 72253),
(72254, '3.90.820.10-FF-000002', NULL, 'MbtH family protein', 70, NULL, NULL, 72254),
(72255, '3.30.40.10-FF-000299', NULL, 'Histone-lysine N-methyltransferase', 63, NULL, NULL, 72255),
(72256, '1.20.58.60-FF-000213', NULL, 'nesprin-1 isoform X11', 279, NULL, NULL, 72256),
(72257, '3.30.160.60-FF-001148', NULL, 'Zinc finger protein 668', 28, NULL, NULL, 72257),
(72258, '1.25.40.10-FF-002963', NULL, 'Uncharacterized protein', 142, NULL, NULL, 72258),
(72259, '3.30.160.60-FF-005431', NULL, NULL, 83, NULL, NULL, 72259),
(72260, '1.25.10.10-FF-002394', NULL, 'Predicted protein', 1019, NULL, NULL, 72260),
(72261, '1.25.40.20-FF-000931', NULL, 'Uncharacterized protein', 163, NULL, NULL, 72261),
(72262, '3.30.950.30-FF-000008', NULL, 'Schlafen family member 5', 142, NULL, NULL, 72262),
(72263, '2.130.10.10-FF-003740', NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', 411, NULL, NULL, 72263);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(72264, '3.30.70.270-FF-000235', NULL, NULL, 177, NULL, NULL, 72264),
(72265, '1.20.1310.10-FF-000087', NULL, 'CUL4A isoform 1', 81, NULL, NULL, 72265),
(72266, '3.80.10.10-FF-003852', NULL, 'Leucine Rich Repeat family protein', 113, NULL, NULL, 72266),
(72267, '3.60.40.10-FF-000140', NULL, 'Protein phosphatase 2C', 285, NULL, NULL, 72267),
(72268, '1.25.10.10-FF-001882', NULL, 'ARM repeat superfamily protein', 388, NULL, NULL, 72268),
(72269, '1.20.1310.10-FF-000194', NULL, NULL, 88, NULL, NULL, 72269),
(72270, '1.10.8.60-FF-000108', NULL, 'Peroxisomal biogenesis factor 6', 97, NULL, NULL, 72270),
(72271, '2.40.30.20-FF-000033', NULL, 'ATP synthase subunit alpha', 48, NULL, NULL, 72271),
(72272, '1.10.1370.30-FF-000020', NULL, 'Angiotensin-converting enzyme', 292, NULL, NULL, 72272),
(72273, '1.10.10.10-FF-000302', NULL, 'MarR family transcriptional regulator', 152, NULL, NULL, 72273),
(72274, '1.10.472.10-FF-000437', NULL, 'Uncharacterized protein', 128, NULL, NULL, 72274),
(72275, '3.80.10.10-FF-000093', NULL, 'Putative leucine-rich repeat protein shoc-2', 172, NULL, NULL, 72275),
(72276, '3.10.450.240-FF-000002', NULL, 'Mitochondrial import inner membrane translocase subunit TIM44', 192, NULL, NULL, 72276),
(72277, '3.40.50.300-FF-005252', NULL, 'Smf-1', 191, NULL, NULL, 72277),
(72278, '1.10.10.60-FF-001312', NULL, NULL, 60, NULL, NULL, 72278),
(72279, '3.40.850.10-FF-000532', NULL, 'Uncharacterized protein', 375, NULL, NULL, 72279),
(72280, '3.40.50.2000-FF-000388', NULL, 'UDP-glycosyltransferase 79', 192, NULL, NULL, 72280),
(72281, '1.10.287.70-FF-000305', NULL, 'Uncharacterized protein B0310.1', 275, NULL, NULL, 72281),
(72282, '3.10.100.10-FF-000319', NULL, NULL, 150, NULL, NULL, 72282),
(72283, '2.70.98.20-FF-000019', NULL, 'Amine oxidase', 318, NULL, NULL, 72283),
(72284, '2.130.10.10-FF-004178', NULL, 'WD-40 repeat family protein', 164, NULL, NULL, 72284),
(72285, '1.10.260.40-FF-000049', NULL, 'XRE family transcriptional regulator', 69, NULL, NULL, 72285),
(72286, '2.30.30.40-FF-000287', NULL, 'BAI1-associated protein 2-like 2b', 64, NULL, NULL, 72286),
(72287, '3.40.50.1010-FF-000175', NULL, NULL, 189, NULL, NULL, 72287),
(72288, '3.40.50.1010-FF-000231', NULL, NULL, 79, NULL, NULL, 72288),
(72289, '3.30.470.30-FF-000022', NULL, 'mRNA capping enzyme', 99, NULL, NULL, 72289),
(72290, '3.30.460.10-FF-000038', NULL, 'Topoisomerase-related function protein-like protein', 108, NULL, NULL, 72290),
(72291, '3.60.40.10-FF-000033', NULL, 'Protein phosphatase 1K, mitochondrial', 271, NULL, NULL, 72291),
(72292, '3.10.20.360-FF-000010', NULL, NULL, 120, NULL, NULL, 72292),
(72293, '1.10.150.780-FF-000002', NULL, 'Probable vacuolar protein sorting-associated protein 16 homolog', 101, NULL, NULL, 72293),
(72294, '3.20.20.100-FF-000019', NULL, 'NADP-dependent D-sorbitol-6-phosphate dehydrogenase', 307, NULL, NULL, 72294),
(72295, '4.10.400.10-FF-000361', NULL, 'Uncharacterized protein', 44, NULL, NULL, 72295),
(72296, '1.20.58.60-FF-000157', NULL, 'Nesprin-1 isoform 1', 283, NULL, NULL, 72296),
(72297, '2.130.10.10-FF-000070', NULL, 'DNA damage-binding protein 1', 377, NULL, NULL, 72297),
(72298, '3.60.20.10-FF-000026', NULL, 'Proteasome subunit alpha type-1', 251, NULL, NULL, 72298),
(72299, '2.130.10.10-FF-005538', NULL, 'Uncharacterized protein', 179, NULL, NULL, 72299),
(72300, '2.40.50.140-FF-000672', NULL, NULL, 84, NULL, NULL, 72300),
(72301, '3.30.450.20-FF-000602', NULL, 'Uncharacterized protein', 142, NULL, NULL, 72301),
(72302, '2.40.10.10-FF-000664', NULL, NULL, 65, NULL, NULL, 72302),
(72303, '1.25.10.10-FF-002343', NULL, 'Uncharacterized protein', 288, NULL, NULL, 72303),
(72304, '3.40.50.300-FF-008006', NULL, 'ADP-ribosylation factor GTPase-activating protein AGD12', 148, NULL, NULL, 72304),
(72305, '3.30.160.60-FF-004818', NULL, NULL, 55, NULL, NULL, 72305),
(72306, '3.30.50.10-FF-000176', NULL, 'Uncharacterized protein', 66, NULL, NULL, 72306),
(72307, '1.20.1250.20-FF-000433', NULL, 'Aminotriazole resistance protein', 196, NULL, NULL, 72307),
(72308, '1.20.144.10-FF-000061', NULL, 'PAP2-domain-containing protein', 225, NULL, NULL, 72308);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(72309, '3.90.740.10-FF-000001', NULL, 'Leucine--tRNA ligase, cytoplasmic', 259, NULL, NULL, 72309),
(72310, '3.40.50.300-FF-004684', NULL, 'SPbeta prophage-derived sublancin-168-processing and transport ATP-binding protein SunT', 234, NULL, NULL, 72310),
(72311, '1.10.3720.10-FF-000194', NULL, 'Dipeptide ABC transporter, permease protein', 219, NULL, NULL, 72311),
(72312, '2.60.40.150-FF-000628', NULL, 'Synaptotagmin 56', 140, NULL, NULL, 72312),
(72313, '3.40.50.2300-FF-000753', NULL, 'Uncharacterized protein', 149, NULL, NULL, 72313),
(72314, '2.40.100.10-FF-000030', NULL, 'Peptidyl-prolyl cis-trans isomerase', 187, NULL, NULL, 72314),
(72315, '1.25.40.10-FF-005329', NULL, 'Uncharacterized protein', 99, NULL, NULL, 72315),
(72316, '1.10.3720.10-FF-000087', NULL, 'Amino acid ABC transporter permease', 215, NULL, NULL, 72316),
(72317, '3.30.505.10-FF-000002', NULL, 'Tensin 1', 112, NULL, NULL, 72317),
(72318, '2.130.10.10-FF-001267', NULL, 'Os07g0660700 protein', 124, NULL, NULL, 72318),
(72319, '3.40.50.150-FF-001800', NULL, NULL, 136, NULL, NULL, 72319),
(72320, '1.10.8.60-FF-000260', NULL, 'Replication-associated recombination protein A', 69, NULL, NULL, 72320),
(72321, '2.60.120.10-FF-000223', NULL, 'Uncharacterized NTE family protein ZK370.4', 116, NULL, NULL, 72321),
(72322, '2.130.10.30-FF-000076', NULL, 'E3 ubiquitin-protein ligase hyd', 199, NULL, NULL, 72322),
(72323, '1.10.10.60-FF-001256', NULL, NULL, 62, NULL, NULL, 72323),
(72324, '3.40.47.10-FF-000173', NULL, NULL, 130, NULL, NULL, 72324),
(72325, '3.60.10.10-FF-000312', NULL, 'Uncharacterized protein', 294, NULL, NULL, 72325),
(72326, '3.30.160.60-FF-004077', NULL, NULL, 28, NULL, NULL, 72326),
(72327, '3.40.250.10-FF-000054', NULL, 'Dual specificity phosphatase 9', 144, NULL, NULL, 72327),
(72328, '2.130.10.120-FF-000029', NULL, 'Uncharacterized protein', 185, NULL, NULL, 72328),
(72329, '2.60.40.150-FF-000735', NULL, 'Uncharacterized protein', 110, NULL, NULL, 72329),
(72330, '3.30.40.10-FF-002209', NULL, 'Uncharacterized protein', 71, NULL, NULL, 72330),
(72331, '2.130.10.10-FF-001323', NULL, 'Intraflagellar transport 140', 242, NULL, NULL, 72331),
(72332, '4.10.1000.10-FF-000024', NULL, 'Zinc finger CCCH domain-containing protein 11A', 58, NULL, NULL, 72332),
(72333, '1.10.1580.10-FF-000024', NULL, 'Nucleolar GTP-binding protein 2', 93, NULL, NULL, 72333),
(72334, '1.20.140.100-FF-000002', NULL, 'Cytoplasmic dynein heavy chain 1', 151, NULL, NULL, 72334),
(72335, '3.40.47.10-FF-000280', NULL, NULL, 47, NULL, NULL, 72335),
(72336, '1.10.3160.10-FF-000004', NULL, 'Outer surface protein', 219, NULL, NULL, 72336),
(72337, '1.20.1250.20-FF-000377', NULL, 'MFS transporter', 391, NULL, NULL, 72337),
(72338, '3.40.50.2300-FF-001321', NULL, NULL, 102, NULL, NULL, 72338),
(72339, '1.10.20.10-FF-000016', NULL, 'Histone H2B', 122, NULL, NULL, 72339),
(72340, '2.30.30.140-FF-000153', NULL, 'GM26024', 59, NULL, NULL, 72340),
(72341, '3.60.21.10-FF-000068', NULL, 'Serine/threonine-protein phosphatase', 325, NULL, NULL, 72341),
(72342, '1.20.1250.20-FF-001782', NULL, 'Probable 3-phenylpropionic acid transporter', 182, NULL, NULL, 72342),
(72343, '3.30.70.330-FF-000219', NULL, 'Putative polyadenylation factor subunit CstF64', 97, NULL, NULL, 72343),
(72344, '1.10.10.60-FF-000851', NULL, NULL, 60, NULL, NULL, 72344),
(72345, '1.10.720.80-FF-000001', NULL, 'E3 ubiquitin-protein ligase HECTD1 isoform X3', 89, NULL, NULL, 72345),
(72346, '1.10.3380.10-FF-000043', NULL, 'Uncharacterized protein', 142, NULL, NULL, 72346),
(72347, '2.60.40.1510-FF-000028', NULL, 'integrin alpha-PS1 isoform X1', 130, NULL, NULL, 72347),
(72348, '3.40.190.10-FF-000560', NULL, 'Transcriptional regulatory protein', 40, NULL, NULL, 72348),
(72349, '3.40.50.300-FF-004791', NULL, 'Putative tRNA delta(2)-isopentenylpyrophosphate transferase', 266, NULL, NULL, 72349),
(72350, '3.30.300.20-FF-000035', NULL, 'OsmC family peroxiredoxin', 133, NULL, NULL, 72350),
(72351, '1.10.3720.10-FF-000143', NULL, 'Amino acid ABC transporter permease protein', 236, NULL, NULL, 72351);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(72352, '3.50.30.30-FF-000062', NULL, 'N-acetylated-alpha-linked acidic dipeptidase 2', 227, NULL, NULL, 72352),
(72353, '3.90.228.10-FF-000030', NULL, 'Poly [ADP-ribose] polymerase', 211, NULL, NULL, 72353),
(72354, '1.20.120.1910-FF-000008', NULL, 'Cysteine-tRNA ligase', 189, NULL, NULL, 72354),
(72355, '3.90.1300.10-FF-000006', NULL, 'Urea amidolyase', 327, NULL, NULL, 72355),
(72356, '2.10.25.10-FF-001621', NULL, 'Predicted protein', 52, NULL, NULL, 72356),
(72357, '1.10.287.1490-FF-000131', NULL, 'Uncharacterized protein', 113, NULL, NULL, 72357),
(72358, '1.25.40.730-FF-000015', NULL, 'Clathrin heavy chain', 97, NULL, NULL, 72358),
(72359, '3.40.50.1220-FF-000064', NULL, 'SIR2 family protein', 67, NULL, NULL, 72359),
(72360, '3.30.160.60-FF-004970', NULL, NULL, 34, NULL, NULL, 72360),
(72361, '1.10.510.10-FF-001847', NULL, 'Serine/threonine-protein kinase ATG1t isoform B', 140, NULL, NULL, 72361),
(72362, '3.40.50.150-FF-001744', NULL, NULL, 247, NULL, NULL, 72362),
(72363, '3.30.200.20-FF-001450', NULL, NULL, 127, NULL, NULL, 72363),
(72364, '3.40.50.300-FF-005988', NULL, 'Uncharacterized protein', 185, NULL, NULL, 72364),
(72365, '1.20.1510.10-FF-000068', NULL, NULL, 240, NULL, NULL, 72365),
(72366, '2.60.40.60-FF-000820', NULL, 'Uncharacterized protein', 109, NULL, NULL, 72366),
(72367, '1.25.40.10-FF-000546', NULL, 'Tetratricopeptide repeat domain 37', 211, NULL, NULL, 72367),
(72368, '1.25.40.20-FF-000083', NULL, 'Uveal autoantigen with coiled-coil domains and ankyrin repeats', 146, NULL, NULL, 72368),
(72369, '2.130.10.10-FF-000811', NULL, 'Intraflagellar transport 140', 293, NULL, NULL, 72369),
(72370, '3.30.30.170-FF-000001', NULL, 'Eukaryotic translation initiation factor 2 subunit', 143, NULL, NULL, 72370),
(72371, '3.10.350.10-FF-000079', NULL, 'Fused lipid transporter subunits of ABC superfamily: membrane component/ATP-binding component', 70, NULL, NULL, 72371),
(72372, '2.130.10.10-FF-000923', NULL, 'Protein transport protein (LST8), putative', 269, NULL, NULL, 72372),
(72373, '2.130.10.10-FF-005134', NULL, 'Intraflagellar transport 140', 149, NULL, NULL, 72373),
(72374, '3.30.420.10-FF-000204', NULL, 'Ribonuclease HII', 207, NULL, NULL, 72374),
(72375, '1.10.1900.40-FF-000008', NULL, 'Erythrocyte membrane protein 1 (PfEMP1)', 70, NULL, NULL, 72375),
(72376, '1.10.630.10-FF-000541', NULL, 'Uncharacterized protein', 355, NULL, NULL, 72376),
(72377, '3.30.160.60-FF-004026', NULL, NULL, 35, NULL, NULL, 72377),
(72378, '3.30.1740.20-FF-000011', NULL, '40S ribosomal protein S26', 41, NULL, NULL, 72378),
(72379, '1.25.40.10-FF-002171', NULL, 'Pentatricopeptide repeat-containing protein', 147, NULL, NULL, 72379),
(72380, '2.40.70.10-FF-000257', NULL, NULL, 87, NULL, NULL, 72380),
(72381, '3.30.420.270-FF-000012', NULL, 'Biopolymer transporter ExbD', 68, NULL, NULL, 72381),
(72382, '2.70.40.10-FF-000018', NULL, 'dCTP deaminase', 169, NULL, NULL, 72382),
(72383, '3.50.50.60-FF-001061', NULL, 'Pcyox1l protein', 101, NULL, NULL, 72383),
(72384, '1.10.620.20-FF-000026', NULL, 'Uncharacterized protein', 271, NULL, NULL, 72384),
(72385, '3.30.420.40-FF-001096', NULL, 'Uncharacterized protein', 73, NULL, NULL, 72385),
(72386, '1.10.645.10-FF-000007', NULL, 'Sulfhydrogenase 1 subunit alpha', 419, NULL, NULL, 72386),
(72387, '1.10.10.10-FF-001606', NULL, 'Uncharacterized protein', 95, NULL, NULL, 72387),
(72388, '2.60.220.50-FF-000080', NULL, 'Adhesion G protein-coupled receptor D2', 194, NULL, NULL, 72388),
(72389, '2.10.220.10-FF-000068', NULL, 'Receptor protein-tyrosine kinase', 110, NULL, NULL, 72389),
(72390, '1.20.920.30-FF-000022', NULL, 'Dynein heavy chain, putative', 216, NULL, NULL, 72390),
(72391, '1.10.10.60-FF-000800', NULL, NULL, 63, NULL, NULL, 72391),
(72392, '3.40.50.1000-FF-000402', NULL, 'Copper-translocating P-type ATPase', 167, NULL, NULL, 72392),
(72393, '2.60.40.10-FF-002975', NULL, 'Vein, isoform C', 136, NULL, NULL, 72393),
(72394, '2.130.10.10-FF-000862', NULL, 'Guanine nucleotide-exchange factor SEC12', 352, NULL, NULL, 72394),
(72395, '3.10.20.90-FF-000108', NULL, 'Elongin-B', 98, NULL, NULL, 72395);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(72396, '2.60.40.10-FF-004425', NULL, NULL, 93, NULL, NULL, 72396),
(72397, '3.30.70.270-FF-000286', NULL, NULL, 92, NULL, NULL, 72397),
(72398, '1.10.10.160-FF-000028', NULL, 'DNA helicase', 82, NULL, NULL, 72398),
(72399, '3.30.450.270-FF-000001', NULL, 'Phytochrome', 137, NULL, NULL, 72399),
(72400, '4.10.1000.10-FF-000075', NULL, 'Zinc finger CCCH domain-containing protein 42', 60, NULL, NULL, 72400),
(72401, '2.10.25.10-FF-001065', NULL, 'Epidermal growth factor', 42, NULL, NULL, 72401),
(72402, '1.20.1070.10-FF-000551', NULL, 'Vomeronasal type-1 receptor', 255, NULL, NULL, 72402),
(72403, '1.10.287.40-FF-000021', NULL, 'Seryl-tRNA synthetase family protein', 111, NULL, NULL, 72403),
(72404, '1.10.150.20-FF-000176', NULL, 'DNA ligase B', 54, NULL, NULL, 72404),
(72405, '3.30.505.10-FF-000053', NULL, 'Dual adapter for phosphotyrosine and 3-phosphotyrosine and 3-phosphoinositide', 121, NULL, NULL, 72405),
(72406, '3.30.160.60-FF-001204', NULL, 'Zinc finger protein 524', 63, NULL, NULL, 72406),
(72407, '1.25.40.10-FF-003531', NULL, 'Uncharacterized protein', 103, NULL, NULL, 72407),
(72408, '1.20.120.720-FF-000032', NULL, 'Neither inactivation nor afterpotential protein C', 132, NULL, NULL, 72408),
(72409, '2.60.40.10-FF-003065', NULL, 'Kekkon5, isoform A', 102, NULL, NULL, 72409),
(72410, '1.25.40.10-FF-004817', NULL, 'Chromosome 1, whole genome shotgun sequence', 153, NULL, NULL, 72410),
(72411, '3.90.70.80-FF-000049', NULL, 'Uncharacterized protein', 136, NULL, NULL, 72411),
(72412, '1.10.238.150-FF-000011', NULL, 'Formin-F', 80, NULL, NULL, 72412),
(72413, '3.60.40.10-FF-000084', NULL, 'Protein phosphatase, Mg2+/Mn2+ dependent 1A', 91, NULL, NULL, 72413),
(72414, '3.40.50.300-FF-004639', NULL, 'Recombinase RecB', 129, NULL, NULL, 72414),
(72415, '1.20.1560.10-FF-000751', NULL, 'Uncharacterized protein', 75, NULL, NULL, 72415),
(72416, '2.60.40.820-FF-000015', NULL, 'T-box transcription factor mls-1', 186, NULL, NULL, 72416),
(72417, '3.30.70.330-FF-002243', NULL, NULL, 110, NULL, NULL, 72417),
(72418, '3.70.10.10-FF-000115', NULL, 'Proliferating cell nuclear antigen', 242, NULL, NULL, 72418),
(72419, '1.10.3080.10-FF-000003', NULL, 'Chloride channel 2', 482, NULL, NULL, 72419),
(72420, '3.40.710.10-FF-000134', NULL, 'Beta-lactamase', 255, NULL, NULL, 72420),
(72421, '3.40.50.300-FF-003279', NULL, 'Ca2+-channel-protein-beta-subunit, isoform M', 195, NULL, NULL, 72421),
(72422, '3.30.1360.40-FF-000027', NULL, 'DNA topoisomerase 2', 95, NULL, NULL, 72422),
(72423, '2.30.29.30-FF-000213', NULL, 'Docking protein 3', 117, NULL, NULL, 72423),
(72424, '3.40.630.70-FF-000011', NULL, NULL, 187, NULL, NULL, 72424),
(72425, '1.20.144.10-FF-000066', NULL, 'Phospholipid phosphatase 5', 221, NULL, NULL, 72425),
(72426, '1.10.10.10-FF-000246', NULL, 'Transcriptional regulator, ArsR family', 105, NULL, NULL, 72426),
(72427, '2.40.50.140-FF-001161', NULL, NULL, 82, NULL, NULL, 72427),
(72428, '3.90.190.10-FF-000094', NULL, 'Probable tyrosine-protein phosphatase', 149, NULL, NULL, 72428),
(72429, '1.25.40.730-FF-000010', NULL, 'Clathrin heavy chain', 99, NULL, NULL, 72429),
(72430, '3.30.160.60-FF-003121', NULL, 'zinc finger protein 250', 30, NULL, NULL, 72430),
(72431, '3.30.2060.10-FF-000001', NULL, 'Penicillin-binding protein 1B', 90, NULL, NULL, 72431),
(72432, '1.20.930.10-FF-000028', NULL, 'Transcription elongation factor (TFIIS) family protein', 135, NULL, NULL, 72432),
(72433, '1.20.5.900-FF-000003', NULL, 'CD4', 60, NULL, NULL, 72433),
(72434, '1.10.10.10-FF-001651', NULL, 'Uncharacterized protein', 77, NULL, NULL, 72434),
(72435, '3.30.160.60-FF-002497', NULL, 'Regulatory protein MIG2', 28, NULL, NULL, 72435),
(72436, '2.130.10.10-FF-002609', NULL, 'Uncharacterized protein', 233, NULL, NULL, 72436),
(72437, '2.60.40.1510-FF-000023', NULL, 'integrin alpha-PS3 isoform X2', 127, NULL, NULL, 72437),
(72438, '3.40.140.100-FF-000013', NULL, 'Ubiquitin-like modifier-activating enzyme ATG7', 106, NULL, NULL, 72438),
(72439, '3.30.760.10-FF-000078', NULL, 'Uncharacterized protein', 217, NULL, NULL, 72439);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(72440, '3.40.50.300-FF-006949', NULL, 'Putative twitching motility protein PilT', 225, NULL, NULL, 72440),
(72441, '3.30.70.870-FF-000027', NULL, 'Elongation factor G, mitochondrial', 51, NULL, NULL, 72441),
(72442, '3.30.420.40-FF-000191', NULL, 'Retrograde regulation protein 2', 139, NULL, NULL, 72442),
(72443, '3.40.1620.60-FF-000006', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 5', 92, NULL, NULL, 72443),
(72444, '2.60.40.10-FF-000159', NULL, 'neural cell adhesion molecule 1 isoform X2', 101, NULL, NULL, 72444),
(72445, '2.30.42.10-FF-000232', NULL, 'Uncharacterized protein, isoform A', 100, NULL, NULL, 72445),
(72446, '3.40.50.720-FF-002236', NULL, 'Uncharacterized protein', 92, NULL, NULL, 72446),
(72447, '1.10.260.40-FF-000044', NULL, 'Homeobox domain-containing protein', 91, NULL, NULL, 72447),
(72448, '3.80.10.10-FF-004196', NULL, 'Tyrosine-protein kinase receptor', 91, NULL, NULL, 72448),
(72449, '3.90.226.10-FF-000256', NULL, 'PDZ domain-containing protein', 163, NULL, NULL, 72449),
(72450, '3.80.10.10-FF-004252', NULL, 'Uncharacterized protein', 260, NULL, NULL, 72450),
(72451, '1.10.260.40-FF-000100', NULL, 'Uncharacterized protein', 71, NULL, NULL, 72451),
(72452, '2.30.42.10-FF-000176', NULL, 'Signal-induced proliferation-associated 1', 79, NULL, NULL, 72452),
(72453, '1.10.1380.10-FF-000020', NULL, 'NEPrilysin metallopeptidase family', 416, NULL, NULL, 72453),
(72454, '2.60.210.10-FF-000045', NULL, NULL, 155, NULL, NULL, 72454),
(72455, '3.40.50.300-FF-007517', NULL, 'P. aerophilum family 417, putative ATP binding', 212, NULL, NULL, 72455),
(72456, '3.60.21.50-FF-000001', NULL, 'DNA polymerase delta 2, accessory subunit', 290, NULL, NULL, 72456),
(72457, '3.30.160.60-FF-003065', NULL, 'Small nuclear ribonucleoprotein associated', 54, NULL, NULL, 72457),
(72458, '1.10.10.990-FF-000002', NULL, 'RecBCD enzyme subunit RecC', 76, NULL, NULL, 72458),
(72459, '3.90.700.10-FF-000004', NULL, 'Succinate dehydrogenase flavoprotein subunit', 109, NULL, NULL, 72459),
(72460, '1.20.58.1280-FF-000002', NULL, 'DNA repair protein REV1', 117, NULL, NULL, 72460),
(72461, '3.90.226.10-FF-000312', NULL, 'Uncharacterized protein', 89, NULL, NULL, 72461),
(72462, '1.20.58.70-FF-000042', NULL, 'Syntaxin 11b, tandem duplicate 2', 199, NULL, NULL, 72462),
(72463, '1.10.510.10-FF-003360', NULL, NULL, 190, NULL, NULL, 72463),
(72464, '1.20.1250.20-FF-001607', NULL, 'Uncharacterized protein', 206, NULL, NULL, 72464),
(72465, '2.60.40.10-FF-005774', NULL, NULL, 113, NULL, NULL, 72465),
(72466, '3.80.10.10-FF-000941', NULL, 'Blast resistance protein Pi-ta variant 9', 272, NULL, NULL, 72466),
(72467, '3.40.1360.10-FF-000033', NULL, 'Meiosis-specific topoisomerase Spo11, putative', 236, NULL, NULL, 72467),
(72468, '2.60.40.10-FF-002008', NULL, 'Frazzled, isoform B', 93, NULL, NULL, 72468),
(72469, '3.40.630.30-FF-000139', NULL, 'L-ornithine N5-acetyltransferase NATA1', 206, NULL, NULL, 72469),
(72470, '2.60.40.10-FF-006050', NULL, NULL, 64, NULL, NULL, 72470),
(72471, '1.20.1070.10-FF-000843', NULL, 'Uncharacterized protein', 370, NULL, NULL, 72471),
(72472, '2.130.10.30-FF-000002', NULL, 'E3 ubiquitin-protein ligase MYCBP2 isoform X1', 164, NULL, NULL, 72472),
(72473, '2.10.110.10-FF-000239', NULL, 'Uncharacterized protein', 68, NULL, NULL, 72473),
(72474, '1.20.1270.60-FF-000137', NULL, 'Uncharacterized protein', 141, NULL, NULL, 72474),
(72475, '2.10.25.10-FF-000261', NULL, 'Fibrillin-1', 27, NULL, NULL, 72475),
(72476, '1.25.40.280-FF-000009', NULL, 'Bro1p', 367, NULL, NULL, 72476),
(72477, '1.20.5.110-FF-000305', NULL, 'Predicted protein', 64, NULL, NULL, 72477),
(72478, '1.10.472.10-FF-000549', NULL, 'Cyclin, N-terminal domain containing protein', 75, NULL, NULL, 72478),
(72479, '1.20.1280.50-FF-000022', NULL, 'F-box protein FBW2', 43, NULL, NULL, 72479),
(72480, '3.40.50.10880-FF-000009', NULL, 'DUF89 domain-containing protein', 108, NULL, NULL, 72480),
(72481, '3.30.470.30-FF-000078', NULL, 'Uncharacterized protein', 95, NULL, NULL, 72481),
(72482, '1.25.40.10-FF-000597', NULL, 'Pre-mRNA-splicing factor CLF1', 163, NULL, NULL, 72482);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(72483, '2.160.20.10-FF-000333', NULL, 'Uncharacterized protein', 335, NULL, NULL, 72483),
(72484, '3.10.620.30-FF-000005', NULL, 'SH3 domain protein (Cyk3), putative', 159, NULL, NULL, 72484),
(72485, '3.40.50.1000-FF-000638', NULL, NULL, 105, NULL, NULL, 72485),
(72486, '3.30.930.10-FF-000018', NULL, 'Serine--tRNA ligase', 326, NULL, NULL, 72486),
(72487, '4.10.60.10-FF-000006', NULL, 'cellular nucleic acid-binding protein-like isoform X1', 32, NULL, NULL, 72487),
(72488, '2.60.120.200-FF-000726', NULL, 'Legume-like lectin, putative', 236, NULL, NULL, 72488),
(72489, '3.50.50.60-FF-000785', NULL, 'Uncharacterized protein', 42, NULL, NULL, 72489),
(72490, '2.30.130.10-FF-000028', NULL, 'PUA domain containing protein', 68, NULL, NULL, 72490),
(72491, '1.25.10.10-FF-000426', NULL, 'Proteasome 26S subunit, non-ATPase 1', 282, NULL, NULL, 72491),
(72492, '3.30.60.30-FF-000053', NULL, 'Complement component C7', 80, NULL, NULL, 72492),
(72493, '1.10.1900.20-FF-000002', NULL, '50S ribosomal protein L20, chloroplastic', 63, NULL, NULL, 72493),
(72494, '1.20.1250.10-FF-000025', NULL, 'Interleukin-2', 134, NULL, NULL, 72494),
(72495, '3.30.160.60-FF-003514', NULL, NULL, 24, NULL, NULL, 72495),
(72496, '1.10.510.10-FF-001842', NULL, 'eIF-2 alpha kinase', 115, NULL, NULL, 72496),
(72497, '3.30.420.40-FF-000932', NULL, 'Os01g0517850 protein', 101, NULL, NULL, 72497),
(72498, '1.10.10.820-FF-000030', NULL, 'Myosin, heavy polypeptide 1.1, skeletal muscle', 34, NULL, NULL, 72498),
(72499, '3.20.70.20-FF-000034', NULL, 'Ribonucleoside-diphosphate reductase large chain, putative', 347, NULL, NULL, 72499),
(72500, '3.40.50.720-FF-001275', NULL, 'Pentafunctional AROM polypeptide', 147, NULL, NULL, 72500),
(72501, '3.30.70.330-FF-002636', NULL, NULL, 176, NULL, NULL, 72501),
(72502, '1.20.1410.10-FF-000027', NULL, 'Cyclin-D1-binding protein 1-like protein', 171, NULL, NULL, 72502),
(72503, '1.25.40.10-FF-004705', NULL, 'Uncharacterized protein', 97, NULL, NULL, 72503),
(72504, '2.60.40.10-FF-000558', NULL, 'Leptin receptor', 98, NULL, NULL, 72504),
(72505, '1.10.12.10-FF-000020', NULL, 'Carnitinyl-CoA dehydratase', 62, NULL, NULL, 72505),
(72506, '1.20.920.10-FF-000207', NULL, 'Uncharacterized protein', 116, NULL, NULL, 72506),
(72507, '2.60.120.200-FF-000378', NULL, 'Collagen, type V, alpha 3a', 240, NULL, NULL, 72507),
(72508, '3.30.230.10-FF-000381', NULL, 'Uncharacterized protein', 190, NULL, NULL, 72508),
(72509, '1.10.10.60-FF-000856', NULL, NULL, 57, NULL, NULL, 72509),
(72510, '1.10.472.80-FF-000205', NULL, NULL, 147, NULL, NULL, 72510),
(72511, '3.40.50.1000-FF-000346', NULL, 'Haloacid dehalogenase family hydrolase, putative', 145, NULL, NULL, 72511),
(72512, '2.30.42.10-FF-000125', NULL, 'PATJ, crumbs cell polarity complex component', 103, NULL, NULL, 72512),
(72513, '3.30.160.60-FF-003806', NULL, NULL, 86, NULL, NULL, 72513),
(72514, '2.130.10.10-FF-000867', NULL, 'Small nucleolar ribonucleoprotein complex subunit Utp15, putative', 151, NULL, NULL, 72514),
(72515, '3.65.10.10-FF-000021', NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', 193, NULL, NULL, 72515),
(72516, '3.30.420.10-FF-000148', NULL, 'DNA polymerase I', 188, NULL, NULL, 72516),
(72517, '1.10.10.10-FF-000358', NULL, 'Acetylserotonin O-methyltransferase', 89, NULL, NULL, 72517),
(72518, '1.25.40.10-FF-000602', NULL, 'rRNA biogenesis protein rrp5', 212, NULL, NULL, 72518),
(72519, '1.10.238.10-FF-000961', NULL, 'Uncharacterized protein', 61, NULL, NULL, 72519),
(72520, '2.60.40.10-FF-002632', NULL, 'YEL043W-like protein', 116, NULL, NULL, 72520),
(72521, '3.80.10.10-FF-001110', NULL, 'CBN-CRML-1 protein', 511, NULL, NULL, 72521),
(72522, '3.40.50.800-FF-000017', NULL, 'Histidine--tRNA ligase chloroplastic/mitochondrial', 93, NULL, NULL, 72522),
(72523, '3.40.50.1000-FF-000689', NULL, NULL, 142, NULL, NULL, 72523),
(72524, '1.20.1050.10-FF-000156', NULL, 'Uncharacterized protein', 150, NULL, NULL, 72524),
(72525, '1.50.10.20-FF-000135', NULL, 'Uncharacterized protein', 190, NULL, NULL, 72525),
(72526, '1.10.150.780-FF-000007', NULL, 'Vacuolar protein sorting-associated protein 16 homolog', 91, NULL, NULL, 72526);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(72527, '2.40.110.10-FF-000036', NULL, 'Acyl-CoA dehydrogenase FadE16', 114, NULL, NULL, 72527),
(72528, '3.40.50.1220-FF-000120', NULL, 'Sir2-type regulatory transcription factor silent information regulator protein', 187, NULL, NULL, 72528),
(72529, '2.40.50.140-FF-000609', NULL, 'Eukaryotic translation initiation factor 5A', 73, NULL, NULL, 72529),
(72530, '2.40.10.120-FF-000017', NULL, 'HtrA-like serine protease', 222, NULL, NULL, 72530),
(72531, '1.10.287.70-FF-000356', NULL, 'Uncharacterized protein', 116, NULL, NULL, 72531),
(72532, '3.40.50.2300-FF-001377', NULL, NULL, 187, NULL, NULL, 72532),
(72533, '2.30.29.30-FF-000218', NULL, 'Epidermal growth factor receptor kinase substrate 8-like 2', 140, NULL, NULL, 72533),
(72534, '1.20.1070.10-FF-000039', NULL, 'somatostatin receptor type 2', 330, NULL, NULL, 72534),
(72535, '1.10.287.70-FF-000412', NULL, 'Putative calcium/potassium channel (CAKC)', 218, NULL, NULL, 72535),
(72536, '3.40.1280.30-FF-000038', NULL, 'tRNA methyltransferase 10A', 72, NULL, NULL, 72536),
(72537, '1.25.40.10-FF-000254', NULL, 'Cell cycle control protein', 152, NULL, NULL, 72537),
(72538, '2.40.160.50-FF-000028', NULL, 'Heme/hemopexin transporter protein HuxB', 381, NULL, NULL, 72538),
(72539, '3.30.200.20-FF-000882', NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase', 112, NULL, NULL, 72539),
(72540, '1.25.10.10-FF-002287', NULL, 'UTP20 small subunit (SSU) processome component', 328, NULL, NULL, 72540),
(72541, '2.40.50.140-FF-001009', NULL, NULL, 101, NULL, NULL, 72541),
(72542, '3.90.400.10-FF-000015', NULL, 'Sucrose phosphorylase', 80, NULL, NULL, 72542),
(72543, '3.40.30.10-FF-000045', NULL, 'Disulfide-isomerase A3', 137, NULL, NULL, 72543),
(72544, '1.10.150.570-FF-000001', NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', 53, NULL, NULL, 72544),
(72545, '3.80.10.10-FF-000834', NULL, 'Probable disease resistance protein At1g15890', 360, NULL, NULL, 72545),
(72546, '3.10.290.70-FF-000007', NULL, '40S ribosomal protein S8', 79, NULL, NULL, 72546),
(72547, '2.40.30.330-FF-000011', NULL, 'mRNA cleavage and polyadenylation factor CLP1', 132, NULL, NULL, 72547),
(72548, '2.20.25.100-FF-000004', NULL, '30S ribosomal protein S27e', 54, NULL, NULL, 72548),
(72549, '1.20.120.1750-FF-000157', NULL, 'RBR-type E3 ubiquitin transferase', 70, NULL, NULL, 72549),
(72550, '3.40.1280.10-FF-000032', NULL, 'rRNA methyltransferase 1, mitochondrial', 188, NULL, NULL, 72550),
(72551, '3.30.710.10-FF-000344', NULL, 'MigA', 167, NULL, NULL, 72551),
(72552, '3.40.350.10-FF-000095', NULL, 'Xaa-Pro aminopeptidase 1-like Protein', 156, NULL, NULL, 72552),
(72553, '2.60.120.200-FF-000434', NULL, 'Uncharacterized protein', 315, NULL, NULL, 72553),
(72554, '3.30.710.10-FF-000131', NULL, 'Blast:Broad-complex core protein isoform 6', 123, NULL, NULL, 72554),
(72555, '3.30.160.60-FF-003857', NULL, NULL, 32, NULL, NULL, 72555),
(72556, '3.40.50.12470-FF-000009', NULL, '2-oxoglutarate dehydrogenase E1 component', 222, NULL, NULL, 72556),
(72557, '3.90.470.20-FF-000062', NULL, '4''-phosphopantetheinyl transferase PfaE', 84, NULL, NULL, 72557),
(72558, '2.60.40.10-FF-001519', NULL, 'Sidestep, isoform B', 96, NULL, NULL, 72558),
(72559, '3.30.30.170-FF-000006', NULL, 'Eukaryotic translation initiation factor 2 beta subunit', 141, NULL, NULL, 72559),
(72560, '2.60.40.10-FF-003121', NULL, 'High Incidence of Males (Increased X chromosome loss)', 92, NULL, NULL, 72560),
(72561, '3.30.300.20-FF-000030', NULL, 'Ribosome-binding factor A', 118, NULL, NULL, 72561),
(72562, '2.60.40.150-FF-000679', NULL, 'Protein kinase C', 75, NULL, NULL, 72562),
(72563, '3.30.70.330-FF-002075', NULL, NULL, 83, NULL, NULL, 72563),
(72564, '3.40.50.1820-FF-000024', NULL, 'acyl-coenzyme A thioesterase 4', 286, NULL, NULL, 72564),
(72565, '3.20.20.70-FF-000473', NULL, 'Fructose-bisphosphate aldolase 3 chloroplastic', 141, NULL, NULL, 72565),
(72566, '3.40.50.300-FF-006157', NULL, 'DNA helicase', 110, NULL, NULL, 72566),
(72567, '3.20.20.80-FF-000257', NULL, 'Glycogen debranching enzyme putative', 239, NULL, NULL, 72567);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(72568, '3.30.930.10-FF-000170', NULL, 'Alanine--tRNA ligase', 236, NULL, NULL, 72568),
(72569, '1.20.1420.30-FF-000067', NULL, 'Uncharacterized protein', 124, NULL, NULL, 72569),
(72570, '2.60.40.10-FF-000210', NULL, 'Fibronectin type III domain containing 3A', 101, NULL, NULL, 72570),
(72571, '3.30.499.10-FF-000003', NULL, 'Aconitate hydratase, mitochondrial', 172, NULL, NULL, 72571),
(72572, '2.40.50.40-FF-000097', NULL, 'Uncharacterized protein', 73, NULL, NULL, 72572),
(72573, '3.30.420.510-FF-000005', NULL, 'Probable pantothenate kinase', 128, NULL, NULL, 72573),
(72574, '3.30.460.10-FF-000145', NULL, 'Ribosomal silencing factor RsfS', 107, NULL, NULL, 72574),
(72575, '2.60.120.10-FF-000167', NULL, 'DNA-binding transcriptional activator YeiL', 195, NULL, NULL, 72575),
(72576, '3.60.10.10-FF-000256', NULL, 'Probable secreted protein', 235, NULL, NULL, 72576),
(72577, '3.30.230.10-FF-000318', NULL, 'Uncharacterized protein', 141, NULL, NULL, 72577),
(72578, '3.30.70.2690-FF-000001', NULL, 'Lysine-ketoglutarate reductase/saccharopine dehydrogenase1', 89, NULL, NULL, 72578),
(72579, '3.40.50.300-FF-003335', NULL, 'Ras family protein', 174, NULL, NULL, 72579),
(72580, '3.30.1360.100-FF-000001', NULL, 'Type II secretion system protein M', 77, NULL, NULL, 72580),
(72581, '3.30.2140.10-FF-000002', NULL, 'Uncharacterized protein', 42, NULL, NULL, 72581),
(72582, '3.90.320.10-FF-000014', NULL, 'ATP-dependent helicase/nuclease subunit A', 223, NULL, NULL, 72582),
(72583, '3.90.830.10-FF-000008', NULL, 'SNARE-interacting protein KEULE', 124, NULL, NULL, 72583),
(72584, '3.30.470.20-FF-000249', NULL, 'Predicted protein', 46, NULL, NULL, 72584),
(72585, '3.40.50.1820-FF-000709', NULL, 'Alpha/beta fold hydrolase', 183, NULL, NULL, 72585),
(72586, '3.40.50.300-FF-001885', NULL, 'DNA mismatch repair protein', 276, NULL, NULL, 72586),
(72587, '3.40.50.1110-FF-000143', NULL, 'Predicted protein', 185, NULL, NULL, 72587),
(72588, '3.30.420.40-FF-000752', NULL, 'AGR099Cp', 65, NULL, NULL, 72588),
(72589, '2.60.40.10-FF-002683', NULL, 'Predicted protein', 103, NULL, NULL, 72589),
(72590, '3.40.50.10330-FF-000042', NULL, 'Diacylglycerol kinase', 138, NULL, NULL, 72590),
(72591, '3.30.590.50-FF-000008', NULL, 'Gamma-glutamylcysteine synthetase', 96, NULL, NULL, 72591),
(72592, '3.60.10.10-FF-000205', NULL, 'Phosphatidylinositol 3,4,5-trisphosphate 5-phosphatase 2B', 315, NULL, NULL, 72592),
(72593, '1.20.58.1970-FF-000001', NULL, 'Conserved oligomeric Golgi complex subunit 4', 170, NULL, NULL, 72593),
(72594, '1.10.1420.10-FF-000187', NULL, 'DNA mismatch repair protein', 132, NULL, NULL, 72594),
(72595, '1.10.630.10-FF-000485', NULL, 'Predicted protein', 471, NULL, NULL, 72595),
(72596, '2.130.10.10-FF-002380', NULL, 'WD domain, G-beta repeat, putative', 285, NULL, NULL, 72596),
(72597, '3.40.50.300-FF-007045', NULL, 'Uncharacterized protein', 199, NULL, NULL, 72597),
(72598, '3.90.25.10-FF-000093', NULL, 'Uncharacterized protein', 60, NULL, NULL, 72598),
(72599, '3.90.370.10-FF-000017', NULL, 'Uncharacterized protein', 14, NULL, NULL, 72599),
(72600, '1.20.1420.30-FF-000016', NULL, 'Membrane bound cation transporter', 156, NULL, NULL, 72600),
(72601, '3.40.1280.10-FF-000083', NULL, 'RNA methyltransferase, TrmH family, group 3', 168, NULL, NULL, 72601),
(72602, '1.20.58.1520-FF-000007', NULL, 'Spd-1', 129, NULL, NULL, 72602),
(72603, '2.170.270.10-FF-000180', NULL, 'Si:dkeyp-41f9.4', 76, NULL, NULL, 72603),
(72604, '2.170.130.20-FF-000015', NULL, NULL, 103, NULL, NULL, 72604),
(72605, '3.40.50.300-FF-006556', NULL, 'Uncharacterized protein', 104, NULL, NULL, 72605),
(72606, '1.20.120.20-FF-000008', NULL, 'Apolipoprotein A-IV a', 105, NULL, NULL, 72606),
(72607, '3.80.10.10-FF-003796', NULL, 'EIN3-binding F-box protein 1', 93, NULL, NULL, 72607),
(72608, '3.40.367.20-FF-000024', NULL, 'Phosphotransferase', 38, NULL, NULL, 72608),
(72609, '1.20.58.60-FF-000106', NULL, 'Spectrin beta chain', 110, NULL, NULL, 72609),
(72610, '2.160.20.10-FF-000277', NULL, 'Uncharacterized protein', 243, NULL, NULL, 72610),
(72611, '1.25.40.10-FF-004525', NULL, 'Uncharacterized protein', 71, NULL, NULL, 72611);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(72612, '3.40.50.200-FF-000113', NULL, 'Clan SB, family S8, subtilisin-like serine peptidase', 357, NULL, NULL, 72612),
(72613, '3.20.20.140-FF-000239', NULL, 'Adenosine deaminase', 303, NULL, NULL, 72613),
(72614, '1.20.120.1760-FF-000042', NULL, 'Bifunctional IPC transferase and DIPP synthase', 192, NULL, NULL, 72614),
(72615, '3.40.50.10380-FF-000028', NULL, 'NADP-dependent malic enzyme 4 chloroplastic', 84, NULL, NULL, 72615),
(72616, '3.10.290.20-FF-000021', NULL, 'Uncharacterized protein', 81, NULL, NULL, 72616),
(72617, '2.60.40.10-FF-001671', NULL, 'Immunoglobulin lambda variable 4-69', 107, NULL, NULL, 72617),
(72618, '3.40.50.300-FF-005196', NULL, 'Septin-domain-containing protein', 307, NULL, NULL, 72618),
(72619, '4.10.240.10-FF-000207', NULL, 'Uncharacterized transcriptional regulatory protein C25B8.11', 69, NULL, NULL, 72619),
(72620, '1.25.40.20-FF-001151', NULL, 'Uncharacterized protein', 143, NULL, NULL, 72620),
(72621, '1.25.40.10-FF-001614', NULL, 'Hypothetical_protein_-_conserved', 206, NULL, NULL, 72621),
(72622, '1.10.3860.10-FF-000029', NULL, 'Amino acid transporter', 408, NULL, NULL, 72622),
(72623, '3.40.850.10-FF-000476', NULL, 'Predicted protein', 350, NULL, NULL, 72623),
(72624, '3.30.750.140-FF-000002', NULL, 'Flagellar hook-length control protein', 132, NULL, NULL, 72624),
(72625, '3.40.50.150-FF-000783', NULL, 'Uncharacterized protein', 174, NULL, NULL, 72625),
(72626, '3.40.50.1400-FF-000022', NULL, 'Ferrochelatase', 182, NULL, NULL, 72626),
(72627, '2.30.30.60-FF-000006', NULL, 'Predicted mechanosensitive ion channel', 50, NULL, NULL, 72627),
(72628, '3.80.10.10-FF-004072', NULL, 'Tubulin folding cofactor E', 130, NULL, NULL, 72628),
(72629, '2.30.42.10-FF-000648', NULL, NULL, 89, NULL, NULL, 72629),
(72630, '3.90.25.10-FF-000042', NULL, 'Expressed protein', 82, NULL, NULL, 72630),
(72631, '1.25.70.10-FF-000082', NULL, NULL, 212, NULL, NULL, 72631),
(72632, '1.25.40.990-FF-000060', NULL, 'Putative 26S proteasome non-ATPase regulatory subunit 8 homolog B', 150, NULL, NULL, 72632),
(72633, '2.130.10.10-FF-001879', NULL, 'Intraflagellar transport protein 80', 137, NULL, NULL, 72633),
(72634, '1.25.40.90-FF-000019', NULL, 'Clathrin coat assembly protein', 155, NULL, NULL, 72634),
(72635, '3.40.50.620-FF-000115', NULL, 'tRNA-specific 2-thiouridylase MnmA', 213, NULL, NULL, 72635),
(72636, '3.80.10.10-FF-001958', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase isoform A', 159, NULL, NULL, 72636),
(72637, '3.40.50.920-FF-000036', NULL, 'Indolepyruvate oxidoreductase subunit IorA', 92, NULL, NULL, 72637),
(72638, '3.40.50.1100-FF-000101', NULL, 'Putative pyridoxal-phosphate dependent protein F13B12.4', 106, NULL, NULL, 72638),
(72639, '1.20.140.30-FF-000007', NULL, 'MOB kinase activator 1B', 122, NULL, NULL, 72639),
(72640, '1.25.10.10-FF-002686', NULL, 'Uncharacterized protein', 75, NULL, NULL, 72640),
(72641, '1.10.510.10-FF-000774', NULL, 'Kinase family protein', 200, NULL, NULL, 72641),
(72642, '3.30.530.20-FF-000187', NULL, 'Uncharacterized protein', 88, NULL, NULL, 72642),
(72643, '3.90.650.10-FF-000062', NULL, 'Phosphoribosylformylglycinamidine synthase-like Protein', 163, NULL, NULL, 72643),
(72644, '3.40.50.2000-FF-000096', NULL, 'ALG1, chitobiosyldiphosphodolichol beta-mannosyltransferase', 175, NULL, NULL, 72644),
(72645, '3.30.60.20-FF-000067', NULL, 'uncharacterized protein LOC108093793 isoform X1', 75, NULL, NULL, 72645),
(72646, '3.30.60.20-FF-000123', NULL, 'Serine/threonine-protein kinase dkf-2', 65, NULL, NULL, 72646),
(72647, '3.30.40.10-FF-002193', NULL, 'Vacuolar segregation protein pep7', 76, NULL, NULL, 72647),
(72648, '1.20.1070.10-FF-000663', NULL, 'Predicted protein', 293, NULL, NULL, 72648),
(72649, '2.10.50.10-FF-000010', NULL, 'Tumor necrosis factor receptor superfamily member 21', 92, NULL, NULL, 72649),
(72650, '1.20.140.10-FF-000001', NULL, 'Acyl-CoA dehydrogenase', 145, NULL, NULL, 72650),
(72651, '3.40.50.11980-FF-000019', NULL, 'Predicted protein', 182, NULL, NULL, 72651),
(72652, '1.10.287.470-FF-000077', NULL, 'Acriflavin resistance periplasmic protein', 59, NULL, NULL, 72652);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(72653, '3.30.70.1320-FF-000006', NULL, 'Transporter AcrB/D/F family protein', 97, NULL, NULL, 72653),
(72654, '1.10.510.10-FF-002859', NULL, NULL, 45, NULL, NULL, 72654),
(72655, '3.40.640.10-FF-000139', NULL, 'Long chain base biosynthesis protein 2a', 251, NULL, NULL, 72655),
(72656, '1.20.1270.60-FF-000249', NULL, 'Probable Rho-GTPase-activating protein 9', 172, NULL, NULL, 72656),
(72657, '3.30.420.10-FF-000592', NULL, NULL, 202, NULL, NULL, 72657),
(72658, '3.30.200.20-FF-001955', NULL, 'Uncharacterized protein', 106, NULL, NULL, 72658),
(72659, '1.10.510.10-FF-000830', NULL, 'PX domain-containing serine/threonine kinase', 294, NULL, NULL, 72659),
(72660, '3.30.70.660-FF-000026', NULL, 'tRNA pseudouridine synthase A', 137, NULL, NULL, 72660),
(72661, '2.40.50.140-FF-000048', NULL, 'DNA replication licensing factor MCM7', 74, NULL, NULL, 72661),
(72662, '3.40.630.30-FF-000027', NULL, 'Protein RibT', 111, NULL, NULL, 72662),
(72663, '3.40.1690.10-FF-000018', NULL, 'Type III secretion system protein', 95, NULL, NULL, 72663),
(72664, '3.40.30.10-FF-000949', NULL, 'Glutathione peroxidase', 108, NULL, NULL, 72664),
(72665, '3.90.70.10-FF-000674', NULL, 'Uncharacterized protein', 278, NULL, NULL, 72665),
(72666, '3.40.50.720-FF-002505', NULL, 'Uncharacterized protein', 140, NULL, NULL, 72666),
(72667, '1.20.1090.10-FF-000041', NULL, 'Hydroxyacid-oxoacid transhydrogenase', 148, NULL, NULL, 72667),
(72668, '2.30.30.490-FF-000022', NULL, 'Blast:Metastasis-associated protein MTA3', 70, NULL, NULL, 72668),
(72669, '3.40.50.300-FF-002846', NULL, 'Os06g0310200 protein', 184, NULL, NULL, 72669),
(72670, '2.130.10.10-FF-003009', NULL, 'Eukaryotic translation initiation factor 2A', 177, NULL, NULL, 72670),
(72671, '2.60.120.920-FF-000144', NULL, 'Cabz01076234.2', 197, NULL, NULL, 72671),
(72672, '3.40.50.1000-FF-000790', NULL, NULL, 58, NULL, NULL, 72672),
(72673, '3.40.50.10860-FF-000077', NULL, 'Uncharacterized protein', 28, NULL, NULL, 72673),
(72674, '1.10.730.10-FF-000026', NULL, 'Methionine--tRNA ligase', 185, NULL, NULL, 72674),
(72675, '1.10.287.70-FF-000013', NULL, 'Glutamate receptor, ionotropic, AMPA 4', 161, NULL, NULL, 72675),
(72676, '3.40.50.11060-FF-000013', NULL, 'Putative GTP-binding protein 6', 127, NULL, NULL, 72676),
(72677, '3.30.40.10-FF-000063', NULL, 'E3 ubiquitin-protein ligase', 67, NULL, NULL, 72677),
(72678, '3.40.50.300-FF-008574', NULL, 'Uncharacterized protein', 30, NULL, NULL, 72678),
(72679, '1.25.40.20-FF-001100', NULL, 'Notch homolog', 248, NULL, NULL, 72679),
(72680, '2.130.10.10-FF-003116', NULL, 'Dynein intermediate chain', 269, NULL, NULL, 72680),
(72681, '3.10.120.10-FF-000034', NULL, 'Fatty acid 2-hydroxylase', 77, NULL, NULL, 72681),
(72682, '1.10.533.10-FF-000231', NULL, 'Predicted protein', 79, NULL, NULL, 72682),
(72683, '2.160.10.10-FF-000091', NULL, 'Transferase hexapeptide repeat containing protein', 157, NULL, NULL, 72683),
(72684, '2.40.50.1000-FF-000004', NULL, '40S ribosomal proteins S11', 156, NULL, NULL, 72684),
(72685, '1.10.238.10-FF-000910', NULL, 'Proline-serine-threonine phosphatase interacting protein 1a', 85, NULL, NULL, 72685),
(72686, '1.10.10.480-FF-000006', NULL, 'Diphosphate-fructose-6-phosphate 1-phosphotransferase', 73, NULL, NULL, 72686),
(72687, '3.80.10.10-FF-004021', NULL, 'Uncharacterized protein', 146, NULL, NULL, 72687),
(72688, '3.30.70.3330-FF-000002', NULL, NULL, 63, NULL, NULL, 72688),
(72689, '3.30.160.60-FF-001772', NULL, 'Uncharacterized protein', 29, NULL, NULL, 72689),
(72690, '1.25.40.10-FF-005037', NULL, 'Uncharacterized protein', 130, NULL, NULL, 72690),
(72691, '3.30.497.10-FF-000128', NULL, 'Serpin family I member 2', 155, NULL, NULL, 72691),
(72692, '3.40.50.300-FF-003515', NULL, 'Activator 1 subunit putative', 203, NULL, NULL, 72692),
(72693, '1.10.555.10-FF-000068', NULL, 'RhoGAP domain containing protein', 234, NULL, NULL, 72693),
(72694, '1.10.555.10-FF-000124', NULL, 'Phosphoinositide-3-kinase, regulatory subunit 2 (beta)', 188, NULL, NULL, 72694),
(72695, '3.40.850.10-FF-000240', NULL, 'Centromere protein E', 252, NULL, NULL, 72695);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(72696, '3.90.190.10-FF-000599', NULL, 'Uncharacterized protein', 282, NULL, NULL, 72696),
(72697, '1.10.510.10-FF-002011', NULL, NULL, 59, NULL, NULL, 72697),
(72698, '1.20.950.20-FF-000021', NULL, 'Cytochrome b', 80, NULL, NULL, 72698),
(72699, '1.20.5.110-FF-000036', NULL, 'Putative Syntaxin-8', 64, NULL, NULL, 72699),
(72700, '3.40.50.720-FF-000420', NULL, 'UDP-glucose 4-epimerase', 216, NULL, NULL, 72700),
(72701, '1.20.58.60-FF-000449', NULL, 'Spectrin beta, non-erythrocytic 5', 104, NULL, NULL, 72701),
(72702, '1.25.40.70-FF-000013', NULL, 'Phosphatidylinositol 4-kinase alpha 1', 182, NULL, NULL, 72702),
(72703, '1.20.1530.20-FF-000016', NULL, 'Solute carrier family 10 member 1', 300, NULL, NULL, 72703),
(72704, '1.10.1040.10-FF-000057', NULL, '2-dehydropantoate 2-reductase', 130, NULL, NULL, 72704),
(72705, '3.20.20.80-FF-000706', NULL, 'Uncharacterized protein', 36, NULL, NULL, 72705),
(72706, '3.90.1150.170-FF-000007', NULL, 'Uncharacterized protein', 143, NULL, NULL, 72706),
(72707, '1.50.40.10-FF-000010', NULL, 'Probable YHM1 (Mitochondrial carrier)', 286, NULL, NULL, 72707),
(72708, '1.10.10.10-FF-000589', NULL, 'HSF-type DNA-binding, putative', 110, NULL, NULL, 72708),
(72709, '3.40.630.10-FF-000021', NULL, 'Nicalin', 280, NULL, NULL, 72709),
(72710, '3.30.70.330-FF-002131', NULL, NULL, 103, NULL, NULL, 72710),
(72711, '3.30.160.60-FF-003913', NULL, NULL, 30, NULL, NULL, 72711),
(72712, '2.60.40.10-FF-004993', NULL, NULL, 107, NULL, NULL, 72712),
(72713, '1.25.10.10-FF-003355', NULL, 'Predicted protein', 202, NULL, NULL, 72713),
(72714, '1.20.1000.10-FF-000041', NULL, NULL, 102, NULL, NULL, 72714),
(72715, '2.10.90.10-FF-000131', NULL, 'Noggin-3', 120, NULL, NULL, 72715),
(72716, '2.10.50.30-FF-000016', NULL, 'Vomeronasal 2, receptor 18', 79, NULL, NULL, 72716),
(72717, '1.10.287.2620-FF-000021', NULL, 'Dynein heavy chain 3', 64, NULL, NULL, 72717),
(72718, '3.40.710.10-FF-000022', NULL, 'Penicillin-binding protein A', 291, NULL, NULL, 72718),
(72719, '3.30.710.10-FF-000400', NULL, 'Uncharacterized protein', 104, NULL, NULL, 72719),
(72720, '3.20.20.140-FF-000127', NULL, 'Putative deoxyribonuclease YjjV', 254, NULL, NULL, 72720),
(72721, '3.40.50.150-FF-001295', NULL, NULL, 215, NULL, NULL, 72721),
(72722, '3.30.900.10-FF-000050', NULL, 'High Incidence of Males (Increased X chromosome loss)', 273, NULL, NULL, 72722),
(72723, '3.30.1370.10-FF-000081', NULL, 'RNA binding protein', 74, NULL, NULL, 72723),
(72724, '1.20.120.1880-FF-000016', NULL, 'Putative nuclear pore complex protein (NUP155)', 138, NULL, NULL, 72724),
(72725, '2.40.50.140-FF-000380', NULL, 'DIS3-like exonuclease 2', 75, NULL, NULL, 72725),
(72726, '3.40.640.10-FF-000426', NULL, 'Uncharacterized protein', 243, NULL, NULL, 72726),
(72727, '3.10.20.90-FF-000945', NULL, 'Ubiquitin specific peptidase 7 (herpes virus-associated)', 71, NULL, NULL, 72727),
(72728, '3.80.10.10-FF-000542', NULL, 'Leucine-rich repeat protein kinase family protein', 100, NULL, NULL, 72728),
(72729, '2.130.10.10-FF-003161', NULL, 'Uncharacterized protein', 251, NULL, NULL, 72729),
(72730, '2.60.40.420-FF-000108', NULL, 'Conserved protein', 169, NULL, NULL, 72730),
(72731, '3.20.20.20-FF-000031', NULL, 'Dihydropteroate synthase', 292, NULL, NULL, 72731),
(72732, '3.40.930.10-FF-000061', NULL, NULL, 118, NULL, NULL, 72732),
(72733, '3.90.870.10-FF-000005', NULL, 'Bifunctional riboflavin biosynthesis protein RIBA 1 chloroplastic', 215, NULL, NULL, 72733),
(72734, '1.20.90.10-FF-000048', NULL, NULL, 121, NULL, NULL, 72734),
(72735, '1.20.1070.10-FF-000950', NULL, 'Neuropeptide FF receptor 1', 128, NULL, NULL, 72735),
(72736, '3.40.50.80-FF-000128', NULL, 'Protein CBG08008', 158, NULL, NULL, 72736),
(72737, '2.60.120.330-FF-000006', NULL, '2-oxoglutarate-Fe(II) type oxidoreductase hxnY', 317, NULL, NULL, 72737),
(72738, '2.60.40.10-FF-001047', NULL, 'amphoterin-induced protein 2 isoform X1', 91, NULL, NULL, 72738),
(72739, '3.10.490.10-FF-000016', NULL, 'Gamma-glutamylcyclotransferase', 179, NULL, NULL, 72739),
(72740, '3.20.20.80-FF-000526', NULL, 'Beta-galactosidase', 193, NULL, NULL, 72740);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(72741, '2.130.10.10-FF-000575', NULL, 'Elongator acetyltransferase complex subunit 2', 122, NULL, NULL, 72741),
(72742, '1.25.40.10-FF-000310', NULL, 'Regulator of microtubule dynamics protein 3', 212, NULL, NULL, 72742),
(72743, '3.40.50.1820-FF-000316', NULL, 'Carboxylic ester hydrolase', 516, NULL, NULL, 72743),
(72744, '3.40.50.10190-FF-000073', NULL, 'Pescadillo homolog', 84, NULL, NULL, 72744),
(72745, '1.10.150.40-FF-000002', NULL, 'Barrier to autointegration factor 2', 88, NULL, NULL, 72745),
(72746, '1.25.40.790-FF-000005', NULL, 'CCR4-NOT transcription complex subunit 1', 301, NULL, NULL, 72746),
(72747, '3.30.70.330-FF-000950', NULL, 'Uncharacterized protein', 83, NULL, NULL, 72747),
(72748, '3.90.1150.10-FF-000079', NULL, 'Molybdenum cofactor sulfurase', 162, NULL, NULL, 72748),
(72749, '3.60.21.10-FF-000012', NULL, 'UDP-2,3-diacylglucosamine hydrolase', 161, NULL, NULL, 72749),
(72750, '1.10.10.10-FF-001319', NULL, 'Redox-sensing transcriptional repressor Rex', 73, NULL, NULL, 72750),
(72751, '2.60.200.40-FF-000036', NULL, 'Sphingosine kinase 2', 215, NULL, NULL, 72751),
(72752, '3.30.70.330-FF-000894', NULL, 'Heterogeneous nuclear ribonucleoprotein A0', 117, NULL, NULL, 72752),
(72753, '3.40.50.300-FF-006264', NULL, 'CSB (Cockayne Syndrome B) homolog', 303, NULL, NULL, 72753),
(72754, '3.30.70.330-FF-001967', NULL, NULL, 131, NULL, NULL, 72754),
(72755, '2.60.40.10-FF-001227', NULL, 'Usherin', 105, NULL, NULL, 72755),
(72756, '3.30.160.60-FF-006387', NULL, NULL, 71, NULL, NULL, 72756),
(72757, '1.10.220.10-FF-000055', NULL, 'Uncharacterized protein', 82, NULL, NULL, 72757),
(72758, '3.30.70.330-FF-001350', NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', 170, NULL, NULL, 72758),
(72759, '2.70.170.10-FF-000117', NULL, 'GH14445p', 186, NULL, NULL, 72759),
(72760, '1.10.238.20-FF-000003', NULL, 'AGAP010409-PA', 116, NULL, NULL, 72760),
(72761, '1.10.10.10-FF-001207', NULL, 'Transcriptional regulator lysR family', 86, NULL, NULL, 72761),
(72762, '1.20.1250.20-FF-002271', NULL, 'Uncharacterized protein', 97, NULL, NULL, 72762),
(72763, '2.60.110.10-FF-000009', NULL, 'Osmotin, thaumatin-like protein', 256, NULL, NULL, 72763),
(72764, '3.30.54.20-FF-000007', NULL, 'Threonine--tRNA ligase', 54, NULL, NULL, 72764),
(72765, '2.30.110.10-FF-000089', NULL, 'Nitroreductase family deazaflavin-dependent oxidoreductase', 129, NULL, NULL, 72765),
(72766, '2.130.10.10-FF-005246', NULL, 'Uncharacterized protein', 298, NULL, NULL, 72766),
(72767, '3.90.1150.80-FF-000004', NULL, NULL, 121, NULL, NULL, 72767),
(72768, '1.20.1070.10-FF-001967', NULL, 'Uncharacterized protein', 183, NULL, NULL, 72768),
(72769, '1.10.10.1100-FF-000007', NULL, '(2Fe-2S)-binding protein', 56, NULL, NULL, 72769),
(72770, '1.25.10.10-FF-002051', NULL, 'RING-type E3 ubiquitin transferase', 159, NULL, NULL, 72770),
(72771, '3.40.50.2300-FF-000921', NULL, NULL, 94, NULL, NULL, 72771),
(72772, '3.80.10.10-FF-002739', NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', 62, NULL, NULL, 72772),
(72773, '1.10.510.10-FF-004141', NULL, NULL, 63, NULL, NULL, 72773),
(72774, '1.10.10.10-FF-000807', NULL, 'Unplaced genomic scaffold supercont1.16, whole genome shotgun sequence', 97, NULL, NULL, 72774),
(72775, '1.20.120.1960-FF-000001', NULL, 'Sulfhydryl oxidase', 119, NULL, NULL, 72775),
(72776, '1.25.40.10-FF-001507', NULL, 'Pentatricopeptide repeat-containing protein At4g01030, mitochondrial', 128, NULL, NULL, 72776),
(72777, '1.10.150.50-FF-000100', NULL, 'Polycomb protein Scm', 79, NULL, NULL, 72777),
(72778, '3.40.50.2300-FF-000360', NULL, 'NEK protein kinase', 132, NULL, NULL, 72778),
(72779, '3.30.70.330-FF-001018', NULL, 'BnaC06g10090D protein', 83, NULL, NULL, 72779),
(72780, '3.40.50.300-FF-001593', NULL, 'ATP-dependent RNA helicase DDX24', 255, NULL, NULL, 72780),
(72781, '1.25.40.20-FF-001044', NULL, 'Uncharacterized protein', 47, NULL, NULL, 72781),
(72782, '1.25.10.10-FF-003411', NULL, 'Chromosome 7, whole genome shotgun sequence', 352, NULL, NULL, 72782),
(72783, '1.20.58.830-FF-000015', NULL, 'Erythrocyte binding antigen-181', 122, NULL, NULL, 72783);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(72784, '3.30.70.330-FF-000618', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 107, NULL, NULL, 72784),
(72785, '1.10.510.10-FF-001499', NULL, 'Kinase, STE STE20', 171, NULL, NULL, 72785),
(72786, '2.60.40.10-FF-003413', NULL, NULL, 101, NULL, NULL, 72786),
(72787, '3.30.420.40-FF-000696', NULL, 'Sugar kinase', 245, NULL, NULL, 72787),
(72788, '3.80.10.10-FF-003291', NULL, 'Uncharacterized protein', 81, NULL, NULL, 72788),
(72789, '2.30.30.40-FF-000579', NULL, 'AEL241Wp', 58, NULL, NULL, 72789),
(72790, '3.30.200.20-FF-001899', NULL, 'Predicted protein', 71, NULL, NULL, 72790),
(72791, '2.40.50.140-FF-000104', NULL, 'Cytochrome c-type biogenesis protein CcmE', 113, NULL, NULL, 72791),
(72792, '3.40.850.10-FF-000184', NULL, 'Kinesin, putative', 369, NULL, NULL, 72792),
(72793, '3.30.9.10-FF-000114', NULL, 'Anaerobic glycerol-3-phosphate dehydrogenase, subunit A', 146, NULL, NULL, 72793),
(72794, '1.10.238.10-FF-000854', NULL, 'Defective in cullin neddylation protein', 90, NULL, NULL, 72794),
(72795, '2.40.128.130-FF-000006', NULL, 'Peptidase S8', 308, NULL, NULL, 72795),
(72796, '2.20.100.10-FF-000080', NULL, 'SCO-spondin', 62, NULL, NULL, 72796),
(72797, '3.20.20.70-FF-000580', NULL, NULL, 150, NULL, NULL, 72797),
(72798, '3.40.50.300-FF-003627', NULL, 'Gll3851 protein', 148, NULL, NULL, 72798),
(72799, '1.25.40.10-FF-003183', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 99, NULL, NULL, 72799),
(72800, '3.30.40.10-FF-000804', NULL, 'PHD finger domain protein, putative', 57, NULL, NULL, 72800),
(72801, '3.30.420.40-FF-000983', NULL, 'Predicted protein', 108, NULL, NULL, 72801),
(72802, '1.25.40.180-FF-000148', NULL, 'Uncharacterized protein', 156, NULL, NULL, 72802),
(72803, '3.40.120.10-FF-000050', NULL, 'Glucose 1,6-bisphosphate synthase', 86, NULL, NULL, 72803),
(72804, '3.30.710.10-FF-000075', NULL, 'zinc finger and BTB domain-containing protein 25', 140, NULL, NULL, 72804),
(72805, '2.60.40.60-FF-000421', NULL, 'Protein CBG29115', 110, NULL, NULL, 72805),
(72806, '3.65.10.20-FF-000018', NULL, 'RNA 3''-terminal phosphate cyclase', 229, NULL, NULL, 72806),
(72807, '1.25.40.10-FF-005217', NULL, 'Uncharacterized protein', 197, NULL, NULL, 72807),
(72808, '3.40.50.1000-FF-000458', NULL, NULL, 179, NULL, NULL, 72808),
(72809, '3.60.15.10-FF-000008', NULL, 'Cleavage and polyadenylation specificity factor subunit 2', 251, NULL, NULL, 72809),
(72810, '3.30.60.10-FF-000007', NULL, 'Class V chitinase, putative (AFU_orthologue AFUA_3G07160)', 41, NULL, NULL, 72810),
(72811, '4.10.240.10-FF-000090', NULL, 'C6 finger domain transcription factor nscR', 54, NULL, NULL, 72811),
(72812, '2.60.120.260-FF-000137', NULL, 'F-box only protein 44 isoform X2', 60, NULL, NULL, 72812),
(72813, '6.10.140.2220-FF-000052', NULL, 'Uncharacterized protein', 47, NULL, NULL, 72813),
(72814, '2.30.42.10-FF-000468', NULL, NULL, 87, NULL, NULL, 72814),
(72815, '3.40.50.720-FF-001668', NULL, 'Uncharacterized protein', 93, NULL, NULL, 72815),
(72816, '3.40.50.1260-FF-000053', NULL, 'Phosphoglycerate kinase', 75, NULL, NULL, 72816),
(72817, '3.30.70.100-FF-000050', NULL, 'Copper-transporting ATPase HMA5', 81, NULL, NULL, 72817),
(72818, '1.25.40.10-FF-004020', NULL, 'Uncharacterized protein', 194, NULL, NULL, 72818),
(72819, '2.60.40.10-FF-002576', NULL, 'High Incidence of Males (Increased X chromosome loss)', 90, NULL, NULL, 72819),
(72820, '3.40.850.10-FF-000060', NULL, 'unconventional myosin-XIX isoform X1', 250, NULL, NULL, 72820),
(72821, '1.10.150.50-FF-000224', NULL, 'Uncharacterized protein', 80, NULL, NULL, 72821),
(72822, '3.40.50.1820-FF-000592', NULL, 'Aclacinomycin methylesterase RdmC', 297, NULL, NULL, 72822),
(72823, '1.10.630.10-FF-000193', NULL, 'Cytochrome p450-like protein', 450, NULL, NULL, 72823),
(72824, '3.80.10.10-FF-000654', NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', 176, NULL, NULL, 72824),
(72825, '1.20.1280.50-FF-000073', NULL, 'F-box protein At5g07670', 39, NULL, NULL, 72825),
(72826, '3.30.2350.20-FF-000049', NULL, NULL, 211, NULL, NULL, 72826);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(72827, '2.60.120.920-FF-000088', NULL, 'SPRY domain containing protein', 201, NULL, NULL, 72827),
(72828, '3.40.50.970-FF-000080', NULL, 'Indolepyruvate oxidoreductase subunit IorA', 173, NULL, NULL, 72828),
(72829, '3.30.160.60-FF-000715', NULL, 'Transcription factor E4F1 isoform 1', 28, NULL, NULL, 72829),
(72830, '2.30.30.490-FF-000078', NULL, 'Uncharacterized protein', 88, NULL, NULL, 72830),
(72831, '1.10.510.10-FF-000594', NULL, 'Myosin light chain kinase isoform-III', 232, NULL, NULL, 72831),
(72832, '1.20.930.20-FF-000019', NULL, 'Predicted protein', 93, NULL, NULL, 72832),
(72833, '3.30.530.20-FF-000131', NULL, 'Uncharacterized protein', 218, NULL, NULL, 72833),
(72834, '3.40.50.720-FF-001724', NULL, 'Calcium-activated potassium channel subunit alpha-1', 131, NULL, NULL, 72834),
(72835, '1.25.40.20-FF-000987', NULL, 'Uncharacterized protein', 192, NULL, NULL, 72835),
(72836, '2.30.38.10-FF-000014', NULL, 'Nonribosomal peptide synthase 2', 69, NULL, NULL, 72836),
(72837, '1.10.490.10-FF-000041', NULL, 'Hemoglobin subunit epsilon 1', 143, NULL, NULL, 72837),
(72838, '1.10.196.10-FF-000008', NULL, 'Locomotion defects, isoform B', 52, NULL, NULL, 72838),
(72839, '2.60.120.10-FF-000510', NULL, 'Uncharacterized protein', 138, NULL, NULL, 72839),
(72840, '1.20.1250.20-FF-002119', NULL, 'Uncharacterized protein', 219, NULL, NULL, 72840),
(72841, '3.30.1640.30-FF-000012', NULL, NULL, 75, NULL, NULL, 72841),
(72842, '3.30.160.60-FF-000659', NULL, 'Zinc finger protein', 30, NULL, NULL, 72842),
(72843, '3.40.140.10-FF-000169', NULL, 'Uncharacterized protein', 174, NULL, NULL, 72843),
(72844, '2.130.10.10-FF-004465', NULL, 'Uncharacterized protein', 134, NULL, NULL, 72844),
(72845, '1.10.420.10-FF-000036', NULL, 'Peroxidase', 105, NULL, NULL, 72845),
(72846, '3.40.50.150-FF-000963', NULL, NULL, 250, NULL, NULL, 72846),
(72847, '2.30.29.30-FF-000505', NULL, 'FACT complex subunit SSRP1', 89, NULL, NULL, 72847),
(72848, '1.20.5.2230-FF-000001', NULL, 'Inner centromere protein', 36, NULL, NULL, 72848),
(72849, '2.10.110.20-FF-000012', NULL, NULL, 76, NULL, NULL, 72849),
(72850, '1.10.238.10-FF-000674', NULL, 'Chromosome 19, whole genome shotgun sequence', 136, NULL, NULL, 72850),
(72851, '2.30.30.100-FF-000225', NULL, 'Small nuclear ribonucleoprotein E', 57, NULL, NULL, 72851),
(72852, '2.40.100.10-FF-000086', NULL, 'Predicted protein', 164, NULL, NULL, 72852),
(72853, '2.60.40.3170-FF-000004', NULL, 'Tripeptidyl-peptidase 2', 133, NULL, NULL, 72853),
(72854, '1.50.40.10-FF-000134', NULL, 'Peroxisomal membrane protein PMP47B', 293, NULL, NULL, 72854),
(72855, '2.10.25.10-FF-000896', NULL, 'Pro-epidermal growth factor', 37, NULL, NULL, 72855),
(72856, '2.40.170.20-FF-000037', NULL, 'Iron-regulated outer membrane protein', 610, NULL, NULL, 72856),
(72857, '3.40.50.720-FF-002000', NULL, 'Short chain dehydrogenase/reductase family 42E, member 2', 232, NULL, NULL, 72857),
(72858, '3.60.110.10-FF-000011', NULL, 'Cyanide hydratase', 294, NULL, NULL, 72858),
(72859, '3.40.30.10-FF-000769', NULL, 'Glutathione S-transferase kappa', 206, NULL, NULL, 72859),
(72860, '3.40.30.10-FF-000152', NULL, 'Protein disulfide-isomerase', 134, NULL, NULL, 72860),
(72861, '4.10.92.10-FF-000001', NULL, '5-aminolevulinate synthase', 49, NULL, NULL, 72861),
(72862, '1.10.287.70-FF-000125', NULL, 'Voltage-dependent T-type calcium channel subunit alpha', 154, NULL, NULL, 72862),
(72863, '3.60.40.10-FF-000320', NULL, 'Protein phosphatase 1J (PP2C domain containing)', 207, NULL, NULL, 72863),
(72864, '3.30.519.10-FF-000051', NULL, NULL, 28, NULL, NULL, 72864),
(72865, '3.40.50.300-FF-005140', NULL, 'Branched-chain amino acid ABC transporter, ATP-binding protein', 237, NULL, NULL, 72865),
(72866, '3.40.50.1460-FF-000012', NULL, 'Caspase 9', 274, NULL, NULL, 72866),
(72867, '2.60.120.920-FF-000032', NULL, 'Tripartite motif-containing protein 26', 111, NULL, NULL, 72867),
(72868, '1.25.10.10-FF-003068', NULL, 'Dynein assembly factor 5, axonemal', 257, NULL, NULL, 72868),
(72869, '3.30.200.20-FF-000651', NULL, 'Fibroblast growth factor receptor', 119, NULL, NULL, 72869);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(72870, '3.90.1150.210-FF-000003', NULL, 'F-actin-capping protein subunit alpha', 144, NULL, NULL, 72870),
(72871, '1.10.630.10-FF-000373', NULL, '9-divinyl ether synthase', 429, NULL, NULL, 72871),
(72872, '1.25.40.10-FF-000889', NULL, 'ST13 isoform 3', 137, NULL, NULL, 72872),
(72873, '3.40.50.410-FF-000058', NULL, 'von Willebrand factor A domain containing 2', 203, NULL, NULL, 72873),
(72874, '2.60.120.200-FF-000147', NULL, 'Hydroxyproline O-galactosyltransferase GALT2', 114, NULL, NULL, 72874),
(72875, '3.40.630.10-FF-000077', NULL, 'p-aminobenzoyl-glutamate hydrolase, A subunit', 284, NULL, NULL, 72875),
(72876, '2.60.40.640-FF-000118', NULL, 'Arrestin family protein 1', 145, NULL, NULL, 72876),
(72877, '1.25.10.10-FF-001090', NULL, 'Scy1p', 271, NULL, NULL, 72877),
(72878, '3.50.50.60-FF-000493', NULL, 'Protoporphyrinogen oxidase', 423, NULL, NULL, 72878),
(72879, '3.30.1330.90-FF-000012', NULL, 'Phosphoglycerate dehydrogenase', 157, NULL, NULL, 72879),
(72880, '3.30.450.20-FF-000130', NULL, 'Period protein homolog lin-42', 156, NULL, NULL, 72880),
(72881, '1.10.8.10-FF-000211', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 76, NULL, NULL, 72881),
(72882, '1.10.510.10-FF-001555', NULL, 'Probable serine/threonine-protein kinase iksA', 250, NULL, NULL, 72882),
(72883, '1.10.150.130-FF-000004', NULL, 'Phage integrase', 113, NULL, NULL, 72883),
(72884, '3.40.50.300-FF-001773', NULL, 'Small GTP-binding protein, putative', 196, NULL, NULL, 72884),
(72885, '1.20.1250.20-FF-001214', NULL, 'Uncharacterized protein', 230, NULL, NULL, 72885),
(72886, '1.10.510.10-FF-001611', NULL, 'Protein CBG08942', 289, NULL, NULL, 72886),
(72887, '1.20.1720.10-FF-000129', NULL, NULL, 150, NULL, NULL, 72887),
(72888, '2.10.25.10-FF-000497', NULL, 'Stabilin 2', 39, NULL, NULL, 72888),
(72889, '2.10.25.10-FF-000553', NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing 1', 37, NULL, NULL, 72889),
(72890, '3.30.160.60-FF-006443', NULL, NULL, 83, NULL, NULL, 72890),
(72891, '3.40.50.1580-FF-000031', NULL, 'Purine nucleoside phosphorylase lateral transfer candidate', 316, NULL, NULL, 72891),
(72892, '2.60.40.10-FF-005830', NULL, NULL, 113, NULL, NULL, 72892),
(72893, '3.40.50.2000-FF-000657', NULL, 'Glycosyl transferase family 1', 236, NULL, NULL, 72893),
(72894, '2.30.29.30-FF-000449', NULL, 'Histone-arginine methyltransferase CARMER', 116, NULL, NULL, 72894),
(72895, '3.40.50.960-FF-000020', NULL, '6,7-dimethyl-8-ribityllumazine synthase', 117, NULL, NULL, 72895),
(72896, '3.30.1370.50-FF-000025', NULL, 'Chromosome 10, whole genome shotgun sequence', 104, NULL, NULL, 72896),
(72897, '3.40.140.10-FF-000225', NULL, 'Uncharacterized protein', 173, NULL, NULL, 72897),
(72898, '3.10.450.10-FF-000019', NULL, 'Cystatin 11', 107, NULL, NULL, 72898),
(72899, '3.80.10.10-FF-001379', NULL, 'Predicted protein', 180, NULL, NULL, 72899),
(72900, '1.10.150.50-FF-000044', NULL, 'kinase D-interacting substrate of 220 kDa isoform X1', 82, NULL, NULL, 72900),
(72901, '1.25.40.10-FF-003800', NULL, 'Uncharacterized protein', 143, NULL, NULL, 72901),
(72902, '3.90.190.10-FF-000543', NULL, 'Dual specificity protein phosphatase CDC14A, putative', 154, NULL, NULL, 72902),
(72903, '3.30.460.10-FF-000190', NULL, '2''-5'' oligoadenylate synthetase 1F', 30, NULL, NULL, 72903),
(72904, '1.25.40.10-FF-000366', NULL, 'Pentatricopeptide (PPR) repeat-containing protein', 164, NULL, NULL, 72904),
(72905, '3.40.50.12240-FF-000002', NULL, 'Flagellum-specific ATP synthase FliI', 428, NULL, NULL, 72905),
(72906, '1.10.287.110-FF-000166', NULL, 'Molecular chaperone, DnaJ family', 83, NULL, NULL, 72906),
(72907, '3.40.5.10-FF-000004', NULL, '50S ribosomal protein L9', 64, NULL, NULL, 72907),
(72908, '3.30.70.330-FF-002928', NULL, NULL, 121, NULL, NULL, 72908),
(72909, '1.20.1250.20-FF-000938', NULL, 'AGAP012419-PA', 205, NULL, NULL, 72909),
(72910, '1.10.10.60-FF-000564', NULL, 'AraC family transcriptional regulator', 55, NULL, NULL, 72910),
(72911, '3.60.40.10-FF-000264', NULL, 'Phosphatase 2C-like domain-containing protein', 298, NULL, NULL, 72911);
INSERT INTO "PUBLIC"."MODEL" VALUES
(72912, '3.30.420.40-FF-000640', NULL, 'Uncharacterized protein', 198, NULL, NULL, 72912),
(72913, '2.160.20.10-FF-000041', NULL, 'Putative polygalacturonase', 397, NULL, NULL, 72913),
(72914, '3.40.50.300-FF-001250', NULL, 'Putative ATP-dependent RNA helicase DDX11', 209, NULL, NULL, 72914),
(72915, '3.40.430.10-FF-000040', NULL, 'Dihydrofolate reductase', 244, NULL, NULL, 72915),
(72916, '3.30.160.60-FF-000991', NULL, 'Zinc finger protein 366', 23, NULL, NULL, 72916),
(72917, '2.60.40.60-FF-000764', NULL, 'Uncharacterized protein', 106, NULL, NULL, 72917),
(72918, '1.25.10.10-FF-000718', NULL, 'Importin-5', 1138, NULL, NULL, 72918),
(72919, '2.60.40.10-FF-000266', NULL, 'Sidekick cell adhesion molecule 2', 92, NULL, NULL, 72919),
(72920, '3.30.50.10-FF-000069', NULL, 'Transcriptional regulatory protein ASH1', 50, NULL, NULL, 72920),
(72921, '3.90.550.10-FF-000458', NULL, 'Putative colanic acid biosynthesis glycosyltransferase', 234, NULL, NULL, 72921),
(72922, '3.20.20.190-FF-000102', NULL, 'Predicted protein', 302, NULL, NULL, 72922),
(72923, '1.20.1560.10-FF-000127', NULL, 'ABC transporter ATP-binding protein', 323, NULL, NULL, 72923),
(72924, '2.130.10.10-FF-000755', NULL, 'WD repeat-containing protein 3', 194, NULL, NULL, 72924),
(72925, '3.40.710.10-FF-000078', NULL, 'PASTA domain-containing protein', 201, NULL, NULL, 72925),
(72926, '2.60.260.20-FF-000039', NULL, 'HSP40, subfamily A, putative', 82, NULL, NULL, 72926),
(72927, '1.20.1050.10-FF-000044', NULL, 'Glutathione S-transferase', 112, NULL, NULL, 72927),
(72928, '1.10.20.10-FF-000308', NULL, NULL, 45, NULL, NULL, 72928),
(72929, '1.20.58.1030-FF-000012', NULL, 'Unplaced genomic scaffold supercont1.201, whole genome shotgun sequence', 201, NULL, NULL, 72929),
(72930, '1.10.132.10-FF-000007', NULL, 'DNA topoisomerase I', 207, NULL, NULL, 72930),
(72931, '3.30.70.330-FF-002187', NULL, NULL, 61, NULL, NULL, 72931),
(72932, '2.30.29.30-FF-000106', NULL, 'ran-binding protein 3 isoform X2', 197, NULL, NULL, 72932),
(72933, '3.30.160.60-FF-005662', NULL, NULL, 78, NULL, NULL, 72933),
(72934, '3.30.200.20-FF-000994', NULL, 'Homoserine kinase', 102, NULL, NULL, 72934),
(72935, '2.130.10.10-FF-001031', NULL, 'Transducin/WD40 repeat-like superfamily protein', 275, NULL, NULL, 72935),
(72936, '1.10.472.150-FF-000004', NULL, NULL, 120, NULL, NULL, 72936),
(72937, '2.120.10.80-FF-000309', NULL, 'Predicted protein', 178, NULL, NULL, 72937),
(72938, '1.25.40.180-FF-000204', NULL, NULL, 74, NULL, NULL, 72938),
(72939, '2.150.10.10-FF-000024', NULL, NULL, 125, NULL, NULL, 72939),
(72940, '4.10.1240.10-FF-000002', NULL, 'Adhesion G protein-coupled receptor B2', 68, NULL, NULL, 72940),
(72941, '2.60.40.790-FF-000079', NULL, 'SGT1 and CS domain protein', 109, NULL, NULL, 72941),
(72942, '3.30.390.30-FF-000021', NULL, 'Glutathione reductase', 126, NULL, NULL, 72942),
(72943, '3.90.550.10-FF-000638', NULL, 'Uncharacterized protein', 177, NULL, NULL, 72943),
(72944, '3.10.20.310-FF-000017', NULL, 'Outer membrane protein assembly factor', 78, NULL, NULL, 72944),
(72945, '2.60.40.10-FF-002396', NULL, 'Uncharacterized protein', 116, NULL, NULL, 72945),
(72946, '2.60.200.20-FF-000210', NULL, 'Pleckstrin homology-like domain, family B, member 1a', 86, NULL, NULL, 72946),
(72947, '3.90.1420.10-FF-000004', NULL, 'Ribulose-1,5 bisphosphate carboxylase/oxygenase large subunit N-methyltransferase, chloroplastic', 166, NULL, NULL, 72947),
(72948, '1.20.1560.10-FF-000706', NULL, 'ABC transporter transmembrane region family protein', 321, NULL, NULL, 72948),
(72949, '3.30.450.20-FF-000653', NULL, 'Uncharacterized protein', 116, NULL, NULL, 72949),
(72950, '1.20.1250.20-FF-001490', NULL, 'Uncharacterized protein', 99, NULL, NULL, 72950),
(72951, '2.130.10.10-FF-005426', NULL, 'Uncharacterized protein', 235, NULL, NULL, 72951),
(72952, '2.170.150.10-FF-000013', NULL, 'Similar to tumor protein, translationally-controlled 1', 90, NULL, NULL, 72952),
(72953, '2.60.120.1250-FF-000001', NULL, 'TRPM8 channel-associated factor 3', 112, NULL, NULL, 72953),
(72954, '1.25.10.10-FF-000870', NULL, 'BP28CT domain containing protein', 282, NULL, NULL, 72954);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(72955, '2.30.30.110-FF-000009', NULL, NULL, 112, NULL, NULL, 72955),
(72956, '1.10.510.10-FF-001735', NULL, 'T0011027 isoform 1', 200, NULL, NULL, 72956),
(72957, '3.40.50.300-FF-005483', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 300, NULL, NULL, 72957),
(72958, '3.30.200.20-FF-000319', NULL, 'Inka box actin regulator 2', 83, NULL, NULL, 72958),
(72959, '3.30.160.60-FF-005482', NULL, NULL, 27, NULL, NULL, 72959),
(72960, '1.25.40.10-FF-001327', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial isoform A', 91, NULL, NULL, 72960),
(72961, '1.25.10.10-FF-001270', NULL, 'Armadillo segment polarity protein', 541, NULL, NULL, 72961),
(72962, '2.40.160.120-FF-000046', NULL, 'Obr-2', 173, NULL, NULL, 72962),
(72963, '3.40.50.300-FF-008394', NULL, 'Uncharacterized protein', 189, NULL, NULL, 72963),
(72964, '3.30.450.20-FF-000310', NULL, 'Two-component system histidine kinase, FrrD', 112, NULL, NULL, 72964),
(72965, '3.30.450.40-FF-000136', NULL, 'Phosphodiesterase', 164, NULL, NULL, 72965),
(72966, '1.20.1050.10-FF-000100', NULL, 'Glutathione S-transferase omega-2', 116, NULL, NULL, 72966),
(72967, '1.25.40.20-FF-000588', NULL, 'Ankyrin repeat domain 1', 73, NULL, NULL, 72967),
(72968, '3.40.50.11340-FF-000007', NULL, 'GDP-fucose protein O-fucosyltransferase 2', 202, NULL, NULL, 72968),
(72969, '2.30.29.30-FF-000781', NULL, 'Mannosyltransferase', 112, NULL, NULL, 72969),
(72970, '3.80.10.10-FF-000598', NULL, 'Glucose-repressible alcohol dehydrogenase transcriptional effector', 191, NULL, NULL, 72970),
(72971, '2.40.70.10-FF-000549', NULL, NULL, 181, NULL, NULL, 72971),
(72972, '3.30.50.10-FF-000125', NULL, 'FXRbeta', 69, NULL, NULL, 72972),
(72973, '3.30.160.60-FF-004369', NULL, NULL, 37, NULL, NULL, 72973),
(72974, '3.50.50.60-FF-000892', NULL, 'Pyridine nucleotide-disulfide oxidoreductase', 192, NULL, NULL, 72974),
(72975, '3.40.50.980-FF-000026', NULL, 'Acyl-CoA synthetase, AMP-forming', 144, NULL, NULL, 72975),
(72976, '4.10.1240.30-FF-000008', NULL, NULL, 87, NULL, NULL, 72976),
(72977, '3.30.390.50-FF-000027', NULL, 'Uncharacterized protein', 60, NULL, NULL, 72977),
(72978, '3.40.50.2000-FF-001113', NULL, 'Uncharacterized protein', 208, NULL, NULL, 72978),
(72979, '2.70.50.30-FF-000002', NULL, 'Rho GDP-dissociation inhibitor 1', 180, NULL, NULL, 72979),
(72980, '1.20.5.370-FF-000012', NULL, 'DNA repair protein XRCC4', 95, NULL, NULL, 72980),
(72981, '1.25.10.10-FF-000538', NULL, 'Uncharacterized protein', 121, NULL, NULL, 72981),
(72982, '1.20.1250.20-FF-001158', NULL, 'Efflux pump afoB', 389, NULL, NULL, 72982),
(72983, '2.60.40.1730-FF-000033', NULL, 'Aminopeptidase', 199, NULL, NULL, 72983),
(72984, '3.40.50.410-FF-000114', NULL, 'Midasin', 159, NULL, NULL, 72984),
(72985, '2.60.40.10-FF-003357', NULL, 'Protein CBR-UNC-22', 98, NULL, NULL, 72985),
(72986, '3.30.70.330-FF-003148', NULL, NULL, 143, NULL, NULL, 72986),
(72987, '1.10.533.10-FF-000287', NULL, 'Uncharacterized protein', 115, NULL, NULL, 72987),
(72988, '2.40.30.170-FF-000047', NULL, NULL, 78, NULL, NULL, 72988),
(72989, '1.20.1560.10-FF-000307', NULL, 'ATP-binding cassette, sub-family B (MDR/TAP), member 11b', 22, NULL, NULL, 72989),
(72990, '2.10.70.10-FF-000129', NULL, 'Uncharacterized protein, isoform A', 70, NULL, NULL, 72990),
(72991, '3.30.200.20-FF-002231', NULL, 'Uncharacterized protein', 37, NULL, NULL, 72991),
(72992, '3.40.50.2000-FF-000713', NULL, 'Glycosyl transferase group 1', 165, NULL, NULL, 72992),
(72993, '1.10.10.60-FF-001020', NULL, NULL, 85, NULL, NULL, 72993),
(72994, '2.10.25.10-FF-001514', NULL, 'Notch receptor 1b', 62, NULL, NULL, 72994),
(72995, '3.90.1150.10-FF-000135', NULL, 'Glutamate decarboxylase', 147, NULL, NULL, 72995),
(72996, '1.10.287.1490-FF-000075', NULL, 'Uncharacterized protein', 164, NULL, NULL, 72996),
(72997, '2.40.30.110-FF-000001', NULL, 'Aminomethyltransferase', 84, NULL, NULL, 72997),
(72998, '1.20.120.1240-FF-000004', NULL, 'dynamin-3 isoform X2', 243, NULL, NULL, 72998),
(72999, '3.40.50.300-FF-000137', NULL, 'Replication-associated recombination protein A', 158, NULL, NULL, 72999);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(73000, '2.40.50.90-FF-000027', NULL, 'Tudor domain containing 1', 48, NULL, NULL, 73000),
(73001, '3.40.50.2000-FF-000314', NULL, '1-acyl-sn-glycerol-3-phosphate acyltransferase', 164, NULL, NULL, 73001),
(73002, '1.25.10.10-FF-001831', NULL, 'Uncharacterized protein', 205, NULL, NULL, 73002),
(73003, '1.10.10.60-FF-000744', NULL, 'MYB transcription factor', 75, NULL, NULL, 73003),
(73004, '2.60.40.10-FF-004717', NULL, NULL, 69, NULL, NULL, 73004),
(73005, '2.40.10.10-FF-000321', NULL, 'GM13374', 230, NULL, NULL, 73005),
(73006, '3.50.50.60-FF-000217', NULL, 'Oleate hydratase', 167, NULL, NULL, 73006),
(73007, '1.25.40.720-FF-000024', NULL, 'Uncharacterized protein', 86, NULL, NULL, 73007),
(73008, '1.20.1270.10-FF-000083', NULL, 'Mitochondrial-type HSP70, putative', 83, NULL, NULL, 73008),
(73009, '3.40.50.2300-FF-000865', NULL, 'Uncharacterized protein', 177, NULL, NULL, 73009),
(73010, '1.20.1070.10-FF-001388', NULL, 'Uncharacterized protein', 245, NULL, NULL, 73010),
(73011, '2.40.30.130-FF-000007', NULL, 'Probable alanine--tRNA ligase, chloroplastic', 115, NULL, NULL, 73011),
(73012, '2.60.40.3610-FF-000001', NULL, 'Outer membrane protein SusE', 104, NULL, NULL, 73012),
(73013, '1.10.287.470-FF-000021', NULL, 'Efflux transporter periplasmic adaptor subunit', 88, NULL, NULL, 73013),
(73014, '1.10.8.1220-FF-000010', NULL, 'Dynein beta chain, putative', 95, NULL, NULL, 73014),
(73015, '4.10.970.10-FF-000004', NULL, 'ATP-dependent DNA helicase 2 subunit KU70', 62, NULL, NULL, 73015),
(73016, '2.130.10.10-FF-005302', NULL, 'Predicted protein', 214, NULL, NULL, 73016),
(73017, '3.40.50.300-FF-005701', NULL, 'NLR family CARD domain containing 3', 175, NULL, NULL, 73017),
(73018, '3.50.50.60-FF-001510', NULL, 'Putative glutamate synthase small subunit', 124, NULL, NULL, 73018),
(73019, '3.40.50.2000-FF-000837', NULL, 'Uncharacterized protein', 77, NULL, NULL, 73019),
(73020, '1.10.287.70-FF-000069', NULL, 'Potassium sodium-activated channel subfamily T member 1', 192, NULL, NULL, 73020),
(73021, '2.60.120.10-FF-000111', NULL, 'Cyclic nucleotide binding domain containing 2', 142, NULL, NULL, 73021),
(73022, '3.40.50.720-FF-000763', NULL, 'Unplaced genomic scaffold supercont1.203, whole genome shotgun sequence', 250, NULL, NULL, 73022),
(73023, '3.30.70.330-FF-000427', NULL, 'Heterogeneous nuclear ribonucleoprotein 27C', 84, NULL, NULL, 73023),
(73024, '3.90.870.10-FF-000033', NULL, 'Slr0006 protein', 205, NULL, NULL, 73024),
(73025, '1.10.630.10-FF-000642', NULL, 'Cytochrome P450, family 4, subfamily f, polypeptide 13', 216, NULL, NULL, 73025),
(73026, '3.90.190.10-FF-000312', NULL, 'Predicted protein', 246, NULL, NULL, 73026),
(73027, '2.40.10.500-FF-000002', NULL, 'CRE-NHL-1 protein', 80, NULL, NULL, 73027),
(73028, '3.90.810.10-FF-000024', NULL, 'Kinase, STE STE20', 44, NULL, NULL, 73028),
(73029, '2.60.40.150-FF-000483', NULL, 'Phosphatidylinositol 3-kinase VPS34', 134, NULL, NULL, 73029),
(73030, '1.25.40.10-FF-000922', NULL, 'Pentatricopeptide repeat-containing protein', 179, NULL, NULL, 73030),
(73031, '3.30.500.10-FF-000025', NULL, NULL, 105, NULL, NULL, 73031),
(73032, '1.25.10.10-FF-002978', NULL, 'HEAT repeat family protein', 399, NULL, NULL, 73032),
(73033, '2.130.10.10-FF-001643', NULL, 'Mak11p', 110, NULL, NULL, 73033),
(73034, '2.20.25.30-FF-000002', NULL, '60S ribosomal protein L37a', 91, NULL, NULL, 73034),
(73035, '3.40.50.300-FF-003594', NULL, 'Rab family GTPase', 189, NULL, NULL, 73035),
(73036, '3.40.50.300-FF-007293', NULL, 'Uncharacterized protein', 151, NULL, NULL, 73036),
(73037, '1.10.10.60-FF-000643', NULL, 'Transcription factor MYB14 isoform A', 71, NULL, NULL, 73037),
(73038, '3.30.40.10-FF-001501', NULL, 'Uncharacterized protein', 114, NULL, NULL, 73038),
(73039, '3.30.70.3190-FF-000005', NULL, NULL, 39, NULL, NULL, 73039),
(73040, '1.10.3470.10-FF-000022', NULL, 'Iron compound ABC transporter, permease protein', 327, NULL, NULL, 73040),
(73041, '1.10.510.10-FF-002140', NULL, 'Striated muscle-enriched protein kinase a', 212, NULL, NULL, 73041),
(73042, '1.10.510.10-FF-001634', NULL, 'Uncharacterized protein', 218, NULL, NULL, 73042);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(73043, '3.30.70.330-FF-002474', NULL, NULL, 80, NULL, NULL, 73043),
(73044, '3.40.30.10-FF-001225', NULL, 'Uncharacterized protein', 139, NULL, NULL, 73044),
(73045, '3.40.50.300-FF-003122', NULL, 'ABC transporter ATP-binding protein', 257, NULL, NULL, 73045),
(73046, '2.130.10.10-FF-005342', NULL, 'WD40-repeat protein', 182, NULL, NULL, 73046),
(73047, '1.20.120.1900-FF-000062', NULL, 'Spindle pole body component', 323, NULL, NULL, 73047),
(73048, '3.30.70.330-FF-000866', NULL, 'RNA-binding protein 1', 91, NULL, NULL, 73048),
(73049, '3.30.160.60-FF-000007', NULL, 'Basic krueppel-like factor 3', 89, NULL, NULL, 73049),
(73050, '3.30.559.70-FF-000037', NULL, 'Uncharacterized protein', 118, NULL, NULL, 73050),
(73051, '1.25.10.10-FF-003484', NULL, 'RING-type E3 ubiquitin transferase', 302, NULL, NULL, 73051),
(73052, '3.90.180.10-FF-000177', NULL, 'Uncharacterized protein', 108, NULL, NULL, 73052),
(73053, '3.20.10.10-FF-000033', NULL, 'Branched-chain-amino-acid aminotransferase', 173, NULL, NULL, 73053),
(73054, '3.30.565.10-FF-000539', NULL, 'Predicted protein', 150, NULL, NULL, 73054),
(73055, '3.80.10.10-FF-001722', NULL, 'GD24204', 185, NULL, NULL, 73055),
(73056, '3.30.160.60-FF-002733', NULL, 'Zinc finger family protein', 63, NULL, NULL, 73056),
(73057, '1.10.1670.10-FF-000003', NULL, 'Endonuclease III homolog', 86, NULL, NULL, 73057),
(73058, '2.60.40.10-FF-003756', NULL, NULL, 71, NULL, NULL, 73058),
(73059, '1.10.238.10-FF-000562', NULL, 'Calumenin isoform A', 70, NULL, NULL, 73059),
(73060, '3.40.50.720-FF-000611', NULL, 'Ubiquitin-activating enzyme', 148, NULL, NULL, 73060),
(73061, '1.20.58.60-FF-000786', NULL, 'Dystonin', 219, NULL, NULL, 73061),
(73062, '2.40.50.40-FF-000001', NULL, 'chromodomain-helicase-DNA-binding protein 8 isoform X4', 67, NULL, NULL, 73062),
(73063, '3.10.450.50-FF-000104', NULL, 'Uncharacterized protein', 77, NULL, NULL, 73063),
(73064, '2.70.160.11-FF-000028', NULL, 'Protein arginine N-methyltransferase 5', 188, NULL, NULL, 73064),
(73065, '3.90.640.10-FF-000224', NULL, 'Uncharacterized protein', 69, NULL, NULL, 73065),
(73066, '2.60.120.380-FF-000055', NULL, 'Cysteine peptidase, Clan CA, family C2, putative', 156, NULL, NULL, 73066),
(73067, '3.40.190.10-FF-000228', NULL, 'Chorismate mutase/prephenate dehydratase', 100, NULL, NULL, 73067),
(73068, '1.20.1560.10-FF-000487', NULL, 'Probable ATP-binding component of ABC transporter', 300, NULL, NULL, 73068),
(73069, '3.40.50.300-FF-002503', NULL, 'Phosphate import ATP-binding protein PstB', 253, NULL, NULL, 73069),
(73070, '2.40.50.100-FF-000227', NULL, 'Putative ABC transporter ATP-binding protein MG187', 45, NULL, NULL, 73070),
(73071, '2.30.42.10-FF-000463', NULL, NULL, 92, NULL, NULL, 73071),
(73072, '2.60.40.60-FF-000921', NULL, 'Uncharacterized protein', 66, NULL, NULL, 73072),
(73073, '3.40.50.620-FF-000244', NULL, 'Deoxyribodipyrimidine photo-lyase, putative', 166, NULL, NULL, 73073),
(73074, '3.30.2350.10-FF-000063', NULL, 'tRNA pseudouridine synthase B', 247, NULL, NULL, 73074),
(73075, '1.20.5.650-FF-000001', NULL, 'transcription factor IIIB 90 kDa subunit isoform X2', 64, NULL, NULL, 73075),
(73076, '3.40.50.300-FF-004111', NULL, 'ATP-dependent rRNA helicase SPB4', 181, NULL, NULL, 73076),
(73077, '3.30.160.60-FF-004178', NULL, NULL, 27, NULL, NULL, 73077),
(73078, '2.130.10.10-FF-001160', NULL, 'YBL104C-like protein', 354, NULL, NULL, 73078),
(73079, '3.40.50.1440-FF-000118', NULL, 'Tubulin alpha chain', 253, NULL, NULL, 73079),
(73080, '3.40.50.720-FF-000078', NULL, 'Alanine dehydrogenase', 185, NULL, NULL, 73080),
(73081, '1.10.8.10-FF-000239', NULL, 'Defective in cullin neddylation protein', 50, NULL, NULL, 73081),
(73082, '3.60.20.10-FF-000178', NULL, NULL, 125, NULL, NULL, 73082),
(73083, '2.10.25.10-FF-001722', NULL, 'Uncharacterized protein', 59, NULL, NULL, 73083),
(73084, '1.10.10.2840-FF-000006', NULL, NULL, 133, NULL, NULL, 73084),
(73085, '3.90.550.10-FF-000767', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 314, NULL, NULL, 73085),
(73086, '1.10.510.10-FF-004377', NULL, NULL, 99, NULL, NULL, 73086);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(73087, '3.30.70.2610-FF-000005', NULL, 'General transcription factor IIH subunit 4', 78, NULL, NULL, 73087),
(73088, '3.30.70.330-FF-001855', NULL, NULL, 110, NULL, NULL, 73088),
(73089, '1.10.3450.40-FF-000018', NULL, NULL, 62, NULL, NULL, 73089),
(73090, '1.10.460.10-FF-000033', NULL, 'DNA topoisomerase', 162, NULL, NULL, 73090),
(73091, '2.130.10.10-FF-000654', NULL, 'Apoptotic protease-activating factor 1', 219, NULL, NULL, 73091),
(73092, '2.60.40.1170-FF-000073', NULL, NULL, 104, NULL, NULL, 73092),
(73093, '1.20.58.1210-FF-000010', NULL, 'Exocyst complex component EXO84', 122, NULL, NULL, 73093),
(73094, '1.10.730.10-FF-000217', NULL, 'Putative leucine--tRNA ligase CDC60', 147, NULL, NULL, 73094),
(73095, '3.30.160.60-FF-000479', NULL, 'Zinc finger protein 287', 27, NULL, NULL, 73095),
(73096, '3.30.750.24-FF-000124', NULL, 'High affinity sulfate transporter', 134, NULL, NULL, 73096),
(73097, '1.20.1070.10-FF-001568', NULL, 'Uncharacterized protein', 166, NULL, NULL, 73097),
(73098, '1.10.510.10-FF-002623', NULL, NULL, 96, NULL, NULL, 73098),
(73099, '1.10.10.10-FF-001078', NULL, 'O-methyltransferase tpcA', 88, NULL, NULL, 73099),
(73100, '3.40.50.720-FF-002056', NULL, 'Cis-retinol/3alpha hydroxysterol short-chain dehydrogenase-like protein isoform', 171, NULL, NULL, 73100),
(73101, '3.10.310.10-FF-000032', NULL, 'Diaminopimelate epimerase', 134, NULL, NULL, 73101),
(73102, '3.40.50.300-FF-006348', NULL, 'Uncharacterized protein', 431, NULL, NULL, 73102),
(73103, '1.25.40.20-FF-001544', NULL, 'Ankyrin repeat domain 31', 120, NULL, NULL, 73103),
(73104, '3.10.129.10-FF-000189', NULL, 'Fatty acid synthase beta subunit', 291, NULL, NULL, 73104),
(73105, '3.40.50.620-FF-000727', NULL, 'Uncharacterized protein', 197, NULL, NULL, 73105),
(73106, '2.60.120.330-FF-000001', NULL, 'Protein SRG1', 335, NULL, NULL, 73106),
(73107, '3.80.10.10-FF-004465', NULL, 'Os06g0585982 protein', 73, NULL, NULL, 73107),
(73108, '3.60.10.10-FF-000104', NULL, 'Endonuclease/exonuclease/phosphatase', 272, NULL, NULL, 73108),
(73109, '2.130.10.10-FF-003088', NULL, 'AGAP007423-PA', 91, NULL, NULL, 73109),
(73110, '2.130.10.10-FF-003408', NULL, 'Sensor histidine kinase/response regulator', 191, NULL, NULL, 73110),
(73111, '2.30.29.30-FF-000005', NULL, 'Amyloid beta (A4) protein b', 166, NULL, NULL, 73111),
(73112, '3.30.559.10-FF-000126', NULL, 'Transferase family protein', 185, NULL, NULL, 73112),
(73113, '1.25.40.10-FF-005240', NULL, 'Uncharacterized protein', 170, NULL, NULL, 73113),
(73114, '1.25.10.10-FF-002539', NULL, 'Uncharacterized protein', 182, NULL, NULL, 73114),
(73115, '3.40.1190.20-FF-000225', NULL, NULL, 65, NULL, NULL, 73115),
(73116, '3.40.50.150-FF-001160', NULL, NULL, 210, NULL, NULL, 73116),
(73117, '3.20.20.80-FF-000521', NULL, 'protein O-GlcNAcase-like isoform X2', 284, NULL, NULL, 73117),
(73118, '3.20.20.70-FF-000181', NULL, 'Ribulose-phosphate 3-epimerase', 226, NULL, NULL, 73118),
(73119, '3.30.420.40-FF-000729', NULL, 'Uncharacterized protein', 120, NULL, NULL, 73119),
(73120, '1.10.760.10-FF-000045', NULL, 'Cytochrome c554', 83, NULL, NULL, 73120),
(73121, '2.130.10.10-FF-003397', NULL, 'Prp-8', 209, NULL, NULL, 73121),
(73122, '2.60.40.10-FF-005038', NULL, NULL, 103, NULL, NULL, 73122),
(73123, '3.30.40.10-FF-000675', NULL, 'RING-type E3 ubiquitin transferase', 74, NULL, NULL, 73123),
(73124, '3.40.850.10-FF-000245', NULL, 'Uncharacterized protein', 216, NULL, NULL, 73124),
(73125, '2.10.60.10-FF-000011', NULL, 'lymphocyte antigen 6H isoform X1', 89, NULL, NULL, 73125),
(73126, '3.30.70.2190-FF-000014', NULL, 'D-lactate dehydrogenase (Dld)', 121, NULL, NULL, 73126),
(73127, '1.25.40.10-FF-004284', NULL, 'Slr1196 protein', 204, NULL, NULL, 73127),
(73128, '2.40.70.10-FF-000358', NULL, NULL, 133, NULL, NULL, 73128),
(73129, '2.60.220.50-FF-000119', NULL, 'Uncharacterized protein', 46, NULL, NULL, 73129),
(73130, '3.30.160.20-FF-000254', NULL, 'Interleukin enhancer-binding factor 3a', 39, NULL, NULL, 73130),
(73131, '1.20.58.1380-FF-000015', NULL, 'Chromosome 7, whole genome shotgun sequence', 88, NULL, NULL, 73131);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(73132, '3.40.50.150-FF-000171', NULL, 'Chemotaxis protein methyltransferase', 194, NULL, NULL, 73132),
(73133, '3.40.50.1820-FF-000564', NULL, 'Alpha/beta-Hydrolases superfamily protein', 214, NULL, NULL, 73133),
(73134, '2.50.20.10-FF-000006', NULL, 'Outer-membrane lipoprotein carrier protein', 185, NULL, NULL, 73134),
(73135, '3.40.50.300-FF-003931', NULL, 'Rho family GTPase, putative', 189, NULL, NULL, 73135),
(73136, '3.30.830.10-FF-000218', NULL, 'Uncharacterized protein', 78, NULL, NULL, 73136),
(73137, '3.30.428.10-FF-000053', NULL, 'Galactose-1-phosphate uridylyltransferase', 81, NULL, NULL, 73137),
(73138, '3.30.300.90-FF-000011', NULL, NULL, 93, NULL, NULL, 73138),
(73139, '4.10.60.10-FF-000079', NULL, 'Nucleic acid binding protein', 30, NULL, NULL, 73139),
(73140, '2.100.10.30-FF-000009', NULL, 'Protein RESTRICTED TEV MOVEMENT 1', 156, NULL, NULL, 73140),
(73141, '3.30.1330.40-FF-000059', NULL, 'Predicted protein', 132, NULL, NULL, 73141),
(73142, '3.40.850.10-FF-000375', NULL, 'Uncharacterized protein', 99, NULL, NULL, 73142),
(73143, '1.10.510.10-FF-000678', NULL, 'Serine/threonine-protein kinase STN7, chloroplastic', 215, NULL, NULL, 73143),
(73144, '3.30.70.1660-FF-000035', NULL, 'Predicted protein', 112, NULL, NULL, 73144),
(73145, '2.60.40.10-FF-000367', NULL, 'Neural cell adhesion molecule L1-like protein', 92, NULL, NULL, 73145),
(73146, '3.40.50.620-FF-000683', NULL, 'Uncharacterized protein', 163, NULL, NULL, 73146),
(73147, '3.90.650.10-FF-000022', NULL, 'selenide, water dikinase 1 isoform X3', 63, NULL, NULL, 73147),
(73148, '2.60.120.260-FF-000165', NULL, 'Beta-mannosidase', 205, NULL, NULL, 73148),
(73149, '3.40.80.10-FF-000008', NULL, 'N-acetylmuramoyl-L-alanine amidase', 148, NULL, NULL, 73149),
(73150, '2.30.30.100-FF-000141', NULL, 'Probable U6 snRNA-associated Sm-like protein LSm4', 83, NULL, NULL, 73150),
(73151, '1.25.40.10-FF-003795', NULL, 'MxaK protein', 144, NULL, NULL, 73151),
(73152, '2.30.30.40-FF-000079', NULL, 'Mitogen-activated protein kinase kinase kinase', 69, NULL, NULL, 73152),
(73153, '3.30.160.60-FF-000316', NULL, 'Zinc finger and BTB domain-containing 14', 32, NULL, NULL, 73153),
(73154, '1.10.8.60-FF-000001', NULL, 'ATP-dependent zinc metalloprotease FtsH', 75, NULL, NULL, 73154),
(73155, '3.40.50.1260-FF-000025', NULL, 'Phosphoglycerate kinase', 193, NULL, NULL, 73155),
(73156, '1.20.900.10-FF-000009', NULL, 'Vav guanine nucleotide exchange factor 1', 194, NULL, NULL, 73156),
(73157, '3.40.50.300-FF-004420', NULL, 'GTP-binding nuclear protein Ran', 176, NULL, NULL, 73157),
(73158, '3.30.700.10-FF-000006', NULL, 'Fimbrial assembly protein PilE', 126, NULL, NULL, 73158),
(73159, '3.30.160.60-FF-003352', NULL, 'Zinc finger protein 792', 31, NULL, NULL, 73159),
(73160, '2.60.40.60-FF-000112', NULL, 'neural-cadherin isoform X1', 106, NULL, NULL, 73160),
(73161, '3.60.110.10-FF-000016', NULL, 'Nitrilase blr3397', 287, NULL, NULL, 73161),
(73162, '3.30.70.660-FF-000072', NULL, 'tRNA pseudouridine synthase A', 148, NULL, NULL, 73162),
(73163, '1.25.50.20-FF-000044', NULL, 'Uncharacterized protein', 335, NULL, NULL, 73163),
(73164, '1.20.58.1080-FF-000015', NULL, 'DExH-box ATP-dependent RNA helicase DExH18 mitochondrial', 99, NULL, NULL, 73164),
(73165, '1.20.1070.10-FF-001259', NULL, 'Uncharacterized protein', 170, NULL, NULL, 73165),
(73166, '3.40.50.11610-FF-000032', NULL, NULL, 140, NULL, NULL, 73166),
(73167, '3.30.40.10-FF-000984', NULL, 'Putative RING zinc finger domain superfamily protein', 93, NULL, NULL, 73167),
(73168, '3.55.50.30-FF-000018', NULL, 'Putative anti-sigma factor', 77, NULL, NULL, 73168),
(73169, '1.10.238.10-FF-001181', NULL, 'Uncharacterized protein', 87, NULL, NULL, 73169),
(73170, '3.30.200.20-FF-001135', NULL, 'Casein kinase I isoform alpha', 59, NULL, NULL, 73170),
(73171, '2.60.120.260-FF-000474', NULL, 'Predicted protein', 181, NULL, NULL, 73171),
(73172, '2.30.29.30-FF-000477', NULL, 'TBC1 domain family member 4 isoform X1', 66, NULL, NULL, 73172),
(73173, '3.20.20.150-FF-000040', NULL, 'Xylose isomerase', 253, NULL, NULL, 73173);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(73174, '3.30.470.20-FF-000081', NULL, 'Glutathione synthetase', 52, NULL, NULL, 73174),
(73175, '3.40.50.1820-FF-000255', NULL, 'Alpha/beta hydrolase, putative', 295, NULL, NULL, 73175),
(73176, '1.10.600.10-FF-000022', NULL, 'NADH dehydrogenase complex assembly factor 6-like protein', 272, NULL, NULL, 73176),
(73177, '2.130.10.10-FF-001290', NULL, 'WD repeat domain 11', 193, NULL, NULL, 73177),
(73178, '3.30.70.330-FF-001046', NULL, 'Nucleolin 1', 165, NULL, NULL, 73178),
(73179, '3.80.10.10-FF-003167', NULL, 'Uncharacterized protein', 415, NULL, NULL, 73179),
(73180, '2.40.128.700-FF-000003', NULL, 'Fatty acid synthase subunit beta', 116, NULL, NULL, 73180),
(73181, '1.20.120.140-FF-000010', NULL, 'signal recognition particle receptor subunit alpha isoform X2', 106, NULL, NULL, 73181),
(73182, '1.10.8.80-FF-000007', NULL, 'Putative moxR protein', 123, NULL, NULL, 73182),
(73183, '3.15.10.10-FF-000006', NULL, 'phospholipid transfer protein isoform X4', 38, NULL, NULL, 73183),
(73184, '3.40.50.300-FF-008282', NULL, 'Uncharacterized protein', 33, NULL, NULL, 73184),
(73185, '1.10.357.10-FF-000046', NULL, 'Transcriptional regulator, TetR family', 208, NULL, NULL, 73185),
(73186, '1.10.287.950-FF-000030', NULL, 'Chemotaxis transducer', 331, NULL, NULL, 73186),
(73187, '2.130.10.10-FF-004386', NULL, 'Activated protein kinase C receptor, putative', 68, NULL, NULL, 73187),
(73188, '2.60.40.420-FF-000131', NULL, 'GM22848', 173, NULL, NULL, 73188),
(73189, '3.40.50.300-FF-007646', NULL, 'Dephospho-CoA kinase', 135, NULL, NULL, 73189),
(73190, '3.30.40.10-FF-002120', NULL, 'Os01g0123700 protein', 101, NULL, NULL, 73190),
(73191, '1.10.10.10-FF-000089', NULL, 'Alkaline phosphatase synthesis response regulator', 111, NULL, NULL, 73191),
(73192, '3.30.930.10-FF-000254', NULL, 'Uncharacterized protein', 270, NULL, NULL, 73192),
(73193, '1.20.120.160-FF-000016', NULL, 'Signal transduction histidine kinase', 147, NULL, NULL, 73193),
(73194, '2.120.10.30-FF-000542', NULL, 'Uncharacterized protein', 76, NULL, NULL, 73194),
(73195, '2.30.30.40-FF-000551', NULL, 'Uncharacterized protein', 162, NULL, NULL, 73195),
(73196, '1.10.10.10-FF-000459', NULL, 'Ferric uptake regulation protein', 80, NULL, NULL, 73196),
(73197, '3.40.630.30-FF-000050', NULL, 'Acetyltransferase YhhY', 161, NULL, NULL, 73197),
(73198, '2.30.39.10-FF-000101', NULL, 'Uncharacterized protein', 118, NULL, NULL, 73198),
(73199, '2.130.10.10-FF-004706', NULL, 'CPSF A subunit region family protein', 402, NULL, NULL, 73199),
(73200, '1.10.196.10-FF-000003', NULL, 'regulator of G-protein signaling 3 isoform X1', 26, NULL, NULL, 73200),
(73201, '3.30.710.10-FF-000260', NULL, 'Uncharacterized protein', 161, NULL, NULL, 73201),
(73202, '1.10.3110.10-FF-000001', NULL, 'Protoporphyrinogen oxidase', 94, NULL, NULL, 73202),
(73203, '1.20.1250.20-FF-000534', NULL, 'Major facilitator superfamily domain-containing protein', 178, NULL, NULL, 73203),
(73204, '1.25.10.10-FF-000741', NULL, 'Armadillo repeat protein', 138, NULL, NULL, 73204),
(73205, '3.30.540.10-FF-000090', NULL, 'Uncharacterized protein', 37, NULL, NULL, 73205),
(73206, '1.20.90.10-FF-000020', NULL, 'Otoconin 90', 114, NULL, NULL, 73206),
(73207, '3.60.130.10-FF-000029', NULL, 'Clavaminate synthase-like protein', 293, NULL, NULL, 73207),
(73208, '2.130.10.10-FF-003897', NULL, 'Uncharacterized protein', 272, NULL, NULL, 73208),
(73209, '1.25.10.10-FF-001230', NULL, 'ARM repeat-containing protein', 242, NULL, NULL, 73209),
(73210, '3.30.200.20-FF-000179', NULL, 'SCY1 like pseudokinase 2', 92, NULL, NULL, 73210),
(73211, '1.20.1370.30-FF-000001', NULL, 'Uncharacterized protein', 89, NULL, NULL, 73211),
(73212, '3.40.50.300-FF-002975', NULL, 'ESX-2 type VII secretion system protein EccC', 320, NULL, NULL, 73212),
(73213, '3.40.50.2000-FF-001006', NULL, 'Uncharacterized protein', 251, NULL, NULL, 73213),
(73214, '2.60.120.290-FF-000028', NULL, 'Complement C1r subcomponent', 124, NULL, NULL, 73214),
(73215, '3.30.160.60-FF-003413', NULL, 'Expressed sequence AI877918', 30, NULL, NULL, 73215),
(73216, '3.80.10.10-FF-003476', NULL, 'F-box domain containing protein', 210, NULL, NULL, 73216);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(73217, '3.30.2450.30-FF-000003', NULL, 'Histone acetyltransferase', 151, NULL, NULL, 73217),
(73218, '1.25.40.10-FF-002704', NULL, 'Uncharacterized protein', 118, NULL, NULL, 73218),
(73219, '3.40.720.10-FF-000180', NULL, 'Arylsulfatase family member H', 144, NULL, NULL, 73219),
(73220, '2.10.25.10-FF-000733', NULL, 'Wall-associated receptor kinase 2', 42, NULL, NULL, 73220),
(73221, '3.30.505.10-FF-000210', NULL, NULL, 112, NULL, NULL, 73221),
(73222, '3.60.21.10-FF-000040', NULL, 'Serine/threonine-protein phosphatase', 305, NULL, NULL, 73222),
(73223, '3.30.160.60-FF-003189', NULL, 'ZNF235 isoform 5', 43, NULL, NULL, 73223),
(73224, '3.30.60.20-FF-000095', NULL, 'Thymidine kinase', 43, NULL, NULL, 73224),
(73225, '3.80.10.10-FF-000750', NULL, 'PH domain leucine-rich repeat-containing protein phosphatase 1 isoform A', 188, NULL, NULL, 73225),
(73226, '2.30.42.10-FF-000524', NULL, NULL, 64, NULL, NULL, 73226),
(73227, '1.20.1740.10-FF-000243', NULL, 'Uncharacterized protein', 342, NULL, NULL, 73227),
(73228, '2.170.140.10-FF-000024', NULL, 'Uncharacterized protein, isoform C', 69, NULL, NULL, 73228),
(73229, '2.120.10.30-FF-000379', NULL, 'Uncharacterized protein', 351, NULL, NULL, 73229),
(73230, '3.50.50.60-FF-000392', NULL, 'FAD/NAD(P)-binding oxidoreductase family protein', 63, NULL, NULL, 73230),
(73231, '3.30.70.260-FF-000058', NULL, 'Ribose 5-phosphate isomerase A', 93, NULL, NULL, 73231),
(73232, '1.10.10.10-FF-000561', NULL, 'ArsR family transcriptional regulator', 94, NULL, NULL, 73232),
(73233, '1.25.40.10-FF-000698', NULL, 'Peroxisomal targeting signal receptor', 294, NULL, NULL, 73233),
(73234, '1.10.600.10-FF-000005', NULL, 'Ent-kaur-16-ene synthase, chloroplastic', 313, NULL, NULL, 73234),
(73235, '1.10.10.10-FF-001415', NULL, 'ORC1-type DNA replication protein 3', 101, NULL, NULL, 73235),
(73236, '3.30.9.10-FF-000007', NULL, 'Glycerol-3-phosphate dehydrogenase', 137, NULL, NULL, 73236),
(73237, '3.50.50.60-FF-000212', NULL, 'Dihydrolipoyl dehydrogenase', 121, NULL, NULL, 73237),
(73238, '1.20.1250.20-FF-001023', NULL, 'Solute carrier organic anion transporter family member', 367, NULL, NULL, 73238),
(73239, '3.40.50.1460-FF-000113', NULL, 'AGAP010827-PA', 97, NULL, NULL, 73239),
(73240, '3.30.230.10-FF-000341', NULL, 'Elongation factor 2', 45, NULL, NULL, 73240),
(73241, '1.25.40.420-FF-000024', NULL, 'Kelch repeat and BTB domain containing 7', 126, NULL, NULL, 73241),
(73242, '3.30.200.20-FF-000842', NULL, 'Cyclin-dependent kinase C-2, putative', 101, NULL, NULL, 73242),
(73243, '2.60.40.60-FF-000904', NULL, 'Uncharacterized protein', 115, NULL, NULL, 73243),
(73244, '1.20.1070.10-FF-000303', NULL, 'Blast:Alpha-2C adrenergic receptor', 247, NULL, NULL, 73244),
(73245, '1.25.40.10-FF-001850', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 257, NULL, NULL, 73245),
(73246, '2.40.50.140-FF-000071', NULL, 'Eukaryotic translation initiation factor 1A', 143, NULL, NULL, 73246),
(73247, '3.30.1010.10-FF-000116', NULL, 'Uncharacterized protein', 83, NULL, NULL, 73247),
(73248, '2.10.25.10-FF-000424', NULL, 'Delta and Notch-like epidermal growth factor-related receptor', 40, NULL, NULL, 73248),
(73249, '3.40.220.10-FF-000035', NULL, 'Probable cytosol aminopeptidase', 155, NULL, NULL, 73249),
(73250, '1.10.10.60-FF-001132', NULL, NULL, 62, NULL, NULL, 73250),
(73251, '1.10.150.170-FF-000016', NULL, NULL, 106, NULL, NULL, 73251),
(73252, '3.40.50.300-FF-005376', NULL, 'Guanine nucleotide-binding protein alpha-4 subunit', 90, NULL, NULL, 73252),
(73253, '3.40.50.1860-FF-000008', NULL, 'Glutamate racemase', 109, NULL, NULL, 73253),
(73254, '3.30.420.40-FF-000831', NULL, 'Actin-related protein 3', 138, NULL, NULL, 73254),
(73255, '3.60.20.10-FF-000206', NULL, NULL, 198, NULL, NULL, 73255),
(73256, '3.40.50.720-FF-000387', NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', 277, NULL, NULL, 73256),
(73257, '2.40.70.10-FF-000460', NULL, NULL, 177, NULL, NULL, 73257),
(73258, '1.25.10.10-FF-002556', NULL, 'Uncharacterized protein', 173, NULL, NULL, 73258),
(73259, '3.80.10.10-FF-002650', NULL, 'Transforming growth factor beta activator LRRC33', 120, NULL, NULL, 73259);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(73260, '3.40.30.10-FF-001242', NULL, 'Uncharacterized protein', 82, NULL, NULL, 73260),
(73261, '3.90.1030.10-FF-000008', NULL, '50S ribosomal protein L17', 125, NULL, NULL, 73261),
(73262, '2.130.10.10-FF-005797', NULL, 'Uncharacterized protein', 403, NULL, NULL, 73262),
(73263, '2.60.40.1730-FF-000038', NULL, 'Aminopeptidase', 183, NULL, NULL, 73263),
(73264, '2.10.25.10-FF-001705', NULL, 'Transmembrane cell adhesion receptor mua-3', 41, NULL, NULL, 73264),
(73265, '3.40.50.800-FF-000113', NULL, 'Predicted protein', 99, NULL, NULL, 73265),
(73266, '3.40.630.10-FF-000381', NULL, 'Diaminopropionate ammonia-lyase, putative', 81, NULL, NULL, 73266),
(73267, '3.10.129.10-FF-000222', NULL, 'acyl-coenzyme A thioesterase 9, mitochondrial isoform X1', 152, NULL, NULL, 73267),
(73268, '1.25.10.10-FF-003175', NULL, 'ATR serine/threonine kinase', 327, NULL, NULL, 73268),
(73269, '3.30.160.60-FF-003661', NULL, 'Uncharacterized protein, isoform B', 105, NULL, NULL, 73269),
(73270, '1.25.40.10-FF-004604', NULL, 'Pentatricopeptide repeat-containing protein At1g30610, chloroplastic', 165, NULL, NULL, 73270),
(73271, '1.20.1250.20-FF-000517', NULL, 'Uncharacterized protein', 185, NULL, NULL, 73271),
(73272, '1.10.1450.10-FF-000094', NULL, 'Tetraspanin', 95, NULL, NULL, 73272),
(73273, '2.130.10.10-FF-003425', NULL, 'Cleavage stimulation factor subunit 1', 176, NULL, NULL, 73273),
(73274, '3.60.21.10-FF-000169', NULL, 'Uncharacterized protein', 255, NULL, NULL, 73274),
(73275, '2.30.36.70-FF-000022', NULL, 'Uncharacterized protein', 45, NULL, NULL, 73275),
(73276, '2.20.70.10-FF-000168', NULL, 'Uncharacterized protein', 54, NULL, NULL, 73276),
(73277, '3.90.190.10-FF-000442', NULL, 'Uncharacterized protein', 277, NULL, NULL, 73277),
(73278, '3.90.190.10-FF-000003', NULL, 'receptor-type tyrosine-protein phosphatase kappa isoform X1', 289, NULL, NULL, 73278),
(73279, '3.40.1410.10-FF-000049', NULL, 'Putative GntR-family regulatory protein', 159, NULL, NULL, 73279),
(73280, '2.30.40.10-FF-000138', NULL, '5-methylthioadenosine/S-adenosylhomocysteine deaminase', 103, NULL, NULL, 73280),
(73281, '2.60.40.150-FF-000174', NULL, 'Multiple C2 domains, transmembrane 2a', 130, NULL, NULL, 73281),
(73282, '2.40.30.10-FF-000103', NULL, 'NADPH oxidase 2', 94, NULL, NULL, 73282),
(73283, '3.40.1190.20-FF-000242', NULL, NULL, 75, NULL, NULL, 73283),
(73284, '1.20.1050.10-FF-000196', NULL, 'Em:AP000351.3 protein', 69, NULL, NULL, 73284),
(73285, '3.40.50.2300-FF-000489', NULL, 'Protein CBG01593', 230, NULL, NULL, 73285),
(73286, '2.40.50.90-FF-000072', NULL, 'Transcription factor (Snd1/p100), putative', 151, NULL, NULL, 73286),
(73287, '2.60.40.10-FF-005673', NULL, NULL, 132, NULL, NULL, 73287),
(73288, '2.30.30.40-FF-000449', NULL, 'SH3 domain-containing protein 2', 79, NULL, NULL, 73288),
(73289, '3.30.40.10-FF-000175', NULL, 'Putative E3 ubiquitin-protein ligase MYLIP', 79, NULL, NULL, 73289),
(73290, '3.40.50.620-FF-000374', NULL, 'Electron transfer flavoprotein subunit alpha', 184, NULL, NULL, 73290),
(73291, '1.20.1250.20-FF-000034', NULL, 'MFS general substrate transporter', 206, NULL, NULL, 73291),
(73292, '1.10.640.10-FF-000098', NULL, 'Uncharacterized protein', 254, NULL, NULL, 73292),
(73293, '1.10.390.10-FF-000117', NULL, 'Predicted protein', 134, NULL, NULL, 73293),
(73294, '3.30.160.60-FF-000816', NULL, 'myoneurin isoform X1', 24, NULL, NULL, 73294),
(73295, '1.25.10.10-FF-002995', NULL, 'Uncharacterized protein', 365, NULL, NULL, 73295),
(73296, '1.10.287.2610-FF-000001', NULL, 'Chromosome segregation protein SMC', 216, NULL, NULL, 73296),
(73297, '3.50.50.60-FF-000549', NULL, 'FAD binding domain protein', 392, NULL, NULL, 73297),
(73298, '1.10.10.10-FF-000898', NULL, 'Homologous-pairing protein 2', 78, NULL, NULL, 73298),
(73299, '3.30.70.920-FF-000037', NULL, 'Transcriptional regulator, AsnC family', 85, NULL, NULL, 73299),
(73300, '1.25.10.10-FF-000078', NULL, 'Coatomer subunit gamma', 294, NULL, NULL, 73300),
(73301, '2.60.220.50-FF-000136', NULL, 'Uncharacterized protein', 157, NULL, NULL, 73301),
(73302, '3.40.640.10-FF-000319', NULL, 'Pyridoxamine--pyruvate transaminase', 246, NULL, NULL, 73302);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(73303, '3.90.810.10-FF-000041', NULL, NULL, 68, NULL, NULL, 73303),
(73304, '3.30.565.10-FF-000186', NULL, 'Two-component system sensor histidine kinase', 155, NULL, NULL, 73304),
(73305, '1.20.1070.10-FF-001731', NULL, 'Uncharacterized protein', 93, NULL, NULL, 73305),
(73306, '1.10.510.10-FF-000223', NULL, 'probable receptor-like protein kinase At1g80640', 200, NULL, NULL, 73306),
(73307, '2.20.100.10-FF-000040', NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 9', 59, NULL, NULL, 73307),
(73308, '3.30.70.100-FF-000134', NULL, NULL, 68, NULL, NULL, 73308),
(73309, '1.25.40.10-FF-001395', NULL, 'Pentatricopeptide repeat-containing protein At3g53700, chloroplastic', 137, NULL, NULL, 73309),
(73310, '3.30.70.330-FF-002344', NULL, NULL, 108, NULL, NULL, 73310),
(73311, '1.10.510.10-FF-002595', NULL, NULL, 189, NULL, NULL, 73311),
(73312, '3.30.70.1660-FF-000018', NULL, 'Mitochondrial translation release factor', 111, NULL, NULL, 73312),
(73313, '1.20.1560.10-FF-000515', NULL, 'Uncharacterized protein', 321, NULL, NULL, 73313),
(73314, '3.10.180.10-FF-000015', NULL, 'Metallothiol transferase FosB', 135, NULL, NULL, 73314),
(73315, '3.20.20.80-FF-000493', NULL, 'Uncharacterized protein', 153, NULL, NULL, 73315),
(73316, '3.30.200.20-FF-002287', NULL, 'CDPK-related kinase 5', 71, NULL, NULL, 73316),
(73317, '1.25.40.10-FF-003295', NULL, 'Predicted protein', 188, NULL, NULL, 73317),
(73318, '3.20.20.80-FF-000830', NULL, 'Beta-galactosidase', 48, NULL, NULL, 73318),
(73319, '1.10.510.10-FF-000695', NULL, 'Protein kinase C', 50, NULL, NULL, 73319),
(73320, '2.170.300.10-FF-000059', NULL, 'Uncharacterized protein', 50, NULL, NULL, 73320),
(73321, '2.130.10.10-FF-005325', NULL, 'Protein rigor mortis', 197, NULL, NULL, 73321),
(73322, '1.25.10.10-FF-002848', NULL, 'Uncharacterized protein', 170, NULL, NULL, 73322),
(73323, '1.20.5.110-FF-000160', NULL, 'Uncharacterized protein', 72, NULL, NULL, 73323),
(73324, '3.30.160.60-FF-000024', NULL, 'zinc finger protein 140 isoform X1', 28, NULL, NULL, 73324),
(73325, '3.30.70.330-FF-001838', NULL, NULL, 117, NULL, NULL, 73325),
(73326, '3.90.660.10-FF-000096', NULL, NULL, 108, NULL, NULL, 73326),
(73327, '3.40.50.970-FF-000118', NULL, 'Indolepyruvate oxidoreductase subunit IorA', 59, NULL, NULL, 73327),
(73328, '1.10.287.70-FF-000704', NULL, 'Uncharacterized protein', 189, NULL, NULL, 73328),
(73329, '2.60.40.10-FF-001648', NULL, 'Immunoglobulin heavy variable 4-3', 97, NULL, NULL, 73329),
(73330, '2.30.29.170-FF-000002', NULL, 'EF-hand domain (C-terminal) containing 1', 122, NULL, NULL, 73330),
(73331, '3.40.50.720-FF-001567', NULL, 'Probable oxidoreductase (Short-chain dehydrogenase family)', 243, NULL, NULL, 73331),
(73332, '3.80.10.10-FF-003976', NULL, 'Uncharacterized protein', 160, NULL, NULL, 73332),
(73333, '2.40.330.10-FF-000007', NULL, 'AP2/ERF and B3 domain-containing transcription factor RAV1', 124, NULL, NULL, 73333),
(73334, '3.30.40.10-FF-002018', NULL, 'Uncharacterized protein', 40, NULL, NULL, 73334),
(73335, '1.20.120.1240-FF-000009', NULL, 'Dynamin-related protein 1C', 257, NULL, NULL, 73335),
(73336, '3.30.160.60-FF-002716', NULL, 'Zinc finger protein 212', 32, NULL, NULL, 73336),
(73337, '3.30.2350.10-FF-000080', NULL, 'Uncharacterized protein', 249, NULL, NULL, 73337),
(73338, '1.20.1260.10-FF-000003', NULL, 'DNA protection during starvation protein', 166, NULL, NULL, 73338),
(73339, '1.10.1410.10-FF-000029', NULL, 'Poly(A) RNA polymerase gld-4', 171, NULL, NULL, 73339),
(73340, '3.90.640.10-FF-000196', NULL, 'Uncharacterized protein', 112, NULL, NULL, 73340),
(73341, '3.40.50.2300-FF-000152', NULL, 'G protein-coupled receptor class C group 6 member A', 154, NULL, NULL, 73341),
(73342, '1.25.40.20-FF-000116', NULL, 'Ankyrin repeat and FYVE domain containing 1', 186, NULL, NULL, 73342),
(73343, '3.40.140.10-FF-000197', NULL, 'Uncharacterized protein', 107, NULL, NULL, 73343),
(73344, '2.30.140.10-FF-000006', NULL, 'thermospermine synthase ACAULIS5', 53, NULL, NULL, 73344),
(73345, '3.40.1370.10-FF-000011', NULL, '50S ribosomal protein L4', 290, NULL, NULL, 73345);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(73346, '2.20.100.10-FF-000068', NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 9', 57, NULL, NULL, 73346),
(73347, '2.60.120.380-FF-000072', NULL, 'Uncharacterized protein', 160, NULL, NULL, 73347),
(73348, '3.30.160.20-FF-000119', NULL, 'R2D2', 84, NULL, NULL, 73348),
(73349, '1.25.40.180-FF-000143', NULL, NULL, 170, NULL, NULL, 73349),
(73350, '1.10.150.120-FF-000012', NULL, 'Xanthine dehydrogenase 2', 147, NULL, NULL, 73350),
(73351, '3.30.160.60-FF-001435', NULL, 'zinc finger protein 777', 27, NULL, NULL, 73351),
(73352, '1.20.58.90-FF-000020', NULL, 'RalA-binding protein 1', 40, NULL, NULL, 73352),
(73353, '1.25.40.10-FF-002676', NULL, 'N-ethylmaleimide-sensitive factor attachment protein, beta b', 123, NULL, NULL, 73353),
(73354, '4.10.410.20-FF-000016', NULL, 'Predicted protein', 55, NULL, NULL, 73354),
(73355, '3.40.50.10810-FF-000096', NULL, 'Helicase, putative', 234, NULL, NULL, 73355),
(73356, '1.25.40.10-FF-005138', NULL, 'Uncharacterized protein', 100, NULL, NULL, 73356),
(73357, '3.40.50.2000-FF-000522', NULL, 'Scopoletin glucosyltransferase', 189, NULL, NULL, 73357),
(73358, '3.30.200.20-FF-002416', NULL, 'Uncharacterized protein', 87, NULL, NULL, 73358),
(73359, '1.10.8.10-FF-000110', NULL, 'NEDD8 ultimate buster 1', 39, NULL, NULL, 73359),
(73360, '3.30.1370.170-FF-000001', NULL, 'Erythronate-4-phosphate dehydrogenase', 86, NULL, NULL, 73360),
(73361, '2.40.270.10-FF-000036', NULL, NULL, 100, NULL, NULL, 73361),
(73362, '3.30.160.60-FF-002233', NULL, 'transcription factor E4F1 isoform X1', 27, NULL, NULL, 73362),
(73363, '1.25.40.20-FF-000779', NULL, 'Uncharacterized protein', 161, NULL, NULL, 73363),
(73364, '3.50.50.60-FF-001038', NULL, 'Rab proteins geranylgeranyltransferase component A', 62, NULL, NULL, 73364),
(73365, '1.10.630.10-FF-000272', NULL, 'Cytochrome P450 oxidoreductase GliF', 405, NULL, NULL, 73365),
(73366, '3.80.10.10-FF-002548', NULL, 'Putative serine/threonine-protein kinase pats1', 154, NULL, NULL, 73366),
(73367, '3.40.50.1010-FF-000208', NULL, NULL, 73, NULL, NULL, 73367),
(73368, '3.40.50.1000-FF-000559', NULL, NULL, 121, NULL, NULL, 73368),
(73369, '3.30.2410.10-FF-000001', NULL, 'E3 ubiquitin-protein ligase NEDD4-like', 118, NULL, NULL, 73369),
(73370, '3.20.20.105-FF-000014', NULL, 'Uncharacterized protein', 373, NULL, NULL, 73370),
(73371, '1.20.5.710-FF-000013', NULL, '54S ribosomal protein L12, mitochondrial', 71, NULL, NULL, 73371),
(73372, '1.20.1420.10-FF-000005', NULL, 'Talin 2', 165, NULL, NULL, 73372),
(73373, '2.40.70.10-FF-000488', NULL, NULL, 138, NULL, NULL, 73373),
(73374, '2.60.40.10-FF-002284', NULL, 'Twitchin', 94, NULL, NULL, 73374),
(73375, '3.80.10.10-FF-003959', NULL, 'Uncharacterized protein', 199, NULL, NULL, 73375),
(73376, '3.40.50.2000-FF-000961', NULL, 'UDP-glycosyltransferase 73C5', 100, NULL, NULL, 73376),
(73377, '3.60.130.10-FF-000046', NULL, 'Predicted protein', 295, NULL, NULL, 73377),
(73378, '2.60.120.10-FF-000190', NULL, 'Cysteine dioxygenase', 129, NULL, NULL, 73378),
(73379, '3.40.50.720-FF-002073', NULL, 'Uncharacterized protein', 150, NULL, NULL, 73379),
(73380, '3.30.465.10-FF-000122', NULL, 'D-lactate dehydrogenase [cytochrome] mitochondrial', 94, NULL, NULL, 73380),
(73381, '3.30.200.20-FF-000207', NULL, 'proline-rich receptor-like protein kinase PERK1', 98, NULL, NULL, 73381),
(73382, '1.10.10.10-FF-001387', NULL, 'Ets variant 1', 72, NULL, NULL, 73382),
(73383, '3.30.160.60-FF-001744', NULL, 'Zinc finger protein 425', 30, NULL, NULL, 73383),
(73384, '1.10.533.10-FF-000259', NULL, 'Uncharacterized protein', 74, NULL, NULL, 73384),
(73385, '3.40.720.10-FF-000163', NULL, 'Predicted protein', 178, NULL, NULL, 73385),
(73386, '3.30.559.30-FF-000003', NULL, 'Nonribosomal peptide synthase SidD', 256, NULL, NULL, 73386),
(73387, '1.25.40.20-FF-000908', NULL, 'Uncharacterized protein', 275, NULL, NULL, 73387),
(73388, '1.10.238.10-FF-001051', NULL, 'Uncharacterized protein', 100, NULL, NULL, 73388),
(73389, '3.30.1940.10-FF-000001', NULL, 'Phenylalanine--tRNA ligase beta subunit', 75, NULL, NULL, 73389);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(73390, '3.30.160.60-FF-001305', NULL, 'Zinc finger protein 48', 33, NULL, NULL, 73390),
(73391, '3.80.10.10-FF-004448', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 109, NULL, NULL, 73391),
(73392, '1.20.1250.20-FF-002203', NULL, 'Uncharacterized protein', 145, NULL, NULL, 73392),
(73393, '1.25.40.10-FF-002367', NULL, 'Pentatricopeptide repeat-containing protein At2g42920, chloroplastic', 104, NULL, NULL, 73393),
(73394, '1.25.40.10-FF-001878', NULL, 'Hypothetical_protein_-_conserved', 171, NULL, NULL, 73394),
(73395, '3.90.1750.10-FF-000001', NULL, 'E3 ubiquitin-protein ligase NEDD4-like', 226, NULL, NULL, 73395),
(73396, '3.30.70.330-FF-002783', NULL, NULL, 56, NULL, NULL, 73396),
(73397, '2.10.25.10-FF-000396', NULL, 'matrilin-2 isoform X3', 34, NULL, NULL, 73397),
(73398, '3.65.10.20-FF-000030', NULL, 'RNA 3''-terminal phosphate cyclase', 162, NULL, NULL, 73398),
(73399, '1.25.40.20-FF-001527', NULL, 'Protein 21.1', 85, NULL, NULL, 73399),
(73400, '3.80.10.10-FF-003829', NULL, 'Receptor like protein 28', 67, NULL, NULL, 73400),
(73401, '3.30.40.10-FF-002092', NULL, 'Uncharacterized protein', 86, NULL, NULL, 73401),
(73402, '2.40.30.70-FF-000014', NULL, 'Predicted protein', 152, NULL, NULL, 73402),
(73403, '1.10.260.100-FF-000003', NULL, 'Ubiquilin 1', 62, NULL, NULL, 73403),
(73404, '3.30.200.20-FF-002107', NULL, 'Predicted protein', 79, NULL, NULL, 73404),
(73405, '3.20.20.70-FF-000164', NULL, '23S rRNA methyltransferase', 292, NULL, NULL, 73405),
(73406, '3.80.10.10-FF-002211', NULL, 'Predicted protein', 182, NULL, NULL, 73406),
(73407, '1.10.555.10-FF-000012', NULL, 'Putative inositol polyphosphate 5-phosphatase OCRL-1', 165, NULL, NULL, 73407),
(73408, '3.40.5.10-FF-000009', NULL, '50S ribosomal protein L9', 44, NULL, NULL, 73408),
(73409, '3.30.2320.80-FF-000003', NULL, 'Hydrogenase maturation factor HypA', 112, NULL, NULL, 73409),
(73410, '1.10.760.10-FF-000062', NULL, 'Cytochrome c family protein', 103, NULL, NULL, 73410),
(73411, '1.25.40.10-FF-001215', NULL, 'Pentatricopeptide repeat-containing protein', 87, NULL, NULL, 73411),
(73412, '3.40.220.10-FF-000018', NULL, 'Protein-ADP-ribose hydrolase', 256, NULL, NULL, 73412),
(73413, '3.30.2140.20-FF-000011', NULL, 'Arylamine N-acetyltransferase 1', 293, NULL, NULL, 73413),
(73414, '3.10.20.90-FF-000491', NULL, 'WGS project CABT00000000 data, contig 2.11', 107, NULL, NULL, 73414),
(73415, '3.15.10.30-FF-000001', NULL, 'Takeout-like protein 1', 221, NULL, NULL, 73415),
(73416, '3.30.420.140-FF-000006', NULL, 'Transcription elongation factor spt6', 176, NULL, NULL, 73416),
(73417, '1.10.3210.10-FF-000048', NULL, 'Diguanylate cyclase', 189, NULL, NULL, 73417),
(73418, '3.10.100.10-FF-000139', NULL, 'Uncharacterized protein', 129, NULL, NULL, 73418),
(73419, '2.60.40.10-FF-004745', NULL, NULL, 90, NULL, NULL, 73419),
(73420, '2.60.40.150-FF-000466', NULL, 'Copine III', 77, NULL, NULL, 73420),
(73421, '3.10.580.10-FF-000107', NULL, 'Putative CBS domains protein', 159, NULL, NULL, 73421),
(73422, '2.60.40.3310-FF-000001', NULL, 'Hypothetical fimbrial subunit', 186, NULL, NULL, 73422),
(73423, '3.40.30.10-FF-000606', NULL, 'Sulfhydryl oxidase', 140, NULL, NULL, 73423),
(73424, '1.20.58.60-FF-000814', NULL, 'Titin, putative', 191, NULL, NULL, 73424),
(73425, '1.50.40.10-FF-000297', NULL, 'Uncharacterized protein', 144, NULL, NULL, 73425),
(73426, '3.30.160.60-FF-005330', NULL, NULL, 72, NULL, NULL, 73426),
(73427, '2.60.40.10-FF-005690', NULL, NULL, 75, NULL, NULL, 73427),
(73428, '1.25.40.180-FF-000013', NULL, 'Nuclear cap-binding protein subunit 1', 252, NULL, NULL, 73428),
(73429, '2.30.30.100-FF-000124', NULL, 'Small nuclear ribonucleoprotein Sm D2', 83, NULL, NULL, 73429),
(73430, '3.40.50.300-FF-004892', NULL, 'Predicted protein', 205, NULL, NULL, 73430),
(73431, '2.40.20.10-FF-000086', NULL, 'Plasminogen', 83, NULL, NULL, 73431),
(73432, '3.40.190.10-FF-000700', NULL, 'Uncharacterized protein', 123, NULL, NULL, 73432),
(73433, '1.25.40.10-FF-004621', NULL, 'Intraflagellar transport protein 56', 158, NULL, NULL, 73433);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(73434, '1.25.40.10-FF-005110', NULL, 'Clustered mitochondria protein homolog', 117, NULL, NULL, 73434),
(73435, '2.20.70.10-FF-000270', NULL, 'Uncharacterized protein', 38, NULL, NULL, 73435),
(73436, '1.20.1280.290-FF-000052', NULL, 'Sugar transporter SWEET', 93, NULL, NULL, 73436),
(73437, '3.40.190.10-FF-000728', NULL, 'Ionotropic receptor 7a', 129, NULL, NULL, 73437),
(73438, '3.40.50.1220-FF-000024', NULL, '2-hydroxyacyl-CoA lyase', 155, NULL, NULL, 73438),
(73439, '1.25.50.20-FF-000061', NULL, 'Aminopeptidase A, putative', 48, NULL, NULL, 73439),
(73440, '1.20.58.1610-FF-000006', NULL, 'NADH-ubiquinone oxidoreductase chain 3', 116, NULL, NULL, 73440),
(73441, '3.30.40.10-FF-000192', NULL, 'G2/M phase-specific E3 ubiquitin-protein ligase isoform X1', 84, NULL, NULL, 73441),
(73442, '1.10.418.10-FF-000188', NULL, 'Zgc:66426', 114, NULL, NULL, 73442),
(73443, '3.40.50.720-FF-000948', NULL, 'Probable 2-hydroxyacid dehydrogenase', 95, NULL, NULL, 73443),
(73444, '1.10.472.10-FF-000589', NULL, 'Os03g0392000 protein', 34, NULL, NULL, 73444),
(73445, '3.30.160.60-FF-004841', NULL, NULL, 63, NULL, NULL, 73445),
(73446, '3.30.300.130-FF-000005', NULL, 'Mitotic spindle-associated mmxd complex subunit', 92, NULL, NULL, 73446),
(73447, '3.40.50.2000-FF-000652', NULL, 'UDP-glucosyltransferase 74AE2', 244, NULL, NULL, 73447),
(73448, '2.60.20.10-FF-000012', NULL, 'Beta-crystallin A2', 91, NULL, NULL, 73448),
(73449, '3.40.50.1000-FF-000661', NULL, NULL, 130, NULL, NULL, 73449),
(73450, '3.40.50.150-FF-001351', NULL, NULL, 192, NULL, NULL, 73450),
(73451, '3.40.50.410-FF-000327', NULL, 'Uncharacterized protein', 185, NULL, NULL, 73451),
(73452, '1.10.287.3080-FF-000001', NULL, 'Cytochrome c-552', 62, NULL, NULL, 73452),
(73453, '3.30.70.1620-FF-000001', NULL, 'Structural maintenance of chromosomes 1B', 85, NULL, NULL, 73453),
(73454, '2.60.40.10-FF-003464', NULL, NULL, 127, NULL, NULL, 73454),
(73455, '2.60.40.150-FF-000819', NULL, 'Uncharacterized protein', 65, NULL, NULL, 73455),
(73456, '1.20.120.310-FF-000022', NULL, NULL, 57, NULL, NULL, 73456),
(73457, '1.25.40.820-FF-000037', NULL, 'Uncharacterized protein', 90, NULL, NULL, 73457),
(73458, '1.10.287.70-FF-000384', NULL, 'Potassium intermediate/small conductance calcium-activated channel, subfamily N, member 4', 177, NULL, NULL, 73458),
(73459, '2.130.10.10-FF-004577', NULL, 'Uncharacterized protein', 210, NULL, NULL, 73459),
(73460, '3.40.50.510-FF-000003', NULL, 'PTS-dependent dihydroxyacetone kinase phosphotransferase subunit DhaM', 125, NULL, NULL, 73460),
(73461, '3.30.700.30-FF-000001', NULL, 'Propionyl-CoA carboxylase alpha chain, mitochondrial', 137, NULL, NULL, 73461),
(73462, '3.20.20.190-FF-000041', NULL, 'Glycerophosphocholine phosphodiesterase GPCPD1', 305, NULL, NULL, 73462),
(73463, '3.40.190.80-FF-000013', NULL, 'Inositol monophosphatase', 124, NULL, NULL, 73463),
(73464, '3.30.70.330-FF-002327', NULL, NULL, 114, NULL, NULL, 73464),
(73465, '1.20.1440.50-FF-000001', NULL, NULL, 111, NULL, NULL, 73465),
(73466, '1.10.10.440-FF-000096', NULL, 'Predicted protein', 58, NULL, NULL, 73466),
(73467, '2.60.120.590-FF-000028', NULL, 'Uncharacterized protein, isoform A', 186, NULL, NULL, 73467),
(73468, '2.60.200.20-FF-000238', NULL, 'Type III export protein PscD', 123, NULL, NULL, 73468),
(73469, '3.30.1300.30-FF-000004', NULL, 'Adhesin', 73, NULL, NULL, 73469),
(73470, '3.40.50.2000-FF-000730', NULL, 'OSJNBa0052O21.10 protein', 99, NULL, NULL, 73470),
(73471, '1.25.40.570-FF-000018', NULL, '26S proteasome non-ATPase regulatory subunit', 330, NULL, NULL, 73471),
(73472, '3.10.20.70-FF-000041', NULL, 'Uncharacterized protein', 59, NULL, NULL, 73472),
(73473, '2.70.20.10-FF-000034', NULL, 'DNA topoisomerase', 130, NULL, NULL, 73473),
(73474, '3.30.450.20-FF-000681', NULL, 'Blr6052 protein', 66, NULL, NULL, 73474),
(73475, '3.40.50.300-FF-007629', NULL, 'Uncharacterized protein YfjK', 146, NULL, NULL, 73475),
(73476, '2.100.10.40-FF-000001', NULL, NULL, 203, NULL, NULL, 73476),
(73477, '1.20.120.1750-FF-000056', NULL, 'RBR-type E3 ubiquitin transferase', 76, NULL, NULL, 73477);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(73478, '3.30.160.60-FF-005667', NULL, NULL, 28, NULL, NULL, 73478),
(73479, '3.40.1280.10-FF-000004', NULL, 'Ribosomal RNA large subunit methyltransferase H', 155, NULL, NULL, 73479),
(73480, '1.20.1070.10-FF-000612', NULL, 'Predicted protein', 315, NULL, NULL, 73480),
(73481, '3.40.50.360-FF-000144', NULL, 'Uncharacterized protein', 151, NULL, NULL, 73481),
(73482, '3.30.1330.30-FF-000040', NULL, 'SECIS-binding protein 2, putative', 134, NULL, NULL, 73482),
(73483, '2.40.10.10-FF-000692', NULL, NULL, 25, NULL, NULL, 73483),
(73484, '2.130.10.10-FF-000199', NULL, 'autophagy-related protein 16-2 isoform X1', 294, NULL, NULL, 73484),
(73485, '3.40.50.300-FF-000749', NULL, 'probable ATP-dependent RNA helicase DHX37', 176, NULL, NULL, 73485),
(73486, '1.20.1070.10-FF-001231', NULL, 'Corticotropin releasing hormone receptor 1', 144, NULL, NULL, 73486),
(73487, '1.25.40.120-FF-000024', NULL, 'Uncharacterized protein', 185, NULL, NULL, 73487),
(73488, '1.25.10.10-FF-002787', NULL, 'Tetratricopeptide repeat protein 12', 284, NULL, NULL, 73488),
(73489, '3.40.50.300-FF-004448', NULL, 'Midasin', 88, NULL, NULL, 73489),
(73490, '3.40.50.2300-FF-000713', NULL, 'Ribose ABC transporter, periplasmic ribose-binding protein', 154, NULL, NULL, 73490),
(73491, '3.10.110.10-FF-000376', NULL, 'RWD domain containing 1', 77, NULL, NULL, 73491),
(73492, '1.25.40.20-FF-001735', NULL, 'Uncharacterized protein', 220, NULL, NULL, 73492),
(73493, '2.60.120.860-FF-000002', NULL, 'Distal tail protein', 111, NULL, NULL, 73493),
(73494, '3.60.10.10-FF-000352', NULL, 'Uncharacterized protein', 162, NULL, NULL, 73494),
(73495, '3.40.50.10190-FF-000342', NULL, 'S-M checkpoint control protein rad4', 105, NULL, NULL, 73495),
(73496, '3.30.1780.10-FF-000011', NULL, 'Ornithine cyclodeaminase', 149, NULL, NULL, 73496),
(73497, '3.30.420.270-FF-000017', NULL, 'Tol-Pal system protein TolR', 75, NULL, NULL, 73497),
(73498, '1.10.8.10-FF-000341', NULL, 'Ubiquilin 4', 29, NULL, NULL, 73498),
(73499, '4.10.60.10-FF-000181', NULL, 'Predicted protein', 52, NULL, NULL, 73499),
(73500, '1.10.472.80-FF-000109', NULL, 'TBC domain containing protein', 125, NULL, NULL, 73500),
(73501, '3.30.750.44-FF-000001', NULL, 'S41 family peptidase', 67, NULL, NULL, 73501),
(73502, '3.30.200.20-FF-000281', NULL, 'Mitogen-activated protein kinase 4', 89, NULL, NULL, 73502),
(73503, '2.120.10.80-FF-000416', NULL, 'Kelch like ECH associated protein 1', 58, NULL, NULL, 73503),
(73504, '2.120.10.80-FF-000372', NULL, 'Tip elongation aberrant protein 3', 167, NULL, NULL, 73504),
(73505, '3.90.1750.20-FF-000021', NULL, NULL, 166, NULL, NULL, 73505),
(73506, '3.10.100.10-FF-000347', NULL, NULL, 145, NULL, NULL, 73506),
(73507, '1.25.40.90-FF-000064', NULL, 'Regulation of nuclear pre-mRNA domain-containing protein 1B', 134, NULL, NULL, 73507),
(73508, '2.60.40.10-FF-005229', NULL, NULL, 89, NULL, NULL, 73508),
(73509, '1.10.10.10-FF-000870', NULL, 'DNA-binding response regulator', 110, NULL, NULL, 73509),
(73510, '3.40.1690.20-FF-000027', NULL, 'Predicted protein', 60, NULL, NULL, 73510),
(73511, '3.30.160.60-FF-004150', NULL, NULL, 36, NULL, NULL, 73511),
(73512, '3.20.20.140-FF-000020', NULL, 'Adenosine deaminase', 351, NULL, NULL, 73512),
(73513, '3.40.50.720-FF-001937', NULL, 'Uncharacterized protein', 360, NULL, NULL, 73513),
(73514, '1.20.58.60-FF-000606', NULL, 'Dystonin', 118, NULL, NULL, 73514),
(73515, '2.30.30.140-FF-000024', NULL, 'Mortality factor 4-like protein 1', 93, NULL, NULL, 73515),
(73516, '3.30.70.1230-FF-000007', NULL, 'Guanylate cyclase soluble subunit alpha-3', 192, NULL, NULL, 73516),
(73517, '2.60.120.620-FF-000161', NULL, 'Uncharacterized protein', 133, NULL, NULL, 73517),
(73518, '3.40.50.2300-FF-000814', NULL, 'Vomeronasal 2, receptor 73', 115, NULL, NULL, 73518),
(73519, '1.20.1250.20-FF-001815', NULL, 'Monocarboxylate transporter, putative', 155, NULL, NULL, 73519),
(73520, '2.40.50.90-FF-000100', NULL, 'Putative ATP-dependent RNA helicase TDRD12', 119, NULL, NULL, 73520),
(73521, '3.40.50.150-FF-001508', NULL, NULL, 111, NULL, NULL, 73521);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(73522, '2.60.40.10-FF-002845', NULL, 'Macrophage stimulating 1 receptor a', 89, NULL, NULL, 73522),
(73523, '3.40.850.10-FF-000392', NULL, 'Uncharacterized protein', 293, NULL, NULL, 73523),
(73524, '1.20.1300.10-FF-000030', NULL, 'Succinate dehydrogenase/fumarate reductase, cytochrome b558 subunit', 215, NULL, NULL, 73524),
(73525, '3.30.1240.10-FF-000055', NULL, 'Cof-type HAD-IIB family hydrolase', 106, NULL, NULL, 73525),
(73526, '3.40.80.10-FF-000025', NULL, 'Peptidoglycan-recognition protein LD', 162, NULL, NULL, 73526),
(73527, '3.40.50.1820-FF-001744', NULL, 'Uncharacterized protein', 58, NULL, NULL, 73527),
(73528, '1.10.10.60-FF-001071', NULL, NULL, 53, NULL, NULL, 73528),
(73529, '1.25.40.550-FF-000012', NULL, 'protein AAR2 homolog', 185, NULL, NULL, 73529),
(73530, '3.90.550.10-FF-000003', NULL, '2-C-methyl-D-erythritol 4-phosphate cytidylyltransferase', 228, NULL, NULL, 73530),
(73531, '3.50.50.60-FF-000521', NULL, 'FAD dependent oxidoreductase domain containing 2', 168, NULL, NULL, 73531),
(73532, '1.20.58.60-FF-000022', NULL, 'Microtubule-actin cross-linking factor 1', 110, NULL, NULL, 73532),
(73533, '2.60.120.200-FF-000271', NULL, 'Laminin alpha 5', 160, NULL, NULL, 73533),
(73534, '2.30.39.10-FF-000056', NULL, 'leukocyte elastase inhibitor', 154, NULL, NULL, 73534),
(73535, '1.20.1070.10-FF-001276', NULL, 'GPR insulin like receptor 1', 323, NULL, NULL, 73535),
(73536, '3.40.50.11660-FF-000036', NULL, NULL, 208, NULL, NULL, 73536),
(73537, '3.40.50.11610-FF-000015', NULL, 'Putative 2-oxoglutarate dehydrogenase subunit', 166, NULL, NULL, 73537),
(73538, '3.10.450.50-FF-000076', NULL, 'Nuclear pore RNA shuttling protein Mtr2', 151, NULL, NULL, 73538),
(73539, '3.40.50.12610-FF-000006', NULL, 'Dolichyl-phosphooligosaccharide-protein glycotransferase', 157, NULL, NULL, 73539),
(73540, '3.30.559.10-FF-000048', NULL, 'Nonribosomal peptide synthase inpB', 181, NULL, NULL, 73540),
(73541, '2.40.50.140-FF-000099', NULL, 'Ribosomal protein S12, mitochondrial', 126, NULL, NULL, 73541),
(73542, '3.30.390.30-FF-000049', NULL, 'Glutathione reductase', 131, NULL, NULL, 73542),
(73543, '3.90.1230.10-FF-000006', NULL, NULL, 89, NULL, NULL, 73543),
(73544, '3.40.1380.20-FF-000060', NULL, 'Pyruvate kinase', 132, NULL, NULL, 73544),
(73545, '3.80.10.10-FF-001694', NULL, 'F-box/LRR-repeat protein 17', 144, NULL, NULL, 73545),
(73546, '1.25.10.10-FF-000269', NULL, 'Uncharacterized protein, isoform A', 249, NULL, NULL, 73546),
(73547, '3.30.40.10-FF-001529', NULL, 'Predicted protein', 109, NULL, NULL, 73547),
(73548, '3.90.70.10-FF-000781', NULL, 'Uncharacterized protein', 409, NULL, NULL, 73548),
(73549, '3.40.50.970-FF-000220', NULL, '2-oxoisovalerate dehydrogenase subunit alpha', 68, NULL, NULL, 73549),
(73550, '3.40.50.2300-FF-001433', NULL, NULL, 132, NULL, NULL, 73550),
(73551, '1.10.510.10-FF-003096', NULL, NULL, 247, NULL, NULL, 73551),
(73552, '3.40.50.800-FF-000085', NULL, 'Histidine--tRNA ligase', 94, NULL, NULL, 73552),
(73553, '1.20.1250.20-FF-000489', NULL, 'MFS general substrate transporter', 220, NULL, NULL, 73553),
(73554, '1.10.287.70-FF-000176', NULL, 'Potassium channel subfamily K member 9', 324, NULL, NULL, 73554),
(73555, '3.40.50.720-FF-002556', NULL, 'Uncharacterized protein', 59, NULL, NULL, 73555),
(73556, '2.10.25.10-FF-000216', NULL, 'Adhesion G protein-coupled receptor E2', 45, NULL, NULL, 73556),
(73557, '2.130.10.10-FF-000463', NULL, 'intraflagellar transport protein 80 homolog', 253, NULL, NULL, 73557),
(73558, '1.20.1250.20-FF-001231', NULL, 'Autophagy-related protein 22-1', 305, NULL, NULL, 73558),
(73559, '2.130.10.10-FF-001143', NULL, 'Pre-mRNA-splicing factor rse-1, putative', 362, NULL, NULL, 73559),
(73560, '1.10.472.80-FF-000020', NULL, 'TBC1 domain family, member 16', 128, NULL, NULL, 73560),
(73561, '1.10.630.10-FF-000142', NULL, 'Mycocyclosin synthase', 396, NULL, NULL, 73561),
(73562, '3.40.50.1970-FF-000030', NULL, '3-dehydroquinate synthase', 162, NULL, NULL, 73562),
(73563, '2.40.30.170-FF-000064', NULL, NULL, 83, NULL, NULL, 73563),
(73564, '3.40.190.10-FF-000245', NULL, 'ABC transporter substrate-binding protein', 101, NULL, NULL, 73564);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(73565, '3.40.390.10-FF-000018', NULL, 'Metalloendoproteinase 1', 272, NULL, NULL, 73565),
(73566, '2.130.10.10-FF-001188', NULL, 'Transducin/WD40 repeat-like superfamily protein', 266, NULL, NULL, 73566),
(73567, '1.20.1250.20-FF-000725', NULL, 'Uncharacterized protein', 201, NULL, NULL, 73567),
(73568, '3.30.160.60-FF-006286', NULL, NULL, 45, NULL, NULL, 73568),
(73569, '3.40.190.10-FF-000829', NULL, 'Phosphate-binding protein PstS', 137, NULL, NULL, 73569),
(73570, '2.40.170.20-FF-000110', NULL, 'TonB-dependent receptor SusC', 633, NULL, NULL, 73570),
(73571, '2.40.50.140-FF-000863', NULL, NULL, 71, NULL, NULL, 73571),
(73572, '1.10.472.10-FF-000460', NULL, 'Cyclin, N-terminal domain containing protein, putative', 112, NULL, NULL, 73572),
(73573, '3.40.50.300-FF-001014', NULL, 'Torsin', 216, NULL, NULL, 73573),
(73574, '3.40.1190.20-FF-000034', NULL, 'Putative hydroxymethylpyrimidine/ phosphomethylpyrimidine kinase 2', 285, NULL, NULL, 73574),
(73575, '3.40.190.10-FF-000672', NULL, 'Uncharacterized protein', 37, NULL, NULL, 73575),
(73576, '3.40.50.300-FF-006909', NULL, 'Uncharacterized protein', 237, NULL, NULL, 73576),
(73577, '2.30.42.10-FF-000316', NULL, 'Uncharacterized protein', 87, NULL, NULL, 73577),
(73578, '3.40.50.880-FF-000182', NULL, 'Imidazole glycerol phosphate synthase subunit HisH', 189, NULL, NULL, 73578),
(73579, '1.10.10.60-FF-001177', NULL, NULL, 37, NULL, NULL, 73579),
(73580, '4.10.280.10-FF-000204', NULL, 'Neuronal stem cell leukemia 2-like protein', 66, NULL, NULL, 73580),
(73581, '3.30.70.270-FF-000050', NULL, 'DNA repair protein', 105, NULL, NULL, 73581),
(73582, '3.60.10.10-FF-000121', NULL, 'Cytolethal distending toxin B subunit', 261, NULL, NULL, 73582),
(73583, '2.20.28.10-FF-000014', NULL, 'DNA helicase', 68, NULL, NULL, 73583),
(73584, '1.10.730.10-FF-000234', NULL, 'Methionine--tRNA ligase', 144, NULL, NULL, 73584),
(73585, '3.90.920.10-FF-000015', NULL, 'DNA primase small subunit PriS', 341, NULL, NULL, 73585),
(73586, '3.40.50.300-FF-005067', NULL, 'ADP ribosylation factor', 122, NULL, NULL, 73586),
(73587, '3.40.50.10490-FF-000050', NULL, 'Related to MRP4-mitochondrial ribosomal protein, small subunit', 223, NULL, NULL, 73587),
(73588, '3.90.76.10-FF-000013', NULL, 'Putative lipoprotein', 111, NULL, NULL, 73588),
(73589, '3.90.1170.50-FF-000024', NULL, 'Aerobic-type carbon monoxide dehydrogenase, large subunit-like protein', 36, NULL, NULL, 73589),
(73590, '1.10.418.10-FF-000216', NULL, 'Uncharacterized protein', 62, NULL, NULL, 73590),
(73591, '3.40.50.620-FF-000166', NULL, 'Electron transfer flavoprotein subunit alpha', 186, NULL, NULL, 73591),
(73592, '1.10.287.70-FF-000485', NULL, 'Calcium/potassium channel (CAKC), putative', 214, NULL, NULL, 73592),
(73593, '3.30.1490.80-FF-000015', NULL, 'Glutathione synthetase', 84, NULL, NULL, 73593),
(73594, '1.50.10.10-FF-000205', NULL, 'alpha-1,2-Mannosidase', 197, NULL, NULL, 73594),
(73595, '2.60.40.420-FF-000159', NULL, 'Auracyanin-B', 140, NULL, NULL, 73595),
(73596, '1.25.40.10-FF-000361', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 105, NULL, NULL, 73596),
(73597, '2.40.50.100-FF-000199', NULL, 'Uncharacterized protein', 51, NULL, NULL, 73597),
(73598, '3.30.160.60-FF-005931', NULL, NULL, 28, NULL, NULL, 73598),
(73599, '1.10.510.10-FF-001443', NULL, 'Uncharacterized protein', 183, NULL, NULL, 73599),
(73600, '3.40.50.10930-FF-000002', NULL, 'RecBCD enzyme subunit RecC', 148, NULL, NULL, 73600),
(73601, '3.30.750.80-FF-000002', NULL, 'Ribosomal RNA large subunit methyltransferase I', 109, NULL, NULL, 73601),
(73602, '3.30.200.20-FF-002079', NULL, 'Uncharacterized protein', 83, NULL, NULL, 73602),
(73603, '1.20.1270.60-FF-000030', NULL, 'Tyrosine-protein kinase', 269, NULL, NULL, 73603),
(73604, '1.20.1310.20-FF-000005', NULL, 'Erythrocyte-binding antigen 175', 163, NULL, NULL, 73604),
(73605, '1.20.1730.10-FF-000006', NULL, 'Urea active transporter', 505, NULL, NULL, 73605),
(73606, '1.10.510.10-FF-003904', NULL, NULL, 83, NULL, NULL, 73606),
(73607, '2.60.40.10-FF-000030', NULL, 'Semaphorin 3F like', 82, NULL, NULL, 73607);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(73608, '2.130.10.10-FF-002924', NULL, 'Uncharacterized protein', 238, NULL, NULL, 73608),
(73609, '1.10.510.10-FF-002123', NULL, 'Guanylate cyclase', 182, NULL, NULL, 73609),
(73610, '2.30.29.30-FF-000786', NULL, 'Ran-binding protein (RanBP), putative', 154, NULL, NULL, 73610),
(73611, '3.40.50.2300-FF-001006', NULL, NULL, 125, NULL, NULL, 73611),
(73612, '3.30.1330.60-FF-000037', NULL, 'Outer membrane porin F', 129, NULL, NULL, 73612),
(73613, '3.80.10.10-FF-001267', NULL, 'Receptor-like protein 9DC2', 259, NULL, NULL, 73613),
(73614, '3.40.50.300-FF-001469', NULL, 'Replicative DNA helicase', 56, NULL, NULL, 73614),
(73615, '2.60.40.820-FF-000043', NULL, 'Uncharacterized protein', 130, NULL, NULL, 73615),
(73616, '1.10.220.10-FF-000004', NULL, 'Annexin', 80, NULL, NULL, 73616),
(73617, '1.20.140.10-FF-000052', NULL, 'Putative acyl-CoA dehydrogenase YdbM', 143, NULL, NULL, 73617),
(73618, '2.60.40.60-FF-000876', NULL, 'E-cadherin-like protein', 103, NULL, NULL, 73618),
(73619, '3.40.630.10-FF-000072', NULL, 'Aminoacyl-histidine dipeptidase', 138, NULL, NULL, 73619),
(73620, '1.10.486.10-FF-000059', NULL, 'ADR113Wp', 179, NULL, NULL, 73620),
(73621, '1.20.1250.20-FF-000989', NULL, 'MFS sugar transporter, putative', 456, NULL, NULL, 73621),
(73622, '1.20.1510.10-FF-000012', NULL, 'Metal tolerance protein 1', 200, NULL, NULL, 73622),
(73623, '1.20.5.170-FF-000054', NULL, 'Cyclic AMP-responsive element-binding protein 3-like 2', 70, NULL, NULL, 73623),
(73624, '1.20.120.1080-FF-000057', NULL, 'Uncharacterized protein', 170, NULL, NULL, 73624),
(73625, '3.60.40.10-FF-000180', NULL, 'Putative protein phosphatase 2C-like protein 44', 94, NULL, NULL, 73625),
(73626, '3.40.50.1820-FF-000108', NULL, 'Lipid particle protein', 373, NULL, NULL, 73626),
(73627, '3.40.50.300-FF-000396', NULL, 'RNA helicase aquarius', 189, NULL, NULL, 73627),
(73628, '1.25.40.10-FF-001187', NULL, 'Superkiller 3 protein', 286, NULL, NULL, 73628),
(73629, '1.10.10.60-FF-000452', NULL, 'Chromatin complexes subunit BAP18', 44, NULL, NULL, 73629),
(73630, '3.20.10.10-FF-000016', NULL, 'Aminodeoxychorismate lyase', 117, NULL, NULL, 73630),
(73631, '3.40.50.1820-FF-000816', NULL, 'Gamma-glutamylcyclotransferase', 116, NULL, NULL, 73631),
(73632, '1.20.80.10-FF-000059', NULL, 'Acyl-CoA binding protein, putative', 101, NULL, NULL, 73632),
(73633, '3.30.420.40-FF-000859', NULL, 'Glucokinase (ROK family protein), conjectural', 120, NULL, NULL, 73633),
(73634, '1.10.238.10-FF-001034', NULL, 'Uncharacterized protein', 57, NULL, NULL, 73634),
(73635, '2.60.40.60-FF-000449', NULL, 'Predicted protein', 111, NULL, NULL, 73635),
(73636, '3.60.40.10-FF-000269', NULL, 'Phosphatase', 282, NULL, NULL, 73636),
(73637, '2.130.10.10-FF-005903', NULL, 'Predicted protein', 282, NULL, NULL, 73637),
(73638, '2.60.40.10-FF-003773', NULL, NULL, 88, NULL, NULL, 73638),
(73639, '3.40.50.1370-FF-000058', NULL, NULL, 136, NULL, NULL, 73639),
(73640, '2.10.220.10-FF-000040', NULL, 'Proprotein convertase subtilisin/kexin type 5', 93, NULL, NULL, 73640),
(73641, '3.40.50.2000-FF-000421', NULL, 'GG16746', 165, NULL, NULL, 73641),
(73642, '2.40.30.10-FF-000367', NULL, '5-methyltetrahydrofolate-homocysteine methyltransferase reductase', 46, NULL, NULL, 73642),
(73643, '3.30.40.10-FF-002148', NULL, 'Predicted protein', 57, NULL, NULL, 73643),
(73644, '3.30.1330.40-FF-000031', NULL, '3-hydroxybenzoate synthase', 130, NULL, NULL, 73644),
(73645, '3.30.9.10-FF-000142', NULL, 'Uncharacterized protein', 148, NULL, NULL, 73645),
(73646, '3.30.710.10-FF-000288', NULL, 'Predicted protein', 113, NULL, NULL, 73646),
(73647, '1.10.533.10-FF-000130', NULL, 'Protein Tube', 153, NULL, NULL, 73647),
(73648, '2.130.10.10-FF-000671', NULL, 'WD repeat containing, antisense to TP73', 145, NULL, NULL, 73648),
(73649, '3.30.559.10-FF-000256', NULL, 'Peptide synthetase', 20, NULL, NULL, 73649),
(73650, '1.10.510.10-FF-001504', NULL, 'Related to MAPKK kinase', 321, NULL, NULL, 73650),
(73651, '2.60.40.10-FF-002492', NULL, 'Uncharacterized protein', 109, NULL, NULL, 73651),
(73652, '1.10.1070.11-FF-000026', NULL, 'Phosphotransferases/inositol or phosphatidylinositol kinase', 182, NULL, NULL, 73652);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(73653, '2.60.40.10-FF-005010', NULL, NULL, 106, NULL, NULL, 73653),
(73654, '1.10.510.10-FF-000886', NULL, 'CK1 family protein kinase', 309, NULL, NULL, 73654),
(73655, '1.10.225.10-FF-000010', NULL, 'Sphingomyelin phosphodiesterase', 84, NULL, NULL, 73655),
(73656, '3.30.450.20-FF-000029', NULL, 'VWFA and cache domain-containing protein 1', 145, NULL, NULL, 73656),
(73657, '2.120.10.80-FF-000063', NULL, 'Kelch-like protein 4 isoform 1', 151, NULL, NULL, 73657),
(73658, '2.60.40.10-FF-004392', NULL, NULL, 98, NULL, NULL, 73658),
(73659, '1.25.40.20-FF-000807', NULL, 'Kinase, NEK', 112, NULL, NULL, 73659),
(73660, '1.20.920.50-FF-000005', NULL, 'Salivary androgen-binding protein gamma subunit', 88, NULL, NULL, 73660),
(73661, '2.60.40.1280-FF-000004', NULL, 'Fibronectin-binding protein A', 152, NULL, NULL, 73661),
(73662, '2.30.29.30-FF-000022', NULL, 'Putative FERM domain-containing protein 4A', 112, NULL, NULL, 73662),
(73663, '2.70.98.30-FF-000005', NULL, 'Alpha-mannosidase', 259, NULL, NULL, 73663),
(73664, '3.30.420.10-FF-000041', NULL, 'Exonuclease 3''-5'' domain containing 2', 190, NULL, NULL, 73664),
(73665, '3.30.430.20-FF-000016', NULL, 'Cysteine-rich receptor-like protein kinase 10', 104, NULL, NULL, 73665),
(73666, '2.130.10.10-FF-002571', NULL, 'Uncharacterized protein', 170, NULL, NULL, 73666),
(73667, '3.40.190.290-FF-000068', NULL, 'LysR family transcriptional regulator', 209, NULL, NULL, 73667),
(73668, '1.10.287.370-FF-000053', NULL, 'Unconventional prefoldin RPB5 interactor-like protein', 117, NULL, NULL, 73668),
(73669, '3.80.10.10-FF-003728', NULL, 'Uncharacterized protein', 138, NULL, NULL, 73669),
(73670, '1.25.10.10-FF-000769', NULL, 'Importin beta-5 subunit', 997, NULL, NULL, 73670),
(73671, '1.10.8.270-FF-000125', NULL, 'TBC domain containing protein', 119, NULL, NULL, 73671),
(73672, '3.50.50.60-FF-000976', NULL, 'FAD/NAD(P)-binding domain-containing protein', 136, NULL, NULL, 73672),
(73673, '3.30.40.10-FF-001029', NULL, 'PHD transcription factor (Rum1), putative (AFU_orthologue AFUA_5G03430)', 89, NULL, NULL, 73673),
(73674, '1.20.1280.50-FF-000213', NULL, 'Uncharacterized protein', 87, NULL, NULL, 73674),
(73675, '1.10.510.10-FF-003551', NULL, NULL, 229, NULL, NULL, 73675),
(73676, '2.60.120.970-FF-000035', NULL, 'Dawdle, isoform A', 222, NULL, NULL, 73676),
(73677, '3.40.50.300-FF-003723', NULL, 'Uncharacterized protein', 164, NULL, NULL, 73677),
(73678, '2.30.29.30-FF-000685', NULL, 'Kinesin protein unc-104', 109, NULL, NULL, 73678),
(73679, '3.40.50.720-FF-001376', NULL, 'Formate dehydrogenase', 204, NULL, NULL, 73679),
(73680, '3.10.270.10-FF-000005', NULL, 'Uricase', 300, NULL, NULL, 73680),
(73681, '2.130.10.10-FF-003852', NULL, 'Uncharacterized protein', 288, NULL, NULL, 73681),
(73682, '1.10.510.10-FF-001651', NULL, 'SRSF protein kinase 1a', 134, NULL, NULL, 73682),
(73683, '3.90.70.80-FF-000077', NULL, 'Uncharacterized protein', 133, NULL, NULL, 73683),
(73684, '2.10.25.10-FF-001694', NULL, 'Uncharacterized protein', 43, NULL, NULL, 73684),
(73685, '1.25.40.710-FF-000004', NULL, 'Tripeptidyl-peptidase 2', 255, NULL, NULL, 73685),
(73686, '3.30.70.1730-FF-000034', NULL, '50S ribosomal protein L10', 130, NULL, NULL, 73686),
(73687, '3.30.10.20-FF-000013', NULL, 'Transmembrane serine/threonine-protein kinase B', 64, NULL, NULL, 73687),
(73688, '3.20.20.70-FF-000501', NULL, NULL, 241, NULL, NULL, 73688),
(73689, '3.40.50.800-FF-000012', NULL, 'Histidine--tRNA ligase, cytoplasmic', 98, NULL, NULL, 73689),
(73690, '4.10.75.10-FF-000012', NULL, 'Protein Wfdc21', 41, NULL, NULL, 73690),
(73691, '3.40.50.1000-FF-000189', NULL, 'Vegetative storage protein 1', 221, NULL, NULL, 73691),
(73692, '3.30.70.330-FF-001355', NULL, 'Unplaced genomic scaffold supercont2.1, whole genome shotgun sequence', 86, NULL, NULL, 73692),
(73693, '3.30.70.3490-FF-000005', NULL, 'Oxysterol-binding protein', 123, NULL, NULL, 73693),
(73694, '3.10.580.20-FF-000009', NULL, 'Uncharacterized protein', 40, NULL, NULL, 73694),
(73695, '1.10.645.10-FF-000002', NULL, 'Hydrogenase 2 large subunit', 547, NULL, NULL, 73695);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(73696, '1.10.340.30-FF-000081', NULL, 'Uncharacterized protein', 119, NULL, NULL, 73696),
(73697, '2.30.33.40-FF-000001', NULL, '10 kDa chaperonin', 96, NULL, NULL, 73697),
(73698, '3.40.50.300-FF-002958', NULL, 'Endoribonuclease Dicer homolog 1', 151, NULL, NULL, 73698),
(73699, '3.80.10.10-FF-000502', NULL, 'Predicted protein', 97, NULL, NULL, 73699),
(73700, '3.40.390.10-FF-000226', NULL, NULL, 116, NULL, NULL, 73700),
(73701, '3.60.90.10-FF-000008', NULL, 'S-adenosylmethionine decarboxylase proenzyme', 192, NULL, NULL, 73701),
(73702, '1.25.40.10-FF-002159', NULL, 'Pentatricopeptide repeat-containing protein', 121, NULL, NULL, 73702),
(73703, '1.10.10.10-FF-001842', NULL, 'DNA replication licensing factor, MCM2/3/5 family', 85, NULL, NULL, 73703),
(73704, '3.90.20.20-FF-000039', NULL, 'Protein GrpE', 112, NULL, NULL, 73704),
(73705, '3.20.20.70-FF-000400', NULL, 'Uncharacterized protein', 362, NULL, NULL, 73705),
(73706, '3.30.160.60-FF-001513', NULL, 'Zinc finger, C2H2 type', 29, NULL, NULL, 73706),
(73707, '3.30.1050.10-FF-000017', NULL, 'Potential peroxisomal lipid carrier', 156, NULL, NULL, 73707),
(73708, '3.30.160.60-FF-003222', NULL, 'Zinc finger protein 473', 57, NULL, NULL, 73708),
(73709, '1.25.40.10-FF-001423', NULL, 'TRP domain containing protein', 358, NULL, NULL, 73709),
(73710, '1.25.40.10-FF-004149', NULL, 'Uncharacterized protein', 112, NULL, NULL, 73710),
(73711, '3.80.10.10-FF-002195', NULL, 'Toll-like receptor 21', 117, NULL, NULL, 73711),
(73712, '3.40.50.300-FF-001677', NULL, 'Bifunctional dethiobiotin synthetase/adenosylmethionine-8-amino-7-oxononanoate aminotransferase', 234, NULL, NULL, 73712),
(73713, '3.30.160.60-FF-002132', NULL, 'Zinc finger protein 445', 34, NULL, NULL, 73713),
(73714, '3.40.1620.10-FF-000003', NULL, 'Antitoxin', 52, NULL, NULL, 73714),
(73715, '3.80.10.10-FF-000603', NULL, 'Gp150, isoform E', 103, NULL, NULL, 73715),
(73716, '2.130.10.10-FF-001082', NULL, 'Protein CBR-SMP-1', 452, NULL, NULL, 73716),
(73717, '3.10.100.10-FF-000095', NULL, 'Furrowed, isoform A', 138, NULL, NULL, 73717),
(73718, '3.90.660.10-FF-000107', NULL, NULL, 258, NULL, NULL, 73718),
(73719, '1.10.287.70-FF-000693', NULL, 'Uncharacterized protein', 57, NULL, NULL, 73719),
(73720, '3.20.20.60-FF-000043', NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', 262, NULL, NULL, 73720),
(73721, '3.30.70.330-FF-001254', NULL, 'HNRNPH1 isoform 19', 60, NULL, NULL, 73721),
(73722, '1.10.540.10-FF-000051', NULL, 'Acyl-CoA dehydrogenase FadE34', 115, NULL, NULL, 73722),
(73723, '1.10.10.60-FF-000660', NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily A member 5', 68, NULL, NULL, 73723),
(73724, '3.40.50.1820-FF-000917', NULL, 'Chromosome 19, whole genome shotgun sequence', 303, NULL, NULL, 73724),
(73725, '2.60.40.10-FF-001064', NULL, 'Interleukin 1 receptor, type I', 92, NULL, NULL, 73725),
(73726, '2.10.25.10-FF-001121', NULL, 'Protein eyes shut homolog', 40, NULL, NULL, 73726),
(73727, '1.10.510.10-FF-002932', NULL, NULL, 205, NULL, NULL, 73727),
(73728, '3.30.710.10-FF-000390', NULL, 'AGAP000475-PA', 160, NULL, NULL, 73728),
(73729, '1.20.1560.10-FF-000942', NULL, 'Uncharacterized protein', 235, NULL, NULL, 73729),
(73730, '3.10.400.20-FF-000025', NULL, 'Uncharacterized protein', 180, NULL, NULL, 73730),
(73731, '4.10.400.10-FF-000041', NULL, 'Sortilin related receptor 1', 44, NULL, NULL, 73731),
(73732, '1.20.5.170-FF-000262', NULL, 'Uncharacterized protein', 93, NULL, NULL, 73732),
(73733, '1.10.220.150-FF-000009', NULL, 'stromal membrane-associated protein 1 isoform X1', 132, NULL, NULL, 73733),
(73734, '3.50.50.100-FF-000047', NULL, 'Type-II NADH dehydrogenase', 111, NULL, NULL, 73734),
(73735, '3.40.50.300-FF-003622', NULL, 'GTPase, IMAP family member 1', 126, NULL, NULL, 73735),
(73736, '3.40.50.1220-FF-000125', NULL, 'Uncharacterized protein', 131, NULL, NULL, 73736),
(73737, '2.60.120.10-FF-000291', NULL, '5-deoxy-glucuronate isomerase', 139, NULL, NULL, 73737),
(73738, '2.10.220.10-FF-000141', NULL, 'Proprotein convertase subtilisin/kexin type 5', 56, NULL, NULL, 73738);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(73739, '3.90.780.10-FF-000026', NULL, 'Vacuolar protein', 142, NULL, NULL, 73739),
(73740, '2.10.110.10-FF-000048', NULL, 'Four and a half LIM domains protein 2', 63, NULL, NULL, 73740),
(73741, '3.30.160.60-FF-006095', NULL, NULL, 23, NULL, NULL, 73741),
(73742, '3.40.50.920-FF-000019', NULL, 'Sulfite reductase beta subunit', 144, NULL, NULL, 73742),
(73743, '3.40.50.1110-FF-000031', NULL, 'GDSL family lipase', 173, NULL, NULL, 73743),
(73744, '1.10.8.60-FF-000029', NULL, 'Replication-associated recombination protein A', 76, NULL, NULL, 73744),
(73745, '1.10.238.10-FF-001242', NULL, 'Uncharacterized protein', 89, NULL, NULL, 73745),
(73746, '3.40.50.300-FF-000188', NULL, 'signal recognition particle receptor subunit alpha', 223, NULL, NULL, 73746),
(73747, '2.60.40.1090-FF-000037', NULL, 'Putative minor fimbrial subunit', 124, NULL, NULL, 73747),
(73748, '2.60.40.10-FF-005482', NULL, NULL, 100, NULL, NULL, 73748),
(73749, '3.30.160.60-FF-005122', NULL, NULL, 62, NULL, NULL, 73749),
(73750, '2.60.40.60-FF-001068', NULL, 'Novel protein similar to human procadherin 15 (PCDH15)', 57, NULL, NULL, 73750),
(73751, '1.10.630.10-FF-000081', NULL, 'Cytochrome P450 CYP81N5', 469, NULL, NULL, 73751),
(73752, '3.90.550.10-FF-000689', NULL, 'Uncharacterized protein', 72, NULL, NULL, 73752),
(73753, '3.30.300.30-FF-000128', NULL, '4-chlorobenzoate--CoA ligase', 102, NULL, NULL, 73753),
(73754, '1.50.10.10-FF-000014', NULL, 'Sulfoquinovose isomerase', 413, NULL, NULL, 73754),
(73755, '3.30.40.10-FF-001956', NULL, 'Uncharacterized protein', 65, NULL, NULL, 73755),
(73756, '3.90.190.10-FF-000251', NULL, 'Unplaced genomic scaffold supercont1.9, whole genome shotgun sequence', 123, NULL, NULL, 73756),
(73757, '3.40.50.150-FF-000671', NULL, 'S-adenosylmethionine sensor upstream of mTORC1', 181, NULL, NULL, 73757),
(73758, '3.30.200.20-FF-002315', NULL, 'Uncharacterized protein', 98, NULL, NULL, 73758),
(73759, '1.25.40.10-FF-004413', NULL, 'Uncharacterized protein', 131, NULL, NULL, 73759),
(73760, '3.80.10.10-FF-004095', NULL, 'Uncharacterized protein', 121, NULL, NULL, 73760),
(73761, '1.25.40.10-FF-003323', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 103, NULL, NULL, 73761),
(73762, '3.40.50.1980-FF-000139', NULL, 'Periplasmic binding protein', 114, NULL, NULL, 73762),
(73763, '4.10.280.10-FF-000160', NULL, 'Putative transcription factor bHLH041', 76, NULL, NULL, 73763),
(73764, '3.90.950.10-FF-000051', NULL, 'Uncharacterized protein', 82, NULL, NULL, 73764),
(73765, '4.10.780.10-FF-000006', NULL, 'Pyruvate-flavodoxin oxidoreductase', 39, NULL, NULL, 73765),
(73766, '1.10.30.50-FF-000006', NULL, 'SNF2 DNA repair protein, putative', 97, NULL, NULL, 73766),
(73767, '2.130.10.10-FF-004369', NULL, 'Uncharacterized protein', 85, NULL, NULL, 73767),
(73768, '1.10.510.10-FF-002168', NULL, NULL, 130, NULL, NULL, 73768),
(73769, '2.40.10.10-FF-000349', NULL, NULL, 117, NULL, NULL, 73769),
(73770, '3.60.15.10-FF-000239', NULL, 'Uncharacterized protein', 162, NULL, NULL, 73770),
(73771, '3.40.50.1000-FF-000453', NULL, 'Copper-transporting ATPase PAA1 chloroplastic', 152, NULL, NULL, 73771),
(73772, '3.30.420.100-FF-000028', NULL, 'Uncharacterized protein', 243, NULL, NULL, 73772),
(73773, '1.20.1560.10-FF-000178', NULL, 'ABC transporter family protein', 272, NULL, NULL, 73773),
(73774, '3.90.1600.10-FF-000018', NULL, 'DNA polymerase', 81, NULL, NULL, 73774),
(73775, '3.80.10.10-FF-001222', NULL, 'Leucine rich repeat protein 1', 128, NULL, NULL, 73775),
(73776, '3.90.190.10-FF-000104', NULL, 'Dual specificity phosphatase, putative', 151, NULL, NULL, 73776),
(73777, '2.130.10.10-FF-001391', NULL, 'Damaged DNA binding protein', 323, NULL, NULL, 73777),
(73778, '1.20.1440.200-FF-000001', NULL, 'Vacuolar protein sorting-associated protein 28 homolog', 100, NULL, NULL, 73778),
(73779, '3.40.50.300-FF-005831', NULL, 'Os01g0976100 protein', 197, NULL, NULL, 73779),
(73780, '1.10.238.10-FF-000062', NULL, 'Centrin 2', 49, NULL, NULL, 73780),
(73781, '3.30.70.330-FF-000635', NULL, 'RNA-binding protein, putative', 95, NULL, NULL, 73781);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(73782, '3.40.1170.10-FF-000013', NULL, 'DNA mismatch repair protein MSH2', 125, NULL, NULL, 73782),
(73783, '3.40.50.1820-FF-001536', NULL, 'Uncharacterized protein', 139, NULL, NULL, 73783),
(73784, '3.40.50.880-FF-000081', NULL, 'DJ-1/PfpI family intracellular protease', 181, NULL, NULL, 73784),
(73785, '2.120.10.30-FF-000407', NULL, 'Uncharacterized protein', 195, NULL, NULL, 73785),
(73786, '2.60.40.2030-FF-000016', NULL, 'Adhesion G protein-coupled receptor V1', 73, NULL, NULL, 73786),
(73787, '3.40.50.300-FF-004903', NULL, 'Uncharacterized protein', 134, NULL, NULL, 73787),
(73788, '3.40.50.300-FF-005168', NULL, 'Si:ch211-208g24.8', 222, NULL, NULL, 73788),
(73789, '1.20.1060.10-FF-000022', NULL, 'Uncharacterized protein', 87, NULL, NULL, 73789),
(73790, '1.10.8.60-FF-000440', NULL, 'Origin recognition complex subunit 1', 72, NULL, NULL, 73790),
(73791, '1.10.274.100-FF-000013', NULL, 'DNA-directed RNA polymerase subunit', 154, NULL, NULL, 73791),
(73792, '1.20.1070.10-FF-000511', NULL, 'Putative neuropeptide G protein-coupled receptor', 305, NULL, NULL, 73792),
(73793, '3.40.1110.10-FF-000346', NULL, NULL, 60, NULL, NULL, 73793),
(73794, '1.20.1260.60-FF-000007', NULL, 'Regulator of Vps4 activity in the MVB pathway protein', 91, NULL, NULL, 73794),
(73795, '3.40.50.720-FF-001112', NULL, 'Alanine dehydrogenase (Ald)', 181, NULL, NULL, 73795),
(73796, '3.30.70.330-FF-002682', NULL, NULL, 57, NULL, NULL, 73796),
(73797, '3.30.200.20-FF-000634', NULL, 'Calcium-dependent protein kinase, putative', 100, NULL, NULL, 73797),
(73798, '3.30.40.10-FF-000203', NULL, 'E3 ubiquitin-protein ligase CHFR isoform X1', 117, NULL, NULL, 73798),
(73799, '3.30.710.10-FF-000243', NULL, 'Leucine-zipper-like transcriptional regulator 1 homolog', 128, NULL, NULL, 73799),
(73800, '3.40.50.1820-FF-001845', NULL, 'Predicted protein', 73, NULL, NULL, 73800),
(73801, '1.20.120.430-FF-000018', NULL, 'tRNA modification GTPase MnmE', 169, NULL, NULL, 73801),
(73802, '3.80.10.10-FF-001930', NULL, 'Type III effector protein XopAC', 164, NULL, NULL, 73802),
(73803, '3.40.50.720-FF-000403', NULL, 'Potassium calcium-activated channel subfamily U member 1', 175, NULL, NULL, 73803),
(73804, '3.30.300.160-FF-000020', NULL, 'Type 4 pili biogenesis protein (Nuleotide-binding protein)', 77, NULL, NULL, 73804),
(73805, '3.30.70.1230-FF-000108', NULL, 'Adenylate cyclase CyaC', 191, NULL, NULL, 73805),
(73806, '1.20.1720.10-FF-000022', NULL, 'MFS drug transporter, putative', 245, NULL, NULL, 73806),
(73807, '1.10.287.110-FF-000379', NULL, 'Heat shock protein', 94, NULL, NULL, 73807),
(73808, '3.40.50.150-FF-001851', NULL, NULL, 30, NULL, NULL, 73808),
(73809, '3.30.930.10-FF-000271', NULL, 'Histidine--tRNA ligase', 334, NULL, NULL, 73809),
(73810, '3.30.1490.190-FF-000017', NULL, 'Fur family transcriptional regulator, ferric uptake regulator', 59, NULL, NULL, 73810),
(73811, '2.60.40.1260-FF-000009', NULL, 'Non-neuronal cytoplasmic intermediate filament protein A', 115, NULL, NULL, 73811),
(73812, '3.40.630.10-FF-000173', NULL, 'Aminopeptidase', 230, NULL, NULL, 73812),
(73813, '2.60.40.10-FF-004953', NULL, NULL, 103, NULL, NULL, 73813),
(73814, '2.60.120.200-FF-000619', NULL, 'Predicted protein', 143, NULL, NULL, 73814),
(73815, '3.40.50.300-FF-000497', NULL, 'Atlastin-1 isoform 1', 311, NULL, NULL, 73815),
(73816, '3.90.110.10-FF-000009', NULL, 'Malate dehydrogenase', 181, NULL, NULL, 73816),
(73817, '1.10.510.10-FF-000015', NULL, 'Ephrin type-B receptor 2', 189, NULL, NULL, 73817),
(73818, '1.10.20.10-FF-000179', NULL, 'Transcriptional activator hap3', 101, NULL, NULL, 73818),
(73819, '3.40.50.80-FF-000145', NULL, 'Uncharacterized protein', 137, NULL, NULL, 73819),
(73820, '3.40.50.150-FF-001143', NULL, 'S-adenosyl-L-methionine-dependent methyl transferase PigF', 259, NULL, NULL, 73820),
(73821, '1.10.510.10-FF-003449', NULL, NULL, 276, NULL, NULL, 73821),
(73822, '1.10.238.10-FF-000770', NULL, 'N-terminal EF-hand calcium binding protein 2', 104, NULL, NULL, 73822),
(73823, '2.30.18.10-FF-000002', NULL, 'Transcription initiation factor IIA subunit 1', 58, NULL, NULL, 73823);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(73824, '3.40.50.2300-FF-000505', NULL, 'Response regulator VieB', 132, NULL, NULL, 73824),
(73825, '3.30.450.60-FF-000081', NULL, 'Uncharacterized protein', 51, NULL, NULL, 73825),
(73826, '3.40.1110.10-FF-000037', NULL, 'Calcium-transporting ATPase', 238, NULL, NULL, 73826),
(73827, '1.10.510.10-FF-004068', NULL, NULL, 259, NULL, NULL, 73827),
(73828, '1.20.1730.10-FF-000107', NULL, 'Uncharacterized protein', 180, NULL, NULL, 73828),
(73829, '3.30.70.330-FF-002991', NULL, NULL, 86, NULL, NULL, 73829),
(73830, '3.30.200.20-FF-000943', NULL, 'Non-specific serine/threonine protein kinase', 21, NULL, NULL, 73830),
(73831, '3.30.70.330-FF-000074', NULL, 'U2 snRNP auxiliary factor large subunit', 56, NULL, NULL, 73831),
(73832, '3.30.50.10-FF-000029', NULL, 'mineralocorticoid receptor isoform X1', 102, NULL, NULL, 73832),
(73833, '3.30.530.20-FF-000182', NULL, 'Polyketide cyclase/dehydrase and lipid transport superfamily protein', 97, NULL, NULL, 73833),
(73834, '3.40.50.2300-FF-001478', NULL, NULL, 137, NULL, NULL, 73834),
(73835, '3.20.20.80-FF-000049', NULL, 'Beta-hexosaminidase A', 360, NULL, NULL, 73835),
(73836, '1.10.8.60-FF-000131', NULL, 'Chromosomal replication initiator protein DnaA', 70, NULL, NULL, 73836),
(73837, '3.30.450.20-FF-000338', NULL, 'Protein kinase, putative', 97, NULL, NULL, 73837),
(73838, '2.10.110.10-FF-000150', NULL, 'Actin binding LIM protein family member 3', 52, NULL, NULL, 73838),
(73839, '3.40.50.620-FF-000452', NULL, 'Lon protease homolog', 268, NULL, NULL, 73839),
(73840, '2.60.120.200-FF-000063', NULL, 'Laminin subunit alpha 2', 164, NULL, NULL, 73840),
(73841, '3.40.50.150-FF-001290', NULL, NULL, 217, NULL, NULL, 73841),
(73842, '1.10.10.10-FF-000914', NULL, 'LuxR family transcriptional regulator', 62, NULL, NULL, 73842),
(73843, '2.160.20.80-FF-000005', NULL, 'SPI-1 type III secretion system effector HECT-type E3 ubiquitin transferase SopA', 161, NULL, NULL, 73843),
(73844, '2.10.25.10-FF-001385', NULL, 'protein eyes shut-like isoform X1', 40, NULL, NULL, 73844),
(73845, '3.40.50.620-FF-000828', NULL, 'Uncharacterized protein', 197, NULL, NULL, 73845),
(73846, '2.40.180.10-FF-000046', NULL, 'Catalase, putative', 154, NULL, NULL, 73846),
(73847, '2.130.10.10-FF-001952', NULL, 'Radiation sensitive protein 28 homologue, putative', 400, NULL, NULL, 73847),
(73848, '3.10.20.90-FF-000709', NULL, 'Mitogen-activated protein kinase kinase kinase A', 80, NULL, NULL, 73848),
(73849, '1.10.3500.10-FF-000020', NULL, 'Transcription elongation factor Spt6', 294, NULL, NULL, 73849),
(73850, '1.20.1050.10-FF-000095', NULL, 'Probable glutathione S-transferase', 119, NULL, NULL, 73850),
(73851, '3.90.70.10-FF-000438', NULL, 'ubiquitin carboxyl-terminal hydrolase 32', 212, NULL, NULL, 73851),
(73852, '3.30.1490.120-FF-000013', NULL, 'GD22536', 97, NULL, NULL, 73852),
(73853, '1.20.910.10-FF-000038', NULL, 'Uncharacterized protein', 126, NULL, NULL, 73853),
(73854, '3.30.70.330-FF-002535', NULL, NULL, 49, NULL, NULL, 73854),
(73855, '2.30.29.30-FF-001303', NULL, 'Pleckstrin 2', 79, NULL, NULL, 73855),
(73856, '3.40.50.2300-FF-000961', NULL, NULL, 43, NULL, NULL, 73856),
(73857, '1.25.40.10-FF-000097', NULL, 'DnaJ homolog subfamily C member 7 homolog', 353, NULL, NULL, 73857),
(73858, '3.40.50.300-FF-005729', NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', 157, NULL, NULL, 73858),
(73859, '3.90.228.20-FF-000016', NULL, NULL, 124, NULL, NULL, 73859),
(73860, '2.10.25.10-FF-000502', NULL, 'Netrin G1', 70, NULL, NULL, 73860),
(73861, '1.10.287.110-FF-000115', NULL, 'DnaJ domain-containing protein', 99, NULL, NULL, 73861),
(73862, '1.50.40.10-FF-000403', NULL, 'Oxodicarboxylate carrier protein, putative', 234, NULL, NULL, 73862),
(73863, '3.40.309.10-FF-000061', NULL, 'Aldehyde dehydrogenase', 203, NULL, NULL, 73863),
(73864, '3.10.20.10-FF-000028', NULL, '60S ribosomal protein L18a', 77, NULL, NULL, 73864),
(73865, '1.20.1740.10-FF-000035', NULL, 'Cationic amino acid transporter 5', 436, NULL, NULL, 73865),
(73866, '2.130.10.10-FF-002469', NULL, 'Plexin A1', 169, NULL, NULL, 73866); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(73867, '3.90.230.10-FF-000030', NULL, 'Xaa-pro aminopeptidase', 256, NULL, NULL, 73867),
(73868, '1.20.58.70-FF-000098', NULL, 'Uncharacterized protein', 187, NULL, NULL, 73868),
(73869, '3.80.10.10-FF-002756', NULL, 'F-box/LRR-repeat protein 3', 208, NULL, NULL, 73869),
(73870, '1.10.400.10-FF-000024', NULL, 'Concertina, isoform B', 119, NULL, NULL, 73870),
(73871, '3.40.50.970-FF-000017', NULL, 'pyruvate decarboxylase 1', 177, NULL, NULL, 73871),
(73872, '2.30.30.40-FF-000096', NULL, 'Neutrophil cytosol factor 2', 62, NULL, NULL, 73872),
(73873, '3.30.2160.10-FF-000037', NULL, 'Chromosome 9, whole genome shotgun sequence', 78, NULL, NULL, 73873),
(73874, '2.130.10.10-FF-002677', NULL, 'Uncharacterized protein', 262, NULL, NULL, 73874),
(73875, '1.20.1730.10-FF-000079', NULL, 'Solute carrier family 5 (sodium/glucose cotransporter), member 2', 550, NULL, NULL, 73875),
(73876, '3.40.50.1820-FF-000356', NULL, '3-oxoadipate enol-lactone hydrolase family protein', 254, NULL, NULL, 73876),
(73877, '1.10.357.110-FF-000008', NULL, 'VPS53 subunit of GARP complex', 124, NULL, NULL, 73877),
(73878, '1.10.8.10-FF-000150', NULL, 'Rhomboid domain-containing protein 3', 41, NULL, NULL, 73878),
(73879, '3.90.550.50-FF-000094', NULL, 'Hexosyltransferase', 148, NULL, NULL, 73879),
(73880, '3.30.70.2390-FF-000001', NULL, 'Possible conserved protein CpsA', 85, NULL, NULL, 73880),
(73881, '3.40.1110.10-FF-000138', NULL, 'Potassium/sodium P-type ATPase, putative', 212, NULL, NULL, 73881),
(73882, '2.60.40.10-FF-001620', NULL, 'Down syndrome cell adhesion molecule-like protein Dscam2', 94, NULL, NULL, 73882),
(73883, '1.10.20.140-FF-000030', NULL, NULL, 13, NULL, NULL, 73883),
(73884, '1.10.150.60-FF-000036', NULL, NULL, 92, NULL, NULL, 73884),
(73885, '3.90.70.10-FF-000865', NULL, 'Uncharacterized protein', 81, NULL, NULL, 73885),
(73886, '3.60.20.10-FF-000077', NULL, 'Proteasome subunit alpha type-3', 255, NULL, NULL, 73886),
(73887, '1.10.472.10-FF-000488', NULL, 'Chromosome 8, whole genome shotgun sequence', 112, NULL, NULL, 73887),
(73888, '3.50.50.60-FF-000318', NULL, 'Oxidoreductase, pyridine nucleotide-disulfide, class I', 118, NULL, NULL, 73888),
(73889, '1.20.1600.10-FF-000002', NULL, 'Multidrug resistance outer membrane protein mdtP', 328, NULL, NULL, 73889),
(73890, '1.10.10.580-FF-000025', NULL, 'N terminus of Rad21 / Rec8 like protein', 83, NULL, NULL, 73890),
(73891, '2.60.120.330-FF-000102', NULL, 'Predicted protein', 319, NULL, NULL, 73891),
(73892, '3.40.1090.10-FF-000057', NULL, 'Patatin-like phospholipase domain containing 4, isoform CRA_b', 224, NULL, NULL, 73892),
(73893, '3.40.1440.10-FF-000011', NULL, 'Structure-specific endonuclease subunit SLX1 isoform 2', 68, NULL, NULL, 73893),
(73894, '1.25.10.10-FF-000842', NULL, 'HEAT repeat domain containing protein', 296, NULL, NULL, 73894),
(73895, '1.10.510.10-FF-002724', NULL, 'Probable inactive protein kinase DDB_G0270444', 285, NULL, NULL, 73895),
(73896, '1.25.40.10-FF-002468', NULL, 'Uncharacterized protein', 99, NULL, NULL, 73896),
(73897, '3.40.367.20-FF-000007', NULL, 'Glucokinase', 204, NULL, NULL, 73897),
(73898, '2.70.150.10-FF-000077', NULL, 'Phospholipid-transporting ATPase', 131, NULL, NULL, 73898),
(73899, '2.60.60.20-FF-000006', NULL, 'Lipoprotein lipase', 115, NULL, NULL, 73899),
(73900, '1.20.1070.10-FF-000848', NULL, 'Leukotriene B4 receptor 1', 288, NULL, NULL, 73900),
(73901, '2.60.120.260-FF-000373', NULL, 'Endo-1,4-beta-xylanase Z', 136, NULL, NULL, 73901),
(73902, '3.30.160.60-FF-000108', NULL, 'Vascular endothelial zinc finger 1', 26, NULL, NULL, 73902),
(73903, '3.40.50.740-FF-000033', NULL, 'NUAM protein', 159, NULL, NULL, 73903),
(73904, '2.60.200.40-FF-000008', NULL, 'Probable lipid kinase YegS', 156, NULL, NULL, 73904),
(73905, '3.30.70.330-FF-002575', NULL, NULL, 142, NULL, NULL, 73905),
(73906, '1.10.510.10-FF-003657', NULL, 'Uncharacterized protein', 396, NULL, NULL, 73906),
(73907, '1.20.1070.10-FF-001467', NULL, 'Uncharacterized protein', 214, NULL, NULL, 73907),
(73908, '1.20.5.340-FF-000099', NULL, 'Uncharacterized protein', 77, NULL, NULL, 73908);
INSERT INTO "PUBLIC"."MODEL" VALUES
(73909, '1.10.3040.10-FF-000001', NULL, 'Nucleoprotein', 208, NULL, NULL, 73909),
(73910, '3.90.1100.10-FF-000008', NULL, 'DNA-directed RNA polymerase subunit beta', 162, NULL, NULL, 73910),
(73911, '1.10.110.10-FF-000013', NULL, 'Chymotrypsin inhibitor WCI', 117, NULL, NULL, 73911),
(73912, '1.20.1250.20-FF-002187', NULL, 'Uncharacterized protein', 163, NULL, NULL, 73912),
(73913, '2.60.200.20-FF-000002', NULL, 'Kinesin family member 13A', 108, NULL, NULL, 73913),
(73914, '2.60.40.10-FF-003329', NULL, 'Fibronectin 1b', 94, NULL, NULL, 73914),
(73915, '3.30.565.10-FF-000438', NULL, 'Two-component sensor CbrA', 155, NULL, NULL, 73915),
(73916, '3.30.200.20-FF-002332', NULL, 'Death-associated protein kinase 2', 71, NULL, NULL, 73916),
(73917, '3.30.40.10-FF-000776', NULL, 'Ecm5p', 64, NULL, NULL, 73917),
(73918, '3.10.300.10-FF-000003', NULL, 'Putative 3-methyladenine DNA glycosylase', 205, NULL, NULL, 73918),
(73919, '1.10.510.10-FF-004276', NULL, NULL, 177, NULL, NULL, 73919),
(73920, '1.10.30.10-FF-000197', NULL, 'Uncharacterized protein', 59, NULL, NULL, 73920),
(73921, '3.90.190.10-FF-000211', NULL, 'Chromosome 10, whole genome shotgun sequence', 159, NULL, NULL, 73921),
(73922, '1.20.990.10-FF-000054', NULL, 'Uncharacterized protein', 58, NULL, NULL, 73922),
(73923, '3.40.50.300-FF-002397', NULL, 'Oligopeptide ABC transporter, ATP-binding protein', 268, NULL, NULL, 73923),
(73924, '3.40.50.300-FF-003167', NULL, 'Tripartite terminase subunit 3', 186, NULL, NULL, 73924),
(73925, '3.40.50.1820-FF-001289', NULL, 'Uncharacterized protein', 283, NULL, NULL, 73925),
(73926, '3.90.420.10-FF-000005', NULL, 'Nitrate reductase', 240, NULL, NULL, 73926),
(73927, '3.40.850.10-FF-000144', NULL, 'Kinesin-like protein', 341, NULL, NULL, 73927),
(73928, '3.30.40.10-FF-000304', NULL, 'TNF receptor-associated factor', 73, NULL, NULL, 73928),
(73929, '1.25.10.10-FF-001022', NULL, 'Coatomer subunit beta', 456, NULL, NULL, 73929),
(73930, '2.130.10.10-FF-001744', NULL, 'Nuclear pore complex protein 15', 376, NULL, NULL, 73930),
(73931, '3.30.160.60-FF-003088', NULL, 'Kruppel-like factor 15', 24, NULL, NULL, 73931),
(73932, '1.10.1420.10-FF-000075', NULL, 'DNA mismatch repair protein', 183, NULL, NULL, 73932),
(73933, '3.40.50.300-FF-005145', NULL, 'Cell division inhibitor', 234, NULL, NULL, 73933),
(73934, '1.20.58.390-FF-000198', NULL, 'Transmembrane ion channel', 139, NULL, NULL, 73934),
(73935, '2.60.120.200-FF-000299', NULL, 'DE-cadherin', 183, NULL, NULL, 73935),
(73936, '1.25.40.10-FF-002575', NULL, 'Pentatricopeptide repeat-containing protein At3g09040, mitochondrial', 162, NULL, NULL, 73936),
(73937, '3.80.10.10-FF-003375', NULL, 'Uncharacterized protein', 106, NULL, NULL, 73937),
(73938, '3.30.1520.10-FF-000115', NULL, 'Ribosomal protein S6 kinase C1', 106, NULL, NULL, 73938),
(73939, '3.30.930.10-FF-000046', NULL, 'Alanine--tRNA ligase', 239, NULL, NULL, 73939),
(73940, '2.30.42.10-FF-000199', NULL, 'Na(+)/H(+) exchange regulatory cofactor NHE-RF4', 100, NULL, NULL, 73940),
(73941, '2.170.270.10-FF-000168', NULL, 'Uncharacterized protein', 113, NULL, NULL, 73941),
(73942, '3.40.50.1000-FF-000762', NULL, NULL, 132, NULL, NULL, 73942),
(73943, '2.60.390.10-FF-000001', NULL, 'Beta-galactosidase A', 87, NULL, NULL, 73943),
(73944, '1.10.150.50-FF-000140', NULL, 'Ephrin type-A receptor 5', 43, NULL, NULL, 73944),
(73945, '2.10.25.10-FF-000632', NULL, 'Nidogen 1', 51, NULL, NULL, 73945),
(73946, '3.10.20.90-FF-000917', NULL, 'Uncharacterized protein', 75, NULL, NULL, 73946),
(73947, '3.30.1870.10-FF-000001', NULL, 'Erythromycin esterase', 83, NULL, NULL, 73947),
(73948, '3.20.20.220-FF-000084', NULL, 'Proline dehydrogenase', 81, NULL, NULL, 73948),
(73949, '2.20.70.10-FF-000062', NULL, 'IQ motif containing GTPase activating protein 1', 65, NULL, NULL, 73949),
(73950, '3.30.70.141-FF-000001', NULL, 'Nucleoside diphosphate kinase', 139, NULL, NULL, 73950),
(73951, '3.30.70.580-FF-000019', NULL, 'RNA pseudouridylate synthase', 96, NULL, NULL, 73951),
(73952, '1.10.150.20-FF-000125', NULL, 'DNA polymerase subunit gamma-1, mitochondrial', 161, NULL, NULL, 73952);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(73953, '3.30.160.60-FF-001199', NULL, 'Zinc finger protein 771', 34, NULL, NULL, 73953),
(73954, '3.40.50.300-FF-007438', NULL, 'Uncharacterized protein', 254, NULL, NULL, 73954),
(73955, '3.30.200.20-FF-000078', NULL, 'Serine/threonine-protein kinase nrc-2', 96, NULL, NULL, 73955),
(73956, '1.10.510.10-FF-003343', NULL, NULL, 31, NULL, NULL, 73956),
(73957, '3.90.70.10-FF-000337', NULL, 'Uncharacterized protein', 314, NULL, NULL, 73957),
(73958, '3.40.367.20-FF-000001', NULL, 'Hexokinase 1', 265, NULL, NULL, 73958),
(73959, '3.40.30.10-FF-000505', NULL, 'Thioredoxin, putative', 121, NULL, NULL, 73959),
(73960, '3.40.630.10-FF-000156', NULL, 'Uncharacterized protein', 271, NULL, NULL, 73960),
(73961, '3.50.4.10-FF-000047', NULL, NULL, 83, NULL, NULL, 73961),
(73962, '2.160.20.10-FF-000254', NULL, 'Uncharacterized protein', 80, NULL, NULL, 73962),
(73963, '3.40.50.620-FF-000019', NULL, 'Argininosuccinate synthase', 179, NULL, NULL, 73963),
(73964, '1.20.1270.220-FF-000001', NULL, 'bromodomain-containing protein 2 isoform X1', 81, NULL, NULL, 73964),
(73965, '1.25.40.10-FF-004520', NULL, 'Uncharacterized protein', 79, NULL, NULL, 73965),
(73966, '3.40.50.2300-FF-000860', NULL, NULL, 129, NULL, NULL, 73966),
(73967, '1.20.120.1910-FF-000020', NULL, 'Cysteine--tRNA ligase 1 cytoplasmic', 135, NULL, NULL, 73967),
(73968, '1.10.150.310-FF-000002', NULL, 'Putative transcription modulator/accessory protein', 140, NULL, NULL, 73968),
(73969, '3.40.50.300-FF-007545', NULL, 'ATP-dependent DNA helicase', 199, NULL, NULL, 73969),
(73970, '3.40.50.150-FF-000070', NULL, 'Protein arginine N-methyltransferase 7', 144, NULL, NULL, 73970),
(73971, '1.10.238.10-FF-000298', NULL, 'Calcium-binding protein CP1', 69, NULL, NULL, 73971),
(73972, '2.60.40.10-FF-005802', NULL, NULL, 79, NULL, NULL, 73972),
(73973, '2.40.260.10-FF-000002', NULL, 'SrtB family sortase', 220, NULL, NULL, 73973),
(73974, '1.20.1740.10-FF-000012', NULL, 'Arginine/ornithine antiporter transporter', 447, NULL, NULL, 73974),
(73975, '1.10.1420.10-FF-000182', NULL, 'Sperm protein, putative', 26, NULL, NULL, 73975),
(73976, '3.80.10.10-FF-001031', NULL, 'Leucine-rich repeat receptor-like serine/threonine/tyrosine-protein kinase SOBIR1', 202, NULL, NULL, 73976),
(73977, '3.40.630.30-FF-000639', NULL, 'uncharacterized protein LOC100184264 isoform X2', 223, NULL, NULL, 73977),
(73978, '1.10.150.110-FF-000021', NULL, 'DNA-directed DNA/RNA polymerase mu', 97, NULL, NULL, 73978),
(73979, '3.40.50.2000-FF-000758', NULL, 'UDP-N-acetylglucosamine transferase subunit ALG14', 180, NULL, NULL, 73979),
(73980, '3.30.420.10-FF-000069', NULL, 'Helicase and polymerase-containing protein TEBICHI', 213, NULL, NULL, 73980),
(73981, '1.20.210.10-FF-000041', NULL, 'Probable intron-encoded endonuclease aI2', 242, NULL, NULL, 73981),
(73982, '2.30.29.90-FF-000017', NULL, 'Uncharacterized protein', 109, NULL, NULL, 73982),
(73983, '3.40.50.150-FF-000755', NULL, 'Protein-L-isoaspartate O-methyltransferase', 199, NULL, NULL, 73983),
(73984, '3.40.50.720-FF-000842', NULL, 'Probable alcohol dehydrogenase adh', 142, NULL, NULL, 73984),
(73985, '1.20.5.1930-FF-000006', NULL, 'Two component sensor histidine kinase', 61, NULL, NULL, 73985),
(73986, '1.10.510.10-FF-001420', NULL, 'Serine/threonine-protein kinase ppk4', 193, NULL, NULL, 73986),
(73987, '3.80.10.10-FF-001458', NULL, 'Leucine_Rich_Repeat_-_putative', 100, NULL, NULL, 73987),
(73988, '3.40.50.150-FF-001391', NULL, NULL, 171, NULL, NULL, 73988),
(73989, '3.30.70.560-FF-000013', NULL, 'Dihydropteroate synthase', 159, NULL, NULL, 73989),
(73990, '2.30.42.10-FF-000564', NULL, NULL, 114, NULL, NULL, 73990),
(73991, '3.40.50.300-FF-002402', NULL, 'Branched-chain amino acid ABC transporter, ATP-binding protein', 229, NULL, NULL, 73991),
(73992, '1.25.40.10-FF-000670', NULL, 'Pentatricopeptide repeat-containing protein', 103, NULL, NULL, 73992),
(73993, '1.20.5.20-FF-000005', NULL, 'Uncharacterized protein', 25, NULL, NULL, 73993),
(73994, '3.30.40.10-FF-000091', NULL, 'transcriptional regulator ATRX isoform X1', 64, NULL, NULL, 73994);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(73995, '2.60.40.420-FF-000232', NULL, 'Predicted protein', 152, NULL, NULL, 73995),
(73996, '2.60.40.60-FF-000213', NULL, 'neural-cadherin isoform X1', 107, NULL, NULL, 73996),
(73997, '2.30.29.30-FF-000713', NULL, 'Nuclear Pore complex Protein', 215, NULL, NULL, 73997),
(73998, '3.40.30.10-FF-001017', NULL, 'Uncharacterized protein', 57, NULL, NULL, 73998),
(73999, '3.30.1120.100-FF-000004', NULL, 'Fatty acid synthase subunit beta', 75, NULL, NULL, 73999),
(74000, '3.10.110.10-FF-000292', NULL, 'Uncharacterized protein', 110, NULL, NULL, 74000),
(74001, '3.90.980.10-FF-000007', NULL, 'DNA primase', 127, NULL, NULL, 74001),
(74002, '3.20.20.190-FF-000001', NULL, 'Phosphoinositide phospholipase C', 323, NULL, NULL, 74002),
(74003, '1.25.40.10-FF-005341', NULL, 'Pentatricopeptide repeat-containing protein At1g52620', 67, NULL, NULL, 74003),
(74004, '2.60.40.150-FF-000691', NULL, 'Non-specific serine/threonine protein kinase', 160, NULL, NULL, 74004),
(74005, '3.60.15.10-FF-000183', NULL, 'Uncharacterized protein', 284, NULL, NULL, 74005),
(74006, '1.10.12.10-FF-000043', NULL, 'Enoyl-CoA hydratase', 57, NULL, NULL, 74006),
(74007, '3.30.710.10-FF-000052', NULL, 'Longitudinals lacking protein-like', 119, NULL, NULL, 74007),
(74008, '2.130.10.10-FF-002363', NULL, 'K7_Rpn14p', 152, NULL, NULL, 74008),
(74009, '1.25.40.10-FF-003896', NULL, 'Uncharacterized protein', 74, NULL, NULL, 74009),
(74010, '3.30.710.10-FF-000479', NULL, 'Zinc finger and BTB domain-containing 25', 96, NULL, NULL, 74010),
(74011, '3.40.30.10-FF-000977', NULL, 'Peroxiredoxin family protein', 94, NULL, NULL, 74011),
(74012, '3.30.420.10-FF-000608', NULL, NULL, 182, NULL, NULL, 74012),
(74013, '1.25.10.10-FF-003276', NULL, 'PIKK family atypical protein kinase', 196, NULL, NULL, 74013),
(74014, '3.40.50.300-FF-007062', NULL, 'Rab_C83 protein', 195, NULL, NULL, 74014),
(74015, '3.40.50.300-FF-006449', NULL, 'Uncharacterized protein', 123, NULL, NULL, 74015),
(74016, '2.130.10.10-FF-003633', NULL, 'WD repeat-containing protein 38', 116, NULL, NULL, 74016),
(74017, '1.10.238.10-FF-001282', NULL, 'Secretagogin, EF-hand calcium binding protein', 59, NULL, NULL, 74017),
(74018, '1.25.40.120-FF-000001', NULL, 'Geranylgeranyl transferase type-2 subunit alpha', 316, NULL, NULL, 74018),
(74019, '3.30.160.60-FF-000215', NULL, 'Spalt-like transcription factor 3', 31, NULL, NULL, 74019),
(74020, '2.60.40.60-FF-000685', NULL, 'Cadherin-4', 116, NULL, NULL, 74020),
(74021, '1.20.58.1360-FF-000004', NULL, 'JmjC domain-containing histone demethylation protein 1', 106, NULL, NULL, 74021),
(74022, '2.170.300.10-FF-000014', NULL, 'Multiple epidermal growth factor-like domains protein 10', 130, NULL, NULL, 74022),
(74023, '1.20.120.330-FF-000005', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 155, NULL, NULL, 74023),
(74024, '3.20.20.100-FF-000031', NULL, 'D-arabinose dehydrogenase heavy chain', 304, NULL, NULL, 74024),
(74025, '3.40.50.2300-FF-000258', NULL, 'Glutamate metabotropic receptor 5', 51, NULL, NULL, 74025),
(74026, '2.30.40.10-FF-000037', NULL, 'Conserved protein', 64, NULL, NULL, 74026),
(74027, '3.80.10.10-FF-001823', NULL, 'Leucine-rich repeat transmembrane protein kinase', 125, NULL, NULL, 74027),
(74028, '3.80.10.10-FF-002442', NULL, 'Leucine-rich repeat-like protein', 127, NULL, NULL, 74028),
(74029, '1.10.1520.10-FF-000127', NULL, 'Uncharacterized protein', 150, NULL, NULL, 74029),
(74030, '2.10.25.10-FF-001486', NULL, 'Predicted protein', 103, NULL, NULL, 74030),
(74031, '3.40.50.720-FF-002320', NULL, 'Uncharacterized protein', 122, NULL, NULL, 74031),
(74032, '3.10.450.10-FF-000087', NULL, 'Kininogen 2', 64, NULL, NULL, 74032),
(74033, '3.40.50.150-FF-000446', NULL, 'tRNA (guanine-N(7)-)-methyltransferase', 196, NULL, NULL, 74033),
(74034, '1.25.10.10-FF-002764', NULL, 'Adaptin N terminal region family protein', 597, NULL, NULL, 74034),
(74035, '2.60.40.150-FF-000382', NULL, 'Protein kinase C', 131, NULL, NULL, 74035),
(74036, '1.20.1560.10-FF-000279', NULL, 'Protease secretion ATP-binding protein', 194, NULL, NULL, 74036);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(74037, '2.10.25.10-FF-000997', NULL, 'Starry night', 36, NULL, NULL, 74037),
(74038, '3.10.20.90-FF-000608', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', 113, NULL, NULL, 74038),
(74039, '1.10.510.10-FF-002359', NULL, NULL, 187, NULL, NULL, 74039),
(74040, '1.10.540.10-FF-000079', NULL, 'Acyl-Coenzyme A dehydrogenase', 108, NULL, NULL, 74040),
(74041, '1.10.510.10-FF-002387', NULL, NULL, 74, NULL, NULL, 74041),
(74042, '3.30.310.10-FF-000050', NULL, 'AP complex subunit beta', 66, NULL, NULL, 74042),
(74043, '1.50.10.20-FF-000112', NULL, 'Uncharacterized protein', 194, NULL, NULL, 74043),
(74044, '1.50.10.20-FF-000118', NULL, 'Farnesyltransferase, CAAX box, beta', 119, NULL, NULL, 74044),
(74045, '3.90.25.10-FF-000025', NULL, 'dTDP-4-dehydrorhamnose reductase', 72, NULL, NULL, 74045),
(74046, '1.20.1070.10-FF-000056', NULL, 'Melatonin receptor type 1A', 325, NULL, NULL, 74046),
(74047, '3.80.10.10-FF-000839', NULL, 'Gp150, isoform D', 225, NULL, NULL, 74047),
(74048, '3.30.1430.10-FF-000002', NULL, 'Ribosomal protein L3-like', 38, NULL, NULL, 74048),
(74049, '1.10.506.10-FF-000039', NULL, 'Plexin-2', 237, NULL, NULL, 74049),
(74050, '3.90.45.10-FF-000032', NULL, 'Peptide deformylase 2', 182, NULL, NULL, 74050),
(74051, '2.30.230.10-FF-000019', NULL, 'Uncharacterized protein', 252, NULL, NULL, 74051),
(74052, '3.90.320.10-FF-000060', NULL, 'Uncharacterized protein', 226, NULL, NULL, 74052),
(74053, '3.30.200.20-FF-002551', NULL, 'Protein kinase superfamily protein', 82, NULL, NULL, 74053),
(74054, '2.60.40.1930-FF-000020', NULL, 'Thioester-containing protein 2, isoform G', 96, NULL, NULL, 74054),
(74055, '1.20.1070.10-FF-001040', NULL, 'Uncharacterized protein', 271, NULL, NULL, 74055),
(74056, '3.30.160.60-FF-005561', NULL, NULL, 67, NULL, NULL, 74056),
(74057, '1.25.40.10-FF-003087', NULL, 'Pentatricopeptide repeat-containing protein isoform A', 169, NULL, NULL, 74057),
(74058, '1.10.1320.10-FF-000016', NULL, 'DNA-directed RNA polymerase family protein', 129, NULL, NULL, 74058),
(74059, '2.30.110.10-FF-000061', NULL, 'Flavin oxidoreductase', 165, NULL, NULL, 74059),
(74060, '1.20.1270.60-FF-000058', NULL, 'Rho GTPase activating protein 45', 286, NULL, NULL, 74060),
(74061, '1.25.40.10-FF-003901', NULL, 'Uncharacterized protein', 68, NULL, NULL, 74061),
(74062, '2.60.40.10-FF-004970', NULL, NULL, 110, NULL, NULL, 74062),
(74063, '3.80.10.10-FF-000042', NULL, 'F-box/LRR-repeat protein 20 isoform 2', 249, NULL, NULL, 74063),
(74064, '3.90.550.10-FF-000559', NULL, '2-phospho-L-lactate guanylyltransferase', 165, NULL, NULL, 74064),
(74065, '3.30.870.10-FF-000075', NULL, 'Phosphatidylcholine-hydrolyzing phospholipase D (PLD) family', 150, NULL, NULL, 74065),
(74066, '1.10.630.10-FF-000417', NULL, 'Cytochrome P450, family 71, subfamily B, polypeptide 32', 157, NULL, NULL, 74066),
(74067, '3.40.30.10-FF-000180', NULL, 'Circadian clock protein KaiB', 104, NULL, NULL, 74067),
(74068, '1.20.1050.10-FF-000049', NULL, 'Glutathione S-transferase family protein', 131, NULL, NULL, 74068),
(74069, '2.130.10.10-FF-001379', NULL, 'Periodic tryptophan protein 2 homolog', 224, NULL, NULL, 74069),
(74070, '2.30.29.70-FF-000011', NULL, 'AT31219p', 114, NULL, NULL, 74070),
(74071, '2.10.110.10-FF-000256', NULL, 'Uncharacterized protein', 67, NULL, NULL, 74071),
(74072, '3.30.460.20-FF-000035', NULL, 'Magnesium/cobalt transport protein', 115, NULL, NULL, 74072),
(74073, '1.10.472.10-FF-000358', NULL, 'Cyclin subunit, putative', 146, NULL, NULL, 74073),
(74074, '3.40.640.10-FF-000218', NULL, 'Aminotransferase', 242, NULL, NULL, 74074),
(74075, '1.20.1110.10-FF-000111', NULL, NULL, 126, NULL, NULL, 74075),
(74076, '1.10.630.10-FF-000378', NULL, 'Putative cytochrome P450', 395, NULL, NULL, 74076),
(74077, '1.25.40.10-FF-005032', NULL, 'OSJNBa0060P14.4 protein', 148, NULL, NULL, 74077),
(74078, '3.40.50.300-FF-001778', NULL, 'Type VII secretion AAA-ATPase EccA', 176, NULL, NULL, 74078),
(74079, '3.30.50.10-FF-000046', NULL, 'Gat4p', 60, NULL, NULL, 74079),
(74080, '3.40.50.2300-FF-000730', NULL, 'Nitrogen fixation master sigma-54-dependent transcriptional response regulator', 134, NULL, NULL, 74080);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(74081, '3.30.420.150-FF-000026', NULL, 'Ectonucleoside triphosphate diphosphohydrolase 1', 22, NULL, NULL, 74081),
(74082, '3.50.50.60-FF-001010', NULL, 'L-amino-acid oxidase', 95, NULL, NULL, 74082),
(74083, '3.40.640.10-FF-000454', NULL, 'Uncharacterized protein', 238, NULL, NULL, 74083),
(74084, '3.30.1520.10-FF-000138', NULL, 'Neutrophil cytosol factor 4', 143, NULL, NULL, 74084),
(74085, '1.10.510.10-FF-001398', NULL, 'Protein kinase, putative', 265, NULL, NULL, 74085),
(74086, '3.30.160.60-FF-001519', NULL, 'Zinc finger 202 m1', 27, NULL, NULL, 74086),
(74087, '1.25.40.10-FF-002592', NULL, 'Uncharacterized protein', 75, NULL, NULL, 74087),
(74088, '1.10.510.10-FF-003348', NULL, NULL, 275, NULL, NULL, 74088),
(74089, '2.120.10.80-FF-000299', NULL, 'Predicted protein', 199, NULL, NULL, 74089),
(74090, '1.20.1250.20-FF-001259', NULL, 'Uncharacterized protein', 393, NULL, NULL, 74090),
(74091, '3.30.420.40-FF-001101', NULL, 'Zgc:172295', 65, NULL, NULL, 74091),
(74092, '3.30.70.3040-FF-000011', NULL, 'Cell division protein FtsX', 114, NULL, NULL, 74092),
(74093, '3.20.20.60-FF-000144', NULL, 'Predicted protein', 168, NULL, NULL, 74093),
(74094, '1.20.5.50-FF-000003', NULL, 'Fibrinogen gamma chain', 143, NULL, NULL, 74094),
(74095, '2.60.40.10-FF-002020', NULL, 'Poliovirus receptor-related 2 like', 94, NULL, NULL, 74095),
(74096, '3.40.50.620-FF-000475', NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', 230, NULL, NULL, 74096),
(74097, '3.80.10.10-FF-003931', NULL, 'Uncharacterized protein', 93, NULL, NULL, 74097),
(74098, '1.25.10.10-FF-001331', NULL, 'Uncharacterized protein', 488, NULL, NULL, 74098),
(74099, '2.10.110.10-FF-000251', NULL, 'Uncharacterized protein', 44, NULL, NULL, 74099),
(74100, '2.60.40.60-FF-000792', NULL, 'Desmocollin 3', 111, NULL, NULL, 74100),
(74101, '2.60.40.10-FF-002059', NULL, 'Protein-glutamine gamma-glutamyltransferase 2', 141, NULL, NULL, 74101),
(74102, '2.70.150.10-FF-000094', NULL, 'Phospholipid-transporting ATPase', 158, NULL, NULL, 74102),
(74103, '3.30.160.60-FF-003560', NULL, NULL, 28, NULL, NULL, 74103),
(74104, '3.10.290.20-FF-000009', NULL, 'Ubiquitin-activating enzyme E1-like', 122, NULL, NULL, 74104),
(74105, '3.60.40.10-FF-000163', NULL, 'Protein serine/threonine phosphatase 2C', 166, NULL, NULL, 74105),
(74106, '3.30.70.1450-FF-000045', NULL, 'Transporter, divalent anion:sodium symporter family', 76, NULL, NULL, 74106),
(74107, '1.10.287.110-FF-000014', NULL, 'dnaJ homolog subfamily A member 1', 103, NULL, NULL, 74107),
(74108, '3.40.50.300-FF-000289', NULL, 'ABC transporter G family member 31', 237, NULL, NULL, 74108),
(74109, '2.170.270.10-FF-000163', NULL, 'SET domain containing 5', 125, NULL, NULL, 74109),
(74110, '3.90.1150.10-FF-000505', NULL, 'Aspartate aminotransferase', 92, NULL, NULL, 74110),
(74111, '2.60.40.10-FF-001311', NULL, 'Sallimus, isoform U', 102, NULL, NULL, 74111),
(74112, '1.25.40.10-FF-002940', NULL, 'Pentatricopeptide repeat-containing protein', 61, NULL, NULL, 74112),
(74113, '3.30.160.60-FF-004739', NULL, NULL, 76, NULL, NULL, 74113),
(74114, '2.30.30.100-FF-000040', NULL, 'Gem-associated protein 7', 85, NULL, NULL, 74114),
(74115, '3.40.50.720-FF-002101', NULL, 'Siroheme synthesis protein, conjectural', 127, NULL, NULL, 74115),
(74116, '3.40.1020.10-FF-000002', NULL, 'L-threonine dehydratase', 103, NULL, NULL, 74116),
(74117, '1.10.510.10-FF-003652', NULL, NULL, 185, NULL, NULL, 74117),
(74118, '3.40.50.150-FF-000862', NULL, 'rRNA methyltransferase', 206, NULL, NULL, 74118),
(74119, '2.30.180.10-FF-000099', NULL, 'DUF5108 domain-containing protein', 170, NULL, NULL, 74119),
(74120, '1.10.630.10-FF-000041', NULL, 'Cytochrome P450 26A1 isoform 1', 458, NULL, NULL, 74120),
(74121, '2.60.40.10-FF-001750', NULL, 'Leptin receptor', 88, NULL, NULL, 74121),
(74122, '3.40.50.300-FF-005275', NULL, 'Uncharacterized protein', 180, NULL, NULL, 74122),
(74123, '3.30.1370.210-FF-000042', NULL, 'Predicted protein', 49, NULL, NULL, 74123),
(74124, '2.60.40.10-FF-002929', NULL, 'AGAP000937-PA', 109, NULL, NULL, 74124),
(74125, '3.40.50.300-FF-001441', NULL, 'DNA helicase', 346, NULL, NULL, 74125);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(74126, '1.20.1070.10-FF-001012', NULL, 'Annetocin receptor', 362, NULL, NULL, 74126),
(74127, '1.25.40.10-FF-002120', NULL, 'Putative pentatricopeptide repeat family protein', 133, NULL, NULL, 74127),
(74128, '1.25.40.20-FF-000796', NULL, 'AGAP001061-PB', 65, NULL, NULL, 74128),
(74129, '3.40.50.2300-FF-001242', NULL, NULL, 69, NULL, NULL, 74129),
(74130, '2.60.120.330-FF-000107', NULL, 'Predicted protein', 337, NULL, NULL, 74130),
(74131, '3.10.280.10-FF-000034', NULL, 'Mitochondrial glycoprotein family protein', 108, NULL, NULL, 74131),
(74132, '3.40.50.300-FF-002767', NULL, 'Fe(3+) ions import ATP-binding protein FbpC', 225, NULL, NULL, 74132),
(74133, '1.20.1250.20-FF-000298', NULL, 'Thiamine transporter', 390, NULL, NULL, 74133),
(74134, '3.60.10.10-FF-000335', NULL, 'Predicted protein', 228, NULL, NULL, 74134),
(74135, '1.10.1520.10-FF-000122', NULL, 'Uncharacterized protein', 79, NULL, NULL, 74135),
(74136, '3.40.50.10420-FF-000001', NULL, 'Methenyltetrahydrofolate synthase domain-containing protein', 185, NULL, NULL, 74136),
(74137, '1.10.555.10-FF-000192', NULL, NULL, 198, NULL, NULL, 74137),
(74138, '3.90.70.10-FF-000882', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 283, NULL, NULL, 74138),
(74139, '3.40.47.10-FF-000145', NULL, 'Polyketide synthase', 500, NULL, NULL, 74139),
(74140, '3.90.70.10-FF-000646', NULL, 'Uncharacterized protein', 93, NULL, NULL, 74140),
(74141, '1.20.58.2190-FF-000011', NULL, 'GM19889', 97, NULL, NULL, 74141),
(74142, '3.40.50.2000-FF-000505', NULL, 'Glycosyl transferase family 1', 148, NULL, NULL, 74142),
(74143, '2.30.42.10-FF-000569', NULL, NULL, 55, NULL, NULL, 74143),
(74144, '3.20.20.140-FF-000251', NULL, 'Allantoinase', 135, NULL, NULL, 74144),
(74145, '3.40.50.300-FF-001093', NULL, 'DNA polymerase III subunit delta', 140, NULL, NULL, 74145),
(74146, '1.10.340.70-FF-000042', NULL, 'OSJNBa0059D20.8-like protein', 85, NULL, NULL, 74146),
(74147, '3.80.10.10-FF-002751', NULL, 'OSIGBa0107E14.8 protein', 87, NULL, NULL, 74147),
(74148, '3.30.460.10-FF-000162', NULL, 'Pol lambda-related class X DNA repair polymerase', 139, NULL, NULL, 74148),
(74149, '3.30.43.10-FF-000018', NULL, 'D-lactate dehydrogenase (Dld)', 91, NULL, NULL, 74149),
(74150, '2.60.60.20-FF-000023', NULL, 'Multidomain scavenger receptor', 110, NULL, NULL, 74150),
(74151, '2.30.29.30-FF-000606', NULL, 'Sterol 3-beta-glucosyltransferase', 96, NULL, NULL, 74151),
(74152, '1.10.10.60-FF-000749', NULL, 'Two-component system sensor histidine kinase/response regulator', 58, NULL, NULL, 74152),
(74153, '3.30.70.330-FF-002558', NULL, NULL, 149, NULL, NULL, 74153),
(74154, '2.30.30.140-FF-000041', NULL, 'Scm-like with four mbt domains 1, isoform CRA_b', 144, NULL, NULL, 74154),
(74155, '1.20.1050.130-FF-000009', NULL, 'Elongation factor 1-beta', 71, NULL, NULL, 74155),
(74156, '1.25.10.10-FF-003259', NULL, 'Chromatin structure-remodeling complex subunit rsc9', 214, NULL, NULL, 74156),
(74157, '3.60.20.10-FF-000150', NULL, 'Proteasome endopeptidase complex', 207, NULL, NULL, 74157),
(74158, '3.30.200.20-FF-000387', NULL, 'Serine/threonine-protein kinase STE11', 98, NULL, NULL, 74158),
(74159, '2.10.25.10-FF-000525', NULL, 'Fat-like cadherin-related tumor suppressor homolog', 37, NULL, NULL, 74159),
(74160, '2.130.10.10-FF-003661', NULL, 'Predicted protein', 85, NULL, NULL, 74160),
(74161, '1.20.5.340-FF-000127', NULL, 'Tropomyosin 3', 46, NULL, NULL, 74161),
(74162, '3.30.70.960-FF-000026', NULL, 'Suppression of tumorigenicity 14b', 100, NULL, NULL, 74162),
(74163, '3.40.50.1370-FF-000035', NULL, 'Aspartate carbamoyltransferase, catalytic subunit', 134, NULL, NULL, 74163),
(74164, '3.40.190.10-FF-000481', NULL, 'Uncharacterized protein', 84, NULL, NULL, 74164),
(74165, '3.30.40.10-FF-002221', NULL, 'Protein CBG05218', 68, NULL, NULL, 74165),
(74166, '1.20.920.10-FF-000090', NULL, 'GD18270', 141, NULL, NULL, 74166),
(74167, '2.130.10.10-FF-002368', NULL, 'Uncharacterized protein', 144, NULL, NULL, 74167),
(74168, '3.40.50.10190-FF-000078', NULL, 'DNA polymerase III subunit epsilon', 90, NULL, NULL, 74168);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(74169, '1.20.1070.10-FF-000051', NULL, 'Vomeronasal type-1 receptor', 299, NULL, NULL, 74169),
(74170, '3.30.70.330-FF-000321', NULL, 'Peptidyl-prolyl cis-trans isomerase E', 92, NULL, NULL, 74170),
(74171, '2.10.25.10-FF-001014', NULL, 'Agrin', 66, NULL, NULL, 74171),
(74172, '3.30.420.510-FF-000022', NULL, 'Uncharacterized protein', 105, NULL, NULL, 74172),
(74173, '1.10.3380.10-FF-000015', NULL, 'U5 small nuclear ribonucleoprotein-specific protein', 149, NULL, NULL, 74173),
(74174, '1.25.10.10-FF-000533', NULL, 'MOT1p protein', 301, NULL, NULL, 74174),
(74175, '2.40.50.90-FF-000128', NULL, 'Uncharacterized protein', 147, NULL, NULL, 74175),
(74176, '3.40.50.720-FF-000050', NULL, 'D-lactate dehydrogenase', 196, NULL, NULL, 74176),
(74177, '1.10.150.50-FF-000016', NULL, 'Ankyrin repeat and sterile alpha motif domain-containing protein 1B', 63, NULL, NULL, 74177),
(74178, '3.40.50.12710-FF-000019', NULL, 'Protein arginine methyltransferase NDUFAF7', 276, NULL, NULL, 74178),
(74179, '2.10.70.10-FF-000028', NULL, 'mannan-binding lectin serine protease 1 isoform X2', 69, NULL, NULL, 74179),
(74180, '3.90.320.10-FF-000065', NULL, 'Uncharacterized protein', 177, NULL, NULL, 74180),
(74181, '1.10.238.10-FF-000337', NULL, 'CALmodulin related genes', 98, NULL, NULL, 74181),
(74182, '2.60.120.290-FF-000253', NULL, 'Cubilin-like Protein', 144, NULL, NULL, 74182),
(74183, '3.30.230.10-FF-000369', NULL, 'Uncharacterized protein', 83, NULL, NULL, 74183),
(74184, '3.40.50.300-FF-003386', NULL, 'DNA repair protein RAD57', 124, NULL, NULL, 74184),
(74185, '2.60.120.330-FF-000074', NULL, 'Predicted protein', 267, NULL, NULL, 74185),
(74186, '1.10.472.80-FF-000126', NULL, 'TBC/Rab GTPase activating domain containing protein', 122, NULL, NULL, 74186),
(74187, '2.40.10.10-FF-000113', NULL, 'Zgc:112285', 114, NULL, NULL, 74187),
(74188, '2.60.40.10-FF-004184', NULL, NULL, 84, NULL, NULL, 74188),
(74189, '1.20.1260.60-FF-000001', NULL, 'IST1 homolog isoform X1', 189, NULL, NULL, 74189),
(74190, '2.60.40.10-FF-003548', NULL, NULL, 96, NULL, NULL, 74190),
(74191, '3.20.80.10-FF-000043', NULL, 'Uncharacterized protein', 185, NULL, NULL, 74191),
(74192, '1.20.1270.130-FF-000002', NULL, 'Type III secretion system effector protein-E3 Ubiquitin ligase', 83, NULL, NULL, 74192),
(74193, '2.120.10.80-FF-000271', NULL, 'Uncharacterized protein', 197, NULL, NULL, 74193),
(74194, '1.20.1220.12-FF-000003', NULL, 'Malate synthase (GlcB)', 169, NULL, NULL, 74194),
(74195, '3.40.1090.10-FF-000085', NULL, 'Patatin-like phospholipase domain-containing protein SPAC1786.01c', 121, NULL, NULL, 74195),
(74196, '3.40.50.2300-FF-001669', NULL, NULL, 167, NULL, NULL, 74196),
(74197, '2.40.100.10-FF-000081', NULL, 'Peptidyl-prolyl cis-trans isomerase', 151, NULL, NULL, 74197),
(74198, '3.80.10.10-FF-001806', NULL, 'Os05g0501600 protein', 91, NULL, NULL, 74198),
(74199, '2.110.10.10-FF-000065', NULL, 'Uncharacterized protein', 84, NULL, NULL, 74199),
(74200, '2.30.40.10-FF-000054', NULL, 'Uncharacterized protein, isoform B', 55, NULL, NULL, 74200),
(74201, '3.80.10.10-FF-000047', NULL, 'protein phosphatase 1 regulatory subunit 29', 207, NULL, NULL, 74201),
(74202, '1.25.40.10-FF-003424', NULL, 'Protein SGT1-like protein A', 150, NULL, NULL, 74202),
(74203, '2.40.50.140-FF-000969', NULL, NULL, 61, NULL, NULL, 74203),
(74204, '3.30.2380.10-FF-000003', NULL, 'At4g34412', 171, NULL, NULL, 74204),
(74205, '3.30.200.20-FF-001798', NULL, 'Kinase, NEK', 92, NULL, NULL, 74205),
(74206, '3.30.300.20-FF-000018', NULL, 'Ribosome-binding factor A', 117, NULL, NULL, 74206),
(74207, '3.90.1820.10-FF-000001', NULL, 'Alpha-galactosidase', 444, NULL, NULL, 74207),
(74208, '3.20.20.80-FF-000605', NULL, 'Beta-glucosidase 11', 180, NULL, NULL, 74208),
(74209, '3.30.70.100-FF-000151', NULL, NULL, 118, NULL, NULL, 74209),
(74210, '2.10.50.10-FF-000145', NULL, 'Uncharacterized protein', 50, NULL, NULL, 74210),
(74211, '3.30.160.60-FF-002941', NULL, 'Zinc finger protein 236', 26, NULL, NULL, 74211),
(74212, '2.30.29.30-FF-000230', NULL, 'Polarized growth protein (Boi2)', 112, NULL, NULL, 74212);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(74213, '2.130.10.10-FF-004622', NULL, 'Uncharacterized protein', 199, NULL, NULL, 74213),
(74214, '3.10.110.10-FF-000157', NULL, 'Ubiquitin-conjugating enzyme family protein', 157, NULL, NULL, 74214),
(74215, '3.40.50.80-FF-000140', NULL, 'Ferric reductase like transmembrane component', 106, NULL, NULL, 74215),
(74216, '2.60.40.1930-FF-000025', NULL, 'Complement component 4', 110, NULL, NULL, 74216),
(74217, '1.20.1250.20-FF-001894', NULL, 'Pyrazinamidase/nicotinamidase, putative', 72, NULL, NULL, 74217),
(74218, '2.40.128.430-FF-000001', NULL, 'ATPase RavA', 107, NULL, NULL, 74218),
(74219, '3.40.50.720-FF-000639', NULL, 'Fatty acyl-CoA reductase', 355, NULL, NULL, 74219),
(74220, '2.60.120.10-FF-000302', NULL, 'cGMP-dependent protein kinase', 136, NULL, NULL, 74220),
(74221, '1.20.120.730-FF-000018', NULL, 'Protein transport protein Sec24-like CEF', 134, NULL, NULL, 74221),
(74222, '3.40.50.300-FF-004656', NULL, 'Methyl coenzyme M reductase system, component A2 homolog', 55, NULL, NULL, 74222),
(74223, '2.130.10.10-FF-005241', NULL, 'Uncharacterized protein', 312, NULL, NULL, 74223),
(74224, '1.10.530.10-FF-000022', NULL, 'Lysozyme g-like protein', 176, NULL, NULL, 74224),
(74225, '2.130.10.10-FF-005111', NULL, 'Protein HIRA', 244, NULL, NULL, 74225),
(74226, '3.30.70.330-FF-001810', NULL, NULL, 179, NULL, NULL, 74226),
(74227, '2.130.10.10-FF-005550', NULL, 'Uncharacterized protein', 222, NULL, NULL, 74227),
(74228, '1.20.144.10-FF-000049', NULL, 'Lipid phosphate phosphatase, putative', 113, NULL, NULL, 74228),
(74229, '1.10.10.60-FF-000188', NULL, 'Anaerobic nitric oxide reductase transcription regulator NorR', 53, NULL, NULL, 74229),
(74230, '1.20.1250.20-FF-001714', NULL, 'Melibiose carrier protein', 233, NULL, NULL, 74230),
(74231, '2.60.120.260-FF-000401', NULL, 'Putative Epithelial discoidin domain-containing receptor', 158, NULL, NULL, 74231),
(74232, '1.10.510.10-FF-001550', NULL, 'Wall-associated receptor kinase-like 6', 148, NULL, NULL, 74232),
(74233, '2.130.10.10-FF-003296', NULL, 'Transducin (beta)-like 3', 129, NULL, NULL, 74233),
(74234, '3.30.160.60-FF-000996', NULL, 'Zinc finger protein 181', 28, NULL, NULL, 74234),
(74235, '1.20.1250.20-FF-001006', NULL, 'solute carrier family 2, facilitated glucose transporter member 6 isoform X2', 94, NULL, NULL, 74235),
(74236, '2.130.10.10-FF-000570', NULL, 'Vacuolar protein sorting-associated protein 11 homolog', 346, NULL, NULL, 74236),
(74237, '1.10.390.10-FF-000033', NULL, 'Endoplasmic reticulum aminopeptidase 1b', 105, NULL, NULL, 74237),
(74238, '3.40.640.10-FF-000235', NULL, 'Aminotransferase', 241, NULL, NULL, 74238),
(74239, '3.30.420.40-FF-000140', NULL, 'Heat shock protein 14', 89, NULL, NULL, 74239),
(74240, '3.30.540.10-FF-000016', NULL, 'SAL1 phosphatase', 212, NULL, NULL, 74240),
(74241, '1.25.40.10-FF-003115', NULL, 'Uncharacterized protein', 65, NULL, NULL, 74241),
(74242, '3.30.450.20-FF-000102', NULL, 'Sensor protein kinase WalK', 151, NULL, NULL, 74242),
(74243, '3.90.226.10-FF-000177', NULL, 'Carboxyl-terminal-processing peptidase 3, chloroplastic', 22, NULL, NULL, 74243),
(74244, '3.10.28.10-FF-000057', NULL, 'Replication factor C small subunit', 169, NULL, NULL, 74244),
(74245, '1.10.630.10-FF-000833', NULL, 'Uncharacterized protein', 212, NULL, NULL, 74245),
(74246, '1.10.510.10-FF-001403', NULL, 'Rab GTPase activating protein, putative', 233, NULL, NULL, 74246),
(74247, '1.10.1200.240-FF-000008', NULL, 'Uncharacterized protein', 84, NULL, NULL, 74247),
(74248, '2.40.50.40-FF-000102', NULL, 'Chemokine (C-C motif) ligand 39, duplicate 4', 51, NULL, NULL, 74248),
(74249, '3.40.50.300-FF-008366', NULL, 'Uncharacterized protein', 169, NULL, NULL, 74249),
(74250, '1.25.10.10-FF-001803', NULL, 'Predicted protein', 270, NULL, NULL, 74250),
(74251, '3.50.30.30-FF-000106', NULL, 'Predicted protein', 25, NULL, NULL, 74251),
(74252, '3.40.50.300-FF-005640', NULL, 'Putative ATP-dependent RNA helicase TDRD12', 233, NULL, NULL, 74252),
(74253, '3.30.160.60-FF-005358', NULL, NULL, 59, NULL, NULL, 74253),
(74254, '2.60.120.590-FF-000045', NULL, '2OG-Fe(II) oxygenase superfamily, putative', 235, NULL, NULL, 74254);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(74255, '1.25.10.10-FF-001461', NULL, 'Serine/threonine-protein kinase TOR', 472, NULL, NULL, 74255),
(74256, '2.130.10.10-FF-004841', NULL, 'Uncharacterized protein', 132, NULL, NULL, 74256),
(74257, '3.80.20.20-FF-000017', NULL, 'Tyrosine-protein kinase receptor', 73, NULL, NULL, 74257),
(74258, '1.20.210.10-FF-000024', NULL, 'Intron-encoded DNA endonuclease aI3', 83, NULL, NULL, 74258),
(74259, '2.130.10.10-FF-004280', NULL, 'Uncharacterized protein', 128, NULL, NULL, 74259),
(74260, '1.25.40.180-FF-000227', NULL, NULL, 77, NULL, NULL, 74260),
(74261, '3.30.160.60-FF-004869', NULL, NULL, 32, NULL, NULL, 74261),
(74262, '1.50.40.10-FF-000033', NULL, 'Solute carrier family 25 member 44', 139, NULL, NULL, 74262),
(74263, '3.40.430.10-FF-000045', NULL, 'Dihydrofolate reductase', 250, NULL, NULL, 74263),
(74264, '2.60.200.30-FF-000022', NULL, 'NAD kinase', 129, NULL, NULL, 74264),
(74265, '1.50.10.160-FF-000019', NULL, 'Uncharacterized protein', 48, NULL, NULL, 74265),
(74266, '1.10.238.10-FF-001265', NULL, 'Calcium-binding EF-hand domain-containing protein', 56, NULL, NULL, 74266),
(74267, '1.20.1260.80-FF-000007', NULL, 'Uncharacterized protein', 191, NULL, NULL, 74267),
(74268, '1.10.472.10-FF-000561', NULL, 'Uncharacterized protein', 66, NULL, NULL, 74268),
(74269, '3.40.50.300-FF-008057', NULL, 'TrwK protein', 125, NULL, NULL, 74269),
(74270, '1.20.5.780-FF-000017', NULL, 'FXYD domain-containing ion transport regulator', 68, NULL, NULL, 74270),
(74271, '1.20.59.10-FF-000015', NULL, 'Chorismate mutase', 164, NULL, NULL, 74271),
(74272, '3.40.50.300-FF-003695', NULL, 'DEXH (Asp-Glu-X-His) box polypeptide 58', 149, NULL, NULL, 74272),
(74273, '1.20.58.1070-FF-000024', NULL, 'Predicted protein', 171, NULL, NULL, 74273),
(74274, '3.30.160.60-FF-000687', NULL, 'Zinc finger and AT-hook domain containing', 86, NULL, NULL, 74274),
(74275, '1.10.287.70-FF-000592', NULL, 'Uncharacterized protein', 135, NULL, NULL, 74275),
(74276, '2.60.40.10-FF-004493', NULL, NULL, 98, NULL, NULL, 74276),
(74277, '3.50.50.60-FF-001140', NULL, 'FAD-dependent oxidoreductase domain-containing 2', 90, NULL, NULL, 74277),
(74278, '1.20.1250.10-FF-000076', NULL, 'Erythropoietin', 159, NULL, NULL, 74278),
(74279, '1.10.510.10-FF-001179', NULL, 'Serine/threonine-protein kinase LMTK1', 206, NULL, NULL, 74279),
(74280, '1.20.920.30-FF-000005', NULL, 'Dynein, axonemal, heavy chain 2', 198, NULL, NULL, 74280),
(74281, '3.90.940.10-FF-000005', NULL, 'Probable DNA-directed RNA polymerases I, II, and III subunit RPABC2', 135, NULL, NULL, 74281),
(74282, '3.30.1490.20-FF-000104', NULL, 'Uncharacterized protein', 59, NULL, NULL, 74282),
(74283, '3.40.50.11380-FF-000019', NULL, NULL, 57, NULL, NULL, 74283),
(74284, '4.10.520.10-FF-000004', NULL, 'HU family DNA-binding protein', 90, NULL, NULL, 74284),
(74285, '1.10.510.10-FF-000779', NULL, 'CAMK/CAMKL protein kinase', 270, NULL, NULL, 74285),
(74286, '3.90.550.10-FF-000666', NULL, 'Uncharacterized protein', 113, NULL, NULL, 74286),
(74287, '1.25.40.10-FF-000467', NULL, 'Putative rRNA biogenesis protein RRP5', 200, NULL, NULL, 74287),
(74288, '2.30.30.140-FF-000260', NULL, 'Uncharacterized protein', 54, NULL, NULL, 74288),
(74289, '3.40.50.150-FF-001407', NULL, NULL, 164, NULL, NULL, 74289),
(74290, '3.30.420.40-FF-000595', NULL, '105/110 kDa heat shock protein, nucleotide-binding domain', 96, NULL, NULL, 74290),
(74291, '1.20.1270.60-FF-000261', NULL, 'Predicted protein', 183, NULL, NULL, 74291),
(74292, '3.40.50.2020-FF-000152', NULL, 'Probable adenine phosphoribosyltransferase', 145, NULL, NULL, 74292),
(74293, '4.10.410.10-FF-000103', NULL, 'Uncharacterized protein', 54, NULL, NULL, 74293),
(74294, '3.30.40.10-FF-002249', NULL, 'Uncharacterized protein', 58, NULL, NULL, 74294),
(74295, '1.25.10.10-FF-000639', NULL, 'Kinesin-like protein', 166, NULL, NULL, 74295),
(74296, '2.60.40.10-FF-001856', NULL, 'Hemicentin 2', 94, NULL, NULL, 74296),
(74297, '1.10.472.10-FF-000252', NULL, 'Protein CBG20098', 98, NULL, NULL, 74297),
(74298, '2.60.40.10-FF-000822', NULL, 'tenascin-X', 92, NULL, NULL, 74298);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(74299, '3.40.50.1170-FF-000003', NULL, '60 kDa lysophospholipase', 232, NULL, NULL, 74299),
(74300, '3.40.50.720-FF-001792', NULL, 'Shikimate dehydrogenase (NADP(+))', 125, NULL, NULL, 74300),
(74301, '2.10.90.10-FF-000030', NULL, 'Vascular endothelial growth factor B', 106, NULL, NULL, 74301),
(74302, '3.80.10.10-FF-002520', NULL, 'Erbb2 interacting protein', 181, NULL, NULL, 74302),
(74303, '3.40.50.2000-FF-000736', NULL, 'Glycosyltransferase', 259, NULL, NULL, 74303),
(74304, '3.30.30.30-FF-000040', NULL, 'Predicted protein', 56, NULL, NULL, 74304),
(74305, '3.30.1140.32-FF-000010', NULL, '30S ribosomal protein S3', 116, NULL, NULL, 74305),
(74306, '3.30.420.40-FF-000067', NULL, 'Pantothenate kinase 4', 173, NULL, NULL, 74306),
(74307, '3.40.50.300-FF-001222', NULL, 'Torsin family 3, member A', 200, NULL, NULL, 74307),
(74308, '1.10.510.10-FF-004040', NULL, NULL, 82, NULL, NULL, 74308),
(74309, '3.40.250.10-FF-000082', NULL, 'Thiosulfate:glutathione sulfurtransferase', 120, NULL, NULL, 74309),
(74310, '2.30.110.10-FF-000044', NULL, 'POSSIBLE OXIDOREDUCTASE', 163, NULL, NULL, 74310),
(74311, '3.40.50.970-FF-000012', NULL, 'Pyruvate:ferredoxin (Flavodoxin) oxidoreductase', 251, NULL, NULL, 74311),
(74312, '3.50.30.30-FF-000067', NULL, 'Uncharacterized protein', 132, NULL, NULL, 74312),
(74313, '3.40.190.10-FF-000037', NULL, 'HTH-type transcriptional regulator CysB', 101, NULL, NULL, 74313),
(74314, '3.30.63.10-FF-000003', NULL, 'Membrane-associated guanylate kinase, WW and PDZ domain-containing protein 3 isoform 1', 56, NULL, NULL, 74314),
(74315, '3.30.1490.20-FF-000093', NULL, 'Uncharacterized protein', 15, NULL, NULL, 74315),
(74316, '3.40.50.300-FF-001694', NULL, 'Adenylate kinase, chloroplastic', 214, NULL, NULL, 74316),
(74317, '3.40.50.300-FF-004875', NULL, 'ATP-dependent RNA and DNA helicase, mitochondrial, putative', 162, NULL, NULL, 74317),
(74318, '2.40.50.90-FF-000095', NULL, 'Qin', 97, NULL, NULL, 74318),
(74319, '1.20.1560.10-FF-000734', NULL, 'Predicted protein', 184, NULL, NULL, 74319),
(74320, '3.40.50.300-FF-006584', NULL, 'ABC transporter AbcG18, putative', 99, NULL, NULL, 74320),
(74321, '3.50.50.60-FF-000993', NULL, 'Predicted protein', 371, NULL, NULL, 74321),
(74322, '3.80.10.10-FF-000278', NULL, 'PH domain and leucine rich repeat protein phosphatase 1', 110, NULL, NULL, 74322),
(74323, '1.10.510.10-FF-003421', NULL, NULL, 291, NULL, NULL, 74323),
(74324, '3.30.420.80-FF-000028', NULL, 'Predicted protein', 98, NULL, NULL, 74324),
(74325, '3.90.660.10-FF-000079', NULL, NULL, 104, NULL, NULL, 74325),
(74326, '2.30.30.100-FF-000164', NULL, 'U6 snRNA-associated Sm-like protein LSm1', 127, NULL, NULL, 74326),
(74327, '3.30.160.60-FF-006179', NULL, NULL, 62, NULL, NULL, 74327),
(74328, '3.10.290.70-FF-000002', NULL, '40S ribosomal protein S8', 54, NULL, NULL, 74328),
(74329, '3.30.70.330-FF-002760', NULL, NULL, 80, NULL, NULL, 74329),
(74330, '1.10.287.10-FF-000046', NULL, 'Uncharacterized protein', 29, NULL, NULL, 74330),
(74331, '1.20.1000.10-FF-000029', NULL, NULL, 102, NULL, NULL, 74331),
(74332, '1.10.8.10-FF-000003', NULL, 'UV excision repair protein RAD23 homolog', 48, NULL, NULL, 74332),
(74333, '1.25.40.10-FF-003340', NULL, 'Pentatricopeptide repeat-containing protein At2g15630, mitochondrial', 92, NULL, NULL, 74333),
(74334, '2.60.40.1180-FF-000199', NULL, 'Glucosylceramidase', 76, NULL, NULL, 74334),
(74335, '3.30.365.10-FF-000002', NULL, 'Xanthine dehydrogenase oxidase', 128, NULL, NULL, 74335),
(74336, '3.90.79.10-FF-000166', NULL, 'Isopentenyl-diphosphate delta-isomerase, type 1 family protein', 197, NULL, NULL, 74336),
(74337, '3.90.190.10-FF-000026', NULL, 'tyrosine-protein phosphatase non-receptor type 9', 308, NULL, NULL, 74337),
(74338, '2.130.10.10-FF-001508', NULL, 'Transducin family protein / WD-40 repeat family protein', 178, NULL, NULL, 74338),
(74339, '2.60.120.200-FF-000754', NULL, 'Uncharacterized protein', 120, NULL, NULL, 74339),
(74340, '1.10.12.70-FF-000015', NULL, NULL, 64, NULL, NULL, 74340),
(74341, '1.10.150.850-FF-000006', NULL, 'Transcription elongation factor SPT6', 104, NULL, NULL, 74341); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(74342, '3.40.50.200-FF-000118', NULL, 'Uncharacterized protein', 99, NULL, NULL, 74342),
(74343, '2.130.10.10-FF-003060', NULL, 'Echinoderm microtubule-associated protein-like 1', 324, NULL, NULL, 74343),
(74344, '2.60.40.1530-FF-000006', NULL, 'Integrin subunit alpha 5', 200, NULL, NULL, 74344),
(74345, '2.60.40.2300-FF-000013', NULL, 'Uncharacterized protein', 94, NULL, NULL, 74345),
(74346, '3.10.20.10-FF-000023', NULL, 'Cell death-inducing DFFA-like effector a', 118, NULL, NULL, 74346),
(74347, '1.20.1560.10-FF-000251', NULL, 'ABC transporter ATP-binding protein', 317, NULL, NULL, 74347),
(74348, '3.40.50.720-FF-000156', NULL, 'Ubiquitin-like modifier-activating enzyme ATG7', 379, NULL, NULL, 74348),
(74349, '2.60.40.10-FF-002475', NULL, 'CRE-UNC-22 protein', 99, NULL, NULL, 74349),
(74350, '3.40.50.300-FF-008618', NULL, 'Uncharacterized protein', 240, NULL, NULL, 74350),
(74351, '3.30.200.20-FF-001371', NULL, 'Non-specific serine/threonine protein kinase', 97, NULL, NULL, 74351),
(74352, '2.60.40.10-FF-003565', NULL, 'Interferon alpha/beta receptor 2', 203, NULL, NULL, 74352),
(74353, '3.40.50.410-FF-000182', NULL, 'Uncharacterized protein, isoform E', 213, NULL, NULL, 74353),
(74354, '1.10.260.40-FF-000021', NULL, 'Trehalose operon repressor', 61, NULL, NULL, 74354),
(74355, '2.30.29.30-FF-000680', NULL, 'Protein kinase domain containing protein', 122, NULL, NULL, 74355),
(74356, '3.40.30.10-FF-001034', NULL, 'Selenoprotein, putative', 45, NULL, NULL, 74356),
(74357, '3.40.190.290-FF-000085', NULL, 'LysR family transcriptional regulator', 204, NULL, NULL, 74357),
(74358, '2.40.10.10-FF-000220', NULL, 'Serine protease 1', 65, NULL, NULL, 74358),
(74359, '3.40.1170.10-FF-000030', NULL, 'DNA mismatch repair protein MutS', 126, NULL, NULL, 74359),
(74360, '3.30.2300.20-FF-000001', NULL, 'Ribosomal RNA large subunit methyltransferase M', 96, NULL, NULL, 74360),
(74361, '3.20.20.70-FF-000372', NULL, 'Biotin synthase', 309, NULL, NULL, 74361),
(74362, '3.40.50.300-FF-005600', NULL, 'Dhx38 protein', 122, NULL, NULL, 74362),
(74363, '1.20.1060.10-FF-000005', NULL, 'DNA polymerase 1, putative', 124, NULL, NULL, 74363),
(74364, '1.10.150.20-FF-000260', NULL, 'DNA repair protein, putative', 87, NULL, NULL, 74364),
(74365, '3.30.70.330-FF-000630', NULL, 'RNA-binding motif protein 12B', 118, NULL, NULL, 74365),
(74366, '1.25.40.10-FF-001086', NULL, 'Pentatricopeptide repeat-containing protein At4g33170', 150, NULL, NULL, 74366),
(74367, '3.90.1010.10-FF-000018', NULL, 'Iron-sulfur cluster assembly protein 1', 65, NULL, NULL, 74367),
(74368, '3.30.428.10-FF-000070', NULL, 'Uncharacterized protein', 142, NULL, NULL, 74368),
(74369, '1.20.5.4820-FF-000019', NULL, NULL, 134, NULL, NULL, 74369),
(74370, '1.10.287.110-FF-000031', NULL, 'Molecular chaperone DnaJ', 114, NULL, NULL, 74370),
(74371, '1.10.287.130-FF-000037', NULL, 'Hybrid sensor histidine kinase/response regulator', 72, NULL, NULL, 74371),
(74372, '3.90.170.10-FF-000013', NULL, 'Adenylosuccinate synthetase', 107, NULL, NULL, 74372),
(74373, '1.10.287.70-FF-000277', NULL, 'KCNN (Potassium K ChaNNel, calcium activated)-Like', 103, NULL, NULL, 74373),
(74374, '1.25.10.10-FF-000494', NULL, 'Sister chromatid cohesion protein', 162, NULL, NULL, 74374),
(74375, '3.40.440.10-FF-000001', NULL, 'Adenylosuccinate synthetase', 161, NULL, NULL, 74375),
(74376, '3.30.450.20-FF-000574', NULL, 'Uncharacterized protein', 90, NULL, NULL, 74376),
(74377, '1.10.238.10-FF-000753', NULL, 'Hydroxymethylglutaryl-CoA lyase, mitochondrial, putative', 83, NULL, NULL, 74377),
(74378, '3.30.230.80-FF-000002', NULL, 'Molecular chaperone HtpG', 168, NULL, NULL, 74378),
(74379, '2.10.25.10-FF-001469', NULL, 'Delta-like protein', 39, NULL, NULL, 74379),
(74380, '1.10.420.10-FF-000008', NULL, 'Peroxidase', 144, NULL, NULL, 74380),
(74381, '1.10.441.10-FF-000006', NULL, 'mannose-6-phosphate isomerase isoform X6', 25, NULL, NULL, 74381),
(74382, '3.40.50.300-FF-001705', NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', 139, NULL, NULL, 74382),
(74383, '2.60.40.10-FF-000131', NULL, 'Plexin A2', 137, NULL, NULL, 74383);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(74384, '2.60.40.10-FF-004509', NULL, NULL, 101, NULL, NULL, 74384),
(74385, '1.20.1050.10-FF-000179', NULL, 'Glutathione S-transferase', 120, NULL, NULL, 74385),
(74386, '3.30.160.60-FF-004633', NULL, NULL, 34, NULL, NULL, 74386),
(74387, '1.10.1670.40-FF-000001', NULL, 'Probable DNA-3-methyladenine glycosylase 2', 76, NULL, NULL, 74387),
(74388, '1.10.20.10-FF-000140', NULL, 'Histone H3-like centromeric protein cse-4', 167, NULL, NULL, 74388),
(74389, '2.130.10.10-FF-001727', NULL, 'F-box/WD repeat-containing protein 9', 158, NULL, NULL, 74389),
(74390, '2.60.40.770-FF-000005', NULL, 'Lymphocyte antigen 86', 142, NULL, NULL, 74390),
(74391, '3.10.180.10-FF-000094', NULL, 'ATP-dependent 6-phosphofructokinase', 144, NULL, NULL, 74391),
(74392, '3.40.50.300-FF-008473', NULL, 'Uncharacterized protein', 228, NULL, NULL, 74392),
(74393, '3.30.70.330-FF-002119', NULL, NULL, 110, NULL, NULL, 74393),
(74394, '1.20.890.10-FF-000018', NULL, 'COMPASS component SDC1', 48, NULL, NULL, 74394),
(74395, '1.10.287.1970-FF-000005', NULL, 'Alanine aminotransferase, putative', 54, NULL, NULL, 74395),
(74396, '1.50.10.10-FF-000194', NULL, 'Uncharacterized protein', 239, NULL, NULL, 74396),
(74397, '3.20.20.80-FF-000066', NULL, 'Beta-amylase', 465, NULL, NULL, 74397),
(74398, '3.90.1530.10-FF-000018', NULL, 'ParB domain protein nuclease', 79, NULL, NULL, 74398),
(74399, '3.30.160.40-FF-000024', NULL, 'Porphobilinogen deaminase-like Protein', 107, NULL, NULL, 74399),
(74400, '2.40.30.20-FF-000005', NULL, 'Riboflavin synthase, alpha subunit', 105, NULL, NULL, 74400),
(74401, '1.10.418.10-FF-000087', NULL, 'p-loop nucleoside triphosphate hydrolase superfamily protein with CH (Calponin Homology) domain', 153, NULL, NULL, 74401),
(74402, '1.10.8.60-FF-000024', NULL, 'DnaA regulatory inactivator Hda', 67, NULL, NULL, 74402),
(74403, '3.30.70.1530-FF-000002', NULL, 'Lipoprotein', 72, NULL, NULL, 74403),
(74404, '3.30.450.40-FF-000001', NULL, 'Phosphodiesterase', 203, NULL, NULL, 74404),
(74405, '3.30.1050.10-FF-000034', NULL, 'Spore associated protein, SapD', 97, NULL, NULL, 74405),
(74406, '1.10.3500.10-FF-000003', NULL, 'S1 RNA-binding domain-containing protein 1', 261, NULL, NULL, 74406),
(74407, '1.10.630.10-FF-000726', NULL, 'Cytochrome P450, putative', 99, NULL, NULL, 74407),
(74408, '3.40.350.10-FF-000027', NULL, 'Aminopeptidase P', 145, NULL, NULL, 74408),
(74409, '2.40.50.40-FF-000029', NULL, 'chromodomain Y-like protein isoform X1', 63, NULL, NULL, 74409),
(74410, '3.40.50.10330-FF-000047', NULL, 'ATP-NAD kinase-like protein', 97, NULL, NULL, 74410),
(74411, '2.40.160.110-FF-000032', NULL, 'Uncharacterized protein', 88, NULL, NULL, 74411),
(74412, '2.80.10.50-FF-000101', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 149, NULL, NULL, 74412),
(74413, '3.30.1370.100-FF-000014', NULL, 'DNA mismatch repair protein MutL', 86, NULL, NULL, 74413),
(74414, '3.40.50.1220-FF-000041', NULL, 'NAD-dependent protein deacetylase sirtuin-3, mitochondrial', 169, NULL, NULL, 74414),
(74415, '3.40.50.2300-FF-000944', NULL, NULL, 164, NULL, NULL, 74415),
(74416, '3.90.780.10-FF-000043', NULL, 'Uncharacterized protein', 206, NULL, NULL, 74416),
(74417, '4.10.280.10-FF-000199', NULL, 'Uncharacterized protein', 79, NULL, NULL, 74417),
(74418, '1.10.10.1180-FF-000003', NULL, 'Heh2p', 93, NULL, NULL, 74418),
(74419, '2.60.40.60-FF-001085', NULL, 'Predicted protein', 131, NULL, NULL, 74419),
(74420, '1.20.58.60-FF-000713', NULL, 'Uncharacterized protein', 282, NULL, NULL, 74420),
(74421, '2.160.20.10-FF-000232', NULL, 'Uncharacterized protein', 238, NULL, NULL, 74421),
(74422, '2.120.10.30-FF-000082', NULL, 'Sorbosone dehydrogenase family protein', 290, NULL, NULL, 74422),
(74423, '3.30.450.190-FF-000027', NULL, 'Chromosome 7, whole genome shotgun sequence', 136, NULL, NULL, 74423),
(74424, '3.30.40.10-FF-000220', NULL, 'E3 ubiquitin-protein ligase RNF31 isoform X2', 93, NULL, NULL, 74424),
(74425, '3.40.50.300-FF-006820', NULL, 'Axonemal dynein heavy chain isotype 11', 37, NULL, NULL, 74425),
(74426, '1.10.3380.30-FF-000026', NULL, 'SKI complex RNA helicase subunit', 99, NULL, NULL, 74426);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(74427, '3.40.50.1820-FF-001053', NULL, 'Carboxypeptidase', 419, NULL, NULL, 74427),
(74428, '3.30.160.60-FF-005903', NULL, NULL, 94, NULL, NULL, 74428),
(74429, '1.10.2000.10-FF-000072', NULL, NULL, 108, NULL, NULL, 74429),
(74430, '3.60.10.10-FF-000251', NULL, 'Deoxyribonuclease gamma [precursor]', 261, NULL, NULL, 74430),
(74431, '3.50.50.60-FF-000285', NULL, 'FAD dependent oxidoreductase', 199, NULL, NULL, 74431),
(74432, '1.25.10.10-FF-001258', NULL, 'HEAT repeat containing 1', 526, NULL, NULL, 74432),
(74433, '3.30.70.260-FF-000165', NULL, 'Predicted protein', 82, NULL, NULL, 74433),
(74434, '1.10.246.230-FF-000002', NULL, 'Gamma-glutamyltranspeptidase', 97, NULL, NULL, 74434),
(74435, '4.10.270.10-FF-000007', NULL, 'Myosin II homolog (Eurofung)', 59, NULL, NULL, 74435),
(74436, '1.10.287.860-FF-000003', NULL, 'GTP pyrophosphokinase', 46, NULL, NULL, 74436),
(74437, '3.40.50.1240-FF-000047', NULL, 'Putative phosphoglycerate mutase', 234, NULL, NULL, 74437),
(74438, '2.60.40.150-FF-000730', NULL, 'Uncharacterized protein', 113, NULL, NULL, 74438),
(74439, '3.40.1280.10-FF-000111', NULL, 'tRNA/rRNA methyltransferase (SpoU) family protein', 101, NULL, NULL, 74439),
(74440, '2.60.120.330-FF-000181', NULL, 'Uncharacterized protein', 199, NULL, NULL, 74440),
(74441, '3.40.50.150-FF-001716', NULL, NULL, 205, NULL, NULL, 74441),
(74442, '1.20.1280.50-FF-000230', NULL, 'Predicted protein', 95, NULL, NULL, 74442),
(74443, '3.80.10.10-FF-004549', NULL, 'Uncharacterized protein', 354, NULL, NULL, 74443),
(74444, '1.10.10.2660-FF-000020', NULL, 'Uncharacterized protein', 267, NULL, NULL, 74444),
(74445, '3.30.160.60-FF-000890', NULL, 'U1 small nuclear ribonucleoprotein C', 50, NULL, NULL, 74445),
(74446, '1.25.40.20-FF-001628', NULL, 'Mindbomb E3 ubiquitin protein ligase 2', 97, NULL, NULL, 74446),
(74447, '3.90.190.10-FF-000335', NULL, 'Uncharacterized protein', 254, NULL, NULL, 74447),
(74448, '1.10.510.10-FF-002707', NULL, 'Serine/threonine protein kinase', 196, NULL, NULL, 74448),
(74449, '1.20.1250.20-FF-001478', NULL, 'Protein NRT1/ PTR FAMILY 4.2', 538, NULL, NULL, 74449),
(74450, '1.20.120.850-FF-000043', NULL, 'Helicase of the snf2/rad54 family (Amino end), hypothetical', 73, NULL, NULL, 74450),
(74451, '3.80.10.10-FF-000497', NULL, 'Leucine-rich repeat transmembrane protein kinase', 241, NULL, NULL, 74451),
(74452, '3.40.1160.10-FF-000057', NULL, 'Glutamate 5-kinase, putative', 251, NULL, NULL, 74452),
(74453, '3.30.160.60-FF-002924', NULL, NULL, 28, NULL, NULL, 74453),
(74454, '1.25.40.410-FF-000004', NULL, 'Dedicator of cytokinesis protein 1', 150, NULL, NULL, 74454),
(74455, '1.10.4160.10-FF-000021', NULL, 'Similar to purine-cytosine permease', 428, NULL, NULL, 74455),
(74456, '2.10.50.10-FF-000162', NULL, 'Uncharacterized protein', 54, NULL, NULL, 74456),
(74457, '3.30.450.60-FF-000007', NULL, 'AP complex subunit sigma', 154, NULL, NULL, 74457),
(74458, '1.25.40.10-FF-004593', NULL, 'Uncharacterized protein', 171, NULL, NULL, 74458),
(74459, '3.90.1170.10-FF-000035', NULL, 'Uncharacterized protein', 40, NULL, NULL, 74459),
(74460, '3.40.50.300-FF-006112', NULL, 'ADP ribosylation factor-related protein 1', 60, NULL, NULL, 74460),
(74461, '3.40.50.720-FF-001483', NULL, 'Short-chain dehydrogenase/reductase SDR', 280, NULL, NULL, 74461),
(74462, '2.30.30.140-FF-000125', NULL, 'Predicted protein', 59, NULL, NULL, 74462),
(74463, '1.10.10.60-FF-000879', NULL, NULL, 83, NULL, NULL, 74463),
(74464, '3.40.50.2000-FF-000197', NULL, 'Alpha-1,4 glucan phosphorylase', 17, NULL, NULL, 74464),
(74465, '3.30.70.330-FF-002428', NULL, NULL, 88, NULL, NULL, 74465),
(74466, '1.20.140.50-FF-000013', NULL, 'pH-response regulator protein palA/RIM20', 178, NULL, NULL, 74466),
(74467, '3.90.1200.10-FF-000033', NULL, 'Spore coat protein S', 237, NULL, NULL, 74467),
(74468, '2.20.25.240-FF-000006', NULL, 'Lola-like protein', 79, NULL, NULL, 74468),
(74469, '2.30.22.10-FF-000006', NULL, 'Protein GrpE', 60, NULL, NULL, 74469),
(74470, '1.25.40.1030-FF-000035', NULL, 'Uncharacterized protein', 431, NULL, NULL, 74470);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(74471, '2.20.100.10-FF-000141', NULL, 'Lonely heart, isoform A', 62, NULL, NULL, 74471),
(74472, '1.20.1080.10-FF-000113', NULL, 'Uncharacterized protein', 119, NULL, NULL, 74472),
(74473, '1.10.510.10-FF-004293', NULL, NULL, 163, NULL, NULL, 74473),
(74474, '1.25.40.20-FF-001319', NULL, 'Predicted protein', 139, NULL, NULL, 74474),
(74475, '1.20.990.10-FF-000037', NULL, 'NADPH--cytochrome P450 reductase, putative', 130, NULL, NULL, 74475),
(74476, '3.90.480.10-FF-000003', NULL, 'Sulfite reductase', 107, NULL, NULL, 74476),
(74477, '3.40.1390.20-FF-000015', NULL, 'Probable manganese-dependent inorganic pyrophosphatase', 112, NULL, NULL, 74477),
(74478, '3.30.559.10-FF-000020', NULL, 'Enterobactin synthetase component F', 199, NULL, NULL, 74478),
(74479, '3.50.50.60-FF-001246', NULL, 'Flavin-containing monooxygenase', 163, NULL, NULL, 74479),
(74480, '3.30.40.10-FF-000759', NULL, 'COMPASS component SPP1', 63, NULL, NULL, 74480),
(74481, '4.10.60.10-FF-000107', NULL, 'Putative Zinc knuckle domain protein', 31, NULL, NULL, 74481),
(74482, '3.40.630.30-FF-000151', NULL, 'Ribosomal-protein-alanine acetyltransferase', 178, NULL, NULL, 74482),
(74483, '2.70.160.11-FF-000045', NULL, 'Protein arginine N-methyltransferase 9', 196, NULL, NULL, 74483),
(74484, '1.25.40.90-FF-000087', NULL, 'Predicted protein', 80, NULL, NULL, 74484),
(74485, '1.10.510.10-FF-003112', NULL, NULL, 192, NULL, NULL, 74485),
(74486, '3.40.850.10-FF-000161', NULL, 'Kinesin-like protein', 240, NULL, NULL, 74486),
(74487, '1.20.1070.10-FF-001832', NULL, 'Uncharacterized protein', 353, NULL, NULL, 74487),
(74488, '1.20.1540.10-FF-000031', NULL, 'RHOMBOID-like protein', 191, NULL, NULL, 74488),
(74489, '2.60.120.200-FF-000046', NULL, 'Galectin', 139, NULL, NULL, 74489),
(74490, '3.30.200.20-FF-002096', NULL, 'Uncharacterized protein', 81, NULL, NULL, 74490),
(74491, '3.80.10.10-FF-003392', NULL, 'Predicted protein', 263, NULL, NULL, 74491),
(74492, '1.25.40.120-FF-000041', NULL, 'Uncharacterized protein', 321, NULL, NULL, 74492),
(74493, '3.40.50.300-FF-006893', NULL, 'Type II secretion system protein, conjectural', 243, NULL, NULL, 74493),
(74494, '3.30.160.60-FF-003649', NULL, NULL, 27, NULL, NULL, 74494),
(74495, '4.10.1060.10-FF-000005', NULL, 'RNA-binding protein 10 isoform X2', 32, NULL, NULL, 74495),
(74496, '1.25.40.430-FF-000015', NULL, 'Checkpoint serine/threonine-protein kinase, putative', 203, NULL, NULL, 74496),
(74497, '1.20.1250.20-FF-000950', NULL, 'Predicted arabinose efflux permease, MFS family', 200, NULL, NULL, 74497),
(74498, '3.40.50.11550-FF-000003', NULL, 'Putative lipoprotein', 201, NULL, NULL, 74498),
(74499, '1.20.1070.10-FF-000742', NULL, 'Uncharacterized protein', 315, NULL, NULL, 74499),
(74500, '3.30.70.330-FF-000557', NULL, 'Peptidyl-prolyl cis-trans isomerase', 154, NULL, NULL, 74500),
(74501, '3.30.60.30-FF-000188', NULL, 'Uncharacterized protein', 73, NULL, NULL, 74501),
(74502, '2.60.40.10-FF-000928', NULL, 'Leucine rich repeat, Ig-like and transmembrane domains 1', 78, NULL, NULL, 74502),
(74503, '2.60.40.2070-FF-000005', NULL, 'Outer membrane fimbrial usher protein', 84, NULL, NULL, 74503),
(74504, '3.60.21.10-FF-000276', NULL, 'Serine/threonine-protein phosphatase', 61, NULL, NULL, 74504),
(74505, '3.30.160.60-FF-004942', NULL, NULL, 67, NULL, NULL, 74505),
(74506, '3.30.70.1230-FF-000215', NULL, 'Guanylate cyclase', 104, NULL, NULL, 74506),
(74507, '1.10.287.130-FF-000256', NULL, 'Sensor histidine kinase', 110, NULL, NULL, 74507),
(74508, '2.60.120.650-FF-000052', NULL, 'Predicted protein', 239, NULL, NULL, 74508),
(74509, '1.10.287.470-FF-000009', NULL, 'Multidrug resistance protein MdtN', 31, NULL, NULL, 74509),
(74510, '1.10.472.10-FF-000706', NULL, 'G2/M mitosis-specific cyclin B, copy C-like protein', 87, NULL, NULL, 74510),
(74511, '3.10.20.650-FF-000001', NULL, 'Calmodulin-like protein containing EF hand domain', 109, NULL, NULL, 74511),
(74512, '3.40.50.300-FF-006365', NULL, 'Small GTP-binding protein, putative', 139, NULL, NULL, 74512),
(74513, '3.40.50.1820-FF-001761', NULL, 'Uncharacterized protein', 229, NULL, NULL, 74513);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(74514, '3.90.1640.20-FF-000001', NULL, 'D-glutamate cyclase, mitochondrial', 319, NULL, NULL, 74514),
(74515, '3.30.30.30-FF-000017', NULL, 'Chaperone DnaK', 56, NULL, NULL, 74515),
(74516, '2.40.240.10-FF-000017', NULL, '50S ribosomal protein L25', 95, NULL, NULL, 74516),
(74517, '3.30.360.10-FF-000137', NULL, 'Bifunctional aspartate kinase/homoserine dehydrogenase', 114, NULL, NULL, 74517),
(74518, '3.90.1150.10-FF-000399', NULL, 'Alanine aminotransferase', 51, NULL, NULL, 74518),
(74519, '3.30.420.10-FF-000524', NULL, NULL, 108, NULL, NULL, 74519),
(74520, '2.30.30.490-FF-000090', NULL, 'Uncharacterized protein', 108, NULL, NULL, 74520),
(74521, '1.25.40.70-FF-000081', NULL, 'Zgc:158659', 108, NULL, NULL, 74521),
(74522, '2.60.40.10-FF-001547', NULL, 'Cytokine receptor-like factor 2', 104, NULL, NULL, 74522),
(74523, '3.20.20.80-FF-000627', NULL, 'Uncharacterized protein', 128, NULL, NULL, 74523),
(74524, '3.40.50.1820-FF-000671', NULL, 'Platelet-activating factor acetylhydrolase, isoform II', 339, NULL, NULL, 74524),
(74525, '1.25.40.800-FF-000014', NULL, 'Uncharacterized protein', 160, NULL, NULL, 74525),
(74526, '3.30.930.10-FF-000355', NULL, 'Histidyl-tRNA synthetase-like protein', 326, NULL, NULL, 74526),
(74527, '2.60.40.60-FF-000320', NULL, 'CaDHerin family', 102, NULL, NULL, 74527),
(74528, '2.60.40.10-FF-002840', NULL, 'Protein NBR1 homolog', 121, NULL, NULL, 74528),
(74529, '1.10.3120.10-FF-000018', NULL, NULL, 210, NULL, NULL, 74529),
(74530, '3.40.50.620-FF-000036', NULL, 'Glutamine-dependent NAD(+) synthetase', 370, NULL, NULL, 74530),
(74531, '3.10.20.90-FF-000592', NULL, 'UBX domain-containing protein 2', 142, NULL, NULL, 74531),
(74532, '3.40.50.80-FF-000067', NULL, 'WGS project CABT00000000 data, contig 2.6', 173, NULL, NULL, 74532),
(74533, '1.25.10.10-FF-001567', NULL, 'Predicted protein', 464, NULL, NULL, 74533),
(74534, '1.20.1740.10-FF-000052', NULL, 'Lysine histidine transporter-like 3', 421, NULL, NULL, 74534),
(74535, '1.20.1070.10-FF-000539', NULL, 'GH13988p', 189, NULL, NULL, 74535),
(74536, '1.20.1250.20-FF-001787', NULL, 'Uncharacterized protein', 180, NULL, NULL, 74536),
(74537, '3.30.200.160-FF-000019', NULL, 'Uncharacterized protein', 100, NULL, NULL, 74537),
(74538, '3.40.720.10-FF-000371', NULL, 'Predicted protein', 232, NULL, NULL, 74538),
(74539, '3.30.160.380-FF-000013', NULL, NULL, 82, NULL, NULL, 74539),
(74540, '3.30.160.60-FF-002688', NULL, 'Crooked legs, isoform G', 31, NULL, NULL, 74540),
(74541, '1.25.40.20-FF-001504', NULL, 'Uncharacterized protein', 35, NULL, NULL, 74541),
(74542, '1.10.1270.10-FF-000001', NULL, 'Trp operon repressor', 108, NULL, NULL, 74542),
(74543, '3.40.50.1970-FF-000013', NULL, 'Phosphoribosylaminoimidazole carboxylase', 179, NULL, NULL, 74543),
(74544, '3.30.497.10-FF-000156', NULL, 'Uncharacterized protein', 69, NULL, NULL, 74544),
(74545, '1.10.565.10-FF-000029', NULL, 'Ecdysone-induced protein 75B, isoform B', 267, NULL, NULL, 74545),
(74546, '1.25.40.10-FF-002699', NULL, 'U3 small nucleolar RNA-associated protein 6-domain-containing protein', 130, NULL, NULL, 74546),
(74547, '3.30.1010.10-FF-000015', NULL, 'Serine-protein kinase ATM', 163, NULL, NULL, 74547),
(74548, '3.20.20.140-FF-000048', NULL, 'AraC family transcriptional regulator', 272, NULL, NULL, 74548),
(74549, '3.40.50.150-FF-001374', NULL, NULL, 176, NULL, NULL, 74549),
(74550, '1.20.58.60-FF-000680', NULL, 'Uncharacterized protein', 115, NULL, NULL, 74550),
(74551, '1.10.3470.10-FF-000005', NULL, 'Zinc ABC transporter, permease component', 234, NULL, NULL, 74551),
(74552, '1.10.10.10-FF-002112', NULL, 'Response regulator', 99, NULL, NULL, 74552),
(74553, '2.40.10.220-FF-000002', NULL, 'Flagellar brake protein YcgR', 127, NULL, NULL, 74553),
(74554, '1.10.10.10-FF-001494', NULL, 'Cullin-2', 61, NULL, NULL, 74554),
(74555, '3.40.50.200-FF-000012', NULL, 'Tripeptidyl-peptidase 1 preproprotein', 366, NULL, NULL, 74555),
(74556, '1.20.58.60-FF-000005', NULL, 'Actinin alpha 1', 121, NULL, NULL, 74556),
(74557, '2.60.120.10-FF-000066', NULL, 'Crp/Fnr family transcriptional regulator', 168, NULL, NULL, 74557);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(74558, '1.10.3210.30-FF-000003', NULL, 'CRISPR-associated endonuclease/helicase Cas3', 282, NULL, NULL, 74558),
(74559, '1.10.3430.10-FF-000031', NULL, 'Rh', 452, NULL, NULL, 74559),
(74560, '3.60.10.10-FF-000357', NULL, 'Uncharacterized protein', 143, NULL, NULL, 74560),
(74561, '1.20.1250.20-FF-000618', NULL, 'Sialic acid-transport membrane protein nanT', 210, NULL, NULL, 74561),
(74562, '3.90.226.10-FF-000071', NULL, 'Putative enoyl-CoA hydratase PaaB', 204, NULL, NULL, 74562),
(74563, '1.25.40.10-FF-004065', NULL, 'Dnaj-like protein', 307, NULL, NULL, 74563),
(74564, '1.20.58.60-FF-000477', NULL, 'Spectrin repeat containing nuclear envelope protein 2', 193, NULL, NULL, 74564),
(74565, '3.40.50.300-FF-007854', NULL, 'PeRoXisome assembly factor', 216, NULL, NULL, 74565),
(74566, '2.60.40.10-FF-000586', NULL, 'motile sperm domain-containing protein 2 isoform X2', 122, NULL, NULL, 74566),
(74567, '2.60.40.1170-FF-000090', NULL, NULL, 133, NULL, NULL, 74567),
(74568, '3.30.70.330-FF-002451', NULL, NULL, 85, NULL, NULL, 74568),
(74569, '2.40.10.240-FF-000008', NULL, 'S-adenosylmethionine:tRNA ribosyltransferase-isomerase', 98, NULL, NULL, 74569),
(74570, '1.25.40.20-FF-001651', NULL, 'Oxysterol-binding protein', 88, NULL, NULL, 74570),
(74571, '1.50.40.10-FF-000398', NULL, 'Uncharacterized protein', 225, NULL, NULL, 74571),
(74572, '3.30.710.10-FF-000283', NULL, 'Uncharacterized protein', 114, NULL, NULL, 74572),
(74573, '3.40.190.10-FF-000801', NULL, 'Uncharacterized protein', 91, NULL, NULL, 74573),
(74574, '2.60.260.20-FF-000141', NULL, 'Uncharacterized protein', 70, NULL, NULL, 74574),
(74575, '3.30.2300.10-FF-000009', NULL, 'THUMP domain-containing protein 1', 87, NULL, NULL, 74575),
(74576, '3.20.20.60-FF-000060', NULL, 'Citrate lyase beta chain', 273, NULL, NULL, 74576),
(74577, '2.60.120.10-FF-000408', NULL, 'cGMP-dependent protein kinase', 131, NULL, NULL, 74577),
(74578, '3.40.50.1010-FF-000107', NULL, 'Ribonuclease VapC1', 134, NULL, NULL, 74578),
(74579, '3.40.50.300-FF-002998', NULL, 'UCK2 isoform 5', 91, NULL, NULL, 74579),
(74580, '3.10.20.90-FF-000120', NULL, 'Plexin b1a', 116, NULL, NULL, 74580),
(74581, '1.10.510.10-FF-000706', NULL, 'Cyclin-dependent kinase 1', 210, NULL, NULL, 74581),
(74582, '2.60.120.200-FF-000193', NULL, 'Tyrosine-protein kinase receptor', 193, NULL, NULL, 74582),
(74583, '2.130.10.10-FF-002599', NULL, 'Sema domain, immunoglobulin domain (Ig), short basic domain, secreted, (semaphorin) 3Gb', 436, NULL, NULL, 74583),
(74584, '1.25.40.10-FF-001406', NULL, 'Protein SULFUR DEFICIENCY-INDUCED 2', 104, NULL, NULL, 74584),
(74585, '2.130.10.10-FF-003217', NULL, 'Flagellar associated protein', 326, NULL, NULL, 74585),
(74586, '2.30.30.180-FF-000002', NULL, 'Ribosome maturation factor RimP', 67, NULL, NULL, 74586),
(74587, '3.30.230.10-FF-000133', NULL, 'Mlh3p', 133, NULL, NULL, 74587),
(74588, '3.40.630.30-FF-000403', NULL, 'Cilia- and flagella-associated protein 61', 85, NULL, NULL, 74588),
(74589, '3.80.20.20-FF-000096', NULL, 'Predicted protein', 69, NULL, NULL, 74589),
(74590, '1.20.1250.20-FF-000309', NULL, 'Glucuronide carrier protein', 214, NULL, NULL, 74590),
(74591, '1.10.150.50-FF-000123', NULL, 'Transcription factor ets-4', 88, NULL, NULL, 74591),
(74592, '2.40.50.140-FF-000733', NULL, NULL, 96, NULL, NULL, 74592),
(74593, '3.10.20.80-FF-000004', NULL, 'Translation initiation factor IF-3', 72, NULL, NULL, 74593),
(74594, '2.10.220.10-FF-000169', NULL, 'Tyrosine-protein kinase receptor', 85, NULL, NULL, 74594),
(74595, '1.25.10.10-FF-002894', NULL, 'Uncharacterized protein', 142, NULL, NULL, 74595),
(74596, '1.10.555.10-FF-000203', NULL, NULL, 100, NULL, NULL, 74596),
(74597, '3.30.160.60-FF-002469', NULL, 'Zinc finger protein 322', 24, NULL, NULL, 74597),
(74598, '2.60.120.10-FF-000774', NULL, 'Uncharacterized protein', 45, NULL, NULL, 74598),
(74599, '2.40.50.250-FF-000002', NULL, 'Elongation factor, putative', 89, NULL, NULL, 74599),
(74600, '1.10.10.10-FF-000875', NULL, 'Pre-mRNA-splicing helicase BRR2', 98, NULL, NULL, 74600),
(74601, '1.10.437.10-FF-000007', NULL, 'bcl-2 homologous antagonist/killer', 170, NULL, NULL, 74601);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(74602, '1.20.1070.10-FF-000287', NULL, 'Dopamine receptor D3', 222, NULL, NULL, 74602),
(74603, '3.40.50.300-FF-002874', NULL, 'Elongation factor G, mitochondrial', 294, NULL, NULL, 74603),
(74604, '2.40.50.140-FF-000205', NULL, 'Breast cancer susceptibility protein 2', 130, NULL, NULL, 74604),
(74605, '1.10.357.140-FF-000006', NULL, 'Protoheme IX farnesyltransferase, mitochondrial', 156, NULL, NULL, 74605),
(74606, '1.25.40.20-FF-000015', NULL, 'calmodulin-binding transcription activator 2 isoform X1', 131, NULL, NULL, 74606),
(74607, '1.10.150.240-FF-000065', NULL, 'Phosphoglycolate phosphatase', 71, NULL, NULL, 74607),
(74608, '3.60.15.10-FF-000109', NULL, 'Bifunctional adenosylcobinamide kinase/adenosylcobinamide-phosphate guanylyltransferase', 77, NULL, NULL, 74608),
(74609, '3.30.300.30-FF-000100', NULL, 'Nonribosomal peptide synthetase 13', 122, NULL, NULL, 74609),
(74610, '3.40.710.10-FF-000090', NULL, 'Penicillin-binding protein 2', 383, NULL, NULL, 74610),
(74611, '2.40.70.10-FF-000561', NULL, NULL, 120, NULL, NULL, 74611),
(74612, '3.30.70.330-FF-001271', NULL, 'RNP domain protein (AFU_orthologue AFUA_6G12300)', 136, NULL, NULL, 74612),
(74613, '3.40.50.12780-FF-000130', NULL, 'Uncharacterized protein', 430, NULL, NULL, 74613),
(74614, '1.10.150.870-FF-000001', NULL, 'DNA polymerase III subunit alpha', 174, NULL, NULL, 74614),
(74615, '3.30.70.580-FF-000036', NULL, 'Pseudouridylate synthase-like protein', 130, NULL, NULL, 74615),
(74616, '3.30.465.10-FF-000021', NULL, 'Cytokinin dehydrogenase 1', 125, NULL, NULL, 74616),
(74617, '3.40.570.10-FF-000010', NULL, 'DNA/RNA non-specific endonuclease', 245, NULL, NULL, 74617),
(74618, '3.30.420.10-FF-000272', NULL, 'CCR4-NOT transcription complex subunit 8', 252, NULL, NULL, 74618),
(74619, '2.60.40.10-FF-001295', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', 109, NULL, NULL, 74619),
(74620, '1.20.5.170-FF-000132', NULL, 'BZIP transcription factor family', 60, NULL, NULL, 74620),
(74621, '1.25.40.180-FF-000249', NULL, NULL, 79, NULL, NULL, 74621),
(74622, '2.60.40.150-FF-000275', NULL, 'Phosphatidylinositol 3-kinase VPS34', 135, NULL, NULL, 74622),
(74623, '3.40.50.1820-FF-000125', NULL, 'Carboxypeptidase', 469, NULL, NULL, 74623),
(74624, '1.10.860.10-FF-000007', NULL, 'DNA primase', 142, NULL, NULL, 74624),
(74625, '3.40.390.10-FF-000148', NULL, 'Lethal factor', 222, NULL, NULL, 74625),
(74626, '3.30.230.70-FF-000089', NULL, 'Uncharacterized protein', 65, NULL, NULL, 74626),
(74627, '3.30.40.10-FF-000198', NULL, 'PHD finger protein 19', 53, NULL, NULL, 74627),
(74628, '3.30.160.60-FF-003453', NULL, NULL, 26, NULL, NULL, 74628),
(74629, '2.160.20.10-FF-000029', NULL, 'Pectinesterase 4', 314, NULL, NULL, 74629),
(74630, '2.70.170.10-FF-000185', NULL, 'Uncharacterized protein', 217, NULL, NULL, 74630),
(74631, '3.80.10.10-FF-000733', NULL, 'F-box/LRR-repeat protein 16', 136, NULL, NULL, 74631),
(74632, '3.40.50.620-FF-000582', NULL, 'Isoleucine--tRNA ligase, mitochondrial', 206, NULL, NULL, 74632),
(74633, '3.30.70.270-FF-000281', NULL, NULL, 104, NULL, NULL, 74633),
(74634, '2.130.10.10-FF-003402', NULL, 'Sortilin', 202, NULL, NULL, 74634),
(74635, '3.30.160.360-FF-000018', NULL, 'Histone-lysine N-methyltransferase', 76, NULL, NULL, 74635),
(74636, '3.10.20.620-FF-000003', NULL, 'Autophagy protein 5', 141, NULL, NULL, 74636),
(74637, '2.40.10.10-FF-000585', NULL, NULL, 42, NULL, NULL, 74637),
(74638, '1.20.140.10-FF-000136', NULL, 'Acyl-CoA dehydrogenase, putative', 54, NULL, NULL, 74638),
(74639, '2.40.50.140-FF-001133', NULL, NULL, 70, NULL, NULL, 74639),
(74640, '2.40.70.10-FF-000252', NULL, 'Aspartic proteinase nepenthesin-2', 195, NULL, NULL, 74640),
(74641, '1.25.10.10-FF-002186', NULL, 'Uncharacterized protein', 456, NULL, NULL, 74641),
(74642, '3.30.160.60-FF-003306', NULL, 'Zinc finger and SCAN domain-containing protein 10', 35, NULL, NULL, 74642),
(74643, '1.10.375.10-FF-000003', NULL, 'Gag polyprotein', 175, NULL, NULL, 74643),
(74644, '3.90.850.10-FF-000015', NULL, '2-keto-4-pentenoate hydratase', 260, NULL, NULL, 74644);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(74645, '2.60.120.260-FF-000058', NULL, 'Beta-galactosidase', 214, NULL, NULL, 74645),
(74646, '2.40.50.140-FF-000424', NULL, 'Unplaced genomic scaffold supercont1.10, whole genome shotgun sequence', 92, NULL, NULL, 74646),
(74647, '2.40.50.140-FF-000172', NULL, 'Sugar ABC transporter, ATP-binding protein', 43, NULL, NULL, 74647),
(74648, '3.30.420.40-FF-000628', NULL, 'Uncharacterized protein', 74, NULL, NULL, 74648),
(74649, '3.30.420.40-FF-000376', NULL, 'Hexokinase 1', 98, NULL, NULL, 74649),
(74650, '3.30.559.10-FF-000273', NULL, 'Os05g0250500 protein', 128, NULL, NULL, 74650),
(74651, '2.70.98.110-FF-000017', NULL, NULL, 258, NULL, NULL, 74651),
(74652, '2.30.42.10-FF-000547', NULL, NULL, 87, NULL, NULL, 74652),
(74653, '3.30.40.10-FF-001400', NULL, 'Histone-lysine N-methyltransferase', 107, NULL, NULL, 74653),
(74654, '3.40.50.10190-FF-000314', NULL, 'Uncharacterized protein', 94, NULL, NULL, 74654),
(74655, '1.10.533.10-FF-000023', NULL, 'DNA-binding death effector domain-containing protein 2', 91, NULL, NULL, 74655),
(74656, '3.20.20.70-FF-000748', NULL, NULL, 67, NULL, NULL, 74656),
(74657, '1.25.40.20-FF-000690', NULL, 'ANKS1B isoform 5', 160, NULL, NULL, 74657),
(74658, '1.20.5.470-FF-000008', NULL, 'Argininosuccinate synthase', 41, NULL, NULL, 74658),
(74659, '1.10.287.70-FF-000513', NULL, 'Uncharacterized protein', 250, NULL, NULL, 74659),
(74660, '3.30.1490.100-FF-000035', NULL, 'Related to DNA polymerase eta', 110, NULL, NULL, 74660),
(74661, '3.40.1190.20-FF-000141', NULL, 'Uncharacterized protein', 322, NULL, NULL, 74661),
(74662, '2.10.110.10-FF-000178', NULL, 'LIM domain family', 57, NULL, NULL, 74662),
(74663, '3.20.20.80-FF-000285', NULL, 'Klotho', 234, NULL, NULL, 74663),
(74664, '1.25.40.10-FF-003879', NULL, 'Uncharacterized protein', 86, NULL, NULL, 74664),
(74665, '3.10.28.10-FF-000035', NULL, 'Laglidadg endonuclease', 133, NULL, NULL, 74665),
(74666, '2.120.10.30-FF-000278', NULL, 'Lipoprotein receptor', 330, NULL, NULL, 74666),
(74667, '3.90.20.20-FF-000011', NULL, 'GrpE protein homolog', 118, NULL, NULL, 74667),
(74668, '3.40.50.1820-FF-000339', NULL, 'Lipase, putative', 232, NULL, NULL, 74668),
(74669, '2.60.120.260-FF-000390', NULL, 'discoidin domain-containing receptor 2 isoform X1', 174, NULL, NULL, 74669),
(74670, '3.10.250.10-FF-000122', NULL, NULL, 45, NULL, NULL, 74670),
(74671, '3.40.50.720-FF-002079', NULL, 'Uncharacterized protein', 144, NULL, NULL, 74671),
(74672, '2.40.50.140-FF-000880', NULL, NULL, 114, NULL, NULL, 74672),
(74673, '3.40.50.1580-FF-000019', NULL, 'Uridine phosphorylase', 238, NULL, NULL, 74673),
(74674, '3.40.50.300-FF-003706', NULL, 'Uncharacterized protein', 144, NULL, NULL, 74674),
(74675, '3.90.70.10-FF-000101', NULL, 'Ubiquitin specific peptidase 40', 62, NULL, NULL, 74675),
(74676, '3.30.2290.10-FF-000013', NULL, 'Putative modulator of DNA gyrase', 225, NULL, NULL, 74676),
(74677, '3.30.360.20-FF-000016', NULL, NULL, 101, NULL, NULL, 74677),
(74678, '4.10.320.10-FF-000023', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 57, NULL, NULL, 74678),
(74679, '3.80.10.10-FF-003953', NULL, 'Uncharacterized protein', 65, NULL, NULL, 74679),
(74680, '2.160.20.10-FF-000338', NULL, 'Uncharacterized protein', 304, NULL, NULL, 74680),
(74681, '3.40.50.620-FF-000800', NULL, 'Uncharacterized protein', 110, NULL, NULL, 74681),
(74682, '1.20.1250.20-FF-000641', NULL, 'MFS transporter, SHS family, lactate transporter', 217, NULL, NULL, 74682),
(74683, '1.20.5.190-FF-000138', NULL, NULL, 48, NULL, NULL, 74683),
(74684, '2.60.40.10-FF-003801', NULL, NULL, 106, NULL, NULL, 74684),
(74685, '3.30.1120.10-FF-000006', NULL, 'Arylsulfatase G', 76, NULL, NULL, 74685),
(74686, '1.10.405.10-FF-000001', NULL, 'Rab GDP dissociation inhibitor', 105, NULL, NULL, 74686),
(74687, '1.20.58.1120-FF-000062', NULL, NULL, 124, NULL, NULL, 74687),
(74688, '1.10.10.10-FF-001151', NULL, 'Interferon regulatory factor 8', 62, NULL, NULL, 74688),
(74689, '3.40.1350.60-FF-000002', NULL, 'Sugar fermentation stimulation protein homolog', 152, NULL, NULL, 74689);
INSERT INTO "PUBLIC"."MODEL" VALUES
(74690, '3.40.50.300-FF-006926', NULL, 'Uncharacterized protein', 232, NULL, NULL, 74690),
(74691, '1.10.472.80-FF-000104', NULL, 'Uncharacterized protein', 161, NULL, NULL, 74691),
(74692, '3.90.70.10-FF-000410', NULL, 'Putative cysteine protease RD19C', 135, NULL, NULL, 74692),
(74693, '3.30.420.40-FF-000937', NULL, 'Actin-42A-like Protein', 81, NULL, NULL, 74693),
(74694, '3.30.413.10-FF-000013', NULL, 'Sulfite reductase [ferredoxin]', 143, NULL, NULL, 74694),
(74695, '3.20.20.80-FF-000594', NULL, 'LYSozyme', 201, NULL, NULL, 74695),
(74696, '1.10.8.720-FF-000030', NULL, 'GD21850', 167, NULL, NULL, 74696),
(74697, '3.40.5.60-FF-000002', NULL, 'DNA replication complex GINS protein SLD5', 74, NULL, NULL, 74697),
(74698, '1.25.40.20-FF-000324', NULL, 'Ankyrin repeat domain 53', 249, NULL, NULL, 74698),
(74699, '3.30.1540.20-FF-000013', NULL, 'DNA mismatch repair protein MLH3', 99, NULL, NULL, 74699),
(74700, '1.25.10.10-FF-002747', NULL, 'Uncharacterized protein', 735, NULL, NULL, 74700),
(74701, '2.20.130.10-FF-000002', NULL, 'Uncharacterized protein', 60, NULL, NULL, 74701),
(74702, '2.30.42.10-FF-000333', NULL, 'Membrane-associated guanylate kinase, WW and PDZ domain-containing protein', 106, NULL, NULL, 74702),
(74703, '1.10.575.10-FF-000002', NULL, 'Endonuclease 2', 270, NULL, NULL, 74703),
(74704, '3.30.1120.90-FF-000002', NULL, 'Testis-specific Y-encoded-like protein 2', 145, NULL, NULL, 74704),
(74705, '2.60.40.720-FF-000007', NULL, 'Cellular tumor antigen p53', 135, NULL, NULL, 74705),
(74706, '2.60.40.420-FF-000024', NULL, 'FET5p Multicopper oxidase', 192, NULL, NULL, 74706),
(74707, '3.30.40.10-FF-002013', NULL, 'Putative E3 ubiquitin-protein ligase UNKL', 48, NULL, NULL, 74707),
(74708, '2.20.25.20-FF-000005', NULL, 'RBR-type E3 ubiquitin transferase', 45, NULL, NULL, 74708),
(74709, '2.30.29.30-FF-000921', NULL, 'Predicted protein', 245, NULL, NULL, 74709),
(74710, '3.40.50.620-FF-000351', NULL, 'Cholinephosphate cytidylyltransferase A, putative', 160, NULL, NULL, 74710),
(74711, '2.40.50.60-FF-000001', NULL, 'Antifungal protein', 54, NULL, NULL, 74711),
(74712, '3.80.10.10-FF-000626', NULL, 'Leucine-rich repeat receptor protein kinase MSP1', 208, NULL, NULL, 74712),
(74713, '3.90.850.10-FF-000026', NULL, '2-keto-4-pentenoate hydratase', 259, NULL, NULL, 74713),
(74714, '3.40.50.150-FF-000547', NULL, 'Malonyl-[acyl-carrier protein] O-methyltransferase', 238, NULL, NULL, 74714),
(74715, '2.60.40.10-FF-003228', NULL, 'Interferon alpha and beta receptor subunit 2', 97, NULL, NULL, 74715),
(74716, '3.40.50.10900-FF-000027', NULL, 'Clast3-related', 65, NULL, NULL, 74716),
(74717, '3.30.200.20-FF-001242', NULL, 'Lectin-domain containing receptor kinase A4.3', 90, NULL, NULL, 74717),
(74718, '4.10.240.10-FF-000062', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 81, NULL, NULL, 74718),
(74719, '1.10.418.10-FF-000183', NULL, 'Neuron navigator 3', 132, NULL, NULL, 74719),
(74720, '3.30.160.60-FF-004285', NULL, NULL, 33, NULL, NULL, 74720),
(74721, '1.10.3090.10-FF-000032', NULL, 'Uncharacterized protein', 241, NULL, NULL, 74721),
(74722, '1.10.238.10-FF-000989', NULL, 'AGAP012066-PA', 198, NULL, NULL, 74722),
(74723, '3.40.50.1010-FF-000074', NULL, 'Ribonuclease VapC', 131, NULL, NULL, 74723),
(74724, '2.20.100.10-FF-000063', NULL, 'Thrombospondin type 1 domain containing 7B', 72, NULL, NULL, 74724),
(74725, '1.10.287.70-FF-000732', NULL, 'Predicted protein', 118, NULL, NULL, 74725),
(74726, '3.30.9.10-FF-000131', NULL, 'FAD dependent oxidoreductase', 89, NULL, NULL, 74726),
(74727, '1.10.20.10-FF-000168', NULL, 'Nuclear transcription factor Y subunit beta', 94, NULL, NULL, 74727),
(74728, '3.40.50.2300-FF-000949', NULL, NULL, 135, NULL, NULL, 74728),
(74729, '2.60.220.30-FF-000006', NULL, 'Unc-5 netrin receptor D', 151, NULL, NULL, 74729),
(74730, '2.60.40.60-FF-000005', NULL, 'Protocadherin 9', 108, NULL, NULL, 74730),
(74731, '2.102.10.10-FF-000026', NULL, 'mRNA, clone: RTFL01-01-M20', 143, NULL, NULL, 74731),
(74732, '1.25.40.1040-FF-000049', NULL, 'Uncharacterized protein', 33, NULL, NULL, 74732);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(74733, '3.40.50.720-FF-001123', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', 178, NULL, NULL, 74733),
(74734, '1.20.900.10-FF-000116', NULL, 'Rho guanine nucleotide exchange factor gef2', 228, NULL, NULL, 74734),
(74735, '1.10.10.1180-FF-000008', NULL, 'Uncharacterized protein', 90, NULL, NULL, 74735),
(74736, '3.40.1000.50-FF-000024', NULL, 'Uncharacterized protein', 140, NULL, NULL, 74736),
(74737, '2.40.50.640-FF-000001', NULL, 'Exoribonuclease 2', 73, NULL, NULL, 74737),
(74738, '3.40.50.1820-FF-000783', NULL, 'Alpha/beta hydrolase fold protein', 245, NULL, NULL, 74738),
(74739, '1.20.1250.20-FF-002086', NULL, 'Uncharacterized protein', 267, NULL, NULL, 74739),
(74740, '3.40.50.720-FF-000504', NULL, 'Siroheme synthase, putative', 140, NULL, NULL, 74740),
(74741, '3.30.710.10-FF-000266', NULL, 'ETO1-like protein 1', 146, NULL, NULL, 74741),
(74742, '1.20.58.60-FF-000258', NULL, 'Spectrin alpha chain', 212, NULL, NULL, 74742),
(74743, '2.130.10.10-FF-004830', NULL, 'Katanin p80 WD40 repeat-containing subunit B1 homolog', 134, NULL, NULL, 74743),
(74744, '3.40.50.80-FF-000044', NULL, 'Ring-1,2-phenylacetyl-CoA epoxidase subunit PaaE', 139, NULL, NULL, 74744),
(74745, '1.10.1450.10-FF-000099', NULL, 'Tetraspanin', 101, NULL, NULL, 74745),
(74746, '3.30.450.20-FF-000445', NULL, 'Sporulation kinase A', 122, NULL, NULL, 74746),
(74747, '3.40.50.2000-FF-000966', NULL, 'Mannosyltransferase B', 96, NULL, NULL, 74747),
(74748, '2.10.70.10-FF-000253', NULL, 'Uncharacterized protein', 73, NULL, NULL, 74748),
(74749, '1.20.120.230-FF-000060', NULL, 'Probable vinculin', 97, NULL, NULL, 74749),
(74750, '3.10.20.90-FF-000816', NULL, 'Uncharacterized protein', 42, NULL, NULL, 74750),
(74751, '3.30.230.10-FF-000122', NULL, 'Mevalonate kinase', 226, NULL, NULL, 74751),
(74752, '1.25.10.10-FF-002972', NULL, 'AGAP002100-PA', 408, NULL, NULL, 74752),
(74753, '3.40.1390.10-FF-000001', NULL, 'UDP-3-O-(3-hydroxymyristoyl)glucosamine N-acyltransferase', 99, NULL, NULL, 74753),
(74754, '1.25.40.20-FF-001280', NULL, 'Predicted protein', 178, NULL, NULL, 74754),
(74755, '3.40.50.300-FF-003487', NULL, 'Dynein heavy chain 9, axonemal', 113, NULL, NULL, 74755),
(74756, '3.40.50.720-FF-002551', NULL, 'Glutamyl-tRNA reductase', 66, NULL, NULL, 74756),
(74757, '3.30.160.60-FF-000440', NULL, 'E3 ubiquitin-protein ligase TRIM23', 76, NULL, NULL, 74757),
(74758, '1.20.120.160-FF-000010', NULL, 'Phosphorelay intermediate protein YPD1', 167, NULL, NULL, 74758),
(74759, '3.30.420.40-FF-000836', NULL, 'Phosphotransferase', 181, NULL, NULL, 74759),
(74760, '3.30.70.330-FF-000534', NULL, 'Pre-rRNA-processing protein ESF2', 139, NULL, NULL, 74760),
(74761, '2.60.40.10-FF-002823', NULL, 'Gingipain R1', 61, NULL, NULL, 74761),
(74762, '1.25.40.10-FF-004609', NULL, 'Cell division cycle protein 27 homolog', 164, NULL, NULL, 74762),
(74763, '2.40.70.10-FF-000465', NULL, NULL, 173, NULL, NULL, 74763),
(74764, '3.40.1810.10-FF-000023', NULL, 'MADS-box protein-like', 74, NULL, NULL, 74764),
(74765, '2.10.25.10-FF-000401', NULL, 'von Willebrand factor C and EGF domain-containing protein', 40, NULL, NULL, 74765),
(74766, '1.20.120.720-FF-000009', NULL, 'Unconventional myosin-Id', 107, NULL, NULL, 74766),
(74767, '2.60.40.10-FF-000895', NULL, 'NPHS1, nephrin', 97, NULL, NULL, 74767),
(74768, '3.80.10.10-FF-002655', NULL, 'Uncharacterized protein', 67, NULL, NULL, 74768),
(74769, '3.90.980.20-FF-000016', NULL, 'Uncharacterized protein', 126, NULL, NULL, 74769),
(74770, '1.10.8.60-FF-000007', NULL, '26S proteasome regulatory subunit 4', 77, NULL, NULL, 74770),
(74771, '3.90.550.50-FF-000195', NULL, 'Hexosyltransferase', 195, NULL, NULL, 74771),
(74772, '3.90.1150.10-FF-000051', NULL, 'Probable gamma-aminobutyrate transaminase 3, mitochondrial', 134, NULL, NULL, 74772),
(74773, '3.40.50.300-FF-005415', NULL, 'ABC transporter A family member 7', 156, NULL, NULL, 74773),
(74774, '1.10.10.60-FF-000536', NULL, 'SWR1-complex protein 4', 116, NULL, NULL, 74774),
(74775, '1.10.220.60-FF-000002', NULL, 'Golgin subfamily A member 1', 59, NULL, NULL, 74775); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(74776, '3.30.300.180-FF-000003', NULL, 'Chromosomal replication initiator protein DnaA', 79, NULL, NULL, 74776),
(74777, '1.25.40.10-FF-005133', NULL, 'Uncharacterized protein', 102, NULL, NULL, 74777),
(74778, '1.25.10.10-FF-001253', NULL, 'Protein CLASP-2', 227, NULL, NULL, 74778),
(74779, '3.30.2090.10-FF-000020', NULL, 'RND multidrug efflux transporter', 94, NULL, NULL, 74779),
(74780, '3.30.40.210-FF-000015', NULL, 'Transcription elongation factor SPT4', 110, NULL, NULL, 74780),
(74781, '2.40.40.20-FF-000062', NULL, 'Periplasmically oriented, membrane-bound formate dehydrogenase, major subunit, selenocysteine-containing', 172, NULL, NULL, 74781),
(74782, '2.30.30.870-FF-000012', NULL, NULL, 57, NULL, NULL, 74782),
(74783, '3.40.50.1820-FF-001300', NULL, 'Uncharacterized protein', 274, NULL, NULL, 74783),
(74784, '2.130.10.10-FF-000547', NULL, 'Cilia- and flagella-associated protein 44', 233, NULL, NULL, 74784),
(74785, '3.40.50.920-FF-000008', NULL, 'transketolase isoform X2', 133, NULL, NULL, 74785),
(74786, '3.30.1230.20-FF-000012', NULL, '40S ribosomal protein S21', 81, NULL, NULL, 74786),
(74787, '3.40.190.10-FF-000705', NULL, 'Leucyl aminopeptidase', 111, NULL, NULL, 74787),
(74788, '3.90.550.50-FF-000206', NULL, 'Uncharacterized protein', 168, NULL, NULL, 74788),
(74789, '3.30.470.10-FF-000016', NULL, 'Class IV aminotransferase', 113, NULL, NULL, 74789),
(74790, '3.40.50.300-FF-000744', NULL, 'intron-binding protein aquarius isoform X1', 244, NULL, NULL, 74790),
(74791, '3.90.20.20-FF-000028', NULL, 'Putative co-chaperone, GrpE', 121, NULL, NULL, 74791),
(74792, '2.60.40.1230-FF-000006', NULL, 'AP-1 complex subunit gamma', 139, NULL, NULL, 74792),
(74793, '1.20.1460.10-FF-000007', NULL, 'V-type proton ATPase subunit C', 144, NULL, NULL, 74793),
(74794, '1.10.260.40-FF-000004', NULL, 'Cut-like homeobox 1a', 89, NULL, NULL, 74794),
(74795, '1.10.8.10-FF-000346', NULL, 'Inhibitor of apoptosis protein 1 and 2, iap1, iap2, putative', 19, NULL, NULL, 74795),
(74796, '3.90.45.10-FF-000009', NULL, 'Peptide deformylase', 132, NULL, NULL, 74796),
(74797, '3.30.1010.10-FF-000144', NULL, 'UVSB PI-3 kinase, putative', 130, NULL, NULL, 74797),
(74798, '2.30.140.10-FF-000001', NULL, 'SPE3p Spermidine synthase', 65, NULL, NULL, 74798),
(74799, '3.10.450.50-FF-000099', NULL, 'Uncharacterized protein', 80, NULL, NULL, 74799),
(74800, '1.20.1540.10-FF-000059', NULL, 'Rhomboid 5 homolog 2', 95, NULL, NULL, 74800),
(74801, '3.30.70.330-FF-002900', NULL, NULL, 48, NULL, NULL, 74801),
(74802, '3.90.70.10-FF-000545', NULL, 'Uncharacterized protein', 221, NULL, NULL, 74802),
(74803, '1.10.1410.20-FF-000010', NULL, '2''-5''-oligoadenylate synthase 3', 147, NULL, NULL, 74803),
(74804, '1.25.40.10-FF-002148', NULL, 'Pentatricopeptide repeat-containing protein At2g29760, chloroplastic', 262, NULL, NULL, 74804),
(74805, '3.20.20.140-FF-000155', NULL, 'D-glutamate deacylase', 296, NULL, NULL, 74805),
(74806, '3.40.50.2300-FF-000045', NULL, 'HTH-type transcriptional repressor PurR', 132, NULL, NULL, 74806),
(74807, '3.30.70.330-FF-000181', NULL, 'RNA binding motif protein 15', 75, NULL, NULL, 74807),
(74808, '2.60.220.50-FF-000113', NULL, 'Uncharacterized protein', 98, NULL, NULL, 74808),
(74809, '3.50.50.60-FF-000656', NULL, 'FAD/NAD(P)-binding domain-containing protein', 275, NULL, NULL, 74809),
(74810, '3.80.10.10-FF-004212', NULL, 'Uncharacterized protein', 87, NULL, NULL, 74810),
(74811, '3.80.10.10-FF-004100', NULL, 'Uncharacterized protein', 120, NULL, NULL, 74811),
(74812, '1.20.1150.12-FF-000003', NULL, 'Protein disulfide isomerase, putative', 101, NULL, NULL, 74812),
(74813, '3.20.20.140-FF-000043', NULL, 'Amidohydrolase family protein', 331, NULL, NULL, 74813),
(74814, '2.10.110.10-FF-000043', NULL, 'protein-methionine sulfoxide oxidase MICAL3 isoform X2', 77, NULL, NULL, 74814),
(74815, '1.10.800.10-FF-000009', NULL, 'Tyrosine/tryptophan monooxygenase, putative', 147, NULL, NULL, 74815),
(74816, '3.40.50.11500-FF-000005', NULL, 'DENN domain containing 5A', 161, NULL, NULL, 74816),
(74817, '3.30.160.60-FF-005223', NULL, NULL, 36, NULL, NULL, 74817);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(74818, '1.20.5.300-FF-000003', NULL, 'Spike glycoprotein', 142, NULL, NULL, 74818),
(74819, '3.40.720.10-FF-000056', NULL, 'Phosphatidylinositol glycan, class O', 212, NULL, NULL, 74819),
(74820, '3.30.160.60-FF-000923', NULL, 'E3 ubiquitin-protein ligase TRIM71', 123, NULL, NULL, 74820),
(74821, '2.60.40.60-FF-000909', NULL, 'Uncharacterized protein', 145, NULL, NULL, 74821),
(74822, '3.40.50.880-FF-000187', NULL, 'Cyanophycinase', 268, NULL, NULL, 74822),
(74823, '1.10.510.10-FF-003444', NULL, NULL, 280, NULL, NULL, 74823),
(74824, '2.40.50.90-FF-000111', NULL, 'Tudor domain containing 12', 72, NULL, NULL, 74824),
(74825, '3.20.20.80-FF-000835', NULL, 'Uncharacterized protein', 39, NULL, NULL, 74825),
(74826, '3.40.50.300-FF-008158', NULL, 'Uncharacterized protein', 90, NULL, NULL, 74826),
(74827, '1.10.510.10-FF-003556', NULL, NULL, 226, NULL, NULL, 74827),
(74828, '1.10.287.470-FF-000004', NULL, 'UPF0194 membrane protein YbhG', 67, NULL, NULL, 74828),
(74829, '2.60.40.10-FF-001412', NULL, 'Plexin A1a', 105, NULL, NULL, 74829),
(74830, '3.30.70.330-FF-002788', NULL, NULL, 51, NULL, NULL, 74830),
(74831, '2.130.10.10-FF-003532', NULL, 'F-box/wd-repeat protein lin-23, putative', 207, NULL, NULL, 74831),
(74832, '3.40.50.410-FF-000322', NULL, 'Uncharacterized protein', 295, NULL, NULL, 74832),
(74833, '3.40.1280.10-FF-000009', NULL, 'tRNA (guanosine(18)-2''-O)-methyltransferase', 204, NULL, NULL, 74833),
(74834, '2.60.40.10-FF-001300', NULL, 'protein-glutamine gamma-glutamyltransferase Z', 119, NULL, NULL, 74834),
(74835, '3.90.1480.20-FF-000022', NULL, 'ST3 beta-galactoside alpha-2,3-sialyltransferase 1', 235, NULL, NULL, 74835),
(74836, '2.60.40.10-FF-002609', NULL, 'Chitinase', 90, NULL, NULL, 74836),
(74837, '1.20.1560.10-FF-000594', NULL, 'ABC transporter, putative', 141, NULL, NULL, 74837),
(74838, '3.30.160.60-FF-001963', NULL, 'Replication initiator 1', 30, NULL, NULL, 74838),
(74839, '3.30.420.140-FF-000001', NULL, 'RNA-binding transcriptional accessory protein', 129, NULL, NULL, 74839),
(74840, '3.60.130.10-FF-000023', NULL, 'Pyoverdine chromophore biosynthetic protein PvcA', 258, NULL, NULL, 74840),
(74841, '2.40.50.140-FF-000868', NULL, NULL, 138, NULL, NULL, 74841),
(74842, '3.30.420.110-FF-000037', NULL, 'DNA mismatch repair protein spellchecker 1', 170, NULL, NULL, 74842),
(74843, '1.20.1510.10-FF-000091', NULL, NULL, 215, NULL, NULL, 74843),
(74844, '2.60.40.10-FF-002031', NULL, 'Protein tyrosine phosphatase, receptor type B', 75, NULL, NULL, 74844),
(74845, '1.10.750.20-FF-000002', NULL, 'Suppressor of cytokine signaling 2', 35, NULL, NULL, 74845),
(74846, '3.30.870.10-FF-000108', NULL, 'Phospholipase D', 250, NULL, NULL, 74846),
(74847, '2.120.10.30-FF-000418', NULL, 'Predicted protein', 178, NULL, NULL, 74847),
(74848, '2.120.10.80-FF-000377', NULL, 'Uncharacterized protein', 151, NULL, NULL, 74848),
(74849, '2.60.34.10-FF-000061', NULL, 'DnaK protein', 181, NULL, NULL, 74849),
(74850, '3.40.50.300-FF-001233', NULL, 'Probable ATP-dependent RNA helicase DDX58', 151, NULL, NULL, 74850),
(74851, '2.130.10.10-FF-002576', NULL, 'DNA damage-binding protein 1', 341, NULL, NULL, 74851),
(74852, '1.10.287.370-FF-000058', NULL, 'RNA polymerase II subunit 5-mediating protein homolog', 128, NULL, NULL, 74852),
(74853, '1.10.150.240-FF-000060', NULL, 'Hydrolase', 71, NULL, NULL, 74853),
(74854, '3.30.200.20-FF-000623', NULL, 'L-type lectin-domain containing receptor kinase IV.1', 92, NULL, NULL, 74854),
(74855, '2.60.40.1670-FF-000003', NULL, 'Protein transport protein SEC23', 163, NULL, NULL, 74855),
(74856, '3.30.40.10-FF-001496', NULL, 'Zn-finger domain protein, putative', 78, NULL, NULL, 74856),
(74857, '4.10.280.10-FF-000171', NULL, 'Basic helix-loop-helix family protein', 79, NULL, NULL, 74857),
(74858, '1.10.287.3700-FF-000007', NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', 80, NULL, NULL, 74858),
(74859, '2.30.180.10-FF-000110', NULL, NULL, 154, NULL, NULL, 74859),
(74860, '3.30.430.20-FF-000011', NULL, 'Cysteine-rich repeat secretory protein 15', 95, NULL, NULL, 74860);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(74861, '2.10.25.10-FF-000289', NULL, 'Slit guidance ligand 2', 41, NULL, NULL, 74861),
(74862, '3.40.50.1000-FF-000554', NULL, NULL, 166, NULL, NULL, 74862),
(74863, '1.10.10.60-FF-000199', NULL, 'Activity-dependent neuroprotector homeobox b', 56, NULL, NULL, 74863),
(74864, '2.30.30.190-FF-000022', NULL, 'Tubulin-specific chaperone B', 96, NULL, NULL, 74864),
(74865, '1.10.630.10-FF-000165', NULL, 'Cytochrome P450, family 2, subfamily Y, polypeptide 3', 334, NULL, NULL, 74865),
(74866, '2.130.10.10-FF-001166', NULL, 'WD repeat protein (AFU_orthologue AFUA_4G09620)', 401, NULL, NULL, 74866),
(74867, '3.90.650.10-FF-000045', NULL, 'Predicted protein', 180, NULL, NULL, 74867),
(74868, '2.40.70.10-FF-000353', NULL, NULL, 146, NULL, NULL, 74868),
(74869, '1.10.30.10-FF-000096', NULL, 'Chromodomain helicase DNA binding protein 3', 65, NULL, NULL, 74869),
(74870, '2.60.120.920-FF-000060', NULL, 'Tripartite motif containing 39', 80, NULL, NULL, 74870),
(74871, '3.30.70.420-FF-000005', NULL, '3-hydroxy-3-methylglutaryl-CoA reductase a', 49, NULL, NULL, 74871),
(74872, '3.30.870.10-FF-000097', NULL, 'Uncharacterized protein', 174, NULL, NULL, 74872),
(74873, '1.20.920.10-FF-000230', NULL, 'SNF2 family N-terminal domain containing protein', 142, NULL, NULL, 74873),
(74874, '2.30.30.100-FF-000017', NULL, 'Small nuclear ribonucleoprotein G', 76, NULL, NULL, 74874),
(74875, '1.10.150.20-FF-000024', NULL, 'DNA polymerase gamma, catalytic subunit', 102, NULL, NULL, 74875),
(74876, '1.10.238.10-FF-000197', NULL, 'probable calcium-binding protein CML21', 198, NULL, NULL, 74876),
(74877, '2.60.120.200-FF-000518', NULL, 'Uncharacterized protein', 232, NULL, NULL, 74877),
(74878, '3.40.50.620-FF-000722', NULL, 'Uncharacterized protein', 206, NULL, NULL, 74878),
(74879, '1.10.10.60-FF-001155', NULL, NULL, 52, NULL, NULL, 74879),
(74880, '3.30.460.10-FF-000061', NULL, 'Poly(A) RNA polymerase gld-2', 120, NULL, NULL, 74880),
(74881, '1.20.58.80-FF-000005', NULL, 'ribosomal protein S6 kinase delta-1 isoform X1', 78, NULL, NULL, 74881),
(74882, '3.90.1230.10-FF-000001', NULL, 'Nitric oxide synthase, brain', 89, NULL, NULL, 74882),
(74883, '1.10.1410.10-FF-000102', NULL, 'DNA polymerase sigma-like protein', 13, NULL, NULL, 74883),
(74884, '3.20.110.10-FF-000020', NULL, 'Alpha-mannosidase', 281, NULL, NULL, 74884),
(74885, '1.10.472.10-FF-000696', NULL, 'Cyclin-D2-1', 91, NULL, NULL, 74885),
(74886, '1.10.506.10-FF-000011', NULL, 'Ras GTPase-activating protein 2 isoform 3', 218, NULL, NULL, 74886),
(74887, '2.60.200.30-FF-000011', NULL, 'NAD kinase', 137, NULL, NULL, 74887),
(74888, '3.40.50.1580-FF-000008', NULL, 'S-methyl-5''-thioadenosine phosphorylase', 304, NULL, NULL, 74888),
(74889, '4.10.60.10-FF-000214', NULL, 'Uncharacterized protein', 60, NULL, NULL, 74889),
(74890, '1.25.40.180-FF-000120', NULL, 'Translation initiation factor eif-2b epsilon subunit', 187, NULL, NULL, 74890),
(74891, '1.10.10.2830-FF-000009', NULL, 'ParB-like partition protein', 110, NULL, NULL, 74891),
(74892, '1.20.58.480-FF-000028', NULL, 'Uncharacterized protein', 233, NULL, NULL, 74892),
(74893, '2.40.10.10-FF-000456', NULL, NULL, 51, NULL, NULL, 74893),
(74894, '2.60.40.1170-FF-000078', NULL, NULL, 143, NULL, NULL, 74894),
(74895, '3.40.50.11610-FF-000038', NULL, NULL, 73, NULL, NULL, 74895),
(74896, '3.30.70.1230-FF-000002', NULL, 'Adenylate cyclase', 198, NULL, NULL, 74896),
(74897, '1.10.10.10-FF-001073', NULL, 'Ferric uptake regulation protein', 84, NULL, NULL, 74897),
(74898, '3.40.50.300-FF-005836', NULL, 'ABC transporter (ATP-binding protein) homolog ygaD', 250, NULL, NULL, 74898),
(74899, '3.40.50.300-FF-003375', NULL, 'ATP-dependent helicase Lhr', 227, NULL, NULL, 74899),
(74900, '3.40.120.10-FF-000078', NULL, 'Uncharacterized protein', 85, NULL, NULL, 74900),
(74901, '1.20.1250.20-FF-000169', NULL, 'Sucrose transport protein SUC3', 465, NULL, NULL, 74901),
(74902, '3.40.50.2300-FF-001113', NULL, NULL, 130, NULL, NULL, 74902),
(74903, '1.10.860.10-FF-000002', NULL, 'Replicative DNA helicase', 164, NULL, NULL, 74903),
(74904, '1.10.10.10-FF-000903', NULL, 'Methylated-DNA--protein-cysteine methyltransferase', 85, NULL, NULL, 74904);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(74905, '3.30.70.330-FF-002890', NULL, NULL, 59, NULL, NULL, 74905),
(74906, '3.40.440.10-FF-000006', NULL, 'Adenylosuccinate synthetase', 157, NULL, NULL, 74906),
(74907, '3.40.50.300-FF-007753', NULL, 'Predicted protein', 74, NULL, NULL, 74907),
(74908, '3.30.40.10-FF-002125', NULL, 'Uncharacterized protein', 41, NULL, NULL, 74908),
(74909, '3.30.40.10-FF-001849', NULL, 'Uncharacterized protein', 82, NULL, NULL, 74909),
(74910, '1.10.150.170-FF-000010', NULL, 'probable methyltransferase-like protein 15 isoform X2', 92, NULL, NULL, 74910),
(74911, '2.40.50.140-FF-000413', NULL, 'Cold shock protein B cspB', 41, NULL, NULL, 74911),
(74912, '2.130.10.10-FF-003083', NULL, 'Transducin/WD40 repeat-like superfamily protein', 97, NULL, NULL, 74912),
(74913, '3.90.640.10-FF-000201', NULL, 'Uncharacterized protein', 88, NULL, NULL, 74913),
(74914, '3.30.559.10-FF-000250', NULL, 'Protein CBG17205', 64, NULL, NULL, 74914),
(74915, '3.30.160.60-FF-002609', NULL, 'Zinc finger protein', 27, NULL, NULL, 74915),
(74916, '3.40.1110.10-FF-000032', NULL, 'Calcium-transporting ATPase', 167, NULL, NULL, 74916),
(74917, '2.30.29.30-FF-000258', NULL, 'SET binding factor 2', 94, NULL, NULL, 74917),
(74918, '3.40.50.2300-FF-000837', NULL, NULL, 85, NULL, NULL, 74918),
(74919, '3.40.50.150-FF-000659', NULL, 'tRNA (adenine(58)-N(1))-methyltransferase', 215, NULL, NULL, 74919),
(74920, '1.10.630.10-FF-000518', NULL, 'Uncharacterized protein', 408, NULL, NULL, 74920),
(74921, '2.130.10.10-FF-001519', NULL, 'WD domain, G-beta repeat, putative', 121, NULL, NULL, 74921),
(74922, '3.30.9.10-FF-000243', NULL, 'Uncharacterized protein', 35, NULL, NULL, 74922),
(74923, '3.40.80.10-FF-000003', NULL, 'N-acetylmuramoyl-L-alanine amidase', 151, NULL, NULL, 74923),
(74924, '3.10.100.10-FF-000100', NULL, 'Lymphocyte antigen 75', 145, NULL, NULL, 74924),
(74925, '3.80.10.10-FF-000738', NULL, 'Predicted protein', 104, NULL, NULL, 74925),
(74926, '2.60.40.420-FF-000154', NULL, 'Uncharacterized protein', 120, NULL, NULL, 74926),
(74927, '2.130.10.10-FF-001183', NULL, 'Cell cycle arrest protein BUB3', 341, NULL, NULL, 74927),
(74928, '1.25.40.20-FF-000223', NULL, 'ankyrin repeat and SOCS box protein 3 isoform X1', 141, NULL, NULL, 74928),
(74929, '2.60.40.10-FF-003880', NULL, NULL, 107, NULL, NULL, 74929),
(74930, '3.10.310.10-FF-000037', NULL, 'Uncharacterized protein', 173, NULL, NULL, 74930),
(74931, '2.60.40.1260-FF-000004', NULL, 'LamC, isoform B', 149, NULL, NULL, 74931),
(74932, '1.10.287.2720-FF-000011', NULL, 'Oxysterol-binding protein homolog C354.07c', 71, NULL, NULL, 74932),
(74933, '3.30.160.60-FF-004397', NULL, NULL, 33, NULL, NULL, 74933),
(74934, '2.60.120.620-FF-000088', NULL, '2-oxoglutarate-Fe(II) oxygenase EGLN2', 159, NULL, NULL, 74934),
(74935, '1.25.10.10-FF-000185', NULL, 'serine/threonine-protein kinase ATR', 485, NULL, NULL, 74935),
(74936, '3.30.70.330-FF-000990', NULL, 'RNA recognition motif-containing protein', 174, NULL, NULL, 74936),
(74937, '3.10.350.10-FF-000051', NULL, 'N-acetylmuramoyl-L-alanine amidase XlyA', 59, NULL, NULL, 74937),
(74938, '3.40.190.10-FF-000695', NULL, 'Bicarbonate-binding protein CmpA', 259, NULL, NULL, 74938),
(74939, '1.25.40.10-FF-004969', NULL, 'Uncharacterized protein', 153, NULL, NULL, 74939),
(74940, '1.20.1530.10-FF-000002', NULL, 'Na(+)/H(+) antiporter NhaA', 380, NULL, NULL, 74940),
(74941, '3.10.20.230-FF-000004', NULL, 'Doublecortin domain containing 2', 89, NULL, NULL, 74941),
(74942, '3.20.20.100-FF-000042', NULL, 'Probable voltage-gated potassium channel subunit beta', 323, NULL, NULL, 74942),
(74943, '3.40.50.150-FF-001036', NULL, NULL, 162, NULL, NULL, 74943),
(74944, '3.40.50.720-FF-001011', NULL, 'Uncharacterized protein', 69, NULL, NULL, 74944),
(74945, '3.40.1110.10-FF-000453', NULL, NULL, 132, NULL, NULL, 74945),
(74946, '3.30.70.141-FF-000012', NULL, 'Thioredoxin domain-containing protein 3', 142, NULL, NULL, 74946),
(74947, '2.130.10.10-FF-005561', NULL, 'Uncharacterized protein', 217, NULL, NULL, 74947),
(74948, '3.40.190.10-FF-000352', NULL, 'LysR family transcriptional regulator', 104, NULL, NULL, 74948);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(74949, '4.10.240.10-FF-000174', NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', 61, NULL, NULL, 74949),
(74950, '3.40.850.10-FF-000509', NULL, 'Kinesin-like protein', 285, NULL, NULL, 74950),
(74951, '1.10.274.100-FF-000018', NULL, 'DNA-directed RNA polymerase subunit', 161, NULL, NULL, 74951),
(74952, '3.30.420.10-FF-000277', NULL, NULL, 86, NULL, NULL, 74952),
(74953, '4.10.780.10-FF-000001', NULL, 'Probable pyruvate-flavodoxin oxidoreductase', 38, NULL, NULL, 74953),
(74954, '2.60.120.290-FF-000022', NULL, 'seizure 6-like protein 2 isoform X2', 117, NULL, NULL, 74954),
(74955, '1.20.1720.10-FF-000045', NULL, 'MFS general substrate transporter', 248, NULL, NULL, 74955),
(74956, '3.40.50.300-FF-006472', NULL, 'Sulfotransferase', 118, NULL, NULL, 74956),
(74957, '3.90.180.10-FF-000172', NULL, 'Uncharacterized protein', 46, NULL, NULL, 74957),
(74958, '1.25.40.120-FF-000029', NULL, 'Protein farnesyltransferase/geranylgeranyltransferase type-1 subunit alpha', 331, NULL, NULL, 74958),
(74959, '1.25.40.10-FF-001743', NULL, 'Prolyl 4-hydroxylase subunit alpha-2', 79, NULL, NULL, 74959),
(74960, '3.40.50.300-FF-005853', NULL, 'DNA helicase', 121, NULL, NULL, 74960),
(74961, '2.60.40.10-FF-000114', NULL, 'Neuronal cell adhesion molecule', 111, NULL, NULL, 74961),
(74962, '3.30.200.20-FF-000735', NULL, 'MOK protein kinase', 60, NULL, NULL, 74962),
(74963, '3.30.230.10-FF-000234', NULL, 'Elongation factor 2', 61, NULL, NULL, 74963),
(74964, '1.10.10.10-FF-001522', NULL, 'Uncharacterized protein', 121, NULL, NULL, 74964),
(74965, '3.40.50.720-FF-001915', NULL, 'Os07g0602050 protein', 66, NULL, NULL, 74965),
(74966, '3.30.200.110-FF-000010', NULL, NULL, 129, NULL, NULL, 74966),
(74967, '2.40.50.140-FF-001032', NULL, NULL, 141, NULL, NULL, 74967),
(74968, '3.30.160.60-FF-002368', NULL, 'Zinc finger protein 124', 26, NULL, NULL, 74968),
(74969, '1.10.3630.10-FF-000001', NULL, 'Golgi phosphoprotein 3', 248, NULL, NULL, 74969),
(74970, '1.20.58.1380-FF-000010', NULL, 'Uncharacterized protein', 90, NULL, NULL, 74970),
(74971, '2.130.10.10-FF-002464', NULL, 'Uncharacterized protein', 126, NULL, NULL, 74971),
(74972, '3.40.50.12780-FF-000231', NULL, 'Predicted protein', 173, NULL, NULL, 74972),
(74973, '1.20.1110.10-FF-000010', NULL, 'Calcium-transporting ATPase 1', 409, NULL, NULL, 74973),
(74974, '2.30.42.10-FF-000339', NULL, 'Golgi reassembly stacking protein (GRASP homologue), putative', 110, NULL, NULL, 74974),
(74975, '3.30.60.20-FF-000090', NULL, 'Diacylglycerol kinase', 55, NULL, NULL, 74975),
(74976, '3.30.1370.10-FF-000053', NULL, 'Fragile X mental retardation syndrome-related protein 1', 80, NULL, NULL, 74976),
(74977, '1.20.1250.20-FF-000270', NULL, 'Major facilitator superfamily domain-containing protein 4A', 189, NULL, NULL, 74977),
(74978, '2.40.110.10-FF-000019', NULL, 'Acyl-coenzyme A oxidase', 137, NULL, NULL, 74978),
(74979, '3.40.1090.10-FF-000068', NULL, 'Cell division protein', 133, NULL, NULL, 74979),
(74980, '1.50.10.10-FF-000093', NULL, 'Glycoside hydrolase family 15 protein', 358, NULL, NULL, 74980),
(74981, '1.10.8.10-FF-000363', NULL, 'Uncharacterized protein', 58, NULL, NULL, 74981),
(74982, '3.30.420.100-FF-000017', NULL, 'Uncharacterized protein', 255, NULL, NULL, 74982),
(74983, '3.40.228.10-FF-000024', NULL, 'Molybdopterin-binding iron-sulfur cluster-binding oxidoreductase MopB-3', 240, NULL, NULL, 74983),
(74984, '3.40.309.10-FF-000067', NULL, 'Putative aldehyde dehydrogenase', 190, NULL, NULL, 74984),
(74985, '1.20.1560.10-FF-000173', NULL, 'Peroxisomal ABC transporter 1', 324, NULL, NULL, 74985),
(74986, '1.20.120.1870-FF-000002', NULL, 'Doc protein', 128, NULL, NULL, 74986),
(74987, '1.25.70.10-FF-000059', NULL, NULL, 209, NULL, NULL, 74987),
(74988, '1.10.472.130-FF-000049', NULL, 'GM10109', 86, NULL, NULL, 74988),
(74989, '2.130.10.10-FF-005218', NULL, 'Uncharacterized protein', 81, NULL, NULL, 74989),
(74990, '2.110.10.10-FF-000048', NULL, 'Predicted protein', 54, NULL, NULL, 74990),
(74991, '3.30.40.10-FF-001945', NULL, 'Uncharacterized protein', 108, NULL, NULL, 74991);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(74992, '3.50.4.10-FF-000058', NULL, NULL, 58, NULL, NULL, 74992),
(74993, '3.30.40.10-FF-000670', NULL, 'SH3 domain-containing protein', 78, NULL, NULL, 74993),
(74994, '3.40.30.10-FF-000281', NULL, 'Thioredoxin-like protein CDSP32, chloroplastic', 119, NULL, NULL, 74994),
(74995, '3.40.50.2000-FF-000174', NULL, 'UDP-glucuronosyltransferase', 207, NULL, NULL, 74995),
(74996, '1.20.1070.10-FF-001692', NULL, 'Olfactory receptor', 112, NULL, NULL, 74996),
(74997, '3.30.200.20-FF-000174', NULL, 'Receptor protein serine/threonine kinase', 95, NULL, NULL, 74997),
(74998, '3.40.50.300-FF-007410', NULL, 'ABC transporter, putative', 85, NULL, NULL, 74998),
(74999, '1.25.40.410-FF-000009', NULL, 'RE54856p', 149, NULL, NULL, 74999),
(75000, '1.25.40.10-FF-004840', NULL, 'Uncharacterized protein', 141, NULL, NULL, 75000),
(75001, '3.20.20.80-FF-000386', NULL, 'Glycoside hydrolase superfamily', 109, NULL, NULL, 75001),
(75002, '2.70.98.10-FF-000005', NULL, 'Aldose 1-epimerase subfamily', 290, NULL, NULL, 75002),
(75003, '1.20.1270.60-FF-000266', NULL, 'Uncharacterized protein', 134, NULL, NULL, 75003),
(75004, '3.30.1330.20-FF-000059', NULL, 'Alpha-tubulin 2, putative', 55, NULL, NULL, 75004),
(75005, '1.10.10.10-FF-000454', NULL, 'RNA polymerase sigma factor SigF', 69, NULL, NULL, 75005),
(75006, '3.40.50.970-FF-000225', NULL, '2-oxoisovalerate dehydrogenase subunit alpha', 175, NULL, NULL, 75006),
(75007, '2.60.40.60-FF-000899', NULL, 'Uncharacterized protein', 103, NULL, NULL, 75007),
(75008, '3.30.40.10-FF-000439', NULL, 'Putative E3 ubiquitin-protein ligase UBR7', 68, NULL, NULL, 75008),
(75009, '2.40.128.20-FF-000063', NULL, 'Cellular retinoic acid-binding protein 2, a', 88, NULL, NULL, 75009),
(75010, '2.40.50.100-FF-000188', NULL, 'Probable cation efflux system', 73, NULL, NULL, 75010),
(75011, '3.90.550.10-FF-000762', NULL, 'Putative polypeptide N-acetylgalactosaminyltransferase 11', 383, NULL, NULL, 75011),
(75012, '3.90.1310.10-FF-000035', NULL, 'Stage V sporulation protein D', 122, NULL, NULL, 75012),
(75013, '1.20.1280.50-FF-000005', NULL, 'F-box/LRR-repeat protein 3 isoform X1', 42, NULL, NULL, 75013),
(75014, '3.30.930.10-FF-000147', NULL, 'Related to GCN2-ser/thr protein kinase', 326, NULL, NULL, 75014),
(75015, '1.25.40.90-FF-000103', NULL, 'Uncharacterized protein', 173, NULL, NULL, 75015),
(75016, '2.40.70.10-FF-000010', NULL, 'Aspartyl protease family protein 2', 178, NULL, NULL, 75016),
(75017, '1.25.40.10-FF-001400', NULL, 'Mitochondrial import receptor subunit ATOM69', 242, NULL, NULL, 75017),
(75018, '1.10.135.10-FF-000008', NULL, 'Predicted protein', 90, NULL, NULL, 75018),
(75019, '3.40.50.720-FF-001932', NULL, 'dTDP-4-dehydrorhamnose reductase', 287, NULL, NULL, 75019),
(75020, '2.60.110.10-FF-000026', NULL, 'Pathogenesis-related thaumatin superfamily protein', 138, NULL, NULL, 75020),
(75021, '3.40.50.410-FF-000305', NULL, 'Integrin beta', 155, NULL, NULL, 75021),
(75022, '2.40.30.10-FF-000356', NULL, 'Flavohemoprotein', 107, NULL, NULL, 75022),
(75023, '3.50.50.60-FF-000768', NULL, 'Amine oxidase', 82, NULL, NULL, 75023),
(75024, '3.30.160.380-FF-000018', NULL, NULL, 86, NULL, NULL, 75024),
(75025, '1.20.120.20-FF-000031', NULL, 'Apolipoprotein Ea', 94, NULL, NULL, 75025),
(75026, '1.25.40.20-FF-001179', NULL, 'Transient receptor potential cation channel, subfamily A, member 1a', 71, NULL, NULL, 75026),
(75027, '3.30.160.60-FF-005111', NULL, NULL, 38, NULL, NULL, 75027),
(75028, '3.40.1190.10-FF-000020', NULL, 'Folylpolyglutamate synthase', 291, NULL, NULL, 75028),
(75029, '3.30.497.10-FF-000151', NULL, 'Uncharacterized protein', 71, NULL, NULL, 75029),
(75030, '2.10.110.10-FF-000155', NULL, 'Protein CBG12788', 61, NULL, NULL, 75030),
(75031, '3.30.1680.10-FF-000054', NULL, 'G-protein coupled receptor 98-like isoform X1', 52, NULL, NULL, 75031),
(75032, '3.30.60.270-FF-000003', NULL, 'Sortilin-related VPS10 domain containing receptor 2', 78, NULL, NULL, 75032),
(75033, '3.10.129.10-FF-000211', NULL, 'Acyl-CoA thioesterase', 130, NULL, NULL, 75033),
(75034, '2.40.50.40-FF-000006', NULL, 'Chromobox protein homolog 7', 63, NULL, NULL, 75034);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(75035, '1.20.140.150-FF-000129', NULL, 'Uncharacterized protein', 214, NULL, NULL, 75035),
(75036, '3.20.110.10-FF-000003', NULL, 'Alpha-mannosidase', 383, NULL, NULL, 75036),
(75037, '1.20.5.170-FF-000155', NULL, 'CREB/ATF bZIP transcription factor', 53, NULL, NULL, 75037),
(75038, '2.130.10.10-FF-003644', NULL, 'Uncharacterized protein', 93, NULL, NULL, 75038),
(75039, '3.60.90.10-FF-000019', NULL, 'S-adenosylmethionine decarboxylase proenzyme', 336, NULL, NULL, 75039),
(75040, '2.130.10.10-FF-000210', NULL, 'WD repeat-containing protein 11 isoform X1', 222, NULL, NULL, 75040),
(75041, '2.40.50.140-FF-000756', NULL, NULL, 146, NULL, NULL, 75041),
(75042, '1.20.1250.20-FF-001579', NULL, 'Uncharacterized protein', 358, NULL, NULL, 75042),
(75043, '1.10.10.60-FF-000896', NULL, NULL, 68, NULL, NULL, 75043),
(75044, '3.40.50.2300-FF-001017', NULL, NULL, 77, NULL, NULL, 75044),
(75045, '2.60.40.10-FF-004526', NULL, NULL, 78, NULL, NULL, 75045),
(75046, '1.10.510.10-FF-002937', NULL, NULL, 225, NULL, NULL, 75046),
(75047, '3.40.1110.10-FF-000110', NULL, 'Phospholipid-transporting ATPase', 195, NULL, NULL, 75047),
(75048, '3.30.160.60-FF-003880', NULL, 'GM22919', 65, NULL, NULL, 75048),
(75049, '1.10.8.40-FF-000001', NULL, NULL, 59, NULL, NULL, 75049),
(75050, '2.40.30.30-FF-000025', NULL, 'Riboflavin biosynthesis protein', 130, NULL, NULL, 75050),
(75051, '1.20.1070.10-FF-000747', NULL, 'Alkaline phosphatase', 338, NULL, NULL, 75051),
(75052, '1.10.10.10-FF-002011', NULL, 'Uncharacterized protein', 113, NULL, NULL, 75052),
(75053, '2.60.40.10-FF-005015', NULL, NULL, 105, NULL, NULL, 75053),
(75054, '2.40.10.10-FF-000473', NULL, NULL, 102, NULL, NULL, 75054),
(75055, '1.25.40.10-FF-003660', NULL, 'Tetratricopeptide repeat domain 21A', 81, NULL, NULL, 75055),
(75056, '1.20.5.350-FF-000006', NULL, 'TropoNin T', 102, NULL, NULL, 75056),
(75057, '2.70.160.11-FF-000022', NULL, 'Protein arginine N-methyltransferase', 169, NULL, NULL, 75057),
(75058, '3.30.1010.10-FF-000127', NULL, 'Uncharacterized protein', 42, NULL, NULL, 75058),
(75059, '4.10.60.10-FF-000186', NULL, 'ATP-dependent RNA helicase glh-4', 65, NULL, NULL, 75059),
(75060, '1.20.1440.200-FF-000006', NULL, 'Vacuolar protein sorting-associated protein 28 homolog', 99, NULL, NULL, 75060),
(75061, '3.20.20.80-FF-000043', NULL, 'cytosolic endo-beta-N-acetylglucosaminidase', 318, NULL, NULL, 75061),
(75062, '1.10.287.130-FF-000245', NULL, 'Sensory box sensor histidine kinase', 75, NULL, NULL, 75062),
(75063, '3.20.20.70-FF-000506', NULL, 'Dihydrodipicolinate synthase/N-acetylneuraminate lyase', 312, NULL, NULL, 75063),
(75064, '3.40.190.10-FF-000256', NULL, 'ABC transporter, periplasmic substrate-binding protein', 166, NULL, NULL, 75064),
(75065, '2.60.40.10-FF-005145', NULL, NULL, 95, NULL, NULL, 75065),
(75066, '3.80.10.10-FF-001683', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 169, NULL, NULL, 75066),
(75067, '1.10.472.80-FF-000093', NULL, 'GTPase-activating protein, putative', 147, NULL, NULL, 75067),
(75068, '3.40.80.10-FF-000020', NULL, 'Peptidoglycan recognition protein LC, isoform H', 167, NULL, NULL, 75068),
(75069, '3.40.50.150-FF-001166', NULL, NULL, 211, NULL, NULL, 75069),
(75070, '3.40.50.10810-FF-000101', NULL, 'SWI/SNF-related, matrix-associated, actin-dependent regulator of', 234, NULL, NULL, 75070),
(75071, '1.20.1250.20-FF-002198', NULL, 'LP07553p', 150, NULL, NULL, 75071),
(75072, '1.25.40.10-FF-002715', NULL, 'CoxI translation protein CYA5', 307, NULL, NULL, 75072),
(75073, '1.10.510.10-FF-001527', NULL, 'Kinase, AGC MAST', 127, NULL, NULL, 75073),
(75074, '3.30.559.10-FF-000149', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 57, NULL, NULL, 75074),
(75075, '3.30.530.20-FF-000058', NULL, 'Conserved protein', 139, NULL, NULL, 75075),
(75076, '3.40.50.720-FF-002421', NULL, 'Uncharacterized protein', 183, NULL, NULL, 75076),
(75077, '1.10.1670.10-FF-000082', NULL, NULL, 18, NULL, NULL, 75077),
(75078, '1.20.140.100-FF-000047', NULL, 'Dynein heavy chain, cytoplasmic', 150, NULL, NULL, 75078);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(75079, '3.80.10.10-FF-001587', NULL, 'RNI-like superfamily protein', 148, NULL, NULL, 75079),
(75080, '2.10.80.10-FF-000001', NULL, 'Dickkopf WNT-signaling pathway inhibitor 2', 90, NULL, NULL, 75080),
(75081, '3.10.350.10-FF-000034', NULL, 'Class V chitinase Chi100', 51, NULL, NULL, 75081),
(75082, '3.30.450.20-FF-000006', NULL, 'aryl hydrocarbon receptor nuclear translocator-like protein 1', 192, NULL, NULL, 75082),
(75083, '2.60.210.10-FF-000062', NULL, NULL, 94, NULL, NULL, 75083),
(75084, '3.80.10.10-FF-000177', NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase At1g17230', 315, NULL, NULL, 75084),
(75085, '3.30.40.10-FF-000540', NULL, 'E3 ubiquitin-protein ligase RDUF1', 91, NULL, NULL, 75085),
(75086, '3.90.150.10-FF-000001', NULL, 'Variant surface glycoprotein (VSG), putative', 197, NULL, NULL, 75086),
(75087, '1.10.1030.10-FF-000005', NULL, 'Carbamoyl-phosphate synthase (glutamine-hydrolyzing)', 156, NULL, NULL, 75087),
(75088, '1.10.10.60-FF-001172', NULL, NULL, 42, NULL, NULL, 75088),
(75089, '3.30.260.10-FF-000062', NULL, NULL, 105, NULL, NULL, 75089),
(75090, '1.10.1450.10-FF-000127', NULL, 'Tetraspanin', 83, NULL, NULL, 75090),
(75091, '1.25.40.10-FF-002811', NULL, 'Pentatricopeptide repeat-containing protein, putative', 233, NULL, NULL, 75091),
(75092, '3.30.70.20-FF-000045', NULL, 'Ferredoxin, 4Fe-4S', 62, NULL, NULL, 75092),
(75093, '1.20.1250.20-FF-002327', NULL, 'Uncharacterized protein', 185, NULL, NULL, 75093),
(75094, '3.90.1150.10-FF-000163', NULL, 'Kynureninase', 146, NULL, NULL, 75094),
(75095, '3.40.1110.10-FF-000470', NULL, NULL, 67, NULL, NULL, 75095),
(75096, '2.60.40.10-FF-000474', NULL, 'Sallimus, isoform Q', 99, NULL, NULL, 75096),
(75097, '1.10.940.10-FF-000036', NULL, 'tRNA/rRNA cytosine-C5-methylase, NOL1/NOP2/Sun family, fused to N-terminal NusB regulator domain', 140, NULL, NULL, 75097),
(75098, '1.10.10.10-FF-000111', NULL, 'Transcriptional repressor MprA', 154, NULL, NULL, 75098),
(75099, '3.20.10.10-FF-000005', NULL, 'Branched-chain-amino-acid aminotransferase', 172, NULL, NULL, 75099),
(75100, '1.10.10.540-FF-000013', NULL, 'Ubiquitin family protein', 63, NULL, NULL, 75100),
(75101, '3.30.160.60-FF-001980', NULL, 'Zinc finger protein 45', 28, NULL, NULL, 75101),
(75102, '3.30.450.20-FF-000462', NULL, 'Predicted protein', 138, NULL, NULL, 75102),
(75103, '1.10.10.2840-FF-000001', NULL, 'Carbohydrate diacid transcriptional regulator', 127, NULL, NULL, 75103),
(75104, '1.20.1250.20-FF-001681', NULL, 'Uncharacterized protein', 307, NULL, NULL, 75104),
(75105, '3.40.50.300-FF-000261', NULL, 'GTP-binding protein SAR1A', 193, NULL, NULL, 75105),
(75106, '2.60.40.60-FF-000556', NULL, 'FAT atypical cadherin 2', 102, NULL, NULL, 75106),
(75107, '3.40.50.300-FF-002189', NULL, 'Os07g0598300 protein', 175, NULL, NULL, 75107),
(75108, '3.90.810.10-FF-000029', NULL, 'Elongation factor Ts, mitochondrial', 48, NULL, NULL, 75108),
(75109, '1.20.58.60-FF-000472', NULL, 'Spectrin beta chain', 134, NULL, NULL, 75109),
(75110, '3.40.20.10-FF-000123', NULL, 'Uncharacterized protein', 133, NULL, NULL, 75110),
(75111, '4.10.400.10-FF-000046', NULL, 'Very low density lipoprotein receptor', 41, NULL, NULL, 75111),
(75112, '2.60.120.430-FF-000019', NULL, '1,4-beta-D-glucan glucohydrolase', 179, NULL, NULL, 75112),
(75113, '3.40.33.10-FF-000203', NULL, 'Uncharacterized protein', 43, NULL, NULL, 75113),
(75114, '3.50.50.60-FF-000740', NULL, 'Uncharacterized protein', 144, NULL, NULL, 75114),
(75115, '1.20.140.10-FF-000041', NULL, 'Acyl-coenzyme A oxidase', 128, NULL, NULL, 75115),
(75116, '2.130.10.10-FF-004493', NULL, 'Uncharacterized protein', 11, NULL, NULL, 75116),
(75117, '3.40.50.1970-FF-000018', NULL, 'Related to 2-epi-5-epi-valiolone synthase', 183, NULL, NULL, 75117),
(75118, '3.30.1120.30-FF-000012', NULL, 'Serine/threonine-protein kinase PLK', 101, NULL, NULL, 75118),
(75119, '3.40.50.300-FF-005292', NULL, 'ADP-ribosylation factor-like protein 5', 175, NULL, NULL, 75119),
(75120, '1.20.1050.10-FF-000072', NULL, 'Omega class glutathione transferase', 163, NULL, NULL, 75120);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(75121, '3.40.50.200-FF-000017', NULL, 'Intracellular serine protease', 304, NULL, NULL, 75121),
(75122, '3.40.50.1820-FF-000120', NULL, 'Alpha/beta-Hydrolases superfamily protein', 305, NULL, NULL, 75122),
(75123, '1.20.58.1030-FF-000040', NULL, 'Uncharacterized protein', 68, NULL, NULL, 75123),
(75124, '3.40.50.300-FF-007641', NULL, 'GTP-binding protein', 138, NULL, NULL, 75124),
(75125, '1.25.40.20-FF-000111', NULL, 'Ankyrin repeat domain-containing protein 1', 100, NULL, NULL, 75125),
(75126, '1.10.357.10-FF-000057', NULL, 'TetR family transcriptional regulator', 195, NULL, NULL, 75126),
(75127, '3.30.40.10-FF-001153', NULL, 'E3 ubiquitin-protein ligase RHF1A', 78, NULL, NULL, 75127),
(75128, '3.30.450.30-FF-000094', NULL, 'Uncharacterized protein', 69, NULL, NULL, 75128),
(75129, '3.80.10.10-FF-004128', NULL, 'Uncharacterized protein', 112, NULL, NULL, 75129),
(75130, '3.30.70.330-FF-000085', NULL, 'RNA-binding protein 4 isoform X1', 73, NULL, NULL, 75130),
(75131, '2.60.40.1660-FF-000017', NULL, 'Uncharacterized protein', 279, NULL, NULL, 75131),
(75132, '2.130.10.10-FF-004049', NULL, 'V-type proton ATPase proteolipid subunit', 216, NULL, NULL, 75132),
(75133, '1.25.40.570-FF-000012', NULL, 'probable 26S proteasome non-ATPase regulatory subunit 3', 201, NULL, NULL, 75133),
(75134, '3.40.50.2300-FF-001225', NULL, NULL, 58, NULL, NULL, 75134),
(75135, '3.20.20.70-FF-000265', NULL, 'Lipoyl synthase', 207, NULL, NULL, 75135),
(75136, '2.60.120.10-FF-000083', NULL, 'Cyclic nucleotide binding domain containing 2', 152, NULL, NULL, 75136),
(75137, '2.60.120.590-FF-000022', NULL, 'DNA repair family protein', 232, NULL, NULL, 75137),
(75138, '2.60.40.1970-FF-000003', NULL, 'MLLT1, super elongation complex subunit', 150, NULL, NULL, 75138),
(75139, '3.30.70.1350-FF-000021', NULL, 'Cation diffusion facilitator family transporter', 80, NULL, NULL, 75139),
(75140, '3.30.460.10-FF-000173', NULL, 'Polynucleotide adenylyltransferase family protein', 94, NULL, NULL, 75140),
(75141, '3.55.50.30-FF-000013', NULL, 'Anti-sigma factor', 77, NULL, NULL, 75141),
(75142, '2.60.40.10-FF-004498', NULL, NULL, 150, NULL, NULL, 75142),
(75143, '2.20.70.10-FF-000292', NULL, 'Uncharacterized protein', 59, NULL, NULL, 75143),
(75144, '3.80.10.10-FF-003032', NULL, 'Uncharacterized protein', 128, NULL, NULL, 75144),
(75145, '3.30.300.20-FF-000007', NULL, 'Ribosome-binding factor A', 115, NULL, NULL, 75145),
(75146, '3.30.160.60-FF-005566', NULL, NULL, 56, NULL, NULL, 75146),
(75147, '1.10.510.10-FF-001870', NULL, 'Serine/threonine protein kinase', 206, NULL, NULL, 75147),
(75148, '2.60.120.650-FF-000164', NULL, 'Predicted protein', 211, NULL, NULL, 75148),
(75149, '1.20.1440.30-FF-000001', NULL, 'Erythromycin esterase', 140, NULL, NULL, 75149),
(75150, '2.30.30.1020-FF-000006', NULL, 'CCR4-NOT transcription complex, subunit 3', 166, NULL, NULL, 75150),
(75151, '3.90.1750.10-FF-000006', NULL, 'E3 ubiquitin-protein ligase TRIP12 isoform X1', 204, NULL, NULL, 75151),
(75152, '1.25.40.10-FF-004857', NULL, 'Uncharacterized protein', 128, NULL, NULL, 75152),
(75153, '1.10.472.80-FF-000121', NULL, 'Putative GTPase activator protein', 141, NULL, NULL, 75153),
(75154, '2.160.20.10-FF-000024', NULL, 'F-box only protein 11', 143, NULL, NULL, 75154),
(75155, '1.10.10.440-FF-000101', NULL, 'Chromosome 19, whole genome shotgun sequence', 79, NULL, NULL, 75155),
(75156, '3.90.70.10-FF-000096', NULL, 'Cathepsin B-like cysteine protease', 303, NULL, NULL, 75156),
(75157, '3.30.465.10-FF-000049', NULL, 'L-galactono-1,4-lactone dehydrogenase', 128, NULL, NULL, 75157),
(75158, '3.30.230.10-FF-000364', NULL, 'Ribonuclease P protein component', 98, NULL, NULL, 75158),
(75159, '1.25.40.10-FF-001631', NULL, 'Tetratricopeptide_repeat/TPR_repeat', 143, NULL, NULL, 75159),
(75160, '3.30.1360.10-FF-000007', NULL, 'DNA-directed RNA polymerase II subunit RPB11-like protein', 115, NULL, NULL, 75160),
(75161, '2.60.200.20-FF-000137', NULL, 'Uncharacterized protein', 128, NULL, NULL, 75161),
(75162, '3.90.180.10-FF-000042', NULL, 'Erythritol/L-threitol dehydrogenase', 194, NULL, NULL, 75162);
INSERT INTO "PUBLIC"."MODEL" VALUES
(75163, '3.40.50.300-FF-005387', NULL, 'Sperm flagellar protein 2', 227, NULL, NULL, 75163),
(75164, '2.140.10.30-FF-000013', NULL, 'Uncharacterized protein', 462, NULL, NULL, 75164),
(75165, '3.30.200.20-FF-000966', NULL, 'Protein kinase, putative', 81, NULL, NULL, 75165),
(75166, '3.80.10.10-FF-003509', NULL, 'Uncharacterized protein', 181, NULL, NULL, 75166),
(75167, '1.10.10.10-FF-001634', NULL, 'Predicted protein', 91, NULL, NULL, 75167),
(75168, '2.30.42.10-FF-000108', NULL, 'Multiple PDZ domain protein isoform X1', 103, NULL, NULL, 75168),
(75169, '3.30.2320.30-FF-000005', NULL, 'V-type proton ATPase subunit E', 135, NULL, NULL, 75169),
(75170, '3.30.70.1730-FF-000039', NULL, 'YALI0C10802p', 172, NULL, NULL, 75170),
(75171, '1.25.40.10-FF-003429', NULL, 'Uncharacterized protein', 113, NULL, NULL, 75171),
(75172, '1.25.40.10-FF-002709', NULL, 'Tetratricopeptide repeat protein 8, tpr8, putative', 87, NULL, NULL, 75172),
(75173, '3.90.190.10-FF-000447', NULL, 'Lmo1800 protein', 252, NULL, NULL, 75173),
(75174, '3.80.10.10-FF-001795', NULL, 'Uncharacterized protein', 246, NULL, NULL, 75174),
(75175, '1.20.120.160-FF-000038', NULL, 'Chemotaxis signal transduction system histidine kinase CheA', 135, NULL, NULL, 75175),
(75176, '3.80.10.10-FF-001475', NULL, 'TLR4', 614, NULL, NULL, 75176),
(75177, '3.40.50.10800-FF-000014', NULL, NULL, 100, NULL, NULL, 75177),
(75178, '3.40.190.10-FF-000144', NULL, 'LysR family hydrogen peroxide-inducible transcriptional activator', 99, NULL, NULL, 75178),
(75179, '1.10.1520.10-FF-000094', NULL, 'Minimal dicer', 144, NULL, NULL, 75179),
(75180, '3.90.190.10-FF-000127', NULL, 'Chromosome 21, whole genome shotgun sequence', 256, NULL, NULL, 75180),
(75181, '1.10.8.680-FF-000001', NULL, 'TBC1 domain family, member 7', 77, NULL, NULL, 75181),
(75182, '3.40.190.10-FF-000464', NULL, 'Dipeptide-binding ABC transporter, periplasmic substrate-binding component', 289, NULL, NULL, 75182),
(75183, '4.10.410.10-FF-000002', NULL, 'WAP, follistatin/kazal, immunoglobulin, kunitz and netrin domain-containing 2', 58, NULL, NULL, 75183),
(75184, '1.25.40.20-FF-000010', NULL, 'Poly [ADP-ribose] polymerase', 154, NULL, NULL, 75184),
(75185, '3.60.15.10-FF-000216', NULL, 'Uncharacterized protein', 218, NULL, NULL, 75185),
(75186, '2.60.40.60-FF-000348', NULL, 'Fat-like cadherin-related tumor suppressor homolog', 106, NULL, NULL, 75186),
(75187, '3.30.70.260-FF-000053', NULL, 'Ribose-5-phosphate isomerase, putative', 83, NULL, NULL, 75187),
(75188, '3.40.50.1820-FF-001637', NULL, 'Esterase-6-like Protein', 566, NULL, NULL, 75188),
(75189, '3.20.20.80-FF-000173', NULL, 'Beta-galactosidase', 250, NULL, NULL, 75189),
(75190, '2.60.120.200-FF-000069', NULL, 'Calsyntenin 3', 182, NULL, NULL, 75190),
(75191, '1.20.1080.10-FF-000012', NULL, 'Aquaporin-1', 249, NULL, NULL, 75191),
(75192, '3.30.70.1230-FF-000232', NULL, 'Uncharacterized protein', 198, NULL, NULL, 75192),
(75193, '2.40.30.270-FF-000004', NULL, 'DNA-binding protein SMUBP-2', 103, NULL, NULL, 75193),
(75194, '3.40.50.10590-FF-000001', NULL, 'Probable aminopeptidase NPEPL1', 156, NULL, NULL, 75194),
(75195, '1.10.10.60-FF-000980', NULL, NULL, 93, NULL, NULL, 75195),
(75196, '3.40.50.150-FF-001828', NULL, NULL, 73, NULL, NULL, 75196),
(75197, '3.50.50.60-FF-000077', NULL, 'Glutamate synthase small subunit', 122, NULL, NULL, 75197),
(75198, '3.40.50.2020-FF-000051', NULL, 'Ribose-phosphate pyrophosphokinase 1', 58, NULL, NULL, 75198),
(75199, '3.40.50.720-FF-000847', NULL, 'NADPH-dependent alkenal/one oxidoreductase, chloroplastic', 115, NULL, NULL, 75199),
(75200, '1.25.40.30-FF-000001', NULL, 'Clathrin heavy chain', 105, NULL, NULL, 75200),
(75201, '1.10.238.10-FF-000646', NULL, 'Calmodulin, striated muscle', 69, NULL, NULL, 75201),
(75202, '3.40.50.150-FF-000098', NULL, 'Trmt1-like isoform 1', 343, NULL, NULL, 75202),
(75203, '3.40.50.790-FF-000031', NULL, 'Ribosomal protein L1, putative', 81, NULL, NULL, 75203),
(75204, '3.30.710.10-FF-000496', NULL, 'AT19737p', 132, NULL, NULL, 75204),
(75205, '1.10.460.10-FF-000022', NULL, 'DNA topoisomerase 1', 99, NULL, NULL, 75205);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(75206, '3.20.20.100-FF-000059', NULL, 'Conserved protein', 338, NULL, NULL, 75206),
(75207, '1.25.40.10-FF-002923', NULL, 'Transcription factor', 317, NULL, NULL, 75207),
(75208, '2.60.40.60-FF-000668', NULL, 'Uncharacterized protein', 108, NULL, NULL, 75208),
(75209, '2.60.40.10-FF-005706', NULL, NULL, 53, NULL, NULL, 75209),
(75210, '3.30.50.10-FF-000041', NULL, 'GATA transcription factor 14', 52, NULL, NULL, 75210),
(75211, '1.20.1070.10-FF-001607', NULL, 'Uncharacterized protein', 149, NULL, NULL, 75211),
(75212, '3.40.50.300-FF-003942', NULL, 'Shikimate kinase', 174, NULL, NULL, 75212),
(75213, '3.40.50.1820-FF-000811', NULL, '6-deoxyerythronolide-B synthase EryA3, modules 5 and 6', 256, NULL, NULL, 75213),
(75214, '3.30.420.150-FF-000021', NULL, 'Exopolyphosphatase', 177, NULL, NULL, 75214),
(75215, '2.30.29.30-FF-000819', NULL, 'Pleckstrin homology like domain family B member 1', 80, NULL, NULL, 75215),
(75216, '1.25.10.10-FF-001691', NULL, 'Hsp70-binding protein 1', 281, NULL, NULL, 75216),
(75217, '3.10.20.90-FF-000575', NULL, 'Ubiquitin-60S ribosomal protein L40', 114, NULL, NULL, 75217),
(75218, '3.30.160.60-FF-003436', NULL, 'Si:ch211-223a21.4', 83, NULL, NULL, 75218),
(75219, '3.30.40.10-FF-002356', NULL, 'Uncharacterized protein ZK632.12', 86, NULL, NULL, 75219),
(75220, '3.40.33.10-FF-000091', NULL, 'Uncharacterized protein, isoform B', 170, NULL, NULL, 75220),
(75221, '1.10.390.20-FF-000002', NULL, 'Microbial collagenase', 127, NULL, NULL, 75221),
(75222, '3.30.1010.10-FF-000032', NULL, 'Serine/threonine-protein kinase TEL1', 149, NULL, NULL, 75222),
(75223, '3.40.50.1170-FF-000009', NULL, 'Uncharacterized protein', 227, NULL, NULL, 75223),
(75224, '2.130.10.10-FF-004381', NULL, 'AGAP012868-PA', 76, NULL, NULL, 75224),
(75225, '2.60.40.4100-FF-000019', NULL, 'POM121 and ZP3 fusion protein', 117, NULL, NULL, 75225),
(75226, '3.30.559.70-FF-000015', NULL, 'Protein CBG23894', 312, NULL, NULL, 75226),
(75227, '3.30.70.141-FF-000029', NULL, 'Flagellar_Member_1', 175, NULL, NULL, 75227),
(75228, '3.30.565.10-FF-000197', NULL, 'Probable two-component response regulator', 158, NULL, NULL, 75228),
(75229, '3.30.200.20-FF-002091', NULL, 'Uncharacterized protein', 81, NULL, NULL, 75229),
(75230, '2.60.40.10-FF-002368', NULL, 'High Incidence of Males (Increased X chromosome loss)', 96, NULL, NULL, 75230),
(75231, '3.20.20.450-FF-000012', NULL, 'Diguanylate cyclase/phosphodiesterase domain 2 (EAL)', 265, NULL, NULL, 75231),
(75232, '1.10.472.10-FF-000566', NULL, 'G2/mitotic-specific cyclin A, putative', 62, NULL, NULL, 75232),
(75233, '3.30.450.20-FF-000349', NULL, 'Circadian locomoter output cycles protein kaput-like Protein', 126, NULL, NULL, 75233),
(75234, '1.25.40.10-FF-004048', NULL, 'UPF0656 protein C926.02', 174, NULL, NULL, 75234),
(75235, '2.30.42.10-FF-000440', NULL, NULL, 96, NULL, NULL, 75235),
(75236, '2.120.10.100-FF-000003', NULL, 'Apyrase calcium-activated nucleotidase SCAN-1-like protein signal peptide', 319, NULL, NULL, 75236),
(75237, '3.40.50.1010-FF-000102', NULL, 'Exosome complex exonuclease RRP44, putative', 184, NULL, NULL, 75237),
(75238, '3.40.50.300-FF-006921', NULL, 'AGAP003075-PA', 232, NULL, NULL, 75238),
(75239, '2.120.10.30-FF-000295', NULL, 'Uncharacterized protein', 288, NULL, NULL, 75239),
(75240, '1.10.640.10-FF-000103', NULL, 'Uncharacterized protein', 106, NULL, NULL, 75240),
(75241, '1.10.510.10-FF-001078', NULL, 'Kinase family protein', 214, NULL, NULL, 75241),
(75242, '3.30.470.30-FF-000005', NULL, 'mRNA capping enzyme, putative', 237, NULL, NULL, 75242),
(75243, '3.40.50.300-FF-002638', NULL, 'ATP-dependent RNA helicase-like protein', 171, NULL, NULL, 75243),
(75244, '3.80.10.10-FF-002312', NULL, 'Leucine-rich repeat family protein', 168, NULL, NULL, 75244),
(75245, '3.20.20.70-FF-000057', NULL, 'GTP 3'',8-cyclase', 329, NULL, NULL, 75245),
(75246, '3.90.1150.10-FF-000394', NULL, 'Putative alanine aminotransferase', 171, NULL, NULL, 75246),
(75247, '1.10.3520.10-FF-000010', NULL, 'Glycolipid transfer protein', 186, NULL, NULL, 75247),
(75248, '1.25.10.10-FF-000393', NULL, 'EFR3 homolog Bb (S. cerevisiae)', 439, NULL, NULL, 75248);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(75249, '3.30.160.20-FF-000018', NULL, 'RISC-loading complex subunit TARBP2 isoform X3', 71, NULL, NULL, 75249),
(75250, '3.30.70.330-FF-002007', NULL, NULL, 82, NULL, NULL, 75250),
(75251, '2.40.50.100-FF-000194', NULL, 'Uncharacterized protein', 59, NULL, NULL, 75251),
(75252, '3.40.50.300-FF-007309', NULL, 'Uncharacterized protein', 148, NULL, NULL, 75252),
(75253, '3.30.560.10-FF-000006', NULL, 'Ecdysone oxidase', 309, NULL, NULL, 75253),
(75254, '1.10.630.10-FF-000069', NULL, 'Cytochrome P450, putative (Eurofung)', 472, NULL, NULL, 75254),
(75255, '3.80.10.10-FF-002094', NULL, 'Predicted protein', 182, NULL, NULL, 75255),
(75256, '1.20.144.10-FF-000038', NULL, 'Lipid phosphate phosphatase', 253, NULL, NULL, 75256),
(75257, '1.25.10.10-FF-001011', NULL, 'Proteasome activator subunit 4', 123, NULL, NULL, 75257),
(75258, '3.30.160.60-FF-004947', NULL, NULL, 31, NULL, NULL, 75258),
(75259, '3.10.110.10-FF-000056', NULL, 'ubiquitin-conjugating enzyme E2 32', 174, NULL, NULL, 75259),
(75260, '1.10.510.10-FF-001971', NULL, 'Putative mitogen-activated protein kinase', 250, NULL, NULL, 75260),
(75261, '3.40.30.10-FF-000522', NULL, 'Thioredoxin, putative', 108, NULL, NULL, 75261),
(75262, '3.40.50.720-FF-002096', NULL, 'Uncharacterized protein', 133, NULL, NULL, 75262),
(75263, '1.25.10.10-FF-003040', NULL, 'Uncharacterized protein', 299, NULL, NULL, 75263),
(75264, '1.10.287.410-FF-000014', NULL, 'Carboxypeptidase', 77, NULL, NULL, 75264),
(75265, '1.50.40.10-FF-000162', NULL, 'Mitochondrial substrate carrier protein-like', 148, NULL, NULL, 75265),
(75266, '3.90.79.10-FF-000065', NULL, 'Invasion-associated protein A', 151, NULL, NULL, 75266),
(75267, '1.25.10.10-FF-000977', NULL, 'Coatomer subunit gamma', 554, NULL, NULL, 75267),
(75268, '3.80.10.10-FF-003936', NULL, 'Uncharacterized protein', 90, NULL, NULL, 75268),
(75269, '3.40.1110.10-FF-000240', NULL, NULL, 138, NULL, NULL, 75269),
(75270, '2.130.10.10-FF-002705', NULL, 'YALI0D18788p', 402, NULL, NULL, 75270),
(75271, '3.40.50.300-FF-004667', NULL, 'Uncharacterized protein', 167, NULL, NULL, 75271),
(75272, '3.40.50.150-FF-000204', NULL, 'Methyltransferase', 205, NULL, NULL, 75272),
(75273, '3.40.50.10490-FF-000073', NULL, 'MurR/RpiR family transcriptional regulator', 184, NULL, NULL, 75273),
(75274, '2.10.25.10-FF-001374', NULL, 'Fibropellin-1', 43, NULL, NULL, 75274),
(75275, '3.30.70.330-FF-003064', NULL, NULL, 104, NULL, NULL, 75275),
(75276, '3.40.50.1820-FF-000440', NULL, 'Carboxypeptidase', 307, NULL, NULL, 75276),
(75277, '2.120.10.30-FF-000306', NULL, 'Cell growth-regulated gene 1 protein', 330, NULL, NULL, 75277),
(75278, '3.40.47.10-FF-000156', NULL, NULL, 196, NULL, NULL, 75278),
(75279, '3.30.565.10-FF-000534', NULL, 'Histidine kinase', 163, NULL, NULL, 75279),
(75280, '3.40.30.10-FF-001141', NULL, 'Chloride intracellular channel protein', 57, NULL, NULL, 75280),
(75281, '2.60.40.10-FF-001542', NULL, 'Sallimus, isoform U', 109, NULL, NULL, 75281),
(75282, '3.30.310.80-FF-000054', NULL, 'Uncharacterized protein', 128, NULL, NULL, 75282),
(75283, '2.60.120.260-FF-000289', NULL, 'Beta-galactosidase', 174, NULL, NULL, 75283),
(75284, '3.30.2140.20-FF-000016', NULL, 'arylamine N-acetyltransferase, liver isozyme', 287, NULL, NULL, 75284),
(75285, '3.30.200.160-FF-000014', NULL, 'Uncharacterized protein', 148, NULL, NULL, 75285),
(75286, '1.10.8.60-FF-000451', NULL, 'Lon protease', 126, NULL, NULL, 75286),
(75287, '3.30.70.3420-FF-000001', NULL, 'Chlorite dismutase', 151, NULL, NULL, 75287),
(75288, '2.60.120.290-FF-000152', NULL, 'Uncharacterized protein', 121, NULL, NULL, 75288),
(75289, '1.10.8.10-FF-000133', NULL, 'UBA/TS-N domain containing protein', 54, NULL, NULL, 75289),
(75290, '2.120.10.80-FF-000164', NULL, 'Attractin-like 1', 214, NULL, NULL, 75290),
(75291, '2.60.40.10-FF-000923', NULL, 'Chaperone, PapD family protein', 91, NULL, NULL, 75291),
(75292, '3.40.50.2300-FF-000606', NULL, 'Receptor-type adenylate cyclase GRESAG 4, putative', 128, NULL, NULL, 75292),
(75293, '3.30.160.60-FF-003228', NULL, 'Zinc finger protein 236', 25, NULL, NULL, 75293);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(75294, '2.130.10.10-FF-000890', NULL, 'Probable E3 ubiquitin ligase complex SCF subunit sconB', 128, NULL, NULL, 75294),
(75295, '2.30.30.40-FF-000427', NULL, 'Peroxin 13, putative', 74, NULL, NULL, 75295),
(75296, '3.40.50.1010-FF-000091', NULL, 'Yen1p', 241, NULL, NULL, 75296),
(75297, '2.60.40.60-FF-001062', NULL, 'Uncharacterized protein', 68, NULL, NULL, 75297),
(75298, '3.60.15.10-FF-000104', NULL, 'Ribonuclease Z', 301, NULL, NULL, 75298),
(75299, '2.130.10.10-FF-003324', NULL, 'Uncharacterized protein', 107, NULL, NULL, 75299),
(75300, '3.20.200.10-FF-000010', NULL, 'Predicted protein', 111, NULL, NULL, 75300),
(75301, '2.130.10.10-FF-001632', NULL, 'Uncharacterized protein, isoform B', 186, NULL, NULL, 75301),
(75302, '3.90.190.10-FF-000239', NULL, 'Phosphatase and tensin homologue, putative', 188, NULL, NULL, 75302),
(75303, '3.40.1000.70-FF-000002', NULL, 'Lipoprotein LpqA', 168, NULL, NULL, 75303),
(75304, '1.20.1560.10-FF-000043', NULL, 'Multidrug resistance protein 1A', 599, NULL, NULL, 75304),
(75305, '3.50.50.60-FF-001033', NULL, 'Uncharacterized protein', 87, NULL, NULL, 75305),
(75306, '3.40.50.2300-FF-000388', NULL, 'Vomeronasal 2, receptor 23', 149, NULL, NULL, 75306),
(75307, '3.30.1640.10-FF-000057', NULL, 'DNA helicase', 96, NULL, NULL, 75307),
(75308, '1.20.1560.10-FF-000381', NULL, 'Probable ABC transporter ATP-binding/permease protein HI_0664', 314, NULL, NULL, 75308),
(75309, '2.30.29.30-FF-000241', NULL, 'Vacuolar protein sorting 36 homolog', 138, NULL, NULL, 75309),
(75310, '1.10.1070.11-FF-000127', NULL, 'Uncharacterized protein', 119, NULL, NULL, 75310),
(75311, '3.30.428.10-FF-000076', NULL, 'Galactose-1-phosphate uridylyltransferase', 125, NULL, NULL, 75311),
(75312, '3.80.10.10-FF-004460', NULL, 'Leucine-rich repeat receptor protein kinase EMS1', 92, NULL, NULL, 75312),
(75313, '3.60.20.10-FF-000173', NULL, NULL, 192, NULL, NULL, 75313),
(75314, '1.10.287.70-FF-000620', NULL, 'Uncharacterized protein', 238, NULL, NULL, 75314),
(75315, '3.40.50.300-FF-007298', NULL, 'Conserved within P. aerophilum', 151, NULL, NULL, 75315),
(75316, '1.20.1440.230-FF-000004', NULL, 'GD25625', 96, NULL, NULL, 75316),
(75317, '3.40.1410.10-FF-000043', NULL, 'DNA-binding transcriptional regulator FrlR', 166, NULL, NULL, 75317),
(75318, '3.30.300.30-FF-000105', NULL, 'Enniatin synthase', 92, NULL, NULL, 75318),
(75319, '2.60.120.260-FF-000507', NULL, 'Uncharacterized protein', 60, NULL, NULL, 75319),
(75320, '3.40.50.300-FF-001913', NULL, 'ABC transporter E family member 2', 236, NULL, NULL, 75320),
(75321, '1.10.240.10-FF-000011', NULL, 'Tyrosine--tRNA ligase', 128, NULL, NULL, 75321),
(75322, '1.20.120.1530-FF-000018', NULL, NULL, 95, NULL, NULL, 75322),
(75323, '3.30.40.10-FF-000309', NULL, 'E3 ubiquitin-protein ligase MBR2', 79, NULL, NULL, 75323),
(75324, '1.10.8.60-FF-000237', NULL, 'Sigma-54 dependent transcriptional regulator', 77, NULL, NULL, 75324),
(75325, '3.30.750.24-FF-000129', NULL, 'Anti-sigma factor antagonist', 112, NULL, NULL, 75325),
(75326, '3.40.50.20-FF-000072', NULL, 'ATP domain protein', 108, NULL, NULL, 75326),
(75327, '1.10.510.10-FF-002696', NULL, NULL, 144, NULL, NULL, 75327),
(75328, '1.20.1070.10-FF-001815', NULL, 'Uncharacterized protein', 356, NULL, NULL, 75328),
(75329, '1.10.510.10-FF-000459', NULL, 'Casein kinase II subunit alpha', 210, NULL, NULL, 75329),
(75330, '2.40.50.770-FF-000023', NULL, 'Uncharacterized protein', 160, NULL, NULL, 75330),
(75331, '3.20.20.190-FF-000029', NULL, 'Glycerophosphodiester phosphodiesterase 1 isoform X1', 268, NULL, NULL, 75331),
(75332, '1.20.58.60-FF-000241', NULL, 'microtubule-actin cross-linking factor 1 isoform X4', 209, NULL, NULL, 75332),
(75333, '2.60.120.620-FF-000060', NULL, 'WGS project CABT00000000 data, contig 2.4', 231, NULL, NULL, 75333),
(75334, '3.30.70.330-FF-001939', NULL, NULL, 135, NULL, NULL, 75334),
(75335, '3.10.100.10-FF-000128', NULL, 'Mannose receptor, C type 1b', 134, NULL, NULL, 75335),
(75336, '3.80.10.10-FF-004004', NULL, 'Si:ch211-159i8.4', 150, NULL, NULL, 75336),
(75337, '1.10.620.20-FF-000009', NULL, 'Uncharacterized protein', 269, NULL, NULL, 75337);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(75338, '3.30.200.20-FF-001354', NULL, 'Uncharacterized protein', 79, NULL, NULL, 75338),
(75339, '3.40.50.2000-FF-001130', NULL, 'Uncharacterized protein', 92, NULL, NULL, 75339),
(75340, '1.10.510.10-FF-002488', NULL, NULL, 201, NULL, NULL, 75340),
(75341, '1.10.640.10-FF-000019', NULL, 'Eosinophil peroxidase', 397, NULL, NULL, 75341),
(75342, '3.30.540.10-FF-000095', NULL, 'Putative PAP-specific phosphatase mitochondrial', 169, NULL, NULL, 75342),
(75343, '3.40.1110.10-FF-000026', NULL, 'Cation-transporting ATPase', 164, NULL, NULL, 75343),
(75344, '3.40.50.300-FF-008613', NULL, 'Uncharacterized protein', 59, NULL, NULL, 75344),
(75345, '1.25.40.10-FF-000462', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 100, NULL, NULL, 75345),
(75346, '1.10.10.10-FF-000797', NULL, 'RHO1 GDP-GTP exchange protein 1', 136, NULL, NULL, 75346),
(75347, '1.25.40.10-FF-002362', NULL, 'ERAD-associated E3 ubiquitin-protein ligase component HRD3A', 111, NULL, NULL, 75347),
(75348, '1.25.10.10-FF-002079', NULL, 'Uncharacterized protein', 132, NULL, NULL, 75348),
(75349, '1.10.1320.10-FF-000011', NULL, 'DNA-directed RNA polymerase', 324, NULL, NULL, 75349),
(75350, '1.10.10.2590-FF-000004', NULL, 'BEN domain-containing protein 6 isoform X1', 104, NULL, NULL, 75350),
(75351, '2.40.50.140-FF-000655', NULL, NULL, 71, NULL, NULL, 75351),
(75352, '3.40.720.10-FF-000264', NULL, 'Predicted protein', 433, NULL, NULL, 75352),
(75353, '1.20.1280.20-FF-000007', NULL, 'Fe-S protein assembly co-chaperone HscB', 80, NULL, NULL, 75353),
(75354, '1.20.1260.10-FF-000009', NULL, 'Ferritin light chain', 175, NULL, NULL, 75354),
(75355, '3.30.160.60-FF-001171', NULL, 'Zinc finger protein 236', 27, NULL, NULL, 75355),
(75356, '1.25.40.190-FF-000005', NULL, 'Actin-related protein 2/3 complex subunit 5', 159, NULL, NULL, 75356),
(75357, '3.40.1170.60-FF-000011', NULL, 'Polymerase (DNA directed), eta', 29, NULL, NULL, 75357),
(75358, '1.10.10.60-FF-000328', NULL, 'MYB transcription factor', 58, NULL, NULL, 75358),
(75359, '1.10.238.10-FF-000438', NULL, 'Probable calcium-binding protein CML15', 118, NULL, NULL, 75359),
(75360, '3.30.420.140-FF-000029', NULL, 'Putative pre-16S rRNA nuclease', 119, NULL, NULL, 75360),
(75361, '1.10.472.10-FF-000128', NULL, 'TFIIK subunit', 113, NULL, NULL, 75361),
(75362, '3.40.50.720-FF-002180', NULL, 'Uncharacterized protein', 56, NULL, NULL, 75362),
(75363, '3.40.50.450-FF-000070', NULL, 'Uncharacterized protein', 180, NULL, NULL, 75363),
(75364, '1.10.510.10-FF-000358', NULL, 'Putative leucine-rich repeat receptor-like serine/threonine-protein kinase', 221, NULL, NULL, 75364),
(75365, '3.10.28.10-FF-000052', NULL, 'Uncharacterized cox1 intron-1 45.6 kDa protein', 161, NULL, NULL, 75365),
(75366, '2.120.10.80-FF-000405', NULL, 'Uncharacterized protein', 301, NULL, NULL, 75366),
(75367, '1.10.287.1490-FF-000058', NULL, 'Centrosomal protein of 83 kDa', 128, NULL, NULL, 75367),
(75368, '2.60.40.1180-FF-000087', NULL, 'Trehalose-6-phosphate hydrolase', 78, NULL, NULL, 75368),
(75369, '1.20.1560.10-FF-000622', NULL, 'Serine protease/ABC transporter B family protein tagA', 323, NULL, NULL, 75369),
(75370, '2.60.120.260-FF-000497', NULL, 'Uncharacterized protein', 94, NULL, NULL, 75370),
(75371, '3.40.50.300-FF-002970', NULL, 'ABC-F type ribosomal protection protein', 84, NULL, NULL, 75371),
(75372, '1.20.120.770-FF-000002', NULL, 'beta-amyloid-like protein isoform X1', 224, NULL, NULL, 75372),
(75373, '2.130.10.10-FF-002913', NULL, 'Pre-rRNA-processing protein pro-1', 255, NULL, NULL, 75373),
(75374, '3.40.50.720-FF-000280', NULL, 'Nitrogen metabolite repression regulator NmrA', 207, NULL, NULL, 75374),
(75375, '1.10.3500.10-FF-000008', NULL, 'Uncharacterized protein', 49, NULL, NULL, 75375),
(75376, '1.25.10.10-FF-001814', NULL, 'LD12333p', 96, NULL, NULL, 75376),
(75377, '3.40.30.10-FF-000730', NULL, 'Uncharacterized protein', 127, NULL, NULL, 75377),
(75378, '3.40.190.290-FF-000080', NULL, 'LysR family transcriptional regulator', 201, NULL, NULL, 75378),
(75379, '2.170.300.10-FF-000037', NULL, 'Netrin-B, isoform G', 109, NULL, NULL, 75379); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(75380, '3.40.50.1260-FF-000036', NULL, 'Phosphoglycerate kinase', 62, NULL, NULL, 75380),
(75381, '3.10.20.90-FF-000928', NULL, 'Uncharacterized protein', 81, NULL, NULL, 75381),
(75382, '1.10.510.10-FF-004388', NULL, NULL, 92, NULL, NULL, 75382),
(75383, '3.30.1360.30-FF-000002', NULL, 'Aspartate--tRNA ligase, mitochondrial', 152, NULL, NULL, 75383),
(75384, '3.30.450.20-FF-000557', NULL, 'Histidine kinase sensor protein', 112, NULL, NULL, 75384),
(75385, '2.60.120.260-FF-000154', NULL, 'laminin subunit alpha-1 isoform X1', 274, NULL, NULL, 75385),
(75386, '1.20.1250.20-FF-002299', NULL, 'Uncharacterized protein', 489, NULL, NULL, 75386),
(75387, '3.40.50.1820-FF-000232', NULL, 'Probable carboxylesterase SOBER1-like', 224, NULL, NULL, 75387),
(75388, '2.130.10.10-FF-004942', NULL, 'Uncharacterized protein', 100, NULL, NULL, 75388),
(75389, '1.10.3380.30-FF-000009', NULL, 'DExH-box ATP-dependent RNA helicase DExH9', 230, NULL, NULL, 75389),
(75390, '2.60.40.10-FF-004734', NULL, NULL, 96, NULL, NULL, 75390),
(75391, '1.10.287.130-FF-000020', NULL, 'Sensor histidine kinase DpiB', 65, NULL, NULL, 75391),
(75392, '2.70.98.10-FF-000090', NULL, 'Putative glucose-6-phosphate 1-epimerase', 303, NULL, NULL, 75392),
(75393, '3.40.50.1010-FF-000203', NULL, NULL, 235, NULL, NULL, 75393),
(75394, '3.30.450.20-FF-000214', NULL, 'Hypoxia-inducible factor 1-alpha', 136, NULL, NULL, 75394),
(75395, '1.20.1250.10-FF-000071', NULL, 'Interleukin 4', 110, NULL, NULL, 75395),
(75396, '1.10.600.10-FF-000106', NULL, 'Terpene synthase', 329, NULL, NULL, 75396),
(75397, '1.10.510.10-FF-001319', NULL, 'Protein kinase, putative', 257, NULL, NULL, 75397),
(75398, '1.10.10.570-FF-000005', NULL, 'Vacuolar protein-sorting-associated protein 25', 125, NULL, NULL, 75398),
(75399, '1.10.555.10-FF-000220', NULL, NULL, 233, NULL, NULL, 75399),
(75400, '3.30.200.20-FF-000415', NULL, 'receptor-like serine/threonine-protein kinase NCRK', 102, NULL, NULL, 75400),
(75401, '1.10.510.10-FF-001639', NULL, 'RE09533p', 280, NULL, NULL, 75401),
(75402, '1.10.10.60-FF-000087', NULL, 'DNA methyltransferase 1-associated protein 1', 92, NULL, NULL, 75402),
(75403, '3.30.2410.10-FF-000006', NULL, 'probable E3 ubiquitin-protein ligase HERC1 isoform X2', 116, NULL, NULL, 75403),
(75404, '2.60.200.20-FF-000249', NULL, 'Uncharacterized protein', 115, NULL, NULL, 75404),
(75405, '2.60.20.10-FF-000017', NULL, 'Beta-gamma-crystallin', 96, NULL, NULL, 75405),
(75406, '3.30.420.270-FF-000040', NULL, 'Tol-Pal system protein TolR', 75, NULL, NULL, 75406),
(75407, '3.30.420.10-FF-000176', NULL, 'DNA polymerase I', 168, NULL, NULL, 75407),
(75408, '1.25.40.10-FF-002603', NULL, 'Pentatricopeptide repeat-containing protein', 65, NULL, NULL, 75408),
(75409, '1.20.58.390-FF-000102', NULL, 'Glycine receptor subunit beta-type 4', 140, NULL, NULL, 75409),
(75410, '3.30.160.60-FF-000002', NULL, 'Zinc finger protein 1 homolog', 28, NULL, NULL, 75410),
(75411, '1.10.630.10-FF-000277', NULL, 'Brain aromatase', 90, NULL, NULL, 75411),
(75412, '3.30.160.60-FF-001412', NULL, 'Zinc finger protein 546', 31, NULL, NULL, 75412),
(75413, '1.50.40.10-FF-000370', NULL, 'Uncharacterized protein', 141, NULL, NULL, 75413),
(75414, '1.20.120.980-FF-000059', NULL, 'Uncharacterized protein', 17, NULL, NULL, 75414),
(75415, '3.40.50.2000-FF-000753', NULL, 'Protein CBG17955', 87, NULL, NULL, 75415),
(75416, '3.30.1370.120-FF-000020', NULL, 'Type II secretion system lipoprotein GspD, putative', 82, NULL, NULL, 75416),
(75417, '3.60.20.10-FF-000072', NULL, 'Proteasome subunit alpha type', 245, NULL, NULL, 75417),
(75418, '3.30.160.60-FF-004846', NULL, NULL, 89, NULL, NULL, 75418),
(75419, '3.40.50.360-FF-000155', NULL, 'Putative cytochrome P450 reductase', 233, NULL, NULL, 75419),
(75420, '3.30.1330.40-FF-000054', NULL, 'Uncharacterized protein', 120, NULL, NULL, 75420),
(75421, '3.40.50.300-FF-000053', NULL, 'Signal recognition particle receptor FtsY', 209, NULL, NULL, 75421),
(75422, '3.15.10.30-FF-000006', NULL, 'GM10322', 223, NULL, NULL, 75422),
(75423, '1.20.1080.10-FF-000118', NULL, 'Uncharacterized protein', 98, NULL, NULL, 75423);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(75424, '2.30.30.100-FF-000147', NULL, 'Probable U6 snRNA-associated Sm-like protein LSm5', 76, NULL, NULL, 75424),
(75425, '1.10.238.10-FF-001057', NULL, 'Uncharacterized protein', 159, NULL, NULL, 75425),
(75426, '2.60.40.150-FF-000258', NULL, 'Misfire, isoform B', 128, NULL, NULL, 75426),
(75427, '1.10.3450.20-FF-000001', NULL, 'Nuclear pore complex protein', 142, NULL, NULL, 75427),
(75428, '1.25.10.10-FF-001915', NULL, 'Probable serine/threonine-protein kinase vps15', 169, NULL, NULL, 75428),
(75429, '2.40.50.40-FF-000107', NULL, 'C-C motif chemokine', 70, NULL, NULL, 75429),
(75430, '3.30.70.240-FF-000058', NULL, 'Uncharacterized protein', 41, NULL, NULL, 75430),
(75431, '3.40.630.30-FF-000055', NULL, 'Ribosomal-protein-alanine acetyltransferase', 104, NULL, NULL, 75431),
(75432, '3.90.70.10-FF-000657', NULL, 'Battenin', 78, NULL, NULL, 75432),
(75433, '3.30.70.1940-FF-000001', NULL, 'tRNA(cytosine(8)) deaminase', 80, NULL, NULL, 75433),
(75434, '1.20.1250.20-FF-000511', NULL, 'MFS general substrate transporter', 202, NULL, NULL, 75434),
(75435, '3.10.400.20-FF-000036', NULL, 'Ligatin, putative', 67, NULL, NULL, 75435),
(75436, '3.40.50.12760-FF-000012', NULL, 'E3 ubiquitin-protein ligase RNF8', 131, NULL, NULL, 75436),
(75437, '1.10.3450.40-FF-000007', NULL, 'Signal recognition particle protein SRP68', 217, NULL, NULL, 75437),
(75438, '3.40.850.10-FF-000268', NULL, 'Kinesin KP1', 367, NULL, NULL, 75438),
(75439, '3.10.20.90-FF-000024', NULL, 'Erythrocyte membrane protein band 4.1-like 5', 84, NULL, NULL, 75439),
(75440, '1.10.10.10-FF-001281', NULL, 'Ribosomal protein S19e, putative', 145, NULL, NULL, 75440),
(75441, '3.40.50.670-FF-000012', NULL, 'DNA gyrase subunit B', 187, NULL, NULL, 75441),
(75442, '2.40.10.10-FF-000568', NULL, NULL, 66, NULL, NULL, 75442),
(75443, '3.30.160.60-FF-000895', NULL, 'Zinc finger protein 597', 27, NULL, NULL, 75443),
(75444, '3.40.50.10990-FF-000014', NULL, '3,4-dihydroxy-2-butanone 4-phosphate synthase', 163, NULL, NULL, 75444),
(75445, '2.10.90.10-FF-000035', NULL, 'Spz1', 106, NULL, NULL, 75445),
(75446, '3.40.50.620-FF-000267', NULL, 'Isoleucine--tRNA ligase, putative', 204, NULL, NULL, 75446),
(75447, '1.10.10.10-FF-001623', NULL, 'ArsR family transcriptional regulator', 99, NULL, NULL, 75447),
(75448, '2.120.10.30-FF-000065', NULL, 'Hemomucin', 259, NULL, NULL, 75448),
(75449, '3.40.50.300-FF-005044', NULL, 'Uncharacterized protein', 176, NULL, NULL, 75449),
(75450, '2.40.30.10-FF-000468', NULL, 'Uncharacterized protein', 79, NULL, NULL, 75450),
(75451, '3.30.70.330-FF-000293', NULL, 'insulin-like growth factor 2 mRNA-binding protein 2 isoform X1', 81, NULL, NULL, 75451),
(75452, '3.30.70.330-FF-001035', NULL, 'Ribosome biogenesis', 173, NULL, NULL, 75452),
(75453, '3.40.50.620-FF-000143', NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', 351, NULL, NULL, 75453),
(75454, '3.30.200.20-FF-001034', NULL, 'Protein kinase domain containing protein', 64, NULL, NULL, 75454),
(75455, '3.40.30.10-FF-001247', NULL, 'Bidirectional NAD-reducing hydrogenase, diaphorase subunit', 101, NULL, NULL, 75455),
(75456, '1.25.40.20-FF-001521', NULL, 'Kinase, NEK', 138, NULL, NULL, 75456),
(75457, '2.60.40.10-FF-000682', NULL, 'Tenascin R', 90, NULL, NULL, 75457),
(75458, '3.40.50.300-FF-003144', NULL, 'Putative multidrug resistance-associated protein lethal(2)03659-like Protein', 257, NULL, NULL, 75458),
(75459, '1.10.565.10-FF-000046', NULL, 'Hormone receptor 51', 233, NULL, NULL, 75459),
(75460, '3.60.40.10-FF-000168', NULL, 'Protein phosphatase 2C', 274, NULL, NULL, 75460),
(75461, '3.30.2350.10-FF-000086', NULL, 'Pseudouridine synthase', 230, NULL, NULL, 75461),
(75462, '3.30.160.60-FF-002817', NULL, 'Transcriptional regulator MNL1', 23, NULL, NULL, 75462),
(75463, '1.25.10.10-FF-002534', NULL, 'Uncharacterized protein', 185, NULL, NULL, 75463),
(75464, '4.10.1000.10-FF-000092', NULL, 'Uncharacterized protein', 77, NULL, NULL, 75464),
(75465, '1.25.40.10-FF-001642', NULL, 'Selenium-binding protein-like', 235, NULL, NULL, 75465),
(75466, '2.130.10.10-FF-000991', NULL, 'Transducin beta like 3', 206, NULL, NULL, 75466);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(75467, '2.60.40.10-FF-003672', NULL, NULL, 101, NULL, NULL, 75467),
(75468, '1.20.58.1200-FF-000001', NULL, 'Si:ch211-108d22.2', 73, NULL, NULL, 75468),
(75469, '3.30.300.150-FF-000005', NULL, 'DNA polymerase III subunit gamma/tau', 124, NULL, NULL, 75469),
(75470, '3.20.20.70-FF-000720', NULL, NULL, 112, NULL, NULL, 75470),
(75471, '1.20.1070.10-FF-000635', NULL, 'Uncharacterized protein', 116, NULL, NULL, 75471),
(75472, '1.10.510.10-FF-002590', NULL, NULL, 205, NULL, NULL, 75472),
(75473, '2.30.29.30-FF-000466', NULL, 'carboxyl-terminal PDZ ligand of neuronal nitric oxide synthase protein-like', 117, NULL, NULL, 75473),
(75474, '2.130.10.10-FF-000098', NULL, 'WD repeat-containing protein slp1', 351, NULL, NULL, 75474),
(75475, '1.25.10.10-FF-003383', NULL, 'Dynein axonemal assembly factor 5', 144, NULL, NULL, 75475),
(75476, '3.60.110.10-FF-000039', NULL, 'Glutamine-dependent NAD(+) synthetase', 226, NULL, NULL, 75476),
(75477, '3.30.70.270-FF-000151', NULL, 'Polymerase (DNA directed) kappa', 151, NULL, NULL, 75477),
(75478, '2.130.10.10-FF-005662', NULL, 'Uncharacterized protein', 165, NULL, NULL, 75478),
(75479, '3.30.710.10-FF-000058', NULL, 'Zinc finger and BTB domain containing 40', 133, NULL, NULL, 75479),
(75480, '3.40.1190.20-FF-000011', NULL, '2-dehydro-3-deoxygluconokinase, putative', 308, NULL, NULL, 75480),
(75481, '3.40.50.300-FF-004768', NULL, 'ATP-dependent DNA helicase', 130, NULL, NULL, 75481),
(75482, '3.30.70.860-FF-000002', NULL, 'DUF406 family protein', 93, NULL, NULL, 75482),
(75483, '1.20.1530.20-FF-000090', NULL, 'Uncharacterized protein', 293, NULL, NULL, 75483),
(75484, '2.30.29.30-FF-000342', NULL, 'beta-1-syntrophin isoform X1', 74, NULL, NULL, 75484),
(75485, '2.60.40.10-FF-005353', NULL, NULL, 66, NULL, NULL, 75485),
(75486, '2.60.40.150-FF-000590', NULL, 'MecKel-Gruber Syndrome (MKS) homolog', 149, NULL, NULL, 75486),
(75487, '1.20.1280.50-FF-000090', NULL, 'F-box protein', 49, NULL, NULL, 75487),
(75488, '2.60.120.470-FF-000003', NULL, 'DUF1000 domain protein (AFU_orthologue AFUA_1G09230)', 166, NULL, NULL, 75488),
(75489, '1.10.4160.10-FF-000038', NULL, NULL, 196, NULL, NULL, 75489),
(75490, '2.30.30.40-FF-000657', NULL, 'Tyrosine-protein kinase', 67, NULL, NULL, 75490),
(75491, '3.40.640.10-FF-000443', NULL, 'Cystathionase, putative', 165, NULL, NULL, 75491),
(75492, '2.40.37.10-FF-000034', NULL, 'S-adenosylmethionine decarboxylase/ornithine decarboxylase', 33, NULL, NULL, 75492),
(75493, '3.40.50.10190-FF-000218', NULL, 'DNA ligase', 104, NULL, NULL, 75493),
(75494, '3.40.50.1110-FF-000019', NULL, 'GDSL Lipase/Acylhydrolase family protein', 246, NULL, NULL, 75494),
(75495, '3.50.50.60-FF-000313', NULL, 'Possible oxidoreductase', 351, NULL, NULL, 75495),
(75496, '2.60.200.10-FF-000016', NULL, 'Mothers against decapentaplegic homolog', 76, NULL, NULL, 75496),
(75497, '2.60.40.10-FF-001643', NULL, 'Putative Sortilin-related receptor', 87, NULL, NULL, 75497),
(75498, '3.30.420.40-FF-001000', NULL, 'Heat shock 70 kDa protein 14', 74, NULL, NULL, 75498),
(75499, '3.40.50.10090-FF-000060', NULL, 'Uncharacterized protein', 48, NULL, NULL, 75499),
(75500, '1.10.287.110-FF-000481', NULL, 'Uncharacterized protein', 83, NULL, NULL, 75500),
(75501, '1.10.10.10-FF-000662', NULL, 'Poly (ADP-ribose) polymerase family, member 12', 70, NULL, NULL, 75501),
(75502, '3.40.50.410-FF-000294', NULL, 'Predicted protein', 185, NULL, NULL, 75502),
(75503, '3.40.50.1820-FF-000575', NULL, 'Putative carboxypeptidase 2', 240, NULL, NULL, 75503),
(75504, '2.10.25.10-FF-000317', NULL, 'latent-transforming growth factor beta-binding protein 3 isoform X2', 41, NULL, NULL, 75504),
(75505, '3.30.160.60-FF-003666', NULL, 'Zgc:110821', 29, NULL, NULL, 75505),
(75506, '3.30.200.20-FF-000073', NULL, 'Mitogen-activated protein kinase', 91, NULL, NULL, 75506),
(75507, '3.30.420.40-FF-000724', NULL, 'actin isoform X1', 160, NULL, NULL, 75507),
(75508, '1.20.1270.250-FF-000004', NULL, NULL, 64, NULL, NULL, 75508),
(75509, '1.10.287.70-FF-000041', NULL, 'Transient receptor potential cation channel subfamily C member 7', 128, NULL, NULL, 75509);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(75510, '3.30.1370.10-FF-000165', NULL, 'Far upstream element (FUSE)-binding protein 3', 60, NULL, NULL, 75510),
(75511, '2.30.30.380-FF-000062', NULL, 'Predicted protein', 46, NULL, NULL, 75511),
(75512, '3.30.565.10-FF-000433', NULL, 'Sensory histidine protein kinase', 160, NULL, NULL, 75512),
(75513, '1.25.40.10-FF-001081', NULL, 'Pentatricopeptide repeat-containing protein At2g20540', 121, NULL, NULL, 75513),
(75514, '3.40.50.2000-FF-001017', NULL, 'Uncharacterized protein', 184, NULL, NULL, 75514),
(75515, '3.40.47.10-FF-000257', NULL, NULL, 289, NULL, NULL, 75515),
(75516, '1.25.10.10-FF-000634', NULL, 'integrator complex subunit 4 isoform X2', 399, NULL, NULL, 75516),
(75517, '2.80.10.50-FF-000106', NULL, 'Pierisin', 149, NULL, NULL, 75517),
(75518, '4.10.320.30-FF-000001', NULL, 'Myelin transcription factor 1-like, a', 32, NULL, NULL, 75518),
(75519, '1.10.8.720-FF-000058', NULL, 'Uncharacterized protein', 190, NULL, NULL, 75519),
(75520, '1.20.58.1220-FF-000007', NULL, 'Exocyst complex component', 104, NULL, NULL, 75520),
(75521, '3.90.550.10-FF-000211', NULL, 'Putative glycosyltransferase EpsJ', 204, NULL, NULL, 75521),
(75522, '1.20.1250.20-FF-000854', NULL, 'Solute carrier organic anion transporter family member', 373, NULL, NULL, 75522),
(75523, '1.20.1070.10-FF-001484', NULL, 'Si:ch211-137j23.7', 207, NULL, NULL, 75523),
(75524, '3.10.20.90-FF-000367', NULL, 'Unplaced genomic scaffold supercont1.15, whole genome shotgun sequence', 138, NULL, NULL, 75524),
(75525, '3.40.630.10-FF-000392', NULL, 'Uncharacterized protein', 42, NULL, NULL, 75525),
(75526, '1.20.120.1910-FF-000025', NULL, 'Cysteine--tRNA ligase', 156, NULL, NULL, 75526),
(75527, '1.20.58.60-FF-000230', NULL, 'Uncharacterized protein, isoform D', 110, NULL, NULL, 75527),
(75528, '1.25.40.860-FF-000009', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 88, NULL, NULL, 75528),
(75529, '2.60.40.150-FF-000488', NULL, 'Uncharacterized protein', 158, NULL, NULL, 75529),
(75530, '3.30.310.210-FF-000003', NULL, 'IGF-II mRNA-binding protein, isoform D', 166, NULL, NULL, 75530),
(75531, '1.20.1270.60-FF-000165', NULL, 'BAI1-associated protein 2', 159, NULL, NULL, 75531),
(75532, '3.30.160.60-FF-000232', NULL, 'Krueppel-like factor 9', 34, NULL, NULL, 75532),
(75533, '1.10.10.60-FF-000648', NULL, 'GD18444', 100, NULL, NULL, 75533),
(75534, '2.40.50.140-FF-000076', NULL, '26S protease regulatory subunit 6A', 128, NULL, NULL, 75534),
(75535, '1.20.120.1630-FF-000031', NULL, 'Prostatic steroid 5-alpha-reductase type I, putative', 190, NULL, NULL, 75535),
(75536, '1.20.1250.20-FF-001130', NULL, 'Uncharacterized MFS-type transporter YfiU', 159, NULL, NULL, 75536),
(75537, '1.10.720.30-FF-000054', NULL, '3''-5'' exoribonuclease 1-like', 71, NULL, NULL, 75537),
(75538, '1.10.510.10-FF-000690', NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 128', 172, NULL, NULL, 75538),
(75539, '3.30.40.10-FF-001737', NULL, 'Si:ch211-119o8.6', 103, NULL, NULL, 75539),
(75540, '3.40.50.11660-FF-000013', NULL, 'Alpha1,3fucosyltransferase', 216, NULL, NULL, 75540),
(75541, '2.130.10.10-FF-000659', NULL, 'Transducin beta-like protein 2', 107, NULL, NULL, 75541),
(75542, '3.40.50.300-FF-001458', NULL, 'Bifunctional cobinamide kinase/cobinamide phosphate guanylyltransferase', 176, NULL, NULL, 75542),
(75543, '3.60.21.60-FF-000015', NULL, 'DNA polymerase alpha subunit B', 161, NULL, NULL, 75543),
(75544, '3.40.50.1240-FF-000154', NULL, NULL, 233, NULL, NULL, 75544),
(75545, '1.10.287.70-FF-000165', NULL, 'Two-pore potassium channel 5', 111, NULL, NULL, 75545),
(75546, '3.40.630.30-FF-000398', NULL, '[Citrate [pro-3S]-lyase] ligase', 121, NULL, NULL, 75546),
(75547, '3.80.10.10-FF-003268', NULL, 'Adhesion molecule with Ig like domain 1', 138, NULL, NULL, 75547),
(75548, '3.40.1000.30-FF-000018', NULL, 'Uncharacterized protein', 148, NULL, NULL, 75548),
(75549, '2.60.40.10-FF-005358', NULL, NULL, 65, NULL, NULL, 75549),
(75550, '3.40.50.300-FF-001464', NULL, 'Arginyl-tRNA synthetase', 353, NULL, NULL, 75550),
(75551, '1.10.10.850-FF-000005', NULL, NULL, 49, NULL, NULL, 75551);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(75552, '2.20.100.10-FF-000057', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 5', 55, NULL, NULL, 75552),
(75553, '1.50.10.10-FF-000222', NULL, 'alpha-1,2-Mannosidase', 66, NULL, NULL, 75553),
(75554, '1.10.472.10-FF-000010', NULL, 'G1/S-specific cyclin Cln1', 114, NULL, NULL, 75554),
(75555, '2.10.25.10-FF-000188', NULL, 'Laminin subunit gamma 2', 53, NULL, NULL, 75555),
(75556, '2.80.10.50-FF-000005', NULL, 'Inositol 1,4,5-trisphosphate receptor type 2', 176, NULL, NULL, 75556),
(75557, '3.40.850.10-FF-000037', NULL, 'kinesin-like protein KIF19', 352, NULL, NULL, 75557),
(75558, '3.40.390.10-FF-000013', NULL, 'Mitochondrial intermediate peptidase', 152, NULL, NULL, 75558),
(75559, '1.20.58.760-FF-000011', NULL, 'Probable inactive ATP-dependent zinc metalloprotease FTSHI 1, chloroplastic', 225, NULL, NULL, 75559),
(75560, '1.10.600.10-FF-000129', NULL, 'Diterpene cyclase DtcycA', 361, NULL, NULL, 75560),
(75561, '3.30.160.60-FF-005914', NULL, NULL, 27, NULL, NULL, 75561),
(75562, '3.30.160.60-FF-001643', NULL, 'Zinc finger with KRAB and SCAN domains 5', 33, NULL, NULL, 75562),
(75563, '1.20.1560.10-FF-000386', NULL, 'ABC transporter, ATP-binding transmembrane protein', 321, NULL, NULL, 75563),
(75564, '3.50.50.60-FF-001370', NULL, 'Flavin-containing monooxygenase', 182, NULL, NULL, 75564),
(75565, '2.60.260.20-FF-000017', NULL, 'dnaJ homolog subfamily A member 3, mitochondrial', 51, NULL, NULL, 75565),
(75566, '3.40.50.300-FF-004212', NULL, 'Predicted protein', 118, NULL, NULL, 75566),
(75567, '3.90.470.20-FF-000045', NULL, 'Phosphopantetheinyl transferase PptB', 144, NULL, NULL, 75567),
(75568, '2.130.10.10-FF-003301', NULL, 'WD repeat-containing protein PCN', 138, NULL, NULL, 75568),
(75569, '3.40.640.10-FF-000342', NULL, 'Cystathionine gamma-lyase', 250, NULL, NULL, 75569),
(75570, '3.40.50.300-FF-003700', NULL, 'DExD/H-box helicase 58', 63, NULL, NULL, 75570),
(75571, '3.40.50.10490-FF-000078', NULL, 'Galactosamine 6-phosphate isomerase AgaS', 187, NULL, NULL, 75571),
(75572, '2.40.30.70-FF-000003', NULL, 'tRNA (Adenine(37)-N6)-methyltransferase isoform A', 157, NULL, NULL, 75572),
(75573, '3.30.160.60-FF-006426', NULL, NULL, 23, NULL, NULL, 75573),
(75574, '1.25.10.10-FF-000409', NULL, 'Uncharacterized protein', 238, NULL, NULL, 75574),
(75575, '1.20.58.60-FF-000685', NULL, 'Predicted protein', 114, NULL, NULL, 75575),
(75576, '1.10.10.10-FF-000667', NULL, 'Arginine repressor', 89, NULL, NULL, 75576),
(75577, '2.130.10.10-FF-003189', NULL, 'Cilia- and flagella-associated protein 43', 122, NULL, NULL, 75577),
(75578, '3.30.1360.220-FF-000003', NULL, 'Zinc finger FYVE domain-containing protein', 63, NULL, NULL, 75578),
(75579, '1.25.40.1030-FF-000052', NULL, 'Protein transport protein sec31', 424, NULL, NULL, 75579),
(75580, '1.10.10.10-FF-001179', NULL, 'Predicted protein', 70, NULL, NULL, 75580),
(75581, '2.60.40.10-FF-001087', NULL, 'Colony stimulating factor 2 receptor alpha subunit', 106, NULL, NULL, 75581),
(75582, '3.30.40.10-FF-000883', NULL, 'Uncharacterized protein, isoform A', 87, NULL, NULL, 75582),
(75583, '3.50.50.60-FF-000757', NULL, 'Rab proteins geranylgeranyltransferase component A', 95, NULL, NULL, 75583),
(75584, '3.40.50.300-FF-008478', NULL, 'Uncharacterized protein', 213, NULL, NULL, 75584),
(75585, '1.25.10.10-FF-001354', NULL, 'U3 small nucleolar RNA-associated protein 10', 261, NULL, NULL, 75585),
(75586, '1.20.920.10-FF-000224', NULL, 'Uncharacterized protein', 63, NULL, NULL, 75586),
(75587, '1.10.8.10-FF-000138', NULL, 'UV excision repair RAD23-like protein', 45, NULL, NULL, 75587),
(75588, '1.10.472.30-FF-000016', NULL, NULL, 57, NULL, NULL, 75588),
(75589, '3.30.40.230-FF-000009', NULL, 'Glycine--tRNA ligase', 26, NULL, NULL, 75589),
(75590, '3.20.20.140-FF-000256', NULL, 'AGAP006162-PA', 298, NULL, NULL, 75590),
(75591, '1.10.630.10-FF-000064', NULL, 'Cytochrome P450 monooxygenase', 472, NULL, NULL, 75591),
(75592, '2.60.120.260-FF-000266', NULL, 'Uncharacterized protein', 142, NULL, NULL, 75592),
(75593, '1.10.287.70-FF-000726', NULL, 'Uncharacterized protein', 129, NULL, NULL, 75593); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(75594, '3.30.40.10-FF-001395', NULL, 'Putative histone-lysine n-methyltransferase 2c-like isoform x6', 43, NULL, NULL, 75594),
(75595, '1.10.510.10-FF-000010', NULL, 'Ribosomal protein S6 kinase', 197, NULL, NULL, 75595),
(75596, '2.120.10.80-FF-000169', NULL, 'F-box family protein', 279, NULL, NULL, 75596),
(75597, '2.40.37.10-FF-000057', NULL, NULL, 145, NULL, NULL, 75597),
(75598, '2.30.30.490-FF-000095', NULL, 'Uncharacterized protein', 49, NULL, NULL, 75598),
(75599, '2.60.40.10-FF-004846', NULL, NULL, 99, NULL, NULL, 75599),
(75600, '3.40.50.300-FF-000952', NULL, 'Replication factor C subunit 2', 163, NULL, NULL, 75600),
(75601, '3.40.390.10-FF-000120', NULL, 'Protein CBG24150', 138, NULL, NULL, 75601),
(75602, '3.40.50.300-FF-008490', NULL, 'Uncharacterized protein', 152, NULL, NULL, 75602),
(75603, '3.40.50.10190-FF-000106', NULL, 'RNA polymerase II C-terminal domain phosphatase-like 4', 91, NULL, NULL, 75603),
(75604, '1.25.10.10-FF-000398', NULL, 'HEAT repeat containing 6', 206, NULL, NULL, 75604),
(75605, '2.30.40.10-FF-000161', NULL, 'Imidazolonepropionase', 81, NULL, NULL, 75605),
(75606, '3.30.2290.10-FF-000018', NULL, 'Metalloprotease slr1322', 226, NULL, NULL, 75606),
(75607, '1.10.287.370-FF-000064', NULL, 'Uncharacterized protein', 120, NULL, NULL, 75607),
(75608, '2.20.25.10-FF-000103', NULL, 'Transcription factor S, archaeal', 55, NULL, NULL, 75608),
(75609, '1.25.40.180-FF-000221', NULL, NULL, 54, NULL, NULL, 75609),
(75610, '3.80.10.10-FF-002071', NULL, 'Uncharacterized protein', 180, NULL, NULL, 75610),
(75611, '2.120.10.80-FF-000276', NULL, 'Predicted protein', 306, NULL, NULL, 75611),
(75612, '2.60.40.10-FF-000575', NULL, 'Neural cell adhesion molecule 2', 95, NULL, NULL, 75612),
(75613, '3.40.50.300-FF-001357', NULL, 'Guanine nucleotide-binding protein G(i) subunit alpha-1', 202, NULL, NULL, 75613),
(75614, '3.40.50.720-FF-000398', NULL, 'Probable 2-deoxy-D-gluconate 3-dehydrogenase', 261, NULL, NULL, 75614),
(75615, '3.30.1470.10-FF-000004', NULL, 'Uncharacterized protein', 133, NULL, NULL, 75615),
(75616, '1.20.1250.20-FF-001473', NULL, 'MonoCarboxylate Transporter family', 395, NULL, NULL, 75616),
(75617, '1.10.8.270-FF-000092', NULL, 'Rab GTPase activating protein, putative', 129, NULL, NULL, 75617),
(75618, '3.40.50.10240-FF-000020', NULL, 'Thiamine pyrophosphokinase', 244, NULL, NULL, 75618),
(75619, '3.30.70.330-FF-000765', NULL, 'RNA-binding protein TIA-1, putative', 94, NULL, NULL, 75619),
(75620, '3.40.140.10-FF-000186', NULL, 'Uncharacterized protein', 167, NULL, NULL, 75620),
(75621, '1.10.287.3490-FF-000006', NULL, 'Mediator of RNA polymerase II transcription subunit 11', 87, NULL, NULL, 75621),
(75622, '3.90.1150.10-FF-000371', NULL, 'Cystathionine gamma-synthase, putative', 78, NULL, NULL, 75622),
(75623, '2.40.50.140-FF-000177', NULL, 'DIS3-like exonuclease 2', 91, NULL, NULL, 75623),
(75624, '1.10.530.10-FF-000005', NULL, 'Basic endochitinase', 176, NULL, NULL, 75624),
(75625, '1.20.1250.20-FF-000742', NULL, 'MHS family proline/betaine transporter-like MFS transporter', 188, NULL, NULL, 75625),
(75626, '1.20.5.110-FF-000171', NULL, 'Syntaxin-binding protein 5-like', 65, NULL, NULL, 75626),
(75627, '3.30.2350.20-FF-000072', NULL, NULL, 97, NULL, NULL, 75627),
(75628, '3.40.50.10190-FF-000213', NULL, 'Poly [ADP-ribose] polymerase', 99, NULL, NULL, 75628),
(75629, '2.20.100.10-FF-000164', NULL, 'Zinc metalloproteinase', 74, NULL, NULL, 75629),
(75630, '3.30.9.10-FF-000030', NULL, 'L-2-hydroxyglutarate dehydrogenase, mitochondrial', 159, NULL, NULL, 75630),
(75631, '1.10.10.10-FF-000774', NULL, 'Transcriptional regulator, LysR family', 87, NULL, NULL, 75631),
(75632, '3.40.1390.20-FF-000010', NULL, 'Manganese-dependent inorganic pyrophosphatase, putative', 94, NULL, NULL, 75632),
(75633, '3.40.1000.10-FF-000012', NULL, 'PsbP domain-containing protein 4, chloroplastic', 149, NULL, NULL, 75633),
(75634, '3.30.70.2740-FF-000016', NULL, 'Ac2-202', 79, NULL, NULL, 75634),
(75635, '3.30.830.10-FF-000319', NULL, 'Transmembrane 9 superfamily member', 63, NULL, NULL, 75635);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(75636, '3.40.50.300-FF-005628', NULL, 'Uncharacterized protein', 65, NULL, NULL, 75636),
(75637, '1.25.40.20-FF-001864', NULL, 'Uncharacterized protein', 130, NULL, NULL, 75637),
(75638, '1.10.287.810-FF-000022', NULL, NULL, 82, NULL, NULL, 75638),
(75639, '3.40.50.920-FF-000014', NULL, '1-deoxy-D-xylulose 5-phosphate synthase', 142, NULL, NULL, 75639),
(75640, '3.40.50.1100-FF-000123', NULL, '1-aminocyclopropane-1-carboxylate deaminase', 178, NULL, NULL, 75640),
(75641, '3.90.1860.10-FF-000003', NULL, 'RNA-splicing ligase RtcB', 395, NULL, NULL, 75641),
(75642, '3.40.50.10580-FF-000009', NULL, 'GEO02534p1', 108, NULL, NULL, 75642),
(75643, '2.30.30.140-FF-000029', NULL, 'SAGA-associated factor 29 homolog', 76, NULL, NULL, 75643),
(75644, '3.30.210.10-FF-000014', NULL, 'DNA-directed DNA polymerase, family X', 66, NULL, NULL, 75644),
(75645, '2.120.10.30-FF-000519', NULL, 'Uncharacterized protein', 181, NULL, NULL, 75645),
(75646, '3.30.450.20-FF-000237', NULL, 'Integral membrane sensor protein', 113, NULL, NULL, 75646),
(75647, '3.10.129.10-FF-000082', NULL, 'Protein CBG18926', 176, NULL, NULL, 75647),
(75648, '3.90.25.10-FF-000002', NULL, 'GDP-L-fucose synthase 1', 90, NULL, NULL, 75648),
(75649, '3.50.50.60-FF-000072', NULL, 'Lysine-specific histone demethylase 1B', 210, NULL, NULL, 75649),
(75650, '3.40.50.1110-FF-000014', NULL, 'Diglucosylglycerate octanoyltransferase', 197, NULL, NULL, 75650),
(75651, '1.10.533.10-FF-000158', NULL, 'Baculoviral IAP repeat-containing protein 7', 45, NULL, NULL, 75651),
(75652, '3.20.20.450-FF-000017', NULL, 'Protein FimX', 251, NULL, NULL, 75652),
(75653, '3.40.190.10-FF-000487', NULL, 'Transcriptional regulator, LysR family', 92, NULL, NULL, 75653),
(75654, '2.130.10.10-FF-001851', NULL, 'Chromosome 19, whole genome shotgun sequence', 325, NULL, NULL, 75654),
(75655, '2.60.40.10-FF-003560', NULL, NULL, 100, NULL, NULL, 75655),
(75656, '3.30.420.40-FF-000623', NULL, 'Uncharacterized protein', 120, NULL, NULL, 75656),
(75657, '3.40.50.300-FF-000738', NULL, 'Dynein heavy chain axonemal', 150, NULL, NULL, 75657),
(75658, '3.40.50.1580-FF-000014', NULL, 'Probable S-methyl-5''-thioinosine phosphorylase', 250, NULL, NULL, 75658),
(75659, '2.30.29.30-FF-000578', NULL, 'Vacuolar protein sorting-associated protein 36', 127, NULL, NULL, 75659),
(75660, '2.60.40.10-FF-001194', NULL, 'Sallimus, isoform Q', 100, NULL, NULL, 75660),
(75661, '3.90.1150.10-FF-000152', NULL, 'Ornithine aminotransferase', 167, NULL, NULL, 75661),
(75662, '1.10.238.10-FF-000758', NULL, 'EF-hand calcium-binding domain 6', 77, NULL, NULL, 75662),
(75663, '3.30.200.20-FF-000522', NULL, 'Tyrosine-protein kinase', 113, NULL, NULL, 75663),
(75664, '3.40.50.300-FF-007085', NULL, 'Predicted protein', 191, NULL, NULL, 75664),
(75665, '1.50.40.10-FF-000050', NULL, 'mitochondrial carnitine/acylcarnitine carrier-like protein', 295, NULL, NULL, 75665),
(75666, '2.60.120.650-FF-000187', NULL, 'Uncharacterized protein', 86, NULL, NULL, 75666),
(75667, '1.20.58.60-FF-000578', NULL, 'Dystonin', 313, NULL, NULL, 75667),
(75668, '1.25.40.10-FF-000237', NULL, 'Bardet-Biedl syndrome 4 (Human)', 147, NULL, NULL, 75668),
(75669, '3.40.630.10-FF-000509', NULL, 'Uncharacterized protein', 119, NULL, NULL, 75669),
(75670, '1.20.210.10-FF-000029', NULL, 'Cytochrome c oxidase subunit 1', 140, NULL, NULL, 75670),
(75671, '3.40.50.300-FF-006573', NULL, 'Uncharacterized protein', 101, NULL, NULL, 75671),
(75672, '3.40.50.12160-FF-000040', NULL, 'tRNA modification enzyme, putative', 127, NULL, NULL, 75672),
(75673, '3.30.63.10-FF-000008', NULL, 'Guanylate kinase, putative', 42, NULL, NULL, 75673),
(75674, '1.10.150.240-FF-000054', NULL, 'HAD superfamily hydrolase (TIGR01509 family)/HAD superfamily hydrolase (TIGR01549 family)', 60, NULL, NULL, 75674),
(75675, '3.30.1370.10-FF-000064', NULL, 'protein bicaudal C homolog 1 isoform X1', 59, NULL, NULL, 75675),
(75676, '3.30.420.10-FF-000732', NULL, NULL, 142, NULL, NULL, 75676),
(75677, '3.60.21.10-FF-000489', NULL, 'Serine/threonine-protein phosphatase', 131, NULL, NULL, 75677);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(75678, '2.60.40.10-FF-005465', NULL, NULL, 104, NULL, NULL, 75678),
(75679, '2.30.29.70-FF-000017', NULL, 'Uncharacterized protein', 139, NULL, NULL, 75679),
(75680, '2.10.70.10-FF-000045', NULL, 'Pappalysin 1', 67, NULL, NULL, 75680),
(75681, '3.40.1110.10-FF-000245', NULL, 'Cation transporter', 191, NULL, NULL, 75681),
(75682, '3.15.10.30-FF-000012', NULL, NULL, 140, NULL, NULL, 75682),
(75683, '3.30.450.20-FF-000107', NULL, 'PAS domain-containing sensor histidine kinase', 134, NULL, NULL, 75683),
(75684, '3.10.290.20-FF-000004', NULL, 'SUMO-activating enzyme subunit', 149, NULL, NULL, 75684),
(75685, '2.10.50.10-FF-000038', NULL, 'Tumor necrosis factor receptor superfamily member 4', 52, NULL, NULL, 75685),
(75686, '3.90.226.10-FF-000284', NULL, '3-hydroxyisobutyryl-CoA hydrolase 1', 208, NULL, NULL, 75686),
(75687, '1.20.1060.20-FF-000019', NULL, NULL, 117, NULL, NULL, 75687),
(75688, '1.20.58.80-FF-000011', NULL, 'Ubiquitin carboxyl-terminal hydrolase 8', 129, NULL, NULL, 75688),
(75689, '1.20.1090.10-FF-000063', NULL, 'Predicted protein', 205, NULL, NULL, 75689),
(75690, '3.30.160.60-FF-001536', NULL, 'CLUMA_CG004886, isoform A', 43, NULL, NULL, 75690),
(75691, '3.30.200.20-FF-002427', NULL, 'Uncharacterized protein', 79, NULL, NULL, 75691),
(75692, '1.10.418.10-FF-000082', NULL, 'cytospin-A isoform X2', 47, NULL, NULL, 75692),
(75693, '1.10.1200.10-FF-000064', NULL, 'Acyl-CoA synthetase, putative', 87, NULL, NULL, 75693),
(75694, '3.40.50.720-FF-001707', NULL, 'Uncharacterized protein', 158, NULL, NULL, 75694),
(75695, '4.10.410.10-FF-000114', NULL, 'Uncharacterized protein', 61, NULL, NULL, 75695),
(75696, '3.40.710.10-FF-000095', NULL, 'Penicillin-binding protein 2x', 385, NULL, NULL, 75696),
(75697, '4.10.95.10-FF-000002', NULL, 'Cytochrome c oxidase subunit Via', 74, NULL, NULL, 75697),
(75698, '3.10.20.310-FF-000040', NULL, 'Blr6126 protein', 88, NULL, NULL, 75698),
(75699, '1.10.1300.10-FF-000009', NULL, 'Phosphodiesterase', 342, NULL, NULL, 75699),
(75700, '1.10.510.10-FF-004169', NULL, NULL, 162, NULL, NULL, 75700),
(75701, '3.90.70.10-FF-000758', NULL, 'Cysteine proteinase cathepsin L, putative', 99, NULL, NULL, 75701),
(75702, '1.20.1200.10-FF-000005', NULL, 'cob(I)yrinic acid a,c-diamide adenosyltransferase, mitochondrial-like', 190, NULL, NULL, 75702),
(75703, '3.20.20.80-FF-000622', NULL, 'Endo-1,3-beta-glucanase', 138, NULL, NULL, 75703),
(75704, '2.30.40.10-FF-000031', NULL, 'Adenine deaminase', 101, NULL, NULL, 75704),
(75705, '1.10.510.10-FF-000807', NULL, 'Checkpoint serine/threonine-protein kinase bub1', 288, NULL, NULL, 75705),
(75706, '2.70.170.10-FF-000084', NULL, 'Ligand-Gated ion Channel', 215, NULL, NULL, 75706),
(75707, '1.20.1270.60-FF-000272', NULL, 'Protein kinase C alpha binding protein, putative', 82, NULL, NULL, 75707),
(75708, '3.30.160.60-FF-005807', NULL, NULL, 39, NULL, NULL, 75708),
(75709, '3.40.50.720-FF-000286', NULL, 'Dihydrodipicolinate reductase family protein', 158, NULL, NULL, 75709),
(75710, '3.40.190.10-FF-000806', NULL, 'Polar amino acid uptake family ABC transporter, periplasmic substrate-binding protein', 131, NULL, NULL, 75710),
(75711, '3.30.420.10-FF-000513', NULL, NULL, 126, NULL, NULL, 75711),
(75712, '1.25.40.990-FF-000037', NULL, 'Os01g0836400 protein', 166, NULL, NULL, 75712),
(75713, '3.40.50.10540-FF-000003', NULL, 'CoA-transferase family protein', 254, NULL, NULL, 75713),
(75714, '3.40.50.300-FF-001227', NULL, 'Dephospho-CoA kinase CAB5', 227, NULL, NULL, 75714),
(75715, '1.10.10.10-FF-001286', NULL, 'RFX-like DNA-binding protein RFX2', 81, NULL, NULL, 75715),
(75716, '3.40.50.12610-FF-000001', NULL, 'Dolichyl-diphosphooligosaccharide--protein glycosyltransferase subunit STT3B', 153, NULL, NULL, 75716),
(75717, '1.20.58.1610-FF-000017', NULL, NULL, 113, NULL, NULL, 75717),
(75718, '1.10.510.10-FF-002831', NULL, NULL, 106, NULL, NULL, 75718),
(75719, '3.40.50.2000-FF-000972', NULL, 'Predicted protein', 87, NULL, NULL, 75719),
(75720, '2.130.10.10-FF-000339', NULL, 'WD-repeat protein pop3', 302, NULL, NULL, 75720),
(75721, '2.60.40.10-FF-003104', NULL, 'Neuron-glia cell adhesion molecule (Ng-CAM)', 93, NULL, NULL, 75721);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(75722, '2.60.40.10-FF-000794', NULL, 'Tenascin-X', 86, NULL, NULL, 75722),
(75723, '1.20.1560.10-FF-000723', NULL, 'Uncharacterized protein', 244, NULL, NULL, 75723),
(75724, '2.60.40.420-FF-000255', NULL, 'Cytochrome C oxidase subunit II', 102, NULL, NULL, 75724),
(75725, '3.40.50.300-FF-005409', NULL, 'Atlastin-2', 165, NULL, NULL, 75725),
(75726, '2.40.70.10-FF-000566', NULL, NULL, 84, NULL, NULL, 75726),
(75727, '3.30.160.60-FF-004386', NULL, NULL, 21, NULL, NULL, 75727),
(75728, '1.20.1070.10-FF-001591', NULL, 'Predicted protein', 154, NULL, NULL, 75728),
(75729, '1.10.555.10-FF-000208', NULL, NULL, 78, NULL, NULL, 75729),
(75730, '2.60.40.2300-FF-000018', NULL, 'Neutral ceramidase-like Protein', 131, NULL, NULL, 75730),
(75731, '2.40.50.90-FF-000105', NULL, 'Transcription factor (Snd1/p100), putative', 142, NULL, NULL, 75731),
(75732, '3.30.200.20-FF-001938', NULL, 'Uncharacterized protein', 95, NULL, NULL, 75732),
(75733, '3.10.250.10-FF-000111', NULL, NULL, 93, NULL, NULL, 75733),
(75734, '3.20.20.10-FF-000062', NULL, 'Uncharacterized protein', 243, NULL, NULL, 75734),
(75735, '3.40.50.10190-FF-000325', NULL, 'Uncharacterized protein', 80, NULL, NULL, 75735),
(75736, '1.20.1070.10-FF-002080', NULL, 'Novopsin-10', 270, NULL, NULL, 75736),
(75737, '3.30.160.60-FF-005010', NULL, NULL, 20, NULL, NULL, 75737),
(75738, '3.30.230.30-FF-000004', NULL, 'IMPACT family member C14C8.09c', 121, NULL, NULL, 75738),
(75739, '1.10.150.50-FF-000128', NULL, 'Uncharacterized protein', 79, NULL, NULL, 75739),
(75740, '1.20.272.10-FF-000088', NULL, NULL, 122, NULL, NULL, 75740),
(75741, '3.30.40.10-FF-002333', NULL, 'Predicted protein', 96, NULL, NULL, 75741),
(75742, '1.20.1250.20-FF-000961', NULL, 'Predicted arabinose efflux permease, MFS family', 184, NULL, NULL, 75742),
(75743, '2.60.210.10-FF-000073', NULL, NULL, 151, NULL, NULL, 75743),
(75744, '1.25.40.20-FF-001752', NULL, 'Arginine N-methyltransferase 2', 200, NULL, NULL, 75744),
(75745, '1.10.10.250-FF-000027', NULL, 'Uncharacterized protein', 28, NULL, NULL, 75745),
(75746, '3.40.525.10-FF-000035', NULL, 'Sec14p-like phosphatidylinositol transfer family protein', 255, NULL, NULL, 75746),
(75747, '2.20.100.10-FF-000169', NULL, 'Complement factor properdin', 56, NULL, NULL, 75747),
(75748, '2.10.25.10-FF-000076', NULL, 'Integrin beta', 53, NULL, NULL, 75748),
(75749, '2.130.10.30-FF-000093', NULL, 'Uncharacterized protein', 387, NULL, NULL, 75749),
(75750, '3.30.160.60-FF-001755', NULL, 'Zinc finger protein 989', 27, NULL, NULL, 75750),
(75751, '2.30.30.40-FF-000652', NULL, 'Uncharacterized protein', 71, NULL, NULL, 75751),
(75752, '3.30.160.60-FF-005802', NULL, NULL, 22, NULL, NULL, 75752),
(75753, '1.10.167.10-FF-000003', NULL, 'Axin 1', 77, NULL, NULL, 75753),
(75754, '1.10.1300.10-FF-000004', NULL, 'Phosphodiesterase', 325, NULL, NULL, 75754),
(75755, '3.40.50.300-FF-005623', NULL, 'Uncharacterized protein', 107, NULL, NULL, 75755),
(75756, '4.10.470.20-FF-000003', NULL, NULL, 93, NULL, NULL, 75756),
(75757, '3.40.50.300-FF-004100', NULL, 'Uncharacterized GTP-binding protein E02H1.2', 192, NULL, NULL, 75757),
(75758, '3.40.50.10810-FF-000236', NULL, 'Predicted protein', 203, NULL, NULL, 75758),
(75759, '1.25.40.180-FF-000244', NULL, NULL, 146, NULL, NULL, 75759),
(75760, '3.50.50.60-FF-001488', NULL, 'Uncharacterized protein', 45, NULL, NULL, 75760),
(75761, '3.30.160.60-FF-004509', NULL, NULL, 26, NULL, NULL, 75761),
(75762, '2.40.160.10-FF-000062', NULL, 'Uncharacterized protein', 236, NULL, NULL, 75762),
(75763, '2.60.40.10-FF-001980', NULL, 'Hemicentin 2', 73, NULL, NULL, 75763),
(75764, '3.20.20.100-FF-000036', NULL, 'NADP-dependent oxidoreductase domain-containing protein', 303, NULL, NULL, 75764),
(75765, '1.10.1420.10-FF-000058', NULL, 'MSH (MutS Homolog) family', 181, NULL, NULL, 75765),
(75766, '3.40.850.10-FF-000167', NULL, 'Uncharacterized protein', 143, NULL, NULL, 75766),
(75767, '1.10.8.60-FF-000232', NULL, 'Katanin p60 ATPase-containing subunit A-like 2', 90, NULL, NULL, 75767),
(75768, '2.60.40.10-FF-000687', NULL, 'transmembrane protein 131-like isoform X3', 102, NULL, NULL, 75768);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(75769, '1.10.10.10-FF-001067', NULL, 'Double-stranded RNA-binding protein', 78, NULL, NULL, 75769),
(75770, '2.70.170.10-FF-000196', NULL, 'Uncharacterized protein', 182, NULL, NULL, 75770),
(75771, '3.90.1420.10-FF-000021', NULL, 'Uncharacterized protein', 164, NULL, NULL, 75771),
(75772, '1.25.40.10-FF-004834', NULL, 'Uncharacterized protein', 144, NULL, NULL, 75772),
(75773, '2.60.120.260-FF-000396', NULL, 'Uncharacterized protein', 161, NULL, NULL, 75773),
(75774, '2.60.40.10-FF-004976', NULL, NULL, 109, NULL, NULL, 75774),
(75775, '3.60.40.10-FF-000393', NULL, 'Serine phosphatase RsbU', 245, NULL, NULL, 75775),
(75776, '1.20.1000.10-FF-000024', NULL, NULL, 336, NULL, NULL, 75776),
(75777, '1.25.40.10-FF-004492', NULL, 'Slr2048 protein', 97, NULL, NULL, 75777),
(75778, '1.10.245.10-FF-000005', NULL, 'E3 ubiquitin-protein ligase Mdm2', 115, NULL, NULL, 75778),
(75779, '3.40.50.280-FF-000007', NULL, 'Monomethylamine corrinoid protein 1', 134, NULL, NULL, 75779),
(75780, '2.160.20.10-FF-000237', NULL, 'Os07g0207800 protein', 212, NULL, NULL, 75780),
(75781, '3.40.390.10-FF-000125', NULL, NULL, 96, NULL, NULL, 75781),
(75782, '2.40.20.10-FF-000069', NULL, 'Uncharacterized protein', 84, NULL, NULL, 75782),
(75783, '3.30.40.10-FF-000771', NULL, 'Uncharacterized protein, isoform E', 72, NULL, NULL, 75783),
(75784, '3.40.50.80-FF-000168', NULL, 'Uncharacterized protein', 161, NULL, NULL, 75784),
(75785, '1.10.3520.10-FF-000015', NULL, 'Protein CBG06218', 207, NULL, NULL, 75785),
(75786, '2.30.29.30-FF-001197', NULL, 'Docking protein 2', 69, NULL, NULL, 75786),
(75787, '2.10.25.10-FF-001593', NULL, 'Matrilin 3a', 41, NULL, NULL, 75787),
(75788, '3.30.465.10-FF-000026', NULL, 'D-lactate dehydrogenase (Dld)', 131, NULL, NULL, 75788),
(75789, '3.90.1150.10-FF-000157', NULL, 'Probable hercynylcysteine sulfoxide lyase', 113, NULL, NULL, 75789),
(75790, '3.30.300.130-FF-000022', NULL, 'Iron-sulfur cluster carrier protein', 94, NULL, NULL, 75790),
(75791, '1.10.10.2560-FF-000001', NULL, NULL, 44, NULL, NULL, 75791),
(75792, '1.20.120.1900-FF-000039', NULL, 'gamma-tubulin complex component 6 isoform X2', 182, NULL, NULL, 75792),
(75793, '1.10.437.10-FF-000002', NULL, 'Induced myeloid leukemia cell differentiation protein Mcl-1', 148, NULL, NULL, 75793),
(75794, '3.80.10.10-FF-001014', NULL, 'EIN3-binding F-box protein 1', 227, NULL, NULL, 75794),
(75795, '1.10.510.10-FF-000122', NULL, 'Mitogen-activated protein kinase kinase kinase 4', 268, NULL, NULL, 75795),
(75796, '3.30.40.10-FF-000664', NULL, 'BRCA1-associated RING domain protein 1', 127, NULL, NULL, 75796),
(75797, '2.60.120.290-FF-000157', NULL, 'LEV-10A protein', 161, NULL, NULL, 75797),
(75798, '3.40.30.10-FF-000972', NULL, 'Uncharacterized protein', 96, NULL, NULL, 75798),
(75799, '1.20.1560.10-FF-000167', NULL, 'ABC transporter ATP-binding protein', 315, NULL, NULL, 75799),
(75800, '3.40.5.60-FF-000007', NULL, 'DNA replication complex GINS protein SLD5', 54, NULL, NULL, 75800),
(75801, '3.30.70.1350-FF-000026', NULL, 'Cation-efflux pump FieF protein', 87, NULL, NULL, 75801),
(75802, '3.30.230.70-FF-000117', NULL, 'Uncharacterized protein', 243, NULL, NULL, 75802),
(75803, '1.25.10.10-FF-000050', NULL, 'Cytoskeleton-associated protein 5 isoform X1', 265, NULL, NULL, 75803),
(75804, '1.25.40.570-FF-000035', NULL, 'Proteasome 26S subunit, non-ATPase 6', 238, NULL, NULL, 75804),
(75805, '6.10.140.2220-FF-000029', NULL, 'HIF prolyl hydroxylase, isoform C', 58, NULL, NULL, 75805),
(75806, '1.25.40.820-FF-000014', NULL, 'Uncharacterized protein', 169, NULL, NULL, 75806),
(75807, '3.30.470.20-FF-000221', NULL, 'Uncharacterized protein', 33, NULL, NULL, 75807),
(75808, '3.40.50.300-FF-000957', NULL, 'ATP-dependent RNA helicase SUV3L, mitochondrial', 153, NULL, NULL, 75808),
(75809, '1.10.1030.10-FF-000011', NULL, 'Carbamoyl-phosphate synthase large chain', 135, NULL, NULL, 75809),
(75810, '3.30.413.10-FF-000036', NULL, 'Assimilatory ferredoxin-dependent nitrite reductase', 170, NULL, NULL, 75810),
(75811, '3.10.580.10-FF-000091', NULL, 'CBS domain-containing protein CBSX6', 135, NULL, NULL, 75811);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(75812, '1.20.58.1370-FF-000001', NULL, 'lysine-specific demethylase 6A isoform X2', 80, NULL, NULL, 75812),
(75813, '3.30.200.20-FF-001011', NULL, 'Os12g0203000 protein', 103, NULL, NULL, 75813),
(75814, '1.10.10.10-FF-001174', NULL, 'Uncharacterized protein', 125, NULL, NULL, 75814),
(75815, '3.40.50.2300-FF-000500', NULL, 'Histidine kinase response regulator hybrid protein', 149, NULL, NULL, 75815),
(75816, '3.20.20.190-FF-000024', NULL, 'Glycerophosphodiester phosphodiesterase gde1', 292, NULL, NULL, 75816),
(75817, '2.170.300.10-FF-000031', NULL, 'Dendrite extension defective protein 1', 71, NULL, NULL, 75817),
(75818, '3.40.630.10-FF-000280', NULL, 'Predicted protein', 317, NULL, NULL, 75818),
(75819, '2.30.30.180-FF-000013', NULL, 'Ribosome maturation factor RimP', 63, NULL, NULL, 75819),
(75820, '3.100.10.10-FF-000039', NULL, NULL, 53, NULL, NULL, 75820),
(75821, '2.130.10.10-FF-002812', NULL, 'Uncharacterized protein', 159, NULL, NULL, 75821),
(75822, '3.30.420.10-FF-000625', NULL, NULL, 168, NULL, NULL, 75822),
(75823, '1.20.1530.20-FF-000095', NULL, 'Uncharacterized protein', 227, NULL, NULL, 75823),
(75824, '2.130.10.10-FF-004605', NULL, 'Predicted protein', 203, NULL, NULL, 75824),
(75825, '1.10.1410.10-FF-000001', NULL, 'Putative poly(A) polymerase gamma', 186, NULL, NULL, 75825),
(75826, '1.20.120.1750-FF-000073', NULL, 'RBR-type E3 ubiquitin transferase', 78, NULL, NULL, 75826),
(75827, '3.60.21.10-FF-000141', NULL, 'Serine/threonine-protein phosphatase with EF-hands', 362, NULL, NULL, 75827),
(75828, '2.30.29.30-FF-001202', NULL, 'RAN binding protein 1', 55, NULL, NULL, 75828),
(75829, '1.10.10.1700-FF-000002', NULL, 'Suppressor of variegation 4-20 protein-like 2', 37, NULL, NULL, 75829),
(75830, '3.40.50.620-FF-000716', NULL, 'AFR721Wp', 217, NULL, NULL, 75830),
(75831, '1.20.5.170-FF-000031', NULL, 'BZIP transcription factor (MeaB)', 61, NULL, NULL, 75831),
(75832, '1.20.5.190-FF-000037', NULL, 'Myosin VB', 47, NULL, NULL, 75832),
(75833, '3.30.420.10-FF-000283', NULL, 'Uncharacterized protein', 373, NULL, NULL, 75833),
(75834, '2.130.10.10-FF-005898', NULL, 'Tyrosine-protein kinase receptor svh-2', 288, NULL, NULL, 75834),
(75835, '1.10.274.100-FF-000024', NULL, 'DNA-directed RNA polymerase subunit', 203, NULL, NULL, 75835),
(75836, '3.30.360.20-FF-000011', NULL, NULL, 107, NULL, NULL, 75836),
(75837, '4.10.320.30-FF-000006', NULL, 'Myelin transcription factor 1b', 22, NULL, NULL, 75837),
(75838, '3.20.20.80-FF-000841', NULL, 'Uncharacterized protein', 29, NULL, NULL, 75838),
(75839, '3.60.15.10-FF-000099', NULL, '3'',5''-cyclic-nucleotide phosphodiesterase', 278, NULL, NULL, 75839),
(75840, '2.40.30.20-FF-000016', NULL, 'Related to RIB5-riboflavin synthase, alpha chain', 139, NULL, NULL, 75840),
(75841, '1.25.40.10-FF-001182', NULL, 'Pentatricopeptide repeat-containing protein At4g18520, chloroplastic', 100, NULL, NULL, 75841),
(75842, '2.40.10.10-FF-000248', NULL, 'Anionic trypsin-2', 120, NULL, NULL, 75842),
(75843, '1.20.1070.10-FF-000972', NULL, 'Uncharacterized protein', 102, NULL, NULL, 75843),
(75844, '3.40.50.10090-FF-000065', NULL, 'Predicted protein', 52, NULL, NULL, 75844),
(75845, '2.60.120.920-FF-000161', NULL, 'Protein TRAUCO', 143, NULL, NULL, 75845),
(75846, '3.40.50.620-FF-000823', NULL, 'Diphthine--ammonia ligase', 165, NULL, NULL, 75846),
(75847, '3.30.70.260-FF-000160', NULL, 'Prephenate dehydratase', 90, NULL, NULL, 75847),
(75848, '3.40.50.620-FF-000031', NULL, 'Asparagine synthase B', 326, NULL, NULL, 75848),
(75849, '3.30.497.10-FF-000145', NULL, 'Uncharacterized protein', 155, NULL, NULL, 75849),
(75850, '1.25.40.10-FF-000782', NULL, 'Pentatricopeptide repeat-containing protein', 64, NULL, NULL, 75850),
(75851, '1.10.10.800-FF-000001', NULL, 'Alpha/beta hydrolase', 89, NULL, NULL, 75851),
(75852, '3.30.1490.100-FF-000030', NULL, 'DNA polymerase IV', 110, NULL, NULL, 75852),
(75853, '3.30.70.330-FF-001147', NULL, 'Pre-rRNA-processing protein esf-2', 197, NULL, NULL, 75853),
(75854, '1.10.10.10-FF-001735', NULL, 'Two-component system regulatory protein', 93, NULL, NULL, 75854);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(75855, '3.40.50.410-FF-000193', NULL, 'Ubiquitin-conjugating enzyme family protein', 182, NULL, NULL, 75855),
(75856, '2.40.70.10-FF-000128', NULL, 'Plasmepsin IX', 157, NULL, NULL, 75856),
(75857, '3.40.50.150-FF-001727', NULL, NULL, 143, NULL, NULL, 75857),
(75858, '3.30.710.10-FF-000491', NULL, 'Tumor necrosis factor, alpha-induced protein 1 (endothelial)', 64, NULL, NULL, 75858),
(75859, '3.30.70.260-FF-000030', NULL, 'Homoserine dehydrogenase', 76, NULL, NULL, 75859),
(75860, '1.20.1270.60-FF-000053', NULL, 'SH3 domain-binding protein 1', 257, NULL, NULL, 75860),
(75861, '3.40.1170.20-FF-000004', NULL, 'tRNA-splicing endonuclease', 75, NULL, NULL, 75861),
(75862, '4.10.410.10-FF-000007', NULL, 'Collagen type VI alpha 3 chain', 66, NULL, NULL, 75862),
(75863, '3.40.50.720-FF-001584', NULL, 'Probable oxidoreductase (Short-chain dehydrogenase family)', 230, NULL, NULL, 75863),
(75864, '3.30.420.40-FF-001005', NULL, 'Uncharacterized protein', 64, NULL, NULL, 75864),
(75865, '1.20.58.390-FF-000203', NULL, 'Predicted protein', 92, NULL, NULL, 75865),
(75866, '2.60.40.1180-FF-000194', NULL, 'Alpha-galactosidase Mel36A', 96, NULL, NULL, 75866),
(75867, '3.90.20.20-FF-000034', NULL, 'GrpE protein homolog', 108, NULL, NULL, 75867),
(75868, '3.40.50.150-FF-001379', NULL, NULL, 175, NULL, NULL, 75868),
(75869, '2.60.120.200-FF-000743', NULL, 'Uncharacterized protein', 148, NULL, NULL, 75869),
(75870, '3.30.160.60-FF-002929', NULL, NULL, 28, NULL, NULL, 75870),
(75871, '1.20.1070.10-FF-001023', NULL, 'Uncharacterized protein', 362, NULL, NULL, 75871),
(75872, '2.30.30.490-FF-000100', NULL, 'Uncharacterized protein', 188, NULL, NULL, 75872),
(75873, '3.30.160.60-FF-002593', NULL, 'Zinc finger protein 80', 31, NULL, NULL, 75873),
(75874, '1.10.1200.10-FF-000171', NULL, 'Sortilin', 91, NULL, NULL, 75874),
(75875, '2.20.25.240-FF-000001', NULL, 'FLYWCH-type zinc finger-containing protein 1', 84, NULL, NULL, 75875),
(75876, '1.20.1390.10-FF-000007', NULL, 'CCCH zinc finger and RRM domain protein', 87, NULL, NULL, 75876),
(75877, '3.20.10.10-FF-000011', NULL, 'Branched-chain-amino-acid aminotransferase-like protein 2', 168, NULL, NULL, 75877),
(75878, '3.30.70.330-FF-000877', NULL, 'Myelin expression factor 2', 84, NULL, NULL, 75878),
(75879, '2.60.120.10-FF-000532', NULL, 'Protein kinase cGMP-dependent 1b', 119, NULL, NULL, 75879),
(75880, '3.30.160.60-FF-003329', NULL, 'Uncharacterized protein, isoform C', 76, NULL, NULL, 75880),
(75881, '1.20.1070.10-FF-000534', NULL, 'Muscarinic acetylcholine receptor', 123, NULL, NULL, 75881),
(75882, '1.20.58.60-FF-000466', NULL, 'Uncharacterized protein', 226, NULL, NULL, 75882),
(75883, '4.10.400.10-FF-000052', NULL, 'Sortilin related receptor 1', 42, NULL, NULL, 75883),
(75884, '1.10.287.70-FF-000721', NULL, 'Uncharacterized protein', 134, NULL, NULL, 75884),
(75885, '3.30.70.330-FF-000658', NULL, 'RNA-binding protein, putative, UPB1', 131, NULL, NULL, 75885),
(75886, '3.40.50.1000-FF-000329', NULL, 'Calcium-transporting ATPase', 40, NULL, NULL, 75886),
(75887, '2.40.240.10-FF-000012', NULL, '50S ribosomal protein L25', 89, NULL, NULL, 75887),
(75888, '1.25.10.10-FF-003271', NULL, 'Serine/threonine-protein kinase TOR', 203, NULL, NULL, 75888),
(75889, '2.60.120.650-FF-000057', NULL, 'Cupin-like domain-containing protein', 251, NULL, NULL, 75889),
(75890, '3.40.50.300-FF-007192', NULL, 'Uncharacterized protein', 169, NULL, NULL, 75890),
(75891, '3.40.50.1820-FF-000463', NULL, 'Alpha/beta-Hydrolases superfamily protein', 267, NULL, NULL, 75891),
(75892, '3.40.50.12780-FF-000006', NULL, 'long-chain-fatty-acid--CoA ligase 6 isoform X2', 436, NULL, NULL, 75892),
(75893, '1.25.10.10-FF-001359', NULL, 'Armadillo-type protein', 220, NULL, NULL, 75893),
(75894, '3.40.50.1980-FF-000027', NULL, 'Ferrichrome ABC transporter substrate-binding protein', 180, NULL, NULL, 75894),
(75895, '1.10.10.10-FF-000229', NULL, 'HSF-type DNA-binding domain protein', 108, NULL, NULL, 75895),
(75896, '3.80.10.10-FF-000525', NULL, 'GLC7-interacting protein 3', 429, NULL, NULL, 75896),
(75897, '2.60.110.10-FF-000032', NULL, 'Pathogenesis-related thaumatin superfamily protein', 65, NULL, NULL, 75897);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(75898, '3.40.50.300-FF-006792', NULL, 'Uncharacterized protein', 57, NULL, NULL, 75898),
(75899, '3.40.250.10-FF-000071', NULL, 'Rodhanase family domain containing protein', 168, NULL, NULL, 75899),
(75900, '1.25.40.20-FF-000566', NULL, '6-phosphofructo-2-kinase/fructose-2,6-biphosphata se-1-like protein', 103, NULL, NULL, 75900),
(75901, '1.10.472.10-FF-000465', NULL, 'Uncharacterized protein', 267, NULL, NULL, 75901),
(75902, '3.40.50.1820-FF-000333', NULL, 'Steryl ester hydrolase, putative', 152, NULL, NULL, 75902),
(75903, '3.40.50.1000-FF-000874', NULL, NULL, 171, NULL, NULL, 75903),
(75904, '3.30.60.20-FF-000084', NULL, 'Diacylglycerol kinase', 50, NULL, NULL, 75904),
(75905, '1.25.70.10-FF-000065', NULL, 'Predicted protein', 252, NULL, NULL, 75905),
(75906, '4.10.372.10-FF-000002', NULL, 'Lipoxygenase', 89, NULL, NULL, 75906),
(75907, '3.80.10.10-FF-004229', NULL, 'Tubulin-specific chaperone E-like Protein', 80, NULL, NULL, 75907),
(75908, '3.40.50.720-FF-002545', NULL, 'Uncharacterized protein', 70, NULL, NULL, 75908),
(75909, '3.80.10.10-FF-003487', NULL, 'Uncharacterized protein', 203, NULL, NULL, 75909),
(75910, '3.40.50.1100-FF-000230', NULL, 'Putative inactive cysteine synthase 2', 72, NULL, NULL, 75910),
(75911, '3.40.50.300-FF-007540', NULL, 'Uncharacterized protein', 201, NULL, NULL, 75911),
(75912, '3.40.630.30-FF-000504', NULL, 'Acetyltransferase', 156, NULL, NULL, 75912),
(75913, '1.10.287.1250-FF-000003', NULL, 'Phosphotransferase', 59, NULL, NULL, 75913),
(75914, '1.25.40.10-FF-000911', NULL, 'Pentatricopeptide repeat-containing protein', 235, NULL, NULL, 75914),
(75915, '3.30.710.10-FF-000035', NULL, 'Elongin C transcription elongation factor', 97, NULL, NULL, 75915),
(75916, '1.25.40.10-FF-004273', NULL, 'AGAP006324-PA', 350, NULL, NULL, 75916),
(75917, '1.20.140.150-FF-000135', NULL, 'Uncharacterized protein', 73, NULL, NULL, 75917),
(75918, '1.10.510.10-FF-003213', NULL, NULL, 141, NULL, NULL, 75918),
(75919, '1.10.287.130-FF-000121', NULL, 'Histidine kinase sensor protein', 82, NULL, NULL, 75919),
(75920, '1.25.10.10-FF-002871', NULL, 'Uncharacterized protein', 155, NULL, NULL, 75920),
(75921, '2.10.70.10-FF-000040', NULL, 'Complement C1r subcomponent', 66, NULL, NULL, 75921),
(75922, '3.40.50.1820-FF-000805', NULL, 'Triacylglycerol lipase', 334, NULL, NULL, 75922),
(75923, '3.30.420.150-FF-000015', NULL, 'WGS project CABT00000000 data, contig 2.1', 198, NULL, NULL, 75923),
(75924, '3.30.160.60-FF-003082', NULL, NULL, 28, NULL, NULL, 75924),
(75925, '3.30.40.10-FF-001951', NULL, 'Uncharacterized protein', 66, NULL, NULL, 75925),
(75926, '3.90.870.10-FF-000022', NULL, 'Uncharacterized protein', 129, NULL, NULL, 75926),
(75927, '3.30.420.100-FF-000023', NULL, 'Uncharacterized protein', 92, NULL, NULL, 75927),
(75928, '3.60.21.10-FF-000484', NULL, 'Serine/threonine-protein phosphatase', 201, NULL, NULL, 75928),
(75929, '1.20.58.400-FF-000044', NULL, 'Vesicle transport through interaction with t-SNAREs 1B', 59, NULL, NULL, 75929),
(75930, '3.30.420.10-FF-000064', NULL, 'RNA exonuclease 4', 188, NULL, NULL, 75930),
(75931, '3.90.1200.10-FF-000044', NULL, 'Serine/threonine protein kinase', 200, NULL, NULL, 75931),
(75932, '3.30.750.24-FF-000023', NULL, 'Anti-sigma factor antagonist', 109, NULL, NULL, 75932),
(75933, '1.10.287.160-FF-000012', NULL, 'Uncharacterized protein', 84, NULL, NULL, 75933),
(75934, '1.10.3210.10-FF-000020', NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase', 200, NULL, NULL, 75934),
(75935, '3.40.50.670-FF-000017', NULL, 'Putative type II DNA topoisomerase', 118, NULL, NULL, 75935),
(75936, '1.20.1070.10-FF-001708', NULL, 'Uncharacterized protein LOPA7', 106, NULL, NULL, 75936),
(75937, '3.80.10.10-FF-002998', NULL, 'Os11g0641200 protein', 97, NULL, NULL, 75937),
(75938, '3.40.630.30-FF-000156', NULL, 'Histone acetyltransferase', 120, NULL, NULL, 75938),
(75939, '3.30.2010.10-FF-000026', NULL, 'Uncharacterized protein', 64, NULL, NULL, 75939),
(75940, '3.40.50.300-FF-003830', NULL, 'GTP-binding family protein', 177, NULL, NULL, 75940),
(75941, '3.10.20.90-FF-000125', NULL, 'pleckstrin homology domain-containing family H member 2', 103, NULL, NULL, 75941);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(75942, '2.40.150.20-FF-000002', NULL, '50S ribosomal protein L14, chloroplastic', 122, NULL, NULL, 75942),
(75943, '3.30.559.10-FF-000025', NULL, 'Carnitine acetyl transferase', 143, NULL, NULL, 75943),
(75944, '1.10.10.820-FF-000007', NULL, 'unconventional myosin-Id', 57, NULL, NULL, 75944),
(75945, '3.30.230.10-FF-000009', NULL, '116 kDa U5 small nuclear ribonucleoprotein component', 155, NULL, NULL, 75945),
(75946, '1.10.510.10-FF-000914', NULL, 'Anti-Muellerian hormone type-2 receptor', 88, NULL, NULL, 75946),
(75947, '1.10.1040.10-FF-000080', NULL, '2-hydroxymethylglutarate dehydrogenase', 135, NULL, NULL, 75947),
(75948, '2.60.40.10-FF-004397', NULL, NULL, 108, NULL, NULL, 75948),
(75949, '1.10.510.10-FF-002376', NULL, NULL, 146, NULL, NULL, 75949),
(75950, '3.40.1190.20-FF-000017', NULL, 'Multifunctional fusion protein', 272, NULL, NULL, 75950),
(75951, '1.10.730.10-FF-000009', NULL, 'Valine--tRNA ligase, mitochondrial', 235, NULL, NULL, 75951),
(75952, '2.60.40.420-FF-000148', NULL, 'Cytochrome C oxidase', 143, NULL, NULL, 75952),
(75953, '3.40.50.10580-FF-000004', NULL, 'V-type proton ATPase subunit F', 114, NULL, NULL, 75953),
(75954, '1.10.8.270-FF-000097', NULL, 'Uncharacterized protein', 63, NULL, NULL, 75954),
(75955, '1.10.8.50-FF-000010', NULL, 'endonuclease 8-like 2', 135, NULL, NULL, 75955),
(75956, '3.30.70.330-FF-002108', NULL, NULL, 162, NULL, NULL, 75956),
(75957, '1.20.1070.10-FF-000079', NULL, 'Calcitonin gene-related peptide type 1 receptor', 285, NULL, NULL, 75957),
(75958, '1.25.40.10-FF-003328', NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', 101, NULL, NULL, 75958),
(75959, '2.60.40.10-FF-005122', NULL, NULL, 97, NULL, NULL, 75959),
(75960, '2.130.10.10-FF-001407', NULL, 'Intraflagellar transport protein 172 homolog', 238, NULL, NULL, 75960),
(75961, '3.40.50.150-FF-000311', NULL, 'Methyltransferase protein 13', 205, NULL, NULL, 75961),
(75962, '3.40.50.10140-FF-000007', NULL, 'Disease resistance protein (TIR-NBS-LRR class)', 169, NULL, NULL, 75962),
(75963, '3.40.390.10-FF-000249', NULL, NULL, 249, NULL, NULL, 75963),
(75964, '4.10.1000.10-FF-000108', NULL, 'An-Nup2 Nuclear pore complex protein (Eurofung)', 62, NULL, NULL, 75964),
(75965, '3.30.460.10-FF-000167', NULL, 'Uncharacterized protein', 131, NULL, NULL, 75965),
(75966, '2.100.10.50-FF-000010', NULL, 'Predicted protein', 81, NULL, NULL, 75966),
(75967, '2.40.50.140-FF-000525', NULL, 'DNA replication licensing factor, putative', 70, NULL, NULL, 75967),
(75968, '3.15.10.10-FF-000023', NULL, 'Uncharacterized protein', 44, NULL, NULL, 75968),
(75969, '1.20.1560.10-FF-000150', NULL, 'ATP-binding Cassette (ABC) Superfamily', 326, NULL, NULL, 75969),
(75970, '3.30.710.10-FF-000507', NULL, 'Predicted protein', 105, NULL, NULL, 75970),
(75971, '1.25.10.10-FF-001702', NULL, 'Uncharacterized protein', 258, NULL, NULL, 75971),
(75972, '3.90.110.10-FF-000004', NULL, 'Malate dehydrogenase', 167, NULL, NULL, 75972),
(75973, '1.10.630.10-FF-000406', NULL, 'Uncharacterized protein', 482, NULL, NULL, 75973),
(75974, '3.40.50.360-FF-000043', NULL, 'NAD(P)H dehydrogenase, quinone family', 192, NULL, NULL, 75974),
(75975, '3.30.1140.32-FF-000016', NULL, '30S ribosomal protein S3', 160, NULL, NULL, 75975),
(75976, '3.40.630.30-FF-000611', NULL, 'Histone acetyltransferase type B catalytic subunit', 51, NULL, NULL, 75976),
(75977, '3.40.50.300-FF-001806', NULL, 'rho-related GTP-binding protein RhoD isoform X3', 86, NULL, NULL, 75977),
(75978, '1.10.8.60-FF-000344', NULL, 'AAA family ATPase', 167, NULL, NULL, 75978),
(75979, '3.30.870.10-FF-000092', NULL, 'Phospholipase D', 84, NULL, NULL, 75979),
(75980, '2.30.42.10-FF-000209', NULL, 'PDZ domain containing 3', 89, NULL, NULL, 75980),
(75981, '3.90.230.10-FF-000058', NULL, NULL, 209, NULL, NULL, 75981),
(75982, '3.20.20.100-FF-000166', NULL, 'Glutamate--cysteine ligase regulatory subunit-like Protein', 190, NULL, NULL, 75982),
(75983, '1.20.5.300-FF-000008', NULL, 'Phosphoprotein', 65, NULL, NULL, 75983),
(75984, '3.40.50.1980-FF-000134', NULL, 'Histidinol dehydrogenase', 132, NULL, NULL, 75984);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(75985, '2.10.25.10-FF-001481', NULL, 'slit homolog 2 protein isoform X1', 38, NULL, NULL, 75985),
(75986, '1.10.10.60-FF-000873', NULL, NULL, 99, NULL, NULL, 75986),
(75987, '1.20.1330.10-FF-000009', NULL, 'Flagellin', 216, NULL, NULL, 75987),
(75988, '3.40.50.150-FF-000199', NULL, 'arginine-hydroxylase NDUFAF5, mitochondrial isoform X1', 201, NULL, NULL, 75988),
(75989, '1.20.58.70-FF-000019', NULL, 't-SNARE', 116, NULL, NULL, 75989),
(75990, '3.30.1340.30-FF-000006', NULL, 'Putative signal peptide protein', 69, NULL, NULL, 75990),
(75991, '1.10.12.10-FF-000048', NULL, 'Enoyl-CoA hydratase', 59, NULL, NULL, 75991),
(75992, '3.30.70.920-FF-000048', NULL, 'Lrp/AsnC family transcriptional regulator', 85, NULL, NULL, 75992),
(75993, '2.130.10.10-FF-001396', NULL, 'Syntaxin-binding protein 5', 251, NULL, NULL, 75993),
(75994, '3.30.160.60-FF-003430', NULL, NULL, 29, NULL, NULL, 75994),
(75995, '3.30.420.40-FF-000168', NULL, 'Xylulose kinase', 240, NULL, NULL, 75995),
(75996, '3.30.300.30-FF-000111', NULL, 'Nonribosomal peptide synthase, putative', 130, NULL, NULL, 75996),
(75997, '2.30.30.440-FF-000001', NULL, 'DUF1918 domain-containing protein', 80, NULL, NULL, 75997),
(75998, '3.30.160.60-FF-006078', NULL, NULL, 32, NULL, NULL, 75998),
(75999, '3.30.1360.120-FF-000086', NULL, 'Uncharacterized protein', 319, NULL, NULL, 75999),
(76000, '1.20.120.80-FF-000021', NULL, 'Cytochrome c oxidase subunit 3', 98, NULL, NULL, 76000),
(76001, '1.20.1250.20-FF-001922', NULL, 'Uncharacterized protein', 220, NULL, NULL, 76001),
(76002, '2.130.10.10-FF-003537', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', 301, NULL, NULL, 76002),
(76003, '3.40.50.300-FF-003936', NULL, 'RabD', 181, NULL, NULL, 76003),
(76004, '1.10.220.120-FF-000001', NULL, 'RNA polymerase sigma factor RpoD', 64, NULL, NULL, 76004),
(76005, '2.60.120.290-FF-000045', NULL, 'Cubilin', 124, NULL, NULL, 76005),
(76006, '1.20.1740.10-FF-000260', NULL, 'Cationic amino acid transporter 3, mitochondrial', 148, NULL, NULL, 76006),
(76007, '1.10.8.240-FF-000004', NULL, '2-phospho-L-lactate transferase', 42, NULL, NULL, 76007),
(76008, '1.10.510.10-FF-003899', NULL, NULL, 84, NULL, NULL, 76008),
(76009, '1.20.1270.60-FF-000160', NULL, 'ADP-ribosylation factor-interacting protein 2a', 120, NULL, NULL, 76009),
(76010, '2.40.50.100-FF-000087', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 58, NULL, NULL, 76010),
(76011, '2.130.10.10-FF-000884', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 208, NULL, NULL, 76011),
(76012, '3.40.50.720-FF-001691', NULL, '2-hydroxyacid dehydrogenase', 56, NULL, NULL, 76012),
(76013, '3.30.160.60-FF-000682', NULL, 'ras-responsive element-binding protein 1 isoform X1', 29, NULL, NULL, 76013),
(76014, '2.30.42.10-FF-000541', NULL, NULL, 46, NULL, NULL, 76014),
(76015, '3.30.160.20-FF-000243', NULL, 'Predicted protein', 25, NULL, NULL, 76015),
(76016, '3.40.250.10-FF-000183', NULL, 'Thiosulfate sulfurtransferase', 126, NULL, NULL, 76016),
(76017, '3.40.720.10-FF-000051', NULL, 'Arylsulfatase', 448, NULL, NULL, 76017),
(76018, '1.10.1380.10-FF-000003', NULL, 'endothelin-converting enzyme-like 1 isoform X1', 359, NULL, NULL, 76018),
(76019, '4.10.1000.10-FF-000097', NULL, 'Uncharacterized protein', 71, NULL, NULL, 76019),
(76020, '3.30.70.330-FF-000186', NULL, 'heterogeneous nuclear ribonucleoprotein A/B isoform X1', 129, NULL, NULL, 76020),
(76021, '1.10.287.130-FF-000251', NULL, 'Hybrid sensory kinase', 78, NULL, NULL, 76021),
(76022, '3.40.50.2300-FF-001118', NULL, NULL, 202, NULL, NULL, 76022),
(76023, '1.10.510.10-FF-003101', NULL, NULL, 197, NULL, NULL, 76023),
(76024, '3.40.50.10800-FF-000008', NULL, 'Quinolinate synthase chloroplastic', 90, NULL, NULL, 76024),
(76025, '1.25.40.10-FF-004964', NULL, 'Uncharacterized protein', 158, NULL, NULL, 76025),
(76026, '3.90.960.10-FF-000017', NULL, 'Proline--tRNA ligase', 142, NULL, NULL, 76026),
(76027, '1.10.472.10-FF-000353', NULL, 'YALI0C15114p', 115, NULL, NULL, 76027),
(76028, '2.60.40.10-FF-001755', NULL, 'Immunoglobulin superfamily DCC subclass member 4', 105, NULL, NULL, 76028);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(76029, '3.40.50.300-FF-007534', NULL, 'Uncharacterized protein', 205, NULL, NULL, 76029),
(76030, '3.90.70.80-FF-000072', NULL, 'Predicted protein', 144, NULL, NULL, 76030),
(76031, '2.40.50.140-FF-000632', NULL, NULL, 60, NULL, NULL, 76031),
(76032, '3.30.160.60-FF-001188', NULL, 'zinc finger protein 629 isoform X2', 31, NULL, NULL, 76032),
(76033, '1.20.1460.10-FF-000002', NULL, 'V-type proton ATPase subunit C', 184, NULL, NULL, 76033),
(76034, '3.80.10.10-FF-003723', NULL, 'Uncharacterized protein', 140, NULL, NULL, 76034),
(76035, '2.60.120.430-FF-000014', NULL, 'Uncharacterized protein', 197, NULL, NULL, 76035),
(76036, '3.30.70.1730-FF-000051', NULL, '50S ribosomal protein L10', 131, NULL, NULL, 76036),
(76037, '1.10.10.10-FF-001050', NULL, 'Predicted protein', 98, NULL, NULL, 76037),
(76038, '1.20.58.60-FF-000342', NULL, 'Microtubule-actin cross-linking factor 1', 114, NULL, NULL, 76038),
(76039, '3.30.70.100-FF-000027', NULL, 'Copper chaperone for superoxide dismutase', 79, NULL, NULL, 76039),
(76040, '3.40.33.10-FF-000102', NULL, 'Uncharacterized protein', 144, NULL, NULL, 76040),
(76041, '1.25.40.420-FF-000001', NULL, 'Kelch-like family member 12', 122, NULL, NULL, 76041),
(76042, '3.30.40.10-FF-000208', NULL, 'Zinc finger protein-related isoform 1', 50, NULL, NULL, 76042),
(76043, '1.20.1560.10-FF-000835', NULL, 'Uncharacterized protein', 614, NULL, NULL, 76043),
(76044, '1.20.1280.20-FF-000002', NULL, 'HscB mitochondrial iron-sulfur cluster co-chaperone', 85, NULL, NULL, 76044),
(76045, '1.10.510.10-FF-001864', NULL, 'Calcium-dependent protein kinase SK5', 96, NULL, NULL, 76045),
(76046, '1.25.40.10-FF-000675', NULL, 'Peptidylprolyl isomerase', 110, NULL, NULL, 76046),
(76047, '3.40.50.1220-FF-000047', NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', 156, NULL, NULL, 76047),
(76048, '3.30.160.60-FF-004953', NULL, NULL, 86, NULL, NULL, 76048),
(76049, '1.25.40.10-FF-002816', NULL, 'Tetratricopeptide repeat domain 17', 157, NULL, NULL, 76049),
(76050, '2.40.30.10-FF-000120', NULL, 'Respiratory burst oxidase homolog protein C', 93, NULL, NULL, 76050),
(76051, '3.20.20.70-FF-000849', NULL, NULL, 78, NULL, NULL, 76051),
(76052, '3.30.70.330-FF-001041', NULL, 'RNA-binding protein CP33, chloroplastic', 101, NULL, NULL, 76052),
(76053, '1.10.560.10-FF-000069', NULL, 'T-complex protein 1 subunit gamma', 176, NULL, NULL, 76053),
(76054, '2.10.25.10-FF-001149', NULL, 'Neurocan core protein', 38, NULL, NULL, 76054),
(76055, '3.90.70.10-FF-000202', NULL, 'Unplaced genomic scaffold supercont1.10, whole genome shotgun sequence', 359, NULL, NULL, 76055),
(76056, '1.10.565.10-FF-000153', NULL, 'nuclear receptor isoform X1', 233, NULL, NULL, 76056),
(76057, '3.30.70.330-FF-000079', NULL, 'Putative splicing factor 45', 85, NULL, NULL, 76057),
(76058, '2.10.110.10-FF-000279', NULL, 'YALI0F13211p', 90, NULL, NULL, 76058),
(76059, '1.20.1070.10-FF-000186', NULL, 'thyrotropin-releasing hormone receptor', 360, NULL, NULL, 76059),
(76060, '3.30.160.60-FF-003205', NULL, NULL, 71, NULL, NULL, 76060),
(76061, '1.10.1540.10-FF-000005', NULL, 'BEACH domain-containing protein C1', 208, NULL, NULL, 76061),
(76062, '3.40.50.1460-FF-000085', NULL, 'Protein CBG22515', 218, NULL, NULL, 76062),
(76063, '2.40.50.230-FF-000002', NULL, 'Type VI secretion protein VgrG', 101, NULL, NULL, 76063),
(76064, '1.10.3450.40-FF-000013', NULL, 'Uncharacterized protein', 302, NULL, NULL, 76064),
(76065, '3.30.2140.20-FF-000022', NULL, 'Uncharacterized protein', 190, NULL, NULL, 76065),
(76066, '2.130.10.10-FF-002121', NULL, 'Endoplasmic reticulum to nucleus signaling 2', 211, NULL, NULL, 76066),
(76067, '3.30.420.40-FF-000275', NULL, 'Putative xylulokinase', 329, NULL, NULL, 76067),
(76068, '3.80.10.10-FF-002200', NULL, 'Uncharacterized protein', 238, NULL, NULL, 76068),
(76069, '2.130.10.30-FF-000109', NULL, 'E3 ubiquitin-protein ligase HERC2', 369, NULL, NULL, 76069),
(76070, '3.40.309.10-FF-000044', NULL, 'Aldehyde dehydrogenase', 201, NULL, NULL, 76070),
(76071, '3.30.420.40-FF-000387', NULL, 'Conserved hypothetical proline and threonine rich protein', 131, NULL, NULL, 76071);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(76072, '3.30.1490.100-FF-000024', NULL, 'DNA polymerase kappa subunit', 105, NULL, NULL, 76072),
(76073, '1.25.40.10-FF-001530', NULL, 'Predicted protein', 120, NULL, NULL, 76073),
(76074, '2.60.40.10-FF-001536', NULL, 'Sidestep, isoform A', 81, NULL, NULL, 76074),
(76075, '1.10.472.10-FF-000572', NULL, 'Cyclin D3', 54, NULL, NULL, 76075),
(76076, '3.20.190.10-FF-000019', NULL, 'Fpg1p', 179, NULL, NULL, 76076),
(76077, '3.30.930.10-FF-000035', NULL, 'Putative lipoyltransferase 2, mitochondrial', 213, NULL, NULL, 76077),
(76078, '3.40.50.1360-FF-000061', NULL, '6-phosphogluconolactonase', 158, NULL, NULL, 76078),
(76079, '3.30.40.10-FF-000315', NULL, 'RING finger protein 215', 90, NULL, NULL, 76079),
(76080, '3.30.750.24-FF-000135', NULL, 'Anti-sigma factor antagonist', 105, NULL, NULL, 76080),
(76081, '2.40.240.20-FF-000009', NULL, 'Ribosomal RNA small subunit methyltransferase E', 74, NULL, NULL, 76081),
(76082, '1.25.60.10-FF-000002', NULL, 'Magnesium transporter MgtE', 129, NULL, NULL, 76082),
(76083, '1.20.1420.30-FF-000090', NULL, 'Potassium-dependent sodium-calcium exchanger, putative', 102, NULL, NULL, 76083),
(76084, '3.60.21.10-FF-000377', NULL, 'Uncharacterized protein', 102, NULL, NULL, 76084),
(76085, '1.20.120.980-FF-000054', NULL, 'Uncharacterized protein', 77, NULL, NULL, 76085),
(76086, '3.40.50.300-FF-006685', NULL, 'Uncharacterized protein, isoform H', 81, NULL, NULL, 76086),
(76087, '1.20.5.170-FF-000267', NULL, 'Predicted protein', 73, NULL, NULL, 76087),
(76088, '2.60.40.2030-FF-000033', NULL, 'Adhesion G protein-coupled receptor V1', 108, NULL, NULL, 76088),
(76089, '2.130.10.10-FF-000103', NULL, 'Meiosis regulator for oocyte development', 314, NULL, NULL, 76089),
(76090, '3.30.519.10-FF-000028', NULL, NULL, 153, NULL, NULL, 76090),
(76091, '1.10.8.1310-FF-000014', NULL, 'Uncharacterized protein', 178, NULL, NULL, 76091),
(76092, '3.30.70.330-FF-002552', NULL, NULL, 151, NULL, NULL, 76092),
(76093, '1.20.144.10-FF-000044', NULL, 'Lipid A 1-phosphatase', 104, NULL, NULL, 76093),
(76094, '3.40.630.150-FF-000015', NULL, 'Uncharacterized protein', 240, NULL, NULL, 76094),
(76095, '3.40.50.300-FF-000502', NULL, 'Apoptotic protease-activating factor 1', 182, NULL, NULL, 76095),
(76096, '1.25.40.20-FF-000791', NULL, 'Ankyrin repeats (3 copies), putative', 108, NULL, NULL, 76096),
(76097, '1.20.140.150-FF-000028', NULL, 'Uncharacterized protein, isoform A', 177, NULL, NULL, 76097),
(76098, '3.90.1150.10-FF-000500', NULL, 'Glycine cleavage system P protein', 139, NULL, NULL, 76098),
(76099, '3.90.226.10-FF-000172', NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', 351, NULL, NULL, 76099),
(76100, '3.10.580.10-FF-000102', NULL, 'Chloride channel, voltage-sensitive 2a', 105, NULL, NULL, 76100),
(76101, '3.30.160.60-FF-005459', NULL, NULL, 33, NULL, NULL, 76101),
(76102, '3.10.110.10-FF-000168', NULL, 'Predicted protein', 110, NULL, NULL, 76102),
(76103, '3.90.1150.10-FF-000388', NULL, 'Uncharacterized protein', 60, NULL, NULL, 76103),
(76104, '2.60.40.4190-FF-000001', NULL, 'Major S-layer protein', 129, NULL, NULL, 76104),
(76105, '3.40.1170.10-FF-000018', NULL, 'MutS family protein', 168, NULL, NULL, 76105),
(76106, '3.40.50.300-FF-003251', NULL, 'SNF2 family helicase-like protein, putative', 260, NULL, NULL, 76106),
(76107, '1.10.150.60-FF-000013', NULL, 'AT-rich interactive domain-containing protein 4B', 108, NULL, NULL, 76107),
(76108, '3.30.160.60-FF-001300', NULL, 'Zinc finger and BTB domain-containing protein 47', 26, NULL, NULL, 76108),
(76109, '1.20.1050.10-FF-000173', NULL, 'Glutathione S-transferase', 133, NULL, NULL, 76109),
(76110, '1.10.220.30-FF-000010', NULL, 'Flagellar motor switch protein FliG', 86, NULL, NULL, 76110),
(76111, '3.90.660.10-FF-000091', NULL, NULL, 211, NULL, NULL, 76111),
(76112, '2.40.50.140-FF-001144', NULL, NULL, 150, NULL, NULL, 76112),
(76113, '2.30.29.30-FF-000235', NULL, 'Coactivator-associated arginine methyltransferase 1', 114, NULL, NULL, 76113),
(76114, '3.30.70.850-FF-000016', NULL, 'Uncharacterized protein', 66, NULL, NULL, 76114);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(76115, '1.20.1070.10-FF-000404', NULL, 'Cyclic AMP receptor-like protein A', 255, NULL, NULL, 76115),
(76116, '3.90.1750.10-FF-000012', NULL, 'E3 ubiquitin-protein ligase UPL7', 158, NULL, NULL, 76116),
(76117, '3.30.200.20-FF-000865', NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', 76, NULL, NULL, 76117),
(76118, '3.30.200.160-FF-000008', NULL, 'Transcription factor TFIIIC subunit', 129, NULL, NULL, 76118),
(76119, '1.10.10.10-FF-001628', NULL, 'Lambda phage replication protein O', 96, NULL, NULL, 76119),
(76120, '1.10.510.10-FF-002483', NULL, NULL, 193, NULL, NULL, 76120),
(76121, '1.20.1640.10-FF-000095', NULL, NULL, 196, NULL, NULL, 76121),
(76122, '3.80.10.10-FF-000963', NULL, 'Nucleotide excision NEF4 component', 179, NULL, NULL, 76122),
(76123, '2.60.40.10-FF-002267', NULL, 'Myotactin form A', 114, NULL, NULL, 76123),
(76124, '3.30.230.10-FF-000358', NULL, 'Uncharacterized protein', 123, NULL, NULL, 76124),
(76125, '1.10.260.40-FF-000027', NULL, 'Homeobox protein cut-like', 83, NULL, NULL, 76125),
(76126, '2.20.70.10-FF-000067', NULL, 'Pre-mRNA-processing protein 40C', 44, NULL, NULL, 76126),
(76127, '2.160.20.10-FF-000018', NULL, 'Pectinesterase', 303, NULL, NULL, 76127),
(76128, '3.90.550.50-FF-000083', NULL, 'Hexosyltransferase', 256, NULL, NULL, 76128),
(76129, '1.20.1250.10-FF-000065', NULL, 'Prolactin, gene 2', 196, NULL, NULL, 76129),
(76130, '1.20.58.70-FF-000126', NULL, 'Uncharacterized protein', 59, NULL, NULL, 76130),
(76131, '2.30.29.170-FF-000025', NULL, NULL, 120, NULL, NULL, 76131),
(76132, '1.20.5.190-FF-000149', NULL, NULL, 55, NULL, NULL, 76132),
(76133, '1.10.510.10-FF-004517', NULL, NULL, 115, NULL, NULL, 76133),
(76134, '1.10.565.10-FF-000041', NULL, 'Nuclear hormone receptor HR78', 238, NULL, NULL, 76134),
(76135, '1.10.238.10-FF-000545', NULL, 'EF-hand calcium-binding domain-containing protein 6', 78, NULL, NULL, 76135),
(76136, '3.40.50.1820-FF-000912', NULL, 'Uncharacterized protein', 94, NULL, NULL, 76136),
(76137, '3.40.50.12760-FF-000017', NULL, 'Uncharacterized protein', 365, NULL, NULL, 76137),
(76138, '3.30.40.10-FF-001844', NULL, 'Uncharacterized protein', 83, NULL, NULL, 76138),
(76139, '3.40.50.720-FF-001359', NULL, 'Glutamyl-tRNA reductase', 141, NULL, NULL, 76139),
(76140, '3.30.160.60-FF-004734', NULL, NULL, 30, NULL, NULL, 76140),
(76141, '1.25.10.10-FF-002427', NULL, 'Uncharacterized protein', 243, NULL, NULL, 76141),
(76142, '2.60.120.200-FF-000294', NULL, 'NeuReXin related', 180, NULL, NULL, 76142),
(76143, '2.60.40.10-FF-005807', NULL, NULL, 70, NULL, NULL, 76143),
(76144, '1.10.510.10-FF-003320', NULL, NULL, 69, NULL, NULL, 76144),
(76145, '3.40.50.740-FF-000050', NULL, 'NADH-quinone oxidoreductase', 124, NULL, NULL, 76145),
(76146, '1.10.287.130-FF-000014', NULL, 'Signal transduction histidine-protein kinase BaeS', 65, NULL, NULL, 76146),
(76147, '3.30.420.10-FF-000171', NULL, '3''-5'' exoribonuclease', 168, NULL, NULL, 76147),
(76148, '1.20.120.140-FF-000038', NULL, 'GTP-binding signal recognition particle SRP54 G-domain protein', 81, NULL, NULL, 76148),
(76149, '3.40.20.10-FF-000016', NULL, 'supervillin isoform X2', 129, NULL, NULL, 76149),
(76150, '3.30.559.30-FF-000020', NULL, 'Nonribosomal peptide synthase SidD', 228, NULL, NULL, 76150),
(76151, '1.25.40.20-FF-000004', NULL, 'Phosphatase 1 regulatory subunit 12A', 137, NULL, NULL, 76151),
(76152, '1.10.590.10-FF-000003', NULL, 'Chorismate mutase', 257, NULL, NULL, 76152),
(76153, '2.60.40.1510-FF-000006', NULL, 'Integrin beta', 142, NULL, NULL, 76153),
(76154, '3.20.20.80-FF-000274', NULL, 'Alpha-L-fucosidase-like', 310, NULL, NULL, 76154),
(76155, '3.50.50.60-FF-000420', NULL, '2-octaprenyl-6-methoxyphenyl hydroxylase', 138, NULL, NULL, 76155),
(76156, '3.30.1520.10-FF-000110', NULL, 'Phospholipase', 134, NULL, NULL, 76156),
(76157, '1.10.620.20-FF-000004', NULL, 'Ribonucleoside-diphosphate reductase subunit M2 B', 310, NULL, NULL, 76157),
(76158, '1.10.150.80-FF-000019', NULL, 'ATP-dependent DNA helicase', 88, NULL, NULL, 76158),
(76159, '3.30.300.20-FF-000013', NULL, 'Transcription termination/antitermination protein NusA', 63, NULL, NULL, 76159);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(76160, '1.25.40.20-FF-000459', NULL, 'Ankyrin_repeats_(3_copies)/Ankyrin_repeat/Ankyrin _repeats_(Many_copies)', 153, NULL, NULL, 76160),
(76161, '3.30.1140.40-FF-000011', NULL, 'Predicted gene 3448', 98, NULL, NULL, 76161),
(76162, '2.60.120.200-FF-000170', NULL, 'neurexin-1 isoform X4', 173, NULL, NULL, 76162),
(76163, '3.30.70.141-FF-000006', NULL, 'Nucleoside diphosphate kinase', 152, NULL, NULL, 76163),
(76164, '3.60.10.10-FF-000127', NULL, 'DNase I superfamily protein', 155, NULL, NULL, 76164),
(76165, '1.25.40.10-FF-003435', NULL, 'Pentatricopeptide repeat-containing protein At4g35130, chloroplastic', 91, NULL, NULL, 76165),
(76166, '1.20.1070.10-FF-000298', NULL, 'Integral membrane protein GPR155', 192, NULL, NULL, 76166),
(76167, '1.10.3380.20-FF-000012', NULL, NULL, 132, NULL, NULL, 76167),
(76168, '3.40.50.300-FF-008607', NULL, 'Peroxisomal ATPase pex6', 149, NULL, NULL, 76168),
(76169, '3.40.50.300-FF-007989', NULL, 'DNA replication helicase DNA2, putative', 156, NULL, NULL, 76169),
(76170, '3.40.50.1000-FF-000767', NULL, NULL, 123, NULL, NULL, 76170),
(76171, '1.20.5.350-FF-000001', NULL, 'Troponin T, fast skeletal muscle', 106, NULL, NULL, 76171),
(76172, '3.40.605.10-FF-000081', NULL, 'Gamma-glutamyl phosphate reductase 2', 245, NULL, NULL, 76172),
(76173, '3.20.20.80-FF-000150', NULL, 'Class III chitinase ChiA1', 308, NULL, NULL, 76173),
(76174, '2.60.40.10-FF-005246', NULL, NULL, 114, NULL, NULL, 76174),
(76175, '3.90.79.10-FF-000290', NULL, 'Adenine DNA glycosylase', 188, NULL, NULL, 76175),
(76176, '1.25.40.10-FF-002598', NULL, 'Pentatricopeptide repeat-containing protein At2g22070', 120, NULL, NULL, 76176),
(76177, '1.20.1560.10-FF-000274', NULL, 'ABC transporter ATP-binding protein', 325, NULL, NULL, 76177),
(76178, '1.10.8.10-FF-000026', NULL, 'E3 ubiquitin-protein ligase AMFR', 52, NULL, NULL, 76178),
(76179, '1.25.40.10-FF-003216', NULL, 'Pentatricopeptide repeat-containing protein', 70, NULL, NULL, 76179),
(76180, '3.30.200.20-FF-002208', NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 178', 47, NULL, NULL, 76180),
(76181, '3.10.330.10-FF-000044', NULL, 'Peroxisomal ATPase pex1', 79, NULL, NULL, 76181),
(76182, '1.20.120.160-FF-000033', NULL, 'Histidine kinase', 107, NULL, NULL, 76182),
(76183, '3.40.50.300-FF-008265', NULL, 'DsRNA-specific nuclease dicer and related ribonuclease', 47, NULL, NULL, 76183),
(76184, '3.10.100.10-FF-000342', NULL, NULL, 141, NULL, NULL, 76184),
(76185, '3.30.70.3020-FF-000005', NULL, 'U3 small nucleolar RNA-associated protein 22', 34, NULL, NULL, 76185),
(76186, '1.10.287.10-FF-000057', NULL, 'Uncharacterized protein', 35, NULL, NULL, 76186),
(76187, '2.60.40.10-FF-002828', NULL, 'Si:ch211-150o23.3', 103, NULL, NULL, 76187),
(76188, '3.30.160.60-FF-001749', NULL, 'Zinc finger protein 263', 31, NULL, NULL, 76188),
(76189, '3.30.1430.10-FF-000007', NULL, '60S ribosomal protein L3, putative', 124, NULL, NULL, 76189),
(76190, '2.60.120.260-FF-000502', NULL, 'Uncharacterized protein', 81, NULL, NULL, 76190),
(76191, '1.10.3120.10-FF-000030', NULL, NULL, 34, NULL, NULL, 76191),
(76192, '2.130.10.10-FF-005555', NULL, 'Sortilin', 220, NULL, NULL, 76192),
(76193, '1.20.1000.10-FF-000018', NULL, 'Uncharacterized protein', 289, NULL, NULL, 76193),
(76194, '2.60.120.10-FF-000307', NULL, 'RmlC-like jelly roll fold protein', 184, NULL, NULL, 76194),
(76195, '3.30.70.330-FF-001602', NULL, 'Peroxisome proliferator-activated receptor gamma, coactivator-related 1', 152, NULL, NULL, 76195),
(76196, '3.30.1240.10-FF-000072', NULL, 'Glr0833 protein', 107, NULL, NULL, 76196),
(76197, '2.60.40.60-FF-000893', NULL, 'Uncharacterized protein', 125, NULL, NULL, 76197),
(76198, '1.25.40.10-FF-005346', NULL, 'Pentatricopeptide repeat-containing protein At1g12300, mitochondrial', 152, NULL, NULL, 76198),
(76199, '1.25.10.10-FF-001466', NULL, 'Dynein axonemal assembly factor 5', 229, NULL, NULL, 76199),
(76200, '1.20.920.10-FF-000100', NULL, 'Chromatin remodeling-related protein, putative', 114, NULL, NULL, 76200),
(76201, '3.30.565.10-FF-000427', NULL, 'Uncharacterized protein', 119, NULL, NULL, 76201);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(76202, '2.170.120.12-FF-000036', NULL, 'RNA polymerase Rpb3/Rpb11 dimerisation domain containing protein', 145, NULL, NULL, 76202),
(76203, '3.30.160.60-FF-002025', NULL, 'zinc finger protein 473 isoform X2', 29, NULL, NULL, 76203),
(76204, '2.120.10.30-FF-000290', NULL, 'Teneurin-m-like Protein', 69, NULL, NULL, 76204),
(76205, '3.40.50.720-FF-000634', NULL, '6-phosphogluconate dehydrogenase, decarboxylating', 193, NULL, NULL, 76205),
(76206, '3.40.50.2300-FF-000736', NULL, 'Two-component hybrid sensor and regulator', 127, NULL, NULL, 76206),
(76207, '3.40.50.360-FF-000149', NULL, 'Oxygen-independent protoporphyrinogen oxidase HemG', 96, NULL, NULL, 76207),
(76208, '2.40.50.40-FF-000113', NULL, 'C-C motif chemokine 5', 49, NULL, NULL, 76208),
(76209, '2.60.40.150-FF-000606', NULL, 'Phosphoinositide phospholipase C', 124, NULL, NULL, 76209),
(76210, '3.50.50.60-FF-001145', NULL, 'FAD dependent oxidoreductase domain containing 2', 80, NULL, NULL, 76210),
(76211, '1.10.510.10-FF-000465', NULL, 'Non-specific serine/threonine protein kinase', 194, NULL, NULL, 76211),
(76212, '2.60.40.10-FF-004285', NULL, NULL, 180, NULL, NULL, 76212),
(76213, '1.20.1280.50-FF-000106', NULL, 'Transcription factor jumonji domain-containing protein', 81, NULL, NULL, 76213),
(76214, '3.90.70.10-FF-000888', NULL, 'Protein CBG06541', 221, NULL, NULL, 76214),
(76215, '1.25.40.10-FF-002255', NULL, 'Uncharacterized protein', 143, NULL, NULL, 76215),
(76216, '3.20.20.70-FF-000052', NULL, 'Fructose-bisphosphate aldolase', 361, NULL, NULL, 76216),
(76217, '3.40.50.1820-FF-000569', NULL, 'Blast:Protein SERAC1', 164, NULL, NULL, 76217),
(76218, '1.10.630.10-FF-000625', NULL, 'Uncharacterized protein', 233, NULL, NULL, 76218),
(76219, '2.30.42.10-FF-000103', NULL, 'membrane-associated guanylate kinase, WW and PDZ domain-containing protein 1 isoform X2', 107, NULL, NULL, 76219),
(76220, '3.90.650.10-FF-000039', NULL, 'Selenide, water dikinase', 180, NULL, NULL, 76220),
(76221, '1.20.120.230-FF-000065', NULL, 'Cas scaffold protein family member 4', 128, NULL, NULL, 76221),
(76222, '3.90.550.10-FF-000661', NULL, 'Hexosyltransferase', 122, NULL, NULL, 76222),
(76223, '3.30.160.60-FF-004498', NULL, NULL, 31, NULL, NULL, 76223),
(76224, '3.50.50.60-FF-000869', NULL, 'Amine oxidase (Flavin-containing)', 405, NULL, NULL, 76224),
(76225, '3.40.1480.10-FF-000008', NULL, 'Glycerate kinase', 171, NULL, NULL, 76225),
(76226, '3.30.160.60-FF-000788', NULL, 'Zinc finger protein 574', 28, NULL, NULL, 76226),
(76227, '3.30.160.60-FF-005791', NULL, NULL, 27, NULL, NULL, 76227),
(76228, '2.130.10.10-FF-004594', NULL, 'Uncharacterized protein', 205, NULL, NULL, 76228),
(76229, '3.30.800.10-FF-000031', NULL, NULL, 91, NULL, NULL, 76229),
(76230, '3.70.10.10-FF-000031', NULL, 'Uncharacterized protein', 263, NULL, NULL, 76230),
(76231, '1.25.40.10-FF-004385', NULL, 'Uncharacterized protein', 143, NULL, NULL, 76231),
(76232, '3.90.228.10-FF-000007', NULL, 'Poly [ADP-ribose] polymerase', 136, NULL, NULL, 76232),
(76233, '1.20.1250.20-FF-001686', NULL, 'Uncharacterized protein', 106, NULL, NULL, 76233),
(76234, '1.25.40.10-FF-001979', NULL, 'Pentatricopeptide repeat-containing protein', 110, NULL, NULL, 76234),
(76235, '3.90.1150.10-FF-000264', NULL, 'DegT/DnrJ/EryC1/StrS aminotransferase', 131, NULL, NULL, 76235),
(76236, '1.10.150.20-FF-000136', NULL, 'DNA ligase B', 77, NULL, NULL, 76236),
(76237, '2.60.120.820-FF-000024', NULL, 'Predicted protein', 54, NULL, NULL, 76237),
(76238, '1.20.1250.20-FF-002304', NULL, 'Uncharacterized protein', 196, NULL, NULL, 76238),
(76239, '2.70.130.10-FF-000087', NULL, NULL, 144, NULL, NULL, 76239),
(76240, '3.80.10.10-FF-000289', NULL, 'leucine-rich repeat-containing protein 30', 123, NULL, NULL, 76240),
(76241, '2.60.120.260-FF-000160', NULL, 'Spindle pole body-associated protein sad1', 206, NULL, NULL, 76241),
(76242, '2.60.40.10-FF-004740', NULL, NULL, 105, NULL, NULL, 76242),
(76243, '3.90.640.10-FF-000089', NULL, 'Heat shock protein family A (Hsp70) member 13', 62, NULL, NULL, 76243),
(76244, '4.10.240.10-FF-000067', NULL, 'TOG1p Transcriptional activator', 64, NULL, NULL, 76244); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(76245, '1.20.58.1070-FF-000029', NULL, 'Uncharacterized protein', 203, NULL, NULL, 76245),
(76246, '3.10.580.10-FF-000208', NULL, 'Uncharacterized protein', 70, NULL, NULL, 76246),
(76247, '3.40.50.300-FF-000160', NULL, 'ATP-dependent RNA helicase DDX3X', 258, NULL, NULL, 76247),
(76248, '3.40.190.10-FF-000936', NULL, 'Uncharacterized protein', 37, NULL, NULL, 76248),
(76249, '3.10.350.10-FF-000057', NULL, 'Uncharacterized protein', 51, NULL, NULL, 76249),
(76250, '2.60.40.740-FF-000002', NULL, 'Cell surface antigen I/II', 159, NULL, NULL, 76250),
(76251, '3.40.50.2000-FF-000860', NULL, 'Glycogen synthase 2', 207, NULL, NULL, 76251),
(76252, '3.30.1300.30-FF-000009', NULL, 'Type II secretion system protein K', 86, NULL, NULL, 76252),
(76253, '1.10.4160.10-FF-000044', NULL, NULL, 244, NULL, NULL, 76253),
(76254, '3.30.200.20-FF-000067', NULL, 'Mitogen-activated protein kinase kinase kinase 5', 100, NULL, NULL, 76254),
(76255, '3.30.160.60-FF-005353', NULL, NULL, 28, NULL, NULL, 76255),
(76256, '1.25.40.10-FF-001075', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 94, NULL, NULL, 76256),
(76257, '3.40.50.150-FF-001615', NULL, NULL, 251, NULL, NULL, 76257),
(76258, '1.20.5.1930-FF-000001', NULL, 'Sensor histidine protein kinase UhpB', 87, NULL, NULL, 76258),
(76259, '1.25.10.10-FF-001808', NULL, 'YALI0D11132p', 239, NULL, NULL, 76259),
(76260, '3.30.160.60-FF-001064', NULL, 'Zinc finger protein 425', 27, NULL, NULL, 76260),
(76261, '3.40.1350.10-FF-000004', NULL, 'Fanconi-associated nuclease', 83, NULL, NULL, 76261),
(76262, '3.50.50.60-FF-000526', NULL, 'FAD-dependent oxidoreductase', 125, NULL, NULL, 76262),
(76263, '3.40.190.10-FF-000357', NULL, 'ABC-type nitrate/sulfonate/bicarbonate transport system, substrate-binding protein', 179, NULL, NULL, 76263),
(76264, '3.30.450.20-FF-000001', NULL, 'Potassium voltage-gated channel subfamily H member 7', 137, NULL, NULL, 76264),
(76265, '3.80.10.10-FF-001582', NULL, 'Slit homolog 2 protein', 115, NULL, NULL, 76265),
(76266, '3.40.50.720-FF-000055', NULL, 'NAD-dependent malic enzyme', 298, NULL, NULL, 76266),
(76267, '1.10.510.10-FF-001426', NULL, 'Uncharacterized protein', 147, NULL, NULL, 76267),
(76268, '1.10.555.10-FF-000091', NULL, 'Rho GTPase activating protein, putative', 204, NULL, NULL, 76268),
(76269, '3.30.70.1390-FF-000010', NULL, 'Uncharacterized protein', 97, NULL, NULL, 76269),
(76270, '3.40.50.11210-FF-000019', NULL, NULL, 64, NULL, NULL, 76270),
(76271, '1.25.40.10-FF-001636', NULL, 'Pentatricopeptide repeat-containing protein At2g20540', 156, NULL, NULL, 76271),
(76272, '3.40.50.1820-FF-001188', NULL, 'Serine carboxypeptidase S28 family protein', 54, NULL, NULL, 76272),
(76273, '3.50.50.60-FF-000184', NULL, 'Phytoene dehydrogenase', 447, NULL, NULL, 76273),
(76274, '2.60.420.10-FF-000004', NULL, 'Uncharacterized glycosyl hydrolase Rv3401', 85, NULL, NULL, 76274),
(76275, '3.40.50.10260-FF-000026', NULL, 'Bifunctional NAD(P)H-hydrate repair enzyme Nnr', 209, NULL, NULL, 76275),
(76276, '2.60.34.10-FF-000066', NULL, 'Heat shock 70kDa protein', 44, NULL, NULL, 76276),
(76277, '3.40.50.410-FF-000081', NULL, 'Vesicle coat component', 241, NULL, NULL, 76277),
(76278, '2.60.40.640-FF-000085', NULL, 'Vacuolar sorting protein 26 putative', 154, NULL, NULL, 76278),
(76279, '1.10.287.3700-FF-000002', NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', 100, NULL, NULL, 76279),
(76280, '2.160.10.10-FF-000068', NULL, 'Uncharacterized protein', 123, NULL, NULL, 76280),
(76281, '1.25.10.10-FF-001123', NULL, 'Catenin (cadherin-associated protein), delta 2a', 198, NULL, NULL, 76281),
(76282, '2.60.40.10-FF-005701', NULL, NULL, 59, NULL, NULL, 76282),
(76283, '1.20.5.110-FF-000165', NULL, 'Coiled-coil domain-containing protein', 53, NULL, NULL, 76283),
(76284, '3.40.50.2000-FF-000528', NULL, 'Sulfoquinovosyl transferase SQD2', 173, NULL, NULL, 76284),
(76285, '3.90.79.10-FF-000177', NULL, 'Nudix (nucleoside diphosphate-linked moiety X)-type motif 5', 132, NULL, NULL, 76285),
(76286, '1.10.10.60-FF-000435', NULL, 'Transcription factor MYB124', 70, NULL, NULL, 76286); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(76287, '2.10.109.10-FF-000085', NULL, 'Signal peptidase I', 53, NULL, NULL, 76287),
(76288, '2.10.70.10-FF-000152', NULL, 'Uncharacterized protein, isoform A', 56, NULL, NULL, 76288),
(76289, '1.20.120.1910-FF-000031', NULL, 'Cysteine--tRNA ligase', 177, NULL, NULL, 76289),
(76290, '1.20.120.420-FF-000021', NULL, 'Methylthioribose-1-phosphate isomerase', 142, NULL, NULL, 76290),
(76291, '1.25.40.180-FF-000019', NULL, 'CBP80/20-dependent translation initiation factor isoform X2', 219, NULL, NULL, 76291),
(76292, '2.30.29.30-FF-000472', NULL, 'Pleckstrin y domain-containing family H member 2', 111, NULL, NULL, 76292),
(76293, '3.40.50.300-FF-004555', NULL, 'Predicted protein', 30, NULL, NULL, 76293),
(76294, '3.40.47.10-FF-000044', NULL, 'Probable acetyl-CoA acyltransferase', 203, NULL, NULL, 76294),
(76295, '3.30.70.330-FF-002895', NULL, NULL, 54, NULL, NULL, 76295),
(76296, '3.40.50.720-FF-000179', NULL, 'Biliverdin reductase A', 137, NULL, NULL, 76296),
(76297, '1.25.10.10-FF-001247', NULL, 'RING-type E3 ubiquitin transferase', 194, NULL, NULL, 76297),
(76298, '2.80.10.50-FF-000112', NULL, 'Hisactophilin-1', 118, NULL, NULL, 76298),
(76299, '3.40.1110.10-FF-000133', NULL, 'Probable cation-transporting P-type ATPase', 117, NULL, NULL, 76299),
(76300, '1.25.10.10-FF-000847', NULL, 'Sister chromatid cohesion protein', 132, NULL, NULL, 76300),
(76301, '3.30.200.20-FF-001247', NULL, 'Protein CBG08151', 92, NULL, NULL, 76301),
(76302, '1.20.1250.20-FF-001467', NULL, 'Putative monocarboxylate transporter', 224, NULL, NULL, 76302),
(76303, '2.40.30.30-FF-000002', NULL, 'Riboflavin kinase, putative', 147, NULL, NULL, 76303),
(76304, '3.40.630.10-FF-000386', NULL, 'Carboxypeptidase D, b', 65, NULL, NULL, 76304),
(76305, '3.90.190.10-FF-000234', NULL, 'Inactive protein-tyrosine phosphatase egg-5', 272, NULL, NULL, 76305),
(76306, '3.30.200.20-FF-002540', NULL, 'Ribosomal protein S6 kinase', 21, NULL, NULL, 76306),
(76307, '2.130.10.10-FF-004156', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit wuho', 174, NULL, NULL, 76307),
(76308, '1.20.58.390-FF-000097', NULL, 'Gamma-aminobutyric acid (GABA) A receptor, beta 2', 158, NULL, NULL, 76308),
(76309, '2.30.39.10-FF-000073', NULL, 'RCG21015, isoform CRA_a', 145, NULL, NULL, 76309),
(76310, '3.40.50.300-FF-001121', NULL, 'Sulfotransferase', 267, NULL, NULL, 76310),
(76311, '3.40.50.300-FF-004898', NULL, 'Drug resistance protein 1 (Truncated)', 268, NULL, NULL, 76311),
(76312, '1.10.220.100-FF-000006', NULL, 'Uncharacterized protein', 56, NULL, NULL, 76312),
(76313, '2.30.30.30-FF-000087', NULL, 'Ribosomal Protein, Large subunit', 86, NULL, NULL, 76313),
(76314, '3.40.50.150-FF-000654', NULL, 'Rab geranylgeranyl transferase component A, putative', 247, NULL, NULL, 76314),
(76315, '1.20.1110.10-FF-000122', NULL, NULL, 75, NULL, NULL, 76315),
(76316, '3.30.230.60-FF-000002', NULL, 'Formaldehyde-activating enzyme domain protein', 87, NULL, NULL, 76316),
(76317, '3.40.50.300-FF-000845', NULL, 'Mitochondrial helicase twinkle', 256, NULL, NULL, 76317),
(76318, '1.10.20.10-FF-000275', NULL, NULL, 76, NULL, NULL, 76318),
(76319, '3.30.1490.180-FF-000008', NULL, 'DNA-directed RNA polymerase subunit', 70, NULL, NULL, 76319),
(76320, '1.25.40.180-FF-000351', NULL, NULL, 66, NULL, NULL, 76320),
(76321, '1.25.10.10-FF-000286', NULL, 'rap1 GTPase-GDP dissociation stimulator 1 isoform X5', 221, NULL, NULL, 76321),
(76322, '2.160.20.20-FF-000010', NULL, 'Adhesion and penetration protein autotransporter', 526, NULL, NULL, 76322),
(76323, '2.70.98.10-FF-000106', NULL, 'Aldose 1-epimerase', 341, NULL, NULL, 76323),
(76324, '3.40.50.2300-FF-001450', NULL, NULL, 19, NULL, NULL, 76324),
(76325, '3.40.50.1820-FF-001749', NULL, 'Uncharacterized protein', 50, NULL, NULL, 76325),
(76326, '2.60.40.1910-FF-000019', NULL, 'Aminopeptidase', 97, NULL, NULL, 76326),
(76327, '3.30.40.10-FF-002226', NULL, 'Uncharacterized protein', 67, NULL, NULL, 76327),
(76328, '3.40.1390.30-FF-000007', NULL, 'Dinuclear metal center protein, YbgI family', 98, NULL, NULL, 76328),
(76329, '2.20.80.10-FF-000017', NULL, 'Apolipoprotein Bb, tandem duplicate 1', 202, NULL, NULL, 76329);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(76330, '2.130.10.10-FF-000446', NULL, 'protein ANTHESIS POMOTING FACTOR 1 isoform X1', 301, NULL, NULL, 76330),
(76331, '3.80.10.10-FF-002543', NULL, 'Uncharacterized protein', 161, NULL, NULL, 76331),
(76332, '3.60.20.10-FF-000066', NULL, 'Proteasome subunit alpha type', 170, NULL, NULL, 76332),
(76333, '3.30.43.10-FF-000013', NULL, 'FAD binding domain in molybdopterin dehydrogenase', 53, NULL, NULL, 76333),
(76334, '2.30.30.140-FF-000136', NULL, 'Uncharacterized protein, isoform A', 97, NULL, NULL, 76334),
(76335, '3.40.220.10-FF-000012', NULL, 'Protein mono-ADP-ribosyltransferase PARP9', 186, NULL, NULL, 76335),
(76336, '1.10.8.270-FF-000108', NULL, 'Uncharacterized protein', 97, NULL, NULL, 76336),
(76337, '2.40.10.10-FF-000012', NULL, 'protease Do-like 9', 111, NULL, NULL, 76337),
(76338, '2.40.330.10-FF-000002', NULL, 'B3 domain-containing protein', 124, NULL, NULL, 76338),
(76339, '3.30.590.10-FF-000047', NULL, 'Uncharacterized protein', 93, NULL, NULL, 76339),
(76340, '3.20.20.140-FF-000150', NULL, 'Error-prone DNA polymerase', 291, NULL, NULL, 76340),
(76341, '1.20.1080.10-FF-000124', NULL, 'Uncharacterized protein', 63, NULL, NULL, 76341),
(76342, '3.40.50.2300-FF-000157', NULL, 'Sugar ABC transporter substrate-binding protein', 141, NULL, NULL, 76342),
(76343, '4.10.400.10-FF-000288', NULL, 'Sortilin-related receptor', 33, NULL, NULL, 76343),
(76344, '1.20.120.850-FF-000032', NULL, 'Protein CBG00336', 95, NULL, NULL, 76344),
(76345, '3.40.350.10-FF-000016', NULL, 'Xaa-Pro aminopeptidase', 164, NULL, NULL, 76345),
(76346, '3.40.140.10-FF-000192', NULL, 'Uncharacterized protein', 128, NULL, NULL, 76346),
(76347, '3.30.70.330-FF-000422', NULL, 'serine/arginine-rich splicing factor 12', 101, NULL, NULL, 76347),
(76348, '1.10.340.30-FF-000064', NULL, 'Uncharacterized protein', 90, NULL, NULL, 76348),
(76349, '2.30.29.30-FF-000814', NULL, 'IQ motif and Sec7 domain 2', 103, NULL, NULL, 76349),
(76350, '1.25.40.10-FF-001294', NULL, 'OJ991214_12.4 protein', 161, NULL, NULL, 76350),
(76351, '2.130.10.10-FF-005117', NULL, 'CKA And Striatin Homolog', 145, NULL, NULL, 76351),
(76352, '2.130.10.10-FF-004717', NULL, 'Uncharacterized protein', 168, NULL, NULL, 76352),
(76353, '3.60.15.10-FF-000211', NULL, 'Chromosome 1, whole genome shotgun sequence', 33, NULL, NULL, 76353),
(76354, '3.30.200.20-FF-000286', NULL, 'Titin a', 84, NULL, NULL, 76354),
(76355, '3.40.50.300-FF-005516', NULL, 'ATPase involved in DNA repair', 145, NULL, NULL, 76355),
(76356, '3.30.565.10-FF-000085', NULL, 'Sensor histidine kinase KdpD', 143, NULL, NULL, 76356),
(76357, '3.10.110.10-FF-000281', NULL, 'Uncharacterized protein', 120, NULL, NULL, 76357),
(76358, '3.40.50.970-FF-000113', NULL, 'Oxalate oxidoreductase subunit beta', 215, NULL, NULL, 76358),
(76359, '3.30.9.90-FF-000008', NULL, 'Electron-transferring-flavoprotein dehydrogenase', 78, NULL, NULL, 76359),
(76360, '3.40.50.300-FF-000946', NULL, 'putative ATP-dependent RNA helicase TDRD9', 174, NULL, NULL, 76360),
(76361, '2.120.10.30-FF-000267', NULL, 'Rme-2', 316, NULL, NULL, 76361),
(76362, '3.40.50.410-FF-000041', NULL, 'Collagen alpha-1(XXI) chain isoform X1', 197, NULL, NULL, 76362),
(76363, '3.90.1150.210-FF-000020', NULL, 'F-actin-capping protein subunit beta', 180, NULL, NULL, 76363),
(76364, '3.40.50.1010-FF-000130', NULL, NULL, 120, NULL, NULL, 76364),
(76365, '3.10.100.10-FF-000218', NULL, NULL, 153, NULL, NULL, 76365),
(76366, '1.10.510.10-FF-001572', NULL, 'Si:dkey-31m5.5', 164, NULL, NULL, 76366),
(76367, '3.40.50.2000-FF-000438', NULL, 'UDP-glycosyltransferase 85A3', 106, NULL, NULL, 76367),
(76368, '3.40.50.10490-FF-000084', NULL, 'Glucose-6-phosphate isomerase', 265, NULL, NULL, 76368),
(76369, '1.20.1250.20-FF-000629', NULL, 'Staphyloferrin B transporter', 190, NULL, NULL, 76369),
(76370, '3.40.190.10-FF-000279', NULL, 'PROBABLE SUGAR-BINDING LIPOPROTEIN LPQY', 145, NULL, NULL, 76370),
(76371, '2.60.40.10-FF-004796', NULL, NULL, 110, NULL, NULL, 76371),
(76372, '1.20.120.350-FF-000213', NULL, NULL, 111, NULL, NULL, 76372),
(76373, '1.10.150.50-FF-000027', NULL, 'scm-like with four MBT domains protein 2', 71, NULL, NULL, 76373);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(76374, '2.130.10.10-FF-002683', NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', 339, NULL, NULL, 76374),
(76375, '1.10.10.60-FF-001211', NULL, NULL, 80, NULL, NULL, 76375),
(76376, '2.60.40.10-FF-001570', NULL, 'Cell surface glycoprotein STIM, contains SAM domain', 110, NULL, NULL, 76376),
(76377, '3.30.420.40-FF-000943', NULL, 'Actin-like protein 4', 54, NULL, NULL, 76377),
(76378, '1.10.472.10-FF-000538', NULL, 'Uncharacterized protein', 81, NULL, NULL, 76378),
(76379, '1.10.287.4070-FF-000023', NULL, 'Uncharacterized protein', 81, NULL, NULL, 76379),
(76380, '1.20.1560.10-FF-000436', NULL, 'ABC transporter B family member 2', 106, NULL, NULL, 76380),
(76381, '3.90.1150.10-FF-000039', NULL, 'Serine--pyruvate aminotransferase', 113, NULL, NULL, 76381),
(76382, '3.30.40.10-FF-000933', NULL, 'Phd finger protein, putative', 99, NULL, NULL, 76382),
(76383, '1.10.510.10-FF-002674', NULL, NULL, 35, NULL, NULL, 76383),
(76384, '3.90.470.20-FF-000039', NULL, '4-phosphopantetheinyl transferase', 108, NULL, NULL, 76384),
(76385, '3.30.160.60-FF-005381', NULL, NULL, 49, NULL, NULL, 76385),
(76386, '3.30.160.60-FF-001047', NULL, 'Zinc finger and SCAN domain-containing protein 21', 25, NULL, NULL, 76386),
(76387, '1.10.150.20-FF-000131', NULL, 'UvrABC system protein C', 59, NULL, NULL, 76387),
(76388, '1.25.10.10-FF-000792', NULL, 'E3 ubiquitin ligase', 374, NULL, NULL, 76388),
(76389, '1.25.40.10-FF-004716', NULL, 'Uncharacterized protein', 90, NULL, NULL, 76389),
(76390, '2.10.25.10-FF-001817', NULL, 'Uncharacterized protein', 67, NULL, NULL, 76390),
(76391, '3.90.470.10-FF-000036', NULL, '39S ribosomal protein L22, mitochondrial-like', 165, NULL, NULL, 76391),
(76392, '3.80.10.10-FF-004414', NULL, 'Uncharacterized protein', 69, NULL, NULL, 76392),
(76393, '3.90.70.10-FF-000859', NULL, 'Ubiquitin-specific protease', 98, NULL, NULL, 76393),
(76394, '3.40.390.10-FF-000114', NULL, 'Metalloendopeptidase', 185, NULL, NULL, 76394),
(76395, '2.20.70.10-FF-000056', NULL, 'Formin binding protein 4', 41, NULL, NULL, 76395),
(76396, '1.20.990.10-FF-000060', NULL, 'Uncharacterized protein', 28, NULL, NULL, 76396),
(76397, '1.25.10.10-FF-003107', NULL, 'Armadillo repeat-containing protein 8-like Protein', 218, NULL, NULL, 76397),
(76398, '2.10.110.10-FF-000262', NULL, 'Protein CBR-LIM-7', 73, NULL, NULL, 76398),
(76399, '3.40.640.10-FF-000387', NULL, '2''-deamino-2''-hydroxyneamine transaminase', 228, NULL, NULL, 76399),
(76400, '3.30.40.10-FF-000254', NULL, 'Probable E3 ubiquitin-protein ligase DTX3', 61, NULL, NULL, 76400),
(76401, '3.40.50.12780-FF-000063', NULL, 'Acetyl-coenzyme A synthetase', 421, NULL, NULL, 76401),
(76402, '1.20.1270.10-FF-000010', NULL, 'Heat shock 70 kDa protein 2', 93, NULL, NULL, 76402),
(76403, '3.30.40.10-FF-002378', NULL, 'Uncharacterized protein', 86, NULL, NULL, 76403),
(76404, '3.30.160.60-FF-003138', NULL, 'Zinc finger protein 214', 26, NULL, NULL, 76404),
(76405, '1.10.220.150-FF-000077', NULL, 'ADP-ribosylation factor GTPase-activating protein AGD10', 76, NULL, NULL, 76405),
(76406, '3.20.20.70-FF-000130', NULL, 'Ribulose-phosphate 3-epimerase', 249, NULL, NULL, 76406),
(76407, '3.90.320.10-FF-000054', NULL, 'Exonuclease V', 172, NULL, NULL, 76407),
(76408, '1.10.8.1120-FF-000002', NULL, 'RNA-binding protein', 71, NULL, NULL, 76408),
(76409, '3.40.50.300-FF-005297', NULL, 'Predicted protein', 174, NULL, NULL, 76409),
(76410, '1.20.58.100-FF-000021', NULL, NULL, 80, NULL, NULL, 76410),
(76411, '2.130.10.30-FF-000126', NULL, NULL, 145, NULL, NULL, 76411),
(76412, '3.10.20.90-FF-000923', NULL, 'Histidine ammonia-lyase', 82, NULL, NULL, 76412),
(76413, '2.30.42.10-FF-000249', NULL, 'membrane-associated guanylate kinase, WW and PDZ domain-containing protein 1-like isoform X2', 108, NULL, NULL, 76413),
(76414, '2.30.30.140-FF-000254', NULL, 'Histone acetyltransferase ESA1', 114, NULL, NULL, 76414),
(76415, '1.25.40.20-FF-000976', NULL, 'Uncharacterized protein', 221, NULL, NULL, 76415),
(76416, '3.40.50.300-FF-005151', NULL, 'ABC transporter, ATP binding protein', 319, NULL, NULL, 76416);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(76417, '2.60.40.150-FF-000578', NULL, 'Copine family member IX', 131, NULL, NULL, 76417),
(76418, '3.80.10.10-FF-003897', NULL, 'Uncharacterized protein', 137, NULL, NULL, 76418),
(76419, '1.20.1270.60-FF-000064', NULL, 'Tyrosine-protein kinase', 274, NULL, NULL, 76419),
(76420, '3.40.50.150-FF-000120', NULL, 'probable 28S rRNA (Cytosine(4447)-C(5))-methyltransferase', 327, NULL, NULL, 76420),
(76421, '3.30.70.3490-FF-000039', NULL, NULL, 116, NULL, NULL, 76421),
(76422, '3.20.20.80-FF-000133', NULL, 'Chitinase C1', 326, NULL, NULL, 76422),
(76423, '3.10.450.10-FF-000093', NULL, 'Uncharacterized protein', 70, NULL, NULL, 76423),
(76424, '2.60.34.10-FF-000049', NULL, 'Protein CBG00051', 194, NULL, NULL, 76424),
(76425, '3.30.160.60-FF-003290', NULL, NULL, 29, NULL, NULL, 76425),
(76426, '1.25.10.10-FF-003433', NULL, 'Predicted protein', 150, NULL, NULL, 76426),
(76427, '3.40.190.10-FF-000958', NULL, 'Uncharacterized protein', 87, NULL, NULL, 76427),
(76428, '2.130.10.10-FF-004448', NULL, 'Uncharacterized protein', 348, NULL, NULL, 76428),
(76429, '3.40.630.30-FF-000162', NULL, 'AT4g28030/T13J8_140', 195, NULL, NULL, 76429),
(76430, '3.40.50.80-FF-000151', NULL, 'NADPH reductase TAH18', 96, NULL, NULL, 76430),
(76431, '3.20.20.190-FF-000170', NULL, NULL, 104, NULL, NULL, 76431),
(76432, '3.40.30.10-FF-000174', NULL, 'Protein disulfide-isomerase 5-4', 157, NULL, NULL, 76432),
(76433, '3.40.50.2300-FF-000910', NULL, NULL, 154, NULL, NULL, 76433),
(76434, '2.30.29.30-FF-000382', NULL, 'Uncharacterized protein, isoform A', 100, NULL, NULL, 76434),
(76435, '3.50.50.60-FF-000763', NULL, 'Predicted protein', 109, NULL, NULL, 76435),
(76436, '3.10.20.90-FF-000131', NULL, 'trans-2,3-enoyl-CoA reductase-like', 80, NULL, NULL, 76436),
(76437, '3.10.390.10-FF-000003', NULL, 'glucocorticoid modulatory element-binding protein 1 isoform X2', 96, NULL, NULL, 76437),
(76438, '3.30.70.330-FF-000815', NULL, 'Serine/arginine-rich splicing factor SR30', 113, NULL, NULL, 76438),
(76439, '3.20.20.140-FF-000262', NULL, 'Carbohydrate esterase family 9 protein', 63, NULL, NULL, 76439),
(76440, '3.30.830.10-FF-000269', NULL, 'FI23714p1', 242, NULL, NULL, 76440),
(76441, '2.130.10.10-FF-000120', NULL, 'Semaphorin 4D', 481, NULL, NULL, 76441),
(76442, '1.10.1820.10-FF-000015', NULL, 'Casein kinase II subunit beta', 101, NULL, NULL, 76442),
(76443, '2.60.40.2860-FF-000023', NULL, 'Merozoite surface protein P41', 138, NULL, NULL, 76443),
(76444, '2.40.37.10-FF-000012', NULL, 'Arginine decarboxylase', 185, NULL, NULL, 76444),
(76445, '1.25.40.470-FF-000044', NULL, 'WD repeat-containing protein', 185, NULL, NULL, 76445),
(76446, '1.20.1260.10-FF-000071', NULL, 'Ferritin light chain', 43, NULL, NULL, 76446),
(76447, '2.120.10.30-FF-000593', NULL, 'Uncharacterized protein', 100, NULL, NULL, 76447),
(76448, '3.30.70.590-FF-000022', NULL, 'Predicted protein', 83, NULL, NULL, 76448),
(76449, '3.60.15.10-FF-000177', NULL, 'MBL fold metallo-hydrolase', 197, NULL, NULL, 76449),
(76450, '3.90.1010.10-FF-000029', NULL, 'Uncharacterized protein', 45, NULL, NULL, 76450),
(76451, '1.25.40.1040-FF-000061', NULL, 'Uncharacterized protein', 112, NULL, NULL, 76451),
(76452, '1.10.287.70-FF-000142', NULL, 'Calcium channel subunit Cch1', 144, NULL, NULL, 76452),
(76453, '3.30.710.10-FF-000322', NULL, 'YALI0D10087p', 166, NULL, NULL, 76453),
(76454, '3.60.40.10-FF-000303', NULL, 'Protein RTF1-like protein', 69, NULL, NULL, 76454),
(76455, '3.30.60.30-FF-000210', NULL, 'Uncharacterized protein', 72, NULL, NULL, 76455),
(76456, '3.40.50.970-FF-000186', NULL, 'Predicted protein', 82, NULL, NULL, 76456),
(76457, '1.10.418.10-FF-000076', NULL, 'Coiled-coil domain containing 88B', 172, NULL, NULL, 76457),
(76458, '3.10.180.10-FF-000083', NULL, 'Uncharacterized 4-hydroxyphenylpyruvate dioxygenase-like protein', 265, NULL, NULL, 76458),
(76459, '1.10.760.10-FF-000096', NULL, 'Probable L-sorbosone dehydrogenase', 151, NULL, NULL, 76459),
(76460, '3.40.50.300-FF-001609', NULL, 'Cell division ATP-binding protein FtsE', 217, NULL, NULL, 76460),
(76461, '3.30.230.10-FF-000419', NULL, 'Uncharacterized protein', 75, NULL, NULL, 76461);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(76462, '1.50.10.130-FF-000027', NULL, NULL, 113, NULL, NULL, 76462),
(76463, '3.30.160.60-FF-004599', NULL, NULL, 61, NULL, NULL, 76463),
(76464, '3.90.190.20-FF-000057', NULL, 'Mur ligase', 139, NULL, NULL, 76464),
(76465, '3.30.70.60-FF-000017', NULL, '30S ribosomal protein S6', 116, NULL, NULL, 76465),
(76466, '3.80.10.10-FF-002436', NULL, 'F-box/LRR-repeat protein 4', 152, NULL, NULL, 76466),
(76467, '3.30.70.330-FF-002732', NULL, NULL, 97, NULL, NULL, 76467),
(76468, '2.30.30.100-FF-000203', NULL, 'Predicted protein', 94, NULL, NULL, 76468),
(76469, '3.40.50.150-FF-001429', NULL, NULL, 151, NULL, NULL, 76469),
(76470, '3.50.4.10-FF-000053', NULL, NULL, 80, NULL, NULL, 76470),
(76471, '3.40.50.720-FF-000662', NULL, 'GDP-mannose 3'',5''-epimerase', 179, NULL, NULL, 76471),
(76472, '1.25.40.10-FF-005026', NULL, 'AGAP000136-PA', 167, NULL, NULL, 76472),
(76473, '3.30.365.10-FF-000007', NULL, 'Carbon monoxide dehydrogenase large chain', 212, NULL, NULL, 76473),
(76474, '1.20.120.1380-FF-000006', NULL, 'Flagellar biosynthesis protein FlhF (Flagella-associated GTP-binding protein)', 53, NULL, NULL, 76474),
(76475, '1.10.390.10-FF-000022', NULL, 'Transcription initiation factor TFIID subunit', 216, NULL, NULL, 76475),
(76476, '3.40.50.11660-FF-000002', NULL, 'Alpha-(1,3)-fucosyltransferase', 211, NULL, NULL, 76476),
(76477, '3.30.160.60-FF-001373', NULL, 'Zinc finger protein 135', 26, NULL, NULL, 76477),
(76478, '2.40.50.140-FF-000503', NULL, 'Polyribonucleotide nucleotidyltransferase', 74, NULL, NULL, 76478),
(76479, '2.30.29.30-FF-000056', NULL, 'Serine/threonine-protein kinase', 123, NULL, NULL, 76479),
(76480, '3.90.190.10-FF-000054', NULL, 'laforin isoform X1', 193, NULL, NULL, 76480),
(76481, '3.40.1690.20-FF-000010', NULL, 'AFG3-like protein spg-7', 93, NULL, NULL, 76481),
(76482, '1.20.5.170-FF-000020', NULL, 'BZIP transcription factor', 52, NULL, NULL, 76482),
(76483, '1.20.5.1300-FF-000014', NULL, 'Histidinol dehydrogenase', 36, NULL, NULL, 76483),
(76484, '2.60.40.10-FF-000788', NULL, 'Cell adhesion molecule-related/down-regulated by oncogenes', 107, NULL, NULL, 76484),
(76485, '1.10.1040.10-FF-000040', NULL, '6-phosphogluconate dehydrogenase, decarboxylating', 275, NULL, NULL, 76485),
(76486, '2.170.300.10-FF-000008', NULL, 'Laminin subunit alpha 2', 82, NULL, NULL, 76486),
(76487, '3.90.1150.10-FF-000365', NULL, 'Uncharacterized protein', 170, NULL, NULL, 76487),
(76488, '1.20.940.10-FF-000023', NULL, 'Protein transport protein Sec31A', 102, NULL, NULL, 76488),
(76489, '2.60.120.260-FF-000536', NULL, 'Netrin 4', 84, NULL, NULL, 76489),
(76490, '2.60.40.650-FF-000020', NULL, 'Uncharacterized protein', 132, NULL, NULL, 76490),
(76491, '2.60.210.10-FF-000067', NULL, NULL, 115, NULL, NULL, 76491),
(76492, '3.40.50.620-FF-000632', NULL, 'Cysteine--tRNA ligase', 325, NULL, NULL, 76492),
(76493, '2.40.420.20-FF-000040', NULL, 'Multidrug efflux RND transporter periplasmic adaptor subunit MexX', 91, NULL, NULL, 76493),
(76494, '2.60.40.1930-FF-000014', NULL, 'Alpha-2-macroglobulin', 97, NULL, NULL, 76494),
(76495, '2.40.50.120-FF-000025', NULL, 'Netrin unc-6', 131, NULL, NULL, 76495),
(76496, '1.20.58.2010-FF-000008', NULL, 'Rop guanine nucleotide exchange factor 9', 145, NULL, NULL, 76496),
(76497, '3.40.50.1820-FF-000193', NULL, 'Ab-hydrolase associated lipase', 405, NULL, NULL, 76497),
(76498, '3.40.50.300-FF-001256', NULL, 'Pentafunctional AROM polypeptide', 179, NULL, NULL, 76498),
(76499, '1.50.10.10-FF-000109', NULL, 'Uncharacterized protein', 219, NULL, NULL, 76499),
(76500, '3.40.50.300-FF-007242', NULL, 'DNA topology modulation kinase FlaR, putative', 160, NULL, NULL, 76500),
(76501, '3.40.50.1820-FF-000513', NULL, 'Palmitoyl protein thioesterase family protein', 286, NULL, NULL, 76501),
(76502, '3.30.870.10-FF-000069', NULL, 'Cardiolipin synthase', 105, NULL, NULL, 76502),
(76503, '1.10.3380.20-FF-000001', NULL, 'DNA polymerase theta', 184, NULL, NULL, 76503),
(76504, '1.25.40.10-FF-000973', NULL, 'Anaphase-promoting complex subunit 3 protein', 170, NULL, NULL, 76504),
(76505, '2.30.40.10-FF-000060', NULL, 'Cytosine deaminase', 76, NULL, NULL, 76505);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(76506, '1.20.1250.20-FF-001883', NULL, 'Uncharacterized protein', 94, NULL, NULL, 76506),
(76507, '2.130.10.10-FF-003346', NULL, 'Uncharacterized protein', 110, NULL, NULL, 76507),
(76508, '3.40.50.1400-FF-000005', NULL, 'Ferrochelatase', 144, NULL, NULL, 76508),
(76509, '3.40.50.620-FF-000132', NULL, 'Cytoplasmic tRNA 2-thiolation protein 1', 323, NULL, NULL, 76509),
(76510, '2.30.29.30-FF-000117', NULL, 'ras-specific guanine nucleotide-releasing factor 1 isoform X2', 177, NULL, NULL, 76510),
(76511, '3.30.70.2510-FF-000009', NULL, NULL, 47, NULL, NULL, 76511),
(76512, '3.30.70.330-FF-002086', NULL, NULL, 75, NULL, NULL, 76512),
(76513, '2.60.40.10-FF-002879', NULL, 'Dorsal-related immunity factor, isoform D', 121, NULL, NULL, 76513),
(76514, '3.40.50.150-FF-001222', NULL, 'Methyltransferase', 266, NULL, NULL, 76514),
(76515, '3.80.10.10-FF-004061', NULL, 'AGAP005961-PA', 133, NULL, NULL, 76515),
(76516, '1.20.1050.10-FF-000145', NULL, 'Amino acyl-tRNA synthetase complex component, putative', 124, NULL, NULL, 76516),
(76517, '2.40.50.40-FF-000052', NULL, 'Uncharacterized protein', 64, NULL, NULL, 76517),
(76518, '3.30.40.10-FF-000580', NULL, 'DNA repair protein RAD5', 65, NULL, NULL, 76518),
(76519, '1.10.3380.30-FF-000004', NULL, 'Superkiller viralicidic activity 2-like 2', 65, NULL, NULL, 76519),
(76520, '3.60.10.10-FF-000155', NULL, 'DNA-(apurinic or apyrimidinic site) lyase', 105, NULL, NULL, 76520),
(76521, '2.60.120.10-FF-000122', NULL, 'Neuropathy target esterase sws', 130, NULL, NULL, 76521),
(76522, '3.40.50.10190-FF-000112', NULL, 'DNA polymerase II complex', 106, NULL, NULL, 76522),
(76523, '3.30.200.20-FF-000393', NULL, 'Non-specific serine/threonine protein kinase', 121, NULL, NULL, 76523),
(76524, '3.90.1070.10-FF-000005', NULL, 'Glycosyltransferase', 87, NULL, NULL, 76524),
(76525, '3.40.50.1820-FF-001295', NULL, 'Uncharacterized protein', 278, NULL, NULL, 76525),
(76526, '2.130.10.10-FF-000766', NULL, 'Cleavage and polyadenylation specificity factor cpsf', 408, NULL, NULL, 76526),
(76527, '2.60.40.790-FF-000096', NULL, 'Heat shock protein 20', 145, NULL, NULL, 76527),
(76528, '3.40.50.300-FF-001935', NULL, 'Cytosolic Fe-S cluster assembly factor NBP35', 247, NULL, NULL, 76528),
(76529, '2.60.40.60-FF-000663', NULL, 'Cadherin 17', 103, NULL, NULL, 76529),
(76530, '3.80.10.10-FF-000345', NULL, 'PH domain and leucine rich repeat protein phosphatase 1', 223, NULL, NULL, 76530),
(76531, '1.10.8.60-FF-000361', NULL, 'Proteasome-activating nucleotidase', 72, NULL, NULL, 76531),
(76532, '3.30.2290.10-FF-000024', NULL, 'Zinc-dependent protease, TldD/PmbA family', 209, NULL, NULL, 76532),
(76533, '2.70.170.10-FF-000308', NULL, 'Uncharacterized protein', 80, NULL, NULL, 76533),
(76534, '2.10.25.10-FF-001464', NULL, 'Uncharacterized protein', 40, NULL, NULL, 76534),
(76535, '1.20.1070.10-FF-001989', NULL, 'Uncharacterized protein', 157, NULL, NULL, 76535),
(76536, '3.30.1370.10-FF-000058', NULL, 'poly(RC)-binding protein 4 isoform X1', 72, NULL, NULL, 76536),
(76537, '1.20.58.60-FF-000735', NULL, 'Predicted protein', 103, NULL, NULL, 76537),
(76538, '3.40.1280.10-FF-000072', NULL, 'Uncharacterized protein', 206, NULL, NULL, 76538),
(76539, '1.10.405.20-FF-000015', NULL, NULL, 23, NULL, NULL, 76539),
(76540, '2.60.40.1210-FF-000006', NULL, 'Uncharacterized protein', 117, NULL, NULL, 76540),
(76541, '3.30.160.60-FF-004919', NULL, NULL, 29, NULL, NULL, 76541),
(76542, '2.10.70.10-FF-000051', NULL, 'von Willebrand factor C and EGF domain-containing protein', 34, NULL, NULL, 76542),
(76543, '3.30.200.20-FF-002484', NULL, 'Uncharacterized protein', 32, NULL, NULL, 76543),
(76544, '3.90.650.10-FF-000073', NULL, 'Uncharacterized protein', 65, NULL, NULL, 76544),
(76545, '3.30.420.60-FF-000011', NULL, 'Eukaryotic polypeptide chain release factor 1', 139, NULL, NULL, 76545),
(76546, '2.130.10.10-FF-002857', NULL, 'Pre-mRNA-processing factor 19', 323, NULL, NULL, 76546),
(76547, '1.10.10.60-FF-000694', NULL, 'Transcription factor MYB10', 53, NULL, NULL, 76547),
(76548, '3.40.50.2300-FF-000264', NULL, 'Glutamate receptor', 126, NULL, NULL, 76548);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(76549, '2.60.40.10-FF-005313', NULL, NULL, 79, NULL, NULL, 76549),
(76550, '3.30.420.10-FF-000075', NULL, 'Transposase, IS30 family', 147, NULL, NULL, 76550),
(76551, '3.30.559.10-FF-000014', NULL, 'Tryptamine hydroxycinnamoyl transferase', 208, NULL, NULL, 76551),
(76552, '2.170.8.10-FF-000012', NULL, 'Predicted protein', 109, NULL, NULL, 76552),
(76553, '3.40.50.11500-FF-000033', NULL, NULL, 181, NULL, NULL, 76553),
(76554, '3.30.450.20-FF-000259', NULL, 'Phytochrome-like protein', 31, NULL, NULL, 76554),
(76555, '1.20.58.60-FF-000056', NULL, 'utrophin isoform X1', 131, NULL, NULL, 76555),
(76556, '3.30.420.40-FF-000617', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', 61, NULL, NULL, 76556),
(76557, '3.40.50.1440-FF-000169', NULL, 'Tubulin alpha chain', 77, NULL, NULL, 76557),
(76558, '3.40.50.10140-FF-000030', NULL, 'Toll-like receptor 5b', 129, NULL, NULL, 76558),
(76559, '1.20.910.10-FF-000021', NULL, 'Biliverdin-producing heme oxygenase', 212, NULL, NULL, 76559),
(76560, '3.30.70.330-FF-000495', NULL, 'Putative G-patch DNA repair protein (Drt111)', 102, NULL, NULL, 76560),
(76561, '1.25.40.10-FF-004981', NULL, 'Uncharacterized protein', 144, NULL, NULL, 76561),
(76562, '3.30.200.20-FF-001410', NULL, 'Uncharacterized protein', 89, NULL, NULL, 76562),
(76563, '1.10.287.70-FF-000316', NULL, 'FI03418p', 173, NULL, NULL, 76563),
(76564, '2.40.50.140-FF-000357', NULL, 'Primosomal replication protein N', 100, NULL, NULL, 76564),
(76565, '2.10.25.10-FF-000362', NULL, 'Pro-epidermal growth factor', 47, NULL, NULL, 76565),
(76566, '2.40.50.140-FF-000649', NULL, 'Uncharacterized protein', 180, NULL, NULL, 76566),
(76567, '3.30.160.60-FF-004892', NULL, NULL, 26, NULL, NULL, 76567),
(76568, '3.40.50.300-FF-000300', NULL, 'Transcription-repair-coupling factor', 214, NULL, NULL, 76568),
(76569, '3.30.70.330-FF-000787', NULL, 'Serine/arginine-rich splicing factor 8', 142, NULL, NULL, 76569),
(76570, '1.10.10.60-FF-000755', NULL, 'Transcription factor MYB36', 68, NULL, NULL, 76570),
(76571, '3.40.50.410-FF-000215', NULL, 'Collagen, type VI, alpha 4a', 187, NULL, NULL, 76571),
(76572, '2.60.40.10-FF-005252', NULL, NULL, 88, NULL, NULL, 76572),
(76573, '2.120.10.80-FF-000349', NULL, 'Predicted protein', 80, NULL, NULL, 76573),
(76574, '3.40.50.2000-FF-000264', NULL, 'Lipopolysaccharide heptosyltransferase II', 180, NULL, NULL, 76574),
(76575, '3.30.200.20-FF-002158', NULL, 'Uncharacterized protein', 66, NULL, NULL, 76575),
(76576, '3.30.160.20-FF-000220', NULL, 'Predicted protein', 65, NULL, NULL, 76576),
(76577, '3.40.50.300-FF-001582', NULL, 'GTP-binding protein BRASSINAZOLE INSENSITIVE PALE GREEN 2, chloroplastic', 181, NULL, NULL, 76577),
(76578, '3.10.50.10-FF-000036', NULL, 'Chitinase', 66, NULL, NULL, 76578),
(76579, '3.30.160.60-FF-003610', NULL, 'Zinc finger protein 277', 115, NULL, NULL, 76579),
(76580, '2.30.30.100-FF-000175', NULL, 'Small nuclear ribonucleoprotein E', 85, NULL, NULL, 76580),
(76581, '3.80.10.10-FF-003925', NULL, 'AGAP012123-PA', 98, NULL, NULL, 76581),
(76582, '3.30.70.1230-FF-000030', NULL, 'Si:ch211-215j19.12', 188, NULL, NULL, 76582),
(76583, '1.20.58.60-FF-000382', NULL, 'Nesprin-1', 208, NULL, NULL, 76583),
(76584, '3.30.420.10-FF-000103', NULL, 'piRNA biogenesis protein EXD1', 283, NULL, NULL, 76584),
(76585, '2.40.50.90-FF-000134', NULL, 'Transcription factor, putative', 155, NULL, NULL, 76585),
(76586, '1.10.8.1220-FF-000032', NULL, NULL, 45, NULL, NULL, 76586),
(76587, '1.10.4020.10-FF-000005', NULL, 'Uncharacterized protein', 96, NULL, NULL, 76587),
(76588, '2.10.25.10-FF-000654', NULL, 'Neurexin 1, isoform F', 54, NULL, NULL, 76588),
(76589, '3.40.50.300-FF-005325', NULL, 'tRNA threonylcarbamoyladenosine biosynthesis protein TsaE', 152, NULL, NULL, 76589),
(76590, '3.40.1800.20-FF-000008', NULL, 'AGAP003961-PA', 75, NULL, NULL, 76590),
(76591, '3.30.70.330-FF-001597', NULL, NULL, 96, NULL, NULL, 76591),
(76592, '2.30.29.30-FF-000443', NULL, 'Sprouty related EVH1 domain containing 3', 80, NULL, NULL, 76592),
(76593, '3.40.50.1110-FF-000160', NULL, 'Uncharacterized protein', 99, NULL, NULL, 76593);
INSERT INTO "PUBLIC"."MODEL" VALUES
(76594, '3.40.710.10-FF-000005', NULL, 'Glutaminase', 307, NULL, NULL, 76594),
(76595, '3.30.720.50-FF-000019', NULL, NULL, 78, NULL, NULL, 76595),
(76596, '1.25.50.20-FF-000010', NULL, 'Aminopeptidase', 313, NULL, NULL, 76596),
(76597, '1.25.10.10-FF-001281', NULL, 'RING-type E3 ubiquitin transferase', 111, NULL, NULL, 76597),
(76598, '2.40.30.10-FF-000446', NULL, 'Uncharacterized protein', 84, NULL, NULL, 76598),
(76599, '1.10.630.10-FF-000530', NULL, 'Putative cytochrome P450 superfamily protein', 383, NULL, NULL, 76599),
(76600, '3.40.50.620-FF-000278', NULL, '(6-4)DNA photolyase', 131, NULL, NULL, 76600),
(76601, '3.30.50.10-FF-000198', NULL, 'Putative GATA transcription factor family protein', 53, NULL, NULL, 76601),
(76602, '3.40.140.10-FF-000068', NULL, 'tRNA-specific adenosine deaminase', 155, NULL, NULL, 76602),
(76603, '1.20.1070.10-FF-001782', NULL, 'Uncharacterized protein', 327, NULL, NULL, 76603),
(76604, '1.20.120.1080-FF-000006', NULL, 'ATP-dependent RNA helicase A protein', 111, NULL, NULL, 76604),
(76605, '2.60.40.60-FF-000955', NULL, 'Predicted protein', 102, NULL, NULL, 76605),
(76606, '1.10.3210.10-FF-000099', NULL, 'GTP diphosphokinase', 168, NULL, NULL, 76606),
(76607, '3.30.9.10-FF-000136', NULL, 'Lethal (2) 37Bb', 162, NULL, NULL, 76607),
(76608, '1.10.287.130-FF-000161', NULL, 'Histidine kinase A domain protein', 64, NULL, NULL, 76608),
(76609, '2.30.180.10-FF-000020', NULL, 'Stabilin 2', 136, NULL, NULL, 76609),
(76610, '2.60.120.590-FF-000051', NULL, 'Uncharacterized protein', 78, NULL, NULL, 76610),
(76611, '1.10.600.10-FF-000056', NULL, 'Putative phytoene synthase', 243, NULL, NULL, 76611),
(76612, '2.60.120.290-FF-000112', NULL, 'AGAP011912-PA', 107, NULL, NULL, 76612),
(76613, '1.10.1520.10-FF-000116', NULL, 'Ribonuclease III, putative', 123, NULL, NULL, 76613),
(76614, '3.30.70.330-FF-001012', NULL, 'RNA splicing factor (Pad-1)', 128, NULL, NULL, 76614),
(76615, '3.30.160.60-FF-003464', NULL, NULL, 26, NULL, NULL, 76615),
(76616, '3.30.200.20-FF-000893', NULL, 'Choline kinase', 65, NULL, NULL, 76616),
(76617, '3.40.47.10-FF-000151', NULL, 'Beta-ketoacyl synthase PigJ', 431, NULL, NULL, 76617),
(76618, '2.40.10.190-FF-000010', NULL, 'Selenocysteine-specific elongation factor', 78, NULL, NULL, 76618),
(76619, '3.75.10.10-FF-000009', NULL, 'Eukaryotic translation initiation factor 6', 40, NULL, NULL, 76619),
(76620, '3.30.230.10-FF-000392', NULL, 'Uncharacterized protein', 88, NULL, NULL, 76620),
(76621, '3.90.180.10-FF-000109', NULL, 'Acryloyl-coenzyme A reductase', 332, NULL, NULL, 76621),
(76622, '1.10.1740.140-FF-000004', NULL, NULL, 96, NULL, NULL, 76622),
(76623, '3.30.910.20-FF-000014', NULL, 'Outer membrane chaperone Skp (OmpH)', 129, NULL, NULL, 76623),
(76624, '4.10.40.20-FF-000002', NULL, 'Endothelial cell-specific molecule 1', 78, NULL, NULL, 76624),
(76625, '3.90.25.10-FF-000019', NULL, 'UDP-glucose 4-epimerase galE1', 100, NULL, NULL, 76625),
(76626, '1.25.40.10-FF-000647', NULL, 'Pentatricopeptide repeat-containing protein At4g33990', 103, NULL, NULL, 76626),
(76627, '3.40.50.1220-FF-000075', NULL, 'Related to NAD-dependent histone deacetylase', 65, NULL, NULL, 76627),
(76628, '3.30.70.1050-FF-000009', NULL, 'Trigger factor', 116, NULL, NULL, 76628),
(76629, '1.25.40.10-FF-003109', NULL, 'Putative pentatricopeptide repeat-containing protein', 114, NULL, NULL, 76629),
(76630, '3.40.190.10-FF-000751', NULL, 'Predicted protein', 202, NULL, NULL, 76630),
(76631, '3.30.479.20-FF-000050', NULL, 'Elongation factor Ts, mitochondrial', 52, NULL, NULL, 76631),
(76632, '2.60.200.30-FF-000016', NULL, 'Inorganic polyphosphate/ATP-NAD kinase', 125, NULL, NULL, 76632),
(76633, '1.20.1070.10-FF-000062', NULL, 'Neuropeptide Y receptor type 1', 354, NULL, NULL, 76633),
(76634, '1.10.8.10-FF-000161', NULL, 'AGAP004245-PA', 44, NULL, NULL, 76634),
(76635, '3.40.50.2300-FF-000590', NULL, 'Sucrose operon repressor ScrR LacI family', 123, NULL, NULL, 76635),
(76636, '3.30.70.370-FF-000041', NULL, NULL, 34, NULL, NULL, 76636),
(76637, '3.30.420.40-FF-000590', NULL, 'Uncharacterized protein', 42, NULL, NULL, 76637);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(76638, '3.40.50.300-FF-004662', NULL, 'Pentamidine resistance protein 1', 226, NULL, NULL, 76638),
(76639, '2.40.30.110-FF-000007', NULL, 'Aminomethyltransferase', 83, NULL, NULL, 76639),
(76640, '2.60.40.420-FF-000210', NULL, 'Uncharacterized protein', 254, NULL, NULL, 76640),
(76641, '3.30.420.40-FF-000882', NULL, 'Predicted protein', 38, NULL, NULL, 76641),
(76642, '1.25.40.180-FF-000047', NULL, 'Nonsense-mediated mRNA decay factor (Upf2)', 339, NULL, NULL, 76642),
(76643, '1.20.1070.10-FF-000680', NULL, 'Predicted protein', 344, NULL, NULL, 76643),
(76644, '3.20.19.10-FF-000002', NULL, 'Aconitate hydratase, mitochondrial', 220, NULL, NULL, 76644),
(76645, '3.40.309.10-FF-000123', NULL, 'tRNA (Uracil-5-)-methyltransferase', 205, NULL, NULL, 76645),
(76646, '2.60.120.650-FF-000237', NULL, 'Uncharacterized protein', 109, NULL, NULL, 76646),
(76647, '1.25.40.10-FF-004655', NULL, 'Anaphase-promoting complex subunit 6', 119, NULL, NULL, 76647),
(76648, '3.40.50.300-FF-006786', NULL, 'Predicted protein', 58, NULL, NULL, 76648),
(76649, '3.30.70.3370-FF-000003', NULL, 'Glutathione S-transferase family protein', 53, NULL, NULL, 76649),
(76650, '1.20.1250.20-FF-002254', NULL, 'Uncharacterized protein', 107, NULL, NULL, 76650),
(76651, '2.10.50.30-FF-000027', NULL, 'Uncharacterized protein', 41, NULL, NULL, 76651),
(76652, '1.25.40.10-FF-004363', NULL, 'Uncharacterized protein', 153, NULL, NULL, 76652),
(76653, '1.10.486.10-FF-000008', NULL, 'DNA helicase', 175, NULL, NULL, 76653),
(76654, '3.30.40.10-FF-002171', NULL, 'Ubiquitinyl hydrolase 1', 83, NULL, NULL, 76654),
(76655, '3.20.20.100-FF-000183', NULL, 'Uncharacterized protein', 125, NULL, NULL, 76655),
(76656, '3.40.50.300-FF-002863', NULL, 'Pre-mRNA-splicing factor cwf11', 196, NULL, NULL, 76656),
(76657, '2.60.200.40-FF-000019', NULL, 'Diacylglycerol kinase', 168, NULL, NULL, 76657),
(76658, '1.20.920.10-FF-000140', NULL, 'Predicted bromodomain protein', 107, NULL, NULL, 76658),
(76659, '3.30.70.1450-FF-000039', NULL, 'Probable sodium/sulfate cotransporter 3', 77, NULL, NULL, 76659),
(76660, '3.40.50.300-FF-001435', NULL, 'NACHT, LRR and PYD domains-containing protein 2', 231, NULL, NULL, 76660),
(76661, '1.10.20.140-FF-000007', NULL, 'tRNA dimethylallyltransferase 9', 72, NULL, NULL, 76661),
(76662, '1.20.120.1780-FF-000003', NULL, '4-hydroxybenzoate polyprenyl transferase', 125, NULL, NULL, 76662),
(76663, '1.25.10.10-FF-000999', NULL, 'Sister chromatid cohesion protein', 206, NULL, NULL, 76663),
(76664, '3.40.50.2000-FF-000910', NULL, 'Glycosyltransferase', 164, NULL, NULL, 76664),
(76665, '3.40.366.10-FF-000007', NULL, 'Fatty acid synthase beta subunit dehydratase', 227, NULL, NULL, 76665),
(76666, '3.30.420.280-FF-000003', NULL, 'Terminase, large subunit gp2', 186, NULL, NULL, 76666),
(76667, '3.30.70.260-FF-000007', NULL, 'D-3-phosphoglycerate dehydrogenase', 83, NULL, NULL, 76667),
(76668, '3.30.160.60-FF-001665', NULL, 'Uncharacterized protein', 29, NULL, NULL, 76668),
(76669, '3.30.710.10-FF-000176', NULL, 'Protein CBG09661', 143, NULL, NULL, 76669),
(76670, '3.90.190.10-FF-000346', NULL, 'Protein-tyrosine phosphatase', 161, NULL, NULL, 76670),
(76671, '3.30.40.10-FF-000607', NULL, 'Uncharacterized protein, isoform B', 75, NULL, NULL, 76671),
(76672, '3.40.250.10-FF-000104', NULL, 'Rodhanase family domain containing protein', 164, NULL, NULL, 76672),
(76673, '2.10.25.10-FF-000036', NULL, 'Integrin beta', 129, NULL, NULL, 76673),
(76674, '2.20.100.10-FF-000091', NULL, 'Somatomedin B and thrombospondin type 1 domain containing', 50, NULL, NULL, 76674),
(76675, '3.30.70.330-FF-000169', NULL, 'protein alan shepard isoform X4', 97, NULL, NULL, 76675),
(76676, '3.30.160.60-FF-005055', NULL, NULL, 103, NULL, NULL, 76676),
(76677, '1.10.472.80-FF-000132', NULL, 'SD08625p', 119, NULL, NULL, 76677),
(76678, '3.50.50.80-FF-000010', NULL, NULL, 87, NULL, NULL, 76678),
(76679, '3.60.110.10-FF-000084', NULL, NULL, 170, NULL, NULL, 76679),
(76680, '2.60.220.50-FF-000057', NULL, 'Adhesion G protein-coupled receptor D1', 41, NULL, NULL, 76680);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(76681, '3.30.460.10-FF-000021', NULL, 'DNA polymerase beta', 123, NULL, NULL, 76681),
(76682, '3.30.70.660-FF-000004', NULL, 'tRNA pseudouridine synthase A', 137, NULL, NULL, 76682),
(76683, '3.80.10.10-FF-002262', NULL, 'Uncharacterized protein', 265, NULL, NULL, 76683),
(76684, '2.60.40.1180-FF-000188', NULL, 'Uncharacterized protein', 56, NULL, NULL, 76684),
(76685, '1.10.10.1760-FF-000014', NULL, 'Uncharacterized protein', 83, NULL, NULL, 76685),
(76686, '3.40.30.10-FF-001276', NULL, 'Protein disulfide isomerase, putative', 130, NULL, NULL, 76686),
(76687, '3.40.390.10-FF-000086', NULL, 'Disintegrin and metalloproteinase domain-containing protein unc-71', 208, NULL, NULL, 76687),
(76688, '1.20.1310.10-FF-000098', NULL, 'Ubiquitin ligase subunit CulD', 116, NULL, NULL, 76688),
(76689, '1.10.565.10-FF-000170', NULL, 'Nuclear receptor subfamily 2, group E, member 3', 178, NULL, NULL, 76689),
(76690, '3.30.70.330-FF-002440', NULL, NULL, 87, NULL, NULL, 76690),
(76691, '1.10.630.10-FF-000119', NULL, 'Alkane hydroxylase MAH1', 480, NULL, NULL, 76691),
(76692, '3.30.40.10-FF-001889', NULL, 'Putative RING zinc finger domain superfamily protein', 74, NULL, NULL, 76692),
(76693, '1.20.1070.10-FF-000354', NULL, '5-hydroxytryptamine receptor 1A', 318, NULL, NULL, 76693),
(76694, '1.10.510.10-FF-003337', NULL, NULL, 51, NULL, NULL, 76694),
(76695, '2.60.200.20-FF-000098', NULL, 'Uncharacterized protein', 110, NULL, NULL, 76695),
(76696, '3.30.70.270-FF-000336', NULL, NULL, 28, NULL, NULL, 76696),
(76697, '1.20.58.60-FF-000409', NULL, 'SPeCtrin', 107, NULL, NULL, 76697),
(76698, '3.40.50.1820-FF-000367', NULL, 'Probable oxidoreductase EphD', 298, NULL, NULL, 76698),
(76699, '3.40.50.720-FF-001797', NULL, 'NmrA-like family domain-containing protein 1', 43, NULL, NULL, 76699),
(76700, '2.60.120.260-FF-000362', NULL, 'Uncharacterized protein', 198, NULL, NULL, 76700),
(76701, '3.90.70.10-FF-000652', NULL, 'Ubiquitin carboxylterminal hydrolase, putative', 85, NULL, NULL, 76701),
(76702, '3.30.230.10-FF-000066', NULL, 'Putative ATP-dependent protease', 166, NULL, NULL, 76702),
(76703, '1.20.1560.10-FF-000083', NULL, 'phosphatidylcholine translocator ABCB4 isoform X7', 23, NULL, NULL, 76703),
(76704, '2.30.42.10-FF-000575', NULL, NULL, 116, NULL, NULL, 76704),
(76705, '3.30.200.20-FF-000567', NULL, 'Serine/threonine-protein kinase MARK2', 92, NULL, NULL, 76705),
(76706, '3.80.10.10-FF-000671', NULL, 'Receptor-like protein kinase 5', 109, NULL, NULL, 76706),
(76707, '3.40.50.1370-FF-000041', NULL, 'Aspartate carbamoyltransferase, catalytic subunit', 163, NULL, NULL, 76707),
(76708, '1.10.532.10-FF-000010', NULL, 'Signal transducer and activator of transcription', 130, NULL, NULL, 76708),
(76709, '1.25.40.570-FF-000041', NULL, 'Uncharacterized protein', 106, NULL, NULL, 76709),
(76710, '3.40.50.2300-FF-000438', NULL, 'Putative sugar ABC transporter', 101, NULL, NULL, 76710),
(76711, '3.30.710.10-FF-000029', NULL, 'potassium voltage-gated channel subfamily S member 2', 119, NULL, NULL, 76711),
(76712, '3.40.50.300-FF-003173', NULL, 'Quinate repressor protein', 157, NULL, NULL, 76712),
(76713, '2.130.10.10-FF-001222', NULL, 'Transducin family protein', 286, NULL, NULL, 76713),
(76714, '1.25.40.10-FF-003261', NULL, 'Uncharacterized protein CaJ7.0066', 256, NULL, NULL, 76714),
(76715, '3.40.50.150-FF-001076', NULL, NULL, 238, NULL, NULL, 76715),
(76716, '1.25.40.90-FF-000098', NULL, 'CMGC family protein kinase', 119, NULL, NULL, 76716),
(76717, '3.40.50.300-FF-002071', NULL, 'Ras family GTPase, putative', 175, NULL, NULL, 76717),
(76718, '3.80.10.10-FF-001773', NULL, 'Uncharacterized protein', 259, NULL, NULL, 76718),
(76719, '2.10.25.10-FF-001756', NULL, 'Uncharacterized protein', 56, NULL, NULL, 76719),
(76720, '3.10.110.10-FF-000163', NULL, 'RBR-type E3 ubiquitin transferase', 83, NULL, NULL, 76720),
(76721, '2.60.410.10-FF-000015', NULL, NULL, 90, NULL, NULL, 76721),
(76722, '3.40.50.10810-FF-000219', NULL, 'Uncharacterized protein', 78, NULL, NULL, 76722),
(76723, '3.60.10.10-FF-000301', NULL, 'Uncharacterized protein', 323, NULL, NULL, 76723);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(76724, '2.170.40.20-FF-000005', NULL, 'Envelope glycoprotein gp160', 376, NULL, NULL, 76724),
(76725, '3.80.10.10-FF-004235', NULL, 'F-box/TPR repeat protein pof3', 262, NULL, NULL, 76725),
(76726, '1.20.1050.10-FF-000319', NULL, 'Eukaryotic translation elongation factor 1 gamma', 98, NULL, NULL, 76726),
(76727, '3.90.660.10-FF-000045', NULL, 'lysine-specific histone demethylase 1A', 155, NULL, NULL, 76727),
(76728, '3.30.160.60-FF-003790', NULL, NULL, 26, NULL, NULL, 76728),
(76729, '3.30.460.20-FF-000024', NULL, 'Magnesium and cobalt transport protein', 111, NULL, NULL, 76729),
(76730, '1.10.8.270-FF-000193', NULL, 'Uncharacterized protein', 83, NULL, NULL, 76730),
(76731, '3.80.10.10-FF-000053', NULL, 'Leucine-rich repeat-containing 8 VRAC subunit Ab', 244, NULL, NULL, 76731),
(76732, '1.10.10.10-FF-001336', NULL, 'Epithelium specific ets factor 3, ese3, putative', 126, NULL, NULL, 76732),
(76733, '3.90.180.10-FF-000082', NULL, 'Reticulon-4-interacting protein 1, mitochondrial', 149, NULL, NULL, 76733),
(76734, '1.25.40.10-FF-002772', NULL, 'Uncharacterized protein', 108, NULL, NULL, 76734),
(76735, '3.40.1190.20-FF-000163', NULL, 'Carbohydrate kinase PfkB family', 277, NULL, NULL, 76735),
(76736, '3.30.70.330-FF-001889', NULL, NULL, 89, NULL, NULL, 76736),
(76737, '3.40.30.10-FF-000966', NULL, 'Predicted protein', 98, NULL, NULL, 76737),
(76738, '3.30.1490.10-FF-000005', NULL, 'Mitochondrial 40S ribosomal protein S8', 68, NULL, NULL, 76738),
(76739, '3.40.50.720-FF-000336', NULL, 'Aldehyde reductase', 349, NULL, NULL, 76739),
(76740, '1.25.10.10-FF-000819', NULL, 'Inscuteable', 237, NULL, NULL, 76740),
(76741, '2.40.10.10-FF-000563', NULL, NULL, 69, NULL, NULL, 76741),
(76742, '3.90.640.10-FF-000162', NULL, 'Actin-related protein 8', 77, NULL, NULL, 76742),
(76743, '3.30.1520.10-FF-000060', NULL, 'Phox (PX) domain-containing protein', 137, NULL, NULL, 76743),
(76744, '2.130.10.10-FF-001429', NULL, 'Similar to DUF1339 domain protein', 243, NULL, NULL, 76744),
(76745, '2.80.10.50-FF-000230', NULL, 'Predicted protein', 130, NULL, NULL, 76745),
(76746, '2.60.40.720-FF-000002', NULL, 'Cellular tumor antigen p53', 205, NULL, NULL, 76746),
(76747, '3.30.565.10-FF-000309', NULL, 'PMS1 homolog 1, mismatch repair system component', 88, NULL, NULL, 76747),
(76748, '1.10.357.140-FF-000034', NULL, 'UbiA prenyltransferase', 168, NULL, NULL, 76748),
(76749, '3.30.200.20-FF-001056', NULL, 'CAMKK/ELM protein kinase', 59, NULL, NULL, 76749),
(76750, '2.60.120.330-FF-000113', NULL, '2-oxoglutarate (2OG) and Fe(II)-dependent oxygenase superfamily protein', 302, NULL, NULL, 76750),
(76751, '3.60.20.10-FF-000127', NULL, 'Glutamine amidotransferase', 256, NULL, NULL, 76751),
(76752, '3.30.1490.20-FF-000008', NULL, 'Synapsin I', 60, NULL, NULL, 76752),
(76753, '1.10.10.10-FF-000847', NULL, 'Regulatory protein RecX', 50, NULL, NULL, 76753),
(76754, '2.60.120.290-FF-000051', NULL, 'Uncharacterized protein, isoform A', 112, NULL, NULL, 76754),
(76755, '3.30.420.580-FF-000003', NULL, 'Actin-related protein 8', 71, NULL, NULL, 76755),
(76756, '3.30.160.60-FF-001401', NULL, 'zinc finger protein 527 isoform X1', 29, NULL, NULL, 76756),
(76757, '2.60.40.10-FF-003514', NULL, NULL, 87, NULL, NULL, 76757),
(76758, '3.40.50.300-FF-003352', NULL, 'HELicase Q homolog', 184, NULL, NULL, 76758),
(76759, '2.70.40.10-FF-000029', NULL, 'Uncharacterized protein', 133, NULL, NULL, 76759),
(76760, '1.25.40.10-FF-002238', NULL, 'Auxilin-like clathrin uncoating factor, putative', 140, NULL, NULL, 76760),
(76761, '1.10.12.70-FF-000009', NULL, NULL, 59, NULL, NULL, 76761),
(76762, '3.30.470.20-FF-000204', NULL, 'Uncharacterized protein', 59, NULL, NULL, 76762),
(76763, '1.20.1250.20-FF-000337', NULL, 'Solute carrier family 16 member 5', 406, NULL, NULL, 76763),
(76764, '1.10.630.10-FF-000412', NULL, 'Cytochrome P450 52E2', 478, NULL, NULL, 76764),
(76765, '1.10.238.10-FF-001321', NULL, 'Mitochondrial Rho GTPase', 136, NULL, NULL, 76765),
(76766, '2.10.25.10-FF-000536', NULL, 'von Willebrand factor D and EGF domain-containing protein', 30, NULL, NULL, 76766);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(76767, '2.90.10.10-FF-000038', NULL, 'Serine/threonine-protein kinase', 126, NULL, NULL, 76767),
(76768, '1.25.10.10-FF-001163', NULL, 'Hypothetical_protein_-_conserved', 246, NULL, NULL, 76768),
(76769, '2.30.29.30-FF-000090', NULL, 'RAS p21 protein activator 1', 123, NULL, NULL, 76769),
(76770, '3.80.10.10-FF-002470', NULL, 'Uncharacterized protein', 190, NULL, NULL, 76770),
(76771, '3.90.79.10-FF-000172', NULL, 'Nucleoside diphosphate-linked moiety X motif 6', 106, NULL, NULL, 76771),
(76772, '3.30.160.60-FF-001339', NULL, 'Zinc finger protein 232', 27, NULL, NULL, 76772),
(76773, '3.30.70.330-FF-000669', NULL, 'U2 snRNP auxiliary factor large subunit', 56, NULL, NULL, 76773),
(76774, '2.130.10.10-FF-005145', NULL, 'Vacuolar protein sorting-associated protein 41 homolog', 182, NULL, NULL, 76774),
(76775, '3.10.180.20-FF-000001', NULL, 'alpha-1,3-mannosyl-glycoprotein 2-beta-N-acetylglucosaminyltransferase', 80, NULL, NULL, 76775),
(76776, '1.10.10.10-FF-001044', NULL, 'ELL complex EAP30 subunit, putative', 78, NULL, NULL, 76776),
(76777, '3.30.420.40-FF-000589', NULL, 'Actin-like protein, putative', 54, NULL, NULL, 76777),
(76778, '3.30.360.20-FF-000022', NULL, NULL, 101, NULL, NULL, 76778),
(76779, '3.40.850.10-FF-000279', NULL, 'Uncharacterized protein', 117, NULL, NULL, 76779),
(76780, '2.160.10.30-FF-000001', NULL, 'UDP-sugar pyrophosphorylase', 121, NULL, NULL, 76780),
(76781, '3.40.50.150-FF-001840', NULL, NULL, 55, NULL, NULL, 76781),
(76782, '1.10.1020.10-FF-000005', NULL, 'Site-specific DNA-methyltransferase (adenine-specific)', 123, NULL, NULL, 76782),
(76783, '3.50.7.10-FF-000059', NULL, NULL, 72, NULL, NULL, 76783),
(76784, '1.10.441.10-FF-000012', NULL, 'Mannose-6-phosphate isomerase 1', 90, NULL, NULL, 76784),
(76785, '2.20.25.240-FF-000012', NULL, 'AGAP004541-PA', 75, NULL, NULL, 76785),
(76786, '3.30.160.60-FF-002975', NULL, NULL, 27, NULL, NULL, 76786),
(76787, '3.30.1360.30-FF-000007', NULL, 'Aspartyl-tRNA synthetase, mitochondrial, isoform A', 146, NULL, NULL, 76787),
(76788, '3.20.20.80-FF-000751', NULL, 'Uncharacterized protein', 56, NULL, NULL, 76788),
(76789, '1.20.120.720-FF-000049', NULL, 'Heavy chain, Unconventional Myosin', 136, NULL, NULL, 76789),
(76790, '3.20.20.80-FF-000280', NULL, 'Glycoside hydrolase family 5', 344, NULL, NULL, 76790),
(76791, '2.60.120.200-FF-000804', NULL, 'Os03g0772700 protein', 104, NULL, NULL, 76791),
(76792, '3.30.70.2460-FF-000005', NULL, NULL, 83, NULL, NULL, 76792),
(76793, '3.40.50.2000-FF-000146', NULL, 'Glycogen [starch] synthase', 98, NULL, NULL, 76793),
(76794, '1.10.1040.10-FF-000006', NULL, '3-hydroxyisobutyrate dehydrogenase', 133, NULL, NULL, 76794),
(76795, '3.30.300.30-FF-000049', NULL, 'Bifunctional enzyme mbtA: salicyl-AMP ligase + salicyl-S-ArCP synthetase', 100, NULL, NULL, 76795),
(76796, '3.30.160.60-FF-005201', NULL, NULL, 44, NULL, NULL, 76796),
(76797, '1.10.340.30-FF-000058', NULL, 'Endonuclease 3', 125, NULL, NULL, 76797),
(76798, '3.90.70.80-FF-000009', NULL, 'OTU domain-containing protein 3', 141, NULL, NULL, 76798),
(76799, '2.170.270.10-FF-000039', NULL, 'Histone-lysine N-methyltransferase SMYD3', 116, NULL, NULL, 76799),
(76800, '2.60.40.60-FF-000781', NULL, 'Uncharacterized protein', 100, NULL, NULL, 76800),
(76801, '2.30.230.10-FF-000047', NULL, 'Uncharacterized protein', 274, NULL, NULL, 76801),
(76802, '3.40.250.10-FF-000076', NULL, 'Ubiquitin-activating enzyme', 159, NULL, NULL, 76802),
(76803, '3.40.50.720-FF-000218', NULL, '2-hydroxy-3-oxopropionate reductase', 158, NULL, NULL, 76803),
(76804, '3.40.50.80-FF-000179', NULL, 'FAD-binding domain-domain-containing protein', 189, NULL, NULL, 76804),
(76805, '2.60.40.10-FF-003043', NULL, 'Uncharacterized protein', 135, NULL, NULL, 76805),
(76806, '3.30.40.10-FF-000641', NULL, 'RABaptiN (Rab effector)', 52, NULL, NULL, 76806),
(76807, '2.40.400.10-FF-000002', NULL, 'Acetoacetate decarboxylase', 228, NULL, NULL, 76807),
(76808, '3.30.450.20-FF-000052', NULL, 'Sigma-54 dependent transcriptional regulator', 108, NULL, NULL, 76808),
(76809, '3.40.50.300-FF-007096', NULL, 'Small GTP-binding protein, putative', 188, NULL, NULL, 76809);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(76810, '1.20.1560.10-FF-000144', NULL, 'ABC transporter ATP-binding protein', 299, NULL, NULL, 76810),
(76811, '1.10.510.10-FF-003371', NULL, NULL, 200, NULL, NULL, 76811),
(76812, '3.40.50.12780-FF-000029', NULL, 'Uncharacterized protein, isoform B', 432, NULL, NULL, 76812),
(76813, '2.40.50.140-FF-000475', NULL, 'ABC transporter ATP-binding protein', 61, NULL, NULL, 76813),
(76814, '3.40.50.620-FF-000486', NULL, 'Valyl-tRNA synthetase', 250, NULL, NULL, 76814),
(76815, '3.30.70.1350-FF-000009', NULL, 'Cation diffusion facilitator 1', 80, NULL, NULL, 76815),
(76816, '1.20.5.110-FF-000081', NULL, 'Syntaxin 16', 102, NULL, NULL, 76816),
(76817, '2.60.40.10-FF-002997', NULL, 'Tyrosine-protein kinase-like otk', 89, NULL, NULL, 76817),
(76818, '1.20.1270.60-FF-000210', NULL, 'arfaptin-2-like isoform X2', 203, NULL, NULL, 76818),
(76819, '3.40.50.1820-FF-000221', NULL, 'Group XV phospholipase A2', 200, NULL, NULL, 76819),
(76820, '3.40.50.720-FF-002461', NULL, 'Uncharacterized protein', 88, NULL, NULL, 76820),
(76821, '3.30.160.60-FF-000884', NULL, 'Zinc finger protein 507', 77, NULL, NULL, 76821),
(76822, '1.20.58.900-FF-000014', NULL, 'Run domain Beclin-1-interacting and cysteine-rich domain-containing protein', 169, NULL, NULL, 76822),
(76823, '3.30.1490.20-FF-000042', NULL, 'D-alanine--D-alanine ligase', 74, NULL, NULL, 76823),
(76824, '1.20.1070.10-FF-000236', NULL, 'G protein-coupled receptor 84', 328, NULL, NULL, 76824),
(76825, '2.130.10.130-FF-000049', NULL, NULL, 198, NULL, NULL, 76825),
(76826, '3.20.20.70-FF-000422', NULL, 'FMN-dependent 2-nitropropane dioxygenase', 351, NULL, NULL, 76826),
(76827, '3.40.1110.10-FF-000003', NULL, 'Calcium-transporting ATPase', 244, NULL, NULL, 76827),
(76828, '3.40.50.1460-FF-000034', NULL, 'Uncharacterized protein', 170, NULL, NULL, 76828),
(76829, '3.40.50.1240-FF-000199', NULL, NULL, 81, NULL, NULL, 76829),
(76830, '3.30.40.10-FF-002086', NULL, 'Predicted protein', 85, NULL, NULL, 76830),
(76831, '3.10.20.90-FF-000895', NULL, 'Cell polarity protein alp11', 80, NULL, NULL, 76831),
(76832, '3.10.260.20-FF-000002', NULL, 'SKI-like oncogene a', 105, NULL, NULL, 76832),
(76833, '3.40.640.10-FF-000533', NULL, 'Uncharacterized protein', 78, NULL, NULL, 76833),
(76834, '3.40.390.10-FF-000294', NULL, NULL, 77, NULL, NULL, 76834),
(76835, '1.10.3380.10-FF-000026', NULL, 'ATP-dependent DNA helicase HFM1/MER3', 145, NULL, NULL, 76835),
(76836, '2.60.120.260-FF-000036', NULL, 'Reelin', 152, NULL, NULL, 76836),
(76837, '3.40.50.300-FF-004869', NULL, 'RecBCD enzyme subunit RecC', 178, NULL, NULL, 76837),
(76838, '3.40.630.10-FF-000504', NULL, 'Glr2658 protein', 215, NULL, NULL, 76838),
(76839, '3.80.10.10-FF-004027', NULL, 'Uncharacterized protein', 145, NULL, NULL, 76839),
(76840, '1.10.1870.10-FF-000018', NULL, 'Predicted protein', 45, NULL, NULL, 76840),
(76841, '3.40.50.12760-FF-000023', NULL, 'Uncharacterized protein', 182, NULL, NULL, 76841),
(76842, '1.20.58.690-FF-000001', NULL, 'MIX protein, putative', 131, NULL, NULL, 76842),
(76843, '2.30.29.30-FF-000617', NULL, 'PH domain containing protein', 103, NULL, NULL, 76843),
(76844, '3.50.50.60-FF-000471', NULL, 'Probable malate:quinone oxidoreductase', 99, NULL, NULL, 76844),
(76845, '3.40.50.1820-FF-000693', NULL, 'EF-hand calcium-binding domain-containing protein', 229, NULL, NULL, 76845),
(76846, '3.30.450.60-FF-000013', NULL, 'Coatomer subunit zeta', 160, NULL, NULL, 76846),
(76847, '3.30.70.2450-FF-000002', NULL, '3-(3-hydroxyphenyl)propionate hydroxylase', 84, NULL, NULL, 76847),
(76848, '2.130.10.10-FF-005471', NULL, 'WD repeat domain 62', 158, NULL, NULL, 76848),
(76849, '1.25.40.10-FF-004481', NULL, 'Uncharacterized protein', 102, NULL, NULL, 76849),
(76850, '3.90.1150.10-FF-000186', NULL, 'Biogenic Amine Synthesis related', 94, NULL, NULL, 76850),
(76851, '3.40.50.720-FF-000370', NULL, 'Fatty acyl-CoA reductase', 343, NULL, NULL, 76851),
(76852, '3.40.109.10-FF-000057', NULL, 'PnbA', 216, NULL, NULL, 76852),
(76853, '1.10.1080.10-FF-000014', NULL, 'Glutathione synthetase', 92, NULL, NULL, 76853);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(76854, '3.40.50.300-FF-005443', NULL, 'Putative ABC transporter involved in multidrug resistance', 252, NULL, NULL, 76854),
(76855, '3.90.640.10-FF-000128', NULL, 'Brahma associated protein 55kD', 121, NULL, NULL, 76855),
(76856, '3.40.30.10-FF-000320', NULL, 'NHL repeat-containing protein 2', 165, NULL, NULL, 76856),
(76857, '3.30.450.50-FF-000010', NULL, 'vesicle-trafficking protein SEC22a isoform X2', 126, NULL, NULL, 76857),
(76858, '1.20.1560.10-FF-000728', NULL, 'p-glycoprotein 6, putative', 224, NULL, NULL, 76858),
(76859, '3.20.20.80-FF-000425', NULL, 'Predicted protein', 148, NULL, NULL, 76859),
(76860, '1.25.40.10-FF-000529', NULL, 'Pentatricopeptide repeat-containing protein', 101, NULL, NULL, 76860),
(76861, '3.40.50.1110-FF-000042', NULL, 'Rhamnogalacturonan acetylesterase RhgT', 223, NULL, NULL, 76861),
(76862, '1.20.58.760-FF-000045', NULL, 'Uncharacterized protein', 106, NULL, NULL, 76862),
(76863, '1.10.10.10-FF-000639', NULL, 'LysR family transcriptional regulator', 87, NULL, NULL, 76863),
(76864, '1.25.40.20-FF-001465', NULL, 'Uncharacterized protein', 112, NULL, NULL, 76864),
(76865, '3.40.50.300-FF-006871', NULL, 'Uncharacterized protein', 252, NULL, NULL, 76865),
(76866, '3.30.420.40-FF-000797', NULL, 'Heat shock 70 kDa protein, putative', 111, NULL, NULL, 76866),
(76867, '1.20.58.400-FF-000021', NULL, 'Vesicle transport v-SNARE protein N-terminus, putative', 115, NULL, NULL, 76867),
(76868, '1.10.510.10-FF-001538', NULL, 'Guanylate cyclase', 218, NULL, NULL, 76868),
(76869, '1.10.20.10-FF-000258', NULL, NULL, 92, NULL, NULL, 76869),
(76870, '3.10.20.770-FF-000003', NULL, 'phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit beta isoform', 308, NULL, NULL, 76870),
(76871, '2.10.25.10-FF-000328', NULL, 'Integrin beta', 45, NULL, NULL, 76871),
(76872, '3.40.1170.60-FF-000033', NULL, NULL, 18, NULL, NULL, 76872),
(76873, '3.40.30.10-FF-001129', NULL, 'Predicted protein', 77, NULL, NULL, 76873),
(76874, '3.40.50.1000-FF-000739', NULL, NULL, 51, NULL, NULL, 76874),
(76875, '3.30.450.20-FF-000467', NULL, 'Uncharacterized protein', 93, NULL, NULL, 76875),
(76876, '3.90.190.10-FF-000172', NULL, 'Dual specificity protein phosphatase, putative', 205, NULL, NULL, 76876),
(76877, '2.130.10.10-FF-002649', NULL, 'WD repeat and HMG-box DNA-binding protein 1-like Protein', 297, NULL, NULL, 76877),
(76878, '3.30.559.10-FF-000222', NULL, 'Uncharacterized protein', 180, NULL, NULL, 76878),
(76879, '3.40.1110.10-FF-000060', NULL, 'Calcium-transporting ATPase', 192, NULL, NULL, 76879),
(76880, '3.40.850.10-FF-000133', NULL, 'Putative kinesin', 360, NULL, NULL, 76880),
(76881, '3.30.565.10-FF-000399', NULL, 'Sensory transduction histidine kinase', 163, NULL, NULL, 76881),
(76882, '3.40.20.10-FF-000022', NULL, 'supervillin isoform X2', 126, NULL, NULL, 76882),
(76883, '1.25.40.10-FF-001344', NULL, 'SET (Trithorax/polycomb) domain containing', 70, NULL, NULL, 76883),
(76884, '2.60.40.420-FF-000064', NULL, 'Cytochrome c oxidase subunit 2, putative', 23, NULL, NULL, 76884),
(76885, '1.10.630.10-FF-000204', NULL, 'Uncharacterized protein', 338, NULL, NULL, 76885),
(76886, '1.20.1720.10-FF-000090', NULL, 'Bcr/CflA family efflux transporter', 376, NULL, NULL, 76886),
(76887, '1.10.150.50-FF-000061', NULL, 'Ets DNA-binding protein pokkuri', 79, NULL, NULL, 76887),
(76888, '1.25.40.20-FF-001347', NULL, 'Uncharacterized protein', 110, NULL, NULL, 76888),
(76889, '1.25.10.10-FF-002944', NULL, 'Integrator complex subunit 4-like Protein', 73, NULL, NULL, 76889),
(76890, '3.60.130.10-FF-000052', NULL, 'Gamma-butyrobetaine hydroxylase 1', 151, NULL, NULL, 76890),
(76891, '2.60.120.200-FF-000333', NULL, 'Laminin subunit alpha', 169, NULL, NULL, 76891),
(76892, '2.60.40.10-FF-005813', NULL, NULL, 65, NULL, NULL, 76892),
(76893, '3.40.50.410-FF-000007', NULL, 'Calcium voltage-gated channel auxiliary subunit alpha2delta 3', 182, NULL, NULL, 76893),
(76894, '3.30.1140.60-FF-000011', NULL, 'F-actin-capping protein subunit alpha', 106, NULL, NULL, 76894),
(76895, '3.40.50.2000-FF-000882', NULL, 'Glycosyl transferase, family 9', 185, NULL, NULL, 76895);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(76896, '1.10.4100.10-FF-000006', NULL, '2-methylcitrate dehydratase', 24, NULL, NULL, 76896),
(76897, '3.40.50.10240-FF-000003', NULL, 'Thiamine pyrophosphokinase', 223, NULL, NULL, 76897),
(76898, '2.60.40.10-FF-004942', NULL, NULL, 56, NULL, NULL, 76898),
(76899, '1.20.1250.20-FF-000601', NULL, 'YCR023C-like protein', 440, NULL, NULL, 76899),
(76900, '3.30.1490.480-FF-000003', NULL, 'Endolytic murein transglycosylase', 74, NULL, NULL, 76900),
(76901, '3.40.140.10-FF-000276', NULL, 'Uncharacterized protein', 71, NULL, NULL, 76901),
(76902, '1.10.238.10-FF-000539', NULL, 'Glycerol-3-phosphate dehydrogenase, mitochondrial', 89, NULL, NULL, 76902),
(76903, '2.130.10.30-FF-000098', NULL, 'E3 ubiquitin-protein ligase MYCBP2-like Protein', 221, NULL, NULL, 76903),
(76904, '3.40.50.1950-FF-000001', NULL, 'Flavin prenyltransferase UbiX', 185, NULL, NULL, 76904),
(76905, '1.20.58.60-FF-000174', NULL, 'Spectrin repeat-containing, nuclear envelope 2', 297, NULL, NULL, 76905),
(76906, '3.40.50.300-FF-003088', NULL, 'ADP-ribosylation factor, putative', 179, NULL, NULL, 76906),
(76907, '3.50.50.60-FF-000942', NULL, 'Uncharacterized protein', 109, NULL, NULL, 76907),
(76908, '3.30.590.50-FF-000020', NULL, 'Predicted protein', 84, NULL, NULL, 76908),
(76909, '1.20.1270.10-FF-000009', NULL, 'DnaK-type molecular chaperone BiP', 75, NULL, NULL, 76909),
(76910, '1.10.238.10-FF-000596', NULL, 'Defective in cullin neddylation protein', 93, NULL, NULL, 76910),
(76911, '1.10.1200.10-FF-000103', NULL, 'Nonribosomal peptide synthase, putative', 73, NULL, NULL, 76911),
(76912, '3.10.20.90-FF-000777', NULL, 'Uncharacterized protein', 102, NULL, NULL, 76912),
(76913, '3.30.70.330-FF-002614', NULL, NULL, 129, NULL, NULL, 76913),
(76914, '1.10.4160.10-FF-000015', NULL, 'Cytosine/purine/uracil/thiamine/allantoin permease family protein', 422, NULL, NULL, 76914),
(76915, '1.10.510.10-FF-003163', NULL, NULL, 169, NULL, NULL, 76915),
(76916, '3.60.15.10-FF-000059', NULL, 'N-acetylphosphatidylethanolamine-hydrolyzing phospholipase D', 287, NULL, NULL, 76916),
(76917, '2.40.50.140-FF-000683', NULL, NULL, 99, NULL, NULL, 76917),
(76918, '2.30.29.230-FF-000015', NULL, 'Tbc-16', 91, NULL, NULL, 76918),
(76919, '2.130.10.10-FF-002239', NULL, 'Quinoprotein amine dehydrogenase, beta chain-like RIC1-like guanyl-nucleotide exchange factor', 208, NULL, NULL, 76919),
(76920, '1.20.5.340-FF-000094', NULL, 'Myosin, heavy chain 11a, smooth muscle', 91, NULL, NULL, 76920),
(76921, '4.10.280.110-FF-000002', NULL, 'U4/U6 small nuclear ribonucleoprotein Prp4', 82, NULL, NULL, 76921),
(76922, '1.10.225.10-FF-000032', NULL, 'Uncharacterized protein', 45, NULL, NULL, 76922),
(76923, '3.40.50.1820-FF-001002', NULL, 'Carboxylesterase', 231, NULL, NULL, 76923),
(76924, '3.60.60.10-FF-000012', NULL, 'Dipeptidase', 308, NULL, NULL, 76924),
(76925, '1.10.1370.10-FF-000025', NULL, 'Uncharacterized protein', 180, NULL, NULL, 76925),
(76926, '3.40.50.2300-FF-000882', NULL, NULL, 203, NULL, NULL, 76926),
(76927, '3.30.450.20-FF-000260', NULL, 'Putative Sigma factor regulatory protein', 147, NULL, NULL, 76927),
(76928, '1.25.10.10-FF-002298', NULL, 'Apoptosis inhibitory protein 5 (API5)', 323, NULL, NULL, 76928),
(76929, '3.40.50.300-FF-005179', NULL, 'Ras-related protein Rab-23', 219, NULL, NULL, 76929),
(76930, '3.30.160.60-FF-003256', NULL, NULL, 30, NULL, NULL, 76930),
(76931, '3.30.1120.30-FF-000052', NULL, 'Uncharacterized protein', 52, NULL, NULL, 76931),
(76932, '1.25.40.90-FF-000126', NULL, 'Uncharacterized protein', 98, NULL, NULL, 76932),
(76933, '1.20.1050.10-FF-000027', NULL, 'Glutathione S-transferase', 107, NULL, NULL, 76933),
(76934, '1.10.287.130-FF-000043', NULL, 'Two-component sensor histidine kinase KdpD', 73, NULL, NULL, 76934),
(76935, '2.60.120.380-FF-000021', NULL, 'Transmembrane protein-related', 114, NULL, NULL, 76935),
(76936, '3.40.50.620-FF-000014', NULL, 'Universal stress protein', 141, NULL, NULL, 76936),
(76937, '3.40.50.1970-FF-000007', NULL, 'Pentafunctional AROM polypeptide', 174, NULL, NULL, 76937),
(76938, '1.20.1070.10-FF-000028', NULL, 'leucine-rich repeat-containing G-protein coupled receptor 4 isoform X1', 311, NULL, NULL, 76938);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(76939, '3.30.160.60-FF-001194', NULL, 'Zinc finger protein 770', 24, NULL, NULL, 76939),
(76940, '2.10.110.10-FF-000228', NULL, 'LIM homeobox 8', 80, NULL, NULL, 76940),
(76941, '3.30.160.60-FF-000676', NULL, 'C2H2 transcription factor (Sfp1)', 44, NULL, NULL, 76941),
(76942, '1.20.58.1120-FF-000022', NULL, 'DHC7 protein', 136, NULL, NULL, 76942),
(76943, '3.30.479.20-FF-000016', NULL, 'Elongation factor Ts', 73, NULL, NULL, 76943),
(76944, '1.50.10.20-FF-000146', NULL, 'Uncharacterized protein', 51, NULL, NULL, 76944),
(76945, '2.30.42.10-FF-000283', NULL, 'Uncharacterized protein, isoform E', 66, NULL, NULL, 76945),
(76946, '3.40.50.700-FF-000004', NULL, 'Methyl viologen-reducing hydrogenase, small subunit', 176, NULL, NULL, 76946),
(76947, '1.25.40.10-FF-003553', NULL, 'Uncharacterized protein', 270, NULL, NULL, 76947),
(76948, '3.30.200.20-FF-000713', NULL, 'Mitogen-activated protein kinase 1, putative, expressed', 103, NULL, NULL, 76948),
(76949, '3.30.160.60-FF-005408', NULL, NULL, 44, NULL, NULL, 76949),
(76950, '2.60.40.10-FF-001098', NULL, 'Titin novex-3', 88, NULL, NULL, 76950),
(76951, '1.20.58.60-FF-000117', NULL, 'A-kinase anchor protein 6', 115, NULL, NULL, 76951),
(76952, '3.40.50.10260-FF-000009', NULL, 'AGAP003131-PA', 253, NULL, NULL, 76952),
(76953, '1.20.1250.60-FF-000001', NULL, 'Interferon lambda 1', 151, NULL, NULL, 76953),
(76954, '3.90.550.10-FF-000655', NULL, 'Uncharacterized protein', 127, NULL, NULL, 76954),
(76955, '1.20.120.80-FF-000015', NULL, 'Cytochrome oxidase subunit III', 92, NULL, NULL, 76955),
(76956, '3.40.50.1980-FF-000128', NULL, 'ABC-type cobalamin/Fe3+ siderophore transport system, periplasmic component', 144, NULL, NULL, 76956),
(76957, '2.10.25.10-FF-000800', NULL, 'Crumbs, isoform D', 37, NULL, NULL, 76957),
(76958, '3.30.479.30-FF-000019', NULL, 'Possible exported conserved protein', 162, NULL, NULL, 76958),
(76959, '2.60.15.10-FF-000011', NULL, 'ATP synthase epsilon chain', 120, NULL, NULL, 76959),
(76960, '2.60.40.60-FF-001091', NULL, 'Uncharacterized protein', 107, NULL, NULL, 76960),
(76961, '1.25.40.10-FF-002946', NULL, 'Os12g0114400 protein', 157, NULL, NULL, 76961),
(76962, '2.20.110.10-FF-000063', NULL, NULL, 57, NULL, NULL, 76962),
(76963, '2.130.10.10-FF-004482', NULL, 'Uncharacterized protein', 144, NULL, NULL, 76963),
(76964, '3.40.367.20-FF-000035', NULL, 'Phosphotransferase', 106, NULL, NULL, 76964),
(76965, '2.160.20.10-FF-000288', NULL, 'Cell surface protein', 142, NULL, NULL, 76965),
(76966, '3.80.10.10-FF-000227', NULL, 'Immunoglobulin superfamily member 10', 100, NULL, NULL, 76966),
(76967, '3.40.50.620-FF-000750', NULL, 'Uncharacterized protein', 145, NULL, NULL, 76967),
(76968, '2.60.120.200-FF-000451', NULL, 'Uncharacterized protein', 183, NULL, NULL, 76968),
(76969, '2.10.109.10-FF-000045', NULL, 'Inner mitochondrial membrane peptidase subunit 2', 83, NULL, NULL, 76969),
(76970, '2.60.40.60-FF-001034', NULL, 'Uncharacterized protein', 115, NULL, NULL, 76970),
(76971, '3.40.50.300-FF-005651', NULL, 'Dynein-1-beta heavy chain, flagellar inner arm I1 complex', 215, NULL, NULL, 76971),
(76972, '2.40.290.30-FF-000009', NULL, 'Prostate tumor overexpressed gene 1, isoform CRA_d', 113, NULL, NULL, 76972),
(76973, '2.60.40.10-FF-004824', NULL, NULL, 111, NULL, NULL, 76973),
(76974, '1.20.1420.30-FF-000084', NULL, 'Uncharacterized protein', 126, NULL, NULL, 76974),
(76975, '3.30.930.10-FF-000041', NULL, 'Phenylalanyl-tRNA synthetase 2, mitochondrial', 308, NULL, NULL, 76975),
(76976, '3.30.479.10-FF-000013', NULL, '6-carboxy-5,6,7,8-tetrahydropterin synthase', 144, NULL, NULL, 76976),
(76977, '3.40.50.720-FF-000162', NULL, '2-dehydropantoate 2-reductase', 167, NULL, NULL, 76977),
(76978, '2.30.40.10-FF-000059', NULL, 'Adenine deaminase', 92, NULL, NULL, 76978),
(76979, '3.30.1490.70-FF-000001', NULL, 'DNA ligase', 73, NULL, NULL, 76979),
(76980, '3.30.2060.10-FF-000007', NULL, 'Putative penicillin-binding protein 1B', 90, NULL, NULL, 76980),
(76981, '3.40.50.300-FF-007803', NULL, 'Uncharacterized protein', 41, NULL, NULL, 76981);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(76982, '3.60.15.10-FF-000205', NULL, 'Predicted protein', 67, NULL, NULL, 76982),
(76983, '3.40.50.300-FF-000828', NULL, 'leucine-rich repeat and guanylate kinase domain-containing protein-like', 191, NULL, NULL, 76983),
(76984, '3.40.50.1970-FF-000064', NULL, NULL, 47, NULL, NULL, 76984),
(76985, '2.120.10.30-FF-000385', NULL, 'Uncharacterized protein', 309, NULL, NULL, 76985),
(76986, '3.40.1190.10-FF-000042', NULL, NULL, 240, NULL, NULL, 76986),
(76987, '3.30.420.40-FF-001045', NULL, 'Uncharacterized protein', 14, NULL, NULL, 76987),
(76988, '3.40.50.720-FF-002522', NULL, 'Uncharacterized protein', 106, NULL, NULL, 76988),
(76989, '1.20.1740.10-FF-000001', NULL, 'Amino acid permease', 452, NULL, NULL, 76989),
(76990, '1.10.472.10-FF-000656', NULL, 'Predicted protein', 98, NULL, NULL, 76990),
(76991, '1.10.555.10-FF-000107', NULL, 'Type II inositol-1,4,5-trisphosphate 5-phosphatase, putative', 143, NULL, NULL, 76991),
(76992, '3.40.1190.20-FF-000045', NULL, 'Ribokinase', 357, NULL, NULL, 76992),
(76993, '1.25.40.20-FF-001611', NULL, 'Uncharacterized protein', 105, NULL, NULL, 76993),
(76994, '2.70.160.11-FF-000051', NULL, 'Coactivator-associated arginine methyltransferase 1', 112, NULL, NULL, 76994),
(76995, '2.60.40.10-FF-002790', NULL, 'Uncharacterized protein', 105, NULL, NULL, 76995),
(76996, '3.30.50.10-FF-000018', NULL, 'GATA transcription factor', 83, NULL, NULL, 76996),
(76997, '3.40.50.1820-FF-001856', NULL, 'Uncharacterized protein', 55, NULL, NULL, 76997),
(76998, '3.50.30.30-FF-000011', NULL, 'E3 ubiquitin-protein ligase RNF130', 154, NULL, NULL, 76998),
(76999, '3.30.1240.10-FF-000021', NULL, 'HAD family phosphatase', 104, NULL, NULL, 76999),
(77000, '3.40.50.300-FF-003234', NULL, 'ABC transporter', 250, NULL, NULL, 77000),
(77001, '3.40.50.300-FF-007034', NULL, 'Uncharacterized protein', 202, NULL, NULL, 77001),
(77002, '3.30.70.1440-FF-000003', NULL, 'Multidrug resistance protein MdtB', 101, NULL, NULL, 77002),
(77003, '2.40.10.10-FF-000681', NULL, NULL, 70, NULL, NULL, 77003),
(77004, '2.70.150.10-FF-000189', NULL, 'Calcium-transporting ATPase', 114, NULL, NULL, 77004),
(77005, '3.40.50.880-FF-000159', NULL, '1,3-beta-galactosyl-N-acetylhexosamine phosphorylase Cphy0577', 227, NULL, NULL, 77005),
(77006, '3.30.70.330-FF-002406', NULL, NULL, 94, NULL, NULL, 77006),
(77007, '3.30.70.2750-FF-000002', NULL, 'V-type ATP synthase subunit I', 70, NULL, NULL, 77007),
(77008, '3.40.1160.10-FF-000006', NULL, 'Glutamate 5-kinase', 273, NULL, NULL, 77008),
(77009, '3.30.750.200-FF-000003', NULL, NULL, 52, NULL, NULL, 77009),
(77010, '3.30.2130.30-FF-000024', NULL, 'THUMP domain containing 2', 155, NULL, NULL, 77010),
(77011, '1.25.10.10-FF-002798', NULL, 'Uncharacterized protein', 124, NULL, NULL, 77011),
(77012, '1.20.1250.20-FF-001849', NULL, 'Uncharacterized protein', 132, NULL, NULL, 77012),
(77013, '3.40.50.300-FF-005090', NULL, 'Uncharacterized protein', 48, NULL, NULL, 77013),
(77014, '2.60.470.10-FF-000024', NULL, 'Pickpocket 14', 159, NULL, NULL, 77014),
(77015, '3.40.50.300-FF-003381', NULL, 'P-loop containing nucleoside triphosphate hydrolases superfamily protein', 179, NULL, NULL, 77015),
(77016, '1.20.58.390-FF-000001', NULL, 'Neuronal nicotinic acetylcholine receptor subunit 3', 114, NULL, NULL, 77016),
(77017, '3.30.70.2760-FF-000005', NULL, 'HD domain containing protein, putative', 126, NULL, NULL, 77017),
(77018, '3.30.1010.10-FF-000122', NULL, 'Uncharacterized protein', 66, NULL, NULL, 77018),
(77019, '3.30.60.270-FF-000008', NULL, 'Vacuolar protein sorting/targeting protein PEP1', 70, NULL, NULL, 77019),
(77020, '1.10.246.90-FF-000003', NULL, 'Nucleolar protein 58', 122, NULL, NULL, 77020),
(77021, '3.90.190.10-FF-000380', NULL, 'Tyrosine protein phosphatase', 345, NULL, NULL, 77021),
(77022, '3.20.20.330-FF-000021', NULL, 'Homocysteine S-methyltransferase, putative', 377, NULL, NULL, 77022),
(77023, '1.20.1250.20-FF-000455', NULL, 'Sugar baby, isoform C', 95, NULL, NULL, 77023),
(77024, '1.20.58.60-FF-000617', NULL, 'Uncharacterized protein', 291, NULL, NULL, 77024);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(77025, '3.40.50.10190-FF-000230', NULL, 'DNA ligase 4-like protein', 119, NULL, NULL, 77025),
(77026, '1.25.40.10-FF-002890', NULL, 'Putative pentatricopeptide repeat protein', 226, NULL, NULL, 77026),
(77027, '3.40.30.10-FF-000202', NULL, 'glutathione S-transferase 1', 80, NULL, NULL, 77027),
(77028, '3.40.50.300-FF-008259', NULL, 'Predicted protein', 268, NULL, NULL, 77028),
(77029, '3.60.10.10-FF-000363', NULL, 'Predicted protein', 127, NULL, NULL, 77029),
(77030, '3.30.160.60-FF-005701', NULL, NULL, 58, NULL, NULL, 77030),
(77031, '3.30.230.70-FF-000095', NULL, 'Exosome complex component Rrp42', 270, NULL, NULL, 77031),
(77032, '3.20.20.80-FF-000279', NULL, 'Glycosyl hydrolase', 361, NULL, NULL, 77032),
(77033, '1.20.140.40-FF-000027', NULL, 'Pectinesterase', 148, NULL, NULL, 77033),
(77034, '1.25.40.10-FF-003053', NULL, 'RNA polymerase III transcription factor, putative', 72, NULL, NULL, 77034),
(77035, '3.40.50.12780-FF-000181', NULL, 'Predicted protein', 253, NULL, NULL, 77035),
(77036, '3.40.50.12430-FF-000008', NULL, 'Uncharacterized protein', 88, NULL, NULL, 77036),
(77037, '3.20.20.190-FF-000052', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 196, NULL, NULL, 77037),
(77038, '3.30.1330.40-FF-000008', NULL, 'ribonuclease UK114 isoform X2', 136, NULL, NULL, 77038),
(77039, '4.10.280.10-FF-000081', NULL, 'transcription cofactor HES-6 isoform X1', 60, NULL, NULL, 77039),
(77040, '3.60.15.10-FF-000262', NULL, 'Uncharacterized protein', 169, NULL, NULL, 77040),
(77041, '3.40.50.300-FF-003291', NULL, 'RAN small monomeric GTPase (Ran)', 211, NULL, NULL, 77041),
(77042, '3.30.465.10-FF-000072', NULL, 'Alkylglycerone-phosphate synthase', 207, NULL, NULL, 77042),
(77043, '1.25.10.10-FF-001516', NULL, 'Formin-B', 302, NULL, NULL, 77043),
(77044, '3.40.1280.10-FF-000038', NULL, 'Ribosomal RNA small subunit methyltransferase E', 231, NULL, NULL, 77044),
(77045, '1.10.287.1060-FF-000013', NULL, 'ESAT-6 like protein EsxS', 97, NULL, NULL, 77045),
(77046, '1.20.1510.10-FF-000046', NULL, 'Cation diffusion facilitator family protein 1', 122, NULL, NULL, 77046),
(77047, '2.130.10.10-FF-002891', NULL, 'Expressed protein', 148, NULL, NULL, 77047),
(77048, '2.30.42.10-FF-000075', NULL, 'Tight junction protein ZO-2 isoform 2', 110, NULL, NULL, 77048),
(77049, '1.10.510.10-FF-003781', NULL, NULL, 132, NULL, NULL, 77049),
(77050, '1.10.8.270-FF-000159', NULL, 'Uncharacterized protein', 102, NULL, NULL, 77050),
(77051, '1.20.58.60-FF-000527', NULL, 'Uncharacterized protein', 243, NULL, NULL, 77051),
(77052, '2.10.25.10-FF-001256', NULL, 'Uncharacterized protein', 50, NULL, NULL, 77052),
(77053, '3.30.200.20-FF-000359', NULL, 'myosin light chain kinase 2, skeletal/cardiac muscle', 87, NULL, NULL, 77053),
(77054, '2.60.40.420-FF-000182', NULL, 'Chromosome 19, whole genome shotgun sequence', 210, NULL, NULL, 77054),
(77055, '3.40.309.10-FF-000095', NULL, 'ALdehyde deHydrogenase', 65, NULL, NULL, 77055),
(77056, '3.30.160.60-FF-001811', NULL, 'Uncharacterized protein, isoform A', 31, NULL, NULL, 77056),
(77057, '1.10.10.10-FF-001544', NULL, 'cGMP binding protein with small GTPase-serine/threonine kinase-dep-rasgef-gram-and two cGMP binding domains', 83, NULL, NULL, 77057),
(77058, '3.30.50.10-FF-000108', NULL, 'Nuclear hormone receptor family member odr-7', 98, NULL, NULL, 77058),
(77059, '1.25.40.10-FF-002738', NULL, 'Trafficking protein particle complex subunit 12', 234, NULL, NULL, 77059),
(77060, '3.10.100.10-FF-000336', NULL, NULL, 78, NULL, NULL, 77060),
(77061, '1.10.287.1080-FF-000019', NULL, 'Uncharacterized protein', 61, NULL, NULL, 77061),
(77062, '1.20.120.980-FF-000048', NULL, 'Uncharacterized protein', 165, NULL, NULL, 77062),
(77063, '3.80.10.10-FF-000019', NULL, 'leucine-rich repeat and fibronectin type III domain-containing protein 1', 140, NULL, NULL, 77063),
(77064, '3.30.450.20-FF-000613', NULL, 'Uncharacterized protein', 122, NULL, NULL, 77064),
(77065, '3.30.40.10-FF-000080', NULL, 'Histone-lysine N-methyltransferase 2C', 100, NULL, NULL, 77065),
(77066, '2.60.120.200-FF-000097', NULL, 'Pappalysin 1', 193, NULL, NULL, 77066);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(77067, '3.30.1740.10-FF-000014', NULL, 'Poly [ADP-ribose] polymerase', 106, NULL, NULL, 77067),
(77068, '1.10.357.50-FF-000013', NULL, 'Exocyst complex component, putative', 180, NULL, NULL, 77068),
(77069, '3.90.70.10-FF-000860', NULL, 'Predicted protein', 96, NULL, NULL, 77069),
(77070, '1.10.10.60-FF-000429', NULL, 'AraC family transcriptional regulator', 54, NULL, NULL, 77070),
(77071, '3.30.200.20-FF-001264', NULL, 'Serine/threonine-protein kinase', 103, NULL, NULL, 77071),
(77072, '1.10.287.70-FF-000350', NULL, 'Predicted protein', 101, NULL, NULL, 77072),
(77073, '1.25.10.10-FF-000499', NULL, 'Uncharacterized protein', 259, NULL, NULL, 77073),
(77074, '3.40.250.10-FF-000222', NULL, 'Uncharacterized protein', 124, NULL, NULL, 77074),
(77075, '2.120.10.80-FF-000383', NULL, 'Tip elongation aberrant protein 1', 127, NULL, NULL, 77075),
(77076, '2.60.40.10-FF-004588', NULL, NULL, 112, NULL, NULL, 77076),
(77077, '3.40.309.10-FF-000038', NULL, 'Betaine aldehyde dehydrogenase, variant', 196, NULL, NULL, 77077),
(77078, '6.10.250.3400-FF-000001', NULL, 'MAM1p Monopolin', 28, NULL, NULL, 77078),
(77079, '3.40.50.2000-FF-000764', NULL, 'Alpha-1,4 glucan phosphorylase', 174, NULL, NULL, 77079),
(77080, '3.30.200.20-FF-002192', NULL, 'Aurora b kinase1', 54, NULL, NULL, 77080),
(77081, '1.10.10.10-FF-000881', NULL, 'SAC3/GANP/Nin1/mts3/eIF-3_p25_family /COP9_signalosome_-_subunit_CSN8_-_putative', 103, NULL, NULL, 77081),
(77082, '3.30.160.60-FF-001547', NULL, 'C2H2 transcription factor RfeC', 39, NULL, NULL, 77082),
(77083, '2.70.70.10-FF-000060', NULL, 'Peptidase', 131, NULL, NULL, 77083),
(77084, '3.90.1150.10-FF-000450', NULL, 'AGAP006541-PA', 147, NULL, NULL, 77084),
(77085, '3.40.50.2300-FF-001135', NULL, NULL, 143, NULL, NULL, 77085),
(77086, '1.20.1160.20-FF-000010', NULL, 'Regulator of telomere elongation helicase 1 homolog', 92, NULL, NULL, 77086),
(77087, '3.30.900.10-FF-000005', NULL, 'Mitotic spindle checkpoint protein', 258, NULL, NULL, 77087),
(77088, '3.40.50.720-FF-001033', NULL, 'Prestalk A differentiation protein A', 183, NULL, NULL, 77088),
(77089, '1.10.940.10-FF-000014', NULL, 'Transcription antitermination protein NusB', 139, NULL, NULL, 77089),
(77090, '3.40.850.10-FF-000015', NULL, 'Kinesin family member 26A', 365, NULL, NULL, 77090),
(77091, '3.30.2010.10-FF-000004', NULL, 'Metalloprotease YcaL', 87, NULL, NULL, 77091),
(77092, '3.40.50.300-FF-003852', NULL, 'Predicted protein', 212, NULL, NULL, 77092),
(77093, '3.30.1460.20-FF-000006', NULL, 'Arp2/3 complex 34 kDa subunit', 137, NULL, NULL, 77093),
(77094, '1.10.150.20-FF-000277', NULL, 'FA core complex associated protein 24', 70, NULL, NULL, 77094),
(77095, '4.10.240.10-FF-000016', NULL, 'C6 transcription factor, putative', 61, NULL, NULL, 77095),
(77096, '1.10.238.10-FF-001113', NULL, 'Uncharacterized protein', 47, NULL, NULL, 77096),
(77097, '2.70.150.10-FF-000279', NULL, 'P-type phospholipid transporter', 184, NULL, NULL, 77097),
(77098, '3.30.160.60-FF-001901', NULL, 'Zinc finger protein 16', 28, NULL, NULL, 77098),
(77099, '3.90.1580.10-FF-000004', NULL, 'Hercynine oxygenase', 271, NULL, NULL, 77099),
(77100, '2.60.40.820-FF-000032', NULL, 'Predicted protein', 102, NULL, NULL, 77100),
(77101, '3.30.160.60-FF-004684', NULL, NULL, 28, NULL, NULL, 77101),
(77102, '1.10.8.140-FF-000002', NULL, 'Programmed cell death, putative', 109, NULL, NULL, 77102),
(77103, '3.20.20.80-FF-000072', NULL, 'lysosomal alpha-glucosidase isoform X2', 344, NULL, NULL, 77103),
(77104, '1.10.3470.10-FF-000056', NULL, 'Divalent manganese/zinc ABC transporter, membrane protein', 253, NULL, NULL, 77104),
(77105, '3.40.50.300-FF-001082', NULL, 'probable ATP-dependent RNA helicase DHX40', 225, NULL, NULL, 77105),
(77106, '3.10.100.10-FF-000426', NULL, NULL, 83, NULL, NULL, 77106),
(77107, '4.10.240.10-FF-000073', NULL, 'Glucose transport transcription regulator RGT1', 84, NULL, NULL, 77107),
(77108, '2.60.40.10-FF-001805', NULL, 'Tyrosine-protein kinase-like otk', 97, NULL, NULL, 77108),
(77109, '3.30.160.60-FF-002475', NULL, 'Si:ch73-221f6.3', 31, NULL, NULL, 77109);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(77110, '3.30.40.10-FF-001827', NULL, 'Predicted protein', 97, NULL, NULL, 77110),
(77111, '3.80.10.10-FF-000637', NULL, 'Toll receptor 13', 131, NULL, NULL, 77111),
(77112, '3.80.10.10-FF-003717', NULL, 'Uncharacterized protein', 148, NULL, NULL, 77112),
(77113, '3.20.20.80-FF-000015', NULL, 'Acidic endochitinase SE2', 273, NULL, NULL, 77113),
(77114, '1.25.40.10-FF-003143', NULL, 'Pentatricopeptide repeat-containing protein At1g20300, mitochondrial', 125, NULL, NULL, 77114),
(77115, '1.20.120.610-FF-000016', NULL, 'V-type proton ATPase proteolipid subunit', 107, NULL, NULL, 77115),
(77116, '3.40.50.300-FF-001643', NULL, 'DNA repair protein RAD51 homolog 2', 275, NULL, NULL, 77116),
(77117, '3.10.450.610-FF-000001', NULL, 'DUF4902 domain-containing protein', 147, NULL, NULL, 77117),
(77118, '3.40.50.1820-FF-000485', NULL, 'Carboxylic ester hydrolase', 547, NULL, NULL, 77118),
(77119, '1.20.1290.10-FF-000011', NULL, 'Sestrin 2', 148, NULL, NULL, 77119),
(77120, '3.60.120.10-FF-000023', NULL, 'Aminodeoxychorismate synthase component I', 488, NULL, NULL, 77120),
(77121, '1.10.1300.10-FF-000077', NULL, 'Uncharacterized protein', 49, NULL, NULL, 77121),
(77122, '3.40.50.150-FF-000648', NULL, 'Uncharacterized protein', 269, NULL, NULL, 77122),
(77123, '3.90.20.20-FF-000005', NULL, 'GrpE protein homolog', 116, NULL, NULL, 77123),
(77124, '3.20.20.70-FF-000012', NULL, 'GMP reductase', 345, NULL, NULL, 77124),
(77125, '4.10.1000.10-FF-000125', NULL, 'Uncharacterized protein', 74, NULL, NULL, 77125),
(77126, '1.20.1250.20-FF-002046', NULL, 'Uncharacterized protein', 316, NULL, NULL, 77126),
(77127, '1.10.510.10-FF-000757', NULL, 'AGC family serine/threonine kinase', 192, NULL, NULL, 77127),
(77128, '3.30.230.10-FF-000184', NULL, '40S ribosomal protein S16', 146, NULL, NULL, 77128),
(77129, '3.10.28.10-FF-000029', NULL, 'Uncharacterized mitochondrial protein RF1', 156, NULL, NULL, 77129),
(77130, '2.60.40.10-FF-003453', NULL, NULL, 102, NULL, NULL, 77130),
(77131, '3.90.176.10-FF-000004', NULL, 'Type III effector HopU1', 236, NULL, NULL, 77131),
(77132, '2.60.120.200-FF-000187', NULL, 'SP2353, isoform A', 181, NULL, NULL, 77132),
(77133, '2.30.29.30-FF-000409', NULL, 'Insulin receptor substrate 2-B', 120, NULL, NULL, 77133),
(77134, '2.60.120.330-FF-000231', NULL, 'Uncharacterized protein', 145, NULL, NULL, 77134),
(77135, '2.30.39.10-FF-000022', NULL, 'Os11g0230400 protein', 123, NULL, NULL, 77135),
(77136, '2.60.60.20-FF-000028', NULL, 'Triacylglycerol lipase, pancreatic', 110, NULL, NULL, 77136),
(77137, '2.130.10.10-FF-003054', NULL, 'THO complex subunit 6', 141, NULL, NULL, 77137),
(77138, '3.10.330.10-FF-000027', NULL, 'Vesicular-fusion protein SEC18', 106, NULL, NULL, 77138),
(77139, '2.60.40.10-FF-005605', NULL, NULL, 107, NULL, NULL, 77139),
(77140, '3.40.50.12470-FF-000003', NULL, '2-oxoglutarate dehydrogenase E1 component', 273, NULL, NULL, 77140),
(77141, '3.30.420.40-FF-000382', NULL, 'Glucosamine kinase GpsK', 120, NULL, NULL, 77141),
(77142, '3.30.200.20-FF-000449', NULL, 'cGMP-dependent protein kinase', 87, NULL, NULL, 77142),
(77143, '1.10.238.210-FF-000012', NULL, 'Glna-1', 82, NULL, NULL, 77143),
(77144, '1.10.860.10-FF-000013', NULL, 'DNA primase', 122, NULL, NULL, 77144),
(77145, '2.30.30.100-FF-000057', NULL, 'LSM1 homolog, mRNA degradation associated', 33, NULL, NULL, 77145),
(77146, '3.90.180.10-FF-000143', NULL, 'Zinc-type alcohol dehydrogenase-like protein C1198.01', 208, NULL, NULL, 77146),
(77147, '1.25.40.10-FF-005352', NULL, 'Uncharacterized protein', 124, NULL, NULL, 77147),
(77148, '3.30.70.270-FF-000275', NULL, NULL, 120, NULL, NULL, 77148),
(77149, '3.20.20.80-FF-000633', NULL, 'Uncharacterized protein', 119, NULL, NULL, 77149),
(77150, '3.60.40.10-FF-000191', NULL, 'Probable protein phosphatase 2C F42G9.1', 325, NULL, NULL, 77150),
(77151, '3.30.420.10-FF-000221', NULL, '3''-5'' exonuclease family protein', 186, NULL, NULL, 77151),
(77152, '4.10.400.10-FF-000170', NULL, 'Low density lipoprotein receptor-related protein 2a', 41, NULL, NULL, 77152),
(77153, '2.60.200.40-FF-000053', NULL, 'Diacylglycerol kinase', 104, NULL, NULL, 77153);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(77154, '1.10.510.10-FF-002909', NULL, NULL, 80, NULL, NULL, 77154),
(77155, '2.60.40.10-FF-001244', NULL, 'Interferon gamma receptor 1', 114, NULL, NULL, 77155),
(77156, '3.30.70.360-FF-000004', NULL, 'Peptidase M20 domain-containing protein 2', 118, NULL, NULL, 77156),
(77157, '2.60.120.260-FF-000244', NULL, 'Alpha-1,3/4-fucosidase', 91, NULL, NULL, 77157),
(77158, '3.20.20.150-FF-000057', NULL, 'Probable hexulose-6-phosphate isomerase', 280, NULL, NULL, 77158),
(77159, '1.10.510.10-FF-002966', NULL, NULL, 169, NULL, NULL, 77159),
(77160, '3.40.50.360-FF-000065', NULL, 'Flavoprotein MioC', 143, NULL, NULL, 77160),
(77161, '1.10.472.80-FF-000250', NULL, NULL, 119, NULL, NULL, 77161),
(77162, '3.30.30.90-FF-000001', NULL, 'Polymerase basic protein 2', 73, NULL, NULL, 77162),
(77163, '1.20.140.140-FF-000008', NULL, 'Uncharacterized protein', 170, NULL, NULL, 77163),
(77164, '3.20.20.70-FF-000630', NULL, NULL, 269, NULL, NULL, 77164),
(77165, '3.20.20.140-FF-000054', NULL, 'Imidazolonepropionase-like amidohydrolase', 272, NULL, NULL, 77165),
(77166, '3.30.70.600-FF-000008', NULL, '40S ribosomal protein S20', 63, NULL, NULL, 77166),
(77167, '1.10.8.1080-FF-000001', NULL, 'N-acetylmuramic acid 6-phosphate etherase', 77, NULL, NULL, 77167),
(77168, '3.30.70.270-FF-000218', NULL, NULL, 93, NULL, NULL, 77168),
(77169, '3.30.110.10-FF-000001', NULL, 'Translation initiation factor IF-3', 96, NULL, NULL, 77169),
(77170, '1.10.287.70-FF-000108', NULL, 'Sodium channel protein', 149, NULL, NULL, 77170),
(77171, '2.170.120.12-FF-000019', NULL, 'RNA Polymerase II (B) subunit', 136, NULL, NULL, 77171),
(77172, '1.10.730.20-FF-000012', NULL, 'Isoleucyl-tRNA synthetase (Mitochondrial)', 265, NULL, NULL, 77172),
(77173, '3.50.50.60-FF-000178', NULL, 'All-trans-retinol 13,14-reductase', 148, NULL, NULL, 77173),
(77174, '3.30.1520.10-FF-000149', NULL, 'Uncharacterized protein', 112, NULL, NULL, 77174),
(77175, '2.130.10.10-FF-005263', NULL, 'Uncharacterized protein', 260, NULL, NULL, 77175),
(77176, '2.60.40.10-FF-004678', NULL, NULL, 89, NULL, NULL, 77176),
(77177, '1.25.40.180-FF-000255', NULL, NULL, 289, NULL, NULL, 77177),
(77178, '1.20.120.230-FF-000054', NULL, 'Uncharacterized protein', 102, NULL, NULL, 77178),
(77179, '3.90.190.10-FF-000262', NULL, 'Uncharacterized protein', 299, NULL, NULL, 77179),
(77180, '3.30.200.20-FF-002276', NULL, 'Calmodulin-binding receptor-like cytoplasmic kinase 2', 110, NULL, NULL, 77180),
(77181, '3.30.160.60-FF-001581', NULL, 'Uncharacterized protein', 30, NULL, NULL, 77181),
(77182, '1.25.40.20-FF-001381', NULL, 'Uncharacterized protein', 77, NULL, NULL, 77182),
(77183, '3.30.70.330-FF-000377', NULL, 'Peptidyl-prolyl cis-trans isomerase', 141, NULL, NULL, 77183),
(77184, '1.20.1250.20-FF-000045', NULL, 'Glycoside-pentoside-hexuronide family transporter', 408, NULL, NULL, 77184),
(77185, '1.20.1250.10-FF-000042', NULL, 'Somatolactin alpha', 199, NULL, NULL, 77185),
(77186, '1.10.10.10-FF-001191', NULL, 'MarR family transcriptional regulator', 141, NULL, NULL, 77186),
(77187, '3.30.559.10-FF-000076', NULL, 'Transferase family protein', 237, NULL, NULL, 77187),
(77188, '1.10.10.10-FF-000729', NULL, 'Transcriptional regulator FurA', 79, NULL, NULL, 77188),
(77189, '3.40.1440.10-FF-000017', NULL, NULL, 94, NULL, NULL, 77189),
(77190, '2.10.230.10-FF-000001', NULL, 'DnaJ subfamily A member 2', 67, NULL, NULL, 77190),
(77191, '3.10.580.10-FF-000130', NULL, 'Hemolysin', 153, NULL, NULL, 77191),
(77192, '3.40.50.460-FF-000005', NULL, 'ATP-dependent 6-phosphofructokinase', 139, NULL, NULL, 77192),
(77193, '3.10.450.70-FF-000003', NULL, 'Thiol:disulfide interchange protein', 63, NULL, NULL, 77193),
(77194, '1.10.8.750-FF-000005', NULL, 'Uncharacterized protein', 37, NULL, NULL, 77194),
(77195, '2.160.20.10-FF-000316', NULL, 'Protein kinase, putative', 192, NULL, NULL, 77195),
(77196, '2.40.50.140-FF-000239', NULL, 'Meiosis specific with OB domains', 178, NULL, NULL, 77196),
(77197, '1.25.40.10-FF-004571', NULL, 'Uncharacterized protein', 288, NULL, NULL, 77197),
(77198, '3.30.565.10-FF-000489', NULL, 'Protein morc-1', 159, NULL, NULL, 77198);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(77199, '3.40.50.150-FF-000497', NULL, 'tRNA wybutosine-synthesizing protein 2', 217, NULL, NULL, 77199),
(77200, '3.30.559.10-FF-000132', NULL, 'Nonribosomal peptide synthetase fmqA', 169, NULL, NULL, 77200),
(77201, '1.20.1070.10-FF-002035', NULL, 'Uncharacterized protein', 118, NULL, NULL, 77201),
(77202, '2.30.36.70-FF-000011', NULL, 'Actin family protein', 40, NULL, NULL, 77202),
(77203, '3.40.630.10-FF-000358', NULL, 'Uncharacterized protein', 159, NULL, NULL, 77203),
(77204, '2.40.50.140-FF-000767', NULL, NULL, 77, NULL, NULL, 77204),
(77205, '1.50.40.10-FF-000201', NULL, 'Solute carrier family 25 member 4', 106, NULL, NULL, 77205),
(77206, '1.20.1720.10-FF-000056', NULL, 'MFS transporter, putative', 189, NULL, NULL, 77206),
(77207, '2.130.10.10-FF-002739', NULL, 'WD40-repeat-containing domain protein', 387, NULL, NULL, 77207),
(77208, '1.20.1250.20-FF-001675', NULL, 'ABC multidrug transporter (Eurofung)', 288, NULL, NULL, 77208),
(77209, '2.60.120.260-FF-000328', NULL, 'Beta-galactosidase', 174, NULL, NULL, 77209),
(77210, '1.20.920.20-FF-000058', NULL, 'Uncharacterized protein', 139, NULL, NULL, 77210),
(77211, '2.170.130.10-FF-000063', NULL, NULL, 127, NULL, NULL, 77211),
(77212, '3.30.160.60-FF-003672', NULL, NULL, 27, NULL, NULL, 77212),
(77213, '1.20.1270.60-FF-000007', NULL, 'Bridging integrator 1, isoform CRA_e', 236, NULL, NULL, 77213),
(77214, '3.100.10.10-FF-000056', NULL, NULL, 81, NULL, NULL, 77214),
(77215, '2.160.20.10-FF-000198', NULL, 'Uncharacterized protein', 125, NULL, NULL, 77215),
(77216, '3.80.10.10-FF-000137', NULL, 'Toll-like receptor 3', 668, NULL, NULL, 77216),
(77217, '3.30.70.330-FF-002468', NULL, NULL, 81, NULL, NULL, 77217),
(77218, '3.90.70.10-FF-000388', NULL, 'Ubiquitin carboxyl-terminal hydrolase 16, putative', 360, NULL, NULL, 77218),
(77219, '1.10.510.10-FF-000965', NULL, 'Putative Raf proto-oncogene serine/threonine-protein kinase', 182, NULL, NULL, 77219),
(77220, '1.10.510.10-FF-001038', NULL, 'Serine/threonine-protein kinase AKL1', 344, NULL, NULL, 77220),
(77221, '3.30.200.20-FF-001820', NULL, NULL, 59, NULL, NULL, 77221),
(77222, '2.60.40.10-FF-004908', NULL, NULL, 99, NULL, NULL, 77222),
(77223, '3.20.20.80-FF-000515', NULL, 'Uncharacterized protein', 154, NULL, NULL, 77223),
(77224, '1.25.40.180-FF-000165', NULL, NULL, 218, NULL, NULL, 77224),
(77225, '3.40.47.10-FF-000179', NULL, 'Predicted protein', 411, NULL, NULL, 77225),
(77226, '1.25.40.10-FF-001428', NULL, 'Tetratricopeptide repeat protein 19, mitochondrial', 135, NULL, NULL, 77226),
(77227, '3.20.20.70-FF-000512', NULL, 'Hydroxymethylglutaryl-CoA lyase', 299, NULL, NULL, 77227),
(77228, '3.30.750.24-FF-000130', NULL, 'Anti-sigma factor antagonist', 111, NULL, NULL, 77228),
(77229, '1.10.150.20-FF-000069', NULL, 'Exonuclease 1', 74, NULL, NULL, 77229),
(77230, '3.40.50.150-FF-000974', NULL, NULL, 224, NULL, NULL, 77230),
(77231, '3.30.160.60-FF-005324', NULL, NULL, 76, NULL, NULL, 77231),
(77232, '3.20.20.30-FF-000017', NULL, 'Possible oxidoreductase', 299, NULL, NULL, 77232),
(77233, '3.40.50.620-FF-000840', NULL, 'Bll4756 protein', 82, NULL, NULL, 77233),
(77234, '3.40.50.2000-FF-000500', NULL, 'ADP-heptose-lipo oligosaccharide heptosyl transferase II', 158, NULL, NULL, 77234),
(77235, '1.10.150.910-FF-000013', NULL, 'Predicted protein', 103, NULL, NULL, 77235),
(77236, '3.40.30.10-FF-001068', NULL, 'Chromosome 12, whole genome shotgun sequence', 159, NULL, NULL, 77236),
(77237, '1.10.510.10-FF-003129', NULL, NULL, 185, NULL, NULL, 77237),
(77238, '3.20.20.20-FF-000014', NULL, 'Folic acid synthesis protein fol1', 321, NULL, NULL, 77238),
(77239, '3.40.50.1820-FF-000305', NULL, 'Alpha/beta hydrolase', 283, NULL, NULL, 77239),
(77240, '2.10.110.10-FF-000318', NULL, 'Uncharacterized protein', 107, NULL, NULL, 77240),
(77241, '1.20.5.370-FF-000018', NULL, NULL, 94, NULL, NULL, 77241),
(77242, '2.20.25.80-FF-000017', NULL, NULL, 83, NULL, NULL, 77242),
(77243, '3.10.450.50-FF-000054', NULL, 'Nuclear RNA export factor 5', 74, NULL, NULL, 77243),
(77244, '3.40.50.300-FF-002599', NULL, 'Protein CHROMATIN REMODELING 19 isoform A', 192, NULL, NULL, 77244);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(77245, '1.20.20.10-FF-000033', NULL, 'Uncharacterized protein', 72, NULL, NULL, 77245),
(77246, '3.10.350.10-FF-000028', NULL, 'Peptidoglycan-binding protein LysM', 54, NULL, NULL, 77246),
(77247, '3.40.50.1820-FF-000249', NULL, 'Polyketide synthase Pks13', 264, NULL, NULL, 77247),
(77248, '3.40.50.10490-FF-000027', NULL, 'HTH-type transcriptional regulator rpiR', 185, NULL, NULL, 77248),
(77249, '1.20.5.350-FF-000012', NULL, 'Troponin I', 105, NULL, NULL, 77249),
(77250, '1.10.260.40-FF-000061', NULL, 'DNA transposition protein (GpB)', 63, NULL, NULL, 77250),
(77251, '3.30.1240.10-FF-000077', NULL, 'Predicted protein', 45, NULL, NULL, 77251),
(77252, '2.60.40.10-FF-003127', NULL, NULL, 93, NULL, NULL, 77252),
(77253, '1.10.510.10-FF-002819', NULL, NULL, 138, NULL, NULL, 77253),
(77254, '1.10.8.60-FF-000153', NULL, 'Peroxisome biogenesis protein 1', 81, NULL, NULL, 77254),
(77255, '3.20.20.10-FF-000011', NULL, 'Pyridoxal phosphate homeostasis protein', 225, NULL, NULL, 77255),
(77256, '2.30.42.10-FF-000513', NULL, NULL, 80, NULL, NULL, 77256),
(77257, '3.40.50.11260-FF-000034', NULL, 'Uncharacterized protein', 53, NULL, NULL, 77257),
(77258, '3.40.50.720-FF-002219', NULL, 'Uncharacterized protein', 113, NULL, NULL, 77258),
(77259, '1.10.472.10-FF-000595', NULL, 'Predicted protein', 25, NULL, NULL, 77259),
(77260, '2.170.140.10-FF-000035', NULL, 'GM22243', 60, NULL, NULL, 77260),
(77261, '2.60.40.10-FF-001513', NULL, 'Protein PTST, chloroplastic', 89, NULL, NULL, 77261),
(77262, '1.20.900.10-FF-000015', NULL, 'son of sevenless homolog 1 isoform X1', 222, NULL, NULL, 77262),
(77263, '2.30.42.10-FF-000193', NULL, 'Syntrophin gamma 1', 106, NULL, NULL, 77263),
(77264, '1.20.5.190-FF-000144', NULL, NULL, 53, NULL, NULL, 77264),
(77265, '3.40.50.720-FF-000605', NULL, 'Glyoxylate/hydroxypyruvate reductase', 121, NULL, NULL, 77265),
(77266, '1.20.58.60-FF-000264', NULL, 'Microtubule-actin cross-linking factor 1', 110, NULL, NULL, 77266),
(77267, '3.30.70.270-FF-000191', NULL, NULL, 134, NULL, NULL, 77267),
(77268, '1.10.238.10-FF-001175', NULL, 'Uncharacterized protein', 92, NULL, NULL, 77268),
(77269, '3.40.50.300-FF-006668', NULL, 'Putative G10 domain family protein', 85, NULL, NULL, 77269),
(77270, '2.60.120.260-FF-000480', NULL, 'Uncharacterized protein', 146, NULL, NULL, 77270),
(77271, '3.30.750.24-FF-000074', NULL, 'Anti-sigma factor antagonist', 107, NULL, NULL, 77271),
(77272, '3.30.1330.40-FF-000065', NULL, 'AGL164Wp', 106, NULL, NULL, 77272),
(77273, '1.10.3500.10-FF-000025', NULL, 'Transcription elongation factor spt6', 234, NULL, NULL, 77273),
(77274, '1.25.40.1030-FF-000001', NULL, 'protein transport protein Sec31A isoform X3', 413, NULL, NULL, 77274),
(77275, '1.25.40.1050-FF-000007', NULL, 'Putative 5''-3'' exonuclease', 93, NULL, NULL, 77275),
(77276, '3.30.470.20-FF-000058', NULL, 'Alpha-aminoadipate--LysW ligase LysX protein', 110, NULL, NULL, 77276),
(77277, '3.10.110.10-FF-000247', NULL, 'RBR-type E3 ubiquitin transferase', 173, NULL, NULL, 77277),
(77278, '3.30.750.44-FF-000023', NULL, NULL, 101, NULL, NULL, 77278),
(77279, '1.10.10.160-FF-000040', NULL, 'DNA helicase', 86, NULL, NULL, 77279),
(77280, '2.10.25.10-FF-001672', NULL, 'AGAP006732-PA', 45, NULL, NULL, 77280),
(77281, '3.40.50.450-FF-000002', NULL, 'ATP-dependent 6-phosphofructokinase', 191, NULL, NULL, 77281),
(77282, '1.10.8.740-FF-000002', NULL, 'Dynein heavy chain, cytoplasmic', 90, NULL, NULL, 77282),
(77283, '2.130.10.10-FF-001637', NULL, 'Dynein, cytoplasmic 1, intermediate chain 2a', 156, NULL, NULL, 77283),
(77284, '2.60.40.10-FF-001036', NULL, 'Muscle M-line assembly protein unc-89', 101, NULL, NULL, 77284),
(77285, '1.10.1200.10-FF-000013', NULL, 'Fatty acid synthase', 88, NULL, NULL, 77285),
(77286, '3.30.1330.30-FF-000062', NULL, 'Putative H/ACA ribonucleoprotein complex subunit 2-like protein', 122, NULL, NULL, 77286),
(77287, '3.30.230.10-FF-000274', NULL, 'Phosphomevalonate kinase', 162, NULL, NULL, 77287),
(77288, '1.25.40.1040-FF-000004', NULL, 'N-alpha-acetyltransferase 25, NatB auxiliary subunit', 306, NULL, NULL, 77288);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(77289, '2.60.40.420-FF-000125', NULL, 'Laccase 2', 132, NULL, NULL, 77289),
(77290, '2.130.10.10-FF-004982', NULL, 'Uncharacterized protein', 78, NULL, NULL, 77290),
(77291, '1.10.1220.10-FF-000020', NULL, 'Bifunctional antitoxin/transcriptional repressor RelB', 76, NULL, NULL, 77291),
(77292, '1.10.10.10-FF-001128', NULL, 'DNA-binding response regulator', 109, NULL, NULL, 77292),
(77293, '3.40.366.10-FF-000064', NULL, 'Uncharacterized protein', 146, NULL, NULL, 77293),
(77294, '1.50.10.20-FF-000056', NULL, 'Terpene cyclase/mutase family member', 281, NULL, NULL, 77294),
(77295, '2.30.30.40-FF-000394', NULL, 'Proline-serine-threonine phosphatase-interacting protein 1b', 88, NULL, NULL, 77295),
(77296, '3.90.660.10-FF-000130', NULL, NULL, 66, NULL, NULL, 77296),
(77297, '3.90.650.10-FF-000016', NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase', 175, NULL, NULL, 77297),
(77298, '3.40.390.10-FF-000171', NULL, NULL, 116, NULL, NULL, 77298),
(77299, '3.30.40.10-FF-000669', NULL, 'Acyl-CoA N-acyltransferase with RING/FYVE/PHD-type zinc finger domain-containing protein', 79, NULL, NULL, 77299),
(77300, '2.60.40.10-FF-003604', NULL, 'Junctional adhesion molecule 2a', 112, NULL, NULL, 77300),
(77301, '3.30.70.330-FF-000579', NULL, '30S ribosomal protein 2, chloroplastic', 101, NULL, NULL, 77301),
(77302, '2.40.50.140-FF-000565', NULL, 'Exosome complex exonuclease RRP44, putative', 78, NULL, NULL, 77302),
(77303, '1.10.2010.10-FF-000004', NULL, NULL, 75, NULL, NULL, 77303),
(77304, '3.30.40.10-FF-001597', NULL, 'Zinc finger protein', 84, NULL, NULL, 77304),
(77305, '3.30.300.30-FF-000050', NULL, 'Fatty-acid-CoA ligase FadD34', 123, NULL, NULL, 77305),
(77306, '1.10.287.920-FF-000009', NULL, 'Alpha-factor pheromone receptor', 43, NULL, NULL, 77306),
(77307, '3.30.70.330-FF-002794', NULL, NULL, 97, NULL, NULL, 77307),
(77308, '1.20.1740.10-FF-000265', NULL, 'Uncharacterized protein', 55, NULL, NULL, 77308),
(77309, '3.40.50.300-FF-003442', NULL, 'ESX-4 secretion system protein EccC4', 263, NULL, NULL, 77309),
(77310, '3.90.78.10-FF-000001', NULL, 'UDP-N-acetylenolpyruvoylglucosamine reductase', 88, NULL, NULL, 77310),
(77311, '1.25.40.10-FF-001226', NULL, 'Pentatricopeptide repeat-containing protein At3g03580', 106, NULL, NULL, 77311),
(77312, '2.20.25.10-FF-000098', NULL, 'Putative conserved secreted protein', 49, NULL, NULL, 77312),
(77313, '3.80.10.10-FF-003482', NULL, 'Uncharacterized protein', 204, NULL, NULL, 77313),
(77314, '2.60.40.2320-FF-000002', NULL, '1,4-alpha-glucan branching enzyme', 90, NULL, NULL, 77314),
(77315, '1.20.1560.10-FF-000228', NULL, 'p-GlycoProtein related', 357, NULL, NULL, 77315),
(77316, '3.40.50.300-FF-008585', NULL, 'ATPase, AAA superfamily', 183, NULL, NULL, 77316),
(77317, '1.20.91.20-FF-000008', NULL, 'Complement component 4', 78, NULL, NULL, 77317),
(77318, '2.10.50.10-FF-000050', NULL, 'Cysteine repeat modular protein 1', 59, NULL, NULL, 77318),
(77319, '1.20.1250.20-FF-000371', NULL, 'H(+) MyoInositol coTransporter', 367, NULL, NULL, 77319),
(77320, '2.60.120.260-FF-000654', NULL, 'Beta-galactosidase', 113, NULL, NULL, 77320),
(77321, '3.40.50.720-FF-001882', NULL, 'Uncharacterized protein', 35, NULL, NULL, 77321),
(77322, '2.10.90.10-FF-000052', NULL, 'Bone morphogenetic protein', 105, NULL, NULL, 77322),
(77323, '1.10.340.70-FF-000014', NULL, 'Uncharacterized protein', 76, NULL, NULL, 77323),
(77324, '1.25.10.10-FF-003164', NULL, 'Uncharacterized protein', 364, NULL, NULL, 77324),
(77325, '3.30.465.10-FF-000133', NULL, 'Uncharacterized protein', 129, NULL, NULL, 77325),
(77326, '1.25.40.20-FF-001701', NULL, 'Diacylglycerol kinase', 60, NULL, NULL, 77326),
(77327, '3.90.70.80-FF-000043', NULL, 'Uncharacterized protein', 155, NULL, NULL, 77327),
(77328, '3.30.470.30-FF-000090', NULL, 'Uncharacterized protein', 206, NULL, NULL, 77328),
(77329, '1.25.10.10-FF-003315', NULL, 'Non-specific serine/threonine protein kinase', 147, NULL, NULL, 77329),
(77330, '1.25.10.10-FF-000584', NULL, 'V-type proton ATPase subunit H', 327, NULL, NULL, 77330),
(77331, '3.40.50.2300-FF-000146', NULL, 'Putative two-component response regulator SSK1p', 146, NULL, NULL, 77331);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(77332, '3.50.30.30-FF-000101', NULL, 'Uncharacterized protein', 57, NULL, NULL, 77332),
(77333, '1.10.510.10-FF-004383', NULL, NULL, 93, NULL, NULL, 77333),
(77334, '1.20.120.20-FF-000020', NULL, 'Apolipoprotein E', 93, NULL, NULL, 77334),
(77335, '2.120.10.30-FF-000475', NULL, 'Uncharacterized protein', 55, NULL, NULL, 77335),
(77336, '3.30.572.10-FF-000011', NULL, 'Bifunctional dihydrofolate reductase-thymidylate synthase', 290, NULL, NULL, 77336),
(77337, '3.80.10.10-FF-000463', NULL, 'EIN3-binding F-box protein 1', 206, NULL, NULL, 77337),
(77338, '3.30.160.60-FF-001255', NULL, 'Zinc finger protein 26', 28, NULL, NULL, 77338),
(77339, '3.30.70.1450-FF-000040', NULL, 'Predicted protein', 75, NULL, NULL, 77339),
(77340, '3.40.850.10-FF-000251', NULL, 'Kinesin-like protein', 293, NULL, NULL, 77340),
(77341, '3.90.640.10-FF-000218', NULL, 'Uncharacterized protein', 78, NULL, NULL, 77341),
(77342, '2.40.50.140-FF-000621', NULL, 'BRCA2, oligonucleotide/oligosaccharide-binding, domain 1 protein', 159, NULL, NULL, 77342),
(77343, '3.30.230.10-FF-000330', NULL, 'Uncharacterized protein', 84, NULL, NULL, 77343),
(77344, '3.30.300.70-FF-000005', NULL, 'Ribosome maturation factor RimP', 77, NULL, NULL, 77344),
(77345, '1.20.5.170-FF-000082', NULL, 'Cell death specification', 65, NULL, NULL, 77345),
(77346, '3.80.10.10-FF-002554', NULL, 'Nuclear export factor 3, isoform B', 145, NULL, NULL, 77346),
(77347, '3.40.50.300-FF-006022', NULL, 'Predicted protein', 162, NULL, NULL, 77347),
(77348, '1.20.1280.290-FF-000069', NULL, 'Sugar transporter SWEET1', 87, NULL, NULL, 77348),
(77349, '2.60.220.50-FF-000142', NULL, 'G-protein coupled receptor, putative', 143, NULL, NULL, 77349),
(77350, '3.30.470.10-FF-000022', NULL, 'Branched-chain amino acid aminotransferase, putative', 103, NULL, NULL, 77350),
(77351, '3.90.25.10-FF-000053', NULL, 'NAD(P)-binding protein', 103, NULL, NULL, 77351),
(77352, '3.40.50.200-FF-000034', NULL, 'Proline rich membrane-anchored mycosin', 124, NULL, NULL, 77352),
(77353, '3.30.420.10-FF-000018', NULL, 'DNA polymerase', 300, NULL, NULL, 77353),
(77354, '3.40.50.300-FF-001817', NULL, 'Primosome assembly protein PriA', 152, NULL, NULL, 77354),
(77355, '1.10.1520.10-FF-000032', NULL, 'Dicer-like protein 2', 218, NULL, NULL, 77355),
(77356, '3.40.50.80-FF-000089', NULL, 'Uncharacterized protein', 148, NULL, NULL, 77356),
(77357, '1.10.167.10-FF-000020', NULL, 'Regulator of G protein signaling 22', 155, NULL, NULL, 77357),
(77358, '2.130.10.30-FF-000070', NULL, 'SD05384p', 393, NULL, NULL, 77358),
(77359, '3.40.50.300-FF-005089', NULL, 'Uncharacterized protein', 51, NULL, NULL, 77359),
(77360, '1.25.40.20-FF-000122', NULL, 'ankyrin repeat domain-containing protein 6', 110, NULL, NULL, 77360),
(77361, '1.10.10.10-FF-001600', NULL, 'Uncharacterized protein', 124, NULL, NULL, 77361),
(77362, '3.10.129.10-FF-000037', NULL, 'acyl-acyl carrier protein thioesterase ATL3, chloroplastic', 141, NULL, NULL, 77362),
(77363, '3.30.160.60-FF-003200', NULL, 'GM26321', 28, NULL, NULL, 77363),
(77364, '3.30.930.10-FF-000102', NULL, 'Bifunctional ligase/repressor BirA', 211, NULL, NULL, 77364),
(77365, '1.20.1070.10-FF-000270', NULL, 'Vomeronasal type-1 receptor', 300, NULL, NULL, 77365),
(77366, '3.40.50.720-FF-002371', NULL, 'Uncharacterized protein', 33, NULL, NULL, 77366),
(77367, '3.10.20.90-FF-000659', NULL, 'Ubiquitin fusion protein', 84, NULL, NULL, 77367),
(77368, '3.40.50.150-FF-001340', NULL, NULL, 194, NULL, NULL, 77368),
(77369, '3.40.50.300-FF-007124', NULL, 'Guanylate kinase 1', 184, NULL, NULL, 77369),
(77370, '3.40.50.12780-FF-000001', NULL, 'Acetyl-coenzyme A synthetase', 514, NULL, NULL, 77370),
(77371, '1.10.1520.10-FF-000060', NULL, 'Predicted protein', 169, NULL, NULL, 77371),
(77372, '1.20.1070.10-FF-000646', NULL, 'Olfactory receptor 887', 92, NULL, NULL, 77372),
(77373, '3.30.160.60-FF-003346', NULL, 'Zinc finger protein 846', 43, NULL, NULL, 77373),
(77374, '3.20.20.80-FF-000341', NULL, 'Maltooligosyl trehalose synthase', 91, NULL, NULL, 77374),
(77375, '1.20.5.190-FF-000088', NULL, 'Myosin', 48, NULL, NULL, 77375); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(77376, '2.20.100.10-FF-000208', NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif, 6', 73, NULL, NULL, 77376),
(77377, '2.60.40.150-FF-000786', NULL, 'Uncharacterized protein', 157, NULL, NULL, 77377),
(77378, '3.10.50.10-FF-000070', NULL, 'CHItinase-Like', 13, NULL, NULL, 77378),
(77379, '3.30.2090.10-FF-000014', NULL, 'Putative multidrug resistance protein', 93, NULL, NULL, 77379),
(77380, '3.60.110.10-FF-000022', NULL, 'Formamidase', 322, NULL, NULL, 77380),
(77381, '3.40.50.11610-FF-000010', NULL, 'Oxoglutarate dehydrogenase (Succinyl-transferring), E1 component', 185, NULL, NULL, 77381),
(77382, '3.30.70.330-FF-002524', NULL, NULL, 60, NULL, NULL, 77382),
(77383, '1.25.40.10-FF-004447', NULL, 'Uncharacterized protein', 115, NULL, NULL, 77383),
(77384, '1.10.510.10-FF-003601', NULL, NULL, 203, NULL, NULL, 77384),
(77385, '2.60.40.10-FF-005370', NULL, NULL, 60, NULL, NULL, 77385),
(77386, '3.30.1050.10-FF-000012', NULL, 'Eucalyptus, isoform A', 104, NULL, NULL, 77386),
(77387, '3.30.710.10-FF-000114', NULL, 'potassium channel regulatory protein', 103, NULL, NULL, 77387),
(77388, '1.10.510.10-FF-003281', NULL, NULL, 99, NULL, NULL, 77388),
(77389, '3.40.50.300-FF-002829', NULL, 'Uncharacterized protein', 149, NULL, NULL, 77389),
(77390, '3.40.50.2000-FF-000382', NULL, 'Protein CBR-BUS-8', 171, NULL, NULL, 77390),
(77391, '3.30.160.60-FF-004976', NULL, NULL, 52, NULL, NULL, 77391),
(77392, '2.10.310.10-FF-000002', NULL, 'Serin peptidase inhibitor, clade A (Alpha-1 antiproteinase, antitrypsin)-like', 40, NULL, NULL, 77392),
(77393, '2.30.29.30-FF-000174', NULL, 'epidermal growth factor receptor kinase substrate 8', 138, NULL, NULL, 77393),
(77394, '3.40.640.10-FF-000179', NULL, 'Aminotransferase', 385, NULL, NULL, 77394),
(77395, '3.40.50.1820-FF-000631', NULL, 'Carboxypeptidase', 466, NULL, NULL, 77395),
(77396, '3.40.50.2000-FF-000702', NULL, 'DUF3492 domain-containing protein', 178, NULL, NULL, 77396),
(77397, '2.60.120.260-FF-000098', NULL, 'Netrin-A, isoform B', 281, NULL, NULL, 77397),
(77398, '3.30.428.10-FF-000047', NULL, 'Probable HIT family protein', 145, NULL, NULL, 77398),
(77399, '1.25.40.20-FF-001229', NULL, 'Ankyrin repeat and KH domain-containing 1', 71, NULL, NULL, 77399),
(77400, '2.40.50.140-FF-000065', NULL, 'Single-stranded DNA-binding protein', 145, NULL, NULL, 77400),
(77401, '3.30.160.60-FF-002885', NULL, 'Uncharacterized protein', 46, NULL, NULL, 77401),
(77402, '3.60.10.10-FF-000273', NULL, 'Inositol 5-phosphatase', 396, NULL, NULL, 77402),
(77403, '3.30.70.1730-FF-000056', NULL, '60S acidic ribosomal protein P0', 98, NULL, NULL, 77403),
(77404, '2.40.30.170-FF-000036', NULL, 'Resistance-Nodulation-Cell Division (RND) multidrug efflux membrane fusion protein MexC', 80, NULL, NULL, 77404),
(77405, '3.10.10.10-FF-000028', NULL, NULL, 79, NULL, NULL, 77405),
(77406, '1.20.1560.10-FF-000318', NULL, 'Multidrug ABC transporter ATPase', 320, NULL, NULL, 77406),
(77407, '3.30.200.20-FF-000836', NULL, 'NEK protein kinase', 48, NULL, NULL, 77407),
(77408, '2.40.50.140-FF-000593', NULL, 'Protein OSB1 mitochondrial', 106, NULL, NULL, 77408),
(77409, '3.50.50.60-FF-000678', NULL, 'Amine oxidase', 231, NULL, NULL, 77409),
(77410, '3.30.230.10-FF-000335', NULL, 'Uncharacterized protein', 65, NULL, NULL, 77410),
(77411, '3.30.40.10-FF-000523', NULL, 'RING finger protein 5', 78, NULL, NULL, 77411),
(77412, '3.40.910.10-FF-000020', NULL, 'Probable deoxyhypusine synthase', 322, NULL, NULL, 77412),
(77413, '4.10.60.10-FF-000057', NULL, 'Uncharacterized protein, isoform A', 47, NULL, NULL, 77413),
(77414, '1.10.510.10-FF-001454', NULL, 'Protein kinase domain containing protein', 201, NULL, NULL, 77414),
(77415, '3.80.10.10-FF-002352', NULL, 'Receptor like protein 28', 251, NULL, NULL, 77415),
(77416, '3.40.850.10-FF-000397', NULL, 'Kinesin-like protein', 285, NULL, NULL, 77416),
(77417, '1.25.10.10-FF-003169', NULL, 'Predicted protein', 340, NULL, NULL, 77417),
(77418, '1.20.1250.20-FF-000747', NULL, 'MFS transporter', 168, NULL, NULL, 77418),
(77419, '1.25.10.10-FF-002854', NULL, 'Uncharacterized protein', 168, NULL, NULL, 77419);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(77420, '2.130.10.10-FF-004712', NULL, 'Inner dynein arm I1 intermediate chain IC138', 170, NULL, NULL, 77420),
(77421, '3.90.199.10-FF-000017', NULL, NULL, 135, NULL, NULL, 77421),
(77422, '3.40.50.11060-FF-000002', NULL, 'GTP binding protein 6 (putative)', 127, NULL, NULL, 77422),
(77423, '1.20.1560.10-FF-000026', NULL, 'Multidrug resistance-associated protein lethal(2)03659', 329, NULL, NULL, 77423),
(77424, '3.30.450.20-FF-000321', NULL, 'Methyl-accepting chemotaxis protein', 82, NULL, NULL, 77424),
(77425, '3.50.50.60-FF-000734', NULL, 'FAD-dependent pyridine nucleotide-disulphide oxidoreductase', 140, NULL, NULL, 77425),
(77426, '1.25.10.10-FF-003225', NULL, 'Protein SERAC1', 261, NULL, NULL, 77426),
(77427, '2.40.50.140-FF-000711', NULL, NULL, 108, NULL, NULL, 77427),
(77428, '2.30.29.30-FF-000264', NULL, 'Potential exocyst complex component Exo84', 129, NULL, NULL, 77428),
(77429, '3.80.10.10-FF-002880', NULL, 'Uncharacterized protein', 63, NULL, NULL, 77429),
(77430, '3.30.40.10-FF-001799', NULL, 'Predicted protein', 120, NULL, NULL, 77430),
(77431, '1.25.40.710-FF-000010', NULL, 'Uncharacterized protein', 240, NULL, NULL, 77431),
(77432, '1.25.40.10-FF-002356', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 108, NULL, NULL, 77432),
(77433, '3.40.220.10-FF-000041', NULL, 'Transcription factor bHLH140', 98, NULL, NULL, 77433),
(77434, '3.90.980.10-FF-000002', NULL, 'DNA primase', 137, NULL, NULL, 77434),
(77435, '1.20.1560.10-FF-000521', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 309, NULL, NULL, 77435),
(77436, '1.10.3810.10-FF-000009', NULL, 'Penicillin-binding protein 1B', 184, NULL, NULL, 77436),
(77437, '2.130.10.10-FF-004656', NULL, 'Uncharacterized protein', 188, NULL, NULL, 77437),
(77438, '3.50.50.60-FF-000881', NULL, 'Uncharacterized protein', 360, NULL, NULL, 77438),
(77439, '3.80.10.10-FF-002700', NULL, 'Predicted protein', 65, NULL, NULL, 77439),
(77440, '3.30.70.20-FF-000028', NULL, 'Electron transport protein hydN', 67, NULL, NULL, 77440),
(77441, '1.10.238.10-FF-000388', NULL, 'Phosphoinositide phospholipase C', 79, NULL, NULL, 77441),
(77442, '2.130.10.10-FF-004892', NULL, 'Uncharacterized protein', 319, NULL, NULL, 77442),
(77443, '1.10.1530.10-FF-000004', NULL, 'Ureidoglycolate dehydrogenase', 79, NULL, NULL, 77443),
(77444, '3.30.710.10-FF-000086', NULL, 'Ankyrin repeat and FYVE domain-containing 1', 158, NULL, NULL, 77444),
(77445, '1.25.40.20-FF-000892', NULL, 'Uncharacterized protein', 182, NULL, NULL, 77445),
(77446, '1.20.1070.10-FF-001579', NULL, 'Uncharacterized protein', 159, NULL, NULL, 77446),
(77447, '3.40.50.10190-FF-000027', NULL, 'DNA ligase', 105, NULL, NULL, 77447),
(77448, '1.20.1270.60-FF-000002', NULL, 'Formin-binding protein 1-like isoform 1', 300, NULL, NULL, 77448),
(77449, '2.60.120.10-FF-000206', NULL, 'Blood vessel epicardial substance', 138, NULL, NULL, 77449),
(77450, '1.10.238.10-FF-001085', NULL, 'Fimbrin, putative', 97, NULL, NULL, 77450),
(77451, '3.60.21.70-FF-000001', NULL, 'Alkaline phosphatase D', 395, NULL, NULL, 77451),
(77452, '1.25.10.10-FF-001224', NULL, 'AP complex subunit beta', 570, NULL, NULL, 77452),
(77453, '1.10.150.50-FF-000145', NULL, 'GH09064p', 67, NULL, NULL, 77453),
(77454, '3.40.50.1820-FF-000721', NULL, 'Carboxylic ester hydrolase', 217, NULL, NULL, 77454),
(77455, '2.20.100.10-FF-000181', NULL, 'Protein CBR-MIG-6', 66, NULL, NULL, 77455),
(77456, '2.130.10.10-FF-004364', NULL, 'UV-damaged DNA binding complex subunit 2 protein', 88, NULL, NULL, 77456),
(77457, '2.30.40.10-FF-000003', NULL, 'Guanine deaminase', 118, NULL, NULL, 77457),
(77458, '2.60.40.2020-FF-000002', NULL, 'Inhibitor of cysteine proteases', 78, NULL, NULL, 77458),
(77459, '4.10.240.10-FF-000224', NULL, 'Uncharacterized transcriptional regulatory protein C1F7.11c', 83, NULL, NULL, 77459),
(77460, '1.50.10.10-FF-000143', NULL, 'Glycogen debranching enzyme-related protein (4-alpha-glucanotransferase)', 290, NULL, NULL, 77460),
(77461, '1.10.640.10-FF-000064', NULL, 'Uncharacterized protein', 193, NULL, NULL, 77461);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(77462, '3.30.70.920-FF-000043', NULL, 'Leucine-responsive regulatory protein [Lrp]', 78, NULL, NULL, 77462),
(77463, '3.40.50.2300-FF-000674', NULL, 'Putative Metabotropic glutamate receptor', 158, NULL, NULL, 77463),
(77464, '2.130.10.10-FF-003262', NULL, 'Periodic tryptophan protein 2-like protein', 191, NULL, NULL, 77464),
(77465, '3.30.780.10-FF-000034', NULL, 'Uncharacterized protein', 127, NULL, NULL, 77465),
(77466, '1.20.1070.10-FF-000118', NULL, 'Adhesion G protein-coupled receptor A3', 262, NULL, NULL, 77466),
(77467, '2.40.30.70-FF-000008', NULL, 'tRNA (N6-threonylcarbamoyladenosine(37)-N6)-methyltransferase TrmO', 136, NULL, NULL, 77467),
(77468, '3.30.230.130-FF-000039', NULL, 'Os03g0786800 protein', 71, NULL, NULL, 77468),
(77469, '3.40.190.10-FF-000548', NULL, 'AGAP010411-PA', 79, NULL, NULL, 77469),
(77470, '2.60.40.10-FF-000024', NULL, 'Tenascin-X', 98, NULL, NULL, 77470),
(77471, '2.20.100.10-FF-000118', NULL, 'No long nerve cord, isoform D', 58, NULL, NULL, 77471),
(77472, '2.60.40.150-FF-000696', NULL, 'Predicted protein', 156, NULL, NULL, 77472),
(77473, '1.25.40.280-FF-000021', NULL, 'pH-response regulator protein palA/rim20', 347, NULL, NULL, 77473),
(77474, '3.90.1170.50-FF-000002', NULL, 'Xanthine dehydrogenase/oxidase', 93, NULL, NULL, 77474),
(77475, '2.60.40.60-FF-001118', NULL, 'Predicted protein', 106, NULL, NULL, 77475),
(77476, '3.40.50.2300-FF-000348', NULL, 'Response regulator receiver domain protein', 136, NULL, NULL, 77476),
(77477, '1.20.1440.100-FF-000010', NULL, 'Phosphoserine phosphatase', 74, NULL, NULL, 77477),
(77478, '3.40.50.150-FF-001430', NULL, NULL, 150, NULL, NULL, 77478),
(77479, '3.90.640.10-FF-000246', NULL, 'AGR099Cp', 15, NULL, NULL, 77479),
(77480, '3.40.50.1220-FF-000018', NULL, 'Pyruvate decarboxylase isozyme', 164, NULL, NULL, 77480),
(77481, '3.90.380.10-FF-000001', NULL, '3-phenylpropionate/cinnamic acid dioxygenase subunit alpha', 287, NULL, NULL, 77481),
(77482, '3.40.640.10-FF-000269', NULL, 'Capreomycidine synthase', 216, NULL, NULL, 77482),
(77483, '2.60.120.430-FF-000025', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 143, NULL, NULL, 77483),
(77484, '3.40.50.1820-FF-000075', NULL, 'Carboxypeptidase', 427, NULL, NULL, 77484),
(77485, '1.25.10.10-FF-001371', NULL, 'WGS project CABT00000000 data, contig 2.9', 1172, NULL, NULL, 77485),
(77486, '3.90.70.10-FF-000298', NULL, 'Ubiquitin carboxyl-terminal hydrolase 13', 95, NULL, NULL, 77486),
(77487, '1.20.1560.10-FF-000700', NULL, 'Uncharacterized protein', 330, NULL, NULL, 77487),
(77488, '3.40.50.2000-FF-000028', NULL, 'Glycogen [starch] synthase', 308, NULL, NULL, 77488),
(77489, '2.40.50.730-FF-000028', NULL, 'Uncharacterized protein', 51, NULL, NULL, 77489),
(77490, '2.130.10.10-FF-004566', NULL, 'ACR190Cp', 214, NULL, NULL, 77490),
(77491, '2.40.70.10-FF-000454', NULL, NULL, 120, NULL, NULL, 77491),
(77492, '3.90.1150.10-FF-000449', NULL, 'Predicted protein', 147, NULL, NULL, 77492),
(77493, '1.10.630.10-FF-000092', NULL, 'Cytochrome P450 CYP727A4', 493, NULL, NULL, 77493),
(77494, '1.20.58.1480-FF-000023', NULL, 'Lon protease homolog, mitochondrial', 132, NULL, NULL, 77494),
(77495, '3.20.20.300-FF-000063', NULL, NULL, 331, NULL, NULL, 77495),
(77496, '3.40.1010.20-FF-000004', NULL, '4-hydroxy-3-methylbut-2-enyl diphosphate reductase', 92, NULL, NULL, 77496),
(77497, '3.40.50.1000-FF-000211', NULL, 'Plasma membrane ATPase', 163, NULL, NULL, 77497),
(77498, '1.20.120.850-FF-000037', NULL, 'DNA-dependent ATPase', 82, NULL, NULL, 77498),
(77499, '3.30.160.60-FF-003902', NULL, NULL, 36, NULL, NULL, 77499),
(77500, '3.30.420.40-FF-000825', NULL, 'ADL253Cp', 32, NULL, NULL, 77500),
(77501, '1.25.40.80-FF-000005', NULL, 'Deoxyribodipyrimidine photo-lyase', 120, NULL, NULL, 77501),
(77502, '1.20.120.1200-FF-000026', NULL, 'NADH dehydrogenase subunit J', 149, NULL, NULL, 77502),
(77503, '1.10.760.10-FF-000039', NULL, 'Thiosulfate dehydrogenase', 130, NULL, NULL, 77503),
(77504, '2.60.450.10-FF-000023', NULL, 'Uncharacterized protein', 140, NULL, NULL, 77504);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(77505, '1.25.40.70-FF-000002', NULL, 'Phosphatidylinositol 4-kinase, catalytic, alpha', 167, NULL, NULL, 77505),
(77506, '3.40.50.1820-FF-000103', NULL, 'Abhydrolase domain-containing 15', 279, NULL, NULL, 77506),
(77507, '3.30.200.20-FF-002074', NULL, 'Uncharacterized protein', 84, NULL, NULL, 77507),
(77508, '3.50.50.60-FF-001044', NULL, 'Guanosine nucleotide diphosphate dissociation inhibitor 2', 32, NULL, NULL, 77508),
(77509, '3.40.50.2000-FF-000646', NULL, 'UDP-glycosyltransferase 85A7', 94, NULL, NULL, 77509),
(77510, '3.30.40.230-FF-000004', NULL, 'Glycine--tRNA ligase', 61, NULL, NULL, 77510),
(77511, '1.10.20.10-FF-000376', NULL, NULL, 68, NULL, NULL, 77511),
(77512, '1.10.510.10-FF-001364', NULL, 'Meiosis-specific serine/threonine protein kinase MEK1, putative', 308, NULL, NULL, 77512),
(77513, '2.130.10.10-FF-005055', NULL, 'CDT (S. pombe CDC10 Dependent Transcript) homolog', 278, NULL, NULL, 77513),
(77514, '1.25.40.20-FF-001757', NULL, 'YALI0E32791p', 196, NULL, NULL, 77514),
(77515, '3.40.50.1010-FF-000214', NULL, NULL, 139, NULL, NULL, 77515),
(77516, '3.30.60.90-FF-000003', NULL, 'E1A binding protein p300', 53, NULL, NULL, 77516),
(77517, '3.40.50.300-FF-001492', NULL, 'ABC transporter ATP-binding protein/permease', 243, NULL, NULL, 77517),
(77518, '3.50.50.60-FF-000408', NULL, 'Guanosine nucleotide diphosphate dissociation inhibitor', 128, NULL, NULL, 77518),
(77519, '1.10.287.70-FF-000226', NULL, 'pH-gated potassium channel KcsA', 53, NULL, NULL, 77519),
(77520, '1.20.1250.20-FF-001349', NULL, 'Uncharacterized protein', 204, NULL, NULL, 77520),
(77521, '1.10.1660.10-FF-000008', NULL, 'Heat shock transcriptional regulator', 95, NULL, NULL, 77521),
(77522, '3.30.200.20-FF-001146', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 1', 109, NULL, NULL, 77522),
(77523, '1.20.1560.10-FF-000644', NULL, 'Predicted protein', 147, NULL, NULL, 77523),
(77524, '2.160.20.10-FF-000226', NULL, 'Predicted protein', 264, NULL, NULL, 77524),
(77525, '3.30.200.20-FF-002422', NULL, 'Predicted protein', 80, NULL, NULL, 77525),
(77526, '2.60.40.420-FF-000120', NULL, 'Uncharacterized protein', 140, NULL, NULL, 77526),
(77527, '3.30.160.60-FF-001429', NULL, 'neurotrophin receptor-interacting factor homolog', 30, NULL, NULL, 77527),
(77528, '3.30.1010.10-FF-000094', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', 155, NULL, NULL, 77528),
(77529, '1.10.150.20-FF-000159', NULL, 'DNA polymerase lambda subunit', 59, NULL, NULL, 77529),
(77530, '1.10.510.10-FF-001128', NULL, 'CRE-SEK-1 protein', 203, NULL, NULL, 77530),
(77531, '1.25.10.10-FF-000909', NULL, 'Hypothetical_protein_-_conserved', 586, NULL, NULL, 77531),
(77532, '1.20.1510.10-FF-000080', NULL, NULL, 174, NULL, NULL, 77532),
(77533, '2.60.40.10-FF-001126', NULL, 'Anti-myosin immunoglobulin heavy chain variable region', 119, NULL, NULL, 77533),
(77534, '1.10.238.10-FF-001231', NULL, 'Uncharacterized protein', 105, NULL, NULL, 77534),
(77535, '2.30.30.100-FF-000091', NULL, 'Enhancer of mRNA-decapping protein 3', 66, NULL, NULL, 77535),
(77536, '3.40.50.80-FF-000207', NULL, 'Uncharacterized protein', 140, NULL, NULL, 77536),
(77537, '1.10.10.60-FF-000839', NULL, NULL, 74, NULL, NULL, 77537),
(77538, '3.30.160.60-FF-004835', NULL, NULL, 26, NULL, NULL, 77538),
(77539, '1.25.40.180-FF-000137', NULL, 'MIF4G domain containing protein', 187, NULL, NULL, 77539),
(77540, '3.40.850.10-FF-000425', NULL, 'Uncharacterized protein', 168, NULL, NULL, 77540),
(77541, '2.30.30.140-FF-000170', NULL, 'DNA (cytosine-5-)-methyltransferase 3 beta, duplicate a', 70, NULL, NULL, 77541),
(77542, '1.10.150.810-FF-000011', NULL, 'Uncharacterized protein', 69, NULL, NULL, 77542),
(77543, '1.25.40.10-FF-002682', NULL, 'Uncharacterized protein', 161, NULL, NULL, 77543),
(77544, '3.30.160.20-FF-000248', NULL, 'Double-stranded RNA-specific editase Adar-like Protein', 93, NULL, NULL, 77544),
(77545, '1.20.1250.20-FF-000663', NULL, 'Solute carrier organic anion transporter family member', 394, NULL, NULL, 77545),
(77546, '3.80.10.10-FF-002026', NULL, 'Predicted protein', 297, NULL, NULL, 77546);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(77547, '1.10.3060.10-FF-000013', NULL, 'Protein translocase subunit SecA 2', 208, NULL, NULL, 77547),
(77548, '4.10.1060.10-FF-000050', NULL, 'RAN binding protein 2', 39, NULL, NULL, 77548),
(77549, '3.40.50.720-FF-000426', NULL, 'Aldehyde reductase 2', 336, NULL, NULL, 77549),
(77550, '3.40.50.720-FF-001909', NULL, 'UDP-galactopyranose mutase', 166, NULL, NULL, 77550),
(77551, '2.60.40.150-FF-000814', NULL, 'Uncharacterized protein', 127, NULL, NULL, 77551),
(77552, '2.60.120.290-FF-000202', NULL, 'Uncharacterized protein', 125, NULL, NULL, 77552),
(77553, '2.30.140.10-FF-000012', NULL, 'Spermidine synthase', 61, NULL, NULL, 77553),
(77554, '1.25.40.90-FF-000070', NULL, 'Putative mrna cleavage and polyadenylation factor i/ii complex subunit pcf11', 55, NULL, NULL, 77554),
(77555, '2.20.100.10-FF-000034', NULL, 'Spondin-1', 54, NULL, NULL, 77555),
(77556, '3.30.420.230-FF-000005', NULL, 'Uncharacterized protein', 62, NULL, NULL, 77556),
(77557, '2.10.60.10-FF-000022', NULL, 'Receptor protein serine/threonine kinase', 42, NULL, NULL, 77557),
(77558, '2.60.40.2310-FF-000004', NULL, 'Subtilisin-like protease SBT3', 134, NULL, NULL, 77558),
(77559, '3.30.1370.10-FF-000143', NULL, 'Partner of Nob1', 95, NULL, NULL, 77559),
(77560, '1.25.10.10-FF-001308', NULL, 'Uncharacterized protein', 852, NULL, NULL, 77560),
(77561, '3.40.640.10-FF-000325', NULL, 'Alanine aminotransferase, putative', 251, NULL, NULL, 77561),
(77562, '4.10.1000.10-FF-000007', NULL, 'Zinc finger CCCH domain-containing protein 6', 65, NULL, NULL, 77562),
(77563, '2.60.40.10-FF-000873', NULL, 'Muscle M-line assembly protein unc-89', 74, NULL, NULL, 77563),
(77564, '3.40.50.1820-FF-001379', NULL, 'Uncharacterized protein', 222, NULL, NULL, 77564),
(77565, '3.30.2350.10-FF-000057', NULL, 'RNA pseudouridine synthase 1', 216, NULL, NULL, 77565),
(77566, '3.10.180.10-FF-000049', NULL, 'Catechol 2,3-dioxygenase', 129, NULL, NULL, 77566),
(77567, '3.10.450.40-FF-000051', NULL, NULL, 78, NULL, NULL, 77567),
(77568, '2.10.25.10-FF-000093', NULL, 'Very low-density lipoprotein receptor', 45, NULL, NULL, 77568),
(77569, '3.40.47.10-FF-000235', NULL, NULL, 64, NULL, NULL, 77569),
(77570, '3.40.50.170-FF-000042', NULL, 'Os08g0501132 protein', 162, NULL, NULL, 77570),
(77571, '3.40.50.150-FF-001514', NULL, NULL, 110, NULL, NULL, 77571),
(77572, '1.20.58.60-FF-000820', NULL, 'Beta-spectrin', 183, NULL, NULL, 77572),
(77573, '2.30.42.10-FF-000311', NULL, 'Protein MET1, chloroplastic', 67, NULL, NULL, 77573),
(77574, '2.60.40.10-FF-002587', NULL, 'AGAP005471-PA', 101, NULL, NULL, 77574),
(77575, '1.10.1580.10-FF-000007', NULL, 'Mitochondrial GTPase 1', 89, NULL, NULL, 77575),
(77576, '3.40.50.80-FF-000117', NULL, 'Ferric reductase like transmembrane component-domain-containing protein', 136, NULL, NULL, 77576),
(77577, '3.30.70.330-FF-002378', NULL, NULL, 101, NULL, NULL, 77577),
(77578, '3.40.50.300-FF-001525', NULL, 'Rho-related GTP-binding protein RhoV', 159, NULL, NULL, 77578),
(77579, '1.10.287.110-FF-000357', NULL, 'Uncharacterized protein', 111, NULL, NULL, 77579),
(77580, '3.10.350.10-FF-000091', NULL, 'Predicted protein', 56, NULL, NULL, 77580),
(77581, '3.40.850.10-FF-000515', NULL, 'Uncharacterized protein', 278, NULL, NULL, 77581),
(77582, '3.40.190.10-FF-000874', NULL, 'Uncharacterized protein', 59, NULL, NULL, 77582),
(77583, '1.25.40.10-FF-001052', NULL, 'Anaphase-promoting complex subunit CDC27', 104, NULL, NULL, 77583),
(77584, '2.30.29.30-FF-000320', NULL, 'Diacylglycerol kinase', 111, NULL, NULL, 77584),
(77585, '1.10.238.10-FF-000865', NULL, 'Uncharacterized protein', 94, NULL, NULL, 77585),
(77586, '3.30.160.60-FF-005145', NULL, NULL, 30, NULL, NULL, 77586),
(77587, '1.10.30.20-FF-000003', NULL, 'ATP-dependent DNA helicase', 60, NULL, NULL, 77587),
(77588, '6.10.140.2220-FF-000041', NULL, 'Uncharacterized protein', 75, NULL, NULL, 77588),
(77589, '1.25.10.10-FF-000876', NULL, 'RING-type E3 ubiquitin transferase', 172, NULL, NULL, 77589),
(77590, '3.40.50.1360-FF-000066', NULL, 'Uncharacterized protein', 84, NULL, NULL, 77590);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(77591, '3.40.50.300-FF-005235', NULL, 'SD05444p2', 198, NULL, NULL, 77591),
(77592, '2.20.28.30-FF-000003', NULL, 'DNA-directed RNA polymerases I, II, and III subunit RPABC4', 50, NULL, NULL, 77592),
(77593, '1.25.40.20-FF-001055', NULL, 'Kinase, NEK', 191, NULL, NULL, 77593),
(77594, '1.20.1420.10-FF-000011', NULL, 'Rhea, isoform B', 164, NULL, NULL, 77594),
(77595, '1.10.510.10-FF-000875', NULL, 'Serine/threonine protein kinase', 234, NULL, NULL, 77595),
(77596, '3.50.50.60-FF-000555', NULL, 'D-amino-acid oxidase', 154, NULL, NULL, 77596),
(77597, '3.40.630.10-FF-000268', NULL, 'Uncharacterized protein', 290, NULL, NULL, 77597),
(77598, '3.30.70.330-FF-000607', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 82, NULL, NULL, 77598),
(77599, '3.30.450.20-FF-000405', NULL, 'Sensory box histidine kinase', 117, NULL, NULL, 77599),
(77600, '3.20.140.10-FF-000027', NULL, 'Nicotinate phosphoribosyltransferase', 38, NULL, NULL, 77600),
(77601, '2.170.140.10-FF-000030', NULL, 'Uncharacterized protein', 59, NULL, NULL, 77601),
(77602, '3.60.20.10-FF-000184', NULL, NULL, 231, NULL, NULL, 77602),
(77603, '2.30.36.70-FF-000016', NULL, 'SWI/SNF nucleosome remodeling complex component', 53, NULL, NULL, 77603),
(77604, '1.20.1050.130-FF-000032', NULL, 'Elongation factor 1-beta', 69, NULL, NULL, 77604),
(77605, '2.60.120.200-FF-000248', NULL, 'Chondroitin sulfate proteoglycan 4', 173, NULL, NULL, 77605),
(77606, '3.40.50.2000-FF-000556', NULL, 'Related to alpha-1,3-mannosyltransferase alg2', 240, NULL, NULL, 77606),
(77607, '2.30.29.30-FF-000590', NULL, 'Protein CBG20227', 87, NULL, NULL, 77607),
(77608, '3.40.50.300-FF-004746', NULL, 'Helicase, putative', 86, NULL, NULL, 77608),
(77609, '2.70.50.40-FF-000016', NULL, 'Uncharacterized protein', 95, NULL, NULL, 77609),
(77610, '2.70.20.10-FF-000028', NULL, 'DNA topoisomerase', 141, NULL, NULL, 77610),
(77611, '3.55.50.30-FF-000007', NULL, 'DUF4974 domain-containing protein', 77, NULL, NULL, 77611),
(77612, '1.10.510.10-FF-001280', NULL, 'Myosin light chain kinase, putative', 206, NULL, NULL, 77612),
(77613, '1.10.10.10-FF-000965', NULL, 'Transcriptional regulator, LuxR family', 65, NULL, NULL, 77613),
(77614, '3.30.2410.10-FF-000023', NULL, 'E3 ubiquitin-protein ligase', 86, NULL, NULL, 77614),
(77615, '3.40.50.150-FF-000789', NULL, 'CcbJ', 192, NULL, NULL, 77615),
(77616, '3.40.50.300-FF-003296', NULL, 'ABC family transporter', 262, NULL, NULL, 77616),
(77617, '3.40.50.2300-FF-000707', NULL, 'Os06g0190800 protein', 100, NULL, NULL, 77617),
(77618, '2.170.200.10-FF-000001', NULL, 'Regulatory protein E2', 105, NULL, NULL, 77618),
(77619, '3.30.50.10-FF-000136', NULL, 'Uncharacterized protein', 111, NULL, NULL, 77619),
(77620, '1.10.287.610-FF-000001', NULL, '30S ribosomal protein S2', 50, NULL, NULL, 77620),
(77621, '2.60.40.10-FF-004616', NULL, NULL, 104, NULL, NULL, 77621),
(77622, '3.30.1330.90-FF-000001', NULL, 'L-serine ammonia-lyase 1', 148, NULL, NULL, 77622),
(77623, '2.60.40.420-FF-000266', NULL, 'Uncharacterized protein', 144, NULL, NULL, 77623),
(77624, '3.30.505.10-FF-000188', NULL, NULL, 124, NULL, NULL, 77624),
(77625, '1.10.10.60-FF-000929', NULL, NULL, 42, NULL, NULL, 77625),
(77626, '1.25.40.20-FF-001139', NULL, 'Serine/threonine-protein kinase NEK', 156, NULL, NULL, 77626),
(77627, '3.40.50.300-FF-004398', NULL, 'Primosomal protein DnaI', 195, NULL, NULL, 77627),
(77628, '3.40.50.720-FF-000752', NULL, 'L-threonine 3-dehydrogenase, mitochondrial', 232, NULL, NULL, 77628),
(77629, '3.30.450.30-FF-000088', NULL, 'Uncharacterized protein', 67, NULL, NULL, 77629),
(77630, '1.10.630.10-FF-000294', NULL, 'Uncharacterized protein', 58, NULL, NULL, 77630),
(77631, '1.20.120.310-FF-000016', NULL, NULL, 117, NULL, NULL, 77631),
(77632, '1.20.140.10-FF-000102', NULL, 'Acyl-CoA dehydrogenase, putative', 161, NULL, NULL, 77632),
(77633, '3.30.710.10-FF-000445', NULL, 'Uncharacterized protein', 155, NULL, NULL, 77633),
(77634, '1.20.1080.10-FF-000057', NULL, 'Aquaporin', 229, NULL, NULL, 77634),
(77635, '2.40.420.20-FF-000006', NULL, 'RND family efflux transporter MFP subunit', 78, NULL, NULL, 77635);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(77636, '3.30.70.330-FF-000580', NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', 132, NULL, NULL, 77636),
(77637, '2.30.110.10-FF-000100', NULL, 'Oxidoreductase, putative', 166, NULL, NULL, 77637),
(77638, '3.10.20.90-FF-000569', NULL, 'Putative serine/threonine-protein kinase WNK5', 88, NULL, NULL, 77638),
(77639, '1.20.1070.10-FF-000562', NULL, '5-hydroxytryptamine receptor', 349, NULL, NULL, 77639),
(77640, '1.20.1250.20-FF-002372', NULL, 'Proton-dependent oligopeptide transport (POT) family protein', 276, NULL, NULL, 77640),
(77641, '3.80.10.10-FF-003987', NULL, 'Uncharacterized protein', 157, NULL, NULL, 77641),
(77642, '2.10.25.10-FF-001582', NULL, 'Delta-like protein', 53, NULL, NULL, 77642),
(77643, '1.10.10.10-FF-000437', NULL, 'Penicillinase repressor BlaI', 64, NULL, NULL, 77643),
(77644, '2.120.10.30-FF-000621', NULL, 'NHL repeat-containing protein 2', 61, NULL, NULL, 77644),
(77645, '3.40.228.10-FF-000013', NULL, 'NADH-quinone oxidoreductase subunit G', 86, NULL, NULL, 77645),
(77646, '1.20.58.60-FF-000443', NULL, 'Spectrin beta, non-erythrocytic 5', 107, NULL, NULL, 77646),
(77647, '2.60.120.260-FF-000570', NULL, 'Uncharacterized protein', 224, NULL, NULL, 77647),
(77648, '3.80.10.10-FF-001857', NULL, 'Putative surface antigen protein', 109, NULL, NULL, 77648),
(77649, '3.15.20.10-FF-000001', NULL, 'Phospholipid transfer protein', 268, NULL, NULL, 77649),
(77650, '3.30.1330.60-FF-000043', NULL, 'Uncharacterized protein', 103, NULL, NULL, 77650),
(77651, '1.10.10.60-FF-001008', NULL, NULL, 48, NULL, NULL, 77651),
(77652, '1.25.40.20-FF-001673', NULL, 'Uncharacterized protein', 81, NULL, NULL, 77652),
(77653, '3.40.50.1820-FF-001738', NULL, 'ABHD14A-ACY1 readthrough', 78, NULL, NULL, 77653),
(77654, '3.30.200.20-FF-000477', NULL, 'Cyclin dependent kinase C, putative', 107, NULL, NULL, 77654),
(77655, '3.10.450.320-FF-000009', NULL, 'Mitochondrial import inner membrane translocase subunit TIM21', 120, NULL, NULL, 77655),
(77656, '2.60.120.10-FF-000032', NULL, 'Mannose-1-phosphate guanylyltransferase/mannose-6-phosphate isomerase', 118, NULL, NULL, 77656),
(77657, '3.30.160.60-FF-005139', NULL, NULL, 28, NULL, NULL, 77657),
(77658, '3.30.1370.10-FF-000087', NULL, 'KH domain containing 3 like, subcortical maternal complex member', 121, NULL, NULL, 77658),
(77659, '3.90.550.10-FF-000537', NULL, 'Mannose-1-phosphate guanylyltransferase/mannose-6-phosphate isomerase', 336, NULL, NULL, 77659),
(77660, '3.20.20.100-FF-000065', NULL, 'Aryl-alcohol dehydrogenase', 122, NULL, NULL, 77660),
(77661, '3.40.50.1820-FF-000159', NULL, 'Chlorophyllase-2, chloroplastic', 290, NULL, NULL, 77661),
(77662, '3.90.660.10-FF-000129', NULL, NULL, 69, NULL, NULL, 77662),
(77663, '1.10.555.10-FF-000225', NULL, NULL, 144, NULL, NULL, 77663),
(77664, '1.10.840.10-FF-000012', NULL, 'Ral guanine nucleotide dissociation stimulator-like 2', 300, NULL, NULL, 77664),
(77665, '3.10.20.410-FF-000002', NULL, 'Outer membrane usher protein FimD', 130, NULL, NULL, 77665),
(77666, '2.60.40.10-FF-005223', NULL, NULL, 90, NULL, NULL, 77666),
(77667, '1.25.40.10-FF-003227', NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', 59, NULL, NULL, 77667),
(77668, '2.130.10.10-FF-003436', NULL, 'WD repeat-containing protein 66-like Protein', 155, NULL, NULL, 77668),
(77669, '1.20.1090.10-FF-000029', NULL, 'Iron-containing alcohol dehydrogenase', 201, NULL, NULL, 77669),
(77670, '2.130.10.10-FF-001306', NULL, 'CCR4-associated factor 4', 229, NULL, NULL, 77670),
(77671, '3.40.50.2300-FF-000764', NULL, 'Predicted protein', 149, NULL, NULL, 77671),
(77672, '1.25.40.20-FF-001196', NULL, 'Uncharacterized protein', 108, NULL, NULL, 77672),
(77673, '1.10.3720.10-FF-000098', NULL, 'Amino acid ABC transporter permease', 210, NULL, NULL, 77673),
(77674, '2.40.50.770-FF-000017', NULL, 'Uncharacterized protein', 181, NULL, NULL, 77674),
(77675, '3.40.5.10-FF-000015', NULL, 'Uncharacterized protein', 61, NULL, NULL, 77675),
(77676, '2.30.30.40-FF-000101', NULL, 'Rho GTPase activating protein 9', 69, NULL, NULL, 77676);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(77677, '3.40.50.300-FF-002745', NULL, 'ABC transporter ATP-binding protein', 255, NULL, NULL, 77677),
(77678, '1.25.40.10-FF-001193', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 134, NULL, NULL, 77678),
(77679, '3.40.640.10-FF-000095', NULL, '8-amino-7-oxononanoate synthase', 228, NULL, NULL, 77679),
(77680, '3.30.160.60-FF-005471', NULL, NULL, 61, NULL, NULL, 77680),
(77681, '2.60.110.10-FF-000003', NULL, 'Thaumatin I', 205, NULL, NULL, 77681),
(77682, '1.20.1250.20-FF-001967', NULL, 'Uncharacterized protein', 411, NULL, NULL, 77682),
(77683, '1.20.1070.10-FF-001809', NULL, 'Uncharacterized protein', 313, NULL, NULL, 77683),
(77684, '3.90.245.10-FF-000013', NULL, 'Inosine-adenosine-guanosine-nucleoside hydrolase', 327, NULL, NULL, 77684),
(77685, '3.30.160.60-FF-005616', NULL, NULL, 30, NULL, NULL, 77685),
(77686, '1.25.40.10-FF-001136', NULL, 'Putative pentatricopeptide repeat-containing protein', 121, NULL, NULL, 77686),
(77687, '1.10.10.60-FF-001121', NULL, NULL, 64, NULL, NULL, 77687),
(77688, '2.40.50.140-FF-000913', NULL, 'Single-stranded DNA-binding protein', 117, NULL, NULL, 77688),
(77689, '2.60.40.10-FF-001328', NULL, 'titin isoform X1', 96, NULL, NULL, 77689),
(77690, '3.90.190.10-FF-000610', NULL, 'Protein-tyrosine-phosphatase', 129, NULL, NULL, 77690),
(77691, '1.10.238.10-FF-000949', NULL, 'Ryanodine receptor 44F (inferred by orthology to a D. melanogaster protein)', 89, NULL, NULL, 77691),
(77692, '1.10.300.10-FF-000011', NULL, 'Adenylosuccinate synthetase', 104, NULL, NULL, 77692),
(77693, '1.20.1250.20-FF-001765', NULL, 'Monocarboxylate transporter 9-like Protein', 190, NULL, NULL, 77693),
(77694, '2.130.10.10-FF-005201', NULL, 'Uncharacterized protein', 102, NULL, NULL, 77694),
(77695, '3.30.710.10-FF-000030', NULL, 'Ankyrin repeat and BTB/POZ domain-containing protein BTBD11', 115, NULL, NULL, 77695),
(77696, '3.55.50.10-FF-000001', NULL, 'Actin cross-linking toxin VgrG1', 92, NULL, NULL, 77696),
(77697, '1.20.140.10-FF-000046', NULL, 'Acyl-CoA dehydrogenase FadE16', 145, NULL, NULL, 77697),
(77698, '3.90.226.10-FF-000267', NULL, 'Predicted protein', 185, NULL, NULL, 77698),
(77699, '2.40.100.10-FF-000165', NULL, 'Uncharacterized protein', 63, NULL, NULL, 77699),
(77700, '3.30.870.10-FF-000187', NULL, 'Uncharacterized protein', 126, NULL, NULL, 77700),
(77701, '3.30.160.60-FF-003582', NULL, NULL, 36, NULL, NULL, 77701),
(77702, '1.10.1140.10-FF-000008', NULL, 'V-type proton ATPase catalytic subunit A', 158, NULL, NULL, 77702),
(77703, '2.60.40.10-FF-003458', NULL, NULL, 101, NULL, NULL, 77703),
(77704, '3.40.50.1820-FF-001851', NULL, 'Uncharacterized protein', 64, NULL, NULL, 77704),
(77705, '3.30.1490.80-FF-000009', NULL, 'Glutathione synthetase', 74, NULL, NULL, 77705),
(77706, '3.30.720.50-FF-000020', NULL, NULL, 90, NULL, NULL, 77706),
(77707, '3.30.1490.70-FF-000006', NULL, 'DNA ligase', 82, NULL, NULL, 77707),
(77708, '1.10.1060.10-FF-000007', NULL, 'Dihydropyrimidine dehydrogenase [NADP(+)]', 157, NULL, NULL, 77708),
(77709, '1.20.1310.20-FF-000011', NULL, 'Erythrocyte binding antigen-181', 193, NULL, NULL, 77709),
(77710, '2.30.180.10-FF-000189', NULL, NULL, 109, NULL, NULL, 77710),
(77711, '3.40.1440.60-FF-000009', NULL, 'Primosomal protein N''', 114, NULL, NULL, 77711),
(77712, '3.40.50.410-FF-000125', NULL, 'von Willebrand factor, type A', 186, NULL, NULL, 77712),
(77713, '3.10.580.10-FF-000220', NULL, 'Uncharacterized protein', 112, NULL, NULL, 77713),
(77714, '2.60.40.10-FF-001660', NULL, 'Neuromusculin, isoform E', 115, NULL, NULL, 77714),
(77715, '1.10.132.60-FF-000039', NULL, 'DNA polymerase', 152, NULL, NULL, 77715),
(77716, '3.40.50.970-FF-000214', NULL, 'Protein CBG00293', 109, NULL, NULL, 77716),
(77717, '3.40.50.2000-FF-000472', NULL, 'Glycosyltransferase', 44, NULL, NULL, 77717),
(77718, '3.40.50.1010-FF-000220', NULL, NULL, 122, NULL, NULL, 77718),
(77719, '1.10.238.10-FF-001028', NULL, 'Calcium-binding protein 2', 62, NULL, NULL, 77719),
(77720, '1.10.510.10-FF-001656', NULL, 'serine/threonine receptor-like kinase NFP', 116, NULL, NULL, 77720);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(77721, '2.60.40.10-FF-003312', NULL, 'Neural cell adhesion molecule 3', 86, NULL, NULL, 77721),
(77722, '3.30.200.20-FF-001202', NULL, 'Predicted protein', 102, NULL, NULL, 77722),
(77723, '1.10.555.10-FF-000023', NULL, 'Arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 1', 192, NULL, NULL, 77723),
(77724, '1.25.40.10-FF-002446', NULL, 'Putative pentatricopeptide repeat-containing protein At3g18840', 94, NULL, NULL, 77724),
(77725, '2.130.10.10-FF-005347', NULL, 'Uncharacterized protein', 179, NULL, NULL, 77725),
(77726, '2.40.160.90-FF-000001', NULL, 'Transferrin-binding protein 2', 154, NULL, NULL, 77726),
(77727, '3.60.40.10-FF-000218', NULL, 'Protein phosphatase type 2c', 281, NULL, NULL, 77727),
(77728, '3.40.50.1010-FF-000040', NULL, 'DNA repair protein complementing XP-G cells', 139, NULL, NULL, 77728),
(77729, '1.10.287.70-FF-000642', NULL, 'Uncharacterized protein', 183, NULL, NULL, 77729),
(77730, '3.30.200.20-FF-002366', NULL, 'Os10g0129466 protein', 96, NULL, NULL, 77730),
(77731, '3.30.70.330-FF-000523', NULL, 'Pre-mRNA splicing factor (Prp24), putative', 81, NULL, NULL, 77731),
(77732, '3.50.50.60-FF-000824', NULL, '1-hydroxycarotenoid 3,4-desaturase', 119, NULL, NULL, 77732),
(77733, '1.20.1250.20-FF-000129', NULL, 'Major Facilitator Superfamily (MFS)', 476, NULL, NULL, 77733),
(77734, '1.10.10.60-FF-000194', NULL, 'Zinc fingers and homeoboxes protein 3', 68, NULL, NULL, 77734),
(77735, '2.30.29.30-FF-000825', NULL, 'SH2B adapter protein 2', 128, NULL, NULL, 77735),
(77736, '3.90.550.50-FF-000178', NULL, 'Hexosyltransferase', 236, NULL, NULL, 77736),
(77737, '1.25.40.10-FF-002974', NULL, 'Uncharacterized protein', 122, NULL, NULL, 77737),
(77738, '3.30.160.60-FF-004829', NULL, NULL, 59, NULL, NULL, 77738),
(77739, '1.20.1070.10-FF-001866', NULL, 'Predicted protein', 294, NULL, NULL, 77739),
(77740, '3.60.20.10-FF-000043', NULL, 'Glutamate synthase 1 [NADH] chloroplastic', 440, NULL, NULL, 77740),
(77741, '3.40.50.1820-FF-001795', NULL, '1-acylglycerol-3-phosphate O-acyltransferase ABHD5-like Protein', 151, NULL, NULL, 77741),
(77742, '3.30.70.141-FF-000035', NULL, NULL, 202, NULL, NULL, 77742),
(77743, '1.20.58.1880-FF-000019', NULL, 'Uncharacterized protein, isoform G', 128, NULL, NULL, 77743),
(77744, '3.40.50.80-FF-000090', NULL, 'Methionine synthase reductase', 163, NULL, NULL, 77744),
(77745, '1.10.150.20-FF-000215', NULL, 'Fanconi anemia core complex-associated protein 24', 68, NULL, NULL, 77745),
(77746, '3.30.980.10-FF-000015', NULL, 'Threonine--tRNA ligase', 98, NULL, NULL, 77746),
(77747, '2.60.40.10-FF-005931', NULL, NULL, 103, NULL, NULL, 77747),
(77748, '3.40.50.80-FF-000033', NULL, 'Sulfite reductase (NADPH) flavoprotein alpha-component', 159, NULL, NULL, 77748),
(77749, '1.20.920.10-FF-000201', NULL, 'Bromo and FHA domain-containing protein DDB_G0267958', 128, NULL, NULL, 77749),
(77750, '1.20.1290.10-FF-000016', NULL, 'Predicted protein', 154, NULL, NULL, 77750),
(77751, '1.10.510.10-FF-001600', NULL, 'Uncharacterized protein OSJNBa0042F15.6', 204, NULL, NULL, 77751),
(77752, '1.10.10.60-FF-001065', NULL, NULL, 51, NULL, NULL, 77752),
(77753, '2.40.50.1020-FF-000004', NULL, 'DNA-binding response regulator', 107, NULL, NULL, 77753),
(77754, '3.40.50.2300-FF-000820', NULL, NULL, 136, NULL, NULL, 77754),
(77755, '1.20.120.1240-FF-000015', NULL, 'Dynamin-2A', 208, NULL, NULL, 77755),
(77756, '3.40.350.10-FF-000084', NULL, 'X-Pro aminopeptidase', 170, NULL, NULL, 77756),
(77757, '1.20.80.10-FF-000008', NULL, 'FERM domain containing 4A', 112, NULL, NULL, 77757),
(77758, '3.40.33.10-FF-000001', NULL, 'Cysteine-rich secretory protein LCCL domain containing 1', 199, NULL, NULL, 77758),
(77759, '2.40.70.10-FF-000538', NULL, NULL, 190, NULL, NULL, 77759),
(77760, '3.30.559.70-FF-000009', NULL, 'Carnitine O-palmitoyltransferase 2', 270, NULL, NULL, 77760),
(77761, '1.25.10.10-FF-001601', NULL, 'Uncharacterized protein', 571, NULL, NULL, 77761),
(77762, '1.10.575.10-FF-000024', NULL, 'Uncharacterized protein', 103, NULL, NULL, 77762),
(77763, '1.20.1050.10-FF-000235', NULL, 'Uncharacterized protein', 84, NULL, NULL, 77763);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(77764, '1.10.8.60-FF-000243', NULL, 'ATPase AAA family protein', 66, NULL, NULL, 77764),
(77765, '1.10.1670.10-FF-000037', NULL, NULL, 77, NULL, NULL, 77765),
(77766, '3.40.1410.10-FF-000015', NULL, 'GntR family transcriptional regulator', 155, NULL, NULL, 77766),
(77767, '3.40.50.720-FF-002135', NULL, 'Uncharacterized protein', 100, NULL, NULL, 77767),
(77768, '2.130.10.10-FF-001076', NULL, 'Syntaxin-binding protein 5 isoform A', 250, NULL, NULL, 77768),
(77769, '3.30.160.60-FF-000558', NULL, 'zinc finger protein 513 isoform X2', 28, NULL, NULL, 77769),
(77770, '2.130.10.10-FF-001019', NULL, 'NACHT and WD repeat domain containing 1', 232, NULL, NULL, 77770),
(77771, '3.30.70.330-FF-003103', NULL, NULL, 137, NULL, NULL, 77771),
(77772, '2.40.160.50-FF-000040', NULL, 'Uncharacterized protein', 318, NULL, NULL, 77772),
(77773, '1.25.40.10-FF-000883', NULL, 'Pentatricopeptide repeat-containing protein', 91, NULL, NULL, 77773),
(77774, '2.130.10.30-FF-000160', NULL, NULL, 123, NULL, NULL, 77774),
(77775, '3.40.190.10-FF-000458', NULL, 'Transcriptional regulator, LysR family', 99, NULL, NULL, 77775),
(77776, '1.25.40.10-FF-004099', NULL, 'Os01g0301500 protein', 145, NULL, NULL, 77776),
(77777, '2.40.50.140-FF-001262', NULL, NULL, 45, NULL, NULL, 77777),
(77778, '3.30.40.10-FF-002294', NULL, 'Protein CBG19351', 35, NULL, NULL, 77778),
(77779, '1.20.1250.20-FF-000186', NULL, 'monocarboxylate transporter 14 isoform X1', 390, NULL, NULL, 77779),
(77780, '3.40.50.2300-FF-001130', NULL, NULL, 26, NULL, NULL, 77780),
(77781, '3.40.50.11610-FF-000009', NULL, '2-oxoglutarate dehydrogenase E1 component', 141, NULL, NULL, 77781),
(77782, '3.30.200.20-FF-002309', NULL, 'Uncharacterized protein', 62, NULL, NULL, 77782),
(77783, '3.10.430.100-FF-000018', NULL, 'Ribosomal protein L9', 82, NULL, NULL, 77783),
(77784, '3.40.390.10-FF-000204', NULL, NULL, 186, NULL, NULL, 77784),
(77785, '1.10.510.10-FF-000673', NULL, 'CAMK family protein kinase', 299, NULL, NULL, 77785),
(77786, '2.30.42.10-FF-000603', NULL, NULL, 99, NULL, NULL, 77786),
(77787, '3.40.50.720-FF-000044', NULL, 'UDP-glucuronic acid decarboxylase 1', 186, NULL, NULL, 77787),
(77788, '3.30.70.330-FF-002176', NULL, NULL, 82, NULL, NULL, 77788),
(77789, '2.60.20.10-FF-000023', NULL, NULL, 62, NULL, NULL, 77789),
(77790, '3.30.200.20-FF-000275', NULL, 'Apoptosis associated tyrosine kinase', 105, NULL, NULL, 77790),
(77791, '3.10.129.10-FF-000273', NULL, 'Mesaconyl-C(4)-CoA hydratase', 122, NULL, NULL, 77791),
(77792, '3.30.930.10-FF-000012', NULL, 'Proline--tRNA ligase', 240, NULL, NULL, 77792),
(77793, '3.40.47.10-FF-000089', NULL, 'Putative polyketide beta-ketoacyl synthase 2', 146, NULL, NULL, 77793),
(77794, '3.50.50.60-FF-000263', NULL, 'Zeaxanthin epoxidase, chloroplastic', 371, NULL, NULL, 77794),
(77795, '3.40.50.150-FF-000210', NULL, 'tRNA (guanine(37)-N1)-methyltransferase', 202, NULL, NULL, 77795),
(77796, '1.20.1270.10-FF-000072', NULL, 'Protein CBG00051', 112, NULL, NULL, 77796),
(77797, '1.25.40.10-FF-002917', NULL, 'Protein O-mannosyl-transferase TMTC1', 323, NULL, NULL, 77797),
(77798, '3.40.50.20-FF-000094', NULL, 'Uncharacterized protein', 50, NULL, NULL, 77798),
(77799, '3.40.850.10-FF-000341', NULL, 'Kinesin-like protein', 66, NULL, NULL, 77799),
(77800, '3.90.1150.10-FF-000455', NULL, 'Aspartate aminotransferase', 134, NULL, NULL, 77800),
(77801, '3.30.160.60-FF-001165', NULL, 'telomere zinc finger-associated protein isoform X1', 26, NULL, NULL, 77801),
(77802, '3.40.50.300-FF-001109', NULL, 'ATP-dependent RNA helicase suv3, mitochondrial', 152, NULL, NULL, 77802),
(77803, '3.30.750.24-FF-000158', NULL, 'AGR213Cp', 160, NULL, NULL, 77803),
(77804, '3.40.50.300-FF-001166', NULL, 'ADP-ribosylation factor D', 174, NULL, NULL, 77804),
(77805, '1.10.132.30-FF-000030', NULL, 'Uncharacterized protein', 41, NULL, NULL, 77805),
(77806, '3.30.70.330-FF-003013', NULL, NULL, 74, NULL, NULL, 77806),
(77807, '1.10.287.470-FF-000032', NULL, 'Cation efflux system protein', 60, NULL, NULL, 77807),
(77808, '1.10.510.10-FF-001510', NULL, 'Receptor-type guanylate cyclase daf-11', 284, NULL, NULL, 77808);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(77809, '3.30.160.60-FF-001873', NULL, 'Zinc finger and BTB domain-containing protein 6', 75, NULL, NULL, 77809),
(77810, '1.20.1250.10-FF-000126', NULL, NULL, 122, NULL, NULL, 77810),
(77811, '3.40.190.10-FF-000835', NULL, 'Uncharacterized protein', 114, NULL, NULL, 77811),
(77812, '1.20.1070.10-FF-002119', NULL, 'Uncharacterized protein', 107, NULL, NULL, 77812),
(77813, '1.20.120.160-FF-000044', NULL, 'Receptor-like histidine kinase BpdS', 123, NULL, NULL, 77813),
(77814, '1.25.40.20-FF-000886', NULL, 'Uncharacterized protein', 224, NULL, NULL, 77814),
(77815, '3.20.20.100-FF-000121', NULL, 'Uncharacterized protein', 159, NULL, NULL, 77815),
(77816, '1.10.472.10-FF-000454', NULL, 'Predicted protein', 114, NULL, NULL, 77816),
(77817, '2.60.40.10-FF-004386', NULL, NULL, 95, NULL, NULL, 77817),
(77818, '1.10.10.10-FF-001421', NULL, 'Heat-inducible transcription repressor HrcA', 86, NULL, NULL, 77818),
(77819, '3.30.70.850-FF-000027', NULL, 'Predicted protein', 50, NULL, NULL, 77819),
(77820, '3.40.50.1000-FF-000537', NULL, NULL, 119, NULL, NULL, 77820),
(77821, '3.30.70.330-FF-002940', NULL, NULL, 159, NULL, NULL, 77821),
(77822, '1.20.1250.20-FF-000219', NULL, 'major facilitator superfamily domain-containing protein 12 isoform X3', 221, NULL, NULL, 77822),
(77823, '2.130.10.10-FF-002565', NULL, 'Signal transducer', 223, NULL, NULL, 77823),
(77824, '3.60.60.10-FF-000017', NULL, 'Uncharacterized protein', 173, NULL, NULL, 77824),
(77825, '3.30.300.30-FF-000134', NULL, 'Nonribosomal peptide synthase nlsA', 107, NULL, NULL, 77825),
(77826, '3.40.50.300-FF-007511', NULL, 'Putative type III restriction-modification system, R subunit', 217, NULL, NULL, 77826),
(77827, '1.20.58.90-FF-000042', NULL, NULL, 47, NULL, NULL, 77827),
(77828, '1.25.40.10-FF-001900', NULL, 'protein NRDE2 homolog isoform X1', 99, NULL, NULL, 77828),
(77829, '1.10.490.10-FF-000029', NULL, 'Adenylate cyclase-like protein', 135, NULL, NULL, 77829),
(77830, '1.10.287.70-FF-000024', NULL, 'Inositol 1,4,5-trisphosphate receptor type 3', 127, NULL, NULL, 77830),
(77831, '1.20.5.170-FF-000166', NULL, 'Activating transcription factor-2', 57, NULL, NULL, 77831),
(77832, '1.10.287.80-FF-000027', NULL, 'Lysine-specific histone demethylase 1A isoform b', 40, NULL, NULL, 77832),
(77833, '1.20.142.10-FF-000028', NULL, 'Poly [ADP-ribose] polymerase', 66, NULL, NULL, 77833),
(77834, '3.40.50.970-FF-000068', NULL, '2-succinyl-5-enolpyruvyl-6-hydroxy-3-cyclohexene-1-carboxylate synthase', 204, NULL, NULL, 77834),
(77835, '3.30.160.60-FF-002559', NULL, 'Zinc finger protein 175', 46, NULL, NULL, 77835),
(77836, '2.120.10.30-FF-000149', NULL, 'NHL repeat-containing protein', 207, NULL, NULL, 77836),
(77837, '1.10.730.10-FF-000094', NULL, 'Leucine--tRNA ligase', 236, NULL, NULL, 77837),
(77838, '1.10.10.10-FF-001218', NULL, 'Two-component response regulator YvcP', 110, NULL, NULL, 77838),
(77839, '2.30.230.10-FF-000042', NULL, 'Vitellogenin 1', 95, NULL, NULL, 77839),
(77840, '2.30.29.30-FF-000735', NULL, 'Uncharacterized protein', 134, NULL, NULL, 77840),
(77841, '3.20.20.140-FF-000380', NULL, 'Uncharacterized protein', 192, NULL, NULL, 77841),
(77842, '2.130.10.10-FF-000002', NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', 391, NULL, NULL, 77842),
(77843, '1.20.1280.290-FF-000041', NULL, 'Uncharacterized protein, isoform F', 91, NULL, NULL, 77843),
(77844, '2.60.40.10-FF-003930', NULL, NULL, 106, NULL, NULL, 77844),
(77845, '1.10.630.10-FF-000327', NULL, 'Cytochrome P450', 462, NULL, NULL, 77845),
(77846, '1.10.287.920-FF-000010', NULL, 'Uncharacterized protein', 80, NULL, NULL, 77846),
(77847, '3.40.50.670-FF-000006', NULL, 'DNA topoisomerase (ATP-hydrolyzing)', 228, NULL, NULL, 77847),
(77848, '1.10.287.380-FF-000005', NULL, 'ABC transporter ATP-binding protein uup', 78, NULL, NULL, 77848),
(77849, '2.60.120.200-FF-000535', NULL, 'Uncharacterized protein', 232, NULL, NULL, 77849),
(77850, '1.10.287.370-FF-000002', NULL, 'Prefoldin subunit 2', 108, NULL, NULL, 77850),
(77851, '3.30.40.10-FF-000815', NULL, 'Histone H3-K36 demethylase', 73, NULL, NULL, 77851);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(77852, '1.20.120.1750-FF-000168', NULL, 'RBR-type E3 ubiquitin transferase', 99, NULL, NULL, 77852),
(77853, '1.25.10.10-FF-002618', NULL, 'Uncharacterized protein', 134, NULL, NULL, 77853),
(77854, '3.90.228.20-FF-000022', NULL, NULL, 100, NULL, NULL, 77854),
(77855, '3.30.70.960-FF-000004', NULL, 'Transmembrane serine protease 6', 103, NULL, NULL, 77855),
(77856, '1.25.10.10-FF-002860', NULL, 'Uncharacterized protein', 507, NULL, NULL, 77856),
(77857, '2.30.30.190-FF-000044', NULL, NULL, 100, NULL, NULL, 77857),
(77858, '3.40.190.80-FF-000018', NULL, 'Inositol-1-monophosphatase', 124, NULL, NULL, 77858),
(77859, '1.10.287.70-FF-000171', NULL, 'Ionotropic receptor 21a', 124, NULL, NULL, 77859),
(77860, '2.10.110.10-FF-000144', NULL, 'Protein CBR-ZYX-1', 58, NULL, NULL, 77860),
(77861, '1.10.287.70-FF-000081', NULL, 'inward rectifier potassium channel 13 isoform X1', 134, NULL, NULL, 77861),
(77862, '3.30.760.10-FF-000033', NULL, 'Eukaryotic initiation factor 4E family protein', 171, NULL, NULL, 77862),
(77863, '3.30.230.10-FF-000004', NULL, '40S ribosomal protein S2', 94, NULL, NULL, 77863),
(77864, '3.40.50.300-FF-001727', NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily A containing DEAD/H box', 92, NULL, NULL, 77864),
(77865, '2.30.42.10-FF-000367', NULL, 'Glutamate receptor-interacting protein 2a', 52, NULL, NULL, 77865),
(77866, '3.20.20.80-FF-000251', NULL, 'Uncharacterized protein', 352, NULL, NULL, 77866),
(77867, '3.30.70.330-FF-001304', NULL, 'Os06g0248200 protein', 102, NULL, NULL, 77867),
(77868, '1.50.10.10-FF-000227', NULL, 'Glycogen debranching enzyme-related protein', 218, NULL, NULL, 77868),
(77869, '2.130.10.30-FF-000008', NULL, 'regulator of chromosome condensation isoform X1', 401, NULL, NULL, 77869),
(77870, '3.80.10.10-FF-000553', NULL, 'Platelet glycoprotein IX', 122, NULL, NULL, 77870),
(77871, '1.20.5.170-FF-000109', NULL, 'ATF (cAMP-dependent transcription factor) family', 74, NULL, NULL, 77871),
(77872, '1.20.1050.10-FF-000055', NULL, 'Glutathione S-transferase', 117, NULL, NULL, 77872),
(77873, '3.40.50.150-FF-001284', NULL, NULL, 220, NULL, NULL, 77873),
(77874, '1.25.10.10-FF-002528', NULL, 'WAPL (Wings apart-like protein regulation of heterochromatin) protein', 189, NULL, NULL, 77874),
(77875, '3.40.50.720-FF-002045', NULL, 'UBA/THIF-type NAD/FAD binding protein', 179, NULL, NULL, 77875),
(77876, '3.90.180.10-FF-000020', NULL, 'Crotonyl-CoA reductase', 91, NULL, NULL, 77876),
(77877, '3.30.1370.50-FF-000014', NULL, 'Poly(A)-specific ribonuclease PARN', 76, NULL, NULL, 77877),
(77878, '2.30.110.10-FF-000010', NULL, 'Pyridoxine phosphate oxidase', 203, NULL, NULL, 77878),
(77879, '3.30.540.30-FF-000005', NULL, 'Nudix hydrolase 3', 182, NULL, NULL, 77879),
(77880, '1.25.40.20-FF-001903', NULL, 'Uncharacterized protein', 101, NULL, NULL, 77880),
(77881, '1.20.58.60-FF-000819', NULL, 'Uncharacterized protein', 183, NULL, NULL, 77881),
(77882, '1.10.10.750-FF-000008', NULL, 'TBC1 domain family member 9', 47, NULL, NULL, 77882),
(77883, '2.60.120.780-FF-000017', NULL, 'Uncharacterized protein', 130, NULL, NULL, 77883),
(77884, '1.20.1530.20-FF-000084', NULL, 'Uncharacterized protein', 324, NULL, NULL, 77884),
(77885, '3.40.50.300-FF-003526', NULL, 'GTPase Der', 161, NULL, NULL, 77885),
(77886, '3.30.70.2150-FF-000002', NULL, 'Chitin-binding protein CbpD', 104, NULL, NULL, 77886),
(77887, '1.10.510.10-FF-002584', NULL, NULL, 219, NULL, NULL, 77887),
(77888, '2.40.50.140-FF-000391', NULL, 'Single-stranded DNA-binding protein', 110, NULL, NULL, 77888),
(77889, '1.20.990.10-FF-000003', NULL, 'NADPH--cytochrome P450 reductase', 134, NULL, NULL, 77889),
(77890, '3.80.10.10-FF-004206', NULL, 'Predicted protein', 266, NULL, NULL, 77890),
(77891, '3.30.497.10-FF-000027', NULL, 'Putative serpin-Z6A', 164, NULL, NULL, 77891),
(77892, '3.90.190.10-FF-000464', NULL, 'Uncharacterized protein', 194, NULL, NULL, 77892),
(77893, '1.20.1740.10-FF-000271', NULL, 'Uncharacterized protein', 224, NULL, NULL, 77893),
(77894, '3.30.40.10-FF-000725', NULL, 'E3 ubiquitin-protein ligase ATL41', 100, NULL, NULL, 77894);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(77895, '1.10.287.130-FF-000222', NULL, 'Hybrid signal transduction histidine kinase C', 72, NULL, NULL, 77895),
(77896, '1.10.287.2620-FF-000009', NULL, 'Dynein Heavy Chain', 65, NULL, NULL, 77896),
(77897, '1.25.40.660-FF-000011', NULL, 'Vacuolar protein sorting-associated protein 35', 46, NULL, NULL, 77897),
(77898, '2.120.10.30-FF-000059', NULL, 'E3 ubiquitin-protein ligase NHLRC1', 210, NULL, NULL, 77898),
(77899, '2.60.120.620-FF-000110', NULL, 'Procollagen-lysine, 2-oxoglutarate 5-dioxygenase, putative', 172, NULL, NULL, 77899),
(77900, '3.40.50.1440-FF-000085', NULL, 'Tubulin gamma chain', 266, NULL, NULL, 77900),
(77901, '1.10.287.2610-FF-000006', NULL, 'Predicted protein', 93, NULL, NULL, 77901),
(77902, '2.40.50.140-FF-000149', NULL, 'Replication protein A 32 kDa subunit', 131, NULL, NULL, 77902),
(77903, '1.25.10.10-FF-003170', NULL, 'Uncharacterized protein', 335, NULL, NULL, 77903),
(77904, '3.30.70.330-FF-002850', NULL, NULL, 83, NULL, NULL, 77904),
(77905, '3.30.450.20-FF-000175', NULL, 'Hypoxia-inducible factor 1', 147, NULL, NULL, 77905),
(77906, '3.20.70.20-FF-000023', NULL, 'Ribonucleoside-triphosphate reductase, adenosylcobalamin-dependent', 317, NULL, NULL, 77906),
(77907, '1.10.565.10-FF-000052', NULL, 'Ultraspiracle nuclear receptor', 226, NULL, NULL, 77907),
(77908, '2.70.98.90-FF-000012', NULL, 'Membrane protein insertase YidC', 270, NULL, NULL, 77908),
(77909, '3.30.70.560-FF-000007', NULL, '2-amino-4-hydroxy-6-hydroxymethyldihydropteridine pyrophosphokinase', 152, NULL, NULL, 77909),
(77910, '3.40.50.150-FF-001845', NULL, NULL, 47, NULL, NULL, 77910),
(77911, '2.60.120.650-FF-000119', NULL, 'Uncharacterized protein', 117, NULL, NULL, 77911),
(77912, '3.40.50.300-FF-006399', NULL, 'Midasin, putative', 133, NULL, NULL, 77912),
(77913, '3.30.70.330-FF-002322', NULL, NULL, 170, NULL, NULL, 77913),
(77914, '3.90.70.10-FF-000011', NULL, 'Ubiquitinyl hydrolase 1', 355, NULL, NULL, 77914),
(77915, '1.25.40.10-FF-004773', NULL, 'Predicted protein', 201, NULL, NULL, 77915),
(77916, '3.90.640.10-FF-000044', NULL, 'Actin-related protein 9', 100, NULL, NULL, 77916),
(77917, '1.10.730.10-FF-000184', NULL, 'AER043Cp', 19, NULL, NULL, 77917),
(77918, '3.30.710.10-FF-000406', NULL, 'Rho related BTB domain containing 3', 124, NULL, NULL, 77918),
(77919, '2.60.120.200-FF-000720', NULL, 'Uncharacterized protein', 248, NULL, NULL, 77919),
(77920, '2.60.40.10-FF-001480', NULL, 'Erythrocyte membrane protein band 4.2', 113, NULL, NULL, 77920),
(77921, '1.20.1070.10-FF-000505', NULL, 'Vomeronasal type-1 receptor', 316, NULL, NULL, 77921),
(77922, '3.40.50.300-FF-003616', NULL, 'Signal recognition particle receptor', 218, NULL, NULL, 77922),
(77923, '1.10.472.80-FF-000014', NULL, 'GTPase-activating protein gyp7 isoform X1', 146, NULL, NULL, 77923),
(77924, '2.170.140.10-FF-000029', NULL, 'Probable endochitinase', 60, NULL, NULL, 77924),
(77925, '3.60.10.10-FF-000071', NULL, 'type I inositol polyphosphate 5-phosphatase 4 isoform X1', 113, NULL, NULL, 77925),
(77926, '1.25.40.530-FF-000023', NULL, 'Unconventional myosin heavy chain 6', 92, NULL, NULL, 77926),
(77927, '1.25.40.540-FF-000026', NULL, 'Uncharacterized protein', 201, NULL, NULL, 77927),
(77928, '3.30.160.60-FF-006398', NULL, NULL, 33, NULL, NULL, 77928),
(77929, '1.10.150.60-FF-000002', NULL, 'AT-rich interactive domain-containing protein 1B', 125, NULL, NULL, 77929),
(77930, '2.60.40.3440-FF-000006', NULL, 'SbsB protein', 115, NULL, NULL, 77930),
(77931, '3.20.20.100-FF-000008', NULL, 'Aldo/keto reductase family oxidoreductase', 299, NULL, NULL, 77931),
(77932, '3.80.10.10-FF-003369', NULL, 'Tubulin folding COfactor E-Like protein', 110, NULL, NULL, 77932),
(77933, '2.60.40.420-FF-000209', NULL, 'ceruloplasmin isoform X2', 97, NULL, NULL, 77933),
(77934, '3.20.20.80-FF-000195', NULL, 'Glycoside hydrolase family 25', 206, NULL, NULL, 77934),
(77935, '2.60.40.10-FF-002817', NULL, 'Hemicentin-2', 92, NULL, NULL, 77935),
(77936, '2.10.80.10-FF-000023', NULL, 'Predicted protein', 68, NULL, NULL, 77936),
(77937, '3.40.1780.10-FF-000003', NULL, 'S-adenosylmethionine:tRNA ribosyltransferase-isomerase', 188, NULL, NULL, 77937);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(77938, '1.10.437.10-FF-000030', NULL, 'ORF 16', 152, NULL, NULL, 77938),
(77939, '3.40.50.620-FF-000216', NULL, 'Leucine--tRNA ligase, putative', 196, NULL, NULL, 77939),
(77940, '3.30.160.60-FF-003054', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 35, NULL, NULL, 77940),
(77941, '3.40.630.30-FF-000280', NULL, 'Diamine acetyltransferase', 167, NULL, NULL, 77941),
(77942, '2.60.40.10-FF-002907', NULL, 'Uncharacterized protein', 103, NULL, NULL, 77942),
(77943, '2.40.50.960-FF-000007', NULL, 'Uncharacterized protein', 95, NULL, NULL, 77943),
(77944, '3.40.50.150-FF-001194', NULL, NULL, 189, NULL, NULL, 77944),
(77945, '1.20.1050.10-FF-000089', NULL, 'Glutathione S-transferase', 119, NULL, NULL, 77945),
(77946, '1.25.40.10-FF-004155', NULL, 'Uncharacterized protein', 108, NULL, NULL, 77946),
(77947, '1.25.40.10-FF-000445', NULL, 'tetratricopeptide repeat protein 21B isoform X2', 127, NULL, NULL, 77947),
(77948, '1.10.238.10-FF-000011', NULL, 'Mitochondrial Rho GTPase', 105, NULL, NULL, 77948),
(77949, '1.10.600.10-FF-000090', NULL, 'Farnesyl-diphosphate farnesyltransferase', 351, NULL, NULL, 77949),
(77950, '3.30.310.40-FF-000019', NULL, 'Uncharacterized protein', 93, NULL, NULL, 77950),
(77951, '1.50.40.10-FF-000055', NULL, 'mitochondrial ornithine transporter 1 isoform X1', 296, NULL, NULL, 77951),
(77952, '1.10.510.10-FF-000021', NULL, 'Serine/threonine protein kinase', 187, NULL, NULL, 77952),
(77953, '1.20.90.10-FF-000037', NULL, NULL, 83, NULL, NULL, 77953),
(77954, '1.20.120.520-FF-000017', NULL, 'Uncharacterized protein', 170, NULL, NULL, 77954),
(77955, '2.140.10.10-FF-000007', NULL, 'Glucose/quinate/shikimate family membrane-bound PQQ-dependent dehydrogenase', 227, NULL, NULL, 77955),
(77956, '3.30.40.10-FF-000782', NULL, 'COP1 protein', 103, NULL, NULL, 77956),
(77957, '1.20.1070.10-FF-000472', NULL, 'Protein CBG21053', 353, NULL, NULL, 77957),
(77958, '3.30.40.10-FF-000164', NULL, 'PHD finger protein 12', 87, NULL, NULL, 77958),
(77959, '1.20.1250.20-FF-000332', NULL, 'Putative transporter AraJ', 374, NULL, NULL, 77959),
(77960, '1.10.510.10-FF-003455', NULL, NULL, 275, NULL, NULL, 77960),
(77961, '3.40.50.620-FF-000306', NULL, 'Valine--tRNA ligase', 215, NULL, NULL, 77961),
(77962, '1.20.58.60-FF-000590', NULL, 'Myosin light chain kinase, smooth muscle', 209, NULL, NULL, 77962),
(77963, '1.10.238.20-FF-000014', NULL, 'Odorant-binding protein 19c', 122, NULL, NULL, 77963),
(77964, '1.10.238.10-FF-000101', NULL, 'SPARC/osteonectin, cwcv and kazal-like domains proteoglycan 2', 115, NULL, NULL, 77964),
(77965, '3.90.1410.10-FF-000077', NULL, 'MIP03820p', 297, NULL, NULL, 77965),
(77966, '2.30.42.10-FF-000457', NULL, NULL, 89, NULL, NULL, 77966),
(77967, '3.30.70.330-FF-000995', NULL, 'Putative RNA binding ribonucleoprotein', 116, NULL, NULL, 77967),
(77968, '1.25.40.420-FF-000046', NULL, 'Protein maternal effect lethal 26', 72, NULL, NULL, 77968),
(77969, '2.20.70.10-FF-000146', NULL, 'E3 ubiquitin-protein ligase', 27, NULL, NULL, 77969),
(77970, '3.20.20.380-FF-000013', NULL, 'Uncharacterized protein', 169, NULL, NULL, 77970),
(77971, '1.20.58.940-FF-000003', NULL, NULL, 70, NULL, NULL, 77971),
(77972, '3.40.30.10-FF-000848', NULL, 'Protein disulfide-isomerase', 108, NULL, NULL, 77972),
(77973, '1.25.10.10-FF-003080', NULL, 'Uncharacterized protein', 239, NULL, NULL, 77973),
(77974, '1.25.10.10-FF-003023', NULL, 'Uncharacterized protein', 323, NULL, NULL, 77974),
(77975, '3.40.50.150-FF-001137', NULL, NULL, 200, NULL, NULL, 77975),
(77976, '2.60.120.650-FF-000029', NULL, 'lysine-specific demethylase JMJ30', 234, NULL, NULL, 77976),
(77977, '1.20.1730.10-FF-000113', NULL, 'Uncharacterized protein', 166, NULL, NULL, 77977),
(77978, '3.40.50.300-FF-007326', NULL, 'Uncharacterized protein', 144, NULL, NULL, 77978),
(77979, '3.80.10.10-FF-004353', NULL, 'Leucine-rich repeat protein (LRRP), putative', 179, NULL, NULL, 77979),
(77980, '3.40.50.1820-FF-000923', NULL, 'Family with sequence similarity 135 member B', 100, NULL, NULL, 77980),
(77981, '2.60.40.1170-FF-000067', NULL, 'AP-1 adaptor complex mu subunit Apm1', 149, NULL, NULL, 77981);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(77982, '3.40.710.10-FF-000123', NULL, 'D-alanyl-D-alanine carboxypeptidase', 256, NULL, NULL, 77982),
(77983, '3.40.50.720-FF-001679', NULL, 'Short-chain dehydrogenase/reductase SDR', 268, NULL, NULL, 77983),
(77984, '1.20.1740.10-FF-000181', NULL, 'Uncharacterized protein', 320, NULL, NULL, 77984),
(77985, '1.10.8.1190-FF-000006', NULL, 'Polyprotein 1a', 112, NULL, NULL, 77985),
(77986, '2.130.10.10-FF-005999', NULL, 'Uncharacterized protein', 93, NULL, NULL, 77986),
(77987, '2.60.40.10-FF-005167', NULL, NULL, 94, NULL, NULL, 77987),
(77988, '3.40.850.10-FF-000195', NULL, 'Kinesin-like protein', 307, NULL, NULL, 77988),
(77989, '1.20.5.420-FF-000022', NULL, 'Small glutamine-rich tetratricopeptide repeat-containing protein', 66, NULL, NULL, 77989),
(77990, '3.40.1120.10-FF-000004', NULL, NULL, 98, NULL, NULL, 77990),
(77991, '3.30.70.330-FF-000287', NULL, 'Peptidyl-prolyl cis-trans isomerase', 148, NULL, NULL, 77991),
(77992, '3.40.850.10-FF-000138', NULL, 'Myosin F, putative', 170, NULL, NULL, 77992),
(77993, '3.40.1090.10-FF-000063', NULL, 'Uncharacterized NTE family protein M110.7', 96, NULL, NULL, 77993),
(77994, '3.40.390.10-FF-000058', NULL, 'Metalloendoproteinase 5-MMP', 257, NULL, NULL, 77994),
(77995, '1.25.40.10-FF-004863', NULL, 'Vacuolar protein sorting-associated protein 41', 160, NULL, NULL, 77995),
(77996, '1.25.40.10-FF-004806', NULL, 'Uncharacterized protein', 163, NULL, NULL, 77996),
(77997, '3.30.230.10-FF-000217', NULL, 'Protein CBG03843', 176, NULL, NULL, 77997),
(77998, '3.30.40.10-FF-000405', NULL, 'E3 ubiquitin-protein ligase CCNB1IP1 homolog', 53, NULL, NULL, 77998),
(77999, '3.40.50.12780-FF-000214', NULL, 'Uncharacterized protein', 67, NULL, NULL, 77999),
(78000, '3.30.1370.120-FF-000003', NULL, 'General secretion pathway protein D', 69, NULL, NULL, 78000),
(78001, '3.40.33.10-FF-000006', NULL, 'Putative pathogenesis-related protein 1', 136, NULL, NULL, 78001),
(78002, '2.60.40.10-FF-004268', NULL, NULL, 90, NULL, NULL, 78002),
(78003, '3.90.360.10-FF-000005', NULL, 'Histone acetyltransferase type B catalytic subunit', 111, NULL, NULL, 78003),
(78004, '3.40.50.300-FF-006781', NULL, 'Uncharacterized protein', 59, NULL, NULL, 78004),
(78005, '3.80.10.10-FF-004358', NULL, 'Uncharacterized protein', 176, NULL, NULL, 78005),
(78006, '3.30.1490.480-FF-000008', NULL, 'Endolytic murein transglycosylase', 74, NULL, NULL, 78006),
(78007, '3.90.1150.10-FF-000534', NULL, 'Uncharacterized protein', 47, NULL, NULL, 78007),
(78008, '3.90.190.10-FF-000256', NULL, 'mRNA capping enzyme, C-terminal domain containing protein', 209, NULL, NULL, 78008),
(78009, '3.40.309.10-FF-000128', NULL, 'Uncharacterized protein', 124, NULL, NULL, 78009),
(78010, '3.30.160.60-FF-002677', NULL, 'Zinc finger protein 1028', 27, NULL, NULL, 78010),
(78011, '3.40.1110.10-FF-000144', NULL, 'Cation-transporting ATPase', 176, NULL, NULL, 78011),
(78012, '1.20.58.390-FF-000299', NULL, 'Uncharacterized protein', 84, NULL, NULL, 78012),
(78013, '2.60.120.1020-FF-000005', NULL, 'PAW domain-containing protein Y50D4B.3', 160, NULL, NULL, 78013),
(78014, '3.50.50.60-FF-000268', NULL, 'spermine oxidase isoform X2', 259, NULL, NULL, 78014),
(78015, '1.25.40.20-FF-001437', NULL, 'Uncharacterized protein', 255, NULL, NULL, 78015),
(78016, '3.40.50.1820-FF-000362', NULL, 'Family of serine hydrolases', 222, NULL, NULL, 78016),
(78017, '3.30.70.260-FF-000182', NULL, 'p-protein (PheA)', 94, NULL, NULL, 78017),
(78018, '3.80.10.10-FF-002172', NULL, 'Sog2p', 191, NULL, NULL, 78018),
(78019, '1.20.1310.10-FF-000093', NULL, 'Cullin family protein', 114, NULL, NULL, 78019),
(78020, '2.60.120.260-FF-000367', NULL, 'Predicted protein', 116, NULL, NULL, 78020),
(78021, '3.40.190.10-FF-000335', NULL, 'Putative amino acid ABC transporter, periplasmic amino acid-binding protein', 115, NULL, NULL, 78021),
(78022, '3.100.10.10-FF-000062', NULL, NULL, 63, NULL, NULL, 78022),
(78023, '2.10.250.10-FF-000002', NULL, 'Calreticulin', 102, NULL, NULL, 78023),
(78024, '3.10.400.20-FF-000002', NULL, 'Eukaryotic translation initiation factor 2D', 185, NULL, NULL, 78024);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(78025, '1.25.10.10-FF-001932', NULL, 'Uncharacterized protein', 286, NULL, NULL, 78025),
(78026, '1.10.238.10-FF-001118', NULL, 'Uncharacterized protein', 42, NULL, NULL, 78026),
(78027, '1.25.40.10-FF-001434', NULL, 'MAU2 chromatid cohesion factor', 155, NULL, NULL, 78027),
(78028, '1.10.4160.10-FF-000010', NULL, 'Hydroxymethylpyrimidine transporter CytX', 420, NULL, NULL, 78028),
(78029, '3.30.70.330-FF-002530', NULL, NULL, 56, NULL, NULL, 78029),
(78030, '2.60.120.200-FF-000361', NULL, 'Laminin, alpha 3', 164, NULL, NULL, 78030),
(78031, '1.20.1740.10-FF-000057', NULL, 'Cystine/glutamate transporter', 441, NULL, NULL, 78031),
(78032, '1.10.940.10-FF-000019', NULL, 'Transcription antitermination protein NusB', 140, NULL, NULL, 78032),
(78033, '1.20.1250.60-FF-000006', NULL, 'Uncharacterized protein', 56, NULL, NULL, 78033),
(78034, '2.60.40.10-FF-001042', NULL, 'Protein-glutamine gamma-glutamyltransferase 2', 115, NULL, NULL, 78034),
(78035, '3.30.750.24-FF-000068', NULL, 'SULfate Permease family', 132, NULL, NULL, 78035),
(78036, '3.30.450.40-FF-000294', NULL, 'PAS sensor protein', 194, NULL, NULL, 78036),
(78037, '1.10.510.10-FF-003814', NULL, NULL, 116, NULL, NULL, 78037),
(78038, '3.40.720.10-FF-000005', NULL, 'Phosphopentomutase', 264, NULL, NULL, 78038),
(78039, '3.10.129.10-FF-000245', NULL, 'Acyl-CoA thioester hydrolase, YbgC/YbaW family in fatty acid biosynthesis locus', 135, NULL, NULL, 78039),
(78040, '3.80.10.10-FF-000143', NULL, 'PH domain leucine-rich repeat-containing protein phosphatase 2 isoform X1', 144, NULL, NULL, 78040),
(78041, '2.60.40.60-FF-000539', NULL, 'Uncharacterized protein', 98, NULL, NULL, 78041),
(78042, '2.40.30.170-FF-000042', NULL, 'RND family efflux transporter, MFP subunit', 82, NULL, NULL, 78042),
(78043, '2.60.9.10-FF-000004', NULL, 'Uncharacterized protein', 78, NULL, NULL, 78043),
(78044, '3.80.10.10-FF-004263', NULL, 'Uncharacterized protein', 62, NULL, NULL, 78044),
(78045, '2.30.30.40-FF-000186', NULL, 'Nitric oxide synthase trafficking', 73, NULL, NULL, 78045),
(78046, '1.20.1250.20-FF-000039', NULL, 'Multidrug resistance protein MdtH', 374, NULL, NULL, 78046),
(78047, '3.40.50.2300-FF-000466', NULL, 'Receptor-type adenylate cyclase GRESAG 4, putative', 117, NULL, NULL, 78047),
(78048, '3.30.200.20-FF-002282', NULL, 'Non-specific serine/threonine protein kinase', 59, NULL, NULL, 78048),
(78049, '1.25.40.20-FF-001342', NULL, 'Uncharacterized protein', 294, NULL, NULL, 78049),
(78050, '1.20.1070.10-FF-002029', NULL, 'Uncharacterized protein', 121, NULL, NULL, 78050),
(78051, '2.20.110.10-FF-000035', NULL, 'MORN repeat-containing protein 4', 62, NULL, NULL, 78051),
(78052, '3.30.1050.10-FF-000006', NULL, 'Non-specific lipid-transfer protein-like 1', 116, NULL, NULL, 78052),
(78053, '1.25.10.10-FF-000943', NULL, 'AP-3 complex subunit beta', 617, NULL, NULL, 78053),
(78054, '3.80.10.10-FF-002234', NULL, 'Uncharacterized protein', 222, NULL, NULL, 78054),
(78055, '3.30.70.270-FF-000185', NULL, NULL, 35, NULL, NULL, 78055),
(78056, '1.20.5.170-FF-000290', NULL, 'Uncharacterized protein', 38, NULL, NULL, 78056),
(78057, '1.10.3500.10-FF-000031', NULL, 'Uncharacterized protein', 173, NULL, NULL, 78057),
(78058, '3.30.1680.10-FF-000037', NULL, 'Plexin b2a', 64, NULL, NULL, 78058),
(78059, '3.30.1370.10-FF-000227', NULL, 'Far upstream element-binding protein 2', 48, NULL, NULL, 78059),
(78060, '3.30.540.10-FF-000078', NULL, 'Monophosphatase', 154, NULL, NULL, 78060),
(78061, '1.10.600.10-FF-000028', NULL, 'Dehydrosqualene synthase', 287, NULL, NULL, 78061),
(78062, '2.60.40.10-FF-005257', NULL, NULL, 87, NULL, NULL, 78062),
(78063, '3.40.50.300-FF-007770', NULL, 'Uncharacterized protein', 64, NULL, NULL, 78063),
(78064, '3.30.40.10-FF-000456', NULL, 'RING-H2 finger protein ATL16', 86, NULL, NULL, 78064),
(78065, '3.20.20.80-FF-000077', NULL, 'Arabinogalactan endo-beta-1,4-galactanase', 334, NULL, NULL, 78065),
(78066, '1.10.510.10-FF-003073', NULL, NULL, 203, NULL, NULL, 78066),
(78067, '1.10.10.60-FF-000750', NULL, 'Hybrid sensor histidine kinase/response regulator', 58, NULL, NULL, 78067);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(78068, '3.30.420.40-FF-000466', NULL, 'Actin-Related Proteins', 140, NULL, NULL, 78068),
(78069, '3.50.50.60-FF-000173', NULL, 'Putative thioredoxin reductase', 134, NULL, NULL, 78069),
(78070, '3.60.10.10-FF-000211', NULL, 'Type II inositol polyphosphate 5-phosphatase 15', 153, NULL, NULL, 78070),
(78071, '3.40.640.10-FF-000185', NULL, 'Ornithine aminotransferase', 56, NULL, NULL, 78071),
(78072, '1.10.510.10-FF-001095', NULL, 'SRPK3 isoform 3', 114, NULL, NULL, 78072),
(78073, '1.25.40.10-FF-000771', NULL, 'Pentatricopeptide repeat-containing protein', 120, NULL, NULL, 78073),
(78074, '1.10.437.10-FF-000024', NULL, 'BCL-WAV', 155, NULL, NULL, 78074),
(78075, '1.10.418.10-FF-000278', NULL, 'Plastin 1', 103, NULL, NULL, 78075),
(78076, '1.20.1070.10-FF-000264', NULL, '5-hydroxytryptamine receptor 1', 324, NULL, NULL, 78076),
(78077, '2.60.40.10-FF-003071', NULL, 'Protein sax-3', 96, NULL, NULL, 78077),
(78078, '3.40.50.2000-FF-001051', NULL, 'Uncharacterized protein', 121, NULL, NULL, 78078),
(78079, '3.60.40.10-FF-000185', NULL, 'TGF-beta-activated kinase 1 and MAP3K7-binding protein 1', 330, NULL, NULL, 78079),
(78080, '3.30.70.270-FF-000134', NULL, 'DNA polymerase kappa', 99, NULL, NULL, 78080),
(78081, '3.30.460.20-FF-000029', NULL, 'CorA family magnesium ion transporter', 141, NULL, NULL, 78081),
(78082, '3.30.70.260-FF-000131', NULL, 'Chorismate mutase/prephenate dehydratase', 87, NULL, NULL, 78082),
(78083, '3.20.20.70-FF-000074', NULL, 'Ribulose-phosphate 3-epimerase', 228, NULL, NULL, 78083),
(78084, '1.20.1270.60-FF-000120', NULL, 'YPR115W-like protein', 278, NULL, NULL, 78084),
(78085, '3.90.190.10-FF-000205', NULL, 'Uncharacterized protein', 174, NULL, NULL, 78085),
(78086, '3.40.50.800-FF-000118', NULL, 'Histidyl-tRNA synthetase, putative', 37, NULL, NULL, 78086),
(78087, '3.30.465.10-FF-000015', NULL, 'Quinone-dependent D-lactate dehydrogenase', 163, NULL, NULL, 78087),
(78088, '3.40.50.150-FF-001750', NULL, NULL, 67, NULL, NULL, 78088),
(78089, '2.40.70.10-FF-000095', NULL, 'Aspartyl protease family protein', 189, NULL, NULL, 78089),
(78090, '2.30.30.550-FF-000017', NULL, NULL, 54, NULL, NULL, 78090),
(78091, '3.20.20.20-FF-000020', NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit gamma', 335, NULL, NULL, 78091),
(78092, '1.25.40.20-FF-000240', NULL, 'Water witch, isoform D', 106, NULL, NULL, 78092),
(78093, '3.40.710.10-FF-000033', NULL, 'Beta-lactamase', 266, NULL, NULL, 78093),
(78094, '2.60.40.770-FF-000028', NULL, 'Salivary lipid interacting protein, putative', 142, NULL, NULL, 78094),
(78095, '2.60.40.60-FF-001096', NULL, 'Uncharacterized protein', 105, NULL, NULL, 78095),
(78096, '1.10.510.10-FF-000959', NULL, 'Cyclin-dependent kinase F-1', 207, NULL, NULL, 78096),
(78097, '3.40.50.720-FF-002163', NULL, 'Uncharacterized protein', 76, NULL, NULL, 78097),
(78098, '3.30.300.30-FF-000139', NULL, 'HC-toxin synthetase', 126, NULL, NULL, 78098),
(78099, '3.30.260.10-FF-000096', NULL, NULL, 66, NULL, NULL, 78099),
(78100, '3.40.190.290-FF-000063', NULL, 'Transcriptional regulator, LysR family', 203, NULL, NULL, 78100),
(78101, '1.10.630.10-FF-000209', NULL, 'Os07g0491800 protein', 163, NULL, NULL, 78101),
(78102, '1.25.40.10-FF-002862', NULL, 'At3g09490', 87, NULL, NULL, 78102),
(78103, '1.20.1280.290-FF-000075', NULL, 'YALI0D02046p', 101, NULL, NULL, 78103),
(78104, '1.25.40.10-FF-004986', NULL, 'Uncharacterized protein', 137, NULL, NULL, 78104),
(78105, '2.60.120.650-FF-000035', NULL, 'PHD transcription factor Rum1', 91, NULL, NULL, 78105),
(78106, '1.20.120.1080-FF-000130', NULL, 'Uncharacterized protein', 99, NULL, NULL, 78106),
(78107, '3.30.160.60-FF-004768', NULL, NULL, 32, NULL, NULL, 78107),
(78108, '4.10.240.10-FF-000106', NULL, 'YLL054C-like protein', 79, NULL, NULL, 78108),
(78109, '1.20.80.10-FF-000036', NULL, 'FERM domain (Protein4.1-ezrin-radixin-moesin) family', 114, NULL, NULL, 78109),
(78110, '3.20.20.30-FF-000023', NULL, 'LLM class flavin-dependent oxidoreductase', 332, NULL, NULL, 78110),
(78111, '1.25.40.20-FF-000774', NULL, 'Os11g0108600 protein', 104, NULL, NULL, 78111);
INSERT INTO "PUBLIC"."MODEL" VALUES
(78112, '1.10.275.40-FF-000016', NULL, 'Uncharacterized protein', 155, NULL, NULL, 78112),
(78113, '3.80.10.10-FF-003695', NULL, 'Predicted protein', 172, NULL, NULL, 78113),
(78114, '1.20.1720.10-FF-000062', NULL, 'L-Proline/Glycine betaine transporter ProP', 170, NULL, NULL, 78114),
(78115, '1.10.10.60-FF-000845', NULL, NULL, 64, NULL, NULL, 78115),
(78116, '3.90.1110.10-FF-000037', NULL, NULL, 41, NULL, NULL, 78116),
(78117, '1.20.58.60-FF-000207', NULL, 'Dystrophin', 189, NULL, NULL, 78117),
(78118, '3.40.47.10-FF-000027', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 2', 438, NULL, NULL, 78118),
(78119, '3.40.50.300-FF-004538', NULL, 'Java no jive', 261, NULL, NULL, 78119),
(78120, '1.10.287.580-FF-000003', NULL, NULL, 35, NULL, NULL, 78120),
(78121, '2.115.10.20-FF-000018', NULL, 'Arylsulfatase', 320, NULL, NULL, 78121),
(78122, '3.30.200.20-FF-000718', NULL, 'CMGC/CLK protein kinase', 97, NULL, NULL, 78122),
(78123, '2.60.120.1030-FF-000008', NULL, 'mRNA cleavage and polyadenylation factor CLP1', 83, NULL, NULL, 78123),
(78124, '2.130.10.10-FF-004925', NULL, 'Uncharacterized protein', 106, NULL, NULL, 78124),
(78125, '1.20.5.1150-FF-000003', NULL, 'Putative ribosomal protein S21', 38, NULL, NULL, 78125),
(78126, '1.10.287.70-FF-000406', NULL, 'TWiK family of potassium channels protein 9', 345, NULL, NULL, 78126),
(78127, '1.20.1560.10-FF-000234', NULL, 'ABC transporter putative', 316, NULL, NULL, 78127),
(78128, '3.40.710.10-FF-000128', NULL, 'Penicillin-binding protein 4B', 347, NULL, NULL, 78128),
(78129, '3.40.50.1220-FF-000070', NULL, 'Transcriptional regulator, Sir2 family protein', 130, NULL, NULL, 78129),
(78130, '3.30.70.2850-FF-000004', NULL, 'DNA-directed RNA polymerase subunit', 147, NULL, NULL, 78130),
(78131, '3.50.50.60-FF-000594', NULL, 'Amine oxidase', 429, NULL, NULL, 78131),
(78132, '1.10.472.10-FF-000336', NULL, 'Cyclin domain-containing protein, variant 2', 98, NULL, NULL, 78132),
(78133, '2.60.40.10-FF-001772', NULL, 'filamin-A isoform X9', 96, NULL, NULL, 78133),
(78134, '1.10.455.10-FF-000038', NULL, 'Uncharacterized protein', 65, NULL, NULL, 78134),
(78135, '3.60.10.10-FF-000306', NULL, 'Uncharacterized protein', 307, NULL, NULL, 78135),
(78136, '2.60.40.10-FF-005162', NULL, NULL, 94, NULL, NULL, 78136),
(78137, '3.40.50.1760-FF-000006', NULL, 'Glutathione synthetase', 126, NULL, NULL, 78137),
(78138, '3.40.50.1000-FF-000863', NULL, NULL, 38, NULL, NULL, 78138),
(78139, '1.20.1250.20-FF-000253', NULL, 'Transporter, major facilitator family', 208, NULL, NULL, 78139),
(78140, '3.30.300.30-FF-000044', NULL, 'Long-chain-fatty-acid--[acyl-carrier-protein] ligase AEE15, chloroplastic', 131, NULL, NULL, 78140),
(78141, '3.30.70.2840-FF-000001', NULL, 'Genome polyprotein', 92, NULL, NULL, 78141),
(78142, '3.40.630.10-FF-000471', NULL, 'Aspartoacylase', 68, NULL, NULL, 78142),
(78143, '3.20.20.300-FF-000029', NULL, 'Auxin-induced beta-glucosidase', 247, NULL, NULL, 78143),
(78144, '3.80.10.10-FF-002560', NULL, 'Flagellar Member 5', 136, NULL, NULL, 78144),
(78145, '3.30.9.100-FF-000002', NULL, 'Tryptophan 2-halogenase', 158, NULL, NULL, 78145),
(78146, '2.130.10.10-FF-002885', NULL, 'LLGL scribble cell polarity complex component 1', 123, NULL, NULL, 78146),
(78147, '2.20.70.10-FF-000258', NULL, 'Uncharacterized protein', 44, NULL, NULL, 78147),
(78148, '1.20.5.170-FF-000076', NULL, 'Lamin B2', 76, NULL, NULL, 78148),
(78149, '1.25.10.10-FF-000617', NULL, 'PUF1, putative', 401, NULL, NULL, 78149),
(78150, '1.10.340.30-FF-000053', NULL, 'DNA-(Apurinic or apyrimidinic site) lyase (Endonuclease III, PaNth)', 120, NULL, NULL, 78150),
(78151, '1.25.10.10-FF-003282', NULL, 'Uncharacterized protein', 188, NULL, NULL, 78151),
(78152, '3.30.70.1450-FF-000034', NULL, 'Trk system potassium uptake protein TrkA', 82, NULL, NULL, 78152),
(78153, '3.90.228.10-FF-000024', NULL, 'RBR-type E3 ubiquitin transferase', 112, NULL, NULL, 78153),
(78154, '3.40.50.150-FF-000289', NULL, 'Chemotaxis protein methyltransferase', 194, NULL, NULL, 78154),
(78155, '1.25.40.710-FF-000009', NULL, 'Predicted protein', 246, NULL, NULL, 78155);
INSERT INTO "PUBLIC"."MODEL" VALUES
(78156, '2.40.50.140-FF-000559', NULL, 'Ribonuclease E/G', 80, NULL, NULL, 78156),
(78157, '2.30.42.10-FF-000570', NULL, NULL, 121, NULL, NULL, 78157),
(78158, '3.30.559.10-FF-000284', NULL, 'Carnitine acyltransferase, putative', 16, NULL, NULL, 78158),
(78159, '2.60.40.10-FF-004594', NULL, NULL, 95, NULL, NULL, 78159),
(78160, '1.10.275.20-FF-000010', NULL, NULL, 65, NULL, NULL, 78160),
(78161, '1.20.920.10-FF-000016', NULL, 'bromodomain-containing protein 8 isoform X1', 140, NULL, NULL, 78161),
(78162, '1.20.1250.20-FF-002344', NULL, 'Uncharacterized protein', 204, NULL, NULL, 78162),
(78163, '3.40.50.11320-FF-000007', NULL, 'Carboxypeptidase', 68, NULL, NULL, 78163),
(78164, '3.30.420.10-FF-000305', NULL, 'DNA polymerase', 231, NULL, NULL, 78164),
(78165, '3.30.160.60-FF-005532', NULL, NULL, 60, NULL, NULL, 78165),
(78166, '1.25.10.10-FF-002293', NULL, 'Uncharacterized protein', 325, NULL, NULL, 78166),
(78167, '3.10.20.230-FF-000038', NULL, 'Uncharacterized protein', 40, NULL, NULL, 78167),
(78168, '1.10.10.10-FF-001134', NULL, 'Uncharacterized protein', 71, NULL, NULL, 78168),
(78169, '2.130.10.10-FF-004572', NULL, 'Uncharacterized protein', 211, NULL, NULL, 78169),
(78170, '2.130.10.10-FF-002947', NULL, 'Uncharacterized protein', 239, NULL, NULL, 78170),
(78171, '1.10.12.70-FF-000004', NULL, 'Serine/threonine-protein kinase 26', 69, NULL, NULL, 78171),
(78172, '2.130.10.10-FF-004976', NULL, 'DDB1- and CUL4-associated factor 11', 82, NULL, NULL, 78172),
(78173, '3.30.300.20-FF-000041', NULL, 'Probable transcription termination protein NusA', 68, NULL, NULL, 78173),
(78174, '1.20.5.1160-FF-000039', NULL, 'Uncharacterized protein', 24, NULL, NULL, 78174),
(78175, '3.80.10.10-FF-000194', NULL, 'Si:dkey-16p6.1', 133, NULL, NULL, 78175),
(78176, '3.30.70.1730-FF-000062', NULL, 'Uncharacterized protein', 86, NULL, NULL, 78176),
(78177, '1.25.10.10-FF-001606', NULL, 'Uncharacterized protein', 628, NULL, NULL, 78177),
(78178, '3.10.50.10-FF-000064', NULL, 'Glutamate carboxypeptidase, putative', 50, NULL, NULL, 78178),
(78179, '3.40.50.360-FF-000121', NULL, 'Methionine synthase reductase, mitochondrial-like protein', 146, NULL, NULL, 78179),
(78180, '3.30.160.60-FF-002891', NULL, 'zinc finger protein 75A-like isoform X1', 33, NULL, NULL, 78180),
(78181, '2.30.29.30-FF-001101', NULL, 'RanBP1 domain containing protein', 155, NULL, NULL, 78181),
(78182, '3.30.260.10-FF-000045', NULL, 'T-complex protein 1 subunit zeta', 104, NULL, NULL, 78182),
(78183, '1.10.287.130-FF-000166', NULL, 'Two-component sensor histidine kinase', 109, NULL, NULL, 78183),
(78184, '1.10.260.100-FF-000008', NULL, 'Protein TIC 40, chloroplastic', 62, NULL, NULL, 78184),
(78185, '3.30.1370.50-FF-000020', NULL, 'Uncharacterized protein', 82, NULL, NULL, 78185),
(78186, '2.130.10.10-FF-001750', NULL, 'WGS project CABT00000000 data, contig 2.18', 314, NULL, NULL, 78186),
(78187, '1.20.120.350-FF-000011', NULL, 'Voltage-dependent N-type calcium channel subunit alpha', 128, NULL, NULL, 78187),
(78188, '3.40.50.10880-FF-000015', NULL, NULL, 76, NULL, NULL, 78188),
(78189, '2.130.10.10-FF-005061', NULL, 'Uncharacterized protein', 274, NULL, NULL, 78189),
(78190, '3.40.50.2000-FF-000820', NULL, 'Uncharacterized protein', 46, NULL, NULL, 78190),
(78191, '1.10.12.10-FF-000014', NULL, 'Enoyl-CoA hydratase/carnithine racemase', 60, NULL, NULL, 78191),
(78192, '2.30.42.10-FF-000631', NULL, NULL, 71, NULL, NULL, 78192),
(78193, '3.40.50.11260-FF-000028', NULL, 'Putative heat shock protein HSP 90-alpha A4', 66, NULL, NULL, 78193),
(78194, '1.10.8.10-FF-000037', NULL, 'E3 ubiquitin-protein ligase CBL-B isoform B', 52, NULL, NULL, 78194),
(78195, '3.90.25.10-FF-000047', NULL, 'NmrA-like family protein', 75, NULL, NULL, 78195),
(78196, '3.40.50.10890-FF-000018', NULL, 'Cleavage and polyadenylation specificity factor 73-like Protein', 63, NULL, NULL, 78196),
(78197, '1.25.40.10-FF-001108', NULL, 'Pentatricopeptide repeat-containing protein', 209, NULL, NULL, 78197),
(78198, '1.20.920.20-FF-000019', NULL, 'Excreted/secreted protein 31', 212, NULL, NULL, 78198);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(78199, '3.40.50.1240-FF-000137', NULL, NULL, 75, NULL, NULL, 78199),
(78200, '1.10.287.70-FF-000518', NULL, 'Polycystic kidney disease and receptor for egg jelly-related protein', 136, NULL, NULL, 78200),
(78201, '3.40.50.150-FF-000968', NULL, NULL, 169, NULL, NULL, 78201),
(78202, '3.40.1800.20-FF-000003', NULL, 'D19B', 74, NULL, NULL, 78202),
(78203, '3.30.230.10-FF-000268', NULL, 'GHMP kinase domain protein', 191, NULL, NULL, 78203),
(78204, '2.70.160.11-FF-000090', NULL, 'Uncharacterized protein', 229, NULL, NULL, 78204),
(78205, '1.20.1560.10-FF-000285', NULL, 'Cadmium ion transporter', 333, NULL, NULL, 78205),
(78206, '2.60.40.10-FF-000957', NULL, 'Interferon gamma receptor 2', 96, NULL, NULL, 78206),
(78207, '3.30.1780.10-FF-000022', NULL, 'Ornithine cyclodeaminase related protein (Ocd-like2)', 126, NULL, NULL, 78207),
(78208, '3.30.200.20-FF-000769', NULL, 'Mitogen-activated protein kinase 14', 136, NULL, NULL, 78208),
(78209, '2.60.40.10-FF-001721', NULL, 'KETtiN (Drosophila actin-binding) homolog', 98, NULL, NULL, 78209),
(78210, '2.170.300.10-FF-000071', NULL, 'Uncharacterized protein', 128, NULL, NULL, 78210),
(78211, '1.10.472.10-FF-000387', NULL, 'Uncharacterized protein', 152, NULL, NULL, 78211),
(78212, '3.40.50.620-FF-000508', NULL, 'Deoxyribodipyrimidine photolyase, putative', 131, NULL, NULL, 78212),
(78213, '1.10.110.10-FF-000007', NULL, '19 kDa globulin', 91, NULL, NULL, 78213),
(78214, '3.40.50.1460-FF-000118', NULL, 'GPI-anchor transamidase', 278, NULL, NULL, 78214),
(78215, '1.20.1070.10-FF-000152', NULL, 'uracil nucleotide/cysteinyl leukotriene receptor', 290, NULL, NULL, 78215),
(78216, '2.10.110.10-FF-000138', NULL, 'Signal transducer', 59, NULL, NULL, 78216),
(78217, '3.30.465.10-FF-000127', NULL, 'Uncharacterized protein', 26, NULL, NULL, 78217),
(78218, '1.10.510.10-FF-003135', NULL, NULL, 183, NULL, NULL, 78218),
(78219, '3.40.50.1220-FF-000131', NULL, 'Uncharacterized protein', 150, NULL, NULL, 78219),
(78220, '3.40.50.300-FF-006876', NULL, 'GPN-loop GTPase 2', 248, NULL, NULL, 78220),
(78221, '1.50.10.130-FF-000022', NULL, NULL, 126, NULL, NULL, 78221),
(78222, '2.60.120.290-FF-000056', NULL, 'C-type LECtin', 112, NULL, NULL, 78222),
(78223, '1.10.630.10-FF-000535', NULL, 'Uncharacterized protein', 371, NULL, NULL, 78223),
(78224, '3.10.20.370-FF-000001', NULL, 'Retrovirus-related Pol polyprotein from transposon 17.6-like protein', 71, NULL, NULL, 78224),
(78225, '3.30.50.10-FF-000075', NULL, 'Gat3p', 42, NULL, NULL, 78225),
(78226, '3.30.1740.10-FF-000008', NULL, 'DNA ligase', 100, NULL, NULL, 78226),
(78227, '3.10.129.10-FF-000183', NULL, 'Acyl-CoA thioesterase', 126, NULL, NULL, 78227),
(78228, '2.70.40.10-FF-000024', NULL, 'Pol polyprotein', 134, NULL, NULL, 78228),
(78229, '3.40.50.800-FF-000006', NULL, 'Proline--tRNA ligase', 99, NULL, NULL, 78229),
(78230, '3.90.10.10-FF-000002', NULL, NULL, 67, NULL, NULL, 78230),
(78231, '3.50.50.60-FF-000914', NULL, 'Amine oxidase domain protein', 438, NULL, NULL, 78231),
(78232, '3.30.160.60-FF-005583', NULL, NULL, 80, NULL, NULL, 78232),
(78233, '3.40.50.300-FF-005527', NULL, 'ABC transporter I family member 21', 101, NULL, NULL, 78233),
(78234, '3.30.70.330-FF-000490', NULL, 'heterogeneous nuclear ribonucleoprotein R isoform X2', 135, NULL, NULL, 78234),
(78235, '1.10.40.90-FF-000002', NULL, 'DNA-directed RNA polymerase subunit', 45, NULL, NULL, 78235),
(78236, '3.60.40.10-FF-000308', NULL, 'Protein phosphatase 2C, putative', 252, NULL, NULL, 78236),
(78237, '1.25.10.10-FF-001511', NULL, 'Chromosome 9 SCAF14991, whole genome shotgun sequence', 229, NULL, NULL, 78237),
(78238, '1.25.10.10-FF-002388', NULL, 'Uncharacterized protein', 265, NULL, NULL, 78238),
(78239, '3.30.465.10-FF-000066', NULL, 'FAD-binding oxidoreductase', 200, NULL, NULL, 78239),
(78240, '3.40.50.720-FF-000813', NULL, 'Probable short-chain dehydrogenase', 264, NULL, NULL, 78240),
(78241, '1.20.5.2950-FF-000003', NULL, 'V-type proton ATPase subunit G', 110, NULL, NULL, 78241),
(78242, '3.40.50.1010-FF-000006', NULL, 'rRNA-processing protein UTP23 homolog', 157, NULL, NULL, 78242);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(78243, '2.60.120.590-FF-000056', NULL, 'Uncharacterized protein', 216, NULL, NULL, 78243),
(78244, '2.60.40.10-FF-003812', NULL, NULL, 88, NULL, NULL, 78244),
(78245, '2.60.40.10-FF-004998', NULL, NULL, 107, NULL, NULL, 78245),
(78246, '2.60.120.200-FF-000209', NULL, 'Laminin subunit alpha 5', 180, NULL, NULL, 78246),
(78247, '2.40.50.140-FF-000773', NULL, 'Meiosis specific with OB domains', 118, NULL, NULL, 78247),
(78248, '1.10.287.70-FF-000311', NULL, 'Predicted protein', 128, NULL, NULL, 78248),
(78249, '1.25.10.10-FF-001191', NULL, 'Uncharacterized protein', 221, NULL, NULL, 78249),
(78250, '1.10.3370.10-FF-000031', NULL, 'Preprotein translocase secY subunit', 425, NULL, NULL, 78250),
(78251, '2.30.30.100-FF-000231', NULL, 'Uncharacterized protein', 48, NULL, NULL, 78251),
(78252, '3.90.550.60-FF-000001', NULL, 'UDP-galactofuranosyl transferase GlfT2', 401, NULL, NULL, 78252),
(78253, '3.30.70.330-FF-002581', NULL, NULL, 138, NULL, NULL, 78253),
(78254, '1.25.40.10-FF-002569', NULL, 'NPG1', 153, NULL, NULL, 78254),
(78255, '1.10.150.20-FF-000333', NULL, 'Uncharacterized protein', 103, NULL, NULL, 78255),
(78256, '3.40.50.1000-FF-000003', NULL, 'HAD-IIB family hydrolase', 151, NULL, NULL, 78256),
(78257, '1.10.510.10-FF-001044', NULL, 'Probable serine/threonine-protein kinase fhkB', 308, NULL, NULL, 78257),
(78258, '2.10.25.10-FF-000452', NULL, 'thyroid peroxidase', 45, NULL, NULL, 78258),
(78259, '1.10.260.40-FF-000055', NULL, 'XRE family transcriptional regulator', 103, NULL, NULL, 78259),
(78260, '2.40.30.10-FF-000098', NULL, 'FAD binding domain-containing protein', 100, NULL, NULL, 78260),
(78261, '3.30.2080.10-FF-000008', NULL, 'Uncharacterized protein', 138, NULL, NULL, 78261),
(78262, '3.10.20.10-FF-000006', NULL, 'DNA fragmentation factor subunit beta', 85, NULL, NULL, 78262),
(78263, '3.40.50.300-FF-006955', NULL, 'Probable lipoprotein releasing system, ATP-binding protein', 223, NULL, NULL, 78263),
(78264, '3.30.450.20-FF-000315', NULL, 'Sensor histidine kinase HpkA', 118, NULL, NULL, 78264),
(78265, '1.20.950.20-FF-000026', NULL, 'Uncharacterized protein', 232, NULL, NULL, 78265),
(78266, '1.25.10.10-FF-001039', NULL, 'Transcription enhancer protein, putative', 1134, NULL, NULL, 78266),
(78267, '1.10.8.10-FF-000312', NULL, 'Uncharacterized protein', 61, NULL, NULL, 78267),
(78268, '2.60.34.10-FF-000044', NULL, 'Heat shock protein 70, putative', 155, NULL, NULL, 78268),
(78269, '3.30.420.40-FF-000819', NULL, 'DnaK protein', 80, NULL, NULL, 78269),
(78270, '3.30.40.10-FF-000517', NULL, 'anaphase-promoting complex subunit 11', 57, NULL, NULL, 78270),
(78271, '3.30.200.20-FF-002394', NULL, 'Probable serine/threonine-protein kinase DDB_G0288147', 95, NULL, NULL, 78271),
(78272, '2.60.40.10-FF-001800', NULL, 'Basal cell adhesion molecule', 84, NULL, NULL, 78272),
(78273, '1.10.510.10-FF-001218', NULL, 'Related to calmodulin-dependent protein kinase', 242, NULL, NULL, 78273),
(78274, '1.10.150.50-FF-000151', NULL, 'Putative ets proteinous factor', 74, NULL, NULL, 78274),
(78275, '3.30.1520.10-FF-000144', NULL, 'Sorting nexin C1711.11', 131, NULL, NULL, 78275),
(78276, '1.20.58.60-FF-000084', NULL, 'microtubule-actin cross-linking factor 1 isoform X2', 107, NULL, NULL, 78276),
(78277, '3.40.50.720-FF-000864', NULL, 'SUMO-activating enzyme subunit', 33, NULL, NULL, 78277),
(78278, '1.10.30.10-FF-000079', NULL, 'IXR1p Transcriptional repressor', 97, NULL, NULL, 78278),
(78279, '3.40.50.720-FF-001674', NULL, '2-hydroxyacid dehydrogenase', 112, NULL, NULL, 78279),
(78280, '3.30.40.10-FF-002081', NULL, 'Uncharacterized protein', 86, NULL, NULL, 78280),
(78281, '1.10.510.10-FF-001448', NULL, 'Protein kinase domain containing protein', 218, NULL, NULL, 78281),
(78282, '2.40.70.10-FF-000448', NULL, NULL, 61, NULL, NULL, 78282),
(78283, '3.30.70.330-FF-002642', NULL, NULL, 121, NULL, NULL, 78283),
(78284, '3.30.70.600-FF-000003', NULL, '30S ribosomal protein S10', 101, NULL, NULL, 78284),
(78285, '2.60.40.790-FF-000186', NULL, NULL, 110, NULL, NULL, 78285),
(78286, '1.10.238.10-FF-000859', NULL, 'Uncharacterized protein', 141, NULL, NULL, 78286);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(78287, '3.30.70.330-FF-000613', NULL, 'Nuclear pore complex subunit', 124, NULL, NULL, 78287),
(78288, '2.130.10.10-FF-003902', NULL, 'Uncharacterized protein', 270, NULL, NULL, 78288),
(78289, '3.40.50.300-FF-001930', NULL, 'ABC ATPase', 265, NULL, NULL, 78289),
(78290, '3.30.565.10-FF-000276', NULL, 'Sensor kinase, EraS', 129, NULL, NULL, 78290),
(78291, '3.90.70.70-FF-000001', NULL, 'Replicase polyprotein 1ab', 117, NULL, NULL, 78291),
(78292, '3.40.50.300-FF-001087', NULL, 'ZGRF1 isoform 9', 194, NULL, NULL, 78292),
(78293, '3.30.70.260-FF-000070', NULL, 'Acetolactate synthase, small subunit', 79, NULL, NULL, 78293),
(78294, '3.30.50.10-FF-000024', NULL, 'Androgen receptor', 102, NULL, NULL, 78294),
(78295, '1.10.1600.10-FF-000027', NULL, 'ATP-dependent DNA helicase II subunit 1', 108, NULL, NULL, 78295),
(78296, '2.20.28.120-FF-000006', NULL, '50S ribosomal protein L33', 57, NULL, NULL, 78296),
(78297, '3.60.130.10-FF-000057', NULL, 'Predicted protein', 294, NULL, NULL, 78297),
(78298, '3.30.70.330-FF-000843', NULL, 'Nucleic acid-binding protein', 103, NULL, NULL, 78298),
(78299, '1.10.287.770-FF-000004', NULL, 'TYRO protein tyrosine kinase-binding protein', 41, NULL, NULL, 78299),
(78300, '2.30.29.30-FF-000612', NULL, 'Phosphoinositide phospholipase C', 120, NULL, NULL, 78300),
(78301, '3.30.2010.10-FF-000009', NULL, 'metalloendopeptidase OMA1, mitochondrial isoform X1', 87, NULL, NULL, 78301),
(78302, '3.30.70.560-FF-000002', NULL, '2-amino-4-hydroxy-6-hydroxymethyldihydropteridine diphosphokinase', 167, NULL, NULL, 78302),
(78303, '3.90.70.80-FF-000004', NULL, 'deubiquitinating protein VCIP135 isoform X2', 169, NULL, NULL, 78303),
(78304, '3.90.550.20-FF-000017', NULL, 'Glycosyl transferase, putative', 195, NULL, NULL, 78304),
(78305, '1.20.1560.10-FF-000560', NULL, 'ABC transporter B family member 19', 310, NULL, NULL, 78305),
(78306, '1.10.510.10-FF-002679', NULL, NULL, 229, NULL, NULL, 78306),
(78307, '1.20.1250.20-FF-002018', NULL, 'Uncharacterized protein', 363, NULL, NULL, 78307),
(78308, '2.60.40.10-FF-001446', NULL, 'Down syndrome cell adhesion molecule-like protein Dscam2', 101, NULL, NULL, 78308),
(78309, '2.20.100.10-FF-000124', NULL, 'Spondin-1-like Protein', 52, NULL, NULL, 78309),
(78310, '3.80.10.10-FF-004151', NULL, 'Uncharacterized protein', 106, NULL, NULL, 78310),
(78311, '1.20.58.1480-FF-000017', NULL, 'Lon protease homolog, mitochondrial 1', 125, NULL, NULL, 78311),
(78312, '2.20.25.20-FF-000022', NULL, NULL, 50, NULL, NULL, 78312),
(78313, '3.80.10.10-FF-002346', NULL, 'Uncharacterized protein', 212, NULL, NULL, 78313),
(78314, '3.30.160.60-FF-004689', NULL, NULL, 30, NULL, NULL, 78314),
(78315, '3.40.50.720-FF-001966', NULL, 'Predicted protein', 255, NULL, NULL, 78315),
(78316, '3.30.200.20-FF-001112', NULL, 'Elongation factor 2 kinase, putative', 122, NULL, NULL, 78316),
(78317, '1.25.40.180-FF-000103', NULL, 'nuclear cap-binding protein subunit 1-A-like', 249, NULL, NULL, 78317),
(78318, '3.30.70.270-FF-000073', NULL, 'Diguanylate cyclase (GGDEF) domain protein', 173, NULL, NULL, 78318),
(78319, '3.40.50.150-FF-001424', NULL, NULL, 154, NULL, NULL, 78319),
(78320, '2.130.10.10-FF-000856', NULL, 'ER membrane protein complex subunit 1', 252, NULL, NULL, 78320),
(78321, '3.30.740.10-FF-000026', NULL, NULL, 87, NULL, NULL, 78321),
(78322, '3.30.70.1130-FF-000005', NULL, 'Putative elongation initiation factor 2 alpha subunit', 114, NULL, NULL, 78322),
(78323, '3.40.50.1820-FF-000423', NULL, 'YGR015C-like protein', 287, NULL, NULL, 78323),
(78324, '1.10.1300.10-FF-000049', NULL, 'Phosphodiesterase', 389, NULL, NULL, 78324),
(78325, '2.170.8.10-FF-000017', NULL, 'Uncharacterized protein', 108, NULL, NULL, 78325),
(78326, '1.25.40.10-FF-003025', NULL, 'Pentatricopeptide repeat-containing protein', 107, NULL, NULL, 78326),
(78327, '1.10.246.140-FF-000003', NULL, 'Transcription and mRNA export factor SUS1', 94, NULL, NULL, 78327),
(78328, '2.60.40.420-FF-000007', NULL, 'Cell division protein FtsP', 137, NULL, NULL, 78328),
(78329, '3.30.450.20-FF-000136', NULL, 'Sensor histidine kinase/response regulator Fos-1', 127, NULL, NULL, 78329);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(78330, '3.90.180.10-FF-000019', NULL, 'Prostaglandin reductase 2', 145, NULL, NULL, 78330),
(78331, '3.30.200.20-FF-000657', NULL, 'Non-specific serine/threonine protein kinase', 113, NULL, NULL, 78331),
(78332, '3.30.230.10-FF-000156', NULL, 'Mevalonate kinase', 218, NULL, NULL, 78332),
(78333, '2.60.40.10-FF-003245', NULL, 'Secreted protein BARF1', 105, NULL, NULL, 78333),
(78334, '3.40.50.150-FF-000856', NULL, 'Spermidine synthase-like protein', 252, NULL, NULL, 78334),
(78335, '3.90.1310.10-FF-000018', NULL, 'Cell division protein FtsI (Penicillin-binding protein 3)', 137, NULL, NULL, 78335),
(78336, '3.40.50.2300-FF-000354', NULL, 'Transcriptional regulator, LuxR family', 44, NULL, NULL, 78336),
(78337, '3.30.40.10-FF-000282', NULL, 'General transcription factor IIH subunit', 70, NULL, NULL, 78337),
(78338, '1.10.510.10-FF-003247', NULL, NULL, 116, NULL, NULL, 78338),
(78339, '3.40.50.200-FF-000040', NULL, 'Predicted protein', 225, NULL, NULL, 78339),
(78340, '3.30.160.60-FF-001042', NULL, 'zinc finger protein 385B isoform X1', 50, NULL, NULL, 78340),
(78341, '3.40.50.1820-FF-000715', NULL, 'Triacylglycerol lipase', 335, NULL, NULL, 78341),
(78342, '3.40.367.20-FF-000030', NULL, 'Phosphotransferase', 207, NULL, NULL, 78342),
(78343, '3.40.50.1000-FF-000296', NULL, 'Trehalose-phosphatase', 113, NULL, NULL, 78343),
(78344, '3.40.50.720-FF-000246', NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 9, mitochondrial', 220, NULL, NULL, 78344),
(78345, '1.10.1520.10-FF-000026', NULL, 'Dicer-like protein 1', 181, NULL, NULL, 78345),
(78346, '3.40.50.360-FF-000060', NULL, 'NAD(P)H-dependent oxidoreductase', 175, NULL, NULL, 78346),
(78347, '3.40.50.300-FF-005802', NULL, 'Uncharacterized protein', 39, NULL, NULL, 78347),
(78348, '3.30.930.10-FF-000164', NULL, 'Lysine--tRNA ligase', 355, NULL, NULL, 78348),
(78349, '3.40.50.12780-FF-000153', NULL, 'Putative pantothenate kinase subunit', 346, NULL, NULL, 78349),
(78350, '3.30.70.330-FF-002288', NULL, NULL, 101, NULL, NULL, 78350),
(78351, '3.30.160.60-FF-006393', NULL, NULL, 96, NULL, NULL, 78351),
(78352, '2.30.29.30-FF-000207', NULL, 'Protein CBR-LIN-10, isoform a', 154, NULL, NULL, 78352),
(78353, '3.40.50.620-FF-000660', NULL, 'DNA photolyase, putative', 169, NULL, NULL, 78353),
(78354, '1.25.40.10-FF-000945', NULL, 'Transcription factor tau 131 kDa subunit', 286, NULL, NULL, 78354),
(78355, '3.40.50.150-FF-001132', NULL, NULL, 171, NULL, NULL, 78355),
(78356, '2.160.20.10-FF-000283', NULL, 'Uncharacterized protein', 185, NULL, NULL, 78356),
(78357, '2.60.40.10-FF-002677', NULL, 'Periplasmic beta-glucosidase', 117, NULL, NULL, 78357),
(78358, '1.20.59.10-FF-000021', NULL, 'Chorismate mutase and prephenate dehydratase', 86, NULL, NULL, 78358),
(78359, '3.40.50.2300-FF-000966', NULL, NULL, 74, NULL, NULL, 78359),
(78360, '1.20.1070.10-FF-000438', NULL, 'NeuroPeptide Receptor family', 331, NULL, NULL, 78360),
(78361, '2.40.340.10-FF-000025', NULL, NULL, 62, NULL, NULL, 78361),
(78362, '1.25.40.10-FF-003351', NULL, 'Pentatricopeptide repeat-containing protein', 79, NULL, NULL, 78362),
(78363, '3.40.50.80-FF-000123', NULL, 'Related to ferric reductase', 167, NULL, NULL, 78363),
(78364, '2.60.120.10-FF-000212', NULL, 'Listeriolysin regulatory protein', 109, NULL, NULL, 78364),
(78365, '2.10.25.10-FF-000710', NULL, 'Blast:Protein eyes shut', 46, NULL, NULL, 78365),
(78366, '1.10.238.10-FF-000629', NULL, 'Parvalbumin beta 2', 111, NULL, NULL, 78366),
(78367, '1.20.120.20-FF-000014', NULL, 'Apolipoprotein A-I', 139, NULL, NULL, 78367),
(78368, '1.20.5.340-FF-000088', NULL, 'Predicted protein', 96, NULL, NULL, 78368),
(78369, '2.60.210.10-FF-000039', NULL, 'Predicted protein', 188, NULL, NULL, 78369),
(78370, '1.20.1250.20-FF-000753', NULL, 'Uncharacterized protein', 323, NULL, NULL, 78370),
(78371, '3.80.30.20-FF-000029', NULL, 'Predicted protein', 155, NULL, NULL, 78371),
(78372, '1.20.1510.10-FF-000074', NULL, NULL, 199, NULL, NULL, 78372),
(78373, '2.60.40.3180-FF-000001', NULL, 'transcription factor COE1 isoform X2', 239, NULL, NULL, 78373);
INSERT INTO "PUBLIC"."MODEL" VALUES
(78374, '1.20.1070.10-FF-002181', NULL, 'C1A receptor, putative', 100, NULL, NULL, 78374),
(78375, '1.10.630.10-FF-000035', NULL, 'CYtochrome P450 family', 482, NULL, NULL, 78375),
(78376, '3.40.50.300-FF-007118', NULL, 'Rab-type small GTPase', 185, NULL, NULL, 78376),
(78377, '3.10.350.10-FF-000085', NULL, 'Cell wall endopeptidase family M23/M37', 56, NULL, NULL, 78377),
(78378, '1.25.10.10-FF-003231', NULL, 'Serine/threonine-protein kinase TOR', 252, NULL, NULL, 78378),
(78379, '3.90.110.10-FF-000038', NULL, NULL, 62, NULL, NULL, 78379),
(78380, '3.90.550.10-FF-000739', NULL, 'Probable dolichyl-phosphate mannose synthase', 245, NULL, NULL, 78380),
(78381, '3.40.50.80-FF-000027', NULL, 'FAD binding domain protein', 148, NULL, NULL, 78381),
(78382, '2.40.50.140-FF-000885', NULL, NULL, 81, NULL, NULL, 78382),
(78383, '3.30.590.50-FF-000014', NULL, 'Glutamate-cysteine ligase catalytic subunit', 84, NULL, NULL, 78383),
(78384, '3.80.10.10-FF-003869', NULL, 'Endonuclease/Exonuclease/phosphatase family protein', 100, NULL, NULL, 78384),
(78385, '3.30.160.60-FF-003166', NULL, 'Zinc finger protein 1152', 30, NULL, NULL, 78385),
(78386, '1.20.1560.10-FF-000408', NULL, 'MRP-like ABC transporter', 341, NULL, NULL, 78386),
(78387, '1.20.58.60-FF-000730', NULL, 'Uncharacterized protein', 267, NULL, NULL, 78387),
(78388, '2.60.40.10-FF-002969', NULL, 'T-cell surface glycoprotein CD4', 72, NULL, NULL, 78388),
(78389, '2.130.10.10-FF-001132', NULL, 'Plexin A', 467, NULL, NULL, 78389),
(78390, '3.40.1170.10-FF-000041', NULL, 'Mismatch repair protein MutS', 104, NULL, NULL, 78390),
(78391, '1.25.40.10-FF-004918', NULL, 'Uncharacterized protein', 66, NULL, NULL, 78391),
(78392, '2.60.40.420-FF-000058', NULL, 'L-ascorbate oxidase', 207, NULL, NULL, 78392),
(78393, '1.10.10.10-FF-000937', NULL, 'Telomere repeat-binding factor 1', 81, NULL, NULL, 78393),
(78394, '2.40.50.140-FF-000447', NULL, 'Translation initiation factor 5A', 60, NULL, NULL, 78394),
(78395, '3.40.50.10140-FF-000035', NULL, 'Sterile alpha and TIR motif containing 1', 144, NULL, NULL, 78395),
(78396, '3.40.50.300-FF-001312', NULL, 'Ras-related protein Rab-18', 196, NULL, NULL, 78396),
(78397, '3.50.50.60-FF-001050', NULL, 'FAD-dependent oxidoreductase domain-containing protein 1 isoform X3', 47, NULL, NULL, 78397),
(78398, '2.60.40.10-FF-000906', NULL, 'Junctional adhesion molecule A', 103, NULL, NULL, 78398),
(78399, '3.40.850.10-FF-000077', NULL, 'Putative Unc104-like kinesin', 397, NULL, NULL, 78399),
(78400, '1.10.287.70-FF-000232', NULL, 'GLutamate Receptor family (AMPA)', 137, NULL, NULL, 78400),
(78401, '3.30.200.20-FF-002068', NULL, 'Uncharacterized protein', 85, NULL, NULL, 78401),
(78402, '3.30.70.2500-FF-000001', NULL, 'Sulfite reductase, dissimilatory-type alpha subunit', 100, NULL, NULL, 78402),
(78403, '2.130.10.10-FF-003341', NULL, 'AGAP010418-PA', 239, NULL, NULL, 78403),
(78404, '1.10.10.10-FF-001213', NULL, 'Disease resistance protein RPM1', 90, NULL, NULL, 78404),
(78405, '2.130.10.10-FF-002773', NULL, 'Mediator of RNA polymerase II transcription subunit 16', 229, NULL, NULL, 78405),
(78406, '3.30.70.330-FF-000517', NULL, 'U2 snRNP auxiliary factor large subunit', 105, NULL, NULL, 78406),
(78407, '3.30.200.20-FF-001500', NULL, 'Probable serine/threonine-protein kinase fhkD', 91, NULL, NULL, 78407),
(78408, '1.20.120.1750-FF-000163', NULL, 'Uncharacterized protein', 57, NULL, NULL, 78408),
(78409, '3.30.920.10-FF-000012', NULL, 'Frataxin, mitochondrial, putative', 119, NULL, NULL, 78409),
(78410, '1.25.40.20-FF-001763', NULL, 'Uncharacterized protein', 192, NULL, NULL, 78410),
(78411, '1.10.510.10-FF-001370', NULL, 'Uncharacterized protein, isoform A', 215, NULL, NULL, 78411),
(78412, '3.40.50.10130-FF-000032', NULL, 'Uncharacterized protein', 192, NULL, NULL, 78412),
(78413, '1.20.1250.20-FF-000427', NULL, 'Battenin', 397, NULL, NULL, 78413),
(78414, '3.30.70.330-FF-001799', NULL, NULL, 108, NULL, NULL, 78414),
(78415, '3.40.1280.10-FF-000077', NULL, 'Ribosomal RNA small subunit methyltransferase E', 255, NULL, NULL, 78415);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(78416, '1.25.40.470-FF-000016', NULL, 'Coatomer subunit beta''', 215, NULL, NULL, 78416),
(78417, '1.20.1740.10-FF-000006', NULL, 'General amino acid permease', 472, NULL, NULL, 78417),
(78418, '1.20.58.60-FF-000112', NULL, 'nesprin-1 isoform X4', 113, NULL, NULL, 78418),
(78419, '1.25.40.20-FF-001049', NULL, 'Ankyrin repeat, PH and SEC7 domain containing protein secG', 163, NULL, NULL, 78419),
(78420, '3.50.50.60-FF-000791', NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', 218, NULL, NULL, 78420),
(78421, '1.20.1250.20-FF-001888', NULL, 'Prop transport protein', 86, NULL, NULL, 78421),
(78422, '1.10.510.10-FF-000881', NULL, 'PTI1-like tyrosine-protein kinase 3 isoform X2', 102, NULL, NULL, 78422),
(78423, '3.40.50.300-FF-005241', NULL, 'Uncharacterized protein', 196, NULL, NULL, 78423),
(78424, '3.10.580.10-FF-000017', NULL, 'CBS domain-containing protein CBSX3, mitochondrial', 156, NULL, NULL, 78424),
(78425, '1.20.1260.10-FF-000043', NULL, 'Ferritin', 177, NULL, NULL, 78425),
(78426, '3.30.160.60-FF-005706', NULL, NULL, 56, NULL, NULL, 78426),
(78427, '3.80.10.10-FF-002913', NULL, 'Insulin-like growth factor-binding protein acid labile subunit', 88, NULL, NULL, 78427),
(78428, '3.10.660.10-FF-000018', NULL, 'Chaperone protein DNAJ, putative', 78, NULL, NULL, 78428),
(78429, '1.20.1720.10-FF-000123', NULL, NULL, 254, NULL, NULL, 78429),
(78430, '3.60.20.10-FF-000190', NULL, NULL, 85, NULL, NULL, 78430),
(78431, '3.60.20.10-FF-000217', NULL, NULL, 143, NULL, NULL, 78431),
(78432, '2.10.10.100-FF-000001', NULL, 'UDP-N-acetylhexosamine pyrophosphorylase isoform X1', 84, NULL, NULL, 78432),
(78433, '1.25.40.10-FF-004711', NULL, 'SEL-1', 215, NULL, NULL, 78433),
(78434, '2.60.98.20-FF-000003', NULL, 'Flagellar hook protein FlgE', 166, NULL, NULL, 78434),
(78435, '3.40.50.300-FF-008579', NULL, 'Predicted protein', 258, NULL, NULL, 78435),
(78436, '1.20.210.10-FF-000018', NULL, 'Cytochrome c oxidase subunit I', 546, NULL, NULL, 78436),
(78437, '1.10.10.10-FF-001426', NULL, 'Transcriptional regulator, SARP family', 87, NULL, NULL, 78437),
(78438, '3.40.50.300-FF-003728', NULL, 'DEAQ box RNA-dependent ATPase 1', 193, NULL, NULL, 78438),
(78439, '3.30.450.20-FF-000411', NULL, 'PAS domain-containing hybrid sensor histidine kinase/response regulator', 123, NULL, NULL, 78439),
(78440, '2.60.40.10-FF-003571', NULL, NULL, 112, NULL, NULL, 78440),
(78441, '2.60.40.10-FF-005111', NULL, NULL, 98, NULL, NULL, 78441),
(78442, '1.10.238.10-FF-000955', NULL, 'Calcium-binding mitochondrial carrier protein SCaMC-1', 59, NULL, NULL, 78442),
(78443, '2.120.10.80-FF-000265', NULL, 'DNA-binding transcriptional activator of the SARP family', 251, NULL, NULL, 78443),
(78444, '3.40.50.300-FF-006904', NULL, 'Uncharacterized protein', 238, NULL, NULL, 78444),
(78445, '1.50.10.20-FF-000062', NULL, 'Uncharacterized protein', 160, NULL, NULL, 78445),
(78446, '2.60.40.1230-FF-000023', NULL, 'Uncharacterized protein', 95, NULL, NULL, 78446),
(78447, '2.60.40.150-FF-000808', NULL, 'Uncharacterized protein', 136, NULL, NULL, 78447),
(78448, '3.40.50.2300-FF-000528', NULL, 'Amino acid/amide ABC transporter substrate-binding protein, HAAT family', 202, NULL, NULL, 78448),
(78449, '3.80.10.10-FF-000761', NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase', 118, NULL, NULL, 78449),
(78450, '1.10.287.70-FF-000283', NULL, 'Ionotropic receptor 40a', 153, NULL, NULL, 78450),
(78451, '3.30.70.3490-FF-000067', NULL, NULL, 75, NULL, NULL, 78451),
(78452, '3.40.50.2300-FF-000680', NULL, NULL, 25, NULL, NULL, 78452),
(78453, '3.40.50.300-FF-007444', NULL, 'ATP-dependent DEAD/H RNA helicase, putative', 251, NULL, NULL, 78453),
(78454, '1.10.3720.10-FF-000188', NULL, 'ABC transporter permease', 198, NULL, NULL, 78454),
(78455, '3.20.20.140-FF-000172', NULL, 'Related to guanine deaminase', 166, NULL, NULL, 78455),
(78456, '2.60.40.10-FF-000783', NULL, 'Tenascin N', 89, NULL, NULL, 78456),
(78457, '3.40.309.10-FF-000033', NULL, 'NAD-dependent phenylacetaldehyde dehydrogenase', 190, NULL, NULL, 78457);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(78458, '2.60.120.200-FF-000035', NULL, 'FAT atypical cadherin 3', 188, NULL, NULL, 78458),
(78459, '2.10.60.10-FF-000016', NULL, 'LY6/PLAUR domain containing 3', 93, NULL, NULL, 78459),
(78460, '3.40.720.10-FF-000073', NULL, 'Cofactor-independent phosphoglycerate mutase', 109, NULL, NULL, 78460),
(78461, '3.30.160.20-FF-000035', NULL, 'RNA polymerase II C-terminal domain phosphatase-like 2', 75, NULL, NULL, 78461),
(78462, '2.30.42.10-FF-000305', NULL, 'Golgi re-assembly stacking protein 2', 98, NULL, NULL, 78462),
(78463, '1.25.40.280-FF-000015', NULL, 'Enhancer of Glp-One (Glp-1)', 385, NULL, NULL, 78463),
(78464, '3.90.1560.10-FF-000003', NULL, 'Probable 2-phosphosulfolactate phosphatase', 213, NULL, NULL, 78464),
(78465, '3.40.190.10-FF-000661', NULL, 'Xyloglucan ABC transport system, sugar-binding protein', 124, NULL, NULL, 78465),
(78466, '2.60.120.650-FF-000147', NULL, 'Uncharacterized protein', 73, NULL, NULL, 78466),
(78467, '1.20.1310.10-FF-000188', NULL, NULL, 109, NULL, NULL, 78467),
(78468, '1.10.630.10-FF-000086', NULL, 'cytochrome P450 90A1-like isoform X1', 450, NULL, NULL, 78468),
(78469, '3.40.20.10-FF-000027', NULL, 'Villin 1', 112, NULL, NULL, 78469),
(78470, '3.30.160.60-FF-003520', NULL, 'Zinc finger protein 234-like Protein', 23, NULL, NULL, 78470),
(78471, '1.10.285.10-FF-000013', NULL, 'Glutamate dehydrogenase', 43, NULL, NULL, 78471),
(78472, '1.20.1250.20-FF-002170', NULL, 'Predicted protein', 179, NULL, NULL, 78472),
(78473, '2.60.40.60-FF-000865', NULL, 'Uncharacterized protein', 118, NULL, NULL, 78473),
(78474, '1.10.472.10-FF-000628', NULL, 'G1/S-specific cyclin e2-like protein', 122, NULL, NULL, 78474),
(78475, '1.10.510.10-FF-003573', NULL, NULL, 215, NULL, NULL, 78475),
(78476, '3.40.50.10090-FF-000031', NULL, 'Uroporphyrinogen-III synthase', 102, NULL, NULL, 78476),
(78477, '1.10.10.10-FF-000196', NULL, 'UPF0502 protein YceH', 94, NULL, NULL, 78477),
(78478, '1.25.40.10-FF-001760', NULL, 'tetratricopeptide repeat protein 28', 155, NULL, NULL, 78478),
(78479, '1.20.58.60-FF-000319', NULL, 'Protein CBG15811', 107, NULL, NULL, 78479),
(78480, '3.40.50.620-FF-000334', NULL, 'Tryptophan--tRNA ligase', 226, NULL, NULL, 78480),
(78481, '3.30.40.10-FF-001979', NULL, 'Uncharacterized protein', 104, NULL, NULL, 78481),
(78482, '1.25.40.120-FF-000046', NULL, 'Uncharacterized protein', 172, NULL, NULL, 78482),
(78483, '2.130.10.10-FF-003015', NULL, 'Putative wd40 domain protein', 171, NULL, NULL, 78483),
(78484, '3.30.497.10-FF-000179', NULL, 'Serpin peptidase inhibitor 6', 134, NULL, NULL, 78484),
(78485, '1.10.555.10-FF-000231', NULL, NULL, 200, NULL, NULL, 78485),
(78486, '3.80.10.10-FF-001896', NULL, 'Calpain, putative', 144, NULL, NULL, 78486),
(78487, '2.130.10.10-FF-005139', NULL, 'Uncharacterized protein', 87, NULL, NULL, 78487),
(78488, '4.10.60.10-FF-000169', NULL, 'YALI0D12056p', 39, NULL, NULL, 78488),
(78489, '1.10.10.10-FF-000971', NULL, 'ESCRT-II complex subunit VPS22', 98, NULL, NULL, 78489),
(78490, '2.10.50.30-FF-000022', NULL, 'Vomeronasal 2, receptor 42', 100, NULL, NULL, 78490),
(78491, '1.25.40.20-FF-001145', NULL, 'AGAP003151-PA', 145, NULL, NULL, 78491),
(78492, '1.25.10.10-FF-002742', NULL, 'Uncharacterized protein', 780, NULL, NULL, 78492),
(78493, '1.25.40.10-FF-004368', NULL, 'Uncharacterized protein', 151, NULL, NULL, 78493),
(78494, '2.160.10.10-FF-000046', NULL, 'Translation initiation factor eIF-2B subunit epsilon, putative', 133, NULL, NULL, 78494),
(78495, '3.30.470.20-FF-000148', NULL, 'Uncharacterized protein', 212, NULL, NULL, 78495),
(78496, '1.10.340.70-FF-000019', NULL, 'Uncharacterized protein', 75, NULL, NULL, 78496),
(78497, '2.10.25.10-FF-000008', NULL, 'Signal peptide, CUB domain, EGF-like 2', 42, NULL, NULL, 78497),
(78498, '3.40.228.10-FF-000007', NULL, 'Oxidoreductase alpha subunit', 223, NULL, NULL, 78498),
(78499, '3.30.40.10-FF-002255', NULL, 'Uncharacterized protein', 120, NULL, NULL, 78499),
(78500, '3.40.718.10-FF-000028', NULL, '3-isopropylmalate dehydrogenase', 368, NULL, NULL, 78500),
(78501, '3.20.20.140-FF-000121', NULL, 'N-acetylglucosamine-6-phosphate deacetylase-like protein', 314, NULL, NULL, 78501);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(78502, '2.30.30.790-FF-000005', NULL, 'Mitochondrial ribosomal protein L19', 127, NULL, NULL, 78502),
(78503, '3.50.50.60-FF-000622', NULL, 'FADH2-dependent halogenase PltA', 449, NULL, NULL, 78503),
(78504, '3.40.50.720-FF-002404', NULL, 'Uncharacterized protein', 65, NULL, NULL, 78504),
(78505, '2.120.10.30-FF-000615', NULL, 'Uncharacterized protein', 98, NULL, NULL, 78505),
(78506, '3.30.70.330-FF-000725', NULL, 'Ribonucleoprotein', 140, NULL, NULL, 78506),
(78507, '2.60.40.10-FF-003520', NULL, NULL, 85, NULL, NULL, 78507),
(78508, '2.60.120.200-FF-000653', NULL, 'Laminin subunit alpha 5', 97, NULL, NULL, 78508),
(78509, '3.80.10.10-FF-004066', NULL, 'Uncharacterized protein', 132, NULL, NULL, 78509),
(78510, '6.10.140.2220-FF-000046', NULL, 'GD10841', 51, NULL, NULL, 78510),
(78511, '2.30.30.100-FF-000113', NULL, 'Lsm7 u6 small nuclear rna associated', 47, NULL, NULL, 78511),
(78512, '2.40.70.10-FF-000336', NULL, NULL, 165, NULL, NULL, 78512),
(78513, '2.10.50.10-FF-000111', NULL, 'Fas cell surface death receptor', 44, NULL, NULL, 78513),
(78514, '3.90.180.10-FF-000104', NULL, 'Zinc-binding dehydrogenase family oxidoreductase', 184, NULL, NULL, 78514),
(78515, '3.40.570.10-FF-000027', NULL, 'Predicted protein', 249, NULL, NULL, 78515),
(78516, '2.30.39.10-FF-000112', NULL, 'AGAP006910-PA', 136, NULL, NULL, 78516),
(78517, '1.10.238.10-FF-000747', NULL, 'Follistatin-related protein 1', 142, NULL, NULL, 78517),
(78518, '2.40.100.10-FF-000159', NULL, 'Peptidyl-prolyl cis-trans isomerase', 120, NULL, NULL, 78518),
(78519, '3.30.450.20-FF-000580', NULL, 'Uncharacterized protein', 59, NULL, NULL, 78519),
(78520, '2.40.420.20-FF-000012', NULL, 'HlyD family secretion protein', 97, NULL, NULL, 78520),
(78521, '2.70.70.10-FF-000059', NULL, 'Peptidase M23', 134, NULL, NULL, 78521),
(78522, '1.10.10.60-FF-000396', NULL, 'NOBOX oogenesis homeobox', 67, NULL, NULL, 78522),
(78523, '2.60.40.420-FF-000272', NULL, 'Cytochrome c oxidase subunit 2', 59, NULL, NULL, 78523),
(78524, '3.30.70.960-FF-000009', NULL, 'Interphotoreceptor matrix proteoglycan 1', 99, NULL, NULL, 78524),
(78525, '3.30.720.50-FF-000014', NULL, NULL, 84, NULL, NULL, 78525),
(78526, '3.90.1150.10-FF-000242', NULL, 'GntR family transcriptional regulator', 140, NULL, NULL, 78526),
(78527, '3.30.160.60-FF-002918', NULL, 'Zinc finger protein 41', 44, NULL, NULL, 78527),
(78528, '2.60.40.10-FF-001334', NULL, 'tyrosine-protein phosphatase 10D isoform X3', 87, NULL, NULL, 78528),
(78529, '1.25.40.10-FF-001142', NULL, 'Pentatricopeptide repeat-containing protein', 150, NULL, NULL, 78529),
(78530, '4.10.860.10-FF-000018', NULL, 'UvrB/UvrC protein', 44, NULL, NULL, 78530),
(78531, '3.40.50.300-FF-007039', NULL, 'Uncharacterized protein', 200, NULL, NULL, 78531),
(78532, '3.40.50.300-FF-000598', NULL, 'Dynein cytoplasmic 2 heavy chain 1', 172, NULL, NULL, 78532),
(78533, '2.170.220.10-FF-000002', NULL, 'Methionine--tRNA ligase', 118, NULL, NULL, 78533),
(78534, '1.25.10.10-FF-003310', NULL, 'Uncharacterized protein', 156, NULL, NULL, 78534),
(78535, '1.20.1250.20-FF-000192', NULL, 'Major facilitator superfamily domain-containing 5', 381, NULL, NULL, 78535),
(78536, '3.80.10.10-FF-000429', NULL, 'Leucine-rich repeat and WD repeat-containing protein 1', 138, NULL, NULL, 78536),
(78537, '1.25.10.10-FF-000589', NULL, 'Uncharacterized protein', 375, NULL, NULL, 78537),
(78538, '3.40.640.10-FF-000089', NULL, 'Aminotransferase, DegT/DnrJ/EryC1/StrS family', 244, NULL, NULL, 78538),
(78539, '2.30.40.10-FF-000115', NULL, 'Uncharacterized protein', 126, NULL, NULL, 78539),
(78540, '3.90.530.10-FF-000002', NULL, 'zinc transporter 9 isoform X1', 91, NULL, NULL, 78540),
(78541, '3.30.710.10-FF-000024', NULL, 'Leucine-zipper-like transcriptional regulator 1', 154, NULL, NULL, 78541),
(78542, '3.30.200.20-FF-001000', NULL, 'Myosin light chain kinase, putative', 83, NULL, NULL, 78542),
(78543, '3.30.450.20-FF-000203', NULL, 'Histidine kinase response regulator hybrid protein', 113, NULL, NULL, 78543),
(78544, '3.40.1280.10-FF-000105', NULL, 'Uncharacterized protein', 147, NULL, NULL, 78544);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(78545, '3.30.40.10-FF-002204', NULL, 'Uncharacterized protein', 73, NULL, NULL, 78545),
(78546, '1.20.1410.10-FF-000010', NULL, 'Uncharacterized protein', 190, NULL, NULL, 78546),
(78547, '1.10.510.10-FF-000667', NULL, 'Tyrosine-protein kinase receptor', 92, NULL, NULL, 78547),
(78548, '1.25.40.20-FF-001050', NULL, 'Uncharacterized protein', 285, NULL, NULL, 78548),
(78549, '3.30.420.60-FF-000016', NULL, 'Eukaryotic release factor 1, putative', 140, NULL, NULL, 78549),
(78550, '3.90.70.10-FF-000736', NULL, 'Cysteine proteinases superfamily protein', 158, NULL, NULL, 78550),
(78551, '3.40.50.300-FF-002739', NULL, 'Small GTPase', 178, NULL, NULL, 78551),
(78552, '1.10.238.10-FF-000860', NULL, 'Acidocalcisomal pyrophosphatase', 120, NULL, NULL, 78552),
(78553, '3.30.200.20-FF-000483', NULL, 'Putative receptor-like protein kinase', 110, NULL, NULL, 78553),
(78554, '3.80.10.10-FF-000755', NULL, 'Si:ch211-213a13.2', 171, NULL, NULL, 78554),
(78555, '3.20.180.20-FF-000038', NULL, 'Uncharacterized protein', 96, NULL, NULL, 78555),
(78556, '1.20.1050.10-FF-000229', NULL, 'Uncharacterized protein', 97, NULL, NULL, 78556),
(78557, '1.10.510.10-FF-002797', NULL, NULL, 192, NULL, NULL, 78557),
(78558, '1.50.10.10-FF-000025', NULL, 'alpha-1,2-Mannosidase', 512, NULL, NULL, 78558),
(78559, '3.30.420.40-FF-000758', NULL, 'Actin-like 6B', 28, NULL, NULL, 78559),
(78560, '2.60.120.260-FF-000188', NULL, 'Proprotein convertase subtilisin/kexin type 7', 101, NULL, NULL, 78560),
(78561, '2.40.50.90-FF-000139', NULL, 'Tapas, isoform A', 43, NULL, NULL, 78561),
(78562, '2.70.220.10-FF-000009', NULL, 'Uncharacterized protein', 65, NULL, NULL, 78562),
(78563, '3.40.50.1820-FF-000541', NULL, 'Acyl transferase', 303, NULL, NULL, 78563),
(78564, '2.10.110.10-FF-000026', NULL, 'PDZ and LIM domain protein 3', 60, NULL, NULL, 78564),
(78565, '1.10.3120.10-FF-000013', NULL, 'Trigger factor', 212, NULL, NULL, 78565),
(78566, '3.30.160.60-FF-004476', NULL, NULL, 24, NULL, NULL, 78566),
(78567, '3.90.180.10-FF-000087', NULL, 'Alcohol dehydrogenase', 168, NULL, NULL, 78567),
(78568, '1.20.58.1970-FF-000007', NULL, 'Conserved oligomeric Golgi complex subunit 4', 170, NULL, NULL, 78568),
(78569, '1.50.10.20-FF-000028', NULL, 'Geranylgeranyl transferase type-2 subunit beta', 323, NULL, NULL, 78569),
(78570, '3.40.225.10-FF-000029', NULL, 'Rhamnulose-1-phosphate aldolase', 236, NULL, NULL, 78570),
(78571, '2.30.29.30-FF-000730', NULL, 'Uncharacterized protein', 97, NULL, NULL, 78571),
(78572, '3.60.150.10-FF-000002', NULL, 'Chorismate synthase', 388, NULL, NULL, 78572),
(78573, '3.40.50.150-FF-000738', NULL, 'Acetylserotonin O-methyltransferase', 259, NULL, NULL, 78573),
(78574, '3.30.1610.10-FF-000010', NULL, 'Predicted protein', 69, NULL, NULL, 78574),
(78575, '2.120.10.30-FF-000565', NULL, 'Senescence marker protein-30, putative', 62, NULL, NULL, 78575),
(78576, '3.90.660.50-FF-000001', NULL, 'Prolycopene isomerase, chloroplastic', 169, NULL, NULL, 78576),
(78577, '3.90.1150.10-FF-000129', NULL, 'DegT/DnrJ/EryC1/StrS aminotransferase family protein', 119, NULL, NULL, 78577),
(78578, '1.10.510.10-FF-002758', NULL, NULL, 124, NULL, NULL, 78578),
(78579, '3.40.850.10-FF-000190', NULL, 'Kinesin motor domain protein', 361, NULL, NULL, 78579),
(78580, '1.10.486.10-FF-000036', NULL, 'DNA helicase', 168, NULL, NULL, 78580),
(78581, '3.30.710.10-FF-000119', NULL, 'potassium voltage-gated channel subfamily A member 4', 114, NULL, NULL, 78581),
(78582, '2.60.120.920-FF-000200', NULL, 'Uncharacterized protein', 122, NULL, NULL, 78582),
(78583, '1.20.1070.10-FF-000556', NULL, 'Uncharacterized protein', 307, NULL, NULL, 78583),
(78584, '4.10.240.10-FF-000191', NULL, 'Uncharacterized protein', 83, NULL, NULL, 78584),
(78585, '1.20.5.650-FF-000012', NULL, NULL, 46, NULL, NULL, 78585),
(78586, '4.10.800.10-FF-000009', NULL, 'Insulin-like growth factor binding protein 5', 77, NULL, NULL, 78586),
(78587, '4.10.520.10-FF-000027', NULL, NULL, 94, NULL, NULL, 78587),
(78588, '3.90.650.10-FF-000011', NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase', 173, NULL, NULL, 78588);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(78589, '2.60.40.10-FF-004886', NULL, NULL, 80, NULL, NULL, 78589),
(78590, '3.40.50.620-FF-000222', NULL, 'Glutamate--tRNA ligase', 342, NULL, NULL, 78590),
(78591, '1.25.10.10-FF-003405', NULL, 'Protein Mo25', 101, NULL, NULL, 78591),
(78592, '3.40.50.10190-FF-000117', NULL, 'Hypothetical_protein_-_conserved', 116, NULL, NULL, 78592),
(78593, '1.10.150.530-FF-000023', NULL, 'Uncharacterized protein', 58, NULL, NULL, 78593),
(78594, '3.30.200.20-FF-001320', NULL, 'Kinase like protein', 76, NULL, NULL, 78594),
(78595, '1.20.1250.20-FF-000135', NULL, 'MFS family transporter', 188, NULL, NULL, 78595),
(78596, '1.10.472.10-FF-000448', NULL, 'G1/S-specific cyclin-E1', 149, NULL, NULL, 78596),
(78597, '2.60.40.10-FF-002582', NULL, 'Stretchin-Mlck, isoform V', 107, NULL, NULL, 78597),
(78598, '1.20.1250.10-FF-000132', NULL, NULL, 101, NULL, NULL, 78598),
(78599, '3.30.559.10-FF-000166', NULL, 'Enniatin synthetase', 172, NULL, NULL, 78599),
(78600, '3.40.50.2300-FF-000915', NULL, NULL, 25, NULL, NULL, 78600),
(78601, '1.10.8.60-FF-000030', NULL, 'replication factor C subunit 3', 59, NULL, NULL, 78601),
(78602, '3.40.50.300-FF-001604', NULL, 'DNA repair protein XRCC3', 251, NULL, NULL, 78602),
(78603, '3.40.50.10050-FF-000008', NULL, 'Translation initiation factor IF-2', 99, NULL, NULL, 78603),
(78604, '3.10.180.10-FF-000088', NULL, '4-hydroxymandelate synthase', 152, NULL, NULL, 78604),
(78605, '3.30.160.60-FF-001603', NULL, 'Zinc finger protein', 23, NULL, NULL, 78605),
(78606, '3.40.50.300-FF-001380', NULL, 'Iron ABC transporter ATP-binding protein', 252, NULL, NULL, 78606),
(78607, '2.130.10.10-FF-003223', NULL, 'YALI0C00913p', 307, NULL, NULL, 78607),
(78608, '1.10.8.10-FF-000104', NULL, 'Ubiquitin domain-containing protein', 46, NULL, NULL, 78608),
(78609, '2.120.10.80-FF-000259', NULL, 'F-box protein AFR', 292, NULL, NULL, 78609),
(78610, '3.30.70.330-FF-000405', NULL, 'polyadenylate-binding protein RBP45', 98, NULL, NULL, 78610),
(78611, '1.50.10.20-FF-000141', NULL, 'Dammarenediol II synthase', 372, NULL, NULL, 78611),
(78612, '2.130.10.10-FF-004690', NULL, 'Uncharacterized protein', 177, NULL, NULL, 78612),
(78613, '3.30.160.60-FF-003907', NULL, NULL, 34, NULL, NULL, 78613),
(78614, '1.10.10.10-FF-000763', NULL, 'Heat shock transcription factor', 137, NULL, NULL, 78614),
(78615, '1.20.5.2650-FF-000003', NULL, '40S ribosomal protein S6', 83, NULL, NULL, 78615),
(78616, '2.40.70.10-FF-000544', NULL, NULL, 184, NULL, NULL, 78616),
(78617, '3.30.900.10-FF-000044', NULL, 'Autophagy-related protein 13', 201, NULL, NULL, 78617),
(78618, '3.30.40.10-FF-000810', NULL, 'Structure-specific endonuclease subunit SLX1', 82, NULL, NULL, 78618),
(78619, '3.80.10.10-FF-000109', NULL, 'nischarin isoform X1', 172, NULL, NULL, 78619),
(78620, '3.30.830.10-FF-000185', NULL, 'Uncharacterized protein', 230, NULL, NULL, 78620),
(78621, '2.130.10.10-FF-004858', NULL, 'WD repeat-containing protein 74', 125, NULL, NULL, 78621),
(78622, '3.30.160.60-FF-003812', NULL, NULL, 52, NULL, NULL, 78622),
(78623, '1.10.287.380-FF-000033', NULL, 'Valyl-tRNA synthetase', 72, NULL, NULL, 78623),
(78624, '3.30.160.60-FF-003700', NULL, NULL, 30, NULL, NULL, 78624),
(78625, '3.40.190.10-FF-000953', NULL, 'Uncharacterized protein', 182, NULL, NULL, 78625),
(78626, '3.40.50.300-FF-002947', NULL, 'ABC transporter, ATP-binding protein', 254, NULL, NULL, 78626),
(78627, '3.40.50.1260-FF-000002', NULL, 'Phosphoglycerate kinase', 166, NULL, NULL, 78627),
(78628, '1.20.1250.20-FF-002226', NULL, 'Uncharacterized protein', 128, NULL, NULL, 78628),
(78629, '3.40.50.1440-FF-000079', NULL, 'Tubulin, alpha 4-like', 78, NULL, NULL, 78629),
(78630, '1.20.58.860-FF-000018', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 80, NULL, NULL, 78630),
(78631, '3.40.50.300-FF-001587', NULL, 'ABC transporter ATP-binding protein', 255, NULL, NULL, 78631),
(78632, '1.20.58.60-FF-000825', NULL, 'Dystonin', 177, NULL, NULL, 78632),
(78633, '3.30.830.10-FF-000297', NULL, 'Uncharacterized protein', 53, NULL, NULL, 78633),
(78634, '3.40.50.300-FF-008467', NULL, 'Uncharacterized protein', 244, NULL, NULL, 78634);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(78635, '1.25.40.770-FF-000005', NULL, 'TATA-binding protein-associated-factor', 203, NULL, NULL, 78635),
(78636, '3.40.640.10-FF-000297', NULL, 'Probable glycine dehydrogenase (decarboxylating) subunit 2', 273, NULL, NULL, 78636),
(78637, '3.10.105.10-FF-000010', NULL, 'ABC transporter substrate-binding protein component', 229, NULL, NULL, 78637),
(78638, '1.25.40.10-FF-002570', NULL, 'Pentatricopeptide repeat-containing protein At1g19720', 212, NULL, NULL, 78638),
(78639, '3.40.20.10-FF-000140', NULL, 'Protein transport protein SEC23', 106, NULL, NULL, 78639),
(78640, '3.30.710.10-FF-000232', NULL, 'GM20065', 146, NULL, NULL, 78640),
(78641, '1.20.1560.10-FF-000352', NULL, 'Multidrug resistance protein 1', 23, NULL, NULL, 78641),
(78642, '2.40.50.140-FF-000155', NULL, 'rRNA biogenesis protein RRP5', 90, NULL, NULL, 78642),
(78643, '2.130.10.10-FF-002767', NULL, 'Uncharacterized protein', 236, NULL, NULL, 78643),
(78644, '3.40.1350.10-FF-000021', NULL, 'Holliday junction resolvase RecU', 173, NULL, NULL, 78644),
(78645, '3.30.160.60-FF-001721', NULL, 'Zinc finger protein 366', 27, NULL, NULL, 78645),
(78646, '1.25.40.180-FF-000311', NULL, NULL, 277, NULL, NULL, 78646),
(78647, '1.10.555.10-FF-000017', NULL, 'Rho GTPase activating protein 6', 248, NULL, NULL, 78647),
(78648, '3.40.50.720-FF-000538', NULL, 'NADH-ubiquinone oxidoreductase complex I subunit, putative', 225, NULL, NULL, 78648),
(78649, '1.10.510.10-FF-001662', NULL, 'Protein CBG16200', 174, NULL, NULL, 78649),
(78650, '3.30.200.20-FF-000269', NULL, 'serine/threonine-protein kinase mph1 isoform X2', 88, NULL, NULL, 78650),
(78651, '1.10.510.10-FF-001605', NULL, 'Probably inactive receptor-like protein kinase At2g46850', 71, NULL, NULL, 78651),
(78652, '3.40.50.12780-FF-000147', NULL, 'Chromosome 19, whole genome shotgun sequence', 181, NULL, NULL, 78652),
(78653, '3.40.50.720-FF-000038', NULL, 'D-3-phosphoglycerate dehydrogenase', 117, NULL, NULL, 78653),
(78654, '1.25.10.10-FF-001106', NULL, 'Dynein, axonemal, assembly factor 5', 258, NULL, NULL, 78654),
(78655, '1.20.1090.10-FF-000035', NULL, '3-dehydroquinate synthase', 187, NULL, NULL, 78655),
(78656, '3.30.559.10-FF-000071', NULL, 'Nonribosomal peptide synthetase 8', 181, NULL, NULL, 78656),
(78657, '1.20.5.1160-FF-000040', NULL, 'Uncharacterized protein', 95, NULL, NULL, 78657),
(78658, '3.40.50.2300-FF-000758', NULL, 'Glutamate receptor', 136, NULL, NULL, 78658),
(78659, '3.40.50.10190-FF-000022', NULL, 'DNA topoisomerase II binding protein 1', 112, NULL, NULL, 78659),
(78660, '3.90.550.10-FF-000745', NULL, 'Predicted protein', 242, NULL, NULL, 78660),
(78661, '3.30.910.20-FF-000008', NULL, 'Outer membrane chaperone Skp (OmpH)', 128, NULL, NULL, 78661),
(78662, '3.80.10.10-FF-002621', NULL, 'Uncharacterized protein', 187, NULL, NULL, 78662),
(78663, '3.50.50.60-FF-001403', NULL, 'Uncharacterized protein', 168, NULL, NULL, 78663),
(78664, '2.130.10.10-FF-004358', NULL, 'Mitochondrial inner membrane protease ATP23', 92, NULL, NULL, 78664),
(78665, '2.30.29.30-FF-000387', NULL, 'Serine/threonine-protein kinase D2', 126, NULL, NULL, 78665),
(78666, '1.50.10.10-FF-000233', NULL, 'alpha-1,2-Mannosidase', 144, NULL, NULL, 78666),
(78667, '1.10.10.10-FF-001752', NULL, 'Spo11/DNA topoisomerase VI subunit A', 111, NULL, NULL, 78667),
(78668, '3.30.9.10-FF-000260', NULL, 'Uncharacterized protein', 159, NULL, NULL, 78668),
(78669, '3.30.160.60-FF-001660', NULL, 'Uncharacterized protein', 28, NULL, NULL, 78669),
(78670, '2.60.40.10-FF-002789', NULL, 'Ig-like and fibronectin type-III domain-containing protein C25G4.10', 86, NULL, NULL, 78670),
(78671, '3.40.1110.10-FF-000211', NULL, 'Heavy-metal transporting P-type ATPase', 122, NULL, NULL, 78671),
(78672, '2.30.40.10-FF-000183', NULL, 'Uncharacterized protein', 43, NULL, NULL, 78672),
(78673, '1.10.510.10-FF-003253', NULL, NULL, 114, NULL, NULL, 78673),
(78674, '2.40.440.10-FF-000010', NULL, 'L,D-transpeptidase', 138, NULL, NULL, 78674),
(78675, '2.60.40.1530-FF-000012', NULL, 'Integrin, alpha 8', 224, NULL, NULL, 78675),
(78676, '1.10.287.370-FF-000030', NULL, 'Probable prefoldin subunit 6', 107, NULL, NULL, 78676);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(78677, '2.30.30.100-FF-000170', NULL, 'U6 snRNA-associated Sm-like protein LSm2', 90, NULL, NULL, 78677),
(78678, '3.40.50.150-FF-001396', NULL, NULL, 168, NULL, NULL, 78678),
(78679, '2.10.25.10-FF-001795', NULL, 'Uncharacterized protein', 28, NULL, NULL, 78679),
(78680, '1.20.5.170-FF-000172', NULL, 'BZIP transcription factor 2', 77, NULL, NULL, 78680),
(78681, '3.40.50.300-FF-007152', NULL, 'ARF-like small GTPase', 176, NULL, NULL, 78681),
(78682, '3.40.50.720-FF-002129', NULL, 'Uncharacterized protein', 105, NULL, NULL, 78682),
(78683, '1.20.1070.10-FF-000764', NULL, 'Muscarinic acetylcholine receptor', 282, NULL, NULL, 78683),
(78684, '3.30.70.3310-FF-000002', NULL, 'Neurogenic locus notch homolog protein 3', 137, NULL, NULL, 78684),
(78685, '1.20.58.1220-FF-000018', NULL, 'Predicted protein', 102, NULL, NULL, 78685),
(78686, '3.80.20.20-FF-000091', NULL, 'Predicted protein', 95, NULL, NULL, 78686),
(78687, '3.40.50.2300-FF-000972', NULL, 'Receptor-type guanylate cyclase gcy-5', 199, NULL, NULL, 78687),
(78688, '1.20.58.70-FF-000087', NULL, 'Syntaxin-12', 116, NULL, NULL, 78688),
(78689, '1.10.10.10-FF-000488', NULL, 'Ferric uptake regulator family protein', 90, NULL, NULL, 78689),
(78690, '1.25.10.10-FF-002000', NULL, 'YALI0D22440p', 251, NULL, NULL, 78690),
(78691, '3.40.50.300-FF-008349', NULL, 'Phospholipid-lipopolysaccharide ABC transporter', 253, NULL, NULL, 78691),
(78692, '3.40.50.1820-FF-001789', NULL, 'Predicted protein', 164, NULL, NULL, 78692),
(78693, '1.20.58.1210-FF-000015', NULL, 'Chromosome 12, whole genome shotgun sequence', 119, NULL, NULL, 78693),
(78694, '3.40.630.40-FF-000024', NULL, 'Uncharacterized protein', 188, NULL, NULL, 78694),
(78695, '1.20.1250.20-FF-000040', NULL, 'Solute carrier family 2, facilitated glucose transporter member 1', 453, NULL, NULL, 78695),
(78696, '3.40.630.30-FF-000021', NULL, 'Serotonin N-acetyltransferase', 166, NULL, NULL, 78696),
(78697, '3.30.479.30-FF-000047', NULL, 'Predicted protein', 105, NULL, NULL, 78697),
(78698, '3.40.50.2300-FF-000079', NULL, 'ABC transporter periplasmic-binding protein ytfQ', 142, NULL, NULL, 78698),
(78699, '3.40.50.1000-FF-000796', NULL, NULL, 162, NULL, NULL, 78699),
(78700, '3.30.70.360-FF-000043', NULL, 'ACY1L2 protein, putative', 65, NULL, NULL, 78700),
(78701, '1.25.40.10-FF-001552', NULL, 'Predicted protein', 135, NULL, NULL, 78701),
(78702, '2.60.40.1530-FF-000023', NULL, NULL, 135, NULL, NULL, 78702),
(78703, '3.40.50.150-FF-001519', NULL, NULL, 107, NULL, NULL, 78703),
(78704, '3.30.40.10-FF-000809', NULL, 'RING-type E3 ubiquitin transferase', 72, NULL, NULL, 78704),
(78705, '1.20.930.10-FF-000022', NULL, 'Mediator of RNA polymerase II transcription subunit 26', 96, NULL, NULL, 78705),
(78706, '2.60.40.420-FF-000092', NULL, 'Cytochrome C oxidase subunit II', 177, NULL, NULL, 78706),
(78707, '1.10.510.10-FF-001162', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 205, NULL, NULL, 78707),
(78708, '3.80.10.10-FF-002060', NULL, 'Uncharacterized protein', 90, NULL, NULL, 78708),
(78709, '1.25.10.10-FF-001045', NULL, 'RING-type E3 ubiquitin transferase', 207, NULL, NULL, 78709),
(78710, '1.10.8.270-FF-000069', NULL, 'TBC/Rab GTPase activating domain containing protein', 108, NULL, NULL, 78710),
(78711, '3.90.1150.10-FF-000360', NULL, 'Blr5429 protein', 119, NULL, NULL, 78711),
(78712, '3.40.50.11600-FF-000001', NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit gamma', 129, NULL, NULL, 78712),
(78713, '3.30.2350.10-FF-000052', NULL, 'RNA pseudouridine synthase 6, chloroplastic', 260, NULL, NULL, 78713),
(78714, '2.60.120.200-FF-000541', NULL, 'Neurexin I isoform B', 184, NULL, NULL, 78714),
(78715, '1.25.40.20-FF-001257', NULL, 'Uncharacterized protein', 217, NULL, NULL, 78715),
(78716, '3.40.190.10-FF-000453', NULL, 'LysR family transcriptional regulator', 94, NULL, NULL, 78716),
(78717, '1.10.8.100-FF-000007', NULL, 'Mitochondrial transcription factor', 75, NULL, NULL, 78717),
(78718, '1.25.40.20-FF-001555', NULL, 'Uncharacterized protein', 104, NULL, NULL, 78718);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(78719, '3.40.50.300-FF-003178', NULL, 'arf-GAP with GTPase, ANK repeat and PH domain-containing protein 1 isoform X7', 106, NULL, NULL, 78719),
(78720, '3.30.70.2240-FF-000001', NULL, 'Krev interaction trapped protein 1', 136, NULL, NULL, 78720),
(78721, '3.30.519.10-FF-000006', NULL, 'Rab GDP dissociation inhibitor', 162, NULL, NULL, 78721),
(78722, '3.40.1190.20-FF-000101', NULL, 'Predicted protein', 275, NULL, NULL, 78722),
(78723, '3.40.1390.30-FF-000024', NULL, 'Uncharacterized protein', 23, NULL, NULL, 78723),
(78724, '1.10.10.60-FF-000519', NULL, 'Homeobox transcription factor', 86, NULL, NULL, 78724),
(78725, '1.20.1560.10-FF-000852', NULL, 'Uncharacterized protein', 268, NULL, NULL, 78725),
(78726, '1.10.287.70-FF-000018', NULL, 'Voltage-dependent T-type calcium channel subunit alpha', 178, NULL, NULL, 78726),
(78727, '2.60.40.1120-FF-000075', NULL, 'Putative outer membrane protein', 78, NULL, NULL, 78727),
(78728, '2.40.320.10-FF-000024', NULL, 'Uncharacterized protein', 221, NULL, NULL, 78728),
(78729, '3.60.40.10-FF-000213', NULL, 'Protein phosphatase 2C, putative', 282, NULL, NULL, 78729),
(78730, '2.60.40.10-FF-001154', NULL, 'Sallimus, isoform Q', 113, NULL, NULL, 78730),
(78731, '2.40.240.10-FF-000023', NULL, 'Glutamine--tRNA ligase', 121, NULL, NULL, 78731),
(78732, '3.30.450.190-FF-000022', NULL, 'Gtr1/RagA G protein conserved region-domain-containing protein', 132, NULL, NULL, 78732),
(78733, '3.40.50.720-FF-002281', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 237, NULL, NULL, 78733),
(78734, '3.30.2350.20-FF-000055', NULL, NULL, 168, NULL, NULL, 78734),
(78735, '2.40.170.20-FF-000088', NULL, 'SusC homolog', 617, NULL, NULL, 78735),
(78736, '3.40.50.300-FF-001379', NULL, 'Nitrogenase iron protein 1', 289, NULL, NULL, 78736),
(78737, '1.25.40.770-FF-000016', NULL, 'Uncharacterized protein', 80, NULL, NULL, 78737),
(78738, '2.60.40.10-FF-006100', NULL, NULL, 83, NULL, NULL, 78738),
(78739, '3.80.10.10-FF-000317', NULL, 'Inactive leucine-rich repeat receptor-like protein kinase', 296, NULL, NULL, 78739),
(78740, '3.30.160.60-FF-002795', NULL, NULL, 29, NULL, NULL, 78740),
(78741, '3.90.190.10-FF-000138', NULL, 'Unplaced genomic scaffold supercont1.18, whole genome shotgun sequence', 140, NULL, NULL, 78741),
(78742, '3.30.1370.10-FF-000199', NULL, 'Uncharacterized protein', 59, NULL, NULL, 78742),
(78743, '2.40.10.10-FF-000439', NULL, NULL, 94, NULL, NULL, 78743),
(78744, '4.10.1060.10-FF-000011', NULL, 'ubiquitin thioesterase ZRANB1 isoform X1', 44, NULL, NULL, 78744),
(78745, '3.30.70.330-FF-002934', NULL, NULL, 118, NULL, NULL, 78745),
(78746, '3.90.660.10-FF-000017', NULL, 'Lysine-specific histone demethylase Aof2, putative', 177, NULL, NULL, 78746),
(78747, '3.30.70.330-FF-000905', NULL, 'RNA-binding family protein', 112, NULL, NULL, 78747),
(78748, '3.40.30.10-FF-000090', NULL, 'Glutaredoxin-3', 96, NULL, NULL, 78748),
(78749, '3.30.420.40-FF-000769', NULL, 'YALI0E31551p', 141, NULL, NULL, 78749),
(78750, '1.20.1540.10-FF-000025', NULL, 'Putative rhomboid family', 164, NULL, NULL, 78750),
(78751, '3.40.570.10-FF-000038', NULL, 'Uncharacterized protein', 176, NULL, NULL, 78751),
(78752, '2.130.10.10-FF-002559', NULL, 'Os02g0136933 protein', 292, NULL, NULL, 78752),
(78753, '3.40.50.300-FF-007562', NULL, 'Putative ATP-binding cassette protein subfamily H,member 3', 186, NULL, NULL, 78753),
(78754, '2.60.40.10-FF-000991', NULL, 'Usherin', 74, NULL, NULL, 78754),
(78755, '3.30.470.20-FF-000137', NULL, '30S ribosomal protein S6 modification protein RimK', 112, NULL, NULL, 78755),
(78756, '3.30.200.20-FF-000505', NULL, 'ephrin type-A receptor 10', 107, NULL, NULL, 78756),
(78757, '3.40.50.1460-FF-000006', NULL, 'Legumain', 283, NULL, NULL, 78757),
(78758, '3.30.9.10-FF-000052', NULL, 'Putative glycine oxidase', 167, NULL, NULL, 78758),
(78759, '2.40.37.10-FF-000068', NULL, NULL, 16, NULL, NULL, 78759),
(78760, '1.20.1070.10-FF-000146', NULL, 'putative P2Y purinoceptor 10 isoform X1', 306, NULL, NULL, 78760),
(78761, '1.20.1420.10-FF-000016', NULL, 'Cyclin-D1-binding protein', 151, NULL, NULL, 78761);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(78762, '3.50.50.60-FF-000347', NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase', 254, NULL, NULL, 78762),
(78763, '2.120.10.80-FF-000198', NULL, 'Predicted protein', 290, NULL, NULL, 78763),
(78764, '2.10.110.10-FF-000346', NULL, 'Uncharacterized protein', 90, NULL, NULL, 78764),
(78765, '3.40.190.80-FF-000024', NULL, 'Inositol monophosphatase family protein', 136, NULL, NULL, 78765),
(78766, '3.40.50.2000-FF-000707', NULL, 'Glycosyltransferase WbpZ', 172, NULL, NULL, 78766),
(78767, '2.40.50.140-FF-000508', NULL, 'ATP-dependent DNA helicase RecG', 93, NULL, NULL, 78767),
(78768, '3.10.110.10-FF-000365', NULL, 'RBR-type E3 ubiquitin transferase', 133, NULL, NULL, 78768),
(78769, '3.30.390.50-FF-000033', NULL, 'AGAP006221-PA', 48, NULL, NULL, 78769),
(78770, '1.20.1050.10-FF-000151', NULL, 'Uncharacterized protein', 34, NULL, NULL, 78770),
(78771, '3.10.129.10-FF-000071', NULL, 'Thioesterase-like family protein', 138, NULL, NULL, 78771),
(78772, '3.40.50.300-FF-007332', NULL, 'Uncharacterized protein', 143, NULL, NULL, 78772),
(78773, '2.60.40.640-FF-000068', NULL, 'Aspergillus niger contig An11c0110, genomic contig', 105, NULL, NULL, 78773),
(78774, '2.60.40.10-FF-005083', NULL, NULL, 100, NULL, NULL, 78774),
(78775, '3.30.70.270-FF-000308', NULL, NULL, 41, NULL, NULL, 78775),
(78776, '3.30.70.330-FF-000164', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 81, NULL, NULL, 78776),
(78777, '1.10.287.280-FF-000003', NULL, 'DNA-directed RNA polymerase', 77, NULL, NULL, 78777),
(78778, '3.40.50.300-FF-000587', NULL, 'von Willebrand factor A domain containing 8', 189, NULL, NULL, 78778),
(78779, '3.40.50.1470-FF-000009', NULL, 'Peptidyl-tRNA hydrolase 1 homolog', 192, NULL, NULL, 78779),
(78780, '2.130.10.10-FF-001424', NULL, 'Damaged DNA binding protein', 345, NULL, NULL, 78780),
(78781, '3.40.50.10490-FF-000117', NULL, NULL, 191, NULL, NULL, 78781),
(78782, '3.90.1530.30-FF-000007', NULL, 'DNA-binding protein', 69, NULL, NULL, 78782),
(78783, '2.60.40.60-FF-000657', NULL, 'Cadherin 16', 115, NULL, NULL, 78783),
(78784, '3.30.457.50-FF-000008', NULL, NULL, 104, NULL, NULL, 78784),
(78785, '1.10.510.10-FF-003461', NULL, NULL, 274, NULL, NULL, 78785),
(78786, '1.20.90.10-FF-000043', NULL, NULL, 59, NULL, NULL, 78786),
(78787, '3.30.160.60-FF-004594', NULL, NULL, 67, NULL, NULL, 78787),
(78788, '2.60.40.10-FF-000878', NULL, 'T cell receptor alpha variable 38-1', 102, NULL, NULL, 78788),
(78789, '1.25.10.10-FF-003074', NULL, 'Nuclear pre-mRNA splicing factor, component of splicing factor 3b', 247, NULL, NULL, 78789),
(78790, '1.25.10.10-FF-000668', NULL, 'Protein DOA1', 252, NULL, NULL, 78790),
(78791, '1.20.900.10-FF-000133', NULL, 'Probable serine/threonine-protein kinase roco5', 232, NULL, NULL, 78791),
(78792, '3.40.50.11610-FF-000004', NULL, '2-oxoglutarate dehydrogenase, mitochondrial isoform X1', 175, NULL, NULL, 78792),
(78793, '3.40.50.720-FF-002337', NULL, 'Uncharacterized protein', 167, NULL, NULL, 78793),
(78794, '1.10.720.30-FF-000020', NULL, 'Cell division cycle and apoptosis regulator 1', 48, NULL, NULL, 78794),
(78795, '3.30.428.10-FF-000042', NULL, 'Uncharacterized protein', 113, NULL, NULL, 78795),
(78796, '2.30.30.140-FF-000052', NULL, 'SAGA-associated factor 29 isoform X6', 64, NULL, NULL, 78796),
(78797, '3.40.50.300-FF-001104', NULL, 'DNA polymerase clamp loader subunit', 161, NULL, NULL, 78797),
(78798, '3.30.160.60-FF-005257', NULL, NULL, 71, NULL, NULL, 78798),
(78799, '3.40.390.10-FF-000316', NULL, NULL, 134, NULL, NULL, 78799),
(78800, '1.10.10.10-FF-000696', NULL, 'DNA-directed RNA polymerase III subunit rpc3', 80, NULL, NULL, 78800),
(78801, '3.75.10.10-FF-000037', NULL, NULL, 150, NULL, NULL, 78801),
(78802, '1.25.40.860-FF-000032', NULL, 'Uncharacterized protein', 51, NULL, NULL, 78802),
(78803, '3.40.250.10-FF-000109', NULL, 'Thiosulfate sulfurtransferase', 146, NULL, NULL, 78803),
(78804, '3.30.70.330-FF-002316', NULL, NULL, 139, NULL, NULL, 78804),
(78805, '3.40.50.1450-FF-000003', NULL, 'Hydrogenase 3 maturation endopeptidase HyCI', 156, NULL, NULL, 78805);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(78806, '1.25.40.570-FF-000046', NULL, 'YALI0F16874p', 343, NULL, NULL, 78806),
(78807, '1.20.120.1630-FF-000008', NULL, 'C-14 sterol reductase', 199, NULL, NULL, 78807),
(78808, '3.80.10.10-FF-000261', NULL, 'LRR receptor-like serine/threonine-protein kinase ERECTA', 74, NULL, NULL, 78808),
(78809, '3.40.50.1000-FF-000588', NULL, NULL, 126, NULL, NULL, 78809),
(78810, '1.25.40.10-FF-002777', NULL, 'Uncharacterized protein', 357, NULL, NULL, 78810),
(78811, '1.20.1280.50-FF-000123', NULL, 'WGS project CABT00000000 data, contig 2.25', 88, NULL, NULL, 78811),
(78812, '3.80.10.10-FF-002380', NULL, 'Uncharacterized protein', 131, NULL, NULL, 78812),
(78813, '3.30.40.10-FF-002047', NULL, 'Uncharacterized protein', 93, NULL, NULL, 78813),
(78814, '3.50.50.60-FF-001162', NULL, 'FAD/NAD(P)-binding oxidoreductase family protein', 42, NULL, NULL, 78814),
(78815, '3.40.50.10490-FF-000106', NULL, NULL, 146, NULL, NULL, 78815),
(78816, '2.70.98.90-FF-000006', NULL, 'Membrane protein insertase YidC', 275, NULL, NULL, 78816),
(78817, '3.40.850.10-FF-000189', NULL, 'Uncharacterized protein', 125, NULL, NULL, 78817),
(78818, '2.130.10.10-FF-000761', NULL, 'Putative nucleolar preribosomal assembly protein', 184, NULL, NULL, 78818),
(78819, '2.40.50.140-FF-000385', NULL, 'rRNA biogenesis protein RRP5, putative', 89, NULL, NULL, 78819),
(78820, '3.90.190.10-FF-000470', NULL, 'Predicted protein', 181, NULL, NULL, 78820),
(78821, '3.50.50.60-FF-000886', NULL, 'Uncharacterized protein', 310, NULL, NULL, 78821),
(78822, '1.10.405.20-FF-000010', NULL, NULL, 124, NULL, NULL, 78822),
(78823, '3.30.40.10-FF-000731', NULL, 'E3 ubiquitin-protein ligase RMA1', 129, NULL, NULL, 78823),
(78824, '1.25.10.10-FF-003017', NULL, 'Uncharacterized protein', 330, NULL, NULL, 78824),
(78825, '2.60.40.10-FF-005044', NULL, NULL, 102, NULL, NULL, 78825),
(78826, '1.25.40.10-FF-000496', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 111, NULL, NULL, 78826),
(78827, '2.30.29.30-FF-000112', NULL, 'active breakpoint cluster region-related protein isoform X2', 148, NULL, NULL, 78827),
(78828, '2.10.25.10-FF-000160', NULL, 'latent-transforming growth factor beta-binding protein 4 isoform X2', 43, NULL, NULL, 78828),
(78829, '3.20.20.100-FF-000188', NULL, 'Uncharacterized protein', 111, NULL, NULL, 78829),
(78830, '1.10.287.2620-FF-000015', NULL, 'Dynein heavy chain, putative', 64, NULL, NULL, 78830),
(78831, '1.25.40.710-FF-000015', NULL, 'Tripeptidyl-peptidase 2 homolog', 215, NULL, NULL, 78831),
(78832, '1.10.3720.10-FF-000093', NULL, 'Iron(III) ABC transporter, permease protein', 261, NULL, NULL, 78832),
(78833, '1.10.8.1220-FF-000004', NULL, 'Dynein heavy chain, cytoplasmic', 91, NULL, NULL, 78833),
(78834, '2.30.29.30-FF-000651', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', 94, NULL, NULL, 78834),
(78835, '3.30.70.330-FF-000782', NULL, 'Polyadenylate-binding protein', 96, NULL, NULL, 78835),
(78836, '1.20.1410.10-FF-000021', NULL, 'Putative transmembrane protein', 171, NULL, NULL, 78836),
(78837, '1.20.120.560-FF-000006', NULL, 'Vacuolar-sorting protein BRO1', 147, NULL, NULL, 78837),
(78838, '1.25.40.10-FF-005262', NULL, 'TPR-repeat-containing chaperone protein DNAJ, putative', 156, NULL, NULL, 78838),
(78839, '3.30.420.10-FF-000131', NULL, 'Protein CBG26278', 193, NULL, NULL, 78839),
(78840, '2.130.10.10-FF-005353', NULL, 'Uncharacterized protein', 177, NULL, NULL, 78840),
(78841, '2.60.40.10-FF-004768', NULL, NULL, 95, NULL, NULL, 78841),
(78842, '3.30.420.10-FF-000311', NULL, 'Ribonuclease H-like domain-containing protein', 172, NULL, NULL, 78842),
(78843, '1.10.287.3990-FF-000004', NULL, '26S proteasome regulatory subunit N10', 85, NULL, NULL, 78843),
(78844, '3.30.360.10-FF-000098', NULL, 'Homoserine dehydrogenase', 144, NULL, NULL, 78844),
(78845, '3.30.450.20-FF-000523', NULL, 'Hybrid signal transduction histidine kinase A', 63, NULL, NULL, 78845),
(78846, '2.60.120.200-FF-000153', NULL, 'neurexin-1 isoform X3', 192, NULL, NULL, 78846),
(78847, '3.30.70.330-FF-001220', NULL, 'NTF2 and RRM domain protein', 155, NULL, NULL, 78847);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(78848, '2.170.300.10-FF-000003', NULL, 'tyrosine-protein kinase receptor Tie-1 isoform X1', 134, NULL, NULL, 78848),
(78849, '3.40.50.150-FF-001632', NULL, NULL, 237, NULL, NULL, 78849),
(78850, '1.20.1560.10-FF-000313', NULL, 'ABC transporter ATP-binding protein/permease', 331, NULL, NULL, 78850),
(78851, '1.10.8.1210-FF-000001', NULL, 'Glutamate dehydrogenase', 49, NULL, NULL, 78851),
(78852, '1.20.1070.10-FF-001574', NULL, 'Uncharacterized protein', 162, NULL, NULL, 78852),
(78853, '1.20.1540.10-FF-000082', NULL, 'Uncharacterized protein', 186, NULL, NULL, 78853),
(78854, '2.60.40.10-FF-003363', NULL, NULL, 81, NULL, NULL, 78854),
(78855, '1.50.40.10-FF-000061', NULL, 'ADP/ATP transporter on adenylate translocase', 297, NULL, NULL, 78855),
(78856, '1.10.287.3980-FF-000001', NULL, 'Mitochondrial ribosomal protein L34', 45, NULL, NULL, 78856),
(78857, '3.90.1530.10-FF-000001', NULL, 'Sulfiredoxin', 96, NULL, NULL, 78857),
(78858, '2.60.40.10-FF-003306', NULL, 'Leukemia inhibitory factor receptor alpha b', 82, NULL, NULL, 78858),
(78859, '3.30.1330.90-FF-000006', NULL, 'L-serine ammonia-lyase', 60, NULL, NULL, 78859),
(78860, '1.10.472.10-FF-000095', NULL, 'Cyclin Ccl1, putative (AFU_orthologue AFUA_5G07030)', 174, NULL, NULL, 78860),
(78861, '3.20.20.300-FF-000068', NULL, NULL, 198, NULL, NULL, 78861),
(78862, '3.90.190.10-FF-000413', NULL, 'Predicted protein', 106, NULL, NULL, 78862),
(78863, '3.10.180.10-FF-000077', NULL, 'Glyoxalase/bleomycin resistance protein/dioxygenase', 134, NULL, NULL, 78863),
(78864, '3.30.40.10-FF-000170', NULL, 'E3 ubiquitin-protein ligase SHPRH isoform X1', 58, NULL, NULL, 78864),
(78865, '3.60.15.10-FF-000172', NULL, 'Integrator complex subunit 11 isoform X3', 75, NULL, NULL, 78865),
(78866, '2.30.29.30-FF-000319', NULL, 'Dynamin 1', 107, NULL, NULL, 78866),
(78867, '3.40.50.12780-FF-000091', NULL, 'Putative long-chain-fatty-acid--CoA ligase', 374, NULL, NULL, 78867),
(78868, '3.30.1010.10-FF-000009', NULL, 'Phosphatidylinositol 4-kinase, catalytic, alpha', 172, NULL, NULL, 78868),
(78869, '3.40.640.10-FF-000477', NULL, 'Alanine aminotransferase 2 mitochondrial', 83, NULL, NULL, 78869),
(78870, '1.25.40.10-FF-003233', NULL, 'TPR repeat, putative', 200, NULL, NULL, 78870),
(78871, '3.40.630.40-FF-000013', NULL, 'N-acetylmuramoyl-L-alanine amidase', 209, NULL, NULL, 78871),
(78872, '2.130.10.10-FF-000968', NULL, 'Hermansky-Pudlak syndrome 5 protein homolog', 188, NULL, NULL, 78872),
(78873, '3.40.50.11060-FF-000007', NULL, 'GTPase HflX', 45, NULL, NULL, 78873),
(78874, '2.60.40.420-FF-000215', NULL, 'Hephaestin-like 1a', 200, NULL, NULL, 78874),
(78875, '4.10.280.10-FF-000103', NULL, 'Transcription factor bHLH162', 85, NULL, NULL, 78875),
(78876, '3.30.505.10-FF-000103', NULL, 'Si:ch73-109i22.2', 96, NULL, NULL, 78876),
(78877, '3.40.630.30-FF-000010', NULL, 'Putative N-alpha-acetyltransferase 30', 144, NULL, NULL, 78877),
(78878, '1.10.472.170-FF-000016', NULL, 'Cyclin family protein', 200, NULL, NULL, 78878),
(78879, '3.90.70.10-FF-000528', NULL, 'YALI0F01903p', 64, NULL, NULL, 78879),
(78880, '1.10.8.60-FF-000041', NULL, 'DNA polymerase III subunit delta', 71, NULL, NULL, 78880),
(78881, '2.70.50.40-FF-000011', NULL, 'Uncharacterized protein', 165, NULL, NULL, 78881),
(78882, '2.60.40.10-FF-002469', NULL, 'Muscle M-line assembly protein unc-89', 110, NULL, NULL, 78882),
(78883, '3.40.50.300-FF-005353', NULL, 'Replication factor C subunit 1', 186, NULL, NULL, 78883),
(78884, '3.40.50.300-FF-004870', NULL, 'Predicted protein', 191, NULL, NULL, 78884),
(78885, '3.30.40.10-FF-002322', NULL, 'Lid2 complex component snt2', 100, NULL, NULL, 78885),
(78886, '1.10.238.10-FF-001287', NULL, 'Uncharacterized protein', 87, NULL, NULL, 78886),
(78887, '2.60.120.10-FF-000324', NULL, 'Mannose-6-phosphate isomerase', 87, NULL, NULL, 78887),
(78888, '3.30.230.10-FF-000094', NULL, 'DNA mismatch repair protein PMS1', 124, NULL, NULL, 78888),
(78889, '1.10.238.10-FF-001023', NULL, 'Calcium-binding EF hand family protein', 64, NULL, NULL, 78889),
(78890, '1.25.40.10-FF-000439', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 151, NULL, NULL, 78890);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(78891, '3.30.160.60-FF-003402', NULL, 'YALI0D05041p', 30, NULL, NULL, 78891),
(78892, '3.40.50.720-FF-002051', NULL, 'Uncharacterized protein', 173, NULL, NULL, 78892),
(78893, '3.30.160.60-FF-004717', NULL, NULL, 68, NULL, NULL, 78893),
(78894, '1.20.1070.10-FF-000326', NULL, 'Free fatty acid receptor 4', 208, NULL, NULL, 78894),
(78895, '2.40.50.770-FF-000012', NULL, 'Uncharacterized protein', 156, NULL, NULL, 78895),
(78896, '3.90.1010.10-FF-000024', NULL, 'IscU', 118, NULL, NULL, 78896),
(78897, '1.25.10.10-FF-001483', NULL, 'RING-type E3 ubiquitin transferase', 266, NULL, NULL, 78897),
(78898, '1.10.10.60-FF-000957', NULL, NULL, 61, NULL, NULL, 78898),
(78899, '1.10.1170.10-FF-000049', NULL, 'baculoviral IAP repeat-containing protein 3', 104, NULL, NULL, 78899),
(78900, '1.10.630.10-FF-000243', NULL, 'Uncharacterized protein', 466, NULL, NULL, 78900),
(78901, '3.80.10.10-FF-000547', NULL, 'Si:dkeyp-100h4.1', 208, NULL, NULL, 78901),
(78902, '3.40.366.10-FF-000002', NULL, 'Probable polyketide synthase 2', 309, NULL, NULL, 78902),
(78903, '3.80.10.10-FF-003807', NULL, 'SCF E3 ubiquitin ligase complex F-box protein pof2', 86, NULL, NULL, 78903),
(78904, '1.20.1250.20-FF-000545', NULL, 'Alpha-ketoglutarate permease', 197, NULL, NULL, 78904),
(78905, '3.60.40.10-FF-000134', NULL, 'Stage II sporulation protein E', 214, NULL, NULL, 78905),
(78906, '1.20.1250.20-FF-001905', NULL, 'Uncharacterized protein', 244, NULL, NULL, 78906),
(78907, '3.40.50.300-FF-008580', NULL, 'Uncharacterized protein', 154, NULL, NULL, 78907),
(78908, '3.40.50.1820-FF-000311', NULL, 'Prolyl endopeptidase like', 24, NULL, NULL, 78908),
(78909, '3.30.160.60-FF-005611', NULL, NULL, 31, NULL, NULL, 78909),
(78910, '3.30.1010.10-FF-000066', NULL, 'AGAP003967-PA', 163, NULL, NULL, 78910),
(78911, '1.20.1270.60-FF-000300', NULL, 'Uncharacterized protein', 128, NULL, NULL, 78911),
(78912, '3.90.226.10-FF-000155', NULL, 'Enoyl-CoA hydratase/isomerase family protein, expressed', 226, NULL, NULL, 78912),
(78913, '2.10.25.10-FF-001784', NULL, 'NIDogen (Basement membrane protein)', 32, NULL, NULL, 78913),
(78914, '3.40.50.80-FF-000235', NULL, 'Uncharacterized protein', 102, NULL, NULL, 78914),
(78915, '3.30.70.660-FF-000032', NULL, 'U2 snRNA/tRNA pseudouridine synthase, putative', 300, NULL, NULL, 78915),
(78916, '3.40.50.2000-FF-000444', NULL, 'Alpha-1,2-mannosyltransferase (Alg2), putative', 204, NULL, NULL, 78916),
(78917, '2.60.40.60-FF-001039', NULL, 'Predicted protein', 97, NULL, NULL, 78917),
(78918, '3.40.50.150-FF-001637', NULL, NULL, 234, NULL, NULL, 78918),
(78919, '2.60.40.10-FF-003806', NULL, NULL, 107, NULL, NULL, 78919),
(78920, '3.40.50.12780-FF-000208', NULL, 'Predicted protein', 234, NULL, NULL, 78920),
(78921, '3.80.10.10-FF-002228', NULL, 'Uncharacterized protein', 193, NULL, NULL, 78921),
(78922, '3.40.50.300-FF-003116', NULL, 'Predicted protein', 259, NULL, NULL, 78922),
(78923, '3.30.160.20-FF-000102', NULL, 'DExH-box ATP-dependent RNA helicase DExH7 chloroplastic', 64, NULL, NULL, 78923),
(78924, '3.40.50.970-FF-000192', NULL, 'Predicted protein', 219, NULL, NULL, 78924),
(78925, '3.90.1170.40-FF-000004', NULL, 'Molybdopterin biosynthesis protein MoeE', 140, NULL, NULL, 78925),
(78926, '2.40.10.10-FF-000557', NULL, NULL, 73, NULL, NULL, 78926),
(78927, '1.20.1720.10-FF-000112', NULL, NULL, 53, NULL, NULL, 78927),
(78928, '3.30.1490.180-FF-000031', NULL, 'DNA-directed RNA polymerase subunit', 90, NULL, NULL, 78928),
(78929, '2.30.42.10-FF-000362', NULL, 'Periplasmic serine endoprotease DegP-like', 88, NULL, NULL, 78929),
(78930, '1.20.1250.20-FF-000540', NULL, 'MFS transporter, putative', 217, NULL, NULL, 78930),
(78931, '3.90.550.10-FF-000189', NULL, 'Abequosyltransferase RfbV', 201, NULL, NULL, 78931),
(78932, '3.80.10.10-FF-004420', NULL, 'Receptor-like protein 14', 144, NULL, NULL, 78932),
(78933, '3.30.160.60-FF-005375', NULL, NULL, 88, NULL, NULL, 78933),
(78934, '1.20.1740.10-FF-000063', NULL, 'Inner membrane transporter YjeM', 491, NULL, NULL, 78934),
(78935, '3.40.20.10-FF-000145', NULL, 'Villidin', 116, NULL, NULL, 78935);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(78936, '3.60.10.10-FF-000149', NULL, 'Endonuclease/exonuclease/phosphatase, putative', 199, NULL, NULL, 78936),
(78937, '2.130.10.10-FF-004919', NULL, 'Os01g0607600 protein', 107, NULL, NULL, 78937),
(78938, '1.10.8.270-FF-000187', NULL, 'Uncharacterized protein', 126, NULL, NULL, 78938),
(78939, '3.40.50.300-FF-001941', NULL, 'Mov10 RISC complex RNA helicase', 276, NULL, NULL, 78939),
(78940, '3.40.50.20-FF-000032', NULL, 'D-alanine--D-alanine ligase', 106, NULL, NULL, 78940),
(78941, '3.10.580.10-FF-000225', NULL, 'Chloride channel protein', 81, NULL, NULL, 78941),
(78942, '1.10.10.60-FF-000688', NULL, 'Homeobox transcription factor (RfeB)', 114, NULL, NULL, 78942),
(78943, '1.20.120.1240-FF-000010', NULL, 'Dynamin-related protein 5A', 255, NULL, NULL, 78943),
(78944, '3.30.590.10-FF-000025', NULL, 'Glutamine synthetase', 336, NULL, NULL, 78944),
(78945, '3.40.50.800-FF-000124', NULL, 'Predicted protein', 58, NULL, NULL, 78945),
(78946, '3.50.50.60-FF-000908', NULL, 'Protoporphyrinogen oxidase', 520, NULL, NULL, 78946),
(78947, '1.20.58.60-FF-000320', NULL, 'VAB-10A protein', 112, NULL, NULL, 78947),
(78948, '3.40.30.10-FF-001219', NULL, '2-hydroxychromene-2-carboxylate isomerase, putative', 170, NULL, NULL, 78948),
(78949, '3.30.160.60-FF-002683', NULL, 'Uncharacterized protein, isoform B', 35, NULL, NULL, 78949),
(78950, '1.20.1110.10-FF-000032', NULL, 'Cation-transporting ATPase', 107, NULL, NULL, 78950),
(78951, '1.20.80.10-FF-000042', NULL, 'diazepam-binding inhibitor-like 5', 87, NULL, NULL, 78951),
(78952, '3.30.70.270-FF-000128', NULL, 'Transcriptional regulator CdgA', 159, NULL, NULL, 78952),
(78953, '2.30.29.30-FF-000269', NULL, 'Synaptosomal-associated protein 47', 103, NULL, NULL, 78953),
(78954, '3.40.50.1460-FF-000124', NULL, 'Caspase-4', 55, NULL, NULL, 78954),
(78955, '3.40.50.300-FF-007450', NULL, 'Uncharacterized protein', 247, NULL, NULL, 78955),
(78956, '4.10.400.10-FF-000310', NULL, 'Uncharacterized protein', 31, NULL, NULL, 78956),
(78957, '1.20.5.170-FF-000233', NULL, 'Probable basic-leucine zipper transcription factor G', 69, NULL, NULL, 78957),
(78958, '2.60.40.180-FF-000008', NULL, '5-hydroxyisourate hydrolase', 111, NULL, NULL, 78958),
(78959, '2.60.40.10-FF-000996', NULL, 'ICOS ligand isoform X2', 97, NULL, NULL, 78959),
(78960, '3.40.50.2300-FF-000472', NULL, 'Vomeronasal 2, receptor 120', 47, NULL, NULL, 78960),
(78961, '3.80.10.10-FF-001565', NULL, 'AGAP001807-PA', 104, NULL, NULL, 78961),
(78962, '3.20.20.80-FF-000127', NULL, 'Glycosyl hydrolases family 18 protein, expressed', 243, NULL, NULL, 78962),
(78963, '2.130.10.10-FF-000974', NULL, 'WD repeat domain 90', 138, NULL, NULL, 78963),
(78964, '3.30.420.140-FF-000046', NULL, 'Uncharacterized protein', 85, NULL, NULL, 78964),
(78965, '1.10.8.10-FF-000043', NULL, 'Fas-associated factor family member 2', 60, NULL, NULL, 78965),
(78966, '1.20.1560.10-FF-000021', NULL, 'ABC transporter B family member 6', 228, NULL, NULL, 78966),
(78967, '1.20.1270.60-FF-000070', NULL, 'Uncharacterized protein, isoform C', 221, NULL, NULL, 78967),
(78968, '3.90.199.10-FF-000012', NULL, 'DNA topoisomerase 2', 183, NULL, NULL, 78968),
(78969, '3.40.50.970-FF-000147', NULL, 'Pyruvate dehydrogenase E1 component subunit beta', 166, NULL, NULL, 78969),
(78970, '2.60.40.60-FF-001146', NULL, 'Predicted protein', 97, NULL, NULL, 78970),
(78971, '3.40.50.2000-FF-000551', NULL, 'Alpha-1,4 glucan phosphorylase', 92, NULL, NULL, 78971),
(78972, '3.40.50.620-FF-000396', NULL, 'Nuclear transcription factor Y subunit A-8', 159, NULL, NULL, 78972),
(78973, '3.30.70.330-FF-000282', NULL, 'Uncharacterized protein, isoform D', 79, NULL, NULL, 78973),
(78974, '1.20.1560.10-FF-000291', NULL, 'ABC multidrug transporter, putative', 626, NULL, NULL, 78974),
(78975, '3.10.129.10-FF-000239', NULL, 'Uncharacterized protein', 142, NULL, NULL, 78975),
(78976, '3.40.350.10-FF-000106', NULL, 'Uncharacterized protein', 95, NULL, NULL, 78976),
(78977, '2.60.40.60-FF-000871', NULL, 'Uncharacterized protein', 96, NULL, NULL, 78977),
(78978, '1.25.40.720-FF-000018', NULL, 'Predicted protein', 138, NULL, NULL, 78978);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(78979, '1.20.920.10-FF-000022', NULL, 'Putative bromodomain-containing protein 9', 118, NULL, NULL, 78979),
(78980, '3.40.50.620-FF-000514', NULL, 'Glutamyl-tRNA synthetase (AFU_orthologue AFUA_2G16280)', 267, NULL, NULL, 78980),
(78981, '1.20.1260.10-FF-000032', NULL, 'Ferritin', 142, NULL, NULL, 78981),
(78982, '1.25.40.10-FF-002912', NULL, 'YALI0F27753p', 188, NULL, NULL, 78982),
(78983, '1.10.3520.10-FF-000032', NULL, 'Uncharacterized protein', 135, NULL, NULL, 78983),
(78984, '1.20.1720.10-FF-000005', NULL, 'Bcr/CflA family efflux transporter', 380, NULL, NULL, 78984),
(78985, '2.120.10.30-FF-000380', NULL, 'Low-density lipoprotein RecePtor related', 316, NULL, NULL, 78985),
(78986, '1.20.120.1380-FF-000012', NULL, 'Flagellar biosynthesis protein FlhF', 21, NULL, NULL, 78986),
(78987, '3.90.70.80-FF-000094', NULL, 'Uncharacterized protein', 156, NULL, NULL, 78987),
(78988, '2.60.120.10-FF-000330', NULL, 'AraC family transcriptional regulator', 93, NULL, NULL, 78988),
(78989, '1.20.5.170-FF-000284', NULL, 'Hepatic leukemia factor-like protein', 52, NULL, NULL, 78989),
(78990, '3.90.1200.10-FF-000010', NULL, 'Maltokinase', 239, NULL, NULL, 78990),
(78991, '2.20.110.10-FF-000029', NULL, 'Protein ACCUMULATION AND REPLICATION OF CHLOROPLASTS 3', 73, NULL, NULL, 78991),
(78992, '4.10.60.30-FF-000001', NULL, 'nanos homolog 3', 70, NULL, NULL, 78992),
(78993, '2.30.29.30-FF-000325', NULL, 'Pleckstrin homology domain-containing family N member 1', 105, NULL, NULL, 78993),
(78994, '3.30.260.10-FF-000039', NULL, '60 kDa chaperonin 2', 91, NULL, NULL, 78994),
(78995, '3.40.50.150-FF-001014', NULL, 'Recombination and DNA repair', 290, NULL, NULL, 78995),
(78996, '2.120.10.30-FF-000273', NULL, 'Uncharacterized protein', 256, NULL, NULL, 78996),
(78997, '3.40.720.10-FF-000011', NULL, 'Non-specific phospholipase C1', 188, NULL, NULL, 78997),
(78998, '3.30.160.60-FF-001160', NULL, 'Zinc finger and BTB domain containing 41', 44, NULL, NULL, 78998),
(78999, '3.30.200.20-FF-000775', NULL, 'Uncharacterized protein', 97, NULL, NULL, 78999),
(79000, '3.60.15.10-FF-000138', NULL, 'Hypothetical_protein_-_conserved', 185, NULL, NULL, 79000),
(79001, '3.40.630.30-FF-000521', NULL, 'Polyketide synthase/nonribosomal peptide synthetase hybrid RzxA', 214, NULL, NULL, 79001),
(79002, '1.10.2040.10-FF-000001', NULL, 'Outer capsid protein mu-1', 122, NULL, NULL, 79002),
(79003, '3.40.50.1000-FF-000857', NULL, NULL, 50, NULL, NULL, 79003),
(79004, '1.50.10.10-FF-000020', NULL, 'Endoglucanase', 466, NULL, NULL, 79004),
(79005, '2.10.25.10-FF-000446', NULL, 'neurogenic locus notch homolog protein 3', 41, NULL, NULL, 79005),
(79006, '1.10.287.70-FF-000524', NULL, 'Predicted protein', 118, NULL, NULL, 79006),
(79007, '2.60.40.10-FF-005100', NULL, NULL, 99, NULL, NULL, 79007),
(79008, '2.160.20.80-FF-000022', NULL, NULL, 199, NULL, NULL, 79008),
(79009, '3.90.1150.10-FF-000247', NULL, 'Sphingosine phosphate lyase, putative', 117, NULL, NULL, 79009),
(79010, '1.10.287.130-FF-000048', NULL, 'Sensor histidine kinase/response regulator', 81, NULL, NULL, 79010),
(79011, '3.30.420.10-FF-000081', NULL, 'Exonuclease DPD1 chloroplastic/mitochondrial', 185, NULL, NULL, 79011),
(79012, '1.10.260.100-FF-000014', NULL, 'Hsc70-interacting protein', 60, NULL, NULL, 79012),
(79013, '3.40.50.11990-FF-000011', NULL, NULL, 176, NULL, NULL, 79013),
(79014, '3.30.420.10-FF-000193', NULL, 'Ribonuclease', 136, NULL, NULL, 79014),
(79015, '1.10.287.130-FF-000104', NULL, 'Sensor histidine kinase', 79, NULL, NULL, 79015),
(79016, '3.40.50.360-FF-000003', NULL, 'Nitric oxide synthase', 204, NULL, NULL, 79016),
(79017, '2.60.40.2860-FF-000017', NULL, 'Membrane protein PF12', 136, NULL, NULL, 79017),
(79018, '3.10.660.10-FF-000007', NULL, 'Diphthamide biosynthesis protein 4', 78, NULL, NULL, 79018),
(79019, '1.25.10.10-FF-001724', NULL, 'Uncharacterized protein', 210, NULL, NULL, 79019),
(79020, '3.40.50.300-FF-005533', NULL, 'Uncharacterized protein', 76, NULL, NULL, 79020),
(79021, '2.30.42.10-FF-000069', NULL, 'Nitric oxide synthase', 121, NULL, NULL, 79021);
INSERT INTO "PUBLIC"."MODEL" VALUES
(79022, '1.10.12.70-FF-000010', NULL, NULL, 53, NULL, NULL, 79022),
(79023, '1.20.1250.20-FF-002338', NULL, 'Uncharacterized protein', 95, NULL, NULL, 79023),
(79024, '3.40.50.720-FF-000252', NULL, 'UDP-sulfoquinovose synthase, chloroplastic', 234, NULL, NULL, 79024),
(79025, '3.30.565.10-FF-000287', NULL, 'Two-component hybrid sensor and regulator', 158, NULL, NULL, 79025),
(79026, '2.40.320.10-FF-000029', NULL, 'THTPA isoform 6', 88, NULL, NULL, 79026),
(79027, '3.30.565.10-FF-000068', NULL, 'Sensor-type histidine kinase prrB', 148, NULL, NULL, 79027),
(79028, '3.30.460.10-FF-000083', NULL, 'DNA polymerase sigma subunit', 111, NULL, NULL, 79028),
(79029, '1.10.10.950-FF-000001', NULL, 'Protein Rep68', 55, NULL, NULL, 79029),
(79030, '3.30.559.10-FF-000278', NULL, 'Uncharacterized protein', 53, NULL, NULL, 79030),
(79031, '1.25.40.10-FF-002856', NULL, 'Os08g0511000 protein', 104, NULL, NULL, 79031),
(79032, '2.130.10.10-FF-000699', NULL, 'POC1 centriolar protein homolog A', 132, NULL, NULL, 79032),
(79033, '3.40.50.10140-FF-000029', NULL, 'TOLl (Drosophila) family', 138, NULL, NULL, 79033),
(79034, '3.20.20.140-FF-000110', NULL, 'Dihydroorotase', 337, NULL, NULL, 79034),
(79035, '1.20.1250.20-FF-000247', NULL, 'MFS general substrate transporter', 196, NULL, NULL, 79035),
(79036, '1.10.630.10-FF-000322', NULL, 'Cytochrome P450, putative', 368, NULL, NULL, 79036),
(79037, '3.40.190.290-FF-000057', NULL, 'Putative Nitrogen assimilation regulatory protein Nac', 209, NULL, NULL, 79037),
(79038, '3.30.540.10-FF-000084', NULL, 'Inositol monophosphatase', 103, NULL, NULL, 79038),
(79039, '3.30.200.20-FF-000831', NULL, 'Homoserine kinase', 101, NULL, NULL, 79039),
(79040, '3.30.450.40-FF-000086', NULL, 'Phosphatase', 176, NULL, NULL, 79040),
(79041, '2.130.10.30-FF-000132', NULL, NULL, 284, NULL, NULL, 79041),
(79042, '3.40.50.300-FF-001722', NULL, 'ADP-ribosylation factor-like protein 2 isoform X2', 112, NULL, NULL, 79042),
(79043, '1.10.287.70-FF-000294', NULL, 'TOK potassium channel', 132, NULL, NULL, 79043),
(79044, '3.30.160.60-FF-000766', NULL, 'Zinc finger and BTB domain-containing 14', 27, NULL, NULL, 79044),
(79045, '3.30.200.20-FF-000887', NULL, 'Uncharacterized protein', 91, NULL, NULL, 79045),
(79046, '3.40.390.10-FF-000322', NULL, NULL, 258, NULL, NULL, 79046),
(79047, '2.40.10.190-FF-000004', NULL, 'LSU ribosomal protein L35AE', 92, NULL, NULL, 79047),
(79048, '1.25.40.20-FF-000768', NULL, 'Protein 21.1', 351, NULL, NULL, 79048),
(79049, '2.130.10.10-FF-001542', NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', 241, NULL, NULL, 79049),
(79050, '1.25.40.10-FF-000765', NULL, 'Uncharacterized protein', 105, NULL, NULL, 79050),
(79051, '2.40.10.350-FF-000018', NULL, 'Rod shape-determining protein MreC', 70, NULL, NULL, 79051),
(79052, '3.40.50.10810-FF-000197', NULL, 'Adenosinetriphosphatase', 205, NULL, NULL, 79052),
(79053, '3.30.40.10-FF-000462', NULL, 'Ring finger domain protein', 52, NULL, NULL, 79053),
(79054, '2.130.10.10-FF-000648', NULL, 'Autophagy-related 16, isoform A', 155, NULL, NULL, 79054),
(79055, '3.30.465.10-FF-000009', NULL, 'K(+)/H(+) antiporter NhaP2', 83, NULL, NULL, 79055),
(79056, '3.50.50.60-FF-000381', NULL, 'AGAP002616-PA', 118, NULL, NULL, 79056),
(79057, '3.40.50.300-FF-005033', NULL, 'Uncharacterized protein', 154, NULL, NULL, 79057),
(79058, '3.30.70.260-FF-000013', NULL, 'TyrR family transcriptional regulator', 81, NULL, NULL, 79058),
(79059, '3.30.310.80-FF-000020', NULL, 'Non-specific serine/threonine protein kinase', 126, NULL, NULL, 79059),
(79060, '2.40.30.270-FF-000038', NULL, 'DNA-binding protein Smubp-2, putative', 53, NULL, NULL, 79060),
(79061, '3.40.50.300-FF-006994', NULL, 'Uncharacterized protein', 212, NULL, NULL, 79061),
(79062, '3.40.50.2300-FF-000702', NULL, 'Low molecular weight protein-tyrosine-phosphatase', 153, NULL, NULL, 79062),
(79063, '3.30.1780.10-FF-000016', NULL, 'Ornithine cyclodeaminase', 142, NULL, NULL, 79063),
(79064, '1.20.1270.60-FF-000182', NULL, 'Autophagy-related protein 24', 217, NULL, NULL, 79064),
(79065, '3.30.559.10-FF-000227', NULL, 'Protein CBG17205', 175, NULL, NULL, 79065);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(79066, '2.60.120.10-FF-000004', NULL, 'Fumarate/nitrate reduction transcriptional regulator Fnr', 146, NULL, NULL, 79066),
(79067, '3.40.1820.10-FF-000001', NULL, 'DNA-directed DNA polymerase', 92, NULL, NULL, 79067),
(79068, '6.20.10.30-FF-000015', NULL, 'DNA ligase', 38, NULL, NULL, 79068),
(79069, '2.170.300.10-FF-000065', NULL, 'Uncharacterized protein', 109, NULL, NULL, 79069),
(79070, '1.20.58.340-FF-000014', NULL, 'CorA family metal ion transporter', 136, NULL, NULL, 79070),
(79071, '3.80.10.10-FF-002503', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 122, NULL, NULL, 79071),
(79072, '1.10.472.80-FF-000019', NULL, 'USP6 N-terminal like', 140, NULL, NULL, 79072),
(79073, '1.20.1050.10-FF-000263', NULL, 'Glutathione S-transferase 2', 131, NULL, NULL, 79073),
(79074, '4.10.410.10-FF-000024', NULL, 'Protein CBR-MEC-1', 81, NULL, NULL, 79074),
(79075, '3.40.50.620-FF-000626', NULL, 'Glutamine--tRNA ligase', 92, NULL, NULL, 79075),
(79076, '3.80.10.10-FF-003689', NULL, 'Uncharacterized protein', 185, NULL, NULL, 79076),
(79077, '3.30.2070.10-FF-000007', NULL, 'Dimethyl sulfoxide reductase', 52, NULL, NULL, 79077),
(79078, '1.10.640.10-FF-000036', NULL, 'AGAP013304-PA', 541, NULL, NULL, 79078),
(79079, '3.30.70.250-FF-000010', NULL, 'Sterigmatocystin biosynthesis polyketide synthase', 66, NULL, NULL, 79079),
(79080, '2.10.90.10-FF-000001', NULL, 'Bone morphogenetic protein 4', 113, NULL, NULL, 79080),
(79081, '3.40.50.720-FF-000656', NULL, 'Glucose-6-phosphate 1-dehydrogenase', 161, NULL, NULL, 79081),
(79082, '2.60.120.20-FF-000007', NULL, 'Capsid polyprotein VP90', 182, NULL, NULL, 79082),
(79083, '1.10.510.10-FF-004478', NULL, NULL, 257, NULL, NULL, 79083),
(79084, '1.10.510.10-FF-002792', NULL, NULL, 195, NULL, NULL, 79084),
(79085, '1.10.10.60-FF-000637', NULL, 'Bric-a-brac', 96, NULL, NULL, 79085),
(79086, '2.60.120.650-FF-000097', NULL, 'Unplaced genomic scaffold supercont2.18, whole genome shotgun sequence', 168, NULL, NULL, 79086),
(79087, '1.10.10.750-FF-000003', NULL, 'GTPase activating protein (Evi5)', 45, NULL, NULL, 79087),
(79088, '1.10.510.10-FF-001780', NULL, 'Uncharacterized protein', 294, NULL, NULL, 79088),
(79089, '3.90.1150.10-FF-000298', NULL, 'alanine--glyoxylate aminotransferase 2, mitochondrial isoform X2', 117, NULL, NULL, 79089),
(79090, '1.10.132.30-FF-000002', NULL, 'DNA-directed RNA polymerase subunit beta''''', 138, NULL, NULL, 79090),
(79091, '3.40.1690.20-FF-000004', NULL, 'ATP-dependent zinc metalloprotease FTSH 10 mitochondrial', 115, NULL, NULL, 79091),
(79092, '1.10.443.10-FF-000022', NULL, 'Prophage integrase IntE', 185, NULL, NULL, 79092),
(79093, '1.10.1060.10-FF-000041', NULL, NULL, 67, NULL, NULL, 79093),
(79094, '3.20.20.70-FF-000310', NULL, 'Dihydrodipicolinate synthase DapA', 300, NULL, NULL, 79094),
(79095, '3.30.160.20-FF-000046', NULL, 'Peptidyl-tRNA hydrolase ICT1', 140, NULL, NULL, 79095),
(79096, '2.60.120.290-FF-000174', NULL, 'Cubilin homolog', 118, NULL, NULL, 79096),
(79097, '3.30.1370.50-FF-000019', NULL, 'R3H-associated N-terminal domain containing protein, putative', 126, NULL, NULL, 79097),
(79098, '1.10.840.10-FF-000017', NULL, 'Blast:Ral guanine nucleotide dissociation stimulator-like 1', 277, NULL, NULL, 79098),
(79099, '3.40.50.1220-FF-000013', NULL, 'Pyruvate dehydrogenase [ubiquinone]', 155, NULL, NULL, 79099),
(79100, '3.40.50.300-FF-006663', NULL, 'Uncharacterized protein', 86, NULL, NULL, 79100),
(79101, '3.20.20.80-FF-000313', NULL, 'Uncharacterized protein', 182, NULL, NULL, 79101),
(79102, '3.40.1110.10-FF-000150', NULL, 'ATP7, isoform B', 181, NULL, NULL, 79102),
(79103, '1.10.40.30-FF-000006', NULL, 'Adenylosuccinate lyase', 77, NULL, NULL, 79103),
(79104, '3.90.640.10-FF-000123', NULL, 'Actin-related protein 8', 45, NULL, NULL, 79104),
(79105, '3.20.180.20-FF-000033', NULL, 'Dynein heavy chain', 104, NULL, NULL, 79105),
(79106, '3.30.160.60-FF-003407', NULL, NULL, 52, NULL, NULL, 79106),
(79107, '3.40.1170.10-FF-000035', NULL, 'DNA mismatch repair protein', 125, NULL, NULL, 79107);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(79108, '2.40.10.340-FF-000010', NULL, 'Cell shape-determining protein MreC', 72, NULL, NULL, 79108),
(79109, '3.40.50.720-FF-000870', NULL, 'Steroid dehydrogenase', 337, NULL, NULL, 79109),
(79110, '2.40.10.350-FF-000013', NULL, 'Cell shape-determining protein MreC', 77, NULL, NULL, 79110),
(79111, '2.60.40.10-FF-001452', NULL, 'Uncharacterized protein, isoform F', 100, NULL, NULL, 79111),
(79112, '3.30.60.30-FF-000002', NULL, 'tomoregulin-2 isoform X1', 64, NULL, NULL, 79112),
(79113, '3.50.50.60-FF-000504', NULL, 'Phytoene desaturase', 51, NULL, NULL, 79113),
(79114, '1.10.1670.10-FF-000065', NULL, NULL, 64, NULL, NULL, 79114),
(79115, '4.10.1080.10-FF-000012', NULL, 'Cartilage oligomeric matrix protein', 53, NULL, NULL, 79115),
(79116, '1.20.1640.10-FF-000078', NULL, 'Protein CBG18375', 206, NULL, NULL, 79116),
(79117, '3.30.70.270-FF-000067', NULL, 'DNA polymerase iota, putative', 151, NULL, NULL, 79117),
(79118, '3.30.470.10-FF-000027', NULL, 'Putative secreted protein', 107, NULL, NULL, 79118),
(79119, '1.10.1200.10-FF-000081', NULL, 'Acyl carrier protein', 87, NULL, NULL, 79119),
(79120, '3.30.2080.10-FF-000014', NULL, 'Predicted protein', 124, NULL, NULL, 79120),
(79121, '2.130.10.10-FF-001761', NULL, 'Chromatin assembly factor 1 subunit b-like protein', 179, NULL, NULL, 79121),
(79122, '1.20.910.10-FF-000015', NULL, 'PET18p protein', 215, NULL, NULL, 79122),
(79123, '3.40.190.10-FF-000397', NULL, 'Glutamate receptor ionotropic, NMDA 2D', 173, NULL, NULL, 79123),
(79124, '1.10.1450.10-FF-000088', NULL, 'Tetraspanin', 75, NULL, NULL, 79124),
(79125, '3.30.420.40-FF-000477', NULL, 'Glycerol kinase', 238, NULL, NULL, 79125),
(79126, '3.30.750.24-FF-000006', NULL, 'Solute carrier family 26 member 6', 147, NULL, NULL, 79126),
(79127, '1.20.1070.10-FF-000500', NULL, 'Chemokine (C-X-C motif) receptor 1', 305, NULL, NULL, 79127),
(79128, '3.40.50.1220-FF-000069', NULL, 'Putative acetolactate synthase large subunit', 151, NULL, NULL, 79128),
(79129, '1.10.4020.10-FF-000011', NULL, 'Uncharacterized protein', 56, NULL, NULL, 79129),
(79130, '1.25.10.10-FF-001101', NULL, 'Predicted protein', 163, NULL, NULL, 79130),
(79131, '2.40.340.10-FF-000031', NULL, NULL, 50, NULL, NULL, 79131),
(79132, '3.30.70.100-FF-000044', NULL, 'Copper-transporting ATPase PAA2 chloroplastic', 73, NULL, NULL, 79132),
(79133, '3.30.56.10-FF-000026', NULL, 'Phenylalanyl-tRNA synthetase beta chain', 79, NULL, NULL, 79133),
(79134, '3.30.559.10-FF-000008', NULL, 'Tryptamine hydroxycinnamoyl transferase', 226, NULL, NULL, 79134),
(79135, '2.40.50.140-FF-000891', NULL, NULL, 79, NULL, NULL, 79135),
(79136, '3.30.70.270-FF-000123', NULL, 'Deoxycytidyl transferase, putative', 105, NULL, NULL, 79136),
(79137, '2.60.40.10-FF-005723', NULL, NULL, 120, NULL, NULL, 79137),
(79138, '3.80.10.10-FF-004201', NULL, 'Uncharacterized protein', 89, NULL, NULL, 79138),
(79139, '3.80.10.10-FF-003982', NULL, 'Uncharacterized protein', 159, NULL, NULL, 79139),
(79140, '3.30.70.270-FF-000016', NULL, 'POL polyprotein', 128, NULL, NULL, 79140),
(79141, '2.30.29.30-FF-001112', NULL, 'Predicted protein', 137, NULL, NULL, 79141),
(79142, '3.40.50.410-FF-000221', NULL, 'Collagen, type VI, alpha 4a', 173, NULL, NULL, 79142),
(79143, '3.40.50.1010-FF-000012', NULL, 'SWT1, RNA endoribonuclease homolog', 149, NULL, NULL, 79143),
(79144, '2.130.10.10-FF-003610', NULL, 'Uncharacterized protein', 376, NULL, NULL, 79144),
(79145, '3.30.70.330-FF-002294', NULL, NULL, 73, NULL, NULL, 79145),
(79146, '2.60.120.650-FF-000153', NULL, 'Predicted protein', 292, NULL, NULL, 79146),
(79147, '3.40.33.10-FF-000124', NULL, 'Protein CBG01204', 116, NULL, NULL, 79147),
(79148, '2.60.40.10-FF-003251', NULL, 'Mannosidase, beta A, lysosomal', 109, NULL, NULL, 79148),
(79149, '3.30.70.260-FF-000120', NULL, 'Bifunctional uridylyltransferase/uridylyl-removing enzyme', 80, NULL, NULL, 79149),
(79150, '3.40.50.300-FF-001048', NULL, 'ABC transporter C family member 4', 263, NULL, NULL, 79150),
(79151, '1.25.40.10-FF-001221', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 125, NULL, NULL, 79151);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(79152, '3.40.50.10130-FF-000021', NULL, 'DNA repair endonuclease xp-f, putative', 143, NULL, NULL, 79152),
(79153, '1.25.40.10-FF-000939', NULL, 'Pentatricopeptide repeat-containing protein ELI1, chloroplastic', 122, NULL, NULL, 79153),
(79154, '3.30.160.60-FF-003458', NULL, 'Zinc finger and BTB domain containing 40', 52, NULL, NULL, 79154),
(79155, '1.25.40.10-FF-000653', NULL, 'Uncharacterized protein, isoform B', 129, NULL, NULL, 79155),
(79156, '3.40.1110.10-FF-000155', NULL, 'Calcium-translocating P-type ATPase, PMCA-type', 189, NULL, NULL, 79156),
(79157, '3.30.160.20-FF-000041', NULL, 'tRNA-dihydrouridine(20) synthase [NAD(P)+]-like isoform X1', 101, NULL, NULL, 79157),
(79158, '3.30.1520.10-FF-000183', NULL, 'Uncharacterized protein', 91, NULL, NULL, 79158),
(79159, '2.40.50.140-FF-001110', NULL, NULL, 119, NULL, NULL, 79159),
(79160, '1.20.1730.10-FF-000118', NULL, 'Uncharacterized protein', 82, NULL, NULL, 79160),
(79161, '3.40.50.1820-FF-000373', NULL, 'Neural stem cell-derived dendrite regulator', 229, NULL, NULL, 79161),
(79162, '2.60.40.10-FF-005375', NULL, NULL, 59, NULL, NULL, 79162),
(79163, '2.30.130.40-FF-000026', NULL, 'AGAP005299-PA', 115, NULL, NULL, 79163),
(79164, '1.10.510.10-FF-000549', NULL, 'Protein serine/threonine kinase (Ran1), putative', 281, NULL, NULL, 79164),
(79165, '3.40.850.10-FF-000346', NULL, 'Kinesin-like protein', 137, NULL, NULL, 79165),
(79166, '3.40.390.10-FF-000266', NULL, NULL, 176, NULL, NULL, 79166),
(79167, '1.20.1560.10-FF-000077', NULL, 'ABC transporter ATP-binding protein/permease', 330, NULL, NULL, 79167),
(79168, '1.10.1760.20-FF-000013', NULL, 'Diguanylate cyclase', 184, NULL, NULL, 79168),
(79169, '1.10.600.10-FF-000146', NULL, 'Uncharacterized protein', 28, NULL, NULL, 79169),
(79170, '3.30.1330.10-FF-000045', NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase chloroplastic', 98, NULL, NULL, 79170),
(79171, '3.30.420.40-FF-000584', NULL, 'Actin-like protein, putative', 113, NULL, NULL, 79171),
(79172, '3.90.1150.190-FF-000002', NULL, 'Scm-like with four MBT domains protein 2', 117, NULL, NULL, 79172),
(79173, '3.40.50.10140-FF-000024', NULL, 'TIR domain-containing adapter molecule 1', 160, NULL, NULL, 79173),
(79174, '1.25.40.10-FF-003345', NULL, 'Uncharacterized protein', 87, NULL, NULL, 79174),
(79175, '3.80.10.10-FF-004145', NULL, 'Uncharacterized protein', 108, NULL, NULL, 79175),
(79176, '3.30.1120.30-FF-000046', NULL, 'Probable serine/threonine-protein kinase CCRP1', 116, NULL, NULL, 79176),
(79177, '2.60.40.10-FF-005105', NULL, NULL, 99, NULL, NULL, 79177),
(79178, '3.40.50.620-FF-000340', NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', 345, NULL, NULL, 79178),
(79179, '3.30.70.1050-FF-000015', NULL, 'Trigger factor', 115, NULL, NULL, 79179),
(79180, '3.30.450.30-FF-000083', NULL, 'Uncharacterized protein', 79, NULL, NULL, 79180),
(79181, '3.30.40.10-FF-000574', NULL, 'E3 ubiquitin-protein ligase Hakai', 18, NULL, NULL, 79181),
(79182, '3.60.10.10-FF-000037', NULL, 'Glucose-repressible alcohol dehydrogenase transcriptional effector', 374, NULL, NULL, 79182),
(79183, '2.70.170.10-FF-000286', NULL, 'Uncharacterized protein', 59, NULL, NULL, 79183),
(79184, '2.40.155.10-FF-000010', NULL, 'Uncharacterized protein', 165, NULL, NULL, 79184),
(79185, '2.30.30.100-FF-000169', NULL, 'LSM domain containing protein', 90, NULL, NULL, 79185),
(79186, '3.40.50.1910-FF-000006', NULL, 'Vacuolar protein sorting-associated protein 33A', 49, NULL, NULL, 79186),
(79187, '1.20.58.60-FF-000325', NULL, 'SMAll', 244, NULL, NULL, 79187),
(79188, '3.30.450.20-FF-000080', NULL, 'protein TWIN LOV 1', 137, NULL, NULL, 79188),
(79189, '3.80.10.10-FF-003577', NULL, 'Uncharacterized protein', 141, NULL, NULL, 79189),
(79190, '3.40.50.300-FF-005319', NULL, 'Uncharacterized protein', 158, NULL, NULL, 79190),
(79191, '3.20.20.100-FF-000126', NULL, 'Aldo-keto reductase family 1, member C20', 93, NULL, NULL, 79191),
(79192, '1.25.40.10-FF-004868', NULL, 'Diguanylate cyclase', 149, NULL, NULL, 79192),
(79193, '2.10.25.10-FF-000660', NULL, 'Eyes shut, isoform E', 38, NULL, NULL, 79193);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(79194, '3.30.40.10-FF-000169', NULL, 'TNF receptor-associated factor', 56, NULL, NULL, 79194),
(79195, '1.25.10.10-FF-000825', NULL, 'Uncharacterized protein', 433, NULL, NULL, 79195),
(79196, '1.20.58.70-FF-000093', NULL, 'Syntaxin-1A', 50, NULL, NULL, 79196),
(79197, '1.20.120.350-FF-000005', NULL, 'Sodium channel protein', 112, NULL, NULL, 79197),
(79198, '1.20.58.60-FF-000090', NULL, 'microtubule-actin cross-linking factor 1 isoform X2', 212, NULL, NULL, 79198),
(79199, '2.60.15.10-FF-000016', NULL, 'Mitochondrial F1F0 ATP synthase, delta subunit', 136, NULL, NULL, 79199),
(79200, '2.60.120.260-FF-000356', NULL, 'Uncharacterized protein', 91, NULL, NULL, 79200),
(79201, '3.80.10.10-FF-003919', NULL, 'Receptor-like protein EIX2', 106, NULL, NULL, 79201),
(79202, '3.55.40.10-FF-000001', NULL, 'Type 4 fimbrial biogenesis protein FimU', 136, NULL, NULL, 79202),
(79203, '1.20.144.10-FF-000128', NULL, 'PAP2 superfamily protein', 150, NULL, NULL, 79203),
(79204, '3.40.50.620-FF-000901', NULL, 'Uncharacterized protein', 69, NULL, NULL, 79204),
(79205, '3.30.160.340-FF-000001', NULL, '2-isopropylmalate synthase', 69, NULL, NULL, 79205),
(79206, '1.25.40.10-FF-005144', NULL, 'Uncharacterized protein', 97, NULL, NULL, 79206),
(79207, '3.40.50.1820-FF-000480', NULL, 'Dimodular nonribosomal peptide synthase', 345, NULL, NULL, 79207),
(79208, '2.60.40.10-FF-004829', NULL, NULL, 115, NULL, NULL, 79208),
(79209, '1.10.510.10-FF-004259', NULL, NULL, 188, NULL, NULL, 79209),
(79210, '3.50.50.60-FF-000386', NULL, 'FAD/NAD(P)-binding oxidoreductase family protein', 224, NULL, NULL, 79210),
(79211, '3.30.70.260-FF-000064', NULL, 'GTP pyrophosphokinase', 76, NULL, NULL, 79211),
(79212, '3.30.460.10-FF-000201', NULL, 'Uncharacterized protein', 89, NULL, NULL, 79212),
(79213, '2.130.10.10-FF-003554', NULL, 'Uncharacterized protein', 273, NULL, NULL, 79213),
(79214, '2.60.120.260-FF-000249', NULL, 'Probable beta-glucosidase K', 167, NULL, NULL, 79214),
(79215, '3.40.970.10-FF-000001', NULL, 'Ribonuclease H1', 49, NULL, NULL, 79215),
(79216, '3.40.50.1820-FF-000154', NULL, 'Alpha/beta hydrolase', 268, NULL, NULL, 79216),
(79217, '3.40.30.10-FF-000207', NULL, 'thioredoxin domain-containing protein 3', 120, NULL, NULL, 79217),
(79218, '3.30.470.20-FF-000182', NULL, 'Succinyl-CoA synthetase beta subunit, putative', 132, NULL, NULL, 79218),
(79219, '3.10.100.10-FF-000196', NULL, NULL, 137, NULL, NULL, 79219),
(79220, '1.20.120.660-FF-000003', NULL, 'Cag pathogenicity island protein', 71, NULL, NULL, 79220),
(79221, '3.40.250.10-FF-000110', NULL, 'Uncharacterized protein', 95, NULL, NULL, 79221),
(79222, '2.10.25.10-FF-000042', NULL, 'Integrin subunit beta-like 1', 36, NULL, NULL, 79222),
(79223, '3.80.10.10-FF-000704', NULL, 'Leucine-rich repeat protein', 72, NULL, NULL, 79223),
(79224, '3.30.70.330-FF-000349', NULL, 'Protein MEI2-like 1', 92, NULL, NULL, 79224),
(79225, '3.40.50.300-FF-004010', NULL, 'Type III restriction-modification enzyme helicase subunit', 202, NULL, NULL, 79225),
(79226, '4.10.240.10-FF-000140', NULL, 'Uncharacterized protein', 36, NULL, NULL, 79226),
(79227, '1.10.510.10-FF-002466', NULL, NULL, 235, NULL, NULL, 79227),
(79228, '3.20.20.80-FF-000190', NULL, 'Sucrose phosphorylase', 316, NULL, NULL, 79228),
(79229, '1.20.5.170-FF-000014', NULL, 'Spectrin alpha chain, non-erythrocytic 1', 32, NULL, NULL, 79229),
(79230, '3.40.50.300-FF-002104', NULL, 'ATP-dependent RNA helicase ROK1', 176, NULL, NULL, 79230),
(79231, '3.50.50.60-FF-000903', NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', 96, NULL, NULL, 79231),
(79232, '1.20.1050.90-FF-000011', NULL, 'DNA replication and repair protein RecF', 180, NULL, NULL, 79232),
(79233, '1.10.8.10-FF-000048', NULL, 'activated CDC42 kinase 1 isoform X2', 38, NULL, NULL, 79233),
(79234, '2.10.10.10-FF-000013', NULL, 'Insulin like growth factor 2 receptor', 51, NULL, NULL, 79234),
(79235, '3.30.365.10-FF-000013', NULL, 'Aldehyde oxidase', 173, NULL, NULL, 79235),
(79236, '2.20.70.10-FF-000264', NULL, 'Uncharacterized protein', 41, NULL, NULL, 79236);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(79237, '2.60.120.260-FF-000575', NULL, 'Uncharacterized protein', 187, NULL, NULL, 79237),
(79238, '3.80.10.10-FF-004471', NULL, 'Uncharacterized protein', 42, NULL, NULL, 79238),
(79239, '1.20.920.10-FF-000027', NULL, 'Cat eye syndrome critical region protein 2', 116, NULL, NULL, 79239),
(79240, '3.30.920.10-FF-000006', NULL, 'FXN isoform 2', 83, NULL, NULL, 79240),
(79241, '1.25.40.10-FF-004924', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 61, NULL, NULL, 79241),
(79242, '3.30.710.10-FF-000182', NULL, 'Rhogtpase, putative', 84, NULL, NULL, 79242),
(79243, '1.25.40.120-FF-000052', NULL, 'Uncharacterized protein', 69, NULL, NULL, 79243),
(79244, '3.10.310.20-FF-000029', NULL, NULL, 173, NULL, NULL, 79244),
(79245, '3.100.10.10-FF-000005', NULL, '50S ribosomal protein L15', 73, NULL, NULL, 79245),
(79246, '1.25.40.20-FF-001550', NULL, 'Uncharacterized protein', 110, NULL, NULL, 79246),
(79247, '3.30.420.40-FF-000876', NULL, 'Uncharacterized protein', 50, NULL, NULL, 79247),
(79248, '1.10.10.10-FF-000757', NULL, 'GntR family transcriptional regulator', 71, NULL, NULL, 79248),
(79249, '2.40.50.140-FF-000267', NULL, 'Protein BREAST CANCER SUSCEPTIBILITY 2 homolog B', 92, NULL, NULL, 79249),
(79250, '3.10.310.10-FF-000026', NULL, 'Uncharacterized isomerase YHI9', 159, NULL, NULL, 79250),
(79251, '3.90.660.10-FF-000051', NULL, NULL, 26, NULL, NULL, 79251),
(79252, '1.20.58.60-FF-000651', NULL, 'Uncharacterized protein', 173, NULL, NULL, 79252),
(79253, '2.30.42.10-FF-000581', NULL, NULL, 110, NULL, NULL, 79253),
(79254, '1.10.287.130-FF-000155', NULL, 'Histidine kinase, putative', 94, NULL, NULL, 79254),
(79255, '2.30.30.100-FF-000118', NULL, 'Probable small nuclear ribonucleoprotein F', 77, NULL, NULL, 79255),
(79256, '3.30.420.10-FF-000316', NULL, 'Uncharacterized protein', 198, NULL, NULL, 79256),
(79257, '2.60.120.200-FF-000041', NULL, 'thrombospondin-1', 209, NULL, NULL, 79257),
(79258, '1.20.1250.20-FF-002164', NULL, 'Biopterin transporter BT1', 185, NULL, NULL, 79258),
(79259, '1.10.1820.10-FF-000009', NULL, 'Casein kinase II subunit beta', 104, NULL, NULL, 79259),
(79260, '1.25.40.10-FF-005200', NULL, 'Predicted protein', 212, NULL, NULL, 79260),
(79261, '2.30.29.30-FF-000095', NULL, 'WD repeat and FYVE domain containing 3', 120, NULL, NULL, 79261),
(79262, '2.130.10.10-FF-002498', NULL, 'Sensor histidine kinase TodS', 143, NULL, NULL, 79262),
(79263, '3.40.50.10490-FF-000151', NULL, NULL, 157, NULL, NULL, 79263),
(79264, '3.30.420.40-FF-000258', NULL, 'Actin-related protein', 72, NULL, NULL, 79264),
(79265, '1.10.2000.10-FF-000004', NULL, 'Frizzled class receptor 8a', 128, NULL, NULL, 79265),
(79266, '3.30.160.60-FF-003172', NULL, NULL, 30, NULL, NULL, 79266),
(79267, '2.60.40.10-FF-005049', NULL, NULL, 102, NULL, NULL, 79267),
(79268, '3.30.310.280-FF-000001', NULL, 'Aerobactin siderophore biosynthesis protein IucC', 113, NULL, NULL, 79268),
(79269, '3.90.640.10-FF-000016', NULL, 'ARP5 actin-related protein 5 homolog', 56, NULL, NULL, 79269),
(79270, '2.40.160.10-FF-000045', NULL, 'Uncharacterized protein', 120, NULL, NULL, 79270),
(79271, '1.25.40.10-FF-004649', NULL, 'Uncharacterized protein', 234, NULL, NULL, 79271),
(79272, '3.40.50.300-FF-002897', NULL, 'Small GTP binding protein Rab7 putative', 187, NULL, NULL, 79272),
(79273, '2.30.30.40-FF-000629', NULL, 'Uncharacterized protein', 88, NULL, NULL, 79273),
(79274, '2.60.120.780-FF-000012', NULL, 'Uncharacterized protein', 180, NULL, NULL, 79274),
(79275, '3.40.50.150-FF-001019', NULL, NULL, 193, NULL, NULL, 79275),
(79276, '2.60.120.200-FF-000092', NULL, 'Laminin subunit alpha 3', 166, NULL, NULL, 79276),
(79277, '1.20.58.60-FF-000376', NULL, 'Protein CBG15811', 177, NULL, NULL, 79277),
(79278, '2.10.25.10-FF-000441', NULL, 'Laminin subunit gamma 2', 48, NULL, NULL, 79278),
(79279, '2.70.170.10-FF-000067', NULL, 'Ligand-Gated ion Channel', 221, NULL, NULL, 79279),
(79280, '3.30.870.10-FF-000182', NULL, 'Predicted protein', 143, NULL, NULL, 79280),
(79281, '1.10.357.50-FF-000018', NULL, 'Uncharacterized protein', 87, NULL, NULL, 79281);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(79282, '1.20.1070.10-FF-000444', NULL, 'Vomeronasal type-1 receptor', 247, NULL, NULL, 79282),
(79283, '3.40.50.300-FF-003734', NULL, 'DNA mismatch repair protein', 254, NULL, NULL, 79283),
(79284, '2.30.30.30-FF-000065', NULL, '60S ribosomal protein L14, putative', 85, NULL, NULL, 79284),
(79285, '3.40.50.300-FF-003521', NULL, 'Mitochondrial Rho GTPase 1', 168, NULL, NULL, 79285),
(79286, '3.30.1740.10-FF-000019', NULL, 'Poly [ADP-ribose] polymerase', 108, NULL, NULL, 79286),
(79287, '3.90.180.10-FF-000025', NULL, 'Zinc-type alcohol dehydrogenase YahK', 179, NULL, NULL, 79287),
(79288, '3.40.50.620-FF-000391', NULL, 'Tryptophan--tRNA ligase', 209, NULL, NULL, 79288),
(79289, '1.25.40.10-FF-003019', NULL, 'Pentatricopeptide repeat-containing protein At5g66520', 111, NULL, NULL, 79289),
(79290, '2.30.42.10-FF-000518', NULL, NULL, 74, NULL, NULL, 79290),
(79291, '3.30.70.100-FF-000100', NULL, 'Mechanosensitive ion channel family protein', 98, NULL, NULL, 79291),
(79292, '1.20.1260.10-FF-000037', NULL, 'Ferritin', 177, NULL, NULL, 79292),
(79293, '3.10.20.90-FF-000890', NULL, 'Protein CBG11828', 54, NULL, NULL, 79293),
(79294, '1.20.1560.10-FF-000296', NULL, 'ABC multidrug transporter (Eurofung)', 219, NULL, NULL, 79294),
(79295, '3.40.50.1110-FF-000036', NULL, 'Thermolabile hemolysin', 279, NULL, NULL, 79295),
(79296, '2.130.10.10-FF-002447', NULL, 'Transducin family protein', 140, NULL, NULL, 79296),
(79297, '3.40.50.1700-FF-000005', NULL, 'Beta-glucosidase H', 179, NULL, NULL, 79297),
(79298, '1.10.510.10-FF-001336', NULL, 'Serine/threonine-protein kinase spe-6', 332, NULL, NULL, 79298),
(79299, '4.10.830.40-FF-000003', NULL, 'Tripartite motif containing 29', 80, NULL, NULL, 79299),
(79300, '2.30.42.10-FF-000070', NULL, 'Multiple PDZ domain protein', 105, NULL, NULL, 79300),
(79301, '2.10.110.10-FF-000077', NULL, 'LIM domain protein', 61, NULL, NULL, 79301),
(79302, '3.50.50.60-FF-000616', NULL, 'Salicylate hydroxylase', 353, NULL, NULL, 79302),
(79303, '4.10.60.10-FF-000175', NULL, 'mRNA-binding translational activator', 24, NULL, NULL, 79303),
(79304, '1.20.1270.60-FF-000305', NULL, 'Uncharacterized protein', 88, NULL, NULL, 79304),
(79305, '3.30.70.330-FF-002816', NULL, NULL, 145, NULL, NULL, 79305),
(79306, '1.25.10.10-FF-001157', NULL, 'APUM18', 289, NULL, NULL, 79306),
(79307, '3.40.50.300-FF-003408', NULL, 'p60 katanin/ AAA family protein', 180, NULL, NULL, 79307),
(79308, '3.10.50.40-FF-000112', NULL, 'Trigger factor', 96, NULL, NULL, 79308),
(79309, '2.60.220.50-FF-000147', NULL, 'Uncharacterized protein', 189, NULL, NULL, 79309),
(79310, '2.120.10.30-FF-000559', NULL, 'Adipocyte plasma membrane-associated protein, putative', 70, NULL, NULL, 79310),
(79311, '3.90.1310.10-FF-000013', NULL, 'Dihydropteridine reductase', 176, NULL, NULL, 79311),
(79312, '1.25.10.10-FF-002736', NULL, 'Uncharacterized protein', 821, NULL, NULL, 79312),
(79313, '3.30.160.60-FF-002969', NULL, 'Zinc finger protein 142', 60, NULL, NULL, 79313),
(79314, '3.30.420.10-FF-000642', NULL, NULL, 142, NULL, NULL, 79314),
(79315, '3.40.50.620-FF-000065', NULL, 'Universal stress protein', 139, NULL, NULL, 79315),
(79316, '3.40.50.2000-FF-000152', NULL, 'Glycosyltransferase', 247, NULL, NULL, 79316),
(79317, '3.40.630.40-FF-000018', NULL, 'Putative N-acetylmuramoyl-L-alanine amidase', 207, NULL, NULL, 79317),
(79318, '3.40.120.10-FF-000100', NULL, 'Phosphoacetylglucosamine mutase', 132, NULL, NULL, 79318),
(79319, '2.60.40.10-FF-005611', NULL, NULL, 97, NULL, NULL, 79319),
(79320, '1.20.1250.20-FF-000871', NULL, 'YALI0A17149p', 229, NULL, NULL, 79320),
(79321, '3.40.50.300-FF-000070', NULL, 'Putative ABC transporter ATP-binding component', 254, NULL, NULL, 79321),
(79322, '2.60.40.10-FF-001272', NULL, 'titin isoform X1', 99, NULL, NULL, 79322),
(79323, '3.10.250.10-FF-000021', NULL, 'Transmembrane serine protease 13', 94, NULL, NULL, 79323),
(79324, '2.30.40.10-FF-000008', NULL, 'Dihydroorotase', 57, NULL, NULL, 79324),
(79325, '3.40.570.10-FF-000033', NULL, 'Uncharacterized protein', 215, NULL, NULL, 79325),
(79326, '2.30.40.10-FF-000065', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 50, NULL, NULL, 79326);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(79327, '3.90.550.20-FF-000012', NULL, 'Uncharacterized protein', 197, NULL, NULL, 79327),
(79328, '2.30.30.100-FF-000063', NULL, 'U6 snRNA-associated Sm-like protein LSm3', 89, NULL, NULL, 79328),
(79329, '3.40.630.30-FF-000072', NULL, 'Histone acetyltransferase type B catalytic subunit', 135, NULL, NULL, 79329),
(79330, '3.40.718.10-FF-000034', NULL, 'Isocitrate dehydrogenase [NAD] subunit alpha, mitochondrial', 70, NULL, NULL, 79330),
(79331, '3.10.20.90-FF-000041', NULL, 'large proline-rich protein BAG6 isoform X1', 92, NULL, NULL, 79331),
(79332, '3.40.50.11370-FF-000005', NULL, 'Inositol-tetrakisphosphate 1-kinase', 110, NULL, NULL, 79332),
(79333, '3.30.70.330-FF-000731', NULL, 'Single-strand telomeric DNA-binding protein GBP2', 97, NULL, NULL, 79333),
(79334, '3.40.50.80-FF-000241', NULL, 'Uncharacterized protein', 129, NULL, NULL, 79334),
(79335, '1.20.1070.10-FF-000713', NULL, 'Relaxin family peptide receptor 3.3b', 296, NULL, NULL, 79335),
(79336, '1.10.150.530-FF-000017', NULL, 'Dual-specificity RNA methyltransferase RlmN', 65, NULL, NULL, 79336),
(79337, '3.40.50.720-FF-002455', NULL, 'Autophagy related 7', 178, NULL, NULL, 79337),
(79338, '3.30.420.40-FF-000707', NULL, 'YALI0F10923p', 178, NULL, NULL, 79338),
(79339, '1.10.150.510-FF-000011', NULL, 'Uncharacterized protein', 95, NULL, NULL, 79339),
(79340, '3.40.220.10-FF-000046', NULL, 'Poly [ADP-ribose] polymerase', 232, NULL, NULL, 79340),
(79341, '3.30.43.10-FF-000047', NULL, 'Uncharacterized protein', 67, NULL, NULL, 79341),
(79342, '3.40.50.410-FF-000333', NULL, 'AGAP001871-PA', 226, NULL, NULL, 79342),
(79343, '3.40.50.1820-FF-001210', NULL, 'Uncharacterized protein', 192, NULL, NULL, 79343),
(79344, '1.10.510.10-FF-003522', NULL, NULL, 244, NULL, NULL, 79344),
(79345, '3.40.30.10-FF-000314', NULL, 'Glutathione peroxidase', 178, NULL, NULL, 79345),
(79346, '3.30.70.330-FF-002822', NULL, NULL, 91, NULL, NULL, 79346),
(79347, '3.40.50.12480-FF-000001', NULL, 'Chitin binding protein', 46, NULL, NULL, 79347),
(79348, '2.170.120.12-FF-000014', NULL, 'DNA-directed RNA polymerase subunit alpha', 138, NULL, NULL, 79348),
(79349, '2.20.100.10-FF-000186', NULL, 'spondin-1-like', 55, NULL, NULL, 79349),
(79350, '3.10.105.10-FF-000004', NULL, 'Peptide ABC transporter substrate-binding protein SapA', 218, NULL, NULL, 79350),
(79351, '3.40.50.150-FF-001306', NULL, NULL, 213, NULL, NULL, 79351),
(79352, '3.30.760.10-FF-000061', NULL, 'Eukaryotic translation initiation factor 4E family protein', 207, NULL, NULL, 79352),
(79353, '3.30.200.20-FF-001051', NULL, 'Os08g0343000 protein', 110, NULL, NULL, 79353),
(79354, '3.30.160.60-FF-000878', NULL, 'Zinc finger protein 544', 28, NULL, NULL, 79354),
(79355, '1.10.1170.10-FF-000044', NULL, 'Chromosomal passenger complex protein bir-1', 142, NULL, NULL, 79355),
(79356, '3.30.780.10-FF-000062', NULL, 'Translation machinery-associated protein 22', 94, NULL, NULL, 79356),
(79357, '2.130.10.10-FF-001250', NULL, 'Eukaryotic translation initiation factor 2A', 195, NULL, NULL, 79357),
(79358, '3.40.50.850-FF-000004', NULL, 'Peroxyureidoacrylate/ureidoacrylate amidohydrolase RutB', 223, NULL, NULL, 79358),
(79359, '1.20.58.60-FF-000612', NULL, 'Spectrin beta chain', 97, NULL, NULL, 79359),
(79360, '1.25.40.180-FF-000261', NULL, NULL, 228, NULL, NULL, 79360),
(79361, '2.30.30.40-FF-000635', NULL, 'Uncharacterized protein', 84, NULL, NULL, 79361),
(79362, '3.30.70.3270-FF-000012', NULL, 'NADH-quinone oxidoreductase subunit I', 164, NULL, NULL, 79362),
(79363, '3.60.120.10-FF-000017', NULL, 'Isochorismate synthase', 453, NULL, NULL, 79363),
(79364, '3.40.720.10-FF-000303', NULL, 'Uncharacterized protein', 225, NULL, NULL, 79364),
(79365, '1.10.3120.10-FF-000007', NULL, 'Trigger factor', 207, NULL, NULL, 79365),
(79366, '3.40.525.10-FF-000018', NULL, 'Phosphatidylinositol transfer protein SFH5', 270, NULL, NULL, 79366),
(79367, '3.30.450.20-FF-000254', NULL, 'Sensory box sensor histidine kinase/response regulator', 119, NULL, NULL, 79367),
(79368, '4.10.1060.10-FF-000016', NULL, 'Calpain 15', 39, NULL, NULL, 79368);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(79369, '3.80.10.10-FF-000435', NULL, 'Uncharacterized protein', 259, NULL, NULL, 79369),
(79370, '3.30.200.20-FF-002517', NULL, 'Predicted protein', 108, NULL, NULL, 79370),
(79371, '2.60.40.10-FF-002795', NULL, 'Stretchin-Mlck, isoform S', 91, NULL, NULL, 79371),
(79372, '2.70.160.11-FF-000056', NULL, 'Uncharacterized protein, isoform B', 174, NULL, NULL, 79372),
(79373, '2.60.40.10-FF-000665', NULL, 'obscurin isoform X1', 87, NULL, NULL, 79373),
(79374, '3.40.50.620-FF-000008', NULL, 'Tyrosine--tRNA ligase', 225, NULL, NULL, 79374),
(79375, '3.30.710.10-FF-000350', NULL, 'Uncharacterized protein', 184, NULL, NULL, 79375),
(79376, '2.30.40.10-FF-000121', NULL, 'Dihydroorotase', 90, NULL, NULL, 79376),
(79377, '3.30.460.20-FF-000030', NULL, 'Cation transporter, putative', 145, NULL, NULL, 79377),
(79378, '2.20.100.10-FF-000242', NULL, 'Uncharacterized protein', 67, NULL, NULL, 79378),
(79379, '3.40.50.2300-FF-000028', NULL, 'Glutamate receptor ionotropic, NMDA 2B, putative', 159, NULL, NULL, 79379),
(79380, '3.40.50.300-FF-001317', NULL, 'Putative ADP-ribosylation factor', 185, NULL, NULL, 79380),
(79381, '1.20.58.900-FF-000008', NULL, 'DENN domain containing 5B', 180, NULL, NULL, 79381),
(79382, '1.10.287.3990-FF-000010', NULL, 'F-box and WD domain-containing protein', 46, NULL, NULL, 79382),
(79383, '3.90.1030.10-FF-000025', NULL, 'Ribosomal protein L17', 117, NULL, NULL, 79383),
(79384, '2.70.70.10-FF-000065', NULL, 'Lysostaphin', 150, NULL, NULL, 79384),
(79385, '3.40.1190.20-FF-000040', NULL, 'Thiamine biosynthetic bifunctional enzyme TH1, chloroplastic', 290, NULL, NULL, 79385),
(79386, '1.10.510.10-FF-002915', NULL, 'Uncharacterized protein', 361, NULL, NULL, 79386),
(79387, '2.60.40.10-FF-004936', NULL, NULL, 72, NULL, NULL, 79387),
(79388, '3.40.190.10-FF-000627', NULL, 'Glutamate receptor', 32, NULL, NULL, 79388),
(79389, '2.20.100.10-FF-000203', NULL, 'Complement factor properdin', 72, NULL, NULL, 79389),
(79390, '3.40.390.10-FF-000092', NULL, 'Stall, isoform C', 236, NULL, NULL, 79390),
(79391, '2.30.39.10-FF-000106', NULL, 'Serpin peptidase inhibitor 4', 98, NULL, NULL, 79391),
(79392, '3.40.50.720-FF-001887', NULL, 'Uncharacterized protein', 200, NULL, NULL, 79392),
(79393, '3.30.70.890-FF-000022', NULL, 'Diphosphomevalonate decarboxylase', 140, NULL, NULL, 79393),
(79394, '2.10.25.10-FF-000098', NULL, 'Integrin beta', 37, NULL, NULL, 79394),
(79395, '3.40.50.150-FF-001345', NULL, NULL, 193, NULL, NULL, 79395),
(79396, '2.60.120.200-FF-000602', NULL, 'Predicted protein', 220, NULL, NULL, 79396),
(79397, '1.25.40.10-FF-004694', NULL, 'Uncharacterized protein', 101, NULL, NULL, 79397),
(79398, '3.30.160.60-FF-005083', NULL, NULL, 91, NULL, NULL, 79398),
(79399, '3.40.190.10-FF-000666', NULL, 'Glutamate receptor, ionotropic, AMPA 2a', 119, NULL, NULL, 79399),
(79400, '2.40.37.10-FF-000017', NULL, 'Putative diaminopimelate decarboxylase', 149, NULL, NULL, 79400),
(79401, '3.40.50.10190-FF-000235', NULL, 'ECT2 (Mammalian Rho GEF) homolog', 81, NULL, NULL, 79401),
(79402, '1.10.287.3240-FF-000021', NULL, 'Vacuolar ATP synthase subunit D, putative (AFU_orthologue AFUA_5G11920)', 164, NULL, NULL, 79402),
(79403, '3.40.850.10-FF-000127', NULL, 'Kinesin-like protein', 392, NULL, NULL, 79403),
(79404, '2.60.40.150-FF-000573', NULL, 'Uncharacterized protein', 121, NULL, NULL, 79404),
(79405, '3.80.10.10-FF-003358', NULL, 'Leucine-rich repeat transmembrane protein FLRT2-like Protein', 113, NULL, NULL, 79405),
(79406, '3.60.10.10-FF-000150', NULL, 'Tdpt-1', 250, NULL, NULL, 79406),
(79407, '2.130.10.10-FF-004920', NULL, 'Transducin/WD40 repeat-like superfamily protein', 107, NULL, NULL, 79407),
(79408, '2.40.50.140-FF-000273', NULL, 'Ribonuclease R', 107, NULL, NULL, 79408),
(79409, '1.10.10.10-FF-000645', NULL, 'Transcriptional regulator, AsnC family', 50, NULL, NULL, 79409),
(79410, '2.10.25.10-FF-000334', NULL, 'protein delta homolog 2 isoform X1', 40, NULL, NULL, 79410),
(79411, '3.30.450.20-FF-000473', NULL, 'Putative regulatory protein', 108, NULL, NULL, 79411),
(79412, '3.30.450.40-FF-000299', NULL, 'PAS sensor protein', 180, NULL, NULL, 79412);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(79413, '3.40.50.720-FF-000600', NULL, '17-beta-hydroxysteroid dehydrogenase 14', 270, NULL, NULL, 79413),
(79414, '3.40.390.10-FF-000047', NULL, 'Matrix metallopeptidase 21', 264, NULL, NULL, 79414),
(79415, '3.80.10.10-FF-002672', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 138, NULL, NULL, 79415),
(79416, '3.40.50.300-FF-001374', NULL, 'Pleiotropic drug resistance protein ABC superfamily', 237, NULL, NULL, 79416),
(79417, '3.40.50.1000-FF-000745', NULL, NULL, 37, NULL, NULL, 79417),
(79418, '3.40.190.10-FF-000902', NULL, 'Probable sensor/response regulator hybrid', 92, NULL, NULL, 79418),
(79419, '1.20.5.2210-FF-000006', NULL, 'Uncharacterized protein', 88, NULL, NULL, 79419),
(79420, '3.30.1960.10-FF-000002', NULL, 'tRNA wybutosine-synthesizing protein 2/3/4', 212, NULL, NULL, 79420),
(79421, '3.30.70.330-FF-002081', NULL, NULL, 78, NULL, NULL, 79421),
(79422, '3.40.50.300-FF-002953', NULL, 'Origin recognition complex subunit 5', 184, NULL, NULL, 79422),
(79423, '3.40.50.300-FF-005645', NULL, 'Uncharacterized protein', 223, NULL, NULL, 79423),
(79424, '3.10.330.10-FF-000022', NULL, 'Cell division cycle protein', 79, NULL, NULL, 79424),
(79425, '3.30.710.10-FF-000294', NULL, 'Rho-related protein racA', 133, NULL, NULL, 79425),
(79426, '2.60.120.200-FF-000546', NULL, 'Calreticulin 4', 146, NULL, NULL, 79426),
(79427, '1.10.10.10-FF-001252', NULL, 'Cullin family protein', 71, NULL, NULL, 79427),
(79428, '2.60.120.200-FF-000327', NULL, 'Kon-tiki, isoform B', 174, NULL, NULL, 79428),
(79429, '1.20.1070.10-FF-000770', NULL, 'Predicted protein', 288, NULL, NULL, 79429),
(79430, '2.170.130.10-FF-000029', NULL, 'Outer membrane cobalamin receptor protein', 132, NULL, NULL, 79430),
(79431, '3.30.420.10-FF-000423', NULL, NULL, 151, NULL, NULL, 79431),
(79432, '3.40.50.620-FF-000845', NULL, 'AGAP003832-PA', 72, NULL, NULL, 79432),
(79433, '1.25.40.10-FF-005150', NULL, 'Uncharacterized protein', 94, NULL, NULL, 79433),
(79434, '3.40.80.10-FF-000031', NULL, 'N-acetylmuramoyl-L-alanine amidase family 2', 116, NULL, NULL, 79434),
(79435, '3.40.50.10490-FF-000112', NULL, NULL, 150, NULL, NULL, 79435),
(79436, '2.30.29.30-FF-000943', NULL, 'Uncharacterized protein', 115, NULL, NULL, 79436),
(79437, '2.40.70.10-FF-000387', NULL, NULL, 188, NULL, NULL, 79437),
(79438, '1.50.40.10-FF-000589', NULL, 'Uncharacterized protein', 187, NULL, NULL, 79438),
(79439, '3.40.50.300-FF-002211', NULL, 'DNA mismatch repair protein Msh2, putative', 289, NULL, NULL, 79439),
(79440, '3.30.160.60-FF-000030', NULL, 'Zinc finger protein 628', 28, NULL, NULL, 79440),
(79441, '3.30.200.20-FF-000157', NULL, 'Mitogen-activated protein kinase', 86, NULL, NULL, 79441),
(79442, '2.10.25.10-FF-000115', NULL, 'latent-transforming growth factor beta-binding protein 4 isoform X2', 41, NULL, NULL, 79442),
(79443, '3.40.718.10-FF-000073', NULL, 'Pentatricopeptide repeat-containing protein', 115, NULL, NULL, 79443),
(79444, '3.90.70.10-FF-000854', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 106, NULL, NULL, 79444),
(79445, '4.10.240.10-FF-000101', NULL, 'Transcription factor with zinc cluster DNA-binding motif, putative', 65, NULL, NULL, 79445),
(79446, '3.90.70.30-FF-000006', NULL, 'Putative methyltransferase PMT23', 71, NULL, NULL, 79446),
(79447, '1.25.10.10-FF-002793', NULL, 'AER448Wp', 249, NULL, NULL, 79447),
(79448, '3.40.50.620-FF-000284', NULL, 'Isoleucyl-tRNA synthetase 2, mitochondrial', 221, NULL, NULL, 79448),
(79449, '3.40.50.1910-FF-000012', NULL, 'Protein SLY1', 211, NULL, NULL, 79449),
(79450, '2.40.50.140-FF-000834', NULL, NULL, 82, NULL, NULL, 79450),
(79451, '2.20.25.20-FF-000016', NULL, 'Casein kinase II subunit beta', 76, NULL, NULL, 79451),
(79452, '3.90.550.50-FF-000173', NULL, 'Hexosyltransferase', 258, NULL, NULL, 79452),
(79453, '3.10.20.90-FF-000783', NULL, 'Uncharacterized protein', 80, NULL, NULL, 79453),
(79454, '2.40.160.210-FF-000028', NULL, 'Uncharacterized protein', 101, NULL, NULL, 79454),
(79455, '3.30.830.10-FF-000179', NULL, 'Uncharacterized protein', 207, NULL, NULL, 79455);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(79456, '3.30.230.10-FF-000212', NULL, 'Galactokinase', 200, NULL, NULL, 79456),
(79457, '1.25.40.10-FF-004475', NULL, 'Pentatricopeptide repeat-containing protein', 105, NULL, NULL, 79457),
(79458, '3.40.50.1820-FF-000603', NULL, 'Alpha/beta hydrolase family protein', 337, NULL, NULL, 79458),
(79459, '1.20.58.60-FF-000269', NULL, 'Microtubule-actin cross-linking factor 1', 213, NULL, NULL, 79459),
(79460, '3.40.605.10-FF-000114', NULL, 'Transcription regulator', 118, NULL, NULL, 79460),
(79461, '3.40.50.300-FF-007270', NULL, 'ATPase family AAA domain-containing protein 3A', 156, NULL, NULL, 79461),
(79462, '2.20.25.30-FF-000019', NULL, 'Uncharacterized protein', 73, NULL, NULL, 79462),
(79463, '2.60.40.60-FF-000022', NULL, 'Cadherin 2', 107, NULL, NULL, 79463),
(79464, '2.130.10.10-FF-003228', NULL, 'WD-repeat membrane protein, putative', 274, NULL, NULL, 79464),
(79465, '1.20.920.10-FF-000134', NULL, 'Protein polybromo-1-like Protein', 112, NULL, NULL, 79465),
(79466, '1.10.10.60-FF-000289', NULL, 'TetR family transcriptional regulator', 50, NULL, NULL, 79466),
(79467, '1.10.150.240-FF-000088', NULL, 'Haloacid dehalogenase superfamily, subfamily IA, variant 1 with third motif having Dx(3-4)D or Dx(3-4)E', 73, NULL, NULL, 79467),
(79468, '3.80.10.10-FF-003690', NULL, 'Uncharacterized protein', 182, NULL, NULL, 79468),
(79469, '2.130.10.10-FF-001137', NULL, 'Unplaced genomic scaffold supercont1.141, whole genome shotgun sequence', 289, NULL, NULL, 79469),
(79470, '1.25.40.320-FF-000011', NULL, 'Predicted protein', 78, NULL, NULL, 79470),
(79471, '3.30.70.330-FF-001512', NULL, NULL, 58, NULL, NULL, 79471),
(79472, '3.60.21.10-FF-000467', NULL, 'Serine/threonine protein phosphatase PP1', 121, NULL, NULL, 79472),
(79473, '1.10.10.60-FF-001183', NULL, NULL, 31, NULL, NULL, 79473),
(79474, '1.50.10.10-FF-000019', NULL, 'LanC-like protein 1', 399, NULL, NULL, 79474),
(79475, '1.25.40.180-FF-000081', NULL, 'Nonsense-mediated mRNA decay protein 2', 318, NULL, NULL, 79475),
(79476, '3.40.50.80-FF-000185', NULL, 'Putative metalloreductase', 173, NULL, NULL, 79476),
(79477, '1.10.510.10-FF-000032', NULL, 'Serine/threonine-protein kinase PBS1', 216, NULL, NULL, 79477),
(79478, '3.30.60.270-FF-000014', NULL, 'Sortilin', 70, NULL, NULL, 79478),
(79479, '2.40.30.160-FF-000005', NULL, 'Aminomethyltransferase', 116, NULL, NULL, 79479),
(79480, '3.30.70.330-FF-000675', NULL, 'Nuclear RNA export factor 7', 95, NULL, NULL, 79480),
(79481, '2.10.25.10-FF-001677', NULL, 'Uncharacterized protein', 44, NULL, NULL, 79481),
(79482, '2.40.50.40-FF-000080', NULL, 'Chemokine (C-C motif) ligand 25a', 75, NULL, NULL, 79482),
(79483, '1.20.5.110-FF-000311', NULL, 'Syntaxin 17', 57, NULL, NULL, 79483),
(79484, '2.130.10.10-FF-001194', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 185, NULL, NULL, 79484),
(79485, '3.40.50.300-FF-003560', NULL, 'ADP-ribosylation factor-like protein 5-like', 65, NULL, NULL, 79485),
(79486, '1.10.10.60-FF-001126', NULL, NULL, 63, NULL, NULL, 79486),
(79487, '1.20.1730.10-FF-000124', NULL, 'Uncharacterized protein', 208, NULL, NULL, 79487),
(79488, '1.10.8.10-FF-000155', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 33, NULL, NULL, 79488),
(79489, '2.60.120.470-FF-000020', NULL, NULL, 79, NULL, NULL, 79489),
(79490, '3.10.450.80-FF-000001', NULL, '60S ribosomal protein L44', 104, NULL, NULL, 79490),
(79491, '3.60.15.10-FF-000065', NULL, 'Ribonuclease Z', 302, NULL, NULL, 79491),
(79492, '2.30.29.30-FF-001399', NULL, 'Uncharacterized protein', 127, NULL, NULL, 79492),
(79493, '2.10.110.10-FF-000352', NULL, 'LIM homeobox 3', 43, NULL, NULL, 79493),
(79494, '3.40.630.30-FF-000302', NULL, 'RNA cytidine acetyltransferase', 206, NULL, NULL, 79494),
(79495, '3.30.40.10-FF-000793', NULL, 'E3 ubiquitin-protein ligase SGR9 amyloplastic', 84, NULL, NULL, 79495),
(79496, '3.10.350.10-FF-000023', NULL, 'Stage VI sporulation protein D', 55, NULL, NULL, 79496),
(79497, '1.25.10.10-FF-001376', NULL, 'Armadillo-type protein', 874, NULL, NULL, 79497),
(79498, '2.20.25.10-FF-000013', NULL, 'DNA topoisomerase 1', 58, NULL, NULL, 79498); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(79499, '2.40.37.10-FF-000074', NULL, NULL, 155, NULL, NULL, 79499),
(79500, '3.90.190.10-FF-000200', NULL, 'Protein-tyrosine phosphatase, putative (AFU_orthologue AFUA_2G02760)', 144, NULL, NULL, 79500),
(79501, '3.40.1190.20-FF-000039', NULL, 'Putative sugar kinase', 309, NULL, NULL, 79501),
(79502, '1.25.40.20-FF-001605', NULL, 'Ankyrin repeat domain 27 (VPS9 domain)', 108, NULL, NULL, 79502),
(79503, '2.130.10.10-FF-005027', NULL, 'Uncharacterized RWD, RING finger and WD repeat-containing protein C11E3.05', 389, NULL, NULL, 79503),
(79504, '1.25.40.10-FF-001260', NULL, 'Unplaced genomic scaffold supercont2.20, whole genome shotgun sequence', 335, NULL, NULL, 79504),
(79505, '1.25.40.20-FF-001549', NULL, 'Uncharacterized protein', 110, NULL, NULL, 79505),
(79506, '1.20.272.10-FF-000066', NULL, NULL, 127, NULL, NULL, 79506),
(79507, '3.40.50.300-FF-003228', NULL, 'ATP binding cassette subfamily C member 8', 183, NULL, NULL, 79507),
(79508, '3.90.190.10-FF-000144', NULL, 'Uncharacterized protein', 286, NULL, NULL, 79508),
(79509, '3.80.10.10-FF-001778', NULL, 'F-box protein', 80, NULL, NULL, 79509),
(79510, '3.40.50.620-FF-000227', NULL, 'Tyrosine--tRNA ligase', 283, NULL, NULL, 79510),
(79511, '3.30.30.10-FF-000017', NULL, NULL, 55, NULL, NULL, 79511),
(79512, '2.70.98.30-FF-000011', NULL, 'Uncharacterized protein', 262, NULL, NULL, 79512),
(79513, '3.30.1370.10-FF-000148', NULL, 'Protein CBG01583', 195, NULL, NULL, 79513),
(79514, '3.80.10.10-FF-002054', NULL, 'F10A5.16', 98, NULL, NULL, 79514),
(79515, '3.10.580.10-FF-000012', NULL, 'DUF21 domain-containing protein', 130, NULL, NULL, 79515),
(79516, '1.20.1540.10-FF-000019', NULL, 'RHOMBOID-like protein', 190, NULL, NULL, 79516),
(79517, '3.20.20.140-FF-000003', NULL, 'AMP deaminase', 436, NULL, NULL, 79517),
(79518, '3.60.20.10-FF-000212', NULL, NULL, 174, NULL, NULL, 79518),
(79519, '3.50.30.20-FF-000002', NULL, 'Carbamoyl-phosphate synthase 1, mitochondrial', 154, NULL, NULL, 79519),
(79520, '1.10.150.20-FF-000007', NULL, 'DNA ligase', 76, NULL, NULL, 79520),
(79521, '3.10.450.40-FF-000056', NULL, NULL, 118, NULL, NULL, 79521),
(79522, '2.10.25.10-FF-001458', NULL, 'Neurogenic locus notch-like protein 1', 41, NULL, NULL, 79522),
(79523, '3.30.160.60-FF-005263', NULL, NULL, 37, NULL, NULL, 79523),
(79524, '3.40.50.2000-FF-000258', NULL, 'Starch synthase 3', 161, NULL, NULL, 79524),
(79525, '2.130.10.10-FF-004807', NULL, 'Uncharacterized protein', 144, NULL, NULL, 79525),
(79526, '3.80.10.10-FF-000255', NULL, 'NLR family CARD domain containing 5', 222, NULL, NULL, 79526),
(79527, '3.60.20.10-FF-000251', NULL, NULL, 203, NULL, NULL, 79527),
(79528, '2.10.109.10-FF-000051', NULL, 'Uncharacterized protein At2g31140', 154, NULL, NULL, 79528),
(79529, '3.30.450.190-FF-000016', NULL, 'Putative ras-like small GTPases', 139, NULL, NULL, 79529),
(79530, '2.60.40.10-FF-001160', NULL, 'Macrophage colony-stimulating factor 1 receptor', 83, NULL, NULL, 79530),
(79531, '3.40.50.300-FF-004864', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 190, NULL, NULL, 79531),
(79532, '3.30.70.1230-FF-000024', NULL, 'ACXA, isoform A', 242, NULL, NULL, 79532),
(79533, '1.10.1670.10-FF-000071', NULL, NULL, 67, NULL, NULL, 79533),
(79534, '2.70.98.40-FF-000014', NULL, 'Six-hairpin glycosidase-like protein', 256, NULL, NULL, 79534),
(79535, '2.30.30.40-FF-000399', NULL, 'Bridging integrator 2b', 80, NULL, NULL, 79535),
(79536, '1.10.8.270-FF-000075', NULL, 'RaB GAP related', 116, NULL, NULL, 79536),
(79537, '3.10.450.50-FF-000059', NULL, 'Related to ntf2-related export protein 1', 158, NULL, NULL, 79537),
(79538, '1.10.8.50-FF-000032', NULL, 'Uncharacterized protein', 138, NULL, NULL, 79538),
(79539, '1.20.120.1630-FF-000014', NULL, 'Steroid 5-alpha reductase, putative', 175, NULL, NULL, 79539),
(79540, '1.10.220.150-FF-000072', NULL, 'Centaurin, alpha 1, isoform CRA_a', 87, NULL, NULL, 79540),
(79541, '2.60.40.10-FF-005431', NULL, NULL, 98, NULL, NULL, 79541),
(79542, '3.30.260.10-FF-000040', NULL, 'Uncharacterized protein', 74, NULL, NULL, 79542);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(79543, '3.50.30.30-FF-000005', NULL, 'subtilisin-like protease SBT1.5', 143, NULL, NULL, 79543),
(79544, '3.30.1910.20-FF-000002', NULL, 'Asparaginyl-tRNA synthetase', 78, NULL, NULL, 79544),
(79545, '1.10.720.30-FF-000071', NULL, 'Predicted protein', 50, NULL, NULL, 79545),
(79546, '3.20.20.150-FF-000006', NULL, 'L-rhamnose isomerase', 419, NULL, NULL, 79546),
(79547, '1.10.8.60-FF-000035', NULL, 'Lon protease', 94, NULL, NULL, 79547),
(79548, '3.40.50.720-FF-002343', NULL, 'Glucose-6-phosphate 1-dehydrogenase', 130, NULL, NULL, 79548),
(79549, '3.30.40.10-FF-002316', NULL, 'Ubiquitinyl hydrolase 1', 159, NULL, NULL, 79549),
(79550, '1.10.238.10-FF-001236', NULL, 'Uncharacterized protein', 100, NULL, NULL, 79550),
(79551, '3.80.20.20-FF-000085', NULL, 'Predicted protein', 113, NULL, NULL, 79551),
(79552, '3.30.40.10-FF-002373', NULL, 'Inhibitor of growth protein', 86, NULL, NULL, 79552),
(79553, '3.30.160.60-FF-001334', NULL, 'zinc finger protein 133 isoform X2', 30, NULL, NULL, 79553),
(79554, '3.40.50.300-FF-003285', NULL, 'Uncharacterized protein', 142, NULL, NULL, 79554),
(79555, '3.40.50.300-FF-000879', NULL, 'Guanylate kinase 1', 197, NULL, NULL, 79555),
(79556, '3.40.50.300-FF-005027', NULL, 'Uncharacterized protein', 116, NULL, NULL, 79556),
(79557, '3.30.310.80-FF-000014', NULL, 'Non-specific serine/threonine protein kinase', 120, NULL, NULL, 79557),
(79558, '3.40.50.170-FF-000008', NULL, 'Phosphoribosylglycinamide formyltransferase', 209, NULL, NULL, 79558),
(79559, '3.20.20.70-FF-000304', NULL, 'Ketose-bisphosphate aldolase class-II family protein', 284, NULL, NULL, 79559),
(79560, '3.40.50.2300-FF-000646', NULL, 'RNA polymerase II subunit A Cterminal domain phosphatase SSU72', 122, NULL, NULL, 79560),
(79561, '2.130.10.10-FF-001430', NULL, 'Coronin', 342, NULL, NULL, 79561),
(79562, '3.10.129.10-FF-000065', NULL, 'Acyl-CoA thioesterase', 135, NULL, NULL, 79562),
(79563, '3.50.50.60-FF-000055', NULL, 'Thioredoxin reductase 1, cytoplasmic', 216, NULL, NULL, 79563),
(79564, '3.10.110.10-FF-000371', NULL, 'Uncharacterized protein', 119, NULL, NULL, 79564),
(79565, '2.10.25.10-FF-001790', NULL, 'AGAP003506-PA', 30, NULL, NULL, 79565),
(79566, '3.90.226.10-FF-000149', NULL, 'Enoyl-CoA delta isomerase 1', 225, NULL, NULL, 79566),
(79567, '1.25.40.10-FF-003401', NULL, 'Uncharacterized protein', 129, NULL, NULL, 79567),
(79568, '1.10.40.30-FF-000012', NULL, 'Adenylosuccinate lyase', 83, NULL, NULL, 79568),
(79569, '2.30.30.140-FF-000102', NULL, 'Protein MRG1', 97, NULL, NULL, 79569),
(79570, '2.70.150.10-FF-000285', NULL, 'Phospholipid-transporting ATPase', 132, NULL, NULL, 79570),
(79571, '3.30.70.1350-FF-000004', NULL, 'Cation diffusion facilitator 10', 68, NULL, NULL, 79571),
(79572, '3.10.450.40-FF-000017', NULL, 'Amine oxidase', 115, NULL, NULL, 79572),
(79573, '3.30.710.10-FF-000237', NULL, 'kelch-like protein 3 isoform X1', 66, NULL, NULL, 79573),
(79574, '1.25.10.10-FF-000376', NULL, 'beta-catenin-like protein 1', 484, NULL, NULL, 79574),
(79575, '3.20.20.80-FF-000307', NULL, 'Glycogen debranching enzyme', 219, NULL, NULL, 79575),
(79576, '3.30.470.20-FF-000143', NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta, mitochondrial', 20, NULL, NULL, 79576),
(79577, '3.30.930.10-FF-000220', NULL, 'Protein CBG23664', 207, NULL, NULL, 79577),
(79578, '3.40.47.10-FF-000297', NULL, NULL, 62, NULL, NULL, 79578),
(79579, '2.60.40.60-FF-001040', NULL, 'Uncharacterized protein', 97, NULL, NULL, 79579),
(79580, '3.40.630.10-FF-000476', NULL, 'Uncharacterized protein', 318, NULL, NULL, 79580),
(79581, '2.130.10.10-FF-005140', NULL, 'WD-repeat containing protein', 86, NULL, NULL, 79581),
(79582, '3.30.70.330-FF-002586', NULL, NULL, 137, NULL, NULL, 79582),
(79583, '2.60.470.10-FF-000030', NULL, 'Eukaryotic translation initiation factor 6', 201, NULL, NULL, 79583),
(79584, '1.10.10.10-FF-001196', NULL, 'DDRGK domain containing protein, putative', 46, NULL, NULL, 79584),
(79585, '3.40.50.720-FF-000544', NULL, 'YMR315W-like protein', 141, NULL, NULL, 79585),
(79586, '3.90.180.10-FF-000194', NULL, 'Uncharacterized protein', 17, NULL, NULL, 79586);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(79587, '2.160.20.10-FF-000108', NULL, 'PKHD1, fibrocystin/polyductin', 265, NULL, NULL, 79587),
(79588, '3.40.50.150-FF-000002', NULL, 'Ribosomal RNA small subunit methyltransferase H', 199, NULL, NULL, 79588),
(79589, '3.90.79.10-FF-000048', NULL, 'NADH pyrophosphatase', 144, NULL, NULL, 79589),
(79590, '3.20.20.330-FF-000015', NULL, 'Protein CBG15622', 275, NULL, NULL, 79590),
(79591, '3.40.50.300-FF-005084', NULL, 'Chromosome undetermined SCAF6183, whole genome shotgun sequence', 67, NULL, NULL, 79591),
(79592, '3.40.50.880-FF-000165', NULL, 'Gamma-glutamyl peptidase 1', 81, NULL, NULL, 79592),
(79593, '1.10.510.10-FF-001156', NULL, 'Mitogen-activated protein kinase', 154, NULL, NULL, 79593),
(79594, '3.40.50.460-FF-000033', NULL, 'Uncharacterized protein', 133, NULL, NULL, 79594),
(79595, '3.10.20.800-FF-000001', NULL, 'Hypothetical Exported Protein', 114, NULL, NULL, 79595),
(79596, '2.40.50.140-FF-001054', NULL, NULL, 111, NULL, NULL, 79596),
(79597, '2.60.40.1120-FF-000069', NULL, 'SD07707p', 94, NULL, NULL, 79597),
(79598, '1.10.472.10-FF-000662', NULL, 'Cyclin B1', 85, NULL, NULL, 79598),
(79599, '2.80.10.50-FF-000022', NULL, 'Ryanodine receptor, isoform E', 182, NULL, NULL, 79599),
(79600, '3.30.70.330-FF-000456', NULL, 'Heterogeneous nuclear ribonucleoprotein A1', 84, NULL, NULL, 79600),
(79601, '1.20.120.560-FF-000012', NULL, 'pH-response regulator protein palA/RIM20', 163, NULL, NULL, 79601),
(79602, '2.60.60.20-FF-000034', NULL, 'Pkd1l2, putative', 123, NULL, NULL, 79602),
(79603, '3.40.850.10-FF-000307', NULL, 'Kinesin-like protein', 406, NULL, NULL, 79603),
(79604, '3.30.565.10-FF-000517', NULL, 'Uncharacterized protein', 144, NULL, NULL, 79604),
(79605, '1.25.40.20-FF-001263', NULL, 'Uncharacterized protein', 204, NULL, NULL, 79605),
(79606, '3.40.1110.10-FF-000262', NULL, NULL, 123, NULL, NULL, 79606),
(79607, '3.40.50.2000-FF-000590', NULL, 'D-inositol-3-phosphate glycosyltransferase', 93, NULL, NULL, 79607),
(79608, '3.30.200.20-FF-001270', NULL, NULL, 90, NULL, NULL, 79608),
(79609, '3.40.50.300-FF-001430', NULL, 'Small GTPase EhRabM3, putative', 191, NULL, NULL, 79609),
(79610, '1.20.58.160-FF-000011', NULL, NULL, 94, NULL, NULL, 79610),
(79611, '2.10.25.10-FF-000154', NULL, 'FAT atypical cadherin 1', 36, NULL, NULL, 79611),
(79612, '1.20.58.760-FF-000039', NULL, 'ATP-dependent zinc metallopeptidase, putative', 192, NULL, NULL, 79612),
(79613, '3.30.40.10-FF-001479', NULL, 'Uncharacterized protein', 84, NULL, NULL, 79613),
(79614, '2.120.10.80-FF-000147', NULL, 'Distracted, isoform B', 223, NULL, NULL, 79614),
(79615, '1.20.1250.20-FF-000197', NULL, 'Siderophore iron transporter 1', 195, NULL, NULL, 79615),
(79616, '3.60.15.30-FF-000003', NULL, 'Uncharacterized protein', 144, NULL, NULL, 79616),
(79617, '3.40.50.2300-FF-001141', NULL, 'Uncharacterized protein', 300, NULL, NULL, 79617),
(79618, '1.20.1560.10-FF-000526', NULL, 'ATP binding cassette subfamily C member 1', 201, NULL, NULL, 79618),
(79619, '1.10.1370.10-FF-000031', NULL, 'Thimet oligopeptidase', 200, NULL, NULL, 79619),
(79620, '2.130.10.10-FF-004864', NULL, 'Uncharacterized protein', 123, NULL, NULL, 79620),
(79621, '2.170.130.10-FF-000068', NULL, NULL, 134, NULL, NULL, 79621),
(79622, '1.10.630.10-FF-000030', NULL, 'vitamin D 25-hydroxylase isoform X1', 473, NULL, NULL, 79622),
(79623, '2.60.40.420-FF-000002', NULL, 'Hephaestin like 1', 355, NULL, NULL, 79623),
(79624, '3.40.50.2000-FF-000770', NULL, 'UDP-glucuronosyltransferase', 172, NULL, NULL, 79624),
(79625, '3.30.200.20-FF-001612', NULL, 'Protein kinase domain containing protein', 100, NULL, NULL, 79625),
(79626, '1.25.40.180-FF-000042', NULL, 'Eukaryotic translation initiation factor 4 gamma', 150, NULL, NULL, 79626),
(79627, '1.25.40.10-FF-002564', NULL, 'Pentatricopeptide repeat-containing protein', 121, NULL, NULL, 79627),
(79628, '1.25.10.10-FF-000994', NULL, 'HEAT repeat family protein', 528, NULL, NULL, 79628),
(79629, '1.20.5.650-FF-000006', NULL, 'Related to BRF1-TFIIIB subunit, 70 kD', 52, NULL, NULL, 79629),
(79630, '3.30.479.20-FF-000011', NULL, 'Elongation factor Ts', 34, NULL, NULL, 79630); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(79631, '1.20.5.1300-FF-000008', NULL, 'Histidinol dehydrogenase', 54, NULL, NULL, 79631),
(79632, '3.30.70.330-FF-002529', NULL, NULL, 57, NULL, NULL, 79632),
(79633, '3.30.160.60-FF-005824', NULL, NULL, 60, NULL, NULL, 79633),
(79634, '1.20.1250.20-FF-000539', NULL, 'Protein unc-93 homolog A', 205, NULL, NULL, 79634),
(79635, '1.10.10.60-FF-000963', NULL, NULL, 55, NULL, NULL, 79635),
(79636, '1.10.238.10-FF-001293', NULL, 'Uncharacterized protein', 97, NULL, NULL, 79636),
(79637, '1.10.357.90-FF-000002', NULL, 'Telomerase reverse transcriptase', 160, NULL, NULL, 79637),
(79638, '1.20.1070.10-FF-001787', NULL, 'Dopamine receptor D7', 325, NULL, NULL, 79638),
(79639, '3.20.20.150-FF-000063', NULL, 'Protein arginine N-methyltransferase 1.5', 158, NULL, NULL, 79639),
(79640, '3.20.20.140-FF-000060', NULL, 'Hydrolase, TatD family', 268, NULL, NULL, 79640),
(79641, '2.130.10.10-FF-004684', NULL, 'Retinoblastoma-binding-like protein E', 180, NULL, NULL, 79641),
(79642, '3.20.20.140-FF-000402', NULL, 'Uncharacterized protein', 120, NULL, NULL, 79642),
(79643, '1.20.1080.10-FF-000091', NULL, 'Uncharacterized protein', 246, NULL, NULL, 79643),
(79644, '1.10.287.10-FF-000023', NULL, 'Ataxin 3 variant ref', 46, NULL, NULL, 79644),
(79645, '3.30.70.3290-FF-000018', NULL, 'PKS-NRPS hybrid synthetase psoA', 94, NULL, NULL, 79645),
(79646, '3.80.10.10-FF-001891', NULL, 'Leucine-rich repeat-containing G protein-coupled receptor 8', 122, NULL, NULL, 79646),
(79647, '3.40.50.720-FF-000364', NULL, 'Dehydrogenase/reductase SDR family member 13', 284, NULL, NULL, 79647),
(79648, '3.50.50.60-FF-000673', NULL, 'Chromosome 9, whole genome shotgun sequence', 355, NULL, NULL, 79648),
(79649, '1.10.287.310-FF-000001', NULL, '50S ribosomal protein L29', 61, NULL, NULL, 79649),
(79650, '2.60.40.2700-FF-000003', NULL, '187-kDa microtubule-associated protein AIR9 isoform X2', 96, NULL, NULL, 79650),
(79651, '1.25.40.20-FF-001881', NULL, 'Predicted protein', 122, NULL, NULL, 79651),
(79652, '3.10.20.90-FF-000889', NULL, 'A-Raf proto-oncogene, serine/threonine kinase', 54, NULL, NULL, 79652),
(79653, '2.60.120.290-FF-000230', NULL, 'Zinc metalloproteinase', 89, NULL, NULL, 79653),
(79654, '1.25.10.10-FF-001432', NULL, 'Cell death abnormality protein 12', 322, NULL, NULL, 79654),
(79655, '1.20.1250.20-FF-002052', NULL, 'Uncharacterized protein', 308, NULL, NULL, 79655),
(79656, '1.20.1070.10-FF-002063', NULL, 'Uncharacterized protein', 85, NULL, NULL, 79656),
(79657, '1.10.10.650-FF-000012', NULL, 'Transcription elongation factor Spt6', 168, NULL, NULL, 79657),
(79658, '3.50.50.60-FF-001111', NULL, 'Uncharacterized protein', 172, NULL, NULL, 79658),
(79659, '1.10.418.10-FF-000166', NULL, 'Predicted protein', 144, NULL, NULL, 79659),
(79660, '3.30.160.20-FF-000153', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 2', 75, NULL, NULL, 79660),
(79661, '2.30.30.140-FF-000046', NULL, 'tudor domain-containing protein 3 isoform X1', 77, NULL, NULL, 79661),
(79662, '1.20.1540.10-FF-000076', NULL, 'Rhomboid-like protein', 196, NULL, NULL, 79662),
(79663, '4.10.860.10-FF-000013', NULL, 'AGAP002107-PA-like protein', 46, NULL, NULL, 79663),
(79664, '3.20.20.190-FF-000046', NULL, 'Phosphoinositide phospholipase C', 311, NULL, NULL, 79664),
(79665, '3.90.70.10-FF-000798', NULL, 'Uncharacterized protein', 323, NULL, NULL, 79665),
(79666, '3.40.50.1820-FF-001497', NULL, 'Uncharacterized protein', 162, NULL, NULL, 79666),
(79667, '1.10.2020.20-FF-000008', NULL, 'Uncharacterized protein', 102, NULL, NULL, 79667),
(79668, '3.30.1740.10-FF-000020', NULL, 'Poly [ADP-ribose] polymerase', 107, NULL, NULL, 79668),
(79669, '3.30.160.60-FF-005206', NULL, NULL, 43, NULL, NULL, 79669),
(79670, '2.60.40.60-FF-000983', NULL, 'Uncharacterized protein', 99, NULL, NULL, 79670),
(79671, '2.130.10.10-FF-005701', NULL, 'Uncharacterized protein', 418, NULL, NULL, 79671),
(79672, '1.10.510.10-FF-000993', NULL, 'Cyclin-dependent kinase 17', 242, NULL, NULL, 79672),
(79673, '1.10.472.10-FF-000443', NULL, 'Uncharacterized protein', 120, NULL, NULL, 79673);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(79674, '3.20.20.80-FF-000021', NULL, 'Beta-galactosidase', 321, NULL, NULL, 79674),
(79675, '1.10.238.10-FF-000798', NULL, 'EF hand family protein', 162, NULL, NULL, 79675),
(79676, '3.30.200.20-FF-000595', NULL, 'STE/STE20/FRAY protein kinase, variant', 89, NULL, NULL, 79676),
(79677, '3.90.79.10-FF-000267', NULL, 'Uncharacterized protein', 110, NULL, NULL, 79677),
(79678, '3.75.10.10-FF-000043', NULL, NULL, 333, NULL, NULL, 79678),
(79679, '3.40.50.300-FF-005207', NULL, 'Thymidylate kinase', 210, NULL, NULL, 79679),
(79680, '1.20.58.860-FF-000013', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 47, NULL, NULL, 79680),
(79681, '1.10.1300.10-FF-000083', NULL, 'Uncharacterized protein', 392, NULL, NULL, 79681),
(79682, '4.10.1000.10-FF-000131', NULL, 'Predicted protein', 92, NULL, NULL, 79682),
(79683, '3.40.190.10-FF-000846', NULL, 'Putative periplasmic amino acid-binding protein', 97, NULL, NULL, 79683),
(79684, '3.30.160.60-FF-006100', NULL, NULL, 19, NULL, NULL, 79684),
(79685, '3.30.450.60-FF-000018', NULL, 'AP-4 complex subunit mu-1 isoform X1', 142, NULL, NULL, 79685),
(79686, '1.10.486.10-FF-000042', NULL, 'RecBCD enzyme subunit RecB', 143, NULL, NULL, 79686),
(79687, '3.90.550.10-FF-000296', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 392, NULL, NULL, 79687),
(79688, '3.30.565.10-FF-000394', NULL, 'Two-component hybrid sensor and regulator', 144, NULL, NULL, 79688),
(79689, '1.20.1250.20-FF-001557', NULL, 'Uncharacterized protein', 404, NULL, NULL, 79689),
(79690, '3.20.20.80-FF-000420', NULL, 'Os03g0828300 protein', 160, NULL, NULL, 79690),
(79691, '1.25.10.10-FF-000937', NULL, 'Unplaced genomic scaffold supercont1.136, whole genome shotgun sequence', 290, NULL, NULL, 79691),
(79692, '3.80.10.10-FF-000199', NULL, 'centrosomal protein of 97 kDa', 89, NULL, NULL, 79692),
(79693, '3.30.930.10-FF-000400', NULL, 'Predicted protein', 113, NULL, NULL, 79693),
(79694, '3.30.70.330-FF-003081', NULL, NULL, 112, NULL, NULL, 79694),
(79695, '1.10.150.20-FF-000283', NULL, 'Uncharacterized protein', 50, NULL, NULL, 79695),
(79696, '1.10.150.20-FF-000226', NULL, 'Protein CBR-XPG-1', 68, NULL, NULL, 79696),
(79697, '3.50.7.10-FF-000065', NULL, NULL, 168, NULL, NULL, 79697),
(79698, '1.10.1870.10-FF-000013', NULL, 'Alpha-aminoadipic semialdehyde synthase, mitochondrial', 99, NULL, NULL, 79698),
(79699, '3.80.10.10-FF-001559', NULL, 'AGAP009688-PA', 120, NULL, NULL, 79699),
(79700, '3.30.450.50-FF-000015', NULL, 'Synaptobrevin 2 isoform 1', 122, NULL, NULL, 79700),
(79701, '3.90.1170.50-FF-000007', NULL, 'Aldehyde oxidase1', 140, NULL, NULL, 79701),
(79702, '3.10.110.10-FF-000039', NULL, 'Ubiquitin-conjugating enzyme E2 C', 154, NULL, NULL, 79702),
(79703, '3.30.160.60-FF-001553', NULL, 'Zinc finger and BTB domain containing 11', 29, NULL, NULL, 79703),
(79704, '1.10.1820.10-FF-000010', NULL, 'Casein kinase II subunit beta', 103, NULL, NULL, 79704),
(79705, '3.40.50.300-FF-001514', NULL, 'Atlastin, isoform C', 316, NULL, NULL, 79705),
(79706, '1.10.287.70-FF-000204', NULL, 'TWiK family of potassium channels', 309, NULL, NULL, 79706),
(79707, '3.40.50.460-FF-000011', NULL, 'Diphosphate-fructose-6-phosphate 1-phosphotransferase', 146, NULL, NULL, 79707),
(79708, '3.90.380.10-FF-000012', NULL, 'Protein TIC 55, chloroplastic', 193, NULL, NULL, 79708),
(79709, '2.60.40.10-FF-005408', NULL, NULL, 39, NULL, NULL, 79709),
(79710, '2.130.10.30-FF-000031', NULL, 'PH, RCC1 and FYVE domains-containing protein 1', 173, NULL, NULL, 79710),
(79711, '3.40.30.10-FF-000123', NULL, 'Glutathione transferase o1', 107, NULL, NULL, 79711),
(79712, '3.40.50.300-FF-005246', NULL, 'ADP-ribosylation factor-related protein 1', 192, NULL, NULL, 79712),
(79713, '1.20.1270.10-FF-000105', NULL, 'Uncharacterized protein', 101, NULL, NULL, 79713),
(79714, '2.130.10.10-FF-003251', NULL, 'Uncharacterized protein', 210, NULL, NULL, 79714),
(79715, '3.40.640.10-FF-000292', NULL, 'Transcriptional regulator, GntR family', 221, NULL, NULL, 79715),
(79716, '3.30.420.40-FF-000359', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', 169, NULL, NULL, 79716);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(79717, '3.90.320.10-FF-000003', NULL, 'RecBCD enzyme subunit RecB', 291, NULL, NULL, 79717),
(79718, '3.40.50.150-FF-001643', NULL, NULL, 244, NULL, NULL, 79718),
(79719, '3.30.559.10-FF-000082', NULL, 'Probable non-ribosomal peptide synthetase', 186, NULL, NULL, 79719),
(79720, '1.10.238.270-FF-000002', NULL, 'Odorant-binding protein 50c', 155, NULL, NULL, 79720),
(79721, '1.25.40.1040-FF-000010', NULL, 'Phagocyte signaling-impaired protein', 346, NULL, NULL, 79721),
(79722, '3.40.50.1820-FF-000934', NULL, 'Uncharacterized protein', 345, NULL, NULL, 79722),
(79723, '2.130.10.10-FF-002099', NULL, 'Uncharacterized protein', 134, NULL, NULL, 79723),
(79724, '1.20.920.20-FF-000064', NULL, 'Predicted protein', 254, NULL, NULL, 79724),
(79725, '3.60.10.10-FF-000060', NULL, 'Uncharacterized protein, isoform C', 319, NULL, NULL, 79725),
(79726, '3.30.590.10-FF-000019', NULL, 'Protein-arginine kinase', 252, NULL, NULL, 79726),
(79727, '1.20.1270.50-FF-000010', NULL, 'Lysosomal alpha-mannosidase, putative', 78, NULL, NULL, 79727),
(79728, '1.20.920.10-FF-000061', NULL, 'Bromodomain protein 2', 137, NULL, NULL, 79728),
(79729, '3.40.50.1220-FF-000007', NULL, 'NAD-dependent histone deacetylase sirtuin-1', 137, NULL, NULL, 79729),
(79730, '3.30.920.10-FF-000017', NULL, 'Iron-sulfur cluster assembly protein CyaY', 106, NULL, NULL, 79730),
(79731, '3.30.565.10-FF-000495', NULL, 'Gll4098 protein', 142, NULL, NULL, 79731),
(79732, '3.30.70.330-FF-002518', NULL, NULL, 62, NULL, NULL, 79732),
(79733, '3.30.420.10-FF-000350', NULL, 'Uncharacterized protein', 259, NULL, NULL, 79733),
(79734, '1.20.1270.60-FF-000013', NULL, 'Amphiphysin isoform 2', 236, NULL, NULL, 79734),
(79735, '2.10.25.10-FF-000250', NULL, 'Laminin subunit alpha 2', 52, NULL, NULL, 79735),
(79736, '3.40.47.10-FF-000229', NULL, NULL, 87, NULL, NULL, 79736),
(79737, '1.20.1070.10-FF-001894', NULL, 'Cephalotocin receptor 1', 338, NULL, NULL, 79737),
(79738, '3.30.710.10-FF-000097', NULL, 'B-cell CLL/lymphoma 6 member B protein', 124, NULL, NULL, 79738),
(79739, '3.40.50.12230-FF-000016', NULL, 'Methionyl-tRNA formyltransferase, putative', 337, NULL, NULL, 79739),
(79740, '3.30.54.20-FF-000002', NULL, 'Threonine--tRNA ligase', 57, NULL, NULL, 79740),
(79741, '2.130.10.10-FF-004869', NULL, 'LD47540p', 121, NULL, NULL, 79741),
(79742, '1.10.10.10-FF-001241', NULL, 'Two-component response regulator', 110, NULL, NULL, 79742),
(79743, '1.10.246.190-FF-000001', NULL, 'Autophagy related 5', 58, NULL, NULL, 79743),
(79744, '3.50.50.60-FF-000375', NULL, 'Pyridine nucleotide-disulphide oxidoreductase', 68, NULL, NULL, 79744),
(79745, '3.30.70.260-FF-000075', NULL, 'GTP pyrophosphokinase', 81, NULL, NULL, 79745),
(79746, '1.20.1050.10-FF-000257', NULL, 'Predicted protein', 137, NULL, NULL, 79746),
(79747, '2.60.40.10-FF-002767', NULL, 'Zwei Ig domain protein zig-6', 91, NULL, NULL, 79747),
(79748, '3.40.50.10190-FF-000050', NULL, 'DNA ligase', 104, NULL, NULL, 79748),
(79749, '2.70.98.30-FF-000022', NULL, 'Alpha-mannosidase', 271, NULL, NULL, 79749),
(79750, '3.30.200.20-FF-000825', NULL, 'CAMK/CDPK protein kinase', 84, NULL, NULL, 79750),
(79751, '3.40.50.11850-FF-000003', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', 73, NULL, NULL, 79751),
(79752, '1.20.1250.20-FF-001040', NULL, 'MFS transporter, putative', 172, NULL, NULL, 79752),
(79753, '3.30.70.270-FF-000078', NULL, 'Diguanylate cyclase response regulator', 165, NULL, NULL, 79753),
(79754, '2.60.120.290-FF-000180', NULL, 'Uncharacterized protein', 112, NULL, NULL, 79754),
(79755, '1.25.40.420-FF-000041', NULL, 'Kelch-like 13', 124, NULL, NULL, 79755),
(79756, '2.60.40.10-FF-003273', NULL, 'Tyrosine-protein kinase receptor TYRO3', 102, NULL, NULL, 79756),
(79757, '1.20.1560.10-FF-000341', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 338, NULL, NULL, 79757),
(79758, '3.40.50.1460-FF-000130', NULL, 'Uncharacterized protein', 110, NULL, NULL, 79758),
(79759, '4.10.240.10-FF-000213', NULL, 'Regulatory protein alcR', 62, NULL, NULL, 79759),
(79760, '3.40.50.410-FF-000136', NULL, 'C-type LECtin', 195, NULL, NULL, 79760);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(79761, '3.30.342.10-FF-000022', NULL, 'DNA polymerase', 167, NULL, NULL, 79761),
(79762, '3.40.350.10-FF-000089', NULL, 'Xaa-pro aminopeptidase, putative', 143, NULL, NULL, 79762),
(79763, '3.10.100.10-FF-000269', NULL, NULL, 130, NULL, NULL, 79763),
(79764, '3.30.420.10-FF-000024', NULL, 'DNA polymerase zeta catalytic subunit', 297, NULL, NULL, 79764),
(79765, '3.80.10.10-FF-002711', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 114, NULL, NULL, 79765),
(79766, '3.30.2280.10-FF-000001', NULL, 'Clustered mitochondria (CluA/CLU1) homolog', 81, NULL, NULL, 79766),
(79767, '2.40.240.10-FF-000034', NULL, 'probable glutamine--tRNA ligase', 115, NULL, NULL, 79767),
(79768, '1.20.58.60-FF-000314', NULL, 'VAB-10B protein', 218, NULL, NULL, 79768),
(79769, '2.60.120.200-FF-000563', NULL, 'Novel protein similar to human EGF LAG seven-pass G-type receptor 1 cadherin (CELSR1)', 100, NULL, NULL, 79769),
(79770, '1.20.120.810-FF-000008', NULL, 'Vinculin, isoform B', 127, NULL, NULL, 79770),
(79771, '1.20.272.40-FF-000013', NULL, 'AaceriAGL240Wp', 81, NULL, NULL, 79771),
(79772, '2.60.120.10-FF-000010', NULL, 'neuropathy target esterase isoform X1', 117, NULL, NULL, 79772),
(79773, '3.40.390.10-FF-000209', NULL, NULL, 237, NULL, NULL, 79773),
(79774, '1.10.150.20-FF-000182', NULL, 'Uncharacterized protein', 81, NULL, NULL, 79774),
(79775, '3.40.50.720-FF-000448', NULL, 'Trk system potassium transporter TrkA', 138, NULL, NULL, 79775),
(79776, '1.25.40.20-FF-001914', NULL, 'Ankyrin-repeat protein, putative', 286, NULL, NULL, 79776),
(79777, '3.30.1370.210-FF-000002', NULL, 'Muscleblind-like 1 isoform 2', 96, NULL, NULL, 79777),
(79778, '3.40.50.300-FF-002020', NULL, 'Ras-related protein Rab-37', 195, NULL, NULL, 79778),
(79779, '3.30.720.90-FF-000003', NULL, '60S ribosomal protein L38', 87, NULL, NULL, 79779),
(79780, '1.20.920.30-FF-000067', NULL, 'Cytoplasmic dynein heavy chain, putative', 106, NULL, NULL, 79780),
(79781, '2.20.100.10-FF-000214', NULL, 'Thrombospondin type-1 domain-containing protein 7B', 48, NULL, NULL, 79781),
(79782, '1.10.510.10-FF-002769', NULL, NULL, 222, NULL, NULL, 79782),
(79783, '3.20.20.300-FF-000074', NULL, NULL, 103, NULL, NULL, 79783),
(79784, '1.10.3430.10-FF-000059', NULL, 'Uncharacterized protein', 146, NULL, NULL, 79784),
(79785, '4.10.280.10-FF-000013', NULL, 'Circadian locomoter output cycles protein kaput', 77, NULL, NULL, 79785),
(79786, '2.40.50.140-FF-000924', NULL, NULL, 148, NULL, NULL, 79786),
(79787, '1.10.490.10-FF-000018', NULL, 'GLoBin related', 161, NULL, NULL, 79787),
(79788, '3.30.160.60-FF-006269', NULL, NULL, 21, NULL, NULL, 79788),
(79789, '3.40.50.1820-FF-000608', NULL, 'Uncharacterized protein, isoform A', 544, NULL, NULL, 79789),
(79790, '3.30.497.10-FF-000095', NULL, 'Serpin peptidase inhibitor 1', 188, NULL, NULL, 79790),
(79791, '1.25.40.20-FF-001235', NULL, 'KN motif and ankyrin repeat domains 3', 256, NULL, NULL, 79791),
(79792, '3.30.1360.40-FF-000050', NULL, 'DNA topoisomerase IIB', 64, NULL, NULL, 79792),
(79793, '1.10.260.100-FF-000020', NULL, 'Heat shock protein 70 (HSP70)-interacting protein, putative', 67, NULL, NULL, 79793),
(79794, '3.30.240.40-FF-000002', NULL, 'Protein E6', 81, NULL, NULL, 79794),
(79795, '1.10.1580.10-FF-000030', NULL, 'Nucleolar GTP-binding protein 2', 87, NULL, NULL, 79795),
(79796, '3.80.10.10-FF-004156', NULL, 'Uncharacterized protein', 104, NULL, NULL, 79796),
(79797, '1.25.40.10-FF-001232', NULL, 'Pentatricopeptide repeat-containing protein At5g52850, chloroplastic', 89, NULL, NULL, 79797),
(79798, '3.90.660.10-FF-000124', NULL, NULL, 104, NULL, NULL, 79798),
(79799, '3.40.50.720-FF-001876', NULL, 'Pyrroline-5-carboxylate reductase-like 2, isoform B', 68, NULL, NULL, 79799),
(79800, '3.40.50.150-FF-001317', NULL, NULL, 207, NULL, NULL, 79800),
(79801, '2.60.40.10-FF-002458', NULL, 'Uncharacterized protein, isoform E', 101, NULL, NULL, 79801),
(79802, '3.30.70.330-FF-000057', NULL, 'U2 snRNP auxiliary factor large subunit', 102, NULL, NULL, 79802),
(79803, '3.40.390.10-FF-000165', NULL, 'Metalloendopeptidase', 239, NULL, NULL, 79803);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(79804, '3.30.160.60-FF-003043', NULL, 'Myc-associated zinc finger protein', 27, NULL, NULL, 79804),
(79805, '3.30.565.10-FF-000169', NULL, 'Sensor protein', 153, NULL, NULL, 79805),
(79806, '2.60.120.650-FF-000142', NULL, 'YALI0B14443p', 112, NULL, NULL, 79806),
(79807, '1.10.1060.10-FF-000018', NULL, 'Putative selenate reductase, YgfK subunit', 131, NULL, NULL, 79807),
(79808, '3.40.50.300-FF-001840', NULL, 'DEAD-box ATP-dependent RNA helicase 3B, chloroplastic', 210, NULL, NULL, 79808),
(79809, '1.10.287.70-FF-000530', NULL, 'Potassium calcium-activated channel subfamily N member 3', 95, NULL, NULL, 79809),
(79810, '3.40.250.10-FF-000216', NULL, 'Uncharacterized protein UNK4.09', 89, NULL, NULL, 79810),
(79811, '2.30.30.40-FF-000388', NULL, 'Uncharacterized protein', 41, NULL, NULL, 79811),
(79812, '3.30.160.60-FF-002879', NULL, 'Uncharacterized protein', 24, NULL, NULL, 79812),
(79813, '3.40.1120.10-FF-000009', NULL, NULL, 84, NULL, NULL, 79813),
(79814, '2.30.30.490-FF-000050', NULL, 'Protein polybromo-1', 204, NULL, NULL, 79814),
(79815, '3.80.10.10-FF-000250', NULL, 'vasorin', 145, NULL, NULL, 79815),
(79816, '3.30.710.10-FF-000108', NULL, 'gigaxonin isoform X1', 126, NULL, NULL, 79816),
(79817, '3.90.180.10-FF-000014', NULL, 'Cinnamyl alcohol dehydrogenase 2', 181, NULL, NULL, 79817),
(79818, '3.10.20.90-FF-000974', NULL, 'Uncharacterized protein', 101, NULL, NULL, 79818),
(79819, '3.10.450.700-FF-000005', NULL, 'purine-rich element-binding protein gamma isoform X1', 39, NULL, NULL, 79819),
(79820, '3.30.160.60-FF-001261', NULL, 'Zinc finger protein 75a', 27, NULL, NULL, 79820),
(79821, '2.60.40.820-FF-000009', NULL, 'MAX gene-associated protein isoform X1', 193, NULL, NULL, 79821),
(79822, '1.20.1080.10-FF-000068', NULL, 'Aquaporin-like protein', 112, NULL, NULL, 79822),
(79823, '2.30.29.30-FF-000168', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', 126, NULL, NULL, 79823),
(79824, '1.25.10.10-FF-001067', NULL, 'WGS project CABT00000000 data, contig 2.21', 312, NULL, NULL, 79824),
(79825, '1.20.5.110-FF-000221', NULL, 'SNARE domain containing protein', 63, NULL, NULL, 79825),
(79826, '2.60.40.60-FF-000758', NULL, 'Hedgehog protein', 106, NULL, NULL, 79826),
(79827, '1.10.10.10-FF-000398', NULL, 'RNA polymerase factor sigma-70', 90, NULL, NULL, 79827),
(79828, '3.90.550.10-FF-000397', NULL, 'Glycosyl transferase CpsJ(V)', 254, NULL, NULL, 79828),
(79829, '1.10.10.160-FF-000034', NULL, 'DNA helicase', 86, NULL, NULL, 79829),
(79830, '1.20.58.1480-FF-000012', NULL, 'Lon protease homolog', 128, NULL, NULL, 79830),
(79831, '1.10.238.10-FF-001225', NULL, 'Calcium-binding protein F-like', 122, NULL, NULL, 79831),
(79832, '4.10.400.10-FF-000102', NULL, 'Low-density lipoprotein receptor-related protein 1B', 39, NULL, NULL, 79832),
(79833, '3.40.50.300-FF-001194', NULL, 'Dynein heavy chain, putative', 124, NULL, NULL, 79833),
(79834, '3.30.710.10-FF-000417', NULL, 'Predicted protein', 127, NULL, NULL, 79834),
(79835, '2.60.260.20-FF-000169', NULL, 'Chaperone protein', 105, NULL, NULL, 79835),
(79836, '3.40.50.150-FF-001008', NULL, NULL, 199, NULL, NULL, 79836),
(79837, '1.20.1700.10-FF-000004', NULL, 'RE73673p', 91, NULL, NULL, 79837),
(79838, '3.40.225.10-FF-000057', NULL, NULL, 97, NULL, NULL, 79838),
(79839, '3.40.630.30-FF-000111', NULL, 'Aminoglycoside N(6'')-acetyltransferase type 1', 145, NULL, NULL, 79839),
(79840, '3.30.70.330-FF-000720', NULL, 'RBM44 isoform 2', 201, NULL, NULL, 79840),
(79841, '2.10.25.10-FF-001559', NULL, 'Delta-like protein', 41, NULL, NULL, 79841),
(79842, '1.25.40.120-FF-000102', NULL, 'Uncharacterized protein', 88, NULL, NULL, 79842),
(79843, '1.20.1250.20-FF-001995', NULL, 'AGAP012344-PA', 383, NULL, NULL, 79843),
(79844, '3.90.1150.10-FF-000427', NULL, 'Uncharacterized protein', 56, NULL, NULL, 79844),
(79845, '2.130.10.10-FF-005712', NULL, 'Uncharacterized protein', 143, NULL, NULL, 79845),
(79846, '3.50.50.60-FF-000049', NULL, 'Protein FLOWERING LOCUS D like', 215, NULL, NULL, 79846),
(79847, '3.40.50.10810-FF-000079', NULL, 'SWF/SNF family helicase', 244, NULL, NULL, 79847);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(79848, '3.40.630.30-FF-000420', NULL, 'Uncharacterized protein', 166, NULL, NULL, 79848),
(79849, '3.90.950.10-FF-000034', NULL, 'Inosine/xanthosine triphosphatase', 67, NULL, NULL, 79849),
(79850, '3.30.40.10-FF-002266', NULL, 'Uncharacterized protein', 54, NULL, NULL, 79850),
(79851, '1.10.287.610-FF-000012', NULL, 'DNA ligase', 62, NULL, NULL, 79851),
(79852, '3.40.50.300-FF-007500', NULL, 'Uncharacterized protein', 223, NULL, NULL, 79852),
(79853, '2.30.42.10-FF-000507', NULL, NULL, 94, NULL, NULL, 79853),
(79854, '1.20.58.60-FF-000640', NULL, 'Uncharacterized protein', 276, NULL, NULL, 79854),
(79855, '1.20.120.900-FF-000002', NULL, 'Peroxisome biogenesis protein 19-2', 113, NULL, NULL, 79855),
(79856, '3.30.780.10-FF-000028', NULL, 'Uncharacterized protein', 103, NULL, NULL, 79856),
(79857, '1.25.40.10-FF-000759', NULL, 'Pentatricopeptide repeat-containing protein PNM1 mitochondrial', 127, NULL, NULL, 79857),
(79858, '1.25.10.10-FF-000578', NULL, 'RING-type E3 ubiquitin transferase', 277, NULL, NULL, 79858),
(79859, '2.60.120.200-FF-000237', NULL, 'Mannose/glucose-specific lectin', 241, NULL, NULL, 79859),
(79860, '3.40.50.300-FF-001205', NULL, 'Midasin', 171, NULL, NULL, 79860),
(79861, '3.30.70.330-FF-002827', NULL, NULL, 88, NULL, NULL, 79861),
(79862, '1.10.340.70-FF-000008', NULL, 'Transposon Tf2-6 polyprotein', 92, NULL, NULL, 79862),
(79863, '2.70.20.10-FF-000017', NULL, 'DNA topoisomerase', 154, NULL, NULL, 79863),
(79864, '3.90.190.10-FF-000149', NULL, 'Receptor-type tyrosine-protein phosphatase V', 266, NULL, NULL, 79864),
(79865, '3.30.160.60-FF-003722', NULL, NULL, 29, NULL, NULL, 79865),
(79866, '3.40.190.10-FF-000863', NULL, 'Transferrin-a', 36, NULL, NULL, 79866),
(79867, '1.25.10.10-FF-003321', NULL, 'Uncharacterized protein', 144, NULL, NULL, 79867),
(79868, '1.25.10.10-FF-003012', NULL, 'Tubulin-specific chaperone D-like Protein', 335, NULL, NULL, 79868),
(79869, '3.40.50.300-FF-007337', NULL, 'Predicted protein', 143, NULL, NULL, 79869),
(79870, '2.60.490.10-FF-000003', NULL, 'P2X purinoceptor', 223, NULL, NULL, 79870),
(79871, '3.40.50.800-FF-000130', NULL, 'Uncharacterized protein', 104, NULL, NULL, 79871),
(79872, '3.30.70.1400-FF-000019', NULL, 'N,N-dimethylglycine oxidase, putative (AFU_orthologue AFUA_8G06470)', 121, NULL, NULL, 79872),
(79873, '3.60.40.10-FF-000241', NULL, 'TGF-beta-activated kinase 1/MAP3K7-binding protein 1', 217, NULL, NULL, 79873),
(79874, '1.25.10.10-FF-000887', NULL, 'Hypothetical_protein_-_conserved', 300, NULL, NULL, 79874),
(79875, '3.30.460.10-FF-000100', NULL, 'Uncharacterized protein', 108, NULL, NULL, 79875),
(79876, '3.90.1390.10-FF-000001', NULL, NULL, 74, NULL, NULL, 79876),
(79877, '3.10.580.10-FF-000124', NULL, 'Metal transporter cnnm-4', 148, NULL, NULL, 79877),
(79878, '1.25.40.10-FF-000389', NULL, 'Serine/threonine-protein phosphatase', 131, NULL, NULL, 79878),
(79879, '2.120.10.30-FF-000481', NULL, 'Putative lipoprotein', 301, NULL, NULL, 79879),
(79880, '1.20.1740.10-FF-000113', NULL, 'Uncharacterized protein', 146, NULL, NULL, 79880),
(79881, '1.20.5.170-FF-000115', NULL, 'Peptide chain release factor subunit 1', 32, NULL, NULL, 79881),
(79882, '2.30.29.30-FF-000640', NULL, 'Atypical/BCR protein kinase', 115, NULL, NULL, 79882),
(79883, '3.40.50.170-FF-000031', NULL, 'Phosphoribosylglycinamide formyltransferase', 204, NULL, NULL, 79883),
(79884, '3.20.20.20-FF-000008', NULL, 'Dihydropteroate synthase', 287, NULL, NULL, 79884),
(79885, '1.20.120.910-FF-000005', NULL, 'RNA polymerase-binding transcription factor DksA', 134, NULL, NULL, 79885),
(79886, '1.20.1250.20-FF-000904', NULL, 'MFS transporter, putative', 475, NULL, NULL, 79886),
(79887, '3.40.190.10-FF-000554', NULL, 'Transcriptional regulatory protein', 92, NULL, NULL, 79887),
(79888, '1.20.1560.10-FF-000015', NULL, 'multidrug resistance-associated protein 5 isoform X1', 348, NULL, NULL, 79888),
(79889, '3.10.129.10-FF-000059', NULL, 'Acyl-coenzyme A thioesterase 13', 131, NULL, NULL, 79889),
(79890, '1.20.1070.10-FF-000803', NULL, 'Neuropeptide FF receptor 2', 350, NULL, NULL, 79890);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(79891, '3.20.180.20-FF-000027', NULL, 'YALI0E32857p', 95, NULL, NULL, 79891),
(79892, '3.30.70.330-FF-001063', NULL, 'SD14970p', 120, NULL, NULL, 79892),
(79893, '4.10.240.10-FF-000230', NULL, 'Uncharacterized protein', 78, NULL, NULL, 79893),
(79894, '3.30.420.40-FF-001039', NULL, 'Uncharacterized protein', 23, NULL, NULL, 79894),
(79895, '1.20.1310.20-FF-000022', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 178, NULL, NULL, 79895),
(79896, '3.40.50.850-FF-000021', NULL, 'Pyrazinamidase/nicotinamidase, putative', 199, NULL, NULL, 79896),
(79897, '3.10.100.10-FF-000286', NULL, NULL, 116, NULL, NULL, 79897),
(79898, '3.20.20.80-FF-000212', NULL, 'Exo-1,3-beta-glucanase', 447, NULL, NULL, 79898),
(79899, '3.90.950.10-FF-000017', NULL, 'Protein PRRC1-B', 142, NULL, NULL, 79899),
(79900, '3.40.190.10-FF-000880', NULL, 'Uncharacterized protein', 102, NULL, NULL, 79900),
(79901, '3.40.50.720-FF-000920', NULL, 'BDH2 isoform 2', 125, NULL, NULL, 79901),
(79902, '2.130.10.10-FF-005988', NULL, 'Uncharacterized protein', 228, NULL, NULL, 79902),
(79903, '3.40.50.300-FF-007028', NULL, 'Ras-related protein RabX', 204, NULL, NULL, 79903),
(79904, '1.20.210.10-FF-000007', NULL, 'Cytochrome c oxidase subunit 1', 472, NULL, NULL, 79904),
(79905, '3.40.50.10190-FF-000033', NULL, 'DNA topoisomerase II binding protein 1', 101, NULL, NULL, 79905),
(79906, '1.20.5.170-FF-000071', NULL, 'Neural retina-specific leucine zipper protein', 101, NULL, NULL, 79906),
(79907, '3.40.190.170-FF-000015', NULL, 'TRAP dicarboxylate transporter, DctP subunit', 317, NULL, NULL, 79907),
(79908, '1.20.1070.10-FF-000450', NULL, 'DOPamine receptor', 149, NULL, NULL, 79908),
(79909, '2.130.10.10-FF-003560', NULL, 'WD repeat domain 62, isoform F', 262, NULL, NULL, 79909),
(79910, '2.40.37.10-FF-000080', NULL, NULL, 101, NULL, NULL, 79910),
(79911, '2.130.10.10-FF-002762', NULL, 'Uncharacterized protein', 246, NULL, NULL, 79911),
(79912, '3.30.160.60-FF-005313', NULL, NULL, 79, NULL, NULL, 79912),
(79913, '3.30.559.10-FF-000109', NULL, 'Transferase family protein', 198, NULL, NULL, 79913),
(79914, '1.10.238.10-FF-000736', NULL, 'Uncharacterized protein', 159, NULL, NULL, 79914),
(79915, '2.60.120.200-FF-000580', NULL, 'Uncharacterized protein', 168, NULL, NULL, 79915),
(79916, '2.120.10.10-FF-000014', NULL, 'Tail spike protein', 356, NULL, NULL, 79916),
(79917, '2.40.50.320-FF-000001', NULL, 'Cation efflux system protein CusF', 75, NULL, NULL, 79917),
(79918, '2.60.40.10-FF-004919', NULL, NULL, 122, NULL, NULL, 79918),
(79919, '3.50.50.60-FF-000684', NULL, '2,6-dihydroxypyridine 3-hydroxylase', 179, NULL, NULL, 79919),
(79920, '2.40.50.140-FF-000941', NULL, NULL, 82, NULL, NULL, 79920),
(79921, '3.20.20.300-FF-000057', NULL, NULL, 327, NULL, NULL, 79921),
(79922, '3.40.50.300-FF-003431', NULL, 'ATP-dependent DNA helicase', 220, NULL, NULL, 79922),
(79923, '3.40.50.1820-FF-001699', NULL, 'Uncharacterized protein', 186, NULL, NULL, 79923),
(79924, '3.40.50.20-FF-000009', NULL, 'Glutathione synthetase', 110, NULL, NULL, 79924),
(79925, '3.30.750.24-FF-000107', NULL, 'Anti sigma factor antagonist', 109, NULL, NULL, 79925),
(79926, '3.10.20.340-FF-000009', NULL, 'Uncharacterized protein', 97, NULL, NULL, 79926),
(79927, '1.10.3430.10-FF-000076', NULL, 'Uncharacterized protein', 116, NULL, NULL, 79927),
(79928, '2.60.40.420-FF-000277', NULL, 'Uncharacterized protein', 209, NULL, NULL, 79928),
(79929, '3.40.50.1970-FF-000058', NULL, NULL, 89, NULL, NULL, 79929),
(79930, '3.40.50.620-FF-000418', NULL, 'tRNA-methyl transferase, putative', 239, NULL, NULL, 79930),
(79931, '2.60.40.10-FF-005055', NULL, NULL, 145, NULL, NULL, 79931),
(79932, '4.10.410.10-FF-000030', NULL, 'CBN-MEC-1 protein', 67, NULL, NULL, 79932),
(79933, '2.60.40.10-FF-003301', NULL, 'Leukemia inhibitory factor receptor alpha b', 95, NULL, NULL, 79933),
(79934, '3.90.550.50-FF-000167', NULL, 'Hexosyltransferase', 162, NULL, NULL, 79934),
(79935, '3.60.10.10-FF-000043', NULL, 'Endonuclease/Exonuclease/phosphatase family protein', 262, NULL, NULL, 79935),
(79936, '3.40.50.300-FF-001531', NULL, 'Endonuclease MutS2', 310, NULL, NULL, 79936);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(79937, '3.40.50.1820-FF-000625', NULL, 'Lipase-related protein', 229, NULL, NULL, 79937),
(79938, '1.10.10.60-FF-000952', NULL, NULL, 103, NULL, NULL, 79938),
(79939, '2.30.30.770-FF-000010', NULL, NULL, 126, NULL, NULL, 79939),
(79940, '3.30.559.10-FF-000065', NULL, 'Non-ribosomal peptide synthetase', 185, NULL, NULL, 79940),
(79941, '2.60.40.150-FF-000792', NULL, 'Uncharacterized protein', 77, NULL, NULL, 79941),
(79942, '3.40.50.1820-FF-000081', NULL, 'phospholipase A1 member A isoform X1', 309, NULL, NULL, 79942),
(79943, '2.30.30.790-FF-000016', NULL, 'Translation protein SH3-like domain-containing protein', 129, NULL, NULL, 79943),
(79944, '1.25.40.20-FF-001370', NULL, 'Uncharacterized protein', 89, NULL, NULL, 79944),
(79945, '3.40.50.300-FF-005229', NULL, 'Uncharacterized protein', 202, NULL, NULL, 79945),
(79946, '3.40.50.150-FF-001334', NULL, NULL, 198, NULL, NULL, 79946),
(79947, '3.30.390.80-FF-000002', NULL, 'RAD52 motif containing 1', 147, NULL, NULL, 79947),
(79948, '3.80.10.10-FF-002239', NULL, 'Leucine-rich repeat (LRR) family protein', 227, NULL, NULL, 79948),
(79949, '3.30.730.10-FF-000008', NULL, 'AP2 domain-containing protein RAP2.8', 58, NULL, NULL, 79949),
(79950, '3.10.20.320-FF-000003', NULL, 'LPXTG cell wall anchor domain-containing protein', 73, NULL, NULL, 79950),
(79951, '1.10.640.10-FF-000070', NULL, 'Uncharacterized protein', 142, NULL, NULL, 79951),
(79952, '2.10.70.20-FF-000003', NULL, 'General secretion pathway protein J', 46, NULL, NULL, 79952),
(79953, '3.40.50.80-FF-000230', NULL, 'Uncharacterized protein', 120, NULL, NULL, 79953),
(79954, '3.30.70.330-FF-002491', NULL, NULL, 75, NULL, NULL, 79954),
(79955, '1.10.730.10-FF-000189', NULL, 'Glycine--tRNA ligase beta subunit', 104, NULL, NULL, 79955),
(79956, '1.10.238.10-FF-001079', NULL, 'EF hand family protein', 68, NULL, NULL, 79956),
(79957, '3.30.1360.40-FF-000033', NULL, 'DNA topoisomerase 4 subunit A', 97, NULL, NULL, 79957),
(79958, '2.30.30.30-FF-000059', NULL, 'Transcription elongation factor SPT5', 65, NULL, NULL, 79958),
(79959, '1.20.920.20-FF-000047', NULL, 'YALI0E32857p', 337, NULL, NULL, 79959),
(79960, '3.40.50.1820-FF-001727', NULL, 'Rop guanine nucleotide exchange factor 7', 99, NULL, NULL, 79960),
(79961, '2.130.10.10-FF-004886', NULL, 'Uncharacterized protein', 117, NULL, NULL, 79961),
(79962, '2.60.40.10-FF-001356', NULL, 'Uncharacterized protein, isoform D', 92, NULL, NULL, 79962),
(79963, '1.20.1250.20-FF-001978', NULL, 'Tetracycline resistance protein', 395, NULL, NULL, 79963),
(79964, '1.20.1560.10-FF-000650', NULL, 'Uncharacterized protein', 128, NULL, NULL, 79964),
(79965, '1.10.260.40-FF-000050', NULL, 'HTH-type transcriptional regulator', 102, NULL, NULL, 79965),
(79966, '3.40.50.720-FF-002365', NULL, 'Predicted protein', 64, NULL, NULL, 79966),
(79967, '2.30.29.30-FF-000314', NULL, 'Beta-1-syntrophin isoform 1', 46, NULL, NULL, 79967),
(79968, '3.40.33.10-FF-000130', NULL, 'Predicted protein', 189, NULL, NULL, 79968),
(79969, '3.30.160.60-FF-003059', NULL, 'Zinc finger protein 335', 60, NULL, NULL, 79969),
(79970, '1.20.920.10-FF-000044', NULL, 'Bromodomain and WD repeat domain-containing 1', 121, NULL, NULL, 79970),
(79971, '1.10.10.160-FF-000051', NULL, 'DNA helicase', 82, NULL, NULL, 79971),
(79972, '3.90.190.10-FF-000621', NULL, 'Uncharacterized protein', 65, NULL, NULL, 79972),
(79973, '1.25.40.90-FF-000047', NULL, 'Uncharacterized protein, isoform A', 136, NULL, NULL, 79973),
(79974, '2.60.40.10-FF-005201', NULL, NULL, 91, NULL, NULL, 79974),
(79975, '4.10.1000.10-FF-000030', NULL, 'CCCH type zinc finger protein', 87, NULL, NULL, 79975),
(79976, '1.25.10.10-FF-001730', NULL, 'Splicing factor3B subunit 1, putative', 197, NULL, NULL, 79976),
(79977, '2.10.25.10-FF-000603', NULL, 'Stabilin 1', 42, NULL, NULL, 79977),
(79978, '3.30.420.10-FF-000333', NULL, 'Uncharacterized protein', 187, NULL, NULL, 79978),
(79979, '3.30.1520.10-FF-000037', NULL, 'Sorting nexin mvp-1', 125, NULL, NULL, 79979),
(79980, '2.130.10.10-FF-000963', NULL, 'AGAP001362-PA-like protein', 181, NULL, NULL, 79980);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(79981, '3.20.20.30-FF-000028', NULL, 'Alkanesulfonate monooxygenase SsuD/methylene tetrahydromethanopterin reductase-like flavin-dependent oxidoreductase (Luciferase family)', 286, NULL, NULL, 79981),
(79982, '1.10.357.10-FF-000029', NULL, 'TetR family transcriptional regulator', 198, NULL, NULL, 79982),
(79983, '1.10.287.520-FF-000002', NULL, 'Noggin', 51, NULL, NULL, 79983),
(79984, '2.130.10.10-FF-000637', NULL, 'WD-40 repeat family protein', 217, NULL, NULL, 79984),
(79985, '3.30.1010.10-FF-000088', NULL, 'DNA-dependent protein kinase catalytic subunit', 165, NULL, NULL, 79985),
(79986, '1.20.1230.10-FF-000013', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 183, NULL, NULL, 79986),
(79987, '3.40.50.1820-FF-000390', NULL, 'BnaC04g55880D protein', 275, NULL, NULL, 79987),
(79988, '3.40.50.620-FF-000553', NULL, 'Uncharacterized protein', 249, NULL, NULL, 79988),
(79989, '3.20.20.20-FF-000025', NULL, 'Corrinoid/iron-sulfur protein large subunit', 316, NULL, NULL, 79989),
(79990, '3.40.366.10-FF-000058', NULL, 'Uncharacterized protein', 171, NULL, NULL, 79990),
(79991, '1.20.58.60-FF-000286', NULL, 'Uncharacterized protein, isoform D', 112, NULL, NULL, 79991),
(79992, '2.10.110.10-FF-000341', NULL, 'LIM and SH3 protein 1', 88, NULL, NULL, 79992),
(79993, '3.40.50.300-FF-001486', NULL, 'Molybdopterin-guanine dinucleotide biosynthesis protein B', 168, NULL, NULL, 79993),
(79994, '1.10.510.10-FF-003921', NULL, NULL, 75, NULL, NULL, 79994),
(79995, '3.30.540.10-FF-000073', NULL, 'Uncharacterized protein', 178, NULL, NULL, 79995),
(79996, '1.10.101.10-FF-000020', NULL, 'Lytic murein transglycosylase', 58, NULL, NULL, 79996),
(79997, '2.60.120.200-FF-000254', NULL, 'MAM and LDL-receptor class A domain-containing protein 1', 159, NULL, NULL, 79997),
(79998, '1.10.287.540-FF-000008', NULL, '23S rRNA (guanine(2535)-N(1))-methyltransferase', 43, NULL, NULL, 79998),
(79999, '3.60.40.10-FF-000106', NULL, 'Uncharacterized protein, isoform A', 327, NULL, NULL, 79999),
(80000, '2.130.10.30-FF-000047', NULL, 'Regulator of chromosome condensation (RCC1) repeat', 210, NULL, NULL, 80000),
(80001, '3.40.50.2300-FF-000461', NULL, 'Histidine kinase', 130, NULL, NULL, 80001),
(80002, '1.10.238.10-FF-001208', NULL, 'Uncharacterized protein', 168, NULL, NULL, 80002),
(80003, '2.20.28.200-FF-000002', NULL, 'NAD-dependent deacetylase sirtuin-7', 53, NULL, NULL, 80003),
(80004, '3.30.420.10-FF-000007', NULL, 'Interferon-stimulated exonuclease gene 20', 175, NULL, NULL, 80004),
(80005, '3.20.20.140-FF-000211', NULL, 'dihydropyrimidinase-related protein 1-like', 232, NULL, NULL, 80005),
(80006, '3.40.50.410-FF-000119', NULL, 'Midasin', 201, NULL, NULL, 80006),
(80007, '1.20.140.150-FF-000096', NULL, 'Uncharacterized protein', 210, NULL, NULL, 80007),
(80008, '3.30.160.60-FF-004796', NULL, NULL, 31, NULL, NULL, 80008),
(80009, '2.60.120.260-FF-000648', NULL, 'Uncharacterized protein', 97, NULL, NULL, 80009),
(80010, '3.40.50.300-FF-003740', NULL, 'AAA family ATPase, putative', 125, NULL, NULL, 80010),
(80011, '1.50.40.10-FF-000212', NULL, 'Putative dicarboxylic acid transmembrane transporter', 287, NULL, NULL, 80011),
(80012, '3.30.710.10-FF-000125', NULL, 'Calicin', 129, NULL, NULL, 80012),
(80013, '3.40.50.300-FF-007354', NULL, 'AGAP012289-PA', 236, NULL, NULL, 80013),
(80014, '2.10.50.10-FF-000100', NULL, 'Zgc:163064 protein', 39, NULL, NULL, 80014),
(80015, '2.60.120.260-FF-000339', NULL, 'Glycosyltransferase-like protein LARGE1', 187, NULL, NULL, 80015),
(80016, '3.40.50.720-FF-002382', NULL, 'Gll3017 protein', 155, NULL, NULL, 80016),
(80017, '2.60.40.10-FF-001339', NULL, 'NPHS1, nephrin', 96, NULL, NULL, 80017),
(80018, '2.60.40.10-FF-003610', NULL, NULL, 104, NULL, NULL, 80018),
(80019, '1.20.1260.110-FF-000005', NULL, 'DNA integrity scanning protein DisA', 148, NULL, NULL, 80019),
(80020, '2.170.300.10-FF-000076', NULL, 'Uncharacterized protein', 122, NULL, NULL, 80020),
(80021, '3.40.50.300-FF-002588', NULL, 'ATPase, AAA family', 179, NULL, NULL, 80021),
(80022, '3.40.50.2000-FF-000343', NULL, 'Glycosyltransferase', 254, NULL, NULL, 80022);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(80023, '1.20.58.540-FF-000001', NULL, 'Botulinum neurotoxin type A', 103, NULL, NULL, 80023),
(80024, '1.10.510.10-FF-001151', NULL, 'Guanylate cyclase', 233, NULL, NULL, 80024),
(80025, '3.40.50.300-FF-000997', NULL, 'Multidrug resistance-associated protein 1', 262, NULL, NULL, 80025),
(80026, '3.20.20.80-FF-000419', NULL, 'Uncharacterized protein', 111, NULL, NULL, 80026),
(80027, '3.30.470.20-FF-000255', NULL, 'Uncharacterized protein', 198, NULL, NULL, 80027),
(80028, '1.20.1270.60-FF-000322', NULL, 'Uncharacterized protein', 112, NULL, NULL, 80028),
(80029, '3.30.70.1180-FF-000003', NULL, 'V-type proton ATPase subunit C', 33, NULL, NULL, 80029),
(80030, '3.40.390.10-FF-000182', NULL, NULL, 233, NULL, NULL, 80030),
(80031, '1.10.8.590-FF-000002', NULL, 'Putative tRNA/rRNA methyltransferase', 57, NULL, NULL, 80031),
(80032, '3.30.160.60-FF-002896', NULL, 'Zinc finger protein 260', 38, NULL, NULL, 80032),
(80033, '2.60.40.10-FF-005381', NULL, NULL, 57, NULL, NULL, 80033),
(80034, '3.40.50.300-FF-003329', NULL, 'Small GTPase EhRabX27, putative', 183, NULL, NULL, 80034),
(80035, '1.10.287.70-FF-000193', NULL, 'Uncharacterized protein, isoform A', 289, NULL, NULL, 80035),
(80036, '1.10.1060.10-FF-000002', NULL, 'Succinate dehydrogenase iron-sulfur subunit', 138, NULL, NULL, 80036),
(80037, '3.40.50.150-FF-001660', NULL, NULL, 189, NULL, NULL, 80037),
(80038, '1.20.120.1630-FF-000003', NULL, 'C-24(28) sterol reductase', 216, NULL, NULL, 80038),
(80039, '3.90.660.10-FF-000141', NULL, NULL, 162, NULL, NULL, 80039),
(80040, '1.25.10.10-FF-001404', NULL, 'Condensin complex subunit 1', 189, NULL, NULL, 80040),
(80041, '2.30.29.30-FF-000185', NULL, 'TBC1 domain family member 8B', 106, NULL, NULL, 80041),
(80042, '3.40.50.300-FF-008456', NULL, 'ATP-binding cassette, sub-family F, member 3', 253, NULL, NULL, 80042),
(80043, '1.10.10.60-FF-000626', NULL, 'Transcription factor LAF1-like', 48, NULL, NULL, 80043),
(80044, '3.30.450.20-FF-000501', NULL, 'Sensor histidine kinase, PAS, PAS, PAS and PAS domain-containing', 119, NULL, NULL, 80044),
(80045, '3.40.50.300-FF-001177', NULL, 'Plastid replication-repair enzyme', 257, NULL, NULL, 80045),
(80046, '1.10.510.10-FF-003612', NULL, NULL, 199, NULL, NULL, 80046),
(80047, '4.10.80.30-FF-000002', NULL, 'DNA polymerase', 44, NULL, NULL, 80047),
(80048, '3.30.60.190-FF-000007', NULL, 'Box C/D snoRNA', 47, NULL, NULL, 80048),
(80049, '3.40.630.10-FF-000364', NULL, 'Uncharacterized protein', 133, NULL, NULL, 80049),
(80050, '3.90.79.10-FF-000149', NULL, 'Adenine DNA glycosylase', 116, NULL, NULL, 80050),
(80051, '1.20.58.2140-FF-000002', NULL, 'Haloacid dehalogenase', 184, NULL, NULL, 80051),
(80052, '2.40.50.90-FF-000055', NULL, 'Tudor domain-containing protein 1', 73, NULL, NULL, 80052),
(80053, '3.30.710.10-FF-000434', NULL, 'Ankyrin repeat containing protein', 68, NULL, NULL, 80053),
(80054, '4.10.80.40-FF-000005', NULL, 'Succinate dehydrogenase flavoprotein subunit', 38, NULL, NULL, 80054),
(80055, '1.20.930.20-FF-000020', NULL, 'Predicted protein', 128, NULL, NULL, 80055),
(80056, '3.40.1110.10-FF-000200', NULL, 'Phospholipid-transporting ATPase', 129, NULL, NULL, 80056),
(80057, '3.30.160.100-FF-000019', NULL, 'Plastid-specific ribosomal protein 1', 103, NULL, NULL, 80057),
(80058, '2.30.30.140-FF-000203', NULL, 'Uncharacterized protein R102.4-like Protein', 45, NULL, NULL, 80058),
(80059, '3.90.70.200-FF-000027', NULL, 'Predicted protein', 135, NULL, NULL, 80059),
(80060, '1.10.10.440-FF-000011', NULL, 'pre-mRNA-processing factor 40 homolog A isoform X1', 73, NULL, NULL, 80060),
(80061, '1.20.1250.20-FF-000360', NULL, 'Solute carrier organic anion transporter family member', 353, NULL, NULL, 80061),
(80062, '3.30.160.60-FF-001126', NULL, 'zinc finger protein 684 isoform X2', 27, NULL, NULL, 80062),
(80063, '1.25.40.10-FF-002985', NULL, 'Pentatricopeptide repeat-containing protein', 144, NULL, NULL, 80063),
(80064, '1.10.510.10-FF-001460', NULL, 'CTD kinase subunit alpha', 239, NULL, NULL, 80064),
(80065, '3.40.50.300-FF-000688', NULL, 'ATP-binding cassette sub-family F member 3', 316, NULL, NULL, 80065);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(80066, '3.30.930.10-FF-000080', NULL, 'phenylalanine--tRNA ligase, chloroplastic/mitochondrial', 119, NULL, NULL, 80066),
(80067, '2.30.29.30-FF-000494', NULL, 'Probable pleckstrin homology domain-containing family N member 1', 110, NULL, NULL, 80067),
(80068, '3.40.640.10-FF-000499', NULL, 'Kynureninase', 184, NULL, NULL, 80068),
(80069, '3.40.50.20-FF-000026', NULL, 'D-alanine--D-alanine ligase', 113, NULL, NULL, 80069),
(80070, '3.30.70.330-FF-002165', NULL, NULL, 91, NULL, NULL, 80070),
(80071, '1.20.1090.10-FF-000024', NULL, 'Iron-containing alcohol dehydrogenase RfbM', 187, NULL, NULL, 80071),
(80072, '1.10.8.100-FF-000018', NULL, 'rRNA adenine N(6)-methyltransferase', 79, NULL, NULL, 80072),
(80073, '3.40.850.10-FF-000419', NULL, 'Uncharacterized protein', 210, NULL, NULL, 80073),
(80074, '2.60.40.10-FF-005072', NULL, NULL, 100, NULL, NULL, 80074),
(80075, '3.90.1310.10-FF-000007', NULL, 'Penicillin-binding protein 2', 198, NULL, NULL, 80075),
(80076, '2.60.220.50-FF-000153', NULL, 'Uncharacterized protein', 177, NULL, NULL, 80076),
(80077, '3.20.20.140-FF-000065', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 313, NULL, NULL, 80077),
(80078, '1.10.10.350-FF-000001', NULL, 'Glutamate--tRNA ligase', 109, NULL, NULL, 80078),
(80079, '3.60.15.10-FF-000273', NULL, 'Uncharacterized protein', 164, NULL, NULL, 80079),
(80080, '3.80.10.10-FF-000912', NULL, 'NLR family pyrin domain-containing 2', 169, NULL, NULL, 80080),
(80081, '3.20.20.150-FF-000068', NULL, 'Xylose isomerase domain protein TIM barrel', 261, NULL, NULL, 80081),
(80082, '3.30.428.10-FF-000019', NULL, 'Galactose-1-phosphate uridylyltransferase', 172, NULL, NULL, 80082),
(80083, '1.10.287.130-FF-000082', NULL, 'Sensor histidine kinase YvrG', 91, NULL, NULL, 80083),
(80084, '1.25.40.10-FF-004913', NULL, 'Pre-mRNA-splicing factor SYF1-like Protein', 72, NULL, NULL, 80084),
(80085, '3.90.70.10-FF-000629', NULL, 'Protein CBG24565', 125, NULL, NULL, 80085),
(80086, '1.25.10.10-FF-003304', NULL, 'Probable cytochrome c', 172, NULL, NULL, 80086),
(80087, '3.40.50.300-FF-005022', NULL, 'Uncharacterized protein', 144, NULL, NULL, 80087),
(80088, '3.40.50.1700-FF-000011', NULL, 'Exported beta-glucosidase', 106, NULL, NULL, 80088),
(80089, '1.20.1070.10-FF-000141', NULL, 'atypical chemokine receptor 3', 301, NULL, NULL, 80089),
(80090, '1.20.144.10-FF-000095', NULL, 'Uncharacterized protein', 266, NULL, NULL, 80090),
(80091, '3.40.50.300-FF-006539', NULL, 'ADP ribosylation factor like GTPase 13B', 108, NULL, NULL, 80091),
(80092, '3.50.50.60-FF-000566', NULL, 'Paromamine 6''-oxidase', 146, NULL, NULL, 80092),
(80093, '1.10.287.10-FF-000001', NULL, 'Non-structural protein 1', 76, NULL, NULL, 80093),
(80094, '1.10.340.70-FF-000025', NULL, 'Transposon Ty3-G Gag-Pol polyprotein', 88, NULL, NULL, 80094),
(80095, '3.30.70.330-FF-002283', NULL, NULL, 97, NULL, NULL, 80095),
(80096, '1.20.58.60-FF-000494', NULL, 'AGAP004440-PA', 109, NULL, NULL, 80096),
(80097, '1.10.3660.10-FF-000014', NULL, 'Chorismate mutase/prephenate dehydrogenase', 117, NULL, NULL, 80097),
(80098, '2.60.40.10-FF-001373', NULL, 'Immunoglobulin superfamily member 10', 98, NULL, NULL, 80098),
(80099, '3.40.50.720-FF-002348', NULL, 'Oxidoreductase domain protein', 109, NULL, NULL, 80099),
(80100, '3.30.70.330-FF-002182', NULL, NULL, 75, NULL, NULL, 80100),
(80101, '2.120.10.30-FF-000464', NULL, 'Uncharacterized protein', 78, NULL, NULL, 80101),
(80102, '3.20.20.100-FF-000115', NULL, 'Uncharacterized protein', 258, NULL, NULL, 80102),
(80103, '3.80.10.10-FF-003993', NULL, 'Protein CBR-HAF-3', 155, NULL, NULL, 80103),
(80104, '3.30.70.330-FF-000574', NULL, 'HIV Tat-specific factor 1', 85, NULL, NULL, 80104),
(80105, '1.20.1070.10-FF-001759', NULL, 'Predicted protein', 73, NULL, NULL, 80105),
(80106, '2.20.70.10-FF-000253', NULL, 'Membrane associated guanylate kinase, WW and PDZ domain containing 3', 48, NULL, NULL, 80106),
(80107, '3.40.50.300-FF-005538', NULL, 'Uncharacterized protein', 62, NULL, NULL, 80107),
(80108, '3.30.40.10-FF-002311', NULL, 'Predicted protein', 109, NULL, NULL, 80108);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(80109, '3.90.1300.10-FF-000035', NULL, 'Uncharacterized protein', 327, NULL, NULL, 80109),
(80110, '1.10.10.10-FF-001106', NULL, 'MarR family transcriptional regulator', 134, NULL, NULL, 80110),
(80111, '3.30.710.10-FF-000451', NULL, 'Cytokinesis defective protein 7', 142, NULL, NULL, 80111),
(80112, '2.10.10.20-FF-000011', NULL, 'Chitinase', 61, NULL, NULL, 80112),
(80113, '3.40.50.620-FF-000109', NULL, 'Methionine--tRNA ligase', 218, NULL, NULL, 80113),
(80114, '3.90.190.10-FF-000604', NULL, 'Protein tyrosine phosphatase, receptor type S', 170, NULL, NULL, 80114),
(80115, '1.10.510.10-FF-001342', NULL, 'Uncharacterized protein', 255, NULL, NULL, 80115),
(80116, '2.60.120.200-FF-000119', NULL, 'Laminin subunit alpha 1', 160, NULL, NULL, 80116),
(80117, '1.10.510.10-FF-001813', NULL, 'Wall-associated serine/threonine kinase-like', 107, NULL, NULL, 80117),
(80118, '3.55.40.20-FF-000026', NULL, 'Uncharacterized protein', 87, NULL, NULL, 80118),
(80119, '3.40.50.300-FF-002796', NULL, 'Protein translocase subunit SecA', 117, NULL, NULL, 80119),
(80120, '3.30.1240.10-FF-000010', NULL, '5-amino-6-(5-phospho-D-ribitylamino)uracil phosphatase YbjI', 107, NULL, NULL, 80120),
(80121, '3.40.50.2300-FF-000135', NULL, 'Guanylate cyclase', 58, NULL, NULL, 80121),
(80122, '3.40.50.1000-FF-000852', NULL, NULL, 59, NULL, NULL, 80122),
(80123, '3.30.40.10-FF-000703', NULL, 'ERAD-associated E3 ubiquitin-protein ligase HRD1, putative', 68, NULL, NULL, 80123),
(80124, '2.40.70.10-FF-000179', NULL, 'ASpartyl Protease', 174, NULL, NULL, 80124),
(80125, '3.40.30.10-FF-000899', NULL, 'Protein disulfide-isomerase', 108, NULL, NULL, 80125),
(80126, '1.10.287.770-FF-000009', NULL, 'NKG2-C type II integral membrane protein', 33, NULL, NULL, 80126),
(80127, '2.70.160.11-FF-000062', NULL, 'Ribosomal protein L11 methyltransferase (PrmA)', 189, NULL, NULL, 80127),
(80128, '3.10.129.10-FF-000060', NULL, 'Os07g0463500 protein', 125, NULL, NULL, 80128),
(80129, '1.20.58.60-FF-000505', NULL, 'Uncharacterized protein', 102, NULL, NULL, 80129),
(80130, '3.30.50.10-FF-000086', NULL, 'Nuclear Hormone Receptor family', 109, NULL, NULL, 80130),
(80131, '1.50.40.10-FF-000004', NULL, 'Calcium-binding mitochondrial carrier protein Aralar1', 285, NULL, NULL, 80131),
(80132, '1.10.246.90-FF-000014', NULL, 'Putative nucleolar protein 5-1', 41, NULL, NULL, 80132),
(80133, '1.25.40.10-FF-002659', NULL, 'Uncharacterized protein', 195, NULL, NULL, 80133),
(80134, '3.90.1280.20-FF-000001', NULL, 'Chloride channel protein', 92, NULL, NULL, 80134),
(80135, '3.40.50.150-FF-001452', NULL, NULL, 140, NULL, NULL, 80135),
(80136, '1.10.8.60-FF-000501', NULL, 'Uncharacterized protein', 76, NULL, NULL, 80136),
(80137, '3.80.10.10-FF-002565', NULL, 'Adhesion G protein-coupled receptor A2', 129, NULL, NULL, 80137),
(80138, '2.60.40.10-FF-005173', NULL, NULL, 140, NULL, NULL, 80138),
(80139, '1.25.10.20-FF-000013', NULL, 'Uncharacterized protein', 343, NULL, NULL, 80139),
(80140, '2.170.140.10-FF-000007', NULL, 'Acidic mammalian chitinase', 68, NULL, NULL, 80140),
(80141, '3.30.160.60-FF-003060', NULL, 'Zinc finger protein, putative', 30, NULL, NULL, 80141),
(80142, '3.30.470.20-FF-000047', NULL, 'Inositol-tetrakisphosphate 1-kinase 4', 208, NULL, NULL, 80142),
(80143, '3.20.140.10-FF-000033', NULL, 'Nicotinate phosphoribosyltransferase', 279, NULL, NULL, 80143),
(80144, '3.30.470.10-FF-000044', NULL, 'Branched-chain-amino-acid aminotransferase', 176, NULL, NULL, 80144),
(80145, '3.40.50.300-FF-003313', NULL, 'Uncharacterized protein', 203, NULL, NULL, 80145),
(80146, '1.25.40.10-FF-004812', NULL, 'Uncharacterized protein', 158, NULL, NULL, 80146),
(80147, '1.20.1280.290-FF-000097', NULL, 'Uncharacterized protein', 70, NULL, NULL, 80147),
(80148, '3.30.460.10-FF-000116', NULL, 'Poly(A) polymerase', 126, NULL, NULL, 80148),
(80149, '3.40.366.10-FF-000075', NULL, 'Uncharacterized protein', 212, NULL, NULL, 80149),
(80150, '1.20.58.390-FF-000012', NULL, 'Acetylcholine receptor subunit alpha-like', 112, NULL, NULL, 80150),
(80151, '3.40.250.10-FF-000233', NULL, 'Sulfurtransferase', 130, NULL, NULL, 80151);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(80152, '3.30.160.60-FF-001822', NULL, 'Zinc finger protein 648', 28, NULL, NULL, 80152),
(80153, '1.10.287.470-FF-000026', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 66, NULL, NULL, 80153),
(80154, '1.10.166.10-FF-000001', NULL, '2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-succinyltransferase', 70, NULL, NULL, 80154),
(80155, '3.40.50.150-FF-001188', NULL, NULL, 200, NULL, NULL, 80155),
(80156, '1.10.12.10-FF-000003', NULL, '1,4-dihydroxy-2-naphthoyl-CoA synthase', 50, NULL, NULL, 80156),
(80157, '3.90.190.10-FF-000503', NULL, 'Predicted protein', 145, NULL, NULL, 80157),
(80158, '3.30.420.40-FF-000814', NULL, 'SWI/SNF and RSC complexes subunit arp9', 104, NULL, NULL, 80158),
(80159, '3.30.497.10-FF-000078', NULL, 'Serpin 100A', 131, NULL, NULL, 80159),
(80160, '4.10.1060.10-FF-000022', NULL, 'Cabeza, isoform D', 37, NULL, NULL, 80160),
(80161, '3.40.50.720-FF-000903', NULL, 'UDP-N-acetylmuramoylalanine--D-glutamate ligase', 91, NULL, NULL, 80161),
(80162, '3.40.1380.20-FF-000003', NULL, 'Pyruvate kinase', 131, NULL, NULL, 80162),
(80163, '3.30.465.10-FF-000004', NULL, 'Xanthine dehydrogenase/oxidase', 128, NULL, NULL, 80163),
(80164, '2.130.10.10-FF-002880', NULL, 'UTP15, small subunit processome component', 134, NULL, NULL, 80164),
(80165, '3.40.1350.100-FF-000006', NULL, 'Protein TIC 22-like chloroplastic', 92, NULL, NULL, 80165),
(80166, '1.10.630.10-FF-000024', NULL, 'Allene oxide synthase, chloroplastic', 467, NULL, NULL, 80166),
(80167, '1.10.10.60-FF-000497', NULL, 'Uncharacterized protein, isoform B', 83, NULL, NULL, 80167),
(80168, '1.25.10.10-FF-003192', NULL, 'Protein ARABIDILLO 1', 303, NULL, NULL, 80168),
(80169, '2.130.10.10-FF-001025', NULL, 'WD repeat protein', 295, NULL, NULL, 80169),
(80170, '1.10.10.60-FF-001014', NULL, NULL, 29, NULL, NULL, 80170),
(80171, '3.40.50.80-FF-000084', NULL, 'Oxidoreductase-like protein', 155, NULL, NULL, 80171),
(80172, '1.10.1520.10-FF-000037', NULL, 'Uncharacterized protein', 188, NULL, NULL, 80172),
(80173, '2.70.150.10-FF-000268', NULL, 'Plasma membrane ATPase', 59, NULL, NULL, 80173),
(80174, '3.40.850.10-FF-000083', NULL, 'Kinesin-like protein', 392, NULL, NULL, 80174),
(80175, '1.10.10.10-FF-000959', NULL, 'RNA polymerase sigma factor', 74, NULL, NULL, 80175),
(80176, '2.60.40.10-FF-000867', NULL, 'Titin a', 103, NULL, NULL, 80176),
(80177, '3.30.40.10-FF-001586', NULL, 'E3 ubiquitin-protein ligase RING1', 85, NULL, NULL, 80177),
(80178, '3.50.30.30-FF-000022', NULL, 'RING finger protein 215', 120, NULL, NULL, 80178),
(80179, '2.130.10.10-FF-002969', NULL, 'Inner dynein arm I1 intermediate chain IC140', 222, NULL, NULL, 80179),
(80180, '1.20.1250.10-FF-000014', NULL, 'Interleukin-4', 124, NULL, NULL, 80180),
(80181, '1.10.630.10-FF-000451', NULL, 'Uncharacterized protein', 343, NULL, NULL, 80181),
(80182, '2.130.10.10-FF-001452', NULL, 'Uncharacterized protein', 219, NULL, NULL, 80182),
(80183, '3.40.1280.10-FF-000049', NULL, 'Ribosomal RNA small subunit methyltransferase E', 226, NULL, NULL, 80183),
(80184, '3.30.40.10-FF-000158', NULL, 'Lysine (K)-specific demethylase 5A', 65, NULL, NULL, 80184),
(80185, '2.70.170.10-FF-000168', NULL, 'Protein CBR-ACR-8', 89, NULL, NULL, 80185),
(80186, '3.30.450.20-FF-000147', NULL, 'Antitoxin of toxin-antitoxin system', 96, NULL, NULL, 80186),
(80187, '2.40.50.730-FF-000017', NULL, 'DNA polymerase', 70, NULL, NULL, 80187),
(80188, '3.90.640.10-FF-000241', NULL, 'Predicted protein', 114, NULL, NULL, 80188),
(80189, '1.10.510.10-FF-001134', NULL, 'Uncharacterized protein', 314, NULL, NULL, 80189),
(80190, '3.20.20.70-FF-000001', NULL, 'Pyridoxine biosynthesis protein PDX1', 293, NULL, NULL, 80190),
(80191, '1.10.510.10-FF-003258', NULL, NULL, 111, NULL, NULL, 80191),
(80192, '1.20.1250.20-FF-000017', NULL, 'Dipeptide and tripeptide permease A', 481, NULL, NULL, 80192),
(80193, '3.30.230.10-FF-000195', NULL, 'Mevalonate kinase', 156, NULL, NULL, 80193),
(80194, '3.30.230.10-FF-000307', NULL, 'Uncharacterized protein', 120, NULL, NULL, 80194),
(80195, '2.60.40.60-FF-001129', NULL, 'Uncharacterized protein', 99, NULL, NULL, 80195);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(80196, '1.20.1070.10-FF-002057', NULL, 'Uncharacterized protein', 93, NULL, NULL, 80196),
(80197, '1.25.40.10-FF-003132', NULL, 'Uncharacterized protein', 142, NULL, NULL, 80197),
(80198, '3.30.70.270-FF-000095', NULL, 'Bifunctional diguanylate cyclase/phosphodiesterase', 170, NULL, NULL, 80198),
(80199, '3.30.230.70-FF-000174', NULL, 'Exosome component 6', 71, NULL, NULL, 80199),
(80200, '2.60.40.1510-FF-000057', NULL, 'Integrin, beta 5', 53, NULL, NULL, 80200),
(80201, '1.25.10.10-FF-000932', NULL, 'Nipped-B protein', 336, NULL, NULL, 80201),
(80202, '1.10.150.910-FF-000002', NULL, 'Splicing factor 3B subunit 3', 81, NULL, NULL, 80202),
(80203, '3.30.160.60-FF-003161', NULL, NULL, 26, NULL, NULL, 80203),
(80204, '2.130.10.10-FF-004914', NULL, 'Uncharacterized protein', 110, NULL, NULL, 80204),
(80205, '2.60.34.10-FF-000128', NULL, 'Uncharacterized protein', 114, NULL, NULL, 80205),
(80206, '3.40.1410.10-FF-000021', NULL, 'Phosphonate metabolism transcriptional regulator PhnF', 154, NULL, NULL, 80206),
(80207, '3.20.20.80-FF-000004', NULL, 'Beta-glucosidase 6-phospho-beta-glucosidase', 456, NULL, NULL, 80207),
(80208, '1.20.1560.10-FF-000532', NULL, 'Related to multidrug resistance protein', 22, NULL, NULL, 80208),
(80209, '1.10.3370.10-FF-000003', NULL, 'Preprotein translocase subunit SECY, chloroplastic', 406, NULL, NULL, 80209),
(80210, '2.60.40.150-FF-000449', NULL, 'Synaptotagmin, putative', 129, NULL, NULL, 80210),
(80211, '3.50.50.60-FF-000358', NULL, 'Irc15p', 137, NULL, NULL, 80211),
(80212, '1.10.418.10-FF-000273', NULL, 'Uncharacterized protein', 80, NULL, NULL, 80212),
(80213, '3.30.40.10-FF-001895', NULL, 'Uncharacterized protein', 74, NULL, NULL, 80213),
(80214, '1.25.40.10-FF-000198', NULL, 'E3 ubiquitin-protein ligase CHIP isoform X2', 120, NULL, NULL, 80214),
(80215, '1.25.10.10-FF-002478', NULL, 'Uncharacterized protein', 213, NULL, NULL, 80215),
(80216, '3.30.960.10-FF-000008', NULL, 'Uncharacterized protein', 103, NULL, NULL, 80216),
(80217, '3.80.10.10-FF-003785', NULL, 'Uncharacterized protein', 99, NULL, NULL, 80217),
(80218, '3.10.129.10-FF-000161', NULL, 'Acyl-CoA thioesterase FadM', 138, NULL, NULL, 80218),
(80219, '1.10.565.10-FF-000102', NULL, 'Nuclear receptor subfamily 5, group A, member 1b', 245, NULL, NULL, 80219),
(80220, '1.20.1070.10-FF-000921', NULL, 'Predicted protein', 150, NULL, NULL, 80220),
(80221, '1.10.150.20-FF-000209', NULL, 'DNA ligase', 84, NULL, NULL, 80221),
(80222, '4.10.110.20-FF-000004', NULL, 'Variant surface glycoprotein (VSG, atypical), putative', 89, NULL, NULL, 80222),
(80223, '1.25.40.10-FF-000861', NULL, 'BnaA05g13750D protein', 95, NULL, NULL, 80223),
(80224, '3.80.10.10-FF-000132', NULL, 'Leiomodin 2', 179, NULL, NULL, 80224),
(80225, '1.10.8.100-FF-000035', NULL, 'rRNA adenine N(6)-methyltransferase', 30, NULL, NULL, 80225),
(80226, '1.25.40.10-FF-002968', NULL, 'Uncharacterized protein', 174, NULL, NULL, 80226),
(80227, '3.40.309.10-FF-000117', NULL, 'Uncharacterized protein', 21, NULL, NULL, 80227),
(80228, '2.40.50.140-FF-000907', NULL, NULL, 49, NULL, NULL, 80228),
(80229, '1.20.120.1080-FF-000102', NULL, 'Uncharacterized protein', 162, NULL, NULL, 80229),
(80230, '3.30.200.60-FF-000017', NULL, 'Os08g0537800 protein', 62, NULL, NULL, 80230),
(80231, '3.30.710.10-FF-000081', NULL, 'zinc finger and BTB domain-containing protein 38', 133, NULL, NULL, 80231),
(80232, '3.30.160.60-FF-001570', NULL, 'zinc finger protein 566 isoform X1', 29, NULL, NULL, 80232),
(80233, '3.40.1800.20-FF-000031', NULL, NULL, 73, NULL, NULL, 80233),
(80234, '3.40.50.720-FF-002247', NULL, 'Dihydropteridine reductase, putative', 78, NULL, NULL, 80234),
(80235, '1.10.2000.10-FF-000043', NULL, NULL, 129, NULL, NULL, 80235),
(80236, '3.100.10.10-FF-000067', NULL, NULL, 124, NULL, NULL, 80236),
(80237, '3.30.160.190-FF-000006', NULL, 'NADH dehydrogenase [ubiquinone] iron-sulfur protein 4, mitochondrial', 39, NULL, NULL, 80237),
(80238, '3.80.10.10-FF-000441', NULL, 'Platelet glycoprotein Ib beta chain', 123, NULL, NULL, 80238),
(80239, '3.40.50.300-FF-003105', NULL, 'Uncharacterized protein', 185, NULL, NULL, 80239);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(80240, '3.40.605.10-FF-000120', NULL, 'Uncharacterized protein', 240, NULL, NULL, 80240),
(80241, '3.30.200.40-FF-000011', NULL, 'Uncharacterized protein', 127, NULL, NULL, 80241),
(80242, '3.80.10.10-FF-000811', NULL, 'Si:ch211-196h24.1', 171, NULL, NULL, 80242),
(80243, '3.50.50.60-FF-000257', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 154, NULL, NULL, 80243),
(80244, '1.10.287.1700-FF-000003', NULL, 'Trichohyalin', 168, NULL, NULL, 80244),
(80245, '2.120.10.80-FF-000254', NULL, 'Kel1p', 218, NULL, NULL, 80245),
(80246, '3.30.40.10-FF-000366', NULL, 'E3 ubiquitin-protein ligase ATL4', 75, NULL, NULL, 80246),
(80247, '3.40.50.1820-FF-000417', NULL, 'Epoxide hydrolase B', 355, NULL, NULL, 80247),
(80248, '3.40.50.300-FF-006966', NULL, 'Predicted protein', 220, NULL, NULL, 80248),
(80249, '1.10.150.20-FF-000198', NULL, 'DNA polymerase nu', 39, NULL, NULL, 80249),
(80250, '2.170.120.12-FF-000008', NULL, 'DNA-directed RNA polymerase II subunit RPB3', 128, NULL, NULL, 80250),
(80251, '3.40.50.150-FF-000946', NULL, NULL, 92, NULL, NULL, 80251),
(80252, '2.60.120.20-FF-000029', NULL, NULL, 219, NULL, NULL, 80252),
(80253, '2.60.40.10-FF-004667', NULL, NULL, 98, NULL, NULL, 80253),
(80254, '3.30.70.270-FF-000196', NULL, NULL, 166, NULL, NULL, 80254),
(80255, '2.30.29.30-FF-000522', NULL, 'GTPase-activating protein pac-1', 116, NULL, NULL, 80255),
(80256, '1.20.140.150-FF-000079', NULL, 'Amastin surface glycoprotein', 176, NULL, NULL, 80256),
(80257, '3.40.350.10-FF-000090', NULL, 'Aminopeptidase, putative', 128, NULL, NULL, 80257),
(80258, '3.40.30.10-FF-001096', NULL, 'Phospholipase A2', 79, NULL, NULL, 80258),
(80259, '2.60.200.40-FF-000042', NULL, 'Diacylglycerol kinase', 76, NULL, NULL, 80259),
(80260, '1.20.1260.10-FF-000048', NULL, 'Ferritin', 182, NULL, NULL, 80260),
(80261, '3.30.2050.10-FF-000001', NULL, 'Oxygen-evolving enhancer protein 1, chloroplastic', 39, NULL, NULL, 80261),
(80262, '3.60.140.10-FF-000018', NULL, 'laccase domain-containing protein 1-like', 118, NULL, NULL, 80262),
(80263, '3.30.465.10-FF-000105', NULL, 'Glycolate oxidase glcE subunit. (GlcE)', 209, NULL, NULL, 80263),
(80264, '3.30.160.60-FF-004695', NULL, NULL, 28, NULL, NULL, 80264),
(80265, '1.10.300.10-FF-000005', NULL, 'Adenylosuccinate synthetase', 125, NULL, NULL, 80265),
(80266, '1.10.1200.80-FF-000006', NULL, 'tRNA-dihydrouridine synthase', 70, NULL, NULL, 80266),
(80267, '1.20.1720.10-FF-000067', NULL, 'Major facilitator superfamily MFS_1', 207, NULL, NULL, 80267),
(80268, '3.60.40.10-FF-000123', NULL, 'Protein phosphatase 2C homolog 7, mitochondrial', 236, NULL, NULL, 80268),
(80269, '3.30.70.270-FF-000207', NULL, NULL, 170, NULL, NULL, 80269),
(80270, '3.30.40.10-FF-000057', NULL, '1-phosphatidylinositol 3-phosphate 5-kinase isoform X1', 80, NULL, NULL, 80270),
(80271, '3.90.550.10-FF-000588', NULL, 'Uncharacterized protein', 237, NULL, NULL, 80271),
(80272, '3.30.160.60-FF-005622', NULL, NULL, 81, NULL, NULL, 80272),
(80273, '1.10.287.70-FF-000119', NULL, 'Potassium channel subfamily K member', 270, NULL, NULL, 80273),
(80274, '3.40.850.10-FF-000554', NULL, 'Uncharacterized protein', 134, NULL, NULL, 80274),
(80275, '3.40.50.300-FF-003414', NULL, 'Armitage, isoform C', 168, NULL, NULL, 80275),
(80276, '1.10.1170.10-FF-000038', NULL, 'Uncharacterized protein', 56, NULL, NULL, 80276),
(80277, '3.40.50.300-FF-006848', NULL, 'Uncharacterized MCM-type protein MJECL13', 337, NULL, NULL, 80277),
(80278, '3.30.420.10-FF-000541', NULL, NULL, 81, NULL, NULL, 80278),
(80279, '4.10.1000.10-FF-000046', NULL, 'Pre-mRNA-splicing factor CWC24', 33, NULL, NULL, 80279),
(80280, '2.60.120.230-FF-000004', NULL, NULL, 145, NULL, NULL, 80280),
(80281, '3.30.70.330-FF-002389', NULL, NULL, 97, NULL, NULL, 80281),
(80282, '2.60.40.150-FF-000657', NULL, 'Uncharacterized protein', 100, NULL, NULL, 80282),
(80283, '2.60.40.10-FF-003582', NULL, NULL, 75, NULL, NULL, 80283),
(80284, '3.40.50.620-FF-000519', NULL, 'Valine--tRNA ligase-like Protein', 229, NULL, NULL, 80284),
(80285, '3.40.50.300-FF-008557', NULL, 'Uncharacterized protein', 122, NULL, NULL, 80285);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(80286, '3.30.200.20-FF-002388', NULL, 'Uncharacterized protein', 138, NULL, NULL, 80286),
(80287, '2.60.98.20-FF-000008', NULL, 'Flagellar hook protein FlgE', 137, NULL, NULL, 80287),
(80288, '3.40.50.10490-FF-000016', NULL, 'Glucose-6-phosphate isomerase', 179, NULL, NULL, 80288),
(80289, '1.20.1250.20-FF-000225', NULL, 'Solute carrier family 19 member 1', 423, NULL, NULL, 80289),
(80290, '3.40.190.10-FF-000099', NULL, 'DNA-binding transcriptional regulator DsdC', 87, NULL, NULL, 80290),
(80291, '3.40.50.720-FF-000139', NULL, 'UDP-N-acetyl-D-mannosamine dehydrogenase', 202, NULL, NULL, 80291),
(80292, '1.10.1390.10-FF-000004', NULL, 'Glucose-6-phosphate isomerase', 44, NULL, NULL, 80292),
(80293, '3.40.50.2300-FF-000197', NULL, 'Branched-chain amino acid ABC transporter, substrate-binding protein', 205, NULL, NULL, 80293),
(80294, '1.25.40.10-FF-000760', NULL, 'Pentatricopeptide repeat-containing protein At5g27460', 189, NULL, NULL, 80294),
(80295, '3.40.1120.10-FF-000010', NULL, NULL, 67, NULL, NULL, 80295),
(80296, '3.40.50.720-FF-000095', NULL, 'NADP-dependent malic enzyme', 283, NULL, NULL, 80296),
(80297, '1.25.40.20-FF-001027', NULL, 'Putative ankyrin repeat protein', 51, NULL, NULL, 80297),
(80298, '2.60.98.10-FF-000005', NULL, 'Envelope glycoprotein', 137, NULL, NULL, 80298),
(80299, '3.60.60.10-FF-000023', NULL, 'Uncharacterized protein', 242, NULL, NULL, 80299),
(80300, '3.40.50.10480-FF-000013', NULL, 'Uncharacterized protein', 171, NULL, NULL, 80300),
(80301, '1.25.40.10-FF-001024', NULL, 'Hypothetical alanine rich protein', 253, NULL, NULL, 80301),
(80302, '3.30.160.60-FF-001227', NULL, 'Zinc finger and BTB domain containing 41', 31, NULL, NULL, 80302),
(80303, '2.130.10.10-FF-005033', NULL, 'Uncharacterized protein', 301, NULL, NULL, 80303),
(80304, '1.20.5.1160-FF-000017', NULL, 'SYNM isoform 4', 105, NULL, NULL, 80304),
(80305, '3.30.40.10-FF-000821', NULL, 'Ubiquitinyl hydrolase 1', 118, NULL, NULL, 80305),
(80306, '3.40.1620.60-FF-000012', NULL, 'Stall, isoform C', 69, NULL, NULL, 80306),
(80307, '3.30.40.10-FF-000467', NULL, 'C-terminal zinc-finger', 68, NULL, NULL, 80307),
(80308, '3.90.190.10-FF-000150', NULL, 'Uncharacterized protein', 148, NULL, NULL, 80308),
(80309, '2.30.230.10-FF-000036', NULL, 'Uncharacterized protein', 177, NULL, NULL, 80309),
(80310, '1.20.1560.10-FF-000324', NULL, 'ATP-binding cassette protein subfamily D, member 1', 308, NULL, NULL, 80310),
(80311, '3.30.565.10-FF-000377', NULL, 'Sensor histidine kinase, GAF domain-containing', 154, NULL, NULL, 80311),
(80312, '2.130.10.10-FF-003133', NULL, 'Uncharacterized protein', 75, NULL, NULL, 80312),
(80313, '2.10.110.10-FF-000195', NULL, 'Paxillin homolog 1', 60, NULL, NULL, 80313),
(80314, '1.20.900.10-FF-000043', NULL, 'ALS2 C-terminal like', 208, NULL, NULL, 80314),
(80315, '1.10.418.40-FF-000023', NULL, 'Beclin homolog', 70, NULL, NULL, 80315),
(80316, '3.90.1150.10-FF-000118', NULL, 'Serine decarboxylase', 89, NULL, NULL, 80316),
(80317, '1.10.2000.10-FF-000009', NULL, 'Muscle, skeletal, receptor tyrosine kinase', 141, NULL, NULL, 80317),
(80318, '3.30.70.3490-FF-000062', NULL, NULL, 122, NULL, NULL, 80318),
(80319, '3.30.160.60-FF-002907', NULL, NULL, 28, NULL, NULL, 80319),
(80320, '3.30.70.330-FF-000692', NULL, 'RNA binding motif protein 3', 85, NULL, NULL, 80320),
(80321, '1.10.510.10-FF-002786', NULL, NULL, 203, NULL, NULL, 80321),
(80322, '3.80.10.10-FF-004302', NULL, 'Uncharacterized protein', 220, NULL, NULL, 80322),
(80323, '1.20.1250.20-FF-002125', NULL, 'Uncharacterized protein', 216, NULL, NULL, 80323),
(80324, '3.40.50.11500-FF-000027', NULL, NULL, 72, NULL, NULL, 80324),
(80325, '3.40.50.300-FF-006657', NULL, 'Predicted protein', 86, NULL, NULL, 80325),
(80326, '3.30.450.60-FF-000035', NULL, 'Signal recognition particle (SRP) subunit', 158, NULL, NULL, 80326),
(80327, '3.10.20.90-FF-001019', NULL, 'Uncharacterized protein', 109, NULL, NULL, 80327),
(80328, '3.30.420.240-FF-000003', NULL, 'Terminase, large subunit, putative', 175, NULL, NULL, 80328),
(80329, '1.10.10.750-FF-000014', NULL, 'Growth hormone-regulated TBC protein 1', 44, NULL, NULL, 80329);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(80330, '3.90.1150.10-FF-000461', NULL, 'Aminotransferase, class I', 122, NULL, NULL, 80330),
(80331, '3.40.50.410-FF-000018', NULL, 'Matrilin 1', 192, NULL, NULL, 80331),
(80332, '3.40.50.720-FF-002039', NULL, 'Uncharacterized protein', 185, NULL, NULL, 80332),
(80333, '1.10.490.10-FF-000035', NULL, 'Uncharacterized protein', 138, NULL, NULL, 80333),
(80334, '3.10.350.10-FF-000006', NULL, 'YgeR family lipoprotein', 41, NULL, NULL, 80334),
(80335, '3.90.226.10-FF-000099', NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', 388, NULL, NULL, 80335),
(80336, '3.40.50.1820-FF-000047', NULL, 'protein NDRG3 isoform X8', 294, NULL, NULL, 80336),
(80337, '3.30.300.30-FF-000072', NULL, 'Nonribosomal peptide synthase SidD', 131, NULL, NULL, 80337),
(80338, '3.90.1150.10-FF-000219', NULL, 'Ornithine aminotransferase', 47, NULL, NULL, 80338),
(80339, '3.90.1520.10-FF-000017', NULL, 'Predicted protein', 190, NULL, NULL, 80339),
(80340, '1.10.760.10-FF-000028', NULL, 'Cytochrome c-550 PedF', 99, NULL, NULL, 80340),
(80341, '3.30.200.20-FF-001505', NULL, 'Calcium-dependent protein kinase 2', 51, NULL, NULL, 80341),
(80342, '1.10.10.10-FF-000752', NULL, 'IclR family transcriptional regulator', 75, NULL, NULL, 80342),
(80343, '3.80.20.20-FF-000079', NULL, 'Tyrosine-protein kinase receptor', 135, NULL, NULL, 80343),
(80344, '3.30.980.10-FF-000010', NULL, 'Alanine--tRNA ligase', 151, NULL, NULL, 80344),
(80345, '1.10.287.70-FF-000221', NULL, 'Potassium voltage-gated channel subfamily Q member 5', 49, NULL, NULL, 80345),
(80346, '2.130.10.10-FF-003234', NULL, 'Protein CFT1', 256, NULL, NULL, 80346),
(80347, '3.30.420.40-FF-000668', NULL, 'Uncharacterized protein', 67, NULL, NULL, 80347),
(80348, '3.40.50.12780-FF-000203', NULL, 'Uncharacterized protein', 331, NULL, NULL, 80348),
(80349, '3.30.70.2110-FF-000002', NULL, 'Penicillin-binding protein', 84, NULL, NULL, 80349),
(80350, '2.130.10.10-FF-001334', NULL, 'Restriction of telomere capping protein 1', 301, NULL, NULL, 80350),
(80351, '2.40.50.140-FF-000806', NULL, NULL, 142, NULL, NULL, 80351),
(80352, '1.10.287.70-FF-000075', NULL, 'Cytochrome c oxidase subunit 3', 72, NULL, NULL, 80352),
(80353, '3.90.930.12-FF-000035', NULL, NULL, 94, NULL, NULL, 80353),
(80354, '1.10.630.10-FF-000333', NULL, 'Uncharacterized protein', 212, NULL, NULL, 80354),
(80355, '3.40.50.2000-FF-000135', NULL, 'Glycosyltransferase', 265, NULL, NULL, 80355),
(80356, '3.50.30.30-FF-000140', NULL, 'Uncharacterized protein', 141, NULL, NULL, 80356),
(80357, '3.30.230.10-FF-000206', NULL, 'Archaeal serine protease', 213, NULL, NULL, 80357),
(80358, '3.30.750.24-FF-000096', NULL, 'Uncharacterized protein', 116, NULL, NULL, 80358),
(80359, '2.70.70.10-FF-000037', NULL, 'M23 peptidase domain protein', 131, NULL, NULL, 80359),
(80360, '3.80.10.10-FF-001885', NULL, 'Si:ch211-11p18.6', 221, NULL, NULL, 80360),
(80361, '3.50.50.60-FF-000919', NULL, 'NADPH-Fe(3+) oxidoreductase subunit beta', 68, NULL, NULL, 80361),
(80362, '3.40.30.10-FF-001208', NULL, 'Uncharacterized protein', 48, NULL, NULL, 80362),
(80363, '3.30.430.20-FF-000073', NULL, 'Uncharacterized protein', 59, NULL, NULL, 80363),
(80364, '3.30.565.10-FF-000478', NULL, 'Sensory transduction histidine kinase', 85, NULL, NULL, 80364),
(80365, '3.20.10.10-FF-000050', NULL, 'Aminotransferase', 161, NULL, NULL, 80365),
(80366, '2.60.120.20-FF-000030', NULL, 'RNA2 polyprotein', 374, NULL, NULL, 80366),
(80367, '3.80.10.10-FF-003684', NULL, 'Uncharacterized protein', 188, NULL, NULL, 80367),
(80368, '2.60.40.2170-FF-000007', NULL, 'Tyrosine-protein kinase RYK', 138, NULL, NULL, 80368),
(80369, '1.10.1080.10-FF-000003', NULL, 'Glutathione synthetase, isoform F', 47, NULL, NULL, 80369),
(80370, '1.10.510.10-FF-003404', NULL, NULL, 300, NULL, NULL, 80370),
(80371, '6.20.10.30-FF-000009', NULL, 'DNA ligase', 37, NULL, NULL, 80371),
(80372, '2.30.30.100-FF-000080', NULL, 'Small nuclear ribonucleoprotein Sm-F, putative', 74, NULL, NULL, 80372),
(80373, '3.40.50.150-FF-001761', NULL, NULL, 226, NULL, NULL, 80373),
(80374, '3.60.20.10-FF-000015', NULL, 'Proteasome subunit alpha type-5', 245, NULL, NULL, 80374);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(80375, '3.40.30.10-FF-000331', NULL, 'Glutathione S-transferase', 86, NULL, NULL, 80375),
(80376, '1.25.10.10-FF-002169', NULL, 'Uncharacterized protein', 491, NULL, NULL, 80376),
(80377, '3.40.850.10-FF-000453', NULL, 'Uncharacterized protein', 76, NULL, NULL, 80377),
(80378, '3.10.129.10-FF-000267', NULL, 'Uncharacterized protein', 160, NULL, NULL, 80378),
(80379, '1.20.1250.20-FF-000326', NULL, 'Solute carrier family 16 member 6', 193, NULL, NULL, 80379),
(80380, '3.90.640.10-FF-000050', NULL, 'Actin, cytoskeletal 3', 68, NULL, NULL, 80380),
(80381, '2.60.40.1400-FF-000024', NULL, NULL, 15, NULL, NULL, 80381),
(80382, '3.30.200.20-FF-000679', NULL, 'CMGC/MAPK protein kinase', 85, NULL, NULL, 80382),
(80383, '1.25.40.280-FF-000010', NULL, 'Programmed cell death 6-interacting protein, putative', 352, NULL, NULL, 80383),
(80384, '1.10.510.10-FF-000987', NULL, 'Receptor protein-tyrosine kinase', 207, NULL, NULL, 80384),
(80385, '2.60.40.2160-FF-000004', NULL, 'Interleukin 17 receptor A2', 170, NULL, NULL, 80385),
(80386, '1.20.1560.10-FF-000223', NULL, 'ATP-dependent bile acid transporter, variant', 346, NULL, NULL, 80386),
(80387, '1.10.10.10-FF-001224', NULL, 'Replication protein A, subunit RPA32', 68, NULL, NULL, 80387),
(80388, '3.40.50.300-FF-004858', NULL, 'Helicase, putative', 208, NULL, NULL, 80388),
(80389, '1.20.58.1880-FF-000025', NULL, 'REST corepressor 3', 127, NULL, NULL, 80389),
(80390, '3.30.160.20-FF-000080', NULL, '30s ribosomal protein s5', 66, NULL, NULL, 80390),
(80391, '3.80.10.10-FF-004038', NULL, 'Uncharacterized protein', 316, NULL, NULL, 80391),
(80392, '3.40.50.720-FF-001994', NULL, 'Uncharacterized protein', 237, NULL, NULL, 80392),
(80393, '1.25.40.10-FF-002558', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 212, NULL, NULL, 80393),
(80394, '3.40.50.2300-FF-000343', NULL, 'Uncharacterized protein', 284, NULL, NULL, 80394),
(80395, '1.20.1540.10-FF-000115', NULL, 'Uncharacterized rhomboid protein P4H10.10, mitochondrial', 202, NULL, NULL, 80395),
(80396, '1.10.10.1210-FF-000001', NULL, 'melanoma-associated antigen D1', 127, NULL, NULL, 80396),
(80397, '1.20.58.1040-FF-000009', NULL, 'Glucan endo-1,3-beta-glucosidase 1', 117, NULL, NULL, 80397),
(80398, '3.30.70.2850-FF-000010', NULL, 'DNA-directed RNA polymerase subunit', 242, NULL, NULL, 80398),
(80399, '3.30.450.20-FF-000181', NULL, 'Probable diguanylate cyclase DgcE', 66, NULL, NULL, 80399),
(80400, '3.30.160.60-FF-005830', NULL, NULL, 61, NULL, NULL, 80400),
(80401, '3.30.160.60-FF-003267', NULL, 'PR/SET domain 14', 62, NULL, NULL, 80401),
(80402, '2.30.42.10-FF-000154', NULL, 'T cell lymphoma invasion and metastasis 1', 92, NULL, NULL, 80402),
(80403, '1.20.58.1030-FF-000006', NULL, 'DNA replication complex GINS protein SLD5', 147, NULL, NULL, 80403),
(80404, '2.30.29.30-FF-000286', NULL, 'PH-protein kinase domain containing protein', 109, NULL, NULL, 80404),
(80405, '2.40.37.10-FF-000079', NULL, NULL, 112, NULL, NULL, 80405),
(80406, '3.30.780.10-FF-000045', NULL, 'Putative translation initiation factor SUI1', 80, NULL, NULL, 80406),
(80407, '3.30.1520.10-FF-000172', NULL, 'Non-specific serine/threonine protein kinase', 112, NULL, NULL, 80407),
(80408, '3.30.200.20-FF-000472', NULL, 'NIMA related kinase 4', 81, NULL, NULL, 80408),
(80409, '1.25.40.10-FF-004458', NULL, 'Uncharacterized protein', 242, NULL, NULL, 80409),
(80410, '1.10.238.10-FF-000837', NULL, 'Calcium uptake protein 1 homolog, mitochondrial', 139, NULL, NULL, 80410),
(80411, '1.20.950.20-FF-000004', NULL, 'Thiosulfate reductase cytochrome B subunit', 201, NULL, NULL, 80411),
(80412, '1.20.58.1020-FF-000003', NULL, 'DNA replication complex GINS protein PSF2, putative', 116, NULL, NULL, 80412),
(80413, '1.25.40.10-FF-001114', NULL, 'TPR repeat-containing protein associated with Hsp90', 111, NULL, NULL, 80413),
(80414, '3.40.50.10190-FF-000241', NULL, 'nibrin isoform X1', 111, NULL, NULL, 80414),
(80415, '3.40.50.720-FF-000550', NULL, 'AmphB polyketide synthase', 478, NULL, NULL, 80415),
(80416, '1.10.150.20-FF-000097', NULL, 'Meiotic recombinase Dmc1', 69, NULL, NULL, 80416);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(80417, '1.20.58.200-FF-000012', NULL, NULL, 83, NULL, NULL, 80417),
(80418, '3.30.450.40-FF-000187', NULL, 'GAF sensor signal transduction histidine kinase', 172, NULL, NULL, 80418),
(80419, '3.30.1370.50-FF-000008', NULL, 'Protein similar to JAG protein', 65, NULL, NULL, 80419),
(80420, '3.30.160.60-FF-005167', NULL, NULL, 26, NULL, NULL, 80420),
(80421, '2.60.40.10-FF-000968', NULL, 'MHC class II H2-M beta 2 chain', 115, NULL, NULL, 80421),
(80422, '3.80.10.10-FF-002150', NULL, 'Fasciated ear3', 316, NULL, NULL, 80422),
(80423, '2.40.128.130-FF-000001', NULL, 'Antigen 43 AG43', 337, NULL, NULL, 80423),
(80424, '2.60.40.60-FF-001023', NULL, 'Uncharacterized protein', 116, NULL, NULL, 80424),
(80425, '3.40.50.300-FF-001059', NULL, 'ATP-dependent RNA helicase DDX24', 242, NULL, NULL, 80425),
(80426, '3.30.70.330-FF-000944', NULL, 'Os04g0682400 protein', 84, NULL, NULL, 80426),
(80427, '3.40.50.720-FF-000241', NULL, 'ketimine reductase mu-crystallin', 162, NULL, NULL, 80427),
(80428, '3.50.50.60-FF-000712', NULL, 'Related to dimethylaniline monooxygenase', 276, NULL, NULL, 80428),
(80429, '1.20.1050.130-FF-000054', NULL, 'Uncharacterized protein', 154, NULL, NULL, 80429),
(80430, '1.20.58.860-FF-000007', NULL, 'Ubiquitin carboxyl-terminal hydrolase BAP1', 77, NULL, NULL, 80430),
(80431, '3.30.160.60-FF-005521', NULL, NULL, 26, NULL, NULL, 80431),
(80432, '4.10.400.10-FF-000203', NULL, 'Uncharacterized protein, isoform A', 53, NULL, NULL, 80432),
(80433, '3.60.40.10-FF-000224', NULL, 'Sll1365 protein', 253, NULL, NULL, 80433),
(80434, '2.10.230.10-FF-000012', NULL, 'Chaperone protein dnaJ 1, mitochondrial', 57, NULL, NULL, 80434),
(80435, '3.30.200.20-FF-000781', NULL, 'Protein CBG18552', 82, NULL, NULL, 80435),
(80436, '3.30.1680.30-FF-000003', NULL, 'Variant surface glycoprotein (VSG), putative', 43, NULL, NULL, 80436),
(80437, '1.10.3080.10-FF-000020', NULL, 'Chloride channel protein', 490, NULL, NULL, 80437),
(80438, '1.20.58.60-FF-000185', NULL, 'Dystonin', 191, NULL, NULL, 80438),
(80439, '2.40.10.10-FF-000658', NULL, NULL, 85, NULL, NULL, 80439),
(80440, '3.90.1170.10-FF-000018', NULL, 'Uncharacterized protein', 146, NULL, NULL, 80440),
(80441, '2.60.40.10-FF-002559', NULL, 'Titin homolog', 96, NULL, NULL, 80441),
(80442, '1.10.565.10-FF-000001', NULL, 'Retinoic acid receptor beta isoform', 242, NULL, NULL, 80442),
(80443, '3.90.930.40-FF-000002', NULL, 'Ribosomal oxygenase 2', 139, NULL, NULL, 80443),
(80444, '1.20.1070.10-FF-000820', NULL, 'C-C chemokine receptor type 10', 105, NULL, NULL, 80444),
(80445, '1.25.10.10-FF-001084', NULL, 'Putative APC1 protein', 207, NULL, NULL, 80445),
(80446, '2.40.50.140-FF-001060', NULL, NULL, 101, NULL, NULL, 80446),
(80447, '3.30.2350.10-FF-000029', NULL, 'TruB pseudouridine synthase family member 2', 245, NULL, NULL, 80447),
(80448, '1.10.150.50-FF-000050', NULL, 'SAM pointed domain containing ETS transcription factor', 91, NULL, NULL, 80448),
(80449, '1.25.40.20-FF-001336', NULL, 'Uncharacterized protein', 124, NULL, NULL, 80449),
(80450, '1.10.555.10-FF-000130', NULL, NULL, 47, NULL, NULL, 80450),
(80451, '1.10.510.10-FF-001033', NULL, 'Uncharacterized protein', 315, NULL, NULL, 80451),
(80452, '1.10.238.20-FF-000008', NULL, 'D7-related 4 protein', 145, NULL, NULL, 80452),
(80453, '2.20.100.10-FF-000006', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 1', 52, NULL, NULL, 80453),
(80454, '3.40.50.1000-FF-000498', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', 145, NULL, NULL, 80454),
(80455, '3.80.10.10-FF-004257', NULL, 'Uncharacterized protein', 67, NULL, NULL, 80455),
(80456, '1.25.40.10-FF-002867', NULL, 'Signal recognition particle subunit SRP72', 76, NULL, NULL, 80456),
(80457, '3.40.50.2300-FF-000652', NULL, 'DNA-binding response regulator', 85, NULL, NULL, 80457),
(80458, '3.80.10.10-FF-002357', NULL, 'Podocan-like protein 1', 167, NULL, NULL, 80458),
(80459, '3.30.450.20-FF-000490', NULL, 'Sensory transduction histidine kinase', 125, NULL, NULL, 80459),
(80460, '1.10.150.60-FF-000053', NULL, NULL, 56, NULL, NULL, 80460);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(80461, '3.30.310.80-FF-000008', NULL, 'Non-specific serine/threonine protein kinase', 113, NULL, NULL, 80461),
(80462, '3.30.1360.180-FF-000002', NULL, 'Alkaline-phosphatase-like family protein', 111, NULL, NULL, 80462),
(80463, '1.20.5.110-FF-000204', NULL, 'EhSyntaxin 16', 105, NULL, NULL, 80463),
(80464, '4.10.860.10-FF-000007', NULL, 'UvrABC system protein C', 52, NULL, NULL, 80464),
(80465, '1.10.287.130-FF-000273', NULL, 'Two-component hybrid sensor and regulator', 67, NULL, NULL, 80465),
(80466, '3.40.50.410-FF-000120', NULL, 'Complement factor B', 187, NULL, NULL, 80466),
(80467, '2.40.50.90-FF-000173', NULL, 'Tudor domain containing protein', 92, NULL, NULL, 80467),
(80468, '1.10.238.10-FF-001080', NULL, 'Defective in cullin neddylation protein', 89, NULL, NULL, 80468),
(80469, '3.90.70.80-FF-000032', NULL, 'Deubiquitylating with USP/UBP and OTU domains', 143, NULL, NULL, 80469),
(80470, '1.20.1080.10-FF-000085', NULL, 'Predicted protein', 215, NULL, NULL, 80470),
(80471, '3.40.20.10-FF-000151', NULL, 'Uncharacterized protein', 93, NULL, NULL, 80471),
(80472, '2.130.10.10-FF-004987', NULL, 'Uncharacterized protein', 77, NULL, NULL, 80472),
(80473, '3.30.40.10-FF-001794', NULL, 'Uncharacterized protein', 52, NULL, NULL, 80473),
(80474, '1.25.10.10-FF-003293', NULL, 'Serine/threonine-protein kinase TOR', 182, NULL, NULL, 80474),
(80475, '2.10.25.10-FF-000811', NULL, 'Vacuolar-sorting receptor 6', 85, NULL, NULL, 80475),
(80476, '1.25.40.10-FF-004767', NULL, 'Anaphase-promoting complex subunit 6', 205, NULL, NULL, 80476),
(80477, '3.30.260.10-FF-000034', NULL, 'T-complex protein 1 subunit gamma', 110, NULL, NULL, 80477),
(80478, '1.20.1420.30-FF-000045', NULL, 'Solute carrier family 24 member 4', 105, NULL, NULL, 80478),
(80479, '3.80.10.10-FF-002048', NULL, 'Uncharacterized protein', 406, NULL, NULL, 80479),
(80480, '3.20.20.100-FF-000014', NULL, 'NAD(P)-linked oxidoreductase superfamily protein', 302, NULL, NULL, 80480),
(80481, '3.40.50.10090-FF-000003', NULL, 'uroporphyrinogen-III synthase', 139, NULL, NULL, 80481),
(80482, '3.40.50.620-FF-000761', NULL, 'Predicted protein', 129, NULL, NULL, 80482),
(80483, '3.30.70.330-FF-002844', NULL, NULL, 84, NULL, NULL, 80483),
(80484, '3.30.70.330-FF-002592', NULL, NULL, 135, NULL, NULL, 80484),
(80485, '2.70.98.10-FF-000067', NULL, 'Putative alpha-1,2-mannosidase', 251, NULL, NULL, 80485),
(80486, '2.60.120.200-FF-000771', NULL, 'Predicted protein', 56, NULL, NULL, 80486),
(80487, '2.130.10.10-FF-004678', NULL, 'Uncharacterized protein', 181, NULL, NULL, 80487),
(80488, '3.40.50.970-FF-000074', NULL, '2-oxoglutarate dehydrogenase E1 component', 364, NULL, NULL, 80488),
(80489, '3.40.50.720-FF-000802', NULL, 'Pyrroline-5-carboxylate reductase', 180, NULL, NULL, 80489),
(80490, '3.30.70.330-FF-000383', NULL, 'Sex lethal, isoform D', 97, NULL, NULL, 80490),
(80491, '3.40.50.12780-FF-000158', NULL, 'Nonribosomal peptide synthase nlsA', 178, NULL, NULL, 80491),
(80492, '1.25.40.10-FF-001333', NULL, 'Pentatricopeptide repeat-containing protein', 161, NULL, NULL, 80492),
(80493, '2.60.40.10-FF-000659', NULL, 'titin isoform X1', 104, NULL, NULL, 80493),
(80494, '2.10.70.10-FF-000101', NULL, 'uncharacterized protein LOC108094628 isoform X1', 62, NULL, NULL, 80494),
(80495, '3.30.40.10-FF-000512', NULL, 'RING finger domain protein', 85, NULL, NULL, 80495),
(80496, '3.90.340.10-FF-000004', NULL, 'Nitric oxide synthase, inducible', 41, NULL, NULL, 80496),
(80497, '3.40.50.10190-FF-000151', NULL, 'Uncharacterized protein', 102, NULL, NULL, 80497),
(80498, '1.20.1250.10-FF-000104', NULL, NULL, 154, NULL, NULL, 80498),
(80499, '2.30.42.10-FF-000406', NULL, NULL, 95, NULL, NULL, 80499),
(80500, '3.40.50.720-FF-002590', NULL, 'Malate dehydrogenase', 115, NULL, NULL, 80500),
(80501, '1.20.1070.10-FF-000365', NULL, 'Muscarinic acetylcholine receptor gar-2', 229, NULL, NULL, 80501),
(80502, '3.10.20.90-FF-000766', NULL, 'Tyrosine-protein phosphatase 1', 86, NULL, NULL, 80502),
(80503, '2.170.8.10-FF-000006', NULL, 'Phosphoenolpyruvate carboxykinase, cytosolic [GTP]', 108, NULL, NULL, 80503);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(80504, '2.60.40.1130-FF-000010', NULL, 'AGAP009724-PA', 104, NULL, NULL, 80504),
(80505, '3.40.50.620-FF-000289', NULL, 'Valyl-tRNA synthetase, isoform A', 198, NULL, NULL, 80505),
(80506, '1.25.40.370-FF-000003', NULL, 'Leucine-rich repeat and WD repeat-containing protein', 100, NULL, NULL, 80506),
(80507, '2.20.110.10-FF-000041', NULL, 'Protein kinase, putative', 73, NULL, NULL, 80507),
(80508, '3.30.160.60-FF-003251', NULL, 'Uncharacterized protein', 30, NULL, NULL, 80508),
(80509, '1.20.120.560-FF-000001', NULL, 'Tyrosine-protein phosphatase non-receptor type 23', 143, NULL, NULL, 80509),
(80510, '1.20.1280.290-FF-000018', NULL, 'Cystinosin homolog', 115, NULL, NULL, 80510),
(80511, '3.40.50.720-FF-000549', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', 191, NULL, NULL, 80511),
(80512, '2.40.50.140-FF-000823', NULL, NULL, 108, NULL, NULL, 80512),
(80513, '1.10.1070.11-FF-000088', NULL, 'DNA-dependent protein kinase catalytic subunit', 190, NULL, NULL, 80513),
(80514, '1.10.1740.10-FF-000020', NULL, 'RNA polymerase sigma factor', 91, NULL, NULL, 80514),
(80515, '1.10.510.10-FF-002668', NULL, NULL, 98, NULL, NULL, 80515),
(80516, '1.25.40.10-FF-004666', NULL, 'Putative pentatricopeptide repeat-containing protein', 113, NULL, NULL, 80516),
(80517, '2.60.120.200-FF-000462', NULL, 'Uncharacterized protein', 172, NULL, NULL, 80517),
(80518, '1.10.8.60-FF-000046', NULL, 'Lon protease homolog 2, peroxisomal', 92, NULL, NULL, 80518),
(80519, '1.10.10.60-FF-001205', NULL, NULL, 83, NULL, NULL, 80519),
(80520, '3.40.50.1360-FF-000015', NULL, 'Hexose-6-phosphate dehydrogenase/glucose 1-dehydrogenase', 237, NULL, NULL, 80520),
(80521, '1.25.40.10-FF-001007', NULL, 'RNA splicing factor', 442, NULL, NULL, 80521),
(80522, '3.30.710.10-FF-000209', NULL, 'AGAP005746-PA', 129, NULL, NULL, 80522),
(80523, '1.10.630.10-FF-000215', NULL, 'Uncharacterized protein', 481, NULL, NULL, 80523),
(80524, '3.60.20.10-FF-000133', NULL, 'SIS domain containing protein', 261, NULL, NULL, 80524),
(80525, '1.10.472.10-FF-000544', NULL, 'Uncharacterized protein', 142, NULL, NULL, 80525),
(80526, '1.20.1250.10-FF-000093', NULL, NULL, 177, NULL, NULL, 80526),
(80527, '3.40.50.1010-FF-000124', NULL, 'Predicted protein', 143, NULL, NULL, 80527),
(80528, '3.40.50.1370-FF-000018', NULL, 'Acetylornithine carbamoyltransferase', 163, NULL, NULL, 80528),
(80529, '3.30.200.20-FF-000680', NULL, 'CMGC/CDK protein kinase', 107, NULL, NULL, 80529),
(80530, '1.10.1300.10-FF-000072', NULL, 'Uncharacterized protein', 85, NULL, NULL, 80530),
(80531, '2.60.40.420-FF-000069', NULL, 'Early nodulin-like protein 1', 109, NULL, NULL, 80531),
(80532, '1.20.1270.60-FF-000114', NULL, 'Formin-binding protein 1-like', 192, NULL, NULL, 80532),
(80533, '3.40.190.10-FF-000329', NULL, 'Glycine/betaine ABC transporter substrate-binding protein', 152, NULL, NULL, 80533),
(80534, '4.10.240.10-FF-000112', NULL, 'ARCA protein', 39, NULL, NULL, 80534),
(80535, '3.40.50.1820-FF-000833', NULL, 'Uncharacterized protein', 157, NULL, NULL, 80535),
(80536, '3.60.110.10-FF-000073', NULL, NULL, 125, NULL, NULL, 80536),
(80537, '2.10.25.10-FF-000339', NULL, 'Crumbs cell polarity complex component 2', 39, NULL, NULL, 80537),
(80538, '3.60.130.10-FF-000080', NULL, 'Uncharacterized protein', 170, NULL, NULL, 80538),
(80539, '2.60.40.10-FF-005307', NULL, NULL, 79, NULL, NULL, 80539),
(80540, '3.20.20.70-FF-000080', NULL, 'Nicotinamide phosphoribosyltransferase', 261, NULL, NULL, 80540),
(80541, '3.60.10.10-FF-000161', NULL, 'Endonuclease exonuclease phosphatase domain contain', 310, NULL, NULL, 80541),
(80542, '3.30.110.10-FF-000006', NULL, 'Probable translation initiation factor, mitochondrial', 94, NULL, NULL, 80542),
(80543, '2.60.120.200-FF-000029', NULL, 'Calsyntenin 2', 194, NULL, NULL, 80543),
(80544, '1.20.1540.10-FF-000014', NULL, 'RHOMBOID-like protein', 167, NULL, NULL, 80544),
(80545, '3.30.559.10-FF-000183', NULL, 'Putrescine hydroxycinnamoyl transferase', 73, NULL, NULL, 80545),
(80546, '3.90.550.50-FF-000049', NULL, 'Hexosyltransferase', 209, NULL, NULL, 80546);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(80547, '3.80.10.10-FF-001767', NULL, 'NACHT, LRR and PYD domains-containing protein 12 isoform X2', 247, NULL, NULL, 80547),
(80548, '3.40.50.300-FF-003223', NULL, 'Eukaryotic elongation factor, selenocysteine-tRNA specific', 106, NULL, NULL, 80548),
(80549, '3.40.50.2300-FF-001040', NULL, NULL, 112, NULL, NULL, 80549),
(80550, '3.20.20.80-FF-000083', NULL, 'Glycogen debranching enzyme', 153, NULL, NULL, 80550),
(80551, '1.10.1370.10-FF-000020', NULL, 'Oligopeptidase A', 200, NULL, NULL, 80551),
(80552, '3.30.110.20-FF-000009', NULL, 'DNA/RNA-binding protein Alba 2, putative', 100, NULL, NULL, 80552),
(80553, '3.30.160.60-FF-003144', NULL, 'Zinc finger protein 789', 29, NULL, NULL, 80553),
(80554, '3.30.160.60-FF-005268', NULL, NULL, 76, NULL, NULL, 80554),
(80555, '2.130.10.10-FF-003352', NULL, 'Sortilin', 232, NULL, NULL, 80555),
(80556, '1.20.1520.10-FF-000007', NULL, 'Cilia- and flagella-associated protein 36', 134, NULL, NULL, 80556),
(80557, '3.30.1360.120-FF-000001', NULL, 'tRNA modification GTPase MnmE', 121, NULL, NULL, 80557),
(80558, '3.30.70.1730-FF-000005', NULL, 'Ribosome assembly factor mrt4', 111, NULL, NULL, 80558),
(80559, '3.30.450.20-FF-000282', NULL, 'Neuronal PAS domain protein 4a', 133, NULL, NULL, 80559),
(80560, '1.20.1070.10-FF-001995', NULL, 'Uncharacterized protein', 151, NULL, NULL, 80560),
(80561, '3.30.160.60-FF-004925', NULL, NULL, 22, NULL, NULL, 80561),
(80562, '3.30.2130.30-FF-000013', NULL, 'Ribosomal RNA large subunit methyltransferase K/L', 185, NULL, NULL, 80562),
(80563, '3.30.70.330-FF-000484', NULL, 'Multiple RNA-binding domain-containing protein 1', 107, NULL, NULL, 80563),
(80564, '3.40.50.2000-FF-000921', NULL, 'ADP-heptose--lipopolysaccharide heptosyltransferase, putative', 160, NULL, NULL, 80564),
(80565, '2.60.40.10-FF-003711', NULL, NULL, 122, NULL, NULL, 80565),
(80566, '3.40.390.10-FF-000064', NULL, 'Matrix metalloproteinase-C', 245, NULL, NULL, 80566),
(80567, '3.30.40.10-FF-002384', NULL, 'Uncharacterized protein', 60, NULL, NULL, 80567),
(80568, '1.20.1740.10-FF-000214', NULL, 'Uncharacterized protein', 109, NULL, NULL, 80568),
(80569, '3.40.50.12780-FF-000057', NULL, 'Possible long-chain acyl-CoA synthase', 417, NULL, NULL, 80569),
(80570, '1.20.1730.10-FF-000040', NULL, 'Sodium/glucose cotransporter slc5a1,2,4, putative', 510, NULL, NULL, 80570),
(80571, '3.50.50.60-FF-000920', NULL, 'NADPH-Fe(3+) oxidoreductase subunit beta', 111, NULL, NULL, 80571),
(80572, '3.40.30.10-FF-000022', NULL, 'NADH dehydrogenase flavoprotein 2, mitochondrial', 98, NULL, NULL, 80572),
(80573, '1.25.10.10-FF-000786', NULL, 'Serine/threonine-protein kinase TOR', 219, NULL, NULL, 80573),
(80574, '1.20.1250.20-FF-002243', NULL, 'Uncharacterized protein', 114, NULL, NULL, 80574),
(80575, '1.10.472.10-FF-000651', NULL, 'Uncharacterized protein', 106, NULL, NULL, 80575),
(80576, '1.25.10.10-FF-003113', NULL, 'Predicted protein', 214, NULL, NULL, 80576),
(80577, '3.40.50.300-FF-001076', NULL, 'ATP-dependent DNA helicase MER3', 193, NULL, NULL, 80577),
(80578, '3.40.50.300-FF-007236', NULL, 'GTP-binding nuclear protein Ran', 161, NULL, NULL, 80578),
(80579, '2.40.50.40-FF-000046', NULL, 'Chemokine (C-C motif) ligand 39, duplicate 3', 68, NULL, NULL, 80579),
(80580, '3.20.20.100-FF-000194', NULL, 'Uncharacterized protein', 92, NULL, NULL, 80580),
(80581, '1.20.1070.10-FF-002142', NULL, 'Predicted protein', 198, NULL, NULL, 80581),
(80582, '1.20.1070.10-FF-000904', NULL, 'Predicted protein', 230, NULL, NULL, 80582),
(80583, '1.10.3930.10-FF-000007', NULL, 'Arginine deiminase', 85, NULL, NULL, 80583),
(80584, '3.30.450.40-FF-000288', NULL, 'Uncharacterized protein', 55, NULL, NULL, 80584),
(80585, '3.40.630.10-FF-000465', NULL, 'Carboxypeptidase', 100, NULL, NULL, 80585),
(80586, '3.30.160.60-FF-003621', NULL, NULL, 26, NULL, NULL, 80586),
(80587, '3.30.479.30-FF-000042', NULL, 'Uncharacterized protein', 132, NULL, NULL, 80587),
(80588, '1.10.510.10-FF-003713', NULL, NULL, 159, NULL, NULL, 80588),
(80589, '3.30.70.1820-FF-000004', NULL, 'Uncharacterized protein', 96, NULL, NULL, 80589);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(80590, '3.30.1360.140-FF-000007', NULL, 'DNA-directed RNA polymerase subunit', 139, NULL, NULL, 80590),
(80591, '1.10.510.10-FF-003820', NULL, NULL, 114, NULL, NULL, 80591),
(80592, '1.10.510.10-FF-003034', NULL, NULL, 221, NULL, NULL, 80592),
(80593, '3.30.160.60-FF-002997', NULL, NULL, 28, NULL, NULL, 80593),
(80594, '3.40.20.10-FF-000050', NULL, 'Villin like', 114, NULL, NULL, 80594),
(80595, '1.20.1250.20-FF-002350', NULL, 'Uncharacterized protein', 176, NULL, NULL, 80595),
(80596, '3.30.200.20-FF-002169', NULL, 'Uncharacterized protein', 63, NULL, NULL, 80596),
(80597, '1.25.10.10-FF-003220', NULL, 'Putative phosphatidylinositol 3-kinase', 264, NULL, NULL, 80597),
(80598, '3.30.70.330-FF-002373', NULL, NULL, 102, NULL, NULL, 80598),
(80599, '1.10.132.30-FF-000007', NULL, 'DNA-directed RNA polymerase subunit', 115, NULL, NULL, 80599),
(80600, '3.10.580.10-FF-000023', NULL, 'Acetoin utilization protein AcuB', 138, NULL, NULL, 80600),
(80601, '1.10.600.10-FF-000067', NULL, 'Terpentetriene synthase', 308, NULL, NULL, 80601),
(80602, '4.10.1000.10-FF-000136', NULL, 'Uncharacterized protein', 75, NULL, NULL, 80602),
(80603, '3.30.200.20-FF-002478', NULL, 'Nerve growth factor receptor TRKA, putative', 41, NULL, NULL, 80603),
(80604, '3.40.50.10730-FF-000004', NULL, 'Urocanate hydratase 1', 88, NULL, NULL, 80604),
(80605, '3.40.50.1820-FF-000726', NULL, 'Alpha/beta superfamily hydrolase, putative (AFU_orthologue AFUA_2G16580)', 135, NULL, NULL, 80605),
(80606, '1.20.1270.60-FF-000221', NULL, 'SH3 domain-containing protein', 240, NULL, NULL, 80606),
(80607, '3.30.420.40-FF-001073', NULL, 'Uncharacterized protein', 161, NULL, NULL, 80607),
(80608, '3.40.1740.10-FF-000006', NULL, 'Uncharacterized protein', 182, NULL, NULL, 80608),
(80609, '3.40.50.12430-FF-000003', NULL, 'GM14826', 111, NULL, NULL, 80609),
(80610, '2.60.40.10-FF-004476', NULL, NULL, 123, NULL, NULL, 80610),
(80611, '2.130.10.10-FF-003043', NULL, 'Eukaryotic translation initiation factor 2A', 150, NULL, NULL, 80611),
(80612, '3.40.50.2300-FF-000567', NULL, 'Predicted protein', 274, NULL, NULL, 80612),
(80613, '3.90.190.10-FF-000520', NULL, 'Uncharacterized protein', 115, NULL, NULL, 80613),
(80614, '3.30.40.10-FF-000613', NULL, 'lysine-specific demethylase 5A', 65, NULL, NULL, 80614),
(80615, '1.25.40.20-FF-001813', NULL, 'Uncharacterized protein', 160, NULL, NULL, 80615),
(80616, '3.40.50.1820-FF-001598', NULL, 'Uncharacterized protein', 82, NULL, NULL, 80616),
(80617, '3.40.50.1980-FF-000095', NULL, 'Histidinol dehydrogenase', 48, NULL, NULL, 80617),
(80618, '3.50.7.10-FF-000054', NULL, NULL, 210, NULL, NULL, 80618),
(80619, '3.10.10.10-FF-000056', NULL, NULL, 76, NULL, NULL, 80619),
(80620, '1.10.10.2030-FF-000005', NULL, 'Kin17 DNA and RNA binding protein', 87, NULL, NULL, 80620),
(80621, '2.30.30.100-FF-000186', NULL, 'Small nuclear ribonucleoprotein Lsm8, putative (AFU_orthologue AFUA_1G11670)', 68, NULL, NULL, 80621),
(80622, '2.60.120.590-FF-000062', NULL, 'Predicted protein', 186, NULL, NULL, 80622),
(80623, '2.60.470.10-FF-000002', NULL, 'Amiloride-sensitive sodium channel subunit alpha', 173, NULL, NULL, 80623),
(80624, '1.10.10.10-FF-000297', NULL, 'DNA-binding transcriptional activator SdiA', 64, NULL, NULL, 80624),
(80625, '1.10.510.10-FF-003511', NULL, NULL, 251, NULL, NULL, 80625),
(80626, '1.20.5.110-FF-000120', NULL, 'Vam3p', 123, NULL, NULL, 80626),
(80627, '3.90.550.20-FF-000040', NULL, 'Predicted protein', 213, NULL, NULL, 80627),
(80628, '1.10.150.20-FF-000327', NULL, 'Xp-G/rad2 DNA repair endonuclease, putative', 68, NULL, NULL, 80628),
(80629, '1.20.1250.20-FF-002041', NULL, 'Predicted protein', 320, NULL, NULL, 80629),
(80630, '3.30.160.60-FF-003930', NULL, NULL, 27, NULL, NULL, 80630),
(80631, '4.10.240.10-FF-000005', NULL, 'Quinic acid utilization activator', 62, NULL, NULL, 80631),
(80632, '1.10.510.10-FF-002887', NULL, NULL, 115, NULL, NULL, 80632),
(80633, '3.40.50.1220-FF-000108', NULL, 'Transcriptional regulator, Sir2 family protein', 64, NULL, NULL, 80633),
(80634, '3.30.450.20-FF-000591', NULL, 'Sensor histidine kinase', 177, NULL, NULL, 80634);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(80635, '3.30.1240.10-FF-000026', NULL, 'HAD family hydrolase', 105, NULL, NULL, 80635),
(80636, '1.25.40.10-FF-004357', NULL, 'Uncharacterized protein', 156, NULL, NULL, 80636),
(80637, '1.25.40.10-FF-004992', NULL, 'Pentatricopeptide repeat protein PPR868-14', 133, NULL, NULL, 80637),
(80638, '1.10.220.150-FF-000038', NULL, 'Uncharacterized protein', 63, NULL, NULL, 80638),
(80639, '3.40.50.1000-FF-000397', NULL, 'GD12369', 143, NULL, NULL, 80639),
(80640, '1.20.81.30-FF-000005', NULL, 'Protein transport protein HofC homolog', 118, NULL, NULL, 80640),
(80641, '3.30.40.10-FF-000248', NULL, 'E3 ubiquitin-protein ligase TRIM68', 86, NULL, NULL, 80641),
(80642, '3.30.70.330-FF-000809', NULL, 'Uncharacterized protein, isoform A', 83, NULL, NULL, 80642),
(80643, '3.30.160.60-FF-001906', NULL, 'zinc finger protein 425', 30, NULL, NULL, 80643),
(80644, '3.40.390.10-FF-000283', NULL, NULL, 112, NULL, NULL, 80644),
(80645, '3.30.760.10-FF-000027', NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', 221, NULL, NULL, 80645),
(80646, '1.20.1050.10-FF-000139', NULL, 'Uncharacterized protein', 115, NULL, NULL, 80646),
(80647, '3.50.50.60-FF-001100', NULL, 'Squalene monooxygenase, putative', 241, NULL, NULL, 80647),
(80648, '3.50.50.60-FF-000611', NULL, 'FAD/NAD(P)-binding domain-containing protein', 416, NULL, NULL, 80648),
(80649, '3.60.20.10-FF-000240', NULL, NULL, 74, NULL, NULL, 80649),
(80650, '2.60.40.10-FF-005616', NULL, NULL, 102, NULL, NULL, 80650),
(80651, '2.30.42.10-FF-000625', NULL, NULL, 76, NULL, NULL, 80651),
(80652, '3.80.10.10-FF-002133', NULL, 'Uncharacterized protein', 151, NULL, NULL, 80652),
(80653, '2.40.50.140-FF-000346', NULL, 'DNA replication licensing factor, putative', 85, NULL, NULL, 80653),
(80654, '3.40.50.1820-FF-000507', NULL, 'Lysophospholipase L2', 312, NULL, NULL, 80654),
(80655, '1.10.10.10-FF-000836', NULL, 'O-methyltransferase family protein', 99, NULL, NULL, 80655),
(80656, '3.40.718.10-FF-000039', NULL, 'NADP-dependent isocitrate dehydrogenase, putative', 295, NULL, NULL, 80656),
(80657, '1.20.1250.20-FF-000096', NULL, 'Major facilitator family transporter', 423, NULL, NULL, 80657),
(80658, '3.30.1520.10-FF-000071', NULL, 'Phox domain-containing protein', 117, NULL, NULL, 80658),
(80659, '3.30.40.10-FF-000618', NULL, 'RING zinc finger protein, putative', 114, NULL, NULL, 80659),
(80660, '3.10.200.10-FF-000012', NULL, 'Carbonic anhydrase 15', 274, NULL, NULL, 80660),
(80661, '2.30.42.10-FF-000255', NULL, 'Multiple PDZ domain protein', 119, NULL, NULL, 80661),
(80662, '3.40.250.10-FF-000115', NULL, 'Rhodanese-like domain-containing protein', 127, NULL, NULL, 80662),
(80663, '3.80.10.10-FF-000351', NULL, 'malignant fibrous histiocytoma-amplified sequence 1 isoform X1', 149, NULL, NULL, 80663),
(80664, '1.10.510.10-FF-001257', NULL, 'Protein kinase, putative', 197, NULL, NULL, 80664),
(80665, '3.40.190.10-FF-000436', NULL, 'ABC transporter substrate-binding protein', 95, NULL, NULL, 80665),
(80666, '1.10.357.140-FF-000023', NULL, 'Cytochrome c oxidase assembly factor heme A:farnesyltransferase COX10', 75, NULL, NULL, 80666),
(80667, '1.10.1240.100-FF-000002', NULL, 'Polyketide synthase RzxD', 81, NULL, NULL, 80667),
(80668, '1.10.10.650-FF-000001', NULL, 'S1 RNA-binding domain 1', 109, NULL, NULL, 80668),
(80669, '3.30.420.10-FF-000232', NULL, 'DNA polymerase', 215, NULL, NULL, 80669),
(80670, '3.80.10.10-FF-003914', NULL, 'Predicted protein', 114, NULL, NULL, 80670),
(80671, '1.25.40.20-FF-000032', NULL, 'BCL-6 corepressor isoform X1', 146, NULL, NULL, 80671),
(80672, '3.40.50.410-FF-000344', NULL, 'Uncharacterized protein', 119, NULL, NULL, 80672),
(80673, '1.10.510.10-FF-002977', NULL, NULL, 142, NULL, NULL, 80673),
(80674, '2.60.120.200-FF-000664', NULL, 'Uncharacterized protein', 77, NULL, NULL, 80674),
(80675, '2.40.50.120-FF-000031', NULL, 'Netrin-A, isoform C', 107, NULL, NULL, 80675),
(80676, '1.10.630.10-FF-000108', NULL, 'Cytochrome P450', 414, NULL, NULL, 80676),
(80677, '3.40.50.1820-FF-001828', NULL, 'Os11g0468300 protein', 87, NULL, NULL, 80677);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(80678, '3.90.180.10-FF-000132', NULL, 'Uncharacterized protein', 36, NULL, NULL, 80678),
(80679, '3.10.110.10-FF-000359', NULL, 'Predicted protein', 157, NULL, NULL, 80679),
(80680, '1.10.1040.10-FF-000034', NULL, 'Mannitol-1-phosphate 5-dehydrogenase', 174, NULL, NULL, 80680),
(80681, '3.40.50.720-FF-002157', NULL, 'Predicted protein', 81, NULL, NULL, 80681),
(80682, '1.20.1070.10-FF-001776', NULL, 'Uncharacterized protein', 330, NULL, NULL, 80682),
(80683, '2.60.120.200-FF-000355', NULL, 'Sex hormone-binding globulin', 175, NULL, NULL, 80683),
(80684, '2.130.10.10-FF-001109', NULL, 'Cytoplasmic dynein 1 intermediate chain', 267, NULL, NULL, 80684),
(80685, '2.60.40.10-FF-001564', NULL, 'tyrosine-protein phosphatase Lar isoform X4', 86, NULL, NULL, 80685),
(80686, '1.20.1250.20-FF-001877', NULL, 'Feline leukemia virus subgroup C cellular receptor family, member 2a', 101, NULL, NULL, 80686),
(80687, '2.60.40.10-FF-001255', NULL, 'usherin', 79, NULL, NULL, 80687),
(80688, '3.30.900.10-FF-000016', NULL, 'Autophagy-related protein 13', 209, NULL, NULL, 80688),
(80689, '1.10.860.10-FF-000024', NULL, 'Replicative DNA helicase', 146, NULL, NULL, 80689),
(80690, '3.90.176.10-FF-000015', NULL, 'NAD(P)(+)--arginine ADP-ribosyltransferase', 120, NULL, NULL, 80690),
(80691, '1.25.40.10-FF-003250', NULL, 'Pre-mRNA-splicing factor CLF1, putative', 172, NULL, NULL, 80691),
(80692, '1.10.486.10-FF-000031', NULL, 'ATP-dependent DNA helicase Rep', 163, NULL, NULL, 80692),
(80693, '2.40.50.140-FF-000716', NULL, NULL, 80, NULL, NULL, 80693),
(80694, '3.40.50.410-FF-000035', NULL, 'collagen alpha-3(VI) chain isoform X3', 187, NULL, NULL, 80694),
(80695, '1.10.472.80-FF-000143', NULL, 'Uncharacterized protein', 134, NULL, NULL, 80695),
(80696, '3.40.50.300-FF-000311', NULL, 'GTP-binding protein RAD', 168, NULL, NULL, 80696),
(80697, '3.30.160.60-FF-003470', NULL, NULL, 31, NULL, NULL, 80697),
(80698, '3.30.200.20-FF-000926', NULL, 'Mitogen-activated protein kinase 10', 115, NULL, NULL, 80698),
(80699, '2.60.40.150-FF-000758', NULL, 'Otoferlin b', 142, NULL, NULL, 80699),
(80700, '2.40.70.10-FF-000196', NULL, 'Uncharacterized protein', 204, NULL, NULL, 80700),
(80701, '1.20.900.10-FF-000060', NULL, 'Rho guanine nucleotide exchange factor osg-1', 204, NULL, NULL, 80701),
(80702, '1.10.10.10-FF-001016', NULL, 'Uncharacterized protein', 146, NULL, NULL, 80702),
(80703, '3.30.230.10-FF-000386', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 158, NULL, NULL, 80703),
(80704, '1.25.40.20-FF-000982', NULL, 'Uncharacterized protein', 127, NULL, NULL, 80704),
(80705, '2.60.40.1730-FF-000100', NULL, NULL, 90, NULL, NULL, 80705),
(80706, '1.10.10.10-FF-000853', NULL, 'ETS-Like transcription Factor homolog', 128, NULL, NULL, 80706),
(80707, '1.10.150.50-FF-000201', NULL, 'Uncharacterized protein', 73, NULL, NULL, 80707),
(80708, '3.30.40.10-FF-002075', NULL, 'Uncharacterized protein', 87, NULL, NULL, 80708),
(80709, '1.50.10.20-FF-000051', NULL, 'Putative squalene-hopene cyclase', 328, NULL, NULL, 80709),
(80710, '1.10.150.670-FF-000020', NULL, 'Nuclease', 81, NULL, NULL, 80710),
(80711, '3.30.70.330-FF-000265', NULL, 'nucleolin isoform X1', 92, NULL, NULL, 80711),
(80712, '3.30.930.10-FF-000063', NULL, 'Octanoyltransferase LIP2, mitochondrial', 210, NULL, NULL, 80712),
(80713, '3.40.50.12780-FF-000052', NULL, 'YOR093C-like protein', 544, NULL, NULL, 80713),
(80714, '3.30.230.10-FF-000279', NULL, 'Elongation factor Tu GTP binding domain containing protein', 164, NULL, NULL, 80714),
(80715, '3.30.200.20-FF-001062', NULL, 'Leucine-rich repeat receptor-like protein kinase PEPR1', 111, NULL, NULL, 80715),
(80716, '2.10.22.10-FF-000007', NULL, NULL, 78, NULL, NULL, 80716),
(80717, '3.30.420.60-FF-000005', NULL, 'Protein pelota homolog', 124, NULL, NULL, 80717),
(80718, '2.120.10.80-FF-000355', NULL, 'Uncharacterized protein', 301, NULL, NULL, 80718),
(80719, '2.40.70.10-FF-000398', NULL, NULL, 180, NULL, NULL, 80719),
(80720, '3.40.50.2300-FF-000551', NULL, 'Guanylate cyclase', 226, NULL, NULL, 80720),
(80721, '1.20.5.110-FF-000013', NULL, 'Vesicle-associated membrane protein 2', 113, NULL, NULL, 80721); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(80722, '2.130.10.30-FF-000137', NULL, NULL, 256, NULL, NULL, 80722),
(80723, '3.60.120.10-FF-000028', NULL, 'Isochorismate synthase', 448, NULL, NULL, 80723),
(80724, '3.10.180.10-FF-000072', NULL, 'Anthracycline biosynthesis protein DnrV', 120, NULL, NULL, 80724),
(80725, '3.40.50.2000-FF-000904', NULL, 'Glycosyl transferase group 1', 167, NULL, NULL, 80725),
(80726, '3.60.40.10-FF-000016', NULL, 'Protein phosphatase 2C', 295, NULL, NULL, 80726),
(80727, '1.25.10.10-FF-001275', NULL, 'Condensin complex subunit 1', 198, NULL, NULL, 80727),
(80728, '3.30.160.60-FF-004886', NULL, NULL, 43, NULL, NULL, 80728),
(80729, '3.40.250.10-FF-000008', NULL, 'Sulfurtransferase', 157, NULL, NULL, 80729),
(80730, '3.30.200.20-FF-001404', NULL, 'Uncharacterized protein CaJ7.0258', 96, NULL, NULL, 80730),
(80731, '3.40.190.10-FF-000745', NULL, 'Uncharacterized protein', 144, NULL, NULL, 80731),
(80732, '1.20.1250.20-FF-002260', NULL, 'Solute carrier family 2, facilitated glucose transporter member 3', 104, NULL, NULL, 80732),
(80733, '3.80.10.10-FF-003875', NULL, 'Leucine rich repeat containing 1', 186, NULL, NULL, 80733),
(80734, '1.10.357.140-FF-000028', NULL, 'UbiA prenyltransferase', 159, NULL, NULL, 80734),
(80735, '3.40.50.720-FF-002466', NULL, 'Uncharacterized protein', 99, NULL, NULL, 80735),
(80736, '1.25.10.10-FF-002949', NULL, 'Uncharacterized protein', 48, NULL, NULL, 80736),
(80737, '2.60.260.20-FF-000085', NULL, 'Chaperone protein DnaJ', 68, NULL, NULL, 80737),
(80738, '1.25.40.180-FF-000053', NULL, 'Eukaryotic translation initiation factor 4 gamma 2', 117, NULL, NULL, 80738),
(80739, '2.160.20.10-FF-000193', NULL, 'Cell surface protein', 83, NULL, NULL, 80739),
(80740, '2.60.120.200-FF-000338', NULL, 'uncharacterized protein LOC100181198 isoform X2', 234, NULL, NULL, 80740),
(80741, '1.25.10.10-FF-000477', NULL, 'ATR serine/threonine kinase', 98, NULL, NULL, 80741),
(80742, '2.60.34.10-FF-000038', NULL, 'Major heat shock 70 kDa protein Ab-like Protein', 182, NULL, NULL, 80742),
(80743, '3.60.20.10-FF-000094', NULL, 'Proteasome subunit beta', 128, NULL, NULL, 80743),
(80744, '1.10.8.140-FF-000007', NULL, 'DNA-binding TFAR19-related protein', 117, NULL, NULL, 80744),
(80745, '3.30.200.20-FF-002506', NULL, 'Uncharacterized protein', 116, NULL, NULL, 80745),
(80746, '3.40.630.10-FF-000139', NULL, 'Putative zinc carboxypeptidase', 264, NULL, NULL, 80746),
(80747, '2.60.40.10-FF-004583', NULL, NULL, 89, NULL, NULL, 80747),
(80748, '3.80.10.10-FF-001969', NULL, 'Insulin like growth factor binding protein acid labile subunit', 154, NULL, NULL, 80748),
(80749, '3.30.70.330-FF-000793', NULL, 'RNA annealing protein YRA2', 145, NULL, NULL, 80749),
(80750, '1.10.486.10-FF-000014', NULL, 'DNA helicase', 158, NULL, NULL, 80750),
(80751, '3.90.650.10-FF-000067', NULL, 'AIR synthase-related protein', 179, NULL, NULL, 80751),
(80752, '3.30.160.60-FF-001362', NULL, 'E3 ubiquitin-protein ligase TRIM13', 68, NULL, NULL, 80752),
(80753, '3.30.160.60-FF-001704', NULL, 'C2H2 transcription factor, putative', 29, NULL, NULL, 80753),
(80754, '3.40.50.620-FF-000328', NULL, 'Isoleucine--tRNA ligase', 215, NULL, NULL, 80754),
(80755, '2.120.10.30-FF-000256', NULL, 'Uncharacterized protein', 201, NULL, NULL, 80755),
(80756, '3.40.50.150-FF-001082', NULL, 'Ubiquinone biosynthesis O-methyltransferase, mitochondrial', 235, NULL, NULL, 80756),
(80757, '2.130.10.10-FF-002986', NULL, 'WD domain', 201, NULL, NULL, 80757),
(80758, '3.40.50.970-FF-000175', NULL, 'Uncharacterized protein', 184, NULL, NULL, 80758),
(80759, '2.10.109.10-FF-000039', NULL, 'Inner Mitochondrial Membrane Protease', 130, NULL, NULL, 80759),
(80760, '3.30.40.10-FF-000276', NULL, 'Receptor homology region transmembrane domain-and RING domain-containing protein 2', 88, NULL, NULL, 80760),
(80761, '1.10.400.10-FF-000086', NULL, 'Uncharacterized protein', 102, NULL, NULL, 80761),
(80762, '3.40.190.10-FF-000638', NULL, 'Uncharacterized protein', 72, NULL, NULL, 80762),
(80763, '2.60.120.10-FF-000116', NULL, 'Cyclic nucleotide-binding domain protein', 127, NULL, NULL, 80763);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(80764, '3.90.550.10-FF-000020', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 361, NULL, NULL, 80764),
(80765, '1.25.40.10-FF-003031', NULL, 'Pentatricopeptide repeat-containing protein At3g62890', 103, NULL, NULL, 80765),
(80766, '1.10.150.20-FF-000288', NULL, 'Uncharacterized protein', 81, NULL, NULL, 80766),
(80767, '1.25.40.10-FF-005155', NULL, 'Uncharacterized protein', 90, NULL, NULL, 80767),
(80768, '3.30.160.60-FF-001036', NULL, 'zinc finger protein 606 isoform X1', 30, NULL, NULL, 80768),
(80769, '1.25.40.10-FF-002749', NULL, 'Uncharacterized protein', 200, NULL, NULL, 80769),
(80770, '1.20.80.10-FF-000014', NULL, 'Tyrosine-protein phosphatase non-receptor type', 112, NULL, NULL, 80770),
(80771, '3.80.10.10-FF-002149', NULL, 'Uncharacterized protein', 317, NULL, NULL, 80771),
(80772, '3.90.550.20-FF-000023', NULL, 'Predicted protein', 255, NULL, NULL, 80772),
(80773, '1.20.1070.10-FF-000702', NULL, 'Neuropeptide receptor 22', 359, NULL, NULL, 80773),
(80774, '1.25.40.470-FF-000033', NULL, 'Outer segment 5', 144, NULL, NULL, 80774),
(80775, '1.20.120.1240-FF-000066', NULL, 'Uncharacterized protein', 111, NULL, NULL, 80775),
(80776, '3.30.160.60-FF-005414', NULL, NULL, 40, NULL, NULL, 80776),
(80777, '3.40.50.300-FF-004965', NULL, 'Membrane-associated sulfotransferase kil1', 268, NULL, NULL, 80777),
(80778, '3.30.1510.10-FF-000019', NULL, 'C-1-tetrahydrofolate synthase, cytoplasmic-like Protein', 106, NULL, NULL, 80778),
(80779, '2.60.40.60-FF-000949', NULL, 'AGAP002828-PA', 111, NULL, NULL, 80779),
(80780, '3.30.70.20-FF-000079', NULL, 'Pyruvate formate-lyase 3 activating enzyme', 48, NULL, NULL, 80780),
(80781, '1.20.1070.10-FF-000360', NULL, 'Tyramine receptor Ser-2', 299, NULL, NULL, 80781),
(80782, '1.20.5.110-FF-000103', NULL, 'Syntaxin, Qa-SNARE family', 99, NULL, NULL, 80782),
(80783, '3.20.20.100-FF-000087', NULL, 'Aldo-keto reductase family 1 member D1', 182, NULL, NULL, 80783),
(80784, '3.40.50.300-FF-007371', NULL, 'CoA synthase', 55, NULL, NULL, 80784),
(80785, '3.30.160.60-FF-004779', NULL, NULL, 29, NULL, NULL, 80785),
(80786, '3.40.50.300-FF-005454', NULL, 'Heme ABC transporter ATP-binding protein', 240, NULL, NULL, 80786),
(80787, '2.60.15.10-FF-000005', NULL, 'ATP synthase delta', 98, NULL, NULL, 80787),
(80788, '1.10.287.1770-FF-000007', NULL, 'Ferrous iron transport protein B', 89, NULL, NULL, 80788),
(80789, '1.10.238.220-FF-000010', NULL, NULL, 110, NULL, NULL, 80789),
(80790, '3.30.40.10-FF-002182', NULL, 'Ubiquitinyl hydrolase 1', 80, NULL, NULL, 80790),
(80791, '3.30.200.20-FF-000590', NULL, 'PH-protein kinase domain containing protein', 102, NULL, NULL, 80791),
(80792, '3.50.50.60-FF-001302', NULL, 'FAD-dependent pyridine nucleotide-disulphide oxidoreductase', 146, NULL, NULL, 80792),
(80793, '3.40.50.300-FF-007129', NULL, 'Predicted protein', 182, NULL, NULL, 80793),
(80794, '3.30.70.330-FF-002743', NULL, NULL, 92, NULL, NULL, 80794),
(80795, '1.10.287.130-FF-000172', NULL, 'Two-component hybrid sensor and regulator', 84, NULL, NULL, 80795),
(80796, '3.50.50.80-FF-000004', NULL, 'Ubiquitin-activating enzyme E1-like', 114, NULL, NULL, 80796),
(80797, '2.60.40.10-FF-001710', NULL, 'immunoglobulin superfamily member 22', 91, NULL, NULL, 80797),
(80798, '3.30.450.20-FF-000063', NULL, 'White collar 1 protein', 109, NULL, NULL, 80798),
(80799, '2.20.100.10-FF-000085', NULL, 'ADAMTS like 4', 67, NULL, NULL, 80799),
(80800, '3.30.160.60-FF-005049', NULL, NULL, 20, NULL, NULL, 80800),
(80801, '1.20.1560.10-FF-000116', NULL, 'Multidrug ABC transporter ATP-binding protein', 324, NULL, NULL, 80801),
(80802, '3.40.50.2000-FF-000814', NULL, 'Trehalose-phosphatase', 306, NULL, NULL, 80802),
(80803, '3.30.1490.80-FF-000032', NULL, 'Glutathione synthetase', 33, NULL, NULL, 80803),
(80804, '3.30.160.60-FF-001671', NULL, 'Zinc finger protein 94', 29, NULL, NULL, 80804),
(80805, '3.30.450.30-FF-000066', NULL, 'Roadblock/LC7 family protein', 120, NULL, NULL, 80805),
(80806, '6.20.10.30-FF-000010', NULL, 'DNA ligase', 39, NULL, NULL, 80806),
(80807, '2.30.40.10-FF-000110', NULL, 'Uncharacterized protein', 66, NULL, NULL, 80807);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(80808, '3.30.460.10-FF-000015', NULL, 'Ribosomal silencing factor RsfS', 108, NULL, NULL, 80808),
(80809, '3.30.160.60-FF-000873', NULL, 'Zinc finger protein 841', 28, NULL, NULL, 80809),
(80810, '3.40.190.10-FF-000419', NULL, 'LysR family transcriptional regulator', 84, NULL, NULL, 80810),
(80811, '1.10.510.10-FF-001712', NULL, 'Testis associated actin remodelling kinase 2', 110, NULL, NULL, 80811),
(80812, '1.25.40.10-FF-002098', NULL, 'Pentatricopeptide repeat-containing protein', 72, NULL, NULL, 80812),
(80813, '3.20.20.100-FF-000205', NULL, 'Uncharacterized protein', 57, NULL, NULL, 80813),
(80814, '3.40.50.1760-FF-000012', NULL, NULL, 133, NULL, NULL, 80814),
(80815, '3.40.190.10-FF-000655', NULL, 'Oligopeptide transport system binding protein', 137, NULL, NULL, 80815),
(80816, '3.40.50.10140-FF-000041', NULL, 'Toll-like receptor 1', 80, NULL, NULL, 80816),
(80817, '3.40.50.150-FF-000929', NULL, NULL, 221, NULL, NULL, 80817),
(80818, '3.40.33.10-FF-000040', NULL, 'Predicted protein', 174, NULL, NULL, 80818),
(80819, '1.20.1070.10-FF-001978', NULL, 'Olfactory receptor 51J1', 173, NULL, NULL, 80819),
(80820, '3.50.50.60-FF-000830', NULL, 'Putative thioredoxin reductase', 112, NULL, NULL, 80820),
(80821, '3.80.10.10-FF-000356', NULL, 'LRR receptor-like serine/threonine-protein kinase', 76, NULL, NULL, 80821),
(80822, '2.60.40.60-FF-000859', NULL, 'Uncharacterized protein', 111, NULL, NULL, 80822),
(80823, '3.30.160.60-FF-000041', NULL, 'Zinc finger protein ZIC 1', 32, NULL, NULL, 80823),
(80824, '2.60.40.10-FF-004892', NULL, NULL, 91, NULL, NULL, 80824),
(80825, '3.40.190.10-FF-000964', NULL, 'Oligopeptide ABC transporter, solute-binding protein', 256, NULL, NULL, 80825),
(80826, '3.75.10.10-FF-000015', NULL, '2-nitroimidazole nitrohydrolase', 309, NULL, NULL, 80826),
(80827, '2.130.10.10-FF-001126', NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', 312, NULL, NULL, 80827),
(80828, '3.90.1150.10-FF-000326', NULL, 'Aromatic-amino-acid aminotransferase 1', 140, NULL, NULL, 80828),
(80829, '1.25.40.10-FF-004576', NULL, 'Uncharacterized protein', 185, NULL, NULL, 80829),
(80830, '1.25.40.10-FF-004885', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 101, NULL, NULL, 80830),
(80831, '3.40.50.1820-FF-000502', NULL, 'Predicted protein', 280, NULL, NULL, 80831),
(80832, '3.30.450.20-FF-000372', NULL, 'Protein single-minded-like Protein', 108, NULL, NULL, 80832),
(80833, '1.10.275.20-FF-000004', NULL, 'Yat2p', 110, NULL, NULL, 80833),
(80834, '3.40.50.300-FF-001306', NULL, 'Clamp-binding protein CrfC', 194, NULL, NULL, 80834),
(80835, '1.20.1560.10-FF-000425', NULL, 'ATP-dependent permease, mitochondrial, putative', 181, NULL, NULL, 80835),
(80836, '3.40.50.300-FF-003077', NULL, 'Rab family GTPase', 188, NULL, NULL, 80836),
(80837, '2.130.10.10-FF-001435', NULL, 'Uncharacterized protein, isoform A', 219, NULL, NULL, 80837),
(80838, '3.10.580.10-FF-000040', NULL, 'Chloride channel 6', 70, NULL, NULL, 80838),
(80839, '3.30.46.10-FF-000008', NULL, 'Glycine N-methyltransferase-like Protein', 90, NULL, NULL, 80839),
(80840, '1.10.150.20-FF-000108', NULL, 'DNA ligase', 71, NULL, NULL, 80840),
(80841, '3.30.40.10-FF-002165', NULL, 'Structure-specific endonuclease subunit SLX1', 82, NULL, NULL, 80841),
(80842, '1.25.40.180-FF-000160', NULL, NULL, 224, NULL, NULL, 80842),
(80843, '2.130.10.10-FF-000946', NULL, 'WD repeat and HMG-box DNA-binding protein 1', 143, NULL, NULL, 80843),
(80844, '3.30.460.20-FF-000018', NULL, 'Magnesium transport protein CorA', 144, NULL, NULL, 80844),
(80845, '1.10.275.30-FF-000007', NULL, 'ATP-dependent DNA helicase', 120, NULL, NULL, 80845),
(80846, '1.10.630.10-FF-000434', NULL, 'Cytochrome P450 76A2', 72, NULL, NULL, 80846),
(80847, '3.40.50.2300-FF-000770', NULL, NULL, 136, NULL, NULL, 80847),
(80848, '2.60.40.10-FF-003481', NULL, 'Titin, tandem duplicate 2', 97, NULL, NULL, 80848),
(80849, '3.40.50.300-FF-001615', NULL, 'Replication factor C subunit 1', 170, NULL, NULL, 80849),
(80850, '2.120.10.80-FF-000338', NULL, 'Flagellar outer dynein arm heavy chain alpha', 120, NULL, NULL, 80850);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(80851, '3.40.1110.10-FF-000071', NULL, 'Copper-transporting ATPase PAA1 chloroplastic', 133, NULL, NULL, 80851),
(80852, '3.90.190.20-FF-000046', NULL, 'Dihydrofolate synthetase', 160, NULL, NULL, 80852),
(80853, '3.30.200.20-FF-000909', NULL, 'Mitogen-activated protein kinase kinase, putative', 110, NULL, NULL, 80853),
(80854, '3.90.190.10-FF-000043', NULL, 'Protein tyrosine phosphatase, receptor type T', 287, NULL, NULL, 80854),
(80855, '1.25.40.370-FF-000008', NULL, 'Uncharacterized protein', 104, NULL, NULL, 80855),
(80856, '3.50.50.60-FF-000459', NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', 281, NULL, NULL, 80856),
(80857, '2.60.120.680-FF-000010', NULL, 'Myosin protein', 107, NULL, NULL, 80857),
(80858, '1.25.40.20-FF-001706', NULL, 'Uncharacterized protein', 55, NULL, NULL, 80858),
(80859, '1.10.287.1150-FF-000001', NULL, '2-oxoglutarate dehydrogenase, mitochondrial isoform X1', 96, NULL, NULL, 80859),
(80860, '1.10.150.670-FF-000003', NULL, 'Crossover junction endonuclease MUS81', 75, NULL, NULL, 80860),
(80861, '3.40.50.1220-FF-000081', NULL, 'Formyltransferase/hydrolase complex Fhc subunit B', 106, NULL, NULL, 80861),
(80862, '1.10.20.140-FF-000013', NULL, 'tRNA dimethylallyltransferase', 69, NULL, NULL, 80862),
(80863, '2.40.70.10-FF-000089', NULL, 'Uncharacterized protein', 227, NULL, NULL, 80863),
(80864, '1.10.532.10-FF-000004', NULL, 'Signal transducer and activator of transcription', 124, NULL, NULL, 80864),
(80865, '2.130.10.10-FF-001216', NULL, 'Type II inositol polyphosphate 5-phosphatase 15', 200, NULL, NULL, 80865),
(80866, '2.60.120.290-FF-000106', NULL, 'SOL-2 protein', 123, NULL, NULL, 80866),
(80867, '1.10.10.60-FF-001115', NULL, NULL, 65, NULL, NULL, 80867),
(80868, '2.40.37.10-FF-000006', NULL, 'Alanine racemase', 131, NULL, NULL, 80868),
(80869, '3.30.70.1130-FF-000011', NULL, 'Eukaryotic translation initiation factor 2 alpha subunit family protein', 120, NULL, NULL, 80869),
(80870, '1.10.630.10-FF-000125', NULL, 'Probable cytochrome P450 CYP36A1', 473, NULL, NULL, 80870),
(80871, '3.30.190.20-FF-000025', NULL, 'FI17503p1', 55, NULL, NULL, 80871),
(80872, '2.60.40.60-FF-001141', NULL, 'Uncharacterized protein', 109, NULL, NULL, 80872),
(80873, '3.60.20.10-FF-000223', NULL, NULL, 133, NULL, NULL, 80873),
(80874, '3.40.309.10-FF-000090', NULL, 'Predicted protein', 140, NULL, NULL, 80874),
(80875, '3.30.70.360-FF-000032', NULL, 'Peptidase M20/M25/M40 family protein', 116, NULL, NULL, 80875),
(80876, '3.40.50.300-FF-005331', NULL, 'origin recognition complex subunit 5', 148, NULL, NULL, 80876),
(80877, '4.10.1030.10-FF-000003', NULL, 'Cullin family protein', 69, NULL, NULL, 80877),
(80878, '1.20.5.110-FF-000322', NULL, 'Uncharacterized protein', 33, NULL, NULL, 80878),
(80879, '3.30.200.20-FF-002473', NULL, 'RAC-beta serine/threonine-protein kinase', 48, NULL, NULL, 80879),
(80880, '3.30.70.370-FF-000035', NULL, NULL, 101, NULL, NULL, 80880),
(80881, '2.40.340.10-FF-000019', NULL, NULL, 71, NULL, NULL, 80881),
(80882, '2.60.260.20-FF-000068', NULL, 'Chaperone protein dnaJ 3', 41, NULL, NULL, 80882),
(80883, '1.25.40.180-FF-000070', NULL, 'Nuclear cap-binding protein complex subunit 1', 297, NULL, NULL, 80883),
(80884, '2.40.37.20-FF-000009', NULL, NULL, 125, NULL, NULL, 80884),
(80885, '2.60.40.10-FF-003172', NULL, 'AGAP003656-PC', 92, NULL, NULL, 80885),
(80886, '3.30.465.10-FF-000077', NULL, 'delta(24)-sterol reductase', 172, NULL, NULL, 80886),
(80887, '3.80.10.10-FF-002610', NULL, 'PH domain leucine-rich repeat protein phosphatase, isoform B', 239, NULL, NULL, 80887),
(80888, '1.20.1070.10-FF-002158', NULL, 'Uncharacterized protein', 145, NULL, NULL, 80888),
(80889, '1.20.58.390-FF-000288', NULL, 'Uncharacterized protein', 28, NULL, NULL, 80889),
(80890, '3.80.10.10-FF-001986', NULL, 'Uncharacterized protein', 104, NULL, NULL, 80890),
(80891, '2.30.30.100-FF-000181', NULL, 'Gem-associated protein 6', 79, NULL, NULL, 80891),
(80892, '3.40.1800.20-FF-000014', NULL, 'GM08392p', 80, NULL, NULL, 80892),
(80893, '4.10.280.10-FF-000221', NULL, 'Uncharacterized protein ASH2', 86, NULL, NULL, 80893);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(80894, '1.10.1300.10-FF-000055', NULL, 'Phosphodiesterase', 270, NULL, NULL, 80894),
(80895, '2.120.10.10-FF-000031', NULL, 'Uncharacterized protein', 257, NULL, NULL, 80895),
(80896, '1.20.1070.10-FF-001669', NULL, 'Uncharacterized protein', 124, NULL, NULL, 80896),
(80897, '3.40.50.12280-FF-000008', NULL, 'Membrane bound oxidoreductase, MbxJ subunit (MbxJ)', 168, NULL, NULL, 80897),
(80898, '2.60.40.200-FF-000003', NULL, 'Superoxide dismutase [Cu-Zn], chloroplastic', 154, NULL, NULL, 80898),
(80899, '3.80.10.10-FF-002464', NULL, 'Uncharacterized protein', 112, NULL, NULL, 80899),
(80900, '2.60.40.10-FF-001912', NULL, 'CD274 molecule', 125, NULL, NULL, 80900),
(80901, '2.30.30.40-FF-000478', NULL, 'Purine-binding chemotaxis protein CheW', 56, NULL, NULL, 80901),
(80902, '1.10.3200.20-FF-000011', NULL, NULL, 177, NULL, NULL, 80902),
(80903, '1.20.1560.10-FF-000206', NULL, 'Chromosome 1, whole genome shotgun sequence', 337, NULL, NULL, 80903),
(80904, '1.10.287.310-FF-000012', NULL, '50S ribosomal protein L29', 62, NULL, NULL, 80904),
(80905, '2.130.10.10-FF-001351', NULL, 'SNARE-dependent exocytosis protein (Sro7), putative', 239, NULL, NULL, 80905),
(80906, '2.40.50.140-FF-000481', NULL, 'Exosome component CSL4', 156, NULL, NULL, 80906),
(80907, '3.30.310.80-FF-000003', NULL, 'Non-specific serine/threonine protein kinase', 147, NULL, NULL, 80907),
(80908, '3.40.605.10-FF-000013', NULL, 'NADP-dependent glyceraldehyde-3-phosphate dehydrogenase', 271, NULL, NULL, 80908),
(80909, '2.70.170.10-FF-000275', NULL, 'Uncharacterized protein', 102, NULL, NULL, 80909),
(80910, '1.20.1540.10-FF-000087', NULL, 'Rhomboid like 1', 156, NULL, NULL, 80910),
(80911, '3.20.20.80-FF-000318', NULL, 'Xyloglucan-specific endo-beta-1,4-glucanase BoGH5A', 376, NULL, NULL, 80911),
(80912, '3.30.40.10-FF-001687', NULL, 'Putative E3 ubiquitin-protein ligase XBAT35', 71, NULL, NULL, 80912),
(80913, '2.60.40.10-FF-000766', NULL, 'junctional adhesion molecule C', 108, NULL, NULL, 80913),
(80914, '1.20.1050.130-FF-000026', NULL, 'Uncharacterized protein', 214, NULL, NULL, 80914),
(80915, '1.10.60.30-FF-000002', NULL, 'UPF0307 protein YjgA', 72, NULL, NULL, 80915),
(80916, '3.30.70.260-FF-000002', NULL, 'UPF0250 protein YbeD', 87, NULL, NULL, 80916),
(80917, '3.30.420.10-FF-000215', NULL, 'Polyprotein of viral origin, putative', 171, NULL, NULL, 80917),
(80918, '3.60.40.10-FF-000331', NULL, 'Protein phosphatase 2C, putative', 162, NULL, NULL, 80918),
(80919, '3.30.70.270-FF-000005', NULL, 'DNA repair protein REV1', 94, NULL, NULL, 80919),
(80920, '1.10.1040.10-FF-000012', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', 161, NULL, NULL, 80920),
(80921, '3.40.50.300-FF-001750', NULL, 'ATP-binding cassette transporter', 274, NULL, NULL, 80921),
(80922, '2.30.42.10-FF-000586', NULL, NULL, 128, NULL, NULL, 80922),
(80923, '3.40.390.10-FF-000311', NULL, NULL, 214, NULL, NULL, 80923),
(80924, '3.20.20.70-FF-000315', NULL, 'Probable RNA methyltransferase PA14_40730', 290, NULL, NULL, 80924),
(80925, '1.10.630.10-FF-000350', NULL, 'Cytochrome P450', 476, NULL, NULL, 80925),
(80926, '1.20.58.240-FF-000001', NULL, 'O-GlcNAcase like', 171, NULL, NULL, 80926),
(80927, '3.50.30.30-FF-000123', NULL, 'Uncharacterized protein', 42, NULL, NULL, 80927),
(80928, '1.10.418.30-FF-000003', NULL, 'Related to kinetochore associated 2 (HEC)', 123, NULL, NULL, 80928),
(80929, '2.40.50.90-FF-000145', NULL, 'YALI0B03960p', 136, NULL, NULL, 80929),
(80930, '1.20.1250.20-FF-000770', NULL, 'Major facilitator superfamily protein', 197, NULL, NULL, 80930),
(80931, '1.25.10.10-FF-001640', NULL, 'Uncharacterized protein', 443, NULL, NULL, 80931),
(80932, '2.60.490.10-FF-000020', NULL, 'P2X purinoceptor', 82, NULL, NULL, 80932),
(80933, '2.30.29.30-FF-000623', NULL, 'Nucleoporin nup61', 233, NULL, NULL, 80933),
(80934, '3.40.50.300-FF-007146', NULL, 'DNA repair protein rdl1', 176, NULL, NULL, 80934),
(80935, '1.20.120.1080-FF-000001', NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase', 105, NULL, NULL, 80935),
(80936, '3.30.465.10-FF-000094', NULL, 'xanthine dehydrogenase/oxidase-like', 127, NULL, NULL, 80936);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(80937, '1.10.10.900-FF-000003', NULL, 'Shwachman-Bodian-Diamond syndrome protein', 63, NULL, NULL, 80937),
(80938, '2.30.30.100-FF-000107', NULL, 'Small nuclear ribonucleoprotein G', 86, NULL, NULL, 80938),
(80939, '3.40.50.300-FF-005437', NULL, 'ABC transporter G family member 3', 238, NULL, NULL, 80939),
(80940, '3.40.1160.10-FF-000001', NULL, 'Uridylate kinase', 240, NULL, NULL, 80940),
(80941, '3.90.190.20-FF-000068', NULL, 'Uncharacterized protein', 101, NULL, NULL, 80941),
(80942, '3.40.50.2000-FF-000253', NULL, 'Glycosyltransferase 1 domain containing 1', 96, NULL, NULL, 80942),
(80943, '1.25.40.570-FF-000063', NULL, 'Uncharacterized protein', 134, NULL, NULL, 80943),
(80944, '3.90.190.10-FF-000065', NULL, 'Dual specificity protein phosphatase 3', 183, NULL, NULL, 80944),
(80945, '2.30.29.30-FF-000084', NULL, 'G protein-coupled receptor kinase', 107, NULL, NULL, 80945),
(80946, '1.20.1070.10-FF-000034', NULL, 'G-protein coupled receptor 1', 299, NULL, NULL, 80946),
(80947, '2.30.30.100-FF-000214', NULL, 'U6 snRNA-associated Sm-like protein LSm3', 82, NULL, NULL, 80947),
(80948, '1.10.10.60-FF-000935', NULL, NULL, 51, NULL, NULL, 80948),
(80949, '1.50.10.10-FF-000031', NULL, 'Unsaturated glucuronyl hydrolase', 375, NULL, NULL, 80949),
(80950, '3.30.160.60-FF-004577', NULL, NULL, 97, NULL, NULL, 80950),
(80951, '1.10.390.10-FF-000050', NULL, 'Aminopeptidase', 252, NULL, NULL, 80951),
(80952, '1.10.510.10-FF-001235', NULL, 'Kinase, CMGC CDK', 201, NULL, NULL, 80952),
(80953, '3.30.200.20-FF-001421', NULL, 'Kinase', 63, NULL, NULL, 80953),
(80954, '3.30.160.60-FF-001452', NULL, 'Odd skipped, putative', 22, NULL, NULL, 80954),
(80955, '3.40.850.10-FF-000228', NULL, 'Kinesin motor family protein', 289, NULL, NULL, 80955),
(80956, '1.20.1560.10-FF-000195', NULL, 'AGAP006273-PA-like protein', 271, NULL, NULL, 80956),
(80957, '3.40.190.10-FF-000094', NULL, 'Glutathione ABC transporter substrate-binding protein GsiB', 85, NULL, NULL, 80957),
(80958, '1.25.40.20-FF-001252', NULL, 'Ankyrin repeat family protein', 226, NULL, NULL, 80958),
(80959, '3.30.70.330-FF-002721', NULL, NULL, 100, NULL, NULL, 80959),
(80960, '3.30.1520.10-FF-000155', NULL, 'Protein CBG07900', 103, NULL, NULL, 80960),
(80961, '3.80.10.10-FF-004173', NULL, 'Predicted protein', 99, NULL, NULL, 80961),
(80962, '3.30.1370.10-FF-000137', NULL, 'KRR1 small subunit processome component', 104, NULL, NULL, 80962),
(80963, '1.20.5.1160-FF-000034', NULL, 'CRE-LET-75 protein', 113, NULL, NULL, 80963),
(80964, '3.50.50.60-FF-000465', NULL, 'NADH oxidase', 265, NULL, NULL, 80964),
(80965, '3.40.50.1820-FF-000491', NULL, 'Carboxylic ester hydrolase', 523, NULL, NULL, 80965),
(80966, '1.10.510.10-FF-000869', NULL, 'Nek protein kinase', 193, NULL, NULL, 80966),
(80967, '1.50.10.20-FF-000034', NULL, 'CAAX geranylgeranyltransferase beta subunit', 367, NULL, NULL, 80967),
(80968, '2.30.42.10-FF-000171', NULL, 'PDZ domain containing 7', 111, NULL, NULL, 80968),
(80969, '1.25.10.10-FF-001314', NULL, 'STAG domain containing protein, putative', 214, NULL, NULL, 80969),
(80970, '2.60.40.2860-FF-000012', NULL, 'Transmission-blocking target antigen S230', 115, NULL, NULL, 80970),
(80971, '2.60.120.260-FF-000238', NULL, 'Calx-beta domain containing protein', 104, NULL, NULL, 80971),
(80972, '1.10.510.10-FF-003365', NULL, NULL, 102, NULL, NULL, 80972),
(80973, '1.20.1070.10-FF-002164', NULL, 'Uncharacterized protein', 140, NULL, NULL, 80973),
(80974, '3.90.1150.10-FF-000343', NULL, 'Cystathionase, putative', 40, NULL, NULL, 80974),
(80975, '3.40.50.80-FF-000229', NULL, 'Uncharacterized protein', 147, NULL, NULL, 80975),
(80976, '3.40.50.300-FF-002689', NULL, 'Predicted protein', 168, NULL, NULL, 80976),
(80977, '3.60.15.10-FF-000166', NULL, 'Uncharacterized protein', 23, NULL, NULL, 80977),
(80978, '3.30.40.10-FF-000692', NULL, 'E3 ubiquitin-protein ligase', 98, NULL, NULL, 80978),
(80979, '1.10.472.10-FF-000089', NULL, 'Cyclin, N-terminal domain containing protein', 112, NULL, NULL, 80979),
(80980, '2.60.40.550-FF-000001', NULL, 'Ecotin', 84, NULL, NULL, 80980);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(80981, '2.60.40.150-FF-000674', NULL, 'Uncharacterized protein', 51, NULL, NULL, 80981),
(80982, '3.90.1150.10-FF-000236', NULL, 'DegT/DnrJ/EryC1/StrS family aminotransferase', 122, NULL, NULL, 80982),
(80983, '2.60.40.10-FF-005510', NULL, NULL, 124, NULL, NULL, 80983),
(80984, '3.30.390.30-FF-000010', NULL, '3-phenylpropionate/cinnamic acid dioxygenase ferredoxin--NAD(+) reductase component', 85, NULL, NULL, 80984),
(80985, '1.10.40.30-FF-000001', NULL, 'Argininosuccinate lyase', 72, NULL, NULL, 80985),
(80986, '1.10.150.670-FF-000019', NULL, 'Crossover junction endonuclease MUS81', 83, NULL, NULL, 80986),
(80987, '3.30.450.60-FF-000052', NULL, 'AP-2 complex subunit, putative', 152, NULL, NULL, 80987),
(80988, '3.10.50.10-FF-000047', NULL, 'Di-N-acetylchitobiase', 52, NULL, NULL, 80988),
(80989, '1.10.418.40-FF-000006', NULL, 'Chromosome 12, whole genome shotgun sequence', 207, NULL, NULL, 80989),
(80990, '3.40.1180.10-FF-000002', NULL, 'Alkyl transferase', 246, NULL, NULL, 80990),
(80991, '1.25.10.10-FF-002585', NULL, 'Predicted protein', 157, NULL, NULL, 80991),
(80992, '3.40.462.10-FF-000001', NULL, 'Cytokinin dehydrogenase 2', 234, NULL, NULL, 80992),
(80993, '3.40.50.150-FF-000845', NULL, 'rRNA adenine N(6)-methyltransferase', 172, NULL, NULL, 80993),
(80994, '2.60.40.1760-FF-000019', NULL, NULL, 225, NULL, NULL, 80994),
(80995, '2.60.40.60-FF-000298', NULL, 'DE-cadherin', 106, NULL, NULL, 80995),
(80996, '3.30.160.60-FF-005723', NULL, NULL, 84, NULL, NULL, 80996),
(80997, '2.160.20.10-FF-000176', NULL, 'Uncharacterized protein', 112, NULL, NULL, 80997),
(80998, '3.30.70.330-FF-000719', NULL, 'Predicted protein', 97, NULL, NULL, 80998),
(80999, '3.30.160.60-FF-001345', NULL, 'zinc finger protein 646', 57, NULL, NULL, 80999),
(81000, '1.20.120.720-FF-000055', NULL, 'Myosin-G heavy chain', 97, NULL, NULL, 81000),
(81001, '1.25.40.10-FF-001029', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 109, NULL, NULL, 81001),
(81002, '2.130.10.10-FF-005151', NULL, 'Uncharacterized protein', 143, NULL, NULL, 81002),
(81003, '3.30.70.330-FF-002597', NULL, NULL, 133, NULL, NULL, 81003),
(81004, '3.40.30.10-FF-001197', NULL, 'Uncharacterized protein', 82, NULL, NULL, 81004),
(81005, '1.10.287.380-FF-000027', NULL, 'AGAP010420-PA', 72, NULL, NULL, 81005),
(81006, '3.30.470.20-FF-000154', NULL, 'Predicted protein', 215, NULL, NULL, 81006),
(81007, '2.40.50.140-FF-000677', NULL, NULL, 85, NULL, NULL, 81007),
(81008, '3.40.1110.10-FF-000054', NULL, 'Cation-transporting ATPase', 189, NULL, NULL, 81008),
(81009, '3.40.50.2000-FF-000360', NULL, 'Os09g0119600 protein', 274, NULL, NULL, 81009),
(81010, '3.40.50.620-FF-000435', NULL, 'Hypothetical_protein_-_conserved', 201, NULL, NULL, 81010),
(81011, '1.20.1070.10-FF-000449', NULL, 'GoNadotropin-Releasing hormone Receptor (GnRHR) related', 274, NULL, NULL, 81011),
(81012, '2.60.120.330-FF-000124', NULL, 'Uncharacterized protein', 201, NULL, NULL, 81012),
(81013, '3.40.850.10-FF-000009', NULL, 'Kinesin-like protein', 332, NULL, NULL, 81013),
(81014, '3.30.200.20-FF-000696', NULL, 'Calcium-dependent protein kinase 1', 100, NULL, NULL, 81014),
(81015, '2.60.40.1730-FF-000010', NULL, 'Putative aminopeptidase N', 177, NULL, NULL, 81015),
(81016, '1.10.10.10-FF-001331', NULL, 'Transcriptional regulatory protein', 114, NULL, NULL, 81016),
(81017, '3.40.50.410-FF-000013', NULL, 'inter-alpha-trypsin inhibitor heavy chain H2', 187, NULL, NULL, 81017),
(81018, '1.25.10.10-FF-002950', NULL, 'Uncharacterized protein', 47, NULL, NULL, 81018),
(81019, '1.20.1270.10-FF-000015', NULL, 'Luminal-binding protein 5', 76, NULL, NULL, 81019),
(81020, '2.60.40.10-FF-003256', NULL, NULL, 50, NULL, NULL, 81020),
(81021, '3.40.50.970-FF-000158', NULL, 'Uncharacterized protein', 218, NULL, NULL, 81021),
(81022, '3.40.50.1820-FF-000378', NULL, 'Carboxylic ester hydrolase', 520, NULL, NULL, 81022),
(81023, '3.30.70.330-FF-000467', NULL, 'Cell wall integrity protein scw1', 89, NULL, NULL, 81023),
(81024, '2.40.180.10-FF-000029', NULL, 'Uncharacterized protein', 145, NULL, NULL, 81024);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(81025, '3.30.230.10-FF-000077', NULL, 'Putative tetQ family GTPase', 78, NULL, NULL, 81025),
(81026, '1.20.1070.10-FF-000343', NULL, 'Uncharacterized protein', 327, NULL, NULL, 81026),
(81027, '1.10.3820.10-FF-000004', NULL, 'C-type cytochrome protein NrfH', 150, NULL, NULL, 81027),
(81028, '1.25.40.970-FF-000003', NULL, 'Histone-lysine N-methyltransferase SMYD3', 80, NULL, NULL, 81028),
(81029, '3.40.50.12780-FF-000074', NULL, 'Acyl-CoA synthetase', 283, NULL, NULL, 81029),
(81030, '3.30.300.30-FF-000156', NULL, 'Uncharacterized protein', 104, NULL, NULL, 81030),
(81031, '1.20.5.5160-FF-000003', NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', 42, NULL, NULL, 81031),
(81032, '3.30.160.60-FF-000979', NULL, 'Zinc finger protein 775', 31, NULL, NULL, 81032),
(81033, '2.130.10.10-FF-005403', NULL, 'Predicted protein', 128, NULL, NULL, 81033),
(81034, '2.60.40.10-FF-004818', NULL, NULL, 61, NULL, NULL, 81034),
(81035, '2.130.10.10-FF-004785', NULL, 'Uncharacterized protein', 151, NULL, NULL, 81035),
(81036, '1.20.80.10-FF-000031', NULL, 'FERM domain (Protein4.1-ezrin-radixin-moesin) family', 108, NULL, NULL, 81036),
(81037, '2.10.109.10-FF-000017', NULL, 'Signal peptidase I', 129, NULL, NULL, 81037),
(81038, '2.30.29.30-FF-000404', NULL, 'Non-specific serine/threonine protein kinase', 118, NULL, NULL, 81038),
(81039, '1.25.40.10-FF-000299', NULL, 'Sel1 repeat family protein', 144, NULL, NULL, 81039),
(81040, '1.25.10.10-FF-001421', NULL, 'ARM repeat superfamily protein', 278, NULL, NULL, 81040),
(81041, '1.20.1280.290-FF-000108', NULL, 'Uncharacterized protein', 140, NULL, NULL, 81041),
(81042, '3.30.479.30-FF-000025', NULL, 'Mechanosensory protein 2-like', 94, NULL, NULL, 81042),
(81043, '3.10.310.10-FF-000015', NULL, 'Proline racemase', 148, NULL, NULL, 81043),
(81044, '3.40.50.720-FF-000465', NULL, 'Quinone oxidoreductase 2', 168, NULL, NULL, 81044),
(81045, '1.25.10.10-FF-003203', NULL, 'PIKK family atypical protein kinase', 282, NULL, NULL, 81045),
(81046, '3.30.50.10-FF-000193', NULL, 'Uncharacterized protein', 34, NULL, NULL, 81046),
(81047, '1.10.10.10-FF-001095', NULL, 'ArsR family transcriptional regulator', 99, NULL, NULL, 81047),
(81048, '1.25.10.10-FF-000696', NULL, 'Formin 3, isoform B', 158, NULL, NULL, 81048),
(81049, '2.170.150.10-FF-000036', NULL, 'Uncharacterized protein', 124, NULL, NULL, 81049),
(81050, '3.90.470.10-FF-000008', NULL, '50S ribosomal protein L22', 128, NULL, NULL, 81050),
(81051, '1.50.40.10-FF-000111', NULL, 'Uncoupling protein 2, like', 210, NULL, NULL, 81051),
(81052, '2.40.50.90-FF-000038', NULL, 'Tudor staphylococcal nuclease', 188, NULL, NULL, 81052),
(81053, '3.20.20.80-FF-000431', NULL, 'Uncharacterized protein', 123, NULL, NULL, 81053),
(81054, '2.60.40.10-FF-005280', NULL, NULL, 84, NULL, NULL, 81054),
(81055, '3.20.20.80-FF-000122', NULL, 'Glycoside hydrolase', 228, NULL, NULL, 81055),
(81056, '3.30.479.20-FF-000022', NULL, 'Elongation factor Ts, mitochondrial', 85, NULL, NULL, 81056),
(81057, '3.40.50.620-FF-000744', NULL, 'Predicted protein', 150, NULL, NULL, 81057),
(81058, '4.10.900.10-FF-000011', NULL, 'Pangolin, isoform Q', 55, NULL, NULL, 81058),
(81059, '3.30.160.60-FF-001143', NULL, 'zinc finger and BTB domain-containing protein 40', 28, NULL, NULL, 81059),
(81060, '1.10.890.20-FF-000001', NULL, 'Fatty-acid-binding protein 2', 45, NULL, NULL, 81060),
(81061, '2.60.40.60-FF-001028', NULL, 'Predicted protein', 105, NULL, NULL, 81061),
(81062, '1.20.950.20-FF-000009', NULL, 'Cytochrome b', 152, NULL, NULL, 81062),
(81063, '3.40.50.300-FF-004021', NULL, 'Uncharacterized protein', 142, NULL, NULL, 81063),
(81064, '3.30.430.20-FF-000045', NULL, 'Os07g0628900 protein', 101, NULL, NULL, 81064),
(81065, '3.40.50.970-FF-000181', NULL, '2-oxoglutarate dehydrogenase, mitochondrial', 371, NULL, NULL, 81065),
(81066, '2.10.110.10-FF-000234', NULL, 'Uncharacterized protein', 51, NULL, NULL, 81066),
(81067, '3.30.70.330-FF-000248', NULL, '50S ribosomal protein L23', 95, NULL, NULL, 81067),
(81068, '3.30.450.30-FF-000049', NULL, 'Profilin', 134, NULL, NULL, 81068);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(81069, '3.30.450.20-FF-000046', NULL, 'Aerotaxis sensor receptor', 131, NULL, NULL, 81069),
(81070, '2.130.10.10-FF-001660', NULL, 'WD_domain_-_G-beta_repeat /Utp13_specific_WD40_associated_domain_containing_protein_-_putative', 198, NULL, NULL, 81070),
(81071, '3.30.720.210-FF-000017', NULL, 'ATP-dependent zinc metalloprotease FtsH 3', 78, NULL, NULL, 81071),
(81072, '2.60.220.50-FF-000052', NULL, 'Uncharacterized protein', 51, NULL, NULL, 81072),
(81073, '3.30.559.70-FF-000066', NULL, 'Novel protein similar to vertebrate carnitine acetyltransferase (CRAT)', 49, NULL, NULL, 81073),
(81074, '2.40.50.140-FF-000368', NULL, 'Mcm10p', 198, NULL, NULL, 81074),
(81075, '3.40.50.2000-FF-000449', NULL, 'Glycosyl transferase group 1', 180, NULL, NULL, 81075),
(81076, '3.30.160.60-FF-005184', NULL, NULL, 38, NULL, NULL, 81076),
(81077, '2.60.120.260-FF-000351', NULL, 'Uncharacterized protein', 245, NULL, NULL, 81077),
(81078, '2.60.40.10-FF-001603', NULL, 'Roundabout 2', 110, NULL, NULL, 81078),
(81079, '1.20.1160.11-FF-000019', NULL, NULL, 67, NULL, NULL, 81079),
(81080, '3.40.50.10090-FF-000020', NULL, 'Uroporphyrinogen-III synthase', 135, NULL, NULL, 81080),
(81081, '3.10.390.10-FF-000008', NULL, 'Abnormal DAuer Formation DAF-5, a Ski oncogene homolog involved in a neuronal TGF beta pathway (71.0 kD) (Daf-5)', 92, NULL, NULL, 81081),
(81082, '3.40.640.10-FF-000527', NULL, 'Uncharacterized protein', 105, NULL, NULL, 81082),
(81083, '2.60.40.10-FF-003037', NULL, 'Zwei Ig domain protein zig-5', 109, NULL, NULL, 81083),
(81084, '3.40.250.10-FF-000025', NULL, 'Molybdopterin biosynthesis MoeZ', 116, NULL, NULL, 81084),
(81085, '1.20.58.60-FF-000404', NULL, 'Spectrin repeat containing nuclear envelope protein 2', 233, NULL, NULL, 81085),
(81086, '1.25.40.20-FF-001780', NULL, 'Poly [ADP-ribose] polymerase', 313, NULL, NULL, 81086),
(81087, '2.30.29.30-FF-001011', NULL, 'Band 4.1-like protein 5', 91, NULL, NULL, 81087),
(81088, '3.40.50.300-FF-000002', NULL, 'ATP synthase subunit alpha', 280, NULL, NULL, 81088),
(81089, '3.40.50.2300-FF-000236', NULL, 'Two component transcriptional regulator NrrA', 82, NULL, NULL, 81089),
(81090, '2.60.410.10-FF-000004', NULL, 'D-alanyl-D-alanine carboxypeptidase DacA', 102, NULL, NULL, 81090),
(81091, '1.10.8.1220-FF-000021', NULL, 'Dynein axonemal heavy chain 6', 85, NULL, NULL, 81091),
(81092, '1.10.357.140-FF-000045', NULL, '1,4-dihydroxy-2-naphthoate octaprenyltransferase, putative', 120, NULL, NULL, 81092),
(81093, '1.10.10.750-FF-000031', NULL, 'Rab GTPase activating protein, putative', 52, NULL, NULL, 81093),
(81094, '3.40.1610.10-FF-000002', NULL, 'Uncharacterized protein', 158, NULL, NULL, 81094),
(81095, '3.75.10.10-FF-000032', NULL, NULL, 214, NULL, NULL, 81095),
(81096, '1.10.1450.10-FF-000077', NULL, 'GM10990', 83, NULL, NULL, 81096),
(81097, '1.10.238.10-FF-001315', NULL, 'Probable calcium-binding mitochondrial carrier F17E5.2', 124, NULL, NULL, 81097),
(81098, '3.10.20.870-FF-000005', NULL, 'Polyubiquitin binding protein, putative', 84, NULL, NULL, 81098),
(81099, '3.30.160.60-FF-005504', NULL, NULL, 31, NULL, NULL, 81099),
(81100, '2.60.40.10-FF-004785', NULL, NULL, 118, NULL, NULL, 81100),
(81101, '3.60.130.10-FF-000001', NULL, 'Trimethyllysine dioxygenase, mitochondrial', 284, NULL, NULL, 81101),
(81102, '1.10.1370.10-FF-000019', NULL, 'Peptidyl-dipeptidase dcp', 375, NULL, NULL, 81102),
(81103, '1.20.1410.10-FF-000004', NULL, 'Cytoskeleton assembly control protein Sla2', 207, NULL, NULL, 81103),
(81104, '1.20.58.60-FF-000387', NULL, 'Spectrin repeat containing nuclear envelope protein 1', 265, NULL, NULL, 81104),
(81105, '2.130.10.10-FF-004763', NULL, 'Uncharacterized protein', 157, NULL, NULL, 81105),
(81106, '3.90.180.10-FF-000093', NULL, 'Alcohol dehydrogenase 5 (class III), chi polypeptide', 150, NULL, NULL, 81106),
(81107, '1.25.40.180-FF-000305', NULL, NULL, 71, NULL, NULL, 81107),
(81108, '3.80.10.10-FF-002155', NULL, 'F-box/LRR-repeat protein 15', 259, NULL, NULL, 81108),
(81109, '1.10.600.10-FF-000051', NULL, 'Geranylgeranyl diphosphate synthetase', 343, NULL, NULL, 81109);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(81110, '2.60.40.420-FF-000070', NULL, 'Potential multicopper ferro-O2-oxidoreductase', 137, NULL, NULL, 81110),
(81111, '1.25.40.20-FF-001471', NULL, 'Os07g0492966 protein', 105, NULL, NULL, 81111),
(81112, '3.40.50.300-FF-003094', NULL, 'ADP ribosylation factor family gtpase', 171, NULL, NULL, 81112),
(81113, '3.40.50.300-FF-003184', NULL, 'Uncharacterized protein', 222, NULL, NULL, 81113),
(81114, '1.20.140.40-FF-000078', NULL, NULL, 114, NULL, NULL, 81114),
(81115, '1.10.510.10-FF-003056', NULL, NULL, 290, NULL, NULL, 81115),
(81116, '1.20.58.100-FF-000010', NULL, 'L-aspartate oxidase', 95, NULL, NULL, 81116),
(81117, '2.60.40.10-FF-003402', NULL, NULL, 121, NULL, NULL, 81117),
(81118, '3.40.50.620-FF-000183', NULL, 'Glutaminyl-tRNA synthetase', 336, NULL, NULL, 81118),
(81119, '3.30.450.20-FF-000265', NULL, 'Methyl-accepting chemotaxis protein', 169, NULL, NULL, 81119),
(81120, '3.40.50.300-FF-005128', NULL, 'ABC-type cobalt transport system, ATPase component', 244, NULL, NULL, 81120),
(81121, '2.60.40.10-FF-002784', NULL, 'Myotactin form A', 95, NULL, NULL, 81121),
(81122, '2.60.120.10-FF-000009', NULL, 'Potassium voltage-gated channel subfamily H member 1', 177, NULL, NULL, 81122),
(81123, '3.40.390.10-FF-000081', NULL, 'Serpentine receptor class gamma', 243, NULL, NULL, 81123),
(81124, '2.60.40.10-FF-005190', NULL, NULL, 117, NULL, NULL, 81124),
(81125, '2.30.42.10-FF-000480', NULL, NULL, 113, NULL, NULL, 81125),
(81126, '1.20.58.60-FF-000078', NULL, 'Spectrin alpha chain, non-erythrocytic 1', 115, NULL, NULL, 81126),
(81127, '3.40.50.1820-FF-000182', NULL, 'Lipase EstA', 180, NULL, NULL, 81127),
(81128, '3.40.50.150-FF-001227', NULL, NULL, 144, NULL, NULL, 81128),
(81129, '6.10.250.3310-FF-000002', NULL, 'Signal transducer and activator of transcription', 39, NULL, NULL, 81129),
(81130, '1.20.58.60-FF-000623', NULL, 'Uncharacterized protein', 290, NULL, NULL, 81130),
(81131, '1.20.1730.10-FF-000023', NULL, 'Sodium transporter', 493, NULL, NULL, 81131),
(81132, '3.40.720.10-FF-000314', NULL, 'Uncharacterized protein', 199, NULL, NULL, 81132),
(81133, '1.25.40.10-FF-002884', NULL, 'Signal recognition particle subunit SRP72', 229, NULL, NULL, 81133),
(81134, '3.30.2130.30-FF-000030', NULL, 'Probable tRNA sulfurtransferase', 175, NULL, NULL, 81134),
(81135, '3.30.420.40-FF-000775', NULL, 'Uncharacterized protein', 92, NULL, NULL, 81135),
(81136, '1.20.1250.20-FF-000461', NULL, 'Monosaccharide-sensing protein 3', 248, NULL, NULL, 81136),
(81137, '3.20.100.10-FF-000008', NULL, 'RNA triphosphatase', 227, NULL, NULL, 81137),
(81138, '1.25.40.10-FF-003502', NULL, 'YALI0F21362p', 244, NULL, NULL, 81138),
(81139, '3.30.450.20-FF-000607', NULL, 'Two-component hybrid sensor and regulator', 120, NULL, NULL, 81139),
(81140, '1.10.238.10-FF-001006', NULL, 'Defective in cullin neddylation protein', 93, NULL, NULL, 81140),
(81141, '2.130.10.10-FF-003711', NULL, 'Uncharacterized protein', 70, NULL, NULL, 81141),
(81142, '3.40.50.1820-FF-000524', NULL, 'Surfactin synthase thioesterase subunit', 242, NULL, NULL, 81142),
(81143, '1.20.1420.30-FF-000062', NULL, 'Predicted protein', 128, NULL, NULL, 81143),
(81144, '3.30.160.190-FF-000001', NULL, 'NADH-ubiquinone oxidoreductase 21 kDa subunit mitochondrial', 80, NULL, NULL, 81144),
(81145, '1.20.5.170-FF-000222', NULL, 'Paramyosin, putative', 37, NULL, NULL, 81145),
(81146, '2.60.120.260-FF-000547', NULL, 'Uncharacterized protein', 63, NULL, NULL, 81146),
(81147, '3.30.70.660-FF-000015', NULL, 'tRNA pseudouridine synthase', 216, NULL, NULL, 81147),
(81148, '2.160.20.10-FF-000086', NULL, 'Probable GLUCAN ENDO-1, 3-BETA-GLUCOSIDASE BGN13.1', 330, NULL, NULL, 81148),
(81149, '3.80.10.10-FF-000025', NULL, 'Leucine rich repeat and fibronectin type III domain containing 5', 118, NULL, NULL, 81149),
(81150, '3.40.630.30-FF-000004', NULL, 'Histone acetyltransferase KAT2A', 168, NULL, NULL, 81150),
(81151, '1.25.40.10-FF-005301', NULL, 'SET domain-containing protein 5', 130, NULL, NULL, 81151),
(81152, '3.90.1720.30-FF-000005', NULL, NULL, 162, NULL, NULL, 81152);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(81153, '2.40.50.140-FF-000790', NULL, NULL, 149, NULL, NULL, 81153),
(81154, '3.40.50.300-FF-007455', NULL, 'ABC transporter protein', 245, NULL, NULL, 81154),
(81155, '1.50.40.10-FF-000420', NULL, 'Solute carrier family 25 (mitochondrial carrier; peroxisomal membrane protein), member 17', 194, NULL, NULL, 81155),
(81156, '1.20.58.120-FF-000016', NULL, NULL, 132, NULL, NULL, 81156),
(81157, '1.10.357.30-FF-000001', NULL, 'Exocyst complex component', 177, NULL, NULL, 81157),
(81158, '2.40.160.50-FF-000017', NULL, 'Outer membrane protein assembly factor BamA', 360, NULL, NULL, 81158),
(81159, '2.20.100.10-FF-000231', NULL, 'plasminogen-like isoform X2', 54, NULL, NULL, 81159),
(81160, '1.10.1040.10-FF-000118', NULL, 'Uncharacterized protein', 101, NULL, NULL, 81160),
(81161, '3.80.10.10-FF-004482', NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase At5g06940', 122, NULL, NULL, 81161),
(81162, '1.10.357.50-FF-000007', NULL, 'BAI1 associated protein 3', 190, NULL, NULL, 81162),
(81163, '1.25.10.10-FF-003422', NULL, 'Ecm29p', 310, NULL, NULL, 81163),
(81164, '1.20.1250.20-FF-002349', NULL, 'Uncharacterized protein', 177, NULL, NULL, 81164),
(81165, '1.25.40.20-FF-001561', NULL, 'Uncharacterized protein', 90, NULL, NULL, 81165),
(81166, '3.40.50.11660-FF-000053', NULL, NULL, 84, NULL, NULL, 81166),
(81167, '4.10.1000.10-FF-000029', NULL, 'tRNA-dihydrouridine(47) synthase [NAD(P)(+)]', 80, NULL, NULL, 81167),
(81168, '1.10.238.220-FF-000009', NULL, NULL, 85, NULL, NULL, 81168),
(81169, '3.40.630.40-FF-000007', NULL, 'N-acetylmuramoyl-L-alanine amidase', 186, NULL, NULL, 81169),
(81170, '3.30.200.20-FF-000365', NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', 97, NULL, NULL, 81170),
(81171, '1.10.357.40-FF-000004', NULL, 'Infection Response protein', 187, NULL, NULL, 81171),
(81172, '2.30.42.10-FF-000277', NULL, 'sorting nexin-27 isoform X2', 41, NULL, NULL, 81172),
(81173, '3.40.50.300-FF-002003', NULL, 'GPN-loop GTPase 2', 93, NULL, NULL, 81173),
(81174, '3.60.15.10-FF-000256', NULL, 'RNA-metabolising metallo-beta-lactamase family protein', 220, NULL, NULL, 81174),
(81175, '3.60.10.10-FF-000413', NULL, 'Nuclear GTPase, germinal center-associated, tandem duplicate 1', 240, NULL, NULL, 81175),
(81176, '3.40.30.10-FF-000106', NULL, 'DnaJ homolog subfamily C member 10', 113, NULL, NULL, 81176),
(81177, '2.40.50.140-FF-000262', NULL, 'Protein BREAST CANCER SUSCEPTIBILITY 2 homolog B', 130, NULL, NULL, 81177),
(81178, '3.30.200.20-FF-000707', NULL, 'Cyclin dependent kinase 19', 103, NULL, NULL, 81178),
(81179, '1.25.10.10-FF-001168', NULL, 'Binding protein', 227, NULL, NULL, 81179),
(81180, '3.40.50.10190-FF-000134', NULL, 'BRCT domain-containing protein', 87, NULL, NULL, 81180),
(81181, '3.30.70.330-FF-000158', NULL, 'heterogeneous nuclear ribonucleoprotein A3 isoform X1', 95, NULL, NULL, 81181),
(81182, '1.10.287.70-FF-000423', NULL, 'Voltage-gated Ca2+ channel, alpha subunit', 137, NULL, NULL, 81182),
(81183, '3.20.20.80-FF-000009', NULL, 'O-GlcNAcase BT_4395', 283, NULL, NULL, 81183),
(81184, '3.40.50.720-FF-001859', NULL, 'Uncharacterized protein', 162, NULL, NULL, 81184),
(81185, '3.40.50.10490-FF-000123', NULL, NULL, 70, NULL, NULL, 81185),
(81186, '2.30.30.490-FF-000033', NULL, 'Agenet and bromo-adjacent homology (BAH) domain-containing protein', 157, NULL, NULL, 81186),
(81187, '1.10.472.10-FF-000179', NULL, 'Cyclin Q', 135, NULL, NULL, 81187),
(81188, '3.40.367.20-FF-000029', NULL, 'Phosphotransferase', 49, NULL, NULL, 81188),
(81189, '2.10.25.10-FF-000233', NULL, 'tomoregulin-1 isoform X1', 47, NULL, NULL, 81189),
(81190, '3.40.850.10-FF-000318', NULL, 'Kinesin, putative', 385, NULL, NULL, 81190),
(81191, '1.20.120.610-FF-000022', NULL, 'ATP synthase subunit C family protein', 157, NULL, NULL, 81191),
(81192, '3.10.20.90-FF-000991', NULL, 'Uncharacterized protein', 90, NULL, NULL, 81192),
(81193, '2.60.40.10-FF-000985', NULL, 'Cardiomyopathy associated 5', 115, NULL, NULL, 81193),
(81194, '3.40.50.300-FF-006764', NULL, 'Uncharacterized protein', 62, NULL, NULL, 81194);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(81195, '2.30.29.30-FF-000393', NULL, 'centaurin-gamma-1A isoform X2', 100, NULL, NULL, 81195),
(81196, '3.40.80.10-FF-000042', NULL, 'Peptidoglycan-recognition protein LF-like Protein', 143, NULL, NULL, 81196),
(81197, '2.40.320.10-FF-000018', NULL, 'Triphosphate tunnel metalloenzyme 3', 212, NULL, NULL, 81197),
(81198, '3.40.50.720-FF-001769', NULL, 'Uncharacterized protein', 122, NULL, NULL, 81198),
(81199, '2.60.120.200-FF-000445', NULL, 'Uncharacterized protein', 81, NULL, NULL, 81199),
(81200, '3.40.570.10-FF-000044', NULL, 'Uncharacterized protein', 324, NULL, NULL, 81200),
(81201, '1.25.40.10-FF-004683', NULL, 'Uncharacterized protein', 105, NULL, NULL, 81201),
(81202, '3.40.50.2000-FF-000359', NULL, 'Glycoside hydrolase', 182, NULL, NULL, 81202),
(81203, '3.30.70.330-FF-002266', NULL, NULL, 89, NULL, NULL, 81203),
(81204, '2.30.30.30-FF-000166', NULL, 'p53-binding protein 1', 47, NULL, NULL, 81204),
(81205, '1.20.1250.20-FF-000803', NULL, 'MFS transporter', 188, NULL, NULL, 81205),
(81206, '3.30.70.330-FF-002608', NULL, NULL, 131, NULL, NULL, 81206),
(81207, '1.10.10.60-FF-000699', NULL, 'MYB transcription factor 84', 72, NULL, NULL, 81207),
(81208, '3.30.710.10-FF-000226', NULL, 'Uncharacterized protein', 91, NULL, NULL, 81208),
(81209, '3.40.1190.20-FF-000051', NULL, 'Pyridoxal kinase', 297, NULL, NULL, 81209),
(81210, '1.10.340.70-FF-000020', NULL, 'Polyprotein', 91, NULL, NULL, 81210),
(81211, '3.40.50.300-FF-001385', NULL, 'STH1 (YIL126W)', 230, NULL, NULL, 81211),
(81212, '1.25.40.770-FF-000022', NULL, 'TAF6-like RNA polymerase II, p300/CBP-associated factor (PCAF)-associated factor', 132, NULL, NULL, 81212),
(81213, '3.30.1330.30-FF-000101', NULL, 'Uncharacterized protein', 67, NULL, NULL, 81213),
(81214, '3.40.50.300-FF-007040', NULL, 'Uncharacterized protein', 200, NULL, NULL, 81214),
(81215, '3.30.420.40-FF-001051', NULL, 'HSP70-like protein', 221, NULL, NULL, 81215),
(81216, '1.25.10.10-FF-003309', NULL, 'Serine/threonine-protein kinase TOR', 160, NULL, NULL, 81216),
(81217, '3.20.20.70-FF-000006', NULL, 'Imidazole glycerol phosphate synthase subunit HisF', 254, NULL, NULL, 81217),
(81218, '2.60.120.200-FF-000136', NULL, 'Collagen type V alpha 3 chain', 205, NULL, NULL, 81218),
(81219, '1.20.58.60-FF-000168', NULL, 'nesprin-1 isoform X3', 291, NULL, NULL, 81219),
(81220, '3.10.100.10-FF-000078', NULL, 'C-type LECtin', 132, NULL, NULL, 81220),
(81221, '2.60.40.10-FF-003150', NULL, 'Tyrosine-protein phosphatase 4', 97, NULL, NULL, 81221),
(81222, '1.10.472.10-FF-000398', NULL, 'Uncharacterized protein', 112, NULL, NULL, 81222),
(81223, '3.40.50.150-FF-000699', NULL, 'tRNA 5-methylaminomethyl-2-thiouridine biosynthesis bifunctional protein MnmC', 232, NULL, NULL, 81223),
(81224, '3.30.40.10-FF-000383', NULL, 'RING/U-box superfamily protein', 66, NULL, NULL, 81224),
(81225, '2.60.40.420-FF-000176', NULL, 'Multicopper oxidase family protein', 145, NULL, NULL, 81225),
(81226, '3.40.50.300-FF-006983', NULL, 'Predicted protein', 216, NULL, NULL, 81226),
(81227, '2.60.220.50-FF-000181', NULL, 'Predicted protein', 55, NULL, NULL, 81227),
(81228, '2.40.128.20-FF-000001', NULL, 'Fatty acid-binding protein, adipocyte', 132, NULL, NULL, 81228),
(81229, '3.30.470.20-FF-000064', NULL, 'Glutathione synthetase', 111, NULL, NULL, 81229),
(81230, '1.20.1440.170-FF-000003', NULL, 'Unplaced genomic scaffold supercont2.9, whole genome shotgun sequence', 126, NULL, NULL, 81230),
(81231, '3.40.190.80-FF-000041', NULL, 'Carbohydrate phosphatase', 128, NULL, NULL, 81231),
(81232, '3.40.850.10-FF-000537', NULL, 'Kinesin family member 5B, a', 331, NULL, NULL, 81232),
(81233, '3.40.50.300-FF-003330', NULL, 'Bifunctional adenosylcobinamide kinase/adenosylcobinamide-phosphate guanylyltransferase', 182, NULL, NULL, 81233),
(81234, '3.50.30.80-FF-000003', NULL, 'Dihydroxy-acid dehydratase, putative', 165, NULL, NULL, 81234),
(81235, '3.30.420.40-FF-000685', NULL, 'Kanosamine kinase', 125, NULL, NULL, 81235),
(81236, '2.20.25.20-FF-000027', NULL, NULL, 53, NULL, NULL, 81236),
(81237, '3.90.1580.10-FF-000010', NULL, 'Gliding motility lipoprotein GldK', 259, NULL, NULL, 81237);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(81238, '1.10.287.70-FF-000114', NULL, 'Cytochrome c oxidase subunit 1', 76, NULL, NULL, 81238),
(81239, '3.10.129.10-FF-000144', NULL, '4-hydroxybenzoyl-CoA thioesterase protein', 160, NULL, NULL, 81239),
(81240, '3.20.20.80-FF-000228', NULL, 'Chitinase A', 374, NULL, NULL, 81240),
(81241, '2.70.70.10-FF-000054', NULL, 'Cell wall endopeptidase family M23/M37', 137, NULL, NULL, 81241),
(81242, '1.20.58.60-FF-000533', NULL, 'Uncharacterized protein', 139, NULL, NULL, 81242),
(81243, '2.60.40.10-FF-001457', NULL, 'MPL proto-oncogene, thrombopoietin receptor', 92, NULL, NULL, 81243),
(81244, '1.10.1670.10-FF-000060', NULL, NULL, 84, NULL, NULL, 81244),
(81245, '2.10.25.10-FF-001778', NULL, 'Uncharacterized protein', 33, NULL, NULL, 81245),
(81246, '1.20.1250.20-FF-000551', NULL, 'Solute carrier organic anion transporter family member', 144, NULL, NULL, 81246),
(81247, '2.60.120.340-FF-000021', NULL, 'Histone deacetylase-related / HD-like protein', 98, NULL, NULL, 81247),
(81248, '3.40.50.1010-FF-000017', NULL, 'protein SMG5 isoform X2', 164, NULL, NULL, 81248),
(81249, '3.30.70.270-FF-000224', NULL, NULL, 53, NULL, NULL, 81249),
(81250, '2.40.50.120-FF-000014', NULL, 'Secreted frizzled-related protein 5', 121, NULL, NULL, 81250),
(81251, '3.30.230.10-FF-000280', NULL, 'GTPase', 181, NULL, NULL, 81251),
(81252, '3.40.50.300-FF-001295', NULL, 'Probable RNA helicase SDE3', 200, NULL, NULL, 81252),
(81253, '3.30.450.270-FF-000006', NULL, 'Phytochrome-like protein cph1', 136, NULL, NULL, 81253),
(81254, '1.10.510.10-FF-003730', NULL, NULL, 151, NULL, NULL, 81254),
(81255, '1.10.940.10-FF-000008', NULL, 'Transcription antitermination protein NusB', 135, NULL, NULL, 81255),
(81256, '2.60.40.10-FF-001238', NULL, 'Sallimus, isoform P', 100, NULL, NULL, 81256),
(81257, '3.30.1060.10-FF-000018', NULL, NULL, 160, NULL, NULL, 81257),
(81258, '3.10.250.10-FF-000032', NULL, 'Si:dkey-14d8.20', 107, NULL, NULL, 81258),
(81259, '3.40.30.10-FF-001091', NULL, 'Uncharacterized protein', 95, NULL, NULL, 81259),
(81260, '3.30.870.10-FF-000058', NULL, 'Putative cardiolipin synthetase', 209, NULL, NULL, 81260),
(81261, '2.130.10.10-FF-002655', NULL, 'Uncharacterized protein', 84, NULL, NULL, 81261),
(81262, '2.60.40.10-FF-002874', NULL, 'Tapasin long form', 106, NULL, NULL, 81262),
(81263, '2.40.50.140-FF-000571', NULL, 'tRNA-binding protein', 117, NULL, NULL, 81263),
(81264, '2.10.110.10-FF-000088', NULL, 'Filamin binding LIM protein 1', 59, NULL, NULL, 81264),
(81265, '3.30.1330.40-FF-000014', NULL, 'Chorismate mutase AroH', 126, NULL, NULL, 81265),
(81266, '3.30.160.60-FF-003615', NULL, 'C2H2 type zinc finger domain-containing protein', 44, NULL, NULL, 81266),
(81267, '3.30.559.10-FF-000216', NULL, 'Ferrichrome siderophore peptide synthetase', 192, NULL, NULL, 81267),
(81268, '3.40.50.300-FF-007601', NULL, 'Ras family protein', 161, NULL, NULL, 81268),
(81269, '3.40.50.1700-FF-000016', NULL, 'Periplasmic beta-glucosidase, xylosidase/arabinosidase', 257, NULL, NULL, 81269),
(81270, '2.120.10.30-FF-000587', NULL, 'Uncharacterized protein', 127, NULL, NULL, 81270),
(81271, '3.40.50.360-FF-000071', NULL, 'FMN-dependent NADH-azoreductase', 198, NULL, NULL, 81271),
(81272, '3.40.50.150-FF-001536', NULL, NULL, 96, NULL, NULL, 81272),
(81273, '3.30.470.30-FF-000067', NULL, 'DNA ligase, putative', 179, NULL, NULL, 81273),
(81274, '3.40.50.10490-FF-000033', NULL, 'Glucokinase regulatory protein', 306, NULL, NULL, 81274),
(81275, '3.40.309.10-FF-000089', NULL, 'Succinate-semialdehyde dehydrogenase mitochondrial', 213, NULL, NULL, 81275),
(81276, '3.30.230.70-FF-000179', NULL, 'Uncharacterized protein', 32, NULL, NULL, 81276),
(81277, '3.30.1330.30-FF-000011', NULL, '40S ribosomal protein S12', 132, NULL, NULL, 81277),
(81278, '3.80.10.10-FF-003459', NULL, 'Uncharacterized protein', 236, NULL, NULL, 81278),
(81279, '2.40.30.10-FF-000289', NULL, 'Protein CBG03843', 128, NULL, NULL, 81279),
(81280, '3.30.160.60-FF-002778', NULL, NULL, 29, NULL, NULL, 81280),
(81281, '1.10.10.10-FF-001460', NULL, 'Uncharacterized protein', 80, NULL, NULL, 81281);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(81282, '3.90.660.10-FF-000023', NULL, 'Putative polyamine oxidase 5', 242, NULL, NULL, 81282),
(81283, '3.10.100.10-FF-000387', NULL, NULL, 129, NULL, NULL, 81283),
(81284, '3.30.230.10-FF-000190', NULL, 'DNA repair protein RadA', 160, NULL, NULL, 81284),
(81285, '3.90.640.10-FF-000134', NULL, 'Heat shock cognate 71 kDa protein', 84, NULL, NULL, 81285),
(81286, '3.40.50.720-FF-002573', NULL, 'D-3-phosphoglycerate dehydrogenase 2 chloroplastic', 33, NULL, NULL, 81286),
(81287, '1.20.1250.20-FF-000242', NULL, 'Solute carrier family 16 member 5', 189, NULL, NULL, 81287),
(81288, '3.30.200.20-FF-002495', NULL, 'Uncharacterized protein', 18, NULL, NULL, 81288),
(81289, '2.130.10.10-FF-003150', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', 308, NULL, NULL, 81289),
(81290, '3.30.40.10-FF-001310', NULL, 'RING finger domain protein, putative', 73, NULL, NULL, 81290),
(81291, '1.10.287.3240-FF-000010', NULL, 'ATPase H+ transporting V1 subunit D', 53, NULL, NULL, 81291),
(81292, '3.40.50.300-FF-007910', NULL, 'Predicted protein', 186, NULL, NULL, 81292),
(81293, '1.25.10.10-FF-002495', NULL, 'Uncharacterized protein', 206, NULL, NULL, 81293),
(81294, '1.10.10.10-FF-001550', NULL, 'Putative serine/threonine-protein kinase pats1', 78, NULL, NULL, 81294),
(81295, '2.130.10.10-FF-002964', NULL, 'Cac2p', 228, NULL, NULL, 81295),
(81296, '3.30.710.10-FF-000316', NULL, 'Uncharacterized protein', 54, NULL, NULL, 81296),
(81297, '3.40.50.360-FF-000104', NULL, 'FMN-dependent NADH-azoreductase 1', 192, NULL, NULL, 81297),
(81298, '2.30.29.30-FF-001388', NULL, 'AGAP002982-PA', 119, NULL, NULL, 81298),
(81299, '3.30.420.10-FF-000434', NULL, NULL, 184, NULL, NULL, 81299),
(81300, '1.20.920.10-FF-000145', NULL, 'AaceriAEL291Cp', 143, NULL, NULL, 81300),
(81301, '3.30.70.270-FF-000314', NULL, NULL, 29, NULL, NULL, 81301),
(81302, '3.40.50.720-FF-002264', NULL, 'NADPH-dependent pterin aldehyde reductase', 48, NULL, NULL, 81302),
(81303, '3.30.160.60-FF-003705', NULL, 'Zinc finger protein 142', 54, NULL, NULL, 81303),
(81304, '3.80.10.10-FF-003768', NULL, 'SCF E3 ubiquitin ligase complex F-box protein GRR1', 112, NULL, NULL, 81304),
(81305, '3.30.1460.20-FF-000012', NULL, 'Arp2/3 complex 34 kDa subunit', 76, NULL, NULL, 81305),
(81306, '3.30.1360.10-FF-000058', NULL, 'Uncharacterized protein', 48, NULL, NULL, 81306),
(81307, '4.10.240.10-FF-000022', NULL, 'Upc2p', 65, NULL, NULL, 81307),
(81308, '3.30.160.60-FF-006488', NULL, NULL, 69, NULL, NULL, 81308),
(81309, '1.10.10.60-FF-001194', NULL, NULL, 88, NULL, NULL, 81309),
(81310, '3.30.190.20-FF-000003', NULL, 'UvrABC system protein A', 110, NULL, NULL, 81310),
(81311, '3.55.40.20-FF-000009', NULL, 'Mitochondrial ribosomal small subunit component', 130, NULL, NULL, 81311),
(81312, '1.10.132.110-FF-000001', NULL, 'Serum amyloid A protein', 111, NULL, NULL, 81312),
(81313, '3.80.10.10-FF-000334', NULL, 'Leucine rich repeat containing 15', 114, NULL, NULL, 81313),
(81314, '2.60.40.10-FF-001148', NULL, 'oncostatin-M-specific receptor subunit beta', 82, NULL, NULL, 81314),
(81315, '4.10.60.10-FF-000164', NULL, 'Zinc knuckle nucleic acid binding protein, putative (AFU_orthologue AFUA_7G02190)', 50, NULL, NULL, 81315),
(81316, '3.40.50.1910-FF-000001', NULL, 'syntaxin-binding protein 1 isoform X1', 209, NULL, NULL, 81316),
(81317, '1.20.1270.60-FF-000204', NULL, 'Uncharacterized protein', 297, NULL, NULL, 81317),
(81318, '3.30.420.10-FF-000125', NULL, 'DNA binding protein', 242, NULL, NULL, 81318),
(81319, '2.60.120.260-FF-000457', NULL, 'Laminin gamma 1 chain, putative', 114, NULL, NULL, 81319),
(81320, '3.30.40.10-FF-001001', NULL, 'RING-H2 finger protein 2B', 75, NULL, NULL, 81320),
(81321, '3.30.710.10-FF-000007', NULL, 'Potassium voltage-gated channel subfamily A member 2', 108, NULL, NULL, 81321),
(81322, '3.30.420.40-FF-000994', NULL, 'Heat shock cognate 70-kd protein, tandem duplicate 1', 83, NULL, NULL, 81322),
(81323, '1.20.910.10-FF-000010', NULL, 'Aminopyrimidine aminohydrolase', 229, NULL, NULL, 81323);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(81324, '3.40.50.1820-FF-000272', NULL, 'Aminopeptidase, putative', 301, NULL, NULL, 81324),
(81325, '1.25.40.10-FF-000844', NULL, 'Tetratricopeptide repeat/TPR repeat, putative', 140, NULL, NULL, 81325),
(81326, '2.30.42.10-FF-000390', NULL, NULL, 100, NULL, NULL, 81326),
(81327, '1.20.120.1750-FF-000039', NULL, 'RBR-type E3 ubiquitin transferase', 65, NULL, NULL, 81327),
(81328, '2.60.120.200-FF-000810', NULL, 'Putative L-type lectin-domain containing receptor kinase S.5', 273, NULL, NULL, 81328),
(81329, '1.25.40.10-FF-003042', NULL, 'Pentatricopeptide repeat-containing protein ATP4, chloroplastic', 91, NULL, NULL, 81329),
(81330, '3.40.50.1820-FF-000406', NULL, 'Uncharacterized protein', 312, NULL, NULL, 81330),
(81331, '1.10.1300.10-FF-000066', NULL, 'Uncharacterized protein', 131, NULL, NULL, 81331),
(81332, '2.10.25.10-FF-000238', NULL, 'Hemicentin 1', 44, NULL, NULL, 81332),
(81333, '1.10.8.10-FF-000200', NULL, 'Protein CBG01857', 49, NULL, NULL, 81333),
(81334, '2.20.100.10-FF-000107', NULL, 'Uncharacterized protein, isoform C', 54, NULL, NULL, 81334),
(81335, '2.40.50.140-FF-000817', NULL, NULL, 174, NULL, NULL, 81335),
(81336, '3.30.450.20-FF-000383', NULL, 'Phytochrome', 159, NULL, NULL, 81336),
(81337, '3.40.1470.10-FF-000002', NULL, NULL, 129, NULL, NULL, 81337),
(81338, '3.40.50.10490-FF-000140', NULL, NULL, 155, NULL, NULL, 81338),
(81339, '3.40.50.12780-FF-000170', NULL, 'SA protein', 428, NULL, NULL, 81339),
(81340, '1.20.1070.10-FF-000910', NULL, 'Si:dkey-7c18.10 protein', 181, NULL, NULL, 81340),
(81341, '3.40.630.30-FF-000313', NULL, 'Probable N-acetyltransferase camello', 130, NULL, NULL, 81341),
(81342, '3.30.230.10-FF-000173', NULL, 'DNA repair protein RadA', 167, NULL, NULL, 81342),
(81343, '4.10.280.10-FF-000120', NULL, 'Spermatogenesis and oogenesis specific basic helix-loop-helix 1', 78, NULL, NULL, 81343),
(81344, '2.40.160.40-FF-000003', NULL, 'Outer membrane porin G', 280, NULL, NULL, 81344),
(81345, '3.80.20.20-FF-000074', NULL, 'Receptor protein-tyrosine kinase', 116, NULL, NULL, 81345),
(81346, '3.30.420.40-FF-000887', NULL, 'Uncharacterized protein', 18, NULL, NULL, 81346),
(81347, '2.60.40.10-FF-005420', NULL, NULL, 127, NULL, NULL, 81347),
(81348, '3.40.50.150-FF-001115', NULL, NULL, 101, NULL, NULL, 81348),
(81349, '3.90.176.10-FF-000009', NULL, 'NAD(P)(+)--arginine ADP-ribosyltransferase', 231, NULL, NULL, 81349),
(81350, '3.30.200.20-FF-001180', NULL, 'Cyclin-dependent kinase 7', 44, NULL, NULL, 81350),
(81351, '2.60.40.10-FF-001137', NULL, 'Receptor protein-tyrosine phosphatase 10d', 94, NULL, NULL, 81351),
(81352, '3.40.50.170-FF-000019', NULL, 'Methionyl-tRNA formyltransferase', 208, NULL, NULL, 81352),
(81353, '3.40.367.20-FF-000046', NULL, 'Uncharacterized protein', 155, NULL, NULL, 81353),
(81354, '2.160.20.10-FF-000299', NULL, 'Uncharacterized protein', 143, NULL, NULL, 81354),
(81355, '2.40.40.20-FF-000011', NULL, 'Formate dehydrogenase, alpha subunit', 117, NULL, NULL, 81355),
(81356, '2.60.40.1400-FF-000035', NULL, NULL, 11, NULL, NULL, 81356),
(81357, '2.60.40.10-FF-003166', NULL, NULL, 94, NULL, NULL, 81357),
(81358, '1.25.40.10-FF-004565', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 199, NULL, NULL, 81358),
(81359, '2.40.160.50-FF-000006', NULL, 'Outer envelope protein 80, chloroplastic', 335, NULL, NULL, 81359),
(81360, '3.30.420.40-FF-000792', NULL, 'YALI0E13255p', 120, NULL, NULL, 81360),
(81361, '1.20.900.10-FF-000054', NULL, 'CDC-42 Guanine nucleotide Exchange Factor', 190, NULL, NULL, 81361),
(81362, '3.40.190.10-FF-000756', NULL, 'Transferrin', 71, NULL, NULL, 81362),
(81363, '3.40.50.720-FF-000460', NULL, '3-oxoacyl-[acyl-carrier-protein] reductase FabG1', 248, NULL, NULL, 81363),
(81364, '3.40.50.300-FF-003650', NULL, 'Hypothetical alanine and arginine rich protein', 171, NULL, NULL, 81364),
(81365, '3.90.1580.10-FF-000015', NULL, 'Chaperone protein LppX', 259, NULL, NULL, 81365),
(81366, '2.130.10.10-FF-001115', NULL, 'Intraflagellar transport 80 homolog (Chlamydomonas)', 135, NULL, NULL, 81366),
(81367, '3.80.10.10-FF-000564', NULL, 'P53-induced death domain protein 1', 169, NULL, NULL, 81367);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(81368, '2.20.100.10-FF-000012', NULL, 'Adhesion G protein-coupled receptor B2', 45, NULL, NULL, 81368),
(81369, '3.30.160.60-FF-000974', NULL, 'zinc finger protein 582 isoform X2', 29, NULL, NULL, 81369),
(81370, '1.20.58.1120-FF-000011', NULL, 'Dynein, axonemal, heavy chain 6', 146, NULL, NULL, 81370),
(81371, '3.90.226.10-FF-000138', NULL, 'Putative 3-hydroxybutyryl-CoA dehydratase', 251, NULL, NULL, 81371),
(81372, '1.10.510.10-FF-001139', NULL, 'Protein kinase domain containing, cytoplasmic', 170, NULL, NULL, 81372),
(81373, '1.10.630.10-FF-000114', NULL, 'Os06g0642500 protein', 286, NULL, NULL, 81373),
(81374, '3.30.160.60-FF-005274', NULL, NULL, 28, NULL, NULL, 81374),
(81375, '1.25.40.10-FF-003137', NULL, 'Uncharacterized protein', 123, NULL, NULL, 81375),
(81376, '1.10.287.70-FF-000086', NULL, 'Polycystic kidney disease 2', 122, NULL, NULL, 81376),
(81377, '3.40.50.80-FF-000106', NULL, 'Ferric reductase transmembrane component', 111, NULL, NULL, 81377),
(81378, '3.30.1520.10-FF-000065', NULL, 'PX domain protein (AFU_orthologue AFUA_2G07450)', 120, NULL, NULL, 81378),
(81379, '2.40.30.300-FF-000002', NULL, 'superkiller viralicidic activity 2-like 2', 122, NULL, NULL, 81379),
(81380, '2.30.280.10-FF-000011', NULL, NULL, 95, NULL, NULL, 81380),
(81381, '1.10.8.100-FF-000030', NULL, 'rRNA adenine N(6)-methyltransferase', 85, NULL, NULL, 81381),
(81382, '1.20.1560.10-FF-000329', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 301, NULL, NULL, 81382),
(81383, '1.10.555.10-FF-000040', NULL, 'Family with sequence similarity 13 member A', 234, NULL, NULL, 81383),
(81384, '3.40.850.10-FF-000094', NULL, 'Kinesin-like protein', 169, NULL, NULL, 81384),
(81385, '1.25.40.10-FF-004239', NULL, 'Predicted protein', 243, NULL, NULL, 81385),
(81386, '1.20.1730.10-FF-000034', NULL, 'Sodium:solute symporter', 512, NULL, NULL, 81386),
(81387, '2.60.40.420-FF-000075', NULL, 'hephaestin isoform X2', 156, NULL, NULL, 81387),
(81388, '3.10.20.90-FF-000867', NULL, 'Uncharacterized protein', 70, NULL, NULL, 81388),
(81389, '3.40.50.300-FF-001407', NULL, 'ZGRF1 isoform 9', 271, NULL, NULL, 81389),
(81390, '1.20.1250.10-FF-000003', NULL, 'Prolactin', 202, NULL, NULL, 81390),
(81391, '3.30.40.10-FF-000826', NULL, 'Peroxisome biogenesis factor 2', 78, NULL, NULL, 81391),
(81392, '3.30.56.10-FF-000037', NULL, 'Phenylalanine--tRNA ligase beta subunit', 72, NULL, NULL, 81392),
(81393, '3.40.50.80-FF-000095', NULL, 'Uncharacterized protein', 190, NULL, NULL, 81393),
(81394, '1.25.40.180-FF-000171', NULL, NULL, 191, NULL, NULL, 81394),
(81395, '1.10.10.10-FF-000628', NULL, 'LysR family transcriptional regulator', 87, NULL, NULL, 81395),
(81396, '1.10.1370.10-FF-000014', NULL, 'Thimet oligopeptidase 1', 161, NULL, NULL, 81396),
(81397, '3.10.450.50-FF-000048', NULL, 'Anthranilate 1,2-dioxygenase small subunit', 159, NULL, NULL, 81397),
(81398, '1.10.10.60-FF-001093', NULL, NULL, 72, NULL, NULL, 81398),
(81399, '3.40.50.300-FF-005095', NULL, 'Uncharacterized protein', 269, NULL, NULL, 81399),
(81400, '3.30.70.330-FF-002625', NULL, NULL, 127, NULL, NULL, 81400),
(81401, '3.30.70.330-FF-001102', NULL, 'Cleavage and Polyadenylation Factor', 109, NULL, NULL, 81401),
(81402, '2.10.109.10-FF-000040', NULL, 'Signal peptidase I', 128, NULL, NULL, 81402),
(81403, '3.30.40.10-FF-002064', NULL, 'Uncharacterized protein', 89, NULL, NULL, 81403),
(81404, '1.10.510.10-FF-001465', NULL, 'Uncharacterized protein', 329, NULL, NULL, 81404),
(81405, '3.40.50.720-FF-000555', NULL, 'Probable 2-ketogluconate reductase', 120, NULL, NULL, 81405),
(81406, '2.60.40.1120-FF-000058', NULL, 'Gram-negative bacterial tonB protein', 78, NULL, NULL, 81406),
(81407, '3.40.50.150-FF-000013', NULL, 'Spermidine synthase', 228, NULL, NULL, 81407),
(81408, '3.40.50.300-FF-004847', NULL, 'RuvB-like helicase', 192, NULL, NULL, 81408),
(81409, '3.30.710.10-FF-000215', NULL, 'CRE-KVS-1 protein', 137, NULL, NULL, 81409),
(81410, '3.30.70.3290-FF-000007', NULL, 'Putative polyketide synthase MbtD', 105, NULL, NULL, 81410),
(81411, '3.30.160.60-FF-001249', NULL, 'CTCF', 29, NULL, NULL, 81411);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(81412, '1.10.150.20-FF-000075', NULL, 'Meiotic recombination protein DMC1', 75, NULL, NULL, 81412),
(81413, '2.10.70.10-FF-000202', NULL, 'Uncharacterized protein', 71, NULL, NULL, 81413),
(81414, '3.40.50.1480-FF-000029', NULL, NULL, 75, NULL, NULL, 81414),
(81415, '2.170.130.10-FF-000057', NULL, NULL, 141, NULL, NULL, 81415),
(81416, '3.30.160.60-FF-001800', NULL, 'Zinc finger protein 467', 29, NULL, NULL, 81416),
(81417, '1.10.8.430-FF-000010', NULL, 'Transmembrane receptors / ATP binding protein', 90, NULL, NULL, 81417),
(81418, '1.10.238.10-FF-000938', NULL, 'Putative calcium-binding protein CML47', 137, NULL, NULL, 81418),
(81419, '2.60.98.60-FF-000003', NULL, 'EFF-1A', 55, NULL, NULL, 81419),
(81420, '3.30.70.360-FF-000009', NULL, 'aminoacylase-1 isoform X1', 112, NULL, NULL, 81420),
(81421, '3.30.70.3270-FF-000001', NULL, 'NADH-quinone oxidoreductase subunit I 1', 124, NULL, NULL, 81421),
(81422, '1.20.1560.10-FF-000543', NULL, 'Uncharacterized protein', 474, NULL, NULL, 81422),
(81423, '2.130.10.10-FF-002638', NULL, 'Predicted protein', 343, NULL, NULL, 81423),
(81424, '2.60.40.10-FF-001463', NULL, 'Probable beta-D-xylosidase 2', 119, NULL, NULL, 81424),
(81425, '3.30.70.330-FF-000922', NULL, 'RNA binding protein', 92, NULL, NULL, 81425),
(81426, '3.30.200.20-FF-000348', NULL, 'Serine/threonine protein kinase', 82, NULL, NULL, 81426),
(81427, '2.60.120.200-FF-000456', NULL, 'AGRin (Synaptic protein) homolog', 186, NULL, NULL, 81427),
(81428, '3.10.450.40-FF-000045', NULL, 'Amine oxidase', 115, NULL, NULL, 81428),
(81429, '3.40.50.720-FF-001983', NULL, 'Uncharacterized protein', 247, NULL, NULL, 81429),
(81430, '3.40.50.150-FF-001441', NULL, NULL, 145, NULL, NULL, 81430),
(81431, '2.40.50.140-FF-000138', NULL, 'Protection of telomeres 1 homolog', 150, NULL, NULL, 81431),
(81432, '4.10.260.10-FF-000006', NULL, 'Guanine nucleotide-binding protein subunit gamma', 69, NULL, NULL, 81432),
(81433, '3.40.50.300-FF-003436', NULL, 'ABC transporter ATP-binding protein', 250, NULL, NULL, 81433),
(81434, '1.10.287.370-FF-000007', NULL, 'UXT isoform 1', 138, NULL, NULL, 81434),
(81435, '1.10.630.10-FF-000440', NULL, 'Uncharacterized protein', 181, NULL, NULL, 81435),
(81436, '2.60.40.10-FF-003380', NULL, NULL, 81, NULL, NULL, 81436),
(81437, '2.130.10.10-FF-001441', NULL, 'Protein TRANSPARENT TESTA GLABRA, putative', 316, NULL, NULL, 81437),
(81438, '3.20.20.190-FF-000063', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', 202, NULL, NULL, 81438),
(81439, '3.40.50.11660-FF-000058', NULL, NULL, 217, NULL, NULL, 81439),
(81440, '3.40.50.1980-FF-000089', NULL, 'Periplasmic solute binding family protein', 106, NULL, NULL, 81440),
(81441, '3.30.70.1040-FF-000001', NULL, 'Dystroglycan 1', 135, NULL, NULL, 81441),
(81442, '3.40.50.1460-FF-000023', NULL, 'Lys-gingipain W83', 241, NULL, NULL, 81442),
(81443, '3.40.50.410-FF-000243', NULL, 'VWA domain containing CoxE-like protein', 141, NULL, NULL, 81443),
(81444, '2.30.30.40-FF-000618', NULL, 'Discs, large homolog 4a (Drosophila)', 47, NULL, NULL, 81444),
(81445, '1.20.1050.60-FF-000008', NULL, 'Alpha-1,2-mannosidase, putative', 88, NULL, NULL, 81445),
(81446, '3.40.50.300-FF-003324', NULL, 'Rab family GTPase', 190, NULL, NULL, 81446),
(81447, '3.30.2350.10-FF-000018', NULL, 'tRNA pseudouridine synthase B', 238, NULL, NULL, 81447),
(81448, '1.20.120.610-FF-000027', NULL, 'Uncharacterized protein', 63, NULL, NULL, 81448),
(81449, '2.60.120.260-FF-000660', NULL, 'Beta-galactosidase', 164, NULL, NULL, 81449),
(81450, '3.30.40.10-FF-000147', NULL, 'Ubiquitin carboxyl-terminal hydrolase 16', 125, NULL, NULL, 81450),
(81451, '4.10.60.10-FF-000265', NULL, 'Predicted protein', 58, NULL, NULL, 81451),
(81452, '3.40.640.10-FF-000494', NULL, 'Uncharacterized protein', 270, NULL, NULL, 81452),
(81453, '1.10.510.10-FF-000864', NULL, 'Vps15 protein kinase', 192, NULL, NULL, 81453),
(81454, '3.30.1330.40-FF-000003', NULL, 'Putative aminoacrylate peracid reductase RutC', 128, NULL, NULL, 81454),
(81455, '1.20.1270.60-FF-000215', NULL, 'Uncharacterized protein', 39, NULL, NULL, 81455);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(81456, '3.40.50.720-FF-000229', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', 82, NULL, NULL, 81456),
(81457, '1.10.1080.10-FF-000025', NULL, 'Uncharacterized protein', 31, NULL, NULL, 81457),
(81458, '3.40.1110.10-FF-000402', NULL, NULL, 78, NULL, NULL, 81458),
(81459, '1.10.10.60-FF-001104', NULL, NULL, 103, NULL, NULL, 81459),
(81460, '3.40.366.10-FF-000070', NULL, 'Acyl transferase-like protein', 80, NULL, NULL, 81460),
(81461, '3.30.1330.50-FF-000006', NULL, '2-C-methyl-D-erythritol 2,4-cyclodiphosphate synthase', 162, NULL, NULL, 81461),
(81462, '3.40.850.10-FF-000431', NULL, 'Predicted protein', 154, NULL, NULL, 81462),
(81463, '1.20.58.60-FF-000516', NULL, 'Spectrin repeat containing, nuclear envelope 1a', 217, NULL, NULL, 81463),
(81464, '3.80.10.10-FF-001880', NULL, 'Leucine-rich transmembrane protein, putative', 123, NULL, NULL, 81464),
(81465, '1.20.1050.40-FF-000002', NULL, 'Oligopeptidase A', 125, NULL, NULL, 81465),
(81466, '2.30.29.30-FF-000180', NULL, 'Exocyst complex component 8', 111, NULL, NULL, 81466),
(81467, '3.50.7.10-FF-000048', NULL, NULL, 49, NULL, NULL, 81467),
(81468, '1.20.1070.10-FF-000573', NULL, 'SERotonin/octopamine receptor family', 300, NULL, NULL, 81468),
(81469, '3.30.70.330-FF-000585', NULL, 'Heterogeneous nuclear ribonucleoprotein Q', 91, NULL, NULL, 81469),
(81470, '1.20.1080.10-FF-000080', NULL, 'VM23, putative', 177, NULL, NULL, 81470),
(81471, '1.10.287.1150-FF-000012', NULL, 'Uncharacterized protein, isoform C', 95, NULL, NULL, 81471),
(81472, '1.10.287.10-FF-000012', NULL, 'Ataxin-3 homolog', 47, NULL, NULL, 81472),
(81473, '3.90.70.10-FF-000596', NULL, 'Uncharacterized protein', 195, NULL, NULL, 81473),
(81474, '1.10.472.10-FF-000645', NULL, 'Uncharacterized protein', 127, NULL, NULL, 81474),
(81475, '3.30.160.60-FF-003503', NULL, 'Zinc finger protein, putative', 28, NULL, NULL, 81475),
(81476, '3.30.70.1050-FF-000004', NULL, 'Trigger factor', 123, NULL, NULL, 81476),
(81477, '1.10.3660.10-FF-000003', NULL, 'Prephenate dehydrogenase', 108, NULL, NULL, 81477),
(81478, '3.40.50.620-FF-000093', NULL, 'Glutamyl-Q tRNA(Asp) synthetase', 290, NULL, NULL, 81478),
(81479, '3.40.50.1580-FF-000059', NULL, 'Probable purine-nucleoside phosphorylase', 241, NULL, NULL, 81479),
(81480, '3.30.40.10-FF-002176', NULL, 'TNF receptor-associated factor', 82, NULL, NULL, 81480),
(81481, '3.40.50.300-FF-000795', NULL, 'Tetratricopeptide repeat protein 25', 132, NULL, NULL, 81481),
(81482, '1.10.418.30-FF-000008', NULL, 'Predicted protein', 76, NULL, NULL, 81482),
(81483, '2.60.40.10-FF-004689', NULL, NULL, 51, NULL, NULL, 81483),
(81484, '2.40.50.140-FF-000464', NULL, 'Translation initiation factor 5A', 62, NULL, NULL, 81484),
(81485, '1.10.287.130-FF-000071', NULL, 'Sensor histidine kinase', 68, NULL, NULL, 81485),
(81486, '3.20.20.80-FF-000335', NULL, 'Beta-1,3-xylanase TXYA', 331, NULL, NULL, 81486),
(81487, '3.30.110.10-FF-000012', NULL, 'Uncharacterized protein', 96, NULL, NULL, 81487),
(81488, '1.10.10.10-FF-000954', NULL, 'Transcriptional regulator, MarR family', 146, NULL, NULL, 81488),
(81489, '2.130.10.10-FF-005156', NULL, 'Predicted protein', 140, NULL, NULL, 81489),
(81490, '3.40.50.2000-FF-000915', NULL, 'Mannosyltransferase', 163, NULL, NULL, 81490),
(81491, '3.30.40.10-FF-000714', NULL, 'Ubiquitinyl hydrolase 1', 121, NULL, NULL, 81491),
(81492, '2.130.10.10-FF-003470', NULL, 'Putative surface layer protein, with cytochrome c domain', 356, NULL, NULL, 81492),
(81493, '3.40.50.10330-FF-000120', NULL, 'Ceramide kinase-like isoform 7', 80, NULL, NULL, 81493),
(81494, '1.20.1050.130-FF-000043', NULL, 'Uncharacterized protein DpGSTS3', 202, NULL, NULL, 81494),
(81495, '2.130.10.10-FF-004881', NULL, 'Uncharacterized protein', 118, NULL, NULL, 81495),
(81496, '3.40.718.10-FF-000045', NULL, 'NAD (H)-specific isocitrate dehydrogenase gamma subunit', 211, NULL, NULL, 81496),
(81497, '3.50.50.60-FF-000605', NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', 219, NULL, NULL, 81497),
(81498, '4.10.240.10-FF-000011', NULL, 'Transcriptional activator of proteases prtT', 78, NULL, NULL, 81498); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(81499, '3.30.1680.40-FF-000001', NULL, 'Variant surface glycoprotein (VSG, atypical), putative', 44, NULL, NULL, 81499),
(81500, '3.40.50.720-FF-000134', NULL, 'K(+) efflux antiporter 2 chloroplastic', 165, NULL, NULL, 81500),
(81501, '1.10.10.10-FF-001229', NULL, 'RNA polymerase III subunit C3', 77, NULL, NULL, 81501),
(81502, '2.60.40.10-FF-003503', NULL, NULL, 89, NULL, NULL, 81502),
(81503, '3.30.110.20-FF-000015', NULL, 'AGAP002362-PA', 117, NULL, NULL, 81503),
(81504, '1.10.510.10-FF-001353', NULL, 'Predicted gene 6176', 279, NULL, NULL, 81504),
(81505, '2.10.25.10-FF-000143', NULL, 'Protein crumbs 1', 38, NULL, NULL, 81505),
(81506, '1.20.1420.30-FF-000056', NULL, 'Uncharacterized protein, isoform F', 175, NULL, NULL, 81506),
(81507, '3.40.800.10-FF-000057', NULL, NULL, 85, NULL, NULL, 81507),
(81508, '2.10.25.10-FF-001649', NULL, 'Uncharacterized protein', 47, NULL, NULL, 81508),
(81509, '1.20.5.120-FF-000005', NULL, 'Proteasome activator subunit 1', 59, NULL, NULL, 81509),
(81510, '2.40.50.90-FF-000162', NULL, 'Uncharacterized protein', 154, NULL, NULL, 81510),
(81511, '1.20.5.110-FF-000002', NULL, 'Vesicle transport through interaction with t-SNAREsB', 81, NULL, NULL, 81511),
(81512, '1.25.10.10-FF-001202', NULL, 'Uncharacterized protein', 421, NULL, NULL, 81512),
(81513, '3.60.20.10-FF-000234', NULL, NULL, 99, NULL, NULL, 81513),
(81514, '2.130.10.10-FF-004667', NULL, 'Uncharacterized protein', 185, NULL, NULL, 81514),
(81515, '2.30.30.140-FF-000310', NULL, 'Tudor domain containing protein', 64, NULL, NULL, 81515),
(81516, '3.40.50.1820-FF-000069', NULL, 'monoacylglycerol lipase ABHD12', 236, NULL, NULL, 81516),
(81517, '3.30.160.60-FF-001912', NULL, 'Hamlet, isoform B', 26, NULL, NULL, 81517),
(81518, '3.80.10.10-FF-001975', NULL, 'Leucine-rich repeat protein lrrA', 92, NULL, NULL, 81518),
(81519, '1.25.10.10-FF-002697', NULL, 'Uncharacterized protein', 62, NULL, NULL, 81519),
(81520, '3.20.20.140-FF-000413', NULL, 'Dihydropyrimidinase', 86, NULL, NULL, 81520),
(81521, '1.10.10.10-FF-001443', NULL, 'Transcriptional regulator, LysR family', 85, NULL, NULL, 81521),
(81522, '2.30.30.940-FF-000011', NULL, 'Predicted protein', 72, NULL, NULL, 81522),
(81523, '3.40.50.620-FF-000188', NULL, 'Cytoplasmic tRNA 2-thiolation protein 1', 334, NULL, NULL, 81523),
(81524, '3.90.79.10-FF-000256', NULL, 'MutT/nudix family protein', 138, NULL, NULL, 81524),
(81525, '1.25.40.10-FF-002199', NULL, 'Uncharacterized protein', 279, NULL, NULL, 81525),
(81526, '2.60.40.10-FF-001351', NULL, 'Myomesin 3', 86, NULL, NULL, 81526),
(81527, '3.40.50.2000-FF-000236', NULL, 'Putative dolichyl-P-Man:GDP-Man1GlcNAc2-PP-dolichyl alpha-1,3-mannosyltransferase', 222, NULL, NULL, 81527),
(81528, '1.20.1250.20-FF-002035', NULL, 'Uncharacterized protein', 330, NULL, NULL, 81528),
(81529, '2.60.40.1490-FF-000005', NULL, 'Anti-silencing protein ASF 1 like protein', 155, NULL, NULL, 81529),
(81530, '2.60.260.20-FF-000079', NULL, 'Chaperone protein DnaJ', 117, NULL, NULL, 81530),
(81531, '1.10.510.10-FF-003505', NULL, NULL, 254, NULL, NULL, 81531),
(81532, '3.30.40.10-FF-002390', NULL, 'Predicted protein', 59, NULL, NULL, 81532),
(81533, '3.40.1190.20-FF-000056', NULL, 'Ribokinase', 300, NULL, NULL, 81533),
(81534, '3.40.50.150-FF-000598', NULL, 'Tetracenpmycin polyketide synthesis 8-o-methyltransferase', 249, NULL, NULL, 81534),
(81535, '3.30.70.330-FF-002951', NULL, NULL, 108, NULL, NULL, 81535),
(81536, '1.25.40.10-FF-001013', NULL, 'Probable UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SPINDLY', 70, NULL, NULL, 81536),
(81537, '1.20.1540.10-FF-000008', NULL, 'RHOMBOID-like protein 13', 195, NULL, NULL, 81537),
(81538, '3.20.20.80-FF-000094', NULL, 'Endo-1,4-beta-xylanase', 301, NULL, NULL, 81538),
(81539, '3.30.200.20-FF-000786', NULL, 'Protein kinase domain protein', 95, NULL, NULL, 81539),
(81540, '3.40.50.2000-FF-000562', NULL, 'Glycosyltransferase', 219, NULL, NULL, 81540),
(81541, '3.30.230.10-FF-000285', NULL, 'Elongation factor G 2', 136, NULL, NULL, 81541),
(81542, '2.10.25.10-FF-000126', NULL, 'Matrilin 3', 39, NULL, NULL, 81542);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(81543, '3.40.1800.20-FF-000020', NULL, 'LD21421p', 77, NULL, NULL, 81543),
(81544, '1.10.472.80-FF-000042', NULL, 'carabin isoform X2', 145, NULL, NULL, 81544),
(81545, '1.50.10.20-FF-000045', NULL, 'Prenyltransferase and squalene oxidase repeat family protein', 369, NULL, NULL, 81545),
(81546, '3.30.170.10-FF-000004', NULL, 'Cyclin-dependent kinases regulatory subunit', 63, NULL, NULL, 81546),
(81547, '3.80.10.10-FF-000452', NULL, 'Probable LRR receptor-like serine/threonine-protein kinase RFK1', 164, NULL, NULL, 81547),
(81548, '1.25.40.10-FF-005054', NULL, 'Pentatricopeptide repeat-containing protein At4g20090', 111, NULL, NULL, 81548),
(81549, '1.10.2000.10-FF-000021', NULL, 'Blast:Protein smoothened', 128, NULL, NULL, 81549),
(81550, '1.10.437.10-FF-000041', NULL, 'Predicted protein', 94, NULL, NULL, 81550),
(81551, '2.40.50.140-FF-000705', NULL, NULL, 60, NULL, NULL, 81551),
(81552, '2.60.40.10-FF-001249', NULL, 'Tenascin R', 89, NULL, NULL, 81552),
(81553, '3.40.50.300-FF-007461', NULL, 'Uncharacterized protein', 319, NULL, NULL, 81553),
(81554, '1.50.10.10-FF-000042', NULL, 'Unsaturated chondroitin disaccharide hydrolase', 396, NULL, NULL, 81554),
(81555, '3.40.50.10810-FF-000186', NULL, 'SWF/SNF family helicase', 301, NULL, NULL, 81555),
(81556, '1.10.150.220-FF-000014', NULL, NULL, 53, NULL, NULL, 81556),
(81557, '3.30.160.20-FF-000164', NULL, 'Nkrf protein, putative', 80, NULL, NULL, 81557),
(81558, '1.10.510.10-FF-001802', NULL, 'Predicted protein', 181, NULL, NULL, 81558),
(81559, '3.30.70.330-FF-000259', NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', 81, NULL, NULL, 81559),
(81560, '3.30.710.10-FF-000092', NULL, 'Germ cell-less, spermatogenesis associated 1', 125, NULL, NULL, 81560),
(81561, '1.10.150.20-FF-000092', NULL, 'DNA excision repair protein Rad2', 68, NULL, NULL, 81561),
(81562, '3.30.70.370-FF-000029', NULL, NULL, 28, NULL, NULL, 81562),
(81563, '3.30.70.330-FF-002737', NULL, NULL, 95, NULL, NULL, 81563),
(81564, '3.40.50.720-FF-000572', NULL, '2-dehydropantoate 2-reductase', 183, NULL, NULL, 81564),
(81565, '3.40.1180.10-FF-000013', NULL, 'Alkyl transferase', 241, NULL, NULL, 81565),
(81566, '1.20.120.1240-FF-000072', NULL, 'Uncharacterized protein', 148, NULL, NULL, 81566),
(81567, '2.60.40.60-FF-000848', NULL, 'Uncharacterized protein', 55, NULL, NULL, 81567),
(81568, '3.40.190.10-FF-000644', NULL, 'Extracellular solute-binding protein family 1', 165, NULL, NULL, 81568),
(81569, '1.20.1450.10-FF-000001', NULL, 'Particulate methane monooxygenase beta subunit', 248, NULL, NULL, 81569),
(81570, '2.60.450.10-FF-000017', NULL, 'Lipopolysaccharide export system protein LptC', 126, NULL, NULL, 81570),
(81571, '3.40.250.10-FF-000014', NULL, 'Adenylyltransferase and sulfurtransferase MOCS3', 119, NULL, NULL, 81571),
(81572, '1.25.40.20-FF-001358', NULL, 'Similar to ankyrin homolog [precursor]', 99, NULL, NULL, 81572),
(81573, '1.10.2020.20-FF-000019', NULL, NULL, 111, NULL, NULL, 81573),
(81574, '3.30.70.360-FF-000026', NULL, 'Putative peptidase M20/M25/M40', 128, NULL, NULL, 81574),
(81575, '3.90.640.10-FF-000252', NULL, 'Actin-related protein 8', 94, NULL, NULL, 81575),
(81576, '3.30.470.20-FF-000171', NULL, 'Carbamoyl-phosphate synthase large chain', 299, NULL, NULL, 81576),
(81577, '2.60.40.60-FF-001124', NULL, 'Dachsous cadherin-related 2', 112, NULL, NULL, 81577),
(81578, '1.20.1160.11-FF-000008', NULL, 'Paired amphipathic helix protein Sin3', 66, NULL, NULL, 81578),
(81579, '3.10.100.10-FF-000179', NULL, 'Surfactant protein A', 147, NULL, NULL, 81579),
(81580, '2.40.128.20-FF-000012', NULL, 'Alpha-1-acid glycoprotein 2', 174, NULL, NULL, 81580),
(81581, '3.30.230.70-FF-000067', NULL, 'Polyribonucleotide nucleotidyltransferase', 349, NULL, NULL, 81581),
(81582, '3.30.60.90-FF-000014', NULL, 'E3 ubiquitin-protein ligase PRT1', 66, NULL, NULL, 81582),
(81583, '2.130.10.10-FF-003032', NULL, 'WD repeat-containing protein GTS1', 157, NULL, NULL, 81583),
(81584, '1.20.1250.20-FF-000348', NULL, '1-acyl-sn-glycerol-3-phosphate acyltransferase', 414, NULL, NULL, 81584);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(81585, '1.25.10.10-FF-000100', NULL, 'phosphoinositide 3-kinase regulatory subunit 4', 211, NULL, NULL, 81585),
(81586, '3.40.50.300-FF-003419', NULL, 'DNA helicase 2', 131, NULL, NULL, 81586),
(81587, '3.80.10.10-FF-004049', NULL, 'Predicted protein', 138, NULL, NULL, 81587),
(81588, '3.90.190.10-FF-000273', NULL, 'Receptor protein-tyrosine phosphatase 10D, putative', 93, NULL, NULL, 81588),
(81589, '1.25.40.10-FF-000849', NULL, 'Pre-mRNA-splicing factor SYF1', 68, NULL, NULL, 81589),
(81590, '3.80.10.10-FF-002481', NULL, 'Peroxidasin like', 56, NULL, NULL, 81590),
(81591, '2.130.10.110-FF-000015', NULL, 'Clathrin heavy chain 1', 368, NULL, NULL, 81591),
(81592, '3.30.420.10-FF-000226', NULL, 'Exodeoxyribonuclease I', 192, NULL, NULL, 81592),
(81593, '2.40.10.10-FF-000198', NULL, 'Glandular kallikrein-10', 106, NULL, NULL, 81593),
(81594, '1.25.40.20-FF-001128', NULL, 'VPS9 domain protein, putative (AFU_orthologue AFUA_1G09870)', 182, NULL, NULL, 81594),
(81595, '3.40.30.10-FF-001186', NULL, 'Glutathione peroxidase', 109, NULL, NULL, 81595),
(81596, '4.10.240.10-FF-000123', NULL, 'Weak acid response element-binding transcriptional factor, putative', 72, NULL, NULL, 81596),
(81597, '2.60.40.10-FF-005403', NULL, NULL, 43, NULL, NULL, 81597),
(81598, '3.30.870.10-FF-000159', NULL, 'Uncharacterized protein', 117, NULL, NULL, 81598),
(81599, '3.30.780.10-FF-000040', NULL, 'Eukaryotic translation initiation factor 2D', 86, NULL, NULL, 81599),
(81600, '2.30.42.10-FF-000047', NULL, 'MAGUK p55 subfamily member 6', 86, NULL, NULL, 81600),
(81601, '3.40.50.170-FF-000036', NULL, 'Phosphoribosylglycinamide formyltransferase', 211, NULL, NULL, 81601),
(81602, '2.60.40.10-FF-004577', NULL, NULL, 97, NULL, NULL, 81602),
(81603, '2.30.29.220-FF-000001', NULL, 'FACT complex subunit SSRP1', 82, NULL, NULL, 81603),
(81604, '1.10.287.70-FF-000209', NULL, 'Uncharacterized protein, isoform B', 302, NULL, NULL, 81604),
(81605, '3.30.420.370-FF-000002', NULL, 'Type II secretion system protein L', 75, NULL, NULL, 81605),
(81606, '3.40.50.300-FF-007702', NULL, 'Uncharacterized protein YddE', 102, NULL, NULL, 81606),
(81607, '3.40.50.1110-FF-000053', NULL, 'Spore gernimation protein', 204, NULL, NULL, 81607),
(81608, '2.60.120.200-FF-000670', NULL, 'Uncharacterized protein', 64, NULL, NULL, 81608),
(81609, '3.40.140.70-FF-000001', NULL, 'Ubiquitin-like modifier-activating enzyme atg7', 166, NULL, NULL, 81609),
(81610, '3.40.33.10-FF-000023', NULL, 'Pathogenesis-related protein-1-like', 138, NULL, NULL, 81610),
(81611, '2.160.20.10-FF-000187', NULL, 'Uncharacterized protein', 399, NULL, NULL, 81611),
(81612, '3.30.70.270-FF-000213', NULL, NULL, 100, NULL, NULL, 81612),
(81613, '1.25.10.10-FF-001623', NULL, 'Pumilio-like 24 isoform A', 501, NULL, NULL, 81613),
(81614, '1.10.1450.10-FF-000178', NULL, 'Tetraspanin', 83, NULL, NULL, 81614),
(81615, '2.60.40.10-FF-003149', NULL, 'Uncharacterized protein', 90, NULL, NULL, 81615),
(81616, '1.10.10.10-FF-001117', NULL, 'LysR family transcriptional regulator', 84, NULL, NULL, 81616),
(81617, '1.10.8.140-FF-000013', NULL, 'DNA-binding protein A3L02_08620', 104, NULL, NULL, 81617),
(81618, '2.130.10.10-FF-005510', NULL, 'Uncharacterized protein', 91, NULL, NULL, 81618),
(81619, '3.30.160.60-FF-002986', NULL, 'Zinc finger protein 208', 24, NULL, NULL, 81619),
(81620, '3.30.420.380-FF-000005', NULL, 'Type II secretion system protein L', 158, NULL, NULL, 81620),
(81621, '2.60.120.340-FF-000032', NULL, 'Predicted protein', 49, NULL, NULL, 81621),
(81622, '3.80.10.10-FF-000126', NULL, 'F-box/LRR-repeat protein 7 isoform X1', 242, NULL, NULL, 81622),
(81623, '2.130.10.10-FF-004779', NULL, 'Uncharacterized protein', 152, NULL, NULL, 81623),
(81624, '3.50.50.60-FF-000482', NULL, 'Succinate dehydrogenase complex, subunit A, flavoprotein (Fp)', 216, NULL, NULL, 81624),
(81625, '3.40.50.620-FF-000076', NULL, 'Universal stress protein G', 142, NULL, NULL, 81625),
(81626, '3.40.50.10090-FF-000008', NULL, 'Transcriptional regulator, putative', 109, NULL, NULL, 81626),
(81627, '1.20.58.900-FF-000036', NULL, 'Small G protein signaling modulator 3', 144, NULL, NULL, 81627);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(81628, '1.20.1250.20-FF-002147', NULL, 'Uncharacterized protein', 198, NULL, NULL, 81628),
(81629, '3.40.50.720-FF-002472', NULL, 'Lovastatin nonaketide synthase, polyketide synthase component', 277, NULL, NULL, 81629),
(81630, '3.30.160.60-FF-003262', NULL, 'Zinc finger protein 263', 40, NULL, NULL, 81630),
(81631, '1.25.40.10-FF-001125', NULL, 'Translation regulator (Cya5), putative', 118, NULL, NULL, 81631),
(81632, '2.40.50.40-FF-000057', NULL, 'Kismet, isoform E', 72, NULL, NULL, 81632),
(81633, '3.30.460.10-FF-000105', NULL, 'Putative tRNA nucleotidyltransferase', 170, NULL, NULL, 81633),
(81634, '1.25.40.10-FF-002553', NULL, 'Pentatricopeptide repeat-containing protein ATP4, chloroplastic', 158, NULL, NULL, 81634),
(81635, '3.30.420.390-FF-000008', NULL, 'DNA polymerase family A', 200, NULL, NULL, 81635),
(81636, '1.20.1580.10-FF-000005', NULL, 'UvrABC system protein A', 153, NULL, NULL, 81636),
(81637, '3.40.830.10-FF-000008', NULL, 'MEMO1 family protein C4H3.04c', 306, NULL, NULL, 81637),
(81638, '2.70.160.11-FF-000073', NULL, 'Protein arginine N-methyltransferase, putative', 174, NULL, NULL, 81638),
(81639, '3.10.200.10-FF-000001', NULL, 'Carbonic anhydrase 2', 261, NULL, NULL, 81639),
(81640, '4.10.1060.10-FF-000027', NULL, 'Zinc finger Ran-binding domain-containing protein 2', 23, NULL, NULL, 81640),
(81641, '2.120.10.30-FF-000469', NULL, 'Uncharacterized protein', 66, NULL, NULL, 81641),
(81642, '1.20.1070.10-FF-001984', NULL, 'Uncharacterized protein', 163, NULL, NULL, 81642),
(81643, '3.80.10.10-FF-002604', NULL, 'G-protein coupled receptor GRL101-like protein', 66, NULL, NULL, 81643),
(81644, '3.40.30.60-FF-000003', NULL, 'Flagellar biosynthesis protein FlhA', 143, NULL, NULL, 81644),
(81645, '2.60.40.10-FF-001704', NULL, 'Uncharacterized protein', 124, NULL, NULL, 81645),
(81646, '3.30.450.20-FF-000057', NULL, 'Voltage-dependent calcium channel subunit alpha-2/delta-4', 151, NULL, NULL, 81646),
(81647, '3.40.50.2000-FF-000466', NULL, '3-deoxy-D-manno-octulosonic acid transferase', 187, NULL, NULL, 81647),
(81648, '1.20.120.900-FF-000007', NULL, 'PEX19 chaperone-like protein', 117, NULL, NULL, 81648),
(81649, '3.40.50.2300-FF-000219', NULL, 'Glutamate metabotropic receptor 5', 316, NULL, NULL, 81649),
(81650, '3.40.50.1820-FF-000732', NULL, 'Lipase', 366, NULL, NULL, 81650),
(81651, '3.30.760.10-FF-000038', NULL, 'Eukaryotic translation initiation factor-like protein', 205, NULL, NULL, 81651),
(81652, '3.40.50.12280-FF-000014', NULL, 'Uncharacterized protein', 102, NULL, NULL, 81652),
(81653, '3.40.718.10-FF-000062', NULL, 'Isocitrate dehydrogenase, putative', 131, NULL, NULL, 81653),
(81654, '1.10.510.10-FF-003270', NULL, NULL, 107, NULL, NULL, 81654),
(81655, '1.10.510.10-FF-002988', NULL, NULL, 231, NULL, NULL, 81655),
(81656, '3.40.50.300-FF-000210', NULL, 'Si:dkey-16p6.1', 234, NULL, NULL, 81656),
(81657, '1.10.132.20-FF-000010', NULL, 'Ribosomal recycling factor, mitochondrial, putative', 100, NULL, NULL, 81657),
(81658, '3.30.40.10-FF-000259', NULL, 'E3 ubiquitin protein ligase RIN2', 80, NULL, NULL, 81658),
(81659, '1.10.510.10-FF-002781', NULL, NULL, 208, NULL, NULL, 81659),
(81660, '1.25.40.10-FF-004891', NULL, 'Uncharacterized protein', 96, NULL, NULL, 81660),
(81661, '3.20.20.100-FF-000093', NULL, 'Aldose reductase', 296, NULL, NULL, 81661),
(81662, '3.40.50.720-FF-000117', NULL, 'N-acetyl-gamma-glutamyl-phosphate reductase', 164, NULL, NULL, 81662),
(81663, '1.20.970.10-FF-000002', NULL, 'Pyrimidine-nucleoside phosphorylase', 67, NULL, NULL, 81663),
(81664, '3.40.50.300-FF-006859', NULL, 'Branched-chain amino acid ABC transporter, ATP-binding protein, putative', 256, NULL, NULL, 81664),
(81665, '1.20.58.60-FF-000421', NULL, 'Nesprin-1', 296, NULL, NULL, 81665),
(81666, '3.40.50.300-FF-007135', NULL, 'Predicted protein', 180, NULL, NULL, 81666),
(81667, '3.40.50.720-FF-002146', NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', 89, NULL, NULL, 81667),
(81668, '1.25.10.10-FF-003214', NULL, 'Uncharacterized protein', 274, NULL, NULL, 81668),
(81669, '1.10.132.30-FF-000013', NULL, 'DNA-directed RNA polymerase I largest subunit', 76, NULL, NULL, 81669);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(81670, '1.20.58.60-FF-000628', NULL, 'Spectrin repeat-containing, nuclear envelope 1b', 289, NULL, NULL, 81670),
(81671, '3.60.60.10-FF-000001', NULL, 'Secernin 1', 306, NULL, NULL, 81671),
(81672, '3.30.465.10-FF-000083', NULL, 'HlyC/CorC family transporter', 85, NULL, NULL, 81672),
(81673, '3.30.420.40-FF-000915', NULL, 'Actin-related protein 4', 28, NULL, NULL, 81673),
(81674, '2.10.25.10-FF-001666', NULL, 'Uncharacterized protein', 45, NULL, NULL, 81674),
(81675, '1.20.58.900-FF-000019', NULL, 'Pinstripe, isoform A', 166, NULL, NULL, 81675),
(81676, '3.40.50.300-FF-001519', NULL, 'ORC1-type DNA replication protein', 95, NULL, NULL, 81676),
(81677, '3.40.225.10-FF-000052', NULL, NULL, 194, NULL, NULL, 81677),
(81678, '1.10.3370.10-FF-000014', NULL, 'SecY protein transport family protein', 310, NULL, NULL, 81678),
(81679, '2.60.40.10-FF-002986', NULL, 'GD23248', 126, NULL, NULL, 81679),
(81680, '3.10.450.40-FF-000028', NULL, 'Amine oxidase', 116, NULL, NULL, 81680),
(81681, '3.40.50.2300-FF-000096', NULL, 'Transcriptional regulatory protein', 135, NULL, NULL, 81681),
(81682, '1.10.10.350-FF-000012', NULL, 'Glutamyl-tRNA synthetase', 122, NULL, NULL, 81682),
(81683, '1.25.40.10-FF-001451', NULL, 'Interferon-induced protein with tetratricopeptide repeats 3', 212, NULL, NULL, 81683),
(81684, '3.40.50.300-FF-003083', NULL, 'Uncharacterized protein, isoform B', 184, NULL, NULL, 81684),
(81685, '1.10.287.70-FF-000535', NULL, 'Two-pore potassium channel 4', 102, NULL, NULL, 81685),
(81686, '3.50.30.30-FF-000016', NULL, 'Ring finger protein 150', 161, NULL, NULL, 81686),
(81687, '1.25.40.20-FF-001454', NULL, 'Palmitoyltransferase', 127, NULL, NULL, 81687),
(81688, '1.20.1250.10-FF-000115', NULL, NULL, 157, NULL, NULL, 81688),
(81689, '1.10.472.10-FF-000319', NULL, 'Uncharacterized protein', 48, NULL, NULL, 81689),
(81690, '3.30.200.20-FF-002377', NULL, 'ADR379Cp', 93, NULL, NULL, 81690),
(81691, '1.25.10.10-FF-002725', NULL, 'Importin-beta N-terminal domain containing protein', 918, NULL, NULL, 81691),
(81692, '3.30.70.330-FF-002513', NULL, NULL, 68, NULL, NULL, 81692),
(81693, '3.40.30.10-FF-000230', NULL, 'Monothiol glutaredoxin, putative', 99, NULL, NULL, 81693),
(81694, '3.30.200.20-FF-000915', NULL, 'Mitogen-activated protein kinase', 88, NULL, NULL, 81694),
(81695, '1.10.3860.10-FF-000001', NULL, 'C4-dicarboxylate transport protein', 412, NULL, NULL, 81695),
(81696, '3.40.50.300-FF-001621', NULL, 'Dermatan sulfate epimerase-like', 288, NULL, NULL, 81696),
(81697, '1.10.1080.10-FF-000008', NULL, 'Glutathione synthetase', 96, NULL, NULL, 81697),
(81698, '1.10.1200.10-FF-000114', NULL, 'Acyl carrier protein', 97, NULL, NULL, 81698),
(81699, '1.20.80.60-FF-000006', NULL, 'Myosin regulatory light chain-interacting protein', 69, NULL, NULL, 81699),
(81700, '3.40.50.1460-FF-000040', NULL, 'CASP8 and FADD like apoptosis regulator', 151, NULL, NULL, 81700),
(81701, '3.30.230.10-FF-000414', NULL, 'DNA mismatch repair protein MutL', 122, NULL, NULL, 81701),
(81702, '1.20.20.10-FF-000027', NULL, 'ATP synthase subunit 9, mitochondrial', 74, NULL, NULL, 81702),
(81703, '3.60.15.10-FF-000054', NULL, 'Metallo-beta-lactamase superfamily protein', 218, NULL, NULL, 81703),
(81704, '3.40.50.1000-FF-000728', NULL, NULL, 77, NULL, NULL, 81704),
(81705, '3.30.70.270-FF-000090', NULL, 'Diguanylate cyclase TpbB', 160, NULL, NULL, 81705),
(81706, '1.10.150.910-FF-000007', NULL, 'CPSF (Cleavage and polyadenylation specific factor), subunit A, putative', 90, NULL, NULL, 81706),
(81707, '2.30.29.30-FF-000533', NULL, 'Pleckstrin homology domain-containing family G member 6', 88, NULL, NULL, 81707),
(81708, '2.60.120.200-FF-000344', NULL, 'Apical endosomal glycoprotein', 160, NULL, NULL, 81708),
(81709, '2.60.40.810-FF-000001', NULL, 'Protective antigen', 131, NULL, NULL, 81709),
(81710, '1.20.5.170-FF-000104', NULL, 'Probable SNF2-component of SWI/SNF global transcription activator complex', 99, NULL, NULL, 81710),
(81711, '1.10.287.630-FF-000007', NULL, 'Cyclic Nucleotide Gated channel', 65, NULL, NULL, 81711),
(81712, '2.40.30.170-FF-000025', NULL, 'Efflux transporter periplasmic adaptor subunit', 64, NULL, NULL, 81712);
INSERT INTO "PUBLIC"."MODEL" VALUES
(81713, '3.30.900.10-FF-000027', NULL, 'Uncharacterized protein', 82, NULL, NULL, 81713),
(81714, '2.40.70.10-FF-000527', NULL, NULL, 210, NULL, NULL, 81714),
(81715, '3.40.50.300-FF-004959', NULL, 'ABC transporter family protein', 210, NULL, NULL, 81715),
(81716, '1.20.1560.10-FF-000431', NULL, 'ABC transporter B family member 5', 23, NULL, NULL, 81716),
(81717, '3.80.10.10-FF-003892', NULL, 'LRR receptor-like serine/threonine-protein kinase RCH1', 146, NULL, NULL, 81717),
(81718, '2.30.110.10-FF-000111', NULL, 'Uncharacterized protein', 191, NULL, NULL, 81718),
(81719, '3.10.129.10-FF-000262', NULL, 'Acyl-[acyl-carrier-protein] hydrolase', 80, NULL, NULL, 81719),
(81720, '3.90.180.10-FF-000121', NULL, 'Predicted protein', 151, NULL, NULL, 81720),
(81721, '1.20.1080.10-FF-000063', NULL, 'Putative aquaporin PIP-type 7a', 132, NULL, NULL, 81721),
(81722, '3.40.190.10-FF-000970', NULL, 'Putative solute-binding lipoprotein', 198, NULL, NULL, 81722),
(81723, '1.20.120.220-FF-000017', NULL, 'ATP synthase subunit a', 166, NULL, NULL, 81723),
(81724, '2.130.10.10-FF-003239', NULL, 'Pre-mRNA-splicing factor RSE1', 390, NULL, NULL, 81724),
(81725, '1.20.1050.10-FF-000252', NULL, 'Uncharacterized protein', 28, NULL, NULL, 81725),
(81726, '1.10.10.60-FF-000278', NULL, 'HTH-type transcriptional regulator GadW', 105, NULL, NULL, 81726),
(81727, '2.30.42.10-FF-000614', NULL, NULL, 91, NULL, NULL, 81727),
(81728, '1.25.50.20-FF-000100', NULL, 'Uncharacterized protein', 168, NULL, NULL, 81728),
(81729, '3.40.50.620-FF-000430', NULL, 'Uncharacterized protein', 146, NULL, NULL, 81729),
(81730, '3.30.428.10-FF-000008', NULL, 'CWF19-like 2, cell cycle control', 135, NULL, NULL, 81730),
(81731, '2.30.30.100-FF-000085', NULL, 'Small nuclear ribonucleoprotein F', 73, NULL, NULL, 81731),
(81732, '6.20.10.30-FF-000004', NULL, 'DNA ligase', 38, NULL, NULL, 81732),
(81733, '3.30.160.60-FF-005291', NULL, NULL, 34, NULL, NULL, 81733),
(81734, '2.20.110.10-FF-000052', NULL, NULL, 46, NULL, NULL, 81734),
(81735, '2.130.10.10-FF-000289', NULL, 'WD40 repeat-containing protein SMU1', 207, NULL, NULL, 81735),
(81736, '1.20.1250.20-FF-000118', NULL, 'D-xylose-proton symporter-like 3, chloroplastic', 446, NULL, NULL, 81736),
(81737, '1.10.472.10-FF-000196', NULL, 'PHO85 cyclin CLG1', 182, NULL, NULL, 81737),
(81738, '2.40.10.480-FF-000001', NULL, 'Serine/threonine protein kinase', 71, NULL, NULL, 81738),
(81739, '1.20.1540.10-FF-000093', NULL, 'Rhomboid family protein', 200, NULL, NULL, 81739),
(81740, '3.40.50.1820-FF-000070', NULL, 'Carboxylesterase', 246, NULL, NULL, 81740),
(81741, '3.40.50.150-FF-000839', NULL, 'Methyltransferase', 288, NULL, NULL, 81741),
(81742, '3.80.10.10-FF-000340', NULL, 'Uncharacterized protein, isoform B', 227, NULL, NULL, 81742),
(81743, '3.40.50.620-FF-000637', NULL, 'tRNA-specific 2-thiouridylase MnmA 1', 205, NULL, NULL, 81743),
(81744, '3.30.160.60-FF-003475', NULL, NULL, 28, NULL, NULL, 81744),
(81745, '2.130.10.10-FF-000839', NULL, 'Uncharacterized protein, isoform A', 147, NULL, NULL, 81745),
(81746, '3.40.50.2000-FF-000674', NULL, 'UDP-glycosyltransferase 73C3', 205, NULL, NULL, 81746),
(81747, '3.30.40.10-FF-000585', NULL, 'ubiquitin carboxyl-terminal hydrolase 3 isoform X2', 87, NULL, NULL, 81747),
(81748, '3.10.129.10-FF-000048', NULL, '14-dihydroxy-2-naphthoyl-CoA thioesterase 1', 136, NULL, NULL, 81748),
(81749, '3.40.50.2300-FF-000663', NULL, 'Response regulator receiver', 99, NULL, NULL, 81749),
(81750, '1.10.287.70-FF-000440', NULL, 'Predicted protein', 222, NULL, NULL, 81750),
(81751, '3.90.660.10-FF-000040', NULL, 'Uncharacterized protein', 104, NULL, NULL, 81751),
(81752, '1.20.1070.10-FF-000135', NULL, 'galanin receptor type 1', 321, NULL, NULL, 81752),
(81753, '3.30.160.60-FF-001351', NULL, 'zinc finger protein 197 isoform X1', 30, NULL, NULL, 81753),
(81754, '2.60.120.10-FF-000133', NULL, 'Camp-dependent protein kinase type i regulatory subunit-like', 147, NULL, NULL, 81754),
(81755, '2.30.29.30-FF-000078', NULL, 'Guanine nucleotide exchange factor DBS', 155, NULL, NULL, 81755);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(81756, '1.10.1040.50-FF-000012', NULL, NULL, 140, NULL, NULL, 81756),
(81757, '3.40.850.10-FF-000335', NULL, 'Kinesin-like protein', 347, NULL, NULL, 81757),
(81758, '1.10.340.30-FF-000019', NULL, 'Base excision DNA repair protein, HhH-GPD family', 113, NULL, NULL, 81758),
(81759, '1.10.287.770-FF-000021', NULL, 'Pickpocket 20, isoform B', 58, NULL, NULL, 81759),
(81760, '3.40.50.620-FF-000643', NULL, 'Valyl tRNA synthetase', 123, NULL, NULL, 81760),
(81761, '3.40.50.300-FF-001172', NULL, 'Cystic fibrosis transmembrane conductance regulator', 251, NULL, NULL, 81761),
(81762, '1.20.1250.20-FF-001872', NULL, 'Uncharacterized protein', 108, NULL, NULL, 81762),
(81763, '1.25.40.10-FF-002766', NULL, 'Os01g0812500 protein', 172, NULL, NULL, 81763),
(81764, '2.130.10.10-FF-001345', NULL, 'WD40 repeat-like protein', 160, NULL, NULL, 81764),
(81765, '2.70.170.10-FF-000269', NULL, 'Uncharacterized protein', 126, NULL, NULL, 81765),
(81766, '1.10.287.130-FF-000200', NULL, 'Probable two-component sensor histidine kinase VicK', 83, NULL, NULL, 81766),
(81767, '2.60.490.10-FF-000008', NULL, 'P2X purinoceptor', 110, NULL, NULL, 81767),
(81768, '1.10.274.30-FF-000039', NULL, 'Protein CBG14008', 108, NULL, NULL, 81768),
(81769, '3.40.50.1820-FF-001694', NULL, 'Methylesterase 3', 192, NULL, NULL, 81769),
(81770, '2.60.470.10-FF-000013', NULL, 'Pickpocket 5, isoform C', 178, NULL, NULL, 81770),
(81771, '2.120.10.10-FF-000025', NULL, 'Probable sialidase', 320, NULL, NULL, 81771),
(81772, '2.60.120.260-FF-000659', NULL, 'Beta-galactosidase', 165, NULL, NULL, 81772),
(81773, '3.30.2460.20-FF-000012', NULL, 'Protein Wnt', 63, NULL, NULL, 81773),
(81774, '3.30.40.10-FF-000602', NULL, 'General transcription factor IIH subunit', 61, NULL, NULL, 81774),
(81775, '1.10.1060.10-FF-000013', NULL, 'NAD-dependent dihydropyrimidine dehydrogenase subunit PreT', 123, NULL, NULL, 81775),
(81776, '1.20.1510.10-FF-000057', NULL, 'Metal-ion transporter, putative', 211, NULL, NULL, 81776),
(81777, '3.30.70.20-FF-000096', NULL, NULL, 53, NULL, NULL, 81777),
(81778, '3.20.20.80-FF-000223', NULL, 'Glycoprotein endo-alpha-1,2-mannosidase', 351, NULL, NULL, 81778),
(81779, '2.30.42.10-FF-000165', NULL, 'Cytohesin-interacting protein isoform X1', 103, NULL, NULL, 81779),
(81780, '3.80.10.10-FF-003566', NULL, 'Uncharacterized protein', 146, NULL, NULL, 81780),
(81781, '3.40.50.2300-FF-000562', NULL, 'Uncharacterized protein', 177, NULL, NULL, 81781),
(81782, '3.30.420.10-FF-000108', NULL, 'DNA helicase, phage-associated', 175, NULL, NULL, 81782),
(81783, '3.10.20.870-FF-000011', NULL, NULL, 80, NULL, NULL, 81783),
(81784, '1.25.40.20-FF-001246', NULL, 'Uncharacterized protein', 238, NULL, NULL, 81784),
(81785, '1.20.58.60-FF-000393', NULL, 'VAB-10B protein', 106, NULL, NULL, 81785),
(81786, '1.25.40.20-FF-001566', NULL, 'Uncharacterized protein', 76, NULL, NULL, 81786),
(81787, '2.40.50.140-FF-000576', NULL, 'ABC transporter ATP-binding protein', 63, NULL, NULL, 81787),
(81788, '3.40.50.2020-FF-000101', NULL, 'Ribose-phosphate pyrophosphokinase, putative', 112, NULL, NULL, 81788),
(81789, '2.60.40.1730-FF-000111', NULL, NULL, 114, NULL, NULL, 81789),
(81790, '2.10.25.10-FF-001099', NULL, 'LDL receptor related protein 1B', 40, NULL, NULL, 81790),
(81791, '1.20.120.960-FF-000003', NULL, 'Sensor protein', 107, NULL, NULL, 81791),
(81792, '2.60.40.150-FF-000668', NULL, 'Uncharacterized protein', 77, NULL, NULL, 81792),
(81793, '1.10.287.70-FF-000541', NULL, 'Potassium channel, putative', 134, NULL, NULL, 81793),
(81794, '3.40.50.1760-FF-000023', NULL, NULL, 124, NULL, NULL, 81794),
(81795, '1.20.1560.10-FF-000105', NULL, 'ABC transporter B family member 25', 343, NULL, NULL, 81795),
(81796, '3.10.129.10-FF-000149', NULL, 'Putative thioesterase', 137, NULL, NULL, 81796),
(81797, '2.130.10.30-FF-000154', NULL, NULL, 160, NULL, NULL, 81797),
(81798, '2.130.10.10-FF-005044', NULL, 'Uncharacterized protein', 287, NULL, NULL, 81798),
(81799, '2.60.40.10-FF-004459', NULL, NULL, 126, NULL, NULL, 81799),
(81800, '3.30.160.60-FF-003380', NULL, NULL, 30, NULL, NULL, 81800);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(81801, '3.30.450.20-FF-000624', NULL, 'Uncharacterized protein', 84, NULL, NULL, 81801),
(81802, '1.25.40.10-FF-001243', NULL, 'Nuclear autoantigenic sperm protein (histone-binding)', 290, NULL, NULL, 81802),
(81803, '3.90.660.10-FF-000135', NULL, NULL, 35, NULL, NULL, 81803),
(81804, '1.20.1250.20-FF-000444', NULL, 'Integral membrane efflux protein', 215, NULL, NULL, 81804),
(81805, '3.30.160.60-FF-003048', NULL, NULL, 27, NULL, NULL, 81805),
(81806, '3.30.300.30-FF-000061', NULL, 'Fatty acid-CoA ligase', 100, NULL, NULL, 81806),
(81807, '3.30.1520.10-FF-000161', NULL, 'Uncharacterized protein', 133, NULL, NULL, 81807),
(81808, '3.40.50.800-FF-000040', NULL, 'DNA polymerase gamma 35kD', 104, NULL, NULL, 81808),
(81809, '1.20.5.170-FF-000110', NULL, 'BZIP-type transcription factor', 76, NULL, NULL, 81809),
(81810, '3.20.20.70-FF-000220', NULL, 'Glucan 1,4-alpha-glucosidase SusB', 429, NULL, NULL, 81810),
(81811, '3.30.70.600-FF-000020', NULL, '30S ribosomal protein S10', 103, NULL, NULL, 81811),
(81812, '2.60.120.290-FF-000090', NULL, 'Seizure 6-like protein', 119, NULL, NULL, 81812),
(81813, '1.10.510.10-FF-001241', NULL, 'Uncharacterized protein', 345, NULL, NULL, 81813),
(81814, '2.60.40.10-FF-003615', NULL, 'Kinase insert domain receptor like', 129, NULL, NULL, 81814),
(81815, '1.20.5.170-FF-000205', NULL, 'Uncharacterized protein', 95, NULL, NULL, 81815),
(81816, '3.30.70.330-FF-002384', NULL, NULL, 99, NULL, NULL, 81816),
(81817, '2.160.20.10-FF-000069', NULL, 'Uncharacterized protein', 367, NULL, NULL, 81817),
(81818, '3.80.10.10-FF-000008', NULL, 'CCR4-NOT transcription complex subunit 6 like', 142, NULL, NULL, 81818),
(81819, '2.40.50.1020-FF-000010', NULL, 'Response regulator', 110, NULL, NULL, 81819),
(81820, '3.40.350.10-FF-000078', NULL, 'Intermediate cleaving peptidase 55', 172, NULL, NULL, 81820),
(81821, '3.30.200.210-FF-000001', NULL, 'Periplasmic nitrate reductase', 124, NULL, NULL, 81821),
(81822, '2.60.120.200-FF-000232', NULL, 'MAM and LDL receptor class A domain containing 1', 182, NULL, NULL, 81822),
(81823, '2.30.30.100-FF-000208', NULL, 'Uncharacterized protein', 119, NULL, NULL, 81823),
(81824, '3.60.20.10-FF-000004', NULL, 'Proteasome subunit alpha type-4', 242, NULL, NULL, 81824),
(81825, '3.30.70.330-FF-000826', NULL, 'Translation initiation factor eIF4B', 102, NULL, NULL, 81825),
(81826, '1.10.10.2770-FF-000002', NULL, 'Selenocysteine-specific translation elongation factor', 118, NULL, NULL, 81826),
(81827, '3.10.10.10-FF-000051', NULL, NULL, 109, NULL, NULL, 81827),
(81828, '1.10.238.10-FF-001214', NULL, 'Uncharacterized protein', 201, NULL, NULL, 81828),
(81829, '3.40.50.1780-FF-000029', NULL, 'Putative iron-dependent hydrogenase', 131, NULL, NULL, 81829),
(81830, '1.20.1440.170-FF-000008', NULL, NULL, 94, NULL, NULL, 81830),
(81831, '3.40.50.620-FF-000542', NULL, 'FAD synthetase', 293, NULL, NULL, 81831),
(81832, '3.30.200.20-FF-000814', NULL, 'Fibroblast growth factor receptor 2', 130, NULL, NULL, 81832),
(81833, '1.20.1560.10-FF-000088', NULL, 'Thiol reductant ABC exporter subunit CydD', 310, NULL, NULL, 81833),
(81834, '2.60.40.150-FF-000781', NULL, 'Uncharacterized protein', 97, NULL, NULL, 81834),
(81835, '1.25.10.10-FF-003085', NULL, 'AGAP004782-PA', 551, NULL, NULL, 81835),
(81836, '1.10.287.70-FF-000327', NULL, 'Voltage-gated Ion Channel (VIC) Superfamily', 234, NULL, NULL, 81836),
(81837, '3.20.20.70-FF-000799', NULL, NULL, 216, NULL, NULL, 81837),
(81838, '3.30.420.10-FF-000013', NULL, 'protein argonaute 10-like', 292, NULL, NULL, 81838),
(81839, '1.10.220.150-FF-000055', NULL, 'uncharacterized protein LOC778851 isoform X2', 124, NULL, NULL, 81839),
(81840, '3.40.50.300-FF-005123', NULL, 'Nucleotide binding protein, putative', 248, NULL, NULL, 81840),
(81841, '3.20.20.150-FF-000080', NULL, 'Protein arginine N-methyltransferase', 245, NULL, NULL, 81841),
(81842, '1.20.120.1770-FF-000011', NULL, 'Protein CBG08803', 238, NULL, NULL, 81842),
(81843, '3.40.50.300-FF-001851', NULL, 'ATP-dependent helicase/nuclease subunit A', 146, NULL, NULL, 81843);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(81844, '3.40.50.150-FF-001553', NULL, NULL, 80, NULL, NULL, 81844),
(81845, '3.10.129.110-FF-000013', NULL, '6-deoxyerythronolide-B synthase EryA2, modules 3 and 4', 283, NULL, NULL, 81845),
(81846, '3.30.1520.10-FF-000048', NULL, 'sorting nexin-16 isoform X2', 76, NULL, NULL, 81846),
(81847, '1.10.418.10-FF-000149', NULL, 'Smoothelin-like 1', 78, NULL, NULL, 81847),
(81848, '3.30.559.10-FF-000104', NULL, 'Nonribosomal peptide synthase, putative', 168, NULL, NULL, 81848),
(81849, '3.40.50.2000-FF-000354', NULL, 'UDP-glucuronosyltransferase', 243, NULL, NULL, 81849),
(81850, '3.30.300.30-FF-000162', NULL, 'Flagellar M-Ring Protein', 84, NULL, NULL, 81850),
(81851, '1.20.1070.10-FF-000455', NULL, 'Transmembrane receptor', 314, NULL, NULL, 81851),
(81852, '1.10.510.10-FF-000976', NULL, 'Associated kinase of Tb14-3-3', 385, NULL, NULL, 81852),
(81853, '3.40.50.300-FF-005224', NULL, 'Rab_C43 protein', 204, NULL, NULL, 81853),
(81854, '3.40.1090.10-FF-000147', NULL, 'Uncharacterized protein', 87, NULL, NULL, 81854),
(81855, '3.30.1370.10-FF-000244', NULL, 'Uncharacterized protein', 201, NULL, NULL, 81855),
(81856, '3.30.200.20-FF-000578', NULL, 'Mitogen-activated protein kinase', 23, NULL, NULL, 81856),
(81857, '3.30.60.190-FF-000018', NULL, 'YALI0F07953p', 47, NULL, NULL, 81857),
(81858, '3.30.160.60-FF-001019', NULL, 'Zinc finger and BTB domain-containing protein 41', 27, NULL, NULL, 81858),
(81859, '2.40.50.90-FF-000044', NULL, 'Tapas, isoform B', 112, NULL, NULL, 81859),
(81860, '2.30.30.30-FF-000149', NULL, '60S ribosomal protein L6', 80, NULL, NULL, 81860),
(81861, '3.40.50.10090-FF-000014', NULL, 'Uroporphyrinogen III synthase', 98, NULL, NULL, 81861),
(81862, '1.10.1240.20-FF-000002', NULL, 'Soluble lytic murein transglycosylase', 66, NULL, NULL, 81862),
(81863, '1.25.40.120-FF-000063', NULL, 'Predicted protein', 214, NULL, NULL, 81863),
(81864, '3.40.630.10-FF-000448', NULL, 'Uncharacterized protein', 175, NULL, NULL, 81864),
(81865, '3.20.20.300-FF-000052', NULL, 'ERG9, Phytoenesqualene synthetase', 247, NULL, NULL, 81865),
(81866, '2.30.39.10-FF-000011', NULL, 'Antithrombin-III', 148, NULL, NULL, 81866),
(81867, '1.10.532.10-FF-000015', NULL, 'Uncharacterized protein', 89, NULL, NULL, 81867),
(81868, '3.30.70.270-FF-000331', NULL, NULL, 179, NULL, NULL, 81868),
(81869, '2.40.10.10-FF-000647', NULL, NULL, 132, NULL, NULL, 81869),
(81870, '1.10.10.60-FF-000828', NULL, NULL, 60, NULL, NULL, 81870),
(81871, '2.130.10.30-FF-000036', NULL, 'Guanidine nucleotide exchange factor', 267, NULL, NULL, 81871),
(81872, '3.40.1450.10-FF-000006', NULL, 'Uncharacterized protein', 170, NULL, NULL, 81872),
(81873, '1.10.10.60-FF-000727', NULL, 'C. Elegans Homeobox', 57, NULL, NULL, 81873),
(81874, '1.25.10.10-FF-000797', NULL, 'Armadillo repeat-containing protein 3', 225, NULL, NULL, 81874),
(81875, '3.30.160.60-FF-004785', NULL, NULL, 23, NULL, NULL, 81875),
(81876, '3.40.720.10-FF-000101', NULL, 'Secreted sulfatase ydeN', 388, NULL, NULL, 81876),
(81877, '2.60.40.10-FF-000980', NULL, 'Titin b', 100, NULL, NULL, 81877),
(81878, '2.130.10.10-FF-000738', NULL, 'Autophagy-specific protein', 305, NULL, NULL, 81878),
(81879, '2.60.40.10-FF-004791', NULL, NULL, 158, NULL, NULL, 81879),
(81880, '3.60.40.10-FF-000005', NULL, 'Serine/threonine protein phosphatase', 219, NULL, NULL, 81880),
(81881, '1.10.520.20-FF-000002', NULL, 'ATP synthase subunit O, mitochondrial', 95, NULL, NULL, 81881),
(81882, '1.25.40.10-FF-000737', NULL, 'SGT1 homolog, MIS12 kinetochore complex assembly cochaperone', 120, NULL, NULL, 81882),
(81883, '2.30.42.10-FF-000373', NULL, NULL, 97, NULL, NULL, 81883),
(81884, '3.30.499.10-FF-000020', NULL, 'Aconitate hydratase A', 222, NULL, NULL, 81884),
(81885, '3.80.10.10-FF-002251', NULL, 'Predicted protein', 118, NULL, NULL, 81885),
(81886, '3.30.40.10-FF-000490', NULL, 'Ring finger protein 214', 90, NULL, NULL, 81886),
(81887, '3.50.50.60-FF-000139', NULL, 'All-trans-retinol 13,14-reductase', 80, NULL, NULL, 81887),
(81888, '3.40.50.1820-FF-000165', NULL, 'Serine peptidase, putative', 241, NULL, NULL, 81888);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(81889, '1.20.1250.20-FF-001973', NULL, 'Uncharacterized protein', 404, NULL, NULL, 81889),
(81890, '3.40.50.10190-FF-000140', NULL, 'Related to FCP1-TFIIF interacting component of CTD phosphatase', 94, NULL, NULL, 81890),
(81891, '1.10.510.10-FF-003039', NULL, NULL, 217, NULL, NULL, 81891),
(81892, '3.40.50.970-FF-000063', NULL, '2-oxoglutarate dehydrogenase, mitochondrial', 365, NULL, NULL, 81892),
(81893, '3.40.50.10140-FF-000052', NULL, 'Predicted protein', 122, NULL, NULL, 81893),
(81894, '3.40.50.300-FF-001071', NULL, 'Thiamine import ATP-binding protein ThiQ', 217, NULL, NULL, 81894),
(81895, '3.30.390.30-FF-000004', NULL, 'Thioredoxin reductase 1, cytoplasmic', 129, NULL, NULL, 81895),
(81896, '3.60.20.10-FF-000116', NULL, 'Proteasome endopeptidase complex', 190, NULL, NULL, 81896),
(81897, '2.70.98.10-FF-000056', NULL, 'Photosynthetic NDH subunit of subcomplex B 2, chloroplastic', 273, NULL, NULL, 81897),
(81898, '3.80.10.10-FF-004403', NULL, 'Leucine-rich repeat protein (LRRP), putative', 96, NULL, NULL, 81898),
(81899, '1.20.1250.20-FF-000556', NULL, 'MFS transporter, putative (AFU_orthologue AFUA_1G17530)', 427, NULL, NULL, 81899),
(81900, '3.30.450.20-FF-000512', NULL, 'PAS/PAC sensor hybrid histidine kinase', 109, NULL, NULL, 81900),
(81901, '1.25.40.420-FF-000063', NULL, 'Uncharacterized protein', 51, NULL, NULL, 81901),
(81902, '2.60.200.20-FF-000087', NULL, 'TRAF-interacting protein with FHA domain-containing protein A', 118, NULL, NULL, 81902),
(81903, '3.30.1010.10-FF-000077', NULL, 'Uncharacterized protein', 169, NULL, NULL, 81903),
(81904, '3.30.70.330-FF-000372', NULL, 'RNA-binding motif protein 12B', 98, NULL, NULL, 81904),
(81905, '3.80.10.10-FF-002037', NULL, 'Uncharacterized protein', 142, NULL, NULL, 81905),
(81906, '2.130.10.10-FF-002981', NULL, 'Uncharacterized protein', 207, NULL, NULL, 81906),
(81907, '1.20.120.1320-FF-000011', NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase', 102, NULL, NULL, 81907),
(81908, '3.30.2420.10-FF-000001', NULL, 'Protein TonB', 90, NULL, NULL, 81908),
(81909, '3.90.1150.10-FF-000337', NULL, 'Predicted protein', 124, NULL, NULL, 81909),
(81910, '1.20.1250.20-FF-001759', NULL, 'Predicted protein', 191, NULL, NULL, 81910),
(81911, '1.10.238.10-FF-001091', NULL, 'Uncharacterized protein', 72, NULL, NULL, 81911),
(81912, '1.20.1740.10-FF-000074', NULL, 'Histidine permease', 472, NULL, NULL, 81912),
(81913, '3.90.15.10-FF-000007', NULL, 'DNA topoisomerase I', 156, NULL, NULL, 81913),
(81914, '3.50.50.60-FF-000690', NULL, 'Phytoene dehydrogenase', 94, NULL, NULL, 81914),
(81915, '3.30.160.60-FF-001137', NULL, 'Combgap, isoform L', 29, NULL, NULL, 81915),
(81916, '2.60.120.260-FF-000564', NULL, 'Predicted protein', 45, NULL, NULL, 81916),
(81917, '1.10.10.60-FF-001222', NULL, NULL, 77, NULL, NULL, 81917),
(81918, '3.40.50.2300-FF-000449', NULL, 'Low molecular weight phosphotyrosine protein phosphatase', 151, NULL, NULL, 81918),
(81919, '1.25.10.10-FF-001415', NULL, 'ARM repeat superfamily protein', 390, NULL, NULL, 81919),
(81920, '1.20.272.40-FF-000018', NULL, 'Uncharacterized protein', 29, NULL, NULL, 81920),
(81921, '1.10.630.10-FF-000232', NULL, 'Uncharacterized protein', 323, NULL, NULL, 81921),
(81922, '3.40.50.410-FF-000131', NULL, 'Uncharacterized protein', 119, NULL, NULL, 81922),
(81923, '3.50.50.60-FF-000818', NULL, 'Flavoprotein monooxygenase, putative', 137, NULL, NULL, 81923),
(81924, '3.90.70.80-FF-000021', NULL, 'Ubiquitin thioesterase OTU1', 176, NULL, NULL, 81924),
(81925, '3.40.50.150-FF-001087', NULL, NULL, 204, NULL, NULL, 81925),
(81926, '3.90.190.10-FF-000402', NULL, 'Uncharacterized protein', 166, NULL, NULL, 81926),
(81927, '2.60.120.620-FF-000003', NULL, 'Prolyl 3-hydroxylase 2', 246, NULL, NULL, 81927),
(81928, '1.25.40.10-FF-003154', NULL, 'Uncharacterized protein', 230, NULL, NULL, 81928),
(81929, '3.30.70.330-FF-001996', NULL, NULL, 90, NULL, NULL, 81929),
(81930, '3.10.100.10-FF-000185', NULL, 'Mannose receptor, C type 1b', 130, NULL, NULL, 81930),
(81931, '3.40.50.2300-FF-001500', NULL, NULL, 115, NULL, NULL, 81931);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(81932, '3.30.160.20-FF-000170', NULL, 'Uncharacterized protein', 74, NULL, NULL, 81932),
(81933, '1.20.1070.10-FF-000247', NULL, 'Uncharacterized protein, isoform B', 262, NULL, NULL, 81933),
(81934, '1.25.40.180-FF-000300', NULL, NULL, 89, NULL, NULL, 81934),
(81935, '3.20.140.10-FF-000022', NULL, 'Nicotinate phosphoribosyltransferase', 396, NULL, NULL, 81935),
(81936, '3.40.50.1000-FF-000829', NULL, NULL, 86, NULL, NULL, 81936),
(81937, '2.60.40.10-FF-002778', NULL, 'Unc-40 protein', 96, NULL, NULL, 81937),
(81938, '3.40.640.10-FF-000168', NULL, 'Putative ornithine aminotransferase RocD1', 156, NULL, NULL, 81938),
(81939, '3.40.50.1820-FF-000518', NULL, 'Hydrolase, alpha/beta fold family domain containing protein', 266, NULL, NULL, 81939),
(81940, '3.10.105.10-FF-000021', NULL, 'Peptide ABC transporter, periplasmic peptide-binding protein', 246, NULL, NULL, 81940),
(81941, '3.20.20.30-FF-000006', NULL, 'LLM class flavin-dependent oxidoreductase', 348, NULL, NULL, 81941),
(81942, '3.40.50.20-FF-000015', NULL, 'D-alanine--D-alanine ligase', 128, NULL, NULL, 81942),
(81943, '3.40.710.10-FF-000050', NULL, 'Putative D-alanyl-D-alanine carboxypeptidase', 260, NULL, NULL, 81943),
(81944, '3.40.190.120-FF-000006', NULL, 'Osmoprotectant transport system substrate-binding protein', 109, NULL, NULL, 81944),
(81945, '3.60.15.10-FF-000149', NULL, 'Cleavage and polyadenylation specific factor 3', 114, NULL, NULL, 81945),
(81946, '1.10.150.670-FF-000014', NULL, 'YALI0C14960p', 76, NULL, NULL, 81946),
(81947, '3.30.450.20-FF-000271', NULL, 'Sensor histidine kinase RcsC', 122, NULL, NULL, 81947),
(81948, '3.40.50.300-FF-003532', NULL, 'GPN-loop GTPase 2', 271, NULL, NULL, 81948),
(81949, '3.30.160.740-FF-000003', NULL, '2-isopropylmalate synthase', 49, NULL, NULL, 81949),
(81950, '3.40.50.620-FF-000531', NULL, 'Valine--tRNA ligase mitochondrial 1', 99, NULL, NULL, 81950),
(81951, '1.10.1510.10-FF-000003', NULL, 'Uncharacterized protein C22F3.15', 89, NULL, NULL, 81951),
(81952, '3.90.640.10-FF-000151', NULL, 'Actin-like protein, putative', 48, NULL, NULL, 81952),
(81953, '3.20.20.20-FF-000003', NULL, '4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase (flavodoxin)', 262, NULL, NULL, 81953),
(81954, '3.40.640.10-FF-000398', NULL, 'Uncharacterized protein', 37, NULL, NULL, 81954),
(81955, '3.30.710.10-FF-000333', NULL, 'Uncharacterized protein', 133, NULL, NULL, 81955),
(81956, '2.20.100.10-FF-000225', NULL, 'spondin-1-like', 72, NULL, NULL, 81956),
(81957, '3.10.20.710-FF-000002', NULL, 'Defective proventriculus, isoform A', 113, NULL, NULL, 81957),
(81958, '1.20.1070.10-FF-002147', NULL, 'Uncharacterized protein', 185, NULL, NULL, 81958),
(81959, '2.60.40.10-FF-003054', NULL, 'Myomesin 2', 101, NULL, NULL, 81959),
(81960, '1.10.1040.10-FF-000124', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', 64, NULL, NULL, 81960),
(81961, '3.30.460.10-FF-000010', NULL, 'Zinc finger RNA-binding protein 2', 185, NULL, NULL, 81961),
(81962, '3.30.160.60-FF-003711', NULL, NULL, 34, NULL, NULL, 81962),
(81963, '3.30.190.20-FF-000020', NULL, 'Related to 50S ribosomal protein L1', 89, NULL, NULL, 81963),
(81964, '3.90.55.10-FF-000004', NULL, 'Trimethylamine-N-oxide reductase TorA', 62, NULL, NULL, 81964),
(81965, '3.10.20.870-FF-000022', NULL, NULL, 76, NULL, NULL, 81965),
(81966, '3.90.550.10-FF-000599', NULL, 'Uncharacterized protein', 223, NULL, NULL, 81966),
(81967, '3.50.50.60-FF-000931', NULL, 'Putidaredoxin reductase CamA', 174, NULL, NULL, 81967),
(81968, '3.30.460.20-FF-000013', NULL, 'Magnesium and cobalt transport protein CorA, putative', 167, NULL, NULL, 81968),
(81969, '1.20.120.260-FF-000001', NULL, 'Outer membrane virulence protein YopE', 130, NULL, NULL, 81969),
(81970, '2.20.70.10-FF-000129', NULL, 'Transcription factor TFIIE alpha subunit', 45, NULL, NULL, 81970),
(81971, '1.20.120.1080-FF-000113', NULL, 'Uncharacterized protein', 145, NULL, NULL, 81971),
(81972, '2.60.40.10-FF-000749', NULL, 'Hemicentin 1', 89, NULL, NULL, 81972),
(81973, '3.30.160.60-FF-005740', NULL, NULL, 55, NULL, NULL, 81973);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(81974, '2.30.30.100-FF-000102', NULL, 'N-alpha-acetyltransferase 38, NatC auxiliary subunit', 73, NULL, NULL, 81974),
(81975, '3.40.50.300-FF-006758', NULL, 'GTP-binding ADP-ribosylation factor ARF1, putative', 65, NULL, NULL, 81975),
(81976, '3.30.2460.20-FF-000001', NULL, 'Wnt homolog', 61, NULL, NULL, 81976),
(81977, '3.90.1600.10-FF-000075', NULL, 'Uncharacterized protein', 35, NULL, NULL, 81977),
(81978, '1.25.40.10-FF-004677', NULL, 'Pentatricopeptide repeat-containing protein At4g21170', 108, NULL, NULL, 81978),
(81979, '1.25.40.10-FF-002648', NULL, 'Uncharacterized protein', 244, NULL, NULL, 81979),
(81980, '3.40.390.10-FF-000075', NULL, 'Metalloendopeptidase', 212, NULL, NULL, 81980),
(81981, '3.40.50.1370-FF-000013', NULL, 'N-acetylornithine carbamoyltransferase', 152, NULL, NULL, 81981),
(81982, '3.10.20.90-FF-000985', NULL, 'Predicted protein', 93, NULL, NULL, 81982),
(81983, '3.20.20.70-FF-000102', NULL, 'Putative N-methylproline demethylase', 380, NULL, NULL, 81983),
(81984, '3.40.50.12180-FF-000001', NULL, 'Phosphoethanolamine MethylTransferase', 204, NULL, NULL, 81984),
(81985, '2.10.110.10-FF-000094', NULL, 'LIM domain-containing protein', 72, NULL, NULL, 81985),
(81986, '3.40.50.300-FF-001733', NULL, 'Export ABC transporter ATP-binding protein', 249, NULL, NULL, 81986),
(81987, '3.40.605.10-FF-000030', NULL, 'Aldehyde dehydrogenase', 262, NULL, NULL, 81987),
(81988, '1.25.40.90-FF-000036', NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', 129, NULL, NULL, 81988),
(81989, '2.40.50.140-FF-000256', NULL, 'Transcription elongation factor spt6', 89, NULL, NULL, 81989),
(81990, '3.30.200.20-FF-002489', NULL, 'Tyramine beta-hydroxylase-like Protein', 27, NULL, NULL, 81990),
(81991, '3.40.50.410-FF-000030', NULL, 'Protein ViaA', 153, NULL, NULL, 81991),
(81992, '3.40.50.12230-FF-000027', NULL, 'Predicted protein', 187, NULL, NULL, 81992),
(81993, '3.40.50.1360-FF-000010', NULL, 'Transcriptional regulator, DeoR family', 158, NULL, NULL, 81993),
(81994, '2.60.220.50-FF-000164', NULL, 'Cadherin, EGF LAG seven-pass G-type receptor 3', 152, NULL, NULL, 81994),
(81995, '2.20.28.200-FF-000007', NULL, 'DHS-like NAD/FAD-binding domain-containing protein', 55, NULL, NULL, 81995),
(81996, '1.10.1200.10-FF-000002', NULL, '10-formyltetrahydrofolate dehydrogenase', 81, NULL, NULL, 81996),
(81997, '1.10.238.260-FF-000010', NULL, 'Homocitrate synthase', 99, NULL, NULL, 81997),
(81998, '3.40.47.10-FF-000095', NULL, 'Uncharacterized protein', 398, NULL, NULL, 81998),
(81999, '1.10.1040.50-FF-000001', NULL, 'Fatty acid oxidation complex subunit alpha', 216, NULL, NULL, 81999),
(82000, '2.60.40.420-FF-000193', NULL, 'Early nodulin-like protein 21', 110, NULL, NULL, 82000),
(82001, '2.10.25.10-FF-000031', NULL, 'neurogenic locus notch homolog protein 3', 38, NULL, NULL, 82001),
(82002, '3.40.50.450-FF-000013', NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase LOG8', 195, NULL, NULL, 82002),
(82003, '2.60.40.10-FF-001025', NULL, 'Immunoglobulin heavy variable V1-74', 118, NULL, NULL, 82003),
(82004, '3.30.750.24-FF-000085', NULL, 'Sulfate permease', 123, NULL, NULL, 82004),
(82005, '1.20.5.510-FF-000009', NULL, 'EPH receptor A2', 39, NULL, NULL, 82005),
(82006, '1.10.510.10-FF-002876', NULL, NULL, 206, NULL, NULL, 82006),
(82007, '3.40.1410.10-FF-000009', NULL, 'GntR family transcriptional regulator', 144, NULL, NULL, 82007),
(82008, '1.10.238.20-FF-000020', NULL, 'Odorant-binding protein 69a', 124, NULL, NULL, 82008),
(82009, '3.40.50.300-FF-001278', NULL, 'Iron-sulfur cluster carrier protein', 252, NULL, NULL, 82009),
(82010, '3.20.20.240-FF-000005', NULL, 'Methylmalonyl-CoA mutase C-terminal domain-containing protein', 374, NULL, NULL, 82010),
(82011, '2.40.128.270-FF-000003', NULL, 'META domain containing protein', 103, NULL, NULL, 82011),
(82012, '3.30.420.10-FF-000440', NULL, NULL, 178, NULL, NULL, 82012),
(82013, '3.40.350.10-FF-000067', NULL, 'AGAP000476-PA', 155, NULL, NULL, 82013),
(82014, '3.90.190.10-FF-000048', NULL, 'dual specificity protein phosphatase 22 isoform X1', 159, NULL, NULL, 82014);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(82015, '2.30.40.10-FF-000082', NULL, 'Putative hydrolase', 91, NULL, NULL, 82015),
(82016, '3.40.20.10-FF-000061', NULL, 'Quail, isoform C', 138, NULL, NULL, 82016),
(82017, '3.30.420.10-FF-000002', NULL, 'Crossover junction endodeoxyribonuclease RuvC', 158, NULL, NULL, 82017),
(82018, '2.60.120.200-FF-000243', NULL, 'Galectin', 145, NULL, NULL, 82018),
(82019, '3.30.70.660-FF-000009', NULL, 'tRNA pseudouridine synthase A', 142, NULL, NULL, 82019),
(82020, '1.25.40.10-FF-002980', NULL, 'Pentatricopeptide repeat-containing protein At3g62890', 150, NULL, NULL, 82020),
(82021, '1.20.120.1380-FF-000001', NULL, 'Flagellar biosynthesis regulator FlhF', 48, NULL, NULL, 82021),
(82022, '1.20.1070.10-FF-002046', NULL, 'Uncharacterized protein', 109, NULL, NULL, 82022),
(82023, '1.10.472.10-FF-000527', NULL, 'Cyclin, N-terminal domain containing protein', 91, NULL, NULL, 82023),
(82024, '2.60.40.10-FF-002891', NULL, 'Alpha-1-B glycoprotein', 93, NULL, NULL, 82024),
(82025, '3.80.10.10-FF-001874', NULL, 'Hypothetical leucine-rich repeat protein 1 (LRRP1)', 112, NULL, NULL, 82025),
(82026, '1.20.5.110-FF-000114', NULL, 'Syntaxin-7', 63, NULL, NULL, 82026),
(82027, '2.30.29.30-FF-000741', NULL, 'Serine/threonine-protein kinase CLA4', 117, NULL, NULL, 82027),
(82028, '3.30.1240.10-FF-000009', NULL, 'Haloacid dehalogenase-like hydrolase', 105, NULL, NULL, 82028),
(82029, '3.60.10.10-FF-000065', NULL, 'Sphingomyelin phosphodiesterase, putative', 310, NULL, NULL, 82029),
(82030, '3.20.20.80-FF-000105', NULL, 'Glucan 1,3-beta-glucosidase', 129, NULL, NULL, 82030),
(82031, '3.80.10.10-FF-000901', NULL, 'CLV1 receptor kinase-like', 287, NULL, NULL, 82031),
(82032, '1.20.5.170-FF-000216', NULL, 'Nuclear pore complex protein Nup54', 42, NULL, NULL, 82032),
(82033, '3.40.50.1820-FF-000850', NULL, 'Predicted protein', 160, NULL, NULL, 82033),
(82034, '3.30.559.10-FF-000087', NULL, 'Uncharacterized protein', 164, NULL, NULL, 82034),
(82035, '3.10.100.10-FF-000393', NULL, NULL, 123, NULL, NULL, 82035),
(82036, '3.80.10.10-FF-004280', NULL, 'Uncharacterized protein', 255, NULL, NULL, 82036),
(82037, '3.30.980.10-FF-000021', NULL, 'Alanyl-tRNA synthetase', 143, NULL, NULL, 82037),
(82038, '2.30.29.30-FF-000421', NULL, 'Arf-GAP with GTPase, ANK repeat and PH domain-containing protein 1 isoform B', 74, NULL, NULL, 82038),
(82039, '1.10.730.10-FF-000178', NULL, 'Leucine--tRNA ligase', 152, NULL, NULL, 82039),
(82040, '3.30.420.40-FF-000679', NULL, 'O-sialoglycoprotein endopeptidase', 68, NULL, NULL, 82040),
(82041, '3.30.40.10-FF-002277', NULL, 'Lysine demethylase 4B', 50, NULL, NULL, 82041),
(82042, '3.90.70.10-FF-000837', NULL, 'Uncharacterized protein', 141, NULL, NULL, 82042),
(82043, '3.40.50.1460-FF-000135', NULL, 'Uncharacterized protein', 268, NULL, NULL, 82043),
(82044, '2.10.110.10-FF-000217', NULL, 'LIM domain family', 38, NULL, NULL, 82044),
(82045, '3.40.50.150-FF-001323', NULL, NULL, 204, NULL, NULL, 82045),
(82046, '3.40.50.970-FF-000164', NULL, 'Thiamine pyrophosphate-dependent dehydrogenase E1 component subunit alpha', 321, NULL, NULL, 82046),
(82047, '3.30.430.20-FF-000062', NULL, 'Uncharacterized protein', 67, NULL, NULL, 82047),
(82048, '1.10.510.10-FF-003382', NULL, NULL, 373, NULL, NULL, 82048),
(82049, '3.80.10.10-FF-004050', NULL, 'Predicted protein', 136, NULL, NULL, 82049),
(82050, '1.20.920.10-FF-000151', NULL, 'Uncharacterized protein', 151, NULL, NULL, 82050),
(82051, '3.40.50.1820-FF-000620', NULL, 'Phospholipase YtpA', 265, NULL, NULL, 82051),
(82052, '3.40.190.10-FF-000189', NULL, 'Glutamate receptor 1', 130, NULL, NULL, 82052),
(82053, '3.40.50.300-FF-006747', NULL, 'Uncharacterized protein', 68, NULL, NULL, 82053),
(82054, '2.130.10.10-FF-001553', NULL, 'WD40 repeat-like protein', 171, NULL, NULL, 82054),
(82055, '3.90.70.10-FF-000495', NULL, 'Ubiquitin-specific protease, putative (AFU_orthologue AFUA_1G07555)', 360, NULL, NULL, 82055),
(82056, '3.40.50.300-FF-007253', NULL, 'Uncharacterized protein', 159, NULL, NULL, 82056),
(82057, '3.30.70.1450-FF-000017', NULL, 'SLC13 family permease', 91, NULL, NULL, 82057);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(82058, '3.90.1150.10-FF-000438', NULL, 'Serine hydroxymethyltransferase', 163, NULL, NULL, 82058),
(82059, '3.20.16.10-FF-000001', NULL, 'Capsid scaffolding protein', 231, NULL, NULL, 82059),
(82060, '3.40.50.720-FF-002258', NULL, 'Uncharacterized protein', 59, NULL, NULL, 82060),
(82061, '1.25.10.10-FF-003326', NULL, 'Uncharacterized protein', 136, NULL, NULL, 82061),
(82062, '1.10.1060.10-FF-000024', NULL, 'Succinate dehydrogenase [ubiquinone] iron-sulfur subunit, mitochondrial', 116, NULL, NULL, 82062),
(82063, '1.25.40.70-FF-000030', NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', 192, NULL, NULL, 82063),
(82064, '3.60.130.10-FF-000091', NULL, 'Predicted protein', 114, NULL, NULL, 82064),
(82065, '3.40.850.10-FF-000543', NULL, 'Uncharacterized protein', 249, NULL, NULL, 82065),
(82066, '3.40.50.20-FF-000004', NULL, 'Probable alpha-L-glutamate ligase', 113, NULL, NULL, 82066),
(82067, '3.40.50.300-FF-007023', NULL, 'Uncharacterized protein', 206, NULL, NULL, 82067),
(82068, '3.30.70.1440-FF-000014', NULL, NULL, 102, NULL, NULL, 82068),
(82069, '2.130.10.10-FF-002970', NULL, 'WD-40 repeat protein', 221, NULL, NULL, 82069),
(82070, '1.10.340.70-FF-000003', NULL, 'Protein CBG25708', 87, NULL, NULL, 82070),
(82071, '1.10.510.10-FF-003152', NULL, NULL, 174, NULL, NULL, 82071),
(82072, '3.30.160.60-FF-005509', NULL, NULL, 76, NULL, NULL, 82072),
(82073, '3.55.40.20-FF-000015', NULL, 'Superoxide dismutase', 117, NULL, NULL, 82073),
(82074, '3.20.20.80-FF-000543', NULL, 'Chitinase, putative', 183, NULL, NULL, 82074),
(82075, '3.40.50.460-FF-000016', NULL, '6-phosphofructokinase', 55, NULL, NULL, 82075),
(82076, '3.40.50.720-FF-002028', NULL, 'Uncharacterized protein', 196, NULL, NULL, 82076),
(82077, '2.40.30.110-FF-000029', NULL, NULL, 61, NULL, NULL, 82077),
(82078, '3.40.50.12780-FF-000068', NULL, 'Nonribosomal peptide synthase GliP', 384, NULL, NULL, 82078),
(82079, '3.40.50.11850-FF-000014', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', 20, NULL, NULL, 82079),
(82080, '3.30.1360.40-FF-000044', NULL, 'Uncharacterized protein', 76, NULL, NULL, 82080),
(82081, '1.10.1240.10-FF-000010', NULL, '5-methyltetrahydrofolate S-homocysteine methyltransferase', 74, NULL, NULL, 82081),
(82082, '3.30.70.2800-FF-000001', NULL, 'Diedel 2', 93, NULL, NULL, 82082),
(82083, '2.30.29.30-FF-000628', NULL, 'Nuclear pore complex protein Nup50', 120, NULL, NULL, 82083),
(82084, '1.25.40.420-FF-000052', NULL, 'Protein CBR-TAG-30', 105, NULL, NULL, 82084),
(82085, '1.10.8.10-FF-000172', NULL, 'Uncharacterized protein', 56, NULL, NULL, 82085),
(82086, '3.80.10.10-FF-002138', NULL, 'Leucine-rich repeat protein (LRRP), putative', 139, NULL, NULL, 82086),
(82087, '2.60.40.60-FF-000747', NULL, 'Cadherin-4', 108, NULL, NULL, 82087),
(82088, '3.40.50.620-FF-000429', NULL, 'Riboflavin biosynthesis protein', 155, NULL, NULL, 82088),
(82089, '1.10.260.40-FF-000072', NULL, 'Helix-turn-helix transcriptional regulator, XRE family', 59, NULL, NULL, 82089),
(82090, '3.40.50.1000-FF-000020', NULL, 'Probable cation-transporting P-type ATPase', 137, NULL, NULL, 82090),
(82091, '3.30.70.330-FF-000473', NULL, 'RNA binding fox-1 homolog 3', 101, NULL, NULL, 82091),
(82092, '3.40.50.11840-FF-000011', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 2', 123, NULL, NULL, 82092),
(82093, '3.80.10.10-FF-003774', NULL, 'Leucine-rich repeat protein soc-2 homolog-like Protein', 253, NULL, NULL, 82093),
(82094, '3.30.70.1430-FF-000011', NULL, 'RND multidrug efflux transporter', 98, NULL, NULL, 82094),
(82095, '4.10.1000.10-FF-000035', NULL, 'CCCH zinc finger protein, variant', 56, NULL, NULL, 82095),
(82096, '3.90.640.10-FF-000140', NULL, 'Related to glucose regulated stress protein, HSP70-like', 90, NULL, NULL, 82096),
(82097, '3.30.200.20-FF-002259', NULL, 'Protein kinase, putative', 142, NULL, NULL, 82097),
(82098, '3.50.50.60-FF-000577', NULL, 'Styrene monooxygenase StyA', 65, NULL, NULL, 82098),
(82099, '1.20.1250.20-FF-000236', NULL, 'Proline/betaine transporter, putative', 192, NULL, NULL, 82099);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(82100, '3.30.160.60-FF-001250', NULL, 'putative transcription factor ovo-like protein 3', 28, NULL, NULL, 82100),
(82101, '2.30.30.40-FF-000495', NULL, 'Rho GTPase-activating protein gacJJ', 64, NULL, NULL, 82101),
(82102, '3.90.190.10-FF-000161', NULL, 'Probable dual specificity protein phosphatase DDB_G0269404', 154, NULL, NULL, 82102),
(82103, '1.10.287.4070-FF-000012', NULL, 'Nucleolar protein NOP5', 165, NULL, NULL, 82103),
(82104, '2.130.10.10-FF-003144', NULL, 'WD repeat-containing protein 35', 193, NULL, NULL, 82104),
(82105, '2.30.29.30-FF-000067', NULL, 'Putative DCC-interacting protein 13-beta isoform 2', 121, NULL, NULL, 82105),
(82106, '3.40.50.150-FF-001542', NULL, NULL, 91, NULL, NULL, 82106),
(82107, '3.40.630.30-FF-000100', NULL, 'Predicted protein', 215, NULL, NULL, 82107),
(82108, '1.25.10.10-FF-001174', NULL, 'Uncharacterized protein', 159, NULL, NULL, 82108),
(82109, '1.10.287.3240-FF-000004', NULL, 'V-type ATP synthase subunit D', 197, NULL, NULL, 82109),
(82110, '3.40.30.10-FF-000112', NULL, 'Glutathione peroxidase', 198, NULL, NULL, 82110),
(82111, '2.40.50.140-FF-000694', NULL, 'GD18443', 71, NULL, NULL, 82111),
(82112, '3.40.50.1010-FF-000023', NULL, 'DNA repair protein complementing XP-G cells', 140, NULL, NULL, 82112),
(82113, '3.40.1280.10-FF-000061', NULL, 'rRNA methyltransferase', 171, NULL, NULL, 82113),
(82114, '1.20.5.170-FF-000093', NULL, 'BZIP transcription factor (Eurofung)', 71, NULL, NULL, 82114),
(82115, '2.60.40.10-FF-005515', NULL, NULL, 76, NULL, NULL, 82115),
(82116, '1.25.10.10-FF-000691', NULL, 'Condensin-2 complex subunit D3', 122, NULL, NULL, 82116),
(82117, '3.90.1150.10-FF-000096', NULL, 'ATP-binding cassette sub-family A member 3-like Protein', 124, NULL, NULL, 82117),
(82118, '1.20.1070.10-FF-001883', NULL, 'Uncharacterized protein', 292, NULL, NULL, 82118),
(82119, '2.130.10.10-FF-002868', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One component system)', 243, NULL, NULL, 82119),
(82120, '3.30.70.330-FF-001310', NULL, 'Dietary Restriction Response (WT but not eat-2 lifespan increased)', 118, NULL, NULL, 82120),
(82121, '2.40.50.120-FF-000020', NULL, 'Netrin 5', 135, NULL, NULL, 82121),
(82122, '1.10.3380.10-FF-000060', NULL, 'Uncharacterized protein', 105, NULL, NULL, 82122),
(82123, '3.30.200.20-FF-000691', NULL, 'Cyclin-dependent kinase G-1', 98, NULL, NULL, 82123),
(82124, '1.25.10.10-FF-000898', NULL, 'Formin BNI1', 285, NULL, NULL, 82124),
(82125, '3.30.160.60-FF-002874', NULL, 'Uncharacterized protein', 26, NULL, NULL, 82125),
(82126, '3.90.640.10-FF-000038', NULL, 'Actin, putative', 15, NULL, NULL, 82126),
(82127, '1.10.287.920-FF-000004', NULL, 'Pheromone receptor PREB', 81, NULL, NULL, 82127),
(82128, '1.10.150.280-FF-000004', NULL, 'Transcription elongation factor, mitochondrial', 73, NULL, NULL, 82128),
(82129, '2.10.109.10-FF-000034', NULL, 'LexA repressor', 124, NULL, NULL, 82129),
(82130, '3.40.190.160-FF-000001', NULL, 'Probable arabinosyltransferase C', 72, NULL, NULL, 82130),
(82131, '3.30.160.60-FF-005302', NULL, NULL, 29, NULL, NULL, 82131),
(82132, '3.40.50.300-FF-005662', NULL, 'Dynein heavy chain', 203, NULL, NULL, 82132),
(82133, '1.20.5.190-FF-000099', NULL, 'Uncharacterized protein', 55, NULL, NULL, 82133),
(82134, '3.40.190.10-FF-000543', NULL, 'Ionotropic receptor 87a', 149, NULL, NULL, 82134),
(82135, '1.10.10.10-FF-001005', NULL, 'Uncharacterized protein', 88, NULL, NULL, 82135),
(82136, '2.60.120.20-FF-000018', NULL, 'Genome polyprotein', 254, NULL, NULL, 82136),
(82137, '1.10.510.10-FF-004467', NULL, NULL, 275, NULL, NULL, 82137),
(82138, '3.40.190.170-FF-000004', NULL, 'Trap dicarboxylate transporter, dctp subunit', 312, NULL, NULL, 82138),
(82139, '3.80.10.10-FF-000238', NULL, 'Leucine rich repeats and guanylate kinase domain containing', 133, NULL, NULL, 82139),
(82140, '3.30.70.1230-FF-000041', NULL, 'Adenylate cyclase 1', 183, NULL, NULL, 82140),
(82141, '2.40.50.180-FF-000009', NULL, 'Chemotaxis protein CheW', 74, NULL, NULL, 82141),
(82142, '3.30.40.10-FF-000377', NULL, 'Putative jumonji family transcription factor', 127, NULL, NULL, 82142);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(82143, '3.40.50.2300-FF-000904', NULL, NULL, 178, NULL, NULL, 82143),
(82144, '3.30.160.60-FF-001457', NULL, 'Zinc finger protein 275', 37, NULL, NULL, 82144),
(82145, '1.10.260.100-FF-000025', NULL, 'Hsc/Hsp70-interacting protein related, isoform B', 50, NULL, NULL, 82145),
(82146, '3.30.930.10-FF-000304', NULL, 'Os07g0165000 protein', 175, NULL, NULL, 82146),
(82147, '3.50.50.60-FF-000370', NULL, 'Sarcosine oxidase subunit beta', 197, NULL, NULL, 82147),
(82148, '1.10.287.910-FF-000001', NULL, 'Hg(II) uptake system permease component MerT family', 73, NULL, NULL, 82148),
(82149, '1.10.150.20-FF-000187', NULL, 'Protein CBR-ERCC-1', 94, NULL, NULL, 82149),
(82150, '3.40.250.10-FF-000132', NULL, 'MAP kinase phosphatase', 126, NULL, NULL, 82150),
(82151, '2.30.280.10-FF-000005', NULL, 'E3 ubiquitin-protein ligase UHRF1', 166, NULL, NULL, 82151),
(82152, '1.25.40.10-FF-000748', NULL, 'Pentatricopeptide repeat-containing protein', 214, NULL, NULL, 82152),
(82153, '3.90.25.10-FF-000064', NULL, 'Predicted protein', 90, NULL, NULL, 82153),
(82154, '2.60.120.10-FF-000015', NULL, 'Rap guanine nucleotide exchange factor 4', 129, NULL, NULL, 82154),
(82155, '3.30.110.130-FF-000001', NULL, 'Hemolysin', 85, NULL, NULL, 82155),
(82156, '3.40.50.720-FF-002360', NULL, 'Uncharacterized protein', 39, NULL, NULL, 82156),
(82157, '1.20.1070.10-FF-000017', NULL, 'lysophosphatidic acid receptor 4', 298, NULL, NULL, 82157),
(82158, '3.40.50.170-FF-000025', NULL, 'Phosphoribosylglycinamide formyltransferase', 207, NULL, NULL, 82158),
(82159, '3.40.50.10490-FF-000134', NULL, NULL, 51, NULL, NULL, 82159),
(82160, '2.60.40.10-FF-002666', NULL, 'Probable beta-glucosidase E', 134, NULL, NULL, 82160),
(82161, '2.130.10.10-FF-001121', NULL, 'Rabconnectin-3B, isoform A', 219, NULL, NULL, 82161),
(82162, '3.30.479.20-FF-000027', NULL, 'Elongation factor Ts, mitochondrial', 141, NULL, NULL, 82162),
(82163, '1.10.630.10-FF-000120', NULL, 'Lanosterol 14-alpha demethylase', 455, NULL, NULL, 82163),
(82164, '3.90.550.10-FF-000728', NULL, 'Glycogenin, putative', 253, NULL, NULL, 82164),
(82165, '2.60.120.380-FF-000010', NULL, 'Calpain 10', 144, NULL, NULL, 82165),
(82166, '2.60.40.10-FF-005414', NULL, NULL, 117, NULL, NULL, 82166),
(82167, '1.25.40.10-FF-003036', NULL, 'Tetratricopeptide repeat protein 37', 98, NULL, NULL, 82167),
(82168, '2.60.40.1400-FF-000029', NULL, NULL, 120, NULL, NULL, 82168),
(82169, '3.40.50.300-FF-001520', NULL, 'ATP-dependent Clp protease, ATP-binding subunit ClpX', 279, NULL, NULL, 82169),
(82170, '1.10.287.70-FF-000092', NULL, 'Voltage-gated potassium channel', 114, NULL, NULL, 82170),
(82171, '3.30.710.10-FF-000221', NULL, 'Uncharacterized protein', 128, NULL, NULL, 82171),
(82172, '2.20.100.10-FF-000113', NULL, 'TRAP-like protein', 84, NULL, NULL, 82172),
(82173, '1.20.58.60-FF-000741', NULL, 'Uncharacterized protein', 86, NULL, NULL, 82173),
(82174, '4.10.280.10-FF-000114', NULL, 'N-acetyl-gamma-glutamyl-phosphate partial', 93, NULL, NULL, 82174),
(82175, '3.40.50.300-FF-003644', NULL, 'Type VI secretion protein', 221, NULL, NULL, 82175),
(82176, '3.40.50.1000-FF-000599', NULL, NULL, 133, NULL, NULL, 82176),
(82177, '2.60.40.60-FF-000966', NULL, 'Uncharacterized protein', 48, NULL, NULL, 82177),
(82178, '1.25.40.610-FF-000013', NULL, 'Adhesion G protein-coupled receptor L2', 114, NULL, NULL, 82178),
(82179, '2.130.10.10-FF-003245', NULL, 'Protein CBG02611', 223, NULL, NULL, 82179),
(82180, '3.40.640.10-FF-000286', NULL, 'Probable acetylornithine aminotransferase', 239, NULL, NULL, 82180),
(82181, '3.40.50.300-FF-006298', NULL, 'Uncharacterized protein', 89, NULL, NULL, 82181),
(82182, '2.60.60.20-FF-000051', NULL, NULL, 122, NULL, NULL, 82182),
(82183, '3.30.110.20-FF-000021', NULL, 'Uncharacterized protein', 71, NULL, NULL, 82183),
(82184, '3.10.450.40-FF-000039', NULL, NULL, 94, NULL, NULL, 82184),
(82185, '3.20.70.20-FF-000051', NULL, 'Glr3745 protein', 101, NULL, NULL, 82185),
(82186, '1.25.40.10-FF-000288', NULL, 'Pentatricopeptide repeat-containing protein At4g02750', 207, NULL, NULL, 82186);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(82187, '3.40.50.880-FF-000148', NULL, 'Imidazole glycerol phosphate synthase subunit HisH', 204, NULL, NULL, 82187),
(82188, '3.40.50.150-FF-001109', NULL, NULL, 150, NULL, NULL, 82188),
(82189, '3.40.50.720-FF-000561', NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', 296, NULL, NULL, 82189),
(82190, '3.30.70.330-FF-002619', NULL, NULL, 128, NULL, NULL, 82190),
(82191, '2.130.10.10-FF-004780', NULL, 'Uncharacterized protein', 152, NULL, NULL, 82191),
(82192, '3.80.10.10-FF-002812', NULL, 'Slit protein, putative', 150, NULL, NULL, 82192),
(82193, '1.10.287.4070-FF-000017', NULL, 'YALI0B13706p', 141, NULL, NULL, 82193),
(82194, '2.40.50.1070-FF-000002', NULL, '23S rRNA (uracil(747)-C(5))-methyltransferase RlmC', 156, NULL, NULL, 82194),
(82195, '3.40.50.150-FF-001216', NULL, NULL, 221, NULL, NULL, 82195),
(82196, '1.25.40.470-FF-000050', NULL, 'Conserved WD40 and TPR repeat-containing protein, putative', 161, NULL, NULL, 82196),
(82197, '2.10.25.10-FF-001767', NULL, 'Agrin', 35, NULL, NULL, 82197),
(82198, '3.30.160.60-FF-003823', NULL, NULL, 28, NULL, NULL, 82198),
(82199, '3.40.50.300-FF-001413', NULL, 'Helicase with zinc finger domain 2', 207, NULL, NULL, 82199),
(82200, '1.10.287.70-FF-000103', NULL, 'Cyclic nucleotide-gated cation channel alpha-4', 233, NULL, NULL, 82200),
(82201, '3.30.1400.10-FF-000005', NULL, 'Cell division protein ZipA', 139, NULL, NULL, 82201),
(82202, '1.25.10.10-FF-002933', NULL, 'Uncharacterized protein', 91, NULL, NULL, 82202),
(82203, '1.20.5.1700-FF-000005', NULL, 'homer protein homolog 3 isoform X1', 78, NULL, NULL, 82203),
(82204, '3.40.50.300-FF-003537', NULL, 'RAS-related protein, putative', 138, NULL, NULL, 82204),
(82205, '2.30.30.940-FF-000005', NULL, 'ATP-dependent RecD-like DNA helicase', 80, NULL, NULL, 82205),
(82206, '1.25.40.10-FF-000967', NULL, 'Pentatricopeptide repeat-containing protein', 85, NULL, NULL, 82206),
(82207, '3.30.200.20-FF-000573', NULL, 'Serine/threonine-protein kinase OXI1', 96, NULL, NULL, 82207),
(82208, '3.30.230.10-FF-000072', NULL, 'Diphosphomevalonate decarboxylase', 182, NULL, NULL, 82208),
(82209, '3.80.10.10-FF-002705', NULL, 'Predicted protein', 173, NULL, NULL, 82209),
(82210, '2.10.25.10-FF-000137', NULL, 'neurexin-2-beta isoform X1', 39, NULL, NULL, 82210),
(82211, '3.30.40.10-FF-002058', NULL, 'Uncharacterized protein', 90, NULL, NULL, 82211),
(82212, '3.30.1520.10-FF-000059', NULL, 'Sorting nexin 2B', 140, NULL, NULL, 82212),
(82213, '3.40.50.300-FF-000789', NULL, 'DNA replication ATP-dependent helicase/nuclease DNA2', 216, NULL, NULL, 82213),
(82214, '2.130.10.10-FF-001014', NULL, 'Pre-mRNA splicing factor, putative', 83, NULL, NULL, 82214),
(82215, '3.20.20.330-FF-000032', NULL, 'Uncharacterized protein', 251, NULL, NULL, 82215),
(82216, '1.10.10.10-FF-001342', NULL, 'Eukaryotic translation initiation factor 3 subunit K', 94, NULL, NULL, 82216),
(82217, '3.30.70.330-FF-002945', NULL, NULL, 159, NULL, NULL, 82217),
(82218, '1.20.1250.20-FF-002136', NULL, 'Solute carrier, putative', 204, NULL, NULL, 82218),
(82219, '3.90.1100.10-FF-000059', NULL, 'Leucine aminopeptidase 2 chloroplastic', 160, NULL, NULL, 82219),
(82220, '2.10.25.10-FF-000351', NULL, 'Neurogenic locus notch homolog protein 2', 38, NULL, NULL, 82220),
(82221, '3.60.20.10-FF-000228', NULL, NULL, 110, NULL, NULL, 82221),
(82222, '1.10.2000.10-FF-000032', NULL, 'Secreted frizzled-related protein precusor', 127, NULL, NULL, 82222),
(82223, '3.40.1190.20-FF-000062', NULL, 'Multifunctional fusion protein', 278, NULL, NULL, 82223),
(82224, '2.130.10.10-FF-004768', NULL, 'Uncharacterized protein', 155, NULL, NULL, 82224),
(82225, '1.25.40.180-FF-000058', NULL, 'Cell cycle control protein', 291, NULL, NULL, 82225),
(82226, '1.10.630.10-FF-000013', NULL, 'Trans-cinnamate 4-monooxygenase', 475, NULL, NULL, 82226),
(82227, '3.90.226.10-FF-000239', NULL, 'Probable enoyl-CoA hydratase/isomerase', 204, NULL, NULL, 82227),
(82228, '3.40.50.620-FF-000194', NULL, 'Diphthine--ammonia ligase', 158, NULL, NULL, 82228),
(82229, '1.10.1670.10-FF-000048', NULL, NULL, 90, NULL, NULL, 82229);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(82230, '2.60.210.10-FF-000028', NULL, 'Speckle-type POZ protein-like', 138, NULL, NULL, 82230),
(82231, '1.25.10.10-FF-001292', NULL, 'Small subunit processome component 20 homolog', 330, NULL, NULL, 82231),
(82232, '2.30.240.10-FF-000003', NULL, 'AT4g02370 protein', 125, NULL, NULL, 82232),
(82233, '3.30.450.20-FF-000400', NULL, 'Uncharacterized protein', 116, NULL, NULL, 82233),
(82234, '3.40.190.10-FF-000762', NULL, 'Transferrin', 29, NULL, NULL, 82234),
(82235, '3.20.20.140-FF-000312', NULL, 'Guanine deaminase', 313, NULL, NULL, 82235),
(82236, '1.25.10.10-FF-002596', NULL, 'Protein HGH1 homolog', 150, NULL, NULL, 82236),
(82237, '2.60.270.50-FF-000004', NULL, 'Uncharacterized protein DDB_G0272682', 122, NULL, NULL, 82237),
(82238, '3.30.420.40-FF-000893', NULL, 'Uncharacterized protein', 268, NULL, NULL, 82238),
(82239, '3.30.1550.10-FF-000005', NULL, '50S ribosomal protein L11', 69, NULL, NULL, 82239),
(82240, '1.10.10.60-FF-001110', NULL, NULL, 66, NULL, NULL, 82240),
(82241, '1.10.1200.10-FF-000120', NULL, 'Uncharacterized protein', 85, NULL, NULL, 82241),
(82242, '1.25.10.10-FF-001410', NULL, 'Uncharacterized protein', 155, NULL, NULL, 82242),
(82243, '3.50.50.60-FF-000813', NULL, 'Uncharacterized protein', 179, NULL, NULL, 82243),
(82244, '1.10.150.220-FF-000003', NULL, 'protein phosphatase 1 regulatory subunit 14D', 85, NULL, NULL, 82244),
(82245, '2.60.40.10-FF-001143', NULL, 'Protein-glutamine gamma-glutamyltransferase K', 174, NULL, NULL, 82245),
(82246, '3.90.950.10-FF-000028', NULL, 'Nucleoside triphosphate pyrophosphatase', 193, NULL, NULL, 82246),
(82247, '3.20.20.140-FF-000205', NULL, 'Guanine deaminase', 340, NULL, NULL, 82247),
(82248, '3.50.50.60-FF-000706', NULL, 'Squalene epoxidase a', 167, NULL, NULL, 82248),
(82249, '1.25.40.10-FF-004559', NULL, 'Uncharacterized protein', 204, NULL, NULL, 82249),
(82250, '1.25.10.10-FF-000679', NULL, 'BnaA09g42810D protein', 357, NULL, NULL, 82250),
(82251, '2.130.10.10-FF-003138', NULL, 'Syntaxin binding protein 5 like', 129, NULL, NULL, 82251),
(82252, '3.40.1110.10-FF-000301', NULL, 'Uncharacterized protein', 251, NULL, NULL, 82252),
(82253, '2.130.10.10-FF-000497', NULL, 'DDB1 and CUL4-associated factor 12-like 1', 155, NULL, NULL, 82253),
(82254, '3.30.497.10-FF-000089', NULL, 'Serpin 42Db, isoform C', 234, NULL, NULL, 82254),
(82255, '3.40.50.720-FF-000128', NULL, 'Quinone oxidoreductase YhdH', 167, NULL, NULL, 82255),
(82256, '2.10.25.10-FF-000244', NULL, 'Fibrillin-1', 39, NULL, NULL, 82256),
(82257, '1.20.58.60-FF-000634', NULL, 'Spectrin repeat-containing, nuclear envelope 1b', 201, NULL, NULL, 82257),
(82258, '2.60.40.10-FF-005521', NULL, NULL, 69, NULL, NULL, 82258),
(82259, '3.80.20.20-FF-000068', NULL, 'Uncharacterized protein', 118, NULL, NULL, 82259),
(82260, '1.25.10.10-FF-001303', NULL, 'Ctnnb1', 191, NULL, NULL, 82260),
(82261, '3.30.420.40-FF-000786', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', 217, NULL, NULL, 82261),
(82262, '3.40.50.300-FF-000896', NULL, 'DNA mismatch repair protein MutS', 316, NULL, NULL, 82262),
(82263, '1.10.10.60-FF-000486', NULL, 'Divergent paired-related homeobox', 74, NULL, NULL, 82263),
(82264, '3.30.1520.10-FF-000166', NULL, 'Uncharacterized protein', 133, NULL, NULL, 82264),
(82265, '3.90.190.10-FF-000060', NULL, 'Phosphatidylglycerophosphatase and protein-tyrosine phosphatase 1', 153, NULL, NULL, 82265),
(82266, '2.30.30.490-FF-000044', NULL, 'Origin recognition complex subunit 1', 158, NULL, NULL, 82266),
(82267, '3.50.50.60-FF-000476', NULL, 'Sarcosine oxidase subunit alpha', 151, NULL, NULL, 82267),
(82268, '2.60.40.2150-FF-000001', NULL, 'Interleukin 17 receptor B', 95, NULL, NULL, 82268),
(82269, '1.10.510.10-FF-001252', NULL, 'IKS protein kinase, variant', 213, NULL, NULL, 82269),
(82270, '2.40.10.10-FF-000299', NULL, NULL, 119, NULL, NULL, 82270),
(82271, '3.30.310.20-FF-000002', NULL, 'DNA-3-methyladenine glycosylase 2', 112, NULL, NULL, 82271),
(82272, '4.10.1060.10-FF-000033', NULL, 'Uncharacterized protein', 42, NULL, NULL, 82272),
(82273, '3.40.50.150-FF-001435', NULL, NULL, 149, NULL, NULL, 82273);
INSERT INTO "PUBLIC"."MODEL" VALUES
(82274, '1.25.10.10-FF-001073', NULL, 'Condensin complex subunit 1', 205, NULL, NULL, 82274),
(82275, '3.90.1720.10-FF-000010', NULL, 'Peptidoglycan endopeptidase RipA', 213, NULL, NULL, 82275),
(82276, '3.30.40.10-FF-000153', NULL, 'Histone-lysine N-methyltransferase NSD2', 47, NULL, NULL, 82276),
(82277, '1.20.1250.20-FF-002029', NULL, 'Solute carrier organic anion transporter family member', 347, NULL, NULL, 82277),
(82278, '3.90.180.10-FF-000008', NULL, 'Sorbitol dehydrogenase', 183, NULL, NULL, 82278),
(82279, '1.10.418.80-FF-000001', NULL, 'Ubiquitin carboxyl-terminal hydrolase 3', 99, NULL, NULL, 82279),
(82280, '1.20.58.900-FF-000025', NULL, 'RUN and FYVE domain-containing protein 1', 82, NULL, NULL, 82280),
(82281, '2.60.40.10-FF-003374', NULL, 'Receptor protein-tyrosine kinase', 125, NULL, NULL, 82281),
(82282, '2.40.50.90-FF-000156', NULL, 'Thermonuclease', 119, NULL, NULL, 82282),
(82283, '3.55.40.20-FF-000021', NULL, 'Superoxide dismutase', 113, NULL, NULL, 82283),
(82284, '1.10.555.10-FF-000141', NULL, 'Rho GTPase-activating protein (RhoGAP), putative', 207, NULL, NULL, 82284),
(82285, '3.90.190.20-FF-000063', NULL, 'Folylpolyglutamate synthetase', 129, NULL, NULL, 82285),
(82286, '1.10.400.10-FF-000069', NULL, 'Guanine nucleotide-binding protein subunit alpha', 68, NULL, NULL, 82286),
(82287, '3.30.200.20-FF-000466', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 115, NULL, NULL, 82287),
(82288, '1.10.10.60-FF-001003', NULL, NULL, 69, NULL, NULL, 82288),
(82289, '3.30.70.370-FF-000018', NULL, 'DNA polymerase gamma 1', 73, NULL, NULL, 82289),
(82290, '2.10.25.10-FF-000570', NULL, 'Notch homolog 4, [Drosophila]', 39, NULL, NULL, 82290),
(82291, '2.30.39.10-FF-000123', NULL, 'Secreted salivary gland peptide, putative', 50, NULL, NULL, 82291),
(82292, '3.30.160.60-FF-005061', NULL, NULL, 30, NULL, NULL, 82292),
(82293, '3.30.200.20-FF-002490', NULL, 'Uncharacterized protein', 23, NULL, NULL, 82293),
(82294, '4.10.260.10-FF-000012', NULL, 'Uncharacterized protein', 68, NULL, NULL, 82294),
(82295, '3.40.50.300-FF-004948', NULL, 'Uncharacterized protein', 150, NULL, NULL, 82295),
(82296, '3.40.720.10-FF-000213', NULL, 'Iduronate-2-sulfatase', 454, NULL, NULL, 82296),
(82297, '3.40.630.30-FF-000212', NULL, 'Putative diamine N-acetyltransferase', 103, NULL, NULL, 82297),
(82298, '3.90.120.10-FF-000016', NULL, 'tRNA (cytosine(38)-C(5))-methyltransferase 2', 112, NULL, NULL, 82298),
(82299, '3.40.50.720-FF-000780', NULL, 'Putative quinone oxidoreductase', 169, NULL, NULL, 82299),
(82300, '1.10.510.10-FF-000858', NULL, 'AGC protein kinase', 116, NULL, NULL, 82300),
(82301, '1.10.510.10-FF-002882', NULL, NULL, 94, NULL, NULL, 82301),
(82302, '3.40.50.720-FF-001758', NULL, 'CurH', 244, NULL, NULL, 82302),
(82303, '1.25.10.10-FF-002826', NULL, 'Uncharacterized protein', 188, NULL, NULL, 82303),
(82304, '2.130.10.10-FF-004549', NULL, 'Ribosome biogenesis protein WDR12 homolog', 219, NULL, NULL, 82304),
(82305, '3.30.160.60-FF-005066', NULL, NULL, 29, NULL, NULL, 82305),
(82306, '3.40.50.620-FF-000205', NULL, 'Isoleucine--tRNA ligase', 371, NULL, NULL, 82306),
(82307, '1.10.10.10-FF-000960', NULL, 'Uncharacterized protein', 90, NULL, NULL, 82307),
(82308, '3.80.10.10-FF-003998', NULL, 'Uncharacterized protein', 152, NULL, NULL, 82308),
(82309, '1.10.490.10-FF-000024', NULL, 'GM10846', 141, NULL, NULL, 82309),
(82310, '2.60.220.50-FF-000170', NULL, 'Predicted protein', 119, NULL, NULL, 82310),
(82311, '1.25.40.20-FF-001134', NULL, 'Kinase, NEK', 164, NULL, NULL, 82311),
(82312, '2.10.25.10-FF-000025', NULL, 'Thrombospondin 3', 50, NULL, NULL, 82312),
(82313, '3.40.50.720-FF-001977', NULL, 'Uncharacterized protein', 249, NULL, NULL, 82313),
(82314, '1.10.238.10-FF-000944', NULL, 'Calcium-binding protein, putative', 101, NULL, NULL, 82314),
(82315, '1.20.1730.10-FF-000028', NULL, 'Sodium/solute symporter', 486, NULL, NULL, 82315),
(82316, '1.25.40.10-FF-001131', NULL, 'Os03g0308800 protein', 183, NULL, NULL, 82316),
(82317, '3.40.640.10-FF-000393', NULL, 'Sphingosine-1-phosphate lyase 1', 136, NULL, NULL, 82317);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(82318, '1.10.510.10-FF-001471', NULL, 'Calcium-dependent kinase family protein', 76, NULL, NULL, 82318),
(82319, '3.40.50.1580-FF-000065', NULL, 'Uncharacterized protein', 195, NULL, NULL, 82319),
(82320, '3.30.450.20-FF-000170', NULL, 'Oxygen sensor protein DosP', 118, NULL, NULL, 82320),
(82321, '1.25.50.20-FF-000111', NULL, 'Uncharacterized protein', 39, NULL, NULL, 82321),
(82322, '1.10.10.60-FF-000946', NULL, NULL, 71, NULL, NULL, 82322),
(82323, '2.40.50.140-FF-000470', NULL, 'Related to RRP5-processing of pre-ribosomal RNA', 84, NULL, NULL, 82323),
(82324, '2.60.40.10-FF-002885', NULL, 'Leptin receptor', 100, NULL, NULL, 82324),
(82325, '1.20.140.40-FF-000089', NULL, NULL, 102, NULL, NULL, 82325),
(82326, '3.30.450.70-FF-000038', NULL, NULL, 82, NULL, NULL, 82326),
(82327, '3.30.70.360-FF-000015', NULL, 'Amidohydrolase', 112, NULL, NULL, 82327),
(82328, '3.30.70.330-FF-000714', NULL, 'Glycine-rich RNA-binding protein 2, mitochondrial', 95, NULL, NULL, 82328),
(82329, '1.25.40.10-FF-002761', NULL, 'Uncharacterized protein', 185, NULL, NULL, 82329),
(82330, '3.90.1580.10-FF-000021', NULL, 'Predicted protein', 322, NULL, NULL, 82330),
(82331, '3.40.50.80-FF-000224', NULL, 'NADH-cytochrome b5 reductase', 159, NULL, NULL, 82331),
(82332, '3.30.160.60-FF-005280', NULL, NULL, 21, NULL, NULL, 82332),
(82333, '3.30.365.10-FF-000030', NULL, 'Aldehyde oxidase', 136, NULL, NULL, 82333),
(82334, '3.20.20.140-FF-000200', NULL, 'Amidohydrolase', 313, NULL, NULL, 82334),
(82335, '2.60.40.10-FF-005740', NULL, NULL, 125, NULL, NULL, 82335),
(82336, '1.20.1080.10-FF-000074', NULL, 'AQuaPorin or aquaglyceroporin related', 235, NULL, NULL, 82336),
(82337, '3.40.190.10-FF-000981', NULL, 'Prephenate dehydratase', 99, NULL, NULL, 82337),
(82338, '1.10.287.10-FF-000006', NULL, 'Bifunctional glutamate/proline--tRNA ligase', 60, NULL, NULL, 82338),
(82339, '3.30.56.10-FF-000043', NULL, 'Phenylalanine--tRNA ligase beta subunit', 72, NULL, NULL, 82339),
(82340, '1.20.1560.10-FF-000442', NULL, 'Protein CBG25498', 108, NULL, NULL, 82340),
(82341, '1.10.238.10-FF-001219', NULL, 'Uncharacterized protein', 147, NULL, NULL, 82341),
(82342, '3.40.50.720-FF-000347', NULL, 'UDP-N-acetylglucosamine 4-epimerase', 321, NULL, NULL, 82342),
(82343, '3.40.462.20-FF-000009', NULL, 'FAD-linked oxidoreductase afoF', 220, NULL, NULL, 82343),
(82344, '1.10.472.10-FF-000639', NULL, 'Protein CBG15501', 116, NULL, NULL, 82344),
(82345, '3.30.160.60-FF-006477', NULL, NULL, 25, NULL, NULL, 82345),
(82346, '1.10.238.20-FF-000025', NULL, 'Odorant-binding protein 8a', 109, NULL, NULL, 82346),
(82347, '1.20.58.60-FF-000522', NULL, 'Uncharacterized protein', 280, NULL, NULL, 82347),
(82348, '3.30.70.330-FF-001203', NULL, 'Nucleolin', 93, NULL, NULL, 82348),
(82349, '2.60.120.290-FF-000213', NULL, 'Uncharacterized protein', 116, NULL, NULL, 82349),
(82350, '3.30.310.40-FF-000008', NULL, 'N-glycosylase/DNA lyase', 85, NULL, NULL, 82350),
(82351, '3.40.190.10-FF-000650', NULL, 'Hydroxymethylbilane synthase', 116, NULL, NULL, 82351),
(82352, '3.40.50.300-FF-003318', NULL, 'Nuclear GTP-binding protein', 199, NULL, NULL, 82352),
(82353, '3.10.50.10-FF-000042', NULL, 'Uncharacterized protein', 55, NULL, NULL, 82353),
(82354, '3.30.420.40-FF-000674', NULL, 'Heat shock protein 70F', 51, NULL, NULL, 82354),
(82355, '3.40.30.10-FF-000005', NULL, 'Glutaredoxin 5', 101, NULL, NULL, 82355),
(82356, '1.20.1090.10-FF-000018', NULL, 'Pentafunctional AROM polypeptide', 188, NULL, NULL, 82356),
(82357, '2.30.30.40-FF-000596', NULL, 'Predicted protein', 59, NULL, NULL, 82357),
(82358, '2.130.10.10-FF-000957', NULL, 'Intraflagellar transport protein 172', 232, NULL, NULL, 82358),
(82359, '3.40.250.10-FF-000020', NULL, 'Dual specificity protein phosphatase 8', 132, NULL, NULL, 82359),
(82360, '1.20.1050.10-FF-000246', NULL, 'Glutathione S-transferase, theta 3', 54, NULL, NULL, 82360),
(82361, '1.10.357.140-FF-000040', NULL, 'Uncharacterized protein', 164, NULL, NULL, 82361),
(82362, '3.80.10.10-FF-000800', NULL, 'Receptor like protein 29', 101, NULL, NULL, 82362);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(82363, '3.40.50.300-FF-001632', NULL, 'RNA helicase', 247, NULL, NULL, 82363),
(82364, '2.130.10.10-FF-001233', NULL, 'regulatory-associated protein of mTOR isoform X2', 143, NULL, NULL, 82364),
(82365, '3.40.850.10-FF-000223', NULL, 'AT27178p', 107, NULL, NULL, 82365),
(82366, '3.20.20.80-FF-000436', NULL, 'Predicted protein', 208, NULL, NULL, 82366),
(82367, '3.30.190.20-FF-000008', NULL, '50S ribosomal protein L1', 105, NULL, NULL, 82367),
(82368, '4.10.400.10-FF-000001', NULL, 'Low-density lipoprotein receptor-related protein 1', 42, NULL, NULL, 82368),
(82369, '1.10.10.160-FF-000045', NULL, 'DNA helicase II', 97, NULL, NULL, 82369),
(82370, '3.40.50.10490-FF-000022', NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', 146, NULL, NULL, 82370),
(82371, '1.10.287.70-FF-000322', NULL, 'Possible transmembrane cation transporter', 105, NULL, NULL, 82371),
(82372, '1.25.10.20-FF-000002', NULL, 'Vitellogenin 7', 333, NULL, NULL, 82372),
(82373, '3.40.50.720-FF-000342', NULL, 'NAD dependent epimerase/dehydratase family protein', 316, NULL, NULL, 82373),
(82374, '1.25.40.10-FF-004778', NULL, 'Tetratricopeptide repeat protein 1', 193, NULL, NULL, 82374),
(82375, '3.30.460.10-FF-000111', NULL, '2''-5''-oligoadenylate synthase 3-like isoform X1', 146, NULL, NULL, 82375),
(82376, '3.40.50.300-FF-005561', NULL, 'Predicted protein', 278, NULL, NULL, 82376),
(82377, '1.10.10.10-FF-000499', NULL, 'Heteromeric transposase endonuclease subunit TnsA', 99, NULL, NULL, 82377),
(82378, '2.130.10.10-FF-005504', NULL, 'Transducin beta-like protein 3', 99, NULL, NULL, 82378),
(82379, '3.30.460.20-FF-000007', NULL, 'Magnesium transport protein CorA', 127, NULL, NULL, 82379),
(82380, '2.120.10.30-FF-000582', NULL, 'Uncharacterized protein', 151, NULL, NULL, 82380),
(82381, '2.130.10.10-FF-002863', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One component system)', 159, NULL, NULL, 82381),
(82382, '3.40.1280.10-FF-000066', NULL, 'tRNA (cytidine/uridine-2''-O-)-methyltransferase TrmJ', 177, NULL, NULL, 82382),
(82383, '2.40.50.40-FF-000063', NULL, 'Two-component response regulator', 66, NULL, NULL, 82383),
(82384, '3.30.420.390-FF-000014', NULL, NULL, 124, NULL, NULL, 82384),
(82385, '1.50.10.10-FF-000036', NULL, 'Glucanase', 339, NULL, NULL, 82385),
(82386, '3.30.900.10-FF-000033', NULL, 'YALI0E10791p', 193, NULL, NULL, 82386),
(82387, '3.40.50.10330-FF-000002', NULL, 'Diacylglycerol kinase', 131, NULL, NULL, 82387),
(82388, '3.30.70.330-FF-002507', NULL, NULL, 71, NULL, NULL, 82388),
(82389, '3.30.160.60-FF-003604', NULL, NULL, 33, NULL, NULL, 82389),
(82390, '3.30.230.10-FF-000291', NULL, 'DNA mismatch repair protein domain', 142, NULL, NULL, 82390),
(82391, '1.20.920.20-FF-000053', NULL, 'Flagellar attachment zone protein 1', 227, NULL, NULL, 82391),
(82392, '3.40.50.150-FF-001328', NULL, NULL, 202, NULL, NULL, 82392),
(82393, '1.50.10.20-FF-000039', NULL, 'Fructose-bisphosphate aldolase', 370, NULL, NULL, 82393),
(82394, '2.60.40.420-FF-000204', NULL, 'Uncharacterized protein', 144, NULL, NULL, 82394),
(82395, '2.60.40.10-FF-003155', NULL, 'Titin homolog', 104, NULL, NULL, 82395),
(82396, '3.30.200.20-FF-000792', NULL, 'Glycogen synthase kinase 3', 97, NULL, NULL, 82396),
(82397, '3.30.710.10-FF-000440', NULL, 'Uncharacterized protein', 160, NULL, NULL, 82397),
(82398, '1.20.920.10-FF-000050', NULL, 'Transcription factor GTE4', 136, NULL, NULL, 82398),
(82399, '3.40.50.300-FF-001290', NULL, 'Zinc finger helicase family protein', 163, NULL, NULL, 82399),
(82400, '3.90.180.10-FF-000115', NULL, 'Uncharacterized protein', 175, NULL, NULL, 82400),
(82401, '3.90.550.10-FF-000498', NULL, 'Glycosyltransferase 8 domain-containing protein 1', 282, NULL, NULL, 82401),
(82402, '2.30.29.30-FF-000308', NULL, 'Rho-associated protein kinase 1', 105, NULL, NULL, 82402),
(82403, '2.40.50.140-FF-000363', NULL, 'Ribonuclease R', 78, NULL, NULL, 82403),
(82404, '1.20.1250.10-FF-000121', NULL, NULL, 144, NULL, NULL, 82404),
(82405, '2.60.120.330-FF-000023', NULL, 'Feruloyl CoA ortho-hydroxylase 1', 329, NULL, NULL, 82405);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(82406, '3.80.10.10-FF-004055', NULL, 'Uncharacterized protein', 135, NULL, NULL, 82406),
(82407, '3.40.640.10-FF-000409', NULL, 'Uncharacterized protein', 126, NULL, NULL, 82407),
(82408, '3.40.50.2300-FF-000444', NULL, 'Sensory transduction histidine kinase', 128, NULL, NULL, 82408),
(82409, '3.30.470.20-FF-000165', NULL, 'Ribosomal modification protein rimK-like family member A', 64, NULL, NULL, 82409),
(82410, '1.20.1250.20-FF-000124', NULL, 'Solute carrier family 2, facilitated glucose transporter member 12', 345, NULL, NULL, 82410),
(82411, '3.40.50.620-FF-000424', NULL, 'GD12953', 190, NULL, NULL, 82411),
(82412, '1.10.8.10-FF-000071', NULL, 'E3 ubiquitin-protein ligase RNF31', 61, NULL, NULL, 82412),
(82413, '3.40.50.1820-FF-000277', NULL, 'Carboxylic ester hydrolase', 530, NULL, NULL, 82413),
(82414, '2.130.10.10-FF-005162', NULL, 'Uncharacterized protein', 137, NULL, NULL, 82414),
(82415, '2.130.10.10-FF-002756', NULL, 'Uncharacterized protein', 383, NULL, NULL, 82415),
(82416, '1.20.1740.10-FF-000080', NULL, 'Tyrosine-specific transport protein', 397, NULL, NULL, 82416),
(82417, '1.10.287.130-FF-000065', NULL, 'Histidine kinase', 80, NULL, NULL, 82417),
(82418, '3.30.559.10-FF-000211', NULL, 'Siderophore peptide synthetase fer3', 196, NULL, NULL, 82418),
(82419, '2.60.120.200-FF-000350', NULL, 'protein kinase C-binding protein NELL2 isoform X3', 122, NULL, NULL, 82419),
(82420, '2.40.50.120-FF-000019', NULL, 'Procollagen C-endopeptidase enhancer 1', 130, NULL, NULL, 82420),
(82421, '1.20.920.30-FF-000056', NULL, 'Uncharacterized protein', 188, NULL, NULL, 82421),
(82422, '3.30.40.10-FF-000372', NULL, 'E3 ubiquitin-protein ligase NHLRC1', 86, NULL, NULL, 82422),
(82423, '3.30.70.330-FF-000933', NULL, 'polyadenylate-binding protein 1-like isoform X5', 96, NULL, NULL, 82423),
(82424, '3.90.640.10-FF-000139', NULL, 'Chaperone protein dnaK', 104, NULL, NULL, 82424),
(82425, '3.80.10.10-FF-000339', NULL, 'F-box/LRR-repeat protein 2 isoform X1', 94, NULL, NULL, 82425),
(82426, '1.20.1160.11-FF-000014', NULL, 'Os02g0635950 protein', 63, NULL, NULL, 82426),
(82427, '2.170.130.10-FF-000046', NULL, 'Colicin I receptor', 133, NULL, NULL, 82427),
(82428, '3.60.40.10-FF-000342', NULL, 'Integrin-linked kinase-associated serine/threonine phosphatase', 123, NULL, NULL, 82428),
(82429, '1.20.120.1080-FF-000012', NULL, 'putative ATP-dependent RNA helicase TDRD9', 114, NULL, NULL, 82429),
(82430, '1.20.1260.10-FF-000060', NULL, 'Uncharacterized protein', 152, NULL, NULL, 82430),
(82431, '2.60.120.260-FF-000452', NULL, 'Uncharacterized protein', 141, NULL, NULL, 82431),
(82432, '3.30.70.330-FF-000591', NULL, 'RNA-binding protein', 144, NULL, NULL, 82432),
(82433, '1.25.10.30-FF-000005', NULL, NULL, 146, NULL, NULL, 82433),
(82434, '4.10.400.20-FF-000004', NULL, 'Uncharacterized protein', 51, NULL, NULL, 82434),
(82435, '1.10.150.20-FF-000086', NULL, 'Translocation protein SEC63', 58, NULL, NULL, 82435),
(82436, '1.10.3460.10-FF-000027', NULL, 'Fucoxanthin chlorophyll a/c protein-LI818 clade', 174, NULL, NULL, 82436),
(82437, '3.40.50.300-FF-007360', NULL, 'Predicted protein', 179, NULL, NULL, 82437),
(82438, '2.60.410.10-FF-000009', NULL, NULL, 104, NULL, NULL, 82438),
(82439, '3.30.40.10-FF-000720', NULL, 'PHD finger transcription factor', 50, NULL, NULL, 82439),
(82440, '2.60.120.1560-FF-000010', NULL, 'PKHD1, fibrocystin/polyductin', 162, NULL, NULL, 82440),
(82441, '2.40.270.10-FF-000002', NULL, 'DNA-directed RNA polymerase subunit beta', 221, NULL, NULL, 82441),
(82442, '3.30.760.10-FF-000044', NULL, 'Uncharacterized protein', 169, NULL, NULL, 82442),
(82443, '3.10.450.50-FF-000037', NULL, 'Calcium/calmodulin-dependent protein kinase type II', 143, NULL, NULL, 82443),
(82444, '3.30.160.60-FF-005403', NULL, NULL, 16, NULL, NULL, 82444),
(82445, '2.30.42.10-FF-000272', NULL, 'Partitioning defective protein 3', 109, NULL, NULL, 82445),
(82446, '2.30.42.10-FF-000608', NULL, NULL, 96, NULL, NULL, 82446),
(82447, '3.30.420.40-FF-000567', NULL, 'Actin', 14, NULL, NULL, 82447),
(82448, '3.30.40.10-FF-000265', NULL, 'E3 ubiquitin-protein ligase RING1', 116, NULL, NULL, 82448);
INSERT INTO "PUBLIC"."MODEL" VALUES
(82449, '4.10.60.10-FF-000259', NULL, 'Uncharacterized protein', 27, NULL, NULL, 82449),
(82450, '1.20.120.220-FF-000023', NULL, 'Uncharacterized protein', 89, NULL, NULL, 82450),
(82451, '3.40.50.300-FF-006865', NULL, 'ABC transporter, putative', 254, NULL, NULL, 82451),
(82452, '3.80.10.10-FF-002256', NULL, 'Leucine rich repeatcontaining protein', 109, NULL, NULL, 82452),
(82453, '1.10.510.10-FF-003264', NULL, NULL, 110, NULL, NULL, 82453),
(82454, '2.170.300.10-FF-000082', NULL, 'Uncharacterized protein', 142, NULL, NULL, 82454),
(82455, '3.20.20.70-FF-000107', NULL, 'Tryptophan synthase alpha chain, chloroplastic', 264, NULL, NULL, 82455),
(82456, '3.80.10.10-FF-004162', NULL, 'Predicted protein', 275, NULL, NULL, 82456),
(82457, '3.30.420.40-FF-000909', NULL, 'Actin like 6B', 71, NULL, NULL, 82457),
(82458, '1.25.40.10-FF-000962', NULL, 'CS_domain/TPR_repeat/Tetratricopeptide_repeat', 124, NULL, NULL, 82458),
(82459, '3.30.160.60-FF-004908', NULL, NULL, 64, NULL, NULL, 82459),
(82460, '1.10.640.10-FF-000053', NULL, 'Uncharacterized protein', 475, NULL, NULL, 82460),
(82461, '1.10.510.10-FF-003606', NULL, NULL, 200, NULL, NULL, 82461),
(82462, '2.60.40.10-FF-001362', NULL, 'Sidekick, isoform B', 85, NULL, NULL, 82462),
(82463, '3.90.1140.10-FF-000056', NULL, 'Uncharacterized protein C15D4.13c', 196, NULL, NULL, 82463),
(82464, '3.40.50.300-FF-007141', NULL, 'Uncharacterized protein', 290, NULL, NULL, 82464),
(82465, '1.10.238.10-FF-001096', NULL, 'Uncharacterized protein', 67, NULL, NULL, 82465),
(82466, '3.40.630.30-FF-000105', NULL, 'Glucosamine 6-phosphate N-acetyltransferase', 141, NULL, NULL, 82466),
(82467, '1.10.510.10-FF-002775', NULL, NULL, 218, NULL, NULL, 82467),
(82468, '2.20.110.10-FF-000046', NULL, NULL, 41, NULL, NULL, 82468),
(82469, '4.10.240.10-FF-000117', NULL, 'C2H2 transcription factor, putative', 51, NULL, NULL, 82469),
(82470, '3.30.342.10-FF-000011', NULL, 'DNA polymerase', 167, NULL, NULL, 82470),
(82471, '3.90.226.10-FF-000346', NULL, 'Enoyl CoA hydratase domain containing 2', 213, NULL, NULL, 82471),
(82472, '2.20.100.10-FF-000220', NULL, 'Metalloendopeptidase', 77, NULL, NULL, 82472),
(82473, '3.30.70.330-FF-003002', NULL, NULL, 82, NULL, NULL, 82473),
(82474, '1.10.510.10-FF-002994', NULL, NULL, 174, NULL, NULL, 82474),
(82475, '1.10.287.470-FF-000043', NULL, 'RND family efflux transporter, MFP subunit', 74, NULL, NULL, 82475),
(82476, '3.40.720.10-FF-000106', NULL, 'Arylsulfatase', 373, NULL, NULL, 82476),
(82477, '3.80.10.10-FF-004510', NULL, 'Uncharacterized protein', 103, NULL, NULL, 82477),
(82478, '1.20.1250.20-FF-000450', NULL, 'MFS transporter permease', 185, NULL, NULL, 82478),
(82479, '2.30.29.30-FF-000527', NULL, 'Signal transducing adaptor family member 2', 142, NULL, NULL, 82479),
(82480, '2.130.10.110-FF-000009', NULL, 'Clathrin heavy chain', 363, NULL, NULL, 82480),
(82481, '2.60.40.10-FF-001581', NULL, 'titin isoform X1', 87, NULL, NULL, 82481),
(82482, '3.40.710.10-FF-000151', NULL, 'Peptidoglycan D,D-transpeptidase FtsI', 183, NULL, NULL, 82482),
(82483, '1.25.10.10-FF-002938', NULL, 'Uncharacterized protein', 82, NULL, NULL, 82483),
(82484, '1.10.1040.10-FF-000017', NULL, '2-dehydropantoate 2-reductase', 131, NULL, NULL, 82484),
(82485, '1.10.510.10-FF-003051', NULL, NULL, 211, NULL, NULL, 82485),
(82486, '2.40.50.90-FF-000049', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 152, NULL, NULL, 82486),
(82487, '2.30.42.10-FF-000485', NULL, NULL, 80, NULL, NULL, 82487),
(82488, '3.30.1520.10-FF-000054', NULL, 'Non-specific serine/threonine protein kinase', 113, NULL, NULL, 82488),
(82489, '1.20.1270.10-FF-000004', NULL, 'Molecular chaperone DnaK', 84, NULL, NULL, 82489),
(82490, '3.30.70.330-FF-002726', NULL, NULL, 186, NULL, NULL, 82490),
(82491, '1.25.40.20-FF-000965', NULL, 'Predicted protein', 141, NULL, NULL, 82491),
(82492, '1.10.1220.10-FF-000003', NULL, 'Arc family DNA-binding protein', 64, NULL, NULL, 82492),
(82493, '3.80.10.10-FF-003886', NULL, 'Uncharacterized protein', 157, NULL, NULL, 82493),
(82494, '3.30.160.60-FF-003149', NULL, 'ZNF649 isoform 1', 29, NULL, NULL, 82494);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(82495, '2.60.120.340-FF-000026', NULL, 'Nucleophosmin/nucleoplasmin, 2a', 122, NULL, NULL, 82495),
(82496, '2.10.110.10-FF-000335', NULL, 'Uncharacterized protein', 49, NULL, NULL, 82496),
(82497, '1.20.1270.20-FF-000007', NULL, 'Hybrid-cluster protein', 150, NULL, NULL, 82497),
(82498, '3.40.50.620-FF-000082', NULL, 'MSW1p Mitochondrial tryptophanyl-tRNA synthetase', 212, NULL, NULL, 82498),
(82499, '2.60.40.10-FF-005291', NULL, NULL, 82, NULL, NULL, 82499),
(82500, '2.130.10.10-FF-003026', NULL, 'Chromatin assembly complex 1 subunit B/CAC2', 166, NULL, NULL, 82500),
(82501, '3.40.50.300-FF-003425', NULL, 'Selenocysteine-specific elongation factor selB', 88, NULL, NULL, 82501),
(82502, '2.60.120.920-FF-000110', NULL, 'SPRY domain containing protein', 180, NULL, NULL, 82502),
(82503, '2.40.50.140-FF-000918', NULL, NULL, 134, NULL, NULL, 82503),
(82504, '3.30.230.10-FF-000408', NULL, 'RT5, ribosomal protein 5', 67, NULL, NULL, 82504),
(82505, '3.40.50.1980-FF-000078', NULL, 'Fe(3+) dicitrate-binding periplasmic protein', 168, NULL, NULL, 82505),
(82506, '1.10.600.10-FF-000062', NULL, 'Phytoene synthase', 267, NULL, NULL, 82506),
(82507, '3.60.15.10-FF-000048', NULL, 'Zn-dependent hydrolase/oxidoreductase family protein, putative', 318, NULL, NULL, 82507),
(82508, '1.20.1070.10-FF-000348', NULL, 'G protein-coupled receptor 150', 351, NULL, NULL, 82508),
(82509, '4.10.1000.10-FF-000153', NULL, 'Uncharacterized protein', 79, NULL, NULL, 82509),
(82510, '2.60.120.650-FF-000243', NULL, 'Uncharacterized protein', 73, NULL, NULL, 82510),
(82511, '2.60.40.420-FF-000081', NULL, 'Spore coat protein A', 177, NULL, NULL, 82511),
(82512, '1.25.40.20-FF-001460', NULL, 'Uncharacterized protein', 121, NULL, NULL, 82512),
(82513, '2.60.120.260-FF-000671', NULL, 'Uncharacterized protein', 149, NULL, NULL, 82513),
(82514, '3.30.420.40-FF-001056', NULL, 'Uncharacterized protein', 238, NULL, NULL, 82514),
(82515, '1.20.58.1420-FF-000005', NULL, 'Uncharacterized protein', 98, NULL, NULL, 82515),
(82516, '3.80.10.10-FF-004381', NULL, 'Uncharacterized protein', 170, NULL, NULL, 82516),
(82517, '1.20.58.60-FF-000067', NULL, 'Short stop, isoform K', 129, NULL, NULL, 82517),
(82518, '3.40.390.10-FF-000176', NULL, NULL, 89, NULL, NULL, 82518),
(82519, '3.10.10.10-FF-000039', NULL, NULL, 80, NULL, NULL, 82519),
(82520, '1.25.10.10-FF-002719', NULL, 'Cullin-associated NEDD8-dissociated protein 1', 1167, NULL, NULL, 82520),
(82521, '2.40.128.20-FF-000006', NULL, 'Fatty acid-binding protein, liver', 127, NULL, NULL, 82521),
(82522, '1.25.10.10-FF-003208', NULL, 'Predicted protein', 911, NULL, NULL, 82522),
(82523, '3.40.1410.10-FF-000004', NULL, 'Histidine utilization repressor', 136, NULL, NULL, 82523),
(82524, '1.10.3370.10-FF-000020', NULL, 'Uncharacterized protein', 62, NULL, NULL, 82524),
(82525, '1.25.10.10-FF-002377', NULL, 'Uncharacterized protein', 274, NULL, NULL, 82525),
(82526, '1.20.58.60-FF-000415', NULL, 'Microtubule-actin crosslinking factor 1', 120, NULL, NULL, 82526),
(82527, '3.60.110.10-FF-000090', NULL, NULL, 120, NULL, NULL, 82527),
(82528, '3.30.160.60-FF-002992', NULL, 'transcription factor grauzone', 70, NULL, NULL, 82528),
(82529, '3.40.50.300-FF-002936', NULL, 'ATP-dependent DNA helicase RecQ', 220, NULL, NULL, 82529),
(82530, '1.10.10.10-FF-001123', NULL, 'CRE-CUL-5 protein', 83, NULL, NULL, 82530),
(82531, '3.60.10.10-FF-000166', NULL, 'DNAse I family protein DHP2', 245, NULL, NULL, 82531),
(82532, '2.60.40.10-FF-002992', NULL, 'Chitinase', 95, NULL, NULL, 82532),
(82533, '3.30.40.10-FF-000046', NULL, 'RUN and FYVE domain containing 2', 82, NULL, NULL, 82533),
(82534, '2.60.220.50-FF-000063', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1b', 198, NULL, NULL, 82534),
(82535, '1.10.150.220-FF-000008', NULL, NULL, 38, NULL, NULL, 82535),
(82536, '2.10.25.10-FF-000132', NULL, 'Teneurin transmembrane protein 4', 29, NULL, NULL, 82536),
(82537, '3.40.1490.10-FF-000003', NULL, 'Peptidyl-tRNA hydrolase', 116, NULL, NULL, 82537),
(82538, '3.30.1440.10-FF-000002', NULL, '60S ribosomal protein L11', 172, NULL, NULL, 82538);
INSERT INTO "PUBLIC"."MODEL" VALUES
(82539, '3.40.718.10-FF-000056', NULL, 'Isocitrate dehydrogenase [NAD] subunit, mitochondrial', 347, NULL, NULL, 82539),
(82540, '3.40.50.1010-FF-000141', NULL, 'Uncharacterized protein', 199, NULL, NULL, 82540),
(82541, '1.10.8.60-FF-000400', NULL, 'Predicted protein', 56, NULL, NULL, 82541),
(82542, '2.60.120.290-FF-000101', NULL, 'Complement component 1, s subcomponent', 118, NULL, NULL, 82542),
(82543, '1.25.40.10-FF-000636', NULL, 'Pentatricopeptide repeat-containing protein', 116, NULL, NULL, 82543),
(82544, '2.60.40.150-FF-000769', NULL, 'Inositol polyphosphate-4-phosphatase type II B', 123, NULL, NULL, 82544),
(82545, '3.10.100.10-FF-000398', NULL, NULL, 119, NULL, NULL, 82545),
(82546, '2.60.40.150-FF-000775', NULL, 'Uncharacterized protein', 106, NULL, NULL, 82546),
(82547, '2.130.10.10-FF-000845', NULL, 'Uncharacterized protein, isoform B', 177, NULL, NULL, 82547),
(82548, '3.60.10.10-FF-000402', NULL, 'Predicted protein', 183, NULL, NULL, 82548),
(82549, '2.60.40.10-FF-005066', NULL, NULL, 101, NULL, NULL, 82549),
(82550, '2.30.130.40-FF-000009', NULL, 'ATP-dependent protease La domain-containing protein', 129, NULL, NULL, 82550),
(82551, '1.20.1560.10-FF-000094', NULL, 'ABC transporter B family member 28', 324, NULL, NULL, 82551),
(82552, '3.40.50.2000-FF-000680', NULL, 'Glycosyltransferase', 195, NULL, NULL, 82552),
(82553, '3.30.40.10-FF-000591', NULL, 'RING-H2 finger protein ATL65', 84, NULL, NULL, 82553),
(82554, '3.40.850.10-FF-000329', NULL, 'Kinesin family member heavy chain', 404, NULL, NULL, 82554),
(82555, '2.40.50.140-FF-000469', NULL, 'Protein lin-28', 86, NULL, NULL, 82555),
(82556, '2.30.130.30-FF-000006', NULL, 'Putative_zinc_finger_motif_-_C2HC5-type /ASCH_domain_containing_protein_-_putative', 112, NULL, NULL, 82556),
(82557, '3.30.160.60-FF-003481', NULL, 'Serendipity beta', 33, NULL, NULL, 82557),
(82558, '1.20.120.1770-FF-000005', NULL, 'Probable transmembrane ascorbate ferrireductase 3', 212, NULL, NULL, 82558),
(82559, '1.10.3660.10-FF-000008', NULL, 'Prephenate dehydrogenase', 121, NULL, NULL, 82559),
(82560, '1.20.1050.10-FF-000134', NULL, 'Glutathione S-transferase', 132, NULL, NULL, 82560),
(82561, '1.20.120.1780-FF-000008', NULL, 'Uncharacterized protein', 126, NULL, NULL, 82561),
(82562, '2.10.60.10-FF-000033', NULL, 'Receptor protein serine/threonine kinase', 96, NULL, NULL, 82562),
(82563, '3.90.70.80-FF-000015', NULL, 'Putative bifunctional UDP-N-acetylglucosamine transferase and deubiquitinase ALG13', 139, NULL, NULL, 82563),
(82564, '1.10.1520.10-FF-000043', NULL, 'Dicer-like protein 1', 201, NULL, NULL, 82564),
(82565, '1.10.287.70-FF-000434', NULL, 'Predicted protein', 110, NULL, NULL, 82565),
(82566, '3.10.10.10-FF-000045', NULL, NULL, 33, NULL, NULL, 82566),
(82567, '3.30.1390.40-FF-000001', NULL, 'Glucosidase YgjK', 32, NULL, NULL, 82567),
(82568, '1.10.510.10-FF-001920', NULL, 'Kinase, NEK', 206, NULL, NULL, 82568),
(82569, '3.90.15.10-FF-000013', NULL, 'DNA topoisomerase I, gene 2', 130, NULL, NULL, 82569),
(82570, '2.40.50.180-FF-000015', NULL, 'Chemotaxis protein CheW', 68, NULL, NULL, 82570),
(82571, '3.30.260.10-FF-000017', NULL, 'T-complex protein 1 subunit zeta', 36, NULL, NULL, 82571),
(82572, '2.120.10.10-FF-000019', NULL, 'Sialidase (Neuraminidase)', 359, NULL, NULL, 82572),
(82573, '3.20.20.80-FF-000330', NULL, 'Alpha-amylase MalA', 331, NULL, NULL, 82573),
(82574, '2.40.340.10-FF-000008', NULL, 'Molybdopterin molybdenumtransferase', 80, NULL, NULL, 82574),
(82575, '3.20.20.100-FF-000109', NULL, 'Uncharacterized protein', 296, NULL, NULL, 82575),
(82576, '2.60.40.3980-FF-000005', NULL, NULL, 52, NULL, NULL, 82576),
(82577, '1.10.1080.10-FF-000020', NULL, 'Glutathione synthetase', 79, NULL, NULL, 82577),
(82578, '3.30.1010.10-FF-000083', NULL, 'Uncharacterized protein', 121, NULL, NULL, 82578),
(82579, '3.90.640.10-FF-000033', NULL, 'Heat shock 70 kDa protein', 104, NULL, NULL, 82579),
(82580, '3.40.50.970-FF-000057', NULL, '2-oxoisovalerate dehydrogenase subunit alpha', 388, NULL, NULL, 82580),
(82581, '2.60.120.590-FF-000073', NULL, 'Predicted gene, 27027', 85, NULL, NULL, 82581);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(82582, '3.30.300.210-FF-000001', NULL, 'Ger(X)C family spore germination protein', 163, NULL, NULL, 82582),
(82583, '2.130.10.10-FF-002975', NULL, 'Component of the chromatin assembly complex (Eurofung)', 213, NULL, NULL, 82583),
(82584, '3.60.15.10-FF-000267', NULL, 'Uncharacterized protein', 108, NULL, NULL, 82584),
(82585, '3.20.20.100-FF-000216', NULL, 'Aldo-keto-reductase-like protein', 70, NULL, NULL, 82585),
(82586, '3.40.50.1820-FF-001587', NULL, 'Si:ch211-93f2.1', 91, NULL, NULL, 82586),
(82587, '1.10.150.20-FF-000316', NULL, 'Predicted protein', 15, NULL, NULL, 82587),
(82588, '1.20.1250.20-FF-000343', NULL, 'MFS transporter', 392, NULL, NULL, 82588),
(82589, '3.80.10.10-FF-002363', NULL, 'Uncharacterized protein', 122, NULL, NULL, 82589),
(82590, '3.30.420.40-FF-001062', NULL, 'Uncharacterized protein', 30, NULL, NULL, 82590),
(82591, '2.60.40.10-FF-001811', NULL, 'Obscurin like 1', 89, NULL, NULL, 82591),
(82592, '2.30.42.10-FF-000491', NULL, NULL, 109, NULL, NULL, 82592),
(82593, '3.40.50.1820-FF-000171', NULL, 'Neuroligin-4, Y-linked', 574, NULL, NULL, 82593),
(82594, '2.30.29.30-FF-000179', NULL, 'Nuclear pore complex protein Nup50', 122, NULL, NULL, 82594),
(82595, '3.30.200.40-FF-000005', NULL, 'Scavenger mRNA decapping enzyme, putative', 99, NULL, NULL, 82595),
(82596, '2.40.50.140-FF-001200', NULL, NULL, 96, NULL, NULL, 82596),
(82597, '2.40.50.140-FF-000582', NULL, 'Elongation factor Ts, mitochondrial', 81, NULL, NULL, 82597),
(82598, '3.30.70.330-FF-001080', NULL, 'non-POU domain-containing octamer-binding protein isoform X3', 59, NULL, NULL, 82598),
(82599, '1.10.246.90-FF-000008', NULL, 'Trans-splicing factor, putative', 111, NULL, NULL, 82599),
(82600, '3.40.50.300-FF-004499', NULL, 'Molybdate transport system ATP-binding protein', 238, NULL, NULL, 82600),
(82601, '3.80.10.10-FF-000233', NULL, 'Leucine-rich repeat receptor-like protein kinase TDR', 317, NULL, NULL, 82601),
(82602, '2.60.120.200-FF-000125', NULL, 'Usherin', 166, NULL, NULL, 82602),
(82603, '3.40.50.300-FF-003195', NULL, 'MutS homolog 3 (E. coli)', 280, NULL, NULL, 82603),
(82604, '1.10.510.10-FF-003045', NULL, NULL, 295, NULL, NULL, 82604),
(82605, '1.10.101.10-FF-000003', NULL, 'N-acetylmuramoyl-L-alanine amidase AmiD', 84, NULL, NULL, 82605),
(82606, '1.10.10.60-FF-000834', NULL, NULL, 69, NULL, NULL, 82606),
(82607, '2.60.120.260-FF-000558', NULL, 'Predicted protein', 48, NULL, NULL, 82607),
(82608, '3.30.40.10-FF-001102', NULL, 'Histone-lysine N-methyltransferase', 121, NULL, NULL, 82608),
(82609, '1.10.260.100-FF-000031', NULL, 'Uncharacterized protein', 55, NULL, NULL, 82609),
(82610, '1.25.40.20-FF-001572', NULL, 'S-acyltransferase', 53, NULL, NULL, 82610),
(82611, '2.130.10.10-FF-003700', NULL, 'Uncharacterized protein', 323, NULL, NULL, 82611),
(82612, '1.10.532.10-FF-000009', NULL, 'Signal transducer and activator of transcription 5A', 133, NULL, NULL, 82612),
(82613, '3.40.50.1220-FF-000086', NULL, 'Sulfoacetaldehyde acetyltransferase', 196, NULL, NULL, 82613),
(82614, '2.60.450.10-FF-000012', NULL, 'Lipopolysaccharide export system protein LptC', 130, NULL, NULL, 82614),
(82615, '3.60.40.10-FF-000011', NULL, 'probable protein phosphatase 2C 59', 259, NULL, NULL, 82615),
(82616, '2.60.120.260-FF-000665', NULL, 'Uncharacterized protein', 307, NULL, NULL, 82616),
(82617, '2.40.290.20-FF-000001', NULL, 'Chromo domain-containing protein 1', 160, NULL, NULL, 82617),
(82618, '1.25.40.10-FF-004907', NULL, 'Uncharacterized protein', 74, NULL, NULL, 82618),
(82619, '3.30.70.270-FF-000106', NULL, 'GGDEF family protein', 174, NULL, NULL, 82619),
(82620, '2.40.50.90-FF-000050', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 176, NULL, NULL, 82620),
(82621, '1.10.565.10-FF-000203', NULL, 'Uncharacterized protein', 170, NULL, NULL, 82621),
(82622, '3.30.1370.50-FF-000003', NULL, 'Transcriptional repressor NF-X1 isoform 1', 79, NULL, NULL, 82622),
(82623, '2.60.450.20-FF-000015', NULL, 'Uncharacterized protein', 182, NULL, NULL, 82623),
(82624, '2.30.30.380-FF-000011', NULL, 'Zinc finger RANBP2-type containing 3', 59, NULL, NULL, 82624);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(82625, '2.60.40.790-FF-000169', NULL, NULL, 103, NULL, NULL, 82625),
(82626, '3.30.200.20-FF-000921', NULL, 'Os02g0156000 protein', 96, NULL, NULL, 82626),
(82627, '2.30.42.10-FF-000502', NULL, NULL, 100, NULL, NULL, 82627),
(82628, '3.30.70.260-FF-000103', NULL, 'Methionine import ATP-binding protein MetN', 99, NULL, NULL, 82628),
(82629, '2.60.200.20-FF-000188', NULL, 'FHA domain-containing protein', 87, NULL, NULL, 82629),
(82630, '1.20.1230.10-FF-000007', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 273, NULL, NULL, 82630),
(82631, '3.40.50.1820-FF-000064', NULL, 'Sn1-specific diacylglycerol lipase beta', 259, NULL, NULL, 82631),
(82632, '2.40.290.30-FF-000004', NULL, 'PTOV1 isoform 17', 50, NULL, NULL, 82632),
(82633, '3.40.50.2300-FF-000337', NULL, 'Metabotropic glutamate receptor 1', 137, NULL, NULL, 82633),
(82634, '3.80.10.10-FF-004504', NULL, 'Predicted protein', 145, NULL, NULL, 82634),
(82635, '3.40.50.300-FF-001065', NULL, 'DNA repair protein RAD50 isoform X1', 239, NULL, NULL, 82635),
(82636, '1.25.40.10-FF-002873', NULL, 'Chromosome 8, whole genome shotgun sequence', 267, NULL, NULL, 82636),
(82637, '3.40.50.300-FF-003206', NULL, 'Iron-sulfur cluster carrier protein', 259, NULL, NULL, 82637),
(82638, '3.40.50.10140-FF-000046', NULL, 'Putative phosphoinositide 3-kinase adapter protein 1', 138, NULL, NULL, 82638),
(82639, '3.40.50.2000-FF-000348', NULL, 'UDP-glycosyltransferase 83A1', 265, NULL, NULL, 82639),
(82640, '3.30.70.330-FF-002277', NULL, NULL, 75, NULL, NULL, 82640),
(82641, '1.20.1070.10-FF-000129', NULL, 'Prostaglandin F2-alpha receptor', 316, NULL, NULL, 82641),
(82642, '2.20.70.10-FF-000247', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-36 specific', 53, NULL, NULL, 82642),
(82643, '2.30.29.230-FF-000009', NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', 110, NULL, NULL, 82643),
(82644, '3.10.450.40-FF-000040', NULL, 'Amine oxidase', 128, NULL, NULL, 82644),
(82645, '3.40.50.620-FF-000317', NULL, 'Tyrosine--tRNA ligase', 211, NULL, NULL, 82645),
(82646, '3.30.160.60-FF-003155', NULL, NULL, 30, NULL, NULL, 82646),
(82647, '1.20.1070.10-FF-001990', NULL, 'Uncharacterized protein', 155, NULL, NULL, 82647),
(82648, '3.80.10.10-FF-004274', NULL, 'Uncharacterized protein', 53, NULL, NULL, 82648),
(82649, '2.30.29.220-FF-000006', NULL, 'FACT complex subunit SSRP1', 81, NULL, NULL, 82649),
(82650, '1.25.10.10-FF-001409', NULL, 'Uncharacterized protein', 157, NULL, NULL, 82650),
(82651, '2.60.120.200-FF-000018', NULL, 'Calreticulin 1b', 245, NULL, NULL, 82651),
(82652, '2.10.110.10-FF-000329', NULL, 'LIM protein', 69, NULL, NULL, 82652),
(82653, '2.60.40.10-FF-003722', NULL, NULL, 95, NULL, NULL, 82653),
(82654, '3.30.70.1430-FF-000005', NULL, 'Multidrug resistance protein MdtB', 99, NULL, NULL, 82654),
(82655, '3.30.230.70-FF-000168', NULL, 'Exosome component 6', 142, NULL, NULL, 82655),
(82656, '1.25.40.20-FF-001353', NULL, 'Uncharacterized protein', 102, NULL, NULL, 82656),
(82657, '3.30.200.20-FF-000808', NULL, 'Protein Kinase N (PKN) homolog', 115, NULL, NULL, 82657),
(82658, '3.10.129.110-FF-000007', NULL, 'Phthiocerol synthesis polyketide synthase type I PpsC', 294, NULL, NULL, 82658),
(82659, '4.10.530.10-FF-000005', NULL, 'Fibrinogen-like protein 1-like protein', 58, NULL, NULL, 82659),
(82660, '1.20.1270.60-FF-000103', NULL, 'Hof1p', 275, NULL, NULL, 82660),
(82661, '3.40.50.300-FF-005336', NULL, 'Heparan-sulfate 6-O-sulfotransferase', 144, NULL, NULL, 82661),
(82662, '2.120.10.30-FF-000357', NULL, 'Predicted protein', 85, NULL, NULL, 82662),
(82663, '2.30.42.10-FF-000378', NULL, NULL, 102, NULL, NULL, 82663),
(82664, '3.40.50.150-FF-001093', NULL, NULL, 194, NULL, NULL, 82664),
(82665, '3.30.160.60-FF-002767', NULL, 'Zinc finger protein 955A', 39, NULL, NULL, 82665),
(82666, '1.10.20.140-FF-000002', NULL, 'tRNA dimethylallyltransferase, mitochondrial', 75, NULL, NULL, 82666),
(82667, '3.30.342.10-FF-000005', NULL, 'DNA polymerase epsilon catalytic subunit', 158, NULL, NULL, 82667),
(82668, '1.20.1250.10-FF-000008', NULL, 'Leptin', 146, NULL, NULL, 82668);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(82669, '3.40.50.2030-FF-000003', NULL, 'Carbon monoxide dehydrogenase', 214, NULL, NULL, 82669),
(82670, '3.40.50.720-FF-002034', NULL, 'Uncharacterized protein', 190, NULL, NULL, 82670),
(82671, '3.40.50.11000-FF-000001', NULL, 'Fe-S cluster assembly protein DRE2', 133, NULL, NULL, 82671),
(82672, '3.30.70.1440-FF-000008', NULL, 'RND multidrug efflux transporter', 101, NULL, NULL, 82672),
(82673, '3.30.70.270-FF-000325', NULL, NULL, 183, NULL, NULL, 82673),
(82674, '1.20.120.1240-FF-000077', NULL, 'Predicted protein', 204, NULL, NULL, 82674),
(82675, '2.60.120.650-FF-000018', NULL, 'HSPB1-associated protein 1 homolog', 262, NULL, NULL, 82675),
(82676, '3.40.630.10-FF-000347', NULL, 'Uncharacterized protein', 220, NULL, NULL, 82676),
(82677, '1.25.10.10-FF-000808', NULL, 'Adaptor related protein complex 3 subunit delta 1', 265, NULL, NULL, 82677),
(82678, '1.20.58.60-FF-000180', NULL, 'Spectrin repeat containing nuclear envelope protein 2', 214, NULL, NULL, 82678),
(82679, '1.20.58.60-FF-000292', NULL, 'Microtubule-actin cross-linking factor 1, isoforms 1/2/3/5', 104, NULL, NULL, 82679),
(82680, '3.40.367.20-FF-000041', NULL, 'Phosphotransferase', 35, NULL, NULL, 82680),
(82681, '1.25.10.10-FF-003102', NULL, 'Integrator complex subunit 4 homolog', 222, NULL, NULL, 82681),
(82682, '3.40.50.300-FF-007247', NULL, 'Uncharacterized protein', 160, NULL, NULL, 82682),
(82683, '1.25.40.10-FF-003710', NULL, 'Os09g0411600 protein', 71, NULL, NULL, 82683),
(82684, '1.20.1280.290-FF-000007', NULL, 'Bidirectional sugar transporter SWEET7', 90, NULL, NULL, 82684),
(82685, '1.20.1250.20-FF-000562', NULL, 'Minor myo-inositol transporter iolF', 394, NULL, NULL, 82685),
(82686, '1.20.1070.10-FF-000461', NULL, 'D(5)-like dopamine receptor', 315, NULL, NULL, 82686),
(82687, '3.80.10.10-FF-003667', NULL, 'Uncharacterized protein', 69, NULL, NULL, 82687),
(82688, '1.25.10.10-FF-003091', NULL, 'Exportin-T', 225, NULL, NULL, 82688),
(82689, '1.20.1260.10-FF-000054', NULL, 'Ferritin', 173, NULL, NULL, 82689),
(82690, '1.10.1280.10-FF-000001', NULL, '5,6-dihydroxyindole-2-carboxylic acid oxidase', 352, NULL, NULL, 82690),
(82691, '3.40.850.10-FF-000436', NULL, 'Predicted protein', 143, NULL, NULL, 82691),
(82692, '2.160.20.10-FF-000294', NULL, 'Uncharacterized protein', 170, NULL, NULL, 82692),
(82693, '2.30.29.30-FF-000292', NULL, 'sesquipedalian-2 isoform X2', 111, NULL, NULL, 82693),
(82694, '3.40.50.1220-FF-000103', NULL, 'ACR211Wp', 158, NULL, NULL, 82694),
(82695, '1.10.10.60-FF-001216', NULL, NULL, 79, NULL, NULL, 82695),
(82696, '2.60.120.10-FF-000240', NULL, 'Cyclic nucleotide-binding domain protein', 137, NULL, NULL, 82696),
(82697, '3.30.70.330-FF-002390', NULL, NULL, 97, NULL, NULL, 82697),
(82698, '1.20.1070.10-FF-000242', NULL, 'Uncharacterized protein', 333, NULL, NULL, 82698),
(82699, '3.60.40.10-FF-000117', NULL, 'Protein phosphatase 2C-like protein', 300, NULL, NULL, 82699),
(82700, '1.10.238.10-FF-001220', NULL, 'Uncharacterized protein', 131, NULL, NULL, 82700),
(82701, '1.25.40.10-FF-001350', NULL, 'Penicillin-binding protein activator LpoA', 123, NULL, NULL, 82701),
(82702, '1.20.1740.10-FF-000203', NULL, 'Uncharacterized protein', 161, NULL, NULL, 82702),
(82703, '1.20.58.1120-FF-000016', NULL, 'Axonemal dynein heavy chain', 145, NULL, NULL, 82703),
(82704, '1.10.510.10-FF-003157', NULL, NULL, 174, NULL, NULL, 82704),
(82705, '1.10.472.10-FF-000297', NULL, 'Cyclin, N-terminal domain containing protein', 148, NULL, NULL, 82705),
(82706, '3.40.50.1820-FF-000283', NULL, 'Alpha/beta fold hydrolase', 307, NULL, NULL, 82706),
(82707, '3.20.20.80-FF-000217', NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', 293, NULL, NULL, 82707),
(82708, '3.30.470.20-FF-000053', NULL, 'Acetyl-/propionyl-coenzyme A carboxylase alpha chain', 253, NULL, NULL, 82708),
(82709, '1.25.40.10-FF-000855', NULL, 'Pentatricopeptide repeat-containing protein', 146, NULL, NULL, 82709),
(82710, '1.20.1440.180-FF-000017', NULL, 'Uncharacterized protein', 81, NULL, NULL, 82710),
(82711, '3.40.366.10-FF-000069', NULL, 'Uncharacterized protein', 89, NULL, NULL, 82711);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(82712, '3.20.20.70-FF-000214', NULL, 'Deoxyribose-phosphate aldolase', 157, NULL, NULL, 82712),
(82713, '3.40.50.12780-FF-000175', NULL, 'Long-chain-fatty-acid-coA ligase protein,putative', 323, NULL, NULL, 82713),
(82714, '3.30.470.10-FF-000050', NULL, 'Uncharacterized protein HI_1169', 79, NULL, NULL, 82714),
(82715, '1.20.1440.170-FF-000014', NULL, NULL, 108, NULL, NULL, 82715),
(82716, '1.10.287.70-FF-000215', NULL, 'Predicted protein', 146, NULL, NULL, 82716),
(82717, '2.60.40.10-FF-003161', NULL, 'Titin, tandem duplicate 1', 99, NULL, NULL, 82717),
(82718, '1.20.1280.270-FF-000001', NULL, 'Bifunctional arginine demethylase and lysyl-hydroxylase JMJD6', 44, NULL, NULL, 82718),
(82719, '2.130.10.30-FF-000042', NULL, 'Guanidine nucleotide exchange factor', 176, NULL, NULL, 82719),
(82720, '3.30.1590.10-FF-000002', NULL, 'Malto-oligosyltrehalose synthase', 131, NULL, NULL, 82720),
(82721, '3.30.70.330-FF-000366', NULL, 'Lupus La protein homolog', 101, NULL, NULL, 82721),
(82722, '3.30.70.330-FF-002058', NULL, NULL, 176, NULL, NULL, 82722),
(82723, '3.40.50.620-FF-000536', NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', 402, NULL, NULL, 82723),
(82724, '3.80.10.10-FF-003779', NULL, 'Putative leucine-rich repeat-containing protein DDB_G0281931', 104, NULL, NULL, 82724),
(82725, '3.60.60.10-FF-000006', NULL, 'N-acylethanolamine-hydrolyzing acid amidase', 252, NULL, NULL, 82725),
(82726, '3.40.50.2000-FF-000567', NULL, 'UDP glucuronosyltransferase 2 family, polypeptide A4', 195, NULL, NULL, 82726),
(82727, '3.30.160.60-FF-004791', NULL, NULL, 29, NULL, NULL, 82727),
(82728, '3.30.460.10-FF-000004', NULL, 'Ribosomal silencing factor RsfS', 104, NULL, NULL, 82728),
(82729, '1.10.10.10-FF-001230', NULL, 'Vacuolar protein sorting 36, putative', 70, NULL, NULL, 82729),
(82730, '3.30.470.30-FF-000056', NULL, 'Uncharacterized protein', 216, NULL, NULL, 82730),
(82731, '1.25.40.20-FF-000858', NULL, 'Nek-like kinase protein', 119, NULL, NULL, 82731),
(82732, '3.30.110.60-FF-000004', NULL, 'RNA-binding CRS1 / YhbY (CRM) domain protein', 100, NULL, NULL, 82732),
(82733, '2.160.20.10-FF-000075', NULL, 'Pectinesterase', 325, NULL, NULL, 82733),
(82734, '3.30.40.10-FF-000484', NULL, 'Histone-lysine N-methyltransferase ATX4', 77, NULL, NULL, 82734),
(82735, '2.170.130.10-FF-000052', NULL, NULL, 94, NULL, NULL, 82735),
(82736, '1.20.1250.20-FF-002248', NULL, 'Uncharacterized protein', 111, NULL, NULL, 82736),
(82737, '3.40.50.300-FF-006972', NULL, 'ABC transporter', 219, NULL, NULL, 82737),
(82738, '2.60.120.260-FF-000446', NULL, 'Nuclear receptor 2C2-associated protein', 128, NULL, NULL, 82738),
(82739, '3.30.1460.20-FF-000001', NULL, 'Actin-related protein 2/3 complex subunit 4', 168, NULL, NULL, 82739),
(82740, '3.40.390.10-FF-000069', NULL, 'Oligopeptidase A', 149, NULL, NULL, 82740),
(82741, '3.40.30.10-FF-001192', NULL, 'Uncharacterized protein', 93, NULL, NULL, 82741),
(82742, '1.20.1070.10-FF-001658', NULL, 'Atypical chemokine receptor 2', 128, NULL, NULL, 82742),
(82743, '2.30.42.10-FF-000159', NULL, 'amyloid beta A4 precursor protein-binding family A member 3', 94, NULL, NULL, 82743),
(82744, '1.10.8.100-FF-000029', NULL, 'Ribosomal RNA small subunit methyltransferase A', 68, NULL, NULL, 82744),
(82745, '3.30.710.10-FF-000327', NULL, 'Ci-BCL6-like C2H2 Zinc finger protein', 148, NULL, NULL, 82745),
(82746, '3.30.70.330-FF-000927', NULL, 'Putative RNA-binding protein', 104, NULL, NULL, 82746),
(82747, '1.20.5.170-FF-000211', NULL, 'Tropomyosin', 132, NULL, NULL, 82747),
(82748, '1.10.10.2320-FF-000002', NULL, 'Phenylalanyl-tRNA synthetase alpha chain B, putative', 43, NULL, NULL, 82748),
(82749, '3.40.50.720-FF-002253', NULL, 'Uncharacterized protein', 68, NULL, NULL, 82749),
(82750, '3.30.420.10-FF-000114', NULL, 'Werner Syndrome-like exonuclease', 205, NULL, NULL, 82750),
(82751, '3.10.129.10-FF-000155', NULL, 'CurJ', 132, NULL, NULL, 82751),
(82752, '3.10.100.10-FF-000409', NULL, NULL, 107, NULL, NULL, 82752),
(82753, '3.90.660.10-FF-000034', NULL, 'Oxidoreductase', 191, NULL, NULL, 82753),
(82754, '3.30.70.3220-FF-000003', NULL, 'Multifunctional fusion protein', 156, NULL, NULL, 82754);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(82755, '3.30.190.20-FF-000014', NULL, 'Ribosomal protein', 43, NULL, NULL, 82755),
(82756, '1.10.10.1210-FF-000006', NULL, NULL, 118, NULL, NULL, 82756),
(82757, '1.20.120.520-FF-000006', NULL, 'Zinc finger protein BRUTUS', 151, NULL, NULL, 82757),
(82758, '3.40.50.800-FF-000034', NULL, 'Histidine--tRNA ligase', 96, NULL, NULL, 82758),
(82759, '1.10.10.60-FF-000598', NULL, 'Two-component system sensor histidine kinase/response regulator', 55, NULL, NULL, 82759),
(82760, '3.30.1460.30-FF-000004', NULL, 'DNA transformation protein TfoX1', 102, NULL, NULL, 82760),
(82761, '2.40.50.140-FF-000812', NULL, NULL, 127, NULL, NULL, 82761),
(82762, '2.30.29.210-FF-000003', NULL, 'Metallopeptidase family M24 containing protein, expressed', 123, NULL, NULL, 82762),
(82763, '1.20.1310.10-FF-000177', NULL, NULL, 123, NULL, NULL, 82763),
(82764, '3.30.160.60-FF-003374', NULL, 'GD10244', 26, NULL, NULL, 82764),
(82765, '1.10.10.2330-FF-000005', NULL, 'phenylalanine--tRNA ligase alpha subunit', 54, NULL, NULL, 82765),
(82766, '3.60.15.10-FF-000155', NULL, 'Metallo-hydrolase/oxidoreductase', 111, NULL, NULL, 82766),
(82767, '3.40.50.2300-FF-000775', NULL, NULL, 131, NULL, NULL, 82767),
(82768, '3.40.710.10-FF-000044', NULL, 'D-alanyl-D-alanine carboxypeptidase', 264, NULL, NULL, 82768),
(82769, '2.20.100.10-FF-000219', NULL, 'Uncharacterized protein', 64, NULL, NULL, 82769),
(82770, '3.60.20.10-FF-000009', NULL, 'Proteasome subunit alpha type-3', 253, NULL, NULL, 82770),
(82771, '2.40.250.10-FF-000001', NULL, 'Core-binding factor subunit beta', 142, NULL, NULL, 82771),
(82772, '3.30.559.10-FF-000194', NULL, 'Putative diacylglycerol O-acyltransferase', 151, NULL, NULL, 82772),
(82773, '3.30.160.60-FF-001463', NULL, 'zinc finger protein 524', 27, NULL, NULL, 82773),
(82774, '3.40.850.10-FF-000217', NULL, 'Kinesin eg-5, putative', 232, NULL, NULL, 82774),
(82775, '3.20.140.10-FF-000016', NULL, 'Nicotinate phosphoribosyltransferase', 256, NULL, NULL, 82775),
(82776, '3.40.50.300-FF-001284', NULL, 'P-loop NTPase domain-containing protein LPA1', 162, NULL, NULL, 82776),
(82777, '1.25.40.10-FF-002654', NULL, 'Protein CBG23745', 305, NULL, NULL, 82777),
(82778, '2.60.40.60-FF-000854', NULL, 'Uncharacterized protein', 59, NULL, NULL, 82778),
(82779, '3.40.350.10-FF-000073', NULL, 'Transporter', 162, NULL, NULL, 82779),
(82780, '1.10.275.30-FF-000002', NULL, 'DNA excision repair protein ERCC-2', 130, NULL, NULL, 82780),
(82781, '3.30.160.60-FF-001805', NULL, 'zinc finger protein 385A isoform X2', 43, NULL, NULL, 82781),
(82782, '1.25.40.10-FF-005060', NULL, 'Pentatricopeptide repeat-containing protein At1g62670, mitochondrial', 106, NULL, NULL, 82782),
(82783, '2.60.40.10-FF-003048', NULL, 'Uncharacterized protein, isoform B', 90, NULL, NULL, 82783),
(82784, '1.25.40.10-FF-004784', NULL, 'Superkiller protein 3', 288, NULL, NULL, 82784),
(82785, '1.10.150.20-FF-000193', NULL, 'DNA polymerase I', 150, NULL, NULL, 82785),
(82786, '1.10.630.10-FF-000226', NULL, 'Cytochrome P-450 monooxygenase DoxA', 413, NULL, NULL, 82786),
(82787, '3.30.930.10-FF-000310', NULL, 'Alanine--tRNA ligase', 254, NULL, NULL, 82787),
(82788, '3.30.1240.10-FF-000015', NULL, 'HAD family hydrolase', 128, NULL, NULL, 82788),
(82789, '1.10.3720.10-FF-000177', NULL, 'ABC transporter, permease protein', 265, NULL, NULL, 82789),
(82790, '3.40.1160.10-FF-000012', NULL, 'Aspartokinase', 195, NULL, NULL, 82790),
(82791, '2.60.120.290-FF-000207', NULL, 'Uncharacterized protein', 121, NULL, NULL, 82791),
(82792, '3.40.50.720-FF-000673', NULL, 'Pyrroline-5-carboxylate reductase', 150, NULL, NULL, 82792),
(82793, '3.10.20.870-FF-000016', NULL, NULL, 77, NULL, NULL, 82793),
(82794, '2.60.40.10-FF-004684', NULL, NULL, 86, NULL, NULL, 82794),
(82795, '2.60.120.10-FF-000021', NULL, 'Quercetin 2,3-dioxygenase', 121, NULL, NULL, 82795),
(82796, '1.10.510.10-FF-001027', NULL, 'Putative serine/threonine-protein kinase', 193, NULL, NULL, 82796),
(82797, '1.10.510.10-FF-001701', NULL, 'Phosphorylase kinase catalytic subunit gamma 2', 181, NULL, NULL, 82797),
(82798, '2.130.10.10-FF-001227', NULL, 'WD repeat domain 93', 198, NULL, NULL, 82798);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(82799, '3.40.50.300-FF-001626', NULL, 'ATP-dependent helicase/nuclease subunit A', 126, NULL, NULL, 82799),
(82800, '3.40.50.2000-FF-000461', NULL, 'Beta-1,4-mannosyltransferase', 172, NULL, NULL, 82800),
(82801, '2.60.120.20-FF-000024', NULL, NULL, 172, NULL, NULL, 82801),
(82802, '3.40.50.2300-FF-001051', NULL, NULL, 137, NULL, NULL, 82802),
(82803, '3.40.50.80-FF-000218', NULL, 'Uncharacterized protein', 122, NULL, NULL, 82803),
(82804, '3.30.450.20-FF-000164', NULL, 'Sensor histidine kinase', 128, NULL, NULL, 82804),
(82805, '3.80.10.10-FF-001649', NULL, 'Uncharacterized protein', 197, NULL, NULL, 82805),
(82806, '3.30.200.20-FF-001303', NULL, 'Uncharacterized protein', 140, NULL, NULL, 82806),
(82807, '1.20.58.60-FF-000179', NULL, 'Spectrin beta chain', 106, NULL, NULL, 82807),
(82808, '3.30.450.70-FF-000044', NULL, NULL, 136, NULL, NULL, 82808),
(82809, '3.30.200.20-FF-002265', NULL, 'Chromosome 1, whole genome shotgun sequence', 170, NULL, NULL, 82809),
(82810, '1.10.840.10-FF-000040', NULL, 'Uncharacterized protein', 303, NULL, NULL, 82810),
(82811, '3.40.50.1370-FF-000007', NULL, 'Aspartate carbamoyltransferase', 156, NULL, NULL, 82811),
(82812, '3.30.450.20-FF-000506', NULL, 'IcfG protein', 177, NULL, NULL, 82812),
(82813, '4.10.1000.10-FF-000041', NULL, 'Pre-mRNA-splicing factor CWC24', 32, NULL, NULL, 82813),
(82814, '3.40.50.2000-FF-000803', NULL, 'Glycosyl transferase, family 9', 169, NULL, NULL, 82814),
(82815, '2.30.29.30-FF-000073', NULL, 'Pleckstrin homology domain-containing family B member 2', 110, NULL, NULL, 82815),
(82816, '3.30.1490.80-FF-000037', NULL, 'Glutathione synthetase', 14, NULL, NULL, 82816),
(82817, '2.40.70.10-FF-000297', NULL, NULL, 113, NULL, NULL, 82817),
(82818, '2.130.10.10-FF-004993', NULL, 'Uncharacterized protein', 71, NULL, NULL, 82818),
(82819, '3.30.70.330-FF-003114', NULL, NULL, 70, NULL, NULL, 82819),
(82820, '3.30.200.20-FF-001989', NULL, 'CMGC family protein kinase', 98, NULL, NULL, 82820),
(82821, '3.30.160.60-FF-005392', NULL, NULL, 24, NULL, NULL, 82821),
(82822, '3.90.176.10-FF-000010', NULL, 'NAD(P)(+)--arginine ADP-ribosyltransferase', 225, NULL, NULL, 82822),
(82823, '3.40.50.1360-FF-000004', NULL, 'Glucosamine-6-phosphate isomerase', 276, NULL, NULL, 82823),
(82824, '1.20.1250.20-FF-002361', NULL, 'LL-diaminopimelate aminotransferase chloroplastic', 69, NULL, NULL, 82824),
(82825, '3.30.70.330-FF-000708', NULL, 'Polyadenylate-binding protein, putative', 97, NULL, NULL, 82825),
(82826, '2.30.29.30-FF-000634', NULL, 'Serine/threonine protein kinase', 103, NULL, NULL, 82826),
(82827, '2.130.10.10-FF-004555', NULL, 'Uncharacterized protein', 216, NULL, NULL, 82827),
(82828, '1.10.150.670-FF-000008', NULL, 'Crossover junction endonuclease MUS81', 79, NULL, NULL, 82828),
(82829, '3.80.10.10-FF-001981', NULL, 'Receptor kinase-like protein Xa21', 95, NULL, NULL, 82829),
(82830, '1.25.40.10-FF-001018', NULL, 'Uncharacterized protein', 147, NULL, NULL, 82830),
(82831, '3.40.50.300-FF-000103', NULL, 'Chromosomal replication initiator protein DnaA', 168, NULL, NULL, 82831),
(82832, '3.60.20.10-FF-000122', NULL, 'Proteasome subunit beta type-1, putative', 207, NULL, NULL, 82832),
(82833, '1.20.1560.10-FF-000330', NULL, 'Uncharacterized protein', 343, NULL, NULL, 82833),
(82834, '1.10.10.60-FF-000379', NULL, 'Hex homeobox', 78, NULL, NULL, 82834),
(82835, '3.40.50.720-FF-000235', NULL, 'UDP-N-acetyl-D-mannosamine dehydrogenase', 183, NULL, NULL, 82835),
(82836, '1.10.510.10-FF-003500', NULL, NULL, 256, NULL, NULL, 82836),
(82837, '3.40.50.300-FF-005230', NULL, 'Thymidylate kinase', 201, NULL, NULL, 82837),
(82838, '1.20.1050.130-FF-000037', NULL, 'tRNA-aminoacylation cofactor arc1', 169, NULL, NULL, 82838),
(82839, '1.20.1070.10-FF-002153', NULL, 'Uncharacterized protein', 164, NULL, NULL, 82839),
(82840, '3.40.50.300-FF-004954', NULL, 'ABC transporter, putative', 173, NULL, NULL, 82840),
(82841, '3.30.450.60-FF-000041', NULL, 'Putative coatomer zeta subunit', 156, NULL, NULL, 82841),
(82842, '1.20.1070.10-FF-001877', NULL, 'Uncharacterized protein', 373, NULL, NULL, 82842);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(82843, '1.10.418.40-FF-000017', NULL, 'Uncharacterized protein', 237, NULL, NULL, 82843),
(82844, '3.10.350.10-FF-000096', NULL, 'Lipoprotein', 68, NULL, NULL, 82844),
(82845, '3.30.230.10-FF-000178', NULL, 'MUTL-2', 142, NULL, NULL, 82845),
(82846, '1.10.238.10-FF-001107', NULL, 'N-terminal EF-hand calcium binding protein 3', 60, NULL, NULL, 82846),
(82847, '2.30.30.40-FF-000489', NULL, 'Predicted protein', 86, NULL, NULL, 82847),
(82848, '1.10.287.770-FF-000026', NULL, 'T-cell surface glycoprotein CD3 delta chain', 43, NULL, NULL, 82848),
(82849, '3.40.30.10-FF-001079', NULL, 'Predicted protein', 142, NULL, NULL, 82849),
(82850, '3.30.160.60-FF-000749', NULL, 'Transcriptional regulator Kaiso', 48, NULL, NULL, 82850),
(82851, '1.10.260.40-FF-000066', NULL, 'Homeobox protein cut-like', 82, NULL, NULL, 82851),
(82852, '3.50.50.60-FF-000364', NULL, 'Possible oxidoreductase', 363, NULL, NULL, 82852),
(82853, '1.10.510.10-FF-001246', NULL, 'Protein CBG15711', 218, NULL, NULL, 82853),
(82854, '3.30.1370.10-FF-000238', NULL, 'Uncharacterized protein', 52, NULL, NULL, 82854),
(82855, '3.40.190.10-FF-000195', NULL, 'Glutamate receptor 2.7', 101, NULL, NULL, 82855),
(82856, '3.80.10.10-FF-002144', NULL, 'Receptor like protein 29', 104, NULL, NULL, 82856),
(82857, '3.30.40.10-FF-002283', NULL, 'Uncharacterized protein', 46, NULL, NULL, 82857),
(82858, '1.20.58.1180-FF-000006', NULL, '54S ribosomal protein L35, mitochondrial', 91, NULL, NULL, 82858),
(82859, '2.60.40.10-FF-000974', NULL, 'Collagen alpha-1(XX) chain', 90, NULL, NULL, 82859),
(82860, '2.60.40.60-FF-001017', NULL, 'Uncharacterized protein', 32, NULL, NULL, 82860),
(82861, '2.60.40.60-FF-000399', NULL, 'Dachsous, isoform B', 108, NULL, NULL, 82861),
(82862, '2.60.40.10-FF-001250', NULL, 'ADAMTS like 3', 77, NULL, NULL, 82862),
(82863, '1.10.486.10-FF-000019', NULL, 'RecBCD enzyme subunit RecB', 144, NULL, NULL, 82863),
(82864, '6.10.250.3370-FF-000003', NULL, 'Petrobactin biosynthesis protein AsbB', 42, NULL, NULL, 82864),
(82865, '1.10.287.380-FF-000016', NULL, 'ABC transporter ATP-binding protein uup', 89, NULL, NULL, 82865),
(82866, '3.30.780.10-FF-000039', NULL, 'Translation initiation factor 1, prokaryotic', 78, NULL, NULL, 82866),
(82867, '3.30.1420.10-FF-000001', NULL, 'Sulfurtransferase', 38, NULL, NULL, 82867),
(82868, '3.80.10.10-FF-001868', NULL, 'At1g04210', 187, NULL, NULL, 82868),
(82869, '1.20.1540.10-FF-000109', NULL, 'Rhomboid, veinlet-like 2 (Drosophila) (Predicted)', 140, NULL, NULL, 82869),
(82870, '3.30.430.20-FF-000056', NULL, 'Cysteine-rich repeat secretory protein 38', 107, NULL, NULL, 82870),
(82871, '1.10.287.370-FF-000013', NULL, 'Prefoldin subunit beta', 113, NULL, NULL, 82871),
(82872, '3.30.750.24-FF-000079', NULL, 'Os01g0593700 protein', 131, NULL, NULL, 82872),
(82873, '3.60.110.10-FF-000101', NULL, NULL, 143, NULL, NULL, 82873),
(82874, '3.10.110.10-FF-000348', NULL, 'Ubiquitin-conjugating enzyme family protein', 149, NULL, NULL, 82874),
(82875, '1.20.1160.20-FF-000004', NULL, 'Cerebral cavernous malformation 2', 98, NULL, NULL, 82875),
(82876, '1.10.630.10-FF-000007', NULL, 'Cytochrome P450 76C4', 470, NULL, NULL, 82876),
(82877, '3.30.1510.10-FF-000008', NULL, 'Protein CBG27847', 96, NULL, NULL, 82877),
(82878, '1.20.5.500-FF-000012', NULL, NULL, 70, NULL, NULL, 82878),
(82879, '3.30.160.60-FF-004897', NULL, NULL, 35, NULL, NULL, 82879),
(82880, '3.30.160.60-FF-004678', NULL, NULL, 59, NULL, NULL, 82880),
(82881, '1.25.10.10-FF-000685', NULL, 'ARM repeat-containing protein', 74, NULL, NULL, 82881),
(82882, '1.50.40.10-FF-000100', NULL, 'Mitochondrial glycine transporter', 147, NULL, NULL, 82882),
(82883, '2.130.10.10-FF-001008', NULL, 'Small nucleolar ribonucleo protein complex subunit', 199, NULL, NULL, 82883),
(82884, '3.30.70.600-FF-000014', NULL, '40S ribosomal protein S20-1', 97, NULL, NULL, 82884),
(82885, '1.20.80.10-FF-000019', NULL, 'E3 ubiquitin-protein ligase MYLIP', 103, NULL, NULL, 82885),
(82886, '1.10.400.10-FF-000075', NULL, 'Guanine nucleotide-binding protein alpha-1 subunit', 118, NULL, NULL, 82886);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(82887, '2.30.29.30-FF-000415', NULL, 'Cell 12A endoglucanase', 123, NULL, NULL, 82887),
(82888, '3.30.565.10-FF-000484', NULL, 'Uncharacterized protein', 53, NULL, NULL, 82888),
(82889, '3.90.70.10-FF-000489', NULL, 'Uncharacterized protein', 149, NULL, NULL, 82889),
(82890, '1.20.5.1190-FF-000003', NULL, 'Sodium channel protein', 29, NULL, NULL, 82890),
(82891, '3.30.160.60-FF-005173', NULL, NULL, 50, NULL, NULL, 82891),
(82892, '1.10.10.600-FF-000003', NULL, 'FeS assembly protein IscX', 77, NULL, NULL, 82892),
(82893, '3.10.580.10-FF-000141', NULL, 'Chloride channel protein', 120, NULL, NULL, 82893),
(82894, '2.10.25.10-FF-001548', NULL, 'Predicted protein', 70, NULL, NULL, 82894),
(82895, '1.20.1270.10-FF-000116', NULL, 'DnaK protein', 87, NULL, NULL, 82895),
(82896, '2.130.10.10-FF-001901', NULL, 'Coronin', 84, NULL, NULL, 82896),
(82897, '3.90.930.12-FF-000018', NULL, 'Plastid ribosomal protein L6', 97, NULL, NULL, 82897),
(82898, '1.10.238.270-FF-000007', NULL, 'Odorant-binding protein 50a, isoform B', 170, NULL, NULL, 82898),
(82899, '3.40.190.10-FF-000537', NULL, 'ABC transporter substrate-binding protein', 155, NULL, NULL, 82899),
(82900, '3.30.160.20-FF-000063', NULL, 'Dicer-like 103', 70, NULL, NULL, 82900),
(82901, '3.30.40.10-FF-001788', NULL, 'Predicted protein', 46, NULL, NULL, 82901),
(82902, '1.20.58.1880-FF-000008', NULL, 'TSL-kinase interacting protein 1', 89, NULL, NULL, 82902),
(82903, '1.10.238.10-FF-000489', NULL, 'Phosphoinositide phospholipase C', 96, NULL, NULL, 82903),
(82904, '3.30.200.20-FF-000685', NULL, 'Calcium and calcium/calmodulin-dependent serine/threonine-protein kinase', 59, NULL, NULL, 82904),
(82905, '1.20.1560.10-FF-000217', NULL, 'ABC transporter ATP-binding protein', 331, NULL, NULL, 82905),
(82906, '1.10.1070.11-FF-000077', NULL, 'Uncharacterized protein', 170, NULL, NULL, 82906),
(82907, '3.40.50.410-FF-000024', NULL, 'Anthrax toxin receptor', 180, NULL, NULL, 82907),
(82908, '2.130.10.10-FF-001340', NULL, 'ASTRA-associated protein 1', 204, NULL, NULL, 82908),
(82909, '3.30.160.60-FF-000968', NULL, 'zinc finger protein 628', 29, NULL, NULL, 82909),
(82910, '3.40.50.2300-FF-000556', NULL, 'Response regulator', 128, NULL, NULL, 82910),
(82911, '3.40.50.1760-FF-000017', NULL, NULL, 48, NULL, NULL, 82911),
(82912, '3.10.20.90-FF-000979', NULL, 'Uncharacterized protein', 98, NULL, NULL, 82912),
(82913, '3.40.50.300-FF-005117', NULL, 'ABC transporter, putative', 253, NULL, NULL, 82913),
(82914, '1.10.1240.10-FF-000004', NULL, 'Monomethylamine methyltransferase corrinoid protein', 81, NULL, NULL, 82914),
(82915, '1.20.1290.10-FF-000005', NULL, 'Possible 4-carboxymuconolactone decarboxylase', 117, NULL, NULL, 82915),
(82916, '2.10.25.10-FF-000463', NULL, 'hyaluronan-binding protein 2', 42, NULL, NULL, 82916),
(82917, '3.40.1350.100-FF-000001', NULL, 'Protein TIC 22, chloroplastic', 102, NULL, NULL, 82917),
(82918, '2.130.10.10-FF-005611', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 187, NULL, NULL, 82918),
(82919, '1.10.10.750-FF-000020', NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', 49, NULL, NULL, 82919),
(82920, '3.30.160.60-FF-001244', NULL, 'Zinc finger protein 37 homolog', 31, NULL, NULL, 82920),
(82921, '1.10.220.150-FF-000049', NULL, 'ADP-ribosylation factor GTPase activating protein, putative', 128, NULL, NULL, 82921),
(82922, '2.60.260.20-FF-000186', NULL, 'Uncharacterized protein', 34, NULL, NULL, 82922),
(82923, '3.50.50.60-FF-001201', NULL, 'Monooxygenase, putative', 385, NULL, NULL, 82923),
(82924, '2.130.10.10-FF-005050', NULL, 'Uncharacterized protein', 281, NULL, NULL, 82924),
(82925, '3.30.1370.10-FF-000019', NULL, 'RNA-binding protein Nova-1 isoform 1', 76, NULL, NULL, 82925),
(82926, '1.25.40.90-FF-000042', NULL, 'Pre-mRNA cleavage complex 2 protein Pcf11', 75, NULL, NULL, 82926),
(82927, '3.30.70.330-FF-000821', NULL, 'Sex determination protein fox-1', 95, NULL, NULL, 82927),
(82928, '1.25.10.10-FF-001180', NULL, 'GM16622', 260, NULL, NULL, 82928),
(82929, '3.50.50.60-FF-000583', NULL, 'FAD-dependent oxidoreductase domain-containing protein 1', 220, NULL, NULL, 82929);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(82930, '3.40.50.720-FF-000454', NULL, 'NADPH-protochlorophyllide oxidoreductase', 325, NULL, NULL, 82930),
(82931, '3.30.300.20-FF-000052', NULL, 'GTPase Era, mitochondrial', 96, NULL, NULL, 82931),
(82932, '1.25.10.10-FF-001522', NULL, 'Predicted protein', 182, NULL, NULL, 82932),
(82933, '1.10.1370.10-FF-000008', NULL, 'Oligopeptidase A, putative', 368, NULL, NULL, 82933),
(82934, '3.40.140.10-FF-000259', NULL, 'Uncharacterized protein', 122, NULL, NULL, 82934),
(82935, '1.20.5.1000-FF-000003', NULL, 'Viral A-type inclusion protein, putative', 73, NULL, NULL, 82935),
(82936, '2.130.10.10-FF-004774', NULL, 'WD repeat domain 82', 154, NULL, NULL, 82936),
(82937, '3.50.50.60-FF-000925', NULL, 'Uncharacterized protein', 260, NULL, NULL, 82937),
(82938, '3.30.70.330-FF-002496', NULL, NULL, 74, NULL, NULL, 82938),
(82939, '3.30.50.10-FF-000092', NULL, 'Steroid hormone receptor ERR1', 38, NULL, NULL, 82939),
(82940, '1.10.238.10-FF-001326', NULL, 'Calpain 11', 69, NULL, NULL, 82940),
(82941, '2.60.40.10-FF-005302', NULL, NULL, 81, NULL, NULL, 82941),
(82942, '3.40.850.10-FF-000330', NULL, 'Kinesin family member 26Bb', 357, NULL, NULL, 82942),
(82943, '3.40.50.2000-FF-000129', NULL, 'Glycosyltransferase', 250, NULL, NULL, 82943),
(82944, '1.20.1250.20-FF-002142', NULL, 'Battenin', 203, NULL, NULL, 82944),
(82945, '2.60.470.10-FF-000007', NULL, 'Sodium channel epithelial 1 delta subunit', 160, NULL, NULL, 82945),
(82946, '1.10.555.10-FF-000034', NULL, 'Rac GTPase-activating protein 1', 205, NULL, NULL, 82946),
(82947, '1.20.1250.20-FF-001866', NULL, 'Uncharacterized protein', 115, NULL, NULL, 82947),
(82948, '3.30.300.30-FF-000055', NULL, 'Bifunctional fatty acid transporter/acyl-CoA synthetase (FAT1), putative', 120, NULL, NULL, 82948),
(82949, '1.10.2000.10-FF-000026', NULL, 'Tyrosine-protein kinase receptor cam-1', 132, NULL, NULL, 82949),
(82950, '2.40.128.80-FF-000002', NULL, 'Dipeptidyl aminopeptidase 1', 137, NULL, NULL, 82950),
(82951, '3.40.50.970-FF-000170', NULL, 'Alpha-ketoacid dehydrogenase subunit beta', 191, NULL, NULL, 82951),
(82952, '1.10.8.10-FF-000301', NULL, 'Uncharacterized protein', 46, NULL, NULL, 82952),
(82953, '3.90.1150.10-FF-000444', NULL, 'Kynureninase', 154, NULL, NULL, 82953),
(82954, '3.60.40.10-FF-000230', NULL, 'Stage II sporulation E family protein', 258, NULL, NULL, 82954),
(82955, '3.30.160.60-FF-005515', NULL, NULL, 69, NULL, NULL, 82955),
(82956, '1.25.40.10-FF-001237', NULL, 'Pentatricopeptide repeat-containing protein', 177, NULL, NULL, 82956),
(82957, '2.40.30.20-FF-000027', NULL, 'Riboflavin synthase alpha chain', 86, NULL, NULL, 82957),
(82958, '3.90.1180.10-FF-000030', NULL, '39S ribosomal protein L13, mitochondrial', 178, NULL, NULL, 82958),
(82959, '3.40.50.300-FF-004206', NULL, 'RAB1B, member RAS oncogene family b', 47, NULL, NULL, 82959),
(82960, '2.60.120.1000-FF-000005', NULL, 'Contactin associated protein-like 2', 211, NULL, NULL, 82960),
(82961, '4.10.1240.10-FF-000036', NULL, 'Adhesion G protein-coupled receptor A2', 67, NULL, NULL, 82961),
(82962, '3.40.50.1370-FF-000024', NULL, 'Ornithine carbamoyltransferase', 128, NULL, NULL, 82962),
(82963, '3.40.47.10-FF-000134', NULL, 'Acetyl-CoA C-acyltransferase', 181, NULL, NULL, 82963),
(82964, '1.10.287.810-FF-000016', NULL, 'Mitochondrial import inner membrane translocase subunit Tim10B-like Protein', 78, NULL, NULL, 82964),
(82965, '2.60.120.370-FF-000001', NULL, 'YhcH/YjgK/YiaL family protein', 153, NULL, NULL, 82965),
(82966, '3.30.479.30-FF-000036', NULL, 'Stomatin-like 1', 120, NULL, NULL, 82966),
(82967, '1.20.80.30-FF-000003', NULL, 'Pyruvate, phosphate dikinase', 94, NULL, NULL, 82967),
(82968, '3.90.70.10-FF-000343', NULL, 'Probable ubiquitin carboxyl-terminal hydrolase K02C4.3', 399, NULL, NULL, 82968),
(82969, '3.90.550.10-FF-000672', NULL, 'Uncharacterized protein', 103, NULL, NULL, 82969),
(82970, '2.60.60.20-FF-000045', NULL, NULL, 126, NULL, NULL, 82970),
(82971, '3.40.1090.10-FF-000107', NULL, 'Patatin-like phospholipase domain-containing protein SPAC1786.01c', 83, NULL, NULL, 82971);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(82972, '3.30.1540.20-FF-000024', NULL, NULL, 64, NULL, NULL, 82972),
(82973, '4.10.860.120-FF-000007', NULL, 'DNA-directed RNA polymerase subunit gamma', 134, NULL, NULL, 82973),
(82974, '1.10.530.10-FF-000011', NULL, 'Soluble lytic murein transglycosylase', 173, NULL, NULL, 82974),
(82975, '3.30.160.60-FF-005864', NULL, NULL, 57, NULL, NULL, 82975),
(82976, '3.60.20.10-FF-000083', NULL, 'Proteasome subunit beta', 194, NULL, NULL, 82976),
(82977, '3.80.10.10-FF-002806', NULL, 'Uncharacterized protein', 155, NULL, NULL, 82977),
(82978, '1.10.8.10-FF-000144', NULL, 'Tyrosyl-DNA phosphodiesterase 2', 70, NULL, NULL, 82978),
(82979, '1.10.357.120-FF-000011', NULL, 'RNA polymerase I largest subunit', 106, NULL, NULL, 82979),
(82980, '3.30.70.330-FF-002569', NULL, NULL, 144, NULL, NULL, 82980),
(82981, '3.20.20.80-FF-000616', NULL, 'Uncharacterized protein', 149, NULL, NULL, 82981),
(82982, '2.60.40.10-FF-004807', NULL, NULL, 112, NULL, NULL, 82982),
(82983, '3.90.1200.10-FF-000055', NULL, 'Spore coat protein YsxE', 227, NULL, NULL, 82983),
(82984, '2.60.40.1180-FF-000025', NULL, 'Alpha-galactosidase', 98, NULL, NULL, 82984),
(82985, '3.30.200.20-FF-000084', NULL, 'Tyrosine-protein kinase', 96, NULL, NULL, 82985),
(82986, '2.70.130.10-FF-000025', NULL, 'Protein OS-9 homolog', 143, NULL, NULL, 82986),
(82987, '3.20.20.10-FF-000056', NULL, 'Pyridoxal phosphate homeostasis protein', 246, NULL, NULL, 82987),
(82988, '3.80.10.10-FF-004370', NULL, 'Uncharacterized protein', 173, NULL, NULL, 82988),
(82989, '1.25.10.10-FF-000836', NULL, 'Importin subunit alpha-3, putative', 404, NULL, NULL, 82989),
(82990, '3.40.50.10380-FF-000034', NULL, 'NADP malic enzyme', 258, NULL, NULL, 82990),
(82991, '4.10.400.10-FF-000299', NULL, 'sortilin-related receptor-like', 30, NULL, NULL, 82991),
(82992, '1.10.950.10-FF-000003', NULL, 'supervillin isoform X2', 67, NULL, NULL, 82992),
(82993, '2.30.30.380-FF-000051', NULL, 'Uncharacterized protein', 55, NULL, NULL, 82993),
(82994, '1.20.140.150-FF-000062', NULL, 'Uncharacterized protein, isoform C', 197, NULL, NULL, 82994),
(82995, '3.30.1370.100-FF-000003', NULL, 'DNA mismatch repair protein Mlh3', 114, NULL, NULL, 82995),
(82996, '1.10.510.10-FF-002718', NULL, 'Guanylate cyclase', 269, NULL, NULL, 82996),
(82997, '2.130.10.10-FF-004291', NULL, 'WD repeatcontaining protein 92, putative', 124, NULL, NULL, 82997),
(82998, '3.40.430.10-FF-000039', NULL, 'Dihydrofolate reductase', 164, NULL, NULL, 82998),
(82999, '1.20.1250.20-FF-002237', NULL, 'Putative uncharacterized transporter YOL163W', 119, NULL, NULL, 82999),
(83000, '3.40.50.10490-FF-000128', NULL, NULL, 156, NULL, NULL, 83000),
(83001, '1.10.510.10-FF-003707', NULL, NULL, 162, NULL, NULL, 83001),
(83002, '1.20.5.340-FF-000110', NULL, 'Kinesin, putative', 109, NULL, NULL, 83002),
(83003, '2.10.109.10-FF-000028', NULL, 'Type I signal peptidase', 154, NULL, NULL, 83003),
(83004, '2.60.40.3460-FF-000001', NULL, 'SbsB protein', 110, NULL, NULL, 83004),
(83005, '3.80.10.10-FF-000036', NULL, 'protein scribble homolog isoform X1', 118, NULL, NULL, 83005),
(83006, '3.40.50.300-FF-001891', NULL, 'ATP-dependent zinc metalloprotease FtsH 3', 212, NULL, NULL, 83006),
(83007, '2.170.270.10-FF-000174', NULL, 'PR domain containing 1c', 102, NULL, NULL, 83007),
(83008, '3.40.50.300-FF-000463', NULL, 'GTP-binding protein TypA', 200, NULL, NULL, 83008),
(83009, '1.10.357.140-FF-000017', NULL, 'Decaprenyl-phosphate phosphoribosyltransferase', 142, NULL, NULL, 83009),
(83010, '3.20.20.60-FF-000077', NULL, 'Citrate lyase subunit beta', 265, NULL, NULL, 83010),
(83011, '4.10.49.10-FF-000002', NULL, 'Unplaced genomic scaffold supercont1.178, whole genome shotgun sequence', 46, NULL, NULL, 83011),
(83012, '3.40.50.1000-FF-000756', NULL, NULL, 145, NULL, NULL, 83012),
(83013, '3.30.1130.10-FF-000001', NULL, 'GTP cyclohydrolase 1', 131, NULL, NULL, 83013),
(83014, '2.30.30.40-FF-000293', NULL, 'PhnA domain protein', 69, NULL, NULL, 83014),
(83015, '3.30.160.60-FF-001682', NULL, 'protein Wiz isoform X1', 78, NULL, NULL, 83015),
(83016, '1.10.1740.100-FF-000003', NULL, 'Histone-lysine N-methyltransferase', 111, NULL, NULL, 83016); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(83017, '3.20.80.10-FF-000032', NULL, 'Phospholipid-transporting ATPase', 151, NULL, NULL, 83017),
(83018, '3.40.50.300-FF-008540', NULL, 'Putative DNA mismatch repair protein Msh6-like Protein', 251, NULL, NULL, 83018),
(83019, '3.40.50.300-FF-003217', NULL, 'RAB41, member RAS oncogene family, transcript variant X1', 152, NULL, NULL, 83019),
(83020, '3.40.50.1820-FF-001339', NULL, 'Uncharacterized protein', 249, NULL, NULL, 83020),
(83021, '2.40.30.10-FF-000137', NULL, 'Elongation factor Tu, putative', 129, NULL, NULL, 83021),
(83022, '3.80.10.10-FF-001817', NULL, 'DNA repair protein, putative', 140, NULL, NULL, 83022),
(83023, '3.30.160.60-FF-001210', NULL, 'zinc finger protein 777', 30, NULL, NULL, 83023),
(83024, '1.10.540.10-FF-000129', NULL, 'Acyl-CoA dehydrogenase medium chain', 110, NULL, NULL, 83024),
(83025, '3.40.50.300-FF-003689', NULL, 'Transmembrane receptors / ATP binding protein', 171, NULL, NULL, 83025),
(83026, '1.20.1070.10-FF-001034', NULL, 'Odorant receptor B1', 129, NULL, NULL, 83026),
(83027, '1.10.10.10-FF-001292', NULL, 'MarR family transcriptional regulator', 138, NULL, NULL, 83027),
(83028, '3.40.850.10-FF-000150', NULL, 'Kinesin-like protein', 347, NULL, NULL, 83028),
(83029, '2.10.220.10-FF-000074', NULL, 'High cysteine membrane protein TMK-like', 112, NULL, NULL, 83029),
(83030, '3.40.1110.10-FF-000251', NULL, NULL, 125, NULL, NULL, 83030),
(83031, '3.40.50.12660-FF-000010', NULL, 'Metacaspase-9', 208, NULL, NULL, 83031),
(83032, '2.20.20.110-FF-000004', NULL, 'Rad4 family protein', 56, NULL, NULL, 83032),
(83033, '1.25.40.20-FF-001010', NULL, 'Protein ACCELERATED CELL DEATH 6', 213, NULL, NULL, 83033),
(83034, '3.30.70.330-FF-000332', NULL, 'flowering time control protein FCA isoform X2', 93, NULL, NULL, 83034),
(83035, '1.10.10.60-FF-000738', NULL, 'MYB-like 2', 82, NULL, NULL, 83035),
(83036, '1.25.40.10-FF-002581', NULL, 'Uncharacterized protein', 94, NULL, NULL, 83036),
(83037, '1.20.890.10-FF-000007', NULL, 'receptor tyrosine-protein kinase erbB-3', 37, NULL, NULL, 83037),
(83038, '1.10.510.10-FF-001729', NULL, 'BcDNA.LD22679', 122, NULL, NULL, 83038),
(83039, '2.40.20.10-FF-000052', NULL, 'Metalloendopeptidase', 112, NULL, NULL, 83039),
(83040, '3.40.50.300-FF-004645', NULL, 'EG:33C11.2 protein', 236, NULL, NULL, 83040),
(83041, '2.60.40.1130-FF-000004', NULL, 'GM10787', 97, NULL, NULL, 83041),
(83042, '2.10.25.10-FF-000671', NULL, 'Protein Z, vitamin K-dependent plasma glycoprotein a', 38, NULL, NULL, 83042),
(83043, '1.50.40.10-FF-000572', NULL, 'Uncharacterized protein', 212, NULL, NULL, 83043),
(83044, '2.60.40.10-FF-000625', NULL, 'Vascular cell adhesion molecule 1', 90, NULL, NULL, 83044),
(83045, '3.30.200.20-FF-001865', NULL, 'Os04g0123750 protein', 98, NULL, NULL, 83045),
(83046, '2.40.10.10-FF-000607', NULL, NULL, 119, NULL, NULL, 83046),
(83047, '2.70.170.10-FF-000090', NULL, 'gamma-aminobutyric acid receptor subunit rho-1-like isoform X2', 158, NULL, NULL, 83047),
(83048, '1.20.58.60-FF-000691', NULL, 'Microtubule-actin crosslinking factor 1', 113, NULL, NULL, 83048),
(83049, '3.40.50.11890-FF-000003', NULL, '(R)-2-hydroxyglutaryl-CoA dehydratase subunit alpha', 143, NULL, NULL, 83049),
(83050, '2.130.10.10-FF-006056', NULL, 'F-box/WD repeat-containing protein pof1', 126, NULL, NULL, 83050),
(83051, '3.40.190.10-FF-000442', NULL, 'Twin-arginine translocation pathway signal protein', 192, NULL, NULL, 83051),
(83052, '1.25.40.20-FF-000493', NULL, 'Mitogen-activated protein kinase kinase kinase 19', 143, NULL, NULL, 83052),
(83053, '2.130.10.10-FF-004139', NULL, 'Uncharacterized protein', 181, NULL, NULL, 83053),
(83054, '3.20.20.80-FF-000296', NULL, 'Exo-1,3-beta-glucanase', 435, NULL, NULL, 83054),
(83055, '3.30.420.510-FF-000011', NULL, 'Conserved protein', 98, NULL, NULL, 83055),
(83056, '3.30.60.20-FF-000157', NULL, 'Protein vav-1', 52, NULL, NULL, 83056),
(83057, '3.40.630.40-FF-000002', NULL, 'N-acetylmuramoyl-L-alanine amidase AmiA', 234, NULL, NULL, 83057),
(83058, '3.30.200.20-FF-000404', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 111, NULL, NULL, 83058);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(83059, '2.10.25.10-FF-001008', NULL, 'Fcgbp protein', 56, NULL, NULL, 83059),
(83060, '3.40.50.150-FF-000749', NULL, 'O-methyltransferase', 218, NULL, NULL, 83060),
(83061, '2.60.40.10-FF-003498', NULL, NULL, 92, NULL, NULL, 83061),
(83062, '3.40.50.300-FF-007551', NULL, 'Predicted protein', 298, NULL, NULL, 83062),
(83063, '2.30.42.10-FF-000558', NULL, NULL, 53, NULL, NULL, 83063),
(83064, '3.30.40.10-FF-002215', NULL, 'Protein kinase, putative', 69, NULL, NULL, 83064),
(83065, '2.160.10.10-FF-000006', NULL, 'Glucose-1-phosphate adenylyltransferase', 131, NULL, NULL, 83065),
(83066, '1.20.1110.10-FF-000133', NULL, NULL, 112, NULL, NULL, 83066),
(83067, '3.40.190.10-FF-000003', NULL, 'Glutamate receptor, ionotropic, AMPA 2', 154, NULL, NULL, 83067),
(83068, '3.30.160.60-FF-003447', NULL, NULL, 31, NULL, NULL, 83068),
(83069, '1.25.40.10-FF-001592', NULL, 'NASP (Human Nuclear Autoantigenic Sperm Protein) homolog', 182, NULL, NULL, 83069),
(83070, '1.10.533.10-FF-000164', NULL, 'Cyclin T-dependent kinase CDK9, putative', 123, NULL, NULL, 83070),
(83071, '2.60.40.60-FF-000207', NULL, 'FAT atypical cadherin 2', 119, NULL, NULL, 83071),
(83072, '3.30.2350.20-FF-000015', NULL, 'Unplaced genomic scaffold supercont1.8, whole genome shotgun sequence', 251, NULL, NULL, 83072),
(83073, '2.30.40.10-FF-000104', NULL, 'Amidohydrolase', 49, NULL, NULL, 83073),
(83074, '1.20.5.1930-FF-000012', NULL, 'Putative methanol utilization control sensor protein moxY', 67, NULL, NULL, 83074),
(83075, '3.30.70.370-FF-000024', NULL, NULL, 126, NULL, NULL, 83075),
(83076, '3.40.570.10-FF-000049', NULL, 'Uncharacterized protein', 208, NULL, NULL, 83076),
(83077, '1.20.5.780-FF-000006', NULL, 'FXYD domain-containing ion transport regulator', 67, NULL, NULL, 83077),
(83078, '3.30.160.60-FF-004083', NULL, NULL, 27, NULL, NULL, 83078),
(83079, '1.10.150.240-FF-000127', NULL, 'Uncharacterized protein', 70, NULL, NULL, 83079),
(83080, '2.130.10.10-FF-001385', NULL, 'Probable cleavage and polyadenylation specificity factor subunit 1', 387, NULL, NULL, 83080),
(83081, '1.25.40.10-FF-000664', NULL, 'Pentatricopeptide repeat-containing protein', 128, NULL, NULL, 83081),
(83082, '3.30.160.60-FF-002519', NULL, 'zinc finger protein 252-like', 29, NULL, NULL, 83082),
(83083, '3.30.70.330-FF-001760', NULL, NULL, 115, NULL, NULL, 83083),
(83084, '1.20.120.330-FF-000011', NULL, 'Type III secretion system needle tip complex protein SipB', 62, NULL, NULL, 83084),
(83085, '3.30.70.270-FF-000292', NULL, NULL, 68, NULL, NULL, 83085),
(83086, '3.80.10.10-FF-001025', NULL, 'Protein zyg-11 homolog A', 255, NULL, NULL, 83086),
(83087, '2.60.40.10-FF-000272', NULL, 'Immunoglobulin superfamily member 9B', 87, NULL, NULL, 83087),
(83088, '1.25.40.10-FF-005335', NULL, 'Uncharacterized protein', 73, NULL, NULL, 83088),
(83089, '3.40.50.720-FF-000353', NULL, 'WW domain-containing oxidoreductase', 297, NULL, NULL, 83089),
(83090, '1.10.486.10-FF-000025', NULL, 'ATP-dependent DNA helicase UvrD2', 30, NULL, NULL, 83090),
(83091, '3.40.710.10-FF-000140', NULL, 'Glutaminase', 297, NULL, NULL, 83091),
(83092, '2.60.120.200-FF-000788', NULL, 'Galectin', 100, NULL, NULL, 83092),
(83093, '1.20.1270.280-FF-000081', NULL, 'Predicted protein', 33, NULL, NULL, 83093),
(83094, '3.40.50.300-FF-002880', NULL, 'Cobyric acid synthase', 249, NULL, NULL, 83094),
(83095, '2.130.10.10-FF-004611', NULL, 'Uncharacterized protein', 201, NULL, NULL, 83095),
(83096, '2.30.30.30-FF-000025', NULL, '39S ribosomal protein L2, mitochondrial', 81, NULL, NULL, 83096),
(83097, '2.130.10.10-FF-005600', NULL, 'Uncharacterized protein', 193, NULL, NULL, 83097),
(83098, '3.60.21.10-FF-000135', NULL, 'Os06g0222800 protein', 301, NULL, NULL, 83098),
(83099, '1.10.238.10-FF-000820', NULL, 'Calmodulin-like protein', 64, NULL, NULL, 83099),
(83100, '2.10.25.10-FF-000019', NULL, 'latent-transforming growth factor beta-binding protein 1 isoform X2', 41, NULL, NULL, 83100),
(83101, '3.40.50.2300-FF-001675', NULL, NULL, 85, NULL, NULL, 83101),
(83102, '3.80.10.10-FF-003381', NULL, 'Predicted protein', 265, NULL, NULL, 83102);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(83103, '3.20.20.70-FF-000759', NULL, NULL, 58, NULL, NULL, 83103),
(83104, '3.30.1360.70-FF-000008', NULL, 'Arginine--tRNA ligase', 111, NULL, NULL, 83104),
(83105, '1.25.40.10-FF-001653', NULL, 'Uncharacterized protein', 112, NULL, NULL, 83105),
(83106, '3.40.50.150-FF-001738', NULL, NULL, 239, NULL, NULL, 83106),
(83107, '2.120.10.90-FF-000015', NULL, 'DNA topoisomerase 4 subunit A', 287, NULL, NULL, 83107),
(83108, '3.30.70.340-FF-000009', NULL, 'GD10919', 75, NULL, NULL, 83108),
(83109, '3.30.160.60-FF-002458', NULL, 'Uncharacterized protein', 28, NULL, NULL, 83109),
(83110, '1.10.1200.10-FF-000058', NULL, 'Nonribosomal peptide synthase GliP', 80, NULL, NULL, 83110),
(83111, '1.10.3260.10-FF-000034', NULL, 'DNA ligase', 275, NULL, NULL, 83111),
(83112, '2.130.10.10-FF-005128', NULL, 'Uncharacterized protein', 215, NULL, NULL, 83112),
(83113, '1.10.472.10-FF-000055', NULL, 'Cyclin F', 121, NULL, NULL, 83113),
(83114, '1.10.510.10-FF-002365', NULL, NULL, 180, NULL, NULL, 83114),
(83115, '2.10.25.10-FF-000519', NULL, 'Nidogen 2', 43, NULL, NULL, 83115),
(83116, '1.20.920.30-FF-000016', NULL, 'Axonemal dynein heavy chain', 145, NULL, NULL, 83116),
(83117, '3.50.50.60-FF-000015', NULL, 'Thioredoxin reductase', 175, NULL, NULL, 83117),
(83118, '2.130.10.10-FF-000396', NULL, 'phosphoinositide 3-kinase regulatory subunit 4', 114, NULL, NULL, 83118),
(83119, '3.30.70.100-FF-000168', NULL, NULL, 65, NULL, NULL, 83119),
(83120, '3.30.1360.10-FF-000069', NULL, 'Serine/threonine-protein kinase CG17528-like Protein', 98, NULL, NULL, 83120),
(83121, '2.40.100.10-FF-000092', NULL, 'Peptidyl-prolyl cis-trans isomerase', 145, NULL, NULL, 83121),
(83122, '2.40.70.10-FF-000263', NULL, 'Aspartic proteinase nepenthesin-1', 172, NULL, NULL, 83122),
(83123, '3.40.30.10-FF-000983', NULL, 'Uncharacterized protein', 90, NULL, NULL, 83123),
(83124, '1.20.1070.10-FF-001473', NULL, 'Uncharacterized protein', 209, NULL, NULL, 83124),
(83125, '3.30.40.10-FF-001726', NULL, 'PHD finger protein EHD3 isoform A', 43, NULL, NULL, 83125),
(83126, '3.10.100.10-FF-000061', NULL, 'CD248 molecule', 142, NULL, NULL, 83126),
(83127, '1.20.120.1910-FF-000014', NULL, 'Cysteine--tRNA ligase', 162, NULL, NULL, 83127),
(83128, '2.140.10.30-FF-000002', NULL, 'Dipeptidyl peptidase 8-like isoform', 532, NULL, NULL, 83128),
(83129, '3.30.410.10-FF-000001', NULL, 'Cellobiose dehydrogenase', 202, NULL, NULL, 83129),
(83130, '3.30.360.20-FF-000005', NULL, 'RNA re-capping enzyme', 100, NULL, NULL, 83130),
(83131, '3.40.250.10-FF-000121', NULL, 'Hydroxyacylglutathione hydrolase', 105, NULL, NULL, 83131),
(83132, '3.30.565.10-FF-000444', NULL, 'Two-component sensor histidine kinase', 119, NULL, NULL, 83132),
(83133, '1.10.8.60-FF-000198', NULL, 'Cell cycle checkpoint protein RAD17', 60, NULL, NULL, 83133),
(83134, '1.10.10.60-FF-000385', NULL, 'Putative homeobox-leucine zipper protein ATHB-51', 64, NULL, NULL, 83134),
(83135, '1.10.150.20-FF-000294', NULL, 'DNA-directed RNA polymerase', 133, NULL, NULL, 83135),
(83136, '2.60.120.10-FF-000577', NULL, 'Sll1924 protein', 144, NULL, NULL, 83136),
(83137, '3.30.70.330-FF-001260', NULL, 'RNA recognition motif domain containing protein', 131, NULL, NULL, 83137),
(83138, '3.40.50.300-FF-008068', NULL, 'Uncharacterized protein', 122, NULL, NULL, 83138),
(83139, '3.40.630.30-FF-000206', NULL, 'GNAT family N-acetyltransferase', 150, NULL, NULL, 83139),
(83140, '3.90.550.10-FF-000200', NULL, 'Uncharacterized protein', 165, NULL, NULL, 83140),
(83141, '3.10.110.10-FF-000146', NULL, 'Uncharacterized protein', 295, NULL, NULL, 83141),
(83142, '3.40.350.10-FF-000005', NULL, 'SPT16 homolog, facilitates chromatin-remodeling subunit', 171, NULL, NULL, 83142),
(83143, '3.50.30.30-FF-000056', NULL, 'Glutamate carboxypeptidase', 222, NULL, NULL, 83143),
(83144, '3.30.160.60-FF-000221', NULL, 'Zinc finger protein 410', 28, NULL, NULL, 83144),
(83145, '2.40.150.20-FF-000013', NULL, '60S ribosomal protein L23', 110, NULL, NULL, 83145),
(83146, '3.30.210.10-FF-000020', NULL, 'DNA-directed DNA/RNA polymerase mu', 38, NULL, NULL, 83146);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(83147, '4.10.1000.10-FF-000142', NULL, 'Predicted protein', 57, NULL, NULL, 83147),
(83148, '1.25.40.70-FF-000075', NULL, 'VPS34-like PI-3-kinase', 181, NULL, NULL, 83148),
(83149, '1.10.238.10-FF-001276', NULL, 'Calmodulin', 73, NULL, NULL, 83149),
(83150, '3.40.50.620-FF-000469', NULL, 'GM10510', 236, NULL, NULL, 83150),
(83151, '2.30.30.40-FF-000646', NULL, 'Tyrosine-protein kinase', 76, NULL, NULL, 83151),
(83152, '3.40.140.100-FF-000007', NULL, 'Ubiquitin-like modifier-activating enzyme atg7', 144, NULL, NULL, 83152),
(83153, '3.40.50.300-FF-002380', NULL, 'SWI/SNF family DNA-dependent ATPase, putative', 230, NULL, NULL, 83153),
(83154, '3.30.930.10-FF-000057', NULL, 'DNA polymerase subunit gamma-2, mitochondrial', 279, NULL, NULL, 83154),
(83155, '2.130.10.30-FF-000143', NULL, NULL, 178, NULL, NULL, 83155),
(83156, '2.60.40.10-FF-005004', NULL, NULL, 106, NULL, NULL, 83156),
(83157, '2.60.40.10-FF-002542', NULL, 'Immunoglobulin heavy variable 1-4', 114, NULL, NULL, 83157),
(83158, '1.10.8.60-FF-000518', NULL, 'Uncharacterized protein', 42, NULL, NULL, 83158),
(83159, '2.10.110.10-FF-000245', NULL, 'Chromosome 21, whole genome shotgun sequence', 68, NULL, NULL, 83159),
(83160, '3.60.15.10-FF-000161', NULL, 'Predicted protein', 78, NULL, NULL, 83160),
(83161, '3.30.1370.210-FF-000036', NULL, 'Uncharacterized protein', 70, NULL, NULL, 83161),
(83162, '2.40.50.140-FF-001155', NULL, NULL, 96, NULL, NULL, 83162),
(83163, '3.40.50.10090-FF-000071', NULL, 'Putative uroporphyrinogen III synthase', 57, NULL, NULL, 83163),
(83164, '1.25.70.10-FF-000020', NULL, 'Mitochondrial transcription termination factor family protein', 219, NULL, NULL, 83164),
(83165, '1.10.3380.10-FF-000009', NULL, 'DEAD/DEAH box helicase, putative', 137, NULL, NULL, 83165),
(83166, '1.10.10.10-FF-001645', NULL, 'Csn-4', 81, NULL, NULL, 83166),
(83167, '3.30.10.20-FF-000007', NULL, 'Serine/threonine protein kinase', 73, NULL, NULL, 83167),
(83168, '3.80.10.10-FF-000980', NULL, 'Protein kinase domain containing protein', 152, NULL, NULL, 83168),
(83169, '1.25.10.10-FF-001764', NULL, 'Uncharacterized protein', 949, NULL, NULL, 83169),
(83170, '3.80.10.10-FF-003442', NULL, 'Uncharacterized protein', 55, NULL, NULL, 83170),
(83171, '1.10.1000.11-FF-000027', NULL, 'YALI0D23463p', 119, NULL, NULL, 83171),
(83172, '1.10.1220.170-FF-000002', NULL, 'Antitoxin', 52, NULL, NULL, 83172),
(83173, '2.130.10.10-FF-003655', NULL, 'Copper resistance D domain protein', 227, NULL, NULL, 83173),
(83174, '3.30.450.60-FF-000029', NULL, 'AP-2 complex subunit mu', 139, NULL, NULL, 83174),
(83175, '1.25.40.10-FF-002901', NULL, 'Pentatricopeptide repeat-containing protein At1g11630, mitochondrial', 205, NULL, NULL, 83175),
(83176, '1.50.10.20-FF-000101', NULL, 'Uncharacterized protein', 133, NULL, NULL, 83176),
(83177, '3.40.30.10-FF-000191', NULL, 'Protein disulfide isomerase like, testis expressed', 125, NULL, NULL, 83177),
(83178, '1.25.40.20-FF-000521', NULL, 'Ankyrin repeat domain 23', 104, NULL, NULL, 83178),
(83179, '1.20.1250.20-FF-001309', NULL, 'Major facilitator superfamily protein', 120, NULL, NULL, 83179),
(83180, '1.10.287.130-FF-000059', NULL, 'PAS domain-containing sensor histidine kinase', 79, NULL, NULL, 83180),
(83181, '1.25.40.10-FF-000164', NULL, 'Vacuolar protein sorting-associated protein 11 homolog', 249, NULL, NULL, 83181),
(83182, '1.10.10.10-FF-000364', NULL, 'IclR family transcriptional regulator', 72, NULL, NULL, 83182),
(83183, '3.90.740.10-FF-000063', NULL, 'Uncharacterized protein', 161, NULL, NULL, 83183),
(83184, '3.40.50.1820-FF-000822', NULL, 'Protein CBG13010', 136, NULL, NULL, 83184),
(83185, '1.10.287.110-FF-000020', NULL, 'DnaJ subfamily B member 13', 124, NULL, NULL, 83185),
(83186, '3.30.360.10-FF-000087', NULL, 'Aspartate-semialdehyde dehydrogenase', 171, NULL, NULL, 83186),
(83187, '2.40.50.770-FF-000001', NULL, 'Tudor domain-containing protein 3', 128, NULL, NULL, 83187),
(83188, '3.20.20.140-FF-000245', NULL, 'Adenine deaminase 1', 250, NULL, NULL, 83188),
(83189, '3.30.565.10-FF-000383', NULL, 'Sensory transduction histidine kinase', 156, NULL, NULL, 83189);
INSERT INTO "PUBLIC"."MODEL" VALUES
(83190, '3.40.50.300-FF-003717', NULL, 'DNA replication and repair protein RecF', 149, NULL, NULL, 83190),
(83191, '3.50.50.60-FF-001443', NULL, 'Amino acid oxidase fmpA', 95, NULL, NULL, 83191),
(83192, '2.60.40.10-FF-002250', NULL, 'Mesocentin', 111, NULL, NULL, 83192),
(83193, '2.30.110.10-FF-000055', NULL, 'GM10976', 233, NULL, NULL, 83193),
(83194, '1.20.59.10-FF-000009', NULL, 'Intracellular chorismate mutase', 90, NULL, NULL, 83194),
(83195, '3.40.50.10050-FF-000019', NULL, 'Uncharacterized protein', 57, NULL, NULL, 83195),
(83196, '2.60.120.200-FF-000288', NULL, 'Galectin', 135, NULL, NULL, 83196),
(83197, '3.40.1390.20-FF-000009', NULL, 'Cobalt-dependent inorganic pyrophosphatase', 116, NULL, NULL, 83197),
(83198, '2.30.29.130-FF-000002', NULL, 'Glycoprotein', 69, NULL, NULL, 83198),
(83199, '1.10.510.10-FF-000892', NULL, 'Ser/Thr kinase', 298, NULL, NULL, 83199),
(83200, '4.10.60.10-FF-000012', NULL, 'Cellular nucleic acid-binding protein', 25, NULL, NULL, 83200),
(83201, '3.40.30.10-FF-000483', NULL, 'Thioredoxin', 88, NULL, NULL, 83201),
(83202, '2.60.40.10-FF-004307', NULL, NULL, 102, NULL, NULL, 83202),
(83203, '3.10.20.540-FF-000002', NULL, 'ORF1a polyprotein', 62, NULL, NULL, 83203),
(83204, '1.10.167.10-FF-000060', NULL, 'Regulator of G protein-signaling 14a', 56, NULL, NULL, 83204),
(83205, '2.60.40.10-FF-004487', NULL, NULL, 114, NULL, NULL, 83205),
(83206, '2.40.50.150-FF-000023', NULL, 'DNA-directed RNA polymerase subunit beta', 136, NULL, NULL, 83206),
(83207, '3.30.40.10-FF-001226', NULL, 'E3 ubiquitin-protein ligase parkin', 96, NULL, NULL, 83207),
(83208, '3.30.60.30-FF-000047', NULL, 'Complement component C6', 74, NULL, NULL, 83208),
(83209, '3.40.50.300-FF-000963', NULL, 'Guanine nucleotide-binding protein-like 1', 172, NULL, NULL, 83209),
(83210, '2.130.10.10-FF-002666', NULL, 'Uncharacterized protein', 72, NULL, NULL, 83210),
(83211, '3.30.1330.80-FF-000009', NULL, 'AT-hook motif nuclear-localized protein 17', 138, NULL, NULL, 83211),
(83212, '3.40.50.2020-FF-000141', NULL, 'Ribose-phosphate pyrophosphokinase 1, putative', 85, NULL, NULL, 83212),
(83213, '1.20.120.290-FF-000010', NULL, 'Sll1638 protein', 133, NULL, NULL, 83213),
(83214, '3.30.1360.120-FF-000097', NULL, 'Sarcosine dehydrogenase', 145, NULL, NULL, 83214),
(83215, '2.60.120.920-FF-000178', NULL, 'Uncharacterized protein', 50, NULL, NULL, 83215),
(83216, '2.160.20.10-FF-000243', NULL, 'Uncharacterized protein', 147, NULL, NULL, 83216),
(83217, '2.120.10.30-FF-000576', NULL, 'Adipocyte plasma membrane-associated protein, putative', 194, NULL, NULL, 83217),
(83218, '3.90.190.10-FF-000037', NULL, 'dual specificity protein phosphatase 26', 177, NULL, NULL, 83218),
(83219, '2.60.40.10-FF-004779', NULL, NULL, 82, NULL, NULL, 83219),
(83220, '3.10.290.10-FF-000102', NULL, 'Tyrosine--tRNA ligase', 103, NULL, NULL, 83220),
(83221, '3.30.160.60-FF-005072', NULL, NULL, 62, NULL, NULL, 83221),
(83222, '3.40.50.300-FF-006562', NULL, 'Uncharacterized protein', 103, NULL, NULL, 83222),
(83223, '1.10.472.10-FF-000555', NULL, 'Uncharacterized protein', 71, NULL, NULL, 83223),
(83224, '3.60.15.10-FF-000014', NULL, 'Zinc phosphodiesterase ELAC protein 2', 279, NULL, NULL, 83224),
(83225, '2.60.260.20-FF-000091', NULL, 'DnaJ domain containing protein', 82, NULL, NULL, 83225),
(83226, '2.120.10.30-FF-000604', NULL, 'Dipeptidyl Peptidase Four (IV) family', 200, NULL, NULL, 83226),
(83227, '2.60.40.10-FF-003970', NULL, NULL, 103, NULL, NULL, 83227),
(83228, '1.10.510.10-FF-003646', NULL, NULL, 186, NULL, NULL, 83228),
(83229, '1.20.120.1750-FF-000123', NULL, 'RBR-type E3 ubiquitin transferase', 114, NULL, NULL, 83229),
(83230, '3.20.20.60-FF-000138', NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', 273, NULL, NULL, 83230),
(83231, '3.30.160.60-FF-005364', NULL, NULL, 27, NULL, NULL, 83231),
(83232, '2.110.10.10-FF-000059', NULL, 'Uncharacterized protein', 190, NULL, NULL, 83232),
(83233, '3.30.1330.60-FF-000003', NULL, 'Flagellar motor protein MotB', 188, NULL, NULL, 83233),
(83234, '1.10.238.10-FF-000287', NULL, 'Probable GTP diphosphokinase CRSH, chloroplastic', 137, NULL, NULL, 83234);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(83235, '1.25.10.10-FF-000483', NULL, 'RING-type E3 ubiquitin transferase', 333, NULL, NULL, 83235),
(83236, '1.20.1070.10-FF-000837', NULL, 'Purinergic receptor P2Y, G-protein-coupled, 11', 300, NULL, NULL, 83236),
(83237, '1.10.150.20-FF-000114', NULL, 'DNA-directed RNA polymerase', 178, NULL, NULL, 83237),
(83238, '3.30.1490.140-FF-000002', NULL, 'beta-amyloid-like protein isoform X3', 59, NULL, NULL, 83238),
(83239, '1.10.132.130-FF-000001', NULL, 'Vacuolar-processing enzyme beta-isozyme', 128, NULL, NULL, 83239),
(83240, '1.10.287.110-FF-000312', NULL, 'Chaperone protein DNAJ, putative', 116, NULL, NULL, 83240),
(83241, '1.25.40.10-FF-004054', NULL, 'Uncharacterized protein', 168, NULL, NULL, 83241),
(83242, '3.40.50.300-FF-006270', NULL, 'Uncharacterized protein', 172, NULL, NULL, 83242),
(83243, '3.40.30.10-FF-000011', NULL, 'Peroxiredoxin PRX1', 147, NULL, NULL, 83243),
(83244, '3.40.50.300-FF-007079', NULL, 'Small GTP-binding protein, putative', 192, NULL, NULL, 83244),
(83245, '3.30.70.330-FF-000271', NULL, 'squamous cell carcinoma antigen recognized by T-cells 3', 114, NULL, NULL, 83245),
(83246, '3.40.390.10-FF-000131', NULL, 'GD21387', 317, NULL, NULL, 83246),
(83247, '3.30.420.40-FF-000281', NULL, 'Actin-like protein, putative', 67, NULL, NULL, 83247),
(83248, '1.25.40.10-FF-004879', NULL, 'Pentatricopeptide repeat-containing protein At3g29230', 104, NULL, NULL, 83248),
(83249, '1.10.555.10-FF-000242', NULL, NULL, 193, NULL, NULL, 83249),
(83250, '1.10.510.10-FF-003354', NULL, NULL, 233, NULL, NULL, 83250),
(83251, '1.25.40.820-FF-000003', NULL, 'Putative RNA polymerase II subunit B1 CTD phosphatase RPAP2 homolog', 130, NULL, NULL, 83251),
(83252, '1.20.1070.10-FF-000045', NULL, 'D(1A) dopamine receptor', 337, NULL, NULL, 83252),
(83253, '3.20.20.70-FF-000467', NULL, 'Hydroxymethylglutaryl-CoA lyase, mitochondrial, putative', 319, NULL, NULL, 83253),
(83254, '3.80.10.10-FF-000828', NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM1', 64, NULL, NULL, 83254),
(83255, '3.10.20.90-FF-000906', NULL, 'Predicted protein', 116, NULL, NULL, 83255),
(83256, '3.30.70.330-FF-002069', NULL, NULL, 86, NULL, NULL, 83256),
(83257, '3.40.50.150-FF-001385', NULL, NULL, 173, NULL, NULL, 83257),
(83258, '2.60.40.150-FF-000741', NULL, 'Uncharacterized protein', 100, NULL, NULL, 83258),
(83259, '3.40.50.200-FF-000107', NULL, 'Uncharacterized protein', 279, NULL, NULL, 83259),
(83260, '3.40.50.1820-FF-000030', NULL, 'Carboxypeptidase', 260, NULL, NULL, 83260),
(83261, '3.40.630.30-FF-000645', NULL, 'Uncharacterized protein', 168, NULL, NULL, 83261),
(83262, '3.10.20.90-FF-000614', NULL, 'mitogen-activated protein kinase kinase kinase 2-like', 83, NULL, NULL, 83262),
(83263, '3.30.200.20-FF-000876', NULL, 'AGC family protein kinase', 96, NULL, NULL, 83263),
(83264, '1.50.10.20-FF-000129', NULL, 'Protein farnesyltransferase subunit beta', 408, NULL, NULL, 83264),
(83265, '1.20.1050.10-FF-000162', NULL, 'Sui m 8 allergen', 105, NULL, NULL, 83265),
(83266, '3.30.160.60-FF-000693', NULL, 'Snail family zinc finger 1a', 24, NULL, NULL, 83266),
(83267, '3.40.30.10-FF-000039', NULL, 'Glutathione S-transferase domain', 83, NULL, NULL, 83267),
(83268, '3.40.50.2300-FF-000747', NULL, 'Uncharacterized protein', 149, NULL, NULL, 83268),
(83269, '3.40.50.150-FF-000457', NULL, 'Ribosomal RNA-processing protein 8', 162, NULL, NULL, 83269),
(83270, '2.130.10.10-FF-005780', NULL, 'Damage-specific DNA binding protein 1', 103, NULL, NULL, 83270),
(83271, '2.60.120.1560-FF-000004', NULL, 'PKHD1-like 1', 151, NULL, NULL, 83271),
(83272, '3.30.420.40-FF-000573', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', 165, NULL, NULL, 83272),
(83273, '2.60.40.60-FF-001135', NULL, 'Uncharacterized protein', 72, NULL, NULL, 83273),
(83274, '2.30.42.10-FF-000266', NULL, 'Uncharacterized protein, isoform A', 84, NULL, NULL, 83274),
(83275, '1.20.1250.20-FF-001720', NULL, 'Predicted protein', 199, NULL, NULL, 83275),
(83276, '1.10.540.10-FF-000068', NULL, 'Acyl-CoA dehydrogenase FadE22', 111, NULL, NULL, 83276);
INSERT INTO "PUBLIC"."MODEL" VALUES
(83277, '3.30.230.10-FF-000375', NULL, '40S ribosomal protein S16', 51, NULL, NULL, 83277),
(83278, '3.30.450.30-FF-000072', NULL, 'Uncharacterized protein', 125, NULL, NULL, 83278),
(83279, '1.20.1270.60-FF-000047', NULL, 'protein FAM92A isoform X1', 206, NULL, NULL, 83279),
(83280, '2.60.120.330-FF-000068', NULL, 'S-norcoclaurine synthase 1', 264, NULL, NULL, 83280),
(83281, '2.60.40.60-FF-000646', NULL, 'Uncharacterized protein', 102, NULL, NULL, 83281),
(83282, '1.25.40.10-FF-004346', NULL, 'Uncharacterized protein', 162, NULL, NULL, 83282),
(83283, '1.25.40.840-FF-000009', NULL, 'NTL-1a', 176, NULL, NULL, 83283),
(83284, '3.40.50.2300-FF-001383', NULL, NULL, 47, NULL, NULL, 83284),
(83285, '2.40.10.10-FF-000107', NULL, 'TISP43 isoform 6', 86, NULL, NULL, 83285),
(83286, '1.20.1250.10-FF-000082', NULL, 'Interleukin-22', 142, NULL, NULL, 83286),
(83287, '3.40.50.1220-FF-000058', NULL, 'Deacetylase SIR2', 277, NULL, NULL, 83287),
(83288, '3.30.710.10-FF-000485', NULL, 'SKP1-like protein 6', 85, NULL, NULL, 83288),
(83289, '1.10.246.140-FF-000014', NULL, 'Uncharacterized protein', 71, NULL, NULL, 83289),
(83290, '3.20.20.80-FF-000116', NULL, 'Beta-galactosidase 3', 277, NULL, NULL, 83290),
(83291, '2.10.70.10-FF-000034', NULL, 'BMP-binding endothelial regulator protein', 34, NULL, NULL, 83291),
(83292, '1.10.510.10-FF-000920', NULL, 'Receptor-like protein kinase ANXUR2', 209, NULL, NULL, 83292),
(83293, '3.30.70.1230-FF-000193', NULL, 'Predicted protein', 138, NULL, NULL, 83293),
(83294, '1.20.58.70-FF-000076', NULL, 'QA-SNARE protein putative', 215, NULL, NULL, 83294),
(83295, '3.60.21.10-FF-000427', NULL, 'Serine/threonine-protein phosphatase', 390, NULL, NULL, 83295),
(83296, '1.10.246.60-FF-000005', NULL, 'Eukaryotic translation initiation factor 3 subunit J', 79, NULL, NULL, 83296),
(83297, '3.90.940.10-FF-000011', NULL, NULL, 93, NULL, NULL, 83297),
(83298, '4.10.950.10-FF-000003', NULL, '50S ribosomal protein L2', 78, NULL, NULL, 83298),
(83299, '2.10.25.10-FF-001447', NULL, 'Uncharacterized protein', 44, NULL, NULL, 83299),
(83300, '3.30.70.1360-FF-000001', NULL, 'Global nitrogen regulator NrpR', 122, NULL, NULL, 83300),
(83301, '3.10.290.70-FF-000013', NULL, '40S ribosomal protein S8', 85, NULL, NULL, 83301),
(83302, '3.40.50.300-FF-005634', NULL, 'Uncharacterized protein', 180, NULL, NULL, 83302),
(83303, '2.40.30.330-FF-000005', NULL, 'mRNA cleavage and polyadenylation factor CLP1', 106, NULL, NULL, 83303),
(83304, '3.90.1420.10-FF-000066', NULL, 'Chromosome 9, whole genome shotgun sequence', 153, NULL, NULL, 83304),
(83305, '3.40.50.720-FF-000645', NULL, 'Anthocyanidin reductase ((2S)-flavan-3-ol-forming)', 333, NULL, NULL, 83305),
(83306, '1.20.5.1200-FF-000001', NULL, 'Clavesin 2', 28, NULL, NULL, 83306),
(83307, '2.60.40.10-FF-000564', NULL, 'Ciliary neurotrophic factor receptor subunit alpha', 96, NULL, NULL, 83307),
(83308, '1.20.5.190-FF-000043', NULL, 'unconventional myosin-Ia isoform X1', 52, NULL, NULL, 83308),
(83309, '3.40.50.2300-FF-001236', NULL, NULL, 110, NULL, NULL, 83309),
(83310, '3.40.50.1100-FF-000168', NULL, 'Pyridoxal-phosphate dependent eynzyme', 119, NULL, NULL, 83310),
(83311, '3.40.367.20-FF-000018', NULL, 'hexokinase-2 isoform X3', 56, NULL, NULL, 83311),
(83312, '1.25.40.10-FF-003418', NULL, 'PPR repeat family, putative', 112, NULL, NULL, 83312),
(83313, '3.10.170.20-FF-000012', NULL, 'Leishmanolysin-like peptidase 2', 202, NULL, NULL, 83313),
(83314, '3.30.559.10-FF-000031', NULL, 'Nonribosomal peptide synthase Pes1', 177, NULL, NULL, 83314),
(83315, '3.80.10.10-FF-001464', NULL, 'Leucine_rich_repeat/Leucine_Rich_Repeat_-_putative', 248, NULL, NULL, 83315),
(83316, '1.10.287.690-FF-000025', NULL, 'DNA polymerase', 56, NULL, NULL, 83316),
(83317, '2.130.10.10-FF-002374', NULL, 'Guanine nucleotide-binding beta subunit-like protein', 124, NULL, NULL, 83317),
(83318, '2.40.50.140-FF-000666', NULL, NULL, 60, NULL, NULL, 83318),
(83319, '1.10.8.710-FF-000027', NULL, NULL, 104, NULL, NULL, 83319),
(83320, '1.10.10.10-FF-001792', NULL, 'Putative MarR-family transcriptional regulator', 145, NULL, NULL, 83320);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(83321, '2.130.10.10-FF-001738', NULL, 'Anaphase-promoting complex subunit 4', 118, NULL, NULL, 83321),
(83322, '3.30.420.10-FF-000058', NULL, 'PARN like, ribonuclease domain containing 1', 169, NULL, NULL, 83322),
(83323, '3.30.160.60-FF-004436', NULL, NULL, 51, NULL, NULL, 83323),
(83324, '2.40.10.10-FF-000254', NULL, 'Trypsin precursor', 147, NULL, NULL, 83324),
(83325, '3.30.470.20-FF-000159', NULL, 'Glutathione synthetase', 111, NULL, NULL, 83325),
(83326, '3.30.160.60-FF-001710', NULL, 'Zinc finger protein 407 isoform 1', 82, NULL, NULL, 83326),
(83327, '3.30.420.40-FF-000134', NULL, 'Actin-related protein 8', 200, NULL, NULL, 83327),
(83328, '3.40.50.300-FF-006123', NULL, 'Predicted protein', 63, NULL, NULL, 83328),
(83329, '3.30.559.30-FF-000037', NULL, 'BcNRPS3, nonribosomal peptide synthetase', 249, NULL, NULL, 83329),
(83330, '2.60.120.10-FF-000605', NULL, 'Mannose-6-phosphate isomerase, class I family protein', 75, NULL, NULL, 83330),
(83331, '1.20.1250.40-FF-000006', NULL, 'DNA-directed RNA polymerase II 16 kDa subunit, putative', 128, NULL, NULL, 83331),
(83332, '3.40.50.1000-FF-000256', NULL, 'Phosphomannomutase', 132, NULL, NULL, 83332),
(83333, '3.40.50.10420-FF-000035', NULL, '5-formyltetrahydrofolate cyclo-ligase', 190, NULL, NULL, 83333),
(83334, '3.30.200.20-FF-001365', NULL, 'V-mos Moloney murine sarcoma viral oncogene homolog', 93, NULL, NULL, 83334),
(83335, '3.40.50.720-FF-001281', NULL, 'Chorismate mutase/prephenate dehydrogenase', 157, NULL, NULL, 83335),
(83336, '3.30.830.10-FF-000140', NULL, 'Cytochrome b-c1 complex subunit 2, mitochondrial', 186, NULL, NULL, 83336),
(83337, '3.30.160.60-FF-003947', NULL, NULL, 28, NULL, NULL, 83337),
(83338, '3.50.50.60-FF-000807', NULL, 'Uncharacterized protein', 229, NULL, NULL, 83338),
(83339, '4.10.410.10-FF-000064', NULL, 'Serine peptidase inhibitor, Kunitz type, 2', 60, NULL, NULL, 83339),
(83340, '1.10.579.10-FF-000005', NULL, 'Deoxyribodipyrimidine photo-lyase, putative', 148, NULL, NULL, 83340),
(83341, '1.10.1040.10-FF-000023', NULL, 'lambda-crystallin homolog', 127, NULL, NULL, 83341),
(83342, '3.90.1150.10-FF-000202', NULL, 'Cysteine desulfurase', 135, NULL, NULL, 83342),
(83343, '1.10.510.10-FF-004282', NULL, NULL, 172, NULL, NULL, 83343),
(83344, '1.20.1250.20-FF-000972', NULL, 'Enterobactin transporter', 218, NULL, NULL, 83344),
(83345, '1.10.12.10-FF-000054', NULL, 'Enoyl-CoA hydratase, putative', 57, NULL, NULL, 83345),
(83346, '1.10.630.10-FF-000428', NULL, 'Uncharacterized protein', 263, NULL, NULL, 83346),
(83347, '2.70.150.10-FF-000060', NULL, 'Cation-transporting ATPase', 186, NULL, NULL, 83347),
(83348, '2.10.90.10-FF-000097', NULL, 'Uncharacterized protein', 63, NULL, NULL, 83348),
(83349, '2.70.150.10-FF-000088', NULL, 'Cation transporting ATPase, putative', 158, NULL, NULL, 83349),
(83350, '3.30.420.10-FF-000619', NULL, NULL, 272, NULL, NULL, 83350),
(83351, '2.60.40.1930-FF-000031', NULL, 'Thiolester containing protein I', 95, NULL, NULL, 83351),
(83352, '2.40.160.60-FF-000003', NULL, 'Outer membrane transport family protein', 441, NULL, NULL, 83352),
(83353, '1.25.40.10-FF-003570', NULL, 'SARP family transcriptional regulator', 204, NULL, NULL, 83353),
(83354, '3.80.10.10-FF-001317', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase isoform A', 117, NULL, NULL, 83354),
(83355, '1.25.40.20-FF-001802', NULL, 'BRCA1-associated RING domain protein 1', 166, NULL, NULL, 83355),
(83356, '3.60.40.10-FF-000319', NULL, 'Putative protein phosphatase 2C 53', 211, NULL, NULL, 83356),
(83357, '3.30.870.10-FF-000086', NULL, 'Cardiolipin synthase YbhO', 172, NULL, NULL, 83357),
(83358, '1.20.1560.10-FF-000392', NULL, 'ABC transporter', 344, NULL, NULL, 83358),
(83359, '1.10.8.60-FF-000226', NULL, 'Chromosomal replication initiator DnaA', 67, NULL, NULL, 83359),
(83360, '3.40.33.10-FF-000164', NULL, 'Uncharacterized protein', 115, NULL, NULL, 83360),
(83361, '1.20.5.1180-FF-000006', NULL, NULL, 55, NULL, NULL, 83361),
(83362, '3.40.50.300-FF-002228', NULL, 'Amino acid/amide ABC transporter ATP-binding protein 1, HAAT family', 244, NULL, NULL, 83362);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(83363, '1.25.10.10-FF-000044', NULL, 'AP complex subunit beta', 588, NULL, NULL, 83363),
(83364, '2.10.50.10-FF-000151', NULL, 'Si:ch211-112c15.8', 62, NULL, NULL, 83364),
(83365, '3.90.470.20-FF-000056', NULL, 'Uncharacterized protein', 91, NULL, NULL, 83365),
(83366, '3.30.1150.10-FF-000031', NULL, NULL, 101, NULL, NULL, 83366),
(83367, '2.70.20.50-FF-000001', NULL, 'Matrix protein', 157, NULL, NULL, 83367),
(83368, '2.40.10.10-FF-000315', NULL, 'AGAP013254-PA', 252, NULL, NULL, 83368),
(83369, '3.40.50.10810-FF-000062', NULL, 'DNA repair protein rhp16', 93, NULL, NULL, 83369),
(83370, '3.50.30.30-FF-000117', NULL, 'Ring finger protein 13', 72, NULL, NULL, 83370),
(83371, '3.90.650.10-FF-000056', NULL, 'Hydrogenase expression/formation protein HypE', 176, NULL, NULL, 83371),
(83372, '1.20.120.30-FF-000006', NULL, 'Methyl-accepting chemotaxis protein IV', 167, NULL, NULL, 83372),
(83373, '2.60.40.3500-FF-000002', NULL, 'N-acetylmuramoyl-L-alanine amidase amiB', 110, NULL, NULL, 83373),
(83374, '3.40.50.670-FF-000023', NULL, 'Uncharacterized protein', 72, NULL, NULL, 83374),
(83375, '1.10.3730.20-FF-000028', NULL, 'Probable 4-amino-4-deoxy-L-arabinose-phosphoundecaprenol flippase subunit ArnF', 123, NULL, NULL, 83375),
(83376, '3.20.20.80-FF-000324', NULL, 'Glucosidase, beta, acid 3 (gene/pseudogene)', 403, NULL, NULL, 83376),
(83377, '1.10.150.20-FF-000322', NULL, 'Uncharacterized protein', 52, NULL, NULL, 83377),
(83378, '3.40.50.1820-FF-000058', NULL, 'Alpha/beta hydrolase domain-containing protein 13', 241, NULL, NULL, 83378),
(83379, '4.10.400.10-FF-000119', NULL, 'Suppressor of tumorigenicity 14 protein homolog', 38, NULL, NULL, 83379),
(83380, '2.30.30.140-FF-000063', NULL, 'PWWP domain-containing DNA repair factor 3A', 68, NULL, NULL, 83380),
(83381, '3.80.10.10-FF-000328', NULL, '187-kDa microtubule-associated protein AIR9', 129, NULL, NULL, 83381),
(83382, '2.30.30.140-FF-000119', NULL, 'Ubiquitin carboxyl-terminal hydrolase 34', 56, NULL, NULL, 83382),
(83383, '2.30.29.30-FF-001180', NULL, 'Beige protein homolog 1', 125, NULL, NULL, 83383),
(83384, '3.40.50.720-FF-001842', NULL, 'Alcohol dehydrogenase, putative (AFU_orthologue AFUA_2G04590)', 76, NULL, NULL, 83384),
(83385, '2.60.120.430-FF-000008', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 174, NULL, NULL, 83385),
(83386, '2.60.40.10-FF-001906', NULL, 'Muscle M-line assembly protein unc-89', 103, NULL, NULL, 83386),
(83387, '2.30.29.170-FF-000019', NULL, 'EF-hand domain (C-terminal) containing 1', 136, NULL, NULL, 83387),
(83388, '3.75.10.10-FF-000026', NULL, NULL, 139, NULL, NULL, 83388),
(83389, '1.20.1270.60-FF-000255', NULL, 'Uncharacterized protein', 209, NULL, NULL, 83389),
(83390, '3.30.160.60-FF-005717', NULL, NULL, 39, NULL, NULL, 83390),
(83391, '4.10.870.10-FF-000002', NULL, 'Family 48 cellulase', 91, NULL, NULL, 83391),
(83392, '1.20.1070.10-FF-002170', NULL, 'Predicted protein', 122, NULL, NULL, 83392),
(83393, '1.25.40.10-FF-003918', NULL, 'ACL089Wp', 441, NULL, NULL, 83393),
(83394, '2.30.29.30-FF-001236', NULL, 'Guanine exchange factor for Rac 30', 114, NULL, NULL, 83394),
(83395, '2.130.10.10-FF-005628', NULL, 'Uncharacterized protein', 179, NULL, NULL, 83395),
(83396, '2.130.10.10-FF-005100', NULL, 'Uncharacterized protein', 253, NULL, NULL, 83396),
(83397, '3.90.79.10-FF-000216', NULL, 'Nudix hydrolase 1', 45, NULL, NULL, 83397),
(83398, '2.60.450.10-FF-000006', NULL, 'Lipopolysaccharide export system protein LptA', 150, NULL, NULL, 83398),
(83399, '1.10.238.10-FF-000848', NULL, 'GM15808', 73, NULL, NULL, 83399),
(83400, '1.10.1410.10-FF-000012', NULL, 'Nucleolar protein 6', 175, NULL, NULL, 83400),
(83401, '3.20.20.80-FF-000796', NULL, 'Glycosyl hydrolase-like protein', 166, NULL, NULL, 83401),
(83402, '3.30.160.60-FF-002930', NULL, 'Zinc finger protein 26', 29, NULL, NULL, 83402),
(83403, '2.10.90.10-FF-000125', NULL, 'Activin B', 111, NULL, NULL, 83403),
(83404, '2.130.10.10-FF-001885', NULL, 'Uncharacterized protein', 290, NULL, NULL, 83404),
(83405, '1.25.40.10-FF-001092', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 81, NULL, NULL, 83405);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(83406, '1.10.533.10-FF-000225', NULL, 'Uncharacterized protein', 92, NULL, NULL, 83406),
(83407, '3.40.50.11500-FF-000016', NULL, 'DENN domain containing protein 2D', 167, NULL, NULL, 83407),
(83408, '3.30.70.330-FF-000624', NULL, 'Oligouridylate-binding protein 1A', 82, NULL, NULL, 83408),
(83409, '2.60.40.10-FF-000772', NULL, 'Uncharacterized protein, isoform B', 98, NULL, NULL, 83409),
(83410, '2.130.10.10-FF-000249', NULL, 'nucleoporin Nup43', 337, NULL, NULL, 83410),
(83411, '1.20.910.10-FF-000004', NULL, 'Aminopyrimidine aminohydrolase', 220, NULL, NULL, 83411),
(83412, '2.30.180.10-FF-000088', NULL, NULL, 134, NULL, NULL, 83412),
(83413, '2.60.40.10-FF-001761', NULL, 'Interleukin 18 receptor accessory protein', 111, NULL, NULL, 83413),
(83414, '3.30.70.330-FF-000040', NULL, 'Heterogeneous nuclear ribonucleoprotein A2/B1', 85, NULL, NULL, 83414),
(83415, '3.30.390.10-FF-000004', NULL, 'Glucarate dehydratase', 146, NULL, NULL, 83415),
(83416, '1.25.40.20-FF-001302', NULL, 'Ankrd15 protein', 155, NULL, NULL, 83416),
(83417, '3.30.160.60-FF-001502', NULL, 'ZFP28 zinc finger protein', 30, NULL, NULL, 83417),
(83418, '3.30.200.20-FF-001101', NULL, 'Inka box actin regulator 1b', 56, NULL, NULL, 83418),
(83419, '1.20.1280.50-FF-000224', NULL, 'Predicted protein', 45, NULL, NULL, 83419),
(83420, '3.40.50.300-FF-003509', NULL, 'Putative ATP-dependent RNA helicase', 155, NULL, NULL, 83420),
(83421, '3.40.1110.10-FF-000279', NULL, NULL, 143, NULL, NULL, 83421),
(83422, '1.20.950.20-FF-000015', NULL, 'Hydrogenase', 160, NULL, NULL, 83422),
(83423, '2.60.120.380-FF-000089', NULL, 'Calpain 9', 77, NULL, NULL, 83423),
(83424, '1.10.230.10-FF-000027', NULL, 'Bll6374 protein', 106, NULL, NULL, 83424),
(83425, '1.20.210.10-FF-000030', NULL, 'Cytochrome c oxidase subunit 1', 102, NULL, NULL, 83425),
(83426, '1.10.150.50-FF-000218', NULL, 'Sphingomyelin synthase-related 1-like Protein', 75, NULL, NULL, 83426),
(83427, '3.40.50.1820-FF-001047', NULL, 'Carboxylic ester hydrolase', 491, NULL, NULL, 83427),
(83428, '3.50.4.10-FF-000036', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase SD1-1 isoform B', 84, NULL, NULL, 83428),
(83429, '2.40.10.350-FF-000002', NULL, 'Cell shape-determining protein MreC', 73, NULL, NULL, 83429),
(83430, '1.25.10.10-FF-000544', NULL, 'AP-1 complex subunit gamma', 124, NULL, NULL, 83430),
(83431, '2.60.120.920-FF-000150', NULL, 'Uncharacterized protein', 269, NULL, NULL, 83431),
(83432, '1.25.40.570-FF-000057', NULL, 'Uncharacterized protein', 310, NULL, NULL, 83432),
(83433, '1.10.510.10-FF-004135', NULL, NULL, 77, NULL, NULL, 83433),
(83434, '3.30.2320.10-FF-000005', NULL, NULL, 99, NULL, NULL, 83434),
(83435, '3.40.50.1820-FF-001311', NULL, 'Uncharacterized protein', 264, NULL, NULL, 83435),
(83436, '1.20.120.140-FF-000044', NULL, 'Predicted protein', 54, NULL, NULL, 83436),
(83437, '3.30.450.80-FF-000007', NULL, 'LuxR family transcriptional regulator', 175, NULL, NULL, 83437),
(83438, '1.20.120.350-FF-000022', NULL, 'Sodium channel protein', 111, NULL, NULL, 83438),
(83439, '3.30.450.20-FF-000304', NULL, 'Probable serine/threonine-protein kinase DDB_G0280133', 102, NULL, NULL, 83439),
(83440, '1.20.1250.20-FF-000500', NULL, 'Metabolite/drug transporter, putative', 384, NULL, NULL, 83440),
(83441, '3.40.50.300-FF-008568', NULL, 'Uncharacterized protein', 127, NULL, NULL, 83441),
(83442, '1.10.357.10-FF-000012', NULL, 'Transcriptional regulator, TetR family', 185, NULL, NULL, 83442),
(83443, '1.20.5.170-FF-000149', NULL, 'LD42070p', 50, NULL, NULL, 83443),
(83444, '1.20.1250.20-FF-000764', NULL, 'Solute carrier organic anion transporter family member', 404, NULL, NULL, 83444),
(83445, '3.30.160.60-FF-001974', NULL, 'zinc finger protein 329', 36, NULL, NULL, 83445),
(83446, '3.30.200.20-FF-001573', NULL, 'Uncharacterized protein', 99, NULL, NULL, 83446),
(83447, '3.40.50.10180-FF-000007', NULL, 'Uncharacterized protein', 177, NULL, NULL, 83447),
(83448, '3.40.50.1000-FF-000464', NULL, NULL, 149, NULL, NULL, 83448),
(83449, '2.30.30.100-FF-000158', NULL, 'LSM11, U7 small nuclear RNA associated', 127, NULL, NULL, 83449);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(83450, '3.40.50.11030-FF-000004', NULL, 'Threonylcarbamoyl-AMP synthase', 134, NULL, NULL, 83450),
(83451, '1.10.8.60-FF-000018', NULL, '26S protease regulatory subunit 6B', 81, NULL, NULL, 83451),
(83452, '2.40.340.10-FF-000014', NULL, 'Molybdopterin molybdenumtransferase', 81, NULL, NULL, 83452),
(83453, '3.40.190.290-FF-000102', NULL, 'LysR family transcriptional regulator', 206, NULL, NULL, 83453),
(83454, '1.20.200.10-FF-000001', NULL, 'Fumarate hydratase, mitochondrial', 268, NULL, NULL, 83454),
(83455, '1.20.5.110-FF-000238', NULL, 'Uncharacterized protein', 62, NULL, NULL, 83455),
(83456, '1.10.287.70-FF-000007', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 111, NULL, NULL, 83456),
(83457, '3.40.850.10-FF-000442', NULL, 'Uncharacterized protein', 132, NULL, NULL, 83457),
(83458, '3.30.160.60-FF-001238', NULL, 'Zinc finger protein 648', 30, NULL, NULL, 83458),
(83459, '3.30.160.60-FF-004583', NULL, NULL, 31, NULL, NULL, 83459),
(83460, '1.25.10.10-FF-001264', NULL, 'PIKK family atypical protein kinase', 256, NULL, NULL, 83460),
(83461, '3.90.230.10-FF-000064', NULL, NULL, 191, NULL, NULL, 83461),
(83462, '3.30.40.10-FF-000478', NULL, 'Ring finger protein 207', 75, NULL, NULL, 83462),
(83463, '1.20.1070.10-FF-001326', NULL, 'Uncharacterized protein', 215, NULL, NULL, 83463),
(83464, '2.40.30.10-FF-000429', NULL, 'Eukaryotic release factor 3 GTPase subunit', 108, NULL, NULL, 83464),
(83465, '3.50.50.60-FF-000987', NULL, 'Fmo1p', 191, NULL, NULL, 83465),
(83466, '2.40.50.90-FF-000089', NULL, 'Endonuclease YncB, thermonuclease family', 126, NULL, NULL, 83466),
(83467, '3.40.50.300-FF-004353', NULL, 'ABC transporter, ATP binding protein', 236, NULL, NULL, 83467),
(83468, '3.50.50.100-FF-000058', NULL, 'Type-II NADH dehydrogenase', 144, NULL, NULL, 83468),
(83469, '1.25.40.540-FF-000009', NULL, 'Similar to TOR signalling pathway regulator (TapA)', 216, NULL, NULL, 83469),
(83470, '1.10.357.30-FF-000018', NULL, NULL, 166, NULL, NULL, 83470),
(83471, '1.25.40.10-FF-000956', NULL, 'Putative pentatricopeptide repeat-containing protein', 156, NULL, NULL, 83471),
(83472, '1.10.437.10-FF-000013', NULL, 'Protein F1', 153, NULL, NULL, 83472),
(83473, '3.30.230.10-FF-000083', NULL, 'Ribonuclease P protein component', 111, NULL, NULL, 83473),
(83474, '3.90.550.10-FF-000700', NULL, 'Uncharacterized protein', 292, NULL, NULL, 83474),
(83475, '3.30.1490.120-FF-000024', NULL, 'Probable DNA-directed RNA polymerase I subunit RPA43', 93, NULL, NULL, 83475),
(83476, '3.30.1520.10-FF-000104', NULL, 'Uncharacterized protein', 132, NULL, NULL, 83476),
(83477, '3.40.630.30-FF-000353', NULL, 'AGAP002287-PA', 234, NULL, NULL, 83477),
(83478, '1.25.40.180-FF-000210', NULL, NULL, 167, NULL, NULL, 83478),
(83479, '1.25.10.10-FF-001972', NULL, 'RING-type E3 ubiquitin transferase', 185, NULL, NULL, 83479),
(83480, '3.30.160.60-FF-000985', NULL, 'Zinc finger protein 236', 27, NULL, NULL, 83480),
(83481, '1.10.510.10-FF-000392', NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 152', 173, NULL, NULL, 83481),
(83482, '3.40.50.10190-FF-000067', NULL, 'Pescadillo homolog', 77, NULL, NULL, 83482),
(83483, '3.40.50.1820-FF-000322', NULL, 'Integral membrane protein', 259, NULL, NULL, 83483),
(83484, '3.40.50.12780-FF-000080', NULL, 'Nonribosomal peptide synthase SidE', 382, NULL, NULL, 83484),
(83485, '3.65.10.20-FF-000024', NULL, 'Uncharacterized protein', 83, NULL, NULL, 83485),
(83486, '3.90.226.10-FF-000166', NULL, 'Membrane-bound serine protease', 211, NULL, NULL, 83486),
(83487, '3.40.50.620-FF-000441', NULL, 'Tryptophan--tRNA ligase', 212, NULL, NULL, 83487),
(83488, '3.40.640.10-FF-000432', NULL, 'Serine--pyruvate aminotransferase', 134, NULL, NULL, 83488),
(83489, '3.80.10.10-FF-000536', NULL, 'Leucine-rich repeat-containing protein 30', 134, NULL, NULL, 83489),
(83490, '3.40.50.1460-FF-000079', NULL, 'Uncharacterized protein', 251, NULL, NULL, 83490),
(83491, '2.60.40.10-FF-000125', NULL, 'filamin-B isoform X1', 80, NULL, NULL, 83491),
(83492, '2.30.30.140-FF-000271', NULL, 'Fragile X mental retardation syndrome-related protein 1-like Protein', 49, NULL, NULL, 83492);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(83493, '3.40.50.80-FF-000134', NULL, 'Ferric reductase like transmembrane component-domain-containing protein', 79, NULL, NULL, 83493),
(83494, '3.40.50.150-FF-001677', NULL, NULL, 150, NULL, NULL, 83494),
(83495, '2.130.10.10-FF-003863', NULL, 'Uncharacterized protein', 282, NULL, NULL, 83495),
(83496, '1.20.90.10-FF-000054', NULL, NULL, 70, NULL, NULL, 83496),
(83497, '1.20.82.10-FF-000007', NULL, 'Uncharacterized protein', 65, NULL, NULL, 83497),
(83498, '1.20.120.710-FF-000001', NULL, 'N-acylneuraminate-9-phosphatase', 86, NULL, NULL, 83498),
(83499, '3.10.110.10-FF-000207', NULL, 'UBC26', 288, NULL, NULL, 83499),
(83500, '4.10.400.10-FF-000271', NULL, 'Uncharacterized protein', 43, NULL, NULL, 83500),
(83501, '1.50.40.10-FF-000280', NULL, 'Mitochondrial carrier protein, putative', 190, NULL, NULL, 83501),
(83502, '1.10.30.10-FF-000186', NULL, 'Uncharacterized protein', 40, NULL, NULL, 83502),
(83503, '3.30.70.270-FF-000112', NULL, 'Uncharacterized protein', 87, NULL, NULL, 83503),
(83504, '3.30.160.60-FF-004728', NULL, NULL, 89, NULL, NULL, 83504),
(83505, '1.10.150.80-FF-000025', NULL, 'HRDC domain./PIF1 helicase', 85, NULL, NULL, 83505),
(83506, '3.30.420.10-FF-000266', NULL, '3''-5'' exoribonuclease parn-1', 228, NULL, NULL, 83506),
(83507, '1.10.10.2330-FF-000011', NULL, NULL, 53, NULL, NULL, 83507),
(83508, '2.70.150.10-FF-000116', NULL, 'Calcium-transporting ATPase', 156, NULL, NULL, 83508),
(83509, '2.130.10.10-FF-004791', NULL, 'Uncharacterized protein', 149, NULL, NULL, 83509),
(83510, '3.10.20.90-FF-000322', NULL, 'Uncharacterized protein, isoform D', 64, NULL, NULL, 83510),
(83511, '1.25.40.1030-FF-000041', NULL, 'Uncharacterized protein', 406, NULL, NULL, 83511),
(83512, '1.20.120.730-FF-000007', NULL, 'Protein transport protein SEC23', 121, NULL, NULL, 83512),
(83513, '3.40.50.300-FF-003189', NULL, 'GTPase HflX', 170, NULL, NULL, 83513),
(83514, '1.10.10.60-FF-000238', NULL, 'Aspartate/glutamate/uridylate kinase family protein', 64, NULL, NULL, 83514),
(83515, '1.25.40.10-FF-002081', NULL, 'C-term of Hsp70-iNteracting protein (CHIP family)', 121, NULL, NULL, 83515),
(83516, '2.60.40.1120-FF-000086', NULL, 'Uncharacterized protein', 92, NULL, NULL, 83516),
(83517, '1.25.40.20-FF-001038', NULL, 'Ankyrin repeat-containing protein', 101, NULL, NULL, 83517),
(83518, '2.60.40.10-FF-002481', NULL, 'AGAP003656-PA', 87, NULL, NULL, 83518),
(83519, '3.40.1090.10-FF-000046', NULL, 'NTE family protein', 84, NULL, NULL, 83519),
(83520, '2.60.40.10-FF-005504', NULL, NULL, 90, NULL, NULL, 83520),
(83521, '1.20.1110.10-FF-000072', NULL, 'ATPase 11, plasma membrane-type-like', 38, NULL, NULL, 83521),
(83522, '1.25.10.10-FF-000336', NULL, 'Catenin delta-2', 464, NULL, NULL, 83522),
(83523, '3.40.850.10-FF-000178', NULL, 'Kinesin-related protein3', 206, NULL, NULL, 83523),
(83524, '2.40.50.140-FF-000374', NULL, 'Nodulation efficiency protein D', 62, NULL, NULL, 83524),
(83525, '2.60.120.200-FF-000760', NULL, 'Uncharacterized protein', 84, NULL, NULL, 83525),
(83526, '3.10.20.10-FF-000017', NULL, 'LPXTG-motif cell wall anchor domain protein', 78, NULL, NULL, 83526),
(83527, '2.120.10.30-FF-000076', NULL, 'Acylamino-acid-releasing enzyme', 219, NULL, NULL, 83527),
(83528, '2.20.100.10-FF-000074', NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 12', 71, NULL, NULL, 83528),
(83529, '3.40.50.300-FF-003397', NULL, 'Eng_C97 protein', 174, NULL, NULL, 83529),
(83530, '3.30.70.330-FF-001288', NULL, 'Protein CBG15138', 83, NULL, NULL, 83530),
(83531, '1.25.40.20-FF-001774', NULL, 'Uncharacterized protein', 315, NULL, NULL, 83531),
(83532, '2.60.40.10-FF-004515', NULL, NULL, 94, NULL, NULL, 83532),
(83533, '2.130.10.10-FF-002082', NULL, 'WD40 repeat-like protein', 297, NULL, NULL, 83533),
(83534, '2.60.40.10-FF-003559', NULL, 'Interleukin 10 receptor, alpha', 196, NULL, NULL, 83534),
(83535, '2.10.25.10-FF-001155', NULL, 'Brevican', 72, NULL, NULL, 83535),
(83536, '1.10.150.720-FF-000001', NULL, 'Haloacid dehalogenase-like hydrolase domain-containing protein 3', 84, NULL, NULL, 83536);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(83537, '1.20.1740.10-FF-000046', NULL, 'Amino-acid permease, putative', 470, NULL, NULL, 83537),
(83538, '3.30.450.20-FF-000568', NULL, 'Putative methyl-accepting chemotaxis protein', 94, NULL, NULL, 83538),
(83539, '1.25.10.10-FF-001472', NULL, 'Uncharacterized protein', 204, NULL, NULL, 83539),
(83540, '1.25.40.10-FF-003862', NULL, 'Uncharacterized protein', 106, NULL, NULL, 83540),
(83541, '3.30.360.10-FF-000120', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase GAPA1 chloroplastic', 64, NULL, NULL, 83541),
(83542, '1.20.1250.20-FF-001692', NULL, 'Uncharacterized protein', 134, NULL, NULL, 83542),
(83543, '1.10.560.10-FF-000131', NULL, 'T-complex protein 1 subunit beta', 48, NULL, NULL, 83543),
(83544, '1.10.8.270-FF-000058', NULL, 'Related to MDR1-Mac1p interacting protein', 105, NULL, NULL, 83544),
(83545, '3.60.21.10-FF-000282', NULL, 'Serine/threonine-protein phosphatase', 256, NULL, NULL, 83545),
(83546, '3.40.50.300-FF-005342', NULL, 'ATPase involved in chromosome partitioning-like protein', 268, NULL, NULL, 83546),
(83547, '3.20.20.70-FF-000698', NULL, NULL, 164, NULL, NULL, 83547),
(83548, '3.80.10.10-FF-002745', NULL, 'Putative F-box/FBD/LRR-repeat protein At4g00315', 272, NULL, NULL, 83548),
(83549, '3.30.60.30-FF-000194', NULL, 'Serine protease inhibitor kazal-like protein, minor form', 57, NULL, NULL, 83549),
(83550, '2.60.120.560-FF-000019', NULL, 'Beta-galactosidase', 169, NULL, NULL, 83550),
(83551, '2.60.40.10-FF-005768', NULL, NULL, 101, NULL, NULL, 83551),
(83552, '1.25.40.20-FF-001510', NULL, 'Ankyrin repeat family protein', 195, NULL, NULL, 83552),
(83553, '1.10.510.10-FF-001229', NULL, 'Rho-associated protein kinase 2', 132, NULL, NULL, 83553),
(83554, '1.20.1070.10-FF-000337', NULL, 'Adrenoceptor alpha 2C', 298, NULL, NULL, 83554),
(83555, '3.30.160.60-FF-003655', NULL, 'IP01015p', 23, NULL, NULL, 83555),
(83556, '1.10.530.10-FF-000039', NULL, 'Possible peptidase', 149, NULL, NULL, 83556),
(83557, '3.90.70.10-FF-000051', NULL, 'Ubiquitinyl hydrolase 1', 173, NULL, NULL, 83557),
(83558, '3.90.640.10-FF-000027', NULL, 'Actin like 8', 95, NULL, NULL, 83558),
(83559, '3.90.930.12-FF-000001', NULL, '50S ribosomal protein L6', 95, NULL, NULL, 83559),
(83560, '3.40.309.10-FF-000022', NULL, 'NADP-dependent glyceraldehyde-3-phosphate dehydrogenase', 194, NULL, NULL, 83560),
(83561, '3.30.260.10-FF-000023', NULL, 'T-complex protein 1 subunit gamma', 74, NULL, NULL, 83561),
(83562, '1.10.760.10-FF-000112', NULL, 'Cytochrome c', 182, NULL, NULL, 83562),
(83563, '2.60.120.200-FF-000024', NULL, 'FAT atypical cadherin 1', 169, NULL, NULL, 83563),
(83564, '2.20.28.10-FF-000003', NULL, 'DNA helicase', 52, NULL, NULL, 83564),
(83565, '1.10.3120.10-FF-000024', NULL, NULL, 207, NULL, NULL, 83565),
(83566, '1.20.58.110-FF-000007', NULL, '30S ribosomal protein S20', 87, NULL, NULL, 83566),
(83567, '2.60.40.10-FF-002834', NULL, 'High Incidence of Males (Increased X chromosome loss)', 97, NULL, NULL, 83567),
(83568, '3.30.230.130-FF-000090', NULL, 'Uncharacterized protein', 79, NULL, NULL, 83568),
(83569, '2.40.33.10-FF-000031', NULL, 'Pyruvate kinase', 95, NULL, NULL, 83569),
(83570, '3.40.50.150-FF-000957', NULL, NULL, 167, NULL, NULL, 83570),
(83571, '1.20.990.10-FF-000043', NULL, 'Oxidoreductase-protein, putative', 145, NULL, NULL, 83571),
(83572, '3.40.50.200-FF-000079', NULL, 'Uncharacterized protein', 268, NULL, NULL, 83572),
(83573, '3.40.50.2300-FF-000539', NULL, 'LacI family transcriptional regulator', 114, NULL, NULL, 83573),
(83574, '3.40.50.10190-FF-000275', NULL, 'Uncharacterized protein', 65, NULL, NULL, 83574),
(83575, '2.60.120.260-FF-000199', NULL, 'CRE-UNC-84 protein', 198, NULL, NULL, 83575),
(83576, '3.40.640.10-FF-000224', NULL, 'Probable glycine dehydrogenase (decarboxylating) subunit 2', 244, NULL, NULL, 83576),
(83577, '3.40.950.10-FF-000034', NULL, NULL, 240, NULL, NULL, 83577),
(83578, '3.30.160.60-FF-000721', NULL, 'Zinc finger protein 407', 77, NULL, NULL, 83578),
(83579, '2.30.180.10-FF-000149', NULL, NULL, 169, NULL, NULL, 83579),
(83580, '2.30.18.10-FF-000013', NULL, 'Uncharacterized protein', 62, NULL, NULL, 83580);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(83581, '3.30.420.10-FF-000530', NULL, NULL, 98, NULL, NULL, 83581),
(83582, '3.40.50.300-FF-005134', NULL, 'DEAD box helicase involved in nonsense mediated decay, putative (AFU_orthologue AFUA_5G09090)', 242, NULL, NULL, 83582),
(83583, '3.40.630.30-FF-000145', NULL, 'Acetyltransferase Atu2258', 105, NULL, NULL, 83583),
(83584, '3.30.2290.10-FF-000007', NULL, 'Metalloprotease TldD', 217, NULL, NULL, 83584),
(83585, '3.40.50.300-FF-002672', NULL, 'Elongation factor, putative', 193, NULL, NULL, 83585),
(83586, '1.50.40.10-FF-000072', NULL, 'solute carrier family 25 member 47', 95, NULL, NULL, 83586),
(83587, '2.30.30.490-FF-000084', NULL, 'Uncharacterized protein', 164, NULL, NULL, 83587),
(83588, '1.10.510.10-FF-000712', NULL, 'Uncharacterized protein', 197, NULL, NULL, 83588),
(83589, '2.30.30.40-FF-000062', NULL, 'caskin-2 isoform X1', 65, NULL, NULL, 83589),
(83590, '1.25.40.20-FF-000993', NULL, 'Uncharacterized protein', 166, NULL, NULL, 83590),
(83591, '3.40.50.620-FF-000177', NULL, 'probable receptor-like serine/threonine-protein kinase At5g57670', 134, NULL, NULL, 83591),
(83592, '3.60.40.10-FF-000258', NULL, 'Protein phosphatase 1H', 351, NULL, NULL, 83592),
(83593, '3.30.930.10-FF-000349', NULL, 'Uncharacterized protein', 65, NULL, NULL, 83593),
(83594, '1.20.1070.10-FF-001826', NULL, 'Uncharacterized protein', 307, NULL, NULL, 83594),
(83595, '3.30.230.70-FF-000022', NULL, 'Polyribonucleotide nucleotidyltransferase 2 mitochondrial', 235, NULL, NULL, 83595),
(83596, '1.20.120.430-FF-000007', NULL, 'tRNA modification GTPase', 171, NULL, NULL, 83596),
(83597, '1.10.510.10-FF-003062', NULL, NULL, 205, NULL, NULL, 83597),
(83598, '3.40.50.300-FF-002728', NULL, 'ATPase family AAA domain-containing protein 3', 166, NULL, NULL, 83598),
(83599, '1.50.40.10-FF-000128', NULL, 'Solute carrier family 25 member 48', 147, NULL, NULL, 83599),
(83600, '3.40.30.10-FF-000775', NULL, 'Hydroperoxy fatty acid reductase gpx2', 151, NULL, NULL, 83600),
(83601, '1.10.287.470-FF-000015', NULL, 'Multidrug efflux RND membrane fusion protein MexE', 74, NULL, NULL, 83601),
(83602, '3.40.50.1820-FF-001811', NULL, 'Predicted protein', 122, NULL, NULL, 83602),
(83603, '2.40.30.170-FF-000053', NULL, NULL, 68, NULL, NULL, 83603),
(83604, '3.10.20.90-FF-000114', NULL, '40S ribosomal protein S30', 74, NULL, NULL, 83604),
(83605, '1.20.58.2220-FF-000060', NULL, 'Uncharacterized protein', 374, NULL, NULL, 83605),
(83606, '3.30.160.60-FF-004936', NULL, NULL, 34, NULL, NULL, 83606),
(83607, '1.10.510.10-FF-001881', NULL, 'ephrin type-A receptor 6-like', 98, NULL, NULL, 83607),
(83608, '1.20.140.10-FF-000063', NULL, 'FMNH2-dependent monooxygenase', 173, NULL, NULL, 83608),
(83609, '2.60.120.650-FF-000046', NULL, 'JmjC domain-containing protein D', 276, NULL, NULL, 83609),
(83610, '1.20.1250.20-FF-001220', NULL, 'Uncharacterized protein', 210, NULL, NULL, 83610),
(83611, '2.60.40.10-FF-000064', NULL, 'Contactin 1', 97, NULL, NULL, 83611),
(83612, '3.30.565.10-FF-000091', NULL, 'Sensor histidine kinase/response regulator EvgS', 169, NULL, NULL, 83612),
(83613, '2.60.120.620-FF-000150', NULL, 'Prolyl 4-hydroxylase alpha subunit, putative', 142, NULL, NULL, 83613),
(83614, '3.40.50.300-FF-003897', NULL, 'Endonuclease MutS2', 246, NULL, NULL, 83614),
(83615, '3.30.460.10-FF-000184', NULL, 'Uncharacterized protein', 43, NULL, NULL, 83615),
(83616, '4.10.280.10-FF-000238', NULL, 'Uncharacterized protein', 64, NULL, NULL, 83616),
(83617, '3.40.50.150-FF-001177', NULL, NULL, 153, NULL, NULL, 83617),
(83618, '1.10.510.10-FF-003938', NULL, NULL, 67, NULL, NULL, 83618),
(83619, '1.10.210.20-FF-000001', NULL, '1H-3-hydroxy-4-oxoquinaldine 2,4-dioxygenase', 70, NULL, NULL, 83619),
(83620, '1.10.20.120-FF-000013', NULL, 'Ribonuclease H2, subunit B', 69, NULL, NULL, 83620),
(83621, '1.25.10.10-FF-001000', NULL, 'Armadillo repeat containing 8', 249, NULL, NULL, 83621),
(83622, '3.80.10.10-FF-001256', NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', 254, NULL, NULL, 83622),
(83623, '3.30.530.20-FF-000069', NULL, 'Protein CBG22145', 267, NULL, NULL, 83623);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(83624, '1.20.1250.20-FF-001017', NULL, 'Os08g0527700 protein', 259, NULL, NULL, 83624),
(83625, '1.25.40.10-FF-003098', NULL, 'Uncharacterized protein', 129, NULL, NULL, 83625),
(83626, '3.10.450.580-FF-000020', NULL, 'Mediator of RNA polymerase II transcription subunit 6', 117, NULL, NULL, 83626),
(83627, '3.40.50.2300-FF-001444', NULL, NULL, 59, NULL, NULL, 83627),
(83628, '1.20.1260.60-FF-000018', NULL, 'DNA mismatch repair protein', 201, NULL, NULL, 83628),
(83629, '3.80.10.10-FF-002161', NULL, 'immunoglobulin superfamily member 10-like', 236, NULL, NULL, 83629),
(83630, '3.40.50.2000-FF-000455', NULL, 'LPS 1,2-N-acetylglucosaminetransferase', 151, NULL, NULL, 83630),
(83631, '2.60.40.10-FF-004015', NULL, NULL, 99, NULL, NULL, 83631),
(83632, '3.30.2160.10-FF-000003', NULL, 'E3 ubiquitin-protein ligase', 79, NULL, NULL, 83632),
(83633, '3.40.50.11660-FF-000047', NULL, NULL, 110, NULL, NULL, 83633),
(83634, '1.25.40.10-FF-004115', NULL, 'U3 small nucleolar RNA-associated protein 6 homolog-like Protein', 298, NULL, NULL, 83634),
(83635, '2.130.10.10-FF-004903', NULL, 'Uncharacterized protein', 112, NULL, NULL, 83635),
(83636, '2.120.10.30-FF-000284', NULL, 'E3 ubiquitin-protein ligase TRIM71', 108, NULL, NULL, 83636),
(83637, '3.40.50.300-FF-007904', NULL, 'Teg12', 188, NULL, NULL, 83637),
(83638, '2.40.180.10-FF-000012', NULL, 'Lipoxygenase homology domain-containing protein 1', 127, NULL, NULL, 83638),
(83639, '1.25.10.10-FF-002753', NULL, 'Uncharacterized protein', 658, NULL, NULL, 83639),
(83640, '2.40.50.140-FF-000166', NULL, '30S ribosomal protein S1', 79, NULL, NULL, 83640),
(83641, '1.10.510.10-FF-004490', NULL, NULL, 235, NULL, NULL, 83641),
(83642, '3.40.50.10190-FF-000128', NULL, 'Mutagen-sensitive 101', 96, NULL, NULL, 83642),
(83643, '3.30.310.270-FF-000004', NULL, 'Defective in germ line development protein 3', 198, NULL, NULL, 83643),
(83644, '1.10.565.10-FF-000035', NULL, 'Nuclear hormone receptor HR96', 247, NULL, NULL, 83644),
(83645, '1.10.10.10-FF-000948', NULL, 'COP9 signalosome complex subunit 4', 79, NULL, NULL, 83645),
(83646, '3.30.40.10-FF-001518', NULL, 'Predicted protein', 111, NULL, NULL, 83646),
(83647, '3.30.1010.10-FF-000021', NULL, 'Phosphatidylinositol 4-kinase', 159, NULL, NULL, 83647),
(83648, '1.10.10.60-FF-000177', NULL, 'Homeobox protein DBX1', 79, NULL, NULL, 83648),
(83649, '2.60.40.150-FF-000269', NULL, 'Non-specific serine/threonine protein kinase', 85, NULL, NULL, 83649),
(83650, '2.40.170.20-FF-000043', NULL, 'Uncharacterized protein', 641, NULL, NULL, 83650),
(83651, '3.30.70.330-FF-002305', NULL, NULL, 138, NULL, NULL, 83651),
(83652, '2.130.10.10-FF-000188', NULL, 'striatin-3 isoform X2', 161, NULL, NULL, 83652),
(83653, '3.30.160.60-FF-002019', NULL, 'zinc finger protein 263-like', 27, NULL, NULL, 83653),
(83654, '3.30.70.330-FF-001788', NULL, NULL, 81, NULL, NULL, 83654),
(83655, '3.10.20.90-FF-000586', NULL, 'Uncharacterized protein', 122, NULL, NULL, 83655),
(83656, '3.30.365.10-FF-000024', NULL, 'Xanthine dehydrogenase, molybdenum binding subunit', 112, NULL, NULL, 83656),
(83657, '2.20.70.10-FF-000073', NULL, 'Rho GTPase activating protein 9', 47, NULL, NULL, 83657),
(83658, '2.60.40.790-FF-000141', NULL, NULL, 130, NULL, NULL, 83658),
(83659, '3.60.21.10-FF-000074', NULL, 'UDP-2,3-diacylglucosamine hydrolase', 236, NULL, NULL, 83659),
(83660, '1.20.1070.10-FF-000545', NULL, 'Serpentine Receptor, class O (Opsin)', 299, NULL, NULL, 83660),
(83661, '2.10.25.10-FF-001508', NULL, 'Uncharacterized protein', 28, NULL, NULL, 83661),
(83662, '2.130.10.10-FF-002958', NULL, 'Katanin p80 WD40 repeat-containing subunit B1', 242, NULL, NULL, 83662),
(83663, '3.30.70.1060-FF-000001', NULL, 'YciI family protein', 98, NULL, NULL, 83663),
(83664, '3.30.70.1230-FF-000221', NULL, 'Uncharacterized protein', 64, NULL, NULL, 83664),
(83665, '3.40.50.1820-FF-000530', NULL, 'Probable acyltransferase', 374, NULL, NULL, 83665),
(83666, '2.40.50.120-FF-000008', NULL, 'agrin isoform X1', 128, NULL, NULL, 83666),
(83667, '1.20.80.10-FF-000025', NULL, 'pleckstrin homology domain-containing family H member 3 isoform X2', 158, NULL, NULL, 83667);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(83668, '2.170.150.80-FF-000023', NULL, 'NAC (No Apical Meristem) domain transcriptional regulator superfamily protein', 148, NULL, NULL, 83668),
(83669, '1.25.40.10-FF-004790', NULL, 'Superkiller protein 3', 280, NULL, NULL, 83669),
(83670, '2.40.50.100-FF-000002', NULL, 'Efflux transporter periplasmic adaptor subunit', 71, NULL, NULL, 83670),
(83671, '3.30.1230.20-FF-000006', NULL, '40S ribosomal protein S21', 82, NULL, NULL, 83671),
(83672, '1.10.10.10-FF-001853', NULL, 'DNA helicase', 76, NULL, NULL, 83672),
(83673, '2.130.10.10-FF-001677', NULL, 'WD repeat-containing protein 16, putative', 186, NULL, NULL, 83673),
(83674, '1.10.8.10-FF-000352', NULL, 'Uncharacterized protein C06E1.9', 42, NULL, NULL, 83674),
(83675, '3.30.450.200-FF-000019', NULL, NULL, 217, NULL, NULL, 83675),
(83676, '3.10.110.10-FF-000354', NULL, 'Uncharacterized protein', 83, NULL, NULL, 83676),
(83677, '2.60.120.920-FF-000211', NULL, 'Uncharacterized protein', 155, NULL, NULL, 83677),
(83678, '3.30.200.20-FF-000292', NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM1', 109, NULL, NULL, 83678),
(83679, '1.10.510.10-FF-000448', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 226, NULL, NULL, 83679),
(83680, '1.10.150.240-FF-000071', NULL, 'Uncharacterized protein, isoform B', 68, NULL, NULL, 83680),
(83681, '2.30.29.30-FF-001028', NULL, 'Uncharacterized protein', 124, NULL, NULL, 83681),
(83682, '1.20.58.670-FF-000006', NULL, 'RINT1-like protein MAG2', 125, NULL, NULL, 83682),
(83683, '2.130.10.10-FF-000749', NULL, 'Nucleoporin 43', 81, NULL, NULL, 83683),
(83684, '3.40.50.300-FF-001952', NULL, 'ATP-dependent RNA helicase RHLE', 167, NULL, NULL, 83684),
(83685, '3.40.50.720-FF-000061', NULL, 'Formate dehydrogenase', 159, NULL, NULL, 83685),
(83686, '3.40.50.300-FF-004414', NULL, 'Nonstructural protein', 182, NULL, NULL, 83686),
(83687, '1.50.10.10-FF-000244', NULL, 'Uncharacterized protein', 149, NULL, NULL, 83687),
(83688, '1.10.238.10-FF-000348', NULL, 'EF hand family protein', 139, NULL, NULL, 83688),
(83689, '3.20.20.80-FF-000588', NULL, 'Uncharacterized protein', 233, NULL, NULL, 83689),
(83690, '3.50.50.60-FF-001504', NULL, 'Lysine (K)-specific demethylase 1a', 26, NULL, NULL, 83690),
(83691, '1.20.1070.10-FF-001265', NULL, 'Pepsin-like aspartic protease A1', 249, NULL, NULL, 83691),
(83692, '3.40.1010.10-FF-000007', NULL, 'Ribosomal RNA small subunit methyltransferase I', 115, NULL, NULL, 83692),
(83693, '1.10.8.20-FF-000001', NULL, 'Alpha-tocopherol transfer protein-like', 79, NULL, NULL, 83693),
(83694, '2.40.160.210-FF-000011', NULL, 'Acyl-CoA thioesterase', 325, NULL, NULL, 83694),
(83695, '2.60.120.200-FF-000496', NULL, 'Uncharacterized protein', 190, NULL, NULL, 83695),
(83696, '1.25.10.10-FF-001825', NULL, 'Predicted protein', 407, NULL, NULL, 83696),
(83697, '3.30.710.10-FF-000013', NULL, 'BTB/POZ domain-containing adapter for CUL3-mediated RhoA degradation protein 3', 110, NULL, NULL, 83697),
(83698, '3.40.50.720-FF-001342', NULL, '3-ketoacyl-ACP reductase', 242, NULL, NULL, 83698),
(83699, '1.20.58.60-FF-000011', NULL, 'Spectrin beta chain', 76, NULL, NULL, 83699),
(83700, '3.30.1370.50-FF-000031', NULL, 'Uncharacterized protein', 78, NULL, NULL, 83700),
(83701, '1.10.10.10-FF-002073', NULL, 'Transcriptional regulator MexT', 56, NULL, NULL, 83701),
(83702, '3.20.20.140-FF-000453', NULL, 'Predicted protein', 252, NULL, NULL, 83702),
(83703, '2.60.40.2860-FF-000006', NULL, '6-cysteine protein', 133, NULL, NULL, 83703),
(83704, '3.90.70.10-FF-000404', NULL, 'Ubiquitinyl hydrolase 1', 238, NULL, NULL, 83704),
(83705, '2.60.120.10-FF-000105', NULL, 'CAMKK/CAMKK-META protein kinase', 149, NULL, NULL, 83705),
(83706, '3.30.505.10-FF-000227', NULL, NULL, 94, NULL, NULL, 83706),
(83707, '3.30.60.290-FF-000003', NULL, 'DNA repair protein RAD4', 49, NULL, NULL, 83707),
(83708, '1.25.40.10-FF-000372', NULL, 'Tetratricopeptide repeat domain 26', 244, NULL, NULL, 83708),
(83709, '3.40.50.720-FF-002270', NULL, 'Uncharacterized protein', 39, NULL, NULL, 83709),
(83710, '3.40.50.1820-FF-000794', NULL, 'Putative hydrolase', 212, NULL, NULL, 83710);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(83711, '3.90.1150.10-FF-000141', NULL, 'Kynurenine--oxoglutarate transaminase 1', 164, NULL, NULL, 83711),
(83712, '3.40.50.360-FF-000110', NULL, 'NAD(P)H dehydrogenase (Quinone) FQR1', 136, NULL, NULL, 83712),
(83713, '1.25.40.20-FF-000021', NULL, 'Poly [ADP-ribose] polymerase', 154, NULL, NULL, 83713),
(83714, '2.20.25.10-FF-000030', NULL, 'DNA-directed RNA polymerase II subunit RPB9', 66, NULL, NULL, 83714),
(83715, '1.10.418.10-FF-000205', NULL, 'Uncharacterized protein', 125, NULL, NULL, 83715),
(83716, '1.10.287.1490-FF-000069', NULL, 'Hypothetical_protein_-_conserved', 177, NULL, NULL, 83716),
(83717, '3.30.420.40-FF-000634', NULL, 'Putative heat shock 70 kDa protein 14', 92, NULL, NULL, 83717),
(83718, '2.10.25.10-FF-000227', NULL, 'Matrilin 4', 40, NULL, NULL, 83718),
(83719, '1.10.418.10-FF-000093', NULL, 'GAS2-like protein 1', 177, NULL, NULL, 83719),
(83720, '3.40.630.10-FF-000459', NULL, 'Predicted protein', 138, NULL, NULL, 83720),
(83721, '1.10.10.750-FF-000048', NULL, 'Ecotropic viral integration site 5-like', 27, NULL, NULL, 83721),
(83722, '1.10.3210.10-FF-000115', NULL, 'AGAP012646-PA', 103, NULL, NULL, 83722),
(83723, '3.40.50.300-FF-006623', NULL, 'Uncharacterized protein, isoform G', 93, NULL, NULL, 83723),
(83724, '1.10.533.10-FF-000017', NULL, 'caspase-8 isoform X1', 97, NULL, NULL, 83724),
(83725, '1.10.472.10-FF-000347', NULL, 'Os02g0800500 protein', 21, NULL, NULL, 83725),
(83726, '3.90.190.20-FF-000074', NULL, 'Folylpolyglutamate synthase', 139, NULL, NULL, 83726),
(83727, '1.10.287.70-FF-000507', NULL, 'Uncharacterized protein', 84, NULL, NULL, 83727),
(83728, '3.40.50.300-FF-001391', NULL, 'ATP-dependent DNA helicase', 224, NULL, NULL, 83728),
(83729, '3.30.470.30-FF-000016', NULL, 'DNA ligase', 207, NULL, NULL, 83729),
(83730, '2.40.50.140-FF-001094', NULL, NULL, 159, NULL, NULL, 83730),
(83731, '1.10.1420.10-FF-000041', NULL, 'Msh2p', 195, NULL, NULL, 83731),
(83732, '3.90.190.10-FF-000537', NULL, 'Uncharacterized protein', 173, NULL, NULL, 83732),
(83733, '3.40.50.150-FF-000396', NULL, 'tRNA (guanine-N(7)-)-methyltransferase', 216, NULL, NULL, 83733),
(83734, '1.20.272.10-FF-000049', NULL, 'Replication factor C subunit 1', 107, NULL, NULL, 83734),
(83735, '2.60.40.10-FF-004279', NULL, NULL, 110, NULL, NULL, 83735),
(83736, '3.40.50.300-FF-006770', NULL, 'Exopolysaccharide biosynthesis domain protein', 275, NULL, NULL, 83736),
(83737, '2.40.50.1000-FF-000010', NULL, 'Uncharacterized protein', 143, NULL, NULL, 83737),
(83738, '3.20.20.140-FF-000306', NULL, 'Sodium/hydrogen exchanger 2', 111, NULL, NULL, 83738),
(83739, '2.60.40.60-FF-000062', NULL, 'Calsyntenin 3', 119, NULL, NULL, 83739),
(83740, '1.10.630.10-FF-000367', NULL, 'Uncharacterized protein', 448, NULL, NULL, 83740),
(83741, '1.25.40.10-FF-005043', NULL, 'Putative pentatricopeptide repeat-containing protein mitochondrial', 124, NULL, NULL, 83741),
(83742, '2.60.40.10-FF-001553', NULL, 'Fas apoptotic inhibitory molecule 3', 103, NULL, NULL, 83742),
(83743, '3.60.130.10-FF-000068', NULL, 'Uncharacterized protein', 193, NULL, NULL, 83743),
(83744, '3.40.630.170-FF-000004', NULL, 'Glycylpeptide N-tetradecanoyltransferase', 411, NULL, NULL, 83744),
(83745, '3.30.160.60-FF-002166', NULL, 'Histone H4 transcription factor', 24, NULL, NULL, 83745),
(83746, '2.60.40.10-FF-004987', NULL, NULL, 108, NULL, NULL, 83746),
(83747, '2.60.40.60-FF-000438', NULL, 'Dachsous, isoform B', 106, NULL, NULL, 83747),
(83748, '3.40.50.1010-FF-000113', NULL, 'DNA repair protein RAD2, putative', 93, NULL, NULL, 83748),
(83749, '3.40.30.10-FF-000511', NULL, 'Protein disulfide-isomerase', 114, NULL, NULL, 83749),
(83750, '2.60.40.2300-FF-000007', NULL, 'Neutral ceramidase B', 132, NULL, NULL, 83750),
(83751, '3.40.50.150-FF-000249', NULL, 'tRNA (Cytosine-5-)-methyltransferase, putative', 348, NULL, NULL, 83751),
(83752, '1.25.10.10-FF-002192', NULL, 'Uncharacterized protein', 449, NULL, NULL, 83752),
(83753, '2.130.10.10-FF-005572', NULL, 'Intraflagellar transport 140 homolog (Chlamydomonas)', 210, NULL, NULL, 83753),
(83754, '1.20.144.10-FF-000027', NULL, 'Inositol phosphorylceramide synthase', 85, NULL, NULL, 83754);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(83755, '3.30.710.10-FF-000277', NULL, 'Hypothetical_protein_-_conserved', 103, NULL, NULL, 83755),
(83756, '1.10.238.10-FF-000495', NULL, 'Protein CBR-CEX-1', 180, NULL, NULL, 83756),
(83757, '2.60.120.590-FF-000067', NULL, 'Os03g0816500 protein', 148, NULL, NULL, 83757),
(83758, '2.40.70.10-FF-000555', NULL, NULL, 215, NULL, NULL, 83758),
(83759, '3.30.160.20-FF-000057', NULL, 'Double-stranded RNA-binding protein Staufen homolog 2', 88, NULL, NULL, 83759),
(83760, '3.30.40.10-FF-001670', NULL, 'E3 ubiquitin-protein ligase PRT1', 127, NULL, NULL, 83760),
(83761, '3.30.160.60-FF-004375', NULL, NULL, 63, NULL, NULL, 83761),
(83762, '4.10.400.10-FF-000327', NULL, 'Uncharacterized protein', 40, NULL, NULL, 83762),
(83763, '1.10.510.10-FF-004343', NULL, NULL, 127, NULL, NULL, 83763),
(83764, '3.40.395.10-FF-000035', NULL, 'Putative ankyrin repeat domain family protein', 211, NULL, NULL, 83764),
(83765, '3.40.140.10-FF-000231', NULL, 'Predicted protein', 167, NULL, NULL, 83765),
(83766, '1.20.1510.10-FF-000001', NULL, 'Ferrous-iron efflux pump FieF', 197, NULL, NULL, 83766),
(83767, '2.30.230.10-FF-000002', NULL, 'Vitellogenin 7', 263, NULL, NULL, 83767),
(83768, '2.30.310.10-FF-000003', NULL, 'Zinc knuckle domain containing protein', 153, NULL, NULL, 83768),
(83769, '3.40.1410.10-FF-000032', NULL, 'GntR family transcriptional regulator', 167, NULL, NULL, 83769),
(83770, '1.25.40.20-FF-000285', NULL, 'Uncharacterized protein, isoform B', 216, NULL, NULL, 83770),
(83771, '2.30.29.30-FF-000960', NULL, 'Drosophila SOS homolog', 111, NULL, NULL, 83771),
(83772, '3.30.40.10-FF-002070', NULL, 'Uncharacterized protein', 88, NULL, NULL, 83772),
(83773, '2.60.40.150-FF-000680', NULL, 'Protein kinase C', 40, NULL, NULL, 83773),
(83774, '3.40.190.10-FF-000234', NULL, 'ABC transporter substrate-binding protein', 186, NULL, NULL, 83774),
(83775, '2.60.200.20-FF-000204', NULL, 'Serine/threonine protein kinase-43', 117, NULL, NULL, 83775),
(83776, '3.30.420.40-FF-000073', NULL, 'Rhamnulokinase', 253, NULL, NULL, 83776),
(83777, '3.30.1510.10-FF-000014', NULL, 'Formate-dihydrofolate ligase', 104, NULL, NULL, 83777),
(83778, '3.40.605.10-FF-000007', NULL, 'NAD/NADP-dependent betaine aldehyde dehydrogenase', 273, NULL, NULL, 83778),
(83779, '3.30.160.60-FF-006061', NULL, NULL, 74, NULL, NULL, 83779),
(83780, '3.40.30.10-FF-001028', NULL, 'Uncharacterized protein', 50, NULL, NULL, 83780),
(83781, '1.10.1200.270-FF-000017', NULL, 'Os06g0243801 protein', 19, NULL, NULL, 83781),
(83782, '3.40.1380.10-FF-000034', NULL, 'Uncharacterized protein', 86, NULL, NULL, 83782),
(83783, '3.40.50.300-FF-006062', NULL, 'Predicted protein', 267, NULL, NULL, 83783),
(83784, '3.30.230.10-FF-000167', NULL, 'Galactokinase family protein', 189, NULL, NULL, 83784),
(83785, '2.60.270.20-FF-000001', NULL, 'DELTA-actitoxin-Afr1a', 176, NULL, NULL, 83785),
(83786, '3.40.50.150-FF-001121', NULL, NULL, 186, NULL, NULL, 83786),
(83787, '3.10.20.90-FF-000822', NULL, 'Uncharacterized protein', 109, NULL, NULL, 83787),
(83788, '1.10.510.10-FF-002134', NULL, 'Tyrosine-protein kinase', 253, NULL, NULL, 83788),
(83789, '2.40.10.10-FF-000023', NULL, 'Hepatocyte growth factor', 115, NULL, NULL, 83789),
(83790, '1.20.58.1120-FF-000005', NULL, 'Dynein, axonemal, heavy chain 12', 139, NULL, NULL, 83790),
(83791, '3.90.550.50-FF-000156', NULL, 'Uncharacterized protein', 229, NULL, NULL, 83791),
(83792, '1.25.40.10-FF-004138', NULL, 'Uncharacterized protein', 116, NULL, NULL, 83792),
(83793, '3.30.1490.180-FF-000019', NULL, 'DNA-directed RNA polymerase subunit', 52, NULL, NULL, 83793),
(83794, '3.60.10.10-FF-000054', NULL, 'Exodeoxyribonuclease III', 263, NULL, NULL, 83794),
(83795, '3.40.50.12780-FF-000164', NULL, 'Long-chain fatty acid transport protein 1', 77, NULL, NULL, 83795),
(83796, '3.30.420.610-FF-000007', NULL, 'Tudor domain-containing protein 5', 77, NULL, NULL, 83796),
(83797, '1.10.630.10-FF-000636', NULL, 'Uncharacterized protein', 224, NULL, NULL, 83797),
(83798, '2.110.10.10-FF-000031', NULL, 'matrix metalloproteinase-21-like', 99, NULL, NULL, 83798);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(83799, '2.60.40.10-FF-000480', NULL, 'Collagen, type XII, alpha 1', 92, NULL, NULL, 83799),
(83800, '3.40.50.300-FF-001508', NULL, 'Small GTP-binding protein Rab28, putative', 208, NULL, NULL, 83800),
(83801, '1.10.10.60-FF-000154', NULL, 'Transcription factor SRM1', 68, NULL, NULL, 83801),
(83802, '1.10.287.70-FF-000682', NULL, 'Hypothetical membrane protein, conserved', 87, NULL, NULL, 83802),
(83803, '3.90.1170.30-FF-000007', NULL, 'Thymidine phosphorylase', 87, NULL, NULL, 83803),
(83804, '1.10.10.60-FF-000210', NULL, 'homeobox protein goosecoid', 93, NULL, NULL, 83804),
(83805, '3.30.160.60-FF-002727', NULL, 'Unplaced genomic scaffold supercont1.56, whole genome shotgun sequence', 43, NULL, NULL, 83805),
(83806, '1.10.418.10-FF-000177', NULL, 'Predicted protein', 110, NULL, NULL, 83806),
(83807, '1.20.58.60-FF-000308', NULL, 'microtubule-actin cross-linking factor 1 isoform X6', 117, NULL, NULL, 83807),
(83808, '3.90.180.10-FF-000183', NULL, 'Protein CBG23238', 72, NULL, NULL, 83808),
(83809, '3.30.70.330-FF-000916', NULL, 'Rna15p', 99, NULL, NULL, 83809),
(83810, '3.40.50.720-FF-002062', NULL, '3beta-hydroxysteroid-dehydrogenase/decarboxylase isoform 2', 159, NULL, NULL, 83810),
(83811, '2.130.10.10-FF-004403', NULL, 'Uncharacterized protein', 43, NULL, NULL, 83811),
(83812, '4.10.640.40-FF-000005', NULL, 'Cytoplasmic polyadenylation element-binding protein 1', 27, NULL, NULL, 83812),
(83813, '3.10.110.10-FF-000090', NULL, 'Ubiquitin-conjugating enzyme E2-17 kDa', 153, NULL, NULL, 83813),
(83814, '1.10.287.70-FF-000187', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 127, NULL, NULL, 83814),
(83815, '1.20.58.60-FF-000836', NULL, 'Uncharacterized protein', 156, NULL, NULL, 83815),
(83816, '1.25.10.10-FF-003006', NULL, 'Uncharacterized protein', 342, NULL, NULL, 83816),
(83817, '2.40.70.10-FF-000471', NULL, NULL, 162, NULL, NULL, 83817),
(83818, '1.25.10.10-FF-002545', NULL, 'Uncharacterized protein', 180, NULL, NULL, 83818),
(83819, '3.30.160.60-FF-004291', NULL, NULL, 59, NULL, NULL, 83819),
(83820, '3.80.10.10-FF-002661', NULL, 'Receptor-like protein kinase HSL1', 256, NULL, NULL, 83820),
(83821, '3.40.50.300-FF-007343', NULL, 'Uncharacterized protein', 139, NULL, NULL, 83821),
(83822, '2.10.70.10-FF-000303', NULL, 'Uncharacterized protein', 37, NULL, NULL, 83822),
(83823, '1.10.238.10-FF-000612', NULL, 'Sodium/calcium exchanger NCL', 81, NULL, NULL, 83823),
(83824, '2.60.40.10-FF-000041', NULL, 'ephrin type-A receptor 3', 110, NULL, NULL, 83824),
(83825, '1.25.10.10-FF-002017', NULL, 'Armadillo repeat-containing 4', 149, NULL, NULL, 83825),
(83826, '3.30.40.10-FF-001018', NULL, 'RBR-type E3 ubiquitin transferase', 83, NULL, NULL, 83826),
(83827, '1.25.40.10-FF-003626', NULL, 'Pentatricopeptide repeat-containing protein At1g63130, mitochondrial', 72, NULL, NULL, 83827),
(83828, '2.60.40.10-FF-004695', NULL, NULL, 56, NULL, NULL, 83828),
(83829, '2.60.40.60-FF-001051', NULL, 'Uncharacterized protein', 82, NULL, NULL, 83829),
(83830, '1.20.1250.20-FF-000528', NULL, 'Solute carrier organic anion transporter family member', 355, NULL, NULL, 83830),
(83831, '3.40.50.2000-FF-000539', NULL, 'Uncharacterized protein', 168, NULL, NULL, 83831),
(83832, '3.30.200.20-FF-001281', NULL, NULL, 55, NULL, NULL, 83832),
(83833, '2.60.40.150-FF-000533', NULL, 'Protein unc-13 homolog 4B', 149, NULL, NULL, 83833),
(83834, '3.80.10.10-FF-003173', NULL, 'LD20162p', 267, NULL, NULL, 83834),
(83835, '3.40.50.150-FF-001593', NULL, NULL, 274, NULL, NULL, 83835),
(83836, '3.30.40.10-FF-000506', NULL, 'Acyl-CoA N-acyltransferase with RING/FYVE/PHD-type zinc finger domain', 63, NULL, NULL, 83836),
(83837, '3.30.450.20-FF-000012', NULL, 'Calcium channel, voltage-dependent, alpha2/delta subunit 3', 146, NULL, NULL, 83837),
(83838, '3.40.1810.10-FF-000017', NULL, 'PISTILLATA-like MADS-box transcription factor', 64, NULL, NULL, 83838),
(83839, '1.10.3370.10-FF-000008', NULL, 'Preprotein translocase subunit SCY2, chloroplastic', 427, NULL, NULL, 83839),
(83840, '2.60.120.380-FF-000061', NULL, 'Uncharacterized protein', 145, NULL, NULL, 83840);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(83841, '3.30.1490.100-FF-000013', NULL, 'DNApol-iota, isoform A', 125, NULL, NULL, 83841),
(83842, '2.130.10.10-FF-000660', NULL, 'U3 snoRNP protein', 329, NULL, NULL, 83842),
(83843, '3.30.9.10-FF-000176', NULL, 'L-2-hydroxyglutarate dehydrogenase, mitochondrial', 158, NULL, NULL, 83843),
(83844, '2.130.10.10-FF-002582', NULL, 'Predicted protein', 80, NULL, NULL, 83844),
(83845, '1.20.1250.20-FF-001192', NULL, 'Putative integral membrane protein', 192, NULL, NULL, 83845),
(83846, '2.40.30.10-FF-000081', NULL, 'Oxidoreductase with FAD/NAD(P)-binding domain', 91, NULL, NULL, 83846),
(83847, '3.40.50.880-FF-000204', NULL, 'Isonitrile hydratase', 228, NULL, NULL, 83847),
(83848, '3.30.70.330-FF-001052', NULL, 'Ribonucleoprotein 1', 105, NULL, NULL, 83848),
(83849, '1.10.533.10-FF-000309', NULL, 'Uncharacterized protein', 56, NULL, NULL, 83849),
(83850, '1.10.10.10-FF-000572', NULL, 'Transcriptional regulator, Crp/Fnr family', 89, NULL, NULL, 83850),
(83851, '3.40.50.12550-FF-000005', NULL, 'Putative ubiquitin-activating enzyme e1', 209, NULL, NULL, 83851),
(83852, '3.30.450.40-FF-000018', NULL, 'Phosphodiesterase', 176, NULL, NULL, 83852),
(83853, '1.20.1560.10-FF-000009', NULL, 'ABC transporter B family member 1', 310, NULL, NULL, 83853),
(83854, '1.10.1170.10-FF-000004', NULL, 'Baculoviral IAP repeat-containing protein 2', 132, NULL, NULL, 83854),
(83855, '3.30.70.270-FF-000084', NULL, 'REV1, polymerase (DNA directed)', 67, NULL, NULL, 83855),
(83856, '3.40.50.1440-FF-000068', NULL, 'Tubulin gamma-2 chain', 99, NULL, NULL, 83856),
(83857, '1.10.510.10-FF-001145', NULL, 'Protein kinase KNS1', 85, NULL, NULL, 83857),
(83858, '3.40.50.300-FF-004061', NULL, 'Probable ATP-dependent RNA helicase spindle-E', 183, NULL, NULL, 83858),
(83859, '3.40.50.1240-FF-000013', NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', 288, NULL, NULL, 83859),
(83860, '3.10.129.10-FF-000200', NULL, 'Thioesterase', 140, NULL, NULL, 83860),
(83861, '1.20.58.1470-FF-000003', NULL, 'Fat mass and obesity-associated', 83, NULL, NULL, 83861),
(83862, '3.30.70.2280-FF-000002', NULL, 'Nucleolar RNA helicase 2', 78, NULL, NULL, 83862),
(83863, '2.60.40.2030-FF-000022', NULL, 'Adhesion G-protein coupled receptor V1', 126, NULL, NULL, 83863),
(83864, '3.90.1170.10-FF-000001', NULL, '50S ribosomal protein L16', 138, NULL, NULL, 83864),
(83865, '1.20.58.1880-FF-000036', NULL, 'Uncharacterized protein', 116, NULL, NULL, 83865),
(83866, '2.70.170.10-FF-000179', NULL, 'Uncharacterized protein', 97, NULL, NULL, 83866),
(83867, '1.10.10.10-FF-000095', NULL, 'GntR family transcriptional regulator', 66, NULL, NULL, 83867),
(83868, '3.30.70.330-FF-001905', NULL, NULL, 75, NULL, NULL, 83868),
(83869, '1.25.10.10-FF-002489', NULL, 'Predicted protein', 207, NULL, NULL, 83869),
(83870, '2.130.10.10-FF-004875', NULL, 'Uncharacterized protein', 120, NULL, NULL, 83870),
(83871, '1.10.510.10-FF-004074', NULL, NULL, 172, NULL, NULL, 83871),
(83872, '2.60.120.260-FF-000171', NULL, 'Beta-galactosidase 3', 181, NULL, NULL, 83872),
(83873, '3.30.70.1230-FF-000249', NULL, 'Guanylate cyclase', 203, NULL, NULL, 83873),
(83874, '1.10.630.10-FF-000159', NULL, 'Isotrichodermin C-15 hydroxylase', 323, NULL, NULL, 83874),
(83875, '3.30.200.20-FF-001129', NULL, 'Cell division control protein 2 like', 72, NULL, NULL, 83875),
(83876, '2.40.50.140-FF-000874', NULL, NULL, 91, NULL, NULL, 83876),
(83877, '2.60.120.10-FF-000369', NULL, 'Crp/Fnr family transcriptional regulator', 132, NULL, NULL, 83877),
(83878, '2.10.110.10-FF-000037', NULL, 'LIM domain-containing protein 1', 76, NULL, NULL, 83878),
(83879, '3.10.50.40-FF-000152', NULL, 'Peptidylprolyl isomerase', 100, NULL, NULL, 83879),
(83880, '3.40.50.1820-FF-001250', NULL, 'Uncharacterized protein', 315, NULL, NULL, 83880),
(83881, '3.80.10.10-FF-000300', NULL, 'Relaxin family peptide receptor 2', 132, NULL, NULL, 83881),
(83882, '3.40.50.300-FF-000199', NULL, 'Origin recognition complex subunit 1', 195, NULL, NULL, 83882),
(83883, '3.30.530.20-FF-000013', NULL, 'Abscisic acid receptor PYL9', 181, NULL, NULL, 83883);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(83884, '2.60.40.10-FF-004751', NULL, NULL, 106, NULL, NULL, 83884),
(83885, '3.40.50.300-FF-008276', NULL, 'RuvB-like helicase', 38, NULL, NULL, 83885),
(83886, '4.10.240.10-FF-000056', NULL, 'Transcription factor PDR1', 63, NULL, NULL, 83886),
(83887, '2.60.200.10-FF-000050', NULL, 'Uncharacterized protein', 157, NULL, NULL, 83887),
(83888, '3.40.50.1260-FF-000019', NULL, 'Phosphoglycerate kinase 1', 186, NULL, NULL, 83888),
(83889, '1.10.472.80-FF-000031', NULL, 'TBC1 domain family, member 32', 119, NULL, NULL, 83889),
(83890, '1.10.246.20-FF-000016', NULL, 'Uncharacterized protein', 44, NULL, NULL, 83890),
(83891, '3.30.780.10-FF-000051', NULL, 'Uncharacterized protein', 107, NULL, NULL, 83891),
(83892, '3.30.160.60-FF-000013', NULL, 'Putative zinc finger E-box-binding homeobox 2', 27, NULL, NULL, 83892),
(83893, '3.40.640.10-FF-000488', NULL, 'Uncharacterized protein', 47, NULL, NULL, 83893),
(83894, '2.10.110.10-FF-000161', NULL, 'MIT domain containing protein', 76, NULL, NULL, 83894),
(83895, '3.90.70.10-FF-000551', NULL, 'Cysteine protease 1', 160, NULL, NULL, 83895),
(83896, '1.25.70.10-FF-000048', NULL, 'Os11g0206300 protein', 148, NULL, NULL, 83896),
(83897, '3.40.190.80-FF-000035', NULL, 'Inositol monophosphatase', 121, NULL, NULL, 83897),
(83898, '3.30.1740.10-FF-000031', NULL, 'Uncharacterized protein', 99, NULL, NULL, 83898),
(83899, '3.30.2310.10-FF-000004', NULL, 'Nef-associated protein 1', 96, NULL, NULL, 83899),
(83900, '1.25.40.90-FF-000053', NULL, 'CTD kinase subunit gamma, variant', 139, NULL, NULL, 83900),
(83901, '1.25.40.10-FF-003362', NULL, 'Putative pentatricopeptide repeat-containing protein At3g16890, mitochondrial', 69, NULL, NULL, 83901),
(83902, '2.40.330.10-FF-000013', NULL, NULL, 122, NULL, NULL, 83902),
(83903, '2.30.180.10-FF-000065', NULL, 'Transforming growth factor-beta-induced protein Ig-H3', 138, NULL, NULL, 83903),
(83904, '3.40.50.300-FF-005398', NULL, 'Predicted protein', 218, NULL, NULL, 83904),
(83905, '3.40.50.1820-FF-000558', NULL, 'Monoglyceride lipase, putative', 272, NULL, NULL, 83905),
(83906, '3.80.10.10-FF-000772', NULL, 'Extracellular matrix protein 2', 97, NULL, NULL, 83906),
(83907, '3.40.50.300-FF-004853', NULL, 'Uncharacterized protein', 181, NULL, NULL, 83907),
(83908, '1.10.30.10-FF-000039', NULL, 'protein CRABS CLAW isoform X3', 60, NULL, NULL, 83908),
(83909, '3.30.505.10-FF-000204', NULL, NULL, 96, NULL, NULL, 83909),
(83910, '2.70.160.11-FF-000067', NULL, 'Protein arginine N-methyltransferase 7', 183, NULL, NULL, 83910),
(83911, '2.130.10.10-FF-000221', NULL, 'gem-associated protein 5 isoform X1', 369, NULL, NULL, 83911),
(83912, '2.10.220.10-FF-000219', NULL, 'Furin2, putative', 43, NULL, NULL, 83912),
(83913, '2.20.28.60-FF-000001', NULL, 'Citrate synthase', 49, NULL, NULL, 83913),
(83914, '2.60.40.10-FF-001289', NULL, 'Oncostatin-M-specific receptor subunit beta', 87, NULL, NULL, 83914),
(83915, '1.10.10.10-FF-001437', NULL, 'ATP-dependent DNA helicase RecQ', 123, NULL, NULL, 83915),
(83916, '1.10.418.20-FF-000034', NULL, 'Predicted protein', 23, NULL, NULL, 83916),
(83917, '1.10.510.10-FF-003438', NULL, NULL, 283, NULL, NULL, 83917),
(83918, '1.10.287.2250-FF-000011', NULL, 'Papain family cysteine protease subfamily protein', 75, NULL, NULL, 83918),
(83919, '3.30.160.60-FF-006145', NULL, NULL, 43, NULL, NULL, 83919),
(83920, '1.25.40.10-FF-004290', NULL, 'Uncharacterized protein', 201, NULL, NULL, 83920),
(83921, '2.40.50.140-FF-000930', NULL, NULL, 94, NULL, NULL, 83921),
(83922, '3.30.460.80-FF-000008', NULL, 'NADH:ubiquinone oxidoreductase ND9 subunit', 163, NULL, NULL, 83922),
(83923, '1.10.510.10-FF-002926', NULL, NULL, 94, NULL, NULL, 83923),
(83924, '3.40.190.10-FF-000711', NULL, 'ABC transporter, periplasmic substrate-binding protein', 103, NULL, NULL, 83924),
(83925, '1.20.140.10-FF-000086', NULL, 'Acyl CoA DeHydrogenase', 53, NULL, NULL, 83925),
(83926, '3.30.830.10-FF-000224', NULL, 'Pitrilysin metallepetidase 1 (Predicted)', 112, NULL, NULL, 83926),
(83927, '2.70.70.10-FF-000048', NULL, 'PTS system, IIa component', 158, NULL, NULL, 83927);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(83928, '2.60.40.790-FF-000202', NULL, NULL, 55, NULL, NULL, 83928),
(83929, '4.10.60.10-FF-000220', NULL, 'Uncharacterized protein', 23, NULL, NULL, 83929),
(83930, '3.90.79.10-FF-000132', NULL, 'DNA mismatch repair protein MutT', 125, NULL, NULL, 83930),
(83931, '2.70.170.10-FF-000235', NULL, 'Uncharacterized protein', 75, NULL, NULL, 83931),
(83932, '3.40.720.10-FF-000174', NULL, 'Uncharacterized protein', 115, NULL, NULL, 83932),
(83933, '3.30.300.90-FF-000005', NULL, 'BolA family transcriptional regulator', 78, NULL, NULL, 83933),
(83934, '3.30.70.330-FF-001849', NULL, NULL, 113, NULL, NULL, 83934),
(83935, '2.60.34.10-FF-000004', NULL, 'Heat shock protein SSB1', 132, NULL, NULL, 83935),
(83936, '3.40.250.10-FF-000149', NULL, 'MBL fold metallo-hydrolase', 100, NULL, NULL, 83936),
(83937, '1.10.287.1480-FF-000004', NULL, 'Ribosomal protein S14, putative', 90, NULL, NULL, 83937),
(83938, '3.40.30.10-FF-000275', NULL, 'Protein disulfide-isomerase, putative', 135, NULL, NULL, 83938),
(83939, '3.30.70.240-FF-000013', NULL, 'Translation elongation factor G', 92, NULL, NULL, 83939),
(83940, '1.10.150.420-FF-000001', NULL, 'Replicase polyprotein', 93, NULL, NULL, 83940),
(83941, '3.30.1370.10-FF-000103', NULL, 'Pbp2p', 73, NULL, NULL, 83941),
(83942, '3.30.1360.10-FF-000041', NULL, 'Uncharacterized protein', 116, NULL, NULL, 83942),
(83943, '1.25.40.270-FF-000001', NULL, 'vacuolar protein sorting-associated protein VTA1 homolog', 162, NULL, NULL, 83943),
(83944, '3.30.30.30-FF-000074', NULL, 'Uncharacterized protein', 40, NULL, NULL, 83944),
(83945, '3.40.50.300-FF-002172', NULL, 'Primosomal protein N''', 149, NULL, NULL, 83945),
(83946, '3.20.20.80-FF-000408', NULL, 'Alpha-L-fucosidase, putative', 37, NULL, NULL, 83946),
(83947, '3.30.70.330-FF-000124', NULL, 'RNA-binding protein 26 isoform X3', 66, NULL, NULL, 83947),
(83948, '3.30.2410.10-FF-000040', NULL, 'Ubiquitin protein ligase E3 component n-recognin 5', 88, NULL, NULL, 83948),
(83949, '3.30.200.20-FF-001657', NULL, 'RE65159p', 86, NULL, NULL, 83949),
(83950, '1.10.510.10-FF-001201', NULL, 'Serine/threonine protein kinase', 174, NULL, NULL, 83950),
(83951, '3.30.497.10-FF-000162', NULL, 'Serpin, putative', 52, NULL, NULL, 83951),
(83952, '1.25.40.20-FF-001538', NULL, 'Uncharacterized protein', 130, NULL, NULL, 83952),
(83953, '2.130.10.10-FF-003094', NULL, 'Os02g0539900 protein', 60, NULL, NULL, 83953),
(83954, '3.30.200.20-FF-002057', NULL, 'Uncharacterized protein', 87, NULL, NULL, 83954),
(83955, '1.20.1560.10-FF-000537', NULL, 'ABC transporter, multidrug resistance associated protein', 339, NULL, NULL, 83955),
(83956, '3.90.190.10-FF-000481', NULL, 'Uncharacterized protein', 169, NULL, NULL, 83956),
(83957, '3.90.950.10-FF-000040', NULL, 'Ham1 family pyrophosphatase, putative', 147, NULL, NULL, 83957),
(83958, '1.10.238.10-FF-000079', NULL, 'Calcium and integrin-binding family member 2', 182, NULL, NULL, 83958),
(83959, '3.30.40.10-FF-000978', NULL, 'Ring-box 1, E3 ubiquitin protein ligase', 73, NULL, NULL, 83959),
(83960, '3.30.160.380-FF-000007', NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', 119, NULL, NULL, 83960),
(83961, '1.10.10.10-FF-001876', NULL, 'SPO11, initiator of meiotic double stranded breaks', 53, NULL, NULL, 83961),
(83962, '2.30.30.40-FF-000085', NULL, 'E3 ubiquitin-protein ligase HECTD1 isoform X1', 88, NULL, NULL, 83962),
(83963, '3.40.50.2300-FF-001152', NULL, NULL, 41, NULL, NULL, 83963),
(83964, '3.30.70.330-FF-002833', NULL, NULL, 87, NULL, NULL, 83964),
(83965, '3.15.10.10-FF-000012', NULL, 'BPI fold containing family C, like', 177, NULL, NULL, 83965),
(83966, '3.90.930.12-FF-000029', NULL, NULL, 86, NULL, NULL, 83966),
(83967, '2.130.10.10-FF-002458', NULL, 'Uncharacterized protein', 244, NULL, NULL, 83967),
(83968, '3.80.10.10-FF-004459', NULL, 'Uncharacterized protein', 96, NULL, NULL, 83968),
(83969, '2.30.29.30-FF-000483', NULL, 'Ran-specific GTPase-activating protein 1', 143, NULL, NULL, 83969),
(83970, '3.30.40.210-FF-000009', NULL, 'Spt4/RpoE2 zinc finger containing protein, putative', 103, NULL, NULL, 83970);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(83971, '3.30.870.10-FF-000114', NULL, 'Phospholipase D A', 190, NULL, NULL, 83971),
(83972, '3.40.228.10-FF-000030', NULL, 'NADH-quinone oxidoreductase', 74, NULL, NULL, 83972),
(83973, '2.30.30.100-FF-000074', NULL, 'LSM2 homolog, U6 small nuclear RNA and mRNA degradation associated', 35, NULL, NULL, 83973),
(83974, '3.40.50.720-FF-001426', NULL, 'ActC', 263, NULL, NULL, 83974),
(83975, '3.30.160.360-FF-000001', NULL, 'Histone-lysine N-methyltransferase', 140, NULL, NULL, 83975),
(83976, '1.10.287.110-FF-000104', NULL, 'Membrane associated DnaJ chaperone, putative', 100, NULL, NULL, 83976),
(83977, '2.20.70.10-FF-000281', NULL, 'Predicted protein', 47, NULL, NULL, 83977),
(83978, '1.10.510.10-FF-003562', NULL, NULL, 223, NULL, NULL, 83978),
(83979, '3.90.1480.20-FF-000016', NULL, 'Sialyltransferase-like protein 3', 264, NULL, NULL, 83979),
(83980, '1.25.40.120-FF-000035', NULL, 'Geranylgeranyl transferase type-2 subunit alpha', 330, NULL, NULL, 83980),
(83981, '1.20.58.60-FF-000483', NULL, 'Spectrin repeat containing nuclear envelope protein 2', 269, NULL, NULL, 83981),
(83982, '3.90.70.10-FF-000079', NULL, 'Cathepsin O', 291, NULL, NULL, 83982),
(83983, '3.20.20.140-FF-000161', NULL, 'Amidohydrolase, imidazolonepropionase', 296, NULL, NULL, 83983),
(83984, '1.10.287.3550-FF-000002', NULL, 'Stromal interaction molecule homolog', 101, NULL, NULL, 83984),
(83985, '2.60.40.10-FF-002334', NULL, 'Kek6, isoform B', 99, NULL, NULL, 83985),
(83986, '3.40.30.10-FF-001231', NULL, 'Protein disulfide-isomerase-like Protein', 110, NULL, NULL, 83986),
(83987, '3.30.450.190-FF-000005', NULL, 'Gtr1 g domain containing protein', 143, NULL, NULL, 83987),
(83988, '3.30.920.10-FF-000023', NULL, 'Uncharacterized protein', 81, NULL, NULL, 83988),
(83989, '3.30.420.110-FF-000043', NULL, 'Putative DNA mismatch repair protein Msh4', 154, NULL, NULL, 83989),
(83990, '2.60.40.150-FF-000477', NULL, 'Uncharacterized protein', 126, NULL, NULL, 83990),
(83991, '1.25.40.480-FF-000002', NULL, 'Fanconi anemia, complementation group E', 264, NULL, NULL, 83991),
(83992, '3.20.20.210-FF-000030', NULL, 'Uncharacterized protein', 57, NULL, NULL, 83992),
(83993, '1.10.510.10-FF-000217', NULL, 'Wee1-like protein kinase', 199, NULL, NULL, 83993),
(83994, '1.25.40.10-FF-004262', NULL, 'TPR Domain containing protein', 367, NULL, NULL, 83994),
(83995, '3.20.20.70-FF-000175', NULL, '2-dehydro-3-deoxy-6-phosphogalactonate aldolase', 205, NULL, NULL, 83995),
(83996, '2.60.40.60-FF-000915', NULL, 'Uncharacterized protein', 100, NULL, NULL, 83996),
(83997, '3.20.20.80-FF-000032', NULL, '1,3-beta-glucanosyltransferase', 318, NULL, NULL, 83997),
(83998, '2.10.60.10-FF-000005', NULL, 'Receptor protein serine/threonine kinase', 79, NULL, NULL, 83998),
(83999, '3.90.132.10-FF-000015', NULL, 'Uncharacterized protein', 53, NULL, NULL, 83999),
(84000, '3.90.730.10-FF-000034', NULL, 'Ribonuclease t2, putative', 86, NULL, NULL, 84000),
(84001, '3.80.10.10-FF-001548', NULL, 'Si:ch211-213a13.2', 237, NULL, NULL, 84001),
(84002, '3.40.50.300-FF-002200', NULL, 'Type VII secretion protein EccC', 244, NULL, NULL, 84002),
(84003, '3.30.9.10-FF-000237', NULL, 'Predicted protein', 57, NULL, NULL, 84003),
(84004, '1.10.287.130-FF-000262', NULL, 'Histidine kinase sensor protein', 70, NULL, NULL, 84004),
(84005, '3.40.50.1460-FF-000107', NULL, 'GPI-anchor transamidase', 122, NULL, NULL, 84005),
(84006, '2.60.40.60-FF-000123', NULL, 'Protocadherin beta 4', 105, NULL, NULL, 84006),
(84007, '3.40.50.150-FF-000721', NULL, 'DNA methylase N-4/N-6 domain protein', 251, NULL, NULL, 84007),
(84008, '1.20.1300.10-FF-000047', NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', 124, NULL, NULL, 84008),
(84009, '2.30.42.10-FF-000002', NULL, 'Disks large homolog 4 isoform 2', 102, NULL, NULL, 84009),
(84010, '1.10.510.10-FF-000656', NULL, 'Uncharacterized protein, isoform C', 180, NULL, NULL, 84010),
(84011, '1.10.8.60-FF-000462', NULL, 'Uncharacterized protein', 44, NULL, NULL, 84011),
(84012, '3.30.40.10-FF-002131', NULL, 'Transcription factor bye1', 79, NULL, NULL, 84012);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(84013, '2.10.25.10-FF-001216', NULL, 'Laminin subunit beta-1', 50, NULL, NULL, 84013),
(84014, '2.130.10.10-FF-003419', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 181, NULL, NULL, 84014),
(84015, '2.170.120.20-FF-000020', NULL, '50S ribosomal protein L25', 88, NULL, NULL, 84015),
(84016, '2.60.120.620-FF-000094', NULL, 'Uncharacterized protein', 132, NULL, NULL, 84016),
(84017, '1.20.920.10-FF-000038', NULL, 'Brahma1', 123, NULL, NULL, 84017),
(84018, '3.30.420.10-FF-000327', NULL, 'Ribonuclease', 225, NULL, NULL, 84018),
(84019, '1.20.1250.20-FF-001984', NULL, 'AGAP012761-PA', 391, NULL, NULL, 84019),
(84020, '1.10.2000.10-FF-000015', NULL, 'membrane frizzled-related protein', 115, NULL, NULL, 84020),
(84021, '4.10.280.10-FF-000002', NULL, 'Basic helix-loop-helix transcription factor', 73, NULL, NULL, 84021),
(84022, '2.60.40.10-FF-002306', NULL, 'Cysteine protease', 95, NULL, NULL, 84022),
(84023, '3.30.1460.40-FF-000001', NULL, 'Hydrogenase-2 operon protein hybE', 136, NULL, NULL, 84023),
(84024, '3.40.50.1440-FF-000101', NULL, 'Misato 1, mitochondrial distribution and morphology regulator', 135, NULL, NULL, 84024),
(84025, '3.30.230.10-FF-000111', NULL, 'Ribosomal protein S9/S16', 132, NULL, NULL, 84025),
(84026, '3.10.20.90-FF-000878', NULL, 'Protein tyrosine phosphatase, non-receptor type 3', 63, NULL, NULL, 84026),
(84027, '2.10.110.10-FF-000009', NULL, 'Paxillin isoform 1', 62, NULL, NULL, 84027),
(84028, '3.40.30.10-FF-000303', NULL, 'Protein disulfide-isomerase', 126, NULL, NULL, 84028),
(84029, '2.40.50.100-FF-000210', NULL, 'RND superfamily efflux pump MFP component', 69, NULL, NULL, 84029),
(84030, '3.40.50.300-FF-002144', NULL, 'CCR4-associated factor 16, putative', 232, NULL, NULL, 84030),
(84031, '3.50.4.10-FF-000013', NULL, 'Apical membrane antigen 1', 107, NULL, NULL, 84031),
(84032, '3.40.33.10-FF-000080', NULL, 'Predicted protein', 143, NULL, NULL, 84032),
(84033, '2.30.42.10-FF-000530', NULL, NULL, 52, NULL, NULL, 84033),
(84034, '3.20.20.70-FF-000203', NULL, 'Mycofactocin system heme/flavin oxidoreductase MftD', 377, NULL, NULL, 84034),
(84035, '1.10.880.10-FF-000003', NULL, 'Nuclear factor, erythroid 2 like 3', 88, NULL, NULL, 84035),
(84036, '2.10.25.10-FF-001363', NULL, 'Wall-associated receptor kinase-like 9', 83, NULL, NULL, 84036),
(84037, '2.80.10.50-FF-000270', NULL, 'Cell surface protein', 112, NULL, NULL, 84037),
(84038, '1.10.510.10-FF-003590', NULL, NULL, 210, NULL, NULL, 84038),
(84039, '3.40.50.300-FF-006415', NULL, 'tRNA threonylcarbamoyladenosine biosynthesis protein TsaE', 130, NULL, NULL, 84039),
(84040, '1.10.238.10-FF-001192', NULL, 'Uncharacterized protein', 82, NULL, NULL, 84040),
(84041, '3.30.70.1660-FF-000024', NULL, 'peptide chain release factor 1-like, mitochondrial', 112, NULL, NULL, 84041),
(84042, '1.10.238.10-FF-001012', NULL, 'UBA domain-containing protein 8', 115, NULL, NULL, 84042),
(84043, '3.30.450.40-FF-000170', NULL, 'Phosphodiesterase', 158, NULL, NULL, 84043),
(84044, '1.20.5.110-FF-000154', NULL, 'Protein CBR-SYN-16', 106, NULL, NULL, 84044),
(84045, '3.20.10.10-FF-000022', NULL, '4-amino-4-deoxychorismate lyase', 155, NULL, NULL, 84045),
(84046, '3.20.20.70-FF-000731', NULL, NULL, 92, NULL, NULL, 84046),
(84047, '1.10.730.10-FF-000200', NULL, 'Uncharacterized protein', 130, NULL, NULL, 84047),
(84048, '1.20.1250.20-FF-001456', NULL, 'Putative transporter', 231, NULL, NULL, 84048),
(84049, '3.40.50.720-FF-001134', NULL, 'Theronine dehydrogenase-like Zn-dependent dehydrogenase', 138, NULL, NULL, 84049),
(84050, '2.40.100.10-FF-000148', NULL, 'Peptidyl-prolyl cis-trans isomerase', 175, NULL, NULL, 84050),
(84051, '1.10.8.270-FF-000119', NULL, 'Uncharacterized protein', 37, NULL, NULL, 84051),
(84052, '3.30.160.60-FF-001890', NULL, 'Uncharacterized protein', 29, NULL, NULL, 84052),
(84053, '1.25.10.10-FF-000191', NULL, 'RHO family interacting cell polarization regulator 2', 148, NULL, NULL, 84053),
(84054, '3.30.70.330-FF-001844', NULL, NULL, 115, NULL, NULL, 84054),
(84055, '1.25.10.10-FF-001617', NULL, 'Transportin2-like protein', 559, NULL, NULL, 84055);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(84056, '3.50.30.50-FF-000011', NULL, 'Slr2121 protein', 212, NULL, NULL, 84056),
(84057, '1.10.150.530-FF-000006', NULL, 'Probable dual-specificity RNA methyltransferase RlmN', 60, NULL, NULL, 84057),
(84058, '3.40.50.150-FF-000188', NULL, 'Protein-lysine methyltransferase METTL21C', 208, NULL, NULL, 84058),
(84059, '3.90.70.10-FF-000612', NULL, 'Uncharacterized protein', 158, NULL, NULL, 84059),
(84060, '2.130.10.10-FF-001469', NULL, 'WD repeat domain 34', 193, NULL, NULL, 84060),
(84061, '3.90.105.10-FF-000020', NULL, 'Molybdopterin molybdenumtransferase', 56, NULL, NULL, 84061),
(84062, '1.10.600.10-FF-000011', NULL, 'Decaprenyl diphosphate synthase subunit 1', 328, NULL, NULL, 84062),
(84063, '3.20.20.80-FF-000088', NULL, 'Alpha-glucosidase yihQ', 385, NULL, NULL, 84063),
(84064, '3.20.20.120-FF-000003', NULL, 'Glucarate dehydratase', 261, NULL, NULL, 84064),
(84065, '1.10.472.80-FF-000087', NULL, 'Chromosome 12, whole genome shotgun sequence', 153, NULL, NULL, 84065),
(84066, '2.60.40.10-FF-003767', NULL, NULL, 86, NULL, NULL, 84066),
(84067, '2.40.70.10-FF-000055', NULL, 'Probable aspartyl protease At4g16563', 203, NULL, NULL, 84067),
(84068, '1.10.390.10-FF-000067', NULL, 'Aminopeptidase N', 103, NULL, NULL, 84068),
(84069, '3.40.50.2020-FF-000169', NULL, 'Ribose-phosphate pyrophosphokinase', 108, NULL, NULL, 84069),
(84070, '3.30.40.10-FF-001170', NULL, 'GD13307', 61, NULL, NULL, 84070),
(84071, '3.55.50.30-FF-000024', NULL, 'Putative anti-sigma factor', 72, NULL, NULL, 84071),
(84072, '3.90.550.50-FF-000217', NULL, 'Hexosyltransferase', 145, NULL, NULL, 84072),
(84073, '2.130.10.10-FF-001654', NULL, 'BPH1p Protein', 247, NULL, NULL, 84073),
(84074, '3.30.420.40-FF-000426', NULL, 'Actin-like protein ARP9', 155, NULL, NULL, 84074),
(84075, '3.90.190.10-FF-000329', NULL, 'Uncharacterized protein', 73, NULL, NULL, 84075),
(84076, '3.80.10.10-FF-002245', NULL, 'Uncharacterized protein', 124, NULL, NULL, 84076),
(84077, '1.25.40.10-FF-001737', NULL, 'SMG6 protein', 200, NULL, NULL, 84077),
(84078, '3.30.200.20-FF-002113', NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 68', 78, NULL, NULL, 84078),
(84079, '2.40.30.10-FF-000053', NULL, 'Ribosome-releasing factor 2, mitochondrial', 135, NULL, NULL, 84079),
(84080, '2.60.120.590-FF-000011', NULL, 'Alpha-ketoglutarate-dependent dioxygenase AlkB', 175, NULL, NULL, 84080),
(84081, '3.90.190.10-FF-000301', NULL, 'Uncharacterized protein', 294, NULL, NULL, 84081),
(84082, '3.40.33.10-FF-000017', NULL, 'GLIPR1 like 2', 198, NULL, NULL, 84082),
(84083, '2.60.40.150-FF-000472', NULL, 'Activating signal cointegrator 1 complex subunit 3', 112, NULL, NULL, 84083),
(84084, '3.30.200.20-FF-002293', NULL, 'Gll3938 protein', 92, NULL, NULL, 84084),
(84085, '1.10.510.10-FF-002449', NULL, 'Uncharacterized protein', 325, NULL, NULL, 84085),
(84086, '3.30.70.2190-FF-000003', NULL, 'Glycolate oxidase, subunit GlcD', 112, NULL, NULL, 84086),
(84087, '3.30.559.70-FF-000026', NULL, 'choline acetyltransferase', 321, NULL, NULL, 84087),
(84088, '2.130.10.10-FF-005364', NULL, 'Uncharacterized protein', 171, NULL, NULL, 84088),
(84089, '3.30.70.260-FF-000171', NULL, 'D-3-phosphoglycerate dehydrogenase', 81, NULL, NULL, 84089),
(84090, '2.60.40.10-FF-001345', NULL, 'titin isoform X1', 95, NULL, NULL, 84090),
(84091, '2.30.30.100-FF-000130', NULL, 'LSM domain containing protein, putative', 108, NULL, NULL, 84091),
(84092, '3.90.810.10-FF-000035', NULL, NULL, 43, NULL, NULL, 84092),
(84093, '1.25.10.10-FF-000128', NULL, 'Vacuolar protein-like protein 8', 170, NULL, NULL, 84093),
(84094, '1.25.40.10-FF-005251', NULL, 'Uncharacterized RNA-binding protein C1861.04c', 163, NULL, NULL, 84094),
(84095, '3.30.565.10-FF-000528', NULL, 'Sensory box sensor histidine kinase', 155, NULL, NULL, 84095),
(84096, '2.30.30.140-FF-000294', NULL, 'Uncharacterized protein', 80, NULL, NULL, 84096),
(84097, '1.10.287.940-FF-000004', NULL, 'Purinergic receptor P2X 7', 36, NULL, NULL, 84097),
(84098, '2.40.30.10-FF-000401', NULL, 'Elongation factor G, domain IV family protein', 120, NULL, NULL, 84098);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(84099, '1.10.510.10-FF-002634', NULL, 'Protein kinase', 336, NULL, NULL, 84099),
(84100, '1.10.10.60-FF-001082', NULL, NULL, 47, NULL, NULL, 84100),
(84101, '2.120.10.30-FF-000312', NULL, 'YALI0F07931p', 283, NULL, NULL, 84101),
(84102, '3.30.160.60-FF-002666', NULL, 'Zgc:174623 protein', 26, NULL, NULL, 84102),
(84103, '1.25.40.10-FF-001445', NULL, 'Peptidylprolyl isomerase', 175, NULL, NULL, 84103),
(84104, '3.30.1140.32-FF-000027', NULL, 'Ribosomal protein S3, putative', 123, NULL, NULL, 84104),
(84105, '1.20.1600.10-FF-000036', NULL, 'Outer membrane channel protein', 471, NULL, NULL, 84105),
(84106, '3.40.30.10-FF-001236', NULL, 'Protein disulfide-isomerase', 131, NULL, NULL, 84106),
(84107, '2.130.10.10-FF-001093', NULL, 'Unplaced genomic scaffold supercont2.10, whole genome shotgun sequence', 297, NULL, NULL, 84107),
(84108, '1.20.1270.60-FF-000316', NULL, 'DDEFL1 protein', 250, NULL, NULL, 84108),
(84109, '3.30.565.10-FF-000236', NULL, 'Phytochrome', 163, NULL, NULL, 84109),
(84110, '3.30.420.40-FF-000050', NULL, 'Actin, alpha skeletal muscle', 174, NULL, NULL, 84110),
(84111, '3.40.50.2000-FF-000163', NULL, 'Sterol 3-beta-glucosyltransferase', 261, NULL, NULL, 84111),
(84112, '1.25.10.10-FF-001680', NULL, 'Uncharacterized protein', 294, NULL, NULL, 84112),
(84113, '3.90.70.10-FF-000899', NULL, 'Uncharacterized protein', 57, NULL, NULL, 84113),
(84114, '3.30.230.70-FF-000106', NULL, 'Acyl-CoA-binding domain-containing protein 1', 320, NULL, NULL, 84114),
(84115, '2.60.40.150-FF-000505', NULL, 'Copine Vb', 104, NULL, NULL, 84115),
(84116, '3.40.50.300-FF-000694', NULL, 'Preprotein translocase subunit SecA', 202, NULL, NULL, 84116),
(84117, '2.60.40.10-FF-003262', NULL, 'Basigin', 90, NULL, NULL, 84117),
(84118, '3.20.20.105-FF-000008', NULL, 'Queuine tRNA-ribosyltransferase accessory subunit 2', 389, NULL, NULL, 84118),
(84119, '3.30.800.10-FF-000020', NULL, 'Predicted protein', 174, NULL, NULL, 84119),
(84120, '3.40.50.2300-FF-000983', NULL, NULL, 113, NULL, NULL, 84120),
(84121, '3.30.160.60-FF-000018', NULL, 'Krueppel-like factor 15', 33, NULL, NULL, 84121),
(84122, '3.40.1030.10-FF-000014', NULL, 'Uncharacterized protein', 146, NULL, NULL, 84122),
(84123, '3.40.50.1450-FF-000014', NULL, 'Ni,Fe-hydrogenase maturation factor', 150, NULL, NULL, 84123),
(84124, '1.25.40.10-FF-001884', NULL, 'Zinc finger, C3H1-type-containing', 188, NULL, NULL, 84124),
(84125, '1.20.140.90-FF-000008', NULL, 'Malonyl-CoA decarboxylase, mitochondrial', 63, NULL, NULL, 84125),
(84126, '3.30.70.1400-FF-000002', NULL, 'tRNA-modifying protein YgfZ', 87, NULL, NULL, 84126),
(84127, '4.10.900.10-FF-000028', NULL, 'Uncharacterized protein', 95, NULL, NULL, 84127),
(84128, '2.60.20.10-FF-000006', NULL, 'Very large A-kinase anchor protein', 89, NULL, NULL, 84128),
(84129, '2.30.30.140-FF-000327', NULL, 'DNA mismatch repair protein', 114, NULL, NULL, 84129),
(84130, '3.40.50.300-FF-007348', NULL, 'Superfamily I DNA and RNA helicase and helicase subunits-like protein', 210, NULL, NULL, 84130),
(84131, '3.30.300.130-FF-000011', NULL, 'Metal-sulfur cluster biosynthetic enzyme', 107, NULL, NULL, 84131),
(84132, '3.10.129.10-FF-000256', NULL, 'Uncharacterized protein', 97, NULL, NULL, 84132),
(84133, '1.10.10.790-FF-000009', NULL, 'splicing factor, suppressor of white-apricot homolog', 56, NULL, NULL, 84133),
(84134, '3.90.780.10-FF-000037', NULL, 'Uncharacterized protein', 197, NULL, NULL, 84134),
(84135, '3.40.50.2300-FF-000039', NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase', 71, NULL, NULL, 84135),
(84136, '1.20.1560.10-FF-000953', NULL, 'Os03g0181750 protein', 37, NULL, NULL, 84136),
(84137, '3.40.50.300-FF-000255', NULL, 'Elongation factor 1-alpha', 226, NULL, NULL, 84137),
(84138, '2.60.40.10-FF-002278', NULL, 'receptor-type tyrosine-protein phosphatase beta isoform X2', 92, NULL, NULL, 84138),
(84139, '2.40.50.90-FF-000061', NULL, 'Ribonuclease', 131, NULL, NULL, 84139),
(84140, '1.20.140.70-FF-000002', NULL, 'Oligoendopeptidase F homolog', 155, NULL, NULL, 84140),
(84141, '3.30.200.20-FF-000168', NULL, 'L-type lectin-domain containing receptor kinase IX.1', 92, NULL, NULL, 84141);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(84142, '2.40.50.40-FF-000012', NULL, 'C-C motif chemokine', 74, NULL, NULL, 84142),
(84143, '1.10.3500.10-FF-000042', NULL, 'SUPT6H,-like protein to suppressor of ty 6', 297, NULL, NULL, 84143),
(84144, '3.40.1810.10-FF-000080', NULL, NULL, 54, NULL, NULL, 84144),
(84145, '2.60.40.790-FF-000197', NULL, NULL, 72, NULL, NULL, 84145),
(84146, '2.40.170.20-FF-000104', NULL, 'TonB-dependent siderophore receptor', 548, NULL, NULL, 84146),
(84147, '3.20.20.80-FF-000824', NULL, 'Uncharacterized protein', 55, NULL, NULL, 84147),
(84148, '3.40.50.300-FF-001183', NULL, 'Terminase, large subunit', 244, NULL, NULL, 84148),
(84149, '2.30.29.30-FF-000191', NULL, 'Tyrosine-protein kinase', 169, NULL, NULL, 84149),
(84150, '3.30.160.60-FF-002722', NULL, 'Blast:Zinc finger protein 175', 53, NULL, NULL, 84150),
(84151, '2.130.10.10-FF-003571', NULL, 'Angio-associated, migratory cell protein', 116, NULL, NULL, 84151),
(84152, '3.30.1680.10-FF-000060', NULL, 'Sema domain, transmembrane domain (TM), and cytoplasmic domain, (semaphorin) 6B', 36, NULL, NULL, 84152),
(84153, '1.20.5.1160-FF-000028', NULL, 'Nestin', 113, NULL, NULL, 84153),
(84154, '3.90.550.10-FF-000756', NULL, 'Uncharacterized protein', 126, NULL, NULL, 84154),
(84155, '3.90.850.10-FF-000037', NULL, NULL, 261, NULL, NULL, 84155),
(84156, '3.40.50.880-FF-000232', NULL, 'Exo-beta-D-glucosaminidase', 189, NULL, NULL, 84156),
(84157, '2.40.50.140-FF-000402', NULL, 'DNA ligase', 167, NULL, NULL, 84157),
(84158, '1.10.1450.10-FF-000133', NULL, 'CD151 antigen, putative', 107, NULL, NULL, 84158),
(84159, '2.30.29.30-FF-000011', NULL, 'Oxysterol-binding protein', 96, NULL, NULL, 84159),
(84160, '3.40.640.10-FF-000016', NULL, 'Glutamate decarboxylase like 1', 249, NULL, NULL, 84160),
(84161, '1.25.40.10-FF-001389', NULL, 'Pentatricopeptide repeat-containing protein At3g14330', 158, NULL, NULL, 84161),
(84162, '1.20.58.870-FF-000010', NULL, NULL, 106, NULL, NULL, 84162),
(84163, '1.10.287.110-FF-000048', NULL, 'DnaJ family protein', 102, NULL, NULL, 84163),
(84164, '3.40.50.300-FF-008332', NULL, 'Predicted protein', 238, NULL, NULL, 84164),
(84165, '3.40.50.970-FF-000231', NULL, 'Uncharacterized protein', 56, NULL, NULL, 84165),
(84166, '1.25.40.10-FF-005099', NULL, 'GM14040p', 114, NULL, NULL, 84166),
(84167, '3.40.50.10190-FF-000336', NULL, 'Predicted protein', 104, NULL, NULL, 84167),
(84168, '2.130.10.10-FF-002110', NULL, 'Katanin p80 WD40 repeat-containing subunit B1', 52, NULL, NULL, 84168),
(84169, '1.25.40.10-FF-002373', NULL, 'PPR repeat/Pentatricopeptide repeat domain containing protein, putative', 97, NULL, NULL, 84169),
(84170, '3.30.160.60-FF-001738', NULL, 'ZFP3 zinc finger protein', 36, NULL, NULL, 84170),
(84171, '3.10.50.40-FF-000157', NULL, 'Peptidylprolyl isomerase', 149, NULL, NULL, 84171),
(84172, '2.10.70.80-FF-000010', NULL, 'Sortilin', 65, NULL, NULL, 84172),
(84173, '3.40.50.1820-FF-001255', NULL, 'Uncharacterized protein', 312, NULL, NULL, 84173),
(84174, '1.25.10.10-FF-001056', NULL, 'Condensin complex subunit 1', 162, NULL, NULL, 84174),
(84175, '3.40.640.10-FF-000201', NULL, 'Aspartate aminotransferase', 239, NULL, NULL, 84175),
(84176, '3.40.50.150-FF-000160', NULL, 'EEF1A lysine methyltransferase 3', 203, NULL, NULL, 84176),
(84177, '2.60.40.1180-FF-000233', NULL, 'Alpha-galactosidase', 101, NULL, NULL, 84177),
(84178, '1.10.1040.30-FF-000001', NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily A member', 107, NULL, NULL, 84178),
(84179, '2.60.40.10-FF-004223', NULL, NULL, 69, NULL, NULL, 84179),
(84180, '1.10.510.10-FF-002073', NULL, 'Protein kinase family protein', 350, NULL, NULL, 84180),
(84181, '3.40.50.2000-FF-000955', NULL, 'Uncharacterized protein', 108, NULL, NULL, 84181),
(84182, '1.10.3330.10-FF-000006', NULL, 'Probable allantoinase 1', 169, NULL, NULL, 84182),
(84183, '3.40.50.10730-FF-000009', NULL, 'Predicted protein', 80, NULL, NULL, 84183),
(84184, '3.10.580.10-FF-000113', NULL, 'Chloride channel protein', 160, NULL, NULL, 84184),
(84185, '1.10.555.10-FF-000006', NULL, 'Rho GTPase activating protein 26', 195, NULL, NULL, 84185); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(84186, '3.40.1080.10-FF-000017', NULL, 'Butyrate--acetoacetate CoA-transferase subunit A', 218, NULL, NULL, 84186),
(84187, '3.30.70.330-FF-002777', NULL, NULL, 68, NULL, NULL, 84187),
(84188, '1.20.1740.10-FF-000102', NULL, 'FI04531p', 145, NULL, NULL, 84188),
(84189, '3.90.76.10-FF-000002', NULL, 'Dipeptide ABC transporter, substrate-binding protein', 161, NULL, NULL, 84189),
(84190, '3.40.50.10130-FF-000009', NULL, 'UV endonuclease', 159, NULL, NULL, 84190),
(84191, '1.10.510.10-FF-001673', NULL, 'Predicted protein', 271, NULL, NULL, 84191),
(84192, '1.20.58.390-FF-000164', NULL, 'Predicted protein', 95, NULL, NULL, 84192),
(84193, '1.10.510.10-FF-000509', NULL, 'Uncharacterized protein, isoform F', 125, NULL, NULL, 84193),
(84194, '3.30.565.10-FF-000152', NULL, 'Sensor histidine kinase AgrC', 151, NULL, NULL, 84194),
(84195, '1.25.10.10-FF-003001', NULL, 'Uncharacterized protein', 349, NULL, NULL, 84195),
(84196, '1.20.58.190-FF-000020', NULL, NULL, 130, NULL, NULL, 84196),
(84197, '3.10.20.30-FF-000091', NULL, 'Nicotinate dehydrogenase small FeS subunit', 79, NULL, NULL, 84197),
(84198, '3.30.70.330-FF-000540', NULL, 'RNA-binding protein Rsf1', 102, NULL, NULL, 84198),
(84199, '2.60.40.10-FF-003823', NULL, NULL, 96, NULL, NULL, 84199),
(84200, '3.40.50.2000-FF-000247', NULL, 'Glycogen [starch] synthase', 331, NULL, NULL, 84200),
(84201, '3.40.50.220-FF-000001', NULL, 'Ornithine decarboxylase SpeF', 107, NULL, NULL, 84201),
(84202, '1.25.40.10-FF-001209', NULL, 'Os07g0213300 protein', 115, NULL, NULL, 84202),
(84203, '3.40.50.300-FF-004437', NULL, 'Uncharacterized protein', 277, NULL, NULL, 84203),
(84204, '2.130.10.10-FF-000165', NULL, 'Mediator of RNA polymerase II transcription subunit 16', 135, NULL, NULL, 84204),
(84205, '2.60.120.200-FF-000557', NULL, 'Uncharacterized protein', 193, NULL, NULL, 84205),
(84206, '2.60.200.20-FF-000143', NULL, 'Predicted protein', 131, NULL, NULL, 84206),
(84207, '3.30.160.60-FF-006409', NULL, NULL, 17, NULL, NULL, 84207),
(84208, '3.40.1160.10-FF-000107', NULL, 'Uncharacterized protein', 84, NULL, NULL, 84208),
(84209, '1.25.10.10-FF-000752', NULL, 'Uncharacterized protein', 241, NULL, NULL, 84209),
(84210, '3.30.70.1230-FF-000013', NULL, 'Guanylate cyclase', 222, NULL, NULL, 84210),
(84211, '3.10.50.10-FF-000053', NULL, 'Uncharacterized protein', 47, NULL, NULL, 84211),
(84212, '3.90.1570.40-FF-000001', NULL, 'Pre-mRNA-processing-splicing factor 8', 172, NULL, NULL, 84212),
(84213, '1.25.10.10-FF-003478', NULL, 'Uncharacterized protein', 122, NULL, NULL, 84213),
(84214, '1.20.1000.10-FF-000007', NULL, 'Uncharacterized protein', 293, NULL, NULL, 84214),
(84215, '2.160.20.10-FF-000007', NULL, 'F-box only protein 11', 258, NULL, NULL, 84215),
(84216, '2.60.40.10-FF-000417', NULL, 'Fibronectin 1', 90, NULL, NULL, 84216),
(84217, '1.10.238.10-FF-000556', NULL, 'Probable CDC31-spindle pole body component, centrin', 54, NULL, NULL, 84217),
(84218, '3.30.160.60-FF-001002', NULL, 'zinc finger protein 32 isoform X1', 26, NULL, NULL, 84218),
(84219, '3.40.50.300-FF-000019', NULL, 'Translation initiation factor IF-2', 176, NULL, NULL, 84219),
(84220, '1.20.1280.170-FF-000016', NULL, 'Eukaryotic aspartyl protease family protein', 106, NULL, NULL, 84220),
(84221, '4.10.280.10-FF-000182', NULL, 'Basic helix-loop-helix', 72, NULL, NULL, 84221),
(84222, '3.10.20.90-FF-000086', NULL, 'Phosphoinositide phospholipase C', 107, NULL, NULL, 84222),
(84223, '2.130.10.10-FF-004347', NULL, 'Uncharacterized protein', 96, NULL, NULL, 84223),
(84224, '3.10.20.90-FF-000794', NULL, 'Uncharacterized protein', 70, NULL, NULL, 84224),
(84225, '2.130.10.10-FF-003947', NULL, 'Uncharacterized protein', 247, NULL, NULL, 84225),
(84226, '3.30.830.10-FF-000168', NULL, 'Mitochondrial-processing peptidase subunit alpha-1', 223, NULL, NULL, 84226),
(84227, '3.30.450.40-FF-000254', NULL, 'GAF domain phosphoenolpyruvate--protein phosphotransferase PtsP', 167, NULL, NULL, 84227),
(84228, '3.40.50.80-FF-000050', NULL, 'Ferric reduction oxidase 6', 120, NULL, NULL, 84228),
(84229, '2.60.40.60-FF-000090', NULL, 'FAT atypical cadherin 3', 93, NULL, NULL, 84229);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(84230, '1.25.70.10-FF-000104', NULL, NULL, 127, NULL, NULL, 84230),
(84231, '2.60.220.50-FF-000102', NULL, 'Putative adhesion G protein-coupled receptor E4P', 82, NULL, NULL, 84231),
(84232, '1.20.58.340-FF-000082', NULL, 'Predicted protein', 198, NULL, NULL, 84232),
(84233, '1.10.20.10-FF-000157', NULL, 'Histone H3-like centromeric protein A', 119, NULL, NULL, 84233),
(84234, '3.90.640.80-FF-000003', NULL, 'Poly [ADP-ribose] polymerase', 128, NULL, NULL, 84234),
(84235, '2.60.40.4310-FF-000003', NULL, 'Structural polyprotein', 58, NULL, NULL, 84235),
(84236, '3.30.1780.10-FF-000005', NULL, 'WGS project CABT00000000 data, contig 2.10', 149, NULL, NULL, 84236),
(84237, '3.40.720.10-FF-000202', NULL, 'N-acetylgalactosamine 6-sulfate sulfatase (GALNS)', 382, NULL, NULL, 84237),
(84238, '1.10.150.240-FF-000043', NULL, 'HAD family phosphatase', 64, NULL, NULL, 84238),
(84239, '3.30.160.60-FF-000777', NULL, 'zinc finger and BTB domain-containing protein 21', 27, NULL, NULL, 84239),
(84240, '3.40.50.300-FF-007635', NULL, 'Uncharacterized protein', 142, NULL, NULL, 84240),
(84241, '2.60.40.1670-FF-000020', NULL, 'Protein transport protein SEC23', 166, NULL, NULL, 84241),
(84242, '3.80.10.10-FF-003026', NULL, 'Uncharacterized protein', 269, NULL, NULL, 84242),
(84243, '1.10.533.10-FF-000080', NULL, 'Uncharacterized protein', 91, NULL, NULL, 84243),
(84244, '3.20.20.190-FF-000035', NULL, 'Phosphoinositide phospholipase C', 313, NULL, NULL, 84244),
(84245, '3.30.160.60-FF-000305', NULL, 'Vascular endothelial zinc finger 1', 27, NULL, NULL, 84245),
(84246, '2.60.40.150-FF-000241', NULL, 'Antiviral helicase SLH1', 109, NULL, NULL, 84246),
(84247, '3.40.50.720-FF-002354', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase 2 (Gapdh)(Nad(P)-dependent glyceraldehyde-3-phosphate dehydrogenase)', 185, NULL, NULL, 84247),
(84248, '3.20.20.70-FF-000259', NULL, 'Dihydroorotate dehydrogenase (quinone)', 354, NULL, NULL, 84248),
(84249, '2.130.10.10-FF-004111', NULL, 'AGAP003804-PA', 191, NULL, NULL, 84249),
(84250, '1.25.40.20-FF-000105', NULL, 'protein phosphatase 1 regulatory inhibitor subunit 16B', 137, NULL, NULL, 84250),
(84251, '3.10.110.10-FF-000382', NULL, 'Predicted protein', 148, NULL, NULL, 84251),
(84252, '1.25.50.20-FF-000078', NULL, 'Aminopeptidase', 209, NULL, NULL, 84252),
(84253, '3.30.465.10-FF-000111', NULL, 'D-2-hydroxyglutarate dehydrogenase, mitochondrial', 119, NULL, NULL, 84253),
(84254, '2.130.10.10-FF-004055', NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', 212, NULL, NULL, 84254),
(84255, '1.10.3210.10-FF-000031', NULL, 'RELA/SPOT homolog 1', 201, NULL, NULL, 84255),
(84256, '1.25.10.10-FF-002309', NULL, 'Uncharacterized protein', 317, NULL, NULL, 84256),
(84257, '1.25.40.20-FF-000577', NULL, 'Rab GTPase activating protein, putative', 168, NULL, NULL, 84257),
(84258, '3.30.420.80-FF-000034', NULL, 'Uncharacterized protein', 86, NULL, NULL, 84258),
(84259, '3.30.160.60-FF-000249', NULL, 'Zinc finger protein 154', 28, NULL, NULL, 84259),
(84260, '3.40.50.360-FF-000138', NULL, 'Putative NAD(P)H oxidoreductase', 182, NULL, NULL, 84260),
(84261, '2.60.40.150-FF-000185', NULL, 'DEAD/DEAH box helicase', 110, NULL, NULL, 84261),
(84262, '2.10.70.10-FF-000118', NULL, 'Uncharacterized protein, isoform A', 68, NULL, NULL, 84262),
(84263, '3.40.50.11380-FF-000002', NULL, 'probable UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SEC', 151, NULL, NULL, 84263),
(84264, '3.40.50.300-FF-000171', NULL, 'Dynamin-like 120 kDa protein, mitochondrial', 345, NULL, NULL, 84264),
(84265, '2.30.39.10-FF-000062', NULL, 'Serpin peptidase inhibitor 4', 152, NULL, NULL, 84265),
(84266, '2.60.40.10-FF-005712', NULL, NULL, 45, NULL, NULL, 84266),
(84267, '2.170.290.10-FF-000001', NULL, 'Baseplate wedge protein gp8', 158, NULL, NULL, 84267),
(84268, '2.130.10.10-FF-004583', NULL, 'WD repeat-containing protein GTS1', 208, NULL, NULL, 84268),
(84269, '2.60.40.10-FF-003998', NULL, NULL, 100, NULL, NULL, 84269),
(84270, '3.20.20.150-FF-000074', NULL, 'Predicted protein', 75, NULL, NULL, 84270);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(84271, '4.10.400.10-FF-000063', NULL, 'low-density lipoprotein receptor-related protein 12', 37, NULL, NULL, 84271),
(84272, '1.10.3720.10-FF-000109', NULL, 'sn-glycerol-3-phosphate transport system permease protein UgpE', 290, NULL, NULL, 84272),
(84273, '2.60.40.10-FF-000333', NULL, 'Down syndrome cell adhesion molecule', 94, NULL, NULL, 84273),
(84274, '3.40.50.1240-FF-000160', NULL, 'Nitric oxide synthase', 393, NULL, NULL, 84274),
(84275, '1.10.238.10-FF-000320', NULL, 'Uncharacterized protein, isoform B', 75, NULL, NULL, 84275),
(84276, '1.25.10.10-FF-002837', NULL, 'Uncharacterized protein', 180, NULL, NULL, 84276),
(84277, '1.25.40.20-FF-000049', NULL, 'Ankyrin repeat domain-containing protein 2', 52, NULL, NULL, 84277),
(84278, '1.10.510.10-FF-000184', NULL, 'cyclin-dependent kinase 5 homolog', 208, NULL, NULL, 84278),
(84279, '2.130.10.10-FF-002874', NULL, 'WD repeat-containing protein 90', 185, NULL, NULL, 84279),
(84280, '2.30.42.10-FF-000058', NULL, 'multiple PDZ domain protein isoform X1', 105, NULL, NULL, 84280),
(84281, '2.10.25.10-FF-000963', NULL, 'Fibrillin-1', 40, NULL, NULL, 84281),
(84282, '2.70.70.10-FF-000020', NULL, 'Peptidase, M23/M37 family', 138, NULL, NULL, 84282),
(84283, '3.10.100.10-FF-000353', NULL, NULL, 97, NULL, NULL, 84283),
(84284, '1.10.287.70-FF-000479', NULL, 'Uncharacterized protein', 302, NULL, NULL, 84284),
(84285, '3.50.50.60-FF-000515', NULL, 'D-amino acid dehydrogenase', 85, NULL, NULL, 84285),
(84286, '1.10.287.70-FF-000390', NULL, 'Sodium channel protein', 111, NULL, NULL, 84286),
(84287, '1.10.220.160-FF-000007', NULL, 'Uncharacterized protein, isoform A', 85, NULL, NULL, 84287),
(84288, '3.30.70.940-FF-000009', NULL, 'Transcription termination/antitermination protein NusG', 113, NULL, NULL, 84288),
(84289, '1.10.720.40-FF-000006', NULL, 'Thymopoietin a', 33, NULL, NULL, 84289),
(84290, '1.10.10.60-FF-000446', NULL, 'Egg-laying defective protein 27', 63, NULL, NULL, 84290),
(84291, '1.20.1070.10-FF-001181', NULL, 'Histamine H2 receptor', 334, NULL, NULL, 84291),
(84292, '3.30.470.20-FF-000098', NULL, 'Succinyl-CoA synthetase subunit alpha, putative', 146, NULL, NULL, 84292),
(84293, '3.40.605.10-FF-000070', NULL, 'Aldehyde dehydrogenase', 254, NULL, NULL, 84293),
(84294, '1.10.510.10-FF-001437', NULL, 'Protein kinase, putative', 282, NULL, NULL, 84294),
(84295, '2.120.10.80-FF-000102', NULL, 'Nitrile-specifier protein 5', 195, NULL, NULL, 84295),
(84296, '3.40.50.980-FF-000060', NULL, 'Acyl-CoA ligase easD', 145, NULL, NULL, 84296),
(84297, '1.10.150.50-FF-000162', NULL, 'Serine/threonine-protein kinase STE11', 58, NULL, NULL, 84297),
(84298, '3.60.21.60-FF-000009', NULL, 'DNA polymerase alpha subunit B', 173, NULL, NULL, 84298),
(84299, '1.10.10.10-FF-000600', NULL, 'DEAD/DEAH box helicase, putative', 83, NULL, NULL, 84299),
(84300, '1.25.40.10-FF-002137', NULL, 'Pentatricopeptide repeat-containing protein At2g42920, chloroplastic', 116, NULL, NULL, 84300),
(84301, '3.40.1370.10-FF-000028', NULL, 'Rpl4', 97, NULL, NULL, 84301),
(84302, '1.10.10.10-FF-001584', NULL, 'RNA polymerase sigma factor sigE, chloroplastic/mitochondrial', 52, NULL, NULL, 84302),
(84303, '1.20.930.20-FF-000008', NULL, 'Os08g0343000 protein', 110, NULL, NULL, 84303),
(84304, '1.50.40.10-FF-000600', NULL, 'Uncharacterized protein', 304, NULL, NULL, 84304),
(84305, '3.30.420.210-FF-000011', NULL, 'SEP_domain_containing_protein_-_putative', 63, NULL, NULL, 84305),
(84306, '3.30.40.10-FF-001198', NULL, 'Uncharacterized protein', 57, NULL, NULL, 84306),
(84307, '3.40.190.10-FF-000150', NULL, 'Glutamate receptor 2.7', 116, NULL, NULL, 84307),
(84308, '3.30.1340.10-FF-000006', NULL, 'PTS-dependent dihydroxyacetone kinase, DhaM subunit', 87, NULL, NULL, 84308),
(84309, '3.30.310.50-FF-000045', NULL, 'Phosphoglucosamine mutase', 81, NULL, NULL, 84309),
(84310, '3.40.50.300-FF-000547', NULL, 'Cell division control protein', 180, NULL, NULL, 84310),
(84311, '1.10.260.170-FF-000001', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', 146, NULL, NULL, 84311),
(84312, '1.20.5.190-FF-000104', NULL, NULL, 43, NULL, NULL, 84312);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(84313, '3.40.50.410-FF-000232', NULL, 'Putative 60 kd ribonucleoprotein ssa/ro60 kd ribonucleoprotein ssa/ro', 194, NULL, NULL, 84313),
(84314, '3.40.50.300-FF-003892', NULL, 'Iron compound ABC transporter, ATP-binding protein, putative', 253, NULL, NULL, 84314),
(84315, '3.10.250.10-FF-000009', NULL, 'WC1', 104, NULL, NULL, 84315),
(84316, '2.130.10.10-FF-002930', NULL, 'Uncharacterized protein', 184, NULL, NULL, 84316),
(84317, '1.10.287.110-FF-000284', NULL, 'Uncharacterized protein', 69, NULL, NULL, 84317),
(84318, '3.80.10.10-FF-002953', NULL, 'Uncharacterized protein', 150, NULL, NULL, 84318),
(84319, '3.40.50.150-FF-000952', NULL, 'Probable methyltransferase tdiE', 277, NULL, NULL, 84319),
(84320, '1.10.10.10-FF-000280', NULL, 'Transcriptional regulator gntR family', 75, NULL, NULL, 84320),
(84321, '3.40.50.1820-FF-001542', NULL, 'Uncharacterized protein', 131, NULL, NULL, 84321),
(84322, '3.40.50.720-FF-002298', NULL, 'Uncharacterized protein', 171, NULL, NULL, 84322),
(84323, '4.10.1000.40-FF-000010', NULL, 'Uncharacterized protein', 70, NULL, NULL, 84323),
(84324, '1.10.287.770-FF-000015', NULL, 'Pickpocket 9, isoform A', 43, NULL, NULL, 84324),
(84325, '2.50.20.20-FF-000004', NULL, 'Lipoarabinomannan carrier protein LprG', 200, NULL, NULL, 84325),
(84326, '3.90.550.10-FF-000380', NULL, 'Posttranslational modification protein', 230, NULL, NULL, 84326),
(84327, '3.40.50.880-FF-000176', NULL, 'DJ-1/PfpI family protein', 208, NULL, NULL, 84327),
(84328, '3.40.50.300-FF-005550', NULL, 'Uncharacterized protein', 269, NULL, NULL, 84328),
(84329, '1.20.120.1750-FF-000062', NULL, 'RBR-type E3 ubiquitin transferase', 260, NULL, NULL, 84329),
(84330, '3.30.300.10-FF-000055', NULL, 'S-adenosylmethionine synthase 1', 79, NULL, NULL, 84330),
(84331, '3.30.1640.30-FF-000001', NULL, 'Serine protease 7', 61, NULL, NULL, 84331),
(84332, '3.30.1360.120-FF-000041', NULL, 'Aminomethyltransferase', 160, NULL, NULL, 84332),
(84333, '2.40.10.10-FF-000170', NULL, 'Serine protease 3', 80, NULL, NULL, 84333),
(84334, '3.20.20.330-FF-000004', NULL, 'Bifunctional homocysteine S-methyltransferase/methylenetetrahydrofolate reductase', 293, NULL, NULL, 84334),
(84335, '3.30.160.60-FF-005780', NULL, NULL, 56, NULL, NULL, 84335),
(84336, '1.20.120.1760-FF-000008', NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase 2', 197, NULL, NULL, 84336),
(84337, '3.30.160.60-FF-002435', NULL, 'Uncharacterized protein', 31, NULL, NULL, 84337),
(84338, '3.10.100.10-FF-000297', NULL, NULL, 136, NULL, NULL, 84338),
(84339, '1.20.1070.10-FF-001557', NULL, 'Uncharacterized protein', 172, NULL, NULL, 84339),
(84340, '3.30.200.20-FF-000584', NULL, 'Non-specific serine/threonine protein kinase', 55, NULL, NULL, 84340),
(84341, '3.40.395.10-FF-000030', NULL, 'Membrane thiol protease', 123, NULL, NULL, 84341),
(84342, '1.10.8.710-FF-000004', NULL, 'Dynein axonemal heavy chain 6', 109, NULL, NULL, 84342),
(84343, '3.40.640.10-FF-000308', NULL, 'Aminotransferase class I and II', 221, NULL, NULL, 84343),
(84344, '1.10.8.10-FF-000060', NULL, 'DCN1-like protein', 39, NULL, NULL, 84344),
(84345, '3.40.190.10-FF-000239', NULL, 'Glutamate receptor ionotropic, delta-2', 117, NULL, NULL, 84345),
(84346, '1.20.120.350-FF-000253', NULL, NULL, 173, NULL, NULL, 84346),
(84347, '1.20.120.1200-FF-000009', NULL, 'NADH-quinone oxidoreductase subunit J', 165, NULL, NULL, 84347),
(84348, '3.40.50.2300-FF-000455', NULL, 'Protein CBG01593', 128, NULL, NULL, 84348),
(84349, '3.40.50.2300-FF-000511', NULL, 'Two-component system sensor protein', 119, NULL, NULL, 84349),
(84350, '1.25.10.10-FF-000275', NULL, 'protein SINE1 isoform X1', 314, NULL, NULL, 84350),
(84351, '1.20.120.350-FF-000197', NULL, NULL, 149, NULL, NULL, 84351),
(84352, '3.40.50.1820-FF-001486', NULL, 'Uncharacterized protein', 167, NULL, NULL, 84352),
(84353, '2.40.50.140-FF-001239', NULL, NULL, 164, NULL, NULL, 84353),
(84354, '2.130.10.10-FF-005836', NULL, 'Nucleoporin nup132', 372, NULL, NULL, 84354),
(84355, '2.30.29.240-FF-000012', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 217, NULL, NULL, 84355);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(84356, '1.20.1510.10-FF-000006', NULL, 'Divalent cation efflux transporter', 197, NULL, NULL, 84356),
(84357, '1.20.1250.20-FF-002153', NULL, 'Uncharacterized protein', 197, NULL, NULL, 84357),
(84358, '3.80.10.10-FF-001172', NULL, 'Os11g0108932 protein', 191, NULL, NULL, 84358),
(84359, '2.70.160.11-FF-000011', NULL, 'Protein arginine N-methyltransferase 9', 176, NULL, NULL, 84359),
(84360, '1.10.510.10-FF-002218', NULL, NULL, 206, NULL, NULL, 84360),
(84361, '2.170.270.10-FF-000202', NULL, 'Whsc1 protein', 175, NULL, NULL, 84361),
(84362, '2.60.40.1180-FF-000002', NULL, '1,4-alpha-glucan branching enzyme GlgB', 108, NULL, NULL, 84362),
(84363, '2.70.130.10-FF-000109', NULL, NULL, 156, NULL, NULL, 84363),
(84364, '3.40.50.300-FF-006331', NULL, 'Zgc:153294', 61, NULL, NULL, 84364),
(84365, '2.40.128.300-FF-000001', NULL, 'Copper homeostasis/adhesion lipoprotein NlpE', 98, NULL, NULL, 84365),
(84366, '3.30.40.10-FF-001962', NULL, 'Uncharacterized protein', 64, NULL, NULL, 84366),
(84367, '3.30.710.10-FF-000193', NULL, 'BTB/POZ and TAZ domain-containing protein 2', 114, NULL, NULL, 84367),
(84368, '3.30.1550.10-FF-000016', NULL, '60S ribosomal protein L12', 31, NULL, NULL, 84368),
(84369, '2.60.120.10-FF-000341', NULL, 'Mannose-6-phosphate isomerase', 101, NULL, NULL, 84369),
(84370, '2.30.29.30-FF-000516', NULL, 'Dos, isoform A', 123, NULL, NULL, 84370),
(84371, '3.90.550.10-FF-000228', NULL, 'Galactinol synthase', 258, NULL, NULL, 84371),
(84372, '1.10.220.150-FF-000061', NULL, 'Uncharacterized protein', 78, NULL, NULL, 84372),
(84373, '3.30.70.330-FF-000832', NULL, 'Small subunit rRNA processing protein, putative', 132, NULL, NULL, 84373),
(84374, '3.40.50.720-FF-001050', NULL, 'Calcium-activated potassium channel subunit alpha-1', 156, NULL, NULL, 84374),
(84375, '1.20.870.10-FF-000040', NULL, 'RIKEN cDNA 4930474N05 gene', 171, NULL, NULL, 84375),
(84376, '2.40.10.10-FF-000546', NULL, NULL, 80, NULL, NULL, 84376),
(84377, '3.30.70.100-FF-000145', NULL, NULL, 70, NULL, NULL, 84377),
(84378, '1.10.630.10-FF-000075', NULL, 'Cytochrome P450 monooxygenase helB1', 464, NULL, NULL, 84378),
(84379, '2.60.40.60-FF-000882', NULL, 'Cadherin 23', 58, NULL, NULL, 84379),
(84380, '1.25.40.610-FF-000002', NULL, 'Adhesion G protein-coupled receptor B2', 124, NULL, NULL, 84380),
(84381, '3.40.50.300-FF-005926', NULL, 'Multidrug resistance-associated protein 1', 252, NULL, NULL, 84381),
(84382, '3.40.50.10190-FF-000191', NULL, 'Transcription coactivator', 92, NULL, NULL, 84382),
(84383, '3.40.50.300-FF-005218', NULL, 'Uncharacterized protein', 207, NULL, NULL, 84383),
(84384, '2.60.120.10-FF-000521', NULL, 'ATP-binding subunit of ABC transporter', 136, NULL, NULL, 84384),
(84385, '3.40.1110.10-FF-000487', NULL, NULL, 169, NULL, NULL, 84385),
(84386, '3.30.160.60-FF-005925', NULL, NULL, 56, NULL, NULL, 84386),
(84387, '1.25.40.10-FF-000900', NULL, 'Pentatricopeptide repeat-containing protein', 114, NULL, NULL, 84387),
(84388, '3.40.50.720-FF-001573', NULL, 'very-long-chain 3-oxoacyl-CoA reductase 1-like', 240, NULL, NULL, 84388),
(84389, '2.130.10.10-FF-000457', NULL, 'rRNA processing protein Pwp1', 166, NULL, NULL, 84389),
(84390, '3.40.50.300-FF-004706', NULL, 'Uncharacterized protein', 168, NULL, NULL, 84390),
(84391, '2.60.40.60-FF-000354', NULL, 'FAT atypical cadherin 3', 33, NULL, NULL, 84391),
(84392, '3.40.5.120-FF-000005', NULL, 'Kismet, isoform B', 47, NULL, NULL, 84392),
(84393, '3.30.200.20-FF-001096', NULL, 'Protein kinase superfamily protein', 113, NULL, NULL, 84393),
(84394, '3.40.800.20-FF-000032', NULL, 'Acetylpolyamine amidohydrolase 2', 344, NULL, NULL, 84394),
(84395, '3.60.20.10-FF-000167', NULL, NULL, 213, NULL, NULL, 84395),
(84396, '3.90.190.10-FF-000245', NULL, 'Phosphoinositide phosphatase', 244, NULL, NULL, 84396),
(84397, '3.60.15.10-FF-000222', NULL, 'Os09g0439000 protein', 107, NULL, NULL, 84397),
(84398, '3.40.50.1390-FF-000007', NULL, 'Serine recombinase', 132, NULL, NULL, 84398),
(84399, '3.50.50.60-FF-001027', NULL, 'Dihydropyrimidine dehydrogenase [NADP(+)]', 119, NULL, NULL, 84399);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(84400, '3.40.50.2300-FF-001528', NULL, NULL, 77, NULL, NULL, 84400),
(84401, '3.90.920.10-FF-000009', NULL, 'DNA primase', 380, NULL, NULL, 84401),
(84402, '2.170.140.10-FF-000013', NULL, 'Uncharacterized protein, isoform B', 73, NULL, NULL, 84402),
(84403, '3.40.50.300-FF-001475', NULL, 'Ferrous iron transport protein B', 170, NULL, NULL, 84403),
(84404, '1.10.510.10-FF-003910', NULL, NULL, 79, NULL, NULL, 84404),
(84405, '3.40.1190.20-FF-000028', NULL, 'ATP-dependent (S)-NAD(P)H-hydrate dehydratase', 312, NULL, NULL, 84405),
(84406, '1.25.40.10-FF-004610', NULL, 'Uncharacterized protein', 268, NULL, NULL, 84406),
(84407, '2.120.10.80-FF-000158', NULL, 'Multiple epidermal growth factor domains protein 8', 216, NULL, NULL, 84407),
(84408, '2.130.10.10-FF-002402', NULL, 'Protein CBG08973', 153, NULL, NULL, 84408),
(84409, '1.25.10.10-FF-003186', NULL, 'Phosphoinositide 3-kinase regulatory subunit, putative', 312, NULL, NULL, 84409),
(84410, '3.10.450.10-FF-000053', NULL, 'Cysteine proteinase inhibitor', 92, NULL, NULL, 84410),
(84411, '3.40.50.300-FF-008040', NULL, 'Uncharacterized protein', 133, NULL, NULL, 84411),
(84412, '3.30.70.920-FF-000003', NULL, 'AsnC family transcriptional regulator', 81, NULL, NULL, 84412),
(84413, '3.80.10.10-FF-001733', NULL, 'Protein C21orf2 homolog, putative', 141, NULL, NULL, 84413),
(84414, '1.10.246.120-FF-000003', NULL, 'Vacuolar protein sorting-associated protein 9A', 81, NULL, NULL, 84414),
(84415, '1.10.630.10-FF-000783', NULL, 'Uncharacterized protein', 128, NULL, NULL, 84415),
(84416, '3.40.50.2000-FF-001091', NULL, 'Glycosyltransferase', 79, NULL, NULL, 84416),
(84417, '3.40.630.10-FF-000375', NULL, 'Uncharacterized protein', 108, NULL, NULL, 84417),
(84418, '2.10.25.10-FF-000199', NULL, 'signal peptide, CUB and EGF-like domain-containing protein 2 isoform X2', 46, NULL, NULL, 84418),
(84419, '1.25.10.10-FF-001909', NULL, 'Predicted protein', 423, NULL, NULL, 84419),
(84420, '3.30.70.330-FF-002485', NULL, NULL, 77, NULL, NULL, 84420),
(84421, '1.20.1560.10-FF-000684', NULL, 'Uncharacterized protein', 350, NULL, NULL, 84421),
(84422, '3.40.50.720-FF-000589', NULL, 'Alpha-aminoadipic semialdehyde synthase', 208, NULL, NULL, 84422),
(84423, '2.10.10.10-FF-000002', NULL, '72 kDa type IV collagenase', 54, NULL, NULL, 84423),
(84424, '3.10.580.10-FF-000057', NULL, 'DUF21 domain-containing protein At5g52790', 46, NULL, NULL, 84424),
(84425, '1.20.5.500-FF-000001', NULL, 'Type II keratin 23', 68, NULL, NULL, 84425),
(84426, '2.40.40.20-FF-000028', NULL, 'Vesicle-fusing ATPase', 91, NULL, NULL, 84426),
(84427, '2.20.28.10-FF-000008', NULL, 'DNA helicase', 55, NULL, NULL, 84427),
(84428, '3.30.160.270-FF-000002', NULL, '2-isopropylmalate synthase', 195, NULL, NULL, 84428),
(84429, '3.30.160.60-FF-004852', NULL, NULL, 32, NULL, NULL, 84429),
(84430, '2.60.40.10-FF-000709', NULL, 'basement membrane-specific heparan sulfate proteoglycan core protein', 95, NULL, NULL, 84430),
(84431, '3.40.50.300-FF-007579', NULL, 'Predicted protein', 296, NULL, NULL, 84431),
(84432, '3.30.160.60-FF-006292', NULL, NULL, 41, NULL, NULL, 84432),
(84433, '3.40.220.10-FF-000001', NULL, 'Probable cytosol aminopeptidase', 180, NULL, NULL, 84433),
(84434, '3.30.560.10-FF-000012', NULL, 'Choline dehydrogenase, putative', 254, NULL, NULL, 84434),
(84435, '1.10.238.10-FF-000264', NULL, 'Calmodulin like 6', 76, NULL, NULL, 84435),
(84436, '1.20.1250.20-FF-000495', NULL, 'Glycoside-Pentoside-Hexuronide (GPH):Cation Symporter Family', 192, NULL, NULL, 84436),
(84437, '1.10.510.10-FF-001965', NULL, NULL, 141, NULL, NULL, 84437),
(84438, '3.40.50.300-FF-004145', NULL, 'DNA helicase', 129, NULL, NULL, 84438),
(84439, '1.25.40.10-FF-002665', NULL, 'Uncharacterized protein', 314, NULL, NULL, 84439),
(84440, '3.90.260.10-FF-000037', NULL, 'AGAP003342-PA', 177, NULL, NULL, 84440),
(84441, '2.170.130.10-FF-000080', NULL, NULL, 140, NULL, NULL, 84441),
(84442, '3.30.160.60-FF-004144', NULL, NULL, 28, NULL, NULL, 84442),
(84443, '2.30.30.40-FF-000410', NULL, 'Chemotaxis protein CheW', 58, NULL, NULL, 84443);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(84444, '1.10.510.10-FF-000364', NULL, 'Guanylate cyclase', 255, NULL, NULL, 84444),
(84445, '2.80.10.50-FF-000067', NULL, 'BnaC05g19630D protein', 143, NULL, NULL, 84445),
(84446, '1.25.40.20-FF-001033', NULL, 'Espin', 68, NULL, NULL, 84446),
(84447, '3.30.40.10-FF-000473', NULL, 'E3 ubiquitin-protein ligase RHF2A', 75, NULL, NULL, 84447),
(84448, '3.40.50.150-FF-000665', NULL, 'Uncharacterized protein', 121, NULL, NULL, 84448),
(84449, '3.40.50.300-FF-008563', NULL, 'Blr8088 protein', 118, NULL, NULL, 84449),
(84450, '2.130.10.10-FF-003127', NULL, 'Transducin/WD40 repeat-like superfamily protein', 252, NULL, NULL, 84450),
(84451, '1.10.510.10-FF-000420', NULL, 'Guanylate cyclase', 293, NULL, NULL, 84451),
(84452, '2.20.25.10-FF-000058', NULL, 'DNA-directed RNA polymerase subunit', 55, NULL, NULL, 84452),
(84453, '2.20.25.10-FF-000114', NULL, 'DNA-directed RNA polymerase subunit', 52, NULL, NULL, 84453),
(84454, '1.20.1070.10-FF-000253', NULL, 'prostaglandin E2 receptor EP1 subtype', 338, NULL, NULL, 84454),
(84455, '3.30.160.60-FF-003363', NULL, NULL, 28, NULL, NULL, 84455),
(84456, '2.60.120.260-FF-000019', NULL, 'Anaphase-promoting complex subunit 10', 171, NULL, NULL, 84456),
(84457, '3.40.630.10-FF-000431', NULL, 'Cpb1 protein', 265, NULL, NULL, 84457),
(84458, '1.10.1070.11-FF-000032', NULL, 'Protein kinase rad3', 178, NULL, NULL, 84458),
(84459, '1.20.120.1080-FF-000107', NULL, 'DEAH-box RNA helicase', 105, NULL, NULL, 84459),
(84460, '2.80.10.50-FF-000123', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 83, NULL, NULL, 84460),
(84461, '3.40.50.300-FF-006707', NULL, 'P-loop containing nucleoside triphosphate hydrolases superfamily protein', 77, NULL, NULL, 84461),
(84462, '1.10.418.10-FF-000121', NULL, 'Calponin domain containing protein', 108, NULL, NULL, 84462),
(84463, '1.20.5.1500-FF-000001', NULL, 'Nucleosome assembly protein 1-like 1', 59, NULL, NULL, 84463),
(84464, '2.60.40.10-FF-005476', NULL, NULL, 101, NULL, NULL, 84464),
(84465, '2.30.40.10-FF-000076', NULL, 'Amidohydrolase', 43, NULL, NULL, 84465),
(84466, '1.20.1070.10-FF-000781', NULL, 'Uncharacterized protein', 249, NULL, NULL, 84466),
(84467, '3.30.160.60-FF-003891', NULL, NULL, 26, NULL, NULL, 84467),
(84468, '1.10.8.270-FF-000030', NULL, 'Ypt/Rab-GAP domain of gyp1p superfamily protein', 97, NULL, NULL, 84468),
(84469, '3.30.428.70-FF-000003', NULL, 'Uncharacterized protein', 328, NULL, NULL, 84469),
(84470, '3.40.50.1780-FF-000001', NULL, 'Nuclear prelamin A recognition factor', 155, NULL, NULL, 84470),
(84471, '1.10.10.10-FF-000128', NULL, 'DNA-binding protein RFX5 isoform X1', 76, NULL, NULL, 84471),
(84472, '3.40.50.1000-FF-000048', NULL, 'Phosphoserine phosphatase', 147, NULL, NULL, 84472),
(84473, '2.40.30.10-FF-000345', NULL, 'Elongation factor EF-2', 133, NULL, NULL, 84473),
(84474, '1.20.5.2440-FF-000013', NULL, 'rab11 family-interacting protein 1 isoform X1', 67, NULL, NULL, 84474),
(84475, '2.70.170.10-FF-000151', NULL, 'Uncharacterized protein', 120, NULL, NULL, 84475),
(84476, '3.30.1330.40-FF-000048', NULL, 'YALI0F14553p', 115, NULL, NULL, 84476),
(84477, '1.10.510.10-FF-004107', NULL, NULL, 126, NULL, NULL, 84477),
(84478, '1.10.10.10-FF-000656', NULL, 'Regulatory protein RecX', 46, NULL, NULL, 84478),
(84479, '3.80.10.10-FF-003678', NULL, 'Uncharacterized protein', 205, NULL, NULL, 84479),
(84480, '3.40.50.620-FF-000525', NULL, 'ATP sulfurylase 1 chloroplastic', 138, NULL, NULL, 84480),
(84481, '3.40.50.920-FF-000025', NULL, '1-deoxy-D-xylulose-5-phosphate synthase', 129, NULL, NULL, 84481),
(84482, '2.60.40.10-FF-001261', NULL, 'immunoglobulin superfamily member 5', 107, NULL, NULL, 84482),
(84483, '3.30.70.3040-FF-000005', NULL, 'Cell division protein FtsX', 108, NULL, NULL, 84483),
(84484, '3.30.200.20-FF-001601', NULL, 'Serine/threonine protein kinase, putative (AFU_orthologue AFUA_5G07950)', 105, NULL, NULL, 84484),
(84485, '2.10.220.10-FF-000135', NULL, 'Uncharacterized protein', 62, NULL, NULL, 84485),
(84486, '1.25.40.20-FF-000757', NULL, 'Mechanosensory transduction channel NOMPC', 101, NULL, NULL, 84486); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(84487, '3.40.50.10310-FF-000002', NULL, 'Putative mycofactocin system creatinine amidohydrolase family protein MftE', 231, NULL, NULL, 84487),
(84488, '3.40.50.10490-FF-000067', NULL, 'Glucose-6-phosphate isomerase', 142, NULL, NULL, 84488),
(84489, '3.30.500.10-FF-000036', NULL, NULL, 163, NULL, NULL, 84489),
(84490, '3.30.420.40-FF-000342', NULL, 'Actin-related protein 7', 55, NULL, NULL, 84490),
(84491, '2.160.20.80-FF-000011', NULL, 'Uncharacterized protein', 79, NULL, NULL, 84491),
(84492, '1.10.540.10-FF-000045', NULL, 'Acyl-CoA dehydrogenase FadE2', 126, NULL, NULL, 84492),
(84493, '3.30.1330.20-FF-000042', NULL, 'Tubulin alpha-2 chain', 77, NULL, NULL, 84493),
(84494, '3.80.10.10-FF-002189', NULL, 'Toll-like receptor 22', 172, NULL, NULL, 84494),
(84495, '2.40.70.10-FF-000319', NULL, NULL, 177, NULL, NULL, 84495),
(84496, '1.10.540.10-FF-000101', NULL, 'Acyl-CoA dehydrogenase domain protein', 119, NULL, NULL, 84496),
(84497, '1.25.40.990-FF-000071', NULL, 'Putative peptidase C48 domain family protein', 105, NULL, NULL, 84497),
(84498, '3.30.70.330-FF-000068', NULL, 'ATP-dependent RNA helicase DeaD', 73, NULL, NULL, 84498),
(84499, '3.90.70.10-FF-000320', NULL, 'Uncharacterized protein F31E3.4', 325, NULL, NULL, 84499),
(84500, '2.130.10.10-FF-001946', NULL, 'WD40 repeat-like protein', 333, NULL, NULL, 84500),
(84501, '3.30.420.40-FF-000718', NULL, 'Actin-related protein 8', 155, NULL, NULL, 84501),
(84502, '3.40.50.460-FF-000022', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit alpha 2', 59, NULL, NULL, 84502),
(84503, '2.60.200.20-FF-000199', NULL, 'Serine/threonine protein kinase', 128, NULL, NULL, 84503),
(84504, '3.60.21.10-FF-000219', NULL, 'Serine/threonine-protein phosphatase', 316, NULL, NULL, 84504),
(84505, '2.130.10.10-FF-005656', NULL, 'Uncharacterized protein (Fragment)', 167, NULL, NULL, 84505),
(84506, '1.10.287.1270-FF-000003', NULL, 'G protein-coupled receptor kinase', 76, NULL, NULL, 84506),
(84507, '1.20.900.10-FF-000094', NULL, 'Dynamin-binding protein', 225, NULL, NULL, 84507),
(84508, '3.30.70.580-FF-000002', NULL, 'tRNA pseudouridine synthase', 121, NULL, NULL, 84508),
(84509, '3.30.460.10-FF-000212', NULL, 'RNA editing 3'' terminal uridylyl transferase 1', 129, NULL, NULL, 84509),
(84510, '3.50.50.100-FF-000030', NULL, 'External alternative NAD(P)H-ubiquinone oxidoreductase B4, mitochondrial', 111, NULL, NULL, 84510),
(84511, '1.20.5.110-FF-000210', NULL, 'Syntaxin-16', 35, NULL, NULL, 84511),
(84512, '2.30.30.30-FF-000109', NULL, '50S ribosomal protein L24', 118, NULL, NULL, 84512),
(84513, '1.10.8.720-FF-000064', NULL, 'Uncharacterized protein', 173, NULL, NULL, 84513),
(84514, '2.70.150.10-FF-000296', NULL, 'Uncharacterized protein', 116, NULL, NULL, 84514),
(84515, '2.60.120.970-FF-000029', NULL, 'Bone morphogenetic protein 6', 184, NULL, NULL, 84515),
(84516, '1.25.40.10-FF-003593', NULL, 'Clustered mitochondria protein homolog', 151, NULL, NULL, 84516),
(84517, '3.30.260.10-FF-000028', NULL, 'T-complex protein 1 subunit epsilon', 36, NULL, NULL, 84517),
(84518, '1.20.1250.20-FF-001512', NULL, 'Uncharacterized protein', 93, NULL, NULL, 84518),
(84519, '4.10.400.10-FF-000243', NULL, 'SCO-spondin', 40, NULL, NULL, 84519),
(84520, '3.40.50.10470-FF-000061', NULL, 'Methylthioribose-1-phosphate isomerase', 176, NULL, NULL, 84520),
(84521, '1.25.10.10-FF-002461', NULL, 'Uncharacterized protein', 221, NULL, NULL, 84521),
(84522, '3.90.70.80-FF-000083', NULL, 'Predicted protein', 100, NULL, NULL, 84522),
(84523, '2.60.40.10-FF-001637', NULL, 'Down syndrome cell adhesion molecule 3, isoform C', 103, NULL, NULL, 84523),
(84524, '1.20.1050.80-FF-000014', NULL, 'Muk1p', 157, NULL, NULL, 84524),
(84525, '2.60.40.10-FF-003003', NULL, 'Uncharacterized protein, isoform A', 111, NULL, NULL, 84525),
(84526, '2.30.30.40-FF-000354', NULL, 'Guanine nucleotide exchange factor UNC-73A', 71, NULL, NULL, 84526),
(84527, '1.25.40.20-FF-000813', NULL, 'Ankyrin repeat-containing protein', 151, NULL, NULL, 84527),
(84528, '2.40.50.140-FF-000458', NULL, '23S rRNA (uracil(1939)-C(5))-methyltransferase RlmD', 79, NULL, NULL, 84528); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(84529, '3.80.10.10-FF-003734', NULL, 'Uncharacterized protein', 133, NULL, NULL, 84529),
(84530, '3.40.50.10480-FF-000007', NULL, 'Ribosome production factor 1, putative', 172, NULL, NULL, 84530),
(84531, '3.40.250.10-FF-000205', NULL, 'Dual specificity phosphatase', 139, NULL, NULL, 84531),
(84532, '1.20.1070.10-FF-001742', NULL, 'Predicted protein', 86, NULL, NULL, 84532),
(84533, '1.20.5.340-FF-000077', NULL, 'Serine/threonine-protein kinase Genghis Khan-like Protein', 77, NULL, NULL, 84533),
(84534, '3.40.50.300-FF-002436', NULL, 'Protein RecA', 242, NULL, NULL, 84534),
(84535, '3.40.50.800-FF-000079', NULL, 'Putative proline--tRNA ligase, mitochondrial', 117, NULL, NULL, 84535),
(84536, '3.30.450.20-FF-000299', NULL, 'Methyl-accepting chemotaxis protein', 177, NULL, NULL, 84536),
(84537, '2.30.180.10-FF-000121', NULL, NULL, 149, NULL, NULL, 84537),
(84538, '3.40.50.200-FF-000051', NULL, 'Uncharacterized protein', 186, NULL, NULL, 84538),
(84539, '3.30.200.20-FF-000640', NULL, 'Protein kinase, putative', 94, NULL, NULL, 84539),
(84540, '3.40.50.10180-FF-000002', NULL, 'glycerate kinase isoform X2', 132, NULL, NULL, 84540),
(84541, '3.10.105.10-FF-000049', NULL, 'Peptide ABC transporter substrate-binding protein', 218, NULL, NULL, 84541),
(84542, '3.40.50.1820-FF-000614', NULL, 'CG14717 protein', 286, NULL, NULL, 84542),
(84543, '3.40.50.10870-FF-000001', NULL, 'Beta-glucosidase', 159, NULL, NULL, 84543),
(84544, '2.30.130.40-FF-000037', NULL, 'Lon protease homolog, mitochondrial', 110, NULL, NULL, 84544),
(84545, '3.60.10.10-FF-000138', NULL, 'Carbon catabolite repressor protein 4 homolog 6', 157, NULL, NULL, 84545),
(84546, '3.30.70.330-FF-001557', NULL, NULL, 66, NULL, NULL, 84546),
(84547, '2.60.120.10-FF-000285', NULL, '1,2-dihydroxy-3-keto-5-methylthiopentene dioxygenase', 184, NULL, NULL, 84547),
(84548, '3.40.50.1980-FF-000145', NULL, 'Periplasmic binding protein', 169, NULL, NULL, 84548),
(84549, '3.30.200.20-FF-000112', NULL, 'Lectin-domain containing receptor kinase A4.3', 92, NULL, NULL, 84549),
(84550, '1.20.1070.10-FF-000629', NULL, 'G protein-coupled receptor 171', 304, NULL, NULL, 84550),
(84551, '3.30.1370.150-FF-000001', NULL, 'YibL family ribosome-associated protein', 60, NULL, NULL, 84551),
(84552, '3.30.160.60-FF-003739', NULL, NULL, 28, NULL, NULL, 84552),
(84553, '1.20.1310.10-FF-000109', NULL, NULL, 117, NULL, NULL, 84553),
(84554, '2.60.40.10-FF-002750', NULL, 'Seminal vesicle antigen-like 2', 116, NULL, NULL, 84554),
(84555, '1.20.1090.10-FF-000052', NULL, 'Bifunctional shikimate kinase/3-dehydroquinate synthase', 178, NULL, NULL, 84555),
(84556, '3.40.532.10-FF-000029', NULL, NULL, 67, NULL, NULL, 84556),
(84557, '3.40.50.800-FF-000135', NULL, 'Uncharacterized protein', 114, NULL, NULL, 84557),
(84558, '3.30.160.60-FF-006089', NULL, NULL, 25, NULL, NULL, 84558),
(84559, '1.10.274.30-FF-000011', NULL, 'Dosage compensation regulatory complex protein, putative', 171, NULL, NULL, 84559),
(84560, '1.10.510.10-FF-002893', NULL, NULL, 112, NULL, NULL, 84560),
(84561, '3.40.50.12760-FF-000006', NULL, 'Methyltransferase, putative', 393, NULL, NULL, 84561),
(84562, '1.25.40.10-FF-000720', NULL, 'Pre-mRNA-splicing factor SYF1', 185, NULL, NULL, 84562),
(84563, '3.40.50.1220-FF-000002', NULL, 'NAD(P) transhydrogenase subunit beta', 179, NULL, NULL, 84563),
(84564, '3.40.30.10-FF-000691', NULL, 'Monothiol glutaredoxin-S17', 87, NULL, NULL, 84564),
(84565, '3.40.50.300-FF-003925', NULL, 'Uncharacterized protein', 190, NULL, NULL, 84565),
(84566, '3.10.20.90-FF-000030', NULL, 'Apoptosis-stimulating of p53 protein 2 isoform 1', 83, NULL, NULL, 84566),
(84567, '1.10.400.10-FF-000030', NULL, 'Guanine nucleotide-binding protein alpha-8 subunit', 119, NULL, NULL, 84567),
(84568, '2.60.40.10-FF-002042', NULL, 'Muscle M-line assembly protein unc-89', 95, NULL, NULL, 84568),
(84569, '3.30.200.20-FF-000820', NULL, 'Cyclin-dependent kinase-like 1', 31, NULL, NULL, 84569),
(84570, '3.90.70.10-FF-000135', NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit pan2', 384, NULL, NULL, 84570);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(84571, '3.30.160.60-FF-003924', NULL, 'REgulator of Fusion', 72, NULL, NULL, 84571),
(84572, '3.30.420.10-FF-000558', NULL, NULL, 58, NULL, NULL, 84572),
(84573, '3.30.1380.20-FF-000045', NULL, 'Uncharacterized protein C13G6.05c', 163, NULL, NULL, 84573),
(84574, '2.30.110.10-FF-000078', NULL, 'Flavin reductase', 168, NULL, NULL, 84574),
(84575, '3.30.70.890-FF-000067', NULL, 'Uncharacterized protein', 124, NULL, NULL, 84575),
(84576, '3.30.470.10-FF-000038', NULL, 'Slr0887 protein', 116, NULL, NULL, 84576),
(84577, '1.10.150.190-FF-000005', NULL, 'Eukaryotic translation initiation factor 2 subunit alpha, putative', 86, NULL, NULL, 84577),
(84578, '2.60.40.3110-FF-000003', NULL, 'Outer membrane usher protein FasD', 88, NULL, NULL, 84578),
(84579, '1.10.720.30-FF-000060', NULL, 'Poly [ADP-ribose] polymerase 2', 70, NULL, NULL, 84579),
(84580, '3.60.21.10-FF-000366', NULL, 'Uncharacterized protein', 129, NULL, NULL, 84580),
(84581, '3.30.70.330-FF-001613', NULL, NULL, 157, NULL, NULL, 84581),
(84582, '1.50.10.10-FF-000008', NULL, 'alpha-1,2-Mannosidase', 470, NULL, NULL, 84582),
(84583, '2.130.10.10-FF-002166', NULL, 'Damage-specific DNA binding protein 2', 325, NULL, NULL, 84583),
(84584, '3.30.160.60-FF-004200', NULL, NULL, 52, NULL, NULL, 84584),
(84585, '2.40.50.140-FF-000082', NULL, 'DNA helicase MCM8 isoform X1', 79, NULL, NULL, 84585),
(84586, '3.40.630.30-FF-000061', NULL, 'N(alpha)-acetyltransferase 80, NatH catalytic subunit', 133, NULL, NULL, 84586),
(84587, '1.10.1420.10-FF-000069', NULL, 'Mismatch repair protein MSH3, putative', 127, NULL, NULL, 84587),
(84588, '4.10.410.10-FF-000125', NULL, 'Uncharacterized protein', 36, NULL, NULL, 84588),
(84589, '2.60.40.3800-FF-000002', NULL, 'Lys-gingipain W83', 208, NULL, NULL, 84589),
(84590, '3.30.70.330-FF-002541', NULL, NULL, 44, NULL, NULL, 84590),
(84591, '3.90.550.50-FF-000072', NULL, 'Hexosyltransferase', 218, NULL, NULL, 84591),
(84592, '3.40.50.1110-FF-000025', NULL, 'Lipolytic enzyme G-D-S-L family', 216, NULL, NULL, 84592),
(84593, '1.20.1270.60-FF-000171', NULL, 'Rho GTPase-activating protein 10', 101, NULL, NULL, 84593),
(84594, '1.20.1250.20-FF-000023', NULL, 'Solute carrier family 22 member 6', 409, NULL, NULL, 84594),
(84595, '3.30.450.20-FF-000484', NULL, 'Histidine kinase', 130, NULL, NULL, 84595),
(84596, '3.30.70.330-FF-002013', NULL, NULL, 73, NULL, NULL, 84596),
(84597, '3.90.70.10-FF-000843', NULL, 'Uncharacterized protein', 124, NULL, NULL, 84597),
(84598, '1.10.238.10-FF-000843', NULL, 'Penta-EF-hand domain containing 1', 76, NULL, NULL, 84598),
(84599, '1.10.10.980-FF-000004', NULL, 'CST complex subunit STN1', 101, NULL, NULL, 84599),
(84600, '2.60.220.50-FF-000158', NULL, 'Uncharacterized protein', 162, NULL, NULL, 84600),
(84601, '3.80.10.10-FF-000244', NULL, 'Monocyte differentiation antigen CD14', 307, NULL, NULL, 84601),
(84602, '1.20.120.1900-FF-000073', NULL, 'Gamma-tubulin complex component', 292, NULL, NULL, 84602),
(84603, '3.30.40.10-FF-001434', NULL, 'SWI/SNF family DNA-dependent ATPase, putative', 74, NULL, NULL, 84603),
(84604, '3.80.30.20-FF-000012', NULL, 'Coproporphyrinogen-III oxidase', 222, NULL, NULL, 84604),
(84605, '2.60.40.10-FF-002565', NULL, 'CD4', 105, NULL, NULL, 84605),
(84606, '2.130.10.130-FF-000009', NULL, 'Alpha L integrin', 235, NULL, NULL, 84606),
(84607, '3.40.630.30-FF-000622', NULL, 'Uncharacterized N-acetyltransferase C18E5.08', 184, NULL, NULL, 84607),
(84608, '1.20.272.10-FF-000021', NULL, 'Replication factor C subunit 1', 109, NULL, NULL, 84608),
(84609, '2.40.50.1060-FF-000005', NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', 226, NULL, NULL, 84609),
(84610, '3.10.490.10-FF-000027', NULL, 'Gamma-glutamylcyclotransferase', 231, NULL, NULL, 84610),
(84611, '2.120.10.30-FF-000368', NULL, 'Uncharacterized protein', 140, NULL, NULL, 84611),
(84612, '3.30.9.10-FF-000092', NULL, 'Aklavinone 12-hydroxylase RdmE', 145, NULL, NULL, 84612),
(84613, '1.25.40.10-FF-004407', NULL, 'Uncharacterized protein', 134, NULL, NULL, 84613),
(84614, '3.50.50.60-FF-001499', NULL, 'Uncharacterized protein', 36, NULL, NULL, 84614);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(84615, '3.40.30.10-FF-001000', NULL, 'Uncharacterized protein', 74, NULL, NULL, 84615),
(84616, '3.30.2350.20-FF-000038', NULL, NULL, 80, NULL, NULL, 84616),
(84617, '1.10.510.10-FF-003854', NULL, NULL, 102, NULL, NULL, 84617),
(84618, '3.30.70.1020-FF-000012', NULL, NULL, 80, NULL, NULL, 84618),
(84619, '3.40.630.150-FF-000026', NULL, 'Uncharacterized protein', 314, NULL, NULL, 84619),
(84620, '6.10.140.2220-FF-000063', NULL, 'Uncharacterized protein', 58, NULL, NULL, 84620),
(84621, '3.40.50.410-FF-000288', NULL, 'Inverted repeat-binding protein', 206, NULL, NULL, 84621),
(84622, '1.50.40.10-FF-000364', NULL, 'Related to folate transporter/carrier (Mitochondrial)', 156, NULL, NULL, 84622),
(84623, '1.10.10.830-FF-000010', NULL, 'Isoleucine--tRNA ligase', 53, NULL, NULL, 84623),
(84624, '3.30.420.10-FF-000182', NULL, 'YDR514C-like protein', 206, NULL, NULL, 84624),
(84625, '3.10.350.10-FF-000012', NULL, 'Membrane-bound lytic murein transglycosylase D', 47, NULL, NULL, 84625),
(84626, '1.10.150.240-FF-000099', NULL, 'Putative pseudouridine-5''-monophosphatase-like Protein', 68, NULL, NULL, 84626),
(84627, '1.10.1060.10-FF-000030', NULL, 'Heterodisulfide oxidoreductase, iron-sulfur cluster-binding subunit D', 119, NULL, NULL, 84627),
(84628, '3.40.80.10-FF-000019', NULL, 'GD14168', 180, NULL, NULL, 84628),
(84629, '3.40.720.10-FF-000258', NULL, 'Uncharacterized protein', 60, NULL, NULL, 84629),
(84630, '3.40.50.300-FF-002964', NULL, 'ATP-dependent helicase SGS1, putative', 235, NULL, NULL, 84630),
(84631, '3.90.1750.10-FF-000023', NULL, 'probable E3 ubiquitin-protein ligase HECTD2 isoform X2', 149, NULL, NULL, 84631),
(84632, '3.10.20.90-FF-000406', NULL, 'Putative conserved membrane protein', 72, NULL, NULL, 84632),
(84633, '1.20.58.60-FF-000191', NULL, 'Spectrin, beta, non-erythrocytic 5', 121, NULL, NULL, 84633),
(84634, '2.30.29.30-FF-000988', NULL, 'Rho GTPase-activating protein 20', 174, NULL, NULL, 84634),
(84635, '2.60.40.10-FF-005999', NULL, NULL, 68, NULL, NULL, 84635),
(84636, '3.40.50.11840-FF-000005', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 2', 96, NULL, NULL, 84636),
(84637, '1.10.506.10-FF-000022', NULL, 'neurofibromin isoform X1', 18, NULL, NULL, 84637),
(84638, '3.30.1330.30-FF-000135', NULL, 'Uncharacterized protein', 89, NULL, NULL, 84638),
(84639, '1.10.287.130-FF-000003', NULL, 'Histidine kinase', 99, NULL, NULL, 84639),
(84640, '3.30.1010.10-FF-000105', NULL, 'Predicted protein', 112, NULL, NULL, 84640),
(84641, '3.40.50.1000-FF-000195', NULL, 'SDT1p Pyrimidine nucleotidase', 155, NULL, NULL, 84641),
(84642, '3.30.70.1450-FF-000023', NULL, 'Trk system potassium uptake protein TrkA', 81, NULL, NULL, 84642),
(84643, '1.10.565.10-FF-000119', NULL, 'Nuclear hormone receptor family member nhr-121', 250, NULL, NULL, 84643),
(84644, '1.10.246.90-FF-000020', NULL, 'Uncharacterized protein', 91, NULL, NULL, 84644),
(84645, '2.30.29.30-FF-001264', NULL, 'Predicted protein', 103, NULL, NULL, 84645),
(84646, '3.40.50.1100-FF-000112', NULL, '1-aminocyclopropane-1-carboxylate deaminase', 168, NULL, NULL, 84646),
(84647, '3.40.50.1000-FF-000380', NULL, 'CTD small phosphatase-like protein isoform X3', 118, NULL, NULL, 84647),
(84648, '1.10.510.10-FF-003146', NULL, NULL, 180, NULL, NULL, 84648),
(84649, '3.40.30.10-FF-000539', NULL, 'GH08893p', 107, NULL, NULL, 84649),
(84650, '3.40.630.30-FF-000437', NULL, 'Acetyltransferase', 87, NULL, NULL, 84650),
(84651, '3.30.930.10-FF-000265', NULL, 'Phenylalanine--tRNA ligase beta subunit', 203, NULL, NULL, 84651),
(84652, '2.60.40.60-FF-000410', NULL, 'Cadherin-4', 99, NULL, NULL, 84652),
(84653, '1.20.1280.50-FF-000039', NULL, 'F-box and WD repeat domain containing 10', 44, NULL, NULL, 84653),
(84654, '3.90.1100.10-FF-000014', NULL, 'DNA-directed RNA polymerase subunit beta', 167, NULL, NULL, 84654),
(84655, '3.90.1170.50-FF-000013', NULL, 'Nicotinate dehydrogenase subunit B', 93, NULL, NULL, 84655),
(84656, '1.10.510.10-FF-000476', NULL, 'PAS domain-containing protein tyrosine kinase family protein', 192, NULL, NULL, 84656);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(84657, '3.40.50.1820-FF-000878', NULL, 'Uncharacterized protein', 370, NULL, NULL, 84657),
(84658, '3.30.160.60-FF-005369', NULL, NULL, 55, NULL, NULL, 84658),
(84659, '3.90.340.10-FF-000010', NULL, 'Inducible nitric oxide synthase', 95, NULL, NULL, 84659),
(84660, '1.20.1730.10-FF-000129', NULL, 'Uncharacterized protein', 47, NULL, NULL, 84660),
(84661, '2.30.310.10-FF-000008', NULL, 'Uncharacterized protein', 152, NULL, NULL, 84661),
(84662, '3.10.110.10-FF-000202', NULL, 'YALI0E29601p', 103, NULL, NULL, 84662),
(84663, '1.10.150.20-FF-000119', NULL, 'GM24241', 54, NULL, NULL, 84663),
(84664, '3.40.50.300-FF-004701', NULL, 'Uncharacterized protein', 240, NULL, NULL, 84664),
(84665, '3.90.1520.10-FF-000006', NULL, 'guanylate cyclase soluble subunit beta-2-like', 189, NULL, NULL, 84665),
(84666, '3.90.70.10-FF-000287', NULL, 'Ubiquitin specific peptidase 37', 336, NULL, NULL, 84666),
(84667, '1.25.40.10-FF-004082', NULL, 'Hepatocellular carcinoma-associated antigen, putative', 156, NULL, NULL, 84667),
(84668, '3.30.160.20-FF-000052', NULL, 'Peptide chain release factor H', 79, NULL, NULL, 84668),
(84669, '3.60.40.10-FF-000090', NULL, 'Protein phosphatase 2C', 291, NULL, NULL, 84669),
(84670, '1.20.1250.20-FF-001725', NULL, 'Chromosome 23, whole genome shotgun sequence', 352, NULL, NULL, 84670),
(84671, '1.10.246.10-FF-000007', NULL, 'Vitamin D-binding protein', 107, NULL, NULL, 84671),
(84672, '2.60.40.10-FF-001558', NULL, 'Immunoglobulin superfamily member 22', 98, NULL, NULL, 84672),
(84673, '3.90.840.10-FF-000003', NULL, 'Thiol-activated cytolysin', 175, NULL, NULL, 84673),
(84674, '2.60.40.10-FF-005892', NULL, NULL, 94, NULL, NULL, 84674),
(84675, '1.10.246.170-FF-000001', NULL, 'Mrpl8p', 85, NULL, NULL, 84675),
(84676, '1.10.3460.10-FF-000038', NULL, 'Early light-inducible protein', 58, NULL, NULL, 84676),
(84677, '1.10.1660.10-FF-000019', NULL, 'Transcriptional regulator MerR family', 122, NULL, NULL, 84677),
(84678, '4.10.280.10-FF-000215', NULL, 'HER-2 protein', 48, NULL, NULL, 84678),
(84679, '3.20.20.70-FF-000462', NULL, 'Multifunctional fusion protein', 241, NULL, NULL, 84679),
(84680, '3.30.565.10-FF-000500', NULL, 'Uncharacterized protein', 129, NULL, NULL, 84680),
(84681, '3.30.160.60-FF-001154', NULL, 'zinc finger and BTB domain-containing protein 40', 28, NULL, NULL, 84681),
(84682, '4.10.1130.20-FF-000008', NULL, 'CHORD, putative', 71, NULL, NULL, 84682),
(84683, '3.40.140.10-FF-000287', NULL, 'Uncharacterized protein', 40, NULL, NULL, 84683),
(84684, '3.30.930.10-FF-000001', NULL, 'Lysine--tRNA ligase', 346, NULL, NULL, 84684),
(84685, '2.40.50.140-FF-000722', NULL, NULL, 69, NULL, NULL, 84685),
(84686, '3.30.1490.190-FF-000028', NULL, 'Ferric uptake regulation protein', 57, NULL, NULL, 84686),
(84687, '3.40.50.1000-FF-000228', NULL, 'NIF domain protein', 213, NULL, NULL, 84687),
(84688, '3.40.50.800-FF-000074', NULL, 'Proline--tRNA ligase', 111, NULL, NULL, 84688),
(84689, '3.30.565.10-FF-000388', NULL, 'Uncharacterized protein', 137, NULL, NULL, 84689),
(84690, '3.40.50.300-FF-008012', NULL, 'DNA polymerase theta', 142, NULL, NULL, 84690),
(84691, '1.20.58.390-FF-000248', NULL, 'Uncharacterized protein', 117, NULL, NULL, 84691),
(84692, '3.30.230.120-FF-000025', NULL, NULL, 85, NULL, NULL, 84692),
(84693, '1.20.1310.10-FF-000137', NULL, NULL, 114, NULL, NULL, 84693),
(84694, '3.90.760.10-FF-000002', NULL, 'NADPH-dependent 2,4-dienoyl-CoA reductase, sulfur reductase', 68, NULL, NULL, 84694),
(84695, '1.20.1640.10-FF-000010', NULL, 'NPC intracellular cholesterol transporter 1', 203, NULL, NULL, 84695),
(84696, '3.60.20.40-FF-000035', NULL, 'Os01g0151500 protein', 110, NULL, NULL, 84696),
(84697, '1.25.40.20-FF-000869', NULL, 'Uncharacterized protein', 106, NULL, NULL, 84697),
(84698, '1.10.20.10-FF-000073', NULL, 'Histone H4', 62, NULL, NULL, 84698),
(84699, '2.70.98.20-FF-000025', NULL, 'Amine oxidase', 328, NULL, NULL, 84699),
(84700, '3.30.160.60-FF-004931', NULL, NULL, 32, NULL, NULL, 84700),
(84701, '1.10.1420.10-FF-000125', NULL, 'DNA mismatch repair protein mutS', 94, NULL, NULL, 84701);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(84702, '2.40.50.140-FF-001178', NULL, NULL, 91, NULL, NULL, 84702),
(84703, '3.40.50.1460-FF-000074', NULL, 'Uncharacterized protein', 99, NULL, NULL, 84703),
(84704, '1.10.287.660-FF-000038', NULL, 'Vacuolar protein sorting-associated protein 37B-like Protein', 59, NULL, NULL, 84704),
(84705, '1.10.10.10-FF-001668', NULL, 'DDRGK domain containing protein, putative', 48, NULL, NULL, 84705),
(84706, '3.30.70.1170-FF-000006', NULL, 'NOL1/NOP2/Sun domain family protein', 80, NULL, NULL, 84706),
(84707, '1.10.560.10-FF-000136', NULL, 'T-complex protein 1 subunit alpha', 108, NULL, NULL, 84707),
(84708, '1.10.3860.10-FF-000035', NULL, 'Uncharacterized protein', 477, NULL, NULL, 84708),
(84709, '3.90.1600.10-FF-000007', NULL, 'DNA polymerase', 154, NULL, NULL, 84709),
(84710, '1.10.274.20-FF-000002', NULL, NULL, 112, NULL, NULL, 84710),
(84711, '2.130.10.10-FF-003678', NULL, 'Uncharacterized protein', 251, NULL, NULL, 84711),
(84712, '3.10.100.10-FF-000325', NULL, NULL, 182, NULL, NULL, 84712),
(84713, '2.130.10.10-FF-000013', NULL, 'semaphorin-6D isoform X2', 495, NULL, NULL, 84713),
(84714, '3.40.50.2300-FF-001360', NULL, NULL, 25, NULL, NULL, 84714),
(84715, '2.40.170.20-FF-000071', NULL, 'SusC homolog', 686, NULL, NULL, 84715),
(84716, '3.90.550.10-FF-000195', NULL, 'Polypeptide N-acetylgalactosaminyltransferase like 6', 135, NULL, NULL, 84716),
(84717, '2.60.40.10-FF-002126', NULL, 'Predicted protein', 83, NULL, NULL, 84717),
(84718, '3.30.70.20-FF-000011', NULL, 'Ferredoxin', 81, NULL, NULL, 84718),
(84719, '4.10.400.10-FF-000304', NULL, 'Uncharacterized protein', 40, NULL, NULL, 84719),
(84720, '1.20.144.10-FF-000004', NULL, 'Undecaprenyl pyrophosphate phosphatase', 93, NULL, NULL, 84720),
(84721, '1.20.1110.10-FF-000077', NULL, 'ECA1 (ER-TYPE CA2+-ATPASE 1)', 255, NULL, NULL, 84721),
(84722, '3.40.50.720-FF-001218', NULL, 'Hypothetical_protein_-_conserved', 180, NULL, NULL, 84722),
(84723, '3.40.50.1010-FF-000118', NULL, 'Expressed protein', 154, NULL, NULL, 84723),
(84724, '1.20.1270.10-FF-000049', NULL, 'Heat shock protein, putative', 74, NULL, NULL, 84724),
(84725, '1.10.3720.10-FF-000137', NULL, 'sn-glycerol-3-phosphate transport system permease protein UgpE', 271, NULL, NULL, 84725),
(84726, '1.25.40.10-FF-005279', NULL, 'Uncharacterized protein', 315, NULL, NULL, 84726),
(84727, '2.60.40.10-FF-004431', NULL, NULL, 91, NULL, NULL, 84727),
(84728, '2.30.29.30-FF-000275', NULL, 'Docking protein 7', 110, NULL, NULL, 84728),
(84729, '3.40.50.2300-FF-000803', NULL, NULL, 137, NULL, NULL, 84729),
(84730, '1.25.40.10-FF-001968', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 87, NULL, NULL, 84730),
(84731, '3.30.420.10-FF-000294', NULL, NULL, 50, NULL, NULL, 84731),
(84732, '3.40.50.2000-FF-000871', NULL, 'Uncharacterized protein', 195, NULL, NULL, 84732),
(84733, '3.40.50.720-FF-001606', NULL, 'YALI0E28182p', 345, NULL, NULL, 84733),
(84734, '1.10.510.10-FF-000425', NULL, 'Serine/threonine-protein kinase SRPK', 276, NULL, NULL, 84734),
(84735, '1.25.40.10-FF-004470', NULL, 'Putative pentatricopeptide repeat-containing protein At5g40405', 107, NULL, NULL, 84735),
(84736, '1.25.10.10-FF-001769', NULL, 'Uncharacterized protein', 926, NULL, NULL, 84736),
(84737, '2.160.20.10-FF-000215', NULL, 'Nitrous oxide maturation protein NosD', 326, NULL, NULL, 84737),
(84738, '2.130.10.30-FF-000019', NULL, 'alsin isoform X1', 244, NULL, NULL, 84738),
(84739, '2.60.120.10-FF-000280', NULL, 'Crp/Fnr family transcriptional regulator', 196, NULL, NULL, 84739),
(84740, '3.40.50.10860-FF-000060', NULL, 'Uncharacterized protein', 98, NULL, NULL, 84740),
(84741, '1.10.3180.10-FF-000005', NULL, 'Os07g0223600 protein', 137, NULL, NULL, 84741),
(84742, '2.60.40.10-FF-002918', NULL, 'Uncharacterized protein', 99, NULL, NULL, 84742),
(84743, '3.40.50.150-FF-000401', NULL, 'Fatty acid synthase', 279, NULL, NULL, 84743),
(84744, '3.40.50.620-FF-000497', NULL, 'Probable valine--tRNA ligase, mitochondrial', 244, NULL, NULL, 84744),
(84745, '3.10.28.10-FF-000018', NULL, 'Intron-encoded DNA endonuclease I-AniI', 134, NULL, NULL, 84745);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(84746, '2.130.10.10-FF-000805', NULL, 'Myosin C', 300, NULL, NULL, 84746),
(84747, '2.60.40.150-FF-000685', NULL, 'Phosphoinositide phospholipase C', 115, NULL, NULL, 84747),
(84748, '1.20.1280.50-FF-000191', NULL, 'Uncharacterized protein', 68, NULL, NULL, 84748),
(84749, '2.60.40.60-FF-000702', NULL, 'Cdh-4', 102, NULL, NULL, 84749),
(84750, '1.20.1070.10-FF-000101', NULL, 'Prostaglandin E2 receptor EP4 subtype', 328, NULL, NULL, 84750),
(84751, '3.30.200.20-FF-000932', NULL, 'Serine/threonine-protein kinase RIO1', 99, NULL, NULL, 84751),
(84752, '2.40.10.10-FF-000670', NULL, NULL, 44, NULL, NULL, 84752),
(84753, '2.120.10.30-FF-000109', NULL, 'Dipeptidyl-peptidase 5', 230, NULL, NULL, 84753),
(84754, '2.60.40.10-FF-004482', NULL, NULL, 54, NULL, NULL, 84754),
(84755, '3.40.50.300-FF-006146', NULL, 'RAB42, member RAS oncogene family', 109, NULL, NULL, 84755),
(84756, '4.10.1000.10-FF-000018', NULL, 'Zinc finger protein', 36, NULL, NULL, 84756),
(84757, '1.25.40.10-FF-001097', NULL, 'Pentatricopeptide repeat-containing protein At4g22760', 207, NULL, NULL, 84757),
(84758, '2.10.220.10-FF-000130', NULL, 'Proprotein convertase subtilisin/kexin type 5', 68, NULL, NULL, 84758),
(84759, '3.20.20.100-FF-000076', NULL, 'Galactose dehydrogenase', 323, NULL, NULL, 84759),
(84760, '3.30.70.330-FF-001636', NULL, NULL, 123, NULL, NULL, 84760),
(84761, '3.80.10.10-FF-003706', NULL, 'Uncharacterized protein', 158, NULL, NULL, 84761),
(84762, '3.40.50.1820-FF-001834', NULL, 'Os11g0468300 protein', 84, NULL, NULL, 84762),
(84763, '3.90.1440.10-FF-000005', NULL, 'Protein translocase subunit SecA', 70, NULL, NULL, 84763),
(84764, '1.10.10.1940-FF-000017', NULL, NULL, 46, NULL, NULL, 84764),
(84765, '2.60.40.10-FF-000148', NULL, 'titin isoform X1', 90, NULL, NULL, 84765),
(84766, '3.60.21.10-FF-000130', NULL, 'Serine/threonine-protein phosphatase', 304, NULL, NULL, 84766),
(84767, '1.20.1720.10-FF-000011', NULL, 'Transporter, major facilitator family', 241, NULL, NULL, 84767),
(84768, '2.60.40.820-FF-000021', NULL, 'T-box transcription factor Ci-Tbx15/18/22', 213, NULL, NULL, 84768),
(84769, '1.10.565.10-FF-000063', NULL, 'Hormone receptor 83', 164, NULL, NULL, 84769),
(84770, '2.60.120.430-FF-000036', NULL, 'Putative receptor-like protein kinase', 112, NULL, NULL, 84770),
(84771, '3.30.420.210-FF-000016', NULL, 'Uncharacterized protein', 69, NULL, NULL, 84771),
(84772, '1.20.1420.30-FF-000005', NULL, 'sodium/potassium/calcium exchanger 3 isoform X1', 194, NULL, NULL, 84772),
(84773, '3.10.290.70-FF-000018', NULL, NULL, 89, NULL, NULL, 84773),
(84774, '1.25.10.10-FF-002337', NULL, 'Uncharacterized protein', 293, NULL, NULL, 84774),
(84775, '3.30.160.60-FF-006325', NULL, NULL, 25, NULL, NULL, 84775),
(84776, '1.25.40.10-FF-004823', NULL, 'Uncharacterized protein', 150, NULL, NULL, 84776),
(84777, '1.10.1580.10-FF-000018', NULL, 'Guanine nucleotide-binding protein-like 3', 86, NULL, NULL, 84777),
(84778, '2.30.30.140-FF-000147', NULL, 'Transcription elongation factor-like protein', 106, NULL, NULL, 84778),
(84779, '2.130.10.10-FF-004116', NULL, 'Predicted protein', 189, NULL, NULL, 84779),
(84780, '3.30.420.40-FF-000578', NULL, 'Actin', 159, NULL, NULL, 84780),
(84781, '3.30.70.330-FF-000276', NULL, 'Splicing factor, CC1-like protein', 100, NULL, NULL, 84781),
(84782, '3.30.450.30-FF-000077', NULL, 'Uncharacterized protein', 117, NULL, NULL, 84782),
(84783, '3.40.50.2020-FF-000085', NULL, 'Related to ribose-phosphate pyrophosphokinase II', 69, NULL, NULL, 84783),
(84784, '3.80.10.10-FF-002397', NULL, 'F-box/LRR-repeat protein 20', 80, NULL, NULL, 84784),
(84785, '3.90.420.10-FF-000011', NULL, 'Predicted protein', 257, NULL, NULL, 84785),
(84786, '1.10.3260.10-FF-000006', NULL, 'DNA ligase', 272, NULL, NULL, 84786),
(84787, '2.120.10.30-FF-000048', NULL, 'Protein strictosidine synthase-like 10', 310, NULL, NULL, 84787),
(84788, '4.10.950.10-FF-000008', NULL, NULL, 45, NULL, NULL, 84788),
(84789, '2.130.10.10-FF-002430', NULL, 'Uncharacterized protein', 417, NULL, NULL, 84789),
(84790, '1.25.40.10-FF-002053', NULL, 'tonsoku-like protein', 161, NULL, NULL, 84790);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(84791, '3.40.50.150-FF-000452', NULL, 'tRNA m5C-methyltransferase', 130, NULL, NULL, 84791),
(84792, '3.40.50.150-FF-001862', NULL, NULL, 220, NULL, NULL, 84792),
(84793, '3.30.40.10-FF-001350', NULL, 'Vacuolar segregation protein, putative', 88, NULL, NULL, 84793),
(84794, '1.25.40.10-FF-004874', NULL, 'Uncharacterized protein', 109, NULL, NULL, 84794),
(84795, '3.30.420.510-FF-000016', NULL, 'Uncharacterized protein', 133, NULL, NULL, 84795),
(84796, '3.30.420.270-FF-000006', NULL, 'Biopolymer transporter ExbD', 70, NULL, NULL, 84796),
(84797, '3.30.460.10-FF-000156', NULL, 'Uncharacterized protein', 52, NULL, NULL, 84797),
(84798, '3.10.100.10-FF-000437', NULL, NULL, 63, NULL, NULL, 84798),
(84799, '3.20.20.330-FF-000009', NULL, 'Bifunctional homocysteine S-methyltransferase/5,10-methylenetetrahydrofolate reductase', 293, NULL, NULL, 84799),
(84800, '3.20.20.100-FF-000025', NULL, 'NADP(+)-dependent glycerol dehydrogenase', 321, NULL, NULL, 84800),
(84801, '1.10.472.10-FF-000550', NULL, 'Uncharacterized protein', 74, NULL, NULL, 84801),
(84802, '1.10.287.1490-FF-000125', NULL, 'Uncharacterized protein', 200, NULL, NULL, 84802),
(84803, '2.40.170.20-FF-000020', NULL, 'TonB-dependent receptor', 602, NULL, NULL, 84803),
(84804, '1.20.140.10-FF-000119', NULL, 'Uncharacterized protein', 53, NULL, NULL, 84804),
(84805, '2.40.128.600-FF-000001', NULL, 'Penicillin-binding protein 4', 102, NULL, NULL, 84805),
(84806, '1.25.40.180-FF-000266', NULL, NULL, 211, NULL, NULL, 84806),
(84807, '1.20.5.690-FF-000007', NULL, 'Importin subunit alpha', 42, NULL, NULL, 84807),
(84808, '1.10.3720.10-FF-000025', NULL, 'Dipeptide ABC transporter permease DppB', 202, NULL, NULL, 84808),
(84809, '2.60.120.330-FF-000220', NULL, 'Uncharacterized protein', 68, NULL, NULL, 84809),
(84810, '3.40.850.10-FF-000526', NULL, 'Kinesin like protein KLP-13', 95, NULL, NULL, 84810),
(84811, '3.40.50.880-FF-000092', NULL, 'Putative carbamoyl-phosphate synthase', 207, NULL, NULL, 84811),
(84812, '3.20.20.80-FF-000740', NULL, 'Iduronidase alpha-L-', 83, NULL, NULL, 84812),
(84813, '4.10.830.40-FF-000008', NULL, 'Probable E3 ubiquitin-protein ligase TRIM8', 79, NULL, NULL, 84813),
(84814, '3.90.230.10-FF-000069', NULL, NULL, 36, NULL, NULL, 84814),
(84815, '1.20.1250.10-FF-000087', NULL, NULL, 164, NULL, NULL, 84815),
(84816, '3.40.50.300-FF-003745', NULL, 'ATP-binding cassette transporter, subfamily B, member 19, group MDR/PGP protein PpABCB19', 25, NULL, NULL, 84816),
(84817, '2.130.10.10-FF-003627', NULL, 'Uncharacterized protein', 213, NULL, NULL, 84817),
(84818, '3.30.505.10-FF-000171', NULL, NULL, 109, NULL, NULL, 84818),
(84819, '2.60.40.10-FF-004543', NULL, NULL, 86, NULL, NULL, 84819),
(84820, '3.40.640.10-FF-000460', NULL, 'Uncharacterized protein', 176, NULL, NULL, 84820),
(84821, '2.160.20.80-FF-000016', NULL, NULL, 133, NULL, NULL, 84821),
(84822, '2.40.128.620-FF-000007', NULL, 'Uncharacterized protein LGR3', 78, NULL, NULL, 84822),
(84823, '2.170.270.10-FF-000230', NULL, 'SET and MYND domain containing, arthropod-specific, member 4, isoform C', 84, NULL, NULL, 84823),
(84824, '1.10.3080.10-FF-000060', NULL, 'Uncharacterized protein', 398, NULL, NULL, 84824),
(84825, '2.40.10.350-FF-000007', NULL, 'Rod shape-determining protein MreC', 51, NULL, NULL, 84825),
(84826, '1.25.10.10-FF-001269', NULL, 'Exportin 5', 513, NULL, NULL, 84826),
(84827, '1.20.920.30-FF-000011', NULL, 'Dynein beta chain, putative', 186, NULL, NULL, 84827),
(84828, '2.130.10.10-FF-004167', NULL, 'Uncharacterized protein', 169, NULL, NULL, 84828),
(84829, '1.10.260.40-FF-000038', NULL, 'HTH-type transcriptional regulator hipB', 88, NULL, NULL, 84829),
(84830, '3.10.110.10-FF-000270', NULL, 'Uncharacterized protein', 142, NULL, NULL, 84830),
(84831, '3.30.1460.50-FF-000010', NULL, 'Hemolysin', 181, NULL, NULL, 84831),
(84832, '2.10.110.10-FF-000301', NULL, 'Uncharacterized protein', 106, NULL, NULL, 84832),
(84833, '3.40.930.10-FF-000027', NULL, 'Anion exchange protein', 332, NULL, NULL, 84833),
(84834, '1.25.40.10-FF-002406', NULL, 'Pentatricopeptide repeat-containing protein At1g28690, mitochondrial', 132, NULL, NULL, 84834);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(84835, '3.30.40.10-FF-000001', NULL, 'chromodomain-helicase-DNA-binding protein 3 isoform X1', 59, NULL, NULL, 84835),
(84836, '1.20.970.10-FF-000036', NULL, 'Anthranilate phosphoribosyltransferase', 69, NULL, NULL, 84836),
(84837, '3.40.50.1820-FF-000474', NULL, 'Carboxylic ester hydrolase', 198, NULL, NULL, 84837),
(84838, '4.10.1080.10-FF-000006', NULL, 'Thrombospondin 3', 55, NULL, NULL, 84838),
(84839, '3.30.70.270-FF-000117', NULL, 'GGDEF family protein', 182, NULL, NULL, 84839),
(84840, '3.40.50.1820-FF-001334', NULL, 'Probable endo-1,4-beta-xylanase Z [precursor]', 253, NULL, NULL, 84840),
(84841, '3.40.50.1820-FF-000766', NULL, 'Acylglycerol lipase', 296, NULL, NULL, 84841),
(84842, '1.10.418.60-FF-000023', NULL, 'Uncharacterized protein', 132, NULL, NULL, 84842),
(84843, '1.20.1070.10-FF-001057', NULL, 'Putative glycoprotein hormone G-protein coupled receptor', 331, NULL, NULL, 84843),
(84844, '3.40.50.2300-FF-000011', NULL, 'Cell cycle response regulator CtrA', 86, NULL, NULL, 84844),
(84845, '2.60.40.1510-FF-000017', NULL, 'Integrin subunit alpha 2', 147, NULL, NULL, 84845),
(84846, '1.25.40.730-FF-000004', NULL, 'Clathrin heavy chain', 97, NULL, NULL, 84846),
(84847, '1.10.10.10-FF-001589', NULL, 'Hydroxyindole O-methyltransferase-like protein', 93, NULL, NULL, 84847),
(84848, '3.40.630.30-FF-000201', NULL, 'NAA30 isoform 1', 103, NULL, NULL, 84848),
(84849, '3.30.930.10-FF-000405', NULL, 'Uncharacterized protein', 88, NULL, NULL, 84849),
(84850, '2.60.40.10-FF-004931', NULL, NULL, 95, NULL, NULL, 84850),
(84851, '3.40.50.300-FF-004622', NULL, 'Ciliary dynein heavy chain 11', 252, NULL, NULL, 84851),
(84852, '1.25.40.20-FF-000026', NULL, 'ankyrin repeat domain-containing protein 17 isoform X3', 109, NULL, NULL, 84852),
(84853, '1.10.238.10-FF-000343', NULL, 'RHBDL3 isoform 3', 136, NULL, NULL, 84853),
(84854, '1.10.1760.10-FF-000004', NULL, 'ARP2/3 complex subunit', 182, NULL, NULL, 84854),
(84855, '3.30.160.60-FF-005448', NULL, NULL, 24, NULL, NULL, 84855),
(84856, '3.50.50.60-FF-000510', NULL, 'Dihydropyrimidine dehydrogenase, putative', 159, NULL, NULL, 84856),
(84857, '3.10.250.10-FF-000133', NULL, NULL, 108, NULL, NULL, 84857),
(84858, '2.60.40.10-FF-002065', NULL, 'Neural cell adhesion molecule 1', 79, NULL, NULL, 84858),
(84859, '4.10.520.10-FF-000010', NULL, 'Integration host factor subunit alpha', 94, NULL, NULL, 84859),
(84860, '2.40.50.140-FF-001099', NULL, NULL, 65, NULL, NULL, 84860),
(84861, '3.10.290.10-FF-000097', NULL, 'Uncharacterized RNA pseudouridine synthase MG209', 55, NULL, NULL, 84861),
(84862, '2.60.120.260-FF-000255', NULL, 'Extracellular serine protease', 130, NULL, NULL, 84862),
(84863, '1.25.10.10-FF-000831', NULL, 'Importin subunit alpha-7, putative', 420, NULL, NULL, 84863),
(84864, '3.30.70.270-FF-000297', NULL, NULL, 58, NULL, NULL, 84864),
(84865, '2.120.10.80-FF-000361', NULL, 'Uncharacterized protein', 259, NULL, NULL, 84865),
(84866, '2.10.110.10-FF-000189', NULL, 'Uncharacterized protein', 62, NULL, NULL, 84866),
(84867, '2.40.155.10-FF-000004', NULL, 'Green fluorescent protein', 145, NULL, NULL, 84867),
(84868, '1.10.510.10-FF-002393', NULL, 'Protein kinase, putative', 235, NULL, NULL, 84868),
(84869, '1.10.10.60-FF-000862', NULL, NULL, 85, NULL, NULL, 84869),
(84870, '2.30.30.40-FF-000298', NULL, 'Rho GTPase-activating protein', 62, NULL, NULL, 84870),
(84871, '3.30.450.20-FF-000692', NULL, 'Putative two-component system sensor kinase/response regulator', 135, NULL, NULL, 84871),
(84872, '1.20.1070.10-FF-000489', NULL, 'Dopamine receptor 3', 143, NULL, NULL, 84872),
(84873, '1.20.58.410-FF-000002', NULL, 'Peptide chain release factor 2', 114, NULL, NULL, 84873),
(84874, '1.10.405.10-FF-000018', NULL, 'Amine oxidase', 92, NULL, NULL, 84874),
(84875, '3.30.470.10-FF-000033', NULL, 'D-amino-acid transaminase', 132, NULL, NULL, 84875),
(84876, '3.30.230.80-FF-000019', NULL, 'Uncharacterized protein', 132, NULL, NULL, 84876),
(84877, '1.10.510.10-FF-003298', NULL, NULL, 85, NULL, NULL, 84877),
(84878, '1.20.120.420-FF-000010', NULL, 'Methylthioribose-1-phosphate isomerase', 158, NULL, NULL, 84878); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(84879, '3.40.50.300-FF-004089', NULL, 'SNF2 domain-containing protein / helicase domain-containing protein / HNH endonuclease domain-containing protein', 244, NULL, NULL, 84879),
(84880, '3.40.50.10140-FF-000018', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', 140, NULL, NULL, 84880),
(84881, '3.40.850.10-FF-000026', NULL, 'Centromere-associated protein E', 357, NULL, NULL, 84881),
(84882, '1.10.1420.10-FF-000193', NULL, 'Uncharacterized protein', 23, NULL, NULL, 84882),
(84883, '3.30.1040.20-FF-000003', NULL, 'Thiol-activated cytolysin', 48, NULL, NULL, 84883),
(84884, '1.10.472.10-FF-000499', NULL, 'Cyclin, cyclin d, cell cycle control', 107, NULL, NULL, 84884),
(84885, '3.30.160.60-FF-001654', NULL, 'Tripartite motif-containing protein 72', 69, NULL, NULL, 84885),
(84886, '1.25.40.10-FF-002457', NULL, 'Superkiller', 150, NULL, NULL, 84886),
(84887, '3.30.505.10-FF-000019', NULL, 'Chimaerin', 104, NULL, NULL, 84887),
(84888, '1.20.1070.10-FF-001006', NULL, 'Predicted protein', 266, NULL, NULL, 84888),
(84889, '3.40.50.300-FF-003341', NULL, 'ADP-ribosylation factor, putative', 164, NULL, NULL, 84889),
(84890, '2.40.30.130-FF-000041', NULL, 'Alanine--tRNA ligase', 102, NULL, NULL, 84890),
(84891, '3.30.390.30-FF-000038', NULL, 'Glutathione reductase', 113, NULL, NULL, 84891),
(84892, '3.30.160.60-FF-001558', NULL, 'Zinc finger protein 569', 27, NULL, NULL, 84892),
(84893, '3.30.40.10-FF-000894', NULL, 'RBR-type E3 ubiquitin transferase', 86, NULL, NULL, 84893),
(84894, '3.10.290.20-FF-000015', NULL, 'Ubiquitin-activating enzyme E1-like', 118, NULL, NULL, 84894),
(84895, '3.30.70.970-FF-000001', NULL, 'Regulator of ribonuclease activity B', 125, NULL, NULL, 84895),
(84896, '1.10.510.10-FF-003702', NULL, NULL, 164, NULL, NULL, 84896),
(84897, '2.30.30.30-FF-000020', NULL, '60S ribosomal protein L6', 84, NULL, NULL, 84897),
(84898, '2.130.10.10-FF-005595', NULL, 'Uncharacterized protein', 196, NULL, NULL, 84898),
(84899, '3.80.10.10-FF-003257', NULL, 'Uncharacterized protein', 171, NULL, NULL, 84899),
(84900, '3.30.160.60-FF-004060', NULL, NULL, 29, NULL, NULL, 84900),
(84901, '3.30.40.10-FF-001462', NULL, 'RING/U-box superfamily protein', 83, NULL, NULL, 84901),
(84902, '3.30.200.20-FF-001837', NULL, NULL, 108, NULL, NULL, 84902),
(84903, '3.90.1170.10-FF-000029', NULL, '60S ribosomal protein L16, mitochondrial', 142, NULL, NULL, 84903),
(84904, '3.30.2000.40-FF-000001', NULL, 'Tail sheath stabilizer and completion', 231, NULL, NULL, 84904),
(84905, '3.80.10.10-FF-001941', NULL, 'Os01g0170300 protein', 127, NULL, NULL, 84905),
(84906, '3.30.70.2740-FF-000005', NULL, 'FAD-binding oxidoreductase', 86, NULL, NULL, 84906),
(84907, '3.30.1370.100-FF-000008', NULL, 'DNA mismatch repair protein MutL', 95, NULL, NULL, 84907),
(84908, '1.25.40.20-FF-000077', NULL, 'Serine/threonine-protein kinase TNNI3K', 124, NULL, NULL, 84908),
(84909, '3.40.800.10-FF-000023', NULL, 'Arginase family protein', 241, NULL, NULL, 84909),
(84910, '3.40.50.720-FF-000729', NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase family protein', 193, NULL, NULL, 84910),
(84911, '1.10.510.10-FF-001853', NULL, 'Protein kinase, putative', 126, NULL, NULL, 84911),
(84912, '3.90.1150.10-FF-000197', NULL, '4-aminobutyrate aminotransferase', 140, NULL, NULL, 84912),
(84913, '3.20.20.140-FF-000301', NULL, 'PHP domain-containing protein', 245, NULL, NULL, 84913),
(84914, '2.60.120.650-FF-000198', NULL, 'Uncharacterized protein', 40, NULL, NULL, 84914),
(84915, '3.30.420.40-FF-000078', NULL, 'Ribulokinase', 373, NULL, NULL, 84915),
(84916, '1.10.630.10-FF-000131', NULL, 'Cytochrome P450 family 722 subfamily A polypeptide 1', 451, NULL, NULL, 84916),
(84917, '1.10.238.200-FF-000015', NULL, 'Defective in cullin neddylation protein', 113, NULL, NULL, 84917),
(84918, '3.40.850.10-FF-000122', NULL, 'Kinesin-like protein, KLP38B', 424, NULL, NULL, 84918),
(84919, '3.30.70.330-FF-002693', NULL, NULL, 259, NULL, NULL, 84919),
(84920, '2.10.25.10-FF-001071', NULL, 'GM24707', 77, NULL, NULL, 84920),
(84921, '3.30.200.20-FF-001449', NULL, 'Serine/threonine protein kinase', 94, NULL, NULL, 84921);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(84922, '2.60.11.10-FF-000019', NULL, 'Uncharacterized protein', 50, NULL, NULL, 84922),
(84923, '2.30.42.10-FF-000182', NULL, 'whirlin isoform X2', 115, NULL, NULL, 84923),
(84924, '1.20.1560.10-FF-000689', NULL, 'Uncharacterized protein', 339, NULL, NULL, 84924),
(84925, '1.20.890.10-FF-000035', NULL, 'Uncharacterized protein', 49, NULL, NULL, 84925),
(84926, '1.10.287.1490-FF-000013', NULL, 'ELKS/RAB6-interacting/CAST family member 2', 172, NULL, NULL, 84926),
(84927, '1.20.120.230-FF-000043', NULL, 'Talin 2', 60, NULL, NULL, 84927),
(84928, '3.60.40.10-FF-000022', NULL, 'probable protein phosphatase 2C 12', 268, NULL, NULL, 84928),
(84929, '1.20.58.1930-FF-000006', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 229, NULL, NULL, 84929),
(84930, '1.10.506.10-FF-000045', NULL, 'Receptor-mediated endocytosis protein 6 homolog', 359, NULL, NULL, 84930),
(84931, '3.60.10.10-FF-000262', NULL, 'Predicted protein', 209, NULL, NULL, 84931),
(84932, '3.30.40.10-FF-002159', NULL, 'Structure-specific endonuclease subunit SLX1 homolog', 72, NULL, NULL, 84932),
(84933, '3.40.50.620-FF-000385', NULL, 'Nicotinamide-nucleotide adenylyltransferase', 236, NULL, NULL, 84933),
(84934, '3.40.50.150-FF-000805', NULL, 'Uncharacterized protein', 182, NULL, NULL, 84934),
(84935, '3.40.630.30-FF-000589', NULL, 'Putative N-acetyltransferase san-like protein', 90, NULL, NULL, 84935),
(84936, '3.40.710.10-FF-000196', NULL, 'Penicillin binding protein 2', 182, NULL, NULL, 84936),
(84937, '2.60.40.10-FF-002626', NULL, 'T cell receptor gamma variable 2', 101, NULL, NULL, 84937),
(84938, '3.30.1490.80-FF-000026', NULL, 'Glutathione synthetase', 62, NULL, NULL, 84938),
(84939, '1.10.510.10-FF-002342', NULL, NULL, 200, NULL, NULL, 84939),
(84940, '2.130.10.10-FF-000873', NULL, 'Microtubule-associated protein ytm1 homologue, putative', 189, NULL, NULL, 84940),
(84941, '3.40.50.300-FF-001828', NULL, 'ras-related protein Rap-1b-like isoform X2', 104, NULL, NULL, 84941),
(84942, '4.10.1240.10-FF-000064', NULL, 'Adhesion G protein-coupled receptor L2', 59, NULL, NULL, 84942),
(84943, '1.10.1520.10-FF-000077', NULL, 'Uncharacterized protein', 111, NULL, NULL, 84943),
(84944, '2.30.29.30-FF-000224', NULL, 'arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 2', 106, NULL, NULL, 84944),
(84945, '3.20.80.10-FF-000037', NULL, 'Uncharacterized protein', 119, NULL, NULL, 84945),
(84946, '3.40.50.300-FF-008063', NULL, 'Uncharacterized protein', 123, NULL, NULL, 84946),
(84947, '2.60.40.150-FF-000393', NULL, 'Os01g0819200 protein', 86, NULL, NULL, 84947),
(84948, '3.40.50.300-FF-007495', NULL, 'DNA mismatch repair protein MutS type 2', 225, NULL, NULL, 84948),
(84949, '3.40.50.800-FF-000023', NULL, 'Threonyl-tRNA synthetase mitochondrial', 123, NULL, NULL, 84949),
(84950, '1.20.1420.30-FF-000073', NULL, 'Vacuolar H+\/Ca2+ exchanger', 100, NULL, NULL, 84950),
(84951, '1.10.287.990-FF-000002', NULL, 'Superoxide dismutase', 62, NULL, NULL, 84951),
(84952, '3.30.160.60-FF-003571', NULL, 'Blast:Zinc finger protein 235', 60, NULL, NULL, 84952),
(84953, '3.90.70.80-FF-000088', NULL, 'Uncharacterized protein', 88, NULL, NULL, 84953),
(84954, '2.40.10.120-FF-000023', NULL, 'Uncharacterized protein', 84, NULL, NULL, 84954),
(84955, '3.40.50.1220-FF-000114', NULL, 'Uncharacterized protein', 108, NULL, NULL, 84955),
(84956, '3.40.50.80-FF-000078', NULL, 'NAD(P)H oxidase', 214, NULL, NULL, 84956),
(84957, '1.25.10.10-FF-002629', NULL, 'Uncharacterized protein', 128, NULL, NULL, 84957),
(84958, '1.10.287.4270-FF-000004', NULL, 'Serine/threonine-protein kinase 3/4', 91, NULL, NULL, 84958),
(84959, '2.130.10.10-FF-004908', NULL, 'Uncharacterized protein', 110, NULL, NULL, 84959),
(84960, '3.30.30.170-FF-000012', NULL, NULL, 83, NULL, NULL, 84960),
(84961, '1.20.120.1760-FF-000036', NULL, 'Uncharacterized protein', 216, NULL, NULL, 84961),
(84962, '3.40.190.290-FF-000046', NULL, 'Malonate utilization transcriptional regulator', 204, NULL, NULL, 84962),
(84963, '1.25.40.10-FF-004531', NULL, 'Signal recognition particle subunit SRP72', 63, NULL, NULL, 84963);
INSERT INTO "PUBLIC"."MODEL" VALUES
(84964, '3.50.30.30-FF-000112', NULL, 'Uncharacterized protein', 18, NULL, NULL, 84964),
(84965, '1.20.5.110-FF-000070', NULL, 'SNARE protein, putative', 58, NULL, NULL, 84965),
(84966, '3.80.10.10-FF-001992', NULL, 'Uncharacterized protein', 95, NULL, NULL, 84966),
(84967, '3.40.50.1000-FF-000751', NULL, NULL, 116, NULL, NULL, 84967),
(84968, '3.10.20.90-FF-000558', NULL, 'AGAP006402-PA', 108, NULL, NULL, 84968),
(84969, '3.90.1200.10-FF-000078', NULL, 'Uncharacterized protein', 168, NULL, NULL, 84969),
(84970, '1.10.555.10-FF-000186', NULL, NULL, 214, NULL, NULL, 84970),
(84971, '1.20.1270.60-FF-000283', NULL, 'Uncharacterized protein', 208, NULL, NULL, 84971),
(84972, '3.30.1360.120-FF-000102', NULL, 'Uncharacterized protein', 77, NULL, NULL, 84972),
(84973, '3.40.50.300-FF-003392', NULL, 'Regulator of nonsense transcripts, putative', 276, NULL, NULL, 84973),
(84974, '1.20.120.850-FF-000054', NULL, 'Uncharacterized protein', 27, NULL, NULL, 84974),
(84975, '3.30.70.141-FF-000046', NULL, NULL, 93, NULL, NULL, 84975),
(84976, '3.40.50.10330-FF-000036', NULL, 'NAD kinase', 17, NULL, NULL, 84976),
(84977, '3.30.160.60-FF-005420', NULL, NULL, 38, NULL, NULL, 84977),
(84978, '2.60.40.10-FF-004190', NULL, NULL, 83, NULL, NULL, 84978),
(84979, '1.20.1560.10-FF-000768', NULL, 'Uncharacterized protein', 367, NULL, NULL, 84979),
(84980, '1.10.10.1050-FF-000003', NULL, 'Decapping enzyme Dcp2, putative', 85, NULL, NULL, 84980),
(84981, '2.60.40.10-FF-003475', NULL, NULL, 98, NULL, NULL, 84981),
(84982, '1.10.630.10-FF-000491', NULL, 'Cytochrome P450 2C31-like', 466, NULL, NULL, 84982),
(84983, '3.60.20.10-FF-000088', NULL, 'Proteasome subunit beta', 218, NULL, NULL, 84983),
(84984, '1.25.40.20-FF-000818', NULL, 'Diego, isoform A', 101, NULL, NULL, 84984),
(84985, '3.80.10.10-FF-002689', NULL, 'Predicted protein', 80, NULL, NULL, 84985),
(84986, '3.10.120.10-FF-000028', NULL, 'Nitrate reductase, putative', 89, NULL, NULL, 84986),
(84987, '1.20.930.10-FF-000039', NULL, 'Transcription elongation factor S-II, putative', 96, NULL, NULL, 84987),
(84988, '1.20.1250.20-FF-001276', NULL, 'Sodium:melibiose symporter', 198, NULL, NULL, 84988),
(84989, '1.10.720.60-FF-000012', NULL, 'Haloacid_dehalogenase-like_hydrolase_-_putative', 88, NULL, NULL, 84989),
(84990, '3.40.50.10480-FF-000002', NULL, 'Ribosome production factor 1', 173, NULL, NULL, 84990),
(84991, '3.40.47.10-FF-000111', NULL, 'Uncharacterized protein', 255, NULL, NULL, 84991),
(84992, '2.20.20.160-FF-000002', NULL, 'Doublesex cognate 73A', 91, NULL, NULL, 84992),
(84993, '2.120.10.80-FF-000310', NULL, 'Multiple epidermal growth factor-like domains protein 8', 178, NULL, NULL, 84993),
(84994, '3.40.50.720-FF-000881', NULL, '2,4-dienoyl-coa reductase-like protein', 98, NULL, NULL, 84994),
(84995, '2.130.10.10-FF-002722', NULL, 'GD22827', 307, NULL, NULL, 84995),
(84996, '1.10.238.10-FF-000904', NULL, 'Glycerol-3-phosphate dehydrogenase', 105, NULL, NULL, 84996),
(84997, '1.10.10.10-FF-000420', NULL, 'RNA polymerase III subunit, putative', 89, NULL, NULL, 84997),
(84998, '3.60.21.10-FF-000051', NULL, 'Serine/threonine-protein phosphatase', 250, NULL, NULL, 84998),
(84999, '2.60.40.10-FF-004835', NULL, NULL, 203, NULL, NULL, 84999),
(85000, '3.40.50.1010-FF-000169', NULL, NULL, 141, NULL, NULL, 85000),
(85001, '3.40.50.1240-FF-000221', NULL, NULL, 294, NULL, NULL, 85001),
(85002, '3.50.50.60-FF-000431', NULL, 'AMine oXidase family', 451, NULL, NULL, 85002),
(85003, '1.25.40.10-FF-004582', NULL, 'Uncharacterized protein', 179, NULL, NULL, 85003),
(85004, '1.20.120.1080-FF-000046', NULL, 'ATP-dependent RNA helicase DHX37', 106, NULL, NULL, 85004),
(85005, '4.10.400.10-FF-000355', NULL, 'Uncharacterized protein', 28, NULL, NULL, 85005),
(85006, '2.40.10.170-FF-000009', NULL, 'CarD-like protein', 71, NULL, NULL, 85006),
(85007, '2.130.10.10-FF-005544', NULL, 'Predicted protein', 224, NULL, NULL, 85007),
(85008, '2.60.40.10-FF-002014', NULL, 'Ig kappa chain C region, A allele', 108, NULL, NULL, 85008),
(85009, '3.40.47.10-FF-000139', NULL, 'Polyketide beta-ketoacyl:acyl carrier proteinsynthase', 410, NULL, NULL, 85009);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(85010, '1.20.144.10-FF-000055', NULL, 'Uncharacterized protein', 237, NULL, NULL, 85010),
(85011, '2.40.10.10-FF-000602', NULL, NULL, 216, NULL, NULL, 85011),
(85012, '3.40.50.11540-FF-000005', NULL, 'Hydrogenase subunit HymB, putative', 180, NULL, NULL, 85012),
(85013, '3.30.70.1290-FF-000008', NULL, NULL, 162, NULL, NULL, 85013),
(85014, '3.30.300.20-FF-000024', NULL, 'Probable transcription termination protein NusA', 74, NULL, NULL, 85014),
(85015, '1.20.1250.20-FF-001372', NULL, 'MFS transporter, putative (AFU_orthologue AFUA_2G17270)', 196, NULL, NULL, 85015),
(85016, '3.40.50.1980-FF-000117', NULL, 'ABC-type transport system periplasmic substrate-binding protein', 179, NULL, NULL, 85016),
(85017, '3.30.50.10-FF-000007', NULL, 'Nitrogen regulatory AreA, N-terminal', 62, NULL, NULL, 85017),
(85018, '2.80.10.50-FF-000191', NULL, 'Putative serine/threonine protein kinase', 121, NULL, NULL, 85018),
(85019, '2.30.40.10-FF-000020', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 82, NULL, NULL, 85019),
(85020, '3.40.50.1000-FF-000700', NULL, NULL, 116, NULL, NULL, 85020),
(85021, '3.30.70.1320-FF-000012', NULL, 'Multidrug resistance protein, putative', 98, NULL, NULL, 85021),
(85022, '3.30.200.20-FF-000140', NULL, 'Leucine-rich repeat receptor-like protein kinase', 106, NULL, NULL, 85022),
(85023, '1.20.58.2230-FF-000001', NULL, 'Dsl1p', 238, NULL, NULL, 85023),
(85024, '2.130.10.10-FF-000513', NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', 394, NULL, NULL, 85024),
(85025, '3.20.20.70-FF-000815', NULL, NULL, 266, NULL, NULL, 85025),
(85026, '1.10.533.10-FF-000169', NULL, 'Guanylate-binding protein 4', 87, NULL, NULL, 85026),
(85027, '1.10.40.50-FF-000001', NULL, 'Small ribosomal subunit biogenesis GTPase RsgA', 75, NULL, NULL, 85027),
(85028, '2.30.330.10-FF-000010', NULL, 'Type III secretion system protein', 87, NULL, NULL, 85028),
(85029, '3.40.50.300-FF-001216', NULL, 'Protein translocase subunit SecA', 64, NULL, NULL, 85029),
(85030, '1.20.1070.10-FF-001950', NULL, 'Uncharacterized protein', 208, NULL, NULL, 85030),
(85031, '3.40.50.1820-FF-001042', NULL, 'Os04g0669700 protein', 95, NULL, NULL, 85031),
(85032, '1.10.10.60-FF-000502', NULL, 'myb protein', 70, NULL, NULL, 85032),
(85033, '1.10.10.10-FF-001297', NULL, 'MarR family transcriptional regulator', 149, NULL, NULL, 85033),
(85034, '2.130.10.10-FF-006033', NULL, 'Predicted protein', 304, NULL, NULL, 85034),
(85035, '3.40.1360.10-FF-000027', NULL, 'Putative type IIB DNA topoisomerase', 226, NULL, NULL, 85035),
(85036, '3.40.50.850-FF-000009', NULL, 'Nicotinamidase, putative', 199, NULL, NULL, 85036),
(85037, '3.30.70.330-FF-000568', NULL, 'U2 snRNP auxiliary factor large subunit', 109, NULL, NULL, 85037),
(85038, '1.20.1270.60-FF-000311', NULL, 'Uncharacterized protein', 59, NULL, NULL, 85038),
(85039, '3.40.50.1820-FF-000586', NULL, 'Thymus-specific serine protease', 286, NULL, NULL, 85039),
(85040, '2.40.10.10-FF-000259', NULL, NULL, 80, NULL, NULL, 85040),
(85041, '1.10.510.10-FF-000768', NULL, 'Non-specific serine/threonine protein kinase', 192, NULL, NULL, 85041),
(85042, '3.90.1410.10-FF-000116', NULL, 'Uncharacterized protein', 211, NULL, NULL, 85042),
(85043, '3.30.530.20-FF-000193', NULL, 'Coenzyme Q10A', 37, NULL, NULL, 85043),
(85044, '2.70.50.30-FF-000019', NULL, NULL, 175, NULL, NULL, 85044),
(85045, '1.10.390.10-FF-000044', NULL, 'Aminopeptidase', 128, NULL, NULL, 85045),
(85046, '1.20.1420.10-FF-000027', NULL, NULL, 161, NULL, NULL, 85046),
(85047, '3.30.160.60-FF-003003', NULL, 'Blast:Transcription factor grauzone', 60, NULL, NULL, 85047),
(85048, '1.20.1110.10-FF-000217', NULL, NULL, 52, NULL, NULL, 85048),
(85049, '1.25.40.10-FF-001676', NULL, 'Os06g0216400 protein', 76, NULL, NULL, 85049),
(85050, '3.30.60.20-FF-000073', NULL, 'Protein kinase C', 61, NULL, NULL, 85050),
(85051, '2.60.120.10-FF-000572', NULL, 'Predicted protein', 266, NULL, NULL, 85051),
(85052, '1.20.1440.90-FF-000007', NULL, 'Os01g0110700 protein', 66, NULL, NULL, 85052),
(85053, '1.20.5.730-FF-000008', NULL, 'Rabaptin, RAB GTPase binding effector protein 1', 31, NULL, NULL, 85053);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(85054, '1.10.357.50-FF-000024', NULL, 'Uncharacterized protein', 52, NULL, NULL, 85054),
(85055, '3.40.50.720-FF-001786', NULL, '3-hydroxyisobutyrate dehydrogenase', 161, NULL, NULL, 85055),
(85056, '1.20.1250.20-FF-002001', NULL, 'Predicted permease, major facilitator superfamily', 380, NULL, NULL, 85056),
(85057, '3.50.7.10-FF-000014', NULL, 'Thermosome subunit', 152, NULL, NULL, 85057),
(85058, '1.50.10.130-FF-000005', NULL, 'S-(+)-linalool synthase, chloroplastic', 199, NULL, NULL, 85058),
(85059, '2.20.28.10-FF-000059', NULL, 'AGAP002581-PA', 58, NULL, NULL, 85059),
(85060, '2.40.30.10-FF-000322', NULL, 'Selenocysteine-specific elongation factor', 48, NULL, NULL, 85060),
(85061, '3.40.50.2020-FF-000146', NULL, 'Uncharacterized protein', 118, NULL, NULL, 85061),
(85062, '3.90.120.10-FF-000027', NULL, 'Lambda phage type II restriction modification system cytosine-5 DNA methyltransferase Dcm', 112, NULL, NULL, 85062),
(85063, '3.40.50.620-FF-000121', NULL, 'Universal stress protein', 139, NULL, NULL, 85063),
(85064, '1.20.58.1080-FF-000004', NULL, 'SUV3p ATP-dependent RNA helicase', 106, NULL, NULL, 85064),
(85065, '3.90.175.10-FF-000002', NULL, 'Diphtheria toxin', 187, NULL, NULL, 85065),
(85066, '1.20.1270.60-FF-000199', NULL, 'Uncharacterized protein', 104, NULL, NULL, 85066),
(85067, '2.60.40.1930-FF-000036', NULL, 'Uncharacterized protein', 36, NULL, NULL, 85067),
(85068, '3.80.10.10-FF-001380', NULL, 'Os05g0256100 protein', 236, NULL, NULL, 85068),
(85069, '1.25.70.10-FF-000076', NULL, NULL, 174, NULL, NULL, 85069),
(85070, '1.20.1080.10-FF-000107', NULL, 'Aquaporin TIP3.1', 154, NULL, NULL, 85070),
(85071, '3.30.420.10-FF-000586', NULL, NULL, 212, NULL, NULL, 85071),
(85072, '1.20.5.710-FF-000002', NULL, '50S ribosomal protein L7/L12', 50, NULL, NULL, 85072),
(85073, '3.10.20.90-FF-000619', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 98, NULL, NULL, 85073),
(85074, '3.40.140.10-FF-000107', NULL, 'dCMP deaminase', 117, NULL, NULL, 85074),
(85075, '1.20.58.80-FF-000022', NULL, 'Vacuolar protein sorting-associated protein 4', 73, NULL, NULL, 85075),
(85076, '1.10.238.10-FF-001309', NULL, 'Uncharacterized protein', 87, NULL, NULL, 85076),
(85077, '3.40.50.150-FF-000901', NULL, 'Predicted protein', 274, NULL, NULL, 85077),
(85078, '1.10.287.1060-FF-000002', NULL, 'Conserved oligomeric Golgi complex subunit 4', 93, NULL, NULL, 85078),
(85079, '1.25.10.10-FF-000600', NULL, 'Exportin-4', 545, NULL, NULL, 85079),
(85080, '1.10.10.10-FF-002045', NULL, 'Gll1095 protein', 96, NULL, NULL, 85080),
(85081, '3.40.50.300-FF-001267', NULL, 'Multidrug resistance-associated protein 1', 313, NULL, NULL, 85081),
(85082, '3.20.20.70-FF-000754', NULL, NULL, 64, NULL, NULL, 85082),
(85083, '2.60.120.260-FF-000143', NULL, 'Beta-galactosidase family protein', 139, NULL, NULL, 85083),
(85084, '3.30.1490.20-FF-000087', NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', 62, NULL, NULL, 85084),
(85085, '2.160.10.10-FF-000001', NULL, 'UTP--glucose-1-phosphate uridylyltransferase', 113, NULL, NULL, 85085),
(85086, '2.40.170.20-FF-000099', NULL, 'Transporter, outer membrane receptor (OMR) family', 456, NULL, NULL, 85086),
(85087, '2.10.25.10-FF-000435', NULL, 'Delta-like protein', 40, NULL, NULL, 85087),
(85088, '1.10.510.10-FF-002281', NULL, NULL, 94, NULL, NULL, 85088),
(85089, '2.130.10.10-FF-003386', NULL, 'Predicted protein', 268, NULL, NULL, 85089),
(85090, '3.60.40.10-FF-000382', NULL, 'Putative protein phosphatase 2C-like protein 44', 147, NULL, NULL, 85090),
(85091, '3.30.160.60-FF-006229', NULL, NULL, 30, NULL, NULL, 85091),
(85092, '3.40.50.300-FF-004297', NULL, 'Chromosome 1, whole genome shotgun sequence', 171, NULL, NULL, 85092),
(85093, '1.10.510.10-FF-002921', NULL, NULL, 236, NULL, NULL, 85093),
(85094, '3.40.50.2300-FF-001652', NULL, NULL, 214, NULL, NULL, 85094),
(85095, '3.80.10.10-FF-002458', NULL, 'Si:ch211-278p9.2', 91, NULL, NULL, 85095),
(85096, '1.25.40.10-FF-000580', NULL, 'Pre-mRNA-splicing factor SYF1', 106, NULL, NULL, 85096),
(85097, '3.40.50.1000-FF-000520', NULL, NULL, 53, NULL, NULL, 85097);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(85098, '1.10.274.100-FF-000002', NULL, 'DNA-directed RNA polymerase subunit beta', 149, NULL, NULL, 85098),
(85099, '3.40.50.410-FF-000176', NULL, 'Copine-7', 117, NULL, NULL, 85099),
(85100, '2.40.50.140-FF-000110', NULL, '30S ribosomal protein S1', 84, NULL, NULL, 85100),
(85101, '2.40.160.210-FF-000034', NULL, 'Uncharacterized protein', 78, NULL, NULL, 85101),
(85102, '1.10.287.90-FF-000013', NULL, 'Cytochrome c oxidase subunit 2', 88, NULL, NULL, 85102),
(85103, '2.60.120.920-FF-000094', NULL, 'Uncharacterized protein', 206, NULL, NULL, 85103),
(85104, '2.40.50.140-FF-000430', NULL, 'Asparagine-tRNA ligase', 107, NULL, NULL, 85104),
(85105, '3.30.160.60-FF-002290', NULL, 'Weckle, isoform B', 30, NULL, NULL, 85105),
(85106, '3.30.60.30-FF-000171', NULL, 'Uncharacterized protein', 67, NULL, NULL, 85106),
(85107, '1.10.287.1080-FF-000008', NULL, 'Histidine biosynthesis bifunctional protein (HISIE)', 98, NULL, NULL, 85107),
(85108, '3.40.50.720-FF-000701', NULL, 'Hydroxysteroid dehydrogenase like 2', 93, NULL, NULL, 85108),
(85109, '1.20.930.10-FF-000011', NULL, 'Transcription elongation factor A protein 1', 57, NULL, NULL, 85109),
(85110, '3.40.50.2000-FF-000775', NULL, 'Glycosyltransferase family 1 protein', 212, NULL, NULL, 85110),
(85111, '3.30.50.10-FF-000187', NULL, 'Transcription factor stalky', 98, NULL, NULL, 85111),
(85112, '2.10.25.10-FF-001003', NULL, 'von Willebrand factor D and EGF domains', 33, NULL, NULL, 85112),
(85113, '3.30.710.10-FF-000069', NULL, 'Rho related BTB domain containing 1', 131, NULL, NULL, 85113),
(85114, '2.30.40.10-FF-000071', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 83, NULL, NULL, 85114),
(85115, '3.40.50.300-FF-005639', NULL, 'ABC multidrug transporter (Eurofung)', 234, NULL, NULL, 85115),
(85116, '1.10.510.10-FF-000133', NULL, 'Non-specific serine/threonine protein kinase', 183, NULL, NULL, 85116),
(85117, '1.20.5.110-FF-000182', NULL, 'Longin-type vesicle-associated membrane protein putative', 87, NULL, NULL, 85117),
(85118, '3.40.50.300-FF-008304', NULL, 'Uncharacterized protein', 261, NULL, NULL, 85118),
(85119, '3.40.50.620-FF-000738', NULL, 'Uncharacterized protein', 156, NULL, NULL, 85119),
(85120, '1.10.220.10-FF-000049', NULL, 'Annexin', 66, NULL, NULL, 85120),
(85121, '3.40.50.1260-FF-000047', NULL, 'Phosphoglycerate kinase', 53, NULL, NULL, 85121),
(85122, '1.25.10.10-FF-003394', NULL, 'Uncharacterized protein', 133, NULL, NULL, 85122),
(85123, '1.25.40.10-FF-000248', NULL, 'Tetratricopeptide repeat domain 28', 165, NULL, NULL, 85123),
(85124, '1.10.510.10-FF-004366', NULL, NULL, 106, NULL, NULL, 85124),
(85125, '3.40.50.10090-FF-000076', NULL, 'Putative uroporphyrinogen III synthase', 20, NULL, NULL, 85125),
(85126, '3.30.420.10-FF-000322', NULL, '3''-5'' exonuclease eri-1', 237, NULL, NULL, 85126),
(85127, '1.20.920.10-FF-000033', NULL, 'Histone-lysine N-methyltransferase', 114, NULL, NULL, 85127),
(85128, '3.40.50.300-FF-002852', NULL, 'Mismatch repair protein', 263, NULL, NULL, 85128),
(85129, '3.30.428.10-FF-000031', NULL, 'HIT family protein', 144, NULL, NULL, 85129),
(85130, '1.20.1250.20-FF-001484', NULL, 'Uncharacterized protein', 395, NULL, NULL, 85130),
(85131, '2.130.10.10-FF-003099', NULL, 'Uncharacterized protein', 311, NULL, NULL, 85131),
(85132, '2.60.120.200-FF-000552', NULL, 'Lectin', 129, NULL, NULL, 85132),
(85133, '3.90.400.10-FF-000009', NULL, 'Alpha-amylase', 65, NULL, NULL, 85133),
(85134, '3.90.1290.10-FF-000027', NULL, 'VAB-10A protein', 152, NULL, NULL, 85134),
(85135, '1.20.1070.10-FF-000040', NULL, 'Coagulation factor 2 (thrombin) receptor', 302, NULL, NULL, 85135),
(85136, '3.20.20.140-FF-000397', NULL, 'Uncharacterized protein', 138, NULL, NULL, 85136),
(85137, '3.30.572.10-FF-000028', NULL, 'Uncharacterized protein', 158, NULL, NULL, 85137),
(85138, '3.30.40.10-FF-001693', NULL, 'Vacuolar protein sorting-associated protein 27', 69, NULL, NULL, 85138),
(85139, '3.90.1750.10-FF-000107', NULL, 'Uncharacterized protein', 56, NULL, NULL, 85139),
(85140, '3.20.20.80-FF-000852', NULL, 'Uncharacterized protein', 109, NULL, NULL, 85140);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(85141, '3.40.50.1480-FF-000001', NULL, 'Adenosylhomocysteinase', 131, NULL, NULL, 85141),
(85142, '2.30.29.30-FF-000567', NULL, 'PH domain-containing endocytic-trafficking adaptor 1', 105, NULL, NULL, 85142),
(85143, '2.10.110.10-FF-000240', NULL, 'LIM domain protein', 68, NULL, NULL, 85143),
(85144, '3.40.50.300-FF-005870', NULL, 'AAA domain containing protein, putative', 238, NULL, NULL, 85144),
(85145, '3.40.50.300-FF-002205', NULL, 'ABC transporter, (TAP family), putative', 122, NULL, NULL, 85145),
(85146, '1.10.10.10-FF-001089', NULL, 'Hypothetical_protein_-_conserved', 97, NULL, NULL, 85146),
(85147, '3.40.50.300-FF-006590', NULL, 'Uncharacterized protein', 98, NULL, NULL, 85147),
(85148, '1.10.20.10-FF-000134', NULL, 'CCAAT-box DNA binding protein subunit B', 146, NULL, NULL, 85148),
(85149, '1.20.5.350-FF-000023', NULL, NULL, 142, NULL, NULL, 85149),
(85150, '1.20.1160.11-FF-000025', NULL, NULL, 47, NULL, NULL, 85150),
(85151, '3.40.720.10-FF-000253', NULL, 'Uncharacterized protein', 84, NULL, NULL, 85151),
(85152, '3.30.2350.10-FF-000041', NULL, 'tRNA pseudouridine synthase B', 239, NULL, NULL, 85152),
(85153, '1.20.58.830-FF-000021', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 179, NULL, NULL, 85153),
(85154, '2.130.10.10-FF-000305', NULL, 'F-box/WD repeat-containing protein 5 isoform X1', 132, NULL, NULL, 85154),
(85155, '1.10.10.10-FF-000651', NULL, 'Regulatory protein RecX', 47, NULL, NULL, 85155),
(85156, '3.40.640.10-FF-000252', NULL, 'Uncharacterized protein', 95, NULL, NULL, 85156),
(85157, '1.10.238.210-FF-000001', NULL, 'Glutaminase kidney isoform, mitochondrial', 81, NULL, NULL, 85157),
(85158, '3.40.50.12660-FF-000015', NULL, 'ICE-like protease p20 domain containing protein, expressed', 302, NULL, NULL, 85158),
(85159, '1.10.8.720-FF-000069', NULL, 'Uncharacterized protein', 158, NULL, NULL, 85159),
(85160, '2.60.40.770-FF-000011', NULL, 'Protein CBR-HEH-1', 131, NULL, NULL, 85160),
(85161, '2.40.180.10-FF-000035', NULL, 'Predicted protein', 98, NULL, NULL, 85161),
(85162, '1.10.510.10-FF-000504', NULL, 'Serine/threonine-protein kinase Nek5', 247, NULL, NULL, 85162),
(85163, '1.10.8.60-FF-000546', NULL, 'Uncharacterized protein', 105, NULL, NULL, 85163),
(85164, '1.25.40.10-FF-002614', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 97, NULL, NULL, 85164),
(85165, '1.20.1270.10-FF-000021', NULL, 'Heat shock protein 70', 114, NULL, NULL, 85165),
(85166, '2.130.10.10-FF-000581', NULL, 'LLGL scribble cell polarity complex component 2', 259, NULL, NULL, 85166),
(85167, '2.60.40.10-FF-006016', NULL, NULL, 99, NULL, NULL, 85167),
(85168, '3.80.10.10-FF-000660', NULL, 'Leucine rich repeats and IQ motif containing 1', 96, NULL, NULL, 85168),
(85169, '1.10.8.60-FF-000142', NULL, 'Katanin p60 ATPase-containing subunit A1', 90, NULL, NULL, 85169),
(85170, '1.25.40.790-FF-000011', NULL, 'CCR4-not transcription complex, putative', 245, NULL, NULL, 85170),
(85171, '2.60.120.290-FF-000247', NULL, 'Uncharacterized protein', 158, NULL, NULL, 85171),
(85172, '2.70.170.10-FF-000123', NULL, 'Uncharacterized protein', 164, NULL, NULL, 85172),
(85173, '3.10.350.10-FF-000017', NULL, 'Peptidase, M23 family', 51, NULL, NULL, 85173),
(85174, '3.40.630.30-FF-000297', NULL, 'AGAP006788-PA', 217, NULL, NULL, 85174),
(85175, '3.40.350.10-FF-000033', NULL, 'Xaa-pro aminopeptidase, putative', 133, NULL, NULL, 85175),
(85176, '3.40.1110.10-FF-000048', NULL, 'Phospholipid-transporting ATPase', 184, NULL, NULL, 85176),
(85177, '2.40.37.10-FF-000023', NULL, 'Diaminopimelate decarboxylase', 151, NULL, NULL, 85177),
(85178, '1.50.40.10-FF-000595', NULL, 'Uncharacterized protein', 151, NULL, NULL, 85178),
(85179, '1.50.10.10-FF-000188', NULL, 'Uncharacterized protein', 301, NULL, NULL, 85179),
(85180, '2.20.100.10-FF-000079', NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 17', 54, NULL, NULL, 85180),
(85181, '3.80.10.10-FF-003818', NULL, 'Predicted protein', 79, NULL, NULL, 85181),
(85182, '1.25.40.180-FF-000154', NULL, NULL, 38, NULL, NULL, 85182),
(85183, '1.10.8.270-FF-000182', NULL, 'TBC domaincontaining protein', 78, NULL, NULL, 85183); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(85184, '2.30.30.40-FF-000270', NULL, 'Blast:Tyrosine-protein kinase Src-1', 60, NULL, NULL, 85184),
(85185, '3.40.710.10-FF-000016', NULL, 'serine beta-lactamase-like protein LACTB, mitochondrial', 228, NULL, NULL, 85185),
(85186, '1.10.472.10-FF-000050', NULL, 'Transcription initiation factor TFIIB', 92, NULL, NULL, 85186),
(85187, '2.60.120.330-FF-000012', NULL, 'Gibberellin 20 oxidase 1', 337, NULL, NULL, 85187),
(85188, '3.40.50.150-FF-000513', NULL, 'S-adenosylmethionine-dependent methyltransferase', 166, NULL, NULL, 85188),
(85189, '3.30.9.10-FF-000097', NULL, 'Glycerol-3-phosphate dehydrogenase', 156, NULL, NULL, 85189),
(85190, '3.90.1200.10-FF-000027', NULL, 'Fructosamine kinase', 200, NULL, NULL, 85190),
(85191, '1.10.10.10-FF-001325', NULL, 'DNA-binding response regulator', 109, NULL, NULL, 85191),
(85192, '2.10.25.10-FF-001683', NULL, 'Uncharacterized protein', 44, NULL, NULL, 85192),
(85193, '1.20.1560.10-FF-000476', NULL, 'ABC transporter ATP-binding protein', 315, NULL, NULL, 85193),
(85194, '2.60.40.1180-FF-000053', NULL, 'Alpha-L-arabinofuranosidase A', 115, NULL, NULL, 85194),
(85195, '3.30.40.10-FF-000922', NULL, 'RING finger protein 38', 85, NULL, NULL, 85195),
(85196, '1.20.1070.10-FF-001506', NULL, 'Uncharacterized protein', 197, NULL, NULL, 85196),
(85197, '1.25.40.10-FF-001940', NULL, 'Os03g0635000 protein', 115, NULL, NULL, 85197),
(85198, '1.10.8.10-FF-000149', NULL, 'CUE2p protein', 44, NULL, NULL, 85198),
(85199, '2.60.60.20-FF-000040', NULL, NULL, 138, NULL, NULL, 85199),
(85200, '3.80.10.10-FF-001048', NULL, 'F-box and leucine rich repeat protein 4', 292, NULL, NULL, 85200),
(85201, '2.60.40.790-FF-000017', NULL, 'Cysteine and histidine-rich domain-containing protein 1', 108, NULL, NULL, 85201),
(85202, '3.10.20.90-FF-000142', NULL, 'E3 ubiquitin-protein ligase parkin', 77, NULL, NULL, 85202),
(85203, '1.10.555.10-FF-000118', NULL, 'Rho GTPase activating protein 28', 240, NULL, NULL, 85203),
(85204, '3.90.1110.10-FF-000020', NULL, 'DNA-directed RNA polymerase subunit beta', 187, NULL, NULL, 85204),
(85205, '1.20.1250.20-FF-001664', NULL, 'AaceriACL172Cp', 207, NULL, NULL, 85205),
(85206, '1.10.150.50-FF-000038', NULL, 'Putative sam and sh3 domain-containing protein 1', 59, NULL, NULL, 85206),
(85207, '3.30.160.60-FF-004431', NULL, NULL, 44, NULL, NULL, 85207),
(85208, '1.25.40.470-FF-000084', NULL, 'Elongator complex protein 1', 179, NULL, NULL, 85208),
(85209, '2.60.220.50-FF-000046', NULL, 'Adhesion G protein-coupled receptor D2', 193, NULL, NULL, 85209),
(85210, '3.30.70.330-FF-002125', NULL, NULL, 105, NULL, NULL, 85210),
(85211, '3.30.450.40-FF-000198', NULL, 'PAS sensor protein', 173, NULL, NULL, 85211),
(85212, '2.30.30.40-FF-000641', NULL, 'Uncharacterized protein', 79, NULL, NULL, 85212),
(85213, '3.40.50.450-FF-000081', NULL, 'Uncharacterized protein', 68, NULL, NULL, 85213),
(85214, '3.40.630.30-FF-000173', NULL, 'Acyl-homoserine-lactone synthase', 190, NULL, NULL, 85214),
(85215, '3.90.180.10-FF-000188', NULL, 'Uncharacterized protein', 84, NULL, NULL, 85215),
(85216, '2.40.70.10-FF-000499', NULL, NULL, 113, NULL, NULL, 85216),
(85217, '1.20.120.1220-FF-000015', NULL, NULL, 158, NULL, NULL, 85217),
(85218, '1.25.10.10-FF-001848', NULL, 'Uncharacterized protein', 427, NULL, NULL, 85218),
(85219, '3.30.60.10-FF-000013', NULL, NULL, 49, NULL, NULL, 85219),
(85220, '1.25.10.10-FF-001320', NULL, 'Uncharacterized protein', 804, NULL, NULL, 85220),
(85221, '3.90.1030.10-FF-000019', NULL, 'Mitochondrial 54S ribosomal protein YmL8', 127, NULL, NULL, 85221),
(85222, '3.50.50.60-FF-000723', NULL, 'Dihydrolipoamide dehydrogenase, point mutation', 140, NULL, NULL, 85222),
(85223, '3.30.60.30-FF-000019', NULL, 'NtA agrin', 67, NULL, NULL, 85223),
(85224, '3.40.50.2300-FF-000242', NULL, 'Hybrid sensor histidine kinase/response regulator', 133, NULL, NULL, 85224),
(85225, '3.40.50.1000-FF-000672', NULL, NULL, 182, NULL, NULL, 85225),
(85226, '1.10.510.10-FF-004079', NULL, NULL, 169, NULL, NULL, 85226),
(85227, '3.90.70.40-FF-000003', NULL, 'josephin-2 isoform X1', 163, NULL, NULL, 85227); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(85228, '3.40.950.10-FF-000011', NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', 18, NULL, NULL, 85228),
(85229, '2.30.29.30-FF-001005', NULL, 'Dynamin-1', 125, NULL, NULL, 85229),
(85230, '1.25.40.20-FF-000526', NULL, 'NACHT and Ankyrin domain protein', 184, NULL, NULL, 85230),
(85231, '1.25.10.10-FF-000488', NULL, 'Serine/threonine-protein kinase mTOR', 248, NULL, NULL, 85231),
(85232, '3.30.160.60-FF-001446', NULL, 'Zinc finger protein 532', 85, NULL, NULL, 85232),
(85233, '1.10.1740.150-FF-000001', NULL, 'Endoribonuclease Dicer', 80, NULL, NULL, 85233),
(85234, '3.40.30.10-FF-000308', NULL, 'Heat shock protein DnaJ homologue Pfj2', 142, NULL, NULL, 85234),
(85235, '3.30.70.330-FF-001136', NULL, 'Polyadenylate-binding protein', 77, NULL, NULL, 85235),
(85236, '1.10.472.130-FF-000015', NULL, 'Dynein heavy chain 7', 153, NULL, NULL, 85236),
(85237, '1.20.1560.10-FF-000189', NULL, 'Multidrug transporter', 342, NULL, NULL, 85237),
(85238, '3.30.200.20-FF-002405', NULL, 'Receptor protein-tyrosine kinase', 130, NULL, NULL, 85238),
(85239, '3.30.200.20-FF-001781', NULL, NULL, 106, NULL, NULL, 85239),
(85240, '3.30.200.20-FF-001045', NULL, 'Microtubule-associated serine/threonine kinase 1a', 141, NULL, NULL, 85240),
(85241, '1.20.58.390-FF-000220', NULL, 'Uncharacterized protein', 105, NULL, NULL, 85241),
(85242, '3.40.630.10-FF-000015', NULL, 'Aminoacyl-histidine dipeptidase PepD', 238, NULL, NULL, 85242),
(85243, '4.10.900.10-FF-000005', NULL, 'Desmocollin 2', 78, NULL, NULL, 85243),
(85244, '1.10.472.10-FF-000611', NULL, 'G2/mitotic-specific cyclin B, copy E-like protein', 137, NULL, NULL, 85244),
(85245, '3.30.497.10-FF-000134', NULL, 'Uncharacterized protein', 38, NULL, NULL, 85245),
(85246, '3.90.70.10-FF-000848', NULL, 'Uncharacterized protein', 113, NULL, NULL, 85246),
(85247, '3.30.200.20-FF-001629', NULL, NULL, 95, NULL, NULL, 85247),
(85248, '3.10.170.20-FF-000017', NULL, NULL, 176, NULL, NULL, 85248),
(85249, '2.60.40.10-FF-001497', NULL, 'MHC class I antigen', 94, NULL, NULL, 85249),
(85250, '2.40.50.140-FF-000222', NULL, 'Programmed cell death 11', 78, NULL, NULL, 85250),
(85251, '3.40.50.1100-FF-000084', NULL, 'Threonine dehydratase', 97, NULL, NULL, 85251),
(85252, '1.10.10.60-FF-000570', NULL, 'Transcriptional adaptor ADA2, putative', 55, NULL, NULL, 85252),
(85253, '3.20.70.20-FF-000040', NULL, 'Vitamin B12-dependent ribonucleotide reductase', 659, NULL, NULL, 85253),
(85254, '3.30.1060.10-FF-000001', NULL, 'Peptide methionine sulfoxide reductase MsrA', 209, NULL, NULL, 85254),
(85255, '3.40.50.300-FF-004173', NULL, 'Phosphomevalonate kinase, putative', 185, NULL, NULL, 85255),
(85256, '3.40.50.300-FF-008512', NULL, 'Transitional endoplasmic reticulum ATPase TER94-like Protein', 160, NULL, NULL, 85256),
(85257, '1.10.730.10-FF-000144', NULL, 'Arginine--tRNA ligase', 123, NULL, NULL, 85257),
(85258, '3.30.720.200-FF-000008', NULL, 'Valine--tRNA ligase', 62, NULL, NULL, 85258),
(85259, '2.130.10.10-FF-005252', NULL, 'Uncharacterized protein', 394, NULL, NULL, 85259),
(85260, '3.40.50.300-FF-003841', NULL, 'Predicted protein', 206, NULL, NULL, 85260),
(85261, '1.25.40.10-FF-005363', NULL, 'Predicted protein', 113, NULL, NULL, 85261),
(85262, '1.10.238.10-FF-000051', NULL, 'Ras guanyl-releasing protein 3 isoform 1', 78, NULL, NULL, 85262),
(85263, '3.20.20.80-FF-000644', NULL, 'Uncharacterized protein', 94, NULL, NULL, 85263),
(85264, '1.20.58.80-FF-000090', NULL, 'Ubiquitin specific peptidase 8', 75, NULL, NULL, 85264),
(85265, '1.10.8.280-FF-000004', NULL, 'UvrABC system protein A', 125, NULL, NULL, 85265),
(85266, '3.10.250.10-FF-000072', NULL, NULL, 121, NULL, NULL, 85266),
(85267, '3.10.330.20-FF-000019', NULL, 'tRNA methyltransferase complex GCD14 subunit', 66, NULL, NULL, 85267),
(85268, '3.20.20.140-FF-000189', NULL, 'Metallo-dependent hydrolase', 556, NULL, NULL, 85268),
(85269, '3.40.30.10-FF-000955', NULL, 'Monothiol glutaredoxin-3', 106, NULL, NULL, 85269),
(85270, '1.25.40.10-FF-000428', NULL, 'Leucine-rich PPR motif-containing protein, mitochondrial', 207, NULL, NULL, 85270);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(85271, '3.80.10.10-FF-004246', NULL, 'Leucine Rich Repeat family protein, expressed', 73, NULL, NULL, 85271),
(85272, '3.40.1110.10-FF-000335', NULL, NULL, 122, NULL, NULL, 85272),
(85273, '3.40.190.10-FF-000739', NULL, 'Hydrogen peroxide-inducible genes activator', 102, NULL, NULL, 85273),
(85274, '3.30.70.330-FF-000888', NULL, 'Related to splicing factor HCC1', 106, NULL, NULL, 85274),
(85275, '2.130.10.10-FF-001941', NULL, 'Uncharacterized protein', 57, NULL, NULL, 85275),
(85276, '3.90.470.10-FF-000014', NULL, '50S ribosomal protein L22, apicoplast', 129, NULL, NULL, 85276),
(85277, '2.30.42.10-FF-000474', NULL, NULL, 112, NULL, NULL, 85277),
(85278, '3.30.60.20-FF-000005', NULL, 'Non-specific serine/threonine protein kinase', 71, NULL, NULL, 85278),
(85279, '3.40.1110.10-FF-000256', NULL, 'Probable cation-transporting P-type ATPase', 148, NULL, NULL, 85279),
(85280, '3.40.50.620-FF-000233', NULL, 'Leucine--tRNA ligase, putative', 146, NULL, NULL, 85280),
(85281, '3.30.160.60-FF-003071', NULL, NULL, 28, NULL, NULL, 85281),
(85282, '3.30.160.60-FF-000665', NULL, 'E3 ubiquitin-protein ligase', 26, NULL, NULL, 85282),
(85283, '3.40.50.300-FF-005078', NULL, 'AFG1-like ATPase a', 95, NULL, NULL, 85283),
(85284, '3.40.50.150-FF-001233', NULL, NULL, 213, NULL, NULL, 85284),
(85285, '2.60.40.10-FF-004200', NULL, NULL, 113, NULL, NULL, 85285),
(85286, '3.10.310.50-FF-000004', NULL, 'POSSIBLE CONSERVED TRANSMEMBRANE PROTEIN', 137, NULL, NULL, 85286),
(85287, '2.60.40.60-FF-000359', NULL, 'LOW QUALITY PROTEIN: protocadherin-23', 103, NULL, NULL, 85287),
(85288, '3.30.40.10-FF-000181', NULL, 'RING-type E3 ubiquitin transferase', 74, NULL, NULL, 85288),
(85289, '3.30.40.10-FF-002367', NULL, 'Ubiquitinyl hydrolase 1', 79, NULL, NULL, 85289),
(85290, '1.20.1110.10-FF-000105', NULL, 'Uncharacterized protein', 189, NULL, NULL, 85290),
(85291, '1.20.140.160-FF-000003', NULL, 'RNA polymerase sigma factor', 146, NULL, NULL, 85291),
(85292, '3.40.190.10-FF-000155', NULL, 'Glutamate receptor ionotropic, NMDA 2B', 107, NULL, NULL, 85292),
(85293, '1.20.1730.10-FF-000017', NULL, 'Solute:sodium symporter family transporter', 527, NULL, NULL, 85293),
(85294, '1.25.40.10-FF-002114', NULL, 'Transcription Factor ThreeC subunit (GTF3C homolog)', 247, NULL, NULL, 85294),
(85295, '3.30.1490.20-FF-000019', NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta, mitochondrial', 92, NULL, NULL, 85295),
(85296, '1.10.196.10-FF-000014', NULL, 'Axin 2 (conductin, axil)', 33, NULL, NULL, 85296),
(85297, '3.40.50.1100-FF-000163', NULL, 'Predicted protein', 41, NULL, NULL, 85297),
(85298, '2.60.40.10-FF-000592', NULL, 'Fc receptor like 1', 91, NULL, NULL, 85298),
(85299, '3.40.50.880-FF-000171', NULL, 'Class I glutamine amidotransferase-like protein', 222, NULL, NULL, 85299),
(85300, '3.10.450.50-FF-000065', NULL, 'Putative dioxygenase beta subunit', 158, NULL, NULL, 85300),
(85301, '1.10.220.150-FF-000066', NULL, 'ArfGAP', 177, NULL, NULL, 85301),
(85302, '3.40.630.30-FF-000089', NULL, 'Mycothiol acetyltransferase', 315, NULL, NULL, 85302),
(85303, '2.130.10.10-FF-000429', NULL, 'RIC1 homolog, RAB6A GEF complex partner 1', 191, NULL, NULL, 85303),
(85304, '2.60.40.10-FF-005824', NULL, NULL, 44, NULL, NULL, 85304),
(85305, '3.40.50.720-FF-000437', NULL, 'Fatty acyl-CoA reductase', 385, NULL, NULL, 85305),
(85306, '1.10.150.130-FF-000010', NULL, 'Centromere binding factor CBF3 subunit', 125, NULL, NULL, 85306),
(85307, '2.70.130.10-FF-000002', NULL, 'protein OS-9 isoform X1', 118, NULL, NULL, 85307),
(85308, '3.40.50.300-FF-008124', NULL, 'Uncharacterized protein', 106, NULL, NULL, 85308),
(85309, '3.30.420.10-FF-000474', NULL, NULL, 173, NULL, NULL, 85309),
(85310, '1.20.920.10-FF-000185', NULL, 'Predicted protein', 90, NULL, NULL, 85310),
(85311, '3.40.430.10-FF-000034', NULL, 'Uncharacterized protein', 189, NULL, NULL, 85311),
(85312, '2.40.50.140-FF-000610', NULL, 'EXOSome (Multiexonuclease complex) component', 139, NULL, NULL, 85312),
(85313, '3.40.140.10-FF-000175', NULL, 'Eukaryotic translation initiation factor 3 subunit H', 207, NULL, NULL, 85313);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(85314, '3.40.50.1580-FF-000025', NULL, 'Purine nucleoside phosphorylase', 265, NULL, NULL, 85314),
(85315, '1.25.40.20-FF-000318', NULL, 'Ankyrin repeat domain 16', 160, NULL, NULL, 85315),
(85316, '1.20.1070.10-FF-000601', NULL, 'Predicted protein', 294, NULL, NULL, 85316),
(85317, '2.30.30.40-FF-000118', NULL, 'Putative E3 ubiquitin-protein ligase SH3RF1', 70, NULL, NULL, 85317),
(85318, '3.20.20.80-FF-000291', NULL, 'Amylo-alpha-1, 6-glucosidase, 4-alpha-glucanotransferase a', 188, NULL, NULL, 85318),
(85319, '1.20.58.390-FF-000136', NULL, 'Ligand-Gated ion Channel', 131, NULL, NULL, 85319),
(85320, '1.25.40.10-FF-003738', NULL, 'Signal recognition particle subunit SRP72', 150, NULL, NULL, 85320),
(85321, '3.40.50.300-FF-000486', NULL, 'E3 ubiquitin-protein ligase TRIM23', 179, NULL, NULL, 85321),
(85322, '1.25.40.10-FF-001597', NULL, 'Pentatricopeptide repeat-containing protein isoform A', 190, NULL, NULL, 85322),
(85323, '1.20.5.430-FF-000008', NULL, 'Nuclear receptor corepressor 2', 39, NULL, NULL, 85323),
(85324, '1.20.1250.20-FF-000944', NULL, 'Solute carrier family 16, member 4', 233, NULL, NULL, 85324),
(85325, '3.40.50.1820-FF-001626', NULL, 'Carboxylic ester hydrolase', 491, NULL, NULL, 85325),
(85326, '1.20.58.1770-FF-000003', NULL, 'RILP-like protein 2 isoform X1', 87, NULL, NULL, 85326),
(85327, '2.10.25.10-FF-000547', NULL, 'Crumbs 2, cell polarity complex component', 39, NULL, NULL, 85327),
(85328, '3.80.10.10-FF-001784', NULL, 'Protein CBG17991', 87, NULL, NULL, 85328),
(85329, '3.40.50.720-FF-002567', NULL, 'Predicted protein', 42, NULL, NULL, 85329),
(85330, '1.20.1310.10-FF-000025', NULL, 'Cullin-1, putative', 122, NULL, NULL, 85330),
(85331, '1.20.1270.60-FF-000075', NULL, 'Related to IVY1-phospholipid-binding protein', 220, NULL, NULL, 85331),
(85332, '3.30.1390.20-FF-000023', NULL, '60S ribosomal protein L7', 100, NULL, NULL, 85332),
(85333, '2.60.40.10-FF-003683', NULL, NULL, 129, NULL, NULL, 85333),
(85334, '3.30.160.60-FF-002222', NULL, 'zinc finger protein 142', 30, NULL, NULL, 85334),
(85335, '1.10.630.10-FF-000423', NULL, 'Uncharacterized protein', 77, NULL, NULL, 85335),
(85336, '1.10.3730.20-FF-000023', NULL, 'Drug/Metabolite Transporter (DMT) Superfamily', 94, NULL, NULL, 85336),
(85337, '3.30.60.30-FF-000103', NULL, 'GEO07179p1', 68, NULL, NULL, 85337),
(85338, '3.40.50.410-FF-000108', NULL, 'Sfb3p', 239, NULL, NULL, 85338),
(85339, '3.40.50.1110-FF-000109', NULL, 'Phospholipase B1', 210, NULL, NULL, 85339),
(85340, '1.20.1560.10-FF-000397', NULL, 'P-glycoprotein 5', 598, NULL, NULL, 85340),
(85341, '3.30.1360.120-FF-000069', NULL, 'Protein CBG14872', 115, NULL, NULL, 85341),
(85342, '3.40.50.980-FF-000032', NULL, 'Linear gramicidin synthase subunit B', 174, NULL, NULL, 85342),
(85343, '1.10.287.70-FF-000131', NULL, 'Uncharacterized protein, isoform B', 138, NULL, NULL, 85343),
(85344, '3.30.1490.100-FF-000041', NULL, 'YALI0C01573p', 119, NULL, NULL, 85344),
(85345, '3.30.50.10-FF-000119', NULL, 'Nuclear Hormone Receptor family', 103, NULL, NULL, 85345),
(85346, '2.60.120.920-FF-000026', NULL, 'tripartite motif-containing protein 46 isoform X2', 203, NULL, NULL, 85346),
(85347, '3.40.50.300-FF-007848', NULL, 'Uncharacterized protein', 226, NULL, NULL, 85347),
(85348, '3.40.50.10810-FF-000085', NULL, 'Transcription regulatory protein SNF2', 31, NULL, NULL, 85348),
(85349, '3.40.33.10-FF-000169', NULL, 'Uncharacterized protein', 103, NULL, NULL, 85349),
(85350, '3.90.850.10-FF-000009', NULL, 'Fumarylacetoacetase', 308, NULL, NULL, 85350),
(85351, '1.20.1250.20-FF-001164', NULL, 'MFS allantoate transporter, putative', 221, NULL, NULL, 85351),
(85352, '3.40.50.1010-FF-000057', NULL, 'Unplaced genomic scaffold supercont1.23, whole genome shotgun sequence', 201, NULL, NULL, 85352),
(85353, '1.10.510.10-FF-001561', NULL, 'Predicted protein', 197, NULL, NULL, 85353),
(85354, '1.25.10.10-FF-003473', NULL, 'Protein ILITYHIA', 197, NULL, NULL, 85354),
(85355, '2.30.110.10-FF-000027', NULL, 'Deazaflavin-dependent nitroreductase ddn', 138, NULL, NULL, 85355),
(85356, '1.10.287.70-FF-000395', NULL, 'Putative calcium channel protein', 138, NULL, NULL, 85356);
INSERT INTO "PUBLIC"."MODEL" VALUES
(85357, '3.60.40.10-FF-000314', NULL, 'Protein CBG02976', 232, NULL, NULL, 85357),
(85358, '3.30.40.10-FF-001142', NULL, 'Histone-lysine N-methyltransferase', 79, NULL, NULL, 85358),
(85359, '3.80.10.10-FF-001109', NULL, 'Tubulin folding cofactor E-like b', 91, NULL, NULL, 85359),
(85360, '3.30.830.10-FF-000308', NULL, 'Uncharacterized protein', 104, NULL, NULL, 85360),
(85361, '3.40.50.10910-FF-000002', NULL, NULL, 138, NULL, NULL, 85361),
(85362, '1.20.1070.10-FF-001450', NULL, 'Vomeronasal type-1 receptor', 219, NULL, NULL, 85362),
(85363, '2.30.30.750-FF-000004', NULL, '5''-3'' exoribonuclease 1', 102, NULL, NULL, 85363),
(85364, '3.30.420.80-FF-000011', NULL, '37S ribosomal protein S18, mitochondrial', 165, NULL, NULL, 85364),
(85365, '1.10.10.60-FF-000418', NULL, 'Homeobox protein engrailed-like', 99, NULL, NULL, 85365),
(85366, '3.40.50.11980-FF-000002', NULL, 'Proteinaceous RNase P 2', 179, NULL, NULL, 85366),
(85367, '3.30.360.10-FF-000143', NULL, 'Lysine-ketoglutarate reductase/saccharopine dehydrogenase bifunctional enzyme', 71, NULL, NULL, 85367),
(85368, '2.60.40.1090-FF-000026', NULL, 'Fimbrial subunit ElfA', 149, NULL, NULL, 85368),
(85369, '3.40.50.2300-FF-001591', NULL, NULL, 126, NULL, NULL, 85369),
(85370, '3.10.390.10-FF-000014', NULL, 'Uncharacterized protein', 84, NULL, NULL, 85370),
(85371, '1.20.58.60-FF-000275', NULL, 'Kakapo', 214, NULL, NULL, 85371),
(85372, '1.10.287.550-FF-000005', NULL, 'Steryl-sulfatase', 59, NULL, NULL, 85372),
(85373, '3.40.50.300-FF-003633', NULL, 'Cobalt ABC transporter ATP-binding protein', 262, NULL, NULL, 85373),
(85374, '3.90.70.10-FF-000348', NULL, 'Cysteine proteinase', 263, NULL, NULL, 85374),
(85375, '3.20.20.140-FF-000273', NULL, 'Sll0549 protein', 201, NULL, NULL, 85375),
(85376, '3.30.70.1230-FF-000018', NULL, 'Adenylate cyclase AcyA', 206, NULL, NULL, 85376),
(85377, '3.30.160.60-FF-001946', NULL, 'Zinc finger protein 19', 27, NULL, NULL, 85377),
(85378, '2.130.10.10-FF-004459', NULL, 'Uncharacterized protein', 342, NULL, NULL, 85378),
(85379, '2.130.10.10-FF-003739', NULL, 'Uncharacterized protein', 333, NULL, NULL, 85379),
(85380, '4.10.800.20-FF-000001', NULL, 'AMP deaminase', 91, NULL, NULL, 85380),
(85381, '3.90.800.10-FF-000006', NULL, NULL, 127, NULL, NULL, 85381),
(85382, '2.130.10.10-FF-005752', NULL, 'Uncharacterized protein', 119, NULL, NULL, 85382),
(85383, '3.30.479.10-FF-000002', NULL, '6-carboxytetrahydropterin synthase QueD', 75, NULL, NULL, 85383),
(85384, '3.50.50.60-FF-001448', NULL, 'Uncharacterized protein', 88, NULL, NULL, 85384),
(85385, '3.90.770.10-FF-000008', NULL, '3-hydroxy-3-methylglutaryl-CoA reductase', 119, NULL, NULL, 85385),
(85386, '1.10.1070.11-FF-000116', NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', 188, NULL, NULL, 85386),
(85387, '2.60.120.10-FF-000780', NULL, 'Uncharacterized protein', 159, NULL, NULL, 85387),
(85388, '2.60.120.10-FF-000049', NULL, 'Potassium/sodium hyperpolarization-activated cyclic nucleotide-gated channel', 138, NULL, NULL, 85388),
(85389, '3.40.50.1820-FF-000266', NULL, 'Carboxylic ester hydrolase', 537, NULL, NULL, 85389),
(85390, '2.60.40.60-FF-000770', NULL, 'Uncharacterized protein', 111, NULL, NULL, 85390),
(85391, '3.40.50.300-FF-001424', NULL, 'Elongation factor 1-alpha 1', 237, NULL, NULL, 85391),
(85392, '3.30.379.10-FF-000017', NULL, NULL, 138, NULL, NULL, 85392),
(85393, '1.20.1280.50-FF-000247', NULL, 'Uncharacterized protein', 98, NULL, NULL, 85393),
(85394, '1.20.58.160-FF-000005', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 98, NULL, NULL, 85394),
(85395, '2.40.50.140-FF-001127', NULL, NULL, 90, NULL, NULL, 85395),
(85396, '3.60.10.10-FF-000374', NULL, 'Sphingomyelin phosphodiesterase 5', 97, NULL, NULL, 85396),
(85397, '1.10.287.130-FF-000054', NULL, 'Sensor histidine kinase', 63, NULL, NULL, 85397),
(85398, '2.60.40.10-FF-002514', NULL, 'Uncharacterized protein, isoform J', 102, NULL, NULL, 85398),
(85399, '3.90.550.10-FF-000644', NULL, 'Predicted protein', 156, NULL, NULL, 85399),
(85400, '3.40.630.20-FF-000029', NULL, 'Pyroglutamyl-peptidase I-like', 118, NULL, NULL, 85400);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(85401, '3.30.70.1660-FF-000029', NULL, 'Uncharacterized protein', 173, NULL, NULL, 85401),
(85402, '2.10.220.10-FF-000051', NULL, 'Proprotein convertase subtilisin/kexin type 5', 64, NULL, NULL, 85402),
(85403, '3.90.550.10-FF-000520', NULL, 'Glycoside transferase family 2', 249, NULL, NULL, 85403),
(85404, '2.20.25.90-FF-000003', NULL, 'NADH-quinone oxidoreductase', 55, NULL, NULL, 85404),
(85405, '3.20.20.70-FF-000411', NULL, 'Indole-3-glycerol phosphate synthase', 248, NULL, NULL, 85405),
(85406, '3.40.50.10420-FF-000012', NULL, '5-formyltetrahydrofolate cyclo-ligase', 207, NULL, NULL, 85406),
(85407, '3.10.100.10-FF-000084', NULL, 'C-type lectin domain family 14 member A', 147, NULL, NULL, 85407),
(85408, '3.40.50.2300-FF-000871', NULL, NULL, 41, NULL, NULL, 85408),
(85409, '3.30.470.20-FF-000070', NULL, 'Alpha-glucan water dikinase 2', 160, NULL, NULL, 85409),
(85410, '1.10.287.70-FF-000474', NULL, 'Uncharacterized protein', 193, NULL, NULL, 85410),
(85411, '1.25.10.10-FF-002045', NULL, 'Importin subunit alpha-5', 250, NULL, NULL, 85411),
(85412, '1.20.1050.10-FF-000038', NULL, 'Glutathione S-transferase omega-like 2', 146, NULL, NULL, 85412),
(85413, '3.30.40.10-FF-001703', NULL, 'Protein kinase, putative', 64, NULL, NULL, 85413),
(85414, '3.30.70.330-FF-002193', NULL, NULL, 120, NULL, NULL, 85414),
(85415, '3.30.200.20-FF-001388', NULL, 'Putative receptor-like protein kinase', 115, NULL, NULL, 85415),
(85416, '2.60.40.790-FF-000085', NULL, '23.6 kDa heat shock protein, mitochondrial', 143, NULL, NULL, 85416),
(85417, '3.30.10.20-FF-000002', NULL, 'Serine/threonine protein kinase PrkC', 67, NULL, NULL, 85417),
(85418, '4.10.970.10-FF-000010', NULL, 'Caenorhabditis KU', 70, NULL, NULL, 85418),
(85419, '3.30.160.60-FF-006437', NULL, NULL, 36, NULL, NULL, 85419),
(85420, '2.60.120.260-FF-000463', NULL, 'Acetylxylan esterase / glucomannan deacetylase', 107, NULL, NULL, 85420),
(85421, '3.90.920.10-FF-000004', NULL, 'DNA primase', 414, NULL, NULL, 85421),
(85422, '3.40.50.720-FF-001157', NULL, 'Shikimate dehydrogenase (NADP(+))', 141, NULL, NULL, 85422),
(85423, '1.25.10.10-FF-002225', NULL, 'Uncharacterized protein', 400, NULL, NULL, 85423),
(85424, '2.10.50.10-FF-000027', NULL, 'tumor necrosis factor receptor superfamily member 16', 35, NULL, NULL, 85424),
(85425, '3.40.50.300-FF-000143', NULL, 'septin-9 isoform X1', 294, NULL, NULL, 85425),
(85426, '2.130.10.10-FF-003919', NULL, 'Predicted protein', 262, NULL, NULL, 85426),
(85427, '2.60.40.10-FF-004723', NULL, NULL, 91, NULL, NULL, 85427),
(85428, '3.30.70.330-FF-001344', NULL, 'RNA-binding protein', 116, NULL, NULL, 85428),
(85429, '2.102.10.10-FF-000060', NULL, 'Benzene 1,2-dioxygenase, ferredoxin protein', 109, NULL, NULL, 85429),
(85430, '1.10.3380.10-FF-000037', NULL, 'Uncharacterized protein', 135, NULL, NULL, 85430),
(85431, '1.10.238.10-FF-000404', NULL, 'Mdr1p', 184, NULL, NULL, 85431),
(85432, '2.30.29.30-FF-001213', NULL, 'Uncharacterized protein', 149, NULL, NULL, 85432),
(85433, '3.80.10.10-FF-002801', NULL, 'Predicted protein', 240, NULL, NULL, 85433),
(85434, '2.40.30.10-FF-000261', NULL, 'tRNA-specific 2-thiouridylase MnmA', 80, NULL, NULL, 85434),
(85435, '3.30.450.60-FF-000024', NULL, 'signal recognition particle receptor subunit alpha isoform X2', 129, NULL, NULL, 85435),
(85436, '2.20.20.110-FF-000009', NULL, 'DNA repair protein Rad4 homologue, putative', 59, NULL, NULL, 85436),
(85437, '3.40.50.2300-FF-001259', NULL, NULL, 64, NULL, NULL, 85437),
(85438, '3.40.190.10-FF-000498', NULL, 'GD12707', 172, NULL, NULL, 85438),
(85439, '3.10.50.40-FF-000005', NULL, 'Peptidyl-prolyl cis-trans isomerase', 113, NULL, NULL, 85439),
(85440, '2.130.10.10-FF-001862', NULL, 'Chromosome 1, whole genome shotgun sequence', 134, NULL, NULL, 85440),
(85441, '2.120.10.80-FF-000153', NULL, 'Kelch-like 11 (Drosophila), isoform CRA_a', 210, NULL, NULL, 85441),
(85442, '3.30.1050.30-FF-000001', NULL, 'Mycinamicin VI 2''''-O-methyltransferase', 150, NULL, NULL, 85442),
(85443, '2.60.40.4060-FF-000001', NULL, 'Reelin', 144, NULL, NULL, 85443);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(85444, '3.40.50.300-FF-006438', NULL, 'Uncharacterized protein', 125, NULL, NULL, 85444),
(85445, '3.30.160.60-FF-001766', NULL, 'Zinc finger protein 17', 28, NULL, NULL, 85445),
(85446, '3.30.450.20-FF-000248', NULL, 'Phosphoserine phosphatase RsbP', 106, NULL, NULL, 85446),
(85447, '1.10.510.10-FF-003359', NULL, NULL, 268, NULL, NULL, 85447),
(85448, '1.20.1280.130-FF-000004', NULL, 'Vps-54', 94, NULL, NULL, 85448),
(85449, '3.40.50.300-FF-001767', NULL, 'Rab family GTPase', 205, NULL, NULL, 85449),
(85450, '3.80.10.10-FF-001441', NULL, 'Uncharacterized protein', 129, NULL, NULL, 85450),
(85451, '3.40.50.1820-FF-001103', NULL, 'Uncharacterized protein', 97, NULL, NULL, 85451),
(85452, '2.130.10.10-FF-003178', NULL, 'Predicted protein', 186, NULL, NULL, 85452),
(85453, '3.40.50.10190-FF-000308', NULL, 'Predicted protein', 100, NULL, NULL, 85453),
(85454, '3.40.50.1820-FF-000827', NULL, 'Uncharacterized protein, isoform B', 183, NULL, NULL, 85454),
(85455, '1.20.1070.10-FF-001118', NULL, 'Predicted protein', 308, NULL, NULL, 85455),
(85456, '3.30.420.10-FF-000086', NULL, 'Ribonuclease H', 156, NULL, NULL, 85456),
(85457, '3.30.40.10-FF-000686', NULL, 'E3 ubiquitin-protein ligase, putative', 99, NULL, NULL, 85457),
(85458, '3.30.830.10-FF-000229', NULL, 'Uncharacterized protein', 122, NULL, NULL, 85458),
(85459, '3.80.10.10-FF-000031', NULL, 'leucine-rich repeat protein SHOC-2', 113, NULL, NULL, 85459),
(85460, '1.10.225.10-FF-000021', NULL, 'Saposin-related', 86, NULL, NULL, 85460),
(85461, '1.10.275.10-FF-000024', NULL, NULL, 40, NULL, NULL, 85461),
(85462, '2.60.40.1730-FF-000027', NULL, 'TAF2p TFIID subunit (150 kDa)', 212, NULL, NULL, 85462),
(85463, '3.30.930.10-FF-000052', NULL, 'Phenylalanyl-tRNA synthetase, beta subunit', 214, NULL, NULL, 85463),
(85464, '3.10.20.360-FF-000009', NULL, NULL, 31, NULL, NULL, 85464),
(85465, '2.100.10.20-FF-000001', NULL, 'Vitelline membrane outer layer 1 homolog', 173, NULL, NULL, 85465),
(85466, '3.90.550.50-FF-000009', NULL, 'Hexosyltransferase', 224, NULL, NULL, 85466),
(85467, '3.10.20.90-FF-000058', NULL, 'Octicosapeptide/phox/Bem1p domain kinase superfamily protein', 83, NULL, NULL, 85467),
(85468, '1.20.1070.10-FF-001793', NULL, 'Uncharacterized protein', 321, NULL, NULL, 85468),
(85469, '1.10.10.250-FF-000016', NULL, 'Uncharacterized protein', 47, NULL, NULL, 85469),
(85470, '3.20.10.10-FF-000027', NULL, 'Branched-chain-amino-acid aminotransferase', 176, NULL, NULL, 85470),
(85471, '3.60.110.10-FF-000005', NULL, 'nitrilase homolog 1 isoform X1', 280, NULL, NULL, 85471),
(85472, '1.25.40.10-FF-002957', NULL, 'Pentatricopeptide repeat-containing protein At5g39680', 172, NULL, NULL, 85472),
(85473, '3.90.470.20-FF-000028', NULL, '4''-phosphopantetheinyl transferase', 98, NULL, NULL, 85473),
(85474, '1.20.1000.10-FF-000035', NULL, NULL, 277, NULL, NULL, 85474),
(85475, '3.80.10.10-FF-003465', NULL, 'F-box domain containing protein', 222, NULL, NULL, 85475),
(85476, '3.40.50.12650-FF-000001', NULL, 'DNA cross-link repair 1A', 148, NULL, NULL, 85476),
(85477, '3.30.200.20-FF-001949', NULL, 'Probable serine/threonine-protein kinase mkcD', 107, NULL, NULL, 85477),
(85478, '3.30.559.10-FF-000003', NULL, 'Acetyltransferase component of pyruvate dehydrogenase complex', 241, NULL, NULL, 85478),
(85479, '3.40.1090.10-FF-000102', NULL, 'Patatin-like phospholipase domain-containing 7b', 120, NULL, NULL, 85479),
(85480, '2.160.20.10-FF-000035', NULL, 'F-box only protein 11', 126, NULL, NULL, 85480),
(85481, '1.10.510.10-FF-002842', NULL, 'Receptor tyrosine kinase-like orphan receptor', 281, NULL, NULL, 85481),
(85482, '3.30.1330.40-FF-000020', NULL, 'RutC family protein C23G10.2', 134, NULL, NULL, 85482),
(85483, '2.60.40.1180-FF-000109', NULL, 'Alpha-glucosidase', 74, NULL, NULL, 85483),
(85484, '2.130.10.10-FF-002661', NULL, 'Uncharacterized WD repeat-containing protein C27B12.05', 258, NULL, NULL, 85484),
(85485, '1.10.10.10-FF-002106', NULL, 'RIO family atypical protein kinase', 90, NULL, NULL, 85485),
(85486, '3.30.70.1590-FF-000008', NULL, NULL, 69, NULL, NULL, 85486);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(85487, '3.90.1420.10-FF-000010', NULL, 'Protein SET DOMAIN GROUP 40', 138, NULL, NULL, 85487),
(85488, '1.10.10.60-FF-001290', NULL, NULL, 48, NULL, NULL, 85488),
(85489, '3.90.76.10-FF-000058', NULL, 'ABC-type dipeptide transport system periplasmic component-like protein', 102, NULL, NULL, 85489),
(85490, '2.10.90.10-FF-000069', NULL, 'noggin', 78, NULL, NULL, 85490),
(85491, '1.10.510.10-FF-004158', NULL, NULL, 198, NULL, NULL, 85491),
(85492, '2.60.40.10-FF-003762', NULL, NULL, 96, NULL, NULL, 85492),
(85493, '3.40.50.300-FF-007287', NULL, 'RAS like family 12', 153, NULL, NULL, 85493),
(85494, '3.10.20.310-FF-000023', NULL, 'Outer membrane protein', 77, NULL, NULL, 85494),
(85495, '1.20.120.80-FF-000004', NULL, 'Cytochrome c oxidase, subunit III', 171, NULL, NULL, 85495),
(85496, '3.40.850.10-FF-000234', NULL, 'Iar1 InvA related Kinesin', 400, NULL, NULL, 85496),
(85497, '3.40.50.2000-FF-000983', NULL, 'Uncharacterized protein', 65, NULL, NULL, 85497),
(85498, '3.40.50.720-FF-001718', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 281, NULL, NULL, 85498),
(85499, '2.60.40.10-FF-005263', NULL, NULL, 87, NULL, NULL, 85499),
(85500, '2.30.29.30-FF-000775', NULL, 'Uncharacterized protein', 107, NULL, NULL, 85500),
(85501, '3.30.530.20-FF-000125', NULL, 'Major allergen Pru ar 1', 116, NULL, NULL, 85501),
(85502, '3.10.650.10-FF-000001', NULL, 'Maltose ABC transporter permease MalF', 84, NULL, NULL, 85502),
(85503, '3.40.710.10-FF-000084', NULL, 'Peptidoglycan D,D-transpeptidase FtsI', 181, NULL, NULL, 85503),
(85504, '3.30.1330.60-FF-000026', NULL, 'OmpA family protein', 143, NULL, NULL, 85504),
(85505, '3.20.20.60-FF-000133', NULL, 'Predicted protein', 46, NULL, NULL, 85505),
(85506, '1.10.540.10-FF-000096', NULL, 'Uncharacterized protein', 130, NULL, NULL, 85506),
(85507, '3.40.50.12670-FF-000007', NULL, 'Uncharacterized protein', 142, NULL, NULL, 85507),
(85508, '3.30.565.10-FF-000124', NULL, 'Histidine kinase', 141, NULL, NULL, 85508),
(85509, '1.20.1600.10-FF-000013', NULL, 'Outer membrane channel protein', 429, NULL, NULL, 85509),
(85510, '3.40.50.300-FF-003976', NULL, 'Guanine nucleotide-binding protein alpha-1 subunit', 206, NULL, NULL, 85510),
(85511, '3.40.630.10-FF-000083', NULL, 'aminoacylase-1 isoform X3', 132, NULL, NULL, 85511),
(85512, '3.30.160.60-FF-003975', NULL, NULL, 62, NULL, NULL, 85512),
(85513, '4.10.60.10-FF-000068', NULL, 'cellular nucleic acid-binding protein isoform X5', 26, NULL, NULL, 85513),
(85514, '3.50.50.60-FF-000274', NULL, 'Selenide water dikinase', 121, NULL, NULL, 85514),
(85515, '2.40.30.10-FF-000030', NULL, 'cytochrome b-245 heavy chain', 102, NULL, NULL, 85515),
(85516, '3.30.70.260-FF-000176', NULL, 'Uncharacterized protein', 62, NULL, NULL, 85516),
(85517, '1.10.10.10-FF-001825', NULL, 'Predicted protein', 138, NULL, NULL, 85517),
(85518, '3.30.1520.10-FF-000020', NULL, 'nischarin isoform X1', 110, NULL, NULL, 85518),
(85519, '3.30.160.60-FF-000541', NULL, 'Zinc finger protein 462', 102, NULL, NULL, 85519),
(85520, '3.40.50.1380-FF-000033', NULL, 'ATIC', 106, NULL, NULL, 85520),
(85521, '2.130.10.10-FF-002161', NULL, 'Uncharacterized protein, isoform A', 132, NULL, NULL, 85521),
(85522, '1.25.40.10-FF-001384', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 108, NULL, NULL, 85522),
(85523, '1.20.920.20-FF-000070', NULL, 'Uncharacterized protein', 192, NULL, NULL, 85523),
(85524, '1.25.40.10-FF-001440', NULL, 'Sel1 repeat family protein', 82, NULL, NULL, 85524),
(85525, '3.30.160.60-FF-003239', NULL, 'Zinc finger protein 1144', 29, NULL, NULL, 85525),
(85526, '3.30.200.20-FF-000668', NULL, 'Serine/threonine-protein kinase Nek6', 95, NULL, NULL, 85526),
(85527, '3.30.420.40-FF-000421', NULL, 'N-acetylglucosamine repressor', 122, NULL, NULL, 85527),
(85528, '1.20.140.150-FF-000118', NULL, 'Uncharacterized protein', 226, NULL, NULL, 85528),
(85529, '2.40.30.30-FF-000036', NULL, 'Predicted protein', 147, NULL, NULL, 85529),
(85530, '3.40.50.300-FF-002560', NULL, 'Axonemal dynein heavy chain', 161, NULL, NULL, 85530),
(85531, '1.25.40.10-FF-000872', NULL, 'Putative pentatricopeptide repeat-containing protein', 132, NULL, NULL, 85531);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(85532, '1.20.1250.20-FF-001141', NULL, 'Uncharacterized protein', 203, NULL, NULL, 85532),
(85533, '3.30.230.70-FF-000078', NULL, 'RNase PH family, RRP42 subunit protein', 220, NULL, NULL, 85533),
(85534, '2.130.10.10-FF-001593', NULL, 'protein lethal(2)denticleless', 281, NULL, NULL, 85534),
(85535, '3.30.230.70-FF-000134', NULL, '3'' exoribonuclease family, domain 1 containing protein', 193, NULL, NULL, 85535),
(85536, '3.30.420.40-FF-000365', NULL, 'Conserved hypothetical proline and threonine rich protein', 102, NULL, NULL, 85536),
(85537, '1.20.1560.10-FF-000925', NULL, 'ABC transporter', 79, NULL, NULL, 85537),
(85538, '2.40.50.90-FF-000010', NULL, 'Ribonuclease', 124, NULL, NULL, 85538),
(85539, '3.10.580.10-FF-000118', NULL, 'Domain_of_uncharacterized_function_DUF21 /CBS_domain_containing_protein_-_putative', 145, NULL, NULL, 85539),
(85540, '2.40.20.10-FF-000108', NULL, 'Uncharacterized protein', 125, NULL, NULL, 85540),
(85541, '2.30.29.30-FF-001000', NULL, 'Uncharacterized protein', 128, NULL, NULL, 85541),
(85542, '2.10.25.10-FF-000727', NULL, 'Stabilin 1', 42, NULL, NULL, 85542),
(85543, '3.90.780.10-FF-000009', NULL, 'Ser/Thr protein phosphatase family', 125, NULL, NULL, 85543),
(85544, '3.30.750.24-FF-000118', NULL, 'Sulfate/bicarbonate/oxalate exchanger SAT-1, putative', 109, NULL, NULL, 85544),
(85545, '1.25.10.10-FF-001505', NULL, 'Exportin-T', 665, NULL, NULL, 85545),
(85546, '2.60.40.150-FF-000005', NULL, 'Synaptotagmin 6', 145, NULL, NULL, 85546),
(85547, '3.60.21.10-FF-000343', NULL, 'Uncharacterized protein', 155, NULL, NULL, 85547),
(85548, '2.40.30.110-FF-000018', NULL, 'Glycine cleavage system aminomethyltransferase T', 78, NULL, NULL, 85548),
(85549, '3.30.40.10-FF-001934', NULL, 'Uncharacterized protein', 70, NULL, NULL, 85549),
(85550, '3.20.20.300-FF-000080', NULL, NULL, 199, NULL, NULL, 85550),
(85551, '1.10.4160.10-FF-000004', NULL, 'Putative allantoin permease', 476, NULL, NULL, 85551),
(85552, '2.10.25.10-FF-001340', NULL, 'Uncharacterized protein', 44, NULL, NULL, 85552),
(85553, '3.40.50.2300-FF-001028', NULL, NULL, 158, NULL, NULL, 85553),
(85554, '3.30.160.570-FF-000002', NULL, NULL, 60, NULL, NULL, 85554),
(85555, '3.30.750.24-FF-000169', NULL, 'Uncharacterized protein', 88, NULL, NULL, 85555),
(85556, '2.10.25.10-FF-001239', NULL, 'Coagulation factor VII', 46, NULL, NULL, 85556),
(85557, '3.80.10.10-FF-001672', NULL, 'Uncharacterized protein', 166, NULL, NULL, 85557),
(85558, '3.30.160.60-FF-000485', NULL, 'Zinc finger protein 90 homolog', 32, NULL, NULL, 85558),
(85559, '3.30.160.100-FF-000002', NULL, 'Ribosome-associated translation inhibitor RaiA', 106, NULL, NULL, 85559),
(85560, '3.40.50.720-FF-001550', NULL, 'YALI0A19536p', 257, NULL, NULL, 85560),
(85561, '3.40.630.10-FF-000370', NULL, 'Uncharacterized protein', 120, NULL, NULL, 85561),
(85562, '3.30.70.330-FF-001001', NULL, 'RNA recognition motif domain containing protein', 91, NULL, NULL, 85562),
(85563, '2.60.120.650-FF-000041', NULL, 'lysine-specific demethylase 5C isoform X6', 171, NULL, NULL, 85563),
(85564, '3.40.33.10-FF-000012', NULL, 'Secreted protein PRY1', 139, NULL, NULL, 85564),
(85565, '3.10.20.90-FF-000327', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 79, NULL, NULL, 85565),
(85566, '2.130.10.10-FF-005920', NULL, 'Uncharacterized protein', 273, NULL, NULL, 85566),
(85567, '3.40.50.720-FF-000033', NULL, 'Adenylyltransferase and sulfurtransferase MOCS3', 248, NULL, NULL, 85567),
(85568, '1.10.238.10-FF-001124', NULL, 'Uncharacterized protein', 29, NULL, NULL, 85568),
(85569, '1.10.540.10-FF-000040', NULL, 'Acyl-CoA dehydrogenase', 123, NULL, NULL, 85569),
(85570, '3.40.50.300-FF-006831', NULL, 'Uncharacterized protein', 269, NULL, NULL, 85570),
(85571, '3.40.630.30-FF-000358', NULL, 'Predicted protein', 92, NULL, NULL, 85571),
(85572, '1.10.437.10-FF-000018', NULL, 'BCL2 like 15', 159, NULL, NULL, 85572),
(85573, '3.30.500.10-FF-000031', NULL, 'T-cell surface glycoprotein CD1A1 antigen', 178, NULL, NULL, 85573),
(85574, '1.20.1280.290-FF-000030', NULL, 'Bidirectional sugar transporter SWEET3b', 92, NULL, NULL, 85574);
INSERT INTO "PUBLIC"."MODEL" VALUES
(85575, '1.10.520.10-FF-000033', NULL, 'Uncharacterized protein', 143, NULL, NULL, 85575),
(85576, '3.40.309.10-FF-000078', NULL, 'Succinate-semialdehyde dehydrogenase', 192, NULL, NULL, 85576),
(85577, '3.30.1490.480-FF-000014', NULL, NULL, 73, NULL, NULL, 85577),
(85578, '1.10.4080.10-FF-000003', NULL, 'ADP-ribosyl-[dinitrogen reductase] glycohydrolase', 299, NULL, NULL, 85578),
(85579, '1.25.10.10-FF-000196', NULL, 'Sperm associated antigen 6', 230, NULL, NULL, 85579),
(85580, '3.30.1600.10-FF-000021', NULL, 'NAD-dependent histone deacetylase Sir2', 94, NULL, NULL, 85580),
(85581, '2.120.10.80-FF-000130', NULL, 'Kelch repeat-containing protein 1', 113, NULL, NULL, 85581),
(85582, '1.25.10.10-FF-000252', NULL, 'pumilio homolog 3 isoform X1', 150, NULL, NULL, 85582),
(85583, '3.50.50.60-FF-000223', NULL, '6-hydroxynicotinate 3-monooxygenase', 377, NULL, NULL, 85583),
(85584, '3.40.50.1440-FF-000124', NULL, 'Uncharacterized protein', 73, NULL, NULL, 85584),
(85585, '3.30.230.70-FF-000027', NULL, 'Exosome complex component RRP46', 213, NULL, NULL, 85585),
(85586, '3.30.1640.10-FF-000023', NULL, 'DNA replication licensing factor MCM7', 101, NULL, NULL, 85586),
(85587, '3.40.309.10-FF-000027', NULL, 'Phenylacetaldehyde dehydrogenase', 190, NULL, NULL, 85587),
(85588, '3.40.50.970-FF-000203', NULL, 'Uncharacterized protein', 83, NULL, NULL, 85588),
(85589, '3.40.50.300-FF-006882', NULL, 'Uncharacterized protein', 327, NULL, NULL, 85589),
(85590, '1.20.58.400-FF-000010', NULL, 'VTI (Vesicle Transport through t-SNARE Interaction) homolog', 100, NULL, NULL, 85590),
(85591, '1.10.1070.11-FF-000037', NULL, 'Phosphatidylinositol kinase (PIK-L3)', 194, NULL, NULL, 85591),
(85592, '3.20.20.140-FF-000458', NULL, 'Guanine deaminase', 311, NULL, NULL, 85592),
(85593, '3.90.1750.10-FF-000046', NULL, 'Hyperplastic disks-like protein', 122, NULL, NULL, 85593),
(85594, '3.40.640.10-FF-000191', NULL, 'Serine-pyruvate aminotransferase (AgxT)', 263, NULL, NULL, 85594),
(85595, '3.40.50.720-FF-001449', NULL, 'Uncharacterized protein', 66, NULL, NULL, 85595),
(85596, '2.40.50.100-FF-000177', NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase-like isoform X1', 78, NULL, NULL, 85596),
(85597, '2.40.50.100-FF-000233', NULL, 'Molybdenum import ATP-binding protein ModC', 72, NULL, NULL, 85597),
(85598, '2.70.98.10-FF-000016', NULL, 'Glucose-6-phosphate 1-epimerase', 284, NULL, NULL, 85598),
(85599, '3.50.50.60-FF-000959', NULL, 'Predicted protein', 176, NULL, NULL, 85599),
(85600, '1.25.10.10-FF-001556', NULL, 'Uncharacterized protein', 310, NULL, NULL, 85600),
(85601, '3.60.21.10-FF-000394', NULL, 'Serine/threonine-protein phosphatase', 329, NULL, NULL, 85601),
(85602, '1.25.10.10-FF-000988', NULL, 'Crescerin-like protein che-12', 249, NULL, NULL, 85602),
(85603, '2.30.29.30-FF-000432', NULL, 'Calcium-dependent protein kinase 7', 105, NULL, NULL, 85603),
(85604, '2.10.70.10-FF-000298', NULL, 'Uncharacterized protein', 44, NULL, NULL, 85604),
(85605, '1.10.510.10-FF-002573', NULL, NULL, 242, NULL, NULL, 85605),
(85606, '2.60.40.60-FF-000590', NULL, 'Si:ch73-74h11.1', 94, NULL, NULL, 85606),
(85607, '3.30.70.1450-FF-000028', NULL, 'Potassium transporter peripheral membrane component', 86, NULL, NULL, 85607),
(85608, '1.20.120.980-FF-000037', NULL, 'Serine carboxypeptidase S28 family protein', 107, NULL, NULL, 85608),
(85609, '3.30.300.30-FF-000089', NULL, 'NonRibosomal Peptide Synthetase', 96, NULL, NULL, 85609),
(85610, '3.40.50.300-FF-006775', NULL, 'Uncharacterized protein', 60, NULL, NULL, 85610),
(85611, '3.40.50.620-FF-000677', NULL, 'Predicted protein', 202, NULL, NULL, 85611),
(85612, '1.10.238.10-FF-001068', NULL, 'Uncharacterized protein', 77, NULL, NULL, 85612),
(85613, '2.60.40.10-FF-000092', NULL, 'Filamin-B isoform B', 97, NULL, NULL, 85613),
(85614, '3.30.40.10-FF-000681', NULL, 'BnaA09g51130D protein', 117, NULL, NULL, 85614),
(85615, '4.10.400.10-FF-000147', NULL, 'Low-density lipoprotein receptor-related protein 2', 41, NULL, NULL, 85615),
(85616, '3.90.226.10-FF-000082', NULL, 'Putative enoyl-CoA hydratase', 196, NULL, NULL, 85616);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(85617, '3.60.21.10-FF-000287', NULL, 'Serine/threonine-protein phosphatase', 183, NULL, NULL, 85617),
(85618, '2.120.10.80-FF-000074', NULL, 'Kelch domain containing 3', 210, NULL, NULL, 85618),
(85619, '3.90.660.20-FF-000003', NULL, 'Prenylcysteine oxidase-like protein', 41, NULL, NULL, 85619),
(85620, '3.40.50.360-FF-000166', NULL, 'Uncharacterized protein', 90, NULL, NULL, 85620),
(85621, '3.40.50.1000-FF-000172', NULL, 'Phospholipid-transporting ATPase', 184, NULL, NULL, 85621),
(85622, '1.10.10.2010-FF-000005', NULL, NULL, 71, NULL, NULL, 85622),
(85623, '3.40.630.30-FF-000414', NULL, 'Chromodomain-helicase-DNA-binding protein 4', 166, NULL, NULL, 85623),
(85624, '1.10.510.10-FF-003859', NULL, NULL, 100, NULL, NULL, 85624),
(85625, '2.10.25.10-FF-001391', NULL, 'Uncharacterized protein', 69, NULL, NULL, 85625),
(85626, '1.20.1560.10-FF-000184', NULL, 'Multidrug ABC transporter ATP-binding protein', 359, NULL, NULL, 85626),
(85627, '1.20.5.170-FF-000177', NULL, 'Laminin subunit alpha 3', 141, NULL, NULL, 85627),
(85628, '3.30.910.20-FF-000003', NULL, 'Outer membrane protein ompH', 139, NULL, NULL, 85628),
(85629, '2.60.40.10-FF-005156', NULL, NULL, 95, NULL, NULL, 85629),
(85630, '3.30.200.20-FF-001606', NULL, 'Protein kinase, catalytic domain', 102, NULL, NULL, 85630),
(85631, '3.40.50.2300-FF-001091', NULL, NULL, 160, NULL, NULL, 85631),
(85632, '1.25.40.20-FF-000549', NULL, 'AGAP006384-PA', 153, NULL, NULL, 85632),
(85633, '3.30.40.100-FF-000004', NULL, 'MORC family CW-type zinc finger 1', 57, NULL, NULL, 85633),
(85634, '3.40.50.10810-FF-000146', NULL, 'RAD54L isoform 5', 85, NULL, NULL, 85634),
(85635, '3.40.525.10-FF-000001', NULL, 'BCL2/adenovirus E1B protein-interacting protein 2', 156, NULL, NULL, 85635),
(85636, '3.40.50.300-FF-004358', NULL, 'Putative anion ABC transporter, ATP-binding protein', 232, NULL, NULL, 85636),
(85637, '3.30.70.2190-FF-000008', NULL, 'Actin interacting protein-like protein', 137, NULL, NULL, 85637),
(85638, '3.30.40.10-FF-001193', NULL, 'GD24108', 63, NULL, NULL, 85638),
(85639, '1.20.190.20-FF-000007', NULL, '14-3-3 protein beta/alpha', 85, NULL, NULL, 85639),
(85640, '3.40.50.10190-FF-000359', NULL, 'Predicted protein', 64, NULL, NULL, 85640),
(85641, '3.40.50.1820-FF-000210', NULL, 'Possible long-chain acyl-CoA synthase', 313, NULL, NULL, 85641),
(85642, '3.40.50.11340-FF-000013', NULL, 'Uncharacterized protein', 129, NULL, NULL, 85642),
(85643, '3.30.70.980-FF-000061', NULL, 'Uncharacterized protein', 74, NULL, NULL, 85643),
(85644, '3.20.20.190-FF-000119', NULL, NULL, 108, NULL, NULL, 85644),
(85645, '3.40.640.10-FF-000084', NULL, 'IscS-like cysteine desulfurase', 177, NULL, NULL, 85645),
(85646, '3.10.450.700-FF-000011', NULL, 'Ci-PUR-alpha/beta/gamma protein', 74, NULL, NULL, 85646),
(85647, '3.40.30.10-FF-000770', NULL, 'Peroxiredoxin', 164, NULL, NULL, 85647),
(85648, '1.25.40.570-FF-000052', NULL, 'COP9 signalosome complex subunit 1', 340, NULL, NULL, 85648),
(85649, '1.10.472.80-FF-000082', NULL, 'Unplaced genomic scaffold supercont1.67, whole genome shotgun sequence', 125, NULL, NULL, 85649),
(85650, '1.10.510.10-FF-000156', NULL, 'Serine/threonine-protein kinase SIK3 homolog', 343, NULL, NULL, 85650),
(85651, '1.20.120.1900-FF-000005', NULL, 'Gamma-tubulin complex component', 303, NULL, NULL, 85651),
(85652, '3.40.50.10810-FF-000202', NULL, 'Uncharacterized protein', 154, NULL, NULL, 85652),
(85653, '3.80.10.10-FF-002958', NULL, 'Uncharacterized protein AT4g09430', 218, NULL, NULL, 85653),
(85654, '2.60.120.820-FF-000007', NULL, 'Macaca fascicularis brain cDNA clone: QmoA-10892, similar to human BTB (POZ) domain containing 1 (BTBD1), mRNA, RefSeq: NM_025238.1', 73, NULL, NULL, 85654),
(85655, '3.40.390.10-FF-000159', NULL, 'Neutral protease 2', 171, NULL, NULL, 85655),
(85656, '3.30.160.60-FF-005656', NULL, NULL, 27, NULL, NULL, 85656),
(85657, '3.30.160.60-FF-005712', NULL, NULL, 49, NULL, NULL, 85657),
(85658, '3.30.200.20-FF-002118', NULL, NULL, 76, NULL, NULL, 85658),
(85659, '2.70.150.10-FF-000228', NULL, 'Plasma membrane calcium-transporting ATPase putative', 131, NULL, NULL, 85659);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(85660, '3.30.160.60-FF-002790', NULL, 'Uncharacterized protein', 30, NULL, NULL, 85660),
(85661, '3.40.228.10-FF-000002', NULL, 'Formate dehydrogenase subunit alpha', 196, NULL, NULL, 85661),
(85662, '3.30.300.30-FF-000038', NULL, 'Nonribosomal siderophore peptide synthase SidC', 120, NULL, NULL, 85662),
(85663, '1.25.40.10-FF-000080', NULL, 'hsc70-interacting protein-like isoform X1', 174, NULL, NULL, 85663),
(85664, '2.60.120.200-FF-000260', NULL, 'CAlSYntenin/Alcadein homolog', 214, NULL, NULL, 85664),
(85665, '3.30.70.1070-FF-000010', NULL, 'Sporulation related domain protein', 74, NULL, NULL, 85665),
(85666, '2.60.40.10-FF-004700', NULL, NULL, 108, NULL, NULL, 85666),
(85667, '2.130.10.10-FF-005813', NULL, 'Uncharacterized protein', 80, NULL, NULL, 85667),
(85668, '1.10.510.10-FF-000268', NULL, 'Receptor protein-tyrosine kinase', 190, NULL, NULL, 85668),
(85669, '1.10.510.10-FF-004427', NULL, NULL, 61, NULL, NULL, 85669),
(85670, '2.130.10.10-FF-002902', NULL, 'Uncharacterized protein', 232, NULL, NULL, 85670),
(85671, '2.20.70.10-FF-000157', NULL, 'E3 ubiquitin-protein ligase', 37, NULL, NULL, 85671),
(85672, '3.90.550.10-FF-000464', NULL, '2-C-methyl-D-erythritol 4-phosphate cytidylyltransferase', 228, NULL, NULL, 85672),
(85673, '1.25.40.20-FF-001662', NULL, 'RE06111p', 84, NULL, NULL, 85673),
(85674, '3.90.550.10-FF-000352', NULL, 'Cellulose synthase A', 168, NULL, NULL, 85674),
(85675, '3.90.70.10-FF-000112', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 370, NULL, NULL, 85675),
(85676, '1.10.340.30-FF-000047', NULL, 'DNA glycosylase', 124, NULL, NULL, 85676),
(85677, '1.10.274.100-FF-000007', NULL, 'DNA-directed RNA polymerase subunit', 174, NULL, NULL, 85677),
(85678, '3.30.30.30-FF-000051', NULL, 'Putative heat shock 70 kDa protein 14', 57, NULL, NULL, 85678),
(85679, '2.60.120.800-FF-000001', NULL, 'Outer capsid glycoprotein VP7', 87, NULL, NULL, 85679),
(85680, '3.40.50.150-FF-000165', NULL, 'probable methyltransferase PMT13', 165, NULL, NULL, 85680),
(85681, '1.10.3210.10-FF-000003', NULL, 'Ribonuclease Y', 154, NULL, NULL, 85681),
(85682, '1.10.8.60-FF-000485', NULL, 'Adenosinetriphosphatase', 97, NULL, NULL, 85682),
(85683, '2.60.40.10-FF-001845', NULL, 'Bent, isoform H', 95, NULL, NULL, 85683),
(85684, '1.20.1050.80-FF-000019', NULL, 'RIN (Ras/Rab INteractor) homolog', 162, NULL, NULL, 85684),
(85685, '1.20.1560.10-FF-000133', NULL, 'Uncharacterized protein, isoform B', 333, NULL, NULL, 85685),
(85686, '3.30.1490.20-FF-000082', NULL, 'Uncharacterized protein', 70, NULL, NULL, 85686),
(85687, '1.25.40.570-FF-000001', NULL, 'Putative cop9 signalosome complex subunit 2', 373, NULL, NULL, 85687),
(85688, '1.10.357.70-FF-000007', NULL, 'Unplaced genomic scaffold supercont1.138, whole genome shotgun sequence', 175, NULL, NULL, 85688),
(85689, '3.30.420.40-FF-000314', NULL, 'Actin-related protein 6', 90, NULL, NULL, 85689),
(85690, '2.60.120.970-FF-000024', NULL, 'Left-right determination factor', 238, NULL, NULL, 85690),
(85691, '3.10.580.10-FF-000181', NULL, 'Chloride channel, voltage-sensitive 1a', 89, NULL, NULL, 85691),
(85692, '3.80.10.10-FF-001609', NULL, 'Pollen receptor-like kinase 4', 118, NULL, NULL, 85692),
(85693, '1.20.1740.10-FF-000170', NULL, 'High affinity cationic amino acid transporter 1-like Protein', 147, NULL, NULL, 85693),
(85694, '3.40.50.720-FF-000937', NULL, 'Short-chain dehydrogenase/reductase family protein', 231, NULL, NULL, 85694),
(85695, '2.40.10.10-FF-000338', NULL, NULL, 110, NULL, NULL, 85695),
(85696, '3.30.200.20-FF-002181', NULL, 'Predicted protein', 58, NULL, NULL, 85696),
(85697, '3.40.50.2000-FF-000663', NULL, 'Glycosyltransferase', 228, NULL, NULL, 85697),
(85698, '1.20.5.420-FF-000011', NULL, 'Vacuolar protein sorting-associated protein VTA1', 53, NULL, NULL, 85698),
(85699, '3.30.300.10-FF-000032', NULL, 'S-adenosylmethionine synthase', 103, NULL, NULL, 85699),
(85700, '3.50.50.60-FF-000167', NULL, 'Flavin-containing monooxygenase', 270, NULL, NULL, 85700),
(85701, '3.40.800.20-FF-000060', NULL, 'Histone deacetylase', 382, NULL, NULL, 85701); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(85702, '1.10.8.970-FF-000003', NULL, 'Genome polyprotein', 75, NULL, NULL, 85702),
(85703, '2.60.40.10-FF-000833', NULL, 'Titin b', 106, NULL, NULL, 85703),
(85704, '3.40.190.80-FF-000030', NULL, 'Myo-inositol-1(Or 4)-monophosphatase', 120, NULL, NULL, 85704),
(85705, '1.10.10.10-FF-001140', NULL, 'DNA-binding transcriptional regulator, Lrp family', 53, NULL, NULL, 85705),
(85706, '1.10.10.440-FF-000079', NULL, 'Uncharacterized protein', 75, NULL, NULL, 85706),
(85707, '1.25.40.90-FF-000002', NULL, 'epsin-2 isoform X1', 144, NULL, NULL, 85707),
(85708, '3.30.413.10-FF-000002', NULL, '4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase (flavodoxin)', 100, NULL, NULL, 85708),
(85709, '1.10.601.10-FF-000007', NULL, 'RNA polymerase sigma factor sigB', 320, NULL, NULL, 85709),
(85710, '3.40.20.10-FF-000038', NULL, 'Villin-like 1', 122, NULL, NULL, 85710),
(85711, '3.40.50.300-FF-003009', NULL, 'Uncharacterized protein', 268, NULL, NULL, 85711),
(85712, '3.40.50.720-FF-000201', NULL, 'UDP-D-apiose/UDP-D-xylose synthase 2', 364, NULL, NULL, 85712),
(85713, '3.30.160.60-FF-006168', NULL, NULL, 73, NULL, NULL, 85713),
(85714, '1.10.565.10-FF-000187', NULL, 'Uncharacterized protein', 101, NULL, NULL, 85714),
(85715, '1.10.101.10-FF-000037', NULL, 'Anhydro-N-acetylmuramyl-tripeptide amidase', 82, NULL, NULL, 85715),
(85716, '3.10.20.90-FF-000378', NULL, 'FERM domain (Protein4.1-ezrin-radixin-moesin) family', 83, NULL, NULL, 85716),
(85717, '4.10.400.10-FF-000035', NULL, 'prolow-density lipoprotein receptor-related protein 1', 44, NULL, NULL, 85717),
(85718, '2.10.110.40-FF-000001', NULL, 'E1A binding protein p300', 68, NULL, NULL, 85718),
(85719, '1.10.420.10-FF-000042', NULL, 'Ascorbate peroxidase', 121, NULL, NULL, 85719),
(85720, '3.20.20.380-FF-000002', NULL, 'copper homeostasis protein cutC homolog', 249, NULL, NULL, 85720),
(85721, '3.40.980.10-FF-000007', NULL, 'FAD synthase', 165, NULL, NULL, 85721),
(85722, '3.30.565.10-FF-000231', NULL, 'Sensor histidine kinase', 159, NULL, NULL, 85722),
(85723, '3.30.160.60-FF-005156', NULL, NULL, 110, NULL, NULL, 85723),
(85724, '3.90.1750.10-FF-000091', NULL, 'Predicted protein', 163, NULL, NULL, 85724),
(85725, '3.30.70.330-FF-000063', NULL, 'MEI2-like protein 5 isoform 2', 95, NULL, NULL, 85725),
(85726, '3.40.50.1820-FF-001547', NULL, 'Uncharacterized protein', 125, NULL, NULL, 85726),
(85727, '1.25.40.420-FF-000035', NULL, 'CBN-EOR-1 protein', 119, NULL, NULL, 85727),
(85728, '2.130.10.10-FF-005864', NULL, 'Cation-transporting ATPase', 312, NULL, NULL, 85728),
(85729, '2.10.80.10-FF-000012', NULL, 'Dkk3-like 2 protein', 89, NULL, NULL, 85729),
(85730, '2.70.150.10-FF-000291', NULL, 'Cation-transporting ATPase', 217, NULL, NULL, 85730),
(85731, '1.10.3210.10-FF-000059', NULL, 'Metal-dependent phosphohydrolase', 224, NULL, NULL, 85731),
(85732, '2.60.120.920-FF-000071', NULL, 'Compass component bre2', 220, NULL, NULL, 85732),
(85733, '3.30.497.10-FF-000111', NULL, 'Serine protease inhibitor, putative', 193, NULL, NULL, 85733),
(85734, '3.30.1490.20-FF-000031', NULL, 'Synapsin III', 30, NULL, NULL, 85734),
(85735, '3.40.50.150-FF-001469', NULL, NULL, 132, NULL, NULL, 85735),
(85736, '3.30.70.330-FF-001349', NULL, 'CiMsi', 116, NULL, NULL, 85736),
(85737, '1.10.630.10-FF-000760', NULL, 'Cytochrome P450', 485, NULL, NULL, 85737),
(85738, '3.40.190.10-FF-000211', NULL, 'Phosphate-binding protein PstS', 137, NULL, NULL, 85738),
(85739, '1.10.533.10-FF-000012', NULL, 'baculoviral IAP repeat-containing protein 2', 128, NULL, NULL, 85739),
(85740, '2.30.29.30-FF-001056', NULL, 'Uncharacterized protein', 86, NULL, NULL, 85740),
(85741, '3.90.1490.10-FF-000008', NULL, 'ATP-binding domain containing protein', 90, NULL, NULL, 85741),
(85742, '3.30.200.20-FF-000264', NULL, 'Protein-ribulosamine 3-kinase, chloroplastic', 90, NULL, NULL, 85742),
(85743, '1.10.533.10-FF-000248', NULL, 'Uncharacterized protein', 82, NULL, NULL, 85743),
(85744, '1.10.10.720-FF-000005', NULL, 'Leucine--tRNA ligase', 52, NULL, NULL, 85744),
(85745, '3.30.200.20-FF-000320', NULL, 'probable L-type lectin-domain containing receptor kinase S.5', 95, NULL, NULL, 85745);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(85746, '1.10.533.10-FF-000304', NULL, 'Uncharacterized protein', 65, NULL, NULL, 85746),
(85747, '3.30.200.20-FF-000612', NULL, 'Mitogen-activated protein kinase', 59, NULL, NULL, 85747),
(85748, '1.10.400.10-FF-000035', NULL, 'Uncharacterized protein', 120, NULL, NULL, 85748),
(85749, '3.30.1370.10-FF-000098', NULL, 'Pbp2p', 73, NULL, NULL, 85749),
(85750, '3.60.21.60-FF-000004', NULL, 'DNA polymerase alpha subunit B', 167, NULL, NULL, 85750),
(85751, '3.30.70.330-FF-001405', NULL, 'YALI0B00616p', 86, NULL, NULL, 85751),
(85752, '1.20.5.190-FF-000127', NULL, NULL, 60, NULL, NULL, 85752),
(85753, '4.10.960.10-FF-000009', NULL, 'Uncharacterized protein', 68, NULL, NULL, 85753),
(85754, '2.30.29.30-FF-000488', NULL, 'Ran-binding protein 1, putative', 156, NULL, NULL, 85754),
(85755, '2.60.40.60-FF-000415', NULL, 'cadherin-89D', 103, NULL, NULL, 85755),
(85756, '3.30.160.60-FF-000081', NULL, 'Zinc finger homeobox protein 4', 27, NULL, NULL, 85756),
(85757, '3.30.342.10-FF-000039', NULL, 'DNA polymerase', 164, NULL, NULL, 85757),
(85758, '2.30.38.10-FF-000020', NULL, 'Non-ribosomal peptide synthetase OfaA', 78, NULL, NULL, 85758),
(85759, '1.20.120.1630-FF-000020', NULL, 'Phosphatidylethanolamine N-methyltransferase', 191, NULL, NULL, 85759),
(85760, '2.60.40.150-FF-000409', NULL, 'Uncharacterized protein', 109, NULL, NULL, 85760),
(85761, '1.10.720.30-FF-000065', NULL, 'Uncharacterized protein', 37, NULL, NULL, 85761),
(85762, '2.170.140.10-FF-000018', NULL, 'MIP27520p', 71, NULL, NULL, 85762),
(85763, '1.20.5.170-FF-000121', NULL, 'Transcription factor jun-1', 67, NULL, NULL, 85763),
(85764, '1.10.1410.10-FF-000035', NULL, 'Mitochondrial editosome-like complex associated TUTase', 248, NULL, NULL, 85764),
(85765, '2.60.40.150-FF-000117', NULL, 'copine-5 isoform X1', 135, NULL, NULL, 85765),
(85766, '3.60.130.10-FF-000012', NULL, 'Pyoverdine/dityrosine biosynthesis protein, putative (AFU_orthologue AFUA_5G02660)', 286, NULL, NULL, 85766),
(85767, '1.10.10.60-FF-000233', NULL, 'Distal-less, isoform C', 76, NULL, NULL, 85767),
(85768, '2.30.29.30-FF-000836', NULL, 'Uncharacterized protein', 117, NULL, NULL, 85768),
(85769, '1.10.3130.10-FF-000002', NULL, 'Serine acetyltransferase', 66, NULL, NULL, 85769),
(85770, '4.10.400.10-FF-000086', NULL, 'Terribly reduced optic lobes, isoform B', 38, NULL, NULL, 85770),
(85771, '1.20.58.60-FF-000432', NULL, 'AGAP009554-PA', 284, NULL, NULL, 85771),
(85772, '3.30.160.60-FF-004700', NULL, NULL, 37, NULL, NULL, 85772),
(85773, '2.102.10.10-FF-000015', NULL, 'Naphthalene 1,2-dioxygenase ferredoxin component', 103, NULL, NULL, 85773),
(85774, '3.30.160.60-FF-002806', NULL, 'Uncharacterized protein, isoform B', 99, NULL, NULL, 85774),
(85775, '3.40.20.10-FF-000033', NULL, 'Villin-4', 137, NULL, NULL, 85775),
(85776, '1.10.3210.10-FF-000110', NULL, 'Uncharacterized protein', 45, NULL, NULL, 85776),
(85777, '1.20.58.80-FF-000045', NULL, 'Spartin a', 95, NULL, NULL, 85777),
(85778, '3.40.50.10810-FF-000141', NULL, 'Uncharacterized protein', 182, NULL, NULL, 85778),
(85779, '3.40.50.300-FF-005718', NULL, 'Putative serine/threonine-protein kinase pats1', 164, NULL, NULL, 85779),
(85780, '3.90.79.10-FF-000104', NULL, 'ADP-ribose pyrophosphatase YjhB, NUDIX family', 179, NULL, NULL, 85780),
(85781, '1.20.58.150-FF-000019', NULL, NULL, 155, NULL, NULL, 85781),
(85782, '2.60.40.10-FF-001789', NULL, 'Terribly reduced optic lobes, isoform AQ', 86, NULL, NULL, 85782),
(85783, '1.10.238.10-FF-000635', NULL, 'Calpain a', 142, NULL, NULL, 85783),
(85784, '3.30.160.60-FF-006117', NULL, NULL, 43, NULL, NULL, 85784),
(85785, '3.40.50.300-FF-004914', NULL, 'Uncharacterized protein', 209, NULL, NULL, 85785),
(85786, '3.10.129.10-FF-000172', NULL, 'Uncharacterized protein, isoform A', 156, NULL, NULL, 85786),
(85787, '3.40.50.300-FF-000643', NULL, 'Small monomeric GTPase (Gtr2)', 179, NULL, NULL, 85787),
(85788, '1.10.287.130-FF-000211', NULL, 'Two-component sensor histidine kinase', 103, NULL, NULL, 85788),
(85789, '1.10.520.10-FF-000038', NULL, 'L-ascorbate peroxidase 2 cytosolic', 95, NULL, NULL, 85789); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(85790, '3.40.605.10-FF-000002', NULL, 'Gamma-glutamyl phosphate reductase', 250, NULL, NULL, 85790),
(85791, '3.20.20.70-FF-000198', NULL, 'Deoxyribose-phosphate aldolase', 248, NULL, NULL, 85791),
(85792, '3.40.50.10490-FF-000095', NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', 147, NULL, NULL, 85792),
(85793, '3.30.60.20-FF-000050', NULL, 'Rho guanine nucleotide exchange factor 28', 57, NULL, NULL, 85793),
(85794, '2.60.40.150-FF-000180', NULL, 'synaptotagmin-5 isoform X2', 136, NULL, NULL, 85794),
(85795, '1.20.1250.20-FF-000028', NULL, 'Sugar phosphate exchanger 3 isoform 1', 224, NULL, NULL, 85795),
(85796, '3.40.1110.10-FF-000099', NULL, 'Copper-translocating P-type ATPase', 122, NULL, NULL, 85796),
(85797, '2.130.10.10-FF-000244', NULL, 'Carboxy-cis,cis-muconate cyclase', 360, NULL, NULL, 85797),
(85798, '3.90.79.10-FF-000155', NULL, 'ADP-ribose diphosphatase', 207, NULL, NULL, 85798),
(85799, '3.30.870.10-FF-000119', NULL, 'Phosphatidylcholine-hydrolyzing phospholipase D (PLD) family', 159, NULL, NULL, 85799),
(85800, '2.60.40.10-FF-002357', NULL, 'Basigin, isoform G', 96, NULL, NULL, 85800),
(85801, '2.40.30.70-FF-000020', NULL, 'tRNA (adenine(37)-N6)-methyltransferase', 87, NULL, NULL, 85801),
(85802, '1.20.1070.10-FF-001681', NULL, 'Uncharacterized protein', 115, NULL, NULL, 85802),
(85803, '3.40.630.60-FF-000013', NULL, NULL, 111, NULL, NULL, 85803),
(85804, '3.30.559.10-FF-000059', NULL, 'Transferase family protein', 206, NULL, NULL, 85804),
(85805, '3.30.60.270-FF-000020', NULL, 'Si:dkey-159a18.1', 35, NULL, NULL, 85805),
(85806, '3.90.79.10-FF-000211', NULL, 'Adenine DNA glycosylase', 110, NULL, NULL, 85806),
(85807, '3.30.559.10-FF-000115', NULL, 'Putative alcohol O-acetyltransferase', 204, NULL, NULL, 85807),
(85808, '3.30.70.60-FF-000040', NULL, 'Intersectin-2', 118, NULL, NULL, 85808),
(85809, '3.90.70.10-FF-000163', NULL, 'Dipeptidyl-peptidase I', 272, NULL, NULL, 85809),
(85810, '2.60.120.10-FF-000493', NULL, 'Uncharacterized protein', 183, NULL, NULL, 85810),
(85811, '1.10.3210.10-FF-000054', NULL, 'Metal-dependent phosphohydrolase, putative', 169, NULL, NULL, 85811),
(85812, '3.30.70.80-FF-000046', NULL, 'Uncharacterized protein', 71, NULL, NULL, 85812),
(85813, '3.60.130.10-FF-000063', NULL, 'Predicted protein', 261, NULL, NULL, 85813),
(85814, '3.10.490.10-FF-000022', NULL, 'Protein AIG2 B', 116, NULL, NULL, 85814),
(85815, '3.40.50.300-FF-003953', NULL, 'tRNA (Adenosine(37)-N6)-threonylcarbamoyltransferase complex ATPase subunit type 1 TsaE', 152, NULL, NULL, 85815),
(85816, '3.40.50.300-FF-002048', NULL, 'Septin 6', 291, NULL, NULL, 85816),
(85817, '3.20.20.80-FF-000532', NULL, 'Glucan 13-beta-glucosidase', 89, NULL, NULL, 85817),
(85818, '3.40.1380.20-FF-000071', NULL, 'Diadenylate cyclase', 138, NULL, NULL, 85818),
(85819, '1.25.40.10-FF-003750', NULL, 'Pentatricopeptide repeat-containing protein At4g31850, chloroplastic', 70, NULL, NULL, 85819),
(85820, '3.30.750.24-FF-000113', NULL, 'K-3-type glutaminase', 103, NULL, NULL, 85820),
(85821, '2.60.40.2030-FF-000050', NULL, 'Integrin beta', 109, NULL, NULL, 85821),
(85822, '3.30.160.60-FF-004352', NULL, NULL, 63, NULL, NULL, 85822),
(85823, '2.40.70.10-FF-000550', NULL, NULL, 181, NULL, NULL, 85823),
(85824, '2.130.10.110-FF-000026', NULL, 'Uncharacterized protein', 120, NULL, NULL, 85824),
(85825, '2.170.150.30-FF-000002', NULL, 'Interferon-induced with helicase C domain 1', 135, NULL, NULL, 85825),
(85826, '3.20.20.30-FF-000034', NULL, 'LLM class flavin-dependent oxidoreductase', 323, NULL, NULL, 85826),
(85827, '2.40.10.10-FF-000490', NULL, NULL, 188, NULL, NULL, 85827),
(85828, '2.60.120.10-FF-000785', NULL, 'Predicted protein', 229, NULL, NULL, 85828),
(85829, '2.60.40.1820-FF-000003', NULL, 'Desiccation protectant protein Lea14 isogeny', 151, NULL, NULL, 85829),
(85830, '1.20.1280.290-FF-000086', NULL, 'L-cystine transporter, putative', 105, NULL, NULL, 85830),
(85831, '3.10.100.10-FF-000201', NULL, 'Predicted protein', 134, NULL, NULL, 85831),
(85832, '3.10.20.10-FF-000012', NULL, '60S ribosomal protein L18a', 78, NULL, NULL, 85832);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(85833, '2.60.200.20-FF-000227', NULL, 'Kinesin-like protein', 84, NULL, NULL, 85833),
(85834, '3.50.50.60-FF-000162', NULL, 'Nitrite reductase [NAD(P)H], large subunit', 159, NULL, NULL, 85834),
(85835, '1.25.10.10-FF-003181', NULL, 'Uncharacterized protein', 317, NULL, NULL, 85835),
(85836, '1.10.8.10-FF-000228', NULL, 'DNA (cytosine-5)-methyltransferase DRM2', 53, NULL, NULL, 85836),
(85837, '3.30.70.920-FF-000026', NULL, 'AsnC family transcriptional regulator', 85, NULL, NULL, 85837),
(85838, '2.80.10.50-FF-000039', NULL, 'Secretory phospholipase A2 receptor', 128, NULL, NULL, 85838),
(85839, '3.40.50.300-FF-007787', NULL, 'Putative uridine kinase C227.14', 50, NULL, NULL, 85839),
(85840, '3.30.9.10-FF-000153', NULL, 'Uncharacterized protein', 59, NULL, NULL, 85840),
(85841, '3.40.50.300-FF-007843', NULL, 'Dynein heavy chain family protein', 231, NULL, NULL, 85841),
(85842, '1.50.10.10-FF-000132', NULL, 'alpha-1,2-Mannosidase', 301, NULL, NULL, 85842),
(85843, '2.130.10.10-FF-003335', NULL, 'Pre-mRNA processing factor 4 (PRP4) like/WD domain, G-beta repeat, putative', 125, NULL, NULL, 85843),
(85844, '1.10.601.10-FF-000002', NULL, 'RNA polymerase sigma factor RpoD', 337, NULL, NULL, 85844),
(85845, '1.10.510.10-FF-000212', NULL, 'Tyrosine-protein kinase', 180, NULL, NULL, 85845),
(85846, '1.10.3430.10-FF-000042', NULL, 'Ammonium transporter, putative', 132, NULL, NULL, 85846),
(85847, '3.80.10.10-FF-003178', NULL, 'Os03g0187500 protein', 252, NULL, NULL, 85847),
(85848, '4.10.1220.10-FF-000001', NULL, 'Prolow-density lipoprotein receptor-related protein 1', 31, NULL, NULL, 85848),
(85849, '3.40.50.10190-FF-000123', NULL, 'DNA repair protein Rtt107', 123, NULL, NULL, 85849),
(85850, '3.40.640.10-FF-000196', NULL, 'Aromatic amino acid aminotransferase I', 526, NULL, NULL, 85850),
(85851, '1.10.10.2480-FF-000005', NULL, 'POSSIBLE RIBONUCLEASE E RNE', 58, NULL, NULL, 85851),
(85852, '3.10.290.60-FF-000004', NULL, 'Ubiquitin-activating enzyme E1', 91, NULL, NULL, 85852),
(85853, '1.20.58.60-FF-000775', NULL, 'Microtubule-actin crosslinking factor 1', 232, NULL, NULL, 85853),
(85854, '3.20.20.80-FF-000476', NULL, 'Glycosyl hydrolase', 289, NULL, NULL, 85854),
(85855, '1.25.40.20-FF-000257', NULL, 'E3 ubiquitin-protein ligase MIB1', 44, NULL, NULL, 85855),
(85856, '1.10.357.10-FF-000035', NULL, 'Transcriptional repressor PhlF', 135, NULL, NULL, 85856),
(85857, '3.90.660.10-FF-000118', NULL, NULL, 126, NULL, NULL, 85857),
(85858, '3.40.630.30-FF-000465', NULL, 'GCN5-related N-acetyltransferase', 167, NULL, NULL, 85858),
(85859, '3.30.70.330-FF-001928', NULL, NULL, 144, NULL, NULL, 85859),
(85860, '3.90.1290.10-FF-000004', NULL, 'microtubule-actin cross-linking factor 1 isoform X4', 197, NULL, NULL, 85860),
(85861, '1.10.287.3550-FF-000007', NULL, 'Predicted protein', 142, NULL, NULL, 85861),
(85862, '1.10.600.10-FF-000039', NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', 274, NULL, NULL, 85862),
(85863, '3.40.50.300-FF-006090', NULL, 'Bromodomain protein', 122, NULL, NULL, 85863),
(85864, '3.30.30.30-FF-000006', NULL, 'Heat shock 70 kDa protein 8', 56, NULL, NULL, 85864),
(85865, '1.20.58.70-FF-000109', NULL, 'Qa-SNARE protein, Sed5/Syntaxin5-family', 217, NULL, NULL, 85865),
(85866, '3.30.70.330-FF-002417', NULL, NULL, 92, NULL, NULL, 85866),
(85867, '3.30.160.60-FF-001789', NULL, 'zinc finger protein 467', 28, NULL, NULL, 85867),
(85868, '1.25.40.10-FF-003238', NULL, 'Pentatricopeptide repeat-containing protein At1g04840', 190, NULL, NULL, 85868),
(85869, '3.40.390.10-FF-000215', NULL, NULL, 273, NULL, NULL, 85869),
(85870, '3.30.40.10-FF-000973', NULL, 'G protein-coupled receptor', 73, NULL, NULL, 85870),
(85871, '1.10.510.10-FF-004315', NULL, NULL, 148, NULL, NULL, 85871),
(85872, '1.10.10.10-FF-001033', NULL, 'DNA-binding response OmpR family regulator', 92, NULL, NULL, 85872),
(85873, '3.30.310.50-FF-000022', NULL, 'Phosphoglucosamine mutase', 69, NULL, NULL, 85873),
(85874, '2.170.210.10-FF-000013', NULL, 'Uncharacterized protein', 112, NULL, NULL, 85874);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(85875, '1.20.1070.10-FF-001618', NULL, 'Uncharacterized protein', 144, NULL, NULL, 85875),
(85876, '3.40.50.2000-FF-001096', NULL, '2-hydroxyacylsphingosine 1-beta-galactosyltransferase-like Protein', 60, NULL, NULL, 85876),
(85877, '3.30.420.10-FF-000030', NULL, 'IS3, transposase orfB', 160, NULL, NULL, 85877),
(85878, '3.40.50.620-FF-000733', NULL, 'Uncharacterized protein', 174, NULL, NULL, 85878),
(85879, '2.60.40.10-FF-000777', NULL, 'Neogenin 1', 97, NULL, NULL, 85879),
(85880, '1.20.120.1750-FF-000090', NULL, 'RBR-type E3 ubiquitin transferase', 133, NULL, NULL, 85880),
(85881, '3.10.20.90-FF-000434', NULL, 'Expressed protein', 78, NULL, NULL, 85881),
(85882, '2.115.10.20-FF-000001', NULL, 'Beta-fructofuranosidase, insoluble isoenzyme CWINV1', 327, NULL, NULL, 85882),
(85883, '2.60.40.10-FF-001053', NULL, 'Uncharacterized protein, isoform D', 101, NULL, NULL, 85883),
(85884, '3.40.50.1440-FF-000129', NULL, 'Cell division protein FtsZ homolog 1 chloroplastic', 163, NULL, NULL, 85884),
(85885, '3.40.50.1820-FF-001603', NULL, 'Uncharacterized protein', 79, NULL, NULL, 85885),
(85886, '3.40.50.10700-FF-000001', NULL, 'D-aminoacyl-tRNA deacylase', 110, NULL, NULL, 85886),
(85887, '1.10.510.10-FF-003915', NULL, NULL, 76, NULL, NULL, 85887),
(85888, '1.50.10.10-FF-000183', NULL, 'alpha-1,2-Mannosidase', 327, NULL, NULL, 85888),
(85889, '1.10.340.30-FF-000042', NULL, 'Methyl-CpG-binding domain protein 4', 146, NULL, NULL, 85889),
(85890, '3.10.100.10-FF-000145', NULL, 'collectin-46-like', 133, NULL, NULL, 85890),
(85891, '3.30.160.60-FF-000480', NULL, 'PR domain zinc finger protein 14', 25, NULL, NULL, 85891),
(85892, '3.90.70.10-FF-000904', NULL, 'Probable ubiquitin carboxyl-terminal hydrolase 7', 270, NULL, NULL, 85892),
(85893, '1.25.10.10-FF-002961', NULL, 'Uncharacterized protein', 435, NULL, NULL, 85893),
(85894, '3.30.2140.20-FF-000005', NULL, 'N-acetyltransferase', 248, NULL, NULL, 85894),
(85895, '3.20.20.70-FF-000254', NULL, '2-dehydro-3-deoxyphosphooctonate aldolase 2', 277, NULL, NULL, 85895),
(85896, '1.10.10.10-FF-001432', NULL, 'Two-component response regulator', 108, NULL, NULL, 85896),
(85897, '3.40.50.150-FF-001418', NULL, NULL, 157, NULL, NULL, 85897),
(85898, '1.20.200.10-FF-000006', NULL, 'Argininosuccinate lyase', 267, NULL, NULL, 85898),
(85899, '3.40.50.12500-FF-000007', NULL, 'Dcg1p', 230, NULL, NULL, 85899),
(85900, '3.30.40.10-FF-000630', NULL, 'E3 ubiquitin-protein ligase RMA3', 72, NULL, NULL, 85900),
(85901, '1.20.58.60-FF-000724', NULL, 'Predicted protein', 107, NULL, NULL, 85901),
(85902, '1.20.930.80-FF-000015', NULL, 'DNA primase large subunit-like Protein', 217, NULL, NULL, 85902),
(85903, '1.25.10.10-FF-002068', NULL, 'Tuberin-like Protein', 478, NULL, NULL, 85903),
(85904, '2.20.100.10-FF-000130', NULL, 'No long nerve cord, isoform A', 59, NULL, NULL, 85904),
(85905, '3.40.30.10-FF-001152', NULL, 'Glutathione S-transferase, putative', 37, NULL, NULL, 85905),
(85906, '1.20.1080.10-FF-000102', NULL, 'Uncharacterized protein', 167, NULL, NULL, 85906),
(85907, '3.90.640.10-FF-000286', NULL, 'Uncharacterized protein', 18, NULL, NULL, 85907),
(85908, '1.10.1670.40-FF-000012', NULL, 'HhH-GPD family protein', 72, NULL, NULL, 85908),
(85909, '3.40.30.10-FF-000663', NULL, 'Glutathione peroxidase 4', 154, NULL, NULL, 85909),
(85910, '1.10.510.10-FF-002685', NULL, NULL, 243, NULL, NULL, 85910),
(85911, '3.30.450.200-FF-000014', NULL, 'DENN domain-containing protein 1A isoform X3', 93, NULL, NULL, 85911),
(85912, '1.20.58.1290-FF-000005', NULL, 'Uncharacterized protein', 97, NULL, NULL, 85912),
(85913, '3.40.50.1100-FF-000140', NULL, 'Bifunctional D-cysteine desulfhydrase/1-aminocyclopropane-1-carboxylate deaminase mitochondrial', 132, NULL, NULL, 85913),
(85914, '2.40.50.140-FF-000054', NULL, 'Nuclease-sensitive element-binding protein 1', 83, NULL, NULL, 85914),
(85915, '2.20.70.10-FF-000213', NULL, 'Histone-lysine N-methyltransferase', 62, NULL, NULL, 85915),
(85916, '1.10.10.10-FF-001084', NULL, 'Transcriptional regulator, MarR family', 147, NULL, NULL, 85916);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(85917, '2.170.130.10-FF-000012', NULL, 'TonB-dependent siderophore receptor', 123, NULL, NULL, 85917),
(85918, '3.40.50.720-FF-001494', NULL, 'D-3-phosphoglycerate dehydrogenase', 116, NULL, NULL, 85918),
(85919, '3.80.10.10-FF-004538', NULL, 'F-box protein SKIP19', 153, NULL, NULL, 85919),
(85920, '2.60.120.290-FF-000067', NULL, 'inactive serine protease PAMR1 isoform X1', 111, NULL, NULL, 85920),
(85921, '1.10.10.10-FF-000072', NULL, 'Transcriptional regulatory protein RcsB', 60, NULL, NULL, 85921),
(85922, '3.30.160.60-FF-002227', NULL, 'Zinc finger protein 302', 31, NULL, NULL, 85922),
(85923, '2.120.10.30-FF-000492', NULL, 'Uncharacterized protein', 241, NULL, NULL, 85923),
(85924, '3.80.10.10-FF-003526', NULL, 'Si:ch211-11p18.6', 170, NULL, NULL, 85924),
(85925, '3.40.50.20-FF-000083', NULL, 'Ribosomal protein S6 modification protein (RimK)', 97, NULL, NULL, 85925),
(85926, '3.30.465.10-FF-000116', NULL, 'Uncharacterized protein', 67, NULL, NULL, 85926),
(85927, '3.40.630.10-FF-000307', NULL, 'Peptide hydrolase', 385, NULL, NULL, 85927),
(85928, '3.10.450.60-FF-000006', NULL, 'Arachidonate 12-lipoxygenase', 115, NULL, NULL, 85928),
(85929, '3.30.70.330-FF-001057', NULL, 'Polyadenylate-binding protein, putative', 92, NULL, NULL, 85929),
(85930, '1.25.40.20-FF-000605', NULL, 'cortactin-binding protein 2 isoform X1', 265, NULL, NULL, 85930),
(85931, '2.60.40.10-FF-005448', NULL, NULL, 96, NULL, NULL, 85931),
(85932, '1.10.287.70-FF-000631', NULL, 'Uncharacterized protein', 205, NULL, NULL, 85932),
(85933, '2.30.30.40-FF-000562', NULL, 'Uncharacterized protein', 57, NULL, NULL, 85933),
(85934, '3.90.1450.10-FF-000006', NULL, 'Si:ch211-220m17.4', 66, NULL, NULL, 85934),
(85935, '1.20.5.170-FF-000065', NULL, 'Keratin, type II cytoskeletal 80', 80, NULL, NULL, 85935),
(85936, '4.10.800.10-FF-000015', NULL, 'Epithelial cell adhesion molecule', 72, NULL, NULL, 85936),
(85937, '3.30.1370.10-FF-000042', NULL, 'Vigilin isoform X1', 91, NULL, NULL, 85937),
(85938, '1.10.10.790-FF-000037', NULL, NULL, 70, NULL, NULL, 85938),
(85939, '1.10.555.10-FF-000181', NULL, 'Uncharacterized protein', 265, NULL, NULL, 85939),
(85940, '2.60.40.10-FF-003470', NULL, 'Putative tyrosine-protein kinase Wsck', 125, NULL, NULL, 85940),
(85941, '2.30.30.190-FF-000033', NULL, NULL, 98, NULL, NULL, 85941),
(85942, '1.10.10.10-FF-002101', NULL, 'Uncharacterized protein', 89, NULL, NULL, 85942),
(85943, '2.30.30.50-FF-000003', NULL, 'Ferredoxin-thioredoxin reductase, variable chain', 74, NULL, NULL, 85943),
(85944, '3.30.200.20-FF-000432', NULL, 'LRR receptor-like serine/threonine-protein kinase EFR', 111, NULL, NULL, 85944),
(85945, '2.10.110.10-FF-000133', NULL, 'Uncharacterized protein', 54, NULL, NULL, 85945),
(85946, '3.30.60.30-FF-000126', NULL, 'AGAP005450-PA', 60, NULL, NULL, 85946),
(85947, '2.30.180.10-FF-000037', NULL, 'Uncharacterized protein, isoform A', 134, NULL, NULL, 85947),
(85948, '1.25.10.10-FF-001213', NULL, 'Serine/threonine-protein kinase D1044.8', 267, NULL, NULL, 85948),
(85949, '3.30.710.10-FF-000018', NULL, 'S-phase kinase-associated protein 1', 163, NULL, NULL, 85949),
(85950, '1.20.1530.20-FF-000073', NULL, 'K(+) efflux antiporter 3 chloroplastic', 174, NULL, NULL, 85950),
(85951, '1.10.290.10-FF-000003', NULL, 'DNA topoisomerase', 127, NULL, NULL, 85951),
(85952, '3.30.200.20-FF-000376', NULL, 'Serine/threonine-protein kinase PBS1', 107, NULL, NULL, 85952),
(85953, '2.60.220.50-FF-000097', NULL, 'Uncharacterized protein', 197, NULL, NULL, 85953),
(85954, '2.60.40.1180-FF-000210', NULL, 'Alpha-amylase', 87, NULL, NULL, 85954),
(85955, '3.40.50.12710-FF-000008', NULL, 'Protein arginine methyltransferase NDUFAF7', 420, NULL, NULL, 85955),
(85956, '1.25.10.10-FF-000595', NULL, 'HEAT repeat-containing protein 1', 175, NULL, NULL, 85956),
(85957, '3.90.570.10-FF-000004', NULL, 'Amyloid protein', 56, NULL, NULL, 85957),
(85958, '3.30.420.100-FF-000006', NULL, '50S ribosomal protein L18-like', 113, NULL, NULL, 85958),
(85959, '4.10.60.10-FF-000225', NULL, 'Zinc finger CCHC-type containing 13', 43, NULL, NULL, 85959);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(85960, '3.40.50.1400-FF-000016', NULL, 'Ferrochelatase Che1', 114, NULL, NULL, 85960),
(85961, '4.10.800.20-FF-000006', NULL, 'AMP deaminase, putative', 99, NULL, NULL, 85961),
(85962, '3.90.25.10-FF-000036', NULL, 'ADP-L-glycero-D-manno-heptose-6-epimerase', 95, NULL, NULL, 85962),
(85963, '1.25.40.80-FF-000016', NULL, 'Deoxyribodipyrimidine photolyase', 118, NULL, NULL, 85963),
(85964, '3.30.720.50-FF-000008', NULL, 'TCDD-inducible poly [ADP-ribose] polymerase', 75, NULL, NULL, 85964),
(85965, '3.40.50.300-FF-006483', NULL, 'Predicted protein', 116, NULL, NULL, 85965),
(85966, '3.40.630.20-FF-000024', NULL, 'Uncharacterized protein', 164, NULL, NULL, 85966),
(85967, '3.30.160.60-FF-005100', NULL, NULL, 38, NULL, NULL, 85967),
(85968, '3.30.40.10-FF-001642', NULL, 'Uncharacterized protein', 56, NULL, NULL, 85968),
(85969, '3.30.70.960-FF-000015', NULL, 'Interphotoreceptor matrix proteoglycan 2', 92, NULL, NULL, 85969),
(85970, '3.10.290.10-FF-000074', NULL, '30S ribosomal protein S4', 55, NULL, NULL, 85970),
(85971, '1.20.140.20-FF-000004', NULL, 'pyruvate dehydrogenase kinase, isozyme 2', 122, NULL, NULL, 85971),
(85972, '3.30.70.660-FF-000083', NULL, 'Uncharacterized protein', 213, NULL, NULL, 85972),
(85973, '2.30.29.30-FF-000724', NULL, 'Uncharacterized protein', 128, NULL, NULL, 85973),
(85974, '1.10.730.20-FF-000029', NULL, 'Uncharacterized protein', 173, NULL, NULL, 85974),
(85975, '3.40.720.10-FF-000197', NULL, 'Alkaline phosphatase', 335, NULL, NULL, 85975),
(85976, '1.20.120.620-FF-000002', NULL, 'Sensor histidine kinase KdpD', 102, NULL, NULL, 85976),
(85977, '3.40.50.1820-FF-001098', NULL, 'Venom carboxylesterase-6-like Protein', 548, NULL, NULL, 85977),
(85978, '2.60.260.20-FF-000096', NULL, 'Chaperone protein DnaJ', 65, NULL, NULL, 85978),
(85979, '1.20.120.330-FF-000016', NULL, 'GIT ArfGAP 1', 64, NULL, NULL, 85979),
(85980, '2.60.40.60-FF-000146', NULL, 'cadherin-23 isoform X1', 107, NULL, NULL, 85980),
(85981, '1.20.1250.20-FF-001433', NULL, 'Transporter, putative', 248, NULL, NULL, 85981),
(85982, '2.40.110.10-FF-000093', NULL, 'Acyl-coenzyme A oxidase', 35, NULL, NULL, 85982),
(85983, '2.30.140.10-FF-000023', NULL, 'Polyamine aminopropyltransferase 1', 53, NULL, NULL, 85983),
(85984, '1.10.8.1220-FF-000009', NULL, 'Dynein heavy chain-like protein', 96, NULL, NULL, 85984),
(85985, '3.40.30.10-FF-000371', NULL, 'Glutathione peroxidase', 151, NULL, NULL, 85985),
(85986, '2.60.40.420-FF-000165', NULL, 'Coagulation factor VIII, procoagulant component', 344, NULL, NULL, 85986),
(85987, '3.90.70.10-FF-000635', NULL, 'Ubiquitinyl hydrolase 1', 117, NULL, NULL, 85987),
(85988, '1.10.287.80-FF-000016', NULL, 'ATP synthase gamma chain', 64, NULL, NULL, 85988),
(85989, '3.40.50.300-FF-000811', NULL, 'probable ATP-dependent RNA helicase YTHDC2', 171, NULL, NULL, 85989),
(85990, '1.10.510.10-FF-000717', NULL, 'Casein kinase I-like protein 2', 350, NULL, NULL, 85990),
(85991, '2.60.120.620-FF-000155', NULL, 'Uncharacterized protein', 206, NULL, NULL, 85991),
(85992, '1.10.390.10-FF-000095', NULL, 'Uncharacterized protein', 113, NULL, NULL, 85992),
(85993, '2.120.10.80-FF-000366', NULL, 'Uncharacterized protein', 244, NULL, NULL, 85993),
(85994, '3.30.160.60-FF-000934', NULL, 'zinc finger protein 90 homolog', 34, NULL, NULL, 85994),
(85995, '3.30.420.40-FF-000022', NULL, 'Actin-related protein 2', 161, NULL, NULL, 85995),
(85996, '3.50.50.60-FF-001235', NULL, 'Flavin-containing monooxygenase', 210, NULL, NULL, 85996),
(85997, '1.20.58.90-FF-000031', NULL, NULL, 58, NULL, NULL, 85997),
(85998, '1.20.5.100-FF-000033', NULL, 'Integrin beta', 53, NULL, NULL, 85998),
(85999, '1.25.40.70-FF-000070', NULL, 'Uncharacterized protein', 120, NULL, NULL, 85999),
(86000, '2.80.10.50-FF-000146', NULL, 'Serine/threonine protein kinase', 80, NULL, NULL, 86000),
(86001, '1.10.10.470-FF-000003', NULL, 'Maltooligosyltrehalose synthase', 113, NULL, NULL, 86001),
(86002, '2.40.30.10-FF-000373', NULL, 'Uncharacterized protein', 90, NULL, NULL, 86002),
(86003, '3.30.420.110-FF-000048', NULL, 'DNA mismatch repair protein MutS', 138, NULL, NULL, 86003);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(86004, '3.20.20.120-FF-000008', NULL, 'D-galactonate dehydratase', 236, NULL, NULL, 86004),
(86005, '3.20.20.100-FF-000020', NULL, 'L-glyceraldehyde 3-phosphate reductase', 332, NULL, NULL, 86005),
(86006, '3.30.160.60-FF-002278', NULL, 'Zinc finger protein 320', 22, NULL, NULL, 86006),
(86007, '2.60.40.10-FF-005499', NULL, NULL, 94, NULL, NULL, 86007),
(86008, '2.30.180.10-FF-000144', NULL, NULL, 118, NULL, NULL, 86008),
(86009, '2.120.10.80-FF-000422', NULL, 'Predicted protein', 143, NULL, NULL, 86009),
(86010, '2.40.70.10-FF-000443', NULL, NULL, 84, NULL, NULL, 86010),
(86011, '2.60.260.20-FF-000152', NULL, 'Uncharacterized protein', 30, NULL, NULL, 86011),
(86012, '3.20.20.70-FF-000703', NULL, NULL, 148, NULL, NULL, 86012),
(86013, '1.20.900.10-FF-000026', NULL, 'Alsin isoform X1', 200, NULL, NULL, 86013),
(86014, '1.20.120.180-FF-000005', NULL, 'Proteasome activator protein PA26', 221, NULL, NULL, 86014),
(86015, '1.10.1040.10-FF-000107', NULL, '2-dehydropantoate 2-reductase', 125, NULL, NULL, 86015),
(86016, '1.10.340.70-FF-000031', NULL, 'Uncharacterized protein', 102, NULL, NULL, 86016),
(86017, '3.90.76.10-FF-000007', NULL, 'Dipeptide ABC transporter periplasmic dipeptide-binding protein', 161, NULL, NULL, 86017),
(86018, '3.30.40.10-FF-002210', NULL, 'Poly [ADP-ribose] polymerase', 71, NULL, NULL, 86018),
(86019, '2.130.10.10-FF-002610', NULL, 'Vacuolar protein sorting-associated protein 11 homolog', 259, NULL, NULL, 86019),
(86020, '2.60.120.780-FF-000006', NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', 160, NULL, NULL, 86020),
(86021, '3.40.50.300-FF-007051', NULL, 'Nucleolar protein 9', 198, NULL, NULL, 86021),
(86022, '3.50.80.10-FF-000002', NULL, 'D-aminoacyl-tRNA deacylase', 141, NULL, NULL, 86022),
(86023, '3.80.10.10-FF-003414', NULL, 'Os11g0108932 protein', 82, NULL, NULL, 86023),
(86024, '3.30.70.3490-FF-000022', NULL, 'Oxysterol-binding protein', 119, NULL, NULL, 86024),
(86025, '3.30.930.10-FF-000288', NULL, 'Serine--tRNA ligase', 317, NULL, NULL, 86025),
(86026, '1.20.58.60-FF-000488', NULL, 'Microtubule actin crosslinking factor 1a', 148, NULL, NULL, 86026),
(86027, '3.50.30.30-FF-000168', NULL, 'Surface-associated serine protease', 136, NULL, NULL, 86027),
(86028, '3.20.20.140-FF-000166', NULL, 'Uncharacterized protein', 292, NULL, NULL, 86028),
(86029, '2.60.40.420-FF-000221', NULL, 'Coagulation factor VIII, procoagulant component', 77, NULL, NULL, 86029),
(86030, '1.10.20.10-FF-000365', NULL, NULL, 86, NULL, NULL, 86030),
(86031, '2.60.40.60-FF-000202', NULL, 'cadherin-8 isoform X4', 112, NULL, NULL, 86031),
(86032, '1.25.40.60-FF-000010', NULL, 'CRE-UNC-18 protein', 120, NULL, NULL, 86032),
(86033, '3.90.640.10-FF-000235', NULL, 'Uncharacterized protein', 43, NULL, NULL, 86033),
(86034, '1.10.10.10-FF-000920', NULL, 'Transcriptional regulator', 106, NULL, NULL, 86034),
(86035, '2.60.40.10-FF-003138', NULL, NULL, 110, NULL, NULL, 86035),
(86036, '2.30.29.30-FF-001287', NULL, 'Dip13 beta, putative', 90, NULL, NULL, 86036),
(86037, '3.30.160.60-FF-003863', NULL, NULL, 30, NULL, NULL, 86037),
(86038, '3.80.10.10-FF-003234', NULL, 'FBD / Leucine Rich Repeat domains containing protein', 191, NULL, NULL, 86038),
(86039, '1.10.510.10-FF-002050', NULL, 'Serine/threonine-protein kinase', 270, NULL, NULL, 86039),
(86040, '4.10.280.10-FF-000210', NULL, 'Protein CBG18500', 54, NULL, NULL, 86040),
(86041, '1.10.1420.10-FF-000148', NULL, 'MutS domain III family protein', 161, NULL, NULL, 86041),
(86042, '3.40.50.300-FF-004122', NULL, 'Uncharacterized protein', 291, NULL, NULL, 86042),
(86043, '1.25.40.20-FF-000313', NULL, 'Uncharacterized protein, isoform C', 88, NULL, NULL, 86043),
(86044, '1.20.58.60-FF-000831', NULL, 'Uncharacterized protein', 166, NULL, NULL, 86044),
(86045, '2.30.30.550-FF-000012', NULL, NULL, 51, NULL, NULL, 86045),
(86046, '3.30.479.20-FF-000067', NULL, 'Uncharacterized protein', 70, NULL, NULL, 86046),
(86047, '2.20.100.10-FF-000023', NULL, 'Thrombospondin type-1 domain-containing protein 4', 58, NULL, NULL, 86047),
(86048, '2.60.40.10-FF-002806', NULL, 'Si:ch73-215d9.1', 100, NULL, NULL, 86048);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(86049, '2.40.50.140-FF-000161', NULL, 'Ribonuclease R', 112, NULL, NULL, 86049),
(86050, '3.40.50.720-FF-002562', NULL, 'Uncharacterized protein', 46, NULL, NULL, 86050),
(86051, '3.10.20.90-FF-000726', NULL, 'Nuclear protein localization protein 4-like protein', 78, NULL, NULL, 86051),
(86052, '3.40.1160.10-FF-000102', NULL, 'Uncharacterized protein', 72, NULL, NULL, 86052),
(86053, '3.30.420.10-FF-000479', NULL, NULL, 56, NULL, NULL, 86053),
(86054, '1.25.40.780-FF-000002', NULL, 'TIR-domain containing adaptor inducing IFN-beta', 153, NULL, NULL, 86054),
(86055, '3.40.1550.20-FF-000011', NULL, 'Transcriptional regulator MraZ', 153, NULL, NULL, 86055),
(86056, '3.90.70.200-FF-000010', NULL, 'Uncharacterized protein', 133, NULL, NULL, 86056),
(86057, '1.25.40.20-FF-000369', NULL, 'Ankyrin repeat domain-containing protein 1', 163, NULL, NULL, 86057),
(86058, '3.40.50.300-FF-003684', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 185, NULL, NULL, 86058),
(86059, '2.60.200.30-FF-000033', NULL, 'NAD kinase', 133, NULL, NULL, 86059),
(86060, '3.20.20.70-FF-000523', NULL, 'Alkaline alpha galactosidase 2', 263, NULL, NULL, 86060),
(86061, '2.60.40.10-FF-005268', NULL, NULL, 86, NULL, NULL, 86061),
(86062, '3.30.160.60-FF-003683', NULL, NULL, 28, NULL, NULL, 86062),
(86063, '2.60.120.320-FF-000003', NULL, 'Thiamine pyrophosphokinase', 125, NULL, NULL, 86063),
(86064, '1.25.40.10-FF-003126', NULL, 'Pentatricopeptide repeat-containing protein', 166, NULL, NULL, 86064),
(86065, '2.60.120.260-FF-000412', NULL, 'Six-hairpin glycosidase-like protein', 145, NULL, NULL, 86065),
(86066, '1.10.730.10-FF-000195', NULL, 'Leucyl-tRNA synthetase', 143, NULL, NULL, 86066),
(86067, '3.65.10.10-FF-000015', NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', 205, NULL, NULL, 86067),
(86068, '2.60.40.1170-FF-000056', NULL, 'Putative adaptor complex AP-1 medium subunit', 145, NULL, NULL, 86068),
(86069, '3.90.1150.70-FF-000001', NULL, 'UPF0425 pyridoxal phosphate-dependent protein MJ0158', 137, NULL, NULL, 86069),
(86070, '3.30.930.10-FF-000344', NULL, 'Uncharacterized protein', 73, NULL, NULL, 86070),
(86071, '3.30.70.1230-FF-000081', NULL, 'Predicted protein', 116, NULL, NULL, 86071),
(86072, '1.25.10.10-FF-002517', NULL, 'Uncharacterized protein', 194, NULL, NULL, 86072),
(86073, '2.20.70.10-FF-000045', NULL, 'E3 ubiquitin-protein ligase NEDD4-like', 36, NULL, NULL, 86073),
(86074, '1.20.1610.10-FF-000014', NULL, 'Alpha-1,2-mannosidase, putative', 164, NULL, NULL, 86074),
(86075, '1.25.40.990-FF-000003', NULL, 'germinal-center associated nuclear protein isoform X2', 288, NULL, NULL, 86075),
(86076, '3.30.420.10-FF-000535', NULL, NULL, 94, NULL, NULL, 86076),
(86077, '1.25.40.10-FF-002401', NULL, 'pentatricopeptide repeat-containing protein At5g04780, mitochondrial isoform X1', 143, NULL, NULL, 86077),
(86078, '3.40.50.300-FF-006207', NULL, 'Uncharacterized protein', 109, NULL, NULL, 86078),
(86079, '3.40.50.261-FF-000031', NULL, 'Uncharacterized protein', 132, NULL, NULL, 86079),
(86080, '3.20.20.70-FF-000647', NULL, NULL, 239, NULL, NULL, 86080),
(86081, '3.40.50.10900-FF-000016', NULL, 'Uncharacterized protein', 139, NULL, NULL, 86081),
(86082, '1.10.238.10-FF-000112', NULL, 'EF-hand domain family, member D2', 104, NULL, NULL, 86082),
(86083, '1.10.10.10-FF-001376', NULL, 'Regulatory protein RecX', 48, NULL, NULL, 86083),
(86084, '3.30.40.10-FF-001411', NULL, 'Uncharacterized protein', 62, NULL, NULL, 86084),
(86085, '1.10.730.10-FF-000083', NULL, 'Isoleucine--tRNA ligase', 185, NULL, NULL, 86085),
(86086, '3.40.1810.10-FF-000012', NULL, 'MADS-box protein SOC1', 81, NULL, NULL, 86086),
(86087, '3.30.40.10-FF-000006', NULL, 'CCR4-NOT transcription complex subunit 4', 77, NULL, NULL, 86087),
(86088, '3.90.640.10-FF-000179', NULL, 'Uncharacterized protein', 72, NULL, NULL, 86088),
(86089, '3.40.50.300-FF-008355', NULL, 'Os06g0561800 protein', 156, NULL, NULL, 86089),
(86090, '1.10.10.10-FF-000864', NULL, 'GntR family transcriptional regulator', 73, NULL, NULL, 86090),
(86091, '3.90.1410.10-FF-000009', NULL, 'Histone-lysine N-methyltransferase setd3', 284, NULL, NULL, 86091);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(86092, '3.10.100.10-FF-000033', NULL, 'Mannose receptor C type 2', 147, NULL, NULL, 86092),
(86093, '1.10.287.70-FF-000182', NULL, 'Outward-rectifier potassium channel TOK1', 145, NULL, NULL, 86093),
(86094, '3.30.160.60-FF-001497', NULL, 'Zinc finger protein 275', 28, NULL, NULL, 86094),
(86095, '1.10.630.10-FF-000659', NULL, 'Uncharacterized protein', 191, NULL, NULL, 86095),
(86096, '1.25.70.10-FF-000025', NULL, 'Uncharacterized protein', 138, NULL, NULL, 86096),
(86097, '3.50.50.60-FF-001179', NULL, 'Cindoxin reductase', 207, NULL, NULL, 86097),
(86098, '1.20.58.670-FF-000001', NULL, 'Exocyst complex component', 140, NULL, NULL, 86098),
(86099, '2.60.120.330-FF-000063', NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', 329, NULL, NULL, 86099),
(86100, '2.60.40.10-FF-004195', NULL, NULL, 83, NULL, NULL, 86100),
(86101, '2.130.10.10-FF-002554', NULL, 'Uncharacterized protein', 254, NULL, NULL, 86101),
(86102, '2.70.170.10-FF-000174', NULL, 'Uncharacterized protein', 128, NULL, NULL, 86102),
(86103, '3.30.920.30-FF-000001', NULL, 'Probable mRNA interferase HicA', 57, NULL, NULL, 86103),
(86104, '1.20.120.350-FF-000230', NULL, NULL, 127, NULL, NULL, 86104),
(86105, '3.30.450.90-FF-000016', NULL, 'ATP-binding protein', 114, NULL, NULL, 86105),
(86106, '3.40.50.10190-FF-000016', NULL, 'protein ECT2 isoform X3', 90, NULL, NULL, 86106),
(86107, '1.10.357.20-FF-000021', NULL, 'Solute carrier family 41 member 1-like Protein', 193, NULL, NULL, 86107),
(86108, '3.30.420.40-FF-000926', NULL, 'Actin-related protein 2', 123, NULL, NULL, 86108),
(86109, '3.90.550.10-FF-000751', NULL, 'Putative mannan synthase 7', 48, NULL, NULL, 86109),
(86110, '1.25.40.10-FF-001041', NULL, 'Transmembrane and tetratricopeptide repeat containing 4', 69, NULL, NULL, 86110),
(86111, '1.25.40.530-FF-000012', NULL, 'Heavy chain, Unconventional Myosin', 183, NULL, NULL, 86111),
(86112, '1.20.1250.20-FF-000652', NULL, 'Os02g0574500 protein', 225, NULL, NULL, 86112),
(86113, '3.40.50.300-FF-000699', NULL, 'ATPase family AAA domain-containing protein 2B', 174, NULL, NULL, 86113),
(86114, '3.20.20.80-FF-000583', NULL, 'Predicted protein', 258, NULL, NULL, 86114),
(86115, '3.40.1190.20-FF-000152', NULL, 'PfkB family kinase', 302, NULL, NULL, 86115),
(86116, '3.30.530.20-FF-000018', NULL, 'Activator of 90 kDa heat shock protein ATPase 1', 130, NULL, NULL, 86116),
(86117, '3.10.310.20-FF-000012', NULL, 'Putative acidocalcisomal exopolyphosphatase', 150, NULL, NULL, 86117),
(86118, '1.10.30.10-FF-000011', NULL, 'Putative SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily E member 1', 108, NULL, NULL, 86118),
(86119, '2.60.40.10-FF-005555', NULL, NULL, 114, NULL, NULL, 86119),
(86120, '3.10.490.20-FF-000019', NULL, 'Dynein heavy chain, putative', 143, NULL, NULL, 86120),
(86121, '2.40.50.140-FF-000958', NULL, NULL, 26, NULL, NULL, 86121),
(86122, '2.60.40.10-FF-000485', NULL, 'Sidekick cell adhesion molecule 2', 75, NULL, NULL, 86122),
(86123, '3.90.770.10-FF-000003', NULL, '3-hydroxy-3-methylglutaryl-coenzyme A reductase 2', 49, NULL, NULL, 86123),
(86124, '3.40.50.150-FF-001126', NULL, NULL, 256, NULL, NULL, 86124),
(86125, '1.10.510.10-FF-003466', NULL, NULL, 272, NULL, NULL, 86125),
(86126, '3.40.930.10-FF-000004', NULL, 'Anion exchange protein', 328, NULL, NULL, 86126),
(86127, '2.120.10.30-FF-000609', NULL, 'DPP6 N-terminal domain-like protein', 189, NULL, NULL, 86127),
(86128, '2.60.120.340-FF-000009', NULL, 'Nucleolar RNA-binding protein, truncated', 100, NULL, NULL, 86128),
(86129, '3.10.100.10-FF-000089', NULL, 'Uncharacterized protein, isoform C', 139, NULL, NULL, 86129),
(86130, '1.20.1070.10-FF-001349', NULL, 'Uncharacterized protein', 269, NULL, NULL, 86130),
(86131, '3.30.450.70-FF-000010', NULL, 'TRAPP subunit', 148, NULL, NULL, 86131),
(86132, '3.50.50.60-FF-000779', NULL, 'Adenylylsulfate reductase subunit alpha', 511, NULL, NULL, 86132),
(86133, '1.20.1280.50-FF-000016', NULL, 'E3 ubiquitin ligase complex SCF subunit sconB', 85, NULL, NULL, 86133),
(86134, '3.30.70.330-FF-002709', NULL, NULL, 106, NULL, NULL, 86134);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(86135, '2.160.20.10-FF-000327', NULL, 'Cell surface glycoprotein (S-layer protein)', 128, NULL, NULL, 86135),
(86136, '1.20.5.880-FF-000002', NULL, 'Photosystem II reaction center protein H', 66, NULL, NULL, 86136),
(86137, '3.40.50.150-FF-001525', NULL, NULL, 357, NULL, NULL, 86137),
(86138, '1.10.10.10-FF-001937', NULL, 'Uncharacterized protein', 88, NULL, NULL, 86138),
(86139, '3.40.50.2300-FF-000303', NULL, 'Glutamate receptor ionotropic, kainate', 235, NULL, NULL, 86139),
(86140, '3.40.190.10-FF-000447', NULL, 'ATP phosphoribosyltransferase', 119, NULL, NULL, 86140),
(86141, '1.10.287.370-FF-000047', NULL, 'URI (Unconventional prefoldin RPB5 Interactor) homolog', 122, NULL, NULL, 86141),
(86142, '1.10.10.1810-FF-000001', NULL, 'RNA-editing ligase 1, mitochondrial', 93, NULL, NULL, 86142),
(86143, '2.60.210.10-FF-000051', NULL, NULL, 191, NULL, NULL, 86143),
(86144, '3.30.2350.10-FF-000046', NULL, 'tRNA pseudouridine synthase B', 221, NULL, NULL, 86144),
(86145, '3.60.20.10-FF-000195', NULL, NULL, 221, NULL, NULL, 86145),
(86146, '1.10.287.110-FF-000109', NULL, 'J-type co-chaperone JAC1, mitochondrial', 87, NULL, NULL, 86146),
(86147, '3.90.1150.10-FF-000410', NULL, 'Uncharacterized protein', 80, NULL, NULL, 86147),
(86148, '1.20.58.390-FF-000187', NULL, 'Ligand-Gated ion Channel', 134, NULL, NULL, 86148),
(86149, '1.20.1600.10-FF-000064', NULL, 'Uncharacterized protein', 378, NULL, NULL, 86149),
(86150, '3.90.470.10-FF-000019', NULL, 'Ribosomal protein L22p/L17e', 143, NULL, NULL, 86150),
(86151, '3.40.50.300-FF-000250', NULL, 'Obg-like ATPase 1', 173, NULL, NULL, 86151),
(86152, '3.40.190.10-FF-000503', NULL, 'ABC transporter substrate-binding protein', 317, NULL, NULL, 86152),
(86153, '1.10.287.370-FF-000103', NULL, 'Predicted protein', 157, NULL, NULL, 86153),
(86154, '3.40.50.300-FF-000194', NULL, 'Sulfotransferase', 263, NULL, NULL, 86154),
(86155, '2.40.30.270-FF-000021', NULL, 'Zinc finger protein', 107, NULL, NULL, 86155),
(86156, '2.60.40.790-FF-000192', NULL, NULL, 92, NULL, NULL, 86156),
(86157, '3.40.50.1820-FF-001278', NULL, 'Protein phosphatase methylesterase 1', 298, NULL, NULL, 86157),
(86158, '3.90.70.10-FF-000455', NULL, 'Ubiquitinyl hydrolase 1', 351, NULL, NULL, 86158),
(86159, '3.80.10.10-FF-001492', NULL, 'Phytosulfokine receptor 1', 101, NULL, NULL, 86159),
(86160, '3.20.20.105-FF-000003', NULL, 'Queuine tRNA-ribosyltransferase accessory subunit 2', 387, NULL, NULL, 86160),
(86161, '1.10.510.10-FF-003410', NULL, NULL, 296, NULL, NULL, 86161),
(86162, '2.40.160.100-FF-000001', NULL, 'Alginate production protein AlgE', 458, NULL, NULL, 86162),
(86163, '2.130.10.10-FF-000137', NULL, 'Regulatory-associated protein of mTOR isoform 1', 109, NULL, NULL, 86163),
(86164, '2.40.170.20-FF-000094', NULL, 'Outer membrane receptor for ferric iron uptake', 506, NULL, NULL, 86164),
(86165, '2.60.120.200-FF-000765', NULL, 'Calnexin', 75, NULL, NULL, 86165),
(86166, '1.10.1450.10-FF-000138', NULL, 'Tetraspanin', 97, NULL, NULL, 86166),
(86167, '3.30.160.60-FF-005605', NULL, NULL, 46, NULL, NULL, 86167),
(86168, '3.40.50.300-FF-005426', NULL, 'Si:ch1073-181h11.2', 122, NULL, NULL, 86168),
(86169, '3.90.1150.10-FF-000354', NULL, '3-amino-5-hydroxybenzoic acid synthase', 122, NULL, NULL, 86169),
(86170, '3.40.50.720-FF-000145', NULL, 'Retinol dehydrogenase 12', 284, NULL, NULL, 86170),
(86171, '3.30.160.60-FF-002514', NULL, 'Uncharacterized protein', 29, NULL, NULL, 86171),
(86172, '1.10.150.240-FF-000020', NULL, 'N-acetylmuramic acid 6-phosphate phosphatase', 68, NULL, NULL, 86172),
(86173, '1.10.560.10-FF-000159', NULL, 'T-complex protein 1 subunit delta', 112, NULL, NULL, 86173),
(86174, '3.30.830.10-FF-000016', NULL, 'Cytochrome b-c1 complex subunit 1, mitochondrial', 229, NULL, NULL, 86174),
(86175, '3.40.50.2300-FF-000247', NULL, 'Autoinducer 2 ABC transporter substrate-binding protein', 159, NULL, NULL, 86175),
(86176, '3.30.160.60-FF-000373', NULL, 'Putative transcriptional repressor ctcf', 29, NULL, NULL, 86176),
(86177, '3.30.40.10-FF-001754', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 141, NULL, NULL, 86177);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(86178, '3.30.2160.10-FF-000054', NULL, 'Predicted protein', 84, NULL, NULL, 86178),
(86179, '1.20.1560.10-FF-000745', NULL, 'Uncharacterized protein', 133, NULL, NULL, 86179),
(86180, '3.30.70.330-FF-000512', NULL, 'Ribosomal RNA-processing 7 homolog A', 109, NULL, NULL, 86180),
(86181, '2.60.40.10-FF-000884', NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein', 86, NULL, NULL, 86181),
(86182, '1.25.40.10-FF-001889', NULL, 'Pentatricopeptide repeat-containing protein', 207, NULL, NULL, 86182),
(86183, '1.10.150.60-FF-000047', NULL, NULL, 151, NULL, NULL, 86183),
(86184, '2.40.10.10-FF-000046', NULL, 'Complement factor b,-like', 119, NULL, NULL, 86184),
(86185, '1.10.472.10-FF-000263', NULL, 'Transcription factor IIIB 70 kDa subunit BRF', 88, NULL, NULL, 86185),
(86186, '2.40.50.140-FF-000778', NULL, NULL, 75, NULL, NULL, 86186),
(86187, '1.10.20.10-FF-000241', NULL, NULL, 102, NULL, NULL, 86187),
(86188, '3.40.50.720-FF-001781', NULL, '2-dehydropantoate 2-reductase', 175, NULL, NULL, 86188),
(86189, '1.20.1110.10-FF-000156', NULL, NULL, 209, NULL, NULL, 86189),
(86190, '3.70.10.10-FF-000121', NULL, 'DNA damage checkpoint protein', 171, NULL, NULL, 86190),
(86191, '2.130.10.10-FF-000536', NULL, 'WD repeat domain 62', 176, NULL, NULL, 86191),
(86192, '2.60.40.10-FF-001901', NULL, 'Complement C5', 114, NULL, NULL, 86192),
(86193, '3.30.70.330-FF-002985', NULL, NULL, 87, NULL, NULL, 86193),
(86194, '2.40.10.10-FF-000102', NULL, 'Dipeptidyl-peptidase 7', 60, NULL, NULL, 86194),
(86195, '3.40.50.300-FF-001211', NULL, 'Torsin family 3 member A', 202, NULL, NULL, 86195),
(86196, '2.10.70.10-FF-000242', NULL, 'Complement factor B', 59, NULL, NULL, 86196),
(86197, '1.25.40.10-FF-002165', NULL, 'Pentatricopeptide repeat-containing protein At4g21065', 98, NULL, NULL, 86197),
(86198, '1.20.1110.10-FF-000212', NULL, NULL, 66, NULL, NULL, 86198),
(86199, '1.10.150.120-FF-000001', NULL, 'Aldehyde oxidase 1', 132, NULL, NULL, 86199),
(86200, '3.90.1100.10-FF-000019', NULL, 'DNA-directed RNA polymerase subunit beta', 218, NULL, NULL, 86200),
(86201, '3.90.1150.220-FF-000006', NULL, 'DNA repair protein Nse1', 87, NULL, NULL, 86201),
(86202, '3.30.700.10-FF-000012', NULL, 'General secretion family protein', 100, NULL, NULL, 86202),
(86203, '3.90.1420.10-FF-000061', NULL, 'Predicted protein', 154, NULL, NULL, 86203),
(86204, '3.40.50.880-FF-000108', NULL, 'Putative glutamine amidotransferase-like protein C13C5.04', 220, NULL, NULL, 86204),
(86205, '2.60.40.60-FF-000707', NULL, 'Hedgehog protein', 101, NULL, NULL, 86205),
(86206, '3.30.160.60-FF-004644', NULL, NULL, 33, NULL, NULL, 86206),
(86207, '3.40.50.300-FF-007556', NULL, 'Uncharacterized protein', 191, NULL, NULL, 86207),
(86208, '3.60.40.10-FF-000207', NULL, 'Serine/threonine-protein phosphatase', 239, NULL, NULL, 86208),
(86209, '3.30.200.20-FF-001157', NULL, 'Predicted protein', 97, NULL, NULL, 86209),
(86210, '1.20.1250.20-FF-000995', NULL, 'MFS transporter', 398, NULL, NULL, 86210),
(86211, '4.10.280.10-FF-000098', NULL, 'Sterol regulatory element-binding protein', 79, NULL, NULL, 86211),
(86212, '3.10.110.10-FF-000258', NULL, 'RBR-type E3 ubiquitin transferase', 165, NULL, NULL, 86212),
(86213, '3.90.70.10-FF-000056', NULL, 'Ubiquitinyl hydrolase 1', 246, NULL, NULL, 86213),
(86214, '1.25.40.10-FF-005094', NULL, 'Uncharacterized protein', 67, NULL, NULL, 86214),
(86215, '2.20.70.10-FF-000101', NULL, 'Pre-mRNA-processing factor 40', 54, NULL, NULL, 86215),
(86216, '3.30.540.30-FF-000016', NULL, 'Dipeptidyl peptidase 3', 86, NULL, NULL, 86216),
(86217, '3.30.300.20-FF-000029', NULL, 'Ribosome-binding factor A', 116, NULL, NULL, 86217),
(86218, '2.60.40.10-FF-001502', NULL, 'Matrix remodeling associated 5', 89, NULL, NULL, 86218),
(86219, '2.60.40.10-FF-000209', NULL, 'Sidekick cell adhesion molecule 2', 97, NULL, NULL, 86219),
(86220, '3.10.250.10-FF-000077', NULL, NULL, 114, NULL, NULL, 86220),
(86221, '3.20.20.80-FF-000240', NULL, 'Chitinase', 322, NULL, NULL, 86221),
(86222, '3.90.245.10-FF-000002', NULL, 'Non-specific ribonucleoside hydrolase RihC', 301, NULL, NULL, 86222);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(86223, '1.20.58.200-FF-000006', NULL, NULL, 97, NULL, NULL, 86223),
(86224, '3.40.50.300-FF-000935', NULL, 'Mitochondrial Rho GTPase', 170, NULL, NULL, 86224),
(86225, '1.10.10.60-FF-000525', NULL, 'TetR family transcriptional regulator', 54, NULL, NULL, 86225),
(86226, '3.30.160.810-FF-000007', NULL, '50S ribosomal protein L3', 82, NULL, NULL, 86226),
(86227, '1.10.287.70-FF-000743', NULL, 'Uncharacterized protein', 96, NULL, NULL, 86227),
(86228, '3.40.50.720-FF-000089', NULL, 'UDP-glucose 6-dehydrogenase', 238, NULL, NULL, 86228),
(86229, '2.130.10.10-FF-003447', NULL, 'Sortilin', 134, NULL, NULL, 86229),
(86230, '3.40.50.300-FF-001716', NULL, 'Peroxisome biogenesis protein 6', 187, NULL, NULL, 86230),
(86231, '1.10.238.10-FF-000056', NULL, 'Myosin light chain 1 skeletal', 83, NULL, NULL, 86231),
(86232, '2.10.25.10-FF-000278', NULL, 'Stabilin 2', 43, NULL, NULL, 86232),
(86233, '3.40.50.300-FF-004066', NULL, 'Benign gonial cell neoplasm protein', 170, NULL, NULL, 86233),
(86234, '3.40.50.620-FF-000789', NULL, 'Uncharacterized protein', 61, NULL, NULL, 86234),
(86235, '1.20.58.1880-FF-000031', NULL, 'Os01g0193900 protein', 67, NULL, NULL, 86235),
(86236, '1.10.8.60-FF-000378', NULL, 'Katanin p60 ATPase-containing subunit A-like 2', 64, NULL, NULL, 86236),
(86237, '3.90.730.10-FF-000006', NULL, 'Ribonuclease, putative', 216, NULL, NULL, 86237),
(86238, '3.90.420.10-FF-000016', NULL, 'Nitrate reductase [NADH]', 65, NULL, NULL, 86238),
(86239, '2.60.120.290-FF-000011', NULL, 'Metalloendopeptidase', 115, NULL, NULL, 86239),
(86240, '3.40.640.10-FF-000140', NULL, 'Acetylornithine aminotransferase', 248, NULL, NULL, 86240),
(86241, '1.10.8.60-FF-000434', NULL, 'Uncharacterized protein', 86, NULL, NULL, 86241),
(86242, '1.10.630.10-FF-000316', NULL, 'Uncharacterized protein', 427, NULL, NULL, 86242),
(86243, '1.10.10.60-FF-000002', NULL, 'Myb family transcription factor', 59, NULL, NULL, 86243),
(86244, '1.20.58.1040-FF-000015', NULL, '1,3-beta-glucanosyltransferase', 106, NULL, NULL, 86244),
(86245, '4.10.280.10-FF-000154', NULL, 'Protein CBR-HLH-12', 69, NULL, NULL, 86245),
(86246, '3.40.1160.10-FF-000046', NULL, 'N-acetylglutamate kinase / N-acetylglutamate synthase', 297, NULL, NULL, 86246),
(86247, '1.25.10.10-FF-001612', NULL, 'Junction plakoglobin 1b', 313, NULL, NULL, 86247),
(86248, '2.60.40.10-FF-005212', NULL, NULL, 91, NULL, NULL, 86248),
(86249, '3.40.50.10810-FF-000034', NULL, 'Protein CHROMATIN REMODELING 8', 279, NULL, NULL, 86249),
(86250, '3.40.390.10-FF-000103', NULL, 'Matrix metallopeptidase 21', 250, NULL, NULL, 86250),
(86251, '3.10.450.10-FF-000076', NULL, 'Cystatin', 48, NULL, NULL, 86251),
(86252, '3.40.50.2000-FF-000039', NULL, 'alpha,alpha-trehalose-phosphate synthase [UDP-forming] 1-like', 203, NULL, NULL, 86252),
(86253, '2.10.25.10-FF-001571', NULL, 'Uncharacterized protein', 45, NULL, NULL, 86253),
(86254, '3.30.2170.10-FF-000004', NULL, 'Endonuclease V, putative', 239, NULL, NULL, 86254),
(86255, '1.20.1250.20-FF-001776', NULL, 'ADL185Wp', 186, NULL, NULL, 86255),
(86256, '2.30.30.100-FF-000006', NULL, 'Protein LSM14 homolog A isoform b', 85, NULL, NULL, 86256),
(86257, '1.10.8.530-FF-000006', NULL, 'Uncharacterized protein', 78, NULL, NULL, 86257),
(86258, '2.170.150.20-FF-000016', NULL, 'Peptide-methionine (R)-S-oxide reductase', 132, NULL, NULL, 86258),
(86259, '3.30.2090.10-FF-000003', NULL, 'Multidrug resistance protein MdtB', 93, NULL, NULL, 86259),
(86260, '2.60.40.10-FF-000541', NULL, 'striated muscle preferentially expressed protein kinase', 99, NULL, NULL, 86260),
(86261, '3.30.1070.10-FF-000002', NULL, 'Cell division topological specificity factor-like, chloroplastic', 81, NULL, NULL, 86261),
(86262, '3.30.70.240-FF-000018', NULL, 'GTP-binding translation elongation factor, putative', 94, NULL, NULL, 86262),
(86263, '3.30.565.10-FF-000175', NULL, 'PAS domain S-box-containing protein', 125, NULL, NULL, 86263),
(86264, '1.10.8.60-FF-000254', NULL, 'Origin recognition complex subunit 1', 117, NULL, NULL, 86264),
(86265, '3.40.190.290-FF-000107', NULL, 'Transcriptional regulator', 215, NULL, NULL, 86265);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(86266, '3.30.450.40-FF-000193', NULL, 'GAF domain-like protein', 170, NULL, NULL, 86266),
(86267, '3.30.980.10-FF-000004', NULL, 'Alanine--tRNA ligase, cytoplasmic', 176, NULL, NULL, 86267),
(86268, '3.30.70.2020-FF-000003', NULL, 'Phosphoserine phosphatase', 89, NULL, NULL, 86268),
(86269, '3.10.400.20-FF-000019', NULL, 'Translation machinery-associated protein 20', 180, NULL, NULL, 86269),
(86270, '3.40.50.970-FF-000023', NULL, 'Pyruvate dehydrogenase E1 component subunit alpha', 367, NULL, NULL, 86270),
(86271, '3.30.300.30-FF-000145', NULL, 'Acyl-CoA synthetase medium chain family member 2A', 79, NULL, NULL, 86271),
(86272, '2.10.250.10-FF-000019', NULL, 'Uncharacterized protein', 78, NULL, NULL, 86272),
(86273, '1.10.10.60-FF-000126', NULL, 'dorsal root ganglia homeobox protein-like', 66, NULL, NULL, 86273),
(86274, '2.40.50.770-FF-000006', NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', 160, NULL, NULL, 86274),
(86275, '1.10.287.130-FF-000267', NULL, 'Periplasmic substrate-binding histidine kinase', 58, NULL, NULL, 86275),
(86276, '1.25.40.10-FF-002906', NULL, 'Uncharacterized protein YbeQ', 333, NULL, NULL, 86276),
(86277, '1.20.1730.10-FF-000068', NULL, 'Acetate permease ActP', 293, NULL, NULL, 86277),
(86278, '2.40.160.110-FF-000043', NULL, 'Uncharacterized protein', 186, NULL, NULL, 86278),
(86279, '2.40.420.20-FF-000017', NULL, 'Putative multidrug resistance protein', 75, NULL, NULL, 86279),
(86280, '3.90.950.10-FF-000045', NULL, 'Predicted protein', 169, NULL, NULL, 86280),
(86281, '3.10.20.30-FF-000063', NULL, 'Succinate dehydrogenase subunit B', 113, NULL, NULL, 86281),
(86282, '3.30.160.60-FF-005948', NULL, NULL, 43, NULL, NULL, 86282),
(86283, '1.20.1560.10-FF-000240', NULL, 'ATP-binding cassette transporter', 24, NULL, NULL, 86283),
(86284, '2.60.40.10-FF-004251', NULL, NULL, 121, NULL, NULL, 86284),
(86285, '1.20.1300.10-FF-000024', NULL, 'GM26134', 146, NULL, NULL, 86285),
(86286, '1.10.287.70-FF-000687', NULL, 'Voltage-dependent calcium channel alpha13 subunit', 80, NULL, NULL, 86286),
(86287, '3.30.200.20-FF-001337', NULL, 'Os11g0609500 protein', 65, NULL, NULL, 86287),
(86288, '2.70.170.10-FF-000230', NULL, 'Protein CBR-EXP-1', 82, NULL, NULL, 86288),
(86289, '1.25.40.10-FF-002221', NULL, 'Alginate biosynthesis protein AlgK', 434, NULL, NULL, 86289),
(86290, '1.10.630.10-FF-000715', NULL, 'Uncharacterized protein', 108, NULL, NULL, 86290),
(86291, '1.25.40.10-FF-002345', NULL, 'Cyclophilin-like domain-containing protein', 157, NULL, NULL, 86291),
(86292, '2.120.10.30-FF-000104', NULL, 'NHL repeat containing 2', 85, NULL, NULL, 86292),
(86293, '2.60.40.10-FF-004375', NULL, NULL, 83, NULL, NULL, 86293),
(86294, '3.40.1110.10-FF-000043', NULL, 'Putative cadmium/zinc-transporting ATPase 3', 122, NULL, NULL, 86294),
(86295, '3.40.50.2300-FF-001208', NULL, NULL, 80, NULL, NULL, 86295),
(86296, '1.10.575.10-FF-000013', NULL, 'Class i nuclease-like protein', 89, NULL, NULL, 86296),
(86297, '2.70.50.40-FF-000005', NULL, 'Protein unc-119', 187, NULL, NULL, 86297),
(86298, '3.80.10.10-FF-002453', NULL, 'AGAP012123-PA', 78, NULL, NULL, 86298),
(86299, '3.40.50.2000-FF-000371', NULL, 'RfbG protein', 172, NULL, NULL, 86299),
(86300, '1.25.40.10-FF-001945', NULL, 'Pentatricopeptide repeat-containing protein', 74, NULL, NULL, 86300),
(86301, '3.40.50.150-FF-000744', NULL, 'Poly A polymerase regulatory subunit, putative', 284, NULL, NULL, 86301),
(86302, '1.10.238.10-FF-001017', NULL, 'Uncharacterized protein', 95, NULL, NULL, 86302),
(86303, '1.10.238.10-FF-000399', NULL, 'Reticulocalbin 2', 118, NULL, NULL, 86303),
(86304, '1.10.150.670-FF-000031', NULL, 'Uncharacterized protein', 46, NULL, NULL, 86304),
(86305, '3.30.160.60-FF-004588', NULL, NULL, 75, NULL, NULL, 86305),
(86306, '2.60.40.10-FF-003975', NULL, NULL, 129, NULL, NULL, 86306),
(86307, '2.10.25.10-FF-000839', NULL, 'Latent transforming growth factor beta binding protein 3', 40, NULL, NULL, 86307),
(86308, '3.40.50.300-FF-000755', NULL, 'Probable ATP-dependent DNA helicase CHR12', 299, NULL, NULL, 86308);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(86309, '1.10.20.10-FF-000185', NULL, 'DNA-binding protein HMf-2', 69, NULL, NULL, 86309),
(86310, '3.30.830.10-FF-000292', NULL, 'Uncharacterized protein', 147, NULL, NULL, 86310),
(86311, '2.130.10.10-FF-004408', NULL, 'DNA excision repair protein ckn1', 372, NULL, NULL, 86311),
(86312, '1.20.120.350-FF-000174', NULL, NULL, 155, NULL, NULL, 86312),
(86313, '3.90.650.10-FF-000005', NULL, 'Phosphoribosylformylglycinamidine synthase', 176, NULL, NULL, 86313),
(86314, '3.40.50.1820-FF-001839', NULL, '1-alkyl-2-acetylglycerophosphocholine esterase', 80, NULL, NULL, 86314),
(86315, '3.30.428.10-FF-000036', NULL, 'Histidine triad nucleotide-binding 4', 111, NULL, NULL, 86315),
(86316, '2.70.130.10-FF-000053', NULL, 'Putative mannose-6-phosphate/insulin receptor type ii', 154, NULL, NULL, 86316),
(86317, '3.90.70.10-FF-000399', NULL, 'ABC transporter HlyB/MsbA family', 127, NULL, NULL, 86317),
(86318, '3.40.50.80-FF-000022', NULL, 'Siderophore-interacting family protein', 122, NULL, NULL, 86318),
(86319, '3.90.1170.10-FF-000024', NULL, 'Uncharacterized protein', 95, NULL, NULL, 86319),
(86320, '3.30.160.60-FF-000193', NULL, 'Zinc finger protein 300', 29, NULL, NULL, 86320),
(86321, '1.20.120.1230-FF-000001', NULL, 'Sucrose synthase', 130, NULL, NULL, 86321),
(86322, '2.10.70.10-FF-000186', NULL, 'Uncharacterized protein', 78, NULL, NULL, 86322),
(86323, '2.10.70.10-FF-000062', NULL, 'CUB and Sushi multiple domains 3', 59, NULL, NULL, 86323),
(86324, '2.70.130.10-FF-000177', NULL, NULL, 166, NULL, NULL, 86324),
(86325, '3.40.50.720-FF-001106', NULL, 'Unplaced genomic scaffold supercont1.27, whole genome shotgun sequence', 97, NULL, NULL, 86325),
(86326, '3.30.160.60-FF-004987', NULL, NULL, 79, NULL, NULL, 86326),
(86327, '3.90.550.10-FF-000172', NULL, 'Hpnb', 209, NULL, NULL, 86327),
(86328, '3.40.50.300-FF-004465', NULL, 'DNA repair protein rad8', 263, NULL, NULL, 86328),
(86329, '3.40.250.10-FF-000093', NULL, 'Dual specificity protein phosphatase', 134, NULL, NULL, 86329),
(86330, '3.40.50.150-FF-000221', NULL, 'Methyltransferase-like protein', 260, NULL, NULL, 86330),
(86331, '2.60.120.620-FF-000099', NULL, 'Prolyl 4-hydroxylase', 208, NULL, NULL, 86331),
(86332, '3.70.10.10-FF-000065', NULL, 'DNA polymerase processivity factor', 303, NULL, NULL, 86332),
(86333, '3.40.50.300-FF-007899', NULL, 'Uncharacterized protein', 190, NULL, NULL, 86333),
(86334, '3.30.40.10-FF-001698', NULL, 'Uncharacterized protein', 67, NULL, NULL, 86334),
(86335, '1.25.40.10-FF-005256', NULL, 'Protein kinase rad3', 161, NULL, NULL, 86335),
(86336, '3.30.230.130-FF-000022', NULL, 'Anaphase-promoting complex subunit 2', 168, NULL, NULL, 86336),
(86337, '1.10.8.60-FF-000586', NULL, 'Uncharacterized protein', 14, NULL, NULL, 86337),
(86338, '3.50.50.60-FF-001364', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 57, NULL, NULL, 86338),
(86339, '1.10.287.110-FF-000380', NULL, 'Predicted protein', 103, NULL, NULL, 86339),
(86340, '3.40.50.10190-FF-000207', NULL, 'DNA-directed DNA/RNA polymerase mu', 106, NULL, NULL, 86340),
(86341, '1.10.20.10-FF-000180', NULL, 'Centromere protein W', 74, NULL, NULL, 86341),
(86342, '3.30.40.10-FF-000349', NULL, 'BRCA1 associated RING domain 1', 97, NULL, NULL, 86342),
(86343, '3.40.640.10-FF-000336', NULL, 'Predicted protein', 176, NULL, NULL, 86343),
(86344, '3.30.160.60-FF-006432', NULL, NULL, 41, NULL, NULL, 86344),
(86345, '2.30.36.70-FF-000005', NULL, 'Actin-like protein 6B', 44, NULL, NULL, 86345),
(86346, '3.30.70.100-FF-000117', NULL, NULL, 64, NULL, NULL, 86346),
(86347, '1.20.5.170-FF-000278', NULL, 'Uncharacterized protein', 58, NULL, NULL, 86347),
(86348, '3.90.1140.10-FF-000016', NULL, 'WGS project CABT00000000 data, contig 2.10', 204, NULL, NULL, 86348),
(86349, '1.20.120.230-FF-000048', NULL, 'TaLiN', 57, NULL, NULL, 86349),
(86350, '3.30.200.20-FF-001814', NULL, 'Serine/threonine protein kinase', 80, NULL, NULL, 86350),
(86351, '1.20.1250.20-FF-001669', NULL, 'Uncharacterized protein', 237, NULL, NULL, 86351),
(86352, '3.40.630.30-FF-000257', NULL, 'Putative N-acetyltransferase YhdJ', 136, NULL, NULL, 86352);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(86353, '1.10.510.10-FF-003758', NULL, NULL, 142, NULL, NULL, 86353),
(86354, '1.20.120.850-FF-000026', NULL, 'Helicase swr-1', 78, NULL, NULL, 86354),
(86355, '1.20.1250.20-FF-000051', NULL, 'Proline/glycine betaine transporter', 188, NULL, NULL, 86355),
(86356, '2.60.40.10-FF-005364', NULL, NULL, 63, NULL, NULL, 86356),
(86357, '1.10.486.10-FF-000076', NULL, 'DNA helicase', 65, NULL, NULL, 86357),
(86358, '2.60.260.20-FF-000023', NULL, 'Molecular chaperone DnaJ', 106, NULL, NULL, 86358),
(86359, '1.25.40.20-FF-001870', NULL, 'Predicted protein', 129, NULL, NULL, 86359),
(86360, '3.65.10.10-FF-000038', NULL, 'Pentafunctional AROM polypeptide', 135, NULL, NULL, 86360),
(86361, '3.40.50.1820-FF-000890', NULL, 'Abhydrolase domain containing 3', 124, NULL, NULL, 86361),
(86362, '1.20.120.1080-FF-000074', NULL, 'Predicted protein', 113, NULL, NULL, 86362),
(86363, '3.10.20.90-FF-000226', NULL, 'Ubiquitin-like protein nedd8 homologue, putative', 76, NULL, NULL, 86363),
(86364, '2.30.29.30-FF-000331', NULL, 'sharpin isoform X1', 126, NULL, NULL, 86364),
(86365, '1.25.10.10-FF-000415', NULL, 'Importin 5', 103, NULL, NULL, 86365),
(86366, '2.130.10.10-FF-000980', NULL, 'Nucleolar protein 10', 177, NULL, NULL, 86366),
(86367, '3.30.160.60-FF-004824', NULL, NULL, 67, NULL, NULL, 86367),
(86368, '3.30.2350.20-FF-000066', NULL, NULL, 220, NULL, NULL, 86368),
(86369, '3.20.20.140-FF-000357', NULL, 'Dipeptidase', 283, NULL, NULL, 86369),
(86370, '3.50.50.60-FF-000858', NULL, 'Uncharacterized protein', 114, NULL, NULL, 86370),
(86371, '3.60.20.10-FF-000032', NULL, 'Proteasome subunit beta', 204, NULL, NULL, 86371),
(86372, '3.90.1640.10-FF-000009', NULL, 'Predicted protein', 124, NULL, NULL, 86372),
(86373, '3.60.40.10-FF-000078', NULL, 'Protein phosphatase 2C, putative', 355, NULL, NULL, 86373),
(86374, '3.60.15.10-FF-000082', NULL, 'DNA repair protein, putative', 21, NULL, NULL, 86374),
(86375, '2.10.220.10-FF-000023', NULL, 'Furin, paired basic amino acid cleaving enzyme', 59, NULL, NULL, 86375),
(86376, '3.40.1160.10-FF-000074', NULL, 'Uncharacterized protein', 85, NULL, NULL, 86376),
(86377, '3.30.160.60-FF-002250', NULL, 'zinc finger protein 596 isoform X1', 33, NULL, NULL, 86377),
(86378, '3.40.50.720-FF-001713', NULL, 'Sll0096 protein', 134, NULL, NULL, 86378),
(86379, '2.130.10.10-FF-002262', NULL, 'General transcription factor 3C polypeptide 2', 315, NULL, NULL, 86379),
(86380, '3.40.50.300-FF-007972', NULL, 'Dynein heavy chain family protein', 162, NULL, NULL, 86380),
(86381, '3.40.50.300-FF-002649', NULL, 'ADP-ribosylation factor-like 3', 81, NULL, NULL, 86381),
(86382, '3.40.50.10190-FF-000196', NULL, 'Protein CBR-MUS-101', 103, NULL, NULL, 86382),
(86383, '1.25.40.10-FF-001541', NULL, 'Pentatricopeptide repeat (PPR) superfamily protein', 164, NULL, NULL, 86383),
(86384, '1.10.287.160-FF-000006', NULL, 'Tyrosine-protein kinase', 94, NULL, NULL, 86384),
(86385, '1.25.40.10-FF-003469', NULL, 'Pentatricopeptide repeat-containing protein At4g20770', 99, NULL, NULL, 86385),
(86386, '1.10.1140.10-FF-000019', NULL, 'Uncharacterized protein', 74, NULL, NULL, 86386),
(86387, '3.80.10.10-FF-002857', NULL, 'F-box/LRR-repeat protein, putative', 130, NULL, NULL, 86387),
(86388, '3.30.230.10-FF-000324', NULL, 'AAL093Cp', 128, NULL, NULL, 86388),
(86389, '3.30.160.60-FF-005004', NULL, NULL, 30, NULL, NULL, 86389),
(86390, '3.30.200.20-FF-002433', NULL, 'Uncharacterized protein', 76, NULL, NULL, 86390),
(86391, '1.10.3060.10-FF-000002', NULL, 'Preprotein translocase subunit SecA', 210, NULL, NULL, 86391),
(86392, '3.40.33.10-FF-000113', NULL, 'Protein CBR-TAG-254', 81, NULL, NULL, 86392),
(86393, '3.40.50.1010-FF-000225', NULL, NULL, 91, NULL, NULL, 86393),
(86394, '2.40.70.10-FF-000151', NULL, 'Gag polyprotein', 124, NULL, NULL, 86394),
(86395, '3.10.320.10-FF-000004', NULL, 'MHC class II H2-M beta 2 chain', 91, NULL, NULL, 86395),
(86396, '2.60.40.10-FF-001665', NULL, 'Muscle M-line assembly protein unc-89-like Protein', 95, NULL, NULL, 86396),
(86397, '1.10.287.370-FF-000070', NULL, 'Prefoldin subunit alpha', 146, NULL, NULL, 86397);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(86398, '3.40.50.150-FF-000980', NULL, NULL, 219, NULL, NULL, 86398),
(86399, '3.40.50.200-FF-000158', NULL, 'Peptidase subtilase family', 281, NULL, NULL, 86399),
(86400, '2.10.109.10-FF-000079', NULL, 'Mitochondrial inner membrane protease subunit', 80, NULL, NULL, 86400),
(86401, '2.10.25.10-FF-000087', NULL, 'Fibrillin 2', 40, NULL, NULL, 86401),
(86402, '2.60.40.10-FF-002621', NULL, 'Microfibril associated protein 3 like', 96, NULL, NULL, 86402),
(86403, '3.40.50.720-FF-002539', NULL, 'Uncharacterized protein', 75, NULL, NULL, 86403),
(86404, '3.30.40.10-FF-001294', NULL, 'Uncharacterized protein', 63, NULL, NULL, 86404),
(86405, '3.30.70.270-FF-000241', NULL, NULL, 99, NULL, NULL, 86405),
(86406, '1.20.5.340-FF-000009', NULL, 'myosin-11 isoform X2', 122, NULL, NULL, 86406),
(86407, '1.20.920.10-FF-000218', NULL, 'Bromodomain protein', 86, NULL, NULL, 86407),
(86408, '1.10.10.60-FF-001306', NULL, NULL, 47, NULL, NULL, 86408),
(86409, '1.20.1270.60-FF-000159', NULL, 'Zgc:158689', 132, NULL, NULL, 86409),
(86410, '3.30.420.10-FF-000507', NULL, NULL, 73, NULL, NULL, 86410),
(86411, '4.10.280.10-FF-000159', NULL, 'Basic helix-loop-helix (BHLH) DNA-binding superfamily protein', 82, NULL, NULL, 86411),
(86412, '1.20.1560.10-FF-000824', NULL, 'p-glycoprotein', 30, NULL, NULL, 86412),
(86413, '1.25.40.20-FF-000881', NULL, 'Uncharacterized protein', 401, NULL, NULL, 86413),
(86414, '3.80.10.10-FF-000087', NULL, 'F-box/LRR-repeat protein 16 isoform X1', 95, NULL, NULL, 86414),
(86415, '2.70.130.10-FF-000076', NULL, NULL, 152, NULL, NULL, 86415),
(86416, '2.60.120.10-FF-000173', NULL, 'Vicilin-like antimicrobial peptides 2-3', 194, NULL, NULL, 86416),
(86417, '1.10.10.520-FF-000013', NULL, 'SUMO-activating enzyme subunit', 210, NULL, NULL, 86417),
(86418, '3.40.630.10-FF-000408', NULL, 'Peptidase M20 domain-containing protein 2', 167, NULL, NULL, 86418),
(86419, '1.10.510.10-FF-001960', NULL, 'Uncharacterized protein', 276, NULL, NULL, 86419),
(86420, '1.20.1200.10-FF-000011', NULL, 'Predicted protein', 128, NULL, NULL, 86420),
(86421, '1.10.287.480-FF-000001', NULL, '33 kDa chaperonin', 49, NULL, NULL, 86421),
(86422, '2.130.10.10-FF-001317', NULL, 'DDB1-and CUL4-associated factor', 101, NULL, NULL, 86422),
(86423, '3.30.70.330-FF-001372', NULL, 'RNA-binding protein, putative', 130, NULL, NULL, 86423),
(86424, '1.10.472.10-FF-000004', NULL, 'Cyclin T2', 117, NULL, NULL, 86424),
(86425, '3.90.550.10-FF-000088', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 383, NULL, NULL, 86425),
(86426, '1.20.58.390-FF-000304', NULL, 'Uncharacterized protein', 128, NULL, NULL, 86426),
(86427, '3.30.497.10-FF-000139', NULL, 'Uncharacterized protein', 218, NULL, NULL, 86427),
(86428, '3.10.580.10-FF-000080', NULL, 'Chloride channel protein', 172, NULL, NULL, 86428),
(86429, '3.90.70.10-FF-000764', NULL, 'Uncharacterized protein', 86, NULL, NULL, 86429),
(86430, '3.10.120.10-FF-000023', NULL, 'Probable conserved membrane protein', 74, NULL, NULL, 86430),
(86431, '3.40.250.10-FF-000172', NULL, 'Uncharacterized protein', 131, NULL, NULL, 86431),
(86432, '2.60.40.640-FF-000079', NULL, 'Uncharacterized protein', 137, NULL, NULL, 86432),
(86433, '3.10.100.10-FF-000010', NULL, 'C-type lectin domain family 3 member A', 136, NULL, NULL, 86433),
(86434, '1.25.40.10-FF-000552', NULL, 'UDP-N-acetylglucosaminyltransferase (AFU_orthologue AFUA_1G03380)', 124, NULL, NULL, 86434),
(86435, '3.10.20.70-FF-000007', NULL, 'LOW QUALITY PROTEIN: lengsin', 108, NULL, NULL, 86435),
(86436, '3.40.50.970-FF-000102', NULL, 'Protein PHYLLO, chloroplastic', 223, NULL, NULL, 86436),
(86437, '3.30.160.60-FF-003559', NULL, NULL, 30, NULL, NULL, 86437),
(86438, '3.30.1330.30-FF-000056', NULL, 'MRM1p Ribose methyltransferase', 79, NULL, NULL, 86438),
(86439, '3.40.50.10260-FF-000032', NULL, 'ADP-dependent (S)-NAD(P)H-hydrate dehydratase', 183, NULL, NULL, 86439),
(86440, '3.30.530.20-FF-000165', NULL, 'Uncharacterized protein (Fragment)', 131, NULL, NULL, 86440),
(86441, '3.90.550.50-FF-000004', NULL, 'Hexosyltransferase', 261, NULL, NULL, 86441);
INSERT INTO "PUBLIC"."MODEL" VALUES
(86442, '3.30.420.10-FF-000187', NULL, 'DNA polymerase', 199, NULL, NULL, 86442),
(86443, '3.30.1360.10-FF-000018', NULL, 'DNA-directed RNA polymerase I/III subunit, putative', 109, NULL, NULL, 86443),
(86444, '2.60.120.10-FF-000217', NULL, 'DNA-binding protein', 108, NULL, NULL, 86444),
(86445, '3.40.50.1100-FF-000117', NULL, 'Threonine dehydratase lateral transfer candidate', 210, NULL, NULL, 86445),
(86446, '3.40.50.300-FF-008591', NULL, 'Uncharacterized protein', 125, NULL, NULL, 86446),
(86447, '3.40.50.920-FF-000020', NULL, 'Putative 2-oxoisovalerate dehydrogenase beta subunit, mitochondrial', 130, NULL, NULL, 86447),
(86448, '3.30.60.30-FF-000098', NULL, 'Serine protease HTRA4', 48, NULL, NULL, 86448),
(86449, '1.10.287.130-FF-000110', NULL, 'Two-component system sensor histidine kinase/response regulator', 77, NULL, NULL, 86449),
(86450, '3.40.30.10-FF-000399', NULL, 'Uncharacterized protein, isoform C', 104, NULL, NULL, 86450),
(86451, '2.10.90.10-FF-000029', NULL, 'glycoprotein hormone beta-5', 100, NULL, NULL, 86451),
(86452, '2.60.40.10-FF-002019', NULL, 'Uncharacterized protein, isoform C', 125, NULL, NULL, 86452),
(86453, '3.30.200.20-FF-002080', NULL, NULL, 83, NULL, NULL, 86453),
(86454, '3.40.50.1000-FF-000335', NULL, 'Copper-transporting P-type ATPase', 138, NULL, NULL, 86454),
(86455, '3.40.630.10-FF-000038', NULL, 'Alkaline phosphatase isozyme conversion', 319, NULL, NULL, 86455),
(86456, '3.40.50.300-FF-002296', NULL, 'GTPase Era, putative', 190, NULL, NULL, 86456),
(86457, '3.30.470.20-FF-000238', NULL, 'Glutathione synthetase', 72, NULL, NULL, 86457),
(86458, '2.130.10.130-FF-000032', NULL, 'Phosphatidylinositol-glycan-specific phospholipase D', 165, NULL, NULL, 86458),
(86459, '3.10.250.10-FF-000105', NULL, NULL, 103, NULL, NULL, 86459),
(86460, '2.30.29.30-FF-001320', NULL, 'Diacylglycerol kinase', 66, NULL, NULL, 86460),
(86461, '2.10.70.10-FF-000146', NULL, 'Furrowed, isoform A', 75, NULL, NULL, 86461),
(86462, '1.20.58.70-FF-000008', NULL, 'Syntaxin family protein', 198, NULL, NULL, 86462),
(86463, '1.10.10.60-FF-000789', NULL, NULL, 63, NULL, NULL, 86463),
(86464, '2.30.30.30-FF-000076', NULL, 'Transcription elongation factor SPT5', 61, NULL, NULL, 86464),
(86465, '2.30.130.10-FF-000034', NULL, 'PUA domain protein', 78, NULL, NULL, 86465),
(86466, '1.20.1440.90-FF-000002', NULL, 'Phosphoenolpyruvate carboxylase', 116, NULL, NULL, 86466),
(86467, '1.10.225.10-FF-000009', NULL, 'Acyloxyacyl hydrolase', 85, NULL, NULL, 86467),
(86468, '1.20.1250.20-FF-000843', NULL, 'MFS transporter, putative', 188, NULL, NULL, 86468),
(86469, '1.50.40.10-FF-000504', NULL, 'Uncharacterized protein', 251, NULL, NULL, 86469),
(86470, '2.60.120.10-FF-000526', NULL, 'Calcium/calmodulin dependent protein kinase kinase 1', 130, NULL, NULL, 86470),
(86471, '2.130.10.10-FF-000345', NULL, 'intraflagellar transport protein 172 homolog', 180, NULL, NULL, 86471),
(86472, '3.30.420.40-FF-000522', NULL, 'Heat shock protein 70, putative', 186, NULL, NULL, 86472),
(86473, '1.20.1050.10-FF-000050', NULL, 'Elongation factor 1-gamma, putative', 124, NULL, NULL, 86473),
(86474, '1.10.8.70-FF-000004', NULL, 'Glutamate--tRNA ligase 2', 50, NULL, NULL, 86474),
(86475, '2.30.29.30-FF-001096', NULL, 'Uncharacterized protein', 35, NULL, NULL, 86475),
(86476, '1.10.510.10-FF-000369', NULL, 'Serine/threonine kinase 17a', 255, NULL, NULL, 86476),
(86477, '3.30.160.60-FF-005813', NULL, NULL, 26, NULL, NULL, 86477),
(86478, '1.20.5.320-FF-000003', NULL, 'Collagen, type XVII, alpha 1', 51, NULL, NULL, 86478),
(86479, '2.60.40.10-FF-000676', NULL, 'motile sperm domain-containing protein 3', 105, NULL, NULL, 86479),
(86480, '3.90.190.10-FF-000458', NULL, 'Protein tyrosine phosphatase non-receptor type 6', 202, NULL, NULL, 86480),
(86481, '3.20.20.80-FF-000184', NULL, 'Beta-amylase', 450, NULL, NULL, 86481),
(86482, '3.40.1280.30-FF-000027', NULL, 'Putative tRNA m1G methyltransferase', 185, NULL, NULL, 86482),
(86483, '3.40.50.12090-FF-000002', NULL, 'Cell surface protein', 95, NULL, NULL, 86483),
(86484, '3.30.450.30-FF-000021', NULL, 'Uncharacterized protein', 104, NULL, NULL, 86484);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(86485, '1.20.58.1610-FF-000023', NULL, NULL, 109, NULL, NULL, 86485),
(86486, '3.40.50.10860-FF-000015', NULL, 'Pentafunctional AROM polypeptide', 119, NULL, NULL, 86486),
(86487, '3.30.60.20-FF-000106', NULL, 'Diacylglycerol kinase', 51, NULL, NULL, 86487),
(86488, '3.40.50.1010-FF-000181', NULL, NULL, 195, NULL, NULL, 86488),
(86489, '2.160.10.10-FF-000057', NULL, 'Sugar 1-phosphate guanyl transferase, putative', 108, NULL, NULL, 86489),
(86490, '2.40.30.10-FF-000249', NULL, 'Eukaryotic translation initiation factor 5B, isoform D', 47, NULL, NULL, 86490),
(86491, '3.90.400.10-FF-000004', NULL, 'Oligo-1,6-glucosidase', 69, NULL, NULL, 86491),
(86492, '3.40.50.1240-FF-000165', NULL, NULL, 224, NULL, NULL, 86492),
(86493, '2.40.50.100-FF-000053', NULL, 'DNA-directed RNA polymerase subunit beta', 75, NULL, NULL, 86493),
(86494, '3.90.190.20-FF-000006', NULL, 'UDP-N-acetylmuramoyl-L-alanyl-D-glutamate--2,6-diaminopimelate ligase', 157, NULL, NULL, 86494),
(86495, '1.10.287.70-FF-000367', NULL, 'Cyclic nucleotide-gated cation channel', 237, NULL, NULL, 86495),
(86496, '2.40.50.140-FF-001234', NULL, NULL, 42, NULL, NULL, 86496),
(86497, '3.80.10.10-FF-003021', NULL, 'LOC100145161 protein', 156, NULL, NULL, 86497),
(86498, '1.10.274.100-FF-000030', NULL, 'RNA polymerase I largest subunit', 184, NULL, NULL, 86498),
(86499, '3.40.50.970-FF-000091', NULL, 'Xylulose-5-phosphate/fructose-6-phosphate phosphoketolase', 217, NULL, NULL, 86499),
(86500, '3.40.50.200-FF-000028', NULL, 'Microbial collagenase', 325, NULL, NULL, 86500),
(86501, '3.30.9.10-FF-000024', NULL, 'Putative sarcosine oxidase', 198, NULL, NULL, 86501),
(86502, '3.50.50.60-FF-001055', NULL, 'Guanosine nucleotide diphosphate dissociation inhibitor', 32, NULL, NULL, 86502),
(86503, '3.30.70.1350-FF-000032', NULL, NULL, 82, NULL, NULL, 86503),
(86504, '1.10.10.10-FF-001724', NULL, 'Probable metalloprotease ARX1', 63, NULL, NULL, 86504),
(86505, '2.60.40.10-FF-004419', NULL, NULL, 97, NULL, NULL, 86505),
(86506, '2.10.25.10-FF-001059', NULL, 'GD23952', 64, NULL, NULL, 86506),
(86507, '1.20.5.110-FF-000058', NULL, 'VAM7p Vacuolar SNARE protein', 63, NULL, NULL, 86507),
(86508, '2.120.10.30-FF-000172', NULL, 'Low-density lipoprotein RecePtor related', 284, NULL, NULL, 86508),
(86509, '2.170.140.10-FF-000041', NULL, 'GD12214', 61, NULL, NULL, 86509),
(86510, '2.130.10.10-FF-004240', NULL, 'Uncharacterized protein', 141, NULL, NULL, 86510),
(86511, '4.10.970.10-FF-000015', NULL, 'Predicted protein', 62, NULL, NULL, 86511),
(86512, '3.30.160.60-FF-003868', NULL, NULL, 38, NULL, NULL, 86512),
(86513, '2.130.10.10-FF-005651', NULL, 'Myosin heavy chain kinase B', 169, NULL, NULL, 86513),
(86514, '3.40.50.150-FF-000328', NULL, 'FkbM family methyltransferase', 173, NULL, NULL, 86514),
(86515, '3.30.830.10-FF-000061', NULL, 'Stromal-processing peptidase', 265, NULL, NULL, 86515),
(86516, '3.60.40.10-FF-000387', NULL, 'Uncharacterized protein', 128, NULL, NULL, 86516),
(86517, '3.40.1110.10-FF-000363', NULL, 'Cation-transporting ATPase', 222, NULL, NULL, 86517),
(86518, '3.90.105.20-FF-000017', NULL, 'Ribosome assembly factor mrt4', 90, NULL, NULL, 86518),
(86519, '3.30.160.60-FF-000772', NULL, 'tripartite motif-containing protein 59', 45, NULL, NULL, 86519),
(86520, '3.20.20.70-FF-000708', NULL, NULL, 140, NULL, NULL, 86520),
(86521, '1.20.1420.10-FF-000022', NULL, 'TaLiN', 159, NULL, NULL, 86521),
(86522, '3.30.450.20-FF-000664', NULL, 'Predicted protein', 109, NULL, NULL, 86522),
(86523, '3.30.750.44-FF-000017', NULL, NULL, 90, NULL, NULL, 86523),
(86524, '2.40.50.120-FF-000059', NULL, 'Protein CBR-AGR-1', 111, NULL, NULL, 86524),
(86525, '3.30.70.20-FF-000034', NULL, 'Ferredoxin', 81, NULL, NULL, 86525),
(86526, '3.30.70.330-FF-000220', NULL, 'Heterogeneous nuclear ribonucleoprotein D-like protein', 124, NULL, NULL, 86526),
(86527, '3.30.200.20-FF-000033', NULL, 'Tyrosine-protein kinase receptor', 118, NULL, NULL, 86527),
(86528, '2.90.10.10-FF-000061', NULL, 'Comitin', 71, NULL, NULL, 86528),
(86529, '2.10.25.10-FF-000879', NULL, 'Disintegrin and metalloproteinase domain-containing protein unc-71', 40, NULL, NULL, 86529);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(86530, '3.60.21.10-FF-000495', NULL, 'Trifunctional nucleotide phosphoesterase protein YfkN', 310, NULL, NULL, 86530),
(86531, '3.30.572.10-FF-000005', NULL, 'Thymidylate synthase', 316, NULL, NULL, 86531),
(86532, '3.90.1150.10-FF-000270', NULL, 'Pyridoxal phosphate-dependent aminotransferase', 108, NULL, NULL, 86532),
(86533, '1.25.10.10-FF-003158', NULL, 'Predicted protein', 412, NULL, NULL, 86533),
(86534, '3.40.710.10-FF-000191', NULL, 'Uncharacterized protein', 249, NULL, NULL, 86534),
(86535, '1.20.91.20-FF-000014', NULL, 'Uncharacterized protein', 82, NULL, NULL, 86535),
(86536, '3.90.226.10-FF-000262', NULL, 'Enoyl-CoA hydratase', 298, NULL, NULL, 86536),
(86537, '3.30.160.60-FF-001098', NULL, 'Ras responsive element binding protein 1', 31, NULL, NULL, 86537),
(86538, '1.20.1070.10-FF-000949', NULL, 'Uncharacterized protein', 333, NULL, NULL, 86538),
(86539, '1.10.1040.10-FF-000091', NULL, 'Uncharacterized protein', 134, NULL, NULL, 86539),
(86540, '1.25.40.20-FF-000925', NULL, 'ankyrin repeat and zinc finger domain-containing protein 1-like', 252, NULL, NULL, 86540),
(86541, '3.30.420.270-FF-000034', NULL, 'Tol-Pal system protein TolR', 77, NULL, NULL, 86541),
(86542, '2.30.40.10-FF-000155', NULL, 'Amidohydrolase', 78, NULL, NULL, 86542),
(86543, '2.30.39.10-FF-000090', NULL, 'Serpin peptidase inhibitor, clade G (C1 inhibitor), member 1', 183, NULL, NULL, 86543),
(86544, '1.25.40.10-FF-003339', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 93, NULL, NULL, 86544),
(86545, '3.30.470.30-FF-000084', NULL, 'DNA ligase', 35, NULL, NULL, 86545),
(86546, '1.10.287.70-FF-000030', NULL, 'Cyclic nucleotide-gated channel alpha 3', 236, NULL, NULL, 86546),
(86547, '1.20.1740.10-FF-000259', NULL, 'SD09342p', 149, NULL, NULL, 86547),
(86548, '1.25.40.10-FF-000243', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 100, NULL, NULL, 86548),
(86549, '3.40.50.410-FF-000092', NULL, 'Midasin', 181, NULL, NULL, 86549),
(86550, '1.20.1560.10-FF-000032', NULL, 'ATP-binding cassette sub-family C member 6', 331, NULL, NULL, 86550),
(86551, '2.60.40.10-FF-001974', NULL, 'Piezo-type mechanosensitive ion channel component 2', 111, NULL, NULL, 86551),
(86552, '1.10.275.10-FF-000029', NULL, NULL, 128, NULL, NULL, 86552),
(86553, '3.30.40.10-FF-001277', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 101, NULL, NULL, 86553),
(86554, '2.60.34.10-FF-000100', NULL, 'Uncharacterized protein', 126, NULL, NULL, 86554),
(86555, '1.20.120.350-FF-000101', NULL, 'Voltage-gated Ion Channel (VIC) Superfamily', 131, NULL, NULL, 86555),
(86556, '2.60.40.10-FF-004728', NULL, NULL, 104, NULL, NULL, 86556),
(86557, '2.60.120.290-FF-000163', NULL, 'Multiple epidermal growth factor-like domains protein 8', 135, NULL, NULL, 86557),
(86558, '3.40.50.300-FF-004566', NULL, 'Chromosome 8, whole genome shotgun sequence', 217, NULL, NULL, 86558),
(86559, '1.10.1300.10-FF-000010', NULL, 'Phosphodiesterase', 385, NULL, NULL, 86559),
(86560, '3.30.160.60-FF-005021', NULL, NULL, 48, NULL, NULL, 86560),
(86561, '1.10.150.50-FF-000139', NULL, 'Uncharacterized protein', 76, NULL, NULL, 86561),
(86562, '1.20.120.1900-FF-000045', NULL, 'Gamma-tubulin complex component', 261, NULL, NULL, 86562),
(86563, '3.40.1170.10-FF-000029', NULL, 'DNA mismatch repair protein MSH3', 141, NULL, NULL, 86563),
(86564, '3.10.110.10-FF-000067', NULL, 'ubiquitin-conjugating enzyme E2 U isoform X1', 148, NULL, NULL, 86564),
(86565, '3.40.50.10240-FF-000037', NULL, 'Uncharacterized protein', 122, NULL, NULL, 86565),
(86566, '1.10.20.10-FF-000050', NULL, 'centromere protein T isoform X2', 103, NULL, NULL, 86566),
(86567, '1.10.506.10-FF-000090', NULL, 'Uncharacterized protein', 97, NULL, NULL, 86567),
(86568, '2.130.10.10-FF-002323', NULL, 'U3 small nucleolar RNA-associated protein 15-like protein', 169, NULL, NULL, 86568),
(86569, '1.10.245.10-FF-000011', NULL, 'SWI/SNF complex component SNF12 homolog', 85, NULL, NULL, 86569),
(86570, '3.40.525.10-FF-000041', NULL, 'CRAL/TRIO, N-terminus family protein, expressed', 52, NULL, NULL, 86570);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(86571, '1.10.238.10-FF-000871', NULL, 'Uncharacterized protein', 59, NULL, NULL, 86571),
(86572, '3.40.605.10-FF-000075', NULL, 'Uncharacterized protein', 275, NULL, NULL, 86572),
(86573, '1.20.1070.10-FF-000966', NULL, '5-HT4 receptor, putative', 317, NULL, NULL, 86573),
(86574, '1.20.1070.10-FF-001585', NULL, 'Endothelin receptor A', 157, NULL, NULL, 86574),
(86575, '1.10.10.60-FF-000334', NULL, 'Paired mesoderm homeobox protein 2B', 51, NULL, NULL, 86575),
(86576, '3.30.1450.10-FF-000008', NULL, NULL, 84, NULL, NULL, 86576),
(86577, '1.10.30.10-FF-000135', NULL, 'Uncharacterized protein', 92, NULL, NULL, 86577),
(86578, '2.60.40.10-FF-000221', NULL, 'neural cell adhesion molecule 1 isoform X2', 95, NULL, NULL, 86578),
(86579, '3.30.160.60-FF-006302', NULL, NULL, 76, NULL, NULL, 86579),
(86580, '3.30.160.60-FF-004515', NULL, NULL, 29, NULL, NULL, 86580),
(86581, '3.30.200.20-FF-001944', NULL, 'Uncharacterized protein', 108, NULL, NULL, 86581),
(86582, '1.10.1040.10-FF-000074', NULL, 'Altronate oxidoreductase', 204, NULL, NULL, 86582),
(86583, '1.20.1270.60-FF-000176', NULL, 'Uncharacterized protein', 223, NULL, NULL, 86583),
(86584, '2.60.120.200-FF-000400', NULL, 'Laminin, alpha 5', 170, NULL, NULL, 86584),
(86585, '2.60.120.650-FF-000203', NULL, 'Uncharacterized protein', 157, NULL, NULL, 86585),
(86586, '3.40.47.10-FF-000055', NULL, '3-oxoacyl-ACP synthase III', 198, NULL, NULL, 86586),
(86587, '1.25.10.10-FF-002332', NULL, 'Uncharacterized protein', 300, NULL, NULL, 86587),
(86588, '3.40.50.300-FF-008017', NULL, 'Autophagy-related protein 13', 142, NULL, NULL, 86588),
(86589, '4.10.400.10-FF-000187', NULL, 'Tequila, isoform G', 41, NULL, NULL, 86589),
(86590, '1.20.58.60-FF-000331', NULL, 'VAB-10B protein', 110, NULL, NULL, 86590),
(86591, '2.60.120.430-FF-000031', NULL, 'Predicted protein', 182, NULL, NULL, 86591),
(86592, '2.130.10.10-FF-002806', NULL, 'Uncharacterized protein', 173, NULL, NULL, 86592),
(86593, '3.80.10.10-FF-002874', NULL, 'Leucine-rich receptor-like protein kinase family protein', 73, NULL, NULL, 86593),
(86594, '3.40.50.150-FF-001817', NULL, NULL, 93, NULL, NULL, 86594),
(86595, '2.20.25.530-FF-000009', NULL, 'Uncharacterized protein', 76, NULL, NULL, 86595),
(86596, '1.10.287.110-FF-000363', NULL, 'Chaperone protein dnaJ', 112, NULL, NULL, 86596),
(86597, '3.20.20.80-FF-000728', NULL, 'Uncharacterized protein', 122, NULL, NULL, 86597),
(86598, '3.30.810.10-FF-000009', NULL, 'Phosphatidylinositol 4-phosphate 5-kinase', 116, NULL, NULL, 86598),
(86599, '3.20.70.20-FF-000028', NULL, 'Vitamin B12-dependent ribonucleotide reductase', 345, NULL, NULL, 86599),
(86600, '2.60.40.10-FF-002593', NULL, 'Muscle M-line assembly protein unc-89-like Protein', 101, NULL, NULL, 86600),
(86601, '3.60.20.40-FF-000030', NULL, 'Uncharacterized protein', 188, NULL, NULL, 86601),
(86602, '3.80.10.10-FF-000879', NULL, 'Adenylate cyclase', 112, NULL, NULL, 86602),
(86603, '1.25.40.20-FF-001398', NULL, 'Ankyrin repeat and SOCS box containing 5', 77, NULL, NULL, 86603),
(86604, '3.30.300.160-FF-000019', NULL, 'Type II secretion system ATPase PulE', 77, NULL, NULL, 86604),
(86605, '1.10.8.60-FF-000569', NULL, 'Acetoin catabolism regulatory protein', 71, NULL, NULL, 86605),
(86606, '2.10.110.10-FF-000296', NULL, 'Uncharacterized protein', 110, NULL, NULL, 86606),
(86607, '1.20.1250.10-FF-000031', NULL, 'Oncostatin M', 187, NULL, NULL, 86607),
(86608, '3.30.70.330-FF-002018', NULL, NULL, 174, NULL, NULL, 86608),
(86609, '3.20.20.70-FF-000490', NULL, NULL, 105, NULL, NULL, 86609),
(86610, '3.90.870.10-FF-000016', NULL, 'Sua5/YciO/YrdC/YwlC family protein', 189, NULL, NULL, 86610),
(86611, '2.60.40.10-FF-005717', NULL, NULL, 40, NULL, NULL, 86611),
(86612, '2.10.90.10-FF-000046', NULL, 'Interleukin 17C', 126, NULL, NULL, 86612),
(86613, '1.25.10.10-FF-001893', NULL, 'Condensin complex subunit 1', 280, NULL, NULL, 86613),
(86614, '3.40.710.10-FF-000089', NULL, 'Peptidoglycan D,D-transpeptidase MrdA', 363, NULL, NULL, 86614),
(86615, '2.30.130.40-FF-000032', NULL, 'protein cereblon isoform X1', 132, NULL, NULL, 86615);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(86616, '3.60.15.10-FF-000110', NULL, 'cAMP-specific phosphodiesterase', 279, NULL, NULL, 86616),
(86617, '3.90.180.10-FF-000031', NULL, '(R,R)-butanediol dehydrogenase', 205, NULL, NULL, 86617),
(86618, '3.40.50.720-FF-000302', NULL, 'Alcohol dehydrogenase', 254, NULL, NULL, 86618),
(86619, '3.10.196.10-FF-000001', NULL, 'Methionine synthase', 235, NULL, NULL, 86619),
(86620, '3.40.1640.10-FF-000004', NULL, 'Uncharacterized protein', 28, NULL, NULL, 86620),
(86621, '3.40.50.261-FF-000019', NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta', 146, NULL, NULL, 86621),
(86622, '3.40.50.11210-FF-000002', NULL, 'Signal-induced proliferation-associated 1-like protein 1', 185, NULL, NULL, 86622),
(86623, '1.25.40.10-FF-000113', NULL, 'Peptidylprolyl isomerase', 149, NULL, NULL, 86623),
(86624, '3.30.40.10-FF-001810', NULL, 'Uncharacterized protein', 65, NULL, NULL, 86624),
(86625, '2.130.10.10-FF-004370', NULL, 'Predicted protein', 85, NULL, NULL, 86625),
(86626, '3.90.740.10-FF-000012', NULL, 'Leucine--tRNA ligase', 175, NULL, NULL, 86626),
(86627, '3.30.70.330-FF-001681', NULL, NULL, 87, NULL, NULL, 86627),
(86628, '3.30.70.1620-FF-000017', NULL, 'Structural maintenance of chromosomes protein', 89, NULL, NULL, 86628),
(86629, '3.90.550.10-FF-000312', NULL, 'hyaluronan synthase 3 isoform X2', 140, NULL, NULL, 86629),
(86630, '1.20.930.40-FF-000031', NULL, 'Predicted protein', 132, NULL, NULL, 86630),
(86631, '3.40.470.10-FF-000036', NULL, NULL, 175, NULL, NULL, 86631),
(86632, '1.25.40.20-FF-001853', NULL, 'BTB/POZ domain-containing protein 1', 136, NULL, NULL, 86632),
(86633, '3.30.160.60-FF-003998', NULL, NULL, 30, NULL, NULL, 86633),
(86634, '3.20.20.450-FF-000023', NULL, 'Sensory box/GGDEF family protein', 258, NULL, NULL, 86634),
(86635, '3.10.600.10-FF-000003', NULL, 'Pyruvate carboxylase', 61, NULL, NULL, 86635),
(86636, '3.90.226.10-FF-000306', NULL, 'Enoyl-CoA delta isomerase 2 peroxisomal', 109, NULL, NULL, 86636),
(86637, '3.90.1420.10-FF-000015', NULL, 'Cytoplasmic protein', 154, NULL, NULL, 86637),
(86638, '3.40.50.10810-FF-000242', NULL, 'Uncharacterized protein', 184, NULL, NULL, 86638),
(86639, '3.30.70.330-FF-000883', NULL, 'Polypyrimidine tract-binding protein 3', 96, NULL, NULL, 86639),
(86640, '3.30.565.10-FF-000332', NULL, 'Two-component sensor kinase', 153, NULL, NULL, 86640),
(86641, '2.40.100.10-FF-000041', NULL, 'Peptidyl-prolyl cis-trans isomerase', 213, NULL, NULL, 86641),
(86642, '2.60.40.150-FF-000820', NULL, 'Uncharacterized protein', 59, NULL, NULL, 86642),
(86643, '1.25.40.10-FF-003778', NULL, 'Uncharacterized protein', 155, NULL, NULL, 86643),
(86644, '1.25.40.990-FF-000043', NULL, 'SAC3/GANP family protein', 276, NULL, NULL, 86644),
(86645, '3.30.160.60-FF-004487', NULL, NULL, 79, NULL, NULL, 86645),
(86646, '3.50.50.60-FF-000066', NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', 132, NULL, NULL, 86646),
(86647, '3.30.160.60-FF-000333', NULL, 'Zinc finger and BTB domain-containing protein 26', 25, NULL, NULL, 86647),
(86648, '3.80.10.10-FF-000396', NULL, 'Leucine-rich repeat-containing protein 45', 162, NULL, NULL, 86648),
(86649, '3.30.160.60-FF-001761', NULL, 'Uncharacterized protein', 28, NULL, NULL, 86649),
(86650, '2.60.40.10-FF-000693', NULL, 'IgG receptor FcRn large subunit p51', 91, NULL, NULL, 86650),
(86651, '4.10.830.10-FF-000005', NULL, 'Ribosomal protein S29A', 57, NULL, NULL, 86651),
(86652, '1.20.1000.10-FF-000030', NULL, NULL, 100, NULL, NULL, 86652),
(86653, '2.60.120.200-FF-000737', NULL, 'Uncharacterized protein AN7484', 186, NULL, NULL, 86653),
(86654, '3.50.50.60-FF-001494', NULL, 'Amino acid oxidase fmpA', 39, NULL, NULL, 86654),
(86655, '1.10.3520.10-FF-000021', NULL, 'Predicted protein', 187, NULL, NULL, 86655),
(86656, '3.40.50.12160-FF-000034', NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase', 127, NULL, NULL, 86656),
(86657, '3.30.420.40-FF-000185', NULL, 'Actin-like protein', 42, NULL, NULL, 86657),
(86658, '6.10.140.2220-FF-000018', NULL, 'Histone-lysine N-methyltransferase, putative', 51, NULL, NULL, 86658);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(86659, '3.40.50.1580-FF-000020', NULL, 'S-methyl-5''-thioadenosine phosphorylase', 274, NULL, NULL, 86659),
(86660, '3.40.50.12780-FF-000012', NULL, 'Non-ribosomal peptide synthetase', 395, NULL, NULL, 86660),
(86661, '3.30.160.60-FF-002587', NULL, 'Ras responsive element binding protein 1', 38, NULL, NULL, 86661),
(86662, '3.40.50.2020-FF-000062', NULL, 'Ribose-phosphate pyrophosphokinase, putative', 38, NULL, NULL, 86662),
(86663, '4.10.410.10-FF-000013', NULL, 'Tissue factor pathway inhibitor', 61, NULL, NULL, 86663),
(86664, '1.10.10.10-FF-001741', NULL, 'ATP-dependent DNA helicase', 142, NULL, NULL, 86664),
(86665, '2.40.50.100-FF-000070', NULL, 'Mitochondrial ribosomal protein L27,putative', 124, NULL, NULL, 86665),
(86666, '3.30.200.20-FF-000516', NULL, 'Protein kinase PK4, putative', 102, NULL, NULL, 86666),
(86667, '2.40.50.140-FF-001251', NULL, NULL, 142, NULL, NULL, 86667),
(86668, '1.25.40.10-FF-002030', NULL, 'Pentatricopeptide repeat protein', 140, NULL, NULL, 86668),
(86669, '1.25.40.20-FF-001061', NULL, 'Double zinc ribbon and ankyrin repeat domains 1', 172, NULL, NULL, 86669),
(86670, '1.25.40.10-FF-001524', NULL, 'AGAP008509-PA', 118, NULL, NULL, 86670),
(86671, '3.30.70.1560-FF-000005', NULL, 'RNA pseudouridylate synthase', 80, NULL, NULL, 86671),
(86672, '3.30.230.10-FF-000015', NULL, 'Lon protease homolog, mitochondrial', 200, NULL, NULL, 86672),
(86673, '1.10.460.10-FF-000016', NULL, 'DNA topoisomerase', 94, NULL, NULL, 86673),
(86674, '2.120.10.30-FF-000525', NULL, 'Uncharacterized protein', 155, NULL, NULL, 86674),
(86675, '2.40.70.10-FF-000134', NULL, 'YALI0D22957p', 153, NULL, NULL, 86675),
(86676, '3.30.1300.10-FF-000009', NULL, 'Pantothenate synthetase', 108, NULL, NULL, 86676),
(86677, '3.40.50.300-FF-007663', NULL, 'GPN-loop GTPase 2', 126, NULL, NULL, 86677),
(86678, '2.60.40.420-FF-000114', NULL, 'GD15660', 198, NULL, NULL, 86678),
(86679, '3.70.10.10-FF-000126', NULL, 'Uncharacterized protein', 62, NULL, NULL, 86679),
(86680, '3.30.360.10-FF-000036', NULL, 'YMR315W-like protein', 183, NULL, NULL, 86680),
(86681, '2.40.50.140-FF-000615', NULL, '30S ribosomal protein S1', 88, NULL, NULL, 86681),
(86682, '3.40.50.300-FF-000042', NULL, 'Maltose/maltodextrin ABC transporter, ATP-binding protein', 240, NULL, NULL, 86682),
(86683, '3.90.1150.10-FF-000253', NULL, 'Isopenicillin N epimerase', 99, NULL, NULL, 86683),
(86684, '1.10.10.820-FF-000013', NULL, 'Unconventional myosin-XVI', 63, NULL, NULL, 86684),
(86685, '1.25.40.180-FF-000098', NULL, 'MA3 domain containing protein', 205, NULL, NULL, 86685),
(86686, '3.40.50.720-FF-001230', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 291, NULL, NULL, 86686),
(86687, '3.60.21.10-FF-000478', NULL, 'Alkaline phosphatase', 403, NULL, NULL, 86687),
(86688, '3.40.50.1000-FF-000205', NULL, 'ATPase 2 plasma membrane-type', 147, NULL, NULL, 86688),
(86689, '3.80.10.10-FF-003493', NULL, 'Uncharacterized protein', 199, NULL, NULL, 86689),
(86690, '6.10.140.2220-FF-000035', NULL, 'SET domain-containing protein SmydA-8, isoform A', 47, NULL, NULL, 86690),
(86691, '1.25.70.10-FF-000071', NULL, NULL, 114, NULL, NULL, 86691),
(86692, '3.30.60.20-FF-000078', NULL, 'Protein CBG14248', 78, NULL, NULL, 86692),
(86693, '1.25.40.20-FF-000133', NULL, 'protein fem-1 homolog A', 179, NULL, NULL, 86693),
(86694, '3.30.519.10-FF-000017', NULL, 'Guanosine nucleotide diphosphate dissociation inhibitor', 101, NULL, NULL, 86694),
(86695, '2.10.25.10-FF-000750', NULL, 'Putative adhesion G protein-coupled receptor E4P', 35, NULL, NULL, 86695),
(86696, '1.25.40.20-FF-000572', NULL, '85/88 kDa calcium-independent phospholipase A2', 78, NULL, NULL, 86696),
(86697, '1.25.40.990-FF-000026', NULL, 'SAC3/GANP family protein, putative', 236, NULL, NULL, 86697),
(86698, '3.40.50.2300-FF-001332', NULL, NULL, 76, NULL, NULL, 86698),
(86699, '1.10.150.130-FF-000015', NULL, 'Site-specific recombinase, phage integrase family', 102, NULL, NULL, 86699),
(86700, '2.40.50.140-FF-000306', NULL, 'Nucleic acid binding protein, putative', 133, NULL, NULL, 86700);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(86701, '1.25.10.10-FF-001713', NULL, 'Hsp70 nucleotide exchange factor FES1', 235, NULL, NULL, 86701),
(86702, '1.10.150.50-FF-000241', NULL, 'Uncharacterized protein', 61, NULL, NULL, 86702),
(86703, '3.40.50.1820-FF-001418', NULL, 'Uncharacterized protein', 201, NULL, NULL, 86703),
(86704, '1.20.120.550-FF-000026', NULL, 'Uncharacterized protein', 92, NULL, NULL, 86704),
(86705, '2.60.120.10-FF-000656', NULL, 'Uncharacterized protein', 131, NULL, NULL, 86705),
(86706, '3.80.10.10-FF-004139', NULL, 'Uncharacterized protein', 109, NULL, NULL, 86706),
(86707, '1.10.1580.10-FF-000013', NULL, 'Chromosome 1, whole genome shotgun sequence', 100, NULL, NULL, 86707),
(86708, '3.50.50.60-FF-001347', NULL, 'Uncharacterized protein', 313, NULL, NULL, 86708),
(86709, '1.20.1070.10-FF-000096', NULL, 'Odorant receptor 131-2', 289, NULL, NULL, 86709),
(86710, '3.30.420.150-FF-000009', NULL, 'Guanosine-diphosphatase, putative', 280, NULL, NULL, 86710),
(86711, '3.40.390.10-FF-000002', NULL, 'Disintegrin and metalloproteinase domain-containing protein 22', 206, NULL, NULL, 86711),
(86712, '1.25.40.20-FF-000442', NULL, 'Calmodulin-binding transcription activator 2', 137, NULL, NULL, 86712),
(86713, '1.25.40.10-FF-000905', NULL, 'Outer envelope protein 61', 143, NULL, NULL, 86713),
(86714, '3.40.50.720-FF-001893', NULL, 'Pyrroline-5-carboxylate reductase', 137, NULL, NULL, 86714),
(86715, '1.20.1250.20-FF-000388', NULL, 'MFS sugar transporter, putative', 250, NULL, NULL, 86715),
(86716, '3.20.20.80-FF-000167', NULL, 'Heparanase', 89, NULL, NULL, 86716),
(86717, '3.90.320.10-FF-000020', NULL, 'DNA replication helicase/nuclease 2', 280, NULL, NULL, 86717),
(86718, '1.20.58.400-FF-000038', NULL, 'Predicted protein', 90, NULL, NULL, 86718),
(86719, '3.40.50.2000-FF-000859', NULL, 'Chromosome 23, whole genome shotgun sequence', 207, NULL, NULL, 86719),
(86720, '3.30.500.10-FF-000008', NULL, 'Endothelial protein C receptor', 193, NULL, NULL, 86720),
(86721, '3.30.40.10-FF-000658', NULL, 'E3 ubiquitin-protein ligase APD2', 60, NULL, NULL, 86721),
(86722, '2.130.10.10-FF-005196', NULL, 'Coronin', 105, NULL, NULL, 86722),
(86723, '1.10.3500.10-FF-000019', NULL, 'Transcription elongation factor spt6', 294, NULL, NULL, 86723),
(86724, '2.30.42.10-FF-000215', NULL, 'uncharacterized protein KIAA1614 homolog', 98, NULL, NULL, 86724),
(86725, '3.20.20.100-FF-000132', NULL, 'Predicted protein', 260, NULL, NULL, 86725),
(86726, '1.10.510.10-FF-003303', NULL, NULL, 81, NULL, NULL, 86726),
(86727, '3.90.290.10-FF-000022', NULL, 'Latent transforming growth factor beta binding protein 3', 68, NULL, NULL, 86727),
(86728, '1.25.40.10-FF-004930', NULL, 'Uncharacterized protein', 209, NULL, NULL, 86728),
(86729, '3.40.50.300-FF-000379', NULL, 'RNA helicase', 231, NULL, NULL, 86729),
(86730, '3.40.630.10-FF-000055', NULL, 'Cytosolic carboxypeptidase-like protein 5 isoform X1', 216, NULL, NULL, 86730),
(86731, '3.30.200.20-FF-001461', NULL, 'Tyrosine-protein kinase', 102, NULL, NULL, 86731),
(86732, '1.20.120.530-FF-000020', NULL, 'Probable D-xylose utilization operon transcriptional repressor', 134, NULL, NULL, 86732),
(86733, '3.40.920.10-FF-000026', NULL, NULL, 167, NULL, NULL, 86733),
(86734, '3.10.20.70-FF-000024', NULL, 'Uncharacterized protein', 111, NULL, NULL, 86734),
(86735, '1.20.1250.20-FF-002288', NULL, 'Uncharacterized protein', 74, NULL, NULL, 86735),
(86736, '2.60.260.20-FF-000040', NULL, 'DnaJ-class molecular chaperone', 61, NULL, NULL, 86736),
(86737, '2.170.270.10-FF-000123', NULL, 'PR domain-containing 1b, with ZNF domain', 84, NULL, NULL, 86737),
(86738, '1.10.10.10-FF-000235', NULL, 'AsnC family transcriptional regulator', 57, NULL, NULL, 86738),
(86739, '2.60.120.10-FF-000509', NULL, 'Predicted protein', 166, NULL, NULL, 86739),
(86740, '1.20.1270.280-FF-000013', NULL, 'Dynein, axonemal, heavy chain 14', 194, NULL, NULL, 86740),
(86741, '1.10.510.10-FF-003697', NULL, NULL, 165, NULL, NULL, 86741),
(86742, '3.30.40.10-FF-001147', NULL, 'GM24368', 118, NULL, NULL, 86742),
(86743, '1.20.1070.10-FF-000657', NULL, 'Uncharacterized protein', 299, NULL, NULL, 86743);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(86744, '2.30.30.30-FF-000104', NULL, 'Uncharacterized protein', 85, NULL, NULL, 86744),
(86745, '2.130.10.10-FF-000328', NULL, 'Bromodomain and WD repeat domain containing 3', 96, NULL, NULL, 86745),
(86746, '3.40.50.150-FF-000406', NULL, 'tRNA (Adenine-N(1)-)-methyltransferase', 255, NULL, NULL, 86746),
(86747, '1.10.287.40-FF-000032', NULL, 'Predicted protein', 106, NULL, NULL, 86747),
(86748, '1.20.140.150-FF-000011', NULL, 'lens fiber membrane intrinsic protein-like', 165, NULL, NULL, 86748),
(86749, '1.25.40.10-FF-002160', NULL, 'Uncharacterized protein', 68, NULL, NULL, 86749),
(86750, '1.20.140.80-FF-000011', NULL, 'Uncharacterized protein', 98, NULL, NULL, 86750),
(86751, '2.60.40.150-FF-000157', NULL, 'Phosphoinositide phospholipase C', 149, NULL, NULL, 86751),
(86752, '2.130.10.10-FF-002014', NULL, 'Putative pre-rrna-processing protein ipi3', 149, NULL, NULL, 86752),
(86753, '3.30.70.3030-FF-000019', NULL, 'Nucleolar protein 6', 128, NULL, NULL, 86753),
(86754, '1.25.40.190-FF-000016', NULL, NULL, 151, NULL, NULL, 86754),
(86755, '1.10.167.10-FF-000037', NULL, 'G protein-coupled receptor kinase', 36, NULL, NULL, 86755),
(86756, '1.10.10.60-FF-000317', NULL, 'homeobox protein abdominal-A', 94, NULL, NULL, 86756),
(86757, '3.30.200.20-FF-001152', NULL, 'Uncharacterized protein', 123, NULL, NULL, 86757),
(86758, '2.70.40.10-FF-000035', NULL, 'Probable dUTP pyrophosphatase', 149, NULL, NULL, 86758),
(86759, '2.30.30.490-FF-000016', NULL, 'RSC complex member', 248, NULL, NULL, 86759),
(86760, '2.170.260.10-FF-000016', NULL, 'RNA interference and gene silencing protein (Qde2), putative (AFU_orthologue AFUA_8G05280)', 158, NULL, NULL, 86760),
(86761, '3.90.1410.10-FF-000060', NULL, 'Protein N-methyltransferase', 269, NULL, NULL, 86761),
(86762, '2.130.10.10-FF-002453', NULL, 'Transducin beta like 3', 192, NULL, NULL, 86762),
(86763, '3.10.129.10-FF-000104', NULL, 'Thioesterase family protein (AFU_orthologue AFUA_2G16350)', 160, NULL, NULL, 86763),
(86764, '3.30.930.10-FF-000237', NULL, 'Uncharacterized protein', 167, NULL, NULL, 86764),
(86765, '1.10.10.10-FF-000443', NULL, 'Transcriptional regulator, MarR family', 139, NULL, NULL, 86765),
(86766, '2.60.120.40-FF-000041', NULL, 'CD40 ligand', 132, NULL, NULL, 86766),
(86767, '3.40.30.10-FF-000854', NULL, 'Protein disulfide-isomerase', 97, NULL, NULL, 86767),
(86768, '1.25.40.10-FF-001732', NULL, 'Os11g0587100 protein', 107, NULL, NULL, 86768),
(86769, '2.130.10.10-FF-003543', NULL, 'QUInine non-avoider', 101, NULL, NULL, 86769),
(86770, '3.30.60.30-FF-000070', NULL, 'C3 and PZP-like alpha-2-macroglobulin domain-containing protein 8', 55, NULL, NULL, 86770),
(86771, '3.30.2410.10-FF-000017', NULL, 'E3 ubiquitin-protein ligase UPL7', 114, NULL, NULL, 86771),
(86772, '1.10.510.10-FF-000824', NULL, 'TBC domain-containing protein kinase-like protein isoform X3', 126, NULL, NULL, 86772),
(86773, '1.25.40.10-FF-002822', NULL, 'RNA polymerase III transcription factor TFIIIC subunit (Tfc4), putative (AFU_orthologue AFUA_1G04980)', 150, NULL, NULL, 86773),
(86774, '3.90.190.10-FF-000560', NULL, 'Predicted protein', 95, NULL, NULL, 86774),
(86775, '1.10.10.10-FF-001533', NULL, 'SARP family transcriptional regulator', 92, NULL, NULL, 86775),
(86776, '2.100.10.50-FF-000004', NULL, 'Ubiquitin-specific protease, putative', 135, NULL, NULL, 86776),
(86777, '1.10.510.10-FF-001858', NULL, 'Tyrosine-protein kinase', 205, NULL, NULL, 86777),
(86778, '3.90.550.20-FF-000006', NULL, 'Alpha-1,6-mannosyltransferase', 321, NULL, NULL, 86778),
(86779, '3.40.50.300-FF-005977', NULL, 'CRISPR-associated helicase/endonuclease Cas3', 213, NULL, NULL, 86779),
(86780, '1.10.220.150-FF-000010', NULL, 'Stromal membrane-associated protein', 128, NULL, NULL, 86780),
(86781, '2.40.100.10-FF-000171', NULL, 'Uncharacterized protein', 47, NULL, NULL, 86781),
(86782, '3.30.1360.40-FF-000016', NULL, 'Ribosome-recycling factor', 74, NULL, NULL, 86782),
(86783, '3.10.20.90-FF-000035', NULL, 'Fermitin family homolog 2 (Drosophila)', 98, NULL, NULL, 86783),
(86784, '1.10.630.10-FF-000288', NULL, 'Uncharacterized protein', 154, NULL, NULL, 86784);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(86785, '1.10.287.110-FF-000233', NULL, 'Uncharacterized protein', 100, NULL, NULL, 86785),
(86786, '3.20.20.70-FF-000855', NULL, NULL, 62, NULL, NULL, 86786),
(86787, '1.20.1310.10-FF-000002', NULL, 'cullin-3 isoform X1', 113, NULL, NULL, 86787),
(86788, '2.130.10.10-FF-001289', NULL, 'RNA polymerase II Elongator subunit', 256, NULL, NULL, 86788),
(86789, '3.40.30.10-FF-000270', NULL, 'Glutathione peroxidase', 163, NULL, NULL, 86789),
(86790, '3.40.630.30-FF-000066', NULL, 'Histone acetyltransferase', 147, NULL, NULL, 86790),
(86791, '1.10.3290.10-FF-000002', NULL, 'Protein adenylyltransferase NmFic', 179, NULL, NULL, 86791),
(86792, '1.20.120.1760-FF-000059', NULL, NULL, 194, NULL, NULL, 86792),
(86793, '3.40.50.150-FF-001289', NULL, NULL, 306, NULL, NULL, 86793),
(86794, '3.70.10.10-FF-000048', NULL, 'DNA polymerase III beta subunit', 191, NULL, NULL, 86794),
(86795, '3.30.460.10-FF-000072', NULL, 'DNA polymerase', 119, NULL, NULL, 86795),
(86796, '3.30.565.10-FF-000315', NULL, 'Sensor histidine kinase', 152, NULL, NULL, 86796),
(86797, '1.20.5.420-FF-000016', NULL, 'Dot/Icm secretion system protein IcmQ', 57, NULL, NULL, 86797),
(86798, '3.40.50.720-FF-001258', NULL, 'CIP1 protein, putative', 169, NULL, NULL, 86798),
(86799, '1.10.510.10-FF-004523', NULL, NULL, 86, NULL, NULL, 86799),
(86800, '2.60.40.10-FF-003891', NULL, NULL, 102, NULL, NULL, 86800),
(86801, '3.40.50.410-FF-000283', NULL, 'Uncharacterized protein', 30, NULL, NULL, 86801),
(86802, '2.60.120.260-FF-000620', NULL, 'Predicted protein', 132, NULL, NULL, 86802),
(86803, '3.30.160.60-FF-000350', NULL, 'Zinc finger protein 699', 28, NULL, NULL, 86803),
(86804, '1.10.10.10-FF-000544', NULL, 'LysR family transcriptional regulator', 88, NULL, NULL, 86804),
(86805, '1.25.40.10-FF-004958', NULL, 'Uncharacterized protein', 162, NULL, NULL, 86805),
(86806, '1.20.1560.10-FF-000633', NULL, 'Predicted protein', 219, NULL, NULL, 86806),
(86807, '1.10.510.10-FF-000780', NULL, 'Receptor-like serine/threonine-protein kinase At4g25390', 151, NULL, NULL, 86807),
(86808, '3.40.710.10-FF-000117', NULL, 'Penicillin-binding protein, putative', 305, NULL, NULL, 86808),
(86809, '1.20.58.390-FF-000113', NULL, 'Ionotropic GABA receptor subunit UNC-49Cshort', 144, NULL, NULL, 86809),
(86810, '3.40.50.300-FF-008147', NULL, 'Uncharacterized protein', 95, NULL, NULL, 86810),
(86811, '1.25.10.10-FF-002202', NULL, 'Uncharacterized protein', 438, NULL, NULL, 86811),
(86812, '3.30.70.80-FF-000006', NULL, 'Autophagic serine protease Alp2', 96, NULL, NULL, 86812),
(86813, '3.40.50.1110-FF-000137', NULL, 'Predicted protein', 208, NULL, NULL, 86813),
(86814, '2.60.40.1510-FF-000012', NULL, 'Integrin subunit alpha 3', 136, NULL, NULL, 86814),
(86815, '3.40.50.720-FF-002511', NULL, 'Bone marrow stromal cell antigen 1', 125, NULL, NULL, 86815),
(86816, '1.50.40.10-FF-000049', NULL, 'Solute carrier family 25 member 45', 286, NULL, NULL, 86816),
(86817, '3.30.200.20-FF-000533', NULL, 'probable protein kinase At2g41970', 104, NULL, NULL, 86817),
(86818, '3.40.50.2300-FF-001124', NULL, NULL, 125, NULL, NULL, 86818),
(86819, '3.90.1480.20-FF-000011', NULL, 'ST6 N-acetylgalactosaminide alpha-2,6-sialyltransferase 5', 241, NULL, NULL, 86819),
(86820, '3.30.160.20-FF-000237', NULL, 'Ribosomal protein S2', 67, NULL, NULL, 86820),
(86821, '3.30.530.20-FF-000148', NULL, 'Uncharacterized protein', 187, NULL, NULL, 86821),
(86822, '1.10.510.10-FF-002477', NULL, 'Uncharacterized protein', 267, NULL, NULL, 86822),
(86823, '2.120.10.30-FF-000508', NULL, 'Peptidyl-glycine alpha-amidating monooxygenase, putative', 204, NULL, NULL, 86823),
(86824, '3.40.50.2300-FF-000034', NULL, 'DNA-binding response OmpR family regulator', 83, NULL, NULL, 86824),
(86825, '3.40.50.300-FF-003829', NULL, 'Ras-related GTP-binding protein', 177, NULL, NULL, 86825),
(86826, '1.20.1280.180-FF-000002', NULL, 'Carnitine palmitoyltransferase 2', 42, NULL, NULL, 86826),
(86827, '1.25.40.10-FF-004267', NULL, 'Uncharacterized protein', 216, NULL, NULL, 86827),
(86828, '2.60.40.10-FF-004083', NULL, NULL, 95, NULL, NULL, 86828);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(86829, '1.10.510.10-FF-003567', NULL, NULL, 222, NULL, NULL, 86829),
(86830, '1.10.3720.10-FF-000002', NULL, 'D-methionine ABC transporter permease MetI', 212, NULL, NULL, 86830),
(86831, '1.10.238.10-FF-000219', NULL, 'EF-hand calcium-binding domain-containing protein 4A', 66, NULL, NULL, 86831),
(86832, '1.10.10.10-FF-000105', NULL, 'HTH-type transcriptional repressor NsrR', 134, NULL, NULL, 86832),
(86833, '3.30.40.10-FF-001838', NULL, 'Protein CBG12045', 85, NULL, NULL, 86833),
(86834, '1.10.287.130-FF-000239', NULL, 'Two component signal transduction system histidine kinase with CHASE and PAS sensory domains', 87, NULL, NULL, 86834),
(86835, '4.10.60.10-FF-000080', NULL, 'RNA helicase, putative', 52, NULL, NULL, 86835),
(86836, '3.30.70.1220-FF-000004', NULL, 'RNA polymerase II transcription factor B subunit 5', 62, NULL, NULL, 86836),
(86837, '3.30.60.30-FF-000227', NULL, 'Uncharacterized protein', 54, NULL, NULL, 86837),
(86838, '3.90.550.10-FF-000543', NULL, 'Uncharacterized protein', 76, NULL, NULL, 86838),
(86839, '3.40.50.300-FF-008248', NULL, 'Uncharacterized protein', 53, NULL, NULL, 86839),
(86840, '1.10.287.470-FF-000083', NULL, 'HlyD family secretion protein', 102, NULL, NULL, 86840),
(86841, '3.30.160.60-FF-005993', NULL, NULL, 46, NULL, NULL, 86841),
(86842, '1.20.120.1900-FF-000028', NULL, 'Spindle pole body component', 315, NULL, NULL, 86842),
(86843, '3.40.50.300-FF-004549', NULL, 'Atlastin GTPase 3', 165, NULL, NULL, 86843),
(86844, '1.20.58.60-FF-000595', NULL, 'Plectin', 190, NULL, NULL, 86844),
(86845, '3.80.10.10-FF-003521', NULL, 'Tehao', 173, NULL, NULL, 86845),
(86846, '1.20.58.70-FF-000025', NULL, 'Syntaxin-12', 124, NULL, NULL, 86846),
(86847, '3.40.140.10-FF-000208', NULL, 'Myb-like protein H', 258, NULL, NULL, 86847),
(86848, '1.10.1600.10-FF-000038', NULL, 'Uncharacterized protein', 52, NULL, NULL, 86848),
(86849, '3.30.70.330-FF-001400', NULL, 'Polyadenylate-binding protein', 82, NULL, NULL, 86849),
(86850, '3.100.10.10-FF-000022', NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', 91, NULL, NULL, 86850),
(86851, '2.10.25.10-FF-001576', NULL, 'Uncharacterized protein', 43, NULL, NULL, 86851),
(86852, '1.10.8.60-FF-000338', NULL, 'Cell division cycle protein', 95, NULL, NULL, 86852),
(86853, '1.20.1070.10-FF-001130', NULL, 'Uncharacterized protein', 302, NULL, NULL, 86853),
(86854, '2.40.160.50-FF-000034', NULL, 'YALI0C06974p', 335, NULL, NULL, 86854),
(86855, '3.40.140.10-FF-000051', NULL, 'Nucleoside deaminase', 156, NULL, NULL, 86855),
(86856, '3.40.50.2000-FF-000298', NULL, 'Protein CBR-BUS-8', 187, NULL, NULL, 86856),
(86857, '2.40.10.10-FF-000703', NULL, NULL, 115, NULL, NULL, 86857),
(86858, '3.40.720.10-FF-000146', NULL, 'N-acetyl-galactosamine-6-sulfatase (GALNS)', 378, NULL, NULL, 86858),
(86859, '3.40.50.150-FF-001025', NULL, NULL, 180, NULL, NULL, 86859),
(86860, '3.40.47.10-FF-000038', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 2', 419, NULL, NULL, 86860),
(86861, '3.30.470.160-FF-000011', NULL, 'Kinase', 251, NULL, NULL, 86861),
(86862, '2.60.120.310-FF-000006', NULL, 'Monooxygenase, DBH-like 2, pseudogene', 154, NULL, NULL, 86862),
(86863, '1.20.144.10-FF-000050', NULL, 'Lipid phosphate phosphatase, putative', 109, NULL, NULL, 86863),
(86864, '1.25.10.10-FF-001904', NULL, 'Armadillo repeat-containing protein 8', 222, NULL, NULL, 86864),
(86865, '1.20.120.350-FF-000129', NULL, 'Uncharacterized protein', 126, NULL, NULL, 86865),
(86866, '2.130.10.10-FF-002823', NULL, 'YALI0D12705p', 124, NULL, NULL, 86866),
(86867, '3.40.50.300-FF-000704', NULL, 'fe-S cluster assembly factor HCF101, chloroplastic', 258, NULL, NULL, 86867),
(86868, '3.30.70.870-FF-000016', NULL, 'Translation elongation factor G', 77, NULL, NULL, 86868),
(86869, '3.20.130.10-FF-000004', NULL, 'Fumarate hydratase class I', 187, NULL, NULL, 86869),
(86870, '1.10.10.1760-FF-000008', NULL, '60S ribosomal protein L36', 103, NULL, NULL, 86870),
(86871, '1.10.287.1490-FF-000148', NULL, 'Uncharacterized protein', 169, NULL, NULL, 86871),
(86872, '3.20.20.150-FF-000023', NULL, 'Protein arginine N-methyltransferase', 299, NULL, NULL, 86872);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(86873, '3.40.50.1100-FF-000039', NULL, 'Threonine synthase, chloroplastic', 220, NULL, NULL, 86873),
(86874, '3.30.70.920-FF-000054', NULL, 'Transcriptional regulator, AsnC family', 94, NULL, NULL, 86874),
(86875, '1.25.10.10-FF-001584', NULL, 'Uncharacterized protein', 115, NULL, NULL, 86875),
(86876, '3.30.505.10-FF-000194', NULL, NULL, 102, NULL, NULL, 86876),
(86877, '3.50.50.60-FF-000667', NULL, 'Uncharacterized protein', 221, NULL, NULL, 86877),
(86878, '3.30.565.10-FF-000101', NULL, 'Two-component sensor histidine kinase', 156, NULL, NULL, 86878),
(86879, '3.30.519.10-FF-000034', NULL, NULL, 176, NULL, NULL, 86879),
(86880, '1.20.1330.10-FF-000015', NULL, 'Flagellin', 130, NULL, NULL, 86880),
(86881, '3.30.420.40-FF-000505', NULL, 'Actin-related protein 3, putative arp3', 118, NULL, NULL, 86881),
(86882, '3.30.420.40-FF-000393', NULL, 'Pantothenate kinase', 153, NULL, NULL, 86882),
(86883, '3.40.50.150-FF-000637', NULL, 'rRNA adenine N(6)-methyltransferase', 232, NULL, NULL, 86883),
(86884, '3.30.1140.40-FF-000005', NULL, 'Topoisomerase I damage affected protein 2', 102, NULL, NULL, 86884),
(86885, '2.130.10.10-FF-001609', NULL, 'Chromatin assembly factor 1 subunit B', 201, NULL, NULL, 86885),
(86886, '1.10.630.10-FF-000608', NULL, 'Os10g0511200 protein', 259, NULL, NULL, 86886),
(86887, '1.10.510.10-FF-002578', NULL, 'Receptor protein serine/threonine kinase', 234, NULL, NULL, 86887),
(86888, '3.40.50.2000-FF-001040', NULL, 'Uncharacterized protein', 162, NULL, NULL, 86888),
(86889, '2.60.200.10-FF-000027', NULL, 'IRF6 isoform 3', 62, NULL, NULL, 86889),
(86890, '3.20.20.220-FF-000067', NULL, 'Proline dehydrogenase', 119, NULL, NULL, 86890),
(86891, '2.130.10.10-FF-001497', NULL, 'Chromatin assembly factor 1, p105 subunit', 109, NULL, NULL, 86891),
(86892, '3.40.50.300-FF-006691', NULL, 'Uncharacterized protein', 80, NULL, NULL, 86892),
(86893, '3.40.50.720-FF-002202', NULL, 'Carnitine acetyl transferase (AFU_orthologue AFUA_2G12530)', 309, NULL, NULL, 86893),
(86894, '3.40.50.1980-FF-000033', NULL, 'Nitrogenase MoFe cofactor biosynthesis protein NifE', 151, NULL, NULL, 86894),
(86895, '3.40.50.300-FF-004196', NULL, 'Predicted protein', 85, NULL, NULL, 86895),
(86896, '3.30.160.60-FF-004307', NULL, NULL, 57, NULL, NULL, 86896),
(86897, '2.60.40.60-FF-000567', NULL, 'Uncharacterized protein', 109, NULL, NULL, 86897),
(86898, '3.90.226.10-FF-000054', NULL, 'probable enoyl-CoA hydratase 1, peroxisomal', 232, NULL, NULL, 86898),
(86899, '2.130.10.10-FF-002115', NULL, 'Transducin beta-like protein 3', 172, NULL, NULL, 86899),
(86900, '3.80.10.10-FF-000648', NULL, 'F-box/LRR-repeat protein 15', 86, NULL, NULL, 86900),
(86901, '1.10.246.10-FF-000002', NULL, 'Serum albumin', 82, NULL, NULL, 86901),
(86902, '3.30.1490.100-FF-000018', NULL, 'DNA polymerase IV', 102, NULL, NULL, 86902),
(86903, '2.60.120.200-FF-000428', NULL, 'Uncharacterized protein', 226, NULL, NULL, 86903),
(86904, '3.40.50.12390-FF-000002', NULL, '5''-3'' exoribonuclease 1', 199, NULL, NULL, 86904),
(86905, '4.10.240.10-FF-000084', NULL, 'Uncharacterized transcriptional regulatory protein C1327.01c', 63, NULL, NULL, 86905),
(86906, '1.10.630.10-FF-000187', NULL, 'Uncharacterized protein', 280, NULL, NULL, 86906),
(86907, '1.10.238.10-FF-000427', NULL, 'Probable calcium-binding protein CML27', 68, NULL, NULL, 86907),
(86908, '1.10.620.20-FF-000010', NULL, 'Ribonucleotide reductase subunit', 334, NULL, NULL, 86908),
(86909, '3.30.1120.10-FF-000046', NULL, 'N-acetylgalactosamine-6-sulfatase (GALNS)', 63, NULL, NULL, 86909),
(86910, '2.30.42.10-FF-000007', NULL, 'Amyloid beta A4 protein-binding family A member', 88, NULL, NULL, 86910),
(86911, '1.25.40.10-FF-003441', NULL, 'Pentatricopeptide repeat-containing protein', 156, NULL, NULL, 86911),
(86912, '1.20.1250.10-FF-000059', NULL, 'Growth hormone d13', 205, NULL, NULL, 86912),
(86913, '2.20.25.10-FF-000007', NULL, 'Transcription initiation factor IIB', 58, NULL, NULL, 86913),
(86914, '1.10.10.60-FF-001278', NULL, NULL, 70, NULL, NULL, 86914),
(86915, '1.10.630.10-FF-000496', NULL, 'Uncharacterized protein', 493, NULL, NULL, 86915);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(86916, '1.20.1310.10-FF-000210', NULL, NULL, 84, NULL, NULL, 86916),
(86917, '3.40.1190.10-FF-000031', NULL, 'Folylpolyglutamate synthase', 311, NULL, NULL, 86917),
(86918, '3.40.50.300-FF-007528', NULL, 'Uncharacterized protein', 208, NULL, NULL, 86918),
(86919, '1.10.510.10-FF-004422', NULL, NULL, 288, NULL, NULL, 86919),
(86920, '3.40.190.10-FF-000363', NULL, 'Oligopeptide ABC transporter (Binding lipoprotein)', 136, NULL, NULL, 86920),
(86921, '3.30.420.40-FF-000977', NULL, 'Heat shock protein 70 putative', 131, NULL, NULL, 86921),
(86922, '2.30.29.30-FF-000831', NULL, 'DCC-interacting protein 13-alpha-like', 118, NULL, NULL, 86922),
(86923, '1.20.5.190-FF-000155', NULL, NULL, 48, NULL, NULL, 86923),
(86924, '1.10.472.170-FF-000027', NULL, 'Uncharacterized protein', 146, NULL, NULL, 86924),
(86925, '3.30.160.20-FF-000136', NULL, 'Staufen 1', 96, NULL, NULL, 86925),
(86926, '3.40.50.1000-FF-000644', NULL, NULL, 202, NULL, NULL, 86926),
(86927, '1.20.1560.10-FF-000841', NULL, 'Uncharacterized protein', 504, NULL, NULL, 86927),
(86928, '3.80.10.10-FF-001576', NULL, 'Leucine rich repeat and phosphatase domain containing protein', 182, NULL, NULL, 86928),
(86929, '3.30.420.40-FF-001011', NULL, 'Actin-related protein 8', 56, NULL, NULL, 86929),
(86930, '1.25.40.20-FF-000364', NULL, 'AF4/FMR2 family member 4 isoform X4', 156, NULL, NULL, 86930),
(86931, '2.130.10.10-FF-004268', NULL, 'Uncharacterized protein', 131, NULL, NULL, 86931),
(86932, '2.30.30.420-FF-000001', NULL, 'Inactive glucansucrase', 76, NULL, NULL, 86932),
(86933, '3.30.497.10-FF-000010', NULL, 'glia-derived nexin isoform X1', 180, NULL, NULL, 86933),
(86934, '3.80.10.10-FF-000957', NULL, 'Leucine rich repeat-containing protein', 127, NULL, NULL, 86934),
(86935, '3.30.1680.10-FF-000065', NULL, 'Integrin beta', 55, NULL, NULL, 86935),
(86936, '3.40.50.300-FF-006702', NULL, 'Uncharacterized protein', 78, NULL, NULL, 86936),
(86937, '3.30.950.10-FF-000019', NULL, 'Trifunctional enzyme subunit', 137, NULL, NULL, 86937),
(86938, '3.30.160.60-FF-003104', NULL, 'Protein CBG08513', 59, NULL, NULL, 86938),
(86939, '1.10.472.10-FF-000151', NULL, 'Cyclin-H, putative', 111, NULL, NULL, 86939),
(86940, '2.30.30.40-FF-000303', NULL, 'ZO-1 (Zonula Occludens tight junctional protein) Ortholog', 113, NULL, NULL, 86940),
(86941, '1.10.510.10-FF-002269', NULL, NULL, 228, NULL, NULL, 86941),
(86942, '3.30.40.10-FF-002002', NULL, 'Uncharacterized protein', 52, NULL, NULL, 86942),
(86943, '2.60.40.150-FF-000612', NULL, 'Uncharacterized protein', 151, NULL, NULL, 86943),
(86944, '1.20.810.10-FF-000019', NULL, 'Uncharacterized protein', 74, NULL, NULL, 86944),
(86945, '3.80.10.10-FF-001121', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 148, NULL, NULL, 86945),
(86946, '3.40.50.300-FF-001323', NULL, 'Dynein heavy chain, putative', 210, NULL, NULL, 86946),
(86947, '4.10.640.10-FF-000030', NULL, 'Mitochondrial 37S ribosomal protein RSM18', 86, NULL, NULL, 86947),
(86948, '3.30.160.60-FF-001070', NULL, 'zinc finger protein 133 isoform X1', 27, NULL, NULL, 86948),
(86949, '2.70.70.10-FF-000071', NULL, 'Morphogenesis protein 1', 168, NULL, NULL, 86949),
(86950, '3.40.525.10-FF-000024', NULL, 'Sec14p-like phosphatidylinositol transfer family protein', 277, NULL, NULL, 86950),
(86951, '3.30.540.30-FF-000011', NULL, 'Nudix hydrolase 3', 151, NULL, NULL, 86951),
(86952, '3.30.1490.70-FF-000012', NULL, 'Multifunctional non-homologous end joining protein LigD', 53, NULL, NULL, 86952),
(86953, '2.60.40.10-FF-005925', NULL, NULL, 106, NULL, NULL, 86953),
(86954, '2.40.30.240-FF-000001', NULL, 'Coat protein', 127, NULL, NULL, 86954),
(86955, '3.80.10.10-FF-002902', NULL, 'Predicted protein', 145, NULL, NULL, 86955),
(86956, '3.30.710.10-FF-000142', NULL, 'Regulatory protein ral2, variant', 160, NULL, NULL, 86956),
(86957, '2.130.10.10-FF-003751', NULL, 'Predicted protein', 328, NULL, NULL, 86957),
(86958, '3.90.370.10-FF-000006', NULL, 'TIMP metallopeptidase inhibitor 4, tandem duplicate 2', 74, NULL, NULL, 86958),
(86959, '3.40.50.300-FF-004757', NULL, 'Uncharacterized protein', 77, NULL, NULL, 86959);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(86960, '1.20.1070.10-FF-000888', NULL, 'Parathyroid hormone 2 receptor', 159, NULL, NULL, 86960),
(86961, '1.20.58.1930-FF-000001', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 231, NULL, NULL, 86961),
(86962, '3.30.9.30-FF-000002', NULL, 'Salicylate hydroxylase, putative (AFU_orthologue AFUA_7G00590)', 196, NULL, NULL, 86962),
(86963, '1.10.3720.10-FF-000210', NULL, 'Oligopeptide transport system permease protein', 214, NULL, NULL, 86963),
(86964, '1.25.40.10-FF-003986', NULL, 'Predicted protein', 216, NULL, NULL, 86964),
(86965, '2.60.40.10-FF-002149', NULL, 'Pili assembly chaperone, N-terminal', 90, NULL, NULL, 86965),
(86966, '3.10.20.30-FF-000023', NULL, '3-ketosteroid-9-alpha-hydroxylase reductase subunit', 107, NULL, NULL, 86966),
(86967, '3.40.47.10-FF-000246', NULL, NULL, 243, NULL, NULL, 86967),
(86968, '2.10.70.10-FF-000293', NULL, 'Uncharacterized protein', 52, NULL, NULL, 86968),
(86969, '3.20.20.140-FF-000374', NULL, 'Adenosine deaminase-like', 213, NULL, NULL, 86969),
(86970, '3.40.50.1360-FF-000055', NULL, '6-phosphogluconolactonase', 162, NULL, NULL, 86970),
(86971, '3.50.50.60-FF-000875', NULL, 'Monooxygenase 2', 378, NULL, NULL, 86971),
(86972, '3.30.420.40-FF-000713', NULL, 'Uncharacterized protein', 53, NULL, NULL, 86972),
(86973, '1.20.1280.50-FF-000112', NULL, 'F-box protein PP2-B1', 103, NULL, NULL, 86973),
(86974, '1.10.220.20-FF-000007', NULL, 'GDP/GTP exchange factor', 79, NULL, NULL, 86974),
(86975, '2.130.10.10-FF-003442', NULL, 'AaceriADR216Wp', 414, NULL, NULL, 86975),
(86976, '2.70.98.40-FF-000008', NULL, 'Trehalose-6-phosphate phosphatase OtsB1', 267, NULL, NULL, 86976),
(86977, '1.10.8.1310-FF-000020', NULL, 'TBC domain containing protein', 115, NULL, NULL, 86977),
(86978, '2.60.120.330-FF-000208', NULL, 'Uncharacterized protein', 124, NULL, NULL, 86978),
(86979, '1.25.40.10-FF-000804', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 95, NULL, NULL, 86979),
(86980, '3.90.80.10-FF-000012', NULL, 'Acidocalcisomal pyrophosphatase', 262, NULL, NULL, 86980),
(86981, '3.40.50.1000-FF-000543', NULL, NULL, 91, NULL, NULL, 86981),
(86982, '3.30.1370.10-FF-000154', NULL, 'RNA-binding KH domain-containing protein', 73, NULL, NULL, 86982),
(86983, '1.10.10.60-FF-000761', NULL, NULL, 59, NULL, NULL, 86983),
(86984, '2.70.150.10-FF-000200', NULL, 'Phospholipid-transporting ATPase', 83, NULL, NULL, 86984),
(86985, '1.20.1050.10-FF-000302', NULL, 'Predicted protein', 45, NULL, NULL, 86985),
(86986, '3.90.79.10-FF-000284', NULL, 'Uncharacterized protein', 63, NULL, NULL, 86986),
(86987, '3.40.50.300-FF-002088', NULL, 'Putative AAA family ATPase', 194, NULL, NULL, 86987),
(86988, '2.60.40.10-FF-003110', NULL, 'Transcription factor unc-3', 107, NULL, NULL, 86988),
(86989, '2.40.50.140-FF-000407', NULL, 'rRNA biogenesis protein RRP5, putative', 88, NULL, NULL, 86989),
(86990, '2.60.40.10-FF-000704', NULL, 'collagen alpha-1(XII) chain isoform X1', 97, NULL, NULL, 86990),
(86991, '2.60.40.10-FF-001210', NULL, 'Obscurin like 1', 88, NULL, NULL, 86991),
(86992, '1.20.58.60-FF-000140', NULL, 'dystrophin isoform X1', 305, NULL, NULL, 86992),
(86993, '2.70.98.20-FF-000002', NULL, 'Amine oxidase', 451, NULL, NULL, 86993),
(86994, '3.90.640.10-FF-000095', NULL, 'Actin-related protein 3, putative', 101, NULL, NULL, 86994),
(86995, '2.60.120.10-FF-000448', NULL, 'Mannose-6-phosphate isomerase', 179, NULL, NULL, 86995),
(86996, '1.10.150.20-FF-000243', NULL, 'Translocation protein SEC63-like protein', 59, NULL, NULL, 86996),
(86997, '1.25.40.700-FF-000001', NULL, 'Nuclear pore complex protein', 135, NULL, NULL, 86997),
(86998, '1.10.1410.10-FF-000080', NULL, 'Uncharacterized protein', 32, NULL, NULL, 86998),
(86999, '1.25.40.10-FF-004503', NULL, 'Pentatricopeptide repeat-containing protein At2g28050', 91, NULL, NULL, 86999),
(87000, '1.25.40.10-FF-001069', NULL, 'Pentatricopeptide repeat-containing protein At3g53700, chloroplastic', 74, NULL, NULL, 87000),
(87001, '3.40.5.10-FF-000010', NULL, '50S ribosomal protein L9', 58, NULL, NULL, 87001),
(87002, '1.20.1070.10-FF-002102', NULL, 'Uncharacterized protein', 344, NULL, NULL, 87002);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(87003, '3.30.160.60-FF-005212', NULL, NULL, 36, NULL, NULL, 87003),
(87004, '2.70.130.10-FF-000093', NULL, NULL, 125, NULL, NULL, 87004),
(87005, '3.40.630.10-FF-000482', NULL, 'Putative glutaminyl cyclase', 114, NULL, NULL, 87005),
(87006, '2.30.30.140-FF-000142', NULL, 'Ribonuclease', 52, NULL, NULL, 87006),
(87007, '1.10.730.10-FF-000088', NULL, 'Leucine--tRNA ligase, mitochondrial', 189, NULL, NULL, 87007),
(87008, '2.130.10.10-FF-004471', NULL, 'Uncharacterized protein', 72, NULL, NULL, 87008),
(87009, '3.40.109.10-FF-000046', NULL, 'Nitroreductase family protein', 203, NULL, NULL, 87009),
(87010, '3.90.215.10-FF-000017', NULL, 'Intelectin 1', 136, NULL, NULL, 87010),
(87011, '1.25.10.10-FF-000724', NULL, 'Cyclosome subunit-like protein', 221, NULL, NULL, 87011),
(87012, '3.50.50.60-FF-000403', NULL, 'Flavin-containing monooxygenase', 174, NULL, NULL, 87012),
(87013, '3.10.20.90-FF-000457', NULL, 'Rad60, isoform B', 88, NULL, NULL, 87013),
(87014, '1.10.287.160-FF-000023', NULL, 'Protein kinase C', 73, NULL, NULL, 87014),
(87015, '3.30.160.60-FF-004296', NULL, NULL, 21, NULL, NULL, 87015),
(87016, '3.30.800.10-FF-000025', NULL, NULL, 163, NULL, NULL, 87016),
(87017, '1.25.40.10-FF-005239', NULL, 'Putative S-locus receptor-like protein kinase family protein', 171, NULL, NULL, 87017),
(87018, '1.10.287.3240-FF-000038', NULL, 'Uncharacterized protein', 144, NULL, NULL, 87018),
(87019, '2.130.10.10-FF-005696', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit', 151, NULL, NULL, 87019),
(87020, '2.170.270.10-FF-000062', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-36 specific', 260, NULL, NULL, 87020),
(87021, '1.10.540.10-FF-000152', NULL, 'Uncharacterized protein', 74, NULL, NULL, 87021),
(87022, '3.90.70.10-FF-000747', NULL, 'Uncharacterized protein', 131, NULL, NULL, 87022),
(87023, '3.10.580.10-FF-000006', NULL, 'DUF21 and CBS domain protein', 151, NULL, NULL, 87023),
(87024, '2.60.40.1270-FF-000001', NULL, 'Putative DD-carboxypeptidase TP_0574', 83, NULL, NULL, 87024),
(87025, '2.70.98.10-FF-000112', NULL, 'Beta-galactosidase', 286, NULL, NULL, 87025),
(87026, '2.60.40.1660-FF-000006', NULL, 'Sodium/potassium-transporting ATPase subunit beta', 223, NULL, NULL, 87026),
(87027, '3.80.10.10-FF-003285', NULL, 'Uncharacterized protein', 118, NULL, NULL, 87027),
(87028, '1.10.1420.10-FF-000165', NULL, 'MutS protein homolog 5', 233, NULL, NULL, 87028),
(87029, '3.30.200.20-FF-001253', NULL, 'Uncharacterized protein', 59, NULL, NULL, 87029),
(87030, '1.10.3080.10-FF-000065', NULL, 'Chloride channel, putative', 211, NULL, NULL, 87030),
(87031, '3.30.200.20-FF-000163', NULL, 'SRSF protein kinase 2 isoform X1', 109, NULL, NULL, 87031),
(87032, '1.20.1170.10-FF-000013', NULL, NULL, 250, NULL, NULL, 87032),
(87033, '3.40.630.30-FF-000488', NULL, 'UPF0039 protein sll0451', 148, NULL, NULL, 87033),
(87034, '3.40.50.300-FF-006039', NULL, 'DEAH-box helicase 15', 143, NULL, NULL, 87034),
(87035, '2.40.10.170-FF-000004', NULL, 'ATP synthase subunit beta', 81, NULL, NULL, 87035),
(87036, '3.30.1490.180-FF-000014', NULL, 'DNA-directed RNA polymerase subunit', 76, NULL, NULL, 87036),
(87037, '3.40.50.720-FF-000196', NULL, 'Leucine dehydrogenase', 203, NULL, NULL, 87037),
(87038, '3.40.50.300-FF-001823', NULL, 'ABC transporter ATP-binding protein', 222, NULL, NULL, 87038),
(87039, '1.25.40.20-FF-000650', NULL, 'KRIT 1 (Krev interaction trapped/cerebral cavernous malformation 1) homolog', 140, NULL, NULL, 87039),
(87040, '1.10.510.10-FF-003197', NULL, NULL, 149, NULL, NULL, 87040),
(87041, '2.70.170.10-FF-000100', NULL, 'Protein CBR-LGC-28', 237, NULL, NULL, 87041),
(87042, '1.10.150.240-FF-000048', NULL, 'Haloacid dehalogenase-like hydrolase family protein', 69, NULL, NULL, 87042),
(87043, '2.160.20.20-FF-000004', NULL, 'Outer membrane autotransporter barrel domain-containing protein', 516, NULL, NULL, 87043),
(87044, '1.10.510.10-FF-000471', NULL, 'OBP3-responsive gene 1', 178, NULL, NULL, 87044),
(87045, '3.40.1000.10-FF-000001', NULL, 'Repulsive guidance molecule BMP co-receptor a', 153, NULL, NULL, 87045);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(87046, '1.10.472.80-FF-000227', NULL, NULL, 75, NULL, NULL, 87046),
(87047, '3.80.10.10-FF-004347', NULL, 'Uncharacterized protein', 185, NULL, NULL, 87047),
(87048, '3.30.70.330-FF-003154', NULL, NULL, 107, NULL, NULL, 87048),
(87049, '3.40.30.10-FF-000640', NULL, 'Peroxiredoxin type II', 167, NULL, NULL, 87049),
(87050, '3.90.1150.10-FF-000062', NULL, 'Aspartate aminotransferase A', 149, NULL, NULL, 87050),
(87051, '2.30.29.30-FF-000595', NULL, 'Putative rac serine-threonine kinase', 96, NULL, NULL, 87051),
(87052, '3.40.50.2300-FF-000298', NULL, 'DNA-binding response regulator', 84, NULL, NULL, 87052),
(87053, '3.30.40.10-FF-000866', NULL, 'Ubiquitinyl hydrolase 1', 105, NULL, NULL, 87053),
(87054, '2.130.10.10-FF-005549', NULL, 'Uncharacterized protein', 222, NULL, NULL, 87054),
(87055, '2.60.40.60-FF-000803', NULL, 'Uncharacterized protein', 74, NULL, NULL, 87055),
(87056, '1.10.8.50-FF-000026', NULL, '30S ribosomal protein S13', 76, NULL, NULL, 87056),
(87057, '2.130.10.10-FF-001598', NULL, 'Meiosis-specific APC/C activator protein AMA1', 383, NULL, NULL, 87057),
(87058, '2.20.20.10-FF-000002', NULL, 'Big defensin', 40, NULL, NULL, 87058),
(87059, '1.20.120.350-FF-000090', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 70, NULL, NULL, 87059),
(87060, '1.10.418.10-FF-000172', NULL, 'Plectin', 113, NULL, NULL, 87060),
(87061, '2.60.120.290-FF-000062', NULL, 'Cubilin', 124, NULL, NULL, 87061),
(87062, '1.20.272.10-FF-000072', NULL, NULL, 55, NULL, NULL, 87062),
(87063, '2.30.140.30-FF-000001', NULL, 'D-alanyl-D-alanine carboxypeptidase DacB', 92, NULL, NULL, 87063),
(87064, '1.10.8.270-FF-000081', NULL, 'TBC domain containing protein', 134, NULL, NULL, 87064),
(87065, '2.30.30.40-FF-000450', NULL, 'Uncharacterized protein', 70, NULL, NULL, 87065),
(87066, '3.30.160.60-FF-004032', NULL, NULL, 57, NULL, NULL, 87066),
(87067, '3.90.79.10-FF-000183', NULL, 'Uncharacterized protein', 191, NULL, NULL, 87067),
(87068, '2.40.70.10-FF-000212', NULL, 'Os09g0556100 protein', 193, NULL, NULL, 87068),
(87069, '3.80.10.10-FF-002402', NULL, 'Leucine Rich Repeat family protein', 265, NULL, NULL, 87069),
(87070, '3.80.10.10-FF-003830', NULL, 'Uncharacterized protein', 67, NULL, NULL, 87070),
(87071, '2.40.290.10-FF-000037', NULL, 'ATP-dependent DNA helicase II subunit 1', 119, NULL, NULL, 87071),
(87072, '1.10.630.10-FF-000390', NULL, 'Taxane 13-alpha-hydroxylase isoform A', 202, NULL, NULL, 87072),
(87073, '3.40.50.300-FF-006803', NULL, 'ATP-dependent transporter, putative', 51, NULL, NULL, 87073),
(87074, '3.40.50.2300-FF-000859', NULL, 'Guanylate cyclase 2G', 128, NULL, NULL, 87074),
(87075, '3.40.50.1820-FF-001070', NULL, 'Prolyl oligopeptidase family protein', 51, NULL, NULL, 87075),
(87076, '3.30.160.60-FF-000917', NULL, 'Zinc finger and BTB domain containing 40', 23, NULL, NULL, 87076),
(87077, '3.80.10.10-FF-002666', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 169, NULL, NULL, 87077),
(87078, '3.40.50.410-FF-000075', NULL, 'Sporozoite surface protein 2', 215, NULL, NULL, 87078),
(87079, '3.40.50.150-FF-001609', NULL, NULL, 256, NULL, NULL, 87079),
(87080, '3.40.50.1440-FF-000091', NULL, 'Protein DML1', 207, NULL, NULL, 87080),
(87081, '3.30.200.20-FF-000988', NULL, 'Serine/threonine-protein kinase VHS1', 77, NULL, NULL, 87081),
(87082, '3.30.2360.10-FF-000002', NULL, 'Probable myo-inositol 1-phosphate synthase (MIPS)', 118, NULL, NULL, 87082),
(87083, '1.20.5.110-FF-000159', NULL, 'EhSyntaxin G, putative', 77, NULL, NULL, 87083),
(87084, '2.160.10.10-FF-000074', NULL, 'Putative DEAD-box ATP-dependent RNA helicase family protein', 82, NULL, NULL, 87084),
(87085, '3.40.50.300-FF-003268', NULL, 'ABC transporter, class H', 288, NULL, NULL, 87085),
(87086, '1.10.510.10-FF-000324', NULL, 'N-terminal kinase-like protein isoform X2', 147, NULL, NULL, 87086),
(87087, '3.30.1600.10-FF-000026', NULL, 'NAD-dependent protein deacetylase 2', 99, NULL, NULL, 87087),
(87088, '3.30.40.10-FF-001485', NULL, 'E3 ubiquitin-protein ligase RNF115', 82, NULL, NULL, 87088);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(87089, '1.20.1060.20-FF-000025', NULL, NULL, 190, NULL, NULL, 87089),
(87090, '1.20.140.40-FF-000050', NULL, NULL, 149, NULL, NULL, 87090),
(87091, '2.60.34.10-FF-000072', NULL, 'Heat shock protein 4a', 135, NULL, NULL, 87091),
(87092, '1.25.40.10-FF-001996', NULL, 'Protein O-mannosyl-transferase TMTC2', 80, NULL, NULL, 87092),
(87093, '1.25.10.10-FF-002101', NULL, 'Zyg-11 family member A, cell cycle regulator', 304, NULL, NULL, 87093),
(87094, '3.30.590.10-FF-000053', NULL, 'Uncharacterized protein', 76, NULL, NULL, 87094),
(87095, '3.30.40.10-FF-002103', NULL, 'Uncharacterized protein', 71, NULL, NULL, 87095),
(87096, '3.10.100.10-FF-000140', NULL, 'Protein-tyrosine-phosphatase', 127, NULL, NULL, 87096),
(87097, '3.40.50.620-FF-000609', NULL, 'Rars-1', 339, NULL, NULL, 87097),
(87098, '3.30.9.10-FF-000041', NULL, 'Fructosyl amino acid oxidase, putative', 182, NULL, NULL, 87098),
(87099, '2.40.320.10-FF-000035', NULL, 'Inorganic triphosphatase', 149, NULL, NULL, 87099),
(87100, '1.10.238.10-FF-000528', NULL, 'Supercoiling factor', 60, NULL, NULL, 87100),
(87101, '3.40.50.720-FF-000757', NULL, 'NADPH-dependent aldehyde reductase 1, chloroplastic', 286, NULL, NULL, 87101),
(87102, '1.20.5.340-FF-000026', NULL, 'myotonin-protein kinase isoform X2', 80, NULL, NULL, 87102),
(87103, '1.10.10.10-FF-001269', NULL, 'Ferric uptake regulator family protein', 83, NULL, NULL, 87103),
(87104, '2.60.40.10-FF-005572', NULL, NULL, 79, NULL, NULL, 87104),
(87105, '1.20.120.420-FF-000015', NULL, 'Methylthioribose-1-phosphate isomerase', 141, NULL, NULL, 87105),
(87106, '1.25.10.10-FF-002410', NULL, 'RPTOR-independent companion of MTOR, complex 2 a', 253, NULL, NULL, 87106),
(87107, '3.40.50.2060-FF-000023', NULL, NULL, 125, NULL, NULL, 87107),
(87108, '2.160.20.70-FF-000002', NULL, 'Probable septum site-determining protein MinC', 110, NULL, NULL, 87108),
(87109, '2.60.40.1180-FF-000076', NULL, 'Glucosidase II', 149, NULL, NULL, 87109),
(87110, '3.10.110.10-FF-000275', NULL, 'Uncharacterized protein', 130, NULL, NULL, 87110),
(87111, '2.60.260.20-FF-000101', NULL, 'Mitochondrial protein import protein mas5', 71, NULL, NULL, 87111),
(87112, '3.30.750.24-FF-000141', NULL, 'Uncharacterized protein', 133, NULL, NULL, 87112),
(87113, '1.20.1270.10-FF-000077', NULL, 'Hsp70_protein_-_putative', 116, NULL, NULL, 87113),
(87114, '2.130.10.10-FF-004723', NULL, 'Predicted protein', 167, NULL, NULL, 87114),
(87115, '3.40.50.720-FF-001685', NULL, 'C-terminal-binding protein 1', 81, NULL, NULL, 87115),
(87116, '1.20.1080.10-FF-000130', NULL, 'AQuaPorin or aquaglyceroporin related', 68, NULL, NULL, 87116),
(87117, '3.40.50.300-FF-001368', NULL, 'Midasin', 224, NULL, NULL, 87117),
(87118, '3.30.720.150-FF-000010', NULL, 'O-linked GlcNAc transferase', 11, NULL, NULL, 87118),
(87119, '3.20.20.70-FF-000046', NULL, '4-hydroxy-tetrahydrodipicolinate synthase', 292, NULL, NULL, 87119),
(87120, '1.20.58.390-FF-000321', NULL, 'Uncharacterized protein', 63, NULL, NULL, 87120),
(87121, '3.40.50.150-FF-001497', NULL, NULL, 117, NULL, NULL, 87121),
(87122, '3.40.50.620-FF-000918', NULL, 'Probable cysteine--tRNA ligase, mitochondrial', 324, NULL, NULL, 87122),
(87123, '1.10.510.10-FF-003803', NULL, NULL, 122, NULL, NULL, 87123),
(87124, '1.10.287.370-FF-000098', NULL, 'Uncharacterized protein', 68, NULL, NULL, 87124),
(87125, '2.60.420.10-FF-000010', NULL, 'Cellobionic acid phosphorylase', 78, NULL, NULL, 87125),
(87126, '2.30.40.10-FF-000172', NULL, 'Predicted protein', 33, NULL, NULL, 87126),
(87127, '3.40.640.10-FF-000353', NULL, 'Lipopolysaccharide biosynthesis protein RfbH', 265, NULL, NULL, 87127),
(87128, '3.30.200.20-FF-002225', NULL, 'Predicted protein', 39, NULL, NULL, 87128),
(87129, '2.40.30.230-FF-000009', NULL, 'UPF1 protein', 88, NULL, NULL, 87129),
(87130, '4.10.1240.10-FF-000087', NULL, 'Uncharacterized protein', 76, NULL, NULL, 87130),
(87131, '3.30.1330.30-FF-000039', NULL, '40S ribosomal protein S12', 135, NULL, NULL, 87131),
(87132, '3.40.50.300-FF-003577', NULL, 'Probable uridine-cytidine kinase', 220, NULL, NULL, 87132);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(87133, '3.30.1490.110-FF-000010', NULL, 'Cell division protein FtsA', 85, NULL, NULL, 87133),
(87134, '3.40.1170.60-FF-000022', NULL, 'DNA repair protein REV1', 57, NULL, NULL, 87134),
(87135, '2.80.10.50-FF-000016', NULL, 'Ryanodine receptor 2 (Cardiac)', 187, NULL, NULL, 87135),
(87136, '2.60.40.1910-FF-000025', NULL, 'Protein CBG08739', 85, NULL, NULL, 87136),
(87137, '3.30.70.330-FF-002226', NULL, NULL, 91, NULL, NULL, 87137),
(87138, '3.30.565.10-FF-000523', NULL, 'Histidine kinase', 143, NULL, NULL, 87138),
(87139, '3.40.50.300-FF-000851', NULL, 'Ras-related small GTP-binding family protein', 177, NULL, NULL, 87139),
(87140, '1.10.287.2900-FF-000009', NULL, 'Uncharacterized protein, isoform B', 74, NULL, NULL, 87140),
(87141, '3.30.1490.40-FF-000014', NULL, NULL, 93, NULL, NULL, 87141),
(87142, '1.25.40.70-FF-000007', NULL, 'phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit alpha', 190, NULL, NULL, 87142),
(87143, '1.10.510.10-FF-001297', NULL, 'Receptor-like protein kinase 1', 199, NULL, NULL, 87143),
(87144, '3.40.630.30-FF-000274', NULL, 'GNAT family N-acetyltransferase', 153, NULL, NULL, 87144),
(87145, '2.30.30.30-FF-000093', NULL, 'LSU ribosomal protein L14E', 84, NULL, NULL, 87145),
(87146, '3.30.50.10-FF-000131', NULL, 'Nuclear Hormone Receptor family', 111, NULL, NULL, 87146),
(87147, '3.40.50.10330-FF-000064', NULL, 'NAD kinase', 128, NULL, NULL, 87147),
(87148, '3.10.20.90-FF-000243', NULL, 'Nuclear protein localization protein 4', 76, NULL, NULL, 87148),
(87149, '6.10.250.3270-FF-000001', NULL, 'Putative proline dehydrogenase (Monofunctional)', 39, NULL, NULL, 87149),
(87150, '3.30.160.60-FF-005785', NULL, NULL, 40, NULL, NULL, 87150),
(87151, '2.40.160.180-FF-000007', NULL, 'Slr1163 protein', 402, NULL, NULL, 87151),
(87152, '2.130.10.10-FF-004162', NULL, 'Pre-mRNA-processing factor 19 homolog 2', 172, NULL, NULL, 87152),
(87153, '3.80.10.10-FF-000295', NULL, 'Tubulin-specific chaperone cofactor E-like', 73, NULL, NULL, 87153),
(87154, '3.40.50.300-FF-002751', NULL, 'Cell division transport system ATP-binding protein', 232, NULL, NULL, 87154),
(87155, '3.30.420.10-FF-000395', NULL, NULL, 58, NULL, NULL, 87155),
(87156, '1.50.40.10-FF-000151', NULL, 'LEU5p Mitochondrial carrier protein', 315, NULL, NULL, 87156),
(87157, '1.20.5.320-FF-000020', NULL, 'Decoration protein gp12', 49, NULL, NULL, 87157),
(87158, '3.30.160.60-FF-002042', NULL, 'Zinc finger and SCAN domain-containing protein 12', 22, NULL, NULL, 87158),
(87159, '1.25.40.10-FF-002249', NULL, 'Uncharacterized protein', 141, NULL, NULL, 87159),
(87160, '3.90.228.10-FF-000013', NULL, 'Poly [ADP-ribose] polymerase', 189, NULL, NULL, 87160),
(87161, '3.30.1890.10-FF-000002', NULL, 'O-antigen chain length determinant protein', 246, NULL, NULL, 87161),
(87162, '3.90.1640.10-FF-000026', NULL, 'ABL083Wp', 234, NULL, NULL, 87162),
(87163, '3.50.50.60-FF-001286', NULL, 'Apoptosis-inducing factor 1', 130, NULL, NULL, 87163),
(87164, '3.40.720.10-FF-000045', NULL, 'GPI ethanolamine phosphate transferase 2', 293, NULL, NULL, 87164),
(87165, '3.40.50.10900-FF-000033', NULL, 'Proteasome assembly chaperone 2', 155, NULL, NULL, 87165),
(87166, '3.30.160.60-FF-005476', NULL, NULL, 56, NULL, NULL, 87166),
(87167, '2.60.120.200-FF-000529', NULL, 'Galectin', 146, NULL, NULL, 87167),
(87168, '3.90.199.10-FF-000006', NULL, 'DNA topoisomerase (ATP-hydrolyzing)', 250, NULL, NULL, 87168),
(87169, '1.20.1070.10-FF-000202', NULL, 'Cadherin EGF LAG seven-pass G-type receptor', 271, NULL, NULL, 87169),
(87170, '1.10.510.10-FF-001549', NULL, 'Serine/threonine protein kinase, putative', 115, NULL, NULL, 87170),
(87171, '3.90.70.10-FF-000186', NULL, 'Unplaced genomic scaffold supercont1.125, whole genome shotgun sequence', 324, NULL, NULL, 87171),
(87172, '2.120.10.80-FF-000181', NULL, 'Galactose oxidase/kelch repeat superfamily protein', 240, NULL, NULL, 87172),
(87173, '2.120.10.30-FF-000317', NULL, 'Glucose dehydrogenase', 362, NULL, NULL, 87173),
(87174, '3.40.50.300-FF-007871', NULL, 'Uncharacterized protein', 207, NULL, NULL, 87174);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(87175, '1.10.472.130-FF-000038', NULL, 'Putative dynein heavy chain', 163, NULL, NULL, 87175),
(87176, '1.10.1070.11-FF-000144', NULL, 'Uncharacterized protein', 57, NULL, NULL, 87176),
(87177, '1.10.10.60-FF-000098', NULL, 'Transcription factor LBX1', 68, NULL, NULL, 87177),
(87178, '3.40.50.150-FF-000553', NULL, 'Uncharacterized protein', 266, NULL, NULL, 87178),
(87179, '3.40.50.1010-FF-000080', NULL, 'rRNA processing Fcf1 Family Protein', 152, NULL, NULL, 87179),
(87180, '1.10.150.50-FF-000033', NULL, 'Protein vts1, variant', 82, NULL, NULL, 87180),
(87181, '3.30.200.20-FF-000724', NULL, 'Mitogen-activated protein kinase', 86, NULL, NULL, 87181),
(87182, '3.30.230.10-FF-000223', NULL, 'DNA repair protein RadA', 154, NULL, NULL, 87182),
(87183, '3.90.1150.210-FF-000014', NULL, 'F-actin-capping protein subunit alpha', 142, NULL, NULL, 87183),
(87184, '2.40.50.140-FF-001279', NULL, NULL, 135, NULL, NULL, 87184),
(87185, '3.40.50.12780-FF-000220', NULL, 'Uncharacterized protein', 50, NULL, NULL, 87185),
(87186, '1.10.3430.10-FF-000014', NULL, 'Urea transporter DVU1160', 306, NULL, NULL, 87186),
(87187, '1.10.580.10-FF-000042', NULL, 'Citrate synthase', 75, NULL, NULL, 87187),
(87188, '2.30.29.30-FF-000915', NULL, 'Uncharacterized protein', 114, NULL, NULL, 87188),
(87189, '2.30.29.30-FF-000376', NULL, 'Exocyst complex component 8', 107, NULL, NULL, 87189),
(87190, '1.25.10.10-FF-003057', NULL, 'Predicted protein', 270, NULL, NULL, 87190),
(87191, '3.90.550.50-FF-000212', NULL, 'Hexosyltransferase', 155, NULL, NULL, 87191),
(87192, '3.30.160.60-FF-001053', NULL, 'zinc finger protein 382 isoform X2', 26, NULL, NULL, 87192),
(87193, '3.40.50.300-FF-008383', NULL, 'DNA helicase', 217, NULL, NULL, 87193),
(87194, '2.60.40.10-FF-004274', NULL, NULL, 107, NULL, NULL, 87194),
(87195, '3.10.450.220-FF-000002', NULL, '60S ribosome subunit biogenesis protein NIP7 homolog', 69, NULL, NULL, 87195),
(87196, '3.30.450.20-FF-000439', NULL, 'Uncharacterized protein', 115, NULL, NULL, 87196),
(87197, '1.20.1250.20-FF-000635', NULL, 'Integral membrane transport protein', 185, NULL, NULL, 87197),
(87198, '1.10.1650.10-FF-000002', NULL, 'LSU ribosomal protein L19E', 56, NULL, NULL, 87198),
(87199, '3.30.200.20-FF-001236', NULL, 'AGC/RSK protein kinase', 95, NULL, NULL, 87199),
(87200, '3.40.630.10-FF-000263', NULL, 'Predicted protein', 307, NULL, NULL, 87200),
(87201, '3.90.850.10-FF-000032', NULL, 'Uncharacterized protein', 246, NULL, NULL, 87201),
(87202, '3.40.50.10090-FF-000048', NULL, 'Uncharacterized protein', 123, NULL, NULL, 87202),
(87203, '2.130.10.10-FF-000114', NULL, 'zinc finger protein 106 isoform X1', 202, NULL, NULL, 87203),
(87204, '2.60.200.30-FF-000005', NULL, 'NAD+ kinase Utr1', 128, NULL, NULL, 87204),
(87205, '1.10.10.540-FF-000007', NULL, 'RAD23 protein, putative', 50, NULL, NULL, 87205),
(87206, '2.60.120.10-FF-000425', NULL, 'At1g07750/F24B9_13', 185, NULL, NULL, 87206),
(87207, '4.10.280.110-FF-000007', NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', 74, NULL, NULL, 87207),
(87208, '1.20.1250.20-FF-001568', NULL, 'Uncharacterized protein', 386, NULL, NULL, 87208),
(87209, '1.25.40.20-FF-000780', NULL, 'BRCA1-associated RING domain protein 1', 68, NULL, NULL, 87209),
(87210, '3.30.1120.10-FF-000023', NULL, 'Arylsulfatase', 74, NULL, NULL, 87210),
(87211, '2.10.25.10-FF-000778', NULL, 'Protein S', 43, NULL, NULL, 87211),
(87212, '3.30.1120.30-FF-000029', NULL, 'Serine/threonine-protein kinase PLK', 90, NULL, NULL, 87212),
(87213, '2.60.40.60-FF-000011', NULL, 'Cadherin 1', 115, NULL, NULL, 87213),
(87214, '1.20.5.110-FF-000266', NULL, 'Qb+c-SNARE protein, SNAP25-family', 67, NULL, NULL, 87214),
(87215, '3.40.50.720-FF-000988', NULL, 'Possible oxidoreductase', 275, NULL, NULL, 87215),
(87216, '3.30.230.130-FF-000067', NULL, 'Ubiquitin-protein ligase, putative', 128, NULL, NULL, 87216),
(87217, '3.10.110.10-FF-000303', NULL, 'Uncharacterized protein', 91, NULL, NULL, 87217),
(87218, '2.130.10.10-FF-003779', NULL, 'WD repeat domain phosphoinositide-interacting protein 3', 316, NULL, NULL, 87218);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(87219, '2.60.120.10-FF-000318', NULL, 'Cyclic nucleotide-binding protein-like protein', 142, NULL, NULL, 87219),
(87220, '2.60.40.420-FF-000030', NULL, 'ephrin-A3 isoform X1', 150, NULL, NULL, 87220),
(87221, '3.30.9.10-FF-000125', NULL, 'FAD dependent oxidoreductase', 174, NULL, NULL, 87221),
(87222, '3.30.70.330-FF-001956', NULL, NULL, 91, NULL, NULL, 87222),
(87223, '1.25.40.20-FF-000341', NULL, 'Bromodomain protein 1', 51, NULL, NULL, 87223),
(87224, '1.10.155.10-FF-000004', NULL, 'Chemotaxis protein methyltransferase', 75, NULL, NULL, 87224),
(87225, '2.60.120.1040-FF-000017', NULL, NULL, 112, NULL, NULL, 87225),
(87226, '1.20.120.1240-FF-000049', NULL, 'Putative vacuolar sorting protein vps1 dynamin', 66, NULL, NULL, 87226),
(87227, '3.30.200.20-FF-001713', NULL, 'Uncharacterized protein', 33, NULL, NULL, 87227),
(87228, '3.40.50.300-FF-004802', NULL, 'Uncharacterized protein', 207, NULL, NULL, 87228),
(87229, '1.25.40.10-FF-000451', NULL, 'mRNA splicing protein (Prp39), putative', 268, NULL, NULL, 87229),
(87230, '1.10.630.10-FF-000743', NULL, 'Uncharacterized protein', 81, NULL, NULL, 87230),
(87231, '3.40.50.12780-FF-000113', NULL, 'Beta-alanine-activating enzyme', 411, NULL, NULL, 87231),
(87232, '3.40.50.300-FF-001929', NULL, 'Ras-related protein Rab-1A', 203, NULL, NULL, 87232),
(87233, '1.10.287.70-FF-000619', NULL, 'Uncharacterized protein', 239, NULL, NULL, 87233),
(87234, '3.40.50.300-FF-003021', NULL, 'Uncharacterized protein (Fragment)', 192, NULL, NULL, 87234),
(87235, '1.20.1250.20-FF-000152', NULL, 'Plastidic glucose transporter 4', 446, NULL, NULL, 87235),
(87236, '3.40.640.10-FF-000437', NULL, 'Aminoadipate aminotransferase', 273, NULL, NULL, 87236),
(87237, '2.40.10.10-FF-000130', NULL, 'Chymotrypsinogen A', 147, NULL, NULL, 87237),
(87238, '3.90.190.10-FF-000357', NULL, 'PTP/DSP-like', 183, NULL, NULL, 87238),
(87239, '3.60.40.10-FF-000179', NULL, 'Probable two-component response regulator', 253, NULL, NULL, 87239),
(87240, '2.60.40.10-FF-004167', NULL, NULL, 88, NULL, NULL, 87240),
(87241, '3.30.70.890-FF-000011', NULL, 'Phosphomevalonate kinase, peroxisomal', 133, NULL, NULL, 87241),
(87242, '3.50.50.60-FF-001263', NULL, 'Predicted protein', 93, NULL, NULL, 87242),
(87243, '3.40.50.300-FF-001559', NULL, 'U3 small nucleolar RNA-associated protein 25', 214, NULL, NULL, 87243),
(87244, '3.30.1490.20-FF-000014', NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta', 76, NULL, NULL, 87244),
(87245, '2.40.30.10-FF-000457', NULL, 'Uncharacterized protein', 104, NULL, NULL, 87245),
(87246, '1.10.510.10-FF-001089', NULL, 'Protein CBG12477', 345, NULL, NULL, 87246),
(87247, '2.60.120.10-FF-000757', NULL, 'Uncharacterized protein', 82, NULL, NULL, 87247),
(87248, '3.40.50.10990-FF-000003', NULL, 'GTP cyclohydrolase II', 178, NULL, NULL, 87248),
(87249, '1.25.40.10-FF-004722', NULL, 'Uncharacterized protein', 87, NULL, NULL, 87249),
(87250, '2.60.40.150-FF-000056', NULL, 'Protein kinase C epsilon', 135, NULL, NULL, 87250),
(87251, '3.40.50.1000-FF-000560', NULL, NULL, 121, NULL, NULL, 87251),
(87252, '1.20.58.1120-FF-000056', NULL, NULL, 165, NULL, NULL, 87252),
(87253, '3.40.720.10-FF-000281', NULL, 'GPI ethanolamine phosphate transferase 2', 306, NULL, NULL, 87253),
(87254, '3.90.79.10-FF-000076', NULL, 'Ap4A hydrolase', 152, NULL, NULL, 87254),
(87255, '2.60.40.10-FF-005791', NULL, NULL, 87, NULL, NULL, 87255),
(87256, '1.10.10.10-FF-002005', NULL, 'Uncharacterized protein', 124, NULL, NULL, 87256),
(87257, '3.10.20.310-FF-000028', NULL, 'Outer membrane protein assembly factor BamA', 81, NULL, NULL, 87257),
(87258, '1.20.1740.10-FF-000158', NULL, 'General amino-acid permease, putative', 470, NULL, NULL, 87258),
(87259, '2.60.40.10-FF-005948', NULL, NULL, 94, NULL, NULL, 87259),
(87260, '1.50.40.10-FF-000252', NULL, 'Uncharacterized protein', 165, NULL, NULL, 87260),
(87261, '1.10.4040.10-FF-000001', NULL, 'BlaI/MecI/CopY family transcriptional regulator', 50, NULL, NULL, 87261),
(87262, '1.20.140.10-FF-000142', NULL, 'Uncharacterized protein', 79, NULL, NULL, 87262);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(87263, '3.30.70.100-FF-000016', NULL, '(4S)-4-hydroxy-5-phosphonooxypentane-2,3-dione isomerase', 96, NULL, NULL, 87263),
(87264, '2.10.270.10-FF-000009', NULL, 'Dextransucrase', 228, NULL, NULL, 87264),
(87265, '1.10.510.10-FF-000105', NULL, 'SRSF protein kinase 2', 220, NULL, NULL, 87265),
(87266, '1.10.150.20-FF-000018', NULL, 'Transcription termination/antitermination protein NusA', 70, NULL, NULL, 87266),
(87267, '1.20.58.2010-FF-000014', NULL, 'Uncharacterized protein', 87, NULL, NULL, 87267),
(87268, '3.30.497.10-FF-000050', NULL, 'Putative non-inhibitory serpin-Z11', 57, NULL, NULL, 87268),
(87269, '3.30.70.330-FF-002092', NULL, NULL, 125, NULL, NULL, 87269),
(87270, '3.20.20.70-FF-000607', NULL, NULL, 166, NULL, NULL, 87270),
(87271, '3.60.90.10-FF-000025', NULL, 'Uncharacterized protein', 78, NULL, NULL, 87271),
(87272, '2.20.28.10-FF-000031', NULL, 'DNA replication licensing factor, putative', 58, NULL, NULL, 87272),
(87273, '1.10.472.10-FF-000342', NULL, 'Cyclin D2, a', 72, NULL, NULL, 87273),
(87274, '3.90.76.10-FF-000053', NULL, 'Oligopeptide ABC transporter, solute-binding protein', 110, NULL, NULL, 87274),
(87275, '1.10.3380.30-FF-000010', NULL, 'DExH-box ATP-dependent RNA helicase DExH11', 68, NULL, NULL, 87275),
(87276, '3.40.190.10-FF-000127', NULL, 'Thiamine ABC transporter, periplasmic binding protein', 155, NULL, NULL, 87276),
(87277, '3.30.40.10-FF-000557', NULL, 'Histone-lysine N-methyltransferase', 53, NULL, NULL, 87277),
(87278, '1.10.1050.10-FF-000001', NULL, '30S ribosomal protein S4', 111, NULL, NULL, 87278),
(87279, '3.30.70.330-FF-000175', NULL, 'Heterogeneous nuclear ribonucleoprotein Q', 81, NULL, NULL, 87279),
(87280, '2.60.40.10-FF-001896', NULL, 'Twitchin', 88, NULL, NULL, 87280),
(87281, '1.20.1050.140-FF-000001', NULL, 'Heterodisulfide oxidoreductase, CCG domain pair-containing subunit B', 130, NULL, NULL, 87281),
(87282, '1.25.40.530-FF-000017', NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', 168, NULL, NULL, 87282),
(87283, '1.20.1460.10-FF-000013', NULL, 'V-type proton ATPase subunit C', 171, NULL, NULL, 87283),
(87284, '2.60.200.20-FF-000148', NULL, 'WGS project CABT00000000 data, contig 2.1', 138, NULL, NULL, 87284),
(87285, '3.60.21.60-FF-000032', NULL, 'Uncharacterized protein', 186, NULL, NULL, 87285),
(87286, '1.10.533.10-FF-000040', NULL, 'tumor necrosis factor receptor superfamily member 25', 88, NULL, NULL, 87286),
(87287, '1.25.40.10-FF-002266', NULL, 'Uncharacterized protein B11O8.010', 229, NULL, NULL, 87287),
(87288, '3.70.10.10-FF-000020', NULL, 'Checkpoint protein', 282, NULL, NULL, 87288),
(87289, '1.20.1110.10-FF-000257', NULL, NULL, 104, NULL, NULL, 87289),
(87290, '1.20.140.40-FF-000038', NULL, 'Plant invertase/pectin methylesterase inhibitor superfamily protein', 133, NULL, NULL, 87290),
(87291, '1.25.40.20-FF-000673', NULL, 'Protein ACCELERATED CELL DEATH 6', 406, NULL, NULL, 87291),
(87292, '1.20.5.30-FF-000008', NULL, NULL, 37, NULL, NULL, 87292),
(87293, '1.10.565.10-FF-000164', NULL, 'Uncharacterized protein', 201, NULL, NULL, 87293),
(87294, '3.30.70.980-FF-000049', NULL, 'Uncharacterized protein', 87, NULL, NULL, 87294),
(87295, '3.80.10.10-FF-003594', NULL, 'Protein CBG03304', 130, NULL, NULL, 87295),
(87296, '3.30.1010.10-FF-000150', NULL, 'Acyl carrier protein', 86, NULL, NULL, 87296),
(87297, '3.40.50.300-FF-001132', NULL, 'Sulfotransferase', 293, NULL, NULL, 87297),
(87298, '1.10.510.10-FF-003983', NULL, NULL, 326, NULL, NULL, 87298),
(87299, '2.60.40.1910-FF-000008', NULL, 'Aminopeptidase', 93, NULL, NULL, 87299),
(87300, '3.90.70.10-FF-000663', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 345, NULL, NULL, 87300),
(87301, '3.40.50.300-FF-000620', NULL, 'NEDD4-binding protein 2 isoform X1', 141, NULL, NULL, 87301),
(87302, '1.10.238.10-FF-000663', NULL, 'Probable calcium-binding protein CML25', 89, NULL, NULL, 87302),
(87303, '3.30.60.30-FF-000204', NULL, 'Uncharacterized protein', 45, NULL, NULL, 87303),
(87304, '1.20.1560.10-FF-000588', NULL, 'Uncharacterized protein', 217, NULL, NULL, 87304);
INSERT INTO "PUBLIC"."MODEL" VALUES
(87305, '3.30.40.10-FF-001069', NULL, 'E4 SUMO-protein ligase PIAL1', 111, NULL, NULL, 87305),
(87306, '2.60.260.20-FF-000124', NULL, 'Predicted protein', 68, NULL, NULL, 87306),
(87307, '3.30.160.60-FF-004616', NULL, NULL, 47, NULL, NULL, 87307),
(87308, '4.10.320.10-FF-000006', NULL, 'Acetyltransferase component of pyruvate dehydrogenase complex', 54, NULL, NULL, 87308),
(87309, '1.25.10.10-FF-000623', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 376, NULL, NULL, 87309),
(87310, '3.30.160.60-FF-006201', NULL, NULL, 41, NULL, NULL, 87310),
(87311, '1.20.1070.10-FF-001686', NULL, 'Uncharacterized protein', 113, NULL, NULL, 87311),
(87312, '1.20.1530.20-FF-000078', NULL, 'K transporter', 343, NULL, NULL, 87312),
(87313, '3.30.450.40-FF-000125', NULL, 'Transcriptional regulator, IclR family', 79, NULL, NULL, 87313),
(87314, '3.30.710.10-FF-000518', NULL, 'Predicted protein', 27, NULL, NULL, 87314),
(87315, '3.30.9.10-FF-000232', NULL, 'FAD-dependent oxidoreductase family protein', 82, NULL, NULL, 87315),
(87316, '3.40.50.300-FF-000148', NULL, 'Nucleolar GTP-binding protein 2', 164, NULL, NULL, 87316),
(87317, '1.20.1080.10-FF-000023', NULL, 'Prip, isoform A', 235, NULL, NULL, 87317),
(87318, '3.30.160.60-FF-002834', NULL, 'Histone-lysine N-methyltransferase PRDM16', 83, NULL, NULL, 87318),
(87319, '1.10.287.110-FF-000155', NULL, 'Apj1p', 129, NULL, NULL, 87319),
(87320, '3.40.140.10-FF-000091', NULL, 'tRNA-specific adenosine deaminase subunit', 160, NULL, NULL, 87320),
(87321, '3.40.720.10-FF-000062', NULL, 'Probable sulfatase', 503, NULL, NULL, 87321),
(87322, '3.30.160.60-FF-005105', NULL, NULL, 37, NULL, NULL, 87322),
(87323, '1.10.720.30-FF-000037', NULL, 'ATP-dependent DNA helicase II subunit 1', 50, NULL, NULL, 87323),
(87324, '3.40.640.10-FF-000128', NULL, 'Serine hydroxymethyltransferase, mitochondrial', 100, NULL, NULL, 87324),
(87325, '3.30.70.1070-FF-000015', NULL, 'Sporulation-specific N-acetylmuramoyl-L-alanine amidase', 72, NULL, NULL, 87325),
(87326, '2.60.40.10-FF-002385', NULL, 'AGAP005471-PA-like protein', 94, NULL, NULL, 87326),
(87327, '1.10.8.60-FF-000355', NULL, 'ATPase, AAA family protein', 68, NULL, NULL, 87327),
(87328, '2.10.70.80-FF-000015', NULL, 'Sortilin', 54, NULL, NULL, 87328),
(87329, '3.40.50.1400-FF-000011', NULL, 'Sirohydrochlorin cobaltochelatase', 123, NULL, NULL, 87329),
(87330, '3.80.10.10-FF-003605', NULL, 'Uncharacterized protein', 274, NULL, NULL, 87330),
(87331, '3.30.1320.10-FF-000027', NULL, 'Uncharacterized protein', 82, NULL, NULL, 87331),
(87332, '1.10.8.500-FF-000003', NULL, 'Methyl-accepting chemotaxis protein', 47, NULL, NULL, 87332),
(87333, '1.20.120.340-FF-000008', NULL, 'Flagellar secretion chaperone FliS', 127, NULL, NULL, 87333),
(87334, '3.40.50.150-FF-000300', NULL, 'S-adenosyl-L-methionine-dependent methyltransferases superfamily protein', 220, NULL, NULL, 87334),
(87335, '1.25.40.20-FF-001162', NULL, 'Zinc finger CCCH domain-containing protein 66', 128, NULL, NULL, 87335),
(87336, '3.30.200.20-FF-000617', NULL, 'NIMA related kinase 1', 48, NULL, NULL, 87336),
(87337, '4.10.800.10-FF-000032', NULL, 'Uncharacterized protein', 58, NULL, NULL, 87337),
(87338, '3.30.230.10-FF-000116', NULL, 'Phosphomevalonate kinase', 283, NULL, NULL, 87338),
(87339, '2.30.180.10-FF-000014', NULL, 'Stabilin 1', 135, NULL, NULL, 87339),
(87340, '2.60.120.330-FF-000091', NULL, 'Oxidoreductase, 2og-fe(Ii) oxygenase family, putative', 325, NULL, NULL, 87340),
(87341, '1.10.510.10-FF-002241', NULL, 'Probable protein kinase DDB_G0291133', 270, NULL, NULL, 87341),
(87342, '3.20.20.470-FF-000001', NULL, 'Inactive glucansucrase', 403, NULL, NULL, 87342),
(87343, '2.130.10.10-FF-001418', NULL, 'Kinesin protein KIF21B', 239, NULL, NULL, 87343),
(87344, '2.60.34.10-FF-000055', NULL, 'Heat shock protein 70 mitochondrial putative', 158, NULL, NULL, 87344),
(87345, '2.60.40.10-FF-001873', NULL, 'Uncharacterized protein, isoform C', 105, NULL, NULL, 87345),
(87346, '3.40.50.300-FF-003493', NULL, 'Predicted protein', 209, NULL, NULL, 87346);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(87347, '2.120.10.30-FF-000424', NULL, 'Uncharacterized protein', 153, NULL, NULL, 87347),
(87348, '2.40.50.140-FF-000986', NULL, NULL, 187, NULL, NULL, 87348),
(87349, '3.30.70.330-FF-001164', NULL, 'Peptidyl-prolyl cis-trans isomerase', 131, NULL, NULL, 87349),
(87350, '3.40.50.300-FF-007764', NULL, 'ABC Transporter family', 69, NULL, NULL, 87350),
(87351, '1.20.58.1030-FF-000023', NULL, 'Probable DNA replication complex GINS protein PSF1', 128, NULL, NULL, 87351),
(87352, '3.90.280.10-FF-000016', NULL, 'Protease inhibitor', 258, NULL, NULL, 87352),
(87353, '3.40.50.450-FF-000053', NULL, 'Probable ATP-dependent 6-phosphofructokinase', 252, NULL, NULL, 87353),
(87354, '1.10.10.10-FF-000460', NULL, 'Two component transcriptional regulator', 105, NULL, NULL, 87354),
(87355, '3.30.260.10-FF-000051', NULL, 'T-complex protein 1 subunit gamma', 116, NULL, NULL, 87355),
(87356, '2.60.40.10-FF-003655', NULL, NULL, 101, NULL, NULL, 87356),
(87357, '3.30.30.30-FF-000023', NULL, 'LD21269p', 66, NULL, NULL, 87357),
(87358, '3.40.30.10-FF-000831', NULL, 'Uncharacterized protein', 127, NULL, NULL, 87358),
(87359, '3.40.50.300-FF-002857', NULL, 'Dynein heavy chain, cytoplasmic', 152, NULL, NULL, 87359),
(87360, '1.50.10.10-FF-000115', NULL, 'alpha-1,2-Mannosidase', 453, NULL, NULL, 87360),
(87361, '3.20.20.80-FF-000829', NULL, 'Uncharacterized protein', 49, NULL, NULL, 87361),
(87362, '3.40.50.11340-FF-000018', NULL, 'uncharacterized protein LOC100183376', 117, NULL, NULL, 87362),
(87363, '3.30.160.60-FF-000434', NULL, 'zinc finger protein 30 homolog', 28, NULL, NULL, 87363),
(87364, '3.80.10.10-FF-000188', NULL, 'F-box protein SKP2B', 221, NULL, NULL, 87364),
(87365, '3.30.70.270-FF-000140', NULL, 'Diguanylate cyclase-related enzyme', 160, NULL, NULL, 87365),
(87366, '3.50.40.10-FF-000011', NULL, 'Uncharacterized protein', 129, NULL, NULL, 87366),
(87367, '3.40.50.360-FF-000054', NULL, 'NAD(P)H dehydrogenase, quinone 1', 100, NULL, NULL, 87367),
(87368, '3.30.2010.10-FF-000015', NULL, 'M48 family peptidase', 84, NULL, NULL, 87368),
(87369, '1.20.940.10-FF-000017', NULL, 'Prp18 domain containing protein, putative', 156, NULL, NULL, 87369),
(87370, '2.30.30.1020-FF-000023', NULL, 'Predicted protein', 179, NULL, NULL, 87370),
(87371, '1.10.1820.10-FF-000021', NULL, 'Casein kinase II subunit beta', 81, NULL, NULL, 87371),
(87372, '1.25.40.10-FF-003677', NULL, 'Uncharacterized protein', 196, NULL, NULL, 87372),
(87373, '2.60.40.1180-FF-000177', NULL, 'Pullulanase 1, chloroplastic', 77, NULL, NULL, 87373),
(87374, '3.40.390.10-FF-000108', NULL, 'A disintegrin and metallopeptidase domain 6', 191, NULL, NULL, 87374),
(87375, '3.30.160.60-FF-006196', NULL, NULL, 50, NULL, NULL, 87375),
(87376, '3.30.930.10-FF-000372', NULL, 'Polymerase (DNA directed), gamma 2, accessory subunit', 207, NULL, NULL, 87376),
(87377, '1.25.40.20-FF-000217', NULL, 'Ankyrin repeat-containing protein ITN1', 121, NULL, NULL, 87377),
(87378, '3.30.70.330-FF-001473', NULL, NULL, 45, NULL, NULL, 87378),
(87379, '1.10.940.10-FF-000025', NULL, 'Transcription antitermination protein NusB', 141, NULL, NULL, 87379),
(87380, '3.40.50.300-FF-008164', NULL, 'Uncharacterized protein', 88, NULL, NULL, 87380),
(87381, '1.20.120.790-FF-000002', NULL, 'Molecular chaperone HtpG', 134, NULL, NULL, 87381),
(87382, '3.30.40.10-FF-001602', NULL, 'Nitric oxide synthase-interacting protein', 60, NULL, NULL, 87382),
(87383, '1.10.3720.10-FF-000238', NULL, 'Sugar ABC transporter, permease protein', 260, NULL, NULL, 87383),
(87384, '2.60.120.260-FF-000603', NULL, 'Alpha-galactosidase', 144, NULL, NULL, 87384),
(87385, '3.10.100.10-FF-000224', NULL, NULL, 141, NULL, NULL, 87385),
(87386, '3.40.50.720-FF-002438', NULL, 'Uncharacterized protein', 177, NULL, NULL, 87386),
(87387, '2.10.50.30-FF-000050', NULL, 'Uncharacterized protein', 43, NULL, NULL, 87387),
(87388, '3.30.70.80-FF-000023', NULL, 'Cerevisin', 95, NULL, NULL, 87388),
(87389, '3.40.50.300-FF-002548', NULL, 'DNA kinase/phosphatase Pnk1', 184, NULL, NULL, 87389),
(87390, '3.40.50.2300-FF-001579', NULL, NULL, 146, NULL, NULL, 87390);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(87391, '1.10.418.10-FF-000065', NULL, 'p-loop nucleoside triphosphate hydrolase superfamily protein with CH (Calponin Homology) domain', 113, NULL, NULL, 87391),
(87392, '2.130.10.10-FF-001525', NULL, 'WD domain, G-beta repeat-containing protein', 247, NULL, NULL, 87392),
(87393, '3.20.20.190-FF-000147', NULL, NULL, 72, NULL, NULL, 87393),
(87394, '2.40.50.140-FF-000879', NULL, NULL, 117, NULL, NULL, 87394),
(87395, '2.70.98.10-FF-000011', NULL, 'Putative glucose-6-phosphate 1-epimerase', 294, NULL, NULL, 87395),
(87396, '3.40.50.2000-FF-000612', NULL, 'Glycosyltransferase', 162, NULL, NULL, 87396),
(87397, '1.10.510.10-FF-002022', NULL, 'Uncharacterized protein', 289, NULL, NULL, 87397),
(87398, '2.40.50.100-FF-000098', NULL, 'Rrp40p', 61, NULL, NULL, 87398),
(87399, '3.40.50.2000-FF-001124', NULL, 'Alpha-1,4 glucan phosphorylase', 153, NULL, NULL, 87399),
(87400, '3.40.50.300-FF-003476', NULL, 'Predicted protein', 312, NULL, NULL, 87400),
(87401, '3.40.50.2000-FF-000270', NULL, 'Alpha-1,4 glucan phosphorylase', 105, NULL, NULL, 87401),
(87402, '2.60.40.10-FF-003874', NULL, NULL, 129, NULL, NULL, 87402),
(87403, '1.10.630.10-FF-000524', NULL, 'AGAP001443-PA', 397, NULL, NULL, 87403),
(87404, '3.40.50.410-FF-000209', NULL, 'Ku70-like protein', 211, NULL, NULL, 87404),
(87405, '3.80.10.10-FF-002296', NULL, 'Uncharacterized protein', 214, NULL, NULL, 87405),
(87406, '3.30.160.60-FF-002615', NULL, 'Zinc finger protein 347', 27, NULL, NULL, 87406),
(87407, '2.30.30.1190-FF-000012', NULL, 'Zinc finger CCCH domain-containing protein 3', 79, NULL, NULL, 87407),
(87408, '3.10.290.10-FF-000006', NULL, 'U3 small nucleolar ribonucleoprotein IMP3', 73, NULL, NULL, 87408),
(87409, '2.130.10.10-FF-005460', NULL, 'Uncharacterized protein', 181, NULL, NULL, 87409),
(87410, '2.60.200.40-FF-000025', NULL, 'Diacylglycerol kinase family protein', 160, NULL, NULL, 87410),
(87411, '3.20.20.70-FF-000147', NULL, 'Phospho-2-dehydro-3-deoxyheptonate aldolase', 337, NULL, NULL, 87411),
(87412, '1.10.10.2100-FF-000004', NULL, NULL, 30, NULL, NULL, 87412),
(87413, '2.10.25.10-FF-000648', NULL, 'Crumbs, isoform D', 41, NULL, NULL, 87413),
(87414, '3.30.40.10-FF-001855', NULL, 'E3 ubiquitin-protein ligase Os06g0535400', 81, NULL, NULL, 87414),
(87415, '1.20.140.150-FF-000039', NULL, 'Neuronal SYmmetry', 205, NULL, NULL, 87415),
(87416, '3.90.550.10-FF-000413', NULL, 'Zgc:172049 protein', 144, NULL, NULL, 87416),
(87417, '3.20.20.100-FF-000177', NULL, 'Uncharacterized protein', 161, NULL, NULL, 87417),
(87418, '3.40.50.880-FF-000209', NULL, 'Glutamine amidotransferase class-I family protein', 212, NULL, NULL, 87418),
(87419, '3.30.70.330-FF-002120', NULL, NULL, 110, NULL, NULL, 87419),
(87420, '1.25.10.10-FF-003130', NULL, 'Uncharacterized protein', 202, NULL, NULL, 87420),
(87421, '3.90.550.10-FF-000649', NULL, 'Si:ch211-135f11.5', 136, NULL, NULL, 87421),
(87422, '3.40.50.720-FF-000858', NULL, 'Phthiocerol synthesis polyketide synthase type I PpsA', 464, NULL, NULL, 87422),
(87423, '1.10.10.60-FF-001031', NULL, NULL, 52, NULL, NULL, 87423),
(87424, '3.40.50.300-FF-007219', NULL, 'Predicted protein', 164, NULL, NULL, 87424),
(87425, '2.60.120.10-FF-000734', NULL, 'Uncharacterized protein', 125, NULL, NULL, 87425),
(87426, '1.10.510.10-FF-002505', NULL, NULL, 106, NULL, NULL, 87426),
(87427, '1.20.1280.290-FF-000035', NULL, 'Solute carrier family 50 member 1', 41, NULL, NULL, 87427),
(87428, '2.130.10.10-FF-001042', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit', 86, NULL, NULL, 87428),
(87429, '3.40.120.10-FF-000061', NULL, 'Putative phosphoglucomutase cytoplasmic 1', 130, NULL, NULL, 87429),
(87430, '3.30.160.20-FF-000029', NULL, 'Peptidyl-tRNA hydrolase YaeJ', 138, NULL, NULL, 87430),
(87431, '3.40.50.300-FF-007747', NULL, 'Uncharacterized protein', 77, NULL, NULL, 87431),
(87432, '3.90.1180.10-FF-000007', NULL, '50S ribosomal protein L13', 158, NULL, NULL, 87432),
(87433, '2.10.25.10-FF-001470', NULL, 'Uncharacterized protein', 39, NULL, NULL, 87433),
(87434, '3.30.160.60-FF-003784', NULL, 'Zinc finger and BTB domain-containing protein 40', 24, NULL, NULL, 87434);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(87435, '3.20.20.80-FF-000392', NULL, 'Protein CBG22612', 267, NULL, NULL, 87435),
(87436, '1.20.120.1110-FF-000010', NULL, 'Uncharacterized protein', 111, NULL, NULL, 87436),
(87437, '1.10.20.10-FF-000286', NULL, NULL, 72, NULL, NULL, 87437),
(87438, '4.10.280.10-FF-000053', NULL, 'BHLH transcription factor', 65, NULL, NULL, 87438),
(87439, '3.40.50.720-FF-001477', NULL, 'Pyrroline-5-carboxylate reductase 3', 165, NULL, NULL, 87439),
(87440, '3.90.1310.10-FF-000024', NULL, 'Penicillin-binding protein 4B', 183, NULL, NULL, 87440),
(87441, '3.10.100.10-FF-000241', NULL, NULL, 147, NULL, NULL, 87441),
(87442, '3.30.160.60-FF-000564', NULL, 'zinc finger protein 699', 29, NULL, NULL, 87442),
(87443, '2.130.10.10-FF-000906', NULL, 'Autophagy-related protein 18b isoform A', 234, NULL, NULL, 87443),
(87444, '3.80.10.10-FF-001593', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 67, NULL, NULL, 87444),
(87445, '1.20.1560.10-FF-000369', NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 8', 146, NULL, NULL, 87445),
(87446, '3.40.50.150-FF-000536', NULL, 'Uncharacterized protein', 53, NULL, NULL, 87446),
(87447, '2.40.50.140-FF-001026', NULL, NULL, 40, NULL, NULL, 87447),
(87448, '1.10.8.530-FF-000001', NULL, 'DNA polymerase alpha subunit B', 78, NULL, NULL, 87448),
(87449, '1.10.472.10-FF-000235', NULL, 'Cyclin J, isoform A', 101, NULL, NULL, 87449),
(87450, '1.10.3210.10-FF-000008', NULL, '3''-5'' exoribonuclease YhaM', 178, NULL, NULL, 87450),
(87451, '3.40.50.300-FF-006910', NULL, 'Uncharacterized protein', 237, NULL, NULL, 87451),
(87452, '1.10.472.130-FF-000055', NULL, 'Predicted protein', 178, NULL, NULL, 87452),
(87453, '1.25.40.10-FF-002013', NULL, 'Pentatricopeptide repeat protein PPR868-14', 161, NULL, NULL, 87453),
(87454, '3.40.50.300-FF-002543', NULL, 'DEAD boX helicase homolog', 185, NULL, NULL, 87454),
(87455, '3.10.20.90-FF-000827', NULL, 'Ubiquitin family protein', 99, NULL, NULL, 87455),
(87456, '2.10.25.10-FF-001267', NULL, 'Predicted protein', 47, NULL, NULL, 87456),
(87457, '3.30.1370.110-FF-000017', NULL, 'Protein CBG07223', 99, NULL, NULL, 87457),
(87458, '3.40.50.1380-FF-000038', NULL, 'Predicted protein', 43, NULL, NULL, 87458),
(87459, '3.40.50.300-FF-007894', NULL, 'Uncharacterized protein', 191, NULL, NULL, 87459),
(87460, '2.130.10.10-FF-003998', NULL, 'Uncharacterized protein', 228, NULL, NULL, 87460),
(87461, '3.40.50.2300-FF-000404', NULL, 'Argonaut-like protein', 125, NULL, NULL, 87461),
(87462, '3.40.630.30-FF-000482', NULL, 'Slr1340 protein', 152, NULL, NULL, 87462),
(87463, '1.25.40.10-FF-002805', NULL, 'Uncharacterized protein', 161, NULL, NULL, 87463),
(87464, '2.30.29.30-FF-001404', NULL, 'Rho GTPase activating protein, putative', 115, NULL, NULL, 87464),
(87465, '3.40.630.10-FF-000291', NULL, 'N-acetylated alpha-linked acidic dipeptidase 2', 248, NULL, NULL, 87465),
(87466, '3.30.300.180-FF-000014', NULL, 'Chromosomal replication initiator protein DnaA', 73, NULL, NULL, 87466),
(87467, '1.20.1050.120-FF-000006', NULL, NULL, 125, NULL, NULL, 87467),
(87468, '3.30.50.10-FF-000030', NULL, 'Nuclear Hormone Receptor family', 106, NULL, NULL, 87468),
(87469, '3.10.20.90-FF-000266', NULL, 'Ubiquilin-1', 54, NULL, NULL, 87469),
(87470, '1.10.2000.10-FF-000088', NULL, NULL, 127, NULL, NULL, 87470),
(87471, '3.30.160.60-FF-005577', NULL, NULL, 40, NULL, NULL, 87471),
(87472, '3.10.20.90-FF-000451', NULL, 'ESX-3 secretion system protein EccD3', 88, NULL, NULL, 87472),
(87473, '3.50.50.60-FF-000774', NULL, 'Flavin-containing monooxygenase', 158, NULL, NULL, 87473),
(87474, '3.40.225.10-FF-000012', NULL, 'L-fuculose-1-phosphate aldolase', 212, NULL, NULL, 87474),
(87475, '1.10.150.110-FF-000037', NULL, 'Uncharacterized protein', 44, NULL, NULL, 87475),
(87476, '3.40.50.720-FF-001005', NULL, 'Molybdopterin and thiamine biosynthesis dinucleotide-utilizing enzyme', 202, NULL, NULL, 87476),
(87477, '3.40.50.300-FF-007399', NULL, 'Uncharacterized protein', 66, NULL, NULL, 87477),
(87478, '3.30.1230.20-FF-000001', NULL, '40S ribosomal protein S21', 82, NULL, NULL, 87478);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(87479, '3.10.20.230-FF-000010', NULL, 'Retinitis pigmentosa 1-like 1a', 85, NULL, NULL, 87479),
(87480, '3.40.50.720-FF-001819', NULL, 'Uncharacterized protein', 204, NULL, NULL, 87480),
(87481, '3.40.50.1820-FF-001435', NULL, 'Predicted protein', 194, NULL, NULL, 87481),
(87482, '3.40.1110.10-FF-000447', NULL, NULL, 152, NULL, NULL, 87482),
(87483, '2.130.10.10-FF-005887', NULL, 'AGAP013266-PA', 297, NULL, NULL, 87483),
(87484, '3.10.450.10-FF-000008', NULL, 'Kininogen 1', 104, NULL, NULL, 87484),
(87485, '3.30.1120.90-FF-000013', NULL, 'Uncharacterized protein', 204, NULL, NULL, 87485),
(87486, '3.40.50.2300-FF-001107', NULL, 'Metabotropic glutamate receptor', 268, NULL, NULL, 87486),
(87487, '2.80.10.50-FF-000207', NULL, 'Kunitz-type elastase inhibitor BrEI', 144, NULL, NULL, 87487),
(87488, '3.40.190.10-FF-000346', NULL, 'Transcriptional regulator, LysR family', 108, NULL, NULL, 87488),
(87489, '1.25.40.10-FF-004975', NULL, 'Uncharacterized protein', 149, NULL, NULL, 87489),
(87490, '3.30.930.10-FF-000153', NULL, 'Glycine-tRNA ligase', 12, NULL, NULL, 87490),
(87491, '3.30.1640.10-FF-000046', NULL, 'DNA helicase', 98, NULL, NULL, 87491),
(87492, '1.10.10.1740-FF-000002', NULL, 'Transmembrane protein 14C', 111, NULL, NULL, 87492),
(87493, '3.90.550.50-FF-000184', NULL, 'Uncharacterized protein', 225, NULL, NULL, 87493),
(87494, '3.30.70.260-FF-000148', NULL, 'Threonine dehydratase', 76, NULL, NULL, 87494),
(87495, '3.40.1110.10-FF-000228', NULL, NULL, 55, NULL, NULL, 87495),
(87496, '1.20.1280.50-FF-000011', NULL, 'F-box DNA helicase 1', 66, NULL, NULL, 87496),
(87497, '1.10.800.10-FF-000015', NULL, 'Tyrosine/tryptophan monooxygenase, putative', 45, NULL, NULL, 87497),
(87498, '1.25.10.10-FF-001005', NULL, 'Putative adaptin', 568, NULL, NULL, 87498),
(87499, '3.40.50.300-FF-000750', NULL, 'Putative ATP-dependent RNA helicase DHX33', 207, NULL, NULL, 87499),
(87500, '1.10.510.10-FF-004186', NULL, NULL, 241, NULL, NULL, 87500),
(87501, '3.30.300.10-FF-000015', NULL, 'S-adenosylmethionine synthase', 94, NULL, NULL, 87501),
(87502, '1.20.1250.20-FF-000949', NULL, 'High-affinity nicotinic acid transporter', 200, NULL, NULL, 87502),
(87503, '3.90.190.10-FF-000352', NULL, 'Protein tyrosine phosphatase-like protein egg-3', 294, NULL, NULL, 87503),
(87504, '3.40.190.10-FF-000599', NULL, 'Glutamate [NMDA] receptor subunit 3A, putative', 184, NULL, NULL, 87504),
(87505, '3.40.50.1820-FF-001654', NULL, 'Uncharacterized protein', 322, NULL, NULL, 87505),
(87506, '3.40.50.2300-FF-001023', NULL, NULL, 142, NULL, NULL, 87506),
(87507, '3.30.230.130-FF-000062', NULL, 'Cullin 1, putative', 153, NULL, NULL, 87507),
(87508, '2.60.40.10-FF-000912', NULL, 'Myeloid cell surface antigen CD33', 96, NULL, NULL, 87508),
(87509, '3.80.10.10-FF-001340', NULL, 'Si:ch211-213a13.2', 67, NULL, NULL, 87509),
(87510, '3.30.70.330-FF-003053', NULL, NULL, 112, NULL, NULL, 87510),
(87511, '2.60.210.10-FF-000056', NULL, NULL, 201, NULL, NULL, 87511),
(87512, '3.90.79.10-FF-000059', NULL, 'Nucleoside diphosphate-linked moiety X motif 13', 153, NULL, NULL, 87512),
(87513, '3.90.70.10-FF-000180', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 232, NULL, NULL, 87513),
(87514, '3.40.20.10-FF-000117', NULL, 'GMF family protein', 80, NULL, NULL, 87514),
(87515, '1.20.120.720-FF-000015', NULL, 'Myosin I', 113, NULL, NULL, 87515),
(87516, '1.10.3520.10-FF-000004', NULL, 'Glycolipid transfer protein 1', 201, NULL, NULL, 87516),
(87517, '3.30.70.20-FF-000135', NULL, NULL, 109, NULL, NULL, 87517),
(87518, '1.10.510.10-FF-002814', NULL, 'Uncharacterized protein', 294, NULL, NULL, 87518),
(87519, '3.30.70.330-FF-001501', NULL, NULL, 83, NULL, NULL, 87519),
(87520, '3.40.50.10810-FF-000225', NULL, 'DNA repair protein RAD5A', 56, NULL, NULL, 87520),
(87521, '1.10.238.10-FF-000180', NULL, 'Calcium-dependent protein kinase 4', 73, NULL, NULL, 87521),
(87522, '2.90.10.10-FF-000021', NULL, 'Serine/threonine-protein kinase', 130, NULL, NULL, 87522),
(87523, '2.30.30.140-FF-000350', NULL, 'Uncharacterized protein', 136, NULL, NULL, 87523),
(87524, '1.10.510.10-FF-004495', NULL, NULL, 232, NULL, NULL, 87524);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(87525, '2.160.20.70-FF-000025', NULL, 'Adenylyl cyclase-associated protein', 164, NULL, NULL, 87525),
(87526, '3.30.830.10-FF-000117', NULL, 'Mitochondrial Processing Peptidase Alpha', 223, NULL, NULL, 87526),
(87527, '1.20.1250.20-FF-001933', NULL, 'Putative drug resistence protein', 211, NULL, NULL, 87527),
(87528, '2.60.40.10-FF-003790', NULL, NULL, 118, NULL, NULL, 87528),
(87529, '3.90.180.10-FF-000076', NULL, 'Unplaced genomic scaffold supercont1.219, whole genome shotgun sequence', 168, NULL, NULL, 87529),
(87530, '3.40.50.970-FF-000208', NULL, 'Putative 2-dehydropantoate 2-reductase', 230, NULL, NULL, 87530),
(87531, '1.10.420.10-FF-000025', NULL, 'Peroxidase', 84, NULL, NULL, 87531),
(87532, '1.10.150.20-FF-000035', NULL, 'DNA polymerase gamma, mitochondrial', 168, NULL, NULL, 87532),
(87533, '2.40.128.20-FF-000057', NULL, 'Uncharacterized protein', 142, NULL, NULL, 87533),
(87534, '3.10.20.30-FF-000040', NULL, 'Putative GTP diphosphokinase RSH3, chloroplastic isoform D', 57, NULL, NULL, 87534),
(87535, '3.40.50.12710-FF-000036', NULL, 'Protein arginine methyltransferase NDUFAF7', 85, NULL, NULL, 87535),
(87536, '2.60.40.60-FF-000466', NULL, 'cadherin-89D', 102, NULL, NULL, 87536),
(87537, '1.25.10.10-FF-000168', NULL, 'LPS responsive beige-like anchor protein', 285, NULL, NULL, 87537),
(87538, '3.40.50.620-FF-000598', NULL, 'Tryptophan--tRNA ligase', 215, NULL, NULL, 87538),
(87539, '3.30.200.20-FF-001489', NULL, 'Protein kinase-like protein', 78, NULL, NULL, 87539),
(87540, '2.10.110.10-FF-000032', NULL, 'LIM/homeobox protein Lhx3', 74, NULL, NULL, 87540),
(87541, '4.10.860.120-FF-000030', NULL, 'DNA-directed RNA polymerase subunit', 106, NULL, NULL, 87541),
(87542, '3.20.180.20-FF-000044', NULL, 'Dynein heavy chain family protein', 82, NULL, NULL, 87542),
(87543, '3.80.10.10-FF-001677', NULL, 'Uncharacterized protein', 50, NULL, NULL, 87543),
(87544, '3.80.10.10-FF-002301', NULL, 'Centrosomal protein of 78 kDa', 200, NULL, NULL, 87544),
(87545, '3.40.50.150-FF-000772', NULL, 'O-methyltransferase tpcA', 277, NULL, NULL, 87545),
(87546, '1.20.1110.10-FF-000004', NULL, 'Sodium/potassium-transporting ATPase subunit alpha', 417, NULL, NULL, 87546),
(87547, '3.90.1210.10-FF-000005', NULL, NULL, 70, NULL, NULL, 87547),
(87548, '3.30.530.20-FF-000064', NULL, 'Lachrymatory-factor synthase', 157, NULL, NULL, 87548),
(87549, '1.10.10.60-FF-000103', NULL, 'Homeobox protein BarH-like 2', 76, NULL, NULL, 87549),
(87550, '3.40.395.10-FF-000007', NULL, 'sentrin-specific protease 5 isoform X2', 80, NULL, NULL, 87550),
(87551, '2.30.29.30-FF-000932', NULL, 'Wiscott-Aldrich syndrome protein', 129, NULL, NULL, 87551),
(87552, '2.130.10.10-FF-004931', NULL, 'Uncharacterized protein', 104, NULL, NULL, 87552),
(87553, '2.60.40.10-FF-001401', NULL, 'immunoglobulin-like and fibronectin type III domain-containing protein 1', 94, NULL, NULL, 87553),
(87554, '2.60.40.10-FF-003239', NULL, 'Uncharacterized protein', 87, NULL, NULL, 87554),
(87555, '3.40.120.10-FF-000089', NULL, 'Phosphomannomutase', 89, NULL, NULL, 87555),
(87556, '3.30.60.90-FF-000054', NULL, 'Uncharacterized protein', 71, NULL, NULL, 87556),
(87557, '1.10.8.60-FF-000439', NULL, 'YALI0C05038p', 72, NULL, NULL, 87557),
(87558, '3.20.20.300-FF-000012', NULL, 'Exported beta-glucosidase', 56, NULL, NULL, 87558),
(87559, '3.30.1360.200-FF-000003', NULL, 'Multifunctional fusion protein', 115, NULL, NULL, 87559),
(87560, '2.130.10.10-FF-001834', NULL, 'WD repeat containing protein 48', 113, NULL, NULL, 87560),
(87561, '3.30.420.40-FF-000606', NULL, 'Heat shock protein 70 putative', 191, NULL, NULL, 87561),
(87562, '1.50.10.150-FF-000016', NULL, 'C4-dicarboxylate transporter/malic acid transport protein', 343, NULL, NULL, 87562),
(87563, '2.70.150.10-FF-000223', NULL, 'Ca2+ transporting ATPase', 82, NULL, NULL, 87563),
(87564, '3.30.160.60-FF-002014', NULL, 'Zinc finger protein 835', 27, NULL, NULL, 87564),
(87565, '3.40.190.10-FF-000262', NULL, 'ABC transporter substrate-binding protein', 173, NULL, NULL, 87565),
(87566, '1.20.1730.10-FF-000096', NULL, 'Uncharacterized protein', 306, NULL, NULL, 87566);
INSERT INTO "PUBLIC"."MODEL" VALUES
(87567, '3.40.50.300-FF-000603', NULL, 'Sulfotransferase', 261, NULL, NULL, 87567),
(87568, '1.10.20.10-FF-000033', NULL, 'Transcription initiation factor TFIID complex subunit', 66, NULL, NULL, 87568),
(87569, '3.80.10.10-FF-003622', NULL, 'Leucine-rich repeat-containing G-protein coupled receptor, lgr, putative', 346, NULL, NULL, 87569),
(87570, '2.40.160.110-FF-000015', NULL, 'uncharacterized protein LOC100185667', 178, NULL, NULL, 87570),
(87571, '2.40.30.10-FF-000452', NULL, 'Eukaryotic translation initiation factor 2 gamma subunit, putative', 35, NULL, NULL, 87571),
(87572, '2.20.28.120-FF-000012', NULL, '50S ribosomal protein L33', 54, NULL, NULL, 87572),
(87573, '1.20.1080.10-FF-000006', NULL, 'Formate transporter FocA', 268, NULL, NULL, 87573),
(87574, '4.10.240.10-FF-000168', NULL, 'Zinc cluster DNA-binding protein, putative', 64, NULL, NULL, 87574),
(87575, '4.10.1110.10-FF-000004', NULL, 'AN1-type zinc finger protein 2B isoform X1', 77, NULL, NULL, 87575),
(87576, '3.40.140.10-FF-000074', NULL, 'Unplaced genomic scaffold supercont1.13, whole genome shotgun sequence', 148, NULL, NULL, 87576),
(87577, '1.10.238.10-FF-001141', NULL, 'Uncharacterized protein', 147, NULL, NULL, 87577),
(87578, '3.40.366.10-FF-000030', NULL, 'Putative polyketide synthase MbtD', 309, NULL, NULL, 87578),
(87579, '1.20.1250.20-FF-001585', NULL, 'MFS transporter, putative', 329, NULL, NULL, 87579),
(87580, '1.20.5.110-FF-000283', NULL, 'Vesicle-associated membrane protein 723', 103, NULL, NULL, 87580),
(87581, '2.30.30.1150-FF-000023', NULL, 'Uncharacterized protein', 130, NULL, NULL, 87581),
(87582, '2.10.70.10-FF-000247', NULL, 'Uncharacterized protein', 56, NULL, NULL, 87582),
(87583, '3.20.20.70-FF-000602', NULL, NULL, 212, NULL, NULL, 87583),
(87584, '1.10.555.10-FF-000219', NULL, NULL, 234, NULL, NULL, 87584),
(87585, '2.70.150.10-FF-000184', NULL, 'Plasma membrane calcium-transporting ATPase 2', 150, NULL, NULL, 87585),
(87586, '3.40.50.300-FF-001924', NULL, 'GTP-binding protein homolog', 185, NULL, NULL, 87586),
(87587, '3.40.50.2300-FF-000399', NULL, 'Taste 1 receptor member 1', 138, NULL, NULL, 87587),
(87588, '3.30.230.70-FF-000090', NULL, 'Uncharacterized protein', 279, NULL, NULL, 87588),
(87589, '3.90.70.10-FF-000556', NULL, 'Protein CBR-DUO-3', 377, NULL, NULL, 87589),
(87590, '1.20.920.20-FF-000002', NULL, 'Cytoplasmic dynein 1 heavy chain', 342, NULL, NULL, 87590),
(87591, '2.10.50.10-FF-000055', NULL, 'Cysteine repeat modular protein 2 PbCRM2', 62, NULL, NULL, 87591),
(87592, '1.20.1250.20-FF-000079', NULL, 'Probable sugar efflux transporter', 375, NULL, NULL, 87592),
(87593, '1.50.10.10-FF-000087', NULL, 'WGS project CABT00000000 data, contig 2.13', 337, NULL, NULL, 87593),
(87594, '3.90.1310.10-FF-000041', NULL, 'Penicillin-binding protein 2', 62, NULL, NULL, 87594),
(87595, '3.30.1370.10-FF-000047', NULL, 'splicing factor-like protein 1', 129, NULL, NULL, 87595),
(87596, '2.170.16.10-FF-000036', NULL, 'ATP-dependent DNA helicase Hel308', 56, NULL, NULL, 87596),
(87597, '3.30.63.20-FF-000006', NULL, '30S ribosomal protein S25e', 98, NULL, NULL, 87597),
(87598, '1.20.140.40-FF-000010', NULL, 'Pectinesterase', 162, NULL, NULL, 87598),
(87599, '1.10.8.250-FF-000001', NULL, 'DNA polymerase III, gamma subunit-related protein', 60, NULL, NULL, 87599),
(87600, '3.40.50.980-FF-000015', NULL, 'Luciferin 4-monooxygenase', 159, NULL, NULL, 87600),
(87601, '3.30.70.330-FF-000091', NULL, 'Polyadenylate-binding protein', 105, NULL, NULL, 87601),
(87602, '1.10.357.10-FF-000063', NULL, 'Transcriptional regulator, TetR family', 140, NULL, NULL, 87602),
(87603, '3.40.449.10-FF-000009', NULL, 'Uncharacterized protein', 120, NULL, NULL, 87603),
(87604, '1.10.510.10-FF-000240', NULL, 'Lectin-domain containing receptor kinase A4.3', 213, NULL, NULL, 87604),
(87605, '3.40.50.720-FF-002410', NULL, 'Uncharacterized protein', 191, NULL, NULL, 87605),
(87606, '3.30.70.1350-FF-000015', NULL, 'Cation diffusion facilitator family transporter', 95, NULL, NULL, 87606),
(87607, '2.40.50.140-FF-001043', NULL, NULL, 121, NULL, NULL, 87607);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(87608, '3.30.43.10-FF-000002', NULL, 'D-2-hydroxyglutarate dehydrogenase, mitochondrial', 100, NULL, NULL, 87608),
(87609, '2.170.240.10-FF-000009', NULL, 'Collagen, type IV, alpha 3', 77, NULL, NULL, 87609),
(87610, '2.30.42.10-FF-000114', NULL, 'protein scribble homolog isoform X1', 94, NULL, NULL, 87610),
(87611, '3.40.30.10-FF-000415', NULL, 'AhpC/TSA family protein', 151, NULL, NULL, 87611),
(87612, '2.60.40.640-FF-000107', NULL, 'Predicted protein', 129, NULL, NULL, 87612),
(87613, '3.30.300.30-FF-000010', NULL, 'Enterobactin synthetase component F', 104, NULL, NULL, 87613),
(87614, '1.25.40.20-FF-001089', NULL, 'VPS9 domain protein, putative (AFU_orthologue AFUA_1G09870)', 95, NULL, NULL, 87614),
(87615, '2.30.30.40-FF-000534', NULL, 'Brain-specific angiogenesis inhibitor 1-associated protein 2', 61, NULL, NULL, 87615),
(87616, '3.30.450.40-FF-000203', NULL, 'Adenylyl cyclase class-3/4/guanylyl cyclase', 169, NULL, NULL, 87616),
(87617, '3.30.70.20-FF-000051', NULL, 'Periplasmic [Fe] hydrogenase', 57, NULL, NULL, 87617),
(87618, '3.30.830.10-FF-000084', NULL, 'Cym1p', 259, NULL, NULL, 87618),
(87619, '1.25.40.10-FF-002244', NULL, 'Pentatricopeptide (PPR) repeat protein-like', 148, NULL, NULL, 87619),
(87620, '3.40.50.300-FF-002312', NULL, 'GPN-loop GTPase 3', 277, NULL, NULL, 87620),
(87621, '4.10.860.10-FF-000024', NULL, NULL, 39, NULL, NULL, 87621),
(87622, '3.40.50.300-FF-005494', NULL, 'ATP-dependent DEAD/H RNA helicase, putative', 190, NULL, NULL, 87622),
(87623, '1.20.58.90-FF-000019', NULL, 'TSNARE that affects a late Golgi compartment', 95, NULL, NULL, 87623),
(87624, '1.20.5.190-FF-000048', NULL, 'IQ motif containing B1', 57, NULL, NULL, 87624),
(87625, '1.10.240.10-FF-000005', NULL, 'Tryptophan--tRNA ligase', 108, NULL, NULL, 87625),
(87626, '2.60.120.260-FF-000042', NULL, 'Reelin', 162, NULL, NULL, 87626),
(87627, '1.20.1560.10-FF-000740', NULL, 'Uncharacterized protein', 157, NULL, NULL, 87627),
(87628, '1.50.40.10-FF-000488', NULL, 'Uncharacterized protein', 275, NULL, NULL, 87628),
(87629, '3.20.20.450-FF-000006', NULL, 'Cyclic diguanylate phosphodiesterase (EAL) domain protein', 232, NULL, NULL, 87629),
(87630, '3.30.420.10-FF-000743', NULL, NULL, 135, NULL, NULL, 87630),
(87631, '1.20.1250.20-FF-001332', NULL, 'Uncharacterized protein', 251, NULL, NULL, 87631),
(87632, '3.30.420.110-FF-000003', NULL, 'mutS protein homolog 4', 159, NULL, NULL, 87632),
(87633, '2.10.25.10-FF-000542', NULL, 'Laminin-like protein epi-1', 48, NULL, NULL, 87633),
(87634, '3.80.10.10-FF-002897', NULL, 'Uncharacterized protein', 196, NULL, NULL, 87634),
(87635, '3.30.470.20-FF-000210', NULL, 'Uncharacterized protein', 165, NULL, NULL, 87635),
(87636, '2.130.10.10-FF-005095', NULL, 'WD repeat-containing protein 48 homolog', 255, NULL, NULL, 87636),
(87637, '2.130.10.10-FF-004476', NULL, 'Striatin', 57, NULL, NULL, 87637),
(87638, '3.30.930.10-FF-000136', NULL, 'Lysine--tRNA ligase', 368, NULL, NULL, 87638),
(87639, '1.25.10.10-FF-001112', NULL, 'RING-type E3 ubiquitin transferase', 99, NULL, NULL, 87639),
(87640, '3.40.850.10-FF-000285', NULL, 'Si:dkey-26i13.8', 121, NULL, NULL, 87640),
(87641, '2.80.10.50-FF-000247', NULL, 'Putative polypeptide N-acetylgalactosaminyltransferase 11', 70, NULL, NULL, 87641),
(87642, '3.90.150.10-FF-000012', NULL, 'Serum resistance associated protein', 69, NULL, NULL, 87642),
(87643, '3.40.50.1000-FF-000413', NULL, 'Cytosolic IMP-GMP specific 5''-nucleotidase', 203, NULL, NULL, 87643),
(87644, '1.10.8.270-FF-000007', NULL, 'TBC1 domain family member 10A', 102, NULL, NULL, 87644),
(87645, '3.80.10.10-FF-001368', NULL, 'Leucine-rich repeat receptor-like protein CLAVATA2', 170, NULL, NULL, 87645),
(87646, '3.50.50.60-FF-000083', NULL, 'Geranylgeranyl diphosphate reductase', 396, NULL, NULL, 87646),
(87647, '3.30.160.60-FF-001289', NULL, 'Zinc finger protein 574', 29, NULL, NULL, 87647),
(87648, '3.40.190.10-FF-000571', NULL, 'Oligopeptide ABC transporter, periplasmic oligopeptide-binding protein', 28, NULL, NULL, 87648),
(87649, '1.10.8.20-FF-000006', NULL, 'Phosphatidylinositol/phosphatidylcholine transfer protein SFH3', 95, NULL, NULL, 87649);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(87650, '3.30.160.60-FF-002379', NULL, NULL, 28, NULL, NULL, 87650),
(87651, '1.25.40.10-FF-002721', NULL, 'Pentatricopeptide repeat domain 3', 293, NULL, NULL, 87651),
(87652, '3.40.50.1820-FF-000687', NULL, 'Alpha/beta hydrolase', 251, NULL, NULL, 87652),
(87653, '2.130.10.10-FF-002346', NULL, 'Transcriptional activator SPT8', 208, NULL, NULL, 87653),
(87654, '1.20.58.1210-FF-000009', NULL, 'Exocyst complex component EXO84', 145, NULL, NULL, 87654),
(87655, '1.10.3380.10-FF-000032', NULL, 'Uncharacterized protein', 153, NULL, NULL, 87655),
(87656, '2.120.10.80-FF-000046', NULL, 'F-box/kelch-repeat protein At5g15710', 283, NULL, NULL, 87656),
(87657, '3.40.50.620-FF-000020', NULL, 'Valine--tRNA ligase, mitochondrial', 199, NULL, NULL, 87657),
(87658, '2.40.10.10-FF-000366', NULL, NULL, 66, NULL, NULL, 87658),
(87659, '3.40.50.2020-FF-000045', NULL, 'Phosphoribosyl pyrophosphate synthetase 2', 35, NULL, NULL, 87659),
(87660, '1.10.630.10-FF-000507', NULL, 'Uncharacterized protein', 431, NULL, NULL, 87660),
(87661, '3.40.50.10260-FF-000015', NULL, 'Multifunctional fusion protein', 212, NULL, NULL, 87661),
(87662, '1.10.1070.11-FF-000009', NULL, 'Putative serine/threonine-protein kinase ATR', 181, NULL, NULL, 87662),
(87663, '3.30.1330.30-FF-000079', NULL, 'tRNA/rRNA metyltransferase', 79, NULL, NULL, 87663),
(87664, '1.10.10.10-FF-001640', NULL, 'RNA polymerase sigma70 factor', 84, NULL, NULL, 87664),
(87665, '1.20.5.620-FF-000003', NULL, 'ATP synthase subunit b', 59, NULL, NULL, 87665),
(87666, '2.130.10.10-FF-000800', NULL, 'Related to S. pombe beta-transducin', 11, NULL, NULL, 87666),
(87667, '3.40.50.620-FF-000492', NULL, 'Blr2135 protein', 338, NULL, NULL, 87667),
(87668, '3.10.350.10-FF-000068', NULL, 'Cell wall glycyl-glycine endopeptidase, putative', 53, NULL, NULL, 87668),
(87669, '3.40.50.300-FF-004982', NULL, 'Deoxythymidylate kinase', 95, NULL, NULL, 87669),
(87670, '3.30.70.2460-FF-000011', NULL, NULL, 60, NULL, NULL, 87670),
(87671, '1.20.1070.10-FF-000758', NULL, 'cadherin EGF LAG seven-pass G-type receptor 2 isoform X2', 272, NULL, NULL, 87671),
(87672, '3.10.20.90-FF-000373', NULL, 'Splicing factor 3A subunit 1', 107, NULL, NULL, 87672),
(87673, '1.25.40.450-FF-000010', NULL, 'LOW QUALITY PROTEIN: nuclear pore complex protein Nup155', 180, NULL, NULL, 87673),
(87674, '2.80.10.50-FF-000090', NULL, 'Kunitz-type inhibitor B', 188, NULL, NULL, 87674),
(87675, '1.20.1060.20-FF-000008', NULL, 'Structural maintenance of chromosomes protein', 68, NULL, NULL, 87675),
(87676, '3.30.710.10-FF-000389', NULL, 'Transcription factor Ken 2', 130, NULL, NULL, 87676),
(87677, '3.90.640.10-FF-000078', NULL, 'Conserved hypothetical proline and threonine rich protein', 78, NULL, NULL, 87677),
(87678, '1.10.30.10-FF-000112', NULL, 'Transcription factor 7-like 2', 84, NULL, NULL, 87678),
(87679, '3.40.50.10810-FF-000011', NULL, 'Transcriptional regulator ATRX homolog', 289, NULL, NULL, 87679),
(87680, '2.60.40.60-FF-000775', NULL, 'Uncharacterized protein', 109, NULL, NULL, 87680),
(87681, '2.160.20.10-FF-000119', NULL, 'Polygalacturonase', 428, NULL, NULL, 87681),
(87682, '3.40.190.10-FF-000947', NULL, 'Uncharacterized protein', 11, NULL, NULL, 87682),
(87683, '2.170.270.10-FF-000146', NULL, 'Histone-lysine N-methyltransferase', 261, NULL, NULL, 87683),
(87684, '1.20.144.10-FF-000139', NULL, 'Predicted protein', 257, NULL, NULL, 87684),
(87685, '3.90.980.20-FF-000027', NULL, NULL, 141, NULL, NULL, 87685),
(87686, '3.30.830.10-FF-000191', NULL, 'Uncharacterized protein', 224, NULL, NULL, 87686),
(87687, '1.20.120.80-FF-000009', NULL, 'Cytochrome c oxidase, subunit III', 181, NULL, NULL, 87687),
(87688, '3.20.20.80-FF-000375', NULL, 'Glycoside hydrolase family 5', 334, NULL, NULL, 87688),
(87689, '2.10.70.10-FF-000163', NULL, 'C-type LECtin', 62, NULL, NULL, 87689),
(87690, '3.30.70.60-FF-000012', NULL, 'Translation elongation factor EF1B/ribosomal protein S6 family protein', 115, NULL, NULL, 87690),
(87691, '3.90.80.10-FF-000017', NULL, 'Inorganic pyrophosphatase, putative', 236, NULL, NULL, 87691);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(87692, '1.25.40.10-FF-004374', NULL, 'Pentatricopeptide repeat-containing protein At3g47530', 148, NULL, NULL, 87692),
(87693, '1.20.140.100-FF-000013', NULL, 'Dynein heavy chain 10, axonemal', 153, NULL, NULL, 87693),
(87694, '3.30.70.330-FF-002917', NULL, NULL, 129, NULL, NULL, 87694),
(87695, '2.30.29.30-FF-000140', NULL, 'CDC42 binding protein kinase beta', 117, NULL, NULL, 87695),
(87696, '1.20.5.4130-FF-000003', NULL, 'Pi-ta protein', 130, NULL, NULL, 87696),
(87697, '2.160.20.10-FF-000030', NULL, 'Pectinesterase', 308, NULL, NULL, 87697),
(87698, '3.40.1260.10-FF-000003', NULL, 'DsrE/DsrF-like family protein', 117, NULL, NULL, 87698),
(87699, '3.30.470.30-FF-000011', NULL, 'mRNA-capping enzyme subunit alpha', 236, NULL, NULL, 87699),
(87700, '3.30.70.330-FF-000776', NULL, 'Peptidyl-prolyl cis-trans isomerase E', 87, NULL, NULL, 87700),
(87701, '1.10.238.10-FF-000899', NULL, 'Uncharacterized protein', 133, NULL, NULL, 87701),
(87702, '3.80.10.10-FF-001913', NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', 89, NULL, NULL, 87702),
(87703, '1.10.3730.20-FF-000040', NULL, 'Putative integral membrane protein', 106, NULL, NULL, 87703),
(87704, '3.70.10.10-FF-000042', NULL, 'DNA polymerase processivity factor BMRF1', 314, NULL, NULL, 87704),
(87705, '2.60.40.640-FF-000096', NULL, 'YALI0E29381p', 179, NULL, NULL, 87705),
(87706, '1.10.1370.30-FF-000031', NULL, 'Angiotensin-converting enzyme', 257, NULL, NULL, 87706),
(87707, '2.60.40.10-FF-002694', NULL, 'Obscurin', 66, NULL, NULL, 87707),
(87708, '3.30.1120.30-FF-000001', NULL, 'Serine/threonine-protein kinase PLK', 97, NULL, NULL, 87708),
(87709, '1.10.20.10-FF-000264', NULL, NULL, 50, NULL, NULL, 87709),
(87710, '1.10.287.110-FF-000464', NULL, 'AGAP006577-PA', 85, NULL, NULL, 87710),
(87711, '1.10.533.10-FF-000276', NULL, 'Predicted protein', 96, NULL, NULL, 87711),
(87712, '2.60.120.620-FF-000054', NULL, 'Prolyl 4-hydroxylase subunit alpha-1', 231, NULL, NULL, 87712),
(87713, '3.30.160.60-FF-000581', NULL, 'zinc finger protein 346 isoform X1', 59, NULL, NULL, 87713),
(87714, '3.10.105.10-FF-000105', NULL, 'Putative ABC transporter solute binding lipoprotein', 209, NULL, NULL, 87714),
(87715, '1.25.10.10-FF-000387', NULL, 'Uncharacterized protein, isoform B', 263, NULL, NULL, 87715),
(87716, '1.20.1110.10-FF-000021', NULL, 'Plasma membrane ATPase', 48, NULL, NULL, 87716),
(87717, '1.10.287.70-FF-000058', NULL, 'Potassium sodium-activated channel subfamily T member 2', 110, NULL, NULL, 87717),
(87718, '3.30.200.20-FF-000056', NULL, 'Fibrillarin like 1', 56, NULL, NULL, 87718),
(87719, '1.10.510.10-FF-001544', NULL, 'Protein CBG12075', 295, NULL, NULL, 87719),
(87720, '3.40.50.2300-FF-001551', NULL, NULL, 26, NULL, NULL, 87720),
(87721, '2.40.40.20-FF-000051', NULL, 'Probable oxidoreductase YyaE', 129, NULL, NULL, 87721),
(87722, '2.10.90.10-FF-000176', NULL, 'Uncharacterized protein', 106, NULL, NULL, 87722),
(87723, '2.40.30.10-FF-000002', NULL, 'Elongation factor Tu', 93, NULL, NULL, 87723),
(87724, '3.40.20.10-FF-000134', NULL, 'TWF1 isoform 4', 78, NULL, NULL, 87724),
(87725, '1.20.1070.10-FF-001377', NULL, 'Uncharacterized protein', 253, NULL, NULL, 87725),
(87726, '1.20.900.10-FF-000127', NULL, 'Uncharacterized protein', 88, NULL, NULL, 87726),
(87727, '3.40.50.300-FF-005746', NULL, 'Dynein-1-beta heavy chain, flagellar inner arm I1 complex', 143, NULL, NULL, 87727),
(87728, '1.10.510.10-FF-003798', NULL, NULL, 124, NULL, NULL, 87728),
(87729, '3.90.1150.10-FF-000489', NULL, 'Aspartate aminotransferase', 18, NULL, NULL, 87729),
(87730, '3.30.450.40-FF-000310', NULL, 'Phosphodiesterase', 66, NULL, NULL, 87730),
(87731, '4.10.240.10-FF-000185', NULL, 'YALI0F13321p', 86, NULL, NULL, 87731),
(87732, '3.90.1150.10-FF-000034', NULL, 'Cysteine desulfurase', 127, NULL, NULL, 87732),
(87733, '3.30.750.24-FF-000034', NULL, 'Sulfate anion transporter 1', 144, NULL, NULL, 87733),
(87734, '3.30.70.330-FF-000411', NULL, 'Polyadenylate-binding protein', 109, NULL, NULL, 87734),
(87735, '3.80.10.10-FF-001149', NULL, 'Relaxin family peptide receptor 1', 145, NULL, NULL, 87735);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(87736, '1.20.120.350-FF-000073', NULL, 'Two pore segment channel 2', 144, NULL, NULL, 87736),
(87737, '3.90.1290.10-FF-000072', NULL, 'Uncharacterized protein', 142, NULL, NULL, 87737),
(87738, '3.30.200.20-FF-001258', NULL, NULL, 92, NULL, NULL, 87738),
(87739, '1.10.287.110-FF-000340', NULL, 'DnaJ-like protein subfamily C member 28', 70, NULL, NULL, 87739),
(87740, '3.10.180.10-FF-000105', NULL, '4-hydroxyphenylpyruvate dioxygenase', 169, NULL, NULL, 87740),
(87741, '1.20.920.10-FF-000089', NULL, 'WD40 domain-containing protein', 107, NULL, NULL, 87741),
(87742, '1.10.400.10-FF-000007', NULL, 'Guanine nucleotide-binding protein subunit alpha', 120, NULL, NULL, 87742),
(87743, '3.40.50.300-FF-001907', NULL, 'Uncharacterized protein', 244, NULL, NULL, 87743),
(87744, '2.70.98.10-FF-000084', NULL, 'Rhamnogalacturonate lyase', 244, NULL, NULL, 87744),
(87745, '3.30.565.10-FF-000107', NULL, 'Histidine kinase', 157, NULL, NULL, 87745),
(87746, '2.40.160.120-FF-000035', NULL, 'Oxysterol binding protein, putative', 179, NULL, NULL, 87746),
(87747, '2.20.80.10-FF-000006', NULL, 'Apolipophorins', 228, NULL, NULL, 87747),
(87748, '3.40.50.300-FF-002060', NULL, 'Rho family GTPase', 180, NULL, NULL, 87748),
(87749, '3.40.50.720-FF-001027', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', 185, NULL, NULL, 87749),
(87750, '3.30.830.10-FF-000336', NULL, 'Os01g0779100 protein', 44, NULL, NULL, 87750),
(87751, '1.10.510.10-FF-003202', NULL, NULL, 146, NULL, NULL, 87751),
(87752, '3.30.40.10-FF-001939', NULL, 'Predicted protein', 69, NULL, NULL, 87752),
(87753, '3.40.1550.10-FF-000014', NULL, NULL, 157, NULL, NULL, 87753),
(87754, '3.80.10.10-FF-000749', NULL, 'F-box and leucine rich repeat protein 18', 168, NULL, NULL, 87754),
(87755, '3.30.530.20-FF-000142', NULL, 'Predicted protein', 211, NULL, NULL, 87755),
(87756, '1.20.1250.20-FF-001113', NULL, 'Major facilitator superfamily permease', 371, NULL, NULL, 87756),
(87757, '3.40.50.150-FF-001250', NULL, NULL, 209, NULL, NULL, 87757),
(87758, '1.25.40.10-FF-001625', NULL, 'Pentatricopeptide repeat-containing protein', 182, NULL, NULL, 87758),
(87759, '1.20.120.1510-FF-000006', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 112, NULL, NULL, 87759),
(87760, '1.10.135.10-FF-000019', NULL, 'Uncharacterized protein', 61, NULL, NULL, 87760),
(87761, '1.10.490.10-FF-000052', NULL, 'Uncharacterized protein', 74, NULL, NULL, 87761),
(87762, '3.30.230.130-FF-000045', NULL, 'Uncharacterized protein', 183, NULL, NULL, 87762),
(87763, '1.10.3090.10-FF-000021', NULL, 'Uncharacterized protein', 217, NULL, NULL, 87763),
(87764, '1.25.10.10-FF-002641', NULL, 'Uncharacterized protein', 119, NULL, NULL, 87764),
(87765, '2.40.30.10-FF-000221', NULL, '50S ribosome-binding GTPase', 94, NULL, NULL, 87765),
(87766, '1.20.120.880-FF-000001', NULL, 'PAS domain-containing sensor histidine kinase', 130, NULL, NULL, 87766),
(87767, '1.10.510.10-FF-000925', NULL, 'PEK protein kinase', 216, NULL, NULL, 87767),
(87768, '3.30.1520.10-FF-000099', NULL, 'Differentiation inhibitory kinase', 136, NULL, NULL, 87768),
(87769, '3.40.50.300-FF-005185', NULL, 'Protein CBR-XBX-1', 216, NULL, NULL, 87769),
(87770, '3.30.420.10-FF-000378', NULL, NULL, 189, NULL, NULL, 87770),
(87771, '3.30.565.10-FF-000096', NULL, 'Anti-sigma regulatory factor', 141, NULL, NULL, 87771),
(87772, '3.40.50.1820-FF-001199', NULL, 'Uncharacterized protein', 111, NULL, NULL, 87772),
(87773, '2.10.25.10-FF-001812', NULL, 'Uncharacterized protein', 30, NULL, NULL, 87773),
(87774, '3.40.50.2000-FF-000303', NULL, 'GDP-mannose-dependent alpha-mannosyltransferase', 153, NULL, NULL, 87774),
(87775, '2.60.120.290-FF-000146', NULL, 'GD12774', 124, NULL, NULL, 87775),
(87776, '3.40.50.1820-FF-001519', NULL, 'Senescence-associated carboxylesterase 101', 149, NULL, NULL, 87776),
(87777, '3.30.590.10-FF-000036', NULL, 'Type-3 glutamine synthetase', 332, NULL, NULL, 87777),
(87778, '2.60.120.970-FF-000052', NULL, 'Inhibin alpha chain', 206, NULL, NULL, 87778),
(87779, '3.30.160.60-FF-004268', NULL, NULL, 37, NULL, NULL, 87779);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(87780, '3.30.40.10-FF-001254', NULL, 'Apoptosis inhibitor IAP, putative', 64, NULL, NULL, 87780),
(87781, '3.30.450.50-FF-000004', NULL, 'vesicle-trafficking protein SEC22b', 127, NULL, NULL, 87781),
(87782, '3.30.70.330-FF-003070', NULL, NULL, 103, NULL, NULL, 87782),
(87783, '1.20.58.60-FF-000696', NULL, 'Predicted protein', 112, NULL, NULL, 87783),
(87784, '1.25.40.400-FF-000001', NULL, 'DNA-binding helix-turn-helix protein', 234, NULL, NULL, 87784),
(87785, '1.10.8.50-FF-000021', NULL, 'Endonuclease', 136, NULL, NULL, 87785),
(87786, '3.30.565.10-FF-000416', NULL, 'Hybrid signal transduction histidine kinase C', 177, NULL, NULL, 87786),
(87787, '1.10.1410.20-FF-000009', NULL, 'Predicted protein', 151, NULL, NULL, 87787),
(87788, '2.102.10.10-FF-000043', NULL, 'Ferredoxin component', 116, NULL, NULL, 87788),
(87789, '4.10.280.10-FF-000075', NULL, 'Transcription factor bHLH113 family', 77, NULL, NULL, 87789),
(87790, '1.10.3810.10-FF-000015', NULL, 'Probable transglycosylase', 209, NULL, NULL, 87790),
(87791, '1.25.40.1040-FF-000038', NULL, 'Uncharacterized protein', 514, NULL, NULL, 87791),
(87792, '3.40.50.880-FF-000064', NULL, 'Imidazole glycerol phosphate synthase subunit HisH', 190, NULL, NULL, 87792),
(87793, '1.10.287.110-FF-000008', NULL, 'Co-chaperone protein HscB', 79, NULL, NULL, 87793),
(87794, '3.30.160.60-FF-005892', NULL, NULL, 28, NULL, NULL, 87794),
(87795, '3.30.70.270-FF-000168', NULL, NULL, 86, NULL, NULL, 87795),
(87796, '1.10.10.10-FF-000004', NULL, 'RNA polymerase sigma factor SigA', 84, NULL, NULL, 87796),
(87797, '3.90.550.10-FF-000104', NULL, 'procollagen-lysine,2-oxoglutarate 5-dioxygenase 2 isoform X3', 151, NULL, NULL, 87797),
(87798, '3.40.50.2000-FF-000051', NULL, 'Glycosyltransferase', 198, NULL, NULL, 87798),
(87799, '3.30.450.20-FF-000355', NULL, 'Two-component sensor kinase', 134, NULL, NULL, 87799),
(87800, '1.10.520.10-FF-000050', NULL, 'Uncharacterized protein', 66, NULL, NULL, 87800),
(87801, '2.60.40.10-FF-003346', NULL, 'Receptor-type tyrosine-protein phosphatase C', 94, NULL, NULL, 87801),
(87802, '1.10.238.10-FF-000972', NULL, 'Calcium-dependent protein kinase, putative', 86, NULL, NULL, 87802),
(87803, '2.60.40.420-FF-000013', NULL, 'basic blue protein-like', 95, NULL, NULL, 87803),
(87804, '3.90.480.20-FF-000006', NULL, 'Sulfite reductase (Ferredoxin)', 144, NULL, NULL, 87804),
(87805, '2.40.50.90-FF-000201', NULL, 'Transcriptional coactivator-like protein', 30, NULL, NULL, 87805),
(87806, '3.30.40.10-FF-001378', NULL, 'BcDNA.GH10646', 78, NULL, NULL, 87806),
(87807, '3.30.160.60-FF-000125', NULL, 'Putative zinc finger protein 143', 31, NULL, NULL, 87807),
(87808, '1.25.40.10-FF-003446', NULL, 'Pentatricopeptide repeat-containing protein', 145, NULL, NULL, 87808),
(87809, '1.20.1070.10-FF-000197', NULL, 'Teleost multiple tissue opsin 2b', 316, NULL, NULL, 87809),
(87810, '3.30.505.10-FF-000064', NULL, 'src-like-adapter 2 isoform X2', 102, NULL, NULL, 87810),
(87811, '3.10.20.90-FF-000934', NULL, 'Uncharacterized protein', 79, NULL, NULL, 87811),
(87812, '3.40.1390.10-FF-000012', NULL, 'UDP-3-O-acylglucosamine N-acyltransferase', 98, NULL, NULL, 87812),
(87813, '3.30.70.330-FF-002884', NULL, NULL, 62, NULL, NULL, 87813),
(87814, '3.40.1390.30-FF-000018', NULL, 'Nif3-related protein', 96, NULL, NULL, 87814),
(87815, '3.40.50.300-FF-003240', NULL, 'Dicer-like protein 1', 166, NULL, NULL, 87815),
(87816, '3.30.450.80-FF-000002', NULL, 'DNA-binding transcriptional activator SdiA', 176, NULL, NULL, 87816),
(87817, '3.90.550.10-FF-000560', NULL, 'Predicted protein', 159, NULL, NULL, 87817),
(87818, '3.40.50.300-FF-000834', NULL, 'Multidrug ABC transporter ATP-binding protein', 245, NULL, NULL, 87818),
(87819, '3.30.160.60-FF-002273', NULL, 'Zinc finger protein', 29, NULL, NULL, 87819),
(87820, '1.10.510.10-FF-002494', NULL, NULL, 56, NULL, NULL, 87820),
(87821, '1.10.287.460-FF-000006', NULL, 'Peptidyl-prolyl cis-trans isomerase Mip', 102, NULL, NULL, 87821),
(87822, '2.60.40.1120-FF-000081', NULL, 'Uncharacterized protein', 49, NULL, NULL, 87822);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(87823, '1.20.58.830-FF-000026', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 137, NULL, NULL, 87823),
(87824, '1.10.8.10-FF-000256', NULL, 'Uncharacterized protein', 61, NULL, NULL, 87824),
(87825, '2.130.10.10-FF-002907', NULL, 'Uncharacterized protein', 183, NULL, NULL, 87825),
(87826, '3.30.70.120-FF-000011', NULL, 'CutA divalent cation tolerance homolog-like', 120, NULL, NULL, 87826),
(87827, '3.80.10.10-FF-004010', NULL, 'Uncharacterized protein', 149, NULL, NULL, 87827),
(87828, '3.40.1810.10-FF-000040', NULL, 'Uncharacterized protein', 53, NULL, NULL, 87828),
(87829, '3.30.160.60-FF-001997', NULL, 'Uncharacterized protein', 28, NULL, NULL, 87829),
(87830, '3.30.70.330-FF-002209', NULL, NULL, 105, NULL, NULL, 87830),
(87831, '1.10.620.20-FF-000015', NULL, 'Ribonucleotide reductase M2 b', 316, NULL, NULL, 87831),
(87832, '2.120.10.30-FF-000391', NULL, 'Low-density lipoprotein RecePtor related', 276, NULL, NULL, 87832),
(87833, '3.80.10.10-FF-001604', NULL, 'Serine-threonine protein kinase plant-type', 105, NULL, NULL, 87833),
(87834, '1.10.3720.10-FF-000132', NULL, 'ABC transporter permease subunit', 191, NULL, NULL, 87834),
(87835, '1.10.10.10-FF-000313', NULL, 'double-stranded RNA-specific adenosine deaminase isoform X4', 76, NULL, NULL, 87835),
(87836, '3.90.226.10-FF-000161', NULL, '3-methylcrotonoyl-CoA carboxylase beta subunit, putative', 255, NULL, NULL, 87836),
(87837, '3.30.1380.10-FF-000003', NULL, 'D-alanyl-D-alanine dipeptidase', 173, NULL, NULL, 87837),
(87838, '3.10.580.10-FF-000186', NULL, 'Chloride channel protein', 113, NULL, NULL, 87838),
(87839, '2.40.50.140-FF-000059', NULL, 'S1 RNA binding protein', 76, NULL, NULL, 87839),
(87840, '1.10.10.10-FF-002022', NULL, 'Heat shock transcription factor, putative', 107, NULL, NULL, 87840),
(87841, '2.40.480.10-FF-000001', NULL, 'Allene oxide cyclase, chloroplastic', 188, NULL, NULL, 87841),
(87842, '2.10.25.10-FF-000851', NULL, 'Slit homolog 1 protein', 39, NULL, NULL, 87842),
(87843, '1.20.58.60-FF-000567', NULL, 'AGAP007562-PA', 279, NULL, NULL, 87843),
(87844, '3.80.10.10-FF-002773', NULL, 'Uncharacterized protein', 68, NULL, NULL, 87844),
(87845, '3.30.200.20-FF-000308', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 4', 104, NULL, NULL, 87845),
(87846, '1.10.8.1310-FF-000003', NULL, 'Uncharacterized protein', 143, NULL, NULL, 87846),
(87847, '1.25.40.10-FF-001316', NULL, 'Transmembrane and tetratricopeptide repeat containing 2', 61, NULL, NULL, 87847),
(87848, '3.90.470.10-FF-000031', NULL, '60S ribosomal protein L17-2', 123, NULL, NULL, 87848),
(87849, '3.40.1380.20-FF-000043', NULL, 'Pyruvate kinase', 138, NULL, NULL, 87849),
(87850, '2.30.30.40-FF-000225', NULL, 'Phosphonoacetate hydrolase', 72, NULL, NULL, 87850),
(87851, '3.20.20.70-FF-000624', NULL, NULL, 293, NULL, NULL, 87851),
(87852, '1.20.120.1910-FF-000042', NULL, 'Cysteinyl-tRNA synthetase, putative', 183, NULL, NULL, 87852),
(87853, '1.10.555.10-FF-000113', NULL, 'Glucosamine 6-phosphate N-acetyltransferase', 209, NULL, NULL, 87853),
(87854, '3.90.45.10-FF-000026', NULL, 'Peptide deformylase', 153, NULL, NULL, 87854),
(87855, '2.40.50.100-FF-000109', NULL, 'DNA-directed RNA polymerase subunit beta''', 64, NULL, NULL, 87855),
(87856, '4.10.1000.10-FF-000119', NULL, 'Predicted protein', 66, NULL, NULL, 87856),
(87857, '2.60.40.10-FF-002727', NULL, 'Muscle M-line assembly protein unc-89', 94, NULL, NULL, 87857),
(87858, '3.40.50.150-FF-001626', NULL, NULL, 242, NULL, NULL, 87858),
(87859, '3.40.50.10190-FF-000224', NULL, 'DNA repair protein, BRCT domain', 96, NULL, NULL, 87859),
(87860, '1.20.1310.10-FF-000132', NULL, NULL, 121, NULL, NULL, 87860),
(87861, '2.30.42.10-FF-000423', NULL, NULL, 96, NULL, NULL, 87861),
(87862, '1.20.1070.10-FF-001158', NULL, 'G-protein coupled receptor moody', 343, NULL, NULL, 87862),
(87863, '2.60.40.4100-FF-000002', NULL, 'Zona pellucida sperm-binding protein 3', 162, NULL, NULL, 87863),
(87864, '3.40.50.1980-FF-000016', NULL, 'Fe(3+)-hydroxamate ABC transporter substrate-binding protein FhuD', 91, NULL, NULL, 87864); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(87865, '2.130.10.10-FF-003526', NULL, 'Echinoderm microtubule associated protein like 6', 160, NULL, NULL, 87865),
(87866, '3.40.630.10-FF-000302', NULL, 'Predicted protein', 298, NULL, NULL, 87866),
(87867, '3.40.30.10-FF-000871', NULL, 'Thioredoxin', 139, NULL, NULL, 87867),
(87868, '3.40.50.2300-FF-001096', NULL, NULL, 149, NULL, NULL, 87868),
(87869, '3.10.105.10-FF-000072', NULL, 'Extracellular solute-binding protein family 5', 239, NULL, NULL, 87869),
(87870, '2.40.10.230-FF-000005', NULL, 'H/ACA ribonucleoprotein complex subunit', 96, NULL, NULL, 87870),
(87871, '2.60.200.20-FF-000255', NULL, 'Predicted protein', 93, NULL, NULL, 87871),
(87872, '3.40.1280.10-FF-000021', NULL, '23S rRNA (guanosine-2''-O-)-methyltransferase RlmB', 166, NULL, NULL, 87872),
(87873, '2.60.40.10-FF-005347', NULL, NULL, 69, NULL, NULL, 87873),
(87874, '2.60.40.60-FF-000230', NULL, 'Si:dkey-22o22.2', 106, NULL, NULL, 87874),
(87875, '2.60.220.30-FF-000023', NULL, 'Uncharacterized protein', 136, NULL, NULL, 87875),
(87876, '3.10.340.11-FF-000001', NULL, 'Methenyltetrahydromethanopterin cyclohydrolase', 116, NULL, NULL, 87876),
(87877, '3.20.20.140-FF-000138', NULL, 'YALI0E14817p', 338, NULL, NULL, 87877),
(87878, '1.10.565.10-FF-000142', NULL, 'Uncharacterized protein', 248, NULL, NULL, 87878),
(87879, '1.20.1550.10-FF-000003', NULL, 'Probable disulfide formation protein', 138, NULL, NULL, 87879),
(87880, '1.10.510.10-FF-003674', NULL, NULL, 174, NULL, NULL, 87880),
(87881, '1.20.1280.20-FF-000013', NULL, 'Co-chaperone Hsc20', 83, NULL, NULL, 87881),
(87882, '1.20.58.1780-FF-000012', NULL, 'Uncharacterized protein', 314, NULL, NULL, 87882),
(87883, '3.40.50.1000-FF-000104', NULL, 'Trehalose 6-phosphate phosphatase', 147, NULL, NULL, 87883),
(87884, '1.25.10.10-FF-003366', NULL, 'Protein Mo25', 167, NULL, NULL, 87884),
(87885, '1.20.1070.10-FF-000652', NULL, 'Uncharacterized protein', 346, NULL, NULL, 87885),
(87886, '2.40.10.10-FF-000675', NULL, NULL, 96, NULL, NULL, 87886),
(87887, '2.60.40.1180-FF-000093', NULL, 'Alpha-mannosidase', 124, NULL, NULL, 87887),
(87888, '1.10.238.10-FF-000444', NULL, 'Ubiquitin carboxyl-terminal hydrolase 6/32', 171, NULL, NULL, 87888),
(87889, '3.20.20.70-FF-000838', NULL, NULL, 101, NULL, NULL, 87889),
(87890, '3.30.70.1230-FF-000125', NULL, 'Predicted protein', 115, NULL, NULL, 87890),
(87891, '1.25.10.10-FF-000640', NULL, 'Serine/threonine-protein kinase TOR', 183, NULL, NULL, 87891),
(87892, '3.30.559.30-FF-000121', NULL, 'Hydroxamate-type ferrichrome siderophore peptide synthetase', 159, NULL, NULL, 87892),
(87893, '3.90.1600.10-FF-000035', NULL, 'DNA polymerase', 186, NULL, NULL, 87893),
(87894, '2.130.10.10-FF-002037', NULL, 'Os02g0539900 protein', 223, NULL, NULL, 87894),
(87895, '3.40.50.620-FF-000126', NULL, 'Valine--tRNA ligase chloroplastic/mitochondrial 2', 236, NULL, NULL, 87895),
(87896, '3.50.50.60-FF-001156', NULL, 'Uncharacterized protein', 53, NULL, NULL, 87896),
(87897, '2.60.40.150-FF-000365', NULL, 'Pre-mRNA-splicing helicase BRR2', 110, NULL, NULL, 87897),
(87898, '3.30.40.10-FF-000905', NULL, 'Protein CBR-NHL-2', 57, NULL, NULL, 87898),
(87899, '2.130.10.10-FF-002222', NULL, 'Conserved WD40 and TPR repeat-containing protein, putative', 152, NULL, NULL, 87899),
(87900, '2.170.270.10-FF-000022', NULL, 'PR domain zinc finger protein 4', 175, NULL, NULL, 87900),
(87901, '3.40.50.300-FF-002621', NULL, 'Dethiobiotin synthetase', 221, NULL, NULL, 87901),
(87902, '3.60.110.10-FF-000056', NULL, 'Nitrilase-like protein 1', 220, NULL, NULL, 87902),
(87903, '2.60.40.10-FF-002930', NULL, 'Sensory AXon guidance', 90, NULL, NULL, 87903),
(87904, '3.20.20.70-FF-000063', NULL, 'peroxisomal (S)-2-hydroxy-acid oxidase GLO1', 366, NULL, NULL, 87904),
(87905, '2.60.220.50-FF-000029', NULL, 'Polycystic kidney disease protein 1-like 2', 60, NULL, NULL, 87905),
(87906, '3.10.20.70-FF-000001', NULL, 'Glutamine synthetase', 104, NULL, NULL, 87906),
(87907, '4.10.1000.10-FF-000086', NULL, 'Zinc finger CCCH domain-containing protein 64', 73, NULL, NULL, 87907),
(87908, '3.10.20.90-FF-000682', NULL, 'Uncharacterized protein', 101, NULL, NULL, 87908);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(87909, '1.25.40.10-FF-003194', NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', 94, NULL, NULL, 87909),
(87910, '2.60.120.920-FF-000043', NULL, 'Protein TRAUCO', 214, NULL, NULL, 87910),
(87911, '2.170.120.12-FF-000025', NULL, 'DNA-directed RNA polymerase subunit alpha', 120, NULL, NULL, 87911),
(87912, '1.10.1410.40-FF-000004', NULL, 'Interleukin enhancer-binding factor 2', 176, NULL, NULL, 87912),
(87913, '2.60.40.1730-FF-000078', NULL, 'Aminopeptidase', 238, NULL, NULL, 87913),
(87914, '3.90.1770.10-FF-000002', NULL, 'Biotin carboxylase subunit of acetyl CoA carboxylase', 41, NULL, NULL, 87914),
(87915, '2.40.30.10-FF-000474', NULL, 'Uncharacterized protein', 59, NULL, NULL, 87915),
(87916, '3.40.630.10-FF-000032', NULL, 'Murein peptide amidase A', 237, NULL, NULL, 87916),
(87917, '3.40.50.11530-FF-000008', NULL, 'Interleukin cytokine receptor-related protein 2', 158, NULL, NULL, 87917),
(87918, '1.25.10.10-FF-001477', NULL, 'Crescerin-like protein che-12', 235, NULL, NULL, 87918),
(87919, '1.20.1250.20-FF-002097', NULL, 'Uncharacterized protein', 249, NULL, NULL, 87919),
(87920, '1.10.10.140-FF-000011', NULL, 'Cytochrome c oxidase subunit', 78, NULL, NULL, 87920),
(87921, '2.60.40.150-FF-000617', NULL, 'Predicted protein', 148, NULL, NULL, 87921),
(87922, '2.60.120.200-FF-000501', NULL, 'Uncharacterized protein', 184, NULL, NULL, 87922),
(87923, '1.20.1250.20-FF-000860', NULL, 'Major facilitator superfamily domain-containing protein', 187, NULL, NULL, 87923),
(87924, '2.60.40.10-FF-005908', NULL, NULL, 61, NULL, NULL, 87924),
(87925, '1.20.1070.10-FF-001922', NULL, 'Uncharacterized protein', 282, NULL, NULL, 87925),
(87926, '3.30.70.330-FF-001029', NULL, 'Os06g0724600 protein', 156, NULL, NULL, 87926),
(87927, '3.40.630.30-FF-000038', NULL, 'PanD regulatory factor', 127, NULL, NULL, 87927),
(87928, '1.10.730.10-FF-000127', NULL, 'Methionine--tRNA ligase', 188, NULL, NULL, 87928),
(87929, '2.60.40.820-FF-000026', NULL, 'GD16690', 96, NULL, NULL, 87929),
(87930, '2.30.30.380-FF-000056', NULL, 'Uncharacterized protein C4.03c', 73, NULL, NULL, 87930),
(87931, '3.30.1650.10-FF-000001', NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit beta 2', 176, NULL, NULL, 87931),
(87932, '1.10.730.20-FF-000006', NULL, 'Isoleucine--tRNA ligase', 277, NULL, NULL, 87932),
(87933, '1.10.220.10-FF-000044', NULL, 'Uncharacterized protein', 78, NULL, NULL, 87933),
(87934, '2.60.40.10-FF-002166', NULL, 'Protein borderless', 99, NULL, NULL, 87934),
(87935, '3.30.70.940-FF-000032', NULL, 'Transcription termination/antitermination protein NusG', 94, NULL, NULL, 87935),
(87936, '3.30.70.330-FF-001737', NULL, NULL, 73, NULL, NULL, 87936),
(87937, '3.90.960.10-FF-000006', NULL, 'Proline--tRNA ligase', 141, NULL, NULL, 87937),
(87938, '3.30.160.60-FF-004723', NULL, NULL, 61, NULL, NULL, 87938),
(87939, '3.60.21.10-FF-000242', NULL, 'Uncharacterized protein', 285, NULL, NULL, 87939),
(87940, '1.25.40.20-FF-000234', NULL, 'ankyrin repeat domain-containing protein 37 isoform X2', 123, NULL, NULL, 87940),
(87941, '2.40.160.10-FF-000073', NULL, 'Outer membrane porin', 309, NULL, NULL, 87941),
(87942, '1.20.1250.40-FF-000034', NULL, 'Uncharacterized protein', 121, NULL, NULL, 87942),
(87943, '3.80.10.10-FF-000952', NULL, 'Leucine-rich repeat containing protein', 109, NULL, NULL, 87943),
(87944, '1.20.1070.10-FF-001613', NULL, 'D(1B) dopamine receptor', 147, NULL, NULL, 87944),
(87945, '1.20.120.1910-FF-000019', NULL, 'Cysteinyl-tRNA synthetase, mitochondrial, isoform A', 190, NULL, NULL, 87945),
(87946, '3.10.20.90-FF-000007', NULL, 'Serine/threonine-protein kinase WNK1 isoform 1', 95, NULL, NULL, 87946),
(87947, '1.10.1200.10-FF-000053', NULL, 'PKS-NRPS hybrid synthetase psoA', 67, NULL, NULL, 87947),
(87948, '3.90.190.10-FF-000588', NULL, 'Predicted protein', 76, NULL, NULL, 87948),
(87949, '1.20.90.10-FF-000003', NULL, 'Group XIIB secretory phospholipase A2-like protein', 106, NULL, NULL, 87949),
(87950, '3.40.30.10-FF-000163', NULL, 'UBX domain-containing protein 4', 118, NULL, NULL, 87950);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(87951, '3.10.50.40-FF-000101', NULL, 'Peptidylprolyl isomerase', 148, NULL, NULL, 87951),
(87952, '3.60.21.10-FF-000023', NULL, 'Metallophosphoesterase mpped2', 294, NULL, NULL, 87952),
(87953, '1.20.58.60-FF-000224', NULL, 'Spectrin beta chain, non-erythrocytic', 104, NULL, NULL, 87953),
(87954, '3.10.330.10-FF-000033', NULL, 'Uncharacterized protein', 78, NULL, NULL, 87954),
(87955, '3.30.365.10-FF-000075', NULL, 'Uncharacterized protein', 85, NULL, NULL, 87955),
(87956, '3.30.200.20-FF-002186', NULL, 'Uncharacterized protein', 55, NULL, NULL, 87956),
(87957, '1.10.10.10-FF-000999', NULL, 'ArsR family transcriptional regulator', 87, NULL, NULL, 87957),
(87958, '3.40.50.300-FF-004201', NULL, 'Guanine nucleotide-binding protein-like alpha-10 subunit', 188, NULL, NULL, 87958),
(87959, '1.10.1170.10-FF-000055', NULL, 'Uncharacterized protein', 68, NULL, NULL, 87959),
(87960, '2.60.40.10-FF-001766', NULL, 'Pre-IgM VH-region (AA-18 to 120)', 102, NULL, NULL, 87960),
(87961, '3.30.1330.40-FF-000071', NULL, 'Uncharacterized protein', 39, NULL, NULL, 87961),
(87962, '3.20.20.10-FF-000051', NULL, 'Arginine decarboxylase', 69, NULL, NULL, 87962),
(87963, '3.20.20.70-FF-000282', NULL, 'Thiamine-phosphate synthase', 204, NULL, NULL, 87963),
(87964, '3.80.10.10-FF-000643', NULL, 'Receptor-like protein kinase 2', 99, NULL, NULL, 87964),
(87965, '1.20.1280.50-FF-000084', NULL, 'EIN3-binding F-box protein 1', 38, NULL, NULL, 87965),
(87966, '2.40.50.140-FF-000514', NULL, 'Single-strand DNA-binding protein', 109, NULL, NULL, 87966),
(87967, '2.60.40.10-FF-006061', NULL, NULL, 99, NULL, NULL, 87967),
(87968, '3.90.550.50-FF-000105', NULL, 'Uncharacterized protein', 184, NULL, NULL, 87968),
(87969, '1.10.287.820-FF-000002', NULL, 'Pickpocket 31', 84, NULL, NULL, 87969),
(87970, '3.30.1540.10-FF-000010', NULL, 'Acyl-CoA transferase/carnitine dehydratase-like protein', 103, NULL, NULL, 87970),
(87971, '2.60.40.150-FF-000584', NULL, 'C2 domain containing protein', 137, NULL, NULL, 87971),
(87972, '1.25.10.10-FF-002096', NULL, 'UvrB/uvrC motif family protein', 228, NULL, NULL, 87972),
(87973, '1.25.40.10-FF-004031', NULL, 'Uncharacterized protein', 183, NULL, NULL, 87973),
(87974, '3.40.50.300-FF-006674', NULL, 'Predicted protein', 84, NULL, NULL, 87974),
(87975, '3.40.50.1820-FF-000581', NULL, 'Os11g0431400 protein', 267, NULL, NULL, 87975),
(87976, '3.30.420.40-FF-000286', NULL, 'Actin-related protein 8', 37, NULL, NULL, 87976),
(87977, '3.30.360.10-FF-000013', NULL, 'Glucose-6-phosphate 1-dehydrogenase', 283, NULL, NULL, 87977),
(87978, '3.30.40.10-FF-000074', NULL, 'Ring finger protein 121', 73, NULL, NULL, 87978),
(87979, '1.10.10.10-FF-001308', NULL, 'Probable transcriptional regulator', 89, NULL, NULL, 87979),
(87980, '2.60.120.260-FF-000148', NULL, 'Beta-galactosidase, putative', 138, NULL, NULL, 87980),
(87981, '2.20.25.10-FF-000081', NULL, 'DNA-directed RNA polymerase subunit', 69, NULL, NULL, 87981),
(87982, '2.30.42.10-FF-000081', NULL, 'Ligand of Numb protein X 2', 94, NULL, NULL, 87982),
(87983, '1.25.10.10-FF-002438', NULL, 'Uncharacterized protein', 238, NULL, NULL, 87983),
(87984, '2.10.55.10-FF-000004', NULL, 'Cell surface protease gp63, putative', 64, NULL, NULL, 87984),
(87985, '1.25.40.10-FF-000012', NULL, 'PEX5-related protein isoform 5', 313, NULL, NULL, 87985),
(87986, '1.10.10.160-FF-000017', NULL, 'DNA helicase', 87, NULL, NULL, 87986),
(87987, '2.70.170.10-FF-000095', NULL, 'Proton-gated ion channel', 196, NULL, NULL, 87987),
(87988, '3.30.70.330-FF-001580', NULL, 'YALI0A02981p', 156, NULL, NULL, 87988),
(87989, '1.20.120.1150-FF-000011', NULL, 'Serine/threonine-protein phosphatase 2A activator', 131, NULL, NULL, 87989),
(87990, '3.30.160.60-FF-003762', NULL, 'Zinc finger protein 236', 54, NULL, NULL, 87990),
(87991, '1.10.405.20-FF-000004', NULL, NULL, 152, NULL, NULL, 87991),
(87992, '3.40.30.10-FF-000724', NULL, 'Glutathione S-Transferase, Omega class', 53, NULL, NULL, 87992),
(87993, '1.50.40.10-FF-000179', NULL, 'S-adenosylmethionine carrier 1, chloroplastic/mitochondrial isoform A', 120, NULL, NULL, 87993);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(87994, '1.10.510.10-FF-004506', NULL, NULL, 60, NULL, NULL, 87994),
(87995, '2.40.50.690-FF-000016', NULL, 'Uncharacterized protein', 110, NULL, NULL, 87995),
(87996, '3.30.40.10-FF-001833', NULL, 'RNA binding (RRM/RBD/RNP motifs) family protein', 59, NULL, NULL, 87996),
(87997, '2.20.130.20-FF-000005', NULL, 'Complement 4B (Chido blood group)', 76, NULL, NULL, 87997),
(87998, '2.40.70.10-FF-000342', NULL, NULL, 161, NULL, NULL, 87998),
(87999, '1.25.40.10-FF-000136', NULL, 'Tetratricopeptide repeat domain 26', 124, NULL, NULL, 87999),
(88000, '3.40.50.1260-FF-000042', NULL, 'Phosphoglycerate kinase', 147, NULL, NULL, 88000),
(88001, '3.40.50.360-FF-000161', NULL, 'NADPH--cytochrome P450 reductase', 179, NULL, NULL, 88001),
(88002, '3.40.50.790-FF-000025', NULL, 'Uncharacterized protein', 94, NULL, NULL, 88002),
(88003, '1.25.40.10-FF-000321', NULL, 'pentatricopeptide repeat-containing protein 1, mitochondrial isoform X1', 159, NULL, NULL, 88003),
(88004, '3.20.20.70-FF-000591', NULL, 'Acyl carrier protein', 243, NULL, NULL, 88004),
(88005, '1.25.40.10-FF-003755', NULL, 'Uncharacterized protein', 196, NULL, NULL, 88005),
(88006, '2.30.29.30-FF-001079', NULL, 'Uncharacterized protein', 66, NULL, NULL, 88006),
(88007, '3.40.30.10-FF-001124', NULL, 'Predicted protein', 80, NULL, NULL, 88007),
(88008, '3.30.70.330-FF-001395', NULL, 'Polyadenylate-binding protein', 112, NULL, NULL, 88008),
(88009, '4.10.410.10-FF-000092', NULL, 'Kunitz-type serine protease inhibitor Bt-KTI', 64, NULL, NULL, 88009),
(88010, '3.40.50.1820-FF-000215', NULL, 'Lysosomal thioesterase PPT2-B', 311, NULL, NULL, 88010),
(88011, '3.40.50.10490-FF-000090', NULL, 'Transcriptional regulator, RpiR family', 183, NULL, NULL, 88011),
(88012, '1.10.10.10-FF-001617', NULL, 'Uncharacterized protein', 104, NULL, NULL, 88012),
(88013, '3.65.10.20-FF-000029', NULL, 'Uncharacterized protein', 43, NULL, NULL, 88013),
(88014, '3.40.605.10-FF-000103', NULL, 'Predicted protein', 17, NULL, NULL, 88014),
(88015, '1.20.58.760-FF-000005', NULL, 'ATP-dependent zinc metalloprotease FTSH 10, mitochondrial', 199, NULL, NULL, 88015),
(88016, '1.20.1170.10-FF-000002', NULL, 'Non-hemolytic enterotoxin A', 342, NULL, NULL, 88016),
(88017, '2.130.10.10-FF-003195', NULL, 'Ribosome biogenesis protein WDR12 homolog', 111, NULL, NULL, 88017),
(88018, '1.25.40.10-FF-002474', NULL, 'Pentatricopeptide repeat-containing protein At3g22150, chloroplastic', 96, NULL, NULL, 88018),
(88019, '3.30.160.60-FF-005920', NULL, NULL, 34, NULL, NULL, 88019),
(88020, '3.30.200.20-FF-002326', NULL, NULL, 77, NULL, NULL, 88020),
(88021, '3.90.70.10-FF-000871', NULL, 'Uncharacterized protein', 67, NULL, NULL, 88021),
(88022, '2.20.25.10-FF-000002', NULL, 'UPF0434 protein YcaR', 53, NULL, NULL, 88022),
(88023, '2.10.25.10-FF-000194', NULL, 'Latent transforming growth factor beta binding protein 2', 44, NULL, NULL, 88023),
(88024, '3.40.30.10-FF-000067', NULL, 'Protein disulfide-isomerase A4', 106, NULL, NULL, 88024),
(88025, '3.80.10.10-FF-003274', NULL, 'Toll-like receptor22', 172, NULL, NULL, 88025),
(88026, '1.50.10.10-FF-000216', NULL, 'alpha-1,2-Mannosidase', 125, NULL, NULL, 88026),
(88027, '3.40.1400.10-FF-000003', NULL, 'Ribose 5-phosphate isomerase B', 148, NULL, NULL, 88027),
(88028, '2.40.50.140-FF-000301', NULL, 'Replication protein A', 102, NULL, NULL, 88028),
(88029, '3.10.105.10-FF-000089', NULL, 'Xyloglucan ABC transport system, sugar-binding protein', 62, NULL, NULL, 88029),
(88030, '3.40.50.2300-FF-000371', NULL, 'Guanylate cyclase', 73, NULL, NULL, 88030),
(88031, '1.10.1420.10-FF-000176', NULL, 'Uncharacterized protein', 129, NULL, NULL, 88031),
(88032, '1.25.40.10-FF-005228', NULL, 'Uncharacterized protein', 185, NULL, NULL, 88032),
(88033, '1.25.40.1030-FF-000046', NULL, 'Im:7147241 protein', 265, NULL, NULL, 88033),
(88034, '1.10.8.720-FF-000041', NULL, 'Uncharacterized protein', 73, NULL, NULL, 88034),
(88035, '2.80.10.50-FF-000011', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 149, NULL, NULL, 88035),
(88036, '3.40.50.1000-FF-000649', NULL, NULL, 95, NULL, NULL, 88036);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(88037, '3.80.10.10-FF-001132', NULL, 'Probable inactive leucine-rich repeat receptor-like protein kinase At1g66830', 212, NULL, NULL, 88037),
(88038, '3.90.470.20-FF-000051', NULL, 'Phosphopantetheinyl transferase-like protein', 49, NULL, NULL, 88038),
(88039, '1.10.510.10-FF-000004', NULL, 'Tyrosine-protein kinase', 189, NULL, NULL, 88039),
(88040, '3.30.40.10-FF-000877', NULL, 'RING-H2 finger protein ATL52', 87, NULL, NULL, 88040),
(88041, '3.40.390.10-FF-000007', NULL, 'Collagenase 3', 248, NULL, NULL, 88041),
(88042, '3.40.50.1000-FF-000071', NULL, 'Cation-transporting ATPase', 180, NULL, NULL, 88042),
(88043, '3.30.160.60-FF-001637', NULL, 'zinc finger and BTB domain-containing protein 21', 95, NULL, NULL, 88043),
(88044, '3.30.160.60-FF-002143', NULL, 'zinc finger protein 623', 25, NULL, NULL, 88044),
(88045, '3.30.70.3400-FF-000012', NULL, 'Protein translocase subunit SecD', 79, NULL, NULL, 88045),
(88046, '1.10.287.110-FF-000368', NULL, 'Uncharacterized protein', 108, NULL, NULL, 88046),
(88047, '3.40.1000.10-FF-000006', NULL, 'PsbP domain-containing protein 1, chloroplastic', 180, NULL, NULL, 88047),
(88048, '3.30.830.10-FF-000325', NULL, 'Protein CBG17023', 83, NULL, NULL, 88048),
(88049, '1.20.1070.10-FF-001366', NULL, 'Uncharacterized protein', 261, NULL, NULL, 88049),
(88050, '2.130.10.10-FF-002801', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit TRM82', 182, NULL, NULL, 88050),
(88051, '1.10.510.10-FF-004175', NULL, NULL, 117, NULL, NULL, 88051),
(88052, '2.70.130.10-FF-000070', NULL, NULL, 116, NULL, NULL, 88052),
(88053, '2.60.40.10-FF-000569', NULL, 'obscurin-like protein 1 isoform X2', 102, NULL, NULL, 88053),
(88054, '1.20.58.60-FF-000679', NULL, 'Beta-H spectrin', 115, NULL, NULL, 88054),
(88055, '3.30.160.60-FF-002582', NULL, 'CCCTC-binding factor (zinc finger protein)', 27, NULL, NULL, 88055),
(88056, '2.70.170.10-FF-000078', NULL, 'Gamma-aminobutyric acid receptor subunit alpha-4', 163, NULL, NULL, 88056),
(88057, '2.40.128.180-FF-000010', NULL, NULL, 82, NULL, NULL, 88057),
(88058, '3.30.1450.10-FF-000003', NULL, 'Outer membrane protein assembly factor BamE', 79, NULL, NULL, 88058),
(88059, '1.25.10.10-FF-000308', NULL, 'U-box domain-containing protein 4', 153, NULL, NULL, 88059),
(88060, '3.40.720.10-FF-000382', NULL, 'Secreted ectonucleotide pyrophosphatase/phosphodiesterase, putative', 209, NULL, NULL, 88060),
(88061, '3.30.40.10-FF-002108', NULL, 'Uncharacterized protein', 118, NULL, NULL, 88061),
(88062, '3.40.50.300-FF-005741', NULL, 'DNA helicase', 147, NULL, NULL, 88062),
(88063, '3.90.1070.20-FF-000002', NULL, 'DNA-directed RNA polymerase subunit beta', 83, NULL, NULL, 88063),
(88064, '3.40.850.10-FF-000043', NULL, 'Kinesin-like protein', 339, NULL, NULL, 88064),
(88065, '1.10.472.10-FF-000111', NULL, 'Unplaced genomic scaffold supercont1.6, whole genome shotgun sequence', 148, NULL, NULL, 88065),
(88066, '1.10.150.50-FF-000134', NULL, 'ets protein isoform X1', 90, NULL, NULL, 88066),
(88067, '2.60.40.10-FF-001997', NULL, 'Uncharacterized protein, isoform D', 98, NULL, NULL, 88067),
(88068, '3.40.50.1100-FF-000224', NULL, 'Threonine dehydratase biosynthetic, chloroplastic', 182, NULL, NULL, 88068),
(88069, '1.20.5.190-FF-000150', NULL, NULL, 53, NULL, NULL, 88069),
(88070, '3.20.20.220-FF-000078', NULL, 'Proline dehydrogenase', 141, NULL, NULL, 88070),
(88071, '3.40.525.10-FF-000046', NULL, 'CRAL/TRIO domain containing protein, putative', 261, NULL, NULL, 88071),
(88072, '4.10.1240.10-FF-000081', NULL, 'Uncharacterized protein', 103, NULL, NULL, 88072),
(88073, '3.30.160.20-FF-000001', NULL, '30S ribosomal protein S5', 73, NULL, NULL, 88073),
(88074, '1.10.510.10-FF-002033', NULL, 'Uncharacterized protein', 218, NULL, NULL, 88074),
(88075, '2.60.40.150-FF-000376', NULL, 'Protein CBR-SNT-6', 135, NULL, NULL, 88075),
(88076, '1.20.1070.10-FF-000961', NULL, 'Predicted protein', 304, NULL, NULL, 88076),
(88077, '4.10.75.10-FF-000001', NULL, 'Anosmin 1', 50, NULL, NULL, 88077),
(88078, '3.30.160.40-FF-000007', NULL, 'Porphobilinogen deaminase', 75, NULL, NULL, 88078);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(88079, '3.30.410.40-FF-000004', NULL, 'Oxidoreductase, putative', 205, NULL, NULL, 88079),
(88080, '3.40.605.10-FF-000098', NULL, 'Uncharacterized protein', 55, NULL, NULL, 88080),
(88081, '1.10.533.10-FF-000271', NULL, 'Tumor necrosis factor receptor superfamily member 10b', 97, NULL, NULL, 88081),
(88082, '3.90.1640.10-FF-000021', NULL, 'Exopolyphosphatase', 247, NULL, NULL, 88082),
(88083, '3.40.980.10-FF-000030', NULL, 'Molybdenum cofactor synthesis domain protein', 147, NULL, NULL, 88083),
(88084, '3.65.10.10-FF-000032', NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', 111, NULL, NULL, 88084),
(88085, '3.40.50.300-FF-007186', NULL, 'Rac3A protein, putative', 170, NULL, NULL, 88085),
(88086, '3.40.225.10-FF-000001', NULL, 'L-ribulose-5-phosphate 4-epimerase UlaF', 230, NULL, NULL, 88086),
(88087, '1.25.10.10-FF-002646', NULL, 'Predicted protein', 111, NULL, NULL, 88087),
(88088, '3.40.50.620-FF-000834', NULL, 'Valyl tRNA synthetase, putative', 253, NULL, NULL, 88088),
(88089, '1.20.58.60-FF-000584', NULL, 'Plectin', 218, NULL, NULL, 88089),
(88090, '3.40.30.10-FF-001023', NULL, 'Predicted protein', 53, NULL, NULL, 88090),
(88091, '2.60.40.10-FF-005471', NULL, NULL, 128, NULL, NULL, 88091),
(88092, '3.30.750.24-FF-000017', NULL, 'Anti-sigma factor antagonist', 103, NULL, NULL, 88092),
(88093, '3.40.430.10-FF-000051', NULL, 'Riboflavin biosynthesis protein RibD', 209, NULL, NULL, 88093),
(88094, '1.25.40.20-FF-000009', NULL, 'Poly [ADP-ribose] polymerase', 175, NULL, NULL, 88094),
(88095, '1.10.510.10-FF-003770', NULL, NULL, 137, NULL, NULL, 88095),
(88096, '3.30.420.10-FF-000614', NULL, NULL, 178, NULL, NULL, 88096),
(88097, '1.10.167.10-FF-000014', NULL, 'RGS domain protein Rax1', 127, NULL, NULL, 88097),
(88098, '2.70.150.10-FF-000083', NULL, 'Plasma membrane ATPase', 84, NULL, NULL, 88098),
(88099, '3.30.70.120-FF-000022', NULL, NULL, 111, NULL, NULL, 88099),
(88100, '3.40.50.300-FF-006455', NULL, 'DNA polymerase III, delta prime subunit, putative', 121, NULL, NULL, 88100),
(88101, '1.10.1200.10-FF-000070', NULL, 'Probable non-ribosomal peptide synthetase', 79, NULL, NULL, 88101),
(88102, '1.10.10.10-FF-001185', NULL, 'DNA-directed RNA polymerase III subunit RPC6', 86, NULL, NULL, 88102),
(88103, '2.170.300.10-FF-000020', NULL, 'Uncharacterized protein', 147, NULL, NULL, 88103),
(88104, '3.40.50.300-FF-000839', NULL, 'ABC transporter G family member 32', 268, NULL, NULL, 88104),
(88105, '3.10.100.10-FF-000016', NULL, 'macrophage mannose receptor 1', 139, NULL, NULL, 88105),
(88106, '2.60.120.920-FF-000155', NULL, 'Si:dkey-61p9.9', 178, NULL, NULL, 88106),
(88107, '1.10.510.10-FF-001302', NULL, 'Protein kinase domain containing protein', 202, NULL, NULL, 88107),
(88108, '1.10.630.10-FF-000844', NULL, 'Uncharacterized protein', 103, NULL, NULL, 88108),
(88109, '2.60.40.10-FF-003554', NULL, NULL, 98, NULL, NULL, 88109),
(88110, '3.40.50.300-FF-006016', NULL, 'Ras-related small GTP-binding family protein', 61, NULL, NULL, 88110),
(88111, '3.40.50.300-FF-001784', NULL, 'ABC transporter, ATP-binding protein', 247, NULL, NULL, 88111),
(88112, '2.10.25.10-FF-001132', NULL, 'Serine protease inhibitor 1', 61, NULL, NULL, 88112),
(88113, '3.40.50.150-FF-000873', NULL, NULL, 167, NULL, NULL, 88113),
(88114, '3.90.190.20-FF-000001', NULL, 'UDP-N-acetylmuramate--L-alanine ligase', 167, NULL, NULL, 88114),
(88115, '3.40.50.150-FF-000761', NULL, 'tRNA (adenine(58)-N(1))-methyltransferase non-catalytic subunit TRM6', 140, NULL, NULL, 88115),
(88116, '3.30.450.60-FF-000092', NULL, 'Predicted protein', 168, NULL, NULL, 88116),
(88117, '3.80.10.10-FF-001924', NULL, 'Malignant fibrous histiocytoma-amplified sequence 1 homolog', 184, NULL, NULL, 88117),
(88118, '3.40.50.1110-FF-000132', NULL, 'Uncharacterized protein', 224, NULL, NULL, 88118),
(88119, '2.40.30.10-FF-000244', NULL, 'Ferredoxin reductase component of carbazole', 100, NULL, NULL, 88119),
(88120, '1.10.1520.10-FF-000009', NULL, 'Ribonuclease III domain-containing protein RNC1, chloroplastic', 132, NULL, NULL, 88120),
(88121, '3.30.420.40-FF-000157', NULL, 'Putative Hsp70 chaperone', 141, NULL, NULL, 88121);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(88122, '1.20.5.110-FF-000053', NULL, 'TNF receptor-associated factor', 64, NULL, NULL, 88122),
(88123, '3.30.830.10-FF-000100', NULL, 'Peptidase insulinase family', 223, NULL, NULL, 88123),
(88124, '1.25.40.10-FF-004514', NULL, 'Uncharacterized protein', 87, NULL, NULL, 88124),
(88125, '1.20.58.90-FF-000008', NULL, 'Tubulin-specific chaperone A', 108, NULL, NULL, 88125),
(88126, '3.30.870.10-FF-000081', NULL, 'Tyrosyl-DNA phosphodiesterase', 250, NULL, NULL, 88126),
(88127, '1.10.3730.20-FF-000068', NULL, 'Uncharacterized protein', 85, NULL, NULL, 88127),
(88128, '1.25.10.10-FF-003377', NULL, 'Exportin 5', 152, NULL, NULL, 88128),
(88129, '1.10.510.10-FF-002825', NULL, NULL, 119, NULL, NULL, 88129),
(88130, '2.10.90.10-FF-000153', NULL, 'Predicted protein', 98, NULL, NULL, 88130),
(88131, '3.30.160.60-FF-003992', NULL, NULL, 48, NULL, NULL, 88131),
(88132, '2.130.10.10-FF-003987', NULL, 'Uncharacterized protein', 232, NULL, NULL, 88132),
(88133, '3.30.70.2740-FF-000022', NULL, 'Uncharacterized protein', 69, NULL, NULL, 88133),
(88134, '1.10.287.460-FF-000001', NULL, 'Peptidyl-prolyl cis-trans isomerase', 97, NULL, NULL, 88134),
(88135, '3.40.630.10-FF-000162', NULL, 'Aminoacyl-histidine dipeptidase', 109, NULL, NULL, 88135),
(88136, '3.80.10.10-FF-002981', NULL, 'Immunoglobulin domain and leucine-rich repeat-containing protein 2', 91, NULL, NULL, 88136),
(88137, '1.25.40.10-FF-000119', NULL, 'synaptonemal complex protein SC65', 98, NULL, NULL, 88137),
(88138, '2.60.40.10-FF-001188', NULL, 'Immunoglobulin superfamily member 10', 96, NULL, NULL, 88138),
(88139, '2.130.10.10-FF-002790', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit trm82', 209, NULL, NULL, 88139),
(88140, '3.90.1150.10-FF-000146', NULL, '8-amino-7-oxononanoate synthase', 96, NULL, NULL, 88140),
(88141, '2.30.29.30-FF-000696', NULL, 'pleckstrin homology domain-containing family A member 2 isoform X2', 100, NULL, NULL, 88141),
(88142, '1.20.1250.20-FF-001355', NULL, 'Transporter protein, putative', 201, NULL, NULL, 88142),
(88143, '3.30.70.330-FF-002676', NULL, NULL, 73, NULL, NULL, 88143),
(88144, '3.30.420.150-FF-000004', NULL, 'Ectonucleoside triphosphate diphosphohydrolase 5', 239, NULL, NULL, 88144),
(88145, '1.25.40.570-FF-000029', NULL, 'Cop9 signalosome complex subunit 1, putative', 396, NULL, NULL, 88145),
(88146, '1.10.260.50-FF-000007', NULL, NULL, 90, NULL, NULL, 88146),
(88147, '1.10.3580.10-FF-000002', NULL, 'Protein ATP12, mitochondrial', 210, NULL, NULL, 88147),
(88148, '2.60.40.1220-FF-000003', NULL, 'Copper transport protein YcnJ', 102, NULL, NULL, 88148),
(88149, '2.60.40.60-FF-000331', NULL, 'Fat-like cadherin-related tumor suppressor homolog', 100, NULL, NULL, 88149),
(88150, '2.60.40.10-FF-003907', NULL, NULL, 111, NULL, NULL, 88150),
(88151, '3.20.20.70-FF-000832', NULL, NULL, 132, NULL, NULL, 88151),
(88152, '2.60.120.1680-FF-000001', NULL, 'Orf1a polyprotein', 144, NULL, NULL, 88152),
(88153, '2.40.10.10-FF-000361', NULL, 'Uncharacterized protein', 259, NULL, NULL, 88153),
(88154, '2.30.30.140-FF-000035', NULL, 'Methyl-CpG binding domain protein 5', 46, NULL, NULL, 88154),
(88155, '1.25.40.10-FF-003093', NULL, 'Os06g0235800 protein', 265, NULL, NULL, 88155),
(88156, '2.120.10.80-FF-000282', NULL, 'tRNA wybutosine-synthesizing protein 4', 323, NULL, NULL, 88156),
(88157, '1.10.1300.10-FF-000015', NULL, 'Phosphodiesterase', 387, NULL, NULL, 88157),
(88158, '1.10.150.50-FF-000246', NULL, 'Predicted protein', 84, NULL, NULL, 88158),
(88159, '3.30.40.10-FF-000310', NULL, 'Breast cancer associated RING 1', 126, NULL, NULL, 88159),
(88160, '3.80.10.10-FF-001357', NULL, 'Leucine-rich repeat protein kinase family protein', 154, NULL, NULL, 88160),
(88161, '3.40.1110.10-FF-000239', NULL, 'Uncharacterized protein', 256, NULL, NULL, 88161),
(88162, '2.30.30.1040-FF-000001', NULL, 'Auxin response factor', 73, NULL, NULL, 88162),
(88163, '1.10.8.10-FF-000251', NULL, 'Probable E3 ubiquitin-protein ligase HERC2', 87, NULL, NULL, 88163),
(88164, '1.25.40.10-FF-001529', NULL, 'Pentatricopeptide repeat-containing protein', 245, NULL, NULL, 88164);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(88165, '1.25.10.10-FF-001348', NULL, 'ARM repeat superfamily protein', 289, NULL, NULL, 88165),
(88166, '3.40.50.12710-FF-000025', NULL, 'Protein arginine methyltransferase NDUFAF7', 394, NULL, NULL, 88166),
(88167, '3.40.50.150-FF-001492', NULL, NULL, 119, NULL, NULL, 88167),
(88168, '1.10.8.270-FF-000086', NULL, 'Uncharacterized protein', 101, NULL, NULL, 88168),
(88169, '2.60.40.150-FF-000264', NULL, 'Coiled-coil and C2 domain containing 1B', 135, NULL, NULL, 88169),
(88170, '3.50.30.30-FF-000084', NULL, 'Subtilisin-like protease SBT1.9', 127, NULL, NULL, 88170),
(88171, '1.20.5.490-FF-000003', NULL, 'nucleoporin p54 isoform X1', 65, NULL, NULL, 88171),
(88172, '4.10.410.10-FF-000120', NULL, 'Uncharacterized protein', 112, NULL, NULL, 88172),
(88173, '1.20.990.10-FF-000048', NULL, 'Sulfite reductase', 123, NULL, NULL, 88173),
(88174, '3.10.280.10-FF-000040', NULL, 'Uncharacterized protein', 101, NULL, NULL, 88174),
(88175, '3.40.50.2300-FF-000854', NULL, NULL, 95, NULL, NULL, 88175),
(88176, '3.90.226.10-FF-000290', NULL, 'ATP-dependent Clp protease proteolytic subunit', 183, NULL, NULL, 88176),
(88177, '3.40.50.300-FF-006567', NULL, 'Uncharacterized protein', 102, NULL, NULL, 88177),
(88178, '2.70.150.10-FF-000195', NULL, 'Uncharacterized protein', 115, NULL, NULL, 88178),
(88179, '3.40.30.10-FF-000404', NULL, 'WGS project CABT00000000 data, contig 2.14', 134, NULL, NULL, 88179),
(88180, '3.30.70.580-FF-000025', NULL, 'Pseudouridine synthase', 83, NULL, NULL, 88180),
(88181, '2.60.40.10-FF-004852', NULL, NULL, 109, NULL, NULL, 88181),
(88182, '3.90.226.10-FF-000301', NULL, 'Uncharacterized protein', 135, NULL, NULL, 88182),
(88183, '2.60.40.10-FF-005583', NULL, NULL, 90, NULL, NULL, 88183),
(88184, '3.50.50.100-FF-000053', NULL, 'Cilia- and flagella-associated protein 61', 115, NULL, NULL, 88184),
(88185, '2.10.50.10-FF-000044', NULL, 'Tumor necrosis factor receptor superfamily member 5', 41, NULL, NULL, 88185),
(88186, '1.50.40.10-FF-000499', NULL, 'Mitochondrial carrier protein, putative', 265, NULL, NULL, 88186),
(88187, '1.20.1070.10-FF-001719', NULL, 'Corazonin receptor, putative', 100, NULL, NULL, 88187),
(88188, '2.30.29.30-FF-000707', NULL, 'Vacuolar protein sorting protein 36 Vps36/EAP30/Vps36 family, putative', 130, NULL, NULL, 88188),
(88189, '3.40.50.300-FF-004330', NULL, 'TraB protein', 259, NULL, NULL, 88189),
(88190, '1.20.210.10-FF-000035', NULL, 'Heme-copper respiratory oxidase family', 468, NULL, NULL, 88190),
(88191, '1.20.1730.10-FF-000085', NULL, 'Uncharacterized protein', 542, NULL, NULL, 88191),
(88192, '2.180.10.10-FF-000011', NULL, 'Tenascin accessory, isoform G', 592, NULL, NULL, 88192),
(88193, '2.10.25.10-FF-001503', NULL, 'Transmembrane matrix receptor MUP-4', 54, NULL, NULL, 88193),
(88194, '1.20.58.70-FF-000002', NULL, 'syntaxin-16 isoform X2', 213, NULL, NULL, 88194),
(88195, '1.50.40.10-FF-000044', NULL, 'Peroxisomal adenine nucleotide carrier 1', 297, NULL, NULL, 88195),
(88196, '3.30.420.10-FF-000726', NULL, NULL, 62, NULL, NULL, 88196),
(88197, '3.30.200.20-FF-000983', NULL, 'Serine/threonine-protein kinase STN7, chloroplastic', 94, NULL, NULL, 88197),
(88198, '3.30.250.20-FF-000008', NULL, 'Uncharacterized protein', 34, NULL, NULL, 88198),
(88199, '1.20.120.350-FF-000106', NULL, 'Potassium voltage-gated channel, Shab-related subfamily, member 2', 96, NULL, NULL, 88199),
(88200, '2.130.10.10-FF-001845', NULL, 'Transducin family protein / WD-40 repeat family protein', 114, NULL, NULL, 88200),
(88201, '1.20.1250.20-FF-000399', NULL, 'MFS general substrate transporter', 199, NULL, NULL, 88201),
(88202, '2.40.70.10-FF-000139', NULL, 'S5', 178, NULL, NULL, 88202),
(88203, '3.40.30.10-FF-000859', NULL, 'Protein disulfide isomerase-like, testis-expressed', 108, NULL, NULL, 88203),
(88204, '3.40.50.2300-FF-001343', NULL, NULL, 231, NULL, NULL, 88204),
(88205, '2.70.98.20-FF-000008', NULL, 'Amine oxidase', 411, NULL, NULL, 88205),
(88206, '3.20.20.70-FF-000383', NULL, 'Uncharacterized protein', 311, NULL, NULL, 88206),
(88207, '3.60.21.10-FF-000028', NULL, 'Putative metallophosphoesterase', 189, NULL, NULL, 88207); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(88208, '3.40.630.30-FF-000381', NULL, 'Acetyltransferase CD1211', 153, NULL, NULL, 88208),
(88209, '2.20.100.10-FF-000175', NULL, 'GD10852', 82, NULL, NULL, 88209),
(88210, '3.90.320.10-FF-000059', NULL, 'Blr8088 protein', 156, NULL, NULL, 88210),
(88211, '1.10.1420.10-FF-000064', NULL, 'DNA mismatch repair protein MutS', 118, NULL, NULL, 88211),
(88212, '2.130.10.30-FF-000087', NULL, NULL, 145, NULL, NULL, 88212),
(88213, '1.10.630.10-FF-000182', NULL, 'Cytochrome P450 3A4', 487, NULL, NULL, 88213),
(88214, '2.60.120.200-FF-000052', NULL, 'Laminin subunit alpha 2', 187, NULL, NULL, 88214),
(88215, '3.40.50.1010-FF-000186', NULL, NULL, 190, NULL, NULL, 88215),
(88216, '3.80.10.10-FF-001020', NULL, 'Leucine rich repeat receptor protein kinase 2', 61, NULL, NULL, 88216),
(88217, '1.25.10.10-FF-001820', NULL, 'Uncharacterized protein', 104, NULL, NULL, 88217),
(88218, '3.40.50.150-FF-000081', NULL, 'rRNA adenine N(6)-methyltransferase', 185, NULL, NULL, 88218),
(88219, '3.30.160.60-FF-002031', NULL, 'Zinc finger protein 655', 24, NULL, NULL, 88219),
(88220, '3.30.465.10-FF-000032', NULL, 'Delta(24)-sterol reductase', 192, NULL, NULL, 88220),
(88221, '1.10.287.1490-FF-000064', NULL, 'Viral A-type inclusion protein, putative', 164, NULL, NULL, 88221),
(88222, '3.30.160.60-FF-006297', NULL, NULL, 36, NULL, NULL, 88222),
(88223, '1.20.5.390-FF-000007', NULL, 'Optineurin', 55, NULL, NULL, 88223),
(88224, '2.60.40.790-FF-000101', NULL, 'Wos2 protein (P21), putative', 117, NULL, NULL, 88224),
(88225, '3.40.50.300-FF-003824', NULL, 'SWF/SNF family helicase', 263, NULL, NULL, 88225),
(88226, '1.10.10.10-FF-001168', NULL, 'Iron dicitrate transport regulator FecR', 77, NULL, NULL, 88226),
(88227, '3.30.710.10-FF-000378', NULL, 'Kelch-like protein 8', 130, NULL, NULL, 88227),
(88228, '2.60.40.10-FF-000457', NULL, 'Immunoglobulin like domain containing receptor 2', 117, NULL, NULL, 88228),
(88229, '1.10.240.10-FF-000028', NULL, 'Uncharacterized protein', 33, NULL, NULL, 88229),
(88230, '2.60.120.10-FF-000549', NULL, 'Germin-like protein subfamily 2 member 1', 61, NULL, NULL, 88230),
(88231, '2.160.20.10-FF-000136', NULL, 'Uncharacterized protein', 221, NULL, NULL, 88231),
(88232, '2.60.40.1250-FF-000001', NULL, 'Thiol:disulfide interchange protein DsbD', 136, NULL, NULL, 88232),
(88233, '3.40.50.620-FF-000817', NULL, 'Nicotinate/nicotinamide mononucleotide adenyltransferase', 153, NULL, NULL, 88233),
(88234, '1.20.58.2050-FF-000003', NULL, 'GINS complex subunit 3 isoform 4', 60, NULL, NULL, 88234),
(88235, '3.10.20.90-FF-000350', NULL, 'Ataxin-3, putative', 105, NULL, NULL, 88235),
(88236, '3.40.50.10090-FF-000059', NULL, 'Uncharacterized protein', 80, NULL, NULL, 88236),
(88237, '1.20.1530.20-FF-000005', NULL, 'Transporter, bile acid/Na+ symporter family', 317, NULL, NULL, 88237),
(88238, '1.10.287.470-FF-000088', NULL, 'Multidrug resistance protein A', 66, NULL, NULL, 88238),
(88239, '1.25.40.10-FF-000557', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 121, NULL, NULL, 88239),
(88240, '3.20.170.30-FF-000001', NULL, 'RNA 2''-phosphotransferase', 83, NULL, NULL, 88240),
(88241, '3.30.420.10-FF-000631', NULL, NULL, 159, NULL, NULL, 88241),
(88242, '3.40.50.300-FF-005499', NULL, 'DEAD-box ATP-dependent RNA helicase CshB', 183, NULL, NULL, 88242),
(88243, '3.40.50.300-FF-006808', NULL, 'Uncharacterized protein', 48, NULL, NULL, 88243),
(88244, '1.20.1070.10-FF-001933', NULL, 'Uncharacterized protein', 258, NULL, NULL, 88244),
(88245, '2.60.120.180-FF-000006', NULL, 'Glycoside hydrolase family 12', 240, NULL, NULL, 88245),
(88246, '3.30.40.10-FF-001619', NULL, 'RBR-type E3 ubiquitin transferase', 86, NULL, NULL, 88246),
(88247, '1.20.5.370-FF-000001', NULL, 'Myosin heavy chain', 53, NULL, NULL, 88247),
(88248, '1.20.1110.10-FF-000240', NULL, NULL, 165, NULL, NULL, 88248),
(88249, '3.40.50.740-FF-000044', NULL, 'NADH dehydrogenase I, G subunit', 74, NULL, NULL, 88249),
(88250, '6.20.50.170-FF-000001', NULL, 'Nucleoporin NUP145', 49, NULL, NULL, 88250),
(88251, '3.30.70.330-FF-002221', NULL, NULL, 114, NULL, NULL, 88251);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(88252, '1.50.10.20-FF-000096', NULL, 'Uncharacterized protein', 71, NULL, NULL, 88252),
(88253, '3.40.50.2000-FF-000511', NULL, 'Uncharacterized protein', 131, NULL, NULL, 88253),
(88254, '3.40.190.10-FF-000026', NULL, 'Glutamate ionotropic receptor NMDA type subunit 2A', 130, NULL, NULL, 88254),
(88255, '3.30.70.3460-FF-000002', NULL, 'Heme d1 biosynthesis protein NirH', 144, NULL, NULL, 88255),
(88256, '2.90.10.10-FF-000049', NULL, 'Serine/threonine-protein kinase', 181, NULL, NULL, 88256),
(88257, '2.60.260.20-FF-000028', NULL, 'DnaJ family protein', 71, NULL, NULL, 88257),
(88258, '3.50.50.60-FF-001387', NULL, 'Uncharacterized protein', 172, NULL, NULL, 88258),
(88259, '2.30.30.40-FF-000539', NULL, 'SH3 domain-containing protein', 61, NULL, NULL, 88259),
(88260, '3.30.1640.10-FF-000063', NULL, 'DNA helicase', 106, NULL, NULL, 88260),
(88261, '2.60.40.10-FF-004043', NULL, NULL, 97, NULL, NULL, 88261),
(88262, '3.20.80.10-FF-000060', NULL, 'Uncharacterized protein', 106, NULL, NULL, 88262),
(88263, '1.10.390.10-FF-000027', NULL, 'M4 family peptidase', 163, NULL, NULL, 88263),
(88264, '1.10.510.10-FF-000785', NULL, 'CMGC/CDK/CDK8 protein kinase', 232, NULL, NULL, 88264),
(88265, '2.130.10.10-FF-000564', NULL, 'WD repeat domain 41', 243, NULL, NULL, 88265),
(88266, '3.40.50.1000-FF-000880', NULL, NULL, 163, NULL, NULL, 88266),
(88267, '1.10.287.70-FF-000715', NULL, 'Predicted protein', 145, NULL, NULL, 88267),
(88268, '3.30.70.330-FF-001945', NULL, NULL, 126, NULL, NULL, 88268),
(88269, '1.25.40.20-FF-001746', NULL, 'Uncharacterized protein', 209, NULL, NULL, 88269),
(88270, '2.60.40.1930-FF-000019', NULL, 'C3 and PZP-like alpha-2-macroglobulin domain-containing protein 8', 97, NULL, NULL, 88270),
(88271, '3.30.60.30-FF-000093', NULL, 'GH09510p', 50, NULL, NULL, 88271),
(88272, '3.30.160.60-FF-003554', NULL, NULL, 25, NULL, NULL, 88272),
(88273, '2.130.10.10-FF-004616', NULL, 'Uncharacterized protein', 200, NULL, NULL, 88273),
(88274, '2.60.120.40-FF-000064', NULL, 'TNF superfamily member 11', 154, NULL, NULL, 88274),
(88275, '1.20.1560.10-FF-000717', NULL, 'Os08g0153000 protein', 261, NULL, NULL, 88275),
(88276, '3.30.160.60-FF-000906', NULL, 'Zinc finger protein 521', 83, NULL, NULL, 88276),
(88277, '2.20.70.10-FF-000180', NULL, 'Pre-mRNA-processing factor 40', 56, NULL, NULL, 88277),
(88278, '3.40.1260.10-FF-000014', NULL, 'Sulfur relay protein TusB/DsrH', 92, NULL, NULL, 88278),
(88279, '2.130.10.10-FF-000081', NULL, 'DNA damage-binding protein 1', 342, NULL, NULL, 88279),
(88280, '1.10.530.10-FF-000016', NULL, 'Uncharacterized protein, isoform B', 132, NULL, NULL, 88280),
(88281, '1.25.40.10-FF-004402', NULL, 'Os12g0490100 protein', 136, NULL, NULL, 88281),
(88282, '3.10.20.90-FF-000479', NULL, 'AT10981p', 88, NULL, NULL, 88282),
(88283, '3.30.710.10-FF-000041', NULL, 'Zinc finger protein 131', 154, NULL, NULL, 88283),
(88284, '3.80.10.10-FF-003841', NULL, 'PH domain and leucine rich repeat protein phosphatase 1', 286, NULL, NULL, 88284),
(88285, '3.40.50.300-FF-004673', NULL, 'Uncharacterized protein', 150, NULL, NULL, 88285),
(88286, '1.10.510.10-FF-000116', NULL, 'inactive tyrosine-protein kinase transmembrane receptor ROR1', 194, NULL, NULL, 88286),
(88287, '2.60.40.1390-FF-000026', NULL, 'Uncharacterized protein', 192, NULL, NULL, 88287),
(88288, '1.20.1250.20-FF-001708', NULL, 'Solute carrier organic anion transporter family, member 2B1', 119, NULL, NULL, 88288),
(88289, '1.25.40.20-FF-000920', NULL, 'Predicted protein', 218, NULL, NULL, 88289),
(88290, '3.40.1000.10-FF-000023', NULL, 'PsbP domain-containing protein 5, chloroplastic', 196, NULL, NULL, 88290),
(88291, '3.30.457.60-FF-000011', NULL, 'MAD (Yeast Mitosis arrest DeFicient) related', 87, NULL, NULL, 88291),
(88292, '1.20.1250.20-FF-001804', NULL, 'Uncharacterized protein', 169, NULL, NULL, 88292),
(88293, '1.10.10.60-FF-000070', NULL, 'DNA-binding protein SATB', 69, NULL, NULL, 88293),
(88294, '3.30.200.20-FF-001680', NULL, 'Myosin light chain kinase, smooth muscle', 77, NULL, NULL, 88294),
(88295, '1.50.40.10-FF-000156', NULL, 'Mitochondrial 2-oxoglutarate malate carrier', 291, NULL, NULL, 88295);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(88296, '3.40.525.10-FF-000029', NULL, 'alpha-tocopherol transfer protein-like', 145, NULL, NULL, 88296),
(88297, '1.25.40.10-FF-000220', NULL, 'Pre-mRNA-splicing factor SYF1', 170, NULL, NULL, 88297),
(88298, '3.90.1800.10-FF-000005', NULL, 'DNA-directed RNA polymerase subunit beta', 90, NULL, NULL, 88298),
(88299, '3.40.50.300-FF-002756', NULL, 'Dephospho-CoA kinase', 198, NULL, NULL, 88299),
(88300, '1.20.1070.10-FF-000410', NULL, 'Olfactory receptor 1348', 124, NULL, NULL, 88300),
(88301, '2.10.70.10-FF-000270', NULL, 'Uncharacterized protein', 65, NULL, NULL, 88301),
(88302, '3.40.50.300-FF-008372', NULL, 'Adenylate kinase 9', 198, NULL, NULL, 88302),
(88303, '1.10.287.370-FF-000075', NULL, 'Predicted protein', 140, NULL, NULL, 88303),
(88304, '3.40.630.150-FF-000021', NULL, 'Uncharacterized protein', 111, NULL, NULL, 88304),
(88305, '1.10.110.10-FF-000024', NULL, 'Metal-dependent protein hydrolase', 75, NULL, NULL, 88305),
(88306, '3.30.160.60-FF-003211', NULL, 'Hypermethylated in cancer 1', 31, NULL, NULL, 88306),
(88307, '3.40.50.300-FF-003032', NULL, 'Uncharacterized protein', 206, NULL, NULL, 88307),
(88308, '1.20.1390.10-FF-000013', NULL, 'Uncharacterized protein', 116, NULL, NULL, 88308),
(88309, '3.40.50.1460-FF-000091', NULL, 'Uncharacterized protein', 195, NULL, NULL, 88309),
(88310, '3.30.40.230-FF-000010', NULL, 'Glycine--tRNA ligase', 36, NULL, NULL, 88310),
(88311, '3.30.1370.10-FF-000070', NULL, 'Uncharacterized protein', 98, NULL, NULL, 88311),
(88312, '1.25.10.10-FF-000729', NULL, 'Unplaced genomic scaffold supercont2.16, whole genome shotgun sequence', 685, NULL, NULL, 88312),
(88313, '1.25.10.10-FF-001365', NULL, 'CBF/Mak21 family-domain-containing protein', 190, NULL, NULL, 88313),
(88314, '1.25.40.10-FF-001176', NULL, 'Pentatricopeptide repeat-containing protein At2g35030, mitochondrial', 86, NULL, NULL, 88314),
(88315, '3.40.47.10-FF-000162', NULL, NULL, 141, NULL, NULL, 88315),
(88316, '1.20.1280.40-FF-000002', NULL, 'OriC-binding nucleoid-associated protein', 71, NULL, NULL, 88316),
(88317, '3.80.10.10-FF-001812', NULL, 'Leucine-rich repeat family protein', 216, NULL, NULL, 88317),
(88318, '3.40.50.300-FF-004190', NULL, 'AIG1 family protein putative', 149, NULL, NULL, 88318),
(88319, '2.130.10.10-FF-005235', NULL, 'Uncharacterized protein', 324, NULL, NULL, 88319),
(88320, '2.60.40.60-FF-001079', NULL, 'Predicted protein', 110, NULL, NULL, 88320),
(88321, '1.20.870.10-FF-000017', NULL, 'Rap guanine nucleotide exchange factor 1', 156, NULL, NULL, 88321),
(88322, '3.40.50.150-FF-001733', NULL, NULL, 177, NULL, NULL, 88322),
(88323, '3.40.50.620-FF-000025', NULL, 'Bifunctional glutamate/proline--tRNA ligase', 110, NULL, NULL, 88323),
(88324, '1.25.40.20-FF-001403', NULL, 'Uncharacterized protein', 101, NULL, NULL, 88324),
(88325, '1.20.120.1530-FF-000001', NULL, 'Two-component osmosensing histidine kinase', 143, NULL, NULL, 88325),
(88326, '1.10.730.10-FF-000015', NULL, 'Valine--tRNA ligase', 244, NULL, NULL, 88326),
(88327, '1.10.8.50-FF-000004', NULL, 'Integration host factor', 104, NULL, NULL, 88327),
(88328, '2.30.29.30-FF-000584', NULL, 'Serine/threonine-protein kinase', 124, NULL, NULL, 88328),
(88329, '3.60.40.10-FF-000073', NULL, 'Putative phosphatase 2C', 286, NULL, NULL, 88329),
(88330, '1.10.10.60-FF-000553', NULL, 'Homeobox protein ceh-5', 69, NULL, NULL, 88330),
(88331, '3.40.630.10-FF-000274', NULL, 'Aminopeptidase, family M28, containing PA domain', 207, NULL, NULL, 88331),
(88332, '1.10.287.1490-FF-000142', NULL, 'Uncharacterized protein', 176, NULL, NULL, 88332),
(88333, '2.20.110.10-FF-000001', NULL, 'Junctophilin', 79, NULL, NULL, 88333),
(88334, '2.60.120.330-FF-000203', NULL, 'Uncharacterized protein', 131, NULL, NULL, 88334),
(88335, '2.30.33.40-FF-000012', NULL, '20 kDa chaperonin', 97, NULL, NULL, 88335),
(88336, '3.40.50.720-FF-002197', NULL, 'Predicted protein', 325, NULL, NULL, 88336),
(88337, '1.20.5.340-FF-000003', NULL, 'Myosin heavy chain', 118, NULL, NULL, 88337),
(88338, '2.60.120.590-FF-000039', NULL, 'Fat mass and obesity associated', 227, NULL, NULL, 88338);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(88339, '2.10.25.10-FF-001020', NULL, 'Delta-like protein', 35, NULL, NULL, 88339),
(88340, '2.40.30.20-FF-000022', NULL, 'Riboflavin synthase subunit alpha', 79, NULL, NULL, 88340),
(88341, '2.60.120.200-FF-000395', NULL, 'Galectin', 141, NULL, NULL, 88341),
(88342, '3.10.20.90-FF-000249', NULL, 'Ubiquitin D', 71, NULL, NULL, 88342),
(88343, '1.10.472.10-FF-000471', NULL, 'Transcription factor IIIB 50 kDa subunit', 105, NULL, NULL, 88343),
(88344, '3.40.640.10-FF-000331', NULL, 'ATP-binding cassette sub-family A member 3-like Protein', 247, NULL, NULL, 88344),
(88345, '2.40.280.10-FF-000003', NULL, 'SsrA-binding protein', 128, NULL, NULL, 88345),
(88346, '2.60.120.330-FF-000080', NULL, 'Uncharacterized protein', 147, NULL, NULL, 88346),
(88347, '3.30.70.330-FF-000304', NULL, 'RNA-binding protein 6 isoform X2', 119, NULL, NULL, 88347),
(88348, '1.10.510.10-FF-000908', NULL, 'Slowpoke binding protein, putative', 152, NULL, NULL, 88348),
(88349, '2.60.40.10-FF-004060', NULL, NULL, 96, NULL, NULL, 88349),
(88350, '1.20.1250.20-FF-001225', NULL, 'MFS transporter, putative (AFU_orthologue AFUA_2G00110)', 390, NULL, NULL, 88350),
(88351, '1.10.1200.10-FF-000165', NULL, 'Chromosome 19, whole genome shotgun sequence', 65, NULL, NULL, 88351),
(88352, '3.30.70.980-FF-000038', NULL, 'Uncharacterized protein', 66, NULL, NULL, 88352),
(88353, '1.20.1250.20-FF-000736', NULL, 'Sugar efflux transporter B', 190, NULL, NULL, 88353),
(88354, '1.10.510.10-FF-001061', NULL, 'eIF-2-alpha kinase GCN2', 262, NULL, NULL, 88354),
(88355, '3.10.20.90-FF-000119', NULL, 'Ubiquitin carboxyl-terminal hydrolase 14', 73, NULL, NULL, 88355),
(88356, '3.40.50.300-FF-004313', NULL, 'Os11g0177400 protein', 137, NULL, NULL, 88356),
(88357, '2.40.50.140-FF-000290', NULL, 'Probable RPT1-26S proteasome regulatory subunit', 63, NULL, NULL, 88357),
(88358, '3.40.50.1820-FF-000457', NULL, 'Putative esterase', 284, NULL, NULL, 88358),
(88359, '2.60.40.10-FF-000018', NULL, 'collagen alpha-1(XII) chain isoform X1', 93, NULL, NULL, 88359),
(88360, '3.40.1000.30-FF-000001', NULL, 'F-box only protein 7', 156, NULL, NULL, 88360),
(88361, '3.40.50.300-FF-002413', NULL, 'Gluconokinase', 169, NULL, NULL, 88361),
(88362, '3.30.70.330-FF-000208', NULL, 'RNA-binding protein 27 isoform X2', 92, NULL, NULL, 88362),
(88363, '3.30.450.30-FF-000009', NULL, 'Dynein light chain roadblock', 96, NULL, NULL, 88363),
(88364, '3.90.1200.10-FF-000050', NULL, 'Uncharacterized protein, isoform C', 316, NULL, NULL, 88364),
(88365, '2.20.100.10-FF-000158', NULL, 'Uncharacterized protein, isoform D', 63, NULL, NULL, 88365),
(88366, '2.30.30.490-FF-000089', NULL, 'Cytosine-specific methyltransferase', 122, NULL, NULL, 88366),
(88367, '2.60.40.10-FF-002935', NULL, 'Sialic acid-binding Ig-like lectin 15', 83, NULL, NULL, 88367),
(88368, '2.30.29.90-FF-000006', NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', 132, NULL, NULL, 88368),
(88369, '3.90.190.10-FF-000565', NULL, 'Uncharacterized protein', 73, NULL, NULL, 88369),
(88370, '3.30.1380.10-FF-000008', NULL, 'Hedgehog protein', 169, NULL, NULL, 88370),
(88371, '3.40.640.10-FF-000229', NULL, 'Aminotransferase', 229, NULL, NULL, 88371),
(88372, '3.30.70.1730-FF-000045', NULL, '60S acidic ribosomal protein P0', 25, NULL, NULL, 88372),
(88373, '1.10.238.10-FF-001169', NULL, 'Uncharacterized protein', 96, NULL, NULL, 88373),
(88374, '3.20.20.80-FF-000509', NULL, 'Chitinase, putative', 225, NULL, NULL, 88374),
(88375, '3.40.50.300-FF-001003', NULL, 'Vacuolar protein sorting-associated protein 4', 180, NULL, NULL, 88375),
(88376, '1.10.10.1420-FF-000002', NULL, 'CDT1-like protein a chloroplastic', 99, NULL, NULL, 88376),
(88377, '2.30.38.10-FF-000003', NULL, 'Vibriobactin-specific 2,3-dihydroxybenzoate-AMP ligase', 75, NULL, NULL, 88377),
(88378, '3.30.760.10-FF-000089', NULL, 'Uncharacterized protein', 125, NULL, NULL, 88378),
(88379, '1.20.272.10-FF-000077', NULL, NULL, 93, NULL, NULL, 88379),
(88380, '3.40.1000.50-FF-000007', NULL, 'Related to MAF1-negative regulator of RNA polymerase III', 133, NULL, NULL, 88380);
INSERT INTO "PUBLIC"."MODEL" VALUES
(88381, '1.10.533.10-FF-000141', NULL, 'Uncharacterized protein', 92, NULL, NULL, 88381),
(88382, '1.20.1250.20-FF-001012', NULL, 'Si:dkey-246g23.4', 102, NULL, NULL, 88382),
(88383, '1.20.120.1750-FF-000067', NULL, 'RBR-type E3 ubiquitin transferase', 104, NULL, NULL, 88383),
(88384, '3.30.70.1450-FF-000051', NULL, 'Transporter, sodium/sulfate symporter family', 78, NULL, NULL, 88384),
(88385, '2.130.10.10-FF-002138', NULL, 'Sortilin', 146, NULL, NULL, 88385),
(88386, '3.40.250.10-FF-000065', NULL, 'YOR286W-like protein', 117, NULL, NULL, 88386),
(88387, '1.25.10.10-FF-003265', NULL, 'Uncharacterized protein', 210, NULL, NULL, 88387),
(88388, '1.10.10.10-FF-000780', NULL, 'ORC1-type DNA replication protein', 102, NULL, NULL, 88388),
(88389, '1.10.840.10-FF-000006', NULL, 'son of sevenless homolog 1 isoform X2', 218, NULL, NULL, 88389),
(88390, '3.80.10.10-FF-000401', NULL, 'TOLL-like receptor 11', 143, NULL, NULL, 88390),
(88391, '3.20.20.140-FF-000481', NULL, 'Uncharacterized protein', 99, NULL, NULL, 88391),
(88392, '1.10.220.20-FF-000018', NULL, 'Uncharacterized protein', 78, NULL, NULL, 88392),
(88393, '2.60.40.1180-FF-000070', NULL, 'Alpha-galactosidase', 159, NULL, NULL, 88393),
(88394, '3.30.160.60-FF-000114', NULL, 'Zinc finger and BTB domain-containing protein 18', 28, NULL, NULL, 88394),
(88395, '1.25.40.10-FF-003997', NULL, 'Protein EBS1', 210, NULL, NULL, 88395),
(88396, '2.30.40.10-FF-000048', NULL, 'Related to guanine deaminase', 21, NULL, NULL, 88396),
(88397, '3.30.1410.10-FF-000006', NULL, 'Uncharacterized protein', 58, NULL, NULL, 88397),
(88398, '3.30.160.60-FF-002935', NULL, 'GD15791', 27, NULL, NULL, 88398),
(88399, '2.60.120.260-FF-000272', NULL, 'Putative wall-associated protein', 171, NULL, NULL, 88399),
(88400, '1.20.1060.20-FF-000002', NULL, 'Structural maintenance of chromosomes 3', 130, NULL, NULL, 88400),
(88401, '1.20.58.390-FF-000327', NULL, 'Uncharacterized protein', 127, NULL, NULL, 88401),
(88402, '1.10.510.10-FF-003882', NULL, NULL, 90, NULL, NULL, 88402),
(88403, '2.130.10.10-FF-004959', NULL, 'WD repeat domain 18', 91, NULL, NULL, 88403),
(88404, '2.70.170.10-FF-000106', NULL, 'Si:ch211-39a7.1', 48, NULL, NULL, 88404),
(88405, '3.30.1370.100-FF-000031', NULL, 'Uncharacterized protein', 131, NULL, NULL, 88405),
(88406, '1.10.238.10-FF-000652', NULL, 'Uncharacterized protein', 65, NULL, NULL, 88406),
(88407, '3.40.50.720-FF-000297', NULL, 'UDP-glucose 6-dehydrogenase', 101, NULL, NULL, 88407),
(88408, '3.30.70.330-FF-001153', NULL, 'Predicted protein', 154, NULL, NULL, 88408),
(88409, '3.80.10.10-FF-002329', NULL, 'Predicted protein', 182, NULL, NULL, 88409),
(88410, '2.30.30.140-FF-000018', NULL, 'Serine/threonine-protein kinase 31', 93, NULL, NULL, 88410),
(88411, '3.40.50.300-FF-000727', NULL, 'Protein SEY1 homolog', 273, NULL, NULL, 88411),
(88412, '3.40.91.90-FF-000001', NULL, 'Polymerase acidic protein', 198, NULL, NULL, 88412),
(88413, '3.40.630.10-FF-000403', NULL, 'Peptidase M20', 227, NULL, NULL, 88413),
(88414, '3.30.160.60-FF-001867', NULL, 'Zinc finger protein 430', 24, NULL, NULL, 88414),
(88415, '3.30.70.980-FF-000021', NULL, 'Probable transcriptional regulatory protein Chy400_1141', 80, NULL, NULL, 88415),
(88416, '1.10.8.60-FF-000350', NULL, 'N-ethylmaleimide sensitive factor, vesicle fusing ATPase', 63, NULL, NULL, 88416),
(88417, '3.30.160.60-FF-004043', NULL, NULL, 25, NULL, NULL, 88417),
(88418, '3.30.200.20-FF-001472', NULL, 'Uncharacterized protein', 53, NULL, NULL, 88418),
(88419, '3.40.630.30-FF-000605', NULL, 'Uncharacterized protein', 66, NULL, NULL, 88419),
(88420, '1.10.150.850-FF-000012', NULL, 'SH2 domain containing protein', 70, NULL, NULL, 88420),
(88421, '3.40.640.10-FF-000100', NULL, 'Putative acetylornithine aminotransferase', 240, NULL, NULL, 88421),
(88422, '3.80.10.10-FF-000856', NULL, 'Leucine-rich repeat-containing protein 30', 258, NULL, NULL, 88422),
(88423, '3.40.50.300-FF-001688', NULL, 'TetQ family GTPase, putative', 279, NULL, NULL, 88423),
(88424, '3.90.110.10-FF-000010', NULL, '6-phospho-alpha-glucosidase', 274, NULL, NULL, 88424); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(88425, '1.25.40.10-FF-003334', NULL, 'PPR repeat family, putative', 220, NULL, NULL, 88425),
(88426, '3.30.450.40-FF-000097', NULL, 'Two-component sensor histidine kinase', 138, NULL, NULL, 88426),
(88427, '2.170.300.10-FF-000048', NULL, 'scavenger receptor class F member 1 isoform X4', 64, NULL, NULL, 88427),
(88428, '3.30.1360.120-FF-000092', NULL, 'Uncharacterized protein', 146, NULL, NULL, 88428),
(88429, '3.30.70.330-FF-001720', NULL, NULL, 102, NULL, NULL, 88429),
(88430, '3.20.20.80-FF-000268', NULL, 'Glucan endo-1,3-alpha-glucosidase agn2', 280, NULL, NULL, 88430),
(88431, '3.40.50.150-FF-000305', NULL, 'S-adenosyl-L-methionine-dependent methyltransferase superfamily protein', 208, NULL, NULL, 88431),
(88432, '3.40.33.10-FF-000192', NULL, 'Uncharacterized protein', 88, NULL, NULL, 88432),
(88433, '3.30.160.60-FF-006185', NULL, NULL, 59, NULL, NULL, 88433),
(88434, '2.130.10.10-FF-005673', NULL, 'Uncharacterized protein', 162, NULL, NULL, 88434),
(88435, '3.90.226.10-FF-000273', NULL, 'Putative periplasmic protease', 181, NULL, NULL, 88435),
(88436, '2.30.110.10-FF-000050', NULL, 'Conserved protein', 122, NULL, NULL, 88436),
(88437, '3.60.40.10-FF-000281', NULL, 'Protein phosphatase 2C family protein', 90, NULL, NULL, 88437),
(88438, '3.90.550.10-FF-000436', NULL, 'Uncharacterized protein', 112, NULL, NULL, 88438),
(88439, '3.40.5.10-FF-000021', NULL, 'Mitochondrial 54S ribosomal protein MRPL50', 53, NULL, NULL, 88439),
(88440, '2.40.30.260-FF-000001', NULL, 'protein MTO1 homolog, mitochondrial isoform X1', 74, NULL, NULL, 88440),
(88441, '1.25.40.20-FF-000094', NULL, 'Oxysterol-binding protein', 147, NULL, NULL, 88441),
(88442, '2.180.10.10-FF-000028', NULL, 'Teneurin-1', 154, NULL, NULL, 88442),
(88443, '3.30.70.20-FF-000039', NULL, 'Chaperone protein DnaJ', 60, NULL, NULL, 88443),
(88444, '3.10.180.10-FF-000004', NULL, 'Lactoylglutathione lyase', 136, NULL, NULL, 88444),
(88445, '3.40.1360.10-FF-000044', NULL, 'DNA primase', 120, NULL, NULL, 88445),
(88446, '3.40.1280.30-FF-000004', NULL, 'tRNA (guanine(9)-N1)-methyltransferase', 200, NULL, NULL, 88446),
(88447, '3.40.50.11350-FF-000038', NULL, 'Uncharacterized protein', 174, NULL, NULL, 88447),
(88448, '3.90.1750.20-FF-000009', NULL, 'DNA recombinase', 180, NULL, NULL, 88448),
(88449, '3.30.40.10-FF-000214', NULL, 'E3 ubiquitin-protein ligase PDZRN3 isoform X1', 101, NULL, NULL, 88449),
(88450, '3.30.450.330-FF-000002', NULL, 'Cell division protein', 132, NULL, NULL, 88450),
(88451, '3.40.50.10810-FF-000118', NULL, 'Defense against restriction protein B', 104, NULL, NULL, 88451),
(88452, '3.30.300.10-FF-000004', NULL, 'S-adenosylmethionine synthase', 122, NULL, NULL, 88452),
(88453, '3.30.420.10-FF-000165', NULL, 'Ribonuclease D, putative', 211, NULL, NULL, 88453),
(88454, '1.20.1420.30-FF-000101', NULL, 'Uncharacterized protein', 190, NULL, NULL, 88454),
(88455, '3.40.50.720-FF-001365', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 163, NULL, NULL, 88455),
(88456, '3.40.50.720-FF-000746', NULL, '3-hydroxyisobutyrate dehydrogenase, mitochondrial', 177, NULL, NULL, 88456),
(88457, '1.10.760.10-FF-000056', NULL, '40-residue YVTN family beta-propeller', 115, NULL, NULL, 88457),
(88458, '2.60.40.10-FF-004622', NULL, NULL, 54, NULL, NULL, 88458),
(88459, '2.60.40.10-FF-000226', NULL, 'protein turtle homolog B', 99, NULL, NULL, 88459),
(88460, '1.25.40.40-FF-000004', NULL, 'Uncharacterized protein', 100, NULL, NULL, 88460),
(88461, '1.20.960.30-FF-000002', NULL, 'Platelet-activating factor acetylhydrolase ib', 86, NULL, NULL, 88461),
(88462, '3.30.420.40-FF-000174', NULL, 'Heat shock 70 kDa protein 8', 97, NULL, NULL, 88462),
(88463, '1.10.510.10-FF-000347', NULL, 'Apoptosis associated tyrosine kinase', 211, NULL, NULL, 88463),
(88464, '3.40.50.10810-FF-000017', NULL, 'ATP-dependent helicase BRM', 230, NULL, NULL, 88464),
(88465, '3.20.20.70-FF-000170', NULL, 'Fatty acid synthase', 282, NULL, NULL, 88465),
(88466, '1.20.1740.10-FF-000254', NULL, 'Protein CBG15341', 279, NULL, NULL, 88466),
(88467, '1.10.340.30-FF-000070', NULL, 'Endonuclease III-like protein 1', 55, NULL, NULL, 88467);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(88468, '3.30.2320.20-FF-000002', NULL, 'Leucine--tRNA ligase', 80, NULL, NULL, 88468),
(88469, '3.90.660.10-FF-000085', NULL, NULL, 153, NULL, NULL, 88469),
(88470, '3.40.50.970-FF-000107', NULL, 'Sulfoacetaldehyde acetyltransferase Xsc', 195, NULL, NULL, 88470),
(88471, '1.10.260.30-FF-000018', NULL, 'Signal recognition particle 54 kDa protein', 42, NULL, NULL, 88471),
(88472, '1.20.120.740-FF-000004', NULL, 'UPF0149 protein VC_2476', 189, NULL, NULL, 88472),
(88473, '3.60.21.10-FF-000259', NULL, '3'',5''-cyclic adenosine monophosphate phosphodiesterase CpdA', 260, NULL, NULL, 88473),
(88474, '3.40.1190.10-FF-000019', NULL, 'Mur ligase family protein', 242, NULL, NULL, 88474),
(88475, '3.40.250.10-FF-000177', NULL, 'Predicted protein', 73, NULL, NULL, 88475),
(88476, '2.60.120.200-FF-000748', NULL, 'Pentaxin', 137, NULL, NULL, 88476),
(88477, '3.40.50.1980-FF-000140', NULL, 'Metal binding protein, putative', 114, NULL, NULL, 88477),
(88478, '3.30.160.60-FF-006084', NULL, NULL, 38, NULL, NULL, 88478),
(88479, '2.60.40.150-FF-000134', NULL, 'BAI1-associated protein 3 isoform X1', 206, NULL, NULL, 88479),
(88480, '3.40.50.300-FF-001115', NULL, 'DNA mismatch repair protein MSH2', 293, NULL, NULL, 88480),
(88481, '2.130.10.10-FF-003970', NULL, 'Predicted protein', 238, NULL, NULL, 88481),
(88482, '2.10.50.10-FF-000156', NULL, 'Uncharacterized protein', 59, NULL, NULL, 88482),
(88483, '3.10.250.10-FF-000116', NULL, NULL, 71, NULL, NULL, 88483),
(88484, '1.10.10.10-FF-001729', NULL, 'Response regulator receiver domain protein', 108, NULL, NULL, 88484),
(88485, '1.10.472.10-FF-000139', NULL, 'Cyclin E1', 91, NULL, NULL, 88485),
(88486, '3.40.50.11900-FF-000001', NULL, 'Putative 2-hydroxyglutaryl-CoA dehydratase, D-component', 143, NULL, NULL, 88486),
(88487, '3.10.20.70-FF-000029', NULL, 'Uncharacterized protein', 100, NULL, NULL, 88487),
(88488, '3.10.28.10-FF-000041', NULL, 'DNA polymerase', 169, NULL, NULL, 88488),
(88489, '1.10.472.80-FF-000216', NULL, NULL, 149, NULL, NULL, 88489),
(88490, '1.10.390.30-FF-000005', NULL, 'Uncharacterized protein', 124, NULL, NULL, 88490),
(88491, '2.40.50.140-FF-001150', NULL, 'DNA repair protein RecO', 84, NULL, NULL, 88491),
(88492, '3.40.630.30-FF-000510', NULL, 'Uncharacterized protein', 167, NULL, NULL, 88492),
(88493, '1.10.510.10-FF-001757', NULL, 'Aurora kinase', 208, NULL, NULL, 88493),
(88494, '1.20.1640.10-FF-000089', NULL, 'Protein translocase subunit SecD', 196, NULL, NULL, 88494),
(88495, '2.130.10.10-FF-001733', NULL, 'Os01g0183100 protein', 195, NULL, NULL, 88495),
(88496, '3.40.50.300-FF-001896', NULL, 'Ferrous iron transport protein B', 180, NULL, NULL, 88496),
(88497, '3.30.470.20-FF-000002', NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta', 153, NULL, NULL, 88497),
(88498, '3.50.50.60-FF-000190', NULL, 'Thioredoxin reductase', 457, NULL, NULL, 88498),
(88499, '3.90.1180.10-FF-000002', NULL, '60S ribosomal protein L16', 149, NULL, NULL, 88499),
(88500, '3.30.2160.10-FF-000026', NULL, 'Ubiquitin protein ligase, putative', 78, NULL, NULL, 88500),
(88501, '1.10.10.520-FF-000018', NULL, 'SUMO-activating enzyme subunit', 122, NULL, NULL, 88501),
(88502, '1.10.630.10-FF-000732', NULL, 'Uncharacterized protein', 92, NULL, NULL, 88502),
(88503, '3.90.550.10-FF-000099', NULL, 'Bactoprenol glucosyl transferase', 189, NULL, NULL, 88503),
(88504, '1.25.10.10-FF-002888', NULL, 'Uncharacterized protein', 146, NULL, NULL, 88504),
(88505, '3.30.420.40-FF-000269', NULL, 'Carbohydrate kinase', 236, NULL, NULL, 88505),
(88506, '1.10.238.10-FF-000551', NULL, 'Mutated in colorectal cancer isoform 1', 87, NULL, NULL, 88506),
(88507, '3.30.160.60-FF-004740', NULL, NULL, 28, NULL, NULL, 88507),
(88508, '2.60.260.40-FF-000006', NULL, 'NADH dehydrogenase [ubiquinone] iron-sulfur protein 6, mitochondrial', 47, NULL, NULL, 88508),
(88509, '3.30.160.60-FF-000457', NULL, 'B-cell lymphoma 6 protein-like', 27, NULL, NULL, 88509),
(88510, '2.130.10.10-FF-004263', NULL, 'WD repeat-containing planar cell polarity effector', 135, NULL, NULL, 88510),
(88511, '3.90.70.10-FF-000303', NULL, 'Uncharacterized protein', 288, NULL, NULL, 88511);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(88512, '3.40.309.10-FF-000050', NULL, 'Phenylacetic acid degradation protein PaaN', 211, NULL, NULL, 88512),
(88513, '3.50.50.60-FF-000414', NULL, 'POSSIBLE FLAVOPROTEIN', 333, NULL, NULL, 88513),
(88514, '2.60.220.50-FF-000001', NULL, 'Adhesion G protein-coupled receptor L2', 196, NULL, NULL, 88514),
(88515, '1.20.1260.20-FF-000001', NULL, 'PPE family protein PPE41', 174, NULL, NULL, 88515),
(88516, '2.10.25.10-FF-000856', NULL, 'Crumbs', 25, NULL, NULL, 88516),
(88517, '1.10.3080.10-FF-000088', NULL, 'Chloride channel protein', 146, NULL, NULL, 88517),
(88518, '3.40.50.720-FF-000960', NULL, 'Acyl-CoA synthetase, putative', 326, NULL, NULL, 88518),
(88519, '3.50.50.60-FF-000302', NULL, 'Protoporphyrinogen oxidase', 167, NULL, NULL, 88519),
(88520, '3.20.70.20-FF-000017', NULL, 'Vitamin B12-dependent ribonucleotide reductase', 151, NULL, NULL, 88520),
(88521, '3.30.70.330-FF-002434', NULL, NULL, 156, NULL, NULL, 88521),
(88522, '3.40.50.2000-FF-001028', NULL, 'UDP-N-acetylglucosamine transferase subunit ALG14 homolog', 171, NULL, NULL, 88522),
(88523, '2.10.70.10-FF-000169', NULL, 'Mannan-binding lectin serine peptidase 1', 73, NULL, NULL, 88523),
(88524, '2.60.120.1380-FF-000001', NULL, 'Alginate biosynthesis protein AlgX', 118, NULL, NULL, 88524),
(88525, '1.10.510.10-FF-002713', NULL, NULL, 62, NULL, NULL, 88525),
(88526, '1.10.1140.10-FF-000014', NULL, 'Uncharacterized protein', 71, NULL, NULL, 88526),
(88527, '2.10.25.10-FF-000755', NULL, 'Blast:Protein slit', 49, NULL, NULL, 88527),
(88528, '3.40.50.1820-FF-000906', NULL, 'Neuroligin 1', 61, NULL, NULL, 88528),
(88529, '1.10.420.10-FF-000014', NULL, 'Catalase-peroxidase 2', 188, NULL, NULL, 88529),
(88530, '3.30.40.10-FF-001850', NULL, 'SR-related CTD-associated factor 11', 82, NULL, NULL, 88530),
(88531, '3.90.70.10-FF-000427', NULL, 'Cathepsin C', 234, NULL, NULL, 88531),
(88532, '1.20.1060.10-FF-000011', NULL, 'DNA polymerase theta', 116, NULL, NULL, 88532),
(88533, '1.20.1270.10-FF-000066', NULL, 'DnaK protein', 109, NULL, NULL, 88533),
(88534, '3.10.580.10-FF-000214', NULL, 'Protein CBR-CLH-6', 193, NULL, NULL, 88534),
(88535, '2.60.40.10-FF-002273', NULL, 'Disorganized muscle protein 1', 105, NULL, NULL, 88535),
(88536, '1.20.5.1230-FF-000004', NULL, NULL, 183, NULL, NULL, 88536),
(88537, '3.20.20.60-FF-000054', NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', 269, NULL, NULL, 88537),
(88538, '3.40.1170.10-FF-000024', NULL, 'Muts domain V-domain-containing protein', 115, NULL, NULL, 88538),
(88539, '2.60.60.20-FF-000017', NULL, 'Polycystin 1 like 1, transient receptor potential channel interacting', 129, NULL, NULL, 88539),
(88540, '3.40.50.300-FF-000278', NULL, 'Structural maintenance of chromosomes 2', 202, NULL, NULL, 88540),
(88541, '2.60.40.10-FF-001654', NULL, 'Cytokine receptor common subunit beta', 95, NULL, NULL, 88541),
(88542, '3.30.160.60-FF-002486', NULL, 'Zinc finger protein 549', 26, NULL, NULL, 88542),
(88543, '3.50.50.60-FF-000291', NULL, 'Peroxisomal N(1)-acetyl-spermine/spermidine oxidase', 233, NULL, NULL, 88543),
(88544, '2.40.10.120-FF-000006', NULL, 'Genome polyprotein', 196, NULL, NULL, 88544),
(88545, '2.60.120.10-FF-000178', NULL, 'Mannose-6-phosphate isomerase, class I', 156, NULL, NULL, 88545),
(88546, '3.60.10.10-FF-000245', NULL, 'DNAse I-like superfamily protein', 283, NULL, NULL, 88546),
(88547, '3.40.50.300-FF-003133', NULL, 'Regulator of nonsense transcripts 1-like protein', 203, NULL, NULL, 88547),
(88548, '1.20.1560.10-FF-000509', NULL, 'ABC transporter, MRP family', 345, NULL, NULL, 88548),
(88549, '2.60.40.10-FF-004291', NULL, NULL, 89, NULL, NULL, 88549),
(88550, '3.90.550.50-FF-000077', NULL, 'Hexosyltransferase', 216, NULL, NULL, 88550),
(88551, '1.10.472.10-FF-000027', NULL, 'G2/mitotic-specific cyclin-B1', 130, NULL, NULL, 88551),
(88552, '2.10.60.10-FF-000084', NULL, 'Uncharacterized protein', 83, NULL, NULL, 88552),
(88553, '3.30.230.10-FF-000240', NULL, 'DNA topoisomerase 2', 124, NULL, NULL, 88553),
(88554, '3.40.50.1820-FF-000895', NULL, 'Uncharacterized protein', 259, NULL, NULL, 88554);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(88555, '2.40.110.10-FF-000025', NULL, 'Acyl-CoA dehydrogenase, C-terminal domain protein', 110, NULL, NULL, 88555),
(88556, '3.30.70.1230-FF-000120', NULL, 'Olfactory guanylyl cyclase GC-D', 68, NULL, NULL, 88556),
(88557, '1.20.120.350-FF-000096', NULL, 'Sodium channel protein', 110, NULL, NULL, 88557),
(88558, '1.50.40.10-FF-000257', NULL, 'Carnitine/acyl carnitine carrier', 139, NULL, NULL, 88558),
(88559, '2.60.40.10-FF-003897', NULL, NULL, 107, NULL, NULL, 88559),
(88560, '3.40.1380.20-FF-000048', NULL, 'Pyruvate kinase', 123, NULL, NULL, 88560),
(88561, '1.20.120.1240-FF-000021', NULL, 'Dynamin-related protein 4C', 256, NULL, NULL, 88561),
(88562, '2.40.70.10-FF-000111', NULL, 'Plasmepsin IX', 41, NULL, NULL, 88562),
(88563, '1.10.630.10-FF-000631', NULL, 'Cytochrome P450, family 2, subfamily R, polypeptide 1', 228, NULL, NULL, 88563),
(88564, '1.10.8.60-FF-000119', NULL, 'Lon protease', 93, NULL, NULL, 88564),
(88565, '1.20.58.1780-FF-000017', NULL, 'Chromosome 10, whole genome shotgun sequence', 330, NULL, NULL, 88565),
(88566, '1.20.120.980-FF-000060', NULL, 'Uncharacterized protein', 13, NULL, NULL, 88566),
(88567, '1.10.10.60-FF-001059', NULL, NULL, 49, NULL, NULL, 88567),
(88568, '1.20.120.1760-FF-000053', NULL, NULL, 106, NULL, NULL, 88568),
(88569, '3.30.870.10-FF-000193', NULL, 'Uncharacterized protein', 66, NULL, NULL, 88569),
(88570, '3.90.1600.10-FF-000030', NULL, 'DNA polymerase II', 209, NULL, NULL, 88570),
(88571, '3.30.160.60-FF-005465', NULL, NULL, 30, NULL, NULL, 88571),
(88572, '3.40.50.1000-FF-000088', NULL, 'Probable bifunctional methylthioribulose-1-phosphate dehydratase/enolase-phosphatase E1', 133, NULL, NULL, 88572),
(88573, '1.20.1270.280-FF-000002', NULL, 'Dynein heavy chain 5, axonemal', 168, NULL, NULL, 88573),
(88574, '2.120.10.30-FF-000520', NULL, 'Uncharacterized protein', 179, NULL, NULL, 88574),
(88575, '3.40.30.10-FF-000646', NULL, 'Disulphide-isomerase', 139, NULL, NULL, 88575),
(88576, '1.20.1250.20-FF-001916', NULL, 'Monocarboxylate transporter, putative', 227, NULL, NULL, 88576),
(88577, '2.60.200.20-FF-000250', NULL, 'Uncharacterized protein', 163, NULL, NULL, 88577),
(88578, '3.10.20.90-FF-000687', NULL, 'ISG15 ubiquitin-like modifier', 76, NULL, NULL, 88578),
(88579, '3.40.50.300-FF-004881', NULL, 'Uncharacterized protein', 94, NULL, NULL, 88579),
(88580, '2.40.160.10-FF-000056', NULL, 'Predicted protein', 292, NULL, NULL, 88580),
(88581, '1.10.3470.10-FF-000011', NULL, 'Fe(3+)-hydroxamate ABC transporter permease FhuB', 328, NULL, NULL, 88581),
(88582, '3.10.110.10-FF-000174', NULL, 'Ubiquitin-conjugating enzyme family protein', 152, NULL, NULL, 88582),
(88583, '1.20.58.60-FF-000707', NULL, 'Predicted protein', 110, NULL, NULL, 88583),
(88584, '3.80.20.20-FF-000006', NULL, 'Receptor protein-tyrosine kinase', 188, NULL, NULL, 88584),
(88585, '2.40.70.10-FF-000235', NULL, 'GD19153', 150, NULL, NULL, 88585),
(88586, '2.40.100.10-FF-000064', NULL, 'Peptidyl-prolyl cis-trans isomerase CPR4', 181, NULL, NULL, 88586),
(88587, '1.20.1270.60-FF-000154', NULL, 'Sorting nexin-2', 223, NULL, NULL, 88587),
(88588, '2.60.40.10-FF-001749', NULL, 'Neural/ectodermal development factor IMP-L2', 94, NULL, NULL, 88588),
(88589, '2.40.50.140-FF-000531', NULL, 'mRNA capping enzyme, putative', 124, NULL, NULL, 88589),
(88590, '3.30.50.10-FF-000142', NULL, 'Uncharacterized protein', 104, NULL, NULL, 88590),
(88591, '1.20.120.350-FF-000202', NULL, NULL, 123, NULL, NULL, 88591),
(88592, '3.40.50.10330-FF-000053', NULL, 'NAD kinase 1', 137, NULL, NULL, 88592),
(88593, '2.60.40.2030-FF-000027', NULL, 'Adhesion G protein-coupled receptor V1', 118, NULL, NULL, 88593),
(88594, '3.30.40.10-FF-001271', NULL, 'Uncharacterized ATP-dependent helicase C17A2.12', 102, NULL, NULL, 88594),
(88595, '3.30.40.10-FF-001041', NULL, 'HL01030p', 45, NULL, NULL, 88595),
(88596, '2.60.40.1730-FF-000050', NULL, 'Aminopeptidase', 241, NULL, NULL, 88596),
(88597, '3.40.1350.10-FF-000010', NULL, 'Heteromeric transposase endonuclease subunit TnsA', 162, NULL, NULL, 88597),
(88598, '1.20.1560.10-FF-000268', NULL, 'ABC transporter ATP-binding protein', 47, NULL, NULL, 88598);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(88599, '1.25.40.20-FF-000465', NULL, 'Os09g0343200 protein', 101, NULL, NULL, 88599),
(88600, '1.20.58.370-FF-000001', NULL, 'Maltose ABC transporter permease MalF', 95, NULL, NULL, 88600),
(88601, '1.10.510.10-FF-002258', NULL, 'CMGC/SRPK protein kinase', 271, NULL, NULL, 88601),
(88602, '3.40.50.300-FF-008271', NULL, 'Uncharacterized protein', 41, NULL, NULL, 88602),
(88603, '3.40.50.1820-FF-000002', NULL, 'S-formylglutathione hydrolase', 280, NULL, NULL, 88603),
(88604, '3.80.10.10-FF-003386', NULL, 'Predicted protein', 102, NULL, NULL, 88604),
(88605, '3.40.50.200-FF-000135', NULL, 'Tripeptidyl peptidase I', 117, NULL, NULL, 88605),
(88606, '2.60.40.2070-FF-000011', NULL, 'Outer membrane usher protein FasD', 77, NULL, NULL, 88606),
(88607, '3.30.565.10-FF-000079', NULL, 'DNA mismatch repair protein MLH', 212, NULL, NULL, 88607),
(88608, '2.70.160.11-FF-000039', NULL, 'Related to HMT1-hnRNP arginine N-methyltransferase', 196, NULL, NULL, 88608),
(88609, '3.30.750.44-FF-000012', NULL, 'Peptidase, S41 family', 50, NULL, NULL, 88609),
(88610, '1.10.287.160-FF-000029', NULL, 'Protein kinase N1', 58, NULL, NULL, 88610),
(88611, '3.30.40.10-FF-000765', NULL, 'Transcription initiation factor TFIIE alpha subunit, putative', 60, NULL, NULL, 88611),
(88612, '1.20.120.140-FF-000021', NULL, 'Signal recognition particle receptor FtsY', 96, NULL, NULL, 88612),
(88613, '3.80.10.10-FF-000160', NULL, 'Protein zer-1 homolog isoform X1', 101, NULL, NULL, 88613),
(88614, '3.40.50.10190-FF-000331', NULL, 'Uncharacterized protein', 56, NULL, NULL, 88614),
(88615, '2.60.40.150-FF-000713', NULL, 'Uncharacterized protein', 135, NULL, NULL, 88615),
(88616, '3.30.70.590-FF-000011', NULL, 'WGS project CABT00000000 data, contig 2.5', 140, NULL, NULL, 88616),
(88617, '3.30.200.20-FF-002214', NULL, 'Uncharacterized protein', 44, NULL, NULL, 88617),
(88618, '3.30.2300.10-FF-000015', NULL, 'THUMP domain protein', 78, NULL, NULL, 88618),
(88619, '1.25.40.180-FF-000002', NULL, 'Eukaryotic translation initiation factor 4 gamma, 3, putative', 153, NULL, NULL, 88619),
(88620, '3.30.559.30-FF-000014', NULL, 'Nonribosomal siderophore peptide synthase SidC', 251, NULL, NULL, 88620),
(88621, '3.30.830.10-FF-000196', NULL, 'Metalloprotease, insulinase family protein', 251, NULL, NULL, 88621),
(88622, '1.10.10.10-FF-000549', NULL, 'Transcriptional regulator, MarR family', 137, NULL, NULL, 88622),
(88623, '1.20.960.10-FF-000007', NULL, 'Mitochondrial import receptor subunit TOM20-like protein B', 86, NULL, NULL, 88623),
(88624, '1.10.150.20-FF-000142', NULL, 'Exonuclease I, putative', 71, NULL, NULL, 88624),
(88625, '3.90.70.10-FF-000219', NULL, 'CaLPain Related', 139, NULL, NULL, 88625),
(88626, '3.70.10.10-FF-000025', NULL, 'AGAP002522-PA', 261, NULL, NULL, 88626),
(88627, '1.20.1250.20-FF-002310', NULL, 'MFS drug transporter, putative', 164, NULL, NULL, 88627),
(88628, '1.25.40.10-FF-001985', NULL, 'Os09g0520300 protein', 112, NULL, NULL, 88628),
(88629, '3.30.230.10-FF-000010', NULL, 'Lon protease', 188, NULL, NULL, 88629),
(88630, '3.40.50.2000-FF-000854', NULL, 'Glycosyltransferase', 230, NULL, NULL, 88630),
(88631, '3.40.50.150-FF-001278', NULL, NULL, 224, NULL, NULL, 88631),
(88632, '3.50.7.10-FF-000082', NULL, NULL, 31, NULL, NULL, 88632),
(88633, '1.25.40.10-FF-004391', NULL, 'Tetratricopeptide repeat protein, putative', 141, NULL, NULL, 88633),
(88634, '2.60.40.1170-FF-000084', NULL, NULL, 153, NULL, NULL, 88634),
(88635, '1.10.260.70-FF-000002', NULL, 'DNA-binding protein SATB', 23, NULL, NULL, 88635),
(88636, '1.20.120.160-FF-000027', NULL, 'Sensory box sensor histidine kinase/response regulator', 116, NULL, NULL, 88636),
(88637, '3.30.160.60-FF-004408', NULL, NULL, 47, NULL, NULL, 88637),
(88638, '2.40.40.20-FF-000079', NULL, 'Uncharacterized protein', 60, NULL, NULL, 88638),
(88639, '3.30.260.10-FF-000079', NULL, NULL, 90, NULL, NULL, 88639),
(88640, '3.30.70.260-FF-000159', NULL, 'Bifunctional chorismate mutase/prephenate dehydratase', 92, NULL, NULL, 88640),
(88641, '2.10.220.10-FF-000028', NULL, 'Fraser extracellular matrix complex subunit 1', 100, NULL, NULL, 88641);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(88642, '3.30.40.10-FF-000422', NULL, 'RING/FYVE/PHD zinc finger superfamily protein', 66, NULL, NULL, 88642),
(88643, '2.60.40.10-FF-006089', NULL, NULL, 111, NULL, NULL, 88643),
(88644, '2.20.80.10-FF-000023', NULL, 'Apolipophorins-like protein', 200, NULL, NULL, 88644),
(88645, '3.80.10.10-FF-002537', NULL, 'Uncharacterized protein', 102, NULL, NULL, 88645),
(88646, '1.20.1050.10-FF-000061', NULL, 'Glutathione S-transferase 3', 128, NULL, NULL, 88646),
(88647, '1.25.40.180-FF-000345', NULL, NULL, 109, NULL, NULL, 88647),
(88648, '3.90.1410.10-FF-000083', NULL, 'Ribosomal lysine N-methyltransferase 4', 263, NULL, NULL, 88648),
(88649, '3.40.50.300-FF-007652', NULL, 'ABC transporter, putative', 133, NULL, NULL, 88649),
(88650, '3.30.160.60-FF-003312', NULL, 'Zinc finger protein 438', 30, NULL, NULL, 88650),
(88651, '3.30.200.20-FF-000977', NULL, 'S-receptor kinase-like', 101, NULL, NULL, 88651),
(88652, '3.30.160.60-FF-002694', NULL, 'Zinc finger protein 729', 31, NULL, NULL, 88652),
(88653, '3.40.1110.10-FF-000127', NULL, 'Probable cation-transporting ATPase exp7', 130, NULL, NULL, 88653),
(88654, '3.30.1330.30-FF-000051', NULL, 'Protein pelota homolog', 102, NULL, NULL, 88654),
(88655, '1.10.510.10-FF-004287', NULL, NULL, 168, NULL, NULL, 88655),
(88656, '1.10.10.580-FF-000008', NULL, 'OJ991113_30.15 protein', 111, NULL, NULL, 88656),
(88657, '3.40.1160.10-FF-000063', NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase 2, chloroplastic', 73, NULL, NULL, 88657),
(88658, '2.40.50.140-FF-001256', NULL, NULL, 56, NULL, NULL, 88658),
(88659, '1.25.40.10-FF-002261', NULL, 'Sel1 repeat protein', 107, NULL, NULL, 88659),
(88660, '1.25.40.10-FF-004161', NULL, 'Chromosome 8, whole genome shotgun sequence', 104, NULL, NULL, 88660),
(88661, '3.40.50.300-FF-004229', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 243, NULL, NULL, 88661),
(88662, '3.40.390.30-FF-000002', NULL, 'Holo-[acyl-carrier-protein] synthase', 163, NULL, NULL, 88662),
(88663, '1.20.920.10-FF-000229', NULL, 'Alpha-galactosidase', 143, NULL, NULL, 88663),
(88664, '2.60.40.420-FF-000249', NULL, 'Uncharacterized protein', 199, NULL, NULL, 88664),
(88665, '3.40.50.1000-FF-000200', NULL, 'NLI interacting factor-like phosphatase, putative', 180, NULL, NULL, 88665),
(88666, '2.60.120.560-FF-000042', NULL, 'Predicted protein', 59, NULL, NULL, 88666),
(88667, '3.30.420.110-FF-000020', NULL, 'Msh1p', 140, NULL, NULL, 88667),
(88668, '1.20.1070.10-FF-000865', NULL, 'LOW QUALITY PROTEIN: uncharacterized protein LOC108100164', 197, NULL, NULL, 88668),
(88669, '2.60.40.10-FF-003099', NULL, 'Titin homolog', 106, NULL, NULL, 88669),
(88670, '1.20.5.170-FF-000273', NULL, 'Uncharacterized protein', 68, NULL, NULL, 88670),
(88671, '1.10.3450.30-FF-000004', NULL, 'Predicted protein', 195, NULL, NULL, 88671),
(88672, '1.10.10.60-FF-001267', NULL, NULL, 77, NULL, NULL, 88672),
(88673, '3.30.160.60-FF-006308', NULL, NULL, 30, NULL, NULL, 88673),
(88674, '1.25.40.10-FF-003885', NULL, 'Uncharacterized protein', 81, NULL, NULL, 88674),
(88675, '3.30.1240.10-FF-000066', NULL, 'Hydrolase (HAD superfamily)', 52, NULL, NULL, 88675),
(88676, '3.30.420.10-FF-000518', NULL, NULL, 121, NULL, NULL, 88676),
(88677, '2.130.10.10-FF-001278', NULL, 'Compass component swd1', 159, NULL, NULL, 88677),
(88678, '1.20.5.30-FF-000003', NULL, 'cartilage matrix protein-like', 42, NULL, NULL, 88678),
(88679, '3.30.70.660-FF-000066', NULL, 'Uncharacterized protein', 173, NULL, NULL, 88679),
(88680, '1.10.460.10-FF-000011', NULL, 'DNA topoisomerase I', 158, NULL, NULL, 88680),
(88681, '3.40.50.300-FF-006224', NULL, 'Uncharacterized protein', 114, NULL, NULL, 88681),
(88682, '1.20.1250.20-FF-001793', NULL, 'Uncharacterized protein', 177, NULL, NULL, 88682),
(88683, '1.10.510.10-FF-000813', NULL, 'Aurora-like kinase', 271, NULL, NULL, 88683),
(88684, '1.20.1070.10-FF-001141', NULL, 'G-protein coupled receptor 126', 297, NULL, NULL, 88684),
(88685, '3.10.196.10-FF-000012', NULL, 'Methionine synthase', 241, NULL, NULL, 88685),
(88686, '3.40.50.300-FF-006359', NULL, 'Uncharacterized protein', 140, NULL, NULL, 88686);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(88687, '3.10.20.30-FF-000046', NULL, 'Obg-like ATPase 1', 77, NULL, NULL, 88687),
(88688, '3.40.50.880-FF-000069', NULL, 'CTP synthase', 227, NULL, NULL, 88688),
(88689, '3.30.43.10-FF-000007', NULL, 'UDP-N-acetylenolpyruvoylglucosamine reductase', 66, NULL, NULL, 88689),
(88690, '2.40.70.10-FF-000027', NULL, 'Aspartic proteinase Asp1 isoform A', 181, NULL, NULL, 88690),
(88691, '3.40.50.150-FF-000429', NULL, 'Ribosomal RNA small subunit methyltransferase G', 204, NULL, NULL, 88691),
(88692, '3.40.50.1820-FF-001755', NULL, 'Uncharacterized protein', 311, NULL, NULL, 88692),
(88693, '2.40.30.10-FF-000114', NULL, '5-methyltetrahydrofolate-homocysteine methyltransferase reductase', 90, NULL, NULL, 88693),
(88694, '1.10.472.80-FF-000008', NULL, 'TBC1 domain family member 10A', 147, NULL, NULL, 88694),
(88695, '3.30.160.60-FF-002351', NULL, 'Unplaced genomic scaffold supercont1.68, whole genome shotgun sequence', 48, NULL, NULL, 88695),
(88696, '3.40.50.150-FF-001839', NULL, NULL, 58, NULL, NULL, 88696),
(88697, '3.40.47.10-FF-000050', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 2', 145, NULL, NULL, 88697),
(88698, '2.30.42.10-FF-000210', NULL, 'Patj, isoform B', 94, NULL, NULL, 88698),
(88699, '3.30.930.10-FF-000029', NULL, 'Lysine--tRNA ligase', 375, NULL, NULL, 88699),
(88700, '1.10.287.950-FF-000041', NULL, 'Methyl-accepting chemotaxis sensory transducer', 161, NULL, NULL, 88700),
(88701, '1.10.10.10-FF-001977', NULL, 'Predicted protein', 62, NULL, NULL, 88701),
(88702, '3.30.497.10-FF-000033', NULL, 'serpin B3', 233, NULL, NULL, 88702),
(88703, '3.30.70.330-FF-001265', NULL, 'Unplaced genomic scaffold supercont1.20, whole genome shotgun sequence', 154, NULL, NULL, 88703),
(88704, '3.40.50.1820-FF-001412', NULL, 'Uncharacterized protein', 204, NULL, NULL, 88704),
(88705, '4.10.60.10-FF-000091', NULL, 'Zinc finger CCHC-type-containing 9', 54, NULL, NULL, 88705),
(88706, '1.20.140.150-FF-000034', NULL, 'Germ cell associated 1', 237, NULL, NULL, 88706),
(88707, '3.30.300.160-FF-000008', NULL, 'Type IV pilus assembly protein PilB', 69, NULL, NULL, 88707),
(88708, '3.30.210.10-FF-000008', NULL, 'DNA polymerase beta', 63, NULL, NULL, 88708),
(88709, '3.10.50.40-FF-000096', NULL, 'Peptidyl-prolyl cis-trans isomerase', 118, NULL, NULL, 88709),
(88710, '2.70.170.10-FF-000191', NULL, 'Uncharacterized protein', 203, NULL, NULL, 88710),
(88711, '2.60.120.480-FF-000006', NULL, 'Ureidoglycolate hydrolase', 176, NULL, NULL, 88711),
(88712, '3.40.50.2300-FF-000163', NULL, 'LacI family transcriptional regulator', 120, NULL, NULL, 88712),
(88713, '3.30.200.20-FF-002534', NULL, NULL, 27, NULL, NULL, 88713),
(88714, '1.25.40.20-FF-001645', NULL, 'Uncharacterized protein', 92, NULL, NULL, 88714),
(88715, '1.10.560.10-FF-000075', NULL, 'Bardet-Biedl syndrome 10', 117, NULL, NULL, 88715),
(88716, '3.40.50.300-FF-001790', NULL, 'Protein translocase subunit SecA', 211, NULL, NULL, 88716),
(88717, '3.40.50.720-FF-001466', NULL, 'Pyrroline-5-carboxylate reductase', 164, NULL, NULL, 88717),
(88718, '2.30.30.40-FF-000438', NULL, 'Tyrosine-protein kinase', 37, NULL, NULL, 88718),
(88719, '1.10.10.60-FF-000441', NULL, 'Homeotic protein bicoid', 68, NULL, NULL, 88719),
(88720, '3.30.70.330-FF-000989', NULL, 'RNA Binding Motif protein homolog', 112, NULL, NULL, 88720),
(88721, '3.30.70.870-FF-000005', NULL, 'Ribosome-releasing factor 2, mitochondrial', 74, NULL, NULL, 88721),
(88722, '1.10.555.10-FF-000085', NULL, 'Rho GTPase-activating protein-like protein', 132, NULL, NULL, 88722),
(88723, '1.25.40.10-FF-000349', NULL, 'Putative Pre-mRNA-splicing factor syf1', 329, NULL, NULL, 88723),
(88724, '1.10.8.270-FF-000114', NULL, 'GTPase-activating protein, putative', 130, NULL, NULL, 88724),
(88725, '2.130.10.10-FF-003886', NULL, 'Uncharacterized protein', 276, NULL, NULL, 88725),
(88726, '2.30.29.30-FF-000808', NULL, 'Eps8 like 1b', 131, NULL, NULL, 88726),
(88727, '2.60.40.60-FF-000461', NULL, 'Protein CBG15736', 97, NULL, NULL, 88727),
(88728, '3.20.20.80-FF-000723', NULL, 'Putative chitinase 3-like Protein', 149, NULL, NULL, 88728);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(88729, '3.30.70.330-FF-000759', NULL, 'RNA binding protein', 78, NULL, NULL, 88729),
(88730, '1.25.40.10-FF-001288', NULL, 'Os01g0280400 protein', 99, NULL, NULL, 88730),
(88731, '1.20.1070.10-FF-000989', NULL, 'Vomeronasal type-1 receptor', 241, NULL, NULL, 88731),
(88732, '3.40.50.300-FF-007539', NULL, 'Uncharacterized protein', 201, NULL, NULL, 88732),
(88733, '3.40.1190.20-FF-000135', NULL, 'Multifunctional fusion protein', 255, NULL, NULL, 88733),
(88734, '1.20.58.340-FF-000003', NULL, 'Zinc transport protein ZntB', 58, NULL, NULL, 88734),
(88735, '2.160.20.10-FF-000344', NULL, 'Uncharacterized protein', 260, NULL, NULL, 88735),
(88736, '2.60.40.10-FF-004414', NULL, NULL, 99, NULL, NULL, 88736),
(88737, '3.30.70.100-FF-000033', NULL, 'Copper-transporting ATPase HMA5', 72, NULL, NULL, 88737),
(88738, '3.50.50.60-FF-001139', NULL, 'Uncharacterized protein', 99, NULL, NULL, 88738),
(88739, '3.20.20.10-FF-000079', NULL, 'Predicted protein', 60, NULL, NULL, 88739),
(88740, '1.10.1040.10-FF-000079', NULL, 'NAD binding domain of 6-phosphogluconate dehydrogenase/NAD-binding of NADP-dependent 3-hydroxyisobutyrate dehydrogenase, putative', 136, NULL, NULL, 88740),
(88741, '4.10.400.10-FF-000294', NULL, 'Uncharacterized protein', 34, NULL, NULL, 88741),
(88742, '2.60.120.10-FF-000633', NULL, '5-nitrosalicylic acid 1,2-dioxygenase', 194, NULL, NULL, 88742),
(88743, '3.40.50.1820-FF-001194', NULL, 'Uncharacterized protein', 188, NULL, NULL, 88743),
(88744, '3.30.310.10-FF-000061', NULL, 'Coatomer subunit gamma', 84, NULL, NULL, 88744),
(88745, '1.20.5.470-FF-000014', NULL, 'Uncharacterized protein', 40, NULL, NULL, 88745),
(88746, '2.40.30.10-FF-000238', NULL, 'Elongation factor, putative', 120, NULL, NULL, 88746),
(88747, '3.30.70.330-FF-000416', NULL, 'CCR4-NOT transcription complex subunit 4, putative', 82, NULL, NULL, 88747),
(88748, '3.30.200.20-FF-001697', NULL, 'Uncharacterized protein', 63, NULL, NULL, 88748),
(88749, '3.20.20.190-FF-000142', NULL, NULL, 102, NULL, NULL, 88749),
(88750, '1.10.287.110-FF-000025', NULL, 'dnaJ homolog subfamily A member 3, mitochondrial isoform X2', 114, NULL, NULL, 88750),
(88751, '3.30.9.10-FF-000029', NULL, 'N,N-dimethylglycine oxidase', 157, NULL, NULL, 88751),
(88752, '1.20.5.190-FF-000020', NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', 50, NULL, NULL, 88752),
(88753, '1.10.3890.10-FF-000003', NULL, 'High frequency lysogenization protein HflD homolog', 204, NULL, NULL, 88753),
(88754, '3.40.50.300-FF-004105', NULL, 'Predicted protein', 223, NULL, NULL, 88754),
(88755, '3.30.470.20-FF-000103', NULL, 'D-alanine--D-alanine ligase', 144, NULL, NULL, 88755),
(88756, '3.60.21.50-FF-000012', NULL, 'DNA polymerase delta subunit 2, putative', 344, NULL, NULL, 88756),
(88757, '2.60.120.620-FF-000071', NULL, '2-oxoglutarate and iron-dependent oxygenase domain-containing protein', 259, NULL, NULL, 88757),
(88758, '3.10.100.10-FF-000117', NULL, 'Mannose receptor, C type 1b', 138, NULL, NULL, 88758),
(88759, '1.25.40.10-FF-004059', NULL, 'Glr1376 protein', 122, NULL, NULL, 88759),
(88760, '2.130.10.10-FF-000452', NULL, 'TBC1 domain family member 31 isoform X1', 99, NULL, NULL, 88760),
(88761, '3.30.70.1620-FF-000012', NULL, 'Structural maintenance of chromosomes protein', 68, NULL, NULL, 88761),
(88762, '3.40.850.10-FF-000498', NULL, 'Uncharacterized protein', 44, NULL, NULL, 88762),
(88763, '1.20.1560.10-FF-000829', NULL, 'Chromosome 7, whole genome shotgun sequence', 357, NULL, NULL, 88763),
(88764, '1.20.120.1900-FF-000022', NULL, 'Spindle pole body component', 317, NULL, NULL, 88764),
(88765, '1.10.20.10-FF-000281', NULL, NULL, 74, NULL, NULL, 88765),
(88766, '3.40.50.2000-FF-000399', NULL, 'UDP-glucosyltransferase', 206, NULL, NULL, 88766),
(88767, '2.10.25.140-FF-000001', NULL, 'Delta-like protein', 46, NULL, NULL, 88767),
(88768, '3.40.50.2300-FF-001568', NULL, NULL, 160, NULL, NULL, 88768),
(88769, '2.10.25.10-FF-001475', NULL, 'Neurogenic locus protein delta', 39, NULL, NULL, 88769),
(88770, '3.30.559.10-FF-000267', NULL, 'Vinorine synthase', 211, NULL, NULL, 88770);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(88771, '2.130.10.10-FF-004504', NULL, 'Uncharacterized protein', 238, NULL, NULL, 88771),
(88772, '3.30.930.10-FF-000361', NULL, 'Phenylalanyl-tRNA synthetase, alpha subunit family protein', 278, NULL, NULL, 88772),
(88773, '3.30.30.30-FF-000034', NULL, 'Related to SSZ1-regulator protein involved in pleiotropic drug resistance', 54, NULL, NULL, 88773),
(88774, '3.40.50.300-FF-004561', NULL, 'Dynein heavy chain family protein', 183, NULL, NULL, 88774),
(88775, '2.60.40.790-FF-000118', NULL, NULL, 101, NULL, NULL, 88775),
(88776, '1.25.10.10-FF-001792', NULL, 'Uncharacterized protein', 584, NULL, NULL, 88776),
(88777, '2.60.40.3710-FF-000003', NULL, 'L,D-transpeptidase 5', 110, NULL, NULL, 88777),
(88778, '1.25.40.850-FF-000006', NULL, 'Vacuolar protein sorting-associated protein 33B', 96, NULL, NULL, 88778),
(88779, '3.90.550.10-FF-000335', NULL, 'CMP-N-acetlyneuraminic acid synthetase', 226, NULL, NULL, 88779),
(88780, '1.25.40.10-FF-003542', NULL, 'Putative two-component system sensor histidine kinase', 102, NULL, NULL, 88780),
(88781, '1.20.58.1210-FF-000004', NULL, 'Exocyst complex component EXO84C', 108, NULL, NULL, 88781),
(88782, '1.25.40.990-FF-000020', NULL, 'Unplaced genomic scaffold supercont2.13, whole genome shotgun sequence', 373, NULL, NULL, 88782),
(88783, '2.60.120.290-FF-000039', NULL, 'LDL receptor related protein 10', 118, NULL, NULL, 88783),
(88784, '2.60.40.640-FF-000091', NULL, 'Arrestin domain-containing protein', 159, NULL, NULL, 88784),
(88785, '1.25.40.540-FF-000032', NULL, 'Uncharacterized protein', 231, NULL, NULL, 88785),
(88786, '3.40.50.261-FF-000014', NULL, 'Acyl-CoA synthetase FdrA', 140, NULL, NULL, 88786),
(88787, '3.50.50.60-FF-001471', NULL, 'Succinate dehydrogenase1', 62, NULL, NULL, 88787),
(88788, '3.30.160.60-FF-000356', NULL, 'E3 ubiquitin-protein ligase ZFP91', 31, NULL, NULL, 88788),
(88789, '3.40.50.1100-FF-000016', NULL, 'Cysteine synthase A', 113, NULL, NULL, 88789),
(88790, '2.60.200.20-FF-000019', NULL, 'Nuclear inhibitor of protein phosphatase', 131, NULL, NULL, 88790),
(88791, '2.60.120.10-FF-000072', NULL, 'cGMP-dependent protein kinase', 132, NULL, NULL, 88791),
(88792, '2.130.10.10-FF-003762', NULL, 'FG-GAP repeat protein, putative', 323, NULL, NULL, 88792),
(88793, '2.10.25.160-FF-000007', NULL, 'Granulin b', 67, NULL, NULL, 88793),
(88794, '3.40.50.300-FF-007995', NULL, 'Uncharacterized protein', 154, NULL, NULL, 88794),
(88795, '2.40.50.100-FF-000093', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 100, NULL, NULL, 88795),
(88796, '3.40.50.1000-FF-000099', NULL, 'Trehalose 6-phosphate phosphatase', 88, NULL, NULL, 88796),
(88797, '3.40.50.720-FF-002303', NULL, 'Predicted protein', 147, NULL, NULL, 88797),
(88798, '1.20.120.1810-FF-000006', NULL, 'RNA polymerase sigma factor RpoH', 78, NULL, NULL, 88798),
(88799, '1.10.472.130-FF-000032', NULL, 'Dynein heavy chain', 151, NULL, NULL, 88799),
(88800, '3.40.50.1000-FF-000655', NULL, NULL, 94, NULL, NULL, 88800),
(88801, '1.10.530.40-FF-000008', NULL, 'Lambda phage lysozyme R', 176, NULL, NULL, 88801),
(88802, '3.30.160.60-FF-004279', NULL, NULL, 38, NULL, NULL, 88802),
(88803, '3.40.50.300-FF-003588', NULL, 'GM04779p', 203, NULL, NULL, 88803),
(88804, '2.130.10.10-FF-000553', NULL, 'Katanin p80 WD40 repeat-containing subunit B1 homolog', 156, NULL, NULL, 88804),
(88805, '3.40.50.10190-FF-000095', NULL, 'Mutator 2, isoform B', 93, NULL, NULL, 88805),
(88806, '3.60.10.10-FF-000110', NULL, 'Putative carbon catabolite repressor protein 4', 336, NULL, NULL, 88806),
(88807, '1.10.730.10-FF-000223', NULL, 'Uncharacterized protein', 178, NULL, NULL, 88807),
(88808, '1.25.40.10-FF-000344', NULL, 'Pentatricopeptide repeat-containing protein', 155, NULL, NULL, 88808),
(88809, '3.30.830.10-FF-000331', NULL, 'Presequence protease', 35, NULL, NULL, 88809),
(88810, '3.30.40.10-FF-002007', NULL, 'Uncharacterized protein', 50, NULL, NULL, 88810),
(88811, '2.40.110.10-FF-000002', NULL, 'Acyl-CoA dehydrogenase fadE12', 114, NULL, NULL, 88811),
(88812, '3.40.50.720-FF-000510', NULL, 'Putative oxidoreductase', 206, NULL, NULL, 88812);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(88813, '3.30.70.2370-FF-000001', NULL, 'Subtilisin-like protease 2', 89, NULL, NULL, 88813),
(88814, '3.10.105.10-FF-000095', NULL, 'ABC-type transport system periplasmic substrate-binding protein (Probable substrate dipeptide/oligopeptide)', 225, NULL, NULL, 88814),
(88815, '4.10.280.10-FF-000058', NULL, 'transcription factor BEE 3-like', 72, NULL, NULL, 88815),
(88816, '3.90.470.10-FF-000042', NULL, 'Uncharacterized protein', 132, NULL, NULL, 88816),
(88817, '3.80.10.10-FF-001126', NULL, 'Receptor-like protein kinase HSL1 isoform A', 251, NULL, NULL, 88817),
(88818, '2.40.40.20-FF-000056', NULL, 'Oxidoreductase', 134, NULL, NULL, 88818),
(88819, '2.60.220.30-FF-000012', NULL, 'Metastasis-associated in colon cancer 1', 149, NULL, NULL, 88819),
(88820, '1.25.40.10-FF-004615', NULL, 'Pre-mRNA-splicing factor prp1', 161, NULL, NULL, 88820),
(88821, '1.25.40.1040-FF-000055', NULL, 'N(alpha)-acetyltransferase 15, NatA auxiliary subunit', 271, NULL, NULL, 88821),
(88822, '2.40.10.10-FF-000462', NULL, NULL, 161, NULL, NULL, 88822),
(88823, '3.40.50.300-FF-002065', NULL, 'ABC transporter C family member 13', 253, NULL, NULL, 88823),
(88824, '2.60.40.10-FF-000468', NULL, 'Glycogen debranching enzyme', 133, NULL, NULL, 88824),
(88825, '1.25.40.10-FF-005234', NULL, 'Predicted protein', 177, NULL, NULL, 88825),
(88826, '3.90.1150.10-FF-000045', NULL, '5-aminolevulinate synthase', 107, NULL, NULL, 88826),
(88827, '1.10.150.20-FF-000030', NULL, 'Flap endonuclease GEN-like 1', 60, NULL, NULL, 88827),
(88828, '3.40.50.720-FF-001022', NULL, 'Predicted gene 15294', 17, NULL, NULL, 88828),
(88829, '3.80.10.10-FF-001233', NULL, 'Leucine-rich repeat containing protein', 153, NULL, NULL, 88829),
(88830, '1.25.40.10-FF-005127', NULL, 'Pentatricopeptide repeat-containing protein ELI1 chloroplastic', 108, NULL, NULL, 88830),
(88831, '2.10.25.10-FF-000300', NULL, 'Pro-epidermal growth factor', 36, NULL, NULL, 88831),
(88832, '3.40.50.2300-FF-000955', NULL, NULL, 120, NULL, NULL, 88832),
(88833, '1.20.1730.10-FF-000091', NULL, 'Uncharacterized protein', 366, NULL, NULL, 88833),
(88834, '3.30.420.40-FF-000842', NULL, 'Luminal-binding protein 2', 93, NULL, NULL, 88834),
(88835, '3.40.50.2300-FF-001467', NULL, NULL, 150, NULL, NULL, 88835),
(88836, '1.10.8.10-FF-000245', NULL, 'DExH-box helicase 57', 72, NULL, NULL, 88836),
(88837, '2.40.160.120-FF-000012', NULL, 'Oxysterol-binding protein-related protein 2A', 172, NULL, NULL, 88837),
(88838, '3.30.60.30-FF-000199', NULL, 'Secreted protein, acidic, cysteine-rich (osteonectin)', 41, NULL, NULL, 88838),
(88839, '2.60.40.60-FF-000106', NULL, 'FAT atypical cadherin 4', 107, NULL, NULL, 88839),
(88840, '3.90.320.10-FF-000048', NULL, 'Exodeoxyribonuclease V subunit beta', 93, NULL, NULL, 88840),
(88841, '2.30.30.140-FF-000248', NULL, 'Metal-response element-binding transcription factor 2', 52, NULL, NULL, 88841),
(88842, '3.40.50.2300-FF-000270', NULL, 'Two-component system response regulator', 126, NULL, NULL, 88842),
(88843, '1.10.400.10-FF-000018', NULL, 'Guanine nucleotide-binding protein alpha-12 subunit', 123, NULL, NULL, 88843),
(88844, '3.40.30.10-FF-000168', NULL, 'Glutathione S-transferase 2', 83, NULL, NULL, 88844),
(88845, '2.60.120.920-FF-000054', NULL, 'Histone-lysine N-methyltransferase (Bre2), putative', 224, NULL, NULL, 88845),
(88846, '3.30.40.10-FF-002114', NULL, 'E3 ubiquitin-protein ligase', 29, NULL, NULL, 88846),
(88847, '1.25.40.10-FF-001861', NULL, 'GG10246', 115, NULL, NULL, 88847),
(88848, '3.30.160.60-FF-000120', NULL, 'Zinc finger protein 430', 28, NULL, NULL, 88848),
(88849, '1.20.1560.10-FF-000493', NULL, 'ABC transporter ATP-binding protein', 152, NULL, NULL, 88849),
(88850, '3.40.50.150-FF-000660', NULL, 'Hercynine oxygenase', 193, NULL, NULL, 88850),
(88851, '2.60.40.3710-FF-000008', NULL, 'Glr0971 protein', 112, NULL, NULL, 88851),
(88852, '1.20.58.830-FF-000049', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 145, NULL, NULL, 88852),
(88853, '3.40.50.300-FF-005842', NULL, 'ABC-type transporter, ATPase component and permease component', 196, NULL, NULL, 88853);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(88854, '2.130.10.10-FF-005443', NULL, 'Predicted protein', 207, NULL, NULL, 88854),
(88855, '3.40.50.620-FF-000250', NULL, 'Electron transfer flavoprotein subunit beta', 181, NULL, NULL, 88855),
(88856, '2.30.30.100-FF-000023', NULL, 'Small nuclear ribonucleoprotein G', 76, NULL, NULL, 88856),
(88857, '3.40.50.2000-FF-000056', NULL, 'Glycosyltransferase', 199, NULL, NULL, 88857),
(88858, '3.30.40.10-FF-000990', NULL, 'E3 ubiquitin-protein ligase MIR1', 60, NULL, NULL, 88858),
(88859, '1.10.287.110-FF-000469', NULL, 'J-type co-chaperone jac1, mitochondrial', 100, NULL, NULL, 88859),
(88860, '1.10.3090.10-FF-000026', NULL, 'tRNA nucleotidyltransferase', 144, NULL, NULL, 88860),
(88861, '3.20.20.105-FF-000020', NULL, 'Queuine tRNA-ribosyltransferase accessory subunit 2', 112, NULL, NULL, 88861),
(88862, '1.20.1070.10-FF-001372', NULL, 'Purinergic receptor P2Y13', 257, NULL, NULL, 88862),
(88863, '3.20.90.10-FF-000010', NULL, NULL, 171, NULL, NULL, 88863),
(88864, '3.30.70.330-FF-002889', NULL, NULL, 59, NULL, NULL, 88864),
(88865, '2.40.100.10-FF-000069', NULL, 'Peptidyl-prolyl cis-trans isomerase', 162, NULL, NULL, 88865),
(88866, '1.20.120.350-FF-000207', NULL, NULL, 127, NULL, NULL, 88866),
(88867, '2.130.10.10-FF-005336', NULL, 'Uncharacterized protein', 186, NULL, NULL, 88867),
(88868, '3.40.50.300-FF-005735', NULL, 'Serine/threonine-protein phosphatase', 153, NULL, NULL, 88868),
(88869, '2.40.10.230-FF-000016', NULL, 'Uncharacterized protein', 57, NULL, NULL, 88869),
(88870, '3.40.50.300-FF-000519', NULL, 'ISWI chromatin-remodeling complex ATPase CHR11', 293, NULL, NULL, 88870),
(88871, '1.10.10.60-FF-000109', NULL, 'Homeobox protein MOX-2', 93, NULL, NULL, 88871),
(88872, '3.30.160.60-FF-003767', NULL, 'Zinc finger protein 233', 32, NULL, NULL, 88872),
(88873, '1.10.287.1660-FF-000002', NULL, 'Erythrocyte binding antigen 140', 30, NULL, NULL, 88873),
(88874, '2.130.10.10-FF-005229', NULL, 'Uncharacterized protein', 58, NULL, NULL, 88874),
(88875, '1.20.1250.20-FF-001580', NULL, 'Uncharacterized protein', 357, NULL, NULL, 88875),
(88876, '3.90.870.10-FF-000027', NULL, 'Threonylcarbamoyl-AMP synthase YrdC', 192, NULL, NULL, 88876),
(88877, '3.30.430.20-FF-000005', NULL, 'Cysteine-rich receptor-like protein kinase 2', 102, NULL, NULL, 88877),
(88878, '1.10.3470.10-FF-000016', NULL, 'Metal ABC transporter permease', 255, NULL, NULL, 88878),
(88879, '3.10.105.10-FF-000100', NULL, 'ABC-type transport system periplasmic substrate-binding protein (Probable substrate dipeptide/oligopeptide)', 236, NULL, NULL, 88879),
(88880, '4.10.280.10-FF-000070', NULL, 'transcription factor bHLH30', 64, NULL, NULL, 88880),
(88881, '3.40.80.10-FF-000014', NULL, 'N-acetylmuramoyl-L-alanine amidase', 177, NULL, NULL, 88881),
(88882, '1.10.20.10-FF-000269', NULL, NULL, 70, NULL, NULL, 88882),
(88883, '4.10.60.10-FF-000085', NULL, 'Zinc knuckle nucleic acid binding protein, putative', 69, NULL, NULL, 88883),
(88884, '3.10.25.10-FF-000017', NULL, 'Methionyl-tRNA formyltransferase', 101, NULL, NULL, 88884),
(88885, '3.40.50.300-FF-000626', NULL, 'probable ATP-dependent RNA helicase DDX47', 174, NULL, NULL, 88885),
(88886, '1.10.390.10-FF-000016', NULL, 'Glutamyl aminopeptidase', 253, NULL, NULL, 88886),
(88887, '2.30.39.10-FF-000067', NULL, 'GM17927', 151, NULL, NULL, 88887),
(88888, '2.30.30.700-FF-000001', NULL, 'Actin cytoskeleton-regulatory complex protein SLA1', 66, NULL, NULL, 88888),
(88889, '1.20.1070.10-FF-001135', NULL, 'G protein-coupled receptor 17', 301, NULL, NULL, 88889),
(88890, '3.40.50.2300-FF-000051', NULL, 'Two-component response regulator yehT', 128, NULL, NULL, 88890),
(88891, '2.60.120.260-FF-000047', NULL, 'Reelin', 61, NULL, NULL, 88891),
(88892, '3.40.50.1110-FF-000126', NULL, 'Uncharacterized protein', 346, NULL, NULL, 88892),
(88893, '3.30.160.60-FF-000805', NULL, 'RE1-silencing transcription factor B', 76, NULL, NULL, 88893),
(88894, '3.80.10.10-FF-001918', NULL, 'Uncharacterized protein', 59, NULL, NULL, 88894),
(88895, '1.20.58.90-FF-000014', NULL, 'Type III secretion apparatus needle protein YscF', 82, NULL, NULL, 88895);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(88896, '3.40.140.10-FF-000079', NULL, 'DNA dC->dU-editing enzyme APOBEC-3', 180, NULL, NULL, 88896),
(88897, '2.100.10.30-FF-000015', NULL, 'Griffithsin', 121, NULL, NULL, 88897),
(88898, '3.30.160.60-FF-002481', NULL, 'Zinc finger protein 572', 32, NULL, NULL, 88898),
(88899, '1.10.760.10-FF-000051', NULL, 'Cytochrome c, mono- and diheme variants', 119, NULL, NULL, 88899),
(88900, '2.60.40.1910-FF-000002', NULL, 'Aminopeptidase', 90, NULL, NULL, 88900),
(88901, '3.40.50.1100-FF-000011', NULL, 'Cysteine synthase (o-acetylserine)', 113, NULL, NULL, 88901),
(88902, '3.20.20.120-FF-000031', NULL, 'L-Ala-D/L-Glu epimerase', 230, NULL, NULL, 88902),
(88903, '3.30.70.60-FF-000023', NULL, 'Uncharacterized protein', 116, NULL, NULL, 88903),
(88904, '3.10.20.10-FF-000040', NULL, 'Uncharacterized protein', 101, NULL, NULL, 88904),
(88905, '2.130.10.10-FF-001969', NULL, 'Hypothetical_protein_-_conserved', 234, NULL, NULL, 88905),
(88906, '3.40.120.10-FF-000084', NULL, 'Slr1334 protein', 110, NULL, NULL, 88906),
(88907, '3.30.70.80-FF-000029', NULL, 'Peptidase S8', 80, NULL, NULL, 88907),
(88908, '3.40.30.10-FF-000410', NULL, 'Mitochondrial ribosomal protein L53', 118, NULL, NULL, 88908),
(88909, '1.25.10.10-FF-000735', NULL, 'E3 ubiquitin-protein ligase TRIP12', 296, NULL, NULL, 88909),
(88910, '3.90.220.20-FF-000004', NULL, 'Type I restriction-modification system, S subunit', 150, NULL, NULL, 88910),
(88911, '1.20.58.60-FF-000359', NULL, 'Spectrin repeat containing, nuclear envelope 1a', 232, NULL, NULL, 88911),
(88912, '1.20.1060.10-FF-000016', NULL, 'DNA polymerase nu', 129, NULL, NULL, 88912),
(88913, '3.10.290.10-FF-000001', NULL, '30S ribosomal protein S4', 97, NULL, NULL, 88913),
(88914, '1.10.1450.10-FF-000110', NULL, 'Tetraspanin', 131, NULL, NULL, 88914),
(88915, '1.25.40.10-FF-004508', NULL, 'Signal recognition particle subunit SRP72', 90, NULL, NULL, 88915),
(88916, '2.30.29.30-FF-000123', NULL, 'cerebral cavernous malformations 2 protein-like', 147, NULL, NULL, 88916),
(88917, '3.30.420.80-FF-000039', NULL, 'Uncharacterized protein', 67, NULL, NULL, 88917),
(88918, '3.20.110.10-FF-000014', NULL, 'Alpha-mannosidase F', 272, NULL, NULL, 88918),
(88919, '3.20.20.140-FF-000037', NULL, 'Dihydropyrimidinase', 326, NULL, NULL, 88919),
(88920, '2.10.25.10-FF-001031', NULL, 'Eater', 62, NULL, NULL, 88920),
(88921, '3.40.50.1820-FF-000682', NULL, '2-(acetamidomethylene)succinate hydrolase', 268, NULL, NULL, 88921),
(88922, '2.60.40.10-FF-000249', NULL, 'myosin-binding protein C, slow-type isoform X4', 98, NULL, NULL, 88922),
(88923, '3.90.70.10-FF-000539', NULL, 'Ubiquitin carboxyl-terminal hydrolase 2', 341, NULL, NULL, 88923),
(88924, '3.40.1360.10-FF-000067', NULL, 'Uncharacterized protein', 173, NULL, NULL, 88924),
(88925, '2.60.40.10-FF-005577', NULL, NULL, 89, NULL, NULL, 88925),
(88926, '3.40.50.1000-FF-000436', NULL, 'Uncharacterized protein', 214, NULL, NULL, 88926),
(88927, '1.10.510.10-FF-001196', NULL, 'Unplaced genomic scaffold supercont1.15, whole genome shotgun sequence', 310, NULL, NULL, 88927),
(88928, '3.40.50.1000-FF-000548', NULL, NULL, 247, NULL, NULL, 88928),
(88929, '3.40.30.10-FF-000298', NULL, 'Thioredoxin-related transmembrane protein 3', 117, NULL, NULL, 88929),
(88930, '1.10.10.60-FF-000542', NULL, 'Terminase small subunit', 112, NULL, NULL, 88930),
(88931, '2.30.30.40-FF-000545', NULL, 'AGAP000255-PE', 22, NULL, NULL, 88931),
(88932, '3.80.10.10-FF-002649', NULL, 'Transforming growth factor beta activator LRRC33', 127, NULL, NULL, 88932),
(88933, '3.80.10.10-FF-001363', NULL, 'Slit homolog 1 protein', 189, NULL, NULL, 88933),
(88934, '2.130.10.10-FF-000772', NULL, 'WD repeat domain 90', 181, NULL, NULL, 88934),
(88935, '3.90.1800.10-FF-000011', NULL, 'Predicted protein', 101, NULL, NULL, 88935),
(88936, '3.30.160.60-FF-000794', NULL, 'zinc finger protein 2 isoform X2', 32, NULL, NULL, 88936),
(88937, '2.60.40.10-FF-000805', NULL, 'Uncharacterized protein, isoform F', 107, NULL, NULL, 88937),
(88938, '3.40.50.2300-FF-000848', NULL, NULL, 128, NULL, NULL, 88938),
(88939, '1.10.510.10-FF-000577', NULL, 'SH3 domain binding kinase family member 3', 196, NULL, NULL, 88939);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(88940, '3.80.10.10-FF-003049', NULL, 'Protein CBG14615', 333, NULL, NULL, 88940),
(88941, '3.30.230.20-FF-000001', NULL, 'UDP-3-O-acyl-N-acetylglucosamine deacetylase', 128, NULL, NULL, 88941),
(88942, '3.50.50.60-FF-001151', NULL, 'Uncharacterized protein', 70, NULL, NULL, 88942),
(88943, '3.30.505.10-FF-000199', NULL, NULL, 86, NULL, NULL, 88943),
(88944, '3.30.830.10-FF-000089', NULL, 'Zinc protease, insulinase family', 210, NULL, NULL, 88944),
(88945, '2.70.150.10-FF-000301', NULL, 'Uncharacterized protein', 66, NULL, NULL, 88945),
(88946, '1.10.510.10-FF-002027', NULL, 'Mitogen-activated protein kinase kinase kinase kinase 5', 146, NULL, NULL, 88946),
(88947, '1.10.730.20-FF-000001', NULL, 'Isoleucine--tRNA ligase', 290, NULL, NULL, 88947),
(88948, '3.60.10.10-FF-000003', NULL, 'Synaptojanin-1 isoform 1', 378, NULL, NULL, 88948),
(88949, '3.40.366.10-FF-000013', NULL, 'Malonyl CoA-acyl carrier protein transacylase, putative', 212, NULL, NULL, 88949),
(88950, '3.40.50.300-FF-005954', NULL, 'DNA mismatch repair protein', 206, NULL, NULL, 88950),
(88951, '3.40.50.720-FF-001921', NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', 173, NULL, NULL, 88951),
(88952, '3.90.260.10-FF-000009', NULL, 'Hemocyte protein-glutamine gamma-glutamyltransferase', 331, NULL, NULL, 88952),
(88953, '3.40.390.10-FF-000232', NULL, NULL, 103, NULL, NULL, 88953),
(88954, '3.40.50.300-FF-006354', NULL, 'Uncharacterized protein', 141, NULL, NULL, 88954),
(88955, '3.10.20.90-FF-000018', NULL, 'Plexin A2', 117, NULL, NULL, 88955),
(88956, '3.40.50.12710-FF-000031', NULL, 'Protein arginine methyltransferase NDUFAF7 homolog, mitochondrial', 294, NULL, NULL, 88956),
(88957, '2.10.25.10-FF-000295', NULL, 'Wnt inhibitory factor 1', 68, NULL, NULL, 88957),
(88958, '3.30.497.10-FF-000038', NULL, 'Serpin peptidase inhibitor, clade B (ovalbumin), member 4', 88, NULL, NULL, 88958),
(88959, '3.40.630.30-FF-000049', NULL, 'Amino-acid acetyltransferase, mitochondrial', 167, NULL, NULL, 88959),
(88960, '3.30.565.10-FF-000192', NULL, 'Two-component sensor histidine kinase VicK', 159, NULL, NULL, 88960),
(88961, '2.10.25.10-FF-001716', NULL, 'Predicted protein', 59, NULL, NULL, 88961),
(88962, '3.40.50.720-FF-001241', NULL, 'Type I glyceraldehyde-3-phosphate dehydrogenase', 157, NULL, NULL, 88962),
(88963, '2.130.10.10-FF-004824', NULL, 'Uncharacterized protein', 137, NULL, NULL, 88963),
(88964, '1.25.50.20-FF-000050', NULL, 'Aminopeptidase', 135, NULL, NULL, 88964),
(88965, '2.60.120.200-FF-000636', NULL, 'Heparan sulfate proteoglycan 2', 117, NULL, NULL, 88965),
(88966, '3.90.230.10-FF-000041', NULL, 'Uncharacterized protein', 260, NULL, NULL, 88966),
(88967, '1.10.10.10-FF-002028', NULL, 'Forkhead box N2', 105, NULL, NULL, 88967),
(88968, '1.10.510.10-FF-001752', NULL, 'Serine/threonine-protein kinase PknB', 193, NULL, NULL, 88968),
(88969, '3.40.1260.10-FF-000008', NULL, 'DsrE family protein', 116, NULL, NULL, 88969),
(88970, '1.10.730.10-FF-000116', NULL, 'Methionine--tRNA ligase, mitochondrial', 206, NULL, NULL, 88970),
(88971, '2.130.10.10-FF-003993', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit', 230, NULL, NULL, 88971),
(88972, '3.30.160.660-FF-000001', NULL, 'Ribosomal protein S12 methylthiotransferase accessory factor YcaO', 125, NULL, NULL, 88972),
(88973, '3.30.230.40-FF-000007', NULL, 'Imidazoleglycerol-phosphate dehydratase', 90, NULL, NULL, 88973),
(88974, '1.10.10.10-FF-000100', NULL, 'E2F transcription factor 8', 93, NULL, NULL, 88974),
(88975, '1.10.510.10-FF-004051', NULL, NULL, 42, NULL, NULL, 88975),
(88976, '3.30.710.10-FF-000384', NULL, 'Uncharacterized protein', 85, NULL, NULL, 88976),
(88977, '3.90.1410.10-FF-000088', NULL, 'Uncharacterized protein', 258, NULL, NULL, 88977),
(88978, '1.25.40.10-FF-002480', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 147, NULL, NULL, 88978),
(88979, '1.10.1450.10-FF-000116', NULL, 'Tetraspanin', 91, NULL, NULL, 88979),
(88980, '2.60.40.1230-FF-000012', NULL, 'AP-1 complex subunit gamma', 109, NULL, NULL, 88980),
(88981, '3.40.50.410-FF-000316', NULL, 'Predicted protein', 115, NULL, NULL, 88981);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(88982, '1.20.140.100-FF-000036', NULL, 'Dynein heavy chain', 145, NULL, NULL, 88982),
(88983, '1.20.1070.10-FF-000860', NULL, 'Chemokine (C-X-C motif) receptor 3, tandem duplicate 1', 103, NULL, NULL, 88983),
(88984, '3.40.1000.50-FF-000018', NULL, 'Repressor of RNA polymerase III transcription MAF1', 160, NULL, NULL, 88984),
(88985, '3.30.2410.10-FF-000012', NULL, 'Ubiquitin-protein ligase E3B', 141, NULL, NULL, 88985),
(88986, '2.60.40.60-FF-000910', NULL, 'Uncharacterized protein', 104, NULL, NULL, 88986),
(88987, '3.80.10.10-FF-000744', NULL, 'Protein phosphatase 1 regulatory subunit pprA', 143, NULL, NULL, 88987),
(88988, '3.40.50.12350-FF-000001', NULL, 'Eyes absent homolog', 271, NULL, NULL, 88988),
(88989, '3.80.10.10-FF-003150', NULL, 'Uncharacterized protein', 299, NULL, NULL, 88989),
(88990, '3.40.50.1240-FF-000036', NULL, '6-phosphofructo-2-kinase/fructose-2, 6-bisphosphatase', 220, NULL, NULL, 88990),
(88991, '3.40.220.10-FF-000029', NULL, 'H2A histone family member Y2', 138, NULL, NULL, 88991),
(88992, '1.25.10.10-FF-000179', NULL, 'Serine/threonine-protein phosphatase 4 regulatory subunit 1', 192, NULL, NULL, 88992),
(88993, '3.40.50.1010-FF-000192', NULL, NULL, 146, NULL, NULL, 88993),
(88994, '3.40.50.300-FF-001576', NULL, 'tRNA-splicing endonuclease, putative', 203, NULL, NULL, 88994),
(88995, '2.60.120.380-FF-000066', NULL, 'Cysteine peptidase, Clan CA, family C2, putative', 138, NULL, NULL, 88995),
(88996, '3.60.21.10-FF-000034', NULL, 'Fe(3+)-Zn(2+) purple acid phosphatase', 308, NULL, NULL, 88996),
(88997, '3.40.1370.10-FF-000005', NULL, '39S ribosomal protein L4, mitochondrial', 249, NULL, NULL, 88997),
(88998, '1.25.10.10-FF-002085', NULL, 'Chromosome 8, whole genome shotgun sequence', 278, NULL, NULL, 88998),
(88999, '3.30.200.20-FF-001596', NULL, 'Uncharacterized protein', 105, NULL, NULL, 88999),
(89000, '1.20.120.1760-FF-000076', NULL, NULL, 316, NULL, NULL, 89000),
(89001, '1.10.220.30-FF-000027', NULL, 'Flagellar motor switch protein G', 82, NULL, NULL, 89001),
(89002, '3.30.380.10-FF-000003', NULL, 'Coat protein', 128, NULL, NULL, 89002),
(89003, '1.10.287.70-FF-000266', NULL, 'Transient receptor potential cation channel subfamily c member 1', 145, NULL, NULL, 89003),
(89004, '3.40.440.10-FF-000012', NULL, NULL, 132, NULL, NULL, 89004),
(89005, '4.10.240.10-FF-000180', NULL, 'Zcf5p', 87, NULL, NULL, 89005),
(89006, '3.40.50.12370-FF-000007', NULL, 'Os12g0180500 protein', 178, NULL, NULL, 89006),
(89007, '1.10.10.10-FF-000555', NULL, 'Histone H1', 90, NULL, NULL, 89007),
(89008, '2.60.120.10-FF-000313', NULL, 'Protein phosphatase 2C and cyclic nucleotide-binding/kinase domain-containing protein', 144, NULL, NULL, 89008),
(89009, '3.30.420.110-FF-000026', NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', 149, NULL, NULL, 89009),
(89010, '1.10.220.10-FF-000021', NULL, 'annexin D4', 91, NULL, NULL, 89010),
(89011, '1.10.510.10-FF-004500', NULL, NULL, 229, NULL, NULL, 89011),
(89012, '1.10.630.10-FF-000176', NULL, 'Uncharacterized protein', 452, NULL, NULL, 89012),
(89013, '2.180.10.10-FF-000005', NULL, 'Teneurin transmembrane protein 4', 209, NULL, NULL, 89013),
(89014, '2.130.10.10-FF-001177', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit TRM82', 260, NULL, NULL, 89014),
(89015, '1.25.10.10-FF-002433', NULL, 'Leukotriene A-4 hydrolase-like protein', 240, NULL, NULL, 89015),
(89016, '1.20.1420.30-FF-000106', NULL, 'Sodium/calcium exchanger membrane region', 126, NULL, NULL, 89016),
(89017, '3.40.50.720-FF-000965', NULL, 'Shikimate dehydrogenase (NADP(+))', 123, NULL, NULL, 89017),
(89018, '1.10.287.70-FF-000614', NULL, 'Uncharacterized protein', 246, NULL, NULL, 89018),
(89019, '3.40.50.1220-FF-000030', NULL, 'Transcriptional regulatory protein sir2b', 150, NULL, NULL, 89019),
(89020, '2.130.10.10-FF-002470', NULL, 'Uncharacterized protein', 362, NULL, NULL, 89020),
(89021, '3.30.160.60-FF-000912', NULL, 'Zinc finger protein 660', 31, NULL, NULL, 89021),
(89022, '1.50.40.10-FF-000605', NULL, 'Predicted protein', 284, NULL, NULL, 89022);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(89023, '2.30.30.140-FF-000243', NULL, 'Histone-lysine N-methyltransferase SETDB1-A', 65, NULL, NULL, 89023),
(89024, '3.40.50.300-FF-002195', NULL, 'Axonemal dynein heavy chain', 113, NULL, NULL, 89024),
(89025, '2.60.40.60-FF-000562', NULL, 'Cadherin 5', 112, NULL, NULL, 89025),
(89026, '1.20.120.1080-FF-000063', NULL, 'ATP-dependent RNA helicase, putative', 137, NULL, NULL, 89026),
(89027, '1.10.8.10-FF-000357', NULL, 'GH10884p', 38, NULL, NULL, 89027),
(89028, '1.25.40.420-FF-000018', NULL, 'Kelch-like family member 22', 125, NULL, NULL, 89028),
(89029, '3.40.50.1820-FF-001171', NULL, 'Carboxylic ester hydrolase', 460, NULL, NULL, 89029),
(89030, '2.40.30.10-FF-000013', NULL, 'eukaryotic translation initiation factor 5B', 120, NULL, NULL, 89030),
(89031, '3.10.100.10-FF-000229', NULL, NULL, 142, NULL, NULL, 89031),
(89032, '3.40.50.620-FF-000368', NULL, 'Some similarities with, putative', 178, NULL, NULL, 89032),
(89033, '1.10.3730.20-FF-000051', NULL, 'DMT superfamily drug/metabolite transporter', 105, NULL, NULL, 89033),
(89034, '3.30.40.10-FF-000102', NULL, 'protrudin isoform X2', 63, NULL, NULL, 89034),
(89035, '3.10.180.10-FF-000009', NULL, '4-hydroxyphenylpyruvate dioxygenase', 168, NULL, NULL, 89035),
(89036, '3.40.50.300-FF-003369', NULL, 'Protein CBG16740', 226, NULL, NULL, 89036),
(89037, '3.30.70.100-FF-000140', NULL, NULL, 68, NULL, NULL, 89037),
(89038, '3.10.50.40-FF-000073', NULL, 'Peptidyl-prolyl cis-trans isomerase', 157, NULL, NULL, 89038),
(89039, '3.30.70.330-FF-001951', NULL, NULL, 78, NULL, NULL, 89039),
(89040, '1.20.1110.10-FF-000234', NULL, NULL, 342, NULL, NULL, 89040),
(89041, '3.40.50.150-FF-001598', NULL, NULL, 262, NULL, NULL, 89041),
(89042, '3.30.160.60-FF-002374', NULL, 'Blast:Transcription factor Sp4', 34, NULL, NULL, 89042),
(89043, '1.20.1050.10-FF-000297', NULL, 'Uncharacterized protein', 83, NULL, NULL, 89043),
(89044, '1.10.510.10-FF-002157', NULL, 'Guanylate cyclase', 254, NULL, NULL, 89044),
(89045, '2.30.30.190-FF-000016', NULL, 'Tubulin-folding cofactor E', 81, NULL, NULL, 89045),
(89046, '1.10.560.10-FF-000052', NULL, '60 kDa chaperonin', 242, NULL, NULL, 89046),
(89047, '1.25.40.10-FF-003199', NULL, 'TPR repeat, putative', 89, NULL, NULL, 89047),
(89048, '2.40.160.180-FF-000002', NULL, 'Porin', 379, NULL, NULL, 89048),
(89049, '1.10.510.10-FF-000791', NULL, 'cyclin-dependent kinase 20', 208, NULL, NULL, 89049),
(89050, '2.40.30.30-FF-000019', NULL, 'Riboflavin biosynthesis protein', 121, NULL, NULL, 89050),
(89051, '2.60.40.10-FF-002941', NULL, NULL, 98, NULL, NULL, 89051),
(89052, '3.40.50.150-FF-001042', NULL, NULL, 143, NULL, NULL, 89052),
(89053, '3.80.10.10-FF-000851', NULL, 'Probable leucine-rich repeat receptor-like protein kinase At1g35710', 158, NULL, NULL, 89053),
(89054, '3.30.250.20-FF-000014', NULL, 'Uncharacterized protein', 43, NULL, NULL, 89054),
(89055, '1.10.10.10-FF-001516', NULL, 'Uncharacterized protein', 73, NULL, NULL, 89055),
(89056, '2.130.10.10-FF-000558', NULL, 'Topless-related protein 1', 219, NULL, NULL, 89056),
(89057, '2.30.30.40-FF-000197', NULL, 'Tyrosine-protein kinase', 77, NULL, NULL, 89057),
(89058, '1.25.50.20-FF-000055', NULL, 'Glutamyl aminopeptidase-like Protein', 322, NULL, NULL, 89058),
(89059, '1.10.357.10-FF-000052', NULL, 'Transcriptional regulator CmeR', 146, NULL, NULL, 89059),
(89060, '3.30.450.20-FF-000456', NULL, 'Uncharacterized protein', 109, NULL, NULL, 89060),
(89061, '4.10.60.10-FF-000208', NULL, 'Uncharacterized protein', 29, NULL, NULL, 89061),
(89062, '3.30.930.10-FF-000260', NULL, 'Class II aaRS and biotin synthetases superfamily protein', 148, NULL, NULL, 89062),
(89063, '1.10.287.850-FF-000005', NULL, 'PE family immunomodulator PE35', 89, NULL, NULL, 89063),
(89064, '1.10.287.470-FF-000094', NULL, 'Putative transporter', 46, NULL, NULL, 89064),
(89065, '2.40.50.140-FF-000981', NULL, NULL, 79, NULL, NULL, 89065),
(89066, '2.160.20.60-FF-000005', NULL, 'Glutamate synthase, large subunit', 283, NULL, NULL, 89066),
(89067, '2.60.40.10-FF-000120', NULL, 'Down syndrome cell adhesion molecule like 1', 107, NULL, NULL, 89067);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(89068, '3.40.1000.50-FF-000013', NULL, 'Repressor of RNA polymerase III transcription MAF1', 52, NULL, NULL, 89068),
(89069, '3.40.50.300-FF-006466', NULL, 'Uncharacterized protein', 119, NULL, NULL, 89069),
(89070, '3.40.1190.20-FF-000236', NULL, NULL, 179, NULL, NULL, 89070),
(89071, '1.10.3720.10-FF-000233', NULL, 'Opine/polyamine ABC transporter, permease protein', 266, NULL, NULL, 89071),
(89072, '3.30.70.330-FF-001496', NULL, 'Protein CBR-RBM-28', 168, NULL, NULL, 89072),
(89073, '3.40.720.10-FF-000157', NULL, 'Iduronate-2-sulfatase', 454, NULL, NULL, 89073),
(89074, '3.30.40.10-FF-001625', NULL, 'Ret finger protein-like 1', 89, NULL, NULL, 89074),
(89075, '1.20.1070.10-FF-001927', NULL, 'Predicted protein', 280, NULL, NULL, 89075),
(89076, '2.60.40.780-FF-000003', NULL, 'Protein Vhl', 86, NULL, NULL, 89076),
(89077, '3.40.50.1440-FF-000096', NULL, 'Uncharacterized protein', 290, NULL, NULL, 89077),
(89078, '1.10.268.10-FF-000024', NULL, NULL, 164, NULL, NULL, 89078),
(89079, '3.90.1480.20-FF-000039', NULL, 'Uncharacterized protein', 286, NULL, NULL, 89079),
(89080, '1.10.730.10-FF-000228', NULL, 'Uncharacterized protein', 131, NULL, NULL, 89080),
(89081, '3.30.1370.110-FF-000028', NULL, 'Smr domain protein', 130, NULL, NULL, 89081),
(89082, '3.30.460.10-FF-000055', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 235, NULL, NULL, 89082),
(89083, '3.90.180.10-FF-000059', NULL, 'YML131W-like protein', 143, NULL, NULL, 89083),
(89084, '3.40.50.800-FF-000107', NULL, 'DNA polymerase subunit gamma-2, mitochondrial', 103, NULL, NULL, 89084),
(89085, '3.10.310.10-FF-000043', NULL, '3-methylitaconate isomerase', 190, NULL, NULL, 89085),
(89086, '2.40.70.10-FF-000347', NULL, NULL, 156, NULL, NULL, 89086),
(89087, '3.30.160.60-FF-004167', NULL, NULL, 53, NULL, NULL, 89087),
(89088, '2.10.25.10-FF-000418', NULL, 'EGF-containing fibulin-like extracellular matrix protein 1', 38, NULL, NULL, 89088),
(89089, '1.20.58.390-FF-000080', NULL, '5-hydroxytryptamine (serotonin) receptor 3C, ionotropic', 118, NULL, NULL, 89089),
(89090, '1.20.58.60-FF-000808', NULL, 'Uncharacterized protein', 202, NULL, NULL, 89090),
(89091, '1.10.530.40-FF-000003', NULL, 'Baseplate hub subunit and tail lysozyme', 169, NULL, NULL, 89091),
(89092, '3.30.420.10-FF-000390', NULL, NULL, 110, NULL, NULL, 89092),
(89093, '2.60.40.1930-FF-000008', NULL, 'Complement C3', 104, NULL, NULL, 89093),
(89094, '1.10.10.10-FF-001409', NULL, 'Rrf2 family transcriptional regulator', 131, NULL, NULL, 89094),
(89095, '3.40.50.720-FF-001926', NULL, 'Crystallin mu', 46, NULL, NULL, 89095),
(89096, '1.10.135.10-FF-000014', NULL, 'Creatine kinase S-type, mitochondrial', 98, NULL, NULL, 89096),
(89097, '3.30.160.60-FF-005684', NULL, NULL, 70, NULL, NULL, 89097),
(89098, '1.25.40.10-FF-003547', NULL, 'Zinc finger CCCH type containing 7 A', 80, NULL, NULL, 89098),
(89099, '2.10.25.10-FF-001711', NULL, 'Delta-like protein', 40, NULL, NULL, 89099),
(89100, '3.30.40.10-FF-000321', NULL, 'E3 ubiquitin-protein ligase SINAT5', 49, NULL, NULL, 89100),
(89101, '2.40.70.10-FF-000004', NULL, 'Pepsin A', 167, NULL, NULL, 89101),
(89102, '3.20.20.140-FF-000149', NULL, 'Dihydropyrimidinase', 331, NULL, NULL, 89102),
(89103, '2.120.10.30-FF-000183', NULL, 'Uncharacterized protein', 112, NULL, NULL, 89103),
(89104, '3.30.1680.10-FF-000048', NULL, 'Semaphorin-5A', 52, NULL, NULL, 89104),
(89105, '2.30.30.40-FF-000326', NULL, 'Alkylphosphonate utilization operon protein PhnA', 66, NULL, NULL, 89105),
(89106, '2.40.10.10-FF-000467', NULL, 'AGAP005196-PA', 238, NULL, NULL, 89106),
(89107, '2.60.40.10-FF-006084', NULL, NULL, 50, NULL, NULL, 89107),
(89108, '3.40.50.1970-FF-000024', NULL, 'Hydroxyacid-oxoacid transhydrogenase, mitochondrial', 200, NULL, NULL, 89108),
(89109, '1.20.1740.10-FF-000153', NULL, 'Amino acid transporter, partial (Eurofung)', 145, NULL, NULL, 89109),
(89110, '3.40.50.300-FF-005286', NULL, 'Uncharacterized protein', 177, NULL, NULL, 89110),
(89111, '3.40.50.300-FF-003026', NULL, 'Uncharacterized protein', 200, NULL, NULL, 89111);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(89112, '2.60.40.10-FF-005684', NULL, NULL, 81, NULL, NULL, 89112),
(89113, '1.10.260.40-FF-000010', NULL, 'Cut-like homeobox 1a', 84, NULL, NULL, 89113),
(89114, '1.25.40.20-FF-000785', NULL, 'Ankyrin repeat-containing protein At2g01680', 152, NULL, NULL, 89114),
(89115, '1.10.8.1310-FF-000008', NULL, 'Rab GTPase activating protein, putative', 119, NULL, NULL, 89115),
(89116, '3.60.70.12-FF-000009', NULL, 'Peptidase S58 DmpA', 278, NULL, NULL, 89116),
(89117, '1.10.1410.20-FF-000004', NULL, '2''-5''-oligoadenylate synthase 3-like isoform X1', 161, NULL, NULL, 89117),
(89118, '1.10.520.10-FF-000061', NULL, 'Catalase/peroxidase', 92, NULL, NULL, 89118),
(89119, '3.40.980.10-FF-000047', NULL, 'Molybdopterin molybdenumtransferase', 119, NULL, NULL, 89119),
(89120, '1.10.10.10-FF-000448', NULL, 'FEV (ETS oncogene family)', 135, NULL, NULL, 89120),
(89121, '2.60.40.150-FF-000033', NULL, 'dysferlin isoform X2', 153, NULL, NULL, 89121),
(89122, '3.30.70.590-FF-000016', NULL, 'PolyA polymerase', 115, NULL, NULL, 89122),
(89123, '3.10.350.10-FF-000040', NULL, 'Membrane-bound lytic murein transglycosylase D', 65, NULL, NULL, 89123),
(89124, '1.20.140.10-FF-000035', NULL, 'Acyl-CoA dehydrogenase FadE4', 147, NULL, NULL, 89124),
(89125, '1.10.150.80-FF-000002', NULL, 'ATP-dependent DNA helicase RecQ', 81, NULL, NULL, 89125),
(89126, '1.10.10.60-FF-001166', NULL, NULL, 48, NULL, NULL, 89126),
(89127, '1.10.10.2150-FF-000002', NULL, 'Ribosomal RNA-processing protein 8', 74, NULL, NULL, 89127),
(89128, '3.30.1140.60-FF-000005', NULL, 'F-actin-capping protein subunit alpha', 109, NULL, NULL, 89128),
(89129, '3.40.50.2000-FF-001135', NULL, 'Uncharacterized protein', 50, NULL, NULL, 89129),
(89130, '3.40.1110.10-FF-000464', NULL, NULL, 111, NULL, NULL, 89130),
(89131, '1.25.10.10-FF-002652', NULL, 'AP-3 complex subunit delta-1, putative', 107, NULL, NULL, 89131),
(89132, '3.40.850.10-FF-000386', NULL, 'Uncharacterized protein', 310, NULL, NULL, 89132),
(89133, '3.20.20.70-FF-000158', NULL, 'Biotin synthase', 279, NULL, NULL, 89133),
(89134, '1.10.510.10-FF-000572', NULL, 'Serine/threonine-protein kinase/endoribonuclease IRE1', 218, NULL, NULL, 89134),
(89135, '2.80.10.50-FF-000224', NULL, 'Uncharacterized protein', 69, NULL, NULL, 89135),
(89136, '2.30.30.40-FF-000202', NULL, 'Tight junction protein 3', 110, NULL, NULL, 89136),
(89137, '1.25.10.10-FF-000516', NULL, 'mRNA binding PUM-HD domain protein-like protein', 366, NULL, NULL, 89137),
(89138, '1.20.58.1380-FF-000004', NULL, 'Uncharacterized protein', 84, NULL, NULL, 89138),
(89139, '1.20.1310.10-FF-000233', NULL, NULL, 106, NULL, NULL, 89139),
(89140, '2.60.40.150-FF-000718', NULL, 'Phosphoinositide phospholipase C', 130, NULL, NULL, 89140),
(89141, '3.30.70.330-FF-000192', NULL, 'Serine/arginine-rich splicing factor SC35', 100, NULL, NULL, 89141),
(89142, '3.60.40.10-FF-000286', NULL, 'Probable protein phosphatase 2C 62', 123, NULL, NULL, 89142),
(89143, '2.10.50.30-FF-000033', NULL, 'Predicted protein', 74, NULL, NULL, 89143),
(89144, '3.30.760.10-FF-000095', NULL, 'Uncharacterized protein', 213, NULL, NULL, 89144),
(89145, '3.30.200.20-FF-000303', NULL, 'Protein kinase superfamily protein', 91, NULL, NULL, 89145),
(89146, '3.30.420.140-FF-000012', NULL, 'Putative pre-16S rRNA nuclease', 139, NULL, NULL, 89146),
(89147, '3.40.50.300-FF-001795', NULL, 'Uncharacterized protein, isoform A', 180, NULL, NULL, 89147),
(89148, '2.60.120.620-FF-000077', NULL, 'Uncharacterized protein', 186, NULL, NULL, 89148),
(89149, '1.10.533.10-FF-000265', NULL, 'Uncharacterized protein', 101, NULL, NULL, 89149),
(89150, '3.30.70.980-FF-000044', NULL, 'Probable transcriptional regulatory protein RBSWK_05502', 76, NULL, NULL, 89150),
(89151, '3.30.60.30-FF-000087', NULL, 'Agrin', 48, NULL, NULL, 89151),
(89152, '3.30.70.120-FF-000016', NULL, 'CutA, putative', 125, NULL, NULL, 89152),
(89153, '2.30.30.870-FF-000006', NULL, 'Pelota, putative', 126, NULL, NULL, 89153),
(89154, '3.30.160.60-FF-003548', NULL, 'AGAP004651-PA', 32, NULL, NULL, 89154),
(89155, '3.30.1520.10-FF-000003', NULL, 'sorting nexin-27 isoform X2', 104, NULL, NULL, 89155);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(89156, '3.60.40.10-FF-000067', NULL, 'Protein phosphatase PPM6, putative', 295, NULL, NULL, 89156),
(89157, '1.20.1070.10-FF-001242', NULL, 'Adhesion G protein-coupled receptor G4b', 148, NULL, NULL, 89157),
(89158, '1.20.120.1810-FF-000001', NULL, 'RNA polymerase sigma factor RpoH', 109, NULL, NULL, 89158),
(89159, '1.10.565.10-FF-000147', NULL, 'Uncharacterized protein', 247, NULL, NULL, 89159),
(89160, '4.10.60.10-FF-000192', NULL, 'Protein CBG28058', 68, NULL, NULL, 89160),
(89161, '1.25.40.20-FF-000914', NULL, 'Uncharacterized protein', 192, NULL, NULL, 89161),
(89162, '2.60.40.10-FF-005139', NULL, NULL, 96, NULL, NULL, 89162),
(89163, '3.40.50.10190-FF-000090', NULL, 'BRCA1 C Terminus domain containing protein expressed', 113, NULL, NULL, 89163),
(89164, '3.10.20.90-FF-000581', NULL, 'Auxin-responsive protein IAA29', 96, NULL, NULL, 89164),
(89165, '3.30.1010.10-FF-000133', NULL, 'Uncharacterized protein', 154, NULL, NULL, 89165),
(89166, '3.30.420.10-FF-000406', NULL, NULL, 186, NULL, NULL, 89166),
(89167, '3.10.250.10-FF-000004', NULL, 'Scavenger receptor cysteine-rich type 1 protein M130', 106, NULL, NULL, 89167),
(89168, '1.20.920.10-FF-000117', NULL, 'Sp110 nuclear body protein', 103, NULL, NULL, 89168),
(89169, '3.40.50.300-FF-005847', NULL, 'Protein translocase subunit SecA', 233, NULL, NULL, 89169),
(89170, '3.40.50.300-FF-006247', NULL, 'Uncharacterized protein', 206, NULL, NULL, 89170),
(89171, '3.30.70.1230-FF-000226', NULL, 'Predicted protein', 211, NULL, NULL, 89171),
(89172, '3.20.190.10-FF-000002', NULL, 'Endonuclease 8', 126, NULL, NULL, 89172),
(89173, '2.20.70.10-FF-000174', NULL, 'Predicted protein', 45, NULL, NULL, 89173),
(89174, '3.80.10.10-FF-003835', NULL, 'Predicted protein', 57, NULL, NULL, 89174),
(89175, '3.40.50.1820-FF-001750', NULL, 'Predicted protein', 39, NULL, NULL, 89175),
(89176, '1.10.30.10-FF-000118', NULL, 'High mobility group protein homolog TDP-1', 78, NULL, NULL, 89176),
(89177, '3.90.980.20-FF-000022', NULL, NULL, 151, NULL, NULL, 89177),
(89178, '1.20.1070.10-FF-000753', NULL, 'Uncharacterized protein', 139, NULL, NULL, 89178),
(89179, '3.30.450.20-FF-000675', NULL, 'Putative DNA-binding protein', 80, NULL, NULL, 89179),
(89180, '3.10.129.10-FF-000205', NULL, 'Uncharacterized protein', 135, NULL, NULL, 89180),
(89181, '1.25.10.10-FF-002989', NULL, 'Predicted protein', 374, NULL, NULL, 89181),
(89182, '1.10.10.10-FF-001393', NULL, 'ArsR family transcriptional regulator', 97, NULL, NULL, 89182),
(89183, '2.130.10.10-FF-005448', NULL, 'Uncharacterized protein', 199, NULL, NULL, 89183),
(89184, '2.102.10.10-FF-000032', NULL, 'Rieske_[2Fe-2S]_domain/Rieske-like_[2Fe-2S ]_domain_containing_protein_-_putative', 137, NULL, NULL, 89184),
(89185, '2.60.40.10-FF-002722', NULL, 'Putative trypsin', 101, NULL, NULL, 89185),
(89186, '3.40.1190.10-FF-000014', NULL, 'UDP-N-acetylmuramoyl-L-alanyl-D-glutamate--2, 6-diaminopimelate ligase', 241, NULL, NULL, 89186),
(89187, '2.60.40.1730-FF-000055', NULL, NULL, 138, NULL, NULL, 89187),
(89188, '3.40.1280.10-FF-000122', NULL, 'Uncharacterized protein', 195, NULL, NULL, 89188),
(89189, '2.60.40.10-FF-003211', NULL, 'Cytochrome c oxidase accessory protein CcoG', 114, NULL, NULL, 89189),
(89190, '1.25.40.10-FF-000563', NULL, 'U3 small nucleolar RNA-associated protein 6', 155, NULL, NULL, 89190),
(89191, '2.60.40.10-FF-001429', NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', 98, NULL, NULL, 89191),
(89192, '3.30.70.270-FF-000033', NULL, 'Probable diguanylate cyclase YeaP', 169, NULL, NULL, 89192),
(89193, '1.20.900.10-FF-000099', NULL, 'Rho1 guanine nucleotide exchange factor 3', 236, NULL, NULL, 89193),
(89194, '3.80.10.10-FF-004111', NULL, 'Uncharacterized protein', 117, NULL, NULL, 89194),
(89195, '1.25.10.10-FF-000067', NULL, 'V-type proton ATPase subunit H', 324, NULL, NULL, 89195),
(89196, '2.60.40.10-FF-002380', NULL, 'Muscle M-line assembly protein unc-89', 100, NULL, NULL, 89196),
(89197, '3.15.10.10-FF-000017', NULL, 'Uncharacterized protein', 171, NULL, NULL, 89197),
(89198, '3.40.50.1240-FF-000148', NULL, NULL, 154, NULL, NULL, 89198);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(89199, '2.60.40.1660-FF-000023', NULL, 'Uncharacterized protein', 329, NULL, NULL, 89199),
(89200, '2.60.40.150-FF-000825', NULL, 'C2 domain containing protein', 141, NULL, NULL, 89200),
(89201, '3.30.200.20-FF-001466', NULL, 'Serine/threonine protein kinase PpkA', 86, NULL, NULL, 89201),
(89202, '3.40.50.200-FF-000023', NULL, 'Subtilisin-like protease 1', 344, NULL, NULL, 89202),
(89203, '2.60.120.10-FF-000077', NULL, '3-hydroxyanthranilate 3,4-dioxygenase', 284, NULL, NULL, 89203),
(89204, '2.60.40.1960-FF-000006', NULL, 'Lysosomal aspartic protease-like Protein', 73, NULL, NULL, 89204),
(89205, '3.60.10.10-FF-000346', NULL, 'Predicted protein', 181, NULL, NULL, 89205),
(89206, '2.60.40.10-FF-002374', NULL, 'AGAP007237-PA-like protein', 91, NULL, NULL, 89206),
(89207, '2.20.25.210-FF-000003', NULL, NULL, 62, NULL, NULL, 89207),
(89208, '3.30.70.330-FF-000203', NULL, 'insulin-like growth factor 2 mRNA-binding protein 1', 81, NULL, NULL, 89208),
(89209, '1.20.1070.10-FF-001714', NULL, 'Uncharacterized protein', 102, NULL, NULL, 89209),
(89210, '3.40.50.620-FF-000593', NULL, 'Cysteinyl-tRNA synthetase, putative', 149, NULL, NULL, 89210),
(89211, '1.10.357.70-FF-000030', NULL, 'Uncharacterized protein', 161, NULL, NULL, 89211),
(89212, '3.40.50.1820-FF-000114', NULL, 'Arylacetamide deacetylase-like 1', 294, NULL, NULL, 89212),
(89213, '1.25.10.10-FF-002197', NULL, 'Uncharacterized protein', 442, NULL, NULL, 89213),
(89214, '3.40.50.2300-FF-001231', NULL, NULL, 136, NULL, NULL, 89214),
(89215, '3.40.190.80-FF-000007', NULL, 'Blast:Putative inositol monophosphatase 3', 124, NULL, NULL, 89215),
(89216, '1.25.10.10-FF-001685', NULL, 'RRP12-like protein', 288, NULL, NULL, 89216),
(89217, '1.10.287.70-FF-000378', NULL, 'KCNN (Potassium K ChaNNel, calcium activated)-Like', 99, NULL, NULL, 89217),
(89218, '2.30.30.1020-FF-000012', NULL, 'CCR4-NOT transcriptional complex subunit', 191, NULL, NULL, 89218),
(89219, '3.30.70.20-FF-000146', NULL, NULL, 49, NULL, NULL, 89219),
(89220, '2.60.200.20-FF-000244', NULL, 'Uncharacterized protein', 132, NULL, NULL, 89220),
(89221, '1.10.287.110-FF-000132', NULL, 'Zuo1p', 89, NULL, NULL, 89221),
(89222, '3.40.1380.20-FF-000054', NULL, 'Uncharacterized protein', 42, NULL, NULL, 89222),
(89223, '3.30.1380.20-FF-000017', NULL, 'Hydrocarbon binding protein', 129, NULL, NULL, 89223),
(89224, '2.60.40.60-FF-000674', NULL, 'Predicted protein', 106, NULL, NULL, 89224),
(89225, '2.90.10.10-FF-000044', NULL, 'PAN domain-containing protein At5g03700', 110, NULL, NULL, 89225),
(89226, '3.40.50.300-FF-006011', NULL, 'DNA helicase', 199, NULL, NULL, 89226),
(89227, '3.30.70.330-FF-001714', NULL, NULL, 124, NULL, NULL, 89227),
(89228, '3.40.50.360-FF-000037', NULL, 'NAD(P)H dehydrogenase (Quinone)', 196, NULL, NULL, 89228),
(89229, '1.10.472.80-FF-000222', NULL, NULL, 133, NULL, NULL, 89229),
(89230, '3.60.21.10-FF-000158', NULL, 'Trifunctional nucleotide phosphoesterase protein YfkN', 315, NULL, NULL, 89230),
(89231, '3.30.70.1660-FF-000001', NULL, 'Peptide chain release factor 2', 133, NULL, NULL, 89231),
(89232, '3.30.70.330-FF-001821', NULL, NULL, 103, NULL, NULL, 89232),
(89233, '3.30.30.30-FF-000028', NULL, 'Uncharacterized protein', 59, NULL, NULL, 89233),
(89234, '3.40.50.11610-FF-000021', NULL, NULL, 169, NULL, NULL, 89234),
(89235, '1.20.5.170-FF-000048', NULL, 'ABSCISIC ACID-INSENSITIVE 5-like protein 5', 58, NULL, NULL, 89235),
(89236, '3.60.21.60-FF-000021', NULL, 'DNA polymerase alpha subunit B', 191, NULL, NULL, 89236),
(89237, '1.10.630.10-FF-000395', NULL, 'Beta-amyrin 28-oxidase', 117, NULL, NULL, 89237),
(89238, '2.10.220.10-FF-000158', NULL, 'Uncharacterized protein', 93, NULL, NULL, 89238),
(89239, '1.10.3720.10-FF-000008', NULL, 'Oligopeptide ABC transporter permease OppC', 199, NULL, NULL, 89239),
(89240, '2.30.30.40-FF-000433', NULL, 'Predicted protein', 65, NULL, NULL, 89240),
(89241, '3.30.450.20-FF-000669', NULL, 'Uncharacterized protein', 106, NULL, NULL, 89241),
(89242, '3.30.450.40-FF-000102', NULL, 'Phosphatase', 161, NULL, NULL, 89242),
(89243, '1.20.58.60-FF-000016', NULL, 'Microtubule-actin cross-linking factor 1', 110, NULL, NULL, 89243);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(89244, '3.30.70.330-FF-002333', NULL, NULL, 112, NULL, NULL, 89244),
(89245, '1.20.5.4130-FF-000009', NULL, 'Disease resistance protein RGA4', 116, NULL, NULL, 89245),
(89246, '3.30.420.40-FF-000494', NULL, 'Hexokinase 2', 164, NULL, NULL, 89246),
(89247, '2.20.28.10-FF-000020', NULL, 'DNA helicase', 51, NULL, NULL, 89247),
(89248, '1.25.40.20-FF-000678', NULL, 'Ankyrin repeats (3 copies), putative', 105, NULL, NULL, 89248),
(89249, '1.20.1070.10-FF-001821', NULL, 'Uncharacterized protein', 309, NULL, NULL, 89249),
(89250, '1.20.1540.10-FF-000042', NULL, 'Rbd2p', 185, NULL, NULL, 89250),
(89251, '1.10.720.30-FF-000048', NULL, 'Uncharacterized protein', 48, NULL, NULL, 89251),
(89252, '3.90.190.10-FF-000453', NULL, 'Uncharacterized protein', 227, NULL, NULL, 89252),
(89253, '2.30.29.30-FF-001073', NULL, 'Uncharacterized protein (Fragment)', 71, NULL, NULL, 89253),
(89254, '3.40.50.720-FF-000853', NULL, 'Shikimate dehydrogenase (NADP(+))', 134, NULL, NULL, 89254),
(89255, '1.10.640.10-FF-000002', NULL, 'Prostaglandin G/H synthase 2', 511, NULL, NULL, 89255),
(89256, '3.30.505.10-FF-000087', NULL, 'protein sprint isoform X1', 96, NULL, NULL, 89256),
(89257, '3.40.630.10-FF-000167', NULL, 'Carboxypeptidase G2', 243, NULL, NULL, 89257),
(89258, '3.30.40.10-FF-001046', NULL, 'Chromatin modification-related protein', 58, NULL, NULL, 89258),
(89259, '3.80.10.10-FF-001469', NULL, 'Leucine-rich repeat containing protein', 299, NULL, NULL, 89259),
(89260, '3.10.450.350-FF-000018', NULL, 'Subfamily M23B unassigned peptidase', 105, NULL, NULL, 89260),
(89261, '1.10.10.10-FF-001960', NULL, 'Uncharacterized protein', 73, NULL, NULL, 89261),
(89262, '3.30.360.10-FF-000019', NULL, 'Bifunctional acetylglutamate kinase/N-acetyl-gamma-glutamyl-phosphate reductase', 157, NULL, NULL, 89262),
(89263, '3.40.190.10-FF-000470', NULL, 'Oligopeptide ABC transporter, periplasmic oligopeptide-binding protein', 127, NULL, NULL, 89263),
(89264, '3.30.565.10-FF-000208', NULL, 'Sensory box sensor histidine kinase', 154, NULL, NULL, 89264),
(89265, '3.10.620.30-FF-000027', NULL, 'Uncharacterized protein', 93, NULL, NULL, 89265),
(89266, '1.10.287.1490-FF-000041', NULL, 'Kinesin, variant', 158, NULL, NULL, 89266),
(89267, '3.30.70.240-FF-000041', NULL, 'Elongation factor G, mitochondrial', 99, NULL, NULL, 89267),
(89268, '1.10.287.70-FF-000491', NULL, 'Ionotropic receptor 7b', 127, NULL, NULL, 89268),
(89269, '2.140.10.30-FF-000007', NULL, 'DAP2p Dipeptidyl aminopeptidase', 480, NULL, NULL, 89269),
(89270, '3.90.920.10-FF-000021', NULL, 'DNA primase small subunit PriS', 252, NULL, NULL, 89270),
(89271, '2.130.10.10-FF-003650', NULL, 'WD repeat-containing protein 48 homolog', 343, NULL, NULL, 89271),
(89272, '3.40.50.2000-FF-001129', NULL, 'Uncharacterized protein', 106, NULL, NULL, 89272),
(89273, '3.30.160.60-FF-002823', NULL, 'Uncharacterized protein, isoform B', 31, NULL, NULL, 89273),
(89274, '2.60.120.650-FF-000063', NULL, 'JmjC domain containing protein', 245, NULL, NULL, 89274),
(89275, '3.40.50.300-FF-005393', NULL, 'Uncharacterized protein', 297, NULL, NULL, 89275),
(89276, '2.40.30.170-FF-000070', NULL, NULL, 87, NULL, NULL, 89276),
(89277, '3.30.1360.10-FF-000013', NULL, 'RNA polymerase I and III subunit C', 60, NULL, NULL, 89277),
(89278, '3.80.10.10-FF-004454', NULL, 'Uncharacterized protein', 101, NULL, NULL, 89278),
(89279, '1.25.10.10-FF-002208', NULL, 'Os01g0973300 protein', 427, NULL, NULL, 89279),
(89280, '3.40.50.300-FF-008141', NULL, 'Uncharacterized protein', 98, NULL, NULL, 89280),
(89281, '2.40.240.10-FF-000006', NULL, 'Putative glutamine--tRNA ligase', 114, NULL, NULL, 89281),
(89282, '1.10.287.180-FF-000001', NULL, 'Transcription elongation factor GreA', 76, NULL, NULL, 89282),
(89283, '1.20.58.1780-FF-000023', NULL, 'Uncharacterized protein', 250, NULL, NULL, 89283),
(89284, '3.40.1360.10-FF-000050', NULL, 'Uncharacterized protein', 209, NULL, NULL, 89284),
(89285, '3.10.110.10-FF-000062', NULL, 'Ubiquitin-conjugating enzyme E2 B', 152, NULL, NULL, 89285),
(89286, '1.50.40.10-FF-000387', NULL, 'Mitochondrial substrate carrier protein', 302, NULL, NULL, 89286);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(89287, '3.30.450.30-FF-000004', NULL, 'ragulator complex protein LAMTOR2', 125, NULL, NULL, 89287),
(89288, '2.60.120.10-FF-000184', NULL, 'XRE family transcriptional regulator', 93, NULL, NULL, 89288),
(89289, '3.40.30.10-FF-000516', NULL, 'Thioredoxin_-_putative', 80, NULL, NULL, 89289),
(89290, '3.40.1280.10-FF-000010', NULL, 'probable methyltransferase TARBP1', 160, NULL, NULL, 89290),
(89291, '2.60.40.10-FF-000917', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', 91, NULL, NULL, 89291),
(89292, '3.60.10.10-FF-000239', NULL, 'DNA-(apurinic or apyrimidinic site) lyase', 305, NULL, NULL, 89292),
(89293, '3.30.160.60-FF-006191', NULL, NULL, 54, NULL, NULL, 89293),
(89294, '2.60.120.650-FF-000170', NULL, 'HR, lysine demethylase and nuclear receptor corepressor', 173, NULL, NULL, 89294),
(89295, '3.60.21.10-FF-000490', NULL, 'Uncharacterized protein', 91, NULL, NULL, 89295),
(89296, '1.20.1310.10-FF-000008', NULL, 'Cullin 4B', 117, NULL, NULL, 89296),
(89297, '2.120.10.30-FF-000177', NULL, 'Major royal jelly protein 3', 386, NULL, NULL, 89297),
(89298, '3.40.50.1820-FF-000007', NULL, 'UPF0227 protein YcfP', 179, NULL, NULL, 89298),
(89299, '1.10.3210.10-FF-000132', NULL, 'Uncharacterized protein', 94, NULL, NULL, 89299),
(89300, '1.20.1250.20-FF-000287', NULL, 'acetyl-coenzyme A transporter 1 isoform X1', 389, NULL, NULL, 89300),
(89301, '3.40.30.10-FF-000747', NULL, '2-hydroxychromene-2-carboxylate isomerase', 198, NULL, NULL, 89301),
(89302, '3.30.1300.40-FF-000001', NULL, 'Fluorescent protein Dronpa', 61, NULL, NULL, 89302),
(89303, '1.25.40.430-FF-000004', NULL, 'Mitotic spindle checkpoint protein BUBR1', 190, NULL, NULL, 89303),
(89304, '3.40.50.10130-FF-000004', NULL, 'Fanconi anemia, complementation group M', 145, NULL, NULL, 89304),
(89305, '3.30.420.10-FF-000749', NULL, NULL, 70, NULL, NULL, 89305),
(89306, '3.30.1360.200-FF-000008', NULL, 'Protein translocase subunit SecD', 98, NULL, NULL, 89306),
(89307, '2.130.10.10-FF-002245', NULL, 'Uncharacterized protein', 117, NULL, NULL, 89307),
(89308, '3.30.1010.10-FF-000026', NULL, 'Serine/threonine-protein kinase smg-1', 153, NULL, NULL, 89308),
(89309, '1.25.40.10-FF-004166', NULL, 'Mitochondrial outer membrane 72K protein', 101, NULL, NULL, 89309),
(89310, '2.30.42.10-FF-000322', NULL, 'MAGI family member, X-linked a', 104, NULL, NULL, 89310),
(89311, '2.10.25.10-FF-001368', NULL, 'Uncharacterized protein', 50, NULL, NULL, 89311),
(89312, '3.30.200.20-FF-000180', NULL, 'serine/threonine-protein kinase STY46-like', 84, NULL, NULL, 89312),
(89313, '3.30.540.10-FF-000005', NULL, 'Fructose-1,6-bisphosphatase isozyme 2', 200, NULL, NULL, 89313),
(89314, '3.30.160.60-FF-003099', NULL, 'C2H2 zinc finger protein Zas1A', 40, NULL, NULL, 89314),
(89315, '3.30.565.10-FF-000540', NULL, 'DNA topoisomerase 6 subunit B', 141, NULL, NULL, 89315),
(89316, '3.40.30.10-FF-001135', NULL, 'Uncharacterized protein', 69, NULL, NULL, 89316),
(89317, '1.25.40.10-FF-003654', NULL, 'Uncharacterized protein', 151, NULL, NULL, 89317),
(89318, '1.10.287.410-FF-000008', NULL, 'Carboxypeptidase', 76, NULL, NULL, 89318),
(89319, '3.30.530.20-FF-000041', NULL, 'Toxin MT0934', 142, NULL, NULL, 89319),
(89320, '3.40.50.300-FF-006915', NULL, 'ATPase, AAA family protein', 236, NULL, NULL, 89320),
(89321, '3.40.50.300-FF-002520', NULL, 'DNA polymerase III subunit delta', 169, NULL, NULL, 89321),
(89322, '3.90.1600.10-FF-000024', NULL, 'DNA polymerase', 172, NULL, NULL, 89322),
(89323, '1.10.238.10-FF-001040', NULL, 'Uncharacterized protein', 48, NULL, NULL, 89323),
(89324, '3.40.30.10-FF-000623', NULL, 'Protein disulfide isomerase', 112, NULL, NULL, 89324),
(89325, '2.10.25.10-FF-000643', NULL, 'Uncharacterized protein, isoform A', 41, NULL, NULL, 89325),
(89326, '1.10.287.550-FF-000022', NULL, 'Predicted protein', 56, NULL, NULL, 89326),
(89327, '2.60.40.10-FF-002143', NULL, 'B- and T-lymphocyte attenuator', 116, NULL, NULL, 89327),
(89328, '3.40.50.720-FF-001578', NULL, 'Short chain dehydrogenase/reductase, putative (AFU_orthologue AFUA_6G02990)', 233, NULL, NULL, 89328);
INSERT INTO "PUBLIC"."MODEL" VALUES
(89329, '3.40.850.10-FF-000493', NULL, 'Uncharacterized protein', 57, NULL, NULL, 89329),
(89330, '2.60.40.60-FF-000455', NULL, 'GG11701', 99, NULL, NULL, 89330),
(89331, '3.20.200.10-FF-000004', NULL, 'Alpha-protein kinase 1', 109, NULL, NULL, 89331),
(89332, '1.20.1110.10-FF-000009', NULL, 'Calcium-transporting ATPase', 356, NULL, NULL, 89332),
(89333, '1.20.58.60-FF-000123', NULL, 'Desmoplakin a', 225, NULL, NULL, 89333),
(89334, '2.60.40.10-FF-003902', NULL, NULL, 94, NULL, NULL, 89334),
(89335, '3.40.50.300-FF-007427', NULL, 'Uncharacterized protein', 262, NULL, NULL, 89335),
(89336, '1.10.10.10-FF-000336', NULL, 'lupus La protein homolog', 89, NULL, NULL, 89336),
(89337, '3.80.10.10-FF-002088', NULL, 'Serine/threonine kinase 11-interacting protein', 259, NULL, NULL, 89337),
(89338, '3.40.50.20-FF-000066', NULL, 'Uncharacterized protein', 163, NULL, NULL, 89338),
(89339, '3.40.190.10-FF-000251', NULL, 'Peptide ABC transporter substrate-binding protein', 266, NULL, NULL, 89339),
(89340, '2.60.40.150-FF-000140', NULL, 'synaptotagmin-7 isoform X1', 141, NULL, NULL, 89340),
(89341, '3.40.1000.10-FF-000029', NULL, 'Uncharacterized protein', 153, NULL, NULL, 89341),
(89342, '3.40.50.200-FF-000130', NULL, 'Clan SB, family S8, subtilisin-like serine peptidase', 138, NULL, NULL, 89342),
(89343, '3.40.50.1010-FF-000085', NULL, 'Exonuclease', 177, NULL, NULL, 89343),
(89344, '3.60.40.10-FF-000174', NULL, 'Serine/threonine protein phosphatase', 248, NULL, NULL, 89344),
(89345, '3.30.70.260-FF-000047', NULL, 'Phosphoserine phosphatase SerB', 80, NULL, NULL, 89345),
(89346, '1.10.3430.10-FF-000019', NULL, 'Urea transporter', 356, NULL, NULL, 89346),
(89347, '3.30.310.80-FF-000048', NULL, 'Non-specific serine/threonine protein kinase', 95, NULL, NULL, 89347),
(89348, '3.40.33.10-FF-000085', NULL, 'Uncharacterized protein', 84, NULL, NULL, 89348),
(89349, '2.130.10.10-FF-003318', NULL, 'Uncharacterized protein', 151, NULL, NULL, 89349),
(89350, '2.110.10.10-FF-000054', NULL, 'Uncharacterized protein', 194, NULL, NULL, 89350),
(89351, '3.30.200.20-FF-002085', NULL, 'Uncharacterized protein', 82, NULL, NULL, 89351),
(89352, '1.10.510.10-FF-000341', NULL, 'Tyrosine-protein kinase receptor', 196, NULL, NULL, 89352),
(89353, '3.40.50.2300-FF-000612', NULL, 'Uncharacterized protein', 213, NULL, NULL, 89353),
(89354, '3.40.630.10-FF-000510', NULL, 'Os08g0511900 protein', 90, NULL, NULL, 89354),
(89355, '3.40.50.1980-FF-000010', NULL, 'Histidinol dehydrogenase', 119, NULL, NULL, 89355),
(89356, '3.30.200.20-FF-000741', NULL, 'Mitogen-activated protein kinase', 21, NULL, NULL, 89356),
(89357, '2.30.29.30-FF-000359', NULL, 'Protein ENHANCED DISEASE RESISTANCE 2-like', 119, NULL, NULL, 89357),
(89358, '1.20.120.720-FF-000010', NULL, 'Unconventional myosin-Ie', 111, NULL, NULL, 89358),
(89359, '3.40.50.1000-FF-000312', NULL, 'Cation-transporting P-type ATPase', 154, NULL, NULL, 89359),
(89360, '3.40.1090.10-FF-000074', NULL, 'Patatin', 392, NULL, NULL, 89360),
(89361, '2.130.10.130-FF-000055', NULL, NULL, 136, NULL, NULL, 89361),
(89362, '2.40.10.10-FF-000574', NULL, NULL, 57, NULL, NULL, 89362),
(89363, '1.20.140.10-FF-000147', NULL, 'Acyl-CoA dehydrogenase very long chain', 118, NULL, NULL, 89363),
(89364, '3.90.1750.20-FF-000015', NULL, NULL, 121, NULL, NULL, 89364),
(89365, '1.10.600.10-FF-000112', NULL, 'Ent-pimara-9(11),15-diene synthase', 272, NULL, NULL, 89365),
(89366, '1.10.472.80-FF-000115', NULL, 'E3 ubiquitin-protein ligase RNF8', 129, NULL, NULL, 89366),
(89367, '1.10.420.10-FF-000020', NULL, 'Os01g0293900 protein', 55, NULL, NULL, 89367),
(89368, '3.40.30.10-FF-000062', NULL, 'Nucleoredoxin', 137, NULL, NULL, 89368),
(89369, '1.10.510.10-FF-003775', NULL, NULL, 135, NULL, NULL, 89369),
(89370, '2.170.270.10-FF-000045', NULL, 'Putative zinc finger protein ZFPM2', 114, NULL, NULL, 89370),
(89371, '2.60.40.10-FF-001070', NULL, 'Prostaglandin F2 receptor inhibitor', 123, NULL, NULL, 89371),
(89372, '3.30.300.10-FF-000010', NULL, 'S-adenosylmethionine synthase', 140, NULL, NULL, 89372),
(89373, '1.10.238.10-FF-000421', NULL, 'Polcalcin Jun o 2', 71, NULL, NULL, 89373);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(89374, '1.20.1720.10-FF-000039', NULL, 'Drug resistance transporter, EmrB/QacA family', 236, NULL, NULL, 89374),
(89375, '3.30.70.330-FF-000984', NULL, 'Hsh49p', 102, NULL, NULL, 89375),
(89376, '1.25.40.10-FF-000001', NULL, 'Clathrin heavy chain', 340, NULL, NULL, 89376),
(89377, '2.130.10.10-FF-000901', NULL, 'WD repeat-containing protein 6', 260, NULL, NULL, 89377),
(89378, '3.10.580.10-FF-000085', NULL, 'Membrane protein, TerC family/CBS domain/transporter associated domain protein', 155, NULL, NULL, 89378),
(89379, '3.30.300.130-FF-000016', NULL, 'Iron-sulfur cluster carrier protein', 88, NULL, NULL, 89379),
(89380, '3.40.50.300-FF-002644', NULL, 'Cobalt ABC transporter ATP-binding protein', 209, NULL, NULL, 89380),
(89381, '3.10.20.90-FF-000474', NULL, 'Autophagy-related protein', 124, NULL, NULL, 89381),
(89382, '1.10.285.10-FF-000002', NULL, 'Glutamate dehydrogenase', 53, NULL, NULL, 89382),
(89383, '1.10.287.130-FF-000138', NULL, 'Sensor histidine kinase', 98, NULL, NULL, 89383),
(89384, '3.80.10.10-FF-001705', NULL, 'Leucine-rich repeat receptor protein kinase EMS1', 219, NULL, NULL, 89384),
(89385, '3.40.50.150-FF-001834', NULL, NULL, 63, NULL, NULL, 89385),
(89386, '3.40.50.800-FF-000091', NULL, 'threonine--tRNA ligase, mitochondrial isoform X3', 63, NULL, NULL, 89386),
(89387, '2.60.40.1500-FF-000003', NULL, NULL, 137, NULL, NULL, 89387),
(89388, '3.40.50.1100-FF-000247', NULL, 'Uncharacterized protein', 23, NULL, NULL, 89388),
(89389, '3.90.740.10-FF-000035', NULL, 'Isoleucyl-tRNA synthetase', 144, NULL, NULL, 89389),
(89390, '3.20.20.70-FF-000271', NULL, 'Lipoyl synthase', 205, NULL, NULL, 89390),
(89391, '3.90.79.10-FF-000071', NULL, 'Hydrolase, NUDIX family', 179, NULL, NULL, 89391),
(89392, '3.20.20.300-FF-000001', NULL, 'Beta-hexosaminidase', 340, NULL, NULL, 89392),
(89393, '1.10.10.570-FF-000011', NULL, 'ESCRT-II subunit protein', 110, NULL, NULL, 89393),
(89394, '3.80.10.10-FF-003942', NULL, 'Ribonuclease inhibitor-like protein', 78, NULL, NULL, 89394),
(89395, '2.130.10.10-FF-005679', NULL, 'Predicted protein', 161, NULL, NULL, 89395),
(89396, '3.40.50.1820-FF-001643', NULL, 'Uncharacterized protein', 402, NULL, NULL, 89396),
(89397, '1.25.40.190-FF-000011', NULL, NULL, 74, NULL, NULL, 89397),
(89398, '2.60.120.970-FF-000041', NULL, 'Bone morphogenetic protein 7a', 254, NULL, NULL, 89398),
(89399, '1.10.1320.10-FF-000005', NULL, 'DNA-directed RNA polymerase', 333, NULL, NULL, 89399),
(89400, '3.40.1170.60-FF-000005', NULL, 'DNA repair protein REV1', 62, NULL, NULL, 89400),
(89401, '3.10.28.10-FF-000046', NULL, 'Probable cell division protein WhiA', 182, NULL, NULL, 89401),
(89402, '1.10.20.10-FF-000056', NULL, 'Transcription initiation factor TFIID subunit 3', 89, NULL, NULL, 89402),
(89403, '3.40.720.10-FF-000270', NULL, 'Predicted protein', 418, NULL, NULL, 89403),
(89404, '1.10.472.10-FF-000134', NULL, 'Os02g0800500 protein', 63, NULL, NULL, 89404),
(89405, '3.30.70.2760-FF-000011', NULL, NULL, 109, NULL, NULL, 89405),
(89406, '3.10.180.10-FF-000116', NULL, '4-hydroxyphenylpyruvate dioxygenase', 174, NULL, NULL, 89406),
(89407, '3.40.50.300-FF-001340', NULL, 'Probable inactive shikimate kinase like 2, chloroplastic', 176, NULL, NULL, 89407),
(89408, '1.10.3380.30-FF-000015', NULL, 'SKI2 homolog, superkiller viralicidic activity 2-like', 65, NULL, NULL, 89408),
(89409, '1.10.10.60-FF-000997', NULL, NULL, 113, NULL, NULL, 89409),
(89410, '3.40.50.2300-FF-001337', NULL, NULL, 74, NULL, NULL, 89410),
(89411, '3.30.70.330-FF-000309', NULL, 'RNA-binding protein 42', 151, NULL, NULL, 89411),
(89412, '2.60.40.10-FF-002486', NULL, 'Immunoglobulin heavy variable 6-1', 108, NULL, NULL, 89412),
(89413, '1.20.1240.10-FF-000002', NULL, 'Photosystem I reaction center subunit XI', 147, NULL, NULL, 89413),
(89414, '1.20.5.4820-FF-000008', NULL, 'Putative myosin F', 112, NULL, NULL, 89414),
(89415, '2.60.260.20-FF-000129', NULL, 'CG7387 protein', 49, NULL, NULL, 89415),
(89416, '3.30.200.20-FF-001702', NULL, 'Putative serine/threonine-protein kinase', 58, NULL, NULL, 89416),
(89417, '1.25.40.10-FF-000456', NULL, 'transmembrane and TPR repeat-containing protein 4 isoform X2', 307, NULL, NULL, 89417);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(89418, '2.30.29.30-FF-000691', NULL, 'Src kinase associated phosphoprotein 1', 127, NULL, NULL, 89418),
(89419, '2.60.200.20-FF-000120', NULL, 'FHA domain containing protein', 103, NULL, NULL, 89419),
(89420, '1.10.225.10-FF-000004', NULL, 'prosaposin isoform X2', 81, NULL, NULL, 89420),
(89421, '2.30.29.30-FF-000016', NULL, 'dedicator of cytokinesis protein 9 isoform X1', 124, NULL, NULL, 89421),
(89422, '1.10.3520.10-FF-000009', NULL, 'Putative glycolipid transfer protein (GLTP) family protein', 197, NULL, NULL, 89422),
(89423, '2.40.20.10-FF-000075', NULL, 'Metalloendopeptidase', 111, NULL, NULL, 89423),
(89424, '3.90.550.10-FF-000548', NULL, 'UDP-N-acetylglucosamine-pyrophosphorylase', 150, NULL, NULL, 89424),
(89425, '3.40.50.300-FF-006230', NULL, 'Uncharacterized protein', 159, NULL, NULL, 89425),
(89426, '2.60.40.10-FF-000356', NULL, 'Low affinity immunoglobulin gamma Fc region receptor III-A', 86, NULL, NULL, 89426),
(89427, '3.30.830.10-FF-000201', NULL, 'Insulin degrading enzyme-like zinc peptidase, putative', 238, NULL, NULL, 89427),
(89428, '1.25.40.10-FF-002710', NULL, 'Tetratricopeptide repeat protein 1', 84, NULL, NULL, 89428),
(89429, '3.40.50.720-FF-001235', NULL, 'D-3-phosphoglycerate dehydrogenase', 191, NULL, NULL, 89429),
(89430, '1.10.287.110-FF-000256', NULL, 'Os05g0397800 protein', 60, NULL, NULL, 89430),
(89431, '1.10.510.10-FF-002606', NULL, NULL, 165, NULL, NULL, 89431),
(89432, '1.20.1070.10-FF-002097', NULL, 'Uncharacterized protein', 365, NULL, NULL, 89432),
(89433, '2.120.10.80-FF-000057', NULL, 'Kelch-like family member 14', 87, NULL, NULL, 89433),
(89434, '3.40.50.300-FF-000047', NULL, '6-phosphofructo-2-kinase/fructose-2, 6-bisphosphatase 3 isoform 2', 211, NULL, NULL, 89434),
(89435, '1.20.1070.10-FF-001478', NULL, 'Uncharacterized protein', 208, NULL, NULL, 89435),
(89436, '1.25.40.180-FF-000238', NULL, NULL, 300, NULL, NULL, 89436),
(89437, '3.90.780.10-FF-000032', NULL, 'Ser/Thr protein phosphatase family protein', 146, NULL, NULL, 89437),
(89438, '3.40.50.300-FF-004336', NULL, 'Packaging enzyme P4', 254, NULL, NULL, 89438),
(89439, '1.10.630.10-FF-000283', NULL, 'Cytochrome P450 family 2 subfamily G member 1, pseudogene', 389, NULL, NULL, 89439),
(89440, '2.130.10.10-FF-000665', NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', 303, NULL, NULL, 89440),
(89441, '1.10.10.60-FF-001273', NULL, NULL, 77, NULL, NULL, 89441),
(89442, '1.20.1530.20-FF-000106', NULL, 'Uncharacterized protein', 110, NULL, NULL, 89442),
(89443, '3.30.420.40-FF-000730', NULL, 'Actin family', 119, NULL, NULL, 89443),
(89444, '2.130.10.10-FF-001284', NULL, 'Maintenance of killer', 299, NULL, NULL, 89444),
(89445, '1.25.10.10-FF-001921', NULL, 'Unc-45 myosin chaperone B', 176, NULL, NULL, 89445),
(89446, '2.130.10.10-FF-001626', NULL, 'Dynein intermediate chain', 223, NULL, NULL, 89446),
(89447, '2.130.10.10-FF-004032', NULL, 'Uncharacterized protein', 220, NULL, NULL, 89447),
(89448, '3.40.50.300-FF-002301', NULL, 'Afg1p', 170, NULL, NULL, 89448),
(89449, '3.40.50.11350-FF-000033', NULL, 'Predicted protein', 140, NULL, NULL, 89449),
(89450, '3.40.50.300-FF-001683', NULL, 'ABC transporter B family member 20', 248, NULL, NULL, 89450),
(89451, '1.20.1250.20-FF-001124', NULL, 'MFS transporter, putative', 244, NULL, NULL, 89451),
(89452, '1.10.555.10-FF-000214', NULL, NULL, 55, NULL, NULL, 89452),
(89453, '2.170.16.10-FF-000047', NULL, 'ATP-dependent DNA helicase Hel308', 109, NULL, NULL, 89453),
(89454, '3.90.170.10-FF-000002', NULL, 'Adenylosuccinate synthetase', 70, NULL, NULL, 89454),
(89455, '3.50.50.60-FF-000307', NULL, 'Monodehydroascorbate reductase 6', 128, NULL, NULL, 89455),
(89456, '2.60.40.10-FF-004627', NULL, NULL, 79, NULL, NULL, 89456),
(89457, '1.10.1070.11-FF-000133', NULL, 'Serine/threonine-protein kinase TOR', 189, NULL, NULL, 89457),
(89458, '3.40.50.2000-FF-000747', NULL, 'Uncharacterized protein', 157, NULL, NULL, 89458),
(89459, '1.10.8.60-FF-000563', NULL, 'ORC1-type DNA replication protein 1', 83, NULL, NULL, 89459),
(89460, '2.130.10.10-FF-003756', NULL, 'Uncharacterized protein', 325, NULL, NULL, 89460); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(89461, '2.40.37.10-FF-000040', NULL, 'Uncharacterized protein', 117, NULL, NULL, 89461),
(89462, '2.60.200.10-FF-000022', NULL, 'Dwarfin sma', 200, NULL, NULL, 89462),
(89463, '1.10.287.890-FF-000006', NULL, 'Uncharacterized protein', 103, NULL, NULL, 89463),
(89464, '2.10.220.10-FF-000034', NULL, 'Proprotein convertase subtilisin/kexin type 5', 54, NULL, NULL, 89464),
(89465, '3.30.70.330-FF-003058', NULL, NULL, 107, NULL, NULL, 89465),
(89466, '2.10.70.10-FF-000039', NULL, 'seizure 6-like protein 2 isoform X2', 63, NULL, NULL, 89466),
(89467, '1.25.40.10-FF-001417', NULL, 'FI17138p1', 134, NULL, NULL, 89467),
(89468, '3.40.640.10-FF-000117', NULL, 'Acetylornithine aminotransferase', 247, NULL, NULL, 89468),
(89469, '1.25.40.10-FF-000799', NULL, 'Pentatricopeptide repeat-containing protein At1g07590, mitochondrial', 92, NULL, NULL, 89469),
(89470, '1.20.140.40-FF-000033', NULL, 'Pectinesterase', 160, NULL, NULL, 89470),
(89471, '2.60.40.10-FF-003447', NULL, NULL, 103, NULL, NULL, 89471),
(89472, '3.10.20.90-FF-000693', NULL, 'Ubiquitin-specific protease', 90, NULL, NULL, 89472),
(89473, '3.30.200.20-FF-000409', NULL, 'serine/threonine-protein kinase haspin', 136, NULL, NULL, 89473),
(89474, '3.30.160.60-FF-000226', NULL, 'Zinc finger protein 236 variant', 32, NULL, NULL, 89474),
(89475, '1.10.3500.10-FF-000014', NULL, 'Putative transcription modulator/accessory protein', 262, NULL, NULL, 89475),
(89476, '3.30.70.1230-FF-000114', NULL, 'Adenylate cyclase 8 (brain)', 195, NULL, NULL, 89476),
(89477, '1.10.510.10-FF-004394', NULL, NULL, 88, NULL, NULL, 89477),
(89478, '2.40.100.10-FF-000176', NULL, 'Uncharacterized protein', 181, NULL, NULL, 89478),
(89479, '2.10.25.10-FF-001604', NULL, 'Uncharacterized protein', 45, NULL, NULL, 89479),
(89480, '3.30.450.20-FF-000563', NULL, 'Histidine kinase sensor protein', 77, NULL, NULL, 89480),
(89481, '1.10.238.10-FF-000764', NULL, 'I/6 autoantigen', 95, NULL, NULL, 89481),
(89482, '1.10.510.10-FF-001988', NULL, 'Ste20-like kinase, isoform C', 212, NULL, NULL, 89482),
(89483, '3.40.50.1820-FF-001862', NULL, 'Triacylglycerol lipase, putative', 47, NULL, NULL, 89483),
(89484, '1.10.10.10-FF-000212', NULL, 'Eukaryotic translation initiation factor 3 subunit K', 96, NULL, NULL, 89484),
(89485, '3.40.1190.20-FF-000129', NULL, 'Adenosine kinase, putative', 297, NULL, NULL, 89485),
(89486, '3.30.2230.10-FF-000026', NULL, 'Uncharacterized protein', 96, NULL, NULL, 89486),
(89487, '1.10.8.60-FF-000125', NULL, 'Peroxisome biogenesis protein 1', 80, NULL, NULL, 89487),
(89488, '1.10.510.10-FF-002264', NULL, NULL, 119, NULL, NULL, 89488),
(89489, '1.25.10.10-FF-000960', NULL, 'Protein phosphatase PP2A regulatory subunit B', 324, NULL, NULL, 89489),
(89490, '3.30.200.20-FF-001360', NULL, 'GD10379', 88, NULL, NULL, 89490),
(89491, '2.70.170.10-FF-000207', NULL, 'Gaba-gated chloride channel, putative', 160, NULL, NULL, 89491),
(89492, '2.120.10.80-FF-000170', NULL, 'Multiple EGF-like-domains 8', 200, NULL, NULL, 89492),
(89493, '3.40.190.290-FF-000074', NULL, 'Transcriptional regulator, LysR family', 202, NULL, NULL, 89493),
(89494, '3.40.50.300-FF-001008', NULL, 'Mitochondrial GTPase 1', 180, NULL, NULL, 89494),
(89495, '3.30.70.330-FF-000641', NULL, 'ELAV-Type RNA binding-protein family', 92, NULL, NULL, 89495),
(89496, '1.10.510.10-FF-000009', NULL, 'Mitogen-activated protein kinase', 222, NULL, NULL, 89496),
(89497, '3.40.50.720-FF-001814', NULL, 'Uncharacterized protein', 262, NULL, NULL, 89497),
(89498, '2.60.40.10-FF-003666', NULL, NULL, 98, NULL, NULL, 89498),
(89499, '3.90.190.10-FF-000110', NULL, 'PPS1p Protein phosphatase', 171, NULL, NULL, 89499),
(89500, '3.30.559.70-FF-000021', NULL, 'Predicted protein', 311, NULL, NULL, 89500),
(89501, '2.60.40.10-FF-004408', NULL, NULL, 100, NULL, NULL, 89501),
(89502, '3.40.50.261-FF-000008', NULL, 'ATP-citrate synthase alpha chain protein', 183, NULL, NULL, 89502),
(89503, '3.30.1640.10-FF-000040', NULL, 'DNA helicase', 105, NULL, NULL, 89503),
(89504, '1.10.510.10-FF-000684', NULL, 'Mitogen-activated protein kinase', 209, NULL, NULL, 89504);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(89505, '2.60.120.330-FF-000192', NULL, 'Os05g0149300 protein', 175, NULL, NULL, 89505),
(89506, '2.40.10.10-FF-000231', NULL, 'Trypsin domain-containing 1', 66, NULL, NULL, 89506),
(89507, '2.60.40.10-FF-004066', NULL, NULL, 96, NULL, NULL, 89507),
(89508, '3.10.20.10-FF-000034', NULL, 'Large subunit ribosomal protein L18Ae', 36, NULL, NULL, 89508),
(89509, '1.25.40.20-FF-001297', NULL, 'Uncharacterized protein', 159, NULL, NULL, 89509),
(89510, '3.40.50.2020-FF-000068', NULL, 'Predicted protein', 168, NULL, NULL, 89510),
(89511, '4.10.800.10-FF-000037', NULL, 'Nidogen 2a (osteonidogen)', 41, NULL, NULL, 89511),
(89512, '2.40.10.10-FF-000355', NULL, NULL, 105, NULL, NULL, 89512),
(89513, '3.30.300.160-FF-000014', NULL, 'Type IV pilus biogenesis ATPase PilB', 81, NULL, NULL, 89513),
(89514, '2.120.10.30-FF-000071', NULL, 'Uncharacterized protein', 197, NULL, NULL, 89514),
(89515, '2.60.40.10-FF-000013', NULL, 'cell adhesion molecule 1 isoform X1', 101, NULL, NULL, 89515),
(89516, '3.30.160.60-FF-000569', NULL, 'zinc finger protein 26 isoform X1', 28, NULL, NULL, 89516),
(89517, '3.30.1320.10-FF-000016', NULL, '30S ribosomal protein S16', 82, NULL, NULL, 89517),
(89518, '2.130.10.10-FF-004375', NULL, 'Uncharacterized protein', 81, NULL, NULL, 89518),
(89519, '2.120.10.30-FF-000413', NULL, 'Uncharacterized protein', 185, NULL, NULL, 89519),
(89520, '3.40.50.720-FF-001472', NULL, 'Hypothetical pyrroline-5-carboxylate reductase (Eurofung)', 189, NULL, NULL, 89520),
(89521, '3.30.200.20-FF-001028', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 1', 119, NULL, NULL, 89521),
(89522, '2.60.120.1000-FF-000033', NULL, 'Uncharacterized protein', 241, NULL, NULL, 89522),
(89523, '1.25.40.10-FF-002036', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 99, NULL, NULL, 89523),
(89524, '3.30.70.270-FF-000269', NULL, NULL, 154, NULL, NULL, 89524),
(89525, '3.40.50.300-FF-004774', NULL, 'GTP-binding ADP-ribosylation factor ARF1, putative', 65, NULL, NULL, 89525),
(89526, '2.60.120.10-FF-000420', NULL, 'Mannose-6-phosphate isomerase', 87, NULL, NULL, 89526),
(89527, '3.90.550.10-FF-000205', NULL, 'Peptidase M23B', 158, NULL, NULL, 89527),
(89528, '2.40.170.20-FF-000127', NULL, NULL, 127, NULL, NULL, 89528),
(89529, '2.10.25.10-FF-001262', NULL, 'Matrilin 2', 36, NULL, NULL, 89529),
(89530, '2.10.25.10-FF-000862', NULL, 'EGF-like-domain multiple 7', 65, NULL, NULL, 89530),
(89531, '3.40.50.880-FF-000075', NULL, 'Carbamoyl-phosphate synthase small chain', 211, NULL, NULL, 89531),
(89532, '3.10.196.10-FF-000006', NULL, 'Methionine synthase', 254, NULL, NULL, 89532),
(89533, '1.10.10.60-FF-000311', NULL, 'Zinc fingers and homeoboxes 2a', 47, NULL, NULL, 89533),
(89534, '2.10.90.10-FF-000041', NULL, 'Platelet-derived growth factor beta polypeptide b', 151, NULL, NULL, 89534),
(89535, '3.40.50.2300-FF-001574', NULL, NULL, 150, NULL, NULL, 89535),
(89536, '2.100.10.50-FF-000009', NULL, 'Predicted protein', 117, NULL, NULL, 89536),
(89537, '3.40.1110.10-FF-000352', NULL, NULL, 60, NULL, NULL, 89537),
(89538, '3.30.200.20-FF-002321', NULL, 'Uncharacterized protein', 87, NULL, NULL, 89538),
(89539, '1.10.287.70-FF-000159', NULL, 'Potassium voltage-gated channel, subfamily H (eag-related), member 6', 207, NULL, NULL, 89539),
(89540, '2.60.40.10-FF-005920', NULL, NULL, 145, NULL, NULL, 89540),
(89541, '1.25.10.10-FF-000628', NULL, 'tRNA binding protein, putative', 1079, NULL, NULL, 89541),
(89542, '1.10.8.50-FF-000009', NULL, 'Formamidopyrimidine-DNA glycosylase', 141, NULL, NULL, 89542),
(89543, '1.25.40.860-FF-000015', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 75, NULL, NULL, 89543),
(89544, '2.60.120.560-FF-000036', NULL, 'Heat shock protein DnaJ domain protein', 160, NULL, NULL, 89544),
(89545, '1.20.80.10-FF-000076', NULL, 'Uncharacterized protein', 106, NULL, NULL, 89545),
(89546, '3.40.50.2000-FF-001023', NULL, 'UDP-N-acetylglucosamine transferase subunit alg14', 177, NULL, NULL, 89546),
(89547, '1.20.1250.20-FF-001248', NULL, 'Solute carrier family 15 member 1a', 533, NULL, NULL, 89547);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(89548, '1.25.10.10-FF-002540', NULL, 'Armadillo repeat-containing zfs1 target protein 1', 182, NULL, NULL, 89548),
(89549, '4.10.400.10-FF-000164', NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein-like Protein', 41, NULL, NULL, 89549),
(89550, '2.40.170.20-FF-000003', NULL, 'Ferrichrome outer membrane transporter/phage receptor', 554, NULL, NULL, 89550),
(89551, '1.20.58.480-FF-000011', NULL, 'Indoleamine 2,3-dioxygenase', 272, NULL, NULL, 89551),
(89552, '1.10.10.60-FF-000654', NULL, 'Homeobox transcription factor', 51, NULL, NULL, 89552),
(89553, '3.10.129.10-FF-000099', NULL, 'UPF0336 protein Rv0635', 158, NULL, NULL, 89553),
(89554, '2.60.40.1090-FF-000043', NULL, 'Fimbrial subunit CupC1', 181, NULL, NULL, 89554),
(89555, '3.30.200.20-FF-001921', NULL, 'Uncharacterized protein', 60, NULL, NULL, 89555),
(89556, '1.20.5.110-FF-000289', NULL, 'Synaptobrevin-B', 98, NULL, NULL, 89556),
(89557, '2.130.10.10-FF-000322', NULL, 'Methylosome protein 50', 322, NULL, NULL, 89557),
(89558, '3.90.550.10-FF-000329', NULL, 'Xyloglucan 6-xylosyltransferase 2', 100, NULL, NULL, 89558),
(89559, '3.30.70.330-FF-000080', NULL, 'RNA-binding protein 39 isoform X1', 105, NULL, NULL, 89559),
(89560, '1.20.1250.20-FF-000848', NULL, 'Drug resistance transporter, EmrB/QacA family', 210, NULL, NULL, 89560),
(89561, '3.40.50.2000-FF-000404', NULL, 'Putative polysaccharide biosynthesis protein', 173, NULL, NULL, 89561),
(89562, '1.25.40.20-FF-001639', NULL, 'Protein 21.1, putative', 94, NULL, NULL, 89562),
(89563, '1.10.10.1440-FF-000002', NULL, NULL, 81, NULL, NULL, 89563),
(89564, '3.90.226.10-FF-000059', NULL, 'ATP-dependent Clp protease proteolytic subunit', 195, NULL, NULL, 89564),
(89565, '3.30.1370.10-FF-000171', NULL, 'Exosomal 3''-5'' exoribonuclease complex subunit, putative', 83, NULL, NULL, 89565),
(89566, '3.20.20.190-FF-000136', NULL, NULL, 71, NULL, NULL, 89566),
(89567, '3.40.190.10-FF-000138', NULL, 'ABC transporter substrate-binding protein', 103, NULL, NULL, 89567),
(89568, '3.40.1390.20-FF-000004', NULL, 'HPr kinase/phosphorylase', 134, NULL, NULL, 89568),
(89569, '1.25.40.20-FF-001858', NULL, 'Predicted protein', 135, NULL, NULL, 89569),
(89570, '3.40.47.10-FF-000263', NULL, NULL, 244, NULL, NULL, 89570),
(89571, '1.10.3650.10-FF-000002', NULL, NULL, 74, NULL, NULL, 89571),
(89572, '1.20.120.430-FF-000024', NULL, 'tRNA modification GTPase GTPBP3, mitochondrial-like protein', 164, NULL, NULL, 89572),
(89573, '2.10.25.10-FF-000986', NULL, 'Megalin, isoform A', 38, NULL, NULL, 89573),
(89574, '3.30.50.10-FF-000035', NULL, 'Nuclear receptor subfamily 1 group I member 3', 106, NULL, NULL, 89574),
(89575, '3.30.230.70-FF-000005', NULL, 'Exosome complex component RRP45', 288, NULL, NULL, 89575),
(89576, '3.30.160.60-FF-001862', NULL, 'Zgc:174563 protein', 29, NULL, NULL, 89576),
(89577, '1.10.150.110-FF-000032', NULL, 'Predicted protein', 74, NULL, NULL, 89577),
(89578, '3.40.50.150-FF-000530', NULL, 'Os11g0256900 protein', 144, NULL, NULL, 89578),
(89579, '2.160.20.10-FF-000131', NULL, 'Right_handed_beta_helix_region /Periplasmic_copper-binding_protein_(NosD)_-_putative', 263, NULL, NULL, 89579),
(89580, '3.30.450.40-FF-000226', NULL, 'Serine phosphatase RsbU, regulator of sigma subunit', 180, NULL, NULL, 89580),
(89581, '3.10.450.50-FF-000082', NULL, 'Ras GTPase-activating protein-binding protein 1', 134, NULL, NULL, 89581),
(89582, '4.10.75.10-FF-000006', NULL, 'Protein CBG06419', 57, NULL, NULL, 89582),
(89583, '3.90.76.10-FF-000030', NULL, 'Oligopeptide ABC transporter, oligopeptide-binding protein', 133, NULL, NULL, 89583),
(89584, '1.20.1250.20-FF-001809', NULL, 'Uncharacterized protein', 165, NULL, NULL, 89584),
(89585, '3.40.50.450-FF-000064', NULL, 'Phosphofructokinase, platelet b', 61, NULL, NULL, 89585),
(89586, '2.60.40.10-FF-000232', NULL, 'Kirre like nephrin family adhesion molecule 1', 83, NULL, NULL, 89586),
(89587, '3.30.70.870-FF-000011', NULL, 'Elongation factor Tu, putative', 74, NULL, NULL, 89587),
(89588, '3.40.50.2000-FF-000062', NULL, 'sulfoquinovosyl transferase SQD2', 163, NULL, NULL, 89588);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(89589, '1.10.1450.10-FF-000009', NULL, 'Tetraspanin', 89, NULL, NULL, 89589),
(89590, '3.50.50.60-FF-000982', NULL, 'Fmo1p', 76, NULL, NULL, 89590),
(89591, '3.90.1420.10-FF-000038', NULL, 'Uncharacterized protein', 160, NULL, NULL, 89591),
(89592, '1.10.510.10-FF-001645', NULL, 'Serine/threonine-protein kinase BGLF4', 210, NULL, NULL, 89592),
(89593, '3.40.50.300-FF-005050', NULL, 'Adp-ribosylation factor-related protein', 195, NULL, NULL, 89593),
(89594, '3.30.1050.10-FF-000023', NULL, 'Metallo-beta-lactamase superfamily protein', 120, NULL, NULL, 89594),
(89595, '2.60.60.30-FF-000003', NULL, 'Tellurium resistance protein TerZ', 169, NULL, NULL, 89595),
(89596, '1.10.10.2660-FF-000031', NULL, 'Ubiquitin-activating enzyme E1-like (Predicted)', 46, NULL, NULL, 89596),
(89597, '1.10.10.60-FF-000093', NULL, 'ALX homeobox protein 1', 72, NULL, NULL, 89597),
(89598, '3.10.290.10-FF-000107', NULL, 'Uncharacterized protein', 64, NULL, NULL, 89598),
(89599, '3.30.160.60-FF-005572', NULL, NULL, 46, NULL, NULL, 89599),
(89600, '3.30.450.20-FF-000220', NULL, 'Sensory box/GGDEF family protein', 119, NULL, NULL, 89600),
(89601, '2.10.25.10-FF-001823', NULL, 'Uncharacterized protein', 20, NULL, NULL, 89601),
(89602, '3.40.50.300-FF-008484', NULL, 'Uncharacterized protein', 174, NULL, NULL, 89602),
(89603, '1.20.1560.10-FF-000616', NULL, 'Uncharacterized protein', 40, NULL, NULL, 89603),
(89604, '1.10.2000.10-FF-000083', NULL, NULL, 135, NULL, NULL, 89604),
(89605, '1.10.10.570-FF-000016', NULL, 'Predicted protein', 97, NULL, NULL, 89605),
(89606, '1.10.510.10-FF-001100', NULL, 'Guanylate cyclase', 267, NULL, NULL, 89606),
(89607, '2.130.10.10-FF-002211', NULL, 'Elongator complex protein 2', 248, NULL, NULL, 89607),
(89608, '3.30.40.10-FF-001389', NULL, 'Lysine-specific demethylase rbr-2', 60, NULL, NULL, 89608),
(89609, '1.10.8.480-FF-000019', NULL, 'rRNA adenine N(6)-methyltransferase', 99, NULL, NULL, 89609),
(89610, '2.60.40.10-FF-004324', NULL, NULL, 89, NULL, NULL, 89610),
(89611, '3.40.1110.10-FF-000088', NULL, 'Potassium/sodium efflux P-type ATPase, fungal-type', 233, NULL, NULL, 89611),
(89612, '1.10.10.10-FF-001775', NULL, 'DNA-binding response regulator', 109, NULL, NULL, 89612),
(89613, '3.30.9.10-FF-000075', NULL, 'FAD dependent oxidoreductase superfamily', 181, NULL, NULL, 89613),
(89614, '2.120.10.80-FF-000175', NULL, 'Nitrile-specifier protein 2', 244, NULL, NULL, 89614),
(89615, '3.90.830.10-FF-000019', NULL, 'Vacuolar protein sorting-associated protein 33B', 137, NULL, NULL, 89615),
(89616, '3.50.50.60-FF-000324', NULL, 'AMine oXidase family', 227, NULL, NULL, 89616),
(89617, '1.10.510.40-FF-000007', NULL, 'Siderophore biosynthesis protein', 219, NULL, NULL, 89617),
(89618, '1.10.565.10-FF-000018', NULL, 'Bile acid receptor isoform 4', 233, NULL, NULL, 89618),
(89619, '3.40.50.1820-FF-001502', NULL, 'Uncharacterized protein', 159, NULL, NULL, 89619),
(89620, '1.20.58.740-FF-000005', NULL, 'Guanine nucleotide exchange factor SPIKE 1', 128, NULL, NULL, 89620),
(89621, '3.50.50.60-FF-001426', NULL, 'Uncharacterized protein', 118, NULL, NULL, 89621),
(89622, '1.25.40.10-FF-001962', NULL, 'Transcription-coupled DNA repair protein', 115, NULL, NULL, 89622),
(89623, '3.60.15.10-FF-000031', NULL, 'integrator complex subunit 11 isoform X2', 103, NULL, NULL, 89623),
(89624, '3.30.160.60-FF-006370', NULL, NULL, 99, NULL, NULL, 89624),
(89625, '1.25.10.10-FF-000353', NULL, 'Serine/threonine-protein phosphatase 2A 56 kDa regulatory subunit', 214, NULL, NULL, 89625),
(89626, '2.10.25.10-FF-001290', NULL, 'AGAP002157-PA', 43, NULL, NULL, 89626),
(89627, '1.10.510.10-FF-003663', NULL, NULL, 178, NULL, NULL, 89627),
(89628, '2.160.20.10-FF-000260', NULL, 'Uncharacterized protein', 125, NULL, NULL, 89628),
(89629, '2.40.50.140-FF-000183', NULL, '26S protease regulatory subunit 6a, putative', 84, NULL, NULL, 89629),
(89630, '2.40.170.20-FF-000026', NULL, 'Putative hydroxamate-type ferrisiderophore receptor', 535, NULL, NULL, 89630),
(89631, '1.25.10.10-FF-002444', NULL, 'Uncharacterized protein', 233, NULL, NULL, 89631);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(89632, '3.90.76.10-FF-000047', NULL, 'ABC-type dipeptide transport system periplasmic component', 122, NULL, NULL, 89632),
(89633, '2.40.70.10-FF-000572', NULL, NULL, 148, NULL, NULL, 89633),
(89634, '3.30.160.60-FF-000058', NULL, 'Zinc finger protein 2 homolog', 28, NULL, NULL, 89634),
(89635, '3.80.10.10-FF-003751', NULL, 'Uncharacterized protein', 123, NULL, NULL, 89635),
(89636, '3.40.50.300-FF-007388', NULL, 'Guanine nucleotide-binding protein, putative', 198, NULL, NULL, 89636),
(89637, '1.25.10.10-FF-001455', NULL, 'VPS15 protein kinase', 218, NULL, NULL, 89637),
(89638, '1.10.1600.10-FF-000004', NULL, 'ATP-dependent DNA helicase II subunit 1', 96, NULL, NULL, 89638),
(89639, '3.10.20.310-FF-000034', NULL, 'ShlB/FhaC/HecB family hemolysin secretion/activation protein', 87, NULL, NULL, 89639),
(89640, '1.10.10.10-FF-000201', NULL, 'Forkhead box E1', 108, NULL, NULL, 89640),
(89641, '1.20.58.730-FF-000002', NULL, 'GD16546', 67, NULL, NULL, 89641),
(89642, '1.10.510.10-FF-004326', NULL, NULL, 139, NULL, NULL, 89642),
(89643, '3.80.10.10-FF-002762', NULL, 'F-box/LRR-repeat protein 3', 175, NULL, NULL, 89643),
(89644, '3.30.56.70-FF-000004', NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', 58, NULL, NULL, 89644),
(89645, '2.60.40.150-FF-000106', NULL, 'extended synaptotagmin-1 isoform X1', 149, NULL, NULL, 89645),
(89646, '2.10.70.100-FF-000002', NULL, 'Two-component oxygen-sensor histidine kinase', 45, NULL, NULL, 89646),
(89647, '3.40.50.300-FF-006253', NULL, 'Uncharacterized protein', 173, NULL, NULL, 89647),
(89648, '1.20.1070.10-FF-000854', NULL, 'Protein CBR-SER-1', 165, NULL, NULL, 89648),
(89649, '3.10.20.90-FF-000277', NULL, 'Regulator of G-protein signaling loco', 70, NULL, NULL, 89649),
(89650, '2.130.10.10-FF-004302', NULL, 'Uncharacterized protein', 117, NULL, NULL, 89650),
(89651, '1.20.1560.10-FF-000875', NULL, 'Predicted protein', 121, NULL, NULL, 89651),
(89652, '2.60.40.1480-FF-000008', NULL, 'Uncharacterized protein', 146, NULL, NULL, 89652),
(89653, '1.10.8.60-FF-000209', NULL, 'ClpB protein', 95, NULL, NULL, 89653),
(89654, '2.30.30.40-FF-000337', NULL, 'Disks large homolog 1', 89, NULL, NULL, 89654),
(89655, '3.30.70.1230-FF-000204', NULL, 'Uncharacterized protein', 104, NULL, NULL, 89655),
(89656, '1.10.287.110-FF-000475', NULL, 'Uncharacterized protein', 107, NULL, NULL, 89656),
(89657, '3.40.50.300-FF-004162', NULL, 'ATP binding cassette subfamily C member 5', 110, NULL, NULL, 89657),
(89658, '2.110.10.10-FF-000076', NULL, 'Matrix metallopeptidase 17b', 75, NULL, NULL, 89658),
(89659, '2.30.29.30-FF-000909', NULL, 'Uncharacterized protein', 117, NULL, NULL, 89659),
(89660, '3.30.1150.10-FF-000014', NULL, 'Energy transducer TonB', 198, NULL, NULL, 89660),
(89661, '1.25.40.20-FF-000830', NULL, 'Poly [ADP-ribose] polymerase', 168, NULL, NULL, 89661),
(89662, '3.90.1290.10-FF-000049', NULL, 'AGAP011396-PA', 234, NULL, NULL, 89662),
(89663, '2.60.120.920-FF-000048', NULL, 'SPRY domain-containing SOCS box protein 2', 177, NULL, NULL, 89663),
(89664, '1.20.1070.10-FF-001517', NULL, 'Uncharacterized protein', 193, NULL, NULL, 89664),
(89665, '1.20.1250.20-FF-001618', NULL, 'Polyol transporter 5', 155, NULL, NULL, 89665),
(89666, '1.10.560.10-FF-000029', NULL, 'Chaperonin CPN60, mitochondrial', 244, NULL, NULL, 89666),
(89667, '2.60.40.10-FF-005785', NULL, NULL, 91, NULL, NULL, 89667),
(89668, '2.10.25.10-FF-000828', NULL, 'Thrombospondin-3-like Protein', 41, NULL, NULL, 89668),
(89669, '2.40.110.10-FF-000047', NULL, 'Acyl-CoA dehydrogenase FadE27', 101, NULL, NULL, 89669),
(89670, '1.25.40.10-FF-000501', NULL, 'Putative pentatricopeptide repeat-containing protein mitochondrial', 128, NULL, NULL, 89670),
(89671, '3.30.1490.120-FF-000007', NULL, 'RNA polymerase-like protein, putative', 100, NULL, NULL, 89671),
(89672, '2.30.30.40-FF-000663', NULL, 'Uncharacterized protein', 66, NULL, NULL, 89672),
(89673, '2.130.10.10-FF-001694', NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', 110, NULL, NULL, 89673),
(89674, '3.40.50.2300-FF-001366', NULL, NULL, 139, NULL, NULL, 89674);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(89675, '3.10.28.10-FF-000063', NULL, 'Cytochrome b mRNA maturase bI3', 129, NULL, NULL, 89675),
(89676, '3.40.640.10-FF-000241', NULL, 'Glutamate decarboxylase isoform 67', 231, NULL, NULL, 89676),
(89677, '2.30.180.10-FF-000166', NULL, NULL, 157, NULL, NULL, 89677),
(89678, '1.20.1280.50-FF-000146', NULL, 'Dactylin, putative', 47, NULL, NULL, 89678),
(89679, '2.60.40.150-FF-000432', NULL, 'Synaptotagmin 15b', 107, NULL, NULL, 89679),
(89680, '1.10.132.70-FF-000019', NULL, 'Telomerase reverse transcriptase', 215, NULL, NULL, 89680),
(89681, '3.40.50.12350-FF-000018', NULL, 'Predicted protein', 70, NULL, NULL, 89681),
(89682, '1.10.20.10-FF-000319', NULL, NULL, 129, NULL, NULL, 89682),
(89683, '1.10.10.1590-FF-000002', NULL, '[Fe] hydrogenase, HymA subunit', 66, NULL, NULL, 89683),
(89684, '3.40.50.10090-FF-000054', NULL, 'Uncharacterized protein', 99, NULL, NULL, 89684),
(89685, '2.130.10.10-FF-005763', NULL, 'Myosin heavy chain kinase D', 110, NULL, NULL, 89685),
(89686, '1.25.70.10-FF-000003', NULL, 'transcription termination factor 2, mitochondrial', 232, NULL, NULL, 89686),
(89687, '3.40.50.150-FF-001694', NULL, NULL, 86, NULL, NULL, 89687),
(89688, '3.30.1490.110-FF-000004', NULL, 'Cell division protein FtsA', 83, NULL, NULL, 89688),
(89689, '1.25.40.20-FF-000504', NULL, 'Mindbomb E3 ubiquitin protein ligase 2', 89, NULL, NULL, 89689),
(89690, '1.10.8.870-FF-000013', NULL, 'Glycerol-3-phosphate dehydrogenase', 135, NULL, NULL, 89690),
(89691, '3.80.10.10-FF-003425', NULL, 'Predicted protein', 69, NULL, NULL, 89691),
(89692, '1.10.132.60-FF-000016', NULL, 'DNA polymerase', 182, NULL, NULL, 89692),
(89693, '2.40.30.10-FF-000507', NULL, 'NADPH oxidase 1', 87, NULL, NULL, 89693),
(89694, '1.20.120.1210-FF-000001', NULL, 'T3SS2 effector VopL nucleation of actin polymerization', 136, NULL, NULL, 89694),
(89695, '3.40.50.300-FF-006932', NULL, 'Uncharacterized protein', 230, NULL, NULL, 89695),
(89696, '1.25.40.20-FF-000184', NULL, 'Ankyrin repeat and FYVE domain containing 1', 141, NULL, NULL, 89696),
(89697, '1.20.120.1750-FF-000140', NULL, 'RBR-type E3 ubiquitin transferase', 237, NULL, NULL, 89697),
(89698, '1.10.510.10-FF-002235', NULL, NULL, 188, NULL, NULL, 89698),
(89699, '1.10.420.10-FF-000019', NULL, 'Peroxidase', 63, NULL, NULL, 89699),
(89700, '2.130.10.10-FF-003785', NULL, 'Uncharacterized WD repeat-containing protein C824.04', 314, NULL, NULL, 89700),
(89701, '1.10.220.10-FF-000038', NULL, 'Annexin', 82, NULL, NULL, 89701),
(89702, '3.60.21.10-FF-000444', NULL, 'Serine/threonine-protein phosphatase', 202, NULL, NULL, 89702),
(89703, '1.10.150.80-FF-000042', NULL, 'ATP-dependent DNA helicase RecQ', 87, NULL, NULL, 89703),
(89704, '3.40.190.10-FF-000812', NULL, 'Transferrin-a', 86, NULL, NULL, 89704),
(89705, '1.10.10.10-FF-000347', NULL, 'Ets variant 2', 139, NULL, NULL, 89705),
(89706, '1.10.238.10-FF-000657', NULL, 'Uncharacterized protein', 65, NULL, NULL, 89706),
(89707, '1.10.238.10-FF-000511', NULL, 'Actin-bundling protein Sac6', 94, NULL, NULL, 89707),
(89708, '1.20.5.130-FF-000002', NULL, 'Bacteriocin carnobacteriocin B2', 48, NULL, NULL, 89708),
(89709, '1.10.287.110-FF-000003', NULL, 'Molecular chaperone DnaJ', 113, NULL, NULL, 89709),
(89710, '2.60.40.1460-FF-000002', NULL, 'Integrin subunit alpha 6', 162, NULL, NULL, 89710),
(89711, '1.25.40.10-FF-000181', NULL, 'probable UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SEC', 39, NULL, NULL, 89711),
(89712, '1.10.10.60-FF-000255', NULL, 'DnaJ (Hsp40) homolog, subfamily C, member 1', 66, NULL, NULL, 89712),
(89713, '2.60.40.10-FF-003661', NULL, 'Fibroblast growth factor receptor homolog 2', 84, NULL, NULL, 89713),
(89714, '2.30.29.30-FF-001045', NULL, 'Uncharacterized protein', 122, NULL, NULL, 89714),
(89715, '1.10.268.10-FF-000013', NULL, 'DNA topoisomerase 2', 190, NULL, NULL, 89715),
(89716, '2.60.40.10-FF-002233', NULL, 'Tyrosine protein kinase receptor tie-1, putative', 87, NULL, NULL, 89716),
(89717, '3.30.200.20-FF-002219', NULL, NULL, 41, NULL, NULL, 89717),
(89718, '2.40.50.140-FF-001285', NULL, 'Telomere-binding protein subunit alpha', 116, NULL, NULL, 89718);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(89719, '3.30.499.10-FF-000043', NULL, NULL, 131, NULL, NULL, 89719),
(89720, '3.30.110.30-FF-000012', NULL, 'Proline--tRNA ligase', 72, NULL, NULL, 89720),
(89721, '3.40.50.300-FF-000800', NULL, 'ATP-binding cassette sub-family D member 1', 244, NULL, NULL, 89721),
(89722, '3.30.160.60-FF-005908', NULL, NULL, 54, NULL, NULL, 89722),
(89723, '1.10.10.580-FF-000019', NULL, 'Uncharacterized protein', 78, NULL, NULL, 89723),
(89724, '3.40.50.1820-FF-000985', NULL, 'Predicted protein', 253, NULL, NULL, 89724),
(89725, '3.30.450.20-FF-000113', NULL, 'Taiman, isoform C', 130, NULL, NULL, 89725),
(89726, '3.30.1360.170-FF-000016', NULL, 'Flavin-dependent thymidylate synthase', 181, NULL, NULL, 89726),
(89727, '3.40.50.980-FF-000043', NULL, '4-chlorobenzoate--CoA ligase', 174, NULL, NULL, 89727),
(89728, '4.10.410.10-FF-000081', NULL, 'Serine proteinase inhibitor, putative', 73, NULL, NULL, 89728),
(89729, '3.30.70.330-FF-001097', NULL, 'Splicing factor, arginine/serine-rich, 46kD, isoform CRA_a', 96, NULL, NULL, 89729),
(89730, '1.20.58.390-FF-000029', NULL, 'acetylcholine receptor subunit delta isoform X1', 71, NULL, NULL, 89730),
(89731, '3.40.33.10-FF-000208', NULL, 'Predicted protein', 199, NULL, NULL, 89731),
(89732, '3.40.50.1240-FF-000114', NULL, 'Probable 6-phosphofructo-2-kinase C222.13c', 228, NULL, NULL, 89732),
(89733, '3.40.50.2020-FF-000124', NULL, 'Uridine cytidine kinase I, putative', 122, NULL, NULL, 89733),
(89734, '3.40.50.1440-FF-000023', NULL, 'Cell division protein FtsZ', 305, NULL, NULL, 89734),
(89735, '3.30.65.10-FF-000013', NULL, 'DNA topoisomerase', 51, NULL, NULL, 89735),
(89736, '2.130.10.10-FF-002357', NULL, 'WD repeat-containing protein 78', 176, NULL, NULL, 89736),
(89737, '3.30.420.40-FF-000151', NULL, 'Actin-related protein 4', 183, NULL, NULL, 89737),
(89738, '1.10.630.10-FF-000384', NULL, 'Cytochrome P450, putative', 278, NULL, NULL, 89738),
(89739, '3.40.50.1100-FF-000005', NULL, 'Threonine dehydratase catabolic', 97, NULL, NULL, 89739),
(89740, '1.20.1300.10-FF-000007', NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', 120, NULL, NULL, 89740),
(89741, '3.30.160.60-FF-001839', NULL, 'Uncharacterized protein', 29, NULL, NULL, 89741),
(89742, '3.30.1360.120-FF-000108', NULL, 'Aminomethyltransferase', 51, NULL, NULL, 89742),
(89743, '3.30.50.10-FF-000052', NULL, 'Retinoid x receptor', 107, NULL, NULL, 89743),
(89744, '3.40.50.300-FF-008231', NULL, 'RNA cytidine acetyltransferase', 60, NULL, NULL, 89744),
(89745, '3.90.550.10-FF-000037', NULL, 'Beta-1,4-galactosyltransferase 6', 276, NULL, NULL, 89745),
(89746, '3.40.50.10420-FF-000018', NULL, 'Methenyltetrahydrofolate synthase domain-containing protein-like Protein', 194, NULL, NULL, 89746),
(89747, '3.40.50.1000-FF-000273', NULL, 'Hydrolase, haloacid dehalogenase-like family', 127, NULL, NULL, 89747),
(89748, '3.80.10.10-FF-003072', NULL, 'Uncharacterized protein', 133, NULL, NULL, 89748),
(89749, '1.10.10.350-FF-000035', NULL, NULL, 92, NULL, NULL, 89749),
(89750, '3.40.50.11980-FF-000008', NULL, 'Hypothetical_protein_-_conserved', 231, NULL, NULL, 89750),
(89751, '2.40.50.150-FF-000040', NULL, 'DNA-directed RNA polymerase subunit beta', 16, NULL, NULL, 89751),
(89752, '1.20.1250.20-FF-000955', NULL, 'MFS transporter', 190, NULL, NULL, 89752),
(89753, '2.160.20.70-FF-000019', NULL, 'Adenylyl cyclase-associated protein', 162, NULL, NULL, 89753),
(89754, '3.30.830.10-FF-000123', NULL, 'Peptidase, M16 family', 181, NULL, NULL, 89754),
(89755, '3.30.160.60-FF-004392', NULL, NULL, 34, NULL, NULL, 89755),
(89756, '2.90.10.10-FF-000010', NULL, 'Serine/threonine-protein kinase', 131, NULL, NULL, 89756),
(89757, '3.40.50.150-FF-000266', NULL, 'Alpha/beta fold hydrolase', 244, NULL, NULL, 89757),
(89758, '3.60.21.10-FF-000091', NULL, 'Sulfur oxidation protein SoxB', 292, NULL, NULL, 89758),
(89759, '1.10.12.10-FF-000037', NULL, '2-(1,2-epoxy-1,2-dihydrophenyl)acetyl-CoA isomerase', 58, NULL, NULL, 89759),
(89760, '3.40.50.300-FF-000093', NULL, 'Fidgetin-like 1', 188, NULL, NULL, 89760),
(89761, '3.50.40.10-FF-000005', NULL, 'Phenylalanine--tRNA ligase beta subunit', 197, NULL, NULL, 89761);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(89762, '1.10.555.10-FF-000079', NULL, 'YHR182W-like protein', 110, NULL, NULL, 89762),
(89763, '1.20.1070.10-FF-000528', NULL, 'SEcretin/class B GPCR', 292, NULL, NULL, 89763),
(89764, '3.80.10.10-FF-001334', NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g53420', 129, NULL, NULL, 89764),
(89765, '1.10.730.10-FF-000122', NULL, 'Leucine--tRNA ligase', 116, NULL, NULL, 89765),
(89766, '3.40.1380.10-FF-000017', NULL, 'ATP synthase subunit gamma, mitochondrial', 135, NULL, NULL, 89766),
(89767, '3.30.1330.30-FF-000118', NULL, 'Uncharacterized protein', 82, NULL, NULL, 89767),
(89768, '2.120.10.30-FF-000121', NULL, 'Protein CBR-TEN-1', 191, NULL, NULL, 89768),
(89769, '3.40.33.10-FF-000181', NULL, 'Uncharacterized protein (Fragment)', 78, NULL, NULL, 89769),
(89770, '3.30.160.60-FF-006044', NULL, NULL, 35, NULL, NULL, 89770),
(89771, '1.25.10.10-FF-000027', NULL, 'Importin subunit beta-1', 864, NULL, NULL, 89771),
(89772, '1.10.1200.270-FF-000034', NULL, 'Uncharacterized protein', 47, NULL, NULL, 89772),
(89773, '1.20.1110.10-FF-000263', NULL, NULL, 55, NULL, NULL, 89773),
(89774, '3.40.50.410-FF-000187', NULL, 'ATP-dependent DNA helicase II subunit 2', 251, NULL, NULL, 89774),
(89775, '3.40.50.10810-FF-000045', NULL, 'Putative chromatin-remodeling complex ATPase chain', 221, NULL, NULL, 89775),
(89776, '3.30.230.130-FF-000073', NULL, 'Cullin, putative', 186, NULL, NULL, 89776),
(89777, '3.40.50.1820-FF-000659', NULL, 'Carboxypeptidase', 412, NULL, NULL, 89777),
(89778, '1.10.1320.10-FF-000022', NULL, 'Predicted protein', 207, NULL, NULL, 89778),
(89779, '2.60.40.10-FF-005459', NULL, NULL, 105, NULL, NULL, 89779),
(89780, '3.40.50.10190-FF-000258', NULL, 'Uncharacterized protein', 96, NULL, NULL, 89780),
(89781, '3.30.420.40-FF-000090', NULL, 'Anhydro-N-acetylmuramic acid kinase', 183, NULL, NULL, 89781),
(89782, '2.130.10.10-FF-003200', NULL, 'Katanin p80 WD40 repeat-containing subunit B1', 97, NULL, NULL, 89782),
(89783, '1.25.40.10-FF-001283', NULL, 'Vegetative storage protein', 125, NULL, NULL, 89783),
(89784, '3.40.50.300-FF-002245', NULL, 'ATP-dependent RNA helicase MAK5', 259, NULL, NULL, 89784),
(89785, '1.25.10.10-FF-002118', NULL, 'RING-type E3 ubiquitin transferase', 127, NULL, NULL, 89785),
(89786, '1.10.540.10-FF-000085', NULL, 'Acyl-CoA dehydrogenase (Acd-7)', 114, NULL, NULL, 89786),
(89787, '3.40.50.620-FF-000778', NULL, 'Uncharacterized protein', 96, NULL, NULL, 89787),
(89788, '2.60.120.10-FF-000268', NULL, 'Crp/Fnr family transcriptional regulator', 149, NULL, NULL, 89788),
(89789, '1.10.3730.20-FF-000045', NULL, 'DMT family transporter', 106, NULL, NULL, 89789),
(89790, '3.10.50.40-FF-000051', NULL, 'Peptidylprolyl isomerase', 126, NULL, NULL, 89790),
(89791, '1.20.1070.10-FF-001843', NULL, 'Uncharacterized protein', 301, NULL, NULL, 89791),
(89792, '1.20.58.670-FF-000023', NULL, NULL, 128, NULL, NULL, 89792),
(89793, '3.90.1600.10-FF-000001', NULL, 'DNA polymerase', 178, NULL, NULL, 89793),
(89794, '2.60.120.260-FF-000070', NULL, 'Nuclear receptor 2C2-associated protein', 133, NULL, NULL, 89794),
(89795, '3.40.50.720-FF-001825', NULL, 'Prephenate dehydrogenase', 156, NULL, NULL, 89795),
(89796, '1.10.510.10-FF-000583', NULL, 'Inactive leucine-rich repeat receptor-like protein kinase CORYNE', 197, NULL, NULL, 89796),
(89797, '3.30.530.20-FF-000114', NULL, 'Uncharacterized protein', 81, NULL, NULL, 89797),
(89798, '3.40.1180.10-FF-000036', NULL, 'Alkyl transferase', 157, NULL, NULL, 89798),
(89799, '3.40.50.300-FF-000154', NULL, 'Vesicle-fusing ATPase 1', 189, NULL, NULL, 89799),
(89800, '1.25.10.10-FF-001781', NULL, 'Nuclear import and export protein Msn5, putative', 648, NULL, NULL, 89800),
(89801, '3.10.250.10-FF-000139', NULL, NULL, 62, NULL, NULL, 89801),
(89802, '2.30.29.30-FF-001371', NULL, 'Predicted protein', 125, NULL, NULL, 89802),
(89803, '1.20.1050.20-FF-000002', NULL, 'Signal transducer and activator of transcription', 204, NULL, NULL, 89803),
(89804, '3.40.50.300-FF-008377', NULL, 'Uncharacterized protein', 93, NULL, NULL, 89804),
(89805, '1.10.720.30-FF-000043', NULL, 'Scaffold attachment factor B1', 52, NULL, NULL, 89805);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(89806, '2.130.10.10-FF-005437', NULL, 'Uncharacterized protein', 338, NULL, NULL, 89806),
(89807, '1.10.287.70-FF-000581', NULL, 'Predicted protein', 202, NULL, NULL, 89807),
(89808, '1.10.10.10-FF-000673', NULL, 'DtxR family transcriptional regulator', 72, NULL, NULL, 89808),
(89809, '3.40.50.300-FF-004515', NULL, 'DNA helicase', 212, NULL, NULL, 89809),
(89810, '3.30.450.40-FF-000119', NULL, 'Two-component sensor KdpD', 144, NULL, NULL, 89810),
(89811, '2.60.40.10-FF-000581', NULL, 'sodium channel subunit beta-1', 132, NULL, NULL, 89811),
(89812, '1.20.1250.20-FF-001265', NULL, 'Major facilitator superfamily domain-containing protein', 371, NULL, NULL, 89812),
(89813, '3.40.50.1010-FF-000276', NULL, NULL, 97, NULL, NULL, 89813),
(89814, '3.90.1420.10-FF-000049', NULL, 'Histone-lysine N-methyltransferase setd3-like', 118, NULL, NULL, 89814),
(89815, '2.20.25.630-FF-000005', NULL, 'Poly [ADP-ribose] polymerase 1', 58, NULL, NULL, 89815),
(89816, '3.40.50.11960-FF-000002', NULL, 'Increased recombination centers protein 6', 184, NULL, NULL, 89816),
(89817, '3.30.160.60-FF-002828', NULL, 'Hamlet, isoform B', 86, NULL, NULL, 89817),
(89818, '1.10.3710.10-FF-000007', NULL, 'Replication factor C small subunit', 96, NULL, NULL, 89818),
(89819, '1.20.1070.10-FF-001164', NULL, 'G-protein coupled receptor GRL101-like protein', 341, NULL, NULL, 89819),
(89820, '3.40.50.300-FF-006606', NULL, 'Uncharacterized protein', 96, NULL, NULL, 89820),
(89821, '3.40.50.1110-FF-000008', NULL, 'Sialate O-acetylesterase', 276, NULL, NULL, 89821),
(89822, '3.40.50.150-FF-001368', NULL, NULL, 180, NULL, NULL, 89822),
(89823, '3.10.100.10-FF-000370', NULL, NULL, 142, NULL, NULL, 89823),
(89824, '3.40.47.10-FF-000004', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 3', 320, NULL, NULL, 89824),
(89825, '2.10.70.10-FF-000197', NULL, 'Mannose-binding lectin associated serine protease-3', 62, NULL, NULL, 89825),
(89826, '2.60.40.10-FF-004150', NULL, NULL, 115, NULL, NULL, 89826),
(89827, '1.10.287.70-FF-000788', NULL, 'Uncharacterized protein', 203, NULL, NULL, 89827),
(89828, '2.60.40.10-FF-003868', NULL, NULL, 112, NULL, NULL, 89828),
(89829, '2.120.10.30-FF-000093', NULL, 'Calcium homeostasis protein Regucalcin, putative', 291, NULL, NULL, 89829),
(89830, '1.10.20.10-FF-000112', NULL, 'Transcription initiation factor TFIID subunit 12', 74, NULL, NULL, 89830),
(89831, '3.50.70.10-FF-000007', NULL, 'Chalcone-flavonone isomerase family protein', 153, NULL, NULL, 89831),
(89832, '1.10.472.10-FF-000072', NULL, 'Cyclin Pch1', 150, NULL, NULL, 89832),
(89833, '3.90.1260.10-FF-000014', NULL, 'Uncharacterized protein', 45, NULL, NULL, 89833),
(89834, '1.10.540.10-FF-000146', NULL, 'Acyl-coenzyme A oxidase', 83, NULL, NULL, 89834),
(89835, '3.40.50.1000-FF-000301', NULL, 'Potassium-transporting ATPase alpha chain 1', 68, NULL, NULL, 89835),
(89836, '1.10.287.70-FF-000608', NULL, 'Potassium channel subfamily K member', 271, NULL, NULL, 89836),
(89837, '3.30.497.10-FF-000061', NULL, 'Serpin 2', 207, NULL, NULL, 89837),
(89838, '1.25.10.10-FF-000527', NULL, 'AP complex subunit beta', 584, NULL, NULL, 89838),
(89839, '2.60.40.10-FF-001744', NULL, 'filamin-A isoform X8', 99, NULL, NULL, 89839),
(89840, '3.40.50.10190-FF-000319', NULL, 'Nibrin', 91, NULL, NULL, 89840),
(89841, '3.30.70.100-FF-000185', NULL, NULL, 126, NULL, NULL, 89841),
(89842, '1.10.510.10-FF-001746', NULL, 'Protein kinase', 101, NULL, NULL, 89842),
(89843, '1.20.58.390-FF-000181', NULL, 'Predicted protein', 104, NULL, NULL, 89843),
(89844, '3.30.565.10-FF-000135', NULL, 'Two-component sensor histidine kinase', 150, NULL, NULL, 89844),
(89845, '1.10.510.10-FF-004152', NULL, NULL, 242, NULL, NULL, 89845),
(89846, '3.30.505.10-FF-000126', NULL, 'Signal transducer and activator of transcription', 108, NULL, NULL, 89846),
(89847, '3.40.225.10-FF-000006', NULL, 'Rhamnulose-1-phosphate aldolase', 274, NULL, NULL, 89847),
(89848, '1.25.40.10-FF-000029', NULL, 'peptidyl-prolyl cis-trans isomerase D', 152, NULL, NULL, 89848),
(89849, '3.30.70.330-FF-000315', NULL, 'RNA-binding motif protein 28', 84, NULL, NULL, 89849);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(89850, '3.30.1680.10-FF-000014', NULL, 'Integrin beta', 58, NULL, NULL, 89850),
(89851, '3.30.160.60-FF-004453', NULL, NULL, 28, NULL, NULL, 89851),
(89852, '3.40.630.20-FF-000007', NULL, 'Protein CBG22077', 197, NULL, NULL, 89852),
(89853, '2.60.40.1770-FF-000005', NULL, 'Eph receptor tyrosine kinase', 56, NULL, NULL, 89853),
(89854, '1.20.1420.30-FF-000112', NULL, 'Uncharacterized protein', 95, NULL, NULL, 89854),
(89855, '3.30.40.10-FF-001861', NULL, 'RING-box protein 1A-like Protein', 79, NULL, NULL, 89855),
(89856, '3.90.550.10-FF-000363', NULL, 'Meiotically up-regulated gene 136 protein', 253, NULL, NULL, 89856),
(89857, '1.25.10.10-FF-002270', NULL, 'Uncharacterized protein', 341, NULL, NULL, 89857),
(89858, '2.30.30.170-FF-000004', NULL, 'Mannosyl-glycoprotein endo-beta-N-acetylglucosamidase', 81, NULL, NULL, 89858),
(89859, '3.30.70.330-FF-002114', NULL, NULL, 113, NULL, NULL, 89859),
(89860, '2.60.40.1760-FF-000002', NULL, 'neutral alpha-glucosidase AB isoform X1', 176, NULL, NULL, 89860),
(89861, '1.50.40.10-FF-000555', NULL, 'Uncharacterized protein', 129, NULL, NULL, 89861),
(89862, '2.60.40.10-FF-000642', NULL, 'Bent, isoform F', 102, NULL, NULL, 89862),
(89863, '2.30.30.40-FF-000163', NULL, 'crk-like protein isoform X1', 67, NULL, NULL, 89863),
(89864, '3.30.830.10-FF-000302', NULL, 'Uncharacterized protein', 194, NULL, NULL, 89864),
(89865, '3.40.50.300-FF-003998', NULL, 'AGL142Cp', 240, NULL, NULL, 89865),
(89866, '1.10.3720.10-FF-000070', NULL, 'Inner membrane ABC transporter permease YdcU', 277, NULL, NULL, 89866),
(89867, '3.40.630.10-FF-000004', NULL, 'Probable cytosol aminopeptidase', 318, NULL, NULL, 89867),
(89868, '2.30.30.180-FF-000007', NULL, 'Ribosome maturation factor RimP', 60, NULL, NULL, 89868),
(89869, '2.30.30.570-FF-000001', NULL, 'major vault protein-like', 63, NULL, NULL, 89869),
(89870, '2.40.30.10-FF-000007', NULL, 'Translation initiation factor IF-2', 120, NULL, NULL, 89870),
(89871, '3.10.280.10-FF-000028', NULL, 'p22 protein', 182, NULL, NULL, 89871),
(89872, '1.20.120.1760-FF-000082', NULL, NULL, 159, NULL, NULL, 89872),
(89873, '2.10.50.10-FF-000134', NULL, 'Tumor necrosis factor receptor superfamily, member 11b', 42, NULL, NULL, 89873),
(89874, '3.30.460.10-FF-000049', NULL, 'RELA/SPOT homolog 1', 155, NULL, NULL, 89874),
(89875, '2.60.120.1190-FF-000005', NULL, 'Epithelial discoidin domain-containing receptor', 183, NULL, NULL, 89875),
(89876, '3.90.70.10-FF-000034', NULL, 'ubiquitin carboxyl-terminal hydrolase 15 isoform X1', 297, NULL, NULL, 89876),
(89877, '1.10.510.10-FF-000611', NULL, 'CMGC family protein kinase', 207, NULL, NULL, 89877),
(89878, '3.40.50.150-FF-000766', NULL, 'tRNA methyltransferase 9B', 109, NULL, NULL, 89878),
(89879, '3.30.450.40-FF-000271', NULL, 'Histidine kinase', 169, NULL, NULL, 89879),
(89880, '3.80.10.10-FF-000845', NULL, 'Disease resistance protein (TIR-NBS-LRR class)', 147, NULL, NULL, 89880),
(89881, '3.20.20.300-FF-000006', NULL, 'Beta-glucosidase H', 330, NULL, NULL, 89881),
(89882, '3.30.200.20-FF-001495', NULL, 'Predicted protein', 111, NULL, NULL, 89882),
(89883, '3.40.630.30-FF-000336', NULL, 'GNAT family N-acetyltransferase', 159, NULL, NULL, 89883),
(89884, '1.10.510.10-FF-002409', NULL, NULL, 184, NULL, NULL, 89884),
(89885, '3.40.630.30-FF-000628', NULL, 'N-hydroxyputrescine-succinyl CoA transferase PubB', 182, NULL, NULL, 89885),
(89886, '3.40.50.300-FF-008170', NULL, 'Uncharacterized protein', 85, NULL, NULL, 89886),
(89887, '3.40.30.10-FF-000348', NULL, 'Thioredoxin', 119, NULL, NULL, 89887),
(89888, '2.130.10.10-FF-004274', NULL, 'Uncharacterized protein', 130, NULL, NULL, 89888),
(89889, '3.40.50.150-FF-001868', NULL, NULL, 150, NULL, NULL, 89889),
(89890, '3.30.160.60-FF-005847', NULL, NULL, 22, NULL, NULL, 89890),
(89891, '1.10.3210.10-FF-000014', NULL, 'HD domain-containing protein', 264, NULL, NULL, 89891),
(89892, '3.30.710.10-FF-000468', NULL, 'Uncharacterized protein', 111, NULL, NULL, 89892),
(89893, '4.10.400.10-FF-000136', NULL, 'low-density lipoprotein receptor isoform X5', 39, NULL, NULL, 89893);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(89894, '3.30.420.10-FF-000721', NULL, NULL, 77, NULL, NULL, 89894),
(89895, '2.30.29.30-FF-001219', NULL, 'Uncharacterized protein', 99, NULL, NULL, 89895),
(89896, '4.10.860.120-FF-000024', NULL, 'DNA-directed RNA polymerase subunit', 128, NULL, NULL, 89896),
(89897, '2.40.20.10-FF-000035', NULL, 'SI:dZ46M7.2 (Novel kinase)', 95, NULL, NULL, 89897),
(89898, '3.80.10.10-FF-001155', NULL, 'F-box domain containing protein, expressed', 284, NULL, NULL, 89898),
(89899, '1.20.5.440-FF-000005', NULL, 'ATP synthase epsilon chain', 43, NULL, NULL, 89899),
(89900, '1.20.1250.20-FF-001591', NULL, 'MFS transporter, putative', 299, NULL, NULL, 89900),
(89901, '3.90.70.10-FF-000326', NULL, 'Ubiquitin carboxyl-terminal hydrolase 25', 379, NULL, NULL, 89901),
(89902, '1.25.50.20-FF-000095', NULL, 'Uncharacterized protein', 233, NULL, NULL, 89902),
(89903, '1.10.1900.10-FF-000016', NULL, 'DEAD-box ATP-dependent RNA helicase 39', 59, NULL, NULL, 89903),
(89904, '1.25.10.10-FF-002091', NULL, 'Uncharacterized protein', 304, NULL, NULL, 89904),
(89905, '2.60.40.10-FF-000255', NULL, 'receptor-type tyrosine-protein phosphatase gamma isoform X2', 109, NULL, NULL, 89905),
(89906, '2.60.120.40-FF-000018', NULL, 'Tumor necrosis factor ligand superfamily member 15', 166, NULL, NULL, 89906),
(89907, '2.60.40.1180-FF-000008', NULL, 'Alpha-galactosidase', 89, NULL, NULL, 89907),
(89908, '2.70.130.10-FF-000008', NULL, 'Cation-dependent mannose-6-phosphate receptor', 153, NULL, NULL, 89908),
(89909, '3.90.1200.10-FF-000038', NULL, 'Spore coat protein, CotS family', 240, NULL, NULL, 89909),
(89910, '3.40.50.300-FF-005617', NULL, 'Uncharacterized protein', 229, NULL, NULL, 89910),
(89911, '3.10.20.90-FF-000305', NULL, 'Uncharacterized protein, isoform A', 109, NULL, NULL, 89911),
(89912, '3.40.630.10-FF-000330', NULL, 'Uncharacterized protein', 283, NULL, NULL, 89912),
(89913, '1.20.5.430-FF-000002', NULL, 'Heat shock factor-binding protein 1', 48, NULL, NULL, 89913),
(89914, '2.10.160.10-FF-000001', NULL, 'Vascular endothelial growth factor A', 54, NULL, NULL, 89914),
(89915, '1.50.40.10-FF-000263', NULL, 'Carrier protein MRS3/4, putative', 116, NULL, NULL, 89915),
(89916, '3.40.50.1100-FF-000270', NULL, 'Threonine synthase', 228, NULL, NULL, 89916),
(89917, '3.40.50.300-FF-000480', NULL, 'DExH-box ATP-dependent RNA helicase DExH3', 157, NULL, NULL, 89917),
(89918, '2.130.10.10-FF-005937', NULL, 'Protein CBR-OSM-1', 261, NULL, NULL, 89918),
(89919, '2.60.40.10-FF-002407', NULL, 'Interleukin 22 receptor subunit alpha 2', 64, NULL, NULL, 89919),
(89920, '2.60.40.60-FF-000163', NULL, 'Cadherin 17', 98, NULL, NULL, 89920),
(89921, '3.30.830.10-FF-000095', NULL, 'Uncharacterized protein, isoform D', 253, NULL, NULL, 89921),
(89922, '2.130.10.10-FF-001868', NULL, 'WD domain, G-beta repeat-containing protein', 272, NULL, NULL, 89922),
(89923, '3.40.50.720-FF-001179', NULL, 'Saccharopine dehydrogenase (putative)', 116, NULL, NULL, 89923),
(89924, '2.130.10.10-FF-004509', NULL, 'Histone transcription regulator slm9', 237, NULL, NULL, 89924),
(89925, '1.20.140.150-FF-000045', NULL, 'Clarin 1', 143, NULL, NULL, 89925),
(89926, '1.10.10.1290-FF-000002', NULL, 'Testis intracellular mediator protein', 32, NULL, NULL, 89926),
(89927, '3.10.110.10-FF-000016', NULL, 'Ubiquitin-conjugating enzyme E2 H', 155, NULL, NULL, 89927),
(89928, '3.60.40.10-FF-000157', NULL, 'Stage II sporulation protein E', 244, NULL, NULL, 89928),
(89929, '2.60.40.1170-FF-000005', NULL, 'SH3-containing GRB2-like protein 3-interacting protein 1 isoform X3', 107, NULL, NULL, 89929),
(89930, '3.10.580.10-FF-000158', NULL, 'Magnesium and cobalt efflux protein', 151, NULL, NULL, 89930),
(89931, '2.170.270.10-FF-000157', NULL, 'Protein CBG24432', 143, NULL, NULL, 89931),
(89932, '4.10.90.10-FF-000002', NULL, 'Genome polyprotein', 72, NULL, NULL, 89932),
(89933, '1.20.1740.10-FF-000147', NULL, 'Uncharacterized protein', 319, NULL, NULL, 89933),
(89934, '3.40.50.280-FF-000013', NULL, 'Radical SAM domain protein', 128, NULL, NULL, 89934),
(89935, '3.30.420.40-FF-000443', NULL, 'Polyphosphate glucokinase', 113, NULL, NULL, 89935);
INSERT INTO "PUBLIC"."MODEL" VALUES
(89936, '3.40.50.2300-FF-001545', NULL, NULL, 40, NULL, NULL, 89936),
(89937, '3.40.1190.10-FF-000008', NULL, 'Folylpolyglutamate synthase', 277, NULL, NULL, 89937),
(89938, '3.30.160.60-FF-004127', NULL, NULL, 25, NULL, NULL, 89938),
(89939, '1.25.40.10-FF-004216', NULL, 'Uncharacterized protein', 53, NULL, NULL, 89939),
(89940, '3.30.40.10-FF-001243', NULL, 'Regulator Ustilago maydis 1 protein', 89, NULL, NULL, 89940),
(89941, '3.10.360.10-FF-000001', NULL, 'Beta-defensin 1', 41, NULL, NULL, 89941),
(89942, '3.40.50.1820-FF-001648', NULL, 'Uncharacterized protein', 381, NULL, NULL, 89942),
(89943, '3.40.50.300-FF-008405', NULL, 'Si:ch211-229i14.2', 167, NULL, NULL, 89943),
(89944, '3.40.1370.10-FF-000045', NULL, 'Uncharacterized protein', 93, NULL, NULL, 89944),
(89945, '1.10.520.10-FF-000055', NULL, 'Uncharacterized protein', 118, NULL, NULL, 89945),
(89946, '1.10.10.60-FF-000901', NULL, NULL, 52, NULL, NULL, 89946),
(89947, '3.40.50.300-FF-005943', NULL, 'Uncharacterized protein', 175, NULL, NULL, 89947),
(89948, '3.30.60.20-FF-000027', NULL, 'Diacylglycerol kinase', 61, NULL, NULL, 89948),
(89949, '3.30.720.120-FF-000001', NULL, 'Phenazine antibiotic resistance protein EhpR', 62, NULL, NULL, 89949),
(89950, '2.10.220.10-FF-000057', NULL, 'Proprotein convertase subtilisin/kexin type 5', 64, NULL, NULL, 89950),
(89951, '3.40.1110.10-FF-000234', NULL, 'Putative copper-transporting ATPase-like protein', 127, NULL, NULL, 89951),
(89952, '2.60.40.10-FF-004178', NULL, NULL, 86, NULL, NULL, 89952),
(89953, '1.10.10.440-FF-000062', NULL, 'WW domain-containing protein ZK1098.1', 55, NULL, NULL, 89953),
(89954, '3.30.70.260-FF-000154', NULL, 'GTP pyrophosphokinase', 78, NULL, NULL, 89954),
(89955, '3.40.980.10-FF-000053', NULL, 'Molybdopterin molybdenumtransferase', 83, NULL, NULL, 89955),
(89956, '2.130.10.10-FF-002065', NULL, 'Related to CAC2-component of the chromatin assembly complex', 137, NULL, NULL, 89956),
(89957, '2.40.50.140-FF-000975', NULL, NULL, 177, NULL, NULL, 89957),
(89958, '1.20.1270.280-FF-000064', NULL, 'Uncharacterized protein', 146, NULL, NULL, 89958),
(89959, '2.70.40.10-FF-000001', NULL, 'dCTP deaminase', 160, NULL, NULL, 89959),
(89960, '2.40.100.10-FF-000075', NULL, 'Peptidyl-prolyl cis-trans isomerase', 179, NULL, NULL, 89960),
(89961, '1.10.630.10-FF-000558', NULL, 'Cytochrome P450, putative', 332, NULL, NULL, 89961),
(89962, '3.30.565.10-FF-000461', NULL, 'Sensor histidine kinase, copper metabolism, putative', 161, NULL, NULL, 89962),
(89963, '1.10.580.10-FF-000031', NULL, 'Citrate synthase', 228, NULL, NULL, 89963),
(89964, '3.40.50.1820-FF-001441', NULL, 'Predicted protein', 189, NULL, NULL, 89964),
(89965, '3.30.1330.60-FF-000020', NULL, 'Outer membrane protein OmpA', 126, NULL, NULL, 89965),
(89966, '3.30.2350.20-FF-000032', NULL, 'tRNA pseudouridine synthase D', 223, NULL, NULL, 89966),
(89967, '3.30.160.60-FF-000384', NULL, 'Zinc finger protein 550', 30, NULL, NULL, 89967),
(89968, '3.40.50.300-FF-000328', NULL, 'Septin spn3', 293, NULL, NULL, 89968),
(89969, '3.65.10.20-FF-000007', NULL, 'RNA 3''-terminal phosphate cyclase-like protein,putative', 108, NULL, NULL, 89969),
(89970, '3.30.160.60-FF-000204', NULL, 'Zinc finger protein 331', 28, NULL, NULL, 89970),
(89971, '1.10.510.10-FF-000257', NULL, 'Calcium/calmodulin-dependent protein kinase type I', 227, NULL, NULL, 89971),
(89972, '3.30.230.70-FF-000123', NULL, 'Uncharacterized protein', 226, NULL, NULL, 89972),
(89973, '1.20.1600.10-FF-000019', NULL, 'Outer membrane protein', 408, NULL, NULL, 89973),
(89974, '2.70.150.10-FF-000217', NULL, 'Calcium-transporting ATPase', 141, NULL, NULL, 89974),
(89975, '1.25.40.820-FF-000020', NULL, 'Chromosome 7, whole genome shotgun sequence', 196, NULL, NULL, 89975),
(89976, '1.25.40.20-FF-000476', NULL, 'Uncharacterized protein', 99, NULL, NULL, 89976),
(89977, '3.65.10.10-FF-000004', NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', 205, NULL, NULL, 89977),
(89978, '3.30.160.60-FF-003638', NULL, 'Transcriptional regulator TAC1', 72, NULL, NULL, 89978),
(89979, '2.40.50.740-FF-000003', NULL, '30S ribosomal protein S4e', 52, NULL, NULL, 89979);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(89980, '1.10.1450.10-FF-000060', NULL, 'Protein late bloomer', 72, NULL, NULL, 89980),
(89981, '1.10.10.1890-FF-000002', NULL, 'Spindle and kinetochore-associated protein 1', 119, NULL, NULL, 89981),
(89982, '3.40.50.10190-FF-000084', NULL, 'DNA ligase', 130, NULL, NULL, 89982),
(89983, '3.30.160.60-FF-002536', NULL, 'zinc finger protein weckle-like', 25, NULL, NULL, 89983),
(89984, '1.10.8.60-FF-000535', NULL, 'Peroxisome biosynthesis protein', 101, NULL, NULL, 89984),
(89985, '3.40.50.300-FF-002537', NULL, 'Exonuclease SbcC', 305, NULL, NULL, 89985),
(89986, '3.20.20.190-FF-000018', NULL, 'Phosphoinositide phospholipase C', 171, NULL, NULL, 89986),
(89987, '1.25.40.790-FF-000022', NULL, 'Uncharacterized protein', 182, NULL, NULL, 89987),
(89988, '3.40.50.2300-FF-000410', NULL, 'Sensor histidine kinase/response regulator Fos-1', 121, NULL, NULL, 89988),
(89989, '1.25.40.10-FF-001575', NULL, 'Pentatricopeptide repeat-containing protein At3g51320', 125, NULL, NULL, 89989),
(89990, '3.10.440.10-FF-000002', NULL, '60S ribosomal protein L31, putative', 118, NULL, NULL, 89990),
(89991, '1.20.120.350-FF-000152', NULL, NULL, 111, NULL, NULL, 89991),
(89992, '3.60.10.10-FF-000329', NULL, 'Exodeoxyribonuclease III', 247, NULL, NULL, 89992),
(89993, '3.30.1460.50-FF-000021', NULL, 'Ubiquitin-like-conjugating enzyme ATG10', 162, NULL, NULL, 89993),
(89994, '3.90.1150.10-FF-000511', NULL, 'Selenocysteine lyase', 61, NULL, NULL, 89994),
(89995, '3.80.10.10-FF-004499', NULL, 'Os06g0557700 protein', 289, NULL, NULL, 89995),
(89996, '3.40.1090.10-FF-000124', NULL, 'Uncharacterized protein', 189, NULL, NULL, 89996),
(89997, '3.30.1540.20-FF-000041', NULL, NULL, 38, NULL, NULL, 89997),
(89998, '6.10.140.2220-FF-000069', NULL, 'Uncharacterized protein', 46, NULL, NULL, 89998),
(89999, '3.30.540.10-FF-000022', NULL, 'Putative PAP-specific phosphatase, mitochondrial', 207, NULL, NULL, 89999),
(90000, '3.90.226.10-FF-000183', NULL, 'Enoyl-CoA hydratase', 178, NULL, NULL, 90000),
(90001, '3.80.10.10-FF-000519', NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3', 156, NULL, NULL, 90001),
(90002, '3.40.1620.80-FF-000001', NULL, 'Big defensin', 39, NULL, NULL, 90002),
(90003, '3.40.50.300-FF-001789', NULL, 'TFIIH basal transcription factor complex helicase XPD subunit', 34, NULL, NULL, 90003),
(90004, '2.130.10.10-FF-000912', NULL, 'Ribosome biogenesis protein BOP1 homolog', 360, NULL, NULL, 90004),
(90005, '1.25.40.10-FF-003727', NULL, 'Uncharacterized protein', 164, NULL, NULL, 90005),
(90006, '1.20.1310.10-FF-000070', NULL, 'CBN-CUL-1 protein', 113, NULL, NULL, 90006),
(90007, '2.60.40.2130-FF-000012', NULL, 'F-spondin, putative', 115, NULL, NULL, 90007),
(90008, '3.90.1180.10-FF-000013', NULL, 'Mitochondrial ribosomal protein L13', 157, NULL, NULL, 90008),
(90009, '1.10.238.10-FF-000157', NULL, 'ATP/GTP-binding protein family', 69, NULL, NULL, 90009),
(90010, '1.20.1690.10-FF-000002', NULL, 'V-type proton ATPase subunit', 105, NULL, NULL, 90010),
(90011, '2.60.40.3690-FF-000002', NULL, 'Minor fimbrium subunit Mfa1', 124, NULL, NULL, 90011),
(90012, '3.90.740.10-FF-000046', NULL, 'Isoleucine--tRNA ligase', 188, NULL, NULL, 90012),
(90013, '3.40.50.300-FF-003791', NULL, 'Protein CBG19372', 171, NULL, NULL, 90013),
(90014, '3.40.50.300-FF-006432', NULL, 'Uncharacterized protein', 127, NULL, NULL, 90014),
(90015, '1.20.1250.20-FF-001411', NULL, 'Proline/betaine transporter', 184, NULL, NULL, 90015),
(90016, '3.20.20.80-FF-000779', NULL, 'Uncharacterized protein', 240, NULL, NULL, 90016),
(90017, '2.30.30.30-FF-000008', NULL, '50S ribosomal protein L2, chloroplastic', 79, NULL, NULL, 90017),
(90018, '3.30.260.10-FF-000101', NULL, NULL, 73, NULL, NULL, 90018),
(90019, '1.20.120.720-FF-000021', NULL, 'Unconventional myosin-Va', 27, NULL, NULL, 90019),
(90020, '1.10.287.3810-FF-000001', NULL, 'Tryptophan 2,3-dioxygenase', 51, NULL, NULL, 90020),
(90021, '3.80.10.10-FF-001008', NULL, 'F-box/LRR-repeat protein 5', 147, NULL, NULL, 90021),
(90022, '3.10.310.20-FF-000001', NULL, 'Probable manganese-dependent inorganic pyrophosphatase', 119, NULL, NULL, 90022);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(90023, '1.10.533.10-FF-000208', NULL, 'CARD- and ANK-containing Inflammasome Adaptor Protein', 93, NULL, NULL, 90023),
(90024, '3.10.310.30-FF-000004', NULL, 'Single-stranded-DNA-specific exonuclease', 116, NULL, NULL, 90024),
(90025, '2.40.70.10-FF-000100', NULL, 'Cathepsin E-like protease', 116, NULL, NULL, 90025),
(90026, '1.10.472.130-FF-000061', NULL, 'Predicted protein', 170, NULL, NULL, 90026),
(90027, '1.10.1070.11-FF-000138', NULL, 'Uncharacterized protein', 117, NULL, NULL, 90027),
(90028, '2.30.30.380-FF-000034', NULL, 'SHANK-associated RH domain interacting protein', 59, NULL, NULL, 90028),
(90029, '3.90.1410.10-FF-000138', NULL, 'Predicted protein', 242, NULL, NULL, 90029),
(90030, '3.60.21.10-FF-000118', NULL, 'Calcineurin-like phosphoesterase family protein', 191, NULL, NULL, 90030),
(90031, '3.30.70.330-FF-001804', NULL, NULL, 189, NULL, NULL, 90031),
(90032, '1.20.5.110-FF-000137', NULL, 'Qc-SNARE protein, putative', 65, NULL, NULL, 90032),
(90033, '3.40.50.720-FF-001590', NULL, 'Bifunctional sterol desaturase/short chaindehydrogenase', 215, NULL, NULL, 90033),
(90034, '1.20.120.730-FF-000024', NULL, 'Protein transport protein SEC23', 146, NULL, NULL, 90034),
(90035, '1.10.10.1340-FF-000006', NULL, 'Mediator of RNA polymerase II transcription subunit 31', 103, NULL, NULL, 90035),
(90036, '3.20.20.70-FF-000776', NULL, NULL, 94, NULL, NULL, 90036),
(90037, '3.30.160.60-FF-004745', NULL, NULL, 26, NULL, NULL, 90037),
(90038, '1.25.40.10-FF-002007', NULL, 'Os03g0314400 protein', 152, NULL, NULL, 90038),
(90039, '1.10.357.70-FF-000024', NULL, 'Predicted protein', 178, NULL, NULL, 90039),
(90040, '2.130.10.10-FF-002391', NULL, 'Striatin Pro11', 173, NULL, NULL, 90040),
(90041, '1.10.472.10-FF-000246', NULL, 'Mitotic cyclin 6', 105, NULL, NULL, 90041),
(90042, '3.30.70.330-FF-000141', NULL, 'Splicing factor 3b subunit 4', 89, NULL, NULL, 90042),
(90043, '2.60.40.10-FF-001862', NULL, 'C3 and PZP like, alpha-2-macroglobulin domain containing 8', 130, NULL, NULL, 90043),
(90044, '2.60.40.640-FF-000045', NULL, 'Vacuolar sorting protein 26, putative', 169, NULL, NULL, 90044),
(90045, '2.40.50.150-FF-000006', NULL, 'DNA-directed RNA polymerase subunit beta', 126, NULL, NULL, 90045),
(90046, '3.30.740.10-FF-000003', NULL, 'Dynein light chain', 97, NULL, NULL, 90046),
(90047, '2.60.40.1910-FF-000036', NULL, NULL, 92, NULL, NULL, 90047),
(90048, '1.25.40.20-FF-001201', NULL, 'CARD- and ANK-containing Inflammasome Adaptor Protein', 92, NULL, NULL, 90048),
(90049, '2.30.110.10-FF-000038', NULL, 'PPOX class F420-dependent oxidoreductase', 120, NULL, NULL, 90049),
(90050, '1.10.510.10-FF-004034', NULL, NULL, 98, NULL, NULL, 90050),
(90051, '1.10.3260.10-FF-000017', NULL, 'DNA ligase 4', 232, NULL, NULL, 90051),
(90052, '1.10.565.10-FF-000198', NULL, 'Androgen receptor a', 78, NULL, NULL, 90052),
(90053, '2.60.120.10-FF-000622', NULL, 'Uncharacterized protein', 65, NULL, NULL, 90053),
(90054, '3.40.50.970-FF-000006', NULL, 'Pyruvate dehydrogenase E1 component subunit beta', 193, NULL, NULL, 90054),
(90055, '3.40.449.10-FF-000015', NULL, 'Uncharacterized protein', 202, NULL, NULL, 90055),
(90056, '2.40.70.10-FF-000280', NULL, 'Aspartic peptidase domain-containing protein', 184, NULL, NULL, 90056),
(90057, '3.40.50.300-FF-006106', NULL, 'Uridine-cytidine kinase 1', 74, NULL, NULL, 90057),
(90058, '3.40.50.1820-FF-001148', NULL, 'Carboxypeptidase', 108, NULL, NULL, 90058),
(90059, '3.30.930.10-FF-000187', NULL, 'Lysine--tRNA ligase', 367, NULL, NULL, 90059),
(90060, '1.25.40.10-FF-004424', NULL, 'Uncharacterized protein', 127, NULL, NULL, 90060),
(90061, '2.170.16.10-FF-000042', NULL, 'Replicative DNA helicase', 136, NULL, NULL, 90061),
(90062, '1.20.1250.20-FF-001383', NULL, 'Major facilitator superfamily MFS_1', 192, NULL, NULL, 90062),
(90063, '3.30.420.40-FF-000117', NULL, 'Heat shock protein 70 kDa', 143, NULL, NULL, 90063),
(90064, '4.10.410.10-FF-000047', NULL, 'Protein CBG06419', 61, NULL, NULL, 90064),
(90065, '2.130.10.10-FF-001929', NULL, 'Protein GAMETE EXPRESSED 3', 305, NULL, NULL, 90065);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(90066, '3.40.50.960-FF-000003', NULL, '6,7-dimethyl-8-ribityllumazine synthase', 139, NULL, NULL, 90066),
(90067, '1.10.1450.10-FF-000026', NULL, 'Tetraspanin', 77, NULL, NULL, 90067),
(90068, '3.50.50.100-FF-000013', NULL, 'Type II NADH:ubiquinone oxidoreductase', 111, NULL, NULL, 90068),
(90069, '2.60.40.60-FF-000724', NULL, 'Uncharacterized protein', 98, NULL, NULL, 90069),
(90070, '1.10.287.110-FF-000183', NULL, 'Protein CBR-DNJ-24', 114, NULL, NULL, 90070),
(90071, '3.40.190.290-FF-000091', NULL, 'LysR family transcriptional regulator', 199, NULL, NULL, 90071),
(90072, '1.25.40.10-FF-003761', NULL, 'Uncharacterized protein', 164, NULL, NULL, 90072),
(90073, '2.60.40.10-FF-003953', NULL, NULL, 104, NULL, NULL, 90073),
(90074, '3.30.160.60-FF-004627', NULL, NULL, 27, NULL, NULL, 90074),
(90075, '1.10.510.10-FF-002382', NULL, NULL, 112, NULL, NULL, 90075),
(90076, '2.40.320.10-FF-000001', NULL, 'Mediator of RNA polymerase II transcription subunit 18', 187, NULL, NULL, 90076),
(90077, '3.90.70.80-FF-000066', NULL, 'Uncharacterized protein', 143, NULL, NULL, 90077),
(90078, '2.60.40.1080-FF-000012', NULL, 'S-layer protein A', 78, NULL, NULL, 90078),
(90079, '1.20.5.730-FF-000002', NULL, 'Rabaptin, RAB GTPase-binding effector protein 1', 61, NULL, NULL, 90079),
(90080, '4.10.400.10-FF-000018', NULL, 'Low-density lipoprotein receptor-related protein 1', 42, NULL, NULL, 90080),
(90081, '1.10.1200.10-FF-000160', NULL, 'Siderophore peptide synthetase fer3', 74, NULL, NULL, 90081),
(90082, '3.30.420.10-FF-000693', NULL, NULL, 123, NULL, NULL, 90082),
(90083, '1.10.287.130-FF-000189', NULL, 'Sensory box sensor histidine kinase/response regulator VieS', 67, NULL, NULL, 90083),
(90084, '2.40.30.10-FF-000272', NULL, 'Sulfite reductase [NADPH] flavoprotein alpha-component', 111, NULL, NULL, 90084),
(90085, '2.60.40.1180-FF-000160', NULL, 'Solute carrier family 3 member 2b', 86, NULL, NULL, 90085),
(90086, '3.30.70.330-FF-001243', NULL, 'Peptidyl-prolyl cis-trans isomerase', 141, NULL, NULL, 90086),
(90087, '4.10.320.10-FF-000017', NULL, 'Pyruvate dehydrogenase complex protein X component, mitochondrial', 48, NULL, NULL, 90087),
(90088, '2.30.29.110-FF-000007', NULL, 'Uncharacterized protein', 69, NULL, NULL, 90088),
(90089, '1.10.510.10-FF-000291', NULL, 'Brassinosteroid LRR receptor kinase', 202, NULL, NULL, 90089),
(90090, '3.30.565.10-FF-000253', NULL, 'Two-component sensor histidine kinase', 147, NULL, NULL, 90090),
(90091, '1.10.10.10-FF-001954', NULL, 'Uncharacterized protein', 79, NULL, NULL, 90091),
(90092, '3.80.10.10-FF-003133', NULL, 'leucine-rich repeat-containing protein 59-like', 71, NULL, NULL, 90092),
(90093, '2.40.30.10-FF-000215', NULL, 'NADPH--cytochrome P450 reductase', 90, NULL, NULL, 90093),
(90094, '1.10.510.10-FF-000403', NULL, 'serine/threonine-protein kinase PLK4 isoform X1', 182, NULL, NULL, 90094),
(90095, '2.30.30.40-FF-000371', NULL, 'Protein arginine methyltransferase 2', 82, NULL, NULL, 90095),
(90096, '2.60.40.150-FF-000724', NULL, 'Putative calpain-like cysteine protease A', 118, NULL, NULL, 90096),
(90097, '2.30.22.10-FF-000012', NULL, 'GrpE, adenine nucleotide exchange factor, putative', 55, NULL, NULL, 90097),
(90098, '3.30.160.60-FF-000412', NULL, 'zinc finger protein 64 isoform X1', 31, NULL, NULL, 90098),
(90099, '1.25.40.10-FF-000473', NULL, 'Os03g0185200 protein', 79, NULL, NULL, 90099),
(90100, '1.20.1250.20-FF-000394', NULL, 'MFS general substrate transporter', 188, NULL, NULL, 90100),
(90101, '2.20.25.10-FF-000075', NULL, 'DNA-directed RNA polymerase subunit', 64, NULL, NULL, 90101),
(90102, '3.30.160.60-FF-002328', NULL, 'Uncharacterized protein', 29, NULL, NULL, 90102),
(90103, '2.130.10.10-FF-001986', NULL, 'Protein CBG20127', 370, NULL, NULL, 90103),
(90104, '3.90.228.10-FF-000047', NULL, 'Poly [ADP-ribose] polymerase', 166, NULL, NULL, 90104),
(90105, '1.20.1110.10-FF-000116', NULL, 'Uncharacterized protein', 174, NULL, NULL, 90105),
(90106, '2.60.40.10-FF-002525', NULL, 'Uncharacterized protein', 105, NULL, NULL, 90106),
(90107, '3.90.79.10-FF-000115', NULL, 'NUDIX domain protein', 149, NULL, NULL, 90107); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(90108, '1.10.418.10-FF-000104', NULL, 'Filamin 2, putative', 117, NULL, NULL, 90108),
(90109, '2.30.29.30-FF-000674', NULL, 'Serine/threonine protein kinase 3/4, putative', 106, NULL, NULL, 90109),
(90110, '2.60.175.10-FF-000001', NULL, 'Major capsid protein VP1', 343, NULL, NULL, 90110),
(90111, '3.30.870.10-FF-000041', NULL, 'Envelope phospholipase F13', 147, NULL, NULL, 90111),
(90112, '1.20.1480.30-FF-000003', NULL, 'Uncharacterized protein', 85, NULL, NULL, 90112),
(90113, '3.40.50.1240-FF-000053', NULL, 'Histidine acid phosphatase, putative', 375, NULL, NULL, 90113),
(90114, '3.40.190.10-FF-000897', NULL, 'Glutamate receptor, putative', 46, NULL, NULL, 90114),
(90115, '1.20.1390.10-FF-000018', NULL, 'Uncharacterized protein', 70, NULL, NULL, 90115),
(90116, '3.40.50.150-FF-000148', NULL, 'Probable methyltransferase PMT25', 166, NULL, NULL, 90116),
(90117, '1.10.8.270-FF-000013', NULL, 'Small G protein signaling modulator 3', 107, NULL, NULL, 90117),
(90118, '2.10.70.10-FF-000017', NULL, 'Fibronectin isoform X1', 37, NULL, NULL, 90118),
(90119, '3.30.830.10-FF-000241', NULL, 'Uncharacterized protein', 217, NULL, NULL, 90119),
(90120, '3.90.70.10-FF-000152', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 387, NULL, NULL, 90120),
(90121, '3.40.50.300-FF-004780', NULL, 'DNA polymerase III subunit', 73, NULL, NULL, 90121),
(90122, '3.30.450.40-FF-000153', NULL, 'Transcriptional regulator', 165, NULL, NULL, 90122),
(90123, '1.25.40.10-FF-005318', NULL, 'Uncharacterized protein', 114, NULL, NULL, 90123),
(90124, '3.40.1810.10-FF-000063', NULL, NULL, 82, NULL, NULL, 90124),
(90125, '3.40.190.10-FF-000520', NULL, 'Uncharacterized protein', 62, NULL, NULL, 90125),
(90126, '2.30.29.30-FF-001337', NULL, 'Uncharacterized protein', 44, NULL, NULL, 90126),
(90127, '1.10.238.10-FF-000803', NULL, 'Defective in cullin neddylation protein 1', 115, NULL, NULL, 90127),
(90128, '3.40.30.10-FF-000466', NULL, 'Iodothyronine deiodinase', 55, NULL, NULL, 90128),
(90129, '2.40.50.140-FF-000003', NULL, '50S ribosomal protein L2', 114, NULL, NULL, 90129),
(90130, '1.10.10.2360-FF-000008', NULL, 'Uncharacterized protein', 41, NULL, NULL, 90130),
(90131, '2.60.120.290-FF-000197', NULL, 'Uncharacterized protein', 117, NULL, NULL, 90131),
(90132, '1.10.30.50-FF-000017', NULL, 'Putative SNF2/RAD54 related DNA helicase', 116, NULL, NULL, 90132),
(90133, '2.10.25.10-FF-001110', NULL, 'fibropellin-1-like isoform X1', 41, NULL, NULL, 90133),
(90134, '2.30.42.10-FF-000221', NULL, 'Tricorn protease homolog', 96, NULL, NULL, 90134),
(90135, '1.50.40.10-FF-000437', NULL, 'Uncharacterized protein', 167, NULL, NULL, 90135),
(90136, '1.20.58.80-FF-000067', NULL, 'Sorting nexin 15', 76, NULL, NULL, 90136),
(90137, '2.130.10.10-FF-002503', NULL, 'RE12436p1', 93, NULL, NULL, 90137),
(90138, '1.10.1420.10-FF-000086', NULL, 'DNA mismatch repair protein Msh4, putative', 125, NULL, NULL, 90138),
(90139, '3.30.40.10-FF-001209', NULL, 'DWNN domain, a CCHC-type zinc finger', 104, NULL, NULL, 90139),
(90140, '1.25.40.20-FF-000212', NULL, 'Protein phosphatase 1 regulatory subunit', 177, NULL, NULL, 90140),
(90141, '3.40.50.1820-FF-001356', NULL, 'Uncharacterized protein', 237, NULL, NULL, 90141),
(90142, '1.20.1070.10-FF-001017', NULL, 'Predicted protein', 126, NULL, NULL, 90142),
(90143, '3.30.379.10-FF-000011', NULL, 'Beta-hexosaminidase', 148, NULL, NULL, 90143),
(90144, '1.25.40.10-FF-002390', NULL, 'HCF152', 185, NULL, NULL, 90144),
(90145, '1.50.10.10-FF-000082', NULL, 'alpha-1,2-Mannosidase', 487, NULL, NULL, 90145),
(90146, '1.25.40.10-FF-001928', NULL, 'Os06g0231400 protein', 110, NULL, NULL, 90146),
(90147, '1.10.490.10-FF-000001', NULL, 'Hemoglobin subunit beta', 146, NULL, NULL, 90147),
(90148, '2.60.40.10-FF-005398', NULL, NULL, 46, NULL, NULL, 90148),
(90149, '2.40.50.1060-FF-000022', NULL, 'Uncharacterized protein', 69, NULL, NULL, 90149),
(90150, '3.30.160.60-FF-002121', NULL, 'zinc finger protein 8', 40, NULL, NULL, 90150),
(90151, '3.30.1360.200-FF-000014', NULL, 'Protein translocase subunit SecD', 108, NULL, NULL, 90151);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(90152, '3.30.70.3100-FF-000001', NULL, 'Homoserine dehydrogenase', 81, NULL, NULL, 90152),
(90153, '3.40.50.300-FF-007949', NULL, 'Rab family protein', 169, NULL, NULL, 90153),
(90154, '3.30.160.60-FF-004419', NULL, NULL, 25, NULL, NULL, 90154),
(90155, '3.40.850.10-FF-000487', NULL, 'Uncharacterized protein', 72, NULL, NULL, 90155),
(90156, '3.30.160.60-FF-000619', NULL, 'juxtaposed with another zinc finger protein 1', 28, NULL, NULL, 90156),
(90157, '3.40.50.300-FF-000980', NULL, 'Cysteine/glutathione ABC transporter permease/ATP-binding protein CydD', 247, NULL, NULL, 90157),
(90158, '2.60.40.10-FF-002172', NULL, 'Myomesin 1a (skelemin)', 103, NULL, NULL, 90158),
(90159, '3.40.630.150-FF-000009', NULL, 'Malonyl-CoA decarboxylase', 107, NULL, NULL, 90159),
(90160, '2.60.40.10-FF-000434', NULL, 'Sidekick cell adhesion molecule 2', 127, NULL, NULL, 90160),
(90161, '1.10.510.10-FF-003629', NULL, NULL, 192, NULL, NULL, 90161),
(90162, '2.60.40.150-FF-000078', NULL, 'Extended synaptotagmin 2', 136, NULL, NULL, 90162),
(90163, '3.40.50.10470-FF-000044', NULL, 'Methylthioribose-1-phosphate isomerase', 161, NULL, NULL, 90163),
(90164, '1.10.10.60-FF-000547', NULL, 'transcription factor AS1-like', 59, NULL, NULL, 90164),
(90165, '1.20.59.20-FF-000001', NULL, 'tRNA(Ile)-lysidine synthase', 86, NULL, NULL, 90165),
(90166, '3.90.550.10-FF-000155', NULL, 'Polysaccharide metabolism', 228, NULL, NULL, 90166),
(90167, '3.40.50.1010-FF-000158', NULL, NULL, 163, NULL, NULL, 90167),
(90168, '1.25.40.10-FF-004071', NULL, 'Pentatricopeptide repeat-containing protein At2g20710, mitochondrial', 159, NULL, NULL, 90168),
(90169, '3.40.50.880-FF-000013', NULL, 'GMP synthase [glutamine-hydrolyzing]', 194, NULL, NULL, 90169),
(90170, '1.10.510.10-FF-000083', NULL, 'Ephrin type-A receptor 3', 187, NULL, NULL, 90170),
(90171, '3.30.200.20-FF-001848', NULL, 'Os10g0562500 protein', 56, NULL, NULL, 90171),
(90172, '3.30.1370.210-FF-000019', NULL, 'Zinc finger CCCH-type containing 10', 51, NULL, NULL, 90172),
(90173, '1.10.10.10-FF-000055', NULL, 'ETS translocation variant 4 isoform 1', 110, NULL, NULL, 90173),
(90174, '3.40.630.30-FF-000662', NULL, 'Glucosamine 6-phosphate N-acetyltransferase', 152, NULL, NULL, 90174),
(90175, '3.10.20.90-FF-000423', NULL, 'Guanine nucleotide exchange factor', 98, NULL, NULL, 90175),
(90176, '3.90.700.10-FF-000015', NULL, '3-oxosteroid 1-dehydrogenase', 128, NULL, NULL, 90176),
(90177, '3.40.50.1000-FF-000155', NULL, 'Putative magnesium dependent phosphatase', 198, NULL, NULL, 90177),
(90178, '2.10.25.10-FF-001317', NULL, 'Matrilin 4', 36, NULL, NULL, 90178),
(90179, '1.20.140.40-FF-000061', NULL, NULL, 112, NULL, NULL, 90179),
(90180, '3.30.160.60-FF-005347', NULL, NULL, 66, NULL, NULL, 90180),
(90181, '3.40.630.30-FF-000454', NULL, 'N-acetyltransferase 6', 183, NULL, NULL, 90181),
(90182, '2.60.120.10-FF-000768', NULL, 'Uncharacterized protein', 55, NULL, NULL, 90182),
(90183, '2.40.50.1070-FF-000025', NULL, NULL, 128, NULL, NULL, 90183),
(90184, '3.90.1600.10-FF-000029', NULL, 'DNA polymerase', 93, NULL, NULL, 90184),
(90185, '3.40.50.10130-FF-000055', NULL, 'Uncharacterized protein', 135, NULL, NULL, 90185),
(90186, '3.50.14.10-FF-000001', NULL, 'DNA replication terminus site-binding protein', 208, NULL, NULL, 90186),
(90187, '3.30.1370.110-FF-000023', NULL, 'Endonuclease MutS2', 87, NULL, NULL, 90187),
(90188, '1.20.58.60-FF-000882', NULL, 'Kalirin RhoGEF kinase a', 93, NULL, NULL, 90188),
(90189, '3.40.30.10-FF-000056', NULL, 'Thiol peroxidase', 168, NULL, NULL, 90189),
(90190, '3.30.160.60-FF-000530', NULL, 'zinc finger protein 775', 29, NULL, NULL, 90190),
(90191, '3.10.105.10-FF-000066', NULL, 'ABC transporter substrate-binding protein', 226, NULL, NULL, 90191),
(90192, '2.80.10.50-FF-000084', NULL, 'Uncharacterized protein Mb1454', 75, NULL, NULL, 90192),
(90193, '3.40.50.300-FF-002363', NULL, 'Spliceosome RNA helicase DDX39B', 94, NULL, NULL, 90193),
(90194, '3.30.559.30-FF-000115', NULL, 'Uncharacterized protein', 204, NULL, NULL, 90194),
(90195, '3.40.50.300-FF-007860', NULL, 'Uncharacterized protein', 211, NULL, NULL, 90195);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(90196, '3.10.20.90-FF-000631', NULL, 'Predicted protein', 77, NULL, NULL, 90196),
(90197, '1.10.3430.10-FF-000025', NULL, 'Ammonium transporter, splicing variant', 425, NULL, NULL, 90197),
(90198, '1.10.4200.10-FF-000008', NULL, 'CITG protein', 126, NULL, NULL, 90198),
(90199, '3.20.20.80-FF-000487', NULL, 'Glucosylceramidase, putative', 310, NULL, NULL, 90199),
(90200, '3.40.50.1820-FF-000013', NULL, 'Carboxypeptidase', 260, NULL, NULL, 90200),
(90201, '4.10.1240.10-FF-000019', NULL, 'Gastric inhibitory polypeptide receptor', 94, NULL, NULL, 90201),
(90202, '3.40.50.200-FF-000124', NULL, 'Predicted protein', 216, NULL, NULL, 90202),
(90203, '1.10.10.540-FF-000002', NULL, 'UV excision repair protein Rad23', 66, NULL, NULL, 90203),
(90204, '1.20.930.40-FF-000008', NULL, 'Tre1p', 153, NULL, NULL, 90204),
(90205, '2.40.50.140-FF-001138', NULL, NULL, 75, NULL, NULL, 90205),
(90206, '1.10.10.10-FF-002000', NULL, 'Uncharacterized protein', 137, NULL, NULL, 90206),
(90207, '2.60.40.10-FF-003189', NULL, NULL, 86, NULL, NULL, 90207),
(90208, '3.90.70.10-FF-000360', NULL, 'Uncharacterized protein', 214, NULL, NULL, 90208),
(90209, '1.20.1250.20-FF-001326', NULL, 'Uncharacterized protein', 177, NULL, NULL, 90209),
(90210, '3.30.200.20-FF-000859', NULL, 'Serine/threonine protein kinase', 136, NULL, NULL, 90210),
(90211, '2.60.40.10-FF-002733', NULL, 'Natural cytotoxicity triggering receptor 3 ligand 1', 118, NULL, NULL, 90211),
(90212, '2.70.130.10-FF-000160', NULL, NULL, 112, NULL, NULL, 90212),
(90213, '3.30.40.10-FF-002024', NULL, 'Uncharacterized protein', 29, NULL, NULL, 90213),
(90214, '3.20.20.70-FF-000484', NULL, 'Homocitrate synthase', 271, NULL, NULL, 90214),
(90215, '3.40.50.300-FF-007742', NULL, 'RAB34, member RAS oncogene family', 80, NULL, NULL, 90215),
(90216, '2.60.120.200-FF-000597', NULL, 'Cadherin, EGF LAG seven-pass G-type receptor 2', 157, NULL, NULL, 90216),
(90217, '2.170.270.10-FF-000191', NULL, 'Uncharacterized protein', 182, NULL, NULL, 90217),
(90218, '3.40.30.10-FF-000674', NULL, 'Delta-like protein', 83, NULL, NULL, 90218),
(90219, '3.40.50.300-FF-005797', NULL, 'Katanin p60 ATPase-containing subunit A1', 61, NULL, NULL, 90219),
(90220, '2.40.160.120-FF-000029', NULL, 'Oxysterol binding protein 5, putative', 176, NULL, NULL, 90220),
(90221, '3.30.160.60-FF-003964', NULL, NULL, 25, NULL, NULL, 90221),
(90222, '3.30.70.1230-FF-000176', NULL, 'Adenylate/guanylate cyclase domain-containing protein', 182, NULL, NULL, 90222),
(90223, '1.20.120.350-FF-000067', NULL, 'Transmembrane phosphatase with tensin homology', 131, NULL, NULL, 90223),
(90224, '3.30.342.10-FF-000056', NULL, 'DNA polymerase', 75, NULL, NULL, 90224),
(90225, '4.10.280.10-FF-000047', NULL, 'mesoderm posterior protein 1', 68, NULL, NULL, 90225),
(90226, '3.50.50.60-FF-001460', NULL, 'Uncharacterized protein', 74, NULL, NULL, 90226),
(90227, '3.40.50.200-FF-000181', NULL, 'Subtilisin-like serine protease', 305, NULL, NULL, 90227),
(90228, '2.40.10.230-FF-000011', NULL, 'H/ACA ribonucleoprotein complex subunit', 93, NULL, NULL, 90228),
(90229, '2.40.10.10-FF-000271', NULL, 'AT07689p', 235, NULL, NULL, 90229),
(90230, '3.30.390.50-FF-000010', NULL, 'Lipoate--protein ligase', 88, NULL, NULL, 90230),
(90231, '3.40.50.740-FF-000022', NULL, 'Anaerobic dimethyl sulfoxide reductase subunit A', 199, NULL, NULL, 90231),
(90232, '3.40.50.720-FF-000628', NULL, 'Oxidoreductase family, NAD-binding Rossmann fold protein', 149, NULL, NULL, 90232),
(90233, '1.25.10.10-FF-000645', NULL, 'HEAT repeat protein', 278, NULL, NULL, 90233),
(90234, '3.30.40.10-FF-001097', NULL, 'RBR-type E3 ubiquitin transferase', 87, NULL, NULL, 90234),
(90235, '3.30.40.10-FF-001417', NULL, 'Predicted protein', 72, NULL, NULL, 90235),
(90236, '3.30.1370.100-FF-000020', NULL, 'DNA mismatch repair protein MutL', 85, NULL, NULL, 90236),
(90237, '3.40.50.620-FF-000896', NULL, 'Uncharacterized protein', 83, NULL, NULL, 90237),
(90238, '3.40.50.980-FF-000009', NULL, 'Blast:Luciferin 4-monooxygenase', 145, NULL, NULL, 90238),
(90239, '2.40.160.110-FF-000026', NULL, 'Uncharacterized protein', 170, NULL, NULL, 90239);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(90240, '1.50.40.10-FF-000229', NULL, 'Mitochondrial arginine transporter BAC1 isoform A', 294, NULL, NULL, 90240),
(90241, '4.10.1110.10-FF-000015', NULL, 'Zinc finger, AN1-type domain 6', 40, NULL, NULL, 90241),
(90242, '3.30.390.60-FF-000013', NULL, 'Heat-inducible transcription repressor HrcA', 108, NULL, NULL, 90242),
(90243, '3.90.1290.10-FF-000050', NULL, 'Uncharacterized protein', 147, NULL, NULL, 90243),
(90244, '1.20.58.830-FF-000032', NULL, 'Erythrocyte membrane protein 1', 129, NULL, NULL, 90244),
(90245, '2.60.40.1820-FF-000009', NULL, 'Late embryogenesis abundant (LEA) hydroxyproline-rich glycoprotein family', 161, NULL, NULL, 90245),
(90246, '1.20.1300.10-FF-000041', NULL, 'Succinate dehydrogenase subunit D', 86, NULL, NULL, 90246),
(90247, '2.60.40.10-FF-000934', NULL, 'vascular endothelial growth factor receptor 1', 92, NULL, NULL, 90247),
(90248, '1.25.10.10-FF-000235', NULL, 'MAP3K epsilon protein kinase 1', 147, NULL, NULL, 90248),
(90249, '1.10.10.440-FF-000028', NULL, 'Pre-mRNA-processing protein 40C', 66, NULL, NULL, 90249),
(90250, '3.30.60.30-FF-000238', NULL, 'Uncharacterized protein', 48, NULL, NULL, 90250),
(90251, '1.10.20.10-FF-000292', NULL, NULL, 68, NULL, NULL, 90251),
(90252, '4.10.60.10-FF-000113', NULL, 'Cleavage and Polyadenylation Specificity Factor', 48, NULL, NULL, 90252),
(90253, '2.170.130.20-FF-000004', NULL, 'Multidomain scavenger receptor', 113, NULL, NULL, 90253),
(90254, '3.30.505.10-FF-000070', NULL, 'GRB2-related adapter protein 2', 98, NULL, NULL, 90254),
(90255, '1.10.630.10-FF-000822', NULL, 'Uncharacterized protein', 239, NULL, NULL, 90255),
(90256, '2.60.40.2880-FF-000001', NULL, 'Conserved membrane protein MmpS3', 88, NULL, NULL, 90256),
(90257, '3.90.480.20-FF-000012', NULL, 'Sulfite reductase beta subunit', 87, NULL, NULL, 90257),
(90258, '3.40.50.2000-FF-001074', NULL, 'Uncharacterized protein', 51, NULL, NULL, 90258),
(90259, '2.60.40.1180-FF-000042', NULL, 'Alpha-mannosidase', 119, NULL, NULL, 90259),
(90260, '3.40.50.300-FF-006371', NULL, 'Uncharacterized protein', 138, NULL, NULL, 90260),
(90261, '3.10.110.10-FF-000308', NULL, 'Si:ch1073-205c8.3', 79, NULL, NULL, 90261),
(90262, '3.40.50.300-FF-000772', NULL, 'ATP-dependent DNA helicase Q4', 214, NULL, NULL, 90262),
(90263, '3.30.160.60-FF-000176', NULL, 'zinc finger protein 70', 28, NULL, NULL, 90263),
(90264, '3.40.50.40-FF-000015', NULL, NULL, 70, NULL, NULL, 90264),
(90265, '3.90.226.10-FF-000211', NULL, 'AUH protein', 89, NULL, NULL, 90265),
(90266, '3.40.50.450-FF-000058', NULL, 'Uncharacterized protein', 154, NULL, NULL, 90266),
(90267, '3.30.160.60-FF-002621', NULL, 'zinc finger protein 566 isoform X1', 27, NULL, NULL, 90267),
(90268, '2.40.10.310-FF-000001', NULL, 'NSA2, ribosome biogenesis homolog', 84, NULL, NULL, 90268),
(90269, '3.80.10.10-FF-002936', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 97, NULL, NULL, 90269),
(90270, '3.20.20.140-FF-000144', NULL, 'Dipeptidase gliJ', 385, NULL, NULL, 90270),
(90271, '2.170.130.10-FF-000001', NULL, 'Catecholate siderophore TonB-dependent receptor', 129, NULL, NULL, 90271),
(90272, '3.30.1330.30-FF-000152', NULL, 'Uncharacterized protein', 70, NULL, NULL, 90272),
(90273, '1.10.510.10-FF-003837', NULL, NULL, 108, NULL, NULL, 90273),
(90274, '2.60.40.10-FF-005959', NULL, NULL, 86, NULL, NULL, 90274),
(90275, '1.10.287.410-FF-000003', NULL, 'Carboxypeptidase', 78, NULL, NULL, 90275),
(90276, '1.25.10.10-FF-003372', NULL, 'Uncharacterized protein', 163, NULL, NULL, 90276),
(90277, '3.40.50.150-FF-000912', NULL, 'Putative uncharacterized protein DDB_G0293380', 226, NULL, NULL, 90277),
(90278, '1.10.630.10-FF-000619', NULL, 'Cytochrome P450, putative', 250, NULL, NULL, 90278),
(90279, '1.20.58.60-FF-000674', NULL, 'Nesprin-1', 220, NULL, NULL, 90279),
(90280, '2.40.10.10-FF-000624', NULL, NULL, 246, NULL, NULL, 90280),
(90281, '1.10.238.10-FF-000096', NULL, 'CDPK-related kinase 5', 85, NULL, NULL, 90281),
(90282, '2.60.260.20-FF-000135', NULL, 'Chloroplast DnaJ-like protein', 135, NULL, NULL, 90282);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(90283, '3.30.160.60-FF-005555', NULL, NULL, 103, NULL, NULL, 90283),
(90284, '3.30.930.10-FF-000248', NULL, 'Ferredoxin-fold anticodon-binding domain-containing 1', 309, NULL, NULL, 90284),
(90285, '3.90.440.10-FF-000001', NULL, 'Endothelial nitric oxide synthase', 98, NULL, NULL, 90285),
(90286, '2.60.11.10-FF-000013', NULL, 'Uncharacterized protein', 93, NULL, NULL, 90286),
(90287, '3.30.200.20-FF-001882', NULL, 'Tyrosine-protein kinase', 104, NULL, NULL, 90287),
(90288, '1.10.238.10-FF-000450', NULL, 'Glycerol-3-phosphate dehydrogenase', 99, NULL, NULL, 90288),
(90289, '1.10.565.10-FF-000136', NULL, 'Uncharacterized protein', 224, NULL, NULL, 90289),
(90290, '3.40.50.2300-FF-001192', NULL, NULL, 145, NULL, NULL, 90290),
(90291, '1.10.238.10-FF-000039', NULL, 'RalBP1-associated Eps domain-containing protein 2 isoform 1', 109, NULL, NULL, 90291),
(90292, '3.30.1540.10-FF-000004', NULL, 'Probable alpha-methylacyl-CoA racemase mcr', 89, NULL, NULL, 90292),
(90293, '1.10.555.10-FF-000164', NULL, NULL, 224, NULL, NULL, 90293),
(90294, '1.25.40.20-FF-000330', NULL, 'Ankyrin repeat domain 28, isoform CRA_c', 99, NULL, NULL, 90294),
(90295, '3.40.640.10-FF-000123', NULL, 'DegT/DnrJ/EryC1/StrS family aminotransferase', 242, NULL, NULL, 90295),
(90296, '1.20.1250.20-FF-001118', NULL, 'Solute carrier organic anion transporter family member', 211, NULL, NULL, 90296),
(90297, '1.10.8.60-FF-000417', NULL, 'Putative replication factor c subunit rfc1 large subunit', 72, NULL, NULL, 90297),
(90298, '4.10.1240.10-FF-000053', NULL, 'PDF receptor-like Protein', 106, NULL, NULL, 90298),
(90299, '2.40.10.10-FF-000006', NULL, 'Serine proteinase stubble', 236, NULL, NULL, 90299),
(90300, '3.30.1540.20-FF-000007', NULL, 'DNA mismatch repair protein PMS1', 95, NULL, NULL, 90300),
(90301, '3.80.10.10-FF-003251', NULL, 'Toll-like receptor 5', 175, NULL, NULL, 90301),
(90302, '3.40.50.300-FF-002571', NULL, 'Peroxisomal ABC transporter 1', 281, NULL, NULL, 90302),
(90303, '3.90.226.10-FF-000065', NULL, 'Clp protease', 197, NULL, NULL, 90303),
(90304, '2.20.28.10-FF-000048', NULL, 'Putative dna replication licensing factor mcm6 component', 53, NULL, NULL, 90304),
(90305, '1.10.8.60-FF-000327', NULL, 'DNA-dependent ATPase (MGS1), putative', 77, NULL, NULL, 90305),
(90306, '1.20.1310.10-FF-000126', NULL, NULL, 130, NULL, NULL, 90306),
(90307, '2.30.30.40-FF-000219', NULL, 'NADPH oxidase organizer 1', 64, NULL, NULL, 90307),
(90308, '1.20.1530.20-FF-000112', NULL, 'Uncharacterized protein', 176, NULL, NULL, 90308),
(90309, '2.60.120.290-FF-000258', NULL, 'Cubilin-like Protein', 127, NULL, NULL, 90309),
(90310, '2.60.40.10-FF-002115', NULL, 'Uncharacterized LOC100216153', 107, NULL, NULL, 90310),
(90311, '3.30.40.10-FF-002232', NULL, 'Predicted protein', 65, NULL, NULL, 90311),
(90312, '3.40.50.11350-FF-000027', NULL, 'Uncharacterized protein', 77, NULL, NULL, 90312),
(90313, '3.30.160.60-FF-000266', NULL, 'zinc finger and BTB domain-containing protein 44 isoform X1', 26, NULL, NULL, 90313),
(90314, '1.25.10.10-FF-000853', NULL, 'Importin subunit beta-1, putative', 825, NULL, NULL, 90314),
(90315, '1.10.287.1490-FF-000024', NULL, 'Cytoplasmic linker protein 190, isoform M', 168, NULL, NULL, 90315),
(90316, '3.40.50.720-FF-001090', NULL, 'Oxidoreductase, short chain dehydrogenase/reductase family', 241, NULL, NULL, 90316),
(90317, '3.10.290.10-FF-000091', NULL, 'Tyrosine--tRNA ligase', 94, NULL, NULL, 90317),
(90318, '1.25.40.10-FF-000063', NULL, 'Pre-mRNA processing factor 39', 278, NULL, NULL, 90318),
(90319, '1.25.10.10-FF-001573', NULL, 'Beta-adaptin-like protein C', 118, NULL, NULL, 90319),
(90320, '3.40.50.300-FF-004723', NULL, 'GTP-binding protein Rheb', 173, NULL, NULL, 90320),
(90321, '2.60.40.10-FF-002379', NULL, 'Muscle M-line assembly protein unc-89', 98, NULL, NULL, 90321),
(90322, '3.30.450.20-FF-000670', NULL, 'PAS sensor protein', 105, NULL, NULL, 90322),
(90323, '3.30.1120.10-FF-000012', NULL, 'Arylsulfatase, putative', 83, NULL, NULL, 90323),
(90324, '3.40.190.80-FF-000081', NULL, 'Inositol-1-monophosphatase', 116, NULL, NULL, 90324);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(90325, '1.10.3720.10-FF-000126', NULL, 'Amino acid ABC transporter permease', 225, NULL, NULL, 90325),
(90326, '3.60.21.10-FF-000383', NULL, 'Predicted protein', 77, NULL, NULL, 90326),
(90327, '3.30.420.10-FF-000575', NULL, NULL, 313, NULL, NULL, 90327),
(90328, '2.60.40.10-FF-000316', NULL, 'Neogenin 1', 105, NULL, NULL, 90328),
(90329, '1.10.10.10-FF-000173', NULL, 'Heat shock transcription factor Hsf1', 113, NULL, NULL, 90329),
(90330, '1.25.40.20-FF-000066', NULL, 'Osteoclast-stimulating factor 1', 116, NULL, NULL, 90330),
(90331, '3.30.160.60-FF-003756', NULL, NULL, 22, NULL, NULL, 90331),
(90332, '3.40.50.300-FF-008169', NULL, 'tRNA modification GTPase trmE', 85, NULL, NULL, 90332),
(90333, '3.60.21.10-FF-000326', NULL, 'Vacuolar protein sorting-associated protein 29', 100, NULL, NULL, 90333),
(90334, '3.10.20.90-FF-000013', NULL, 'radixin isoform X1', 79, NULL, NULL, 90334),
(90335, '1.25.40.550-FF-000001', NULL, 'AAR2 splicing factor homolog', 187, NULL, NULL, 90335),
(90336, '3.40.50.2300-FF-000938', NULL, NULL, 175, NULL, NULL, 90336),
(90337, '3.40.50.300-FF-005909', NULL, 'Uncharacterized protein', 218, NULL, NULL, 90337),
(90338, '4.10.410.10-FF-000108', NULL, 'WAP four-disulfide core domain protein 6', 36, NULL, NULL, 90338),
(90339, '3.40.50.11340-FF-000024', NULL, 'Serine carboxypeptidase, putative', 85, NULL, NULL, 90339),
(90340, '3.40.47.10-FF-000212', NULL, NULL, 170, NULL, NULL, 90340),
(90341, '3.50.50.60-FF-001252', NULL, 'Uncharacterized protein', 136, NULL, NULL, 90341),
(90342, '3.40.50.720-FF-000836', NULL, 'Similar to D-3-phosphoglycerate dehydrogenase', 181, NULL, NULL, 90342),
(90343, '3.50.50.60-FF-000532', NULL, '2-octaprenyl-6-methoxyphenyl hydroxylase', 254, NULL, NULL, 90343),
(90344, '3.40.50.970-FF-000040', NULL, 'Oxalyl-CoA decarboxylase', 192, NULL, NULL, 90344),
(90345, '3.40.630.30-FF-000044', NULL, 'dTDP-fucosamine acetyltransferase', 224, NULL, NULL, 90345),
(90346, '3.40.50.150-FF-001576', NULL, NULL, 57, NULL, NULL, 90346),
(90347, '3.40.50.1000-FF-000773', NULL, NULL, 99, NULL, NULL, 90347),
(90348, '2.130.10.10-FF-002183', NULL, 'Uncharacterized protein', 218, NULL, NULL, 90348),
(90349, '2.60.40.10-FF-001598', NULL, 'Defective proboscis extension response', 111, NULL, NULL, 90349),
(90350, '3.30.160.40-FF-000018', NULL, 'Probable porphobilinogen deaminase', 83, NULL, NULL, 90350),
(90351, '1.25.40.800-FF-000008', NULL, 'Subunit of the CCR4-NOT transcriptional complex, putative', 235, NULL, NULL, 90351),
(90352, '2.70.98.30-FF-000039', NULL, 'Putative alpha-mannosidase', 124, NULL, NULL, 90352),
(90353, '3.30.70.330-FF-002878', NULL, NULL, 67, NULL, NULL, 90353),
(90354, '1.10.560.10-FF-000030', NULL, '60 kDa chaperonin', 242, NULL, NULL, 90354),
(90355, '1.25.40.10-FF-002272', NULL, 'YALI0D16225p', 197, NULL, NULL, 90355),
(90356, '1.25.40.150-FF-000004', NULL, 'V-type proton ATPase subunit H', 102, NULL, NULL, 90356),
(90357, '3.40.1350.10-FF-000044', NULL, 'Predicted protein', 56, NULL, NULL, 90357),
(90358, '1.10.630.10-FF-000676', NULL, 'Uncharacterized protein', 508, NULL, NULL, 90358),
(90359, '2.40.50.140-FF-000211', NULL, 'breast cancer type 2 susceptibility protein', 146, NULL, NULL, 90359),
(90360, '3.40.50.150-FF-000351', NULL, 'S-adenosyl-L-methionine-dependent methyltransferase superfamily protein', 272, NULL, NULL, 90360),
(90361, '3.40.50.2000-FF-000410', NULL, 'Lipopolysaccharide 1,6-galactosyltransferase', 156, NULL, NULL, 90361),
(90362, '3.30.70.920-FF-000020', NULL, 'AsnC family transcriptional regulator', 84, NULL, NULL, 90362),
(90363, '1.10.3260.10-FF-000051', NULL, 'DNA ligase 4-like protein', 96, NULL, NULL, 90363),
(90364, '2.40.10.10-FF-000063', NULL, 'Hepatocyte growth factor', 99, NULL, NULL, 90364),
(90365, '3.40.50.300-FF-008523', NULL, 'ATP-dependent RNA helicase, putative', 210, NULL, NULL, 90365),
(90366, '1.10.1410.40-FF-000010', NULL, 'Interleukin enhancer-binding factor 2', 35, NULL, NULL, 90366),
(90367, '1.10.246.130-FF-000023', NULL, NULL, 61, NULL, NULL, 90367),
(90368, '3.90.70.10-FF-000713', NULL, 'Uncharacterized protein', 200, NULL, NULL, 90368);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(90369, '2.40.70.10-FF-000246', NULL, 'Pepsin A', 205, NULL, NULL, 90369),
(90370, '2.70.98.20-FF-000036', NULL, 'Amine oxidase', 98, NULL, NULL, 90370),
(90371, '3.30.40.10-FF-001361', NULL, 'Ring finger protein 112, gene 1', 88, NULL, NULL, 90371),
(90372, '2.60.120.970-FF-000069', NULL, 'Uncharacterized protein', 204, NULL, NULL, 90372),
(90373, '2.60.40.630-FF-000008', NULL, 'signal transducer and activator of transcription 4', 39, NULL, NULL, 90373),
(90374, '3.90.190.10-FF-000228', NULL, 'Protein tyrosine phosphatase, receptor type C', 161, NULL, NULL, 90374),
(90375, '3.30.160.60-FF-004009', NULL, NULL, 28, NULL, NULL, 90375),
(90376, '1.10.287.90-FF-000002', NULL, 'Ubiquinol oxidase subunit 2', 86, NULL, NULL, 90376),
(90377, '1.20.890.10-FF-000024', NULL, 'GD14626', 46, NULL, NULL, 90377),
(90378, '3.30.70.330-FF-001389', NULL, 'RNA recognition motif domain containing protein', 109, NULL, NULL, 90378),
(90379, '2.60.120.620-FF-000048', NULL, 'Verruculogen synthase', 290, NULL, NULL, 90379),
(90380, '3.60.21.10-FF-000236', NULL, '2'',3''-cyclic-nucleotide 2''-phosphodiesterase (CpdB)', 304, NULL, NULL, 90380),
(90381, '1.20.920.30-FF-000033', NULL, 'Dynein heavy chain', 144, NULL, NULL, 90381),
(90382, '2.70.98.10-FF-000033', NULL, 'Glucan 1,4-alpha-glucosidase SusB', 284, NULL, NULL, 90382),
(90383, '3.90.1100.10-FF-000036', NULL, 'DNA-directed RNA polymerase subunit beta', 203, NULL, NULL, 90383),
(90384, '3.80.10.10-FF-001508', NULL, 'Leucine Rich repeat, putative', 91, NULL, NULL, 90384),
(90385, '3.40.140.10-FF-000129', NULL, 'Nucleoside deaminase', 150, NULL, NULL, 90385),
(90386, '3.70.10.10-FF-000014', NULL, 'DNA repair protein Rad1, putative', 323, NULL, NULL, 90386),
(90387, '1.10.287.110-FF-000149', NULL, 'Related to cell cycle control protein cwf23', 103, NULL, NULL, 90387),
(90388, '2.10.70.10-FF-000225', NULL, 'Uncharacterized protein', 68, NULL, NULL, 90388),
(90389, '3.30.420.40-FF-000325', NULL, 'Actin-related protein RO7, putative', 96, NULL, NULL, 90389),
(90390, '3.40.50.300-FF-006314', NULL, 'CTP synthase', 293, NULL, NULL, 90390),
(90391, '3.30.60.30-FF-000148', NULL, 'Predicted protein', 64, NULL, NULL, 90391),
(90392, '2.10.25.10-FF-000593', NULL, 'SP2353, isoform A', 40, NULL, NULL, 90392),
(90393, '2.60.120.10-FF-000414', NULL, 'Predicted protein', 101, NULL, NULL, 90393),
(90394, '2.30.30.30-FF-000126', NULL, 'G patch domain and KOW motifs', 51, NULL, NULL, 90394),
(90395, '3.30.160.60-FF-006218', NULL, NULL, 89, NULL, NULL, 90395),
(90396, '3.10.20.30-FF-000102', NULL, NULL, 80, NULL, NULL, 90396),
(90397, '1.20.1310.10-FF-000036', NULL, 'SCF ubiquitin ligase subunit CulC, putative', 137, NULL, NULL, 90397),
(90398, '3.30.1320.10-FF-000022', NULL, '30S ribosomal protein S16', 143, NULL, NULL, 90398),
(90399, '2.30.30.40-FF-000129', NULL, 'MAGUK p55 subfamily member 4', 83, NULL, NULL, 90399),
(90400, '3.90.940.20-FF-000002', NULL, 'RNA polymerase, 25-kDa subunit, putative', 28, NULL, NULL, 90400),
(90401, '1.20.1560.10-FF-000667', NULL, 'Protein CBG17574', 47, NULL, NULL, 90401),
(90402, '1.10.510.10-FF-004091', NULL, NULL, 151, NULL, NULL, 90402),
(90403, '3.40.980.10-FF-000024', NULL, 'Probable FAD synthase', 170, NULL, NULL, 90403),
(90404, '1.20.900.10-FF-000077', NULL, 'Uncharacterized protein', 233, NULL, NULL, 90404),
(90405, '2.130.10.10-FF-005881', NULL, 'Predicted protein', 300, NULL, NULL, 90405),
(90406, '1.20.120.1510-FF-000001', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 113, NULL, NULL, 90406),
(90407, '1.25.10.10-FF-000292', NULL, 'Deoxyhypusine hydroxylase', 151, NULL, NULL, 90407),
(90408, '3.40.50.150-FF-000558', NULL, 'Protein arginine N-methyltransferase, putative', 131, NULL, NULL, 90408),
(90409, '3.30.860.10-FF-000012', NULL, 'Uncharacterized protein', 123, NULL, NULL, 90409),
(90410, '2.60.40.60-FF-000281', NULL, 'Cadherin related family member 3', 100, NULL, NULL, 90410),
(90411, '2.20.130.20-FF-000011', NULL, 'Blast:CD109 antigen', 65, NULL, NULL, 90411),
(90412, '3.40.50.790-FF-000019', NULL, 'Uncharacterized protein', 72, NULL, NULL, 90412);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(90413, '2.40.30.10-FF-000480', NULL, 'Uncharacterized protein', 45, NULL, NULL, 90413),
(90414, '3.40.350.10-FF-000022', NULL, 'FACT complex subunit spt16', 170, NULL, NULL, 90414),
(90415, '1.25.40.10-FF-000681', NULL, 'Pentatricopeptide repeat-containing protein', 117, NULL, NULL, 90415),
(90416, '1.25.40.20-FF-000684', NULL, 'Dynein_heavy_chain_and_region_D6_of_dynein_motor/ Ankyrin_repeats_(3_copies)/Ankyrin_repeat_-_putative', 131, NULL, NULL, 90416),
(90417, '3.30.160.60-FF-004066', NULL, NULL, 31, NULL, NULL, 90417),
(90418, '2.130.10.10-FF-005971', NULL, 'WD repeat domain 19', 240, NULL, NULL, 90418),
(90419, '3.90.70.10-FF-000770', NULL, 'Uncharacterized protein', 68, NULL, NULL, 90419),
(90420, '3.30.70.330-FF-001743', NULL, NULL, 100, NULL, NULL, 90420),
(90421, '1.20.1280.50-FF-000180', NULL, 'Glucose-induced repressor, putative', 55, NULL, NULL, 90421),
(90422, '1.10.3720.10-FF-000036', NULL, 'Maltodextrin ABC transporter, permease protein', 255, NULL, NULL, 90422),
(90423, '3.40.50.300-FF-007596', NULL, 'Uncharacterized protein', 165, NULL, NULL, 90423),
(90424, '3.40.50.720-FF-001651', NULL, 'dTDP-4-dehydrorhamnose reductase', 301, NULL, NULL, 90424),
(90425, '2.60.40.150-FF-000224', NULL, 'Double C2-like domain-containing protein', 140, NULL, NULL, 90425),
(90426, '2.10.25.10-FF-001610', NULL, 'Uncharacterized protein', 53, NULL, NULL, 90426),
(90427, '1.10.510.10-FF-002443', NULL, NULL, 250, NULL, NULL, 90427),
(90428, '2.60.40.150-FF-000314', NULL, 'Phosphatidylinositol 3-kinase age-1', 146, NULL, NULL, 90428),
(90429, '2.130.10.10-FF-001368', NULL, 'Protein HIRA', 162, NULL, NULL, 90429),
(90430, '2.20.28.290-FF-000006', NULL, 'Predicted protein', 46, NULL, NULL, 90430),
(90431, '2.60.120.820-FF-000018', NULL, 'Uncharacterized protein', 130, NULL, NULL, 90431),
(90432, '2.60.40.60-FF-000371', NULL, 'Cadherin-related hmr-1', 98, NULL, NULL, 90432),
(90433, '1.10.630.10-FF-000058', NULL, 'Fatty acid oxygenase', 409, NULL, NULL, 90433),
(90434, '1.10.287.1040-FF-000002', NULL, 'Exodeoxyribonuclease 7 small subunit', 74, NULL, NULL, 90434),
(90435, '2.70.170.10-FF-000134', NULL, 'Glutamate-gated chloride channel, putative', 93, NULL, NULL, 90435),
(90436, '3.10.20.30-FF-000012', NULL, 'Xanthine dehydrogenase/oxidase', 90, NULL, NULL, 90436),
(90437, '1.10.287.1490-FF-000114', NULL, 'Uncharacterized protein', 139, NULL, NULL, 90437),
(90438, '2.130.10.10-FF-005729', NULL, 'Uncharacterized protein', 134, NULL, NULL, 90438),
(90439, '3.30.505.10-FF-000160', NULL, NULL, 110, NULL, NULL, 90439),
(90440, '1.10.510.10-FF-000139', NULL, 'Non-specific serine/threonine protein kinase', 193, NULL, NULL, 90440),
(90441, '3.10.580.10-FF-000192', NULL, 'Uncharacterized protein', 116, NULL, NULL, 90441),
(90442, '3.40.30.10-FF-000820', NULL, 'Glutathione S-transferase theta-1', 81, NULL, NULL, 90442),
(90443, '1.25.40.10-FF-003609', NULL, 'Adenylyl cyclase class-3/4/guanylyl cyclase', 126, NULL, NULL, 90443),
(90444, '3.30.1640.10-FF-000068', NULL, 'DNA helicase', 100, NULL, NULL, 90444),
(90445, '1.10.10.1050-FF-000009', NULL, 'MutT/nudix family protein', 80, NULL, NULL, 90445),
(90446, '1.10.472.10-FF-000038', NULL, 'Cyclin F', 110, NULL, NULL, 90446),
(90447, '2.70.70.10-FF-000003', NULL, 'Murein hydrolase activator EnvC', 136, NULL, NULL, 90447),
(90448, '2.130.10.10-FF-003577', NULL, 'Abnormal embryogenesis protein 30', 148, NULL, NULL, 90448),
(90449, '3.30.70.940-FF-000026', NULL, 'Transcription termination/antitermination protein NusG', 102, NULL, NULL, 90449),
(90450, '2.10.220.10-FF-000118', NULL, 'Putative furin-like protease 2', 98, NULL, NULL, 90450),
(90451, '2.60.40.60-FF-000129', NULL, 'protocadherin alpha-C2 isoform X1', 107, NULL, NULL, 90451),
(90452, '3.20.20.80-FF-000690', NULL, 'Uncharacterized protein', 291, NULL, NULL, 90452),
(90453, '1.10.20.10-FF-000174', NULL, 'MIP14426p', 73, NULL, NULL, 90453),
(90454, '1.10.3480.20-FF-000003', NULL, 'Predicted protein', 109, NULL, NULL, 90454),
(90455, '1.20.272.10-FF-000004', NULL, 'Replication factor C subunit 5', 98, NULL, NULL, 90455);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(90456, '1.20.1250.20-FF-000101', NULL, 'feline leukemia virus subgroup C receptor-related protein 2', 203, NULL, NULL, 90456),
(90457, '3.30.500.10-FF-000019', NULL, NULL, 84, NULL, NULL, 90457),
(90458, '1.10.540.10-FF-000028', NULL, 'Acyl-CoA dehydrogenase fadE12', 119, NULL, NULL, 90458),
(90459, '3.90.550.50-FF-000150', NULL, 'Hexosyltransferase', 116, NULL, NULL, 90459),
(90460, '3.40.50.261-FF-000042', NULL, 'ATP citrate (Pro-S)-lyase', 72, NULL, NULL, 90460),
(90461, '3.30.160.60-FF-002093', NULL, NULL, 28, NULL, NULL, 90461),
(90462, '1.25.40.20-FF-000919', NULL, 'Transient receptor potential-gamma protein-like Protein', 317, NULL, NULL, 90462),
(90463, '1.20.1250.20-FF-001147', NULL, 'Predicted protein', 215, NULL, NULL, 90463),
(90464, '2.40.30.10-FF-000036', NULL, 'NADPH--cytochrome P450 reductase', 109, NULL, NULL, 90464),
(90465, '3.30.200.20-FF-001764', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', 103, NULL, NULL, 90465),
(90466, '3.30.70.330-FF-002996', NULL, NULL, 85, NULL, NULL, 90466),
(90467, '3.10.580.10-FF-000074', NULL, 'Membrane protein TerC', 156, NULL, NULL, 90467),
(90468, '1.20.1610.10-FF-000025', NULL, 'Predicted protein', 136, NULL, NULL, 90468),
(90469, '3.80.10.10-FF-003280', NULL, 'Uncharacterized protein', 131, NULL, NULL, 90469),
(90470, '1.10.8.60-FF-000592', NULL, 'Cell division control protein', 96, NULL, NULL, 90470),
(90471, '3.30.565.10-FF-000017', NULL, 'PMS1 homolog 1, mismatch repair system component', 210, NULL, NULL, 90471),
(90472, '1.10.510.10-FF-000526', NULL, 'serine/threonine-protein kinase BRI1-like 2', 218, NULL, NULL, 90472),
(90473, '3.90.810.10-FF-000018', NULL, 'Non-specific serine/threonine protein kinase', 78, NULL, NULL, 90473),
(90474, '3.80.10.10-FF-001716', NULL, 'Kekkon5, isoform A', 156, NULL, NULL, 90474),
(90475, '2.40.100.10-FF-000018', NULL, 'Peptidyl-prolyl cis-trans isomerase-like 2', 182, NULL, NULL, 90475),
(90476, '2.40.30.130-FF-000018', NULL, 'Alanyl-tRNA synthetase, putative', 118, NULL, NULL, 90476),
(90477, '3.30.70.1230-FF-000092', NULL, 'Adenylate cyclase 1', 173, NULL, NULL, 90477),
(90478, '1.10.30.10-FF-000202', NULL, 'Predicted protein', 75, NULL, NULL, 90478),
(90479, '1.10.8.60-FF-000097', NULL, 'spermatogenesis-associated protein 5 isoform X2', 89, NULL, NULL, 90479),
(90480, '3.30.2130.10-FF-000013', NULL, 'Aspartokinase', 83, NULL, NULL, 90480),
(90481, '3.30.565.10-FF-000545', NULL, 'Hypothetical regulatory protein', 127, NULL, NULL, 90481),
(90482, '1.20.1670.10-FF-000001', NULL, 'Putative deoxyuridine triphosphatase', 135, NULL, NULL, 90482),
(90483, '3.30.2170.10-FF-000015', NULL, NULL, 220, NULL, NULL, 90483),
(90484, '3.40.30.10-FF-000556', NULL, 'Tumor suppressor candidate 3', 102, NULL, NULL, 90484),
(90485, '2.60.40.60-FF-000432', NULL, 'Cadherin-4', 100, NULL, NULL, 90485),
(90486, '2.130.10.10-FF-004190', NULL, 'Uncharacterized protein', 160, NULL, NULL, 90486),
(90487, '3.30.160.60-FF-004184', NULL, NULL, 26, NULL, NULL, 90487),
(90488, '4.10.640.10-FF-000002', NULL, '30S ribosomal protein S18, chloroplastic', 64, NULL, NULL, 90488),
(90489, '1.10.510.10-FF-002617', NULL, NULL, 120, NULL, NULL, 90489),
(90490, '3.10.490.10-FF-000005', NULL, 'Gamma-glutamylcyclotransferase', 177, NULL, NULL, 90490),
(90491, '3.40.50.300-FF-002981', NULL, 'ABC transporter C family member 5', 267, NULL, NULL, 90491),
(90492, '1.10.530.10-FF-000056', NULL, 'Uncharacterized protein', 86, NULL, NULL, 90492),
(90493, '1.20.1600.10-FF-000053', NULL, 'Protein containing Peptidase M56, BlaR1 domain protein', 356, NULL, NULL, 90493),
(90494, '2.30.29.30-FF-000966', NULL, 'Uncharacterized protein', 106, NULL, NULL, 90494),
(90495, '4.10.280.10-FF-000165', NULL, 'Transcription factor bHLH104', 82, NULL, NULL, 90495),
(90496, '3.40.50.300-FF-004307', NULL, 'Uncharacterized protein', 162, NULL, NULL, 90496),
(90497, '3.30.2160.10-FF-000043', NULL, 'HECT-domain ubiquitin--protein ligase E3', 39, NULL, NULL, 90497),
(90498, '3.20.180.20-FF-000010', NULL, 'Dynein heavy chain', 99, NULL, NULL, 90498);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(90499, '3.40.50.300-FF-002453', NULL, '26S protease regulatory subunit putative', 182, NULL, NULL, 90499),
(90500, '2.60.40.2580-FF-000001', NULL, 'Major fimbrium subunit FimA type-2', 157, NULL, NULL, 90500),
(90501, '2.60.40.1510-FF-000040', NULL, 'Uncharacterized protein', 133, NULL, NULL, 90501),
(90502, '1.10.1300.10-FF-000021', NULL, 'Phosphodiesterase', 334, NULL, NULL, 90502),
(90503, '3.80.10.10-FF-000727', NULL, 'Toll-like protein', 178, NULL, NULL, 90503),
(90504, '1.10.1370.30-FF-000008', NULL, 'Angiotensin-converting enzyme', 509, NULL, NULL, 90504),
(90505, '3.40.50.10140-FF-000092', NULL, 'Uncharacterized protein', 80, NULL, NULL, 90505),
(90506, '1.20.1310.20-FF-000039', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 188, NULL, NULL, 90506),
(90507, '2.70.150.10-FF-000133', NULL, 'Probable metal-transporting P-type ATPase', 113, NULL, NULL, 90507),
(90508, '3.10.110.10-FF-000101', NULL, 'Ubiquitin-conjugating enzyme E2 D2', 149, NULL, NULL, 90508),
(90509, '4.10.240.10-FF-000163', NULL, 'Nucleus protein, putative', 68, NULL, NULL, 90509),
(90510, '3.30.200.20-FF-000185', NULL, 'Tyrosine-protein kinase', 96, NULL, NULL, 90510),
(90511, '1.20.5.2050-FF-000003', NULL, 'Transcription factor with AP2 domain(S)', 72, NULL, NULL, 90511),
(90512, '3.90.550.10-FF-000301', NULL, 'Uncharacterized protein', 463, NULL, NULL, 90512),
(90513, '1.25.40.10-FF-003519', NULL, 'Uncharacterized protein', 134, NULL, NULL, 90513),
(90514, '1.50.40.10-FF-000145', NULL, 'Mitochondrial carnitine carrier', 126, NULL, NULL, 90514),
(90515, '3.40.50.300-FF-002127', NULL, 'guanine nucleotide-binding protein G(Q) subunit alpha', 89, NULL, NULL, 90515),
(90516, '1.25.10.10-FF-002062', NULL, 'HEAT repeat-containing protein 1 homolog', 444, NULL, NULL, 90516),
(90517, '3.20.20.80-FF-000717', NULL, 'Uncharacterized protein', 168, NULL, NULL, 90517),
(90518, '3.20.20.360-FF-000002', NULL, 'Malate synthase G', 379, NULL, NULL, 90518),
(90519, '3.30.70.330-FF-001535', NULL, 'Multiple RNA-binding domain containing protein 1', 80, NULL, NULL, 90519),
(90520, '3.40.30.10-FF-000758', NULL, '28S ribosomal protein S25, mitochondrial-like', 92, NULL, NULL, 90520),
(90521, '2.60.120.1040-FF-000011', NULL, 'Uncharacterized protein', 143, NULL, NULL, 90521),
(90522, '3.40.30.10-FF-000612', NULL, 'Thioredoxin', 62, NULL, NULL, 90522),
(90523, '2.60.40.790-FF-000034', NULL, 'Protein SGT1 homolog A', 92, NULL, NULL, 90523),
(90524, '3.30.160.60-FF-003874', NULL, NULL, 24, NULL, NULL, 90524),
(90525, '1.10.10.60-FF-001149', NULL, NULL, 55, NULL, NULL, 90525),
(90526, '2.40.30.10-FF-000362', NULL, 'Pyruvate:ferredoxin oxidoreductase/NADPH-cytochrome P450 reductase PNO', 92, NULL, NULL, 90526),
(90527, '1.20.1250.20-FF-001203', NULL, 'Permeases of the major facilitator superfamily', 183, NULL, NULL, 90527),
(90528, '3.20.20.70-FF-000714', NULL, NULL, 125, NULL, NULL, 90528),
(90529, '2.130.10.10-FF-003728', NULL, 'Uncharacterized protein', 337, NULL, NULL, 90529),
(90530, '3.50.30.30-FF-000157', NULL, 'Alkaline serine protease, subtilase family', 113, NULL, NULL, 90530),
(90531, '3.40.50.1000-FF-000065', NULL, 'Putative Phosphatidyl synthase', 156, NULL, NULL, 90531),
(90532, '1.20.120.1900-FF-000056', NULL, 'Spindle pole body component', 286, NULL, NULL, 90532),
(90533, '3.30.40.10-FF-001451', NULL, 'Uncharacterized protein', 98, NULL, NULL, 90533),
(90534, '3.10.450.580-FF-000003', NULL, 'Mediator of RNA polymerase II transcription subunit 6', 162, NULL, NULL, 90534),
(90535, '3.90.70.10-FF-000444', NULL, 'Uncharacterized protein', 138, NULL, NULL, 90535),
(90536, '3.30.200.20-FF-002130', NULL, 'Uncharacterized protein', 72, NULL, NULL, 90536),
(90537, '2.10.110.20-FF-000001', NULL, 'lysine-specific demethylase 6A isoform X2', 67, NULL, NULL, 90537),
(90538, '3.30.420.40-FF-000409', NULL, 'Heat shock protein 70, putative', 92, NULL, NULL, 90538),
(90539, '3.40.50.1010-FF-000068', NULL, 'Ribonuclease VapC', 138, NULL, NULL, 90539),
(90540, '1.20.1530.20-FF-000027', NULL, 'sodium/bile acid cotransporter 7 isoform X4', 148, NULL, NULL, 90540);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(90541, '3.30.70.100-FF-000123', NULL, NULL, 82, NULL, NULL, 90541),
(90542, '3.30.40.10-FF-000023', NULL, 'Lysine (K)-specific demethylase 5A', 60, NULL, NULL, 90542),
(90543, '1.10.20.10-FF-000230', NULL, NULL, 45, NULL, NULL, 90543),
(90544, '1.10.510.10-FF-004181', NULL, NULL, 107, NULL, NULL, 90544),
(90545, '2.60.40.380-FF-000001', NULL, 'Fe(3+)-Zn(2+) purple acid phosphatase', 97, NULL, NULL, 90545),
(90546, '2.160.10.10-FF-000080', NULL, 'Predicted protein', 129, NULL, NULL, 90546),
(90547, '2.130.10.130-FF-000026', NULL, NULL, 206, NULL, NULL, 90547),
(90548, '3.10.120.10-FF-000017', NULL, 'Fatty acid desaturase 1', 97, NULL, NULL, 90548),
(90549, '1.10.1090.10-FF-000009', NULL, 'Cytochrome b-c1 complex subunit 7', 93, NULL, NULL, 90549),
(90550, '1.10.720.60-FF-000001', NULL, 'Probable bifunctional methylthioribulose-1-phosphate dehydratase/enolase-phosphatase E1', 97, NULL, NULL, 90550),
(90551, '3.10.620.30-FF-000022', NULL, 'Uncharacterized protein', 158, NULL, NULL, 90551),
(90552, '3.30.390.10-FF-000021', NULL, 'Regulator of nonsense transcripts 1-like protein', 102, NULL, NULL, 90552),
(90553, '1.10.3730.20-FF-000074', NULL, 'Uncharacterized protein', 121, NULL, NULL, 90553),
(90554, '2.120.10.30-FF-000003', NULL, 'Teneurin transmembrane protein 2', 162, NULL, NULL, 90554),
(90555, '1.10.10.10-FF-001567', NULL, 'Endonuclease III family protein', 56, NULL, NULL, 90555),
(90556, '2.130.10.10-FF-001839', NULL, 'WD-40 repeat protein', 225, NULL, NULL, 90556),
(90557, '3.30.420.40-FF-000735', NULL, 'Actin-like protein ARP6', 111, NULL, NULL, 90557),
(90558, '3.40.50.2300-FF-001309', NULL, NULL, 119, NULL, NULL, 90558),
(90559, '1.25.40.10-FF-002210', NULL, 'Signal recognition particle subunit SRP72', 164, NULL, NULL, 90559),
(90560, '3.40.850.10-FF-000369', NULL, 'Uncharacterized protein', 34, NULL, NULL, 90560),
(90561, '3.40.605.10-FF-000053', NULL, 'Aldehyde dehydrogenase', 265, NULL, NULL, 90561),
(90562, '1.10.1200.10-FF-000159', NULL, 'Putative peptide synthetase', 74, NULL, NULL, 90562),
(90563, '3.30.200.20-FF-001438', NULL, 'Putative serine/threonine protein kinase IREH1', 169, NULL, NULL, 90563),
(90564, '3.50.50.60-FF-000116', NULL, 'Glycine oxidase ThiO', 203, NULL, NULL, 90564),
(90565, '1.10.510.10-FF-003871', NULL, NULL, 93, NULL, NULL, 90565),
(90566, '3.30.200.20-FF-001966', NULL, 'Protein CBG04906', 126, NULL, NULL, 90566),
(90567, '2.130.10.10-FF-002003', NULL, 'Dynein, axonemal, intermediate chain 1, paralog 2', 240, NULL, NULL, 90567),
(90568, '3.10.20.80-FF-000010', NULL, 'Predicted protein', 75, NULL, NULL, 90568),
(90569, '1.10.510.10-FF-002292', NULL, NULL, 94, NULL, NULL, 90569),
(90570, '2.60.120.260-FF-000598', NULL, 'Predicted protein', 148, NULL, NULL, 90570),
(90571, '3.40.50.1820-FF-001710', NULL, 'Uncharacterized protein', 151, NULL, NULL, 90571),
(90572, '1.20.120.1750-FF-000022', NULL, 'RBR-type E3 ubiquitin transferase', 246, NULL, NULL, 90572),
(90573, '3.40.50.11530-FF-000014', NULL, 'Interleukin 17 receptor E', 143, NULL, NULL, 90573),
(90574, '1.10.238.10-FF-000242', NULL, 'EF-hand calcium binding domain 6', 79, NULL, NULL, 90574),
(90575, '2.170.270.10-FF-000073', NULL, 'AGAP013139-PA', 180, NULL, NULL, 90575),
(90576, '1.20.1250.20-FF-000837', NULL, 'Solute carrier organic anion transporter family member', 298, NULL, NULL, 90576),
(90577, '2.160.20.10-FF-000052', NULL, 'Pectinesterase', 297, NULL, NULL, 90577),
(90578, '2.60.200.20-FF-000221', NULL, 'Uncharacterized protein', 108, NULL, NULL, 90578),
(90579, '3.40.1380.20-FF-000077', NULL, 'Pyruvate kinase', 155, NULL, NULL, 90579),
(90580, '3.40.50.300-FF-000036', NULL, 'septin-6 isoform X2', 291, NULL, NULL, 90580),
(90581, '3.30.40.10-FF-001653', NULL, 'Predicted protein', 50, NULL, NULL, 90581),
(90582, '1.25.10.10-FF-002236', NULL, 'Uncharacterized protein', 383, NULL, NULL, 90582),
(90583, '1.50.40.10-FF-000347', NULL, 'Mitochondrial carrier protein, putative', 154, NULL, NULL, 90583),
(90584, '2.30.40.10-FF-000149', NULL, 'Periplasmic amidohydrolase family protein', 61, NULL, NULL, 90584);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(90585, '3.40.50.300-FF-008113', NULL, 'Uncharacterized protein', 107, NULL, NULL, 90585),
(90586, '3.30.420.40-FF-000033', NULL, 'glycerol kinase isoform X2', 249, NULL, NULL, 90586),
(90587, '1.20.58.340-FF-000065', NULL, 'Predicted protein', 61, NULL, NULL, 90587),
(90588, '3.90.70.10-FF-000242', NULL, 'Peptidase', 311, NULL, NULL, 90588),
(90589, '1.10.287.940-FF-000021', NULL, 'P2X purinoceptor', 25, NULL, NULL, 90589),
(90590, '3.30.60.20-FF-000112', NULL, 'Diacylglycerol kinase', 47, NULL, NULL, 90590),
(90591, '3.30.450.40-FF-000237', NULL, 'GGDEF family protein', 170, NULL, NULL, 90591),
(90592, '1.20.1280.50-FF-000264', NULL, 'Uncharacterized protein', 53, NULL, NULL, 90592),
(90593, '3.30.930.10-FF-000097', NULL, 'Proline--tRNA ligase', 119, NULL, NULL, 90593),
(90594, '1.20.1070.10-FF-001725', NULL, 'Mu-type opioid receptor', 98, NULL, NULL, 90594),
(90595, '1.25.40.20-FF-001111', NULL, 'Fibronectin type III and ankyrin repeat domains 1', 33, NULL, NULL, 90595),
(90596, '1.10.287.950-FF-000024', NULL, 'Methyl-accepting chemotaxis sensory transducer, class 40+24H', 269, NULL, NULL, 90596),
(90597, '1.20.120.1760-FF-000025', NULL, 'CDP-diacylglycerol--serine o-phosphatidyltransferase PssA', 190, NULL, NULL, 90597),
(90598, '2.10.25.10-FF-000885', NULL, 'Protein S', 43, NULL, NULL, 90598),
(90599, '1.10.506.10-FF-000005', NULL, 'Plexin A1', 253, NULL, NULL, 90599),
(90600, '2.60.40.1180-FF-000126', NULL, 'Alpha-mannosidase', 123, NULL, NULL, 90600),
(90601, '2.30.180.10-FF-000104', NULL, NULL, 142, NULL, NULL, 90601),
(90602, '2.60.40.10-FF-002615', NULL, 'Uncharacterized protein', 86, NULL, NULL, 90602),
(90603, '3.40.50.150-FF-001486', NULL, NULL, 122, NULL, NULL, 90603),
(90604, '1.10.10.60-FF-000047', NULL, 'Myb transcription factor', 57, NULL, NULL, 90604),
(90605, '3.40.630.30-FF-000572', NULL, 'Uncharacterized protein', 107, NULL, NULL, 90605),
(90606, '3.90.730.10-FF-000017', NULL, 'Uncharacterized protein', 214, NULL, NULL, 90606),
(90607, '3.40.525.10-FF-000052', NULL, 'Protein tyrosine phosphatase Meg2, isoform F', 108, NULL, NULL, 90607),
(90608, '3.30.9.10-FF-000018', NULL, 'D-amino acid oxidase, putative', 172, NULL, NULL, 90608),
(90609, '2.60.40.150-FF-000640', NULL, 'Uncharacterized protein', 130, NULL, NULL, 90609),
(90610, '3.40.630.30-FF-000544', NULL, 'L-lysine 2,3-aminomutase, putative/acetyltransferase, GNAT family', 164, NULL, NULL, 90610),
(90611, '1.25.40.10-FF-003317', NULL, 'Pentatricopeptide repeat-containing protein', 106, NULL, NULL, 90611),
(90612, '1.10.533.10-FF-000063', NULL, 'Mitochondrial antiviral-signaling protein', 94, NULL, NULL, 90612),
(90613, '2.40.128.20-FF-000052', NULL, 'LiPocalin-Related protein', 170, NULL, NULL, 90613),
(90614, '3.40.50.1100-FF-000062', NULL, '1-aminocyclopropane-1-carboxylate deaminase, putative', 118, NULL, NULL, 90614),
(90615, '1.20.58.60-FF-000792', NULL, 'Uncharacterized protein', 309, NULL, NULL, 90615),
(90616, '2.40.10.10-FF-000708', NULL, NULL, 31, NULL, NULL, 90616),
(90617, '3.10.20.90-FF-000541', NULL, 'GH01724p', 133, NULL, NULL, 90617),
(90618, '1.10.510.10-FF-003399', NULL, NULL, 304, NULL, NULL, 90618),
(90619, '3.40.50.300-FF-006724', NULL, 'Uncharacterized protein', 276, NULL, NULL, 90619),
(90620, '3.40.1360.10-FF-000016', NULL, 'DNA primase', 124, NULL, NULL, 90620),
(90621, '3.40.50.200-FF-000006', NULL, 'Subtilisin-like protease SBT1.5', 352, NULL, NULL, 90621),
(90622, '2.40.10.10-FF-000332', NULL, NULL, 111, NULL, NULL, 90622),
(90623, '3.40.50.10860-FF-000009', NULL, 'Bifunctional 3-dehydroquinate dehydratase/shikimate dehydrogenase, chloroplastic', 98, NULL, NULL, 90623),
(90624, '1.25.40.10-FF-004301', NULL, 'Pentatricopeptide repeat-containing protein', 194, NULL, NULL, 90624),
(90625, '3.90.70.10-FF-000118', NULL, 'Ubiquitin carboxyl-terminal hydrolase 25', 325, NULL, NULL, 90625),
(90626, '2.60.40.150-FF-000168', NULL, 'Protein BONZAI 1', 143, NULL, NULL, 90626),
(90627, '2.60.40.290-FF-000007', NULL, 'Uncharacterized protein', 101, NULL, NULL, 90627),
(90628, '1.10.10.10-FF-002056', NULL, 'Uncharacterized protein', 106, NULL, NULL, 90628);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(90629, '3.60.40.10-FF-000365', NULL, 'Uncharacterized protein', 281, NULL, NULL, 90629),
(90630, '3.40.630.10-FF-000414', NULL, 'Uncharacterized protein', 303, NULL, NULL, 90630),
(90631, '2.60.40.10-FF-002295', NULL, 'Stretchin-Mlck, isoform V', 100, NULL, NULL, 90631),
(90632, '3.40.50.300-FF-003908', NULL, 'Molybdate ABC transporter ATP-binding protein', 221, NULL, NULL, 90632),
(90633, '1.20.144.10-FF-000105', NULL, 'Uncharacterized protein', 278, NULL, NULL, 90633),
(90634, '1.10.238.10-FF-000303', NULL, 'Cornulin', 108, NULL, NULL, 90634),
(90635, '2.130.10.10-FF-005494', NULL, 'Heterotrimeric G protein beta subunit 1', 120, NULL, NULL, 90635),
(90636, '3.40.50.720-FF-001387', NULL, 'Uncharacterized protein', 56, NULL, NULL, 90636),
(90637, '3.20.20.140-FF-000470', NULL, 'Adenosine deaminase 2', 214, NULL, NULL, 90637),
(90638, '3.70.10.10-FF-000076', NULL, 'Checkpoint protein', 262, NULL, NULL, 90638),
(90639, '3.40.1280.10-FF-000015', NULL, 'Putative tRNA/rRNA methyltransferase', 165, NULL, NULL, 90639),
(90640, '2.60.40.10-FF-002025', NULL, NULL, 110, NULL, NULL, 90640),
(90641, '3.40.50.720-FF-001117', NULL, 'D-3-phosphoglycerate dehydrogenase', 119, NULL, NULL, 90641),
(90642, '1.10.3560.10-FF-000001', NULL, 'Protein PBDC1 homolog', 136, NULL, NULL, 90642),
(90643, '2.130.10.10-FF-000058', NULL, 'striatin isoform X1', 156, NULL, NULL, 90643),
(90644, '2.130.10.10-FF-002149', NULL, 'Os08g0524100 protein', 214, NULL, NULL, 90644),
(90645, '2.40.270.10-FF-000025', NULL, NULL, 74, NULL, NULL, 90645),
(90646, '1.20.1070.10-FF-001107', NULL, 'Rhodopsin, GQ-coupled', 311, NULL, NULL, 90646),
(90647, '1.50.40.10-FF-000471', NULL, 'Uncharacterized protein', 59, NULL, NULL, 90647),
(90648, '3.10.20.90-FF-000513', NULL, 'Uncharacterized protein', 198, NULL, NULL, 90648),
(90649, '2.160.20.10-FF-000142', NULL, 'Uncharacterized protein', 159, NULL, NULL, 90649),
(90650, '3.30.70.330-FF-000433', NULL, 'RNA-binding protein', 86, NULL, NULL, 90650),
(90651, '2.40.50.140-FF-001077', NULL, NULL, 87, NULL, NULL, 90651),
(90652, '2.30.130.10-FF-000040', NULL, 'Dyskeratosis congenita 1, dyskerin', 29, NULL, NULL, 90652),
(90653, '3.40.50.1820-FF-000777', NULL, 'Uncharacterized protein CaJ7.0249', 269, NULL, NULL, 90653),
(90654, '3.10.450.50-FF-000110', NULL, 'Predicted protein', 66, NULL, NULL, 90654),
(90655, '1.10.287.110-FF-000065', NULL, 'Chaperone protein dnaJ 49', 117, NULL, NULL, 90655),
(90656, '2.130.10.10-FF-004217', NULL, 'Uncharacterized protein', 151, NULL, NULL, 90656),
(90657, '3.30.40.10-FF-001327', NULL, 'Ring-H2 finger A3B', 97, NULL, NULL, 90657),
(90658, '3.40.50.2000-FF-000848', NULL, 'Glycosyltransferase, putative', 238, NULL, NULL, 90658),
(90659, '1.20.120.450-FF-000007', NULL, NULL, 164, NULL, NULL, 90659),
(90660, '3.90.460.10-FF-000002', NULL, 'Ferredoxin-thioredoxin reductase, catalytic chain', 101, NULL, NULL, 90660),
(90661, '3.30.1640.10-FF-000006', NULL, 'DNA helicase', 101, NULL, NULL, 90661),
(90662, '3.40.50.1110-FF-000098', NULL, 'Uncharacterized protein', 222, NULL, NULL, 90662),
(90663, '1.25.40.10-FF-001844', NULL, 'Thioredoxin', 88, NULL, NULL, 90663),
(90664, '3.10.120.10-FF-000045', NULL, 'Uncharacterized protein', 74, NULL, NULL, 90664),
(90665, '3.40.50.300-FF-006168', NULL, 'Predicted protein', 81, NULL, NULL, 90665),
(90666, '1.10.238.10-FF-000921', NULL, 'Phosphoinositide phospholipase C', 78, NULL, NULL, 90666),
(90667, '1.20.5.190-FF-000121', NULL, NULL, 63, NULL, NULL, 90667),
(90668, '1.10.630.10-FF-000468', NULL, 'Uncharacterized protein', 108, NULL, NULL, 90668),
(90669, '3.90.920.10-FF-000026', NULL, 'DNA primase', 284, NULL, NULL, 90669),
(90670, '3.40.640.10-FF-000510', NULL, 'Uncharacterized protein', 54, NULL, NULL, 90670),
(90671, '3.40.50.300-FF-003818', NULL, 'Eukaryotic Elongation Factor, SelenoCysteine-tRNA-specific', 177, NULL, NULL, 90671),
(90672, '3.30.450.40-FF-000035', NULL, 'PAS sensor protein', 193, NULL, NULL, 90672),
(90673, '3.40.50.970-FF-000124', NULL, '1-deoxy-D-xylulose-5-phosphate synthase', 185, NULL, NULL, 90673),
(90674, '3.30.450.30-FF-000032', NULL, 'Dynein light chain 2B, cytoplasmic, putative', 109, NULL, NULL, 90674);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(90675, '3.40.140.10-FF-000130', NULL, 'Eukaryotic translation initiation factor 3 subunit H', 144, NULL, NULL, 90675),
(90676, '2.130.10.10-FF-003077', NULL, 'YALI0A20636p', 115, NULL, NULL, 90676),
(90677, '2.60.40.10-FF-004442', NULL, NULL, 60, NULL, NULL, 90677),
(90678, '2.120.10.30-FF-000205', NULL, 'Uncharacterized protein', 203, NULL, NULL, 90678),
(90679, '3.50.50.60-FF-000206', NULL, 'Digeranylgeranylglycerophospholipid reductase', 226, NULL, NULL, 90679),
(90680, '3.30.200.20-FF-001348', NULL, 'CMGC family protein kinase', 92, NULL, NULL, 90680),
(90681, '3.40.50.10420-FF-000052', NULL, 'Uncharacterized protein', 240, NULL, NULL, 90681),
(90682, '3.40.50.300-FF-008023', NULL, 'Uncharacterized protein', 140, NULL, NULL, 90682),
(90683, '1.50.40.10-FF-000319', NULL, 'Uncharacterized protein', 332, NULL, NULL, 90683),
(90684, '1.10.238.10-FF-000573', NULL, 'Serine/threonine-protein phosphatase', 166, NULL, NULL, 90684),
(90685, '1.20.1070.10-FF-000736', NULL, 'SIFamide receptor-like protein', 327, NULL, NULL, 90685),
(90686, '3.10.20.90-FF-000395', NULL, 'Polyubiquitin containing 7 ubiquitin monomers', 69, NULL, NULL, 90686),
(90687, '3.30.70.1230-FF-000266', NULL, 'Predicted protein', 142, NULL, NULL, 90687),
(90688, '3.40.50.1480-FF-000012', NULL, 'Adenosylhomocysteinase', 143, NULL, NULL, 90688),
(90689, '3.90.550.10-FF-000071', NULL, 'Mannose-1-phosphate guanyltransferase alpha', 267, NULL, NULL, 90689),
(90690, '3.40.20.10-FF-000168', NULL, 'Actin-depolymerizing factor 1, isoforms a/b', 56, NULL, NULL, 90690),
(90691, '3.30.420.40-FF-000179', NULL, 'Actin-like 6a isoform 3', 91, NULL, NULL, 90691),
(90692, '3.30.160.60-FF-006252', NULL, NULL, 48, NULL, NULL, 90692),
(90693, '1.10.8.960-FF-000006', NULL, 'Putative gamma-glutamylcysteine synthetase', 60, NULL, NULL, 90693),
(90694, '1.20.960.30-FF-000007', NULL, 'Uncharacterized protein', 110, NULL, NULL, 90694),
(90695, '1.10.3730.10-FF-000008', NULL, 'Pyrroline-5-carboxylate reductase', 118, NULL, NULL, 90695),
(90696, '2.130.10.10-FF-006016', NULL, 'Uncharacterized protein', 167, NULL, NULL, 90696),
(90697, '1.10.10.1830-FF-000001', NULL, 'Non-ribosomal peptide synthetase', 52, NULL, NULL, 90697),
(90698, '3.30.1360.120-FF-000024', NULL, 'Putative transferase, mitochondrial', 370, NULL, NULL, 90698),
(90699, '3.30.200.20-FF-002220', NULL, 'Uncharacterized protein', 41, NULL, NULL, 90699),
(90700, '3.40.50.1820-FF-001564', NULL, 'Uncharacterized protein', 116, NULL, NULL, 90700),
(90701, '1.25.40.20-FF-001847', NULL, 'Uncharacterized protein', 140, NULL, NULL, 90701),
(90702, '3.30.70.3400-FF-000001', NULL, 'Protein translocase subunit SecD', 59, NULL, NULL, 90702),
(90703, '3.90.550.10-FF-000306', NULL, 'Uncharacterized glycosyltransferase YwdF', 234, NULL, NULL, 90703),
(90704, '2.130.10.10-FF-000530', NULL, 'Autophagy-related protein 18a', 139, NULL, NULL, 90704),
(90705, '1.20.1110.10-FF-000055', NULL, 'Calcium-transporting ATPase', 116, NULL, NULL, 90705),
(90706, '2.60.40.10-FF-000171', NULL, 'protein-glutamine gamma-glutamyltransferase 6', 115, NULL, NULL, 90706),
(90707, '3.30.160.60-FF-002267', NULL, NULL, 28, NULL, NULL, 90707),
(90708, '2.70.170.10-FF-000016', NULL, 'Nicotinic acetylcholine receptor subunit', 220, NULL, NULL, 90708),
(90709, '4.10.240.10-FF-000039', NULL, 'ARG81-like protein', 40, NULL, NULL, 90709),
(90710, '1.10.287.40-FF-000009', NULL, 'Serine-tRNA ligase, putative', 109, NULL, NULL, 90710),
(90711, '2.60.40.680-FF-000001', NULL, 'O-GlcNAcase NagJ', 136, NULL, NULL, 90711),
(90712, '2.10.110.10-FF-000200', NULL, 'Uncharacterized protein', 73, NULL, NULL, 90712),
(90713, '1.10.287.70-FF-000373', NULL, 'Ion_transport_protein_-_putative', 118, NULL, NULL, 90713),
(90714, '1.10.418.10-FF-000194', NULL, 'Leucine-rich repeats and calponin homology (CH) domain-containing 3', 89, NULL, NULL, 90714),
(90715, '3.80.10.10-FF-001391', NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', 120, NULL, NULL, 90715),
(90716, '3.40.50.300-FF-006814', NULL, 'Uncharacterized protein', 44, NULL, NULL, 90716);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(90717, '3.90.1140.10-FF-000005', NULL, 'activating signal cointegrator 1 complex subunit 1', 230, NULL, NULL, 90717),
(90718, '2.60.40.690-FF-000004', NULL, 'Complement C3', 149, NULL, NULL, 90718),
(90719, '3.40.50.1820-FF-001087', NULL, 'Phospholipid:diacylglycerol acyltransferase 1', 106, NULL, NULL, 90719),
(90720, '2.60.40.10-FF-003689', NULL, NULL, 100, NULL, NULL, 90720),
(90721, '2.60.120.200-FF-000389', NULL, 'Cell wall organization and biogenesis-related protein, putative', 268, NULL, NULL, 90721),
(90722, '2.60.40.1660-FF-000028', NULL, 'ATPase Na+/K+ transporting subunit beta 2a', 250, NULL, NULL, 90722),
(90723, '3.90.70.10-FF-000270', NULL, 'SUMO-specific isopeptidase USPL1', 275, NULL, NULL, 90723),
(90724, '3.40.30.10-FF-000584', NULL, 'Possible thiol:disulfide interchange protein', 145, NULL, NULL, 90724),
(90725, '2.30.180.10-FF-000048', NULL, 'Tyrosine-protein kinase', 140, NULL, NULL, 90725),
(90726, '3.40.1060.10-FF-000004', NULL, 'Aconitase 2', 53, NULL, NULL, 90726),
(90727, '4.10.400.10-FF-000193', NULL, 'Uncharacterized protein, isoform B', 42, NULL, NULL, 90727),
(90728, '3.30.160.60-FF-006162', NULL, NULL, 103, NULL, NULL, 90728),
(90729, '1.10.10.790-FF-000026', NULL, 'Protein SWAP', 60, NULL, NULL, 90729),
(90730, '3.40.50.300-FF-007798', NULL, 'Uncharacterized protein', 45, NULL, NULL, 90730),
(90731, '1.10.10.60-FF-000137', NULL, 'MYB DNA binding protein', 62, NULL, NULL, 90731),
(90732, '1.10.1040.10-FF-000068', NULL, 'ApbA-domain-containing protein', 150, NULL, NULL, 90732),
(90733, '1.25.10.10-FF-002326', NULL, 'Uncharacterized protein', 303, NULL, NULL, 90733),
(90734, '3.30.70.360-FF-000066', NULL, 'AGL325Wp', 109, NULL, NULL, 90734),
(90735, '3.90.1010.10-FF-000001', NULL, 'Iron-sulfur cluster assembly scaffold protein IscU', 128, NULL, NULL, 90735),
(90736, '1.20.1070.10-FF-001635', NULL, 'Uncharacterized protein', 139, NULL, NULL, 90736),
(90737, '3.90.550.10-FF-000447', NULL, 'Uncharacterized protein', 271, NULL, NULL, 90737),
(90738, '3.90.180.10-FF-000166', NULL, 'Uncharacterized protein', 104, NULL, NULL, 90738),
(90739, '3.30.30.30-FF-000057', NULL, 'Heat shock protein 70 putative', 60, NULL, NULL, 90739),
(90740, '3.30.450.50-FF-000038', NULL, 'Synaptobrevin family protein', 116, NULL, NULL, 90740),
(90741, '3.10.110.10-FF-000073', NULL, 'Ubiquitin-conjugating enzyme E2 N', 149, NULL, NULL, 90741),
(90742, '2.10.90.10-FF-000142', NULL, 'Transforming growth factor beta superfamily signaling ligand', 110, NULL, NULL, 90742),
(90743, '1.20.120.430-FF-000001', NULL, 'tRNA modification GTPase MnmE', 167, NULL, NULL, 90743),
(90744, '1.10.10.60-FF-000340', NULL, 'Transcriptional adapter', 51, NULL, NULL, 90744),
(90745, '3.30.160.60-FF-000468', NULL, 'B-cell lymphoma 6 protein-like', 32, NULL, NULL, 90745),
(90746, '1.10.510.10-FF-002943', NULL, NULL, 55, NULL, NULL, 90746),
(90747, '3.30.500.10-FF-000014', NULL, 'Uncharacterized protein', 137, NULL, NULL, 90747),
(90748, '3.80.10.10-FF-002644', NULL, 'LRR receptor-like serine/threonine-protein kinase GSO2', 70, NULL, NULL, 90748),
(90749, '3.40.50.10900-FF-000010', NULL, 'Proteasome assembly chaperone 2', 196, NULL, NULL, 90749),
(90750, '3.30.420.610-FF-000024', NULL, 'Tapas, isoform B', 95, NULL, NULL, 90750),
(90751, '3.80.10.10-FF-003190', NULL, 'Ribonuclease inhibitor', 232, NULL, NULL, 90751),
(90752, '3.40.50.10190-FF-000174', NULL, 'DNA ligase 4', 109, NULL, NULL, 90752),
(90753, '3.40.50.1820-FF-001620', NULL, 'Uncharacterized protein', 59, NULL, NULL, 90753),
(90754, '3.30.230.130-FF-000011', NULL, 'SCF ubiquitin ligase subunit CulC, putative', 173, NULL, NULL, 90754),
(90755, '1.25.40.10-FF-003643', NULL, 'Genomes uncoupled1', 113, NULL, NULL, 90755),
(90756, '3.40.50.300-FF-000238', NULL, 'Cell division control 12', 295, NULL, NULL, 90756),
(90757, '3.40.50.2300-FF-000056', NULL, 'Gamma-aminobutyric acid type B receptor subunit 1', 172, NULL, NULL, 90757),
(90758, '1.20.1250.20-FF-001057', NULL, 'Permeases of the major facilitator superfamily', 201, NULL, NULL, 90758),
(90759, '2.60.40.3510-FF-000022', NULL, 'Delta-like protein', 159, NULL, NULL, 90759);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(90760, '1.20.120.350-FF-000275', NULL, NULL, 58, NULL, NULL, 90760),
(90761, '3.50.7.10-FF-000003', NULL, 'T-complex protein 1 subunit epsilon', 155, NULL, NULL, 90761),
(90762, '1.10.540.10-FF-000023', NULL, 'Acyl-CoA dehydrogenase FadE25', 122, NULL, NULL, 90762),
(90763, '1.10.150.50-FF-000235', NULL, 'Uncharacterized protein', 69, NULL, NULL, 90763),
(90764, '3.40.50.2020-FF-000186', NULL, 'Orotate phosphoribosyltransferase', 194, NULL, NULL, 90764),
(90765, '2.60.40.640-FF-000129', NULL, 'Arrestin 3, retinal (X-arrestin)', 204, NULL, NULL, 90765),
(90766, '1.25.50.20-FF-000038', NULL, 'Aminopeptidase', 323, NULL, NULL, 90766),
(90767, '2.130.10.10-FF-000351', NULL, 'semaphorin-4F isoform X1', 474, NULL, NULL, 90767),
(90768, '1.10.472.130-FF-000004', NULL, 'Dynein axonemal heavy chain 8', 94, NULL, NULL, 90768),
(90769, '3.30.200.20-FF-001674', NULL, 'Uncharacterized protein', 79, NULL, NULL, 90769),
(90770, '3.40.50.720-FF-000954', NULL, 'Homoserine dehydrogenase', 169, NULL, NULL, 90770),
(90771, '1.10.20.10-FF-000084', NULL, 'Histone H2B', 123, NULL, NULL, 90771),
(90772, '3.30.519.10-FF-000040', NULL, NULL, 118, NULL, NULL, 90772),
(90773, '3.30.160.60-FF-001311', NULL, 'Zinc finger protein 668', 30, NULL, NULL, 90773),
(90774, '1.10.287.600-FF-000026', NULL, 'Tubulin alpha-8 chain', 37, NULL, NULL, 90774),
(90775, '3.80.10.10-FF-001626', NULL, 'CLL4B clavata1-like receptor S/T protein kinase protein', 167, NULL, NULL, 90775),
(90776, '1.10.1070.11-FF-000110', NULL, 'Non-specific serine/threonine protein kinase', 196, NULL, NULL, 90776),
(90777, '1.25.40.10-FF-002154', NULL, 'regulator of microtubule dynamics protein 1', 140, NULL, NULL, 90777),
(90778, '1.10.390.10-FF-000084', NULL, 'Aminopeptidase N', 44, NULL, NULL, 90778),
(90779, '3.30.160.60-FF-002413', NULL, 'Zinc finger protein 547', 31, NULL, NULL, 90779),
(90780, '2.60.40.150-FF-000163', NULL, 'Copine 7', 125, NULL, NULL, 90780),
(90781, '3.80.10.10-FF-002728', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 421, NULL, NULL, 90781),
(90782, '3.40.30.10-FF-000702', NULL, 'AhpC/TSA family thioredoxin peroxidase, putative', 118, NULL, NULL, 90782),
(90783, '3.40.50.300-FF-000564', NULL, 'Structural maintenance of chromosomes 1A', 213, NULL, NULL, 90783),
(90784, '2.60.120.950-FF-000001', NULL, 'Capsid protein', 193, NULL, NULL, 90784),
(90785, '3.30.160.60-FF-001957', NULL, 'Si:dkey-77f5.11', 29, NULL, NULL, 90785),
(90786, '3.30.70.100-FF-000095', NULL, 'Disease resistance protein RGA5', 75, NULL, NULL, 90786),
(90787, '3.30.70.2190-FF-000020', NULL, 'Glr3436 protein', 116, NULL, NULL, 90787),
(90788, '1.25.40.10-FF-001698', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 133, NULL, NULL, 90788),
(90789, '3.30.160.60-FF-000327', NULL, 'Zinc finger and AT-hook domain containing', 32, NULL, NULL, 90789),
(90790, '1.10.287.110-FF-000267', NULL, 'DnaJ domain containing protein, putative', 81, NULL, NULL, 90790),
(90791, '1.10.3210.10-FF-000071', NULL, 'Falten, isoform B', 312, NULL, NULL, 90791),
(90792, '3.10.110.10-FF-000106', NULL, 'Ubiquitin-fold modifier-conjugating enzyme 1', 165, NULL, NULL, 90792),
(90793, '3.40.140.10-FF-000040', NULL, '26S proteasome regulatory subunit RPN8', 182, NULL, NULL, 90793),
(90794, '4.10.1240.50-FF-000014', NULL, 'Uncharacterized protein', 103, NULL, NULL, 90794),
(90795, '1.20.1560.10-FF-000791', NULL, 'Uncharacterized protein', 226, NULL, NULL, 90795),
(90796, '2.60.40.10-FF-000726', NULL, 'Hemicentin 1', 92, NULL, NULL, 90796),
(90797, '3.40.50.880-FF-000193', NULL, 'Uncharacterized protein', 126, NULL, NULL, 90797),
(90798, '3.80.10.10-FF-002970', NULL, 'Uncharacterized protein', 116, NULL, NULL, 90798),
(90799, '3.40.50.720-FF-001443', NULL, 'Malate dehydrogenase', 62, NULL, NULL, 90799),
(90800, '3.30.870.10-FF-000131', NULL, 'Uncharacterized protein', 182, NULL, NULL, 90800),
(90801, '1.20.1410.10-FF-000044', NULL, 'Uncharacterized protein C22E12.18', 162, NULL, NULL, 90801),
(90802, '3.40.50.2000-FF-000180', NULL, 'Glycosyltransferase', 248, NULL, NULL, 90802);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(90803, '3.70.10.10-FF-000132', NULL, 'Checkpoint protein hus1', 285, NULL, NULL, 90803),
(90804, '3.30.565.10-FF-000219', NULL, 'Two-component sensor histidine kinase malate', 154, NULL, NULL, 90804),
(90805, '3.40.630.30-FF-000600', NULL, 'Uncharacterized protein', 68, NULL, NULL, 90805),
(90806, '3.30.60.300-FF-000001', NULL, '60S ribosomal protein L10', 40, NULL, NULL, 90806),
(90807, '3.40.50.300-FF-008293', NULL, 'Uncharacterized protein', 28, NULL, NULL, 90807),
(90808, '3.40.50.620-FF-000694', NULL, 'Uncharacterized protein', 268, NULL, NULL, 90808),
(90809, '3.30.70.330-FF-000231', NULL, 'Cleavage and polyadenylation specificity factor subunit 7', 99, NULL, NULL, 90809),
(90810, '3.30.160.60-FF-005763', NULL, NULL, 29, NULL, NULL, 90810),
(90811, '3.30.420.40-FF-000207', NULL, 'Type II pantothenate kinase', 181, NULL, NULL, 90811),
(90812, '1.20.5.110-FF-000047', NULL, 'Vesicle-associated membrane protein 727', 87, NULL, NULL, 90812),
(90813, '1.10.472.10-FF-000510', NULL, 'Putative cyclin-T1-1', 100, NULL, NULL, 90813),
(90814, '2.40.10.10-FF-000416', NULL, NULL, 98, NULL, NULL, 90814),
(90815, '2.60.120.970-FF-000007', NULL, 'Inhibin beta A chain', 267, NULL, NULL, 90815),
(90816, '3.40.50.300-FF-004370', NULL, 'Elongator complex protein 4', 310, NULL, NULL, 90816),
(90817, '1.20.140.100-FF-000053', NULL, 'Dynein heavy chain 9', 77, NULL, NULL, 90817),
(90818, '3.40.50.300-FF-004128', NULL, 'AAA ATPase central domain protein', 185, NULL, NULL, 90818),
(90819, '2.40.70.10-FF-000364', NULL, NULL, 112, NULL, NULL, 90819),
(90820, '3.30.530.20-FF-000030', NULL, 'Pathogenesis-related protein 10', 158, NULL, NULL, 90820),
(90821, '2.60.40.10-FF-005021', NULL, NULL, 104, NULL, NULL, 90821),
(90822, '3.40.50.10810-FF-000129', NULL, 'SWF/SNF family helicase', 211, NULL, NULL, 90822),
(90823, '3.40.50.150-FF-000502', NULL, 'rRNA adenine N(6)-methyltransferase', 229, NULL, NULL, 90823),
(90824, '3.40.50.2300-FF-001074', NULL, NULL, 150, NULL, NULL, 90824),
(90825, '2.60.40.10-FF-000108', NULL, 'Tyrosine-protein kinase receptor', 107, NULL, NULL, 90825),
(90826, '1.10.418.10-FF-000014', NULL, 'Plastin-3 isoform 1', 128, NULL, NULL, 90826),
(90827, '1.10.238.10-FF-000247', NULL, 'Calcium-dependent protein kinase 5', 68, NULL, NULL, 90827),
(90828, '4.10.220.110-FF-000001', NULL, 'VgrG1', 63, NULL, NULL, 90828),
(90829, '3.40.50.12160-FF-000028', NULL, 'tRNA 2-methylthioadenosine synthase', 140, NULL, NULL, 90829),
(90830, '3.30.2130.30-FF-000047', NULL, 'Uncharacterized protein', 167, NULL, NULL, 90830),
(90831, '3.10.180.10-FF-000021', NULL, '1,2-dihydroxynaphthalene dioxygenase', 164, NULL, NULL, 90831),
(90832, '1.20.1280.50-FF-000062', NULL, 'F-box/WD repeat-containing protein 9 isoform X2', 80, NULL, NULL, 90832),
(90833, '2.10.25.10-FF-001233', NULL, 'GD23943', 70, NULL, NULL, 90833),
(90834, '2.10.25.10-FF-001609', NULL, 'Mucin glycoprotein MUC3', 87, NULL, NULL, 90834),
(90835, '3.90.79.20-FF-000028', NULL, 'Uncharacterized protein', 123, NULL, NULL, 90835),
(90836, '3.10.20.90-FF-000485', NULL, 'GM11949', 99, NULL, NULL, 90836),
(90837, '3.30.450.140-FF-000001', NULL, 'Virulence sensor histidine kinase PhoQ', 149, NULL, NULL, 90837),
(90838, '1.10.418.20-FF-000017', NULL, 'Chromosome 1, whole genome shotgun sequence', 114, NULL, NULL, 90838),
(90839, '2.130.10.10-FF-003638', NULL, 'WD repeat-containing protein 18-like Protein', 217, NULL, NULL, 90839),
(90840, '2.60.40.10-FF-003599', NULL, NULL, 88, NULL, NULL, 90840),
(90841, '3.40.930.10-FF-000050', NULL, NULL, 142, NULL, NULL, 90841),
(90842, '2.10.25.10-FF-000744', NULL, 'Delta-like protein', 42, NULL, NULL, 90842),
(90843, '1.10.472.10-FF-000600', NULL, 'D type cyclin', 20, NULL, NULL, 90843),
(90844, '2.60.40.60-FF-000808', NULL, 'Uncharacterized protein', 122, NULL, NULL, 90844),
(90845, '2.60.210.10-FF-000005', NULL, 'Ubiquitin carboxyl-terminal hydrolase 13', 144, NULL, NULL, 90845),
(90846, '1.10.4080.10-FF-000009', NULL, 'Uncharacterized protein', 127, NULL, NULL, 90846),
(90847, '1.20.120.550-FF-000032', NULL, 'Uncharacterized protein', 70, NULL, NULL, 90847);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(90848, '2.40.40.10-FF-000008', NULL, 'Expansin', 142, NULL, NULL, 90848),
(90849, '3.90.79.10-FF-000025', NULL, 'isopentenyl-diphosphate Delta-isomerase I', 234, NULL, NULL, 90849),
(90850, '2.130.10.10-FF-000204', NULL, 'WD repeat domain 11', 270, NULL, NULL, 90850),
(90851, '1.10.10.60-FF-000463', NULL, 'RNA polymerase sigma-54 factor', 66, NULL, NULL, 90851),
(90852, '3.30.70.100-FF-000128', NULL, NULL, 74, NULL, NULL, 90852),
(90853, '1.10.10.2750-FF-000002', NULL, 'TBC1 domain family member 4', 72, NULL, NULL, 90853),
(90854, '3.40.190.10-FF-000604', NULL, 'Glutamate ionotropic receptor kainate type subunit 4', 99, NULL, NULL, 90854),
(90855, '1.20.120.1900-FF-000051', NULL, 'Spindle pole body component', 304, NULL, NULL, 90855),
(90856, '2.60.40.10-FF-004532', NULL, NULL, 94, NULL, NULL, 90856),
(90857, '3.80.10.10-FF-001065', NULL, 'Reticulon/nogo receptor', 182, NULL, NULL, 90857),
(90858, '1.20.870.10-FF-000023', NULL, 'Drosophila SOS homolog', 214, NULL, NULL, 90858),
(90859, '1.20.1640.10-FF-000027', NULL, 'Blast:Protein patched', 214, NULL, NULL, 90859),
(90860, '2.40.10.10-FF-000506', NULL, NULL, 86, NULL, NULL, 90860),
(90861, '3.30.450.150-FF-000004', NULL, 'UPF0303 protein YBR137W', 179, NULL, NULL, 90861),
(90862, '1.25.40.10-FF-002064', NULL, 'probable UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SEC', 34, NULL, NULL, 90862),
(90863, '1.10.8.270-FF-000136', NULL, 'Uncharacterized protein', 110, NULL, NULL, 90863),
(90864, '3.40.50.300-FF-004280', NULL, 'Guanine nucleotide-binding protein (G protein), alpha-activating activity polypeptide, olfactory type 2', 155, NULL, NULL, 90864),
(90865, '3.40.50.2020-FF-000039', NULL, 'Ribose-phosphate pyrophosphokinase', 139, NULL, NULL, 90865),
(90866, '3.40.190.10-FF-000689', NULL, 'Lipoprotein, putative', 114, NULL, NULL, 90866),
(90867, '1.10.472.140-FF-000007', NULL, 'GM24273', 159, NULL, NULL, 90867),
(90868, '3.40.20.10-FF-000084', NULL, 'Drebrin 1', 100, NULL, NULL, 90868),
(90869, '3.40.50.2300-FF-001635', NULL, NULL, 264, NULL, NULL, 90869),
(90870, '1.25.40.10-FF-001518', NULL, 'Heat shock protein STI1, putative', 111, NULL, NULL, 90870),
(90871, '3.30.70.890-FF-000045', NULL, 'Mevalonate kinase', 158, NULL, NULL, 90871),
(90872, '2.130.10.10-FF-000474', NULL, 'Syntaxin binding protein 5', 139, NULL, NULL, 90872),
(90873, '2.120.10.30-FF-000531', NULL, 'Uncharacterized protein', 136, NULL, NULL, 90873),
(90874, '3.40.50.720-FF-001533', NULL, 'Short-chain dehydrogenase, putative', 279, NULL, NULL, 90874),
(90875, '3.30.60.30-FF-000064', NULL, 'Serine protease inhibitor dipetalogastin', 33, NULL, NULL, 90875),
(90876, '1.10.510.10-FF-000818', NULL, 'Protein kinase', 253, NULL, NULL, 90876),
(90877, '3.30.300.230-FF-000001', NULL, 'Putative metallo-beta-lactamase', 87, NULL, NULL, 90877),
(90878, '3.40.50.300-FF-000710', NULL, 'Cytoplasmic dynein 2 heavy chain 1', 123, NULL, NULL, 90878),
(90879, '3.30.700.10-FF-000001', NULL, 'General secretion pathway protein G', 119, NULL, NULL, 90879),
(90880, '1.10.760.10-FF-000011', NULL, 'Cytochrome c1, putative', 195, NULL, NULL, 90880),
(90881, '2.10.25.10-FF-001048', NULL, 'Delta-like protein', 40, NULL, NULL, 90881),
(90882, '3.10.20.70-FF-000035', NULL, 'Glutamine synthetase', 92, NULL, NULL, 90882),
(90883, '3.30.720.10-FF-000002', NULL, 'signal recognition particle 14 kDa protein-like', 134, NULL, NULL, 90883),
(90884, '3.50.50.60-FF-001134', NULL, 'Predicted protein', 115, NULL, NULL, 90884),
(90885, '3.30.160.60-FF-004037', NULL, 'Uncharacterized protein', 91, NULL, NULL, 90885),
(90886, '3.40.50.300-FF-000654', NULL, 'Small g-protein ras2', 195, NULL, NULL, 90886),
(90887, '2.40.50.100-FF-000042', NULL, '50S ribosomal protein L27', 97, NULL, NULL, 90887),
(90888, '3.30.420.270-FF-000023', NULL, 'TonB system transport protein ExbD', 66, NULL, NULL, 90888),
(90889, '3.30.700.20-FF-000004', NULL, 'Uncharacterized protein', 128, NULL, NULL, 90889),
(90890, '2.60.300.12-FF-000026', NULL, NULL, 109, NULL, NULL, 90890),
(90891, '3.40.50.2020-FF-000096', NULL, 'Ribose-phosphate pyrophosphokinase', 147, NULL, NULL, 90891);
INSERT INTO "PUBLIC"."MODEL" VALUES
(90892, '2.180.10.10-FF-000034', NULL, 'Uncharacterized protein', 303, NULL, NULL, 90892),
(90893, '3.50.50.60-FF-000032', NULL, 'D-amino acid dehydrogenase', 144, NULL, NULL, 90893),
(90894, '2.60.40.10-FF-000816', NULL, 'collagen alpha-1(XII) chain isoform X2', 93, NULL, NULL, 90894),
(90895, '3.40.30.10-FF-000904', NULL, 'Uncharacterized protein', 138, NULL, NULL, 90895),
(90896, '3.40.720.10-FF-000096', NULL, 'AGAP004721-PA', 442, NULL, NULL, 90896),
(90897, '1.25.40.10-FF-002300', NULL, 'Tetratricopeptide repeat protein 1', 182, NULL, NULL, 90897),
(90898, '3.30.420.10-FF-000159', NULL, 'Ribonuclease, putative', 174, NULL, NULL, 90898),
(90899, '3.10.20.30-FF-000074', NULL, NULL, 69, NULL, NULL, 90899),
(90900, '2.60.120.1540-FF-000009', NULL, 'Thioester-containing protein 4, isoform B', 96, NULL, NULL, 90900),
(90901, '2.130.10.10-FF-003493', NULL, 'Intraflagellar transport protein 172', 271, NULL, NULL, 90901),
(90902, '3.40.50.300-FF-004454', NULL, 'ABC transporter, putative', 121, NULL, NULL, 90902),
(90903, '3.30.40.10-FF-000107', NULL, 'pygopus homolog 1', 70, NULL, NULL, 90903),
(90904, '3.40.50.720-FF-001264', NULL, 'Glycerol-3-phosphate dehydrogenase', 196, NULL, NULL, 90904),
(90905, '3.40.720.10-FF-000152', NULL, 'Lipid A phosphoethanolamine transferase', 332, NULL, NULL, 90905),
(90906, '3.30.40.10-FF-001743', NULL, 'YALI0E30547p', 98, NULL, NULL, 90906),
(90907, '1.25.40.120-FF-000018', NULL, 'Protein farnesyltransferase subunit alpha', 178, NULL, NULL, 90907),
(90908, '2.130.10.10-FF-003964', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit TRM82', 239, NULL, NULL, 90908),
(90909, '1.10.287.40-FF-000010', NULL, 'Probable serine-tRNA ligase, cytosolic', 109, NULL, NULL, 90909),
(90910, '2.60.40.790-FF-000124', NULL, 'GM15349', 128, NULL, NULL, 90910),
(90911, '3.60.40.10-FF-000275', NULL, 'Protein serine/threonine phosphatase PrpC, regulation of stationary phase', 254, NULL, NULL, 90911),
(90912, '3.30.70.330-FF-002232', NULL, NULL, 126, NULL, NULL, 90912),
(90913, '2.10.25.10-FF-001525', NULL, 'Predicted protein', 48, NULL, NULL, 90913),
(90914, '1.25.10.10-FF-002152', NULL, 'Uncharacterized protein', 527, NULL, NULL, 90914),
(90915, '1.25.10.10-FF-001747', NULL, 'Condensin subunit 1, putative', 147, NULL, NULL, 90915),
(90916, '1.20.58.70-FF-000031', NULL, 'Syntaxin-32', 247, NULL, NULL, 90916),
(90917, '2.40.420.20-FF-000063', NULL, 'Acriflavine resistance protein A [Precursor]', 83, NULL, NULL, 90917),
(90918, '3.30.2020.30-FF-000016', NULL, 'Trimethyllysine hydroxylase, epsilon', 91, NULL, NULL, 90918),
(90919, '3.50.30.30-FF-000073', NULL, 'Zinc finger protein, putative', 145, NULL, NULL, 90919),
(90920, '3.60.21.10-FF-000057', NULL, 'Acid sphingomyelinase-like phosphodiesterase', 305, NULL, NULL, 90920),
(90921, '3.40.630.10-FF-000066', NULL, 'M28 family peptidase', 279, NULL, NULL, 90921),
(90922, '2.10.25.10-FF-001054', NULL, 'Wall-associated receptor kinase 2', 39, NULL, NULL, 90922),
(90923, '1.10.8.60-FF-000389', NULL, 'Predicted protein', 78, NULL, NULL, 90923),
(90924, '1.10.1520.10-FF-000088', NULL, 'Dicer-like protein', 163, NULL, NULL, 90924),
(90925, '3.90.190.10-FF-000554', NULL, 'Uncharacterized protein', 105, NULL, NULL, 90925),
(90926, '1.25.40.10-FF-003699', NULL, 'Os05g0534900 protein', 193, NULL, NULL, 90926),
(90927, '2.30.130.10-FF-000039', NULL, 'Chromosome 1, whole genome shotgun sequence', 77, NULL, NULL, 90927),
(90928, '3.40.120.10-FF-000038', NULL, 'Phosphoacetylglucosamine mutase', 176, NULL, NULL, 90928),
(90929, '1.25.40.70-FF-000058', NULL, 'Uncharacterized protein', 189, NULL, NULL, 90929),
(90930, '1.10.238.10-FF-001259', NULL, 'Uncharacterized protein', 60, NULL, NULL, 90930),
(90931, '3.30.70.980-FF-000015', NULL, 'Probable transcriptional regulatory protein LEP1GSC115_2457', 81, NULL, NULL, 90931),
(90932, '2.30.29.30-FF-001135', NULL, 'Uncharacterized protein', 118, NULL, NULL, 90932),
(90933, '2.60.120.560-FF-000013', NULL, 'Levanase', 156, NULL, NULL, 90933),
(90934, '3.40.33.10-FF-000147', NULL, 'Uncharacterized protein', 143, NULL, NULL, 90934);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(90935, '3.30.200.20-FF-000331', NULL, 'Calcium/calmodulin-dependent protein kinase type 1G', 81, NULL, NULL, 90935),
(90936, '3.90.950.20-FF-000003', NULL, 'Os01g0691500 protein', 158, NULL, NULL, 90936),
(90937, '3.10.20.30-FF-000017', NULL, '39S ribosomal protein L39, mitochondrial', 56, NULL, NULL, 90937),
(90938, '3.40.50.620-FF-000688', NULL, 'tRNA synthetase, putative', 307, NULL, NULL, 90938),
(90939, '3.30.800.10-FF-000003', NULL, 'Phosphatidylinositol 4-phosphate 5-kinase', 183, NULL, NULL, 90939),
(90940, '2.170.120.20-FF-000003', NULL, '50S ribosomal protein L25', 94, NULL, NULL, 90940),
(90941, '3.40.50.150-FF-000412', NULL, 'mRNA cap guanine-N7 methyltransferase', 287, NULL, NULL, 90941),
(90942, '1.20.1250.20-FF-001821', NULL, 'Uncharacterized protein', 154, NULL, NULL, 90942),
(90943, '1.10.220.20-FF-000013', NULL, 'Uncharacterized protein', 63, NULL, NULL, 90943),
(90944, '3.80.10.10-FF-000699', NULL, 'Leucine rich repeat containing 23', 66, NULL, NULL, 90944),
(90945, '2.170.120.30-FF-000006', NULL, 'YbbR-like domain-containing protein YbbR', 102, NULL, NULL, 90945),
(90946, '3.90.1720.10-FF-000033', NULL, 'Uncharacterized protein', 154, NULL, NULL, 90946),
(90947, '3.30.160.60-FF-005673', NULL, NULL, 75, NULL, NULL, 90947),
(90948, '2.30.30.40-FF-000045', NULL, 'Short stop, isoform K', 66, NULL, NULL, 90948),
(90949, '1.10.220.10-FF-000010', NULL, 'Annexin', 75, NULL, NULL, 90949),
(90950, '1.20.1250.20-FF-001534', NULL, 'Facilitated trehalose transporter Tret1', 444, NULL, NULL, 90950),
(90951, '1.10.30.10-FF-000056', NULL, 'Brahma-associated protein 111kD', 100, NULL, NULL, 90951),
(90952, '3.30.2390.20-FF-000001', NULL, 'ESX-1 secretion system ATPase EccB1', 93, NULL, NULL, 90952),
(90953, '3.30.70.330-FF-001866', NULL, NULL, 105, NULL, NULL, 90953),
(90954, '1.10.510.10-FF-004416', NULL, NULL, 76, NULL, NULL, 90954),
(90955, '2.10.25.10-FF-001380', NULL, 'Uncharacterized protein', 35, NULL, NULL, 90955),
(90956, '2.30.30.30-FF-000042', NULL, '50S ribosomal protein L24', 107, NULL, NULL, 90956),
(90957, '3.40.640.10-FF-000038', NULL, 'Cystathionine gamma-synthase', 247, NULL, NULL, 90957),
(90958, '3.30.505.10-FF-000244', NULL, NULL, 64, NULL, NULL, 90958),
(90959, '3.30.70.80-FF-000057', NULL, 'Os08g0452100 protein', 63, NULL, NULL, 90959),
(90960, '2.60.40.10-FF-000081', NULL, 'Myosin-binding protein C, slow type', 90, NULL, NULL, 90960),
(90961, '1.10.20.10-FF-000027', NULL, 'Nuclear transcription factor Y subunit beta', 131, NULL, NULL, 90961),
(90962, '3.40.50.1000-FF-000357', NULL, 'Uncharacterized protein', 191, NULL, NULL, 90962),
(90963, '2.130.10.10-FF-001840', NULL, 'Transducin family protein / WD-40 repeat family protein', 212, NULL, NULL, 90963),
(90964, '3.40.50.450-FF-000087', NULL, 'Uncharacterized protein', 111, NULL, NULL, 90964),
(90965, '2.70.170.10-FF-000218', NULL, 'Uncharacterized protein', 125, NULL, NULL, 90965),
(90966, '3.40.50.1580-FF-000042', NULL, 'Purine nucleoside phosphorylase', 272, NULL, NULL, 90966),
(90967, '3.40.50.300-FF-006640', NULL, 'Uncharacterized protein', 90, NULL, NULL, 90967),
(90968, '2.10.60.10-FF-000078', NULL, 'Serine/threonine-protein kinase receptor', 49, NULL, NULL, 90968),
(90969, '1.25.40.850-FF-000001', NULL, 'vacuolar protein sorting-associated protein 33B isoform X1', 92, NULL, NULL, 90969),
(90970, '1.25.40.10-FF-003284', NULL, 'Probable pre-mRNA splicing factor prp1', 132, NULL, NULL, 90970),
(90971, '1.20.58.390-FF-000119', NULL, 'AcetylCholine Receptor', 70, NULL, NULL, 90971),
(90972, '1.10.8.60-FF-000445', NULL, 'Filamentation temperature-sensitive H 2A isoform 1', 53, NULL, NULL, 90972),
(90973, '3.30.420.40-FF-000651', NULL, 'Actin-related protein Arp5', 152, NULL, NULL, 90973),
(90974, '1.10.510.10-FF-002527', NULL, 'Uncharacterized protein', 344, NULL, NULL, 90974),
(90975, '1.10.1200.120-FF-000006', NULL, 'Large-conductance mechanosensitive channel', 96, NULL, NULL, 90975),
(90976, '3.90.550.10-FF-000273', NULL, 'Chitin synthase 2, putative', 291, NULL, NULL, 90976),
(90977, '1.10.405.10-FF-000035', NULL, 'Uncharacterized protein', 101, NULL, NULL, 90977);
INSERT INTO "PUBLIC"."MODEL" VALUES
(90978, '2.60.34.10-FF-000021', NULL, 'Heat shock cognate protein 1', 129, NULL, NULL, 90978),
(90979, '3.30.160.60-FF-000294', NULL, 'Odd-skipped-related transciption factor 2', 25, NULL, NULL, 90979),
(90980, '1.25.10.10-FF-000437', NULL, 'Ribosomal RNA processing 12 homolog', 175, NULL, NULL, 90980),
(90981, '1.10.510.10-FF-002056', NULL, 'NIMA-related kinase 6', 302, NULL, NULL, 90981),
(90982, '2.60.120.10-FF-000830', NULL, 'Nitrogen regulator, putative', 144, NULL, NULL, 90982),
(90983, '3.40.50.1440-FF-000141', NULL, 'Uncharacterized protein', 52, NULL, NULL, 90983),
(90984, '3.90.550.50-FF-000234', NULL, 'Uncharacterized protein', 93, NULL, NULL, 90984),
(90985, '2.60.40.10-FF-004240', NULL, NULL, 111, NULL, NULL, 90985),
(90986, '1.10.1070.11-FF-000054', NULL, 'serine/threonine-protein kinase ATM', 199, NULL, NULL, 90986),
(90987, '2.120.10.80-FF-000091', NULL, 'host cell factor 1 isoform X3', 169, NULL, NULL, 90987),
(90988, '2.60.40.10-FF-004296', NULL, NULL, 120, NULL, NULL, 90988),
(90989, '3.40.50.1100-FF-000185', NULL, 'Pyridoxal-phosphate dependent enzyme family protein', 110, NULL, NULL, 90989),
(90990, '3.10.100.10-FF-000134', NULL, 'Uncharacterized protein', 151, NULL, NULL, 90990),
(90991, '3.40.50.410-FF-000069', NULL, 'von Willebrand factor A domain containing 5A', 181, NULL, NULL, 90991),
(90992, '1.10.3860.10-FF-000018', NULL, 'Sodium:dicarboxylate symport protein', 399, NULL, NULL, 90992),
(90993, '3.40.50.300-FF-001020', NULL, 'Nickel import ATP-binding protein NikE', 254, NULL, NULL, 90993),
(90994, '1.20.85.10-FF-000002', NULL, 'Photosystem II protein D1', 183, NULL, NULL, 90994),
(90995, '3.40.50.2000-FF-000938', NULL, 'Uncharacterized protein', 141, NULL, NULL, 90995),
(90996, '3.40.1110.10-FF-000178', NULL, 'Heavy metal translocatin', 74, NULL, NULL, 90996),
(90997, '3.30.390.170-FF-000001', NULL, 'Envelope glycoprotein L', 95, NULL, NULL, 90997),
(90998, '3.50.50.60-FF-001336', NULL, 'Protein CBG18665', 45, NULL, NULL, 90998),
(90999, '2.130.10.10-FF-000148', NULL, 'probable E3 ubiquitin-protein ligase HERC1 isoform X1', 406, NULL, NULL, 90999),
(91000, '2.60.200.30-FF-000039', NULL, 'NAD kinase b', 59, NULL, NULL, 91000),
(91001, '2.60.260.20-FF-000051', NULL, 'Mdj1p', 60, NULL, NULL, 91001),
(91002, '2.40.70.10-FF-000072', NULL, 'DNA damage-inducible protein', 146, NULL, NULL, 91002),
(91003, '2.60.40.60-FF-000045', NULL, 'Cadherin 2', 114, NULL, NULL, 91003),
(91004, '3.30.160.60-FF-002183', NULL, 'Uncharacterized protein', 32, NULL, NULL, 91004),
(91005, '2.130.10.10-FF-005527', NULL, 'Uncharacterized protein', 16, NULL, NULL, 91005),
(91006, '3.30.200.20-FF-001910', NULL, NULL, 90, NULL, NULL, 91006),
(91007, '2.60.40.60-FF-000573', NULL, 'Cadherin 10', 91, NULL, NULL, 91007),
(91008, '2.60.120.260-FF-000513', NULL, 'Beta-galactosidase', 124, NULL, NULL, 91008),
(91009, '2.70.150.10-FF-000043', NULL, 'Phospholipid-transporting ATPase', 147, NULL, NULL, 91009),
(91010, '3.40.50.720-FF-001207', NULL, 'Probable short-chain dehydrogenase', 251, NULL, NULL, 91010),
(91011, '3.90.470.20-FF-000073', NULL, 'Uncharacterized protein', 114, NULL, NULL, 91011),
(91012, '1.20.58.390-FF-000271', NULL, 'Uncharacterized protein', 76, NULL, NULL, 91012),
(91013, '2.20.70.10-FF-000202', NULL, 'mRNA cap guanine-N7 methyltransferase', 43, NULL, NULL, 91013),
(91014, '3.40.50.620-FF-000868', NULL, 'Protein CBR-LARS-2', 137, NULL, NULL, 91014),
(91015, '4.10.1240.50-FF-000008', NULL, 'REST corepressor 3', 61, NULL, NULL, 91015),
(91016, '1.20.1270.60-FF-000148', NULL, 'Unplaced genomic scaffold supercont1.21, whole genome shotgun sequence', 218, NULL, NULL, 91016),
(91017, '2.60.40.60-FF-000516', NULL, 'CaDHerin family', 82, NULL, NULL, 91017),
(91018, '3.30.160.60-FF-000092', NULL, 'Early growth response protein 3', 93, NULL, NULL, 91018),
(91019, '2.10.70.10-FF-000287', NULL, 'Uncharacterized protein', 57, NULL, NULL, 91019),
(91020, '3.40.1050.10-FF-000032', NULL, 'Carbonic anhydrase', 142, NULL, NULL, 91020),
(91021, '3.40.50.720-FF-001735', NULL, 'Zgc:172341', 96, NULL, NULL, 91021);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(91022, '2.60.200.20-FF-000036', NULL, 'Ras interacting protein 1', 113, NULL, NULL, 91022),
(91023, '3.40.140.10-FF-000214', NULL, 'Uncharacterized protein', 58, NULL, NULL, 91023),
(91024, '2.70.130.10-FF-000098', NULL, NULL, 151, NULL, NULL, 91024),
(91025, '1.20.1560.10-FF-000375', NULL, 'Os04g0620066 protein', 225, NULL, NULL, 91025),
(91026, '2.60.200.10-FF-000033', NULL, 'Interferon regulatory factor like protein', 202, NULL, NULL, 91026),
(91027, '3.30.9.10-FF-000198', NULL, 'D-amino acid dehydrogenase 2', 145, NULL, NULL, 91027),
(91028, '2.10.260.10-FF-000003', NULL, 'Putative regulator PrlF', 46, NULL, NULL, 91028),
(91029, '3.40.50.300-FF-000856', NULL, 'AFG1-like ATPase isoform X1', 155, NULL, NULL, 91029),
(91030, '3.30.160.60-FF-003110', NULL, 'Draculin-like 3', 30, NULL, NULL, 91030),
(91031, '3.90.1100.10-FF-000031', NULL, 'DNA-directed RNA polymerase subunit beta', 202, NULL, NULL, 91031),
(91032, '3.40.30.10-FF-001253', NULL, 'Uncharacterized protein', 120, NULL, NULL, 91032),
(91033, '3.30.70.330-FF-001451', NULL, 'Protein CBR-FUST-1', 119, NULL, NULL, 91033),
(91034, '2.130.10.10-FF-000620', NULL, 'cilia- and flagella-associated protein 52 isoform X2', 167, NULL, NULL, 91034),
(91035, '2.60.120.1000-FF-000022', NULL, 'Col1a1 protein', 123, NULL, NULL, 91035),
(91036, '1.10.132.10-FF-000018', NULL, NULL, 33, NULL, NULL, 91036),
(91037, '1.10.555.10-FF-000080', NULL, 'Similar to GTPase-activating protein testicular GAP1', 204, NULL, NULL, 91037),
(91038, '2.40.30.270-FF-000010', NULL, 'DNA2-like helicase', 63, NULL, NULL, 91038),
(91039, '3.80.10.10-FF-001481', NULL, 'EIN3-binding F-box protein 1', 82, NULL, NULL, 91039),
(91040, '3.40.640.10-FF-000151', NULL, 'Adenosylmethionine-8-amino-7-oxononanoate aminotransferase', 300, NULL, NULL, 91040),
(91041, '3.30.420.40-FF-000180', NULL, 'D-ribulose kinase isoform X1', 194, NULL, NULL, 91041),
(91042, '3.40.50.10190-FF-000168', NULL, 'BRCA1 C Terminus (BRCT) domain containing protein, putative', 124, NULL, NULL, 91042),
(91043, '3.90.1140.10-FF-000011', NULL, 'AKAP7 2''5'' RNA ligase-like domain containing protein', 204, NULL, NULL, 91043),
(91044, '3.40.50.2300-FF-001276', NULL, NULL, 177, NULL, NULL, 91044),
(91045, '3.40.710.10-FF-000067', NULL, 'Peptidoglycan D,D-transpeptidase MrdA', 373, NULL, NULL, 91045),
(91046, '3.40.190.10-FF-000312', NULL, 'Ionotropic receptor 41a', 133, NULL, NULL, 91046),
(91047, '1.10.10.820-FF-000018', NULL, 'Myosin C', 44, NULL, NULL, 91047),
(91048, '3.40.50.300-FF-007888', NULL, 'ABC transporter, transmembrane ATP-binding protein, putative', 193, NULL, NULL, 91048),
(91049, '2.60.40.10-FF-003745', NULL, NULL, 113, NULL, NULL, 91049),
(91050, '2.130.10.10-FF-001784', NULL, 'Uncharacterized protein', 127, NULL, NULL, 91050),
(91051, '3.10.10.20-FF-000003', NULL, 'Telomerase reverse transcriptase', 60, NULL, NULL, 91051),
(91052, '1.20.1270.370-FF-000001', NULL, 'Putative 2-hydroxyglutaryl-CoA dehydratase, D-component', 73, NULL, NULL, 91052),
(91053, '1.10.167.10-FF-000048', NULL, 'Regulator of G-protein signaling rgs-3', 146, NULL, NULL, 91053),
(91054, '2.40.160.120-FF-000001', NULL, 'Oxysterol-binding protein', 168, NULL, NULL, 91054),
(91055, '1.10.8.10-FF-000127', NULL, 'E3 ubiquitin-protein ligase AMFR', 57, NULL, NULL, 91055),
(91056, '2.30.29.30-FF-000882', NULL, 'switch-associated protein 70-like isoform X1', 113, NULL, NULL, 91056),
(91057, '3.30.160.60-FF-002800', NULL, 'Zinc finger protein 792', 30, NULL, NULL, 91057),
(91058, '3.20.20.70-FF-000861', NULL, NULL, 51, NULL, NULL, 91058),
(91059, '3.40.50.300-FF-002801', NULL, 'Protein translocase subunit SecA', 174, NULL, NULL, 91059),
(91060, '2.60.40.60-FF-000606', NULL, 'Si:dkey-30k22.7', 110, NULL, NULL, 91060),
(91061, '3.20.20.70-FF-000804', NULL, NULL, 141, NULL, NULL, 91061),
(91062, '3.40.50.10380-FF-000017', NULL, 'Malate dehydrogenase:SUBUNIT=A, putative', 256, NULL, NULL, 91062),
(91063, '1.25.40.10-FF-001991', NULL, 'TPR domain protein', 99, NULL, NULL, 91063),
(91064, '3.10.20.90-FF-000193', NULL, 'Polycomb group RING finger protein 6', 93, NULL, NULL, 91064);
INSERT INTO "PUBLIC"."MODEL" VALUES
(91065, '3.30.200.20-FF-000218', NULL, 'Tyrosine-protein kinase RYK', 101, NULL, NULL, 91065),
(91066, '3.10.450.10-FF-000031', NULL, 'Histidine-rich glycoprotein', 113, NULL, NULL, 91066),
(91067, '1.20.1560.10-FF-000936', NULL, 'AFR432Wp', 626, NULL, NULL, 91067),
(91068, '1.10.287.160-FF-000001', NULL, 'Putative serine/threonine-protein kinase N2', 74, NULL, NULL, 91068),
(91069, '2.70.130.10-FF-000042', NULL, 'Uncharacterized protein', 124, NULL, NULL, 91069),
(91070, '2.60.40.150-FF-000022', NULL, 'Dedicator of cytokinesis protein 7', 177, NULL, NULL, 91070),
(91071, '1.10.287.1490-FF-000086', NULL, 'CENP-meta, isoform D', 181, NULL, NULL, 91071),
(91072, '2.60.120.200-FF-000479', NULL, 'Thrombospondin 4', 113, NULL, NULL, 91072),
(91073, '3.80.10.10-FF-003515', NULL, 'Uncharacterized protein', 176, NULL, NULL, 91073),
(91074, '3.20.20.140-FF-000228', NULL, 'Deoxyribonuclease YcfH', 256, NULL, NULL, 91074),
(91075, '3.20.20.80-FF-000807', NULL, 'AGAP005337-PA', 119, NULL, NULL, 91075),
(91076, '2.10.25.10-FF-000918', NULL, 'Eater', 34, NULL, NULL, 91076),
(91077, '3.40.50.2300-FF-001219', NULL, NULL, 177, NULL, NULL, 91077),
(91078, '3.40.50.300-FF-001874', NULL, 'GTP binding protein (EngB), putative', 181, NULL, NULL, 91078),
(91079, '3.40.50.150-FF-000356', NULL, 'tRNA m5C-methyltransferase, putative', 201, NULL, NULL, 91079),
(91080, '1.10.510.10-FF-004236', NULL, NULL, 203, NULL, NULL, 91080),
(91081, '2.60.40.1180-FF-000216', NULL, 'Alpha-xylosidase BoGH31A', 113, NULL, NULL, 91081),
(91082, '3.30.830.10-FF-000246', NULL, 'Uncharacterized protein', 202, NULL, NULL, 91082),
(91083, '2.40.10.10-FF-000001', NULL, 'Periplasmic serine protease DegS', 118, NULL, NULL, 91083),
(91084, '3.40.50.720-FF-000898', NULL, 'YDL144Cp protein', 199, NULL, NULL, 91084),
(91085, '1.10.150.50-FF-000089', NULL, 'Ankyrin repeat, SAM and basic leucine zipper domain-containing 1', 68, NULL, NULL, 91085),
(91086, '2.120.10.80-FF-000321', NULL, 'Lztr-1, putative', 159, NULL, NULL, 91086),
(91087, '2.130.10.10-FF-002711', NULL, 'UTP15 C terminal-domain-containing protein', 314, NULL, NULL, 91087),
(91088, '2.10.230.10-FF-000029', NULL, 'Uncharacterized protein', 61, NULL, NULL, 91088),
(91089, '3.80.10.10-FF-001424', NULL, 'Dynein regulatory complex subunit 6', 196, NULL, NULL, 91089),
(91090, '1.10.555.10-FF-000169', NULL, 'Probable inactive serine/threonine-protein kinase roco10', 271, NULL, NULL, 91090),
(91091, '1.20.1280.50-FF-000207', NULL, 'Uncharacterized protein', 58, NULL, NULL, 91091),
(91092, '3.10.100.10-FF-000044', NULL, 'CD209 antigen, isoform CRA_b', 179, NULL, NULL, 91092),
(91093, '2.60.120.920-FF-000077', NULL, 'Tripartite motif containing 75, pseudogene', 182, NULL, NULL, 91093),
(91094, '3.30.40.10-FF-001035', NULL, 'Polycomblike, isoform B', 80, NULL, NULL, 91094),
(91095, '3.30.470.30-FF-000033', NULL, 'DNA ligase', 226, NULL, NULL, 91095),
(91096, '1.10.1170.10-FF-000021', NULL, 'Bir1p', 122, NULL, NULL, 91096),
(91097, '3.20.20.70-FF-000097', NULL, 'Glutamate synthase, large subunit', 401, NULL, NULL, 91097),
(91098, '3.40.50.300-FF-002094', NULL, 'Structural maintenance of chromosomes protein 1', 224, NULL, NULL, 91098),
(91099, '1.10.10.10-FF-001893', NULL, 'Uncharacterized protein', 113, NULL, NULL, 91099),
(91100, '3.40.605.10-FF-000137', NULL, 'Uncharacterized protein', 66, NULL, NULL, 91100),
(91101, '2.40.70.10-FF-000162', NULL, 'Aspartic proteinase nepenthesin-1', 171, NULL, NULL, 91101),
(91102, '3.20.20.70-FF-000153', NULL, '4-hydroxy-2-oxoglutarate aldolase, mitochondrial isoform X1', 304, NULL, NULL, 91102),
(91103, '3.30.310.130-FF-000030', NULL, 'Uncharacterized protein', 59, NULL, NULL, 91103),
(91104, '1.10.472.10-FF-000364', NULL, 'Uncharacterized protein', 106, NULL, NULL, 91104),
(91105, '1.25.40.240-FF-000003', NULL, 'Endonuclease G inhibitor, isoform A', 147, NULL, NULL, 91105),
(91106, '2.60.120.200-FF-000102', NULL, 'Laminin subunit alpha 3', 152, NULL, NULL, 91106),
(91107, '2.60.120.920-FF-000133', NULL, 'Uncharacterized protein', 160, NULL, NULL, 91107);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(91108, '2.130.10.10-FF-002621', NULL, 'Uncharacterized protein', 263, NULL, NULL, 91108),
(91109, '2.60.120.10-FF-000740', NULL, 'Uncharacterized protein', 176, NULL, NULL, 91109),
(91110, '3.40.30.10-FF-000197', NULL, 'Glutathione S-transferase U10', 86, NULL, NULL, 91110),
(91111, '3.30.300.110-FF-000016', NULL, 'tRNA (Guanine(37)-N(1))-methyltransferase', 70, NULL, NULL, 91111),
(91112, '2.60.120.10-FF-000684', NULL, 'Predicted gene, 28042', 80, NULL, NULL, 91112),
(91113, '2.60.40.10-FF-006038', NULL, NULL, 101, NULL, NULL, 91113),
(91114, '2.170.150.10-FF-000002', NULL, 'Translationally-controlled tumor protein homolog', 168, NULL, NULL, 91114),
(91115, '1.20.1070.10-FF-001490', NULL, 'Uncharacterized protein', 332, NULL, NULL, 91115),
(91116, '3.30.1360.120-FF-000018', NULL, 'Aminomethyltransferase, mitochondrial', 151, NULL, NULL, 91116),
(91117, '1.25.40.10-FF-004008', NULL, 'Mitosis inhibitor nif1', 204, NULL, NULL, 91117),
(91118, '2.60.40.1730-FF-000044', NULL, 'Peptidase', 191, NULL, NULL, 91118),
(91119, '1.10.510.10-FF-003545', NULL, NULL, 233, NULL, NULL, 91119),
(91120, '2.20.90.10-FF-000001', NULL, 'Vitellogenin 7', 169, NULL, NULL, 91120),
(91121, '3.10.330.20-FF-000002', NULL, 'tRNA (adenine(58)-N(1))-methyltransferase catalytic subunit TRMT61A', 71, NULL, NULL, 91121),
(91122, '3.40.50.12390-FF-000007', NULL, 'XRN_5''-3''_exonuclease_N-terminus_-_putative', 185, NULL, NULL, 91122),
(91123, '1.20.58.2220-FF-000015', NULL, 'Diaphanous, isoform E', 295, NULL, NULL, 91123),
(91124, '1.20.1250.20-FF-000894', NULL, 'Multidrug MFS transporter', 250, NULL, NULL, 91124),
(91125, '1.20.1070.10-FF-001343', NULL, 'Uncharacterized protein', 272, NULL, NULL, 91125),
(91126, '1.25.40.10-FF-000265', NULL, 'Bardet-Biedl syndrome 4 (Human)', 187, NULL, NULL, 91126),
(91127, '3.30.590.10-FF-000002', NULL, 'Creatine kinase S-type, mitochondrial', 275, NULL, NULL, 91127),
(91128, '2.30.29.30-FF-000792', NULL, 'Non-specific serine/threonine protein kinase', 108, NULL, NULL, 91128),
(91129, '3.20.20.220-FF-000050', NULL, 'Proline dehydrogenase', 136, NULL, NULL, 91129),
(91130, '2.170.150.20-FF-000005', NULL, 'Blast:Protein cereblon homolog', 118, NULL, NULL, 91130),
(91131, '2.60.40.10-FF-002351', NULL, 'Interleukin 13 receptor, alpha 2', 107, NULL, NULL, 91131),
(91132, '3.40.190.10-FF-000402', NULL, 'ABC transporter, periplasmic substrate-binding protein', 154, NULL, NULL, 91132),
(91133, '2.10.110.10-FF-000054', NULL, 'Cysteine-rich protein 1', 75, NULL, NULL, 91133),
(91134, '2.120.10.80-FF-000411', NULL, 'Uncharacterized protein', 186, NULL, NULL, 91134),
(91135, '3.10.50.40-FF-000135', NULL, 'Peptidylprolyl isomerase', 105, NULL, NULL, 91135),
(91136, '3.10.28.10-FF-000001', NULL, 'Probable cell division protein WhiA', 211, NULL, NULL, 91136),
(91137, '3.40.50.1820-FF-001233', NULL, 'Uncharacterized protein', 338, NULL, NULL, 91137),
(91138, '1.10.287.110-FF-000121', NULL, 'Homeobox-containing protein', 132, NULL, NULL, 91138),
(91139, '3.40.50.10260-FF-000037', NULL, 'Uncharacterized protein', 178, NULL, NULL, 91139),
(91140, '1.25.40.20-FF-000268', NULL, 'Espin like', 75, NULL, NULL, 91140),
(91141, '3.20.20.60-FF-000150', NULL, 'Os01g0225400 protein', 105, NULL, NULL, 91141),
(91142, '2.10.70.10-FF-000141', NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing 1', 55, NULL, NULL, 91142),
(91143, '1.25.40.250-FF-000006', NULL, 'Eukaryotic translation initiation factor 3 subunit K', 34, NULL, NULL, 91143),
(91144, '3.20.20.70-FF-000568', NULL, 'Inosine-5''-monophosphate dehydrogenase', 477, NULL, NULL, 91144),
(91145, '3.80.10.10-FF-000929', NULL, 'AIR9 protein', 95, NULL, NULL, 91145),
(91146, '3.30.160.60-FF-000614', NULL, 'Zinc finger protein 142', 28, NULL, NULL, 91146),
(91147, '1.25.40.20-FF-000414', NULL, 'E3 ubiquitin-protein ligase XB3', 82, NULL, NULL, 91147),
(91148, '2.160.10.10-FF-000023', NULL, 'Mannose-1-phosphate guanyltransferase alpha (Predicted)', 149, NULL, NULL, 91148),
(91149, '3.80.10.10-FF-003335', NULL, 'Predicted protein', 123, NULL, NULL, 91149);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(91150, '2.20.28.230-FF-000011', NULL, NULL, 23, NULL, NULL, 91150),
(91151, '2.60.40.10-FF-006095', NULL, NULL, 57, NULL, NULL, 91151),
(91152, '3.80.10.10-FF-003279', NULL, 'Uncharacterized protein', 234, NULL, NULL, 91152),
(91153, '3.40.50.300-FF-007944', NULL, 'Predicted protein', 171, NULL, NULL, 91153),
(91154, '3.40.50.2300-FF-000202', NULL, 'Olfactory receptor family 13 subfamily C member 8', 276, NULL, NULL, 91154),
(91155, '3.30.70.330-FF-001248', NULL, 'Musashi RNA-binding protein 2a', 47, NULL, NULL, 91155),
(91156, '1.10.10.10-FF-001836', NULL, 'Histone acetyltransferase', 91, NULL, NULL, 91156),
(91157, '3.30.40.10-FF-001092', NULL, 'PHD type transcription factor with transmembrane domain protein (PTM)', 76, NULL, NULL, 91157),
(91158, '3.80.10.10-FF-004297', NULL, 'Leucine-rich repeats and immunoglobulin-like domains 3', 229, NULL, NULL, 91158),
(91159, '3.30.530.20-FF-000176', NULL, 'Predicted protein', 108, NULL, NULL, 91159),
(91160, '1.25.40.20-FF-000358', NULL, 'Oxysterol binding protein (Osh1), putative', 106, NULL, NULL, 91160),
(91161, '3.30.160.60-FF-002126', NULL, 'Si:dkey-7i4.21', 25, NULL, NULL, 91161),
(91162, '3.40.50.1820-FF-000867', NULL, 'Uncharacterized protein', 358, NULL, NULL, 91162),
(91163, '1.20.1270.60-FF-000238', NULL, 'Uncharacterized protein', 128, NULL, NULL, 91163),
(91164, '3.40.390.10-FF-000024', NULL, 'Matrix metallopeptidase 23B', 207, NULL, NULL, 91164),
(91165, '1.25.40.180-FF-000339', NULL, NULL, 180, NULL, NULL, 91165),
(91166, '3.30.590.20-FF-000005', NULL, 'Glutamate--cysteine ligase', 494, NULL, NULL, 91166),
(91167, '3.30.160.60-FF-002744', NULL, NULL, 31, NULL, NULL, 91167),
(91168, '2.130.10.10-FF-004420', NULL, 'Actin-related protein 2/3 complex subunit', 362, NULL, NULL, 91168),
(91169, '1.25.40.10-FF-003935', NULL, 'Predicted protein', 286, NULL, NULL, 91169),
(91170, '1.10.8.60-FF-000299', NULL, '26S protease regulatory subunit 8', 74, NULL, NULL, 91170),
(91171, '3.40.50.720-FF-000100', NULL, 'Glutamate dehydrogenase 1, mitochondrial', 295, NULL, NULL, 91171),
(91172, '2.60.40.1910-FF-000031', NULL, NULL, 86, NULL, NULL, 91172),
(91173, '3.30.70.3490-FF-000011', NULL, 'Oxysterol-binding protein', 119, NULL, NULL, 91173),
(91174, '3.30.450.20-FF-000698', NULL, 'Chemotaxis signal transduction system methyl accepting sensory transducer', 122, NULL, NULL, 91174),
(91175, '3.30.70.330-FF-001361', NULL, 'RNA-binding protein rnp24', 110, NULL, NULL, 91175),
(91176, '1.10.533.10-FF-000057', NULL, 'Tumor necrosis factor receptor superfamily member 6', 113, NULL, NULL, 91176),
(91177, '3.90.260.10-FF-000060', NULL, 'Uncharacterized protein', 286, NULL, NULL, 91177),
(91178, '3.10.620.30-FF-000016', NULL, 'Putative exported protein', 120, NULL, NULL, 91178),
(91179, '1.25.40.10-FF-003789', NULL, 'Predicted protein', 148, NULL, NULL, 91179),
(91180, '1.10.442.10-FF-000008', NULL, NULL, 69, NULL, NULL, 91180),
(91181, '3.30.360.10-FF-000047', NULL, 'Oxidoreductase, NAD-binding domain protein', 241, NULL, NULL, 91181),
(91182, '3.90.640.10-FF-000100', NULL, 'Putative actin-like protein', 50, NULL, NULL, 91182),
(91183, '3.40.50.300-FF-003583', NULL, 'Adenylate kinase 2', 215, NULL, NULL, 91183),
(91184, '1.25.40.10-FF-000355', NULL, 'Pentatricopeptide repeat-containing protein', 101, NULL, NULL, 91184),
(91185, '3.30.310.10-FF-000044', NULL, 'Coatomer subunit gamma', 73, NULL, NULL, 91185),
(91186, '2.60.40.150-FF-000550', NULL, 'C2 domain-containing protein', 210, NULL, NULL, 91186),
(91187, '1.10.533.10-FF-000242', NULL, 'Uncharacterized protein', 80, NULL, NULL, 91187),
(91188, '3.30.160.60-FF-006454', NULL, NULL, 37, NULL, NULL, 91188),
(91189, '3.30.1360.10-FF-000024', NULL, 'DNA-directed RNA polymerase II subunit RPB3', 87, NULL, NULL, 91189),
(91190, '3.30.40.10-FF-001125', NULL, 'Predicted protein', 64, NULL, NULL, 91190),
(91191, '2.60.40.10-FF-001946', NULL, 'Antigen WC1.1', 97, NULL, NULL, 91191),
(91192, '3.80.10.10-FF-002498', NULL, 'Leucine Rich Repeat family protein', 175, NULL, NULL, 91192),
(91193, '3.10.20.90-FF-000900', NULL, 'UBX domain protein 11', 127, NULL, NULL, 91193);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(91194, '3.40.50.300-FF-003150', NULL, 'Replication factor C small subunit', 54, NULL, NULL, 91194),
(91195, '3.30.70.240-FF-000030', NULL, 'Elongation factor G', 84, NULL, NULL, 91195),
(91196, '3.30.505.10-FF-000098', NULL, 'Phosphoinositide phospholipase C', 105, NULL, NULL, 91196),
(91197, '3.40.1170.10-FF-000007', NULL, 'DNA mismatch repair protein', 171, NULL, NULL, 91197),
(91198, '1.25.10.10-FF-002770', NULL, 'Uncharacterized protein', 590, NULL, NULL, 91198),
(91199, '3.30.9.10-FF-000159', NULL, 'Glycerol-3-phosphate dehydrogenase', 147, NULL, NULL, 91199),
(91200, '2.40.50.140-FF-000857', NULL, NULL, 58, NULL, NULL, 91200),
(91201, '3.40.50.1000-FF-000447', NULL, NULL, 67, NULL, NULL, 91201),
(91202, '1.10.10.10-FF-001983', NULL, 'Spi1 protein', 54, NULL, NULL, 91202),
(91203, '1.25.10.10-FF-003456', NULL, 'Uncharacterized protein', 201, NULL, NULL, 91203),
(91204, '3.30.420.10-FF-000249', NULL, 'Exonuclease 3''-5'' domain containing 3', 210, NULL, NULL, 91204),
(91205, '3.90.1110.10-FF-000003', NULL, 'DNA-directed RNA polymerase subunit beta', 176, NULL, NULL, 91205),
(91206, '2.60.40.60-FF-000101', NULL, 'FAT atypical cadherin 4', 103, NULL, NULL, 91206),
(91207, '2.30.30.870-FF-000001', NULL, 'Protein pelota homolog', 131, NULL, NULL, 91207),
(91208, '3.40.930.10-FF-000049', NULL, NULL, 143, NULL, NULL, 91208),
(91209, '3.30.930.10-FF-000389', NULL, 'Uncharacterized protein', 193, NULL, NULL, 91209),
(91210, '2.130.10.10-FF-002475', NULL, 'Predicted protein', 71, NULL, NULL, 91210),
(91211, '3.40.470.10-FF-000025', NULL, 'Type-4 uracil-DNA glycosylase', 192, NULL, NULL, 91211),
(91212, '1.20.1070.10-FF-001433', NULL, 'Olfactory receptor', 225, NULL, NULL, 91212),
(91213, '2.60.120.10-FF-000594', NULL, 'Uncharacterized protein', 170, NULL, NULL, 91213),
(91214, '1.20.5.170-FF-000256', NULL, 'Uncharacterized protein', 50, NULL, NULL, 91214),
(91215, '3.40.720.10-FF-000039', NULL, 'arylsulfatase K', 468, NULL, NULL, 91215),
(91216, '3.30.40.10-FF-000872', NULL, 'Irc20p', 106, NULL, NULL, 91216),
(91217, '3.40.630.10-FF-000212', NULL, 'Putative membrane protein', 246, NULL, NULL, 91217),
(91218, '1.25.40.10-FF-003845', NULL, 'Mitochondrial import receptor subunit tomm-70', 118, NULL, NULL, 91218),
(91219, '3.30.360.10-FF-000103', NULL, 'Uncharacterized protein C12C2.04', 220, NULL, NULL, 91219),
(91220, '1.20.1740.10-FF-000029', NULL, 'Putative amino acid permease', 423, NULL, NULL, 91220),
(91221, '1.10.287.3510-FF-000001', NULL, 'NADH-quinone oxidoreductase subunit K', 99, NULL, NULL, 91221),
(91222, '2.130.10.10-FF-004510', NULL, 'Ribosome biogenesis protein WDR12 homolog', 235, NULL, NULL, 91222),
(91223, '3.30.420.110-FF-000060', NULL, 'DNA mismatch repair protein MSH2', 173, NULL, NULL, 91223),
(91224, '1.10.20.10-FF-000320', NULL, NULL, 129, NULL, NULL, 91224),
(91225, '3.40.50.300-FF-005999', NULL, 'Uncharacterized protein', 205, NULL, NULL, 91225),
(91226, '1.10.10.10-FF-001275', NULL, 'O-methyltransferase family protein', 100, NULL, NULL, 91226),
(91227, '3.40.50.300-FF-002037', NULL, 'Putative DEAD/DEAH box ATP-dependent RNA helicase', 239, NULL, NULL, 91227),
(91228, '3.30.70.330-FF-001922', NULL, NULL, 150, NULL, NULL, 91228),
(91229, '1.20.930.40-FF-000003', NULL, 'Glutamate carboxypeptidase, putative', 159, NULL, NULL, 91229),
(91230, '3.90.1640.10-FF-000032', NULL, 'Uncharacterized protein', 99, NULL, NULL, 91230),
(91231, '2.60.40.640-FF-000040', NULL, 'Aly2p', 167, NULL, NULL, 91231),
(91232, '2.60.40.150-FF-000494', NULL, 'Protein kinase c conserved region 2', 145, NULL, NULL, 91232),
(91233, '3.30.1600.10-FF-000032', NULL, 'Uncharacterized protein', 52, NULL, NULL, 91233),
(91234, '1.25.40.10-FF-000411', NULL, 'pre-mRNA-splicing factor SYF1', 128, NULL, NULL, 91234),
(91235, '3.40.630.30-FF-000370', NULL, 'Acyl-CoA N-acyltransferase', 198, NULL, NULL, 91235),
(91236, '1.25.70.10-FF-000093', NULL, NULL, 269, NULL, NULL, 91236),
(91237, '3.30.70.980-FF-000072', NULL, 'Uncharacterized protein', 47, NULL, NULL, 91237),
(91238, '3.30.200.20-FF-000421', NULL, 'Serine/threonine-protein kinase receptor', 106, NULL, NULL, 91238);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(91239, '1.10.510.10-FF-000111', NULL, 'CDPK-related kinase 1', 188, NULL, NULL, 91239),
(91240, '3.30.160.60-FF-000704', NULL, 'zinc finger protein 169 isoform X2', 28, NULL, NULL, 91240),
(91241, '3.10.20.90-FF-000715', NULL, 'Ubiquitin domain-containing protein', 103, NULL, NULL, 91241),
(91242, '3.40.50.300-FF-002655', NULL, 'Dynein cytoplasmic 1 heavy chain 1', 157, NULL, NULL, 91242),
(91243, '2.160.10.10-FF-000113', NULL, 'Protein CBG00512', 97, NULL, NULL, 91243),
(91244, '2.130.10.10-FF-002508', NULL, 'Rho guanine nucleotide exchange factor (GEF) 10-like b', 334, NULL, NULL, 91244),
(91245, '3.20.20.70-FF-000658', NULL, NULL, 230, NULL, NULL, 91245),
(91246, '1.10.10.1100-FF-000018', NULL, 'Glycoprotein 64', 53, NULL, NULL, 91246),
(91247, '2.60.34.10-FF-000111', NULL, 'Cytosol-type hsp70', 178, NULL, NULL, 91247),
(91248, '1.10.730.10-FF-000037', NULL, 'Methionyl-tRNA synthetase', 154, NULL, NULL, 91248),
(91249, '1.10.3080.10-FF-000071', NULL, 'Uncharacterized protein', 134, NULL, NULL, 91249),
(91250, '3.40.30.10-FF-000382', NULL, 'Elongation factor 1-gamma (Ef-1-gamma), putative', 75, NULL, NULL, 91250),
(91251, '3.40.630.30-FF-000128', NULL, 'Acetyltransferase', 175, NULL, NULL, 91251),
(91252, '1.10.10.10-FF-000257', NULL, 'Transcriptional repressor CcpN', 61, NULL, NULL, 91252),
(91253, '2.30.30.490-FF-000067', NULL, 'Origin recognition complex subunit 1', 240, NULL, NULL, 91253),
(91254, '3.30.1520.10-FF-000121', NULL, 'Uncharacterized protein', 141, NULL, NULL, 91254),
(91255, '1.10.560.10-FF-000114', NULL, 'Uncharacterized protein', 243, NULL, NULL, 91255),
(91256, '1.10.10.10-FF-001926', NULL, 'ArsR family transcriptional regulatory protein', 93, NULL, NULL, 91256),
(91257, '2.60.40.640-FF-000130', NULL, 'Uncharacterized protein', 200, NULL, NULL, 91257),
(91258, '1.25.40.990-FF-000048', NULL, 'Uncharacterized protein', 269, NULL, NULL, 91258),
(91259, '1.20.1070.10-FF-000938', NULL, 'Uncharacterized protein', 285, NULL, NULL, 91259),
(91260, '1.10.30.10-FF-000146', NULL, 'Protein CBG08365', 83, NULL, NULL, 91260),
(91261, '3.30.420.10-FF-000491', NULL, NULL, 78, NULL, NULL, 91261),
(91262, '1.25.40.10-FF-004340', NULL, 'Putative ERAD-associated E3 ubiquitin-protein ligase component', 310, NULL, NULL, 91262),
(91263, '3.40.50.300-FF-004600', NULL, 'Replicase polyprotein 1ab', 129, NULL, NULL, 91263),
(91264, '2.60.40.10-FF-005875', NULL, NULL, 94, NULL, NULL, 91264),
(91265, '2.30.29.30-FF-000679', NULL, 'Nucleosome binding factor SPN, SPT16 subunit', 132, NULL, NULL, 91265),
(91266, '1.10.3110.10-FF-000012', NULL, 'Blr3003 protein', 82, NULL, NULL, 91266),
(91267, '1.10.287.110-FF-000211', NULL, 'DnaJ-like-60, isoform C', 89, NULL, NULL, 91267),
(91268, '3.20.20.60-FF-000094', NULL, 'Predicted protein', 282, NULL, NULL, 91268),
(91269, '2.40.50.100-FF-000132', NULL, 'Binding-protein-dependent transport system, ATP-binding component', 65, NULL, NULL, 91269),
(91270, '3.40.630.10-FF-000122', NULL, 'Membrane protein', 254, NULL, NULL, 91270),
(91271, '2.60.40.10-FF-002441', NULL, 'Twitchin', 99, NULL, NULL, 91271),
(91272, '3.90.110.10-FF-000015', NULL, 'L-lactate dehydrogenase', 169, NULL, NULL, 91272),
(91273, '3.40.1090.10-FF-000006', NULL, '85/88 kDa calcium-independent phospholipase A2', 337, NULL, NULL, 91273),
(91274, '3.30.530.20-FF-000086', NULL, 'Activator of Hsp90 ATPase, N-terminal/Activator of Hsp90 ATPase like protein, putative', 131, NULL, NULL, 91274),
(91275, '3.90.1030.20-FF-000005', NULL, 'Uncharacterized protein', 165, NULL, NULL, 91275),
(91276, '3.20.20.60-FF-000037', NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', 263, NULL, NULL, 91276),
(91277, '1.20.1610.10-FF-000019', NULL, 'Uncharacterized protein', 174, NULL, NULL, 91277),
(91278, '3.40.50.1100-FF-000275', NULL, 'Uncharacterized protein', 130, NULL, NULL, 91278),
(91279, '1.25.40.10-FF-002002', NULL, 'Crooked neck-like protein 1', 131, NULL, NULL, 91279),
(91280, '1.10.418.10-FF-000227', NULL, 'Rac guanine nucleotide exchange factor B', 107, NULL, NULL, 91280),
(91281, '1.10.520.10-FF-000027', NULL, 'Peroxidase', 11, NULL, NULL, 91281);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(91282, '3.30.230.70-FF-000128', NULL, 'Uncharacterized protein', 208, NULL, NULL, 91282),
(91283, '3.30.420.40-FF-000415', NULL, 'Possible d-xylulose kinase xylB', 216, NULL, NULL, 91283),
(91284, '3.30.70.3160-FF-000002', NULL, 'tRNA pseudouridine synthase D TruD', 81, NULL, NULL, 91284),
(91285, '1.10.10.10-FF-001831', NULL, 'Type III restriction enzyme, res subunit family protein', 96, NULL, NULL, 91285),
(91286, '3.30.70.1230-FF-000086', NULL, 'Adenylate cyclase type 10-like Protein', 211, NULL, NULL, 91286),
(91287, '1.10.357.120-FF-000017', NULL, 'Uncharacterized protein', 104, NULL, NULL, 91287),
(91288, '1.20.5.220-FF-000001', NULL, 'Rho GTPase activating protein 21', 22, NULL, NULL, 91288),
(91289, '3.40.50.1820-FF-001446', NULL, 'Putative lipase C4A8.10', 187, NULL, NULL, 91289),
(91290, '3.10.110.10-FF-000140', NULL, 'AGAP002223-PA', 127, NULL, NULL, 91290),
(91291, '1.25.40.10-FF-003576', NULL, 'Receptor-like histidine kinase BpdS', 181, NULL, NULL, 91291),
(91292, '2.130.10.10-FF-002155', NULL, 'Type II inositol polyphosphate 5-phosphatase 15', 138, NULL, NULL, 91292),
(91293, '3.40.50.300-FF-000418', NULL, 'Iron-sulfur cluster carrier protein', 254, NULL, NULL, 91293),
(91294, '3.40.50.1390-FF-000024', NULL, 'Recombinase family protein', 82, NULL, NULL, 91294),
(91295, '3.60.21.10-FF-000388', NULL, 'Serine/threonine protein phosphatase, putative', 66, NULL, NULL, 91295),
(91296, '1.25.10.10-FF-000297', NULL, 'Transportin-1', 850, NULL, NULL, 91296),
(91297, '3.10.580.10-FF-000068', NULL, 'DUF21 domain-containing protein At2g14520-like isoform X2', 37, NULL, NULL, 91297),
(91298, '3.40.50.300-FF-000356', NULL, 'DNA repair protein RecN', 283, NULL, NULL, 91298),
(91299, '3.60.21.10-FF-000293', NULL, 'Serine/threonine-protein phosphatase', 305, NULL, NULL, 91299),
(91300, '2.60.40.10-FF-002177', NULL, 'Receptor-type tyrosine-protein phosphatase C', 82, NULL, NULL, 91300),
(91301, '2.40.20.10-FF-000007', NULL, 'Hepatocyte growth factor', 93, NULL, NULL, 91301),
(91302, '3.40.50.300-FF-004690', NULL, 'Uncharacterized protein', 296, NULL, NULL, 91302),
(91303, '3.40.50.150-FF-000064', NULL, '2-methoxy-6-polyprenyl-1,4-benzoquinol methylase, mitochondrial', 239, NULL, NULL, 91303),
(91304, '1.10.238.10-FF-000455', NULL, 'Uncharacterized protein', 71, NULL, NULL, 91304),
(91305, '3.40.50.720-FF-002112', NULL, 'Short chain dehydrogenase reductase, putative', 119, NULL, NULL, 91305),
(91306, '2.130.10.10-FF-000064', NULL, 'Cleavage stimulation factor subunit 1', 172, NULL, NULL, 91306),
(91307, '3.10.440.10-FF-000007', NULL, 'Uncharacterized protein', 84, NULL, NULL, 91307),
(91308, '2.10.25.10-FF-000677', NULL, 'Wing blister, isoform B', 69, NULL, NULL, 91308),
(91309, '3.40.800.20-FF-000009', NULL, 'Histone deacetylase 11', 311, NULL, NULL, 91309),
(91310, '3.10.110.10-FF-000191', NULL, 'Ubiquitin-fold modifier-conjugating enzyme 1', 166, NULL, NULL, 91310),
(91311, '4.10.400.10-FF-000260', NULL, 'Complement component C9', 40, NULL, NULL, 91311),
(91312, '3.30.300.130-FF-000033', NULL, NULL, 88, NULL, NULL, 91312),
(91313, '2.130.10.10-FF-003841', NULL, 'DDB1-and CUL4-associated factor 10 homolog-like Protein', 293, NULL, NULL, 91313),
(91314, '3.80.20.20-FF-000023', NULL, 'LD35811p', 149, NULL, NULL, 91314),
(91315, '1.25.40.10-FF-003525', NULL, 'UTX (Ubiquitously transcribed TPR on X) homolog', 144, NULL, NULL, 91315),
(91316, '3.40.630.10-FF-000420', NULL, 'Predicted protein', 296, NULL, NULL, 91316),
(91317, '2.60.40.10-FF-005954', NULL, NULL, 90, NULL, NULL, 91317),
(91318, '2.70.130.10-FF-000132', NULL, NULL, 178, NULL, NULL, 91318),
(91319, '3.30.200.20-FF-000191', NULL, '3-phosphoinositide-dependent protein kinase 2-like', 86, NULL, NULL, 91319),
(91320, '3.30.160.60-FF-000535', NULL, 'Zinc finger protein 367', 32, NULL, NULL, 91320),
(91321, '1.20.1250.20-FF-000478', NULL, 'Molybdate-anion transporter', 390, NULL, NULL, 91321),
(91322, '1.50.40.10-FF-000139', NULL, 'Mitochondrial carrier protein', 255, NULL, NULL, 91322),
(91323, '2.40.70.10-FF-000044', NULL, 'Lysosomal aspartic protease', 164, NULL, NULL, 91323);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(91324, '3.90.79.10-FF-000031', NULL, 'Nudix hydrolase 16, mitochondrial', 157, NULL, NULL, 91324),
(91325, '3.90.550.50-FF-000111', NULL, 'Uncharacterized protein', 258, NULL, NULL, 91325),
(91326, '3.40.800.10-FF-000006', NULL, 'Agmatinase 1', 347, NULL, NULL, 91326),
(91327, '3.30.540.10-FF-000027', NULL, 'Fructose-1,6-bisphosphatase/inositol-1-monophosphatase', 141, NULL, NULL, 91327),
(91328, '2.40.50.690-FF-000022', NULL, 'Uncharacterized protein', 110, NULL, NULL, 91328),
(91329, '3.40.50.10140-FF-000086', NULL, 'Protein tirA', 131, NULL, NULL, 91329),
(91330, '1.10.580.10-FF-000036', NULL, 'Os11g0623601 protein', 34, NULL, NULL, 91330),
(91331, '1.10.10.60-FF-000053', NULL, 'H6 family homeobox 2', 70, NULL, NULL, 91331),
(91332, '2.130.10.10-FF-001492', NULL, 'Prolactin regulatory element-binding protein', 125, NULL, NULL, 91332),
(91333, '1.25.40.10-FF-001485', NULL, 'Putative pentatricopeptide repeat-containing protein At3g05240', 123, NULL, NULL, 91333),
(91334, '3.40.50.300-FF-002447', NULL, 'DnaA regulatory inactivator Hda', 164, NULL, NULL, 91334),
(91335, '3.40.50.300-FF-001879', NULL, 'Shikimate kinase', 156, NULL, NULL, 91335),
(91336, '2.40.290.10-FF-000026', NULL, 'ATP-dependent DNA helicase 2 subunit KU80', 203, NULL, NULL, 91336),
(91337, '3.40.630.150-FF-000004', NULL, 'Malonyl-CoA decarboxylase', 282, NULL, NULL, 91337),
(91338, '1.20.1640.10-FF-000061', NULL, 'Protein patched homolog 1', 184, NULL, NULL, 91338),
(91339, '3.90.440.10-FF-000006', NULL, 'Nitric oxide synthase', 41, NULL, NULL, 91339),
(91340, '3.40.630.30-FF-000364', NULL, 'AGAP011742-PA', 99, NULL, NULL, 91340),
(91341, '3.30.160.60-FF-000586', NULL, 'zinc finger protein 2 isoform X2', 26, NULL, NULL, 91341),
(91342, '1.10.510.10-FF-000055', NULL, 'Glycogen synthase kinase-3 beta', 247, NULL, NULL, 91342),
(91343, '2.130.10.10-FF-000390', NULL, 'THO complex subunit 3', 165, NULL, NULL, 91343),
(91344, '1.10.287.950-FF-000018', NULL, 'Methyl-accepting chemotaxis protein', 232, NULL, NULL, 91344),
(91345, '1.20.120.350-FF-000062', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 94, NULL, NULL, 91345),
(91346, '2.60.40.10-FF-003863', NULL, NULL, 124, NULL, NULL, 91346),
(91347, '3.30.70.330-FF-001574', NULL, NULL, 140, NULL, NULL, 91347),
(91348, '1.20.272.10-FF-000043', NULL, NULL, 96, NULL, NULL, 91348),
(91349, '4.10.1110.10-FF-000010', NULL, 'Zinc finger AN1 domain-containing stress-associated protein 12', 66, NULL, NULL, 91349),
(91350, '2.130.10.10-FF-005965', NULL, 'Uncharacterized protein', 243, NULL, NULL, 91350),
(91351, '2.130.10.10-FF-000710', NULL, 'U3 snoRNP protein', 317, NULL, NULL, 91351),
(91352, '3.30.9.10-FF-000226', NULL, 'Uncharacterized protein', 121, NULL, NULL, 91352),
(91353, '2.60.200.20-FF-000103', NULL, 'Protein kinase, putative', 114, NULL, NULL, 91353),
(91354, '3.30.160.60-FF-000209', NULL, 'Zinc finger protein 711', 60, NULL, NULL, 91354),
(91355, '1.10.510.10-FF-002179', NULL, NULL, 141, NULL, NULL, 91355),
(91356, '1.10.287.1490-FF-000081', NULL, 'Viral A-type inclusion protein, putative', 173, NULL, NULL, 91356),
(91357, '3.30.870.10-FF-000013', NULL, 'phospholipase D3 isoform X1', 159, NULL, NULL, 91357),
(91358, '2.60.40.1550-FF-000001', NULL, 'ORF8', 83, NULL, NULL, 91358),
(91359, '3.30.1960.10-FF-000019', NULL, 'Uncharacterized protein', 146, NULL, NULL, 91359),
(91360, '3.10.20.90-FF-000333', NULL, 'Ubiquitin-like protein ATG12', 91, NULL, NULL, 91360),
(91361, '1.10.10.10-FF-000145', NULL, 'LysR family transcriptional regulator', 83, NULL, NULL, 91361),
(91362, '3.40.50.740-FF-000027', NULL, 'Formate dehydrogenase molybdopterin-binding subunit FdhA', 298, NULL, NULL, 91362),
(91363, '3.90.230.10-FF-000018', NULL, 'Methionine aminopeptidase', 248, NULL, NULL, 91363),
(91364, '2.60.120.200-FF-000310', NULL, 'Chromosome 16, whole genome shotgun sequence', 285, NULL, NULL, 91364),
(91365, '3.90.550.10-FF-000565', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 79, NULL, NULL, 91365),
(91366, '3.30.1330.120-FF-000006', NULL, '2-methylcitrate dehydratase', 75, NULL, NULL, 91366);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(91367, '3.40.50.880-FF-000041', NULL, 'Glutamine amidotransferase subunit pdxT, putative', 199, NULL, NULL, 91367),
(91368, '3.40.50.720-FF-001595', NULL, 'Glutamate dehydrogenase', 189, NULL, NULL, 91368),
(91369, '2.10.25.10-FF-001441', NULL, 'Putative fibrillin 2', 46, NULL, NULL, 91369),
(91370, '2.30.30.380-FF-000039', NULL, 'Translation elongation factor EF1A/initiation factor IF2gamma family protein', 41, NULL, NULL, 91370),
(91371, '1.10.510.10-FF-002730', NULL, 'Probable serine/threonine-protein kinase DDB_G0279719', 255, NULL, NULL, 91371),
(91372, '3.30.310.130-FF-000029', NULL, 'Predicted protein', 68, NULL, NULL, 91372),
(91373, '1.20.1560.10-FF-000931', NULL, 'Uncharacterized protein', 29, NULL, NULL, 91373),
(91374, '1.25.10.10-FF-001399', NULL, 'INTegrator complex Subunit homolog', 200, NULL, NULL, 91374),
(91375, '3.30.160.60-FF-001103', NULL, 'Zinc finger protein 639', 57, NULL, NULL, 91375),
(91376, '3.30.70.330-FF-002142', NULL, NULL, 98, NULL, NULL, 91376),
(91377, '3.50.70.10-FF-000002', NULL, 'Chalcone-flavonone isomerase family protein', 144, NULL, NULL, 91377),
(91378, '2.90.10.10-FF-000066', NULL, 'Uncharacterized protein', 172, NULL, NULL, 91378),
(91379, '1.25.10.10-FF-002500', NULL, 'Uncharacterized protein', 201, NULL, NULL, 91379),
(91380, '2.60.120.820-FF-000013', NULL, 'Predicted protein', 163, NULL, NULL, 91380),
(91381, '3.30.420.40-FF-000320', NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', 32, NULL, NULL, 91381),
(91382, '2.120.10.30-FF-000323', NULL, 'Os10g0443000 protein', 53, NULL, NULL, 91382),
(91383, '1.10.287.110-FF-000273', NULL, 'Protein psi1', 166, NULL, NULL, 91383),
(91384, '3.10.20.90-FF-000721', NULL, 'Uncharacterized protein', 82, NULL, NULL, 91384),
(91385, '3.40.50.150-FF-000390', NULL, 'Short/branched chain specific acyl-CoA dehydrogenase', 212, NULL, NULL, 91385),
(91386, '3.30.2130.10-FF-000007', NULL, 'ACT domain-domain-containing protein', 146, NULL, NULL, 91386),
(91387, '1.20.200.10-FF-000012', NULL, 'Tyrosine ammonia-lyase', 309, NULL, NULL, 91387),
(91388, '1.10.630.10-FF-000586', NULL, 'Uncharacterized protein', 296, NULL, NULL, 91388),
(91389, '3.30.70.330-FF-000225', NULL, 'U2 snRNP auxiliary factor large subunit', 106, NULL, NULL, 91389),
(91390, '1.10.8.60-FF-000384', NULL, 'ATPase, AAA family', 89, NULL, NULL, 91390),
(91391, '3.40.50.1000-FF-000503', NULL, NULL, 151, NULL, NULL, 91391),
(91392, '1.10.472.80-FF-000076', NULL, 'Ubiquitin and WLM domain-containing protein', 122, NULL, NULL, 91392),
(91393, '1.10.357.20-FF-000026', NULL, 'Uncharacterized protein', 112, NULL, NULL, 91393),
(91394, '1.10.20.10-FF-000022', NULL, 'Histone H2A', 123, NULL, NULL, 91394),
(91395, '3.30.470.20-FF-000120', NULL, 'Uncharacterized protein', 127, NULL, NULL, 91395),
(91396, '3.30.40.10-FF-001187', NULL, 'RING/U-box superfamily protein', 75, NULL, NULL, 91396),
(91397, '2.130.10.10-FF-002481', NULL, 'Predicted protein', 201, NULL, NULL, 91397),
(91398, '1.25.10.10-FF-000151', NULL, 'AP complex subunit beta', 578, NULL, NULL, 91398),
(91399, '2.170.270.10-FF-000067', NULL, 'Uncharacterized protein, isoform D', 176, NULL, NULL, 91399),
(91400, '3.40.250.10-FF-000048', NULL, 'Thiosulfate sulfurtransferase', 126, NULL, NULL, 91400),
(91401, '3.40.50.300-FF-004364', NULL, 'Hypothetical_protein_-_conserved', 226, NULL, NULL, 91401),
(91402, '1.10.150.240-FF-000121', NULL, 'Putative phosphatase', 66, NULL, NULL, 91402),
(91403, '1.20.5.4770-FF-000021', NULL, 'Uncharacterized protein', 54, NULL, NULL, 91403),
(91404, '3.40.50.300-FF-003796', NULL, 'Endoribonuclease dcr-1', 182, NULL, NULL, 91404),
(91405, '2.10.50.10-FF-000139', NULL, 'CD40 molecule, TNF receptor superfamily member 5', 40, NULL, NULL, 91405),
(91406, '3.90.660.10-FF-000068', NULL, NULL, 234, NULL, NULL, 91406),
(91407, '3.30.70.80-FF-000052', NULL, 'Uncharacterized protein', 68, NULL, NULL, 91407),
(91408, '3.30.420.40-FF-000741', NULL, 'Putative actin-28', 109, NULL, NULL, 91408),
(91409, '1.25.40.800-FF-000003', NULL, 'CCR4-NOT transcription complex subunit 1,putative', 223, NULL, NULL, 91409);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(91410, '1.10.10.10-FF-000403', NULL, 'ArsR family transcriptional regulator', 99, NULL, NULL, 91410),
(91411, '1.50.40.10-FF-000353', NULL, 'Putative tricarboxylate secondary active transmembrane transporter', 71, NULL, NULL, 91411),
(91412, '3.40.630.10-FF-000206', NULL, 'AGAP002414-PA', 268, NULL, NULL, 91412),
(91413, '1.10.510.10-FF-002404', NULL, NULL, 152, NULL, NULL, 91413),
(91414, '3.30.1380.20-FF-000028', NULL, 'Trafficking protein particle complex subunit', 201, NULL, NULL, 91414),
(91415, '1.20.120.1750-FF-000084', NULL, 'RBR-type E3 ubiquitin transferase', 88, NULL, NULL, 91415),
(91416, '1.10.150.110-FF-000015', NULL, 'DNA polymerase X family', 88, NULL, NULL, 91416),
(91417, '3.20.20.70-FF-000299', NULL, 'NADPH dehydrogenase', 337, NULL, NULL, 91417),
(91418, '3.30.565.10-FF-000225', NULL, 'Signal transduction histidine kinase', 137, NULL, NULL, 91418),
(91419, '1.50.40.10-FF-000465', NULL, 'Carrier protein, putative', 79, NULL, NULL, 91419),
(91420, '3.20.20.140-FF-000464', NULL, 'Uncharacterized protein', 165, NULL, NULL, 91420),
(91421, '3.30.70.20-FF-000062', NULL, '4Fe-4S binding domain containing protein', 56, NULL, NULL, 91421),
(91422, '1.50.10.100-FF-000007', NULL, 'Chondroitin sulfate ABC exolyase', 413, NULL, NULL, 91422),
(91423, '3.50.50.60-FF-000965', NULL, 'Uncharacterized protein', 104, NULL, NULL, 91423),
(91424, '2.60.40.60-FF-000640', NULL, 'AGAP002828-PA', 103, NULL, NULL, 91424),
(91425, '3.30.70.330-FF-001748', NULL, 'Multiple RNA-binding domain-containing protein 1', 116, NULL, NULL, 91425),
(91426, '3.90.1300.10-FF-000012', NULL, 'Amidase AmiD', 448, NULL, NULL, 91426),
(91427, '2.60.40.1390-FF-000009', NULL, 'Myelin regulatory factor like', 108, NULL, NULL, 91427),
(91428, '3.40.920.10-FF-000021', NULL, NULL, 180, NULL, NULL, 91428),
(91429, '3.90.280.10-FF-000022', NULL, NULL, 156, NULL, NULL, 91429),
(91430, '3.40.630.70-FF-000005', NULL, 'Leucyl/phenylalanyl-tRNA--protein transferase', 177, NULL, NULL, 91430),
(91431, '3.40.718.10-FF-000011', NULL, 'Isocitrate dehydrogenase [NAD] subunit, mitochondrial', 352, NULL, NULL, 91431),
(91432, '3.30.160.60-FF-004543', NULL, NULL, 38, NULL, NULL, 91432),
(91433, '3.40.50.300-FF-005887', NULL, 'DNA helicase', 118, NULL, NULL, 91433),
(91434, '1.20.120.1760-FF-000087', NULL, NULL, 43, NULL, NULL, 91434),
(91435, '1.10.510.10-FF-003865', NULL, NULL, 97, NULL, NULL, 91435),
(91436, '1.10.238.10-FF-000781', NULL, 'AGAP002536-PA', 47, NULL, NULL, 91436),
(91437, '3.40.630.60-FF-000002', NULL, 'Ornithine decarboxylase antizyme 3', 136, NULL, NULL, 91437),
(91438, '1.10.287.1490-FF-000030', NULL, 'Bruchpilot, isoform L', 152, NULL, NULL, 91438),
(91439, '1.20.1280.50-FF-000202', NULL, 'Uncharacterized protein', 81, NULL, NULL, 91439),
(91440, '3.40.50.720-FF-001269', NULL, 'Probable 3-hydroxyisobutyrate dehydrogenase-like 1, mitochondrial', 166, NULL, NULL, 91440),
(91441, '3.40.30.10-FF-000764', NULL, 'Predicted protein', 178, NULL, NULL, 91441),
(91442, '1.10.565.10-FF-000193', NULL, 'DAX', 107, NULL, NULL, 91442),
(91443, '3.30.43.10-FF-000024', NULL, 'FAD dependent oxidoreductase', 103, NULL, NULL, 91443),
(91444, '1.10.1420.10-FF-000030', NULL, 'DNA mismatch repair protein MSH2', 99, NULL, NULL, 91444),
(91445, '3.40.50.1980-FF-000038', NULL, 'Iron compound ABC transporter, iron compound-binding protein', 82, NULL, NULL, 91445),
(91446, '3.40.50.300-FF-002335', NULL, 'SWI/SNF nucleosome remodeling complex component', 228, NULL, NULL, 91446),
(91447, '3.30.1130.10-FF-000007', NULL, 'GTP cyclohydrolase 1', 136, NULL, NULL, 91447),
(91448, '3.90.70.10-FF-000450', NULL, 'Calpain-like cysteine peptidase, putative', 124, NULL, NULL, 91448),
(91449, '1.10.510.10-FF-000313', NULL, 'Serine/threonine-protein kinase srk1', 195, NULL, NULL, 91449),
(91450, '1.10.8.60-FF-000333', NULL, 'Peroxisomal biogenesis factor 6', 102, NULL, NULL, 91450),
(91451, '1.10.1420.10-FF-000081', NULL, 'MutS-like protein', 165, NULL, NULL, 91451),
(91452, '3.40.630.30-FF-000690', NULL, 'Uncharacterized protein', 63, NULL, NULL, 91452),
(91453, '1.10.3730.20-FF-000017', NULL, 'Cation transporter protein', 118, NULL, NULL, 91453);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(91454, '2.30.42.10-FF-000131', NULL, 'membrane-associated guanylate kinase, WW and PDZ domain-containing protein 3 isoform X1', 112, NULL, NULL, 91454),
(91455, '3.40.33.10-FF-000057', NULL, 'Uncharacterized protein', 122, NULL, NULL, 91455),
(91456, '3.30.420.10-FF-000665', NULL, NULL, 183, NULL, NULL, 91456),
(91457, '1.10.620.20-FF-000032', NULL, 'Uncharacterized protein', 328, NULL, NULL, 91457),
(91458, '2.60.40.1510-FF-000034', NULL, 'Integrin beta', 111, NULL, NULL, 91458),
(91459, '1.10.1620.20-FF-000014', NULL, 'F1F0 ATP synthase epsilon subunit', 56, NULL, NULL, 91459),
(91460, '2.170.270.10-FF-000016', NULL, 'Histone-lysine N-methyltransferase', 275, NULL, NULL, 91460),
(91461, '1.25.10.10-FF-000090', NULL, 'eIF-2-alpha kinase activator GCN1', 164, NULL, NULL, 91461),
(91462, '1.10.8.60-FF-000479', NULL, 'Uncharacterized protein', 58, NULL, NULL, 91462),
(91463, '3.40.50.620-FF-000042', NULL, 'Isoleucine--tRNA ligase', 197, NULL, NULL, 91463),
(91464, '2.60.40.2440-FF-000010', NULL, 'GLC7-interacting protein 2', 133, NULL, NULL, 91464),
(91465, '3.30.160.60-FF-002952', NULL, 'Zinc finger protein 710b', 31, NULL, NULL, 91465),
(91466, '2.60.40.150-FF-000634', NULL, 'Synaptotagmin Ib', 136, NULL, NULL, 91466),
(91467, '2.60.40.10-FF-000086', NULL, 'Neural cell adhesion molecule 1', 87, NULL, NULL, 91467),
(91468, '2.40.128.20-FF-000046', NULL, 'Epididymal-specific lipocalin-5', 164, NULL, NULL, 91468),
(91469, '3.40.140.10-FF-000124', NULL, 'COP9 signalosome complex subunit 6', 203, NULL, NULL, 91469),
(91470, '3.30.70.1230-FF-000148', NULL, 'Adenylate cyclase type 10', 206, NULL, NULL, 91470),
(91471, '3.30.450.40-FF-000243', NULL, 'Phosphodiesterase', 191, NULL, NULL, 91471),
(91472, '2.10.25.10-FF-001492', NULL, 'Neurogenic locus notch homolog protein 1', 35, NULL, NULL, 91472),
(91473, '3.30.420.40-FF-000027', NULL, '78 kDa glucose-regulated', 143, NULL, NULL, 91473),
(91474, '1.20.58.340-FF-000071', NULL, 'Magnesium/cobalt transport protein', 127, NULL, NULL, 91474),
(91475, '1.25.10.10-FF-001657', NULL, 'MO25-like protein 3', 362, NULL, NULL, 91475),
(91476, '3.30.1370.240-FF-000005', NULL, 'Probable FRS2-phenylalanine--tRNA ligase beta chain, cytosolic', 69, NULL, NULL, 91476),
(91477, '1.10.560.10-FF-000092', NULL, 'Uncharacterized protein', 258, NULL, NULL, 91477),
(91478, '4.10.240.10-FF-000157', NULL, 'ScfA', 70, NULL, NULL, 91478),
(91479, '1.25.40.10-FF-001159', NULL, 'Putative pentatricopeptide repeat-containing protein At3g25060, mitochondrial', 89, NULL, NULL, 91479),
(91480, '1.25.40.10-FF-003929', NULL, 'Uncharacterized protein', 406, NULL, NULL, 91480),
(91481, '2.60.40.1120-FF-000007', NULL, 'Carboxypeptidase X, M14 family member 2', 96, NULL, NULL, 91481),
(91482, '2.60.40.10-FF-005903', NULL, NULL, 67, NULL, NULL, 91482),
(91483, '3.90.70.10-FF-000236', NULL, 'Cysteine protease, putative', 279, NULL, NULL, 91483),
(91484, '2.70.98.10-FF-000117', NULL, 'Alpha-glucosidase SusB', 262, NULL, NULL, 91484),
(91485, '1.10.3730.10-FF-000014', NULL, 'Pyrroline-5-carboxylate reductase', 104, NULL, NULL, 91485),
(91486, '3.80.10.10-FF-000935', NULL, 'Carboxypeptidase N subunit 2', 134, NULL, NULL, 91486),
(91487, '2.60.200.20-FF-000154', NULL, 'Uncharacterized protein', 94, NULL, NULL, 91487),
(91488, '3.40.50.880-FF-000103', NULL, 'PROBABLE TRANSCRIPTIONAL REGULATORY PROTEIN', 61, NULL, NULL, 91488),
(91489, '3.40.50.300-FF-007618', NULL, 'Guanylate kinase-like protein', 150, NULL, NULL, 91489),
(91490, '1.10.579.10-FF-000016', NULL, 'CPD photolyase type II', 36, NULL, NULL, 91490),
(91491, '3.30.360.10-FF-000081', NULL, 'Uncharacterized protein CaJ7.0133', 210, NULL, NULL, 91491),
(91492, '2.60.40.60-FF-000691', NULL, 'Fat-like cadherin-related tumor suppressor homolog', 104, NULL, NULL, 91492),
(91493, '1.25.40.10-FF-001838', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 159, NULL, NULL, 91493),
(91494, '2.60.40.1110-FF-000004', NULL, 'Voltage-sensor containing phosphatase', 141, NULL, NULL, 91494),
(91495, '1.10.630.10-FF-000474', NULL, 'Putative cytochrome P450 superfamily protein', 73, NULL, NULL, 91495);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(91496, '3.30.450.30-FF-000026', NULL, 'Protein SLM4', 132, NULL, NULL, 91496),
(91497, '3.30.1640.10-FF-000012', NULL, 'DNA helicase', 101, NULL, NULL, 91497),
(91498, '1.25.40.10-FF-001608', NULL, 'Ribonucleoprotein p18, mitochondrial,putative', 121, NULL, NULL, 91498),
(91499, '3.40.50.1820-FF-001272', NULL, 'Abhydrolase domain-containing protein C57A10.08c', 300, NULL, NULL, 91499),
(91500, '3.50.30.10-FF-000005', NULL, 'PTS-dependent dihydroxyacetone kinase, DhaM subunit', 85, NULL, NULL, 91500),
(91501, '2.40.10.10-FF-000147', NULL, 'Kallikrein related peptidase 12', 94, NULL, NULL, 91501),
(91502, '3.90.1720.10-FF-000038', NULL, 'Protein CBG04856', 72, NULL, NULL, 91502),
(91503, '1.20.1070.10-FF-001287', NULL, 'Uncharacterized protein', 158, NULL, NULL, 91503),
(91504, '2.10.25.10-FF-000598', NULL, 'Notch receptor 4', 37, NULL, NULL, 91504),
(91505, '1.10.472.10-FF-000420', NULL, 'D-type cyclin', 73, NULL, NULL, 91505),
(91506, '3.30.420.40-FF-000527', NULL, 'Actin like 6B', 54, NULL, NULL, 91506),
(91507, '2.130.10.10-FF-002267', NULL, 'Putative U5 snRNP-specific 40 kDa protein', 302, NULL, NULL, 91507),
(91508, '3.40.50.300-FF-002722', NULL, 'ATP-dependent DNA helicase (Eurofung)', 253, NULL, NULL, 91508),
(91509, '1.10.1200.260-FF-000003', NULL, 'Potassium voltage-gated channel subfamily H member 1', 41, NULL, NULL, 91509),
(91510, '3.90.700.10-FF-000010', NULL, 'L-aspartate oxidase', 110, NULL, NULL, 91510),
(91511, '3.30.365.10-FF-000070', NULL, 'Uncharacterized protein', 176, NULL, NULL, 91511),
(91512, '2.40.50.100-FF-000160', NULL, 'AT5G38890 protein', 51, NULL, NULL, 91512),
(91513, '2.30.39.10-FF-000045', NULL, 'Blast:Leukocyte elastase inhibitor', 140, NULL, NULL, 91513),
(91514, '3.80.10.10-FF-002638', NULL, 'Receptor like protein 41', 100, NULL, NULL, 91514),
(91515, '3.30.1330.30-FF-000146', NULL, 'Uncharacterized protein', 168, NULL, NULL, 91515),
(91516, '2.170.150.20-FF-000011', NULL, 'Peptide-methionine (R)-S-oxide reductase', 143, NULL, NULL, 91516),
(91517, '3.40.50.1010-FF-000248', NULL, NULL, 173, NULL, NULL, 91517),
(91518, '1.10.238.150-FF-000005', NULL, 'BNI1p Formin', 100, NULL, NULL, 91518),
(91519, '3.90.70.10-FF-000511', NULL, 'Uncharacterized protein', 91, NULL, NULL, 91519),
(91520, '1.20.58.80-FF-000039', NULL, 'Uncharacterized protein', 57, NULL, NULL, 91520),
(91521, '1.20.144.10-FF-000072', NULL, 'Uncharacterized protein', 272, NULL, NULL, 91521),
(91522, '1.20.1250.20-FF-001321', NULL, 'Solute carrier family 16, member 13 (monocarboxylic acid transporter 13)', 197, NULL, NULL, 91522),
(91523, '2.130.10.10-FF-000238', NULL, 'Nuclear pore complex protein Nup133', 410, NULL, NULL, 91523),
(91524, '1.10.3210.10-FF-000104', NULL, 'Uncharacterized protein', 80, NULL, NULL, 91524),
(91525, '3.60.21.10-FF-000181', NULL, 'Serine/threonine-protein phosphatase PP-Z, putative', 294, NULL, NULL, 91525),
(91526, '3.40.50.790-FF-000014', NULL, 'Mitochondrial Ribosomal Protein, Large', 94, NULL, NULL, 91526),
(91527, '2.60.40.10-FF-005780', NULL, NULL, 93, NULL, NULL, 91527),
(91528, '3.40.50.300-FF-000244', NULL, 'Midasin', 173, NULL, NULL, 91528),
(91529, '3.40.50.150-FF-000238', NULL, 'protein-L-isoaspartate(D-aspartate) O-methyltransferase isoform X3', 70, NULL, NULL, 91529),
(91530, '3.30.70.1230-FF-000209', NULL, 'Predicted protein', 141, NULL, NULL, 91530),
(91531, '1.10.10.60-FF-000227', NULL, 'LIM homeobox transcription factor', 65, NULL, NULL, 91531),
(91532, '4.10.400.10-FF-000372', NULL, 'EG:BACR25B3.2 protein', 49, NULL, NULL, 91532),
(91533, '3.30.200.20-FF-001551', NULL, 'Uncharacterized protein', 83, NULL, NULL, 91533),
(91534, '3.90.79.10-FF-000205', NULL, 'Uncharacterized protein', 126, NULL, NULL, 91534),
(91535, '3.40.50.200-FF-000091', NULL, 'Tripeptidyl peptidase SED3 (AFU_orthologue AFUA_3G08930)', 369, NULL, NULL, 91535),
(91536, '1.20.1110.10-FF-000094', NULL, 'Sarcoplasmic endoplasmic reticulum calcium atpase 2 isoform x1', 105, NULL, NULL, 91536),
(91537, '2.60.40.2030-FF-000044', NULL, 'Adhesion G protein-coupled receptor V1', 136, NULL, NULL, 91537);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(91538, '3.30.160.60-FF-000709', NULL, 'GDNF-inducible zinc finger protein 1', 28, NULL, NULL, 91538),
(91539, '3.30.200.20-FF-002017', NULL, 'Protein kinase domain protein', 93, NULL, NULL, 91539),
(91540, '2.40.50.790-FF-000001', NULL, 'Tudor, isoform B', 75, NULL, NULL, 91540),
(91541, '1.20.140.150-FF-000101', NULL, 'Uncharacterized protein', 206, NULL, NULL, 91541),
(91542, '2.60.40.10-FF-004094', NULL, NULL, 94, NULL, NULL, 91542),
(91543, '1.50.40.10-FF-000027', NULL, 'mitoferrin-2 isoform X1', 161, NULL, NULL, 91543),
(91544, '3.80.10.10-FF-001503', NULL, 'Os11g0197000 protein', 108, NULL, NULL, 91544),
(91545, '1.20.5.340-FF-000037', NULL, 'Polycystin 2 like 1, transient receptor potential cation channel', 47, NULL, NULL, 91545),
(91546, '2.60.40.60-FF-000073', NULL, 'protocadherin-7 isoform X1', 105, NULL, NULL, 91546),
(91547, '3.30.160.60-FF-004801', NULL, NULL, 32, NULL, NULL, 91547),
(91548, '3.30.450.40-FF-000029', NULL, 'PAS domain S-box', 187, NULL, NULL, 91548),
(91549, '1.10.30.10-FF-000028', NULL, 'WD repeat and HMG-box DNA-binding protein 1', 52, NULL, NULL, 91549),
(91550, '3.40.50.1100-FF-000207', NULL, 'Uncharacterized protein', 221, NULL, NULL, 91550),
(91551, '2.60.120.330-FF-000057', NULL, 'Oxidoreductase, 2OG-Fe(II) oxygenase family, putative', 305, NULL, NULL, 91551),
(91552, '3.30.160.60-FF-002452', NULL, 'zinc finger protein 142 isoform X4', 33, NULL, NULL, 91552),
(91553, '2.60.40.150-FF-000522', NULL, 'Uncharacterized protein', 125, NULL, NULL, 91553),
(91554, '3.40.50.1820-FF-001093', NULL, 'Uncharacterized protein', 141, NULL, NULL, 91554),
(91555, '3.90.70.10-FF-000562', NULL, 'Calpain 3', 82, NULL, NULL, 91555),
(91556, '1.20.120.350-FF-000236', NULL, NULL, 194, NULL, NULL, 91556),
(91557, '3.20.20.70-FF-000248', NULL, 'Lipoyl synthase, mitochondrial', 214, NULL, NULL, 91557),
(91558, '3.40.710.10-FF-000179', NULL, 'Uncharacterized protein', 338, NULL, NULL, 91558),
(91559, '1.10.510.10-FF-000493', NULL, 'serine/threonine-protein kinase unc-51 isoform X2', 189, NULL, NULL, 91559),
(91560, '2.60.40.1660-FF-000034', NULL, 'Sodium/potassium-dependent ATPase beta-2 subunit, putative', 78, NULL, NULL, 91560),
(91561, '3.40.50.300-FF-005269', NULL, 'ABL048Wp', 182, NULL, NULL, 91561),
(91562, '3.40.50.720-FF-001623', NULL, 'Os06g0251000 protein', 68, NULL, NULL, 91562),
(91563, '2.10.25.10-FF-000177', NULL, 'Adhesion G protein-coupled receptor E2', 48, NULL, NULL, 91563),
(91564, '3.30.450.200-FF-000008', NULL, 'DENN domain-containing protein 3', 132, NULL, NULL, 91564),
(91565, '1.20.1050.10-FF-000201', NULL, 'Uncharacterized protein', 71, NULL, NULL, 91565),
(91566, '3.30.530.20-FF-000024', NULL, 'Abscisic acid receptor PYL4', 189, NULL, NULL, 91566),
(91567, '1.10.1780.10-FF-000017', NULL, 'ATP-dependent Clp protease subunit, heat shock protein 100 (HSP100), putative', 142, NULL, NULL, 91567),
(91568, '2.60.40.1670-FF-000037', NULL, NULL, 54, NULL, NULL, 91568),
(91569, '3.10.20.90-FF-000507', NULL, 'Uncharacterized protein', 24, NULL, NULL, 91569),
(91570, '1.20.1410.10-FF-000038', NULL, 'Uncharacterized protein', 196, NULL, NULL, 91570),
(91571, '2.30.30.140-FF-000344', NULL, 'Histone acetyltransferase', 106, NULL, NULL, 91571),
(91572, '3.40.630.30-FF-000538', NULL, 'Histone acetyltransferase', 40, NULL, NULL, 91572),
(91573, '3.40.30.10-FF-000438', NULL, 'Grx8p', 109, NULL, NULL, 91573),
(91574, '1.20.58.1070-FF-000018', NULL, 'Survival of motor neuron protein-interacting protein yip12', 140, NULL, NULL, 91574),
(91575, '3.30.200.20-FF-002343', NULL, 'Uncharacterized protein', 155, NULL, NULL, 91575),
(91576, '3.40.30.10-FF-000825', NULL, 'Uncharacterized protein', 109, NULL, NULL, 91576),
(91577, '3.20.20.80-FF-000482', NULL, 'Glycoside hydrolase 35 family enzyme,exo-beta D-glucosaminidase, putative', 362, NULL, NULL, 91577),
(91578, '2.10.25.10-FF-001615', NULL, 'Notch 3', 84, NULL, NULL, 91578),
(91579, '3.40.1830.10-FF-000002', NULL, 'Aminopeptidase AmpS', 178, NULL, NULL, 91579),
(91580, '1.10.30.10-FF-000180', NULL, 'Uncharacterized protein', 70, NULL, NULL, 91580);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(91581, '2.102.10.10-FF-000009', NULL, 'Rieske Fe-S domain containing', 153, NULL, NULL, 91581),
(91582, '1.20.58.70-FF-000036', NULL, 'SNARE domain protein', 196, NULL, NULL, 91582),
(91583, '1.50.40.10-FF-000078', NULL, 'Mitochondrial DNA replication protein YHM2', 292, NULL, NULL, 91583),
(91584, '3.90.550.10-FF-000127', NULL, 'Probable glycosyltransferase 7', 188, NULL, NULL, 91584),
(91585, '2.10.25.10-FF-000738', NULL, 'neurogenic locus notch homolog protein 4', 36, NULL, NULL, 91585),
(91586, '3.40.50.10330-FF-000087', NULL, 'NAD kinase', 91, NULL, NULL, 91586),
(91587, '1.20.1420.30-FF-000022', NULL, 'sodium/potassium/calcium exchanger 2 isoform X4', 126, NULL, NULL, 91587),
(91588, '1.10.1450.10-FF-000150', NULL, 'Tetraspanin', 86, NULL, NULL, 91588),
(91589, '3.40.1090.10-FF-000040', NULL, 'Intracelllar PhosphoLipase A family', 340, NULL, NULL, 91589),
(91590, '3.40.50.880-FF-000215', NULL, '4-methyl-5(Beta-hydroxyethyl)-thiazole monophosphate synthesis protein', 180, NULL, NULL, 91590),
(91591, '1.20.58.60-FF-000033', NULL, 'Spectrin beta chain', 102, NULL, NULL, 91591),
(91592, '2.110.10.10-FF-000020', NULL, 'Hemopexin', 201, NULL, NULL, 91592),
(91593, '3.40.50.10810-FF-000135', NULL, 'Uncharacterized protein', 91, NULL, NULL, 91593),
(91594, '3.80.10.10-FF-002964', NULL, 'Uncharacterized protein', 60, NULL, NULL, 91594),
(91595, '3.40.50.300-FF-000295', NULL, 'Ras-related protein Rab7', 189, NULL, NULL, 91595),
(91596, '3.30.70.330-FF-003047', NULL, NULL, 196, NULL, NULL, 91596),
(91597, '3.30.160.60-FF-005499', NULL, NULL, 32, NULL, NULL, 91597),
(91598, '1.10.287.70-FF-000586', NULL, 'AGAP004923-PA', 194, NULL, NULL, 91598),
(91599, '3.40.50.1000-FF-000571', NULL, NULL, 93, NULL, NULL, 91599),
(91600, '1.10.472.10-FF-000162', NULL, 'Cyclin-l1 isoform x1', 93, NULL, NULL, 91600),
(91601, '3.60.15.10-FF-000003', NULL, 'Integrator complex subunit 11', 238, NULL, NULL, 91601),
(91602, '3.40.1500.10-FF-000016', NULL, 'Uncharacterized protein', 314, NULL, NULL, 91602),
(91603, '3.40.50.300-FF-000570', NULL, '6-phosphofructo-2-kinase/fructose-2, 6-bisphosphatase-like isoform X1', 208, NULL, NULL, 91603),
(91604, '2.110.10.10-FF-000071', NULL, 'Uncharacterized protein', 111, NULL, NULL, 91604),
(91605, '3.40.1810.10-FF-000006', NULL, 'Agamous-like MADS-box protein AGL62', 67, NULL, NULL, 91605),
(91606, '1.25.40.10-FF-003076', NULL, 'Anaphase promoting complex subunit 7, isoform A', 189, NULL, NULL, 91606),
(91607, '3.40.50.300-FF-006084', NULL, 'Os04g0620066 protein', 179, NULL, NULL, 91607),
(91608, '1.10.286.20-FF-000007', NULL, 'Elongation factor Ts', 26, NULL, NULL, 91608),
(91609, '3.10.450.10-FF-000070', NULL, 'Histidine-rich glycoprotein', 76, NULL, NULL, 91609),
(91610, '3.40.50.720-FF-001095', NULL, 'Saccharopine dehydrogenase, putative', 160, NULL, NULL, 91610),
(91611, '1.25.40.10-FF-002502', NULL, 'Predicted protein', 77, NULL, NULL, 91611),
(91612, '3.90.520.10-FF-000007', NULL, 'Mothers against decapentaplegic homolog', 93, NULL, NULL, 91612),
(91613, '3.90.79.10-FF-000082', NULL, 'NUDIX hydrolase', 166, NULL, NULL, 91613),
(91614, '1.10.10.2010-FF-000011', NULL, NULL, 38, NULL, NULL, 91614),
(91615, '1.10.150.50-FF-000229', NULL, 'Uncharacterized protein', 45, NULL, NULL, 91615),
(91616, '3.40.50.10470-FF-000050', NULL, 'Eukaryotic Initiation Factor', 200, NULL, NULL, 91616),
(91617, '3.30.70.3490-FF-000016', NULL, 'Oxysterol binding protein (Osh5)', 100, NULL, NULL, 91617),
(91618, '2.60.40.10-FF-000440', NULL, 'Bent, isoform C', 117, NULL, NULL, 91618),
(91619, '2.60.40.60-FF-000814', NULL, 'Cadherin-89D', 127, NULL, NULL, 91619),
(91620, '3.30.1020.10-FF-000004', NULL, 'Thiol-specific antioxidant protein 3', 64, NULL, NULL, 91620),
(91621, '2.40.50.100-FF-000008', NULL, 'V-type proton ATPase catalytic subunit A', 72, NULL, NULL, 91621),
(91622, '2.40.110.10-FF-000042', NULL, 'Acyl-CoA oxidase, putative', 131, NULL, NULL, 91622),
(91623, '1.10.510.10-FF-004321', NULL, NULL, 145, NULL, NULL, 91623),
(91624, '3.40.50.300-FF-001958', NULL, 'ATP binding cassette subfamily C member 11', 133, NULL, NULL, 91624);
INSERT INTO "PUBLIC"."MODEL" VALUES
(91625, '3.40.1090.10-FF-000091', NULL, 'Lysophospholipase', 518, NULL, NULL, 91625),
(91626, '1.10.630.10-FF-000614', NULL, 'Cytochrome P450, putative', 252, NULL, NULL, 91626),
(91627, '3.40.50.300-FF-005595', NULL, 'DNA replication licensing factor MCM7', 146, NULL, NULL, 91627),
(91628, '3.40.190.10-FF-000610', NULL, 'At1g31410', 132, NULL, NULL, 91628),
(91629, '1.20.120.1080-FF-000097', NULL, 'Uncharacterized protein', 154, NULL, NULL, 91629),
(91630, '3.40.30.10-FF-000876', NULL, 'Uncharacterized protein', 50, NULL, NULL, 91630),
(91631, '3.40.30.10-FF-000590', NULL, 'Alkyl hydroperoxide reductase/ Thiol specific antioxidant/ Mal allergen', 166, NULL, NULL, 91631),
(91632, '2.170.120.40-FF-000009', NULL, 'Putative secreted protein associated with spyDAC', 86, NULL, NULL, 91632),
(91633, '2.170.130.20-FF-000009', NULL, 'Zinc finger CCCH domain protein', 111, NULL, NULL, 91633),
(91634, '2.60.40.840-FF-000009', NULL, 'Predicted protein', 156, NULL, NULL, 91634),
(91635, '3.40.630.30-FF-000459', NULL, 'Acetyltransferase', 176, NULL, NULL, 91635),
(91636, '1.10.510.10-FF-001836', NULL, 'Protein kinase domain containing protein', 327, NULL, NULL, 91636),
(91637, '3.30.300.180-FF-000020', NULL, 'DNA polymerase III subunit gamma/tau', 82, NULL, NULL, 91637),
(91638, '3.40.50.2300-FF-001197', NULL, NULL, 137, NULL, NULL, 91638),
(91639, '2.60.40.10-FF-005454', NULL, NULL, 108, NULL, NULL, 91639),
(91640, '1.20.920.10-FF-000084', NULL, 'Bromodomain_-__putative', 121, NULL, NULL, 91640),
(91641, '3.40.250.10-FF-000099', NULL, '3-mercaptopyruvate sulfurtransferase', 155, NULL, NULL, 91641),
(91642, '1.10.510.10-FF-002112', NULL, 'AGAP004008-PA', 191, NULL, NULL, 91642),
(91643, '2.60.40.3780-FF-000001', NULL, 'L,D-transpeptidase 2', 95, NULL, NULL, 91643),
(91644, '2.170.130.10-FF-000006', NULL, 'FhuE outer membrane receptor', 143, NULL, NULL, 91644),
(91645, '3.40.120.10-FF-000095', NULL, 'Uncharacterized protein', 36, NULL, NULL, 91645),
(91646, '2.20.70.10-FF-000207', NULL, 'YALI0D02827p', 38, NULL, NULL, 91646),
(91647, '1.10.10.10-FF-000471', NULL, 'Transcriptional regulator, LysR family', 81, NULL, NULL, 91647),
(91648, '3.40.395.10-FF-000013', NULL, 'SUMO specific peptidase 6', 188, NULL, NULL, 91648),
(91649, '3.40.50.300-FF-002773', NULL, 'ATP-dependent helicase HRQ1', 243, NULL, NULL, 91649),
(91650, '3.30.420.10-FF-000373', NULL, NULL, 211, NULL, NULL, 91650),
(91651, '3.10.20.90-FF-000272', NULL, 'Serine/threonine-protein kinase STE11', 122, NULL, NULL, 91651),
(91652, '3.20.20.120-FF-000020', NULL, '4-hydroxyproline betaine 2-epimerase', 235, NULL, NULL, 91652),
(91653, '3.30.230.70-FF-000033', NULL, 'Exosome complex component RRP45', 281, NULL, NULL, 91653),
(91654, '3.40.50.300-FF-002161', NULL, 'Septin 1', 62, NULL, NULL, 91654),
(91655, '1.25.40.20-FF-001488', NULL, 'Uncharacterized protein', 84, NULL, NULL, 91655),
(91656, '3.30.160.60-FF-002626', NULL, 'Zinc finger protein 850', 30, NULL, NULL, 91656),
(91657, '2.60.120.920-FF-000138', NULL, 'Tripartite motif containing 69 protein', 180, NULL, NULL, 91657),
(91658, '3.40.630.30-FF-000252', NULL, 'Beta-N-acetylglucosaminidase, putative', 87, NULL, NULL, 91658),
(91659, '1.25.40.10-FF-003637', NULL, 'Tetratricopeptide repeat protein 21B', 115, NULL, NULL, 91659),
(91660, '2.170.210.10-FF-000007', NULL, 'DNA repair protein XRCC4', 123, NULL, NULL, 91660),
(91661, '3.30.890.10-FF-000008', NULL, 'Methyl-CpG-binding domain-containing protein 10', 74, NULL, NULL, 91661),
(91662, '3.40.50.2300-FF-000062', NULL, 'HTH-type transcriptional regulator GntR', 111, NULL, NULL, 91662),
(91663, '3.40.50.2300-FF-001422', NULL, NULL, 40, NULL, NULL, 91663),
(91664, '3.90.70.10-FF-000157', NULL, 'Ubiquitin carboxyl-terminal hydrolase 38', 206, NULL, NULL, 91664),
(91665, '3.90.550.10-FF-000453', NULL, 'Glycosyl transferase family 2', 239, NULL, NULL, 91665),
(91666, '3.10.20.90-FF-000221', NULL, 'Autophagy-related protein', 114, NULL, NULL, 91666),
(91667, '3.40.1810.10-FF-000057', NULL, NULL, 67, NULL, NULL, 91667),
(91668, '1.20.1110.10-FF-000268', NULL, NULL, 276, NULL, NULL, 91668);
INSERT INTO "PUBLIC"."MODEL" VALUES
(91669, '2.40.50.1060-FF-000027', NULL, 'Uncharacterized protein', 106, NULL, NULL, 91669),
(91670, '2.60.40.630-FF-000003', NULL, 'Signal transducer and transcription activator 6', 141, NULL, NULL, 91670),
(91671, '3.30.160.60-FF-000474', NULL, 'zinc finger protein 367', 30, NULL, NULL, 91671),
(91672, '3.30.160.60-FF-001396', NULL, 'Zinc finger protein 585A', 30, NULL, NULL, 91672),
(91673, '1.25.40.550-FF-000006', NULL, 'A1 cistron-splicing factor AAR2', 199, NULL, NULL, 91673),
(91674, '2.90.10.10-FF-000015', NULL, 'Serine/threonine-protein kinase', 119, NULL, NULL, 91674),
(91675, '3.10.20.90-FF-000428', NULL, 'Polyubiquitin-C', 84, NULL, NULL, 91675),
(91676, '2.130.10.10-FF-004184', NULL, 'Uncharacterized protein', 162, NULL, NULL, 91676),
(91677, '1.20.1510.10-FF-000023', NULL, 'Metal tolerance protein C1', 223, NULL, NULL, 91677),
(91678, '2.30.22.10-FF-000017', NULL, 'Uncharacterized protein', 55, NULL, NULL, 91678),
(91679, '3.50.30.30-FF-000163', NULL, 'Uncharacterized protein', 149, NULL, NULL, 91679),
(91680, '2.70.150.10-FF-000127', NULL, 'Cation transporting P-ATPase', 146, NULL, NULL, 91680),
(91681, '3.60.20.30-FF-000015', NULL, NULL, 157, NULL, NULL, 91681),
(91682, '2.10.90.10-FF-000136', NULL, 'Uncharacterized protein', 119, NULL, NULL, 91682),
(91683, '1.25.40.690-FF-000020', NULL, 'Predicted protein', 85, NULL, NULL, 91683),
(91684, '1.10.150.20-FF-000041', NULL, 'DNA-directed RNA polymerase', 203, NULL, NULL, 91684),
(91685, '3.80.10.10-FF-001278', NULL, 'Toll-like receptor 13', 96, NULL, NULL, 91685),
(91686, '2.60.40.10-FF-000165', NULL, 'MAM domain containing glycosylphosphatidylinositol anchor 2', 91, NULL, NULL, 91686),
(91687, '2.40.70.10-FF-000370', NULL, NULL, 206, NULL, NULL, 91687),
(91688, '3.30.160.60-FF-004190', NULL, NULL, 47, NULL, NULL, 91688),
(91689, '3.30.460.10-FF-000139', NULL, 'Uncharacterized protein', 115, NULL, NULL, 91689),
(91690, '3.90.105.20-FF-000006', NULL, 'Ribosome assembly factor mrt4', 74, NULL, NULL, 91690),
(91691, '2.60.40.150-FF-000342', NULL, 'Tcb3p', 134, NULL, NULL, 91691),
(91692, '2.80.10.50-FF-000045', NULL, 'Fascin', 109, NULL, NULL, 91692),
(91693, '2.130.10.10-FF-001699', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', 306, NULL, NULL, 91693),
(91694, '2.60.120.370-FF-000007', NULL, 'YhcH/YjgK/YiaL family protein', 150, NULL, NULL, 91694),
(91695, '3.30.9.10-FF-000277', NULL, 'Uncharacterized protein', 72, NULL, NULL, 91695),
(91696, '3.30.230.80-FF-000036', NULL, 'Heat shock protein 90-2', 75, NULL, NULL, 91696),
(91697, '3.30.565.10-FF-000551', NULL, 'Uncharacterized protein', 51, NULL, NULL, 91697),
(91698, '3.30.870.10-FF-000125', NULL, 'Tyrosyl-DNA Phosphodiesterase (Tdp1), putative', 304, NULL, NULL, 91698),
(91699, '3.30.40.10-FF-000231', NULL, 'RING-H2 finger protein ATL46', 91, NULL, NULL, 91699),
(91700, '3.60.20.40-FF-000018', NULL, 'Protein CBG11402', 175, NULL, NULL, 91700),
(91701, '3.90.105.10-FF-000003', NULL, 'Amino acid decarboxylase', 52, NULL, NULL, 91701),
(91702, '3.30.160.60-FF-006342', NULL, NULL, 25, NULL, NULL, 91702),
(91703, '3.10.20.90-FF-000833', NULL, 'Small ubiquitin-related modifier', 96, NULL, NULL, 91703),
(91704, '1.10.286.10-FF-000004', NULL, 'GTP cyclohydrolase 1', 50, NULL, NULL, 91704),
(91705, '3.90.1480.20-FF-000005', NULL, 'ST3 beta-galactoside alpha-2,3-sialyltransferase 4', 293, NULL, NULL, 91705),
(91706, '1.20.140.50-FF-000007', NULL, 'Protein CBR-ALX-1, isoform b', 183, NULL, NULL, 91706),
(91707, '1.20.1270.170-FF-000003', NULL, 'Stress response kinase A', 98, NULL, NULL, 91707),
(91708, '1.20.58.390-FF-000057', NULL, 'Resistance to dieldrin, isoform E', 123, NULL, NULL, 91708),
(91709, '3.30.160.60-FF-002385', NULL, 'Zinc finger protein', 27, NULL, NULL, 91709),
(91710, '3.90.190.10-FF-000548', NULL, 'Uncharacterized protein', 131, NULL, NULL, 91710),
(91711, '2.120.10.30-FF-000031', NULL, 'B-box type zinc finger protein ncl-1', 284, NULL, NULL, 91711),
(91712, '3.10.610.10-FF-000004', NULL, 'Type II secretion system protein J', 107, NULL, NULL, 91712);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(91713, '2.130.10.10-FF-005089', NULL, 'Uncharacterized protein', 260, NULL, NULL, 91713),
(91714, '2.60.300.12-FF-000032', NULL, NULL, 63, NULL, NULL, 91714),
(91715, '1.20.1070.10-FF-001219', NULL, 'GM15262', 144, NULL, NULL, 91715),
(91716, '3.30.1330.30-FF-000028', NULL, 'H/ACA ribonucleoprotein complex subunit 2-like protein', 122, NULL, NULL, 91716),
(91717, '2.60.120.920-FF-000189', NULL, 'Uncharacterized protein', 84, NULL, NULL, 91717),
(91718, '3.10.20.30-FF-000068', NULL, 'Ferredoxin reductase component of carbazole', 86, NULL, NULL, 91718),
(91719, '3.30.1330.20-FF-000025', NULL, '50S ribosomal protein L34', 123, NULL, NULL, 91719),
(91720, '2.30.30.70-FF-000003', NULL, '60S ribosomal protein L21', 68, NULL, NULL, 91720),
(91721, '3.40.50.2000-FF-000202', NULL, 'Glycosyltransferase', 201, NULL, NULL, 91721),
(91722, '3.30.40.10-FF-000113', NULL, 'Histone-lysine N-methyltransferase', 68, NULL, NULL, 91722),
(91723, '3.40.190.10-FF-000043', NULL, 'LysR family transcriptional regulator', 94, NULL, NULL, 91723),
(91724, '4.10.800.20-FF-000012', NULL, 'AMP deaminase, putative', 41, NULL, NULL, 91724),
(91725, '3.50.50.60-FF-001078', NULL, 'Succinate dehydrogenase [ubiquinone] flavoprotein subunit, mitochondrial', 302, NULL, NULL, 91725),
(91726, '2.60.40.10-FF-004026', NULL, NULL, 98, NULL, NULL, 91726),
(91727, '2.60.40.60-FF-000247', NULL, 'Protocadherin 12', 142, NULL, NULL, 91727),
(91728, '3.30.1330.10-FF-000022', NULL, 'Selenide water dikinase, putative', 169, NULL, NULL, 91728),
(91729, '3.30.200.20-FF-000426', NULL, 'Serine/threonine-protein kinase ssn3', 93, NULL, NULL, 91729),
(91730, '1.20.120.790-FF-000019', NULL, 'Chaperone protein HtpG', 135, NULL, NULL, 91730),
(91731, '3.40.50.720-FF-001320', NULL, 'Uncharacterized protein', 41, NULL, NULL, 91731),
(91732, '2.60.40.60-FF-000191', NULL, 'Cadherin 1', 88, NULL, NULL, 91732),
(91733, '3.30.1360.70-FF-000019', NULL, 'Arginyl-tRNA synthetase', 114, NULL, NULL, 91733),
(91734, '1.25.40.990-FF-000054', NULL, 'Uncharacterized protein', 283, NULL, NULL, 91734),
(91735, '3.30.160.60-FF-000827', NULL, 'Zinc finger protein Gfi-1', 29, NULL, NULL, 91735),
(91736, '3.50.50.60-FF-001128', NULL, 'Predicted protein', 121, NULL, NULL, 91736),
(91737, '2.130.10.10-FF-004633', NULL, 'Uncharacterized protein', 342, NULL, NULL, 91737),
(91738, '2.60.40.2440-FF-000009', NULL, 'Protein interacting with gsy2p', 159, NULL, NULL, 91738),
(91739, '1.10.10.10-FF-001477', NULL, 'Protein CBG12577', 83, NULL, NULL, 91739),
(91740, '2.60.40.10-FF-005662', NULL, NULL, 88, NULL, NULL, 91740),
(91741, '2.60.40.60-FF-000253', NULL, 'Cadherin 16, KSP-cadherin', 103, NULL, NULL, 91741),
(91742, '1.10.533.10-FF-000118', NULL, 'TUBE', 135, NULL, NULL, 91742),
(91743, '4.10.365.10-FF-000008', NULL, 'CKI family (Cyclin-dependent Kinase Inhibitor)', 84, NULL, NULL, 91743),
(91744, '1.25.10.10-FF-000701', NULL, 'V-type proton ATPase subunit H', 309, NULL, NULL, 91744),
(91745, '3.10.310.10-FF-000060', NULL, 'Uncharacterized protein', 106, NULL, NULL, 91745),
(91746, '3.40.50.10700-FF-000006', NULL, 'Os09g0248000 protein', 75, NULL, NULL, 91746),
(91747, '1.25.40.10-FF-000153', NULL, 'Transmembrane and tetratricopeptide repeat containing 2', 163, NULL, NULL, 91747),
(91748, '1.10.10.1080-FF-000001', NULL, 'Stn1p', 89, NULL, NULL, 91748),
(91749, '3.30.930.10-FF-000243', NULL, 'Uncharacterized protein', 205, NULL, NULL, 91749),
(91750, '1.20.5.190-FF-000054', NULL, 'Calmodulin-binding transcription activator 4', 53, NULL, NULL, 91750),
(91751, '1.20.5.4010-FF-000001', NULL, 'protein quaking isoform X1', 55, NULL, NULL, 91751),
(91752, '4.10.410.10-FF-000086', NULL, 'IP13257p', 53, NULL, NULL, 91752),
(91753, '1.10.3370.10-FF-000048', NULL, 'Uncharacterized protein', 95, NULL, NULL, 91753),
(91754, '3.10.129.10-FF-000003', NULL, '3-hydroxydecanoyl-[acyl-carrier-protein] dehydratase', 172, NULL, NULL, 91754),
(91755, '3.40.50.300-FF-000648', NULL, 'Stage IV sporulation protein A', 215, NULL, NULL, 91755),
(91756, '3.80.10.10-FF-003077', NULL, 'Uncharacterized protein', 131, NULL, NULL, 91756);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(91757, '3.40.1710.10-FF-000004', NULL, 'Multidrug ABC transporter ATP-binding protein', 134, NULL, NULL, 91757),
(91758, '3.30.830.10-FF-000128', NULL, 'Phosphoglycan beta 1,3 galactosyltransferase 5', 230, NULL, NULL, 91758),
(91759, '3.30.450.90-FF-000022', NULL, 'Type 4 pili biogenesis protein (Nuleotide-binding protein)', 123, NULL, NULL, 91759),
(91760, '1.20.140.40-FF-000004', NULL, 'Pectinesterase', 152, NULL, NULL, 91760),
(91761, '1.25.40.20-FF-000156', NULL, 'ankyrin repeat and KH domain-containing protein 1-like isoform X6', 82, NULL, NULL, 91761),
(91762, '3.20.20.80-FF-000689', NULL, 'Chitinase-like protein PB1E7.04c', 307, NULL, NULL, 91762),
(91763, '1.10.630.10-FF-000827', NULL, 'Uncharacterized protein', 215, NULL, NULL, 91763),
(91764, '3.40.50.150-FF-000682', NULL, 'Ribosomal RNA small subunit methyltransferase G', 203, NULL, NULL, 91764),
(91765, '6.10.140.2200-FF-000001', NULL, 'Cbp/p300-interacting transactivator 2 isoform 1', 50, NULL, NULL, 91765),
(91766, '2.130.10.10-FF-004004', NULL, 'AGL156Wp', 227, NULL, NULL, 91766),
(91767, '2.60.40.150-FF-000404', NULL, 'Phosphoinositide phospholipase C', 135, NULL, NULL, 91767),
(91768, '1.10.455.10-FF-000021', NULL, 'Uncharacterized protein', 154, NULL, NULL, 91768),
(91769, '2.30.180.10-FF-000138', NULL, NULL, 161, NULL, NULL, 91769),
(91770, '2.30.29.30-FF-000033', NULL, 'Rho-associated protein kinase 2', 109, NULL, NULL, 91770),
(91771, '3.20.20.70-FF-000366', NULL, 'Hyaluronidase', 321, NULL, NULL, 91771),
(91772, '1.10.15.40-FF-000002', NULL, 'Periplasmic [Fe] hydrogenase', 58, NULL, NULL, 91772),
(91773, '1.25.70.10-FF-000031', NULL, 'Transcription termination factor MTERF2 chloroplastic', 226, NULL, NULL, 91773),
(91774, '3.90.1410.10-FF-000015', NULL, 'Ribosomal lysine N-methyltransferase 4', 257, NULL, NULL, 91774),
(91775, '1.10.510.10-FF-001387', NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', 218, NULL, NULL, 91775),
(91776, '2.60.120.330-FF-000175', NULL, 'Uncharacterized protein', 242, NULL, NULL, 91776),
(91777, '1.10.3380.30-FF-000032', NULL, 'Uncharacterized protein', 224, NULL, NULL, 91777),
(91778, '3.80.10.10-FF-001003', NULL, 'Os03g0228800 protein', 160, NULL, NULL, 91778),
(91779, '2.60.40.10-FF-005549', NULL, NULL, 117, NULL, NULL, 91779),
(91780, '1.10.533.10-FF-000175', NULL, 'Apoptotic protease-activating factor, putative', 97, NULL, NULL, 91780),
(91781, '3.60.20.10-FF-000268', NULL, NULL, 127, NULL, NULL, 91781),
(91782, '3.20.20.120-FF-000014', NULL, 'Enolase', 297, NULL, NULL, 91782),
(91783, '2.40.20.10-FF-000092', NULL, 'Plasminogen activator, urokinase a', 104, NULL, NULL, 91783),
(91784, '3.50.4.10-FF-000030', NULL, 'Protein CBR-NOAH-2', 80, NULL, NULL, 91784),
(91785, '1.25.40.10-FF-003817', NULL, 'Predicted protein', 134, NULL, NULL, 91785),
(91786, '2.40.50.90-FF-000196', NULL, 'Uncharacterized protein', 55, NULL, NULL, 91786),
(91787, '3.40.50.300-FF-006163', NULL, 'Ras family protein', 212, NULL, NULL, 91787),
(91788, '2.60.200.20-FF-000042', NULL, 'Kinesin-like protein Klp98A', 109, NULL, NULL, 91788),
(91789, '3.20.20.70-FF-000653', NULL, NULL, 234, NULL, NULL, 91789),
(91790, '3.30.160.60-FF-000148', NULL, 'zinc finger protein Gfi-1', 30, NULL, NULL, 91790),
(91791, '2.10.90.10-FF-000024', NULL, 'Inhibin alpha chain', 114, NULL, NULL, 91791),
(91792, '1.10.443.20-FF-000002', NULL, 'Transposable element-crypton-Cn1, putative', 350, NULL, NULL, 91792),
(91793, '3.30.200.20-FF-001904', NULL, 'Uncharacterized protein', 83, NULL, NULL, 91793),
(91794, '2.30.110.10-FF-000095', NULL, 'Uncharacterized protein', 172, NULL, NULL, 91794),
(91795, '3.40.1110.10-FF-000436', NULL, NULL, 16, NULL, NULL, 91795),
(91796, '2.30.30.90-FF-000009', NULL, 'FeoA family protein', 78, NULL, NULL, 91796),
(91797, '3.40.50.300-FF-004460', NULL, 'Small GTP-binding protein', 164, NULL, NULL, 91797),
(91798, '3.30.160.60-FF-002008', NULL, 'Zinc finger protein 684', 34, NULL, NULL, 91798),
(91799, '1.10.730.10-FF-000032', NULL, 'Leucine--tRNA ligase, putative', 162, NULL, NULL, 91799),
(91800, '2.80.10.50-FF-000253', NULL, 'Fascin', 118, NULL, NULL, 91800);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(91801, '2.60.40.1850-FF-000001', NULL, 'Heme uptake protein IsdC', 125, NULL, NULL, 91801),
(91802, '3.40.120.10-FF-000044', NULL, 'Phosphoglucomutase', 200, NULL, NULL, 91802),
(91803, '3.90.730.10-FF-000012', NULL, 'Uncharacterized protein', 216, NULL, NULL, 91803),
(91804, '1.10.238.10-FF-000163', NULL, 'Calmodulin like 6', 76, NULL, NULL, 91804),
(91805, '2.60.260.20-FF-000045', NULL, 'DnaJ protein, putative', 67, NULL, NULL, 91805),
(91806, '2.40.50.150-FF-000045', NULL, 'RNA polymerase II second largest subunit (RPB2), putative', 77, NULL, NULL, 91806),
(91807, '3.30.40.10-FF-001248', NULL, 'Ring finger protein 180', 116, NULL, NULL, 91807),
(91808, '3.30.930.10-FF-000338', NULL, 'Class II aminoacyl-tRNA and biotin synthetases superfamily protein', 104, NULL, NULL, 91808),
(91809, '2.40.30.10-FF-000159', NULL, 'Translation elongation factor alpha', 108, NULL, NULL, 91809),
(91810, '1.50.10.150-FF-000011', NULL, 'Uncharacterized protein', 326, NULL, NULL, 91810),
(91811, '1.10.390.10-FF-000106', NULL, 'Predicted protein', 250, NULL, NULL, 91811),
(91812, '2.130.10.10-FF-000682', NULL, 'Actin-related protein 2/3 complex subunit', 375, NULL, NULL, 91812),
(91813, '1.20.120.1750-FF-000112', NULL, 'RBR-type E3 ubiquitin transferase', 78, NULL, NULL, 91813),
(91814, '1.10.1420.10-FF-000142', NULL, 'Him-14', 234, NULL, NULL, 91814),
(91815, '3.40.50.300-FF-004072', NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', 155, NULL, NULL, 91815),
(91816, '1.10.1750.10-FF-000009', NULL, 'Chromosomal replication initiator protein DnaA', 101, NULL, NULL, 91816),
(91817, '3.10.100.10-FF-000246', NULL, NULL, 100, NULL, NULL, 91817),
(91818, '2.20.25.10-FF-000036', NULL, 'Transcription initiation factor IIB', 56, NULL, NULL, 91818),
(91819, '3.40.50.2300-FF-001489', NULL, NULL, 131, NULL, NULL, 91819),
(91820, '1.10.150.780-FF-000013', NULL, 'Probable vacuolar protein sorting-associated protein 16 homolog', 91, NULL, NULL, 91820),
(91821, '3.40.50.300-FF-000862', NULL, 'Eukaryotic peptide chain release factor GTP-binding subunit ERF3A', 245, NULL, NULL, 91821),
(91822, '3.30.559.30-FF-000048', NULL, 'Nonribosomal peptide synthase GliP2', 224, NULL, NULL, 91822),
(91823, '2.40.160.20-FF-000025', NULL, 'Omp-1X', 168, NULL, NULL, 91823),
(91824, '3.40.50.1820-FF-001480', NULL, 'Uncharacterized protein', 170, NULL, NULL, 91824),
(91825, '1.10.510.10-FF-002180', NULL, NULL, 120, NULL, NULL, 91825),
(91826, '3.40.720.10-FF-000298', NULL, 'Predicted protein', 240, NULL, NULL, 91826),
(91827, '3.10.310.20-FF-000006', NULL, 'Manganese-dependent inorganic pyrophosphatase', 114, NULL, NULL, 91827),
(91828, '2.60.40.10-FF-000614', NULL, 'Bent, isoform H', 93, NULL, NULL, 91828),
(91829, '2.60.120.1440-FF-000007', NULL, 'Probable transmembrane sensor', 144, NULL, NULL, 91829),
(91830, '3.30.750.24-FF-000040', NULL, 'Anion transporter SULP-4', 141, NULL, NULL, 91830),
(91831, '3.40.50.300-FF-006258', NULL, 'Uncharacterized protein', 129, NULL, NULL, 91831),
(91832, '3.90.1170.20-FF-000015', NULL, 'Nicotinate-nucleotide pyrophosphorylase [carboxylating]', 112, NULL, NULL, 91832),
(91833, '3.20.20.10-FF-000034', NULL, 'Alanine racemase', 208, NULL, NULL, 91833),
(91834, '2.20.25.110-FF-000001', NULL, 'Cypemycin methyltransferase', 52, NULL, NULL, 91834),
(91835, '2.60.40.150-FF-000016', NULL, 'Synaptotagmin 1', 139, NULL, NULL, 91835),
(91836, '2.60.40.1860-FF-000004', NULL, 'Peptidyl arginine deiminase 6', 124, NULL, NULL, 91836),
(91837, '4.10.640.10-FF-000007', NULL, '28S ribosomal protein S18c, mitochondrial', 63, NULL, NULL, 91837),
(91838, '2.40.160.10-FF-000022', NULL, 'Porin', 284, NULL, NULL, 91838),
(91839, '3.40.30.10-FF-001040', NULL, 'Thyroxine 5''-deiodinase', 194, NULL, NULL, 91839),
(91840, '2.30.29.30-FF-001281', NULL, 'Uncharacterized protein', 94, NULL, NULL, 91840),
(91841, '3.20.20.140-FF-000352', NULL, 'Predicted protein', 313, NULL, NULL, 91841),
(91842, '3.80.10.10-FF-003420', NULL, 'Uncharacterized protein', 79, NULL, NULL, 91842),
(91843, '3.90.980.20-FF-000033', NULL, NULL, 84, NULL, NULL, 91843);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(91844, '2.170.120.30-FF-000012', NULL, 'Putative exported protein', 87, NULL, NULL, 91844),
(91845, '2.30.30.140-FF-000277', NULL, 'Protein CBG13704', 72, NULL, NULL, 91845),
(91846, '3.30.160.60-FF-005886', NULL, NULL, 32, NULL, NULL, 91846),
(91847, '1.10.30.10-FF-000062', NULL, 'Hmg-1.1', 69, NULL, NULL, 91847),
(91848, '1.10.510.10-FF-004242', NULL, NULL, 199, NULL, NULL, 91848),
(91849, '2.60.120.260-FF-000300', NULL, 'Trypsin-like serine protease', 156, NULL, NULL, 91849),
(91850, '1.20.1250.20-FF-002102', NULL, 'Uncharacterized protein', 241, NULL, NULL, 91850),
(91851, '3.30.40.10-FF-001541', NULL, 'Putative e3 ubiquitin-protein ligase ubr7', 62, NULL, NULL, 91851),
(91852, '1.20.1070.10-FF-002001', NULL, 'Uncharacterized protein', 143, NULL, NULL, 91852),
(91853, '2.130.10.10-FF-002216', NULL, 'Protein HIRA', 101, NULL, NULL, 91853),
(91854, '3.30.1050.10-FF-000040', NULL, 'Non-specific lipid-transfer protein', 119, NULL, NULL, 91854),
(91855, '3.40.50.300-FF-003678', NULL, 'Adenylate/guanylate cyclase domain-containing protein', 198, NULL, NULL, 91855),
(91856, '1.10.530.10-FF-000090', NULL, 'lysozyme g', 154, NULL, NULL, 91856),
(91857, '1.10.555.10-FF-000074', NULL, 'RhoGAP GTPase, putative', 232, NULL, NULL, 91857),
(91858, '3.50.50.60-FF-001342', NULL, 'Uncharacterized protein', 126, NULL, NULL, 91858),
(91859, '1.25.40.10-FF-005088', NULL, 'Uncharacterized protein', 79, NULL, NULL, 91859),
(91860, '3.20.20.80-FF-000369', NULL, 'Zgc:66313', 244, NULL, NULL, 91860),
(91861, '1.10.510.10-FF-000931', NULL, 'Ballchen, isoform B', 401, NULL, NULL, 91861),
(91862, '3.30.565.10-FF-000045', NULL, 'Two-component sensor histidine kinase', 158, NULL, NULL, 91862),
(91863, '2.60.40.10-FF-000491', NULL, 'Immunoglobulin superfamily, member 3', 129, NULL, NULL, 91863),
(91864, '3.60.21.10-FF-000416', NULL, 'Uncharacterized protein C23A1.02c', 279, NULL, NULL, 91864),
(91865, '1.25.40.180-FF-000199', NULL, NULL, 153, NULL, NULL, 91865),
(91866, '1.10.10.2660-FF-000014', NULL, 'Ubiquitin-activating enzyme-like protein', 46, NULL, NULL, 91866),
(91867, '1.10.10.820-FF-000024', NULL, 'Unplaced genomic scaffold supercont1.8, whole genome shotgun sequence', 58, NULL, NULL, 91867),
(91868, '3.80.10.10-FF-001211', NULL, 'Si:ch211-181d7.1', 272, NULL, NULL, 91868),
(91869, '3.40.50.300-FF-002481', NULL, 'MIP14774p', 199, NULL, NULL, 91869),
(91870, '3.40.50.10190-FF-000286', NULL, 'DNA ligase 4', 104, NULL, NULL, 91870),
(91871, '1.20.1250.20-FF-001208', NULL, 'MFS transporter, putative', 177, NULL, NULL, 91871),
(91872, '2.130.10.10-FF-001778', NULL, 'Katanin p80 WD40 repeat-containing subunit B1', 122, NULL, NULL, 91872),
(91873, '1.20.58.760-FF-000022', NULL, 'ATP-dependent zinc metalloprotease FtsH', 201, NULL, NULL, 91873),
(91874, '1.10.10.60-FF-000019', NULL, 'Ligand-dependent corepressor isoform 1', 43, NULL, NULL, 91874),
(91875, '3.40.50.300-FF-000805', NULL, 'ATP-dependent DNA helicase PIF1', 218, NULL, NULL, 91875),
(91876, '1.25.40.10-FF-001777', NULL, 'Os01g0959600 protein', 110, NULL, NULL, 91876),
(91877, '1.10.20.10-FF-000235', NULL, NULL, 126, NULL, NULL, 91877),
(91878, '3.20.20.70-FF-000574', NULL, NULL, 160, NULL, NULL, 91878),
(91879, '3.30.530.20-FF-000204', NULL, 'Protein retinal degeneration B-like Protein', 168, NULL, NULL, 91879),
(91880, '1.20.1440.340-FF-000003', NULL, 'GAL1p Galactokinase', 166, NULL, NULL, 91880),
(91881, '2.60.40.340-FF-000017', NULL, NULL, 129, NULL, NULL, 91881),
(91882, '2.40.10.10-FF-000214', NULL, 'Protein Z, vitamin K-dependent plasma glycoprotein a', 122, NULL, NULL, 91882),
(91883, '2.30.29.30-FF-001129', NULL, 'Uncharacterized protein', 122, NULL, NULL, 91883),
(91884, '3.65.10.10-FF-000009', NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', 205, NULL, NULL, 91884),
(91885, '1.10.10.60-FF-000171', NULL, 'Homeobox transcription factor', 69, NULL, NULL, 91885),
(91886, '2.10.25.10-FF-000385', NULL, 'Hemicentin 1', 37, NULL, NULL, 91886),
(91887, '1.20.1280.160-FF-000002', NULL, 'Dynein heavy chain, cytoplasmic', 91, NULL, NULL, 91887),
(91888, '1.20.1530.20-FF-000022', NULL, 'Cation/H(+) antiporter 24', 404, NULL, NULL, 91888); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(91889, '3.30.70.330-FF-003098', NULL, NULL, 97, NULL, NULL, 91889),
(91890, '1.10.1450.10-FF-000144', NULL, 'Tetraspanin', 90, NULL, NULL, 91890),
(91891, '2.60.120.1000-FF-000016', NULL, 'Uncharacterized protein', 225, NULL, NULL, 91891),
(91892, '3.40.50.720-FF-001056', NULL, 'Pyrroline-5-carboxylate reductase 3', 161, NULL, NULL, 91892),
(91893, '1.25.40.10-FF-004632', NULL, 'Uncharacterized protein', 194, NULL, NULL, 91893),
(91894, '1.20.1610.10-FF-000020', NULL, 'Chromosome 21, whole genome shotgun sequence', 172, NULL, NULL, 91894),
(91895, '2.40.30.10-FF-000502', NULL, 'Uncharacterized protein', 94, NULL, NULL, 91895),
(91896, '3.90.70.10-FF-000449', NULL, 'HlyB/MsbA family ABC transporter', 125, NULL, NULL, 91896),
(91897, '1.10.510.10-FF-003747', NULL, NULL, 145, NULL, NULL, 91897),
(91898, '2.170.190.11-FF-000017', NULL, 'Molybdopterin molybdenumtransferase', 83, NULL, NULL, 91898),
(91899, '3.30.70.330-FF-002030', NULL, NULL, 133, NULL, NULL, 91899),
(91900, '3.10.290.10-FF-000029', NULL, 'Pseudouridine synthase, putative', 59, NULL, NULL, 91900),
(91901, '1.20.1070.10-FF-001495', NULL, 'Uncharacterized protein', 200, NULL, NULL, 91901),
(91902, '1.20.58.2220-FF-000009', NULL, 'Disheveled-associated activator of morphogenesis', 400, NULL, NULL, 91902),
(91903, '3.30.450.40-FF-000304', NULL, 'Sensory box/ggdef domain protein', 186, NULL, NULL, 91903),
(91904, '3.40.50.300-FF-004572', NULL, 'Similarity to HepA-related protein Harp', 311, NULL, NULL, 91904),
(91905, '2.60.40.1400-FF-000001', NULL, 'G protein-activated inward rectifier potassium channel 2', 186, NULL, NULL, 91905),
(91906, '3.40.50.1000-FF-000245', NULL, '4-nitrophenyl phosphatase', 131, NULL, NULL, 91906),
(91907, '3.30.1330.30-FF-000085', NULL, 'GD14076', 121, NULL, NULL, 91907),
(91908, '2.30.30.140-FF-000338', NULL, 'RBB1NT (NUC162) domaincontaining protein', 112, NULL, NULL, 91908),
(91909, '4.10.110.10-FF-000007', NULL, 'Lysosomal alpha-glucosidase', 50, NULL, NULL, 91909),
(91910, '3.30.160.60-FF-002177', NULL, 'Zinc finger protein 404', 27, NULL, NULL, 91910),
(91911, '2.120.10.30-FF-000211', NULL, 'Teneurin-1', 229, NULL, NULL, 91911),
(91912, '3.30.1490.120-FF-000002', NULL, 'DNA-directed RNA polymerase III subunit RPC8', 80, NULL, NULL, 91912),
(91913, '3.30.70.890-FF-000084', NULL, 'Uncharacterized protein', 24, NULL, NULL, 91913),
(91914, '2.10.25.10-FF-001407', NULL, 'Uncharacterized protein', 43, NULL, NULL, 91914),
(91915, '1.10.1200.10-FF-000036', NULL, 'Acyl carrier protein', 81, NULL, NULL, 91915),
(91916, '3.30.160.60-FF-000086', NULL, 'transcription factor E4F1 isoform X1', 26, NULL, NULL, 91916),
(91917, '3.90.79.10-FF-000110', NULL, 'Putative nudix hydrolase 6', 169, NULL, NULL, 91917),
(91918, '2.30.180.10-FF-000043', NULL, 'Fasciclin-like arabinogalactan protein 2', 135, NULL, NULL, 91918),
(91919, '3.40.140.100-FF-000018', NULL, 'Ubiquitin activating enzyme e1-like protein', 151, NULL, NULL, 91919),
(91920, '3.40.47.10-FF-000061', NULL, 'Thiolase, C-terminal domain protein', 420, NULL, NULL, 91920),
(91921, '3.40.720.10-FF-000365', NULL, 'Uncharacterized protein HI_0841', 156, NULL, NULL, 91921),
(91922, '3.40.50.920-FF-000042', NULL, '2-oxoglutarate ferredoxin oxidoreductase subunit alpha', 110, NULL, NULL, 91922),
(91923, '1.20.1250.40-FF-000017', NULL, 'DNA-directed RNA polymerase II subunit RPB4', 136, NULL, NULL, 91923),
(91924, '2.60.120.10-FF-000392', NULL, 'AtABP1-like auxin binding protein', 158, NULL, NULL, 91924),
(91925, '3.90.550.10-FF-000065', NULL, 'UDP-glucose:glycoprotein glucosyltransferase, putative', 248, NULL, NULL, 91925),
(91926, '3.90.70.10-FF-000803', NULL, 'Predicted protein', 320, NULL, NULL, 91926),
(91927, '3.40.50.970-FF-000130', NULL, 'N(2)-(2-carboxyethyl)arginine synthase', 214, NULL, NULL, 91927),
(91928, '1.25.40.10-FF-004014', NULL, 'AFR088Wp', 615, NULL, NULL, 91928),
(91929, '2.40.70.10-FF-000156', NULL, 'Uncharacterized protein', 172, NULL, NULL, 91929),
(91930, '3.30.70.330-FF-001299', NULL, 'At3g08000', 111, NULL, NULL, 91930),
(91931, '3.40.47.10-FF-000302', NULL, NULL, 30, NULL, NULL, 91931);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(91932, '3.30.1330.30-FF-000096', NULL, 'RNA methyltransferase, TrmH family, group 3', 79, NULL, NULL, 91932),
(91933, '2.130.10.10-FF-002273', NULL, 'IFT complex A', 258, NULL, NULL, 91933),
(91934, '2.60.40.10-FF-001688', NULL, 'GM13016', 88, NULL, NULL, 91934),
(91935, '3.80.10.10-FF-001486', NULL, 'DNA repair protein rhp7 isoform A', 100, NULL, NULL, 91935),
(91936, '1.10.455.10-FF-000010', NULL, 'Ribosomal protein', 50, NULL, NULL, 91936),
(91937, '2.40.30.10-FF-000148', NULL, 'Sulfate adenylyltransferase subunit 1', 105, NULL, NULL, 91937),
(91938, '3.30.1370.10-FF-000210', NULL, 'Polyribonucleotide nucleotidyltransferase, putative', 41, NULL, NULL, 91938),
(91939, '3.90.1030.20-FF-000011', NULL, NULL, 141, NULL, NULL, 91939),
(91940, '1.10.472.10-FF-000370', NULL, 'Cyclin G2', 84, NULL, NULL, 91940),
(91941, '3.30.420.40-FF-000235', NULL, 'ROK family transcriptional regulator', 126, NULL, NULL, 91941),
(91942, '1.10.510.10-FF-000942', NULL, 'Serine/threonine-protein kinase KSP1', 268, NULL, NULL, 91942),
(91943, '1.10.287.110-FF-000059', NULL, 'dnaJ homolog subfamily C member 17', 100, NULL, NULL, 91943),
(91944, '1.10.533.10-FF-000006', NULL, 'Tumor necrosis factor receptor superfamily member EDAR', 93, NULL, NULL, 91944),
(91945, '3.40.50.2000-FF-000320', NULL, '3-deoxy-D-manno-octulosonic acid transferase', 191, NULL, NULL, 91945),
(91946, '1.10.630.10-FF-000766', NULL, 'Predicted protein', 480, NULL, NULL, 91946),
(91947, '1.20.58.340-FF-000037', NULL, 'Magnesium transporter MRS2-5 like', 161, NULL, NULL, 91947),
(91948, '3.30.70.2820-FF-000012', NULL, NULL, 106, NULL, NULL, 91948),
(91949, '3.40.1770.10-FF-000002', NULL, 'Urocanate hydratase 1', 138, NULL, NULL, 91949),
(91950, '3.40.120.10-FF-000123', NULL, 'Uncharacterized protein', 68, NULL, NULL, 91950),
(91951, '3.10.250.10-FF-000083', NULL, NULL, 110, NULL, NULL, 91951),
(91952, '3.20.20.60-FF-000088', NULL, 'Carboxyvinyl-carboxyphosphonate phosphorylmutase', 288, NULL, NULL, 91952),
(91953, '3.40.50.300-FF-004813', NULL, 'ATPase, AAA family', 168, NULL, NULL, 91953),
(91954, '3.40.140.10-FF-000219', NULL, 'Predicted protein', 185, NULL, NULL, 91954),
(91955, '3.30.70.80-FF-000001', NULL, 'Multiple organellar RNA editing factor', 85, NULL, NULL, 91955),
(91956, '3.80.10.10-FF-004437', NULL, 'Uncharacterized protein', 158, NULL, NULL, 91956),
(91957, '3.40.50.10470-FF-000016', NULL, 'Methylthioribose-1-phosphate isomerase 1', 156, NULL, NULL, 91957),
(91958, '3.40.50.2300-FF-001490', NULL, NULL, 129, NULL, NULL, 91958),
(91959, '1.10.2000.10-FF-000066', NULL, NULL, 175, NULL, NULL, 91959),
(91960, '3.20.20.10-FF-000045', NULL, 'Alanine racemase', 212, NULL, NULL, 91960),
(91961, '1.10.238.10-FF-000281', NULL, 'Calcium-binding EF hand family protein', 84, NULL, NULL, 91961),
(91962, '3.40.50.2020-FF-000040', NULL, 'Phosphoribosyl pyrophosphate synthetase 1', 26, NULL, NULL, 91962),
(91963, '2.10.25.10-FF-001520', NULL, 'Uncharacterized protein', 66, NULL, NULL, 91963),
(91964, '2.40.10.10-FF-000153', NULL, 'Venom plasminogen activator TSV-PA', 101, NULL, NULL, 91964),
(91965, '1.25.40.430-FF-000021', NULL, 'Uncharacterized protein', 105, NULL, NULL, 91965),
(91966, '2.10.25.10-FF-001166', NULL, 'Uncharacterized protein', 39, NULL, NULL, 91966),
(91967, '3.20.20.80-FF-000577', NULL, 'Beta-galactosidase', 285, NULL, NULL, 91967),
(91968, '4.10.1000.10-FF-000069', NULL, 'Uncharacterized protein', 38, NULL, NULL, 91968),
(91969, '3.30.420.40-FF-000292', NULL, 'Heat shock cognate 71 kDa protein', 153, NULL, NULL, 91969),
(91970, '2.30.30.40-FF-000461', NULL, 'Hematopoietic cell-specific Lyn substrate 1', 68, NULL, NULL, 91970),
(91971, '3.40.50.300-FF-001997', NULL, 'Pre-mRNA splicing factor RNA helicase, putative', 108, NULL, NULL, 91971),
(91972, '1.25.40.10-FF-000703', NULL, 'Unplaced genomic scaffold supercont1.19, whole genome shotgun sequence', 253, NULL, NULL, 91972),
(91973, '3.30.9.10-FF-000108', NULL, 'D-aspartate oxidase', 178, NULL, NULL, 91973),
(91974, '1.20.1110.10-FF-000206', NULL, NULL, 88, NULL, NULL, 91974);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(91975, '3.40.50.2300-FF-001214', NULL, NULL, 30, NULL, NULL, 91975),
(91976, '1.25.40.20-FF-000706', NULL, 'Uncharacterized protein', 126, NULL, NULL, 91976),
(91977, '3.80.10.10-FF-003627', NULL, 'Uncharacterized protein', 225, NULL, NULL, 91977),
(91978, '3.40.50.300-FF-004459', NULL, 'Novel protein similar to guanylate binding protein 4', 280, NULL, NULL, 91978),
(91979, '3.40.50.300-FF-002329', NULL, 'ATP-binding cassette protein subfamily F, member 3', 251, NULL, NULL, 91979),
(91980, '1.10.8.720-FF-000024', NULL, 'AGAP010790-PA', 167, NULL, NULL, 91980),
(91981, '1.10.10.2670-FF-000017', NULL, 'YALI0B03718p', 103, NULL, NULL, 91981),
(91982, '2.10.70.10-FF-000192', NULL, 'Fraser extracellular matrix complex subunit 1', 35, NULL, NULL, 91982),
(91983, '1.10.287.110-FF-000391', NULL, 'Uncharacterized protein', 72, NULL, NULL, 91983),
(91984, '3.80.10.10-FF-003009', NULL, 'Uncharacterized protein', 226, NULL, NULL, 91984),
(91985, '3.40.50.150-FF-000272', NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', 318, NULL, NULL, 91985),
(91986, '3.40.50.300-FF-002273', NULL, 'Uncharacterized protein', 296, NULL, NULL, 91986),
(91987, '3.40.50.300-FF-007950', NULL, 'Uncharacterized protein', 169, NULL, NULL, 91987),
(91988, '1.25.40.1030-FF-000029', NULL, 'Protein transport protein sec16', 379, NULL, NULL, 91988),
(91989, '3.90.110.10-FF-000021', NULL, 'Malate dehydrogenase 1B, NAD (soluble)', 183, NULL, NULL, 91989),
(91990, '3.70.10.10-FF-000071', NULL, 'Beta sliding clamp', 201, NULL, NULL, 91990),
(91991, '2.60.120.310-FF-000017', NULL, 'Uncharacterized protein', 163, NULL, NULL, 91991),
(91992, '3.40.50.1820-FF-000131', NULL, 'Monoglyceride lipase', 280, NULL, NULL, 91992),
(91993, '3.30.160.60-FF-000322', NULL, 'GDNF-inducible zinc finger protein 1', 28, NULL, NULL, 91993),
(91994, '2.70.130.10-FF-000047', NULL, NULL, 68, NULL, NULL, 91994),
(91995, '1.10.3090.10-FF-000015', NULL, 'tRNA nucleotidyltransferase putative', 203, NULL, NULL, 91995),
(91996, '2.130.10.10-FF-004072', NULL, 'Uncharacterized protein', 205, NULL, NULL, 91996),
(91997, '2.60.120.1540-FF-000004', NULL, 'CD109 molecule', 88, NULL, NULL, 91997),
(91998, '2.70.170.10-FF-000044', NULL, 'AcetylCholine Receptor', 233, NULL, NULL, 91998),
(91999, '3.30.930.10-FF-000395', NULL, 'Uncharacterized protein', 145, NULL, NULL, 91999),
(92000, '3.30.450.60-FF-000069', NULL, 'AP complex subunit sigma', 68, NULL, NULL, 92000),
(92001, '1.20.120.1080-FF-000147', NULL, 'Uncharacterized protein', 127, NULL, NULL, 92001),
(92002, '1.20.5.190-FF-000065', NULL, 'Calmodulin-binding transcription activator (Camta), drome', 56, NULL, NULL, 92002),
(92003, '1.20.1270.280-FF-000036', NULL, 'Putative dynein heavy chain', 172, NULL, NULL, 92003),
(92004, '2.70.150.10-FF-000015', NULL, 'Cation-transporting ATPase', 166, NULL, NULL, 92004),
(92005, '1.10.472.10-FF-000712', NULL, 'Uncharacterized protein', 52, NULL, NULL, 92005),
(92006, '2.10.70.10-FF-000135', NULL, 'Complement factor H', 64, NULL, NULL, 92006),
(92007, '2.60.120.10-FF-000678', NULL, 'Predicted protein', 91, NULL, NULL, 92007),
(92008, '3.40.50.1820-FF-000665', NULL, 'Kidney thyroglobulin variant', 324, NULL, NULL, 92008),
(92009, '2.40.30.270-FF-000015', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', 57, NULL, NULL, 92009),
(92010, '1.25.40.10-FF-002215', NULL, 'Uncharacterized protein', 122, NULL, NULL, 92010),
(92011, '3.30.160.60-FF-004537', NULL, NULL, 65, NULL, NULL, 92011),
(92012, '2.60.120.260-FF-000064', NULL, 'Ephrin type-B receptor 6', 198, NULL, NULL, 92012),
(92013, '1.10.510.10-FF-003539', NULL, NULL, 235, NULL, NULL, 92013),
(92014, '3.40.250.10-FF-000166', NULL, 'Superoxide dismutase, Fe-Mn family', 114, NULL, NULL, 92014),
(92015, '2.60.120.10-FF-000504', NULL, 'cGMP-dependent protein kinase 8-2', 134, NULL, NULL, 92015),
(92016, '1.10.10.60-FF-000671', NULL, 'Protein CHROMATIN REMODELING 5', 114, NULL, NULL, 92016),
(92017, '2.60.40.10-FF-003981', NULL, NULL, 101, NULL, NULL, 92017),
(92018, '3.40.30.10-FF-000146', NULL, 'Thioredoxin domain containing 5', 120, NULL, NULL, 92018);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(92019, '3.40.50.150-FF-000614', NULL, 'NOL1/NOP2/sun family, putative', 344, NULL, NULL, 92019),
(92020, '2.60.40.60-FF-000039', NULL, 'FAT atypical cadherin 3', 107, NULL, NULL, 92020),
(92021, '2.30.30.570-FF-000006', NULL, 'Major vault protein, putative', 54, NULL, NULL, 92021),
(92022, '3.30.505.50-FF-000003', NULL, 'ribosome-binding factor PSRP1, chloroplastic', 52, NULL, NULL, 92022),
(92023, '1.10.150.50-FF-000117', NULL, 'Kinase suppressor of Ras', 72, NULL, NULL, 92023),
(92024, '3.30.70.250-FF-000027', NULL, NULL, 73, NULL, NULL, 92024),
(92025, '3.10.129.10-FF-000014', NULL, 'Acyl-[acyl-carrier-protein] hydrolase', 281, NULL, NULL, 92025),
(92026, '2.40.50.100-FF-000126', NULL, 'Putative periplasmic linker protein', 69, NULL, NULL, 92026),
(92027, '3.50.50.60-FF-000004', NULL, 'protein-methionine sulfoxide oxidase MICAL2 isoform X1', 492, NULL, NULL, 92027),
(92028, '3.40.50.1240-FF-000120', NULL, 'Phosphoglycerate mutase family protein', 256, NULL, NULL, 92028),
(92029, '2.60.40.10-FF-004644', NULL, NULL, 123, NULL, NULL, 92029),
(92030, '3.80.10.10-FF-003066', NULL, 'Predicted protein', 141, NULL, NULL, 92030),
(92031, '3.90.640.10-FF-000185', NULL, 'Actin related protein', 100, NULL, NULL, 92031),
(92032, '1.10.1200.10-FF-000047', NULL, 'Acyl carrier protein', 91, NULL, NULL, 92032),
(92033, '1.20.1070.10-FF-000944', NULL, 'Predicted protein', 306, NULL, NULL, 92033),
(92034, '3.30.365.10-FF-000069', NULL, 'Uncharacterized protein', 185, NULL, NULL, 92034),
(92035, '3.30.70.240-FF-000024', NULL, 'Ribosome-releasing factor 2, mitochondrial', 136, NULL, NULL, 92035),
(92036, '1.25.40.10-FF-000142', NULL, 'Serine/threonine-protein kinase ATR', 426, NULL, NULL, 92036),
(92037, '3.40.50.280-FF-000018', NULL, 'Probable transcriptional regulator', 126, NULL, NULL, 92037),
(92038, '3.30.160.60-FF-004251', NULL, NULL, 29, NULL, NULL, 92038),
(92039, '1.20.120.1750-FF-000101', NULL, 'RBR-type E3 ubiquitin transferase', 120, NULL, NULL, 92039),
(92040, '3.80.10.10-FF-002846', NULL, 'Predicted protein', 234, NULL, NULL, 92040),
(92041, '3.30.70.580-FF-000042', NULL, 'Pseudouridylate synthase 3', 125, NULL, NULL, 92041),
(92042, '3.40.50.300-FF-004252', NULL, 'DNA replication licensing factor MCM7', 340, NULL, NULL, 92042),
(92043, '2.30.30.560-FF-000003', NULL, 'Major vault protein', 62, NULL, NULL, 92043),
(92044, '3.40.50.2300-FF-001079', NULL, NULL, 37, NULL, NULL, 92044),
(92045, '1.10.20.10-FF-000314', NULL, NULL, 167, NULL, NULL, 92045),
(92046, '3.30.300.330-FF-000003', NULL, 'Alkyldihydroxyacetonephosphate synthase (ADS1)', 104, NULL, NULL, 92046),
(92047, '3.10.280.10-FF-000023', NULL, 'Mitochondrial glyco protein', 220, NULL, NULL, 92047),
(92048, '2.60.40.150-FF-000281', NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', 135, NULL, NULL, 92048),
(92049, '2.60.120.380-FF-000044', NULL, 'Calpain-B', 150, NULL, NULL, 92049),
(92050, '3.30.70.330-FF-000107', NULL, 'TAR DNA-binding protein 43', 82, NULL, NULL, 92050),
(92051, '2.130.10.10-FF-004015', NULL, 'Uncharacterized protein', 224, NULL, NULL, 92051),
(92052, '3.30.1360.10-FF-000030', NULL, 'RNA polymerase I and III subunit C', 109, NULL, NULL, 92052),
(92053, '1.10.287.110-FF-000334', NULL, 'Chaperone protein DNAJ, putative', 80, NULL, NULL, 92053),
(92054, '1.10.540.10-FF-000141', NULL, 'Uncharacterized protein', 27, NULL, NULL, 92054),
(92055, '1.20.1070.10-FF-001220', NULL, 'Putative G-protein coupled receptor 101', 288, NULL, NULL, 92055),
(92056, '3.40.50.300-FF-005819', NULL, 'Uncharacterized protein', 239, NULL, NULL, 92056),
(92057, '1.10.10.10-FF-001488', NULL, 'Eukaryotic translation initiation factor 3 subunit K', 104, NULL, NULL, 92057),
(92058, '3.30.310.10-FF-000038', NULL, 'Coatomer subunit gamma', 117, NULL, NULL, 92058),
(92059, '1.10.10.1540-FF-000004', NULL, 'Protein CBR-TAG-243', 82, NULL, NULL, 92059),
(92060, '3.30.450.50-FF-000066', NULL, '25.3 kDa vesicle transport protein', 68, NULL, NULL, 92060),
(92061, '2.40.40.20-FF-000045', NULL, 'Arginine N-succinyltransferase', 64, NULL, NULL, 92061);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(92062, '3.30.56.10-FF-000003', NULL, 'Phenylalanine--tRNA ligase beta subunit', 74, NULL, NULL, 92062),
(92063, '1.20.920.10-FF-000196', NULL, 'Uncharacterized protein', 134, NULL, NULL, 92063),
(92064, '1.50.40.10-FF-000527', NULL, 'Uncharacterized protein', 162, NULL, NULL, 92064),
(92065, '3.30.450.40-FF-000063', NULL, 'Stage II sporulation protein E', 176, NULL, NULL, 92065),
(92066, '2.60.40.10-FF-003020', NULL, 'interferon gamma receptor 1', 96, NULL, NULL, 92066),
(92067, '2.60.40.60-FF-000932', NULL, 'Uncharacterized protein', 39, NULL, NULL, 92067),
(92068, '3.30.160.60-FF-005875', NULL, NULL, 43, NULL, NULL, 92068),
(92069, '3.30.160.60-FF-002660', NULL, 'Zinc finger protein 200', 28, NULL, NULL, 92069),
(92070, '1.10.510.10-FF-001948', NULL, 'Uncharacterized protein', 213, NULL, NULL, 92070),
(92071, '2.70.170.10-FF-000224', NULL, 'Uncharacterized protein', 102, NULL, NULL, 92071),
(92072, '3.40.50.10810-FF-000040', NULL, 'Switch 2', 251, NULL, NULL, 92072),
(92073, '1.20.120.350-FF-000180', NULL, NULL, 113, NULL, NULL, 92073),
(92074, '3.40.1160.10-FF-000097', NULL, 'Predicted protein', 342, NULL, NULL, 92074),
(92075, '3.40.50.300-FF-002661', NULL, 'GTP binding protein, putative', 174, NULL, NULL, 92075),
(92076, '2.130.10.10-FF-005639', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', 175, NULL, NULL, 92076),
(92077, '3.30.420.10-FF-000485', NULL, NULL, 156, NULL, NULL, 92077),
(92078, '2.40.30.10-FF-000423', NULL, 'Uncharacterized protein', 42, NULL, NULL, 92078),
(92079, '2.10.25.10-FF-001109', NULL, 'Predicted protein', 43, NULL, NULL, 92079),
(92080, '1.10.8.710-FF-000021', NULL, NULL, 43, NULL, NULL, 92080),
(92081, '3.90.190.10-FF-000195', NULL, 'Tyrosine-protein phosphatase', 247, NULL, NULL, 92081),
(92082, '1.10.510.10-FF-000381', NULL, 'Putative receptor-like protein kinase', 201, NULL, NULL, 92082),
(92083, '3.10.20.90-FF-000951', NULL, 'Uncharacterized protein', 65, NULL, NULL, 92083),
(92084, '3.30.160.60-FF-002508', NULL, 'Neuroectoderm-expressed 2, isoform A', 29, NULL, NULL, 92084),
(92085, '3.30.559.30-FF-000059', NULL, 'Nonribosomal peptide synthetase fmqC', 239, NULL, NULL, 92085),
(92086, '1.10.630.10-FF-000709', NULL, 'Uncharacterized protein', 119, NULL, NULL, 92086),
(92087, '1.20.1250.40-FF-000028', NULL, 'AaceriAGR317Cp', 136, NULL, NULL, 92087),
(92088, '2.10.110.10-FF-000060', NULL, 'Uncharacterized protein, isoform Z', 59, NULL, NULL, 92088),
(92089, '3.40.30.160-FF-000001', NULL, 'Microbial collagenase', 144, NULL, NULL, 92089),
(92090, '1.25.40.20-FF-000594', NULL, 'Uncharacterized protein', 217, NULL, NULL, 92090),
(92091, '3.40.30.10-FF-000376', NULL, 'Glutathione S-transferase 2', 88, NULL, NULL, 92091),
(92092, '2.30.180.10-FF-000082', NULL, 'Fasciclin-like arabinogalactan protein 1', 157, NULL, NULL, 92092),
(92093, '1.10.10.60-FF-000339', NULL, 'Transcription factor MYB30', 59, NULL, NULL, 92093),
(92094, '2.60.40.10-FF-003829', NULL, NULL, 90, NULL, NULL, 92094),
(92095, '3.90.226.10-FF-000031', NULL, 'Interphotoreceptor retinoid binding protein', 204, NULL, NULL, 92095),
(92096, '2.60.34.10-FF-000105', NULL, 'Uncharacterized protein', 181, NULL, NULL, 92096),
(92097, '2.40.50.360-FF-000007', NULL, 'RuvB-like helicase', 64, NULL, NULL, 92097),
(92098, '3.30.160.60-FF-000940', NULL, 'transcription factor Sp7', 33, NULL, NULL, 92098),
(92099, '2.30.29.150-FF-000002', NULL, 'FACT complex subunit SPT16', 166, NULL, NULL, 92099),
(92100, '3.40.140.10-FF-000096', NULL, 'GG22115', 160, NULL, NULL, 92100),
(92101, '3.30.870.10-FF-000007', NULL, 'Polyphosphate kinase', 187, NULL, NULL, 92101),
(92102, '1.20.1640.10-FF-000055', NULL, 'Protein-export membrane protein SecF', 206, NULL, NULL, 92102),
(92103, '1.20.1070.10-FF-002012', NULL, 'Olfactory receptor', 138, NULL, NULL, 92103),
(92104, '3.40.390.10-FF-000030', NULL, 'Metalloendopeptidase', 197, NULL, NULL, 92104),
(92105, '3.40.50.150-FF-000890', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', 170, NULL, NULL, 92105),
(92106, '3.40.190.10-FF-000110', NULL, 'Survival motor neuron protein 1', 61, NULL, NULL, 92106);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(92107, '1.20.5.110-FF-000261', NULL, 'Putative synaptobrevin homolog YKT6', 58, NULL, NULL, 92107),
(92108, '1.10.8.10-FF-000329', NULL, 'AGR352Cp', 45, NULL, NULL, 92108),
(92109, '3.20.20.220-FF-000044', NULL, 'Proline dehydrogenase', 338, NULL, NULL, 92109),
(92110, '3.60.10.10-FF-000099', NULL, 'EEP domain-containing protein', 244, NULL, NULL, 92110),
(92111, '1.25.10.10-FF-001949', NULL, 'Mitogen activated protein kinase kinase kinase 1, MAPKKK1, MEKK1, putative', 285, NULL, NULL, 92111),
(92112, '3.90.70.10-FF-000680', NULL, 'Uncharacterized protein', 272, NULL, NULL, 92112),
(92113, '3.40.50.300-FF-007686', NULL, 'Uncharacterized protein', 111, NULL, NULL, 92113),
(92114, '2.30.29.30-FF-001051', NULL, 'Uncharacterized protein', 73, NULL, NULL, 92114),
(92115, '2.160.10.10-FF-000107', NULL, 'Uncharacterized protein', 107, NULL, NULL, 92115),
(92116, '2.40.33.10-FF-000020', NULL, 'Pyruvate kinase', 122, NULL, NULL, 92116),
(92117, '3.90.70.10-FF-000062', NULL, 'Dipeptidyl peptidase 1', 233, NULL, NULL, 92117),
(92118, '3.30.750.24-FF-000051', NULL, 'Sulfate transporter', 96, NULL, NULL, 92118),
(92119, '1.25.40.70-FF-000064', NULL, 'Phosphatidylinositol 4-kinase alpha, putative', 155, NULL, NULL, 92119),
(92120, '1.10.10.60-FF-000132', NULL, 'AraC family transcriptional regulator', 105, NULL, NULL, 92120),
(92121, '3.30.420.110-FF-000054', NULL, 'DNA mismatch repair protein MutS', 155, NULL, NULL, 92121),
(92122, '1.10.220.160-FF-000024', NULL, NULL, 73, NULL, NULL, 92122),
(92123, '1.20.120.330-FF-000022', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 155, NULL, NULL, 92123),
(92124, '1.25.40.10-FF-003851', NULL, 'Uncharacterized protein', 114, NULL, NULL, 92124),
(92125, '1.20.120.350-FF-000028', NULL, 'Potassium voltage-gated channel subfamily a member', 176, NULL, NULL, 92125),
(92126, '2.40.10.10-FF-000591', NULL, NULL, 33, NULL, NULL, 92126),
(92127, '1.10.10.10-FF-000353', NULL, 'H1 histone family member X', 83, NULL, NULL, 92127),
(92128, '2.10.25.10-FF-000626', NULL, 'Blast:Protein eyes shut', 28, NULL, NULL, 92128),
(92129, '2.130.10.10-FF-000143', NULL, 'U3 small nucleolar RNA-interacting protein 2 isoform X2', 343, NULL, NULL, 92129),
(92130, '3.30.56.30-FF-000009', NULL, 'Signal recognition particle 19 kDa protein', 108, NULL, NULL, 92130),
(92131, '3.40.50.620-FF-000576', NULL, 'Uncharacterized protein', 143, NULL, NULL, 92131),
(92132, '1.20.1560.10-FF-000577', NULL, 'ATP-binding cassette, sub-family B (MDR/TAP), member 10', 244, NULL, NULL, 92132),
(92133, '2.60.40.60-FF-000314', NULL, 'Fat-like cadherin-related tumor suppressor homolog', 104, NULL, NULL, 92133),
(92134, '3.40.470.10-FF-000031', NULL, NULL, 267, NULL, NULL, 92134),
(92135, '2.60.40.10-FF-001952', NULL, 'Programmed cell death protein 1', 125, NULL, NULL, 92135),
(92136, '1.10.220.150-FF-000021', NULL, 'Uncharacterized protein, isoform B', 136, NULL, NULL, 92136),
(92137, '1.25.40.20-FF-000420', NULL, 'Squamosa promoter binding protein-like 1', 145, NULL, NULL, 92137),
(92138, '3.90.930.1-FF-000004', NULL, NULL, 129, NULL, NULL, 92138),
(92139, '3.40.50.12390-FF-000013', NULL, 'Putative exoribonuclease 2', 186, NULL, NULL, 92139),
(92140, '3.60.15.10-FF-000115', NULL, 'Cleavage and polyadenylation specificity factor 73 kDa subunit', 224, NULL, NULL, 92140),
(92141, '3.40.50.300-FF-002043', NULL, 'Guanine nucleotide-binding 3', 185, NULL, NULL, 92141),
(92142, '1.10.238.10-FF-000129', NULL, 'Serine/threonine-protein phosphatase 2A regulatory subunit B'''' subunit gamma', 171, NULL, NULL, 92142),
(92143, '2.130.10.10-FF-005078', NULL, 'Predicted protein', 266, NULL, NULL, 92143),
(92144, '1.25.10.10-FF-000325', NULL, 'Serine/threonine-protein kinase 36', 222, NULL, NULL, 92144),
(92145, '3.40.50.10810-FF-000247', NULL, 'DNA repair protein-like protein', 219, NULL, NULL, 92145),
(92146, '2.10.220.10-FF-000175', NULL, 'Proprotein convertase subtilisin/kexin type 4', 79, NULL, NULL, 92146),
(92147, '3.80.10.10-FF-003341', NULL, 'Flagellar associated protein', 121, NULL, NULL, 92147);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(92148, '1.20.1250.20-FF-001085', NULL, 'Autophagy-related protein 22', 198, NULL, NULL, 92148),
(92149, '1.10.630.10-FF-000592', NULL, 'Uncharacterized protein', 288, NULL, NULL, 92149),
(92150, '1.25.40.10-FF-004076', NULL, 'Uncharacterized protein', 158, NULL, NULL, 92150),
(92151, '2.40.70.10-FF-000038', NULL, 'Plasmepsin-2', 161, NULL, NULL, 92151),
(92152, '3.30.1640.10-FF-000074', NULL, 'DNA replication licensing factor MCM7', 95, NULL, NULL, 92152),
(92153, '3.40.50.720-FF-001612', NULL, '(+)-neomenthol dehydrogenase', 129, NULL, NULL, 92153),
(92154, '1.25.40.10-FF-004132', NULL, 'Uncharacterized protein', 121, NULL, NULL, 92154),
(92155, '3.20.20.60-FF-000032', NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', 269, NULL, NULL, 92155),
(92156, '1.10.640.10-FF-000087', NULL, 'Peroxidase, putative', 87, NULL, NULL, 92156),
(92157, '3.40.50.1100-FF-000269', NULL, 'Uncharacterized protein', 97, NULL, NULL, 92157),
(92158, '1.10.560.10-FF-000035', NULL, 'T-complex protein 1 subunit gamma', 230, NULL, NULL, 92158),
(92159, '2.70.98.10-FF-000123', NULL, 'Uncharacterized protein', 102, NULL, NULL, 92159),
(92160, '2.60.40.10-FF-004318', NULL, NULL, 94, NULL, NULL, 92160),
(92161, '3.30.230.130-FF-000016', NULL, 'Ubiquitin-protein ligase, putative', 161, NULL, NULL, 92161),
(92162, '2.10.25.10-FF-001284', NULL, 'Uncharacterized protein', 53, NULL, NULL, 92162),
(92163, '3.40.50.300-FF-000362', NULL, 'Dynein, axonemal, heavy chain 6', 125, NULL, NULL, 92163),
(92164, '3.30.559.70-FF-000043', NULL, 'Uncharacterized protein', 342, NULL, NULL, 92164),
(92165, '2.60.40.10-FF-000047', NULL, 'Contactin 1', 99, NULL, NULL, 92165),
(92166, '3.40.50.300-FF-001992', NULL, 'ATP-dependent RNA helicase, putative', 164, NULL, NULL, 92166),
(92167, '2.30.310.10-FF-000014', NULL, NULL, 104, NULL, NULL, 92167),
(92168, '1.20.58.1100-FF-000005', NULL, 'Unc-13 homolog A (C. elegans)', 97, NULL, NULL, 92168),
(92169, '3.40.50.1000-FF-000127', NULL, 'Magnesium-dependent phosphatase 1', 163, NULL, NULL, 92169),
(92170, '2.60.40.10-FF-002227', NULL, 'Wrapper/Rega-1/Klingon homolog', 101, NULL, NULL, 92170),
(92171, '3.40.50.300-FF-001025', NULL, 'ATPase family, AAA domain-containing 2B', 175, NULL, NULL, 92171),
(92172, '2.60.40.1110-FF-000010', NULL, 'Cyclin G associated kinase', 85, NULL, NULL, 92172),
(92173, '3.30.980.40-FF-000002', NULL, 'Cell division protein FtsK', 103, NULL, NULL, 92173),
(92174, '1.10.268.10-FF-000007', NULL, 'DNA topoisomerase (ATP-hydrolyzing)', 84, NULL, NULL, 92174),
(92175, '2.60.40.10-FF-000103', NULL, 'Kirre like nephrin family adhesion molecule 3', 82, NULL, NULL, 92175),
(92176, '3.40.50.150-FF-000058', NULL, 'Ribosomal RNA small subunit methyltransferase C', 185, NULL, NULL, 92176),
(92177, '3.40.1190.20-FF-000219', NULL, NULL, 292, NULL, NULL, 92177),
(92178, '2.60.120.10-FF-000274', NULL, 'Gentisate 1,2-dioxygenase', 346, NULL, NULL, 92178),
(92179, '3.30.70.330-FF-000967', NULL, 'AGAP002390-PA', 70, NULL, NULL, 92179),
(92180, '2.130.10.10-FF-004341', NULL, 'Subunit of VPS-C complex', 99, NULL, NULL, 92180),
(92181, '2.60.40.60-FF-000601', NULL, 'Predicted protein', 112, NULL, NULL, 92181),
(92182, '3.30.70.100-FF-000067', NULL, 'Stable protein 1', 106, NULL, NULL, 92182),
(92183, '3.30.160.20-FF-000097', NULL, 'Endoribonuclease dcr-1', 63, NULL, NULL, 92183),
(92184, '4.10.400.10-FF-000198', NULL, 'Low density lipoprotein receptor-related protein 2a', 40, NULL, NULL, 92184),
(92185, '1.10.510.10-FF-001628', NULL, 'Uncharacterized protein', 256, NULL, NULL, 92185),
(92186, '3.30.2230.10-FF-000009', NULL, 'Ubiquitin carboxyl-terminal hydrolase 32', 136, NULL, NULL, 92186),
(92187, '3.60.21.10-FF-000450', NULL, 'Uncharacterized metallophosphoesterase DR_2345', 190, NULL, NULL, 92187),
(92188, '1.20.144.10-FF-000010', NULL, 'Glucose-6-phosphatase', 200, NULL, NULL, 92188),
(92189, '1.10.287.70-FF-000575', NULL, 'Uncharacterized protein', 132, NULL, NULL, 92189),
(92190, '1.20.1270.370-FF-000006', NULL, '(R)-2-hydroxyacyl-CoA dehydratase YjiM', 76, NULL, NULL, 92190),
(92191, '2.60.40.1120-FF-000013', NULL, 'DUF1416 domain-containing protein', 77, NULL, NULL, 92191);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(92192, '3.40.1110.10-FF-000094', NULL, 'Cation-transporting P-type ATPase', 204, NULL, NULL, 92192),
(92193, '1.10.238.10-FF-000505', NULL, 'Probable calcium-binding protein CML34', 64, NULL, NULL, 92193),
(92194, '1.10.1620.20-FF-000008', NULL, 'ATP synthase subunit epsilon, mitochondrial', 54, NULL, NULL, 92194),
(92195, '3.50.50.60-FF-000330', NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase', 232, NULL, NULL, 92195),
(92196, '1.10.10.10-FF-001769', NULL, 'ORC1-type DNA replication protein', 93, NULL, NULL, 92196),
(92197, '1.10.150.80-FF-000036', NULL, 'ATP-dependent DNA helicase, RecQ family protein', 75, NULL, NULL, 92197),
(92198, '1.10.510.10-FF-000049', NULL, 'Mitogen-activated protein kinase', 209, NULL, NULL, 92198),
(92199, '3.40.50.1970-FF-000041', NULL, NULL, 154, NULL, NULL, 92199),
(92200, '3.30.160.60-FF-000592', NULL, 'zinc finger protein 90 homolog', 28, NULL, NULL, 92200),
(92201, '3.80.10.10-FF-000997', NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3', 115, NULL, NULL, 92201),
(92202, '1.25.40.10-FF-000821', NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', 337, NULL, NULL, 92202),
(92203, '3.40.50.800-FF-000068', NULL, 'Threonyl-tRNA synthetase, mitochondrial', 119, NULL, NULL, 92203),
(92204, '3.30.200.20-FF-001343', NULL, 'Serine/threonine-protein kinase ppk31', 86, NULL, NULL, 92204),
(92205, '1.20.120.150-FF-000007', NULL, 'Serine/threonine-protein kinase tor1', 91, NULL, NULL, 92205),
(92206, '1.25.40.20-FF-000190', NULL, 'Putative espin', 100, NULL, NULL, 92206),
(92207, '2.30.30.40-FF-000343', NULL, 'Cell division cycle-related protein', 113, NULL, NULL, 92207),
(92208, '1.10.510.10-FF-001679', NULL, 'Serine/threonine protein kinase', 360, NULL, NULL, 92208),
(92209, '3.30.1010.10-FF-000043', NULL, 'Phosphatidylinositol 4-kinase, putative', 158, NULL, NULL, 92209),
(92210, '2.130.10.10-FF-000704', NULL, 'Transducin/WD40 repeat-like superfamily protein', 177, NULL, NULL, 92210),
(92211, '3.40.33.10-FF-000063', NULL, 'Uncharacterized protein', 145, NULL, NULL, 92211),
(92212, '3.40.50.10810-FF-000253', NULL, 'Uncharacterized protein', 108, NULL, NULL, 92212),
(92213, '1.25.40.20-FF-000824', NULL, 'CARD- and ANK-containing Inflammasome Adaptor Protein', 127, NULL, NULL, 92213),
(92214, '2.130.10.10-FF-004392', NULL, 'Uncharacterized protein', 61, NULL, NULL, 92214),
(92215, '2.10.220.10-FF-000124', NULL, 'Furin-like protease 2', 78, NULL, NULL, 92215),
(92216, '3.40.50.2000-FF-001107', NULL, 'Uncharacterized protein', 14, NULL, NULL, 92216),
(92217, '3.40.1050.10-FF-000004', NULL, 'Carbonic anhydrase', 202, NULL, NULL, 92217),
(92218, '1.25.40.10-FF-001491', NULL, 'Os05g0572900 protein', 92, NULL, NULL, 92218),
(92219, '2.10.25.10-FF-001402', NULL, 'Uncharacterized protein', 59, NULL, NULL, 92219),
(92220, '1.10.510.10-FF-000375', NULL, 'Putative eukaryotic translation initiation factor 2-alpha kinase 1', 207, NULL, NULL, 92220),
(92221, '1.10.10.10-FF-001718', NULL, 'DNA-binding protein', 99, NULL, NULL, 92221),
(92222, '3.30.1370.240-FF-000011', NULL, 'Phenylalanyl-tRNA synthetase alpha chain', 81, NULL, NULL, 92222),
(92223, '1.20.120.140-FF-000004', NULL, 'Signal recognition particle receptor subunit alpha', 111, NULL, NULL, 92223),
(92224, '1.10.287.70-FF-000249', NULL, 'Calcium channel, voltage-dependent, R type, alpha 1E subunit b', 153, NULL, NULL, 92224),
(92225, '2.130.10.10-FF-005819', NULL, 'Coatomer subunit beta''-3', 68, NULL, NULL, 92225),
(92226, '3.90.550.10-FF-000245', NULL, 'Dolichyl-phosphate mannose synthase', 247, NULL, NULL, 92226),
(92227, '3.30.565.10-FF-000343', NULL, 'Sensory histidine protein kinase', 117, NULL, NULL, 92227),
(92228, '1.20.58.2220-FF-000043', NULL, 'Excretory canal abnormal protein 6', 372, NULL, NULL, 92228),
(92229, '1.10.540.10-FF-000091', NULL, 'Acyl-coenzyme A oxidase', 119, NULL, NULL, 92229),
(92230, '3.30.70.330-FF-003036', NULL, NULL, 33, NULL, NULL, 92230),
(92231, '4.10.400.10-FF-000254', NULL, 'AGAP003656-PB', 43, NULL, NULL, 92231);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(92232, '2.70.130.10-FF-000126', NULL, NULL, 150, NULL, NULL, 92232),
(92233, '3.40.20.10-FF-000089', NULL, 'Villin-1', 130, NULL, NULL, 92233),
(92234, '3.40.800.10-FF-000012', NULL, 'Arginase', 309, NULL, NULL, 92234),
(92235, '3.30.505.10-FF-000272', NULL, NULL, 63, NULL, NULL, 92235),
(92236, '2.60.40.10-FF-000373', NULL, 'fibronectin type-III domain-containing protein 3A isoform X1', 99, NULL, NULL, 92236),
(92237, '1.20.1260.140-FF-000014', NULL, NULL, 69, NULL, NULL, 92237),
(92238, '1.10.630.10-FF-000266', NULL, 'Ent-kaurene oxidase', 469, NULL, NULL, 92238),
(92239, '3.40.800.20-FF-000015', NULL, 'Histone deacetylase 2', 171, NULL, NULL, 92239),
(92240, '1.25.10.10-FF-001449', NULL, 'Apoptosis inhibitory protein', 273, NULL, NULL, 92240),
(92241, '1.10.1600.10-FF-000010', NULL, 'Inverted repeat-binding protein', 98, NULL, NULL, 92241),
(92242, '1.10.40.30-FF-000029', NULL, 'Argininosuccinate lyase', 34, NULL, NULL, 92242),
(92243, '2.40.33.10-FF-000008', NULL, 'Pyruvate kinase', 98, NULL, NULL, 92243),
(92244, '3.10.10.10-FF-000005', NULL, 'Endogenous retrovirus group K member 25 Pol protein', 116, NULL, NULL, 92244),
(92245, '1.25.10.10-FF-002450', NULL, 'Uncharacterized protein', 228, NULL, NULL, 92245),
(92246, '2.40.50.140-FF-001228', NULL, NULL, 56, NULL, NULL, 92246),
(92247, '1.20.1280.50-FF-000185', NULL, 'F-box only protein 39-like', 49, NULL, NULL, 92247),
(92248, '3.40.50.1980-FF-000044', NULL, 'ABC transporter substrate-binding protein', 128, NULL, NULL, 92248),
(92249, '1.10.8.60-FF-000541', NULL, 'RuvB-like helicase', 59, NULL, NULL, 92249),
(92250, '3.40.190.290-FF-000113', NULL, 'Transcriptional regulatory protein', 206, NULL, NULL, 92250),
(92251, '3.40.50.1010-FF-000282', NULL, NULL, 154, NULL, NULL, 92251),
(92252, '3.80.10.10-FF-000778', NULL, 'Putative leucine-rich repeat receptor-like protein kinase', 123, NULL, NULL, 92252),
(92253, '1.10.472.10-FF-000212', NULL, 'Cyclin-T1-2', 184, NULL, NULL, 92253),
(92254, '3.10.180.10-FF-000026', NULL, 'Lactoylglutathione lyase', 154, NULL, NULL, 92254),
(92255, '1.10.1520.10-FF-000083', NULL, 'Dicer-like protein', 171, NULL, NULL, 92255),
(92256, '2.60.120.970-FF-000075', NULL, 'Nodal homolog 2-B', 244, NULL, NULL, 92256),
(92257, '1.25.10.10-FF-000033', NULL, 'Diaphanous related formin 2', 234, NULL, NULL, 92257),
(92258, '3.30.43.10-FF-000030', NULL, 'Dimethylmenaquinone methyltransferase', 73, NULL, NULL, 92258),
(92259, '1.10.472.80-FF-000194', NULL, NULL, 124, NULL, NULL, 92259),
(92260, '1.10.1420.10-FF-000024', NULL, 'DNA mismatch repair protein', 170, NULL, NULL, 92260),
(92261, '3.30.160.60-FF-001845', NULL, 'Transcription factor Msn2p', 34, NULL, NULL, 92261),
(92262, '1.25.10.10-FF-000089', NULL, 'Rho family-interacting cell polarization regulator 1', 154, NULL, NULL, 92262),
(92263, '1.20.58.60-FF-000887', NULL, 'Uncharacterized protein', 76, NULL, NULL, 92263),
(92264, '3.30.1360.120-FF-000052', NULL, 'Folate-binding protein', 122, NULL, NULL, 92264),
(92265, '1.10.287.110-FF-000093', NULL, 'DNAJ heat shock N-terminal domain-containing protein-like', 84, NULL, NULL, 92265),
(92266, '1.25.10.10-FF-000145', NULL, 'Regulatory-associated protein of TOR 1', 295, NULL, NULL, 92266),
(92267, '3.30.200.20-FF-002006', NULL, 'Uncharacterized protein', 95, NULL, NULL, 92267),
(92268, '1.10.510.10-FF-001898', NULL, 'Uncharacterized protein', 220, NULL, NULL, 92268),
(92269, '3.40.50.1820-FF-000991', NULL, 'GPI inositol-deacylase', 246, NULL, NULL, 92269),
(92270, '1.10.3720.10-FF-000031', NULL, 'Phosphate transport system permease protein', 295, NULL, NULL, 92270),
(92271, '3.90.1420.10-FF-000055', NULL, 'Predicted protein', 88, NULL, NULL, 92271),
(92272, '1.20.1250.20-FF-001826', NULL, 'Solute carrier family 45 member 1', 151, NULL, NULL, 92272),
(92273, '2.60.200.20-FF-000160', NULL, 'Kinesin motor domain protein', 141, NULL, NULL, 92273),
(92274, '3.90.1150.10-FF-000303', NULL, '4-aminobutyrate aminotransferase', 140, NULL, NULL, 92274),
(92275, '1.20.1560.10-FF-000818', NULL, 'Sulfonylurea receptor, putative', 107, NULL, NULL, 92275);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(92276, '3.40.50.300-FF-008225', NULL, 'Uncharacterized protein', 64, NULL, NULL, 92276),
(92277, '1.25.10.10-FF-001663', NULL, 'AaceriADR292Wp', 331, NULL, NULL, 92277),
(92278, '2.130.10.10-FF-005589', NULL, 'Sortilin', 199, NULL, NULL, 92278),
(92279, '3.30.420.10-FF-000659', NULL, NULL, 191, NULL, NULL, 92279),
(92280, '2.60.40.790-FF-000129', NULL, NULL, 95, NULL, NULL, 92280),
(92281, '1.25.10.10-FF-001775', NULL, 'YALI0F01793p', 865, NULL, NULL, 92281),
(92282, '3.40.50.720-FF-001331', NULL, 'SDR family oxidoreductase', 256, NULL, NULL, 92282),
(92283, '1.25.10.10-FF-002124', NULL, 'Serine/threonine-protein kinase ULK4', 321, NULL, NULL, 92283),
(92284, '3.30.450.20-FF-000546', NULL, 'Predicted protein', 103, NULL, NULL, 92284),
(92285, '1.10.10.10-FF-000521', NULL, 'Histone H1', 86, NULL, NULL, 92285),
(92286, '3.30.300.10-FF-000038', NULL, 'S-adenosylmethionine synthase', 120, NULL, NULL, 92286),
(92287, '3.80.10.10-FF-002003', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 265, NULL, NULL, 92287),
(92288, '1.25.40.10-FF-001277', NULL, 'Intraflagellar transport 88 homolog', 159, NULL, NULL, 92288),
(92289, '3.20.20.70-FF-000361', NULL, 'N-(5''-phosphoribosyl)anthranilate isomerase', 202, NULL, NULL, 92289),
(92290, '3.30.70.20-FF-000005', NULL, 'Respiratory nitrate reductase beta subunit', 84, NULL, NULL, 92290),
(92291, '2.70.50.70-FF-000003', NULL, 'Endo-beta-1,4-glucanase D', 229, NULL, NULL, 92291),
(92292, '3.30.200.20-FF-001562', NULL, 'Uncharacterized protein', 102, NULL, NULL, 92292),
(92293, '1.20.1050.10-FF-000212', NULL, 'Glutathione transferase11', 74, NULL, NULL, 92293),
(92294, '3.40.50.2300-FF-000697', NULL, 'Glutamate receptor DGluRIIB', 190, NULL, NULL, 92294),
(92295, '2.60.40.10-FF-002520', NULL, 'L1 CAM ADhesion molecule homolog', 100, NULL, NULL, 92295),
(92296, '3.40.50.300-FF-006045', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', 210, NULL, NULL, 92296),
(92297, '3.30.200.20-FF-002051', NULL, 'Predicted protein', 118, NULL, NULL, 92297),
(92298, '3.40.50.200-FF-000057', NULL, 'Alkaline serine protease', 281, NULL, NULL, 92298),
(92299, '2.60.120.10-FF-000055', NULL, 'pirin', 148, NULL, NULL, 92299),
(92300, '1.10.560.10-FF-000086', NULL, 'Bardet-Biedl syndrome 12', 226, NULL, NULL, 92300),
(92301, '3.40.50.1440-FF-000017', NULL, 'Tubulin epsilon chain', 400, NULL, NULL, 92301),
(92302, '3.90.1490.10-FF-000003', NULL, 'Diphthine--ammonia ligase', 95, NULL, NULL, 92302),
(92303, '3.40.50.1980-FF-000100', NULL, 'Heme ABC superfamily ATP binding cassette transporter, binding protein', 142, NULL, NULL, 92303),
(92304, '2.130.10.10-FF-003498', NULL, 'Inositol polyphosphate phosphatase', 261, NULL, NULL, 92304),
(92305, '3.80.10.10-FF-004089', NULL, 'NLR family CARD domain containing 5', 124, NULL, NULL, 92305),
(92306, '1.10.510.10-FF-000431', NULL, 'Putative inactive leucine-rich repeat receptor-like protein kinase', 203, NULL, NULL, 92306),
(92307, '3.40.50.720-FF-001831', NULL, 'D-3-phosphoglycerate dehydrogenase', 133, NULL, NULL, 92307),
(92308, '3.50.50.60-FF-000111', NULL, 'Zeta-carotene desaturase', 291, NULL, NULL, 92308),
(92309, '3.40.190.80-FF-000086', NULL, 'Bisphosphate nucleotidase', 109, NULL, NULL, 92309),
(92310, '1.25.10.10-FF-000084', NULL, '26S proteasome non-ATPase regulatory subunit 2 homolog', 441, NULL, NULL, 92310),
(92311, '1.20.58.1540-FF-000002', NULL, 'Ring finger protein 207', 134, NULL, NULL, 92311),
(92312, '3.30.200.20-FF-001287', NULL, 'Spore coat protein, CotS family', 104, NULL, NULL, 92312),
(92313, '2.30.30.40-FF-000455', NULL, 'Uncharacterized protein', 145, NULL, NULL, 92313),
(92314, '1.10.510.10-FF-003011', NULL, NULL, 133, NULL, NULL, 92314),
(92315, '3.30.40.10-FF-001748', NULL, 'Zinc finger (C3HC4-type RING finger) family protein', 135, NULL, NULL, 92315),
(92316, '3.30.160.60-FF-006331', NULL, NULL, 88, NULL, NULL, 92316),
(92317, '1.25.40.20-FF-000712', NULL, 'SH3 and multiple ankyrin repeat domains 1', 157, NULL, NULL, 92317),
(92318, '2.40.50.100-FF-000047', NULL, 'Exosome complex component RRP4', 52, NULL, NULL, 92318);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(92319, '3.80.10.10-FF-003633', NULL, 'Predicted protein', 169, NULL, NULL, 92319),
(92320, '3.90.1750.10-FF-000102', NULL, 'E3 ubiquitin-protein ligase', 80, NULL, NULL, 92320),
(92321, '1.20.1560.10-FF-000869', NULL, 'Predicted protein', 132, NULL, NULL, 92321),
(92322, '3.40.50.2300-FF-001158', NULL, NULL, 121, NULL, NULL, 92322),
(92323, '3.40.33.10-FF-000175', NULL, 'Uncharacterized protein', 90, NULL, NULL, 92323),
(92324, '1.10.10.1800-FF-000009', NULL, 'Uncharacterized protein', 87, NULL, NULL, 92324),
(92325, '3.90.190.10-FF-000487', NULL, 'Uncharacterized protein', 161, NULL, NULL, 92325),
(92326, '2.30.110.10-FF-000033', NULL, 'Nitroreductase family deazaflavin-dependent oxidoreductase', 114, NULL, NULL, 92326),
(92327, '2.10.25.10-FF-000946', NULL, 'Delta-like protein', 47, NULL, NULL, 92327),
(92328, '3.60.20.40-FF-000029', NULL, 'Gamma-glutamyltransferase, putative', 154, NULL, NULL, 92328),
(92329, '3.30.160.60-FF-006050', NULL, NULL, 75, NULL, NULL, 92329),
(92330, '2.130.10.10-FF-000182', NULL, 'DNA damage-binding protein 1a', 333, NULL, NULL, 92330),
(92331, '3.50.20.20-FF-000007', NULL, '14 kDa phosphohistidine phosphatase', 114, NULL, NULL, 92331),
(92332, '3.40.50.300-FF-000087', NULL, 'Recombinase RecA', 298, NULL, NULL, 92332),
(92333, '3.30.800.10-FF-000008', NULL, 'Putative 1-phosphatidylinositol-3-phosphate 5-kinase FAB1D', 179, NULL, NULL, 92333),
(92334, '3.30.70.1660-FF-000041', NULL, 'Mitochondrial translation release factor 1', 20, NULL, NULL, 92334),
(92335, '1.20.58.190-FF-000003', NULL, 'Translin family protein', 130, NULL, NULL, 92335),
(92336, '3.40.920.10-FF-000015', NULL, 'Putative 2-ketoglutarate ferredoxin oxidoreductase (Alpha)', 194, NULL, NULL, 92336),
(92337, '3.30.460.90-FF-000005', NULL, 'Cyclic GMP-AMP synthase', 180, NULL, NULL, 92337),
(92338, '3.30.460.80-FF-000002', NULL, 'NADH dehydrogenase iron-sulfur protein 3, mitochondrial', 148, NULL, NULL, 92338),
(92339, '2.60.40.380-FF-000006', NULL, 'Purple acid phosphatase', 114, NULL, NULL, 92339),
(92340, '3.30.70.20-FF-000056', NULL, '4Fe-4S dicluster domain-containing protein', 98, NULL, NULL, 92340),
(92341, '1.10.510.10-FF-002522', NULL, 'Probable serine/threonine-protein kinase DDB_G0276461', 306, NULL, NULL, 92341),
(92342, '2.40.20.10-FF-000097', NULL, 'Uncharacterized protein', 136, NULL, NULL, 92342),
(92343, '3.40.50.300-FF-007394', NULL, 'mRNA cleavage and polyadenylation factor CLP1', 278, NULL, NULL, 92343),
(92344, '2.60.120.380-FF-000049', NULL, 'Uncharacterized protein', 138, NULL, NULL, 92344),
(92345, '1.10.238.10-FF-000449', NULL, 'Serine/threonine-protein phosphatase', 117, NULL, NULL, 92345),
(92346, '2.90.10.10-FF-000004', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', 130, NULL, NULL, 92346),
(92347, '2.40.290.10-FF-000032', NULL, 'Putative RNA-binding protein 15B', 174, NULL, NULL, 92347),
(92348, '3.40.640.10-FF-000033', NULL, 'Aspartate aminotransferase', 222, NULL, NULL, 92348),
(92349, '1.10.287.130-FF-000099', NULL, 'Two-component sensor histidine kinase', 79, NULL, NULL, 92349),
(92350, '3.10.20.90-FF-001002', NULL, 'Uncharacterized protein', 85, NULL, NULL, 92350),
(92351, '1.20.5.3600-FF-000002', NULL, 'Nucleoporin nup44', 59, NULL, NULL, 92351),
(92352, '3.40.1810.10-FF-000068', NULL, NULL, 88, NULL, NULL, 92352),
(92353, '1.10.287.660-FF-000027', NULL, 'NOP56 ribonucleoprotein homolog', 31, NULL, NULL, 92353),
(92354, '3.30.530.20-FF-000081', NULL, 'Uncharacterized protein', 189, NULL, NULL, 92354),
(92355, '2.40.10.10-FF-000091', NULL, 'Kallikrein-4', 105, NULL, NULL, 92355),
(92356, '2.60.40.10-FF-004206', NULL, NULL, 79, NULL, NULL, 92356),
(92357, '1.10.720.140-FF-000002', NULL, 'uncharacterized protein LOC108096637', 77, NULL, NULL, 92357),
(92358, '3.40.33.10-FF-000068', NULL, 'Uncharacterized protein', 162, NULL, NULL, 92358),
(92359, '3.90.190.10-FF-000436', NULL, 'Uncharacterized protein', 67, NULL, NULL, 92359),
(92360, '3.40.50.1100-FF-000213', NULL, 'Uncharacterized protein', 82, NULL, NULL, 92360),
(92361, '3.40.50.880-FF-000221', NULL, 'Predicted protein', 102, NULL, NULL, 92361);
INSERT INTO "PUBLIC"."MODEL" VALUES
(92362, '1.20.1740.10-FF-000237', NULL, 'Uncharacterized protein', 386, NULL, NULL, 92362),
(92363, '1.25.40.10-FF-001496', NULL, 'Pentatricopeptide repeat-containing protein At3g49710', 131, NULL, NULL, 92363),
(92364, '3.40.50.1820-FF-001328', NULL, 'Protein phosphatase methylesterase 1', 257, NULL, NULL, 92364),
(92365, '1.20.1310.10-FF-000031', NULL, 'Ubiquitin ligase subunit CulD', 124, NULL, NULL, 92365),
(92366, '3.30.1680.10-FF-000020', NULL, 'Plexin C1', 60, NULL, NULL, 92366),
(92367, '3.80.10.10-FF-001542', NULL, 'Predicted protein', 146, NULL, NULL, 92367),
(92368, '1.20.58.390-FF-000237', NULL, 'Uncharacterized protein', 137, NULL, NULL, 92368),
(92369, '2.60.40.10-FF-004144', NULL, NULL, 115, NULL, NULL, 92369),
(92370, '3.40.630.10-FF-000184', NULL, 'Nicastrin-like Protein', 243, NULL, NULL, 92370),
(92371, '3.90.260.10-FF-000026', NULL, 'Protein-glutamine gamma-glutamyltransferase, putative', 184, NULL, NULL, 92371),
(92372, '3.30.2160.10-FF-000048', NULL, 'Uncharacterized protein', 78, NULL, NULL, 92372),
(92373, '3.30.70.1730-FF-000028', NULL, '50S ribosomal protein L10', 128, NULL, NULL, 92373),
(92374, '1.25.40.10-FF-004306', NULL, 'Uncharacterized protein', 188, NULL, NULL, 92374),
(92375, '2.30.30.40-FF-000124', NULL, 'obscurin isoform X2', 71, NULL, NULL, 92375),
(92376, '3.30.420.40-FF-000533', NULL, 'Uncharacterized protein', 21, NULL, NULL, 92376),
(92377, '3.30.497.10-FF-000055', NULL, 'Serpin peptidase inhibitor, clade B (ovalbumin), member 1,-like 3', 181, NULL, NULL, 92377),
(92378, '1.20.1070.10-FF-000495', NULL, 'Predicted protein', 280, NULL, NULL, 92378),
(92379, '2.60.40.10-FF-004088', NULL, NULL, 119, NULL, NULL, 92379),
(92380, '3.40.50.1000-FF-000239', NULL, 'HAD hydrolase, family IIID, variant', 221, NULL, NULL, 92380),
(92381, '2.60.40.10-FF-001738', NULL, 'CD226 molecule', 104, NULL, NULL, 92381),
(92382, '1.10.510.10-FF-004208', NULL, NULL, 217, NULL, NULL, 92382),
(92383, '1.25.40.20-FF-001499', NULL, 'Uncharacterized protein', 65, NULL, NULL, 92383),
(92384, '3.30.200.20-FF-001843', NULL, 'Uncharacterized protein', 103, NULL, NULL, 92384),
(92385, '1.10.10.10-FF-000414', NULL, 'LysR family transcriptional regulator', 86, NULL, NULL, 92385),
(92386, '3.10.20.90-FF-000215', NULL, 'Ubiquitin carboxyl-terminal hydrolase 7, variant', 116, NULL, NULL, 92386),
(92387, '3.30.365.10-FF-000064', NULL, 'Protein CBG19218', 47, NULL, NULL, 92387),
(92388, '1.10.510.10-FF-002741', NULL, NULL, 78, NULL, NULL, 92388),
(92389, '3.40.630.10-FF-000240', NULL, 'Aspartate aminotransferase', 176, NULL, NULL, 92389),
(92390, '1.20.140.10-FF-000125', NULL, 'Uncharacterized protein', 102, NULL, NULL, 92390),
(92391, '3.60.21.10-FF-000231', NULL, 'Acid sphingomyelinase-like phosphodiesterase', 304, NULL, NULL, 92391),
(92392, '3.40.720.10-FF-000359', NULL, 'Sulfatase 2', 173, NULL, NULL, 92392),
(92393, '2.10.70.10-FF-000079', NULL, 'Complement decay-accelerating factor', 63, NULL, NULL, 92393),
(92394, '3.90.70.10-FF-000505', NULL, 'Ubiquitin C-terminal hydrolase, putative (AFU_orthologue AFUA_5G13620)', 395, NULL, NULL, 92394),
(92395, '3.30.160.60-FF-004751', NULL, NULL, 60, NULL, NULL, 92395),
(92396, '2.60.40.10-FF-001396', NULL, 'Interleukin 13 receptor subunit alpha 2', 101, NULL, NULL, 92396),
(92397, '1.20.1560.10-FF-000695', NULL, 'ABC transporter', 377, NULL, NULL, 92397),
(92398, '3.10.110.10-FF-000022', NULL, 'Ubiquitin-conjugating enzyme E2 W', 150, NULL, NULL, 92398),
(92399, '1.25.40.10-FF-003694', NULL, 'Tetratricopeptide repeat protein 21 homolog', 204, NULL, NULL, 92399),
(92400, '2.110.10.10-FF-000014', NULL, 'Matrix metallopeptidase 28', 196, NULL, NULL, 92400),
(92401, '3.40.630.30-FF-000246', NULL, 'RNA cytidine acetyltransferase', 219, NULL, NULL, 92401),
(92402, '2.30.30.30-FF-000121', NULL, 'Uncharacterized protein', 62, NULL, NULL, 92402),
(92403, '3.30.70.3250-FF-000023', NULL, NULL, 79, NULL, NULL, 92403),
(92404, '3.30.40.10-FF-001804', NULL, 'RING-type E3 ubiquitin transferase', 51, NULL, NULL, 92404),
(92405, '2.130.10.10-FF-004515', NULL, 'Uncharacterized protein', 233, NULL, NULL, 92405);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(92406, '2.130.10.10-FF-005319', NULL, 'Uncharacterized protein', 202, NULL, NULL, 92406),
(92407, '2.40.30.10-FF-000160', NULL, '50S ribosomal protein L3', 94, NULL, NULL, 92407),
(92408, '1.25.10.10-FF-001994', NULL, 'Predicted protein', 151, NULL, NULL, 92408),
(92409, '3.30.70.580-FF-000047', NULL, 'tRNA pseudouridine synthase A', 119, NULL, NULL, 92409),
(92410, '1.10.3470.10-FF-000033', NULL, 'Zinc ABC transporter permease', 234, NULL, NULL, 92410),
(92411, '2.60.120.260-FF-000305', NULL, 'Predicted protein', 179, NULL, NULL, 92411),
(92412, '1.10.10.10-FF-001988', NULL, 'Uncharacterized protein', 48, NULL, NULL, 92412),
(92413, '2.30.30.40-FF-000511', NULL, 'Small G protein signaling modulator 3', 49, NULL, NULL, 92413),
(92414, '3.80.10.10-FF-003307', NULL, 'Uncharacterized protein', 223, NULL, NULL, 92414),
(92415, '1.20.1270.420-FF-000005', NULL, 'Inhibitor of nuclear factor kappa B kinase subunit epsilon', 254, NULL, NULL, 92415),
(92416, '3.30.70.980-FF-000010', NULL, 'translational activator of cytochrome c oxidase 1', 73, NULL, NULL, 92416),
(92417, '3.30.2410.10-FF-000046', NULL, 'Ubiquitin-protein ligase E3B', 141, NULL, NULL, 92417),
(92418, '3.30.497.10-FF-000004', NULL, 'Serpin family B member 1', 225, NULL, NULL, 92418),
(92419, '1.20.1070.10-FF-000388', NULL, 'Uncharacterized protein', 338, NULL, NULL, 92419),
(92420, '2.60.40.10-FF-005667', NULL, NULL, 86, NULL, NULL, 92420),
(92421, '3.40.710.10-FF-000185', NULL, 'Uncharacterized protein', 192, NULL, NULL, 92421),
(92422, '3.30.70.330-FF-002024', NULL, NULL, 71, NULL, NULL, 92422),
(92423, '2.60.120.10-FF-000386', NULL, 'Cupin-like_domain_containing_protein_-_putative', 178, NULL, NULL, 92423),
(92424, '3.30.390.10-FF-000026', NULL, 'o-succinylbenzoate synthase', 155, NULL, NULL, 92424),
(92425, '3.60.20.30-FF-000021', NULL, NULL, 110, NULL, NULL, 92425),
(92426, '3.10.129.10-FF-000121', NULL, '4-hydroxybenzoyl-CoA thioesterase', 142, NULL, NULL, 92426),
(92427, '3.40.50.300-FF-006612', NULL, 'Predicted protein', 95, NULL, NULL, 92427),
(92428, '3.60.20.40-FF-000024', NULL, 'Gamma glutamyl transpeptidase, putative', 188, NULL, NULL, 92428),
(92429, '2.130.10.10-FF-002716', NULL, 'Sister-chromatid cohesion-and DNA replication-associated protein, putative', 311, NULL, NULL, 92429),
(92430, '2.30.29.30-FF-001163', NULL, 'Uncharacterized protein', 104, NULL, NULL, 92430),
(92431, '3.30.505.10-FF-000165', NULL, NULL, 87, NULL, NULL, 92431),
(92432, '3.40.50.720-FF-001617', NULL, 'Hydroxysteroid (17-beta) dehydrogenase 14', 107, NULL, NULL, 92432),
(92433, '3.40.1090.10-FF-000001', NULL, 'neuropathy target esterase isoform X2', 247, NULL, NULL, 92433),
(92434, '1.10.10.10-FF-000465', NULL, 'Proliferation-associated protein 2g4, putative', 62, NULL, NULL, 92434),
(92435, '2.30.29.30-FF-000887', NULL, 'Putative actin binding protein anillin', 106, NULL, NULL, 92435),
(92436, '3.40.50.1820-FF-000772', NULL, 'Alpha/beta hydrolase', 285, NULL, NULL, 92436),
(92437, '1.10.287.110-FF-000216', NULL, 'Chaperone protein dnaJ 49 isoform A', 124, NULL, NULL, 92437),
(92438, '3.40.50.10890-FF-000001', NULL, 'Cleavage and polyadenylation specificity factor subunit 3', 182, NULL, NULL, 92438),
(92439, '1.25.40.10-FF-000035', NULL, 'Tetratricopeptide repeat domain 7B', 319, NULL, NULL, 92439),
(92440, '2.50.20.10-FF-000012', NULL, 'Outer-membrane lipoprotein carrier protein', 172, NULL, NULL, 92440),
(92441, '1.20.140.10-FF-000018', NULL, 'Acyl-CoA dehydrogenase family member 10', 158, NULL, NULL, 92441),
(92442, '2.102.10.10-FF-000066', NULL, 'Ferredoxin, putative', 99, NULL, NULL, 92442),
(92443, '2.10.50.10-FF-000128', NULL, 'Tumor necrosis factor receptor superfamily, member 1a', 47, NULL, NULL, 92443),
(92444, '3.40.30.10-FF-000882', NULL, 'Predicted protein', 204, NULL, NULL, 92444),
(92445, '2.40.50.140-FF-000216', NULL, 'Cell division cycle and apoptosis regulator 1', 79, NULL, NULL, 92445),
(92446, '3.30.1380.20-FF-000034', NULL, 'Trafficking protein particle complex 6b-like', 94, NULL, NULL, 92446),
(92447, '3.40.30.10-FF-001101', NULL, 'Predicted protein', 66, NULL, NULL, 92447);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(92448, '1.20.5.190-FF-000172', NULL, NULL, 62, NULL, NULL, 92448),
(92449, '1.20.58.190-FF-000008', NULL, 'Translin-associated factor TraX, putative', 133, NULL, NULL, 92449),
(92450, '3.30.200.20-FF-000213', NULL, 'TGF-beta receptor type-2', 96, NULL, NULL, 92450),
(92451, '2.170.260.40-FF-000002', NULL, '5''-3'' exoribonuclease 1', 174, NULL, NULL, 92451),
(92452, '3.40.50.790-FF-000020', NULL, 'GM12858', 69, NULL, NULL, 92452),
(92453, '6.10.250.3250-FF-000001', NULL, '60S ribosomal protein L13a', 52, NULL, NULL, 92453),
(92454, '2.40.50.140-FF-000323', NULL, '30S ribosomal protein S1', 82, NULL, NULL, 92454),
(92455, '3.40.50.300-FF-001666', NULL, 'LuxR family transcriptional regulator', 147, NULL, NULL, 92455),
(92456, '1.10.357.150-FF-000003', NULL, 'Centromere/kinetochore protein zw10', 192, NULL, NULL, 92456),
(92457, '1.10.30.10-FF-000141', NULL, 'YALI0D26972p', 88, NULL, NULL, 92457),
(92458, '3.10.20.90-FF-000159', NULL, 'Ras association domain family member 2', 164, NULL, NULL, 92458),
(92459, '1.20.1070.10-FF-000787', NULL, 'Uncharacterized protein', 378, NULL, NULL, 92459),
(92460, '1.10.167.10-FF-000043', NULL, 'Sst2p', 151, NULL, NULL, 92460),
(92461, '2.10.60.10-FF-000073', NULL, 'Uncharacterized protein', 41, NULL, NULL, 92461),
(92462, '1.10.10.10-FF-000813', NULL, 'Probable transcriptional regulator', 147, NULL, NULL, 92462),
(92463, '1.25.10.10-FF-000207', NULL, 'Pumilio RNA-binding family member 3', 187, NULL, NULL, 92463),
(92464, '2.60.40.10-FF-002290', NULL, 'Glycerophosphocholine phosphodiesterase 1', 123, NULL, NULL, 92464),
(92465, '3.30.160.60-FF-002065', NULL, 'Si:ch211-266d19.4', 28, NULL, NULL, 92465),
(92466, '3.20.20.70-FF-000809', NULL, NULL, 113, NULL, NULL, 92466),
(92467, '2.60.120.310-FF-000012', NULL, 'probable peptidylglycine alpha-hydroxylating monooxygenase 1', 167, NULL, NULL, 92467),
(92468, '1.20.120.730-FF-000030', NULL, 'LOC553407 protein', 33, NULL, NULL, 92468),
(92469, '3.40.1370.10-FF-000039', NULL, '50S ribosomal protein L4', 202, NULL, NULL, 92469),
(92470, '3.40.50.12650-FF-000024', NULL, 'Predicted protein', 145, NULL, NULL, 92470),
(92471, '3.40.800.10-FF-000017', NULL, 'Agmatinase-like protein', 316, NULL, NULL, 92471),
(92472, '3.30.9.10-FF-000283', NULL, 'Uncharacterized protein', 185, NULL, NULL, 92472),
(92473, '1.10.10.1100-FF-000013', NULL, 'Sarcosine oxidase alpha subunit', 59, NULL, NULL, 92473),
(92474, '3.30.160.60-FF-004133', NULL, NULL, 28, NULL, NULL, 92474),
(92475, '4.10.1240.10-FF-000058', NULL, 'Uncharacterized protein', 111, NULL, NULL, 92475),
(92476, '1.20.920.10-FF-000078', NULL, 'Uncharacterized protein, isoform B', 114, NULL, NULL, 92476),
(92477, '3.40.50.300-FF-005937', NULL, 'RNA helicase, putative', 225, NULL, NULL, 92477),
(92478, '3.60.21.10-FF-000124', NULL, 'Metallo phosphoesterase', 294, NULL, NULL, 92478),
(92479, '3.40.1500.10-FF-000022', NULL, 'Uncharacterized protein', 263, NULL, NULL, 92479),
(92480, '3.30.160.60-FF-006336', NULL, NULL, 59, NULL, NULL, 92480),
(92481, '1.20.1070.10-FF-001551', NULL, 'Uncharacterized protein', 175, NULL, NULL, 92481),
(92482, '2.60.40.10-FF-005993', NULL, NULL, 84, NULL, NULL, 92482),
(92483, '3.10.50.10-FF-000002', NULL, 'Chitinase domain-containing protein 1', 55, NULL, NULL, 92483),
(92484, '3.40.109.10-FF-000023', NULL, 'Nitroreductase', 188, NULL, NULL, 92484),
(92485, '2.30.30.30-FF-000014', NULL, '60S ribosomal protein L6', 85, NULL, NULL, 92485),
(92486, '1.10.8.10-FF-000099', NULL, 'Ubiquitin-associated domain-containing protein 1', 82, NULL, NULL, 92486),
(92487, '3.30.559.30-FF-000060', NULL, 'Non-ribosomal peptide synthetase', 228, NULL, NULL, 92487),
(92488, '2.30.30.40-FF-000017', NULL, 'Formin-binding protein 1-like isoform 1', 65, NULL, NULL, 92488),
(92489, '1.25.40.20-FF-000419', NULL, 'Regulatory protein SWI6', 272, NULL, NULL, 92489),
(92490, '1.10.472.10-FF-000156', NULL, 'Cyclin-D2-2', 73, NULL, NULL, 92490),
(92491, '3.80.10.10-FF-000486', NULL, 'probable LRR receptor-like serine/threonine-protein kinase At1g12460', 363, NULL, NULL, 92491);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(92492, '3.90.740.10-FF-000052', NULL, 'Valine--tRNA ligase', 38, NULL, NULL, 92492),
(92493, '3.40.50.1100-FF-000264', NULL, 'Pyridoxal-5''-phosphate-dependent protein beta subunit', 110, NULL, NULL, 92493),
(92494, '3.40.50.300-FF-002099', NULL, 'ABC transporter, putative', 269, NULL, NULL, 92494),
(92495, '3.30.450.240-FF-000003', NULL, 'KICSTOR complex protein C12orf66 homolog', 127, NULL, NULL, 92495),
(92496, '3.40.50.150-FF-001688', NULL, NULL, 113, NULL, NULL, 92496),
(92497, '2.60.120.620-FF-000043', NULL, 'Serine/threonine-protein kinase CTR1', 130, NULL, NULL, 92497),
(92498, '1.10.510.10-FF-000263', NULL, 'MAP kinase skh1/pek1', 207, NULL, NULL, 92498),
(92499, '2.60.40.10-FF-002413', NULL, 'Extracellular endoglucanase, putative', 100, NULL, NULL, 92499),
(92500, '2.60.120.1190-FF-000011', NULL, 'Uncharacterized protein', 205, NULL, NULL, 92500),
(92501, '1.10.510.10-FF-000605', NULL, 'serine/threonine-protein kinase 3 isoform X2', 274, NULL, NULL, 92501),
(92502, '2.130.10.10-FF-001486', NULL, 'Polyadenylation factor subunit, putative', 163, NULL, NULL, 92502),
(92503, '1.25.40.10-FF-003289', NULL, 'Os07g0172600 protein', 127, NULL, NULL, 92503),
(92504, '1.25.40.10-FF-004183', NULL, 'Protein CBR-DDL-3', 85, NULL, NULL, 92504),
(92505, '2.130.10.10-FF-000300', NULL, 'THO complex subunit 3', 135, NULL, NULL, 92505),
(92506, '1.25.50.20-FF-000089', NULL, 'Aminopeptidase', 283, NULL, NULL, 92506),
(92507, '3.20.20.360-FF-000007', NULL, 'Uncharacterized protein', 62, NULL, NULL, 92507),
(92508, '1.20.890.10-FF-000029', NULL, 'Dpy-30 1', 56, NULL, NULL, 92508),
(92509, '1.10.10.10-FF-000139', NULL, 'Fur family transcriptional regulator', 84, NULL, NULL, 92509),
(92510, '3.30.420.10-FF-000715', NULL, NULL, 89, NULL, NULL, 92510),
(92511, '1.25.40.20-FF-000206', NULL, 'Ankyrin repeat domain-containing protein 9', 163, NULL, NULL, 92511),
(92512, '2.40.128.150-FF-000001', NULL, 'N-hydroxyarylamine O-acetyltransferase NhoA', 114, NULL, NULL, 92512),
(92513, '3.30.70.330-FF-001456', NULL, NULL, 89, NULL, NULL, 92513),
(92514, '3.80.10.10-FF-003127', NULL, 'GM13370p', 81, NULL, NULL, 92514),
(92515, '2.40.70.10-FF-000313', NULL, NULL, 175, NULL, NULL, 92515),
(92516, '1.10.720.60-FF-000006', NULL, 'enolase-phosphatase E1 isoform X2', 33, NULL, NULL, 92516),
(92517, '2.60.40.1180-FF-000098', NULL, 'Neutral alpha-glucosidase AB', 135, NULL, NULL, 92517),
(92518, '3.40.50.1440-FF-000062', NULL, 'Tubulin gamma chain', 405, NULL, NULL, 92518),
(92519, '3.30.890.10-FF-000014', NULL, 'Methyl-CpG-binding domain protein 3b', 60, NULL, NULL, 92519),
(92520, '2.80.10.50-FF-000258', NULL, 'Predicted protein', 173, NULL, NULL, 92520),
(92521, '1.10.540.10-FF-000107', NULL, 'Acyl-CoA dehydrogenase long chain', 89, NULL, NULL, 92521),
(92522, '3.10.50.30-FF-000008', NULL, 'Transcription elongation factor GreA', 80, NULL, NULL, 92522),
(92523, '3.40.50.1820-FF-001109', NULL, 'Carboxylic ester hydrolase', 371, NULL, NULL, 92523),
(92524, '1.10.238.200-FF-000009', NULL, 'Defective in cullin neddylation protein', 108, NULL, NULL, 92524),
(92525, '1.25.10.10-FF-001668', NULL, 'Uncharacterized protein', 322, NULL, NULL, 92525),
(92526, '2.130.10.10-FF-005757', NULL, 'Hepatocyte growth factor receptor', 116, NULL, NULL, 92526),
(92527, '3.30.310.130-FF-000035', NULL, 'Predicted protein', 86, NULL, NULL, 92527),
(92528, '1.25.40.1030-FF-000024', NULL, 'Protein transport protein sec16', 403, NULL, NULL, 92528),
(92529, '3.30.70.330-FF-002350', NULL, NULL, 106, NULL, NULL, 92529),
(92530, '1.20.140.10-FF-000069', NULL, 'Cytochrome c-552', 106, NULL, NULL, 92530),
(92531, '3.30.160.60-FF-004532', NULL, NULL, 25, NULL, NULL, 92531),
(92532, '3.60.21.10-FF-000175', NULL, 'Vacuolar protein sorting 29', 161, NULL, NULL, 92532),
(92533, '1.25.10.10-FF-002562', NULL, 'Uncharacterized protein', 170, NULL, NULL, 92533),
(92534, '4.10.400.10-FF-000142', NULL, 'MAM and LDL receptor class A domain-containing 1', 39, NULL, NULL, 92534),
(92535, '3.30.360.10-FF-000042', NULL, 'Glucose-6-phosphate 1-dehydrogenase', 275, NULL, NULL, 92535);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(92536, '3.30.420.10-FF-000367', NULL, NULL, 198, NULL, NULL, 92536),
(92537, '2.60.120.10-FF-000566', NULL, 'Pirin', 107, NULL, NULL, 92537),
(92538, '2.70.98.60-FF-000003', NULL, 'Adenylyl-sulfate kinase', 309, NULL, NULL, 92538),
(92539, '3.30.450.260-FF-000009', NULL, 'Soluble guanylate cyclase gcy-31', 148, NULL, NULL, 92539),
(92540, '2.60.40.10-FF-000378', NULL, 'Nectin cell adhesion molecule 3', 112, NULL, NULL, 92540),
(92541, '3.30.160.60-FF-000822', NULL, 'Zinc finger protein 234, isoform CRA_a', 28, NULL, NULL, 92541),
(92542, '3.30.70.330-FF-001861', NULL, NULL, 107, NULL, NULL, 92542),
(92543, '3.40.50.1000-FF-000565', NULL, NULL, 108, NULL, NULL, 92543),
(92544, '1.25.10.10-FF-000140', NULL, 'Serine/threonine-protein kinase mTOR', 194, NULL, NULL, 92544),
(92545, '2.60.120.330-FF-000170', NULL, 'Uncharacterized protein', 269, NULL, NULL, 92545),
(92546, '3.90.480.10-FF-000014', NULL, 'Ferredoxin-sulfite reductase', 90, NULL, NULL, 92546),
(92547, '3.40.30.10-FF-000258', NULL, 'Glutathione S-transferase', 80, NULL, NULL, 92547),
(92548, '3.30.40.140-FF-000005', NULL, 'Uncharacterized protein', 101, NULL, NULL, 92548),
(92549, '3.40.50.1460-FF-000068', NULL, 'Uncharacterized protein', 235, NULL, NULL, 92549),
(92550, '3.90.1480.20-FF-000062', NULL, 'Uncharacterized protein', 58, NULL, NULL, 92550),
(92551, '1.10.560.10-FF-000142', NULL, 'Uncharacterized protein', 40, NULL, NULL, 92551),
(92552, '3.90.190.20-FF-000023', NULL, 'Bifunctional folylpolyglutamate synthase/dihydrofolate synthase', 143, NULL, NULL, 92552),
(92553, '3.30.760.10-FF-000010', NULL, 'Eukaryotic translation initiation factor 4E1', 183, NULL, NULL, 92553),
(92554, '1.10.510.10-FF-004028', NULL, NULL, 106, NULL, NULL, 92554),
(92555, '2.60.40.10-FF-004032', NULL, NULL, 124, NULL, NULL, 92555),
(92556, '2.40.30.10-FF-000266', NULL, 'Translation initiation factor IF-2', 98, NULL, NULL, 92556),
(92557, '3.40.50.410-FF-000277', NULL, 'Integrin beta', 62, NULL, NULL, 92557),
(92558, '3.30.310.10-FF-000033', NULL, 'TATA box-binding protein-like 2', 75, NULL, NULL, 92558),
(92559, '3.30.1330.20-FF-000031', NULL, 'Cell division protein FtsZ', 111, NULL, NULL, 92559),
(92560, '1.20.1070.10-FF-001169', NULL, 'Vomeronasal type-1 receptor', 290, NULL, NULL, 92560),
(92561, '3.30.60.20-FF-000117', NULL, 'Protein kinase D2', 40, NULL, NULL, 92561),
(92562, '1.10.10.10-FF-001483', NULL, 'Histone acetyltransferase', 32, NULL, NULL, 92562),
(92563, '1.20.58.390-FF-000063', NULL, 'AcetylCholine Receptor', 118, NULL, NULL, 92563),
(92564, '2.60.120.920-FF-000195', NULL, 'Uncharacterized protein', 198, NULL, NULL, 92564),
(92565, '3.10.50.40-FF-000056', NULL, 'Peptidylprolyl isomerase', 129, NULL, NULL, 92565),
(92566, '1.25.40.20-FF-001729', NULL, 'Kinase, NEK', 223, NULL, NULL, 92566),
(92567, '3.90.1480.20-FF-000056', NULL, 'ST3 beta-galactoside alpha-2,3-sialyltransferase 5', 148, NULL, NULL, 92567),
(92568, '1.20.1070.10-FF-001225', NULL, 'Alpha-2B adrenergic receptor', 325, NULL, NULL, 92568),
(92569, '2.60.40.640-FF-000051', NULL, 'Vacuolar sorting protein 26, putative', 162, NULL, NULL, 92569),
(92570, '3.30.160.60-FF-003970', NULL, NULL, 31, NULL, NULL, 92570),
(92571, '2.60.40.1910-FF-000042', NULL, NULL, 94, NULL, NULL, 92571),
(92572, '1.10.533.10-FF-000124', NULL, 'Uncharacterized protein', 114, NULL, NULL, 92572),
(92573, '3.30.70.330-FF-001237', NULL, 'RNA-binding RNA annealing protein', 83, NULL, NULL, 92573),
(92574, '3.30.160.60-FF-002391', NULL, 'Transcription factor IIIA', 30, NULL, NULL, 92574),
(92575, '1.20.190.50-FF-000005', NULL, 'Nuclear pore complex protein', 245, NULL, NULL, 92575),
(92576, '3.30.1330.30-FF-000034', NULL, 'Os03g0685100 protein', 105, NULL, NULL, 92576),
(92577, '3.90.1410.10-FF-000054', NULL, 'Histone-lysine N-methyltransferase setd3', 45, NULL, NULL, 92577),
(92578, '3.40.1110.10-FF-000386', NULL, NULL, 135, NULL, NULL, 92578),
(92579, '1.25.10.10-FF-003248', NULL, 'Predicted protein', 230, NULL, NULL, 92579),
(92580, '3.40.50.300-FF-007101', NULL, 'Predicted protein', 188, NULL, NULL, 92580); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(92581, '2.60.40.150-FF-000286', NULL, 'C2 domain-containing protein', 147, NULL, NULL, 92581),
(92582, '1.25.10.10-FF-000651', NULL, 'Unplaced genomic scaffold supercont1.201, whole genome shotgun sequence', 258, NULL, NULL, 92582),
(92583, '1.20.120.1750-FF-000106', NULL, 'RBR-type E3 ubiquitin transferase', 142, NULL, NULL, 92583),
(92584, '2.130.10.10-FF-000356', NULL, 'U4/U6 small nuclear ribonucleoprotein Prp4', 116, NULL, NULL, 92584),
(92585, '2.40.50.740-FF-000008', NULL, '40S ribosomal protein S4-3', 23, NULL, NULL, 92585),
(92586, '4.10.1000.40-FF-000016', NULL, 'Uncharacterized protein', 60, NULL, NULL, 92586),
(92587, '1.20.190.40-FF-000002', NULL, 'Major DNA-binding protein', 145, NULL, NULL, 92587),
(92588, '3.80.10.10-FF-000379', NULL, 'Protein NSP-INTERACTING KINASE 2', 150, NULL, NULL, 92588),
(92589, '3.40.50.150-FF-000800', NULL, 'Capsuleen, putative', 170, NULL, NULL, 92589),
(92590, '4.10.60.10-FF-000231', NULL, 'Uncharacterized protein', 50, NULL, NULL, 92590),
(92591, '1.25.50.20-FF-000033', NULL, 'Aminopeptidase', 326, NULL, NULL, 92591),
(92592, '1.20.1560.10-FF-000583', NULL, 'ABC transporter B family member 27', 127, NULL, NULL, 92592),
(92593, '1.50.10.150-FF-000005', NULL, 'Sulfite efflux pump SSU1', 356, NULL, NULL, 92593),
(92594, '3.40.140.10-FF-000006', NULL, 'Cytidine deaminase', 112, NULL, NULL, 92594),
(92595, '2.60.40.640-FF-000006', NULL, 'Vacuolar protein sorting-associated protein 26', 146, NULL, NULL, 92595),
(92596, '2.130.10.10-FF-001935', NULL, 'Uncharacterized protein', 368, NULL, NULL, 92596),
(92597, '2.160.10.10-FF-000102', NULL, 'Eukaryotic translation initiation factor 2B, epsilon subunit, putative', 80, NULL, NULL, 92597),
(92598, '3.40.140.10-FF-000045', NULL, 'Eukaryotic translation initiation factor 3 subunit H', 201, NULL, NULL, 92598),
(92599, '1.25.40.540-FF-000003', NULL, 'Immunoglobulin (CD79A)-binding protein 1', 223, NULL, NULL, 92599),
(92600, '2.130.10.10-FF-004010', NULL, 'LD12356p', 225, NULL, NULL, 92600),
(92601, '3.90.105.20-FF-000012', NULL, 'Ribosome assembly factor mrt4', 74, NULL, NULL, 92601),
(92602, '2.40.10.10-FF-000265', NULL, 'GM13457', 113, NULL, NULL, 92602),
(92603, '2.10.90.10-FF-000075', NULL, 'Follicle stimulating hormone beta', 85, NULL, NULL, 92603),
(92604, '2.10.90.10-FF-000018', NULL, 'Spatzle 4', 102, NULL, NULL, 92604),
(92605, '1.25.40.10-FF-000203', NULL, 'E3 ubiquitin-protein ligase TTC3 isoform X2', 122, NULL, NULL, 92605),
(92606, '1.50.10.140-FF-000002', NULL, 'Cyclic beta-1,2-glucan synthetase', 413, NULL, NULL, 92606),
(92607, '3.40.950.10-FF-000017', NULL, NULL, 33, NULL, NULL, 92607),
(92608, '3.30.230.10-FF-000032', NULL, 'mismatch repair endonuclease PMS2 isoform X2', 133, NULL, NULL, 92608),
(92609, '1.10.533.10-FF-000181', NULL, 'Putative nuclear matrix protein', 101, NULL, NULL, 92609),
(92610, '1.25.40.20-FF-000532', NULL, 'CRE-DAPK-1 protein', 100, NULL, NULL, 92610),
(92611, '3.40.50.720-FF-001943', NULL, 'Uncharacterized protein', 270, NULL, NULL, 92611),
(92612, '1.25.40.20-FF-000482', NULL, 'Ankyrin repeats (3 copies), putative', 135, NULL, NULL, 92612),
(92613, '2.60.40.10-FF-001957', NULL, 'TAP binding protein-like variant', 110, NULL, NULL, 92613),
(92614, '2.60.40.10-FF-002851', NULL, 'Glycosyl hydrolase family 3 domain containing protein', 129, NULL, NULL, 92614),
(92615, '1.20.990.10-FF-000026', NULL, 'NADPH-cytochrome P450 reductase', 52, NULL, NULL, 92615),
(92616, '2.60.40.10-FF-000721', NULL, 'Immunoglobulin lambda variable 5-45', 121, NULL, NULL, 92616),
(92617, '3.80.10.10-FF-001273', NULL, 'Nischarin', 74, NULL, NULL, 92617),
(92618, '1.20.140.40-FF-000055', NULL, NULL, 146, NULL, NULL, 92618),
(92619, '3.40.50.1000-FF-000514', NULL, NULL, 129, NULL, NULL, 92619),
(92620, '1.10.8.10-FF-000335', NULL, 'OTU deubiquitinase 7B', 40, NULL, NULL, 92620),
(92621, '3.40.50.10190-FF-000292', NULL, 'DNA ligase 4', 126, NULL, NULL, 92621),
(92622, '3.20.20.70-FF-000692', NULL, NULL, 174, NULL, NULL, 92622),
(92623, '3.40.30.10-FF-000264', NULL, 'Glutathione S-transferase mu 1', 31, NULL, NULL, 92623);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(92624, '2.130.10.10-FF-000412', NULL, 'WD repeat domain 54', 117, NULL, NULL, 92624),
(92625, '3.40.50.2300-FF-000180', NULL, 'Guanylate cyclase', 180, NULL, NULL, 92625),
(92626, '3.40.605.10-FF-000058', NULL, 'Aldehyde dehydrogenase 3 family, member A2a', 131, NULL, NULL, 92626),
(92627, '1.20.5.2440-FF-000002', NULL, 'rab11 family-interacting protein 2 isoform X1', 73, NULL, NULL, 92627),
(92628, '3.40.1110.10-FF-000329', NULL, NULL, 147, NULL, NULL, 92628),
(92629, '1.10.1200.10-FF-000098', NULL, 'Enniatin synthase', 85, NULL, NULL, 92629),
(92630, '1.10.530.10-FF-000084', NULL, 'Uncharacterized protein', 107, NULL, NULL, 92630),
(92631, '3.90.1460.10-FF-000001', NULL, 'general transcription factor II-I isoform X1', 97, NULL, NULL, 92631),
(92632, '3.30.40.10-FF-000748', NULL, 'PHD finger domain protein, putative', 69, NULL, NULL, 92632),
(92633, '1.10.1450.10-FF-000032', NULL, 'Tetraspanin', 89, NULL, NULL, 92633),
(92634, '1.25.40.10-FF-003963', NULL, 'Uncharacterized protein', 245, NULL, NULL, 92634),
(92635, '2.60.40.1180-FF-000154', NULL, 'Starch branching enzyme', 106, NULL, NULL, 92635),
(92636, '1.10.10.60-FF-000401', NULL, 'Uncharacterized protein, isoform A', 64, NULL, NULL, 92636),
(92637, '2.70.150.10-FF-000161', NULL, 'Cation-transporting ATPase', 107, NULL, NULL, 92637),
(92638, '1.10.533.10-FF-000068', NULL, 'NLR family CARD domain containing 4', 84, NULL, NULL, 92638),
(92639, '2.130.10.10-FF-004740', NULL, 'Transducin', 162, NULL, NULL, 92639),
(92640, '3.30.860.10-FF-000006', NULL, 'Ribosomal protein S19, mitochondrial', 87, NULL, NULL, 92640),
(92641, '3.20.20.80-FF-000695', NULL, 'Uncharacterized protein', 211, NULL, NULL, 92641),
(92642, '3.30.565.10-FF-000051', NULL, '[3-methyl-2-oxobutanoate dehydrogenase [lipoamide]] kinase, mitochondrial', 189, NULL, NULL, 92642),
(92643, '1.10.3370.10-FF-000054', NULL, 'Os12g0627700 protein', 79, NULL, NULL, 92643),
(92644, '1.10.10.10-FF-002090', NULL, 'Uncharacterized protein', 67, NULL, NULL, 92644),
(92645, '2.30.39.10-FF-000163', NULL, 'Uncharacterized protein', 78, NULL, NULL, 92645),
(92646, '3.40.50.300-FF-002155', NULL, 'U5 small nuclear ribonuclear protein', 220, NULL, NULL, 92646),
(92647, '1.10.510.10-FF-004085', NULL, NULL, 163, NULL, NULL, 92647),
(92648, '1.20.58.220-FF-000001', NULL, 'Phosphate-specific transport system accessory protein PhoU', 112, NULL, NULL, 92648),
(92649, '3.30.1460.50-FF-000015', NULL, 'ATG10 autophagy-related 10 homolog (S. cerevisiae)', 156, NULL, NULL, 92649),
(92650, '3.30.160.60-FF-004206', NULL, NULL, 28, NULL, NULL, 92650),
(92651, '1.10.3730.20-FF-000079', NULL, 'Putative membrane protein', 109, NULL, NULL, 92651),
(92652, '2.30.30.140-FF-000226', NULL, 'RE70955p', 86, NULL, NULL, 92652),
(92653, '3.60.130.30-FF-000001', NULL, 'Bifunctional helicase and thymine dioxygenase JBP2', 242, NULL, NULL, 92653),
(92654, '1.20.120.790-FF-000025', NULL, 'Chaperone protein HtpG', 131, NULL, NULL, 92654),
(92655, '3.40.50.300-FF-005589', NULL, 'Uncharacterized protein', 99, NULL, NULL, 92655),
(92656, '3.30.70.330-FF-001187', NULL, 'RNA recognition motif domain containing protein', 108, NULL, NULL, 92656),
(92657, '2.60.40.1180-FF-000047', NULL, '1,4-alpha-glucan branching enzyme GlgB', 107, NULL, NULL, 92657),
(92658, '3.30.160.60-FF-002115', NULL, 'Krueppel-like factor 15', 30, NULL, NULL, 92658),
(92659, '1.10.10.10-FF-002051', NULL, 'Uncharacterized protein', 31, NULL, NULL, 92659),
(92660, '1.20.58.530-FF-000032', NULL, NULL, 24, NULL, NULL, 92660),
(92661, '1.20.1250.20-FF-001377', NULL, 'Major facilitator superfamily MFS_1', 266, NULL, NULL, 92661),
(92662, '1.25.40.10-FF-001783', NULL, 'Transcription factor EMB1444', 126, NULL, NULL, 92662),
(92663, '3.40.50.1820-FF-001154', NULL, 'Carbohydrate esterase MZ0003', 366, NULL, NULL, 92663),
(92664, '3.40.50.2300-FF-001427', NULL, NULL, 23, NULL, NULL, 92664),
(92665, '1.25.40.10-FF-001726', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 98, NULL, NULL, 92665),
(92666, '3.90.550.50-FF-000116', NULL, 'Beta-1,3-galactosyltransferase bre-5', 245, NULL, NULL, 92666);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(92667, '3.40.50.12650-FF-000018', NULL, 'YALI0E29931p', 155, NULL, NULL, 92667),
(92668, '3.40.50.10490-FF-000168', NULL, NULL, 46, NULL, NULL, 92668),
(92669, '3.80.20.20-FF-000028', NULL, 'Receptor protein-tyrosine kinase', 214, NULL, NULL, 92669),
(92670, '3.40.50.300-FF-007955', NULL, 'Uncharacterized protein', 168, NULL, NULL, 92670),
(92671, '1.20.120.1220-FF-000009', NULL, 'Type 4 prepilin-like proteins leader peptide-processing enzyme', 145, NULL, NULL, 92671),
(92672, '2.60.120.1440-FF-000013', NULL, 'FecR family protein', 137, NULL, NULL, 92672),
(92673, '3.40.50.1000-FF-000621', NULL, NULL, 156, NULL, NULL, 92673),
(92674, '2.40.160.20-FF-000031', NULL, 'Major outer membrane protein OmpA', 193, NULL, NULL, 92674),
(92675, '3.50.50.60-FF-001398', NULL, 'Lysine demethylase 1A', 182, NULL, NULL, 92675),
(92676, '3.40.50.300-FF-008411', NULL, 'DNA helicase', 153, NULL, NULL, 92676),
(92677, '1.50.10.20-FF-000079', NULL, 'Protein farnesyltransferase subunit beta', 477, NULL, NULL, 92677),
(92678, '1.10.510.10-FF-002174', NULL, NULL, 90, NULL, NULL, 92678),
(92679, '3.30.40.10-FF-001355', NULL, 'Tripartite motif-containing 28', 63, NULL, NULL, 92679),
(92680, '1.10.472.130-FF-000066', NULL, 'Uncharacterized protein', 157, NULL, NULL, 92680),
(92681, '3.40.50.300-FF-007793', NULL, 'Uncharacterized protein', 48, NULL, NULL, 92681),
(92682, '2.120.10.80-FF-000203', NULL, 'Serine/threonine-protein phosphatase', 169, NULL, NULL, 92682),
(92683, '1.10.8.720-FF-000075', NULL, 'Uncharacterized protein', 113, NULL, NULL, 92683),
(92684, '3.40.50.150-FF-000507', NULL, 'Possible transcriptional regulatory protein', 202, NULL, NULL, 92684),
(92685, '3.30.40.10-FF-001535', NULL, 'Uncharacterized protein', 64, NULL, NULL, 92685),
(92686, '1.50.10.10-FF-000076', NULL, 'alpha-1,2-Mannosidase', 491, NULL, NULL, 92686),
(92687, '3.30.190.20-FF-000048', NULL, 'Ribosomal protein L1, putative', 32, NULL, NULL, 92687),
(92688, '3.90.470.20-FF-000011', NULL, 'Os08g0243100 protein', 122, NULL, NULL, 92688),
(92689, '3.40.395.10-FF-000018', NULL, 'Related to Ubl-specific protease', 239, NULL, NULL, 92689),
(92690, '3.10.100.10-FF-000252', NULL, NULL, 137, NULL, NULL, 92690),
(92691, '1.25.40.10-FF-000422', NULL, 'Pentatricopeptide repeat-containing protein', 124, NULL, NULL, 92691),
(92692, '1.20.1070.10-FF-001512', NULL, 'Uncharacterized protein', 195, NULL, NULL, 92692),
(92693, '3.40.50.300-FF-004302', NULL, 'Uncharacterized protein', 232, NULL, NULL, 92693),
(92694, '2.130.10.10-FF-003285', NULL, 'Uncharacterized protein', 333, NULL, NULL, 92694),
(92695, '3.40.50.300-FF-005769', NULL, 'DNA binding protein eukaryotic-like', 107, NULL, NULL, 92695),
(92696, '1.25.40.20-FF-000425', NULL, 'Glutaminase 2', 92, NULL, NULL, 92696),
(92697, '3.30.559.30-FF-000110', NULL, 'Nonribosomal peptide synthetase easA', 230, NULL, NULL, 92697),
(92698, '3.40.640.10-FF-000246', NULL, 'Arginine decarboxylase', 275, NULL, NULL, 92698),
(92699, '3.40.50.1000-FF-000801', NULL, NULL, 148, NULL, NULL, 92699),
(92700, '3.30.559.30-FF-000054', NULL, 'Peptide synthetase', 256, NULL, NULL, 92700),
(92701, '1.10.510.10-FF-004360', NULL, NULL, 111, NULL, NULL, 92701),
(92702, '3.30.160.60-FF-005768', NULL, NULL, 25, NULL, NULL, 92702),
(92703, '1.20.5.340-FF-000071', NULL, 'Cortexillin-1', 101, NULL, NULL, 92703),
(92704, '1.20.930.40-FF-000014', NULL, 'Inactive zinc metalloprotease C354.09c', 143, NULL, NULL, 92704),
(92705, '3.10.20.600-FF-000003', NULL, 'NADH-quinone oxidoreductase subunit F', 94, NULL, NULL, 92705),
(92706, '1.20.1070.10-FF-001282', NULL, 'Uncharacterized protein', 242, NULL, NULL, 92706),
(92707, '2.40.20.10-FF-000041', NULL, 'Uncharacterized protein', 91, NULL, NULL, 92707),
(92708, '3.40.50.300-FF-006376', NULL, 'Uncharacterized protein', 280, NULL, NULL, 92708),
(92709, '1.20.1250.40-FF-000023', NULL, 'Predicted protein', 63, NULL, NULL, 92709),
(92710, '2.20.70.10-FF-000090', NULL, 'Formin binding protein (FNB3)', 49, NULL, NULL, 92710),
(92711, '2.70.170.10-FF-000050', NULL, 'Nicotinic acetylcholine receptor alpha4, isoform D', 63, NULL, NULL, 92711);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(92712, '2.130.10.10-FF-001992', NULL, 'U4/U6 small nuclear ribonucleoprotein', 123, NULL, NULL, 92712),
(92713, '2.60.40.10-FF-001103', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', 104, NULL, NULL, 92713),
(92714, '1.10.510.10-FF-003753', NULL, NULL, 142, NULL, NULL, 92714),
(92715, '1.20.272.10-FF-000009', NULL, 'replication factor C subunit 2', 93, NULL, NULL, 92715),
(92716, '2.170.150.80-FF-000006', NULL, 'NAC domain-containing protein 100-like', 147, NULL, NULL, 92716),
(92717, '3.30.70.1560-FF-000011', NULL, 'Pseudouridine synthase', 80, NULL, NULL, 92717),
(92718, '1.10.287.110-FF-000441', NULL, 'Predicted protein', 71, NULL, NULL, 92718),
(92719, '3.50.50.60-FF-001454', NULL, 'Uncharacterized protein', 78, NULL, NULL, 92719),
(92720, '3.80.10.10-FF-002796', NULL, 'Si:dkey-157e10.6', 64, NULL, NULL, 92720),
(92721, '3.30.160.60-FF-002059', NULL, 'transcription factor Ken', 73, NULL, NULL, 92721),
(92722, '1.10.1750.10-FF-000015', NULL, NULL, 95, NULL, NULL, 92722),
(92723, '2.40.10.10-FF-000208', NULL, 'Serine-peptidase 212', 247, NULL, NULL, 92723),
(92724, '2.30.29.30-FF-001343', NULL, 'Protein vav-1', 153, NULL, NULL, 92724),
(92725, '1.10.8.60-FF-000597', NULL, 'Cell division control protein 18', 115, NULL, NULL, 92725),
(92726, '3.30.450.20-FF-000198', NULL, 'Two-component system, cell cycle sensor histidine kinase PleC', 122, NULL, NULL, 92726),
(92727, '3.30.470.20-FF-000199', NULL, 'Glutathione synthetase ATP-binding domain-like superfamily protein', 106, NULL, NULL, 92727),
(92728, '3.30.160.60-FF-002334', NULL, 'Tripartite motif containing 15', 75, NULL, NULL, 92728),
(92729, '3.30.40.10-FF-002030', NULL, 'Uncharacterized protein', 101, NULL, NULL, 92729),
(92730, '1.10.8.10-FF-000279', NULL, 'Putative BOI-related E3 ubiquitin-protein ligase 3', 39, NULL, NULL, 92730),
(92731, '2.60.40.150-FF-000516', NULL, 'Uncharacterized protein', 97, NULL, NULL, 92731),
(92732, '1.20.140.150-FF-000051', NULL, 'Germ cell associated 1', 120, NULL, NULL, 92732),
(92733, '3.40.50.300-FF-007736', NULL, 'Uncharacterized protein', 288, NULL, NULL, 92733),
(92734, '3.40.50.1010-FF-000063', NULL, 'Ribonuclease VapC', 142, NULL, NULL, 92734),
(92735, '1.10.510.10-FF-002117', NULL, 'Predicted protein', 201, NULL, NULL, 92735),
(92736, '4.10.60.10-FF-000118', NULL, 'DNA-binding protein', 42, NULL, NULL, 92736),
(92737, '3.40.50.1100-FF-000090', NULL, 'Threonine synthase', 97, NULL, NULL, 92737),
(92738, '3.10.450.240-FF-000019', NULL, '39S ribosomal protein L45, mitochondrial', 165, NULL, NULL, 92738),
(92739, '1.10.1670.10-FF-000014', NULL, 'Adenine DNA glycosylase', 92, NULL, NULL, 92739),
(92740, '3.40.50.1700-FF-000062', NULL, 'Thermostable beta-glucosidase B', 111, NULL, NULL, 92740),
(92741, '3.40.720.10-FF-000247', NULL, 'Predicted protein', 181, NULL, NULL, 92741),
(92742, '1.10.1200.10-FF-000154', NULL, 'Ferrichrome siderophore peptide synthetase', 77, NULL, NULL, 92742),
(92743, '3.10.170.20-FF-000023', NULL, NULL, 149, NULL, NULL, 92743),
(92744, '2.40.50.690-FF-000027', NULL, 'Uncharacterized protein', 113, NULL, NULL, 92744),
(92745, '2.40.10.10-FF-000484', NULL, NULL, 233, NULL, NULL, 92745),
(92746, '3.30.1680.10-FF-000071', NULL, 'Uncharacterized protein', 36, NULL, NULL, 92746),
(92747, '3.10.590.10-FF-000018', NULL, 'Os08g0485300 protein', 104, NULL, NULL, 92747),
(92748, '1.25.40.470-FF-000078', NULL, 'Uncharacterized protein', 105, NULL, NULL, 92748),
(92749, '3.20.20.140-FF-000346', NULL, 'Adenosine deaminase, putative', 335, NULL, NULL, 92749),
(92750, '1.50.10.160-FF-000008', NULL, '(E)-nerolidol/(E,E)-geranyl linalool synthase', 211, NULL, NULL, 92750),
(92751, '3.40.50.1110-FF-000093', NULL, 'Lipolytic protein G-D-S-L family', 249, NULL, NULL, 92751),
(92752, '3.40.630.10-FF-000190', NULL, 'GM13753', 316, NULL, NULL, 92752),
(92753, '1.20.58.60-FF-000668', NULL, 'Uncharacterized protein', 144, NULL, NULL, 92753),
(92754, '2.30.29.30-FF-000668', NULL, 'Tyrosine-protein kinase', 116, NULL, NULL, 92754),
(92755, '1.25.40.10-FF-000147', NULL, 'Mitochondrial fission 1 protein', 150, NULL, NULL, 92755);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(92756, '1.25.10.10-FF-000432', NULL, 'Pumilio-homology domain family', 317, NULL, NULL, 92756),
(92757, '3.90.226.10-FF-000205', NULL, 'Enoyl-CoA hydratase/isomerase family protein', 199, NULL, NULL, 92757),
(92758, '1.25.10.10-FF-003467', NULL, 'Predicted protein', 273, NULL, NULL, 92758),
(92759, '1.20.120.1200-FF-000003', NULL, 'NADH-ubiquinone oxidoreductase chain 6', 172, NULL, NULL, 92759),
(92760, '2.30.42.10-FF-000013', NULL, 'Putative tight junction protein ZO-1', 97, NULL, NULL, 92760),
(92761, '2.60.40.10-FF-002121', NULL, 'I-set domain containing protein', 115, NULL, NULL, 92761),
(92762, '1.10.455.10-FF-000015', NULL, 'Uncharacterized protein, isoform B', 166, NULL, NULL, 92762),
(92763, '2.60.120.10-FF-000673', NULL, 'Homogentisate 1,2-dioxygenase HmgA', 102, NULL, NULL, 92763),
(92764, '3.40.50.1000-FF-000060', NULL, 'Haloacid dehalogenase-like hydrolase domain-containing protein 2', 103, NULL, NULL, 92764),
(92765, '2.60.40.10-FF-002519', NULL, 'Titin homolog', 90, NULL, NULL, 92765),
(92766, '1.10.510.10-FF-002735', NULL, NULL, 177, NULL, NULL, 92766),
(92767, '2.40.100.10-FF-000103', NULL, '26S proteasome regulatory complex ATPase', 97, NULL, NULL, 92767),
(92768, '3.30.160.60-FF-004425', NULL, NULL, 47, NULL, NULL, 92768),
(92769, '1.20.5.190-FF-000060', NULL, 'Myosin XVA', 51, NULL, NULL, 92769),
(92770, '1.20.1250.20-FF-000719', NULL, 'MFS transporter', 207, NULL, NULL, 92770),
(92771, '1.20.5.190-FF-000003', NULL, 'Calmodulin-binding transcription activator 2', 49, NULL, NULL, 92771),
(92772, '3.30.60.30-FF-000233', NULL, 'Predicted protein', 50, NULL, NULL, 92772),
(92773, '1.10.287.90-FF-000007', NULL, 'Cytochrome c oxidase subunit 2', 88, NULL, NULL, 92773),
(92774, '2.60.120.10-FF-000616', NULL, 'Uncharacterized protein', 91, NULL, NULL, 92774),
(92775, '3.40.50.720-FF-002399', NULL, 'Uncharacterized protein', 40, NULL, NULL, 92775),
(92776, '3.90.1110.10-FF-000014', NULL, 'DNA-directed RNA polymerase subunit beta', 174, NULL, NULL, 92776),
(92777, '3.40.190.290-FF-000001', NULL, 'Transcriptional regulator, LysR family', 205, NULL, NULL, 92777),
(92778, '2.60.40.10-FF-000940', NULL, 'Muscle M-line assembly protein unc-89', 100, NULL, NULL, 92778),
(92779, '3.40.50.2020-FF-000034', NULL, 'Ribose-phosphate pyrophosphokinase 4', 137, NULL, NULL, 92779),
(92780, '2.20.25.10-FF-000070', NULL, 'Terminal oxygenase component of carbazole', 55, NULL, NULL, 92780),
(92781, '3.90.1280.20-FF-000018', NULL, NULL, 31, NULL, NULL, 92781),
(92782, '3.30.430.20-FF-000022', NULL, 'Os07g0534300 protein', 107, NULL, NULL, 92782),
(92783, '1.10.760.10-FF-000073', NULL, 'Cytochrome b/c1', 218, NULL, NULL, 92783),
(92784, '3.80.10.10-FF-001834', NULL, 'EIN3-binding F-box protein 1 isoform A', 224, NULL, NULL, 92784),
(92785, '3.10.450.50-FF-000115', NULL, 'Uncharacterized protein', 118, NULL, NULL, 92785),
(92786, '1.10.510.10-FF-000650', NULL, 'Serine/threonine-protein kinase ppk16', 339, NULL, NULL, 92786),
(92787, '2.60.40.840-FF-000010', NULL, 'Uncharacterized protein', 107, NULL, NULL, 92787),
(92788, '3.90.80.10-FF-000006', NULL, 'Inorganic pyrophosphatase', 177, NULL, NULL, 92788),
(92789, '3.40.50.1100-FF-000157', NULL, 'Cysteine synthase B protein', 145, NULL, NULL, 92789),
(92790, '3.40.47.10-FF-000010', NULL, 'Acetyl-CoA acetyltransferase (Thiolase)', 391, NULL, NULL, 92790),
(92791, '2.60.40.60-FF-000365', NULL, 'FlaMIngo (Cadherin plus 7TM domain) homolog', 99, NULL, NULL, 92791),
(92792, '2.40.30.10-FF-000210', NULL, 'Eukaryotic peptide chain release factor GTP-binding subunit', 110, NULL, NULL, 92792),
(92793, '2.60.120.560-FF-000002', NULL, 'Beta-fructofuranosidase, insoluble isoenzyme CWINV1', 188, NULL, NULL, 92793),
(92794, '2.40.30.10-FF-000154', NULL, 'Selenocysteine-specific translation elongation factor', 82, NULL, NULL, 92794),
(92795, '3.30.1370.10-FF-000204', NULL, 'Vigilin 1', 66, NULL, NULL, 92795),
(92796, '2.60.120.260-FF-000013', NULL, 'Neuropilin', 166, NULL, NULL, 92796),
(92797, '3.40.50.300-FF-008118', NULL, 'Polynucleotide kinase 3''-phosphatase', 106, NULL, NULL, 92797);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(92798, '1.20.120.980-FF-000020', NULL, 'Serine protease 16', 144, NULL, NULL, 92798),
(92799, '3.80.10.10-FF-002110', NULL, 'Protein CBG22694', 298, NULL, NULL, 92799),
(92800, '1.10.287.660-FF-000033', NULL, 'Uncharacterized protein', 75, NULL, NULL, 92800),
(92801, '1.10.506.10-FF-000101', NULL, 'Uncharacterized protein', 35, NULL, NULL, 92801),
(92802, '1.10.3090.10-FF-000009', NULL, 'Polynucleotide adenylyltransferase family protein', 329, NULL, NULL, 92802),
(92803, '1.20.1250.20-FF-001271', NULL, 'Uncharacterized protein', 201, NULL, NULL, 92803),
(92804, '1.20.1250.20-FF-001613', NULL, 'Uncharacterized protein', 172, NULL, NULL, 92804),
(92805, '3.40.50.300-FF-004807', NULL, 'Uncharacterized protein', 230, NULL, NULL, 92805),
(92806, '1.20.5.110-FF-000255', NULL, 'Uncharacterized protein', 103, NULL, NULL, 92806),
(92807, '3.40.640.10-FF-000027', NULL, 'Serine--pyruvate aminotransferase, mitochondrial', 246, NULL, NULL, 92807),
(92808, '3.10.110.10-FF-000314', NULL, 'Uncharacterized protein', 67, NULL, NULL, 92808),
(92809, '3.30.160.60-FF-001952', NULL, 'Zgc:174623 protein', 29, NULL, NULL, 92809),
(92810, '3.40.50.300-FF-000536', NULL, 'GTPase IMAP family member 8', 206, NULL, NULL, 92810),
(92811, '1.10.418.10-FF-000109', NULL, 'Patronin (microtubule-binding protein) homolog', 111, NULL, NULL, 92811),
(92812, '3.40.50.1240-FF-000171', NULL, NULL, 260, NULL, NULL, 92812),
(92813, '1.10.10.10-FF-001595', NULL, 'Eugenol O-methyltransferase', 114, NULL, NULL, 92813),
(92814, '3.90.280.10-FF-000027', NULL, NULL, 183, NULL, NULL, 92814),
(92815, '3.40.30.10-FF-001045', NULL, 'Uncharacterized protein', 187, NULL, NULL, 92815),
(92816, '3.40.50.300-FF-004521', NULL, 'ATP-dependent RecD-like DNA helicase', 196, NULL, NULL, 92816),
(92817, '1.10.400.10-FF-000041', NULL, 'Predicted protein', 38, NULL, NULL, 92817),
(92818, '2.130.10.10-FF-001716', NULL, 'Inositol requiring 1-1', 217, NULL, NULL, 92818),
(92819, '3.40.720.10-FF-000028', NULL, 'Non-specific phospholipase C1', 175, NULL, NULL, 92819),
(92820, '1.10.230.10-FF-000005', NULL, 'ATP-citrate synthase subunit 1', 94, NULL, NULL, 92820),
(92821, '2.70.150.10-FF-000009', NULL, 'Phospholipid-transporting ATPase', 175, NULL, NULL, 92821),
(92822, '3.10.20.30-FF-000006', NULL, 'Threonine--tRNA ligase, cytoplasmic', 62, NULL, NULL, 92822),
(92823, '3.40.50.2300-FF-001540', NULL, NULL, 53, NULL, NULL, 92823),
(92824, '3.30.420.40-FF-000241', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', 195, NULL, NULL, 92824),
(92825, '2.60.40.10-FF-004537', NULL, NULL, 91, NULL, NULL, 92825),
(92826, '2.60.40.10-FF-003537', NULL, NULL, 119, NULL, NULL, 92826),
(92827, '1.20.870.10-FF-000028', NULL, 'Ral GDS-Like', 189, NULL, NULL, 92827),
(92828, '1.20.120.830-FF-000003', NULL, 'Putative breast cancer anti-estrogen resistance protein 1', 155, NULL, NULL, 92828),
(92829, '3.80.10.10-FF-003015', NULL, 'Predicted protein', 285, NULL, NULL, 92829),
(92830, '3.40.190.10-FF-000104', NULL, 'Peptide ABC transporter substrate-binding protein', 304, NULL, NULL, 92830),
(92831, '2.60.40.60-FF-000308', NULL, 'Cadherin 74A, isoform A', 107, NULL, NULL, 92831),
(92832, '1.25.40.10-FF-002507', NULL, 'TPR repeat-containing protein', 107, NULL, NULL, 92832),
(92833, '1.10.10.2660-FF-000008', NULL, 'Ubiquitin-activating enzyme e1', 272, NULL, NULL, 92833),
(92834, '3.10.105.10-FF-000128', NULL, 'ABC-type dipeptide transport system periplasmic component-like protein', 236, NULL, NULL, 92834),
(92835, '2.130.10.10-FF-004122', NULL, 'Uncharacterized protein', 188, NULL, NULL, 92835),
(92836, '1.10.220.150-FF-000015', NULL, 'arf-GAP with dual PH domain-containing protein 2 isoform X1', 128, NULL, NULL, 92836),
(92837, '3.40.50.150-FF-000564', NULL, 'Hypothetical_protein_-_conserved', 195, NULL, NULL, 92837),
(92838, '1.10.472.130-FF-000009', NULL, 'Dynein heavy chain 5, axonemal', 146, NULL, NULL, 92838),
(92839, '1.10.220.160-FF-000018', NULL, NULL, 84, NULL, NULL, 92839),
(92840, '1.20.1250.20-FF-000596', NULL, 'Vitamin b6 transporter bsu1', 426, NULL, NULL, 92840);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(92841, '4.10.1110.10-FF-000009', NULL, 'Probable ubiquitin', 68, NULL, NULL, 92841),
(92842, '1.20.120.850-FF-000009', NULL, 'SNF2 family helicase/ATPase (Swr1)', 76, NULL, NULL, 92842),
(92843, '2.10.25.10-FF-000952', NULL, 'Putative Fibrillin-1', 39, NULL, NULL, 92843),
(92844, '2.130.10.10-FF-003846', NULL, 'ARPC1', 388, NULL, NULL, 92844),
(92845, '2.40.10.10-FF-000501', NULL, NULL, 107, NULL, NULL, 92845),
(92846, '1.20.1050.80-FF-000025', NULL, 'Uncharacterized protein', 155, NULL, NULL, 92846),
(92847, '1.10.8.720-FF-000018', NULL, 'Uncharacterized protein', 153, NULL, NULL, 92847),
(92848, '3.40.50.150-FF-000906', NULL, NULL, 67, NULL, NULL, 92848),
(92849, '3.40.50.2020-FF-000091', NULL, 'Orotate phosphoribosyltransferase', 211, NULL, NULL, 92849),
(92850, '3.40.50.720-FF-001325', NULL, 'Aspergillus niger contig An11c0010, genomic contig', 264, NULL, NULL, 92850),
(92851, '1.20.120.730-FF-000029', NULL, 'SD04292p', 34, NULL, NULL, 92851),
(92852, '2.170.270.10-FF-000011', NULL, 'Histone-lysine N-methyltransferase', 223, NULL, NULL, 92852),
(92853, '3.40.50.12160-FF-000023', NULL, 'Protein CBG15101', 122, NULL, NULL, 92853),
(92854, '2.130.10.10-FF-005645', NULL, 'Uncharacterized protein', 172, NULL, NULL, 92854),
(92855, '2.40.10.10-FF-000540', NULL, NULL, 92, NULL, NULL, 92855),
(92856, '1.10.10.10-FF-000027', NULL, 'Heat shock transcription factor 1', 110, NULL, NULL, 92856),
(92857, '3.40.50.300-FF-006320', NULL, 'Midasin', 131, NULL, NULL, 92857),
(92858, '3.20.20.10-FF-000039', NULL, 'Ornithine decarboxylase', 229, NULL, NULL, 92858),
(92859, '2.30.30.1020-FF-000046', NULL, NULL, 210, NULL, NULL, 92859),
(92860, '1.10.8.270-FF-000131', NULL, 'Rab-GAP domain-containing protein, putative', 105, NULL, NULL, 92860),
(92861, '3.30.160.60-FF-005549', NULL, NULL, 24, NULL, NULL, 92861),
(92862, '3.10.105.10-FF-000061', NULL, 'ABC transporter substrate-binding protein', 239, NULL, NULL, 92862),
(92863, '3.30.160.60-FF-001896', NULL, 'insulinoma-associated protein 1b', 28, NULL, NULL, 92863),
(92864, '3.30.200.20-FF-002450', NULL, 'Leucine-rich repeat family protein /protein kinase family protein-like', 60, NULL, NULL, 92864),
(92865, '1.20.5.110-FF-000199', NULL, 'Syntaxin, putative', 60, NULL, NULL, 92865),
(92866, '1.10.418.10-FF-000222', NULL, 'Predicted protein', 119, NULL, NULL, 92866),
(92867, '1.10.472.10-FF-000605', NULL, 'Cyclin A2', 14, NULL, NULL, 92867),
(92868, '2.30.30.1160-FF-000003', NULL, 'Antiviral helicase SKI2', 127, NULL, NULL, 92868),
(92869, '3.80.10.10-FF-001216', NULL, 'Uncharacterized F-box/LRR-repeat protein C02F5.7', 250, NULL, NULL, 92869),
(92870, '2.130.10.130-FF-000021', NULL, 'Integrin alpha ina-1', 477, NULL, NULL, 92870),
(92871, '3.40.50.720-FF-001382', NULL, 'Hypothetical_protein_-_conserved', 156, NULL, NULL, 92871),
(92872, '2.60.40.150-FF-000230', NULL, 'Tcb1p', 177, NULL, NULL, 92872),
(92873, '3.40.190.10-FF-000161', NULL, 'Serotransferrin', 144, NULL, NULL, 92873),
(92874, '3.40.50.2300-FF-001484', NULL, NULL, 134, NULL, NULL, 92874),
(92875, '2.10.50.10-FF-000078', NULL, 'Tumor necrosis factor receptor superfamily member 3', 44, NULL, NULL, 92875),
(92876, '1.25.10.10-FF-000319', NULL, 'Condensin-2 complex subunit D3', 192, NULL, NULL, 92876),
(92877, '1.10.10.10-FF-000701', NULL, 'GntR family transcriptional regulator', 73, NULL, NULL, 92877),
(92878, '2.60.40.1080-FF-000017', NULL, 'Major capsid protein', 87, NULL, NULL, 92878),
(92879, '3.60.15.10-FF-000121', NULL, 'Cleavage and polyadenylation specificity factor, 73 kDa subunit', 250, NULL, NULL, 92879),
(92880, '3.30.200.20-FF-001556', NULL, 'Uncharacterized protein', 120, NULL, NULL, 92880),
(92881, '3.30.160.60-FF-004189', NULL, NULL, 28, NULL, NULL, 92881),
(92882, '3.30.160.60-FF-004245', NULL, NULL, 28, NULL, NULL, 92882),
(92883, '1.10.472.80-FF-000188', NULL, NULL, 157, NULL, NULL, 92883),
(92884, '1.10.472.10-FF-000044', NULL, 'cyclin-H isoform X1', 120, NULL, NULL, 92884),
(92885, '3.40.720.10-FF-000360', NULL, 'Predicted protein', 173, NULL, NULL, 92885),
(92886, '3.30.70.330-FF-000113', NULL, 'RNA-binding protein 26 isoform X3', 61, NULL, NULL, 92886);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(92887, '1.10.472.10-FF-000100', NULL, 'Cyclin-SDS', 98, NULL, NULL, 92887),
(92888, '3.40.50.300-FF-004246', NULL, 'Translation elongation factor G', 287, NULL, NULL, 92888),
(92889, '1.20.1690.10-FF-000007', NULL, 'V-type proton ATPase subunit', 111, NULL, NULL, 92889),
(92890, '3.40.1350.10-FF-000038', NULL, 'tRNA-splicing endonuclease', 92, NULL, NULL, 92890),
(92891, '1.10.287.70-FF-000468', NULL, 'Potassium two pore domain channel subfamily K member 4', 217, NULL, NULL, 92891),
(92892, '1.10.30.50-FF-000012', NULL, 'IclR family transcriptional regulator', 74, NULL, NULL, 92892),
(92893, '3.30.200.20-FF-002012', NULL, 'Serine/threonine-protein kinase haspin homolog hrk1', 120, NULL, NULL, 92893),
(92894, '3.40.50.10190-FF-000179', NULL, 'NLI interacting factor-like phosphatase family protein', 90, NULL, NULL, 92894),
(92895, '1.10.1420.10-FF-000204', NULL, 'Os07g0486000 protein', 76, NULL, NULL, 92895),
(92896, '3.40.50.2300-FF-001607', NULL, NULL, 65, NULL, NULL, 92896),
(92897, '3.40.50.2300-FF-000989', NULL, NULL, 81, NULL, NULL, 92897),
(92898, '3.30.56.30-FF-000015', NULL, 'Signal recognition particle 19 kDa protein', 98, NULL, NULL, 92898),
(92899, '3.40.50.300-FF-005825', NULL, 'Cell division control protein', 211, NULL, NULL, 92899),
(92900, '1.20.1250.20-FF-001832', NULL, 'Uncharacterized protein', 143, NULL, NULL, 92900),
(92901, '1.20.5.340-FF-000032', NULL, 'Tropomyosin alpha-1 chain', 58, NULL, NULL, 92901),
(92902, '1.10.100.10-FF-000001', NULL, 'insulin-like growth factor I isoform X1', 82, NULL, NULL, 92902),
(92903, '2.40.440.10-FF-000027', NULL, 'ErfK/YbiS/YcfS/YnhG', 136, NULL, NULL, 92903),
(92904, '1.25.40.10-FF-002620', NULL, 'Uncharacterized protein', 196, NULL, NULL, 92904),
(92905, '2.60.40.10-FF-004650', NULL, NULL, 125, NULL, NULL, 92905),
(92906, '3.40.50.300-FF-008175', NULL, 'Uncharacterized protein', 85, NULL, NULL, 92906),
(92907, '3.40.50.150-FF-000345', NULL, 'S-adenosylmethionine-dependent methyltransferase', 209, NULL, NULL, 92907),
(92908, '1.10.510.10-FF-000318', NULL, 'Tyrosine-protein kinase', 190, NULL, NULL, 92908),
(92909, '3.30.565.10-FF-000337', NULL, 'Histidine kinase', 149, NULL, NULL, 92909),
(92910, '1.10.510.10-FF-001954', NULL, 'Uncharacterized protein', 194, NULL, NULL, 92910),
(92911, '3.40.640.10-FF-000302', NULL, 'Uncharacterized aminotransferase C27F1.05c', 259, NULL, NULL, 92911),
(92912, '2.10.220.10-FF-000181', NULL, 'Uncharacterized protein', 67, NULL, NULL, 92912),
(92913, '2.60.40.10-FF-000608', NULL, 'obscurin-like protein 1 isoform X2', 94, NULL, NULL, 92913),
(92914, '2.60.40.10-FF-000322', NULL, 'Muscle, skeletal receptor tyrosine protein kinase', 92, NULL, NULL, 92914),
(92915, '1.10.275.10-FF-000030', NULL, NULL, 113, NULL, NULL, 92915),
(92916, '3.30.160.60-FF-006224', NULL, NULL, 90, NULL, NULL, 92916),
(92917, '4.10.70.10-FF-000001', NULL, 'Disintegrin and metalloproteinase domain-containing protein 22', 85, NULL, NULL, 92917),
(92918, '3.40.50.1360-FF-000038', NULL, 'Ribose 5-phosphate isomerase A, variant', 135, NULL, NULL, 92918),
(92919, '1.10.287.1130-FF-000001', NULL, 'cytochrome c oxidase copper chaperone', 66, NULL, NULL, 92919),
(92920, '3.30.160.60-FF-003969', NULL, NULL, 33, NULL, NULL, 92920),
(92921, '3.30.70.20-FF-000112', NULL, NULL, 60, NULL, NULL, 92921),
(92922, '2.10.25.10-FF-001733', NULL, 'Adhesion G protein-coupled receptor L4', 38, NULL, NULL, 92922),
(92923, '3.40.50.720-FF-000488', NULL, 'N5-(Carboxyethyl)ornithine synthase', 120, NULL, NULL, 92923),
(92924, '1.10.150.110-FF-000009', NULL, 'DNA polymerase', 46, NULL, NULL, 92924),
(92925, '3.90.175.10-FF-000007', NULL, 'Uncharacterized protein', 106, NULL, NULL, 92925),
(92926, '3.40.50.300-FF-008517', NULL, 'Uncharacterized protein', 112, NULL, NULL, 92926),
(92927, '3.90.550.10-FF-000571', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 31, NULL, NULL, 92927),
(92928, '3.40.190.10-FF-000048', NULL, 'sn-glycerol-3-phosphate-binding periplasmic protein ugpB', 203, NULL, NULL, 92928),
(92929, '2.120.10.80-FF-000023', NULL, 'Kelch-like family member 24', 300, NULL, NULL, 92929);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(92930, '3.40.1190.20-FF-000096', NULL, 'Phosphomethylpyrimidine kinase (ThiD-2)', 269, NULL, NULL, 92930),
(92931, '3.30.40.10-FF-001299', NULL, 'YALI0F02981p', 82, NULL, NULL, 92931),
(92932, '3.30.200.20-FF-001736', NULL, 'Calcium-dependent protein kinase', 84, NULL, NULL, 92932),
(92933, '3.30.1240.10-FF-000049', NULL, 'Cof-type HAD-IIB family hydrolase', 112, NULL, NULL, 92933),
(92934, '3.90.1150.10-FF-000011', NULL, 'Pyridoxal phosphate-dependent aminotransferase', 136, NULL, NULL, 92934),
(92935, '3.90.230.10-FF-000024', NULL, 'Probable metalloprotease ARX1', 282, NULL, NULL, 92935),
(92936, '3.40.50.1820-FF-001772', NULL, 'Carboxypeptidase', 194, NULL, NULL, 92936),
(92937, '3.30.1490.40-FF-000020', NULL, NULL, 30, NULL, NULL, 92937),
(92938, '2.60.120.330-FF-000169', NULL, '2-oxoglutarate (2OG) and Fe(II)-dependent oxygenase superfamily protein', 271, NULL, NULL, 92938),
(92939, '1.10.8.60-FF-000092', NULL, 'IQ motif containing with AAA domain 1 like', 50, NULL, NULL, 92939),
(92940, '3.90.550.10-FF-000514', NULL, 'Alpha-1,3-rhamnosyltransferase WapR', 254, NULL, NULL, 92940),
(92941, '3.30.1120.120-FF-000004', NULL, 'serine/threonine-protein kinase PLK4-like isoform X1', 121, NULL, NULL, 92941),
(92942, '1.10.150.50-FF-000168', NULL, 'Uncharacterized protein', 50, NULL, NULL, 92942),
(92943, '2.130.10.10-FF-004066', NULL, 'Uncharacterized protein', 206, NULL, NULL, 92943),
(92944, '1.10.1070.11-FF-000043', NULL, 'Serine/threonine-protein kinase Tel1', 195, NULL, NULL, 92944),
(92945, '2.120.10.80-FF-000080', NULL, 'Actin-binding protein IPP', 140, NULL, NULL, 92945),
(92946, '2.20.28.10-FF-000054', NULL, 'DNA replication licensing factor MCM7', 17, NULL, NULL, 92946),
(92947, '2.40.33.10-FF-000014', NULL, 'Pyruvate kinase', 99, NULL, NULL, 92947),
(92948, '1.10.555.10-FF-000248', NULL, NULL, 246, NULL, NULL, 92948),
(92949, '2.10.25.10-FF-001115', NULL, 'Delta-like protein', 42, NULL, NULL, 92949),
(92950, '3.40.50.150-FF-000620', NULL, 'Uncharacterized protein', 208, NULL, NULL, 92950),
(92951, '1.10.418.10-FF-000042', NULL, 'Fimbrin, putative', 131, NULL, NULL, 92951),
(92952, '3.40.50.200-FF-000096', NULL, 'Serine protease, subtilase family', 367, NULL, NULL, 92952),
(92953, '1.10.8.270-FF-000018', NULL, 'Ypt/Rab-GAP domain of gyp1p superfamily protein', 99, NULL, NULL, 92953),
(92954, '3.40.190.10-FF-000380', NULL, 'Molybdate ABC transporter, periplasmic molybdate-binding protein', 112, NULL, NULL, 92954),
(92955, '1.25.10.10-FF-001955', NULL, 'Uncharacterized protein', 272, NULL, NULL, 92955),
(92956, '3.40.50.720-FF-001505', NULL, 'Predicted protein', 113, NULL, NULL, 92956),
(92957, '1.25.10.10-FF-002231', NULL, 'Uncharacterized protein', 1058, NULL, NULL, 92957),
(92958, '1.10.10.60-FF-000345', NULL, 'Homeobox protein engrailed-like', 81, NULL, NULL, 92958),
(92959, '3.30.830.10-FF-000235', NULL, 'Uncharacterized protein', 219, NULL, NULL, 92959),
(92960, '3.30.160.60-FF-005881', NULL, NULL, 37, NULL, NULL, 92960),
(92961, '3.90.600.10-FF-000002', NULL, 'Trifunctional purine biosynthetic protein adenosine-3', 97, NULL, NULL, 92961),
(92962, '1.20.140.50-FF-000002', NULL, 'tyrosine-protein phosphatase non-receptor type 23 isoform X2', 183, NULL, NULL, 92962),
(92963, '3.40.50.720-FF-000887', NULL, 'Mannosyl-transferase', 124, NULL, NULL, 92963),
(92964, '3.80.10.10-FF-002852', NULL, 'Si:ch211-191d15.2', 115, NULL, NULL, 92964),
(92965, '3.50.7.10-FF-000008', NULL, 'T-complex protein 1 subunit theta', 153, NULL, NULL, 92965),
(92966, '3.70.10.10-FF-000008', NULL, 'Cell cycle checkpoint control protein', 271, NULL, NULL, 92966),
(92967, '3.40.1110.10-FF-000442', NULL, NULL, 127, NULL, NULL, 92967),
(92968, '2.40.40.20-FF-000039', NULL, 'Vesicle-fusing ATPase, putative', 79, NULL, NULL, 92968),
(92969, '3.40.50.300-FF-006101', NULL, 'Uncharacterized protein', 107, NULL, NULL, 92969),
(92970, '2.80.10.50-FF-000202', NULL, 'Predicted protein', 169, NULL, NULL, 92970),
(92971, '1.10.287.110-FF-000385', NULL, 'Uncharacterized protein', 98, NULL, NULL, 92971),
(92972, '3.80.10.10-FF-001093', NULL, 'NACHT, LRR and PYD domains-containing protein 6', 218, NULL, NULL, 92972);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(92973, '2.60.40.3510-FF-000027', NULL, 'Delta-like protein', 124, NULL, NULL, 92973),
(92974, '3.40.190.290-FF-000040', NULL, 'LysR family transcriptional regulator', 202, NULL, NULL, 92974),
(92975, '2.60.40.60-FF-000584', NULL, 'FAT atypical cadherin 1b', 99, NULL, NULL, 92975),
(92976, '1.20.890.10-FF-000030', NULL, 'DPY30 domain-containing protein 2', 44, NULL, NULL, 92976),
(92977, '3.40.50.300-FF-001031', NULL, 'Iron ABC transporter ATP-binding protein', 259, NULL, NULL, 92977),
(92978, '3.90.550.10-FF-000239', NULL, 'Possible transferase (Possibly glycosyltransferase)', 234, NULL, NULL, 92978),
(92979, '2.10.25.10-FF-001172', NULL, 'uromodulin', 52, NULL, NULL, 92979),
(92980, '3.20.110.10-FF-000031', NULL, 'Uncharacterized protein', 124, NULL, NULL, 92980),
(92981, '1.10.287.1490-FF-000018', NULL, 'cytospin-A isoform X5', 156, NULL, NULL, 92981),
(92982, '3.30.450.60-FF-000075', NULL, 'Uncharacterized protein', 142, NULL, NULL, 92982),
(92983, '2.60.40.150-FF-000011', NULL, 'Synaptotagmin 6', 145, NULL, NULL, 92983),
(92984, '2.130.10.10-FF-004009', NULL, 'Protein CBG07981', 225, NULL, NULL, 92984),
(92985, '1.10.510.10-FF-002230', NULL, NULL, 224, NULL, NULL, 92985),
(92986, '3.40.50.1240-FF-000058', NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', 401, NULL, NULL, 92986),
(92987, '1.20.1250.20-FF-001091', NULL, 'Monocarboxylate transporter, putative', 217, NULL, NULL, 92987),
(92988, '2.40.100.10-FF-000142', NULL, 'Peptidyl-prolyl cis-trans isomerase', 181, NULL, NULL, 92988),
(92989, '1.10.246.130-FF-000017', NULL, NULL, 100, NULL, NULL, 92989),
(92990, '3.30.1360.70-FF-000025', NULL, NULL, 118, NULL, NULL, 92990),
(92991, '3.40.50.261-FF-000036', NULL, 'Succinate--CoA ligase', 137, NULL, NULL, 92991),
(92992, '1.10.20.10-FF-000224', NULL, NULL, 75, NULL, NULL, 92992),
(92993, '1.10.3080.10-FF-000048', NULL, 'Chloride channel protein-related protein', 378, NULL, NULL, 92993),
(92994, '1.10.510.10-FF-000532', NULL, 'VRK serine/threonine kinase 2', 384, NULL, NULL, 92994),
(92995, '3.40.50.1000-FF-000705', NULL, NULL, 105, NULL, NULL, 92995),
(92996, '2.30.30.40-FF-000242', NULL, 'Actin binding protein', 63, NULL, NULL, 92996),
(92997, '1.20.810.10-FF-000036', NULL, 'COB-i1 protein, alternatively spliced', 177, NULL, NULL, 92997),
(92998, '3.30.70.330-FF-002035', NULL, NULL, 177, NULL, NULL, 92998),
(92999, '1.10.287.70-FF-000676', NULL, 'Uncharacterized protein', 99, NULL, NULL, 92999),
(93000, '1.25.40.10-FF-001378', NULL, 'Pre-mRNA-splicing factor SYF1', 124, NULL, NULL, 93000),
(93001, '3.30.70.890-FF-000056', NULL, 'Mevalonate kinase', 121, NULL, NULL, 93001),
(93002, '3.40.47.10-FF-000072', NULL, 'Thiolase', 429, NULL, NULL, 93002),
(93003, '3.20.20.60-FF-000026', NULL, 'Pyruvate kinase', 215, NULL, NULL, 93003),
(93004, '1.10.540.10-FF-000034', NULL, 'Acyl-[acyl-carrier-protein] dehydrogenase MbtN', 115, NULL, NULL, 93004),
(93005, '3.80.10.10-FF-003330', NULL, 'leucine-rich repeat transmembrane neuronal protein 1-like', 124, NULL, NULL, 93005),
(93006, '3.30.2170.10-FF-000009', NULL, 'Endonuclease V, putative', 250, NULL, NULL, 93006),
(93007, '2.130.10.10-FF-006005', NULL, 'Uncharacterized protein', 26, NULL, NULL, 93007),
(93008, '3.30.160.60-FF-004341', NULL, NULL, 23, NULL, NULL, 93008),
(93009, '3.30.160.60-FF-002087', NULL, 'Zinc finger protein 619', 32, NULL, NULL, 93009),
(93010, '1.10.238.10-FF-000606', NULL, 'Calmodulin, putative', 70, NULL, NULL, 93010),
(93011, '2.60.40.10-FF-005847', NULL, NULL, 102, NULL, NULL, 93011),
(93012, '2.130.10.10-FF-005858', NULL, 'Ubiquitin-binding serine/threonine protein kinase', 318, NULL, NULL, 93012),
(93013, '2.40.10.10-FF-000512', NULL, NULL, 64, NULL, NULL, 93013),
(93014, '3.40.50.140-FF-000016', NULL, 'DNA topoisomerase', 167, NULL, NULL, 93014),
(93015, '1.25.40.20-FF-000279', NULL, 'Calmodulin-binding transcription activator 4', 127, NULL, NULL, 93015),
(93016, '1.10.8.430-FF-000016', NULL, 'Apoptotic protease-activating factor, putative', 89, NULL, NULL, 93016),
(93017, '1.25.40.930-FF-000002', NULL, 'Checkpoint serine/threonine-protein kinase BUB1', 124, NULL, NULL, 93017);
INSERT INTO "PUBLIC"."MODEL" VALUES
(93018, '3.80.10.10-FF-001076', NULL, 'Protein phosphatase PP1 regulatory subunit sds22', 113, NULL, NULL, 93018),
(93019, '1.10.8.270-FF-000142', NULL, 'Uncharacterized protein', 104, NULL, NULL, 93019),
(93020, '3.30.70.580-FF-000070', NULL, 'tRNA pseudouridine synthase', 122, NULL, NULL, 93020),
(93021, '3.40.50.150-FF-000019', NULL, 'tRNA (adenine(58)-N(1))-methyltransferase TrmI', 197, NULL, NULL, 93021),
(93022, '1.10.10.10-FF-000252', NULL, 'Exu regulon transcriptional regulator', 73, NULL, NULL, 93022),
(93023, '2.40.100.10-FF-000024', NULL, 'Peptidyl-prolyl cis-trans isomerase', 181, NULL, NULL, 93023),
(93024, '3.30.70.330-FF-001529', NULL, 'Polyadenylate-binding protein', 103, NULL, NULL, 93024),
(93025, '3.40.1090.10-FF-000012', NULL, 'calcium-independent phospholipase A2-gamma isoform X1', 330, NULL, NULL, 93025),
(93026, '1.10.10.60-FF-000160', NULL, 'MYB-like transcription factor', 43, NULL, NULL, 93026),
(93027, '3.90.550.10-FF-000251', NULL, 'Beta-1,3-glucosyltransferase', 244, NULL, NULL, 93027),
(93028, '3.30.70.330-FF-003137', NULL, NULL, 100, NULL, NULL, 93028),
(93029, '3.10.20.350-FF-000001', NULL, 'Orf1a polyprotein', 90, NULL, NULL, 93029),
(93030, '2.60.40.1120-FF-000052', NULL, 'Carboxypeptidase M', 107, NULL, NULL, 93030),
(93031, '3.90.1170.20-FF-000010', NULL, 'ModD protein', 121, NULL, NULL, 93031),
(93032, '2.60.40.10-FF-000530', NULL, 'V-set and transmembrane domain containing 2A', 132, NULL, NULL, 93032),
(93033, '3.50.4.10-FF-000002', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', 82, NULL, NULL, 93033),
(93034, '3.90.1600.10-FF-000052', NULL, 'DNA polymerase epsilon, catalytic subunit A', 195, NULL, NULL, 93034),
(93035, '3.40.1500.10-FF-000011', NULL, 'Coproporphyrinogen III oxidase', 335, NULL, NULL, 93035),
(93036, '2.60.40.60-FF-001101', NULL, 'Uncharacterized protein', 111, NULL, NULL, 93036),
(93037, '2.40.40.10-FF-000014', NULL, NULL, 136, NULL, NULL, 93037),
(93038, '3.40.50.300-FF-006191', NULL, 'ABC transporter ATP-binding protein uup-2', 91, NULL, NULL, 93038),
(93039, '3.30.200.20-FF-001770', NULL, 'High affinity nerve growth factor receptor, putative', 142, NULL, NULL, 93039),
(93040, '3.90.1170.30-FF-000013', NULL, 'Pyrimidine-nucleoside phosphorylase (PYNP)', 65, NULL, NULL, 93040),
(93041, '2.130.10.10-FF-002632', NULL, 'Protein FAM234A', 226, NULL, NULL, 93041),
(93042, '4.10.1240.50-FF-000003', NULL, 'Arginine-glutamic acid dipeptide (RE) repeats a', 110, NULL, NULL, 93042),
(93043, '1.20.870.10-FF-000045', NULL, 'Ras guanine nucleotide exchange factor Q', 167, NULL, NULL, 93043),
(93044, '3.10.20.360-FF-000004', NULL, NULL, 118, NULL, NULL, 93044),
(93045, '3.40.50.300-FF-004257', NULL, 'SNF2 family N-terminal domain-domain-containing protein', 192, NULL, NULL, 93045),
(93046, '2.120.10.30-FF-000216', NULL, 'low-density lipoprotein receptor-related protein 6 isoform X3', 358, NULL, NULL, 93046),
(93047, '2.60.40.10-FF-006027', NULL, NULL, 85, NULL, NULL, 93047),
(93048, '2.40.270.10-FF-000019', NULL, 'DNA-directed RNA polymerase subunit beta', 83, NULL, NULL, 93048),
(93049, '3.90.730.10-FF-000023', NULL, 'Uncharacterized protein', 58, NULL, NULL, 93049),
(93050, '1.10.530.10-FF-000062', NULL, 'Uncharacterized protein', 98, NULL, NULL, 93050),
(93051, '2.60.120.330-FF-000147', NULL, 'Uncharacterized protein', 101, NULL, NULL, 93051),
(93052, '3.40.50.12550-FF-000011', NULL, 'Uncharacterized protein', 145, NULL, NULL, 93052),
(93053, '3.90.550.10-FF-000621', NULL, 'Uncharacterized protein', 205, NULL, NULL, 93053),
(93054, '1.25.40.10-FF-005077', NULL, 'Uncharacterized protein', 94, NULL, NULL, 93054),
(93055, '1.10.1750.10-FF-000004', NULL, 'Chromosomal replication initiator protein DnaA', 100, NULL, NULL, 93055),
(93056, '3.30.1640.10-FF-000017', NULL, 'DNA helicase', 114, NULL, NULL, 93056),
(93057, '2.60.120.970-FF-000018', NULL, 'Decapentaplegic, isoform A', 241, NULL, NULL, 93057),
(93058, '2.120.10.80-FF-000124', NULL, 'Kel1p', 239, NULL, NULL, 93058),
(93059, '4.10.910.10-FF-000006', NULL, 'Similar to ribosomal protein S18', 41, NULL, NULL, 93059);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(93060, '1.20.120.350-FF-000264', NULL, NULL, 117, NULL, NULL, 93060),
(93061, '2.40.70.10-FF-000521', NULL, NULL, 55, NULL, NULL, 93061),
(93062, '3.40.395.10-FF-000041', NULL, 'SUMO-specific peptidase 3', 127, NULL, NULL, 93062),
(93063, '3.30.160.60-FF-000642', NULL, 'Zinc finger with KRAB and SCAN domains 2', 37, NULL, NULL, 93063),
(93064, '3.40.50.300-FF-006202', NULL, 'DNA helicase', 273, NULL, NULL, 93064),
(93065, '3.40.50.720-FF-001393', NULL, 'YALI0F31427p', 162, NULL, NULL, 93065),
(93066, '3.10.110.10-FF-000084', NULL, 'WD repeat domain 59', 118, NULL, NULL, 93066),
(93067, '3.40.1360.10-FF-000022', NULL, 'Topoisomerase, putative', 214, NULL, NULL, 93067),
(93068, '1.10.510.10-FF-004231', NULL, NULL, 308, NULL, NULL, 93068),
(93069, '1.20.245.10-FF-000003', NULL, 'Arachidonate lipoxygenase 3', 68, NULL, NULL, 93069),
(93070, '1.25.40.10-FF-003632', NULL, 'Uncharacterized protein', 132, NULL, NULL, 93070),
(93071, '1.25.10.10-FF-001876', NULL, 'Uncharacterized protein', 116, NULL, NULL, 93071),
(93072, '1.10.30.10-FF-000152', NULL, 'Uncharacterized protein', 79, NULL, NULL, 93072),
(93073, '3.40.30.10-FF-000562', NULL, 'NADH dehydrogenase subunit E', 97, NULL, NULL, 93073),
(93074, '3.30.890.10-FF-000020', NULL, 'Predicted protein', 54, NULL, NULL, 93074),
(93075, '1.20.1250.20-FF-001523', NULL, 'Uncharacterized protein', 123, NULL, NULL, 93075),
(93076, '1.20.1070.10-FF-001422', NULL, 'Uncharacterized protein', 229, NULL, NULL, 93076),
(93077, '3.40.50.300-FF-008326', NULL, 'Uncharacterized protein', 243, NULL, NULL, 93077),
(93078, '1.10.630.10-FF-000479', NULL, 'Uncharacterized protein', 499, NULL, NULL, 93078),
(93079, '1.25.10.10-FF-002023', NULL, 'Uncharacterized protein', 344, NULL, NULL, 93079),
(93080, '3.30.565.10-FF-000023', NULL, 'PAS domain-containing sensor histidine kinase', 156, NULL, NULL, 93080),
(93081, '3.20.20.80-FF-000667', NULL, 'AEL220Cp', 424, NULL, NULL, 93081),
(93082, '3.40.800.20-FF-000054', NULL, 'Os11g0201400 protein', 254, NULL, NULL, 93082),
(93083, '3.10.400.10-FF-000005', NULL, 'Sulfate adenylyltransferase', 141, NULL, NULL, 93083),
(93084, '3.90.226.10-FF-000132', NULL, 'Crotonase', 251, NULL, NULL, 93084),
(93085, '2.20.70.10-FF-000005', NULL, 'E3 ubiquitin-protein ligase', 43, NULL, NULL, 93085),
(93086, '3.40.50.1000-FF-000026', NULL, 'NT5DC3 isoform 1', 196, NULL, NULL, 93086),
(93087, '2.60.120.1440-FF-000002', NULL, 'Probable transmembrane sensor', 138, NULL, NULL, 93087),
(93088, '3.40.50.300-FF-001986', NULL, 'ATP-dependent DNA helicase PIF1', 229, NULL, NULL, 93088),
(93089, '3.40.50.300-FF-005685', NULL, 'Uncharacterized protein', 184, NULL, NULL, 93089),
(93090, '3.20.20.70-FF-000664', NULL, NULL, 224, NULL, NULL, 93090),
(93091, '1.10.510.10-FF-000162', NULL, 'Mitogen-activated protein kinase', 210, NULL, NULL, 93091),
(93092, '3.30.200.20-FF-002124', NULL, NULL, 74, NULL, NULL, 93092),
(93093, '1.10.418.20-FF-000028', NULL, 'Uncharacterized protein', 122, NULL, NULL, 93093),
(93094, '3.30.420.40-FF-000213', NULL, 'Actin related protein T3', 160, NULL, NULL, 93094),
(93095, '2.30.30.40-FF-000612', NULL, 'Dynamin binding protein', 54, NULL, NULL, 93095),
(93096, '3.40.50.150-FF-001789', NULL, NULL, 172, NULL, NULL, 93096),
(93097, '3.40.50.1700-FF-000039', NULL, 'Glycoside hydrolase family 3 domain protein', 237, NULL, NULL, 93097),
(93098, '3.30.1360.120-FF-000046', NULL, 'Pyruvate dehydrogenase phosphatase regulatory mitochondrial', 113, NULL, NULL, 93098),
(93099, '2.30.180.10-FF-000071', NULL, 'Uncharacterized protein', 139, NULL, NULL, 93099),
(93100, '2.40.10.10-FF-000175', NULL, 'Serine protease grass', 133, NULL, NULL, 93100),
(93101, '2.130.10.10-FF-004077', NULL, 'Protein CBG18869', 203, NULL, NULL, 93101),
(93102, '1.10.220.160-FF-000029', NULL, NULL, 92, NULL, NULL, 93102),
(93103, '3.10.180.10-FF-000032', NULL, 'Cadmium inducible protein CadI', 122, NULL, NULL, 93103),
(93104, '1.10.287.2250-FF-000005', NULL, 'Cysteine peptidase', 75, NULL, NULL, 93104),
(93105, '3.90.640.90-FF-000028', NULL, 'Uncharacterized protein', 69, NULL, NULL, 93105);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(93106, '3.30.160.60-FF-006139', NULL, NULL, 28, NULL, NULL, 93106),
(93107, '3.40.50.1820-FF-001244', NULL, 'Predicted protein', 321, NULL, NULL, 93107),
(93108, '3.80.10.10-FF-000896', NULL, 'Leucine-rich repeat receptor-like protein kinase', 93, NULL, NULL, 93108),
(93109, '3.40.920.10-FF-000009', NULL, 'Pyruvate synthase subunit PorD', 201, NULL, NULL, 93109),
(93110, '3.30.530.20-FF-000209', NULL, 'WD40 repeat-containing protein', 235, NULL, NULL, 93110),
(93111, '3.40.50.2300-FF-000213', NULL, 'Grik, isoform C', 204, NULL, NULL, 93111),
(93112, '1.10.1420.10-FF-000018', NULL, 'DNA mismatch repair protein MutS', 117, NULL, NULL, 93112),
(93113, '2.40.30.10-FF-000412', NULL, 'Uncharacterized protein', 111, NULL, NULL, 93113),
(93114, '1.25.10.10-FF-002702', NULL, 'Ppp2r5d protein', 60, NULL, NULL, 93114),
(93115, '1.10.418.10-FF-000025', NULL, 'Plastin-3 isoform 1', 133, NULL, NULL, 93115),
(93116, '2.130.10.10-FF-005179', NULL, 'Predicted protein', 125, NULL, NULL, 93116),
(93117, '3.40.50.1780-FF-000006', NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', 143, NULL, NULL, 93117),
(93118, '1.10.238.10-FF-000236', NULL, 'Protein S100', 76, NULL, NULL, 93118),
(93119, '3.30.1390.20-FF-000012', NULL, '50S ribosomal protein L30', 91, NULL, NULL, 93119),
(93120, '3.30.200.20-FF-001444', NULL, 'CDK14 isoform 1', 42, NULL, NULL, 93120),
(93121, '1.25.40.10-FF-002204', NULL, 'Anaphase-promoting complex subunit 5-like Protein', 295, NULL, NULL, 93121),
(93122, '1.20.144.10-FF-000111', NULL, 'Phospholipid phosphatase 2', 228, NULL, NULL, 93122),
(93123, '3.10.20.590-FF-000005', NULL, 'Uncharacterized protein', 75, NULL, NULL, 93123),
(93124, '3.10.50.40-FF-000146', NULL, 'Trigger factor', 100, NULL, NULL, 93124),
(93125, '1.20.58.220-FF-000006', NULL, 'Phosphate-specific transport system accessory protein PhoU', 114, NULL, NULL, 93125),
(93126, '3.30.160.60-FF-002407', NULL, 'Zinc finger and SCAN domain containing 1', 32, NULL, NULL, 93126),
(93127, '3.70.10.10-FF-000109', NULL, 'Uncharacterized protein', 258, NULL, NULL, 93127),
(93128, '3.30.360.10-FF-000053', NULL, 'Aspartate-semialdehyde dehydrogenase, putative', 188, NULL, NULL, 93128),
(93129, '3.90.132.10-FF-000009', NULL, 'Cell surface protease gp63, putative', 110, NULL, NULL, 93129),
(93130, '2.60.40.10-FF-002328', NULL, 'Basal cell adhesion molecule', 81, NULL, NULL, 93130),
(93131, '2.130.10.10-FF-005488', NULL, 'Uncharacterized protein', 305, NULL, NULL, 93131),
(93132, '3.10.20.90-FF-000535', NULL, 'Ubiquitin, putative', 78, NULL, NULL, 93132),
(93133, '2.60.120.10-FF-000482', NULL, 'Predicted protein', 137, NULL, NULL, 93133),
(93134, '1.10.3210.10-FF-000065', NULL, 'RelA/SpoT family protein', 181, NULL, NULL, 93134),
(93135, '3.40.140.10-FF-000034', NULL, 'Eukaryotic translation initiation factor 3 subunit F', 179, NULL, NULL, 93135),
(93136, '3.40.50.1820-FF-001553', NULL, 'Uncharacterized protein', 123, NULL, NULL, 93136),
(93137, '3.70.10.10-FF-000082', NULL, 'DNA repair protein Rad9, putative', 236, NULL, NULL, 93137),
(93138, '2.40.50.140-FF-000132', NULL, 'Aspartyl-tRNA synthetase, cytoplasmic', 129, NULL, NULL, 93138),
(93139, '3.40.50.720-FF-001404', NULL, 'NAD-dependent epimerase/dehydratase', 206, NULL, NULL, 93139),
(93140, '1.10.10.790-FF-000015', NULL, 'Splicing factor 3A subunit 1', 68, NULL, NULL, 93140),
(93141, '1.10.10.10-FF-000622', NULL, 'GntR family transcriptional regulator', 70, NULL, NULL, 93141),
(93142, '3.40.50.12160-FF-000017', NULL, 'Threonylcarbamoyladenosine tRNA methylthiotransferase', 120, NULL, NULL, 93142),
(93143, '3.40.630.30-FF-000566', NULL, 'Uncharacterized protein', 116, NULL, NULL, 93143),
(93144, '4.10.900.10-FF-000034', NULL, 'Uncharacterized protein', 81, NULL, NULL, 93144),
(93145, '3.40.50.300-FF-006511', NULL, 'Uncharacterized protein', 112, NULL, NULL, 93145),
(93146, '3.30.200.20-FF-000342', NULL, 'Protein kinase superfamily protein', 109, NULL, NULL, 93146),
(93147, '2.60.120.620-FF-000127', NULL, 'Putative prolyl 4-hydroxylase 3', 85, NULL, NULL, 93147),
(93148, '1.10.1170.10-FF-000010', NULL, 'Baculoviral IAP repeat containing 2', 122, NULL, NULL, 93148);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(93149, '1.20.1280.50-FF-000258', NULL, 'F-box/WD repeat-containing protein A', 122, NULL, NULL, 93149),
(93150, '1.25.40.20-FF-000616', NULL, 'Ankyrin repeats (3 copies)/Ankyrin repeats (Many copies)/Ankyrin repeat, putative', 119, NULL, NULL, 93150),
(93151, '1.20.5.580-FF-000002', NULL, 'Complexin, isoform AB', 62, NULL, NULL, 93151),
(93152, '3.20.20.70-FF-000338', NULL, 'Alpha-galactosidase', 328, NULL, NULL, 93152),
(93153, '1.25.40.10-FF-000613', NULL, 'Coatomer subunit epsilon', 283, NULL, NULL, 93153),
(93154, '1.10.287.40-FF-000015', NULL, 'Serine-tRNA ligase', 104, NULL, NULL, 93154),
(93155, '3.30.505.10-FF-000047', NULL, 'Transcription elongation factor spt6', 112, NULL, NULL, 93155),
(93156, '2.30.29.30-FF-001157', NULL, 'DEF6 guanine nucleotide exchange factor c', 108, NULL, NULL, 93156),
(93157, '1.20.120.1760-FF-000031', NULL, 'Choline/ethanolaminephosphotransferase, putative', 191, NULL, NULL, 93157),
(93158, '3.40.50.300-FF-004920', NULL, 'Uncharacterized protein', 219, NULL, NULL, 93158),
(93159, '3.30.70.1230-FF-000272', NULL, 'Guanylate cyclase', 119, NULL, NULL, 93159),
(93160, '1.10.60.10-FF-000007', NULL, 'Manganese transport regulator MntR', 54, NULL, NULL, 93160),
(93161, '3.40.50.11770-FF-000001', NULL, 'Uncharacterized protein', 112, NULL, NULL, 93161),
(93162, '4.10.60.10-FF-000242', NULL, 'Uncharacterized protein', 41, NULL, NULL, 93162),
(93163, '3.30.160.60-FF-005959', NULL, NULL, 30, NULL, NULL, 93163),
(93164, '4.10.400.10-FF-000248', NULL, 'Uncharacterized protein, isoform B', 48, NULL, NULL, 93164),
(93165, '1.20.58.2220-FF-000037', NULL, 'Formin 2', 405, NULL, NULL, 93165),
(93166, '2.10.220.10-FF-000186', NULL, 'Proprotein convertase subtilisin/kexin type 5a', 65, NULL, NULL, 93166),
(93167, '2.40.20.10-FF-000114', NULL, 'Plasminogen activator, urokinase', 75, NULL, NULL, 93167),
(93168, '3.40.720.10-FF-000337', NULL, 'Uncharacterized protein', 109, NULL, NULL, 93168),
(93169, '3.30.1490.20-FF-000076', NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', 69, NULL, NULL, 93169),
(93170, '2.130.10.10-FF-002306', NULL, 'Uncharacterized protein', 364, NULL, NULL, 93170),
(93171, '2.170.270.10-FF-000106', NULL, 'Histone-lysine N-methyltransferase', 280, NULL, NULL, 93171),
(93172, '3.30.160.60-FF-003498', NULL, 'zinc finger protein 613 isoform X2', 23, NULL, NULL, 93172),
(93173, '3.40.50.2300-FF-001624', NULL, NULL, 282, NULL, NULL, 93173),
(93174, '3.40.120.10-FF-000117', NULL, 'Uncharacterized protein', 60, NULL, NULL, 93174),
(93175, '1.20.58.530-FF-000009', NULL, 'unconventional myosin-IXb isoform X1', 39, NULL, NULL, 93175),
(93176, '1.20.1530.20-FF-000050', NULL, 'Uncharacterized protein', 156, NULL, NULL, 93176),
(93177, '3.40.50.80-FF-000100', NULL, 'Ferric reduction oxidase 2', 124, NULL, NULL, 93177),
(93178, '3.60.21.10-FF-000186', NULL, 'Calcineurin-like metallo-phosphoesterase superfamily protein', 372, NULL, NULL, 93178),
(93179, '1.20.190.50-FF-000016', NULL, 'Uncharacterized protein', 255, NULL, NULL, 93179),
(93180, '3.40.50.300-FF-005100', NULL, 'GPN-loop GTPase 2', 266, NULL, NULL, 93180),
(93181, '3.80.10.10-FF-001385', NULL, 'Blast:Chaoptin', 156, NULL, NULL, 93181),
(93182, '3.40.50.1480-FF-000006', NULL, 'Adenosylhomocysteinase', 149, NULL, NULL, 93182),
(93183, '3.20.20.70-FF-000029', NULL, 'L-lactate dehydrogenase', 364, NULL, NULL, 93183),
(93184, '3.30.310.130-FF-000024', NULL, 'Uncharacterized protein', 126, NULL, NULL, 93184),
(93185, '3.30.365.10-FF-000058', NULL, 'Uncharacterized protein', 32, NULL, NULL, 93185),
(93186, '1.20.1070.10-FF-000579', NULL, 'EGF-like module-containing mucin-like hormone receptor-like 2', 153, NULL, NULL, 93186),
(93187, '3.40.50.2300-FF-001315', NULL, NULL, 112, NULL, NULL, 93187),
(93188, '3.30.70.870-FF-000050', NULL, 'Elongation factor G', 73, NULL, NULL, 93188),
(93189, '3.40.50.300-FF-002666', NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', 117, NULL, NULL, 93189),
(93190, '2.60.40.10-FF-004436', NULL, NULL, 87, NULL, NULL, 93190),
(93191, '3.30.9.10-FF-000187', NULL, 'Uncharacterized protein', 192, NULL, NULL, 93191);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(93192, '1.20.1070.10-FF-000011', NULL, 'Adhesion G protein-coupled receptor L2', 280, NULL, NULL, 93192),
(93193, '1.10.287.950-FF-000013', NULL, 'Methyl-accepting chemotaxis protein', 331, NULL, NULL, 93193),
(93194, '1.10.560.10-FF-000097', NULL, 'Chaperonin, putative', 232, NULL, NULL, 93194),
(93195, '3.40.50.150-FF-000715', NULL, 'Site-specific DNA-methyltransferase (adenine-specific)', 153, NULL, NULL, 93195),
(93196, '3.40.50.300-FF-004274', NULL, 'Predicted protein', 226, NULL, NULL, 93196),
(93197, '1.10.437.10-FF-000047', NULL, 'Uncharacterized protein', 139, NULL, NULL, 93197),
(93198, '1.10.630.10-FF-000816', NULL, 'Cytochrome P450', 259, NULL, NULL, 93198),
(93199, '1.25.40.20-FF-000751', NULL, 'Ankyrin repeat and SOCS box-containing 2b', 101, NULL, NULL, 93199),
(93200, '3.90.190.10-FF-000088', NULL, 'Receptor protein-tyrosine phosphatase LAR', 288, NULL, NULL, 93200),
(93201, '3.40.50.300-FF-002150', NULL, 'Phosphoglycerate mutase, putative', 210, NULL, NULL, 93201),
(93202, '3.30.160.60-FF-005976', NULL, NULL, 62, NULL, NULL, 93202),
(93203, '3.20.100.10-FF-000002', NULL, 'mRNA capping nucleoside-triphosphatase, putative', 329, NULL, NULL, 93203),
(93204, '1.20.920.10-FF-000191', NULL, 'Uncharacterized protein', 148, NULL, NULL, 93204),
(93205, '1.20.1110.10-FF-000049', NULL, 'Putative P-type ATPase', 122, NULL, NULL, 93205),
(93206, '3.30.420.10-FF-000480', NULL, 'Predicted protein', 260, NULL, NULL, 93206),
(93207, '2.130.10.10-FF-004223', NULL, 'Uncharacterized protein', 146, NULL, NULL, 93207),
(93208, '3.90.730.10-FF-000040', NULL, 'Ribonuclease 2', 167, NULL, NULL, 93208),
(93209, '3.40.50.2300-FF-001641', NULL, NULL, 253, NULL, NULL, 93209),
(93210, '2.60.120.330-FF-000164', NULL, 'Predicted protein', 350, NULL, NULL, 93210),
(93211, '2.60.200.20-FF-000064', NULL, 'Putative ABC transporter ATP-binding protein', 95, NULL, NULL, 93211),
(93212, '2.30.29.30-FF-000977', NULL, 'Tyrosine-protein kinase', 89, NULL, NULL, 93212),
(93213, '2.40.10.10-FF-000203', NULL, 'GD11897', 109, NULL, NULL, 93213),
(93214, '1.20.1070.10-FF-001113', NULL, 'Alpha-1B adrenergic receptor', 378, NULL, NULL, 93214),
(93215, '2.130.10.10-FF-001817', NULL, 'ER membrane protein complex subunit 1', 258, NULL, NULL, 93215),
(93216, '1.10.287.940-FF-000010', NULL, 'P2X receptor E', 57, NULL, NULL, 93216),
(93217, '1.20.58.920-FF-000003', NULL, 'Histidine kinase', 274, NULL, NULL, 93217),
(93218, '3.40.50.2300-FF-001287', NULL, NULL, 157, NULL, NULL, 93218),
(93219, '3.30.420.110-FF-000065', NULL, 'DNA mismatch repair protein', 178, NULL, NULL, 93219),
(93220, '3.10.20.90-FF-000165', NULL, 'E3 ubiquitin-protein ligase UHRF2 isoform X1', 78, NULL, NULL, 93220),
(93221, '1.20.1560.10-FF-000807', NULL, 'Putative multidrug resistance-associated protein lethal(2)03659-like Protein', 164, NULL, NULL, 93221),
(93222, '2.10.25.10-FF-001413', NULL, 'Uncharacterized protein', 42, NULL, NULL, 93222),
(93223, '1.20.1070.10-FF-001405', NULL, 'Histamine 4 receptor', 236, NULL, NULL, 93223),
(93224, '2.130.10.10-FF-003717', NULL, 'Uncharacterized protein', 178, NULL, NULL, 93224),
(93225, '1.10.510.10-FF-001943', NULL, 'Uncharacterized protein', 169, NULL, NULL, 93225),
(93226, '2.60.40.1180-FF-000137', NULL, 'Uncharacterized protein', 112, NULL, NULL, 93226),
(93227, '3.10.20.740-FF-000011', NULL, '4Fe-4S ferredoxin, iron-sulphur binding, conserved site', 120, NULL, NULL, 93227),
(93228, '2.60.40.60-FF-000612', NULL, 'Cadherin 26, tandem duplicate 1', 113, NULL, NULL, 93228),
(93229, '1.10.287.110-FF-000071', NULL, 'Heat shock protein DNAJ homologue Pfj4', 114, NULL, NULL, 93229),
(93230, '1.25.40.10-FF-002058', NULL, 'RING zinc finger-containing protein', 140, NULL, NULL, 93230),
(93231, '2.60.40.10-FF-005538', NULL, NULL, 47, NULL, NULL, 93231),
(93232, '3.40.50.300-FF-008309', NULL, 'Uncharacterized protein', 258, NULL, NULL, 93232),
(93233, '1.20.58.390-FF-000243', NULL, 'Uncharacterized protein', 124, NULL, NULL, 93233),
(93234, '1.25.10.10-FF-002040', NULL, 'Microtubule associated protein', 250, NULL, NULL, 93234);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(93235, '3.40.630.30-FF-000196', NULL, 'Potential polyamine N-acetyl transferase', 187, NULL, NULL, 93235),
(93236, '1.10.472.80-FF-000183', NULL, NULL, 133, NULL, NULL, 93236),
(93237, '3.30.230.120-FF-000002', NULL, 'Bifunctional fucokinase/fucose pyrophosphorylase', 344, NULL, NULL, 93237),
(93238, '1.10.8.60-FF-000277', NULL, 'DNA polymerase epsilon subunit', 74, NULL, NULL, 93238),
(93239, '1.20.1250.20-FF-000697', NULL, 'MFS drug efflux pump', 374, NULL, NULL, 93239),
(93240, '1.10.15.30-FF-000004', NULL, 'Putative 60S ribosomal protein L7', 65, NULL, NULL, 93240),
(93241, '1.10.390.10-FF-000073', NULL, 'Uncharacterized protein', 242, NULL, NULL, 93241),
(93242, '1.10.1510.30-FF-000003', NULL, 'Probable tRNA pseudouridine synthase D', 87, NULL, NULL, 93242),
(93243, '3.30.70.870-FF-000033', NULL, 'Elongation factor G-like protein', 77, NULL, NULL, 93243),
(93244, '3.30.160.60-FF-000951', NULL, 'Zinc finger protein 8', 31, NULL, NULL, 93244),
(93245, '3.40.50.300-FF-000351', NULL, 'Replicative DNA helicase', 280, NULL, NULL, 93245),
(93246, '3.40.50.300-FF-005668', NULL, 'ATP-dependent protease ATPase subunit HslU', 195, NULL, NULL, 93246),
(93247, '3.40.640.10-FF-000162', NULL, 'DegT/DnrJ/EryC1/StrS aminotransferase family protein', 253, NULL, NULL, 93247),
(93248, '1.20.1640.10-FF-000033', NULL, 'MMPL family transporter', 209, NULL, NULL, 93248),
(93249, '3.40.50.300-FF-001969', NULL, 'Putative magnesium chelatase', 315, NULL, NULL, 93249),
(93250, '2.130.10.10-FF-000480', NULL, 'Transducin beta like 3', 168, NULL, NULL, 93250),
(93251, '2.40.70.10-FF-000049', NULL, 'Aspartyl protease AED1', 175, NULL, NULL, 93251),
(93252, '3.40.630.60-FF-000007', NULL, NULL, 80, NULL, NULL, 93252),
(93253, '1.50.10.10-FF-000177', NULL, 'alpha-1,2-Mannosidase', 387, NULL, NULL, 93253),
(93254, '3.90.70.10-FF-000910', NULL, 'Ubiquitinyl hydrolase 1', 53, NULL, NULL, 93254),
(93255, '3.40.250.10-FF-000155', NULL, 'Rhodanese domain protein / beta-lactamase domain protein', 107, NULL, NULL, 93255),
(93256, '1.10.12.40-FF-000001', NULL, 'L-seryl-tRNA(Sec) kinase', 64, NULL, NULL, 93256),
(93257, '2.70.170.10-FF-000022', NULL, 'glutamate-gated chloride channel isoform X1', 216, NULL, NULL, 93257),
(93258, '1.10.510.10-FF-000841', NULL, 'Fructosamine kinase', 89, NULL, NULL, 93258),
(93259, '3.40.50.300-FF-006409', NULL, 'Nucleotide binding protein like', 131, NULL, NULL, 93259),
(93260, '3.30.70.890-FF-000039', NULL, 'Phosphomevalonate kinase protein, putative', 128, NULL, NULL, 93260),
(93261, '2.40.40.20-FF-000034', NULL, 'Probable oxidoreductase YoaE', 137, NULL, NULL, 93261),
(93262, '3.30.1360.10-FF-000035', NULL, 'Expressed protein', 54, NULL, NULL, 93262),
(93263, '3.40.50.300-FF-005994', NULL, 'DnaA regulatory inactivator Hda', 161, NULL, NULL, 93263),
(93264, '3.30.310.10-FF-000016', NULL, 'Ribonuclease HIII', 85, NULL, NULL, 93264),
(93265, '1.20.1050.10-FF-000111', NULL, 'Glutathione Stransferase EC 25118', 105, NULL, NULL, 93265),
(93266, '1.10.533.10-FF-000085', NULL, 'Baculoviral IAP repeat containing 7', 22, NULL, NULL, 93266),
(93267, '3.30.450.150-FF-000010', NULL, 'Sll1307 protein', 150, NULL, NULL, 93267),
(93268, '1.10.418.10-FF-000008', NULL, 'Filamin-B isoform C', 123, NULL, NULL, 93268),
(93269, '3.80.10.10-FF-001059', NULL, 'Leucine-rich repeat containing protein', 103, NULL, NULL, 93269),
(93270, '2.30.30.140-FF-000333', NULL, 'Uncharacterized protein', 102, NULL, NULL, 93270),
(93271, '3.40.50.1820-FF-001570', NULL, 'Lipase, putative', 111, NULL, NULL, 93271),
(93272, '3.90.260.10-FF-000032', NULL, 'Uncharacterized protein', 266, NULL, NULL, 93272),
(93273, '2.60.120.10-FF-000835', NULL, 'Probable transcriptional regulator', 72, NULL, NULL, 93273),
(93274, '3.10.20.90-FF-000209', NULL, 'Plexin B3', 140, NULL, NULL, 93274),
(93275, '3.30.160.60-FF-006123', NULL, NULL, 36, NULL, NULL, 93275),
(93276, '1.10.100.10-FF-000012', NULL, 'Insulin-like growth factor II', 37, NULL, NULL, 93276),
(93277, '2.10.220.10-FF-000006', NULL, 'Receptor protein-tyrosine kinase', 123, NULL, NULL, 93277);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(93278, '3.40.50.2000-FF-000213', NULL, 'Alpha-1,4 glucan phosphorylase', 377, NULL, NULL, 93278),
(93279, '3.30.70.330-FF-000118', NULL, 'msx2-interacting protein-like isoform X1', 95, NULL, NULL, 93279),
(93280, '2.80.10.50-FF-000264', NULL, 'Uncharacterized protein', 123, NULL, NULL, 93280),
(93281, '3.40.50.300-FF-003768', NULL, 'Peroxisomal biogenesis factor 6', 158, NULL, NULL, 93281),
(93282, '4.10.170.10-FF-000005', NULL, 'Cellular tumor antigen p53', 48, NULL, NULL, 93282),
(93283, '1.20.58.60-FF-000769', NULL, 'Uncharacterized protein', 243, NULL, NULL, 93283),
(93284, '3.30.70.330-FF-001546', NULL, 'RNA-binding protein, putative', 88, NULL, NULL, 93284),
(93285, '1.20.1110.10-FF-000184', NULL, NULL, 191, NULL, NULL, 93285),
(93286, '2.10.70.10-FF-000085', NULL, 'Uncharacterized protein, isoform A', 62, NULL, NULL, 93286),
(93287, '3.40.30.10-FF-000932', NULL, 'Thioredoxin domain-containing protein C13F5.05, mitochondrial', 116, NULL, NULL, 93287),
(93288, '3.40.50.300-FF-006174', NULL, 'ATP-dependent DNA helicase', 159, NULL, NULL, 93288),
(93289, '3.30.1330.20-FF-000020', NULL, 'Tubulin gamma chain', 111, NULL, NULL, 93289),
(93290, '1.25.40.20-FF-000263', NULL, 'Forked, isoform B', 220, NULL, NULL, 93290),
(93291, '1.10.510.10-FF-002286', NULL, NULL, 96, NULL, NULL, 93291),
(93292, '3.80.10.10-FF-003184', NULL, 'Predicted protein', 243, NULL, NULL, 93292),
(93293, '1.10.510.10-FF-001488', NULL, 'Predicted protein', 81, NULL, NULL, 93293),
(93294, '3.40.50.1240-FF-000002', NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', 410, NULL, NULL, 93294),
(93295, '1.20.1600.10-FF-000042', NULL, 'Channel protein TolC', 406, NULL, NULL, 93295),
(93296, '2.130.10.30-FF-000177', NULL, NULL, 252, NULL, NULL, 93296),
(93297, '1.10.630.10-FF-000788', NULL, 'Predicted protein', 115, NULL, NULL, 93297),
(93298, '4.10.640.10-FF-000013', NULL, '37S ribosomal protein S18', 54, NULL, NULL, 93298),
(93299, '1.20.58.340-FF-000059', NULL, 'Putative metal ion transporter YfjQ protein', 80, NULL, NULL, 93299),
(93300, '1.25.10.10-FF-000095', NULL, 'Vacuolar protein 8', 224, NULL, NULL, 93300),
(93301, '1.10.472.10-FF-000504', NULL, 'G1/S-specific cyclin-D', 103, NULL, NULL, 93301),
(93302, '3.90.70.10-FF-000601', NULL, 'LD22095p', 189, NULL, NULL, 93302),
(93303, '3.30.830.10-FF-000044', NULL, 'Mitochondrial-processing peptidase subunit beta, putative', 226, NULL, NULL, 93303),
(93304, '1.10.510.10-FF-000206', NULL, 'Mitogen-activated protein kinase', 230, NULL, NULL, 93304),
(93305, '1.10.472.130-FF-000010', NULL, 'Dynein axonemal heavy chain 10', 155, NULL, NULL, 93305),
(93306, '3.30.160.60-FF-000507', NULL, 'ras-responsive element-binding protein 1 isoform X2', 67, NULL, NULL, 93306),
(93307, '3.30.479.30-FF-000002', NULL, 'band 7 protein AGAP004871', 111, NULL, NULL, 93307),
(93308, '2.60.120.920-FF-000099', NULL, 'Tripartite motif family-like 2', 186, NULL, NULL, 93308),
(93309, '3.30.70.2970-FF-000001', NULL, 'Oxidative stress defense protein', 107, NULL, NULL, 93309),
(93310, '3.30.1490.20-FF-000059', NULL, 'D-alanine--D-alanine ligase', 69, NULL, NULL, 93310),
(93311, '3.40.140.10-FF-000017', NULL, 'COP9 signalosome complex subunit 6', 185, NULL, NULL, 93311),
(93312, '3.30.110.110-FF-000001', NULL, 'Double-strand break repair protein', 106, NULL, NULL, 93312),
(93313, '2.70.150.10-FF-000037', NULL, 'Phospholipid-transporting ATPase', 137, NULL, NULL, 93313),
(93314, '3.40.532.10-FF-000023', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 142, NULL, NULL, 93314),
(93315, '1.25.40.1010-FF-000012', NULL, 'NMDA receptor-regulated protein 1-domain-containing protein', 212, NULL, NULL, 93315),
(93316, '3.40.50.1240-FF-000182', NULL, NULL, 157, NULL, NULL, 93316),
(93317, '2.10.110.10-FF-000211', NULL, 'Uncharacterized protein', 66, NULL, NULL, 93317),
(93318, '3.40.1190.20-FF-000197', NULL, NULL, 210, NULL, NULL, 93318),
(93319, '3.20.20.370-FF-000016', NULL, 'Chitin oligosaccharide deacetylase', 307, NULL, NULL, 93319),
(93320, '2.60.120.10-FF-000347', NULL, 'Cyclic nucleotide-binding protein', 153, NULL, NULL, 93320);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(93321, '1.25.40.630-FF-000002', NULL, 'Cleavage stimulating factor 64', 76, NULL, NULL, 93321),
(93322, '3.10.10.10-FF-000011', NULL, 'Transposon Tf2-2 polyprotein', 111, NULL, NULL, 93322),
(93323, '3.90.470.20-FF-000005', NULL, 'Fatty acid synthase alpha subunit FasA', 119, NULL, NULL, 93323),
(93324, '1.10.238.110-FF-000016', NULL, 'Uncharacterized protein', 83, NULL, NULL, 93324),
(93325, '2.60.40.10-FF-000384', NULL, 'CD166 antigen isoform X1', 92, NULL, NULL, 93325),
(93326, '2.70.170.10-FF-000229', NULL, 'Uncharacterized protein', 84, NULL, NULL, 93326),
(93327, '2.80.10.50-FF-000281', NULL, 'Uncharacterized protein', 58, NULL, NULL, 93327),
(93328, '2.130.10.10-FF-000171', NULL, 'denticleless protein homolog isoform X1', 260, NULL, NULL, 93328),
(93329, '1.10.1200.30-FF-000002', NULL, 'Gag polyprotein', 96, NULL, NULL, 93329),
(93330, '3.40.50.1980-FF-000050', NULL, 'Histidine biosynthesis trifunctional protein', 225, NULL, NULL, 93330),
(93331, '3.80.10.10-FF-000002', NULL, 'Slit guidance ligand 2', 217, NULL, NULL, 93331),
(93332, '1.20.5.1430-FF-000019', NULL, 'Uncharacterized protein', 85, NULL, NULL, 93332),
(93333, '1.10.510.10-FF-001797', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase-like protein', 200, NULL, NULL, 93333),
(93334, '3.30.1380.20-FF-000040', NULL, 'Trafficking protein particle complex subunit', 181, NULL, NULL, 93334),
(93335, '3.40.50.300-FF-002812', NULL, 'Long-chain fatty acid transporter subunit', 243, NULL, NULL, 93335),
(93336, '1.10.3090.10-FF-000004', NULL, 'CCA tRNA nucleotidyltransferase 1, mitochondrial', 204, NULL, NULL, 93336),
(93337, '1.25.40.10-FF-000260', NULL, 'tetratricopeptide repeat protein 28 isoform X1', 189, NULL, NULL, 93337),
(93338, '3.40.30.10-FF-000915', NULL, 'Uncharacterized protein', 127, NULL, NULL, 93338),
(93339, '1.10.1410.10-FF-000046', NULL, 'Terminal uridylyltransferase 4', 16, NULL, NULL, 93339),
(93340, '1.20.1270.60-FF-000098', NULL, 'FCH and double SH3 domains protein 2 isoform X3', 154, NULL, NULL, 93340),
(93341, '3.80.10.10-FF-003004', NULL, 'AGAP010289-PA', 78, NULL, NULL, 93341),
(93342, '2.130.10.10-FF-001789', NULL, 'Transducin/WD40 repeat-like superfamily protein', 204, NULL, NULL, 93342),
(93343, '3.40.50.1000-FF-000043', NULL, 'General stress response phosphoprotein phosphatase Psr1/2', 185, NULL, NULL, 93343),
(93344, '1.25.40.1030-FF-000018', NULL, 'Protein transport protein sec16', 365, NULL, NULL, 93344),
(93345, '3.20.20.190-FF-000069', NULL, 'Phosphoinositide phospholipase C', 317, NULL, NULL, 93345),
(93346, '2.30.30.210-FF-000011', NULL, 'Ribonuclease P protein subunit p29', 94, NULL, NULL, 93346),
(93347, '2.60.40.10-FF-001795', NULL, 'ephrin type-B receptor 1-like', 89, NULL, NULL, 93347),
(93348, '2.60.200.10-FF-000044', NULL, 'Uncharacterized protein', 129, NULL, NULL, 93348),
(93349, '1.20.1250.20-FF-001186', NULL, 'MFS transporter', 199, NULL, NULL, 93349),
(93350, '1.10.510.10-FF-000515', NULL, 'serine/threonine-protein kinase SBK2', 283, NULL, NULL, 93350),
(93351, '1.10.510.10-FF-004129', NULL, NULL, 92, NULL, NULL, 93351),
(93352, '2.30.180.10-FF-000054', NULL, 'Transforming growth factor-beta-induced protein', 136, NULL, NULL, 93352),
(93353, '3.80.10.10-FF-001413', NULL, 'leucine-rich repeat-containing protein C10orf11 homolog isoform X1', 164, NULL, NULL, 93353),
(93354, '3.30.230.130-FF-000005', NULL, 'Cullin-1 like', 154, NULL, NULL, 93354),
(93355, '1.10.287.70-FF-000659', NULL, 'Potassium channel, subfamily, member 5 (KCNK5), transcript variant 2', 135, NULL, NULL, 93355),
(93356, '1.10.10.1940-FF-000012', NULL, NULL, 50, NULL, NULL, 93356),
(93357, '3.30.420.40-FF-000230', NULL, 'D-allose kinase', 196, NULL, NULL, 93357),
(93358, '1.25.40.10-FF-004003', NULL, 'Uncharacterized protein', 207, NULL, NULL, 93358),
(93359, '1.10.630.10-FF-000581', NULL, 'Uncharacterized protein', 303, NULL, NULL, 93359),
(93360, '1.10.10.10-FF-001696', NULL, 'Rrf2 family transcriptional regulator', 146, NULL, NULL, 93360),
(93361, '2.40.10.10-FF-000158', NULL, 'Thrombin-like enzyme saxthrombin', 114, NULL, NULL, 93361);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(93362, '1.10.8.10-FF-000195', NULL, 'UBX domain-containing protein 1', 35, NULL, NULL, 93362),
(93363, '1.10.540.10-FF-000017', NULL, 'long-chain specific acyl-CoA dehydrogenase, mitochondrial', 135, NULL, NULL, 93363),
(93364, '3.40.50.410-FF-000266', NULL, 'Uncharacterized protein', 141, NULL, NULL, 93364),
(93365, '1.10.1370.30-FF-000014', NULL, 'Angiotensin-converting enzyme', 341, NULL, NULL, 93365),
(93366, '3.30.70.3550-FF-000001', NULL, 'Leucyl/phenylalanyl-tRNA--protein transferase', 60, NULL, NULL, 93366),
(93367, '3.30.2310.20-FF-000018', NULL, 'Putative killer suppression protein HigA', 106, NULL, NULL, 93367),
(93368, '2.60.40.10-FF-004127', NULL, NULL, 116, NULL, NULL, 93368),
(93369, '2.30.30.140-FF-000288', NULL, 'Histone acetyltransferase', 136, NULL, NULL, 93369),
(93370, '3.90.79.10-FF-000121', NULL, 'RNA pyrophosphohydrolase', 165, NULL, NULL, 93370),
(93371, '3.80.10.10-FF-003313', NULL, 'Uncharacterized protein', 178, NULL, NULL, 93371),
(93372, '3.40.50.300-FF-004583', NULL, 'Pentafunctional AROM polypeptide, putative', 182, NULL, NULL, 93372),
(93373, '3.40.50.150-FF-000154', NULL, 'Probable tRNA methyltransferase 9B', 167, NULL, NULL, 93373),
(93374, '3.20.20.60-FF-000009', NULL, '2-methylisocitrate lyase', 294, NULL, NULL, 93374),
(93375, '3.40.50.2300-FF-000798', NULL, NULL, 107, NULL, NULL, 93375),
(93376, '3.40.50.1780-FF-000023', NULL, 'Uncharacterized protein', 126, NULL, NULL, 93376),
(93377, '1.10.238.10-FF-000253', NULL, 'Two pore calcium channel protein 1', 75, NULL, NULL, 93377),
(93378, '2.60.200.20-FF-000047', NULL, 'Tyrosyl-DNA phosphodiesterase 1', 95, NULL, NULL, 93378),
(93379, '3.40.50.1000-FF-000352', NULL, 'Trehalose-phosphatase', 49, NULL, NULL, 93379),
(93380, '2.110.10.10-FF-000008', NULL, 'Matrix metallopeptidase 19', 131, NULL, NULL, 93380),
(93381, '2.130.10.10-FF-003734', NULL, 'U3 small nucleolar RNA-associated protein 5', 334, NULL, NULL, 93381),
(93382, '3.30.450.40-FF-000041', NULL, 'IclR family transcriptional regulator', 168, NULL, NULL, 93382),
(93383, '1.20.58.390-FF-000260', NULL, 'Glycine receptor alpha 4', 96, NULL, NULL, 93383),
(93384, '3.30.70.100-FF-000089', NULL, 'Antibiotic biosynthesis monooxygenase', 100, NULL, NULL, 93384),
(93385, '3.60.21.10-FF-000214', NULL, 'Serine/threonine-protein phosphatase', 301, NULL, NULL, 93385),
(93386, '2.60.120.260-FF-000311', NULL, 'Alpha-mannosidase', 140, NULL, NULL, 93386),
(93387, '3.20.20.140-FF-000296', NULL, 'TatD related DNase', 127, NULL, NULL, 93387),
(93388, '1.25.40.10-FF-004312', NULL, 'Protein CBG21210', 180, NULL, NULL, 93388),
(93389, '3.20.20.220-FF-000022', NULL, 'Proline dehydrogenase', 293, NULL, NULL, 93389),
(93390, '3.10.20.90-FF-000182', NULL, 'pleckstrin homology domain-containing family H member 3 isoform X1', 96, NULL, NULL, 93390),
(93391, '1.10.510.10-FF-003388', NULL, NULL, 314, NULL, NULL, 93391),
(93392, '1.20.1250.20-FF-000826', NULL, 'Allantoate permease', 410, NULL, NULL, 93392),
(93393, '2.60.40.10-FF-000204', NULL, 'Major histocompatibility complex, class I-related protein', 91, NULL, NULL, 93393),
(93394, '2.60.40.10-FF-000513', NULL, 'striated muscle preferentially expressed protein kinase', 98, NULL, NULL, 93394),
(93395, '1.10.10.790-FF-000032', NULL, NULL, 69, NULL, NULL, 93395),
(93396, '1.10.390.10-FF-000090', NULL, 'Aminopeptidase', 242, NULL, NULL, 93396),
(93397, '2.60.120.260-FF-000002', NULL, 'Coagulation factor VIII', 160, NULL, NULL, 93397),
(93398, '3.80.10.10-FF-001104', NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', 109, NULL, NULL, 93398),
(93399, '3.30.40.10-FF-000967', NULL, 'CDK-activating kinase assembly factor MAT1', 63, NULL, NULL, 93399),
(93400, '3.40.1110.10-FF-000285', NULL, NULL, 87, NULL, NULL, 93400),
(93401, '3.20.20.40-FF-000003', NULL, 'Glucanase', 280, NULL, NULL, 93401),
(93402, '2.130.10.10-FF-004532', NULL, 'Cilia- and flagella-associated protein 43', 226, NULL, NULL, 93402),
(93403, '2.40.160.20-FF-000020', NULL, 'Major surface antigen 4', 181, NULL, NULL, 93403),
(93404, '3.40.50.2300-FF-001596', NULL, NULL, 107, NULL, NULL, 93404);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(93405, '3.40.50.300-FF-000912', NULL, 'RecBCD enzyme subunit RecD', 245, NULL, NULL, 93405),
(93406, '1.25.40.10-FF-003278', NULL, 'Pentatricopeptide repeat-containing protein', 136, NULL, NULL, 93406),
(93407, '3.40.50.300-FF-000660', NULL, 'Genome polyprotein', 172, NULL, NULL, 93407),
(93408, '2.30.110.50-FF-000005', NULL, 'Type IV secretion protein Rhs', 151, NULL, NULL, 93408),
(93409, '3.30.1370.70-FF-000003', NULL, 'Nfu1p', 113, NULL, NULL, 93409),
(93410, '4.10.1060.10-FF-000067', NULL, 'Calpain-D-like Protein', 32, NULL, NULL, 93410),
(93411, '2.130.10.10-FF-004105', NULL, 'Os07g0506700 protein', 193, NULL, NULL, 93411),
(93412, '1.10.555.10-FF-000175', NULL, NULL, 173, NULL, NULL, 93412),
(93413, '3.30.160.60-FF-002441', NULL, 'Zinc finger protein 521', 89, NULL, NULL, 93413),
(93414, '3.80.10.10-FF-001430', NULL, 'Toll-like receptor 15', 161, NULL, NULL, 93414),
(93415, '3.40.630.10-FF-000116', NULL, 'Peptide hydrolase', 288, NULL, NULL, 93415),
(93416, '1.10.8.60-FF-000294', NULL, 'p60 katanin', 102, NULL, NULL, 93416),
(93417, '2.60.40.150-FF-000303', NULL, 'C2 domain-containing protein', 146, NULL, NULL, 93417),
(93418, '3.30.870.10-FF-000136', NULL, 'Phospholipase D', 158, NULL, NULL, 93418),
(93419, '1.20.1560.10-FF-000678', NULL, 'Predicted protein', 20, NULL, NULL, 93419),
(93420, '3.40.640.10-FF-000044', NULL, 'Aspartate aminotransferase', 282, NULL, NULL, 93420),
(93421, '1.25.40.20-FF-000055', NULL, 'ankyrin repeat domain-containing protein 17 isoform X2', 138, NULL, NULL, 93421),
(93422, '2.60.120.10-FF-000139', NULL, 'Bacilysin biosynthesis protein', 110, NULL, NULL, 93422),
(93423, '1.20.120.1760-FF-000014', NULL, 'Choline/ethanolaminephosphotransferase 1', 227, NULL, NULL, 93423),
(93424, '3.30.505.10-FF-000238', NULL, NULL, 76, NULL, NULL, 93424),
(93425, '1.20.120.1750-FF-000011', NULL, 'RBR-type E3 ubiquitin transferase', 79, NULL, NULL, 93425),
(93426, '2.60.120.650-FF-000220', NULL, 'Uncharacterized protein', 201, NULL, NULL, 93426),
(93427, '3.30.1310.10-FF-000015', NULL, 'Nucleoid-associated protein DICTH_1981', 104, NULL, NULL, 93427),
(93428, '1.10.238.10-FF-000270', NULL, 'calpain-3 isoform X7', 171, NULL, NULL, 93428),
(93429, '2.10.25.10-FF-001531', NULL, 'Uncharacterized protein', 66, NULL, NULL, 93429),
(93430, '3.30.70.330-FF-001664', NULL, NULL, 111, NULL, NULL, 93430),
(93431, '3.30.2020.30-FF-000022', NULL, 'Gamma-butyrobetaine hydroxylase subfamily, putative (AFU_orthologue AFUA_2G14970)', 90, NULL, NULL, 93431),
(93432, '1.10.10.1200-FF-000009', NULL, 'Uncharacterized protein', 77, NULL, NULL, 93432),
(93433, '1.25.10.10-FF-003349', NULL, 'Uncharacterized protein', 216, NULL, NULL, 93433),
(93434, '1.20.58.1060-FF-000004', NULL, 'Desmoplakin a', 151, NULL, NULL, 93434),
(93435, '2.30.29.30-FF-001242', NULL, 'Predicted protein', 112, NULL, NULL, 93435),
(93436, '3.40.50.300-FF-003886', NULL, 'Oligopeptide transport system ATP-binding protein', 272, NULL, NULL, 93436),
(93437, '3.30.160.60-FF-006140', NULL, NULL, 65, NULL, NULL, 93437),
(93438, '2.60.40.790-FF-000062', NULL, 'Small heat shock protein HSP20', 135, NULL, NULL, 93438),
(93439, '3.40.50.300-FF-003785', NULL, 'Ras-related small GTP-binding family protein', 114, NULL, NULL, 93439),
(93440, '1.25.40.10-FF-000052', NULL, 'Aryl-hydrocarbon-interacting protein-like 1', 158, NULL, NULL, 93440),
(93441, '1.20.58.530-FF-000026', NULL, 'Myosin B', 151, NULL, NULL, 93441),
(93442, '1.10.510.10-FF-003949', NULL, NULL, 56, NULL, NULL, 93442),
(93443, '3.30.1360.70-FF-000031', NULL, NULL, 106, NULL, NULL, 93443),
(93444, '1.20.58.340-FF-000060', NULL, 'Uncharacterized protein', 171, NULL, NULL, 93444),
(93445, '1.10.390.10-FF-000089', NULL, 'AGAP000131-PA', 242, NULL, NULL, 93445),
(93446, '3.40.50.1240-FF-000210', NULL, NULL, 199, NULL, NULL, 93446),
(93447, '3.40.710.10-FF-000174', NULL, 'ABC1 family protein', 131, NULL, NULL, 93447),
(93448, '1.10.3720.10-FF-000047', NULL, 'Amino acid ABC transporter, permease protein', 104, NULL, NULL, 93448),
(93449, '4.10.60.10-FF-000124', NULL, 'Protein CBG13587', 29, NULL, NULL, 93449);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(93450, '3.40.50.300-FF-007585', NULL, 'Predicted protein', 176, NULL, NULL, 93450),
(93451, '1.10.510.10-FF-000723', NULL, 'Receptor like protein kinase S.2', 228, NULL, NULL, 93451),
(93452, '1.10.510.10-FF-002432', NULL, 'Predicted protein', 323, NULL, NULL, 93452),
(93453, '1.10.510.10-FF-002005', NULL, 'Uncharacterized protein', 179, NULL, NULL, 93453),
(93454, '1.25.40.10-FF-003177', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 106, NULL, NULL, 93454),
(93455, '2.60.40.10-FF-004453', NULL, NULL, 109, NULL, NULL, 93455),
(93456, '3.30.1660.10-FF-000002', NULL, 'Hypothetical lipoprotein yjfO', 68, NULL, NULL, 93456),
(93457, '3.30.2160.10-FF-000071', NULL, 'E3 ubiquitin-protein ligase', 34, NULL, NULL, 93457),
(93458, '3.90.25.10-FF-000087', NULL, 'Uncharacterized protein', 70, NULL, NULL, 93458),
(93459, '2.130.10.10-FF-004206', NULL, 'Uncharacterized protein', 155, NULL, NULL, 93459),
(93460, '1.10.8.60-FF-000395', NULL, 'Peroxisomal biogenesis factor 6', 105, NULL, NULL, 93460),
(93461, '3.40.50.1820-FF-001261', NULL, 'Lipase, putative', 310, NULL, NULL, 93461),
(93462, '2.30.30.40-FF-000051', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', 66, NULL, NULL, 93462),
(93463, '3.90.550.50-FF-000021', NULL, 'Beta 3-glucosyltransferase', 209, NULL, NULL, 93463),
(93464, '3.30.160.60-FF-002542', NULL, NULL, 29, NULL, NULL, 93464),
(93465, '3.30.450.40-FF-000248', NULL, 'Two component signal transduction system histidine kinase with GAF sensory domain', 176, NULL, NULL, 93465),
(93466, '2.60.200.20-FF-000081', NULL, 'Uncharacterized protein', 111, NULL, NULL, 93466),
(93467, '2.30.29.30-FF-000994', NULL, 'Uncharacterized protein', 135, NULL, NULL, 93467),
(93468, '1.25.40.10-FF-001833', NULL, 'Pentatricopeptide repeat-containing protein At3g13160, mitochondrial', 119, NULL, NULL, 93468),
(93469, '3.60.10.10-FF-000189', NULL, 'YALI0C07436p', 338, NULL, NULL, 93469),
(93470, '1.10.506.10-FF-000073', NULL, 'Uncharacterized protein', 222, NULL, NULL, 93470),
(93471, '3.30.160.60-FF-006241', NULL, NULL, 53, NULL, NULL, 93471),
(93472, '3.30.40.10-FF-000012', NULL, 'Zinc finger MIZ domain-containing protein 2', 139, NULL, NULL, 93472),
(93473, '1.25.10.10-FF-000224', NULL, 'Microtubule-associated protein TORTIFOLIA1', 160, NULL, NULL, 93473),
(93474, '3.90.70.10-FF-000472', NULL, 'Uncharacterized protein', 347, NULL, NULL, 93474),
(93475, '3.40.50.300-FF-003459', NULL, 'MutS family protein', 251, NULL, NULL, 93475),
(93476, '3.10.50.40-FF-000163', NULL, 'Peptidylprolyl isomerase', 68, NULL, NULL, 93476),
(93477, '3.50.50.60-FF-001185', NULL, 'Predicted protein', 82, NULL, NULL, 93477),
(93478, '3.40.50.150-FF-000362', NULL, 'Histidine N-alpha-methyltransferase', 181, NULL, NULL, 93478),
(93479, '3.30.420.210-FF-000005', NULL, 'Plant UBX domain-containing protein 4', 63, NULL, NULL, 93479),
(93480, '1.25.40.20-FF-001836', NULL, 'Oxysterol-binding protein', 146, NULL, NULL, 93480),
(93481, '3.90.550.10-FF-000060', NULL, 'Hexosyltransferase', 267, NULL, NULL, 93481),
(93482, '3.40.50.300-FF-000025', NULL, 'ATP-dependent Clp protease subunit', 214, NULL, NULL, 93482),
(93483, '2.10.25.10-FF-001430', NULL, 'Laminin subunit beta-1', 49, NULL, NULL, 93483),
(93484, '3.10.20.90-FF-000518', NULL, 'Ubiquitin C-terminal hydrolase', 129, NULL, NULL, 93484),
(93485, '1.25.40.120-FF-000069', NULL, 'Uncharacterized protein', 174, NULL, NULL, 93485),
(93486, '1.10.10.60-FF-000351', NULL, 'Transcription factor GAMYB', 73, NULL, NULL, 93486),
(93487, '3.30.200.20-FF-001961', NULL, 'Uncharacterized protein', 104, NULL, NULL, 93487),
(93488, '1.10.150.290-FF-000001', NULL, 'Trans-aconitate 2-methyltransferase', 71, NULL, NULL, 93488),
(93489, '3.20.20.70-FF-000810', NULL, NULL, 109, NULL, NULL, 93489),
(93490, '3.30.160.60-FF-000187', NULL, 'zinc finger protein 37 homolog', 28, NULL, NULL, 93490),
(93491, '1.10.3210.10-FF-000082', NULL, 'Metal-dependent phosphohydrolase', 346, NULL, NULL, 93491),
(93492, '1.20.5.170-FF-000099', NULL, 'Uncharacterized protein', 42, NULL, NULL, 93492);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(93493, '1.10.274.30-FF-000033', NULL, 'Uncharacterized protein', 100, NULL, NULL, 93493),
(93494, '1.20.1310.10-FF-000047', NULL, 'Cullin-like protein, putative', 120, NULL, NULL, 93494),
(93495, '3.40.50.300-FF-004403', NULL, 'Rab family GTPase', 189, NULL, NULL, 93495),
(93496, '3.40.190.10-FF-000200', NULL, 'Sensor histidine kinase/response regulator EvgS', 93, NULL, NULL, 93496),
(93497, '2.60.40.150-FF-000191', NULL, 'Protein kinase C', 122, NULL, NULL, 93497),
(93498, '3.40.50.300-FF-000334', NULL, 'Protein translocase subunit SecA', 256, NULL, NULL, 93498),
(93499, '2.30.30.360-FF-000005', NULL, 'Myosin XI B', 45, NULL, NULL, 93499),
(93500, '3.60.21.10-FF-000006', NULL, 'Serine/threonine-protein phosphatase', 308, NULL, NULL, 93500),
(93501, '3.40.640.10-FF-000145', NULL, 'Aminotransferase DegT', 376, NULL, NULL, 93501),
(93502, '3.40.630.30-FF-000549', NULL, 'Acteyltransferase GNAT family', 138, NULL, NULL, 93502),
(93503, '1.10.472.80-FF-000166', NULL, NULL, 139, NULL, NULL, 93503),
(93504, '2.60.120.1540-FF-000015', NULL, 'Complement C3', 63, NULL, NULL, 93504),
(93505, '3.40.50.300-FF-008091', NULL, 'DNA replication licensing factor MCM7', 113, NULL, NULL, 93505),
(93506, '1.25.50.20-FF-000027', NULL, 'Aminopeptidase', 344, NULL, NULL, 93506),
(93507, '3.60.20.30-FF-000010', NULL, 'L-asparaginase-like protein GM15681', 138, NULL, NULL, 93507),
(93508, '3.40.50.1700-FF-000056', NULL, 'Predicted protein', 112, NULL, NULL, 93508),
(93509, '3.40.50.720-FF-001421', NULL, 'Putative methylene tetrahydromethanopterin dehydrogenase/methylenetetrahydrofolate dehydrogenase', 160, NULL, NULL, 93509),
(93510, '3.10.110.10-FF-000112', NULL, 'RBR-type E3 ubiquitin transferase', 132, NULL, NULL, 93510),
(93511, '2.130.10.10-FF-000362', NULL, 'Coronin', 345, NULL, NULL, 93511),
(93512, '2.40.420.20-FF-000057', NULL, 'HAE1 family effllux pump MFP component', 93, NULL, NULL, 93512),
(93513, '1.20.120.530-FF-000003', NULL, 'Fatty acid metabolism regulator protein', 160, NULL, NULL, 93513),
(93514, '2.130.10.10-FF-005960', NULL, 'Uncharacterized protein', 246, NULL, NULL, 93514),
(93515, '3.90.190.10-FF-000296', NULL, 'Protein-tyrosine-phosphatase', 227, NULL, NULL, 93515),
(93516, '3.40.50.300-FF-007837', NULL, 'DNA mismatch repair mutS protein', 235, NULL, NULL, 93516),
(93517, '2.30.31.10-FF-000027', NULL, 'Uncharacterized protein', 59, NULL, NULL, 93517),
(93518, '3.40.930.10-FF-000055', NULL, NULL, 68, NULL, NULL, 93518),
(93519, '1.20.1280.50-FF-000067', NULL, 'F-box protein GID2', 87, NULL, NULL, 93519),
(93520, '3.30.160.60-FF-004195', NULL, NULL, 31, NULL, NULL, 93520),
(93521, '1.10.8.10-FF-000178', NULL, 'ATP-dependent protease ATPase subunit HslU2', 26, NULL, NULL, 93521),
(93522, '2.150.10.10-FF-000018', NULL, NULL, 129, NULL, NULL, 93522),
(93523, '2.130.10.10-FF-005842', NULL, 'Uncharacterized protein', 347, NULL, NULL, 93523),
(93524, '2.130.10.10-FF-003279', NULL, 'Uncharacterized protein', 360, NULL, NULL, 93524),
(93525, '2.120.10.80-FF-000315', NULL, 'Uncharacterized protein', 170, NULL, NULL, 93525),
(93526, '3.40.50.300-FF-002458', NULL, 'Cytidylate kinase', 221, NULL, NULL, 93526),
(93527, '3.60.20.40-FF-000013', NULL, 'Gamma-glutamyltranspeptidase', 182, NULL, NULL, 93527),
(93528, '3.40.50.1440-FF-000135', NULL, 'Uncharacterized protein', 137, NULL, NULL, 93528),
(93529, '1.10.10.10-FF-001679', NULL, 'SirR/DtxR family transcription regulator', 123, NULL, NULL, 93529),
(93530, '3.30.200.20-FF-000224', NULL, 'Citron rho-interacting serine/threonine kinase', 148, NULL, NULL, 93530),
(93531, '3.90.79.10-FF-000020', NULL, 'Pre-mRNA cleavage factor Im subunit 2', 193, NULL, NULL, 93531),
(93532, '3.90.550.50-FF-000122', NULL, 'Hexosyltransferase', 256, NULL, NULL, 93532),
(93533, '3.30.2170.10-FF-000010', NULL, 'Endonuclease V', 238, NULL, NULL, 93533),
(93534, '3.80.20.20-FF-000034', NULL, 'GG16886', 239, NULL, NULL, 93534),
(93535, '1.25.40.10-FF-003486', NULL, 'Pentatricopeptide repeat-containing protein', 81, NULL, NULL, 93535),
(93536, '3.40.395.10-FF-000024', NULL, 'Chromosome 1, whole genome shotgun sequence', 237, NULL, NULL, 93536);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(93537, '3.40.50.720-FF-001522', NULL, 'Uncharacterized protein', 142, NULL, NULL, 93537),
(93538, '1.10.8.710-FF-000010', NULL, 'Dynein beta chain, putative', 111, NULL, NULL, 93538),
(93539, '1.10.580.10-FF-000008', NULL, 'Citrate synthase', 232, NULL, NULL, 93539),
(93540, '3.30.70.330-FF-001872', NULL, NULL, 102, NULL, NULL, 93540),
(93541, '3.20.20.210-FF-000002', NULL, '5-methyltetrahydropteroyltriglutamate--homocysteine methyltransferase', 353, NULL, NULL, 93541),
(93542, '2.40.30.10-FF-000058', NULL, 'GTP binding protein 2', 81, NULL, NULL, 93542),
(93543, '3.40.50.300-FF-007000', NULL, 'Uncharacterized protein', 211, NULL, NULL, 93543),
(93544, '1.20.1250.20-FF-001540', NULL, 'Uncharacterized protein', 425, NULL, NULL, 93544),
(93545, '3.60.21.10-FF-000315', NULL, 'Serine/threonine-protein phosphatase', 374, NULL, NULL, 93545),
(93546, '1.10.287.1490-FF-000092', NULL, 'Viral A-type inclusion protein, putative', 162, NULL, NULL, 93546),
(93547, '3.40.50.880-FF-000125', NULL, 'CTP synthase', 266, NULL, NULL, 93547),
(93548, '3.40.140.10-FF-000152', NULL, 'Apolipoprotein B mRNA-editing enzyme, catalytic polypeptide-like 2', 191, NULL, NULL, 93548),
(93549, '3.40.50.450-FF-000019', NULL, '2''-deoxynucleoside 5''-phosphate N-hydrolase 1', 146, NULL, NULL, 93549),
(93550, '1.25.40.10-FF-000304', NULL, 'Putative Pre-mRNA-splicing factor prp1', 82, NULL, NULL, 93550),
(93551, '3.40.470.10-FF-000019', NULL, 'Hypoxanthine DNA glycosylase', 158, NULL, NULL, 93551),
(93552, '3.40.50.300-FF-002149', NULL, 'DNA transposition protein (GpB)', 146, NULL, NULL, 93552),
(93553, '3.20.20.220-FF-000005', NULL, 'Methylenetetrahydrofolate reductase', 304, NULL, NULL, 93553),
(93554, '1.10.10.60-FF-000704', NULL, 'Sigma-54 activator protein ActB', 55, NULL, NULL, 93554),
(93555, '3.10.120.10-FF-000040', NULL, 'Uncharacterized protein', 87, NULL, NULL, 93555),
(93556, '3.10.450.10-FF-000025', NULL, 'Cysteine proteinase inhibitor', 121, NULL, NULL, 93556),
(93557, '1.10.20.10-FF-000078', NULL, 'Histone H3', 49, NULL, NULL, 93557),
(93558, '1.25.40.20-FF-000307', NULL, 'Protein arginine N-methyltransferase 2', 101, NULL, NULL, 93558),
(93559, '3.40.50.1390-FF-000013', NULL, 'Serine recombinase', 150, NULL, NULL, 93559),
(93560, '1.10.8.720-FF-000013', NULL, 'Axonemal dynein heavy chain', 170, NULL, NULL, 93560),
(93561, '3.40.50.720-FF-000595', NULL, 'CoB--CoM heterodisulfide reductase iron-sulfur subunit A', 92, NULL, NULL, 93561),
(93562, '3.90.79.20-FF-000023', NULL, 'Mutt/nudix family protein-like protein', 155, NULL, NULL, 93562),
(93563, '1.25.40.10-FF-002513', NULL, 'Uncharacterized protein', 222, NULL, NULL, 93563),
(93564, '3.40.50.150-FF-000053', NULL, 'Release factor glutamine methyltransferase', 192, NULL, NULL, 93564),
(93565, '3.30.70.330-FF-001563', NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', 194, NULL, NULL, 93565),
(93566, '3.80.10.10-FF-003228', NULL, 'Uncharacterized protein', 200, NULL, NULL, 93566),
(93567, '3.60.10.10-FF-000397', NULL, 'Predicted protein', 58, NULL, NULL, 93567),
(93568, '3.30.590.20-FF-000011', NULL, 'Glutathione biosynthesis bifunctional protein GshAB', 451, NULL, NULL, 93568),
(93569, '1.20.120.290-FF-000004', NULL, 'Oxygen-evolving enhancer protein 3', 126, NULL, NULL, 93569),
(93570, '3.40.50.150-FF-000480', NULL, 'Trans-aconitate 3-methyltransferase', 299, NULL, NULL, 93570),
(93571, '3.40.1010.10-FF-000018', NULL, 'Ribosomal RNA small subunit methyltransferase I', 109, NULL, NULL, 93571),
(93572, '3.30.420.610-FF-000018', NULL, 'Emb|CAB71880.1', 65, NULL, NULL, 93572),
(93573, '2.40.50.590-FF-000003', NULL, 'DNA polymerase', 83, NULL, NULL, 93573),
(93574, '2.130.10.10-FF-003588', NULL, 'Predicted protein', 107, NULL, NULL, 93574),
(93575, '3.90.1100.10-FF-000025', NULL, 'DNA-directed RNA polymerase subunit beta', 249, NULL, NULL, 93575),
(93576, '2.60.40.60-FF-000292', NULL, 'Cadherin-related family member 5', 100, NULL, NULL, 93576),
(93577, '2.60.120.10-FF-000791', NULL, 'Uncharacterized protein', 141, NULL, NULL, 93577),
(93578, '1.10.472.10-FF-000521', NULL, 'Uncharacterized protein', 96, NULL, NULL, 93578);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(93579, '3.40.50.790-FF-000008', NULL, '50S ribosomal protein L1', 96, NULL, NULL, 93579),
(93580, '1.10.287.1490-FF-000103', NULL, 'GRIP and coiled-coil domain-containing protein C27D7.02c', 206, NULL, NULL, 93580),
(93581, '1.20.58.830-FF-000009', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 154, NULL, NULL, 93581),
(93582, '1.10.520.40-FF-000002', NULL, 'Uncharacterized protein', 232, NULL, NULL, 93582),
(93583, '1.20.1740.10-FF-000198', NULL, 'Uncharacterized protein', 186, NULL, NULL, 93583),
(93584, '2.130.10.10-FF-000406', NULL, 'Putative acyl-activating enzyme 19', 180, NULL, NULL, 93584),
(93585, '1.10.287.110-FF-000278', NULL, 'Co-chaperone Hsc20', 101, NULL, NULL, 93585),
(93586, '2.60.40.10-FF-005982', NULL, NULL, 96, NULL, NULL, 93586),
(93587, '1.10.1420.10-FF-000209', NULL, 'Uncharacterized protein', 174, NULL, NULL, 93587),
(93588, '2.60.120.650-FF-000012', NULL, 'Cupin superfamily protein family', 203, NULL, NULL, 93588),
(93589, '3.10.20.30-FF-000080', NULL, NULL, 78, NULL, NULL, 93589),
(93590, '1.10.510.10-FF-000178', NULL, 'Calcium-dependent protein kinase 5', 181, NULL, NULL, 93590),
(93591, '3.40.50.300-FF-006382', NULL, 'Uncharacterized protein', 136, NULL, NULL, 93591),
(93592, '2.40.100.10-FF-000007', NULL, 'Peptidyl-prolyl cis-trans isomerase CWC27 homolog', 178, NULL, NULL, 93592),
(93593, '2.130.10.10-FF-000154', NULL, 'WD repeat domain phosphoinositide-interacting protein 4', 330, NULL, NULL, 93593),
(93594, '1.10.1740.10-FF-000048', NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', 84, NULL, NULL, 93594),
(93595, '2.60.40.60-FF-000303', NULL, 'Cadherin 96Cb, isoform B', 101, NULL, NULL, 93595),
(93596, '2.170.150.20-FF-000033', NULL, 'Uncharacterized protein', 11, NULL, NULL, 93596),
(93597, '3.90.290.10-FF-000005', NULL, 'Fibrillin 2', 71, NULL, NULL, 93597),
(93598, '1.10.287.70-FF-000805', NULL, 'Uncharacterized protein', 156, NULL, NULL, 93598),
(93599, '3.30.70.580-FF-000053', NULL, 'tRNA pseudouridine synthase A', 104, NULL, NULL, 93599),
(93600, '3.30.70.940-FF-000015', NULL, 'Transcription initiation factor SPT5, putative', 97, NULL, NULL, 93600),
(93601, '1.10.10.60-FF-000143', NULL, 'homeobox protein knotted-1-like 3 isoform X1', 62, NULL, NULL, 93601),
(93602, '1.25.40.20-FF-001898', NULL, 'Uncharacterized protein', 212, NULL, NULL, 93602),
(93603, '1.10.1420.10-FF-000120', NULL, 'YALI0B10197p', 175, NULL, NULL, 93603),
(93604, '2.60.40.150-FF-000292', NULL, 'Putative DEAD/DEAH box helicase', 124, NULL, NULL, 93604),
(93605, '3.60.10.10-FF-000088', NULL, 'DNA-(apurinic or apyrimidinic site) lyase', 347, NULL, NULL, 93605),
(93606, '1.10.220.10-FF-000061', NULL, 'Uncharacterized protein', 75, NULL, NULL, 93606),
(93607, '3.20.20.190-FF-000086', NULL, 'Uncharacterized protein', 299, NULL, NULL, 93607),
(93608, '3.40.50.720-FF-001213', NULL, 'HesA/MoeB/ThiF family protein', 237, NULL, NULL, 93608),
(93609, '3.30.200.20-FF-001753', NULL, 'Uncharacterized protein', 74, NULL, NULL, 93609),
(93610, '1.25.40.10-FF-001895', NULL, 'Pentatricopeptide repeat-containing protein', 150, NULL, NULL, 93610),
(93611, '1.10.1070.11-FF-000060', NULL, 'Predicted protein', 182, NULL, NULL, 93611),
(93612, '2.130.10.10-FF-002615', NULL, 'Probable cytosolic iron-sulfur protein assembly protein CIAO1 homolog', 338, NULL, NULL, 93612),
(93613, '1.10.150.20-FF-000052', NULL, 'DNA polymerase iota', 77, NULL, NULL, 93613),
(93614, '2.10.25.10-FF-001222', NULL, 'Predicted protein', 37, NULL, NULL, 93614),
(93615, '3.40.50.1820-FF-000873', NULL, 'Carboxylic ester hydrolase', 485, NULL, NULL, 93615),
(93616, '2.40.50.140-FF-001217', NULL, NULL, 72, NULL, NULL, 93616),
(93617, '2.30.30.40-FF-000360', NULL, 'Peripheral plasma membrane protein CASK', 122, NULL, NULL, 93617),
(93618, '2.60.120.920-FF-000127', NULL, 'SPRY domain/Ankyrin repeats (3 copies), putative', 132, NULL, NULL, 93618),
(93619, '3.40.50.300-FF-000542', NULL, 'Peptide chain release factor 3', 271, NULL, NULL, 93619),
(93620, '1.10.10.10-FF-001887', NULL, 'Uncharacterized protein', 113, NULL, NULL, 93620);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(93621, '3.40.50.2000-FF-000798', NULL, 'Alpha-1,4 glucan phosphorylase', 58, NULL, NULL, 93621),
(93622, '1.10.150.50-FF-000095', NULL, 'uncharacterized protein LOC108099255 isoform X1', 65, NULL, NULL, 93622),
(93623, '2.20.25.10-FF-000064', NULL, 'Peptide-N(4)-(N-acetyl-beta-glucosaminyl)asparagine amidase', 51, NULL, NULL, 93623),
(93624, '2.40.30.10-FF-000204', NULL, 'tRNA-specific 2-thiouridylase MnmA', 82, NULL, NULL, 93624),
(93625, '2.10.110.20-FF-000006', NULL, NULL, 67, NULL, NULL, 93625),
(93626, '3.40.50.2020-FF-000028', NULL, 'Amidophosphoribosyltransferase', 125, NULL, NULL, 93626),
(93627, '2.60.40.10-FF-006044', NULL, NULL, 66, NULL, NULL, 93627),
(93628, '2.80.10.50-FF-000073', NULL, 'Inositol 1,4,5-trisphosphate receptor itr-1', 233, NULL, NULL, 93628),
(93629, '2.60.40.830-FF-000001', NULL, 'Cytochrome f', 192, NULL, NULL, 93629),
(93630, '3.30.870.10-FF-000018', NULL, 'Phospholipase', 54, NULL, NULL, 93630),
(93631, '3.30.200.20-FF-001298', NULL, 'Uncharacterized protein', 129, NULL, NULL, 93631),
(93632, '3.10.100.10-FF-000038', NULL, 'Secretory phospholipase A2 receptor', 132, NULL, NULL, 93632),
(93633, '2.10.110.10-FF-000003', NULL, 'actin-binding LIM protein 1 isoform X1', 66, NULL, NULL, 93633),
(93634, '2.120.10.80-FF-000107', NULL, 'Transcription factor INI', 285, NULL, NULL, 93634),
(93635, '3.30.200.20-FF-001652', NULL, 'Uncharacterized protein', 87, NULL, NULL, 93635),
(93636, '1.10.287.70-FF-000794', NULL, 'Uncharacterized protein', 153, NULL, NULL, 93636),
(93637, '1.10.510.10-FF-002314', NULL, NULL, 218, NULL, NULL, 93637),
(93638, '1.20.1560.10-FF-000796', NULL, 'Predicted protein', 204, NULL, NULL, 93638),
(93639, '2.30.29.30-FF-001348', NULL, 'Predicted protein', 138, NULL, NULL, 93639),
(93640, '1.10.10.60-FF-000042', NULL, 'Transcriptional activator Myb isoform A', 72, NULL, NULL, 93640),
(93641, '2.60.40.840-FF-000004', NULL, 'Uncharacterized protein, isoform A', 176, NULL, NULL, 93641),
(93642, '3.40.50.720-FF-001730', NULL, 'Aspartate-semialdehyde dehydrogenase', 142, NULL, NULL, 93642),
(93643, '3.30.860.10-FF-000001', NULL, '30S ribosomal protein S19', 93, NULL, NULL, 93643),
(93644, '1.10.510.10-FF-000414', NULL, 'Interleukin-1 receptor-associated kinase 4', 196, NULL, NULL, 93644),
(93645, '1.10.1200.10-FF-000137', NULL, '7-keto-8-aminopelargonate synthetase', 91, NULL, NULL, 93645),
(93646, '3.30.830.10-FF-000252', NULL, 'Uncharacterized protein', 151, NULL, NULL, 93646),
(93647, '1.25.10.10-FF-001859', NULL, 'Uncharacterized protein', 184, NULL, NULL, 93647),
(93648, '1.10.510.10-FF-004214', NULL, NULL, 213, NULL, NULL, 93648),
(93649, '2.30.110.10-FF-000117', NULL, 'Uncharacterized protein', 60, NULL, NULL, 93649),
(93650, '1.20.1600.10-FF-000058', NULL, 'Uncharacterized protein', 407, NULL, NULL, 93650),
(93651, '2.40.50.690-FF-000033', NULL, 'Uncharacterized protein', 107, NULL, NULL, 93651),
(93652, '3.90.1580.10-FF-000038', NULL, 'Uncharacterized protein', 199, NULL, NULL, 93652),
(93653, '1.20.1070.10-FF-001540', NULL, 'Odorant receptor, family F, subfamily 115, member 12', 179, NULL, NULL, 93653),
(93654, '3.30.60.60-FF-000011', NULL, 'Histone acetyltransferase', 63, NULL, NULL, 93654),
(93655, '2.60.40.60-FF-000713', NULL, 'Cdh-4', 100, NULL, NULL, 93655),
(93656, '3.90.79.10-FF-000093', NULL, 'Unplaced genomic scaffold supercont1.38, whole genome shotgun sequence', 127, NULL, NULL, 93656),
(93657, '3.40.630.10-FF-000425', NULL, 'Uncharacterized protein', 289, NULL, NULL, 93657),
(93658, '2.130.10.10-FF-004414', NULL, 'Plexin D1', 368, NULL, NULL, 93658),
(93659, '2.70.130.10-FF-000137', NULL, NULL, 155, NULL, NULL, 93659),
(93660, '3.40.190.290-FF-000023', NULL, 'LysR family transcriptional regulator', 198, NULL, NULL, 93660),
(93661, '1.25.40.10-FF-003941', NULL, 'Uncharacterized protein', 277, NULL, NULL, 93661),
(93662, '3.80.10.10-FF-003212', NULL, 'Protein CBG22555', 370, NULL, NULL, 93662),
(93663, '1.25.40.10-FF-003587', NULL, 'Bll5958 protein', 160, NULL, NULL, 93663),
(93664, '2.60.40.10-FF-001839', NULL, 'filamin-A isoform X7', 95, NULL, NULL, 93664);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(93665, '2.60.120.10-FF-000690', NULL, 'lysine-specific demethylase 8-like isoform X1', 248, NULL, NULL, 93665),
(93666, '2.130.10.10-FF-000715', NULL, 'F-box protein MET30', 125, NULL, NULL, 93666),
(93667, '2.60.40.60-FF-000258', NULL, 'neural-cadherin isoform X8', 104, NULL, NULL, 93667),
(93668, '1.20.1250.20-FF-001506', NULL, 'Uncharacterized protein', 213, NULL, NULL, 93668),
(93669, '2.130.10.10-FF-001997', NULL, 'Striatin-3', 72, NULL, NULL, 93669),
(93670, '3.30.160.60-FF-004650', NULL, NULL, 34, NULL, NULL, 93670),
(93671, '3.20.80.10-FF-000009', NULL, 'Testis-expressed sequence 264 protein', 152, NULL, NULL, 93671),
(93672, '3.10.580.10-FF-000063', NULL, 'DUF21 domain-containing protein At5g52790', 135, NULL, NULL, 93672),
(93673, '1.20.1250.20-FF-001394', NULL, 'MFS general substrate transporter', 190, NULL, NULL, 93673),
(93674, '2.60.40.10-FF-004245', NULL, NULL, 111, NULL, NULL, 93674),
(93675, '3.30.1640.10-FF-000091', NULL, 'DNA helicase', 126, NULL, NULL, 93675),
(93676, '1.25.40.10-FF-001939', NULL, 'Pentatricopeptide repeat-containing protein At5g66520 family', 120, NULL, NULL, 93676),
(93677, '2.40.10.10-FF-000192', NULL, 'CLIP-domain serine protease', 146, NULL, NULL, 93677),
(93678, '3.30.1490.250-FF-000001', NULL, 'Glutathione synthetase', 72, NULL, NULL, 93678),
(93679, '1.10.472.10-FF-000313', NULL, 'retinoblastoma-like protein 2', 180, NULL, NULL, 93679),
(93680, '2.130.10.10-FF-002424', NULL, 'Periodic tryptophan protein 2-like protein', 300, NULL, NULL, 93680),
(93681, '3.40.190.10-FF-000054', NULL, 'Glutamate receptor', 117, NULL, NULL, 93681),
(93682, '3.40.50.300-FF-004139', NULL, 'Replication related protein', 160, NULL, NULL, 93682),
(93683, '1.25.40.10-FF-001687', NULL, 'Suppressor of RPS4-RLD 1', 97, NULL, NULL, 93683),
(93684, '2.130.10.10-FF-002514', NULL, 'Two-component system sensor histidine kinase/response regulator', 292, NULL, NULL, 93684),
(93685, '3.40.50.1010-FF-000147', NULL, 'Predicted protein', 204, NULL, NULL, 93685),
(93686, '2.40.30.130-FF-000013', NULL, 'Threonyl and alanyl tRNA synthetase second additional domain-containing protein', 104, NULL, NULL, 93686),
(93687, '2.60.120.620-FF-000009', NULL, 'Prolyl 3-hydroxylase OGFOD1 isoform 1', 239, NULL, NULL, 93687),
(93688, '1.25.10.10-FF-000106', NULL, 'Symplekin', 331, NULL, NULL, 93688),
(93689, '1.25.40.10-FF-003839', NULL, 'FKBP prolyl isomerase-like', 119, NULL, NULL, 93689),
(93690, '3.40.50.1000-FF-000144', NULL, 'copper-transporting ATPase 1 isoform X2', 46, NULL, NULL, 93690),
(93691, '2.60.40.10-FF-001587', NULL, 'Collagen type XX alpha 1 chain', 91, NULL, NULL, 93691),
(93692, '3.30.500.10-FF-000042', NULL, NULL, 102, NULL, NULL, 93692),
(93693, '3.90.550.10-FF-000166', NULL, 'Probable sugar transferase', 222, NULL, NULL, 93693),
(93694, '1.20.1070.10-FF-001394', NULL, 'Predicted protein', 243, NULL, NULL, 93694),
(93695, '1.10.3260.10-FF-000028', NULL, 'DNA ligase', 261, NULL, NULL, 93695),
(93696, '3.90.1140.10-FF-000033', NULL, 'Uncharacterized protein', 224, NULL, NULL, 93696),
(93697, '3.40.50.360-FF-000099', NULL, 'NADPH-dependent diflavin oxidoreductase 1', 163, NULL, NULL, 93697),
(93698, '3.10.490.10-FF-000033', NULL, 'Gamma-glutamylcyclotransferase', 172, NULL, NULL, 93698),
(93699, '1.25.40.20-FF-000408', NULL, 'Ankyrin repeat family protein', 174, NULL, NULL, 93699),
(93700, '2.60.40.640-FF-000124', NULL, 'Uncharacterized protein', 131, NULL, NULL, 93700),
(93701, '3.90.190.20-FF-000040', NULL, 'Dihydrofolate synthase, putative', 160, NULL, NULL, 93701),
(93702, '2.120.10.70-FF-000003', NULL, 'Uncharacterized protein', 100, NULL, NULL, 93702),
(93703, '1.25.40.340-FF-000005', NULL, 'Dihydroxyacetone kinase 1-like protein', 203, NULL, NULL, 93703),
(93704, '3.40.50.1400-FF-000039', NULL, 'Predicted protein', 94, NULL, NULL, 93704),
(93705, '2.60.120.260-FF-000210', NULL, 'Alpha-L-arabinofuranosidase', 146, NULL, NULL, 93705),
(93706, '1.25.40.250-FF-000012', NULL, 'Eukaryotic translation initiation factor 3 subunit K', 117, NULL, NULL, 93706),
(93707, '1.10.510.10-FF-003596', NULL, NULL, 206, NULL, NULL, 93707);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(93708, '3.30.450.40-FF-000142', NULL, 'Histidine kinase', 160, NULL, NULL, 93708),
(93709, '3.10.450.490-FF-000004', NULL, 'Hemagglutinin/proteinase', 89, NULL, NULL, 93709),
(93710, '1.10.510.10-FF-004113', NULL, NULL, 116, NULL, NULL, 93710),
(93711, '1.10.730.10-FF-000043', NULL, 'Methionine-tRNA ligase', 173, NULL, NULL, 93711),
(93712, '1.20.1080.10-FF-000040', NULL, 'AQuaPorin or aquaglyceroporin related', 247, NULL, NULL, 93712),
(93713, '3.30.160.60-FF-006347', NULL, NULL, 23, NULL, NULL, 93713),
(93714, '2.30.130.10-FF-000017', NULL, 'RNA-binding protein, containing PUA domain', 78, NULL, NULL, 93714),
(93715, '3.30.40.10-FF-001440', NULL, 'TNF receptor-associated factor 4', 54, NULL, NULL, 93715),
(93716, '1.10.8.60-FF-000086', NULL, '26S protease regulatory subunit 10B, putative', 71, NULL, NULL, 93716),
(93717, '1.25.40.330-FF-000002', NULL, 'Adenylyl cyclase-associated protein', 119, NULL, NULL, 93717),
(93718, '3.40.30.10-FF-001051', NULL, 'Iodothyronine deiodinase', 181, NULL, NULL, 93718),
(93719, '1.25.40.10-FF-000405', NULL, 'Sel1 repeat family protein', 132, NULL, NULL, 93719),
(93720, '2.120.10.80-FF-000006', NULL, 'Kelch-like family member 20', 304, NULL, NULL, 93720),
(93721, '1.25.40.180-FF-000289', NULL, NULL, 128, NULL, NULL, 93721),
(93722, '1.20.5.930-FF-000006', NULL, 'Integrin subunit alpha 1', 43, NULL, NULL, 93722),
(93723, '2.40.160.120-FF-000052', NULL, 'Oxysterol-binding protein', 62, NULL, NULL, 93723),
(93724, '1.20.5.110-FF-000249', NULL, 'Syntaxin 2-2', 100, NULL, NULL, 93724),
(93725, '2.30.30.140-FF-000187', NULL, 'Tudor domain-containing 12', 73, NULL, NULL, 93725),
(93726, '1.10.560.10-FF-000108', NULL, 'Uncharacterized protein', 19, NULL, NULL, 93726),
(93727, '3.30.70.340-FF-000032', NULL, NULL, 77, NULL, NULL, 93727),
(93728, '3.40.1190.20-FF-000079', NULL, 'BUD17p putative pyridoxal kinase', 302, NULL, NULL, 93728),
(93729, '3.30.70.330-FF-001973', NULL, NULL, 149, NULL, NULL, 93729),
(93730, '1.10.1670.10-FF-000020', NULL, 'Adenine DNA glycosylase', 91, NULL, NULL, 93730),
(93731, '2.120.10.90-FF-000009', NULL, 'DNA topoisomerase 4 subunit A', 241, NULL, NULL, 93731),
(93732, '3.30.160.60-FF-002396', NULL, 'Tripartite motif containing 65', 58, NULL, NULL, 93732),
(93733, '1.10.357.10-FF-000080', NULL, 'TetR/AcrR family transcriptional regulator', 141, NULL, NULL, 93733),
(93734, '1.20.272.10-FF-000015', NULL, 'Replication factor C subunit 4', 94, NULL, NULL, 93734),
(93735, '1.10.8.270-FF-000024', NULL, 'TBC1 domain family member 13', 112, NULL, NULL, 93735),
(93736, '2.60.40.10-FF-003739', NULL, NULL, 114, NULL, NULL, 93736),
(93737, '4.10.400.10-FF-000350', NULL, 'GPR insulin like receptor 1', 46, NULL, NULL, 93737),
(93738, '1.20.1250.20-FF-000888', NULL, 'MFS transporter', 184, NULL, NULL, 93738),
(93739, '3.40.50.1100-FF-000073', NULL, 'Pyridoxal-phosphate dependent enzyme, putative', 233, NULL, NULL, 93739),
(93740, '2.10.25.10-FF-001076', NULL, 'Uncharacterized protein', 35, NULL, NULL, 93740),
(93741, '3.90.1410.10-FF-000026', NULL, 'Actin-histidine N-methyltransferase', 330, NULL, NULL, 93741),
(93742, '3.40.720.10-FF-000354', NULL, 'N-acetylgalactosamine-6-sulfatase, putative', 61, NULL, NULL, 93742),
(93743, '3.40.50.1240-FF-000064', NULL, 'WGS project CABT00000000 data, contig 2.2', 181, NULL, NULL, 93743),
(93744, '3.80.10.10-FF-003122', NULL, 'Uncharacterized protein', 86, NULL, NULL, 93744),
(93745, '1.25.40.10-FF-000714', NULL, 'RNA polymerase-associated protein CTR9', 354, NULL, NULL, 93745),
(93746, '3.30.1130.10-FF-000018', NULL, 'Predicted protein', 128, NULL, NULL, 93746),
(93747, '2.30.30.140-FF-000097', NULL, 'AT-rich interactive domain-containing protein 4B', 112, NULL, NULL, 93747),
(93748, '3.30.559.30-FF-000104', NULL, 'Uncharacterized protein', 245, NULL, NULL, 93748),
(93749, '3.20.20.80-FF-000358', NULL, 'Chitinase-like 5', 64, NULL, NULL, 93749),
(93750, '1.20.120.350-FF-000247', NULL, NULL, 90, NULL, NULL, 93750),
(93751, '2.60.120.290-FF-000129', NULL, 'Complement component 1, s subcomponent', 118, NULL, NULL, 93751);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(93752, '3.10.110.10-FF-000230', NULL, 'AT28509p', 162, NULL, NULL, 93752),
(93753, '2.130.10.10-FF-005297', NULL, 'Uncharacterized protein', 385, NULL, NULL, 93753),
(93754, '3.10.20.90-FF-000390', NULL, 'UBP6p Ubiquitin-specific protease', 72, NULL, NULL, 93754),
(93755, '2.30.29.30-FF-001258', NULL, 'Uncharacterized protein', 158, NULL, NULL, 93755),
(93756, '3.40.50.720-FF-001319', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase GAPC1 cytosolic', 103, NULL, NULL, 93756),
(93757, '1.25.40.10-FF-004104', NULL, 'Uncharacterized protein', 143, NULL, NULL, 93757),
(93758, '2.60.40.1120-FF-000018', NULL, 'Carboxypeptidase D', 86, NULL, NULL, 93758),
(93759, '2.60.40.1110-FF-000015', NULL, 'Phosphatidylinositol 3,4,5-trisphosphate 3-phosphatase cnrN', 111, NULL, NULL, 93759),
(93760, '3.10.100.10-FF-000302', NULL, NULL, 162, NULL, NULL, 93760),
(93761, '1.20.1110.10-FF-000083', NULL, 'PMCA23 protein', 447, NULL, NULL, 93761),
(93762, '3.30.40.10-FF-001647', NULL, 'Predicted protein', 43, NULL, NULL, 93762),
(93763, '1.20.1050.80-FF-000008', NULL, 'Ankyrin repeat domain-containing protein 27', 160, NULL, NULL, 93763),
(93764, '3.40.50.1110-FF-000076', NULL, 'Acetylxylan esterase', 226, NULL, NULL, 93764),
(93765, '3.30.160.60-FF-004902', NULL, NULL, 78, NULL, NULL, 93765),
(93766, '2.80.10.50-FF-000163', NULL, 'Fibroblast growth factor 21', 126, NULL, NULL, 93766),
(93767, '3.20.20.70-FF-000355', NULL, 'Putative galactinol--sucrose galactosyltransferase 1', 99, NULL, NULL, 93767),
(93768, '2.130.10.10-FF-000053', NULL, 'Coronin', 354, NULL, NULL, 93768),
(93769, '3.40.50.720-FF-001628', NULL, 'Short chain dehydrogenase/reductase family 42E, member 2', 335, NULL, NULL, 93769),
(93770, '3.30.1330.30-FF-000141', NULL, 'Predicted protein', 61, NULL, NULL, 93770),
(93771, '2.60.40.10-FF-002093', NULL, 'Inverse autotransporter adhesin-like protein YeeJ', 93, NULL, NULL, 93771),
(93772, '1.20.5.990-FF-000018', NULL, 'Uncharacterized protein', 36, NULL, NULL, 93772),
(93773, '2.60.120.260-FF-000120', NULL, 'Probable allantoicase', 189, NULL, NULL, 93773),
(93774, '3.40.50.10420-FF-000057', NULL, '5-formyltetrahydrofolate cyclo-ligase', 183, NULL, NULL, 93774),
(93775, '3.30.830.10-FF-000162', NULL, 'Insulin-degrading enzyme-like Protein', 219, NULL, NULL, 93775),
(93776, '1.10.132.20-FF-000016', NULL, 'Ribosome recycling factor', 82, NULL, NULL, 93776),
(93777, '2.60.40.60-FF-000404', NULL, 'Si:ch211-186j3.6', 93, NULL, NULL, 93777),
(93778, '1.10.10.10-FF-000044', NULL, 'RNA polymerase sigma factor RpoS', 74, NULL, NULL, 93778),
(93779, '3.40.1360.10-FF-000005', NULL, 'DNA primase, Toprim domain', 114, NULL, NULL, 93779),
(93780, '3.10.490.20-FF-000036', NULL, 'Uncharacterized protein', 50, NULL, NULL, 93780),
(93781, '1.20.1530.20-FF-000033', NULL, 'Glutathione-regulated potassium-efflux system protein kefB', 374, NULL, NULL, 93781),
(93782, '2.60.40.790-FF-000028', NULL, 'Heat shock protein beta-8', 85, NULL, NULL, 93782),
(93783, '2.60.40.10-FF-005639', NULL, NULL, 94, NULL, NULL, 93783),
(93784, '1.20.1070.10-FF-001085', NULL, 'Neuropeptide FF receptor 2', 361, NULL, NULL, 93784),
(93785, '1.20.140.10-FF-000097', NULL, 'Nitrite reductase (cytochrome; ammonia-forming)', 127, NULL, NULL, 93785),
(93786, '3.30.40.10-FF-001338', NULL, 'SET domain-containing protein, putative', 73, NULL, NULL, 93786),
(93787, '1.10.510.10-FF-003860', NULL, NULL, 99, NULL, NULL, 93787),
(93788, '2.60.40.10-FF-005881', NULL, NULL, 102, NULL, NULL, 93788),
(93789, '1.10.132.10-FF-000013', NULL, NULL, 130, NULL, NULL, 93789),
(93790, '2.170.270.10-FF-000005', NULL, 'Euchromatic histone-lysine N-methyltransferase 2', 274, NULL, NULL, 93790),
(93791, '1.20.1050.60-FF-000002', NULL, 'Glycosyl hydrolase family 92', 106, NULL, NULL, 93791),
(93792, '3.10.50.40-FF-000129', NULL, 'Peptidylprolyl isomerase', 52, NULL, NULL, 93792),
(93793, '3.30.70.100-FF-000090', NULL, 'AGL041Cp', 78, NULL, NULL, 93793),
(93794, '2.40.490.10-FF-000002', NULL, 'Fusion glycoprotein F0', 86, NULL, NULL, 93794),
(93795, '3.40.50.1820-FF-001227', NULL, 'Uncharacterized protein', 348, NULL, NULL, 93795);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(93796, '2.130.10.120-FF-000012', NULL, 'Prolyl oligopeptidase', 358, NULL, NULL, 93796),
(93797, '3.80.10.10-FF-001531', NULL, 'Uncharacterized protein', 130, NULL, NULL, 93797),
(93798, '3.50.50.60-FF-001229', NULL, 'GidA-related protein', 233, NULL, NULL, 93798),
(93799, '3.30.160.60-FF-000850', NULL, 'Zinc finger and SCAN domain containing 25', 29, NULL, NULL, 93799),
(93800, '1.10.533.10-FF-000293', NULL, 'NLR family CARD domain containing 3', 82, NULL, NULL, 93800),
(93801, '1.20.5.190-FF-000110', NULL, NULL, 50, NULL, NULL, 93801),
(93802, '3.30.200.20-FF-001859', NULL, 'Protein kinase, putative', 29, NULL, NULL, 93802),
(93803, '2.60.40.640-FF-000034', NULL, 'Uncharacterized protein, isoform A', 146, NULL, NULL, 93803),
(93804, '3.30.160.60-FF-000608', NULL, 'zinc finger protein 286A isoform X1', 29, NULL, NULL, 93804),
(93805, '1.50.40.10-FF-000460', NULL, 'Predicted protein', 92, NULL, NULL, 93805),
(93806, '1.10.472.80-FF-000065', NULL, 'GTPase-activating protein, putative', 150, NULL, NULL, 93806),
(93807, '1.10.405.10-FF-000029', NULL, 'Rab escort protein 1', 26, NULL, NULL, 93807),
(93808, '3.40.50.300-FF-000233', NULL, 'Methionine import ATP-binding protein MetN', 232, NULL, NULL, 93808),
(93809, '3.40.50.200-FF-000192', NULL, 'Uncharacterized protein', 193, NULL, NULL, 93809),
(93810, '1.25.10.10-FF-001298', NULL, 'Uncharacterized protein', 180, NULL, NULL, 93810),
(93811, '1.10.238.10-FF-000680', NULL, 'GTPase-activating protein GYP2', 214, NULL, NULL, 93811),
(93812, '3.30.70.980-FF-000066', NULL, 'Predicted protein', 44, NULL, NULL, 93812),
(93813, '3.40.50.2000-FF-000489', NULL, 'Glycosyltransferase 9 family protein', 189, NULL, NULL, 93813),
(93814, '1.10.287.660-FF-000016', NULL, 'AGAP004056-PA', 73, NULL, NULL, 93814),
(93815, '2.130.10.130-FF-000015', NULL, 'integrin alpha-PS3 isoform X1', 466, NULL, NULL, 93815),
(93816, '3.30.930.10-FF-000428', NULL, 'Aspartate-tRNA ligase or aspartyl tRNA synthetase', 356, NULL, NULL, 93816),
(93817, '3.30.40.10-FF-001086', NULL, 'E3 ubiquitin-protein ligase RNF5, putative', 132, NULL, NULL, 93817),
(93818, '2.60.120.970-FF-000092', NULL, 'Uncharacterized protein', 184, NULL, NULL, 93818),
(93819, '3.30.70.890-FF-000073', NULL, 'Galactokinase 1', 98, NULL, NULL, 93819),
(93820, '3.40.1230.10-FF-000001', NULL, 'Adipogenesis-associated, Mth938 domain-containing', 122, NULL, NULL, 93820),
(93821, '3.40.50.12100-FF-000005', NULL, 'Uncharacterized protein', 102, NULL, NULL, 93821),
(93822, '3.90.228.10-FF-000070', NULL, 'Poly [ADP-ribose] polymerase', 65, NULL, NULL, 93822),
(93823, '3.80.30.20-FF-000006', NULL, 'MiaB-like tRNA modifying enzyme', 234, NULL, NULL, 93823),
(93824, '3.30.200.20-FF-000016', NULL, 'Tyrosine-protein kinase', 92, NULL, NULL, 93824),
(93825, '3.40.50.300-FF-005477', NULL, 'DEAD-box ATP-dependent RNA helicase CshB', 214, NULL, NULL, 93825),
(93826, '1.10.1450.10-FF-000155', NULL, 'Uncharacterized protein', 82, NULL, NULL, 93826),
(93827, '2.60.120.10-FF-000381', NULL, 'Cyclic nucleotide-binding domain containing protein, putative', 150, NULL, NULL, 93827),
(93828, '1.10.238.10-FF-000371', NULL, 'CDPK-related kinase 3', 63, NULL, NULL, 93828),
(93829, '3.30.160.60-FF-002750', NULL, 'zinc finger protein 529 isoform X1', 32, NULL, NULL, 93829),
(93830, '3.30.450.20-FF-000647', NULL, 'PAS sensor protein', 123, NULL, NULL, 93830),
(93831, '2.40.30.10-FF-000513', NULL, 'Uncharacterized protein', 49, NULL, NULL, 93831),
(93832, '1.10.287.110-FF-000424', NULL, 'Uncharacterized protein', 92, NULL, NULL, 93832),
(93833, '1.10.10.10-FF-000605', NULL, 'Uncharacterized protein', 137, NULL, NULL, 93833),
(93834, '1.10.287.110-FF-000172', NULL, 'Pre-mRNA-splicing factor CWC23', 70, NULL, NULL, 93834),
(93835, '2.60.40.10-FF-000193', NULL, 'Myelin protein zero-like 1 like', 127, NULL, NULL, 93835),
(93836, '3.30.200.20-FF-000325', NULL, 'Putative receptor-like serine/threonine-protein kinase', 110, NULL, NULL, 93836),
(93837, '1.10.10.10-FF-001578', NULL, 'MurR/RpiR family transcriptional regulator', 78, NULL, NULL, 93837);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(93838, '3.30.1380.20-FF-000039', NULL, 'Uncharacterized protein', 155, NULL, NULL, 93838),
(93839, '3.10.290.10-FF-000068', NULL, '40S ribosomal protein S4-3', 91, NULL, NULL, 93839),
(93840, '3.40.50.2300-FF-001169', NULL, NULL, 221, NULL, NULL, 93840),
(93841, '3.80.10.10-FF-001840', NULL, 'Hypothetical_protein_-_conserved', 111, NULL, NULL, 93841),
(93842, '3.30.930.10-FF-000119', NULL, 'Lysine-tRNA ligase', 358, NULL, NULL, 93842),
(93843, '2.120.10.30-FF-000008', NULL, 'Low-density lipoprotein receptor-related protein 4', 304, NULL, NULL, 93843),
(93844, '3.40.50.720-FF-001067', NULL, 'SUMO-activating enzyme subunit aos-1', 351, NULL, NULL, 93844),
(93845, '1.20.120.980-FF-000014', NULL, 'GH14278p', 153, NULL, NULL, 93845),
(93846, '2.120.10.30-FF-000250', NULL, 'Nidogen 2a (osteonidogen)', 112, NULL, NULL, 93846),
(93847, '3.90.70.10-FF-000129', NULL, 'Ubiquitinyl hydrolase 1', 282, NULL, NULL, 93847),
(93848, '3.40.50.300-FF-007938', NULL, 'Uncharacterized protein', 363, NULL, NULL, 93848),
(93849, '3.90.226.10-FF-000340', NULL, 'Putative enoyl-CoA hydratase/Enoyl-CoA isomerase/3-hydroxyacyl-CoA dehydrogenase', 317, NULL, NULL, 93849),
(93850, '3.90.1720.10-FF-000027', NULL, 'Probable endopeptidase Cgl2188', 144, NULL, NULL, 93850),
(93851, '2.40.50.100-FF-000036', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 78, NULL, NULL, 93851),
(93852, '3.30.160.60-FF-005870', NULL, NULL, 51, NULL, NULL, 93852),
(93853, '2.60.120.330-FF-000046', NULL, 'Os09g0353700 protein', 330, NULL, NULL, 93853),
(93854, '3.10.20.90-FF-000760', NULL, 'Ubiquitin-like domain containing protein, putative', 89, NULL, NULL, 93854),
(93855, '3.30.540.10-FF-000033', NULL, 'Inositol-1-monophosphatase', 153, NULL, NULL, 93855),
(93856, '1.10.8.10-FF-000094', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 60, NULL, NULL, 93856),
(93857, '1.10.167.10-FF-000071', NULL, 'Uncharacterized protein', 133, NULL, NULL, 93857),
(93858, '3.40.190.290-FF-000006', NULL, 'HTH-type transcriptional regulator tdcA', 206, NULL, NULL, 93858),
(93859, '2.20.70.10-FF-000106', NULL, 'CUGBP Elav-like family member 2', 59, NULL, NULL, 93859),
(93860, '2.60.40.1170-FF-000016', NULL, 'AP-1 complex subunit mu', 34, NULL, NULL, 93860),
(93861, '2.60.40.10-FF-004330', NULL, NULL, 77, NULL, NULL, 93861),
(93862, '1.10.238.10-FF-000028', NULL, 'Putative calcium-binding mitochondrial carrier protein scamc-2', 75, NULL, NULL, 93862),
(93863, '3.10.490.10-FF-000050', NULL, 'Protein CBG21102', 110, NULL, NULL, 93863),
(93864, '2.130.10.10-FF-005387', NULL, 'Uncharacterized protein', 154, NULL, NULL, 93864),
(93865, '1.10.418.10-FF-000233', NULL, 'Plectin', 84, NULL, NULL, 93865),
(93866, '1.20.140.150-FF-000056', NULL, 'Claudin', 186, NULL, NULL, 93866),
(93867, '3.40.50.2300-FF-000421', NULL, 'Glutamate receptor', 97, NULL, NULL, 93867),
(93868, '2.20.50.20-FF-000007', NULL, 'von Willebrand factor type D domaincontaining protein', 137, NULL, NULL, 93868),
(93869, '3.30.70.1230-FF-000047', NULL, 'Adenylate/guanylate cyclase catalytic domain protein', 192, NULL, NULL, 93869),
(93870, '1.10.20.120-FF-000018', NULL, 'Predicted protein', 76, NULL, NULL, 93870),
(93871, '3.40.50.300-FF-006292', NULL, 'Uncharacterized protein', 34, NULL, NULL, 93871),
(93872, '1.50.40.10-FF-000196', NULL, 'mitoferrin', 191, NULL, NULL, 93872),
(93873, '3.30.200.20-FF-000134', NULL, 'Dual specificity testis-specific protein kinase 2', 77, NULL, NULL, 93873),
(93874, '1.10.238.10-FF-000461', NULL, 'Calcium-binding protein SPEC 2D', 72, NULL, NULL, 93874),
(93875, '3.10.20.90-FF-000283', NULL, 'Pez, isoform A', 89, NULL, NULL, 93875),
(93876, '2.30.29.30-FF-000859', NULL, 'Nucleoporin', 149, NULL, NULL, 93876),
(93877, '2.60.40.1180-FF-000019', NULL, 'Alpha-mannosidase 2', 123, NULL, NULL, 93877),
(93878, '1.20.5.340-FF-000060', NULL, 'Unplaced genomic scaffold supercont1.13, whole genome shotgun sequence', 86, NULL, NULL, 93878),
(93879, '2.170.270.10-FF-000224', NULL, 'Uncharacterized protein', 98, NULL, NULL, 93879),
(93880, '3.20.20.60-FF-000127', NULL, 'Pyruvate kinase', 80, NULL, NULL, 93880);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(93881, '3.30.70.330-FF-001428', NULL, 'RNA-binding protein', 117, NULL, NULL, 93881),
(93882, '1.10.510.10-FF-002078', NULL, 'Kinase, STE STE11', 377, NULL, NULL, 93882),
(93883, '3.90.550.10-FF-000722', NULL, 'Protein CBR-LGE-1', 259, NULL, NULL, 93883),
(93884, '3.40.50.1820-FF-001452', NULL, 'Uncharacterized protein', 183, NULL, NULL, 93884),
(93885, '2.130.10.10-FF-002205', NULL, 'Minichromosome loss protein 1', 173, NULL, NULL, 93885),
(93886, '3.30.1540.20-FF-000030', NULL, NULL, 63, NULL, NULL, 93886),
(93887, '1.10.10.10-FF-000151', NULL, 'DNA-binding transcriptional repressor', 58, NULL, NULL, 93887),
(93888, '2.60.40.10-FF-000619', NULL, 'Nectin cell adhesion molecule 2', 94, NULL, NULL, 93888),
(93889, '3.40.30.10-FF-000707', NULL, 'Protein disulfide-isomerase', 132, NULL, NULL, 93889),
(93890, '4.10.400.10-FF-000349', NULL, 'Uncharacterized protein', 34, NULL, NULL, 93890),
(93891, '2.70.170.10-FF-000128', NULL, 'Uncharacterized protein', 158, NULL, NULL, 93891),
(93892, '1.10.3930.10-FF-000001', NULL, 'Arginine deiminase', 84, NULL, NULL, 93892),
(93893, '3.40.50.300-FF-002604', NULL, 'Cytosolic Fe-S cluster assembly factor NUBP2 homolog', 279, NULL, NULL, 93893),
(93894, '1.10.1130.10-FF-000002', NULL, 'Cytochrome c-552', 290, NULL, NULL, 93894),
(93895, '2.30.180.10-FF-000172', NULL, NULL, 96, NULL, NULL, 93895),
(93896, '3.30.1150.10-FF-000008', NULL, 'TolA protein', 103, NULL, NULL, 93896),
(93897, '2.10.25.10-FF-001177', NULL, 'Hemicentin 1', 48, NULL, NULL, 93897),
(93898, '3.40.190.10-FF-000172', NULL, 'SgrR family transcriptional regulator', 196, NULL, NULL, 93898),
(93899, '3.40.950.10-FF-000045', NULL, NULL, 26, NULL, NULL, 93899),
(93900, '3.30.70.330-FF-000012', NULL, 'RNA-binding motif, single-stranded-interacting protein 3 isoform 1', 83, NULL, NULL, 93900),
(93901, '2.40.50.140-FF-000340', NULL, 'Unplaced genomic scaffold supercont1.162, whole genome shotgun sequence', 84, NULL, NULL, 93901),
(93902, '3.90.70.10-FF-000500', NULL, 'Uncharacterized protein', 326, NULL, NULL, 93902),
(93903, '3.40.50.2300-FF-001416', NULL, NULL, 52, NULL, NULL, 93903),
(93904, '3.30.160.60-FF-006038', NULL, NULL, 21, NULL, NULL, 93904),
(93905, '2.60.40.10-FF-003857', NULL, NULL, 110, NULL, NULL, 93905),
(93906, '3.30.450.290-FF-000001', NULL, 'Methyl-accepting chemotaxis protein', 136, NULL, NULL, 93906),
(93907, '2.60.40.60-FF-000376', NULL, 'Predicted protein', 103, NULL, NULL, 93907),
(93908, '3.40.1350.120-FF-000001', NULL, 'tRNA nuclease CdiA-2', 135, NULL, NULL, 93908),
(93909, '1.10.132.60-FF-000022', NULL, 'Predicted protein', 144, NULL, NULL, 93909),
(93910, '3.30.530.20-FF-000120', NULL, 'YALI0A02563p', 146, NULL, NULL, 93910),
(93911, '4.10.60.10-FF-000034', NULL, 'Universal minicircle sequence binding protein (UMSBP), putative', 28, NULL, NULL, 93911),
(93912, '1.10.510.10-FF-002185', NULL, NULL, 101, NULL, NULL, 93912),
(93913, '1.10.20.10-FF-000123', NULL, 'TAF (TBP-associated transcription factor) family', 73, NULL, NULL, 93913),
(93914, '2.40.10.10-FF-000074', NULL, 'glyoxysomal processing protease, glyoxysomal-like', 107, NULL, NULL, 93914),
(93915, '1.25.40.10-FF-002631', NULL, 'Pentatricopeptide repeat-containing protein At4g31850, chloroplastic', 151, NULL, NULL, 93915),
(93916, '1.50.40.10-FF-000089', NULL, 'protein MITOFERRINLIKE 1, chloroplastic', 171, NULL, NULL, 93916),
(93917, '1.10.132.70-FF-000025', NULL, 'Telomerase reverse transcriptase', 138, NULL, NULL, 93917),
(93918, '3.90.1290.10-FF-000055', NULL, 'Uncharacterized protein', 108, NULL, NULL, 93918),
(93919, '2.60.40.2840-FF-000017', NULL, 'Phosphatidylethanolamine N-methyltransferase', 130, NULL, NULL, 93919),
(93920, '3.30.200.20-FF-000241', NULL, 'Serine/threonine-protein kinase Nek6', 59, NULL, NULL, 93920),
(93921, '2.60.40.150-FF-000112', NULL, 'centrosomal protein of 120 kDa isoform X1', 146, NULL, NULL, 93921),
(93922, '3.80.10.10-FF-001621', NULL, 'EIN3-binding F-box protein 1 isoform A', 160, NULL, NULL, 93922),
(93923, '3.40.850.20-FF-000001', NULL, 'Cik1p', 192, NULL, NULL, 93923),
(93924, '3.40.50.620-FF-000891', NULL, 'Leucyl-tRNA synthetase 2, mitochondrial', 92, NULL, NULL, 93924);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(93925, '2.30.30.40-FF-000141', NULL, 'SH3 and PX domain-containing protein 2A', 64, NULL, NULL, 93925),
(93926, '3.40.50.720-FF-001168', NULL, 'Os04g0581600 protein', 115, NULL, NULL, 93926),
(93927, '2.60.40.10-FF-002076', NULL, 'Myotactin form A', 100, NULL, NULL, 93927),
(93928, '1.20.1250.40-FF-000012', NULL, 'Unplaced genomic scaffold supercont1.20, whole genome shotgun sequence', 125, NULL, NULL, 93928),
(93929, '2.130.10.10-FF-003835', NULL, 'Methylosome protein 50-like Protein', 295, NULL, NULL, 93929),
(93930, '1.20.142.10-FF-000011', NULL, 'Poly [ADP-ribose] polymerase', 152, NULL, NULL, 93930),
(93931, '3.10.580.10-FF-000169', NULL, 'Chloride channel protein', 102, NULL, NULL, 93931),
(93932, '3.40.50.620-FF-000784', NULL, 'Uncharacterized protein', 81, NULL, NULL, 93932),
(93933, '3.10.20.90-FF-000081', NULL, 'ubiquilin-1 isoform X2', 102, NULL, NULL, 93933),
(93934, '1.10.1000.11-FF-000005', NULL, 'Brefeldin A-inhibited guanine nucleotide-exchange 1', 119, NULL, NULL, 93934),
(93935, '2.10.25.10-FF-000834', NULL, 'Eater', 37, NULL, NULL, 93935),
(93936, '1.10.287.110-FF-000323', NULL, 'ARC6-like protein', 93, NULL, NULL, 93936),
(93937, '1.10.10.10-FF-001932', NULL, 'Uncharacterized protein', 90, NULL, NULL, 93937),
(93938, '3.30.420.10-FF-000564', NULL, NULL, 49, NULL, NULL, 93938),
(93939, '3.30.60.30-FF-000160', NULL, 'Solute carrier organic anion transporter family member', 53, NULL, NULL, 93939),
(93940, '2.60.40.10-FF-002183', NULL, 'Sallimus, isoform P', 103, NULL, NULL, 93940),
(93941, '3.40.50.1100-FF-000281', NULL, 'Uncharacterized protein', 45, NULL, NULL, 93941),
(93942, '2.60.40.60-FF-000483', NULL, 'cadherin-89D', 114, NULL, NULL, 93942),
(93943, '2.40.180.10-FF-000001', NULL, 'Catalase', 481, NULL, NULL, 93943),
(93944, '2.70.130.10-FF-000019', NULL, 'Insulin-like growth factor 2 receptor', 130, NULL, NULL, 93944),
(93945, '3.30.65.10-FF-000007', NULL, 'DNA topoisomerase', 56, NULL, NULL, 93945),
(93946, '2.60.120.200-FF-000794', NULL, 'Galectin', 63, NULL, NULL, 93946),
(93947, '2.10.25.10-FF-000941', NULL, 'Crumbs', 39, NULL, NULL, 93947),
(93948, '3.30.9.10-FF-000069', NULL, 'p-hydroxybenzoate hydroxylase', 148, NULL, NULL, 93948),
(93949, '2.120.10.30-FF-000115', NULL, 'NIDogen (Basement membrane protein)', 262, NULL, NULL, 93949),
(93950, '2.60.40.630-FF-000014', NULL, 'Signal transducer and activator of transcription', 70, NULL, NULL, 93950),
(93951, '3.10.50.40-FF-000028', NULL, 'Peptidylprolyl isomerase', 120, NULL, NULL, 93951),
(93952, '3.20.20.70-FF-000237', NULL, 'Ribulose-phosphate 3-epimerase', 227, NULL, NULL, 93952),
(93953, '3.80.10.10-FF-001514', NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', 126, NULL, NULL, 93953),
(93954, '1.10.10.930-FF-000001', NULL, 'Genome polyprotein', 78, NULL, NULL, 93954),
(93955, '1.25.40.20-FF-000717', NULL, 'Uncharacterized protein', 97, NULL, NULL, 93955),
(93956, '3.40.50.1820-FF-001126', NULL, 'Protease 2', 326, NULL, NULL, 93956),
(93957, '1.10.510.10-FF-000280', NULL, 'Cell division control protein 2 homolog', 207, NULL, NULL, 93957),
(93958, '1.10.230.10-FF-000016', NULL, 'Citrate synthase', 105, NULL, NULL, 93958),
(93959, '3.30.505.10-FF-000148', NULL, NULL, 119, NULL, NULL, 93959),
(93960, '2.60.40.640-FF-000017', NULL, 'thioredoxin-interacting protein-like', 149, NULL, NULL, 93960),
(93961, '3.30.2410.10-FF-000063', NULL, 'Uncharacterized protein', 75, NULL, NULL, 93961),
(93962, '1.20.5.4770-FF-000015', NULL, 'Uncharacterized protein', 56, NULL, NULL, 93962),
(93963, '1.10.10.440-FF-000056', NULL, 'Transcription elongation regulator 1', 70, NULL, NULL, 93963),
(93964, '3.30.160.60-FF-002525', NULL, 'Zinc finger protein Y-linked', 67, NULL, NULL, 93964),
(93965, '2.70.150.10-FF-000240', NULL, 'Uncharacterized protein', 107, NULL, NULL, 93965),
(93966, '2.40.50.150-FF-000034', NULL, 'DNA-directed RNA polymerase subunit beta', 143, NULL, NULL, 93966),
(93967, '1.25.40.10-FF-003368', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 67, NULL, NULL, 93967);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(93968, '1.10.8.850-FF-000001', NULL, 'SET-domain containing protein lysine methyltransferase family protein', 63, NULL, NULL, 93968),
(93969, '1.10.555.10-FF-000259', NULL, NULL, 107, NULL, NULL, 93969),
(93970, '1.10.10.350-FF-000029', NULL, NULL, 97, NULL, NULL, 93970),
(93971, '3.10.280.10-FF-000017', NULL, 'Mitochondrial_glycoprotein_-_putative', 208, NULL, NULL, 93971),
(93972, '2.40.50.140-FF-000031', NULL, '30S ribosomal protein S1', 95, NULL, NULL, 93972),
(93973, '1.20.58.390-FF-000035', NULL, 'Acetylcholine receptor subunit beta-like 1', 75, NULL, NULL, 93973),
(93974, '2.60.11.10-FF-000002', NULL, 'Cytochrome c oxidase subunit Vb', 95, NULL, NULL, 93974),
(93975, '1.20.1250.20-FF-001950', NULL, 'Uncharacterized protein', 438, NULL, NULL, 93975),
(93976, '1.25.40.20-FF-000487', NULL, 'Transient receptor potential cation channel subfamily V member 5', 84, NULL, NULL, 93976),
(93977, '2.130.10.10-FF-003942', NULL, 'Coronin', 249, NULL, NULL, 93977),
(93978, '1.20.1300.20-FF-000016', NULL, 'Uncharacterized protein', 115, NULL, NULL, 93978),
(93979, '3.40.50.980-FF-000037', NULL, 'AMP-binding enzyme, putative', 117, NULL, NULL, 93979),
(93980, '3.20.20.70-FF-000765', NULL, 'Putative NADPH dehydrogenase C23G7.10c', 364, NULL, NULL, 93980),
(93981, '1.10.287.1490-FF-000119', NULL, 'Uncharacterized protein', 156, NULL, NULL, 93981),
(93982, '1.10.150.50-FF-000179', NULL, 'Predicted protein', 71, NULL, NULL, 93982),
(93983, '2.60.120.40-FF-000007', NULL, 'Tumor necrosis factor', 157, NULL, NULL, 93983),
(93984, '1.20.1300.10-FF-000013', NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', 60, NULL, NULL, 93984),
(93985, '2.60.200.20-FF-000272', NULL, 'Uncharacterized protein', 145, NULL, NULL, 93985),
(93986, '1.10.287.470-FF-000066', NULL, 'Efflux transporter, RND family, MFP subunit', 60, NULL, NULL, 93986),
(93987, '3.30.310.50-FF-000005', NULL, 'L antigen family member 3', 85, NULL, NULL, 93987),
(93988, '3.30.160.60-FF-002295', NULL, 'ZFP37 zinc finger protein', 29, NULL, NULL, 93988),
(93989, '2.130.10.10-FF-003509', NULL, 'Flagellar Member 5', 229, NULL, NULL, 93989),
(93990, '1.50.40.10-FF-000566', NULL, 'Mitochondrial carrier protein-like protein', 107, NULL, NULL, 93990),
(93991, '2.60.40.10-FF-005746', NULL, NULL, 104, NULL, NULL, 93991),
(93992, '2.40.50.430-FF-000011', NULL, 'DNA polymerase alpha/epsilon subunit B-domain-containing protein', 138, NULL, NULL, 93992),
(93993, '3.30.1600.10-FF-000009', NULL, 'Nad-dependent deacetylase 1 putative', 96, NULL, NULL, 93993),
(93994, '3.40.50.300-FF-002711', NULL, 'Peptide chain release factor 3', 117, NULL, NULL, 93994),
(93995, '3.30.310.40-FF-000002', NULL, 'N-glycosylase/DNA lyase, putative', 87, NULL, NULL, 93995),
(93996, '1.10.1420.10-FF-000119', NULL, 'DNA mismatch repair protein MutS', 183, NULL, NULL, 93996),
(93997, '3.30.70.340-FF-000015', NULL, NULL, 94, NULL, NULL, 93997),
(93998, '1.25.10.10-FF-002803', NULL, 'AGAP005771-PA', 175, NULL, NULL, 93998),
(93999, '1.10.510.10-FF-000307', NULL, 'Serine/threonine-protein kinase RIO2', 126, NULL, NULL, 93999),
(94000, '3.40.50.2300-FF-001186', NULL, NULL, 25, NULL, NULL, 94000),
(94001, '1.10.287.1130-FF-000006', NULL, 'Cytochrome c oxidase copper chaperone', 60, NULL, NULL, 94001),
(94002, '3.40.30.10-FF-000337', NULL, 'Protein disulfide-isomerase domain', 139, NULL, NULL, 94002),
(94003, '4.10.410.10-FF-000075', NULL, 'Tissue factor pathway inhibitor', 65, NULL, NULL, 94003),
(94004, '2.30.29.30-FF-001039', NULL, 'Uncharacterized protein', 89, NULL, NULL, 94004),
(94005, '1.10.238.10-FF-000354', NULL, 'Actin cytoskeleton-regulatory complex protein pan1', 112, NULL, NULL, 94005),
(94006, '1.10.290.10-FF-000008', NULL, 'DNA topoisomerase', 142, NULL, NULL, 94006),
(94007, '2.60.120.970-FF-000119', NULL, 'Myostatin', 66, NULL, NULL, 94007),
(94008, '2.60.40.10-FF-004021', NULL, NULL, 98, NULL, NULL, 94008),
(94009, '3.30.160.60-FF-000743', NULL, 'PR domain zinc finger protein 13', 25, NULL, NULL, 94009),
(94010, '2.130.10.10-FF-002054', NULL, 'Putative beta propeller protein', 167, NULL, NULL, 94010);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(94011, '1.20.120.230-FF-000003', NULL, 'Talin 2', 125, NULL, NULL, 94011),
(94012, '2.60.40.10-FF-003964', NULL, NULL, 103, NULL, NULL, 94012),
(94013, '2.40.30.10-FF-000311', NULL, 'Methionine synthase reductase, mitochondrial-like protein', 69, NULL, NULL, 94013),
(94014, '2.60.40.2440-FF-000004', NULL, 'protein phosphatase 1 regulatory subunit 3A', 138, NULL, NULL, 94014),
(94015, '3.80.10.10-FF-003419', NULL, 'Uncharacterized protein', 79, NULL, NULL, 94015),
(94016, '3.90.70.10-FF-000702', NULL, 'Uncharacterized protein', 215, NULL, NULL, 94016),
(94017, '3.40.50.1000-FF-000806', NULL, NULL, 136, NULL, NULL, 94017),
(94018, '3.30.70.1170-FF-000012', NULL, 'Uncharacterized protein', 65, NULL, NULL, 94018),
(94019, '3.30.160.60-FF-002306', NULL, 'Zinc finger protein 433', 25, NULL, NULL, 94019),
(94020, '2.40.50.100-FF-000019', NULL, 'DNA-directed RNA polymerase subunit beta', 75, NULL, NULL, 94020),
(94021, '2.10.110.10-FF-000110', NULL, 'Nebulin related anchoring protein', 65, NULL, NULL, 94021),
(94022, '2.60.40.1730-FF-000095', NULL, NULL, 227, NULL, NULL, 94022),
(94023, '1.20.1520.10-FF-000001', NULL, 'Cilia- and flagella-associated protein 36', 133, NULL, NULL, 94023),
(94024, '3.80.10.10-FF-002279', NULL, 'Leucine Rich Repeat domain protein (AFU_orthologue AFUA_1G04960)', 83, NULL, NULL, 94024),
(94025, '3.30.40.10-FF-001232', NULL, 'Protein kinase, putative', 71, NULL, NULL, 94025),
(94026, '3.30.9.10-FF-000288', NULL, 'Uncharacterized protein', 175, NULL, NULL, 94026),
(94027, '3.90.1410.10-FF-000127', NULL, 'Predicted protein', 284, NULL, NULL, 94027),
(94028, '3.20.20.80-FF-000459', NULL, 'Beta-glucosidase 40', 80, NULL, NULL, 94028),
(94029, '2.30.30.30-FF-000019', NULL, 'Tumor suppressor p53-binding protein 1', 65, NULL, NULL, 94029),
(94030, '3.30.420.40-FF-000084', NULL, 'Heat shock protein 17', 103, NULL, NULL, 94030),
(94031, '3.90.550.10-FF-000503', NULL, 'Uncharacterized protein', 269, NULL, NULL, 94031),
(94032, '2.120.10.90-FF-000021', NULL, 'DNA topoisomerase (ATP-hydrolyzing)', 233, NULL, NULL, 94032),
(94033, '2.60.40.2430-FF-000001', NULL, 'Agglutinin-like protein 3', 152, NULL, NULL, 94033),
(94034, '1.10.510.10-FF-004023', NULL, NULL, 117, NULL, NULL, 94034),
(94035, '1.10.10.10-FF-000370', NULL, 'Methionine aminopeptidase 2', 80, NULL, NULL, 94035),
(94036, '3.40.640.10-FF-000061', NULL, 'Cystathionine gamma-synthase', 253, NULL, NULL, 94036),
(94037, '3.40.50.300-FF-006073', NULL, 'Uncharacterized protein', 149, NULL, NULL, 94037),
(94038, '3.40.50.300-FF-005584', NULL, 'Uncharacterized protein', 143, NULL, NULL, 94038),
(94039, '1.10.3260.10-FF-000012', NULL, 'DNA ligase', 222, NULL, NULL, 94039),
(94040, '2.80.10.50-FF-000180', NULL, 'Fascin', 108, NULL, NULL, 94040),
(94041, '1.10.630.10-FF-000687', NULL, 'Os01g0543600 protein', 152, NULL, NULL, 94041),
(94042, '2.130.10.10-FF-001688', NULL, 'Phosphoinositide 3-kinase regulatory subunit 4', 285, NULL, NULL, 94042),
(94043, '3.40.50.1820-FF-001671', NULL, 'Predicted protein', 261, NULL, NULL, 94043),
(94044, '3.30.40.10-FF-001872', NULL, 'Peroxisome biogenesis factor 10', 77, NULL, NULL, 94044),
(94045, '1.10.472.10-FF-000049', NULL, 'Retinoblastoma-like 2, isoform CRA_a', 180, NULL, NULL, 94045),
(94046, '1.20.1070.10-FF-001321', NULL, 'Uncharacterized protein', 282, NULL, NULL, 94046),
(94047, '1.20.1250.20-FF-001422', NULL, 'Blr5939 protein', 170, NULL, NULL, 94047),
(94048, '1.10.246.130-FF-000028', NULL, NULL, 79, NULL, NULL, 94048),
(94049, '3.40.50.300-FF-002239', NULL, 'Dynein-related AAA-type ATPase', 243, NULL, NULL, 94049),
(94050, '1.10.1900.10-FF-000022', NULL, 'Predicted protein', 71, NULL, NULL, 94050),
(94051, '3.20.20.80-FF-000768', NULL, 'Chitinase, putative', 13, NULL, NULL, 94051),
(94052, '3.40.50.720-FF-002011', NULL, 'Uncharacterized protein', 220, NULL, NULL, 94052),
(94053, '3.40.50.300-FF-000457', NULL, 'ADP-ribosylation factor-like protein 6', 171, NULL, NULL, 94053),
(94054, '3.30.2350.20-FF-000021', NULL, 'tRNA pseudouridine synthase D', 36, NULL, NULL, 94054),
(94055, '1.10.510.10-FF-004332', NULL, NULL, 135, NULL, NULL, 94055);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(94056, '3.40.1380.20-FF-000026', NULL, 'Pyruvate kinase', 130, NULL, NULL, 94056),
(94057, '3.40.1380.10-FF-000023', NULL, 'H(+)-transporting ATP synthase, subunit gamma', 222, NULL, NULL, 94057),
(94058, '3.30.70.330-FF-001754', NULL, NULL, 113, NULL, NULL, 94058),
(94059, '3.40.1090.10-FF-000113', NULL, 'Uncharacterized protein', 351, NULL, NULL, 94059),
(94060, '1.25.40.20-FF-000178', NULL, 'Ankyrin repeat and sterile alpha motif domain containing 6', 145, NULL, NULL, 94060),
(94061, '2.40.70.10-FF-000050', NULL, 'Aspartic proteinase CDR1', 171, NULL, NULL, 94061),
(94062, '1.20.120.1750-FF-000117', NULL, 'RBR-type E3 ubiquitin transferase', 141, NULL, NULL, 94062),
(94063, '3.40.50.300-FF-003869', NULL, 'Rbj_C92 protein', 176, NULL, NULL, 94063),
(94064, '1.10.8.870-FF-000007', NULL, 'Glycerol-3-phosphate dehydrogenase', 125, NULL, NULL, 94064),
(94065, '3.30.505.50-FF-000008', NULL, 'Plastid-specific ribosomal protein 1', 48, NULL, NULL, 94065),
(94066, '1.10.418.60-FF-000017', NULL, 'Predicted protein', 165, NULL, NULL, 94066),
(94067, '1.20.120.350-FF-000163', NULL, NULL, 158, NULL, NULL, 94067),
(94068, '3.90.1180.10-FF-000024', NULL, NULL, 172, NULL, NULL, 94068),
(94069, '2.40.110.10-FF-000053', NULL, 'Acyl-CoA dehydrogenase', 110, NULL, NULL, 94069),
(94070, '2.70.98.20-FF-000031', NULL, 'Amine oxidase', 269, NULL, NULL, 94070),
(94071, '2.30.39.10-FF-000129', NULL, 'Serpin, putative', 109, NULL, NULL, 94071),
(94072, '3.20.80.10-FF-000026', NULL, 'Uncharacterized protein', 112, NULL, NULL, 94072),
(94073, '3.40.50.300-FF-005893', NULL, 'HflX family GTPase', 171, NULL, NULL, 94073),
(94074, '3.20.20.70-FF-000456', NULL, 'Uncharacterized protein', 180, NULL, NULL, 94074),
(94075, '2.40.70.10-FF-000420', NULL, NULL, 160, NULL, NULL, 94075),
(94076, '3.30.160.60-FF-004240', NULL, NULL, 46, NULL, NULL, 94076),
(94077, '3.30.1350.10-FF-000001', NULL, 'Hellethionin-D', 46, NULL, NULL, 94077),
(94078, '3.30.40.10-FF-001563', NULL, 'Uncharacterized protein', 98, NULL, NULL, 94078),
(94079, '1.20.1070.10-FF-001630', NULL, 'Growth hormone secretagogue receptor a', 140, NULL, NULL, 94079),
(94080, '1.20.1250.20-FF-001731', NULL, 'Synaptic vesicle glycoprotein 2', 337, NULL, NULL, 94080),
(94081, '1.25.40.10-FF-001788', NULL, 'Pentatricopeptide repeat-containing protein At4g25270, chloroplastic', 170, NULL, NULL, 94081),
(94082, '2.60.40.150-FF-000421', NULL, 'Sperm vesicle fusion protein fer-1', 126, NULL, NULL, 94082),
(94083, '2.40.50.100-FF-000154', NULL, 'Efflux pump, RND family, membrane fusion protein', 47, NULL, NULL, 94083),
(94084, '3.30.70.1470-FF-000012', NULL, 'Uncharacterized protein', 63, NULL, NULL, 94084),
(94085, '2.60.40.10-FF-003638', NULL, NULL, 85, NULL, NULL, 94085),
(94086, '3.30.565.10-FF-000129', NULL, 'Putative sensory histidine kinase in two-component regulatory system', 154, NULL, NULL, 94086),
(94087, '3.40.50.1820-FF-001036', NULL, 'Carboxylesterase 2 (intestine, liver)', 135, NULL, NULL, 94087),
(94088, '2.40.10.10-FF-000383', NULL, NULL, 95, NULL, NULL, 94088),
(94089, '1.25.10.10-FF-002910', NULL, 'Uncharacterized protein', 121, NULL, NULL, 94089),
(94090, '1.25.70.10-FF-000014', NULL, 'Transcription termination factor MTEF18, mitochondrial', 268, NULL, NULL, 94090),
(94091, '1.10.275.60-FF-000005', NULL, 'Adenylosuccinate lyase', 17, NULL, NULL, 94091),
(94092, '3.40.50.300-FF-001868', NULL, 'DNA helicase A', 210, NULL, NULL, 94092),
(94093, '2.60.40.60-FF-000067', NULL, 'FAT atypical cadherin 1', 113, NULL, NULL, 94093),
(94094, '3.90.1260.10-FF-000008', NULL, 'Argininosuccinate synthase', 207, NULL, NULL, 94094),
(94095, '3.30.70.2280-FF-000007', NULL, 'Nucleolar RNA helicase 2', 78, NULL, NULL, 94095),
(94096, '1.50.40.10-FF-000561', NULL, 'Predicted protein', 121, NULL, NULL, 94096),
(94097, '2.60.40.1770-FF-000011', NULL, 'Ephrin receptor like protein', 64, NULL, NULL, 94097),
(94098, '3.90.550.10-FF-000357', NULL, 'Slr2122 protein', 216, NULL, NULL, 94098),
(94099, '1.25.40.10-FF-002412', NULL, 'Pentatricopeptide repeat-containing protein At1g20300, mitochondrial', 128, NULL, NULL, 94099);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(94100, '3.40.50.1440-FF-000045', NULL, 'Tubulin gamma chain', 287, NULL, NULL, 94100),
(94101, '3.40.50.150-FF-000137', NULL, 'protein N-lysine methyltransferase METTL21A', 212, NULL, NULL, 94101),
(94102, '3.30.160.60-FF-000417', NULL, 'Zinc finger protein', 29, NULL, NULL, 94102),
(94103, '2.60.40.150-FF-000073', NULL, 'protein fantom isoform X1', 134, NULL, NULL, 94103),
(94104, '3.40.430.10-FF-000028', NULL, 'Bifunctional dihydrofolate reductase-thymidylate synthase', 186, NULL, NULL, 94104),
(94105, '3.30.40.10-FF-001911', NULL, 'Ring-box 1', 111, NULL, NULL, 94105),
(94106, '3.40.50.2300-FF-000005', NULL, 'Protein argonaute-2', 170, NULL, NULL, 94106),
(94107, '3.40.190.100-FF-000006', NULL, 'Glycine/betaine ABC transporter', 113, NULL, NULL, 94107),
(94108, '3.80.10.10-FF-001194', NULL, 'Leucine-rich receptor-like protein kinase family protein', 162, NULL, NULL, 94108),
(94109, '3.40.50.300-FF-008074', NULL, 'Uncharacterized protein', 118, NULL, NULL, 94109),
(94110, '1.10.1450.10-FF-000037', NULL, 'Tetraspanin', 96, NULL, NULL, 94110),
(94111, '1.25.40.690-FF-000003', NULL, 'Nucleoporin SONB, putative', 91, NULL, NULL, 94111),
(94112, '3.30.70.330-FF-001782', NULL, NULL, 87, NULL, NULL, 94112),
(94113, '2.120.10.80-FF-000208', NULL, 'Carboxymethyl transferase, putative', 240, NULL, NULL, 94113),
(94114, '1.20.58.60-FF-000859', NULL, 'Predicted protein', 127, NULL, NULL, 94114),
(94115, '2.120.10.30-FF-000441', NULL, 'Peptidylglycine alpha-amidating monooxygenase', 117, NULL, NULL, 94115),
(94116, '1.25.40.790-FF-000016', NULL, 'Uncharacterized protein', 139, NULL, NULL, 94116),
(94117, '1.25.10.10-FF-001770', NULL, 'Importin-beta N-terminal domain protein', 912, NULL, NULL, 94117),
(94118, '2.30.39.10-FF-000039', NULL, 'Uncharacterized protein', 140, NULL, NULL, 94118),
(94119, '3.30.160.60-FF-003599', NULL, NULL, 24, NULL, NULL, 94119),
(94120, '1.10.167.10-FF-000054', NULL, 'YALI0E10329p', 102, NULL, NULL, 94120),
(94121, '3.30.70.100-FF-000179', NULL, NULL, 108, NULL, NULL, 94121),
(94122, '1.10.1000.11-FF-000033', NULL, 'Chromosome 19, whole genome shotgun sequence', 146, NULL, NULL, 94122),
(94123, '3.30.160.60-FF-000069', NULL, 'Zinc finger protein 572', 28, NULL, NULL, 94123),
(94124, '1.10.3260.10-FF-000040', NULL, 'AGAP000623-PA', 210, NULL, NULL, 94124),
(94125, '1.10.533.10-FF-000186', NULL, 'Uncharacterized protein', 85, NULL, NULL, 94125),
(94126, '1.20.120.350-FF-000146', NULL, NULL, 124, NULL, NULL, 94126),
(94127, '1.20.1070.10-FF-001293', NULL, 'Predicted protein', 197, NULL, NULL, 94127),
(94128, '3.60.15.10-FF-000020', NULL, 'Class B metallo-beta-lactamase', 230, NULL, NULL, 94128),
(94129, '2.10.60.10-FF-000056', NULL, 'RoBo-1', 79, NULL, NULL, 94129),
(94130, '3.30.200.20-FF-002023', NULL, 'Uncharacterized protein', 92, NULL, NULL, 94130),
(94131, '2.170.16.10-FF-000019', NULL, 'Probable translation initiation factor IF-2', 109, NULL, NULL, 94131),
(94132, '3.40.50.1380-FF-000010', NULL, 'carbamoyl-phosphate synthase [ammonia], mitochondrial', 138, NULL, NULL, 94132),
(94133, '3.30.1330.80-FF-000015', NULL, 'AT-hook motif nuclear-localized protein 17', 125, NULL, NULL, 94133),
(94134, '2.60.120.10-FF-000611', NULL, 'Mannose-6-phosphate isomerase', 96, NULL, NULL, 94134),
(94135, '1.10.287.1040-FF-000007', NULL, 'Exodeoxyribonuclease 7 small subunit', 71, NULL, NULL, 94135),
(94136, '2.130.10.10-FF-002200', NULL, 'Uncharacterized protein', 315, NULL, NULL, 94136),
(94137, '3.10.450.50-FF-000020', NULL, 'Nuclear transport factor 2 protein', 128, NULL, NULL, 94137),
(94138, '3.40.50.2000-FF-000899', NULL, 'UDP-glucose,sterol transferase', 172, NULL, NULL, 94138),
(94139, '3.40.50.300-FF-000441', NULL, 'ADP-ribosylation factor-like protein 8a', 181, NULL, NULL, 94139),
(94140, '3.20.20.70-FF-000546', NULL, NULL, 213, NULL, NULL, 94140),
(94141, '3.65.10.10-FF-000010', NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', 181, NULL, NULL, 94141),
(94142, '3.10.20.30-FF-000107', NULL, NULL, 115, NULL, NULL, 94142),
(94143, '2.60.40.10-FF-000294', NULL, 'Glucans biosynthesis protein G', 114, NULL, NULL, 94143);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(94144, '2.60.40.1460-FF-000013', NULL, 'Integrin alpha-PS1', 162, NULL, NULL, 94144),
(94145, '1.10.10.10-FF-000706', NULL, 'Histone H1 linker', 91, NULL, NULL, 94145),
(94146, '2.10.25.10-FF-001323', NULL, 'Neurogenic locus protein delta-like Protein', 29, NULL, NULL, 94146),
(94147, '3.30.2130.10-FF-000018', NULL, 'Aspartokinase', 146, NULL, NULL, 94147),
(94148, '1.10.3710.10-FF-000013', NULL, 'ATPase, AAA family', 88, NULL, NULL, 94148),
(94149, '3.40.50.720-FF-000679', NULL, 'UDP-glucose 4-epimerase', 317, NULL, NULL, 94149),
(94150, '1.10.418.10-FF-000250', NULL, 'Uncharacterized protein', 99, NULL, NULL, 94150),
(94151, '2.60.40.60-FF-000174', NULL, 'FAT atypical cadherin 4', 98, NULL, NULL, 94151),
(94152, '3.40.47.10-FF-000201', NULL, NULL, 228, NULL, NULL, 94152),
(94153, '2.60.40.60-FF-000522', NULL, 'Protocadherin gamma subfamily C, 4', 107, NULL, NULL, 94153),
(94154, '2.10.25.10-FF-000795', NULL, 'Slit homolog 1 protein', 37, NULL, NULL, 94154),
(94155, '3.30.110.30-FF-000001', NULL, 'Bifunctional glutamate/proline--tRNA ligase', 91, NULL, NULL, 94155),
(94156, '3.40.630.10-FF-000010', NULL, 'Succinyl-diaminopimelate desuccinylase', 121, NULL, NULL, 94156),
(94157, '3.40.1690.10-FF-000007', NULL, 'Type III secretion appartus protein YscU', 144, NULL, NULL, 94157),
(94158, '3.90.70.10-FF-000028', NULL, 'Ubiquitinyl hydrolase 1', 363, NULL, NULL, 94158),
(94159, '1.10.510.10-FF-003966', NULL, NULL, 348, NULL, NULL, 94159),
(94160, '3.15.20.10-FF-000018', NULL, 'Phospholipid transfer protein', 56, NULL, NULL, 94160),
(94161, '3.30.160.60-FF-002851', NULL, NULL, 28, NULL, NULL, 94161),
(94162, '2.30.29.30-FF-000876', NULL, 'Uncharacterized protein', 117, NULL, NULL, 94162),
(94163, '3.40.50.300-FF-004712', NULL, 'Atlastin-like Protein', 315, NULL, NULL, 94163),
(94164, '3.30.110.40-FF-000004', NULL, 'SirA family protein', 71, NULL, NULL, 94164),
(94165, '1.10.30.10-FF-000034', NULL, 'SWI/SNF-related matrix-associated regulator of chromatin subfamily E member 1-related', 90, NULL, NULL, 94165),
(94166, '2.60.120.650-FF-000102', NULL, 'Histone lysine demethylase PHF8', 261, NULL, NULL, 94166),
(94167, '1.20.120.550-FF-000009', NULL, 'YALI0E19745p', 147, NULL, NULL, 94167),
(94168, '2.130.10.10-FF-003689', NULL, 'SCF ubiquitin ligase complex subunit', 197, NULL, NULL, 94168),
(94169, '3.40.50.150-FF-000244', NULL, 'protein-L-isoaspartate(D-aspartate) O-methyltransferase isoform X3', 127, NULL, NULL, 94169),
(94170, '3.40.50.10810-FF-000039', NULL, 'DNA repair protein Rhp26/Rad26', 279, NULL, NULL, 94170),
(94171, '3.30.200.20-FF-001399', NULL, 'Unplaced genomic scaffold supercont2.7, whole genome shotgun sequence', 103, NULL, NULL, 94171),
(94172, '1.10.150.80-FF-000053', NULL, 'Uncharacterized protein', 58, NULL, NULL, 94172),
(94173, '3.30.200.20-FF-001545', NULL, NULL, 139, NULL, NULL, 94173),
(94174, '3.50.50.60-FF-000009', NULL, 'Succinate dehydrogenase flavoprotein subunit', 284, NULL, NULL, 94174),
(94175, '1.10.555.10-FF-000057', NULL, 'Rho GTPase-activating protein', 259, NULL, NULL, 94175),
(94176, '2.40.50.1000-FF-000015', NULL, 'Similar to ribosomal protein S11', 162, NULL, NULL, 94176),
(94177, '1.10.10.10-FF-001786', NULL, 'Neck appendage protein', 125, NULL, NULL, 94177),
(94178, '1.25.40.10-FF-002322', NULL, 'Tetratricopeptide repeat protein 30B', 90, NULL, NULL, 94178),
(94179, '1.20.1640.10-FF-000050', NULL, 'Protein CBR-CHE-14', 168, NULL, NULL, 94179),
(94180, '3.40.50.300-FF-002234', NULL, 'Thymidylate kinase', 202, NULL, NULL, 94180),
(94181, '1.10.510.10-FF-002106', NULL, NULL, 117, NULL, NULL, 94181),
(94182, '1.10.286.20-FF-000013', NULL, NULL, 45, NULL, NULL, 94182),
(94183, '3.30.530.20-FF-000103', NULL, 'StAR-related lipid transfer protein 6', 220, NULL, NULL, 94183),
(94184, '3.40.50.150-FF-000463', NULL, 'Gibberellic acid methyltransferase 2', 202, NULL, NULL, 94184),
(94185, '3.40.50.1100-FF-000191', NULL, 'Uncharacterized protein', 126, NULL, NULL, 94185),
(94186, '1.10.286.10-FF-000010', NULL, 'GTP cyclohydrolase 1', 47, NULL, NULL, 94186),
(94187, '2.60.40.1860-FF-000010', NULL, NULL, 125, NULL, NULL, 94187);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(94188, '3.80.10.10-FF-001284', NULL, 'Leucine-rich repeat kinase, isoform D', 155, NULL, NULL, 94188),
(94189, '3.40.50.450-FF-000036', NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase LOG2', 185, NULL, NULL, 94189),
(94190, '1.10.10.2660-FF-000003', NULL, 'ubiquitin-like modifier-activating enzyme 6 isoform X1', 265, NULL, NULL, 94190),
(94191, '2.130.10.10-FF-004313', NULL, 'Uncharacterized protein', 111, NULL, NULL, 94191),
(94192, '3.10.580.10-FF-000164', NULL, 'Uncharacterized protein (Fragment)', 123, NULL, NULL, 94192),
(94193, '3.90.226.10-FF-000216', NULL, 'Uncharacterized protein', 71, NULL, NULL, 94193),
(94194, '3.30.200.20-FF-001854', NULL, 'Probable serine/threonine-protein kinase DDB_G0278845', 86, NULL, NULL, 94194),
(94195, '3.30.40.10-FF-001237', NULL, 'ORTHRUS-like protein', 122, NULL, NULL, 94195),
(94196, '1.20.1250.20-FF-001405', NULL, 'Monocarboxylate transporter, putative', 186, NULL, NULL, 94196),
(94197, '2.60.40.60-FF-000157', NULL, 'Neural-cadherin', 104, NULL, NULL, 94197),
(94198, '3.30.160.60-FF-006033', NULL, NULL, 79, NULL, NULL, 94198),
(94199, '1.20.58.1000-FF-000003', NULL, 'CopY family transcriptional regulator', 90, NULL, NULL, 94199),
(94200, '3.30.160.60-FF-000378', NULL, 'zinc finger homeobox protein 3', 65, NULL, NULL, 94200),
(94201, '1.25.40.10-FF-003733', NULL, 'Pentatricopeptide repeat-containing protein At4g31850, chloroplastic', 71, NULL, NULL, 94201),
(94202, '2.10.220.10-FF-000080', NULL, 'Fraser extracellular matrix complex subunit 1', 98, NULL, NULL, 94202),
(94203, '3.90.70.10-FF-000247', NULL, 'Ubiquitin hydrolase, putative', 331, NULL, NULL, 94203),
(94204, '1.25.40.10-FF-005285', NULL, 'Protein fem-1 homolog A', 141, NULL, NULL, 94204),
(94205, '2.130.10.10-FF-000507', NULL, 'WD repeat domain 34', 180, NULL, NULL, 94205),
(94206, '2.60.40.1170-FF-000011', NULL, 'Coatomer subunit delta', 116, NULL, NULL, 94206),
(94207, '3.40.33.10-FF-000170', NULL, 'Uncharacterized protein', 99, NULL, NULL, 94207),
(94208, '2.60.40.3210-FF-000027', NULL, 'Uncharacterized protein', 72, NULL, NULL, 94208),
(94209, '2.10.25.10-FF-000469', NULL, 'Latent transforming growth factor beta binding protein 2', 42, NULL, NULL, 94209),
(94210, '1.10.357.70-FF-000002', NULL, 'Exocyst complex component SEC6', 174, NULL, NULL, 94210),
(94211, '1.50.40.10-FF-000342', NULL, 'Calcium-binding mitochondrial carrier protein Aralar1-like Protein', 240, NULL, NULL, 94211),
(94212, '2.40.170.20-FF-000065', NULL, 'Ferrichrome-iron receptor 3', 535, NULL, NULL, 94212),
(94213, '1.10.1420.10-FF-000103', NULL, 'Uncharacterized protein', 122, NULL, NULL, 94213),
(94214, '2.60.40.10-FF-000075', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', 92, NULL, NULL, 94214),
(94215, '1.10.10.2670-FF-000006', NULL, 'Ubiquitin-protein ligase, putative', 97, NULL, NULL, 94215),
(94216, '3.40.720.10-FF-000236', NULL, 'Uncharacterized protein', 178, NULL, NULL, 94216),
(94217, '3.30.40.10-FF-001546', NULL, 'E3 ubiquitin-protein ligase RMA2', 103, NULL, NULL, 94217),
(94218, '3.90.550.10-FF-000048', NULL, 'Glycosyltransferase 25 family member 1', 176, NULL, NULL, 94218),
(94219, '3.30.70.1170-FF-000028', NULL, 'Putative methyltransferase NSUN5C', 26, NULL, NULL, 94219),
(94220, '3.40.1370.10-FF-000051', NULL, 'Uncharacterized protein', 67, NULL, NULL, 94220),
(94221, '3.40.50.2020-FF-000135', NULL, 'Uncharacterized protein', 154, NULL, NULL, 94221),
(94222, '3.30.65.10-FF-000002', NULL, 'DNA topoisomerase 1', 60, NULL, NULL, 94222),
(94223, '3.90.228.10-FF-000069', NULL, 'Poly [ADP-ribose] polymerase', 73, NULL, NULL, 94223),
(94224, '2.130.10.10-FF-005943', NULL, 'Uncharacterized protein', 253, NULL, NULL, 94224),
(94225, '3.40.50.1820-FF-001345', NULL, 'Uncharacterized protein', 245, NULL, NULL, 94225),
(94226, '4.10.410.10-FF-000070', NULL, 'Seminal fluid protein 24Bc', 65, NULL, NULL, 94226),
(94227, '3.40.50.1820-FF-000979', NULL, 'Uncharacterized protein', 257, NULL, NULL, 94227),
(94228, '2.120.10.30-FF-000132', NULL, 'Uncharacterized protein', 246, NULL, NULL, 94228);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(94229, '3.30.160.60-FF-004094', NULL, NULL, 37, NULL, NULL, 94229),
(94230, '3.30.40.10-FF-001456', NULL, 'Uncharacterized RING finger protein C548.05c', 112, NULL, NULL, 94230),
(94231, '1.10.8.60-FF-000529', NULL, 'Uncharacterized protein PEX6', 90, NULL, NULL, 94231),
(94232, '1.25.40.10-FF-005195', NULL, 'Uncharacterized protein', 219, NULL, NULL, 94232),
(94233, '2.60.120.40-FF-000024', NULL, 'erythroferrone isoform X2', 121, NULL, NULL, 94233),
(94234, '1.10.580.10-FF-000025', NULL, 'Citrate synthase', 230, NULL, NULL, 94234),
(94235, '3.30.200.20-FF-001219', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 3', 99, NULL, NULL, 94235),
(94236, '1.10.150.50-FF-000196', NULL, 'Predicted protein', 78, NULL, NULL, 94236),
(94237, '3.30.160.60-FF-002632', NULL, 'Zinc finger protein 646', 31, NULL, NULL, 94237),
(94238, '3.80.10.10-FF-002695', NULL, 'Receptor-like protein kinase HSL1', 74, NULL, NULL, 94238),
(94239, '1.25.40.10-FF-000158', NULL, 'pentatricopeptide repeat-containing protein At2g33680', 227, NULL, NULL, 94239),
(94240, '1.20.1250.20-FF-001624', NULL, 'PTR family peptide transporter, putative', 123, NULL, NULL, 94240),
(94241, '1.20.1270.280-FF-000070', NULL, 'Uncharacterized protein', 119, NULL, NULL, 94241),
(94242, '2.130.10.10-FF-001891', NULL, 'DDB1-and CUL4-associated factor 11 homolog', 267, NULL, NULL, 94242),
(94243, '2.60.40.10-FF-001002', NULL, 'obscurin-like protein 1 isoform X2', 83, NULL, NULL, 94243),
(94244, '1.25.10.10-FF-002601', NULL, 'Uncharacterized protein', 149, NULL, NULL, 94244),
(94245, '1.20.120.350-FF-000056', NULL, 'Two pore segment channel 2', 126, NULL, NULL, 94245),
(94246, '1.20.5.110-FF-000098', NULL, 'Vesicle-associated membrane protein', 86, NULL, NULL, 94246),
(94247, '1.20.1250.20-FF-001315', NULL, 'AGL277Wp', 248, NULL, NULL, 94247),
(94248, '1.10.510.10-FF-002415', NULL, 'Uncharacterized protein', 299, NULL, NULL, 94248),
(94249, '2.60.40.10-FF-003947', NULL, NULL, 105, NULL, NULL, 94249),
(94250, '2.40.20.10-FF-000029', NULL, 'Uncharacterized protein', 77, NULL, NULL, 94250),
(94251, '1.25.40.10-FF-001479', NULL, 'Suppressor of RPS4-RLD 1', 101, NULL, NULL, 94251),
(94252, '2.60.40.790-FF-000146', NULL, NULL, 114, NULL, NULL, 94252),
(94253, '3.90.550.10-FF-000705', NULL, 'Uncharacterized protein', 281, NULL, NULL, 94253),
(94254, '3.30.160.60-FF-000726', NULL, 'Zinc finger protein 214', 28, NULL, NULL, 94254),
(94255, '3.40.50.880-FF-000142', NULL, 'Uncharacterized protein', 168, NULL, NULL, 94255),
(94256, '1.20.58.1880-FF-000002', NULL, 'nuclear receptor corepressor 2 isoform X1', 135, NULL, NULL, 94256),
(94257, '1.10.8.60-FF-000187', NULL, 'Unplaced genomic scaffold supercont1.232, whole genome shotgun sequence', 68, NULL, NULL, 94257),
(94258, '3.10.105.10-FF-000027', NULL, 'Possible conserved lipoprotein', 204, NULL, NULL, 94258),
(94259, '1.25.40.10-FF-002103', NULL, 'Pentatricopeptide repeat-containing protein At1g51965, mitochondrial', 155, NULL, NULL, 94259),
(94260, '1.10.20.10-FF-000342', NULL, NULL, 102, NULL, NULL, 94260),
(94261, '3.30.70.330-FF-001900', NULL, NULL, 80, NULL, NULL, 94261),
(94262, '3.30.160.60-FF-002323', NULL, 'Zinc finger protein 322', 23, NULL, NULL, 94262),
(94263, '3.30.200.20-FF-002040', NULL, NULL, 90, NULL, NULL, 94263),
(94264, '2.40.10.10-FF-000309', NULL, NULL, 152, NULL, NULL, 94264),
(94265, '3.90.190.10-FF-000498', NULL, 'Uncharacterized protein', 148, NULL, NULL, 94265),
(94266, '3.40.30.10-FF-000359', NULL, 'Thioredoxin', 107, NULL, NULL, 94266),
(94267, '2.40.10.170-FF-000021', NULL, 'H(+)-transporting ATP synthase, subunit beta', 83, NULL, NULL, 94267),
(94268, '3.30.420.40-FF-000123', NULL, 'Hexokinase 3', 164, NULL, NULL, 94268),
(94269, '2.10.60.10-FF-000039', NULL, 'Sperm acrosome-associated 4-like', 85, NULL, NULL, 94269),
(94270, '3.40.50.10860-FF-000032', NULL, 'Bifunctional protein FolD', 150, NULL, NULL, 94270),
(94271, '1.25.40.10-FF-000630', NULL, 'Pentatricopeptide repeat-containing protein', 85, NULL, NULL, 94271),
(94272, '3.30.160.60-FF-000833', NULL, 'PR domain zinc finger protein', 34, NULL, NULL, 94272);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(94273, '2.30.30.140-FF-000069', NULL, 'DNA mismatch repair protein', 135, NULL, NULL, 94273),
(94274, '2.60.40.10-FF-000277', NULL, 'Phytanoyl-CoA hydroxylase-interacting protein-like protein', 113, NULL, NULL, 94274),
(94275, '2.10.25.10-FF-001104', NULL, 'Latent transforming growth factor beta binding protein 2', 32, NULL, NULL, 94275),
(94276, '2.130.10.10-FF-005634', NULL, 'Apoptotic protease-activating factor, putative', 177, NULL, NULL, 94276),
(94277, '3.40.50.300-FF-006056', NULL, 'Predicted protein', 154, NULL, NULL, 94277),
(94278, '3.40.50.300-FF-002256', NULL, 'Dynein beta chain, putative', 181, NULL, NULL, 94278),
(94279, '3.30.450.50-FF-000061', NULL, 'Uncharacterized protein', 128, NULL, NULL, 94279),
(94280, '3.40.50.720-FF-000696', NULL, 'GAL80p Transcriptional regulator', 51, NULL, NULL, 94280),
(94281, '3.30.450.40-FF-000147', NULL, 'Heat-inducible transcription repressor HrcA', 130, NULL, NULL, 94281),
(94282, '3.30.60.90-FF-000037', NULL, 'Putative N6-adenosine-methyltransferase with ZZ-type zinc-binding domains', 59, NULL, NULL, 94282),
(94283, '2.70.150.10-FF-000262', NULL, 'Predicted protein', 192, NULL, NULL, 94283),
(94284, '2.10.90.10-FF-000119', NULL, 'Artemin', 97, NULL, NULL, 94284),
(94285, '1.25.40.20-FF-000633', NULL, 'Squamosa promoter-binding-like protein 14', 151, NULL, NULL, 94285),
(94286, '1.10.1200.270-FF-000023', NULL, 'Os11g0260100 protein', 76, NULL, NULL, 94286),
(94287, '3.40.50.300-FF-004510', NULL, 'DNA helicase RecQ', 217, NULL, NULL, 94287),
(94288, '3.10.150.10-FF-000013', NULL, 'Beta sliding clamp', 183, NULL, NULL, 94288),
(94289, '2.10.25.10-FF-001632', NULL, 'Uncharacterized protein', 49, NULL, NULL, 94289),
(94290, '3.30.160.60-FF-003958', NULL, 'zinc finger protein Xfin', 73, NULL, NULL, 94290),
(94291, '3.90.70.10-FF-000045', NULL, 'Ubiquitin carboxyl-terminal hydrolase 16', 281, NULL, NULL, 94291),
(94292, '3.40.50.1440-FF-000028', NULL, 'Tubulin beta chain', 228, NULL, NULL, 94292),
(94293, '3.30.390.60-FF-000007', NULL, 'Heat-inducible transcription repressor HrcA', 102, NULL, NULL, 94293),
(94294, '2.60.40.1090-FF-000009', NULL, 'Fimbrial family protein', 140, NULL, NULL, 94294),
(94295, '1.20.1270.280-FF-000053', NULL, 'Uncharacterized protein', 197, NULL, NULL, 94295),
(94296, '2.60.120.260-FF-000081', NULL, 'Intraflagellar transport protein 25 homolog', 139, NULL, NULL, 94296),
(94297, '3.90.70.10-FF-000573', NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', 427, NULL, NULL, 94297),
(94298, '2.120.10.30-FF-000025', NULL, 'E3 ubiquitin-protein ligase TRIM71', 144, NULL, NULL, 94298),
(94299, '2.30.130.40-FF-000003', NULL, 'Lon protease homolog 2, peroxisomal', 123, NULL, NULL, 94299),
(94300, '2.60.40.790-FF-000163', NULL, NULL, 80, NULL, NULL, 94300),
(94301, '3.60.21.10-FF-000096', NULL, 'Serine/threonine-protein phosphatase', 357, NULL, NULL, 94301),
(94302, '3.90.226.10-FF-000323', NULL, 'Predicted protein', 191, NULL, NULL, 94302),
(94303, '3.30.160.60-FF-004088', NULL, NULL, 80, NULL, NULL, 94303),
(94304, '3.40.50.1820-FF-000648', NULL, '1-acylglycerol-3-phosphate O-acyltransferase ABHD5-like Protein', 285, NULL, NULL, 94304),
(94305, '3.30.310.130-FF-000007', NULL, 'polyhomeotic-proximal chromatin protein isoform X2', 56, NULL, NULL, 94305),
(94306, '3.30.200.20-FF-001528', NULL, NULL, 82, NULL, NULL, 94306),
(94307, '2.30.30.90-FF-000015', NULL, 'Iron/manganese-dependent transcriptional regulator', 71, NULL, NULL, 94307),
(94308, '3.30.1330.20-FF-000019', NULL, 'Cell division protein FtsZ', 120, NULL, NULL, 94308),
(94309, '1.25.40.10-FF-004430', NULL, 'Uncharacterized protein', 123, NULL, NULL, 94309),
(94310, '1.25.10.10-FF-000550', NULL, 'Predicted protein', 314, NULL, NULL, 94310),
(94311, '1.20.1110.10-FF-000167', NULL, NULL, 179, NULL, NULL, 94311),
(94312, '3.40.630.30-FF-000656', NULL, 'Uncharacterized protein', 157, NULL, NULL, 94312),
(94313, '1.20.58.390-FF-000158', NULL, 'Nicotinic acetylcholine receptor subunit', 104, NULL, NULL, 94313),
(94314, '1.20.970.10-FF-000019', NULL, 'Anthranilate phosphoribosyltransferase like', 70, NULL, NULL, 94314);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(94315, '3.80.10.10-FF-003083', NULL, 'Uncharacterized protein', 126, NULL, NULL, 94315),
(94316, '2.60.40.10-FF-002531', NULL, 'Defective proboscis extension response', 107, NULL, NULL, 94316),
(94317, '3.40.50.1000-FF-000470', NULL, 'NLI_interacting_factor-like_phosphatase_-_putative', 221, NULL, NULL, 94317),
(94318, '1.10.437.10-FF-000064', NULL, 'Uncharacterized protein', 169, NULL, NULL, 94318),
(94319, '1.20.1280.50-FF-000174', NULL, 'Uncharacterized protein', 47, NULL, NULL, 94319),
(94320, '3.30.60.20-FF-000022', NULL, 'SH3 and cysteine-rich domain-containing protein 3 isoform 2', 57, NULL, NULL, 94320),
(94321, '2.10.25.10-FF-001093', NULL, 'Stabilin 2', 44, NULL, NULL, 94321),
(94322, '1.10.357.10-FF-000006', NULL, 'TetR family transcriptional regulator', 178, NULL, NULL, 94322),
(94323, '3.40.630.30-FF-000460', NULL, 'Acyl-CoA N-acyltransferase', 174, NULL, NULL, 94323),
(94324, '1.20.58.60-FF-000876', NULL, 'Spectrin beta chain', 121, NULL, NULL, 94324),
(94325, '3.40.50.1240-FF-000103', NULL, 'Multiple inositol polyphosphate phosphatase 1', 422, NULL, NULL, 94325),
(94326, '1.10.510.10-FF-002331', NULL, NULL, 205, NULL, NULL, 94326),
(94327, '3.40.50.1100-FF-000202', NULL, 'Threonine ammonia-lyase', 65, NULL, NULL, 94327),
(94328, '1.50.40.10-FF-000544', NULL, 'Uncharacterized protein', 138, NULL, NULL, 94328),
(94329, '2.40.10.10-FF-000422', NULL, 'GD15727', 236, NULL, NULL, 94329),
(94330, '3.40.50.11040-FF-000013', NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', 175, NULL, NULL, 94330),
(94331, '3.30.160.60-FF-001828', NULL, 'Zinc finger protein-interacting with ribonucleoprotein K', 26, NULL, NULL, 94331),
(94332, '1.10.8.270-FF-000052', NULL, 'Predicted protein', 112, NULL, NULL, 94332),
(94333, '1.10.8.60-FF-000193', NULL, 'AAA ATPase forming ring-shaped complexes', 16, NULL, NULL, 94333),
(94334, '1.25.40.10-FF-001569', NULL, 'RNA polymerase-associated protein CTR9', 190, NULL, NULL, 94334),
(94335, '2.60.40.1080-FF-000006', NULL, 'Beta-galactosidase, putative', 93, NULL, NULL, 94335),
(94336, '3.30.830.10-FF-000027', NULL, 'nardilysin isoform X1', 245, NULL, NULL, 94336),
(94337, '3.40.50.880-FF-000226', NULL, 'Predicted protein', 51, NULL, NULL, 94337),
(94338, '1.10.510.10-FF-000077', NULL, 'Vascular endothelial growth factor receptor 2', 203, NULL, NULL, 94338),
(94339, '3.40.50.2060-FF-000006', NULL, 'Syntaxin binding protein 3', 135, NULL, NULL, 94339),
(94340, '2.70.130.10-FF-000154', NULL, NULL, 132, NULL, NULL, 94340),
(94341, '3.60.21.10-FF-000113', NULL, 'Phosphohydrolase', 263, NULL, NULL, 94341),
(94342, '2.60.120.10-FF-000717', NULL, 'Predicted protein', 245, NULL, NULL, 94342),
(94343, '1.20.1250.20-FF-000927', NULL, 'Drug resistance transporter, EmrB/QacA family', 188, NULL, NULL, 94343),
(94344, '2.60.120.10-FF-000465', NULL, 'Cysteine dioxygenase', 155, NULL, NULL, 94344),
(94345, '3.40.50.720-FF-001314', NULL, 'Uncharacterized protein', 189, NULL, NULL, 94345),
(94346, '2.130.10.10-FF-000255', NULL, 'Periodic tryptophan protein 2 homolog', 210, NULL, NULL, 94346),
(94347, '3.10.130.10-FF-000012', NULL, 'Uncharacterized protein', 48, NULL, NULL, 94347),
(94348, '1.10.10.60-FF-000244', NULL, 'Highly divergent homeobox', 65, NULL, NULL, 94348),
(94349, '2.60.40.10-FF-002418', NULL, 'Uncharacterized protein', 95, NULL, NULL, 94349),
(94350, '3.30.70.1230-FF-000182', NULL, 'Adenylyl cyclase class-3/4/guanylyl cyclase', 176, NULL, NULL, 94350),
(94351, '3.30.830.10-FF-000134', NULL, 'Putative mitochondrial-processing peptidase subunit alpha-2 chloroplastic/mitochondrial', 170, NULL, NULL, 94351),
(94352, '3.40.50.10420-FF-000029', NULL, '5-formyltetrahydrofolate cyclo-ligase', 180, NULL, NULL, 94352),
(94353, '2.40.100.10-FF-000108', NULL, 'Peptidyl-prolyl cis-trans isomerase, putative', 99, NULL, NULL, 94353),
(94354, '2.10.220.10-FF-000113', NULL, 'Uncharacterized protein', 105, NULL, NULL, 94354),
(94355, '2.10.25.10-FF-000486', NULL, 'Protein delta homolog 1', 40, NULL, NULL, 94355),
(94356, '3.40.50.150-FF-001683', NULL, NULL, 132, NULL, NULL, 94356);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(94357, '3.10.20.90-FF-000625', NULL, 'Uncharacterized protein', 75, NULL, NULL, 94357),
(94358, '1.10.510.10-FF-000386', NULL, 'serine/threonine-protein kinase LMTK2 isoform X1', 284, NULL, NULL, 94358),
(94359, '3.20.20.10-FF-000028', NULL, 'Putative diaminopimelate decarboxylase', 230, NULL, NULL, 94359),
(94360, '3.30.9.10-FF-000215', NULL, 'Glycerol-3-phosphate dehydrogenase', 63, NULL, NULL, 94360),
(94361, '3.30.60.30-FF-000025', NULL, 'Follistatin-related protein 3', 76, NULL, NULL, 94361),
(94362, '3.90.79.10-FF-000222', NULL, 'Uncharacterized protein', 177, NULL, NULL, 94362),
(94363, '1.10.2000.10-FF-000049', NULL, NULL, 132, NULL, NULL, 94363),
(94364, '2.60.40.10-FF-005656', NULL, NULL, 89, NULL, NULL, 94364),
(94365, '2.10.25.10-FF-000379', NULL, 'Cubilin', 39, NULL, NULL, 94365),
(94366, '3.40.980.10-FF-000002', NULL, 'Molybdopterin molybdenumtransferase', 188, NULL, NULL, 94366),
(94367, '2.40.50.140-FF-001189', NULL, NULL, 128, NULL, NULL, 94367),
(94368, '3.20.20.140-FF-000447', NULL, 'Uncharacterized protein', 70, NULL, NULL, 94368),
(94369, '3.90.1750.10-FF-000057', NULL, 'HECT-domain (Ubiquitin-transferase), putative', 166, NULL, NULL, 94369),
(94370, '1.10.287.110-FF-000177', NULL, 'DnaJ heat shock protein family (Hsp40) member C19', 53, NULL, NULL, 94370),
(94371, '1.10.510.10-FF-000616', NULL, 'Uncharacterized protein', 344, NULL, NULL, 94371),
(94372, '3.40.50.12780-FF-000198', NULL, 'Firefly luciferase, putative', 396, NULL, NULL, 94372),
(94373, '2.60.40.10-FF-004352', NULL, NULL, 106, NULL, NULL, 94373),
(94374, '3.40.1050.10-FF-000009', NULL, 'Carbonic anhydrase', 217, NULL, NULL, 94374),
(94375, '3.40.640.10-FF-000370', NULL, 'Uncharacterized protein', 201, NULL, NULL, 94375),
(94376, '3.30.200.20-FF-002242', NULL, NULL, 31, NULL, NULL, 94376),
(94377, '3.40.50.2300-FF-001495', NULL, NULL, 119, NULL, NULL, 94377),
(94378, '2.40.10.10-FF-000057', NULL, 'Zgc:100868', 242, NULL, NULL, 94378),
(94379, '1.10.418.10-FF-000143', NULL, 'Zygote defective protein 12', 154, NULL, NULL, 94379),
(94380, '2.40.170.20-FF-000048', NULL, 'Ferrichrome iron receptor', 537, NULL, NULL, 94380),
(94381, '3.10.20.90-FF-000844', NULL, 'UBX domain-containing protein 4', 84, NULL, NULL, 94381),
(94382, '1.25.10.10-FF-001966', NULL, 'Protein CELLULOSE SYNTHASE INTERACTIVE 1', 208, NULL, NULL, 94382),
(94383, '3.40.50.200-FF-000175', NULL, 'Predicted protein', 343, NULL, NULL, 94383),
(94384, '2.40.33.10-FF-000003', NULL, 'Pyruvate kinase', 94, NULL, NULL, 94384),
(94385, '3.40.50.740-FF-000016', NULL, 'NADH dehydrogenase (Quinone), G subunit', 108, NULL, NULL, 94385),
(94386, '2.10.25.10-FF-000688', NULL, 'Neurogenic locus notch homolog protein 1', 41, NULL, NULL, 94386),
(94387, '1.10.510.10-FF-002640', NULL, NULL, 27, NULL, NULL, 94387),
(94388, '1.20.1250.20-FF-001641', NULL, 'Quinate permease', 493, NULL, NULL, 94388),
(94389, '1.50.40.10-FF-000235', NULL, 'Mitochondrial carrier protein (Rim2), putative (AFU_orthologue AFUA_3G06950)', 106, NULL, NULL, 94389),
(94390, '2.130.10.10-FF-000036', NULL, 'Neurobeachin isoform A', 270, NULL, NULL, 94390),
(94391, '3.90.79.10-FF-000109', NULL, 'MutT/nudix family protein', 145, NULL, NULL, 94391),
(94392, '2.130.10.10-FF-004330', NULL, 'Uncharacterized protein', 100, NULL, NULL, 94392),
(94393, '2.40.30.10-FF-000530', NULL, 'Uncharacterized protein', 88, NULL, NULL, 94393),
(94394, '2.60.40.10-FF-004661', NULL, NULL, 102, NULL, NULL, 94394),
(94395, '4.10.1240.10-FF-000047', NULL, 'Parathyroid hormone receptor like 2', 109, NULL, NULL, 94395),
(94396, '3.40.50.720-FF-000010', NULL, 'Malate dehydrogenase', 153, NULL, NULL, 94396),
(94397, '3.10.20.310-FF-000006', NULL, 'Cell division protein FtsQ', 70, NULL, NULL, 94397),
(94398, '3.40.50.2300-FF-001506', NULL, NULL, 103, NULL, NULL, 94398),
(94399, '1.10.238.230-FF-000001', NULL, 'Serine/threonine-protein phosphatase 2A regulatory subunit B'''' subunit beta', 102, NULL, NULL, 94399),
(94400, '3.40.50.11030-FF-000010', NULL, 'Threonylcarbamoyl-AMP synthase', 106, NULL, NULL, 94400),
(94401, '3.90.70.10-FF-000354', NULL, 'Protein CBG17829', 121, NULL, NULL, 94401);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(94402, '2.130.10.10-FF-004307', NULL, 'Uncharacterized protein', 114, NULL, NULL, 94402),
(94403, '3.30.70.340-FF-000037', NULL, NULL, 90, NULL, NULL, 94403),
(94404, '3.40.630.10-FF-000009', NULL, 'N-acetylated-alpha-linked acidic dipeptidase 2', 292, NULL, NULL, 94404),
(94405, '1.10.510.10-FF-001111', NULL, 'Protein kinase superfamily protein', 91, NULL, NULL, 94405),
(94406, '3.30.420.40-FF-000432', NULL, 'Heat shock protein 70 putative', 186, NULL, NULL, 94406),
(94407, '3.40.250.10-FF-000239', NULL, 'Sulfurtransferase', 156, NULL, NULL, 94407),
(94408, '3.30.160.60-FF-002216', NULL, 'Zinc finger protein 555', 30, NULL, NULL, 94408),
(94409, '3.40.50.300-FF-004167', NULL, 'Uncharacterized protein', 152, NULL, NULL, 94409),
(94410, '1.10.20.10-FF-000207', NULL, NULL, 94, NULL, NULL, 94410),
(94411, '3.30.160.60-FF-000524', NULL, 'Zinc finger protein 155', 28, NULL, NULL, 94411),
(94412, '3.80.10.10-FF-000587', NULL, 'NLR family pyrin domain containing 4', 398, NULL, NULL, 94412),
(94413, '3.90.230.10-FF-000013', NULL, 'DNA-binding protein, 42 kDa', 271, NULL, NULL, 94413),
(94414, '1.10.472.80-FF-000267', NULL, NULL, 135, NULL, NULL, 94414),
(94415, '1.10.10.60-FF-000025', NULL, 'Mesoderm induction early response 1, transcriptional regulator', 68, NULL, NULL, 94415),
(94416, '2.60.40.10-FF-004329', NULL, NULL, 84, NULL, NULL, 94416),
(94417, '3.30.200.20-FF-001635', NULL, 'STE20-related kinase adapter protein alpha', 91, NULL, NULL, 94417),
(94418, '2.160.20.70-FF-000042', NULL, 'AFL149Cp', 140, NULL, NULL, 94418),
(94419, '3.40.50.300-FF-008416', NULL, 'Uncharacterized protein', 131, NULL, NULL, 94419),
(94420, '3.40.50.300-FF-000435', NULL, 'Ferrichrome ABC transporter, ATP-binding protein FhuC', 260, NULL, NULL, 94420),
(94421, '1.10.150.650-FF-000008', NULL, 'PHP domain protein', 72, NULL, NULL, 94421),
(94422, '3.30.499.10-FF-000048', NULL, NULL, 95, NULL, NULL, 94422),
(94423, '3.30.70.330-FF-000034', NULL, 'heterogeneous nuclear ribonucleoprotein M isoform X1', 80, NULL, NULL, 94423),
(94424, '1.10.150.80-FF-000047', NULL, 'AFL159Wp', 80, NULL, NULL, 94424),
(94425, '3.40.50.10130-FF-000049', NULL, 'Uncharacterized protein', 44, NULL, NULL, 94425),
(94426, '3.10.110.10-FF-000213', NULL, 'Ubiquitin-conjugating enzyme family protein', 108, NULL, NULL, 94426),
(94427, '1.25.10.10-FF-000802', NULL, 'Serine/threonine-protein kinase TOR', 177, NULL, NULL, 94427),
(94428, '3.30.420.10-FF-000687', NULL, NULL, 135, NULL, NULL, 94428),
(94429, '3.40.50.880-FF-000007', NULL, 'Peptidase E', 229, NULL, NULL, 94429),
(94430, '1.25.40.10-FF-003716', NULL, 'Putative pentatricopeptide repeat-containing protein', 80, NULL, NULL, 94430),
(94431, '3.90.70.10-FF-000264', NULL, 'Ubiquitin carboxyl-terminal hydrolase, putative', 339, NULL, NULL, 94431),
(94432, '3.90.550.10-FF-000161', NULL, 'Probable mannosyltransferase KTR7', 381, NULL, NULL, 94432),
(94433, '1.20.5.110-FF-000244', NULL, 'Uncharacterized protein', 102, NULL, NULL, 94433),
(94434, '2.130.10.10-FF-006022', NULL, 'Uncharacterized protein', 169, NULL, NULL, 94434),
(94435, '1.10.10.10-FF-000061', NULL, 'HTH-type transcriptional regulator ArgP', 77, NULL, NULL, 94435),
(94436, '3.30.160.60-FF-005398', NULL, NULL, 23, NULL, NULL, 94436),
(94437, '1.10.533.10-FF-000219', NULL, 'Predicted protein', 96, NULL, NULL, 94437),
(94438, '1.10.510.10-FF-002550', NULL, 'Uncharacterized protein', 284, NULL, NULL, 94438),
(94439, '3.40.50.300-FF-006421', NULL, 'Uncharacterized protein', 129, NULL, NULL, 94439),
(94440, '1.20.1250.20-FF-001080', NULL, 'WGS project CABT00000000 data, contig 2.12', 420, NULL, NULL, 94440),
(94441, '1.20.5.340-FF-000043', NULL, 'Transcriptional repressor TUP1', 92, NULL, NULL, 94441),
(94442, '1.20.1440.130-FF-000002', NULL, 'vitamin K epoxide reductase complex subunit 1-like protein 1', 107, NULL, NULL, 94442),
(94443, '1.10.287.70-FF-000766', NULL, 'Sodium channel protein', 130, NULL, NULL, 94443),
(94444, '3.30.810.10-FF-000026', NULL, 'Phosphatidylinositol-5-phosphate 4-kinase, type II, alpha a', 72, NULL, NULL, 94444);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(94445, '1.25.40.10-FF-001934', NULL, 'Unplaced genomic scaffold supercont1.111, whole genome shotgun sequence', 138, NULL, NULL, 94445),
(94446, '1.10.10.10-FF-000712', NULL, 'HTH-type transcriptional regulator', 82, NULL, NULL, 94446),
(94447, '3.10.450.50-FF-000014', NULL, 'Phenazine biosynthesis protein PhzB 2', 141, NULL, NULL, 94447),
(94448, '3.40.50.1820-FF-001362', NULL, 'GPI inositol-deacylase', 231, NULL, NULL, 94448),
(94449, '2.60.40.10-FF-000620', NULL, 'Immunoglobulin lambda locus', 109, NULL, NULL, 94449),
(94450, '3.40.1580.10-FF-000004', NULL, 'Uncharacterized protein', 95, NULL, NULL, 94450),
(94451, '1.10.1410.10-FF-000063', NULL, 'Terminal uridylyltransferase 3, putative', 223, NULL, NULL, 94451),
(94452, '1.20.1070.10-FF-001068', NULL, 'Neuropeptide FF receptor 2', 330, NULL, NULL, 94452),
(94453, '2.60.40.10-FF-000058', NULL, 'roundabout homolog 2 isoform X3', 124, NULL, NULL, 94453),
(94454, '3.40.50.300-FF-000126', NULL, 'Galactose/methyl galactoside import ATP-binding protein MglA', 242, NULL, NULL, 94454),
(94455, '3.40.50.10470-FF-000038', NULL, 'Putative methylthioribose-1-phosphate isomerase', 156, NULL, NULL, 94455),
(94456, '1.20.1250.20-FF-001169', NULL, 'Uncharacterized protein', 240, NULL, NULL, 94456),
(94457, '3.40.50.410-FF-000159', NULL, 'Calcium voltage-gated channel auxiliary subunit alpha2delta 2', 128, NULL, NULL, 94457),
(94458, '1.10.10.10-FF-001707', NULL, 'LysR family transcriptional regulator', 87, NULL, NULL, 94458),
(94459, '2.30.180.10-FF-000155', NULL, NULL, 137, NULL, NULL, 94459),
(94460, '2.10.220.10-FF-000079', NULL, 'Furin-like protease 2', 51, NULL, NULL, 94460),
(94461, '1.10.132.60-FF-000005', NULL, 'Putative DNA polymerase zeta catalytic subunit', 153, NULL, NULL, 94461),
(94462, '3.30.200.20-FF-000550', NULL, 'Serine/threonine-protein kinase greatwall', 84, NULL, NULL, 94462),
(94463, '3.40.50.200-FF-000085', NULL, 'Uncharacterized protein', 143, NULL, NULL, 94463),
(94464, '3.40.50.1460-FF-000057', NULL, 'Uncharacterized protein', 254, NULL, NULL, 94464),
(94465, '3.40.50.1000-FF-000251', NULL, 'Phosphatidylglycerophosphatase GEP4, mitochondrial', 171, NULL, NULL, 94465),
(94466, '3.80.10.10-FF-002588', NULL, 'Serine/threonine-protein kinase BRI1-like 1', 93, NULL, NULL, 94466),
(94467, '3.30.70.330-FF-001119', NULL, 'Cold sensitive u2 snRNA suppressor', 141, NULL, NULL, 94467),
(94468, '3.30.930.10-FF-000299', NULL, 'Phenylalanine--tRNA ligase beta subunit', 192, NULL, NULL, 94468),
(94469, '3.30.230.130-FF-000084', NULL, 'Uncharacterized protein', 153, NULL, NULL, 94469),
(94470, '1.20.5.190-FF-000071', NULL, 'Class V myosin', 48, NULL, NULL, 94470),
(94471, '3.30.60.30-FF-000244', NULL, 'Uncharacterized protein', 45, NULL, NULL, 94471),
(94472, '3.90.226.10-FF-000014', NULL, 'ATP-dependent Clp protease proteolytic subunit', 185, NULL, NULL, 94472),
(94473, '3.80.10.10-FF-000210', NULL, 'leucine-rich repeat serine/threonine-protein kinase 1', 136, NULL, NULL, 94473),
(94474, '1.10.132.70-FF-000008', NULL, 'Telomerase reverse transcriptase', 228, NULL, NULL, 94474),
(94475, '3.40.50.10190-FF-000281', NULL, 'Uncharacterized protein', 121, NULL, NULL, 94475),
(94476, '1.10.287.1490-FF-000120', NULL, 'Phosphatidylinositol 3-kinase regulatory subunit alpha-like Protein', 155, NULL, NULL, 94476),
(94477, '2.60.40.10-FF-005965', NULL, NULL, 70, NULL, NULL, 94477),
(94478, '3.20.20.140-FF-000195', NULL, 'PHP C-terminal domain protein', 229, NULL, NULL, 94478),
(94479, '1.10.455.10-FF-000004', NULL, '28S ribosomal protein S7, mitochondrial', 169, NULL, NULL, 94479),
(94480, '2.60.120.620-FF-000144', NULL, 'Zgc:174917', 135, NULL, NULL, 94480),
(94481, '3.30.70.330-FF-001647', NULL, NULL, 106, NULL, NULL, 94481),
(94482, '2.40.70.10-FF-000504', NULL, NULL, 107, NULL, NULL, 94482),
(94483, '1.25.10.10-FF-000241', NULL, 'Putative importin subunit beta-4', 1009, NULL, NULL, 94483),
(94484, '2.60.40.150-FF-000218', NULL, 'Protein kinase C', 134, NULL, NULL, 94484),
(94485, '2.10.90.10-FF-000086', NULL, 'Vascular endothelial growth factor c', 171, NULL, NULL, 94485);
INSERT INTO "PUBLIC"."MODEL" VALUES
(94486, '3.10.20.90-FF-000064', NULL, 'Putative ubiquitin carboxyl-terminal hydrolase 7', 116, NULL, NULL, 94486),
(94487, '1.20.1070.10-FF-001304', NULL, 'Uncharacterized protein', 287, NULL, NULL, 94487),
(94488, '3.20.20.80-FF-000684', NULL, 'Predicted protein', 319, NULL, NULL, 94488),
(94489, '3.30.565.10-FF-000040', NULL, 'Sensor histidine kinase DpiB', 132, NULL, NULL, 94489),
(94490, '1.20.1260.140-FF-000003', NULL, 'Ubiquinol oxidase', 260, NULL, NULL, 94490),
(94491, '3.30.2350.20-FF-000004', NULL, 'pseudouridylate synthase 7 homolog-like protein', 221, NULL, NULL, 94491),
(94492, '1.10.287.110-FF-000407', NULL, 'Predicted protein', 107, NULL, NULL, 94492),
(94493, '3.30.530.20-FF-000119', NULL, 'Kirola', 150, NULL, NULL, 94493),
(94494, '1.25.40.10-FF-004211', NULL, 'Putative UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SEC', 60, NULL, NULL, 94494),
(94495, '1.10.565.10-FF-000086', NULL, 'Nuclear receptor subfamily 1, group H, member 5', 248, NULL, NULL, 94495),
(94496, '3.40.720.10-FF-000129', NULL, 'Protein CBG23355', 299, NULL, NULL, 94496),
(94497, '3.30.1330.120-FF-000001', NULL, '2-methylcitrate dehydratase', 142, NULL, NULL, 94497),
(94498, '2.170.150.80-FF-000017', NULL, 'Os05g0415400 protein', 158, NULL, NULL, 94498),
(94499, '1.10.220.160-FF-000030', NULL, NULL, 92, NULL, NULL, 94499),
(94500, '2.60.40.10-FF-002109', NULL, 'Kekkon-1, isoform B', 109, NULL, NULL, 94500),
(94501, '1.10.238.10-FF-000500', NULL, 'CALmodulin related genes', 72, NULL, NULL, 94501),
(94502, '3.40.630.30-FF-000095', NULL, 'Histone acetyltransferase, ELP3 family', 149, NULL, NULL, 94502),
(94503, '2.40.110.10-FF-000070', NULL, 'Blr0119 protein', 44, NULL, NULL, 94503),
(94504, '3.30.2350.10-FF-000001', NULL, 'H/ACA ribonucleoprotein complex subunit CBF5', 207, NULL, NULL, 94504),
(94505, '3.40.50.1440-FF-000051', NULL, 'Tubulin-like protein CetZ', 229, NULL, NULL, 94505),
(94506, '3.30.420.10-FF-000581', NULL, NULL, 217, NULL, NULL, 94506),
(94507, '2.60.120.310-FF-000023', NULL, 'Uncharacterized protein', 49, NULL, NULL, 94507),
(94508, '3.40.30.10-FF-000668', NULL, 'DNaJ domain (Prokaryotic heat shock protein)', 111, NULL, NULL, 94508),
(94509, '3.40.950.10-FF-000028', NULL, NULL, 192, NULL, NULL, 94509),
(94510, '1.25.10.10-FF-002129', NULL, 'Coatomer subunit gamma', 164, NULL, NULL, 94510),
(94511, '3.20.20.70-FF-000681', NULL, NULL, 197, NULL, NULL, 94511),
(94512, '3.40.50.12650-FF-000029', NULL, 'DNA repair protein, putative (AFU_orthologue AFUA_1G04570)', 32, NULL, NULL, 94512),
(94513, '3.40.50.720-FF-001084', NULL, 'Short-subunit dehydrogenase involved in D-alanine esterification of teichoic acids', 248, NULL, NULL, 94513),
(94514, '3.30.890.10-FF-000019', NULL, 'Methyl-CpG-binding domain-containing protein 7', 56, NULL, NULL, 94514),
(94515, '1.10.533.10-FF-000113', NULL, 'Baculoviral IAP repeat-containing 3', 129, NULL, NULL, 94515),
(94516, '3.20.20.70-FF-000439', NULL, 'Triosephosphate isomerase', 275, NULL, NULL, 94516),
(94517, '1.20.1250.20-FF-001170', NULL, 'Uncharacterized protein', 132, NULL, NULL, 94517),
(94518, '2.60.40.10-FF-002312', NULL, 'Beta-galactosidase', 123, NULL, NULL, 94518),
(94519, '3.40.190.80-FF-000075', NULL, 'Protein CBG13639', 73, NULL, NULL, 94519),
(94520, '1.25.40.20-FF-000942', NULL, 'Uncharacterized protein', 138, NULL, NULL, 94520),
(94521, '3.40.50.2300-FF-000112', NULL, 'Uncharacterized protein', 162, NULL, NULL, 94521),
(94522, '3.90.1410.10-FF-000043', NULL, 'Expressed protein', 287, NULL, NULL, 94522),
(94523, '3.30.160.60-FF-003020', NULL, 'Zinc finger protein 674', 27, NULL, NULL, 94523),
(94524, '3.30.62.10-FF-000001', NULL, 'Protein Nef', 150, NULL, NULL, 94524),
(94525, '2.40.10.10-FF-000276', NULL, NULL, 47, NULL, NULL, 94525),
(94526, '2.170.180.11-FF-000005', NULL, 'Methuselah-like 1, isoform B', 109, NULL, NULL, 94526),
(94527, '1.10.533.10-FF-000203', NULL, 'CARD15', 92, NULL, NULL, 94527),
(94528, '3.30.160.60-FF-001598', NULL, 'Zinc finger protein 467', 28, NULL, NULL, 94528),
(94529, '3.10.50.40-FF-000045', NULL, 'Peptidyl-prolyl cis-trans isomerase', 137, NULL, NULL, 94529);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(94530, '3.40.50.1110-FF-000059', NULL, 'SGNH hydrolase', 254, NULL, NULL, 94530),
(94531, '3.30.559.30-FF-000065', NULL, 'Uncharacterized protein', 156, NULL, NULL, 94531),
(94532, '1.20.120.1050-FF-000003', NULL, 'Nucleoporin NUP170, putative', 174, NULL, NULL, 94532),
(94533, '3.40.50.1820-FF-001143', NULL, 'AGAP011681-PA', 179, NULL, NULL, 94533),
(94534, '3.90.190.10-FF-000279', NULL, 'Serine/threonine/tyrosine interacting protein', 103, NULL, NULL, 94534),
(94535, '3.40.50.1100-FF-000056', NULL, 'Threonine synthase', 224, NULL, NULL, 94535),
(94536, '3.30.40.10-FF-000130', NULL, 'E3 ubiquitin-protein ligase TRIM23', 84, NULL, NULL, 94536),
(94537, '3.80.10.10-FF-001205', NULL, 'serine/threonine-protein kinase 11-interacting protein isoform X1', 301, NULL, NULL, 94537),
(94538, '3.30.160.60-FF-000272', NULL, 'Zinc finger protein 827', 25, NULL, NULL, 94538),
(94539, '1.10.3420.10-FF-000002', NULL, 'Uncharacterized protein', 148, NULL, NULL, 94539),
(94540, '1.20.120.1070-FF-000009', NULL, 'Translation initiation factor eIF-2B alpha subunit, putative', 116, NULL, NULL, 94540),
(94541, '3.60.21.10-FF-000422', NULL, 'Serine/threonine-protein phosphatase', 394, NULL, NULL, 94541),
(94542, '1.20.58.390-FF-000052', NULL, 'Cholinergic receptor nicotinic alpha 1 subunit', 141, NULL, NULL, 94542),
(94543, '2.60.120.10-FF-000156', NULL, 'cAMP-dependent protein kinase regulatory subunit', 127, NULL, NULL, 94543),
(94544, '1.25.40.10-FF-001715', NULL, 'Pentatricopeptide repeat-containing protein', 98, NULL, NULL, 94544),
(94545, '3.30.160.60-FF-004324', NULL, NULL, 57, NULL, NULL, 94545),
(94546, '1.10.510.10-FF-003944', NULL, NULL, 60, NULL, NULL, 94546),
(94547, '3.20.20.80-FF-000774', NULL, 'Predicted protein', 302, NULL, NULL, 94547),
(94548, '1.10.730.10-FF-000150', NULL, 'Valyl tRNA Synthetase', 64, NULL, NULL, 94548),
(94549, '3.90.1410.10-FF-000133', NULL, 'Uncharacterized protein', 271, NULL, NULL, 94549),
(94550, '2.60.40.1170-FF-000033', NULL, 'stonin-2 isoform X3', 119, NULL, NULL, 94550),
(94551, '3.40.50.1820-FF-000957', NULL, 'Alpha/beta hydrolase fold protein', 287, NULL, NULL, 94551),
(94552, '1.10.238.10-FF-000045', NULL, 'Nucleobindin 2', 103, NULL, NULL, 94552),
(94553, '1.25.40.10-FF-004121', NULL, 'Uncharacterized protein', 127, NULL, NULL, 94553),
(94554, '1.10.8.480-FF-000014', NULL, 'rRNA adenine N(6)-methyltransferase', 98, NULL, NULL, 94554),
(94555, '2.120.10.30-FF-000334', NULL, 'Uncharacterized protein', 187, NULL, NULL, 94555),
(94556, '2.40.30.170-FF-000002', NULL, 'p-hydroxybenzoic acid efflux pump subunit AaeA', 127, NULL, NULL, 94556),
(94557, '3.40.630.10-FF-000341', NULL, 'Uncharacterized protein', 249, NULL, NULL, 94557),
(94558, '3.20.20.70-FF-000771', NULL, NULL, 320, NULL, NULL, 94558),
(94559, '3.30.160.60-FF-005869', NULL, NULL, 51, NULL, NULL, 94559),
(94560, '3.90.1480.20-FF-000067', NULL, 'Uncharacterized protein', 110, NULL, NULL, 94560),
(94561, '1.20.1630.10-FF-000004', NULL, 'Polysulphide reductase NrfD', 279, NULL, NULL, 94561),
(94562, '3.40.30.10-FF-000253', NULL, 'Peroxiredoxin 2', 130, NULL, NULL, 94562),
(94563, '3.40.120.10-FF-000016', NULL, 'Glucose 1,6-bisphosphate synthase', 182, NULL, NULL, 94563),
(94564, '4.10.410.10-FF-000069', NULL, 'Collagen, type VII, alpha 1', 68, NULL, NULL, 94564),
(94565, '1.20.58.570-FF-000004', NULL, NULL, 62, NULL, NULL, 94565),
(94566, '2.40.160.210-FF-000005', NULL, 'Acyl-CoA thioesterase', 335, NULL, NULL, 94566),
(94567, '3.40.50.2000-FF-001068', NULL, 'Uncharacterized protein', 77, NULL, NULL, 94567),
(94568, '1.10.238.20-FF-000048', NULL, 'Odorant-binding protein 47a, isoform B', 111, NULL, NULL, 94568),
(94569, '2.130.10.10-FF-002076', NULL, 'WGS project CABT00000000 data, contig 2.8', 107, NULL, NULL, 94569),
(94570, '2.60.40.1180-FF-000036', NULL, 'Probable alpha-L-arabinofuranosidase A', 104, NULL, NULL, 94570),
(94571, '3.30.160.60-FF-003397', NULL, 'GD20620', 27, NULL, NULL, 94571),
(94572, '1.10.510.10-FF-003489', NULL, NULL, 357, NULL, NULL, 94572),
(94573, '2.40.30.180-FF-000005', NULL, 'Ubiquitin-activating enzyme e1, putative', 100, NULL, NULL, 94573);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(94574, '1.10.10.440-FF-000034', NULL, 'Formin binding protein (FNB3)', 74, NULL, NULL, 94574),
(94575, '2.130.10.10-FF-000401', NULL, 'Cilia- and flagella-associated protein 44', 290, NULL, NULL, 94575),
(94576, '2.60.40.150-FF-000308', NULL, 'CRE-SNT-4 protein', 140, NULL, NULL, 94576),
(94577, '1.10.132.50-FF-000002', NULL, 'V-type proton ATPase subunit', 115, NULL, NULL, 94577),
(94578, '1.20.120.230-FF-000020', NULL, 'Catenin alpha', 112, NULL, NULL, 94578),
(94579, '1.10.1420.10-FF-000092', NULL, 'DNA mismatch repair protein MSH2, putative', 126, NULL, NULL, 94579),
(94580, '1.25.10.10-FF-002039', NULL, 'eIF-2-alpha kinase activator GCN1', 307, NULL, NULL, 94580),
(94581, '3.30.60.20-FF-000151', NULL, 'Ankyrin repeat-containing protein kinase A', 77, NULL, NULL, 94581),
(94582, '1.20.58.530-FF-000021', NULL, 'Myosin E, putative', 149, NULL, NULL, 94582),
(94583, '1.10.418.60-FF-000001', NULL, 'NDC80 kinetochore complex component NUF2', 167, NULL, NULL, 94583),
(94584, '4.10.60.10-FF-000017', NULL, 'zinc finger CCHC domain-containing protein 9', 46, NULL, NULL, 94584),
(94585, '3.40.50.1010-FF-000164', NULL, NULL, 204, NULL, NULL, 94585),
(94586, '3.30.2410.10-FF-000057', NULL, 'Neural precursor cell expressed, developmentally down-regulated 4-like, E3 ubiquitin protein ligase', 38, NULL, NULL, 94586),
(94587, '3.30.60.30-FF-000154', NULL, 'Serine-type endopeptidase inhibitor', 49, NULL, NULL, 94587),
(94588, '2.60.120.380-FF-000038', NULL, 'Serine protease', 106, NULL, NULL, 94588),
(94589, '3.90.1140.10-FF-000050', NULL, 'U6 snRNA phosphodiesterase', 211, NULL, NULL, 94589),
(94590, '1.20.5.820-FF-000001', NULL, 'Transport protein Sec61 subunit gamma', 62, NULL, NULL, 94590),
(94591, '2.60.40.10-FF-002222', NULL, 'KETtiN (Drosophila actin-binding) homolog', 100, NULL, NULL, 94591),
(94592, '1.10.1620.20-FF-000003', NULL, 'Mitochondrial ATP synthase epsilon chain domain-containing protein', 58, NULL, NULL, 94592),
(94593, '1.20.58.670-FF-000012', NULL, NULL, 69, NULL, NULL, 94593),
(94594, '1.10.287.500-FF-000002', NULL, 'Protein phosphatase CheZ', 129, NULL, NULL, 94594),
(94595, '3.40.50.1000-FF-000161', NULL, 'Trehalose 6-phosphate phosphatase', 98, NULL, NULL, 94595),
(94596, '3.40.630.30-FF-000347', NULL, 'N-acetyltransferase aca1', 223, NULL, NULL, 94596),
(94597, '3.40.50.720-FF-002388', NULL, 'Uncharacterized protein', 133, NULL, NULL, 94597),
(94598, '1.10.506.10-FF-000056', NULL, 'Probable Ras GTPase-activating-like protein ngap', 178, NULL, NULL, 94598),
(94599, '2.130.10.10-FF-002531', NULL, 'WD repeat-containing protein 90', 213, NULL, NULL, 94599),
(94600, '3.40.50.300-FF-002930', NULL, 'ABC transporter family protein', 236, NULL, NULL, 94600),
(94601, '2.30.42.10-FF-000024', NULL, 'rap guanine nucleotide exchange factor 2 isoform X1', 94, NULL, NULL, 94601),
(94602, '1.20.58.1120-FF-000039', NULL, NULL, 139, NULL, NULL, 94602),
(94603, '3.10.20.90-FF-000316', NULL, 'ubiquitin carboxyl-terminal hydrolase 7', 98, NULL, NULL, 94603),
(94604, '1.10.8.870-FF-000024', NULL, 'Glycerol-3-phosphate dehydrogenase', 123, NULL, NULL, 94604),
(94605, '2.30.29.30-FF-000769', NULL, 'Uncharacterized protein', 225, NULL, NULL, 94605),
(94606, '1.10.510.10-FF-004130', NULL, NULL, 92, NULL, NULL, 94606),
(94607, '1.10.730.10-FF-000060', NULL, 'Leucyl-tRNA synthetase', 191, NULL, NULL, 94607),
(94608, '1.20.1070.10-FF-000596', NULL, 'Protein CBG18476', 315, NULL, NULL, 94608),
(94609, '3.40.30.10-FF-000472', NULL, 'Protein CBG04233', 85, NULL, NULL, 94609),
(94610, '1.10.287.690-FF-000002', NULL, 'DNA polymerase zeta', 59, NULL, NULL, 94610),
(94611, '3.30.565.10-FF-000130', NULL, 'Sensor histidine kinase', 147, NULL, NULL, 94611),
(94612, '2.130.10.10-FF-003925', NULL, 'Uncharacterized protein', 260, NULL, NULL, 94612),
(94613, '3.40.30.10-FF-000814', NULL, 'Glutathione S-transferase', 91, NULL, NULL, 94613),
(94614, '1.20.58.80-FF-000073', NULL, 'Predicted protein', 117, NULL, NULL, 94614),
(94615, '1.25.10.10-FF-000331', NULL, 'Phosphoprotein phosphatase, putative', 391, NULL, NULL, 94615);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(94616, '1.10.3720.10-FF-000042', NULL, 'sn-glycerol-3-phosphate transport system permease protein UgpE', 273, NULL, NULL, 94616),
(94617, '1.10.238.10-FF-000135', NULL, 'RAS guanyl-releasing protein 2 isoform X1', 79, NULL, NULL, 94617),
(94618, '3.40.50.300-FF-006308', NULL, 'Uncharacterized protein', 46, NULL, NULL, 94618),
(94619, '2.40.20.10-FF-000030', NULL, 'Uncharacterized protein', 80, NULL, NULL, 94619),
(94620, '3.30.420.40-FF-000319', NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', 70, NULL, NULL, 94620),
(94621, '3.30.505.10-FF-000154', NULL, 'E3 ubiquitin-protein ligase CBL', 87, NULL, NULL, 94621),
(94622, '4.10.400.10-FF-000333', NULL, 'Vitellogenin receptor', 39, NULL, NULL, 94622),
(94623, '3.40.50.10610-FF-000007', NULL, 'Adenylate cyclase', 132, NULL, NULL, 94623),
(94624, '3.40.1010.10-FF-000013', NULL, 'Uroporphyrinogen-III synthase /uroporphyrinogen-III C-methyltransferase', 141, NULL, NULL, 94624),
(94625, '2.20.70.10-FF-000022', NULL, 'Rho GTPase activating protein 39', 51, NULL, NULL, 94625),
(94626, '3.30.40.10-FF-000849', NULL, 'Pep7p', 83, NULL, NULL, 94626),
(94627, '2.40.50.150-FF-000028', NULL, 'DNA-directed RNA polymerase subunit beta', 124, NULL, NULL, 94627),
(94628, '3.30.160.60-FF-004015', NULL, NULL, 29, NULL, NULL, 94628),
(94629, '2.130.10.10-FF-002840', NULL, 'Uncharacterized protein', 358, NULL, NULL, 94629),
(94630, '2.40.160.20-FF-000019', NULL, 'Outer membrane porin F', 190, NULL, NULL, 94630),
(94631, '3.40.50.300-FF-008220', NULL, 'Predicted protein', 65, NULL, NULL, 94631),
(94632, '3.50.50.60-FF-000010', NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', 232, NULL, NULL, 94632),
(94633, '3.60.21.10-FF-000080', NULL, 'Serine/threonine-protein phosphatase', 302, NULL, NULL, 94633),
(94634, '3.40.50.300-FF-002565', NULL, 'Cysteine ABC transporter ATP-binding protein', 233, NULL, NULL, 94634),
(94635, '2.40.30.10-FF-000165', NULL, 'Elongation factor 1 alpha-like protein', 106, NULL, NULL, 94635),
(94636, '3.40.50.1000-FF-000722', NULL, NULL, 91, NULL, NULL, 94636),
(94637, '1.10.357.20-FF-000009', NULL, 'Magnesium transporter MgtE', 178, NULL, NULL, 94637),
(94638, '3.40.50.880-FF-000120', NULL, '4-methyl-5(B-hydroxyethyl)-thiazole monophosphate biosynthesis enzyme', 205, NULL, NULL, 94638),
(94639, '1.20.1310.20-FF-000045', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 125, NULL, NULL, 94639),
(94640, '1.25.10.10-FF-000022', NULL, 'protein EXPORTIN 1A', 1057, NULL, NULL, 94640),
(94641, '3.40.50.300-FF-008310', NULL, 'Nuclear GTPase, germinal center-associated, tandem duplicate 1', 258, NULL, NULL, 94641),
(94642, '2.60.200.20-FF-000165', NULL, 'FHA domain containing protein, putative', 109, NULL, NULL, 94642),
(94643, '3.10.100.10-FF-000263', NULL, NULL, 153, NULL, NULL, 94643),
(94644, '3.90.1750.10-FF-000080', NULL, 'Uncharacterized protein', 35, NULL, NULL, 94644),
(94645, '1.10.560.10-FF-000024', NULL, 'T-complex protein 1 subunit delta', 25, NULL, NULL, 94645),
(94646, '3.30.70.1230-FF-000069', NULL, 'Adenylyl CYclase', 238, NULL, NULL, 94646),
(94647, '3.90.190.10-FF-000189', NULL, 'Predicted protein', 240, NULL, NULL, 94647),
(94648, '3.90.79.10-FF-000003', NULL, 'M7GpppN-mRNA hydrolase isoform 2', 146, NULL, NULL, 94648),
(94649, '3.50.50.100-FF-000007', NULL, 'Rotenone-insensitive NADH-ubiquinone oxidoreductase, mitochondrial', 460, NULL, NULL, 94649),
(94650, '2.30.30.30-FF-000132', NULL, 'Ribosomal protein L2', 95, NULL, NULL, 94650),
(94651, '3.40.50.300-FF-006275', NULL, 'Uncharacterized protein', 293, NULL, NULL, 94651),
(94652, '4.10.60.10-FF-000040', NULL, 'Uncharacterized protein', 75, NULL, NULL, 94652),
(94653, '2.40.30.10-FF-000075', NULL, 'Translation initiation factor 2 subunit gamma', 94, NULL, NULL, 94653),
(94654, '3.30.70.330-FF-001086', NULL, 'Chromosome 1, whole genome shotgun sequence', 96, NULL, NULL, 94654),
(94655, '1.20.58.70-FF-000070', NULL, 'Uncharacterized protein', 193, NULL, NULL, 94655),
(94656, '3.60.21.10-FF-000332', NULL, 'Uncharacterized protein', 298, NULL, NULL, 94656);
INSERT INTO "PUBLIC"."MODEL" VALUES
(94657, '1.25.40.20-FF-000072', NULL, 'Ankyrin repeat and LEM domain containing 2', 168, NULL, NULL, 94657),
(94658, '3.30.360.10-FF-000070', NULL, 'Oxidoreductase, putative', 211, NULL, NULL, 94658),
(94659, '3.40.50.300-FF-006617', NULL, 'Uncharacterized protein', 94, NULL, NULL, 94659),
(94660, '2.60.40.1860-FF-000009', NULL, 'Peptidylarginine deiminase type I', 118, NULL, NULL, 94660),
(94661, '1.20.1270.50-FF-000016', NULL, 'Lysosomal alpha-mannosidase, putative', 41, NULL, NULL, 94661),
(94662, '1.20.58.390-FF-000142', NULL, 'Uncharacterized protein', 125, NULL, NULL, 94662),
(94663, '3.30.1120.10-FF-000063', NULL, 'Predicted protein', 52, NULL, NULL, 94663),
(94664, '1.20.1070.10-FF-001214', NULL, 'Uncharacterized protein', 268, NULL, NULL, 94664),
(94665, '3.40.50.1820-FF-000980', NULL, 'Protein ABHD11', 257, NULL, NULL, 94665),
(94666, '1.20.1070.10-FF-001523', NULL, 'Uncharacterized protein', 189, NULL, NULL, 94666),
(94667, '2.60.40.4070-FF-000010', NULL, 'Basal-body rod modification protein FlgD', 88, NULL, NULL, 94667),
(94668, '2.30.30.40-FF-000135', NULL, '55 kDa erythrocyte membrane protein', 96, NULL, NULL, 94668),
(94669, '2.60.40.150-FF-000527', NULL, 'Uncharacterized protein', 173, NULL, NULL, 94669),
(94670, '1.10.540.10-FF-000135', NULL, 'Acyl-CoA dehydrogenase', 78, NULL, NULL, 94670),
(94671, '3.10.129.10-FF-000020', NULL, 'Acyl-coenzyme A thioesterase 11', 155, NULL, NULL, 94671),
(94672, '3.40.30.10-FF-000781', NULL, 'Sulfhydryl oxidase', 130, NULL, NULL, 94672),
(94673, '1.20.1310.10-FF-000042', NULL, 'Putative cullin-1', 139, NULL, NULL, 94673),
(94674, '2.40.50.140-FF-000115', NULL, '28S ribosomal protein S12, mitochondrial', 109, NULL, NULL, 94674),
(94675, '1.25.40.20-FF-000381', NULL, 'KiDINs220 (Vertebrate scaffold protein) homolog', 79, NULL, NULL, 94675),
(94676, '3.30.70.330-FF-001338', NULL, 'RNA binding (RRM/RBD/RNP motifs) family protein', 162, NULL, NULL, 94676),
(94677, '1.10.510.10-FF-002095', NULL, NULL, 75, NULL, NULL, 94677),
(94678, '2.120.10.80-FF-000231', NULL, 'Serine/threonine-protein phosphatase', 174, NULL, NULL, 94678),
(94679, '3.30.160.60-FF-002205', NULL, 'Zinc finger transcription factor YY1', 68, NULL, NULL, 94679),
(94680, '3.40.50.300-FF-007927', NULL, 'Uncharacterized protein', 173, NULL, NULL, 94680),
(94681, '3.40.50.12650-FF-000046', NULL, 'Uncharacterized protein', 34, NULL, NULL, 94681),
(94682, '1.10.10.60-FF-000148', NULL, 'Dek, isoform B', 67, NULL, NULL, 94682),
(94683, '3.30.160.60-FF-004329', NULL, NULL, 27, NULL, NULL, 94683),
(94684, '3.30.200.20-FF-001758', NULL, 'RIKEN cDNA E030030I06 gene', 74, NULL, NULL, 94684),
(94685, '3.30.40.10-FF-001445', NULL, 'Uncharacterized protein', 92, NULL, NULL, 94685),
(94686, '1.10.510.10-FF-002084', NULL, NULL, 96, NULL, NULL, 94686),
(94687, '3.20.20.70-FF-000557', NULL, 'Glycolate oxidase', 367, NULL, NULL, 94687),
(94688, '1.25.40.20-FF-000291', NULL, 'APSES transcription factor, putative', 234, NULL, NULL, 94688),
(94689, '3.80.10.10-FF-003318', NULL, 'Toll-like receptor 20, tandem duplicate 2', 312, NULL, NULL, 94689),
(94690, '3.40.50.2300-FF-001517', NULL, NULL, 91, NULL, NULL, 94690),
(94691, '3.20.20.210-FF-000024', NULL, 'Os03g0340001 protein', 155, NULL, NULL, 94691),
(94692, '1.10.167.10-FF-000065', NULL, 'Uncharacterized protein', 179, NULL, NULL, 94692),
(94693, '3.40.50.300-FF-008433', NULL, 'Uncharacterized protein', 89, NULL, NULL, 94693),
(94694, '3.30.1120.10-FF-000068', NULL, 'Arylsulfatase I-like Protein', 102, NULL, NULL, 94694),
(94695, '1.20.1250.20-FF-001630', NULL, 'Uncharacterized protein', 108, NULL, NULL, 94695),
(94696, '3.30.420.610-FF-000013', NULL, 'Putative endonuclease or glycosyl hydrolase', 69, NULL, NULL, 94696),
(94697, '3.20.20.220-FF-000027', NULL, 'Proline dehydrogenase 2', 285, NULL, NULL, 94697),
(94698, '3.40.30.90-FF-000001', NULL, 'Eukaryotic translation elongation factor 1 epsilon-1', 55, NULL, NULL, 94698),
(94699, '1.10.8.10-FF-000088', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 58, NULL, NULL, 94699),
(94700, '2.70.170.10-FF-000027', NULL, 'Ligand-Gated ion Channel', 214, NULL, NULL, 94700);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(94701, '3.90.550.10-FF-000144', NULL, 'Glycogenin 1', 189, NULL, NULL, 94701),
(94702, '1.20.120.350-FF-000157', NULL, NULL, 63, NULL, NULL, 94702),
(94703, '3.40.50.300-FF-006404', NULL, 'Uncharacterized protein', 132, NULL, NULL, 94703),
(94704, '1.50.40.10-FF-000095', NULL, 'Mitochondrial carrier protein', 155, NULL, NULL, 94704),
(94705, '2.70.150.10-FF-000032', NULL, 'Phospholipid-transporting ATPase', 177, NULL, NULL, 94705),
(94706, '3.30.530.20-FF-000007', NULL, 'Major pollen allergen Bet v 1-A', 159, NULL, NULL, 94706),
(94707, '3.80.10.10-FF-001183', NULL, 'Predicted protein', 96, NULL, NULL, 94707),
(94708, '1.25.40.10-FF-001917', NULL, 'Uncharacterized protein', 146, NULL, NULL, 94708),
(94709, '2.40.30.130-FF-000024', NULL, 'Alanine--tRNA ligase', 115, NULL, NULL, 94709),
(94710, '3.10.490.10-FF-000044', NULL, 'Gamma-glutamylcyclotransferase', 183, NULL, NULL, 94710),
(94711, '3.40.50.300-FF-002026', NULL, 'DEAD-box helicase 51', 184, NULL, NULL, 94711),
(94712, '1.10.510.10-FF-004219', NULL, NULL, 209, NULL, NULL, 94712),
(94713, '1.10.238.10-FF-000034', NULL, 'Calmodulin', 71, NULL, NULL, 94713),
(94714, '3.30.160.60-FF-002194', NULL, 'STP1p Transcription factor', 86, NULL, NULL, 94714),
(94715, '3.40.30.10-FF-000129', NULL, 'Chloride intracellular channel protein 1', 97, NULL, NULL, 94715),
(94716, '3.40.50.2000-FF-000011', NULL, 'Glycogen synthase', 261, NULL, NULL, 94716),
(94717, '3.90.70.10-FF-000820', NULL, 'Uncharacterized protein', 193, NULL, NULL, 94717),
(94718, '3.40.395.10-FF-000029', NULL, 'Clan CE, family C48, Ulp1-like cysteine peptidase', 194, NULL, NULL, 94718),
(94719, '3.40.50.300-FF-004055', NULL, 'E3 ubiquitin-protein ligase Mdm2', 212, NULL, NULL, 94719),
(94720, '3.40.50.2300-FF-000320', NULL, 'Two-component response regulator:antitermination factor NasT', 135, NULL, NULL, 94720),
(94721, '3.30.60.30-FF-000249', NULL, 'Uncharacterized protein', 42, NULL, NULL, 94721),
(94722, '3.50.50.60-FF-001319', NULL, 'Putatibe oxidoreductase', 203, NULL, NULL, 94722),
(94723, '2.60.40.60-FF-000056', NULL, 'protocadherin-15 isoform X1', 110, NULL, NULL, 94723),
(94724, '1.20.1090.10-FF-000001', NULL, 'Aldehyde-alcohol dehydrogenase', 199, NULL, NULL, 94724),
(94725, '2.30.30.140-FF-000198', NULL, 'RING finger protein 17', 100, NULL, NULL, 94725),
(94726, '3.30.497.10-FF-000100', NULL, 'Serpin peptidase inhibitor 4', 206, NULL, NULL, 94726),
(94727, '3.30.160.60-FF-004234', NULL, NULL, 30, NULL, NULL, 94727),
(94728, '1.25.40.20-FF-000386', NULL, 'Avo2p', 199, NULL, NULL, 94728),
(94729, '1.25.10.10-FF-001983', NULL, 'Uncharacterized protein', 133, NULL, NULL, 94729),
(94730, '3.40.350.10-FF-000050', NULL, 'Probable Xaa-Pro aminopeptidase pepP', 162, NULL, NULL, 94730),
(94731, '3.40.50.10470-FF-000033', NULL, 'Translation initiation factor eIF-2B subunit alpha, putative', 236, NULL, NULL, 94731),
(94732, '2.40.50.1060-FF-000011', NULL, 'Predicted protein', 168, NULL, NULL, 94732),
(94733, '2.20.25.90-FF-000020', NULL, NULL, 56, NULL, NULL, 94733),
(94734, '3.40.1110.10-FF-000195', NULL, 'Metal cation transporter P-type ATPase CtpV', 122, NULL, NULL, 94734),
(94735, '1.20.140.10-FF-000092', NULL, 'Acyl CoA DeHydrogenase', 129, NULL, NULL, 94735),
(94736, '3.40.50.10310-FF-000013', NULL, 'Creatininase', 205, NULL, NULL, 94736),
(94737, '3.40.50.300-FF-005792', NULL, 'Uncharacterized protein', 67, NULL, NULL, 94737),
(94738, '2.60.40.10-FF-000518', NULL, 'Myosin-binding protein C, cardiac-type', 131, NULL, NULL, 94738),
(94739, '2.30.31.10-FF-000016', NULL, 'Putative RNA polymerase II transcriptional coactivator', 72, NULL, NULL, 94739),
(94740, '3.90.79.10-FF-000126', NULL, 'Nucleoside diphosphate-linked moiety X motif 8', 185, NULL, NULL, 94740),
(94741, '3.40.470.10-FF-000008', NULL, 'Uracil-DNA glycosylase', 219, NULL, NULL, 94741),
(94742, '3.40.140.10-FF-000236', NULL, 'Lys-63-specific deubiquitinase BRCC36-like Protein', 166, NULL, NULL, 94742),
(94743, '1.20.58.80-FF-000056', NULL, 'Spastin', 95, NULL, NULL, 94743),
(94744, '2.20.70.10-FF-000112', NULL, 'Yorkie, isoform G', 42, NULL, NULL, 94744);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(94745, '1.20.1070.10-FF-000798', NULL, 'Zg06', 211, NULL, NULL, 94745),
(94746, '3.40.50.10330-FF-000019', NULL, 'NAD kinase 2, chloroplastic', 169, NULL, NULL, 94746),
(94747, '2.60.40.10-FF-004801', NULL, NULL, 107, NULL, NULL, 94747),
(94748, '2.20.90.10-FF-000012', NULL, 'Vitellogenin 3, phosvitinless', 175, NULL, NULL, 94748),
(94749, '1.20.1070.10-FF-001315', NULL, 'Uncharacterized protein', 103, NULL, NULL, 94749),
(94750, '1.20.1600.10-FF-000047', NULL, 'Similar to AprF-putative outer membrane efflux protein or secreted alkaline phosphatase', 461, NULL, NULL, 94750),
(94751, '2.170.150.80-FF-000034', NULL, 'Putative NAC domain transcription factor superfamily protein', 157, NULL, NULL, 94751),
(94752, '3.40.50.300-FF-005578', NULL, 'XPD (Xeroderma Pigmentosum complementation group D) related', 137, NULL, NULL, 94752),
(94753, '3.40.50.150-FF-000710', NULL, 'N2,N2-dimethylguanosine tRNA methyltransferase,putative', 255, NULL, NULL, 94753),
(94754, '3.30.70.670-FF-000001', NULL, 'Formimidoyltransferase cyclodeaminase', 145, NULL, NULL, 94754),
(94755, '3.30.200.20-FF-001079', NULL, 'Serine/threonine protein kinase, STE20 family', 103, NULL, NULL, 94755),
(94756, '2.130.10.10-FF-000159', NULL, 'Autophagy-related protein 16-1 isoform 1', 231, NULL, NULL, 94756),
(94757, '2.60.40.10-FF-000732', NULL, 'Interleukin 31 receptor A', 88, NULL, NULL, 94757),
(94758, '3.40.50.1000-FF-000812', NULL, NULL, 126, NULL, NULL, 94758),
(94759, '3.30.160.60-FF-002531', NULL, 'Uncharacterized protein, isoform A', 27, NULL, NULL, 94759),
(94760, '1.10.30.10-FF-000045', NULL, 'Transcription factor A, mitochondrial', 109, NULL, NULL, 94760),
(94761, '3.30.40.10-FF-001771', NULL, 'Uncharacterized protein', 86, NULL, NULL, 94761),
(94762, '3.30.559.30-FF-000082', NULL, 'Bacitracin synthetase 1, BacA', 267, NULL, NULL, 94762),
(94763, '2.130.10.10-FF-005286', NULL, 'Uncharacterized protein', 228, NULL, NULL, 94763),
(94764, '3.30.2170.10-FF-000021', NULL, NULL, 40, NULL, NULL, 94764),
(94765, '1.10.510.10-FF-004124', NULL, NULL, 96, NULL, NULL, 94765),
(94766, '1.10.555.10-FF-000265', NULL, NULL, 77, NULL, NULL, 94766),
(94767, '1.10.150.250-FF-000012', NULL, NULL, 73, NULL, NULL, 94767),
(94768, '2.80.10.50-FF-000269', NULL, 'Uncharacterized protein', 115, NULL, NULL, 94768),
(94769, '1.10.150.50-FF-000185', NULL, 'Caskin-1', 71, NULL, NULL, 94769),
(94770, '2.60.40.10-FF-004122', NULL, NULL, 92, NULL, NULL, 94770),
(94771, '1.10.510.10-FF-000734', NULL, 'Checkpoint protein kinase (SldA), putative', 351, NULL, NULL, 94771),
(94772, '2.40.30.10-FF-000182', NULL, 'NADH-cytochrome b5 reductase', 115, NULL, NULL, 94772),
(94773, '3.30.1370.10-FF-000002', NULL, 'poly(RC)-binding protein 2 isoform X1', 79, NULL, NULL, 94773),
(94774, '1.20.58.970-FF-000001', NULL, 'Mite allergen Blo t 5', 101, NULL, NULL, 94774),
(94775, '2.60.40.10-FF-003958', NULL, NULL, 104, NULL, NULL, 94775),
(94776, '3.30.1370.30-FF-000008', NULL, 'Unplaced genomic scaffold supercont2.18, whole genome shotgun sequence', 79, NULL, NULL, 94776),
(94777, '2.60.40.630-FF-000020', NULL, 'Signal transducer and activator of transcription', 48, NULL, NULL, 94777),
(94778, '1.10.533.10-FF-000220', NULL, 'Predicted protein', 96, NULL, NULL, 94778),
(94779, '2.160.10.10-FF-000130', NULL, 'UTP--glucose-1-phosphate uridylyltransferase', 123, NULL, NULL, 94779),
(94780, '2.60.120.40-FF-000013', NULL, 'CD40 ligand', 146, NULL, NULL, 94780),
(94781, '3.90.70.10-FF-000141', NULL, 'ubiquitin carboxyl-terminal hydrolase 32 isoform X3', 114, NULL, NULL, 94781),
(94782, '2.40.10.10-FF-000405', NULL, NULL, 103, NULL, NULL, 94782),
(94783, '1.10.8.270-FF-000035', NULL, 'Cell cycle arrest protein BUB2', 104, NULL, NULL, 94783),
(94784, '3.40.50.1820-FF-001704', NULL, 'Undecaprenyl pyrophosphate synthetase, putative', 170, NULL, NULL, 94784),
(94785, '3.20.20.80-FF-000791', NULL, 'Uncharacterized protein', 179, NULL, NULL, 94785),
(94786, '3.30.70.330-FF-001327', NULL, 'Serine/arginine-rich SC35-like splicing factor SCL28', 146, NULL, NULL, 94786),
(94787, '1.20.1250.20-FF-001293', NULL, 'Uncharacterized protein', 211, NULL, NULL, 94787);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(94788, '1.20.1250.20-FF-000899', NULL, 'MFS transporter of unkown specificity', 223, NULL, NULL, 94788),
(94789, '1.10.390.10-FF-000078', NULL, 'AT07704p', 145, NULL, NULL, 94789),
(94790, '3.10.20.90-FF-000075', NULL, 'sorting nexin-27 isoform X2', 94, NULL, NULL, 94790),
(94791, '1.20.58.70-FF-000053', NULL, 'Uncharacterized protein', 119, NULL, NULL, 94791),
(94792, '2.60.40.790-FF-000040', NULL, 'Calcyclin binding protein', 103, NULL, NULL, 94792),
(94793, '3.40.30.10-FF-000455', NULL, 'Glutathione S-transferase kappa 1', 133, NULL, NULL, 94793),
(94794, '1.10.10.60-FF-000362', NULL, 'Chitin synthase 6', 63, NULL, NULL, 94794),
(94795, '3.90.1410.10-FF-000150', NULL, 'Uncharacterized protein', 220, NULL, NULL, 94795),
(94796, '2.40.100.10-FF-000131', NULL, 'Peptidylprolyl isomerase (cyclophilin)-like 2', 138, NULL, NULL, 94796),
(94797, '1.10.287.110-FF-000317', NULL, 'DnaJ domain containing protein, putative', 105, NULL, NULL, 94797),
(94798, '3.10.290.10-FF-000063', NULL, 'Ribosomal protein S9', 74, NULL, NULL, 94798),
(94799, '2.10.50.10-FF-000095', NULL, 'Ovarian TNF receptor', 62, NULL, NULL, 94799),
(94800, '1.25.40.70-FF-000047', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', 210, NULL, NULL, 94800),
(94801, '3.30.160.60-FF-000277', NULL, 'Zinc finger protein 48', 28, NULL, NULL, 94801),
(94802, '3.40.30.10-FF-000808', NULL, 'Uncharacterized protein', 76, NULL, NULL, 94802),
(94803, '1.20.120.1080-FF-000029', NULL, 'Probable pre-mRNA-splicing factor ATP-dependent RNA helicase DEAH4', 102, NULL, NULL, 94803),
(94804, '3.60.40.10-FF-000359', NULL, 'Protein phosphatase, Mg2+/Mn2+-dependent 1J', 382, NULL, NULL, 94804),
(94805, '2.40.70.10-FF-000302', NULL, NULL, 168, NULL, NULL, 94805),
(94806, '1.25.40.10-FF-003834', NULL, 'Predicted protein', 124, NULL, NULL, 94806),
(94807, '3.30.60.30-FF-000042', NULL, 'Serine protease inhibitor dipetalogastin', 50, NULL, NULL, 94807),
(94808, '2.80.10.50-FF-000174', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 43, NULL, NULL, 94808),
(94809, '2.80.10.50-FF-000062', NULL, 'Fibroblast growth factor 23', 155, NULL, NULL, 94809),
(94810, '3.40.50.620-FF-000559', NULL, 'Putative nicotinamide mononucleotide adenylyltransferase', 218, NULL, NULL, 94810),
(94811, '2.60.120.10-FF-000807', NULL, 'Uncharacterized protein', 118, NULL, NULL, 94811),
(94812, '1.25.40.10-FF-000057', NULL, 'RNA polymerase II associated protein 3', 128, NULL, NULL, 94812),
(94813, '2.60.40.3500-FF-000013', NULL, NULL, 104, NULL, NULL, 94813),
(94814, '2.30.29.30-FF-000758', NULL, 'E3 SUMO-protein ligase RanBP2-like', 92, NULL, NULL, 94814),
(94815, '3.30.2310.20-FF-000013', NULL, 'Toxin', 96, NULL, NULL, 94815),
(94816, '1.10.506.10-FF-000062', NULL, 'Uncharacterized protein', 373, NULL, NULL, 94816),
(94817, '2.60.40.150-FF-000213', NULL, 'Phosphatidylinositol-4-phosphate 3-kinase catalytic subunit type 2 gamma', 143, NULL, NULL, 94817),
(94818, '3.40.605.10-FF-000047', NULL, 'Aldehyde dehydrogenase, putative', 259, NULL, NULL, 94818),
(94819, '1.10.20.10-FF-000117', NULL, 'Nuclear factor Y, subunit C13', 92, NULL, NULL, 94819),
(94820, '3.15.20.10-FF-000024', NULL, 'Uncharacterized protein', 173, NULL, NULL, 94820),
(94821, '3.30.9.10-FF-000294', NULL, 'D-amino acid oxidase, putative', 74, NULL, NULL, 94821),
(94822, '2.60.40.150-FF-000325', NULL, 'synaptotagmin-17 isoform X4', 100, NULL, NULL, 94822),
(94823, '2.40.10.170-FF-000026', NULL, 'Uncharacterized protein', 60, NULL, NULL, 94823),
(94824, '1.25.40.10-FF-002423', NULL, 'Os12g0109800 protein', 112, NULL, NULL, 94824),
(94825, '3.40.50.1820-FF-001025', NULL, 'Uncharacterized protein', 184, NULL, NULL, 94825),
(94826, '2.130.10.10-FF-002060', NULL, 'Protein CBG03993', 147, NULL, NULL, 94826),
(94827, '3.10.105.10-FF-000038', NULL, 'Peptide/nickel transport system substrate-binding protein', 217, NULL, NULL, 94827),
(94828, '3.30.60.20-FF-000134', NULL, 'Protein kinase C', 48, NULL, NULL, 94828),
(94829, '1.10.287.70-FF-000457', NULL, 'Predicted protein', 141, NULL, NULL, 94829),
(94830, '1.10.533.10-FF-000315', NULL, 'Uncharacterized protein', 19, NULL, NULL, 94830);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(94831, '2.60.40.60-FF-000168', NULL, 'Cadherin-related family member 2', 113, NULL, NULL, 94831),
(94832, '2.40.50.100-FF-000025', NULL, 'UPF0194 membrane protein YbhG', 35, NULL, NULL, 94832),
(94833, '3.30.160.60-FF-001688', NULL, 'Zgc:171727', 27, NULL, NULL, 94833),
(94834, '3.30.60.30-FF-000137', NULL, 'Reversion-inducing cysteine-rich protein with Kazal motifs', 40, NULL, NULL, 94834),
(94835, '1.10.290.10-FF-000014', NULL, 'DNA topoisomerase', 88, NULL, NULL, 94835),
(94836, '1.10.780.10-FF-000001', NULL, 'Hydroxylamine oxidoreductase', 238, NULL, NULL, 94836),
(94837, '3.30.70.330-FF-000130', NULL, 'Differentiation 1 negative regulator', 83, NULL, NULL, 94837),
(94838, '3.40.50.300-FF-006730', NULL, 'Uncharacterized protein', 71, NULL, NULL, 94838),
(94839, '3.40.950.10-FF-000039', NULL, NULL, 108, NULL, NULL, 94839),
(94840, '2.60.40.3510-FF-000016', NULL, 'Delta-like protein', 160, NULL, NULL, 94840),
(94841, '3.30.70.240-FF-000007', NULL, 'Translation factor GUF1, mitochondrial', 113, NULL, NULL, 94841),
(94842, '1.10.20.10-FF-000331', NULL, NULL, 116, NULL, NULL, 94842),
(94843, '2.60.120.260-FF-000204', NULL, 'UvrB/uvrC motif family protein', 149, NULL, NULL, 94843),
(94844, '1.20.1070.10-FF-001192', NULL, 'Uncharacterized protein', 171, NULL, NULL, 94844),
(94845, '3.90.70.10-FF-000606', NULL, 'Ubiquitinyl hydrolase 1', 175, NULL, NULL, 94845),
(94846, '2.30.30.140-FF-000086', NULL, 'PHD finger protein 1', 52, NULL, NULL, 94846),
(94847, '1.10.510.10-FF-004450', NULL, NULL, 34, NULL, NULL, 94847),
(94848, '2.60.40.60-FF-000382', NULL, 'Cadherin 23', 108, NULL, NULL, 94848),
(94849, '3.40.50.300-FF-002705', NULL, 'Midasin', 155, NULL, NULL, 94849),
(94850, '3.40.1160.10-FF-000029', NULL, 'Glutamate 5-kinase', 68, NULL, NULL, 94850),
(94851, '2.60.40.10-FF-000311', NULL, 'Down syndrome cell adhesion molecule, isoform D', 98, NULL, NULL, 94851),
(94852, '3.40.50.1100-FF-000180', NULL, 'Putative cysteine synthase A CysK2', 186, NULL, NULL, 94852),
(94853, '3.40.50.720-FF-001174', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(P)+]', 122, NULL, NULL, 94853),
(94854, '1.25.10.10-FF-002242', NULL, 'Uncharacterized protein', 378, NULL, NULL, 94854),
(94855, '2.130.10.10-FF-003936', NULL, 'Uncharacterized protein', 253, NULL, NULL, 94855),
(94856, '3.40.630.10-FF-000111', NULL, 'Probable M18 family aminopeptidase 2', 288, NULL, NULL, 94856),
(94857, '1.20.920.10-FF-000067', NULL, 'Transcription initiation factor TFIID subunit 1', 154, NULL, NULL, 94857),
(94858, '3.40.50.300-FF-008107', NULL, 'Dicer-1, putative', 109, NULL, NULL, 94858),
(94859, '2.40.50.140-FF-000008', NULL, '30S ribosomal protein S12, chloroplastic', 123, NULL, NULL, 94859),
(94860, '3.30.70.2970-FF-000006', NULL, 'interleukin-1 receptor-associated kinase 1-binding protein 1-like', 48, NULL, NULL, 94860),
(94861, '3.30.420.10-FF-000356', NULL, NULL, 154, NULL, NULL, 94861),
(94862, '2.40.160.120-FF-000057', NULL, 'Oxysterol-binding protein', 90, NULL, NULL, 94862),
(94863, '1.20.1250.20-FF-001304', NULL, 'Uncharacterized protein', 133, NULL, NULL, 94863),
(94864, '2.40.10.10-FF-000310', NULL, NULL, 112, NULL, NULL, 94864),
(94865, '1.25.10.10-FF-000460', NULL, 'Armadillo repeat protein', 203, NULL, NULL, 94865),
(94866, '2.60.40.10-FF-002082', NULL, 'PKHD1, fibrocystin/polyductin', 87, NULL, NULL, 94866),
(94867, '1.10.238.10-FF-000360', NULL, 'Uncharacterized protein, isoform A', 196, NULL, NULL, 94867),
(94868, '3.30.890.10-FF-000025', NULL, 'Uncharacterized protein', 74, NULL, NULL, 94868),
(94869, '2.60.40.640-FF-000023', NULL, 'Vacuolar protein sorting-associated protein 26', 108, NULL, NULL, 94869),
(94870, '2.10.25.10-FF-001183', NULL, 'Agrin', 63, NULL, NULL, 94870),
(94871, '1.10.230.10-FF-000022', NULL, 'Os11g0623601 protein', 34, NULL, NULL, 94871),
(94872, '2.60.120.10-FF-000712', NULL, 'Uncharacterized protein', 150, NULL, NULL, 94872),
(94873, '3.30.110.110-FF-000006', NULL, 'Endo/exonuclease Mre11, putative', 103, NULL, NULL, 94873),
(94874, '3.40.50.150-FF-000822', NULL, 'Probable methyltransferase BMT2 homolog', 231, NULL, NULL, 94874);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(94875, '3.30.160.60-FF-000182', NULL, 'zinc finger protein 366', 28, NULL, NULL, 94875),
(94876, '2.70.170.10-FF-000241', NULL, 'Uncharacterized protein', 215, NULL, NULL, 94876),
(94877, '1.20.58.390-FF-000153', NULL, 'Acetylcholine receptor subunit alpha-type acr-7', 75, NULL, NULL, 94877),
(94878, '3.80.10.10-FF-001520', NULL, 'Leucine-rich repeat-containing 29', 152, NULL, NULL, 94878),
(94879, '2.60.40.150-FF-000651', NULL, 'Uncharacterized protein', 119, NULL, NULL, 94879),
(94880, '3.40.50.2300-FF-001629', NULL, NULL, 271, NULL, NULL, 94880),
(94881, '3.40.50.10140-FF-000069', NULL, 'Uncharacterized protein', 108, NULL, NULL, 94881),
(94882, '2.40.290.10-FF-000009', NULL, 'ATP-dependent DNA helicase II subunit 2', 201, NULL, NULL, 94882),
(94883, '1.20.140.40-FF-000072', NULL, NULL, 156, NULL, NULL, 94883),
(94884, '2.130.10.10-FF-003599', NULL, 'Related to yeast Vacuolar Protein Sorting factor', 285, NULL, NULL, 94884),
(94885, '3.40.50.300-FF-008321', NULL, 'Uncharacterized protein', 245, NULL, NULL, 94885),
(94886, '3.40.50.10130-FF-000066', NULL, 'Uncharacterized protein', 100, NULL, NULL, 94886),
(94887, '1.10.533.10-FF-000192', NULL, 'Uncharacterized protein', 103, NULL, NULL, 94887),
(94888, '3.30.70.1470-FF-000006', NULL, 'cell death protein 3-like isoform X1', 103, NULL, NULL, 94888),
(94889, '3.30.160.60-FF-002317', NULL, 'Zgc:174696 protein', 28, NULL, NULL, 94889),
(94890, '3.30.160.60-FF-004217', NULL, NULL, 59, NULL, NULL, 94890),
(94891, '1.25.40.10-FF-002070', NULL, 'Hypothetical_protein_-_conserved', 199, NULL, NULL, 94891),
(94892, '3.80.10.10-FF-003206', NULL, 'Reticulon 4 receptor like 1', 223, NULL, NULL, 94892),
(94893, '3.40.50.300-FF-004038', NULL, 'DNA replication ATP-dependent helicase/nuclease DNA2', 113, NULL, NULL, 94893),
(94894, '3.40.50.150-FF-000143', NULL, 'DNA (cytosine-5)-methyltransferase 1', 345, NULL, NULL, 94894),
(94895, '1.10.10.60-FF-000811', NULL, NULL, 42, NULL, NULL, 94895),
(94896, '1.25.40.20-FF-001797', NULL, 'Ankyrin and IPT/TIG repeat-containing protein C26H5.05', 168, NULL, NULL, 94896),
(94897, '1.25.40.10-FF-001794', NULL, 'Pentatricopeptide repeat-containing protein At1g20230', 140, NULL, NULL, 94897),
(94898, '3.40.50.2060-FF-000001', NULL, 'syntaxin-binding protein 1 isoform X2', 132, NULL, NULL, 94898),
(94899, '3.30.40.10-FF-001333', NULL, 'HRT1-like protein', 88, NULL, NULL, 94899),
(94900, '3.10.120.10-FF-000051', NULL, 'Cytochrome b5 reductase 4', 62, NULL, NULL, 94900),
(94901, '1.10.510.10-FF-004096', NULL, NULL, 141, NULL, NULL, 94901),
(94902, '1.10.220.10-FF-000066', NULL, 'Uncharacterized protein', 49, NULL, NULL, 94902),
(94903, '3.40.50.300-FF-006516', NULL, 'Predicted protein', 111, NULL, NULL, 94903),
(94904, '3.40.50.300-FF-000109', NULL, 'Peroxisomal biogenesis factor 6', 194, NULL, NULL, 94904),
(94905, '3.40.50.720-FF-001527', NULL, 'Uncharacterized protein', 289, NULL, NULL, 94905),
(94906, '2.60.120.10-FF-000263', NULL, 'Transcription regulator, CRP family', 220, NULL, NULL, 94906),
(94907, '2.170.270.10-FF-000213', NULL, 'Uncharacterized protein', 144, NULL, NULL, 94907),
(94908, '1.10.530.10-FF-000067', NULL, 'Acidic endochitinase WIN6.2B', 98, NULL, NULL, 94908),
(94909, '3.50.30.30-FF-000146', NULL, 'Uncharacterized protein', 148, NULL, NULL, 94909),
(94910, '1.10.8.1290-FF-000002', NULL, 'Glutamine--tRNA ligase cytoplasmic', 114, NULL, NULL, 94910),
(94911, '3.90.1290.10-FF-000044', NULL, 'Uncharacterized protein', 165, NULL, NULL, 94911),
(94912, '2.70.150.10-FF-000144', NULL, 'Copper transporter, ATP dependent', 125, NULL, NULL, 94912),
(94913, '3.40.50.720-FF-001191', NULL, 'Os01g0828100 protein', 220, NULL, NULL, 94913),
(94914, '3.30.200.20-FF-000123', NULL, 'serine/threonine-protein kinase PRP4 homolog', 87, NULL, NULL, 94914),
(94915, '3.50.4.10-FF-000007', NULL, 'No-mechanoreceptor potential a', 80, NULL, NULL, 94915),
(94916, '3.40.1110.10-FF-000318', NULL, NULL, 180, NULL, NULL, 94916),
(94917, '1.20.1300.10-FF-000002', NULL, 'Fumarate reductase subunit D', 119, NULL, NULL, 94917),
(94918, '2.20.25.420-FF-000004', NULL, 'Zinc finger protein, putative', 52, NULL, NULL, 94918);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(94919, '3.40.50.150-FF-000373', NULL, 'Demethylmenaquinone methyltransferase', 210, NULL, NULL, 94919),
(94920, '3.40.50.300-FF-002138', NULL, 'Putative dynein heavy chain', 192, NULL, NULL, 94920),
(94921, '1.10.630.10-FF-000569', NULL, 'Cytochrome P450 3A12', 319, NULL, NULL, 94921),
(94922, '3.20.20.370-FF-000027', NULL, 'Uncharacterized protein', 266, NULL, NULL, 94922),
(94923, '3.90.550.50-FF-000127', NULL, 'Hexosyltransferase', 117, NULL, NULL, 94923),
(94924, '3.80.10.10-FF-001071', NULL, 'volume-regulated anion channel subunit LRRC8E', 127, NULL, NULL, 94924),
(94925, '2.40.20.10-FF-000119', NULL, 'Uncharacterized protein', 66, NULL, NULL, 94925),
(94926, '1.10.418.10-FF-000020', NULL, 'Cytospin-A isoform 1', 108, NULL, NULL, 94926),
(94927, '3.40.50.12550-FF-000016', NULL, 'ThiF family protein', 62, NULL, NULL, 94927),
(94928, '3.50.50.100-FF-000002', NULL, 'External alternative NAD(P)H-ubiquinone oxidoreductase B1, mitochondrial', 360, NULL, NULL, 94928),
(94929, '3.30.2130.10-FF-000024', NULL, 'Uncharacterized protein', 107, NULL, NULL, 94929),
(94930, '1.10.287.110-FF-000194', NULL, 'Putative DNAJ domain protein', 104, NULL, NULL, 94930),
(94931, '1.10.580.10-FF-000019', NULL, 'Citrate synthase', 224, NULL, NULL, 94931),
(94932, '3.10.450.10-FF-000047', NULL, 'AGAP002879-PA', 109, NULL, NULL, 94932),
(94933, '3.40.1050.10-FF-000026', NULL, 'Carbonic anhydrase', 185, NULL, NULL, 94933),
(94934, '3.40.50.11720-FF-000003', NULL, '3-deoxy-D-manno-octulosonic acid transferase', 175, NULL, NULL, 94934),
(94935, '2.40.30.10-FF-000305', NULL, 'Mitochondrial 54S ribosomal protein YmL9', 105, NULL, NULL, 94935),
(94936, '3.40.50.300-FF-006067', NULL, 'Predicted protein', 151, NULL, NULL, 94936),
(94937, '1.20.5.520-FF-000001', NULL, 'Thymosin beta', 40, NULL, NULL, 94937),
(94938, '3.20.20.210-FF-000007', NULL, 'Uroporphyrinogen decarboxylase', 344, NULL, NULL, 94938),
(94939, '3.10.20.30-FF-000085', NULL, NULL, 92, NULL, NULL, 94939),
(94940, '1.20.5.540-FF-000007', NULL, 'Uncharacterized protein', 27, NULL, NULL, 94940),
(94941, '1.10.260.40-FF-000089', NULL, 'Homeodomain-containing DNA- binding protein, putative', 91, NULL, NULL, 94941),
(94942, '1.10.340.30-FF-000002', NULL, 'Adenine DNA glycosylase', 120, NULL, NULL, 94942),
(94943, '1.10.10.10-FF-002062', NULL, 'ATP-dependent DNA helicase', 112, NULL, NULL, 94943),
(94944, '1.20.58.60-FF-000758', NULL, 'Smyhc1 protein', 38, NULL, NULL, 94944),
(94945, '2.40.160.20-FF-000008', NULL, 'Outer membrane protein', 177, NULL, NULL, 94945),
(94946, '3.40.50.300-FF-008080', NULL, 'Uncharacterized protein', 117, NULL, NULL, 94946),
(94947, '3.30.450.40-FF-000164', NULL, 'GAF sensor signal transduction histidine kinase', 173, NULL, NULL, 94947),
(94948, '3.10.580.10-FF-000147', NULL, 'Inorganic pyrophosphatase', 67, NULL, NULL, 94948),
(94949, '3.40.50.2020-FF-000129', NULL, 'Hypoxanthine phosphoribosyltransferase', 179, NULL, NULL, 94949),
(94950, '3.10.250.10-FF-000049', NULL, 'Lysyl oxidase homolog 3', 66, NULL, NULL, 94950),
(94951, '3.30.160.60-FF-006016', NULL, NULL, 33, NULL, NULL, 94951),
(94952, '3.90.550.10-FF-000711', NULL, 'Uncharacterized protein', 269, NULL, NULL, 94952),
(94953, '2.40.160.10-FF-000005', NULL, 'mitochondrial import receptor subunit TOM40 homolog', 285, NULL, NULL, 94953),
(94954, '1.10.340.40-FF-000005', NULL, 'mRNA-binding protein', 104, NULL, NULL, 94954),
(94955, '2.60.40.60-FF-000270', NULL, 'protocadherin-7 isoform X3', 74, NULL, NULL, 94955),
(94956, '2.30.29.30-FF-001152', NULL, 'Uncharacterized protein', 110, NULL, NULL, 94956),
(94957, '3.40.50.300-FF-003875', NULL, 'ABC transporter-like protein', 131, NULL, NULL, 94957),
(94958, '1.10.274.30-FF-000022', NULL, 'Uncharacterized protein', 171, NULL, NULL, 94958),
(94959, '3.10.110.10-FF-000123', NULL, 'Ubiquitin-conjugating enzyme e2, putative', 189, NULL, NULL, 94959),
(94960, '1.20.120.1760-FF-000019', NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', 175, NULL, NULL, 94960),
(94961, '3.30.300.20-FF-000075', NULL, 'Ribosome-binding factor A', 93, NULL, NULL, 94961);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(94962, '3.30.70.2280-FF-000013', NULL, 'Uncharacterized protein', 78, NULL, NULL, 94962),
(94963, '2.30.30.40-FF-000247', NULL, 'Rho-type guanine nucleotide exchange factor, isoform A', 62, NULL, NULL, 94963),
(94964, '2.60.40.10-FF-002194', NULL, 'Sallimus, isoform P', 110, NULL, NULL, 94964),
(94965, '2.60.210.10-FF-000011', NULL, 'Ubiquitin carboxyl-terminal hydrolase 7', 157, NULL, NULL, 94965),
(94966, '1.10.238.10-FF-000472', NULL, 'Hypothetical_protein', 172, NULL, NULL, 94966),
(94967, '3.40.50.800-FF-000057', NULL, 'Proline--tRNA ligase', 114, NULL, NULL, 94967),
(94968, '2.60.120.200-FF-000001', NULL, 'neurexin-1 isoform X1', 192, NULL, NULL, 94968),
(94969, '1.25.40.10-FF-003508', NULL, 'Pentatricopeptide repeat-containing protein', 105, NULL, NULL, 94969),
(94970, '1.20.120.1750-FF-000016', NULL, 'E3 ubiquitin-protein ligase RNF216 isoform X1', 135, NULL, NULL, 94970),
(94971, '3.40.50.1440-FF-000146', NULL, 'Uncharacterized protein', 313, NULL, NULL, 94971),
(94972, '2.60.40.200-FF-000026', NULL, 'Copper chaperone for superoxide dismutase', 143, NULL, NULL, 94972),
(94973, '1.20.1310.10-FF-000154', NULL, NULL, 109, NULL, NULL, 94973),
(94974, '3.80.10.10-FF-001632', NULL, 'Uncharacterized protein', 288, NULL, NULL, 94974),
(94975, '2.130.10.10-FF-003369', NULL, 'Leucine rich repeat kinase 2', 220, NULL, NULL, 94975),
(94976, '4.10.260.30-FF-000001', NULL, 'Apolipoprotein C-I', 57, NULL, NULL, 94976),
(94977, '1.20.58.830-FF-000004', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 180, NULL, NULL, 94977),
(94978, '1.10.4030.10-FF-000006', NULL, NULL, 122, NULL, NULL, 94978),
(94979, '2.60.34.10-FF-000010', NULL, 'heat shock 70 kDa protein 4 isoform X1', 153, NULL, NULL, 94979),
(94980, '2.60.40.10-FF-000069', NULL, 'Alpha-protein kinase 3', 101, NULL, NULL, 94980),
(94981, '2.30.30.40-FF-000040', NULL, 'kalirin isoform X1', 74, NULL, NULL, 94981),
(94982, '2.60.34.20-FF-000013', NULL, NULL, 167, NULL, NULL, 94982),
(94983, '1.10.560.10-FF-000119', NULL, 'Uncharacterized protein', 161, NULL, NULL, 94983),
(94984, '3.30.160.20-FF-000086', NULL, 'double-stranded RNA-binding protein Staufen homolog 1 isoform X2', 80, NULL, NULL, 94984),
(94985, '3.30.390.10-FF-000015', NULL, 'Mandelate racemase', 121, NULL, NULL, 94985),
(94986, '2.130.10.10-FF-002413', NULL, 'Related to SOF1-involved in 18S pre-rRNA production', 114, NULL, NULL, 94986),
(94987, '1.10.3710.10-FF-000002', NULL, 'ATPase WRNIP1 isoform 1', 76, NULL, NULL, 94987),
(94988, '1.25.10.10-FF-000443', NULL, 'Armadillo repeat-containing protein 10', 94, NULL, NULL, 94988),
(94989, '1.20.1250.20-FF-001063', NULL, 'Uncharacterized protein', 193, NULL, NULL, 94989),
(94990, '2.10.25.10-FF-001306', NULL, 'C-type LECtin', 36, NULL, NULL, 94990),
(94991, '3.40.30.10-FF-000567', NULL, 'Uncharacterized protein', 76, NULL, NULL, 94991),
(94992, '3.40.50.40-FF-000010', NULL, 'Cytoplasmic l-asparaginase i-like protein', 162, NULL, NULL, 94992),
(94993, '1.20.272.10-FF-000026', NULL, 'DNA polymerase III delta subunit', 127, NULL, NULL, 94993),
(94994, '3.40.190.10-FF-000301', NULL, 'Sulfate ABC transporter substrate-binding lipoprotein SubI', 138, NULL, NULL, 94994),
(94995, '2.60.40.4370-FF-000010', NULL, NULL, 113, NULL, NULL, 94995),
(94996, '1.10.760.10-FF-000101', NULL, 'Cytochrome c-552 Ks_3358', 92, NULL, NULL, 94996),
(94997, '2.60.120.260-FF-000221', NULL, 'Laminin-like protein epi-1', 136, NULL, NULL, 94997),
(94998, '2.130.10.10-FF-003695', NULL, 'Uncharacterized protein', 297, NULL, NULL, 94998),
(94999, '1.10.20.10-FF-000090', NULL, 'DNA polymerase epsilon subunit 3', 141, NULL, NULL, 94999),
(95000, '3.30.420.10-FF-000682', NULL, NULL, 153, NULL, NULL, 95000),
(95001, '3.40.50.300-FF-002464', NULL, 'Putative SNF2 family helicase', 282, NULL, NULL, 95001),
(95002, '3.40.20.10-FF-000078', NULL, 'Macrophage-capping protein', 119, NULL, NULL, 95002),
(95003, '1.10.10.10-FF-000162', NULL, 'Regulator of G-protein signaling 6', 109, NULL, NULL, 95003),
(95004, '2.60.40.790-FF-000152', NULL, NULL, 69, NULL, NULL, 95004),
(95005, '3.10.290.10-FF-000046', NULL, 'RNA pseudouridine synthase', 65, NULL, NULL, 95005);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(95006, '2.60.40.60-FF-000505', NULL, 'cadherin EGF LAG seven-pass G-type receptor 2 isoform X2', 104, NULL, NULL, 95006),
(95007, '1.10.510.10-FF-002421', NULL, NULL, 255, NULL, NULL, 95007),
(95008, '3.30.565.10-FF-000242', NULL, 'Uncharacterized protein', 191, NULL, NULL, 95008),
(95009, '3.30.450.40-FF-000260', NULL, 'Probable IclR family regulator (Putative secreted protein)', 160, NULL, NULL, 95009),
(95010, '1.10.510.10-FF-002651', NULL, NULL, 96, NULL, NULL, 95010),
(95011, '2.130.10.10-FF-001924', NULL, 'guanine nucleotide-binding protein G(I)/G(S)/G(T) subunit beta-1-like', 153, NULL, NULL, 95011),
(95012, '3.20.20.140-FF-000329', NULL, 'Uncharacterized protein', 160, NULL, NULL, 95012),
(95013, '3.30.420.40-FF-000095', NULL, 'Phosphotransferase', 162, NULL, NULL, 95013),
(95014, '3.90.70.10-FF-000253', NULL, 'Ubiquitin carboxyl-terminal hydrolase domain containing protein', 306, NULL, NULL, 95014),
(95015, '3.90.226.10-FF-000222', NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', 379, NULL, NULL, 95015),
(95016, '1.25.40.10-FF-003946', NULL, 'Chitin synthase regulatory factor 1', 273, NULL, NULL, 95016),
(95017, '1.10.3720.10-FF-000154', NULL, 'Phosphate transport system permease protein PstA', 286, NULL, NULL, 95017),
(95018, '3.40.1380.10-FF-000012', NULL, 'ATP synthase gamma chain', 212, NULL, NULL, 95018),
(95019, '3.40.50.1100-FF-000303', NULL, 'Pyridoxal-5''-phosphate-dependent enzyme family protein', 24, NULL, NULL, 95019),
(95020, '3.30.505.10-FF-000042', NULL, 'Cytokine-inducible SH2-containing protein b', 149, NULL, NULL, 95020),
(95021, '1.25.10.10-FF-000230', NULL, 'Serine/threonine-protein kinase Nek10', 132, NULL, NULL, 95021),
(95022, '1.10.238.10-FF-000601', NULL, 'Probable calcium-binding protein CML11', 101, NULL, NULL, 95022),
(95023, '1.10.3080.10-FF-000043', NULL, 'Chloride channel protein', 174, NULL, NULL, 95023),
(95024, '3.30.160.60-FF-000165', NULL, 'Zinc finger protein 34', 27, NULL, NULL, 95024),
(95025, '2.30.40.10-FF-000099', NULL, 'Guanine deaminase', 111, NULL, NULL, 95025),
(95026, '1.10.1280.10-FF-000024', NULL, 'Uncharacterized protein', 128, NULL, NULL, 95026),
(95027, '3.50.50.60-FF-000122', NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase, mitochondrial', 244, NULL, NULL, 95027),
(95028, '1.10.287.110-FF-000290', NULL, 'Predicted protein', 96, NULL, NULL, 95028),
(95029, '3.40.140.10-FF-000253', NULL, 'Uncharacterized protein', 132, NULL, NULL, 95029),
(95030, '3.40.930.10-FF-000044', NULL, NULL, 156, NULL, NULL, 95030),
(95031, '1.20.1280.50-FF-000056', NULL, 'F-box/LRR-repeat protein 8', 40, NULL, NULL, 95031),
(95032, '2.20.25.10-FF-000053', NULL, 'DNA-directed RNA polymerase subunit', 68, NULL, NULL, 95032),
(95033, '2.130.10.10-FF-000822', NULL, '3-carboxy-cis,cis-muconate lactonizing enzyme', 341, NULL, NULL, 95033),
(95034, '3.30.1680.10-FF-000003', NULL, 'semaphorin-5B isoform X1', 50, NULL, NULL, 95034),
(95035, '1.10.1420.10-FF-000013', NULL, 'mutS protein homolog 4', 226, NULL, NULL, 95035),
(95036, '2.120.10.80-FF-000214', NULL, 'Serine/threonine-protein phosphatase', 122, NULL, NULL, 95036),
(95037, '3.80.10.10-FF-003223', NULL, 'Uncharacterized protein', 202, NULL, NULL, 95037),
(95038, '3.30.565.10-FF-000146', NULL, 'Oxygen sensor histidine kinase response regulator DevS/DosS', 128, NULL, NULL, 95038),
(95039, '3.30.930.10-FF-000198', NULL, 'Threonine--tRNA ligase mitochondrial 1', 129, NULL, NULL, 95039),
(95040, '2.40.100.10-FF-000114', NULL, 'Uncharacterized protein', 175, NULL, NULL, 95040),
(95041, '2.60.40.150-FF-000090', NULL, 'C2 domain-containing protein', 152, NULL, NULL, 95041),
(95042, '2.40.10.10-FF-000068', NULL, 'transmembrane protease serine 2', 100, NULL, NULL, 95042),
(95043, '3.40.50.1820-FF-001351', NULL, 'GPI inositol-deacylase', 240, NULL, NULL, 95043),
(95044, '1.10.400.10-FF-000052', NULL, 'Uncharacterized protein', 115, NULL, NULL, 95044),
(95045, '2.130.10.10-FF-005853', NULL, 'Uncharacterized protein', 326, NULL, NULL, 95045),
(95046, '2.60.40.10-FF-002323', NULL, 'CD96 molecule', 121, NULL, NULL, 95046);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(95047, '1.20.1070.10-FF-001641', NULL, 'Predicted protein', 137, NULL, NULL, 95047),
(95048, '1.20.1560.10-FF-000459', NULL, 'Transporter 2, ATP-binding cassette, sub-family B (MDR/TAP)', 252, NULL, NULL, 95048),
(95049, '3.30.1330.20-FF-000008', NULL, 'Cell division protein FtsZ', 113, NULL, NULL, 95049),
(95050, '3.90.132.10-FF-000004', NULL, 'GP63-like', 127, NULL, NULL, 95050),
(95051, '3.30.1330.10-FF-000005', NULL, 'Phosphoribosylformylglycinamidine synthase', 189, NULL, NULL, 95051),
(95052, '2.120.10.30-FF-000126', NULL, 'Senescence marker protein-30', 290, NULL, NULL, 95052),
(95053, '2.60.40.10-FF-005757', NULL, NULL, 115, NULL, NULL, 95053),
(95054, '1.10.10.60-FF-000250', NULL, 'Homeobox protein cut-like', 60, NULL, NULL, 95054),
(95055, '3.30.70.330-FF-001765', NULL, NULL, 82, NULL, NULL, 95055),
(95056, '3.30.365.10-FF-000047', NULL, 'Nicotinate dehydrogenase medium molybdopterin subunit', 149, NULL, NULL, 95056),
(95057, '1.25.40.470-FF-000067', NULL, 'WD repeat protein, putative', 181, NULL, NULL, 95057),
(95058, '1.20.1250.20-FF-000787', NULL, 'Siderochrome-iron transporter, putative', 177, NULL, NULL, 95058),
(95059, '3.10.20.90-FF-001013', NULL, 'Uncharacterized protein', 72, NULL, NULL, 95059),
(95060, '1.50.40.10-FF-000336', NULL, 'Uncharacterized protein', 243, NULL, NULL, 95060),
(95061, '1.20.5.340-FF-000054', NULL, 'Probable TUP1-general transcription repressor', 86, NULL, NULL, 95061),
(95062, '3.40.190.290-FF-000012', NULL, 'Transcriptional regulator, LysR family', 206, NULL, NULL, 95062),
(95063, '3.30.160.60-FF-005757', NULL, NULL, 30, NULL, NULL, 95063),
(95064, '1.10.510.10-FF-000167', NULL, 'Tau tubulin kinase 1', 324, NULL, NULL, 95064),
(95065, '2.170.270.10-FF-000084', NULL, 'UpSET, isoform A', 224, NULL, NULL, 95065),
(95066, '3.30.200.20-FF-001860', NULL, NULL, 14, NULL, NULL, 95066),
(95067, '3.40.50.300-FF-001981', NULL, 'protein KTI12 homolog', 111, NULL, NULL, 95067),
(95068, '1.25.40.10-FF-000506', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 96, NULL, NULL, 95068),
(95069, '2.40.70.10-FF-000061', NULL, 'Aspartyl protease APCB1', 186, NULL, NULL, 95069),
(95070, '3.40.50.150-FF-001784', NULL, NULL, 178, NULL, NULL, 95070),
(95071, '1.25.40.20-FF-000509', NULL, 'Ankyrin repeat domain 28, isoform CRA_c', 105, NULL, NULL, 95071),
(95072, '1.25.70.10-FF-000008', NULL, 'Transcription termination factor MTERF5 chloroplastic', 221, NULL, NULL, 95072),
(95073, '3.80.10.10-FF-000789', NULL, 'LRR receptor-like serine/threonine-protein kinase GSO1', 101, NULL, NULL, 95073),
(95074, '3.30.160.60-FF-006246', NULL, NULL, 23, NULL, NULL, 95074),
(95075, '3.40.50.300-FF-004931', NULL, 'Septin 4', 219, NULL, NULL, 95075),
(95076, '3.30.70.1230-FF-000283', NULL, 'Predicted protein', 226, NULL, NULL, 95076),
(95077, '3.90.730.10-FF-000028', NULL, 'Uncharacterized protein', 164, NULL, NULL, 95077),
(95078, '1.10.10.1230-FF-000001', NULL, 'Penicillin-binding protein 3', 140, NULL, NULL, 95078),
(95079, '3.60.21.10-FF-000079', NULL, 'Double-strand break repair protein MRE11', 227, NULL, NULL, 95079),
(95080, '3.30.505.10-FF-000249', NULL, NULL, 53, NULL, NULL, 95080),
(95081, '1.10.3260.10-FF-000023', NULL, 'Uncharacterized protein', 88, NULL, NULL, 95081),
(95082, '1.20.1110.10-FF-000173', NULL, 'Calcium-transporting ATPase', 343, NULL, NULL, 95082),
(95083, '1.10.510.10-FF-003961', NULL, NULL, 45, NULL, NULL, 95083),
(95084, '3.40.1230.10-FF-000012', NULL, 'YALI0E11011p', 144, NULL, NULL, 95084),
(95085, '1.25.10.10-FF-000117', NULL, 'TOG array regulator of axonemal microtubules 1', 250, NULL, NULL, 95085),
(95086, '1.10.238.10-FF-000258', NULL, 'NADPH oxidase, isoform B', 169, NULL, NULL, 95086),
(95087, '3.40.50.2300-FF-001181', NULL, NULL, 61, NULL, NULL, 95087),
(95088, '1.10.760.10-FF-000005', NULL, 'Menaquinol-cytochrome c reductase cytochrome b/c subunit', 72, NULL, NULL, 95088),
(95089, '2.60.40.690-FF-000009', NULL, 'Alpha-2-macroglobulin-like', 133, NULL, NULL, 95089),
(95090, '1.25.40.10-FF-002182', NULL, 'Pentatricopeptide repeat-containing protein', 115, NULL, NULL, 95090); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(95091, '2.130.10.10-FF-003487', NULL, 'E3 ubiquitin-protein ligase PEP5', 291, NULL, NULL, 95091),
(95092, '2.130.10.120-FF-000001', NULL, 'Prolyl endopeptidase', 356, NULL, NULL, 95092),
(95093, '3.40.50.10810-FF-000056', NULL, 'DNA repair protein RAD5', 175, NULL, NULL, 95093),
(95094, '1.25.40.20-FF-000627', NULL, 'Ankyrin repeat and LEM domain containing 1', 168, NULL, NULL, 95094),
(95095, '1.10.287.30-FF-000001', NULL, 'Regulatory protein E2', 100, NULL, NULL, 95095),
(95096, '3.30.160.60-FF-002429', NULL, 'Uncharacterized protein, isoform A', 58, NULL, NULL, 95096),
(95097, '3.70.10.10-FF-000104', NULL, 'Uncharacterized protein', 316, NULL, NULL, 95097),
(95098, '3.40.30.10-FF-000910', NULL, 'Peroxiredoxin, putative', 133, NULL, NULL, 95098),
(95099, '2.130.10.10-FF-000261', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 222, NULL, NULL, 95099),
(95100, '1.10.287.40-FF-000004', NULL, 'Serine--tRNA ligase', 103, NULL, NULL, 95100),
(95101, '1.10.287.130-FF-000088', NULL, 'Two-component sensor histidine kinase', 109, NULL, NULL, 95101),
(95102, '1.10.1040.30-FF-000006', NULL, 'Putative DNA-dependent ATPase', 105, NULL, NULL, 95102),
(95103, '3.80.10.10-FF-001418', NULL, 'Tehao', 314, NULL, NULL, 95103),
(95104, '2.40.128.20-FF-000029', NULL, 'Beta-lactoglobulin', 162, NULL, NULL, 95104),
(95105, '2.40.50.700-FF-000008', NULL, 'Exosome complex exonuclease RRP44, putative', 73, NULL, NULL, 95105),
(95106, '1.10.287.110-FF-000082', NULL, 'Iron-sulfur cluster co-chaperone protein HscB, mitochondrial', 111, NULL, NULL, 95106),
(95107, '3.40.50.12160-FF-000006', NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase', 133, NULL, NULL, 95107),
(95108, '3.40.532.10-FF-000012', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 235, NULL, NULL, 95108),
(95109, '3.30.450.50-FF-000055', NULL, 'Synaptobrevin family protein', 120, NULL, NULL, 95109),
(95110, '3.70.10.10-FF-000087', NULL, 'Uncharacterized protein', 158, NULL, NULL, 95110),
(95111, '1.10.405.10-FF-000041', NULL, 'L-amino-acid oxidase', 40, NULL, NULL, 95111),
(95112, '1.10.418.50-FF-000003', NULL, 'Uncharacterized protein', 129, NULL, NULL, 95112),
(95113, '2.60.40.10-FF-000182', NULL, 'Gamma intimin', 98, NULL, NULL, 95113),
(95114, '3.40.50.720-FF-001409', NULL, 'Tetrapyrrole methylase', 137, NULL, NULL, 95114),
(95115, '3.70.10.10-FF-000093', NULL, 'DNA repair exonuclease REC1', 235, NULL, NULL, 95115),
(95116, '3.30.450.40-FF-000052', NULL, 'Oxygen sensor histidine kinase response regulator DevS/DosS', 152, NULL, NULL, 95116),
(95117, '3.30.450.60-FF-000058', NULL, 'Uncharacterized protein', 167, NULL, NULL, 95117),
(95118, '3.30.1390.20-FF-000001', NULL, '50S ribosomal protein L30', 58, NULL, NULL, 95118),
(95119, '2.10.220.10-FF-000208', NULL, 'Uncharacterized protein', 115, NULL, NULL, 95119),
(95120, '2.130.10.130-FF-000004', NULL, 'Integrin subunit alpha 10', 142, NULL, NULL, 95120),
(95121, '3.40.50.1000-FF-000363', NULL, 'Nuclear LIM interactor-interacting factor 1', 188, NULL, NULL, 95121),
(95122, '2.60.40.3210-FF-000016', NULL, 'Uncharacterized protein', 110, NULL, NULL, 95122),
(95123, '3.30.360.10-FF-000064', NULL, 'Lysine-ketoglutarate reductase/saccharopine dehydrogenase bifunctional enzyme', 40, NULL, NULL, 95123),
(95124, '1.10.630.10-FF-000457', NULL, 'Protein CBG01271', 228, NULL, NULL, 95124),
(95125, '1.10.10.440-FF-000051', NULL, 'U1 snRNP protein', 69, NULL, NULL, 95125),
(95126, '3.40.50.150-FF-000261', NULL, 'U6 small nuclear RNA (adenine-(43)-N(6))-methyltransferase', 277, NULL, NULL, 95126),
(95127, '1.10.472.10-FF-000302', NULL, 'Predicted protein', 204, NULL, NULL, 95127),
(95128, '2.60.40.10-FF-000283', NULL, 'Immunoglobulin kappa constant', 110, NULL, NULL, 95128),
(95129, '3.30.505.10-FF-000250', NULL, NULL, 52, NULL, NULL, 95129),
(95130, '1.50.40.10-FF-000550', NULL, 'Mitochondrial glycine transporter', 132, NULL, NULL, 95130),
(95131, '3.10.130.10-FF-000006', NULL, 'Ribonuclease homolog', 112, NULL, NULL, 95131),
(95132, '3.80.10.10-FF-001519', NULL, 'Highly similar to receptor-like protein kinase', 169, NULL, NULL, 95132);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(95133, '3.80.10.10-FF-002947', NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3', 174, NULL, NULL, 95133),
(95134, '3.30.420.40-FF-000544', NULL, 'DnaK-type molecular chaperone', 123, NULL, NULL, 95134),
(95135, '2.40.50.100-FF-000137', NULL, 'RND efflux membrane fusion protein', 69, NULL, NULL, 95135),
(95136, '3.40.50.200-FF-000068', NULL, 'p-domain proprotein convertase, putative', 330, NULL, NULL, 95136),
(95137, '3.40.50.720-FF-001741', NULL, 'Adenosylhomocysteinase', 159, NULL, NULL, 95137),
(95138, '3.30.497.10-FF-000072', NULL, 'Serine protease inhibitor (serpin) 14', 196, NULL, NULL, 95138),
(95139, '3.30.160.60-FF-000732', NULL, 'zinc finger protein 140 isoform X3', 28, NULL, NULL, 95139),
(95140, '3.40.50.1010-FF-000271', NULL, NULL, 194, NULL, NULL, 95140),
(95141, '3.30.530.20-FF-000092', NULL, 'Uncharacterized protein 5F3.180', 186, NULL, NULL, 95141),
(95142, '1.10.472.10-FF-000403', NULL, 'Uncharacterized protein', 109, NULL, NULL, 95142),
(95143, '3.40.50.2300-FF-001282', NULL, NULL, 167, NULL, NULL, 95143),
(95144, '3.10.100.10-FF-000403', NULL, NULL, 112, NULL, NULL, 95144),
(95145, '1.10.510.10-FF-002325', NULL, NULL, 208, NULL, NULL, 95145),
(95146, '3.30.70.380-FF-000004', NULL, 'Ferredoxin-fold anticodon-binding domain-containing protein 1 homolog', 97, NULL, NULL, 95146),
(95147, '3.90.70.10-FF-000039', NULL, 'Cysteine proteinase 2, putative', 305, NULL, NULL, 95147),
(95148, '1.20.1070.10-FF-001074', NULL, 'Alpha-1D adrenergic receptor', 364, NULL, NULL, 95148),
(95149, '3.30.930.10-FF-000086', NULL, 'Octanoyltransferase LIP2p, chloroplastic isoform A', 208, NULL, NULL, 95149),
(95150, '1.10.1410.10-FF-000057', NULL, 'Uncharacterized protein', 176, NULL, NULL, 95150),
(95151, '3.90.260.10-FF-000043', NULL, 'Uncharacterized protein', 165, NULL, NULL, 95151),
(95152, '3.40.50.300-FF-007478', NULL, 'ATP binding cassette subfamily A member 2', 236, NULL, NULL, 95152),
(95153, '3.40.50.300-FF-004605', NULL, 'DNA helicase', 113, NULL, NULL, 95153),
(95154, '3.40.50.980-FF-000054', NULL, 'Peptide synthetase', 93, NULL, NULL, 95154),
(95155, '3.30.565.10-FF-000354', NULL, 'Two-component system sensor histidine kinase/response regulator', 151, NULL, NULL, 95155),
(95156, '1.10.287.1170-FF-000001', NULL, 'Endo-1,3-beta-glucanase Engl1', 66, NULL, NULL, 95156),
(95157, '3.30.1330.30-FF-000129', NULL, '60S ribosomal protein L7A, putative', 119, NULL, NULL, 95157),
(95158, '3.30.70.370-FF-000001', NULL, 'DNA polymerase I', 117, NULL, NULL, 95158),
(95159, '2.60.40.60-FF-000831', NULL, 'Uncharacterized protein', 102, NULL, NULL, 95159),
(95160, '3.40.50.360-FF-000088', NULL, 'Pyruvate dehydrogenase [NADP(+)]', 156, NULL, NULL, 95160),
(95161, '3.40.30.10-FF-000893', NULL, 'Predicted protein', 108, NULL, NULL, 95161),
(95162, '1.10.510.10-FF-003848', NULL, NULL, 105, NULL, NULL, 95162),
(95163, '3.30.1240.20-FF-000001', NULL, 'Phosphomannomutase', 102, NULL, NULL, 95163),
(95164, '3.40.50.1820-FF-000974', NULL, 'Alpha/beta hydrolase fold protein', 270, NULL, NULL, 95164),
(95165, '1.10.10.60-FF-000603', NULL, 'Putative phage transposase', 65, NULL, NULL, 95165),
(95166, '3.30.365.10-FF-000053', NULL, 'Aldehyde oxidase / xanthine dehydrogenase family molybdopterin cytosine dinucleotide-binding subunit', 92, NULL, NULL, 95166),
(95167, '1.10.472.80-FF-000273', NULL, NULL, 60, NULL, NULL, 95167),
(95168, '1.10.10.370-FF-000001', NULL, 'Sulfurtransferase', 71, NULL, NULL, 95168),
(95169, '1.10.10.390-FF-000007', NULL, 'Chl-1', 53, NULL, NULL, 95169),
(95170, '2.60.40.10-FF-005763', NULL, NULL, 159, NULL, NULL, 95170),
(95171, '3.20.20.60-FF-000099', NULL, 'Pyruvate kinase', 104, NULL, NULL, 95171),
(95172, '3.40.50.2300-FF-001068', NULL, NULL, 86, NULL, NULL, 95172),
(95173, '2.60.120.10-FF-000824', NULL, 'Uncharacterized protein', 68, NULL, NULL, 95173),
(95174, '2.40.30.10-FF-000070', NULL, 'Translation elongation factor EF-1 subunit', 107, NULL, NULL, 95174),
(95175, '1.20.58.340-FF-000048', NULL, 'CorA-like Mg2+ transporter protein', 115, NULL, NULL, 95175);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(95176, '3.30.420.40-FF-000224', NULL, 'NuA4 histone acetyltransferase subunit', 79, NULL, NULL, 95176),
(95177, '1.25.10.10-FF-002354', NULL, 'Uncharacterized protein', 284, NULL, NULL, 95177),
(95178, '1.20.58.2220-FF-000032', NULL, 'formin-like protein 2 isoform X1', 380, NULL, NULL, 95178),
(95179, '3.30.505.10-FF-000137', NULL, 'Phosphoinositide 3-kinase adapter subunit', 110, NULL, NULL, 95179),
(95180, '1.10.60.10-FF-000002', NULL, 'Mn-dependent transcriptional regulator MntR', 61, NULL, NULL, 95180),
(95181, '1.10.1000.11-FF-000016', NULL, 'Exchange factor for Arf-6', 119, NULL, NULL, 95181),
(95182, '3.30.70.3250-FF-000006', NULL, 'Ribonuclease P/MRP protein subunit POP5', 117, NULL, NULL, 95182),
(95183, '3.30.200.20-FF-002034', NULL, 'Uncharacterized protein', 91, NULL, NULL, 95183),
(95184, '1.20.1560.10-FF-000785', NULL, 'ATP binding cassette subfamily C member 2', 268, NULL, NULL, 95184),
(95185, '3.10.20.90-FF-000850', NULL, 'UBX domain-containing protein 10', 138, NULL, NULL, 95185),
(95186, '2.40.50.140-FF-001195', NULL, NULL, 105, NULL, NULL, 95186),
(95187, '1.10.10.10-FF-001909', NULL, 'Predicted protein', 113, NULL, NULL, 95187),
(95188, '3.40.50.300-FF-002582', NULL, 'Nicotinamide riboside kinase, variant', 216, NULL, NULL, 95188),
(95189, '1.20.1310.20-FF-000062', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 290, NULL, NULL, 95189),
(95190, '2.30.29.240-FF-000006', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 220, NULL, NULL, 95190),
(95191, '4.10.60.10-FF-000023', NULL, 'Cellular nucleic acid-binding protein homolog', 22, NULL, NULL, 95191),
(95192, '2.60.40.10-FF-004234', NULL, NULL, 56, NULL, NULL, 95192),
(95193, '3.40.630.30-FF-000235', NULL, 'Putative acetyltransferase', 136, NULL, NULL, 95193),
(95194, '1.20.1250.20-FF-001175', NULL, 'Sodium-dependent glucose transporter 1', 255, NULL, NULL, 95194),
(95195, '3.30.70.260-FF-000098', NULL, 'Formyltetrahydrofolate deformylase 2, mitochondrial', 73, NULL, NULL, 95195),
(95196, '1.25.40.20-FF-000835', NULL, 'TRPA1(A) isoform', 117, NULL, NULL, 95196),
(95197, '1.10.510.10-FF-001010', NULL, 'Serine/threonine-protein kinase Chk2', 305, NULL, NULL, 95197),
(95198, '3.40.50.720-FF-001640', NULL, 'SDR family oxidoreductase', 317, NULL, NULL, 95198),
(95199, '1.25.40.10-FF-001468', NULL, 'Pentatricopeptide repeat-containing protein', 84, NULL, NULL, 95199),
(95200, '1.20.1640.10-FF-000044', NULL, 'Multifunctional fusion protein', 185, NULL, NULL, 95200),
(95201, '1.10.560.10-FF-000007', NULL, 'T-complex protein 1 subunit zeta', 232, NULL, NULL, 95201),
(95202, '3.10.20.90-FF-000187', NULL, 'Tubulin-folding cofactor E', 94, NULL, NULL, 95202),
(95203, '2.10.220.10-FF-000107', NULL, 'Uncharacterized protein', 97, NULL, NULL, 95203),
(95204, '3.90.1750.10-FF-000063', NULL, 'Putative E3 ubiquitin-protein ligase HECTD4', 70, NULL, NULL, 95204),
(95205, '1.10.510.10-FF-000622', NULL, 'Tyrosine-protein kinase', 265, NULL, NULL, 95205),
(95206, '2.130.10.10-FF-004425', NULL, 'Uncharacterized protein', 359, NULL, NULL, 95206),
(95207, '1.10.10.10-FF-000274', NULL, 'Cullin 4B', 74, NULL, NULL, 95207),
(95208, '1.20.5.1430-FF-000008', NULL, 'EB1 homolog, putative', 88, NULL, NULL, 95208),
(95209, '3.10.20.90-FF-000204', NULL, 'tether containing UBX domain for GLUT4', 86, NULL, NULL, 95209),
(95210, '1.25.10.10-FF-001539', NULL, 'Mo25-like family protein', 360, NULL, NULL, 95210),
(95211, '2.40.170.20-FF-000054', NULL, 'SusC/RagA family TonB-linked outer membrane protein', 667, NULL, NULL, 95211),
(95212, '3.30.9.10-FF-000209', NULL, 'Uncharacterized protein', 16, NULL, NULL, 95212),
(95213, '3.90.226.10-FF-000110', NULL, 'Propionyl-CoA carboxylase, putative', 259, NULL, NULL, 95213),
(95214, '3.30.160.60-FF-004330', NULL, NULL, 22, NULL, NULL, 95214),
(95215, '1.10.580.10-FF-000020', NULL, 'Citrate synthase', 220, NULL, NULL, 95215),
(95216, '3.40.630.10-FF-000324', NULL, 'Uncharacterized protein', 51, NULL, NULL, 95216),
(95217, '4.10.400.10-FF-000338', NULL, 'Uncharacterized protein', 37, NULL, NULL, 95217);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(95218, '2.70.130.10-FF-000036', NULL, 'Endoplasmic reticulum lectin 1', 75, NULL, NULL, 95218),
(95219, '2.130.10.10-FF-002059', NULL, 'Uncharacterized protein', 326, NULL, NULL, 95219),
(95220, '4.10.400.10-FF-000226', NULL, 'Corin, isoform B', 40, NULL, NULL, 95220),
(95221, '2.60.40.10-FF-005858', NULL, NULL, 96, NULL, NULL, 95221),
(95222, '3.90.79.10-FF-000008', NULL, 'cleavage and polyadenylation specificity factor subunit 5', 193, NULL, NULL, 95222),
(95223, '1.20.5.110-FF-000339', NULL, 'Uncharacterized protein', 34, NULL, NULL, 95223),
(95224, '2.40.10.10-FF-000523', NULL, NULL, 103, NULL, NULL, 95224),
(95225, '2.40.40.10-FF-000019', NULL, NULL, 123, NULL, NULL, 95225),
(95226, '1.10.30.10-FF-000163', NULL, 'Protein maelstrom', 54, NULL, NULL, 95226),
(95227, '2.10.25.10-FF-001312', NULL, 'Si:dkey-237h12.3', 29, NULL, NULL, 95227),
(95228, '3.40.50.300-FF-004151', NULL, 'DNA repair protein RAD51 homolog 4', 164, NULL, NULL, 95228),
(95229, '3.40.50.2000-FF-001085', NULL, 'Uncharacterized protein', 111, NULL, NULL, 95229),
(95230, '3.40.1090.10-FF-000023', NULL, 'Phospholipase A2 group IVC', 465, NULL, NULL, 95230),
(95231, '1.20.58.1100-FF-000016', NULL, 'Uncharacterized protein', 74, NULL, NULL, 95231),
(95232, '2.30.30.40-FF-000152', NULL, 'Tyrosine-protein kinase', 70, NULL, NULL, 95232),
(95233, '1.10.540.10-FF-000118', NULL, 'Acyl-CoA dehydrogenase', 102, NULL, NULL, 95233),
(95234, '2.110.10.10-FF-000003', NULL, 'Matrix metallopeptidase 17', 197, NULL, NULL, 95234),
(95235, '2.30.30.220-FF-000003', NULL, 'Stringent starvation protein B', 125, NULL, NULL, 95235),
(95236, '3.30.230.70-FF-000050', NULL, 'Unplaced genomic scaffold supercont2.8, whole genome shotgun sequence', 324, NULL, NULL, 95236),
(95237, '1.10.20.10-FF-000213', NULL, NULL, 110, NULL, NULL, 95237),
(95238, '1.10.10.10-FF-001691', NULL, 'Uncharacterized protein', 106, NULL, NULL, 95238),
(95239, '2.60.40.2840-FF-000006', NULL, 'Phosphatidylethanolamine N-methyltransferase', 140, NULL, NULL, 95239),
(95240, '1.20.1280.50-FF-000168', NULL, 'F-box only protein 31-B', 77, NULL, NULL, 95240),
(95241, '2.130.10.10-FF-003818', NULL, 'Uncharacterized protein', 304, NULL, NULL, 95241),
(95242, '1.10.8.470-FF-000005', NULL, 'Ribosome-binding ATPase YchF protein', 90, NULL, NULL, 95242),
(95243, '2.10.220.10-FF-000096', NULL, 'Furin-like protease 2', 54, NULL, NULL, 95243),
(95244, '1.25.40.20-FF-000274', NULL, 'Ankyrin repeat and SOCS box containing 8', 135, NULL, NULL, 95244),
(95245, '1.25.10.10-FF-001871', NULL, 'Predicted protein', 143, NULL, NULL, 95245),
(95246, '3.30.160.60-FF-000620', NULL, 'Zinc finger protein 263', 28, NULL, NULL, 95246),
(95247, '1.10.8.460-FF-000002', NULL, NULL, 54, NULL, NULL, 95247),
(95248, '3.80.10.10-FF-003195', NULL, 'Predicted protein', 228, NULL, NULL, 95248),
(95249, '2.60.40.10-FF-002643', NULL, 'Chaperone CupA5', 122, NULL, NULL, 95249),
(95250, '1.10.8.480-FF-000008', NULL, 'rRNA adenine N(6)-methyltransferase', 123, NULL, NULL, 95250),
(95251, '3.40.50.720-FF-001078', NULL, 'Probable short-chain type dehydrogenase/reductase', 274, NULL, NULL, 95251),
(95252, '3.40.50.300-FF-000553', NULL, 'Mitochondrial Rho GTPase', 98, NULL, NULL, 95252),
(95253, '3.30.450.400-FF-000001', NULL, 'Putative Bacteriocin', 151, NULL, NULL, 95253),
(95254, '1.10.510.10-FF-002213', NULL, NULL, 32, NULL, NULL, 95254),
(95255, '1.25.40.10-FF-004323', NULL, 'Uncharacterized protein', 172, NULL, NULL, 95255),
(95256, '1.10.510.10-FF-001595', NULL, 'Os08g0365500 protein', 219, NULL, NULL, 95256),
(95257, '3.10.110.10-FF-000331', NULL, 'Ubiquitin protein ligase, putative', 154, NULL, NULL, 95257),
(95258, '1.10.287.110-FF-000413', NULL, 'J domain-containing protein spf31', 100, NULL, NULL, 95258),
(95259, '2.40.30.180-FF-000011', NULL, 'Ubiquitin-activating enzyme E1', 127, NULL, NULL, 95259),
(95260, '3.30.70.100-FF-000078', NULL, 'Acylphosphatase', 108, NULL, NULL, 95260),
(95261, '3.40.50.1820-FF-001800', NULL, 'Uncharacterized protein', 146, NULL, NULL, 95261),
(95262, '3.30.40.10-FF-000956', NULL, 'Ubiquitin C-terminal hydrolase Ubp8, putative', 124, NULL, NULL, 95262);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(95263, '3.90.550.10-FF-000374', NULL, 'Uncharacterized protein', 356, NULL, NULL, 95263),
(95264, '3.40.50.300-FF-008192', NULL, 'Midasin', 76, NULL, NULL, 95264),
(95265, '1.25.40.10-FF-000271', NULL, 'Tetratricopeptide repeat domain 26', 114, NULL, NULL, 95265),
(95266, '3.60.21.10-FF-000107', NULL, 'Serine/threonine-protein phosphatase', 301, NULL, NULL, 95266),
(95267, '2.70.170.10-FF-000145', NULL, 'Protein CBR-LGC-31', 144, NULL, NULL, 95267),
(95268, '1.20.5.990-FF-000007', NULL, 'TNFAIP3 interacting protein 2', 105, NULL, NULL, 95268),
(95269, '2.10.25.10-FF-000694', NULL, 'Integrin beta', 46, NULL, NULL, 95269),
(95270, '1.20.1560.10-FF-000908', NULL, 'Uncharacterized protein', 159, NULL, NULL, 95270),
(95271, '3.40.50.300-FF-003987', NULL, 'RAD50 homolog uvs-6', 250, NULL, NULL, 95271),
(95272, '3.30.160.60-FF-000395', NULL, 'zinc finger protein 513', 29, NULL, NULL, 95272),
(95273, '3.10.450.580-FF-000008', NULL, 'Mediator of RNA polymerase II transcription subunit 6', 144, NULL, NULL, 95273),
(95274, '2.40.240.10-FF-000057', NULL, '50S ribosomal protein L25', 86, NULL, NULL, 95274),
(95275, '3.40.50.300-FF-000339', NULL, 'Uridine kinase', 207, NULL, NULL, 95275),
(95276, '3.30.830.10-FF-000033', NULL, 'Stromal processing peptidase, chloroplastic', 168, NULL, NULL, 95276),
(95277, '3.10.110.10-FF-000117', NULL, 'Putative ubiquitin-conjugating enzyme e2', 147, NULL, NULL, 95277),
(95278, '3.30.70.330-FF-001445', NULL, 'Related to RNA-binding protein 8A', 136, NULL, NULL, 95278),
(95279, '1.10.510.10-FF-001819', NULL, 'Protein_kinase_-_putative', 323, NULL, NULL, 95279),
(95280, '2.60.40.10-FF-001379', NULL, 'Usherin', 97, NULL, NULL, 95280),
(95281, '3.20.10.10-FF-000073', NULL, 'Uncharacterized protein', 108, NULL, NULL, 95281),
(95282, '3.90.550.50-FF-000240', NULL, 'Uncharacterized protein', 191, NULL, NULL, 95282),
(95283, '3.40.50.300-FF-002790', NULL, 'Dbp45A', 172, NULL, NULL, 95283),
(95284, '2.130.10.10-FF-005398', NULL, 'Uncharacterized protein', 147, NULL, NULL, 95284),
(95285, '1.25.40.20-FF-000740', NULL, 'Ankyrin_repeats_(Many_copies)/Ankyrin_repeats_(3_ copies)/Ankyrin_repeat_-_putative', 181, NULL, NULL, 95285),
(95286, '3.30.420.40-FF-000336', NULL, 'Exopolyphosphatase', 111, NULL, NULL, 95286),
(95287, '1.25.40.500-FF-000003', NULL, 'Transcription initiation factor TFIID subunit 5', 146, NULL, NULL, 95287),
(95288, '3.30.70.100-FF-000196', NULL, NULL, 112, NULL, NULL, 95288),
(95289, '3.40.50.300-FF-008203', NULL, 'Os07g0689300 protein', 73, NULL, NULL, 95289),
(95290, '1.20.120.1900-FF-000090', NULL, 'Spindle pole body component', 403, NULL, NULL, 95290),
(95291, '3.40.190.80-FF-000058', NULL, 'Inositol-1-monophosphatase', 130, NULL, NULL, 95291),
(95292, '3.30.200.20-FF-000005', NULL, 'cAMP-dependent protein kinase catalytic subunit', 99, NULL, NULL, 95292),
(95293, '1.25.10.10-FF-002146', NULL, 'Uncharacterized protein', 537, NULL, NULL, 95293),
(95294, '1.20.1560.10-FF-000897', NULL, 'ATP-binding cassette, sub-family B (MDR/TAP), member 9', 224, NULL, NULL, 95294),
(95295, '1.10.10.10-FF-001898', NULL, 'Predicted protein', 104, NULL, NULL, 95295),
(95296, '3.80.10.10-FF-001312', NULL, 'Receptor-like protein kinase HSL1', 73, NULL, NULL, 95296),
(95297, '3.90.226.10-FF-000008', NULL, 'Acetyl-coenzyme A carboxylase carboxyl transferase subunit alpha', 316, NULL, NULL, 95297),
(95298, '3.50.50.60-FF-001196', NULL, 'Amine oxidase', 416, NULL, NULL, 95298),
(95299, '3.40.190.80-FF-000069', NULL, 'Extragenic suppressor', 116, NULL, NULL, 95299),
(95300, '1.20.1280.50-FF-000157', NULL, 'Predicted protein', 91, NULL, NULL, 95300),
(95301, '1.20.1050.20-FF-000007', NULL, 'Signal transducer and activator of transcription 1', 196, NULL, NULL, 95301),
(95302, '3.90.550.50-FF-000032', NULL, 'Parasite-infected erythrocyte surface protein', 135, NULL, NULL, 95302),
(95303, '1.20.1050.10-FF-000004', NULL, 'Glutathione S-transferase F2', 122, NULL, NULL, 95303),
(95304, '3.40.250.10-FF-000256', NULL, 'Uncharacterized protein', 64, NULL, NULL, 95304),
(95305, '3.40.630.30-FF-000443', NULL, 'Uncharacterized protein', 202, NULL, NULL, 95305);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(95306, '2.60.120.620-FF-000138', NULL, 'Predicted protein', 232, NULL, NULL, 95306),
(95307, '1.10.1420.10-FF-000108', NULL, 'DNA mismatch repair protein MSH3', 137, NULL, NULL, 95307),
(95308, '3.30.70.1170-FF-000023', NULL, 'NOL1/NOP2/sun family protein', 37, NULL, NULL, 95308),
(95309, '1.20.5.100-FF-000016', NULL, 'Penicillin-binding protein 1B', 37, NULL, NULL, 95309),
(95310, '2.40.50.140-FF-000121', NULL, '30S ribosomal protein S1', 86, NULL, NULL, 95310),
(95311, '1.10.510.10-FF-000072', NULL, 'AP2 associated kinase 1', 305, NULL, NULL, 95311),
(95312, '3.90.228.10-FF-000058', NULL, 'Predicted protein', 154, NULL, NULL, 95312),
(95313, '3.40.630.30-FF-000673', NULL, 'Acetyltransferase, GNAT family protein', 146, NULL, NULL, 95313),
(95314, '2.10.220.10-FF-000085', NULL, 'Proprotein convertase subtilisin/kexin type 6', 69, NULL, NULL, 95314),
(95315, '3.20.20.70-FF-000445', NULL, '1-(5-phosphoribosyl)-5-[(5-phosphoribosylamino)methylideneamino] imidazole-4-carboxamide isomerase', 232, NULL, NULL, 95315),
(95316, '1.10.8.60-FF-000176', NULL, 'Replication related protein', 65, NULL, NULL, 95316),
(95317, '3.30.70.330-FF-000017', NULL, 'ELAV-like protein', 107, NULL, NULL, 95317),
(95318, '1.10.472.80-FF-000284', NULL, NULL, 95, NULL, NULL, 95318),
(95319, '1.10.510.10-FF-001696', NULL, 'Uncharacterized protein', 191, NULL, NULL, 95319),
(95320, '3.40.30.10-FF-000247', NULL, '28S ribosomal protein S25, mitochondrial', 106, NULL, NULL, 95320),
(95321, '3.40.109.10-FF-000001', NULL, 'Nitroreductase family', 198, NULL, NULL, 95321),
(95322, '2.130.10.10-FF-000373', NULL, 'WD repeat domain 78', 205, NULL, NULL, 95322),
(95323, '3.20.20.80-FF-000678', NULL, 'Predicted protein', 336, NULL, NULL, 95323),
(95324, '3.40.190.290-FF-000124', NULL, 'LysR family transcriptional regulator', 205, NULL, NULL, 95324),
(95325, '3.20.20.70-FF-000675', NULL, NULL, 205, NULL, NULL, 95325),
(95326, '2.30.180.10-FF-000161', NULL, NULL, 89, NULL, NULL, 95326),
(95327, '1.25.50.10-FF-000013', NULL, 'Predicted protein', 110, NULL, NULL, 95327),
(95328, '2.60.40.790-FF-000039', NULL, 'CS domain containing protein', 123, NULL, NULL, 95328),
(95329, '3.30.70.1010-FF-000003', NULL, 'Protein Translation Elongation Factor 1B subunitbeta (EF-1Bb)/1-gamma', 160, NULL, NULL, 95329),
(95330, '3.10.20.90-FF-000412', NULL, 'Nuclear protein localization', 78, NULL, NULL, 95330),
(95331, '2.60.40.10-FF-000406', NULL, 'angiopoietin-1 receptor isoform X2', 99, NULL, NULL, 95331),
(95332, '1.10.10.10-FF-000263', NULL, 'Interferon regulatory factor 3', 111, NULL, NULL, 95332),
(95333, '2.40.70.10-FF-000510', NULL, NULL, 91, NULL, NULL, 95333),
(95334, '3.30.160.60-FF-003846', NULL, NULL, 27, NULL, NULL, 95334),
(95335, '3.30.70.1020-FF-000006', NULL, 'Trehalose 6-phosphate phosphatase', 75, NULL, NULL, 95335),
(95336, '3.30.870.10-FF-000030', NULL, 'mitochondrial cardiolipin hydrolase', 181, NULL, NULL, 95336),
(95337, '3.30.830.10-FF-000151', NULL, 'Metalloenzyme, LuxS/M16 peptidase-like protein', 231, NULL, NULL, 95337),
(95338, '3.30.60.30-FF-000250', NULL, 'Uncharacterized protein', 40, NULL, NULL, 95338),
(95339, '3.90.550.10-FF-000256', NULL, 'UDP-glucose glycoprotein:glucosyltransferase, putative', 267, NULL, NULL, 95339),
(95340, '3.40.532.10-FF-000001', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 227, NULL, NULL, 95340),
(95341, '1.10.1130.10-FF-000007', NULL, 'C-type multiheme cytochrome', 74, NULL, NULL, 95341),
(95342, '3.40.50.880-FF-000024', NULL, 'Folate gamma-glutamyl hydrolase', 292, NULL, NULL, 95342),
(95343, '3.30.160.60-FF-004122', NULL, NULL, 31, NULL, NULL, 95343),
(95344, '3.30.70.1230-FF-000165', NULL, 'adenylate cyclase type 10-like', 200, NULL, NULL, 95344),
(95345, '3.40.50.10420-FF-000046', NULL, '5-formyltetrahydrofolate cyclo-ligase', 118, NULL, NULL, 95345),
(95346, '3.10.20.90-FF-000642', NULL, 'Uncharacterized protein', 72, NULL, NULL, 95346),
(95347, '2.120.10.30-FF-000340', NULL, 'Peptidase S9 prolyl oligopeptidase active site domain protein', 123, NULL, NULL, 95347),
(95348, '3.10.20.90-FF-000288', NULL, 'Autophagy-related protein', 124, NULL, NULL, 95348);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(95349, '1.10.132.60-FF-000011', NULL, 'DNA polymerase catalytic subunit', 213, NULL, NULL, 95349),
(95350, '3.40.50.1980-FF-000061', NULL, 'Iron complex transport system substrate-binding protein', 173, NULL, NULL, 95350),
(95351, '3.90.550.10-FF-000610', NULL, 'Predicted protein', 216, NULL, NULL, 95351),
(95352, '1.10.132.70-FF-000014', NULL, 'Telomerase reverse transcriptase', 278, NULL, NULL, 95352),
(95353, '3.90.1750.10-FF-000074', NULL, 'Putative ubiquitin-protein ligase e3c', 161, NULL, NULL, 95353),
(95354, '3.40.50.1820-FF-001137', NULL, 'Predicted protein', 191, NULL, NULL, 95354),
(95355, '2.30.29.30-FF-001247', NULL, 'Uncharacterized protein', 111, NULL, NULL, 95355),
(95356, '3.80.10.10-FF-002835', NULL, 'Uncharacterized protein', 289, NULL, NULL, 95356),
(95357, '3.80.10.10-FF-000694', NULL, 'Receptor-like protein kinase HSL1', 133, NULL, NULL, 95357),
(95358, '4.10.400.10-FF-000237', NULL, 'LDL receptor repeat-containing protein egg-1', 41, NULL, NULL, 95358),
(95359, '1.25.40.10-FF-005296', NULL, 'DnaJ domain containing protein', 133, NULL, NULL, 95359),
(95360, '1.25.40.10-FF-001709', NULL, 'Tetratricopeptide repeat domain 21A', 176, NULL, NULL, 95360),
(95361, '1.10.287.2250-FF-000016', NULL, 'Cathepsin 12', 69, NULL, NULL, 95361),
(95362, '3.30.9.10-FF-000086', NULL, 'Dehydrogenase', 153, NULL, NULL, 95362),
(95363, '1.10.287.600-FF-000015', NULL, 'Tubulin beta chain', 74, NULL, NULL, 95363),
(95364, '2.130.10.10-FF-002172', NULL, 'Uncharacterized protein', 128, NULL, NULL, 95364),
(95365, '3.30.160.60-FF-002418', NULL, 'FI01124p', 32, NULL, NULL, 95365),
(95366, '2.60.40.10-FF-001929', NULL, 'Down syndrome cell adhesion molecule 3, isoform C', 93, NULL, NULL, 95366),
(95367, '2.130.10.10-FF-001896', NULL, 'Cytoplasmic dynein 1 intermediate chain', 179, NULL, NULL, 95367),
(95368, '1.25.40.10-FF-001367', NULL, 'Pentatricopeptide repeat-containing protein At4g30825, chloroplastic', 113, NULL, NULL, 95368),
(95369, '2.120.10.30-FF-000020', NULL, 'Prolow-density lipoprotein receptor-related protein 1', 306, NULL, NULL, 95369),
(95370, '2.60.40.10-FF-003397', NULL, NULL, 109, NULL, NULL, 95370),
(95371, '1.20.58.520-FF-000001', NULL, 'Imidazolonepropionase-like amidohydrolase', 96, NULL, NULL, 95371),
(95372, '2.60.40.10-FF-004335', NULL, NULL, 62, NULL, NULL, 95372),
(95373, '3.20.20.140-FF-000088', NULL, 'Histidinol-phosphatase', 290, NULL, NULL, 95373),
(95374, '1.25.40.10-FF-003497', NULL, 'Uncharacterized protein', 70, NULL, NULL, 95374),
(95375, '3.30.420.40-FF-000106', NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', 188, NULL, NULL, 95375),
(95376, '3.30.540.10-FF-000050', NULL, 'Fructose-1,6-bisphosphatase class 1', 178, NULL, NULL, 95376),
(95377, '2.60.40.10-FF-002205', NULL, 'V-set and immunoglobulin domain containing 10 like', 97, NULL, NULL, 95377),
(95378, '2.60.40.10-FF-005869', NULL, NULL, 84, NULL, NULL, 95378),
(95379, '3.40.50.300-FF-004381', NULL, 'Zgc:158417', 201, NULL, NULL, 95379),
(95380, '1.20.120.920-FF-000002', NULL, 'CRISPR-associated endonuclease Cas1', 197, NULL, NULL, 95380),
(95381, '2.20.28.230-FF-000005', NULL, 'Interleukin 15 receptor alpha isoform 2', 52, NULL, NULL, 95381),
(95382, '3.30.565.10-FF-000034', NULL, 'DNA mismatch repair protein mlh1, putative', 214, NULL, NULL, 95382),
(95383, '4.10.280.10-FF-000137', NULL, 'Transcription factor bHLH52', 70, NULL, NULL, 95383),
(95384, '2.60.40.10-FF-002435', NULL, 'Fc receptor like 5', 82, NULL, NULL, 95384),
(95385, '3.30.1490.220-FF-000009', NULL, 'Inositol-tetrakisphosphate 1-kinase', 106, NULL, NULL, 95385),
(95386, '1.20.1280.50-FF-000270', NULL, 'Predicted protein', 42, NULL, NULL, 95386),
(95387, '1.20.58.530-FF-000004', NULL, 'Unconventional myosin ID', 195, NULL, NULL, 95387),
(95388, '2.130.10.10-FF-000614', NULL, 'WD domain protein', 128, NULL, NULL, 95388),
(95389, '3.90.1410.10-FF-000037', NULL, 'SET (Trithorax/polycomb) domain containing', 311, NULL, NULL, 95389),
(95390, '3.40.50.1100-FF-000292', NULL, 'Uncharacterized protein', 99, NULL, NULL, 95390); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(95391, '1.10.150.240-FF-000104', NULL, 'Slr0458 protein', 66, NULL, NULL, 95391),
(95392, '3.40.50.300-FF-002913', NULL, 'NO-associated protein 1, chloroplastic/mitochondrial', 177, NULL, NULL, 95392),
(95393, '1.10.287.110-FF-000205', NULL, 'DnaJ protein', 120, NULL, NULL, 95393),
(95394, '2.60.40.10-FF-000305', NULL, 'neurotrimin isoform X2', 94, NULL, NULL, 95394),
(95395, '2.40.20.10-FF-000024', NULL, 'Uncharacterized protein', 82, NULL, NULL, 95395),
(95396, '1.50.40.10-FF-000448', NULL, 'Mitochondrial dicarboxylate/tricarboxylate transporter DTC', 132, NULL, NULL, 95396),
(95397, '2.60.40.1120-FF-000041', NULL, 'Predicted protein', 78, NULL, NULL, 95397),
(95398, '1.10.238.10-FF-000152', NULL, 'Centrin 3', 66, NULL, NULL, 95398),
(95399, '3.90.226.10-FF-000121', NULL, 'Serine protease SPPA, chloroplastic', 195, NULL, NULL, 95399),
(95400, '2.60.120.10-FF-000358', NULL, 'Camk protein kinase', 129, NULL, NULL, 95400),
(95401, '3.30.70.330-FF-001653', NULL, NULL, 86, NULL, NULL, 95401),
(95402, '1.10.10.10-FF-001359', NULL, 'Putative ATP-dependent RNA helicase', 129, NULL, NULL, 95402),
(95403, '3.40.50.720-FF-001286', NULL, 'Uncharacterized oxidoreductase C162.03', 285, NULL, NULL, 95403),
(95404, '3.30.200.20-FF-001972', NULL, 'Uncharacterized protein', 102, NULL, NULL, 95404),
(95405, '2.40.30.10-FF-000390', NULL, 'translation initiation factor IF-2, mitochondrial', 122, NULL, NULL, 95405),
(95406, '3.40.50.300-FF-006281', NULL, 'Uncharacterized protein', 174, NULL, NULL, 95406),
(95407, '1.10.533.10-FF-000107', NULL, 'Nucleotide-binding oligomerization domain-containing protein 1', 94, NULL, NULL, 95407),
(95408, '3.40.50.10810-FF-000270', NULL, 'Uncharacterized protein', 118, NULL, NULL, 95408),
(95409, '3.30.160.60-FF-002076', NULL, 'Uncharacterized protein', 29, NULL, NULL, 95409),
(95410, '1.20.1250.20-FF-001416', NULL, 'Slc-17.2', 181, NULL, NULL, 95410),
(95411, '3.60.9.10-FF-000002', NULL, 'Aldehyde ferredoxin oxidoreductase', 229, NULL, NULL, 95411),
(95412, '3.40.50.2300-FF-001388', NULL, NULL, 80, NULL, NULL, 95412),
(95413, '3.90.640.90-FF-000023', NULL, 'Uncharacterized protein', 116, NULL, NULL, 95413),
(95414, '1.25.40.10-FF-003828', NULL, 'Uncharacterized protein', 126, NULL, NULL, 95414),
(95415, '3.30.160.60-FF-000518', NULL, 'Zinc finger protein', 29, NULL, NULL, 95415),
(95416, '2.130.10.10-FF-004324', NULL, 'Uncharacterized protein', 104, NULL, NULL, 95416),
(95417, '3.30.1370.10-FF-000120', NULL, 'Uncharacterized protein, isoform D', 75, NULL, NULL, 95417),
(95418, '1.20.58.390-FF-000265', NULL, 'Uncharacterized protein', 89, NULL, NULL, 95418),
(95419, '2.10.90.10-FF-000092', NULL, 'GM13635', 137, NULL, NULL, 95419),
(95420, '2.160.20.70-FF-000047', NULL, 'Tubulin folding cofactor C, putative', 190, NULL, NULL, 95420),
(95421, '2.60.40.1120-FF-000030', NULL, 'Silver, isoform N', 86, NULL, NULL, 95421),
(95422, '2.30.180.10-FF-000059', NULL, 'Stabilin 2', 138, NULL, NULL, 95422),
(95423, '3.40.50.150-FF-000581', NULL, 'Methyltransferase like 1', 52, NULL, NULL, 95423),
(95424, '3.30.160.60-FF-000631', NULL, 'zinc finger protein 189 isoform X2', 35, NULL, NULL, 95424),
(95425, '1.10.8.10-FF-000296', NULL, 'Ubiquitin family protein', 88, NULL, NULL, 95425),
(95426, '3.10.450.50-FF-000031', NULL, 'Unplaced genomic scaffold supercont2.3, whole genome shotgun sequence', 207, NULL, NULL, 95426),
(95427, '3.30.40.10-FF-001119', NULL, 'Ubiquitinyl hydrolase 1', 105, NULL, NULL, 95427),
(95428, '3.30.70.330-FF-002968', NULL, NULL, 99, NULL, NULL, 95428),
(95429, '1.10.472.10-FF-000280', NULL, 'Protein CBG20098', 147, NULL, NULL, 95429),
(95430, '3.40.50.300-FF-007719', NULL, 'Uncharacterized protein', 94, NULL, NULL, 95430),
(95431, '3.30.160.60-FF-006460', NULL, NULL, 23, NULL, NULL, 95431),
(95432, '2.60.40.1510-FF-000051', NULL, 'Im:7145180 protein', 80, NULL, NULL, 95432),
(95433, '2.60.40.1180-FF-000132', NULL, 'Alpha-amylase', 109, NULL, NULL, 95433),
(95434, '3.80.10.10-FF-001750', NULL, 'Predicted gene 3259', 171, NULL, NULL, 95434),
(95435, '3.40.50.300-FF-000452', NULL, 'DnaA regulatory inactivator Hda', 165, NULL, NULL, 95435);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(95436, '1.10.10.10-FF-001797', NULL, 'Histone acetyltransferase', 50, NULL, NULL, 95436),
(95437, '1.20.1260.100-FF-000014', NULL, NULL, 61, NULL, NULL, 95437),
(95438, '2.130.10.10-FF-005948', NULL, 'Transducin family protein / WD-40 repeat family protein', 251, NULL, NULL, 95438),
(95439, '3.40.50.150-FF-000923', NULL, 'S-adenosyl-L-methionine-dependent methyltransferases superfamily protein', 336, NULL, NULL, 95439),
(95440, '2.10.25.10-FF-001418', NULL, 'Uncharacterized protein', 42, NULL, NULL, 95440),
(95441, '3.80.10.10-FF-003650', NULL, 'Predicted protein', 174, NULL, NULL, 95441),
(95442, '3.40.50.300-FF-002352', NULL, 'ABC transporter B family member 7', 166, NULL, NULL, 95442),
(95443, '1.10.287.470-FF-000049', NULL, 'Multidrug resistance protein VceA', 71, NULL, NULL, 95443),
(95444, '3.40.120.10-FF-000033', NULL, 'Phosphomannomutase / phosphoglucomutase', 150, NULL, NULL, 95444),
(95445, '1.10.238.10-FF-000713', NULL, 'Myosin, essential light chain', 77, NULL, NULL, 95445),
(95446, '2.10.25.10-FF-000935', NULL, 'Matrilin 3a', 46, NULL, NULL, 95446),
(95447, '2.30.39.10-FF-000146', NULL, 'Serpin peptidase inhibitor 6', 149, NULL, NULL, 95447),
(95448, '3.40.50.1000-FF-000374', NULL, 'E1-E2 ATPase superfamily protein', 169, NULL, NULL, 95448),
(95449, '2.30.30.140-FF-000209', NULL, 'Histone acetyltransferase', 77, NULL, NULL, 95449),
(95450, '3.80.10.10-FF-003431', NULL, 'EIN3-binding F-box protein 1', 66, NULL, NULL, 95450),
(95451, '2.60.120.10-FF-000471', NULL, 'Homogentisate 1,2-dioxygenase, putative', 138, NULL, NULL, 95451),
(95452, '2.30.42.10-FF-000030', NULL, 'Partitioning defective 6 homolog beta', 128, NULL, NULL, 95452),
(95453, '3.90.260.10-FF-000054', NULL, 'Uncharacterized protein', 100, NULL, NULL, 95453),
(95454, '1.10.20.10-FF-000005', NULL, 'Histone H2A', 122, NULL, NULL, 95454),
(95455, '2.60.200.20-FF-000171', NULL, 'AGAP003213-PA', 99, NULL, NULL, 95455),
(95456, '3.40.50.300-FF-007377', NULL, 'DNA helicase', 177, NULL, NULL, 95456),
(95457, '1.10.287.70-FF-000783', NULL, 'Uncharacterized protein', 81, NULL, NULL, 95457),
(95458, '3.40.140.10-FF-000141', NULL, 'Lys-63-specific deubiquitinase BRCC36', 130, NULL, NULL, 95458),
(95459, '1.10.472.130-FF-000083', NULL, 'Dynein heavy chain at 16F', 155, NULL, NULL, 95459),
(95460, '3.40.50.2020-FF-000017', NULL, 'Ribose-phosphate pyrophosphokinase 1', 147, NULL, NULL, 95460),
(95461, '3.30.390.60-FF-000002', NULL, 'Heat-inducible transcription repressor HrcA', 102, NULL, NULL, 95461),
(95462, '1.20.120.350-FF-000270', NULL, NULL, 94, NULL, NULL, 95462),
(95463, '1.10.560.10-FF-000018', NULL, 'T-complex protein 1, zeta subunit', 231, NULL, NULL, 95463),
(95464, '3.10.50.40-FF-000039', NULL, 'Peptidylprolyl isomerase', 110, NULL, NULL, 95464),
(95465, '4.10.860.120-FF-000002', NULL, 'DNA-directed RNA polymerase subunit', 49, NULL, NULL, 95465),
(95466, '1.10.510.10-FF-000633', NULL, 'AGC/AKT protein kinase', 210, NULL, NULL, 95466),
(95467, '1.25.10.20-FF-000019', NULL, 'Vtg3 protein', 203, NULL, NULL, 95467),
(95468, '1.20.5.4770-FF-000004', NULL, 'OTU deubiquitinase 7A', 45, NULL, NULL, 95468),
(95469, '1.50.10.10-FF-000059', NULL, 'YMR196W-like protein', 266, NULL, NULL, 95469),
(95470, '1.10.510.10-FF-002533', NULL, 'protein O-mannose kinase-like', 311, NULL, NULL, 95470),
(95471, '3.30.160.60-FF-006128', NULL, NULL, 34, NULL, NULL, 95471),
(95472, '3.10.110.10-FF-000011', NULL, 'Ubiquitin-conjugating enzyme E2 L3', 154, NULL, NULL, 95472),
(95473, '3.30.230.70-FF-000151', NULL, 'Uncharacterized protein', 86, NULL, NULL, 95473),
(95474, '3.30.200.20-FF-002135', NULL, 'Stretchin-MLCK', 71, NULL, NULL, 95474),
(95475, '3.30.1360.120-FF-000035', NULL, 'IBA57, iron-sulfur cluster assembly', 154, NULL, NULL, 95475),
(95476, '3.40.50.300-FF-000098', NULL, 'Probable GTP-binding protein EngB', 210, NULL, NULL, 95476),
(95477, '3.40.50.300-FF-003667', NULL, 'Putative ATP-dependent RNA helicase', 266, NULL, NULL, 95477),
(95478, '1.25.10.10-FF-000016', NULL, 'Serine/threonine-protein phosphatase 2A 56 kDa regulatory subunit', 402, NULL, NULL, 95478);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(95479, '3.30.160.60-FF-004560', NULL, NULL, 30, NULL, NULL, 95479),
(95480, '2.60.40.60-FF-000623', NULL, 'Uncharacterized protein', 85, NULL, NULL, 95480),
(95481, '1.50.40.10-FF-000218', NULL, 'GG15457', 271, NULL, NULL, 95481),
(95482, '2.30.30.40-FF-000039', NULL, 'Vav guanine nucleotide exchange factor 3', 63, NULL, NULL, 95482),
(95483, '2.60.120.650-FF-000001', NULL, 'Putative lysine-specific demethylase 5b', 284, NULL, NULL, 95483),
(95484, '1.20.1560.10-FF-000886', NULL, 'ABC protein, subfamily ABCC', 144, NULL, NULL, 95484),
(95485, '2.10.25.10-FF-001211', NULL, 'Fibulin 2', 43, NULL, NULL, 95485),
(95486, '2.70.150.10-FF-000245', NULL, 'Uncharacterized protein', 97, NULL, NULL, 95486),
(95487, '3.40.30.10-FF-000685', NULL, 'Glutathione S-transferase', 104, NULL, NULL, 95487),
(95488, '3.40.50.300-FF-004504', NULL, 'Putative ABC transporter ATP-binding component', 230, NULL, NULL, 95488),
(95489, '1.10.3460.10-FF-000004', NULL, 'Chlorophyll a-b binding protein, chloroplastic', 187, NULL, NULL, 95489),
(95490, '3.40.50.300-FF-005786', NULL, 'Uncharacterized protein', 86, NULL, NULL, 95490),
(95491, '3.40.50.620-FF-000885', NULL, 'Tryptophanyl-trna synthetase', 102, NULL, NULL, 95491),
(95492, '1.10.1740.10-FF-000037', NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', 85, NULL, NULL, 95492),
(95493, '3.40.50.1440-FF-000034', NULL, 'Tubulin beta chain', 54, NULL, NULL, 95493),
(95494, '1.20.1070.10-FF-001427', NULL, 'Uncharacterized protein', 227, NULL, NULL, 95494),
(95495, '2.60.40.10-FF-005971', NULL, NULL, 103, NULL, NULL, 95495),
(95496, '3.10.100.10-FF-000050', NULL, 'Secretory phospholipase A2 receptor', 152, NULL, NULL, 95496),
(95497, '2.40.10.10-FF-000282', NULL, 'Serine-type enodpeptidase, putative', 99, NULL, NULL, 95497),
(95498, '1.20.58.1590-FF-000005', NULL, 'Tethering factor for nuclear proteasome STS1', 216, NULL, NULL, 95498),
(95499, '1.10.8.870-FF-000018', NULL, 'Glycerol-3-phosphate dehydrogenase', 119, NULL, NULL, 95499),
(95500, '2.60.120.200-FF-000586', NULL, 'Uncharacterized protein', 163, NULL, NULL, 95500),
(95501, '2.30.29.30-FF-001360', NULL, 'Uncharacterized protein', 132, NULL, NULL, 95501),
(95502, '3.30.470.110-FF-000002', NULL, 'ATP-citrate synthase alpha chain protein', 233, NULL, NULL, 95502),
(95503, '3.30.2350.20-FF-000010', NULL, 'Putative pseudouridine synthase YOR243C family', 243, NULL, NULL, 95503),
(95504, '1.10.437.10-FF-000058', NULL, 'Uncharacterized protein', 196, NULL, NULL, 95504),
(95505, '3.90.70.10-FF-000371', NULL, 'Calpain 10', 125, NULL, NULL, 95505),
(95506, '2.60.120.620-FF-000026', NULL, 'Procollagen-lysine,2-oxoglutarate 5-dioxygenase', 173, NULL, NULL, 95506),
(95507, '2.60.120.920-FF-000009', NULL, 'E3 ubiquitin-protein ligase TRIM9 isoform X1', 156, NULL, NULL, 95507),
(95508, '3.40.50.300-FF-004156', NULL, 'Putative rab40c member ras oncoprotein family', 183, NULL, NULL, 95508),
(95509, '3.30.70.890-FF-000062', NULL, 'Mevalonate kinase', 143, NULL, NULL, 95509),
(95510, '3.30.40.10-FF-001439', NULL, 'TNF receptor-associated factor 4', 56, NULL, NULL, 95510),
(95511, '1.50.10.10-FF-000166', NULL, 'alpha-1,2-Mannosidase', 544, NULL, NULL, 95511),
(95512, '1.25.40.10-FF-000400', NULL, 'Putative transcriptional regulator', 196, NULL, NULL, 95512),
(95513, '2.40.30.130-FF-000030', NULL, 'Alanine--tRNA ligase', 107, NULL, NULL, 95513),
(95514, '3.10.100.10-FF-000162', NULL, 'Polycystic kidney disease 1a', 134, NULL, NULL, 95514),
(95515, '1.25.40.20-FF-000403', NULL, 'Kinase D interacting substrate 220', 103, NULL, NULL, 95515),
(95516, '3.40.50.1000-FF-000711', NULL, NULL, 99, NULL, NULL, 95516),
(95517, '1.10.510.10-FF-002090', NULL, NULL, 111, NULL, NULL, 95517),
(95518, '3.40.50.2300-FF-000899', NULL, NULL, 145, NULL, NULL, 95518),
(95519, '3.30.499.10-FF-000037', NULL, NULL, 60, NULL, NULL, 95519),
(95520, '3.90.640.10-FF-000269', NULL, 'Uncharacterized protein', 47, NULL, NULL, 95520),
(95521, '2.70.130.10-FF-000031', NULL, 'Yos9p', 113, NULL, NULL, 95521),
(95522, '1.20.870.10-FF-000051', NULL, 'Rap guanine nucleotide exchange factor 5', 96, NULL, NULL, 95522);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(95523, '1.20.1250.20-FF-000579', NULL, 'MFS transporter', 186, NULL, NULL, 95523),
(95524, '3.40.50.300-FF-007933', NULL, 'Uncharacterized protein', 173, NULL, NULL, 95524),
(95525, '1.25.40.10-FF-005178', NULL, 'Uncharacterized protein', 54, NULL, NULL, 95525),
(95526, '3.20.20.70-FF-000563', NULL, '2-nitropropane dioxygenase', 342, NULL, NULL, 95526),
(95527, '1.10.20.10-FF-000218', NULL, NULL, 60, NULL, NULL, 95527),
(95528, '1.10.1450.10-FF-000161', NULL, 'Tetraspanin', 74, NULL, NULL, 95528),
(95529, '3.90.550.10-FF-000150', NULL, 'Collagen beta(1-O)galactosyltransferase 1', 129, NULL, NULL, 95529),
(95530, '3.10.450.10-FF-000036', NULL, 'AGAP002879-PA', 97, NULL, NULL, 95530),
(95531, '1.10.238.200-FF-000026', NULL, 'Defective in cullin neddylation protein', 94, NULL, NULL, 95531),
(95532, '3.30.70.330-FF-002041', NULL, NULL, 154, NULL, NULL, 95532),
(95533, '4.10.1240.10-FF-000042', NULL, 'Parathyroid hormone receptor-like protein bf98C', 102, NULL, NULL, 95533),
(95534, '3.40.50.10610-FF-000002', NULL, 'Penicillin-binding protein activator LpoB', 136, NULL, NULL, 95534),
(95535, '3.40.50.720-FF-001073', NULL, 'Predicted protein', 323, NULL, NULL, 95535),
(95536, '1.10.287.110-FF-000418', NULL, 'Uncharacterized protein', 97, NULL, NULL, 95536),
(95537, '2.60.120.310-FF-000028', NULL, 'Uncharacterized protein', 103, NULL, NULL, 95537),
(95538, '1.10.730.10-FF-000161', NULL, 'YALI0D03619p', 183, NULL, NULL, 95538),
(95539, '3.40.50.300-FF-005679', NULL, 'Uncharacterized protein', 187, NULL, NULL, 95539),
(95540, '3.40.140.10-FF-000242', NULL, 'Os10g0506300 protein', 153, NULL, NULL, 95540),
(95541, '3.40.50.300-FF-006303', NULL, 'Regulator of nonsense transcripts 1', 211, NULL, NULL, 95541),
(95542, '3.20.20.80-FF-000566', NULL, 'Chitinase, putative', 86, NULL, NULL, 95542),
(95543, '3.30.160.60-FF-000064', NULL, 'Early growth response protein 3', 94, NULL, NULL, 95543),
(95544, '2.130.10.10-FF-006011', NULL, 'Uncharacterized protein', 189, NULL, NULL, 95544),
(95545, '1.10.167.10-FF-000059', NULL, 'Axin-1', 79, NULL, NULL, 95545),
(95546, '3.30.980.10-FF-000038', NULL, 'Alanine--tRNA ligase', 79, NULL, NULL, 95546),
(95547, '1.25.40.20-FF-001004', NULL, 'Ankyrin repeat domain-containing protein M-T5', 97, NULL, NULL, 95547),
(95548, '3.30.160.60-FF-004335', NULL, NULL, 66, NULL, NULL, 95548),
(95549, '3.30.530.20-FF-000108', NULL, 'Collagen type IV alpha 3 binding protein', 152, NULL, NULL, 95549),
(95550, '3.40.50.620-FF-000879', NULL, 'Uncharacterized protein', 114, NULL, NULL, 95550),
(95551, '3.10.105.10-FF-000044', NULL, 'Extracellular solute-binding protein, family 5', 67, NULL, NULL, 95551),
(95552, '2.20.90.10-FF-000006', NULL, 'Vitellogenin 5', 71, NULL, NULL, 95552),
(95553, '1.20.120.350-FF-000258', NULL, NULL, 125, NULL, NULL, 95553),
(95554, '3.80.10.10-FF-003324', NULL, 'Si:ch211-149a19.3', 174, NULL, NULL, 95554),
(95555, '3.40.50.10190-FF-000157', NULL, 'HSK1 kinase regulatory subunit, putative', 89, NULL, NULL, 95555),
(95556, '1.10.472.10-FF-000061', NULL, 'cyclin-O', 103, NULL, NULL, 95556),
(95557, '1.10.150.50-FF-000084', NULL, 'EPS (Human endocytosis) related', 82, NULL, NULL, 95557),
(95558, '3.40.50.1100-FF-000174', NULL, 'Putative truncated L-serine dehydratase SDL1', 12, NULL, NULL, 95558),
(95559, '3.30.160.60-FF-004228', NULL, NULL, 24, NULL, NULL, 95559),
(95560, '3.80.30.30-FF-000004', NULL, 'Possible DNA repair photolyase', 214, NULL, NULL, 95560),
(95561, '3.40.50.10310-FF-000007', NULL, 'Creatinine amidohydrolase', 253, NULL, NULL, 95561),
(95562, '3.90.70.10-FF-000814', NULL, 'Uncharacterized protein', 216, NULL, NULL, 95562),
(95563, '1.10.418.10-FF-000126', NULL, 'Actin binding protein putative', 101, NULL, NULL, 95563),
(95564, '3.10.100.10-FF-000055', NULL, 'NKG2-D type II integral membrane protein', 123, NULL, NULL, 95564),
(95565, '2.20.25.10-FF-000047', NULL, 'DNA-directed RNA polymerase subunit', 34, NULL, NULL, 95565),
(95566, '3.40.50.1820-FF-001019', NULL, 'Uncharacterized protein', 201, NULL, NULL, 95566),
(95567, '3.40.850.10-FF-000200', NULL, 'Kinesin-like protein 8', 349, NULL, NULL, 95567); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(95568, '1.20.5.340-FF-000048', NULL, 'Rho kinase, isoform B', 163, NULL, NULL, 95568),
(95569, '2.70.170.10-FF-000140', NULL, 'Ligand-Gated ion Channel', 215, NULL, NULL, 95569),
(95570, '2.60.40.150-FF-000426', NULL, 'RNA helicase, putative', 112, NULL, NULL, 95570),
(95571, '4.10.240.30-FF-000005', NULL, 'A20-S', 37, NULL, NULL, 95571),
(95572, '3.80.30.20-FF-000001', NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase 2', 237, NULL, NULL, 95572),
(95573, '2.60.120.10-FF-000813', NULL, 'Predicted protein', 108, NULL, NULL, 95573),
(95574, '2.60.40.60-FF-001000', NULL, 'Uncharacterized protein', 111, NULL, NULL, 95574),
(95575, '2.60.120.10-FF-000476', NULL, 'Germin-like protein subfamily T member 3', 191, NULL, NULL, 95575),
(95576, '2.70.150.10-FF-000026', NULL, 'Phospholipid-transporting ATPase', 188, NULL, NULL, 95576),
(95577, '3.30.420.10-FF-000457', NULL, NULL, 121, NULL, NULL, 95577),
(95578, '3.90.1150.10-FF-000101', NULL, 'Putative 4-aminobutyrate aminotransferase', 158, NULL, NULL, 95578),
(95579, '2.10.70.10-FF-000096', NULL, 'Beta-2-glycoprotein 1', 62, NULL, NULL, 95579),
(95580, '2.40.160.120-FF-000063', NULL, 'Oxysterol-binding protein', 136, NULL, NULL, 95580),
(95581, '2.30.29.30-FF-001365', NULL, 'Kinesin-like protein', 128, NULL, NULL, 95581),
(95582, '3.30.930.10-FF-000327', NULL, 'Uncharacterized protein', 160, NULL, NULL, 95582),
(95583, '3.80.10.10-FF-001177', NULL, 'Disease resistance protein RRS1', 205, NULL, NULL, 95583),
(95584, '1.20.920.10-FF-000168', NULL, 'Protein polybromo-1', 150, NULL, NULL, 95584),
(95585, '1.10.1450.10-FF-000054', NULL, 'Tetraspanin', 85, NULL, NULL, 95585),
(95586, '3.30.160.60-FF-005858', NULL, NULL, 65, NULL, NULL, 95586),
(95587, '3.40.50.2300-FF-001630', NULL, NULL, 270, NULL, NULL, 95587),
(95588, '1.10.8.10-FF-000189', NULL, 'Prion-like-(Q/N-rich)-domain-bearing protein', 63, NULL, NULL, 95588),
(95589, '3.40.50.2300-FF-001523', NULL, NULL, 85, NULL, NULL, 95589),
(95590, '2.60.120.620-FF-000133', NULL, 'L-proline trans-4-hydroxylase', 263, NULL, NULL, 95590),
(95591, '3.40.930.10-FF-000038', NULL, 'Anion exchange protein', 339, NULL, NULL, 95591),
(95592, '3.30.70.380-FF-000015', NULL, NULL, 79, NULL, NULL, 95592),
(95593, '3.30.160.60-FF-005965', NULL, NULL, 77, NULL, NULL, 95593),
(95594, '2.130.10.10-FF-002407', NULL, 'Uncharacterized protein', 140, NULL, NULL, 95594),
(95595, '2.70.170.10-FF-000033', NULL, 'Gamma-aminobutyric acid (GABA-A) receptor, subunit theta', 215, NULL, NULL, 95595),
(95596, '3.30.160.60-FF-000390', NULL, 'Transcription factor stea', 38, NULL, NULL, 95596),
(95597, '3.40.50.300-FF-007826', NULL, 'Uncharacterized protein', 271, NULL, NULL, 95597),
(95598, '2.160.10.10-FF-000124', NULL, 'Predicted protein', 117, NULL, NULL, 95598),
(95599, '2.130.10.10-FF-004083', NULL, 'Uncharacterized protein', 201, NULL, NULL, 95599),
(95600, '2.60.40.2140-FF-000004', NULL, 'Uncharacterized protein', 105, NULL, NULL, 95600),
(95601, '3.90.1410.10-FF-000032', NULL, 'Rubisco LSMT substrate-binding, putative', 268, NULL, NULL, 95601),
(95602, '1.20.58.390-FF-000147', NULL, 'Uncharacterized protein', 131, NULL, NULL, 95602),
(95603, '3.40.50.300-FF-002806', NULL, 'Msh4p', 285, NULL, NULL, 95603),
(95604, '1.10.510.10-FF-004118', NULL, NULL, 104, NULL, NULL, 95604),
(95605, '3.40.1110.10-FF-000296', NULL, NULL, 12, NULL, NULL, 95605),
(95606, '3.10.20.90-FF-000069', NULL, 'UV excision repair protein RAD23', 80, NULL, NULL, 95606),
(95607, '2.60.520.10-FF-000001', NULL, 'Receptor binding protein', 140, NULL, NULL, 95607),
(95608, '1.10.220.150-FF-000032', NULL, 'ARF GAP', 165, NULL, NULL, 95608),
(95609, '1.25.40.20-FF-001589', NULL, 'Uncharacterized protein', 264, NULL, NULL, 95609),
(95610, '1.25.40.10-FF-001816', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 96, NULL, NULL, 95610),
(95611, '1.10.150.50-FF-000191', NULL, 'Poly [ADP-ribose] polymerase', 67, NULL, NULL, 95611),
(95612, '3.50.50.60-FF-001218', NULL, 'Thioredoxin reductase 2, tandem duplicate 2', 280, NULL, NULL, 95612),
(95613, '3.10.130.10-FF-000001', NULL, 'Ribonuclease pancreatic', 126, NULL, NULL, 95613);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(95614, '1.20.1250.20-FF-001517', NULL, 'Battenin', 127, NULL, NULL, 95614),
(95615, '1.10.1200.270-FF-000028', NULL, 'Uncharacterized protein', 63, NULL, NULL, 95615),
(95616, '1.10.275.10-FF-000007', NULL, 'Histidine ammonia-lyase', 210, NULL, NULL, 95616),
(95617, '1.10.555.10-FF-000271', NULL, NULL, 215, NULL, NULL, 95617),
(95618, '3.40.50.410-FF-000367', NULL, 'MxaL protein', 207, NULL, NULL, 95618),
(95619, '3.90.245.10-FF-000036', NULL, 'Predicted protein', 300, NULL, NULL, 95619),
(95620, '2.40.10.10-FF-000181', NULL, 'Chymotrypsinogen A', 131, NULL, NULL, 95620),
(95621, '3.40.50.1820-FF-001238', NULL, 'Uncharacterized protein', 329, NULL, NULL, 95621),
(95622, '3.40.50.2000-FF-000112', NULL, 'Sucrose-phosphate synthase 1', 221, NULL, NULL, 95622),
(95623, '2.80.10.50-FF-000275', NULL, 'Predicted protein', 93, NULL, NULL, 95623),
(95624, '1.25.40.10-FF-001586', NULL, 'RNA polymerase II transcription elongation factor (Ctr9), putative', 159, NULL, NULL, 95624),
(95625, '3.20.20.70-FF-000670', NULL, NULL, 210, NULL, NULL, 95625),
(95626, '3.40.50.1780-FF-000012', NULL, 'Cytosolic Fe-S cluster assembly factor nar1', 14, NULL, NULL, 95626),
(95627, '2.60.120.10-FF-000695', NULL, 'Uncharacterized protein', 54, NULL, NULL, 95627),
(95628, '3.30.160.60-FF-004661', NULL, NULL, 30, NULL, NULL, 95628),
(95629, '3.40.50.720-FF-001292', NULL, 'Alcohol dehydrogenase class-P', 139, NULL, NULL, 95629),
(95630, '1.10.10.60-FF-000261', NULL, 'Gastrulation brain homeobox 1', 75, NULL, NULL, 95630),
(95631, '3.30.200.20-FF-001871', NULL, 'Sulfhydryl oxidase', 115, NULL, NULL, 95631),
(95632, '2.60.120.10-FF-000583', NULL, 'Transcriptional regulator, Crp/Fnr family', 149, NULL, NULL, 95632),
(95633, '2.40.100.10-FF-000125', NULL, 'Peptidyl-prolyl cis-trans isomerase', 112, NULL, NULL, 95633),
(95634, '2.130.10.10-FF-000272', NULL, 'Ribosome biogenesis protein WDR12', 327, NULL, NULL, 95634),
(95635, '2.30.30.910-FF-000002', NULL, 'Basal-body rod modification protein FlgD', 46, NULL, NULL, 95635),
(95636, '1.20.1070.10-FF-000697', NULL, 'Uncharacterized protein', 301, NULL, NULL, 95636),
(95637, '2.60.120.10-FF-000706', NULL, 'Uncharacterized protein', 179, NULL, NULL, 95637),
(95638, '1.25.40.70-FF-000053', NULL, 'Putative phosphatidylinositol 4-kinase beta', 121, NULL, NULL, 95638),
(95639, '1.20.1250.20-FF-000798', NULL, 'MFS transporter of unkown specificity', 196, NULL, NULL, 95639),
(95640, '1.20.1250.20-FF-000686', NULL, 'Multidrug efflux pump Tap', 183, NULL, NULL, 95640),
(95641, '3.90.550.10-FF-000043', NULL, 'UDP-N-acetylhexosamine pyrophosphorylase isoform X2', 437, NULL, NULL, 95641),
(95642, '3.80.10.10-FF-003543', NULL, 'Uncharacterized protein', 160, NULL, NULL, 95642),
(95643, '3.40.50.720-FF-002489', NULL, 'Malic enzyme', 175, NULL, NULL, 95643),
(95644, '1.20.1270.280-FF-000058', NULL, 'Uncharacterized protein', 171, NULL, NULL, 95644),
(95645, '3.40.50.720-FF-001180', NULL, 'Oxidoreductase, short chain dehydrogenase/reductase family protein, putative (AFU_orthologue AFUA_3G09150)', 252, NULL, NULL, 95645),
(95646, '3.40.470.10-FF-000014', NULL, 'Uracil-DNA glycosylase', 239, NULL, NULL, 95646),
(95647, '1.25.40.20-FF-000622', NULL, 'Protein fem-1 B', 93, NULL, NULL, 95647),
(95648, '1.25.10.10-FF-000454', NULL, 'Armadillo repeat containing 12', 143, NULL, NULL, 95648),
(95649, '3.40.50.300-FF-000671', NULL, 'DNA helicase MCM9 isoform X1', 333, NULL, NULL, 95649),
(95650, '3.40.50.300-FF-004482', NULL, 'ATP-dependent DNA helicase', 260, NULL, NULL, 95650),
(95651, '2.40.10.10-FF-000304', NULL, NULL, 95, NULL, NULL, 95651),
(95652, '1.10.10.630-FF-000001', NULL, 'DNA replication protein dnaD', 75, NULL, NULL, 95652),
(95653, '3.40.50.2020-FF-000118', NULL, 'Adenine phosphoribosyltransferase', 49, NULL, NULL, 95653),
(95654, '1.10.20.10-FF-000325', NULL, NULL, 148, NULL, NULL, 95654),
(95655, '1.25.40.20-FF-000392', NULL, 'Protein CfxQ-like', 120, NULL, NULL, 95655),
(95656, '3.50.50.60-FF-000021', NULL, 'Ubiquinone biosynthesis monooxygenase COQ6', 131, NULL, NULL, 95656),
(95657, '1.25.40.10-FF-002305', NULL, 'Tetratricopeptide repeat protein 30 homolog', 129, NULL, NULL, 95657);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(95658, '2.80.10.50-FF-000056', NULL, 'Glucan 1,3-beta-glucosidase A', 140, NULL, NULL, 95658),
(95659, '1.20.1070.10-FF-001186', NULL, 'Uncharacterized protein', 275, NULL, NULL, 95659),
(95660, '2.40.128.630-FF-000010', NULL, 'Uncharacterized protein', 109, NULL, NULL, 95660),
(95661, '1.10.10.2740-FF-000010', NULL, 'Uncharacterized protein', 30, NULL, NULL, 95661),
(95662, '3.40.50.150-FF-000704', NULL, 'Methyltransferase', 230, NULL, NULL, 95662),
(95663, '1.10.10.10-FF-000830', NULL, 'Pre-rRNA-processing protein FHL1', 94, NULL, NULL, 95663),
(95664, '3.40.50.300-FF-004263', NULL, 'ADP-ribosylation factor L', 174, NULL, NULL, 95664),
(95665, '3.40.50.300-FF-008534', NULL, 'Uncharacterized protein', 137, NULL, NULL, 95665),
(95666, '1.25.40.10-FF-003840', NULL, 'Uncharacterized protein', 119, NULL, NULL, 95666),
(95667, '1.20.58.80-FF-000062', NULL, 'Predicted protein', 53, NULL, NULL, 95667),
(95668, '3.40.1340.10-FF-000009', NULL, 'RNA polymerase subunit', 95, NULL, NULL, 95668),
(95669, '3.30.160.60-FF-002430', NULL, 'testis-specific zinc finger protein topi', 27, NULL, NULL, 95669),
(95670, '4.10.81.20-FF-000001', NULL, 'Calcium-activated potassium channel beta 2 subunit', 45, NULL, NULL, 95670),
(95671, '3.40.50.300-FF-000901', NULL, 'Chromosome partition protein Smc', 187, NULL, NULL, 95671),
(95672, '2.60.300.12-FF-000009', NULL, 'Fe-S cluster assembly protein HesB', 107, NULL, NULL, 95672),
(95673, '1.10.510.10-FF-001937', NULL, NULL, 83, NULL, NULL, 95673),
(95674, '3.30.160.60-FF-004116', NULL, NULL, 18, NULL, NULL, 95674),
(95675, '2.130.10.10-FF-000502', NULL, 'Coronin', 350, NULL, NULL, 95675),
(95676, '2.20.70.10-FF-000011', NULL, 'E3 ubiquitin-protein ligase', 43, NULL, NULL, 95676),
(95677, '3.40.50.10810-FF-000051', NULL, 'Helicase SWR1', 275, NULL, NULL, 95677),
(95678, '2.30.29.30-FF-001253', NULL, 'Uncharacterized protein', 107, NULL, NULL, 95678),
(95679, '3.30.1120.10-FF-000074', NULL, 'Arylsulfatase homolog b1498', 66, NULL, NULL, 95679),
(95680, '2.170.150.80-FF-000028', NULL, 'At5g18300', 123, NULL, NULL, 95680),
(95681, '2.60.40.3500-FF-000007', NULL, 'N-acetylmuramoyl-L-alanine amidase', 114, NULL, NULL, 95681),
(95682, '2.60.40.10-FF-000524', NULL, 'Interleukin-6 receptor subunit beta', 96, NULL, NULL, 95682),
(95683, '2.60.40.150-FF-000207', NULL, 'DExH-box ATP-dependent RNA helicase DExH14', 111, NULL, NULL, 95683),
(95684, '3.10.290.10-FF-000057', NULL, 'Pseudouridine synthase', 67, NULL, NULL, 95684),
(95685, '3.40.30.10-FF-000461', NULL, 'viral IAP-associated factor homolog', 134, NULL, NULL, 95685),
(95686, '1.20.120.330-FF-000033', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 132, NULL, NULL, 95686),
(95687, '1.10.510.10-FF-000740', NULL, 'SNF1-related protein kinase, putative', 345, NULL, NULL, 95687),
(95688, '3.40.50.10860-FF-000037', NULL, 'Methylenetetrahydrofolate dehydrogenase (NADP+ dependent) 1b', 115, NULL, NULL, 95688),
(95689, '2.60.40.2130-FF-000001', NULL, 'Spondin 1a', 201, NULL, NULL, 95689),
(95690, '3.30.160.60-FF-005746', NULL, NULL, 37, NULL, NULL, 95690),
(95691, '2.60.40.1180-FF-000031', NULL, 'Alpha-xylosidase', 48, NULL, NULL, 95691),
(95692, '1.25.40.1010-FF-000001', NULL, 'N-alpha-acetyltransferase 15, NatA auxiliary subunit', 229, NULL, NULL, 95692),
(95693, '2.40.30.10-FF-000406', NULL, 'Eukaryotic translation initiation factor 2 subunit 3', 56, NULL, NULL, 95693),
(95694, '1.10.533.10-FF-000091', NULL, 'NLR family pyrin domain containing 10', 84, NULL, NULL, 95694),
(95695, '1.10.150.250-FF-000006', NULL, 'Succinate dehydrogenase assembly factor 2 family protein', 80, NULL, NULL, 95695),
(95696, '3.40.50.300-FF-004049', NULL, 'ATP-binding cassette, sub-family B (MDR/TAP), member 11b', 72, NULL, NULL, 95696),
(95697, '1.10.150.240-FF-000003', NULL, 'Phosphoglycolate phosphatase', 88, NULL, NULL, 95697),
(95698, '2.60.40.10-FF-004116', NULL, NULL, 92, NULL, NULL, 95698),
(95699, '2.30.30.140-FF-000299', NULL, 'Suppressor of fused homolog-like Protein', 76, NULL, NULL, 95699),
(95700, '1.10.472.10-FF-000173', NULL, 'Uncharacterized protein', 105, NULL, NULL, 95700);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(95701, '1.20.1270.60-FF-000339', NULL, 'AFR651Wp', 262, NULL, NULL, 95701),
(95702, '3.40.140.10-FF-000028', NULL, 'Cytidine and dCMP deaminase domain containing 1', 166, NULL, NULL, 95702),
(95703, '3.30.1600.10-FF-000004', NULL, 'NAD-dependent deacetylase sir2A', 108, NULL, NULL, 95703),
(95704, '3.30.70.100-FF-000191', NULL, NULL, 79, NULL, NULL, 95704),
(95705, '1.25.40.20-FF-000515', NULL, 'Ankyrin repeat family protein', 173, NULL, NULL, 95705),
(95706, '3.80.10.10-FF-003436', NULL, 'Uncharacterized protein', 63, NULL, NULL, 95706),
(95707, '1.10.20.10-FF-000106', NULL, 'Centromeric histone 3', 158, NULL, NULL, 95707),
(95708, '3.80.10.10-FF-003094', NULL, 'Uncharacterized protein', 118, NULL, NULL, 95708),
(95709, '3.30.160.60-FF-001699', NULL, 'zinc finger protein 527 isoform X2', 28, NULL, NULL, 95709),
(95710, '3.90.1290.10-FF-000038', NULL, 'VAB-10A protein', 171, NULL, NULL, 95710),
(95711, '1.25.40.180-FF-000188', NULL, NULL, 236, NULL, NULL, 95711),
(95712, '3.30.420.40-FF-000005', NULL, 'heat shock 70 kDa protein-like', 90, NULL, NULL, 95712),
(95713, '1.20.200.10-FF-000023', NULL, 'Predicted protein', 181, NULL, NULL, 95713),
(95714, '3.30.9.10-FF-000193', NULL, 'Uncharacterized protein', 186, NULL, NULL, 95714),
(95715, '1.10.357.20-FF-000004', NULL, 'Uncharacterized protein, isoform B', 188, NULL, NULL, 95715),
(95716, '3.40.50.720-FF-001185', NULL, 'Trk system potassium uptake protein CeoB', 136, NULL, NULL, 95716),
(95717, '3.40.50.300-FF-004044', NULL, 'Predicted protein', 137, NULL, NULL, 95717),
(95718, '1.25.40.10-FF-000512', NULL, 'Signal recognition particle subunit SRP72', 152, NULL, NULL, 95718),
(95719, '3.40.30.10-FF-000680', NULL, 'Chloride intracellular channel protein', 48, NULL, NULL, 95719),
(95720, '3.40.50.1000-FF-000481', NULL, NULL, 74, NULL, NULL, 95720),
(95721, '2.130.10.10-FF-005499', NULL, 'WD repeat domain 90', 301, NULL, NULL, 95721),
(95722, '3.30.890.10-FF-000031', NULL, 'Uncharacterized protein', 91, NULL, NULL, 95722),
(95723, '3.40.50.300-FF-006180', NULL, 'tRNA modification GTPase MnmE', 170, NULL, NULL, 95723),
(95724, '1.20.120.350-FF-000039', NULL, 'Sodium channel protein', 121, NULL, NULL, 95724),
(95725, '2.20.70.10-FF-000230', NULL, 'Uncharacterized protein', 56, NULL, NULL, 95725),
(95726, '2.30.30.380-FF-000028', NULL, 'Tamo, isoform B', 52, NULL, NULL, 95726),
(95727, '3.40.1090.10-FF-000130', NULL, 'Predicted protein', 130, NULL, NULL, 95727),
(95728, '3.30.310.130-FF-000018', NULL, 'Uncharacterized protein', 59, NULL, NULL, 95728),
(95729, '3.30.70.330-FF-001552', NULL, 'RNA-binding region (RNP1, RRM)-containing 3', 114, NULL, NULL, 95729),
(95730, '1.10.287.110-FF-000306', NULL, 'DNaJ domain (Prokaryotic heat shock protein)', 98, NULL, NULL, 95730),
(95731, '2.60.200.20-FF-000070', NULL, 'Ovarian-specific serine/threonine-protein kinase Lok', 117, NULL, NULL, 95731),
(95732, '1.10.274.30-FF-000016', NULL, 'Uncharacterized protein R102.4-like Protein', 192, NULL, NULL, 95732),
(95733, '3.30.160.60-FF-003953', NULL, NULL, 57, NULL, NULL, 95733),
(95734, '2.40.290.10-FF-000015', NULL, 'Glutamate Receptor Level Decreased', 151, NULL, NULL, 95734),
(95735, '3.30.60.30-FF-000143', NULL, 'Uncharacterized protein', 69, NULL, NULL, 95735),
(95736, '1.10.357.10-FF-000001', NULL, 'HTH-type transcriptional repressor FabR', 157, NULL, NULL, 95736),
(95737, '3.30.160.60-FF-004223', NULL, NULL, 26, NULL, NULL, 95737),
(95738, '2.40.70.10-FF-000403', NULL, 'Uncharacterized protein', 257, NULL, NULL, 95738),
(95739, '1.25.40.120-FF-000086', NULL, 'Uncharacterized protein', 284, NULL, NULL, 95739),
(95740, '3.30.300.20-FF-000069', NULL, 'Uncharacterized protein', 99, NULL, NULL, 95740),
(95741, '2.130.10.10-FF-005847', NULL, 'Uncharacterized protein', 336, NULL, NULL, 95741),
(95742, '3.40.50.620-FF-000767', NULL, 'Glutamate--tRNA ligase chloroplastic/mitochondrial', 118, NULL, NULL, 95742),
(95743, '3.30.1330.10-FF-000011', NULL, 'Phosphoribosylformylglycinamidine synthase subunit PurL', 177, NULL, NULL, 95743),
(95744, '2.30.180.10-FF-000060', NULL, 'Protein CBG03800', 151, NULL, NULL, 95744);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(95745, '6.10.250.3330-FF-000002', NULL, 'Secreted effector protein EspF(U)', 23, NULL, NULL, 95745),
(95746, '2.60.40.10-FF-002536', NULL, 'Limbic system-associated membrane protein', 118, NULL, NULL, 95746),
(95747, '2.80.10.50-FF-000168', NULL, 'Inositol 1,4,5-trisphosphate receptor, type 3', 118, NULL, NULL, 95747),
(95748, '1.10.10.10-FF-001808', NULL, 'Cullin, putative', 92, NULL, NULL, 95748),
(95749, '3.50.50.60-FF-001095', NULL, '5-demethoxyubiquinone hydroxylase, mitochondrial', 247, NULL, NULL, 95749),
(95750, '2.130.10.10-FF-001576', NULL, 'Predicted protein', 268, NULL, NULL, 95750),
(95751, '3.90.660.20-FF-000020', NULL, 'Protoporphyrinogen oxidase', 192, NULL, NULL, 95751),
(95752, '3.80.10.10-FF-000795', NULL, 'Antagonist of mitotic exit network', 250, NULL, NULL, 95752),
(95753, '3.40.50.300-FF-002251', NULL, 'Glutathione import ATP-binding protein GsiA', 267, NULL, NULL, 95753),
(95754, '1.25.40.20-FF-000280', NULL, 'E3 ubiquitin-protein ligase KEG', 146, NULL, NULL, 95754),
(95755, '2.40.160.20-FF-000014', NULL, 'Outer membrane protein, MSP2 family', 168, NULL, NULL, 95755),
(95756, '1.10.630.10-FF-000575', NULL, 'LOC100127852 protein', 308, NULL, NULL, 95756),
(95757, '2.120.10.80-FF-000220', NULL, 'Protein CBG01796', 142, NULL, NULL, 95757),
(95758, '1.10.1420.10-FF-000007', NULL, 'DNA mismatch repair protein MutS', 118, NULL, NULL, 95758),
(95759, '1.10.3080.10-FF-000037', NULL, 'CIC chloride ion channel family Cl-:H+ antiporter', 436, NULL, NULL, 95759),
(95760, '1.10.510.10-FF-000521', NULL, 'Tyrosine-protein kinase pr2', 271, NULL, NULL, 95760),
(95761, '2.60.40.420-FF-000199', NULL, 'Ubiquinol oxidase subunit 2', 169, NULL, NULL, 95761),
(95762, '3.10.20.90-FF-000743', NULL, 'Kinesin-like calmodulin binding protein', 103, NULL, NULL, 95762),
(95763, '2.40.50.150-FF-000017', NULL, 'DNA-directed RNA polymerase subunit beta', 159, NULL, NULL, 95763),
(95764, '3.30.505.10-FF-000255', NULL, NULL, 124, NULL, NULL, 95764),
(95765, '2.40.50.100-FF-000031', NULL, '39S ribosomal protein L27, mitochondrial', 113, NULL, NULL, 95765),
(95766, '3.60.21.10-FF-000085', NULL, 'Putative ser/thr protein phosphatase', 246, NULL, NULL, 95766),
(95767, '2.60.40.10-FF-005870', NULL, NULL, 95, NULL, NULL, 95767),
(95768, '3.40.50.300-FF-001975', NULL, 'ATP-dependent DNA helicase', 204, NULL, NULL, 95768),
(95769, '1.10.287.70-FF-000665', NULL, 'Uncharacterized protein', 119, NULL, NULL, 95769),
(95770, '3.40.50.300-FF-006522', NULL, 'Uncharacterized protein', 111, NULL, NULL, 95770),
(95771, '3.30.200.20-FF-001197', NULL, 'Myosin heavy chain kinase C', 70, NULL, NULL, 95771),
(95772, '1.20.1070.10-FF-001528', NULL, 'Uncharacterized protein', 187, NULL, NULL, 95772),
(95773, '1.10.510.10-FF-000173', NULL, 'proline-rich receptor-like protein kinase PERK8', 213, NULL, NULL, 95773),
(95774, '1.10.238.10-FF-000814', NULL, 'Calcium-binding protein', 55, NULL, NULL, 95774),
(95775, '2.60.40.60-FF-000511', NULL, 'Cadherin-related hmr-1', 108, NULL, NULL, 95775),
(95776, '3.30.60.20-FF-000140', NULL, 'Protein kinase C, putative', 60, NULL, NULL, 95776),
(95777, '2.60.40.10-FF-000743', NULL, 'myelin-associated glycoprotein isoform X1', 98, NULL, NULL, 95777),
(95778, '3.40.50.2000-FF-000697', NULL, 'Glycosyl transferase group 1', 182, NULL, NULL, 95778),
(95779, '2.40.50.140-FF-000014', NULL, '30S ribosomal protein S17', 80, NULL, NULL, 95779),
(95780, '2.20.70.10-FF-000123', NULL, 'Uncharacterized protein', 38, NULL, NULL, 95780),
(95781, '2.40.30.10-FF-000283', NULL, 'Ferric reductase transmembrane component, putative', 93, NULL, NULL, 95781),
(95782, '1.25.10.10-FF-001758', NULL, 'Uncharacterized protein', 82, NULL, NULL, 95782),
(95783, '3.30.200.20-FF-000117', NULL, 'Tyrosine-protein kinase receptor', 115, NULL, NULL, 95783),
(95784, '3.40.140.10-FF-000023', NULL, 'Eukaryotic translation initiation factor 3 subunit H', 210, NULL, NULL, 95784),
(95785, '2.60.40.150-FF-000319', NULL, 'Coiled-coil and C2 domain-containing protein 1-like', 135, NULL, NULL, 95785),
(95786, '3.30.70.1230-FF-000064', NULL, 'Adenylate cyclase type 9', 237, NULL, NULL, 95786);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(95787, '1.10.510.10-FF-004444', NULL, NULL, 47, NULL, NULL, 95787),
(95788, '3.40.50.300-FF-005898', NULL, 'tRNA modification GTPase gtpbp3, mitochondrial', 196, NULL, NULL, 95788),
(95789, '2.170.270.10-FF-000207', NULL, 'Histone-lysine N-methyltransferase', 272, NULL, NULL, 95789),
(95790, '1.25.40.420-FF-000069', NULL, 'Predicted protein', 103, NULL, NULL, 95790),
(95791, '2.60.120.200-FF-000687', NULL, 'Uncharacterized protein', 204, NULL, NULL, 95791),
(95792, '1.10.10.10-FF-000504', NULL, 'Rho guanyl nucleotide exchange factor', 119, NULL, NULL, 95792),
(95793, '1.20.1740.10-FF-000097', NULL, 'Amino acid transporter, putative', 463, NULL, NULL, 95793),
(95794, '3.20.20.370-FF-000033', NULL, 'LP01646p', 189, NULL, NULL, 95794),
(95795, '3.40.30.10-FF-000573', NULL, 'AGAP003415-PA', 108, NULL, NULL, 95795),
(95796, '3.40.50.300-FF-008315', NULL, 'ABC transporter G family member 20', 253, NULL, NULL, 95796),
(95797, '2.30.30.40-FF-000034', NULL, 'Rho guanine nucleotide exchange factor (GEF) 7', 75, NULL, NULL, 95797),
(95798, '4.10.410.10-FF-000058', NULL, 'Protein CBR-MEC-9', 63, NULL, NULL, 95798),
(95799, '1.25.10.10-FF-002034', NULL, 'Armadillo/beta-catenin-like repeat, putative', 180, NULL, NULL, 95799),
(95800, '2.130.10.10-FF-001918', NULL, 'Si:ch211-248g20.5', 283, NULL, NULL, 95800),
(95801, '1.25.40.20-FF-000173', NULL, 'Fem-1 homolog c (C.elegans)', 96, NULL, NULL, 95801),
(95802, '2.10.25.10-FF-000699', NULL, 'Uncharacterized protein, isoform C', 39, NULL, NULL, 95802),
(95803, '3.10.290.10-FF-000052', NULL, 'S4 domain containing protein', 81, NULL, NULL, 95803),
(95804, '1.25.40.10-FF-000170', NULL, 'Trafficking protein particle complex subunit 12', 336, NULL, NULL, 95804),
(95805, '2.30.29.30-FF-000983', NULL, 'cDNA FLJ54163, highly similar to Centaurin-alpha 1', 39, NULL, NULL, 95805),
(95806, '3.60.21.10-FF-000433', NULL, '3'',5''-cyclic adenosine monophosphate phosphodiesterase CpdA', 243, NULL, NULL, 95806),
(95807, '3.50.50.60-FF-001437', NULL, 'Putative bifunctional amine oxidase DDB_G0291301', 107, NULL, NULL, 95807),
(95808, '4.10.60.10-FF-000141', NULL, 'Uncharacterized protein', 33, NULL, NULL, 95808),
(95809, '2.40.40.50-FF-000003', NULL, 'UFD1 isoform 10', 54, NULL, NULL, 95809),
(95810, '2.30.30.30-FF-000031', NULL, '40S ribosomal protein S4-3', 39, NULL, NULL, 95810),
(95811, '3.90.70.40-FF-000020', NULL, 'Uncharacterized protein', 149, NULL, NULL, 95811),
(95812, '3.30.1490.20-FF-000065', NULL, 'Formate-dependent phosphoribosylglycinamide formyltransferase', 73, NULL, NULL, 95812),
(95813, '3.30.1150.10-FF-000025', NULL, NULL, 191, NULL, NULL, 95813),
(95814, '3.90.1410.10-FF-000144', NULL, 'Uncharacterized protein', 289, NULL, NULL, 95814),
(95815, '1.10.630.10-FF-000794', NULL, 'Uncharacterized protein', 442, NULL, NULL, 95815),
(95816, '3.30.830.10-FF-000038', NULL, 'Zinc protease, insulinase family', 193, NULL, NULL, 95816),
(95817, '3.40.33.10-FF-000158', NULL, 'Predicted protein', 125, NULL, NULL, 95817),
(95818, '3.30.160.60-FF-000513', NULL, 'POZ-, AT hook-, and zinc finger-containing protein 1 isoform X1', 33, NULL, NULL, 95818),
(95819, '2.60.40.4370-FF-000004', NULL, 'Transcription factor tau 55 kDa subunit', 94, NULL, NULL, 95819),
(95820, '2.130.10.10-FF-001795', NULL, 'Os07g0224900 protein', 215, NULL, NULL, 95820),
(95821, '1.25.40.10-FF-003598', NULL, 'TPR repeat-containing protein', 145, NULL, NULL, 95821),
(95822, '3.40.50.300-FF-002470', NULL, 'ABC transporter, putative', 243, NULL, NULL, 95822),
(95823, '2.60.40.10-FF-001828', NULL, 'Thy-1 membrane glycoprotein', 105, NULL, NULL, 95823),
(95824, '3.30.60.20-FF-000033', NULL, 'Rac GTPase-activating protein 1', 58, NULL, NULL, 95824),
(95825, '1.25.40.20-FF-000841', NULL, 'Protein CBR-DAPK-1', 74, NULL, NULL, 95825),
(95826, '3.40.50.300-FF-006741', NULL, 'Uncharacterized protein', 69, NULL, NULL, 95826),
(95827, '1.10.510.10-FF-004006', NULL, NULL, 156, NULL, NULL, 95827),
(95828, '3.30.160.60-FF-000171', NULL, 'Zinc finger protein 26', 26, NULL, NULL, 95828),
(95829, '3.30.505.10-FF-000036', NULL, 'Suppressor of cytokine signaling 6', 133, NULL, NULL, 95829);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(95830, '2.30.29.30-FF-001146', NULL, 'Predicted protein', 175, NULL, NULL, 95830),
(95831, '3.40.800.20-FF-000043', NULL, 'Histone deacetylase', 399, NULL, NULL, 95831),
(95832, '3.40.1380.10-FF-000006', NULL, 'ATP synthase gamma chain', 127, NULL, NULL, 95832),
(95833, '1.10.533.10-FF-000214', NULL, 'Predicted protein', 102, NULL, NULL, 95833),
(95834, '2.160.10.10-FF-000012', NULL, 'Carnitine operon protein CaiE', 174, NULL, NULL, 95834),
(95835, '3.30.60.30-FF-000036', NULL, 'Ovomucoid', 63, NULL, NULL, 95835),
(95836, '3.30.390.10-FF-000009', NULL, 'Hydrophobic dipeptide epimerase', 114, NULL, NULL, 95836),
(95837, '1.10.30.10-FF-000051', NULL, 'Transcription factor Sox-10', 80, NULL, NULL, 95837),
(95838, '3.20.20.80-FF-000785', NULL, 'Uncharacterized protein', 369, NULL, NULL, 95838),
(95839, '3.10.250.10-FF-000055', NULL, 'Deleted in malignant brain tumors 1', 97, NULL, NULL, 95839),
(95840, '3.30.160.60-FF-004442', NULL, NULL, 61, NULL, NULL, 95840),
(95841, '3.40.800.10-FF-000040', NULL, NULL, 290, NULL, NULL, 95841),
(95842, '2.10.25.10-FF-000817', NULL, 'Stabilin 2', 44, NULL, NULL, 95842),
(95843, '1.25.40.250-FF-000001', NULL, 'Eukaryotic translation initiation factor 3 subunit K', 119, NULL, NULL, 95843),
(95844, '2.60.40.10-FF-002317', NULL, 'Lymphocyte antigen 6 complex locus protein G6d', 103, NULL, NULL, 95844),
(95845, '3.20.20.70-FF-000782', NULL, NULL, 75, NULL, NULL, 95845),
(95846, '3.40.1380.20-FF-000009', NULL, 'Pyruvate kinase', 142, NULL, NULL, 95846),
(95847, '1.20.58.2220-FF-000026', NULL, 'Uncharacterized protein', 161, NULL, NULL, 95847),
(95848, '3.40.50.1390-FF-000002', NULL, 'ORF1 in transposon ISC1904', 98, NULL, NULL, 95848),
(95849, '2.60.120.10-FF-000818', NULL, 'Homogentisate 12-dioxygenase', 91, NULL, NULL, 95849),
(95850, '2.60.40.10-FF-002104', NULL, 'Fc receptor-like B', 98, NULL, NULL, 95850),
(95851, '3.40.630.10-FF-000217', NULL, 'M18 family aminopeptidase', 274, NULL, NULL, 95851),
(95852, '1.25.40.10-FF-004222', NULL, 'Uncharacterized protein', 273, NULL, NULL, 95852),
(95853, '3.90.70.170-FF-000001', NULL, 'Gifsy-2 prophage protein', 140, NULL, NULL, 95853),
(95854, '1.10.10.1940-FF-000006', NULL, 'Matrix metallopeptidase 23bb', 40, NULL, NULL, 95854),
(95855, '3.20.20.220-FF-000016', NULL, 'Methylenetetrahydrofolate reductase', 280, NULL, NULL, 95855),
(95856, '2.40.160.10-FF-000011', NULL, 'mitochondrial import receptor subunit TOM40 homolog', 118, NULL, NULL, 95856),
(95857, '1.20.1070.10-FF-001309', NULL, 'Predicted protein', 351, NULL, NULL, 95857),
(95858, '1.20.1250.20-FF-000793', NULL, 'GG12415', 194, NULL, NULL, 95858),
(95859, '3.30.40.10-FF-001900', NULL, 'Uncharacterized protein', 74, NULL, NULL, 95859),
(95860, '3.40.50.40-FF-000004', NULL, 'Type II asparaginase', 109, NULL, NULL, 95860),
(95861, '3.40.50.1820-FF-000856', NULL, 'Prolylcarboxypeptidase, putative', 178, NULL, NULL, 95861),
(95862, '3.90.226.10-FF-000003', NULL, '1,4-dihydroxy-2-naphthoyl-CoA synthase', 215, NULL, NULL, 95862),
(95863, '3.30.2350.20-FF-000009', NULL, 'Pseudouridine synthase TruD/Pus7, putative', 188, NULL, NULL, 95863),
(95864, '3.30.70.380-FF-000010', NULL, NULL, 91, NULL, NULL, 95864),
(95865, '3.40.1110.10-FF-000189', NULL, 'Phospholipid-transporting ATPase', 150, NULL, NULL, 95865),
(95866, '3.30.1330.20-FF-000014', NULL, 'Tubulin alpha chain', 82, NULL, NULL, 95866),
(95867, '3.40.605.10-FF-000036', NULL, 'Phenylacetic acid degradation protein MaoC', 261, NULL, NULL, 95867),
(95868, '3.40.50.10420-FF-000041', NULL, '5-formyltetrahydrofolate cyclo-ligase', 166, NULL, NULL, 95868),
(95869, '2.40.100.10-FF-000120', NULL, 'Peptidyl-prolyl cis-trans isomerase', 163, NULL, NULL, 95869),
(95870, '1.10.10.440-FF-000039', NULL, 'Repeat organellar protein', 77, NULL, NULL, 95870),
(95871, '3.20.20.210-FF-000013', NULL, 'Methanosarcina family methyltransferase cognate corrinoid protein', 222, NULL, NULL, 95871),
(95872, '3.80.10.10-FF-003217', NULL, 'Uncharacterized protein', 209, NULL, NULL, 95872),
(95873, '2.30.30.210-FF-000005', NULL, 'Ribonuclease P protein subunit', 110, NULL, NULL, 95873);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(95874, '3.90.550.50-FF-000133', NULL, 'Beta-1,3-N-acetylglucosaminyltransferase', 278, NULL, NULL, 95874),
(95875, '1.20.1310.10-FF-000160', NULL, NULL, 133, NULL, NULL, 95875),
(95876, '3.40.50.1440-FF-000152', NULL, 'Uncharacterized protein', 270, NULL, NULL, 95876),
(95877, '3.40.50.1000-FF-000262', NULL, 'Hydrolase, haloacid dehalogenase-like family', 107, NULL, NULL, 95877),
(95878, '1.25.40.10-FF-003385', NULL, 'Pentatricopeptide repeat-containing protein At2g37230', 147, NULL, NULL, 95878),
(95879, '2.130.10.10-FF-002284', NULL, 'Anaphase-promoting complex subunit 4', 225, NULL, NULL, 95879),
(95880, '2.70.170.10-FF-000252', NULL, 'Uncharacterized protein', 221, NULL, NULL, 95880),
(95881, '1.10.1280.10-FF-000018', NULL, 'Uncharacterized protein', 323, NULL, NULL, 95881),
(95882, '1.10.418.70-FF-000009', NULL, 'Intraflagellar transport protein 81-like protein', 130, NULL, NULL, 95882),
(95883, '3.30.70.2130-FF-000002', NULL, 'Bisphosphoglycerate-independent phosphoglycerate mutase family protein', 95, NULL, NULL, 95883),
(95884, '1.20.1110.10-FF-000178', NULL, NULL, 220, NULL, NULL, 95884),
(95885, '1.10.418.60-FF-000006', NULL, 'Related to Myosin-like protein NUF2', 163, NULL, NULL, 95885),
(95886, '1.10.246.60-FF-000011', NULL, NULL, 79, NULL, NULL, 95886),
(95887, '1.10.510.10-FF-004225', NULL, NULL, 207, NULL, NULL, 95887),
(95888, '3.40.50.1010-FF-000265', NULL, NULL, 149, NULL, NULL, 95888),
(95889, '3.30.1330.30-FF-000017', NULL, 'RNA methyltransferase TrmH family group 3', 74, NULL, NULL, 95889),
(95890, '1.25.40.10-FF-001923', NULL, 'Pentatricopeptide repeat-containing protein', 219, NULL, NULL, 95890),
(95891, '2.30.30.40-FF-000253', NULL, 'Tyrosine-protein kinase', 61, NULL, NULL, 95891),
(95892, '1.10.3720.10-FF-000160', NULL, 'Oligopeptide ABC transporter, permease protein (OppC)', 205, NULL, NULL, 95892),
(95893, '1.10.1410.10-FF-000052', NULL, 'GM17772', 169, NULL, NULL, 95893),
(95894, '3.40.50.10470-FF-000027', NULL, 'Putative translation initiation factor eif-2b beta subunit', 223, NULL, NULL, 95894),
(95895, '3.30.420.10-FF-000676', NULL, NULL, 168, NULL, NULL, 95895),
(95896, '1.25.10.10-FF-002253', NULL, 'Uncharacterized protein', 368, NULL, NULL, 95896),
(95897, '3.40.50.150-FF-000367', NULL, 'Ribosomal RNA small subunit methyltransferase B', 298, NULL, NULL, 95897),
(95898, '3.30.160.60-FF-002188', NULL, 'RE1-silencing transcription factor', 27, NULL, NULL, 95898),
(95899, '1.10.510.10-FF-003736', NULL, NULL, 150, NULL, NULL, 95899),
(95900, '3.40.30.10-FF-000909', NULL, 'Iodothyronine deiodinase', 133, NULL, NULL, 95900),
(95901, '2.60.120.10-FF-000257', NULL, 'Crp/Fnr family transcriptional regulator', 133, NULL, NULL, 95901),
(95902, '1.10.220.10-FF-000072', NULL, 'Uncharacterized protein', 59, NULL, NULL, 95902),
(95903, '1.10.10.10-FF-000381', NULL, 'Fur family transcriptional regulator', 85, NULL, NULL, 95903),
(95904, '2.40.20.10-FF-000125', NULL, 'Plasminogen', 50, NULL, NULL, 95904),
(95905, '3.10.170.20-FF-000006', NULL, 'Leishmanolysin like peptidase 2', 62, NULL, NULL, 95905),
(95906, '2.60.40.10-FF-006033', NULL, NULL, 67, NULL, NULL, 95906),
(95907, '3.40.30.10-FF-000354', NULL, 'Caspar, isoform A', 179, NULL, NULL, 95907),
(95908, '2.130.10.10-FF-002071', NULL, 'Ribosome biogenesis protein WDR12 homolog', 123, NULL, NULL, 95908),
(95909, '2.30.30.40-FF-000601', NULL, 'Uncharacterized protein', 90, NULL, NULL, 95909),
(95910, '3.40.50.200-FF-000074', NULL, 'Uncharacterized protein', 343, NULL, NULL, 95910),
(95911, '1.10.510.10-FF-002319', NULL, NULL, 215, NULL, NULL, 95911),
(95912, '3.10.170.10-FF-000003', NULL, 'Peptidase M28', 143, NULL, NULL, 95912),
(95913, '1.25.10.10-FF-001977', NULL, 'Phosphatidylinositol 3 kinase', 168, NULL, NULL, 95913),
(95914, '3.40.50.1000-FF-000604', NULL, NULL, 96, NULL, NULL, 95914),
(95915, '1.50.40.10-FF-000549', NULL, 'Mitochondrial substrate carrier protein', 133, NULL, NULL, 95915),
(95916, '3.60.10.10-FF-000296', NULL, 'AEL090Cp', 341, NULL, NULL, 95916),
(95917, '3.40.630.30-FF-000555', NULL, 'Acetyltransferase (GNAT) family protein', 130, NULL, NULL, 95917);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(95918, '2.60.40.10-FF-002430', NULL, 'Uncharacterized protein', 104, NULL, NULL, 95918),
(95919, '2.120.10.80-FF-000001', NULL, 'Kelch-like family member 13', 313, NULL, NULL, 95919),
(95920, '3.40.50.1240-FF-000204', NULL, NULL, 40, NULL, NULL, 95920),
(95921, '1.10.1440.10-FF-000003', NULL, 'Uncharacterized protein', 79, NULL, NULL, 95921),
(95922, '1.10.510.10-FF-002426', NULL, 'Uncharacterized protein', 368, NULL, NULL, 95922),
(95923, '1.25.10.10-FF-000123', NULL, 'Importin 9', 980, NULL, NULL, 95923),
(95924, '3.40.630.30-FF-000561', NULL, 'Glycylpeptide N-tetradecanoyltransferase', 123, NULL, NULL, 95924),
(95925, '3.10.20.90-FF-000530', NULL, 'Autophagy-related protein', 134, NULL, NULL, 95925),
(95926, '1.10.3380.10-FF-000077', NULL, 'Uncharacterized protein', 139, NULL, NULL, 95926),
(95927, '3.30.360.10-FF-000058', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', 169, NULL, NULL, 95927),
(95928, '1.20.1280.50-FF-000275', NULL, 'Protein aardvark', 89, NULL, NULL, 95928),
(95929, '1.50.40.10-FF-000443', NULL, 'Uncharacterized protein', 148, NULL, NULL, 95929),
(95930, '1.10.3720.10-FF-000053', NULL, 'Amino acid ABC transporter permease', 219, NULL, NULL, 95930),
(95931, '1.25.10.10-FF-002247', NULL, 'Pumilio/PUF RNA binding protein 4, putative', 374, NULL, NULL, 95931),
(95932, '3.40.710.10-FF-000168', NULL, 'Cell division protein FtsI [Peptidoglycan synthetase]', 368, NULL, NULL, 95932),
(95933, '1.20.1380.10-FF-000001', NULL, 'Negative modulator of initiation of replication', 117, NULL, NULL, 95933),
(95934, '1.10.1040.50-FF-000018', NULL, NULL, 211, NULL, NULL, 95934),
(95935, '1.20.1280.50-FF-000269', NULL, 'Predicted protein', 45, NULL, NULL, 95935),
(95936, '2.60.40.3210-FF-000022', NULL, 'Transforming growth factor, beta receptor III', 90, NULL, NULL, 95936),
(95937, '3.40.50.2300-FF-001175', NULL, NULL, 108, NULL, NULL, 95937),
(95938, '1.10.8.60-FF-000288', NULL, 'Putative AAA family protein', 126, NULL, NULL, 95938),
(95939, '3.40.30.10-FF-000792', NULL, 'Uncharacterized protein', 62, NULL, NULL, 95939),
(95940, '3.10.20.90-FF-000524', NULL, 'Probable splicing factor 3A subunit 1', 108, NULL, NULL, 95940),
(95941, '1.10.510.10-FF-000302', NULL, 'Serine/threonine-protein kinase', 214, NULL, NULL, 95941),
(95942, '3.40.50.300-FF-008085', NULL, 'RecQ like helicase 4', 115, NULL, NULL, 95942),
(95943, '4.10.400.10-FF-000125', NULL, 'LDL receptor related protein 2', 37, NULL, NULL, 95943),
(95944, '3.30.870.10-FF-000142', NULL, 'Phospholipase D B', 241, NULL, NULL, 95944),
(95945, '1.20.1070.10-FF-001080', NULL, 'Substance-K receptor', 325, NULL, NULL, 95945),
(95946, '3.30.505.10-FF-000143', NULL, 'Uncharacterized protein', 67, NULL, NULL, 95946),
(95947, '3.40.50.720-FF-001415', NULL, '2-dehydropantoate 2-reductase', 176, NULL, NULL, 95947),
(95948, '2.60.120.1540-FF-000021', NULL, 'Uncharacterized protein', 71, NULL, NULL, 95948),
(95949, '3.30.200.20-FF-002028', NULL, 'Protein CBG12846', 91, NULL, NULL, 95949),
(95950, '3.30.70.1230-FF-000277', NULL, 'Adenylate cyclase 5-like', 84, NULL, NULL, 95950),
(95951, '3.30.420.40-FF-000218', NULL, 'actin, alpha sarcomeric/skeletal-like', 67, NULL, NULL, 95951),
(95952, '2.130.10.10-FF-005735', NULL, 'Uncharacterized protein', 131, NULL, NULL, 95952),
(95953, '2.60.40.10-FF-004560', NULL, NULL, 106, NULL, NULL, 95953),
(95954, '3.30.870.10-FF-000035', NULL, 'Phospholipase D domain protein', 160, NULL, NULL, 95954),
(95955, '1.10.565.10-FF-000097', NULL, 'Nuclear Hormone Receptor family', 206, NULL, NULL, 95955),
(95956, '3.40.50.300-FF-002357', NULL, 'Glutathione S-transferase class-mu 26 kDa isozyme', 188, NULL, NULL, 95956),
(95957, '2.170.270.10-FF-000101', NULL, 'Putative positive regulatory Domain/B-lymphocyte induced maturation protein 1, version B', 89, NULL, NULL, 95957),
(95958, '3.30.70.330-FF-001771', NULL, NULL, 158, NULL, NULL, 95958),
(95959, '3.60.21.10-FF-000208', NULL, '3'',5''-cyclic adenosine monophosphate phosphodiesterase CpdA', 266, NULL, NULL, 95959),
(95960, '1.10.1040.30-FF-000012', NULL, 'Predicted protein', 73, NULL, NULL, 95960);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(95961, '3.80.10.10-FF-000918', NULL, 'Slit protein', 225, NULL, NULL, 95961),
(95962, '2.170.300.10-FF-000099', NULL, 'Uncharacterized protein', 49, NULL, NULL, 95962),
(95963, '3.90.70.10-FF-000146', NULL, 'Ubiquitin-specific protease', 341, NULL, NULL, 95963),
(95964, '3.30.160.60-FF-001929', NULL, 'paternally-expressed gene 3 protein', 50, NULL, NULL, 95964),
(95965, '3.40.640.10-FF-000050', NULL, 'Serine hydroxymethyltransferase', 265, NULL, NULL, 95965),
(95966, '2.130.10.10-FF-002290', NULL, 'Transducin/WD40 repeat-like superfamily protein', 203, NULL, NULL, 95966),
(95967, '1.10.3790.10-FF-000001', NULL, 'DLP12 prophage DNA base-flipping protein', 140, NULL, NULL, 95967),
(95968, '3.90.190.10-FF-000397', NULL, 'Protein-tyrosine-phosphatase, putative', 65, NULL, NULL, 95968),
(95969, '3.90.132.10-FF-000010', NULL, 'GP63-like', 117, NULL, NULL, 95969),
(95970, '1.25.40.10-FF-003379', NULL, 'Pre-mRNA-splicing factor CLF1', 159, NULL, NULL, 95970),
(95971, '1.10.472.80-FF-000059', NULL, 'Ypt/Rab-GAP domain of gyp1p superfamily protein', 136, NULL, NULL, 95971),
(95972, '2.40.70.10-FF-000173', NULL, 'Uncharacterized protein', 121, NULL, NULL, 95972),
(95973, '2.60.120.970-FF-000108', NULL, 'Bone morphogenetic protein 6', 168, NULL, NULL, 95973),
(95974, '1.25.40.20-FF-000734', NULL, 'Ankyrin repeat protein', 95, NULL, NULL, 95974),
(95975, '3.30.200.20-FF-001427', NULL, NULL, 114, NULL, NULL, 95975),
(95976, '3.80.10.10-FF-001525', NULL, 'Leucine-rich repeat containing protein', 85, NULL, NULL, 95976),
(95977, '3.40.50.1440-FF-000040', NULL, 'Tubulin alpha chain', 164, NULL, NULL, 95977),
(95978, '3.40.50.150-FF-001778', NULL, NULL, 191, NULL, NULL, 95978),
(95979, '1.10.760.10-FF-000106', NULL, 'Monoheme cytochrome c SoxX', 137, NULL, NULL, 95979),
(95980, '3.30.200.20-FF-002141', NULL, 'Uncharacterized protein', 70, NULL, NULL, 95980),
(95981, '3.30.70.330-FF-000242', NULL, 'RNA-binding protein FUS isoform X1', 124, NULL, NULL, 95981),
(95982, '3.30.450.30-FF-000043', NULL, 'GM26652', 101, NULL, NULL, 95982),
(95983, '3.30.200.20-FF-000011', NULL, 'Fibroblast growth factor receptor', 126, NULL, NULL, 95983),
(95984, '1.10.506.10-FF-000067', NULL, 'Uncharacterized protein', 25, NULL, NULL, 95984),
(95985, '1.10.10.440-FF-000045', NULL, 'U1 snRNP protein', 59, NULL, NULL, 95985),
(95986, '1.10.238.10-FF-000365', NULL, 'Calmodulin, putative', 82, NULL, NULL, 95986),
(95987, '3.40.190.80-FF-000064', NULL, 'Inositol-1-monophosphatase', 125, NULL, NULL, 95987),
(95988, '1.20.1110.10-FF-000066', NULL, 'Phospholipid-transporting ATPase', 120, NULL, NULL, 95988),
(95989, '3.40.50.300-FF-008102', NULL, 'Uncharacterized protein', 110, NULL, NULL, 95989),
(95990, '1.10.10.10-FF-000049', NULL, 'Heat-inducible transcription repressor HrcA', 83, NULL, NULL, 95990),
(95991, '3.30.160.20-FF-000187', NULL, 'Cdl1p', 76, NULL, NULL, 95991),
(95992, '3.40.50.300-FF-004830', NULL, 'Helicase, Snf2 family protein', 281, NULL, NULL, 95992),
(95993, '3.40.532.10-FF-000006', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 229, NULL, NULL, 95993),
(95994, '3.40.630.10-FF-000223', NULL, 'Uncharacterized protein', 182, NULL, NULL, 95994),
(95995, '3.40.50.10810-FF-000163', NULL, 'Putative DNA excision/repair protein SNF2', 262, NULL, NULL, 95995),
(95996, '3.10.110.10-FF-000005', NULL, 'NEDD8-conjugating enzyme Ubc12', 159, NULL, NULL, 95996),
(95997, '2.60.40.10-FF-005976', NULL, NULL, 101, NULL, NULL, 95997),
(95998, '2.170.270.10-FF-000090', NULL, 'SET-8', 189, NULL, NULL, 95998),
(95999, '3.40.50.1000-FF-000037', NULL, 'D,D-heptose 1,7-bisphosphate phosphatase', 183, NULL, NULL, 95999),
(96000, '2.60.40.150-FF-000084', NULL, 'Protein KIBRA isoform 1', 128, NULL, NULL, 96000),
(96001, '3.40.50.300-FF-000227', NULL, 'Sulfate/thiosulfate import ATP-binding protein CysA', 255, NULL, NULL, 96001),
(96002, '3.40.50.2000-FF-001079', NULL, 'Glycosyltransferase', 132, NULL, NULL, 96002),
(96003, '3.30.160.60-FF-006134', NULL, NULL, 31, NULL, NULL, 96003),
(96004, '2.130.10.10-FF-004431', NULL, 'Actin-related protein 2/3 complex subunit', 357, NULL, NULL, 96004);
INSERT INTO "PUBLIC"."MODEL" VALUES
(96005, '3.40.140.70-FF-000018', NULL, 'Autophagy related 7', 25, NULL, NULL, 96005),
(96006, '3.40.50.720-FF-000797', NULL, 'Uncharacterized protein', 137, NULL, NULL, 96006),
(96007, '3.40.50.150-FF-000255', NULL, 'Protein arginine N-methyltransferase', 163, NULL, NULL, 96007),
(96008, '3.30.450.50-FF-000049', NULL, '25.3 kDa vesicle transport protein isoform C', 111, NULL, NULL, 96008),
(96009, '2.60.120.970-FF-000097', NULL, 'Uncharacterized protein', 157, NULL, NULL, 96009),
(96010, '1.10.510.10-FF-003955', NULL, NULL, 53, NULL, NULL, 96010),
(96011, '1.20.144.10-FF-000100', NULL, 'Carbohydrate-binding protein', 206, NULL, NULL, 96011),
(96012, '2.60.40.10-FF-004228', NULL, NULL, 64, NULL, NULL, 96012),
(96013, '1.10.630.10-FF-000682', NULL, 'Cytochrome P450, family 2, subfamily d, polypeptide 12', 158, NULL, NULL, 96013),
(96014, '1.10.1900.10-FF-000027', NULL, 'Uncharacterized protein', 45, NULL, NULL, 96014),
(96015, '1.10.418.60-FF-000012', NULL, 'Uncharacterized protein', 166, NULL, NULL, 96015),
(96016, '3.30.450.40-FF-000046', NULL, 'Phosphodiesterase', 104, NULL, NULL, 96016),
(96017, '3.40.630.30-FF-000229', NULL, 'Histone acetyltransferase', 57, NULL, NULL, 96017),
(96018, '2.40.50.1060-FF-000016', NULL, 'Predicted protein', 121, NULL, NULL, 96018),
(96019, '2.40.30.10-FF-000064', NULL, 'Na(+)-translocating NADH-quinone reductase subunit F', 139, NULL, NULL, 96019),
(96020, '3.40.1090.10-FF-000017', NULL, 'Patatin-like phospholipase domain-containing protein 2', 74, NULL, NULL, 96020),
(96021, '1.10.10.10-FF-001685', NULL, 'Putative ArsR-family transcriptional regulator', 114, NULL, NULL, 96021),
(96022, '2.120.10.30-FF-000233', NULL, 'Putative peptide hydrolase', 225, NULL, NULL, 96022),
(96023, '3.40.47.10-FF-000100', NULL, 'Beta-ketoacyl synthase, N-terminal domain protein', 145, NULL, NULL, 96023),
(96024, '3.40.50.150-FF-001559', NULL, NULL, 75, NULL, NULL, 96024),
(96025, '3.30.160.60-FF-000625', NULL, 'Zinc finger protein 536', 26, NULL, NULL, 96025),
(96026, '2.40.50.1070-FF-000019', NULL, 'tRNA (Uracil(54)-C(5))-methyltransferase homolog', 170, NULL, NULL, 96026),
(96027, '3.30.230.70-FF-000044', NULL, 'Exosome complex exonuclease MTR3-like protein', 218, NULL, NULL, 96027),
(96028, '2.130.10.10-FF-001683', NULL, 'WD repeat and FYVE domain-containing protein 2', 168, NULL, NULL, 96028),
(96029, '2.130.10.10-FF-005954', NULL, 'Uncharacterized protein', 247, NULL, NULL, 96029),
(96030, '3.40.50.880-FF-000131', NULL, 'Uncharacterized protein', 124, NULL, NULL, 96030),
(96031, '1.20.20.10-FF-000010', NULL, 'ATP synthase subunit c', 81, NULL, NULL, 96031),
(96032, '1.20.1310.20-FF-000056', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 199, NULL, NULL, 96032),
(96033, '3.60.20.40-FF-000007', NULL, 'Glutathione hydrolase 1 proenzyme', 195, NULL, NULL, 96033),
(96034, '3.40.50.720-FF-000111', NULL, 'Glucose-6-phosphate 1-dehydrogenase', 187, NULL, NULL, 96034),
(96035, '2.60.40.10-FF-003846', NULL, NULL, 93, NULL, NULL, 96035),
(96036, '3.30.70.330-FF-001439', NULL, 'CG14718', 84, NULL, NULL, 96036),
(96037, '3.40.50.720-FF-001634', NULL, 'Uncharacterized protein', 327, NULL, NULL, 96037),
(96038, '2.60.34.10-FF-000122', NULL, 'Predicted protein', 173, NULL, NULL, 96038),
(96039, '1.20.1640.10-FF-000038', NULL, 'Blast:Protein patched', 168, NULL, NULL, 96039),
(96040, '2.40.10.10-FF-000517', NULL, NULL, 46, NULL, NULL, 96040),
(96041, '3.10.490.20-FF-000042', NULL, 'Uncharacterized protein', 83, NULL, NULL, 96041),
(96042, '3.30.1150.10-FF-000019', NULL, 'Energy transducer TonB', 138, NULL, NULL, 96042),
(96043, '1.10.540.10-FF-000124', NULL, 'Acyl-CoA dehydrogenase', 125, NULL, NULL, 96043),
(96044, '2.30.29.30-FF-001034', NULL, 'Homer, putative', 66, NULL, NULL, 96044),
(96045, '2.40.20.10-FF-000018', NULL, 'Muscle, skeletal receptor tyrosine protein kinase', 99, NULL, NULL, 96045),
(96046, '1.25.40.10-FF-001474', NULL, 'Pentatricopeptide repeat-containing protein At1g59720, chloroplastic/mitochondrial', 160, NULL, NULL, 96046),
(96047, '1.20.1310.10-FF-000053', NULL, 'Cullin-3', 114, NULL, NULL, 96047);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(96048, '2.60.120.10-FF-000364', NULL, 'Mannose-6-phosphate isomerase', 219, NULL, NULL, 96048),
(96049, '3.40.800.20-FF-000037', NULL, 'Histone deacetylase 4', 390, NULL, NULL, 96049),
(96050, '1.10.1000.11-FF-000022', NULL, 'Uncharacterized protein', 119, NULL, NULL, 96050),
(96051, '1.25.10.10-FF-002360', NULL, 'Uncharacterized protein', 281, NULL, NULL, 96051),
(96052, '3.40.50.300-FF-003993', NULL, 'Ribosome biogenesis ATPase', 273, NULL, NULL, 96052),
(96053, '4.10.400.10-FF-000344', NULL, 'Uncharacterized protein', 46, NULL, NULL, 96053),
(96054, '3.60.20.30-FF-000004', NULL, 'Putative threonine aspartase isoform A', 166, NULL, NULL, 96054),
(96055, '1.10.10.10-FF-000156', NULL, 'DNA-binding transcriptional regulator CsiR', 61, NULL, NULL, 96055),
(96056, '2.40.100.10-FF-000013', NULL, 'Peptidyl-prolyl cis-trans isomerase', 167, NULL, NULL, 96056),
(96057, '3.40.30.10-FF-000803', NULL, 'Glutathione S-transferase 1-1-like Protein', 105, NULL, NULL, 96057),
(96058, '3.80.10.10-FF-004398', NULL, 'Predicted protein', 163, NULL, NULL, 96058),
(96059, '1.25.10.10-FF-000342', NULL, 'Serine/threonine-protein kinase VPS15', 347, NULL, NULL, 96059),
(96060, '3.30.70.330-FF-001990', NULL, NULL, 140, NULL, NULL, 96060),
(96061, '2.130.10.10-FF-000160', NULL, 'Protein phosphatase PP2A regulatory subunit B', 341, NULL, NULL, 96061),
(96062, '3.20.20.60-FF-000116', NULL, 'Pyruvate kinase', 234, NULL, NULL, 96062),
(96063, '3.40.50.1820-FF-000968', NULL, 'Aspergillus niger contig An11c0010, genomic contig', 277, NULL, NULL, 96063),
(96064, '1.10.560.10-FF-000125', NULL, 'T-complex protein 1 subunit eta', 94, NULL, NULL, 96064),
(96065, '1.25.40.10-FF-004110', NULL, 'Chitin synthase regulatory factor 2', 137, NULL, NULL, 96065),
(96066, '1.10.10.10-FF-001915', NULL, 'Uncharacterized protein', 101, NULL, NULL, 96066),
(96067, '1.10.560.10-FF-000013', NULL, 'ruBisCO large subunit-binding protein subunit alpha', 243, NULL, NULL, 96067),
(96068, '3.30.70.1230-FF-000058', NULL, 'Photoactivated adenylate cyclase subunit beta-like protein FB', 189, NULL, NULL, 96068),
(96069, '1.20.5.990-FF-000013', NULL, 'Uncharacterized protein', 85, NULL, NULL, 96069),
(96070, '1.20.272.10-FF-000032', NULL, 'Replication factor c subunit 4, putative', 92, NULL, NULL, 96070),
(96071, '2.130.10.10-FF-003594', NULL, 'Protein HIRA', 221, NULL, NULL, 96071),
(96072, '3.90.226.10-FF-000115', NULL, 'Probable enoyl-CoA hydratase echA6', 244, NULL, NULL, 96072),
(96073, '3.40.50.2300-FF-001394', NULL, NULL, 84, NULL, NULL, 96073),
(96074, '3.30.160.60-FF-002082', NULL, 'Zinc finger protein 646', 74, NULL, NULL, 96074),
(96075, '1.25.10.10-FF-002028', NULL, 'Uncharacterized protein', 231, NULL, NULL, 96075),
(96076, '2.40.50.100-FF-000143', NULL, 'ATP-binding subunit of an ABC-type osmolytetransporter', 79, NULL, NULL, 96076),
(96077, '2.60.40.10-FF-000176', NULL, 'Down syndrome cell adhesion molecule a', 99, NULL, NULL, 96077),
(96078, '3.40.50.12650-FF-000041', NULL, 'Predicted protein', 135, NULL, NULL, 96078),
(96079, '3.40.630.30-FF-000448', NULL, 'Acyl-CoA N-acyltransferase', 190, NULL, NULL, 96079),
(96080, '1.20.1560.10-FF-000779', NULL, 'Uncharacterized protein', 289, NULL, NULL, 96080),
(96081, '1.10.1240.40-FF-000002', NULL, 'ENT domain containing protein', 112, NULL, NULL, 96081),
(96082, '2.60.40.1700-FF-000001', NULL, 'Protein-arginine deiminase type-2', 173, NULL, NULL, 96082),
(96083, '3.40.50.1820-FF-000749', NULL, 'Carboxylic ester hydrolase', 537, NULL, NULL, 96083),
(96084, '3.30.559.70-FF-000060', NULL, 'Uncharacterized protein', 95, NULL, NULL, 96084),
(96085, '3.30.1640.10-FF-000001', NULL, 'DNA helicase', 109, NULL, NULL, 96085),
(96086, '1.25.40.10-FF-002075', NULL, 'GD11343', 146, NULL, NULL, 96086),
(96087, '3.30.420.40-FF-000550', NULL, 'Glucokinase', 104, NULL, NULL, 96087),
(96088, '3.40.50.150-FF-000474', NULL, 'Carboxy-S-adenosyl-L-methionine synthase', 230, NULL, NULL, 96088),
(96089, '3.30.720.210-FF-000011', NULL, 'ATP-dependent zinc metalloprotease FtsH', 100, NULL, NULL, 96089),
(96090, '1.20.1070.10-FF-000927', NULL, 'Uncharacterized protein', 186, NULL, NULL, 96090);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(96091, '2.30.30.30-FF-000143', NULL, '5''-3'' exoribonuclease 1', 45, NULL, NULL, 96091),
(96092, '3.10.20.90-FF-000417', NULL, 'GD22628', 112, NULL, NULL, 96092),
(96093, '3.30.160.60-FF-006353', NULL, NULL, 52, NULL, NULL, 96093),
(96094, '3.40.50.300-FF-004611', NULL, 'ORC1-type DNA replication protein 7', 83, NULL, NULL, 96094),
(96095, '2.60.40.10-FF-005864', NULL, NULL, 117, NULL, NULL, 96095),
(96096, '1.20.1070.10-FF-001534', NULL, 'Uncharacterized protein', 182, NULL, NULL, 96096),
(96097, '2.30.30.40-FF-000146', NULL, 'Tyrosine-protein kinase', 80, NULL, NULL, 96097),
(96098, '2.60.40.1120-FF-000035', NULL, 'SusC/RagA family TonB-linked outer membrane protein', 83, NULL, NULL, 96098),
(96099, '3.40.109.10-FF-000006', NULL, 'Oxygen-insensitive NADPH nitroreductase', 240, NULL, NULL, 96099),
(96100, '2.60.60.20-FF-000068', NULL, NULL, 135, NULL, NULL, 96100),
(96101, '3.40.50.1000-FF-000149', NULL, 'Related to trehalose-6-phosphate phosphatase', 119, NULL, NULL, 96101),
(96102, '2.40.180.10-FF-000006', NULL, 'lipoxygenase homology domain-containing protein 1', 135, NULL, NULL, 96102),
(96103, '3.30.2130.10-FF-000030', NULL, 'Uncharacterized protein', 132, NULL, NULL, 96103),
(96104, '1.10.580.10-FF-000014', NULL, 'Citrate synthase-like protein, putative', 241, NULL, NULL, 96104),
(96105, '3.90.79.20-FF-000017', NULL, 'NADH pyrophosphatase', 133, NULL, NULL, 96105),
(96106, '1.10.30.10-FF-000157', NULL, 'Uncharacterized protein', 68, NULL, NULL, 96106),
(96107, '3.30.160.60-FF-000406', NULL, 'Uncharacterized protein', 27, NULL, NULL, 96107),
(96108, '3.30.160.60-FF-002643', NULL, 'zinc finger protein 101', 28, NULL, NULL, 96108),
(96109, '3.40.1210.10-FF-000005', NULL, 'Acid phosphatase, putative', 301, NULL, NULL, 96109),
(96110, '1.10.1370.40-FF-000006', NULL, 'Organellar oligopeptidase A, chloroplastic/mitochondrial', 114, NULL, NULL, 96110),
(96111, '3.30.70.330-FF-001658', NULL, NULL, 57, NULL, NULL, 96111),
(96112, '3.60.21.10-FF-000321', NULL, 'NAD 5''-nucleotidase', 356, NULL, NULL, 96112),
(96113, '2.60.40.60-FF-000730', NULL, 'Fat-like cadherin-related tumor suppressor homolog', 95, NULL, NULL, 96113),
(96114, '1.25.40.10-FF-004109', NULL, 'NAC2 protein', 138, NULL, NULL, 96114),
(96115, '2.70.150.10-FF-000138', NULL, 'Phospholipid-transporting ATPase', 140, NULL, NULL, 96115),
(96116, '1.25.40.10-FF-003492', NULL, 'Pentatricopeptide repeat-containing protein At5g12100, mitochondrial', 75, NULL, NULL, 96116),
(96117, '2.130.10.10-FF-004212', NULL, 'Uncharacterized protein', 152, NULL, NULL, 96117),
(96118, '3.90.79.10-FF-000014', NULL, '8-oxo-dGTP diphosphatase MutT', 130, NULL, NULL, 96118),
(96119, '3.20.80.10-FF-000015', NULL, 'Heme-binding protein soul2', 173, NULL, NULL, 96119),
(96120, '2.130.10.10-FF-000721', NULL, 'intraflagellar transport protein 122 homolog', 91, NULL, NULL, 96120),
(96121, '4.10.280.30-FF-000002', NULL, 'EG:23E12.2, isoform A', 65, NULL, NULL, 96121),
(96122, '3.20.20.70-FF-000669', NULL, NULL, 213, NULL, NULL, 96122),
(96123, '1.10.1370.30-FF-000003', NULL, 'Thermostable carboxypeptidase 1', 498, NULL, NULL, 96123),
(96124, '4.10.280.10-FF-000244', NULL, 'Transcription factor bHLH62', 59, NULL, NULL, 96124),
(96125, '2.30.30.650-FF-000002', NULL, NULL, 27, NULL, NULL, 96125),
(96126, '1.20.1050.10-FF-000010', NULL, 'Maleylacetoacetate isomerase isoform 1', 127, NULL, NULL, 96126),
(96127, '3.30.70.340-FF-000026', NULL, NULL, 85, NULL, NULL, 96127),
(96128, '1.10.472.80-FF-000278', NULL, NULL, 168, NULL, NULL, 96128),
(96129, '3.80.10.10-FF-000688', NULL, 'Transforming growth factor beta activator LRRC33', 128, NULL, NULL, 96129),
(96130, '3.30.200.20-FF-001646', NULL, 'Calcium/calmodulin-dependent protein kinase type IV', 88, NULL, NULL, 96130),
(96131, '1.25.50.10-FF-000007', NULL, 'Peptidase M1 family protein', 97, NULL, NULL, 96131),
(96132, '1.20.1280.50-FF-000163', NULL, 'Protein SUPPRESSOR OF NIM1 1', 48, NULL, NULL, 96132),
(96133, '3.90.950.10-FF-000011', NULL, 'Maf-like protein, putative', 207, NULL, NULL, 96133),
(96134, '3.40.950.10-FF-000040', NULL, NULL, 80, NULL, NULL, 96134);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(96135, '2.60.40.290-FF-000002', NULL, 'Stalk-specific protein B', 94, NULL, NULL, 96135),
(96136, '3.30.70.1170-FF-000017', NULL, 'NOL1/NOP2/sun family, putative', 96, NULL, NULL, 96136),
(96137, '3.80.10.10-FF-001306', NULL, 'EIN3-binding F-box domain containing protein', 97, NULL, NULL, 96137),
(96138, '1.10.1130.10-FF-000013', NULL, 'Nitrite reductase (cytochrome; ammonia-forming)', 124, NULL, NULL, 96138),
(96139, '1.20.120.350-FF-000045', NULL, 'Potassium voltage-gated channel subfamily S member 3', 154, NULL, NULL, 96139),
(96140, '3.40.630.30-FF-000667', NULL, 'Predicted protein', 150, NULL, NULL, 96140),
(96141, '3.40.50.880-FF-000018', NULL, 'Carbamoyl-phosphate synthase small chain', 219, NULL, NULL, 96141),
(96142, '3.10.20.90-FF-000636', NULL, 'Ubiquitin domain-containing protein 7SL RNA2', 96, NULL, NULL, 96142),
(96143, '3.90.550.50-FF-000026', NULL, 'Glycoprotein-N-acetylgalactosamine 3-beta-galactosyltransferase 1', 238, NULL, NULL, 96143),
(96144, '2.70.130.10-FF-000143', NULL, NULL, 66, NULL, NULL, 96144),
(96145, '2.10.220.10-FF-000091', NULL, 'Proprotein convertase subtilisin/kexin type 5', 71, NULL, NULL, 96145),
(96146, '1.10.1420.10-FF-000114', NULL, 'DNA mismatch repair protein MutS', 120, NULL, NULL, 96146),
(96147, '3.30.420.10-FF-000569', NULL, NULL, 262, NULL, NULL, 96147),
(96148, '1.10.10.10-FF-000611', NULL, 'Transcriptional repressor of nicotinamide riboside utilization NrtR', 76, NULL, NULL, 96148),
(96149, '3.90.228.10-FF-000064', NULL, 'Uncharacterized protein', 106, NULL, NULL, 96149),
(96150, '2.60.40.10-FF-000070', NULL, 'Myosin-binding protein C, slow type', 96, NULL, NULL, 96150),
(96151, '3.40.190.290-FF-000130', NULL, 'Transcriptional regulator LysR family', 202, NULL, NULL, 96151),
(96152, '3.30.420.110-FF-000071', NULL, 'MutS domain III family protein', 144, NULL, NULL, 96152),
(96153, '2.30.30.140-FF-000193', NULL, 'Os11g0545600 protein', 55, NULL, NULL, 96153),
(96154, '3.30.60.190-FF-000001', NULL, 'box C/D snoRNA protein 1', 52, NULL, NULL, 96154),
(96155, '1.10.287.600-FF-000021', NULL, 'Alpha_tubulin,putative', 60, NULL, NULL, 96155),
(96156, '2.130.10.10-FF-002520', NULL, 'GG11023', 275, NULL, NULL, 96156),
(96157, '1.10.510.10-FF-000408', NULL, 'Serine/threonine-protein kinase SSN3', 248, NULL, NULL, 96157),
(96158, '2.70.150.10-FF-000251', NULL, 'Uncharacterized protein', 66, NULL, NULL, 96158),
(96159, '1.10.238.10-FF-000146', NULL, 'guanylyl cyclase-activating protein 2', 92, NULL, NULL, 96159),
(96160, '2.60.40.10-FF-001935', NULL, 'Twitchin', 104, NULL, NULL, 96160),
(96161, '1.10.8.60-FF-000524', NULL, 'Uncharacterized protein', 18, NULL, NULL, 96161),
(96162, '1.10.510.10-FF-002320', NULL, NULL, 214, NULL, NULL, 96162),
(96163, '2.60.40.10-FF-004341', NULL, NULL, 170, NULL, NULL, 96163),
(96164, '1.25.40.20-FF-001696', NULL, 'Uncharacterized protein', 68, NULL, NULL, 96164),
(96165, '3.40.50.10190-FF-000269', NULL, 'Putative dna topoisomerase 2-binding protein 1 isoform x1', 99, NULL, NULL, 96165),
(96166, '3.30.70.330-FF-000023', NULL, 'Heterogeneous nuclear ribonucleoprotein q isoform', 81, NULL, NULL, 96166),
(96167, '1.10.287.1490-FF-000108', NULL, 'Microtubule organizer protein 1', 161, NULL, NULL, 96167),
(96168, '1.10.510.10-FF-001589', NULL, 'Probable protein kinase DDB_G0277539', 176, NULL, NULL, 96168),
(96169, '3.30.565.10-FF-000141', NULL, 'Sensor histidine kinase/response regulator Fos-1', 165, NULL, NULL, 96169),
(96170, '2.60.40.640-FF-000028', NULL, 'Uncharacterized protein', 123, NULL, NULL, 96170),
(96171, '2.120.10.30-FF-000014', NULL, 'Low-density lipoprotein receptor-related protein 1', 319, NULL, NULL, 96171),
(96172, '3.40.50.1240-FF-000081', NULL, 'Putative phosphoglycerate mutase', 210, NULL, NULL, 96172),
(96173, '1.10.510.10-FF-002207', NULL, NULL, 117, NULL, NULL, 96173),
(96174, '2.60.300.12-FF-000015', NULL, 'Iron-sulfur cluster assembly accessory protein', 108, NULL, NULL, 96174),
(96175, '3.80.10.10-FF-003105', NULL, 'Fbxl18 protein', 106, NULL, NULL, 96175),
(96176, '3.40.50.10860-FF-000043', NULL, 'Bifunctional protein FolD', 150, NULL, NULL, 96176);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(96177, '1.20.1250.20-FF-001068', NULL, 'Nicotinamide mononucleotide permease, variant', 184, NULL, NULL, 96177),
(96178, '3.30.160.60-FF-002424', NULL, 'Zinc finger protein GIS3', 63, NULL, NULL, 96178),
(96179, '3.40.50.300-FF-004375', NULL, 'Probable thymidylate kinase', 213, NULL, NULL, 96179),
(96180, '1.25.40.10-FF-002311', NULL, 'Pentatricopeptide repeat-containing protein MRL1, chloroplastic', 106, NULL, NULL, 96180),
(96181, '3.40.50.1000-FF-000150', NULL, 'bifunctional TH2 protein, mitochondrial', 206, NULL, NULL, 96181),
(96182, '3.80.20.20-FF-000051', NULL, 'Predicted protein', 113, NULL, NULL, 96182),
(96183, '3.30.1310.10-FF-000010', NULL, 'Nucleoid-associated protein CbuG_1351', 101, NULL, NULL, 96183),
(96184, '1.10.510.10-FF-004337', NULL, NULL, 133, NULL, NULL, 96184),
(96185, '3.40.1110.10-FF-000419', NULL, NULL, 213, NULL, NULL, 96185),
(96186, '3.50.7.10-FF-000031', NULL, 'GD23041', 184, NULL, NULL, 96186),
(96187, '3.20.10.10-FF-000067', NULL, 'Branched-chain-amino-acid aminotransferase', 175, NULL, NULL, 96187),
(96188, '3.40.120.10-FF-000027', NULL, 'Phosphoglucosamine mutase', 117, NULL, NULL, 96188),
(96189, '3.80.10.10-FF-002829', NULL, 'Leucine-rich repeat protein kinase family protein', 98, NULL, NULL, 96189),
(96190, '1.10.1740.10-FF-000043', NULL, 'RNA polymerase sigma factor SigW, putative', 95, NULL, NULL, 96190),
(96191, '3.30.40.10-FF-001664', NULL, 'Uncharacterized protein', 85, NULL, NULL, 96191),
(96192, '3.80.10.10-FF-002487', NULL, 'Uncharacterized protein', 72, NULL, NULL, 96192),
(96193, '3.40.50.1820-FF-001463', NULL, 'Chromosome 21, whole genome shotgun sequence', 179, NULL, NULL, 96193),
(96194, '1.10.10.1680-FF-000001', NULL, 'Heterocyst differentiation control protein', 68, NULL, NULL, 96194),
(96195, '2.130.10.10-FF-000266', NULL, 'WD repeat-containing protein 59 isoform X1', 213, NULL, NULL, 96195),
(96196, '1.25.10.10-FF-002141', NULL, 'Uncharacterized protein', 554, NULL, NULL, 96196),
(96197, '1.10.238.100-FF-000002', NULL, 'AP-1-like transcription factor', 86, NULL, NULL, 96197),
(96198, '3.90.550.10-FF-000262', NULL, 'Glycosyltransferases', 257, NULL, NULL, 96198),
(96199, '3.30.70.2580-FF-000002', NULL, '1-methylguanosine tRNA methyltransferase', 66, NULL, NULL, 96199),
(96200, '3.20.20.140-FF-000436', NULL, 'Predicted protein', 141, NULL, NULL, 96200),
(96201, '3.40.50.300-FF-008208', NULL, 'Developmentally-regulated GTP-binding protein 1', 71, NULL, NULL, 96201),
(96202, '3.90.1750.10-FF-000068', NULL, 'Putative E3 ubiquitin-protein ligase TRIP12-like', 35, NULL, NULL, 96202),
(96203, '3.40.1190.20-FF-000186', NULL, NULL, 290, NULL, NULL, 96203),
(96204, '1.20.5.4770-FF-000010', NULL, 'RAB eXchange factor', 73, NULL, NULL, 96204),
(96205, '3.10.450.580-FF-000014', NULL, 'Mediator of RNA polymerase II transcription subunit 6', 169, NULL, NULL, 96205),
(96206, '1.20.1560.10-FF-000892', NULL, 'Uncharacterized protein', 18, NULL, NULL, 96206),
(96207, '3.90.550.10-FF-000604', NULL, 'Putative glycosyl transferase', 219, NULL, NULL, 96207),
(96208, '2.60.120.260-FF-000103', NULL, 'Glycosyl hydrolase family 10 protein', 157, NULL, NULL, 96208),
(96209, '3.90.79.10-FF-000233', NULL, 'Tyrosine--tRNA ligase', 70, NULL, NULL, 96209),
(96210, '3.10.20.90-FF-000294', NULL, 'Nuclear protein localization protein 4, putative', 88, NULL, NULL, 96210),
(96211, '2.60.40.790-FF-000045', NULL, 'Hsp20/alpha crystallin family protein', 142, NULL, NULL, 96211),
(96212, '3.40.50.1820-FF-001805', NULL, 'Carboxylic ester hydrolase', 135, NULL, NULL, 96212),
(96213, '3.40.50.300-FF-000665', NULL, 'ABC transporter A family member 2', 254, NULL, NULL, 96213),
(96214, '1.10.20.10-FF-000095', NULL, 'Histone H2A', 107, NULL, NULL, 96214),
(96215, '1.10.520.10-FF-000016', NULL, 'Adenylate/guanylate cyclase catalytic domain protein', 117, NULL, NULL, 96215),
(96216, '3.30.70.1230-FF-000171', NULL, 'Blr1670 protein', 192, NULL, NULL, 96216),
(96217, '3.30.830.10-FF-000145', NULL, 'Uncharacterized protein CaJ7.0411', 248, NULL, NULL, 96217),
(96218, '1.10.10.60-FF-000710', NULL, 'Paired box 7a', 57, NULL, NULL, 96218);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(96219, '2.60.40.10-FF-000412', NULL, 'tripartite motif-containing protein 3', 103, NULL, NULL, 96219),
(96220, '3.30.70.100-FF-000084', NULL, 'ATPase copper-transporting alpha', 69, NULL, NULL, 96220),
(96221, '1.10.418.10-FF-000019', NULL, 'Vav guanine nucleotide exchange factor 2', 164, NULL, NULL, 96221),
(96222, '2.60.40.10-FF-002087', NULL, 'AIR9 protein', 89, NULL, NULL, 96222),
(96223, '1.10.510.10-FF-000066', NULL, 'Serine/threonine-protein kinase DCLK1 isoform 2', 211, NULL, NULL, 96223),
(96224, '2.120.10.80-FF-000113', NULL, 'Serine/threonine-protein phosphatase', 144, NULL, NULL, 96224),
(96225, '1.25.10.10-FF-001865', NULL, 'Pumilio/PUF RNA binding protein 10, putative', 168, NULL, NULL, 96225),
(96226, '3.40.1110.10-FF-000077', NULL, 'Calcium-transporting ATPase', 27, NULL, NULL, 96226),
(96227, '1.20.5.110-FF-000345', NULL, 'Synaptosomal-associated protein', 44, NULL, NULL, 96227),
(96228, '1.10.287.70-FF-000558', NULL, 'Uncharacterized protein', 181, NULL, NULL, 96228),
(96229, '3.40.50.200-FF-000186', NULL, 'Uncharacterized protein', 115, NULL, NULL, 96229),
(96230, '3.40.190.10-FF-000071', NULL, 'Glutamate receptor, ionotropic, N-methyl-D-aspartate 3B', 12, NULL, NULL, 96230),
(96231, '3.50.50.60-FF-000240', NULL, '3-ketosteroid-delta-1-dehydrogenase', 73, NULL, NULL, 96231),
(96232, '3.30.70.3250-FF-000001', NULL, 'Ribonuclease P/MRP protein subunit POP5', 120, NULL, NULL, 96232),
(96233, '1.10.3730.20-FF-000006', NULL, 'Probable magnesium transporter', 115, NULL, NULL, 96233),
(96234, '3.30.1390.20-FF-000006', NULL, '50S ribosomal protein L30', 59, NULL, NULL, 96234),
(96235, '1.20.1070.10-FF-001079', NULL, 'G-protein coupled receptor GRL101-like protein', 325, NULL, NULL, 96235),
(96236, '3.30.1390.30-FF-000009', NULL, NULL, 70, NULL, NULL, 96236),
(96237, '2.60.40.10-FF-000850', NULL, 'Beta-galactosidase', 106, NULL, NULL, 96237),
(96238, '2.130.10.10-FF-002301', NULL, 'Uncharacterized protein', 136, NULL, NULL, 96238),
(96239, '3.30.420.40-FF-000331', NULL, 'Heat shock protein 105 kDa', 77, NULL, NULL, 96239),
(96240, '2.70.98.30-FF-000045', NULL, 'Uncharacterized protein', 42, NULL, NULL, 96240),
(96241, '1.20.1250.20-FF-001181', NULL, 'Major facilitator superfamily multidrug transporter mdr3', 202, NULL, NULL, 96241),
(96242, '3.40.30.40-FF-000003', NULL, 'Perfringolysin O', 125, NULL, NULL, 96242),
(96243, '3.30.1390.10-FF-000003', NULL, 'E3 ubiquitin-protein ligase UBR2 isoform X1', 99, NULL, NULL, 96243),
(96244, '3.90.1100.10-FF-000042', NULL, 'DNA-directed RNA polymerase subunit beta', 244, NULL, NULL, 96244),
(96245, '3.40.33.10-FF-000046', NULL, 'Venom allergen-like protein', 205, NULL, NULL, 96245),
(96246, '3.30.160.60-FF-000283', NULL, 'Putative transcriptional repressor ctcf', 53, NULL, NULL, 96246),
(96247, '1.25.10.10-FF-000561', NULL, 'ARM repeat superfamily protein', 299, NULL, NULL, 96247),
(96248, '3.40.1050.10-FF-000021', NULL, 'Carbonic anhydrase', 221, NULL, NULL, 96248),
(96249, '3.40.190.10-FF-000413', NULL, 'LysR family transcriptional regulator', 95, NULL, NULL, 96249),
(96250, '3.90.550.10-FF-000149', NULL, 'Alpha-1,6-mannosyltransferase subunit', 233, NULL, NULL, 96250),
(96251, '1.10.3730.10-FF-000003', NULL, 'Pyrroline-5-carboxylate reductase 1, mitochondrial', 106, NULL, NULL, 96251),
(96252, '3.90.1150.10-FF-000320', NULL, 'Serine palmitoyl CoA transferase subunit LCBA', 59, NULL, NULL, 96252),
(96253, '2.10.25.10-FF-001082', NULL, 'Signal peptide, CUB domain, EGF-like 2', 50, NULL, NULL, 96253),
(96254, '3.40.50.1100-FF-000067', NULL, 'Cysteine synthase', 190, NULL, NULL, 96254),
(96255, '2.10.70.10-FF-000219', NULL, 'Protein lev-9', 67, NULL, NULL, 96255),
(96256, '3.30.310.180-FF-000005', NULL, 'Mediator of RNA polymerase II transcription subunit 20', 49, NULL, NULL, 96256),
(96257, '3.90.70.10-FF-000365', NULL, 'Ubiquitin carboxyl-terminal hydrolase 13', 197, NULL, NULL, 96257),
(96258, '1.20.5.1430-FF-000014', NULL, 'EB1', 90, NULL, NULL, 96258),
(96259, '3.40.50.300-FF-002700', NULL, 'DNA repair helicase putative', 204, NULL, NULL, 96259);
INSERT INTO "PUBLIC"."MODEL" VALUES
(96260, '2.40.170.20-FF-000060', NULL, 'TonB-dependent Receptor Plug Domain protein', 569, NULL, NULL, 96260),
(96261, '2.10.25.10-FF-000929', NULL, 'Uncharacterized protein', 49, NULL, NULL, 96261),
(96262, '2.40.30.10-FF-000300', NULL, 'Elongation factor 1 alpha-like protein, putative', 96, NULL, NULL, 96262),
(96263, '2.10.25.10-FF-001424', NULL, 'Integrin beta', 53, NULL, NULL, 96263),
(96264, '3.10.150.10-FF-000002', NULL, 'Beta sliding clamp', 124, NULL, NULL, 96264),
(96265, '2.40.10.10-FF-000411', NULL, NULL, 199, NULL, NULL, 96265),
(96266, '3.30.565.10-FF-000360', NULL, 'Mismatch repair protein', 222, NULL, NULL, 96266),
(96267, '1.10.8.60-FF-000069', NULL, 'spermatogenesis-associated protein 5 isoform X1', 71, NULL, NULL, 96267),
(96268, '3.50.30.30-FF-000039', NULL, 'Subtilisin-like protease SBT3', 134, NULL, NULL, 96268),
(96269, '1.10.3210.10-FF-000076', NULL, 'Diguanylate cyclase and metal dependent phosphohydrolase', 190, NULL, NULL, 96269),
(96270, '3.30.160.60-FF-001120', NULL, 'zinc finger protein 618 isoform X2', 66, NULL, NULL, 96270),
(96271, '4.10.1240.50-FF-000019', NULL, 'LD32549p', 43, NULL, NULL, 96271),
(96272, '1.10.3460.10-FF-000010', NULL, 'Chlorophyll a-b binding protein, chloroplastic', 208, NULL, NULL, 96272),
(96273, '2.10.25.10-FF-001205', NULL, 'Uncharacterized protein', 37, NULL, NULL, 96273),
(96274, '3.30.2020.30-FF-000027', NULL, 'Uncharacterized protein', 96, NULL, NULL, 96274),
(96275, '3.30.160.60-FF-004554', NULL, NULL, 78, NULL, NULL, 96275),
(96276, '2.60.260.20-FF-000062', NULL, 'Heat shock protein-like', 88, NULL, NULL, 96276),
(96277, '2.60.40.60-FF-000617', NULL, 'Uncharacterized protein', 106, NULL, NULL, 96277),
(96278, '3.40.1810.10-FF-000085', NULL, NULL, 84, NULL, NULL, 96278),
(96279, '3.40.50.1480-FF-000023', NULL, NULL, 220, NULL, NULL, 96279),
(96280, '1.10.8.270-FF-000041', NULL, 'TBC1 domain family member 25', 99, NULL, NULL, 96280),
(96281, '2.120.10.80-FF-000332', NULL, 'tRNA wybutosine-synthesizing protein 4', 130, NULL, NULL, 96281),
(96282, '2.60.40.150-FF-000320', NULL, 'C2 domain-containing protein aex-1', 136, NULL, NULL, 96282),
(96283, '2.130.10.10-FF-004318', NULL, 'Uncharacterized protein', 108, NULL, NULL, 96283),
(96284, '3.30.420.40-FF-000112', NULL, 'Heat shock 70 kDa protein 14', 143, NULL, NULL, 96284),
(96285, '3.90.640.90-FF-000017', NULL, 'BTG family protein', 130, NULL, NULL, 96285),
(96286, '1.10.418.10-FF-000132', NULL, 'Actin binding protein putative', 113, NULL, NULL, 96286),
(96287, '3.30.1360.120-FF-000029', NULL, 'Mitochondrial GTPase (Mss1), putative', 140, NULL, NULL, 96287),
(96288, '1.10.10.2360-FF-000003', NULL, 'Nucleoporin-like protein', 50, NULL, NULL, 96288),
(96289, '1.25.40.10-FF-001693', NULL, 'Protein O-mannosyl-transferase TMTC2', 149, NULL, NULL, 96289),
(96290, '1.10.150.240-FF-000110', NULL, 'Phosphoglycolate phosphatase 1', 72, NULL, NULL, 96290),
(96291, '1.10.287.70-FF-000777', NULL, 'Uncharacterized protein', 103, NULL, NULL, 96291),
(96292, '3.40.50.1100-FF-000286', NULL, 'Uncharacterized protein', 26, NULL, NULL, 96292),
(96293, '3.60.60.30-FF-000001', NULL, 'Phospholipase B-like protein G', 520, NULL, NULL, 96293),
(96294, '3.30.160.60-FF-005971', NULL, NULL, 67, NULL, NULL, 96294),
(96295, '1.10.150.50-FF-000078', NULL, 'Sterile alpha motif (SAM) domain-containing protein', 76, NULL, NULL, 96295),
(96296, '2.40.50.140-FF-001088', NULL, NULL, 75, NULL, NULL, 96296),
(96297, '2.60.40.10-FF-000631', NULL, 'Hyaluronan and proteoglycan link protein 1', 118, NULL, NULL, 96297),
(96298, '2.60.40.10-FF-004009', NULL, NULL, 99, NULL, NULL, 96298),
(96299, '1.10.555.10-FF-000158', NULL, 'YALI0A12111p', 250, NULL, NULL, 96299),
(96300, '3.40.50.300-FF-006410', NULL, 'Uncharacterized protein', 131, NULL, NULL, 96300),
(96301, '1.10.510.10-FF-000285', NULL, 'Mitogen-activated protein kinase kinase 6', 199, NULL, NULL, 96301),
(96302, '1.10.287.110-FF-000076', NULL, 'Chaperone protein dnaJ', 120, NULL, NULL, 96302),
(96303, '1.20.58.340-FF-000054', NULL, 'CorA family metal ion transporter', 76, NULL, NULL, 96303);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(96304, '1.10.20.120-FF-000007', NULL, 'Uncharacterized protein', 127, NULL, NULL, 96304),
(96305, '3.30.160.60-FF-005639', NULL, NULL, 52, NULL, NULL, 96305),
(96306, '1.10.10.10-FF-000050', NULL, 'Cullin 4B', 74, NULL, NULL, 96306),
(96307, '3.30.390.10-FF-000010', NULL, 'Dipeptide epimerase', 103, NULL, NULL, 96307),
(96308, '2.40.10.10-FF-000630', NULL, NULL, 235, NULL, NULL, 96308),
(96309, '2.60.120.200-FF-000799', NULL, 'Neurexin I isoform B', 87, NULL, NULL, 96309),
(96310, '2.10.90.10-FF-000108', NULL, 'DAN domain family, member 5', 116, NULL, NULL, 96310),
(96311, '3.40.430.10-FF-000017', NULL, 'Bifunctional dihydrofolate reductase-thymidylate synthase', 226, NULL, NULL, 96311),
(96312, '1.20.1250.20-FF-001742', NULL, 'Major facilitator superfamily domain containing 4B', 284, NULL, NULL, 96312),
(96313, '2.10.220.10-FF-000214', NULL, 'Uncharacterized protein', 50, NULL, NULL, 96313),
(96314, '3.90.550.10-FF-000481', NULL, 'Galactosyl transferase GMA12/MNN10 family-domain-containing protein', 201, NULL, NULL, 96314),
(96315, '3.40.309.10-FF-000100', NULL, 'Uncharacterized protein', 195, NULL, NULL, 96315),
(96316, '3.40.140.10-FF-000135', NULL, 'Nuclear protein localization protein 4, variant', 208, NULL, NULL, 96316),
(96317, '2.130.10.10-FF-000047', NULL, 'Mitotic checkpoint protein bub3, putative', 325, NULL, NULL, 96317),
(96318, '2.30.29.240-FF-000001', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 212, NULL, NULL, 96318),
(96319, '1.20.1260.100-FF-000008', NULL, NULL, 135, NULL, NULL, 96319),
(96320, '3.40.50.2000-FF-000005', NULL, 'Alpha-1,4 glucan phosphorylase', 327, NULL, NULL, 96320),
(96321, '1.25.10.10-FF-001646', NULL, 'Expressed protein', 436, NULL, NULL, 96321),
(96322, '3.10.450.10-FF-000042', NULL, 'Salivary cystatin-L', 115, NULL, NULL, 96322),
(96323, '1.20.1050.20-FF-000013', NULL, NULL, 187, NULL, NULL, 96323),
(96324, '3.50.50.60-FF-001325', NULL, 'Uncharacterized protein', 142, NULL, NULL, 96324),
(96325, '2.10.25.10-FF-000587', NULL, 'Slit 2', 40, NULL, NULL, 96325),
(96326, '1.25.40.10-FF-002530', NULL, 'Protein sel-1 homolog 1 isoform 1', 115, NULL, NULL, 96326),
(96327, '2.60.40.60-FF-000275', NULL, 'Si:dkey-30k22.7', 107, NULL, NULL, 96327),
(96328, '2.30.31.40-FF-000002', NULL, 'Guide RNA binding protein gBP25', 169, NULL, NULL, 96328),
(96329, '3.40.50.150-FF-000036', NULL, 'DNA (cytosine-5)-methyltransferase', 268, NULL, NULL, 96329),
(96330, '3.30.1130.10-FF-000024', NULL, 'Uncharacterized protein', 137, NULL, NULL, 96330),
(96331, '1.25.10.10-FF-000229', NULL, 'TELO2-interacting protein 1 homolog', 202, NULL, NULL, 96331),
(96332, '1.10.10.60-FF-000036', NULL, 'Two-component system response regulator', 57, NULL, NULL, 96332),
(96333, '3.40.50.300-FF-000446', NULL, 'ATP-dependent RNA helicase SUPV3L1, mitochondrial', 156, NULL, NULL, 96333),
(96334, '1.10.10.10-FF-002067', NULL, 'ATP-dependent DNA helicase', 146, NULL, NULL, 96334),
(96335, '3.30.565.10-FF-000028', NULL, 'PAS sensor protein', 123, NULL, NULL, 96335),
(96336, '3.10.110.10-FF-000224', NULL, 'UBE2O', 136, NULL, NULL, 96336),
(96337, '3.30.750.24-FF-000142', NULL, 'Glycosyl transferase, WecB/TagA/CpsF family', 106, NULL, NULL, 96337),
(96338, '3.30.590.10-FF-000037', NULL, 'Uncharacterized protein', 247, NULL, NULL, 96338),
(96339, '3.30.720.210-FF-000006', NULL, 'ATP-dependent zinc metalloprotease FtsH', 74, NULL, NULL, 96339),
(96340, '2.10.230.10-FF-000013', NULL, 'DnaJ homolog, isoform A', 64, NULL, NULL, 96340),
(96341, '3.10.580.10-FF-000142', NULL, 'Uncharacterized protein', 105, NULL, NULL, 96341),
(96342, '3.30.559.70-FF-000055', NULL, 'Carnitine acyltransferase, putative', 136, NULL, NULL, 96342),
(96343, '3.40.50.300-FF-005747', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 281, NULL, NULL, 96343),
(96344, '3.30.450.20-FF-000389', NULL, 'Two-component response regulator', 73, NULL, NULL, 96344),
(96345, '1.25.10.10-FF-003030', NULL, 'Uncharacterized protein', 314, NULL, NULL, 96345),
(96346, '3.30.200.20-FF-001186', NULL, 'Receptor-like serine/threonine-protein kinase ALE2', 88, NULL, NULL, 96346);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(96347, '3.40.630.30-FF-000319', NULL, 'N-acetyltransferase', 91, NULL, NULL, 96347),
(96348, '2.60.40.10-FF-005909', NULL, NULL, 55, NULL, NULL, 96348),
(96349, '2.60.40.10-FF-004280', NULL, NULL, 119, NULL, NULL, 96349),
(96350, '3.80.10.10-FF-001138', NULL, 'F-box only protein 39', 318, NULL, NULL, 96350),
(96351, '1.20.1250.20-FF-000113', NULL, 'Purine ribonucleoside efflux pump NepI', 380, NULL, NULL, 96351),
(96352, '3.30.160.60-FF-003740', NULL, NULL, 34, NULL, NULL, 96352),
(96353, '2.30.29.30-FF-000865', NULL, 'Uncharacterized protein', 135, NULL, NULL, 96353),
(96354, '3.10.100.10-FF-000174', NULL, 'Immune-related lectin-like receptor 3 splice variant a', 206, NULL, NULL, 96354),
(96355, '3.40.30.10-FF-000624', NULL, 'Protein disulfide isomerase', 97, NULL, NULL, 96355),
(96356, '2.20.50.20-FF-000013', NULL, 'Vitellogenin', 84, NULL, NULL, 96356),
(96357, '1.10.20.10-FF-000242', NULL, NULL, 101, NULL, NULL, 96357),
(96358, '3.40.50.300-FF-002993', NULL, 'ABC transporter, multidrug resistance associated protein', 261, NULL, NULL, 96358),
(96359, '3.20.10.10-FF-000051', NULL, 'Probable branched-chain amino acid aminotransferase', 161, NULL, NULL, 96359),
(96360, '2.10.25.10-FF-000312', NULL, 'neural-cadherin isoform X10', 70, NULL, NULL, 96360),
(96361, '3.20.20.140-FF-000419', NULL, 'Imidazolonepropionase, putative', 71, NULL, NULL, 96361),
(96362, '3.90.190.10-FF-000330', NULL, 'Uncharacterized protein', 63, NULL, NULL, 96362),
(96363, '1.10.630.10-FF-000660', NULL, 'Cytochrome P450, family 2, subfamily R, polypeptide 1', 190, NULL, NULL, 96363),
(96364, '2.10.25.10-FF-001301', NULL, 'Uncharacterized protein', 58, NULL, NULL, 96364),
(96365, '1.10.1070.11-FF-000061', NULL, 'Serine/threonine-protein kinase ATR', 169, NULL, NULL, 96365),
(96366, '3.40.50.1000-FF-000077', NULL, 'Phosphoserine phosphatase, chloroplastic', 151, NULL, NULL, 96366),
(96367, '3.30.1120.30-FF-000002', NULL, 'Serine/threonine-protein kinase PLK', 106, NULL, NULL, 96367),
(96368, '3.30.565.10-FF-000557', NULL, 'Protein-histidine kinase, putative', 211, NULL, NULL, 96368),
(96369, '2.60.40.60-FF-000500', NULL, 'Cadherin-2', 90, NULL, NULL, 96369),
(96370, '1.10.1670.10-FF-000021', NULL, 'Endonuclease III homolog', 101, NULL, NULL, 96370),
(96371, '2.60.40.150-FF-000062', NULL, 'synaptotagmin-14 isoform X1', 152, NULL, NULL, 96371),
(96372, '3.30.70.120-FF-000028', NULL, NULL, 115, NULL, NULL, 96372),
(96373, '1.10.472.130-FF-000044', NULL, 'Dynein alpha chain, flagellar outer arm', 143, NULL, NULL, 96373),
(96374, '1.10.3470.10-FF-000040', NULL, 'Vitamin B12 ABC transporter, permease component BtuC', 320, NULL, NULL, 96374),
(96375, '3.90.550.10-FF-000313', NULL, 'Uncharacterized protein', 294, NULL, NULL, 96375),
(96376, '3.40.50.880-FF-000109', NULL, 'Uncharacterized protein', 218, NULL, NULL, 96376),
(96377, '2.40.50.140-FF-000779', NULL, NULL, 82, NULL, NULL, 96377),
(96378, '3.40.50.620-FF-000262', NULL, 'Tryptophan--tRNA ligase', 213, NULL, NULL, 96378),
(96379, '1.20.1720.10-FF-000068', NULL, 'Uncharacterized MFS-type transporter YwoD', 234, NULL, NULL, 96379),
(96380, '1.25.40.10-FF-000305', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 222, NULL, NULL, 96380),
(96381, '3.40.50.300-FF-006736', NULL, 'RAB36, member RAS oncogene family', 69, NULL, NULL, 96381),
(96382, '3.30.70.330-FF-001873', NULL, NULL, 161, NULL, NULL, 96382),
(96383, '1.20.58.60-FF-000332', NULL, 'VAB-10B protein', 111, NULL, NULL, 96383),
(96384, '1.10.510.10-FF-002039', NULL, 'cDNA FLJ50375, highly similar to Serine/threonine-protein kinase RIO3', 141, NULL, NULL, 96384),
(96385, '2.130.10.10-FF-001026', NULL, 'Atg18p', 201, NULL, NULL, 96385),
(96386, '2.70.150.10-FF-000201', NULL, 'Phospholipid-transporting ATPase', 166, NULL, NULL, 96386),
(96387, '2.60.120.230-FF-000005', NULL, NULL, 93, NULL, NULL, 96387),
(96388, '1.20.1250.20-FF-001541', NULL, 'ORF', 423, NULL, NULL, 96388),
(96389, '2.130.10.10-FF-001498', NULL, 'Rtt10p', 303, NULL, NULL, 96389),
(96390, '1.20.1640.10-FF-000067', NULL, 'Transmembrane transport protein mmpL13b', 223, NULL, NULL, 96390);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(96391, '1.10.287.2900-FF-000015', NULL, 'Cox19-like CHCH family protein', 97, NULL, NULL, 96391),
(96392, '3.40.47.10-FF-000247', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase', 429, NULL, NULL, 96392),
(96393, '4.10.280.10-FF-000031', NULL, 'Oligodendrocyte transcription factor 3', 70, NULL, NULL, 96393),
(96394, '1.10.8.60-FF-000491', NULL, 'Uncharacterized protein', 88, NULL, NULL, 96394),
(96395, '1.10.490.10-FF-000036', NULL, 'Uncharacterized protein', 119, NULL, NULL, 96395),
(96396, '3.40.50.150-FF-001498', NULL, NULL, 115, NULL, NULL, 96396),
(96397, '1.10.10.1770-FF-000001', NULL, 'Tetrapyrrole-binding protein, chloroplastic', 88, NULL, NULL, 96397),
(96398, '3.30.505.10-FF-000109', NULL, 'CRE-STA-2 protein', 84, NULL, NULL, 96398),
(96399, '3.30.160.60-FF-002751', NULL, 'Uncharacterized protein', 27, NULL, NULL, 96399),
(96400, '3.40.50.300-FF-004758', NULL, 'Uncharacterized protein', 66, NULL, NULL, 96400),
(96401, '3.40.50.2000-FF-001057', NULL, 'UDP-N-acetylglucosamine transferase subunit ALG14', 202, NULL, NULL, 96401),
(96402, '3.30.40.10-FF-001991', NULL, 'Os02g0611300 protein', 55, NULL, NULL, 96402),
(96403, '1.10.533.10-FF-000277', NULL, 'Si:ch211-108d22.2', 96, NULL, NULL, 96403),
(96404, '1.10.8.10-FF-000257', NULL, 'Zinc finger protein', 61, NULL, NULL, 96404),
(96405, '2.10.25.10-FF-001740', NULL, 'Integrin beta', 57, NULL, NULL, 96405),
(96406, '2.30.30.30-FF-000138', NULL, '30S ribosomal protein S4e', 58, NULL, NULL, 96406),
(96407, '2.10.25.10-FF-000784', NULL, 'Uncharacterized protein', 38, NULL, NULL, 96407),
(96408, '3.30.40.10-FF-001839', NULL, 'Uncharacterized protein', 122, NULL, NULL, 96408),
(96409, '3.30.70.1220-FF-000005', NULL, 'TFIIH basal transcription factor complex TTD-A subunit', 74, NULL, NULL, 96409),
(96410, '2.60.98.10-FF-000006', NULL, 'Genome polyprotein', 126, NULL, NULL, 96410),
(96411, '3.30.160.60-FF-004196', NULL, NULL, 76, NULL, NULL, 96411),
(96412, '3.60.21.10-FF-000248', NULL, 'Serine/threonine-protein phosphatase', 251, NULL, NULL, 96412),
(96413, '4.10.640.10-FF-000014', NULL, '30S ribosomal protein S18', 84, NULL, NULL, 96413),
(96414, '3.90.70.10-FF-000017', NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', 400, NULL, NULL, 96414),
(96415, '3.40.50.300-FF-002521', NULL, 'ATPase', 164, NULL, NULL, 96415),
(96416, '1.25.40.10-FF-004200', NULL, 'Uncharacterized protein', 71, NULL, NULL, 96416),
(96417, '3.30.70.330-FF-000445', NULL, 'RNA-binding protein, putative', 107, NULL, NULL, 96417),
(96418, '3.40.50.2300-FF-000540', NULL, 'LacI family transcriptional regulator', 133, NULL, NULL, 96418),
(96419, '3.40.50.1110-FF-000138', NULL, 'Probable platelet-activating factor acetylhydrolase IB gamma subunit', 206, NULL, NULL, 96419),
(96420, '3.40.920.10-FF-000027', NULL, NULL, 149, NULL, NULL, 96420),
(96421, '3.30.420.40-FF-000747', NULL, 'Actin-like protein 2', 162, NULL, NULL, 96421),
(96422, '2.130.10.10-FF-005393', NULL, 'Uncharacterized protein', 151, NULL, NULL, 96422),
(96423, '1.10.10.60-FF-000059', NULL, 'TGFB-induced factor homeobox 1', 78, NULL, NULL, 96423),
(96424, '1.50.40.10-FF-000213', NULL, 'Mitochondrial carrier protein, putative', 254, NULL, NULL, 96424),
(96425, '3.40.50.10330-FF-000126', NULL, 'Diacylglycerol kinase', 63, NULL, NULL, 96425),
(96426, '3.30.710.10-FF-000126', NULL, 'BTB/POZ domain-containing protein 18', 121, NULL, NULL, 96426),
(96427, '3.90.79.10-FF-000037', NULL, 'Nudix hydrolase 2', 146, NULL, NULL, 96427),
(96428, '1.25.10.10-FF-000949', NULL, 'Protein HASTY 1', 747, NULL, NULL, 96428),
(96429, '3.30.559.10-FF-000144', NULL, 'Peptide synthetase', 206, NULL, NULL, 96429),
(96430, '3.30.497.10-FF-000011', NULL, 'heparin cofactor 2 isoform X1', 209, NULL, NULL, 96430),
(96431, '3.30.530.20-FF-000070', NULL, 'Uncharacterized protein', 223, NULL, NULL, 96431),
(96432, '1.20.1050.10-FF-000275', NULL, 'Uncharacterized protein', 91, NULL, NULL, 96432),
(96433, '3.40.50.720-FF-001894', NULL, 'Uncharacterized protein', 67, NULL, NULL, 96433),
(96434, '1.20.1070.10-FF-002103', NULL, 'Predicted protein', 340, NULL, NULL, 96434);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(96435, '3.40.50.720-FF-000466', NULL, 'Probable short-chain type dehydrogenase/reductase', 264, NULL, NULL, 96435),
(96436, '2.60.40.10-FF-003291', NULL, NULL, 92, NULL, NULL, 96436),
(96437, '2.60.120.200-FF-000581', NULL, 'Uncharacterized protein', 167, NULL, NULL, 96437),
(96438, '3.30.1370.10-FF-000008', NULL, 'far upstream element-binding protein 1 isoform X1', 101, NULL, NULL, 96438),
(96439, '2.70.70.10-FF-000072', NULL, 'Gll2330 protein', 142, NULL, NULL, 96439),
(96440, '3.30.160.60-FF-001323', NULL, 'zinc finger protein 771', 27, NULL, NULL, 96440),
(96441, '3.40.630.50-FF-000005', NULL, 'D-aminoacyl-tRNA deacylase', 163, NULL, NULL, 96441),
(96442, '1.10.510.10-FF-004395', NULL, NULL, 88, NULL, NULL, 96442),
(96443, '2.60.120.10-FF-000718', NULL, 'Uncharacterized protein', 138, NULL, NULL, 96443),
(96444, '3.40.50.300-FF-000104', NULL, 'ATP-binding cassette sub-family F member 3', 254, NULL, NULL, 96444),
(96445, '3.90.190.20-FF-000007', NULL, 'Folylpolyglutamate synthase', 119, NULL, NULL, 96445),
(96446, '2.60.300.12-FF-000010', NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', 110, NULL, NULL, 96446),
(96447, '2.60.120.260-FF-000020', NULL, 'neuroendocrine convertase 2', 135, NULL, NULL, 96447),
(96448, '2.60.40.790-FF-000046', NULL, 'Heat shock protein beta-3', 99, NULL, NULL, 96448),
(96449, '3.90.260.10-FF-000066', NULL, 'Uncharacterized protein', 194, NULL, NULL, 96449),
(96450, '3.80.10.10-FF-002566', NULL, 'leucine-rich repeat and guanylate kinase domain-containing protein-like', 127, NULL, NULL, 96450),
(96451, '3.60.20.10-FF-000196', NULL, NULL, 221, NULL, NULL, 96451),
(96452, '3.50.50.60-FF-001056', NULL, 'Flavin-containing monooxygenase', 77, NULL, NULL, 96452),
(96453, '1.10.490.160-FF-000005', NULL, 'Ryanodine receptor 2', 108, NULL, NULL, 96453),
(96454, '1.10.238.10-FF-000141', NULL, 'transmembrane prolyl 4-hydroxylase', 74, NULL, NULL, 96454),
(96455, '3.30.870.10-FF-000019', NULL, 'phospholipase D3 isoform X1', 197, NULL, NULL, 96455),
(96456, '1.25.40.10-FF-003683', NULL, 'Uncharacterized protein', 136, NULL, NULL, 96456),
(96457, '2.60.40.10-FF-006045', NULL, NULL, 42, NULL, NULL, 96457),
(96458, '3.30.160.60-FF-000834', NULL, 'Uncharacterized protein', 28, NULL, NULL, 96458),
(96459, '1.25.40.10-FF-002694', NULL, 'G-protein regulator 1', 317, NULL, NULL, 96459),
(96460, '1.10.510.10-FF-003467', NULL, NULL, 272, NULL, NULL, 96460),
(96461, '1.20.140.40-FF-000011', NULL, 'Cell wall / vacuolar inhibitor of fructosidase 2', 153, NULL, NULL, 96461),
(96462, '3.30.160.60-FF-005185', NULL, NULL, 51, NULL, NULL, 96462),
(96463, '2.30.39.10-FF-000091', NULL, 'Phosphotransferase', 93, NULL, NULL, 96463),
(96464, '3.40.1110.10-FF-000364', NULL, NULL, 104, NULL, NULL, 96464),
(96465, '1.10.1410.10-FF-000064', NULL, 'U3 small nucleolar RNA-associated protein 22', 52, NULL, NULL, 96465),
(96466, '1.10.287.440-FF-000001', NULL, 'Bifunctional purine biosynthesis protein PURH', 44, NULL, NULL, 96466),
(96467, '3.90.1150.10-FF-000315', NULL, 'Probable serine--glyoxylate aminotransferase, class V', 108, NULL, NULL, 96467),
(96468, '1.20.5.490-FF-000009', NULL, 'Cell shape-determining protein MreC', 40, NULL, NULL, 96468),
(96469, '1.20.1250.20-FF-000905', NULL, 'Major facilitator superfamily domain containing 12', 429, NULL, NULL, 96469),
(96470, '3.40.190.10-FF-000555', NULL, 'Transcriptional regulator, LysR family', 92, NULL, NULL, 96470),
(96471, '2.60.40.10-FF-000738', NULL, 'Leukemia inhibitory factor receptor', 98, NULL, NULL, 96471),
(96472, '3.30.160.60-FF-006174', NULL, NULL, 65, NULL, NULL, 96472),
(96473, '1.25.10.10-FF-000157', NULL, 'Hsp70-binding protein 1', 273, NULL, NULL, 96473),
(96474, '1.10.10.10-FF-000005', NULL, 'Two-component system response regulator', 102, NULL, NULL, 96474),
(96475, '2.60.40.1940-FF-000001', NULL, 'Complement component C3', 124, NULL, NULL, 96475),
(96476, '1.10.10.60-FF-001015', NULL, NULL, 76, NULL, NULL, 96476),
(96477, '3.90.226.10-FF-000307', NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', 109, NULL, NULL, 96477); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(96478, '3.40.120.10-FF-000022', NULL, 'phosphomannomutase/phosphoglucomutase isoform X1', 158, NULL, NULL, 96478),
(96479, '3.30.465.10-FF-000140', NULL, 'FAD linked oxidase domain protein', 258, NULL, NULL, 96479),
(96480, '3.40.1510.10-FF-000001', NULL, 'Hut operon positive regulatory protein', 145, NULL, NULL, 96480),
(96481, '3.90.70.10-FF-000456', NULL, 'Uncharacterized protein', 141, NULL, NULL, 96481),
(96482, '1.10.2000.10-FF-000044', NULL, NULL, 127, NULL, NULL, 96482),
(96483, '1.10.238.10-FF-000580', NULL, 'Uncharacterized protein', 104, NULL, NULL, 96483),
(96484, '2.60.40.10-FF-002363', NULL, 'Uncharacterized protein, isoform J', 92, NULL, NULL, 96484),
(96485, '3.10.20.90-FF-000727', NULL, 'Protein phosphatase 1 regulatory subunit 13B', 76, NULL, NULL, 96485),
(96486, '3.40.50.720-FF-001455', NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', 23, NULL, NULL, 96486),
(96487, '1.20.5.170-FF-000150', NULL, 'AP-1-like transcription factor YAP7', 74, NULL, NULL, 96487),
(96488, '4.10.860.10-FF-000025', NULL, NULL, 65, NULL, NULL, 96488),
(96489, '1.10.510.10-FF-004456', NULL, NULL, 341, NULL, NULL, 96489),
(96490, '2.60.40.60-FF-000759', NULL, 'Hedgehog protein', 106, NULL, NULL, 96490),
(96491, '3.30.160.60-FF-002312', NULL, 'Zinc finger protein 658', 33, NULL, NULL, 96491),
(96492, '2.10.70.10-FF-000208', NULL, 'Complement regulatory membrane protein', 62, NULL, NULL, 96492),
(96493, '3.30.70.330-FF-000092', NULL, 'Calcipressin-2 isoform 2', 103, NULL, NULL, 96493),
(96494, '1.10.287.110-FF-000133', NULL, 'Gametocyte erythrocyte cytosolic protein', 93, NULL, NULL, 96494),
(96495, '1.10.1870.10-FF-000002', NULL, 'Saccharopine dehydrogenase Lys9', 102, NULL, NULL, 96495),
(96496, '3.30.160.60-FF-001823', NULL, 'Zinc finger protein 322', 29, NULL, NULL, 96496),
(96497, '3.30.160.60-FF-004549', NULL, NULL, 35, NULL, NULL, 96497),
(96498, '2.40.10.10-FF-000367', NULL, NULL, 73, NULL, NULL, 96498),
(96499, '2.60.120.10-FF-000218', NULL, 'AraC family transcriptional regulator', 73, NULL, NULL, 96499),
(96500, '3.80.10.10-FF-004011', NULL, 'Uncharacterized protein', 149, NULL, NULL, 96500),
(96501, '3.40.50.20-FF-000044', NULL, 'Lysine biosynthesis enzyme LysX', 103, NULL, NULL, 96501),
(96502, '2.130.10.130-FF-000033', NULL, NULL, 128, NULL, NULL, 96502),
(96503, '3.10.310.60-FF-000002', NULL, 'Protein OS-9 homolog', 141, NULL, NULL, 96503),
(96504, '4.10.400.10-FF-000092', NULL, 'LDL receptor related protein 4', 40, NULL, NULL, 96504),
(96505, '4.10.60.10-FF-000125', NULL, 'Putative e3 ubiquitin ligase', 28, NULL, NULL, 96505),
(96506, '3.40.50.300-FF-003510', NULL, 'Dynein heavy chain, cytosolic, putative', 51, NULL, NULL, 96506),
(96507, '1.20.5.110-FF-000059', NULL, 'Related to syntaxin 12', 106, NULL, NULL, 96507),
(96508, '3.40.980.10-FF-000036', NULL, 'Molybdenum cofactor biosynthesis protein MoeA', 136, NULL, NULL, 96508),
(96509, '1.20.120.340-FF-000014', NULL, 'Flagellar protein FliS', 126, NULL, NULL, 96509),
(96510, '3.10.129.10-FF-000105', NULL, 'uncharacterized protein LOC101841231 isoform X3', 171, NULL, NULL, 96510),
(96511, '1.25.10.10-FF-001113', NULL, 'RING-type E3 ubiquitin transferase', 136, NULL, NULL, 96511),
(96512, '3.30.40.10-FF-000530', NULL, 'Histone-lysine N-methyltransferase', 43, NULL, NULL, 96512),
(96513, '3.30.870.10-FF-000171', NULL, 'Polyphosphate kinase', 176, NULL, NULL, 96513),
(96514, '3.30.2160.10-FF-000055', NULL, 'Uncharacterized protein', 80, NULL, NULL, 96514),
(96515, '3.80.10.10-FF-001577', NULL, 'Leucine-rich repeat-containing G protein-coupled receptor 4, isoform C', 172, NULL, NULL, 96515),
(96516, '2.10.70.10-FF-000147', NULL, 'Uncharacterized protein, isoform A', 64, NULL, NULL, 96516),
(96517, '1.25.10.10-FF-001938', NULL, 'Telomere repeats-binding bouquet formation protein 1', 357, NULL, NULL, 96517),
(96518, '2.70.130.10-FF-000138', NULL, NULL, 150, NULL, NULL, 96518),
(96519, '3.30.70.330-FF-002862', NULL, NULL, 78, NULL, NULL, 96519),
(96520, '4.10.1000.30-FF-000002', NULL, 'Nuclear polyadenylated RNA-binding protein Nab2', 64, NULL, NULL, 96520); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(96521, '2.130.10.10-FF-000250', NULL, 'Dynein assembly factor with WDR repeat domains 1', 75, NULL, NULL, 96521),
(96522, '2.130.10.10-FF-002487', NULL, 'Histidine kinase/response regulator hybrid protein', 199, NULL, NULL, 96522),
(96523, '1.25.40.180-FF-000031', NULL, 'Eukaryotic translation initiation factor 5', 157, NULL, NULL, 96523),
(96524, '1.20.5.190-FF-000156', NULL, NULL, 65, NULL, NULL, 96524),
(96525, '1.10.287.1150-FF-000018', NULL, 'Oxoglutarate dehydrogenase', 47, NULL, NULL, 96525),
(96526, '2.60.40.790-FF-000107', NULL, 'Prostaglandin E synthase 3', 40, NULL, NULL, 96526),
(96527, '2.130.10.10-FF-002807', NULL, 'Uncharacterized protein', 170, NULL, NULL, 96527),
(96528, '3.30.1450.10-FF-000009', NULL, NULL, 79, NULL, NULL, 96528),
(96529, '3.40.47.10-FF-000308', NULL, 'Polyketide synthase/nonribosomal peptide synthetase hybrid RzxA', 478, NULL, NULL, 96529),
(96530, '1.25.10.10-FF-002866', NULL, 'Uncharacterized protein', 161, NULL, NULL, 96530),
(96531, '3.80.10.10-FF-002066', NULL, 'Uncharacterized protein', 106, NULL, NULL, 96531),
(96532, '1.20.1700.10-FF-000005', NULL, 'Pantothenate kinase', 89, NULL, NULL, 96532),
(96533, '3.40.50.970-FF-000136', NULL, 'Putative inositol polyphosphate phosphatase (Synaptogenin-like) family protein', 79, NULL, NULL, 96533),
(96534, '3.30.519.10-FF-000018', NULL, 'Rab GDP dissociation inhibitor', 171, NULL, NULL, 96534),
(96535, '1.20.58.60-FF-000865', NULL, 'Microtubule-actin crosslinking factor 1', 122, NULL, NULL, 96535),
(96536, '3.40.50.2300-FF-001057', NULL, NULL, 127, NULL, NULL, 96536),
(96537, '3.30.430.20-FF-000034', NULL, 'Putative DUF26-domain protein kinase', 87, NULL, NULL, 96537),
(96538, '2.30.29.30-FF-001321', NULL, 'Uncharacterized protein', 66, NULL, NULL, 96538),
(96539, '3.90.70.10-FF-000809', NULL, 'Uncharacterized protein', 310, NULL, NULL, 96539),
(96540, '2.40.40.20-FF-000085', NULL, 'Uncharacterized protein', 67, NULL, NULL, 96540),
(96541, '3.30.300.30-FF-000090', NULL, 'Acetate-CoA ligase, putative', 144, NULL, NULL, 96541),
(96542, '2.60.120.970-FF-000053', NULL, 'Uncharacterized protein', 228, NULL, NULL, 96542),
(96543, '3.40.109.10-FF-000007', NULL, 'Iodotyrosine deiodinase', 161, NULL, NULL, 96543),
(96544, '1.10.533.10-FF-000310', NULL, 'Uncharacterized protein', 44, NULL, NULL, 96544),
(96545, '1.10.1370.30-FF-000015', NULL, 'Angiotensin-converting enzyme', 231, NULL, NULL, 96545),
(96546, '3.40.50.300-FF-000604', NULL, 'ABC transporter B family member 28', 248, NULL, NULL, 96546),
(96547, '2.120.10.30-FF-000397', NULL, 'Gll1931 protein', 243, NULL, NULL, 96547),
(96548, '1.10.287.740-FF-000001', NULL, 'Photosystem II reaction center protein Z', 62, NULL, NULL, 96548),
(96549, '3.30.70.260-FF-000076', NULL, 'D-3-phosphoglycerate dehydrogenase', 82, NULL, NULL, 96549),
(96550, '1.10.30.10-FF-000040', NULL, 'SRY (sex determining region Y)-box 32', 82, NULL, NULL, 96550),
(96551, '3.30.160.60-FF-002279', NULL, 'Histone H4 transcription factor', 61, NULL, NULL, 96551),
(96552, '2.130.10.10-FF-001970', NULL, 'Eukaryotic translation initiation factor 2A', 226, NULL, NULL, 96552),
(96553, '3.20.180.20-FF-000045', NULL, 'Uncharacterized protein', 62, NULL, NULL, 96553),
(96554, '3.30.70.330-FF-001081', NULL, 'RNA-binding protein Musashi homolog 1', 77, NULL, NULL, 96554),
(96555, '1.10.238.10-FF-001097', NULL, 'Signal transducer and activator of transcription', 66, NULL, NULL, 96555),
(96556, '2.60.120.10-FF-000398', NULL, 'Homogentisate 12-dioxygenase', 115, NULL, NULL, 96556),
(96557, '1.25.40.20-FF-001623', NULL, 'Kinase, NEK', 98, NULL, NULL, 96557),
(96558, '3.30.450.200-FF-000020', NULL, NULL, 136, NULL, NULL, 96558),
(96559, '3.30.1010.10-FF-000134', NULL, 'PIKK family atypical protein kinase', 153, NULL, NULL, 96559),
(96560, '2.30.30.140-FF-000204', NULL, 'Uncharacterized protein R102.4-like Protein', 42, NULL, NULL, 96560),
(96561, '3.10.20.30-FF-000024', NULL, 'Na(+)-translocating NADH-quinone reductase subunit F', 92, NULL, NULL, 96561),
(96562, '1.10.220.150-FF-000027', NULL, 'Gts1p', 132, NULL, NULL, 96562);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(96563, '3.30.70.330-FF-001373', NULL, 'Oligouridylate-binding protein 1 isoform A', 128, NULL, NULL, 96563),
(96564, '1.20.58.1120-FF-000034', NULL, 'Dynein_heavy_chain_-_N-terminal_region_2_-_putative', 145, NULL, NULL, 96564),
(96565, '3.30.70.3490-FF-000023', NULL, 'Unplaced genomic scaffold supercont1.170, whole genome shotgun sequence', 113, NULL, NULL, 96565),
(96566, '1.25.40.10-FF-004167', NULL, 'Os01g0299150 protein', 101, NULL, NULL, 96566),
(96567, '1.10.472.10-FF-000668', NULL, 'Uncharacterized protein', 74, NULL, NULL, 96567),
(96568, '2.60.120.560-FF-000020', NULL, 'N-acetyl-galactosamine-6-sulfatase (GALNS)', 202, NULL, NULL, 96568),
(96569, '1.25.10.10-FF-001585', NULL, 'Uncharacterized protein', 112, NULL, NULL, 96569),
(96570, '1.10.510.10-FF-001230', NULL, 'Spindle assembly checkpoint kinase', 179, NULL, NULL, 96570),
(96571, '3.90.1480.20-FF-000045', NULL, 'Uncharacterized protein', 241, NULL, NULL, 96571),
(96572, '2.120.10.30-FF-000217', NULL, 'Os10g0543500 protein', 256, NULL, NULL, 96572),
(96573, '3.40.50.12780-FF-000013', NULL, 'Long-chain-fatty-acid--AMP ligase FadD32', 463, NULL, NULL, 96573),
(96574, '3.30.420.40-FF-000394', NULL, 'Heat shock protein 70 putative', 41, NULL, NULL, 96574),
(96575, '3.40.50.300-FF-006383', NULL, 'ATP-dependent DNA helicase', 136, NULL, NULL, 96575),
(96576, '1.25.10.20-FF-000014', NULL, 'Hemelipoglyco-carrier protein', 189, NULL, NULL, 96576),
(96577, '2.60.40.1730-FF-000056', NULL, 'Aminopeptidase', 217, NULL, NULL, 96577),
(96578, '1.25.40.540-FF-000010', NULL, 'Uncharacterized protein', 197, NULL, NULL, 96578),
(96579, '2.40.33.20-FF-000001', NULL, '6-N-hydroxylaminopurine resistance protein', 224, NULL, NULL, 96579),
(96580, '3.90.550.50-FF-000038', NULL, 'Predicted protein', 258, NULL, NULL, 96580),
(96581, '2.130.10.10-FF-005713', NULL, 'Uncharacterized protein', 142, NULL, NULL, 96581),
(96582, '3.40.50.10860-FF-000049', NULL, 'Bifunctional protein FolD 3, chloroplastic', 88, NULL, NULL, 96582),
(96583, '3.40.50.720-FF-002383', NULL, 'Uncharacterized protein', 151, NULL, NULL, 96583),
(96584, '2.10.110.10-FF-000066', NULL, 'Four and a half LIM domains protein', 60, NULL, NULL, 96584),
(96585, '4.10.240.10-FF-000085', NULL, 'Zinc cluster transcription factor CZF1', 65, NULL, NULL, 96585),
(96586, '1.10.150.290-FF-000002', NULL, 'Trans-aconitate 2-methyltransferase', 70, NULL, NULL, 96586),
(96587, '3.30.9.10-FF-000058', NULL, 'Chromosome 19, whole genome shotgun sequence', 144, NULL, NULL, 96587),
(96588, '1.10.510.10-FF-002950', NULL, NULL, 214, NULL, NULL, 96588),
(96589, '3.80.10.10-FF-003055', NULL, 'Uncharacterized protein', 149, NULL, NULL, 96589),
(96590, '2.180.10.10-FF-000017', NULL, 'Wall-associated protein', 253, NULL, NULL, 96590),
(96591, '3.10.20.90-FF-000699', NULL, 'Ubiquitin specific peptidase 32', 53, NULL, NULL, 96591),
(96592, '1.20.1270.50-FF-000011', NULL, 'Uncharacterized protein', 80, NULL, NULL, 96592),
(96593, '2.170.300.10-FF-000077', NULL, 'Platelet endothelial aggregation receptor 1', 112, NULL, NULL, 96593),
(96594, '3.40.50.300-FF-002049', NULL, 'Si:ch73-170d6.2', 255, NULL, NULL, 96594),
(96595, '1.25.40.20-FF-000134', NULL, 'inversin isoform X1', 57, NULL, NULL, 96595),
(96596, '2.30.30.40-FF-000467', NULL, 'SH3 domain-containing YSC84-like protein 1', 73, NULL, NULL, 96596),
(96597, '2.130.10.10-FF-005421', NULL, 'Endoplasmic reticulum to nucleus signaling 1', 169, NULL, NULL, 96597),
(96598, '1.10.3290.10-FF-000003', NULL, 'Protein adenylyltransferase fic-1', 241, NULL, NULL, 96598),
(96599, '3.40.50.720-FF-002411', NULL, 'Uncharacterized protein', 178, NULL, NULL, 96599),
(96600, '3.30.200.20-FF-000697', NULL, 'Mitogen-activated protein kinase', 86, NULL, NULL, 96600),
(96601, '2.130.10.10-FF-003476', NULL, 'Uncharacterized protein', 315, NULL, NULL, 96601),
(96602, '3.30.230.10-FF-000196', NULL, 'Uncharacterized protein', 179, NULL, NULL, 96602),
(96603, '1.25.10.10-FF-000096', NULL, 'eIF-2-alpha kinase activator gcn1', 318, NULL, NULL, 96603),
(96604, '2.60.40.10-FF-005589', NULL, NULL, 112, NULL, NULL, 96604);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(96605, '3.30.160.60-FF-000042', NULL, 'Zinc finger protein 148', 27, NULL, NULL, 96605),
(96606, '2.60.40.60-FF-000028', NULL, 'Protocadherin 1', 121, NULL, NULL, 96606),
(96607, '3.90.1410.10-FF-000061', NULL, 'Predicted protein', 267, NULL, NULL, 96607),
(96608, '3.80.10.10-FF-000649', NULL, 'Leucine Rich Repeat family protein', 123, NULL, NULL, 96608),
(96609, '3.90.1150.10-FF-000023', NULL, 'Tryptophanase', 193, NULL, NULL, 96609),
(96610, '3.20.20.140-FF-000066', NULL, 'Adenosine deaminase', 360, NULL, NULL, 96610),
(96611, '3.30.40.10-FF-002328', NULL, 'LON peptidase N-terminal domain and RING finger protein C14F5.10c', 97, NULL, NULL, 96611),
(96612, '2.10.220.10-FF-000187', NULL, 'Predicted protein', 64, NULL, NULL, 96612),
(96613, '2.60.120.380-FF-000090', NULL, 'Predicted protein', 59, NULL, NULL, 96613),
(96614, '3.40.50.300-FF-004819', NULL, 'Uncharacterized protein', 200, NULL, NULL, 96614),
(96615, '3.10.330.10-FF-000011', NULL, 'Peroxisome biogenesis protein peroxin 1', 94, NULL, NULL, 96615),
(96616, '3.60.10.10-FF-000431', NULL, 'Proteasome subunit beta type-6-like Protein', 67, NULL, NULL, 96616),
(96617, '3.30.70.60-FF-000001', NULL, 'Elongation factor 1-beta 1 like', 92, NULL, NULL, 96617),
(96618, '1.20.1250.20-FF-000052', NULL, 'Protein TsgA', 190, NULL, NULL, 96618),
(96619, '3.90.550.50-FF-000185', NULL, 'Hexosyltransferase', 216, NULL, NULL, 96619),
(96620, '1.10.274.100-FF-000031', NULL, 'DNA-directed RNA polymerase subunit', 156, NULL, NULL, 96620),
(96621, '3.20.20.190-FF-000120', NULL, NULL, 89, NULL, NULL, 96621),
(96622, '3.40.50.1820-FF-000935', NULL, 'Putative lipase (Putative secreted protein)', 344, NULL, NULL, 96622),
(96623, '1.20.120.1240-FF-000027', NULL, 'Uncharacterized protein', 121, NULL, NULL, 96623),
(96624, '3.40.190.10-FF-000908', NULL, 'ABC transporter permease fused to pyrimidine biosynthesis enzyme', 102, NULL, NULL, 96624),
(96625, '1.20.1250.20-FF-002030', NULL, 'Solute carrier organic anion transporter family member', 345, NULL, NULL, 96625),
(96626, '3.40.50.1000-FF-000869', NULL, NULL, 11, NULL, NULL, 96626),
(96627, '2.60.40.10-FF-006106', NULL, NULL, 91, NULL, NULL, 96627),
(96628, '3.30.1640.10-FF-000052', NULL, 'DNA helicase', 116, NULL, NULL, 96628),
(96629, '3.30.70.80-FF-000007', NULL, 'Organelle RRM domain-containing protein 1, chloroplastic', 90, NULL, NULL, 96629),
(96630, '3.40.50.1440-FF-000153', NULL, 'Putative nucleolar protein 5-1', 56, NULL, NULL, 96630),
(96631, '3.30.40.10-FF-002036', NULL, 'Uncharacterized protein', 98, NULL, NULL, 96631),
(96632, '3.30.160.60-FF-002812', NULL, 'Neuroectoderm-expressed 2, isoform B', 37, NULL, NULL, 96632),
(96633, '2.160.10.10-FF-000119', NULL, 'Eukaryotic Initiation Factor', 143, NULL, NULL, 96633),
(96634, '2.70.98.10-FF-000045', NULL, 'Putative aldose 1-epimerase', 357, NULL, NULL, 96634),
(96635, '2.130.10.10-FF-002015', NULL, 'Transducin family protein / WD-40 repeat family protein', 105, NULL, NULL, 96635),
(96636, '2.130.10.10-FF-001559', NULL, 'Uncharacterized protein', 387, NULL, NULL, 96636),
(96637, '2.40.100.10-FF-000025', NULL, 'Peptidyl-prolyl cis-trans isomerase CYP19-2', 173, NULL, NULL, 96637),
(96638, '1.20.1280.50-FF-000129', NULL, 'AGAP008941-PA', 101, NULL, NULL, 96638),
(96639, '3.30.70.330-FF-001934', NULL, NULL, 141, NULL, NULL, 96639),
(96640, '1.20.1540.10-FF-000003', NULL, 'Rhomboid protease GlpG', 181, NULL, NULL, 96640),
(96641, '2.10.25.10-FF-001801', NULL, 'Uncharacterized protein', 26, NULL, NULL, 96641),
(96642, '2.20.80.10-FF-000012', NULL, 'Uncharacterized protein VTG4', 246, NULL, NULL, 96642),
(96643, '2.60.120.260-FF-000492', NULL, 'Uncharacterized protein', 110, NULL, NULL, 96643),
(96644, '2.60.220.50-FF-000007', NULL, 'Adhesion G protein-coupled receptor E5', 197, NULL, NULL, 96644),
(96645, '3.40.50.1820-FF-001132', NULL, 'Uncharacterized protein', 88, NULL, NULL, 96645),
(96646, '4.10.60.10-FF-000097', NULL, 'Universal minicircle sequence binding protein', 24, NULL, NULL, 96646),
(96647, '2.40.128.630-FF-000005', NULL, 'Cell surface protein', 104, NULL, NULL, 96647);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(96648, '3.40.250.10-FF-000234', NULL, 'Thiosulfate sulfurtransferase', 124, NULL, NULL, 96648),
(96649, '3.30.565.10-FF-000057', NULL, 'Sensor histidine kinase', 157, NULL, NULL, 96649),
(96650, '2.60.40.10-FF-004128', NULL, NULL, 116, NULL, NULL, 96650),
(96651, '1.20.1070.10-FF-001586', NULL, 'Relaxin family peptide receptor 2,-like', 156, NULL, NULL, 96651),
(96652, '1.20.58.80-FF-000079', NULL, 'Uncharacterized protein', 146, NULL, NULL, 96652),
(96653, '3.30.160.60-FF-006466', NULL, NULL, 54, NULL, NULL, 96653),
(96654, '3.10.50.40-FF-000034', NULL, 'Peptidylprolyl isomerase', 169, NULL, NULL, 96654),
(96655, '1.10.1370.10-FF-000037', NULL, 'Metallopeptidase MepB', 288, NULL, NULL, 96655),
(96656, '2.60.40.1180-FF-000138', NULL, 'Isoamylase 2, chloroplastic', 124, NULL, NULL, 96656),
(96657, '3.40.190.10-FF-000263', NULL, 'ABC transporter substrate-binding protein', 103, NULL, NULL, 96657),
(96658, '2.60.200.20-FF-000048', NULL, 'Zeaxanthin epoxidase, chloroplastic', 113, NULL, NULL, 96658),
(96659, '3.40.50.1820-FF-000643', NULL, 'Protein phosphatase methylesterase 1', 286, NULL, NULL, 96659),
(96660, '3.30.200.20-FF-001978', NULL, 'Uncharacterized protein', 101, NULL, NULL, 96660),
(96661, '2.30.30.360-FF-000006', NULL, 'Non-muscle MYosin', 52, NULL, NULL, 96661),
(96662, '3.50.50.60-FF-000600', NULL, 'Probable oxidoreductase', 132, NULL, NULL, 96662),
(96663, '3.80.10.10-FF-002858', NULL, 'AGAP009688-PA', 112, NULL, NULL, 96663),
(96664, '3.30.450.40-FF-000075', NULL, 'Bifunctional diguanylate cyclase/phosphodiesterase', 168, NULL, NULL, 96664),
(96665, '1.20.5.620-FF-000004', NULL, 'V-type proton ATPase subunit G', 60, NULL, NULL, 96665),
(96666, '1.10.10.440-FF-000012', NULL, 'pre-mRNA-processing factor 40 homolog A isoform X2', 71, NULL, NULL, 96666),
(96667, '3.60.110.10-FF-000034', NULL, 'Putative hydrolase NIT3', 285, NULL, NULL, 96667),
(96668, '1.20.1250.20-FF-000613', NULL, 'AmpG protein', 402, NULL, NULL, 96668),
(96669, '3.40.50.300-FF-004258', NULL, 'Uncharacterized protein', 237, NULL, NULL, 96669),
(96670, '3.30.1050.10-FF-000052', NULL, 'Uncharacterized protein', 106, NULL, NULL, 96670),
(96671, '2.130.10.10-FF-003768', NULL, 'Uncharacterized protein', 318, NULL, NULL, 96671),
(96672, '3.30.70.1180-FF-000004', NULL, 'V-type proton ATPase subunit C', 73, NULL, NULL, 96672),
(96673, '3.40.50.2000-FF-000068', NULL, 'UDP-N-acetylglucosamine 2-epimerase', 170, NULL, NULL, 96673),
(96674, '1.10.565.10-FF-000120', NULL, 'Nuclear receptor subfamily 5, group A, member 1a', 249, NULL, NULL, 96674),
(96675, '3.80.10.10-FF-000621', NULL, 'Si:dkeyp-4c4.2', 94, NULL, NULL, 96675),
(96676, '3.40.50.12160-FF-000035', NULL, 'Threonylcarbamoyladenosine tRNA methylthiotransferase MtaB', 121, NULL, NULL, 96676),
(96677, '3.30.160.60-FF-004257', NULL, NULL, 27, NULL, NULL, 96677),
(96678, '2.60.40.2030-FF-000051', NULL, 'Calx-beta domain containing protein', 141, NULL, NULL, 96678),
(96679, '1.20.1070.10-FF-001147', NULL, 'Putative G-protein coupled receptor 135', 374, NULL, NULL, 96679),
(96680, '1.20.1070.10-FF-000658', NULL, 'Olfactory receptor', 221, NULL, NULL, 96680),
(96681, '1.25.10.10-FF-002074', NULL, 'RING-type E3 ubiquitin transferase', 191, NULL, NULL, 96681),
(96682, '3.40.50.1820-FF-001571', NULL, 'Uncharacterized protein', 110, NULL, NULL, 96682),
(96683, '3.50.7.10-FF-000043', NULL, NULL, 125, NULL, NULL, 96683),
(96684, '3.30.160.60-FF-000334', NULL, 'E3 ubiquitin-protein ligase Midline-1', 77, NULL, NULL, 96684),
(96685, '3.40.50.150-FF-000250', NULL, 'Ubiquinone/menaquinone biosynthesis C-methyltransferase UbiE', 226, NULL, NULL, 96685),
(96686, '3.40.50.150-FF-001026', NULL, NULL, 179, NULL, NULL, 96686),
(96687, '3.90.640.10-FF-000112', NULL, 'Actin, putative', 110, NULL, NULL, 96687),
(96688, '3.30.160.60-FF-005977', NULL, NULL, 61, NULL, NULL, 96688),
(96689, '3.50.50.60-FF-000067', NULL, 'spermine oxidase isoform X2', 128, NULL, NULL, 96689),
(96690, '3.40.50.300-FF-002021', NULL, 'RHOD isoform 2', 30, NULL, NULL, 96690),
(96691, '3.40.1160.10-FF-000075', NULL, 'Isopentenyl phosphate kinase', 244, NULL, NULL, 96691);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(96692, '1.25.40.10-FF-000777', NULL, 'pentatricopeptide repeat-containing protein At5g39980, chloroplastic', 74, NULL, NULL, 96692),
(96693, '3.90.1750.10-FF-000052', NULL, 'Zn-finger_in_Ran_binding_protein_and_others/SPRY_domain/HECT-domain_(Ubiquitin-transferase)', 174, NULL, NULL, 96693),
(96694, '1.10.8.270-FF-000143', NULL, 'Predicted protein', 45, NULL, NULL, 96694),
(96695, '2.60.40.10-FF-000385', NULL, 'Neuroplastin a', 90, NULL, NULL, 96695),
(96696, '3.40.50.300-FF-007664', NULL, 'ATP binding cassette subfamily A member 8', 123, NULL, NULL, 96696),
(96697, '1.10.1450.10-FF-000010', NULL, 'Tetraspanin', 95, NULL, NULL, 96697),
(96698, '3.90.70.10-FF-000164', NULL, 'Cysteine protease Mir1', 329, NULL, NULL, 96698),
(96699, '3.40.50.720-FF-001747', NULL, 'quinone oxidoreductase', 168, NULL, NULL, 96699),
(96700, '3.20.20.70-FF-000108', NULL, 'IMP dehydrogenase family protein', 473, NULL, NULL, 96700),
(96701, '3.90.180.10-FF-000032', NULL, 'Probable polyketide synthase pks1', 326, NULL, NULL, 96701),
(96702, '3.40.50.1440-FF-000006', NULL, 'Tubulin beta chain', 263, NULL, NULL, 96702),
(96703, '1.10.1450.10-FF-000038', NULL, 'Tetraspanin', 118, NULL, NULL, 96703),
(96704, '3.20.20.20-FF-000026', NULL, 'Dihydropteroate synthase', 278, NULL, NULL, 96704),
(96705, '3.40.50.12780-FF-000193', NULL, 'AMP dependent CoA ligase, putative', 113, NULL, NULL, 96705),
(96706, '1.25.40.180-FF-000323', NULL, NULL, 47, NULL, NULL, 96706),
(96707, '1.10.510.10-FF-002539', NULL, 'Kinase-like domain-containing protein', 303, NULL, NULL, 96707),
(96708, '3.40.140.10-FF-000113', NULL, 'Putative deaminase', 201, NULL, NULL, 96708),
(96709, '3.40.190.10-FF-000116', NULL, 'Phosphate-binding protein PstS', 137, NULL, NULL, 96709),
(96710, '2.60.40.150-FF-000562', NULL, 'Sperm vesicle fusion protein fer-1', 139, NULL, NULL, 96710),
(96711, '1.10.565.10-FF-000148', NULL, 'Nuclear hormone receptor family member nhr-23', 246, NULL, NULL, 96711),
(96712, '2.70.98.30-FF-000023', NULL, 'Alpha-mannosidase', 284, NULL, NULL, 96712),
(96713, '1.20.1560.10-FF-000858', NULL, 'Uncharacterized protein', 229, NULL, NULL, 96713),
(96714, '2.10.25.10-FF-001268', NULL, 'Drosophila CRumBs homolog', 63, NULL, NULL, 96714),
(96715, '3.40.850.10-FF-000263', NULL, 'Kinesin-like protein', 352, NULL, NULL, 96715),
(96716, '1.20.1280.50-FF-000276', NULL, 'Mitogen-activated protein kinase kinase kinase A', 86, NULL, NULL, 96716),
(96717, '1.10.510.10-FF-002511', NULL, NULL, 148, NULL, NULL, 96717),
(96718, '2.40.170.20-FF-000009', NULL, 'Fe(3+) dicitrate transport protein FecA', 519, NULL, NULL, 96718),
(96719, '3.80.10.10-FF-003494', NULL, 'Uncharacterized protein', 196, NULL, NULL, 96719),
(96720, '2.60.220.30-FF-000029', NULL, 'Uncharacterized protein', 176, NULL, NULL, 96720),
(96721, '2.60.40.10-FF-003791', NULL, NULL, 97, NULL, NULL, 96721),
(96722, '3.40.50.12350-FF-000002', NULL, 'Eyes absent homolog', 271, NULL, NULL, 96722),
(96723, '3.30.2350.20-FF-000067', NULL, NULL, 212, NULL, NULL, 96723),
(96724, '3.10.129.10-FF-000077', NULL, 'Thioesterase-like family protein', 126, NULL, NULL, 96724),
(96725, '3.30.505.10-FF-000256', NULL, NULL, 107, NULL, NULL, 96725),
(96726, '1.20.1560.10-FF-000033', NULL, 'ABC transporter B family member 19', 23, NULL, NULL, 96726),
(96727, '3.40.1110.10-FF-000072', NULL, 'Phospholipid-transporting ATPase', 208, NULL, NULL, 96727),
(96728, '1.50.10.130-FF-000011', NULL, 'Terpene synthase26', 196, NULL, NULL, 96728),
(96729, '3.40.50.300-FF-000076', NULL, 'Replicative DNA helicase', 284, NULL, NULL, 96729),
(96730, '2.30.180.10-FF-000150', NULL, NULL, 168, NULL, NULL, 96730),
(96731, '3.30.200.20-FF-002203', NULL, 'Uncharacterized protein', 48, NULL, NULL, 96731),
(96732, '3.30.200.20-FF-000517', NULL, 'probable LRR receptor-like serine/threonine-protein kinase At1g34110', 104, NULL, NULL, 96732),
(96733, '2.10.25.10-FF-001240', NULL, 'Uncharacterized protein', 40, NULL, NULL, 96733),
(96734, '3.30.160.60-FF-001795', NULL, 'Uncharacterized protein', 28, NULL, NULL, 96734),
(96735, '1.25.40.20-FF-001062', NULL, 'Predicted protein', 268, NULL, NULL, 96735);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(96736, '2.160.20.10-FF-000064', NULL, 'Cell wall surface anchor family protein', 361, NULL, NULL, 96736),
(96737, '2.60.40.60-FF-000467', NULL, 'protocadherin-11 X-linked', 105, NULL, NULL, 96737),
(96738, '3.30.230.10-FF-000016', NULL, 'Ribonuclease P protein component', 119, NULL, NULL, 96738),
(96739, '1.10.730.10-FF-000105', NULL, 'Isoleucyl-tRNA synthetase', 214, NULL, NULL, 96739),
(96740, '2.40.50.140-FF-000307', NULL, 'Eukaryotic translation initiation factor 5A', 76, NULL, NULL, 96740),
(96741, '1.25.40.10-FF-002722', NULL, 'Uncharacterized protein', 411, NULL, NULL, 96741),
(96742, '1.20.5.1190-FF-000009', NULL, 'Sodium channel protein', 34, NULL, NULL, 96742),
(96743, '1.20.58.80-FF-000051', NULL, 'AAA family ATPase, p60 katanin', 83, NULL, NULL, 96743),
(96744, '1.10.220.10-FF-000022', NULL, 'Annexin A5', 72, NULL, NULL, 96744),
(96745, '1.25.40.10-FF-003211', NULL, 'Transcription factor TFIIIC subunit', 78, NULL, NULL, 96745),
(96746, '3.20.20.80-FF-000729', NULL, 'Uncharacterized protein', 97, NULL, NULL, 96746),
(96747, '3.40.1190.20-FF-000113', NULL, 'ADP-dependent (S)-NAD(P)H-hydrate dehydratase', 280, NULL, NULL, 96747),
(96748, '3.30.70.980-FF-000027', NULL, 'AGAP001629-PA', 72, NULL, NULL, 96748),
(96749, '2.40.50.140-FF-000015', NULL, 'Eukaryotic translation initiation factor 2 subunit alpha', 88, NULL, NULL, 96749),
(96750, '3.40.50.1580-FF-000054', NULL, 'S-methyl-5''-thioadenosine phosphorylase', 274, NULL, NULL, 96750),
(96751, '3.40.1280.10-FF-000022', NULL, 'Trm3p', 164, NULL, NULL, 96751),
(96752, '3.30.200.20-FF-001006', NULL, 'Leucine-rich repeat receptor-like protein kinase TDR', 86, NULL, NULL, 96752),
(96753, '3.30.420.270-FF-000035', NULL, 'Probable Biopolymer transport exbD protein', 69, NULL, NULL, 96753),
(96754, '3.40.50.300-FF-008153', NULL, 'Uncharacterized protein', 93, NULL, NULL, 96754),
(96755, '3.40.50.1000-FF-000369', NULL, '5''-nucleotidase', 192, NULL, NULL, 96755),
(96756, '1.10.60.10-FF-000008', NULL, 'Diphtheria toxin repressor', 61, NULL, NULL, 96756),
(96757, '3.30.200.20-FF-001478', NULL, NULL, 13, NULL, NULL, 96757),
(96758, '3.90.1150.10-FF-000254', NULL, 'Neamine transaminase NeoN', 79, NULL, NULL, 96758),
(96759, '3.40.50.300-FF-008209', NULL, '26S protease regulatory subunit, putative', 71, NULL, NULL, 96759),
(96760, '3.30.390.50-FF-000022', NULL, 'Uncharacterized protein', 117, NULL, NULL, 96760),
(96761, '1.10.10.10-FF-000977', NULL, 'Transcriptional regulator, IclR family', 76, NULL, NULL, 96761),
(96762, '3.30.450.20-FF-000209', NULL, 'DNA-binding protein', 112, NULL, NULL, 96762),
(96763, '3.40.50.1820-FF-000082', NULL, 'monoacylglycerol lipase ABHD6', 296, NULL, NULL, 96763),
(96764, '1.50.40.10-FF-000393', NULL, 'Uncharacterized protein', 142, NULL, NULL, 96764),
(96765, '2.160.10.10-FF-000058', NULL, 'Transferase, hexapeptide repeat family', 181, NULL, NULL, 96765),
(96766, '3.30.60.30-FF-000132', NULL, 'Agrin, putative', 50, NULL, NULL, 96766),
(96767, '2.60.40.10-FF-001402', NULL, 'Matrix remodeling associated 5', 100, NULL, NULL, 96767),
(96768, '3.30.160.60-FF-006202', NULL, NULL, 40, NULL, NULL, 96768),
(96769, '3.40.50.920-FF-000054', NULL, 'Branched chain keto acid dehydrogenase E1 subunit beta', 77, NULL, NULL, 96769),
(96770, '3.10.290.60-FF-000005', NULL, 'Ubiquitin-like modifier-activating enzyme 7', 100, NULL, NULL, 96770),
(96771, '2.120.10.80-FF-000390', NULL, 'Uncharacterized protein', 209, NULL, NULL, 96771),
(96772, '1.25.40.840-FF-000010', NULL, 'Uncharacterized protein', 91, NULL, NULL, 96772),
(96773, '2.60.40.150-FF-000793', NULL, 'Uncharacterized protein', 76, NULL, NULL, 96773),
(96774, '1.25.10.10-FF-000657', NULL, 'RPTOR independent companion of MTOR complex 2', 255, NULL, NULL, 96774),
(96775, '2.60.40.640-FF-000113', NULL, 'Uncharacterized protein', 63, NULL, NULL, 96775),
(96776, '3.40.50.1110-FF-000110', NULL, 'Phospholipase B1, membrane-associated-like Protein', 306, NULL, NULL, 96776),
(96777, '3.40.50.410-FF-000345', NULL, 'Integrin beta', 116, NULL, NULL, 96777),
(96778, '3.40.50.300-FF-004466', NULL, 'Adenylate isopentenyltransferase 5, chloroplastic', 168, NULL, NULL, 96778); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(96779, '2.130.10.10-FF-003976', NULL, 'Uncharacterized protein', 236, NULL, NULL, 96779),
(96780, '1.20.1250.20-FF-000405', NULL, 'Solute carrier family 46 member 3', 387, NULL, NULL, 96780),
(96781, '1.10.510.10-FF-000741', NULL, 'Uncharacterized protein, isoform A', 232, NULL, NULL, 96781),
(96782, '2.60.40.10-FF-004572', NULL, NULL, 99, NULL, NULL, 96782),
(96783, '3.30.720.170-FF-000005', NULL, 'Perilipin', 57, NULL, NULL, 96783),
(96784, '1.10.510.10-FF-002450', NULL, NULL, 134, NULL, NULL, 96784),
(96785, '3.40.50.300-FF-001240', NULL, 'DNA helicase', 178, NULL, NULL, 96785),
(96786, '2.20.28.10-FF-000032', NULL, 'Acyl-CoA dehydrogenase', 54, NULL, NULL, 96786),
(96787, '3.30.70.330-FF-000153', NULL, 'U1 small nuclear ribonucleoprotein 70 kDa', 126, NULL, NULL, 96787),
(96788, '3.30.160.60-FF-004488', NULL, NULL, 24, NULL, NULL, 96788),
(96789, '3.40.50.150-FF-000750', NULL, 'Hypothetical_protein_-_conserved', 215, NULL, NULL, 96789),
(96790, '2.70.20.60-FF-000004', NULL, 'Matrix protein', 166, NULL, NULL, 96790),
(96791, '2.60.40.3510-FF-000005', NULL, 'Delta-like 3 (Drosophila), isoform CRA_b', 152, NULL, NULL, 96791),
(96792, '3.10.25.10-FF-000006', NULL, 'Methionyl-tRNA formyltransferase', 105, NULL, NULL, 96792),
(96793, '3.30.40.10-FF-001811', NULL, 'Uncharacterized protein', 64, NULL, NULL, 96793),
(96794, '2.60.120.290-FF-000208', NULL, 'Uncharacterized protein', 121, NULL, NULL, 96794),
(96795, '2.60.40.1730-FF-000117', NULL, NULL, 79, NULL, NULL, 96795),
(96796, '3.30.70.330-FF-001581', NULL, NULL, 105, NULL, NULL, 96796),
(96797, '2.30.30.30-FF-000110', NULL, '50S ribosomal protein L24', 110, NULL, NULL, 96797),
(96798, '1.20.1250.20-FF-001833', NULL, 'Uncharacterized protein', 143, NULL, NULL, 96798),
(96799, '2.130.10.10-FF-005685', NULL, 'Uncharacterized protein', 158, NULL, NULL, 96799),
(96800, '3.40.50.720-FF-001955', NULL, 'Fat body protein 2-like Protein', 260, NULL, NULL, 96800),
(96801, '2.130.10.10-FF-000750', NULL, 'Microtubule associated katanin, putative', 293, NULL, NULL, 96801),
(96802, '3.20.20.80-FF-000229', NULL, 'Lysozyme', 187, NULL, NULL, 96802),
(96803, '1.20.1270.280-FF-000014', NULL, 'Dynein heavy chain, putative', 134, NULL, NULL, 96803),
(96804, '3.90.550.10-FF-000493', NULL, 'procollagen galactosyltransferase 2', 97, NULL, NULL, 96804),
(96805, '2.60.200.20-FF-000256', NULL, 'Transcription factor P14E8.02', 90, NULL, NULL, 96805),
(96806, '1.25.40.10-FF-000013', NULL, 'UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase 110 kDa subunit', 111, NULL, NULL, 96806),
(96807, '2.70.150.10-FF-000229', NULL, 'Protein CBG19651', 42, NULL, NULL, 96807),
(96808, '2.30.30.140-FF-000176', NULL, 'Protein CBG17113', 92, NULL, NULL, 96808),
(96809, '3.30.530.20-FF-000098', NULL, 'Coenzyme Q-binding protein COQ10 B, mitochondrial', 148, NULL, NULL, 96809),
(96810, '1.20.1070.10-FF-002075', NULL, 'Uncharacterized protein', 62, NULL, NULL, 96810),
(96811, '1.25.40.90-FF-000082', NULL, 'ENTH/VHS family protein', 86, NULL, NULL, 96811),
(96812, '2.30.29.30-FF-000101', NULL, 'Rho GTPase activating protein 21', 119, NULL, NULL, 96812),
(96813, '3.40.50.720-FF-000174', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 327, NULL, NULL, 96813),
(96814, '2.130.10.10-FF-003504', NULL, 'F-box and WD domain protein (AFU_orthologue AFUA_6G11400)', 245, NULL, NULL, 96814),
(96815, '2.60.40.420-FF-000278', NULL, 'Uncharacterized protein', 203, NULL, NULL, 96815),
(96816, '3.90.1310.10-FF-000025', NULL, 'Cell division protein', 194, NULL, NULL, 96816),
(96817, '1.20.1250.20-FF-000877', NULL, 'Sugar (Glycoside-Pentoside-Hexuronide) transporter', 207, NULL, NULL, 96817),
(96818, '3.50.50.60-FF-000628', NULL, 'FAD-dependent pyridine nucleotide-disulphide oxidoreductase', 180, NULL, NULL, 96818),
(96819, '2.40.420.20-FF-000018', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 91, NULL, NULL, 96819),
(96820, '3.90.105.20-FF-000018', NULL, 'Uncharacterized protein', 41, NULL, NULL, 96820),
(96821, '1.10.10.2830-FF-000004', NULL, 'ParB-like protein', 131, NULL, NULL, 96821);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(96822, '3.30.830.10-FF-000045', NULL, 'M16 family peptidase', 231, NULL, NULL, 96822),
(96823, '1.10.10.60-FF-000031', NULL, 'Homeobox protein', 74, NULL, NULL, 96823),
(96824, '1.25.40.10-FF-004228', NULL, 'Uncharacterized protein', 260, NULL, NULL, 96824),
(96825, '2.40.70.10-FF-000084', NULL, 'Uncharacterized protein', 140, NULL, NULL, 96825),
(96826, '2.130.10.10-FF-001470', NULL, 'Protein CBR-CHE-2', 140, NULL, NULL, 96826),
(96827, '2.60.40.10-FF-000885', NULL, 'Putative GTP-binding protein EsdC', 96, NULL, NULL, 96827),
(96828, '3.40.50.2300-FF-000568', NULL, 'Guanylate cyclase', 234, NULL, NULL, 96828),
(96829, '3.20.20.190-FF-000148', NULL, NULL, 42, NULL, NULL, 96829),
(96830, '2.10.25.10-FF-000020', NULL, 'Latent-transforming growth factor beta-binding protein 1', 90, NULL, NULL, 96830),
(96831, '3.30.40.10-FF-000030', NULL, 'Protein Jade-1 isoform 1', 118, NULL, NULL, 96831),
(96832, '3.30.40.10-FF-000119', NULL, 'E3 ubiquitin-protein ligase MARCH2', 72, NULL, NULL, 96832),
(96833, '2.60.120.830-FF-000005', NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 17', 83, NULL, NULL, 96833),
(96834, '2.60.40.2700-FF-000004', NULL, 'Stomatal closure actin-binding-like protein', 98, NULL, NULL, 96834),
(96835, '2.40.70.10-FF-000404', NULL, NULL, 235, NULL, NULL, 96835),
(96836, '3.10.450.50-FF-000094', NULL, 'Uncharacterized protein', 116, NULL, NULL, 96836),
(96837, '3.80.10.10-FF-002274', NULL, 'Leucine-rich repeat-containing protein ODA7', 93, NULL, NULL, 96837),
(96838, '3.40.50.300-FF-003038', NULL, 'RAB10, member RAS oncogene family', 114, NULL, NULL, 96838),
(96839, '2.40.50.140-FF-000279', NULL, 'rRNA biogenesis protein rrp5', 120, NULL, NULL, 96839),
(96840, '1.20.1720.10-FF-000040', NULL, 'Multidrug resistance protein D', 376, NULL, NULL, 96840),
(96841, '2.40.30.130-FF-000002', NULL, 'alanine--tRNA ligase, cytoplasmic', 81, NULL, NULL, 96841),
(96842, '3.30.505.50-FF-000009', NULL, 'Uncharacterized protein', 45, NULL, NULL, 96842),
(96843, '3.40.80.10-FF-000043', NULL, 'Uncharacterized protein', 165, NULL, NULL, 96843),
(96844, '3.40.50.1000-FF-000577', NULL, NULL, 129, NULL, NULL, 96844),
(96845, '1.20.85.10-FF-000014', NULL, 'Uncharacterized protein', 74, NULL, NULL, 96845),
(96846, '2.20.110.10-FF-000013', NULL, 'Putative Junctophilin-1', 58, NULL, NULL, 96846),
(96847, '3.30.497.10-FF-000039', NULL, 'Innexin', 224, NULL, NULL, 96847),
(96848, '3.40.50.1010-FF-000226', NULL, NULL, 89, NULL, NULL, 96848),
(96849, '3.40.50.1000-FF-000105', NULL, 'Phosphoserine phosphatase ThrH', 94, NULL, NULL, 96849),
(96850, '3.90.830.10-FF-000003', NULL, 'Sec1 family domain containing 1', 139, NULL, NULL, 96850),
(96851, '1.10.510.10-FF-001022', NULL, 'Cyclin-dependent kinase C-1, putative', 202, NULL, NULL, 96851),
(96852, '3.30.200.20-FF-001686', NULL, NULL, 68, NULL, NULL, 96852),
(96853, '2.130.10.10-FF-004696', NULL, 'Flagellar/basal body protein', 332, NULL, NULL, 96853),
(96854, '3.20.20.370-FF-000022', NULL, 'Feruloyl esterase', 95, NULL, NULL, 96854),
(96855, '3.90.70.10-FF-000309', NULL, 'Ubiquitin carboxyl-terminal hydrolase 13', 92, NULL, NULL, 96855),
(96856, '3.40.50.300-FF-006883', NULL, 'Uncharacterized protein', 245, NULL, NULL, 96856),
(96857, '3.40.50.1100-FF-000253', NULL, 'Uncharacterized protein', 184, NULL, NULL, 96857),
(96858, '1.10.150.50-FF-000011', NULL, 'Polyhomeotic-like protein 2 isoform 1', 72, NULL, NULL, 96858),
(96859, '1.10.510.10-FF-002186', NULL, 'Predicted protein', 187, NULL, NULL, 96859),
(96860, '2.30.42.10-FF-000290', NULL, 'Partitioning defective protein 3', 106, NULL, NULL, 96860),
(96861, '3.40.50.1820-FF-001863', NULL, 'Uncharacterized protein', 40, NULL, NULL, 96861),
(96862, '3.10.320.10-FF-000005', NULL, 'MHC class II histocompatibility antigen', 70, NULL, NULL, 96862),
(96863, '2.60.40.10-FF-001666', NULL, 'Dystroglycan, isoform B', 109, NULL, NULL, 96863),
(96864, '1.10.287.140-FF-000001', NULL, 'Glutamate dehydrogenase 1, mitochondrial', 58, NULL, NULL, 96864),
(96865, '3.40.630.10-FF-000191', NULL, 'Succinyl-diaminopimelate desuccinylase', 119, NULL, NULL, 96865); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(96866, '1.10.1420.10-FF-000154', NULL, 'Uncharacterized protein', 107, NULL, NULL, 96866),
(96867, '1.25.40.10-FF-003503', NULL, 'Uncharacterized protein', 209, NULL, NULL, 96867),
(96868, '2.60.40.420-FF-000014', NULL, 'Quinol oxidase subunit 2', 165, NULL, NULL, 96868),
(96869, '3.30.540.10-FF-000034', NULL, 'Inositol monophosphatase family protein', 145, NULL, NULL, 96869),
(96870, '3.30.870.10-FF-000199', NULL, 'Phopholipase D, putative', 56, NULL, NULL, 96870),
(96871, '1.10.287.160-FF-000007', NULL, 'Rhophilin-2', 82, NULL, NULL, 96871),
(96872, '3.90.1600.10-FF-000036', NULL, 'DNA polymerase', 99, NULL, NULL, 96872),
(96873, '1.25.10.10-FF-001377', NULL, 'Karyopherin', 1134, NULL, NULL, 96873),
(96874, '3.40.50.12780-FF-000221', NULL, 'Uncharacterized protein', 211, NULL, NULL, 96874),
(96875, '3.40.50.150-FF-001470', NULL, NULL, 132, NULL, NULL, 96875),
(96876, '2.170.15.10-FF-000001', NULL, 'Aerolysin', 207, NULL, NULL, 96876),
(96877, '1.10.287.70-FF-000772', NULL, 'Voltage-dependent sodium channel, putative', 117, NULL, NULL, 96877),
(96878, '2.120.10.30-FF-000425', NULL, 'Uncharacterized protein', 151, NULL, NULL, 96878),
(96879, '3.20.20.70-FF-000491', NULL, NULL, 124, NULL, NULL, 96879),
(96880, '1.10.580.10-FF-000043', NULL, 'Citrate synthase', 103, NULL, NULL, 96880),
(96881, '1.10.472.10-FF-000640', NULL, 'Uncharacterized protein', 149, NULL, NULL, 96881),
(96882, '1.10.238.10-FF-000080', NULL, 'Sodium leak channel non-selective protein', 125, NULL, NULL, 96882),
(96883, '3.40.50.2300-FF-000832', NULL, NULL, 122, NULL, NULL, 96883),
(96884, '3.10.490.10-FF-000051', NULL, 'Uncharacterized protein', 84, NULL, NULL, 96884),
(96885, '1.25.40.450-FF-000016', NULL, 'Nuclear pore complex protein Nup155-like Protein', 159, NULL, NULL, 96885),
(96886, '3.90.550.50-FF-000246', NULL, 'RFNG O-fucosylpeptide 3-beta-N-acetylglucosaminyltransferase', 96, NULL, NULL, 96886),
(96887, '3.40.50.300-FF-006175', NULL, 'Uncharacterized protein', 61, NULL, NULL, 96887),
(96888, '3.40.20.10-FF-000067', NULL, 'TWF1p Twinfilin', 130, NULL, NULL, 96888),
(96889, '3.30.559.30-FF-000122', NULL, 'Uncharacterized protein', 143, NULL, NULL, 96889),
(96890, '3.40.50.150-FF-000542', NULL, 'Class I SAM-dependent methyltransferase', 206, NULL, NULL, 96890),
(96891, '3.40.50.10810-FF-000175', NULL, 'DNA excision repair protein ERCC-6', 143, NULL, NULL, 96891),
(96892, '1.10.238.20-FF-000026', NULL, 'Odorant-binding protein 56g', 107, NULL, NULL, 96892),
(96893, '1.25.40.20-FF-001415', NULL, 'Oxysterol-binding protein', 84, NULL, NULL, 96893),
(96894, '3.30.460.10-FF-000033', NULL, 'Poly A polymerase head domain protein', 155, NULL, NULL, 96894),
(96895, '1.10.510.10-FF-000033', NULL, 'Non-specific serine/threonine protein kinase', 206, NULL, NULL, 96895),
(96896, '1.25.40.10-FF-000485', NULL, 'pentatricopeptide repeat-containing protein At4g16390, chloroplastic', 104, NULL, NULL, 96896),
(96897, '2.30.42.10-FF-000379', NULL, NULL, 99, NULL, NULL, 96897),
(96898, '3.40.50.10540-FF-000010', NULL, 'Probable CoA-transferase Rv1866', 254, NULL, NULL, 96898),
(96899, '2.70.130.10-FF-000110', NULL, NULL, 156, NULL, NULL, 96899),
(96900, '3.30.40.10-FF-001108', NULL, 'Small subunit ribosomal protein 20', 78, NULL, NULL, 96900),
(96901, '3.90.550.10-FF-000605', NULL, 'Uncharacterized protein', 219, NULL, NULL, 96901),
(96902, '3.40.50.1910-FF-000018', NULL, 'Carnation, isoform C', 102, NULL, NULL, 96902),
(96903, '3.90.1140.10-FF-000017', NULL, 'U6 snRNA phosphodiesterase', 172, NULL, NULL, 96903),
(96904, '2.30.30.40-FF-000175', NULL, 'Melanoma-derived growth regulatory protein', 107, NULL, NULL, 96904),
(96905, '3.30.420.40-FF-000186', NULL, 'Actin-like protein', 21, NULL, NULL, 96905),
(96906, '1.20.1070.10-FF-001939', NULL, 'Uncharacterized protein', 241, NULL, NULL, 96906),
(96907, '3.40.1000.10-FF-000035', NULL, 'Uncharacterized protein', 130, NULL, NULL, 96907),
(96908, '2.60.40.10-FF-000677', NULL, 'protein sidekick isoform X1', 102, NULL, NULL, 96908),
(96909, '1.25.40.180-FF-000059', NULL, 'Putative eukaryotic translation initiation factor 5', 176, NULL, NULL, 96909);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(96910, '3.90.45.10-FF-000004', NULL, 'Peptide deformylase', 183, NULL, NULL, 96910),
(96911, '1.10.10.10-FF-001966', NULL, 'Uncharacterized protein', 70, NULL, NULL, 96911),
(96912, '3.30.70.1230-FF-000126', NULL, 'Two-component response regulator', 203, NULL, NULL, 96912),
(96913, '1.25.40.20-FF-001915', NULL, 'Ankyrin-repeat protein, putative', 235, NULL, NULL, 96913),
(96914, '3.30.70.1820-FF-000005', NULL, 'Predicted protein', 90, NULL, NULL, 96914),
(96915, '2.70.150.10-FF-000173', NULL, 'Phospholipid-transporting ATPase', 126, NULL, NULL, 96915),
(96916, '1.10.8.60-FF-000311', NULL, 'Uncharacterized protein', 79, NULL, NULL, 96916),
(96917, '1.10.510.10-FF-001994', NULL, 'Protein kinase superfamily protein', 206, NULL, NULL, 96917),
(96918, '1.25.10.10-FF-001877', NULL, 'ARM repeat superfamily protein', 114, NULL, NULL, 96918),
(96919, '2.60.40.760-FF-000003', NULL, 'Expansin-like A2', 105, NULL, NULL, 96919),
(96920, '3.40.50.2300-FF-001496', NULL, NULL, 118, NULL, NULL, 96920),
(96921, '1.10.510.10-FF-001730', NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', 215, NULL, NULL, 96921),
(96922, '2.60.34.10-FF-000033', NULL, 'Heat shock 70 kDa protein 17', 149, NULL, NULL, 96922),
(96923, '3.30.9.10-FF-000266', NULL, 'Fructosyl-amino acid oxidase, putative', 144, NULL, NULL, 96923),
(96924, '2.40.10.10-FF-000428', NULL, 'AGAP005310-PA', 232, NULL, NULL, 96924),
(96925, '3.30.160.60-FF-000626', NULL, 'zinc finger protein 384 isoform X1', 30, NULL, NULL, 96925),
(96926, '1.10.1240.100-FF-000003', NULL, 'Polyketide synthase/nonribosomal peptide synthetase hybrid RzxB', 91, NULL, NULL, 96926),
(96927, '3.20.20.80-FF-000437', NULL, 'Uncharacterized protein', 394, NULL, NULL, 96927),
(96928, '3.40.50.10900-FF-000022', NULL, 'Proteasome assembly chaperone 2', 160, NULL, NULL, 96928),
(96929, '2.60.120.260-FF-000048', NULL, 'netrin-4 isoform X1', 250, NULL, NULL, 96929),
(96930, '1.25.40.10-FF-002430', NULL, 'Uncharacterized protein', 128, NULL, NULL, 96930),
(96931, '1.25.40.10-FF-005156', NULL, 'Uncharacterized protein', 89, NULL, NULL, 96931),
(96932, '2.80.10.50-FF-000152', NULL, 'Fascin', 114, NULL, NULL, 96932),
(96933, '3.60.150.10-FF-000008', NULL, 'Chorismate synthase', 112, NULL, NULL, 96933),
(96934, '1.10.1060.10-FF-000019', NULL, 'Oxidoreductase/iron-sulfur cluster-binding protein', 111, NULL, NULL, 96934),
(96935, '2.40.50.100-FF-000054', NULL, 'Exosome complex exonuclease RRP40', 66, NULL, NULL, 96935),
(96936, '2.60.40.10-FF-005409', NULL, NULL, 24, NULL, NULL, 96936),
(96937, '3.40.1110.10-FF-000100', NULL, 'P-type ATPase, putative', 33, NULL, NULL, 96937),
(96938, '3.40.50.300-FF-007956', NULL, 'Uncharacterized protein', 168, NULL, NULL, 96938),
(96939, '3.30.230.80-FF-000025', NULL, 'Putative heat shock protein HSP 90-beta 4', 44, NULL, NULL, 96939),
(96940, '3.40.50.2300-FF-001557', NULL, NULL, 20, NULL, NULL, 96940),
(96941, '1.10.20.10-FF-000303', NULL, NULL, 55, NULL, NULL, 96941),
(96942, '3.40.1480.10-FF-000003', NULL, 'D-glycerate 2-kinase', 170, NULL, NULL, 96942),
(96943, '2.60.120.200-FF-000081', NULL, 'Crumbs 1, cell polarity complex component', 181, NULL, NULL, 96943),
(96944, '3.90.1010.10-FF-000013', NULL, 'Iron-sulfur cluster assembly enzyme ISCU, mitochondrial', 87, NULL, NULL, 96944),
(96945, '2.60.120.200-FF-000401', NULL, 'Agrin', 177, NULL, NULL, 96945),
(96946, '1.10.30.10-FF-000068', NULL, 'PolyBRoMo domain containing', 52, NULL, NULL, 96946),
(96947, '3.40.250.10-FF-000026', NULL, 'Dual specificity protein phosphatase', 129, NULL, NULL, 96947),
(96948, '3.40.50.300-FF-000312', NULL, 'ATP-dependent RNA helicase RhlB', 216, NULL, NULL, 96948),
(96949, '3.40.50.720-FF-001394', NULL, 'Erythronate-4-phosphate dehydrogenase', 110, NULL, NULL, 96949),
(96950, '3.90.70.10-FF-000517', NULL, 'Protein CBG00738', 213, NULL, NULL, 96950),
(96951, '1.10.238.10-FF-000641', NULL, 'Os02g0253601 protein', 50, NULL, NULL, 96951),
(96952, '3.90.1430.10-FF-000005', NULL, 'Elongation Factor TU family', 106, NULL, NULL, 96952),
(96953, '2.170.150.20-FF-000017', NULL, 'Uncharacterized protein', 72, NULL, NULL, 96953); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(96954, '1.10.1200.240-FF-000003', NULL, '50S ribosomal protein L19e', 92, NULL, NULL, 96954),
(96955, '2.30.30.30-FF-000077', NULL, '5''-3'' exoribonuclease 1', 48, NULL, NULL, 96955),
(96956, '3.30.420.40-FF-000539', NULL, 'Uncharacterized protein', 133, NULL, NULL, 96956),
(96957, '2.30.30.100-FF-000007', NULL, 'U6 snRNA-associated Sm-like protein LSm3', 93, NULL, NULL, 96957),
(96958, '3.40.50.2300-FF-001349', NULL, NULL, 56, NULL, NULL, 96958),
(96959, '3.30.40.10-FF-001047', NULL, 'Zinc finger, SWIM domain containing 2', 81, NULL, NULL, 96959),
(96960, '3.30.70.330-FF-002362', NULL, NULL, 104, NULL, NULL, 96960),
(96961, '2.130.10.10-FF-004432', NULL, 'Ribosome assembly protein rrb1', 435, NULL, NULL, 96961),
(96962, '1.25.40.10-FF-003711', NULL, 'Uncharacterized protein', 66, NULL, NULL, 96962),
(96963, '2.20.25.10-FF-000082', NULL, 'Phosphonoacetate hydrolase', 39, NULL, NULL, 96963),
(96964, '2.30.30.1150-FF-000012', NULL, 'Uncharacterized protein', 166, NULL, NULL, 96964),
(96965, '1.10.10.60-FF-000531', NULL, 'Transcription factor', 76, NULL, NULL, 96965),
(96966, '3.40.50.2060-FF-000007', NULL, 'Vacuolar sorting protein', 124, NULL, NULL, 96966),
(96967, '3.40.50.300-FF-003538', NULL, 'Protein SEY1 homolog', 227, NULL, NULL, 96967),
(96968, '3.40.1180.10-FF-000019', NULL, 'Alkyl transferase', 244, NULL, NULL, 96968),
(96969, '3.40.50.2000-FF-000568', NULL, 'Glycogen synthase', 190, NULL, NULL, 96969),
(96970, '1.20.58.60-FF-000101', NULL, 'Short stop, isoform K', 104, NULL, NULL, 96970),
(96971, '3.90.960.10-FF-000007', NULL, 'Prolyl-tRNA synthetase', 170, NULL, NULL, 96971),
(96972, '3.60.21.10-FF-000187', NULL, 'Ser/thr protein phosphatase family protein', 221, NULL, NULL, 96972),
(96973, '1.10.10.10-FF-001141', NULL, 'SWI/SNF complex subunit SMARCC1', 55, NULL, NULL, 96973),
(96974, '3.40.50.300-FF-006675', NULL, 'Ras homolog, mTORC1-binding', 83, NULL, NULL, 96974),
(96975, '2.170.140.10-FF-000042', NULL, 'Mucin 11A', 68, NULL, NULL, 96975),
(96976, '1.10.565.10-FF-000092', NULL, 'AGAP001348-PA', 209, NULL, NULL, 96976),
(96977, '2.20.70.10-FF-000186', NULL, 'E3 ubiquitin-protein ligase', 49, NULL, NULL, 96977),
(96978, '1.20.5.170-FF-000178', NULL, 'C-type lectin domain family 4 member F', 47, NULL, NULL, 96978),
(96979, '3.40.50.1820-FF-001340', NULL, 'Hydrolase, putative', 249, NULL, NULL, 96979),
(96980, '1.20.5.110-FF-000031', NULL, 'SNAP25 homologous protein SNAP33', 78, NULL, NULL, 96980),
(96981, '1.10.10.140-FF-000012', NULL, 'Cytochrome Oxidase Assembly subunits', 74, NULL, NULL, 96981),
(96982, '1.20.1070.10-FF-001355', NULL, 'Histamine receptor H3', 266, NULL, NULL, 96982),
(96983, '3.20.20.300-FF-000018', NULL, 'Sugar hydrolase', 332, NULL, NULL, 96983),
(96984, '3.80.10.10-FF-001610', NULL, 'Probable inactive receptor kinase At2g26730', 44, NULL, NULL, 96984),
(96985, '2.40.50.100-FF-000115', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 69, NULL, NULL, 96985),
(96986, '1.10.472.10-FF-000140', NULL, 'G1/S-specific cyclin-E1', 106, NULL, NULL, 96986),
(96987, '2.40.50.90-FF-000090', NULL, 'Endonuclease YncB, thermonuclease family', 125, NULL, NULL, 96987),
(96988, '3.40.50.790-FF-000026', NULL, '50S ribosomal protein L1', 109, NULL, NULL, 96988),
(96989, '1.20.1310.10-FF-000082', NULL, 'Cullin family protein', 114, NULL, NULL, 96989),
(96990, '3.30.1680.10-FF-000026', NULL, 'Sema domain, transmembrane domain (TM), and cytoplasmic domain, (semaphorin) 6D', 64, NULL, NULL, 96990),
(96991, '1.10.340.30-FF-000008', NULL, 'DNA-3-methyladenine glycosylase 2', 116, NULL, NULL, 96991),
(96992, '1.25.10.10-FF-002282', NULL, 'Uncharacterized protein', 332, NULL, NULL, 96992),
(96993, '1.20.58.390-FF-000305', NULL, 'Uncharacterized protein', 70, NULL, NULL, 96993),
(96994, '1.20.58.390-FF-000193', NULL, 'Predicted protein', 92, NULL, NULL, 96994),
(96995, '3.60.15.10-FF-000066', NULL, 'Hydroxyacylglutathione hydrolase', 264, NULL, NULL, 96995),
(96996, '1.10.150.650-FF-000014', NULL, 'Gll2048 protein', 66, NULL, NULL, 96996),
(96997, '3.40.630.30-FF-000258', NULL, 'Glycine-N-acyltransferase-like 2, isoform CRA_a', 125, NULL, NULL, 96997);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(96998, '1.10.10.10-FF-001758', NULL, 'Uncharacterized protein', 71, NULL, NULL, 96998),
(96999, '2.40.50.90-FF-000202', NULL, 'Uncharacterized protein', 147, NULL, NULL, 96999),
(97000, '3.30.499.10-FF-000026', NULL, 'Aconitate hydratase', 219, NULL, NULL, 97000),
(97001, '1.10.3730.20-FF-000057', NULL, 'YALI0F04081p', 121, NULL, NULL, 97001),
(97002, '2.110.10.10-FF-000060', NULL, 'Matrix metallopeptidase 17b', 187, NULL, NULL, 97002),
(97003, '2.40.160.120-FF-000013', NULL, 'Oxysterol binding protein', 170, NULL, NULL, 97003),
(97004, '2.40.160.200-FF-000003', NULL, 'Eukaryotic translation initiation factor 2B (eIF-2B) family protein', 170, NULL, NULL, 97004),
(97005, '2.20.25.20-FF-000028', NULL, NULL, 52, NULL, NULL, 97005),
(97006, '2.30.140.10-FF-000024', NULL, 'Putative spermidine synthase', 62, NULL, NULL, 97006),
(97007, '3.50.50.60-FF-001409', NULL, 'Uncharacterized protein', 139, NULL, NULL, 97007),
(97008, '3.90.70.10-FF-000664', NULL, 'Ubiquitin carboxyl-terminal hydrolase 11', 305, NULL, NULL, 97008),
(97009, '3.40.50.1240-FF-000149', NULL, NULL, 216, NULL, NULL, 97009),
(97010, '1.25.40.10-FF-000277', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 224, NULL, NULL, 97010),
(97011, '3.30.60.30-FF-000099', NULL, 'Protein CBG17314', 49, NULL, NULL, 97011),
(97012, '1.10.45.10-FF-000001', NULL, 'D-lactate dehydrogenase mitochondrial', 41, NULL, NULL, 97012),
(97013, '3.40.720.10-FF-000079', NULL, 'Non-specific phospholipase C5', 175, NULL, NULL, 97013),
(97014, '2.60.40.10-FF-004780', NULL, NULL, 81, NULL, NULL, 97014),
(97015, '3.40.850.10-FF-000471', NULL, 'Kinesin-like protein', 358, NULL, NULL, 97015),
(97016, '2.30.29.30-FF-000040', NULL, 'Kalirin RhoGEF kinase b', 144, NULL, NULL, 97016),
(97017, '1.25.40.20-FF-000898', NULL, 'Protein phosphatase 1 regulatory subunit 12A', 162, NULL, NULL, 97017),
(97018, '3.40.50.300-FF-002785', NULL, 'Structural maintenance of chromosomes', 209, NULL, NULL, 97018),
(97019, '3.30.160.60-FF-002520', NULL, 'Uncharacterized protein', 28, NULL, NULL, 97019),
(97020, '3.40.50.300-FF-005247', NULL, 'Rac_C94 protein', 192, NULL, NULL, 97020),
(97021, '3.10.20.90-FF-000227', NULL, 'Plexin A3', 96, NULL, NULL, 97021),
(97022, '2.60.40.3210-FF-000005', NULL, 'Deleted in malignant brain tumors 1', 121, NULL, NULL, 97022),
(97023, '3.30.70.20-FF-000068', NULL, 'Dihydropyrimidine dehydrogenase, putative', 107, NULL, NULL, 97023),
(97024, '3.30.230.10-FF-000224', NULL, 'YALI0E10769p', 147, NULL, NULL, 97024),
(97025, '1.20.1560.10-FF-000241', NULL, 'Multidrug resistance-associated protein 1', 328, NULL, NULL, 97025),
(97026, '1.10.510.10-FF-001522', NULL, 'Serine/threonine protein kinase', 203, NULL, NULL, 97026),
(97027, '2.60.40.10-FF-000177', NULL, 'Sidekick cell adhesion molecule 2', 88, NULL, NULL, 97027),
(97028, '3.40.50.720-FF-001247', NULL, 'Gfo/Idh/MocA family oxidoreductase', 116, NULL, NULL, 97028),
(97029, '1.10.510.10-FF-000802', NULL, 'Serine/threonine protein kinase', 272, NULL, NULL, 97029),
(97030, '3.10.129.10-FF-000285', NULL, 'Uncharacterized protein', 155, NULL, NULL, 97030),
(97031, '3.30.420.10-FF-000379', NULL, NULL, 217, NULL, NULL, 97031),
(97032, '3.30.450.20-FF-000417', NULL, 'Histidine kinase sensor protein', 145, NULL, NULL, 97032),
(97033, '1.25.40.10-FF-002222', NULL, 'Est1p', 281, NULL, NULL, 97033),
(97034, '1.20.5.320-FF-000004', NULL, '6-phosphogluconate dehydrogenase, decarboxylating', 33, NULL, NULL, 97034),
(97035, '3.40.30.10-FF-000416', NULL, 'Maleylacetoacetate isomerase maia', 81, NULL, NULL, 97035),
(97036, '1.20.120.1900-FF-000006', NULL, 'Spindle pole body component', 299, NULL, NULL, 97036),
(97037, '3.30.1360.210-FF-000001', NULL, '60S ribosomal protein L22 1', 121, NULL, NULL, 97037),
(97038, '2.40.128.330-FF-000005', NULL, 'Magnesium transporter MRS2, mitochondrial', 93, NULL, NULL, 97038),
(97039, '1.10.10.1420-FF-000008', NULL, NULL, 137, NULL, NULL, 97039),
(97040, '3.40.640.10-FF-000337', NULL, 'Predicted protein', 114, NULL, NULL, 97040),
(97041, '1.25.40.10-FF-004431', NULL, 'Uncharacterized protein', 122, NULL, NULL, 97041);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(97042, '2.60.40.10-FF-005297', NULL, NULL, 82, NULL, NULL, 97042),
(97043, '3.30.450.40-FF-000103', NULL, 'Transcriptional regulatory protein', 181, NULL, NULL, 97043),
(97044, '3.40.630.10-FF-000252', NULL, 'Nicalin', 338, NULL, NULL, 97044),
(97045, '1.20.1260.10-FF-000021', NULL, 'Ferritin BfrB', 181, NULL, NULL, 97045),
(97046, '2.60.120.650-FF-000159', NULL, 'Uncharacterized protein', 255, NULL, NULL, 97046),
(97047, '3.20.190.10-FF-000014', NULL, 'Formamidopyrimidine-DNA glycosylase', 134, NULL, NULL, 97047),
(97048, '3.20.20.140-FF-000358', NULL, 'Adenosine deaminase', 279, NULL, NULL, 97048),
(97049, '2.40.50.140-FF-000515', NULL, 'DNA-Binding protein G5P', 87, NULL, NULL, 97049),
(97050, '3.40.50.300-FF-004730', NULL, 'ABC transporter I family member 21', 165, NULL, NULL, 97050),
(97051, '3.90.79.10-FF-000268', NULL, 'Uncharacterized protein', 108, NULL, NULL, 97051),
(97052, '3.50.50.60-FF-000128', NULL, 'Pyridine nucleotide-disulfide oxidoreductase YkgC', 119, NULL, NULL, 97052),
(97053, '1.10.630.10-FF-000160', NULL, 'Fumitremorgin C synthase', 472, NULL, NULL, 97053),
(97054, '3.40.50.300-FF-001032', NULL, 'GTP-binding protein REM 2', 172, NULL, NULL, 97054),
(97055, '1.10.470.10-FF-000006', NULL, 'Variant surface glycoprotein (VSG), putative', 153, NULL, NULL, 97055),
(97056, '3.40.50.300-FF-000576', NULL, 'Elongation factor Tu', 203, NULL, NULL, 97056),
(97057, '3.40.50.720-FF-000674', NULL, 'N(5)-(Carboxyethyl)ornithine synthase', 16, NULL, NULL, 97057),
(97058, '3.80.10.10-FF-001346', NULL, 'LRR receptor-like serine/threonine-protein kinase EFR', 93, NULL, NULL, 97058),
(97059, '3.40.50.300-FF-008361', NULL, 'Uncharacterized protein', 261, NULL, NULL, 97059),
(97060, '3.30.470.20-FF-000008', NULL, 'D-alanine--D-alanine ligase', 153, NULL, NULL, 97060),
(97061, '2.60.40.10-FF-004072', NULL, NULL, 95, NULL, NULL, 97061),
(97062, '3.30.160.60-FF-001031', NULL, 'zinc finger protein 341 isoform X1', 30, NULL, NULL, 97062),
(97063, '2.60.200.40-FF-000003', NULL, 'Diacylglycerol kinase', 187, NULL, NULL, 97063),
(97064, '3.30.200.20-FF-001214', NULL, 'Serine/threonine-protein kinase ppk21', 91, NULL, NULL, 97064),
(97065, '3.90.76.10-FF-000031', NULL, 'ABC transporter solute binding lipoprotein', 111, NULL, NULL, 97065),
(97066, '1.20.1250.20-FF-001069', NULL, 'Uncharacterized transporter YwbF', 184, NULL, NULL, 97066),
(97067, '1.10.520.10-FF-000067', NULL, 'Os01g0294300 protein', 49, NULL, NULL, 97067),
(97068, '1.10.10.60-FF-001195', NULL, NULL, 88, NULL, NULL, 97068),
(97069, '3.80.10.10-FF-004483', NULL, 'Probable inactive leucine-rich repeat receptor-like protein kinase At3g03770', 115, NULL, NULL, 97069),
(97070, '3.30.342.10-FF-000040', NULL, 'DNA polymerase', 182, NULL, NULL, 97070),
(97071, '1.25.40.10-FF-003975', NULL, 'Uncharacterized protein', 224, NULL, NULL, 97071),
(97072, '2.60.40.10-FF-001082', NULL, 'Titin novex-3', 87, NULL, NULL, 97072),
(97073, '4.10.400.10-FF-000120', NULL, 'Terribly reduced optic lobes, isoform AI', 42, NULL, NULL, 97073),
(97074, '2.120.10.30-FF-000189', NULL, 'Acylaminoacyl-peptide hydrolase', 219, NULL, NULL, 97074),
(97075, '2.30.29.30-FF-000601', NULL, 'Vacuolar protein sorting-associated protein 36', 133, NULL, NULL, 97075),
(97076, '3.20.20.70-FF-000844', NULL, NULL, 87, NULL, NULL, 97076),
(97077, '1.20.58.70-FF-000014', NULL, 't-SNARE domain containing 1', 121, NULL, NULL, 97077),
(97078, '3.30.200.20-FF-002142', NULL, 'Receptor protein serine/threonine kinase', 70, NULL, NULL, 97078),
(97079, '1.20.1740.10-FF-000159', NULL, 'Uncharacterized protein', 446, NULL, NULL, 97079),
(97080, '3.40.50.11130-FF-000001', NULL, 'Outer capsid glycoprotein VP7', 147, NULL, NULL, 97080),
(97081, '2.30.29.170-FF-000020', NULL, NULL, 124, NULL, NULL, 97081),
(97082, '1.25.10.10-FF-000449', NULL, 'Cohesin subunit SA-3', 210, NULL, NULL, 97082),
(97083, '1.50.40.10-FF-000185', NULL, 'Chromosome 1, whole genome shotgun sequence', 344, NULL, NULL, 97083),
(97084, '1.10.510.10-FF-004248', NULL, NULL, 195, NULL, NULL, 97084),
(97085, '1.10.3380.30-FF-000016', NULL, 'Superkiller viralicidic activity 2-like (S. cerevisiae)', 75, NULL, NULL, 97085);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(97086, '3.30.70.3270-FF-000013', NULL, 'NADH-quinone oxidoreductase subunit I protein', 115, NULL, NULL, 97086),
(97087, '2.60.40.60-FF-000528', NULL, 'Dachsous cadherin-related 1a', 102, NULL, NULL, 97087),
(97088, '3.90.226.10-FF-000015', NULL, 'Periplasmic tail-specific protease', 161, NULL, NULL, 97088),
(97089, '3.60.40.10-FF-000348', NULL, 'Uncharacterized protein', 69, NULL, NULL, 97089),
(97090, '3.50.30.30-FF-000169', NULL, 'Glutamate carboxypeptidase, putative', 132, NULL, NULL, 97090),
(97091, '3.30.230.70-FF-000135', NULL, 'Uncharacterized protein', 191, NULL, NULL, 97091),
(97092, '1.25.40.20-FF-000634', NULL, 'Death-associated protein kinase 1', 94, NULL, NULL, 97092),
(97093, '3.30.40.10-FF-001311', NULL, 'AT07234p', 72, NULL, NULL, 97093),
(97094, '3.30.70.330-FF-002098', NULL, NULL, 122, NULL, NULL, 97094),
(97095, '3.40.190.10-FF-000324', NULL, 'Predicted protein', 101, NULL, NULL, 97095),
(97096, '2.60.200.20-FF-000109', NULL, 'Protein kinase domain containing protein', 120, NULL, NULL, 97096),
(97097, '2.30.42.10-FF-000643', NULL, NULL, 50, NULL, NULL, 97097),
(97098, '1.25.10.10-FF-000596', NULL, 'cullin-associated NEDD8-dissociated protein 2 isoform X3', 989, NULL, NULL, 97098),
(97099, '3.30.160.60-FF-003240', NULL, NULL, 30, NULL, NULL, 97099),
(97100, '3.10.20.90-FF-000935', NULL, 'E3 ubiquitin-protein ligase parkin', 79, NULL, NULL, 97100),
(97101, '3.80.10.10-FF-003555', NULL, 'Predicted protein', 151, NULL, NULL, 97101),
(97102, '2.40.30.10-FF-000430', NULL, 'Uncharacterized protein', 108, NULL, NULL, 97102),
(97103, '1.25.40.10-FF-001766', NULL, 'Pentatricopeptide repeat-containing protein', 239, NULL, NULL, 97103),
(97104, '3.30.420.40-FF-001091', NULL, 'Ectonucleoside triphosphate diphosphohydrolase 6', 88, NULL, NULL, 97104),
(97105, '1.10.600.10-FF-000068', NULL, 'Conserved hypthetical protein', 293, NULL, NULL, 97105),
(97106, '3.30.300.130-FF-000040', NULL, NULL, 73, NULL, NULL, 97106),
(97107, '1.10.150.20-FF-000227', NULL, 'DNA repair protein complementing XP-G cells-like isoform X1', 65, NULL, NULL, 97107),
(97108, '2.70.40.10-FF-000013', NULL, 'Deoxyuridine 5''-triphosphate nucleotidohydrolase', 143, NULL, NULL, 97108),
(97109, '1.10.510.10-FF-000241', NULL, 'Putative serine/threonine-protein kinase ULK3', 183, NULL, NULL, 97109),
(97110, '3.30.300.20-FF-000053', NULL, 'Probable transcription termination protein NusA', 68, NULL, NULL, 97110),
(97111, '3.50.50.60-FF-000275', NULL, 'Putative selenate reductase subunit YgfK', 143, NULL, NULL, 97111),
(97112, '3.40.50.300-FF-001857', NULL, 'Elongation factor 1-alpha', 130, NULL, NULL, 97112),
(97113, '3.40.50.300-FF-007080', NULL, 'Uncharacterized protein', 192, NULL, NULL, 97113),
(97114, '1.20.870.10-FF-000029', NULL, 'ral guanine nucleotide dissociation stimulator-like 2 isoform X2', 173, NULL, NULL, 97114),
(97115, '3.40.390.10-FF-000244', NULL, NULL, 44, NULL, NULL, 97115),
(97116, '1.20.120.830-FF-000004', NULL, 'Neural precursor cell-expressed, developmentally down-regulated 9', 174, NULL, NULL, 97116),
(97117, '1.20.1050.10-FF-000011', NULL, 'Predicted glutathione S-transferase', 113, NULL, NULL, 97117),
(97118, '2.40.30.10-FF-000019', NULL, 'Respiratory burst oxidase homolog A', 93, NULL, NULL, 97118),
(97119, '2.60.120.40-FF-000002', NULL, 'Cerebellin 4', 137, NULL, NULL, 97119),
(97120, '3.40.50.2020-FF-000107', NULL, 'Guanine phosphoribosyltransferase', 230, NULL, NULL, 97120),
(97121, '2.10.25.10-FF-000992', NULL, 'Fibulin-1', 30, NULL, NULL, 97121),
(97122, '3.40.50.1820-FF-001099', NULL, 'Uncharacterized protein', 132, NULL, NULL, 97122),
(97123, '2.10.50.30-FF-000011', NULL, 'Vomeronasal 2, receptor 73', 50, NULL, NULL, 97123),
(97124, '3.40.50.300-FF-003802', NULL, 'Predicted protein', 107, NULL, NULL, 97124),
(97125, '3.40.50.2300-FF-000068', NULL, 'Glutamate receptor, ionotropic, delta 1b', 165, NULL, NULL, 97125),
(97126, '3.40.50.1820-FF-000435', NULL, 'Ppe family protein ppe63', 222, NULL, NULL, 97126),
(97127, '1.20.120.1080-FF-000075', NULL, 'DEAH (Asp-Glu-Ala-His) box helicase 30', 105, NULL, NULL, 97127);
INSERT INTO "PUBLIC"."MODEL" VALUES
(97128, '1.20.920.30-FF-000040', NULL, 'Uncharacterized protein', 104, NULL, NULL, 97128),
(97129, '1.10.1300.10-FF-000027', NULL, 'Uncharacterized protein', 120, NULL, NULL, 97129),
(97130, '2.60.120.290-FF-000096', NULL, 'SOL-2 protein', 147, NULL, NULL, 97130),
(97131, '1.10.3380.10-FF-000010', NULL, 'DExH-box ATP-dependent RNA helicase DExH12', 137, NULL, NULL, 97131),
(97132, '2.130.10.10-FF-003004', NULL, 'Uncharacterized protein', 337, NULL, NULL, 97132),
(97133, '3.80.10.10-FF-000121', NULL, 'Protein zyg-11 B isoform X5', 154, NULL, NULL, 97133),
(97134, '3.10.110.10-FF-000259', NULL, 'RBR-type E3 ubiquitin transferase', 164, NULL, NULL, 97134),
(97135, '2.60.120.1060-FF-000001', NULL, 'Blood-group-substance endo-1,4-beta-galactosidase', 180, NULL, NULL, 97135),
(97136, '3.90.226.10-FF-000279', NULL, 'Uncharacterized protein', 222, NULL, NULL, 97136),
(97137, '2.130.10.10-FF-000542', NULL, 'semaphorin-4F isoform X4', 236, NULL, NULL, 97137),
(97138, '3.90.1100.10-FF-000043', NULL, 'DNA-directed RNA polymerase subunit beta', 252, NULL, NULL, 97138),
(97139, '2.60.40.10-FF-004628', NULL, NULL, 77, NULL, NULL, 97139),
(97140, '3.40.50.1470-FF-000021', NULL, 'Uncharacterized protein', 91, NULL, NULL, 97140),
(97141, '3.30.70.330-FF-001434', NULL, NULL, 95, NULL, NULL, 97141),
(97142, '1.10.420.10-FF-000003', NULL, 'L-ascorbate peroxidase, cytosolic', 108, NULL, NULL, 97142),
(97143, '1.10.3080.10-FF-000049', NULL, 'Chloride channel protein', 363, NULL, NULL, 97143),
(97144, '2.130.10.10-FF-005213', NULL, 'WD repeat-containing protein 38', 86, NULL, NULL, 97144),
(97145, '3.90.190.10-FF-000594', NULL, 'Phosphatase and tensin homolog', 93, NULL, NULL, 97145),
(97146, '2.20.100.10-FF-000187', NULL, 'Lonely heart, isoform A', 58, NULL, NULL, 97146),
(97147, '3.30.1330.80-FF-000010', NULL, 'AT-hook motif nuclear-localized protein', 137, NULL, NULL, 97147),
(97148, '1.10.287.70-FF-000300', NULL, 'Voltage-gated Ca2+ channel, alpha subunit', 151, NULL, NULL, 97148),
(97149, '1.20.120.1070-FF-000015', NULL, 'Uncharacterized protein', 64, NULL, NULL, 97149),
(97150, '2.170.130.10-FF-000069', NULL, NULL, 128, NULL, NULL, 97150),
(97151, '1.20.144.10-FF-000084', NULL, 'Phospholipid phosphatase 5', 239, NULL, NULL, 97151),
(97152, '3.40.50.300-FF-004319', NULL, 'Cell division inhibitor SulA', 112, NULL, NULL, 97152),
(97153, '2.170.120.12-FF-000026', NULL, 'Polymerase (RNA) II (DNA directed) polypeptide C, 33kDa', 141, NULL, NULL, 97153),
(97154, '3.40.50.300-FF-006528', NULL, 'Si:ch211-113e8.6', 110, NULL, NULL, 97154),
(97155, '3.30.70.3290-FF-000019', NULL, 'Polyketide synthase, putative (JCVI)', 135, NULL, NULL, 97155),
(97156, '3.30.365.10-FF-000076', NULL, 'Uncharacterized protein', 85, NULL, NULL, 97156),
(97157, '1.10.10.10-FF-000477', NULL, 'IclR family transcriptional regulator', 75, NULL, NULL, 97157),
(97158, '1.10.1170.10-FF-000056', NULL, 'Uncharacterized protein', 64, NULL, NULL, 97158),
(97159, '2.130.10.10-FF-005921', NULL, 'Protein CBR-TOM-1', 272, NULL, NULL, 97159),
(97160, '3.40.50.360-FF-000015', NULL, 'NADPH-dependent diflavin oxidoreductase 1', 161, NULL, NULL, 97160),
(97161, '3.90.380.10-FF-000013', NULL, 'Possible dioxygenase', 128, NULL, NULL, 97161),
(97162, '1.10.8.530-FF-000007', NULL, 'DNA polymerase alpha subunit B', 77, NULL, NULL, 97162),
(97163, '3.30.200.20-FF-000197', NULL, 'dual specificity mitogen-activated protein kinase kinase 5', 108, NULL, NULL, 97163),
(97164, '1.10.357.10-FF-000064', NULL, 'TetR family transcriptional regulator', 210, NULL, NULL, 97164),
(97165, '1.20.1070.10-FF-000922', NULL, 'Uncharacterized protein', 187, NULL, NULL, 97165),
(97166, '1.25.10.10-FF-000860', NULL, 'Pumilio homolog 3', 209, NULL, NULL, 97166),
(97167, '3.80.10.10-FF-000060', NULL, 'F-box/LRR-repeat protein 20 isoform 2', 140, NULL, NULL, 97167),
(97168, '1.25.40.340-FF-000006', NULL, 'Conserved hypothetical alanine rich protein', 134, NULL, NULL, 97168),
(97169, '3.20.200.10-FF-000005', NULL, 'Alpha-protein kinase 2', 105, NULL, NULL, 97169),
(97170, '2.60.40.10-FF-001110', NULL, 'phosphatidylinositol phosphatase PTPRQ isoform X1', 89, NULL, NULL, 97170);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(97171, '1.10.472.170-FF-000005', NULL, 'Transcription initiation factor IIB', 196, NULL, NULL, 97171),
(97172, '2.60.40.10-FF-002094', NULL, 'Alpha-2-macroglobulin like 1', 87, NULL, NULL, 97172),
(97173, '1.10.3460.10-FF-000011', NULL, 'Fucoxanthin chlorophyll a/c protein 8', 183, NULL, NULL, 97173),
(97174, '3.50.50.60-FF-000336', NULL, 'Cellobiose dehydrogenase', 330, NULL, NULL, 97174),
(97175, '2.120.10.80-FF-000243', NULL, 'Uncharacterized protein', 127, NULL, NULL, 97175),
(97176, '1.20.1170.10-FF-000014', NULL, NULL, 240, NULL, NULL, 97176),
(97177, '6.10.250.3440-FF-000002', NULL, '54S ribosomal protein L28, mitochondrial', 104, NULL, NULL, 97177),
(97178, '1.10.10.10-FF-001197', NULL, 'Transcriptional regulator, MarR family', 136, NULL, NULL, 97178),
(97179, '1.20.1280.50-FF-000045', NULL, 'F-box protein 7', 93, NULL, NULL, 97179),
(97180, '2.60.40.1450-FF-000011', NULL, 'Predicted protein', 12, NULL, NULL, 97180),
(97181, '2.60.40.10-FF-005797', NULL, NULL, 81, NULL, NULL, 97181),
(97182, '2.60.120.200-FF-000373', NULL, 'Apical endosomal glycoprotein', 168, NULL, NULL, 97182),
(97183, '2.60.40.10-FF-005853', NULL, NULL, 121, NULL, NULL, 97183),
(97184, '3.80.20.20-FF-000035', NULL, 'Insulin-like receptor', 173, NULL, NULL, 97184),
(97185, '3.30.40.10-FF-000794', NULL, 'CG13732 protein', 85, NULL, NULL, 97185),
(97186, '3.40.50.300-FF-005163', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 225, NULL, NULL, 97186),
(97187, '3.40.50.1820-FF-001363', NULL, 'Uncharacterized protein', 230, NULL, NULL, 97187),
(97188, '3.90.1600.10-FF-000013', NULL, 'DNA polymerase', 176, NULL, NULL, 97188),
(97189, '1.25.40.10-FF-001974', NULL, 'Putative pentatricopeptide repeat-containing protein', 150, NULL, NULL, 97189),
(97190, '1.10.3520.10-FF-000038', NULL, 'Uncharacterized protein', 81, NULL, NULL, 97190),
(97191, '1.10.1300.10-FF-000090', NULL, 'Phosphodiesterase', 154, NULL, NULL, 97191),
(97192, '2.130.10.10-FF-005449', NULL, 'Uncharacterized protein', 199, NULL, NULL, 97192),
(97193, '3.40.1110.10-FF-000156', NULL, 'Copper-transporting ATPase', 119, NULL, NULL, 97193),
(97194, '1.20.58.190-FF-000009', NULL, 'Unplaced genomic scaffold supercont2.8, whole genome shotgun sequence', 140, NULL, NULL, 97194),
(97195, '3.30.200.20-FF-002350', NULL, 'Probable ribosome biogenesis protein WBGene00106114', 50, NULL, NULL, 97195),
(97196, '1.20.1070.10-FF-001378', NULL, 'Uncharacterized protein', 253, NULL, NULL, 97196),
(97197, '2.40.290.10-FF-000038', NULL, 'ATP-dependent DNA helicase II subunit 2', 230, NULL, NULL, 97197),
(97198, '3.40.190.10-FF-000347', NULL, 'LysR family transcriptional regulator', 94, NULL, NULL, 97198),
(97199, '3.40.50.1820-FF-000851', NULL, 'Serine carboxypeptidase S28 family protein', 41, NULL, NULL, 97199),
(97200, '1.10.510.10-FF-002686', NULL, NULL, 105, NULL, NULL, 97200),
(97201, '1.10.472.90-FF-000001', NULL, 'Pyruvate carboxylase', 120, NULL, NULL, 97201),
(97202, '2.70.130.10-FF-000082', NULL, NULL, 146, NULL, NULL, 97202),
(97203, '2.10.25.10-FF-001829', NULL, 'Uncharacterized protein', 27, NULL, NULL, 97203),
(97204, '1.10.1600.10-FF-000016', NULL, 'ATP-dependent DNA helicase 2 subunit KU80', 95, NULL, NULL, 97204),
(97205, '3.40.50.1010-FF-000142', NULL, 'GH28353p', 144, NULL, NULL, 97205),
(97206, '2.30.30.40-FF-000675', NULL, 'Uncharacterized protein', 60, NULL, NULL, 97206),
(97207, '1.20.1560.10-FF-000297', NULL, 'ABC a-pheromone efflux pump AtrD', 277, NULL, NULL, 97207),
(97208, '1.20.1070.10-FF-000866', NULL, 'Uncharacterized protein', 178, NULL, NULL, 97208),
(97209, '1.10.8.60-FF-000547', NULL, 'C4-dicarboxylate transport transcriptional regulatory protein', 77, NULL, NULL, 97209),
(97210, '2.60.200.20-FF-000020', NULL, 'Kinesin family member 14', 109, NULL, NULL, 97210),
(97211, '3.30.160.60-FF-000126', NULL, 'Mds1 and evi1 complex locus protein', 28, NULL, NULL, 97211),
(97212, '2.40.30.10-FF-000519', NULL, 'Putative tetracycline resistance protein', 107, NULL, NULL, 97212),
(97213, '3.90.1150.10-FF-000107', NULL, 'Putative cysteine desulfurase', 116, NULL, NULL, 97213);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(97214, '1.10.510.10-FF-003675', NULL, NULL, 173, NULL, NULL, 97214),
(97215, '3.30.160.60-FF-006382', NULL, NULL, 71, NULL, NULL, 97215),
(97216, '1.25.10.10-FF-000365', NULL, 'Armadillo repeat-containing protein 1', 115, NULL, NULL, 97216),
(97217, '3.30.70.330-FF-003087', NULL, NULL, 106, NULL, NULL, 97217),
(97218, '3.40.50.720-FF-001663', NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase NAD-binding', 82, NULL, NULL, 97218),
(97219, '3.90.290.10-FF-000006', NULL, 'Fibrillin 2', 60, NULL, NULL, 97219),
(97220, '3.40.50.2300-FF-000276', NULL, 'LacI family transcriptional regulator', 123, NULL, NULL, 97220),
(97221, '1.10.287.1880-FF-000001', NULL, 'Protein zwilch homolog', 64, NULL, NULL, 97221),
(97222, '2.60.120.650-FF-000103', NULL, 'JmjC domain containing protein', 233, NULL, NULL, 97222),
(97223, '1.10.287.110-FF-000341', NULL, 'Predicted protein', 68, NULL, NULL, 97223),
(97224, '3.40.50.300-FF-007456', NULL, 'RNA helicase', 244, NULL, NULL, 97224),
(97225, '1.20.58.1520-FF-000002', NULL, '65-kDa microtubule-associated protein 6', 134, NULL, NULL, 97225),
(97226, '2.60.40.1510-FF-000046', NULL, 'Integrin beta', 112, NULL, NULL, 97226),
(97227, '1.10.10.10-FF-001202', NULL, 'Transcriptional regulator, GntR family', 73, NULL, NULL, 97227),
(97228, '2.60.40.10-FF-002571', NULL, 'Usherin', 78, NULL, NULL, 97228),
(97229, '1.10.238.10-FF-000372', NULL, 'Centrin, putative', 69, NULL, NULL, 97229),
(97230, '3.90.400.10-FF-000010', NULL, '4-alpha-glucanotransferase', 65, NULL, NULL, 97230),
(97231, '2.40.110.10-FF-000059', NULL, 'Acyl-CoA dehydrogenase', 107, NULL, NULL, 97231),
(97232, '3.40.525.10-FF-000058', NULL, 'Sec14p-like phosphatidylinositol transfer family protein', 101, NULL, NULL, 97232),
(97233, '3.40.50.11860-FF-000012', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase', 103, NULL, NULL, 97233),
(97234, '3.30.160.60-FF-002048', NULL, 'Crooked legs, isoform F', 27, NULL, NULL, 97234),
(97235, '3.30.710.10-FF-000070', NULL, 'zinc finger and BTB domain-containing protein 11', 147, NULL, NULL, 97235),
(97236, '3.40.50.10810-FF-000259', NULL, 'Predicted protein', 307, NULL, NULL, 97236),
(97237, '1.10.4190.10-FF-000001', NULL, 'Urease accessory protein F', 205, NULL, NULL, 97237),
(97238, '3.30.1370.240-FF-000017', NULL, 'Phenylalanyl-tRNA synthetase alpha chain', 43, NULL, NULL, 97238),
(97239, '1.10.150.20-FF-000143', NULL, 'DNA excision repair protein, putative', 66, NULL, NULL, 97239),
(97240, '3.40.1090.10-FF-000075', NULL, 'Uncharacterized protein', 48, NULL, NULL, 97240),
(97241, '1.25.40.10-FF-000985', NULL, 'Signal recognition particle subunit SRP72', 162, NULL, NULL, 97241),
(97242, '1.10.506.10-FF-000074', NULL, 'Uncharacterized protein', 213, NULL, NULL, 97242),
(97243, '1.20.120.530-FF-000004', NULL, 'Galactonate operon transcriptional repressor', 143, NULL, NULL, 97243),
(97244, '1.10.260.40-FF-000067', NULL, 'Shikimate kinase', 77, NULL, NULL, 97244),
(97245, '3.90.550.10-FF-000049', NULL, 'Hexosyltransferase', 279, NULL, NULL, 97245),
(97246, '3.80.10.10-FF-001785', NULL, 'Uncharacterized protein', 123, NULL, NULL, 97246),
(97247, '3.40.50.2000-FF-000832', NULL, 'Uncharacterized protein', 129, NULL, NULL, 97247),
(97248, '1.20.1560.10-FF-000774', NULL, 'Uncharacterized protein', 301, NULL, NULL, 97248),
(97249, '3.30.40.10-FF-000322', NULL, 'PHD transcription factor (Rum1)', 67, NULL, NULL, 97249),
(97250, '2.60.40.10-FF-005325', NULL, NULL, 77, NULL, NULL, 97250),
(97251, '1.20.1730.10-FF-000097', NULL, 'High affinity choline transporter, putative', 291, NULL, NULL, 97251),
(97252, '1.10.1380.10-FF-000010', NULL, 'Gone early, isoform B', 362, NULL, NULL, 97252),
(97253, '1.10.10.820-FF-000002', NULL, 'Myosin heavy chain 10', 56, NULL, NULL, 97253),
(97254, '2.30.29.30-FF-001113', NULL, 'Target of rapamycin complex 2 subunit MAPKAP1-like Protein', 137, NULL, NULL, 97254),
(97255, '3.40.50.720-FF-001186', NULL, 'Trk system potassium uptake protein TrkA', 135, NULL, NULL, 97255),
(97256, '2.60.40.1120-FF-000019', NULL, 'Carboxypeptidase D', 103, NULL, NULL, 97256);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(97257, '3.90.470.10-FF-000048', NULL, 'Predicted protein', 63, NULL, NULL, 97257),
(97258, '3.30.70.2330-FF-000001', NULL, 'helicase-like transcription factor isoform X2', 122, NULL, NULL, 97258),
(97259, '3.30.70.270-FF-000202', NULL, NULL, 130, NULL, NULL, 97259),
(97260, '1.10.287.70-FF-000800', NULL, 'Uncharacterized protein', 121, NULL, NULL, 97260),
(97261, '3.30.1520.10-FF-000133', NULL, 'UPF0507 protein YALI0E18612g', 115, NULL, NULL, 97261),
(97262, '1.25.40.10-FF-002930', NULL, 'Clathrin heavy chain', 338, NULL, NULL, 97262),
(97263, '2.130.10.10-FF-002695', NULL, 'Protein CBG22664', 325, NULL, NULL, 97263),
(97264, '3.20.140.10-FF-000011', NULL, 'Nicotinate phosphoribosyltransferase', 286, NULL, NULL, 97264),
(97265, '1.25.40.690-FF-000004', NULL, 'Nucleoporin 98-96', 90, NULL, NULL, 97265),
(97266, '1.20.1110.10-FF-000038', NULL, 'Sodium/potassium-transporting ATPase subunit alpha', 262, NULL, NULL, 97266),
(97267, '1.25.40.10-FF-001502', NULL, 'Methyltransferase, putative', 179, NULL, NULL, 97267),
(97268, '3.30.200.20-FF-000309', NULL, 'Leucine-rich repeat receptor protein kinase MSP1', 117, NULL, NULL, 97268),
(97269, '3.10.620.30-FF-000028', NULL, 'Predicted protein', 89, NULL, NULL, 97269),
(97270, '3.40.605.10-FF-000059', NULL, 'Succinate-semialdehyde dehydrogenase', 270, NULL, NULL, 97270),
(97271, '3.40.30.10-FF-000832', NULL, 'Protein disulfide isomerase1-2', 104, NULL, NULL, 97271),
(97272, '3.40.50.1000-FF-000341', NULL, 'Haloacid dehalogenase family hydrolase domain containing protein', 159, NULL, NULL, 97272),
(97273, '3.30.60.20-FF-000039', NULL, 'Diacylglycerol kinase', 54, NULL, NULL, 97273),
(97274, '3.40.50.720-FF-000730', NULL, 'Glycerate-and formate-dehydrogenase, putative', 135, NULL, NULL, 97274),
(97275, '2.130.10.10-FF-004640', NULL, 'U3 small nucleolar RNA-associated protein 17', 193, NULL, NULL, 97275),
(97276, '2.10.25.10-FF-000048', NULL, 'Netrin 3', 44, NULL, NULL, 97276),
(97277, '3.40.190.290-FF-000131', NULL, 'Transcriptional regulator, LysR family', 202, NULL, NULL, 97277),
(97278, '1.25.40.990-FF-000032', NULL, 'COP9 signalosome complex subunit 8', 131, NULL, NULL, 97278),
(97279, '2.70.250.10-FF-000001', NULL, 'Adsorption protein P2', 254, NULL, NULL, 97279),
(97280, '3.80.10.10-FF-001402', NULL, 'Leucine Rich Repeat family protein', 128, NULL, NULL, 97280),
(97281, '1.10.555.10-FF-000147', NULL, NULL, 125, NULL, NULL, 97281),
(97282, '1.10.630.10-FF-000452', NULL, 'Cytochrome P450, family 2, subfamily d, polypeptide 22', 149, NULL, NULL, 97282),
(97283, '3.40.30.10-FF-000888', NULL, 'Predicted protein', 130, NULL, NULL, 97283),
(97284, '3.40.50.300-FF-001324', NULL, 'GTPase Era', 179, NULL, NULL, 97284),
(97285, '3.30.40.10-FF-001255', NULL, 'E3 ubiquitin-protein ligase SINA-like 10', 56, NULL, NULL, 97285),
(97286, '2.60.120.260-FF-000109', NULL, 'Beta-galactosidase', 94, NULL, NULL, 97286),
(97287, '3.10.290.10-FF-000007', NULL, 'Tyrosine--tRNA ligase', 92, NULL, NULL, 97287),
(97288, '3.90.1720.10-FF-000016', NULL, 'Possible Inv protein', 147, NULL, NULL, 97288),
(97289, '1.10.730.10-FF-000021', NULL, 'Isoleucine--tRNA ligase', 185, NULL, NULL, 97289),
(97290, '3.30.160.60-FF-002487', NULL, 'Zinc finger protein 700', 29, NULL, NULL, 97290),
(97291, '1.20.58.670-FF-000030', NULL, NULL, 122, NULL, NULL, 97291),
(97292, '3.30.9.10-FF-000289', NULL, 'Uncharacterized protein', 101, NULL, NULL, 97292),
(97293, '2.40.50.180-FF-000004', NULL, 'Chemotaxis protein CheV', 90, NULL, NULL, 97293),
(97294, '3.40.50.300-FF-000812', NULL, 'multidrug resistance-associated protein 1 isoform X15', 231, NULL, NULL, 97294),
(97295, '1.25.10.10-FF-002310', NULL, 'Cullin-associated NEDD8-dissociated protein 1, N-terminal part', 317, NULL, NULL, 97295),
(97296, '2.10.25.10-FF-000576', NULL, 'Coagulation factor XII', 39, NULL, NULL, 97296),
(97297, '3.30.43.10-FF-000036', NULL, 'xanthine dehydrogenase/oxidase-like', 56, NULL, NULL, 97297),
(97298, '3.40.50.2000-FF-000304', NULL, 'UDP-N-acetylglucosamine transferase subunit ALG14, putative', 173, NULL, NULL, 97298);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(97299, '2.60.40.640-FF-000052', NULL, 'Arrestin domain-containing protein 17', 155, NULL, NULL, 97299),
(97300, '3.10.20.90-FF-000019', NULL, 'FERM domain containing 4A', 86, NULL, NULL, 97300),
(97301, '2.130.10.10-FF-001762', NULL, 'RBBP4 isoform 18', 180, NULL, NULL, 97301),
(97302, '3.40.50.620-FF-000470', NULL, '7-cyano-7-deazaguanine synthase', 223, NULL, NULL, 97302),
(97303, '3.90.226.10-FF-000195', NULL, 'Enoyl-CoA hydratase', 254, NULL, NULL, 97303),
(97304, '2.30.110.10-FF-000084', NULL, 'Uncharacterized protein', 161, NULL, NULL, 97304),
(97305, '3.80.10.10-FF-000913', NULL, 'Transforming growth factor beta activator LRRC33', 158, NULL, NULL, 97305),
(97306, '2.60.40.10-FF-003875', NULL, NULL, 106, NULL, NULL, 97306),
(97307, '3.10.20.90-FF-001008', NULL, 'Uncharacterized protein', 106, NULL, NULL, 97307),
(97308, '1.10.472.80-FF-000144', NULL, 'TBC1 domain family member 20/GTPase, putative', 162, NULL, NULL, 97308),
(97309, '2.40.50.140-FF-000987', NULL, NULL, 126, NULL, NULL, 97309),
(97310, '3.30.50.10-FF-000120', NULL, 'Nuclear receptor subfamily 2 group E member 3', 83, NULL, NULL, 97310),
(97311, '3.90.920.10-FF-000010', NULL, 'DNA primase', 350, NULL, NULL, 97311),
(97312, '2.60.40.200-FF-000004', NULL, 'Copper chaperone for superoxide dismutase', 153, NULL, NULL, 97312),
(97313, '3.30.200.20-FF-000961', NULL, 'Mitogen-activated protein kinase', 83, NULL, NULL, 97313),
(97314, '1.25.40.10-FF-002806', NULL, 'Uncharacterized protein', 165, NULL, NULL, 97314),
(97315, '2.60.40.10-FF-002947', NULL, 'Neuronal cell adhesion molecule, putative', 85, NULL, NULL, 97315),
(97316, '1.20.1560.10-FF-000302', NULL, 'Uncharacterized protein', 330, NULL, NULL, 97316),
(97317, '2.70.50.50-FF-000003', NULL, 'Secreted cellulose binding protein', 187, NULL, NULL, 97317),
(97318, '3.30.40.10-FF-001608', NULL, 'Putative RING finger domain protein', 91, NULL, NULL, 97318),
(97319, '2.130.10.10-FF-000834', NULL, 'Transducin beta-like 3', 173, NULL, NULL, 97319),
(97320, '4.10.1000.10-FF-000047', NULL, 'Makorin ring finger protein 1', 35, NULL, NULL, 97320),
(97321, '3.30.2010.10-FF-000016', NULL, 'CAAX prenyl protease', 85, NULL, NULL, 97321),
(97322, '3.40.50.720-FF-000202', NULL, 'Short-chain dehydrogenase/reductase family 16C member 6', 264, NULL, NULL, 97322),
(97323, '2.60.40.150-FF-000293', NULL, 'Guanine nucleotide exchange factor SPIKE 1', 179, NULL, NULL, 97323),
(97324, '3.90.550.10-FF-000105', NULL, 'translation initiation factor eIF-2B subunit gamma', 328, NULL, NULL, 97324),
(97325, '2.60.40.60-FF-000731', NULL, 'Predicted protein', 94, NULL, NULL, 97325),
(97326, '1.20.120.1750-FF-000152', NULL, 'Uncharacterized protein', 42, NULL, NULL, 97326),
(97327, '3.90.170.10-FF-000003', NULL, 'Adenylosuccinate synthetase', 240, NULL, NULL, 97327),
(97328, '1.20.1440.130-FF-000003', NULL, 'Probable conserved integral membrane protein', 150, NULL, NULL, 97328),
(97329, '1.20.120.230-FF-000009', NULL, 'Talin 2', 125, NULL, NULL, 97329),
(97330, '1.20.120.350-FF-000074', NULL, 'SHaW family of potassium channels', 161, NULL, NULL, 97330),
(97331, '3.40.50.150-FF-000334', NULL, 'Methyltransferase', 250, NULL, NULL, 97331),
(97332, '1.25.40.20-FF-000398', NULL, 'ankyrin repeat and KH domain-containing protein 1 isoform X3', 99, NULL, NULL, 97332),
(97333, '1.20.1270.60-FF-000132', NULL, 'Rho GTPase Activating protein', 211, NULL, NULL, 97333),
(97334, '3.90.1750.10-FF-000108', NULL, 'Uncharacterized protein', 55, NULL, NULL, 97334),
(97335, '1.10.167.10-FF-000026', NULL, 'Developmental regulator FlbA', 155, NULL, NULL, 97335),
(97336, '2.60.120.290-FF-000124', NULL, 'GM24707', 116, NULL, NULL, 97336),
(97337, '1.10.510.10-FF-002742', NULL, NULL, 131, NULL, NULL, 97337),
(97338, '2.40.50.40-FF-000120', NULL, 'Signal recognition particle 43 kDa protein, chloroplastic', 37, NULL, NULL, 97338),
(97339, '3.30.1370.60-FF-000001', NULL, '2,3-diketo-L-gulonate reductase', 155, NULL, NULL, 97339),
(97340, '1.20.930.40-FF-000015', NULL, 'Uncharacterized protein', 131, NULL, NULL, 97340),
(97341, '1.20.120.1110-FF-000011', NULL, 'Predicted protein', 101, NULL, NULL, 97341);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(97342, '3.30.70.330-FF-001665', NULL, NULL, 52, NULL, NULL, 97342),
(97343, '2.30.170.40-FF-000012', NULL, 'Ribosomal L28 family protein', 70, NULL, NULL, 97343),
(97344, '2.160.10.10-FF-000035', NULL, 'Gamma carbonic anhydrase-like 1, mitochondrial', 174, NULL, NULL, 97344),
(97345, '2.130.10.10-FF-005505', NULL, 'Protein CBG01041', 96, NULL, NULL, 97345),
(97346, '1.20.1090.10-FF-000013', NULL, 'NDMA-dependent methanol dehydrogenase', 219, NULL, NULL, 97346),
(97347, '1.20.140.40-FF-000039', NULL, 'Pectinesterase', 139, NULL, NULL, 97347),
(97348, '1.25.40.10-FF-001497', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 110, NULL, NULL, 97348),
(97349, '3.40.640.10-FF-000253', NULL, 'Nucleotide sugar transaminase', 223, NULL, NULL, 97349),
(97350, '3.40.366.10-FF-000019', NULL, 'Sterigmatocystin biosynthesis polyketide synthase', 235, NULL, NULL, 97350),
(97351, '3.30.40.10-FF-001783', NULL, 'Acyl-CoA N-acyltransferase with RING/FYVE/PHD-type zinc finger protein', 84, NULL, NULL, 97351),
(97352, '3.40.50.2300-FF-000332', NULL, 'DNA-binding response OmpR family regulator', 85, NULL, NULL, 97352),
(97353, '1.20.1250.20-FF-001333', NULL, 'Uncharacterized protein', 138, NULL, NULL, 97353),
(97354, '3.90.1800.10-FF-000017', NULL, 'DNA-directed RNA polymerase subunit 2', 107, NULL, NULL, 97354),
(97355, '3.80.10.10-FF-004275', NULL, 'Uncharacterized protein', 48, NULL, NULL, 97355),
(97356, '2.10.25.10-FF-000520', NULL, 'Predicted protein', 37, NULL, NULL, 97356),
(97357, '1.10.533.10-FF-000069', NULL, 'NACHT, LRR and PYD domains-containing protein 6', 105, NULL, NULL, 97357),
(97358, '3.30.160.60-FF-000250', NULL, 'zinc finger protein 197 isoform X1', 28, NULL, NULL, 97358),
(97359, '2.60.40.60-FF-000175', NULL, 'cadherin-23 isoform X1', 121, NULL, NULL, 97359),
(97360, '3.40.50.720-FF-000258', NULL, 'Hydroxyacyl-coenzyme A dehydrogenase, mitochondrial', 203, NULL, NULL, 97360),
(97361, '3.40.630.10-FF-000044', NULL, 'Allantoate amidohydrolase', 273, NULL, NULL, 97361),
(97362, '2.60.40.420-FF-000194', NULL, 'Cytochrome c oxidase subunit 2', 106, NULL, NULL, 97362),
(97363, '3.30.70.330-FF-002154', NULL, NULL, 92, NULL, NULL, 97363),
(97364, '2.40.37.10-FF-000024', NULL, 'Putative diaminopimelate decarboxylase', 143, NULL, NULL, 97364),
(97365, '3.30.420.40-FF-000955', NULL, 'ARP1 actin related protein 1 homolog B', 38, NULL, NULL, 97365),
(97366, '3.10.110.10-FF-000028', NULL, 'Probable ubiquitin-conjugating enzyme E2 23', 277, NULL, NULL, 97366),
(97367, '3.30.200.20-FF-001422', NULL, 'Si:dkeyp-67e1.6', 58, NULL, NULL, 97367),
(97368, '3.30.420.10-FF-000143', NULL, 'Oligoribonuclease', 184, NULL, NULL, 97368),
(97369, '1.10.540.10-FF-000153', NULL, 'Uncharacterized protein', 69, NULL, NULL, 97369),
(97370, '1.10.3720.10-FF-000082', NULL, 'Phosphate transport system permease protein PstA', 278, NULL, NULL, 97370),
(97371, '1.10.287.90-FF-000014', NULL, 'Cytochrome c oxidase subunit 2', 80, NULL, NULL, 97371),
(97372, '1.25.40.10-FF-004728', NULL, 'Pentatricopeptide repeat-containing protein At4g21170', 84, NULL, NULL, 97372),
(97373, '1.10.510.10-FF-000797', NULL, 'CMGC/SRPK protein kinase', 182, NULL, NULL, 97373),
(97374, '1.20.120.1200-FF-000010', NULL, 'NADH-quinone oxidoreductase subunit J', 166, NULL, NULL, 97374),
(97375, '3.90.1490.10-FF-000009', NULL, 'ATP binding protein', 97, NULL, NULL, 97375),
(97376, '1.10.30.50-FF-000001', NULL, 'HNH endonuclease', 75, NULL, NULL, 97376),
(97377, '3.10.20.70-FF-000013', NULL, 'Glutamine synthetase bacteria', 107, NULL, NULL, 97377),
(97378, '3.40.710.10-FF-000045', NULL, 'Glutaminase', 309, NULL, NULL, 97378),
(97379, '3.40.50.300-FF-006944', NULL, 'Uncharacterized protein', 227, NULL, NULL, 97379),
(97380, '3.40.50.620-FF-000846', NULL, 'Predicted protein', 171, NULL, NULL, 97380),
(97381, '2.10.109.10-FF-000052', NULL, 'LexA repressor', 120, NULL, NULL, 97381),
(97382, '3.30.160.60-FF-004521', NULL, NULL, 54, NULL, NULL, 97382),
(97383, '3.30.450.40-FF-000311', NULL, 'Phosphodiesterase', 56, NULL, NULL, 97383),
(97384, '3.40.350.10-FF-000062', NULL, 'AGAP001037-PA', 164, NULL, NULL, 97384);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(97385, '3.40.50.300-FF-000492', NULL, 'Hydrogenase nickel incorporation protein HypB', 222, NULL, NULL, 97385),
(97386, '2.60.40.1180-FF-000110', NULL, '1,4-alpha-glucan branching enzyme GlgB', 107, NULL, NULL, 97386),
(97387, '2.60.40.10-FF-000654', NULL, 'MAM domain containing glycosylphosphatidylinositol anchor 2', 89, NULL, NULL, 97387),
(97388, '3.20.70.20-FF-000001', NULL, 'Ribonucleoside-diphosphate reductase', 678, NULL, NULL, 97388),
(97389, '3.30.70.2030-FF-000001', NULL, 'N-acetylmuramoyl-L-alanine amidase', 66, NULL, NULL, 97389),
(97390, '2.60.40.10-FF-000946', NULL, 'Roundabout guidance receptor 4', 110, NULL, NULL, 97390),
(97391, '2.10.70.10-FF-000091', NULL, 'Beta-2-glycoprotein 1', 62, NULL, NULL, 97391),
(97392, '3.40.50.300-FF-006091', NULL, 'Uncharacterized protein', 305, NULL, NULL, 97392),
(97393, '2.40.128.680-FF-000003', NULL, 'Uncharacterized protein C12B10.15c', 141, NULL, NULL, 97393),
(97394, '1.10.472.10-FF-000376', NULL, 'Uncharacterized protein', 128, NULL, NULL, 97394),
(97395, '3.20.20.80-FF-000701', NULL, 'Os03g0320100 protein', 135, NULL, NULL, 97395),
(97396, '3.40.930.10-FF-000033', NULL, 'Sodium bicarbonate cotransporter, putative', 323, NULL, NULL, 97396),
(97397, '3.40.190.80-FF-000087', NULL, 'Inositol-1-monophosphatase', 106, NULL, NULL, 97397),
(97398, '3.20.20.80-FF-000645', NULL, 'Uncharacterized protein', 91, NULL, NULL, 97398),
(97399, '3.40.47.10-FF-000016', NULL, 'Non-specific lipid-transfer protein', 392, NULL, NULL, 97399),
(97400, '3.30.160.60-FF-005269', NULL, NULL, 74, NULL, NULL, 97400),
(97401, '1.20.1250.20-FF-001277', NULL, 'Solute carrier family 2, facilitated glucose transporter member 6', 166, NULL, NULL, 97401),
(97402, '1.10.510.10-FF-001758', NULL, 'Serine/threonine protein kinase ppk15, putative', 251, NULL, NULL, 97402),
(97403, '2.120.10.30-FF-000509', NULL, 'Uncharacterized protein', 198, NULL, NULL, 97403),
(97404, '3.30.200.20-FF-001894', NULL, 'Mitogen-activated protein kinase', 27, NULL, NULL, 97404),
(97405, '1.25.10.10-FF-001293', NULL, 'Protein CBG02946', 247, NULL, NULL, 97405),
(97406, '1.10.150.20-FF-000199', NULL, 'DNA-directed RNA polymerase subunit alpha, chloroplastic', 60, NULL, NULL, 97406),
(97407, '1.10.132.10-FF-000002', NULL, 'DNA topoisomerase I', 181, NULL, NULL, 97407),
(97408, '3.50.50.60-FF-001264', NULL, 'Glycerol-3-phosphate dehydrogenase', 91, NULL, NULL, 97408),
(97409, '3.10.28.10-FF-000070', NULL, 'DNA helicase, SNF2/RAD54 family', 103, NULL, NULL, 97409),
(97410, '1.10.472.10-FF-000432', NULL, 'Uncharacterized protein', 135, NULL, NULL, 97410),
(97411, '3.80.10.10-FF-003347', NULL, 'Uncharacterized protein', 118, NULL, NULL, 97411),
(97412, '3.40.50.150-FF-001767', NULL, NULL, 215, NULL, NULL, 97412),
(97413, '3.40.50.1000-FF-000605', NULL, NULL, 49, NULL, NULL, 97413),
(97414, '1.10.132.30-FF-000008', NULL, 'DNA-directed RNA polymerase subunit', 97, NULL, NULL, 97414),
(97415, '3.30.70.330-FF-000176', NULL, 'Inner nuclear membrane protein Man1', 111, NULL, NULL, 97415),
(97416, '3.40.50.300-FF-000840', NULL, 'Immune-associated nucleotide-binding protein 9', 217, NULL, NULL, 97416),
(97417, '3.30.930.10-FF-000081', NULL, 'Ferredoxin-fold anticodon binding domain containing 1', 216, NULL, NULL, 97417),
(97418, '3.40.50.10240-FF-000010', NULL, 'Thiamin pyrophosphokinase, vitamin B1 binding domain containing protein, putative', 158, NULL, NULL, 97418),
(97419, '3.90.1410.10-FF-000089', NULL, 'Uncharacterized protein', 277, NULL, NULL, 97419),
(97420, '2.130.10.30-FF-000048', NULL, 'YLR077W-like protein', 376, NULL, NULL, 97420),
(97421, '3.30.1370.100-FF-000032', NULL, 'YALI0C07260p', 93, NULL, NULL, 97421),
(97422, '3.40.1280.30-FF-000005', NULL, 'tRNA methyltransferase 10 A', 196, NULL, NULL, 97422),
(97423, '1.10.1740.10-FF-000049', NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', 84, NULL, NULL, 97423),
(97424, '3.40.47.10-FF-000163', NULL, NULL, 140, NULL, NULL, 97424),
(97425, '3.30.160.60-FF-001054', NULL, 'Regulatory protein brlA', 40, NULL, NULL, 97425),
(97426, '1.25.40.20-FF-000426', NULL, 'receptor-interacting serine/threonine-protein kinase 4', 63, NULL, NULL, 97426);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(97427, '3.40.50.300-FF-007580', NULL, 'DEAD_2 protein domain containing protein', 178, NULL, NULL, 97427),
(97428, '3.40.50.12710-FF-000037', NULL, 'Protein arginine methyltransferase NDUFAF7', 76, NULL, NULL, 97428),
(97429, '3.80.10.10-FF-001369', NULL, 'F-box domain protein', 82, NULL, NULL, 97429),
(97430, '3.30.930.10-FF-000373', NULL, 'Uncharacterized protein', 204, NULL, NULL, 97430),
(97431, '2.30.29.30-FF-000129', NULL, 'Insulin receptor substrate 1', 109, NULL, NULL, 97431),
(97432, '2.130.10.10-FF-003999', NULL, 'Glutamate-rich WD repeat-containing protein 1', 228, NULL, NULL, 97432),
(97433, '2.60.40.10-FF-000469', NULL, 'Mast/stem cell growth factor receptor', 102, NULL, NULL, 97433),
(97434, '3.30.200.20-FF-000433', NULL, 'Predicted protein', 106, NULL, NULL, 97434),
(97435, '3.40.190.270-FF-000001', NULL, 'Putative monooxygenase', 150, NULL, NULL, 97435),
(97436, '3.40.1440.10-FF-000001', NULL, 'UvrABC system protein C', 100, NULL, NULL, 97436),
(97437, '1.25.10.10-FF-001669', NULL, 'Uncharacterized protein', 322, NULL, NULL, 97437),
(97438, '3.90.110.10-FF-000027', NULL, NULL, 64, NULL, NULL, 97438),
(97439, '3.90.1200.10-FF-000084', NULL, 'Spore coat protein I', 233, NULL, NULL, 97439),
(97440, '2.60.40.420-FF-000250', NULL, 'Uncharacterized protein', 148, NULL, NULL, 97440),
(97441, '2.130.10.10-FF-002723', NULL, 'Protein CBG19744', 305, NULL, NULL, 97441),
(97442, '3.30.200.20-FF-001950', NULL, 'Uncharacterized protein', 131, NULL, NULL, 97442),
(97443, '3.30.70.960-FF-000016', NULL, 'Suppressor of tumorigenicity 14 protein homolog', 111, NULL, NULL, 97443),
(97444, '2.40.10.10-FF-000636', NULL, NULL, 220, NULL, NULL, 97444),
(97445, '1.10.10.10-FF-000269', NULL, 'Pleckstrin', 105, NULL, NULL, 97445),
(97446, '3.40.50.300-FF-001801', NULL, 'Putative arsenical pump-driving ATPase', 311, NULL, NULL, 97446),
(97447, '3.50.50.60-FF-001320', NULL, 'FAD-dependent catabolic D-arginine dehydrogenase DauA', 194, NULL, NULL, 97447),
(97448, '1.20.120.620-FF-000003', NULL, 'Osmosensitive K+ channel histidine kinase KdpD', 104, NULL, NULL, 97448),
(97449, '2.60.120.10-FF-000134', NULL, 'AraC family transcriptional regulator', 108, NULL, NULL, 97449),
(97450, '1.20.5.390-FF-000013', NULL, NULL, 52, NULL, NULL, 97450),
(97451, '2.10.109.10-FF-000057', NULL, 'Signal peptidase I', 150, NULL, NULL, 97451),
(97452, '3.30.160.60-FF-001615', NULL, 'Zinc finger and SCAN domain containing 4', 27, NULL, NULL, 97452),
(97453, '3.40.50.300-FF-004527', NULL, 'Uncharacterized protein', 175, NULL, NULL, 97453),
(97454, '1.20.1070.10-FF-001411', NULL, 'Uncharacterized protein', 232, NULL, NULL, 97454),
(97455, '2.60.40.10-FF-004836', NULL, NULL, 73, NULL, NULL, 97455),
(97456, '1.20.5.170-FF-000234', NULL, 'Cyclic AMP-responsive element-binding protein 3-like protein 1', 69, NULL, NULL, 97456),
(97457, '1.10.3080.10-FF-000026', NULL, 'Chloride channel protein EriC', 439, NULL, NULL, 97457),
(97458, '2.40.10.10-FF-000159', NULL, 'Complement C1r subcomponent like', 108, NULL, NULL, 97458),
(97459, '1.10.10.60-FF-000767', NULL, NULL, 65, NULL, NULL, 97459),
(97460, '1.10.287.1490-FF-000070', NULL, 'Protein NETWORKED 1D isoform B', 175, NULL, NULL, 97460),
(97461, '2.130.10.10-FF-000042', NULL, 'echinoderm microtubule-associated protein-like 6 isoform X1', 278, NULL, NULL, 97461),
(97462, '2.170.120.12-FF-000003', NULL, 'Dna-directed rna polymerases i and iii subunit', 138, NULL, NULL, 97462),
(97463, '3.50.50.60-FF-001348', NULL, 'Flavin-containing monooxygenase', 136, NULL, NULL, 97463),
(97464, '2.60.40.1180-FF-000054', NULL, 'Trehalose synthase/amylase TreS', 101, NULL, NULL, 97464),
(97465, '3.40.50.300-FF-005539', NULL, 'Septin 7', 55, NULL, NULL, 97465),
(97466, '3.30.70.940-FF-000010', NULL, 'Protein RNA-directed DNA methylation 3', 105, NULL, NULL, 97466),
(97467, '3.40.50.2300-FF-001260', NULL, NULL, 45, NULL, NULL, 97467),
(97468, '1.25.40.20-FF-001359', NULL, 'Ankyrin repeat and KH domain-containing 1', 99, NULL, NULL, 97468),
(97469, '2.130.10.10-FF-000778', NULL, 'WD repeat domain 33', 157, NULL, NULL, 97469);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(97470, '1.20.58.60-FF-000601', NULL, 'Plectin', 138, NULL, NULL, 97470),
(97471, '1.25.10.10-FF-002782', NULL, 'CAMK family protein kinase', 154, NULL, NULL, 97471),
(97472, '1.20.58.1310-FF-000001', NULL, 'Rop guanine nucleotide exchange factor 9', 117, NULL, NULL, 97472),
(97473, '3.40.50.970-FF-000052', NULL, 'Sulfite reductase [NADPH] flavoprotein component', 235, NULL, NULL, 97473),
(97474, '3.30.70.2330-FF-000006', NULL, 'Fanconi-associated nuclease', 84, NULL, NULL, 97474),
(97475, '2.60.120.1440-FF-000019', NULL, 'Probable transmembrane sensor', 124, NULL, NULL, 97475),
(97476, '1.25.10.10-FF-002602', NULL, 'Uncharacterized protein', 147, NULL, NULL, 97476),
(97477, '3.30.160.60-FF-001559', NULL, 'Zinc finger and BTB domain-containing protein 39', 50, NULL, NULL, 97477),
(97478, '2.60.120.260-FF-000312', NULL, 'Uncharacterized protein', 199, NULL, NULL, 97478),
(97479, '2.60.120.10-FF-000662', NULL, 'Uncharacterized protein', 124, NULL, NULL, 97479),
(97480, '2.60.120.40-FF-000025', NULL, 'tumor necrosis factor ligand superfamily member 4', 136, NULL, NULL, 97480),
(97481, '1.10.3720.10-FF-000110', NULL, 'Amino acid ABC transporter, permease protein', 216, NULL, NULL, 97481),
(97482, '1.10.630.10-FF-000396', NULL, 'Cytochrome P450, family 2, subfamily k, polypeptide 20', 109, NULL, NULL, 97482),
(97483, '3.30.70.60-FF-000029', NULL, 'Ribosomal protein S6', 122, NULL, NULL, 97483),
(97484, '1.10.10.10-FF-000241', NULL, 'UPF0502 protein YceH', 80, NULL, NULL, 97484),
(97485, '2.60.120.10-FF-000426', NULL, 'Vicilin-like seed storage protein At2g28490', 178, NULL, NULL, 97485),
(97486, '2.40.10.10-FF-000075', NULL, 'Structural polyprotein', 86, NULL, NULL, 97486),
(97487, '1.25.10.10-FF-001854', NULL, 'HEAT repeat-containing protein 5B-like isoform X1', 194, NULL, NULL, 97487),
(97488, '1.20.58.2190-FF-000001', NULL, 'peptide-N(4)-(N-acetyl-beta- glucosaminyl)asparagine amidase', 98, NULL, NULL, 97488),
(97489, '3.40.50.2000-FF-000776', NULL, 'Predicted protein', 164, NULL, NULL, 97489),
(97490, '3.40.50.300-FF-006467', NULL, 'Si:ch1073-181h11.2', 119, NULL, NULL, 97490),
(97491, '2.120.10.30-FF-000133', NULL, 'Protein CBG19478', 302, NULL, NULL, 97491),
(97492, '4.10.70.10-FF-000007', NULL, 'Disintegrin and metalloproteinase domain-containing protein B', 86, NULL, NULL, 97492),
(97493, '3.30.70.850-FF-000011', NULL, 'Proprotein convertase subtilisin/kexin type 7', 97, NULL, NULL, 97493),
(97494, '3.30.450.240-FF-000004', NULL, 'Uncharacterized protein', 112, NULL, NULL, 97494),
(97495, '3.40.50.150-FF-000773', NULL, 'O-methyltransferase GliM-like protein', 246, NULL, NULL, 97495),
(97496, '1.20.890.10-FF-000036', NULL, 'Uncharacterized protein', 41, NULL, NULL, 97496),
(97497, '3.30.160.780-FF-000004', NULL, 'Uncharacterized protein', 39, NULL, NULL, 97497),
(97498, '3.30.160.60-FF-002543', NULL, 'LOC567465 protein', 48, NULL, NULL, 97498),
(97499, '2.30.29.30-FF-001057', NULL, 'Predicted protein', 86, NULL, NULL, 97499),
(97500, '3.30.1610.10-FF-000016', NULL, 'Nucleoporin autopeptidase', 138, NULL, NULL, 97500),
(97501, '4.10.60.10-FF-000209', NULL, 'Uncharacterized protein', 58, NULL, NULL, 97501),
(97502, '3.30.70.330-FF-000361', NULL, '28 kDa ribonucleoprotein, chloroplastic', 91, NULL, NULL, 97502),
(97503, '2.60.200.40-FF-000059', NULL, 'Diacylglycerol kinase', 194, NULL, NULL, 97503),
(97504, '3.30.930.10-FF-000406', NULL, 'Predicted protein', 84, NULL, NULL, 97504),
(97505, '3.30.1960.10-FF-000008', NULL, 'Methyltransferase TYW3, putative', 204, NULL, NULL, 97505),
(97506, '3.20.20.40-FF-000004', NULL, 'Glucanase', 281, NULL, NULL, 97506),
(97507, '3.40.33.10-FF-000069', NULL, 'GM10902', 145, NULL, NULL, 97507),
(97508, '2.70.20.10-FF-000006', NULL, 'DNA topoisomerase 1', 171, NULL, NULL, 97508),
(97509, '2.60.40.10-FF-001958', NULL, 'Frazzled, isoform C', 94, NULL, NULL, 97509),
(97510, '3.40.50.300-FF-007400', NULL, 'Uncharacterized protein', 64, NULL, NULL, 97510),
(97511, '3.40.30.10-FF-000540', NULL, 'Protein disulfide isomerase PDI2', 133, NULL, NULL, 97511),
(97512, '2.20.70.10-FF-000214', NULL, 'YALI0D02827p', 60, NULL, NULL, 97512);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(97513, '2.60.120.920-FF-000055', NULL, 'Uncharacterized protein', 178, NULL, NULL, 97513),
(97514, '3.40.850.10-FF-000027', NULL, 'Kinesin-like protein', 354, NULL, NULL, 97514),
(97515, '1.25.40.10-FF-002986', NULL, 'Pre-mRNA-splicing factor 6', 143, NULL, NULL, 97515),
(97516, '3.40.470.10-FF-000037', NULL, NULL, 125, NULL, NULL, 97516),
(97517, '3.30.70.870-FF-000017', NULL, 'Elongation factor G, mitochondrial', 74, NULL, NULL, 97517),
(97518, '3.40.50.300-FF-006652', NULL, 'ATP-dependent RNA helicase, putative', 87, NULL, NULL, 97518),
(97519, '1.10.3380.10-FF-000066', NULL, 'Activating signal cointegrator 1 complex subunit 3', 64, NULL, NULL, 97519),
(97520, '2.130.10.10-FF-005977', NULL, 'Uncharacterized protein', 235, NULL, NULL, 97520),
(97521, '1.10.8.10-FF-000049', NULL, 'ancient ubiquitous protein 1 isoform X2', 46, NULL, NULL, 97521),
(97522, '1.10.8.60-FF-000283', NULL, 'Sigma-54 dependent transcriptional regulator', 75, NULL, NULL, 97522),
(97523, '2.30.30.40-FF-000203', NULL, 'Cdc42-interacting protein 4, isoform F', 65, NULL, NULL, 97523),
(97524, '3.40.390.10-FF-000036', NULL, 'Metalloendopeptidase', 229, NULL, NULL, 97524),
(97525, '3.30.710.10-FF-000042', NULL, 'BTB/POZ domain-containing protein 9', 150, NULL, NULL, 97525),
(97526, '1.25.40.10-FF-000513', NULL, 'Uncharacterized protein', 271, NULL, NULL, 97526),
(97527, '3.40.50.150-FF-001262', NULL, NULL, 261, NULL, NULL, 97527),
(97528, '1.25.40.20-FF-000050', NULL, 'integrin-linked protein kinase', 174, NULL, NULL, 97528),
(97529, '3.40.1090.10-FF-000131', NULL, 'Uncharacterized protein', 122, NULL, NULL, 97529),
(97530, '3.30.60.20-FF-000034', NULL, 'Protein kinase C', 59, NULL, NULL, 97530),
(97531, '3.30.420.40-FF-000478', NULL, 'Carbohydrate kinase', 233, NULL, NULL, 97531),
(97532, '1.20.1280.20-FF-000025', NULL, 'Uncharacterized protein', 79, NULL, NULL, 97532),
(97533, '3.30.160.60-FF-003032', NULL, 'Uncharacterized protein', 24, NULL, NULL, 97533),
(97534, '1.25.40.10-FF-003239', NULL, 'Uncharacterized protein', 185, NULL, NULL, 97534),
(97535, '1.20.1310.20-FF-000023', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 252, NULL, NULL, 97535),
(97536, '1.20.1310.10-FF-000110', NULL, NULL, 35, NULL, NULL, 97536),
(97537, '1.10.357.50-FF-000025', NULL, 'Uncharacterized protein', 181, NULL, NULL, 97537),
(97538, '3.30.450.20-FF-000625', NULL, 'Uncharacterized protein', 61, NULL, NULL, 97538),
(97539, '4.10.1240.10-FF-000065', NULL, 'Adhesion G protein-coupled receptor L3', 58, NULL, NULL, 97539),
(97540, '3.30.530.20-FF-000154', NULL, 'Predicted protein', 150, NULL, NULL, 97540),
(97541, '2.30.30.210-FF-000012', NULL, 'Ribonuclease P protein subunit p29', 106, NULL, NULL, 97541),
(97542, '3.90.190.10-FF-000566', NULL, 'Uncharacterized protein', 68, NULL, NULL, 97542),
(97543, '3.30.420.40-FF-000663', NULL, 'Uncharacterized protein', 71, NULL, NULL, 97543),
(97544, '1.25.40.20-FF-001887', NULL, 'Os11g0435300 protein', 52, NULL, NULL, 97544),
(97545, '1.10.630.10-FF-000744', NULL, 'Uncharacterized protein', 80, NULL, NULL, 97545),
(97546, '2.60.510.10-FF-000001', NULL, 'Matrix protein VP40', 111, NULL, NULL, 97546),
(97547, '3.40.50.140-FF-000005', NULL, 'DNA topoisomerase', 166, NULL, NULL, 97547),
(97548, '1.10.3380.30-FF-000044', NULL, 'Uncharacterized protein', 55, NULL, NULL, 97548),
(97549, '3.30.70.330-FF-000209', NULL, 'U2 small nuclear ribonucleoprotein auxiliary factor 35 kDa subunit-related protein 2', 104, NULL, NULL, 97549),
(97550, '3.40.50.300-FF-001796', NULL, 'ATP-dependent DNA helicase PIF1', 224, NULL, NULL, 97550),
(97551, '3.30.50.10-FF-000064', NULL, 'GATA transcription factor', 71, NULL, NULL, 97551),
(97552, '2.130.10.10-FF-002690', NULL, 'Putative WD-repeat family protein', 332, NULL, NULL, 97552),
(97553, '3.30.470.30-FF-000045', NULL, 'mRNA-capping enzyme', 115, NULL, NULL, 97553),
(97554, '1.10.1420.10-FF-000070', NULL, 'DNA mismatch repair protein mutS, putative', 219, NULL, NULL, 97554),
(97555, '3.20.20.70-FF-000783', NULL, NULL, 73, NULL, NULL, 97555),
(97556, '3.40.50.410-FF-000053', NULL, 'von Willebrand factor', 181, NULL, NULL, 97556);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(97557, '3.40.50.150-FF-000278', NULL, 'Coactivator-associated arginine methyltransferase 1', 169, NULL, NULL, 97557),
(97558, '3.90.550.10-FF-000577', NULL, 'Predicted protein', 273, NULL, NULL, 97558),
(97559, '3.60.40.10-FF-000287', NULL, 'Stage II sporulation E family protein', 245, NULL, NULL, 97559),
(97560, '2.10.25.10-FF-000868', NULL, 'Transmembrane matrix receptor MUP-4', 45, NULL, NULL, 97560),
(97561, '3.90.1410.10-FF-000145', NULL, 'N-lysine methyltransferase SETD6', 277, NULL, NULL, 97561),
(97562, '3.80.10.10-FF-002482', NULL, 'Uncharacterized protein', 76, NULL, NULL, 97562),
(97563, '3.40.50.300-FF-000784', NULL, 'ATP-dependent RNA helicase DDX54', 161, NULL, NULL, 97563),
(97564, '3.40.50.11350-FF-000039', NULL, 'Predicted protein', 222, NULL, NULL, 97564),
(97565, '1.20.1050.10-FF-000067', NULL, 'Uncharacterized protein', 152, NULL, NULL, 97565),
(97566, '2.60.40.10-FF-001582', NULL, 'Receptor tyrosine kinase Flt1b', 97, NULL, NULL, 97566),
(97567, '3.30.160.60-FF-000598', NULL, 'zinc finger protein 692 isoform X2', 29, NULL, NULL, 97567),
(97568, '1.20.1530.20-FF-000011', NULL, 'K(+) efflux antiporter 3, chloroplastic', 400, NULL, NULL, 97568),
(97569, '3.40.50.300-FF-005983', NULL, '26S protease regulatory subunit, putative', 49, NULL, NULL, 97569),
(97570, '1.10.10.10-FF-000505', NULL, 'Forkhead box R1', 110, NULL, NULL, 97570),
(97571, '3.40.640.10-FF-000106', NULL, 'Cysteine desulfurase IscS', 246, NULL, NULL, 97571),
(97572, '3.30.1330.10-FF-000034', NULL, 'AGAP011375-PA', 88, NULL, NULL, 97572),
(97573, '3.20.20.100-FF-000133', NULL, 'LOC100127714 protein', 172, NULL, NULL, 97573),
(97574, '3.50.50.60-FF-000044', NULL, 'N-methyl-L-tryptophan oxidase', 160, NULL, NULL, 97574),
(97575, '2.130.10.10-FF-000273', NULL, 'WD repeat domain-containing protein 83', 295, NULL, NULL, 97575),
(97576, '2.120.10.80-FF-000007', NULL, 'F-box/kelch-repeat protein SKIP11', 280, NULL, NULL, 97576),
(97577, '4.10.830.40-FF-000009', NULL, 'Tripartite motif-containing 25', 64, NULL, NULL, 97577),
(97578, '3.90.79.10-FF-000184', NULL, 'NUDIX family hydrolase', 189, NULL, NULL, 97578),
(97579, '3.40.30.10-FF-000916', NULL, 'Peroxiredoxin-2', 127, NULL, NULL, 97579),
(97580, '2.70.50.30-FF-000025', NULL, NULL, 130, NULL, NULL, 97580),
(97581, '3.30.160.60-FF-004049', NULL, NULL, 22, NULL, NULL, 97581),
(97582, '3.30.740.10-FF-000015', NULL, 'Dynein light chain', 89, NULL, NULL, 97582),
(97583, '1.20.5.730-FF-000014', NULL, 'Rabaptin, RAB GTPase binding effector protein 1', 45, NULL, NULL, 97583),
(97584, '3.50.50.60-FF-000100', NULL, 'Flavin-containing monooxygenase', 379, NULL, NULL, 97584),
(97585, '1.10.287.470-FF-000044', NULL, 'Probable RND efflux membrane fusion protein', 74, NULL, NULL, 97585),
(97586, '1.20.1080.10-FF-000131', NULL, 'Aquaporin PIP1-6', 53, NULL, NULL, 97586),
(97587, '1.25.40.10-FF-002194', NULL, 'HTH-type transcriptional regulator MalT', 373, NULL, NULL, 97587),
(97588, '2.30.30.770-FF-000011', NULL, NULL, 111, NULL, NULL, 97588),
(97589, '2.120.10.60-FF-000001', NULL, 'Tricorn protease homolog', 270, NULL, NULL, 97589),
(97590, '1.25.40.10-FF-001682', NULL, 'Pentatricopeptide repeat-containing protein At5g42310, chloroplastic', 122, NULL, NULL, 97590),
(97591, '2.60.40.10-FF-001874', NULL, '1,4-alpha-glucan-branching enzyme', 113, NULL, NULL, 97591),
(97592, '3.30.420.10-FF-000648', NULL, NULL, 132, NULL, NULL, 97592),
(97593, '3.30.310.50-FF-000006', NULL, 'Phosphoglucosamine mutase', 82, NULL, NULL, 97593),
(97594, '3.40.50.300-FF-005455', NULL, 'ATPase involved in DNA repair', 239, NULL, NULL, 97594),
(97595, '3.30.450.20-FF-000592', NULL, 'PHOTB3 phototropin blue light photoreceptor', 169, NULL, NULL, 97595),
(97596, '1.10.443.10-FF-000011', NULL, 'Site-specific integrase', 215, NULL, NULL, 97596),
(97597, '1.20.1070.10-FF-000630', NULL, 'NeuroPeptide Receptor family', 361, NULL, NULL, 97597),
(97598, '1.25.40.10-FF-001210', NULL, 'Pentatricopeptide repeat-containing protein', 209, NULL, NULL, 97598),
(97599, '1.10.510.10-FF-003383', NULL, NULL, 320, NULL, NULL, 97599);
INSERT INTO "PUBLIC"."MODEL" VALUES
(97600, '1.10.3730.20-FF-000052', NULL, 'DMT family transporter', 131, NULL, NULL, 97600),
(97601, '3.40.50.80-FF-000247', NULL, 'NADPH oxidase 4', 61, NULL, NULL, 97601),
(97602, '1.20.1250.20-FF-000260', NULL, 'Major facilitator superfamily domain containing 2B', 214, NULL, NULL, 97602),
(97603, '2.30.29.30-FF-000096', NULL, 'IQ motif and SEC7 domain-containing protein 3', 140, NULL, NULL, 97603),
(97604, '3.70.10.10-FF-000054', NULL, 'DNA polymerase processivity factor', 291, NULL, NULL, 97604),
(97605, '1.25.40.10-FF-004931', NULL, 'Uncharacterized protein', 348, NULL, NULL, 97605),
(97606, '3.30.160.60-FF-006090', NULL, NULL, 63, NULL, NULL, 97606),
(97607, '1.50.40.10-FF-000449', NULL, 'Uncharacterized protein', 129, NULL, NULL, 97607),
(97608, '1.10.357.70-FF-000036', NULL, 'Uncharacterized protein', 75, NULL, NULL, 97608),
(97609, '2.160.20.70-FF-000003', NULL, 'Probable septum site-determining protein MinC', 125, NULL, NULL, 97609),
(97610, '1.50.40.10-FF-000505', NULL, 'Uncharacterized protein', 250, NULL, NULL, 97610),
(97611, '1.20.1410.10-FF-000022', NULL, 'transmembrane protein 98', 170, NULL, NULL, 97611),
(97612, '1.10.10.790-FF-000010', NULL, 'SURP and G-patch domain-containing protein 2', 64, NULL, NULL, 97612),
(97613, '3.40.1360.10-FF-000056', NULL, 'Uncharacterized protein', 113, NULL, NULL, 97613),
(97614, '3.40.50.1240-FF-000121', NULL, 'Uncharacterized protein', 238, NULL, NULL, 97614),
(97615, '3.40.1110.10-FF-000448', NULL, NULL, 237, NULL, NULL, 97615),
(97616, '3.30.300.20-FF-000058', NULL, 'Probable transcription termination protein NusA', 55, NULL, NULL, 97616),
(97617, '1.10.287.610-FF-000013', NULL, 'DNA ligase', 70, NULL, NULL, 97617),
(97618, '3.40.1810.10-FF-000069', NULL, NULL, 85, NULL, NULL, 97618),
(97619, '2.60.40.10-FF-001930', NULL, 'FiLamiN (Actin binding protein) homolog', 87, NULL, NULL, 97619),
(97620, '3.30.450.40-FF-000159', NULL, 'Two-component system sensor histidine kinase/response regulator', 161, NULL, NULL, 97620),
(97621, '1.10.565.10-FF-000209', NULL, 'Retinoic acid receptor alpha protein', 128, NULL, NULL, 97621),
(97622, '3.90.190.10-FF-000622', NULL, 'Uncharacterized protein', 58, NULL, NULL, 97622),
(97623, '3.40.50.2020-FF-000170', NULL, 'Uncharacterized protein', 99, NULL, NULL, 97623),
(97624, '1.10.8.210-FF-000001', NULL, 'Siroheme synthase', 61, NULL, NULL, 97624),
(97625, '3.10.20.10-FF-000041', NULL, 'Uncharacterized protein', 86, NULL, NULL, 97625),
(97626, '3.50.30.30-FF-000085', NULL, 'Subtilisin-like protease SBT4.1', 149, NULL, NULL, 97626),
(97627, '3.10.120.10-FF-000001', NULL, 'Cytochrome b5 reductase 4', 83, NULL, NULL, 97627),
(97628, '3.30.50.10-FF-000148', NULL, 'Predicted protein', 51, NULL, NULL, 97628),
(97629, '3.40.190.10-FF-000055', NULL, 'Phosphate ABC transporter, phosphate-binding protein', 115, NULL, NULL, 97629),
(97630, '2.80.10.50-FF-000208', NULL, 'Uncharacterized protein', 139, NULL, NULL, 97630),
(97631, '1.20.5.190-FF-000009', NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', 51, NULL, NULL, 97631),
(97632, '2.40.440.10-FF-000016', NULL, 'Murein L,D-transpeptidase', 138, NULL, NULL, 97632),
(97633, '1.20.1110.10-FF-000185', NULL, NULL, 188, NULL, NULL, 97633),
(97634, '3.30.160.60-FF-006197', NULL, NULL, 50, NULL, NULL, 97634),
(97635, '2.30.110.10-FF-000112', NULL, 'Putative reductase', 186, NULL, NULL, 97635),
(97636, '3.60.40.10-FF-000343', NULL, 'Uncharacterized protein', 123, NULL, NULL, 97636),
(97637, '2.30.140.30-FF-000002', NULL, 'Serine-type D-Ala-D-Ala carboxypeptidase', 84, NULL, NULL, 97637),
(97638, '3.30.160.60-FF-003976', NULL, NULL, 24, NULL, NULL, 97638),
(97639, '2.60.40.2150-FF-000002', NULL, 'Interleukin 17 receptor A', 105, NULL, NULL, 97639),
(97640, '3.90.640.90-FF-000006', NULL, 'Protein BTG1', 119, NULL, NULL, 97640),
(97641, '1.10.860.10-FF-000025', NULL, 'Replicative DNA helicase', 128, NULL, NULL, 97641),
(97642, '1.10.150.240-FF-000004', NULL, '2-deoxyglucose-6-phosphate phosphatase YniC', 72, NULL, NULL, 97642),
(97643, '3.20.20.70-FF-000816', NULL, NULL, 210, NULL, NULL, 97643);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(97644, '1.10.238.10-FF-000169', NULL, 'Calcium-dependent protein kinase 28', 90, NULL, NULL, 97644),
(97645, '3.40.605.10-FF-000031', NULL, 'Phenylacetic acid degradation protein PaaN', 237, NULL, NULL, 97645),
(97646, '3.30.70.1230-FF-000250', NULL, 'Blr6052 protein', 197, NULL, NULL, 97646),
(97647, '3.20.140.10-FF-000039', NULL, 'Nicotinate phosphoribosyltransferase', 152, NULL, NULL, 97647),
(97648, '3.30.160.60-FF-005741', NULL, NULL, 52, NULL, NULL, 97648),
(97649, '3.10.20.90-FF-000643', NULL, 'Predicted protein', 61, NULL, NULL, 97649),
(97650, '3.40.50.720-FF-001371', NULL, 'UDP-galactopyranose mutase Glf', 95, NULL, NULL, 97650),
(97651, '1.20.120.1070-FF-000010', NULL, 'Uncharacterized protein', 104, NULL, NULL, 97651),
(97652, '3.40.50.300-FF-007164', NULL, 'Uncharacterized protein', 174, NULL, NULL, 97652),
(97653, '3.30.1370.10-FF-000155', NULL, 'RNA-binding KH domain-containing protein', 92, NULL, NULL, 97653),
(97654, '3.40.50.2300-FF-001288', NULL, NULL, 148, NULL, NULL, 97654),
(97655, '1.10.287.130-FF-000111', NULL, 'Two-component sensor histidine kinase', 135, NULL, NULL, 97655),
(97656, '2.60.40.10-FF-003583', NULL, NULL, 97, NULL, NULL, 97656),
(97657, '3.30.200.20-FF-000017', NULL, 'Non-specific serine/threonine protein kinase', 147, NULL, NULL, 97657),
(97658, '3.40.630.30-FF-000674', NULL, 'Uncharacterized protein', 145, NULL, NULL, 97658),
(97659, '2.130.10.10-FF-004488', NULL, 'Uncharacterized protein', 203, NULL, NULL, 97659),
(97660, '3.30.1390.10-FF-000010', NULL, 'E3 ubiquitin-protein ligase ubr-1', 99, NULL, NULL, 97660),
(97661, '2.60.40.10-FF-000238', NULL, 'Neuronal cell adhesion molecule', 91, NULL, NULL, 97661),
(97662, '1.25.40.180-FF-000267', NULL, NULL, 208, NULL, NULL, 97662),
(97663, '1.25.40.20-FF-001270', NULL, 'Uncharacterized protein', 193, NULL, NULL, 97663),
(97664, '3.30.1360.120-FF-000002', NULL, 'Aminomethyltransferase', 139, NULL, NULL, 97664),
(97665, '3.80.10.10-FF-004191', NULL, 'Predicted protein', 92, NULL, NULL, 97665),
(97666, '3.30.310.80-FF-000021', NULL, 'Non-specific serine/threonine protein kinase', 174, NULL, NULL, 97666),
(97667, '2.10.25.10-FF-001537', NULL, 'Delta-like protein', 36, NULL, NULL, 97667),
(97668, '1.20.1280.50-FF-000192', NULL, 'LOC100145161 protein', 49, NULL, NULL, 97668),
(97669, '1.20.1560.10-FF-000589', NULL, 'p-glycoprotein', 646, NULL, NULL, 97669),
(97670, '2.60.40.10-FF-005617', NULL, NULL, 100, NULL, NULL, 97670),
(97671, '1.20.1250.20-FF-002058', NULL, 'Uncharacterized protein', 301, NULL, NULL, 97671),
(97672, '3.40.50.200-FF-000136', NULL, 'Uncharacterized protein', 97, NULL, NULL, 97672),
(97673, '1.20.58.60-FF-000129', NULL, 'Dystrophin', 113, NULL, NULL, 97673),
(97674, '1.10.287.1490-FF-000098', NULL, 'Viral A-type inclusion protein, putative', 180, NULL, NULL, 97674),
(97675, '2.60.40.60-FF-000259', NULL, 'cadherin-86C isoform X3', 116, NULL, NULL, 97675),
(97676, '2.170.270.10-FF-000107', NULL, 'N-lysine methyltransferase KMT5A-B', 235, NULL, NULL, 97676),
(97677, '2.40.30.220-FF-000001', NULL, 'Photosystem II reaction center Psb28 protein', 111, NULL, NULL, 97677),
(97678, '1.20.58.60-FF-000040', NULL, 'Short stop, isoform N', 109, NULL, NULL, 97678),
(97679, '3.10.100.10-FF-000258', NULL, NULL, 63, NULL, NULL, 97679),
(97680, '1.10.10.60-FF-000262', NULL, 'Zinc fingers and homeoboxes 1', 88, NULL, NULL, 97680),
(97681, '3.40.50.2000-FF-000540', NULL, 'Gll1176 protein', 170, NULL, NULL, 97681),
(97682, '1.10.287.70-FF-000295', NULL, 'Uncharacterized protein', 127, NULL, NULL, 97682),
(97683, '1.10.2020.20-FF-000020', NULL, NULL, 104, NULL, NULL, 97683),
(97684, '1.10.8.270-FF-000120', NULL, 'Uncharacterized protein', 156, NULL, NULL, 97684),
(97685, '3.90.79.10-FF-000240', NULL, 'Gll3262 protein', 180, NULL, NULL, 97685),
(97686, '2.60.120.260-FF-000256', NULL, 'Uncharacterized protein', 184, NULL, NULL, 97686),
(97687, '2.40.50.140-FF-001004', NULL, NULL, 56, NULL, NULL, 97687),
(97688, '3.30.230.80-FF-000020', NULL, 'Heat shock protein 90-2', 54, NULL, NULL, 97688),
(97689, '3.10.10.10-FF-000012', NULL, 'YALI0E34980p', 101, NULL, NULL, 97689); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(97690, '3.30.70.330-FF-000737', NULL, 'polyadenylate-binding protein RBP47 isoform X2', 135, NULL, NULL, 97690),
(97691, '3.40.720.10-FF-000107', NULL, 'Phosphatidylglycerol specific phospholipase, putative', 179, NULL, NULL, 97691),
(97692, '3.40.50.300-FF-002813', NULL, 'Cytochrome biosyntheisis ABC transporter ATP-binding protein/permease CydD', 218, NULL, NULL, 97692),
(97693, '2.60.40.1530-FF-000024', NULL, NULL, 120, NULL, NULL, 97693),
(97694, '1.10.287.1130-FF-000007', NULL, 'Cytochrome c oxidase copper chaperone COX17', 29, NULL, NULL, 97694),
(97695, '1.20.120.1760-FF-000065', NULL, NULL, 185, NULL, NULL, 97695),
(97696, '1.20.1280.140-FF-000002', NULL, 'Uncharacterized protein', 87, NULL, NULL, 97696),
(97697, '3.90.1750.10-FF-000075', NULL, 'Uncharacterized protein', 190, NULL, NULL, 97697),
(97698, '3.30.40.210-FF-000010', NULL, 'Transcription elongation factor SPT4', 104, NULL, NULL, 97698),
(97699, '1.20.920.30-FF-000045', NULL, 'Dynein heavy chain', 158, NULL, NULL, 97699),
(97700, '3.60.15.10-FF-000127', NULL, 'Beta-lactamase superfamily domain/DNA repair metallo-beta-lactamase, putative', 22, NULL, NULL, 97700),
(97701, '1.10.940.10-FF-000026', NULL, 'Transcription antitermination protein NusB', 136, NULL, NULL, 97701),
(97702, '3.40.50.720-FF-000966', NULL, 'Probable shikimate 5-dehydrogenase AroE (5-dehydroshikimate reductase)', 139, NULL, NULL, 97702),
(97703, '1.10.150.50-FF-000067', NULL, 'SAM and HD domain-containing deoxynucleoside triphosphate triphosphohydrolase 1', 62, NULL, NULL, 97703),
(97704, '1.10.246.10-FF-000008', NULL, 'Vitamin D-binding protein', 88, NULL, NULL, 97704),
(97705, '3.80.10.10-FF-001638', NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase At2g25790', 283, NULL, NULL, 97705),
(97706, '1.10.630.10-FF-000688', NULL, 'Uncharacterized protein', 149, NULL, NULL, 97706),
(97707, '2.160.20.10-FF-000300', NULL, 'Predicted protein', 110, NULL, NULL, 97707),
(97708, '2.40.50.140-FF-000223', NULL, 'Chromosome 1, whole genome shotgun sequence', 131, NULL, NULL, 97708),
(97709, '3.40.50.410-FF-000137', NULL, 'Integrator complex subunit 14', 179, NULL, NULL, 97709),
(97710, '3.20.80.10-FF-000061', NULL, 'Uncharacterized protein', 102, NULL, NULL, 97710),
(97711, '1.10.287.1490-FF-000154', NULL, 'Uncharacterized protein', 162, NULL, NULL, 97711),
(97712, '2.130.10.10-FF-002307', NULL, 'WD repeat protein ybl104c homologue, putative', 360, NULL, NULL, 97712),
(97713, '3.40.50.150-FF-000481', NULL, 'Os02g0158500 protein', 202, NULL, NULL, 97713),
(97714, '1.20.1050.10-FF-000303', NULL, 'Uncharacterized protein', 42, NULL, NULL, 97714),
(97715, '3.40.50.300-FF-000868', NULL, 'DEAD/DEAH box helicase, putative', 157, NULL, NULL, 97715),
(97716, '1.25.10.10-FF-002366', NULL, 'Uncharacterized protein', 278, NULL, NULL, 97716),
(97717, '1.10.287.1110-FF-000001', NULL, NULL, 33, NULL, NULL, 97717),
(97718, '2.60.40.10-FF-006022', NULL, NULL, 92, NULL, NULL, 97718),
(97719, '1.20.120.1900-FF-000034', NULL, 'Spindle pole body component', 332, NULL, NULL, 97719),
(97720, '1.25.40.20-FF-000903', NULL, 'Predicted ankyrin repeat family protein', 111, NULL, NULL, 97720),
(97721, '3.30.56.10-FF-000015', NULL, 'Phenylalanine--tRNA ligase beta subunit', 69, NULL, NULL, 97721),
(97722, '2.40.50.140-FF-000751', NULL, NULL, 92, NULL, NULL, 97722),
(97723, '3.40.1000.50-FF-000019', NULL, 'Repressor of RNA polymerase III transcription', 157, NULL, NULL, 97723),
(97724, '3.30.1680.10-FF-000021', NULL, 'Semaphorin 4C', 67, NULL, NULL, 97724),
(97725, '3.10.100.10-FF-000202', NULL, 'Uncharacterized protein', 150, NULL, NULL, 97725),
(97726, '1.10.10.10-FF-000185', NULL, 'Transcriptional adapter', 87, NULL, NULL, 97726),
(97727, '2.60.40.10-FF-000093', NULL, 'Down syndrome cell adhesion molecule, isoform B', 99, NULL, NULL, 97727),
(97728, '3.40.30.10-FF-000124', NULL, 'Thioredoxin domain-containing 17', 126, NULL, NULL, 97728),
(97729, '1.25.40.10-FF-004083', NULL, 'Alpha-soluble NSF attachment protein 1', 156, NULL, NULL, 97729),
(97730, '1.25.40.10-FF-002458', NULL, 'Intraflagellar transport protein 139', 139, NULL, NULL, 97730);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(97731, '3.30.110.110-FF-000007', NULL, 'Double-strand break repair protein', 111, NULL, NULL, 97731),
(97732, '2.60.40.10-FF-004364', NULL, NULL, 97, NULL, NULL, 97732),
(97733, '2.10.110.10-FF-000358', NULL, 'LIM domain-binding protein 3-like', 70, NULL, NULL, 97733),
(97734, '3.40.850.10-FF-000555', NULL, 'Myosin-K heavy chain', 132, NULL, NULL, 97734),
(97735, '3.40.525.10-FF-000030', NULL, 'CRAL/TRIO_-_N-terminal_domain/CRAL /TRIO_domain_containing_protein_-_putative', 253, NULL, NULL, 97735),
(97736, '1.10.540.10-FF-000006', NULL, 'Acyl-coenzyme A oxidase', 119, NULL, NULL, 97736),
(97737, '2.60.210.10-FF-000017', NULL, 'TNF receptor-associated factor', 193, NULL, NULL, 97737),
(97738, '3.50.40.10-FF-000012', NULL, 'Uncharacterized protein', 64, NULL, NULL, 97738),
(97739, '3.40.50.2000-FF-000484', NULL, 'Glycosyl transferase family 1', 207, NULL, NULL, 97739),
(97740, '3.40.50.720-FF-001219', NULL, 'NADP oxidoreductase coenzyme F420-dependent, putative', 155, NULL, NULL, 97740),
(97741, '2.30.30.380-FF-000017', NULL, 'Nei like DNA glycosylase 3', 47, NULL, NULL, 97741),
(97742, '3.40.30.10-FF-001052', NULL, 'At1g07080/F10K1_15', 181, NULL, NULL, 97742),
(97743, '3.30.70.580-FF-000054', NULL, 'tRNA pseudouridine synthase', 146, NULL, NULL, 97743),
(97744, '3.30.70.890-FF-000028', NULL, 'MeValonate Kinase', 55, NULL, NULL, 97744),
(97745, '2.40.160.10-FF-000034', NULL, 'Voltage-dependent anion-selective channel, putative', 286, NULL, NULL, 97745),
(97746, '1.20.5.580-FF-000003', NULL, 'Protein CBR-CPX-2', 46, NULL, NULL, 97746),
(97747, '3.30.160.60-FF-002251', NULL, 'Zinc finger protein 407 isoform 1', 28, NULL, NULL, 97747),
(97748, '2.40.30.10-FF-000014', NULL, 'Probable GTP-binding protein 1', 93, NULL, NULL, 97748),
(97749, '3.90.1150.10-FF-000523', NULL, 'Kynurenine aminotransferase 1', 54, NULL, NULL, 97749),
(97750, '3.30.200.20-FF-000489', NULL, 'Inactive receptor-like serine/threonine-protein kinase', 109, NULL, NULL, 97750),
(97751, '3.40.1350.10-FF-000027', NULL, 'tRNA-splicing endonuclease subunit Sen34', 34, NULL, NULL, 97751),
(97752, '3.30.160.60-FF-005685', NULL, NULL, 23, NULL, NULL, 97752),
(97753, '2.130.10.10-FF-005893', NULL, 'BEACH domain-containing protein lvsE', 294, NULL, NULL, 97753),
(97754, '2.60.15.10-FF-000017', NULL, 'ATP synthase epsilon chain', 127, NULL, NULL, 97754),
(97755, '2.60.98.60-FF-000004', NULL, NULL, 97, NULL, NULL, 97755),
(97756, '3.10.110.10-FF-000175', NULL, 'Ubiquitin-conjugating enzyme E2, putative', 151, NULL, NULL, 97756),
(97757, '1.10.238.200-FF-000021', NULL, 'Defective in cullin neddylation protein 1', 101, NULL, NULL, 97757),
(97758, '1.25.40.10-FF-004700', NULL, 'Uncharacterized protein', 99, NULL, NULL, 97758),
(97759, '1.10.246.130-FF-000006', NULL, 'Gamma-glutamyltranspeptidase', 105, NULL, NULL, 97759),
(97760, '1.20.120.1630-FF-000021', NULL, 'Polyprenol reductase 1', 187, NULL, NULL, 97760),
(97761, '3.80.10.10-FF-003263', NULL, 'Leucine-rich repeat protein (LRRP), putative', 282, NULL, NULL, 97761),
(97762, '3.40.1000.30-FF-000013', NULL, 'Expressed protein', 187, NULL, NULL, 97762),
(97763, '3.30.565.10-FF-000473', NULL, 'Two-component hybrid sensor and regulator', 154, NULL, NULL, 97763),
(97764, '2.60.40.150-FF-000146', NULL, 'E3 ubiquitin-protein ligase NEDD4 isoform X1', 109, NULL, NULL, 97764),
(97765, '2.60.40.10-FF-003111', NULL, 'Beta-glucosidase', 113, NULL, NULL, 97765),
(97766, '3.30.230.130-FF-000023', NULL, 'Protein CBR-CUL-2', 164, NULL, NULL, 97766),
(97767, '2.40.50.140-FF-000190', NULL, '30S ribosomal protein S1', 103, NULL, NULL, 97767),
(97768, '3.30.70.260-FF-000020', NULL, 'Aspartokinase 1', 75, NULL, NULL, 97768),
(97769, '1.20.1200.10-FF-000012', NULL, 'Uncharacterized protein', 94, NULL, NULL, 97769),
(97770, '3.90.550.10-FF-000285', NULL, 'Hypothetical glycosyl transferase', 224, NULL, NULL, 97770),
(97771, '1.10.287.110-FF-000189', NULL, 'Chaperone protein dnaJ', 85, NULL, NULL, 97771),
(97772, '3.40.50.720-FF-002203', NULL, 'Putative oxidoreductase', 307, NULL, NULL, 97772),
(97773, '1.10.760.10-FF-000080', NULL, 'Uncharacterized protein', 158, NULL, NULL, 97773); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(97774, '2.130.10.10-FF-001998', NULL, 'Predicted protein', 209, NULL, NULL, 97774),
(97775, '3.40.5.10-FF-000027', NULL, 'Probable 54S ribosomal protein L9, mitochondrial', 59, NULL, NULL, 97775),
(97776, '1.20.1070.10-FF-000102', NULL, 'neuropeptides B/W receptor type 1', 300, NULL, NULL, 97776),
(97777, '3.30.200.20-FF-002434', NULL, 'Non-specific serine/threonine protein kinase', 75, NULL, NULL, 97777),
(97778, '2.10.110.10-FF-000302', NULL, 'Uncharacterized protein', 57, NULL, NULL, 97778),
(97779, '3.30.160.60-FF-003324', NULL, NULL, 30, NULL, NULL, 97779),
(97780, '3.30.470.20-FF-000003', NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', 202, NULL, NULL, 97780),
(97781, '1.25.40.10-FF-000805', NULL, 'Pentatricopeptide repeat-containing protein', 100, NULL, NULL, 97781),
(97782, '2.30.29.30-FF-001349', NULL, 'Uncharacterized protein', 138, NULL, NULL, 97782),
(97783, '3.40.50.300-FF-006236', NULL, 'Predicted protein', 260, NULL, NULL, 97783),
(97784, '3.30.1320.10-FF-000005', NULL, '30S ribosomal protein S16', 87, NULL, NULL, 97784),
(97785, '3.30.830.10-FF-000314', NULL, 'Uncharacterized protein', 162, NULL, NULL, 97785),
(97786, '1.10.274.20-FF-000003', NULL, 'Phenylalanine aminomutase (L-beta-phenylalanine forming)', 119, NULL, NULL, 97786),
(97787, '1.25.40.20-FF-000342', NULL, 'Acyl-CoA binding domain containing 6', 42, NULL, NULL, 97787),
(97788, '2.30.42.10-FF-000351', NULL, 'ALP/Enigma encoding', 90, NULL, NULL, 97788),
(97789, '3.40.50.720-FF-002591', NULL, 'Uncharacterized protein', 59, NULL, NULL, 97789),
(97790, '2.30.29.30-FF-000949', NULL, 'Phosphoinositide phospholipase C', 117, NULL, NULL, 97790),
(97791, '3.90.1440.10-FF-000006', NULL, 'Protein translocase subunit SecA 2', 122, NULL, NULL, 97791),
(97792, '3.30.1120.10-FF-000024', NULL, 'Arylsulfatase', 61, NULL, NULL, 97792),
(97793, '2.60.40.10-FF-001166', NULL, 'Uncharacterized protein, isoform D', 109, NULL, NULL, 97793),
(97794, '2.60.40.180-FF-000009', NULL, '5-hydroxyisourate hydrolase', 114, NULL, NULL, 97794),
(97795, '3.30.413.10-FF-000031', NULL, 'Nitrite and sulphite reductase 4Fe-4S region', 78, NULL, NULL, 97795),
(97796, '1.10.533.10-FF-000041', NULL, 'Caspase 9', 102, NULL, NULL, 97796),
(97797, '1.10.10.60-FF-001279', NULL, NULL, 66, NULL, NULL, 97797),
(97798, '3.20.20.70-FF-000552', NULL, NULL, 164, NULL, NULL, 97798),
(97799, '1.10.1280.10-FF-000007', NULL, 'Polyphenol oxidase, chloroplastic', 341, NULL, NULL, 97799),
(97800, '3.30.505.10-FF-000025', NULL, 'Signal transducer and activator of transcription', 107, NULL, NULL, 97800),
(97801, '2.70.170.10-FF-000056', NULL, 'Ligand-Gated ion Channel', 197, NULL, NULL, 97801),
(97802, '3.30.420.40-FF-000247', NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase', 121, NULL, NULL, 97802),
(97803, '2.60.40.10-FF-000710', NULL, 'ADAMTS-like protein 1', 104, NULL, NULL, 97803),
(97804, '1.10.10.60-FF-000823', NULL, NULL, 46, NULL, NULL, 97804),
(97805, '3.30.310.200-FF-000001', NULL, 'Probable serine/threonine-protein kinase pats1', 106, NULL, NULL, 97805),
(97806, '1.10.287.70-FF-000328', NULL, 'Calcium-gated potassium channel protein, putative', 104, NULL, NULL, 97806),
(97807, '3.40.50.1010-FF-000198', NULL, NULL, 156, NULL, NULL, 97807),
(97808, '1.10.238.10-FF-000877', NULL, 'Serine/threonine-protein phosphatase', 178, NULL, NULL, 97808),
(97809, '3.30.70.330-FF-001850', NULL, NULL, 112, NULL, NULL, 97809),
(97810, '3.30.70.100-FF-000197', NULL, NULL, 110, NULL, NULL, 97810),
(97811, '1.10.238.10-FF-000933', NULL, 'Uncharacterized protein', 81, NULL, NULL, 97811),
(97812, '3.30.160.60-FF-004960', NULL, NULL, 82, NULL, NULL, 97812),
(97813, '3.40.50.300-FF-000020', NULL, 'Amino acid ABC transporter ATP-binding component', 241, NULL, NULL, 97813),
(97814, '3.30.200.20-FF-001130', NULL, 'Uncharacterized protein', 80, NULL, NULL, 97814),
(97815, '1.10.238.10-FF-000405', NULL, 'Polycystin 2 like 1, transient receptor potential cation channel', 45, NULL, NULL, 97815),
(97816, '1.20.1070.10-FF-001850', NULL, 'Vomeronasal type-1 receptor', 299, NULL, NULL, 97816);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(97817, '2.40.320.10-FF-000036', NULL, 'Uncharacterized protein', 116, NULL, NULL, 97817),
(97818, '1.10.238.10-FF-001153', NULL, 'Chromosome 13 SCAF14769, whole genome shotgun sequence', 123, NULL, NULL, 97818),
(97819, '3.30.565.10-FF-000288', NULL, 'Nitrogen regulation protein NR (II)', 157, NULL, NULL, 97819),
(97820, '1.20.1070.10-FF-001794', NULL, 'Uncharacterized protein', 321, NULL, NULL, 97820),
(97821, '3.40.50.10810-FF-000203', NULL, 'Uncharacterized protein', 153, NULL, NULL, 97821),
(97822, '2.20.25.90-FF-000004', NULL, 'Dimethyl sulfoxide reductase subunit A', 69, NULL, NULL, 97822),
(97823, '1.10.510.10-FF-004164', NULL, NULL, 190, NULL, NULL, 97823),
(97824, '1.20.58.390-FF-000013', NULL, 'Putative acetylcholine receptor subunit alpha', 124, NULL, NULL, 97824),
(97825, '1.50.40.10-FF-000269', NULL, 'Mitochondrial carrier protein', 310, NULL, NULL, 97825),
(97826, '2.40.110.10-FF-000031', NULL, 'Acyl-CoA dehydrogenase, putative', 127, NULL, NULL, 97826),
(97827, '2.40.10.10-FF-000400', NULL, NULL, 110, NULL, NULL, 97827),
(97828, '3.30.160.60-FF-003796', NULL, NULL, 33, NULL, NULL, 97828),
(97829, '3.30.70.330-FF-002070', NULL, NULL, 85, NULL, NULL, 97829),
(97830, '1.25.40.20-FF-000718', NULL, 'LOW QUALITY PROTEIN: SH3 and multiple ankyrin repeat domains protein 1', 96, NULL, NULL, 97830),
(97831, '3.40.50.10320-FF-000005', NULL, 'N-acetylglucosaminylphosphatidylinositol deacetylase, putative', 214, NULL, NULL, 97831),
(97832, '3.80.10.10-FF-003639', NULL, 'Predicted protein', 116, NULL, NULL, 97832),
(97833, '1.20.1070.10-FF-001647', NULL, 'Uncharacterized protein', 135, NULL, NULL, 97833),
(97834, '3.60.10.10-FF-000375', NULL, 'Phosphate transporter', 93, NULL, NULL, 97834),
(97835, '3.30.70.360-FF-000044', NULL, 'Putative amidohydrolase', 123, NULL, NULL, 97835),
(97836, '3.60.20.30-FF-000027', NULL, NULL, 137, NULL, NULL, 97836),
(97837, '1.10.1200.10-FF-000087', NULL, 'Nonribosomal peptide synthase SidC', 79, NULL, NULL, 97837),
(97838, '3.30.160.60-FF-003268', NULL, NULL, 30, NULL, NULL, 97838),
(97839, '2.40.240.10-FF-000035', NULL, 'Glutaminyl-tRNA synthetase, putative', 86, NULL, NULL, 97839),
(97840, '3.40.1380.20-FF-000004', NULL, 'Pyruvate kinase', 134, NULL, NULL, 97840),
(97841, '3.30.30.30-FF-000035', NULL, 'Heat shock protein 70, putative', 13, NULL, NULL, 97841),
(97842, '3.90.25.10-FF-000065', NULL, 'Uncharacterized protein', 90, NULL, NULL, 97842),
(97843, '4.10.400.10-FF-000148', NULL, 'low-density lipoprotein receptor-related protein 1B', 40, NULL, NULL, 97843),
(97844, '3.40.50.1820-FF-000143', NULL, 'Carboxypeptidase', 283, NULL, NULL, 97844),
(97845, '1.10.220.10-FF-000078', NULL, 'Uncharacterized protein', 86, NULL, NULL, 97845),
(97846, '1.20.58.60-FF-000096', NULL, 'Spectrin beta chain', 118, NULL, NULL, 97846),
(97847, '2.60.40.10-FF-002127', NULL, 'tyrosine-protein kinase-like otk', 91, NULL, NULL, 97847),
(97848, '2.60.40.150-FF-000798', NULL, 'Uncharacterized protein', 62, NULL, NULL, 97848),
(97849, '2.60.40.10-FF-002599', NULL, 'Titin homolog', 96, NULL, NULL, 97849),
(97850, '1.10.510.10-FF-000269', NULL, 'Serine/threonine-protein kinase 40', 196, NULL, NULL, 97850),
(97851, '3.90.70.10-FF-000372', NULL, 'Uncharacterized protein', 254, NULL, NULL, 97851),
(97852, '3.20.20.10-FF-000085', NULL, 'Uncharacterized protein', 86, NULL, NULL, 97852),
(97853, '3.40.50.620-FF-000054', NULL, 'Cytoplasmic tRNA 2-thiolation protein 1', 317, NULL, NULL, 97853),
(97854, '1.20.1070.10-FF-001703', NULL, 'Uncharacterized protein', 107, NULL, NULL, 97854),
(97855, '3.80.10.10-FF-001077', NULL, 'Tsukushin', 79, NULL, NULL, 97855),
(97856, '3.40.50.1400-FF-000045', NULL, 'Ferrochelatase', 77, NULL, NULL, 97856),
(97857, '1.25.40.10-FF-000569', NULL, 'Pentatricopeptide repeat-containing protein At1g15510, chloroplastic', 104, NULL, NULL, 97857),
(97858, '2.30.42.10-FF-000295', NULL, 'Alpha-1-syntrophin', 66, NULL, NULL, 97858),
(97859, '1.10.418.10-FF-000026', NULL, 'protein-methionine sulfoxide oxidase MICAL3 isoform X1', 114, NULL, NULL, 97859),
(97860, '3.40.30.10-FF-000068', NULL, 'ArsC family reductase', 117, NULL, NULL, 97860);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(97861, '1.20.1070.10-FF-000158', NULL, 'Neuropeptide Y receptor type 2', 331, NULL, NULL, 97861),
(97862, '3.40.50.300-FF-004235', NULL, 'Probable ATP-dependent helicase, putative', 169, NULL, NULL, 97862),
(97863, '1.25.10.10-FF-003327', NULL, 'Uncharacterized protein', 133, NULL, NULL, 97863),
(97864, '1.10.510.10-FF-000325', NULL, 'Casein kinase I isoform delta-like', 340, NULL, NULL, 97864),
(97865, '3.40.50.10190-FF-000096', NULL, 'DNA repair protein REV1', 89, NULL, NULL, 97865),
(97866, '2.40.100.10-FF-000002', NULL, 'Peptidyl-prolyl cis-trans isomerase', 173, NULL, NULL, 97866),
(97867, '1.20.1250.20-FF-000821', NULL, 'facilitated trehalose transporter Tret1', 453, NULL, NULL, 97867),
(97868, '3.40.50.1370-FF-000053', NULL, NULL, 163, NULL, NULL, 97868),
(97869, '3.40.50.300-FF-004382', NULL, 'Signal recognition particle receptor FtsY', 206, NULL, NULL, 97869),
(97870, '3.30.565.10-FF-000001', NULL, 'Heat shock protein HSP 90-alpha', 227, NULL, NULL, 97870),
(97871, '2.60.120.1190-FF-000017', NULL, 'Discoidin domain receptor, isoform D', 114, NULL, NULL, 97871),
(97872, '2.40.160.180-FF-000008', NULL, 'Carbohydrate porin', 378, NULL, NULL, 97872),
(97873, '3.30.160.60-FF-004757', NULL, NULL, 89, NULL, NULL, 97873),
(97874, '1.25.40.10-FF-002514', NULL, 'Major Facilitator Superfamily (MFS)', 215, NULL, NULL, 97874),
(97875, '3.30.70.330-FF-001518', NULL, 'Myelin expression factor 2', 157, NULL, NULL, 97875),
(97876, '3.40.190.10-FF-000616', NULL, 'ATP phosphoribosyltransferase', 106, NULL, NULL, 97876),
(97877, '2.10.25.10-FF-001032', NULL, 'AGAP003873-PA', 41, NULL, NULL, 97877),
(97878, '3.40.850.10-FF-000499', NULL, 'Uncharacterized protein', 33, NULL, NULL, 97878),
(97879, '3.10.180.10-FF-000033', NULL, 'Putative lyase', 134, NULL, NULL, 97879),
(97880, '1.10.132.60-FF-000023', NULL, 'Putative DNA polymerase zeta catalytic subunit', 172, NULL, NULL, 97880),
(97881, '2.30.180.10-FF-000173', NULL, NULL, 94, NULL, NULL, 97881),
(97882, '3.30.200.20-FF-000725', NULL, 'Protein kinase C', 115, NULL, NULL, 97882),
(97883, '3.40.50.300-FF-007872', NULL, 'Bll5958 protein', 206, NULL, NULL, 97883),
(97884, '1.10.10.60-FF-000970', NULL, NULL, 51, NULL, NULL, 97884),
(97885, '2.130.10.10-FF-000981', NULL, 'Uncharacterized protein, isoform B', 146, NULL, NULL, 97885),
(97886, '1.10.10.2660-FF-000015', NULL, 'Ubiquitin-conjugating enzyme E1', 283, NULL, NULL, 97886),
(97887, '3.40.367.20-FF-000047', NULL, 'Phosphotransferase', 150, NULL, NULL, 97887),
(97888, '2.60.120.200-FF-000406', NULL, 'AGRin (Synaptic protein) homolog', 194, NULL, NULL, 97888),
(97889, '3.30.710.10-FF-000098', NULL, 'Kelch-like family member 31', 145, NULL, NULL, 97889),
(97890, '1.20.120.1810-FF-000007', NULL, 'RNA polymerase sigma factor SigF', 104, NULL, NULL, 97890),
(97891, '3.30.200.20-FF-001506', NULL, 'Predicted protein', 85, NULL, NULL, 97891),
(97892, '3.40.50.300-FF-002493', NULL, 'Sulfate/thiosulfate import ATP-binding protein CysA', 240, NULL, NULL, 97892),
(97893, '1.20.810.10-FF-000025', NULL, 'Cytochrome b', 401, NULL, NULL, 97893),
(97894, '1.10.1070.11-FF-000122', NULL, 'mDNApk3'', putative', 157, NULL, NULL, 97894),
(97895, '2.30.29.30-FF-000332', NULL, 'arf-GAP with GTPase, ANK repeat and PH domain-containing protein 1 isoform X2', 98, NULL, NULL, 97895),
(97896, '1.20.1640.10-FF-000011', NULL, 'Dispatched RND transporter family member 1', 196, NULL, NULL, 97896),
(97897, '4.10.400.10-FF-000204', NULL, 'Putative low-density lipoprotein receptor', 40, NULL, NULL, 97897),
(97898, '3.10.20.770-FF-000015', NULL, 'phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit beta isoform-like isoform X1', 317, NULL, NULL, 97898),
(97899, '1.10.510.10-FF-004220', NULL, NULL, 209, NULL, NULL, 97899),
(97900, '1.10.510.10-FF-001814', NULL, 'Serine/threonine-protein kinase sel-5', 305, NULL, NULL, 97900),
(97901, '1.25.40.20-FF-000870', NULL, 'Ankyrin repeat domain-containing protein 50', 66, NULL, NULL, 97901),
(97902, '1.20.1720.10-FF-000012', NULL, 'MFS toxin efflux pump (AflT)', 246, NULL, NULL, 97902);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(97903, '1.10.287.110-FF-000369', NULL, 'YALI0E17303p', 123, NULL, NULL, 97903),
(97904, '3.40.50.2000-FF-000012', NULL, 'UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase 110 kDa subunit', 164, NULL, NULL, 97904),
(97905, '3.40.630.10-FF-000483', NULL, 'Aminoacyl-histidine dipeptidase', 113, NULL, NULL, 97905),
(97906, '3.90.760.10-FF-000003', NULL, 'Putative oxidoreductase', 69, NULL, NULL, 97906),
(97907, '3.40.630.30-FF-000527', NULL, 'Uncharacterized protein', 88, NULL, NULL, 97907),
(97908, '3.40.970.10-FF-000007', NULL, NULL, 49, NULL, NULL, 97908),
(97909, '3.40.50.1100-FF-000017', NULL, 'D-cysteine desulfhydrase', 109, NULL, NULL, 97909),
(97910, '3.40.50.1000-FF-000285', NULL, 'Tpp1p', 221, NULL, NULL, 97910),
(97911, '3.40.50.300-FF-008125', NULL, 'ATP-dependent DNA helicase', 105, NULL, NULL, 97911),
(97912, '1.20.1560.10-FF-000010', NULL, 'Multidrug resistance-associated ABC transporter', 329, NULL, NULL, 97912),
(97913, '1.10.510.10-FF-003759', NULL, NULL, 141, NULL, NULL, 97913),
(97914, '3.20.20.140-FF-000010', NULL, 'Membrane dipeptidase', 324, NULL, NULL, 97914),
(97915, '3.30.70.1010-FF-000004', NULL, NULL, 62, NULL, NULL, 97915),
(97916, '1.10.510.10-FF-000510', NULL, 'Inactive tyrosine-protein kinase PRAG1', 187, NULL, NULL, 97916),
(97917, '3.40.50.620-FF-000762', NULL, 'Uncharacterized protein', 127, NULL, NULL, 97917),
(97918, '2.60.450.20-FF-000004', NULL, 'Centromere protein J', 116, NULL, NULL, 97918),
(97919, '2.10.25.10-FF-000104', NULL, 'Fibulin-1', 41, NULL, NULL, 97919),
(97920, '1.25.40.20-FF-001123', NULL, 'Protein CBR-MIB-1', 195, NULL, NULL, 97920),
(97921, '2.130.10.10-FF-002779', NULL, 'Uncharacterized protein', 219, NULL, NULL, 97921),
(97922, '2.70.98.50-FF-000006', NULL, 'Glycoside hydrolase family 95', 74, NULL, NULL, 97922),
(97923, '3.40.50.880-FF-000025', NULL, 'Bifunctional pyrimidine biosynthesis protein', 217, NULL, NULL, 97923),
(97924, '2.40.50.140-FF-000695', NULL, 'Asparagine--tRNA ligase, cytoplasmic 3', 97, NULL, NULL, 97924),
(97925, '3.40.50.10330-FF-000065', NULL, 'NAD kinase', 88, NULL, NULL, 97925),
(97926, '3.50.50.60-FF-000623', NULL, 'Uncharacterized protein', 225, NULL, NULL, 97926),
(97927, '2.40.70.10-FF-000376', NULL, NULL, 198, NULL, NULL, 97927),
(97928, '3.90.1290.10-FF-000033', NULL, 'VAB-10A protein', 122, NULL, NULL, 97928),
(97929, '1.10.540.10-FF-000097', NULL, 'Uncharacterized protein', 128, NULL, NULL, 97929),
(97930, '1.10.3720.10-FF-000166', NULL, 'ABC transporter permease', 195, NULL, NULL, 97930),
(97931, '3.90.180.10-FF-000088', NULL, 'Probable quinone oxidoreductase', 162, NULL, NULL, 97931),
(97932, '2.20.28.200-FF-000008', NULL, 'NAD-dependent protein deacetylase sirtuin-6', 55, NULL, NULL, 97932),
(97933, '3.30.420.10-FF-000087', NULL, 'Exonuclease, putative', 201, NULL, NULL, 97933),
(97934, '3.40.50.10190-FF-000152', NULL, 'DNA ligase 3-like Protein', 92, NULL, NULL, 97934),
(97935, '3.40.630.10-FF-000336', NULL, 'Predicted protein', 176, NULL, NULL, 97935),
(97936, '1.10.8.870-FF-000019', NULL, 'Glycerol-3-phosphate dehydrogenase', 122, NULL, NULL, 97936),
(97937, '3.40.50.300-FF-003982', NULL, 'Guanylate kinase, putative', 30, NULL, NULL, 97937),
(97938, '3.30.160.60-FF-000542', NULL, 'Zinc finger and BTB domain-containing protein 26', 29, NULL, NULL, 97938),
(97939, '1.20.1250.20-FF-001602', NULL, 'MFS toxin efflux pump, putative', 237, NULL, NULL, 97939),
(97940, '3.20.20.70-FF-000496', NULL, 'Dihydroorotate oxidase', 325, NULL, NULL, 97940),
(97941, '3.30.70.920-FF-000055', NULL, 'Transcriptional regulator, AsnC family', 93, NULL, NULL, 97941),
(97942, '1.10.3210.10-FF-000083', NULL, 'Uncharacterized protein', 83, NULL, NULL, 97942),
(97943, '3.10.350.10-FF-000102', NULL, 'Gll1142 protein', 55, NULL, NULL, 97943),
(97944, '3.40.140.10-FF-000052', NULL, 'Eukaryotic translation initiation factor 3 subunit H', 216, NULL, NULL, 97944),
(97945, '1.25.40.20-FF-001831', NULL, 'Uncharacterized protein', 149, NULL, NULL, 97945),
(97946, '1.25.10.10-FF-003294', NULL, 'Non-specific serine/threonine protein kinase', 181, NULL, NULL, 97946);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(97947, '3.80.10.10-FF-001841', NULL, 'GM24816', 93, NULL, NULL, 97947),
(97948, '2.10.25.10-FF-000812', NULL, 'adhesion G protein-coupled receptor E1', 47, NULL, NULL, 97948),
(97949, '3.30.40.10-FF-001491', NULL, 'YALI0A19514p', 79, NULL, NULL, 97949),
(97950, '3.30.9.10-FF-000182', NULL, 'Putatibe oxidoreductase', 150, NULL, NULL, 97950),
(97951, '3.40.50.2300-FF-000040', NULL, 'DNA-binding transcriptional activator UhpA', 193, NULL, NULL, 97951),
(97952, '3.40.50.300-FF-008092', NULL, 'Predicted protein', 113, NULL, NULL, 97952),
(97953, '1.10.287.110-FF-000425', NULL, 'Uncharacterized protein', 89, NULL, NULL, 97953),
(97954, '2.130.10.10-FF-000306', NULL, '3-carboxymuconate cyclase', 349, NULL, NULL, 97954),
(97955, '3.75.10.10-FF-000050', NULL, NULL, 115, NULL, NULL, 97955),
(97956, '2.30.180.10-FF-000026', NULL, 'Stabilin 1', 141, NULL, NULL, 97956),
(97957, '3.90.550.10-FF-000521', NULL, 'Nucleotide-diphospho-sugar transferase', 249, NULL, NULL, 97957),
(97958, '2.10.50.30-FF-000039', NULL, 'Uncharacterized protein', 91, NULL, NULL, 97958),
(97959, '2.30.30.40-FF-000259', NULL, 'Protein BOI2', 65, NULL, NULL, 97959),
(97960, '3.20.20.210-FF-000019', NULL, 'Methylcobalamin:coenzyme M methyltransferase, methylamine-specific', 338, NULL, NULL, 97960),
(97961, '3.10.110.10-FF-000231', NULL, 'Uncharacterized protein', 259, NULL, NULL, 97961),
(97962, '3.10.20.90-FF-000463', NULL, 'Autophagy protein 5', 103, NULL, NULL, 97962),
(97963, '1.20.1270.60-FF-000076', NULL, 'Rho GTPase activating protein 42', 99, NULL, NULL, 97963),
(97964, '2.60.40.10-FF-002655', NULL, 'Roundabout-like protein 4', 114, NULL, NULL, 97964),
(97965, '1.25.40.10-FF-000193', NULL, 'protein sel-1 homolog 1 isoform X1', 256, NULL, NULL, 97965),
(97966, '3.50.30.30-FF-000141', NULL, 'Uncharacterized protein', 115, NULL, NULL, 97966),
(97967, '3.30.160.60-FF-005213', NULL, NULL, 54, NULL, NULL, 97967),
(97968, '3.80.10.10-FF-000857', NULL, 'Leucine rich repeat protein', 166, NULL, NULL, 97968),
(97969, '2.130.10.10-FF-004016', NULL, 'Uncharacterized protein', 223, NULL, NULL, 97969),
(97970, '3.40.50.1820-FF-001071', NULL, 'Carboxypeptidase', 299, NULL, NULL, 97970),
(97971, '1.20.1310.10-FF-000166', NULL, NULL, 106, NULL, NULL, 97971),
(97972, '3.30.160.60-FF-004813', NULL, NULL, 28, NULL, NULL, 97972),
(97973, '3.40.120.10-FF-000106', NULL, 'Uncharacterized protein', 86, NULL, NULL, 97973),
(97974, '3.40.50.170-FF-000020', NULL, 'Methionyl-tRNA formyltransferase', 203, NULL, NULL, 97974),
(97975, '3.30.460.10-FF-000117', NULL, 'Uncharacterized protein', 117, NULL, NULL, 97975),
(97976, '2.60.40.1660-FF-000012', NULL, 'Na+/K+ ATPase, Beta subunit', 292, NULL, NULL, 97976),
(97977, '2.30.30.550-FF-000001', NULL, 'major vault protein-like', 51, NULL, NULL, 97977),
(97978, '1.20.870.10-FF-000001', NULL, 'rap guanine nucleotide exchange factor 2 isoform X2', 119, NULL, NULL, 97978),
(97979, '1.25.10.10-FF-000421', NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit', 402, NULL, NULL, 97979),
(97980, '1.20.1250.20-FF-001041', NULL, 'Predicted protein', 160, NULL, NULL, 97980),
(97981, '2.60.40.1250-FF-000007', NULL, 'Thiol:disulfide interchange protein DsbD 1', 132, NULL, NULL, 97981),
(97982, '3.40.30.10-FF-000596', NULL, 'Thioredoxin', 118, NULL, NULL, 97982),
(97983, '3.30.1370.10-FF-000211', NULL, 'Uncharacterized protein', 30, NULL, NULL, 97983),
(97984, '2.130.10.10-FF-004201', NULL, 'Uncharacterized protein', 157, NULL, NULL, 97984),
(97985, '1.10.472.80-FF-000228', NULL, NULL, 152, NULL, NULL, 97985),
(97986, '3.90.1170.50-FF-000014', NULL, 'Aldehyde oxidase and xanthine dehydrogenase, a/b hammerhead domain', 92, NULL, NULL, 97986),
(97987, '3.30.160.60-FF-003829', NULL, 'Crooked legs, isoform H', 28, NULL, NULL, 97987),
(97988, '3.40.50.1820-FF-001632', NULL, 'Carboxylic ester hydrolase', 450, NULL, NULL, 97988),
(97989, '1.20.58.2050-FF-000009', NULL, 'GINS complex subunit 3', 89, NULL, NULL, 97989),
(97990, '2.60.40.10-FF-004600', NULL, NULL, 104, NULL, NULL, 97990),
(97991, '1.20.1070.10-FF-001086', NULL, 'Uncharacterized protein', 321, NULL, NULL, 97991);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(97992, '3.30.40.10-FF-001339', NULL, 'ATP-dependent chromatin assembly factor large subunit', 89, NULL, NULL, 97992),
(97993, '2.40.50.1070-FF-000008', NULL, '23S rRNA (uracil(747)-C(5))-methyltransferase', 146, NULL, NULL, 97993),
(97994, '3.90.70.10-FF-000748', NULL, 'Uncharacterized protein', 373, NULL, NULL, 97994),
(97995, '3.90.226.10-FF-000251', NULL, 'Enoyl-CoA hydratase/carnithine racemase', 112, NULL, NULL, 97995),
(97996, '3.80.10.10-FF-000149', NULL, 'NLR family member X1', 225, NULL, NULL, 97996),
(97997, '2.170.130.10-FF-000041', NULL, 'Hemin receptor', 123, NULL, NULL, 97997),
(97998, '3.90.70.10-FF-000225', NULL, 'Cysteine protease 15', 268, NULL, NULL, 97998),
(97999, '3.30.70.330-FF-002446', NULL, NULL, 86, NULL, NULL, 97999),
(98000, '3.30.160.60-FF-000918', NULL, 'Zinc finger protein', 29, NULL, NULL, 98000),
(98001, '3.40.630.30-FF-000494', NULL, 'Diamine acetyltransferase', 141, NULL, NULL, 98001),
(98002, '2.30.30.570-FF-000007', NULL, 'Uncharacterized protein', 51, NULL, NULL, 98002),
(98003, '2.60.120.330-FF-000209', NULL, 'Uncharacterized protein', 121, NULL, NULL, 98003),
(98004, '2.130.10.10-FF-004724', NULL, 'Uncharacterized protein', 166, NULL, NULL, 98004),
(98005, '1.10.10.10-FF-001674', NULL, 'Metal-dependent transcriptional regulator', 133, NULL, NULL, 98005),
(98006, '3.60.21.10-FF-000456', NULL, 'Putative 5''-nucleotidase', 230, NULL, NULL, 98006),
(98007, '3.40.50.12780-FF-000069', NULL, 'YOR093C-like protein', 349, NULL, NULL, 98007),
(98008, '1.10.238.10-FF-000225', NULL, 'Calpain-12', 167, NULL, NULL, 98008),
(98009, '3.40.50.1820-FF-000087', NULL, 'Gibberellin receptor GID1', 343, NULL, NULL, 98009),
(98010, '3.40.50.1240-FF-000065', NULL, 'Similar to histidine acid phosphatase', 372, NULL, NULL, 98010),
(98011, '1.10.10.10-FF-001489', NULL, 'Transcription factor E2F/dimerisation partner (TDP) family protein', 98, NULL, NULL, 98011),
(98012, '2.40.160.10-FF-000006', NULL, 'Translocase of outer mitochondrial membrane 40 like', 116, NULL, NULL, 98012),
(98013, '1.20.1720.10-FF-000124', NULL, NULL, 249, NULL, NULL, 98013),
(98014, '3.30.200.20-FF-000202', NULL, 'Serine/threonine-protein kinase 32B', 96, NULL, NULL, 98014),
(98015, '3.30.230.130-FF-000028', NULL, 'Cullin family protein', 153, NULL, NULL, 98015),
(98016, '3.40.50.720-FF-000994', NULL, 'Dehydrogenase', 248, NULL, NULL, 98016),
(98017, '3.40.50.450-FF-000014', NULL, 'ATP-dependent 6-phosphofructokinase', 225, NULL, NULL, 98017),
(98018, '3.90.1150.10-FF-000490', NULL, 'Alanine aminotransferase 2-like Protein', 16, NULL, NULL, 98018),
(98019, '3.40.20.10-FF-000062', NULL, 'Quail, isoform C', 125, NULL, NULL, 98019),
(98020, '1.20.120.1240-FF-000022', NULL, 'Dynamin-like GTPase Dnm1', 123, NULL, NULL, 98020),
(98021, '1.20.1250.20-FF-000057', NULL, 'MFS general substrate transporter', 208, NULL, NULL, 98021),
(98022, '3.30.559.10-FF-000088', NULL, 'Acyltransferase, WS/DGAT/MGAT', 161, NULL, NULL, 98022),
(98023, '3.30.160.20-FF-000114', NULL, 'Uncharacterized protein', 95, NULL, NULL, 98023),
(98024, '3.90.1150.210-FF-000026', NULL, 'F-actin-capping protein subunit beta', 95, NULL, NULL, 98024),
(98025, '3.40.800.10-FF-000024', NULL, 'Formimidoylglutamase', 293, NULL, NULL, 98025),
(98026, '3.40.50.1000-FF-000133', NULL, '5''(3'')-deoxyribonucleotidase, cytosolic type', 129, NULL, NULL, 98026),
(98027, '3.40.50.2300-FF-001001', NULL, NULL, 130, NULL, NULL, 98027),
(98028, '3.80.10.10-FF-002190', NULL, 'Toll-like receptor 22', 270, NULL, NULL, 98028),
(98029, '3.40.309.10-FF-000051', NULL, 'Aldehyde dehydrogenase', 195, NULL, NULL, 98029),
(98030, '1.10.238.10-FF-001041', NULL, 'Uncharacterized protein', 48, NULL, NULL, 98030),
(98031, '3.10.20.340-FF-000004', NULL, 'Arginine biosynthesis bifunctional protein ArgJ, mitochondrial', 157, NULL, NULL, 98031),
(98032, '3.90.550.50-FF-000162', NULL, 'Uncharacterized protein', 244, NULL, NULL, 98032),
(98033, '1.25.40.10-FF-004144', NULL, 'Uncharacterized protein', 114, NULL, NULL, 98033),
(98034, '1.10.510.10-FF-001578', NULL, 'Serine/threonine protein kinase', 260, NULL, NULL, 98034);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(98035, '1.10.238.10-FF-000517', NULL, 'Sodium/calcium exchanger family protein / calcium-binding EF hand family protein', 123, NULL, NULL, 98035),
(98036, '3.30.160.60-FF-004252', NULL, NULL, 26, NULL, NULL, 98036),
(98037, '1.10.10.1420-FF-000003', NULL, 'CDT1-like protein a chloroplastic', 131, NULL, NULL, 98037),
(98038, '3.40.30.10-FF-001136', NULL, 'Uncharacterized protein', 67, NULL, NULL, 98038),
(98039, '3.40.50.2000-FF-000512', NULL, 'Uncharacterized protein', 103, NULL, NULL, 98039),
(98040, '3.30.1050.10-FF-000024', NULL, 'Metallo-beta-lactamase superfamily protein', 128, NULL, NULL, 98040),
(98041, '2.30.29.30-FF-000388', NULL, 'von Willebrand RING finger domain-containing protein', 158, NULL, NULL, 98041),
(98042, '3.40.50.800-FF-000136', NULL, 'Prolyl Amino-acyl tRNA Synthetase', 85, NULL, NULL, 98042),
(98043, '1.10.8.270-FF-000148', NULL, 'Uncharacterized protein', 116, NULL, NULL, 98043),
(98044, '3.30.565.10-FF-000029', NULL, 'Sensor protein', 134, NULL, NULL, 98044),
(98045, '3.40.50.10070-FF-000003', NULL, 'Tol-Pal system protein TolB', 143, NULL, NULL, 98045),
(98046, '1.10.287.110-FF-000009', NULL, 'Auxilin-related protein 1', 130, NULL, NULL, 98046),
(98047, '3.80.10.10-FF-001633', NULL, 'Uncharacterized protein', 110, NULL, NULL, 98047),
(98048, '3.40.190.10-FF-000240', NULL, 'Glutamate receptor ionotropic, kainate 2', 105, NULL, NULL, 98048),
(98049, '3.40.30.10-FF-000568', NULL, 'GM26257', 94, NULL, NULL, 98049),
(98050, '2.30.42.10-FF-000323', NULL, 'Leucine-rich repeat-containing protein', 120, NULL, NULL, 98050),
(98051, '2.10.25.10-FF-001296', NULL, 'Integrin beta', 59, NULL, NULL, 98051),
(98052, '3.30.420.40-FF-000371', NULL, 'Ribosomal-protein-alanine acetyltransferase rimI', 135, NULL, NULL, 98052),
(98053, '3.10.180.10-FF-000089', NULL, '4-hydroxyphenylpyruvate dioxygenase', 136, NULL, NULL, 98053),
(98054, '1.10.287.550-FF-000006', NULL, 'Steroid sulfatase (microsomal), isozyme S', 56, NULL, NULL, 98054),
(98055, '3.40.50.150-FF-000126', NULL, 'Polyamine aminopropyltransferase', 228, NULL, NULL, 98055),
(98056, '2.60.120.10-FF-000393', NULL, 'Mannose-6-phosphate isomerase', 155, NULL, NULL, 98056),
(98057, '2.60.40.1460-FF-000008', NULL, 'Integrin subunit alpha 10', 146, NULL, NULL, 98057),
(98058, '3.80.10.10-FF-000205', NULL, 'Podocan', 72, NULL, NULL, 98058),
(98059, '3.40.50.10090-FF-000009', NULL, 'Uroporphyrinogen-III synthase, chloroplastic', 108, NULL, NULL, 98059),
(98060, '3.30.200.20-FF-001681', NULL, 'Uncharacterized protein', 77, NULL, NULL, 98060),
(98061, '1.50.40.10-FF-000157', NULL, 'ADP/ATP carrier', 296, NULL, NULL, 98061),
(98062, '3.40.1190.20-FF-000169', NULL, 'Multifunctional fusion protein', 312, NULL, NULL, 98062),
(98063, '3.10.580.10-FF-000086', NULL, 'Protein MAM3, putative', 154, NULL, NULL, 98063),
(98064, '1.20.1740.10-FF-000075', NULL, 'Amino acid permease', 473, NULL, NULL, 98064),
(98065, '2.60.40.10-FF-002239', NULL, 'Adhesion G protein-coupled receptor F5', 101, NULL, NULL, 98065),
(98066, '3.40.50.450-FF-000065', NULL, 'Phosphofructokinase, platelet', 101, NULL, NULL, 98066),
(98067, '3.30.70.1130-FF-000006', NULL, 'Eukaryotic translation initiation factor 2 alpha subunit, putative', 113, NULL, NULL, 98067),
(98068, '1.20.1250.20-FF-001097', NULL, 'GM15184', 445, NULL, NULL, 98068),
(98069, '2.60.40.10-FF-003667', NULL, NULL, 101, NULL, NULL, 98069),
(98070, '3.80.10.10-FF-000677', NULL, 'Si:dkey-205i10.1', 102, NULL, NULL, 98070),
(98071, '3.30.230.130-FF-000079', NULL, 'Uncharacterized protein', 142, NULL, NULL, 98071),
(98072, '1.20.80.10-FF-000054', NULL, 'Acyl-CoA-binding domain-containing protein 4', 66, NULL, NULL, 98072),
(98073, '3.10.20.90-FF-000351', NULL, 'Cell division control protein 24', 91, NULL, NULL, 98073),
(98074, '3.30.160.20-FF-000165', NULL, 'Uncharacterized protein', 99, NULL, NULL, 98074),
(98075, '1.25.70.10-FF-000009', NULL, 'BnaA09g42960D protein', 232, NULL, NULL, 98075),
(98076, '2.60.40.10-FF-000441', NULL, 'TEK receptor tyrosine kinase', 99, NULL, NULL, 98076),
(98077, '3.90.70.10-FF-000192', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 321, NULL, NULL, 98077);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(98078, '3.20.20.190-FF-000176', NULL, NULL, 318, NULL, NULL, 98078),
(98079, '3.40.630.10-FF-000224', NULL, 'Clan MH, family M18, aspartyl aminopeptidase-like metallopeptidase', 73, NULL, NULL, 98079),
(98080, '3.40.50.11840-FF-000006', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 2', 95, NULL, NULL, 98080),
(98081, '3.30.870.10-FF-000194', NULL, 'Uncharacterized protein', 60, NULL, NULL, 98081),
(98082, '1.20.1250.20-FF-001046', NULL, 'Peptide transporter family 1-like Protein', 134, NULL, NULL, 98082),
(98083, '2.70.98.30-FF-000028', NULL, 'Lysosomal alpha-mannosidase, putative', 167, NULL, NULL, 98083),
(98084, '2.70.98.10-FF-000040', NULL, 'Aldose 1-epimerase (Mutarotase)', 331, NULL, NULL, 98084),
(98085, '3.40.50.300-FF-001037', NULL, 'DNA repair protein RAD50', 296, NULL, NULL, 98085),
(98086, '3.40.50.300-FF-002465', NULL, 'ATP-dependent DNA helicase RecQ', 134, NULL, NULL, 98086),
(98087, '3.50.50.60-FF-000191', NULL, 'Monooxygenase ethA', 89, NULL, NULL, 98087),
(98088, '2.40.70.10-FF-000432', NULL, NULL, 106, NULL, NULL, 98088),
(98089, '1.10.287.70-FF-000587', NULL, 'Uncharacterized protein', 153, NULL, NULL, 98089),
(98090, '1.20.1050.20-FF-000008', NULL, 'Signal transducer and activator of transcription', 163, NULL, NULL, 98090),
(98091, '1.25.40.10-FF-001289', NULL, 'Putative pentatricopeptide (PPR) repeat-containing protein', 94, NULL, NULL, 98091),
(98092, '3.30.70.1180-FF-000009', NULL, 'V-type proton ATPase subunit C', 65, NULL, NULL, 98092),
(98093, '3.30.160.60-FF-003212', NULL, 'Zinc finger protein 367', 32, NULL, NULL, 98093),
(98094, '1.20.1070.10-FF-000282', NULL, 'Dopamine receptor 2', 329, NULL, NULL, 98094),
(98095, '3.30.160.60-FF-002695', NULL, 'AGAP001987-PA', 70, NULL, NULL, 98095),
(98096, '2.10.25.10-FF-001245', NULL, 'Delta-like protein', 41, NULL, NULL, 98096),
(98097, '3.30.200.20-FF-001630', NULL, 'Uncharacterized protein', 94, NULL, NULL, 98097),
(98098, '1.10.510.10-FF-003091', NULL, NULL, 198, NULL, NULL, 98098),
(98099, '3.40.50.300-FF-004022', NULL, 'Uncharacterized protein', 141, NULL, NULL, 98099),
(98100, '2.120.10.30-FF-000341', NULL, 'Peptidase S9 family protein', 186, NULL, NULL, 98100),
(98101, '2.30.30.40-FF-000411', NULL, 'Cell death abnormality protein 2', 74, NULL, NULL, 98101),
(98102, '1.10.510.10-FF-002534', NULL, 'Putative serine/threonine-protein kinase', 310, NULL, NULL, 98102),
(98103, '3.30.830.10-FF-000230', NULL, 'Insulin degrading enzyme', 50, NULL, NULL, 98103),
(98104, '2.60.40.60-FF-000444', NULL, 'Cadherin-99C', 118, NULL, NULL, 98104),
(98105, '3.80.10.10-FF-003819', NULL, 'Uncharacterized protein', 77, NULL, NULL, 98105),
(98106, '1.20.200.10-FF-000030', NULL, 'Uncharacterized protein', 37, NULL, NULL, 98106),
(98107, '3.40.630.30-FF-000382', NULL, 'Protein CBG11814', 152, NULL, NULL, 98107),
(98108, '2.10.60.10-FF-000085', NULL, 'Uncharacterized protein', 52, NULL, NULL, 98108),
(98109, '1.10.10.10-FF-001882', NULL, 'Uncharacterized protein', 37, NULL, NULL, 98109),
(98110, '1.10.437.10-FF-000042', NULL, 'Uncharacterized protein', 162, NULL, NULL, 98110),
(98111, '1.10.3380.20-FF-000007', NULL, 'HELicase Q homolog', 180, NULL, NULL, 98111),
(98112, '1.25.10.10-FF-002130', NULL, 'Uncharacterized protein', 245, NULL, NULL, 98112),
(98113, '1.25.10.10-FF-000213', NULL, 'Rotatin', 235, NULL, NULL, 98113),
(98114, '3.90.226.10-FF-000043', NULL, 'carboxyl-terminal-processing peptidase 2, chloroplastic', 164, NULL, NULL, 98114),
(98115, '1.10.287.130-FF-000116', NULL, 'Sensor histidine kinase', 71, NULL, NULL, 98115),
(98116, '3.30.40.10-FF-001075', NULL, 'GM25045', 72, NULL, NULL, 98116),
(98117, '3.40.250.10-FF-000178', NULL, 'Sulfurtransferase', 160, NULL, NULL, 98117),
(98118, '2.160.20.10-FF-000120', NULL, 'Os07g0208100 protein', 233, NULL, NULL, 98118),
(98119, '2.40.50.140-FF-000043', NULL, 'DNA-directed RNA polymerase II subunit RPB7', 91, NULL, NULL, 98119),
(98120, '3.40.50.300-FF-008597', NULL, '26S protease regulatory subunit 6A homolog A', 89, NULL, NULL, 98120),
(98121, '1.25.40.20-FF-001067', NULL, 'Nudix (Nucleoside diphosphate linked moiety X)-type motif 12 (Predicted)', 150, NULL, NULL, 98121);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(98122, '3.30.420.40-FF-000219', NULL, 'Actin-related protein 5', 32, NULL, NULL, 98122),
(98123, '3.30.70.920-FF-000032', NULL, 'AsnC family transcriptional regulator', 85, NULL, NULL, 98123),
(98124, '2.60.120.290-FF-000091', NULL, 'Cubilin homolog', 123, NULL, NULL, 98124),
(98125, '3.30.70.240-FF-000042', NULL, 'Ribosome-releasing factor 2, mitochondrial', 72, NULL, NULL, 98125),
(98126, '3.80.10.10-FF-003078', NULL, 'Uncharacterized protein', 129, NULL, NULL, 98126),
(98127, '1.10.10.10-FF-000533', NULL, 'Transcriptional regulator, LysR family', 86, NULL, NULL, 98127),
(98128, '1.10.510.10-FF-004451', NULL, NULL, 30, NULL, NULL, 98128),
(98129, '3.40.50.300-FF-008237', NULL, 'Uncharacterized protein', 57, NULL, NULL, 98129),
(98130, '2.70.150.10-FF-000196', NULL, 'Predicted protein', 116, NULL, NULL, 98130),
(98131, '3.30.160.60-FF-000339', NULL, 'zinc finger protein 300', 27, NULL, NULL, 98131),
(98132, '3.30.200.20-FF-002086', NULL, 'Uncharacterized protein', 82, NULL, NULL, 98132),
(98133, '3.30.870.10-FF-000143', NULL, 'Phospholipase', 220, NULL, NULL, 98133),
(98134, '1.10.340.30-FF-000003', NULL, 'A/G-specific adenine glycosylase', 113, NULL, NULL, 98134),
(98135, '3.50.30.40-FF-000003', NULL, '4-hydroxy-4-methyl-2-oxoglutarate aldolase', 234, NULL, NULL, 98135),
(98136, '3.80.10.10-FF-003971', NULL, 'Uncharacterized protein', 162, NULL, NULL, 98136),
(98137, '2.60.120.200-FF-000053', NULL, 'Laminin subunit alpha 4', 158, NULL, NULL, 98137),
(98138, '3.40.50.1440-FF-000029', NULL, 'Cell division protein FtsZ', 218, NULL, NULL, 98138),
(98139, '2.30.30.40-FF-000462', NULL, 'Uncharacterized protein', 63, NULL, NULL, 98139),
(98140, '3.40.50.970-FF-000108', NULL, '2-oxoisovalerate dehydrogenase subunit alpha', 333, NULL, NULL, 98140),
(98141, '3.10.180.10-FF-000038', NULL, '3,4-dihydroxyphenylacetate 2,3-dioxygenase', 160, NULL, NULL, 98141),
(98142, '1.10.720.30-FF-000049', NULL, 'Zinc finger CCCH domain-containing protein 62', 66, NULL, NULL, 98142),
(98143, '3.90.180.10-FF-000037', NULL, 'Conserved protein', 153, NULL, NULL, 98143),
(98144, '2.60.490.10-FF-000009', NULL, 'P2X purinoceptor', 213, NULL, NULL, 98144),
(98145, '3.10.100.10-FF-000438', NULL, NULL, 58, NULL, NULL, 98145),
(98146, '2.60.120.260-FF-000076', NULL, 'Beta-galactosidase', 143, NULL, NULL, 98146),
(98147, '2.130.10.10-FF-003471', NULL, 'Apoptotic protease-activating factor 1', 348, NULL, NULL, 98147),
(98148, '3.50.50.60-FF-001180', NULL, 'NADPH:adrenodoxin oxidoreductase, putative', 197, NULL, NULL, 98148),
(98149, '3.40.50.10810-FF-000170', NULL, 'Predicted protein', 130, NULL, NULL, 98149),
(98150, '1.25.40.10-FF-004195', NULL, 'Uncharacterized protein', 76, NULL, NULL, 98150),
(98151, '3.30.505.10-FF-000172', NULL, NULL, 89, NULL, NULL, 98151),
(98152, '3.30.40.10-FF-000586', NULL, 'Traf3, isoform A', 58, NULL, NULL, 98152),
(98153, '2.130.10.10-FF-005769', NULL, 'Predicted protein', 107, NULL, NULL, 98153),
(98154, '3.30.70.20-FF-000124', NULL, NULL, 60, NULL, NULL, 98154),
(98155, '3.90.70.10-FF-000580', NULL, 'Ubiquitinyl hydrolase 1', 309, NULL, NULL, 98155),
(98156, '3.80.10.10-FF-003550', NULL, 'Uncharacterized protein', 155, NULL, NULL, 98156),
(98157, '2.130.10.10-FF-004460', NULL, 'Uncharacterized protein', 307, NULL, NULL, 98157),
(98158, '3.40.109.10-FF-000035', NULL, 'Nitroreductase', 251, NULL, NULL, 98158),
(98159, '3.40.50.300-FF-005371', NULL, 'Primosomal protein N''', 197, NULL, NULL, 98159),
(98160, '3.80.10.10-FF-003027', NULL, 'Predicted protein', 138, NULL, NULL, 98160),
(98161, '1.10.510.10-FF-003995', NULL, NULL, 134, NULL, NULL, 98161),
(98162, '3.30.890.10-FF-000026', NULL, 'Uncharacterized protein', 65, NULL, NULL, 98162),
(98163, '1.10.510.10-FF-001966', NULL, 'Uncharacterized protein', 242, NULL, NULL, 98163),
(98164, '2.180.10.10-FF-000012', NULL, 'Teneurin transmembrane protein 3', 213, NULL, NULL, 98164),
(98165, '3.60.15.10-FF-000251', NULL, 'Ribonuclease Z', 280, NULL, NULL, 98165),
(98166, '1.20.120.1770-FF-000006', NULL, 'Blast:Putative ferric-chelate reductase 1 homolog', 188, NULL, NULL, 98166);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(98167, '2.40.160.10-FF-000057', NULL, 'Putative mitochondrial outer membrane protein porin 5', 102, NULL, NULL, 98167),
(98168, '3.40.50.300-FF-004882', NULL, 'DEAH-box helicase 35', 71, NULL, NULL, 98168),
(98169, '3.40.50.620-FF-000138', NULL, 'Tryptophan--tRNA ligase', 268, NULL, NULL, 98169),
(98170, '3.30.40.10-FF-000086', NULL, 'PHD finger protein 14 isoform X1', 75, NULL, NULL, 98170),
(98171, '1.10.287.130-FF-000167', NULL, 'Sensor histide kinase', 120, NULL, NULL, 98171),
(98172, '2.70.150.10-FF-000145', NULL, 'Calcium-transporting ATPase', 34, NULL, NULL, 98172),
(98173, '1.25.40.120-FF-000064', NULL, 'Uncharacterized protein', 205, NULL, NULL, 98173),
(98174, '3.90.70.10-FF-000080', NULL, 'Ubiquitin carboxyl-terminal hydrolase 15', 234, NULL, NULL, 98174),
(98175, '2.130.10.10-FF-005657', NULL, 'Uncharacterized protein', 167, NULL, NULL, 98175),
(98176, '1.10.260.30-FF-000002', NULL, 'Signal recognition particle 54 kDa protein', 126, NULL, NULL, 98176),
(98177, '2.10.60.10-FF-000034', NULL, 'Sperm acrosome associated 4', 84, NULL, NULL, 98177),
(98178, '1.10.565.10-FF-000204', NULL, 'Uncharacterized protein', 165, NULL, NULL, 98178),
(98179, '1.25.40.10-FF-005100', NULL, 'Uncharacterized protein', 97, NULL, NULL, 98179),
(98180, '1.25.40.10-FF-000833', NULL, 'Tetratricopeptide repeat (TPR)-containing protein', 311, NULL, NULL, 98180),
(98181, '3.40.640.10-FF-000101', NULL, 'Serine hydroxymethyltransferase', 253, NULL, NULL, 98181),
(98182, '3.40.50.2300-FF-000484', NULL, 'Transcriptional regulator, LuxR family', 207, NULL, NULL, 98182),
(98183, '1.20.1420.10-FF-000028', NULL, NULL, 157, NULL, NULL, 98183),
(98184, '1.10.530.10-FF-000068', NULL, 'Acidic endochitinase WIN6.2B', 83, NULL, NULL, 98184),
(98185, '2.60.40.150-FF-000826', NULL, 'Uncharacterized protein', 153, NULL, NULL, 98185),
(98186, '3.40.50.1820-FF-000115', NULL, 'Poly depolymerase', 267, NULL, NULL, 98186),
(98187, '2.120.10.30-FF-000453', NULL, 'Uncharacterized protein', 98, NULL, NULL, 98187),
(98188, '3.40.1050.10-FF-000010', NULL, 'Carbonic anhydrase', 212, NULL, NULL, 98188),
(98189, '2.30.29.30-FF-000337', NULL, 'Protein still life, isoform SIF type', 163, NULL, NULL, 98189),
(98190, '2.130.10.10-FF-004308', NULL, 'Uncharacterized protein', 114, NULL, NULL, 98190),
(98191, '1.10.510.10-FF-004080', NULL, NULL, 166, NULL, NULL, 98191),
(98192, '1.10.260.50-FF-000008', NULL, NULL, 90, NULL, NULL, 98192),
(98193, '1.20.5.170-FF-000026', NULL, 'Calcium-transporting ATPase', 61, NULL, NULL, 98193),
(98194, '2.170.16.10-FF-000020', NULL, 'Probable translation initiation factor IF-2', 173, NULL, NULL, 98194),
(98195, '1.10.10.10-FF-000033', NULL, 'DNA-binding response regulator MtrA', 108, NULL, NULL, 98195),
(98196, '3.30.230.70-FF-000051', NULL, 'Exosome complex exonuclease RRP42, putative', 263, NULL, NULL, 98196),
(98197, '3.30.60.90-FF-000015', NULL, 'Transcriptional coactivator ADA2', 52, NULL, NULL, 98197),
(98198, '2.120.10.30-FF-000392', NULL, 'Low-density lipoprotein RecePtor related', 274, NULL, NULL, 98198),
(98199, '1.10.455.10-FF-000022', NULL, 'Ribosomal protein', 55, NULL, NULL, 98199),
(98200, '2.30.30.40-FF-000523', NULL, 'BAR domaincontaining protein', 71, NULL, NULL, 98200),
(98201, '3.40.50.300-FF-007248', NULL, 'Predicted protein', 160, NULL, NULL, 98201),
(98202, '2.60.120.10-FF-000342', NULL, 'Plant cysteine oxidase 1', 193, NULL, NULL, 98202),
(98203, '1.10.287.110-FF-000161', NULL, 'Small t antigen', 72, NULL, NULL, 98203),
(98204, '3.90.190.10-FF-000274', NULL, 'Uncharacterized protein MJ0215', 118, NULL, NULL, 98204),
(98205, '2.130.10.10-FF-005718', NULL, 'Predicted protein', 139, NULL, NULL, 98205),
(98206, '2.130.10.10-FF-000986', NULL, 'COMPASS component SWD2', 127, NULL, NULL, 98206),
(98207, '2.60.120.970-FF-000081', NULL, 'Transforming growth factor beta, putative', 227, NULL, NULL, 98207),
(98208, '1.10.287.370-FF-000008', NULL, 'unconventional prefoldin RPB5 interactor 1', 127, NULL, NULL, 98208),
(98209, '3.80.10.10-FF-004488', NULL, 'Putative leucine-rich repeat protein kinase family protein', 109, NULL, NULL, 98209);
INSERT INTO "PUBLIC"."MODEL" VALUES
(98210, '3.30.160.60-FF-000278', NULL, 'zinc finger and BTB domain-containing protein 44 isoform X1', 29, NULL, NULL, 98210),
(98211, '3.30.2320.20-FF-000003', NULL, 'Predicted protein', 64, NULL, NULL, 98211),
(98212, '1.25.10.10-FF-000101', NULL, 'TATA-binding protein-associated factor 172 isoform X2', 309, NULL, NULL, 98212),
(98213, '1.10.10.60-FF-000975', NULL, NULL, 35, NULL, NULL, 98213),
(98214, '2.60.40.1730-FF-000112', NULL, NULL, 110, NULL, NULL, 98214),
(98215, '2.60.40.60-FF-000883', NULL, 'Cadherin 23', 112, NULL, NULL, 98215),
(98216, '1.25.40.20-FF-001567', NULL, 'Ankyrin repeat family protein', 76, NULL, NULL, 98216),
(98217, '3.90.550.10-FF-000257', NULL, 'Alpha-1,6-mannosyl-glycoprotein 2-beta-N-acetylglucosaminyltransferase', 258, NULL, NULL, 98217),
(98218, '3.40.50.150-FF-000918', NULL, NULL, 140, NULL, NULL, 98218),
(98219, '1.20.120.1920-FF-000012', NULL, 'Uncharacterized protein', 61, NULL, NULL, 98219),
(98220, '3.40.50.300-FF-000548', NULL, 'ADP-ribosylation factor 2', 183, NULL, NULL, 98220),
(98221, '2.60.40.10-FF-003588', NULL, NULL, 102, NULL, NULL, 98221),
(98222, '2.130.10.10-FF-003920', NULL, 'WD repeat domain 74', 261, NULL, NULL, 98222),
(98223, '2.40.100.10-FF-000109', NULL, 'Peptidyl-prolyl cis-trans isomerase', 180, NULL, NULL, 98223),
(98224, '3.40.50.720-FF-001450', NULL, 'Predicted protein', 163, NULL, NULL, 98224),
(98225, '1.20.5.190-FF-000133', NULL, NULL, 50, NULL, NULL, 98225),
(98226, '2.10.90.10-FF-000154', NULL, 'Nodal-related protein 1', 94, NULL, NULL, 98226),
(98227, '3.40.50.720-FF-000882', NULL, 'Uncharacterized protein', 104, NULL, NULL, 98227),
(98228, '1.20.120.430-FF-000013', NULL, 'GTPase mss1/trme, putative', 97, NULL, NULL, 98228),
(98229, '2.10.70.10-FF-000203', NULL, 'sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1 isoform X1', 60, NULL, NULL, 98229),
(98230, '3.80.10.10-FF-001554', NULL, 'Flagellar_Member_5', 149, NULL, NULL, 98230),
(98231, '3.30.420.40-FF-000303', NULL, 'Heat shock protein, putative', 101, NULL, NULL, 98231),
(98232, '2.60.120.10-FF-000746', NULL, 'Uncharacterized protein', 103, NULL, NULL, 98232),
(98233, '1.20.58.830-FF-000038', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 127, NULL, NULL, 98233),
(98234, '3.40.50.300-FF-006731', NULL, 'Uncharacterized protein', 70, NULL, NULL, 98234),
(98235, '3.30.40.10-FF-001103', NULL, 'Homeodomain protein', 65, NULL, NULL, 98235),
(98236, '1.10.132.20-FF-000011', NULL, 'Uncharacterized protein', 94, NULL, NULL, 98236),
(98237, '1.20.58.60-FF-000629', NULL, 'Spectrin repeat-containing, nuclear envelope 1b', 286, NULL, NULL, 98237),
(98238, '1.10.510.10-FF-002034', NULL, 'Protein kinase superfamily protein', 293, NULL, NULL, 98238),
(98239, '1.10.287.660-FF-000039', NULL, 'Predicted protein', 72, NULL, NULL, 98239),
(98240, '3.40.30.10-FF-001057', NULL, 'Uncharacterized protein', 174, NULL, NULL, 98240),
(98241, '1.25.40.10-FF-003655', NULL, 'Uncharacterized protein', 223, NULL, NULL, 98241),
(98242, '1.10.287.410-FF-000009', NULL, 'Uncharacterized protein', 73, NULL, NULL, 98242),
(98243, '1.10.10.60-FF-001043', NULL, NULL, 70, NULL, NULL, 98243),
(98244, '3.10.580.10-FF-000018', NULL, 'Chloride channel protein', 70, NULL, NULL, 98244),
(98245, '3.40.50.2300-FF-001552', NULL, NULL, 25, NULL, NULL, 98245),
(98246, '3.90.190.10-FF-000206', NULL, 'Leucine rich repeat and phosphatase domain containing protein', 154, NULL, NULL, 98246),
(98247, '2.60.40.150-FF-000377', NULL, 'Synaptotagmin Ib', 84, NULL, NULL, 98247),
(98248, '3.30.70.120-FF-000023', NULL, NULL, 81, NULL, NULL, 98248),
(98249, '3.40.630.10-FF-000196', NULL, 'glutaminyl-peptide cyclotransferase isoform X1', 313, NULL, NULL, 98249),
(98250, '1.10.10.10-FF-001961', NULL, 'Uncharacterized protein', 72, NULL, NULL, 98250),
(98251, '3.10.129.10-FF-000133', NULL, 'PaaI family thioesterase', 137, NULL, NULL, 98251),
(98252, '3.40.1190.20-FF-000057', NULL, 'Aminoimidazole riboside kinase', 315, NULL, NULL, 98252),
(98253, '1.10.730.10-FF-000049', NULL, 'Leucine--tRNA ligase', 26, NULL, NULL, 98253);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(98254, '1.20.120.980-FF-000026', NULL, 'Uncharacterized protein', 132, NULL, NULL, 98254),
(98255, '3.30.450.20-FF-000333', NULL, 'Methyl-accepting chemotaxis protein', 133, NULL, NULL, 98255),
(98256, '2.60.40.60-FF-000091', NULL, 'Desmocollin 1', 110, NULL, NULL, 98256),
(98257, '1.20.58.420-FF-000005', NULL, NULL, 104, NULL, NULL, 98257),
(98258, '3.30.70.580-FF-000059', NULL, 'tRNA pseudouridine synthase', 177, NULL, NULL, 98258),
(98259, '1.25.10.10-FF-003086', NULL, 'Plakophilin 2', 232, NULL, NULL, 98259),
(98260, '3.40.50.1100-FF-000225', NULL, 'Uncharacterized protein', 92, NULL, NULL, 98260),
(98261, '2.40.10.10-FF-000395', NULL, NULL, 121, NULL, NULL, 98261),
(98262, '1.10.8.270-FF-000087', NULL, 'GTPase activator-like protein', 118, NULL, NULL, 98262),
(98263, '2.10.25.10-FF-001184', NULL, 'Neurogenic locus notch homolog protein 1', 38, NULL, NULL, 98263),
(98264, '1.10.1670.10-FF-000026', NULL, 'Endonuclease III homolog', 80, NULL, NULL, 98264),
(98265, '2.60.120.200-FF-000114', NULL, 'Probable endo-1,3(4)-beta-glucanase NFIA_089530', 294, NULL, NULL, 98265),
(98266, '3.30.750.24-FF-000018', NULL, 'Anti-sigma factor antagonist', 109, NULL, NULL, 98266),
(98267, '2.20.90.10-FF-000013', NULL, 'Uncharacterized LOC495702', 102, NULL, NULL, 98267),
(98268, '1.25.40.10-FF-000041', NULL, 'Co-chaperone YbbN', 84, NULL, NULL, 98268),
(98269, '3.10.580.10-FF-000198', NULL, 'Predicted protein', 59, NULL, NULL, 98269),
(98270, '2.130.10.10-FF-005269', NULL, 'Predicted protein', 253, NULL, NULL, 98270),
(98271, '1.20.1080.10-FF-000007', NULL, 'Aquaporin Z', 231, NULL, NULL, 98271),
(98272, '3.30.200.20-FF-002170', NULL, 'Uncharacterized protein', 63, NULL, NULL, 98272),
(98273, '2.60.40.150-FF-000085', NULL, 'Phosphoinositide phospholipase C', 153, NULL, NULL, 98273),
(98274, '1.10.3210.10-FF-000060', NULL, 'Metal dependent phosphohydrolase', 175, NULL, NULL, 98274),
(98275, '3.80.10.10-FF-002122', NULL, 'X-ray radiation resistance-associated protein 1', 89, NULL, NULL, 98275),
(98276, '3.40.1770.10-FF-000014', NULL, 'Uncharacterized protein', 72, NULL, NULL, 98276),
(98277, '1.10.510.10-FF-002455', NULL, NULL, 151, NULL, NULL, 98277),
(98278, '3.30.160.60-FF-002756', NULL, 'Zinc finger protein 1159', 28, NULL, NULL, 98278),
(98279, '2.120.10.30-FF-000402', NULL, 'Uncharacterized protein', 210, NULL, NULL, 98279),
(98280, '2.130.10.10-FF-003971', NULL, 'Predicted protein', 237, NULL, NULL, 98280),
(98281, '1.20.1740.10-FF-000187', NULL, 'Os12g0613100 protein', 266, NULL, NULL, 98281),
(98282, '1.20.1250.20-FF-001917', NULL, 'Uncharacterized protein', 224, NULL, NULL, 98282),
(98283, '2.60.40.60-FF-000995', NULL, 'Protein CBR-CDH-12', 82, NULL, NULL, 98283),
(98284, '3.30.1370.110-FF-000029', NULL, 'Smr/MutS family protein', 125, NULL, NULL, 98284),
(98285, '3.40.630.30-FF-000022', NULL, 'Histone acetyltransferase type B catalytic subunit', 133, NULL, NULL, 98285),
(98286, '3.90.550.10-FF-000757', NULL, 'Predicted protein', 126, NULL, NULL, 98286),
(98287, '3.40.50.2000-FF-001001', NULL, 'Alpha-1,4 glucan phosphorylase', 24, NULL, NULL, 98287),
(98288, '2.40.50.100-FF-000059', NULL, 'Biotin/lipoyl attachment domain-containing protein', 80, NULL, NULL, 98288),
(98289, '2.60.40.150-FF-000034', NULL, 'otoferlin isoform X2', 133, NULL, NULL, 98289),
(98290, '3.20.20.70-FF-000024', NULL, 'Indole-3-glycerol phosphate synthase', 260, NULL, NULL, 98290),
(98291, '2.30.30.40-FF-000023', NULL, 'RIMS-binding protein 2 isoform F', 65, NULL, NULL, 98291),
(98292, '1.10.630.10-FF-000665', NULL, 'Uncharacterized protein', 182, NULL, NULL, 98292),
(98293, '3.10.110.10-FF-000383', NULL, 'Uncharacterized protein', 144, NULL, NULL, 98293),
(98294, '2.130.10.10-FF-001054', NULL, 'Transducin (beta)-like 3', 146, NULL, NULL, 98294),
(98295, '3.30.1250.10-FF-000005', NULL, NULL, 102, NULL, NULL, 98295),
(98296, '3.90.79.10-FF-000161', NULL, 'Adenine DNA glycosylase', 175, NULL, NULL, 98296),
(98297, '1.25.40.10-FF-000333', NULL, 'Pentatricopeptide repeat-containing protein', 99, NULL, NULL, 98297),
(98298, '1.20.58.1030-FF-000035', NULL, 'Predicted protein', 134, NULL, NULL, 98298);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(98299, '1.10.20.10-FF-000247', NULL, NULL, 91, NULL, NULL, 98299),
(98300, '2.130.10.10-FF-001150', NULL, 'WD repeat-containing protein 37', 134, NULL, NULL, 98300),
(98301, '1.20.5.710-FF-000003', NULL, '50S ribosomal protein L7/L12', 51, NULL, NULL, 98301),
(98302, '2.30.42.10-FF-000435', NULL, NULL, 120, NULL, NULL, 98302),
(98303, '1.25.40.10-FF-003998', NULL, 'Uncharacterized protein', 210, NULL, NULL, 98303),
(98304, '3.40.50.10130-FF-000033', NULL, 'Crossover junction endonuclease EME1-like Protein', 167, NULL, NULL, 98304),
(98305, '3.30.160.60-FF-000778', NULL, 'PR/SET domain 6', 29, NULL, NULL, 98305),
(98306, '3.90.79.10-FF-000009', NULL, 'Isopentenyl-diphosphate Delta-isomerase', 180, NULL, NULL, 98306),
(98307, '2.60.40.60-FF-000383', NULL, 'Protocadherin Fat', 105, NULL, NULL, 98307),
(98308, '2.10.25.10-FF-001796', NULL, 'Uncharacterized protein', 28, NULL, NULL, 98308),
(98309, '3.30.70.1230-FF-000278', NULL, 'Predicted protein', 78, NULL, NULL, 98309),
(98310, '1.10.150.380-FF-000001', NULL, 'Aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase subunit B', 56, NULL, NULL, 98310),
(98311, '2.40.160.120-FF-000041', NULL, 'Uncharacterized protein', 224, NULL, NULL, 98311),
(98312, '1.20.1070.10-FF-000214', NULL, 'Neuromedin U receptor 1', 320, NULL, NULL, 98312),
(98313, '3.90.1530.10-FF-000013', NULL, 'Sulfiredoxin', 96, NULL, NULL, 98313),
(98314, '3.30.160.60-FF-004605', NULL, NULL, 27, NULL, NULL, 98314),
(98315, '1.10.3470.10-FF-000045', NULL, 'ABC transporter, permease protein, FecCD family', 323, NULL, NULL, 98315),
(98316, '3.30.450.40-FF-000131', NULL, 'Transcriptional regulatory protein', 176, NULL, NULL, 98316),
(98317, '3.40.190.10-FF-000791', NULL, 'Oligopeptide transport system binding protein', 133, NULL, NULL, 98317),
(98318, '2.60.40.10-FF-005112', NULL, NULL, 98, NULL, NULL, 98318),
(98319, '1.25.40.10-FF-001890', NULL, 'Pentatricopeptide repeat-containing protein', 145, NULL, NULL, 98319),
(98320, '3.30.160.60-FF-004313', NULL, NULL, 60, NULL, NULL, 98320),
(98321, '1.20.1250.20-FF-000557', NULL, 'Solute carrier organic anion transporter family member', 219, NULL, NULL, 98321),
(98322, '1.10.510.10-FF-000909', NULL, 'Calmodulin-dependent protein kinase I, putative', 213, NULL, NULL, 98322),
(98323, '2.30.30.1040-FF-000002', NULL, 'Auxin response factor', 74, NULL, NULL, 98323),
(98324, '1.25.10.10-FF-003035', NULL, 'Nuclear pre-mRNA splicing factor, component of splicing factor 3b', 304, NULL, NULL, 98324),
(98325, '1.10.1670.10-FF-000077', NULL, NULL, 87, NULL, NULL, 98325),
(98326, '3.30.40.10-FF-000827', NULL, 'probable E3 ubiquitin-protein ligase TRIM8', 54, NULL, NULL, 98326),
(98327, '1.10.520.10-FF-000062', NULL, 'Peroxidase', 86, NULL, NULL, 98327),
(98328, '3.90.70.40-FF-000004', NULL, 'ataxin-3 homolog', 112, NULL, NULL, 98328),
(98329, '1.20.120.1510-FF-000007', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 108, NULL, NULL, 98329),
(98330, '3.40.50.2300-FF-000984', NULL, NULL, 83, NULL, NULL, 98330),
(98331, '1.10.238.10-FF-000017', NULL, 'Diacylglycerol kinase', 74, NULL, NULL, 98331),
(98332, '3.50.50.60-FF-000123', NULL, '2-octaprenyl-6-methoxyphenyl hydroxylase', 214, NULL, NULL, 98332),
(98333, '3.30.40.10-FF-000535', NULL, 'Chromatin modification-related protein', 67, NULL, NULL, 98333),
(98334, '3.40.50.2300-FF-000888', NULL, NULL, 124, NULL, NULL, 98334),
(98335, '3.30.70.330-FF-002334', NULL, NULL, 112, NULL, NULL, 98335),
(98336, '1.10.357.10-FF-000041', NULL, 'TetR/AcrR family transcriptional regulator', 197, NULL, NULL, 98336),
(98337, '2.40.10.10-FF-000344', NULL, 'Plasminogen activator, urokinase', 254, NULL, NULL, 98337),
(98338, '3.90.190.10-FF-000386', NULL, 'Protein-tyrosine-phosphatase', 287, NULL, NULL, 98338),
(98339, '2.60.40.10-FF-004605', NULL, NULL, 76, NULL, NULL, 98339),
(98340, '3.40.50.620-FF-000638', NULL, 'tRNA 5-methylaminomethyl-2-thiouridylate methyltransferase', 77, NULL, NULL, 98340),
(98341, '2.70.130.10-FF-000115', NULL, NULL, 94, NULL, NULL, 98341),
(98342, '3.40.50.300-FF-008529', NULL, 'Predicted protein', 172, NULL, NULL, 98342);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(98343, '1.10.510.10-FF-003883', NULL, NULL, 90, NULL, NULL, 98343),
(98344, '2.120.10.80-FF-000035', NULL, 'Muskelin 1', 154, NULL, NULL, 98344),
(98345, '3.40.50.1440-FF-000097', NULL, 'Uncharacterized protein', 273, NULL, NULL, 98345),
(98346, '1.10.10.10-FF-000421', NULL, 'Embryo defective 1379', 113, NULL, NULL, 98346),
(98347, '3.40.640.10-FF-000022', NULL, 'Glutamate decarboxylase', 295, NULL, NULL, 98347),
(98348, '3.40.50.980-FF-000049', NULL, 'Uncharacterized protein', 163, NULL, NULL, 98348),
(98349, '1.20.1070.10-FF-001642', NULL, 'Vomeronasal type-1 receptor', 137, NULL, NULL, 98349),
(98350, '1.50.10.10-FF-000088', NULL, 'alpha-1,2-Mannosidase', 455, NULL, NULL, 98350),
(98351, '3.40.1280.10-FF-000106', NULL, 'Uncharacterized protein', 143, NULL, NULL, 98351),
(98352, '3.40.50.2000-FF-001052', NULL, 'Uncharacterized protein', 120, NULL, NULL, 98352),
(98353, '2.20.70.10-FF-000181', NULL, 'Reticulocyte-binding protein 2-like protein a', 38, NULL, NULL, 98353),
(98354, '3.20.20.140-FF-000482', NULL, 'Uncharacterized protein', 88, NULL, NULL, 98354),
(98355, '3.30.750.24-FF-000170', NULL, 'Probable sulfate transporter', 87, NULL, NULL, 98355),
(98356, '2.30.29.30-FF-001405', NULL, 'Predicted protein', 99, NULL, NULL, 98356),
(98357, '3.30.70.1450-FF-000052', NULL, 'Membrane protein, TrkA-C domain pair-containing', 77, NULL, NULL, 98357),
(98358, '3.30.70.330-FF-000001', NULL, '50S ribosomal protein L23', 99, NULL, NULL, 98358),
(98359, '1.20.1250.20-FF-001838', NULL, 'Sodium-dependent glucose transporter, putative', 139, NULL, NULL, 98359),
(98360, '1.25.40.530-FF-000029', NULL, NULL, 120, NULL, NULL, 98360),
(98361, '2.130.10.130-FF-000038', NULL, NULL, 186, NULL, NULL, 98361),
(98362, '3.40.140.10-FF-000288', NULL, 'Uncharacterized protein', 127, NULL, NULL, 98362),
(98363, '2.60.40.790-FF-000102', NULL, 'Inactive protein RESTRICTED TEV MOVEMENT 2', 108, NULL, NULL, 98363),
(98364, '3.40.50.1000-FF-000521', NULL, NULL, 55, NULL, NULL, 98364),
(98365, '1.10.472.10-FF-000112', NULL, 'D1-type cyclin', 73, NULL, NULL, 98365),
(98366, '3.40.1160.10-FF-000108', NULL, 'Aspartate kinase', 181, NULL, NULL, 98366),
(98367, '1.10.287.2900-FF-000010', NULL, 'Protein CBG19950', 58, NULL, NULL, 98367),
(98368, '3.20.20.140-FF-000122', NULL, 'Probable allantoinase 2', 455, NULL, NULL, 98368),
(98369, '3.30.200.20-FF-002198', NULL, NULL, 50, NULL, NULL, 98369),
(98370, '1.20.1530.20-FF-000039', NULL, 'Transporter, CPA2 family', 383, NULL, NULL, 98370),
(98371, '3.40.50.150-FF-000065', NULL, 'Phenylethanolamine N-methyltransferase', 261, NULL, NULL, 98371),
(98372, '3.90.1580.10-FF-000016', NULL, 'Sulfatase-modifying factor 1', 168, NULL, NULL, 98372),
(98373, '3.30.1330.10-FF-000006', NULL, 'Selenide water dikinase 1', 141, NULL, NULL, 98373),
(98374, '2.60.40.10-FF-005292', NULL, NULL, 82, NULL, NULL, 98374),
(98375, '2.60.120.200-FF-000165', NULL, 'Calpain-type cysteine protease DEK1', 175, NULL, NULL, 98375),
(98376, '1.20.1250.20-FF-002114', NULL, 'Uncharacterized protein', 228, NULL, NULL, 98376),
(98377, '2.40.40.50-FF-000004', NULL, 'Ubiquitin fusion degradation protein, putative', 104, NULL, NULL, 98377),
(98378, '3.40.50.300-FF-003858', NULL, 'ABC transporter, eXtended', 258, NULL, NULL, 98378),
(98379, '3.30.930.10-FF-000294', NULL, 'tRNA synthetases class II-domain-containing protein', 363, NULL, NULL, 98379),
(98380, '3.40.50.720-FF-001399', NULL, 'IMP dehydrogenase', 142, NULL, NULL, 98380),
(98381, '2.60.200.20-FF-000233', NULL, 'Aprataxin', 60, NULL, NULL, 98381),
(98382, '2.130.10.10-FF-005365', NULL, 'chromatin assembly factor 1 subunit B-like isoform X1', 170, NULL, NULL, 98382),
(98383, '3.20.10.10-FF-000056', NULL, 'Branched-chain amino acid aminotransferase, putative', 130, NULL, NULL, 98383),
(98384, '3.10.450.10-FF-000014', NULL, 'Retinoic acid receptor responder 2', 100, NULL, NULL, 98384),
(98385, '3.30.720.210-FF-000001', NULL, 'ATP-dependent zinc metalloprotease FtsH', 75, NULL, NULL, 98385),
(98386, '2.60.40.10-FF-004656', NULL, NULL, 132, NULL, NULL, 98386),
(98387, '3.30.559.70-FF-000050', NULL, 'Uncharacterized protein', 163, NULL, NULL, 98387);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(98388, '1.10.1200.10-FF-000115', NULL, 'Probable acyl carrier protein PigG', 82, NULL, NULL, 98388),
(98389, '2.40.50.100-FF-000138', NULL, 'Efflux transporter, RND family, MFP subunit', 69, NULL, NULL, 98389),
(98390, '1.25.40.20-FF-000611', NULL, 'Related to transcription factor MBP1', 219, NULL, NULL, 98390),
(98391, '1.20.80.40-FF-000001', NULL, 'Pre-mRNA-processing-splicing factor 8', 99, NULL, NULL, 98391),
(98392, '1.10.287.70-FF-000536', NULL, 'Two-pore potassium channel 1', 90, NULL, NULL, 98392),
(98393, '1.25.40.10-FF-001789', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 126, NULL, NULL, 98393),
(98394, '1.10.510.10-FF-004372', NULL, NULL, 102, NULL, NULL, 98394),
(98395, '3.60.21.10-FF-000304', NULL, 'Uncharacterized protein', 302, NULL, NULL, 98395),
(98396, '3.40.50.1260-FF-000020', NULL, 'Phosphoglycerate kinase', 72, NULL, NULL, 98396),
(98397, '3.40.50.720-FF-000090', NULL, 'NADP-dependent mannitol dehydrogenase', 264, NULL, NULL, 98397),
(98398, '1.50.10.10-FF-000037', NULL, 'alpha-1,2-Mannosidase', 506, NULL, NULL, 98398),
(98399, '1.25.40.10-FF-002227', NULL, 'Uncharacterized protein', 210, NULL, NULL, 98399),
(98400, '3.40.720.10-FF-000023', NULL, 'Arylsulfatase A', 351, NULL, NULL, 98400),
(98401, '3.40.50.150-FF-000014', NULL, 'Ubiquinone/menaquinone biosynthesis C-methyltransferase UbiE', 221, NULL, NULL, 98401),
(98402, '2.60.40.10-FF-000733', NULL, 'Turtle, isoform F', 86, NULL, NULL, 98402),
(98403, '2.20.25.10-FF-000087', NULL, 'DNA-directed RNA polymerase subunit', 66, NULL, NULL, 98403),
(98404, '3.10.660.10-FF-000019', NULL, 'Uncharacterized protein', 67, NULL, NULL, 98404),
(98405, '2.60.120.330-FF-000237', NULL, 'Uncharacterized protein', 71, NULL, NULL, 98405),
(98406, '4.10.1060.10-FF-000028', NULL, 'E3 ubiquitin-protein ligase RNF31', 35, NULL, NULL, 98406),
(98407, '2.10.230.10-FF-000018', NULL, 'Uncharacterized protein', 73, NULL, NULL, 98407),
(98408, '3.30.559.30-FF-000127', NULL, 'Uncharacterized protein', 256, NULL, NULL, 98408),
(98409, '3.40.50.300-FF-003033', NULL, 'P-type conjugative transfer ATPase TrbB', 204, NULL, NULL, 98409),
(98410, '1.20.1110.10-FF-000218', NULL, NULL, 51, NULL, NULL, 98410),
(98411, '3.40.50.150-FF-000986', NULL, 'Uncharacterized protein, isoform B', 216, NULL, NULL, 98411),
(98412, '3.40.50.150-FF-000626', NULL, 'Uncharacterized protein', 257, NULL, NULL, 98412),
(98413, '3.90.70.10-FF-000872', NULL, 'Uncharacterized protein', 67, NULL, NULL, 98413),
(98414, '3.30.565.10-FF-000529', NULL, 'Histidine kinase sensor protein', 151, NULL, NULL, 98414),
(98415, '3.80.10.10-FF-000273', NULL, 'Leucine Rich Repeat domain protein', 84, NULL, NULL, 98415),
(98416, '3.30.200.20-FF-000169', NULL, 'kalirin isoform X1', 85, NULL, NULL, 98416),
(98417, '1.10.510.10-FF-000117', NULL, 'dual specificity tyrosine-phosphorylation-regulated kinase 1A isoform X1', 248, NULL, NULL, 98417),
(98418, '3.40.228.10-FF-000019', NULL, 'Anaerobic dehydrogenase typically selenocysteine-containing', 236, NULL, NULL, 98418),
(98419, '3.30.40.10-FF-000878', NULL, 'RING-H2 finger protein ATL52', 88, NULL, NULL, 98419),
(98420, '3.30.70.1660-FF-000030', NULL, 'Peptide chain release factor 1-like, mitochondrial', 79, NULL, NULL, 98420),
(98421, '1.25.40.10-FF-004223', NULL, 'Uncharacterized protein', 267, NULL, NULL, 98421),
(98422, '1.10.8.1310-FF-000009', NULL, 'TBC domain protein, putative (AFU_orthologue AFUA_1G04010)', 95, NULL, NULL, 98422),
(98423, '3.40.50.1820-FF-001508', NULL, 'Uncharacterized protein', 154, NULL, NULL, 98423),
(98424, '1.25.40.10-FF-003947', NULL, 'Predicted protein', 273, NULL, NULL, 98424),
(98425, '1.20.58.1380-FF-000005', NULL, 'Nuclear pore complex protein NUP133', 105, NULL, NULL, 98425),
(98426, '3.10.400.20-FF-000020', NULL, 'Eukaryotic translation initiation factor 2D', 185, NULL, NULL, 98426),
(98427, '1.10.10.480-FF-000001', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit alpha', 65, NULL, NULL, 98427),
(98428, '3.40.50.12650-FF-000030', NULL, 'DNA repair protein', 21, NULL, NULL, 98428);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(98429, '1.25.40.20-FF-000662', NULL, 'Ankyrin repeat domain 17', 114, NULL, NULL, 98429),
(98430, '3.30.200.20-FF-002018', NULL, 'Receptor protein serine/threonine kinase', 93, NULL, NULL, 98430),
(98431, '1.10.8.140-FF-000008', NULL, 'YMR074C-like protein', 106, NULL, NULL, 98431),
(98432, '2.160.20.70-FF-000031', NULL, 'Tubulin cofactor C domain-containing protein 1', 165, NULL, NULL, 98432),
(98433, '3.30.160.60-FF-002195', NULL, 'C2H2 finger domain protein, putative', 54, NULL, NULL, 98433),
(98434, '3.40.630.10-FF-000275', NULL, 'Peptidase, M20/M25/M40 family', 200, NULL, NULL, 98434),
(98435, '3.40.50.300-FF-000599', NULL, 'Deoxycytidine kinase isoform A', 227, NULL, NULL, 98435),
(98436, '2.40.100.10-FF-000177', NULL, 'Uncharacterized protein', 176, NULL, NULL, 98436),
(98437, '2.60.220.50-FF-000159', NULL, 'Uncharacterized protein', 162, NULL, NULL, 98437),
(98438, '3.40.50.1000-FF-000425', NULL, NULL, 22, NULL, NULL, 98438),
(98439, '2.30.30.100-FF-000131', NULL, 'RNA-binding protein Hfq', 67, NULL, NULL, 98439),
(98440, '3.90.1480.20-FF-000068', NULL, 'Uncharacterized protein', 104, NULL, NULL, 98440),
(98441, '3.30.160.60-FF-001407', NULL, 'zinc finger and SCAN domain-containing protein 20 isoform X1', 26, NULL, NULL, 98441),
(98442, '3.40.50.720-FF-002416', NULL, 'dTDP-4-dehydrorhamnose reductase', 47, NULL, NULL, 98442),
(98443, '3.90.70.10-FF-000641', NULL, 'Ubiquitinyl hydrolase 1', 107, NULL, NULL, 98443),
(98444, '3.40.50.1820-FF-001216', NULL, 'Uncharacterized protein', 369, NULL, NULL, 98444),
(98445, '3.30.310.10-FF-000045', NULL, 'Uncharacterized protein', 80, NULL, NULL, 98445),
(98446, '3.90.1150.10-FF-000310', NULL, 'Serine--pyruvate aminotransferase-like Protein', 112, NULL, NULL, 98446),
(98447, '2.170.16.10-FF-000048', NULL, 'DNA replication licensing factor, MCM2/3/5 family', 105, NULL, NULL, 98447),
(98448, '3.40.50.980-FF-000021', NULL, 'Vibriobactin-specific 2,3-dihydroxybenzoate-AMP ligase', 156, NULL, NULL, 98448),
(98449, '3.40.50.410-FF-000289', NULL, 'Uncharacterized protein', 201, NULL, NULL, 98449),
(98450, '2.30.42.10-FF-000082', NULL, 'LIM domain kinase 2 isoform X2', 110, NULL, NULL, 98450),
(98451, '3.10.250.10-FF-000033', NULL, 'Scavenger receptor family member expressed on T cells 1', 107, NULL, NULL, 98451),
(98452, '1.20.1070.10-FF-000574', NULL, 'Pigment-dispersing factor receptor, isoform C', 294, NULL, NULL, 98452),
(98453, '1.20.58.390-FF-000069', NULL, 'Ligand-Gated ion Channel', 136, NULL, NULL, 98453),
(98454, '3.80.10.10-FF-001925', NULL, 'Protein kinase, putative', 173, NULL, NULL, 98454),
(98455, '3.20.20.80-FF-000757', NULL, 'Uncharacterized protein', 319, NULL, NULL, 98455),
(98456, '3.90.226.10-FF-000335', NULL, 'Uncharacterized protein', 63, NULL, NULL, 98456),
(98457, '1.20.1250.20-FF-001389', NULL, 'monocarboxylate transporter 5-like', 191, NULL, NULL, 98457),
(98458, '1.20.5.490-FF-000004', NULL, 'Transcription factor HY5', 42, NULL, NULL, 98458),
(98459, '1.25.40.10-FF-001738', NULL, 'CRE-LET-716 protein', 201, NULL, NULL, 98459),
(98460, '2.60.40.10-FF-001290', NULL, 'Matrix remodeling associated 5', 97, NULL, NULL, 98460),
(98461, '3.30.60.30-FF-000076', NULL, 'Agrin', 69, NULL, NULL, 98461),
(98462, '1.20.140.40-FF-000016', NULL, 'Pectinesterase', 153, NULL, NULL, 98462),
(98463, '3.40.50.300-FF-002757', NULL, 'Mitochondrial GTPase 1', 195, NULL, NULL, 98463),
(98464, '3.40.140.10-FF-000057', NULL, 'Cytidine deaminase, putative', 127, NULL, NULL, 98464),
(98465, '1.25.10.10-FF-003299', NULL, 'Serine/threonine-protein kinase TOR', 176, NULL, NULL, 98465),
(98466, '1.25.40.10-FF-003767', NULL, 'Predicted protein', 323, NULL, NULL, 98466),
(98467, '2.130.10.10-FF-001846', NULL, 'Transducin family protein / WD-40 repeat family protein', 87, NULL, NULL, 98467),
(98468, '3.30.40.10-FF-002160', NULL, 'GIY-YIG domain-containing protein, putative', 71, NULL, NULL, 98468),
(98469, '1.25.40.10-FF-005004', NULL, 'Uncharacterized protein', 123, NULL, NULL, 98469),
(98470, '2.130.10.10-FF-005157', NULL, 'Uncharacterized protein', 140, NULL, NULL, 98470);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(98471, '3.30.420.10-FF-000227', NULL, 'ERI1 exoribonuclease family member 2', 176, NULL, NULL, 98471),
(98472, '1.10.472.10-FF-000163', NULL, 'Unplaced genomic scaffold supercont2.13, whole genome shotgun sequence', 93, NULL, NULL, 98472),
(98473, '2.60.40.790-FF-000074', NULL, 'Ubiquitin-specific peptidase 19', 107, NULL, NULL, 98473),
(98474, '3.10.129.10-FF-000021', NULL, 'Acyl-coenzyme A thioesterase 13', 141, NULL, NULL, 98474),
(98475, '1.25.10.10-FF-001169', NULL, 'Uncharacterized protein', 1008, NULL, NULL, 98475),
(98476, '1.10.10.60-FF-000407', NULL, 'MYB transcription factor', 80, NULL, NULL, 98476),
(98477, '3.30.420.40-FF-000719', NULL, 'Actin-related protein 8', 153, NULL, NULL, 98477),
(98478, '2.80.10.50-FF-000096', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 132, NULL, NULL, 98478),
(98479, '3.80.10.10-FF-002010', NULL, 'Leucine-rich repeat (LRR) family protein', 59, NULL, NULL, 98479),
(98480, '3.30.200.110-FF-000005', NULL, 'Inositol-pentakisphosphate 2-kinase', 165, NULL, NULL, 98480),
(98481, '2.170.300.10-FF-000021', NULL, 'Platelet endothelial aggregation receptor 1', 103, NULL, NULL, 98481),
(98482, '2.60.40.10-FF-006073', NULL, NULL, 123, NULL, NULL, 98482),
(98483, '2.130.10.10-FF-000418', NULL, 'Protein HIRA', 105, NULL, NULL, 98483),
(98484, '3.40.50.300-FF-004994', NULL, 'Uncharacterized protein', 185, NULL, NULL, 98484),
(98485, '2.60.120.260-FF-000104', NULL, 'DNA repair protein XRCC1', 110, NULL, NULL, 98485),
(98486, '2.60.40.10-FF-004044', NULL, NULL, 143, NULL, NULL, 98486),
(98487, '2.60.120.200-FF-000665', NULL, 'Uncharacterized protein', 76, NULL, NULL, 98487),
(98488, '3.40.50.300-FF-001329', NULL, 'Small GTP-binding protein, putative', 187, NULL, NULL, 98488),
(98489, '2.60.120.10-FF-000685', NULL, 'Acireductone dioxygenase, putative', 78, NULL, NULL, 98489),
(98490, '3.40.50.2300-FF-000192', NULL, 'Ethylene receptor', 134, NULL, NULL, 98490),
(98491, '3.40.50.2000-FF-000063', NULL, 'Glycosyltransferase', 194, NULL, NULL, 98491),
(98492, '1.20.1270.60-FF-000216', NULL, 'Fcho-1', 273, NULL, NULL, 98492),
(98493, '3.40.50.150-FF-000418', NULL, 'Probable methyltransferase PMT11', 166, NULL, NULL, 98493),
(98494, '1.10.10.10-FF-001438', NULL, 'ATP-dependent DNA helicase', 73, NULL, NULL, 98494),
(98495, '1.10.418.10-FF-000054', NULL, 'Dixin isoform 1', 117, NULL, NULL, 98495),
(98496, '1.10.287.1150-FF-000013', NULL, '2-oxoglutarate dehydrogenase E1 component', 84, NULL, NULL, 98496),
(98497, '2.40.50.40-FF-000092', NULL, 'C-C motif chemokine', 69, NULL, NULL, 98497),
(98498, '3.30.70.20-FF-000012', NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase, mitochondrial', 96, NULL, NULL, 98498),
(98499, '1.10.510.10-FF-002826', NULL, 'Ubiquitin-binding serine/threonine protein kinase', 344, NULL, NULL, 98499),
(98500, '3.20.20.120-FF-000032', NULL, 'L-Ala-D/L-amino acid epimerase', 225, NULL, NULL, 98500),
(98501, '3.30.760.10-FF-000073', NULL, 'Uncharacterized protein', 88, NULL, NULL, 98501),
(98502, '2.40.30.10-FF-000227', NULL, 'Translation elongation factor EF1A/initiation factor IF2gamma family protein', 91, NULL, NULL, 98502),
(98503, '3.40.50.620-FF-000026', NULL, 'Methionine--tRNA ligase', 342, NULL, NULL, 98503),
(98504, '1.10.220.20-FF-000019', NULL, 'Chromosome 19, whole genome shotgun sequence', 74, NULL, NULL, 98504),
(98505, '3.30.9.10-FF-000002', NULL, 'D-amino acid dehydrogenase', 155, NULL, NULL, 98505),
(98506, '1.20.5.1190-FF-000004', NULL, 'ISWI chromatin-remodeling complex ATPase CHR11', 33, NULL, NULL, 98506),
(98507, '3.20.20.80-FF-000140', NULL, 'Glucan 1,3-beta-glucosidase 2', 396, NULL, NULL, 98507),
(98508, '3.30.450.260-FF-000015', NULL, 'Uncharacterized protein', 120, NULL, NULL, 98508),
(98509, '3.40.630.30-FF-000090', NULL, 'Glycine N-acyltransferase-like protein 1', 122, NULL, NULL, 98509),
(98510, '1.20.5.190-FF-000072', NULL, 'Class V myosin', 52, NULL, NULL, 98510),
(98511, '2.60.40.1250-FF-000002', NULL, 'Thiol:disulfide interchange protein DsbD', 138, NULL, NULL, 98511),
(98512, '3.40.50.1820-FF-000227', NULL, 'Yolk protein 2', 327, NULL, NULL, 98512);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(98513, '3.30.2350.20-FF-000044', NULL, NULL, 235, NULL, NULL, 98513),
(98514, '2.170.120.20-FF-000021', NULL, '50S ribosomal protein L25', 84, NULL, NULL, 98514),
(98515, '2.60.40.60-FF-000152', NULL, 'Cadherin 17', 118, NULL, NULL, 98515),
(98516, '3.30.1200.10-FF-000002', NULL, 'Uncharacterized ACR, YggU family COG1872, putative', 104, NULL, NULL, 98516),
(98517, '1.10.510.10-FF-000685', NULL, 'Serine/threonine-protein kinase dyf-5', 217, NULL, NULL, 98517),
(98518, '1.20.120.1080-FF-000108', NULL, 'Pre-mRNA splicing factor ATP-dependent RNA helicase, putative', 104, NULL, NULL, 98518),
(98519, '3.30.2350.10-FF-000002', NULL, 'Pseudouridine synthase', 190, NULL, NULL, 98519),
(98520, '1.25.40.20-FF-001679', NULL, 'Kinase, NEK', 76, NULL, NULL, 98520),
(98521, '1.10.486.10-FF-000054', NULL, 'RecBCD enzyme subunit RecB', 145, NULL, NULL, 98521),
(98522, '2.60.40.640-FF-000057', NULL, 'Vacuolar sorting protein 26 putative', 124, NULL, NULL, 98522),
(98523, '1.10.150.20-FF-000171', NULL, 'UvrABC system protein C', 56, NULL, NULL, 98523),
(98524, '3.40.50.1700-FF-000017', NULL, 'Glycosyl hydrolase family 3 C terminal domain containing protein', 155, NULL, NULL, 98524),
(98525, '3.30.200.20-FF-001922', NULL, 'Uncharacterized protein', 45, NULL, NULL, 98525),
(98526, '2.10.50.30-FF-000034', NULL, 'Uncharacterized protein', 44, NULL, NULL, 98526),
(98527, '3.80.10.10-FF-000773', NULL, 'EIN3-binding F-box protein 1', 58, NULL, NULL, 98527),
(98528, '2.60.40.820-FF-000038', NULL, 'Uncharacterized protein', 203, NULL, NULL, 98528),
(98529, '3.30.160.60-FF-004544', NULL, NULL, 30, NULL, NULL, 98529),
(98530, '1.25.50.20-FF-000084', NULL, 'Aminopeptidase', 331, NULL, NULL, 98530),
(98531, '2.60.40.630-FF-000015', NULL, 'Uncharacterized protein', 135, NULL, NULL, 98531),
(98532, '3.80.10.10-FF-002914', NULL, 'Uncharacterized protein', 87, NULL, NULL, 98532),
(98533, '3.30.1360.170-FF-000005', NULL, 'Flavin-dependent thymidylate synthase', 208, NULL, NULL, 98533),
(98534, '3.40.50.300-FF-006231', NULL, 'Uncharacterized protein', 153, NULL, NULL, 98534),
(98535, '1.10.468.10-FF-000001', NULL, 'Photosynthetic reaction center cytochrome c subunit', 142, NULL, NULL, 98535),
(98536, '3.40.50.150-FF-000806', NULL, 'Methyltransferase-like 22', 209, NULL, NULL, 98536),
(98537, '1.10.8.10-FF-000285', NULL, 'Uncharacterized protein', 70, NULL, NULL, 98537),
(98538, '1.20.58.2050-FF-000004', NULL, 'GINS complex subunit', 194, NULL, NULL, 98538),
(98539, '3.30.160.60-FF-005954', NULL, NULL, 23, NULL, NULL, 98539),
(98540, '3.30.1120.30-FF-000007', NULL, 'Polo like kinase 5', 25, NULL, NULL, 98540),
(98541, '1.10.167.10-FF-000049', NULL, 'Bud site selection protein rax1 homologue, putative', 117, NULL, NULL, 98541),
(98542, '1.10.246.130-FF-000029', NULL, NULL, 78, NULL, NULL, 98542),
(98543, '3.30.160.60-FF-002127', NULL, 'Uncharacterized protein', 31, NULL, NULL, 98543),
(98544, '1.10.1660.10-FF-000020', NULL, 'Transcriptional regulator', 113, NULL, NULL, 98544),
(98545, '2.60.40.10-FF-003324', NULL, NULL, 100, NULL, NULL, 98545),
(98546, '3.40.50.300-FF-008417', NULL, 'Predicted protein', 260, NULL, NULL, 98546),
(98547, '3.30.420.110-FF-000072', NULL, 'DNA mismatch repair protein MutS', 142, NULL, NULL, 98547),
(98548, '1.10.10.60-FF-001251', NULL, NULL, 72, NULL, NULL, 98548),
(98549, '1.20.58.150-FF-000020', NULL, NULL, 150, NULL, NULL, 98549),
(98550, '1.10.287.70-FF-000244', NULL, 'Ionotropic receptor 41a', 133, NULL, NULL, 98550),
(98551, '1.10.287.4070-FF-000001', NULL, 'Probable Nucleolar protein 58', 155, NULL, NULL, 98551),
(98552, '2.20.25.420-FF-000005', NULL, 'Putative zinc finger protein', 55, NULL, NULL, 98552),
(98553, '2.10.25.10-FF-001745', NULL, 'Predicted protein', 57, NULL, NULL, 98553),
(98554, '1.10.10.10-FF-000713', NULL, 'CopY/TcrY family copper transport repressor', 69, NULL, NULL, 98554),
(98555, '3.30.70.330-FF-001878', NULL, NULL, 99, NULL, NULL, 98555),
(98556, '3.40.50.300-FF-005775', NULL, 'Mitochondrial F1F0 ATP synthase, alpha subunit', 273, NULL, NULL, 98556),
(98557, '3.10.20.90-FF-000694', NULL, 'ubiquitin thioesterase OTU1', 78, NULL, NULL, 98557);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(98558, '1.10.510.10-FF-000038', NULL, 'serine/threonine-protein kinase N2 isoform X1', 205, NULL, NULL, 98558),
(98559, '1.10.1420.10-FF-000210', NULL, 'Uncharacterized protein', 170, NULL, NULL, 98559),
(98560, '3.30.2270.10-FF-000001', NULL, 'Sarcosine oxidase, delta subunit protein', 91, NULL, NULL, 98560),
(98561, '1.25.10.10-FF-000505', NULL, 'HEAT repeat-containing protein 6 isoform X1', 489, NULL, NULL, 98561),
(98562, '1.20.1250.20-FF-001125', NULL, 'MFS transporter', 191, NULL, NULL, 98562),
(98563, '1.10.510.10-FF-002242', NULL, 'Probable serine/threonine-protein kinase glkA', 256, NULL, NULL, 98563),
(98564, '3.10.450.10-FF-000082', NULL, 'Fetuin B', 101, NULL, NULL, 98564),
(98565, '3.40.50.1000-FF-000813', NULL, NULL, 123, NULL, NULL, 98565),
(98566, '3.40.50.200-FF-000187', NULL, 'Predicted protein', 109, NULL, NULL, 98566),
(98567, '4.10.260.30-FF-000002', NULL, 'Apolipoprotein C-I', 56, NULL, NULL, 98567),
(98568, '3.10.120.10-FF-000052', NULL, 'Sphingolipid 10-desaturase', 76, NULL, NULL, 98568),
(98569, '3.40.50.300-FF-003746', NULL, 'Guanylate-binding protein 4', 152, NULL, NULL, 98569),
(98570, '2.60.40.10-FF-002650', NULL, 'Frazzled', 109, NULL, NULL, 98570),
(98571, '3.40.190.290-FF-000007', NULL, 'LysR family transcriptional regulator', 202, NULL, NULL, 98571),
(98572, '1.20.1250.20-FF-002182', NULL, 'Uncharacterized protein', 167, NULL, NULL, 98572),
(98573, '3.90.850.10-FF-000010', NULL, 'FAA hydrolase family protein', 214, NULL, NULL, 98573),
(98574, '3.30.950.30-FF-000003', NULL, 'Schlafen family member 9', 128, NULL, NULL, 98574),
(98575, '1.25.40.10-FF-005280', NULL, 'Uncharacterized protein', 146, NULL, NULL, 98575),
(98576, '3.20.20.140-FF-000414', NULL, 'Uncharacterized protein', 81, NULL, NULL, 98576),
(98577, '3.20.20.140-FF-000190', NULL, 'Amidohydrolase', 331, NULL, NULL, 98577),
(98578, '3.30.40.10-FF-000799', NULL, 'E3 ubiquitin-protein ligase HEL2', 58, NULL, NULL, 98578),
(98579, '3.10.20.90-FF-000912', NULL, 'Uncharacterized protein', 75, NULL, NULL, 98579),
(98580, '2.60.40.420-FF-000019', NULL, 'Putative ephrin-B3', 144, NULL, NULL, 98580),
(98581, '2.40.10.230-FF-000017', NULL, 'Uncharacterized protein', 43, NULL, NULL, 98581),
(98582, '3.30.450.20-FF-000541', NULL, 'Two-component sensor PprA', 121, NULL, NULL, 98582),
(98583, '1.10.3430.10-FF-000003', NULL, 'Ammonium transporter', 437, NULL, NULL, 98583),
(98584, '2.60.120.200-FF-000457', NULL, 'Uncharacterized protein', 282, NULL, NULL, 98584),
(98585, '3.30.70.2760-FF-000012', NULL, NULL, 101, NULL, NULL, 98585),
(98586, '3.30.70.3490-FF-000028', NULL, 'Oxysterol binding protein (Osh3), putative (AFU_orthologue AFUA_3G05880)', 75, NULL, NULL, 98586),
(98587, '3.30.1490.20-FF-000048', NULL, 'D-alanine--D-alanine ligase', 63, NULL, NULL, 98587),
(98588, '2.30.40.10-FF-000133', NULL, 'D-phenylhydantoinase protein', 118, NULL, NULL, 98588),
(98589, '3.60.20.40-FF-000036', NULL, 'Uncharacterized protein', 67, NULL, NULL, 98589),
(98590, '3.40.1370.10-FF-000034', NULL, '50S ribosomal protein L4', 207, NULL, NULL, 98590),
(98591, '2.70.170.10-FF-000180', NULL, 'Protein CBG10414', 130, NULL, NULL, 98591),
(98592, '3.40.1000.10-FF-000007', NULL, 'RGM domain family member B', 166, NULL, NULL, 98592),
(98593, '3.40.720.10-FF-000315', NULL, 'Uncharacterized protein', 196, NULL, NULL, 98593),
(98594, '1.20.58.530-FF-000038', NULL, NULL, 141, NULL, NULL, 98594),
(98595, '1.25.40.10-FF-000221', NULL, 'Mitochondrial import receptor subunit TOM34', 127, NULL, NULL, 98595),
(98596, '2.130.10.10-FF-001262', NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', 335, NULL, NULL, 98596),
(98597, '2.60.40.3180-FF-000013', NULL, 'Uncharacterized protein', 29, NULL, NULL, 98597),
(98598, '1.20.1070.10-FF-001563', NULL, 'Uncharacterized protein', 169, NULL, NULL, 98598),
(98599, '3.40.50.2000-FF-000271', NULL, 'Lipopolysaccharide heptosyltransferase II', 145, NULL, NULL, 98599),
(98600, '1.10.418.10-FF-000178', NULL, 'PLaSTin (Actin bundling protein) homolog', 102, NULL, NULL, 98600),
(98601, '3.10.50.10-FF-000014', NULL, 'Class V chitinase Chi100', 78, NULL, NULL, 98601);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(98602, '3.30.1370.110-FF-000001', NULL, 'DNA endonuclease SmrA', 137, NULL, NULL, 98602),
(98603, '2.70.170.10-FF-000028', NULL, 'AcetylCholine Receptor', 216, NULL, NULL, 98603),
(98604, '3.10.20.90-FF-000171', NULL, 'Small ubiquitin-related modifier', 94, NULL, NULL, 98604),
(98605, '1.25.10.10-FF-000713', NULL, 'Beta-catenin-like protein hmp-2', 562, NULL, NULL, 98605),
(98606, '3.40.50.300-FF-002577', NULL, 'RuvB-like helicase', 143, NULL, NULL, 98606),
(98607, '1.10.287.850-FF-000006', NULL, 'PE family protein PE22', 98, NULL, NULL, 98607),
(98608, '3.90.470.10-FF-000043', NULL, 'Uncharacterized protein', 129, NULL, NULL, 98608),
(98609, '3.40.50.1820-FF-000379', NULL, 'Neuroligin 1', 127, NULL, NULL, 98609),
(98610, '3.40.50.1100-FF-000276', NULL, 'Cysteine synthase', 103, NULL, NULL, 98610),
(98611, '3.30.70.1430-FF-000006', NULL, 'Putative cation efflux system protein CusA', 103, NULL, NULL, 98611),
(98612, '3.30.450.20-FF-000384', NULL, 'Sensory transduction histidine kinase', 122, NULL, NULL, 98612),
(98613, '3.40.1110.10-FF-000392', NULL, NULL, 110, NULL, NULL, 98613),
(98614, '3.30.70.60-FF-000024', NULL, 'EF-1 guanine nucleotide exchange domain-containing protein', 95, NULL, NULL, 98614),
(98615, '2.40.110.10-FF-000003', NULL, 'Acyl-coenzyme A oxidase', 139, NULL, NULL, 98615),
(98616, '1.20.58.390-FF-000249', NULL, 'Uncharacterized protein', 116, NULL, NULL, 98616),
(98617, '3.30.565.10-FF-000113', NULL, 'Histidine phosphotransferase', 133, NULL, NULL, 98617),
(98618, '2.40.10.10-FF-000552', NULL, NULL, 76, NULL, NULL, 98618),
(98619, '3.60.15.10-FF-000190', NULL, 'Putative metallo-beta-lactamase-like protein', 128, NULL, NULL, 98619),
(98620, '2.10.25.10-FF-001588', NULL, 'Uncharacterized protein', 30, NULL, NULL, 98620),
(98621, '1.20.5.110-FF-000087', NULL, 'SNARE protein, putative', 76, NULL, NULL, 98621),
(98622, '3.40.1810.10-FF-000018', NULL, 'agamous-like MADS-box protein AGL80', 85, NULL, NULL, 98622),
(98623, '3.40.50.80-FF-000039', NULL, 'Ferric reduction oxidase 3', 118, NULL, NULL, 98623),
(98624, '3.30.70.330-FF-000529', NULL, 'UBP1-associated protein 2C isoform A', 104, NULL, NULL, 98624),
(98625, '1.20.1560.10-FF-000538', NULL, 'ATP-binding cassette subfamily C member 6', 336, NULL, NULL, 98625),
(98626, '3.40.50.2300-FF-000271', NULL, 'DNA-binding response regulator', 138, NULL, NULL, 98626),
(98627, '3.30.470.20-FF-000216', NULL, 'Alpha-L-glutamate ligases, RimK family', 116, NULL, NULL, 98627),
(98628, '3.10.105.10-FF-000073', NULL, 'Dipeptide-binding lipoprotein', 231, NULL, NULL, 98628),
(98629, '2.60.40.10-FF-004948', NULL, NULL, 98, NULL, NULL, 98629),
(98630, '1.20.1020.10-FF-000003', NULL, 'Histone acetyltransferase HAC1-like protein', 118, NULL, NULL, 98630),
(98631, '3.90.470.20-FF-000017', NULL, 'Phosphopantetheine-protein transferase domain protein', 102, NULL, NULL, 98631),
(98632, '3.40.50.150-FF-000694', NULL, 'Methyltransferase', 233, NULL, NULL, 98632),
(98633, '3.40.50.10860-FF-000044', NULL, 'Pentafunctional AROM polypeptide, putative', 98, NULL, NULL, 98633),
(98634, '1.20.120.330-FF-000040', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 152, NULL, NULL, 98634),
(98635, '1.25.40.10-FF-002519', NULL, 'Adenylate cyclase', 165, NULL, NULL, 98635),
(98636, '3.80.10.10-FF-003999', NULL, 'Uncharacterized protein', 152, NULL, NULL, 98636),
(98637, '1.25.10.10-FF-002861', NULL, 'Uncharacterized protein', 163, NULL, NULL, 98637),
(98638, '3.10.50.40-FF-000118', NULL, 'Peptidylprolyl isomerase', 123, NULL, NULL, 98638),
(98639, '3.90.550.20-FF-000018', NULL, 'Glycoside transferase family 32', 226, NULL, NULL, 98639),
(98640, '1.10.510.10-FF-000409', NULL, 'CMGC/SRPK protein kinase', 174, NULL, NULL, 98640),
(98641, '3.80.10.10-FF-000565', NULL, 'Leucine-rich repeat receptor-like kinase protein FLORAL ORGAN NUMBER1', 113, NULL, NULL, 98641),
(98642, '3.90.190.20-FF-000035', NULL, 'Bifunctional folylpolyglutamate synthase/dihydrofolate synthase', 131, NULL, NULL, 98642),
(98643, '3.40.640.10-FF-000314', NULL, 'Aspartate aminotransferase', 274, NULL, NULL, 98643);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(98644, '3.40.50.300-FF-007809', NULL, 'Predicted protein', 31, NULL, NULL, 98644),
(98645, '1.10.10.980-FF-000005', NULL, 'CST complex subunit STN1', 101, NULL, NULL, 98645),
(98646, '1.20.58.900-FF-000003', NULL, 'DENN domain containing 5A', 105, NULL, NULL, 98646),
(98647, '3.40.910.10-FF-000026', NULL, 'Deoxyhypusine synthase', 121, NULL, NULL, 98647),
(98648, '1.10.287.70-FF-000036', NULL, 'ATP-sensitive inward rectifier potassium channel 1', 132, NULL, NULL, 98648),
(98649, '3.40.980.10-FF-000031', NULL, 'Predicted protein', 167, NULL, NULL, 98649),
(98650, '1.20.1560.10-FF-000038', NULL, 'ABC transporter B family member 19', 637, NULL, NULL, 98650),
(98651, '2.130.10.10-FF-002043', NULL, 'Uncharacterized protein', 197, NULL, NULL, 98651),
(98652, '3.30.497.10-FF-000067', NULL, 'Serpin family B member 10', 225, NULL, NULL, 98652),
(98653, '1.25.10.10-FF-002922', NULL, 'Uncharacterized protein', 103, NULL, NULL, 98653),
(98654, '2.40.100.10-FF-000053', NULL, 'Peptidyl-prolyl cis-trans isomerase', 166, NULL, NULL, 98654),
(98655, '3.90.80.10-FF-000018', NULL, 'Inorganic pyrophosphatase, putative', 230, NULL, NULL, 98655),
(98656, '3.40.50.1000-FF-000313', NULL, 'Phospholipid-transporting ATPase IH-like protein', 110, NULL, NULL, 98656),
(98657, '1.20.1310.20-FF-000028', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 201, NULL, NULL, 98657),
(98658, '2.130.10.10-FF-001767', NULL, 'Putative WD40 domain protein', 370, NULL, NULL, 98658),
(98659, '3.40.50.1010-FF-000018', NULL, 'RNA-binding protein NOB1', 121, NULL, NULL, 98659),
(98660, '2.30.30.30-FF-000133', NULL, 'Translation elongation factor P', 62, NULL, NULL, 98660),
(98661, '1.20.120.1630-FF-000026', NULL, 'Uncharacterized protein', 197, NULL, NULL, 98661),
(98662, '3.40.140.10-FF-000136', NULL, 'COP9 signalosome complex subunit 6', 192, NULL, NULL, 98662),
(98663, '3.40.50.2000-FF-000624', NULL, 'Putative TPR repeat family protein', 164, NULL, NULL, 98663),
(98664, '2.60.260.20-FF-000052', NULL, 'Chaperone DnaJ', 63, NULL, NULL, 98664),
(98665, '3.30.450.20-FF-000041', NULL, 'Adagio protein 1', 132, NULL, NULL, 98665),
(98666, '1.10.760.10-FF-000085', NULL, 'Probable cytochrome-c peroxidase', 176, NULL, NULL, 98666),
(98667, '3.60.21.10-FF-000243', NULL, 'Protein CBG11338', 299, NULL, NULL, 98667),
(98668, '1.10.510.10-FF-001466', NULL, 'Uncharacterized protein', 271, NULL, NULL, 98668),
(98669, '1.25.10.10-FF-003378', NULL, 'Uncharacterized protein', 149, NULL, NULL, 98669),
(98670, '1.10.10.60-FF-000475', NULL, 'Transcription factor MYB36', 62, NULL, NULL, 98670),
(98671, '3.40.50.1110-FF-000166', NULL, 'Predicted protein', 252, NULL, NULL, 98671),
(98672, '2.60.40.10-FF-001458', NULL, 'EBF transcription factor 3b', 92, NULL, NULL, 98672),
(98673, '2.60.40.10-FF-004448', NULL, NULL, 111, NULL, NULL, 98673),
(98674, '3.30.428.10-FF-000060', NULL, 'M7GpppX diphosphatase', 98, NULL, NULL, 98674),
(98675, '2.60.34.10-FF-000056', NULL, 'Protein CBG18239', 57, NULL, NULL, 98675),
(98676, '1.10.533.10-FF-000254', NULL, 'CASP8 and FADD-like apoptosis regulator a', 91, NULL, NULL, 98676),
(98677, '2.130.10.10-FF-004376', NULL, 'Uncharacterized protein', 79, NULL, NULL, 98677),
(98678, '2.60.40.10-FF-005741', NULL, NULL, 105, NULL, NULL, 98678),
(98679, '3.30.200.20-FF-002462', NULL, NULL, 54, NULL, NULL, 98679),
(98680, '3.30.40.10-FF-001816', NULL, 'Uncharacterized protein', 97, NULL, NULL, 98680),
(98681, '3.30.70.260-FF-000132', NULL, 'Lysine-sensitive aspartokinase 3', 71, NULL, NULL, 98681),
(98682, '1.10.510.10-FF-002747', NULL, NULL, 75, NULL, NULL, 98682),
(98683, '1.25.10.10-FF-000152', NULL, 'Ectoderm-expressed 4, isoform G', 188, NULL, NULL, 98683),
(98684, '3.30.450.40-FF-000047', NULL, 'IclR family transcriptional regulator', 173, NULL, NULL, 98684),
(98685, '3.90.260.10-FF-000038', NULL, 'Putative transglutaminase/protease-like protein', 102, NULL, NULL, 98685),
(98686, '3.40.50.200-FF-000052', NULL, 'Serine protease, putative', 387, NULL, NULL, 98686),
(98687, '3.40.50.150-FF-001150', NULL, 'Herbicide safener binding protein', 252, NULL, NULL, 98687);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(98688, '1.10.510.10-FF-000561', NULL, 'AKT serine/threonine kinase 1', 108, NULL, NULL, 98688),
(98689, '1.10.1410.10-FF-000041', NULL, 'Tailor, isoform C', 207, NULL, NULL, 98689),
(98690, '2.60.40.10-FF-000233', NULL, 'Myomesin 1', 115, NULL, NULL, 98690),
(98691, '4.10.40.20-FF-000008', NULL, 'Crimpy, isoform C', 75, NULL, NULL, 98691),
(98692, '1.25.10.10-FF-000781', NULL, 'HEAT repeat domain containing protein', 404, NULL, NULL, 98692),
(98693, '3.40.50.1220-FF-000087', NULL, 'ADR254Wp', 154, NULL, NULL, 98693),
(98694, '1.10.238.10-FF-000585', NULL, 'Calcium-dependent protein kinase-a', 100, NULL, NULL, 98694),
(98695, '2.60.120.650-FF-000215', NULL, 'Uncharacterized protein', 285, NULL, NULL, 98695),
(98696, '3.30.60.30-FF-000008', NULL, 'Transmembrane agrin', 63, NULL, NULL, 98696),
(98697, '1.10.10.1320-FF-000012', NULL, 'Anti-ECFsigma factor ChrR', 121, NULL, NULL, 98697),
(98698, '1.10.530.10-FF-000040', NULL, 'Lysin A', 171, NULL, NULL, 98698),
(98699, '3.30.70.560-FF-000020', NULL, 'Uncharacterized protein', 92, NULL, NULL, 98699),
(98700, '3.40.50.1000-FF-000072', NULL, 'Phosphonoacetaldehyde hydrolase', 177, NULL, NULL, 98700),
(98701, '3.30.710.10-FF-000250', NULL, 'Myoneurin', 125, NULL, NULL, 98701),
(98702, '3.40.1280.30-FF-000033', NULL, 'Uncharacterized protein', 199, NULL, NULL, 98702),
(98703, '3.60.10.10-FF-000279', NULL, 'Uncharacterized protein', 124, NULL, NULL, 98703),
(98704, '2.10.25.10-FF-001824', NULL, 'Uncharacterized protein', 44, NULL, NULL, 98704),
(98705, '1.25.40.10-FF-004936', NULL, 'Uncharacterized protein', 203, NULL, NULL, 98705),
(98706, '1.50.10.10-FF-000149', NULL, 'alpha-1,2-Mannosidase', 365, NULL, NULL, 98706),
(98707, '3.30.40.10-FF-000294', NULL, 'Nuclear autoantigen Sp-100', 53, NULL, NULL, 98707),
(98708, '1.20.1110.10-FF-000162', NULL, NULL, 59, NULL, NULL, 98708),
(98709, '3.40.50.880-FF-000076', NULL, 'CTP synthase', 235, NULL, NULL, 98709),
(98710, '1.20.1270.10-FF-000050', NULL, 'Chaperone protein HscA homolog', 95, NULL, NULL, 98710),
(98711, '3.80.10.10-FF-002982', NULL, 'Uncharacterized protein', 75, NULL, NULL, 98711),
(98712, '1.20.1640.10-FF-000039', NULL, 'Protein-export membrane protein SecF', 213, NULL, NULL, 98712),
(98713, '1.20.58.1610-FF-000001', NULL, 'NAD(P)H-quinone oxidoreductase subunit 3, chloroplastic', 120, NULL, NULL, 98713),
(98714, '2.30.42.10-FF-000587', NULL, NULL, 107, NULL, NULL, 98714),
(98715, '3.30.40.10-FF-002008', NULL, 'Uncharacterized protein', 50, NULL, NULL, 98715),
(98716, '2.60.120.620-FF-000055', NULL, 'egl nine homolog 3 isoform X2', 141, NULL, NULL, 98716),
(98717, '3.40.50.620-FF-000346', NULL, 'Nicotinamide-nucleotide adenylyltransferase', 221, NULL, NULL, 98717),
(98718, '3.30.160.60-FF-003184', NULL, 'Uncharacterized protein, isoform E', 24, NULL, NULL, 98718),
(98719, '3.20.20.70-FF-000316', NULL, 'Dihydrodipicolinate synthetase family protein', 294, NULL, NULL, 98719),
(98720, '3.40.190.10-FF-000471', NULL, 'Peptide ABC transporter permease protein', 133, NULL, NULL, 98720),
(98721, '2.20.28.10-FF-000060', NULL, 'Uncharacterized protein', 64, NULL, NULL, 98721),
(98722, '3.30.70.330-FF-000861', NULL, 'Rim4p', 131, NULL, NULL, 98722),
(98723, '1.25.40.180-FF-000115', NULL, 'Protein CBR-SMG-3', 264, NULL, NULL, 98723),
(98724, '2.60.120.330-FF-000125', NULL, 'Uncharacterized protein', 171, NULL, NULL, 98724),
(98725, '3.40.630.30-FF-000314', NULL, 'Alpha-tubulin N-acetyltransferase 2', 186, NULL, NULL, 98725),
(98726, '1.20.58.60-FF-000388', NULL, 'Uncharacterized protein', 119, NULL, NULL, 98726),
(98727, '3.30.420.40-FF-000871', NULL, 'Uncharacterized protein', 72, NULL, NULL, 98727),
(98728, '3.30.70.330-FF-003115', NULL, NULL, 68, NULL, NULL, 98728),
(98729, '3.30.530.20-FF-000042', NULL, 'StAR-related lipid transfer protein', 232, NULL, NULL, 98729),
(98730, '2.120.10.30-FF-000110', NULL, 'Probable cytochrome c', 348, NULL, NULL, 98730),
(98731, '2.10.25.10-FF-000464', NULL, 'Adhesion G protein-coupled receptor E1', 45, NULL, NULL, 98731),
(98732, '1.25.40.10-FF-005212', NULL, 'Uncharacterized protein', 386, NULL, NULL, 98732);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(98733, '1.25.40.10-FF-002019', NULL, 'Pentatricopeptide repeat-containing protein', 153, NULL, NULL, 98733),
(98734, '1.10.287.110-FF-000077', NULL, 'Translocation protein SEC63', 79, NULL, NULL, 98734),
(98735, '2.130.10.10-FF-000486', NULL, 'DDB1- and CUL4-associated factor 12-like protein 2', 156, NULL, NULL, 98735),
(98736, '1.10.238.10-FF-000309', NULL, 'Chromosome 21, whole genome shotgun sequence', 102, NULL, NULL, 98736),
(98737, '2.40.10.10-FF-000052', NULL, 'Neutrophil elastase', 114, NULL, NULL, 98737),
(98738, '3.90.1170.10-FF-000030', NULL, 'Uncharacterized protein', 92, NULL, NULL, 98738),
(98739, '1.25.40.10-FF-000721', NULL, 'Empty pericarp7', 92, NULL, NULL, 98739),
(98740, '3.40.50.300-FF-004090', NULL, 'RNase L inhibitor', 247, NULL, NULL, 98740),
(98741, '1.10.510.10-FF-003023', NULL, NULL, 228, NULL, NULL, 98741),
(98742, '3.40.50.11660-FF-000008', NULL, 'Alpha-(1,3)-fucosyltransferase', 215, NULL, NULL, 98742),
(98743, '1.20.58.1040-FF-000021', NULL, '1,3-beta-glucanosyltransferase', 119, NULL, NULL, 98743),
(98744, '1.20.1250.20-FF-000849', NULL, 'Multidrug transporter', 210, NULL, NULL, 98744),
(98745, '1.10.472.10-FF-000516', NULL, 'Predicted protein', 186, NULL, NULL, 98745),
(98746, '1.20.272.40-FF-000002', NULL, 'ATP-dependent RNA helicase SUV3, mitochondrial', 79, NULL, NULL, 98746),
(98747, '2.40.170.20-FF-000004', NULL, 'FhuE outer membrane receptor', 543, NULL, NULL, 98747),
(98748, '3.70.10.10-FF-000138', NULL, 'Uncharacterized protein', 126, NULL, NULL, 98748),
(98749, '2.60.40.10-FF-001790', NULL, 'Terribly reduced optic lobes, isoform AM', 86, NULL, NULL, 98749),
(98750, '3.40.50.11610-FF-000022', NULL, NULL, 127, NULL, NULL, 98750),
(98751, '1.10.510.10-FF-000617', NULL, 'Serine/threonine-protein kinase UCNL', 126, NULL, NULL, 98751),
(98752, '1.20.58.480-FF-000012', NULL, 'Indoleamine 2,3-dioxygenase', 268, NULL, NULL, 98752),
(98753, '2.40.30.10-FF-000166', NULL, 'Ribosome-releasing factor 2, mitochondrial', 106, NULL, NULL, 98753),
(98754, '2.60.120.260-FF-000025', NULL, 'DNA repair protein XRCC1 isoform X1', 151, NULL, NULL, 98754),
(98755, '2.60.40.60-FF-000675', NULL, 'Cadherin-related hmr-1', 123, NULL, NULL, 98755),
(98756, '3.30.160.60-FF-006230', NULL, NULL, 30, NULL, NULL, 98756),
(98757, '3.90.550.10-FF-000369', NULL, 'Galactosylgalactosylxylosylprotein 3-beta-glucuronosyltransferase', 126, NULL, NULL, 98757),
(98758, '1.25.10.10-FF-000629', NULL, 'Unc-45', 429, NULL, NULL, 98758),
(98759, '1.20.1070.10-FF-000506', NULL, 'Adrenoceptor alpha 1Ab', 348, NULL, NULL, 98759),
(98760, '2.60.40.1730-FF-000084', NULL, NULL, 170, NULL, NULL, 98760),
(98761, '1.10.357.150-FF-000015', NULL, 'Chromosome 19, whole genome shotgun sequence', 196, NULL, NULL, 98761),
(98762, '1.25.40.10-FF-001238', NULL, 'Pentatricopeptide repeat-containing protein At3g22690', 127, NULL, NULL, 98762),
(98763, '3.40.50.1820-FF-001008', NULL, 'Uncharacterized protein', 224, NULL, NULL, 98763),
(98764, '1.20.1070.10-FF-000782', NULL, 'Parietopsin', 299, NULL, NULL, 98764),
(98765, '1.25.40.430-FF-000005', NULL, 'Mad3/BUB1 homology region 1', 158, NULL, NULL, 98765),
(98766, '1.10.555.10-FF-000035', NULL, 'Phosphatidylinositol 3-kinase regulatory subunit alpha', 216, NULL, NULL, 98766),
(98767, '3.40.190.10-FF-000139', NULL, 'LysR family transcriptional regulator', 90, NULL, NULL, 98767),
(98768, '2.130.10.10-FF-001503', NULL, 'DDB1-and CUL4-associated factor', 260, NULL, NULL, 98768),
(98769, '3.40.50.1000-FF-000633', NULL, NULL, 75, NULL, NULL, 98769),
(98770, '1.10.1040.10-FF-000052', NULL, 'Mitochondrial translational activator', 136, NULL, NULL, 98770),
(98771, '2.60.40.150-FF-000585', NULL, 'Predicted protein', 143, NULL, NULL, 98771),
(98772, '3.40.50.2000-FF-000888', NULL, 'Lipid-A-disaccharide synthase', 179, NULL, NULL, 98772),
(98773, '3.90.1150.10-FF-000046', NULL, 'Acetylornithine aminotransferase, mitochondrial', 114, NULL, NULL, 98773),
(98774, '3.40.30.10-FF-000944', NULL, 'Predicted protein', 110, NULL, NULL, 98774),
(98775, '3.30.420.40-FF-000950', NULL, 'Actin-related protein 8', 69, NULL, NULL, 98775);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(98776, '2.40.50.140-FF-000335', NULL, 'Uncharacterized protein', 61, NULL, NULL, 98776),
(98777, '3.30.559.10-FF-000060', NULL, 'Diacylglycerol O-acyltransferase', 170, NULL, NULL, 98777),
(98778, '3.40.50.300-FF-002841', NULL, 'Ras-related protein Rab-33', 204, NULL, NULL, 98778),
(98779, '3.30.160.60-FF-006410', NULL, NULL, 60, NULL, NULL, 98779),
(98780, '3.40.50.300-FF-003241', NULL, 'Dicer-like protein', 138, NULL, NULL, 98780),
(98781, '3.60.20.10-FF-000229', NULL, NULL, 105, NULL, NULL, 98781),
(98782, '2.20.70.10-FF-000219', NULL, 'Zygote-specific protein 3', 56, NULL, NULL, 98782),
(98783, '1.20.1280.50-FF-000040', NULL, 'protein UNUSUAL FLORAL ORGANS', 45, NULL, NULL, 98783),
(98784, '3.40.50.2300-FF-001613', NULL, NULL, 38, NULL, NULL, 98784),
(98785, '1.10.1900.10-FF-000005', NULL, 'Poly(A) binding protein cytoplasmic 1 like', 82, NULL, NULL, 98785),
(98786, '1.25.40.10-FF-004375', NULL, 'Uncharacterized protein', 147, NULL, NULL, 98786),
(98787, '2.130.10.10-FF-005477', NULL, 'WD-40 repeat-containing protein', 312, NULL, NULL, 98787),
(98788, '3.10.350.10-FF-000097', NULL, 'Intracellular hyphae protein 1', 64, NULL, NULL, 98788),
(98789, '3.40.50.300-FF-006152', NULL, 'Os03g0181750 protein', 69, NULL, NULL, 98789),
(98790, '3.90.1150.220-FF-000012', NULL, 'Uncharacterized protein', 77, NULL, NULL, 98790),
(98791, '3.40.190.290-FF-000075', NULL, 'LysR family transcriptional regulator', 201, NULL, NULL, 98791),
(98792, '3.30.1010.10-FF-000111', NULL, 'Serine/threonine-protein kinase Tel1', 119, NULL, NULL, 98792),
(98793, '3.40.50.300-FF-001560', NULL, 'Rab family GTPase', 195, NULL, NULL, 98793),
(98794, '3.10.100.10-FF-000207', NULL, 'Lymphocyte antigen 75', 131, NULL, NULL, 98794),
(98795, '4.10.410.10-FF-000093', NULL, 'Serine protease inhibitor, putative', 59, NULL, NULL, 98795),
(98796, '3.20.20.100-FF-000138', NULL, 'Uncharacterized protein', 301, NULL, NULL, 98796),
(98797, '3.40.50.10190-FF-000365', NULL, 'BRCT domain protein (Eurofung)', 86, NULL, NULL, 98797),
(98798, '3.30.420.10-FF-000435', NULL, 'DNA polymerase', 276, NULL, NULL, 98798),
(98799, '3.40.850.10-FF-000139', NULL, 'Kinesin-like protein', 364, NULL, NULL, 98799),
(98800, '1.10.10.440-FF-000017', NULL, 'Rho GTPase activating protein 35', 68, NULL, NULL, 98800),
(98801, '1.10.1370.30-FF-000043', NULL, 'Angiotensin-converting enzyme', 149, NULL, NULL, 98801),
(98802, '1.20.920.10-FF-000146', NULL, 'YALI0E32307p', 137, NULL, NULL, 98802),
(98803, '2.70.20.10-FF-000029', NULL, 'DNA topoisomerase', 29, NULL, NULL, 98803),
(98804, '3.40.50.300-FF-002965', NULL, 'Cell division control protein', 220, NULL, NULL, 98804),
(98805, '1.50.40.10-FF-000365', NULL, 'Mitochondrial carrier protein-like protein', 152, NULL, NULL, 98805),
(98806, '2.60.40.10-FF-000098', NULL, 'receptor-type tyrosine-protein phosphatase F isoform X1', 101, NULL, NULL, 98806),
(98807, '2.60.40.10-FF-004105', NULL, NULL, 93, NULL, NULL, 98807),
(98808, '2.60.40.10-FF-002419', NULL, 'T cell receptor delta constant', 100, NULL, NULL, 98808),
(98809, '3.30.1460.50-FF-000027', NULL, 'Autophagy-related protein 10', 140, NULL, NULL, 98809),
(98810, '3.40.630.10-FF-000432', NULL, 'Uncharacterized protein', 262, NULL, NULL, 98810),
(98811, '3.30.70.3400-FF-000013', NULL, 'Protein translocase subunit SecD', 83, NULL, NULL, 98811),
(98812, '3.40.50.720-FF-001899', NULL, 'Uncharacterized protein', 202, NULL, NULL, 98812),
(98813, '3.40.1260.20-FF-000001', NULL, 'Ribonuclease G Rng', 87, NULL, NULL, 98813),
(98814, '2.30.30.380-FF-000012', NULL, 'Protein transport protein Sec24A', 72, NULL, NULL, 98814),
(98815, '1.10.20.10-FF-000039', NULL, 'Nuclear transcription Y subunit beta', 119, NULL, NULL, 98815),
(98816, '3.40.50.300-FF-000609', NULL, 'PrkA family serine protein kinase', 83, NULL, NULL, 98816),
(98817, '2.40.50.140-FF-001184', NULL, NULL, 151, NULL, NULL, 98817),
(98818, '2.40.10.10-FF-000631', NULL, NULL, 234, NULL, NULL, 98818),
(98819, '1.25.40.10-FF-000541', NULL, 'Pentatricopeptide repeat-containing protein', 153, NULL, NULL, 98819),
(98820, '1.10.287.70-FF-000379', NULL, 'TOK potassium channel', 140, NULL, NULL, 98820);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(98821, '3.30.1380.20-FF-000046', NULL, 'Uncharacterized protein', 161, NULL, NULL, 98821),
(98822, '3.90.70.10-FF-000012', NULL, 'ubiquitin carboxyl-terminal hydrolase 19 isoform X2', 258, NULL, NULL, 98822),
(98823, '2.60.120.1000-FF-000034', NULL, 'Uncharacterized protein', 223, NULL, NULL, 98823),
(98824, '1.10.1450.10-FF-000162', NULL, 'Uncharacterized protein', 70, NULL, NULL, 98824),
(98825, '3.40.50.720-FF-001511', NULL, 'Malate dehydrogenase 1Aa, NAD (soluble)', 95, NULL, NULL, 98825),
(98826, '2.30.30.40-FF-000231', NULL, 'Rho GTPase activating protein 27', 66, NULL, NULL, 98826),
(98827, '3.40.50.1970-FF-000053', NULL, NULL, 162, NULL, NULL, 98827),
(98828, '3.30.200.20-FF-001181', NULL, 'CMGC/CDK/CDK7 protein kinase, variant', 39, NULL, NULL, 98828),
(98829, '3.30.230.10-FF-000044', NULL, 'elongation factor-like GTPase 1 isoform X1', 191, NULL, NULL, 98829),
(98830, '3.40.50.12780-FF-000041', NULL, 'very long-chain-fatty-acid--CoA ligase bubblegum', 423, NULL, NULL, 98830),
(98831, '2.30.130.40-FF-000038', NULL, 'Lon protease homolog, mitochondrial', 110, NULL, NULL, 98831),
(98832, '3.90.550.10-FF-000549', NULL, 'Uncharacterized protein', 132, NULL, NULL, 98832),
(98833, '1.25.40.10-FF-002750', NULL, 'Uncharacterized protein', 200, NULL, NULL, 98833),
(98834, '3.40.50.10990-FF-000009', NULL, '3,4-dihydroxy-2-butanone-4-phosphate synthase/GTP cyclohydrolase II', 135, NULL, NULL, 98834),
(98835, '2.60.40.60-FF-000495', NULL, 'AGAP006731-PA', 92, NULL, NULL, 98835),
(98836, '2.130.10.10-FF-004937', NULL, 'Uncharacterized protein', 102, NULL, NULL, 98836),
(98837, '1.10.220.10-FF-000050', NULL, 'Nex-1', 89, NULL, NULL, 98837),
(98838, '2.160.10.10-FF-000114', NULL, 'Predicted protein', 77, NULL, NULL, 98838),
(98839, '3.30.830.10-FF-000022', NULL, 'mitochondrial-processing peptidase subunit alpha', 209, NULL, NULL, 98839),
(98840, '3.30.200.20-FF-001742', NULL, 'Fructosamine-3-kinase', 91, NULL, NULL, 98840),
(98841, '3.30.2020.30-FF-000028', NULL, 'Uncharacterized protein', 104, NULL, NULL, 98841),
(98842, '1.10.357.70-FF-000031', NULL, 'Si:dkey-196h17.9', 148, NULL, NULL, 98842),
(98843, '1.25.40.20-FF-001859', NULL, 'No mechanoreceptor potential C, isoform F', 134, NULL, NULL, 98843),
(98844, '3.40.630.30-FF-000590', NULL, 'Uncharacterized protein', 87, NULL, NULL, 98844),
(98845, '1.20.58.60-FF-000045', NULL, 'Short stop, isoform K', 112, NULL, NULL, 98845),
(98846, '3.40.190.10-FF-000291', NULL, 'Glutamate receptor', 125, NULL, NULL, 98846),
(98847, '3.10.180.10-FF-000117', NULL, '4-hydroxyphenylpyruvate dioxygenase', 170, NULL, NULL, 98847),
(98848, '2.60.120.260-FF-000368', NULL, 'Uncharacterized protein', 151, NULL, NULL, 98848),
(98849, '3.30.160.60-FF-004201', NULL, NULL, 48, NULL, NULL, 98849),
(98850, '3.10.10.10-FF-000017', NULL, 'Os04g0191000 protein', 112, NULL, NULL, 98850),
(98851, '3.40.50.300-FF-000048', NULL, 'Transitional endoplasmic reticulum ATPase', 184, NULL, NULL, 98851),
(98852, '3.40.50.2300-FF-000776', NULL, NULL, 162, NULL, NULL, 98852),
(98853, '1.20.1070.10-FF-001299', NULL, 'Predicted protein', 138, NULL, NULL, 98853),
(98854, '3.40.50.300-FF-008029', NULL, 'Predicted protein', 138, NULL, NULL, 98854),
(98855, '1.20.1250.20-FF-000669', NULL, 'MonoCarboxylate Transporter family', 233, NULL, NULL, 98855),
(98856, '3.90.550.10-FF-000026', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 363, NULL, NULL, 98856),
(98857, '3.30.160.60-FF-000047', NULL, 'zinc finger protein OZF', 28, NULL, NULL, 98857),
(98858, '3.10.330.10-FF-000034', NULL, 'Predicted protein', 98, NULL, NULL, 98858),
(98859, '1.20.1250.40-FF-000035', NULL, 'Uncharacterized protein', 170, NULL, NULL, 98859),
(98860, '2.60.40.1180-FF-000166', NULL, 'Alpha-mannosidase', 114, NULL, NULL, 98860),
(98861, '3.40.50.1820-FF-001284', NULL, 'UPF0613 protein PB24D3.06c', 288, NULL, NULL, 98861),
(98862, '3.30.1370.120-FF-000015', NULL, 'Type II secretion system protein D', 72, NULL, NULL, 98862),
(98863, '3.30.420.110-FF-000004', NULL, 'DNA mismatch repair protein', 197, NULL, NULL, 98863);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(98864, '3.30.1330.20-FF-000043', NULL, 'Cell division protein FtsZ', 115, NULL, NULL, 98864),
(98865, '3.40.50.2300-FF-001052', NULL, NULL, 133, NULL, NULL, 98865),
(98866, '1.10.472.80-FF-000200', NULL, NULL, 164, NULL, NULL, 98866),
(98867, '2.30.29.30-FF-001118', NULL, 'Uncharacterized protein', 134, NULL, NULL, 98867),
(98868, '3.30.565.10-FF-000181', NULL, 'Sensor histidine kinase', 151, NULL, NULL, 98868),
(98869, '2.100.10.30-FF-000004', NULL, 'Zymogen granule protein 16B', 151, NULL, NULL, 98869),
(98870, '3.30.70.330-FF-001249', NULL, 'RNA-binding protein, putative', 138, NULL, NULL, 98870),
(98871, '3.40.50.720-FF-002175', NULL, 'Uncharacterized protein', 63, NULL, NULL, 98871),
(98872, '3.30.559.30-FF-000066', NULL, 'NonRibosomal Peptide Synthetase', 98, NULL, NULL, 98872),
(98873, '1.10.268.10-FF-000025', NULL, NULL, 149, NULL, NULL, 98873),
(98874, '3.30.70.330-FF-002542', NULL, NULL, 43, NULL, NULL, 98874),
(98875, '2.160.20.10-FF-000272', NULL, 'Uncharacterized protein', 282, NULL, NULL, 98875),
(98876, '2.30.30.40-FF-000198', NULL, 'Guanine nucleotide exchange factor DBS', 62, NULL, NULL, 98876),
(98877, '3.30.160.60-FF-000547', NULL, 'PR domain zinc finger protein 10', 29, NULL, NULL, 98877),
(98878, '3.90.1100.10-FF-000020', NULL, 'DNA-directed RNA polymerase subunit beta', 256, NULL, NULL, 98878),
(98879, '2.130.10.10-FF-002167', NULL, 'WD repeat and FYVE domain-containing protein 3', 306, NULL, NULL, 98879),
(98880, '3.30.160.60-FF-004836', NULL, NULL, 75, NULL, NULL, 98880),
(98881, '3.30.70.100-FF-000129', NULL, NULL, 72, NULL, NULL, 98881),
(98882, '3.10.490.20-FF-000020', NULL, 'Dynein heavy chain, putative', 137, NULL, NULL, 98882),
(98883, '4.10.400.10-FF-000272', NULL, 'neurotrypsin-like isoform X1', 44, NULL, NULL, 98883),
(98884, '4.10.240.10-FF-000118', NULL, 'Filamentous growth regulator 27', 66, NULL, NULL, 98884),
(98885, '1.25.40.10-FF-002014', NULL, 'Putative pentatricopeptide repeat-containing protein', 175, NULL, NULL, 98885),
(98886, '1.10.418.10-FF-000239', NULL, 'Uncharacterized protein', 47, NULL, NULL, 98886),
(98887, '3.20.20.60-FF-000038', NULL, 'Citrate lyase subunit beta-like protein', 222, NULL, NULL, 98887),
(98888, '3.40.50.300-FF-000424', NULL, 'Structural maintenance of chromosomes 3', 197, NULL, NULL, 98888),
(98889, '1.10.3480.10-FF-000006', NULL, 'Putative nitrate reductase delta chain NarJ2', 187, NULL, NULL, 98889),
(98890, '3.30.160.60-FF-001059', NULL, 'Uncharacterized protein', 27, NULL, NULL, 98890),
(98891, '3.40.50.720-FF-002124', NULL, 'NADP-dependent malic enzyme 1', 109, NULL, NULL, 98891),
(98892, '3.40.50.12780-FF-000226', NULL, 'Uncharacterized protein', 309, NULL, NULL, 98892),
(98893, '2.60.40.10-FF-004336', NULL, NULL, 61, NULL, NULL, 98893),
(98894, '2.30.30.40-FF-000254', NULL, 'Myosin I MyoA/Myo5', 57, NULL, NULL, 98894),
(98895, '3.80.10.10-FF-003763', NULL, 'Uncharacterized protein', 115, NULL, NULL, 98895),
(98896, '3.60.40.10-FF-000051', NULL, 'Protein phosphatase 2C-like protein', 294, NULL, NULL, 98896),
(98897, '2.40.70.10-FF-000056', NULL, 'Eukaryotic aspartyl protease family protein', 181, NULL, NULL, 98897),
(98898, '1.10.1740.10-FF-000026', NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', 82, NULL, NULL, 98898),
(98899, '3.30.160.60-FF-000603', NULL, 'PR domain zinc finger protein 15', 77, NULL, NULL, 98899),
(98900, '3.30.160.60-FF-001115', NULL, 'Zinc finger protein 236', 33, NULL, NULL, 98900),
(98901, '1.25.40.20-FF-000842', NULL, '60 kDa lysophospholipase', 73, NULL, NULL, 98901),
(98902, '3.80.10.10-FF-002302', NULL, 'Uncharacterized protein', 199, NULL, NULL, 98902),
(98903, '3.40.50.300-FF-007405', NULL, 'Uncharacterized protein', 161, NULL, NULL, 98903),
(98904, '3.90.1600.10-FF-000064', NULL, 'DNA polymerase', 89, NULL, NULL, 98904),
(98905, '3.30.230.10-FF-000229', NULL, 'DNA mismatch repair protein MutL', 121, NULL, NULL, 98905),
(98906, '3.30.540.10-FF-000039', NULL, 'SAL1 phosphatase, putative', 182, NULL, NULL, 98906),
(98907, '2.10.220.10-FF-000035', NULL, 'Proprotein convertase subtilisin/kexin type 5', 99, NULL, NULL, 98907);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(98908, '1.20.5.110-FF-000328', NULL, 'Uncharacterized protein', 102, NULL, NULL, 98908),
(98909, '3.60.20.10-FF-000044', NULL, 'Probable proteasome subunit alpha type-7', 255, NULL, NULL, 98909),
(98910, '1.10.472.10-FF-000455', NULL, 'Predicted protein', 129, NULL, NULL, 98910),
(98911, '1.10.620.20-FF-000044', NULL, 'Uncharacterized protein', 318, NULL, NULL, 98911),
(98912, '3.30.950.10-FF-000020', NULL, 'Uroporphyrin-III methyltransferase', 123, NULL, NULL, 98912),
(98913, '1.10.540.10-FF-000102', NULL, 'Acyl-CoA dehydrogenase', 119, NULL, NULL, 98913),
(98914, '1.50.10.20-FF-000130', NULL, 'Protein farnesyltransferase subunit beta', 403, NULL, NULL, 98914),
(98915, '4.10.860.120-FF-000031', NULL, 'DNA-directed RNA polymerase subunit', 43, NULL, NULL, 98915),
(98916, '2.30.36.70-FF-000017', NULL, 'Actin-87E-like Protein', 38, NULL, NULL, 98916),
(98917, '3.40.30.10-FF-000040', NULL, 'Thiol:disulfide interchange protein DsbE', 150, NULL, NULL, 98917),
(98918, '3.40.50.200-FF-000164', NULL, 'Uncharacterized protein', 138, NULL, NULL, 98918),
(98919, '2.130.10.10-FF-002223', NULL, 'Cleavage and polyadenylation specific factor 1', 47, NULL, NULL, 98919),
(98920, '1.10.150.80-FF-000054', NULL, 'Uncharacterized protein', 91, NULL, NULL, 98920),
(98921, '3.40.190.100-FF-000001', NULL, 'Glycine betaine transporter periplasmic subunit', 141, NULL, NULL, 98921),
(98922, '3.30.70.1230-FF-000154', NULL, 'Soluble guanylyl cyclase beta1', 196, NULL, NULL, 98922),
(98923, '1.10.10.10-FF-000213', NULL, 'Coniferyl alcohol 9-O-methyltransferase', 105, NULL, NULL, 98923),
(98924, '3.40.1010.20-FF-000005', NULL, 'mRNA, clone: RTFL01-07-F02', 100, NULL, NULL, 98924),
(98925, '2.60.40.2540-FF-000001', NULL, 'Sodium-type flagellar protein MotY', 153, NULL, NULL, 98925),
(98926, '2.60.120.340-FF-000010', NULL, 'Os01g0909500 protein', 98, NULL, NULL, 98926),
(98927, '3.40.50.720-FF-002231', NULL, 'Glyoxylate reductase/hydroxypyruvate reductase b', 96, NULL, NULL, 98927),
(98928, '3.30.1680.10-FF-000049', NULL, 'Sema domain, immunoglobulin domain (Ig), transmembrane domain (TM) and short cytoplasmic domain, (semaphorin) 4Ab', 56, NULL, NULL, 98928),
(98929, '3.10.110.10-FF-000152', NULL, 'Uncharacterized protein', 165, NULL, NULL, 98929),
(98930, '1.25.40.10-FF-003475', NULL, 'Pentatricopeptide repeat-containing protein', 95, NULL, NULL, 98930),
(98931, '2.60.34.10-FF-000117', NULL, 'AGAP007682-PA', 184, NULL, NULL, 98931),
(98932, '1.20.1070.10-FF-001855', NULL, 'Predicted protein', 297, NULL, NULL, 98932),
(98933, '3.40.47.10-FF-000191', NULL, 'Hydroxymethylglutaryl-CoA synthase', 475, NULL, NULL, 98933),
(98934, '4.10.240.10-FF-000169', NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', 62, NULL, NULL, 98934),
(98935, '3.10.20.90-FF-000671', NULL, 'Ubiquitin family, putative', 71, NULL, NULL, 98935),
(98936, '3.90.70.10-FF-000248', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 324, NULL, NULL, 98936),
(98937, '1.25.10.10-FF-002361', NULL, 'Armadillo repeat-containing protein 6 homolog-like Protein', 280, NULL, NULL, 98937),
(98938, '3.30.260.10-FF-000113', NULL, NULL, 15, NULL, NULL, 98938),
(98939, '3.30.160.60-FF-005393', NULL, NULL, 46, NULL, NULL, 98939),
(98940, '3.40.50.300-FF-004606', NULL, 'Leucine-rich repeat serine/threonine-protein kinase 1', 112, NULL, NULL, 98940),
(98941, '3.40.50.1820-FF-001784', NULL, 'Uncharacterized protein', 171, NULL, NULL, 98941),
(98942, '3.40.50.880-FF-000002', NULL, 'CTP synthase', 253, NULL, NULL, 98942),
(98943, '3.40.50.1820-FF-001840', NULL, 'Gastric triacylglycerol lipase, putative', 79, NULL, NULL, 98943),
(98944, '3.40.50.1010-FF-000193', NULL, NULL, 211, NULL, NULL, 98944),
(98945, '3.20.20.80-FF-000201', NULL, 'Alpha-L-fucosidase', 339, NULL, NULL, 98945),
(98946, '4.10.270.10-FF-000002', NULL, 'unconventional myosin-XVIIIa isoform X1', 59, NULL, NULL, 98946),
(98947, '2.170.270.10-FF-000079', NULL, 'GM24661', 129, NULL, NULL, 98947),
(98948, '2.60.40.10-FF-003824', NULL, NULL, 96, NULL, NULL, 98948),
(98949, '2.40.70.10-FF-000112', NULL, 'Plasmepsin IX', 166, NULL, NULL, 98949);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(98950, '3.30.505.10-FF-000020', NULL, 'Tyrosine-protein kinase', 107, NULL, NULL, 98950),
(98951, '3.30.1140.40-FF-000006', NULL, 'Dynein light chain', 98, NULL, NULL, 98951),
(98952, '1.10.1280.10-FF-000002', NULL, 'L-dopachrome tautomerase', 347, NULL, NULL, 98952),
(98953, '1.10.1420.10-FF-000093', NULL, 'DNA mismatch repair protein MSH2, putative', 121, NULL, NULL, 98953),
(98954, '2.40.10.10-FF-000575', NULL, NULL, 56, NULL, NULL, 98954),
(98955, '3.40.50.150-FF-001711', NULL, NULL, 52, NULL, NULL, 98955),
(98956, '3.30.260.10-FF-000057', NULL, '60 kDa chaperonin GroEL', 79, NULL, NULL, 98956),
(98957, '3.30.70.330-FF-001642', NULL, NULL, 130, NULL, NULL, 98957),
(98958, '2.60.40.2310-FF-000005', NULL, 'Subtilisin-like protease SBT2.1', 128, NULL, NULL, 98958),
(98959, '3.30.160.60-FF-004729', NULL, NULL, 100, NULL, NULL, 98959),
(98960, '1.20.1070.10-FF-001799', NULL, 'Uncharacterized protein', 317, NULL, NULL, 98960),
(98961, '1.10.510.10-FF-000393', NULL, 'C-type lectin receptor-like tyrosine-protein kinase At1g52310', 212, NULL, NULL, 98961),
(98962, '3.30.420.40-FF-000039', NULL, 'Hypoxia up-regulated protein 1', 144, NULL, NULL, 98962),
(98963, '3.10.330.10-FF-000039', NULL, 'cDNA FLJ54349, highly similar to Vesicle-fusing ATPase', 49, NULL, NULL, 98963),
(98964, '2.60.40.150-FF-000646', NULL, 'Predicted protein', 125, NULL, NULL, 98964),
(98965, '1.20.1310.10-FF-000161', NULL, NULL, 125, NULL, NULL, 98965),
(98966, '1.20.1510.10-FF-000035', NULL, 'Zinc transporter 5', 212, NULL, NULL, 98966),
(98967, '2.130.10.10-FF-004196', NULL, 'Predicted protein', 159, NULL, NULL, 98967),
(98968, '1.10.510.10-FF-002303', NULL, NULL, 227, NULL, NULL, 98968),
(98969, '1.50.40.10-FF-000421', NULL, 'Mitochondrial brown fat uncoupling protein 1-like', 194, NULL, NULL, 98969),
(98970, '2.60.120.260-FF-000604', NULL, 'Uncharacterized protein', 144, NULL, NULL, 98970),
(98971, '2.160.20.20-FF-000005', NULL, 'AIDA-I family autotransporter YfaL', 220, NULL, NULL, 98971),
(98972, '1.20.120.350-FF-000023', NULL, 'Sodium channel protein', 121, NULL, NULL, 98972),
(98973, '1.10.630.10-FF-000328', NULL, 'Cytochrome P-450 IIC5, putative', 143, NULL, NULL, 98973),
(98974, '1.20.120.1760-FF-000060', NULL, NULL, 192, NULL, NULL, 98974),
(98975, '3.40.50.300-FF-005899', NULL, 'tRNA modification GTPase mss1, mitochondrial', 187, NULL, NULL, 98975),
(98976, '3.40.50.300-FF-005955', NULL, 'DNA mismatch repair protein MutS', 317, NULL, NULL, 98976),
(98977, '1.10.510.10-FF-002298', NULL, NULL, 186, NULL, NULL, 98977),
(98978, '1.25.40.10-FF-004779', NULL, 'Os06g0705300 protein', 188, NULL, NULL, 98978),
(98979, '1.10.510.10-FF-001786', NULL, 'Ser/thr kinase', 254, NULL, NULL, 98979),
(98980, '3.30.470.30-FF-000040', NULL, 'mRNA-capping enzyme', 224, NULL, NULL, 98980),
(98981, '1.10.287.10-FF-000041', NULL, 'CTD phosphatase subunit 1', 14, NULL, NULL, 98981),
(98982, '3.30.70.1350-FF-000016', NULL, 'Co/Zn/Cd cation transporter', 84, NULL, NULL, 98982),
(98983, '3.30.565.10-FF-000349', NULL, 'Histidine kinase osmosensor and regulator, putative', 166, NULL, NULL, 98983),
(98984, '3.90.640.90-FF-000001', NULL, 'TOB1 isoform 1', 122, NULL, NULL, 98984),
(98985, '1.10.1820.10-FF-000027', NULL, 'Casein kinase II subunit beta', 78, NULL, NULL, 98985),
(98986, '1.10.10.750-FF-000009', NULL, 'TBC1 domain family member 22A', 58, NULL, NULL, 98986),
(98987, '2.60.120.10-FF-000185', NULL, 'Predicted transcriptional regulator', 112, NULL, NULL, 98987),
(98988, '2.70.50.30-FF-000020', NULL, NULL, 162, NULL, NULL, 98988),
(98989, '2.170.270.10-FF-000135', NULL, 'Uncharacterized protein', 130, NULL, NULL, 98989),
(98990, '3.30.160.60-FF-003476', NULL, 'Zinc finger protein 607', 27, NULL, NULL, 98990),
(98991, '2.60.40.10-FF-004387', NULL, NULL, 102, NULL, NULL, 98991),
(98992, '2.170.270.10-FF-000023', NULL, 'putative histone-lysine N-methyltransferase PRDM6', 184, NULL, NULL, 98992),
(98993, '3.30.50.10-FF-000143', NULL, 'Thyroid hormone receptor alpha', 71, NULL, NULL, 98993),
(98994, '1.20.1440.100-FF-000016', NULL, 'HAD family hydrolase', 73, NULL, NULL, 98994);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(98995, '3.30.70.330-FF-001693', NULL, NULL, 125, NULL, NULL, 98995),
(98996, '2.120.10.30-FF-000610', NULL, 'Uncharacterized protein', 133, NULL, NULL, 98996),
(98997, '3.40.50.300-FF-000317', NULL, 'Amino acid ABC transporter ATP-binding protein', 251, NULL, NULL, 98997),
(98998, '3.40.50.2300-FF-000208', NULL, 'Branched-chain amino acid ABC transporter, substrate-binding protein', 133, NULL, NULL, 98998),
(98999, '1.10.10.2320-FF-000003', NULL, 'Phenylalanyl-tRNA synthetase alpha subunit, putative', 42, NULL, NULL, 98999),
(99000, '3.40.1280.10-FF-000050', NULL, 'tRNA (guanine-N(1)-)-methyltransferase', 161, NULL, NULL, 99000),
(99001, '2.60.40.150-FF-000702', NULL, 'C2 domain containing protein', 202, NULL, NULL, 99001),
(99002, '3.30.2340.10-FF-000001', NULL, 'tRNA pseudouridine synthase D', 135, NULL, NULL, 99002),
(99003, '1.10.510.10-FF-002247', NULL, NULL, 214, NULL, NULL, 99003),
(99004, '1.50.40.10-FF-000477', NULL, 'Mitochondrial substrate carrier', 288, NULL, NULL, 99004),
(99005, '3.40.50.150-FF-000357', NULL, 'Ribosomal RNA small subunit methyltransferase A', 196, NULL, NULL, 99005),
(99006, '1.20.1050.130-FF-000021', NULL, 'General transcription factor ii, putative', 222, NULL, NULL, 99006),
(99007, '3.40.50.150-FF-000306', NULL, 'Arsenite methyltransferase', 228, NULL, NULL, 99007),
(99008, '3.40.47.10-FF-000039', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 2', 423, NULL, NULL, 99008),
(99009, '4.10.240.10-FF-000225', NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', 83, NULL, NULL, 99009),
(99010, '2.60.40.150-FF-000242', NULL, 'Calcium-dependent lipid-binding (CaLB domain) family protein', 126, NULL, NULL, 99010),
(99011, '1.20.1070.10-FF-001911', NULL, 'Uncharacterized protein', 285, NULL, NULL, 99011),
(99012, '3.30.160.60-FF-004881', NULL, NULL, 38, NULL, NULL, 99012),
(99013, '3.30.70.100-FF-000174', NULL, NULL, 72, NULL, NULL, 99013),
(99014, '3.30.2420.10-FF-000002', NULL, 'TonB-like periplasmic protein', 78, NULL, NULL, 99014),
(99015, '2.10.25.10-FF-001532', NULL, 'Uncharacterized protein', 37, NULL, NULL, 99015),
(99016, '3.20.20.60-FF-000083', NULL, 'N-Acetyl-D-Glucosamine phosphotransferase system transporter', 329, NULL, NULL, 99016),
(99017, '3.10.450.580-FF-000009', NULL, 'Mediator of RNA polymerase II transcription subunit 6', 42, NULL, NULL, 99017),
(99018, '3.90.70.10-FF-000304', NULL, 'Ubiquitin carboxyl-terminal hydrolase domain containing protein', 288, NULL, NULL, 99018),
(99019, '3.30.310.80-FF-000026', NULL, 'Non-specific serine/threonine protein kinase', 96, NULL, NULL, 99019),
(99020, '3.40.50.300-FF-005039', NULL, 'Protein CBG21674', 74, NULL, NULL, 99020),
(99021, '1.20.1070.10-FF-000006', NULL, 'Olfactory receptor', 290, NULL, NULL, 99021),
(99022, '1.10.10.60-FF-000762', NULL, 'Homeobox protein Hox-B8', 56, NULL, NULL, 99022),
(99023, '3.30.70.270-FF-000197', NULL, NULL, 117, NULL, NULL, 99023),
(99024, '1.20.58.60-FF-000124', NULL, 'SEC14 domain and spectrin repeat-containing protein 1', 248, NULL, NULL, 99024),
(99025, '1.10.287.310-FF-000013', NULL, 'Uncharacterized protein', 41, NULL, NULL, 99025),
(99026, '2.80.10.50-FF-000091', NULL, 'Protein CBR-ITR-1, isoform b', 192, NULL, NULL, 99026),
(99027, '1.20.120.670-FF-000001', NULL, 'N-acetyl-alpha-glucosaminidase', 270, NULL, NULL, 99027),
(99028, '2.130.10.10-FF-003684', NULL, 'Coatomer, alpha chain, putative', 117, NULL, NULL, 99028),
(99029, '2.60.40.10-FF-000154', NULL, 'filamin-B isoform X1', 105, NULL, NULL, 99029),
(99030, '3.30.60.30-FF-000020', NULL, 'tomoregulin-2 isoform X2', 63, NULL, NULL, 99030),
(99031, '1.10.472.10-FF-000404', NULL, 'Cyclin domain-containing protein', 108, NULL, NULL, 99031),
(99032, '1.10.238.10-FF-000293', NULL, 'Calcium-binding protein CML42', 72, NULL, NULL, 99032),
(99033, '2.30.30.140-FF-000064', NULL, 'Tudor domain containing 6', 84, NULL, NULL, 99033),
(99034, '3.40.50.1820-FF-000727', NULL, 'CocE/NonD family hydrolase', 220, NULL, NULL, 99034),
(99035, '3.30.230.10-FF-000336', NULL, 'Lon protease homolog 2 peroxisomal', 61, NULL, NULL, 99035);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(99036, '2.130.10.10-FF-000773', NULL, 'Guanine nucleotide-binding protein subunit beta-like protein', 309, NULL, NULL, 99036),
(99037, '1.10.510.10-FF-003203', NULL, NULL, 146, NULL, NULL, 99037),
(99038, '1.20.1250.20-FF-000321', NULL, 'Solute carrier family 45 member 2', 455, NULL, NULL, 99038),
(99039, '3.30.160.60-FF-003420', NULL, NULL, 29, NULL, NULL, 99039),
(99040, '1.20.1420.30-FF-000034', NULL, 'YDL206W-like protein', 215, NULL, NULL, 99040),
(99041, '1.10.560.10-FF-000160', NULL, 'Uncharacterized protein', 96, NULL, NULL, 99041),
(99042, '3.40.50.10810-FF-000208', NULL, 'Uncharacterized protein', 130, NULL, NULL, 99042),
(99043, '3.40.50.300-FF-000368', NULL, 'U5 small nuclear ribonucleoprotein 200 kDa helicase', 205, NULL, NULL, 99043),
(99044, '3.20.20.80-FF-000089', NULL, 'Periplasmic alpha-amylase', 240, NULL, NULL, 99044),
(99045, '1.25.40.20-FF-000893', NULL, 'Molting protein MLT-4', 165, NULL, NULL, 99045),
(99046, '1.20.120.20-FF-000026', NULL, 'Apolipoprotein E', 94, NULL, NULL, 99046),
(99047, '3.60.10.10-FF-000223', NULL, 'Uncharacterized protein', 156, NULL, NULL, 99047),
(99048, '3.30.450.20-FF-000597', NULL, 'BfiS', 118, NULL, NULL, 99048),
(99049, '2.60.34.10-FF-000005', NULL, 'Chaperone protein HscA homolog', 140, NULL, NULL, 99049),
(99050, '3.30.9.10-FF-000238', NULL, 'GH19226p', 55, NULL, NULL, 99050),
(99051, '3.30.40.10-FF-001659', NULL, 'UDP-sugar-dependent glycosyltransferase 52', 79, NULL, NULL, 99051),
(99052, '1.10.10.10-FF-000157', NULL, 'Response regulator receiver', 62, NULL, NULL, 99052),
(99053, '2.130.10.10-FF-004084', NULL, 'Uncharacterized protein', 200, NULL, NULL, 99053),
(99054, '2.10.110.10-FF-000206', NULL, 'Thyroid hormone receptor interactor 6', 51, NULL, NULL, 99054),
(99055, '3.70.10.10-FF-000026', NULL, 'Checkpoint protein', 298, NULL, NULL, 99055),
(99056, '2.40.50.140-FF-000627', NULL, 'Transcription termination/antitermination protein NusA', 70, NULL, NULL, 99056),
(99057, '1.10.287.1490-FF-000093', NULL, 'At1g64330', 193, NULL, NULL, 99057),
(99058, '3.30.460.10-FF-000089', NULL, 'Poly(U) Polymerase', 100, NULL, NULL, 99058),
(99059, '2.30.29.30-FF-000124', NULL, 'carboxyl-terminal PDZ ligand of neuronal nitric oxide synthase protein-like', 154, NULL, NULL, 99059),
(99060, '2.130.10.10-FF-002279', NULL, 'Embryo sac development arrest protein', 240, NULL, NULL, 99060),
(99061, '3.30.260.10-FF-000052', NULL, 'T-complex protein 1 subunit delta', 104, NULL, NULL, 99061),
(99062, '1.25.40.10-FF-001558', NULL, 'Os01g0818200 protein', 194, NULL, NULL, 99062),
(99063, '3.30.160.60-FF-001003', NULL, 'Zinc finger protein 444', 32, NULL, NULL, 99063),
(99064, '1.20.272.10-FF-000078', NULL, NULL, 93, NULL, NULL, 99064),
(99065, '1.10.1600.10-FF-000039', NULL, 'Putative KU70 protein', 107, NULL, NULL, 99065),
(99066, '3.40.50.1000-FF-000257', NULL, 'Haloacid dehalogenase-like hydrolase (HAD) superfamily protein', 239, NULL, NULL, 99066),
(99067, '3.90.226.10-FF-000223', NULL, 'Enoyl-CoA hydratase', 377, NULL, NULL, 99067),
(99068, '3.30.450.290-FF-000002', NULL, 'Sensor protein, DUF3365, HAMP and PAS domain-containing, heme-binding', 163, NULL, NULL, 99068),
(99069, '2.40.70.10-FF-000168', NULL, 'Eukaryotic aspartyl protease family protein, expressed', 175, NULL, NULL, 99069),
(99070, '1.10.510.10-FF-002803', NULL, 'CAMKK/CAMKK-META protein kinase', 349, NULL, NULL, 99070),
(99071, '1.25.10.10-FF-000736', NULL, 'Serine/threonine-protein kinase TOR', 153, NULL, NULL, 99071),
(99072, '3.10.450.350-FF-000002', NULL, 'Murein DD-endopeptidase MepM', 87, NULL, NULL, 99072),
(99073, '1.10.510.10-FF-003607', NULL, NULL, 200, NULL, NULL, 99073),
(99074, '1.25.40.10-FF-001906', NULL, 'ATPase expression protein', 201, NULL, NULL, 99074),
(99075, '2.40.70.10-FF-000224', NULL, 'Uncharacterized protein', 199, NULL, NULL, 99075),
(99076, '3.30.360.10-FF-000093', NULL, 'NAD(P)-dependent dyhydrogenase, Gfo/Idh/MocA family', 167, NULL, NULL, 99076),
(99077, '2.130.10.10-FF-002627', NULL, 'Uncharacterized protein', 163, NULL, NULL, 99077),
(99078, '1.20.58.90-FF-000048', NULL, NULL, 83, NULL, NULL, 99078);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(99079, '3.40.50.2000-FF-000040', NULL, 'UDP-glycosyltransferase 76C1', 181, NULL, NULL, 99079),
(99080, '1.10.1820.10-FF-000022', NULL, 'Casein kinase II subunit beta', 47, NULL, NULL, 99080),
(99081, '1.25.40.20-FF-001275', NULL, 'Chromosome condensation complex protein', 182, NULL, NULL, 99081),
(99082, '2.60.40.1510-FF-000041', NULL, 'Integrin beta', 145, NULL, NULL, 99082),
(99083, '3.30.70.330-FF-002946', NULL, NULL, 110, NULL, NULL, 99083),
(99084, '1.25.40.20-FF-001331', NULL, 'Ankyrin repeat-containing protein P16F5.05c', 127, NULL, NULL, 99084),
(99085, '3.90.226.10-FF-000167', NULL, 'ClpP/crotonase-like domain-containing protein', 212, NULL, NULL, 99085),
(99086, '3.20.20.330-FF-000033', NULL, 'Predicted protein', 56, NULL, NULL, 99086),
(99087, '1.10.260.40-FF-000011', NULL, 'homeobox-containing protein 1 isoform X2', 87, NULL, NULL, 99087),
(99088, '3.30.2230.10-FF-000004', NULL, 'Ubiquitin carboxyl-terminal hydrolase 32', 153, NULL, NULL, 99088),
(99089, '1.20.1440.180-FF-000001', NULL, 'Serine/threonine-protein kinase/endoribonuclease IRE1', 136, NULL, NULL, 99089),
(99090, '3.40.30.10-FF-000444', NULL, 'Cytochrome C biogenesis protein DipZ', 200, NULL, NULL, 99090),
(99091, '3.30.428.10-FF-000048', NULL, 'Galactose-1-phosphate uridylyltransferase', 181, NULL, NULL, 99091),
(99092, '3.10.250.10-FF-000089', NULL, NULL, 95, NULL, NULL, 99092),
(99093, '1.10.506.10-FF-000051', NULL, 'Receptor-mediated endocytosis protein 6', 363, NULL, NULL, 99093),
(99094, '1.25.10.10-FF-000388', NULL, 'Huntingtin', 253, NULL, NULL, 99094),
(99095, '3.30.1380.10-FF-000009', NULL, 'Desert hedgehog, putative', 101, NULL, NULL, 99095),
(99096, '2.40.30.10-FF-000222', NULL, 'tRNA-specific 2-thiouridylase', 91, NULL, NULL, 99096),
(99097, '3.10.25.10-FF-000001', NULL, 'Methionyl-tRNA formyltransferase', 106, NULL, NULL, 99097),
(99098, '3.50.50.60-FF-000415', NULL, 'AT3g04650/F7O18_13', 147, NULL, NULL, 99098),
(99099, '1.10.510.10-FF-003259', NULL, NULL, 111, NULL, NULL, 99099),
(99100, '3.80.10.10-FF-001846', NULL, 'Leucine-rich repeat protein (LRRP), putative', 97, NULL, NULL, 99100),
(99101, '6.10.30.50-FF-000001', NULL, 'Cytokinesis sepA protein', 60, NULL, NULL, 99101),
(99102, '3.30.2350.10-FF-000058', NULL, 'Pseudouridine synthase', 216, NULL, NULL, 99102),
(99103, '3.30.2310.10-FF-000005', NULL, 'Methyltransferase, YaeB/AF_0241 family protein', 99, NULL, NULL, 99103),
(99104, '3.40.30.10-FF-000837', NULL, 'Protein disulfide isomerase1-1', 117, NULL, NULL, 99104),
(99105, '3.30.70.330-FF-002598', NULL, NULL, 133, NULL, NULL, 99105),
(99106, '2.60.120.260-FF-000609', NULL, 'Uncharacterized protein', 142, NULL, NULL, 99106),
(99107, '1.10.1300.10-FF-000095', NULL, 'Predicted protein', 74, NULL, NULL, 99107),
(99108, '3.40.1360.10-FF-000051', NULL, 'DNA primase', 127, NULL, NULL, 99108),
(99109, '1.10.3080.10-FF-000077', NULL, 'Chloride channel protein 1,2, putative', 270, NULL, NULL, 99109),
(99110, '2.30.29.70-FF-000001', NULL, 'Proteasomal ubiquitin receptor ADRM1', 115, NULL, NULL, 99110),
(99111, '3.40.50.300-FF-002341', NULL, 'tRNA (Adenosine(37)-N6)-threonylcarbamoyltransferase complex ATPase subunit type 1 TsaE', 151, NULL, NULL, 99111),
(99112, '1.20.1250.20-FF-001625', NULL, 'Major facilitator superfamily domain-containing 4B5', 121, NULL, NULL, 99112),
(99113, '3.90.470.20-FF-000080', NULL, 'Chromosome 10, whole genome shotgun sequence', 80, NULL, NULL, 99113),
(99114, '3.40.50.2020-FF-000102', NULL, 'Hypoxanthine phosphoribosyltransferase', 174, NULL, NULL, 99114),
(99115, '3.30.160.60-FF-005893', NULL, NULL, 27, NULL, NULL, 99115),
(99116, '3.10.20.90-FF-000519', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 116, NULL, NULL, 99116),
(99117, '2.130.10.10-FF-004140', NULL, 'Uncharacterized protein', 181, NULL, NULL, 99117),
(99118, '3.40.50.10330-FF-000093', NULL, 'NAD kinase 1', 136, NULL, NULL, 99118),
(99119, '1.10.150.20-FF-000019', NULL, 'DNA polymerase IV', 62, NULL, NULL, 99119),
(99120, '3.40.50.300-FF-003246', NULL, 'RAS related 2', 85, NULL, NULL, 99120),
(99121, '3.10.450.240-FF-000025', NULL, 'Predicted protein', 186, NULL, NULL, 99121);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(99122, '1.10.8.60-FF-000103', NULL, 'Origin recognition complex subunit 1', 78, NULL, NULL, 99122),
(99123, '1.10.1520.10-FF-000038', NULL, 'Uncharacterized protein', 179, NULL, NULL, 99123),
(99124, '2.30.42.10-FF-000143', NULL, 'Membrane associated guanylate kinase, WW and PDZ domain containing 2', 88, NULL, NULL, 99124),
(99125, '1.10.1740.10-FF-000021', NULL, 'ECF RNA polymerase sigma factor SigK', 85, NULL, NULL, 99125),
(99126, '3.70.10.10-FF-000077', NULL, 'Checkpoint protein', 312, NULL, NULL, 99126),
(99127, '1.10.238.10-FF-001310', NULL, 'Uncharacterized protein', 86, NULL, NULL, 99127),
(99128, '3.40.30.10-FF-000096', NULL, 'Glutathione S-transferase kappa', 208, NULL, NULL, 99128),
(99129, '1.10.10.540-FF-000008', NULL, 'XPC-binding_domain/UBA/TS-N_domain_containing_protein_-_putative', 63, NULL, NULL, 99129),
(99130, '1.20.1250.10-FF-000043', NULL, 'Growth hormone d5', 190, NULL, NULL, 99130),
(99131, '1.20.5.110-FF-000323', NULL, 'Predicted protein', 101, NULL, NULL, 99131),
(99132, '3.30.160.60-FF-002464', NULL, 'Zinc finger protein 668', 31, NULL, NULL, 99132),
(99133, '3.40.5.10-FF-000022', NULL, '50S ribosomal protein L9', 61, NULL, NULL, 99133),
(99134, '1.10.287.110-FF-000397', NULL, 'Chaperone protein dnaJ', 30, NULL, NULL, 99134),
(99135, '3.40.50.1820-FF-001239', NULL, 'Uncharacterized protein', 328, NULL, NULL, 99135),
(99136, '1.50.40.10-FF-000426', NULL, 'Uncharacterized protein', 184, NULL, NULL, 99136),
(99137, '1.10.470.10-FF-000001', NULL, 'Variant surface glycoprotein (VSG), putative', 148, NULL, NULL, 99137),
(99138, '3.10.105.10-FF-000078', NULL, 'ABC transporter substrate-binding protein', 214, NULL, NULL, 99138),
(99139, '3.30.470.30-FF-000096', NULL, 'Uncharacterized protein', 74, NULL, NULL, 99139),
(99140, '1.10.8.710-FF-000033', NULL, NULL, 43, NULL, NULL, 99140),
(99141, '3.40.50.1000-FF-000656', NULL, NULL, 141, NULL, NULL, 99141),
(99142, '1.10.8.60-FF-000047', NULL, 'DNA-binding transcriptional regulator TyrR', 76, NULL, NULL, 99142),
(99143, '3.10.250.10-FF-000038', NULL, 'Scavenger receptor family member expressed on T cells 1', 104, NULL, NULL, 99143),
(99144, '3.80.10.10-FF-001902', NULL, 'Uncharacterized protein AT4g34280', 126, NULL, NULL, 99144),
(99145, '3.10.100.10-FF-000382', NULL, NULL, 133, NULL, NULL, 99145),
(99146, '1.10.405.10-FF-000024', NULL, 'Rab geranylgeranyl transferase component A, putative', 116, NULL, NULL, 99146),
(99147, '1.10.10.520-FF-000002', NULL, 'SUMO-activating enzyme subunit 2', 213, NULL, NULL, 99147),
(99148, '3.30.2020.30-FF-000005', NULL, 'Unplaced genomic scaffold supercont2.7, whole genome shotgun sequence', 88, NULL, NULL, 99148),
(99149, '1.10.238.10-FF-000248', NULL, 'Calcium-dependent protein kinase 5', 92, NULL, NULL, 99149),
(99150, '2.20.25.530-FF-000015', NULL, 'Uncharacterized protein', 72, NULL, NULL, 99150),
(99151, '3.30.470.20-FF-000211', NULL, 'Gll0508 protein', 150, NULL, NULL, 99151),
(99152, '3.10.490.20-FF-000025', NULL, 'GG12117', 134, NULL, NULL, 99152),
(99153, '1.20.1070.10-FF-001063', NULL, 'Putative dopamine type 2 receptor', 110, NULL, NULL, 99153),
(99154, '3.40.30.10-FF-000388', NULL, 'Thioredoxin', 110, NULL, NULL, 99154),
(99155, '1.25.10.10-FF-000444', NULL, 'Coatomer subunit beta', 561, NULL, NULL, 99155),
(99156, '1.20.5.110-FF-000267', NULL, 'Synaptosomal-associated protein', 60, NULL, NULL, 99156),
(99157, '3.30.70.330-FF-002042', NULL, NULL, 91, NULL, NULL, 99157),
(99158, '3.30.1370.120-FF-000010', NULL, 'Type IV pilus secretin PilQ', 95, NULL, NULL, 99158),
(99159, '3.40.366.10-FF-000014', NULL, 'Malonyl CoA-acyl carrier protein transacylase', 206, NULL, NULL, 99159),
(99160, '2.60.40.1400-FF-000013', NULL, NULL, 175, NULL, NULL, 99160),
(99161, '3.30.160.60-FF-001907', NULL, 'AZF1 (YOR113W)', 29, NULL, NULL, 99161),
(99162, '3.30.70.330-FF-000125', NULL, 'Putative ribonucleoprotein PTB-binding 1', 71, NULL, NULL, 99162),
(99163, '2.40.50.1070-FF-000003', NULL, '23S rRNA (Uracil-5-)-methyltransferase RumA', 157, NULL, NULL, 99163),
(99164, '2.10.25.10-FF-000571', NULL, 'Hyaluronan-binding protein 2', 73, NULL, NULL, 99164);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(99165, '2.60.40.1120-FF-000087', NULL, 'Predicted protein', 105, NULL, NULL, 99165),
(99166, '3.90.226.10-FF-000274', NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', 430, NULL, NULL, 99166),
(99167, '3.30.160.60-FF-003824', NULL, NULL, 31, NULL, NULL, 99167),
(99168, '3.30.479.20-FF-000028', NULL, 'Elongation factor Ts, mitochondrial', 124, NULL, NULL, 99168),
(99169, '1.20.910.10-FF-000033', NULL, 'Pyrroloquinoline-quinone synthase', 237, NULL, NULL, 99169),
(99170, '3.60.21.10-FF-000479', NULL, 'Uncharacterized protein', 238, NULL, NULL, 99170),
(99171, '3.40.1190.10-FF-000048', NULL, NULL, 115, NULL, NULL, 99171),
(99172, '3.40.50.10860-FF-000021', NULL, 'Quinate repressor protein', 96, NULL, NULL, 99172),
(99173, '1.10.150.60-FF-000008', NULL, 'Putative AT-rich interactive domain-containing protein 3B', 130, NULL, NULL, 99173),
(99174, '1.20.1250.20-FF-001569', NULL, 'Uncharacterized protein', 386, NULL, NULL, 99174),
(99175, '2.130.10.10-FF-005101', NULL, 'Uncharacterized protein', 253, NULL, NULL, 99175),
(99176, '1.10.510.10-FF-003208', NULL, NULL, 144, NULL, NULL, 99176),
(99177, '1.10.540.10-FF-000158', NULL, 'Putative medium-chain specific acyl-CoA dehydrogenase, mitochondrial-like Protein', 79, NULL, NULL, 99177),
(99178, '3.30.1370.10-FF-000216', NULL, 'Vigilin 1', 97, NULL, NULL, 99178),
(99179, '3.20.20.220-FF-000056', NULL, 'Proline dehydrogenase', 373, NULL, NULL, 99179),
(99180, '3.40.50.300-FF-003302', NULL, 'DNA mismatch repair protein MutS', 224, NULL, NULL, 99180),
(99181, '2.40.128.20-FF-000058', NULL, 'Uncharacterized protein', 122, NULL, NULL, 99181),
(99182, '3.30.70.330-FF-002654', NULL, NULL, 120, NULL, NULL, 99182),
(99183, '1.10.246.60-FF-000006', NULL, 'Eukaryotic translation initiation factor 3 subunit J', 80, NULL, NULL, 99183),
(99184, '3.30.160.60-FF-005218', NULL, NULL, 31, NULL, NULL, 99184),
(99185, '3.10.20.90-FF-000620', NULL, 'Uncharacterized protein', 98, NULL, NULL, 99185),
(99186, '1.25.40.10-FF-001002', NULL, 'Uncharacterized protein', 152, NULL, NULL, 99186),
(99187, '2.40.50.360-FF-000002', NULL, 'RuvB-like helicase', 123, NULL, NULL, 99187),
(99188, '2.130.10.10-FF-004932', NULL, 'Uncharacterized protein', 104, NULL, NULL, 99188),
(99189, '1.10.287.690-FF-000031', NULL, 'DNA polymerase', 14, NULL, NULL, 99189),
(99190, '2.40.128.20-FF-000007', NULL, 'Alpha-1-microglobulin/bikunin precursor', 166, NULL, NULL, 99190),
(99191, '3.30.710.10-FF-000311', NULL, 'Si:dkey-6b12.5', 85, NULL, NULL, 99191),
(99192, '3.40.50.10710-FF-000004', NULL, 'Ribonuclease J', 151, NULL, NULL, 99192),
(99193, '2.60.40.10-FF-003032', NULL, 'Lymphocyte activating 3', 100, NULL, NULL, 99193),
(99194, '3.90.550.10-FF-000526', NULL, '3-deoxy-manno-octulosonate cytidylyltransferase', 245, NULL, NULL, 99194),
(99195, '1.10.10.160-FF-000046', NULL, 'Predicted protein', 102, NULL, NULL, 99195),
(99196, '3.40.50.1240-FF-000126', NULL, NULL, 158, NULL, NULL, 99196),
(99197, '3.30.40.10-FF-001367', NULL, 'Uncharacterized protein', 68, NULL, NULL, 99197),
(99198, '1.10.20.10-FF-000034', NULL, 'STAGA complex 65 subunit gamma', 94, NULL, NULL, 99198),
(99199, '3.90.550.50-FF-000010', NULL, 'Hexosyltransferase', 259, NULL, NULL, 99199),
(99200, '2.130.10.10-FF-004752', NULL, 'AGAP000479-PA', 159, NULL, NULL, 99200),
(99201, '2.30.30.140-FF-000120', NULL, 'PWWP domain-containing protein2', 102, NULL, NULL, 99201),
(99202, '1.10.3280.10-FF-000002', NULL, 'Siroheme biosynthesis protein met8', 82, NULL, NULL, 99202),
(99203, '3.40.630.30-FF-000651', NULL, 'Uncharacterized protein', 162, NULL, NULL, 99203),
(99204, '1.10.1420.10-FF-000098', NULL, 'Msh2-like protein', 181, NULL, NULL, 99204),
(99205, '1.20.58.1780-FF-000001', NULL, 'nuclear pore complex protein Nup155', 300, NULL, NULL, 99205),
(99206, '1.25.40.10-FF-004487', NULL, 'Uncharacterized protein', 99, NULL, NULL, 99206),
(99207, '2.20.28.20-FF-000001', NULL, 'Methionine--tRNA ligase', 35, NULL, NULL, 99207),
(99208, '3.30.70.330-FF-001586', NULL, NULL, 109, NULL, NULL, 99208),
(99209, '3.30.40.10-FF-002115', NULL, 'Uncharacterized protein', 107, NULL, NULL, 99209);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(99210, '2.170.270.10-FF-000028', NULL, 'Histone-lysine N-methyltransferase', 239, NULL, NULL, 99210),
(99211, '2.30.230.10-FF-000031', NULL, 'Predicted protein', 220, NULL, NULL, 99211),
(99212, '3.30.160.60-FF-003768', NULL, NULL, 29, NULL, NULL, 99212),
(99213, '3.30.1360.120-FF-000070', NULL, 'Dimethylglycine dehydrogenase', 125, NULL, NULL, 99213),
(99214, '2.30.29.30-FF-001293', NULL, 'Uncharacterized protein', 88, NULL, NULL, 99214),
(99215, '3.40.50.2300-FF-000720', NULL, 'Sensory box sensor histidine kinase/response regulator', 130, NULL, NULL, 99215),
(99216, '1.20.1250.20-FF-000265', NULL, 'MFS transporter', 186, NULL, NULL, 99216),
(99217, '2.60.40.60-FF-000107', NULL, 'FAT atypical cadherin 1', 80, NULL, NULL, 99217),
(99218, '1.25.40.10-FF-000564', NULL, 'UTP6, small subunit processome component', 129, NULL, NULL, 99218),
(99219, '2.120.10.80-FF-000215', NULL, 'leucine-zipper-like transcriptional regulator 1 isoform X2', 82, NULL, NULL, 99219),
(99220, '3.90.1300.10-FF-000024', NULL, '1-carboxybiuret hydrolase subunit AtzE', 456, NULL, NULL, 99220),
(99221, '1.10.3720.10-FF-000161', NULL, 'Probable permease of ABC transporter', 199, NULL, NULL, 99221),
(99222, '2.60.120.620-FF-000116', NULL, 'Uncharacterized protein', 163, NULL, NULL, 99222),
(99223, '1.10.472.80-FF-000256', NULL, NULL, 62, NULL, NULL, 99223),
(99224, '1.10.287.110-FF-000402', NULL, 'Uncharacterized protein', 113, NULL, NULL, 99224),
(99225, '3.30.1490.140-FF-000003', NULL, 'CRE-APL-1 protein', 65, NULL, NULL, 99225),
(99226, '2.70.40.10-FF-000036', NULL, 'Chromosome 7, whole genome shotgun sequence', 148, NULL, NULL, 99226),
(99227, '3.90.1570.40-FF-000002', NULL, 'Spliceosomal protein PrP8, U6-snRNA interacting domain', 197, NULL, NULL, 99227),
(99228, '3.30.200.20-FF-000045', NULL, 'Serine/threonine-protein kinase SRK2E', 79, NULL, NULL, 99228),
(99229, '1.25.40.10-FF-001053', NULL, 'Anaphase-promoting complex subunit CDC27', 73, NULL, NULL, 99229),
(99230, '2.60.40.10-FF-003083', NULL, 'GM25779', 118, NULL, NULL, 99230),
(99231, '1.10.10.60-FF-000470', NULL, 'Trihelix transcription factor ASR3', 71, NULL, NULL, 99231),
(99232, '3.60.10.10-FF-000167', NULL, 'Endonuclease/exonuclease/phosphatase family metal-dependent hydrolase', 243, NULL, NULL, 99232),
(99233, '2.60.210.10-FF-000012', NULL, 'BTB/POZ and MATH domain-containing protein 4', 140, NULL, NULL, 99233),
(99234, '1.10.287.110-FF-000453', NULL, 'Uncharacterized protein', 53, NULL, NULL, 99234),
(99235, '2.10.25.10-FF-000964', NULL, 'Uncharacterized protein', 43, NULL, NULL, 99235),
(99236, '3.40.50.300-FF-002285', NULL, 'Uncharacterized protein', 327, NULL, NULL, 99236),
(99237, '1.25.40.10-FF-000165', NULL, 'Transmembrane and tetratricopeptide repeat containing 1', 62, NULL, NULL, 99237),
(99238, '2.30.42.10-FF-000087', NULL, 'Whirlin a', 125, NULL, NULL, 99238),
(99239, '3.80.10.10-FF-001285', NULL, 'Hypothetical_protein_-_conserved', 152, NULL, NULL, 99239),
(99240, '1.20.1510.10-FF-000030', NULL, 'zinc transporter 2 isoform X2', 141, NULL, NULL, 99240),
(99241, '3.30.70.330-FF-002603', NULL, NULL, 132, NULL, NULL, 99241),
(99242, '1.20.58.390-FF-000018', NULL, 'Glycine receptor subunit beta', 133, NULL, NULL, 99242),
(99243, '2.130.10.10-FF-002228', NULL, 'WD repeat domain 62, isoform D', 353, NULL, NULL, 99243),
(99244, '3.10.350.10-FF-000041', NULL, 'Putative invasin', 72, NULL, NULL, 99244),
(99245, '3.20.20.450-FF-000007', NULL, 'Predicted diguanylate cyclase', 254, NULL, NULL, 99245),
(99246, '3.40.50.300-FF-003297', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 253, NULL, NULL, 99246),
(99247, '3.30.70.270-FF-000253', NULL, NULL, 59, NULL, NULL, 99247),
(99248, '3.60.21.10-FF-000428', NULL, 'Uncharacterized protein', 253, NULL, NULL, 99248),
(99249, '2.90.10.10-FF-000022', NULL, 'Receptor-like protein kinase 4', 136, NULL, NULL, 99249),
(99250, '1.10.238.10-FF-000872', NULL, 'Uncharacterized protein', 79, NULL, NULL, 99250),
(99251, '3.40.50.11350-FF-000011', NULL, 'O-fucosyltransferase 28', 196, NULL, NULL, 99251);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(99252, '3.40.630.10-FF-000488', NULL, 'Glutaminylpeptide cyclotransferase, putative', 63, NULL, NULL, 99252),
(99253, '3.10.110.10-FF-000107', NULL, 'Ubiquitin conjugating enzyme, putative', 174, NULL, NULL, 99253),
(99254, '3.30.160.60-FF-004044', NULL, NULL, 32, NULL, NULL, 99254),
(99255, '3.30.2130.10-FF-000019', NULL, 'Aspartokinase', 141, NULL, NULL, 99255),
(99256, '3.40.50.300-FF-004590', NULL, 'GPI inositol-deacylase', 162, NULL, NULL, 99256),
(99257, '2.60.40.10-FF-003431', NULL, NULL, 105, NULL, NULL, 99257),
(99258, '1.25.40.10-FF-004436', NULL, 'Pentatricopeptide repeat-containing protein At1g09220, mitochondrial', 121, NULL, NULL, 99258),
(99259, '2.40.50.140-FF-000919', NULL, NULL, 131, NULL, NULL, 99259),
(99260, '4.10.400.10-FF-000209', NULL, 'Low-density lipoprotein receptor-related protein', 51, NULL, NULL, 99260),
(99261, '3.50.30.30-FF-000017', NULL, 'Protease-associated domain-containing protein 1', 146, NULL, NULL, 99261),
(99262, '3.30.360.10-FF-000109', NULL, 'Uncharacterized protein', 175, NULL, NULL, 99262),
(99263, '2.30.30.870-FF-000007', NULL, 'Pelo/ eRF1 domain 1 protein', 130, NULL, NULL, 99263),
(99264, '3.30.70.1230-FF-000098', NULL, 'Adenylate/guanylate cyclase catalytic domain protein', 180, NULL, NULL, 99264),
(99265, '2.130.10.10-FF-004191', NULL, 'Coronin', 160, NULL, NULL, 99265),
(99266, '1.25.40.20-FF-000786', NULL, 'Uncharacterized protein', 148, NULL, NULL, 99266),
(99267, '1.10.510.10-FF-001410', NULL, 'Serine/threonine-protein kinase ppk27', 329, NULL, NULL, 99267),
(99268, '1.10.418.10-FF-000234', NULL, 'Spectrin, beta, non-erythrocytic 5', 83, NULL, NULL, 99268),
(99269, '3.40.50.1110-FF-000054', NULL, 'Maternal effect protein oskar', 207, NULL, NULL, 99269),
(99270, '3.30.810.10-FF-000015', NULL, 'Putative 1-phosphatidylinositol-3-phosphate 5-kinase FAB1D', 98, NULL, NULL, 99270),
(99271, '1.10.40.30-FF-000024', NULL, 'Argininosuccinate lyase', 79, NULL, NULL, 99271),
(99272, '3.50.80.10-FF-000014', NULL, 'Uncharacterized protein', 63, NULL, NULL, 99272),
(99273, '2.60.40.10-FF-002594', NULL, 'Muscle M-line assembly protein unc-89-like Protein', 99, NULL, NULL, 99273),
(99274, '2.60.40.60-FF-000652', NULL, 'Cadherin-89D', 107, NULL, NULL, 99274),
(99275, '3.30.2300.10-FF-000004', NULL, 'THUMP domain containing protein', 81, NULL, NULL, 99275),
(99276, '3.30.2350.10-FF-000007', NULL, 'Pseudouridine synthase', 228, NULL, NULL, 99276),
(99277, '2.20.20.110-FF-000010', NULL, 'YALI0D08756p', 56, NULL, NULL, 99277),
(99278, '2.60.40.10-FF-002071', NULL, 'Interference hedgehog', 86, NULL, NULL, 99278),
(99279, '2.30.30.140-FF-000171', NULL, 'PHD finger protein 1', 55, NULL, NULL, 99279),
(99280, '2.130.10.10-FF-000481', NULL, 'Leucine-rich repeat serine/threonine-protein kinase 2', 365, NULL, NULL, 99280),
(99281, '3.40.50.880-FF-000053', NULL, 'GMP synthase (glutamine-hydrolyzing)', 107, NULL, NULL, 99281),
(99282, '3.30.1360.120-FF-000007', NULL, 'tRNA modification GTPase GTPBP3, mitochondrial', 124, NULL, NULL, 99282),
(99283, '2.40.10.240-FF-000003', NULL, 'S-adenosylmethionine:tRNA ribosyltransferase-isomerase', 98, NULL, NULL, 99283),
(99284, '3.80.10.10-FF-000885', NULL, 'Adhesion G protein-coupled receptor A2', 129, NULL, NULL, 99284),
(99285, '3.50.30.10-FF-000011', NULL, NULL, 112, NULL, NULL, 99285),
(99286, '3.40.50.1220-FF-000031', NULL, 'Alpha-keto acid decarboxylase family protein', 153, NULL, NULL, 99286),
(99287, '2.60.40.1360-FF-000012', NULL, 'Alpha-mannosidase B', 117, NULL, NULL, 99287),
(99288, '2.30.30.850-FF-000001', NULL, 'Gag-Pol polyprotein', 88, NULL, NULL, 99288),
(99289, '3.30.450.330-FF-000003', NULL, 'Cell division protein FtsI', 131, NULL, NULL, 99289),
(99290, '3.40.1690.20-FF-000022', NULL, 'Uncharacterized protein', 99, NULL, NULL, 99290),
(99291, '3.30.457.50-FF-000003', NULL, 'Spc25p', 92, NULL, NULL, 99291),
(99292, '3.40.50.2020-FF-000046', NULL, 'Hypoxanthine-guanine phosphoribosyltransferase', 206, NULL, NULL, 99292),
(99293, '3.30.565.10-FF-000405', NULL, 'Two-component sensor kinase', 149, NULL, NULL, 99293);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(99294, '1.10.8.810-FF-000001', NULL, 'Death domain-associated protein 6', 89, NULL, NULL, 99294),
(99295, '2.60.120.40-FF-000053', NULL, 'Uncharacterized protein', 154, NULL, NULL, 99295),
(99296, '3.30.43.10-FF-000008', NULL, 'Xanthine dehydrogenase, FAD binding subunit', 52, NULL, NULL, 99296),
(99297, '3.40.50.300-FF-000716', NULL, 'ATP-dependent RNA helicase DDX1', 87, NULL, NULL, 99297),
(99298, '3.90.1410.10-FF-000066', NULL, 'Uncharacterized protein', 314, NULL, NULL, 99298),
(99299, '1.10.418.10-FF-000003', NULL, 'Spectrin beta chain', 120, NULL, NULL, 99299),
(99300, '1.25.10.10-FF-002754', NULL, 'Uncharacterized protein', 655, NULL, NULL, 99300),
(99301, '2.30.180.10-FF-000049', NULL, 'Uncharacterized protein', 163, NULL, NULL, 99301),
(99302, '2.60.120.10-FF-000578', NULL, 'Crp/Fnr family transcriptional regulator', 144, NULL, NULL, 99302),
(99303, '3.30.760.10-FF-000022', NULL, 'Putative eukaryotic translation initiation factor eIF-4E', 211, NULL, NULL, 99303),
(99304, '2.60.120.10-FF-000634', NULL, 'Crp family transcriptional regulatory protein', 190, NULL, NULL, 99304),
(99305, '3.40.50.1100-FF-000045', NULL, 'Threonine ammonia-lyase', 97, NULL, NULL, 99305),
(99306, '1.25.40.10-FF-002306', NULL, 'Putative pentatricopeptide repeat family protein', 120, NULL, NULL, 99306),
(99307, '1.20.1440.130-FF-000008', NULL, 'Vitamin-K epoxide reductase', 149, NULL, NULL, 99307),
(99308, '2.130.10.10-FF-002459', NULL, 'Os03g0735100 protein', 243, NULL, NULL, 99308),
(99309, '3.30.200.20-FF-001973', NULL, 'Uncharacterized protein', 102, NULL, NULL, 99309),
(99310, '2.30.39.10-FF-000124', NULL, 'Protein CBG06349', 33, NULL, NULL, 99310),
(99311, '2.130.10.10-FF-002515', NULL, 'Uncharacterized protein', 292, NULL, NULL, 99311),
(99312, '3.30.70.660-FF-000044', NULL, 'Pseudouridine synthase 3', 175, NULL, NULL, 99312),
(99313, '4.10.800.10-FF-000021', NULL, 'Magu, isoform F', 76, NULL, NULL, 99313),
(99314, '3.30.160.60-FF-001790', NULL, 'BCL6A, transcription repressor a', 44, NULL, NULL, 99314),
(99315, '2.60.120.920-FF-000212', NULL, 'Uncharacterized protein', 153, NULL, NULL, 99315),
(99316, '1.25.40.540-FF-000015', NULL, 'Uncharacterized protein', 220, NULL, NULL, 99316),
(99317, '2.40.70.10-FF-000348', NULL, NULL, 156, NULL, NULL, 99317),
(99318, '2.40.10.10-FF-000283', NULL, 'Cortical granule serine protease 1; Uncharacterized protein', 101, NULL, NULL, 99318),
(99319, '1.10.3290.10-FF-000008', NULL, 'Cell filamentation protein Fic', 204, NULL, NULL, 99319),
(99320, '3.40.30.10-FF-000332', NULL, 'Blast:Protein disulfide-isomerase TMX3', 110, NULL, NULL, 99320),
(99321, '2.60.40.10-FF-002863', NULL, 'Uncharacterized protein', 104, NULL, NULL, 99321),
(99322, '1.10.10.2740-FF-000005', NULL, 'Transcription elongation factor spt6, putative', 87, NULL, NULL, 99322),
(99323, '1.50.10.150-FF-000017', NULL, 'S-type anion channel SLAH1', 64, NULL, NULL, 99323),
(99324, '1.20.5.420-FF-000028', NULL, 'Small glutamine-rich tetratricopeptide repeat-containing protein 2', 49, NULL, NULL, 99324),
(99325, '3.40.50.10190-FF-000360', NULL, 'Uncharacterized protein', 63, NULL, NULL, 99325),
(99326, '3.30.160.390-FF-000005', NULL, 'Prophage integrase IntF', 105, NULL, NULL, 99326),
(99327, '1.25.10.10-FF-002810', NULL, 'Uncharacterized protein', 201, NULL, NULL, 99327),
(99328, '1.25.40.20-FF-000494', NULL, 'Death-associated protein kinase 1', 104, NULL, NULL, 99328),
(99329, '1.10.238.10-FF-000809', NULL, 'Superoxide-generating NADPH oxidase heavy chain subunit C', 132, NULL, NULL, 99329),
(99330, '2.60.440.10-FF-000001', NULL, 'Cell division protein ZapD', 72, NULL, NULL, 99330),
(99331, '3.30.160.60-FF-000839', NULL, 'Zinc finger protein 691', 30, NULL, NULL, 99331),
(99332, '3.10.290.10-FF-000035', NULL, 'Ribosomal small subunit pseudouridylate synthase', 54, NULL, NULL, 99332),
(99333, '2.130.10.10-FF-004645', NULL, 'Uncharacterized protein', 192, NULL, NULL, 99333),
(99334, '4.10.800.20-FF-000018', NULL, 'AMP deaminase', 12, NULL, NULL, 99334),
(99335, '2.60.40.200-FF-000009', NULL, 'Superoxide dismutase 1 copper chaperone', 143, NULL, NULL, 99335);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(99336, '2.10.110.10-FF-000038', NULL, 'LIM domain kinase 2', 60, NULL, NULL, 99336),
(99337, '3.90.950.10-FF-000006', NULL, 'PRRC1 isoform 1', 142, NULL, NULL, 99337),
(99338, '2.60.40.150-FF-000354', NULL, 'Synaptotagmin 2', 157, NULL, NULL, 99338),
(99339, '1.10.730.10-FF-000100', NULL, 'Leucine--tRNA ligase', 164, NULL, NULL, 99339),
(99340, '1.10.455.10-FF-000027', NULL, 'Uncharacterized protein', 57, NULL, NULL, 99340),
(99341, '1.20.1530.20-FF-000034', NULL, 'Sodium bile acid symporter family protein', 341, NULL, NULL, 99341),
(99342, '1.10.555.10-FF-000086', NULL, 'Heavy chain, Unconventional Myosin', 212, NULL, NULL, 99342),
(99343, '3.40.50.300-FF-007748', NULL, 'DNA repair protein RAD51 homolog 4', 77, NULL, NULL, 99343),
(99344, '3.40.50.300-FF-002173', NULL, 'RNA helicase', 282, NULL, NULL, 99344),
(99345, '3.30.40.10-FF-001316', NULL, 'Putative transcription factor 20', 106, NULL, NULL, 99345),
(99346, '4.10.410.10-FF-000098', NULL, 'Uncharacterized protein', 59, NULL, NULL, 99346),
(99347, '2.30.180.10-FF-000094', NULL, NULL, 137, NULL, NULL, 99347),
(99348, '1.10.555.10-FF-000142', NULL, 'YALI0A17578p', 176, NULL, NULL, 99348),
(99349, '3.80.10.10-FF-001341', NULL, 'Leucine Rich repeat, putative', 85, NULL, NULL, 99349),
(99350, '3.40.50.300-FF-006444', NULL, 'Predicted protein', 124, NULL, NULL, 99350),
(99351, '2.60.40.150-FF-000298', NULL, 'DEAD/DEAH box helicase, putative', 123, NULL, NULL, 99351),
(99352, '2.60.40.1180-FF-000115', NULL, 'Alpha-L-fucosidase', 89, NULL, NULL, 99352),
(99353, '1.10.510.10-FF-000792', NULL, 'Non-specific serine/threonine protein kinase', 291, NULL, NULL, 99353),
(99354, '1.10.287.90-FF-000019', NULL, 'Cytochrome C oxidase', 73, NULL, NULL, 99354),
(99355, '3.40.390.10-FF-000160', NULL, 'Matrix metalloproteinase-28-like Protein', 271, NULL, NULL, 99355),
(99356, '3.40.50.300-FF-008592', NULL, 'Predicted protein', 123, NULL, NULL, 99356),
(99357, '3.30.70.330-FF-001294', NULL, 'SUPPRESSOR OF ABI3-5', 121, NULL, NULL, 99357),
(99358, '1.20.120.920-FF-000003', NULL, 'CRISPR-associated endonuclease Cas1', 197, NULL, NULL, 99358),
(99359, '2.130.10.10-FF-000430', NULL, 'WD repeat domain 63', 234, NULL, NULL, 99359),
(99360, '3.90.1480.20-FF-000017', NULL, 'ST6 N-acetylgalactosaminide alpha-2,6-sialyltransferase 3', 137, NULL, NULL, 99360),
(99361, '3.30.1370.10-FF-000003', NULL, 'poly(RC)-binding protein 2 isoform X1', 73, NULL, NULL, 99361),
(99362, '3.30.200.20-FF-000337', NULL, 'Wall-associated receptor kinase 3', 101, NULL, NULL, 99362),
(99363, '1.20.1070.10-FF-002131', NULL, 'Uncharacterized protein', 266, NULL, NULL, 99363),
(99364, '2.60.40.790-FF-000023', NULL, 'NudC domain-containing protein 3', 122, NULL, NULL, 99364),
(99365, '3.90.550.10-FF-000021', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 372, NULL, NULL, 99365),
(99366, '1.10.1200.10-FF-000166', NULL, 'Uncharacterized protein', 61, NULL, NULL, 99366),
(99367, '3.80.10.10-FF-003471', NULL, 'Proteophosphoglycan ppg1', 213, NULL, NULL, 99367),
(99368, '3.30.930.10-FF-000249', NULL, 'Uncharacterized protein', 283, NULL, NULL, 99368),
(99369, '3.30.160.60-FF-005005', NULL, NULL, 105, NULL, NULL, 99369),
(99370, '3.10.105.10-FF-000022', NULL, 'Peptide transport system secreted peptide-binding protein', 223, NULL, NULL, 99370),
(99371, '3.40.50.300-FF-004314', NULL, 'ID624', 279, NULL, NULL, 99371),
(99372, '3.30.160.60-FF-004437', NULL, NULL, 32, NULL, NULL, 99372),
(99373, '3.30.420.110-FF-000009', NULL, 'DNA mismatch repair protein MutS', 133, NULL, NULL, 99373),
(99374, '2.60.40.2070-FF-000012', NULL, 'Fimbrial biogenesis protein', 74, NULL, NULL, 99374),
(99375, '3.30.160.60-FF-000098', NULL, 'Zinc finger protein 614', 28, NULL, NULL, 99375),
(99376, '3.30.40.10-FF-001547', NULL, 'E3 ubiquitin-protein ligase PEP5', 103, NULL, NULL, 99376),
(99377, '1.25.40.20-FF-000550', NULL, 'Uncharacterized protein, isoform B', 152, NULL, NULL, 99377),
(99378, '2.60.260.20-FF-000113', NULL, 'DNAJB1 isoform 1', 48, NULL, NULL, 99378),
(99379, '1.10.1200.10-FF-000059', NULL, 'Aspergillus niger contig An11c0010, genomic contig', 77, NULL, NULL, 99379);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(99380, '3.10.20.90-FF-000963', NULL, 'Rap guanine nucleotide exchange factor 5', 41, NULL, NULL, 99380),
(99381, '3.15.20.10-FF-000007', NULL, 'BPI fold-containing family B member 1', 237, NULL, NULL, 99381),
(99382, '3.40.1190.20-FF-000001', NULL, 'Phosphofructokinase', 308, NULL, NULL, 99382),
(99383, '1.25.10.10-FF-001118', NULL, 'Proline-, glutamic acid- and leucine-rich protein 1', 327, NULL, NULL, 99383),
(99384, '2.10.110.10-FF-000190', NULL, 'LIM domain protein', 62, NULL, NULL, 99384),
(99385, '3.90.1410.10-FF-000122', NULL, 'Uncharacterized protein', 154, NULL, NULL, 99385),
(99386, '2.60.40.10-FF-004100', NULL, NULL, 94, NULL, NULL, 99386),
(99387, '1.20.1070.10-FF-001294', NULL, 'Uncharacterized protein', 131, NULL, NULL, 99387),
(99388, '3.40.50.10190-FF-000028', NULL, 'DNA topoisomerase 2-binding protein 1 isoform X1', 103, NULL, NULL, 99388),
(99389, '2.170.260.10-FF-000022', NULL, 'Endoribonuclease dcr-1', 112, NULL, NULL, 99389),
(99390, '3.40.50.300-FF-000992', NULL, 'probable ATP-dependent RNA helicase DDX20', 207, NULL, NULL, 99390),
(99391, '1.20.1250.20-FF-001338', NULL, 'Myo-inositol/proton symporter (MIT)', 209, NULL, NULL, 99391),
(99392, '1.10.20.10-FF-000326', NULL, NULL, 148, NULL, NULL, 99392),
(99393, '3.20.20.70-FF-000760', NULL, NULL, 57, NULL, NULL, 99393),
(99394, '1.25.40.10-FF-003924', NULL, 'Prp39p', 292, NULL, NULL, 99394),
(99395, '2.130.10.10-FF-004701', NULL, 'Uncharacterized protein', 173, NULL, NULL, 99395),
(99396, '3.40.50.2000-FF-000220', NULL, 'Glycogen synthase', 163, NULL, NULL, 99396),
(99397, '3.40.1170.60-FF-000039', NULL, NULL, 65, NULL, NULL, 99397),
(99398, '2.40.160.120-FF-000064', NULL, 'Oxysterol-binding protein', 105, NULL, NULL, 99398),
(99399, '2.40.180.10-FF-000041', NULL, 'Uncharacterized protein', 81, NULL, NULL, 99399),
(99400, '2.130.10.10-FF-001211', NULL, 'CBN-PRP-4 protein', 240, NULL, NULL, 99400),
(99401, '2.60.40.10-FF-000626', NULL, 'Ephrin type-A receptor 1', 91, NULL, NULL, 99401),
(99402, '3.30.1600.10-FF-000038', NULL, 'Uncharacterized protein', 133, NULL, NULL, 99402),
(99403, '2.60.40.60-FF-000944', NULL, 'Uncharacterized protein', 31, NULL, NULL, 99403),
(99404, '1.25.40.10-FF-000272', NULL, 'DUF410 domain protein', 314, NULL, NULL, 99404),
(99405, '1.10.10.10-FF-000769', NULL, 'MarR family transcriptional regulator', 104, NULL, NULL, 99405),
(99406, '3.40.50.10990-FF-000004', NULL, 'GTP cyclohydrolase II', 166, NULL, NULL, 99406),
(99407, '2.120.10.80-FF-000327', NULL, 'Uncharacterized protein', 141, NULL, NULL, 99407),
(99408, '2.40.40.20-FF-000057', NULL, 'AAA family ATPase, CDC48 subfamily', 91, NULL, NULL, 99408),
(99409, '1.10.3060.10-FF-000019', NULL, 'Protein translocase subunit SecA', 208, NULL, NULL, 99409),
(99410, '2.40.20.10-FF-000053', NULL, 'Lipoprotein(a)', 60, NULL, NULL, 99410),
(99411, '1.10.287.70-FF-000648', NULL, 'Predicted protein', 168, NULL, NULL, 99411),
(99412, '3.40.50.720-FF-000382', NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', 319, NULL, NULL, 99412),
(99413, '1.10.720.180-FF-000003', NULL, 'Extracellular respiratory system surface decaheme cytochrome c component MtrF', 50, NULL, NULL, 99413),
(99414, '1.10.150.20-FF-000120', NULL, 'DNA-directed RNA polymerase subunit alpha', 70, NULL, NULL, 99414),
(99415, '3.90.470.10-FF-000020', NULL, '50S ribosomal protein L22', 127, NULL, NULL, 99415),
(99416, '1.20.1070.10-FF-000894', NULL, 'Predicted protein', 184, NULL, NULL, 99416),
(99417, '3.30.830.10-FF-000253', NULL, 'Uncharacterized protein', 134, NULL, NULL, 99417),
(99418, '1.10.530.10-FF-000045', NULL, 'Peptidoglycan hydrolase gp181', 182, NULL, NULL, 99418),
(99419, '1.20.120.350-FF-000135', NULL, 'Uncharacterized protein', 170, NULL, NULL, 99419),
(99420, '2.40.70.10-FF-000455', NULL, NULL, 120, NULL, NULL, 99420),
(99421, '2.60.40.10-FF-000502', NULL, 'obscurin-like protein 1 isoform X2', 91, NULL, NULL, 99421),
(99422, '1.10.30.10-FF-000192', NULL, 'Predicted protein', 73, NULL, NULL, 99422),
(99423, '1.25.10.10-FF-000337', NULL, 'dnaJ homolog subfamily C member 13-like isoform X3', 219, NULL, NULL, 99423);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(99424, '1.10.510.10-FF-003591', NULL, NULL, 210, NULL, NULL, 99424),
(99425, '3.10.450.10-FF-000037', NULL, 'Fetuin-B', 111, NULL, NULL, 99425),
(99426, '3.20.20.80-FF-000488', NULL, 'Solute carrier family 3 member 2b', 315, NULL, NULL, 99426),
(99427, '3.30.70.340-FF-000010', NULL, 'GD23628', 83, NULL, NULL, 99427),
(99428, '2.40.110.10-FF-000054', NULL, 'Acyl-CoA dehydrogenase', 115, NULL, NULL, 99428),
(99429, '3.40.50.2300-FF-001501', NULL, NULL, 113, NULL, NULL, 99429),
(99430, '1.20.1070.10-FF-002024', NULL, 'Uncharacterized protein', 126, NULL, NULL, 99430),
(99431, '2.60.260.20-FF-000057', NULL, 'Heat shock protein-like', 96, NULL, NULL, 99431),
(99432, '1.25.40.10-FF-002582', NULL, 'Pentatricopeptide repeat-containing protein ATP4 homolog, chloroplastic', 78, NULL, NULL, 99432),
(99433, '3.30.499.10-FF-000021', NULL, 'BnaC08g47120D protein', 279, NULL, NULL, 99433),
(99434, '3.40.50.300-FF-006388', NULL, 'Uncharacterized protein', 135, NULL, NULL, 99434),
(99435, '3.40.50.300-FF-003589', NULL, 'Uncharacterized protein', 299, NULL, NULL, 99435),
(99436, '1.10.3370.10-FF-000009', NULL, 'Pretranslocation protein, alpha subunit, putative', 466, NULL, NULL, 99436),
(99437, '3.40.50.300-FF-007804', NULL, 'Predicted protein', 40, NULL, NULL, 99437),
(99438, '3.30.160.60-FF-003588', NULL, 'Zinc finger protein 227', 32, NULL, NULL, 99438),
(99439, '1.10.287.70-FF-000031', NULL, 'Potassium/sodium hyperpolarization-activated cyclic nucleotide-gated channel 1, putative', 256, NULL, NULL, 99439),
(99440, '2.60.120.620-FF-000004', NULL, 'Procollagen-lysine,2-oxoglutarate 5-dioxygenase 2', 174, NULL, NULL, 99440),
(99441, '3.40.190.10-FF-000740', NULL, 'Predicted protein', 76, NULL, NULL, 99441),
(99442, '2.170.190.11-FF-000023', NULL, 'Molybdopterin molybdenumtransferase', 91, NULL, NULL, 99442),
(99443, '3.10.100.10-FF-000090', NULL, 'Proteoglycan 2, bone marrow', 117, NULL, NULL, 99443),
(99444, '1.20.1070.10-FF-001350', NULL, 'Uncharacterized protein', 267, NULL, NULL, 99444),
(99445, '1.10.533.10-FF-000193', NULL, 'Predicted protein', 90, NULL, NULL, 99445),
(99446, '2.10.25.10-FF-000172', NULL, 'FAT atypical cadherin 3', 40, NULL, NULL, 99446),
(99447, '3.30.40.10-FF-001603', NULL, 'Ring finger protein 32, isoform CRA_b', 54, NULL, NULL, 99447),
(99448, '3.90.70.10-FF-000692', NULL, 'Ubiquitin carboxyl-terminal hydrolase 11', 228, NULL, NULL, 99448),
(99449, '2.130.10.30-FF-000020', NULL, 'serine/threonine-protein kinase Nek8', 183, NULL, NULL, 99449),
(99450, '3.30.70.330-FF-002093', NULL, NULL, 125, NULL, NULL, 99450),
(99451, '2.40.10.10-FF-000007', NULL, 'Transmembrane serine protease 7', 103, NULL, NULL, 99451),
(99452, '1.10.3120.10-FF-000025', NULL, NULL, 206, NULL, NULL, 99452),
(99453, '2.40.50.140-FF-000066', NULL, 'Ribonuclease E', 92, NULL, NULL, 99453),
(99454, '1.25.40.20-FF-000218', NULL, 'Fibronectin type 3 and ankyrin repeat domains protein 1', 130, NULL, NULL, 99454),
(99455, '1.20.5.190-FF-000184', NULL, NULL, 52, NULL, NULL, 99455),
(99456, '3.40.50.720-FF-002467', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', 74, NULL, NULL, 99456),
(99457, '3.80.10.10-FF-003139', NULL, 'Uncharacterized protein', 50, NULL, NULL, 99457),
(99458, '4.10.280.10-FF-000115', NULL, 'Transcription factor bHLH113', 63, NULL, NULL, 99458),
(99459, '1.25.40.180-FF-000003', NULL, 'Putative eukaryotic translation initiation factor 4 gamma 1', 203, NULL, NULL, 99459),
(99460, '3.90.290.10-FF-000034', NULL, 'Follistatin', 92, NULL, NULL, 99460),
(99461, '3.30.710.10-FF-000362', NULL, 'Uncharacterized protein', 166, NULL, NULL, 99461),
(99462, '3.40.50.300-FF-004027', NULL, 'ATP-binding cassette subfamily A, member 1, putative', 276, NULL, NULL, 99462),
(99463, '2.40.30.130-FF-000025', NULL, 'Alanine--tRNA ligase', 77, NULL, NULL, 99463),
(99464, '1.20.140.40-FF-000067', NULL, NULL, 139, NULL, NULL, 99464),
(99465, '2.70.160.11-FF-000068', NULL, 'protein arginine N-methyltransferase 9', 195, NULL, NULL, 99465),
(99466, '3.30.497.10-FF-000016', NULL, 'Serpin family B member 11', 228, NULL, NULL, 99466);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(99467, '1.10.287.70-FF-000087', NULL, 'glutamate receptor ionotropic, NMDA 1 isoform X4', 95, NULL, NULL, 99467),
(99468, '2.40.50.140-FF-000228', NULL, 'ATP-dependent DNA ligase', 135, NULL, NULL, 99468),
(99469, '2.60.220.50-FF-000002', NULL, 'Adhesion G protein-coupled receptor B2', 179, NULL, NULL, 99469),
(99470, '3.30.160.60-FF-000154', NULL, 'Tripartite motif-containing protein 2', 76, NULL, NULL, 99470),
(99471, '3.30.1120.10-FF-000052', NULL, 'N-acetylgalactosamine-4-sulfatase', 72, NULL, NULL, 99471),
(99472, '2.60.260.20-FF-000001', NULL, 'Molecular chaperone DnaJ', 63, NULL, NULL, 99472),
(99473, '2.70.70.10-FF-000077', NULL, 'Lipoprotein', 123, NULL, NULL, 99473),
(99474, '3.20.20.70-FF-000428', NULL, 'Predicted protein', 162, NULL, NULL, 99474),
(99475, '1.25.40.20-FF-000370', NULL, 'Ankyrin repeat domain-containing protein 6', 66, NULL, NULL, 99475),
(99476, '1.10.1410.10-FF-000092', NULL, 'Trf4 poly(A) polymerase', 81, NULL, NULL, 99476),
(99477, '2.110.10.10-FF-000032', NULL, 'Uncharacterized protein', 73, NULL, NULL, 99477),
(99478, '2.60.120.200-FF-000614', NULL, 'Uncharacterized protein', 148, NULL, NULL, 99478),
(99479, '1.20.1440.340-FF-000009', NULL, 'Uncharacterized protein', 137, NULL, NULL, 99479),
(99480, '2.60.40.10-FF-003375', NULL, NULL, 101, NULL, NULL, 99480),
(99481, '1.10.10.10-FF-002006', NULL, 'Uncharacterized protein', 124, NULL, NULL, 99481),
(99482, '3.40.50.1820-FF-001391', NULL, 'Uncharacterized protein', 217, NULL, NULL, 99482),
(99483, '2.40.50.120-FF-000060', NULL, 'Uncharacterized protein', 105, NULL, NULL, 99483),
(99484, '3.90.550.10-FF-000133', NULL, 'Cellulose synthase A catalytic subunit 4', 140, NULL, NULL, 99484),
(99485, '3.30.200.20-FF-000225', NULL, 'cold-responsive protein kinase 1', 105, NULL, NULL, 99485),
(99486, '3.40.30.10-FF-001113', NULL, 'Uncharacterized protein', 17, NULL, NULL, 99486),
(99487, '3.30.390.110-FF-000012', NULL, '60S ribosomal protein L28', 122, NULL, NULL, 99487),
(99488, '3.40.1090.10-FF-000052', NULL, 'Patatin', 369, NULL, NULL, 99488),
(99489, '2.60.40.1180-FF-000059', NULL, 'Alpha-amylase', 73, NULL, NULL, 99489),
(99490, '1.10.418.30-FF-000009', NULL, 'Kinetochore and Eb1-associated basic protein', 123, NULL, NULL, 99490),
(99491, '2.30.30.40-FF-000647', NULL, 'Uncharacterized protein', 75, NULL, NULL, 99491),
(99492, '1.10.225.10-FF-000038', NULL, 'Protein CBR-TWK-44', 99, NULL, NULL, 99492),
(99493, '3.90.1180.10-FF-000031', NULL, NULL, 134, NULL, NULL, 99493),
(99494, '3.10.20.90-FF-000851', NULL, 'DNA repair protein rad60', 80, NULL, NULL, 99494),
(99495, '3.90.105.10-FF-000021', NULL, 'Molybdopterin molybdenumtransferase', 55, NULL, NULL, 99495),
(99496, '3.40.30.10-FF-000276', NULL, 'Glutaredoxin 3', 100, NULL, NULL, 99496),
(99497, '1.10.287.110-FF-000346', NULL, 'Uncharacterized protein', 64, NULL, NULL, 99497),
(99498, '2.40.30.10-FF-000278', NULL, 'Uncharacterized protein', 72, NULL, NULL, 99498),
(99499, '3.80.10.10-FF-001054', NULL, 'AGAP007467-PA', 188, NULL, NULL, 99499),
(99500, '1.50.10.10-FF-000144', NULL, 'Non-lysosomal glucosylceramidase', 278, NULL, NULL, 99500),
(99501, '3.40.190.10-FF-000408', NULL, 'Amino acid ABC transporter, periplasmic amino acid-binding protein, putative', 96, NULL, NULL, 99501),
(99502, '1.20.58.60-FF-000337', NULL, 'Spectrin beta chain', 213, NULL, NULL, 99502),
(99503, '3.40.50.2000-FF-000332', NULL, 'Glycosyltransferase, MGT', 220, NULL, NULL, 99503),
(99504, '2.160.10.10-FF-000007', NULL, 'Serine acetyltransferase', 115, NULL, NULL, 99504),
(99505, '1.25.10.10-FF-002630', NULL, 'Transportin, putative', 127, NULL, NULL, 99505),
(99506, '3.40.50.300-FF-001116', NULL, 'Type IV pili twitching motility protein PilT', 258, NULL, NULL, 99506),
(99507, '2.60.40.10-FF-004156', NULL, NULL, 89, NULL, NULL, 99507),
(99508, '2.60.290.11-FF-000001', NULL, 'N-acetylmuramoyl-L-alanine amidase', 100, NULL, NULL, 99508),
(99509, '1.10.510.10-FF-001174', NULL, 'CMGC family protein kinase', 250, NULL, NULL, 99509),
(99510, '3.30.450.30-FF-000038', NULL, 'Profilin', 128, NULL, NULL, 99510);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(99511, '3.40.50.1000-FF-000021', NULL, 'NT5C2 isoform 1', 208, NULL, NULL, 99511),
(99512, '3.40.630.30-FF-000207', NULL, 'GCN5-related N-acetyltransferase', 147, NULL, NULL, 99512),
(99513, '3.30.1490.20-FF-000043', NULL, 'Synapsin', 65, NULL, NULL, 99513),
(99514, '2.30.30.100-FF-000187', NULL, 'Small nuclear ribonucleoprotein F', 67, NULL, NULL, 99514),
(99515, '1.20.58.1480-FF-000029', NULL, 'Lon protease homolog 2, peroxisomal', 107, NULL, NULL, 99515),
(99516, '1.25.10.10-FF-002574', NULL, 'Uncharacterized protein', 163, NULL, NULL, 99516),
(99517, '2.60.120.650-FF-000108', NULL, 'Uncharacterized protein', 230, NULL, NULL, 99517),
(99518, '3.30.40.10-FF-000243', NULL, 'Tripartite motif-containing 46, isoform CRA_c', 67, NULL, NULL, 99518),
(99519, '3.80.10.10-FF-002358', NULL, 'Os08g0203300 protein', 151, NULL, NULL, 99519),
(99520, '2.60.40.10-FF-003936', NULL, NULL, 106, NULL, NULL, 99520),
(99521, '3.40.50.300-FF-003010', NULL, 'Teichoic acids export ATP-binding protein TagH', 279, NULL, NULL, 99521),
(99522, '3.90.550.10-FF-000077', NULL, 'Probable chitin synthase D', 232, NULL, NULL, 99522),
(99523, '1.20.58.70-FF-000110', NULL, 'Qa-SNARE protein, Tlg2/Syntaxin16-family', 210, NULL, NULL, 99523),
(99524, '3.30.60.20-FF-000011', NULL, 'Protein kinase C', 58, NULL, NULL, 99524),
(99525, '3.80.10.10-FF-002414', NULL, 'Uncharacterized protein', 212, NULL, NULL, 99525),
(99526, '1.10.10.60-FF-000183', NULL, 'Transcriptional regulator, TetR family', 68, NULL, NULL, 99526),
(99527, '3.40.50.1480-FF-000018', NULL, 'S-adenosyl-L-homocysteine hydrolase', 180, NULL, NULL, 99527),
(99528, '1.20.1270.280-FF-000042', NULL, 'Dynein, axonemal, heavy polypeptide 9-like', 41, NULL, NULL, 99528),
(99529, '3.30.160.60-FF-002571', NULL, 'Protein odd-skipped-related 2', 29, NULL, NULL, 99529),
(99530, '2.40.160.110-FF-000004', NULL, 'Lysosomal associated membrane protein 2', 168, NULL, NULL, 99530),
(99531, '3.20.20.190-FF-000064', NULL, 'Phosphoinositide phospholipase C', 303, NULL, NULL, 99531),
(99532, '3.90.550.50-FF-000241', NULL, 'Uncharacterized protein', 188, NULL, NULL, 99532),
(99533, '3.90.70.50-FF-000001', NULL, 'Streptopain', 253, NULL, NULL, 99533),
(99534, '3.40.50.300-FF-002734', NULL, 'Chromatin associated protein KTI12', 222, NULL, NULL, 99534),
(99535, '3.30.70.600-FF-000009', NULL, '30S ribosomal protein S10', 102, NULL, NULL, 99535),
(99536, '3.40.630.10-FF-000201', NULL, 'Putative zinc metalloprotease', 286, NULL, NULL, 99536),
(99537, '3.40.50.150-FF-000981', NULL, 'Uncharacterized protein', 306, NULL, NULL, 99537),
(99538, '2.130.10.10-FF-000194', NULL, 'Macrophage-stimulating 1 receptor a', 480, NULL, NULL, 99538),
(99539, '3.40.50.720-FF-001742', NULL, 'Uncharacterized protein', 34, NULL, NULL, 99539),
(99540, '3.30.70.1230-FF-000042', NULL, 'Adenylate cyclase', 204, NULL, NULL, 99540),
(99541, '1.10.630.10-FF-000772', NULL, 'Cytochrome P450 monooxygenase, putative', 171, NULL, NULL, 99541),
(99542, '3.90.320.10-FF-000032', NULL, 'RecBCD enzyme subunit RecB', 312, NULL, NULL, 99542),
(99543, '2.20.70.10-FF-000006', NULL, 'E3 ubiquitin-protein ligase NEDD4-like protein', 37, NULL, NULL, 99543),
(99544, '2.130.10.10-FF-002335', NULL, 'Pre-rRNA-processing protein pro-1', 136, NULL, NULL, 99544),
(99545, '3.40.50.2000-FF-000276', NULL, 'Phosphatidylinositol N-acetylglucosaminyltransferase GPI3 subunit', 167, NULL, NULL, 99545),
(99546, '3.30.200.20-FF-002355', NULL, 'Uncharacterized protein', 42, NULL, NULL, 99546),
(99547, '1.10.3090.10-FF-000027', NULL, 'Predicted protein', 202, NULL, NULL, 99547),
(99548, '3.30.70.330-FF-002710', NULL, NULL, 157, NULL, NULL, 99548),
(99549, '1.25.40.10-FF-003363', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 69, NULL, NULL, 99549),
(99550, '1.10.10.60-FF-001200', NULL, NULL, 85, NULL, NULL, 99550),
(99551, '3.80.10.10-FF-001397', NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', 72, NULL, NULL, 99551),
(99552, '1.10.8.60-FF-000339', NULL, 'Replication factor C subunit 2', 41, NULL, NULL, 99552),
(99553, '3.30.160.60-FF-002172', NULL, 'Zinc finger protein 19', 31, NULL, NULL, 99553);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(99554, '2.60.40.10-FF-005792', NULL, NULL, 86, NULL, NULL, 99554),
(99555, '3.30.160.60-FF-006461', NULL, NULL, 33, NULL, NULL, 99555),
(99556, '4.10.280.10-FF-000059', NULL, 'transcription factor UNE10 isoform X1', 66, NULL, NULL, 99556),
(99557, '1.10.472.80-FF-000149', NULL, 'Predicted protein', 130, NULL, NULL, 99557),
(99558, '3.40.50.720-FF-001343', NULL, 'Related to cholesterol dehydrogenase', 381, NULL, NULL, 99558),
(99559, '3.80.10.10-FF-002015', NULL, 'Leucine Rich Repeat family protein', 134, NULL, NULL, 99559),
(99560, '3.30.70.1390-FF-000005', NULL, 'Probable serine/threonine-protein kinase roco4', 77, NULL, NULL, 99560),
(99561, '3.30.420.10-FF-000727', NULL, NULL, 46, NULL, NULL, 99561),
(99562, '2.10.25.10-FF-001476', NULL, 'Integrin beta', 58, NULL, NULL, 99562),
(99563, '1.10.10.440-FF-000080', NULL, 'Uncharacterized protein', 75, NULL, NULL, 99563),
(99564, '2.40.30.10-FF-000514', NULL, 'Uncharacterized protein', 116, NULL, NULL, 99564),
(99565, '3.40.640.10-FF-000045', NULL, 'Valine--pyruvate aminotransferase', 415, NULL, NULL, 99565),
(99566, '3.30.70.870-FF-000045', NULL, 'Translation elongation factor G, putative', 46, NULL, NULL, 99566),
(99567, '1.10.274.70-FF-000001', NULL, 'Major ampullate spidroin 1', 123, NULL, NULL, 99567),
(99568, '3.30.1520.10-FF-000105', NULL, 'YALI0B01056p', 126, NULL, NULL, 99568),
(99569, '2.60.120.260-FF-000317', NULL, 'Endo-1,4-beta-mannosidase', 179, NULL, NULL, 99569),
(99570, '3.30.70.270-FF-000141', NULL, 'DNA polymerase eta subunit', 199, NULL, NULL, 99570),
(99571, '3.30.70.330-FF-000417', NULL, 'RNA recognition motif-containing protein', 109, NULL, NULL, 99571),
(99572, '3.30.505.10-FF-000233', NULL, NULL, 87, NULL, NULL, 99572),
(99573, '1.20.1050.10-FF-000062', NULL, 'S-crystallin 4', 112, NULL, NULL, 99573),
(99574, '1.10.510.10-FF-003315', NULL, NULL, 72, NULL, NULL, 99574),
(99575, '3.30.60.30-FF-000071', NULL, 'Magu, isoform F', 50, NULL, NULL, 99575),
(99576, '3.30.300.10-FF-000044', NULL, 'GMP synthase [glutamine-hydrolyzing] subunit B', 97, NULL, NULL, 99576),
(99577, '2.40.30.10-FF-000458', NULL, 'Uncharacterized protein', 103, NULL, NULL, 99577),
(99578, '2.80.10.50-FF-000040', NULL, 'lymphocyte antigen 75 isoform X1', 124, NULL, NULL, 99578),
(99579, '1.20.1260.10-FF-000049', NULL, 'Ferritin', 60, NULL, NULL, 99579),
(99580, '3.40.630.170-FF-000005', NULL, 'Glycylpeptide N-tetradecanoyltransferase', 205, NULL, NULL, 99580),
(99581, '3.80.10.10-FF-002690', NULL, 'Receptor-like protein kinase HSL1', 78, NULL, NULL, 99581),
(99582, '3.40.1110.10-FF-000280', NULL, NULL, 137, NULL, NULL, 99582),
(99583, '3.30.160.60-FF-003532', NULL, NULL, 31, NULL, NULL, 99583),
(99584, '3.40.50.300-FF-000099', NULL, 'Shikimate kinase 1', 173, NULL, NULL, 99584),
(99585, '2.60.120.10-FF-000454', NULL, 'Potassium voltage-gated channel protein eag', 163, NULL, NULL, 99585),
(99586, '1.10.420.10-FF-000054', NULL, 'Os07g0626700 protein', 96, NULL, NULL, 99586),
(99587, '3.30.40.10-FF-000642', NULL, 'Vacuolar protein sorting-associated protein 11 homolog', 76, NULL, NULL, 99587),
(99588, '3.30.310.50-FF-000034', NULL, 'Phosphoglucomutase, putative', 102, NULL, NULL, 99588),
(99589, '1.20.1560.10-FF-000145', NULL, 'ABC transporter B family member 7', 339, NULL, NULL, 99589),
(99590, '2.70.170.10-FF-000079', NULL, 'Uncharacterized protein', 214, NULL, NULL, 99590),
(99591, '3.60.10.10-FF-000111', NULL, 'Endonuclease/Exonuclease/phosphatase family, putative', 345, NULL, NULL, 99591),
(99592, '1.20.120.230-FF-000004', NULL, 'Talin 2', 132, NULL, NULL, 99592),
(99593, '1.50.40.10-FF-000533', NULL, 'Uncharacterized protein', 156, NULL, NULL, 99593),
(99594, '2.70.150.10-FF-000122', NULL, 'Phospholipid-transporting ATPase', 167, NULL, NULL, 99594),
(99595, '3.40.630.30-FF-000606', NULL, 'Uncharacterized protein, isoform B', 60, NULL, NULL, 99595),
(99596, '3.40.50.1000-FF-000364', NULL, 'LP01149p', 232, NULL, NULL, 99596),
(99597, '3.30.200.20-FF-002411', NULL, 'Serine/threonine protein kinase, putative', 88, NULL, NULL, 99597),
(99598, '1.10.472.10-FF-000168', NULL, 'BRF1, RNA polymerase III transcription initiation factor subunit', 80, NULL, NULL, 99598);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(99599, '2.60.120.590-FF-000068', NULL, 'RNA replication polyprotein', 147, NULL, NULL, 99599),
(99600, '1.25.40.10-FF-004723', NULL, 'Uncharacterized protein', 86, NULL, NULL, 99600),
(99601, '1.20.1270.240-FF-000002', NULL, NULL, 35, NULL, NULL, 99601),
(99602, '1.10.220.30-FF-000005', NULL, 'Flagellar motor switch protein FliG', 92, NULL, NULL, 99602),
(99603, '3.30.1330.60-FF-000032', NULL, 'OmpA/MotB domain protein', 154, NULL, NULL, 99603),
(99604, '3.40.50.300-FF-005663', NULL, 'DNA binding protein eukaryotic-like', 200, NULL, NULL, 99604),
(99605, '3.30.200.20-FF-001394', NULL, 'Serine/threonine-protein kinase BUR1', 106, NULL, NULL, 99605),
(99606, '3.30.70.330-FF-000237', NULL, 'CUGBP Elav-like family member 2', 100, NULL, NULL, 99606),
(99607, '1.10.10.10-FF-000825', NULL, 'ECF sigma factor FoxI', 57, NULL, NULL, 99607),
(99608, '3.40.50.2300-FF-001265', NULL, NULL, 208, NULL, NULL, 99608),
(99609, '3.40.50.10130-FF-000038', NULL, 'crossover junction endonuclease MUS81', 152, NULL, NULL, 99609),
(99610, '3.40.50.150-FF-000649', NULL, 'Methyltransferase, putative', 215, NULL, NULL, 99610),
(99611, '1.10.3380.10-FF-000061', NULL, 'Predicted protein', 103, NULL, NULL, 99611),
(99612, '1.10.472.10-FF-000224', NULL, 'Cyclin-D2-1', 70, NULL, NULL, 99612),
(99613, '3.30.379.10-FF-000023', NULL, NULL, 184, NULL, NULL, 99613),
(99614, '2.30.29.30-FF-001181', NULL, 'Neurobeachin/beige protein, putative', 101, NULL, NULL, 99614),
(99615, '1.20.120.350-FF-000079', NULL, 'Calcium channel subunit Cch1', 112, NULL, NULL, 99615),
(99616, '2.120.10.10-FF-000003', NULL, 'Neuraminidase 1', 351, NULL, NULL, 99616),
(99617, '2.60.40.1170-FF-000017', NULL, 'stonin-1 isoform X2', 151, NULL, NULL, 99617),
(99618, '2.60.40.10-FF-000446', NULL, 'cell adhesion molecule 2 isoform X1', 104, NULL, NULL, 99618),
(99619, '1.20.58.2220-FF-000061', NULL, 'Formin-like 3', 312, NULL, NULL, 99619),
(99620, '1.20.1280.50-FF-000253', NULL, 'Uncharacterized protein', 123, NULL, NULL, 99620),
(99621, '3.30.450.40-FF-000098', NULL, 'IclR family transcriptional regulator', 168, NULL, NULL, 99621),
(99622, '1.10.1420.10-FF-000042', NULL, 'DNA mismatch repair protein Msh1', 188, NULL, NULL, 99622),
(99623, '1.10.510.10-FF-002478', NULL, 'CAMK family protein kinase', 288, NULL, NULL, 99623),
(99624, '1.20.5.2480-FF-000003', NULL, 'Reticulon', 74, NULL, NULL, 99624),
(99625, '3.30.830.10-FF-000073', NULL, 'Mitochondrial processing peptidase, beta subunit, putative', 231, NULL, NULL, 99625),
(99626, '3.40.33.10-FF-000193', NULL, 'Uncharacterized protein', 85, NULL, NULL, 99626),
(99627, '3.20.20.70-FF-000608', NULL, NULL, 175, NULL, NULL, 99627),
(99628, '3.40.50.150-FF-001762', NULL, NULL, 225, NULL, NULL, 99628),
(99629, '1.20.1510.10-FF-000086', NULL, NULL, 94, NULL, NULL, 99629),
(99630, '3.50.50.60-FF-001472', NULL, 'Type-II NADH dehydrogenase', 62, NULL, NULL, 99630),
(99631, '3.40.50.10240-FF-000015', NULL, 'Thiamin diphosphokinase1', 100, NULL, NULL, 99631),
(99632, '2.60.40.420-FF-000126', NULL, 'AGAP006185-PA', 154, NULL, NULL, 99632),
(99633, '3.30.830.10-FF-000197', NULL, 'Peptidase family protein', 250, NULL, NULL, 99633),
(99634, '3.30.450.260-FF-000010', NULL, 'Uncharacterized protein', 101, NULL, NULL, 99634),
(99635, '3.30.160.60-FF-006062', NULL, NULL, 28, NULL, NULL, 99635),
(99636, '3.30.365.10-FF-000025', NULL, 'Aldehyde oxidase 4', 65, NULL, NULL, 99636),
(99637, '2.130.10.10-FF-004988', NULL, 'Uncharacterized protein', 76, NULL, NULL, 99637),
(99638, '3.50.50.60-FF-001292', NULL, 'Chromosome 9, whole genome shotgun sequence', 167, NULL, NULL, 99638),
(99639, '1.10.472.10-FF-000348', NULL, 'Cdk activating kinase (CAK)/RNA polymerase II transcription initiation/nucleotide excision repair factor TFIIH/TFIIK, cyclin H subunit', 166, NULL, NULL, 99639),
(99640, '3.30.70.980-FF-000022', NULL, 'YGR021W-like protein', 75, NULL, NULL, 99640),
(99641, '3.20.20.80-FF-000145', NULL, 'Class III chitinase, putative', 304, NULL, NULL, 99641),
(99642, '2.20.20.10-FF-000003', NULL, 'Defensin-like peptide 2/4', 42, NULL, NULL, 99642);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(99643, '1.10.260.100-FF-000026', NULL, 'Heat shock 70kD protein binding protein', 64, NULL, NULL, 99643),
(99644, '2.60.200.40-FF-000054', NULL, 'Diacylglycerol kinase', 189, NULL, NULL, 99644),
(99645, '2.120.10.30-FF-000009', NULL, 'Putative low-density lipoprotein receptor-related protein 1B', 313, NULL, NULL, 99645),
(99646, '1.20.58.1590-FF-000006', NULL, 'Uncharacterized protein', 321, NULL, NULL, 99646),
(99647, '1.25.10.10-FF-001793', NULL, 'Uncharacterized protein', 580, NULL, NULL, 99647),
(99648, '2.130.10.10-FF-005949', NULL, 'Uncharacterized protein', 251, NULL, NULL, 99648),
(99649, '1.20.920.20-FF-000031', NULL, 'Uncharacterized protein', 92, NULL, NULL, 99649),
(99650, '2.40.10.170-FF-000010', NULL, 'ATP synthase subunit beta', 79, NULL, NULL, 99650),
(99651, '3.40.50.300-FF-006500', NULL, 'Uncharacterized protein', 114, NULL, NULL, 99651),
(99652, '3.40.50.300-FF-006624', NULL, 'Uncharacterized protein', 93, NULL, NULL, 99652),
(99653, '1.10.10.10-FF-000264', NULL, 'Transcription factor E', 84, NULL, NULL, 99653),
(99654, '2.130.10.10-FF-005825', NULL, 'Uncharacterized protein', 45, NULL, NULL, 99654),
(99655, '2.30.42.10-FF-000031', NULL, 'Glutamate receptor interacting protein 1', 110, NULL, NULL, 99655),
(99656, '2.60.40.10-FF-001407', NULL, 'Plexin A, isoform B', 150, NULL, NULL, 99656),
(99657, '2.60.40.10-FF-005117', NULL, NULL, 98, NULL, NULL, 99657),
(99658, '1.25.40.10-FF-003762', NULL, 'Uncharacterized protein', 163, NULL, NULL, 99658),
(99659, '1.10.730.10-FF-000044', NULL, 'Methionine--tRNA ligase, putative', 153, NULL, NULL, 99659),
(99660, '3.40.390.10-FF-000008', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 3', 209, NULL, NULL, 99660),
(99661, '1.20.1560.10-FF-000089', NULL, 'ABC transporter B family member 1', 23, NULL, NULL, 99661),
(99662, '2.130.10.10-FF-001554', NULL, 'DNA damage-binding protein 1', 345, NULL, NULL, 99662),
(99663, '3.30.420.40-FF-000326', NULL, 'Pantothenate kinase', 182, NULL, NULL, 99663),
(99664, '3.80.10.10-FF-003319', NULL, 'Uncharacterized protein', 144, NULL, NULL, 99664),
(99665, '3.30.1230.20-FF-000007', NULL, '40S ribosomal protein S21', 88, NULL, NULL, 99665),
(99666, '3.30.420.580-FF-000004', NULL, 'Actin-related protein 8', 80, NULL, NULL, 99666),
(99667, '3.20.20.140-FF-000307', NULL, 'Uncharacterized protein', 18, NULL, NULL, 99667),
(99668, '3.40.50.10810-FF-000091', NULL, 'DNA helicase, SNF2/RAD54 family', 212, NULL, NULL, 99668),
(99669, '3.80.10.10-FF-002919', NULL, 'Uncharacterized protein', 75, NULL, NULL, 99669),
(99670, '2.60.40.150-FF-000410', NULL, 'Tandem C2 domains nuclear protein', 128, NULL, NULL, 99670),
(99671, '3.40.50.720-FF-002523', NULL, 'Uncharacterized protein', 103, NULL, NULL, 99671),
(99672, '1.10.600.10-FF-000040', NULL, 'Phytoene synthase', 276, NULL, NULL, 99672),
(99673, '1.10.8.60-FF-000159', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 81, NULL, NULL, 99673),
(99674, '3.40.50.1460-FF-000136', NULL, 'CASP8 and FADD-like apoptosis regulator a', 228, NULL, NULL, 99674),
(99675, '3.30.70.20-FF-000017', NULL, 'Epoxyqueuosine reductase', 71, NULL, NULL, 99675),
(99676, '4.10.49.10-FF-000003', NULL, 'Cytochrome OXidase assembly protein', 44, NULL, NULL, 99676),
(99677, '1.10.3080.10-FF-000021', NULL, 'Chloride channel protein', 458, NULL, NULL, 99677),
(99678, '3.40.50.1820-FF-000222', NULL, 'Carboxypeptidase', 488, NULL, NULL, 99678),
(99679, '3.40.50.720-FF-001163', NULL, 'ADP-ribosyl cyclase/cyclic ADP-ribose hydrolase', 126, NULL, NULL, 99679),
(99680, '2.60.200.20-FF-000172', NULL, 'Two-component signal transduction', 99, NULL, NULL, 99680),
(99681, '2.20.25.10-FF-000031', NULL, 'DNA-directed RNA polymerase subunit', 53, NULL, NULL, 99681),
(99682, '3.20.16.10-FF-000002', NULL, 'Capsid scaffolding protein', 235, NULL, NULL, 99682),
(99683, '3.30.160.60-FF-002419', NULL, 'C2H2 finger domain protein', 23, NULL, NULL, 99683),
(99684, '2.60.40.150-FF-000534', NULL, 'phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit beta isoform-like isoform X1', 173, NULL, NULL, 99684);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(99685, '3.30.210.10-FF-000009', NULL, 'DNA polymerase', 61, NULL, NULL, 99685),
(99686, '3.30.530.20-FF-000093', NULL, 'Hypothetical_protein_-_conserved', 223, NULL, NULL, 99686),
(99687, '2.120.10.30-FF-000161', NULL, 'NHL domain-containing protein', 118, NULL, NULL, 99687),
(99688, '2.40.50.40-FF-000041', NULL, 'Rhino', 62, NULL, NULL, 99688),
(99689, '3.30.1360.40-FF-000045', NULL, 'Putative ribosomal recycling factor, mitochondrial', 81, NULL, NULL, 99689),
(99690, '3.90.1150.10-FF-000259', NULL, 'Serine palmitoyltransferase-like protein', 126, NULL, NULL, 99690),
(99691, '3.40.50.720-FF-001686', NULL, 'Uncharacterized protein', 76, NULL, NULL, 99691),
(99692, '3.50.4.10-FF-000042', NULL, NULL, 85, NULL, NULL, 99692),
(99693, '2.60.40.10-FF-001806', NULL, 'Blast:Twitchin', 101, NULL, NULL, 99693),
(99694, '3.40.50.1440-FF-000130', NULL, 'Uncharacterized protein', 154, NULL, NULL, 99694),
(99695, '2.30.29.30-FF-000629', NULL, 'Adaptin ear-binding coat-associated protein, putative', 120, NULL, NULL, 99695),
(99696, '3.30.450.20-FF-000092', NULL, 'Related to white collar 1 protein', 120, NULL, NULL, 99696),
(99697, '1.10.8.10-FF-000173', NULL, 'ToLlIp homolog', 51, NULL, NULL, 99697),
(99698, '1.20.1740.10-FF-000131', NULL, 'General amino-acid permease GAP1', 466, NULL, NULL, 99698),
(99699, '1.25.40.10-FF-000356', NULL, 'U3 small nucleolar RNA-associated protein 6 homolog', 198, NULL, NULL, 99699),
(99700, '1.25.10.10-FF-002462', NULL, 'Uncharacterized protein', 219, NULL, NULL, 99700),
(99701, '4.10.280.10-FF-000082', NULL, 'Transcription factor ILI6', 82, NULL, NULL, 99701),
(99702, '1.20.1640.10-FF-000016', NULL, 'Patched domain-containing protein 1', 200, NULL, NULL, 99702),
(99703, '1.20.1250.20-FF-001592', NULL, 'Related to HOL1 protein', 285, NULL, NULL, 99703),
(99704, '3.90.470.20-FF-000057', NULL, 'Uncharacterized protein', 41, NULL, NULL, 99704),
(99705, '3.90.70.10-FF-000877', NULL, 'Protein CBG17827', 56, NULL, NULL, 99705),
(99706, '3.30.160.60-FF-005926', NULL, NULL, 53, NULL, NULL, 99706),
(99707, '1.10.287.70-FF-000160', NULL, 'Potassium calcium-activated channel subfamily N member 4', 229, NULL, NULL, 99707),
(99708, '3.30.70.260-FF-000188', NULL, 'Homoserine dehydrogenase', 73, NULL, NULL, 99708),
(99709, '3.30.1140.60-FF-000012', NULL, 'F-actin-capping protein subunit alpha', 101, NULL, NULL, 99709),
(99710, '2.40.30.10-FF-000042', NULL, 'NAD(P)H-flavin reductase', 97, NULL, NULL, 99710),
(99711, '2.60.40.10-FF-003240', NULL, NULL, 48, NULL, NULL, 99711),
(99712, '3.30.70.3400-FF-000018', NULL, 'Protein translocase subunit SecD', 84, NULL, NULL, 99712),
(99713, '1.25.40.10-FF-004088', NULL, 'Uncharacterized protein', 153, NULL, NULL, 99713),
(99714, '2.10.250.10-FF-000008', NULL, 'Calreticulin-3', 69, NULL, NULL, 99714),
(99715, '2.30.30.140-FF-000272', NULL, 'Retinoblastoma-binding protein', 118, NULL, NULL, 99715),
(99716, '3.40.50.300-FF-000964', NULL, 'Multidrug ABC transporter ATP-binding protein', 243, NULL, NULL, 99716),
(99717, '1.20.120.350-FF-000231', NULL, NULL, 118, NULL, NULL, 99717),
(99718, '3.30.9.10-FF-000137', NULL, 'Uncharacterized protein', 162, NULL, NULL, 99718),
(99719, '2.40.50.960-FF-000002', NULL, 'LOC100145507 protein', 153, NULL, NULL, 99719),
(99720, '2.30.42.10-FF-000430', NULL, NULL, 135, NULL, NULL, 99720),
(99721, '3.30.70.330-FF-002002', NULL, NULL, 86, NULL, NULL, 99721),
(99722, '1.10.3430.10-FF-000026', NULL, 'Ammonium transporter 2, putative', 316, NULL, NULL, 99722),
(99723, '3.60.21.10-FF-000299', NULL, 'Serine/threonine-protein phosphatase 5', 116, NULL, NULL, 99723),
(99724, '3.30.1360.200-FF-000015', NULL, 'Multifunctional fusion protein', 120, NULL, NULL, 99724),
(99725, '3.40.50.300-FF-002572', NULL, 'Peroxin 6, isoform D', 159, NULL, NULL, 99725),
(99726, '2.60.200.30-FF-000017', NULL, 'NAD kinase, putative', 143, NULL, NULL, 99726),
(99727, '3.40.50.720-FF-001034', NULL, 'GDP-L-fucose synthase isoform X2', 83, NULL, NULL, 99727),
(99728, '3.30.70.330-FF-001485', NULL, 'Uncharacterized protein', 71, NULL, NULL, 99728),
(99729, '3.30.200.20-FF-002193', NULL, NULL, 52, NULL, NULL, 99729);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(99730, '2.40.50.100-FF-000183', NULL, 'RND family efflux transporter MFP subunit', 35, NULL, NULL, 99730),
(99731, '2.70.150.10-FF-000089', NULL, 'Phospholipid-transporting ATPase', 139, NULL, NULL, 99731),
(99732, '2.120.10.30-FF-000329', NULL, 'Uncharacterized protein', 148, NULL, NULL, 99732),
(99733, '3.40.50.12780-FF-000125', NULL, 'PKS-NRPS hybrid synthetase psoA', 407, NULL, NULL, 99733),
(99734, '4.10.1110.10-FF-000016', NULL, 'Uncharacterized protein', 63, NULL, NULL, 99734),
(99735, '2.40.160.110-FF-000027', NULL, 'Lysosomal-associated membrane protein 1', 172, NULL, NULL, 99735),
(99736, '3.20.20.70-FF-000631', NULL, NULL, 266, NULL, NULL, 99736),
(99737, '1.25.10.100-FF-000001', NULL, 'She4p', 290, NULL, NULL, 99737),
(99738, '2.60.120.200-FF-000530', NULL, 'Uncharacterized protein', 138, NULL, NULL, 99738),
(99739, '1.20.140.150-FF-000124', NULL, 'Epithelial membrane protein 1', 104, NULL, NULL, 99739),
(99740, '3.30.160.60-FF-003791', NULL, NULL, 31, NULL, NULL, 99740),
(99741, '3.40.30.10-FF-000675', NULL, 'Uncharacterized protein', 174, NULL, NULL, 99741),
(99742, '2.130.10.10-FF-000458', NULL, 'Intraflagellar transport 80 homolog (Chlamydomonas)', 161, NULL, NULL, 99742),
(99743, '3.40.1800.20-FF-000009', NULL, 'AGAP005348-PA', 72, NULL, NULL, 99743),
(99744, '1.10.472.10-FF-000117', NULL, 'Mediator complex subunit', 142, NULL, NULL, 99744),
(99745, '3.30.70.330-FF-002441', NULL, NULL, 86, NULL, NULL, 99745),
(99746, '3.30.559.70-FF-000004', NULL, 'Choline O-acetyltransferase', 321, NULL, NULL, 99746),
(99747, '3.50.50.60-FF-000179', NULL, 'Phytoene dehydrogenase', 121, NULL, NULL, 99747),
(99748, '3.40.50.150-FF-000458', NULL, 'O-methyltransferase B', 245, NULL, NULL, 99748),
(99749, '2.130.10.10-FF-005781', NULL, 'Uncharacterized protein', 103, NULL, NULL, 99749),
(99750, '2.60.40.10-FF-002251', NULL, 'Basement membrane proteoglycan', 89, NULL, NULL, 99750),
(99751, '1.25.40.10-FF-003099', NULL, 'GM14979', 193, NULL, NULL, 99751),
(99752, '1.20.1740.10-FF-000182', NULL, 'Uncharacterized protein', 213, NULL, NULL, 99752),
(99753, '4.10.75.10-FF-000007', NULL, 'KALlmann syndrome homolog', 48, NULL, NULL, 99753),
(99754, '3.30.230.70-FF-000039', NULL, 'Exosome complex component RRP42', 291, NULL, NULL, 99754),
(99755, '2.60.40.10-FF-004179', NULL, NULL, 85, NULL, NULL, 99755),
(99756, '3.40.50.300-FF-007776', NULL, 'Uncharacterized protein', 56, NULL, NULL, 99756),
(99757, '1.10.1450.10-FF-000122', NULL, 'Tetraspanin', 115, NULL, NULL, 99757),
(99758, '3.30.60.290-FF-000004', NULL, 'DNA repair protein Rad4 homologue, putative', 38, NULL, NULL, 99758),
(99759, '3.10.580.10-FF-000193', NULL, 'Predicted protein', 109, NULL, NULL, 99759),
(99760, '2.40.50.90-FF-000022', NULL, 'Tudor domain containing 1', 103, NULL, NULL, 99760),
(99761, '1.20.120.1100-FF-000002', NULL, 'Fatty-acid and retinol-binding protein 2', 140, NULL, NULL, 99761),
(99762, '3.10.100.10-FF-000123', NULL, 'C-type lectin 37Da', 146, NULL, NULL, 99762),
(99763, '2.60.40.60-FF-000551', NULL, 'Cadherin-related hmr-1', 99, NULL, NULL, 99763),
(99764, '3.40.50.1820-FF-001520', NULL, 'Alpha/beta-Hydrolases superfamily protein', 149, NULL, NULL, 99764),
(99765, '3.40.120.10-FF-000090', NULL, 'Phosphohexomutase (Phosphoglucomutase / phosphomannomutase)', 88, NULL, NULL, 99765),
(99766, '3.10.110.10-FF-000051', NULL, 'ubiquitin-conjugating enzyme E2 R2-like', 168, NULL, NULL, 99766),
(99767, '1.20.1250.20-FF-000973', NULL, 'Major facilitator superfamily MFS_1', 206, NULL, NULL, 99767),
(99768, '2.10.90.10-FF-000159', NULL, 'Glycoprotein hormone beta 5', 74, NULL, NULL, 99768),
(99769, '3.60.15.10-FF-000206', NULL, 'DNA cross-link repair 1C', 64, NULL, NULL, 99769),
(99770, '3.40.30.10-FF-000192', NULL, 'Iodothyronine deiodinase', 171, NULL, NULL, 99770),
(99771, '3.40.50.2300-FF-001580', NULL, NULL, 145, NULL, NULL, 99771),
(99772, '3.30.70.270-FF-000045', NULL, 'Transposon Tf2-7 polyprotein', 82, NULL, NULL, 99772),
(99773, '1.10.287.70-FF-000643', NULL, 'Predicted protein', 182, NULL, NULL, 99773),
(99774, '3.40.50.20-FF-000095', NULL, 'Cycloserine biosynthesis protein DcsG', 40, NULL, NULL, 99774);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(99775, '1.20.140.40-FF-000062', NULL, NULL, 63, NULL, NULL, 99775),
(99776, '1.10.135.10-FF-000003', NULL, 'Three-domain arginine kinase', 95, NULL, NULL, 99776),
(99777, '3.90.280.10-FF-000028', NULL, NULL, 165, NULL, NULL, 99777),
(99778, '2.60.200.10-FF-000011', NULL, 'interferon regulatory factor 4-like', 198, NULL, NULL, 99778),
(99779, '2.40.50.690-FF-000028', NULL, 'Uncharacterized protein', 96, NULL, NULL, 99779),
(99780, '2.10.25.10-FF-001352', NULL, 'Delta-like 1 protein', 28, NULL, NULL, 99780),
(99781, '3.90.550.50-FF-000117', NULL, 'Beta-1,3-N-acetylglucosaminyltransferase radical fringe, putative', 198, NULL, NULL, 99781),
(99782, '2.60.40.10-FF-002734', NULL, 'Cysteine protease', 93, NULL, NULL, 99782),
(99783, '2.10.70.10-FF-000259', NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', 72, NULL, NULL, 99783),
(99784, '1.25.40.10-FF-002290', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform A', 128, NULL, NULL, 99784),
(99785, '3.40.1170.60-FF-000034', NULL, NULL, 45, NULL, NULL, 99785),
(99786, '1.20.5.1200-FF-000002', NULL, 'clavesin-1', 17, NULL, NULL, 99786),
(99787, '3.40.50.300-FF-003398', NULL, 'Mot1 helicase-like protein', 192, NULL, NULL, 99787),
(99788, '3.30.70.3040-FF-000006', NULL, 'Cell division protein FtsX', 112, NULL, NULL, 99788),
(99789, '1.10.418.10-FF-000094', NULL, 'Hook domain-containing protein', 154, NULL, NULL, 99789),
(99790, '3.30.230.10-FF-000128', NULL, 'DNA mismatch repair protein, putative', 140, NULL, NULL, 99790),
(99791, '2.130.10.10-FF-004836', NULL, 'Uncharacterized protein', 132, NULL, NULL, 99791),
(99792, '2.60.120.620-FF-000083', NULL, 'AGAP013377-PA', 196, NULL, NULL, 99792),
(99793, '3.10.110.10-FF-000208', NULL, 'Ubiquitin-conjugating enzyme E2 I', 164, NULL, NULL, 99793),
(99794, '1.20.1250.20-FF-001153', NULL, 'Solute carrier organic anion transporter family member', 216, NULL, NULL, 99794),
(99795, '6.10.140.2150-FF-000003', NULL, 'Sphingosine-1-phosphate lyase', 43, NULL, NULL, 99795),
(99796, '3.30.200.20-FF-000629', NULL, 'Focal adhesion kinase, isoform D', 115, NULL, NULL, 99796),
(99797, '3.30.1490.120-FF-000025', NULL, 'RNA polymerase Rpb7, N-terminal domain containing protein', 87, NULL, NULL, 99797),
(99798, '1.25.40.20-FF-000685', NULL, 'CAMTA (CAlModulin-binding Transcriptional activator)', 133, NULL, NULL, 99798),
(99799, '1.10.730.20-FF-000030', NULL, 'Uncharacterized protein', 167, NULL, NULL, 99799),
(99800, '3.30.70.330-FF-001822', NULL, NULL, 137, NULL, NULL, 99800),
(99801, '2.60.40.1500-FF-000004', NULL, NULL, 140, NULL, NULL, 99801),
(99802, '3.40.50.11340-FF-000025', NULL, 'Uncharacterized protein', 82, NULL, NULL, 99802),
(99803, '1.10.10.10-FF-000365', NULL, 'ETS domain-containing protein Elk-1 isoform a', 102, NULL, NULL, 99803),
(99804, '1.25.40.20-FF-000555', NULL, 'Putative ankyrin repeat and KH domain-containing protein 1 isoform 2', 139, NULL, NULL, 99804),
(99805, '2.60.40.60-FF-000708', NULL, 'Cadherin-4', 101, NULL, NULL, 99805),
(99806, '2.40.100.10-FF-000093', NULL, 'Peptidyl-prolyl cis-trans isomerase', 140, NULL, NULL, 99806),
(99807, '1.25.70.10-FF-000054', NULL, 'Transcription termination factor 4, mitochondrial', 172, NULL, NULL, 99807),
(99808, '3.40.50.720-FF-001826', NULL, 'Pentafunctional AROM polypeptide', 150, NULL, NULL, 99808),
(99809, '1.20.1540.10-FF-000071', NULL, 'Conserved protein, with rhomboid family domain', 189, NULL, NULL, 99809),
(99810, '1.10.3210.10-FF-000032', NULL, 'HD domain-containing protein', 163, NULL, NULL, 99810),
(99811, '3.40.50.300-FF-008069', NULL, 'Protein CBR-PRX-1', 122, NULL, NULL, 99811),
(99812, '1.10.287.130-FF-000240', NULL, 'Histidine kinase', 87, NULL, NULL, 99812),
(99813, '3.40.50.1000-FF-000465', NULL, 'Uncharacterized protein', 194, NULL, NULL, 99813),
(99814, '1.10.340.30-FF-000059', NULL, 'Endonuclease III homolog', 111, NULL, NULL, 99814),
(99815, '3.90.740.10-FF-000064', NULL, 'Uncharacterized protein', 149, NULL, NULL, 99815),
(99816, '2.60.40.10-FF-001778', NULL, 'Protein tyrosine phosphatase, receptor type B', 77, NULL, NULL, 99816);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(99817, '3.20.110.10-FF-000026', NULL, 'Lysosomal alpha-mannosidase, putative', 44, NULL, NULL, 99817),
(99818, '3.30.160.60-FF-001874', NULL, 'sal-like protein 4 isoform X2', 25, NULL, NULL, 99818),
(99819, '3.40.50.1820-FF-000694', NULL, 'Neuroligin-4, Y-linked', 577, NULL, NULL, 99819),
(99820, '3.30.160.60-FF-005134', NULL, NULL, 28, NULL, NULL, 99820),
(99821, '3.30.200.20-FF-001574', NULL, NULL, 85, NULL, NULL, 99821),
(99822, '1.10.20.10-FF-000293', NULL, NULL, 67, NULL, NULL, 99822),
(99823, '3.30.160.60-FF-005589', NULL, NULL, 70, NULL, NULL, 99823),
(99824, '1.20.200.10-FF-000018', NULL, 'Argininosuccinate lyase', 217, NULL, NULL, 99824),
(99825, '2.30.180.10-FF-000021', NULL, 'Stabilin 2', 134, NULL, NULL, 99825),
(99826, '3.30.450.40-FF-000024', NULL, 'Formate hydrogenlyase transcriptional activator', 171, NULL, NULL, 99826),
(99827, '3.90.260.10-FF-000015', NULL, 'Xeroderma pigmentosum, complementation group C', 261, NULL, NULL, 99827),
(99828, '2.60.40.790-FF-000097', NULL, 'SHQ1 protein', 135, NULL, NULL, 99828),
(99829, '1.10.472.10-FF-000247', NULL, 'Retinoblastoma family protein', 178, NULL, NULL, 99829),
(99830, '3.30.160.60-FF-002363', NULL, 'Putative endonuclease or glycosyl hydrolase with C2H2-type zinc finger domain-containing protein', 50, NULL, NULL, 99830),
(99831, '3.50.70.10-FF-000008', NULL, 'Predicted protein', 159, NULL, NULL, 99831),
(99832, '2.10.25.10-FF-001509', NULL, 'Uncharacterized protein', 32, NULL, NULL, 99832),
(99833, '3.40.50.11960-FF-000003', NULL, 'Increased recombination centers protein 6', 208, NULL, NULL, 99833),
(99834, '3.50.50.100-FF-000059', NULL, 'Uncharacterized protein', 106, NULL, NULL, 99834),
(99835, '3.40.50.300-FF-001144', NULL, 'RAB1A, member RAS oncogene family', 109, NULL, NULL, 99835),
(99836, '3.40.50.1100-FF-000040', NULL, 'L-serine dehydratase, putative', 105, NULL, NULL, 99836),
(99837, '2.40.33.10-FF-000032', NULL, 'Pyruvate kinase', 100, NULL, NULL, 99837),
(99838, '3.30.2080.10-FF-000003', NULL, 'Glycoside hydrolase family 92 protein', 148, NULL, NULL, 99838),
(99839, '2.60.40.10-FF-004549', NULL, NULL, 77, NULL, NULL, 99839),
(99840, '1.25.40.10-FF-001654', NULL, 'Bardet-Biedl syndrome 4 protein, putative', 108, NULL, NULL, 99840),
(99841, '1.25.40.20-FF-001191', NULL, 'Uncharacterized protein', 218, NULL, NULL, 99841),
(99842, '2.60.40.1910-FF-000037', NULL, NULL, 91, NULL, NULL, 99842),
(99843, '3.40.50.300-FF-000655', NULL, 'Protein PHOTOPERIOD-INDEPENDENT EARLY FLOWERING 1', 255, NULL, NULL, 99843),
(99844, '1.10.8.10-FF-000369', NULL, 'Rad23 like protein', 72, NULL, NULL, 99844),
(99845, '2.40.240.20-FF-000004', NULL, 'Ribosomal RNA small subunit methyltransferase E', 72, NULL, NULL, 99845),
(99846, '2.70.70.10-FF-000021', NULL, 'Peptidase, M23 family', 157, NULL, NULL, 99846),
(99847, '2.60.120.10-FF-000769', NULL, 'Uncharacterized protein', 52, NULL, NULL, 99847),
(99848, '2.60.40.10-FF-001323', NULL, 'immunoglobulin superfamily member 10', 97, NULL, NULL, 99848),
(99849, '3.40.50.300-FF-000525', NULL, 'rab-like protein 3 isoform X1', 205, NULL, NULL, 99849),
(99850, '3.30.60.30-FF-000109', NULL, 'Solute carrier organic anion transporter family member', 44, NULL, NULL, 99850),
(99851, '1.25.40.10-FF-000709', NULL, 'Pentatricopeptide repeat-containing protein At2g21090', 140, NULL, NULL, 99851),
(99852, '1.25.40.20-FF-000246', NULL, 'Ankyrin repeat and SOCS box containing 2', 153, NULL, NULL, 99852),
(99853, '1.20.1250.20-FF-001945', NULL, 'Uncharacterized protein', 450, NULL, NULL, 99853),
(99854, '3.40.50.300-FF-008602', NULL, 'Uncharacterized protein', 196, NULL, NULL, 99854),
(99855, '2.60.260.20-FF-000153', NULL, 'DNAJ heat shock N-terminal domain-containing protein', 122, NULL, NULL, 99855),
(99856, '2.30.30.30-FF-000026', NULL, '60S ribosomal protein L14-1', 84, NULL, NULL, 99856),
(99857, '3.30.470.20-FF-000031', NULL, 'Phosphoribosylamine--glycine ligase', 139, NULL, NULL, 99857),
(99858, '1.50.40.10-FF-000264', NULL, 'SLC (SoLute Carrier) homolog', 197, NULL, NULL, 99858),
(99859, '1.10.565.10-FF-000069', NULL, 'Protein CBR-NHR-85', 202, NULL, NULL, 99859);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(99860, '3.40.50.720-FF-000415', NULL, 'Related to GAL10-UDP-glucose 4-epimerase', 254, NULL, NULL, 99860),
(99861, '1.20.1250.20-FF-000164', NULL, 'solute carrier family 2, facilitated glucose transporter member 10', 129, NULL, NULL, 99861),
(99862, '2.60.40.10-FF-004049', NULL, NULL, 97, NULL, NULL, 99862),
(99863, '2.20.70.10-FF-000074', NULL, 'E3 ubiquitin-protein ligase', 33, NULL, NULL, 99863),
(99864, '3.40.50.300-FF-000155', NULL, 'AAA ATPase forming ring-shaped complexes', 191, NULL, NULL, 99864),
(99865, '3.40.1380.20-FF-000055', NULL, 'Pyruvate kinase', 135, NULL, NULL, 99865),
(99866, '3.40.50.300-FF-004550', NULL, 'Midasin', 109, NULL, NULL, 99866),
(99867, '2.40.70.10-FF-000264', NULL, 'Pepsin A', 176, NULL, NULL, 99867),
(99868, '3.30.40.10-FF-001631', NULL, 'E3 ubiquitin-protein ligase NEURL3', 65, NULL, NULL, 99868),
(99869, '4.10.40.20-FF-000003', NULL, 'cysteine-rich motor neuron 1 protein isoform X1', 78, NULL, NULL, 99869),
(99870, '3.30.800.10-FF-000037', NULL, NULL, 108, NULL, NULL, 99870),
(99871, '3.80.10.10-FF-002987', NULL, 'Immunoglobulin domain and leucine-rich repeat-containing protein 2', 153, NULL, NULL, 99871),
(99872, '1.20.58.1030-FF-000030', NULL, 'DNA replication complex GINS protein SLD5', 148, NULL, NULL, 99872),
(99873, '1.25.10.10-FF-000528', NULL, 'Polyubiquitin binding protein, putative', 276, NULL, NULL, 99873),
(99874, '2.130.10.10-FF-001610', NULL, 'Probable cytosolic iron-sulfur protein assembly protein CIAO1 homolog', 321, NULL, NULL, 99874),
(99875, '1.10.1070.11-FF-000010', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit gamma isoform', 201, NULL, NULL, 99875),
(99876, '3.40.630.10-FF-000168', NULL, 'Amidohydrolase', 234, NULL, NULL, 99876),
(99877, '3.40.190.10-FF-000504', NULL, 'ABC transporter substrate-binding protein', 256, NULL, NULL, 99877),
(99878, '3.30.1010.10-FF-000055', NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', 154, NULL, NULL, 99878),
(99879, '1.10.1410.10-FF-000013', NULL, 'PAP/OAS1 substrate-binding domain superfamily', 197, NULL, NULL, 99879),
(99880, '1.20.5.760-FF-000001', NULL, 'Gag polyprotein', 42, NULL, NULL, 99880),
(99881, '3.40.50.300-FF-004707', NULL, 'ATP-binding cassette subfamily F member 2', 161, NULL, NULL, 99881),
(99882, '3.30.40.10-FF-001940', NULL, 'Uncharacterized protein', 68, NULL, NULL, 99882),
(99883, '3.40.1110.10-FF-000004', NULL, 'Plasma membrane ATPase', 148, NULL, NULL, 99883),
(99884, '3.90.980.20-FF-000011', NULL, 'Uncharacterized protein', 130, NULL, NULL, 99884),
(99885, '1.10.4020.10-FF-000006', NULL, 'Uncharacterized protein', 95, NULL, NULL, 99885),
(99886, '3.90.1410.10-FF-000010', NULL, 'Protein PLASTID TRANSCRIPTIONALLY ACTIVE 14', 255, NULL, NULL, 99886),
(99887, '3.50.7.10-FF-000094', NULL, NULL, 82, NULL, NULL, 99887),
(99888, '3.80.10.10-FF-001498', NULL, 'Leucine Rich repeat, putative', 171, NULL, NULL, 99888),
(99889, '3.30.160.60-FF-000385', NULL, 'Zinc finger protein 236 variant', 30, NULL, NULL, 99889),
(99890, '3.30.70.590-FF-000023', NULL, 'Predicted protein', 61, NULL, NULL, 99890),
(99891, '2.30.30.40-FF-000416', NULL, 'Neutrophil cytosolic factor 2', 61, NULL, NULL, 99891),
(99892, '3.40.50.2300-FF-000309', NULL, 'Uncharacterized protein', 302, NULL, NULL, 99892),
(99893, '3.40.630.30-FF-000387', NULL, 'Spermidine/spermine N1-acetyltransferase 1a, duplicate 1', 96, NULL, NULL, 99893),
(99894, '2.40.30.270-FF-000027', NULL, 'Uncharacterized protein', 108, NULL, NULL, 99894),
(99895, '1.10.630.10-FF-000300', NULL, 'Uncharacterized protein', 494, NULL, NULL, 99895),
(99896, '3.40.190.10-FF-000167', NULL, 'Eye-enriched kainate receptor, isoform B', 38, NULL, NULL, 99896),
(99897, '3.90.780.10-FF-000038', NULL, 'Putative secreted 5''-nucleotidase', 191, NULL, NULL, 99897),
(99898, '3.10.100.10-FF-000106', NULL, 'Lectin29Ca', 134, NULL, NULL, 99898),
(99899, '3.90.79.10-FF-000116', NULL, 'MutT/nudix family protein', 126, NULL, NULL, 99899),
(99900, '3.40.50.2000-FF-001136', NULL, 'Uncharacterized protein', 46, NULL, NULL, 99900),
(99901, '3.40.50.1100-FF-000169', NULL, '2-amino-4-ketopentanoate thiolase beta subunit', 197, NULL, NULL, 99901);
INSERT INTO "PUBLIC"."MODEL" VALUES
(99902, '1.10.3130.10-FF-000014', NULL, 'Serine acetyltransferase', 91, NULL, NULL, 99902),
(99903, '2.130.10.10-FF-003864', NULL, 'Uncharacterized protein', 282, NULL, NULL, 99903),
(99904, '2.130.10.10-FF-000149', NULL, 'Eukaryotic translation initiation factor 2A', 204, NULL, NULL, 99904),
(99905, '3.40.30.10-FF-000736', NULL, 'Thioredoxin, putative', 133, NULL, NULL, 99905),
(99906, '3.30.420.110-FF-000032', NULL, 'MutS protein homolog him-14', 163, NULL, NULL, 99906),
(99907, '2.80.10.50-FF-000129', NULL, 'Fibroblast growth factor 10', 46, NULL, NULL, 99907),
(99908, '3.60.15.10-FF-000223', NULL, 'Chromosome 10, whole genome shotgun sequence', 104, NULL, NULL, 99908),
(99909, '3.40.50.10190-FF-000337', NULL, 'Uncharacterized protein', 92, NULL, NULL, 99909),
(99910, '1.20.1250.20-FF-001462', NULL, 'Glucose transporter, putative', 226, NULL, NULL, 99910),
(99911, '3.10.20.90-FF-000356', NULL, 'UBX domain-containing protein', 83, NULL, NULL, 99911),
(99912, '3.90.480.10-FF-000009', NULL, 'NADPH-dependent assimilatory sulfite reductase hemoprotein subunit', 82, NULL, NULL, 99912),
(99913, '1.20.1250.20-FF-000956', NULL, 'Probable multidrug-efflux transporter MT1670', 189, NULL, NULL, 99913),
(99914, '3.30.1130.10-FF-000002', NULL, '7,8-dihydroneopterin aldolase', 119, NULL, NULL, 99914),
(99915, '1.20.1250.20-FF-000181', NULL, 'Major facilitator superfamily domain-containing protein 10', 431, NULL, NULL, 99915),
(99916, '3.30.1360.10-FF-000002', NULL, 'DNA-directed RNA polymerase subunit alpha', 77, NULL, NULL, 99916),
(99917, '2.30.29.30-FF-000461', NULL, 'Coactivator associated arginine methyltransferase 1', 69, NULL, NULL, 99917),
(99918, '2.30.29.30-FF-001080', NULL, 'Zgc:110468 protein', 66, NULL, NULL, 99918),
(99919, '3.40.640.10-FF-000466', NULL, 'Uncharacterized protein', 138, NULL, NULL, 99919),
(99920, '3.40.50.2000-FF-000989', NULL, 'Os02g0207100 protein', 55, NULL, NULL, 99920),
(99921, '3.30.1050.10-FF-000029', NULL, 'Uncharacterized protein', 134, NULL, NULL, 99921),
(99922, '3.30.200.190-FF-000001', NULL, 'Distal tail protein', 79, NULL, NULL, 99922),
(99923, '2.160.20.10-FF-000013', NULL, 'Pectinesterase', 297, NULL, NULL, 99923),
(99924, '2.130.10.10-FF-004483', NULL, 'GH20665p', 131, NULL, NULL, 99924),
(99925, '3.40.109.10-FF-000058', NULL, 'Uncharacterized protein', 214, NULL, NULL, 99925),
(99926, '2.10.70.10-FF-000198', NULL, 'Complement factor b,-like', 62, NULL, NULL, 99926),
(99927, '1.10.10.60-FF-000110', NULL, 'Transcriptional adapter', 54, NULL, NULL, 99927),
(99928, '3.10.50.40-FF-000085', NULL, 'Peptidylprolyl isomerase', 122, NULL, NULL, 99928),
(99929, '1.10.1740.100-FF-000004', NULL, 'Histone-lysine N-methyltransferase', 104, NULL, NULL, 99929),
(99930, '3.50.50.60-FF-000988', NULL, 'Flavin-containing monooxygenase', 162, NULL, NULL, 99930),
(99931, '2.130.10.10-FF-005472', NULL, 'Uncharacterized protein', 157, NULL, NULL, 99931),
(99932, '3.30.565.10-FF-000445', NULL, 'Putative two-component system response regulator', 116, NULL, NULL, 99932),
(99933, '3.40.50.2020-FF-000175', NULL, 'Phosphoribosyl transferase domain containing protein', 66, NULL, NULL, 99933),
(99934, '1.20.1280.50-FF-000225', NULL, 'Putative F-box/LRR-repeat protein At3g42770', 43, NULL, NULL, 99934),
(99935, '3.30.420.40-FF-000298', NULL, 'Rhamnulokinase', 238, NULL, NULL, 99935),
(99936, '3.30.70.1400-FF-000003', NULL, 'Pyruvate dehydrogenase phosphatase regulatory subunit', 114, NULL, NULL, 99936),
(99937, '3.20.20.10-FF-000057', NULL, 'Diaminopimelate decarboxylase', 229, NULL, NULL, 99937),
(99938, '1.20.140.150-FF-000063', NULL, 'Voltage-dependent calcium channel gamma-5 subunit', 222, NULL, NULL, 99938),
(99939, '1.10.20.10-FF-000163', NULL, 'Histone H3, putative', 102, NULL, NULL, 99939),
(99940, '3.90.550.50-FF-000089', NULL, 'Hexosyltransferase', 213, NULL, NULL, 99940),
(99941, '3.30.1360.30-FF-000008', NULL, NULL, 147, NULL, NULL, 99941),
(99942, '2.60.40.1180-FF-000189', NULL, 'Glucosylceramidase', 84, NULL, NULL, 99942),
(99943, '2.60.40.1130-FF-000005', NULL, 'RAB geranylgeranyl transferase alpha subunit, putative', 99, NULL, NULL, 99943);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(99944, '2.60.40.10-FF-000817', NULL, 'Vascular cell adhesion molecule 1', 86, NULL, NULL, 99944),
(99945, '3.30.160.60-FF-005617', NULL, NULL, 30, NULL, NULL, 99945),
(99946, '3.40.50.1820-FF-001183', NULL, 'AGAP003641-PA', 156, NULL, NULL, 99946),
(99947, '3.30.70.980-FF-000050', NULL, 'Predicted protein', 84, NULL, NULL, 99947),
(99948, '1.10.238.10-FF-000220', NULL, 'Centrin, putative', 78, NULL, NULL, 99948),
(99949, '1.10.4160.10-FF-000033', NULL, NULL, 40, NULL, NULL, 99949),
(99950, '2.30.30.140-FF-000255', NULL, 'Uncharacterized protein', 47, NULL, NULL, 99950),
(99951, '3.30.9.10-FF-000154', NULL, 'Uncharacterized protein', 187, NULL, NULL, 99951),
(99952, '3.40.50.300-FF-001453', NULL, 'Adenylate kinase 9', 248, NULL, NULL, 99952),
(99953, '1.20.900.10-FF-000111', NULL, 'Protein CBG05206', 109, NULL, NULL, 99953),
(99954, '3.90.1150.210-FF-000021', NULL, 'F-actin-capping protein subunit beta', 179, NULL, NULL, 99954),
(99955, '1.10.630.10-FF-000429', NULL, 'Uncharacterized protein', 316, NULL, NULL, 99955),
(99956, '3.30.70.330-FF-001030', NULL, 'Polyadenylate-binding protein 1', 87, NULL, NULL, 99956),
(99957, '2.130.10.10-FF-002919', NULL, 'Predicted protein', 121, NULL, NULL, 99957),
(99958, '1.20.120.1910-FF-000048', NULL, 'Cysteine--tRNA ligase', 160, NULL, NULL, 99958),
(99959, '3.80.10.10-FF-002807', NULL, 'Leucine-rich repeat protein (LRRP), putative', 85, NULL, NULL, 99959),
(99960, '3.10.50.40-FF-000113', NULL, 'Peptidylprolyl isomerase', 150, NULL, NULL, 99960),
(99961, '1.20.1480.20-FF-000001', NULL, 'microtubule-associated serine/threonine-protein kinase 4 isoform X1', 95, NULL, NULL, 99961),
(99962, '3.40.50.1820-FF-001211', NULL, 'Uncharacterized protein', 176, NULL, NULL, 99962),
(99963, '3.90.70.10-FF-000085', NULL, 'Ubiquitin carboxyl-terminal hydrolase 36', 313, NULL, NULL, 99963),
(99964, '3.30.200.20-FF-002546', NULL, 'AGC family protein kinase', 128, NULL, NULL, 99964),
(99965, '2.70.50.40-FF-000017', NULL, 'Unc-119-like protein 2', 65, NULL, NULL, 99965),
(99966, '3.40.50.300-FF-004207', NULL, 'Ras GTPase', 190, NULL, NULL, 99966),
(99967, '1.10.565.10-FF-000199', NULL, 'Coup transcription factor, putative', 72, NULL, NULL, 99967),
(99968, '1.10.357.120-FF-000012', NULL, 'DNA-directed RNA polymerase subunit', 134, NULL, NULL, 99968),
(99969, '1.10.30.10-FF-000091', NULL, 'HMG (High mobility group) box domain containing protein', 109, NULL, NULL, 99969),
(99970, '3.20.110.10-FF-000043', NULL, 'NADPH--cytochrome P450 reductase 2', 69, NULL, NULL, 99970),
(99971, '3.30.70.3000-FF-000005', NULL, 'tRNA(His) guanylyltransferase', 249, NULL, NULL, 99971),
(99972, '1.20.1280.290-FF-000047', NULL, 'Bidirectional sugar transporter SWEET17', 82, NULL, NULL, 99972),
(99973, '1.10.10.60-FF-000447', NULL, 'ISWI chromatin-remodeling complex ATPase ISW2', 109, NULL, NULL, 99973),
(99974, '3.40.350.10-FF-000039', NULL, 'Cytoplasmic protein', 167, NULL, NULL, 99974),
(99975, '3.40.50.720-FF-001051', NULL, 'Lysine-ketoglutarate reductase, putative', 50, NULL, NULL, 99975),
(99976, '3.30.160.60-FF-006415', NULL, NULL, 55, NULL, NULL, 99976),
(99977, '2.170.270.10-FF-000175', NULL, 'Uncharacterized protein', 101, NULL, NULL, 99977),
(99978, '1.25.10.10-FF-003142', NULL, 'Uncharacterized protein', 101, NULL, NULL, 99978),
(99979, '3.40.120.10-FF-000101', NULL, 'Phosphoglucomutase/phosphomannomutase family protein', 114, NULL, NULL, 99979),
(99980, '3.40.50.970-FF-000232', NULL, 'Uncharacterized protein', 224, NULL, NULL, 99980),
(99981, '3.20.20.80-FF-000297', NULL, 'Galactose-binding domain-containing protein', 336, NULL, NULL, 99981),
(99982, '3.40.50.10810-FF-000046', NULL, 'Putative SNF2 family helicase/ATPase', 227, NULL, NULL, 99982),
(99983, '3.20.20.70-FF-000159', NULL, 'tRNA-dihydrouridine synthase 4', 234, NULL, NULL, 99983),
(99984, '3.90.550.10-FF-000234', NULL, 'Uncharacterized protein', 202, NULL, NULL, 99984),
(99985, '2.60.40.60-FF-000490', NULL, 'Cadherin 17, LI cadherin (liver-intestine)', 102, NULL, NULL, 99985),
(99986, '2.60.120.10-FF-000639', NULL, 'Uncharacterized protein', 173, NULL, NULL, 99986);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(99987, '1.25.40.10-FF-004751', NULL, 'Os08g0494350 protein', 66, NULL, NULL, 99987),
(99988, '3.60.15.10-FF-000195', NULL, 'Flavo-diiron protein FprA2', 248, NULL, NULL, 99988),
(99989, '1.10.510.10-FF-004405', NULL, NULL, 83, NULL, NULL, 99989),
(99990, '1.10.510.10-FF-002719', NULL, NULL, 173, NULL, NULL, 99990),
(99991, '1.10.720.30-FF-000077', NULL, 'Defective in cullin neddylation protein', 44, NULL, NULL, 99991),
(99992, '2.130.10.10-FF-002375', NULL, 'STXBP5L isoform 4', 115, NULL, NULL, 99992),
(99993, '3.40.50.12780-FF-000142', NULL, 'Uncharacterized protein', 252, NULL, NULL, 99993),
(99994, '1.20.1250.20-FF-000664', NULL, 'MonoCarboxylate Transporter family', 227, NULL, NULL, 99994),
(99995, '2.60.120.200-FF-000513', NULL, 'Calnexin', 109, NULL, NULL, 99995),
(99996, '2.60.40.1170-FF-000101', NULL, NULL, 103, NULL, NULL, 99996),
(99997, '3.30.200.20-FF-000085', NULL, 'Mitogen-activated protein kinase kinase kinase', 90, NULL, NULL, 99997),
(99998, '1.20.5.4130-FF-000010', NULL, 'Disease resistance protein RPM1', 111, NULL, NULL, 99998),
(99999, '2.60.120.10-FF-000786', NULL, 'Uncharacterized protein', 146, NULL, NULL, 99999),
(100000, '3.30.1490.10-FF-000006', NULL, '30S ribosomal protein S8', 64, NULL, NULL, 100000),
(100001, '3.40.50.720-FF-002332', NULL, 'Uncharacterized protein', 97, NULL, NULL, 100001),
(100002, '3.40.50.10180-FF-000008', NULL, 'Glycerate kinase, putative', 199, NULL, NULL, 100002),
(100003, '3.40.50.300-FF-000172', NULL, 'Dynamin-1-like protein isoform 1', 310, NULL, NULL, 100003),
(100004, '2.170.300.10-FF-000026', NULL, 'laminin subunit alpha-2 isoform X2', 67, NULL, NULL, 100004),
(100005, '3.40.50.300-FF-000508', NULL, 'ABC transporter C family member 5', 246, NULL, NULL, 100005),
(100006, '2.60.40.150-FF-000511', NULL, 'Phosphoinositide phospholipase C', 164, NULL, NULL, 100006),
(100007, '3.90.550.10-FF-000364', NULL, 'Glycosyltransferase domain-containing protein, putative', 268, NULL, NULL, 100007),
(100008, '3.30.1010.10-FF-000038', NULL, 'Phosphatidylinositol 4-kinase beta 1', 87, NULL, NULL, 100008),
(100009, '1.20.5.1160-FF-000001', NULL, 'Keratin type II', 116, NULL, NULL, 100009),
(100010, '2.10.25.10-FF-001291', NULL, 'Delta-like protein', 66, NULL, NULL, 100010),
(100011, '3.30.40.10-FF-000451', NULL, 'E3 ubiquitin-protein ligase rnf12-A', 81, NULL, NULL, 100011),
(100012, '2.60.40.10-FF-001306', NULL, 'Matrix remodeling associated 5', 93, NULL, NULL, 100012),
(100013, '3.40.1190.20-FF-000164', NULL, 'ATP-dependent (S)-NAD(P)H-hydrate dehydratase', 276, NULL, NULL, 100013),
(100014, '3.80.10.10-FF-002206', NULL, 'Si:ch211-191a16.5', 115, NULL, NULL, 100014),
(100015, '3.10.20.30-FF-000075', NULL, NULL, 34, NULL, NULL, 100015),
(100016, '1.20.58.60-FF-000253', NULL, 'Spectrin beta, non-erythrocytic 5', 68, NULL, NULL, 100016),
(100017, '3.40.50.300-FF-002072', NULL, 'U3 small nucleolar RNA-associated protein 25', 234, NULL, NULL, 100017),
(100018, '1.10.168.20-FF-000003', NULL, '40S ribosomal protein S8', 72, NULL, NULL, 100018),
(100019, '2.170.280.10-FF-000001', NULL, 'Flagellin', 125, NULL, NULL, 100019),
(100020, '3.50.50.60-FF-001168', NULL, 'Uncharacterized protein', 229, NULL, NULL, 100020),
(100021, '1.10.10.60-FF-000008', NULL, 'Pre-B-cell leukemia transcription factor 1', 82, NULL, NULL, 100021),
(100022, '1.10.220.60-FF-000008', NULL, 'GRIP domain containing protein', 53, NULL, NULL, 100022),
(100023, '1.10.238.10-FF-001046', NULL, 'Calmodulin 5', 40, NULL, NULL, 100023),
(100024, '1.10.10.60-FF-000138', NULL, 'Homeobox protein prophet of Pit-1', 66, NULL, NULL, 100024),
(100025, '3.30.200.20-FF-002563', NULL, 'Serine/threonine-protein kinase SSN3', 42, NULL, NULL, 100025),
(100026, '3.30.160.60-FF-004280', NULL, NULL, 24, NULL, NULL, 100026),
(100027, '3.30.1520.10-FF-000004', NULL, 'Sorting nexin', 133, NULL, NULL, 100027),
(100028, '2.60.40.10-FF-000025', NULL, 'receptor-type tyrosine-protein phosphatase U isoform X2', 97, NULL, NULL, 100028),
(100029, '3.30.160.60-FF-006106', NULL, NULL, 59, NULL, NULL, 100029),
(100030, '1.25.10.10-FF-001489', NULL, 'AEL006Wp', 289, NULL, NULL, 100030);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(100031, '3.40.30.10-FF-000175', NULL, '54S ribosomal protein L51, mitochondrial', 119, NULL, NULL, 100031),
(100032, '1.10.510.40-FF-000008', NULL, 'NTP-dependent putrebactin synthetase PubC', 208, NULL, NULL, 100032),
(100033, '3.90.70.10-FF-000905', NULL, 'Ubiquitinyl hydrolase 1', 269, NULL, NULL, 100033),
(100034, '3.30.870.10-FF-000087', NULL, 'Cardiolipin synthase', 146, NULL, NULL, 100034),
(100035, '1.20.1000.10-FF-000013', NULL, 'Guanylate binding protein 11', 169, NULL, NULL, 100035),
(100036, '2.120.10.80-FF-000400', NULL, 'Kelch domain-containing 10', 131, NULL, NULL, 100036),
(100037, '3.40.910.10-FF-000021', NULL, 'Deoxyhypusine synthase', 307, NULL, NULL, 100037),
(100038, '3.40.1090.10-FF-000108', NULL, 'Uncharacterized protein', 77, NULL, NULL, 100038),
(100039, '3.30.565.10-FF-000006', NULL, 'Sensor histidine kinase WalK', 154, NULL, NULL, 100039),
(100040, '3.30.930.10-FF-000058', NULL, 'Histidine--tRNA ligase', 320, NULL, NULL, 100040),
(100041, '2.130.10.10-FF-004044', NULL, 'Zgc:86896', 218, NULL, NULL, 100041),
(100042, '2.130.10.10-FF-001739', NULL, 'Uncharacterized protein', 81, NULL, NULL, 100042),
(100043, '3.40.390.10-FF-000132', NULL, 'GG12482', 309, NULL, NULL, 100043),
(100044, '3.90.1150.10-FF-000203', NULL, 'Kynureninase', 101, NULL, NULL, 100044),
(100045, '3.40.1110.10-FF-000021', NULL, 'calcium-transporting ATPase, endoplasmic reticulum-type', 244, NULL, NULL, 100045),
(100046, '1.25.40.90-FF-000014', NULL, 'Hepatocyte growth factor-regulated tyrosine kinase substrate', 154, NULL, NULL, 100046),
(100047, '3.30.200.160-FF-000003', NULL, 'Putative general transcription factor 3C polypeptide 5', 115, NULL, NULL, 100047),
(100048, '3.40.50.300-FF-007304', NULL, 'ABC transporter A family member 7', 149, NULL, NULL, 100048),
(100049, '1.25.40.10-FF-004190', NULL, 'Uncharacterized protein', 80, NULL, NULL, 100049),
(100050, '1.25.40.10-FF-003571', NULL, 'Squamous cell carcinoma antigen recognized by T-cells 3', 199, NULL, NULL, 100050),
(100051, '3.20.19.10-FF-000003', NULL, '3-isopropylmalate dehydratase small subunit', 179, NULL, NULL, 100051),
(100052, '2.130.10.10-FF-000121', NULL, 'U3 small nucleolar RNA-associated protein 18 homolog', 320, NULL, NULL, 100052),
(100053, '3.40.50.300-FF-006815', NULL, 'RE52190p', 42, NULL, NULL, 100053),
(100054, '2.80.10.50-FF-000231', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 128, NULL, NULL, 100054),
(100055, '3.50.50.60-FF-001477', NULL, 'Uncharacterized protein', 59, NULL, NULL, 100055),
(100056, '1.20.120.720-FF-000022', NULL, 'Chitin synthase ChsE', 159, NULL, NULL, 100056),
(100057, '1.10.3450.40-FF-000002', NULL, 'Signal recognition particle subunit SRP68', 220, NULL, NULL, 100057),
(100058, '2.70.98.10-FF-000096', NULL, 'Predicted protein', 239, NULL, NULL, 100058),
(100059, '3.90.550.10-FF-000673', NULL, 'Uncharacterized protein', 100, NULL, NULL, 100059),
(100060, '3.40.50.920-FF-000003', NULL, 'Transketolase', 127, NULL, NULL, 100060),
(100061, '3.90.1150.10-FF-000383', NULL, 'PLP-dependent aminotransferase family protein', 142, NULL, NULL, 100061),
(100062, '1.10.510.10-FF-000353', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 4', 268, NULL, NULL, 100062),
(100063, '2.170.150.30-FF-000003', NULL, 'Probable ATP-dependent RNA helicase DHX58', 138, NULL, NULL, 100063),
(100064, '1.10.287.70-FF-000143', NULL, 'Probable glutamate receptor', 148, NULL, NULL, 100064),
(100065, '3.40.50.720-FF-001843', NULL, 'Putative malate dehydrogenase 1B', 55, NULL, NULL, 100065),
(100066, '3.30.30.30-FF-000063', NULL, 'Predicted protein', 58, NULL, NULL, 100066),
(100067, '2.60.40.10-FF-003695', NULL, NULL, 63, NULL, NULL, 100067),
(100068, '3.10.20.690-FF-000002', NULL, 'DNA gyrase subunit B', 90, NULL, NULL, 100068),
(100069, '3.30.160.60-FF-000946', NULL, 'Zinc finger protein 438', 69, NULL, NULL, 100069),
(100070, '1.20.1540.10-FF-000054', NULL, 'Putative membrane protein', 231, NULL, NULL, 100070),
(100071, '1.20.1310.10-FF-000014', NULL, 'Cullin 5', 231, NULL, NULL, 100071),
(100072, '2.30.30.40-FF-000107', NULL, 'FCH and double SH3 domains 1', 72, NULL, NULL, 100072);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(100073, '3.40.50.300-FF-002633', NULL, 'mRNA cleavage and polyadenylation factor CLP1', 253, NULL, NULL, 100073),
(100074, '3.40.50.1440-FF-000102', NULL, 'Uncharacterized protein', 94, NULL, NULL, 100074),
(100075, '1.20.1250.20-FF-002081', NULL, 'Uncharacterized protein', 268, NULL, NULL, 100075),
(100076, '3.40.50.450-FF-000093', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit alpha 2', 124, NULL, NULL, 100076),
(100077, '3.30.497.10-FF-000062', NULL, 'AGAP007691-PA', 117, NULL, NULL, 100077),
(100078, '3.50.50.60-FF-000679', NULL, 'Uncharacterized protein', 158, NULL, NULL, 100078),
(100079, '3.30.720.10-FF-000003', NULL, 'Signal recognition particle 14', 111, NULL, NULL, 100079),
(100080, '4.10.60.10-FF-000193', NULL, 'RNA binding motif protein 4.2', 39, NULL, NULL, 100080),
(100081, '3.40.50.150-FF-001610', NULL, NULL, 255, NULL, NULL, 100081),
(100082, '1.10.3430.10-FF-000043', NULL, 'Uncharacterized protein', 200, NULL, NULL, 100082),
(100083, '2.130.10.10-FF-000019', NULL, 'echinoderm microtubule-associated protein-like 4 isoform X2', 327, NULL, NULL, 100083),
(100084, '3.30.160.60-FF-001891', NULL, 'Zinc finger protein 527', 28, NULL, NULL, 100084),
(100085, '3.30.560.10-FF-000001', NULL, 'Oxygen-dependent choline dehydrogenase', 319, NULL, NULL, 100085),
(100086, '3.20.20.190-FF-000171', NULL, NULL, 100, NULL, NULL, 100086),
(100087, '1.10.287.110-FF-000054', NULL, 'dnaJ homolog subfamily B member 9', 114, NULL, NULL, 100087),
(100088, '3.90.1150.10-FF-000074', NULL, 'Putative aminotransferase', 105, NULL, NULL, 100088),
(100089, '1.25.40.10-FF-002626', NULL, 'Uncharacterized protein', 87, NULL, NULL, 100089),
(100090, '3.30.40.10-FF-002379', NULL, 'Tnf receptor associated factor, putative', 76, NULL, NULL, 100090),
(100091, '3.40.190.10-FF-000476', NULL, 'Oligopeptide ABC transporter, periplasmic oligopeptide-binding protein', 148, NULL, NULL, 100091),
(100092, '1.25.40.20-FF-001674', NULL, 'Uncharacterized protein', 81, NULL, NULL, 100092),
(100093, '1.10.950.10-FF-000004', NULL, 'Villin-like 1', 63, NULL, NULL, 100093),
(100094, '2.60.40.4100-FF-000014', NULL, 'Uromodulin-like 1', 135, NULL, NULL, 100094),
(100095, '3.30.200.20-FF-001927', NULL, 'LRR receptor-like serine/threonine-protein kinase EFR', 72, NULL, NULL, 100095),
(100096, '3.30.559.10-FF-000032', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 234, NULL, NULL, 100096),
(100097, '3.30.200.20-FF-001618', NULL, 'Kinase-like domain-containing protein', 98, NULL, NULL, 100097),
(100098, '1.10.100.10-FF-000007', NULL, 'Insulin like 5', 88, NULL, NULL, 100098),
(100099, '3.40.640.10-FF-000449', NULL, 'Uncharacterized protein', 45, NULL, NULL, 100099),
(100100, '1.10.10.1890-FF-000003', NULL, 'Spindle and kinetochore-associated protein 1 homolog', 124, NULL, NULL, 100100),
(100101, '3.30.160.60-FF-000694', NULL, 'zinc finger protein 516', 66, NULL, NULL, 100101),
(100102, '3.40.50.1970-FF-000025', NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', 202, NULL, NULL, 100102),
(100103, '3.30.70.860-FF-000008', NULL, 'UPF0381 protein HI_0400', 94, NULL, NULL, 100103),
(100104, '1.20.1560.10-FF-000954', NULL, 'Uncharacterized protein', 18, NULL, NULL, 100104),
(100105, '1.10.510.10-FF-001101', NULL, 'serine/threonine-protein kinase Nek10', 94, NULL, NULL, 100105),
(100106, '1.20.5.110-FF-000290', NULL, 'Syntaxin 8-1', 98, NULL, NULL, 100106),
(100107, '3.30.160.60-FF-002380', NULL, 'Zinc finger protein 662', 27, NULL, NULL, 100107),
(100108, '3.50.50.60-FF-000651', NULL, 'Amino acid dehydrogenase', 142, NULL, NULL, 100108),
(100109, '2.30.30.180-FF-000008', NULL, 'Ribosome maturation factor RimP', 62, NULL, NULL, 100109),
(100110, '3.40.50.300-FF-006607', NULL, 'Uncharacterized protein', 96, NULL, NULL, 100110),
(100111, '3.40.50.720-FF-001798', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', 79, NULL, NULL, 100111),
(100112, '3.30.300.30-FF-000022', NULL, 'Putative acyl-activating enzyme 19', 116, NULL, NULL, 100112),
(100113, '3.30.160.60-FF-003009', NULL, 'Ras-responsive element binding protein, putative', 30, NULL, NULL, 100113);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(100114, '3.30.200.20-FF-000438', NULL, 'Serine/threonine-protein kinase WAG2', 86, NULL, NULL, 100114),
(100115, '2.60.40.1180-FF-000222', NULL, 'Glycosyl hydrolase, family 13', 68, NULL, NULL, 100115),
(100116, '3.40.250.10-FF-000094', NULL, 'Tyrosine-protein phosphatase vhp-1', 148, NULL, NULL, 100116),
(100117, '2.40.50.140-FF-001055', NULL, NULL, 169, NULL, NULL, 100117),
(100118, '3.40.50.2300-FF-001237', NULL, NULL, 97, NULL, NULL, 100118),
(100119, '3.40.720.10-FF-000158', NULL, 'Arylsulfatase', 397, NULL, NULL, 100119),
(100120, '1.10.565.10-FF-000171', NULL, 'Uncharacterized protein', 176, NULL, NULL, 100120),
(100121, '2.60.120.260-FF-000632', NULL, 'Alpha-galactosidase', 115, NULL, NULL, 100121),
(100122, '3.40.33.10-FF-000198', NULL, 'Uncharacterized protein', 72, NULL, NULL, 100122),
(100123, '2.30.30.30-FF-000009', NULL, '60S ribosomal protein L26', 140, NULL, NULL, 100123),
(100124, '2.30.30.190-FF-000045', NULL, NULL, 53, NULL, NULL, 100124),
(100125, '1.20.1560.10-FF-000645', NULL, 'ATP-binding cassette subfamily B member 5', 138, NULL, NULL, 100125),
(100126, '1.20.58.390-FF-000125', NULL, 'Acetylcholine-gated ion channel acc-4', 154, NULL, NULL, 100126),
(100127, '3.30.720.10-FF-000020', NULL, 'Signal recognition particle subunit srp14', 91, NULL, NULL, 100127),
(100128, '3.30.1360.120-FF-000098', NULL, 'Putative transferase caf17, mitochondrial', 138, NULL, NULL, 100128),
(100129, '1.25.10.10-FF-002214', NULL, 'Tape measure protein', 417, NULL, NULL, 100129),
(100130, '1.20.1250.20-FF-002007', NULL, 'Predicted protein', 376, NULL, NULL, 100130),
(100131, '1.10.3720.10-FF-000115', NULL, 'Sugar-transport integral membrane protein ABC transporter sugB', 261, NULL, NULL, 100131),
(100132, '3.80.10.10-FF-004140', NULL, 'RXFP2 isoform 1', 109, NULL, NULL, 100132),
(100133, '3.40.50.1980-FF-000146', NULL, 'Putative ferrichrome-binding protein', 164, NULL, NULL, 100133),
(100134, '3.30.230.20-FF-000002', NULL, 'Probable UDP-3-O-acyl-N-acetylglucosamine deacetylase 2, mitochondrial', 128, NULL, NULL, 100134),
(100135, '2.40.30.230-FF-000010', NULL, 'YALI0D23881p', 98, NULL, NULL, 100135),
(100136, '3.30.420.40-FF-000618', NULL, 'Uncharacterized protein', 192, NULL, NULL, 100136),
(100137, '2.30.30.10-FF-000003', NULL, 'Gag-Pol polyprotein', 55, NULL, NULL, 100137),
(100138, '3.30.565.10-FF-000214', NULL, 'Sensor histidine kinase', 145, NULL, NULL, 100138),
(100139, '1.20.120.330-FF-000028', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 158, NULL, NULL, 100139),
(100140, '3.30.70.330-FF-001305', NULL, 'U1 small nuclear ribonucleoprotein, putative', 122, NULL, NULL, 100140),
(100141, '3.10.20.800-FF-000002', NULL, 'L,D-transpeptidase catalytic domain protein', 120, NULL, NULL, 100141),
(100142, '1.10.240.10-FF-000017', NULL, 'Tyrosine--tRNA ligase', 148, NULL, NULL, 100142),
(100143, '1.20.1070.10-FF-001243', NULL, 'Uncharacterized protein', 164, NULL, NULL, 100143),
(100144, '1.10.260.130-FF-000001', NULL, 'Lipase 2', 99, NULL, NULL, 100144),
(100145, '3.40.33.10-FF-000209', NULL, 'Uncharacterized protein', 193, NULL, NULL, 100145),
(100146, '3.30.505.10-FF-000099', NULL, 'Signal transducer and activator of transcription', 136, NULL, NULL, 100146),
(100147, '1.20.1560.10-FF-000162', NULL, 'Predicted protein', 331, NULL, NULL, 100147),
(100148, '3.30.60.80-FF-000001', NULL, 'Recombination protein RecR', 23, NULL, NULL, 100148),
(100149, '1.10.555.10-FF-000243', NULL, NULL, 193, NULL, NULL, 100149),
(100150, '2.130.10.10-FF-002358', NULL, 'Unplaced genomic scaffold supercont2.10, whole genome shotgun sequence', 172, NULL, NULL, 100150),
(100151, '2.60.40.60-FF-000096', NULL, 'Desmocollin 2', 82, NULL, NULL, 100151),
(100152, '1.10.3170.10-FF-000005', NULL, 'RecBCD enzyme subunit RecB', 23, NULL, NULL, 100152),
(100153, '3.30.310.50-FF-000051', NULL, 'Uncharacterized protein', 44, NULL, NULL, 100153),
(100154, '1.10.287.470-FF-000095', NULL, 'Uncharacterized protein', 74, NULL, NULL, 100154),
(100155, '1.25.10.10-FF-001809', NULL, 'Phospholipase A-2-activating protein', 78, NULL, NULL, 100155);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(100156, '1.25.10.10-FF-001697', NULL, 'Uncharacterized protein', 265, NULL, NULL, 100156),
(100157, '3.20.20.80-FF-000858', NULL, 'Uncharacterized protein', 82, NULL, NULL, 100157),
(100158, '1.10.510.10-FF-004052', NULL, NULL, 35, NULL, NULL, 100158),
(100159, '3.90.20.20-FF-000023', NULL, 'Protein GrpE', 126, NULL, NULL, 100159),
(100160, '3.40.50.300-FF-006495', NULL, 'Autophagy-related protein 3', 114, NULL, NULL, 100160),
(100161, '2.130.10.10-FF-002936', NULL, 'Uncharacterized protein', 153, NULL, NULL, 100161),
(100162, '3.40.30.10-FF-000967', NULL, 'Iodothyronine deiodinase', 98, NULL, NULL, 100162),
(100163, '2.40.100.10-FF-000076', NULL, 'Peptidyl-prolyl cis-trans isomerase', 169, NULL, NULL, 100163),
(100164, '3.30.200.20-FF-001057', NULL, 'Probable receptor-like protein kinase At1g33260', 93, NULL, NULL, 100164),
(100165, '2.30.30.100-FF-000030', NULL, 'Bifunctional ligase/repressor BirA', 50, NULL, NULL, 100165),
(100166, '1.10.510.10-FF-003916', NULL, NULL, 76, NULL, NULL, 100166),
(100167, '3.90.1150.10-FF-000411', NULL, 'Uncharacterized protein', 60, NULL, NULL, 100167),
(100168, '2.60.40.10-FF-004960', NULL, NULL, 62, NULL, NULL, 100168),
(100169, '2.40.50.140-FF-000436', NULL, 'DNA-directed RNA polymerases I, II, and III subunit RPABC3', 156, NULL, NULL, 100169),
(100170, '3.10.20.90-FF-001003', NULL, 'FERM domain-containing 5', 63, NULL, NULL, 100170),
(100171, '1.10.10.10-FF-000348', NULL, 'Transcriptional regulator BlaI', 72, NULL, NULL, 100171),
(100172, '3.30.70.330-FF-000541', NULL, 'Nuclear cap-binding protein subunit 2', 140, NULL, NULL, 100172),
(100173, '2.60.210.10-FF-000068', NULL, NULL, 107, NULL, NULL, 100173),
(100174, '3.30.830.10-FF-000202', NULL, 'Metalloenzyme, LuxS/M16 peptidase-like protein', 236, NULL, NULL, 100174),
(100175, '3.80.10.10-FF-003634', NULL, 'Slit guidance ligand 3', 116, NULL, NULL, 100175),
(100176, '3.30.70.240-FF-000047', NULL, 'Uncharacterized protein', 134, NULL, NULL, 100176),
(100177, '3.40.850.10-FF-000151', NULL, 'Kinesin-like protein costa', 165, NULL, NULL, 100177),
(100178, '3.10.100.10-FF-000045', NULL, 'Pulmonary surfactant-associated protein D', 119, NULL, NULL, 100178),
(100179, '3.30.40.10-FF-001070', NULL, 'GM16934', 82, NULL, NULL, 100179),
(100180, '1.10.340.30-FF-000076', NULL, 'Uncharacterized protein', 121, NULL, NULL, 100180),
(100181, '1.10.400.10-FF-000019', NULL, 'Unplaced genomic scaffold supercont1.208, whole genome shotgun sequence', 118, NULL, NULL, 100181),
(100182, '3.10.129.10-FF-000217', NULL, '1,4-dihydroxy-2-naphthoyl-CoA thioesterase 1', 94, NULL, NULL, 100182),
(100183, '3.30.450.20-FF-000485', NULL, 'Histidine kinase', 130, NULL, NULL, 100183),
(100184, '1.25.10.10-FF-002315', NULL, 'Uncharacterized protein', 314, NULL, NULL, 100184),
(100185, '3.40.50.300-FF-003370', NULL, 'Putative ATP-dependent RNA helicase CG14443', 239, NULL, NULL, 100185),
(100186, '3.40.50.620-FF-000503', NULL, 'Tryptophan--tRNA ligase', 101, NULL, NULL, 100186),
(100187, '3.10.20.90-FF-000148', NULL, 'Ubiquitin-like protein ATG12', 90, NULL, NULL, 100187),
(100188, '1.20.58.80-FF-000028', NULL, 'Putative ubiquitin C-terminal hydrolase', 113, NULL, NULL, 100188),
(100189, '1.20.1560.10-FF-000746', NULL, 'Multidrug resistance protein, putative', 124, NULL, NULL, 100189),
(100190, '1.20.58.390-FF-000226', NULL, 'Predicted protein', 134, NULL, NULL, 100190),
(100191, '1.10.472.10-FF-000264', NULL, 'RNA polymerase II holoenzyme cyclin-like subunit', 73, NULL, NULL, 100191),
(100192, '3.40.630.30-FF-000179', NULL, 'RNA cytidine acetyltransferase', 233, NULL, NULL, 100192),
(100193, '3.40.1390.30-FF-000002', NULL, 'Nif3-like dinuclear metal center protein', 122, NULL, NULL, 100193),
(100194, '2.10.25.10-FF-001060', NULL, 'Uncharacterized protein', 40, NULL, NULL, 100194),
(100195, '1.10.510.10-FF-000937', NULL, 'Tyrosine-protein kinase', 181, NULL, NULL, 100195),
(100196, '3.30.200.20-FF-001282', NULL, NULL, 51, NULL, NULL, 100196),
(100197, '2.20.25.90-FF-000009', NULL, 'DMSO reductase', 67, NULL, NULL, 100197),
(100198, '2.60.40.790-FF-000130', NULL, NULL, 98, NULL, NULL, 100198);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(100199, '3.30.160.60-FF-000255', NULL, 'Zinc finger and AT-hook domain containing', 28, NULL, NULL, 100199),
(100200, '3.90.70.10-FF-000113', NULL, 'Putative cysteine protease', 326, NULL, NULL, 100200),
(100201, '3.30.465.10-FF-000061', NULL, 'Aspergillus niger contig An11c0010, genomic contig', 173, NULL, NULL, 100201),
(100202, '1.10.8.50-FF-000033', NULL, 'Predicted protein', 71, NULL, NULL, 100202),
(100203, '2.130.10.10-FF-004061', NULL, 'Coronin', 210, NULL, NULL, 100203),
(100204, '3.30.565.10-FF-000428', NULL, 'Hybrid signal transduction histidine kinase M', 181, NULL, NULL, 100204),
(100205, '1.25.40.10-FF-001637', NULL, 'General transcription factor 3C polypeptide 3', 246, NULL, NULL, 100205),
(100206, '2.30.30.40-FF-000546', NULL, 'Calcium channel, voltage-dependent, beta 3 subunit', 153, NULL, NULL, 100206),
(100207, '3.30.1380.20-FF-000023', NULL, 'Transport protein particle component bet3 domain-containing protein', 156, NULL, NULL, 100207),
(100208, '1.20.1110.10-FF-000134', NULL, NULL, 102, NULL, NULL, 100208),
(100209, '2.30.110.10-FF-000056', NULL, 'Heme oxygenase HugZ', 171, NULL, NULL, 100209),
(100210, '3.90.70.10-FF-000540', NULL, 'Ubiquitinyl hydrolase 1', 226, NULL, NULL, 100210),
(100211, '4.10.60.10-FF-000237', NULL, 'Uncharacterized protein', 49, NULL, NULL, 100211),
(100212, '3.40.50.300-FF-005404', NULL, 'Uncharacterized protein', 177, NULL, NULL, 100212),
(100213, '3.30.1740.20-FF-000006', NULL, '40S ribosomal protein S26', 107, NULL, NULL, 100213),
(100214, '3.40.850.10-FF-000403', NULL, 'Kinesin-like protein', 268, NULL, NULL, 100214),
(100215, '2.30.30.40-FF-000208', NULL, 'Tyrosine-protein kinase', 57, NULL, NULL, 100215),
(100216, '3.40.50.300-FF-007321', NULL, 'Uncharacterized protein', 145, NULL, NULL, 100216),
(100217, '2.60.40.820-FF-000050', NULL, 'Uncharacterized protein', 33, NULL, NULL, 100217),
(100218, '1.10.590.10-FF-000004', NULL, 'Chorismate mutase', 261, NULL, NULL, 100218),
(100219, '1.10.246.20-FF-000005', NULL, 'Protein sepa-1', 81, NULL, NULL, 100219),
(100220, '2.60.120.320-FF-000009', NULL, 'Thiamine pyrophosphokinase', 134, NULL, NULL, 100220),
(100221, '3.30.410.10-FF-000002', NULL, 'GMC-type oxidoreductase', 49, NULL, NULL, 100221),
(100222, '3.50.50.60-FF-000196', NULL, 'L-amino acid oxidase LaoA', 171, NULL, NULL, 100222),
(100223, '1.10.287.110-FF-000476', NULL, 'Predicted protein', 98, NULL, NULL, 100223),
(100224, '3.30.160.60-FF-005898', NULL, NULL, 52, NULL, NULL, 100224),
(100225, '2.60.120.260-FF-000380', NULL, 'Uncharacterized protein', 56, NULL, NULL, 100225),
(100226, '3.90.180.10-FF-000161', NULL, 'Uncharacterized protein', 138, NULL, NULL, 100226),
(100227, '3.30.160.60-FF-001211', NULL, 'Zinc finger and AT-hook domain containing', 55, NULL, NULL, 100227),
(100228, '2.115.10.20-FF-000007', NULL, 'Levansucrase LscB', 415, NULL, NULL, 100228),
(100229, '1.10.10.430-FF-000003', NULL, 'probable protein phosphatase 1N isoform X2', 71, NULL, NULL, 100229),
(100230, '3.30.160.60-FF-000593', NULL, 'PR domain zinc finger protein 15', 26, NULL, NULL, 100230),
(100231, '3.50.50.60-FF-000308', NULL, 'Mycothione reductase', 206, NULL, NULL, 100231),
(100232, '1.10.238.10-FF-000118', NULL, 'Peptidylprolyl isomerase', 76, NULL, NULL, 100232),
(100233, '2.40.70.10-FF-000016', NULL, 'Probable aspartic protease At2g35615', 190, NULL, NULL, 100233),
(100234, '3.30.750.24-FF-000046', NULL, 'Solute carrier family 26 (Sodium-independent sulfate anion transporter), member 11', 160, NULL, NULL, 100234),
(100235, '2.70.170.10-FF-000005', NULL, 'Neuronal nicotinic acetylcholine receptor alpha4 subunit', 217, NULL, NULL, 100235),
(100236, '1.10.472.10-FF-000056', NULL, 'Cyclin G2', 77, NULL, NULL, 100236),
(100237, '2.80.10.70-FF-000006', NULL, 'Uncharacterized protein', 141, NULL, NULL, 100237),
(100238, '3.30.160.60-FF-003689', NULL, 'Si:ch73-347e22.4', 34, NULL, NULL, 100238),
(100239, '2.40.10.10-FF-000390', NULL, NULL, 45, NULL, NULL, 100239),
(100240, '3.40.850.10-FF-000504', NULL, 'Predicted protein', 200, NULL, NULL, 100240),
(100241, '1.25.40.10-FF-005268', NULL, 'Uncharacterized protein', 153, NULL, NULL, 100241);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(100242, '3.90.980.20-FF-000039', NULL, NULL, 126, NULL, NULL, 100242),
(100243, '3.80.10.10-FF-000200', NULL, 'Outer arm dynein light chain 1 protein', 99, NULL, NULL, 100243),
(100244, '3.30.420.40-FF-001023', NULL, 'Uncharacterized protein', 43, NULL, NULL, 100244),
(100245, '3.30.1540.20-FF-000025', NULL, NULL, 72, NULL, NULL, 100245),
(100246, '2.60.60.20-FF-000046', NULL, NULL, 147, NULL, NULL, 100246),
(100247, '3.40.50.150-FF-000121', NULL, 'Sterol 24-C-methyltransferase', 259, NULL, NULL, 100247),
(100248, '3.40.30.10-FF-001164', NULL, 'Glutathione S-transferase Gst', 99, NULL, NULL, 100248),
(100249, '1.10.135.10-FF-000020', NULL, 'Creatine kinase, brain b', 40, NULL, NULL, 100249),
(100250, '2.60.40.4100-FF-000031', NULL, 'Uncharacterized protein', 158, NULL, NULL, 100250),
(100251, '3.40.50.1980-FF-000045', NULL, 'Ferric hydroxamate receptor 2', 165, NULL, NULL, 100251),
(100252, '2.130.10.10-FF-004275', NULL, 'Uncharacterized protein', 129, NULL, NULL, 100252),
(100253, '3.40.50.300-FF-002650', NULL, 'MAK5p nucleolar protein', 285, NULL, NULL, 100253),
(100254, '1.10.472.30-FF-000011', NULL, 'WGS project CABT00000000 data, contig 2.29', 104, NULL, NULL, 100254),
(100255, '1.10.510.10-FF-000584', NULL, 'NIMA related kinase 4', 204, NULL, NULL, 100255),
(100256, '1.10.3470.10-FF-000017', NULL, 'Iron compound ABC transporter, permease protein', 316, NULL, NULL, 100256),
(100257, '2.120.10.30-FF-000301', NULL, 'Uncharacterized protein', 220, NULL, NULL, 100257),
(100258, '1.20.5.1500-FF-000002', NULL, 'breast cancer metastasis-suppressor 1-like protein-A', 49, NULL, NULL, 100258),
(100259, '2.60.40.10-FF-001115', NULL, 'Titin b', 101, NULL, NULL, 100259),
(100260, '2.130.10.10-FF-003656', NULL, 'Transducin family protein / WD-40 repeat family protein', 87, NULL, NULL, 100260),
(100261, '2.40.150.20-FF-000014', NULL, 'Uncharacterized protein', 71, NULL, NULL, 100261),
(100262, '3.90.730.10-FF-000018', NULL, 'T2 family ribonuclease, putative', 270, NULL, NULL, 100262),
(100263, '2.130.10.10-FF-003347', NULL, 'Autophagy-related protein 16', 90, NULL, NULL, 100263),
(100264, '2.60.120.260-FF-000424', NULL, 'Alpha-L-arabinofuranosidase 1', 109, NULL, NULL, 100264),
(100265, '3.30.230.10-FF-000145', NULL, 'Galactokinase putative', 209, NULL, NULL, 100265),
(100266, '3.80.10.10-FF-003735', NULL, 'Uncharacterized protein', 132, NULL, NULL, 100266),
(100267, '2.130.10.10-FF-001638', NULL, 'Os07g0589400 protein', 145, NULL, NULL, 100267),
(100268, '3.30.70.330-FF-001513', NULL, 'Uncharacterized protein', 168, NULL, NULL, 100268),
(100269, '1.20.1280.50-FF-000017', NULL, 'F-box only protein 32', 98, NULL, NULL, 100269),
(100270, '1.10.510.10-FF-002062', NULL, 'Serine/threonine kinase, putative', 282, NULL, NULL, 100270),
(100271, '3.90.1200.10-FF-000039', NULL, 'Methylthioribose kinase', 288, NULL, NULL, 100271),
(100272, '3.90.226.10-FF-000083', NULL, 'Enoyl-CoA hydratase EchA13', 272, NULL, NULL, 100272),
(100273, '3.20.20.140-FF-000279', NULL, 'Deoxyribonuclease, TatD family', 331, NULL, NULL, 100273),
(100274, '3.30.230.130-FF-000074', NULL, 'Anaphase promoting complex subunit 2', 160, NULL, NULL, 100274),
(100275, '3.10.28.10-FF-000047', NULL, 'DNA endonuclease I-CreI', 143, NULL, NULL, 100275),
(100276, '3.30.200.20-FF-000068', NULL, 'G protein-coupled receptor kinase', 95, NULL, NULL, 100276),
(100277, '3.40.50.150-FF-000430', NULL, 'Arginine N-methyltransferase 2', 233, NULL, NULL, 100277),
(100278, '2.160.20.10-FF-000143', NULL, 'Uncharacterized protein', 383, NULL, NULL, 100278),
(100279, '2.60.40.10-FF-005932', NULL, NULL, 103, NULL, NULL, 100279),
(100280, '1.10.10.10-FF-000556', NULL, 'ELK1, member of ETS oncogene family', 107, NULL, NULL, 100280),
(100281, '1.25.40.10-FF-002143', NULL, 'Predicted protein', 58, NULL, NULL, 100281),
(100282, '2.10.70.10-FF-000304', NULL, 'Pregnancy-associated plasma protein A, pappalysin 1b', 67, NULL, NULL, 100282),
(100283, '2.30.29.30-FF-000736', NULL, 'Dip13 beta, putative', 146, NULL, NULL, 100283),
(100284, '3.30.420.10-FF-000755', NULL, NULL, 252, NULL, NULL, 100284);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(100285, '2.40.70.10-FF-000117', NULL, 'Os01g0937500 protein', 208, NULL, NULL, 100285),
(100286, '3.50.50.60-FF-000207', NULL, 'Glutamate synthase', 211, NULL, NULL, 100286),
(100287, '2.10.25.10-FF-000672', NULL, 'Uncharacterized protein, isoform C', 41, NULL, NULL, 100287),
(100288, '3.40.50.300-FF-002864', NULL, 'Dynein heavy chain', 172, NULL, NULL, 100288),
(100289, '3.40.50.300-FF-006596', NULL, 'Uncharacterized protein', 97, NULL, NULL, 100289),
(100290, '3.30.420.40-FF-000404', NULL, 'Major actin', 109, NULL, NULL, 100290),
(100291, '1.10.630.10-FF-000637', NULL, 'Uncharacterized protein', 223, NULL, NULL, 100291),
(100292, '3.40.50.300-FF-006916', NULL, 'Uncharacterized protein', 235, NULL, NULL, 100292),
(100293, '2.10.109.10-FF-000080', NULL, 'Inner mitochondrial membrane peptidase subunit 1', 74, NULL, NULL, 100293),
(100294, '3.30.160.60-FF-004645', NULL, NULL, 36, NULL, NULL, 100294),
(100295, '1.10.3450.20-FF-000007', NULL, 'Nuclear pore complex protein', 145, NULL, NULL, 100295),
(100296, '3.30.1520.10-FF-000021', NULL, 'Phospholipase', 132, NULL, NULL, 100296),
(100297, '1.20.810.10-FF-000020', NULL, 'Cytochrome b', 366, NULL, NULL, 100297),
(100298, '1.10.150.20-FF-000148', NULL, 'Uncharacterized protein', 152, NULL, NULL, 100298),
(100299, '3.80.10.10-FF-003426', NULL, 'Uncharacterized protein', 255, NULL, NULL, 100299),
(100300, '3.30.70.330-FF-002339', NULL, NULL, 110, NULL, NULL, 100300),
(100301, '3.30.420.100-FF-000012', NULL, 'Apicoplast ribosomal protein L18', 130, NULL, NULL, 100301),
(100302, '2.60.40.150-FF-000641', NULL, 'Uncharacterized protein', 129, NULL, NULL, 100302),
(100303, '1.50.10.20-FF-000001', NULL, 'CD109 isoform 1', 310, NULL, NULL, 100303),
(100304, '2.40.160.50-FF-000046', NULL, 'Uncharacterized protein', 383, NULL, NULL, 100304),
(100305, '1.10.510.10-FF-002618', NULL, NULL, 120, NULL, NULL, 100305),
(100306, '2.60.40.60-FF-000360', NULL, 'Protocadherin 19', 106, NULL, NULL, 100306),
(100307, '3.40.50.300-FF-006023', NULL, 'Uncharacterized protein', 137, NULL, NULL, 100307),
(100308, '1.10.560.10-FF-000064', NULL, 'Probable T-complex protein 1 subunit theta', 219, NULL, NULL, 100308),
(100309, '3.30.365.10-FF-000008', NULL, 'Aldehyde oxidase1', 127, NULL, NULL, 100309),
(100310, '3.60.40.10-FF-000219', NULL, 'Probable protein phosphatase 2C 54', 132, NULL, NULL, 100310),
(100311, '1.10.220.160-FF-000013', NULL, 'SET domain-containing protein SmydA-8, isoform B', 71, NULL, NULL, 100311),
(100312, '2.130.10.10-FF-003908', NULL, 'PRP4 pre-mRNA-processing factor 4 homolog (yeast)', 267, NULL, NULL, 100312),
(100313, '3.30.1370.10-FF-000104', NULL, 'Uncharacterized protein', 90, NULL, NULL, 100313),
(100314, '1.20.1060.10-FF-000017', NULL, 'DNA polymerase theta', 119, NULL, NULL, 100314),
(100315, '3.10.129.10-FF-000009', NULL, 'Cytosolic acyl coenzyme A thioester hydrolase', 150, NULL, NULL, 100315),
(100316, '1.20.120.620-FF-000008', NULL, 'Sensor histidine kinase KdpD', 108, NULL, NULL, 100316),
(100317, '3.40.50.410-FF-000188', NULL, 'Uncharacterized protein', 200, NULL, NULL, 100317),
(100318, '2.130.10.10-FF-003072', NULL, 'WD repeat-containing protein 1', 320, NULL, NULL, 100318),
(100319, '3.40.630.30-FF-000078', NULL, 'N-alpha-acetyltransferase 50', 170, NULL, NULL, 100319),
(100320, '1.10.510.10-FF-000370', NULL, 'cyclin-dependent kinase-like 3 isoform X2', 212, NULL, NULL, 100320),
(100321, '2.20.100.10-FF-000052', NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 6', 59, NULL, NULL, 100321),
(100322, '3.10.20.90-FF-000047', NULL, 'Auxin response factor', 95, NULL, NULL, 100322),
(100323, '1.25.10.10-FF-002523', NULL, 'Condensin complex subunit 3-like Protein', 191, NULL, NULL, 100323),
(100324, '3.40.50.300-FF-008041', NULL, 'Uncharacterized protein', 279, NULL, NULL, 100324),
(100325, '2.60.40.60-FF-000916', NULL, 'Protocadherin 12', 99, NULL, NULL, 100325),
(100326, '3.30.470.10-FF-000039', NULL, 'Probable amino acid aminotransferase', 110, NULL, NULL, 100326),
(100327, '3.30.40.10-FF-000007', NULL, 'Bromodomain containing 1, isoform CRA_b', 123, NULL, NULL, 100327);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(100328, '1.20.920.30-FF-000017', NULL, 'Dynein axonemal heavy chain 14', 202, NULL, NULL, 100328),
(100329, '3.80.10.10-FF-003943', NULL, 'Uncharacterized protein', 77, NULL, NULL, 100329),
(100330, '2.60.120.290-FF-000175', NULL, 'Mannose-binding lectin associated serine protease', 116, NULL, NULL, 100330),
(100331, '3.90.550.10-FF-000572', NULL, 'UTP--glucose-1-phosphate uridylyltransferase family protein', 414, NULL, NULL, 100331),
(100332, '3.40.190.10-FF-000712', NULL, 'Blr6048 protein', 103, NULL, NULL, 100332),
(100333, '1.10.10.470-FF-000004', NULL, 'Probable glycosyl hydrolase', 106, NULL, NULL, 100333),
(100334, '3.10.110.10-FF-000282', NULL, 'Uncharacterized protein', 120, NULL, NULL, 100334),
(100335, '1.10.10.10-FF-000909', NULL, 'RNA polymerase sigma factor SigB', 58, NULL, NULL, 100335),
(100336, '2.10.25.10-FF-000863', NULL, 'Multiple epidermal growth factor-like domains protein 6', 47, NULL, NULL, 100336),
(100337, '3.40.50.300-FF-002442', NULL, 'GTPase Era', 184, NULL, NULL, 100337),
(100338, '2.130.10.10-FF-002830', NULL, 'AT07549p', 374, NULL, NULL, 100338),
(100339, '2.60.120.920-FF-000083', NULL, 'Zn-finger in Ran binding protein and others/SPRY domain/HECT-domain (Ubiquitin-transferase), putative', 183, NULL, NULL, 100339),
(100340, '1.10.287.110-FF-000262', NULL, 'Uncharacterized protein', 98, NULL, NULL, 100340),
(100341, '2.60.34.10-FF-000112', NULL, 'DnaK protein', 176, NULL, NULL, 100341),
(100342, '3.30.70.330-FF-001614', NULL, 'RNA-binding protein-like protein', 203, NULL, NULL, 100342),
(100343, '2.60.40.10-FF-004651', NULL, NULL, 85, NULL, NULL, 100343),
(100344, '3.30.70.330-FF-000996', NULL, 'U4/U6 snRNP-associated protein', 83, NULL, NULL, 100344),
(100345, '1.20.58.830-FF-000050', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 133, NULL, NULL, 100345),
(100346, '3.80.10.10-FF-001026', NULL, 'Putative leucine-rich repeat receptor-like serine/threonine-protein kinase isoform A', 159, NULL, NULL, 100346),
(100347, '3.40.50.10800-FF-000009', NULL, 'Quinolinate synthase, chloroplastic', 109, NULL, NULL, 100347),
(100348, '2.60.40.10-FF-002604', NULL, 'Uncharacterized protein', 117, NULL, NULL, 100348),
(100349, '2.60.40.10-FF-001986', NULL, 'Titin homolog', 102, NULL, NULL, 100349),
(100350, '2.10.110.10-FF-000307', NULL, 'Uncharacterized protein', 37, NULL, NULL, 100350),
(100351, '2.70.170.10-FF-000213', NULL, 'Uncharacterized protein', 146, NULL, NULL, 100351),
(100352, '3.40.50.720-FF-002540', NULL, 'Uncharacterized protein', 75, NULL, NULL, 100352),
(100353, '3.10.100.10-FF-000253', NULL, NULL, 130, NULL, NULL, 100353),
(100354, '1.20.120.420-FF-000022', NULL, 'Probable translation initiation factor eIF-2B subunit beta', 110, NULL, NULL, 100354),
(100355, '3.40.1090.10-FF-000007', NULL, 'Lysophospholipase NTE1', 113, NULL, NULL, 100355),
(100356, '3.40.30.10-FF-000545', NULL, 'Glutathione peroxidase', 127, NULL, NULL, 100356),
(100357, '3.30.50.10-FF-000036', NULL, 'Endothelial transcription factor GATA-2', 52, NULL, NULL, 100357),
(100358, '3.30.930.10-FF-000266', NULL, 'Class II aaRS and biotin synthetases superfamily protein', 58, NULL, NULL, 100358),
(100359, '3.30.710.10-FF-000047', NULL, 'Zinc finger and BTB domain-containing protein 26', 150, NULL, NULL, 100359),
(100360, '2.60.120.620-FF-000111', NULL, 'Uncharacterized protein', 171, NULL, NULL, 100360),
(100361, '1.10.8.720-FF-000070', NULL, 'Dynein axonemal heavy chain 3', 157, NULL, NULL, 100361),
(100362, '1.10.472.10-FF-000617', NULL, 'Uncharacterized protein', 156, NULL, NULL, 100362),
(100363, '2.120.10.80-FF-000322', NULL, 'Uncharacterized protein', 158, NULL, NULL, 100363),
(100364, '2.60.200.20-FF-000132', NULL, 'Cell-cycle checkpoint serine-threonine kinase (Eurofung)', 175, NULL, NULL, 100364),
(100365, '2.130.10.10-FF-000930', NULL, 'Dmx like 1', 139, NULL, NULL, 100365),
(100366, '3.30.450.40-FF-000232', NULL, 'Heat-inducible transcription repressor HrcA', 135, NULL, NULL, 100366),
(100367, '3.30.60.30-FF-000211', NULL, 'Uncharacterized protein', 70, NULL, NULL, 100367),
(100368, '1.25.40.10-FF-003470', NULL, 'Pentatricopeptide repeat-containing protein', 99, NULL, NULL, 100368);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(100369, '1.10.510.10-FF-002270', NULL, NULL, 228, NULL, NULL, 100369),
(100370, '2.60.40.10-FF-002751', NULL, 'Uncharacterized protein', 108, NULL, NULL, 100370),
(100371, '1.10.418.10-FF-000077', NULL, 'Related to alpha-actinin', 118, NULL, NULL, 100371),
(100372, '3.90.550.10-FF-000425', NULL, 'polypeptide N-acetylgalactosaminyltransferase 10 isoform X3', 66, NULL, NULL, 100372),
(100373, '1.10.10.10-FF-002034', NULL, 'Cell division control protein', 96, NULL, NULL, 100373),
(100374, '1.20.920.10-FF-000011', NULL, 'Protein polybromo-1 isoform 1', 119, NULL, NULL, 100374),
(100375, '3.30.420.10-FF-000300', NULL, 'Poly(A)-specific_ribonuclease_PARN_-_putative', 205, NULL, NULL, 100375),
(100376, '1.10.30.10-FF-000147', NULL, 'Uncharacterized protein', 83, NULL, NULL, 100376),
(100377, '3.10.110.10-FF-000079', NULL, 'ubiquitin-conjugating enzyme E2 H isoform X2', 61, NULL, NULL, 100377),
(100378, '3.40.50.300-FF-005051', NULL, 'Predicted protein', 82, NULL, NULL, 100378),
(100379, '1.10.20.10-FF-000062', NULL, 'Nuclear transcription factor Y subunit C', 114, NULL, NULL, 100379),
(100380, '3.100.10.10-FF-000051', NULL, NULL, 125, NULL, NULL, 100380),
(100381, '3.10.120.10-FF-000006', NULL, 'Membrane steroid-binding protein 1', 99, NULL, NULL, 100381),
(100382, '3.40.50.620-FF-000150', NULL, 'Integral membrane protein', 150, NULL, NULL, 100382),
(100383, '3.20.20.140-FF-000487', NULL, 'Uncharacterized protein', 240, NULL, NULL, 100383),
(100384, '3.40.395.10-FF-000019', NULL, 'Similar to Ulp1 peptidase', 249, NULL, NULL, 100384),
(100385, '1.10.10.60-FF-000874', NULL, NULL, 62, NULL, NULL, 100385),
(100386, '1.10.238.10-FF-000984', NULL, 'Probable mitochondrial Rho GTPase gemA', 190, NULL, NULL, 100386),
(100387, '3.30.160.100-FF-000003', NULL, 'Ribosome hibernation promoting factor', 108, NULL, NULL, 100387),
(100388, '3.30.200.20-FF-002119', NULL, 'Uncharacterized protein', 76, NULL, NULL, 100388),
(100389, '3.90.70.200-FF-000011', NULL, 'Rtfo-1', 129, NULL, NULL, 100389),
(100390, '3.30.1330.200-FF-000003', NULL, 'Probable chemoreceptor glutamine deamidase CheD 1', 165, NULL, NULL, 100390),
(100391, '4.10.410.10-FF-000126', NULL, 'Uncharacterized protein', 67, NULL, NULL, 100391),
(100392, '3.30.160.60-FF-001110', NULL, 'Krueppel factor 13', 33, NULL, NULL, 100392),
(100393, '2.30.29.30-FF-000944', NULL, 'Phospholipase D B', 124, NULL, NULL, 100393),
(100394, '3.60.140.10-FF-000002', NULL, 'Laccase (multicopper oxidoreductase) domain-containing 1', 253, NULL, NULL, 100394),
(100395, '2.30.30.100-FF-000136', NULL, 'YALI0D14102p', 99, NULL, NULL, 100395),
(100396, '3.40.50.10810-FF-000107', NULL, 'SNF2 domain-containing protein / helicase domain-containing protein / zinc finger protein-like protein', 92, NULL, NULL, 100396),
(100397, '2.40.70.10-FF-000472', NULL, NULL, 160, NULL, NULL, 100397),
(100398, '3.40.800.10-FF-000001', NULL, 'Agmatinase', 302, NULL, NULL, 100398),
(100399, '3.40.140.10-FF-000001', NULL, '26S proteasome non-ATPase regulatory subunit', 215, NULL, NULL, 100399),
(100400, '3.30.870.10-FF-000120', NULL, 'Cardiolipin synthase', 149, NULL, NULL, 100400),
(100401, '2.60.40.10-FF-003223', NULL, NULL, 92, NULL, NULL, 100401),
(100402, '1.25.10.10-FF-002006', NULL, 'mRNA-binding U2 snRNP complex subunit', 221, NULL, NULL, 100402),
(100403, '3.90.1150.10-FF-000175', NULL, 'Unplaced genomic scaffold supercont1.163, whole genome shotgun sequence', 149, NULL, NULL, 100403),
(100404, '1.20.1050.10-FF-000207', NULL, 'Methionine--tRNA ligase, cytoplasmic', 105, NULL, NULL, 100404),
(100405, '4.10.520.10-FF-000016', NULL, 'DNA-binding protein', 86, NULL, NULL, 100405),
(100406, '2.60.120.370-FF-000002', NULL, 'YhcH/YjgK/YiaL family protein', 149, NULL, NULL, 100406),
(100407, '3.30.1370.10-FF-000059', NULL, 'Tudor and KH domain containing, isoform CRA_a', 84, NULL, NULL, 100407),
(100408, '2.40.30.10-FF-000351', NULL, 'Ribosomal protein L3', 180, NULL, NULL, 100408),
(100409, '3.40.50.300-FF-004342', NULL, 'ABC transporter ATP-binding protein', 248, NULL, NULL, 100409),
(100410, '3.90.1290.10-FF-000084', NULL, 'Uncharacterized protein', 62, NULL, NULL, 100410);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(100411, '1.10.150.20-FF-000047', NULL, 'DNA-directed RNA polymerase subunit alpha', 74, NULL, NULL, 100411),
(100412, '1.10.510.10-FF-002371', NULL, NULL, 169, NULL, NULL, 100412),
(100413, '1.20.1070.10-FF-002007', NULL, 'Uncharacterized protein', 140, NULL, NULL, 100413),
(100414, '3.10.100.10-FF-000354', NULL, NULL, 96, NULL, NULL, 100414),
(100415, '1.25.40.10-FF-004296', NULL, 'TPR Domain containing protein', 334, NULL, NULL, 100415),
(100416, '2.60.40.10-FF-000497', NULL, 'Striated muscle preferentially expressed protein kinase', 107, NULL, NULL, 100416),
(100417, '2.60.120.200-FF-000058', NULL, 'Laminin subunit alpha 4', 181, NULL, NULL, 100417),
(100418, '3.40.309.10-FF-000056', NULL, 'Aldehyde dehydrogenase', 187, NULL, NULL, 100418),
(100419, '3.30.40.10-FF-000350', NULL, 'Histone-lysine N-methyltransferase', 109, NULL, NULL, 100419),
(100420, '2.60.120.260-FF-000071', NULL, 'Ephrin type-B receptor 4', 184, NULL, NULL, 100420),
(100421, '2.60.200.30-FF-000034', NULL, 'Inorganic polyphosphate/ATP-NAD kinase, putative', 153, NULL, NULL, 100421),
(100422, '3.40.50.300-FF-001936', NULL, 'tRNA dimethylallyltransferase', 219, NULL, NULL, 100422),
(100423, '3.40.50.150-FF-001402', NULL, NULL, 165, NULL, NULL, 100423),
(100424, '2.40.10.10-FF-000451', NULL, NULL, 57, NULL, NULL, 100424),
(100425, '1.25.40.10-FF-000917', NULL, 'Signal recognition particle subunit SRP72', 108, NULL, NULL, 100425),
(100426, '2.60.40.10-FF-004196', NULL, NULL, 82, NULL, NULL, 100426),
(100427, '3.80.10.10-FF-001689', NULL, 'Leucine Rich Repeat domain protein (AFU_orthologue AFUA_7G02000)', 384, NULL, NULL, 100427),
(100428, '3.10.580.10-FF-000119', NULL, 'Chloride channel protein', 158, NULL, NULL, 100428),
(100429, '3.40.20.10-FF-000146', NULL, 'Villidin', 112, NULL, NULL, 100429),
(100430, '3.90.105.10-FF-000026', NULL, 'Molybdenum cofactor biosynthesis protein (MoaA)', 57, NULL, NULL, 100430),
(100431, '1.25.40.20-FF-001174', NULL, 'Transient receptor potential cation channel subfamily A member 1', 134, NULL, NULL, 100431),
(100432, '2.90.10.10-FF-000027', NULL, 'Serine/threonine-protein kinase', 124, NULL, NULL, 100432),
(100433, '1.10.287.130-FF-000268', NULL, 'Sensor histidine kinase/response regulator', 120, NULL, NULL, 100433),
(100434, '2.60.260.20-FF-000006', NULL, 'DnaJ subfamily B member 13', 81, NULL, NULL, 100434),
(100435, '1.10.10.10-FF-000134', NULL, 'Regulatory protein RecX', 46, NULL, NULL, 100435),
(100436, '2.60.40.1670-FF-000009', NULL, 'Sfb3p', 137, NULL, NULL, 100436),
(100437, '2.60.40.150-FF-000141', NULL, 'Coiled-coil and C2 domain-containing protein 2A', 154, NULL, NULL, 100437),
(100438, '3.40.640.10-FF-000258', NULL, 'Cystathionine gamma-synthase', 246, NULL, NULL, 100438),
(100439, '1.25.40.10-FF-002042', NULL, 'Putative pentatricopeptide repeat-containing protein', 152, NULL, NULL, 100439),
(100440, '2.60.40.10-FF-000918', NULL, 'Heparan sulfate proteoglycan 2', 81, NULL, NULL, 100440),
(100441, '2.60.120.740-FF-000001', NULL, 'Adhesion G protein-coupled receptor L2', 107, NULL, NULL, 100441),
(100442, '1.25.40.90-FF-000115', NULL, 'Clathrin interactor 1', 48, NULL, NULL, 100442),
(100443, '1.20.1110.10-FF-000033', NULL, 'Calcium-transporting ATPase', 143, NULL, NULL, 100443),
(100444, '1.20.1310.10-FF-000115', NULL, NULL, 113, NULL, NULL, 100444),
(100445, '1.20.1270.60-FF-000289', NULL, 'Uncharacterized protein', 165, NULL, NULL, 100445),
(100446, '3.30.160.20-FF-000030', NULL, 'NFKB repressing factor', 78, NULL, NULL, 100446),
(100447, '3.40.630.150-FF-000027', NULL, 'Uncharacterized protein', 267, NULL, NULL, 100447),
(100448, '1.20.1070.10-FF-000107', NULL, '5-hydroxytryptamine (Serotonin) receptor 1A', 311, NULL, NULL, 100448),
(100449, '1.20.1070.10-FF-001698', NULL, 'Uncharacterized protein', 109, NULL, NULL, 100449),
(100450, '2.130.10.10-FF-000885', NULL, 'BEACH-DOMAIN HOMOLOG A1', 272, NULL, NULL, 100450),
(100451, '1.20.1080.10-FF-000035', NULL, 'AQuaPorin or aquaglyceroporin related', 250, NULL, NULL, 100451),
(100452, '3.30.70.1660-FF-000002', NULL, 'Peptide chain release factor 1', 111, NULL, NULL, 100452);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(100453, '1.10.510.10-FF-001090', NULL, 'Serine threonine protein kinase putative', 309, NULL, NULL, 100453),
(100454, '1.10.510.10-FF-001865', NULL, 'Uncharacterized protein', 224, NULL, NULL, 100454),
(100455, '3.40.50.300-FF-000756', NULL, 'Rho-related GTP-binding protein RhoH', 183, NULL, NULL, 100455),
(100456, '1.10.510.10-FF-004327', NULL, NULL, 138, NULL, NULL, 100456),
(100457, '3.30.450.20-FF-000440', NULL, 'Uncharacterized protein', 112, NULL, NULL, 100457),
(100458, '3.20.20.80-FF-000196', NULL, 'Class III chitinase ChiA2', 299, NULL, NULL, 100458),
(100459, '3.40.50.2020-FF-000074', NULL, 'Ribose-phosphate pyrophosphokinase', 135, NULL, NULL, 100459),
(100460, '3.90.950.10-FF-000001', NULL, 'dITP/XTP pyrophosphatase', 196, NULL, NULL, 100460),
(100461, '2.10.80.10-FF-000024', NULL, 'Prokineticin 1-like protein', 24, NULL, NULL, 100461),
(100462, '3.30.70.1230-FF-000255', NULL, 'Uncharacterized protein', 185, NULL, NULL, 100462),
(100463, '3.30.160.60-FF-003217', NULL, 'Zinc finger protein unc-98', 63, NULL, NULL, 100463),
(100464, '1.20.1590.10-FF-000001', NULL, 'DUF416 family protein', 193, NULL, NULL, 100464),
(100465, '1.10.150.190-FF-000011', NULL, NULL, 79, NULL, NULL, 100465),
(100466, '2.60.120.780-FF-000018', NULL, 'Uncharacterized protein', 110, NULL, NULL, 100466),
(100467, '1.20.1070.10-FF-001035', NULL, 'Putative olfactory receptor', 213, NULL, NULL, 100467),
(100468, '2.40.10.10-FF-000496', NULL, NULL, 117, NULL, NULL, 100468),
(100469, '2.40.70.10-FF-000163', NULL, 'cDNA FLJ60006, highly similar to Pepsin A', 11, NULL, NULL, 100469),
(100470, '3.30.70.120-FF-000051', NULL, NULL, 54, NULL, NULL, 100470),
(100471, '2.60.40.150-FF-000039', NULL, 'Synaptotagmin 11', 146, NULL, NULL, 100471),
(100472, '2.60.40.10-FF-005477', NULL, NULL, 101, NULL, NULL, 100472),
(100473, '3.30.460.10-FF-000168', NULL, 'Protein CBG04590', 114, NULL, NULL, 100473),
(100474, '1.10.1320.10-FF-000006', NULL, 'DNA-directed RNA polymerase', 309, NULL, NULL, 100474),
(100475, '3.90.79.10-FF-000088', NULL, 'Mitochondrial ribosomal protein L17', 125, NULL, NULL, 100475),
(100476, '1.10.506.10-FF-000023', NULL, 'Neurofibromin isoform 1', 193, NULL, NULL, 100476),
(100477, '2.60.40.10-FF-006096', NULL, NULL, 81, NULL, NULL, 100477),
(100478, '3.55.50.30-FF-000002', NULL, 'Probable TonB-dependent receptor', 101, NULL, NULL, 100478),
(100479, '3.40.50.300-FF-001009', NULL, 'RING finger protein 112', 283, NULL, NULL, 100479),
(100480, '2.70.150.10-FF-000105', NULL, 'Phospholipid-transporting ATPase', 62, NULL, NULL, 100480),
(100481, '1.25.40.10-FF-002351', NULL, 'Uncharacterized protein', 127, NULL, NULL, 100481),
(100482, '2.60.120.200-FF-000322', NULL, 'Binding protein', 193, NULL, NULL, 100482),
(100483, '3.30.230.70-FF-000011', NULL, 'exosome complex component RRP43', 276, NULL, NULL, 100483),
(100484, '1.20.140.10-FF-000047', NULL, 'Putative acyl-CoA dehydrogenase', 144, NULL, NULL, 100484),
(100485, '3.40.50.300-FF-005876', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 172, NULL, NULL, 100485),
(100486, '1.20.5.350-FF-000029', NULL, NULL, 102, NULL, NULL, 100486),
(100487, '2.60.40.770-FF-000017', NULL, 'Putative phosphatidylglycerol/phosphatidylinositol transfer protein DDB_G0282179', 124, NULL, NULL, 100487),
(100488, '2.60.40.10-FF-005168', NULL, NULL, 94, NULL, NULL, 100488),
(100489, '3.40.50.300-FF-003061', NULL, 'Small GTP-binding protein domain containing protein', 218, NULL, NULL, 100489),
(100490, '2.130.10.10-FF-002728', NULL, 'Uncharacterized protein', 300, NULL, NULL, 100490),
(100491, '2.40.10.10-FF-000608', NULL, NULL, 117, NULL, NULL, 100491),
(100492, '3.30.360.10-FF-000048', NULL, 'GAL80p Transcriptional regulator', 225, NULL, NULL, 100492),
(100493, '3.40.1440.10-FF-000006', NULL, 'Structure-specific endonuclease subunit SLX1', 107, NULL, NULL, 100493),
(100494, '3.30.160.60-FF-002964', NULL, 'PEG3 isoform 3', 41, NULL, NULL, 100494),
(100495, '3.30.160.60-FF-003583', NULL, NULL, 27, NULL, NULL, 100495),
(100496, '3.30.160.60-FF-000446', NULL, 'Zinc finger protein', 29, NULL, NULL, 100496);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(100497, '3.40.50.10480-FF-000008', NULL, 'U3 small nuclear ribonucleoprotein (SnRNP),putative', 172, NULL, NULL, 100497),
(100498, '1.20.1070.10-FF-001743', NULL, 'Peropsin, putative', 85, NULL, NULL, 100498),
(100499, '3.30.40.10-FF-001176', NULL, 'RING finger protein 121', 72, NULL, NULL, 100499),
(100500, '1.20.140.100-FF-000025', NULL, 'Dynein beta chain, putative', 166, NULL, NULL, 100500),
(100501, '3.30.710.10-FF-000502', NULL, 'Uncharacterized protein', 74, NULL, NULL, 100501),
(100502, '3.30.420.510-FF-000028', NULL, 'Pantothenate kinase 4', 111, NULL, NULL, 100502),
(100503, '3.80.10.10-FF-002307', NULL, 'Uncharacterized protein', 314, NULL, NULL, 100503),
(100504, '3.40.50.1000-FF-000234', NULL, 'Haloacid dehalogenase-like hydrolase', 143, NULL, NULL, 100504),
(100505, '3.30.70.890-FF-000023', NULL, 'Phosphomevalonate kinase', 138, NULL, NULL, 100505),
(100506, '2.30.40.10-FF-000077', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 21, NULL, NULL, 100506),
(100507, '2.60.40.10-FF-000609', NULL, 'Tenascin R', 93, NULL, NULL, 100507),
(100508, '2.30.30.40-FF-000355', NULL, 'Unplaced genomic scaffold supercont2.1, whole genome shotgun sequence', 59, NULL, NULL, 100508),
(100509, '3.10.20.90-FF-000811', NULL, 'Ubiquitin-like protein 7', 72, NULL, NULL, 100509),
(100510, '2.120.10.80-FF-000058', NULL, 'Kelch protein K13', 299, NULL, NULL, 100510),
(100511, '1.10.530.10-FF-000028', NULL, 'Lytic murein transglycosylase', 92, NULL, NULL, 100511),
(100512, '3.40.33.10-FF-000097', NULL, 'Copper expressed protein 15', 150, NULL, NULL, 100512),
(100513, '1.10.10.10-FF-001062', NULL, 'Cullin family protein', 89, NULL, NULL, 100513),
(100514, '4.10.240.10-FF-000197', NULL, 'Putative transcription factor with C2H2 and Zn(2)-Cys(6) DNA binding domain (Eurofung)', 53, NULL, NULL, 100514),
(100515, '3.40.50.10890-FF-000013', NULL, 'Subunit of mRNA cleavage and polyadenylation specificity factor', 185, NULL, NULL, 100515),
(100516, '1.10.20.10-FF-000371', NULL, NULL, 66, NULL, NULL, 100516),
(100517, '1.25.10.10-FF-001034', NULL, 'Related to BLM10-proteasome activator subunit', 165, NULL, NULL, 100517),
(100518, '3.40.50.1000-FF-000448', NULL, 'AGL041Cp', 129, NULL, NULL, 100518),
(100519, '1.10.3520.10-FF-000033', NULL, 'Ceramide-1-phosphate transfer protein', 117, NULL, NULL, 100519),
(100520, '2.60.40.10-FF-002043', NULL, 'Muscle M-line assembly protein unc-89', 100, NULL, NULL, 100520),
(100521, '2.10.25.10-FF-000200', NULL, 'netrin-4 isoform X1', 52, NULL, NULL, 100521),
(100522, '3.20.20.140-FF-000178', NULL, 'WGS project CABT00000000 data, contig 2.98', 309, NULL, NULL, 100522),
(100523, '3.40.50.620-FF-000402', NULL, '7-cyano-7-deazaguanine synthase', 231, NULL, NULL, 100523),
(100524, '3.30.70.330-FF-002233', NULL, NULL, 163, NULL, NULL, 100524),
(100525, '3.20.20.70-FF-000659', NULL, NULL, 229, NULL, NULL, 100525),
(100526, '3.30.70.330-FF-003059', NULL, NULL, 106, NULL, NULL, 100526),
(100527, '1.10.260.170-FF-000002', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', 166, NULL, NULL, 100527),
(100528, '1.25.40.10-FF-004408', NULL, 'Uncharacterized protein', 134, NULL, NULL, 100528),
(100529, '1.10.238.10-FF-000012', NULL, 'Signal transducer and activator of transcription', 122, NULL, NULL, 100529),
(100530, '3.30.70.330-FF-000333', NULL, 'Nucleolin', 79, NULL, NULL, 100530),
(100531, '2.60.40.10-FF-005729', NULL, NULL, 114, NULL, NULL, 100531),
(100532, '3.40.50.10810-FF-000254', NULL, 'Uncharacterized protein', 88, NULL, NULL, 100532),
(100533, '3.30.160.60-FF-005117', NULL, NULL, 37, NULL, NULL, 100533),
(100534, '2.60.40.10-FF-004504', NULL, NULL, 105, NULL, NULL, 100534),
(100535, '4.10.400.10-FF-000199', NULL, 'Terribly reduced optic lobes, isoform AU', 39, NULL, NULL, 100535),
(100536, '2.30.29.30-FF-000017', NULL, 'FACT complex subunit SPT16', 132, NULL, NULL, 100536),
(100537, '2.60.120.10-FF-000538', NULL, 'cGMP-dependent protein kinase 7-1', 111, NULL, NULL, 100537),
(100538, '1.10.510.10-FF-003708', NULL, NULL, 162, NULL, NULL, 100538),
(100539, '3.40.50.11660-FF-000020', NULL, 'Uncharacterized protein', 227, NULL, NULL, 100539);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(100540, '3.40.50.300-FF-007113', NULL, 'Rho-related protein racI', 185, NULL, NULL, 100540),
(100541, '3.30.1490.40-FF-000021', NULL, NULL, 78, NULL, NULL, 100541),
(100542, '2.40.160.110-FF-000044', NULL, 'Uncharacterized protein', 149, NULL, NULL, 100542),
(100543, '1.10.238.10-FF-000321', NULL, 'Solute carrier family 25 member 12', 79, NULL, NULL, 100543),
(100544, '3.30.500.10-FF-000037', NULL, NULL, 94, NULL, NULL, 100544),
(100545, '2.40.50.140-FF-000083', NULL, 'Holliday junction ATP-dependent DNA helicase RuvA', 64, NULL, NULL, 100545),
(100546, '3.40.50.620-FF-000711', NULL, 'Probable tRNA(Ile)-lysidine synthase', 221, NULL, NULL, 100546),
(100547, '3.40.50.970-FF-000024', NULL, 'Pyruvate decarboxylase isozyme', 199, NULL, NULL, 100547),
(100548, '2.130.10.10-FF-004628', NULL, 'Uncharacterized protein', 197, NULL, NULL, 100548),
(100549, '2.130.10.10-FF-000666', NULL, 'WD repeat-containing protein 37 isoform X2', 129, NULL, NULL, 100549),
(100550, '3.90.1640.10-FF-000033', NULL, 'Predicted protein', 194, NULL, NULL, 100550),
(100551, '3.30.160.60-FF-002700', NULL, 'zinc finger protein 407', 65, NULL, NULL, 100551),
(100552, '3.60.10.10-FF-000116', NULL, 'Endonuclease-exonuclease-phosphatase family', 255, NULL, NULL, 100552),
(100553, '3.40.50.720-FF-001618', NULL, '(+)-neomenthol dehydrogenase', 92, NULL, NULL, 100553),
(100554, '1.10.472.10-FF-000016', NULL, 'cyclin-L1 isoform X1', 142, NULL, NULL, 100554),
(100555, '3.40.50.1010-FF-000086', NULL, 'YKR096W-like protein', 163, NULL, NULL, 100555),
(100556, '3.40.350.10-FF-000011', NULL, 'Aminopeptidase P family protein', 135, NULL, NULL, 100556),
(100557, '3.40.50.300-FF-000380', NULL, 'Guanine nucleotide-binding protein G(Olf) subunit alpha', 211, NULL, NULL, 100557),
(100558, '1.10.10.60-FF-000655', NULL, 'Myb family DNA-binding domain containing protein', 47, NULL, NULL, 100558),
(100559, '3.40.47.10-FF-000140', NULL, 'Acetyl-CoA acetyltransferase', 378, NULL, NULL, 100559),
(100560, '3.30.1060.10-FF-000002', NULL, 'Peptide methionine sulfoxide reductase', 178, NULL, NULL, 100560),
(100561, '3.30.300.130-FF-000045', NULL, NULL, 86, NULL, NULL, 100561),
(100562, '2.10.109.10-FF-000001', NULL, 'LexA repressor', 124, NULL, NULL, 100562),
(100563, '2.130.10.10-FF-005926', NULL, 'Apaf-1 related killer DARK', 270, NULL, NULL, 100563),
(100564, '3.10.450.40-FF-000006', NULL, 'Putative baseplate wedge subunit', 131, NULL, NULL, 100564),
(100565, '1.20.1250.10-FF-000060', NULL, 'Uncharacterized protein', 164, NULL, NULL, 100565),
(100566, '1.50.10.10-FF-000228', NULL, 'alpha-1,2-Mannosidase', 203, NULL, NULL, 100566),
(100567, '2.60.40.10-FF-002150', NULL, 'Protein tyrosine kinase 7a', 99, NULL, NULL, 100567),
(100568, '3.40.50.2300-FF-000383', NULL, 'Sensor histidine kinase', 125, NULL, NULL, 100568),
(100569, '3.30.1490.190-FF-000001', NULL, 'Ferric uptake regulation protein', 56, NULL, NULL, 100569),
(100570, '1.10.287.110-FF-000392', NULL, 'Uncharacterized protein', 67, NULL, NULL, 100570),
(100571, '2.130.10.10-FF-001655', NULL, 'Vacuolar protein sorting-associated protein 11 homolog', 283, NULL, NULL, 100571),
(100572, '3.30.420.40-FF-000427', NULL, 'Chaperone protein HscA homolog', 177, NULL, NULL, 100572),
(100573, '2.40.110.10-FF-000008', NULL, 'Glutaryl-CoA dehydrogenase, mitochondrial', 107, NULL, NULL, 100573),
(100574, '3.60.21.10-FF-000405', NULL, 'Predicted protein', 302, NULL, NULL, 100574),
(100575, '1.10.510.10-FF-002635', NULL, 'Protein kinase', 333, NULL, NULL, 100575),
(100576, '1.10.730.10-FF-000229', NULL, 'Uncharacterized protein', 172, NULL, NULL, 100576),
(100577, '3.30.160.60-FF-005342', NULL, NULL, 28, NULL, NULL, 100577),
(100578, '4.10.60.10-FF-000001', NULL, 'Gag polyprotein', 43, NULL, NULL, 100578),
(100579, '2.40.30.70-FF-000009', NULL, 'Uncharacterized protein', 132, NULL, NULL, 100579),
(100580, '1.20.1070.10-FF-001962', NULL, 'Retinal G protein coupled receptor', 189, NULL, NULL, 100580),
(100581, '3.80.10.10-FF-004331', NULL, 'NLR family CARD domain containing 5', 196, NULL, NULL, 100581),
(100582, '2.40.50.40-FF-000013', NULL, 'Two-component system response regulator', 70, NULL, NULL, 100582);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(100583, '1.20.1260.80-FF-000002', NULL, 'Haptoglobin-hemoglobin receptor', 265, NULL, NULL, 100583),
(100584, '1.10.3500.10-FF-000043', NULL, 'Predicted protein', 47, NULL, NULL, 100584),
(100585, '3.30.70.270-FF-000146', NULL, NULL, 95, NULL, NULL, 100585),
(100586, '1.10.287.70-FF-000744', NULL, 'Predicted protein', 96, NULL, NULL, 100586),
(100587, '3.40.50.2000-FF-000411', NULL, 'UDP-glucuronosyltransferase', 151, NULL, NULL, 100587),
(100588, '1.25.40.20-FF-001410', NULL, 'Uncharacterized protein', 88, NULL, NULL, 100588),
(100589, '2.20.25.30-FF-000014', NULL, 'Uncharacterized protein', 73, NULL, NULL, 100589),
(100590, '2.10.25.10-FF-001408', NULL, 'Delta-like protein', 40, NULL, NULL, 100590),
(100591, '3.40.50.300-FF-004123', NULL, 'ATP-binding cassette protein subfamily C, member 8', 316, NULL, NULL, 100591),
(100592, '3.30.160.40-FF-000019', NULL, 'Uncharacterized protein', 82, NULL, NULL, 100592),
(100593, '1.10.287.950-FF-000042', NULL, 'rRNA (Adenosine-2''-O-)-methyltransferase,putative', 161, NULL, NULL, 100593),
(100594, '3.30.160.60-FF-002594', NULL, 'Uncharacterized protein', 28, NULL, NULL, 100594),
(100595, '3.80.10.10-FF-001734', NULL, 'Uncharacterized protein', 138, NULL, NULL, 100595),
(100596, '1.25.40.10-FF-000934', NULL, 'Pentatricopeptide repeat-containing protein', 100, NULL, NULL, 100596),
(100597, '3.40.50.300-FF-004651', NULL, 'ATP-dependent rRNA helicase SPB4', 178, NULL, NULL, 100597),
(100598, '2.110.10.10-FF-000037', NULL, 'Protein CBG05638', 193, NULL, NULL, 100598),
(100599, '1.20.120.850-FF-000038', NULL, 'YALI0E24431p', 79, NULL, NULL, 100599),
(100600, '1.20.120.350-FF-000130', NULL, 'Uncharacterized protein', 67, NULL, NULL, 100600),
(100601, '1.25.40.10-FF-001446', NULL, 'Tetratricopeptide repeat protein 30 homolog', 179, NULL, NULL, 100601),
(100602, '1.10.20.10-FF-000085', NULL, 'Histone H3.2', 99, NULL, NULL, 100602),
(100603, '2.130.10.10-FF-004252', NULL, 'Predicted protein', 138, NULL, NULL, 100603),
(100604, '1.10.287.130-FF-000015', NULL, 'Histidine kinase 4', 92, NULL, NULL, 100604),
(100605, '1.20.59.20-FF-000002', NULL, 'tRNA(Ile)-lysidine synthase', 72, NULL, NULL, 100605),
(100606, '3.30.70.2240-FF-000002', NULL, 'krev interaction trapped protein 1', 49, NULL, NULL, 100606),
(100607, '2.60.40.10-FF-001531', NULL, 'Fc fragment of IgA and IgM receptor', 118, NULL, NULL, 100607),
(100608, '1.20.140.150-FF-000023', NULL, 'Epithelial membrane protein 2', 166, NULL, NULL, 100608),
(100609, '1.10.287.3440-FF-000003', NULL, 'Biosynthetic arginine decarboxylase', 56, NULL, NULL, 100609),
(100610, '1.10.225.10-FF-000033', NULL, 'Uncharacterized protein', 93, NULL, NULL, 100610),
(100611, '3.40.50.12650-FF-000007', NULL, 'DNA cross-link repair 1A protein, variant', 167, NULL, NULL, 100611),
(100612, '3.30.160.20-FF-000013', NULL, 'double-stranded RNA-binding protein Staufen homolog 2 isoform X3', 95, NULL, NULL, 100612),
(100613, '4.10.280.10-FF-000183', NULL, 'Transcription factor protein', 65, NULL, NULL, 100613),
(100614, '1.25.40.20-FF-000454', NULL, 'ankyrin repeat and KH domain-containing protein 1 isoform X7', 103, NULL, NULL, 100614),
(100615, '1.25.40.10-FF-002065', NULL, 'Tetratricopeptide repeat protein 21B', 395, NULL, NULL, 100615),
(100616, '1.20.1250.20-FF-001693', NULL, 'Uncharacterized protein', 103, NULL, NULL, 100616),
(100617, '1.10.10.720-FF-000006', NULL, 'Predicted protein', 70, NULL, NULL, 100617),
(100618, '2.60.40.10-FF-005269', NULL, NULL, 86, NULL, NULL, 100618),
(100619, '3.30.420.40-FF-000270', NULL, 'Cell division protein FtsA', 159, NULL, NULL, 100619),
(100620, '2.60.40.60-FF-000607', NULL, 'Si:dkey-1m11.5', 37, NULL, NULL, 100620),
(100621, '3.30.160.60-FF-006337', NULL, NULL, 79, NULL, NULL, 100621),
(100622, '3.90.199.10-FF-000018', NULL, NULL, 89, NULL, NULL, 100622),
(100623, '3.90.226.10-FF-000200', NULL, 'Enoyl-CoA hydratase', 354, NULL, NULL, 100623),
(100624, '3.40.50.720-FF-000623', NULL, 'Ubiquitin activating enzyme (E1) subunit Aos1, putative', 337, NULL, NULL, 100624),
(100625, '3.40.1110.10-FF-000049', NULL, 'Copper-exporting P-type ATPase', 74, NULL, NULL, 100625);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(100626, '2.130.10.10-FF-004409', NULL, 'Uncharacterized protein', 371, NULL, NULL, 100626),
(100627, '3.30.70.330-FF-002103', NULL, NULL, 119, NULL, NULL, 100627),
(100628, '2.30.29.30-FF-001006', NULL, 'Phosphoinositide phospholipase C', 124, NULL, NULL, 100628),
(100629, '3.10.350.10-FF-000046', NULL, 'Chitin elicitor-binding protein', 64, NULL, NULL, 100629),
(100630, '2.170.130.10-FF-000018', NULL, 'TonB-dependent siderophore receptor', 123, NULL, NULL, 100630),
(100631, '1.25.40.20-FF-001775', NULL, 'Poly [ADP-ribose] polymerase tankyrase', 187, NULL, NULL, 100631),
(100632, '3.30.565.10-FF-000080', NULL, 'Molecular chaperone HtpG', 204, NULL, NULL, 100632),
(100633, '3.90.1150.10-FF-000158', NULL, 'Phosphoserine aminotransferase', 115, NULL, NULL, 100633),
(100634, '3.40.190.10-FF-000403', NULL, 'Putative ABC transporter (Substrate binding protein)', 125, NULL, NULL, 100634),
(100635, '6.10.20.180-FF-000001', NULL, 'Import receptor subunit tom20, putative', 79, NULL, NULL, 100635),
(100636, '2.40.170.20-FF-000032', NULL, 'SusC/RagA family TonB-linked outer membrane protein', 536, NULL, NULL, 100636),
(100637, '3.30.9.90-FF-000003', NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase', 203, NULL, NULL, 100637),
(100638, '2.120.10.30-FF-000184', NULL, 'Alanyl dipeptidyl peptidase', 256, NULL, NULL, 100638),
(100639, '3.30.1330.30-FF-000080', NULL, 'Putative rRNA methyltransferase', 99, NULL, NULL, 100639),
(100640, '1.25.40.10-FF-004043', NULL, 'Uncharacterized protein', 176, NULL, NULL, 100640),
(100641, '3.30.519.10-FF-000041', NULL, NULL, 112, NULL, NULL, 100641),
(100642, '1.25.40.20-FF-001882', NULL, 'Kinase, NEK', 122, NULL, NULL, 100642),
(100643, '1.10.760.10-FF-000057', NULL, 'Nicotinate dehydrogenase subunit B', 153, NULL, NULL, 100643),
(100644, '3.30.810.10-FF-000010', NULL, 'Phosphatidylinositol 5-phosphate 4-kinase, isoform A', 206, NULL, NULL, 100644),
(100645, '3.30.160.60-FF-000710', NULL, 'Zinc finger protein 768', 29, NULL, NULL, 100645),
(100646, '3.30.572.10-FF-000017', NULL, 'GM18183', 302, NULL, NULL, 100646),
(100647, '3.30.559.30-FF-000043', NULL, 'Nonribosomal peptide synthase, putative', 234, NULL, NULL, 100647),
(100648, '2.60.40.10-FF-003931', NULL, NULL, 106, NULL, NULL, 100648),
(100649, '1.20.1280.50-FF-000096', NULL, 'F-box domain protein', 100, NULL, NULL, 100649),
(100650, '3.50.50.60-FF-000443', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 59, NULL, NULL, 100650),
(100651, '3.30.40.10-FF-000215', NULL, 'E3 ubiquitin-protein ligase RNF25', 92, NULL, NULL, 100651),
(100652, '1.25.40.10-FF-001070', NULL, 'Pentatricopeptide repeat-containing protein At1g11630, mitochondrial', 159, NULL, NULL, 100652),
(100653, '1.10.150.20-FF-000250', NULL, 'DNA polymerase IV', 64, NULL, NULL, 100653),
(100654, '1.25.40.570-FF-000058', NULL, 'Uncharacterized protein', 309, NULL, NULL, 100654),
(100655, '3.90.660.20-FF-000009', NULL, 'Amine oxidase, variant 2', 105, NULL, NULL, 100655),
(100656, '2.60.120.650-FF-000210', NULL, 'Uncharacterized protein', 74, NULL, NULL, 100656),
(100657, '3.30.40.10-FF-001199', NULL, 'Ring finger domain containing protein', 99, NULL, NULL, 100657),
(100658, '3.30.160.60-FF-005718', NULL, NULL, 37, NULL, NULL, 100658),
(100659, '1.10.287.1490-FF-000042', NULL, 'Uncharacterized protein', 191, NULL, NULL, 100659),
(100660, '3.40.50.720-FF-001242', NULL, 'Oxidoreductase, putative', 146, NULL, NULL, 100660),
(100661, '1.10.238.10-FF-000793', NULL, 'Solute carrier family 25 member 24,-like', 72, NULL, NULL, 100661),
(100662, '3.40.50.1100-FF-000129', NULL, 'Cysteate synthase', 100, NULL, NULL, 100662),
(100663, '2.60.40.10-FF-002526', NULL, 'Immunolglobulin kappa light chain variable region L22', 101, NULL, NULL, 100663),
(100664, '3.20.20.120-FF-000037', NULL, 'o-succinylbenzoate synthase', 183, NULL, NULL, 100664),
(100665, '1.25.40.10-FF-000148', NULL, 'Coatomer subunit epsilon', 291, NULL, NULL, 100665),
(100666, '2.120.10.30-FF-000077', NULL, 'SMP-30/gluconolactonase/LRE family protein', 287, NULL, NULL, 100666),
(100667, '2.130.10.10-FF-004145', NULL, 'Predicted protein', 179, NULL, NULL, 100667);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(100668, '2.40.50.100-FF-000082', NULL, 'Exosome complex component Rrp4', 54, NULL, NULL, 100668),
(100669, '3.90.1150.190-FF-000003', NULL, 'Scm polycomb group protein-like 2', 118, NULL, NULL, 100669),
(100670, '3.40.30.10-FF-000776', NULL, 'Polyglutamine-binding protein 1', 146, NULL, NULL, 100670),
(100671, '3.30.420.10-FF-000199', NULL, 'Putative CCR4-associated factor 1 homolog 11', 271, NULL, NULL, 100671),
(100672, '1.20.1250.20-FF-000748', NULL, 'Arabinose-proton symporter', 223, NULL, NULL, 100672),
(100673, '3.40.605.10-FF-000115', NULL, '10-formyltetrahydrofolate dehydrogenase', 100, NULL, NULL, 100673),
(100674, '1.20.1270.60-FF-000183', NULL, 'Sorting nexin, putative', 215, NULL, NULL, 100674),
(100675, '3.60.120.10-FF-000012', NULL, 'Menaquinone-specific isochorismate synthase', 462, NULL, NULL, 100675),
(100676, '1.10.10.10-FF-001629', NULL, 'Spleen focus forming virus (SFFV) proviral integration oncogene spi1 like', 96, NULL, NULL, 100676),
(100677, '3.30.420.40-FF-000534', NULL, 'Actin, epsilon 1', 121, NULL, NULL, 100677),
(100678, '3.40.718.10-FF-000023', NULL, 'Isocitrate dehydrogenase [NADP]', 412, NULL, NULL, 100678),
(100679, '3.40.50.300-FF-002673', NULL, 'Multispecific organic anion transporter, putative', 275, NULL, NULL, 100679),
(100680, '3.30.450.30-FF-000033', NULL, 'Uncharacterized protein', 96, NULL, NULL, 100680),
(100681, '3.80.10.10-FF-004224', NULL, 'Uncharacterized protein', 82, NULL, NULL, 100681),
(100682, '3.30.160.60-FF-001975', NULL, 'zinc finger protein 181 isoform X2', 23, NULL, NULL, 100682),
(100683, '1.25.40.840-FF-000015', NULL, 'Uncharacterized protein', 58, NULL, NULL, 100683),
(100684, '1.25.50.20-FF-000056', NULL, 'Aminopeptidase', 169, NULL, NULL, 100684),
(100685, '2.10.25.10-FF-001397', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', 38, NULL, NULL, 100685),
(100686, '1.20.1560.10-FF-000729', NULL, 'ATP-binding cassette transporter, subfamily B, member 10, group ATM protein PpABCB10', 220, NULL, NULL, 100686),
(100687, '2.60.40.10-FF-002835', NULL, 'Type II inositol-1,4,5-trisphosphate 5-phosphatase, putative', 132, NULL, NULL, 100687),
(100688, '2.60.40.4310-FF-000004', NULL, 'Structural polyprotein', 57, NULL, NULL, 100688),
(100689, '3.80.10.10-FF-000964', NULL, 'Nucleotide excision NEF4 component', 107, NULL, NULL, 100689),
(100690, '3.40.50.10830-FF-000001', NULL, 'F420-dependent methylenetetrahydromethanopterin dehydrogenase', 142, NULL, NULL, 100690),
(100691, '3.10.250.10-FF-000117', NULL, NULL, 70, NULL, NULL, 100691),
(100692, '3.40.570.10-FF-000022', NULL, 'GM12732', 221, NULL, NULL, 100692),
(100693, '3.40.50.11980-FF-000014', NULL, 'Cytochrome Oxidase Assembly subunits', 155, NULL, NULL, 100693),
(100694, '3.30.360.10-FF-000121', NULL, 'Uncharacterized protein', 155, NULL, NULL, 100694),
(100695, '3.30.200.20-FF-001473', NULL, 'Uncharacterized protein', 50, NULL, NULL, 100695),
(100696, '1.25.40.20-FF-001303', NULL, 'Uncharacterized protein', 155, NULL, NULL, 100696),
(100697, '1.20.58.60-FF-000489', NULL, 'Microtubule actin crosslinking factor 1a', 237, NULL, NULL, 100697),
(100698, '3.30.565.10-FF-000237', NULL, 'Uncharacterized protein', 162, NULL, NULL, 100698),
(100699, '2.60.220.50-FF-000030', NULL, 'Polycystin 1 like 3, transient receptor potential channel interacting', 71, NULL, NULL, 100699),
(100700, '3.80.10.10-FF-001953', NULL, 'Protein STRUBBELIG-RECEPTOR FAMILY 1', 76, NULL, NULL, 100700),
(100701, '3.40.950.10-FF-000012', NULL, 'Putative iron-dependent hydrogenase', 68, NULL, NULL, 100701),
(100702, '1.20.1090.10-FF-000064', NULL, 'NADH-dependent butanol dehydrogenase a', 197, NULL, NULL, 100702),
(100703, '3.90.190.10-FF-000010', NULL, 'tensin-1 isoform X2', 165, NULL, NULL, 100703),
(100704, '1.10.510.10-FF-003782', NULL, NULL, 132, NULL, NULL, 100704),
(100705, '3.40.50.12470-FF-000021', NULL, NULL, 185, NULL, NULL, 100705),
(100706, '1.20.144.10-FF-000140', NULL, 'Uncharacterized loc100135382', 257, NULL, NULL, 100706),
(100707, '3.40.50.970-FF-000007', NULL, 'Acetolactate synthase', 181, NULL, NULL, 100707);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(100708, '1.10.238.10-FF-000804', NULL, 'Defective in cullin neddylation protein 1', 110, NULL, NULL, 100708),
(100709, '2.60.40.10-FF-003015', NULL, 'Interferon (alpha, beta and omega) receptor 2, gene 1', 194, NULL, NULL, 100709),
(100710, '1.25.40.10-FF-000457', NULL, 'Pentatricopeptide repeat domain-containing protein 3, mitochondrial', 166, NULL, NULL, 100710),
(100711, '3.15.20.10-FF-000002', NULL, 'Cholesteryl ester transfer protein', 261, NULL, NULL, 100711),
(100712, '3.30.420.10-FF-000519', NULL, NULL, 120, NULL, NULL, 100712),
(100713, '2.130.10.10-FF-002274', NULL, 'Translation initiation factor, putative', 265, NULL, NULL, 100713),
(100714, '3.40.50.300-FF-007984', NULL, 'Dynein heavy chain, cytoplasmic', 157, NULL, NULL, 100714),
(100715, '2.60.120.10-FF-000555', NULL, 'Uncharacterized protein', 123, NULL, NULL, 100715),
(100716, '1.25.10.10-FF-000314', NULL, 'Exportin 6', 524, NULL, NULL, 100716),
(100717, '1.20.58.1780-FF-000024', NULL, 'Uncharacterized protein', 188, NULL, NULL, 100717),
(100718, '3.60.15.10-FF-000094', NULL, 'Probable metallo-hydrolase MT2357', 259, NULL, NULL, 100718),
(100719, '2.130.10.10-FF-001874', NULL, 'Two-component system sensor histidine kinase/response', 311, NULL, NULL, 100719),
(100720, '3.40.1370.10-FF-000006', NULL, '50S ribosomal protein L4', 229, NULL, NULL, 100720),
(100721, '1.25.10.10-FF-001725', NULL, 'Sister chromatid cohesion protein', 206, NULL, NULL, 100721),
(100722, '2.40.50.1020-FF-000005', NULL, 'Accessory gene regulator A', 99, NULL, NULL, 100722),
(100723, '3.40.50.10810-FF-000147', NULL, 'RAD54 like', 140, NULL, NULL, 100723),
(100724, '1.10.287.110-FF-000285', NULL, 'Predicted protein', 111, NULL, NULL, 100724),
(100725, '1.20.5.190-FF-000032', NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', 50, NULL, NULL, 100725),
(100726, '3.30.1360.120-FF-000075', NULL, 'Uncharacterized protein', 94, NULL, NULL, 100726),
(100727, '1.20.140.10-FF-000148', NULL, 'Acyl-coenzyme A oxidase', 96, NULL, NULL, 100727),
(100728, '3.40.30.10-FF-000091', NULL, 'Glutathione S-transferase L2, chloroplastic', 104, NULL, NULL, 100728),
(100729, '1.20.1070.10-FF-000181', NULL, 'Thyrotropin receptor', 286, NULL, NULL, 100729),
(100730, '3.40.50.2000-FF-000883', NULL, 'Glycogen synthase ADP-glucose transglucosylase GlgA', 185, NULL, NULL, 100730),
(100731, '2.60.40.640-FF-000080', NULL, 'Beta-arrestin, putative', 128, NULL, NULL, 100731),
(100732, '3.30.1360.70-FF-000014', NULL, 'Arginyl-tRNA synthetase, putative', 109, NULL, NULL, 100732),
(100733, '1.20.58.2220-FF-000066', NULL, 'Erythrocyte membrane-associated giant protein antigen 332 containing protein', 326, NULL, NULL, 100733),
(100734, '3.30.2350.10-FF-000075', NULL, 'Uncharacterized protein', 186, NULL, NULL, 100734),
(100735, '2.30.29.30-FF-001225', NULL, 'Uncharacterized protein', 117, NULL, NULL, 100735),
(100736, '3.40.33.10-FF-000125', NULL, 'Uncharacterized protein', 110, NULL, NULL, 100736),
(100737, '2.60.120.920-FF-000184', NULL, 'Tripartite motif-containing protein 16', 124, NULL, NULL, 100737),
(100738, '3.30.160.60-FF-001290', NULL, 'Zinc finger 45-like', 29, NULL, NULL, 100738),
(100739, '4.10.400.10-FF-000316', NULL, 'glycoprotein 330-like isoform X1', 37, NULL, NULL, 100739),
(100740, '2.60.40.2240-FF-000006', NULL, 'Acyl-CoA thioesterase 20', 139, NULL, NULL, 100740),
(100741, '3.40.50.300-FF-002178', NULL, 'Similar to cation ABC transporter', 221, NULL, NULL, 100741),
(100742, '3.40.50.300-FF-001689', NULL, 'Ras-related protein Rab-11B', 210, NULL, NULL, 100742),
(100743, '1.20.1250.20-FF-000872', NULL, 'Solute carrier family 16, member 9a', 236, NULL, NULL, 100743),
(100744, '3.40.190.10-FF-000931', NULL, 'Dipeptide binding protein', 57, NULL, NULL, 100744),
(100745, '2.60.40.1170-FF-000085', NULL, NULL, 148, NULL, NULL, 100745),
(100746, '3.30.160.60-FF-001183', NULL, 'Zinc finger protein 18', 28, NULL, NULL, 100746),
(100747, '3.30.457.60-FF-000023', NULL, 'Mitotic arrest deficient 1 like 1', 44, NULL, NULL, 100747),
(100748, '2.130.10.30-FF-000099', NULL, 'Uncharacterized protein', 241, NULL, NULL, 100748);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(100749, '3.90.79.10-FF-000296', NULL, 'Adenine DNA glycosylase', 129, NULL, NULL, 100749),
(100750, '3.40.50.1000-FF-000549', NULL, NULL, 193, NULL, NULL, 100750),
(100751, '3.30.200.20-FF-001366', NULL, 'Uncharacterized protein', 165, NULL, NULL, 100751),
(100752, '3.40.50.10800-FF-000003', NULL, 'Quinolinate synthase A', 101, NULL, NULL, 100752),
(100753, '2.130.10.10-FF-000093', NULL, 'DmX-like protein 1', 191, NULL, NULL, 100753),
(100754, '2.170.270.10-FF-000074', NULL, 'PR domain 14', 111, NULL, NULL, 100754),
(100755, '1.10.150.50-FF-000163', NULL, 'Kinase suppressor of ras 1', 49, NULL, NULL, 100755),
(100756, '3.30.420.10-FF-000536', NULL, NULL, 90, NULL, NULL, 100756),
(100757, '1.20.120.1880-FF-000011', NULL, 'Nuclear pore complex protein NUP155', 197, NULL, NULL, 100757),
(100758, '2.60.40.10-FF-000598', NULL, 'Fibronectin type 3 and ankyrin repeat domains protein 1', 95, NULL, NULL, 100758),
(100759, '3.30.505.10-FF-000076', NULL, 'Signal transducing adaptor family member 2', 91, NULL, NULL, 100759),
(100760, '3.40.50.740-FF-000056', NULL, 'Gll2176 protein', 127, NULL, NULL, 100760),
(100761, '1.25.40.20-FF-001758', NULL, 'Predicted protein', 195, NULL, NULL, 100761),
(100762, '3.40.50.300-FF-004578', NULL, 'Stage V sporulation protein K', 195, NULL, NULL, 100762),
(100763, '1.25.10.10-FF-001242', NULL, 'Putative U-box domain-containing protein 47', 297, NULL, NULL, 100763),
(100764, '3.30.450.20-FF-000569', NULL, 'Uncharacterized protein', 58, NULL, NULL, 100764),
(100765, '3.40.50.1980-FF-000123', NULL, 'Iron-siderophore ABC transporter substrate-binding protein', 165, NULL, NULL, 100765),
(100766, '2.60.40.150-FF-000725', NULL, 'Uncharacterized protein C11E3.02c', 116, NULL, NULL, 100766),
(100767, '3.90.1420.10-FF-000027', NULL, 'Uncharacterized protein', 137, NULL, NULL, 100767),
(100768, '1.10.510.10-FF-003124', NULL, NULL, 187, NULL, NULL, 100768),
(100769, '3.90.1150.160-FF-000005', NULL, 'Glutamate decarboxylase', 100, NULL, NULL, 100769),
(100770, '1.25.40.10-FF-002374', NULL, 'Os01g0754700 protein', 95, NULL, NULL, 100770),
(100771, '2.40.10.10-FF-000507', NULL, NULL, 85, NULL, NULL, 100771),
(100772, '3.40.50.720-FF-000207', NULL, 'Glycerate dehydrogenase HPR, peroxisomal', 204, NULL, NULL, 100772),
(100773, '3.40.1110.10-FF-000268', NULL, NULL, 76, NULL, NULL, 100773),
(100774, '3.40.50.720-FF-001927', NULL, 'Uncharacterized protein', 88, NULL, NULL, 100774),
(100775, '1.10.287.70-FF-000749', NULL, 'Calcium-gated potassium channel MthK', 80, NULL, NULL, 100775),
(100776, '3.30.160.60-FF-005797', NULL, NULL, 44, NULL, NULL, 100776),
(100777, '2.60.40.10-FF-001222', NULL, 'Sallimus, isoform P', 100, NULL, NULL, 100777),
(100778, '1.10.10.10-FF-000325', NULL, 'Transcriptional regulator, LysR family', 85, NULL, NULL, 100778),
(100779, '3.30.160.60-FF-001666', NULL, 'MDS1 and EVI1 complex locus', 27, NULL, NULL, 100779),
(100780, '2.70.98.20-FF-000014', NULL, 'Amine oxidase', 182, NULL, NULL, 100780),
(100781, '3.90.76.10-FF-000036', NULL, 'Peptide ABC transporter substrate-binding protein', 112, NULL, NULL, 100781),
(100782, '1.20.1640.10-FF-000090', NULL, 'Predicted protein', 191, NULL, NULL, 100782),
(100783, '4.10.1000.40-FF-000011', NULL, 'Nuclear polyadenylated RNA-binding protein, putative', 67, NULL, NULL, 100783),
(100784, '3.90.70.80-FF-000100', NULL, 'Uncharacterized protein', 76, NULL, NULL, 100784),
(100785, '3.40.50.11210-FF-000014', NULL, 'Ral GTPase-activating protein subunit beta-like Protein', 233, NULL, NULL, 100785),
(100786, '3.30.70.330-FF-001721', NULL, NULL, 97, NULL, NULL, 100786),
(100787, '2.130.10.10-FF-002144', NULL, 'Uncharacterized protein', 90, NULL, NULL, 100787),
(100788, '3.10.110.10-FF-000091', NULL, 'Ubiquitin-conjugating enzyme E2 N', 148, NULL, NULL, 100788),
(100789, '3.10.20.90-FF-000603', NULL, 'Guanine nucleotide exchange factor Cdc24 homologue, putative', 81, NULL, NULL, 100789),
(100790, '3.30.1490.100-FF-000047', NULL, 'DNA polymerase IV', 108, NULL, NULL, 100790),
(100791, '3.40.30.10-FF-000883', NULL, 'Uncharacterized protein', 72, NULL, NULL, 100791);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(100792, '1.10.286.10-FF-000005', NULL, 'GTP cyclohydrolase 1', 51, NULL, NULL, 100792),
(100793, '3.40.47.10-FF-000067', NULL, 'Hydroxyacyl-CoA dehydrogenase trifunctional multienzyme complex subunit beta', 200, NULL, NULL, 100793),
(100794, '3.20.20.80-FF-000752', NULL, 'Uncharacterized protein', 52, NULL, NULL, 100794),
(100795, '1.10.246.140-FF-000015', NULL, 'Transcription/mRNA export factor', 64, NULL, NULL, 100795),
(100796, '2.130.10.10-FF-001402', NULL, 'Enhancer of mRNA-decapping protein', 360, NULL, NULL, 100796),
(100797, '3.40.50.2020-FF-000097', NULL, 'phosphoribosyl pyrophosphate synthase-associated protein 2 isoform X4', 71, NULL, NULL, 100797),
(100798, '3.40.630.30-FF-000634', NULL, 'Ribosomal protein N-acetyltransferase, putative', 176, NULL, NULL, 100798),
(100799, '3.40.640.10-FF-000365', NULL, 'Aminotransferase class I/II-fold pyridoxal phosphate-dependent enzyme', 336, NULL, NULL, 100799),
(100800, '3.30.530.20-FF-000194', NULL, 'Uncharacterized protein', 260, NULL, NULL, 100800),
(100801, '1.20.58.760-FF-000034', NULL, 'paraplegin-like', 192, NULL, NULL, 100801),
(100802, '1.10.510.10-FF-002854', NULL, NULL, 236, NULL, NULL, 100802),
(100803, '2.30.30.380-FF-000068', NULL, 'Uncharacterized protein', 65, NULL, NULL, 100803),
(100804, '3.30.2350.10-FF-000070', NULL, 'RNA pseudouridine synthase 2, chloroplastic isoform A', 233, NULL, NULL, 100804),
(100805, '1.25.10.10-FF-002237', NULL, 'Uncharacterized protein', 382, NULL, NULL, 100805),
(100806, '3.40.50.1100-FF-000124', NULL, '1-aminocyclopropane-1-carboxylate deaminase', 166, NULL, NULL, 100806),
(100807, '2.10.110.10-FF-000162', NULL, 'LD14485p', 58, NULL, NULL, 100807),
(100808, '2.60.40.10-FF-001907', NULL, 'Muscle M-line assembly protein unc-89', 103, NULL, NULL, 100808),
(100809, '1.10.10.10-FF-000820', NULL, 'Transcriptional regulator, LysR family', 89, NULL, NULL, 100809),
(100810, '3.20.20.150-FF-000052', NULL, 'Xylose isomerase domain protein TIM barrel', 245, NULL, NULL, 100810),
(100811, '1.20.58.60-FF-000236', NULL, 'microtubule-actin cross-linking factor 1 isoform X5', 142, NULL, NULL, 100811),
(100812, '2.60.40.10-FF-004313', NULL, NULL, 99, NULL, NULL, 100812),
(100813, '1.10.472.10-FF-000033', NULL, 'retinoblastoma-associated protein isoform X1', 164, NULL, NULL, 100813),
(100814, '3.30.70.330-FF-000232', NULL, 'RNA-binding domain-containing protein', 87, NULL, NULL, 100814),
(100815, '3.90.1640.10-FF-000010', NULL, 'Uncharacterized protein', 85, NULL, NULL, 100815),
(100816, '3.90.190.10-FF-000482', NULL, 'Putative phosphatase', 169, NULL, NULL, 100816),
(100817, '3.30.450.380-FF-000001', NULL, 'Secretion protein', 175, NULL, NULL, 100817),
(100818, '2.40.50.140-FF-000330', NULL, 'Protein OSB2 chloroplastic', 100, NULL, NULL, 100818),
(100819, '3.60.20.10-FF-000061', NULL, 'Heat stress transcription factor A-6b', 154, NULL, NULL, 100819),
(100820, '1.25.40.10-FF-003554', NULL, 'Uncharacterized protein', 67, NULL, NULL, 100820),
(100821, '3.80.10.10-FF-003403', NULL, 'Predicted protein', 92, NULL, NULL, 100821),
(100822, '3.30.420.10-FF-000194', NULL, 'Ribonuclease', 131, NULL, NULL, 100822),
(100823, '3.90.1800.10-FF-000012', NULL, 'DNA-directed RNA polymerase subunit beta', 117, NULL, NULL, 100823),
(100824, '2.30.30.490-FF-000101', NULL, 'Predicted protein', 180, NULL, NULL, 100824),
(100825, '1.25.40.180-FF-000008', NULL, 'Programmed cell death protein 4', 140, NULL, NULL, 100825),
(100826, '2.40.30.10-FF-000273', NULL, 'Putative cytochrome P450 reductase', 97, NULL, NULL, 100826),
(100827, '3.30.1360.10-FF-000042', NULL, 'DNA-directed RNA polymerases I and III 16 kDa polypeptide', 89, NULL, NULL, 100827),
(100828, '3.40.50.300-FF-006832', NULL, 'Sulfotransferase', 269, NULL, NULL, 100828),
(100829, '1.10.630.10-FF-000401', NULL, 'Cytochrome P450', 489, NULL, NULL, 100829),
(100830, '3.40.50.1820-FF-000014', NULL, 'lysosomal Pro-X carboxypeptidase', 282, NULL, NULL, 100830),
(100831, '1.20.1270.60-FF-000188', NULL, 'Uncharacterized protein', 260, NULL, NULL, 100831),
(100832, '3.30.420.40-FF-000843', NULL, 'Actin-related protein 3', 80, NULL, NULL, 100832);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(100833, '1.10.357.150-FF-000010', NULL, 'YALI0A07689p', 192, NULL, NULL, 100833),
(100834, '1.25.10.10-FF-002546', NULL, 'Condensin, putative', 179, NULL, NULL, 100834),
(100835, '1.20.1070.10-FF-001934', NULL, 'Uncharacterized protein', 257, NULL, NULL, 100835),
(100836, '1.20.120.850-FF-000055', NULL, 'Uncharacterized protein', 26, NULL, NULL, 100836),
(100837, '2.60.40.10-FF-000042', NULL, 'Filamin-B isoform B', 95, NULL, NULL, 100837),
(100838, '3.40.50.1240-FF-000177', NULL, NULL, 192, NULL, NULL, 100838),
(100839, '3.40.605.10-FF-000087', NULL, 'Os07g0689150 protein', 141, NULL, NULL, 100839),
(100840, '1.10.287.70-FF-000188', NULL, 'SLOwpoke potassium channel family', 119, NULL, NULL, 100840),
(100841, '3.90.70.80-FF-000061', NULL, 'AaceriABR233Wp', 176, NULL, NULL, 100841),
(100842, '3.40.50.1360-FF-000067', NULL, 'Predicted protein', 246, NULL, NULL, 100842),
(100843, '2.60.40.10-FF-000570', NULL, 'Lipolysis stimulated lipoprotein receptor', 125, NULL, NULL, 100843),
(100844, '3.40.630.30-FF-000415', NULL, 'N-acetyltransferase, GNAT family', 196, NULL, NULL, 100844),
(100845, '3.30.420.40-FF-000051', NULL, 'N-acetyl-D-glucosamine kinase', 173, NULL, NULL, 100845),
(100846, '2.10.90.10-FF-000070', NULL, 'CRE-UNC-129 protein', 102, NULL, NULL, 100846),
(100847, '1.25.40.440-FF-000002', NULL, 'Nuclear pore complex protein NUP155', 97, NULL, NULL, 100847),
(100848, '3.80.10.10-FF-002881', NULL, 'Uncharacterized protein', 98, NULL, NULL, 100848),
(100849, '1.25.10.10-FF-002422', NULL, 'Uncharacterized protein', 248, NULL, NULL, 100849),
(100850, '3.10.100.10-FF-000022', NULL, 'Mannose receptor C-type 1', 139, NULL, NULL, 100850),
(100851, '4.10.1000.10-FF-000098', NULL, 'Uncharacterized protein', 37, NULL, NULL, 100851),
(100852, '3.30.70.330-FF-002210', NULL, NULL, 104, NULL, NULL, 100852),
(100853, '3.30.70.330-FF-000788', NULL, 'Rbp1-like, isoform B', 112, NULL, NULL, 100853),
(100854, '1.50.40.10-FF-000409', NULL, 'Uncharacterized protein', 225, NULL, NULL, 100854),
(100855, '1.10.10.60-FF-000683', NULL, 'Muscle wasted, isoform D', 65, NULL, NULL, 100855),
(100856, '1.20.120.1750-FF-000107', NULL, 'RBR-type E3 ubiquitin transferase', 116, NULL, NULL, 100856),
(100857, '1.25.10.10-FF-002198', NULL, 'Uncharacterized protein', 441, NULL, NULL, 100857),
(100858, '2.160.20.80-FF-000028', NULL, NULL, 86, NULL, NULL, 100858),
(100859, '3.60.21.10-FF-000035', NULL, 'Lariat debranching enzyme', 243, NULL, NULL, 100859),
(100860, '3.20.20.70-FF-000732', NULL, NULL, 91, NULL, NULL, 100860),
(100861, '3.20.20.70-FF-000423', NULL, 'NADH:quinone reductase', 328, NULL, NULL, 100861),
(100862, '3.80.10.10-FF-003370', NULL, 'Predicted protein', 362, NULL, NULL, 100862),
(100863, '2.60.200.10-FF-000051', NULL, 'Interferon regulatory factor 6', 143, NULL, NULL, 100863),
(100864, '1.20.90.10-FF-000015', NULL, 'Phospholipase A(2)', 133, NULL, NULL, 100864),
(100865, '1.10.510.10-FF-001674', NULL, 'Guanylate cyclase', 111, NULL, NULL, 100865),
(100866, '3.30.60.30-FF-000003', NULL, 'SPARC/osteonectin, cwcv and kazal-like domains proteoglycan 3', 96, NULL, NULL, 100866),
(100867, '2.40.10.10-FF-000260', NULL, 'GM14069', 99, NULL, NULL, 100867),
(100868, '3.40.850.10-FF-000050', NULL, 'Kinesin-like protein', 370, NULL, NULL, 100868),
(100869, '1.25.10.10-FF-001798', NULL, 'AGC family protein kinase', 229, NULL, NULL, 100869),
(100870, '3.80.10.10-FF-003712', NULL, 'Uncharacterized protein', 279, NULL, NULL, 100870),
(100871, '2.30.30.60-FF-000001', NULL, 'MscS Mechanosensitive ion channel', 50, NULL, NULL, 100871),
(100872, '3.30.420.150-FF-000016', NULL, 'Probable apyrase 7', 267, NULL, NULL, 100872),
(100873, '3.40.50.300-FF-006040', NULL, 'Ras-related protein RABA1d', 163, NULL, NULL, 100873),
(100874, '3.30.470.20-FF-000132', NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', 102, NULL, NULL, 100874),
(100875, '3.30.450.40-FF-000255', NULL, 'Sensor histidine kinase, GAF domain-containing', 157, NULL, NULL, 100875),
(100876, '2.170.270.10-FF-000158', NULL, 'PR domain containing 15', 143, NULL, NULL, 100876);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(100877, '1.20.1250.20-FF-000400', NULL, 'Blast:Monocarboxylate transporter 12', 189, NULL, NULL, 100877),
(100878, '3.40.50.300-FF-002780', NULL, 'DEAD box ATP-dependent RNA helicase', 254, NULL, NULL, 100878),
(100879, '3.40.50.150-FF-000227', NULL, 'tRNA (adenine(58)-N(1))-methyltransferase', 232, NULL, NULL, 100879),
(100880, '3.40.50.80-FF-000051', NULL, 'Ferredoxin--NADP reductase, apicoplast', 159, NULL, NULL, 100880),
(100881, '2.30.42.10-FF-000222', NULL, 'Golgi re-assembly stacking protein 1', 111, NULL, NULL, 100881),
(100882, '1.10.150.240-FF-000077', NULL, 'HAD family hydrolase', 61, NULL, NULL, 100882),
(100883, '3.20.20.70-FF-000384', NULL, 'Multifunctional fusion protein', 190, NULL, NULL, 100883),
(100884, '2.70.170.10-FF-000112', NULL, 'Uncharacterized protein', 159, NULL, NULL, 100884),
(100885, '2.60.120.10-FF-000078', NULL, 'Cyclic nucleotide-gated channel', 144, NULL, NULL, 100885),
(100886, '3.30.310.280-FF-000002', NULL, 'Siderophore biosynthesis protein', 134, NULL, NULL, 100886),
(100887, '3.30.450.20-FF-000676', NULL, 'Nuclear receptor coactivator 3', 77, NULL, NULL, 100887),
(100888, '2.60.40.10-FF-000603', NULL, 'Fibronectin type III domain containing 3B', 99, NULL, NULL, 100888),
(100889, '3.40.710.10-FF-000101', NULL, 'Penicillin-binding protein 1A', 86, NULL, NULL, 100889),
(100890, '3.60.21.10-FF-000400', NULL, 'Ser/Thr protein phosphatase, putative', 314, NULL, NULL, 100890),
(100891, '1.20.1070.10-FF-000973', NULL, 'Uncharacterized protein', 330, NULL, NULL, 100891),
(100892, '2.60.120.290-FF-000068', NULL, 'Metalloendopeptidase', 115, NULL, NULL, 100892),
(100893, '3.40.50.2000-FF-000091', NULL, 'Glycosyltransferase', 176, NULL, NULL, 100893),
(100894, '3.30.160.20-FF-000249', NULL, 'Uncharacterized protein', 91, NULL, NULL, 100894),
(100895, '1.50.40.10-FF-000180', NULL, 'Mitochondrial carrier protein, putative', 286, NULL, NULL, 100895),
(100896, '3.90.170.10-FF-000008', NULL, 'Adenylosuccinate synthetase', 164, NULL, NULL, 100896),
(100897, '3.40.50.300-FF-004095', NULL, 'Dynein beta chain, flagellar outer arm', 184, NULL, NULL, 100897),
(100898, '2.60.40.10-FF-004095', NULL, NULL, 94, NULL, NULL, 100898),
(100899, '1.10.150.20-FF-000255', NULL, 'DNA polymerase IV', 70, NULL, NULL, 100899),
(100900, '2.60.120.260-FF-000525', NULL, 'Predicted protein', 80, NULL, NULL, 100900),
(100901, '3.40.50.720-FF-001135', NULL, 'NADP-dependent alcohol dehydrogenase C', 138, NULL, NULL, 100901),
(100902, '2.120.10.80-FF-000428', NULL, 'Serine/threonine-protein phosphatase BSL1', 132, NULL, NULL, 100902),
(100903, '2.130.10.10-FF-000694', NULL, 'Apoptotic protease-activating factor 1', 12, NULL, NULL, 100903),
(100904, '2.60.40.10-FF-002942', NULL, 'Sensory AXon guidance', 140, NULL, NULL, 100904),
(100905, '3.40.50.1450-FF-000015', NULL, 'Hydrogenase-specific maturation endopeptidase', 148, NULL, NULL, 100905),
(100906, '3.40.50.10490-FF-000101', NULL, NULL, 79, NULL, NULL, 100906),
(100907, '3.80.10.10-FF-003842', NULL, 'Leucine Rich Repeat family protein', 232, NULL, NULL, 100907),
(100908, '3.10.360.10-FF-000002', NULL, 'Beta-defensin 106A', 49, NULL, NULL, 100908),
(100909, '3.40.50.670-FF-000024', NULL, 'DNA topoisomerase 2', 164, NULL, NULL, 100909),
(100910, '3.40.50.11610-FF-000027', NULL, NULL, 119, NULL, NULL, 100910),
(100911, '3.10.100.10-FF-000331', NULL, NULL, 95, NULL, NULL, 100911),
(100912, '3.40.718.10-FF-000006', NULL, '3-isopropylmalate dehydrogenase', 352, NULL, NULL, 100912),
(100913, '3.30.930.10-FF-000030', NULL, 'Aspartate--tRNA ligase', 316, NULL, NULL, 100913),
(100914, '1.20.58.60-FF-000017', NULL, 'Spectrin alpha chain, non-erythrocytic 1', 107, NULL, NULL, 100914),
(100915, '3.30.1360.210-FF-000006', NULL, 'Uncharacterized protein', 54, NULL, NULL, 100915),
(100916, '1.10.3060.10-FF-000014', NULL, 'Protein translocase subunit SecA', 187, NULL, NULL, 100916),
(100917, '3.30.428.10-FF-000065', NULL, 'Uncharacterized protein', 90, NULL, NULL, 100917),
(100918, '1.25.10.10-FF-002107', NULL, 'Uncharacterized protein', 395, NULL, NULL, 100918);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(100919, '1.25.40.10-FF-002935', NULL, 'Pentatricopeptide repeat-containing protein At1g61870, mitochondrial', 198, NULL, NULL, 100919),
(100920, '1.10.287.1490-FF-000047', NULL, 'RAD50 homolog, double strand break repair protein', 173, NULL, NULL, 100920),
(100921, '2.10.25.10-FF-001144', NULL, 'Predicted protein', 46, NULL, NULL, 100921),
(100922, '3.30.450.40-FF-000108', NULL, 'GAF domain-containing protein', 153, NULL, NULL, 100922),
(100923, '1.20.58.480-FF-000017', NULL, 'Nematode resistance protein-like HSPRO2', 116, NULL, NULL, 100923),
(100924, '2.40.160.120-FF-000018', NULL, 'Oxysterol-binding protein 9', 180, NULL, NULL, 100924),
(100925, '2.60.40.10-FF-000261', NULL, 'Sidekick cell adhesion molecule 2', 103, NULL, NULL, 100925),
(100926, '2.170.240.10-FF-000010', NULL, 'Uncharacterized protein', 227, NULL, NULL, 100926),
(100927, '1.25.10.10-FF-001618', NULL, 'CSE1 chromosome segregation 1-like (yeast)', 553, NULL, NULL, 100927),
(100928, '1.10.472.10-FF-000472', NULL, 'Plant-specific TFIIB-related protein PTF2', 99, NULL, NULL, 100928),
(100929, '3.40.50.150-FF-001638', NULL, NULL, 233, NULL, NULL, 100929),
(100930, '2.40.10.10-FF-000687', NULL, NULL, 45, NULL, NULL, 100930),
(100931, '2.40.30.10-FF-000143', NULL, 'Elongation factor Tu, putative', 119, NULL, NULL, 100931),
(100932, '3.40.33.10-FF-000018', NULL, 'SCP-like extracellular protein, putative', 157, NULL, NULL, 100932),
(100933, '3.30.70.330-FF-000760', NULL, '33 kDa ribonucleoprotein, chloroplastic', 145, NULL, NULL, 100933),
(100934, '2.160.20.10-FF-000160', NULL, 'Polygalacturonase', 112, NULL, NULL, 100934),
(100935, '4.10.1000.10-FF-000103', NULL, 'Uncharacterized protein', 55, NULL, NULL, 100935),
(100936, '3.90.650.10-FF-000034', NULL, 'Phosphoribosylformylglycinamidine synthase', 201, NULL, NULL, 100936),
(100937, '1.25.40.10-FF-000120', NULL, 'Tetratricopeptide repeat domain 8', 118, NULL, NULL, 100937),
(100938, '2.30.140.10-FF-000029', NULL, 'Polyamine aminopropyltransferase', 67, NULL, NULL, 100938),
(100939, '2.60.40.10-FF-000834', NULL, 'Proto-oncogene tyrosine-protein kinase MER', 107, NULL, NULL, 100939),
(100940, '3.90.230.10-FF-000070', NULL, NULL, 21, NULL, NULL, 100940),
(100941, '3.30.40.10-FF-001159', NULL, 'Predicted protein', 78, NULL, NULL, 100941),
(100942, '3.40.50.300-FF-006601', NULL, 'GTP-binding protein, putative', 97, NULL, NULL, 100942),
(100943, '1.10.150.20-FF-000272', NULL, 'Uncharacterized protein', 81, NULL, NULL, 100943),
(100944, '3.40.50.300-FF-003853', NULL, 'Predicted protein', 201, NULL, NULL, 100944),
(100945, '3.40.1260.20-FF-000006', NULL, 'Ribonuclease E', 105, NULL, NULL, 100945),
(100946, '1.25.40.10-FF-001098', NULL, 'Putative pentatricopeptide repeat-containing protein', 76, NULL, NULL, 100946),
(100947, '2.130.10.10-FF-004600', NULL, 'Uncharacterized protein', 204, NULL, NULL, 100947),
(100948, '3.30.1300.10-FF-000010', NULL, 'Pantothenate synthetase', 105, NULL, NULL, 100948),
(100949, '3.40.1260.10-FF-000015', NULL, 'Uncharacterized protein', 123, NULL, NULL, 100949),
(100950, '3.40.50.300-FF-004887', NULL, 'Predicted protein', 96, NULL, NULL, 100950),
(100951, '1.10.10.10-FF-000449', NULL, '30S ribosomal protein S19e', 143, NULL, NULL, 100951),
(100952, '3.20.20.150-FF-000035', NULL, 'AP endonuclease', 260, NULL, NULL, 100952),
(100953, '3.30.2410.10-FF-000041', NULL, 'Uncharacterized protein', 113, NULL, NULL, 100953),
(100954, '1.20.58.60-FF-000461', NULL, 'Dystonin', 106, NULL, NULL, 100954),
(100955, '2.60.40.1940-FF-000006', NULL, 'Thioester-containing protein 4, isoform B', 123, NULL, NULL, 100955),
(100956, '3.40.50.2000-FF-000208', NULL, 'Alpha,alpha-trehalose-phosphate synthase subunit, putative', 245, NULL, NULL, 100956),
(100957, '3.30.70.330-FF-002250', NULL, NULL, 118, NULL, NULL, 100957),
(100958, '2.30.30.760-FF-000002', NULL, 'Flagella basal body P-ring formation protein FlgA', 59, NULL, NULL, 100958),
(100959, '1.20.58.1390-FF-000002', NULL, 'O-methyltransferase', 89, NULL, NULL, 100959),
(100960, '1.10.472.10-FF-000691', NULL, 'Uncharacterized protein', 38, NULL, NULL, 100960);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(100961, '1.25.40.10-FF-000592', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 126, NULL, NULL, 100961),
(100962, '2.30.30.30-FF-000003', NULL, 'Elongation factor P', 64, NULL, NULL, 100962),
(100963, '3.40.50.2300-FF-000725', NULL, NULL, 84, NULL, NULL, 100963),
(100964, '3.30.160.60-FF-002936', NULL, 'Zinc finger and SCAN domain-containing protein 2', 37, NULL, NULL, 100964),
(100965, '3.30.505.10-FF-000205', NULL, NULL, 289, NULL, NULL, 100965),
(100966, '2.40.70.10-FF-000247', NULL, NULL, 58, NULL, NULL, 100966),
(100967, '2.10.70.10-FF-000068', NULL, 'Pappalysin 1', 71, NULL, NULL, 100967),
(100968, '2.80.10.50-FF-000259', NULL, 'Uncharacterized protein', 142, NULL, NULL, 100968),
(100969, '4.10.60.10-FF-000092', NULL, 'Universal minicircle sequence binding protein', 23, NULL, NULL, 100969),
(100970, '3.80.10.10-FF-003527', NULL, 'Uncharacterized protein', 170, NULL, NULL, 100970),
(100971, '2.30.29.30-FF-000152', NULL, 'ras-specific guanine nucleotide-releasing factor RalGPS1 isoform X1', 126, NULL, NULL, 100971),
(100972, '1.10.510.10-FF-002293', NULL, 'Protein kinase, putative (AFU_orthologue AFUA_7G00740)', 300, NULL, NULL, 100972),
(100973, '1.25.40.60-FF-000016', NULL, NULL, 75, NULL, NULL, 100973),
(100974, '1.10.30.10-FF-000017', NULL, 'high mobility group protein B3', 92, NULL, NULL, 100974),
(100975, '4.10.1000.10-FF-000120', NULL, 'Zinc finger CCCH domain-containing protein 17', 65, NULL, NULL, 100975),
(100976, '3.40.630.10-FF-000084', NULL, 'Carboxypeptidase B2', 309, NULL, NULL, 100976),
(100977, '1.20.1070.10-FF-001142', NULL, 'Beta-2 adrenergic receptor', 349, NULL, NULL, 100977),
(100978, '1.25.40.10-FF-004279', NULL, 'Pentatricopeptide repeat-containing protein', 208, NULL, NULL, 100978),
(100979, '3.40.366.10-FF-000042', NULL, 'Fatty acid synthase beta subunit', 130, NULL, NULL, 100979),
(100980, '3.30.497.10-FF-000140', NULL, 'Angiotensinogen', 155, NULL, NULL, 100980),
(100981, '2.40.50.100-FF-000003', NULL, 'Acetyl-CoA carboxylase biotin carboxyl carrier protein', 76, NULL, NULL, 100981),
(100982, '3.90.550.10-FF-000009', NULL, 'Cellulose synthase', 175, NULL, NULL, 100982),
(100983, '1.10.510.10-FF-001781', NULL, 'Forkhead-associated domain-containing protein / FHA domain-containing protein', 133, NULL, NULL, 100983),
(100984, '2.30.29.30-FF-000045', NULL, 'Ankyrin repeat and sterile alpha motif domain-containing protein 1B', 153, NULL, NULL, 100984),
(100985, '3.40.50.1820-FF-001756', NULL, 'Carboxypeptidase', 306, NULL, NULL, 100985),
(100986, '3.10.20.30-FF-000029', NULL, 'Obg-like ATPase 1', 110, NULL, NULL, 100986),
(100987, '3.30.830.10-FF-000096', NULL, 'Zinc protease, insulinase family', 244, NULL, NULL, 100987),
(100988, '1.10.10.10-FF-001545', NULL, 'CurA', 82, NULL, NULL, 100988),
(100989, '3.30.870.10-FF-000204', NULL, 'Uncharacterized protein', 124, NULL, NULL, 100989),
(100990, '1.10.220.150-FF-000022', NULL, 'ADP-ribosylation factor GTPase-activating protein, putative', 135, NULL, NULL, 100990),
(100991, '3.40.50.1820-FF-000031', NULL, 'Lipoprotein lipase', 315, NULL, NULL, 100991),
(100992, '1.20.1070.10-FF-001827', NULL, 'Uncharacterized protein', 354, NULL, NULL, 100992),
(100993, '2.70.170.10-FF-000236', NULL, 'Uncharacterized protein', 74, NULL, NULL, 100993),
(100994, '2.30.29.70-FF-000006', NULL, '26S proteasome regulatory subunit RPN13, putative', 112, NULL, NULL, 100994),
(100995, '3.10.580.20-FF-000004', NULL, 'Chloride channel protein', 87, NULL, NULL, 100995),
(100996, '2.60.120.10-FF-000533', NULL, 'Lysophospholipase NTE1', 118, NULL, NULL, 100996),
(100997, '2.60.110.10-FF-000021', NULL, 'Receptor Serine/Threonine kinase-like protein', 214, NULL, NULL, 100997),
(100998, '3.40.50.1100-FF-000146', NULL, 'Cysteine synthase/cystathionine beta-synthase', 188, NULL, NULL, 100998),
(100999, '1.20.210.10-FF-000036', NULL, 'Cytochrome c oxidase subunit 1', 429, NULL, NULL, 100999),
(101000, '3.40.30.10-FF-000961', NULL, 'Uncharacterized protein', 100, NULL, NULL, 101000),
(101001, '1.20.58.670-FF-000007', NULL, 'Exocyst complex component SEC15', 147, NULL, NULL, 101001);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(101002, '2.30.30.40-FF-000439', NULL, 'Uncharacterized protein', 34, NULL, NULL, 101002),
(101003, '3.60.90.10-FF-000003', NULL, 'S-adenosylmethionine decarboxylase proenzyme', 334, NULL, NULL, 101003),
(101004, '1.10.579.10-FF-000011', NULL, 'Deoxyribodipyrimidine photolyase, putative', 216, NULL, NULL, 101004),
(101005, '1.25.10.10-FF-002653', NULL, 'Predicted protein', 107, NULL, NULL, 101005),
(101006, '1.10.287.110-FF-000245', NULL, 'DnaJ domain containing protein', 118, NULL, NULL, 101006),
(101007, '2.40.30.10-FF-000379', NULL, 'Elongation factor G', 119, NULL, NULL, 101007),
(101008, '2.60.40.10-FF-005724', NULL, NULL, 119, NULL, NULL, 101008),
(101009, '3.30.1010.10-FF-000139', NULL, 'Phosphoinositide-3-kinase, catalytic, alpha polypeptide', 140, NULL, NULL, 101009),
(101010, '3.60.21.50-FF-000024', NULL, 'Uncharacterized protein', 258, NULL, NULL, 101010),
(101011, '3.90.550.10-FF-000341', NULL, '4930431L04Rik protein', 56, NULL, NULL, 101011),
(101012, '3.40.50.1000-FF-000318', NULL, '5''-deoxynucleotidase', 167, NULL, NULL, 101012),
(101013, '1.20.5.110-FF-000188', NULL, 'Syntaxin, epimorphin family', 71, NULL, NULL, 101013),
(101014, '2.60.120.560-FF-000025', NULL, 'Uncharacterized protein', 192, NULL, NULL, 101014),
(101015, '3.30.160.60-FF-004381', NULL, NULL, 96, NULL, NULL, 101015),
(101016, '3.40.50.720-FF-002315', NULL, 'Uncharacterized protein', 128, NULL, NULL, 101016),
(101017, '2.60.40.2610-FF-000005', NULL, 'Outer membrane usher protein PefC', 86, NULL, NULL, 101017),
(101018, '3.40.228.10-FF-000031', NULL, 'Gll2176 protein', 268, NULL, NULL, 101018),
(101019, '3.30.160.60-FF-000362', NULL, 'Zinc finger protein 606', 28, NULL, NULL, 101019),
(101020, '3.80.10.10-FF-000880', NULL, 'Leucine-rich repeat protein kinase family protein', 239, NULL, NULL, 101020),
(101021, '2.10.25.10-FF-000447', NULL, 'EGF-like repeat and discoidin I-like domain-containing protein 3', 48, NULL, NULL, 101021),
(101022, '3.40.50.150-FF-000913', NULL, NULL, 172, NULL, NULL, 101022),
(101023, '3.30.460.10-FF-000084', NULL, 'GTP pyrophosphokinase', 135, NULL, NULL, 101023),
(101024, '2.60.40.10-FF-004420', NULL, NULL, 96, NULL, NULL, 101024),
(101025, '1.20.1050.10-FF-000090', NULL, 'Maleylacetoacetate isomerase/glutathione S-transferase', 115, NULL, NULL, 101025),
(101026, '3.80.10.10-FF-003151', NULL, 'Uncharacterized protein', 296, NULL, NULL, 101026),
(101027, '3.30.420.40-FF-000612', NULL, 'Actin-related protein 8', 90, NULL, NULL, 101027),
(101028, '1.20.120.420-FF-000027', NULL, 'Uncharacterized protein', 92, NULL, NULL, 101028),
(101029, '1.10.3720.10-FF-000222', NULL, 'Sugar ABC transporter, permease protein', 240, NULL, NULL, 101029),
(101030, '3.40.50.300-FF-006124', NULL, 'Uncharacterized protein', 154, NULL, NULL, 101030),
(101031, '1.50.10.20-FF-000102', NULL, 'Protein farnesyltransferase subunit beta', 589, NULL, NULL, 101031),
(101032, '1.25.10.10-FF-000764', NULL, 'ARM repeat superfamily protein', 322, NULL, NULL, 101032),
(101033, '1.20.1250.20-FF-001018', NULL, 'Uncharacterized protein', 196, NULL, NULL, 101033),
(101034, '1.20.140.10-FF-000064', NULL, 'Dehydrogenase', 171, NULL, NULL, 101034),
(101035, '3.40.50.720-FF-000281', NULL, 'Uncharacterized oxidoreductase YIR035C', 249, NULL, NULL, 101035),
(101036, '3.30.470.20-FF-000115', NULL, 'LD38689p', 216, NULL, NULL, 101036),
(101037, '1.20.5.340-FF-000038', NULL, 'Myosin heavy chain muscle', 103, NULL, NULL, 101037),
(101038, '2.30.29.30-FF-000837', NULL, 'Uncharacterized protein', 108, NULL, NULL, 101038),
(101039, '3.40.50.1580-FF-000003', NULL, 'Uridine phosphorylase', 253, NULL, NULL, 101039),
(101040, '2.60.40.150-FF-000742', NULL, 'Uncharacterized protein', 97, NULL, NULL, 101040),
(101041, '2.10.220.10-FF-000063', NULL, 'Furin 2, isoform D', 60, NULL, NULL, 101041),
(101042, '2.30.42.10-FF-000328', NULL, 'FERM domain (Protein4.1-ezrin-radixin-moesin) family', 89, NULL, NULL, 101042),
(101043, '3.40.50.720-FF-002568', NULL, 'Uncharacterized protein', 39, NULL, NULL, 101043),
(101044, '1.20.58.60-FF-000837', NULL, 'Uncharacterized protein', 155, NULL, NULL, 101044);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(101045, '3.90.550.10-FF-000650', NULL, 'Uncharacterized protein', 135, NULL, NULL, 101045),
(101046, '3.40.50.150-FF-001155', NULL, 'Predicted protein', 241, NULL, NULL, 101046),
(101047, '2.130.10.10-FF-002127', NULL, 'Transducin beta protein 3', 191, NULL, NULL, 101047),
(101048, '1.20.1250.10-FF-000088', NULL, NULL, 134, NULL, NULL, 101048),
(101049, '2.160.20.10-FF-000244', NULL, 'Uncharacterized protein', 145, NULL, NULL, 101049),
(101050, '3.30.530.20-FF-000047', NULL, 'Hsp90 co-chaperone AHA1', 136, NULL, NULL, 101050),
(101051, '1.10.1450.10-FF-000145', NULL, 'Uncharacterized protein', 89, NULL, NULL, 101051),
(101052, '2.10.70.10-FF-000299', NULL, 'Limulus clotting factor C, putative', 42, NULL, NULL, 101052),
(101053, '3.40.50.300-FF-002526', NULL, 'Protein CLP1 homolog', 231, NULL, NULL, 101053),
(101054, '3.20.20.70-FF-000529', NULL, 'Radical S-adenosyl methionine domain-containing protein 1, mitochondrial', 253, NULL, NULL, 101054),
(101055, '1.25.10.10-FF-001017', NULL, 'Uncharacterized protein', 491, NULL, NULL, 101055),
(101056, '3.80.10.10-FF-002678', NULL, 'LRR receptor-like serine/threonine-protein kinase EFR', 105, NULL, NULL, 101056),
(101057, '3.60.15.10-FF-000015', NULL, 'probable hydrolase PNKD isoform X1', 267, NULL, NULL, 101057),
(101058, '1.10.601.10-FF-000008', NULL, 'RNA polymerase sigma factor sigE, chloroplastic/mitochondrial', 276, NULL, NULL, 101058),
(101059, '1.50.40.10-FF-000073', NULL, 'folate transporter 1, chloroplastic isoform X1', 105, NULL, NULL, 101059),
(101060, '2.30.40.10-FF-000184', NULL, 'Uncharacterized protein', 59, NULL, NULL, 101060),
(101061, '1.10.510.10-FF-003815', NULL, NULL, 115, NULL, NULL, 101061),
(101062, '1.20.1250.20-FF-001237', NULL, 'Uncharacterized protein', 535, NULL, NULL, 101062),
(101063, '3.10.450.70-FF-000004', NULL, 'Thiol:disulfide interchange protein', 47, NULL, NULL, 101063),
(101064, '1.20.1510.10-FF-000018', NULL, 'transmembrane protein 163', 189, NULL, NULL, 101064),
(101065, '3.30.70.330-FF-000316', NULL, 'RNA-binding family protein isoform 1', 84, NULL, NULL, 101065),
(101066, '3.30.890.10-FF-000003', NULL, 'methyl-CpG-binding domain protein 2', 76, NULL, NULL, 101066),
(101067, '2.130.10.10-FF-002835', NULL, 'Angio-associated migratory cell protein', 363, NULL, NULL, 101067),
(101068, '1.10.10.10-FF-000218', NULL, 'DNA-directed RNA polymerase III subunit RPC3', 78, NULL, NULL, 101068),
(101069, '3.30.60.30-FF-000239', NULL, 'Predicted protein', 47, NULL, NULL, 101069),
(101070, '3.50.50.60-FF-001404', NULL, 'Uncharacterized protein', 166, NULL, NULL, 101070),
(101071, '2.10.25.10-FF-001161', NULL, 'Netrin-G2', 91, NULL, NULL, 101071),
(101072, '2.120.10.80-FF-000283', NULL, 'Predicted protein', 228, NULL, NULL, 101072),
(101073, '2.40.50.90-FF-000106', NULL, 'Transcription factor (Snd1/p100), putative', 138, NULL, NULL, 101073),
(101074, '1.10.150.60-FF-000020', NULL, 'Ecm5p', 132, NULL, NULL, 101074),
(101075, '2.10.70.10-FF-000175', NULL, 'Mannan-binding lectin associated serine protease 2', 74, NULL, NULL, 101075),
(101076, '2.40.10.10-FF-000491', NULL, NULL, 187, NULL, NULL, 101076),
(101077, '3.40.30.10-FF-000652', NULL, '2-hydroxychromene-2-carboxylate isomerase', 192, NULL, NULL, 101077),
(101078, '2.30.42.10-FF-000019', NULL, 'LIM domain binding 3 isoform 1', 86, NULL, NULL, 101078),
(101079, '3.30.479.10-FF-000014', NULL, 'Queuosine biosynthesis QueD, PTPS-I / Folate biosynthesis protein PTPS-III', 159, NULL, NULL, 101079),
(101080, '3.40.50.300-FF-007905', NULL, 'Probable ATP-dependent RNA helicase spindle-E', 187, NULL, NULL, 101080),
(101081, '1.10.1740.150-FF-000002', NULL, 'Endoribonuclease Dicer-like', 33, NULL, NULL, 101081),
(101082, '2.130.10.10-FF-004853', NULL, 'Predicted protein', 127, NULL, NULL, 101082),
(101083, '3.90.70.10-FF-000804', NULL, 'BMA-CPL-6, isoform c', 317, NULL, NULL, 101083),
(101084, '1.20.1070.10-FF-000523', NULL, '5-hydroxytryptamine receptor 2B', 302, NULL, NULL, 101084),
(101085, '1.25.40.10-FF-002481', NULL, 'Putative pentatricopeptide repeat-containing protein At1g77010, mitochondrial', 137, NULL, NULL, 101085);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(101086, '2.40.30.10-FF-000126', NULL, 'Mitochondrial translation initiation factor', 120, NULL, NULL, 101086),
(101087, '3.30.920.10-FF-000001', NULL, 'Iron-sulfur cluster assembly protein CyaY', 106, NULL, NULL, 101087),
(101088, '1.20.5.340-FF-000111', NULL, 'Uncharacterized protein', 108, NULL, NULL, 101088),
(101089, '2.40.10.120-FF-000012', NULL, 'Genome polyprotein', 63, NULL, NULL, 101089),
(101090, '1.20.1740.10-FF-000266', NULL, 'Uncharacterized protein', 373, NULL, NULL, 101090),
(101091, '3.40.50.2000-FF-000517', NULL, 'UDP-N-acetylglucosamine transferase subunit ALG13', 168, NULL, NULL, 101091),
(101092, '1.10.10.60-FF-000790', NULL, NULL, 54, NULL, NULL, 101092),
(101093, '3.40.50.300-FF-007220', NULL, 'Uncharacterized protein', 163, NULL, NULL, 101093),
(101094, '3.40.50.720-FF-001803', NULL, 'Uncharacterized protein', 146, NULL, NULL, 101094),
(101095, '1.10.10.10-FF-000926', NULL, 'Transcriptional regulator, LysR family', 87, NULL, NULL, 101095),
(101096, '2.80.10.50-FF-000028', NULL, 'Inositol 1,4,5-trisphosphate receptor type 3', 209, NULL, NULL, 101096),
(101097, '3.20.20.60-FF-000055', NULL, '2,4-dihydroxyhept-2-ene-1,7-dioic acid aldolase, putative', 263, NULL, NULL, 101097),
(101098, '3.40.50.300-FF-002217', NULL, 'ATP-binding cassette sub-family G member 1', 242, NULL, NULL, 101098),
(101099, '3.40.190.10-FF-000959', NULL, 'Uncharacterized protein', 83, NULL, NULL, 101099),
(101100, '1.10.530.50-FF-000001', NULL, 'Membrane protein', 173, NULL, NULL, 101100),
(101101, '3.30.40.10-FF-000434', NULL, 'von Willebrand and RING finger domain protein', 72, NULL, NULL, 101101),
(101102, '1.10.1420.10-FF-000177', NULL, 'Chromosome 23, whole genome shotgun sequence', 128, NULL, NULL, 101102),
(101103, '3.80.10.10-FF-002223', NULL, 'Leucine-rich repeat protein', 69, NULL, NULL, 101103),
(101104, '3.40.50.2300-FF-001344', NULL, NULL, 70, NULL, NULL, 101104),
(101105, '1.10.510.10-FF-001073', NULL, 'Long-flagella protein kinase, CMGC RCK', 205, NULL, NULL, 101105),
(101106, '3.50.50.60-FF-001393', NULL, 'Uncharacterized protein', 202, NULL, NULL, 101106),
(101107, '3.40.190.10-FF-000583', NULL, 'ABC transporter, substrate-binding protein, family 5', 208, NULL, NULL, 101107),
(101108, '2.130.10.10-FF-005106', NULL, 'Uncharacterized protein', 247, NULL, NULL, 101108),
(101109, '1.10.10.60-FF-000082', NULL, 'Putative zinc finger homeobox protein 4', 83, NULL, NULL, 101109),
(101110, '3.40.1400.10-FF-000004', NULL, 'Ribose 5-phosphate isomerase', 152, NULL, NULL, 101110),
(101111, '1.10.10.60-FF-000239', NULL, 'Highly divergent homeobox', 66, NULL, NULL, 101111),
(101112, '3.40.50.300-FF-005399', NULL, 'ATP-binding cassette transporter, subfamily G, member 26, group PDR protein PpABCG26', 237, NULL, NULL, 101112),
(101113, '2.130.10.10-FF-002583', NULL, 'DNA damage-binding protein 2', 55, NULL, NULL, 101113),
(101114, '3.30.450.40-FF-000215', NULL, 'PleD gene product', 74, NULL, NULL, 101114),
(101115, '3.30.200.20-FF-002310', NULL, 'Uncharacterized protein', 60, NULL, NULL, 101115),
(101116, '3.50.50.60-FF-001371', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 175, NULL, NULL, 101116),
(101117, '2.60.40.10-FF-002711', NULL, 'Receptor-type tyrosine-protein phosphatase gamma', 98, NULL, NULL, 101117),
(101118, '3.60.10.10-FF-000010', NULL, 'protein angel homolog 2 isoform X1', 370, NULL, NULL, 101118),
(101119, '1.10.510.10-FF-003107', NULL, NULL, 194, NULL, NULL, 101119),
(101120, '3.40.140.10-FF-000181', NULL, 'Eukaryotic translation initiation factor 3 subunit F', 176, NULL, NULL, 101120),
(101121, '3.30.70.330-FF-000102', NULL, 'Heterogeneous nuclear ribonucleoprotein 1', 88, NULL, NULL, 101121),
(101122, '2.20.25.530-FF-000010', NULL, 'Uncharacterized protein', 84, NULL, NULL, 101122),
(101123, '2.60.40.60-FF-000787', NULL, 'Uncharacterized protein', 99, NULL, NULL, 101123),
(101124, '3.40.50.10810-FF-000023', NULL, 'helicase-like transcription factor isoform X1', 190, NULL, NULL, 101124),
(101125, '2.10.25.10-FF-001375', NULL, 'Vitamin K-dependent protein S', 69, NULL, NULL, 101125);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(101126, '3.30.70.20-FF-000063', NULL, 'Iron-sulfur cluster-binding protein', 78, NULL, NULL, 101126),
(101127, '1.20.120.1240-FF-000050', NULL, 'Predicted protein', 181, NULL, NULL, 101127),
(101128, '3.30.9.10-FF-000053', NULL, 'FAD dependent oxidoreductase', 157, NULL, NULL, 101128),
(101129, '1.20.58.60-FF-000152', NULL, 'Spectrin, beta, non-erythrocytic 5', 110, NULL, NULL, 101129),
(101130, '3.90.1030.10-FF-000020', NULL, '50S ribosomal protein L17', 175, NULL, NULL, 101130),
(101131, '3.30.200.20-FF-001849', NULL, 'Kinase, NEK', 55, NULL, NULL, 101131),
(101132, '4.10.400.10-FF-000277', NULL, 'Transmembrane cell adhesion receptor mua-3', 34, NULL, NULL, 101132),
(101133, '3.40.50.300-FF-004781', NULL, 'Bromodomain protein', 40, NULL, NULL, 101133),
(101134, '3.40.50.150-FF-000205', NULL, 'Ribosomal RNA large subunit methyltransferase A', 267, NULL, NULL, 101134),
(101135, '3.80.10.10-FF-001262', NULL, 'Leucine-rich repeat protein SHOC-2', 92, NULL, NULL, 101135),
(101136, '3.80.10.10-FF-000514', NULL, 'Si:dkey-159n16.2', 171, NULL, NULL, 101136),
(101137, '3.90.79.10-FF-000060', NULL, 'Nudix hydrolase 1', 142, NULL, NULL, 101137),
(101138, '2.170.130.20-FF-000010', NULL, NULL, 122, NULL, NULL, 101138),
(101139, '2.10.25.10-FF-001717', NULL, 'Uncharacterized protein', 40, NULL, NULL, 101139),
(101140, '2.130.10.10-FF-000435', NULL, 'SEC12-like protein 1', 316, NULL, NULL, 101140),
(101141, '3.40.50.1220-FF-000036', NULL, 'NAD-dependent protein deacetylase HST2', 157, NULL, NULL, 101141),
(101142, '3.30.750.44-FF-000024', NULL, NULL, 69, NULL, NULL, 101142),
(101143, '2.170.150.10-FF-000020', NULL, 'Translationally-controlled tumor protein-like protein', 176, NULL, NULL, 101143),
(101144, '1.25.40.20-FF-000471', NULL, 'GM20065', 131, NULL, NULL, 101144),
(101145, '3.90.740.10-FF-000024', NULL, 'Leucine--tRNA ligase', 243, NULL, NULL, 101145),
(101146, '3.20.20.100-FF-000189', NULL, 'Predicted protein', 108, NULL, NULL, 101146),
(101147, '2.30.230.10-FF-000003', NULL, 'Apolipoprotein B', 253, NULL, NULL, 101147),
(101148, '3.30.565.10-FF-000344', NULL, 'Sensory transduction histidine kinase', 129, NULL, NULL, 101148),
(101149, '3.30.50.10-FF-000171', NULL, 'Estrogen receptor', 69, NULL, NULL, 101149),
(101150, '1.25.40.10-FF-004987', NULL, 'Pentatricopeptide repeat-containing protein At2g36980, mitochondrial', 136, NULL, NULL, 101150),
(101151, '1.10.472.80-FF-000251', NULL, NULL, 112, NULL, NULL, 101151),
(101152, '3.40.50.720-FF-000062', NULL, 'Homoserine dehydrogenase', 168, NULL, NULL, 101152),
(101153, '1.20.1310.10-FF-000037', NULL, 'Related to cullin 4A', 113, NULL, NULL, 101153),
(101154, '2.60.40.10-FF-000126', NULL, 'filamin-C isoform X1', 98, NULL, NULL, 101154),
(101155, '3.40.50.1820-FF-000828', NULL, 'Alpha/Beta hydrolase protein', 167, NULL, NULL, 101155),
(101156, '1.10.1740.110-FF-000001', NULL, 'Homoserine O-acetyltransferase', 105, NULL, NULL, 101156),
(101157, '3.80.10.10-FF-000986', NULL, 'Dia2p', 107, NULL, NULL, 101157),
(101158, '1.10.238.10-FF-000349', NULL, 'Actin cytoskeleton-regulatory complex protein PAN1', 103, NULL, NULL, 101158),
(101159, '3.30.1330.30-FF-000063', NULL, 'RNA methyltransferase, TrmH family, group 3', 83, NULL, NULL, 101159),
(101160, '2.60.40.2030-FF-000056', NULL, 'Fras1-like extracellular matrix protein 1a', 119, NULL, NULL, 101160),
(101161, '3.40.30.10-FF-001248', NULL, 'Hydrogenosomal NADH dehydrogenase 24 kDa subunit', 97, NULL, NULL, 101161),
(101162, '3.40.50.300-FF-003959', NULL, 'DNA helicase', 183, NULL, NULL, 101162),
(101163, '3.90.550.10-FF-000318', NULL, 'Glycosyltransferase family 2 protein', 257, NULL, NULL, 101163),
(101164, '1.25.40.10-FF-001862', NULL, 'Tetratricopeptide repeat domain containing protein', 113, NULL, NULL, 101164),
(101165, '2.60.40.640-FF-000001', NULL, 'Vacuolar protein sorting-associated protein 26A', 154, NULL, NULL, 101165),
(101166, '3.30.1490.30-FF-000001', NULL, 'DNA topoisomerase 2', 45, NULL, NULL, 101166),
(101167, '3.40.50.1000-FF-000009', NULL, 'Phospholipid-transporting ATPase', 176, NULL, NULL, 101167);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(101168, '3.30.1380.20-FF-000006', NULL, 'Trafficking protein particle complex subunit', 182, NULL, NULL, 101168),
(101169, '3.40.190.80-FF-000036', NULL, 'Inositol-1-monophosphatase', 120, NULL, NULL, 101169),
(101170, '3.60.130.10-FF-000069', NULL, 'Uncharacterized protein', 192, NULL, NULL, 101170),
(101171, '3.40.50.1820-FF-000486', NULL, 'ABHydrolase Domain containing homolog', 260, NULL, NULL, 101171),
(101172, '3.10.129.10-FF-000234', NULL, 'Thioesterase family protein', 102, NULL, NULL, 101172),
(101173, '2.60.40.60-FF-000135', NULL, 'cadherin-23 isoform X1', 111, NULL, NULL, 101173),
(101174, '3.30.710.10-FF-000154', NULL, 'Uncharacterized protein, isoform A', 137, NULL, NULL, 101174),
(101175, '1.25.40.10-FF-000226', NULL, 'Tetratricopeptide repeat protein 30A', 239, NULL, NULL, 101175),
(101176, '3.90.770.10-FF-000009', NULL, '3-hydroxy-3-methylglutaryl-CoA reductase', 118, NULL, NULL, 101176),
(101177, '1.20.144.10-FF-000033', NULL, 'Dolichylpyrophosphate phosphatase', 95, NULL, NULL, 101177),
(101178, '3.30.1490.80-FF-000010', NULL, 'Glutathione synthetase', 83, NULL, NULL, 101178),
(101179, '1.20.1250.20-FF-000080', NULL, 'Muropeptide transporter AmpG', 193, NULL, NULL, 101179),
(101180, '3.40.47.10-FF-000270', NULL, NULL, 129, NULL, NULL, 101180),
(101181, '3.30.70.3030-FF-000020', NULL, 'U3 small nucleolar RNA-associated protein 22', 121, NULL, NULL, 101181),
(101182, '3.30.200.20-FF-000854', NULL, 'Uncharacterized protein', 87, NULL, NULL, 101182),
(101183, '3.10.196.10-FF-000013', NULL, 'Methionine synthase', 236, NULL, NULL, 101183),
(101184, '3.40.50.300-FF-002869', NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily A containing DEAD/H box 1', 180, NULL, NULL, 101184),
(101185, '3.40.50.300-FF-008524', NULL, 'Uncharacterized protein', 206, NULL, NULL, 101185),
(101186, '3.30.559.30-FF-000026', NULL, 'Acyltransferase, WS/DGAT/MGAT', 249, NULL, NULL, 101186),
(101187, '3.30.160.60-FF-004072', NULL, NULL, 57, NULL, NULL, 101187),
(101188, '3.30.70.330-FF-001266', NULL, 'RNA recognition motif domain containing protein', 103, NULL, NULL, 101188),
(101189, '1.20.1310.10-FF-000222', NULL, NULL, 48, NULL, NULL, 101189),
(101190, '3.90.1180.10-FF-000019', NULL, 'Leukotriene A(4) hydrolase', 54, NULL, NULL, 101190),
(101191, '3.40.605.10-FF-000008', NULL, 'Aldehyde-alcohol dehydrogenase', 231, NULL, NULL, 101191),
(101192, '3.10.20.90-FF-000839', NULL, 'Gamma-aminobutyric acid receptor associated protein, putative', 90, NULL, NULL, 101192),
(101193, '1.10.555.10-FF-000018', NULL, 'Rho GTPase activating protein 28', 256, NULL, NULL, 101193),
(101194, '2.30.30.40-FF-000315', NULL, 'Calcium channel, voltage-dependent, beta 2b', 158, NULL, NULL, 101194),
(101195, '3.40.250.10-FF-000077', NULL, 'Ubiquitin-specific protease', 144, NULL, NULL, 101195),
(101196, '3.90.550.10-FF-000465', NULL, 'CMP-N,N''-diacetyllegionaminic acid synthase', 227, NULL, NULL, 101196),
(101197, '3.30.70.330-FF-002811', NULL, NULL, 93, NULL, NULL, 101197),
(101198, '2.20.25.10-FF-000019', NULL, 'DNA-directed RNA polymerase subunit', 54, NULL, NULL, 101198),
(101199, '2.60.120.590-FF-000023', NULL, 'Alkylated DNA repair protein alkB homolog 8', 207, NULL, NULL, 101199),
(101200, '3.90.70.10-FF-000568', NULL, 'Predicted protein', 402, NULL, NULL, 101200),
(101201, '1.25.40.10-FF-000373', NULL, 'MAU2 chromatid cohesion factor homolog', 246, NULL, NULL, 101201),
(101202, '1.10.3630.10-FF-000007', NULL, 'Uncharacterized protein', 178, NULL, NULL, 101202),
(101203, '3.30.310.10-FF-000062', NULL, 'Beta subunit of clathrin adaptor complex AP2', 137, NULL, NULL, 101203),
(101204, '3.40.50.360-FF-000066', NULL, 'RFS1p protein', 209, NULL, NULL, 101204),
(101205, '1.10.510.10-FF-001415', NULL, 'Predicted protein', 264, NULL, NULL, 101205),
(101206, '3.40.20.10-FF-000039', NULL, 'Villin-4', 107, NULL, NULL, 101206),
(101207, '3.40.50.300-FF-003145', NULL, 'rho-related BTB domain-containing protein 1 isoform X2', 134, NULL, NULL, 101207),
(101208, '1.10.510.10-FF-003888', NULL, NULL, 88, NULL, NULL, 101208);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(101209, '3.50.50.60-FF-000752', NULL, 'Glutathione reductase', 322, NULL, NULL, 101209),
(101210, '1.20.120.350-FF-000214', NULL, NULL, 126, NULL, NULL, 101210),
(101211, '3.30.70.1450-FF-000057', NULL, 'Uncharacterized protein', 75, NULL, NULL, 101211),
(101212, '3.40.50.300-FF-000739', NULL, 'Putative ATP-dependent RNA helicase DHX36', 232, NULL, NULL, 101212),
(101213, '1.10.10.10-FF-001854', NULL, 'Histone acetyltransferase', 76, NULL, NULL, 101213),
(101214, '3.30.56.70-FF-000005', NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', 57, NULL, NULL, 101214),
(101215, '3.30.160.60-FF-005033', NULL, NULL, 24, NULL, NULL, 101215),
(101216, '3.30.1540.20-FF-000008', NULL, 'DNA mismatch repair protein PMS1, putative', 25, NULL, NULL, 101216),
(101217, '3.50.30.30-FF-000118', NULL, 'Peptidase M28', 126, NULL, NULL, 101217),
(101218, '3.90.190.20-FF-000030', NULL, 'Folylpolyglutamate synthase', 143, NULL, NULL, 101218),
(101219, '3.90.70.10-FF-000771', NULL, 'Uncharacterized protein', 66, NULL, NULL, 101219),
(101220, '2.60.120.330-FF-000232', NULL, 'Uncharacterized protein', 91, NULL, NULL, 101220),
(101221, '3.40.120.10-FF-000073', NULL, 'Phosphomannomutase', 98, NULL, NULL, 101221),
(101222, '3.30.40.10-FF-002143', NULL, 'RBR-type E3 ubiquitin transferase', 71, NULL, NULL, 101222),
(101223, '1.20.1250.20-FF-001384', NULL, 'Major facilitator superfamily MFS_1', 192, NULL, NULL, 101223),
(101224, '4.10.640.10-FF-000042', NULL, 'Uncharacterized protein', 66, NULL, NULL, 101224),
(101225, '1.10.418.10-FF-000211', NULL, 'Uncharacterized protein', 102, NULL, NULL, 101225),
(101226, '1.25.40.10-FF-004644', NULL, 'Uncharacterized protein', 124, NULL, NULL, 101226),
(101227, '1.10.3720.10-FF-000037', NULL, 'Inner membrane ABC transporter permease ycjP', 267, NULL, NULL, 101227),
(101228, '3.10.50.40-FF-000006', NULL, 'Peptidyl-prolyl cis-trans isomerase', 116, NULL, NULL, 101228),
(101229, '1.10.510.10-FF-002399', NULL, 'Uncharacterized protein', 268, NULL, NULL, 101229),
(101230, '3.40.50.1820-FF-001104', NULL, 'Predicted protein', 113, NULL, NULL, 101230),
(101231, '3.40.50.1000-FF-000684', NULL, NULL, 151, NULL, NULL, 101231),
(101232, '3.30.780.10-FF-000012', NULL, 'Translation initiation factor SUI1, putative', 84, NULL, NULL, 101232),
(101233, '1.20.1070.10-FF-001518', NULL, 'Uncharacterized protein', 191, NULL, NULL, 101233),
(101234, '4.10.320.10-FF-000018', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 43, NULL, NULL, 101234),
(101235, '3.40.570.10-FF-000005', NULL, 'ectonucleotide pyrophosphatase/phosphodiesterase family member 3', 327, NULL, NULL, 101235),
(101236, '1.20.5.110-FF-000082', NULL, 't-SNARE (ER)', 101, NULL, NULL, 101236),
(101237, '2.60.40.790-FF-000091', NULL, 'GL22442', 126, NULL, NULL, 101237),
(101238, '1.20.120.1530-FF-000013', NULL, NULL, 126, NULL, NULL, 101238),
(101239, '2.130.10.10-FF-004292', NULL, 'Syntaxin-binding protein 5a (tomosyn)', 124, NULL, NULL, 101239),
(101240, '2.40.50.140-FF-000419', NULL, 'Transcription termination/antitermination protein NusA', 66, NULL, NULL, 101240),
(101241, '3.80.10.10-FF-000172', NULL, 'Nyctalopin', 239, NULL, NULL, 101241),
(101242, '3.30.160.60-FF-000671', NULL, 'Zinc finger protein 26', 29, NULL, NULL, 101242),
(101243, '3.30.40.10-FF-001867', NULL, 'Nuclear transcription factor, X-box-binding-like 1', 78, NULL, NULL, 101243),
(101244, '2.10.25.10-FF-000756', NULL, 'Delta-like protein', 37, NULL, NULL, 101244),
(101245, '3.30.160.60-FF-000486', NULL, 'E3 ubiquitin-protein ligase TRIM41 isoform X2', 50, NULL, NULL, 101245),
(101246, '2.60.120.460-FF-000001', NULL, 'UPF0047 protein MT2633', 132, NULL, NULL, 101246),
(101247, '1.20.140.150-FF-000040', NULL, 'Uncharacterized protein, isoform B', 168, NULL, NULL, 101247),
(101248, '2.60.120.310-FF-000018', NULL, 'Predicted protein', 162, NULL, NULL, 101248),
(101249, '1.20.120.80-FF-000010', NULL, 'Cytochrome c oxidase subunit 3', 184, NULL, NULL, 101249),
(101250, '3.30.430.20-FF-000006', NULL, 'Receptor-like serine-threonine protein kinase', 109, NULL, NULL, 101250);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(101251, '3.30.160.60-FF-004628', NULL, NULL, 33, NULL, NULL, 101251),
(101252, '2.60.40.790-FF-000214', NULL, NULL, 128, NULL, NULL, 101252),
(101253, '3.40.50.300-FF-006579', NULL, 'Bifunctional coenzyme A synthase', 100, NULL, NULL, 101253),
(101254, '2.130.10.30-FF-000121', NULL, NULL, 241, NULL, NULL, 101254),
(101255, '1.10.510.10-FF-000454', NULL, 'Uncharacterized protein', 196, NULL, NULL, 101255),
(101256, '3.40.50.261-FF-000020', NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta mitochondrial', 102, NULL, NULL, 101256),
(101257, '3.40.50.10190-FF-000129', NULL, 'Poly [ADP-ribose] polymerase', 111, NULL, NULL, 101257),
(101258, '1.10.10.1050-FF-000015', NULL, 'mRNA-decapping enzyme 2', 85, NULL, NULL, 101258),
(101259, '2.60.120.200-FF-000749', NULL, 'Uncharacterized protein', 137, NULL, NULL, 101259),
(101260, '1.20.1250.20-FF-001726', NULL, 'Uncharacterized protein', 205, NULL, NULL, 101260),
(101261, '3.40.30.10-FF-000629', NULL, 'Thioredoxin-like protein 4B', 94, NULL, NULL, 101261),
(101262, '1.10.560.10-FF-000081', NULL, '60 kDa chaperonin', 245, NULL, NULL, 101262),
(101263, '1.10.238.10-FF-000192', NULL, 'Protein S100', 100, NULL, NULL, 101263),
(101264, '2.60.20.10-FF-000018', NULL, 'Calcium-dependent cell adhesion molecule 1', 92, NULL, NULL, 101264),
(101265, '1.10.510.10-FF-003579', NULL, NULL, 214, NULL, NULL, 101265),
(101266, '3.30.70.270-FF-000062', NULL, 'Uncharacterized protein', 97, NULL, NULL, 101266),
(101267, '1.10.8.60-FF-000570', NULL, 'Cytosolic Fe-S cluster assembly factor NUBP1 homolog', 71, NULL, NULL, 101267),
(101268, '3.40.30.10-FF-001029', NULL, 'Uncharacterized protein', 49, NULL, NULL, 101268),
(101269, '3.30.465.10-FF-000145', NULL, 'Uncharacterized protein', 140, NULL, NULL, 101269),
(101270, '1.10.150.80-FF-000031', NULL, 'Ribonuclease D', 98, NULL, NULL, 101270),
(101271, '1.20.1250.20-FF-002002', NULL, 'Uncharacterized protein', 380, NULL, NULL, 101271),
(101272, '3.80.10.10-FF-001818', NULL, 'YALI0D21208p', 133, NULL, NULL, 101272),
(101273, '2.130.10.10-FF-003763', NULL, 'Predicted protein', 323, NULL, NULL, 101273),
(101274, '2.10.270.10-FF-000010', NULL, 'Dextransucrase', 83, NULL, NULL, 101274),
(101275, '3.40.50.620-FF-000397', NULL, 'Isoleucine--tRNA ligase, cytoplasmic', 82, NULL, NULL, 101275),
(101276, '2.60.120.920-FF-000167', NULL, 'Uncharacterized protein', 117, NULL, NULL, 101276),
(101277, '1.20.58.390-FF-000209', NULL, 'Cholinergic receptor nicotinic alpha 10 subunit', 65, NULL, NULL, 101277),
(101278, '3.30.40.10-FF-000687', NULL, 'Rco1p', 61, NULL, NULL, 101278),
(101279, '3.40.50.2300-FF-000416', NULL, 'DNA-binding response regulator KdpE', 81, NULL, NULL, 101279),
(101280, '1.10.533.10-FF-000170', NULL, 'Uncharacterized protein', 43, NULL, NULL, 101280),
(101281, '3.40.50.720-FF-000314', NULL, 'Quinone oxidoreductase PIG3', 144, NULL, NULL, 101281),
(101282, '1.10.510.10-FF-000145', NULL, 'Dual specificity protein kinase CLK2', 249, NULL, NULL, 101282),
(101283, '3.50.7.10-FF-000015', NULL, 'Chaperonin HSP60, mitochondrial', 184, NULL, NULL, 101283),
(101284, '3.40.50.880-FF-000210', NULL, 'Chromosome 10, whole genome shotgun sequence', 207, NULL, NULL, 101284),
(101285, '3.90.79.10-FF-000217', NULL, 'Uncharacterized protein', 177, NULL, NULL, 101285),
(101286, '3.10.20.90-FF-000587', NULL, 'Ubiquitin family protein 5, putative', 79, NULL, NULL, 101286),
(101287, '2.60.120.380-FF-000095', NULL, 'Putative calpain-like cysteine protease A', 141, NULL, NULL, 101287),
(101288, '3.40.50.10420-FF-000013', NULL, '5-formyltetrahydrofolate cyclo-ligase', 191, NULL, NULL, 101288),
(101289, '4.10.400.10-FF-000171', NULL, 'Low-density lipoprotein receptor-related protein', 40, NULL, NULL, 101289),
(101290, '3.80.10.10-FF-001133', NULL, 'Transmembrane protein kinase', 98, NULL, NULL, 101290),
(101291, '3.90.870.10-FF-000028', NULL, 'Sua5/YciO/YrdC/YwlC family protein', 200, NULL, NULL, 101291),
(101292, '3.90.470.20-FF-000034', NULL, 'Enterobactin synthase component D', 101, NULL, NULL, 101292),
(101293, '3.80.10.10-FF-001509', NULL, '2mit, isoform B', 77, NULL, NULL, 101293);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(101294, '2.40.70.10-FF-000033', NULL, 'Aspartyl protease family protein', 177, NULL, NULL, 101294),
(101295, '1.20.1250.20-FF-000765', NULL, 'Riboflavin transporter', 406, NULL, NULL, 101295),
(101296, '3.30.200.20-FF-000545', NULL, 'CMGC family protein kinase', 83, NULL, NULL, 101296),
(101297, '1.25.40.10-FF-001553', NULL, 'Pentatricopeptide (PPR) repeat-containing protein-like', 93, NULL, NULL, 101297),
(101298, '1.25.40.20-FF-001090', NULL, 'Kinase, NEK', 93, NULL, NULL, 101298),
(101299, '1.25.10.10-FF-000545', NULL, 'VPS15 protein kinase', 183, NULL, NULL, 101299),
(101300, '2.10.25.10-FF-000071', NULL, 'Fibrillin 2', 43, NULL, NULL, 101300),
(101301, '3.40.50.2300-FF-000164', NULL, 'LacI family transcriptional regulator', 133, NULL, NULL, 101301),
(101302, '3.40.50.300-FF-004814', NULL, 'Protein CBG17965', 154, NULL, NULL, 101302),
(101303, '2.60.40.60-FF-000591', NULL, 'Protocadherin gamma subfamily B, 7', 70, NULL, NULL, 101303),
(101304, '3.30.300.20-FF-000002', NULL, 'Transcription termination/antitermination protein NusA', 79, NULL, NULL, 101304),
(101305, '1.10.565.10-FF-000176', NULL, 'Uncharacterized protein', 171, NULL, NULL, 101305),
(101306, '3.40.1190.10-FF-000043', NULL, NULL, 206, NULL, NULL, 101306),
(101307, '3.30.160.60-FF-004414', NULL, NULL, 31, NULL, NULL, 101307),
(101308, '1.10.287.70-FF-000727', NULL, 'Protein CBR-TWK-44', 128, NULL, NULL, 101308),
(101309, '3.90.226.10-FF-000066', NULL, 'Enoyl-CoA hydratase', 200, NULL, NULL, 101309),
(101310, '3.40.50.1820-FF-001447', NULL, 'Uncharacterized protein', 187, NULL, NULL, 101310),
(101311, '3.40.50.620-FF-000739', NULL, 'Uncharacterized protein C1F12.08', 155, NULL, NULL, 101311),
(101312, '3.30.40.10-FF-001524', NULL, 'RING/U-box superfamily protein', 110, NULL, NULL, 101312),
(101313, '2.40.50.140-FF-001280', NULL, NULL, 135, NULL, NULL, 101313),
(101314, '3.40.47.10-FF-000303', NULL, NULL, 15, NULL, NULL, 101314),
(101315, '3.50.50.60-FF-000224', NULL, 'Putative oxidoreductase C1F5.03c', 119, NULL, NULL, 101315),
(101316, '3.10.180.20-FF-000002', NULL, 'Alpha-1,3-mannosyl-glycoprotein 2-beta-N-acetylglucosaminyltransferase', 75, NULL, NULL, 101316),
(101317, '3.40.50.1820-FF-000795', NULL, 'Uncharacterized protein', 164, NULL, NULL, 101317),
(101318, '3.40.50.300-FF-004106', NULL, 'Uncharacterized protein', 234, NULL, NULL, 101318),
(101319, '2.130.10.10-FF-005000', NULL, 'Predicted protein', 63, NULL, NULL, 101319),
(101320, '1.20.1070.10-FF-001271', NULL, 'low-density lipoprotein receptor-related protein 2-like', 154, NULL, NULL, 101320),
(101321, '3.10.20.90-FF-000278', NULL, 'serine-rich adhesin for platelets', 123, NULL, NULL, 101321),
(101322, '1.25.40.20-FF-000139', NULL, 'caskin-2 isoform X1', 118, NULL, NULL, 101322),
(101323, '2.60.260.20-FF-000136', NULL, 'Uncharacterized protein', 84, NULL, NULL, 101323),
(101324, '1.20.1070.10-FF-000995', NULL, 'Adrenoceptor alpha 1D', 271, NULL, NULL, 101324),
(101325, '1.10.260.40-FF-000016', NULL, 'HTH-type transcriptional regulator PuuR', 72, NULL, NULL, 101325),
(101326, '1.10.340.30-FF-000071', NULL, 'Uncharacterized protein', 42, NULL, NULL, 101326),
(101327, '2.130.10.10-FF-000705', NULL, 'Probable cytosolic iron-sulfur protein assembly protein 1', 332, NULL, NULL, 101327),
(101328, '3.30.200.20-FF-000293', NULL, 'Tyrosine-protein kinase', 96, NULL, NULL, 101328),
(101329, '3.100.10.10-FF-000034', NULL, 'Ribosomal protein L18e/L15', 93, NULL, NULL, 101329),
(101330, '1.25.40.10-FF-005263', NULL, 'Uncharacterized protein', 155, NULL, NULL, 101330),
(101331, '1.20.120.1750-FF-000096', NULL, 'RBR-type E3 ubiquitin transferase', 236, NULL, NULL, 101331),
(101332, '2.70.130.10-FF-000003', NULL, 'Endoplasmic reticulum lectin 1', 131, NULL, NULL, 101332),
(101333, '3.30.450.90-FF-000005', NULL, 'Protein VirB11', 104, NULL, NULL, 101333),
(101334, '2.80.10.70-FF-000001', NULL, 'Spindlin 1', 216, NULL, NULL, 101334),
(101335, '3.20.20.220-FF-000079', NULL, 'Proline dehydrogenase', 125, NULL, NULL, 101335),
(101336, '2.60.40.10-FF-000492', NULL, 'Mucosa-associated lymphoid tissue lymphoma translocation protein 1', 89, NULL, NULL, 101336);
INSERT INTO "PUBLIC"."MODEL" VALUES
(101337, '1.25.40.10-FF-000350', NULL, 'Vacuolar protein sorting-associated protein 41 homolog', 206, NULL, NULL, 101337),
(101338, '3.30.300.180-FF-000021', NULL, 'Chromosomal replication initiator protein DnaA', 102, NULL, NULL, 101338),
(101339, '2.10.70.10-FF-000271', NULL, 'Uncharacterized protein', 65, NULL, NULL, 101339),
(101340, '2.130.10.10-FF-001071', NULL, 'Protein HIRA', 132, NULL, NULL, 101340),
(101341, '1.10.530.10-FF-000017', NULL, 'Lytic murein transglycosylase', 177, NULL, NULL, 101341),
(101342, '3.80.10.10-FF-001150', NULL, 'Outer arm dynein light chain 1', 212, NULL, NULL, 101342),
(101343, '1.10.10.830-FF-000011', NULL, 'Isoleucine--tRNA ligase', 58, NULL, NULL, 101343),
(101344, '1.10.630.10-FF-000648', NULL, 'Predicted protein', 207, NULL, NULL, 101344),
(101345, '1.10.510.10-FF-001106', NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g29720', 200, NULL, NULL, 101345),
(101346, '1.25.40.10-FF-003104', NULL, 'Peptidyl-prolyl cis-trans isomerase, rhodopsin-specific isozyme-like Protein', 148, NULL, NULL, 101346),
(101347, '1.10.150.20-FF-000042', NULL, '5''-3'' exonuclease family protein', 81, NULL, NULL, 101347),
(101348, '1.10.20.10-FF-000186', NULL, 'CCAAT-binding factor complex subunit Php3', 111, NULL, NULL, 101348),
(101349, '3.30.710.10-FF-000171', NULL, 'Uncharacterized protein, isoform B', 121, NULL, NULL, 101349),
(101350, '2.130.10.10-FF-000565', NULL, 'Putative snoRNA binding protein', 342, NULL, NULL, 101350),
(101351, '3.40.50.2300-FF-001473', NULL, NULL, 209, NULL, NULL, 101351),
(101352, '1.10.510.10-FF-002146', NULL, 'inactive tyrosine-protein kinase transmembrane receptor ROR1 isoform X1', 196, NULL, NULL, 101352),
(101353, '3.90.70.10-FF-000349', NULL, 'Ubiquitinyl hydrolase 1', 227, NULL, NULL, 101353),
(101354, '1.10.1420.10-FF-000194', NULL, 'Uncharacterized protein', 176, NULL, NULL, 101354),
(101355, '2.102.10.10-FF-000044', NULL, 'Methylxanthine N1-demethylase NdmA', 134, NULL, NULL, 101355),
(101356, '2.40.10.10-FF-000035', NULL, 'Complement C1r subcomponent', 133, NULL, NULL, 101356),
(101357, '2.60.40.150-FF-000489', NULL, 'Predicted protein', 135, NULL, NULL, 101357),
(101358, '1.10.3470.10-FF-000028', NULL, 'Iron ABC transporter permease', 324, NULL, NULL, 101358),
(101359, '3.30.420.40-FF-000854', NULL, 'Uncharacterized protein', 142, NULL, NULL, 101359),
(101360, '3.90.550.10-FF-000678', NULL, 'Uncharacterized protein', 93, NULL, NULL, 101360),
(101361, '3.20.20.70-FF-000524', NULL, 'PelA', 259, NULL, NULL, 101361),
(101362, '3.30.200.20-FF-000641', NULL, 'Protein kinase 7', 119, NULL, NULL, 101362),
(101363, '3.40.50.2300-FF-000967', NULL, NULL, 136, NULL, NULL, 101363),
(101364, '3.40.50.2000-FF-000984', NULL, 'Uncharacterized protein', 65, NULL, NULL, 101364),
(101365, '3.30.40.10-FF-000895', NULL, 'AGAP005461-PA', 49, NULL, NULL, 101365),
(101366, '2.60.40.420-FF-000042', NULL, 'Cytochrome c oxidase subunit 2', 223, NULL, NULL, 101366),
(101367, '3.10.100.10-FF-000230', NULL, 'C-type lectin domain-containing 14A', 140, NULL, NULL, 101367),
(101368, '2.130.10.10-FF-000126', NULL, 'Plexin B1', 449, NULL, NULL, 101368),
(101369, '3.60.20.10-FF-000089', NULL, 'Proteasome endopeptidase complex', 260, NULL, NULL, 101369),
(101370, '3.30.160.60-FF-003684', NULL, 'Zinc finger protein 462', 97, NULL, NULL, 101370),
(101371, '1.25.40.10-FF-004627', NULL, 'Prolyl 4-hydroxylase subunit alpha-2-like Protein', 129, NULL, NULL, 101371),
(101372, '2.40.70.10-FF-000483', NULL, NULL, 151, NULL, NULL, 101372),
(101373, '1.20.1560.10-FF-000510', NULL, 'ABC transporter, multidrug resistance associated protein', 325, NULL, NULL, 101373),
(101374, '3.80.10.10-FF-002673', NULL, 'Uncharacterized protein', 123, NULL, NULL, 101374),
(101375, '1.25.40.10-FF-001873', NULL, 'GM18509', 329, NULL, NULL, 101375),
(101376, '1.20.1560.10-FF-000398', NULL, 'Multidrug resistance-associated protein 7', 332, NULL, NULL, 101376),
(101377, '3.30.230.10-FF-000140', NULL, 'DNA topoisomerase 2', 125, NULL, NULL, 101377),
(101378, '1.10.10.60-FF-000115', NULL, 'Transcriptional adapter 2', 53, NULL, NULL, 101378);
INSERT INTO "PUBLIC"."MODEL" VALUES
(101379, '2.60.40.60-FF-000023', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', 109, NULL, NULL, 101379),
(101380, '1.25.10.10-FF-002990', NULL, 'Protein CBG04073', 373, NULL, NULL, 101380),
(101381, '3.60.20.10-FF-000201', NULL, NULL, 215, NULL, NULL, 101381),
(101382, '3.90.1030.10-FF-000003', NULL, '50S ribosomal protein L17', 116, NULL, NULL, 101382),
(101383, '3.40.50.300-FF-006360', NULL, 'Uncharacterized protein', 140, NULL, NULL, 101383),
(101384, '3.30.40.10-FF-001507', NULL, 'RING finger protein 145', 74, NULL, NULL, 101384),
(101385, '1.20.120.350-FF-000219', NULL, NULL, 73, NULL, NULL, 101385),
(101386, '3.40.50.150-FF-000565', NULL, 'Predicted protein', 193, NULL, NULL, 101386),
(101387, '3.10.20.90-FF-000834', NULL, 'Autophagy-related protein', 127, NULL, NULL, 101387),
(101388, '1.10.10.10-FF-001298', NULL, 'MarR family transcriptional regulator', 110, NULL, NULL, 101388),
(101389, '3.30.1370.10-FF-000183', NULL, 'YALI0C05324p', 84, NULL, NULL, 101389),
(101390, '3.10.100.10-FF-000129', NULL, 'Thrombomodulin', 151, NULL, NULL, 101390),
(101391, '2.170.140.10-FF-000047', NULL, 'Mucin 68E', 60, NULL, NULL, 101391),
(101392, '2.40.150.20-FF-000019', NULL, 'Ribosomal protein L23', 140, NULL, NULL, 101392),
(101393, '3.40.50.720-FF-000522', NULL, 'L-carnitine dehydrogenase', 185, NULL, NULL, 101393),
(101394, '1.20.58.60-FF-000697', NULL, 'Predicted protein', 111, NULL, NULL, 101394),
(101395, '2.70.170.10-FF-000096', NULL, 'Gamma-aminobutyric acid receptor subunit beta', 216, NULL, NULL, 101395),
(101396, '3.30.70.330-FF-001378', NULL, NULL, 138, NULL, NULL, 101396),
(101397, '2.60.120.260-FF-000385', NULL, 'Predicted protein', 204, NULL, NULL, 101397),
(101398, '3.60.10.10-FF-000015', NULL, 'sphingomyelin phosphodiesterase 3', 298, NULL, NULL, 101398),
(101399, '3.40.50.720-FF-001719', NULL, 'Possible 2-hydroxyacid-family dehydrogenase', 121, NULL, NULL, 101399),
(101400, '3.10.110.10-FF-000315', NULL, 'Uncharacterized protein', 63, NULL, NULL, 101400),
(101401, '1.10.510.10-FF-000589', NULL, 'Serine/threonine-protein kinase', 221, NULL, NULL, 101401),
(101402, '1.25.10.10-FF-003395', NULL, 'Armadillo repeat-containing protein 3', 131, NULL, NULL, 101402),
(101403, '2.60.120.10-FF-000763', NULL, 'Cyclic nucleotide-activated ion channel', 65, NULL, NULL, 101403),
(101404, '2.20.25.10-FF-000115', NULL, 'DNA-directed RNA polymerase subunit', 52, NULL, NULL, 101404),
(101405, '3.30.559.10-FF-000037', NULL, 'Nonribosomal peptide synthase Pes1', 172, NULL, NULL, 101405),
(101406, '1.10.10.10-FF-000112', NULL, 'HTH-type transcriptional regulator lrhA', 89, NULL, NULL, 101406),
(101407, '3.80.10.10-FF-001245', NULL, 'Reduced ocelli, isoform B', 125, NULL, NULL, 101407),
(101408, '3.40.50.300-FF-002077', NULL, 'Damage-inducible mutagenesis protein', 104, NULL, NULL, 101408),
(101409, '2.30.30.40-FF-000091', NULL, 'Putative E3 ubiquitin-protein ligase SH3RF1', 58, NULL, NULL, 101409),
(101410, '3.90.980.20-FF-000034', NULL, NULL, 71, NULL, NULL, 101410),
(101411, '1.20.1070.10-FF-000765', NULL, 'Predicted protein', 269, NULL, NULL, 101411),
(101412, '1.10.510.10-FF-003574', NULL, NULL, 215, NULL, NULL, 101412),
(101413, '2.60.220.30-FF-000024', NULL, 'Uncharacterized protein', 164, NULL, NULL, 101413),
(101414, '3.30.200.20-FF-002439', NULL, 'Predicted protein', 69, NULL, NULL, 101414),
(101415, '2.60.40.10-FF-002627', NULL, 'Uncharacterized protein', 126, NULL, NULL, 101415),
(101416, '3.40.1550.10-FF-000003', NULL, 'Flagellar motor switch phosphatase FliY', 196, NULL, NULL, 101416),
(101417, '2.130.10.10-FF-003903', NULL, 'Uncharacterized protein', 270, NULL, NULL, 101417),
(101418, '2.130.10.10-FF-004729', NULL, 'Eukaryotic translation initiation factor 2A', 166, NULL, NULL, 101418),
(101419, '2.30.38.10-FF-000004', NULL, 'Acyl-CoA synthetase family member 2', 75, NULL, NULL, 101419),
(101420, '2.60.40.60-FF-000927', NULL, 'cDNA FLJ11853 fis, clone HEMBA1006758, highly similar to Homo sapiens protocadherin beta 13 (PCDH-beta13) mRNA', 56, NULL, NULL, 101420),
(101421, '2.60.40.150-FF-000394', NULL, 'Copine family protein', 120, NULL, NULL, 101421);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(101422, '3.40.50.80-FF-000062', NULL, 'NADPH-dependent diflavin oxidoreductase 1', 155, NULL, NULL, 101422),
(101423, '1.10.10.60-FF-000554', NULL, 'POU domain, class 5, transcription factor 2', 47, NULL, NULL, 101423),
(101424, '1.10.510.10-FF-002051', NULL, 'Protein CBG06004', 353, NULL, NULL, 101424),
(101425, '1.10.238.10-FF-000085', NULL, 'CDPK-related kinase 1', 73, NULL, NULL, 101425),
(101426, '1.10.100.10-FF-000002', NULL, 'Insulin-like growth factor II preproprotein', 68, NULL, NULL, 101426),
(101427, '1.10.10.60-FF-001060', NULL, NULL, 49, NULL, NULL, 101427),
(101428, '1.25.10.10-FF-000522', NULL, 'AP-3 complex subunit beta, putative', 214, NULL, NULL, 101428),
(101429, '1.20.1730.10-FF-000001', NULL, 'Cation/acetate symporter ActP', 493, NULL, NULL, 101429),
(101430, '2.30.29.30-FF-001326', NULL, 'Beta 1 syntrophin, putative', 62, NULL, NULL, 101430),
(101431, '1.10.1670.10-FF-000009', NULL, 'DNA-3-methyladenine glycosylase 2 family protein', 54, NULL, NULL, 101431),
(101432, '4.10.60.10-FF-000102', NULL, 'Cellular nucleic acid binding protein, putative', 67, NULL, NULL, 101432),
(101433, '3.20.20.140-FF-000173', NULL, 'Protein unc-33', 361, NULL, NULL, 101433),
(101434, '3.40.50.300-FF-006259', NULL, 'Zinc finger RANBP2-type containing 3', 115, NULL, NULL, 101434),
(101435, '1.10.238.10-FF-000568', NULL, 'Hypothetical_protein', 75, NULL, NULL, 101435),
(101436, '2.130.10.10-FF-001975', NULL, 'Uncharacterized protein', 203, NULL, NULL, 101436),
(101437, '2.40.160.110-FF-000021', NULL, 'uncharacterized protein LOC101242403 isoform X1', 172, NULL, NULL, 101437),
(101438, '2.10.25.10-FF-000205', NULL, 'latent-transforming growth factor beta-binding protein 1 isoform X1', 64, NULL, NULL, 101438),
(101439, '3.30.70.120-FF-000040', NULL, NULL, 102, NULL, NULL, 101439),
(101440, '3.30.40.10-FF-001412', NULL, 'U-box domain-containing protein 13', 33, NULL, NULL, 101440),
(101441, '1.10.472.10-FF-000612', NULL, 'T-type cyclin', 135, NULL, NULL, 101441),
(101442, '3.40.30.10-FF-000989', NULL, 'Uncharacterized protein', 86, NULL, NULL, 101442),
(101443, '2.60.40.3330-FF-000002', NULL, 'TransThyretin-Related family domain', 112, NULL, NULL, 101443),
(101444, '3.40.190.10-FF-000723', NULL, 'Glutamate receptor', 54, NULL, NULL, 101444),
(101445, '1.10.730.10-FF-000128', NULL, 'Methionine-tRNA synthetase, putative', 152, NULL, NULL, 101445),
(101446, '1.20.5.340-FF-000116', NULL, 'Membrane protein related to metalloendopeptidase', 89, NULL, NULL, 101446),
(101447, '1.10.950.10-FF-000009', NULL, 'Unc-115 protein', 72, NULL, NULL, 101447),
(101448, '2.130.10.10-FF-003892', NULL, 'Uncharacterized protein', 273, NULL, NULL, 101448),
(101449, '3.30.70.330-FF-000552', NULL, 'RNA recognition motif domain containing protein', 97, NULL, NULL, 101449),
(101450, '1.10.246.130-FF-000001', NULL, 'Gamma-glutamyltransferase 5 isoform 1', 107, NULL, NULL, 101450),
(101451, '2.40.40.20-FF-000080', NULL, 'AGAP012684-PA', 53, NULL, NULL, 101451),
(101452, '3.40.20.10-FF-000011', NULL, 'Drebrin-like protein B', 133, NULL, NULL, 101452),
(101453, '1.10.3430.10-FF-000020', NULL, 'Ammonium transporter', 450, NULL, NULL, 101453),
(101454, '3.30.750.24-FF-000035', NULL, 'STAS domain protein', 111, NULL, NULL, 101454),
(101455, '1.25.40.20-FF-000027', NULL, 'Arf-GAP with GTPase, ANK repeat and PH domain-containing protein 1', 127, NULL, NULL, 101455),
(101456, '3.30.160.60-FF-000699', NULL, 'Zinc finger protein 33B', 26, NULL, NULL, 101456),
(101457, '3.40.50.2300-FF-000175', NULL, 'Propionate catabolism operon regulatory protein PrpR', 110, NULL, NULL, 101457),
(101458, '2.30.30.40-FF-000102', NULL, 'Desmoplakin a', 69, NULL, NULL, 101458),
(101459, '1.10.1410.40-FF-000016', NULL, 'Smith-Magenis syndrome chromosome region, candidate 7', 15, NULL, NULL, 101459),
(101460, '1.25.10.10-FF-000652', NULL, 'Serine/threonine-protein kinase TOR', 216, NULL, NULL, 101460),
(101461, '2.10.110.10-FF-000173', NULL, 'XLIM-Kinases2', 63, NULL, NULL, 101461),
(101462, '1.10.510.10-FF-002955', NULL, NULL, 167, NULL, NULL, 101462);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(101463, '1.10.390.10-FF-000028', NULL, 'Aminopeptidase', 255, NULL, NULL, 101463),
(101464, '1.10.10.10-FF-000893', NULL, 'Regulatory protein RecX', 47, NULL, NULL, 101464),
(101465, '4.10.400.10-FF-000064', NULL, 'low-density lipoprotein receptor-related protein 4', 43, NULL, NULL, 101465),
(101466, '2.60.120.760-FF-000001', NULL, 'Fucose-binding lectin II', 130, NULL, NULL, 101466),
(101467, '3.40.50.300-FF-007669', NULL, 'Uncharacterized protein', 121, NULL, NULL, 101467),
(101468, '3.30.930.10-FF-000277', NULL, 'Uncharacterized protein', 122, NULL, NULL, 101468),
(101469, '1.20.1110.10-FF-000139', NULL, NULL, 257, NULL, NULL, 101469),
(101470, '3.40.1810.10-FF-000041', NULL, 'Agamous-like MADS-box protein AGL80', 103, NULL, NULL, 101470),
(101471, '3.30.160.60-FF-000811', NULL, 'Zinc finger protein 521', 86, NULL, NULL, 101471),
(101472, '3.40.50.300-FF-007557', NULL, 'Uncharacterized protein', 188, NULL, NULL, 101472),
(101473, '3.40.50.2000-FF-000080', NULL, 'Glycosyltransferase', 260, NULL, NULL, 101473),
(101474, '2.80.10.50-FF-000124', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 49, NULL, NULL, 101474),
(101475, '3.40.50.300-FF-005062', NULL, 'Uncharacterized protein', 137, NULL, NULL, 101475),
(101476, '3.40.50.720-FF-001950', NULL, 'Predicted protein', 265, NULL, NULL, 101476),
(101477, '2.60.40.1970-FF-000004', NULL, 'YEATS domain-containing protein 4 isoform X2', 50, NULL, NULL, 101477),
(101478, '2.60.40.10-FF-004544', NULL, NULL, 83, NULL, NULL, 101478),
(101479, '3.20.19.10-FF-000008', NULL, 'Aconitate hydratase', 227, NULL, NULL, 101479),
(101480, '3.10.20.30-FF-000052', NULL, 'Ubiquitin-related modifier 1', 99, NULL, NULL, 101480),
(101481, '3.30.505.10-FF-000216', NULL, NULL, 108, NULL, NULL, 101481),
(101482, '1.10.510.10-FF-000926', NULL, 'Serine/threonine protein kinase VPS15', 127, NULL, NULL, 101482),
(101483, '3.40.220.10-FF-000030', NULL, 'ADP-ribose glycohydrolase AF_1521', 192, NULL, NULL, 101483),
(101484, '3.40.50.300-FF-004331', NULL, 'ABC transporter ATP-binding protein', 250, NULL, NULL, 101484),
(101485, '2.130.10.10-FF-003420', NULL, 'Sortilin', 179, NULL, NULL, 101485),
(101486, '3.40.640.10-FF-000461', NULL, 'Uncharacterized protein', 175, NULL, NULL, 101486),
(101487, '4.10.320.10-FF-000012', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 41, NULL, NULL, 101487),
(101488, '1.20.58.1210-FF-000016', NULL, 'Predicted protein', 116, NULL, NULL, 101488),
(101489, '1.10.8.500-FF-000010', NULL, 'Methyl-accepting chemotaxis protein CtpH', 46, NULL, NULL, 101489),
(101490, '3.40.50.1860-FF-000003', NULL, 'Aspartate racemase', 109, NULL, NULL, 101490),
(101491, '1.25.40.10-FF-000249', NULL, 'N-lysine methyltransferase SMYD2 isoform X2', 192, NULL, NULL, 101491),
(101492, '1.20.5.5270-FF-000003', NULL, 'Lon protease homolog 2, peroxisomal', 49, NULL, NULL, 101492),
(101493, '2.60.40.1910-FF-000014', NULL, 'Aminopeptidase', 79, NULL, NULL, 101493),
(101494, '2.30.39.10-FF-000096', NULL, 'serine protease inhibitor isoform X1', 160, NULL, NULL, 101494),
(101495, '2.60.40.10-FF-005584', NULL, NULL, 81, NULL, NULL, 101495),
(101496, '2.60.40.1180-FF-000183', NULL, 'Alpha-glucosidase, family 31 of glycosyl hydrolase', 51, NULL, NULL, 101496),
(101497, '1.10.30.10-FF-000012', NULL, 'axial regulator YABBY 5-like', 59, NULL, NULL, 101497),
(101498, '2.40.50.140-FF-000094', NULL, 'cold shock domain-containing protein E1 isoform X1', 70, NULL, NULL, 101498),
(101499, '1.20.5.350-FF-000024', NULL, NULL, 107, NULL, NULL, 101499),
(101500, '3.30.420.40-FF-000062', NULL, 'N-acetylmannosamine kinase', 127, NULL, NULL, 101500),
(101501, '1.10.510.10-FF-004400', NULL, NULL, 86, NULL, NULL, 101501),
(101502, '2.60.40.1850-FF-000002', NULL, 'Internalin', 130, NULL, NULL, 101502),
(101503, '1.20.5.1230-FF-000005', NULL, NULL, 158, NULL, NULL, 101503),
(101504, '3.40.50.960-FF-000010', NULL, '6,7-dimethyl-8-ribityllumazine synthase', 148, NULL, NULL, 101504),
(101505, '3.10.20.230-FF-000022', NULL, 'Double-cortin, putative', 98, NULL, NULL, 101505);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(101506, '1.10.472.10-FF-000241', NULL, 'Cyclin domain containing protein', 131, NULL, NULL, 101506),
(101507, '2.160.20.60-FF-000011', NULL, 'Predicted protein', 187, NULL, NULL, 101507),
(101508, '2.60.120.320-FF-000004', NULL, 'Thiamine pyrophosphokinase', 93, NULL, NULL, 101508),
(101509, '2.130.10.10-FF-002931', NULL, 'Uncharacterized protein', 121, NULL, NULL, 101509),
(101510, '2.130.10.10-FF-004617', NULL, 'AFR634Wp', 200, NULL, NULL, 101510),
(101511, '3.30.450.20-FF-000024', NULL, 'VWFA and cache domain-containing protein 1', 113, NULL, NULL, 101511),
(101512, '1.20.1250.20-FF-001485', NULL, 'Solute carrier organic anion transporter family member', 399, NULL, NULL, 101512),
(101513, '3.60.21.10-FF-000260', NULL, 'Ser/Thr protein phosphatase', 262, NULL, NULL, 101513),
(101514, '3.40.50.300-FF-008288', NULL, 'Predicted protein', 31, NULL, NULL, 101514),
(101515, '3.40.50.10140-FF-000002', NULL, 'Interleukin 1 receptor accessory protein', 153, NULL, NULL, 101515),
(101516, '2.60.260.20-FF-000029', NULL, 'Molecular chaperone DnaJ', 61, NULL, NULL, 101516),
(101517, '3.30.930.10-FF-000165', NULL, 'Lysine--tRNA ligase', 355, NULL, NULL, 101517),
(101518, '1.25.10.10-FF-001141', NULL, 'Uncharacterized protein', 140, NULL, NULL, 101518),
(101519, '3.40.50.300-FF-002886', NULL, 'Rho family GTPase', 188, NULL, NULL, 101519),
(101520, '3.30.40.10-FF-002031', NULL, 'Uncharacterized protein', 138, NULL, NULL, 101520),
(101521, '2.40.30.10-FF-000374', NULL, 'NADH-dependent ferredoxin:NADP+ oxidoreductase, beta subunit', 90, NULL, NULL, 101521),
(101522, '1.20.1440.90-FF-000008', NULL, 'Phosphoenolpyruvate carboxylase', 118, NULL, NULL, 101522),
(101523, '3.80.10.10-FF-003611', NULL, 'Uncharacterized protein', 108, NULL, NULL, 101523),
(101524, '2.130.10.10-FF-005348', NULL, 'Uncharacterized protein', 179, NULL, NULL, 101524),
(101525, '3.80.10.10-FF-003387', NULL, 'Uncharacterized protein', 263, NULL, NULL, 101525),
(101526, '3.50.50.60-FF-000544', NULL, 'Flavin-containing monooxygenase, putative', 120, NULL, NULL, 101526),
(101527, '2.70.160.11-FF-000040', NULL, 'Protein arginine N-methyltransferase-related protein', 169, NULL, NULL, 101527),
(101528, '3.30.830.10-FF-000129', NULL, 'Protease, insulinase family/protease, insulinase family', 205, NULL, NULL, 101528),
(101529, '1.10.1630.10-FF-000001', NULL, 'histone acetyltransferase p300', 50, NULL, NULL, 101529),
(101530, '3.40.50.300-FF-001700', NULL, 'ATP-dependent DNA helicase RecQ', 204, NULL, NULL, 101530),
(101531, '1.20.5.110-FF-000183', NULL, 't-SNARE protein aex-4', 85, NULL, NULL, 101531),
(101532, '1.20.5.320-FF-000009', NULL, 'Collagen alpha-1(XVII) chain', 40, NULL, NULL, 101532),
(101533, '2.40.480.10-FF-000002', NULL, 'Dirigent protein', 158, NULL, NULL, 101533),
(101534, '2.30.29.30-FF-000028', NULL, 'Talin 2', 98, NULL, NULL, 101534),
(101535, '3.40.850.10-FF-000156', NULL, 'Myosin heavy chain subunit', 216, NULL, NULL, 101535),
(101536, '3.40.50.150-FF-001503', NULL, NULL, 113, NULL, NULL, 101536),
(101537, '2.60.120.430-FF-000037', NULL, 'NADH:ubiquinone oxidoreductase complex assembly factor 1', 152, NULL, NULL, 101537),
(101538, '1.20.120.1760-FF-000088', NULL, NULL, 217, NULL, NULL, 101538),
(101539, '1.25.10.10-FF-002338', NULL, 'Armadillo repeat-containing protein LFR', 292, NULL, NULL, 101539),
(101540, '2.60.40.10-FF-004173', NULL, NULL, 87, NULL, NULL, 101540),
(101541, '2.60.120.650-FF-000070', NULL, '40S ribosomal protein S4-3', 155, NULL, NULL, 101541),
(101542, '1.20.120.140-FF-000033', NULL, 'Signal recognition particle receptor FtsY', 127, NULL, NULL, 101542),
(101543, '3.10.20.90-FF-000704', NULL, 'Uncharacterized protein', 89, NULL, NULL, 101543),
(101544, '2.30.33.40-FF-000013', NULL, '20 kDa chaperonin', 103, NULL, NULL, 101544),
(101545, '3.40.50.450-FF-000082', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit alpha 2', 147, NULL, NULL, 101545),
(101546, '1.10.510.10-FF-000134', NULL, 'Casein kinase I isoform delta-like', 308, NULL, NULL, 101546),
(101547, '1.20.5.350-FF-000007', NULL, 'Troponin I2, fast skeletal type', 123, NULL, NULL, 101547);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(101548, '2.130.10.10-FF-000677', NULL, 'Type I inositol polyphosphate 5-phosphatase 13', 250, NULL, NULL, 101548),
(101549, '3.40.50.300-FF-005871', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 230, NULL, NULL, 101549),
(101550, '1.10.418.10-FF-000071', NULL, 'plastin-1 isoform X1', 125, NULL, NULL, 101550),
(101551, '2.60.40.10-FF-003116', NULL, 'Putative neuronal cell adhesion molecule', 95, NULL, NULL, 101551),
(101552, '2.30.29.30-FF-000697', NULL, 'GM16509', 149, NULL, NULL, 101552),
(101553, '1.25.40.10-FF-000480', NULL, 'WGS project CABT00000000 data, contig 2.13', 215, NULL, NULL, 101553),
(101554, '1.20.120.160-FF-000039', NULL, 'Histidine kinase', 121, NULL, NULL, 101554),
(101555, '2.70.150.10-FF-000206', NULL, 'Phospholipid-transporting ATPase', 137, NULL, NULL, 101555),
(101556, '3.90.70.80-FF-000089', NULL, 'Predicted protein', 87, NULL, NULL, 101556),
(101557, '1.10.460.10-FF-000023', NULL, 'DNA topoisomerase 3', 50, NULL, NULL, 101557),
(101558, '3.40.50.300-FF-002448', NULL, 'Dynein heavy chain family protein', 200, NULL, NULL, 101558),
(101559, '1.25.40.10-FF-004515', NULL, 'Uncharacterized protein', 86, NULL, NULL, 101559),
(101560, '3.40.140.10-FF-000080', NULL, 'NPL4-like protein 1', 174, NULL, NULL, 101560),
(101561, '2.60.120.260-FF-000508', NULL, 'Uncharacterized protein', 54, NULL, NULL, 101561),
(101562, '1.10.20.10-FF-000298', NULL, NULL, 62, NULL, NULL, 101562),
(101563, '1.20.140.100-FF-000048', NULL, 'Uncharacterized protein', 150, NULL, NULL, 101563),
(101564, '3.30.160.60-FF-004173', NULL, NULL, 27, NULL, NULL, 101564),
(101565, '3.30.420.40-FF-000742', NULL, 'Uncharacterized protein', 108, NULL, NULL, 101565),
(101566, '3.40.50.10090-FF-000077', NULL, 'Uncharacterized protein', 164, NULL, NULL, 101566),
(101567, '3.40.50.1260-FF-000048', NULL, 'Phosphoglycerate kinase', 120, NULL, NULL, 101567),
(101568, '1.10.510.10-FF-004063', NULL, NULL, 153, NULL, NULL, 101568),
(101569, '1.20.5.1500-FF-000013', NULL, 'GM16360', 56, NULL, NULL, 101569),
(101570, '1.20.58.390-FF-000092', NULL, 'Nicotinic acetylcholine receptor subunit alpha10', 165, NULL, NULL, 101570),
(101571, '1.10.3720.10-FF-000138', NULL, 'ABC transporter permease protein', 194, NULL, NULL, 101571),
(101572, '3.40.50.1820-FF-001868', NULL, 'Uncharacterized protein', 245, NULL, NULL, 101572),
(101573, '3.30.420.10-FF-000295', NULL, 'Pol polyprotein', 125, NULL, NULL, 101573),
(101574, '3.30.830.10-FF-000213', NULL, 'Mitochondrial presequence protease', 259, NULL, NULL, 101574),
(101575, '1.25.40.20-FF-000819', NULL, 'Protein ACCELERATED CELL DEATH 6', 98, NULL, NULL, 101575),
(101576, '3.30.200.20-FF-000753', NULL, 'Serine/Threonine Kinase', 88, NULL, NULL, 101576),
(101577, '3.40.50.1820-FF-001525', NULL, 'Uncharacterized protein', 145, NULL, NULL, 101577),
(101578, '3.30.230.10-FF-000252', NULL, 'Uncharacterized protein', 45, NULL, NULL, 101578),
(101579, '3.40.50.1820-FF-000250', NULL, 'Non-ribosomal peptide synthetase', 262, NULL, NULL, 101579),
(101580, '1.25.40.10-FF-001761', NULL, 'Pentatricopeptide repeat-containing protein At2g41720', 71, NULL, NULL, 101580),
(101581, '2.40.70.10-FF-000371', NULL, NULL, 206, NULL, NULL, 101581),
(101582, '3.80.10.10-FF-000756', NULL, 'Rab geranylgeranyl transferase like protein', 165, NULL, NULL, 101582),
(101583, '3.40.50.11540-FF-000006', NULL, 'RE33648p', 139, NULL, NULL, 101583),
(101584, '3.30.450.70-FF-000011', NULL, 'Trafficking protein particle complex subunit 2', 152, NULL, NULL, 101584),
(101585, '2.70.70.10-FF-000009', NULL, 'N-acetyl glucosamine specific PTS system component IIABC', 155, NULL, NULL, 101585),
(101586, '2.60.40.820-FF-000055', NULL, 'Uncharacterized protein', 70, NULL, NULL, 101586),
(101587, '3.80.10.10-FF-004016', NULL, 'Uncharacterized protein', 147, NULL, NULL, 101587),
(101588, '2.30.30.100-FF-000052', NULL, 'Small nuclear ribonucleoprotein Sm D2', 101, NULL, NULL, 101588),
(101589, '3.40.1110.10-FF-000471', NULL, NULL, 64, NULL, NULL, 101589),
(101590, '1.20.900.10-FF-000004', NULL, 'Rho guanine nucleotide exchange factor 2', 244, NULL, NULL, 101590);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(101591, '3.40.50.150-FF-000677', NULL, 'Methyltransferase, putative', 351, NULL, NULL, 101591),
(101592, '3.30.1370.10-FF-000071', NULL, 'KH domain containing 1 like', 104, NULL, NULL, 101592),
(101593, '1.25.40.120-FF-000047', NULL, 'YALI0B16126p', 330, NULL, NULL, 101593),
(101594, '3.40.50.1000-FF-000212', NULL, 'Probable phosphatase', 139, NULL, NULL, 101594),
(101595, '4.10.240.10-FF-000192', NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', 82, NULL, NULL, 101595),
(101596, '2.20.70.10-FF-000079', NULL, 'FCA gamma protein', 66, NULL, NULL, 101596),
(101597, '1.10.10.10-FF-000472', NULL, 'GntR family transcriptional regulator', 67, NULL, NULL, 101597),
(101598, '1.10.8.60-FF-000367', NULL, 'Spermatogenesis-associated protein 5-like protein 1', 88, NULL, NULL, 101598),
(101599, '1.25.40.10-FF-001659', NULL, 'Activator of G protein Signalling', 334, NULL, NULL, 101599),
(101600, '2.160.20.80-FF-000017', NULL, NULL, 198, NULL, NULL, 101600),
(101601, '2.60.120.290-FF-000040', NULL, 'Transmembrane serine protease 7', 123, NULL, NULL, 101601),
(101602, '2.10.250.10-FF-000003', NULL, 'Calreticulin 3', 44, NULL, NULL, 101602),
(101603, '2.60.40.10-FF-001559', NULL, 'Roundabout 1, isoform A', 107, NULL, NULL, 101603),
(101604, '3.40.50.300-FF-006490', NULL, 'Predicted protein', 115, NULL, NULL, 101604),
(101605, '3.30.760.10-FF-000005', NULL, 'UPF0696 protein C11orf68 homolog', 219, NULL, NULL, 101605),
(101606, '3.30.160.60-FF-002144', NULL, 'Zinc finger protein 343', 25, NULL, NULL, 101606),
(101607, '3.90.230.10-FF-000053', NULL, NULL, 135, NULL, NULL, 101607),
(101608, '3.40.50.300-FF-002105', NULL, 'tRNA dimethylallyltransferase', 167, NULL, NULL, 101608),
(101609, '3.30.70.330-FF-001749', NULL, 'SC35-like splicing factor 33', 162, NULL, NULL, 101609),
(101610, '3.40.50.1000-FF-000442', NULL, 'Phosphotransferase', 111, NULL, NULL, 101610),
(101611, '3.40.50.2300-FF-001456', NULL, NULL, 114, NULL, NULL, 101611),
(101612, '3.30.40.10-FF-001384', NULL, 'E3 ubiquitin-protein ligase rnf146', 65, NULL, NULL, 101612),
(101613, '4.10.280.10-FF-000087', NULL, 'Transcription factor hes-1', 73, NULL, NULL, 101613),
(101614, '3.40.1110.10-FF-000369', NULL, NULL, 185, NULL, NULL, 101614),
(101615, '3.40.50.300-FF-001829', NULL, 'Nickel import system ATP-binding protein NikE', 233, NULL, NULL, 101615),
(101616, '3.80.10.10-FF-001942', NULL, 'LRR receptor-like serine/threonine-protein kinase ERECTA', 97, NULL, NULL, 101616),
(101617, '3.40.50.1820-FF-000587', NULL, 'Serine carboxypeptidase-like 33', 335, NULL, NULL, 101617),
(101618, '3.40.50.150-FF-000194', NULL, 'Phosphoglycerate kinase', 199, NULL, NULL, 101618),
(101619, '3.40.50.11660-FF-000025', NULL, 'Alpha-(1,3)-fucosyltransferase fut-3', 204, NULL, NULL, 101619),
(101620, '3.20.20.70-FF-000636', NULL, NULL, 262, NULL, NULL, 101620),
(101621, '1.10.510.10-FF-001657', NULL, 'Protein kinase, putative', 92, NULL, NULL, 101621),
(101622, '1.25.10.10-FF-001933', NULL, 'Serine/threonine-protein kinase TOR', 110, NULL, NULL, 101622),
(101623, '2.40.30.10-FF-000486', NULL, 'Uncharacterized protein', 38, NULL, NULL, 101623),
(101624, '3.30.160.60-FF-002627', NULL, 'Zinc finger and BTB domain-containing 41', 30, NULL, NULL, 101624),
(101625, '3.30.565.10-FF-000097', NULL, 'DNA topoisomerase 2', 248, NULL, NULL, 101625),
(101626, '2.30.30.140-FF-000148', NULL, 'Hydrogenase expression/formation protein HupF', 74, NULL, NULL, 101626),
(101627, '3.90.228.10-FF-000025', NULL, 'UBA/TS-N domain containing protein', 128, NULL, NULL, 101627),
(101628, '3.30.160.60-FF-002705', NULL, 'Zinc finger protein 732', 28, NULL, NULL, 101628),
(101629, '3.40.449.10-FF-000010', NULL, 'Phosphoenolpyruvate carboxykinase [GTP]', 233, NULL, NULL, 101629),
(101630, '3.40.1350.10-FF-000022', NULL, 'Sen15p', 119, NULL, NULL, 101630),
(101631, '1.10.287.70-FF-000519', NULL, 'Phosphomevalonate kinase', 134, NULL, NULL, 101631),
(101632, '3.40.50.1240-FF-000042', NULL, 'Acid phosphatase aph, 3-phytase phyB', 206, NULL, NULL, 101632),
(101633, '1.20.1740.10-FF-000058', NULL, 'Amino Acid Transporter', 444, NULL, NULL, 101633);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(101634, '1.20.1270.60-FF-000284', NULL, 'Predicted protein', 207, NULL, NULL, 101634),
(101635, '2.70.98.10-FF-000101', NULL, 'Aldose 1-epimerase', 361, NULL, NULL, 101635),
(101636, '3.40.50.2000-FF-001029', NULL, 'Predicted protein', 170, NULL, NULL, 101636),
(101637, '1.10.238.10-FF-000113', NULL, 'Actinin alpha 1', 59, NULL, NULL, 101637),
(101638, '2.60.40.10-FF-005937', NULL, NULL, 98, NULL, NULL, 101638),
(101639, '3.40.50.300-FF-000391', NULL, 'ATP-dependent DNA helicase RecG', 173, NULL, NULL, 101639),
(101640, '3.40.630.30-FF-000073', NULL, 'PHD finger family protein', 170, NULL, NULL, 101640),
(101641, '3.30.160.60-FF-004752', NULL, NULL, 60, NULL, NULL, 101641),
(101642, '3.30.70.100-FF-000045', NULL, 'Rhodanese-like domain-containing protein 6', 112, NULL, NULL, 101642),
(101643, '3.40.720.10-FF-000074', NULL, 'GPI ethanolamine phosphate transferase 1', 232, NULL, NULL, 101643),
(101644, '1.10.418.10-FF-000099', NULL, 'Nuclear anchorage protein 1', 118, NULL, NULL, 101644),
(101645, '3.40.50.1820-FF-001076', NULL, '2-succinyl-6-hydroxy-2, 4-cyclohexadiene-1-carboxylate synthase', 252, NULL, NULL, 101645),
(101646, '3.40.50.2300-FF-000063', NULL, 'Gamma-aminobutyric acid type B receptor subunit', 165, NULL, NULL, 101646),
(101647, '1.10.238.10-FF-000905', NULL, 'Ubiquitin carboxyl-terminal hydrolase 32-like Protein', 193, NULL, NULL, 101647),
(101648, '3.40.50.620-FF-000155', NULL, 'Glutamine-dependent NAD(+) synthetase', 221, NULL, NULL, 101648),
(101649, '3.40.50.720-FF-001478', NULL, 'Pyrroline-5-carboxylate reductase', 165, NULL, NULL, 101649),
(101650, '3.10.110.10-FF-000074', NULL, 'ubiquitin-conjugating enzyme E2 D1 isoform X2', 109, NULL, NULL, 101650),
(101651, '3.30.565.10-FF-000552', NULL, 'Uncharacterized protein', 45, NULL, NULL, 101651),
(101652, '3.90.70.10-FF-000433', NULL, 'Cysteine protease XCP1', 85, NULL, NULL, 101652),
(101653, '1.25.40.10-FF-002278', NULL, 'Pentatricopeptide repeat-containing protein At2g40240, mitochondrial', 160, NULL, NULL, 101653),
(101654, '1.20.1110.10-FF-000269', NULL, NULL, 24, NULL, NULL, 101654),
(101655, '3.10.20.90-FF-000042', NULL, 'Ral guanine nucleotide dissociation stimulator isoform 1', 120, NULL, NULL, 101655),
(101656, '2.60.260.20-FF-000130', NULL, 'Chaperone protein DNAj, putative', 110, NULL, NULL, 101656),
(101657, '3.40.1350.60-FF-000008', NULL, 'Sugar fermentation stimulation protein homolog', 150, NULL, NULL, 101657),
(101658, '2.60.40.1230-FF-000024', NULL, 'Probable ADP-ribosylation factor-binding protein C25H2.16c', 124, NULL, NULL, 101658),
(101659, '3.30.160.60-FF-004622', NULL, NULL, 88, NULL, NULL, 101659),
(101660, '3.40.50.720-FF-001039', NULL, '2-dehydropantoate 2-reductase', 170, NULL, NULL, 101660),
(101661, '3.30.559.70-FF-000027', NULL, 'carnitine O-palmitoyltransferase 1, liver isoform', 319, NULL, NULL, 101661),
(101662, '4.10.60.10-FF-000232', NULL, 'CCHC-type zinc finger nucleic acid-binding protein', 24, NULL, NULL, 101662),
(101663, '3.20.20.70-FF-000075', NULL, 'Tryptophan biosynthesis protein TRP1', 203, NULL, NULL, 101663),
(101664, '2.10.60.10-FF-000017', NULL, 'Ly6/PLAUR domain-containing protein 3', 93, NULL, NULL, 101664),
(101665, '3.30.70.330-FF-001406', NULL, 'AT27578p', 184, NULL, NULL, 101665),
(101666, '3.40.50.300-FF-004443', NULL, 'ATPase YjeE, predicted to have essential role in cell wall biosynthesis', 151, NULL, NULL, 101666),
(101667, '3.90.226.10-FF-000060', NULL, 'Propionyl-CoA carboxylase subunit beta 6', 255, NULL, NULL, 101667),
(101668, '2.60.40.10-FF-005241', NULL, NULL, 88, NULL, NULL, 101668),
(101669, '3.30.70.330-FF-002025', NULL, NULL, 107, NULL, NULL, 101669),
(101670, '3.30.1890.10-FF-000008', NULL, 'O-antigen chain length regulator', 274, NULL, NULL, 101670),
(101671, '3.40.1280.10-FF-000027', NULL, 'Putative tRNA/rRNA methyltransferase YsgA', 168, NULL, NULL, 101671),
(101672, '2.60.40.10-FF-004965', NULL, NULL, 87, NULL, NULL, 101672),
(101673, '2.40.50.140-FF-000886', NULL, NULL, 198, NULL, NULL, 101673),
(101674, '3.30.870.10-FF-000126', NULL, 'YALI0D07590p', 244, NULL, NULL, 101674);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(101675, '2.120.10.80-FF-000395', NULL, 'Uncharacterized protein', 177, NULL, NULL, 101675),
(101676, '2.60.40.1820-FF-000004', NULL, 'Harpin-induced protein', 152, NULL, NULL, 101676),
(101677, '1.25.40.10-FF-003790', NULL, 'Uncharacterized protein', 147, NULL, NULL, 101677),
(101678, '1.20.1070.10-FF-001951', NULL, 'Uncharacterized protein', 208, NULL, NULL, 101678),
(101679, '3.10.120.10-FF-000029', NULL, 'AGAP011823-PA', 87, NULL, NULL, 101679),
(101680, '1.10.150.60-FF-000025', NULL, 'Arid/bright DNA binding domain protein', 110, NULL, NULL, 101680),
(101681, '3.30.1490.190-FF-000012', NULL, 'Ferric uptake regulator family protein', 50, NULL, NULL, 101681),
(101682, '1.20.58.390-FF-000120', NULL, '5-hydroxytryptamine receptor 3A', 104, NULL, NULL, 101682),
(101683, '1.10.730.20-FF-000018', NULL, 'Uncharacterized protein', 315, NULL, NULL, 101683),
(101684, '3.40.50.300-FF-000520', NULL, 'probable ATP-dependent RNA helicase DDX23', 189, NULL, NULL, 101684),
(101685, '3.10.110.10-FF-000287', NULL, 'Ubiquitin-conjugating enzyme E2 G1', 113, NULL, NULL, 101685),
(101686, '1.10.10.10-FF-001865', NULL, 'Mu phage transposase OrfA TnpA_MuSo2', 67, NULL, NULL, 101686),
(101687, '3.90.190.10-FF-000257', NULL, 'Map kinase phosphatase', 174, NULL, NULL, 101687),
(101688, '1.10.8.10-FF-000364', NULL, 'Uncharacterized protein', 56, NULL, NULL, 101688),
(101689, '2.30.230.10-FF-000008', NULL, 'Vitellogenin-like Protein', 293, NULL, NULL, 101689),
(101690, '1.10.8.10-FF-000021', NULL, 'DCN1-like protein', 54, NULL, NULL, 101690),
(101691, '1.10.30.10-FF-000124', NULL, 'Uncharacterized protein', 55, NULL, NULL, 101691),
(101692, '3.40.50.2000-FF-000203', NULL, 'UDP-glucuronosyltransferase', 184, NULL, NULL, 101692),
(101693, '1.20.920.20-FF-000003', NULL, 'Dynein axonemal heavy chain 17', 346, NULL, NULL, 101693),
(101694, '3.80.10.10-FF-004359', NULL, 'Uncharacterized protein', 176, NULL, NULL, 101694),
(101695, '3.30.60.30-FF-000216', NULL, 'Predicted protein', 61, NULL, NULL, 101695),
(101696, '2.60.40.60-FF-000815', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 2', 46, NULL, NULL, 101696),
(101697, '3.30.300.30-FF-000123', NULL, 'Uncharacterized protein', 77, NULL, NULL, 101697),
(101698, '3.40.50.1010-FF-000119', NULL, 'Family with sequence similarity 120B', 206, NULL, NULL, 101698),
(101699, '3.40.50.300-FF-005854', NULL, 'Uncharacterized protein', 78, NULL, NULL, 101699),
(101700, '2.10.25.10-FF-001616', NULL, 'Uncharacterized protein', 84, NULL, NULL, 101700),
(101701, '3.40.50.11260-FF-000012', NULL, 'Heat shock protein 90, putative', 90, NULL, NULL, 101701),
(101702, '1.20.1310.10-FF-000138', NULL, NULL, 114, NULL, NULL, 101702),
(101703, '3.40.50.880-FF-000216', NULL, 'Glutamine amidotransferase class-I', 179, NULL, NULL, 101703),
(101704, '1.25.40.10-FF-004532', NULL, 'Uncharacterized protein', 60, NULL, NULL, 101704),
(101705, '3.40.50.300-FF-003954', NULL, 'Protein serine/threonine kinase PrkA', 148, NULL, NULL, 101705),
(101706, '1.20.144.10-FF-000056', NULL, 'AGAP001941-PA', 227, NULL, NULL, 101706),
(101707, '3.30.160.60-FF-000570', NULL, 'Spalt like transcription factor 3', 29, NULL, NULL, 101707),
(101708, '1.10.510.10-FF-000477', NULL, 'Receptor protein kinase CRINKLY4', 203, NULL, NULL, 101708),
(101709, '3.30.505.10-FF-000093', NULL, 'Tyrosine-protein kinase', 70, NULL, NULL, 101709),
(101710, '3.30.200.20-FF-002327', NULL, 'Uncharacterized protein', 75, NULL, NULL, 101710),
(101711, '1.20.58.630-FF-000001', NULL, 'Diaphanous related formin 1', 105, NULL, NULL, 101711),
(101712, '3.40.30.10-FF-001153', NULL, 'Glutathione S-transferase, putative', 33, NULL, NULL, 101712),
(101713, '3.30.160.60-FF-004965', NULL, NULL, 68, NULL, NULL, 101713),
(101714, '3.40.1170.10-FF-000036', NULL, 'DNA mismatch repair protein', 121, NULL, NULL, 101714),
(101715, '1.25.40.450-FF-000011', NULL, 'Uncharacterized protein', 154, NULL, NULL, 101715),
(101716, '4.10.400.10-FF-000305', NULL, 'Uncharacterized protein', 40, NULL, NULL, 101716),
(101717, '1.10.510.10-FF-002163', NULL, NULL, 141, NULL, NULL, 101717);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(101718, '3.30.70.330-FF-001619', NULL, NULL, 88, NULL, NULL, 101718),
(101719, '1.20.1070.10-FF-002108', NULL, 'Uncharacterized protein', 137, NULL, NULL, 101719),
(101720, '2.40.155.10-FF-000005', NULL, 'NIDogen (Basement membrane protein)', 250, NULL, NULL, 101720),
(101721, '3.30.1360.120-FF-000103', NULL, 'Glr1472 protein', 170, NULL, NULL, 101721),
(101722, '1.25.40.10-FF-005021', NULL, 'Uncharacterized protein', 102, NULL, NULL, 101722),
(101723, '1.10.510.10-FF-001887', NULL, 'Uncharacterized protein', 198, NULL, NULL, 101723),
(101724, '1.10.600.10-FF-000012', NULL, 'Squalene synthase 1', 337, NULL, NULL, 101724),
(101725, '2.60.40.1170-FF-000096', NULL, NULL, 133, NULL, NULL, 101725),
(101726, '3.40.30.10-FF-000208', NULL, 'glutathione S-transferase 1', 76, NULL, NULL, 101726),
(101727, '3.10.100.10-FF-000146', NULL, 'Uncharacterized protein', 129, NULL, NULL, 101727),
(101728, '2.30.39.10-FF-000079', NULL, 'Serine protease inhibitor 27A', 128, NULL, NULL, 101728),
(101729, '3.90.280.10-FF-000005', NULL, 'Phage kinase inhibitor', 164, NULL, NULL, 101729),
(101730, '1.20.1060.10-FF-000028', NULL, 'DNA polymerase theta-like Protein', 97, NULL, NULL, 101730),
(101731, '1.10.441.10-FF-000001', NULL, 'Mannose-6-phosphate isomerase', 130, NULL, NULL, 101731),
(101732, '2.130.10.10-FF-002594', NULL, 'F-box/WD repeat-containing protein 12', 359, NULL, NULL, 101732),
(101733, '1.10.510.10-FF-000701', NULL, 'Tyrosine-protein kinase receptor', 206, NULL, NULL, 101733),
(101734, '1.10.287.370-FF-000076', NULL, 'Uncharacterized protein', 136, NULL, NULL, 101734),
(101735, '2.30.30.100-FF-000035', NULL, 'U6 snRNA-associated Sm-like protein LSm8', 92, NULL, NULL, 101735),
(101736, '3.40.120.10-FF-000096', NULL, 'Phosphoacetylglucosamine mutase', 61, NULL, NULL, 101736),
(101737, '3.30.160.60-FF-005241', NULL, NULL, 50, NULL, NULL, 101737),
(101738, '3.30.70.20-FF-000141', NULL, NULL, 81, NULL, NULL, 101738),
(101739, '3.10.100.10-FF-000359', NULL, NULL, 41, NULL, NULL, 101739),
(101740, '2.40.10.10-FF-000474', NULL, NULL, 101, NULL, NULL, 101740),
(101741, '4.10.520.10-FF-000011', NULL, 'Bacterial histone-like protein, putative', 96, NULL, NULL, 101741),
(101742, '3.40.190.10-FF-000611', NULL, 'ABC transporter substrate-binding protein', 131, NULL, NULL, 101742),
(101743, '3.90.440.10-FF-000007', NULL, 'Nitric oxide synthase oxygenase', 87, NULL, NULL, 101743),
(101744, '3.40.50.1000-FF-000572', NULL, NULL, 165, NULL, NULL, 101744),
(101745, '2.60.40.10-FF-006090', NULL, NULL, 123, NULL, NULL, 101745),
(101746, '3.40.50.720-FF-000859', NULL, 'Calcium-activated potassium channel subunit alpha-1', 143, NULL, NULL, 101746),
(101747, '2.115.10.20-FF-000002', NULL, 'Invertase 2', 322, NULL, NULL, 101747),
(101748, '3.90.70.10-FF-000563', NULL, 'Uncharacterized protein', 411, NULL, NULL, 101748),
(101749, '3.30.750.24-FF-000147', NULL, 'Uncharacterized protein', 140, NULL, NULL, 101749),
(101750, '3.30.720.10-FF-000008', NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', 83, NULL, NULL, 101750),
(101751, '2.60.40.10-FF-003004', NULL, 'AGAP003656-PC', 80, NULL, NULL, 101751),
(101752, '3.40.50.300-FF-002318', NULL, 'ADP-ribosylation factor, putative', 195, NULL, NULL, 101752),
(101753, '3.30.1780.10-FF-000017', NULL, 'YALI0C02343p', 126, NULL, NULL, 101753),
(101754, '1.25.40.20-FF-001207', NULL, 'Uncharacterized protein', 124, NULL, NULL, 101754),
(101755, '3.30.420.40-FF-000079', NULL, 'ROK family transcriptional regulator', 169, NULL, NULL, 101755),
(101756, '3.90.550.10-FF-000448', NULL, 'Uncharacterized protein', 238, NULL, NULL, 101756),
(101757, '2.60.120.650-FF-000182', NULL, 'Uncharacterized protein', 102, NULL, NULL, 101757),
(101758, '3.30.30.30-FF-000052', NULL, 'Heat shock 70 kDa protein 14', 54, NULL, NULL, 101758),
(101759, '3.60.10.10-FF-000358', NULL, 'Uncharacterized protein', 141, NULL, NULL, 101759),
(101760, '1.20.1070.10-FF-001720', NULL, 'Melanin-concentrating hormone receptor 2', 100, NULL, NULL, 101760),
(101761, '2.60.120.590-FF-000040', NULL, 'Alpha-ketoglutarate-dependent dioxygenase alkB', 217, NULL, NULL, 101761);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(101762, '3.30.70.330-FF-000097', NULL, 'U2 snRNP auxiliary factor large subunit', 104, NULL, NULL, 101762),
(101763, '2.60.40.10-FF-002386', NULL, 'Muscle M-line assembly protein unc-89', 96, NULL, NULL, 101763),
(101764, '3.30.700.10-FF-000013', NULL, 'MSHA minor pilin protein MshB', 146, NULL, NULL, 101764),
(101765, '3.40.50.10110-FF-000004', NULL, 'DNA polymerase III, chi subunit', 146, NULL, NULL, 101765),
(101766, '3.30.160.60-FF-001879', NULL, 'General transcription factor IIIA', 49, NULL, NULL, 101766),
(101767, '3.30.830.10-FF-000101', NULL, 'Zn-dependent peptidase, putative', 194, NULL, NULL, 101767),
(101768, '3.40.50.300-FF-005511', NULL, 'U3 small nucleolar RNA-associated protein 25', 158, NULL, NULL, 101768),
(101769, '3.10.180.20-FF-000007', NULL, NULL, 49, NULL, NULL, 101769),
(101770, '3.20.20.70-FF-000283', NULL, 'Isopentenyl-diphosphate delta-isomerase', 350, NULL, NULL, 101770),
(101771, '2.40.50.140-FF-000543', NULL, 'Replication factor A', 102, NULL, NULL, 101771),
(101772, '3.30.160.60-FF-005584', NULL, NULL, 22, NULL, NULL, 101772),
(101773, '3.40.50.620-FF-000610', NULL, 'Glutaminyl-tRNA synthetase', 231, NULL, NULL, 101773),
(101774, '3.90.1420.10-FF-000044', NULL, 'Uncharacterized protein', 159, NULL, NULL, 101774),
(101775, '1.25.10.10-FF-000073', NULL, 'Splicing factor 3b, subunit 1', 336, NULL, NULL, 101775),
(101776, '3.30.300.10-FF-000016', NULL, 'S-adenosylmethionine synthase', 137, NULL, NULL, 101776),
(101777, '1.10.1410.10-FF-000018', NULL, 'Terminal uridylyltransferase cid1', 169, NULL, NULL, 101777),
(101778, '3.50.50.60-FF-000999', NULL, 'Uncharacterized protein', 140, NULL, NULL, 101778),
(101779, '3.30.70.1730-FF-000057', NULL, 'Uncharacterized protein', 92, NULL, NULL, 101779),
(101780, '3.30.360.10-FF-000025', NULL, 'Glucose-fructose oxidoreductase domain-containing protein 2', 237, NULL, NULL, 101780),
(101781, '2.40.50.100-FF-000110', NULL, 'Putative multidrug resistance protein', 59, NULL, NULL, 101781),
(101782, '3.40.50.300-FF-000177', NULL, 'Rho-related BTB domain-containing protein 2', 202, NULL, NULL, 101782),
(101783, '3.80.10.10-FF-003050', NULL, 'Predicted protein', 153, NULL, NULL, 101783),
(101784, '1.10.220.100-FF-000001', NULL, 'Enhancer of mRNA-decapping protein 4', 86, NULL, NULL, 101784),
(101785, '3.30.70.1660-FF-000013', NULL, 'Peptide chain release factor 1-like, mitochondrial', 162, NULL, NULL, 101785),
(101786, '2.30.29.30-FF-001085', NULL, 'NeCAP (NECAP) endocytosis associated protein homolog', 60, NULL, NULL, 101786),
(101787, '2.30.30.40-FF-000540', NULL, 'Tyrosine-protein kinase', 58, NULL, NULL, 101787),
(101788, '3.90.190.10-FF-000465', NULL, 'Phosphatidylinositol 3,4,5-trisphosphate 3-phosphatase ptn1', 189, NULL, NULL, 101788),
(101789, '1.25.40.10-FF-002250', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 122, NULL, NULL, 101789),
(101790, '2.60.40.10-FF-005033', NULL, NULL, 130, NULL, NULL, 101790),
(101791, '3.90.660.20-FF-000004', NULL, 'Protoporphyrinogen oxidase', 199, NULL, NULL, 101791),
(101792, '2.120.10.30-FF-000532', NULL, 'Uncharacterized protein', 135, NULL, NULL, 101792),
(101793, '3.30.1360.10-FF-000025', NULL, 'Probable DNA-directed RNA polymerases I and III subunit RPAC2', 115, NULL, NULL, 101793),
(101794, '2.130.10.10-FF-003448', NULL, 'Uncharacterized protein', 125, NULL, NULL, 101794),
(101795, '3.90.180.10-FF-000060', NULL, 'Crystallin zeta like 1', 346, NULL, NULL, 101795),
(101796, '3.90.226.10-FF-000291', NULL, 'Uncharacterized protein', 177, NULL, NULL, 101796),
(101797, '3.40.630.30-FF-000623', NULL, 'Acetyltransferase, GNAT family protein', 184, NULL, NULL, 101797),
(101798, '3.80.10.10-FF-000301', NULL, 'leucine-rich repeat neuronal protein 2', 250, NULL, NULL, 101798),
(101799, '3.10.20.90-FF-000480', NULL, 'Tubulin-binding cofactor B', 80, NULL, NULL, 101799),
(101800, '3.55.50.30-FF-000025', NULL, 'Fec operon regulator FecR', 77, NULL, NULL, 101800),
(101801, '2.60.200.20-FF-000155', NULL, 'Uncharacterized protein', 59, NULL, NULL, 101801),
(101802, '2.30.30.1020-FF-000024', NULL, 'GM25089', 101, NULL, NULL, 101802);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(101803, '2.130.10.10-FF-004067', NULL, 'Uncharacterized protein', 206, NULL, NULL, 101803),
(101804, '3.40.50.10440-FF-000002', NULL, 'Dihydroxyacetone kinase', 175, NULL, NULL, 101804),
(101805, '1.10.1520.10-FF-000111', NULL, 'Uncharacterized protein', 122, NULL, NULL, 101805),
(101806, '3.40.50.10260-FF-000021', NULL, 'Bifunctional NAD(P)H-hydrate repair enzyme Nnr', 209, NULL, NULL, 101806),
(101807, '1.10.238.10-FF-000664', NULL, 'Calmodulin, putative', 86, NULL, NULL, 101807),
(101808, '3.40.50.300-FF-001133', NULL, 'UMP-CMP kinase 2, mitochondrial', 200, NULL, NULL, 101808),
(101809, '1.10.1580.10-FF-000019', NULL, 'Nucleolar GTP-binding protein 2', 103, NULL, NULL, 101809),
(101810, '1.10.840.10-FF-000018', NULL, 'Rap guanine nucleotide exchange factor 5', 191, NULL, NULL, 101810),
(101811, '3.90.70.10-FF-000220', NULL, 'Ubiquitin carboxyl-terminal hydrolase cyk-3', 221, NULL, NULL, 101811),
(101812, '3.40.50.300-FF-006708', NULL, 'Uncharacterized protein', 76, NULL, NULL, 101812),
(101813, '2.60.120.970-FF-000058', NULL, 'Uncharacterized protein', 90, NULL, NULL, 101813),
(101814, '2.120.10.80-FF-000052', NULL, 'Multiple epidermal growth factor-like domains 8', 133, NULL, NULL, 101814),
(101815, '3.30.40.10-FF-000226', NULL, 'E3 ubiquitin ligase BIG BROTHER', 84, NULL, NULL, 101815),
(101816, '3.50.50.60-FF-000095', NULL, 'apoptosis-inducing factor 1, mitochondrial isoform X2', 176, NULL, NULL, 101816),
(101817, '2.170.150.10-FF-000003', NULL, 'Translationally-controlled tumor protein homolog', 168, NULL, NULL, 101817),
(101818, '3.40.50.150-FF-000222', NULL, 'Ribosomal RNA small subunit methyltransferase A', 192, NULL, NULL, 101818),
(101819, '1.20.1060.20-FF-000014', NULL, 'Structural maintenance of chromosomes protein', 93, NULL, NULL, 101819),
(101820, '1.10.3130.10-FF-000003', NULL, 'Serine acetyltransferase', 63, NULL, NULL, 101820),
(101821, '3.40.50.1000-FF-000004', NULL, 'Sodium/potassium-transporting ATPase subunit alpha', 174, NULL, NULL, 101821),
(101822, '1.20.960.40-FF-000005', NULL, 'Uncharacterized protein', 78, NULL, NULL, 101822),
(101823, '3.40.50.720-FF-000865', NULL, 'NEDD8-activating enzyme E1 catalytic subunit', 238, NULL, NULL, 101823),
(101824, '1.10.8.60-FF-000463', NULL, 'Replication-associated recombination protein A', 75, NULL, NULL, 101824),
(101825, '2.40.30.270-FF-000022', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', 54, NULL, NULL, 101825),
(101826, '3.90.740.10-FF-000041', NULL, 'Isoleucine--tRNA ligase', 197, NULL, NULL, 101826),
(101827, '3.30.70.1990-FF-000005', NULL, NULL, 78, NULL, NULL, 101827),
(101828, '2.170.270.10-FF-000051', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-9 specific SUVH6', 291, NULL, NULL, 101828),
(101829, '3.40.50.1820-FF-001317', NULL, 'Uncharacterized protein', 261, NULL, NULL, 101829),
(101830, '3.80.10.10-FF-001493', NULL, 'Phytosulfokine receptor 1', 246, NULL, NULL, 101830),
(101831, '3.40.50.280-FF-000002', NULL, 'Methylmalonyl-CoA mutase, mitochondrial', 146, NULL, NULL, 101831),
(101832, '3.80.10.10-FF-002431', NULL, 'Uncharacterized protein', 155, NULL, NULL, 101832),
(101833, '1.10.220.160-FF-000019', NULL, NULL, 86, NULL, NULL, 101833),
(101834, '2.130.10.10-FF-004168', NULL, 'Predicted protein', 169, NULL, NULL, 101834),
(101835, '3.80.10.10-FF-000969', NULL, 'Leucine-rich repeat protein soc-2', 101, NULL, NULL, 101835),
(101836, '3.60.40.10-FF-000186', NULL, 'Protein Phosphatase, Mg2+/Mn2+ dependent', 374, NULL, NULL, 101836),
(101837, '1.25.40.10-FF-003447', NULL, 'Pentatricopeptide repeat-containing protein', 141, NULL, NULL, 101837),
(101838, '2.60.120.200-FF-000766', NULL, 'Perlecan', 68, NULL, NULL, 101838),
(101839, '2.60.40.2030-FF-000039', NULL, 'Adhesion G protein-coupled receptor V1', 122, NULL, NULL, 101839),
(101840, '3.40.30.10-FF-001265', NULL, 'Predicted protein', 87, NULL, NULL, 101840),
(101841, '3.80.10.10-FF-003954', NULL, 'Uncharacterized protein', 64, NULL, NULL, 101841),
(101842, '1.10.1070.11-FF-000015', NULL, 'Serine/threonine-protein kinase ATM', 190, NULL, NULL, 101842);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(101843, '3.30.870.10-FF-000098', NULL, 'Uncharacterized protein', 171, NULL, NULL, 101843),
(101844, '1.10.472.10-FF-000584', NULL, 'Uncharacterized protein', 42, NULL, NULL, 101844),
(101845, '3.40.50.10810-FF-000231', NULL, 'Uncharacterized protein', 254, NULL, NULL, 101845),
(101846, '1.10.287.110-FF-000138', NULL, 'DNAJ heat shock family protein', 114, NULL, NULL, 101846),
(101847, '1.10.620.20-FF-000016', NULL, 'Phenol hydroxylase', 331, NULL, NULL, 101847),
(101848, '2.130.10.10-FF-005578', NULL, 'Vacuolar protein sorting/targeting protein 10', 207, NULL, NULL, 101848),
(101849, '4.10.400.10-FF-000176', NULL, 'CG32637-PA protein', 43, NULL, NULL, 101849),
(101850, '3.40.50.150-FF-001846', NULL, NULL, 45, NULL, NULL, 101850),
(101851, '2.40.10.10-FF-000131', NULL, 'Protease Do-like 9', 107, NULL, NULL, 101851),
(101852, '3.30.890.10-FF-000009', NULL, 'Methyl-CpG binding domain protein 4', 97, NULL, NULL, 101852),
(101853, '1.10.510.10-FF-001202', NULL, 'Kinase suppressor of ras 1', 95, NULL, NULL, 101853),
(101854, '1.10.420.10-FF-000026', NULL, 'Catalase/peroxidase', 112, NULL, NULL, 101854),
(101855, '1.20.1110.10-FF-000241', NULL, NULL, 146, NULL, NULL, 101855),
(101856, '1.25.40.10-FF-002727', NULL, 'Coatomer subunit epsilon', 282, NULL, NULL, 101856),
(101857, '3.30.70.330-FF-000310', NULL, 'RNA recognition water-stress protein1', 122, NULL, NULL, 101857),
(101858, '2.60.40.10-FF-004527', NULL, NULL, 89, NULL, NULL, 101858),
(101859, '2.30.42.10-FF-000452', NULL, NULL, 104, NULL, NULL, 101859),
(101860, '2.60.40.10-FF-003796', NULL, NULL, 96, NULL, NULL, 101860),
(101861, '3.30.160.60-FF-003116', NULL, NULL, 28, NULL, NULL, 101861),
(101862, '1.10.565.10-FF-000064', NULL, 'Coup-like 2 transcription factor', 212, NULL, NULL, 101862),
(101863, '3.30.1010.10-FF-000050', NULL, 'Uncharacterized protein', 148, NULL, NULL, 101863),
(101864, '1.20.940.10-FF-000001', NULL, 'Protein transport protein Sec31A isoform A', 108, NULL, NULL, 101864),
(101865, '1.10.3210.10-FF-000043', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 202, NULL, NULL, 101865),
(101866, '2.130.10.10-FF-005005', NULL, 'Uncharacterized protein', 56, NULL, NULL, 101866),
(101867, '3.10.250.10-FF-000134', NULL, NULL, 70, NULL, NULL, 101867),
(101868, '1.10.287.110-FF-000470', NULL, 'DNaJ domain (Prokaryotic heat shock protein)', 67, NULL, NULL, 101868),
(101869, '1.10.437.10-FF-000019', NULL, 'Apoptosis facilitator Bcl-2-like protein 14', 154, NULL, NULL, 101869),
(101870, '3.30.160.60-FF-000469', NULL, 'Zinc finger protein 423', 44, NULL, NULL, 101870),
(101871, '2.30.30.40-FF-000332', NULL, 'Caspase recruitment domain family, member 11', 121, NULL, NULL, 101871),
(101872, '2.60.40.10-FF-002178', NULL, 'Mesocentin', 83, NULL, NULL, 101872),
(101873, '3.30.200.20-FF-001821', NULL, 'AGAP006872-PA', 57, NULL, NULL, 101873),
(101874, '3.40.50.300-FF-003162', NULL, 'EMB1135', 200, NULL, NULL, 101874),
(101875, '1.10.10.60-FF-000211', NULL, 'Homeobox and leucine zipper protein Homez', 65, NULL, NULL, 101875),
(101876, '1.20.1070.10-FF-000310', NULL, '5-hydroxytryptamine receptor 2B', 120, NULL, NULL, 101876),
(101877, '3.30.1560.10-FF-000006', NULL, 'Uncharacterized protein', 104, NULL, NULL, 101877),
(101878, '1.25.10.10-FF-000281', NULL, 'Coatomer subunit gamma', 143, NULL, NULL, 101878),
(101879, '2.60.40.60-FF-000366', NULL, 'Proto-oncogene tyrosine-protein kinase receptor Ret', 116, NULL, NULL, 101879),
(101880, '3.30.160.270-FF-000003', NULL, '2-isopropylmalate synthase', 106, NULL, NULL, 101880),
(101881, '2.130.10.10-FF-002251', NULL, 'Nuclear pore complex protein 14', 406, NULL, NULL, 101881),
(101882, '3.40.50.300-FF-003050', NULL, 'AAA protein', 140, NULL, NULL, 101882),
(101883, '1.10.400.10-FF-000013', NULL, 'Extra-large guanine nucleotide-binding protein 2', 120, NULL, NULL, 101883),
(101884, '2.130.10.130-FF-000061', NULL, NULL, 85, NULL, NULL, 101884),
(101885, '3.40.190.10-FF-000162', NULL, 'Amino acid ABC transporter', 100, NULL, NULL, 101885),
(101886, '1.20.1250.20-FF-001597', NULL, 'YALI0A07447p', 261, NULL, NULL, 101886);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(101887, '1.10.472.10-FF-000483', NULL, 'Uncharacterized protein', 159, NULL, NULL, 101887),
(101888, '2.40.50.140-FF-001263', NULL, NULL, 64, NULL, NULL, 101888),
(101889, '3.90.480.10-FF-000004', NULL, 'Sulfite reductase hemoprotein beta component (CysI)', 146, NULL, NULL, 101889),
(101890, '3.80.10.10-FF-001711', NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', 92, NULL, NULL, 101890),
(101891, '1.20.142.10-FF-000006', NULL, 'Poly [ADP-ribose] polymerase', 146, NULL, NULL, 101891),
(101892, '2.60.40.10-FF-003690', NULL, NULL, 90, NULL, NULL, 101892),
(101893, '3.40.50.720-FF-000067', NULL, 'Malic enzyme', 287, NULL, NULL, 101893),
(101894, '3.30.1680.10-FF-000072', NULL, 'Plexin C1', 30, NULL, NULL, 101894),
(101895, '2.40.37.10-FF-000052', NULL, 'Uncharacterized protein', 137, NULL, NULL, 101895),
(101896, '3.30.230.70-FF-000112', NULL, 'Predicted protein', 258, NULL, NULL, 101896),
(101897, '3.30.565.10-FF-000422', NULL, 'Histidine kinase sensor protein', 158, NULL, NULL, 101897),
(101898, '3.40.50.2300-FF-000304', NULL, 'Two-component system response regulator MprA', 83, NULL, NULL, 101898),
(101899, '2.40.50.40-FF-000024', NULL, 'C-C motif chemokine 21', 79, NULL, NULL, 101899),
(101900, '3.90.79.10-FF-000077', NULL, 'ADP-ribose pyrophosphatase, NudF', 175, NULL, NULL, 101900),
(101901, '3.30.540.10-FF-000011', NULL, 'Bisphosphate nucleotidase 1', 175, NULL, NULL, 101901),
(101902, '2.130.10.10-FF-003875', NULL, 'Uncharacterized protein', 280, NULL, NULL, 101902),
(101903, '2.40.70.10-FF-000140', NULL, 'Os01g0696800 protein', 186, NULL, NULL, 101903),
(101904, '3.40.50.300-FF-004674', NULL, 'GD13761', 140, NULL, NULL, 101904),
(101905, '1.10.579.10-FF-000017', NULL, 'CPD photolyase type II', 56, NULL, NULL, 101905),
(101906, '3.20.110.10-FF-000021', NULL, 'Alpha-mannosidase', 162, NULL, NULL, 101906),
(101907, '2.60.40.150-FF-000517', NULL, 'Uncharacterized protein', 123, NULL, NULL, 101907),
(101908, '3.40.50.300-FF-004786', NULL, 'Dynein heavy chain family protein', 321, NULL, NULL, 101908),
(101909, '1.10.20.10-FF-000270', NULL, NULL, 81, NULL, NULL, 101909),
(101910, '2.130.10.10-FF-000222', NULL, 'Bromodomain and WD repeat domain containing 3', 154, NULL, NULL, 101910),
(101911, '3.30.70.100-FF-000146', NULL, NULL, 70, NULL, NULL, 101911),
(101912, '3.30.1960.10-FF-000003', NULL, 'tRNA methyltransferase', 224, NULL, NULL, 101912),
(101913, '2.60.40.10-FF-002739', NULL, 'Filamin 2, putative', 86, NULL, NULL, 101913),
(101914, '2.60.210.10-FF-000080', NULL, NULL, 100, NULL, NULL, 101914),
(101915, '3.90.70.10-FF-000332', NULL, 'Cathepsin L1', 316, NULL, NULL, 101915),
(101916, '1.10.8.60-FF-000575', NULL, 'ATPase, AAA family protein', 56, NULL, NULL, 101916),
(101917, '1.25.40.420-FF-000013', NULL, 'germ cell-less protein-like 1 isoform X1', 77, NULL, NULL, 101917),
(101918, '3.40.47.10-FF-000275', NULL, NULL, 70, NULL, NULL, 101918),
(101919, '3.60.15.10-FF-000228', NULL, 'Uncharacterized protein', 341, NULL, NULL, 101919),
(101920, '1.20.1280.50-FF-000236', NULL, 'F-box/LRR-repeat protein, putative', 40, NULL, NULL, 101920),
(101921, '3.30.540.30-FF-000017', NULL, 'Dipeptidyl peptidase 3', 65, NULL, NULL, 101921),
(101922, '1.20.1250.20-FF-001709', NULL, 'Uncharacterized protein', 98, NULL, NULL, 101922),
(101923, '3.40.50.720-FF-002107', NULL, 'Uncharacterized protein', 123, NULL, NULL, 101923),
(101924, '1.10.1520.10-FF-000010', NULL, '39S ribosomal protein L44, mitochondrial', 131, NULL, NULL, 101924),
(101925, '3.20.20.80-FF-000061', NULL, '4F2 cell-surface antigen heavy chain', 331, NULL, NULL, 101925),
(101926, '1.10.510.10-FF-004304', NULL, NULL, 294, NULL, NULL, 101926),
(101927, '3.40.630.30-FF-000522', NULL, 'Uncharacterized protein', 119, NULL, NULL, 101927),
(101928, '3.40.50.300-FF-008384', NULL, 'Uncharacterized protein', 206, NULL, NULL, 101928),
(101929, '3.60.21.10-FF-000164', NULL, 'Acid sphingomyelin phosphodiesterase, putative', 276, NULL, NULL, 101929),
(101930, '3.40.640.10-FF-000005', NULL, 'Glycine dehydrogenase (decarboxylating), mitochondrial', 261, NULL, NULL, 101930);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(101931, '1.20.58.70-FF-000037', NULL, 'Putative QA-SNARE protein', 225, NULL, NULL, 101931),
(101932, '1.10.10.60-FF-000666', NULL, 'HD-ZIP IV family of homeobox-leucine zipper protein with lipid-binding START domain-containing protein', 81, NULL, NULL, 101932),
(101933, '3.50.50.60-FF-000331', NULL, 'FAD/NAD(P)-binding domain-containing protein', 384, NULL, NULL, 101933),
(101934, '2.60.200.10-FF-000034', NULL, 'Interferon regulatory factor like protein', 191, NULL, NULL, 101934),
(101935, '1.10.510.10-FF-002394', NULL, NULL, 234, NULL, NULL, 101935),
(101936, '3.30.450.20-FF-000120', NULL, 'PAS domain S-box protein', 128, NULL, NULL, 101936),
(101937, '3.40.50.1240-FF-000172', NULL, NULL, 240, NULL, NULL, 101937),
(101938, '3.60.21.60-FF-000033', NULL, 'Uncharacterized protein', 235, NULL, NULL, 101938),
(101939, '1.50.40.10-FF-000286', NULL, 'AT13149p', 148, NULL, NULL, 101939),
(101940, '2.60.40.10-FF-003908', NULL, NULL, 127, NULL, NULL, 101940),
(101941, '2.10.220.10-FF-000164', NULL, 'Proprotein convertase subtilisin/kexin type 5a', 95, NULL, NULL, 101941),
(101942, '2.60.120.330-FF-000092', NULL, 'Os02g0320800 protein', 304, NULL, NULL, 101942),
(101943, '1.20.5.370-FF-000002', NULL, 'Myosin heavy chain', 45, NULL, NULL, 101943),
(101944, '3.30.160.60-FF-002711', NULL, 'Zinc finger protein 16', 30, NULL, NULL, 101944),
(101945, '1.10.510.10-FF-003231', NULL, NULL, 126, NULL, NULL, 101945),
(101946, '1.10.8.720-FF-000076', NULL, 'Uncharacterized protein', 106, NULL, NULL, 101946),
(101947, '1.20.1420.30-FF-000006', NULL, 'sodium/potassium/calcium exchanger 4 isoform X1', 133, NULL, NULL, 101947),
(101948, '1.10.720.30-FF-000072', NULL, 'ATP-dependent DNA helicase II subunit 1', 49, NULL, NULL, 101948),
(101949, '3.30.830.10-FF-000090', NULL, 'Probable zinc protease PqqL', 209, NULL, NULL, 101949),
(101950, '1.10.510.10-FF-004428', NULL, NULL, 60, NULL, NULL, 101950),
(101951, '3.30.1120.30-FF-000030', NULL, 'Serine/threonine-protein kinase', 101, NULL, NULL, 101951),
(101952, '1.10.10.10-FF-000680', NULL, 'Rrf2 family transcriptional regulator', 143, NULL, NULL, 101952),
(101953, '1.10.238.10-FF-000456', NULL, 'Calcium-binding mitochondrial carrier protein SCaMC-2 isoform A', 96, NULL, NULL, 101953),
(101954, '1.10.10.10-FF-000342', NULL, 'MarR family transcriptional regulator', 134, NULL, NULL, 101954),
(101955, '3.40.800.10-FF-000007', NULL, 'Arginase 1, mitochondrial', 288, NULL, NULL, 101955),
(101956, '3.30.160.60-FF-002835', NULL, 'zinc finger protein 384 isoform X2', 26, NULL, NULL, 101956),
(101957, '2.130.10.10-FF-003780', NULL, 'Uncharacterized protein', 316, NULL, NULL, 101957),
(101958, '3.90.780.10-FF-000049', NULL, 'Uncharacterized protein', 125, NULL, NULL, 101958),
(101959, '3.40.50.10190-FF-000236', NULL, 'Uncharacterized protein', 77, NULL, NULL, 101959),
(101960, '1.20.120.1910-FF-000043', NULL, 'Uncharacterized protein', 183, NULL, NULL, 101960),
(101961, '3.30.200.20-FF-000062', NULL, 'PHO system negative regulator', 85, NULL, NULL, 101961),
(101962, '3.30.260.10-FF-000080', NULL, NULL, 43, NULL, NULL, 101962),
(101963, '1.25.40.10-FF-003346', NULL, 'Pentatricopeptide repeat-containing protein At5g16860', 86, NULL, NULL, 101963),
(101964, '1.20.1080.10-FF-000024', NULL, 'MIP aquaporin (Eurofung)', 268, NULL, NULL, 101964),
(101965, '1.10.1760.10-FF-000005', NULL, 'Actin-related protein 2/3 complex subunit 3', 170, NULL, NULL, 101965),
(101966, '3.40.50.300-FF-008260', NULL, 'Uncharacterized protein', 48, NULL, NULL, 101966),
(101967, '3.30.450.20-FF-000693', NULL, 'Diguanylate cyclase with PAS sensory domain', 134, NULL, NULL, 101967),
(101968, '3.30.40.10-FF-001755', NULL, 'Ubiquitinyl hydrolase 1', 94, NULL, NULL, 101968),
(101969, '1.25.40.570-FF-000030', NULL, 'COP9 signalosome complex subunit 1, putative', 338, NULL, NULL, 101969),
(101970, '3.40.50.1440-FF-000113', NULL, 'FtsZ', 66, NULL, NULL, 101970),
(101971, '3.40.50.720-FF-000410', NULL, 'Peroxisomal multifunctional beta-oxidation protein', 296, NULL, NULL, 101971),
(101972, '2.60.120.380-FF-000078', NULL, 'Uncharacterized protein', 80, NULL, NULL, 101972); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(101973, '2.70.98.10-FF-000017', NULL, 'Glycoside hydrolase family 2 protein', 306, NULL, NULL, 101973),
(101974, '2.70.170.10-FF-000219', NULL, 'Protein CBR-PBO-6', 116, NULL, NULL, 101974),
(101975, '1.25.40.20-FF-000235', NULL, 'E3 ubiquitin-protein ligase MIB1 isoform X4', 91, NULL, NULL, 101975),
(101976, '2.30.22.10-FF-000001', NULL, 'Protein GrpE', 56, NULL, NULL, 101976),
(101977, '1.20.120.350-FF-000107', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 112, NULL, NULL, 101977),
(101978, '3.40.50.12350-FF-000007', NULL, 'Eyes absent homolog', 273, NULL, NULL, 101978),
(101979, '2.130.10.10-FF-004960', NULL, 'Uncharacterized protein', 90, NULL, NULL, 101979),
(101980, '3.30.1650.10-FF-000002', NULL, 'Carbon monoxide dehydrogenase, alpha subunit', 177, NULL, NULL, 101980),
(101981, '1.10.630.10-FF-000536', NULL, 'Uncharacterized protein', 367, NULL, NULL, 101981),
(101982, '2.60.40.10-FF-002262', NULL, 'Hypothetical_protein_-_conserved', 111, NULL, NULL, 101982),
(101983, '2.30.42.10-FF-000014', NULL, 'Segment polarity protein dishevelled homolog DVL-3', 100, NULL, NULL, 101983),
(101984, '1.10.510.10-FF-000376', NULL, 'Tyrosine-protein kinase', 257, NULL, NULL, 101984),
(101985, '2.40.50.100-FF-000216', NULL, 'Glr1290 protein', 44, NULL, NULL, 101985),
(101986, '2.60.120.260-FF-000172', NULL, 'neurexin-4 isoform X2', 139, NULL, NULL, 101986),
(101987, '3.40.50.1460-FF-000119', NULL, 'Uncharacterized protein', 270, NULL, NULL, 101987),
(101988, '2.60.40.340-FF-000006', NULL, 'Dorsal isoform 1-B', 175, NULL, NULL, 101988),
(101989, '3.40.720.10-FF-000282', NULL, 'Putative phosphoethanolamine transferase HI_1005', 299, NULL, NULL, 101989),
(101990, '3.40.50.300-FF-007765', NULL, 'Si:ch211-247i17.1', 67, NULL, NULL, 101990),
(101991, '2.60.40.60-FF-001080', NULL, 'DE cadherin-like protein', 109, NULL, NULL, 101991),
(101992, '2.60.40.60-FF-000574', NULL, 'Predicted protein', 41, NULL, NULL, 101992),
(101993, '1.10.510.10-FF-000718', NULL, 'casein kinase I', 333, NULL, NULL, 101993),
(101994, '1.50.10.20-FF-000107', NULL, 'Uncharacterized protein', 436, NULL, NULL, 101994),
(101995, '3.30.450.40-FF-000002', NULL, 'IclR family transcriptional regulator', 162, NULL, NULL, 101995),
(101996, '1.25.40.10-FF-002621', NULL, 'Slr2048 protein', 115, NULL, NULL, 101996),
(101997, '1.10.8.80-FF-000002', NULL, 'Methanol dehydrogenase transcriptional regulator MoxR2', 107, NULL, NULL, 101997),
(101998, '2.40.50.40-FF-000125', NULL, 'Chromodomain protein, Y-like', 63, NULL, NULL, 101998),
(101999, '2.120.10.80-FF-000423', NULL, 'Predicted protein', 143, NULL, NULL, 101999),
(102000, '3.30.200.20-FF-001613', NULL, 'Protein kinase', 100, NULL, NULL, 102000),
(102001, '2.30.90.10-FF-000001', NULL, 'Pleiotrophin', 43, NULL, NULL, 102001),
(102002, '1.20.1070.10-FF-001254', NULL, 'AGAP013324-PA', 158, NULL, NULL, 102002),
(102003, '1.10.10.60-FF-000003', NULL, 'Iroquois-class homeobox protein IRX', 60, NULL, NULL, 102003),
(102004, '3.40.50.2300-FF-000512', NULL, 'Uncharacterized protein', 299, NULL, NULL, 102004),
(102005, '3.40.225.10-FF-000018', NULL, 'Class II aldolase', 240, NULL, NULL, 102005),
(102006, '1.25.10.10-FF-002097', NULL, 'Uncharacterized protein', 137, NULL, NULL, 102006),
(102007, '1.10.10.10-FF-000921', NULL, 'DNA-binding response regulator VicR', 100, NULL, NULL, 102007),
(102008, '2.30.39.10-FF-000107', NULL, 'Uncharacterized protein', 150, NULL, NULL, 102008),
(102009, '3.30.230.10-FF-000353', NULL, 'Predicted protein', 169, NULL, NULL, 102009),
(102010, '2.160.10.10-FF-000081', NULL, 'AGAP000082-PA', 127, NULL, NULL, 102010),
(102011, '2.30.180.10-FF-000122', NULL, 'Vacuolar membrane protein, putative', 268, NULL, NULL, 102011),
(102012, '1.10.472.130-FF-000067', NULL, 'Cytoplasmic dynein heavy chain, putative', 119, NULL, NULL, 102012),
(102013, '3.40.50.1980-FF-000022', NULL, 'Heme ABC transporter substrate-binding protein IsdE', 171, NULL, NULL, 102013),
(102014, '1.25.10.10-FF-001478', NULL, 'Armadillo/beta-catenin-like repeat, putative', 196, NULL, NULL, 102014);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(102015, '1.25.40.60-FF-000011', NULL, 'Vacuolar sorting protein', 127, NULL, NULL, 102015),
(102016, '1.20.1070.10-FF-000978', NULL, 'Vasopressin v1a recpetor, putative', 310, NULL, NULL, 102016),
(102017, '3.30.230.130-FF-000051', NULL, 'Anaphase-promoting complex subunit 2', 161, NULL, NULL, 102017),
(102018, '3.30.70.330-FF-002463', NULL, NULL, 82, NULL, NULL, 102018),
(102019, '1.20.1050.10-FF-000308', NULL, 'Uncharacterized protein', 17, NULL, NULL, 102019),
(102020, '3.40.1440.60-FF-000004', NULL, 'Primosomal protein N''', 111, NULL, NULL, 102020),
(102021, '3.40.50.300-FF-000975', NULL, 'DNA helicase', 181, NULL, NULL, 102021),
(102022, '3.50.50.60-FF-001157', NULL, 'Uncharacterized protein', 53, NULL, NULL, 102022),
(102023, '1.10.287.110-FF-000032', NULL, 'Translocation protein SEC63 homolog', 85, NULL, NULL, 102023),
(102024, '1.20.1250.20-FF-001698', NULL, 'Sucrose transporter, putative', 199, NULL, NULL, 102024),
(102025, '3.60.21.10-FF-000288', NULL, 'Serine/threonine-protein phosphatase', 159, NULL, NULL, 102025),
(102026, '3.30.360.20-FF-000017', NULL, NULL, 100, NULL, NULL, 102026),
(102027, '1.25.40.480-FF-000003', NULL, 'Fanconi anemia, complementation group E', 120, NULL, NULL, 102027),
(102028, '1.20.120.790-FF-000008', NULL, 'Chaperone protein HtpG', 133, NULL, NULL, 102028),
(102029, '1.20.120.1750-FF-000079', NULL, 'RBR-type E3 ubiquitin transferase', 121, NULL, NULL, 102029),
(102030, '3.40.190.10-FF-000370', NULL, 'Glutamate receptor', 107, NULL, NULL, 102030),
(102031, '1.10.630.10-FF-000295', NULL, 'Cytochrome P450', 329, NULL, NULL, 102031),
(102032, '3.30.160.60-FF-004853', NULL, NULL, 30, NULL, NULL, 102032),
(102033, '1.10.260.100-FF-000009', NULL, 'FAM10 family protein At4g22670-like', 56, NULL, NULL, 102033),
(102034, '1.10.533.10-FF-000153', NULL, 'Caspase-8', 97, NULL, NULL, 102034),
(102035, '2.30.42.10-FF-000115', NULL, 'Regulator of G-protein signaling 12', 82, NULL, NULL, 102035),
(102036, '3.40.50.300-FF-008176', NULL, 'Uncharacterized protein', 84, NULL, NULL, 102036),
(102037, '1.10.238.10-FF-000540', NULL, 'Serine/threonine-protein phosphatase with EF-hands', 169, NULL, NULL, 102037),
(102038, '1.10.287.2610-FF-000007', NULL, 'Uncharacterized protein', 58, NULL, NULL, 102038),
(102039, '3.30.497.10-FF-000168', NULL, 'Serpin peptidase inhibitor 26', 34, NULL, NULL, 102039),
(102040, '3.30.300.130-FF-000028', NULL, NULL, 76, NULL, NULL, 102040),
(102041, '2.130.10.10-FF-005909', NULL, 'Uncharacterized protein', 281, NULL, NULL, 102041),
(102042, '3.60.21.10-FF-000372', NULL, 'Uncharacterized protein', 110, NULL, NULL, 102042),
(102043, '2.130.10.10-FF-000014', NULL, 'Putative F-box-like/WD repeat-containing protein TBL1XR1', 363, NULL, NULL, 102043),
(102044, '1.25.40.20-FF-000578', NULL, 'Tyrosine-protein kinase', 163, NULL, NULL, 102044),
(102045, '3.30.160.60-FF-001430', NULL, 'Uncharacterized protein', 30, NULL, NULL, 102045),
(102046, '2.60.40.60-FF-000231', NULL, 'Cadherin related family member 3', 111, NULL, NULL, 102046),
(102047, '2.60.40.150-FF-000618', NULL, 'Uncharacterized protein', 166, NULL, NULL, 102047),
(102048, '3.80.10.10-FF-000065', NULL, 'F-box only protein 38 isoform X1', 303, NULL, NULL, 102048),
(102049, '1.10.510.10-FF-004512', NULL, NULL, 77, NULL, NULL, 102049),
(102050, '3.40.190.10-FF-000268', NULL, 'Transcriptional regulator', 84, NULL, NULL, 102050),
(102051, '2.60.120.260-FF-000413', NULL, 'Similar to calmodulin-like protein-putative secreted, membrane associated or paryphoplasmic Ca(2+)-binding protein', 144, NULL, NULL, 102051),
(102052, '3.30.300.30-FF-000011', NULL, 'Crotonobetaine/carnitine--CoA ligase', 97, NULL, NULL, 102052),
(102053, '3.30.1520.10-FF-000009', NULL, 'rho GTPase-activating protein 32 isoform X2', 120, NULL, NULL, 102053),
(102054, '3.30.70.80-FF-000035', NULL, 'Uncharacterized protein', 76, NULL, NULL, 102054),
(102055, '2.130.10.30-FF-000104', NULL, NULL, 207, NULL, NULL, 102055),
(102056, '2.60.40.1180-FF-000211', NULL, 'Cyclodextrin glucanotransferase', 85, NULL, NULL, 102056),
(102057, '3.30.2410.10-FF-000024', NULL, 'E3 ubiquitin-protein ligase hecw-1', 117, NULL, NULL, 102057);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(102058, '1.10.510.10-FF-002612', NULL, NULL, 140, NULL, NULL, 102058),
(102059, '1.20.1250.20-FF-002215', NULL, 'Uncharacterized protein', 136, NULL, NULL, 102059),
(102060, '3.40.630.10-FF-000067', NULL, 'Beta-Ala-Xaa dipeptidase', 255, NULL, NULL, 102060),
(102061, '1.10.220.10-FF-000027', NULL, 'Annexin', 78, NULL, NULL, 102061),
(102062, '3.80.10.10-FF-003499', NULL, 'UV-damaged DNA-binding protein', 188, NULL, NULL, 102062),
(102063, '1.20.120.330-FF-000017', NULL, 'Polarisome protein, putative', 130, NULL, NULL, 102063),
(102064, '1.10.150.80-FF-000014', NULL, 'ATP-dependent DNA helicase RecQ', 81, NULL, NULL, 102064),
(102065, '2.40.10.10-FF-000266', NULL, 'MIP04821p', 148, NULL, NULL, 102065),
(102066, '1.20.5.110-FF-000295', NULL, 'Uncharacterized protein', 90, NULL, NULL, 102066),
(102067, '2.40.20.10-FF-000081', NULL, 'Metalloendopeptidase', 94, NULL, NULL, 102067),
(102068, '1.20.120.310-FF-000011', NULL, 'Sulfhydryl oxidase', 149, NULL, NULL, 102068),
(102069, '3.40.50.920-FF-000026', NULL, 'Pyruvate-flavodoxin oxidoreductase', 166, NULL, NULL, 102069),
(102070, '2.60.40.10-FF-000362', NULL, 'Receptor-type tyrosine-protein phosphatase eta', 85, NULL, NULL, 102070),
(102071, '3.40.50.300-FF-000071', NULL, 'Cytoplasmic dynein heavy chain 1', 154, NULL, NULL, 102071),
(102072, '1.10.600.10-FF-000124', NULL, 'Uncharacterized protein', 101, NULL, NULL, 102072),
(102073, '2.40.30.10-FF-000031', NULL, 'Sulfate adenylyltransferase subunit 1', 105, NULL, NULL, 102073),
(102074, '3.30.40.10-FF-001963', NULL, 'Uncharacterized protein', 64, NULL, NULL, 102074),
(102075, '2.60.120.10-FF-000319', NULL, 'Cyclic nucleotide-binding domain containing protein, putative', 119, NULL, NULL, 102075),
(102076, '3.10.20.70-FF-000036', NULL, 'Glutamate--ammonia ligase', 92, NULL, NULL, 102076),
(102077, '3.30.200.20-FF-001158', NULL, 'Os01g0296000 protein', 96, NULL, NULL, 102077),
(102078, '1.10.4080.10-FF-000010', NULL, 'Adprhl2 protein, putative', 102, NULL, NULL, 102078),
(102079, '3.40.50.2000-FF-000192', NULL, 'Protein RfbU', 155, NULL, NULL, 102079),
(102080, '3.90.70.10-FF-000321', NULL, 'Ananain', 147, NULL, NULL, 102080),
(102081, '3.30.420.10-FF-000744', NULL, NULL, 127, NULL, NULL, 102081),
(102082, '3.90.1070.20-FF-000003', NULL, 'DNA-directed RNA polymerase subunit beta', 90, NULL, NULL, 102082),
(102083, '3.40.50.2300-FF-001029', NULL, NULL, 171, NULL, NULL, 102083),
(102084, '3.40.50.12780-FF-000018', NULL, 'Fatty acyl CoA synthetase 2', 438, NULL, NULL, 102084),
(102085, '1.20.1050.130-FF-000004', NULL, 'Bifunctional glutamate/proline--tRNA ligase', 173, NULL, NULL, 102085),
(102086, '1.10.10.60-FF-000907', NULL, NULL, 74, NULL, NULL, 102086),
(102087, '1.20.5.190-FF-000049', NULL, 'Igloo, isoform A', 75, NULL, NULL, 102087),
(102088, '3.30.420.40-FF-000287', NULL, 'Actin-related protein', 44, NULL, NULL, 102088),
(102089, '1.25.40.10-FF-002166', NULL, 'Pentatricopeptide (PPR) repeat-containing protein-like', 107, NULL, NULL, 102089),
(102090, '3.30.160.60-FF-004864', NULL, NULL, 35, NULL, NULL, 102090),
(102091, '3.30.70.100-FF-000157', NULL, NULL, 71, NULL, NULL, 102091),
(102092, '2.10.70.10-FF-000063', NULL, 'Sushi domain-containing protein 4', 59, NULL, NULL, 102092),
(102093, '3.40.50.720-FF-001820', NULL, 'Malic enzyme', 192, NULL, NULL, 102093),
(102094, '3.90.25.10-FF-000014', NULL, 'Bifunctional pinoresinol-lariciresinol reductase 1', 115, NULL, NULL, 102094),
(102095, '3.30.420.40-FF-000163', NULL, 'Heat shock protein (Eurofung)', 89, NULL, NULL, 102095),
(102096, '2.40.50.90-FF-000123', NULL, 'Succinoglycan biosynthesis protein', 121, NULL, NULL, 102096),
(102097, '3.30.160.60-FF-002599', NULL, 'Zinc finger protein 827', 78, NULL, NULL, 102097),
(102098, '2.130.10.10-FF-005786', NULL, 'Cell surface protein', 99, NULL, NULL, 102098),
(102099, '3.30.70.330-FF-003082', NULL, NULL, 111, NULL, NULL, 102099),
(102100, '1.20.120.720-FF-000027', NULL, 'Myosin F, putative', 133, NULL, NULL, 102100),
(102101, '3.30.160.60-FF-003892', NULL, NULL, 28, NULL, NULL, 102101),
(102102, '1.10.1450.10-FF-000015', NULL, 'Tetraspanin', 80, NULL, NULL, 102102);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(102103, '3.40.50.300-FF-005303', NULL, 'Uncharacterized protein', 170, NULL, NULL, 102103),
(102104, '1.10.10.10-FF-002023', NULL, 'Uncharacterized protein', 107, NULL, NULL, 102104),
(102105, '2.30.30.140-FF-000047', NULL, 'Staphylococcal nuclease domain-containing protein', 93, NULL, NULL, 102105),
(102106, '2.130.10.10-FF-000357', NULL, 'Cilia and flagella associated protein 57', 238, NULL, NULL, 102106),
(102107, '2.60.40.2240-FF-000001', NULL, 'acyl-coenzyme A thioesterase 4', 131, NULL, NULL, 102107),
(102108, '3.40.50.300-FF-002656', NULL, 'WD domain, G-beta repeat, putative', 124, NULL, NULL, 102108),
(102109, '2.60.40.1670-FF-000021', NULL, NULL, 64, NULL, NULL, 102109),
(102110, '2.60.40.10-FF-005696', NULL, NULL, 68, NULL, NULL, 102110),
(102111, '3.30.1540.10-FF-000011', NULL, 'Solute carrier family 45 member 2', 37, NULL, NULL, 102111),
(102112, '3.30.450.30-FF-000010', NULL, 'Profilin', 136, NULL, NULL, 102112),
(102113, '3.30.70.260-FF-000177', NULL, 'Os02g0478525 protein', 46, NULL, NULL, 102113),
(102114, '3.10.105.10-FF-000005', NULL, 'ABC transporter substrate-binding protein', 260, NULL, NULL, 102114),
(102115, '3.30.470.20-FF-000020', NULL, 'Probable multifunctional protein ADE2', 142, NULL, NULL, 102115),
(102116, '2.120.10.30-FF-000324', NULL, 'Glucose/sorbosone dehydrogenase-like lipoprotein', 345, NULL, NULL, 102116),
(102117, '1.20.1250.20-FF-000978', NULL, 'Solute carrier organic anion transporter family member', 215, NULL, NULL, 102117),
(102118, '1.10.510.10-FF-003332', NULL, NULL, 54, NULL, NULL, 102118),
(102119, '1.20.5.170-FF-000043', NULL, 'Basic leucine zipper transcriptional factor ATF-like', 63, NULL, NULL, 102119),
(102120, '3.40.50.410-FF-000210', NULL, 'ATP-dependent DNA helicase II subunit 1', 206, NULL, NULL, 102120),
(102121, '3.80.10.10-FF-001037', NULL, 'Leucine_Rich_repeat /CHAT_domain_containing_protein_-_putative', 160, NULL, NULL, 102121),
(102122, '3.40.50.720-FF-002208', NULL, 'Putative ketoreductase', 302, NULL, NULL, 102122),
(102123, '2.10.25.10-FF-001392', NULL, 'Uncharacterized protein', 70, NULL, NULL, 102123),
(102124, '3.60.130.10-FF-000041', NULL, 'Uncharacterized protein', 285, NULL, NULL, 102124),
(102125, '2.60.40.10-FF-000941', NULL, 'Terribly reduced optic lobes, isoform AN', 95, NULL, NULL, 102125),
(102126, '3.30.450.50-FF-000016', NULL, 'Vesicle transporter Sec22', 131, NULL, NULL, 102126),
(102127, '3.30.56.10-FF-000010', NULL, 'Phenylalanyl-tRNA synthetase subunit beta', 89, NULL, NULL, 102127),
(102128, '2.40.50.140-FF-000644', NULL, NULL, 102, NULL, NULL, 102128),
(102129, '3.80.10.10-FF-002330', NULL, 'Predicted protein', 130, NULL, NULL, 102129),
(102130, '3.40.50.300-FF-000632', NULL, 'Bifunctional adenosylcobalamin biosynthesis protein', 180, NULL, NULL, 102130),
(102131, '3.30.160.60-FF-006101', NULL, NULL, 16, NULL, NULL, 102131),
(102132, '3.20.20.100-FF-000161', NULL, 'Potassium voltage-gated channel, shaker-related subfamily, beta member 2 b', 223, NULL, NULL, 102132),
(102133, '3.30.70.330-FF-001957', NULL, NULL, 141, NULL, NULL, 102133),
(102134, '3.30.70.2630-FF-000006', NULL, 'Telomerase reverse transcriptase', 90, NULL, NULL, 102134),
(102135, '1.20.5.650-FF-000007', NULL, 'transcription factor IIIB 90 kDa subunit', 67, NULL, NULL, 102135),
(102136, '3.30.160.60-FF-005825', NULL, NULL, 57, NULL, NULL, 102136),
(102137, '3.30.160.60-FF-002256', NULL, 'Zinc finger protein 670', 43, NULL, NULL, 102137),
(102138, '1.10.8.60-FF-000255', NULL, 'Lon protease', 93, NULL, NULL, 102138),
(102139, '3.90.1750.10-FF-000024', NULL, 'E3 ubiquitin-protein ligase', 186, NULL, NULL, 102139),
(102140, '2.60.40.10-FF-001767', NULL, 'Erythropoietin receptor', 97, NULL, NULL, 102140),
(102141, '3.30.70.330-FF-001833', NULL, NULL, 184, NULL, NULL, 102141),
(102142, '1.10.238.10-FF-001170', NULL, 'Uncharacterized protein', 96, NULL, NULL, 102142),
(102143, '1.10.10.60-FF-000346', NULL, 'HTH-type transcriptional regulator ydeO', 111, NULL, NULL, 102143),
(102144, '2.160.20.10-FF-000249', NULL, 'Uncharacterized protein', 98, NULL, NULL, 102144);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(102145, '1.20.1560.10-FF-000061', NULL, 'ATP-binding cassette transporter YOR1', 336, NULL, NULL, 102145),
(102146, '2.10.110.10-FF-000274', NULL, 'LIM domain-containing protein B', 66, NULL, NULL, 102146),
(102147, '3.40.50.1820-FF-000699', NULL, 'Peptidase S10', 439, NULL, NULL, 102147),
(102148, '3.40.50.300-FF-006129', NULL, 'Protein Wnt', 60, NULL, NULL, 102148),
(102149, '3.30.740.10-FF-000010', NULL, 'Dynein light chain', 97, NULL, NULL, 102149),
(102150, '1.10.510.40-FF-000002', NULL, 'IucA/IucC family siderophore biosynthesis protein', 214, NULL, NULL, 102150),
(102151, '3.40.190.290-FF-000108', NULL, 'LysR family transcriptional regulator', 202, NULL, NULL, 102151),
(102152, '1.20.1250.20-FF-001254', NULL, 'Minor myo-inositol transporter IolF', 410, NULL, NULL, 102152),
(102153, '3.40.30.10-FF-000759', NULL, 'Ribosomal protein mRpS25, putative', 92, NULL, NULL, 102153),
(102154, '2.130.10.10-FF-000918', NULL, 'Nucleolar protein 10', 159, NULL, NULL, 102154),
(102155, '3.40.640.10-FF-000360', NULL, 'Methionine gamma-lyase, putative', 238, NULL, NULL, 102155),
(102156, '3.10.310.10-FF-000055', NULL, 'Uncharacterized protein', 153, NULL, NULL, 102156),
(102157, '3.30.410.40-FF-000005', NULL, '5-(hydroxymethyl)furfural oxidase', 180, NULL, NULL, 102157),
(102158, '1.10.8.270-FF-000019', NULL, 'TBC1 domain family member 13', 125, NULL, NULL, 102158),
(102159, '3.30.2040.10-FF-000001', NULL, 'D-glutamate cyclase, mitochondrial', 113, NULL, NULL, 102159),
(102160, '3.30.200.20-FF-001490', NULL, 'Putative serine/threonine protein kinase', 103, NULL, NULL, 102160),
(102161, '2.90.10.10-FF-000050', NULL, 'Putative receptor protein kinase ZmPK1', 129, NULL, NULL, 102161),
(102162, '1.25.40.10-FF-004066', NULL, 'Uncharacterized protein', 263, NULL, NULL, 102162),
(102163, '3.40.50.2300-FF-001361', NULL, NULL, 19, NULL, NULL, 102163),
(102164, '3.30.1640.10-FF-000075', NULL, 'DNA replication licensing factor MCM7', 95, NULL, NULL, 102164),
(102165, '2.170.270.10-FF-000152', NULL, 'Protein CBG24719', 176, NULL, NULL, 102165),
(102166, '3.20.20.190-FF-000047', NULL, 'Phosphoinositide phospholipase C', 254, NULL, NULL, 102166),
(102167, '1.25.10.10-FF-002658', NULL, 'Uncharacterized protein', 101, NULL, NULL, 102167),
(102168, '1.25.10.10-FF-000197', NULL, 'Ecm29 proteasome adaptor and scaffold', 517, NULL, NULL, 102168),
(102169, '1.20.1070.10-FF-000074', NULL, 'probable G-protein coupled receptor 173', 312, NULL, NULL, 102169),
(102170, '3.30.1120.120-FF-000005', NULL, 'Serine/threonine-protein kinase PLK4', 55, NULL, NULL, 102170),
(102171, '3.30.40.10-FF-001620', NULL, 'RBR-type E3 ubiquitin transferase', 86, NULL, NULL, 102171),
(102172, '3.40.190.80-FF-000019', NULL, 'Inositol-1-monophosphatase', 126, NULL, NULL, 102172),
(102173, '2.130.10.10-FF-002352', NULL, 'K7_Rpn14p', 184, NULL, NULL, 102173),
(102174, '1.20.5.630-FF-000001', NULL, 'Integrin beta', 42, NULL, NULL, 102174),
(102175, '3.60.15.10-FF-000122', NULL, 'Metallo-beta-lactamase domain containing protein', 213, NULL, NULL, 102175),
(102176, '1.20.5.4820-FF-000014', NULL, 'Class V myosin', 124, NULL, NULL, 102176),
(102177, '3.30.40.10-FF-000327', NULL, 'tripartite motif-containing protein 45', 48, NULL, NULL, 102177),
(102178, '3.40.50.10190-FF-000101', NULL, 'Microcephalin, isoform A', 96, NULL, NULL, 102178),
(102179, '3.80.10.10-FF-003156', NULL, 'Uncharacterized protein', 287, NULL, NULL, 102179),
(102180, '2.40.160.10-FF-000074', NULL, 'Uncharacterized protein', 291, NULL, NULL, 102180),
(102181, '3.30.160.60-FF-002155', NULL, 'Zinc finger protein ZIC 3', 29, NULL, NULL, 102181),
(102182, '2.40.50.140-FF-000195', NULL, 'Breast cancer type 2 susceptibility protein', 120, NULL, NULL, 102182),
(102183, '1.10.150.50-FF-000039', NULL, 'GA-binding protein alpha chain, putative', 92, NULL, NULL, 102183),
(102184, '1.10.530.10-FF-000023', NULL, 'Invertebrate-type lysozyme', 124, NULL, NULL, 102184),
(102185, '1.25.40.180-FF-000132', NULL, 'Predicted protein', 165, NULL, NULL, 102185),
(102186, '3.40.50.300-FF-007877', NULL, 'DNA helicase RecQ4', 203, NULL, NULL, 102186); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(102187, '1.25.40.20-FF-000347', NULL, 'Transcription factor, putative', 213, NULL, NULL, 102187),
(102188, '3.90.850.10-FF-000038', NULL, 'Hydratase', 257, NULL, NULL, 102188),
(102189, '3.40.50.300-FF-008389', NULL, 'Uncharacterized protein', 196, NULL, NULL, 102189),
(102190, '1.20.1250.20-FF-002210', NULL, 'Uncharacterized protein', 138, NULL, NULL, 102190),
(102191, '2.70.150.10-FF-000100', NULL, 'Calcium-transporting ATPase', 167, NULL, NULL, 102191),
(102192, '2.120.10.80-FF-000187', NULL, 'Leucine-zipper-like transcriptional regulator 1', 132, NULL, NULL, 102192),
(102193, '2.40.10.10-FF-000029', NULL, 'Genome polyprotein', 88, NULL, NULL, 102193),
(102194, '1.10.10.10-FF-000685', NULL, 'ArsR family transcriptional regulator', 105, NULL, NULL, 102194),
(102195, '3.10.20.90-FF-000250', NULL, 'Protein kinase activator Bem1', 85, NULL, NULL, 102195),
(102196, '1.25.40.10-FF-002486', NULL, 'Pentatricopeptide repeat-containing protein At2g18940, chloroplastic', 117, NULL, NULL, 102196),
(102197, '3.40.190.10-FF-000824', NULL, 'Excitatory amino acid transporter, putative', 126, NULL, NULL, 102197),
(102198, '1.20.1070.10-FF-002002', NULL, 'Predicted protein', 143, NULL, NULL, 102198),
(102199, '2.60.40.10-FF-000486', NULL, 'Tyrosine-protein kinase receptor', 88, NULL, NULL, 102199),
(102200, '3.50.50.60-FF-001376', NULL, 'Squalene monooxygenase', 36, NULL, NULL, 102200),
(102201, '3.20.20.140-FF-000274', NULL, 'Uncharacterized protein', 556, NULL, NULL, 102201),
(102202, '1.20.58.760-FF-000017', NULL, 'Putative ATP-dependent zinc metallopeptidase', 190, NULL, NULL, 102202),
(102203, '3.40.630.30-FF-000281', NULL, 'Acyl-CoA N-acyltransferases (NAT) superfamily protein', 171, NULL, NULL, 102203),
(102204, '3.90.550.50-FF-000218', NULL, 'Hexosyltransferase', 143, NULL, NULL, 102204),
(102205, '3.10.20.90-FF-000828', NULL, 'Uncharacterized protein', 99, NULL, NULL, 102205),
(102206, '1.20.5.340-FF-000122', NULL, 'Uncharacterized protein', 71, NULL, NULL, 102206),
(102207, '3.40.50.1000-FF-000673', NULL, NULL, 181, NULL, NULL, 102207),
(102208, '1.25.40.10-FF-003110', NULL, 'Uncharacterized protein', 84, NULL, NULL, 102208),
(102209, '3.40.850.10-FF-000055', NULL, 'Chitin synthase ChsE', 132, NULL, NULL, 102209),
(102210, '2.60.120.330-FF-000108', NULL, 'Uncharacterized protein', 334, NULL, NULL, 102210),
(102211, '3.40.50.300-FF-003611', NULL, 'ADP-ribosylation factor family, putative', 153, NULL, NULL, 102211),
(102212, '3.40.390.10-FF-000031', NULL, 'Pappalysin 2', 205, NULL, NULL, 102212),
(102213, '2.80.10.50-FF-000023', NULL, 'Stromal cell-derived factor 2-like 1', 184, NULL, NULL, 102213),
(102214, '3.90.550.10-FF-000094', NULL, 'Alpha-1,6-mannosyl-glycoprotein 2-beta-N-acetylglucosaminyltransferase', 239, NULL, NULL, 102214),
(102215, '1.20.1260.60-FF-000002', NULL, 'Vacuolar protein sorting-associated protein IST1', 183, NULL, NULL, 102215),
(102216, '1.20.1730.10-FF-000102', NULL, 'Uncharacterized protein', 222, NULL, NULL, 102216),
(102217, '2.60.40.10-FF-004757', NULL, NULL, 99, NULL, NULL, 102217),
(102218, '3.30.930.10-FF-000378', NULL, 'Protein CBR-PARS-2', 114, NULL, NULL, 102218),
(102219, '3.40.50.300-FF-000863', NULL, 'DNA excision repair protein ERCC-6', 287, NULL, NULL, 102219),
(102220, '1.10.510.10-FF-004187', NULL, NULL, 195, NULL, NULL, 102220),
(102221, '2.60.120.260-FF-000284', NULL, 'Si:dkey-147f3.8', 105, NULL, NULL, 102221),
(102222, '2.60.40.10-FF-004864', NULL, NULL, 106, NULL, NULL, 102222),
(102223, '3.30.160.60-FF-000019', NULL, 'GLI family zinc finger 3', 29, NULL, NULL, 102223),
(102224, '1.20.890.10-FF-000013', NULL, 'cAMP-dependent protein kinase type I regulatory subunit', 50, NULL, NULL, 102224),
(102225, '3.40.50.80-FF-000056', NULL, 'Probable ferredoxin', 140, NULL, NULL, 102225),
(102226, '3.90.76.10-FF-000059', NULL, 'Oligopeptide-binding protein OppA', 38, NULL, NULL, 102226),
(102227, '3.30.1120.90-FF-000014', NULL, 'Putative nucleosome assembly protein C36B7.08c', 157, NULL, NULL, 102227),
(102228, '3.40.50.10490-FF-000096', NULL, NULL, 137, NULL, NULL, 102228);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(102229, '1.20.870.10-FF-000006', NULL, 'ras-specific guanine nucleotide-releasing factor 1 isoform X1', 122, NULL, NULL, 102229),
(102230, '2.20.25.10-FF-000014', NULL, 'Transcription factor IIIB 50 kDa subunit', 42, NULL, NULL, 102230),
(102231, '3.40.50.300-FF-008501', NULL, 'Uncharacterized protein', 258, NULL, NULL, 102231),
(102232, '3.50.50.60-FF-001269', NULL, 'At5g24155', 80, NULL, NULL, 102232),
(102233, '1.10.8.10-FF-000156', NULL, 'Protein CBG03251', 56, NULL, NULL, 102233),
(102234, '2.10.25.10-FF-000099', NULL, 'Slit guidance ligand 2', 37, NULL, NULL, 102234),
(102235, '3.10.105.10-FF-000106', NULL, 'Diguanylate phosphodiesterase', 206, NULL, NULL, 102235),
(102236, '3.30.559.30-FF-000049', NULL, 'L-aminoadipate-semialdehyde dehydrogenase large subunit, putative', 208, NULL, NULL, 102236),
(102237, '2.60.40.10-FF-005376', NULL, NULL, 59, NULL, NULL, 102237),
(102238, '2.10.70.10-FF-000170', NULL, 'Kielin/chordin-like protein', 35, NULL, NULL, 102238),
(102239, '1.25.40.10-FF-004740', NULL, 'Uncharacterized protein', 75, NULL, NULL, 102239),
(102240, '2.60.40.10-FF-000593', NULL, 'Fibroblast growth factor receptor-like 1', 97, NULL, NULL, 102240),
(102241, '1.25.40.10-FF-002379', NULL, 'Os12g0557800 protein', 78, NULL, NULL, 102241),
(102242, '1.10.630.10-FF-000749', NULL, 'Uncharacterized protein', 69, NULL, NULL, 102242),
(102243, '3.40.50.300-FF-005646', NULL, 'ABC-type transporter, ATPase component, fused to acetyltransferase domain', 223, NULL, NULL, 102243),
(102244, '2.40.50.140-FF-000088', NULL, 'cold shock domain-containing protein E1 isoform X1', 73, NULL, NULL, 102244),
(102245, '2.120.10.80-FF-000294', NULL, 'Mei4-dependent protein 6', 213, NULL, NULL, 102245),
(102246, '1.25.40.480-FF-000008', NULL, 'Fanconi anemia, complementation group E', 154, NULL, NULL, 102246),
(102247, '2.130.10.10-FF-003212', NULL, 'Uncharacterized protein', 54, NULL, NULL, 102247),
(102248, '2.130.10.10-FF-002588', NULL, 'Minichromosome loss protein 1', 124, NULL, NULL, 102248),
(102249, '1.25.10.10-FF-000753', NULL, 'RING-type E3 ubiquitin transferase', 179, NULL, NULL, 102249),
(102250, '2.60.120.260-FF-000391', NULL, 'Predicted protein', 171, NULL, NULL, 102250),
(102251, '1.50.40.10-FF-000056', NULL, 'mitochondrial 2-oxodicarboxylate carrier isoform X2', 102, NULL, NULL, 102251),
(102252, '3.20.20.80-FF-000628', NULL, 'Uncharacterized protein', 125, NULL, NULL, 102252),
(102253, '3.40.1550.20-FF-000012', NULL, 'Transcriptional regulator MraZ', 141, NULL, NULL, 102253),
(102254, '1.10.405.10-FF-000007', NULL, 'Lysine-specific histone demethylase', 25, NULL, NULL, 102254),
(102255, '2.40.50.140-FF-000206', NULL, 'ATP-dependent DNA helicase RecG', 94, NULL, NULL, 102255),
(102256, '3.40.50.300-FF-008496', NULL, 'ABC transporter, putative', 58, NULL, NULL, 102256),
(102257, '1.25.40.1030-FF-000058', NULL, 'Uncharacterized protein', 99, NULL, NULL, 102257),
(102258, '1.10.8.720-FF-000053', NULL, 'Uncharacterized protein', 68, NULL, NULL, 102258),
(102259, '3.30.40.10-FF-002132', NULL, 'Chromosome 1, whole genome shotgun sequence', 78, NULL, NULL, 102259),
(102260, '3.30.200.20-FF-000540', NULL, 'Receptor-like protein kinase HAIKU2', 110, NULL, NULL, 102260),
(102261, '3.30.1120.10-FF-000029', NULL, 'Arylsulfatase A', 73, NULL, NULL, 102261),
(102262, '3.30.200.20-FF-001826', NULL, 'Ankyrin repeat protein', 47, NULL, NULL, 102262),
(102263, '1.10.10.60-FF-000216', NULL, 'MYB proto-oncogene like 2', 63, NULL, NULL, 102263),
(102264, '3.30.420.150-FF-000010', NULL, 'Adenosine-diphosphatase, putative', 298, NULL, NULL, 102264),
(102265, '2.60.40.60-FF-000124', NULL, 'Cadherin-related family member 1', 113, NULL, NULL, 102265),
(102266, '3.40.50.1000-FF-000780', NULL, NULL, 73, NULL, NULL, 102266),
(102267, '3.80.10.10-FF-003286', NULL, 'Uncharacterized protein', 111, NULL, NULL, 102267),
(102268, '2.130.10.10-FF-000227', NULL, 'Dynein assembly factor with WDR repeat domains 1', 89, NULL, NULL, 102268),
(102269, '1.20.90.10-FF-000032', NULL, NULL, 110, NULL, NULL, 102269),
(102270, '2.60.40.420-FF-000143', NULL, 'Cupredoxin superfamily protein', 108, NULL, NULL, 102270);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(102271, '3.30.200.20-FF-001719', NULL, 'Uncharacterized protein', 113, NULL, NULL, 102271),
(102272, '1.10.8.60-FF-000598', NULL, 'Uncharacterized protein', 109, NULL, NULL, 102272),
(102273, '3.80.10.10-FF-003179', NULL, 'RNI-like superfamily protein', 251, NULL, NULL, 102273),
(102274, '1.25.40.10-FF-003003', NULL, 'Os06g0694300 protein', 125, NULL, NULL, 102274),
(102275, '3.40.50.1820-FF-000800', NULL, 'Carboxylic ester hydrolase', 476, NULL, NULL, 102275),
(102276, '2.60.120.920-FF-000072', NULL, 'Tripartite motif containing 38', 178, NULL, NULL, 102276),
(102277, '3.40.1000.10-FF-000030', NULL, 'Uncharacterized protein', 152, NULL, NULL, 102277),
(102278, '2.60.120.330-FF-000097', NULL, '1-aminocyclopropane-1-carboxylate oxidase-like 1', 274, NULL, NULL, 102278),
(102279, '1.10.10.10-FF-000792', NULL, 'Vacuolar protein-sorting-associated protein 25', 77, NULL, NULL, 102279),
(102280, '2.130.10.10-FF-004516', NULL, 'Denticleless protein homolog', 233, NULL, NULL, 102280),
(102281, '2.60.120.10-FF-000550', NULL, 'Uncharacterized protein', 121, NULL, NULL, 102281),
(102282, '2.10.110.10-FF-000167', NULL, 'Predicted protein', 61, NULL, NULL, 102282),
(102283, '2.20.28.10-FF-000037', NULL, 'DNA helicase', 59, NULL, NULL, 102283),
(102284, '1.20.120.790-FF-000003', NULL, 'Heat shock protein 90', 149, NULL, NULL, 102284),
(102285, '1.10.8.970-FF-000004', NULL, 'Genome polyprotein', 75, NULL, NULL, 102285),
(102286, '4.10.410.10-FF-000025', NULL, 'Papilin-like Protein', 66, NULL, NULL, 102286),
(102287, '1.25.10.10-FF-002670', NULL, 'Uncharacterized protein', 91, NULL, NULL, 102287),
(102288, '3.90.70.10-FF-000669', NULL, 'Uncharacterized protein', 293, NULL, NULL, 102288),
(102289, '1.25.40.90-FF-000003', NULL, 'TOM1-like protein 2 isoform X1', 153, NULL, NULL, 102289),
(102290, '3.40.225.10-FF-000013', NULL, 'Class II aldolase', 251, NULL, NULL, 102290),
(102291, '1.10.287.160-FF-000030', NULL, 'Uncharacterized protein', 49, NULL, NULL, 102291),
(102292, '3.30.530.20-FF-000177', NULL, 'Uncharacterized protein', 108, NULL, NULL, 102292),
(102293, '1.10.238.10-FF-000669', NULL, 'Voltage-dependent N-type calcium channel subunit alpha', 82, NULL, NULL, 102293),
(102294, '2.60.40.1180-FF-000082', NULL, 'Alpha-mannosidase', 95, NULL, NULL, 102294),
(102295, '3.40.50.150-FF-001397', NULL, NULL, 168, NULL, NULL, 102295),
(102296, '3.30.530.20-FF-000171', NULL, 'Uncharacterized protein', 119, NULL, NULL, 102296),
(102297, '2.60.40.150-FF-000169', NULL, 'Protein translocation complex component (Npl1)', 130, NULL, NULL, 102297),
(102298, '3.30.200.20-FF-000298', NULL, 'Protein-associating with the carboxyl-terminal domain of ezrin', 81, NULL, NULL, 102298),
(102299, '3.30.200.20-FF-000410', NULL, 'Serine/threonine-protein kinase 3', 87, NULL, NULL, 102299),
(102300, '2.30.29.30-FF-000489', NULL, 'Inositol-3,4-bisphosphate 4-phosphatase', 122, NULL, NULL, 102300),
(102301, '3.80.10.10-FF-003393', NULL, 'Uncharacterized protein', 99, NULL, NULL, 102301),
(102302, '2.60.40.10-FF-004971', NULL, NULL, 110, NULL, NULL, 102302),
(102303, '2.60.40.340-FF-000001', NULL, 'Nuclear factor of activated T-cells, cytoplasmic, calcineurin-dependent 2', 175, NULL, NULL, 102303),
(102304, '3.40.850.10-FF-000162', NULL, 'Kinesin-like protein', 356, NULL, NULL, 102304),
(102305, '3.20.20.140-FF-000167', NULL, 'Hypothetical_protein_-_conserved', 342, NULL, NULL, 102305),
(102306, '1.10.400.10-FF-000036', NULL, 'Guanine nucleotide-binding protein G(Olf) subunit alpha', 56, NULL, NULL, 102306),
(102307, '3.40.190.10-FF-000717', NULL, 'Polar amino acid/opine ABC transporter, periplasmic amino acid-binding protein', 93, NULL, NULL, 102307),
(102308, '3.30.70.330-FF-001165', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-4 specific', 91, NULL, NULL, 102308),
(102309, '3.40.50.150-FF-000885', NULL, 'Uncharacterized protein', 211, NULL, NULL, 102309),
(102310, '2.30.30.1020-FF-000029', NULL, 'CCR4-NOT core subunit', 204, NULL, NULL, 102310),
(102311, '1.25.40.10-FF-004307', NULL, 'Predicted protein', 186, NULL, NULL, 102311);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(102312, '1.10.510.10-FF-003568', NULL, NULL, 221, NULL, NULL, 102312),
(102313, '3.90.79.10-FF-000189', NULL, 'NUDIX hydrolase', 180, NULL, NULL, 102313),
(102314, '2.160.10.10-FF-000086', NULL, 'AGL094Wp', 88, NULL, NULL, 102314),
(102315, '3.40.190.10-FF-000032', NULL, 'Maltose/maltodextrin-binding periplasmic protein', 186, NULL, NULL, 102315),
(102316, '1.10.599.10-FF-000001', NULL, 'Aldehyde:ferredoxin oxidoreductase, tungsten-containing', 173, NULL, NULL, 102316),
(102317, '3.40.50.2300-FF-000169', NULL, 'Glutamate receptor', 159, NULL, NULL, 102317),
(102318, '3.30.497.10-FF-000163', NULL, 'Uncharacterized protein', 51, NULL, NULL, 102318),
(102319, '3.40.50.80-FF-000163', NULL, 'Ferric reductase-like transmembrane component with cytochrome b-245 motif', 218, NULL, NULL, 102319),
(102320, '1.25.40.10-FF-003907', NULL, 'Uncharacterized protein', 55, NULL, NULL, 102320),
(102321, '2.130.10.10-FF-005680', NULL, 'Uncharacterized protein', 161, NULL, NULL, 102321),
(102322, '3.40.930.10-FF-000005', NULL, 'Ascorbate-specific phosphotransferase enzyme IIA component', 153, NULL, NULL, 102322),
(102323, '3.30.70.580-FF-000031', NULL, 'Pseudouridine synthase', 74, NULL, NULL, 102323),
(102324, '3.90.190.10-FF-000122', NULL, 'myotubularin-related protein 14', 133, NULL, NULL, 102324),
(102325, '3.30.750.24-FF-000041', NULL, 'Anti-sigma factor antagonist', 114, NULL, NULL, 102325),
(102326, '3.40.50.2300-FF-001248', NULL, NULL, 23, NULL, NULL, 102326),
(102327, '3.30.450.20-FF-000018', NULL, 'Sensor histidine kinase DcuS', 116, NULL, NULL, 102327),
(102328, '2.60.40.150-FF-000270', NULL, 'Elicitor-responsive protein 3', 124, NULL, NULL, 102328),
(102329, '3.40.630.30-FF-000174', NULL, 'Acetyltransferase, GNAT family, putative', 178, NULL, NULL, 102329),
(102330, '1.20.1390.10-FF-000002', NULL, 'Serine/arginine repetitive matrix 1 isoform 2', 95, NULL, NULL, 102330),
(102331, '1.10.510.10-FF-001207', NULL, 'probable receptor-like protein kinase At1g49730', 90, NULL, NULL, 102331),
(102332, '1.25.40.10-FF-004852', NULL, 'Uncharacterized protein', 239, NULL, NULL, 102332),
(102333, '3.20.20.140-FF-000381', NULL, 'Ampd2 protein', 184, NULL, NULL, 102333),
(102334, '2.30.33.40-FF-000024', NULL, '10 kDa chaperonin', 68, NULL, NULL, 102334),
(102335, '2.40.50.140-FF-000200', NULL, 'Programmed cell death 11', 108, NULL, NULL, 102335),
(102336, '3.90.1150.10-FF-000063', NULL, 'Probable cystathionine gamma-synthase', 135, NULL, NULL, 102336),
(102337, '1.25.40.10-FF-001867', NULL, 'Cleavage stimulation factor, putative', 414, NULL, NULL, 102337),
(102338, '1.20.1550.10-FF-000004', NULL, 'Disulfide bond formation protein B', 165, NULL, NULL, 102338),
(102339, '3.40.50.300-FF-002313', NULL, 'Phosphate import ATP-binding protein PstB', 243, NULL, NULL, 102339),
(102340, '3.20.20.100-FF-000054', NULL, 'L-fucose dehydrogenase', 316, NULL, NULL, 102340),
(102341, '3.40.50.2000-FF-000759', NULL, 'Alpha-1,6-glucosyltransferase', 179, NULL, NULL, 102341),
(102342, '3.80.10.10-FF-001829', NULL, 'Leucine-rich repeat receptor-like protein kinase PXC2', 166, NULL, NULL, 102342),
(102343, '1.25.40.10-FF-000125', NULL, 'Pentatricopeptide repeat-containing protein', 63, NULL, NULL, 102343),
(102344, '3.30.559.10-FF-000043', NULL, 'Peptide synthetase mbtE', 200, NULL, NULL, 102344),
(102345, '3.30.70.330-FF-000653', NULL, 'AGAP002654-PB', 75, NULL, NULL, 102345),
(102346, '3.30.1610.10-FF-000011', NULL, 'Predicted protein', 64, NULL, NULL, 102346),
(102347, '1.20.58.390-FF-000221', NULL, 'AcetylCholine Receptor', 70, NULL, NULL, 102347),
(102348, '3.40.50.150-FF-000666', NULL, 'S-adenosyl-L-methionine-dependent methyltransferases superfamily protein', 224, NULL, NULL, 102348),
(102349, '3.30.450.380-FF-000006', NULL, 'Type II/IV secretion system protein, TadA subfamily', 186, NULL, NULL, 102349),
(102350, '3.30.160.60-FF-003111', NULL, 'Zinc finger protein 557', 28, NULL, NULL, 102350),
(102351, '3.40.50.1820-FF-001312', NULL, 'Uncharacterized protein', 262, NULL, NULL, 102351),
(102352, '3.90.180.10-FF-000189', NULL, 'Uncharacterized protein', 65, NULL, NULL, 102352);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(102353, '2.10.90.10-FF-000058', NULL, 'Maverick', 111, NULL, NULL, 102353),
(102354, '2.40.30.10-FF-000250', NULL, 'AGAP011314-PA', 102, NULL, NULL, 102354),
(102355, '3.30.160.60-FF-004297', NULL, NULL, 32, NULL, NULL, 102355),
(102356, '2.40.70.10-FF-000477', NULL, NULL, 157, NULL, NULL, 102356),
(102357, '1.20.1250.20-FF-001361', NULL, 'Uncharacterized protein', 198, NULL, NULL, 102357),
(102358, '3.80.10.10-FF-002774', NULL, 'Uncharacterized protein', 88, NULL, NULL, 102358),
(102359, '2.60.40.60-FF-000236', NULL, 'Dachsous, isoform B', 105, NULL, NULL, 102359),
(102360, '2.40.10.10-FF-000243', NULL, 'KLK4 isoform 6', 45, NULL, NULL, 102360),
(102361, '3.30.200.20-FF-001607', NULL, 'PTO-like protein kinase', 102, NULL, NULL, 102361),
(102362, '3.20.20.70-FF-000737', NULL, NULL, 78, NULL, NULL, 102362),
(102363, '1.20.5.340-FF-000015', NULL, 'Mitochondrial calcium uniporter regulator 1', 97, NULL, NULL, 102363),
(102364, '3.30.160.60-FF-003897', NULL, NULL, 30, NULL, NULL, 102364),
(102365, '3.30.160.60-FF-006207', NULL, NULL, 31, NULL, NULL, 102365),
(102366, '3.10.20.90-FF-000143', NULL, 'E3 ubiquitin-protein ligase UHRF1 isoform 1', 95, NULL, NULL, 102366),
(102367, '1.10.510.10-FF-000932', NULL, 'Protein CBG09188', 379, NULL, NULL, 102367),
(102368, '3.30.200.20-FF-002338', NULL, 'Uncharacterized protein', 69, NULL, NULL, 102368),
(102369, '1.25.40.10-FF-000581', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 165, NULL, NULL, 102369),
(102370, '2.60.120.200-FF-000305', NULL, 'CoLlagen with Endostatin domain', 209, NULL, NULL, 102370),
(102371, '3.30.40.10-FF-002244', NULL, 'Predicted protein', 61, NULL, NULL, 102371),
(102372, '1.20.890.10-FF-000019', NULL, 'Dpy-30_motif_containing_protein_-_putative', 44, NULL, NULL, 102372),
(102373, '2.10.25.10-FF-001037', NULL, 'C-type LECtin', 36, NULL, NULL, 102373),
(102374, '3.40.640.10-FF-000129', NULL, 'Alanine aminotransferase 2', 246, NULL, NULL, 102374),
(102375, '3.40.50.300-FF-008277', NULL, 'Predicted protein', 38, NULL, NULL, 102375),
(102376, '1.20.120.1750-FF-000091', NULL, 'RBR-type E3 ubiquitin transferase', 84, NULL, NULL, 102376),
(102377, '1.20.1250.20-FF-001810', NULL, 'Uncharacterized protein', 162, NULL, NULL, 102377),
(102378, '3.30.450.60-FF-000002', NULL, 'AP-2 complex subunit mu, putative', 140, NULL, NULL, 102378),
(102379, '1.25.10.10-FF-000972', NULL, 'GM26729', 285, NULL, NULL, 102379),
(102380, '1.20.5.340-FF-000010', NULL, 'Non-specific serine/threonine protein kinase', 73, NULL, NULL, 102380),
(102381, '3.40.50.300-FF-001352', NULL, 'DNA repair helicase', 214, NULL, NULL, 102381),
(102382, '2.170.130.10-FF-000013', NULL, 'Carboxypeptidase regulatory-like domain protein', 131, NULL, NULL, 102382),
(102383, '1.20.58.1220-FF-000002', NULL, 'Exocyst complex component 8', 102, NULL, NULL, 102383),
(102384, '2.60.40.10-FF-002498', NULL, 'Protease', 81, NULL, NULL, 102384),
(102385, '1.20.1070.10-FF-000990', NULL, 'Uncharacterized protein', 315, NULL, NULL, 102385),
(102386, '1.10.510.10-FF-000140', NULL, 'Platelet-derived growth factor receptor beta', 203, NULL, NULL, 102386),
(102387, '3.20.20.70-FF-000395', NULL, 'Probable tRNA-dihydrouridine synthase', 240, NULL, NULL, 102387),
(102388, '3.10.28.10-FF-000058', NULL, 'Gll3966 protein', 165, NULL, NULL, 102388),
(102389, '1.10.1320.10-FF-000017', NULL, 'DNA-directed RNA polymerase', 348, NULL, NULL, 102389),
(102390, '3.40.50.1000-FF-000785', NULL, NULL, 60, NULL, NULL, 102390),
(102391, '3.30.70.270-FF-000270', NULL, NULL, 148, NULL, NULL, 102391),
(102392, '2.160.20.10-FF-000148', NULL, 'ZFP family member', 230, NULL, NULL, 102392),
(102393, '2.30.250.10-FF-000010', NULL, 'Clan MH, family M18, aspartyl aminopeptidase-like metallopeptidase', 122, NULL, NULL, 102393),
(102394, '1.20.5.1500-FF-000007', NULL, 'Testis-specific Y-encoded protein 10', 87, NULL, NULL, 102394),
(102395, '3.30.450.80-FF-000008', NULL, 'Transcriptional activator protein VanR', 163, NULL, NULL, 102395),
(102396, '1.10.287.110-FF-000268', NULL, 'Uncharacterized protein', 70, NULL, NULL, 102396);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(102397, '3.40.50.1820-FF-000244', NULL, 'Cutinase', 211, NULL, NULL, 102397),
(102398, '1.20.1510.10-FF-000007', NULL, 'Zinc transporter 7', 199, NULL, NULL, 102398),
(102399, '3.90.1750.10-FF-000029', NULL, 'Circadian trip, isoform C', 74, NULL, NULL, 102399),
(102400, '3.90.1290.10-FF-000005', NULL, 'microtubule-actin cross-linking factor 1 isoform X7', 179, NULL, NULL, 102400),
(102401, '1.10.287.130-FF-000032', NULL, 'Sensor histidine kinase', 55, NULL, NULL, 102401),
(102402, '3.40.390.10-FF-000143', NULL, 'Metalloendopeptidase', 130, NULL, NULL, 102402),
(102403, '1.10.1300.10-FF-000022', NULL, 'Phosphodiesterase', 337, NULL, NULL, 102403),
(102404, '1.20.1550.10-FF-000009', NULL, 'Putative protein-disulfide oxidoreductase DsbI', 190, NULL, NULL, 102404),
(102405, '3.20.20.140-FF-000386', NULL, 'Predicted protein', 173, NULL, NULL, 102405),
(102406, '1.20.1070.10-FF-000315', NULL, 'G protein-coupled receptor 32', 306, NULL, NULL, 102406),
(102407, '3.50.50.60-FF-001399', NULL, 'Predicted protein', 176, NULL, NULL, 102407),
(102408, '2.30.30.40-FF-000563', NULL, 'Uncharacterized protein', 47, NULL, NULL, 102408),
(102409, '3.30.160.60-FF-001531', NULL, 'Zinc finger protein 649', 29, NULL, NULL, 102409),
(102410, '3.40.50.360-FF-000167', NULL, 'Uncharacterized protein', 88, NULL, NULL, 102410),
(102411, '3.30.43.10-FF-000031', NULL, 'Protein CBG02865', 99, NULL, NULL, 102411),
(102412, '2.60.40.10-FF-004752', NULL, NULL, 106, NULL, NULL, 102412),
(102413, '3.40.630.10-FF-000308', NULL, 'Uncharacterized protein', 318, NULL, NULL, 102413),
(102414, '3.30.40.10-FF-001283', NULL, 'Uncharacterized protein', 85, NULL, NULL, 102414),
(102415, '3.30.160.270-FF-000008', NULL, '2-isopropylmalate synthase', 167, NULL, NULL, 102415),
(102416, '3.30.160.60-FF-000238', NULL, 'Zinc finger protein 485', 28, NULL, NULL, 102416),
(102417, '3.30.465.10-FF-000044', NULL, 'DUF21 domain-containing protein At1g55930, chloroplastic', 102, NULL, NULL, 102417),
(102418, '1.25.40.90-FF-000110', NULL, 'Uncharacterized protein', 72, NULL, NULL, 102418),
(102419, '1.10.510.10-FF-003787', NULL, NULL, 131, NULL, NULL, 102419),
(102420, '3.30.420.10-FF-000643', NULL, NULL, 141, NULL, NULL, 102420),
(102421, '3.40.50.970-FF-000001', NULL, 'Pyruvate dehydrogenase E1 beta subunit', 192, NULL, NULL, 102421),
(102422, '3.40.50.300-FF-006484', NULL, 'Sulfotransferase', 116, NULL, NULL, 102422),
(102423, '2.60.40.10-FF-002503', NULL, 'Synaptogenesis protein syg-2', 103, NULL, NULL, 102423),
(102424, '2.60.40.10-FF-001879', NULL, 'Protein tyrosine phosphatase, receptor type Q', 95, NULL, NULL, 102424),
(102425, '3.40.50.300-FF-000733', NULL, 'Guanine nucleotide-binding protein alpha-1 subunit', 205, NULL, NULL, 102425),
(102426, '2.10.90.10-FF-000053', NULL, 'PDGF-and VEGF-related factor 3', 109, NULL, NULL, 102426),
(102427, '2.130.10.10-FF-004623', NULL, 'Cytoplasmic dynein intermediate chain-like protein', 199, NULL, NULL, 102427),
(102428, '1.50.10.20-FF-000006', NULL, 'Mannan endo-1,6-alpha-mannosidase', 359, NULL, NULL, 102428),
(102429, '3.50.50.60-FF-000319', NULL, 'Rubredoxin-NAD(+) reductase', 136, NULL, NULL, 102429),
(102430, '3.90.79.10-FF-000301', NULL, 'Uncharacterized protein', 66, NULL, NULL, 102430),
(102431, '1.25.40.10-FF-003902', NULL, 'rRNA processing protein Utp6, putative (AFU_orthologue AFUA_3G09750)', 68, NULL, NULL, 102431),
(102432, '3.40.50.1400-FF-000017', NULL, 'Ferrochelatase che1', 112, NULL, NULL, 102432),
(102433, '2.40.440.10-FF-000011', NULL, 'L,D-transpeptidase catalytic domain', 136, NULL, NULL, 102433),
(102434, '2.30.29.30-FF-000360', NULL, 'Alpha-1-syntrophin', 67, NULL, NULL, 102434),
(102435, '2.60.40.10-FF-002155', NULL, 'Cell adhesion molecule L1-like b', 96, NULL, NULL, 102435),
(102436, '3.30.160.60-FF-002150', NULL, 'Zinc finger protein 140', 38, NULL, NULL, 102436),
(102437, '2.130.10.10-FF-000334', NULL, 'C-Jun-amino-terminal kinase-interacting protein 3 isoform X6', 230, NULL, NULL, 102437),
(102438, '3.60.21.10-FF-000052', NULL, 'Endonuclease YhcR', 311, NULL, NULL, 102438);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(102439, '3.30.450.20-FF-000232', NULL, 'Diguanylate cyclase', 148, NULL, NULL, 102439),
(102440, '1.25.40.10-FF-005364', NULL, 'Predicted protein', 97, NULL, NULL, 102440),
(102441, '2.60.40.10-FF-003807', NULL, NULL, 94, NULL, NULL, 102441),
(102442, '1.20.58.390-FF-000333', NULL, 'Uncharacterized protein', 65, NULL, NULL, 102442),
(102443, '2.30.110.10-FF-000067', NULL, 'Uncharacterized protein', 139, NULL, NULL, 102443),
(102444, '1.20.1250.20-FF-001142', NULL, 'Predicted protein', 220, NULL, NULL, 102444),
(102445, '4.10.60.10-FF-000226', NULL, 'Uncharacterized protein', 44, NULL, NULL, 102445),
(102446, '2.60.40.790-FF-000006', NULL, 'calcyclin-binding protein-like', 105, NULL, NULL, 102446),
(102447, '3.40.50.300-FF-003729', NULL, 'Putative ATP-dependent DEAD/H RNA helicase', 206, NULL, NULL, 102447),
(102448, '3.30.1320.10-FF-000028', NULL, 'Uncharacterized protein', 66, NULL, NULL, 102448),
(102449, '1.10.8.500-FF-000004', NULL, 'PAS domain-containing sensor histidine kinase', 48, NULL, NULL, 102449),
(102450, '3.30.40.10-FF-001732', NULL, 'Lysine-specific demethylase rbr-2', 109, NULL, NULL, 102450),
(102451, '3.40.50.1820-FF-001424', NULL, 'Uncharacterized protein', 198, NULL, NULL, 102451),
(102452, '3.80.10.10-FF-001717', NULL, 'Os02g0317300 protein', 92, NULL, NULL, 102452),
(102453, '2.160.20.70-FF-000008', NULL, 'Adenylyl cyclase-associated protein', 159, NULL, NULL, 102453),
(102454, '3.90.1640.10-FF-000038', NULL, 'Predicted protein', 227, NULL, NULL, 102454),
(102455, '3.30.200.20-FF-002333', NULL, NULL, 71, NULL, NULL, 102455),
(102456, '3.30.70.1350-FF-000044', NULL, NULL, 87, NULL, NULL, 102456),
(102457, '3.30.60.20-FF-000118', NULL, 'Diacylglycerol kinase', 54, NULL, NULL, 102457),
(102458, '2.40.10.10-FF-000024', NULL, 'Serine protease 53', 248, NULL, NULL, 102458),
(102459, '3.80.10.10-FF-002779', NULL, 'FBD-associated F-box protein At3g49020', 338, NULL, NULL, 102459),
(102460, '3.40.50.300-FF-006028', NULL, 'Helicase, putative', 211, NULL, NULL, 102460),
(102461, '1.20.1070.10-FF-001838', NULL, 'Uncharacterized protein', 303, NULL, NULL, 102461),
(102462, '3.40.970.10-FF-000002', NULL, 'Ribonuclease H', 49, NULL, NULL, 102462),
(102463, '3.40.630.30-FF-000286', NULL, 'AGAP004528-PA', 238, NULL, NULL, 102463),
(102464, '4.10.280.110-FF-000008', NULL, 'U4/U6 small nuclear ribonucleoprotein PRP4', 77, NULL, NULL, 102464),
(102465, '3.10.20.90-FF-000255', NULL, 'probable serine/threonine-protein kinase WNK9', 81, NULL, NULL, 102465),
(102466, '3.40.50.1820-FF-001531', NULL, 'Uncharacterized protein', 143, NULL, NULL, 102466),
(102467, '2.40.330.10-FF-000014', NULL, NULL, 125, NULL, NULL, 102467),
(102468, '3.60.21.60-FF-000038', NULL, 'Uncharacterized protein', 153, NULL, NULL, 102468),
(102469, '3.30.450.40-FF-000238', NULL, 'PleD', 166, NULL, NULL, 102469),
(102470, '3.40.47.10-FF-000056', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 3', 172, NULL, NULL, 102470),
(102471, '3.90.70.10-FF-000557', NULL, 'Uncharacterized protein', 261, NULL, NULL, 102471),
(102472, '1.10.10.10-FF-001859', NULL, 'Uncharacterized protein', 74, NULL, NULL, 102472),
(102473, '1.20.140.150-FF-000046', NULL, 'Transmembrane protein 114', 90, NULL, NULL, 102473),
(102474, '1.10.287.950-FF-000047', NULL, 'Methyl-accepting chemotaxis protein', 307, NULL, NULL, 102474),
(102475, '3.40.50.300-FF-004915', NULL, 'ADP-ribosylation factor D1B', 182, NULL, NULL, 102475),
(102476, '3.30.40.10-FF-001862', NULL, 'Uncharacterized protein', 79, NULL, NULL, 102476),
(102477, '2.40.50.90-FF-000011', NULL, 'Ribonuclease', 145, NULL, NULL, 102477),
(102478, '3.80.10.10-FF-000306', NULL, 'Toll-like receptor 5', 266, NULL, NULL, 102478),
(102479, '3.60.21.10-FF-000395', NULL, 'Serine/threonine-protein phosphatase', 327, NULL, NULL, 102479),
(102480, '1.10.533.10-FF-000176', NULL, 'Baculoviral IAP repeat-containing protein 7', 40, NULL, NULL, 102480),
(102481, '3.90.1160.10-FF-000001', NULL, 'Baseplate wedge completion tail pin', 109, NULL, NULL, 102481),
(102482, '2.60.200.10-FF-000039', NULL, 'Uncharacterized protein', 173, NULL, NULL, 102482);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(102483, '3.80.10.10-FF-001470', NULL, 'Connectin, isoform B', 163, NULL, NULL, 102483),
(102484, '3.90.1150.10-FF-000170', NULL, 'Orn/Arg/Lys decarboxylase, putative', 171, NULL, NULL, 102484),
(102485, '3.40.630.30-FF-000067', NULL, 'Histone acetyltransferase', 119, NULL, NULL, 102485),
(102486, '1.10.238.10-FF-000557', NULL, 'Uncharacterized protein', 101, NULL, NULL, 102486),
(102487, '1.20.5.170-FF-000285', NULL, 'Uncharacterized protein', 99, NULL, NULL, 102487),
(102488, '1.10.510.10-FF-001314', NULL, 'Uncharacterized protein', 232, NULL, NULL, 102488),
(102489, '3.90.1180.10-FF-000014', NULL, 'Ribosomal protein L13, variant', 138, NULL, NULL, 102489),
(102490, '3.30.70.330-FF-001277', NULL, 'Nucleolin', 89, NULL, NULL, 102490),
(102491, '2.10.25.10-FF-000655', NULL, 'Complement component C1q receptor', 41, NULL, NULL, 102491),
(102492, '3.20.20.60-FF-000066', NULL, 'Pyruvate kinase', 235, NULL, NULL, 102492),
(102493, '1.10.10.10-FF-001989', NULL, 'Uncharacterized protein', 45, NULL, NULL, 102493),
(102494, '1.10.533.10-FF-000046', NULL, 'Si:ch211-196f19.1', 88, NULL, NULL, 102494),
(102495, '3.40.50.2000-FF-000416', NULL, 'Protein CBG10769', 172, NULL, NULL, 102495),
(102496, '1.10.1200.10-FF-000082', NULL, 'Transferase family protein', 85, NULL, NULL, 102496),
(102497, '2.30.180.10-FF-000127', NULL, NULL, 141, NULL, NULL, 102497),
(102498, '3.30.70.330-FF-002570', NULL, NULL, 219, NULL, NULL, 102498),
(102499, '1.25.40.10-FF-000018', NULL, 'Cell division cycle protein 27 homolog B', 133, NULL, NULL, 102499),
(102500, '2.60.40.60-FF-000343', NULL, 'Fat-like cadherin-related tumor suppressor homolog', 108, NULL, NULL, 102500),
(102501, '3.30.70.60-FF-000041', NULL, '30S ribosomal protein S6', 94, NULL, NULL, 102501),
(102502, '3.30.40.10-FF-001390', NULL, 'Uncharacterized protein', 57, NULL, NULL, 102502),
(102503, '2.130.10.10-FF-000790', NULL, 'Chromosome segregation protein (SepB)', 133, NULL, NULL, 102503),
(102504, '1.10.540.10-FF-000074', NULL, 'Acyl-CoA dehydrogenase', 99, NULL, NULL, 102504),
(102505, '1.10.10.60-FF-000323', NULL, 'jerky protein homolog-like', 54, NULL, NULL, 102505),
(102506, '3.40.50.300-FF-004567', NULL, 'DNA helicase HCS1', 221, NULL, NULL, 102506),
(102507, '3.30.1300.10-FF-000015', NULL, NULL, 108, NULL, NULL, 102507),
(102508, '1.25.40.10-FF-004060', NULL, 'Protein STIP1 homolog', 129, NULL, NULL, 102508),
(102509, '3.40.50.1100-FF-000141', NULL, 'Cysteine synthase', 29, NULL, NULL, 102509),
(102510, '3.40.50.2300-FF-000411', NULL, 'PROBABLE RESPONSE REGULATOR', 129, NULL, NULL, 102510),
(102511, '3.40.630.10-FF-000061', NULL, 'Aminobenzoyl-glutamate utilization protein B', 186, NULL, NULL, 102511),
(102512, '3.30.450.20-FF-000013', NULL, 'Period circadian protein homolog 2', 161, NULL, NULL, 102512),
(102513, '2.10.50.10-FF-000056', NULL, 'Cysteine repeat modular protein 2 PbCRM2', 66, NULL, NULL, 102513),
(102514, '1.10.357.110-FF-000003', NULL, 'Putative GARP complex subunit Vps53', 164, NULL, NULL, 102514),
(102515, '3.30.70.330-FF-001058', NULL, 'Mip6p', 104, NULL, NULL, 102515),
(102516, '3.10.20.70-FF-000030', NULL, 'Glutamine synthetase', 97, NULL, NULL, 102516),
(102517, '2.40.50.140-FF-001156', NULL, NULL, 96, NULL, NULL, 102517),
(102518, '3.40.366.10-FF-000031', NULL, 'Malonyl CoA-acyl carrier protein transacylase, mitochondrial', 220, NULL, NULL, 102518),
(102519, '3.30.1330.30-FF-000068', NULL, 'Protein pelota homolog', 106, NULL, NULL, 102519),
(102520, '2.60.40.10-FF-003459', NULL, NULL, 101, NULL, NULL, 102520),
(102521, '3.30.750.44-FF-000029', NULL, NULL, 58, NULL, NULL, 102521),
(102522, '3.50.50.60-FF-000090', NULL, 'Rab GDP dissociation inhibitor', 167, NULL, NULL, 102522),
(102523, '2.30.29.30-FF-000141', NULL, 'Pleckstrin homology domain-containing family G member 5', 124, NULL, NULL, 102523),
(102524, '2.60.120.260-FF-000177', NULL, 'Hemolectin', 148, NULL, NULL, 102524),
(102525, '3.90.550.10-FF-000217', NULL, 'Glycosyl transferase, group 2', 123, NULL, NULL, 102525),
(102526, '3.20.20.70-FF-000288', NULL, 'Oxidoreductase, 2-nitropropane dioxygenase family, putative (AFU_orthologue AFUA_7G03850)', 342, NULL, NULL, 102526);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(102527, '2.70.98.50-FF-000001', NULL, 'Glucosidase YgjK', 232, NULL, NULL, 102527),
(102528, '1.10.238.10-FF-000776', NULL, 'Mechanosensitive ion channel protein', 64, NULL, NULL, 102528),
(102529, '1.25.40.20-FF-001308', NULL, 'Os09g0294901 protein', 148, NULL, NULL, 102529),
(102530, '1.20.58.60-FF-000596', NULL, 'Spectrin beta chain', 179, NULL, NULL, 102530),
(102531, '3.40.720.10-FF-000287', NULL, 'Uncharacterized protein', 274, NULL, NULL, 102531),
(102532, '3.90.226.10-FF-000190', NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', 338, NULL, NULL, 102532),
(102533, '1.10.150.50-FF-000146', NULL, 'Phosphatidylinositol 3-kinase regulatory subunit alpha-like Protein', 76, NULL, NULL, 102533),
(102534, '3.40.30.10-FF-000753', NULL, 'Glutaredoxin', 103, NULL, NULL, 102534),
(102535, '1.10.3500.10-FF-000026', NULL, 'SH2 domain containing protein', 293, NULL, NULL, 102535),
(102536, '2.120.10.80-FF-000182', NULL, 'Kelch_motif/Galactose_oxidase_-_central_domain_containing_protein_-_putative', 267, NULL, NULL, 102536),
(102537, '3.30.160.40-FF-000013', NULL, 'Porphobilinogen deaminase', 88, NULL, NULL, 102537),
(102538, '1.25.40.730-FF-000005', NULL, 'Clathrin heavy chain', 97, NULL, NULL, 102538),
(102539, '3.10.450.40-FF-000001', NULL, 'Amine oxidase', 129, NULL, NULL, 102539),
(102540, '1.10.10.10-FF-001646', NULL, 'YALI0D25146p', 80, NULL, NULL, 102540),
(102541, '3.90.70.10-FF-000776', NULL, 'Predicted protein', 51, NULL, NULL, 102541),
(102542, '3.30.70.660-FF-000061', NULL, 'tRNA pseudouridine synthase', 190, NULL, NULL, 102542),
(102543, '2.40.70.10-FF-000584', NULL, NULL, 105, NULL, NULL, 102543),
(102544, '1.20.120.350-FF-000006', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 122, NULL, NULL, 102544),
(102545, '1.10.287.3490-FF-000001', NULL, 'Mediator of RNA polymerase II transcription subunit 11', 88, NULL, NULL, 102545),
(102546, '1.25.40.10-FF-003784', NULL, 'Uncharacterized protein', 153, NULL, NULL, 102546),
(102547, '2.40.70.10-FF-000039', NULL, 'Cathepsin D preproprotein', 102, NULL, NULL, 102547),
(102548, '1.20.58.390-FF-000114', NULL, 'Uncharacterized protein', 105, NULL, NULL, 102548),
(102549, '3.40.630.10-FF-000179', NULL, 'uncharacterized protein LOC100177071', 329, NULL, NULL, 102549),
(102550, '1.10.3720.10-FF-000014', NULL, 'Microcin C ABC transporter permease YejB', 232, NULL, NULL, 102550),
(102551, '3.80.10.10-FF-000981', NULL, 'Serine-threonine protein kinase, putative', 146, NULL, NULL, 102551),
(102552, '3.10.20.90-FF-000036', NULL, 'Unconventional myosin-VIIa', 96, NULL, NULL, 102552),
(102553, '3.30.200.20-FF-001714', NULL, 'Uncharacterized protein', 28, NULL, NULL, 102553),
(102554, '1.10.150.60-FF-000031', NULL, 'Lysine-specific demethylase rbr-2 isoform A', 117, NULL, NULL, 102554),
(102555, '3.40.50.300-FF-004230', NULL, 'Ferrous iron transport protein B', 163, NULL, NULL, 102555),
(102556, '1.10.1070.11-FF-000145', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit, putative', 203, NULL, NULL, 102556),
(102557, '1.20.1050.10-FF-000202', NULL, 'Uncharacterized protein', 136, NULL, NULL, 102557),
(102558, '3.30.160.60-FF-003459', NULL, NULL, 31, NULL, NULL, 102558),
(102559, '1.10.510.10-FF-000825', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 196, NULL, NULL, 102559),
(102560, '2.20.70.10-FF-000085', NULL, 'Peptidyl-prolyl cis-trans isomerase', 43, NULL, NULL, 102560),
(102561, '3.20.70.20-FF-000029', NULL, 'Vitamin B12-dependent ribonucleotide reductase', 164, NULL, NULL, 102561),
(102562, '3.30.1740.20-FF-000001', NULL, '40S ribosomal protein S26', 115, NULL, NULL, 102562),
(102563, '3.30.40.10-FF-002351', NULL, 'RING finger protein', 133, NULL, NULL, 102563),
(102564, '1.10.1070.11-FF-000021', NULL, 'Serine/threonine-protein kinase ATR, putative', 163, NULL, NULL, 102564),
(102565, '1.25.40.20-FF-000477', NULL, 'Ankyrin repeat family protein', 245, NULL, NULL, 102565),
(102566, '3.60.21.10-FF-000271', NULL, 'Serine/threonine-protein phosphatase', 367, NULL, NULL, 102566),
(102567, '3.30.50.10-FF-000160', NULL, 'Predicted protein', 100, NULL, NULL, 102567);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(102568, '1.20.1070.10-FF-001619', NULL, 'Uncharacterized protein', 144, NULL, NULL, 102568),
(102569, '3.20.20.10-FF-000080', NULL, 'Uncharacterized protein', 54, NULL, NULL, 102569),
(102570, '3.80.10.10-FF-003398', NULL, 'Uncharacterized protein', 95, NULL, NULL, 102570),
(102571, '1.10.555.10-FF-000226', NULL, NULL, 142, NULL, NULL, 102571),
(102572, '1.10.150.80-FF-000037', NULL, 'ATP-dependent DNA helicase', 75, NULL, NULL, 102572),
(102573, '3.30.70.330-FF-002019', NULL, NULL, 124, NULL, NULL, 102573),
(102574, '1.25.40.10-FF-001429', NULL, 'Pentatricopeptide repeat-containing protein', 233, NULL, NULL, 102574),
(102575, '3.20.20.450-FF-000030', NULL, NULL, 240, NULL, NULL, 102575),
(102576, '1.20.1070.10-FF-001726', NULL, 'Uncharacterized protein', 98, NULL, NULL, 102576),
(102577, '3.30.2410.10-FF-000029', NULL, 'Ubiquitin protein ligase E3A', 76, NULL, NULL, 102577),
(102578, '1.20.1250.20-FF-001934', NULL, 'Uncharacterized protein', 210, NULL, NULL, 102578),
(102579, '3.30.70.80-FF-000030', NULL, 'Subtilisin-like protease SBT2.1', 117, NULL, NULL, 102579),
(102580, '3.30.360.80-FF-000001', NULL, 'RNA polymerase-associated protein RapA', 78, NULL, NULL, 102580),
(102581, '2.160.20.10-FF-000036', NULL, 'Pectate lyase A', 289, NULL, NULL, 102581),
(102582, '1.10.357.10-FF-000069', NULL, 'TetR family transcriptional regulator', 186, NULL, NULL, 102582),
(102583, '3.90.110.10-FF-000022', NULL, NULL, 73, NULL, NULL, 102583),
(102584, '3.10.20.90-FF-000486', NULL, 'MAPKKK cascade protein kinase regulator Ste50 (AFU_orthologue AFUA_2G17130)', 88, NULL, NULL, 102584),
(102585, '1.10.287.70-FF-000396', NULL, 'Uncharacterized protein', 139, NULL, NULL, 102585),
(102586, '3.30.1380.20-FF-000029', NULL, 'Trafficking protein particle complex subunit', 167, NULL, NULL, 102586),
(102587, '1.10.790.10-FF-000002', NULL, 'Prion-like protein doppel', 107, NULL, NULL, 102587),
(102588, '3.30.200.20-FF-002102', NULL, 'Uncharacterized protein', 79, NULL, NULL, 102588),
(102589, '1.10.8.60-FF-000362', NULL, '26S protease regulatory subunit 6B', 84, NULL, NULL, 102589),
(102590, '2.60.40.1970-FF-000009', NULL, 'Gas41 homologue, putative', 157, NULL, NULL, 102590),
(102591, '2.60.120.10-FF-000089', NULL, 'cGMP-dependent protein kinase 5-1', 126, NULL, NULL, 102591),
(102592, '3.40.50.10810-FF-000124', NULL, 'RAD54 like', 98, NULL, NULL, 102592),
(102593, '2.60.40.1660-FF-000035', NULL, 'Sodium/potassium-dependent ATPase beta-2 subunit, putative', 70, NULL, NULL, 102593),
(102594, '3.30.70.330-FF-001726', NULL, NULL, 111, NULL, NULL, 102594),
(102595, '1.25.40.10-FF-004291', NULL, 'Uncharacterized protein', 201, NULL, NULL, 102595),
(102596, '3.40.50.1240-FF-000166', NULL, 'Uncharacterized protein', 479, NULL, NULL, 102596),
(102597, '3.40.50.720-FF-000758', NULL, 'Short-chain dehydrogenase/reductase family protein', 278, NULL, NULL, 102597),
(102598, '1.25.40.10-FF-000704', NULL, 'Cdc16p', 492, NULL, NULL, 102598),
(102599, '3.90.660.10-FF-000102', NULL, NULL, 238, NULL, NULL, 102599),
(102600, '1.10.510.10-FF-000246', NULL, 'Putative Serine-threonine kinase SepH', 289, NULL, NULL, 102600),
(102601, '1.20.58.60-FF-000028', NULL, 'Spectrin beta chain', 100, NULL, NULL, 102601),
(102602, '3.40.1380.20-FF-000072', NULL, 'Pyruvate kinase', 89, NULL, NULL, 102602),
(102603, '3.40.50.1820-FF-001655', NULL, 'Carboxypeptidase', 274, NULL, NULL, 102603),
(102604, '2.60.40.10-FF-005140', NULL, NULL, 121, NULL, NULL, 102604),
(102605, '1.10.10.60-FF-000891', NULL, NULL, 84, NULL, NULL, 102605),
(102606, '2.60.40.10-FF-004521', NULL, NULL, 107, NULL, NULL, 102606),
(102607, '2.130.10.10-FF-003555', NULL, 'Uncharacterized protein', 316, NULL, NULL, 102607),
(102608, '1.20.58.1930-FF-000007', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 227, NULL, NULL, 102608),
(102609, '3.30.160.60-FF-004061', NULL, NULL, 40, NULL, NULL, 102609),
(102610, '2.40.70.10-FF-000241', NULL, 'Acid protease', 189, NULL, NULL, 102610),
(102611, '3.30.870.10-FF-000103', NULL, 'Phosphatidylcholine-hydrolyzing phospholipase D (PLD) family', 165, NULL, NULL, 102611);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(102612, '3.30.360.10-FF-000126', NULL, 'Uncharacterized protein', 38, NULL, NULL, 102612),
(102613, '1.10.3210.10-FF-000037', NULL, 'Metal-dependent phosphohydrolase, HD superfamily', 275, NULL, NULL, 102613),
(102614, '3.30.40.100-FF-000005', NULL, 'uncharacterized protein LOC106759733 isoform X4', 69, NULL, NULL, 102614),
(102615, '2.60.40.10-FF-001773', NULL, 'Interference hedgehog', 101, NULL, NULL, 102615),
(102616, '1.20.1250.20-FF-001940', NULL, 'Autophagy-related protein 22-1', 462, NULL, NULL, 102616),
(102617, '2.60.40.1670-FF-000026', NULL, NULL, 161, NULL, NULL, 102617),
(102618, '1.10.506.10-FF-000028', NULL, 'RAS p21 protein activator 3', 89, NULL, NULL, 102618),
(102619, '3.20.20.70-FF-000176', NULL, 'N-(5''-phosphoribosyl)anthranilate isomerase', 215, NULL, NULL, 102619),
(102620, '3.40.50.2300-FF-000624', NULL, 'Glutamate receptor subunit', 148, NULL, NULL, 102620),
(102621, '3.30.40.10-FF-001171', NULL, 'Uncharacterized protein', 80, NULL, NULL, 102621),
(102622, '3.40.50.1440-FF-000001', NULL, 'Cell division protein FtsZ', 217, NULL, NULL, 102622),
(102623, '2.30.29.90-FF-000012', NULL, 'GTP-Rho binding exocyst subunit', 147, NULL, NULL, 102623),
(102624, '2.30.30.750-FF-000005', NULL, NULL, 94, NULL, NULL, 102624),
(102625, '3.40.30.10-FF-000860', NULL, 'Uncharacterized protein', 100, NULL, NULL, 102625),
(102626, '3.40.50.960-FF-000015', NULL, 'Predicted protein', 157, NULL, NULL, 102626),
(102627, '1.10.285.10-FF-000014', NULL, 'Glutamate dehydrogenase', 30, NULL, NULL, 102627),
(102628, '2.60.40.1510-FF-000018', NULL, 'Alpha L integrin', 151, NULL, NULL, 102628),
(102629, '3.90.79.10-FF-000083', NULL, '7,8-dihydro-8-oxoguanine triphosphatase', 158, NULL, NULL, 102629),
(102630, '2.40.100.10-FF-000070', NULL, 'BnaA05g33830D protein', 180, NULL, NULL, 102630),
(102631, '1.10.10.1050-FF-000004', NULL, 'mRNA-decapping enzyme 2, putative', 86, NULL, NULL, 102631),
(102632, '2.10.25.10-FF-000880', NULL, 'Uncharacterized protein, isoform A', 32, NULL, NULL, 102632),
(102633, '1.20.1080.10-FF-000030', NULL, 'Aquaporin Z', 220, NULL, NULL, 102633),
(102634, '3.40.50.2000-FF-000309', NULL, 'Glycogen synthase', 210, NULL, NULL, 102634),
(102635, '3.40.50.2300-FF-001136', NULL, 'Uncharacterized protein', 237, NULL, NULL, 102635),
(102636, '3.30.565.10-FF-000321', NULL, 'Hybrid sensor histidine kinase/response regulator', 164, NULL, NULL, 102636),
(102637, '1.10.510.10-FF-001882', NULL, 'Putative dual specificity protein phosphatase', 276, NULL, NULL, 102637),
(102638, '3.30.70.330-FF-000108', NULL, 'Heterogeneous nuclear ribonucleoproteins A2/B1', 81, NULL, NULL, 102638),
(102639, '3.90.228.20-FF-000011', NULL, NULL, 57, NULL, NULL, 102639),
(102640, '3.10.20.90-FF-000379', NULL, 'Ubiquitin/ribosomal protein CEP52', 81, NULL, NULL, 102640),
(102641, '3.40.50.300-FF-002425', NULL, 'Uncharacterized protein, isoform A', 151, NULL, NULL, 102641),
(102642, '3.30.70.1230-FF-000238', NULL, 'Adenylate cyclase, putative', 153, NULL, NULL, 102642),
(102643, '3.40.710.10-FF-000129', NULL, 'Penicillin-binding protein', 217, NULL, NULL, 102643),
(102644, '3.90.740.10-FF-000047', NULL, 'Leucine--tRNA ligase, putative', 27, NULL, NULL, 102644),
(102645, '3.90.260.10-FF-000010', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 303, NULL, NULL, 102645),
(102646, '3.20.20.300-FF-000013', NULL, 'Probable exo-1,4-beta-xylosidase xlnD', 328, NULL, NULL, 102646),
(102647, '1.10.760.10-FF-000068', NULL, 'C-type cytochrome', 119, NULL, NULL, 102647),
(102648, '3.60.70.12-FF-000010', NULL, 'Arginine biosynthesis bifunctional protein ArgJ 1, mitochondrial', 113, NULL, NULL, 102648),
(102649, '2.60.120.740-FF-000006', NULL, 'Protein eva-1 C', 115, NULL, NULL, 102649),
(102650, '2.130.10.10-FF-000806', NULL, 'WD repeat-containing protein 6', 251, NULL, NULL, 102650),
(102651, '3.30.70.330-FF-002238', NULL, NULL, 75, NULL, NULL, 102651),
(102652, '1.25.40.20-FF-000802', NULL, 'M-T5', 198, NULL, NULL, 102652),
(102653, '1.10.560.10-FF-000087', NULL, 'Bardet-Biedl syndrome 12', 110, NULL, NULL, 102653);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(102654, '2.130.10.10-FF-000913', NULL, 'WD repeat domain phosphoinositide-interacting protein 1', 269, NULL, NULL, 102654),
(102655, '2.60.200.20-FF-000149', NULL, 'CAMK/RAD53 protein kinase', 113, NULL, NULL, 102655),
(102656, '2.10.25.10-FF-001167', NULL, 'Drosophila CRumBs homolog', 40, NULL, NULL, 102656),
(102657, '3.50.50.60-FF-000432', NULL, 'L-ornithine N(5)-monooxygenase', 435, NULL, NULL, 102657),
(102658, '1.10.720.30-FF-000066', NULL, 'Uncharacterized protein', 36, NULL, NULL, 102658),
(102659, '2.60.40.10-FF-002048', NULL, 'Muscle M-line assembly protein unc-89', 96, NULL, NULL, 102659),
(102660, '2.60.40.60-FF-000579', NULL, 'Uncharacterized protein', 103, NULL, NULL, 102660),
(102661, '2.60.120.200-FF-000182', NULL, 'MAM and LDL-receptor class A domain-containing protein 1', 163, NULL, NULL, 102661),
(102662, '1.10.238.10-FF-000326', NULL, 'IRS4p EH domain-containing protein', 140, NULL, NULL, 102662),
(102663, '1.25.40.10-FF-002834', NULL, 'Tetratricopeptide repeat, putative', 137, NULL, NULL, 102663),
(102664, '4.10.410.20-FF-000011', NULL, 'Poly(U)-specific endoribonuclease', 42, NULL, NULL, 102664),
(102665, '3.30.450.40-FF-000007', NULL, 'Phosphodiesterase', 175, NULL, NULL, 102665),
(102666, '2.30.230.10-FF-000014', NULL, 'Vitellogenin 7', 102, NULL, NULL, 102666),
(102667, '3.30.60.270-FF-000009', NULL, 'Sortilin', 72, NULL, NULL, 102667),
(102668, '2.40.50.140-FF-000650', NULL, 'Single-stranded DNA-binding protein', 122, NULL, NULL, 102668),
(102669, '1.10.10.60-FF-000902', NULL, NULL, 51, NULL, NULL, 102669),
(102670, '1.20.59.10-FF-000010', NULL, 'Chorismate mutase', 87, NULL, NULL, 102670),
(102671, '1.25.40.10-FF-000693', NULL, 'Tetratricopeptide repeat domain 30A', 125, NULL, NULL, 102671),
(102672, '1.10.238.10-FF-000433', NULL, 'Flagellar calcium-binding protein TB-24', 218, NULL, NULL, 102672),
(102673, '1.20.58.60-FF-000360', NULL, 'VAB-10B protein', 114, NULL, NULL, 102673),
(102674, '3.50.50.60-FF-000201', NULL, 'Salicylate hydroxylase protein', 386, NULL, NULL, 102674),
(102675, '2.60.40.10-FF-002279', NULL, 'Cilia- and flagella-associated protein 74', 107, NULL, NULL, 102675),
(102676, '3.30.559.10-FF-000279', NULL, 'Uncharacterized protein', 136, NULL, NULL, 102676),
(102677, '4.10.400.10-FF-000069', NULL, 'complement component C8 beta chain', 36, NULL, NULL, 102677),
(102678, '1.10.472.80-FF-000127', NULL, 'Rab GTPase activating protein, putative', 104, NULL, NULL, 102678),
(102679, '2.60.40.10-FF-003010', NULL, 'Uncharacterized protein', 145, NULL, NULL, 102679),
(102680, '3.40.50.880-FF-000093', NULL, 'Cyclin 1, putative', 257, NULL, NULL, 102680),
(102681, '3.30.160.60-FF-000463', NULL, 'Krueppel-like factor 5', 23, NULL, NULL, 102681),
(102682, '3.10.580.10-FF-000226', NULL, 'Chloride channel protein', 78, NULL, NULL, 102682),
(102683, '2.60.34.10-FF-000084', NULL, 'Heat shock 70-related protein 5', 118, NULL, NULL, 102683),
(102684, '3.40.47.10-FF-000062', NULL, 'Acetyl-CoA acetyltransferase FadA2', 430, NULL, NULL, 102684),
(102685, '3.30.200.20-FF-000192', NULL, 'Serine/threonine-protein kinase cot-1', 111, NULL, NULL, 102685),
(102686, '3.30.2160.10-FF-000032', NULL, 'HECT, UBA and WWE domain containing 1, E3 ubiquitin protein ligase', 41, NULL, NULL, 102686),
(102687, '2.30.30.40-FF-000338', NULL, 'Transport and Golgi organization protein 1', 92, NULL, NULL, 102687),
(102688, '3.40.50.1000-FF-000217', NULL, 'P-type ATPase, putative', 177, NULL, NULL, 102688),
(102689, '3.30.420.40-FF-000399', NULL, 'Probable apyrase 7', 146, NULL, NULL, 102689),
(102690, '3.40.50.1970-FF-000036', NULL, 'Glycerol-1-phosphate dehydrogenase [NAD(P)+]', 162, NULL, NULL, 102690),
(102691, '2.40.170.20-FF-000021', NULL, 'Vitamin B12 transporter BtuB', 454, NULL, NULL, 102691),
(102692, '1.10.287.950-FF-000053', NULL, 'Chemotaxis signal transduction system methyl accepting sensory transducer', 232, NULL, NULL, 102692),
(102693, '3.30.70.2630-FF-000001', NULL, 'Telomerase reverse transcriptase', 87, NULL, NULL, 102693),
(102694, '3.40.50.300-FF-004573', NULL, 'Tornado 1', 203, NULL, NULL, 102694);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(102695, '2.30.18.10-FF-000014', NULL, 'Transcription initiation factor IIA large subunit isoform A', 45, NULL, NULL, 102695),
(102696, '1.10.418.10-FF-000217', NULL, 'Uncharacterized protein', 164, NULL, NULL, 102696),
(102697, '3.40.50.2300-FF-000517', NULL, 'Vomeronasal 2, receptor 96', 149, NULL, NULL, 102697),
(102698, '3.40.630.10-FF-000415', NULL, 'Predicted protein', 302, NULL, NULL, 102698),
(102699, '1.20.1560.10-FF-000853', NULL, 'Uncharacterized protein', 261, NULL, NULL, 102699),
(102700, '3.40.50.1820-FF-001548', NULL, 'Abhydrolase domain-containing protein, putative', 125, NULL, NULL, 102700),
(102701, '1.10.287.110-FF-000037', NULL, 'Chaperone protein dnaJ A6 chloroplastic', 107, NULL, NULL, 102701),
(102702, '1.25.40.20-FF-000926', NULL, 'KN motif and ankyrin repeat domain-containing protein 1', 248, NULL, NULL, 102702),
(102703, '1.10.472.10-FF-000371', NULL, 'G2/mitotic-specific cyclin A, putative', 109, NULL, NULL, 102703),
(102704, '3.80.10.10-FF-003847', NULL, 'Protein phosphatase 2C, putative', 137, NULL, NULL, 102704),
(102705, '1.25.10.10-FF-000180', NULL, 'DnaJ homolog subfamily C GRV2', 277, NULL, NULL, 102705),
(102706, '3.40.50.150-FF-001739', NULL, NULL, 99, NULL, NULL, 102706),
(102707, '3.40.190.10-FF-000375', NULL, 'Alkaline phosphatase L', 209, NULL, NULL, 102707),
(102708, '1.20.1280.290-FF-000064', NULL, 'Uncharacterized protein', 90, NULL, NULL, 102708),
(102709, '1.10.1140.10-FF-000020', NULL, 'Uncharacterized protein', 52, NULL, NULL, 102709),
(102710, '1.20.58.340-FF-000015', NULL, 'magnesium transporter MRS2-4', 205, NULL, NULL, 102710),
(102711, '2.40.50.100-FF-000211', NULL, 'ABC transporter ATP-binding protein', 57, NULL, NULL, 102711),
(102712, '2.10.50.10-FF-000168', NULL, 'Nerve growth factor receptor a (TNFR superfamily, member 16)', 75, NULL, NULL, 102712),
(102713, '1.10.640.10-FF-000014', NULL, 'Uncharacterized protein', 570, NULL, NULL, 102713),
(102714, '3.40.50.300-FF-002549', NULL, 'Tetracycline resistance protein, GTP-binding elongation family', 246, NULL, NULL, 102714),
(102715, '3.30.160.60-FF-004858', NULL, NULL, 28, NULL, NULL, 102715),
(102716, '3.30.420.140-FF-000024', NULL, 'Transcription accessory protein (S1 RNA-binding domain)', 128, NULL, NULL, 102716),
(102717, '3.40.50.1820-FF-000351', NULL, 'POSSIBLE HYDROLASE', 293, NULL, NULL, 102717),
(102718, '1.10.10.10-FF-001753', NULL, 'AGAP010898-PA', 60, NULL, NULL, 102718),
(102719, '2.102.10.10-FF-000049', NULL, 'Nitrite reductase [NAD(P)H] small subunit', 112, NULL, NULL, 102719),
(102720, '3.40.630.10-FF-000292', NULL, 'Glutamate carboxypeptidase, putative', 57, NULL, NULL, 102720),
(102721, '3.30.70.330-FF-000889', NULL, 'Poly(A) binding protein', 152, NULL, NULL, 102721),
(102722, '1.10.460.10-FF-000028', NULL, 'DNA topoisomerase', 174, NULL, NULL, 102722),
(102723, '3.30.200.20-FF-000646', NULL, 'Cyclin dependent kinase 10', 66, NULL, NULL, 102723),
(102724, '2.30.42.10-FF-000227', NULL, 'PDZ domain containing 2', 123, NULL, NULL, 102724),
(102725, '3.40.350.10-FF-000034', NULL, 'Ectoine hydrolase DoeA', 157, NULL, NULL, 102725),
(102726, '1.20.120.730-FF-000013', NULL, 'Protein transport protein SEC23', 127, NULL, NULL, 102726),
(102727, '2.40.30.30-FF-000020', NULL, 'Riboflavin kinase, putative', 173, NULL, NULL, 102727),
(102728, '1.20.1250.20-FF-001703', NULL, 'Predicted protein', 320, NULL, NULL, 102728),
(102729, '2.70.98.20-FF-000003', NULL, 'Amine oxidase', 444, NULL, NULL, 102729),
(102730, '3.40.190.10-FF-000156', NULL, 'Phosphate ABC transporter, phosphate-binding protein', 144, NULL, NULL, 102730),
(102731, '3.40.50.300-FF-008046', NULL, 'Uncharacterized protein', 129, NULL, NULL, 102731),
(102732, '1.25.10.10-FF-000865', NULL, 'Serine/threonine-protein phosphatase 2A 56 kDa regulatory subunit', 65, NULL, NULL, 102732),
(102733, '2.60.120.650-FF-000075', NULL, 'Uncharacterized protein B13D15.230', 234, NULL, NULL, 102733),
(102734, '3.40.50.1820-FF-000019', NULL, '1-acylglycerol-3-phosphate O-acyltransferase ABHD5', 313, NULL, NULL, 102734),
(102735, '3.40.50.620-FF-000498', NULL, 'Phosphoadenosine-phosphosulphate reductase', 227, NULL, NULL, 102735);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(102736, '1.25.40.10-FF-003559', NULL, 'Predicted protein', 429, NULL, NULL, 102736),
(102737, '3.90.1100.10-FF-000003', NULL, 'DNA-directed RNA polymerase subunit beta', 182, NULL, NULL, 102737),
(102738, '2.60.40.770-FF-000012', NULL, 'GG17324', 134, NULL, NULL, 102738),
(102739, '3.40.50.2000-FF-000641', NULL, 'ADP-heptose:LPS heptosyltransferase', 170, NULL, NULL, 102739),
(102740, '3.40.850.10-FF-000398', NULL, 'Uncharacterized protein', 282, NULL, NULL, 102740),
(102741, '1.25.40.10-FF-002615', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', 152, NULL, NULL, 102741),
(102742, '3.40.30.10-FF-000528', NULL, 'Glutathione peroxidase', 181, NULL, NULL, 102742),
(102743, '3.30.1140.60-FF-000017', NULL, 'Chromosome 1, whole genome shotgun sequence', 126, NULL, NULL, 102743),
(102744, '2.40.50.690-FF-000005', NULL, 'Exosome complex exonuclease dis3', 117, NULL, NULL, 102744),
(102745, '3.40.50.720-FF-000073', NULL, 'UDP-glucuronic acid decarboxylase 2', 126, NULL, NULL, 102745),
(102746, '2.10.25.10-FF-000548', NULL, 'Multimerin 1', 80, NULL, NULL, 102746),
(102747, '3.30.40.10-FF-001968', NULL, 'RING/U-box superfamily protein', 63, NULL, NULL, 102747),
(102748, '3.30.1540.20-FF-000002', NULL, 'Putative mismatch repair endonuclease PMS2', 73, NULL, NULL, 102748),
(102749, '3.30.70.330-FF-002126', NULL, NULL, 154, NULL, NULL, 102749),
(102750, '3.40.50.200-FF-000035', NULL, 'Tripeptidyl peptidase I', 243, NULL, NULL, 102750),
(102751, '1.10.10.580-FF-000014', NULL, 'Kleisin alpha', 102, NULL, NULL, 102751),
(102752, '3.40.50.970-FF-000131', NULL, '2-oxoisovalerate dehydrogenase, E1 component, alpha and beta subunit', 338, NULL, NULL, 102752),
(102753, '3.30.70.330-FF-000440', NULL, 'Putative RNA-binding protein ARP1', 89, NULL, NULL, 102753),
(102754, '2.70.98.10-FF-000124', NULL, 'Aldose 1-epimerase family protein, putative', 66, NULL, NULL, 102754),
(102755, '2.60.40.10-FF-000250', NULL, '1,4-alpha-glucan-branching enzyme, chloroplastic/amyloplastic', 115, NULL, NULL, 102755),
(102756, '1.10.10.820-FF-000025', NULL, 'Uncharacterized protein', 63, NULL, NULL, 102756),
(102757, '1.10.1380.10-FF-000015', NULL, 'Neprilysin-4', 27, NULL, NULL, 102757),
(102758, '3.30.460.10-FF-000185', NULL, 'Predicted protein', 36, NULL, NULL, 102758),
(102759, '3.40.50.300-FF-007771', NULL, 'Uncharacterized protein', 60, NULL, NULL, 102759),
(102760, '3.10.180.10-FF-000010', NULL, 'Glyoxalase domain-containing protein 4', 145, NULL, NULL, 102760),
(102761, '2.60.40.10-FF-003684', NULL, NULL, 97, NULL, NULL, 102761),
(102762, '3.90.550.10-FF-000442', NULL, 'Putative mannan synthase 7', 81, NULL, NULL, 102762),
(102763, '1.10.555.10-FF-000119', NULL, 'Rho GTPase-activating protein 33', 163, NULL, NULL, 102763),
(102764, '3.40.50.150-FF-000435', NULL, 'Proliferating-cell nucleolar antigen p120', 296, NULL, NULL, 102764),
(102765, '3.40.1370.10-FF-000017', NULL, '50S ribosomal protein L4', 205, NULL, NULL, 102765),
(102766, '1.20.140.100-FF-000042', NULL, 'YALI0E32857p', 153, NULL, NULL, 102766),
(102767, '3.40.50.300-FF-002206', NULL, 'ATP-dependent Clp protease, putative', 218, NULL, NULL, 102767),
(102768, '2.130.10.10-FF-001189', NULL, 'Periodic tryptophan protein 1', 218, NULL, NULL, 102768),
(102769, '3.40.50.300-FF-001588', NULL, 'Small GTPase rab5', 176, NULL, NULL, 102769),
(102770, '1.25.10.10-FF-001826', NULL, 'Uncharacterized protein', 269, NULL, NULL, 102770),
(102771, '3.40.30.10-FF-001260', NULL, 'Uncharacterized protein', 106, NULL, NULL, 102771),
(102772, '3.30.572.10-FF-000012', NULL, 'Thymidylate synthase', 317, NULL, NULL, 102772),
(102773, '3.40.390.10-FF-000137', NULL, 'Metalloendopeptidase', 225, NULL, NULL, 102773),
(102774, '1.20.5.370-FF-000007', NULL, 'Myosin heavy chain', 51, NULL, NULL, 102774),
(102775, '1.10.600.10-FF-000017', NULL, 'Solanesyl-diphosphate synthase 2, chloroplastic', 323, NULL, NULL, 102775),
(102776, '2.120.10.80-FF-000075', NULL, 'Multiple EGF like domains 8', 153, NULL, NULL, 102776),
(102777, '3.90.640.10-FF-000213', NULL, 'Uncharacterized protein', 84, NULL, NULL, 102777);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(102778, '3.40.50.1440-FF-000107', NULL, 'Uncharacterized protein', 116, NULL, NULL, 102778),
(102779, '2.40.10.120-FF-000001', NULL, 'Periplasmic serine endoprotease DegP-like', 235, NULL, NULL, 102779),
(102780, '3.10.20.90-FF-000598', NULL, 'IkB kinase', 82, NULL, NULL, 102780),
(102781, '1.10.10.10-FF-000573', NULL, 'HTH-type transcriptional regulator ArcR', 85, NULL, NULL, 102781),
(102782, '2.60.120.260-FF-000520', NULL, 'Beta-galactosidase 14', 121, NULL, NULL, 102782),
(102783, '3.30.160.60-FF-006314', NULL, NULL, 28, NULL, NULL, 102783),
(102784, '3.40.50.300-FF-002881', NULL, 'Putative snf2 family helicase atpase protein', 74, NULL, NULL, 102784),
(102785, '1.20.1250.20-FF-002322', NULL, 'Inhibitor of growth family protein 2like, putative', 68, NULL, NULL, 102785),
(102786, '3.40.640.10-FF-000230', NULL, 'Neamine transaminase NeoN', 221, NULL, NULL, 102786),
(102787, '3.30.160.60-FF-003908', NULL, NULL, 30, NULL, NULL, 102787),
(102788, '1.25.40.20-FF-000241', NULL, 'No mechanoreceptor potential C, isoform D', 99, NULL, NULL, 102788),
(102789, '3.80.10.10-FF-003162', NULL, 'Uncharacterized protein', 281, NULL, NULL, 102789),
(102790, '1.20.920.20-FF-000008', NULL, 'Dynein heavy chain 10, axonemal', 340, NULL, NULL, 102790),
(102791, '1.10.1070.11-FF-000038', NULL, 'Serine/threonine-protein kinase Tel1', 188, NULL, NULL, 102791),
(102792, '1.10.630.10-FF-000188', NULL, 'Cytochrome P450, putative (Eurofung)', 467, NULL, NULL, 102792),
(102793, '1.20.1250.20-FF-001029', NULL, 'AGAP000718-PA', 195, NULL, NULL, 102793),
(102794, '1.50.40.10-FF-000281', NULL, 'GD20812', 191, NULL, NULL, 102794),
(102795, '3.50.50.60-FF-000887', NULL, 'Uncharacterized protein', 472, NULL, NULL, 102795),
(102796, '2.30.42.10-FF-000008', NULL, 'microtubule-associated serine/threonine-protein kinase 4 isoform X2', 97, NULL, NULL, 102796),
(102797, '3.40.30.10-FF-000309', NULL, 'Formate dehydrogenase, gamma subunit', 84, NULL, NULL, 102797),
(102798, '3.40.30.10-FF-000984', NULL, 'Anterior gradient 1', 90, NULL, NULL, 102798),
(102799, '3.50.50.60-FF-001505', NULL, 'Uncharacterized protein', 25, NULL, NULL, 102799),
(102800, '1.25.10.10-FF-002102', NULL, 'Sister chromatid cohesion protein', 242, NULL, NULL, 102800),
(102801, '1.25.10.10-FF-001484', NULL, 'HEAT repeat containing protein', 344, NULL, NULL, 102801),
(102802, '2.40.50.140-FF-000431', NULL, 'Probable DPS1-aspartyl-tRNA synthetase, cytosolic', 133, NULL, NULL, 102802),
(102803, '3.40.50.1820-FF-001767', NULL, 'Carboxypeptidase', 219, NULL, NULL, 102803),
(102804, '1.10.510.10-FF-004299', NULL, NULL, 159, NULL, NULL, 102804),
(102805, '3.40.50.12650-FF-000002', NULL, 'DNA cross-link repair 1C', 145, NULL, NULL, 102805),
(102806, '3.80.10.10-FF-003504', NULL, 'Fgr28p', 187, NULL, NULL, 102806),
(102807, '3.80.20.20-FF-000012', NULL, 'Receptor protein-tyrosine kinase', 117, NULL, NULL, 102807),
(102808, '2.130.10.10-FF-003100', NULL, 'Mono-functional DNA-alkylating methyl methanesulfonate N-term-domain-containing protein', 303, NULL, NULL, 102808),
(102809, '2.170.150.10-FF-000008', NULL, 'D-threonine aldolase', 180, NULL, NULL, 102809),
(102810, '3.30.200.20-FF-000989', NULL, 'NEK protein kinase', 50, NULL, NULL, 102810),
(102811, '2.60.200.20-FF-000025', NULL, 'Forkhead box protein K2', 112, NULL, NULL, 102811),
(102812, '3.40.30.160-FF-000002', NULL, 'Microbial collagenase', 147, NULL, NULL, 102812),
(102813, '1.25.40.10-FF-001997', NULL, 'TPR domain protein', 74, NULL, NULL, 102813),
(102814, '3.40.1810.10-FF-000046', NULL, 'Agamous-like MADS-box protein AGL92', 97, NULL, NULL, 102814),
(102815, '3.30.160.60-FF-001767', NULL, 'Zinc finger protein 629', 28, NULL, NULL, 102815),
(102816, '1.25.40.70-FF-000008', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', 194, NULL, NULL, 102816),
(102817, '3.60.10.10-FF-000240', NULL, 'Endonuclease/exonuclease/phosphatase', 303, NULL, NULL, 102817),
(102818, '2.10.50.30-FF-000051', NULL, 'Uncharacterized protein', 43, NULL, NULL, 102818),
(102819, '1.25.40.10-FF-003891', NULL, 'Uncharacterized protein', 78, NULL, NULL, 102819);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(102820, '2.60.40.1110-FF-000005', NULL, 'Phosphatase and tensin homolog', 143, NULL, NULL, 102820),
(102821, '4.10.280.10-FF-000188', NULL, 'Transcription factor bHLH66', 52, NULL, NULL, 102821),
(102822, '2.130.10.10-FF-005230', NULL, 'Uncharacterized protein', 56, NULL, NULL, 102822),
(102823, '1.25.40.10-FF-002273', NULL, 'Uncharacterized protein', 194, NULL, NULL, 102823),
(102824, '3.30.200.20-FF-001265', NULL, 'MOK protein kinase', 101, NULL, NULL, 102824),
(102825, '1.20.120.1900-FF-000057', NULL, 'Spindle pole body component', 282, NULL, NULL, 102825),
(102826, '3.40.525.10-FF-000053', NULL, 'Protein tyrosine phosphatase, non-receptor type 9', 81, NULL, NULL, 102826),
(102827, '3.30.160.60-FF-001424', NULL, 'Zinc finger and BTB domain-containing protein 21', 31, NULL, NULL, 102827),
(102828, '3.30.160.60-FF-002043', NULL, 'Zinc finger protein, putative', 24, NULL, NULL, 102828),
(102829, '3.80.10.10-FF-000413', NULL, 'Inactive leucine-rich repeat receptor-like protein kinase', 99, NULL, NULL, 102829),
(102830, '3.40.367.20-FF-000002', NULL, 'Glucokinase', 200, NULL, NULL, 102830),
(102831, '3.30.450.20-FF-000468', NULL, 'Hif-1', 83, NULL, NULL, 102831),
(102832, '3.30.420.40-FF-000056', NULL, 'Molecular chaperone DnaK', 80, NULL, NULL, 102832),
(102833, '2.160.20.10-FF-000255', NULL, 'Uncharacterized protein', 80, NULL, NULL, 102833),
(102834, '1.20.142.10-FF-000001', NULL, 'Poly [ADP-ribose] polymerase', 144, NULL, NULL, 102834),
(102835, '3.40.720.10-FF-000175', NULL, 'Alkaline-phosphatase-like family protein', 67, NULL, NULL, 102835),
(102836, '3.40.50.150-FF-001054', NULL, 'Methyltransferase', 278, NULL, NULL, 102836),
(102837, '3.30.300.90-FF-000006', NULL, 'Protein BOLA2', 92, NULL, NULL, 102837),
(102838, '1.20.1270.10-FF-000078', NULL, 'Uncharacterized protein', 102, NULL, NULL, 102838),
(102839, '3.30.160.60-FF-001082', NULL, 'zinc finger and BTB domain-containing protein 16', 32, NULL, NULL, 102839),
(102840, '1.10.730.20-FF-000013', NULL, 'tRNA synthetases class I-domain-containing protein', 284, NULL, NULL, 102840),
(102841, '2.40.50.140-FF-001268', NULL, NULL, 100, NULL, NULL, 102841),
(102842, '2.60.40.10-FF-000811', NULL, 'Titin a', 100, NULL, NULL, 102842),
(102843, '3.30.1490.490-FF-000001', NULL, 'cell growth-regulating nucleolar protein-like', 50, NULL, NULL, 102843),
(102844, '1.10.472.10-FF-000039', NULL, 'RB transcriptional corepressor 1', 184, NULL, NULL, 102844),
(102845, '3.40.50.11980-FF-000003', NULL, 'Mitochondrial ribonuclease P catalytic subunit', 162, NULL, NULL, 102845),
(102846, '1.10.1420.10-FF-000171', NULL, 'Uncharacterized protein', 170, NULL, NULL, 102846),
(102847, '1.25.70.10-FF-000077', NULL, NULL, 238, NULL, NULL, 102847),
(102848, '3.20.20.80-FF-000510', NULL, 'Klotho', 333, NULL, NULL, 102848),
(102849, '1.25.40.820-FF-000032', NULL, 'Predicted protein', 151, NULL, NULL, 102849),
(102850, '1.25.40.20-FF-001202', NULL, 'Predicted protein', 127, NULL, NULL, 102850),
(102851, '1.10.150.240-FF-000072', NULL, 'AT29272p', 68, NULL, NULL, 102851),
(102852, '3.40.50.410-FF-000328', NULL, 'Protein transport protein SEC23', 183, NULL, NULL, 102852),
(102853, '1.20.1280.50-FF-000124', NULL, 'Zgc:171857', 80, NULL, NULL, 102853),
(102854, '3.80.10.10-FF-004123', NULL, 'Uncharacterized protein', 113, NULL, NULL, 102854),
(102855, '1.10.238.10-FF-001288', NULL, 'Uncharacterized protein', 83, NULL, NULL, 102855),
(102856, '2.30.30.40-FF-000670', NULL, 'Uncharacterized protein', 64, NULL, NULL, 102856),
(102857, '3.40.50.720-FF-002091', NULL, 'Uncharacterized protein', 135, NULL, NULL, 102857),
(102858, '3.40.50.150-FF-000778', NULL, 'Amine oxidase', 184, NULL, NULL, 102858),
(102859, '2.130.10.10-FF-002482', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 223, NULL, NULL, 102859),
(102860, '3.40.50.300-FF-006135', NULL, 'ATP-binding cassette, sub-family G (WHITE), member 2c', 129, NULL, NULL, 102860),
(102861, '3.80.10.10-FF-002886', NULL, 'Uncharacterized protein', 339, NULL, NULL, 102861),
(102862, '3.30.9.10-FF-000261', NULL, 'Uncharacterized protein', 158, NULL, NULL, 102862);
INSERT INTO "PUBLIC"."MODEL" VALUES
(102863, '2.10.220.10-FF-000052', NULL, 'proprotein convertase subtilisin/kexin type 6 isoform X1', 56, NULL, NULL, 102863),
(102864, '3.30.160.60-FF-002947', NULL, NULL, 31, NULL, NULL, 102864),
(102865, '3.30.830.10-FF-000106', NULL, 'Pitrilysin-like metalloprotease', 283, NULL, NULL, 102865),
(102866, '3.10.129.10-FF-000004', NULL, 'Tol-pal system-associated acyl-CoA thioesterase', 134, NULL, NULL, 102866),
(102867, '2.40.10.10-FF-000479', NULL, NULL, 110, NULL, NULL, 102867),
(102868, '3.50.50.60-FF-001163', NULL, 'Uncharacterized protein', 39, NULL, NULL, 102868),
(102869, '3.30.780.10-FF-000001', NULL, 'Eukaryotic translation initiation factor SUI1', 112, NULL, NULL, 102869),
(102870, '2.40.50.40-FF-000018', NULL, 'Chromodomain Y like 2', 63, NULL, NULL, 102870),
(102871, '1.10.10.60-FF-001178', NULL, NULL, 98, NULL, NULL, 102871),
(102872, '3.40.1710.10-FF-000005', NULL, 'ESAT-6 secretion accessory factor EsaA', 183, NULL, NULL, 102872),
(102873, '3.20.10.10-FF-000028', NULL, 'Branched-chain-amino-acid transaminase', 156, NULL, NULL, 102873),
(102874, '3.60.40.10-FF-000079', NULL, 'Probable protein phosphatase 2C 74', 269, NULL, NULL, 102874),
(102875, '3.40.50.300-FF-005859', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', 281, NULL, NULL, 102875),
(102876, '3.30.70.20-FF-000040', NULL, 'Electron transporter YccM', 56, NULL, NULL, 102876),
(102877, '1.10.167.10-FF-000021', NULL, 'A-kinase anchor protein 10, mitochondrial', 139, NULL, NULL, 102877),
(102878, '3.30.1680.10-FF-000066', NULL, 'Integrin beta', 55, NULL, NULL, 102878),
(102879, '1.10.4080.10-FF-000004', NULL, 'Uncharacterized protein', 347, NULL, NULL, 102879),
(102880, '1.10.472.10-FF-000477', NULL, 'L-ascorbate peroxidase 2 cytosolic', 62, NULL, NULL, 102880),
(102881, '1.50.10.20-FF-000113', NULL, 'Transcobalamin II', 179, NULL, NULL, 102881),
(102882, '3.30.200.20-FF-002226', NULL, 'Uncharacterized protein', 39, NULL, NULL, 102882),
(102883, '1.20.5.780-FF-000012', NULL, 'FXYD domain-containing ion transport regulator', 55, NULL, NULL, 102883),
(102884, '3.90.1200.10-FF-000056', NULL, 'RE28849p', 186, NULL, NULL, 102884),
(102885, '3.30.1370.10-FF-000076', NULL, 'KH domain protein', 104, NULL, NULL, 102885),
(102886, '1.20.1280.20-FF-000020', NULL, 'AGR164Cp', 83, NULL, NULL, 102886),
(102887, '2.70.70.10-FF-000004', NULL, 'NlpD family lipoprotein', 160, NULL, NULL, 102887),
(102888, '3.20.20.80-FF-000853', NULL, 'Predicted protein', 104, NULL, NULL, 102888),
(102889, '3.40.50.1580-FF-000026', NULL, 'Aminodeoxyfutalosine nucleosidase', 232, NULL, NULL, 102889),
(102890, '1.20.5.190-FF-000055', NULL, 'Putative microtubule-associated protein futsch', 49, NULL, NULL, 102890),
(102891, '3.30.470.10-FF-000011', NULL, '4-amino-4-deoxychorismate lyase', 117, NULL, NULL, 102891),
(102892, '1.10.510.10-FF-002843', NULL, 'eIF-2-alpha kinase GCN2', 274, NULL, NULL, 102892),
(102893, '3.90.1480.20-FF-000040', NULL, 'Uncharacterized protein', 283, NULL, NULL, 102893),
(102894, '3.30.450.20-FF-000125', NULL, 'Histidine kinase', 166, NULL, NULL, 102894),
(102895, '3.90.1150.10-FF-000282', NULL, 'Serine-palmitoyl-CoA transferase, putative', 59, NULL, NULL, 102895),
(102896, '3.30.1490.100-FF-000042', NULL, 'Predicted protein', 47, NULL, NULL, 102896),
(102897, '3.40.50.300-FF-000284', NULL, 'probable ATP-dependent RNA helicase YTHDC2', 229, NULL, NULL, 102897),
(102898, '3.30.360.50-FF-000003', NULL, 'S-adenosylmethionine decarboxylase proenzyme isoform X2', 41, NULL, NULL, 102898),
(102899, '1.20.58.60-FF-000141', NULL, 'Microtubule-actin cross-linking factor 1', 222, NULL, NULL, 102899),
(102900, '2.60.220.50-FF-000131', NULL, 'Adhesion G protein-coupled receptor E17', 171, NULL, NULL, 102900),
(102901, '3.40.50.720-FF-001938', NULL, 'Sll6053 protein', 278, NULL, NULL, 102901),
(102902, '3.40.47.10-FF-000168', NULL, NULL, 243, NULL, NULL, 102902),
(102903, '1.20.1070.10-FF-000422', NULL, 'Protein CBG07754', 309, NULL, NULL, 102903),
(102904, '3.90.25.10-FF-000020', NULL, 'Udp-sulfoquinovose synthase, chloroplastic', 135, NULL, NULL, 102904);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(102905, '3.90.1860.10-FF-000021', NULL, 'Uncharacterized protein', 33, NULL, NULL, 102905),
(102906, '2.60.210.10-FF-000085', NULL, NULL, 209, NULL, NULL, 102906),
(102907, '1.20.58.80-FF-000023', NULL, 'Chitin synthase 1', 73, NULL, NULL, 102907),
(102908, '3.90.190.10-FF-000358', NULL, 'Uncharacterized protein', 170, NULL, NULL, 102908),
(102909, '3.30.420.40-FF-000293', NULL, 'Actin, putative', 158, NULL, NULL, 102909),
(102910, '3.30.519.10-FF-000046', NULL, NULL, 55, NULL, NULL, 102910),
(102911, '3.40.50.300-FF-004679', NULL, 'MSH (MutS Homolog) family', 255, NULL, NULL, 102911),
(102912, '3.40.50.300-FF-005298', NULL, 'Protein-tyrosine sulfotransferase', 287, NULL, NULL, 102912),
(102913, '1.10.10.10-FF-000117', NULL, 'Two-component system response regulator BaeR', 106, NULL, NULL, 102913),
(102914, '6.10.140.2220-FF-000047', NULL, 'Zinc finger MYND domain-containing protein 10', 54, NULL, NULL, 102914),
(102915, '2.30.29.30-FF-000253', NULL, 'F-actin-uncapping protein LRRC16A isoform X1', 114, NULL, NULL, 102915),
(102916, '2.60.40.10-FF-000137', NULL, 'neural cell adhesion molecule 1 isoform X2', 96, NULL, NULL, 102916),
(102917, '3.30.505.10-FF-000104', NULL, 'Phosphoinositide 3-kinase adapter subunit', 107, NULL, NULL, 102917),
(102918, '1.20.1050.10-FF-000191', NULL, 'Glutathione S-transferase, putative', 99, NULL, NULL, 102918),
(102919, '2.120.10.30-FF-000537', NULL, 'Uncharacterized protein', 106, NULL, NULL, 102919),
(102920, '3.30.70.1230-FF-000019', NULL, 'Guanylate cyclase', 223, NULL, NULL, 102920),
(102921, '3.30.420.40-FF-000511', NULL, 'N-acetyl-D-glucosamine kinase', 126, NULL, NULL, 102921),
(102922, '2.30.38.10-FF-000009', NULL, 'Nonribosomal peptide synthase inpB', 86, NULL, NULL, 102922),
(102923, '3.30.470.30-FF-000017', NULL, 'DNA ligase', 126, NULL, NULL, 102923),
(102924, '2.80.10.50-FF-000236', NULL, 'Uncharacterized protein', 121, NULL, NULL, 102924),
(102925, '2.10.110.10-FF-000061', NULL, 'Testin', 64, NULL, NULL, 102925),
(102926, '3.40.1110.10-FF-000476', NULL, NULL, 13, NULL, NULL, 102926),
(102927, '3.30.160.60-FF-005477', NULL, NULL, 28, NULL, NULL, 102927),
(102928, '3.30.70.330-FF-000546', NULL, 'Poly [ADP-ribose] polymerase', 73, NULL, NULL, 102928),
(102929, '2.10.25.10-FF-001728', NULL, 'Uncharacterized protein', 39, NULL, NULL, 102929),
(102930, '2.30.29.30-FF-000596', NULL, 'Downstream of kinase', 105, NULL, NULL, 102930),
(102931, '3.30.1370.100-FF-000037', NULL, 'DNA mismatch repair protein MutL', 95, NULL, NULL, 102931),
(102932, '2.10.70.10-FF-000276', NULL, 'Uncharacterized protein', 62, NULL, NULL, 102932),
(102933, '3.30.160.60-FF-002386', NULL, 'Zinc finger protein 556', 43, NULL, NULL, 102933),
(102934, '2.40.30.10-FF-000149', NULL, 'Translation initiation factor IF-2', 121, NULL, NULL, 102934),
(102935, '3.40.50.300-FF-006591', NULL, 'Uncharacterized protein', 98, NULL, NULL, 102935),
(102936, '1.10.10.10-FF-001410', NULL, 'Os06g0130800 protein', 125, NULL, NULL, 102936),
(102937, '1.20.1270.280-FF-000019', NULL, 'Dynein axonemal heavy chain 14', 200, NULL, NULL, 102937),
(102938, '3.30.420.10-FF-000750', NULL, NULL, 62, NULL, NULL, 102938),
(102939, '2.60.40.10-FF-001430', NULL, 'titin isoform X1', 100, NULL, NULL, 102939),
(102940, '3.30.160.60-FF-001986', NULL, 'zinc finger and SCAN domain-containing protein 2-like', 24, NULL, NULL, 102940),
(102941, '3.30.1890.10-FF-000003', NULL, 'Ferric enterobactin transport protein fepE', 277, NULL, NULL, 102941),
(102942, '1.25.50.20-FF-000067', NULL, 'Aminopeptidase', 263, NULL, NULL, 102942),
(102943, '1.20.120.20-FF-000043', NULL, 'Apolipoprotein A-I', 174, NULL, NULL, 102943),
(102944, '2.130.10.10-FF-005792', NULL, 'WD repeat and HMG-box DNA binding protein 1', 96, NULL, NULL, 102944),
(102945, '3.30.60.30-FF-000104', NULL, 'GEO08910p1', 47, NULL, NULL, 102945),
(102946, '1.25.40.990-FF-000055', NULL, 'Uncharacterized protein', 230, NULL, NULL, 102946),
(102947, '3.90.190.10-FF-000015', NULL, 'Dual specificity phosphatase 4', 151, NULL, NULL, 102947),
(102948, '1.10.3380.10-FF-000038', NULL, 'Uncharacterized protein', 168, NULL, NULL, 102948);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(102949, '1.50.40.10-FF-000404', NULL, 'Uncharacterized protein', 232, NULL, NULL, 102949),
(102950, '1.20.1110.10-FF-000246', NULL, NULL, 312, NULL, NULL, 102950),
(102951, '3.90.1030.20-FF-000012', NULL, NULL, 135, NULL, NULL, 102951),
(102952, '3.40.50.300-FF-000969', NULL, 'Ferrous iron transporter B', 167, NULL, NULL, 102952),
(102953, '1.25.10.10-FF-002445', NULL, 'Uncharacterized protein', 233, NULL, NULL, 102953),
(102954, '2.130.10.10-FF-005573', NULL, 'Uncharacterized protein', 208, NULL, NULL, 102954),
(102955, '1.10.10.180-FF-000001', NULL, 'Matrix protein 1', 89, NULL, NULL, 102955),
(102956, '2.170.220.10-FF-000003', NULL, 'Methionine--tRNA ligase', 114, NULL, NULL, 102956),
(102957, '2.60.40.2660-FF-000003', NULL, NULL, 48, NULL, NULL, 102957),
(102958, '1.20.1000.10-FF-000036', NULL, NULL, 273, NULL, NULL, 102958),
(102959, '2.60.120.10-FF-000325', NULL, 'Mannose-6-phosphate isomerase', 86, NULL, NULL, 102959),
(102960, '3.30.230.80-FF-000008', NULL, 'Molecular chaperone HtpG', 169, NULL, NULL, 102960),
(102961, '1.10.510.10-FF-002169', NULL, 'Mitogen-activated protein kinase sma-5', 246, NULL, NULL, 102961),
(102962, '2.40.30.20-FF-000028', NULL, 'Riboflavin synthase subunit alpha', 80, NULL, NULL, 102962),
(102963, '2.120.10.30-FF-000318', NULL, 'Blr3643 protein', 165, NULL, NULL, 102963),
(102964, '3.40.1110.10-FF-000257', NULL, NULL, 14, NULL, NULL, 102964),
(102965, '2.60.60.20-FF-000029', NULL, 'Predicted protein', 125, NULL, NULL, 102965),
(102966, '3.30.360.10-FF-000020', NULL, 'Biliverdin reductase A', 145, NULL, NULL, 102966),
(102967, '3.30.40.10-FF-000114', NULL, 'RING-type E3 ubiquitin transferase', 75, NULL, NULL, 102967),
(102968, '3.40.80.10-FF-000026', NULL, 'Uncharacterized protein', 190, NULL, NULL, 102968),
(102969, '3.40.50.300-FF-001245', NULL, 'ATP-dependent RNA helicase DbpA', 168, NULL, NULL, 102969),
(102970, '2.130.10.10-FF-001863', NULL, 'Peptidase S41', 124, NULL, NULL, 102970),
(102971, '3.30.160.60-FF-002728', NULL, 'metal regulatory transcription factor 1-like', 24, NULL, NULL, 102971),
(102972, '3.30.420.40-FF-000635', NULL, 'Cell division protein FtsA', 97, NULL, NULL, 102972),
(102973, '2.130.10.10-FF-002700', NULL, 'Uncharacterized protein', 322, NULL, NULL, 102973),
(102974, '1.20.120.1190-FF-000001', NULL, 'Nucleolar GTP-binding protein 1', 159, NULL, NULL, 102974),
(102975, '2.60.40.10-FF-006101', NULL, NULL, 100, NULL, NULL, 102975),
(102976, '3.40.50.800-FF-000119', NULL, 'Threonine--tRNA ligase editing subunit', 109, NULL, NULL, 102976),
(102977, '3.30.70.141-FF-000024', NULL, 'Nucleoside diphosphate kinase', 152, NULL, NULL, 102977),
(102978, '1.10.10.60-FF-000559', NULL, 'Unplaced genomic scaffold supercont1.71, whole genome shotgun sequence', 78, NULL, NULL, 102978),
(102979, '2.20.130.20-FF-000012', NULL, 'pregnancy zone protein-like', 82, NULL, NULL, 102979),
(102980, '2.60.40.10-FF-005825', NULL, NULL, 44, NULL, NULL, 102980),
(102981, '2.40.30.10-FF-000481', NULL, 'Predicted protein', 44, NULL, NULL, 102981),
(102982, '2.30.29.30-FF-001214', NULL, 'Phosphoinositide phospholipase C', 94, NULL, NULL, 102982),
(102983, '3.30.160.60-FF-003004', NULL, 'Zinc finger protein 560', 31, NULL, NULL, 102983),
(102984, '3.30.160.60-FF-002604', NULL, 'Zinc finger protein 715', 31, NULL, NULL, 102984),
(102985, '3.30.160.60-FF-006438', NULL, NULL, 35, NULL, NULL, 102985),
(102986, '3.80.10.10-FF-002667', NULL, 'Leucine-rich repeat transmembrane protein kinase', 161, NULL, NULL, 102986),
(102987, '1.10.1410.40-FF-000011', NULL, 'Uncharacterized protein', 61, NULL, NULL, 102987),
(102988, '2.40.10.10-FF-000136', NULL, 'Kallikrein related-peptidase 12', 78, NULL, NULL, 102988),
(102989, '3.40.50.150-FF-000093', NULL, 'mRNA cap guanine-N7 methyltransferase', 281, NULL, NULL, 102989),
(102990, '1.10.8.60-FF-000468', NULL, 'Uncharacterized protein', 85, NULL, NULL, 102990),
(102991, '2.110.10.10-FF-000043', NULL, 'Zmp-1', 212, NULL, NULL, 102991),
(102992, '2.20.25.10-FF-000008', NULL, 'DNA-directed RNA polymerase II subunit RPB9', 46, NULL, NULL, 102992); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(102993, '3.40.630.30-FF-000275', NULL, '[Ribosomal protein S18]-alanine N-acetyltransferase', 146, NULL, NULL, 102993),
(102994, '3.30.200.20-FF-000208', NULL, 'Ribosomal protein S6 kinase', 60, NULL, NULL, 102994),
(102995, '3.40.47.10-FF-000090', NULL, 'Lipid transfer protein or keto acyl-CoA thiolase Ltp2', 386, NULL, NULL, 102995),
(102996, '1.25.40.20-FF-000297', NULL, 'Asparaginase homolog (S. cerevisiae)', 119, NULL, NULL, 102996),
(102997, '1.25.10.10-FF-001894', NULL, 'AaceriACL132Cp', 266, NULL, NULL, 102997),
(102998, '3.80.10.10-FF-001094', NULL, 'Relaxin/insulin-like family peptide receptor 2 splice variant 1', 75, NULL, NULL, 102998),
(102999, '3.30.160.60-FF-000497', NULL, 'Endolytic murein transglycosylase', 38, NULL, NULL, 102999),
(103000, '1.10.30.10-FF-000170', NULL, 'Uncharacterized protein', 95, NULL, NULL, 103000),
(103001, '1.20.1310.10-FF-000211', NULL, NULL, 137, NULL, NULL, 103001),
(103002, '1.10.8.270-FF-000160', NULL, 'TBC1 domain family, member 15', 101, NULL, NULL, 103002),
(103003, '1.25.40.10-FF-001396', NULL, 'Pentatricopeptide repeat-containing protein At4g33170', 132, NULL, NULL, 103003),
(103004, '3.30.70.890-FF-000074', NULL, 'Predicted protein', 68, NULL, NULL, 103004),
(103005, '1.20.1070.10-FF-001956', NULL, 'Muscarinic acetylcholine receptor', 203, NULL, NULL, 103005),
(103006, '3.90.1140.10-FF-000034', NULL, 'U6 snRNA phosphodiesterase', 189, NULL, NULL, 103006),
(103007, '1.10.10.10-FF-001303', NULL, 'Cell division protein FtsK', 62, NULL, NULL, 103007),
(103008, '2.130.10.80-FF-000001', NULL, 'Aldehyde oxidase GLOX', 412, NULL, NULL, 103008),
(103009, '3.30.420.40-FF-000910', NULL, 'Actin-related protein 4', 70, NULL, NULL, 103009),
(103010, '3.30.1010.10-FF-000004', NULL, 'Serine/threonine-protein kinase TOR', 130, NULL, NULL, 103010),
(103011, '3.10.20.90-FF-000244', NULL, '3-oxo-5-alpha-steroid 4-dehydrogenase, putative', 75, NULL, NULL, 103011),
(103012, '3.30.40.10-FF-000900', NULL, 'Ubiquitinyl hydrolase 1', 143, NULL, NULL, 103012),
(103013, '1.10.3090.10-FF-000038', NULL, 'Uncharacterized protein', 60, NULL, NULL, 103013),
(103014, '2.70.150.10-FF-000038', NULL, 'Phospholipid-transporting ATPase', 136, NULL, NULL, 103014),
(103015, '3.30.160.60-FF-002149', NULL, 'Zinc finger protein 256', 28, NULL, NULL, 103015),
(103016, '1.25.40.10-FF-000294', NULL, 'Pentatricopeptide repeat-containing protein At1g09900', 71, NULL, NULL, 103016),
(103017, '4.10.240.10-FF-000068', NULL, 'C6 transcription factor, putative', 64, NULL, NULL, 103017),
(103018, '2.60.40.10-FF-004763', NULL, NULL, 97, NULL, NULL, 103018),
(103019, '2.60.40.150-FF-000545', NULL, 'Phospholipase A2', 122, NULL, NULL, 103019),
(103020, '2.130.10.10-FF-005876', NULL, 'Apoptotic protease-activating factor 1', 304, NULL, NULL, 103020),
(103021, '3.40.50.2300-FF-001479', NULL, NULL, 137, NULL, NULL, 103021),
(103022, '2.60.40.10-FF-003774', NULL, NULL, 84, NULL, NULL, 103022),
(103023, '1.10.472.10-FF-000505', NULL, 'Uncharacterized cyclin-L1-like protein C1296.05c', 103, NULL, NULL, 103023),
(103024, '3.30.500.10-FF-000043', NULL, NULL, 181, NULL, NULL, 103024),
(103025, '3.40.30.10-FF-001130', NULL, 'Predicted protein', 76, NULL, NULL, 103025),
(103026, '1.10.287.70-FF-000694', NULL, 'Uncharacterized protein', 52, NULL, NULL, 103026),
(103027, '3.90.1150.10-FF-000006', NULL, 'Phosphoserine aminotransferase', 105, NULL, NULL, 103027),
(103028, '2.40.50.1060-FF-000017', NULL, 'DNA-directed RNA polymerase I subunit RPA43', 254, NULL, NULL, 103028),
(103029, '3.40.50.300-FF-000913', NULL, 'ABC multidrug transporter SitT', 244, NULL, NULL, 103029),
(103030, '3.30.230.130-FF-000040', NULL, 'Uncharacterized protein', 146, NULL, NULL, 103030),
(103031, '3.30.40.10-FF-001356', NULL, 'Structure-specific endonuclease subunit SLX1 homolog', 84, NULL, NULL, 103031),
(103032, '1.10.3080.10-FF-000066', NULL, 'Chloride channel protein CLC-b', 205, NULL, NULL, 103032),
(103033, '2.130.10.10-FF-002650', NULL, 'Uncharacterized protein', 84, NULL, NULL, 103033),
(103034, '1.25.40.10-FF-002385', NULL, 'Predicted protein', 69, NULL, NULL, 103034);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(103035, '3.40.1090.10-FF-000030', NULL, 'Lysophospholipase', 486, NULL, NULL, 103035),
(103036, '2.40.10.10-FF-000530', NULL, NULL, 98, NULL, NULL, 103036),
(103037, '1.20.120.1900-FF-000080', NULL, 'Spindle pole body component', 220, NULL, NULL, 103037),
(103038, '1.10.8.720-FF-000047', NULL, 'Dynein heavy chain family protein', 166, NULL, NULL, 103038),
(103039, '1.25.40.10-FF-004037', NULL, 'Uncharacterized protein', 180, NULL, NULL, 103039),
(103040, '1.10.10.10-FF-000640', NULL, 'LysR family transcriptional regulator', 87, NULL, NULL, 103040),
(103041, '2.60.40.1120-FF-000070', NULL, 'SusC homolog', 75, NULL, NULL, 103041),
(103042, '3.40.640.10-FF-000354', NULL, 'Uncharacterized protein', 265, NULL, NULL, 103042),
(103043, '3.20.20.140-FF-000375', NULL, 'Uncharacterized protein', 212, NULL, NULL, 103043),
(103044, '3.40.50.10050-FF-000003', NULL, 'translation initiation factor IF-2, mitochondrial isoform X1', 107, NULL, NULL, 103044),
(103045, '3.40.50.970-FF-000153', NULL, 'Indolepyruvate oxidoreductase subunit IorA', 153, NULL, NULL, 103045),
(103046, '2.60.40.1730-FF-000039', NULL, 'Aminopeptidase', 219, NULL, NULL, 103046),
(103047, '1.10.3810.10-FF-000010', NULL, 'Penicillin-binding protein 1A', 156, NULL, NULL, 103047),
(103048, '2.40.160.10-FF-000051', NULL, 'Voltage-dependent anion-selective channel protein 2', 280, NULL, NULL, 103048),
(103049, '3.40.50.720-FF-000949', NULL, 'D-3-phosphoglycerate dehydrogenase', 199, NULL, NULL, 103049),
(103050, '3.40.50.300-FF-008344', NULL, 'Dynein heavy chain family protein', 182, NULL, NULL, 103050),
(103051, '3.30.420.40-FF-000264', NULL, 'Adenosine-diphosphatase, putative', 132, NULL, NULL, 103051),
(103052, '1.10.630.10-FF-000497', NULL, 'Uncharacterized protein', 453, NULL, NULL, 103052),
(103053, '3.40.50.1440-FF-000136', NULL, 'Uncharacterized protein', 95, NULL, NULL, 103053),
(103054, '3.90.76.10-FF-000014', NULL, 'Extracellular solute-binding protein family 5', 152, NULL, NULL, 103054),
(103055, '3.30.160.60-FF-001014', NULL, 'Zinc finger protein 597', 28, NULL, NULL, 103055),
(103056, '3.30.1640.10-FF-000035', NULL, 'DNA helicase', 115, NULL, NULL, 103056),
(103057, '2.60.40.10-FF-001211', NULL, 'Usherin', 85, NULL, NULL, 103057),
(103058, '1.10.1070.11-FF-000105', NULL, 'Protein kinase, DNA-activated, catalytic subunit', 156, NULL, NULL, 103058),
(103059, '1.25.10.10-FF-002557', NULL, 'Predicted protein', 172, NULL, NULL, 103059),
(103060, '3.30.200.20-FF-001669', NULL, 'Serine/threonine kinase, putative', 81, NULL, NULL, 103060),
(103061, '2.120.10.80-FF-000142', NULL, 'tRNA wybutosine-synthesizing protein 4', 327, NULL, NULL, 103061),
(103062, '1.10.3720.10-FF-000211', NULL, 'Dipeptide transport system permease protein DppC', 209, NULL, NULL, 103062),
(103063, '2.60.120.970-FF-000036', NULL, 'Bone morphogenetic protein 3', 224, NULL, NULL, 103063),
(103064, '3.10.20.10-FF-000001', NULL, '60S ribosomal protein L18a', 76, NULL, NULL, 103064),
(103065, '3.40.50.300-FF-000267', NULL, 'ATP-binding cassette, sub-family G (WHITE), member 1', 257, NULL, NULL, 103065),
(103066, '1.20.1540.10-FF-000020', NULL, 'Rhomboid family intramembrane serine protease', 169, NULL, NULL, 103066),
(103067, '1.10.540.10-FF-000052', NULL, 'Acyl-CoA dehydrogenase FadE34', 107, NULL, NULL, 103067),
(103068, '3.30.160.60-FF-006483', NULL, NULL, 83, NULL, NULL, 103068),
(103069, '1.25.10.10-FF-000466', NULL, 'Beta-catenin-like protein 1, putative', 494, NULL, NULL, 103069),
(103070, '3.40.50.880-FF-000098', NULL, 'Hydrogenobyrinate a,c-diamide synthase', 189, NULL, NULL, 103070),
(103071, '2.40.37.20-FF-000015', NULL, NULL, 124, NULL, NULL, 103071),
(103072, '2.20.25.30-FF-000020', NULL, 'Ribosomal protein L37', 53, NULL, NULL, 103072),
(103073, '1.25.40.10-FF-002059', NULL, 'Clustered mitochondria protein homolog', 93, NULL, NULL, 103073),
(103074, '2.60.260.20-FF-000074', NULL, 'Putative heat shock protein-like protein', 90, NULL, NULL, 103074),
(103075, '3.30.70.330-FF-002053', NULL, NULL, 93, NULL, NULL, 103075),
(103076, '2.60.40.10-FF-005898', NULL, NULL, 71, NULL, NULL, 103076);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(103077, '1.10.510.10-FF-000550', NULL, 'Serine/threonine kinase 16', 141, NULL, NULL, 103077),
(103078, '3.30.2310.20-FF-000019', NULL, 'Gsr3132 protein', 50, NULL, NULL, 103078),
(103079, '1.25.40.1010-FF-000013', NULL, 'Uncharacterized protein', 199, NULL, NULL, 103079),
(103080, '3.10.20.30-FF-000007', NULL, 'Succinate dehydrogenase [ubiquinone] iron-sulfur subunit, mitochondrial', 113, NULL, NULL, 103080),
(103081, '3.90.226.10-FF-000150', NULL, 'ECHDC1 isoform 3', 110, NULL, NULL, 103081),
(103082, '2.60.120.560-FF-000003', NULL, 'Extracellular exo-inulinase inuE', 160, NULL, NULL, 103082),
(103083, '3.40.50.300-FF-004275', NULL, 'Uncharacterized protein', 235, NULL, NULL, 103083),
(103084, '1.10.8.710-FF-000011', NULL, 'Axonemal dynein heavy chain', 128, NULL, NULL, 103084),
(103085, '1.10.220.150-FF-000044', NULL, 'ADP-ribosylation factor GTPase-activating protein 3 isoform X2', 111, NULL, NULL, 103085),
(103086, '3.10.28.10-FF-000030', NULL, 'Uncharacterized mitochondrial protein RF1', 132, NULL, NULL, 103086),
(103087, '1.10.510.10-FF-001213', NULL, 'serine/threonine-protein kinase Nek10', 331, NULL, NULL, 103087),
(103088, '2.30.33.40-FF-000018', NULL, 'Predicted protein', 94, NULL, NULL, 103088),
(103089, '3.20.20.70-FF-000682', NULL, NULL, 196, NULL, NULL, 103089),
(103090, '3.80.10.10-FF-000958', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase isoform A', 149, NULL, NULL, 103090),
(103091, '3.90.1480.20-FF-000028', NULL, 'Uncharacterized protein', 232, NULL, NULL, 103091),
(103092, '1.20.58.390-FF-000322', NULL, 'Uncharacterized protein', 55, NULL, NULL, 103092),
(103093, '2.60.40.60-FF-000337', NULL, 'Cadherin 74A, isoform A', 107, NULL, NULL, 103093),
(103094, '1.10.287.690-FF-000008', NULL, 'DNA polymerase', 53, NULL, NULL, 103094),
(103095, '1.10.510.10-FF-002641', NULL, NULL, 92, NULL, NULL, 103095),
(103096, '2.30.30.40-FF-000304', NULL, 'Sporulation protein', 68, NULL, NULL, 103096),
(103097, '1.25.10.10-FF-002411', NULL, 'CAP-G condensin subunit', 252, NULL, NULL, 103097),
(103098, '1.10.287.160-FF-000024', NULL, 'Protein kinase C', 66, NULL, NULL, 103098),
(103099, '2.20.70.10-FF-000023', NULL, 'E3 ubiquitin-protein ligase', 31, NULL, NULL, 103099),
(103100, '2.40.160.210-FF-000023', NULL, 'Uncharacterized protein', 96, NULL, NULL, 103100),
(103101, '2.120.10.30-FF-000234', NULL, 'Uncharacterized protein', 254, NULL, NULL, 103101),
(103102, '3.40.50.1820-FF-000160', NULL, 'Phospholipid:diacylglycerol acyltransferase 1', 189, NULL, NULL, 103102),
(103103, '3.80.10.10-FF-002875', NULL, 'F-box/leucine rich repeat protein, putative', 247, NULL, NULL, 103103),
(103104, '1.20.1530.20-FF-000051', NULL, 'Os12g0616500 protein', 270, NULL, NULL, 103104),
(103105, '3.40.50.10860-FF-000066', NULL, 'Bifunctional protein FolD', 158, NULL, NULL, 103105),
(103106, '3.40.50.300-FF-002184', NULL, '6-phosphofructo-2-kinase/fructose-2, 6-bisphosphatase', 210, NULL, NULL, 103106),
(103107, '3.40.50.720-FF-001764', NULL, 'NAD-dependent epimerase/dehydratase family protein', 183, NULL, NULL, 103107),
(103108, '3.30.750.80-FF-000003', NULL, 'Ribosomal RNA large subunit methyltransferase K/L', 99, NULL, NULL, 103108),
(103109, '1.10.150.240-FF-000083', NULL, 'Phosphoglycolate phosphatase', 65, NULL, NULL, 103109),
(103110, '2.30.42.10-FF-000042', NULL, 'Membrane-associated guanylate kinase, WW and PDZ domain-containing protein 3 isoform 1', 111, NULL, NULL, 103110),
(103111, '3.50.7.10-FF-000060', NULL, NULL, 12, NULL, NULL, 103111),
(103112, '1.20.5.300-FF-000009', NULL, 'Spike glycoprotein', 76, NULL, NULL, 103112),
(103113, '3.10.20.90-FF-000570', NULL, 'Abnormal cell migration protein 10', 117, NULL, NULL, 103113),
(103114, '1.20.1250.20-FF-001850', NULL, 'Sodium-dependent glucose transporter, putative', 132, NULL, NULL, 103114),
(103115, '3.90.660.10-FF-000012', NULL, 'Polyamine oxidase 1', 217, NULL, NULL, 103115),
(103116, '3.30.160.60-FF-000351', NULL, 'Zinc finger and AT-hook domain containing', 54, NULL, NULL, 103116),
(103117, '3.30.470.160-FF-000012', NULL, 'Uncharacterized inositol polyphosphate kinase C970.08', 249, NULL, NULL, 103117);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(103118, '3.40.50.300-FF-004921', NULL, 'Protein-tyrosine sulfotransferase', 280, NULL, NULL, 103118),
(103119, '2.70.170.10-FF-000247', NULL, 'Cholinergic receptor nicotinic beta 1 subunit', 131, NULL, NULL, 103119),
(103120, '1.10.510.10-FF-000224', NULL, 'serine/threonine-protein kinase mph1 isoform X1', 183, NULL, NULL, 103120),
(103121, '3.90.550.10-FF-000476', NULL, 'Glycosyltransferase involved in cell wall bisynthesis', 212, NULL, NULL, 103121),
(103122, '1.10.10.10-FF-002085', NULL, 'Transcriptional regulator/arsenate reductase', 86, NULL, NULL, 103122),
(103123, '1.20.120.1490-FF-000006', NULL, 'CpxP superfamily protein', 104, NULL, NULL, 103123),
(103124, '1.10.1510.30-FF-000004', NULL, 'Probable tRNA pseudouridine synthase D 2', 92, NULL, NULL, 103124),
(103125, '2.130.10.10-FF-000407', NULL, 'Eukaryotic translation initiation factor 2A', 203, NULL, NULL, 103125),
(103126, '3.20.20.100-FF-000211', NULL, 'Uncharacterized protein', 125, NULL, NULL, 103126),
(103127, '1.10.3620.10-FF-000001', NULL, 'YdcF family protein', 83, NULL, NULL, 103127),
(103128, '1.25.40.10-FF-000614', NULL, 'Sister chromatid cohesion protein SCC4', 249, NULL, NULL, 103128),
(103129, '2.40.10.10-FF-000237', NULL, 'Trypsin, putative', 98, NULL, NULL, 103129),
(103130, '1.10.238.10-FF-000271', NULL, 'Epidermal growth factor receptor substrate 15 homolog', 110, NULL, NULL, 103130),
(103131, '3.90.1410.10-FF-000044', NULL, 'SET domain-containing protein', 276, NULL, NULL, 103131),
(103132, '3.30.420.10-FF-000688', NULL, NULL, 133, NULL, NULL, 103132),
(103133, '1.25.40.20-FF-000617', NULL, 'Ankyrin-like protein', 98, NULL, NULL, 103133),
(103134, '3.30.1360.10-FF-000053', NULL, 'RNA polymerase I and III subunit D', 74, NULL, NULL, 103134),
(103135, '3.90.660.20-FF-000015', NULL, 'Protoporphyrinogen oxidase', 231, NULL, NULL, 103135),
(103136, '3.20.20.140-FF-000049', NULL, 'DNA polymerase III subunit alpha', 288, NULL, NULL, 103136),
(103137, '3.40.850.10-FF-000280', NULL, 'Kinesin-like protein', 178, NULL, NULL, 103137),
(103138, '3.40.190.10-FF-000133', NULL, 'Lipoprotein', 109, NULL, NULL, 103138),
(103139, '2.60.120.650-FF-000204', NULL, 'Putative lysine-specific demethylase JMJ16', 145, NULL, NULL, 103139),
(103140, '3.40.50.150-FF-000672', NULL, 'RNA methylase', 145, NULL, NULL, 103140),
(103141, '3.30.1360.120-FF-000081', NULL, 'Uncharacterized protein', 76, NULL, NULL, 103141),
(103142, '2.40.70.10-FF-000213', NULL, 'Uncharacterized protein', 117, NULL, NULL, 103142),
(103143, '2.30.29.30-FF-001158', NULL, 'Uncharacterized protein', 170, NULL, NULL, 103143),
(103144, '3.90.226.10-FF-000296', NULL, 'Uncharacterized protein', 152, NULL, NULL, 103144),
(103145, '3.40.50.1820-FF-001615', NULL, 'Serine carboxypeptidase S28 family protein', 63, NULL, NULL, 103145),
(103146, '3.30.70.20-FF-000085', NULL, NULL, 67, NULL, NULL, 103146),
(103147, '1.20.1280.50-FF-000259', NULL, 'Uncharacterized protein', 56, NULL, NULL, 103147),
(103148, '2.60.40.10-FF-000429', NULL, 'Mast/stem cell growth factor receptor', 103, NULL, NULL, 103148),
(103149, '3.30.830.10-FF-000062', NULL, 'Mitochondrial-processing peptidase subunit alpha-1', 220, NULL, NULL, 103149),
(103150, '3.30.505.10-FF-000239', NULL, NULL, 76, NULL, NULL, 103150),
(103151, '1.10.1410.10-FF-000108', NULL, 'Predicted protein', 132, NULL, NULL, 103151),
(103152, '1.10.510.10-FF-004086', NULL, NULL, 161, NULL, NULL, 103152),
(103153, '2.160.20.10-FF-000047', NULL, 'F-box protein 10', 108, NULL, NULL, 103153),
(103154, '2.130.10.10-FF-003898', NULL, 'WD40 domain-containing protein', 272, NULL, NULL, 103154),
(103155, '2.10.25.10-FF-000003', NULL, 'fibrillin-1 isoform X1', 42, NULL, NULL, 103155),
(103156, '2.30.140.10-FF-000007', NULL, 'Polyamine aminopropyltransferase', 52, NULL, NULL, 103156),
(103157, '3.40.1370.10-FF-000012', NULL, '50S ribosomal protein L4', 228, NULL, NULL, 103157),
(103158, '3.30.2400.30-FF-000001', NULL, '29 kDa antigen', 166, NULL, NULL, 103158),
(103159, '2.170.150.10-FF-000031', NULL, 'Uncharacterized protein', 153, NULL, NULL, 103159);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(103160, '3.40.50.300-FF-002830', NULL, 'Guanylate-binding protein 2', 279, NULL, NULL, 103160),
(103161, '3.40.50.10470-FF-000039', NULL, 'Translation initiation factor 2B', 197, NULL, NULL, 103161),
(103162, '3.30.230.10-FF-000033', NULL, 'Ribosome-releasing factor 2, mitochondrial', 130, NULL, NULL, 103162),
(103163, '1.10.220.10-FF-000005', NULL, 'Annexin', 72, NULL, NULL, 103163),
(103164, '3.40.50.12760-FF-000018', NULL, 'AGAP005415-PA', 343, NULL, NULL, 103164),
(103165, '2.60.40.10-FF-003009', NULL, 'Auxin-induced beta-glucosidase', 118, NULL, NULL, 103165),
(103166, '2.130.10.10-FF-004741', NULL, 'AAR103Cp', 162, NULL, NULL, 103166),
(103167, '2.60.220.50-FF-000024', NULL, 'latrophilin Cirl isoform X2', 210, NULL, NULL, 103167),
(103168, '3.30.1310.10-FF-000016', NULL, 'Nucleoid-associated protein SAMN04488058_11828', 96, NULL, NULL, 103168),
(103169, '1.10.20.10-FF-000079', NULL, 'Transcription initiation factor TFIID subunit 6, putative', 66, NULL, NULL, 103169),
(103170, '3.40.30.10-FF-000933', NULL, 'Predicted protein', 116, NULL, NULL, 103170),
(103171, '2.40.100.10-FF-000042', NULL, 'Multifunctional urea amidolyase', 158, NULL, NULL, 103171),
(103172, '3.30.430.20-FF-000017', NULL, 'Cysteine-rich receptor-like protein kinase 2', 102, NULL, NULL, 103172),
(103173, '3.90.70.10-FF-000826', NULL, 'Uncharacterized protein', 169, NULL, NULL, 103173),
(103174, '1.10.238.10-FF-000950', NULL, 'Calcium-binding protein CML42', 88, NULL, NULL, 103174),
(103175, '3.90.740.10-FF-000013', NULL, 'Isoleucine--tRNA ligase, chloroplastic/mitochondrial', 173, NULL, NULL, 103175),
(103176, '3.30.1330.20-FF-000054', NULL, 'Tubulin alpha chain', 107, NULL, NULL, 103176),
(103177, '3.30.70.330-FF-001917', NULL, NULL, 152, NULL, NULL, 103177),
(103178, '3.10.450.10-FF-000060', NULL, 'Ovocalyxin-32', 123, NULL, NULL, 103178),
(103179, '1.25.40.10-FF-004330', NULL, 'Uncharacterized protein', 167, NULL, NULL, 103179),
(103180, '1.25.40.20-FF-001140', NULL, 'Kinase, NEK', 154, NULL, NULL, 103180),
(103181, '1.10.510.10-FF-003776', NULL, NULL, 135, NULL, NULL, 103181),
(103182, '3.30.200.20-FF-002125', NULL, 'Predicted protein', 74, NULL, NULL, 103182),
(103183, '1.10.150.20-FF-000305', NULL, '1,4-alpha-glucan branching enzyme TK1436', 64, NULL, NULL, 103183),
(103184, '2.60.40.1180-FF-000155', NULL, 'Oligo-1,6-glucosidase', 62, NULL, NULL, 103184),
(103185, '3.80.10.10-FF-001740', NULL, 'K7_Sog2p', 276, NULL, NULL, 103185),
(103186, '1.10.3210.10-FF-000127', NULL, 'Predicted protein', 273, NULL, NULL, 103186),
(103187, '2.30.180.10-FF-000072', NULL, 'Uncharacterized protein', 178, NULL, NULL, 103187),
(103188, '1.10.510.10-FF-000903', NULL, 'Receptor-like protein kinase 4', 207, NULL, NULL, 103188),
(103189, '1.10.10.10-FF-000314', NULL, 'GntR family transcriptional regulator', 69, NULL, NULL, 103189),
(103190, '1.10.1370.30-FF-000032', NULL, 'Angiotensin-converting enzyme', 240, NULL, NULL, 103190),
(103191, '3.30.1330.30-FF-000057', NULL, 'Peptide chain release factor subunit 1', 122, NULL, NULL, 103191),
(103192, '3.30.70.2190-FF-000015', NULL, 'Uncharacterized protein', 116, NULL, NULL, 103192),
(103193, '3.20.20.80-FF-000100', NULL, 'Glycoside hydrolase superfamily', 372, NULL, NULL, 103193),
(103194, '1.20.1050.80-FF-000026', NULL, 'Predicted protein', 70, NULL, NULL, 103194),
(103195, '3.30.420.80-FF-000017', NULL, 'Uncharacterized protein TCIL3000_10_8880', 140, NULL, NULL, 103195),
(103196, '3.40.50.1100-FF-000091', NULL, 'Related to L-serine dehydratase', 205, NULL, NULL, 103196),
(103197, '3.30.565.10-FF-000074', NULL, 'Sensor protein', 148, NULL, NULL, 103197),
(103198, '3.30.200.20-FF-001995', NULL, NULL, 97, NULL, NULL, 103198),
(103199, '3.80.10.10-FF-001947', NULL, 'Uncharacterized protein', 52, NULL, NULL, 103199),
(103200, '3.10.100.10-FF-000011', NULL, 'Aggrecan core protein', 98, NULL, NULL, 103200),
(103201, '3.30.420.610-FF-000019', NULL, 'Putative endonuclease or glycosyl hydrolase', 74, NULL, NULL, 103201),
(103202, '2.60.200.20-FF-000065', NULL, 'Serine/threonine-protein kinase RAD53', 140, NULL, NULL, 103202);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(103203, '2.40.30.10-FF-000093', NULL, 'Naphthalene 1,2-dioxygenase reductase component', 93, NULL, NULL, 103203),
(103204, '3.30.70.270-FF-000303', NULL, NULL, 165, NULL, NULL, 103204),
(103205, '1.20.58.70-FF-000059', NULL, 'Qa-SNARE protein', 109, NULL, NULL, 103205),
(103206, '2.40.30.10-FF-000413', NULL, 'Uncharacterized protein', 109, NULL, NULL, 103206),
(103207, '3.40.50.300-FF-008018', NULL, 'Uncharacterized protein', 141, NULL, NULL, 103207),
(103208, '3.40.140.10-FF-000035', NULL, 'dCMP deaminase', 157, NULL, NULL, 103208),
(103209, '1.10.400.10-FF-000042', NULL, 'Guanine nucleotide-binding protein alpha-12 subunit', 124, NULL, NULL, 103209),
(103210, '1.10.750.20-FF-000008', NULL, 'Suppressor of cytokine signaling, invertebrate', 35, NULL, NULL, 103210),
(103211, '3.90.1070.20-FF-000008', NULL, 'DNA-directed RNA polymerase subunit beta', 81, NULL, NULL, 103211),
(103212, '2.60.40.10-FF-000901', NULL, 'Titin b', 105, NULL, NULL, 103212),
(103213, '1.25.40.10-FF-001749', NULL, 'Actin binding protein, putative', 90, NULL, NULL, 103213),
(103214, '3.90.70.10-FF-000147', NULL, 'Ubiquitin specific protease', 373, NULL, NULL, 103214),
(103215, '2.20.28.10-FF-000015', NULL, 'DNA replication licensing factor MCM3', 68, NULL, NULL, 103215),
(103216, '3.40.50.150-FF-000733', NULL, 'GD20129', 221, NULL, NULL, 103216),
(103217, '1.10.1450.10-FF-000173', NULL, 'Retinal degradation slow', 50, NULL, NULL, 103217),
(103218, '3.40.50.720-FF-001085', NULL, 'LD36273p', 247, NULL, NULL, 103218),
(103219, '3.30.750.24-FF-000012', NULL, 'Sulfate transporter family protein', 133, NULL, NULL, 103219),
(103220, '1.10.3210.10-FF-000066', NULL, 'Uncharacterized protein', 268, NULL, NULL, 103220),
(103221, '2.60.40.10-FF-002672', NULL, 'Ig and fibronectin type-III', 102, NULL, NULL, 103221),
(103222, '3.40.50.12780-FF-000030', NULL, 'Acyl-CoA synthetase family member 3', 423, NULL, NULL, 103222),
(103223, '3.90.550.50-FF-000055', NULL, 'Hexosyltransferase', 221, NULL, NULL, 103223),
(103224, '2.70.98.10-FF-000028', NULL, 'Alpha-1,2-mannosidase family protein (AFU_orthologue AFUA_5G10520)', 306, NULL, NULL, 103224),
(103225, '1.10.287.110-FF-000442', NULL, 'Uncharacterized protein', 68, NULL, NULL, 103225),
(103226, '1.25.10.10-FF-001568', NULL, 'Uncharacterized protein', 205, NULL, NULL, 103226),
(103227, '2.60.40.1220-FF-000009', NULL, 'Copper resistance protein', 95, NULL, NULL, 103227),
(103228, '3.30.750.44-FF-000018', NULL, NULL, 86, NULL, NULL, 103228),
(103229, '3.30.70.330-FF-001856', NULL, NULL, 110, NULL, NULL, 103229),
(103230, '3.80.10.10-FF-001268', NULL, 'Receptor-like protein 9DC3', 72, NULL, NULL, 103230),
(103231, '3.30.200.20-FF-000034', NULL, 'Kinase suppressor of Ras 1', 89, NULL, NULL, 103231),
(103232, '3.30.1460.50-FF-000016', NULL, 'ubiquitin-like-conjugating enzyme ATG10 isoform X2', 143, NULL, NULL, 103232),
(103233, '3.10.20.90-FF-000418', NULL, 'UBX domain-containing protein 4', 83, NULL, NULL, 103233),
(103234, '3.10.50.10-FF-000003', NULL, 'Class V chitinase CHIT5b', 72, NULL, NULL, 103234),
(103235, '3.30.160.60-FF-005994', NULL, NULL, 46, NULL, NULL, 103235),
(103236, '1.20.1510.10-FF-000013', NULL, 'Cation efflux family protein', 221, NULL, NULL, 103236),
(103237, '2.60.40.10-FF-005691', NULL, NULL, 74, NULL, NULL, 103237),
(103238, '1.20.1640.10-FF-000084', NULL, 'PaTched Related family', 202, NULL, NULL, 103238),
(103239, '3.90.70.10-FF-000473', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 288, NULL, NULL, 103239),
(103240, '2.130.10.10-FF-000733', NULL, 'WD40 repeat-like protein', 263, NULL, NULL, 103240),
(103241, '2.80.10.50-FF-000282', NULL, 'Predicted protein', 55, NULL, NULL, 103241),
(103242, '2.60.40.10-FF-002846', NULL, 'Uncharacterized protein, isoform C', 89, NULL, NULL, 103242),
(103243, '1.10.10.10-FF-001949', NULL, 'Uncharacterized protein', 81, NULL, NULL, 103243),
(103244, '3.20.20.105-FF-000015', NULL, 'tRNA-guanine transglycosylases, various specificities family protein', 184, NULL, NULL, 103244),
(103245, '3.40.50.300-FF-006427', NULL, 'Predicted protein', 128, NULL, NULL, 103245); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(103246, '1.10.260.60-FF-000005', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', 125, NULL, NULL, 103246),
(103247, '1.10.510.10-FF-000078', NULL, 'Serine/threonine-protein kinase PRP4 homolog', 261, NULL, NULL, 103247),
(103248, '2.60.200.20-FF-000126', NULL, 'Kinesin-like protein', 133, NULL, NULL, 103248),
(103249, '3.40.630.30-FF-000449', NULL, 'Iron transport protein B', 188, NULL, NULL, 103249),
(103250, '3.40.50.300-FF-002504', NULL, 'ABC transporter, ATP-binding protein', 235, NULL, NULL, 103250),
(103251, '3.40.50.1780-FF-000007', NULL, 'Cytosolic Fe-S cluster assembly factor NAR1, putative', 63, NULL, NULL, 103251),
(103252, '3.90.550.10-FF-000622', NULL, 'Uncharacterized protein', 203, NULL, NULL, 103252),
(103253, '4.10.372.10-FF-000003', NULL, 'Lipoxygenase', 100, NULL, NULL, 103253),
(103254, '1.10.260.50-FF-000002', NULL, 'Cysteine desulfurase NifS', 90, NULL, NULL, 103254),
(103255, '3.40.50.1000-FF-000740', NULL, NULL, 43, NULL, NULL, 103255),
(103256, '1.20.1250.20-FF-001232', NULL, 'Protein NRT1/ PTR FAMILY 1.2', 420, NULL, NULL, 103256),
(103257, '2.40.50.100-FF-000071', NULL, 'Dihydrolipoyllysine-residue succinyltransferase component of 2-oxoglutarate dehydrogenase complex', 105, NULL, NULL, 103257),
(103258, '3.30.2160.10-FF-000072', NULL, 'Predicted protein', 31, NULL, NULL, 103258),
(103259, '2.130.10.10-FF-000379', NULL, 'WD repeat domain 78', 162, NULL, NULL, 103259),
(103260, '3.40.50.720-FF-001438', NULL, 'D-amino acid oxidase', 140, NULL, NULL, 103260),
(103261, '2.170.270.10-FF-000124', NULL, 'PR domain 4', 124, NULL, NULL, 103261),
(103262, '2.40.50.140-FF-000324', NULL, 'Aspartate--tRNA(Asp/Asn) ligase', 107, NULL, NULL, 103262),
(103263, '3.30.559.10-FF-000161', NULL, 'MFS transporter/NRPS-like enzyme, putative (JCVI)', 181, NULL, NULL, 103263),
(103264, '3.40.50.1100-FF-000118', NULL, 'Related to CYS4-cystathionine beta-synthase', 166, NULL, NULL, 103264),
(103265, '3.30.160.60-FF-004712', NULL, NULL, 32, NULL, NULL, 103265),
(103266, '1.20.1070.10-FF-002120', NULL, 'Predicted protein', 282, NULL, NULL, 103266),
(103267, '1.10.10.10-FF-000814', NULL, 'Unplaced genomic scaffold supercont1.10, whole genome shotgun sequence', 103, NULL, NULL, 103267),
(103268, '3.40.630.10-FF-000089', NULL, 'N-acetylated alpha-linked acidic dipeptidase like 1', 256, NULL, NULL, 103268),
(103269, '2.70.130.10-FF-000155', NULL, NULL, 131, NULL, NULL, 103269),
(103270, '3.40.50.300-FF-001402', NULL, 'Discs, large homolog 3 (Drosophila)', 186, NULL, NULL, 103270),
(103271, '3.40.630.10-FF-000443', NULL, 'Uncharacterized protein', 205, NULL, NULL, 103271),
(103272, '3.40.50.300-FF-002684', NULL, 'Dynamin-1 family protein, putative', 301, NULL, NULL, 103272),
(103273, '3.40.50.1760-FF-000001', NULL, 'Glutathione synthetase', 124, NULL, NULL, 103273),
(103274, '3.30.210.10-FF-000003', NULL, 'DNA nucleotidylexotransferase', 70, NULL, NULL, 103274),
(103275, '3.40.50.300-FF-006719', NULL, 'Uncharacterized protein', 276, NULL, NULL, 103275),
(103276, '1.10.287.40-FF-000033', NULL, 'Uncharacterized protein', 49, NULL, NULL, 103276),
(103277, '3.10.520.10-FF-000003', NULL, NULL, 230, NULL, NULL, 103277),
(103278, '1.20.140.150-FF-000012', NULL, 'Claudin', 189, NULL, NULL, 103278),
(103279, '3.40.30.10-FF-000787', NULL, 'Uncharacterized protein', 110, NULL, NULL, 103279),
(103280, '1.10.510.10-FF-002848', NULL, 'Protein phosphatase 2C-related protein', 264, NULL, NULL, 103280),
(103281, '1.10.357.140-FF-000001', NULL, 'Protoheme IX farnesyltransferase', 156, NULL, NULL, 103281),
(103282, '3.80.10.10-FF-001447', NULL, 'Os08g0459100 protein', 83, NULL, NULL, 103282),
(103283, '3.30.390.60-FF-000008', NULL, 'Heat-inducible transcription repressor HrcA', 102, NULL, NULL, 103283),
(103284, '3.40.50.1580-FF-000071', NULL, 'Purine nucleoside phosphorylase 4b', 111, NULL, NULL, 103284),
(103285, '3.30.420.40-FF-000438', NULL, 'Related to ARP5-Actin-related protein', 30, NULL, NULL, 103285),
(103286, '3.70.10.10-FF-000127', NULL, 'RAD9 checkpoint clamp component B', 37, NULL, NULL, 103286);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(103287, '3.40.50.1100-FF-000298', NULL, 'Uncharacterized protein', 163, NULL, NULL, 103287),
(103288, '3.40.50.1000-FF-000386', NULL, 'Mg-dependent acid phosphatase', 172, NULL, NULL, 103288),
(103289, '3.30.390.50-FF-000005', NULL, 'Lipoyltransferase 1, mitochondrial', 102, NULL, NULL, 103289),
(103290, '4.10.400.10-FF-000283', NULL, 'glycoprotein 330-like isoform X1', 46, NULL, NULL, 103290),
(103291, '3.40.50.1000-FF-000094', NULL, 'Haloacid dehalogenase like hydrolase domain containing 5', 140, NULL, NULL, 103291),
(103292, '2.60.40.790-FF-000063', NULL, 'Heat shock protein beta-9', 103, NULL, NULL, 103292),
(103293, '1.20.1250.20-FF-000130', NULL, 'Protein NRT1/ PTR FAMILY 3.1', 522, NULL, NULL, 103293),
(103294, '2.60.40.10-FF-005926', NULL, NULL, 106, NULL, NULL, 103294),
(103295, '2.30.29.30-FF-000410', NULL, 'A-kinase anchor protein 13', 131, NULL, NULL, 103295),
(103296, '3.40.640.10-FF-000415', NULL, 'Bifunctional dethiobiotin synthetase/7,8-diamino-pelargonic acid aminotransferase, mitochondrial', 79, NULL, NULL, 103296),
(103297, '1.50.40.10-FF-000376', NULL, 'Mitochondrial substrate carrier family protein', 113, NULL, NULL, 103297),
(103298, '3.30.70.100-FF-000152', NULL, NULL, 40, NULL, NULL, 103298),
(103299, '1.10.10.1740-FF-000003', NULL, 'Protein FATTY ACID EXPORT 1, chloroplastic', 124, NULL, NULL, 103299),
(103300, '3.40.50.1010-FF-000097', NULL, 'AGAP008671-PA', 204, NULL, NULL, 103300),
(103301, '1.25.10.10-FF-002383', NULL, 'Si:ch211-233m11.2', 268, NULL, NULL, 103301),
(103302, '3.30.450.40-FF-000092', NULL, 'Crp family transcriptional regulator', 175, NULL, NULL, 103302),
(103303, '1.10.472.10-FF-000331', NULL, 'Cyclin-like protein', 108, NULL, NULL, 103303),
(103304, '3.30.428.70-FF-000009', NULL, 'Predicted protein', 97, NULL, NULL, 103304),
(103305, '3.90.1600.10-FF-000053', NULL, 'DNA polymerase', 171, NULL, NULL, 103305),
(103306, '3.30.40.10-FF-001682', NULL, 'FI06716p', 73, NULL, NULL, 103306),
(103307, '1.20.1070.10-FF-000321', NULL, 'Octopamine receptor beta-3R', 247, NULL, NULL, 103307),
(103308, '2.120.10.30-FF-000060', NULL, 'Putative strictosidine synthase', 337, NULL, NULL, 103308),
(103309, '1.10.580.10-FF-000026', NULL, 'Citrate synthase, mitochondrial', 96, NULL, NULL, 103309),
(103310, '3.30.450.380-FF-000012', NULL, NULL, 192, NULL, NULL, 103310),
(103311, '3.40.50.261-FF-000037', NULL, 'Succinate--CoA ligase [ADP/GDP-forming] subunit alpha, mitochondrial', 177, NULL, NULL, 103311),
(103312, '1.10.1410.10-FF-000047', NULL, 'WGS project CABT00000000 data, contig 2.5', 189, NULL, NULL, 103312),
(103313, '3.40.50.2000-FF-000085', NULL, 'alpha-1,3/1,6-mannosyltransferase ALG2', 195, NULL, NULL, 103313),
(103314, '3.30.40.10-FF-000400', NULL, 'Bromodomain adjacent to zinc finger domain protein 2A', 58, NULL, NULL, 103314),
(103315, '1.20.5.190-FF-000026', NULL, 'Unconventional myosin-X', 51, NULL, NULL, 103315),
(103316, '1.20.272.10-FF-000033', NULL, 'Replication factor C small subunit', 90, NULL, NULL, 103316),
(103317, '3.40.50.300-FF-008283', NULL, 'Uncharacterized protein', 32, NULL, NULL, 103317),
(103318, '3.30.70.330-FF-000136', NULL, 'poly(U)-binding-splicing factor PUF60 isoform X1', 110, NULL, NULL, 103318),
(103319, '3.40.1010.10-FF-000019', NULL, 'Precorrin-6Y C(5,15)-methyltransferase [decarboxylating]', 101, NULL, NULL, 103319),
(103320, '1.25.40.790-FF-000017', NULL, 'Uncharacterized protein', 264, NULL, NULL, 103320),
(103321, '1.10.510.10-FF-003130', NULL, NULL, 185, NULL, NULL, 103321),
(103322, '3.90.550.10-FF-000330', NULL, 'Uncharacterized protein', 250, NULL, NULL, 103322),
(103323, '3.40.50.880-FF-000126', NULL, 'Carbamoyl-phosphate synthase small chain', 214, NULL, NULL, 103323),
(103324, '3.90.1150.10-FF-000332', NULL, 'Uncharacterized protein', 131, NULL, NULL, 103324),
(103325, '1.25.10.10-FF-003400', NULL, 'Nucleolar protein 9', 117, NULL, NULL, 103325),
(103326, '3.80.10.10-FF-000312', NULL, 'Protein phosphatases pp1 regulatory subunit, putative', 137, NULL, NULL, 103326),
(103327, '1.20.58.530-FF-000027', NULL, 'Dachs, isoform D', 168, NULL, NULL, 103327);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(103328, '1.10.238.10-FF-000563', NULL, 'Sodium/calcium exchanger NCL', 141, NULL, NULL, 103328),
(103329, '3.40.50.300-FF-002358', NULL, 'Rho-related GTP-binding protein RhoC', 94, NULL, NULL, 103329),
(103330, '2.30.30.40-FF-000158', NULL, 'Osteoclast-stimulating factor 1', 74, NULL, NULL, 103330),
(103331, '3.40.50.2300-FF-000231', NULL, 'LacI family transcriptional regulator', 119, NULL, NULL, 103331),
(103332, '3.40.50.150-FF-000407', NULL, 'O-methyltransferase 4', 238, NULL, NULL, 103332),
(103333, '2.60.120.650-FF-000030', NULL, 'JmjC domain-containing protein 4', 263, NULL, NULL, 103333),
(103334, '3.30.200.20-FF-000360', NULL, 'Protein kinase C', 114, NULL, NULL, 103334),
(103335, '1.10.10.60-FF-000161', NULL, 'POU domain protein', 50, NULL, NULL, 103335),
(103336, '2.10.25.10-FF-001138', NULL, 'Heart development protein with EGF-like domains 1', 37, NULL, NULL, 103336),
(103337, '2.130.10.10-FF-004095', NULL, 'Uncharacterized protein', 197, NULL, NULL, 103337),
(103338, '3.30.160.60-FF-000643', NULL, 'Zinc finger protein 668', 27, NULL, NULL, 103338),
(103339, '2.60.120.330-FF-000198', NULL, 'Os08g0392300 protein', 152, NULL, NULL, 103339),
(103340, '3.30.40.10-FF-001709', NULL, 'JmjC domain, hydroxylase-domain-containing protein', 121, NULL, NULL, 103340),
(103341, '1.25.40.10-FF-000440', NULL, 'E3 ubiquitin-protein ligase PEP5', 214, NULL, NULL, 103341),
(103342, '3.30.40.10-FF-001502', NULL, 'Putative RING finger domain protein', 113, NULL, NULL, 103342),
(103343, '1.25.40.770-FF-000011', NULL, 'TAF (TBP-associated transcription factor) family', 230, NULL, NULL, 103343),
(103344, '2.70.150.10-FF-000190', NULL, 'Calcium-transporting ATPase', 86, NULL, NULL, 103344),
(103345, '2.30.30.30-FF-000155', NULL, '50S ribosomal protein L24', 108, NULL, NULL, 103345),
(103346, '1.20.58.480-FF-000023', NULL, 'Tryptophan oxygenase, putative', 45, NULL, NULL, 103346),
(103347, '1.20.1070.10-FF-001810', NULL, 'Uncharacterized protein', 313, NULL, NULL, 103347),
(103348, '3.40.50.1820-FF-001262', NULL, 'Protein phosphatase methylesterase 1', 309, NULL, NULL, 103348),
(103349, '1.10.10.60-FF-000368', NULL, 'Transcription factor MYB60', 72, NULL, NULL, 103349),
(103350, '2.40.10.10-FF-000384', NULL, NULL, 93, NULL, NULL, 103350),
(103351, '3.90.730.10-FF-000041', NULL, 'Uncharacterized protein', 130, NULL, NULL, 103351),
(103352, '3.60.21.10-FF-000265', NULL, 'UDP-sugar hydrolase, putative', 270, NULL, NULL, 103352),
(103353, '3.20.20.220-FF-000073', NULL, 'Probable proline dehydrogenase, mitochondrial', 403, NULL, NULL, 103353),
(103354, '1.25.40.10-FF-003548', NULL, 'Pentatricopeptide repeat-containing protein', 79, NULL, NULL, 103354),
(103355, '3.30.160.60-FF-004566', NULL, NULL, 35, NULL, NULL, 103355),
(103356, '1.25.40.10-FF-002413', NULL, 'Vacuolar protein sorting-associated protein 41', 205, NULL, NULL, 103356),
(103357, '1.25.50.20-FF-000062', NULL, 'Aminopeptidase', 43, NULL, NULL, 103357),
(103358, '1.20.58.390-FF-000294', NULL, 'Uncharacterized protein', 109, NULL, NULL, 103358),
(103359, '1.20.1050.10-FF-000112', NULL, 'Uncharacterized protein', 32, NULL, NULL, 103359),
(103360, '2.130.10.130-FF-000050', NULL, NULL, 192, NULL, NULL, 103360),
(103361, '3.40.50.300-FF-007973', NULL, 'SNF2 family N-terminal domain containing protein', 288, NULL, NULL, 103361),
(103362, '2.60.120.260-FF-000003', NULL, 'Reelin', 196, NULL, NULL, 103362),
(103363, '3.40.50.150-FF-000380', NULL, 'Uncharacterized protein', 233, NULL, NULL, 103363),
(103364, '1.20.5.170-FF-000279', NULL, 'Uncharacterized protein', 57, NULL, NULL, 103364),
(103365, '3.30.60.30-FF-000177', NULL, 'Agrin', 59, NULL, NULL, 103365),
(103366, '2.10.109.10-FF-000012', NULL, 'Peptidase/ serine-type peptidase', 132, NULL, NULL, 103366),
(103367, '2.70.170.10-FF-000073', NULL, 'Uncharacterized protein', 199, NULL, NULL, 103367),
(103368, '1.10.287.1080-FF-000020', NULL, 'Uncharacterized protein', 45, NULL, NULL, 103368),
(103369, '3.10.600.10-FF-000004', NULL, 'Pyruvate carboxylase', 62, NULL, NULL, 103369),
(103370, '2.60.120.380-FF-000073', NULL, 'Clan SB, family S8, subtilisin-like serine peptidase', 129, NULL, NULL, 103370);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(103371, '2.10.70.10-FF-000164', NULL, 'Cysteine rich transmembrane BMP regulator 1', 31, NULL, NULL, 103371),
(103372, '2.60.40.2080-FF-000003', NULL, NULL, 101, NULL, NULL, 103372),
(103373, '3.40.190.10-FF-000425', NULL, 'Transcriptional regulator, LysR family', 109, NULL, NULL, 103373),
(103374, '1.20.1070.10-FF-001277', NULL, 'Uncharacterized protein', 302, NULL, NULL, 103374),
(103375, '3.30.70.1620-FF-000018', NULL, 'Structural maintenance of chromosomes protein 4', 70, NULL, NULL, 103375),
(103376, '1.20.5.190-FF-000173', NULL, NULL, 61, NULL, NULL, 103376),
(103377, '1.10.10.10-FF-000286', NULL, 'Heat shock transcription factor', 101, NULL, NULL, 103377),
(103378, '2.60.40.10-FF-004437', NULL, NULL, 84, NULL, NULL, 103378),
(103379, '3.90.1420.10-FF-000016', NULL, 'SET domain-containing protein', 155, NULL, NULL, 103379),
(103380, '2.130.10.10-FF-000172', NULL, 'WD repeat domain 3', 193, NULL, NULL, 103380),
(103381, '1.25.10.10-FF-003485', NULL, 'RING-type E3 ubiquitin transferase', 296, NULL, NULL, 103381),
(103382, '1.10.10.60-FF-000722', NULL, 'Homeobox protein pal-1', 106, NULL, NULL, 103382),
(103383, '2.60.40.10-FF-002285', NULL, 'Protein sidekick homolog', 86, NULL, NULL, 103383),
(103384, '3.90.470.20-FF-000006', NULL, 'L-aminoadipate-semialdehyde dehydrogenase-phosphopantetheinyl transferase', 133, NULL, NULL, 103384),
(103385, '3.60.15.10-FF-000144', NULL, 'Predicted protein', 114, NULL, NULL, 103385),
(103386, '3.50.4.10-FF-000020', NULL, 'Uncharacterized protein, isoform B', 87, NULL, NULL, 103386),
(103387, '1.25.40.10-FF-001311', NULL, 'Pentatricopeptide repeat-containing protein', 143, NULL, NULL, 103387),
(103388, '3.40.30.10-FF-000607', NULL, 'Glutathione S-transferase', 89, NULL, NULL, 103388),
(103389, '1.25.40.990-FF-000077', NULL, 'Uncharacterized protein', 330, NULL, NULL, 103389),
(103390, '1.25.40.20-FF-001314', NULL, 'Predicted protein', 141, NULL, NULL, 103390),
(103391, '1.25.10.10-FF-002911', NULL, 'Exportin-T, putative', 121, NULL, NULL, 103391),
(103392, '1.10.510.10-FF-002820', NULL, NULL, 135, NULL, NULL, 103392),
(103393, '1.10.10.2050-FF-000001', NULL, 'putative tRNA pseudouridine synthase Pus10', 50, NULL, NULL, 103393),
(103394, '2.130.10.10-FF-002324', NULL, 'Transducin family protein / WD-40 repeat family protein', 128, NULL, NULL, 103394),
(103395, '3.80.10.10-FF-002549', NULL, 'AGAP002004-PA', 153, NULL, NULL, 103395),
(103396, '2.40.70.10-FF-000185', NULL, 'Plasmepsin VIII', 236, NULL, NULL, 103396),
(103397, '2.40.40.20-FF-000068', NULL, 'Uncharacterized protein', 82, NULL, NULL, 103397),
(103398, '2.40.50.140-FF-000150', NULL, 'DNA ligase', 156, NULL, NULL, 103398),
(103399, '3.90.470.10-FF-000003', NULL, '60S ribosomal protein L17', 184, NULL, NULL, 103399),
(103400, '3.40.50.1820-FF-001469', NULL, 'Uncharacterized protein', 177, NULL, NULL, 103400),
(103401, '3.80.10.10-FF-003185', NULL, 'Uncharacterized protein', 242, NULL, NULL, 103401),
(103402, '1.20.1070.10-FF-000967', NULL, 'Uncharacterized protein', 251, NULL, NULL, 103402),
(103403, '2.40.30.10-FF-000267', NULL, 'Globin-like protein', 118, NULL, NULL, 103403),
(103404, '2.10.90.10-FF-000047', NULL, 'Left-right determination factor', 102, NULL, NULL, 103404),
(103405, '1.25.40.10-FF-005139', NULL, 'Uncharacterized protein', 100, NULL, NULL, 103405),
(103406, '3.30.200.20-FF-002512', NULL, 'Uncharacterized protein', 113, NULL, NULL, 103406),
(103407, '1.20.1070.10-FF-001456', NULL, 'Uncharacterized protein', 218, NULL, NULL, 103407),
(103408, '3.30.56.10-FF-000032', NULL, 'Phenylalanine--tRNA ligase beta subunit', 87, NULL, NULL, 103408),
(103409, '3.30.9.10-FF-000188', NULL, 'Predicted protein', 209, NULL, NULL, 103409),
(103410, '1.20.58.60-FF-000202', NULL, 'Uncharacterized protein, isoform D', 279, NULL, NULL, 103410),
(103411, '1.20.1250.20-FF-001439', NULL, 'Uncharacterized protein', 110, NULL, NULL, 103411),
(103412, '2.60.120.260-FF-000183', NULL, 'Fucolectin', 151, NULL, NULL, 103412),
(103413, '3.90.1110.10-FF-000032', NULL, NULL, 166, NULL, NULL, 103413),
(103414, '1.10.510.10-FF-004439', NULL, NULL, 55, NULL, NULL, 103414);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(103415, '3.40.50.10810-FF-000012', NULL, 'RNA polymerase-associated protein RapA', 287, NULL, NULL, 103415),
(103416, '3.90.1670.10-FF-000001', NULL, 'Protein FdhE', 285, NULL, NULL, 103416),
(103417, '2.130.10.10-FF-002942', NULL, 'Uncharacterized protein', 150, NULL, NULL, 103417),
(103418, '2.60.40.10-FF-000076', NULL, 'Leucine-rich repeat and Ig domain-containing 4', 96, NULL, NULL, 103418),
(103419, '3.90.45.10-FF-000021', NULL, 'Peptide deformylase', 202, NULL, NULL, 103419),
(103420, '2.130.10.10-FF-006040', NULL, 'Predicted protein', 232, NULL, NULL, 103420),
(103421, '3.30.160.60-FF-005668', NULL, NULL, 28, NULL, NULL, 103421),
(103422, '2.60.120.470-FF-000009', NULL, 'PITH domain-containing protein ZK353.9', 165, NULL, NULL, 103422),
(103423, '3.30.310.10-FF-000067', NULL, 'Coatomer subunit gamma', 116, NULL, NULL, 103423),
(103424, '3.10.20.90-FF-000744', NULL, 'Uncharacterized protein', 102, NULL, NULL, 103424),
(103425, '1.10.510.10-FF-002287', NULL, 'Dual specificity protein kinase splB', 217, NULL, NULL, 103425),
(103426, '3.30.870.10-FF-000036', NULL, 'Phospholipase', 163, NULL, NULL, 103426),
(103427, '3.30.160.60-FF-006157', NULL, NULL, 43, NULL, NULL, 103427),
(103428, '3.30.70.580-FF-000071', NULL, 'Uncharacterized protein', 68, NULL, NULL, 103428),
(103429, '1.25.40.10-FF-000586', NULL, 'Bardet-Biedl syndrome 8', 352, NULL, NULL, 103429),
(103430, '1.25.40.20-FF-000117', NULL, 'Protein fem-1 homolog B', 180, NULL, NULL, 103430),
(103431, '3.30.160.60-FF-000317', NULL, 'zinc finger homeobox protein 3', 70, NULL, NULL, 103431),
(103432, '3.90.550.10-FF-000504', NULL, 'Uncharacterized protein', 268, NULL, NULL, 103432),
(103433, '3.80.10.10-FF-003038', NULL, 'Uncharacterized protein', 163, NULL, NULL, 103433),
(103434, '3.40.50.300-FF-007647', NULL, 'Uncharacterized protein', 291, NULL, NULL, 103434),
(103435, '3.40.50.620-FF-000071', NULL, '[Citrate [pro-3S]-lyase] ligase', 208, NULL, NULL, 103435),
(103436, '1.10.418.10-FF-000009', NULL, 'smoothelin isoform X2', 112, NULL, NULL, 103436),
(103437, '2.30.30.40-FF-000484', NULL, 'Uncharacterized protein', 88, NULL, NULL, 103437),
(103438, '3.30.70.330-FF-001682', NULL, NULL, 86, NULL, NULL, 103438),
(103439, '1.10.510.10-FF-000196', NULL, 'Probable serine/threonine protein kinase IREH1', 192, NULL, NULL, 103439),
(103440, '1.20.1110.10-FF-000229', NULL, 'Flagellar associated protein, calcium-transporting ATPase', 399, NULL, NULL, 103440),
(103441, '1.10.10.10-FF-002113', NULL, 'Response regulator', 99, NULL, NULL, 103441),
(103442, '1.10.150.240-FF-000111', NULL, 'HAD family hydrolase', 71, NULL, NULL, 103442),
(103443, '3.40.50.300-FF-004421', NULL, 'Adenylyl-sulfate kinase', 171, NULL, NULL, 103443),
(103444, '1.10.10.790-FF-000049', NULL, NULL, 50, NULL, NULL, 103444),
(103445, '1.20.1070.10-FF-001664', NULL, 'Uncharacterized protein', 126, NULL, NULL, 103445),
(103446, '3.30.70.20-FF-000113', NULL, NULL, 41, NULL, NULL, 103446),
(103447, '3.30.40.10-FF-001710', NULL, 'Ubiquitinyl hydrolase 1', 121, NULL, NULL, 103447),
(103448, '2.10.110.10-FF-000083', NULL, 'LIM domain kinase 1', 61, NULL, NULL, 103448),
(103449, '3.40.640.10-FF-000062', NULL, 'Cystathionine beta-lyase', 258, NULL, NULL, 103449),
(103450, '3.40.50.150-FF-000851', NULL, 'N-terminal Xaa-Pro-Lys N-methyltransferase 1', 135, NULL, NULL, 103450),
(103451, '2.60.40.10-FF-000840', NULL, 'Roundabout guidance receptor 4', 94, NULL, NULL, 103451),
(103452, '3.40.50.200-FF-000029', NULL, 'Subtilisin-like serine protease', 311, NULL, NULL, 103452),
(103453, '1.10.510.10-FF-003012', NULL, NULL, 222, NULL, NULL, 103453),
(103454, '2.50.20.10-FF-000007', NULL, 'Outer-membrane lipoprotein carrier protein', 184, NULL, NULL, 103454),
(103455, '2.60.120.920-FF-000162', NULL, 'Uncharacterized protein', 140, NULL, NULL, 103455),
(103456, '3.40.50.800-FF-000001', NULL, 'Threonine--tRNA ligase', 107, NULL, NULL, 103456),
(103457, '4.10.60.10-FF-000142', NULL, 'DEAD-Box Protein', 36, NULL, NULL, 103457),
(103458, '2.60.40.10-FF-004471', NULL, NULL, 94, NULL, NULL, 103458);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(103459, '1.20.1250.20-FF-000304', NULL, 'Protein NRT1/ PTR FAMILY 6.4', 518, NULL, NULL, 103459),
(103460, '3.40.190.10-FF-000633', NULL, 'Transcriptional regulator, LysR family', 107, NULL, NULL, 103460),
(103461, '3.90.70.10-FF-000208', NULL, 'Ubiquitinyl hydrolase 1', 344, NULL, NULL, 103461),
(103462, '3.30.870.10-FF-000154', NULL, 'Uncharacterized protein', 142, NULL, NULL, 103462),
(103463, '3.10.129.10-FF-000122', NULL, '3-hydroxyacyl-CoA dehydrogenase', 142, NULL, NULL, 103463),
(103464, '3.30.70.270-FF-000011', NULL, 'DNA polymerase kappa', 124, NULL, NULL, 103464),
(103465, '3.30.505.10-FF-000211', NULL, NULL, 112, NULL, NULL, 103465),
(103466, '3.30.70.80-FF-000024', NULL, 'Putative subtilisin-like protease pr1a protein', 79, NULL, NULL, 103466),
(103467, '1.20.1050.10-FF-000084', NULL, 'Cofactor for methionyl-and glutamyl-tRNA synthetases, putative', 104, NULL, NULL, 103467),
(103468, '2.80.10.50-FF-000197', NULL, 'Botulinum neurotoxin type G', 205, NULL, NULL, 103468),
(103469, '1.10.287.1490-FF-000053', NULL, 'AGAP002527-PA', 162, NULL, NULL, 103469),
(103470, '3.40.50.2020-FF-000063', NULL, 'Phosphoribosylpyrophosphate synthetase', 38, NULL, NULL, 103470),
(103471, '1.10.555.10-FF-000193', NULL, NULL, 190, NULL, NULL, 103471),
(103472, '3.10.250.10-FF-000078', NULL, NULL, 111, NULL, NULL, 103472),
(103473, '3.40.1260.20-FF-000012', NULL, 'Cytoplasmic axial filament protein', 55, NULL, NULL, 103473),
(103474, '4.10.830.10-FF-000006', NULL, 'Uncharacterized protein', 36, NULL, NULL, 103474),
(103475, '2.70.170.10-FF-000281', NULL, 'Uncharacterized protein', 73, NULL, NULL, 103475),
(103476, '3.90.660.10-FF-000097', NULL, NULL, 105, NULL, NULL, 103476),
(103477, '3.40.1350.60-FF-000003', NULL, 'Sugar fermentation stimulation protein homolog', 140, NULL, NULL, 103477),
(103478, '1.25.40.10-FF-000114', NULL, 'E3 SUMO-protein ligase RanBP2 isoform X1', 145, NULL, NULL, 103478),
(103479, '2.40.10.10-FF-000176', NULL, 'Chymotrypsinogen A', 98, NULL, NULL, 103479),
(103480, '1.10.3110.10-FF-000002', NULL, 'Protoporphyrinogen oxidase', 102, NULL, NULL, 103480),
(103481, '3.30.43.10-FF-000053', NULL, 'Uncharacterized protein', 59, NULL, NULL, 103481),
(103482, '1.10.238.10-FF-000916', NULL, 'Mitochondrial Rho GTPase 2', 82, NULL, NULL, 103482),
(103483, '3.40.50.300-FF-002419', NULL, 'ATP-dependent RNA helicase MSS116, mitochondrial', 260, NULL, NULL, 103483),
(103484, '2.130.10.10-FF-002296', NULL, 'Telomerase Cajal body protein 1 homolog', 170, NULL, NULL, 103484),
(103485, '3.60.21.50-FF-000018', NULL, 'DNA polymerase epsilon subunit B, putative', 247, NULL, NULL, 103485),
(103486, '2.120.10.30-FF-000088', NULL, 'Megalin, isoform A', 323, NULL, NULL, 103486),
(103487, '3.30.450.70-FF-000016', NULL, 'Trafficking protein particle complex 2 like', 40, NULL, NULL, 103487),
(103488, '2.40.50.140-FF-000116', NULL, 'Asparagine--tRNA ligase', 101, NULL, NULL, 103488),
(103489, '1.25.40.10-FF-001103', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', 102, NULL, NULL, 103489),
(103490, '2.130.10.10-FF-000380', NULL, 'Dynein intermediate chain 2, axonemal', 189, NULL, NULL, 103490),
(103491, '3.30.430.20-FF-000051', NULL, 'Cysteine-rich RLK (RECEPTOR-like protein kinase) 38', 101, NULL, NULL, 103491),
(103492, '1.10.287.940-FF-000011', NULL, 'P2X purinoceptor', 35, NULL, NULL, 103492),
(103493, '1.10.630.10-FF-000789', NULL, 'Uncharacterized protein', 112, NULL, NULL, 103493),
(103494, '3.90.260.10-FF-000049', NULL, 'Uncharacterized protein', 224, NULL, NULL, 103494),
(103495, '3.80.10.10-FF-002111', NULL, 'Uncharacterized protein', 374, NULL, NULL, 103495),
(103496, '3.30.70.3490-FF-000040', NULL, NULL, 105, NULL, NULL, 103496),
(103497, '1.10.287.70-FF-000401', NULL, 'GD16867', 137, NULL, NULL, 103497),
(103498, '3.10.180.10-FF-000111', NULL, '4-hydroxyphenylpyruvate dioxygenase', 81, NULL, NULL, 103498),
(103499, '1.20.1260.140-FF-000004', NULL, 'Mitochondrial alternative oxidase', 249, NULL, NULL, 103499),
(103500, '3.10.100.10-FF-000365', NULL, NULL, 149, NULL, NULL, 103500),
(103501, '3.40.30.10-FF-000815', NULL, 'Uncharacterized protein', 90, NULL, NULL, 103501);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(103502, '4.10.970.10-FF-000016', NULL, 'ATP-dependent DNA helicase II subunit 1', 68, NULL, NULL, 103502),
(103503, '1.25.40.20-FF-001106', NULL, '85/88 kDa calcium-independent phospholipase A2 isoform X6', 53, NULL, NULL, 103503),
(103504, '1.25.10.10-FF-002703', NULL, 'Uncharacterized protein', 56, NULL, NULL, 103504),
(103505, '2.40.70.10-FF-000393', NULL, NULL, 228, NULL, NULL, 103505),
(103506, '2.10.25.10-FF-000649', NULL, 'Uncharacterized protein, isoform A', 41, NULL, NULL, 103506),
(103507, '2.60.40.60-FF-000629', NULL, 'putative protocadherin beta-18', 110, NULL, NULL, 103507),
(103508, '1.10.287.110-FF-000088', NULL, 'Co-chaperone protein HscB homolog', 78, NULL, NULL, 103508),
(103509, '3.30.70.2510-FF-000010', NULL, NULL, 150, NULL, NULL, 103509),
(103510, '2.60.40.10-FF-006028', NULL, NULL, 77, NULL, NULL, 103510),
(103511, '2.30.39.10-FF-000074', NULL, 'Predicted protein', 130, NULL, NULL, 103511),
(103512, '1.25.40.10-FF-003874', NULL, 'Os12g0281933 protein', 91, NULL, NULL, 103512),
(103513, '1.10.1450.10-FF-000139', NULL, 'Uncharacterized protein', 126, NULL, NULL, 103513),
(103514, '2.60.40.10-FF-001975', NULL, 'Uncharacterized protein', 107, NULL, NULL, 103514),
(103515, '1.50.40.10-FF-000494', NULL, 'Predicted protein', 274, NULL, NULL, 103515),
(103516, '3.40.50.2300-FF-001658', NULL, NULL, 194, NULL, NULL, 103516),
(103517, '1.25.40.20-FF-000443', NULL, 'Putative vps9 domain protein', 273, NULL, NULL, 103517),
(103518, '1.25.10.10-FF-000174', NULL, 'Ecm29 proteasome adaptor and scaffold', 193, NULL, NULL, 103518),
(103519, '3.90.70.40-FF-000015', NULL, 'Uncharacterized protein', 161, NULL, NULL, 103519),
(103520, '3.80.10.10-FF-003364', NULL, 'Uncharacterized protein', 111, NULL, NULL, 103520),
(103521, '3.40.50.1000-FF-000268', NULL, 'ATPase 4 plasma membrane-type', 122, NULL, NULL, 103521),
(103522, '3.40.50.620-FF-000599', NULL, 'Tryptophan--tRNA ligase', 210, NULL, NULL, 103522),
(103523, '3.40.630.30-FF-000567', NULL, 'Acetyltransferase (GNAT) family protein', 116, NULL, NULL, 103523),
(103524, '1.20.58.60-FF-000410', NULL, 'Nesprin-1', 109, NULL, NULL, 103524),
(103525, '3.90.1640.20-FF-000002', NULL, 'Uncharacterized protein', 133, NULL, NULL, 103525),
(103526, '1.25.40.20-FF-000589', NULL, 'ankyrin repeat and KH domain-containing protein 1 isoform X2', 202, NULL, NULL, 103526),
(103527, '3.10.20.90-FF-000536', NULL, 'serine/threonine protein kinase isoform X1', 69, NULL, NULL, 103527),
(103528, '1.10.8.60-FF-000356', NULL, 'FtsH-like AAA+ protein', 72, NULL, NULL, 103528),
(103529, '3.30.530.20-FF-000109', NULL, 'Uncharacterized protein', 52, NULL, NULL, 103529),
(103530, '3.40.1740.10-FF-000001', NULL, 'UPF0301 protein YqgE', 80, NULL, NULL, 103530),
(103531, '1.20.1250.20-FF-001732', NULL, 'Uncharacterized protein', 311, NULL, NULL, 103531),
(103532, '2.130.10.10-FF-000587', NULL, 'Plexin A4, B', 456, NULL, NULL, 103532),
(103533, '3.30.530.20-FF-000053', NULL, 'Uncharacterized protein', 154, NULL, NULL, 103533),
(103534, '2.30.30.40-FF-000276', NULL, 'CheW-like protein', 59, NULL, NULL, 103534),
(103535, '1.10.287.110-FF-000408', NULL, 'Predicted protein', 104, NULL, NULL, 103535),
(103536, '3.40.50.720-FF-001646', NULL, 'UDP-glucose 4-epimerase (GalE-2)', 308, NULL, NULL, 103536),
(103537, '3.90.70.10-FF-000265', NULL, 'ubiquitin carboxyl-terminal hydrolase 35', 341, NULL, NULL, 103537),
(103538, '3.40.50.10190-FF-000079', NULL, 'Mutator 2, isoform B', 111, NULL, NULL, 103538),
(103539, '1.20.1310.10-FF-000183', NULL, NULL, 147, NULL, NULL, 103539),
(103540, '1.20.120.350-FF-000265', NULL, NULL, 112, NULL, NULL, 103540),
(103541, '3.30.160.60-FF-004920', NULL, NULL, 80, NULL, NULL, 103541),
(103542, '2.60.40.10-FF-002638', NULL, 'Neuronal immunoglobulin domain-containing protein rig-3', 101, NULL, NULL, 103542),
(103543, '2.70.150.10-FF-000072', NULL, 'Phospholipid-transporting ATPase', 222, NULL, NULL, 103543),
(103544, '3.40.390.10-FF-000053', NULL, 'Metalloendopeptidase', 283, NULL, NULL, 103544),
(103545, '3.30.200.20-FF-002304', NULL, 'Uncharacterized protein', 27, NULL, NULL, 103545);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(103546, '2.60.120.1040-FF-000006', NULL, 'Zinc finger protein zpr1', 144, NULL, NULL, 103546),
(103547, '3.30.40.10-FF-001974', NULL, 'Uncharacterized protein', 62, NULL, NULL, 103547),
(103548, '2.30.29.240-FF-000018', NULL, 'Phosphoinositide phospholipase C', 148, NULL, NULL, 103548),
(103549, '1.10.506.10-FF-000091', NULL, 'Uncharacterized protein', 97, NULL, NULL, 103549),
(103550, '1.20.120.1240-FF-000044', NULL, 'Dynamin-related GTPase', 299, NULL, NULL, 103550),
(103551, '2.130.10.10-FF-004802', NULL, 'Uncharacterized protein', 145, NULL, NULL, 103551),
(103552, '3.30.450.40-FF-000266', NULL, 'Osmosensitive potassium channel sensor histidine kinase KdpD, KdpD and USP_OKCHK domain-containing', 146, NULL, NULL, 103552),
(103553, '2.20.28.120-FF-000001', NULL, '50S ribosomal protein L33', 55, NULL, NULL, 103553),
(103554, '3.80.30.20-FF-000024', NULL, 'Fe-S oxidoreductase', 235, NULL, NULL, 103554),
(103555, '1.10.1170.10-FF-000011', NULL, 'E3 ubiquitin-protein ligase XIAP', 111, NULL, NULL, 103555),
(103556, '2.60.40.60-FF-000422', NULL, 'Cadherin 26', 108, NULL, NULL, 103556),
(103557, '2.170.270.10-FF-000096', NULL, 'Histone-lysine N-methyltransferase set-26', 145, NULL, NULL, 103557),
(103558, '3.40.30.10-FF-000579', NULL, 'MIP10555p', 106, NULL, NULL, 103558),
(103559, '1.25.40.10-FF-004537', NULL, 'Hsp70/Hsp90 organizing protein', 58, NULL, NULL, 103559),
(103560, '1.20.1250.20-FF-001024', NULL, 'MFS general substrate transporter', 195, NULL, NULL, 103560),
(103561, '3.30.559.30-FF-000021', NULL, 'Nonribosomal peptide synthetase 7', 236, NULL, NULL, 103561),
(103562, '1.25.40.10-FF-004122', NULL, 'Uncharacterized protein', 126, NULL, NULL, 103562),
(103563, '3.30.160.60-FF-003869', NULL, NULL, 27, NULL, NULL, 103563),
(103564, '2.60.120.10-FF-000409', NULL, '2-hydroxyethylphosphonate dioxygenase', 124, NULL, NULL, 103564),
(103565, '3.40.50.2300-FF-000523', NULL, 'Response regulator', 150, NULL, NULL, 103565),
(103566, '2.60.40.1120-FF-000036', NULL, 'Putative vitamin B12 receptor', 76, NULL, NULL, 103566),
(103567, '2.60.40.10-FF-004263', NULL, NULL, 98, NULL, NULL, 103567),
(103568, '2.60.40.60-FF-000484', NULL, 'Cadherin-89D', 113, NULL, NULL, 103568),
(103569, '2.40.290.30-FF-000010', NULL, 'Uncharacterized protein', 106, NULL, NULL, 103569),
(103570, '3.30.70.330-FF-000254', NULL, 'ATP-dependent RNA helicase DbpA', 73, NULL, NULL, 103570),
(103571, '3.80.10.10-FF-001240', NULL, 'F-box/leucine rich repeat protein', 293, NULL, NULL, 103571),
(103572, '1.10.10.60-FF-000076', NULL, 'Homeobox protein knotted-1-like 2', 63, NULL, NULL, 103572),
(103573, '3.40.1160.10-FF-000058', NULL, 'Aspartokinase', 248, NULL, NULL, 103573),
(103574, '1.20.1270.60-FF-000059', NULL, 'Rho GTPase activating protein 4b', 290, NULL, NULL, 103574),
(103575, '2.40.30.130-FF-000047', NULL, 'Uncharacterized protein', 96, NULL, NULL, 103575),
(103576, '2.40.10.10-FF-000119', NULL, 'ORF1a polyprotein', 73, NULL, NULL, 103576),
(103577, '3.80.10.10-FF-000020', NULL, 'Erbin isoform 7', 208, NULL, NULL, 103577),
(103578, '3.60.21.10-FF-000439', NULL, 'Uncharacterized protein', 230, NULL, NULL, 103578),
(103579, '3.40.50.880-FF-000070', NULL, 'Phosphoribosylformylglycinamidine synthase', 308, NULL, NULL, 103579),
(103580, '3.50.50.60-FF-001365', NULL, 'Monooxygenase, putative', 39, NULL, NULL, 103580),
(103581, '3.40.50.300-FF-000767', NULL, 'Putative ATP-dependent RNA helicase DHX35', 174, NULL, NULL, 103581),
(103582, '3.40.50.1000-FF-000532', NULL, NULL, 217, NULL, NULL, 103582),
(103583, '3.30.559.70-FF-000038', NULL, 'Carnitine O-acetyltransferase, putative', 334, NULL, NULL, 103583),
(103584, '3.40.50.150-FF-001104', NULL, NULL, 158, NULL, NULL, 103584),
(103585, '1.20.1250.70-FF-000004', NULL, 'Interleukin', 115, NULL, NULL, 103585),
(103586, '2.160.20.10-FF-000081', NULL, 'SHC SH2 domain-binding protein 1 homolog A', 318, NULL, NULL, 103586),
(103587, '1.10.357.150-FF-000004', NULL, 'Centromere/kinetochore protein zw10 homolog', 195, NULL, NULL, 103587),
(103588, '1.10.10.10-FF-001596', NULL, '5-pentadecatrienyl resorcinol O-methyltransferase', 110, NULL, NULL, 103588);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(103589, '3.40.800.20-FF-000038', NULL, 'Histone deacetylase', 388, NULL, NULL, 103589),
(103590, '3.40.50.10470-FF-000073', NULL, 'Uncharacterized protein', 201, NULL, NULL, 103590),
(103591, '3.40.50.10490-FF-000079', NULL, 'Galactosamine 6-phosphate isomerase AgaS', 179, NULL, NULL, 103591),
(103592, '3.40.50.1000-FF-000678', NULL, NULL, 166, NULL, NULL, 103592),
(103593, '2.40.10.10-FF-000058', NULL, 'Tissue-type plasminogen activator', 112, NULL, NULL, 103593),
(103594, '3.40.800.10-FF-000035', NULL, 'Arginase', 315, NULL, NULL, 103594),
(103595, '3.10.450.10-FF-000059', NULL, 'Cysteine proteinase inhibitor 7', 77, NULL, NULL, 103595),
(103596, '1.10.20.10-FF-000051', NULL, 'DNA polymerase epsilon 4, accessory subunit', 100, NULL, NULL, 103596),
(103597, '3.40.50.300-FF-000621', NULL, 'Interferon-induced GTP-binding protein Mx1', 298, NULL, NULL, 103597),
(103598, '3.30.450.30-FF-000055', NULL, 'Uncharacterized protein', 49, NULL, NULL, 103598),
(103599, '3.10.290.10-FF-000086', NULL, 'Tyrosine--tRNA ligase', 100, NULL, NULL, 103599),
(103600, '3.40.50.300-FF-002712', NULL, 'GD25199', 184, NULL, NULL, 103600),
(103601, '1.25.40.10-FF-004329', NULL, 'Signal recognition particle subunit SRP72', 167, NULL, NULL, 103601),
(103602, '3.30.450.40-FF-000058', NULL, 'GAF domain-containing protein', 154, NULL, NULL, 103602),
(103603, '1.10.10.10-FF-000932', NULL, 'Histone acetyltransferase', 81, NULL, NULL, 103603),
(103604, '2.130.10.10-FF-002178', NULL, 'Kinesin-like protein', 127, NULL, NULL, 103604),
(103605, '2.60.40.10-FF-000463', NULL, 'Immunoglobulin heavy constant gamma 1', 109, NULL, NULL, 103605),
(103606, '3.30.70.3250-FF-000018', NULL, NULL, 120, NULL, NULL, 103606),
(103607, '3.80.10.10-FF-001801', NULL, 'LRR47', 110, NULL, NULL, 103607),
(103608, '1.20.1270.280-FF-000059', NULL, 'Predicted protein', 156, NULL, NULL, 103608),
(103609, '2.130.10.10-FF-004123', NULL, 'Predicted protein', 188, NULL, NULL, 103609),
(103610, '1.10.510.10-FF-004147', NULL, NULL, 42, NULL, NULL, 103610),
(103611, '3.90.226.10-FF-000116', NULL, 'Enoyl-CoA hydratase', 229, NULL, NULL, 103611),
(103612, '3.30.200.20-FF-000652', NULL, 'probably inactive leucine-rich repeat receptor-like protein kinase At5g06940', 85, NULL, NULL, 103612),
(103613, '2.60.120.1030-FF-000003', NULL, 'mRNA cleavage and polyadenylation factor CLP1', 85, NULL, NULL, 103613),
(103614, '3.20.20.140-FF-000257', NULL, 'Alpha-D-ribose 1-methylphosphonate 5-triphosphate diphosphatase', 120, NULL, NULL, 103614),
(103615, '3.50.50.60-FF-001247', NULL, 'Flavin-containing monooxygenase', 158, NULL, NULL, 103615),
(103616, '2.60.40.10-FF-004881', NULL, NULL, 122, NULL, NULL, 103616),
(103617, '3.40.190.10-FF-000280', NULL, 'Prephenate dehydratase, putative', 86, NULL, NULL, 103617),
(103618, '2.10.25.10-FF-000121', NULL, 'Neural EGFL like 2', 47, NULL, NULL, 103618),
(103619, '3.60.110.10-FF-000051', NULL, NULL, 85, NULL, NULL, 103619),
(103620, '3.30.60.20-FF-000141', NULL, 'Uncharacterized protein', 59, NULL, NULL, 103620),
(103621, '3.40.50.11030-FF-000016', NULL, NULL, 147, NULL, NULL, 103621),
(103622, '2.60.120.10-FF-000527', NULL, 'Diguanylate cyclase, CAP_ED domain-containing', 127, NULL, NULL, 103622),
(103623, '3.40.50.1820-FF-001554', NULL, 'Uncharacterized protein', 123, NULL, NULL, 103623),
(103624, '3.30.40.10-FF-001474', NULL, 'Uncharacterized protein (Fragment)', 57, NULL, NULL, 103624),
(103625, '1.20.1280.290-FF-000013', NULL, 'lysosomal amino acid transporter 1 homolog', 87, NULL, NULL, 103625),
(103626, '3.40.50.2300-FF-001187', NULL, NULL, 21, NULL, NULL, 103626),
(103627, '1.20.1280.290-FF-000070', NULL, 'Predicted protein', 110, NULL, NULL, 103627),
(103628, '2.60.40.150-FF-000371', NULL, 'E3 ubiquitin-protein ligase', 129, NULL, NULL, 103628),
(103629, '2.60.40.60-FF-000630', NULL, 'Protocadherin 1 gamma 32', 116, NULL, NULL, 103629),
(103630, '3.30.46.10-FF-000003', NULL, 'Glycine/sarcosine N-methyltransferase', 59, NULL, NULL, 103630),
(103631, '3.40.50.2300-FF-000023', NULL, 'Transcriptional regulatory protein RcsB', 147, NULL, NULL, 103631);
INSERT INTO "PUBLIC"."MODEL" VALUES
(103632, '1.20.1530.20-FF-000017', NULL, 'Na+/H+/K+ antiporter GerN', 384, NULL, NULL, 103632),
(103633, '1.10.730.10-FF-000061', NULL, 'Valyl-tRNA synthetase, isoform A', 180, NULL, NULL, 103633),
(103634, '2.10.110.10-FF-000021', NULL, 'Lim and senescent cell antigen-like-containing', 68, NULL, NULL, 103634),
(103635, '4.10.240.10-FF-000186', NULL, 'Ecm22p', 86, NULL, NULL, 103635),
(103636, '1.20.58.70-FF-000060', NULL, 'Syntaxin 2a', 131, NULL, NULL, 103636),
(103637, '1.20.1250.20-FF-001524', NULL, 'Uncharacterized protein', 366, NULL, NULL, 103637),
(103638, '3.20.20.70-FF-000389', NULL, 'Putative transmembrane GTPase FZO-like, chloroplastic', 135, NULL, NULL, 103638),
(103639, '1.25.40.10-FF-000176', NULL, 'dynein assembly factor 4, axonemal isoform X1', 124, NULL, NULL, 103639),
(103640, '3.30.70.1660-FF-000036', NULL, 'Uncharacterized protein PRFA2', 77, NULL, NULL, 103640),
(103641, '3.40.50.1820-FF-001054', NULL, 'Retinoid-inducible serine carboxypeptidase', 417, NULL, NULL, 103641),
(103642, '3.30.40.10-FF-002137', NULL, 'RBR-type E3 ubiquitin transferase', 88, NULL, NULL, 103642),
(103643, '3.50.80.10-FF-000003', NULL, 'probable D-tyrosyl-tRNA(Tyr) deacylase 2', 166, NULL, NULL, 103643),
(103644, '1.10.110.10-FF-000002', NULL, 'Non-specific lipid-transfer protein', 92, NULL, NULL, 103644),
(103645, '3.30.1490.80-FF-000004', NULL, 'Glutathione synthetase', 84, NULL, NULL, 103645),
(103646, '2.40.128.700-FF-000004', NULL, 'Chromosome 23, whole genome shotgun sequence', 116, NULL, NULL, 103646),
(103647, '3.30.572.10-FF-000006', NULL, 'Thymidylate synthase', 278, NULL, NULL, 103647),
(103648, '2.60.40.10-FF-006062', NULL, NULL, 127, NULL, NULL, 103648),
(103649, '1.10.600.10-FF-000023', NULL, 'Squalene synthase', 335, NULL, NULL, 103649),
(103650, '3.40.1360.10-FF-000039', NULL, 'Topoisomerase-like enzyme1', 102, NULL, NULL, 103650),
(103651, '1.20.50.70-FF-000002', NULL, 'Complement component C3-4', 40, NULL, NULL, 103651),
(103652, '3.30.70.330-FF-000462', NULL, 'Zinc finger CCCH domain-containing protein 25', 105, NULL, NULL, 103652),
(103653, '2.130.10.10-FF-002532', NULL, 'F-box/WD-40 repeat-containing protein At5g21040', 225, NULL, NULL, 103653),
(103654, '2.40.30.10-FF-000121', NULL, 'Translation elongation factor Tu', 110, NULL, NULL, 103654),
(103655, '2.60.40.60-FF-000276', NULL, 'FAT atypical cadherin 2', 105, NULL, NULL, 103655),
(103656, '1.10.10.10-FF-001860', NULL, 'Histone acetyltransferase', 73, NULL, NULL, 103656),
(103657, '1.20.1070.10-FF-001069', NULL, 'C-C chemokine receptor type 5', 329, NULL, NULL, 103657),
(103658, '3.40.50.300-FF-004628', NULL, 'ABC transporter-like protein', 235, NULL, NULL, 103658),
(103659, '2.130.10.10-FF-004241', NULL, 'Uncharacterized protein', 141, NULL, NULL, 103659),
(103660, '3.40.50.150-FF-000087', NULL, 'tRNA1(Val) (adenine(37)-N6)-methyltransferase', 233, NULL, NULL, 103660),
(103661, '3.40.980.10-FF-000019', NULL, 'Molybdopterin molybdenumtransferase', 154, NULL, NULL, 103661),
(103662, '1.10.10.60-FF-000576', NULL, 'Double homeobox B-like 1', 64, NULL, NULL, 103662),
(103663, '2.130.10.10-FF-000087', NULL, 'WD repeat-containing protein 26 homolog', 305, NULL, NULL, 103663),
(103664, '3.40.640.10-FF-000180', NULL, 'Biogenic Amine Synthesis related', 300, NULL, NULL, 103664),
(103665, '3.90.79.10-FF-000054', NULL, 'ADP compounds hydrolase nudE', 168, NULL, NULL, 103665),
(103666, '3.40.47.10-FF-000117', NULL, '4-hydroxycoumarin synthase 1', 155, NULL, NULL, 103666),
(103667, '3.30.70.1450-FF-000006', NULL, 'Citrate transporter protein', 76, NULL, NULL, 103667),
(103668, '1.25.40.20-FF-000179', NULL, 'NF-kappa-B inhibitor zeta isoform X2', 200, NULL, NULL, 103668),
(103669, '3.20.20.60-FF-000061', NULL, 'Phosphoenolpyruvate carboxylase family protein', 305, NULL, NULL, 103669),
(103670, '1.10.510.10-FF-003984', NULL, NULL, 148, NULL, NULL, 103670),
(103671, '1.10.1420.10-FF-000199', NULL, 'DNA mismatch repair protein', 103, NULL, NULL, 103671),
(103672, '3.30.1330.10-FF-000017', NULL, 'Phosphoribosylformylglycinamidine synthase', 204, NULL, NULL, 103672);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(103673, '1.10.10.10-FF-000522', NULL, 'Forkhead domain protein', 106, NULL, NULL, 103673),
(103674, '3.40.50.300-FF-008518', NULL, 'AAA ATPase domain-containing protein', 105, NULL, NULL, 103674),
(103675, '1.10.510.10-FF-003894', NULL, NULL, 87, NULL, NULL, 103675),
(103676, '1.10.3260.10-FF-000046', NULL, 'DNA ligase', 120, NULL, NULL, 103676),
(103677, '1.10.10.10-FF-000432', NULL, 'Cullin 2', 46, NULL, NULL, 103677),
(103678, '3.40.50.1000-FF-000414', NULL, 'Phosphoserine phosphatase SerB', 247, NULL, NULL, 103678),
(103679, '1.20.120.350-FF-000208', NULL, NULL, 57, NULL, NULL, 103679),
(103680, '1.10.1040.30-FF-000013', NULL, 'Predicted protein', 59, NULL, NULL, 103680),
(103681, '3.10.580.10-FF-000097', NULL, 'SNF1-related protein kinase regulatory subunit gamma-like PV42a', 193, NULL, NULL, 103681),
(103682, '3.40.50.300-FF-000885', NULL, 'DNA polymerase theta', 207, NULL, NULL, 103682),
(103683, '1.10.357.70-FF-000019', NULL, 'Component of the exocyst complex', 168, NULL, NULL, 103683),
(103684, '2.130.10.10-FF-002442', NULL, 'Cleavage and polyadenylation specificity factor subunit 1', 403, NULL, NULL, 103684),
(103685, '2.60.40.10-FF-001857', NULL, 'Hemicentin 2', 91, NULL, NULL, 103685),
(103686, '3.40.50.300-FF-001695', NULL, 'ATP-binding cassette sub-family G member', 235, NULL, NULL, 103686),
(103687, '2.130.10.10-FF-001104', NULL, 'WD repeat-containing protein 44 isoform A', 245, NULL, NULL, 103687),
(103688, '3.40.50.300-FF-004157', NULL, 'Katanin p60 ATPase-containing subunit A-like 2', 174, NULL, NULL, 103688),
(103689, '1.10.472.10-FF-000185', NULL, 'FAM58A isoform 10', 94, NULL, NULL, 103689),
(103690, '3.40.50.10330-FF-000048', NULL, 'NAD kinase', 135, NULL, NULL, 103690),
(103691, '3.40.850.10-FF-000072', NULL, 'Kinesin family protein', 333, NULL, NULL, 103691),
(103692, '3.30.479.30-FF-000020', NULL, 'SPFH domain/Band 7 family protein', 137, NULL, NULL, 103692),
(103693, '1.10.730.20-FF-000007', NULL, 'Isoleucine--tRNA ligase', 271, NULL, NULL, 103693),
(103694, '1.10.472.80-FF-000099', NULL, 'Gyl1p', 165, NULL, NULL, 103694),
(103695, '3.40.225.10-FF-000030', NULL, 'Rhamnulose-1-phosphate aldolase/alcohol dehydrogenase', 220, NULL, NULL, 103695),
(103696, '1.50.10.10-FF-000195', NULL, 'alpha-1,2-Mannosidase', 498, NULL, NULL, 103696),
(103697, '3.40.33.10-FF-000176', NULL, 'Uncharacterized protein', 85, NULL, NULL, 103697),
(103698, '3.30.50.10-FF-000165', NULL, 'Uncharacterized protein', 86, NULL, NULL, 103698),
(103699, '3.50.50.60-FF-000230', NULL, 'Dihydrolipoyl dehydrogenase', 30, NULL, NULL, 103699),
(103700, '3.30.1390.20-FF-000030', NULL, 'Uncharacterized protein', 58, NULL, NULL, 103700),
(103701, '2.60.40.790-FF-000208', NULL, NULL, 86, NULL, NULL, 103701),
(103702, '1.10.3720.10-FF-000183', NULL, 'ABC Amino Acid Transporter Permease', 212, NULL, NULL, 103702),
(103703, '1.10.640.10-FF-000031', NULL, 'Myeloid-specific peroxidase', 247, NULL, NULL, 103703),
(103704, '3.40.50.720-FF-000011', NULL, 'Potassium channel subfamily T member 1', 143, NULL, NULL, 103704),
(103705, '2.60.40.10-FF-002880', NULL, 'Leptin receptor', 96, NULL, NULL, 103705),
(103706, '1.10.730.10-FF-000004', NULL, 'Isoleucyl-tRNA synthetase, cytoplasmic', 200, NULL, NULL, 103706),
(103707, '3.30.70.330-FF-001272', NULL, 'U2 snRNP auxiliary factor large subunit, putative', 75, NULL, NULL, 103707),
(103708, '3.50.50.100-FF-000008', NULL, 'External alternative NAD(P)H-ubiquinone oxidoreductase B1, mitochondrial', 156, NULL, NULL, 103708),
(103709, '3.30.160.60-FF-002734', NULL, 'CBN-HAM-2 protein', 54, NULL, NULL, 103709),
(103710, '3.30.40.10-FF-001917', NULL, 'Uncharacterized protein', 71, NULL, NULL, 103710),
(103711, '3.30.200.20-FF-001787', NULL, 'Tyrosine-protein kinase', 91, NULL, NULL, 103711),
(103712, '1.20.1250.20-FF-001939', NULL, 'Uncharacterized protein', 463, NULL, NULL, 103712),
(103713, '3.30.160.60-FF-006365', NULL, NULL, 81, NULL, NULL, 103713),
(103714, '3.90.226.10-FF-000324', NULL, 'Uncharacterized protein', 188, NULL, NULL, 103714),
(103715, '3.30.160.60-FF-000525', NULL, 'IKAROS family zinc finger 1', 78, NULL, NULL, 103715);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(103716, '3.30.160.60-FF-005140', NULL, NULL, 48, NULL, NULL, 103716),
(103717, '1.25.10.10-FF-000551', NULL, 'HEAT repeat-containing 1', 381, NULL, NULL, 103717),
(103718, '1.10.8.270-FF-000042', NULL, 'TBC/Rab GTPase activating domain containing protein', 98, NULL, NULL, 103718),
(103719, '2.70.170.10-FF-000129', NULL, 'Predicted protein', 218, NULL, NULL, 103719),
(103720, '3.40.190.10-FF-000072', NULL, 'glutamate receptor ionotropic, kainate 4', 144, NULL, NULL, 103720),
(103721, '2.120.10.80-FF-000024', NULL, 'Kelch-like ECH-associated protein 1', 311, NULL, NULL, 103721),
(103722, '2.40.10.10-FF-000529', NULL, NULL, 99, NULL, NULL, 103722),
(103723, '1.10.1070.11-FF-000044', NULL, 'NuA4 histone acetyltransferase subunit', 203, NULL, NULL, 103723),
(103724, '3.90.70.10-FF-000618', NULL, 'Uncharacterized protein', 149, NULL, NULL, 103724),
(103725, '1.25.10.10-FF-001776', NULL, 'Importin, putative', 855, NULL, NULL, 103725),
(103726, '3.30.720.210-FF-000023', NULL, 'ATP-dependent zinc metalloprotease FtsH 4', 86, NULL, NULL, 103726),
(103727, '3.40.50.720-FF-001293', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 159, NULL, NULL, 103727),
(103728, '1.20.1080.10-FF-000001', NULL, 'Probable aquaporin PIP1-2', 258, NULL, NULL, 103728),
(103729, '3.90.470.20-FF-000040', NULL, 'Phosphopantetheinyl transferase', 102, NULL, NULL, 103729),
(103730, '3.50.30.50-FF-000017', NULL, 'Uncharacterized protein', 112, NULL, NULL, 103730),
(103731, '2.120.10.80-FF-000081', NULL, 'Multiple EGF like domains 8', 122, NULL, NULL, 103731),
(103732, '1.10.860.10-FF-000008', NULL, 'Replicative DNA helicase', 163, NULL, NULL, 103732),
(103733, '1.20.58.60-FF-000787', NULL, 'Dystonin', 216, NULL, NULL, 103733),
(103734, '1.25.40.10-FF-000322', NULL, 'RNA polymerase-associated protein CTR9 homolog', 307, NULL, NULL, 103734),
(103735, '3.40.50.720-FF-002220', NULL, 'Glyoxylate reductase/hydroxypyruvate reductase b', 109, NULL, NULL, 103735),
(103736, '3.40.640.10-FF-000028', NULL, 'L-seryl-tRNA(Sec) selenium transferase', 264, NULL, NULL, 103736),
(103737, '3.40.50.2300-FF-000113', NULL, 'Low molecular weight protein-tyrosine-phosphatase', 157, NULL, NULL, 103737),
(103738, '2.60.40.150-FF-000219', NULL, 'Copine-E', 129, NULL, NULL, 103738),
(103739, '3.40.190.10-FF-000015', NULL, 'Glycine cleavage system transcriptional activator', 92, NULL, NULL, 103739),
(103740, '3.30.360.10-FF-000071', NULL, 'Dehydrogenase, putative', 243, NULL, NULL, 103740),
(103741, '3.30.1370.10-FF-000082', NULL, 'RNA-binding protein PNO1', 97, NULL, NULL, 103741),
(103742, '2.40.240.10-FF-000018', NULL, '50S ribosomal protein L25', 95, NULL, NULL, 103742),
(103743, '3.30.70.330-FF-001890', NULL, NULL, 88, NULL, NULL, 103743),
(103744, '3.40.50.300-FF-006461', NULL, 'Uncharacterized protein', 120, NULL, NULL, 103744),
(103745, '2.60.120.650-FF-000092', NULL, 'Specific transcriptional repressor', 281, NULL, NULL, 103745),
(103746, '3.40.395.10-FF-000042', NULL, 'Uncharacterized protein', 124, NULL, NULL, 103746),
(103747, '1.10.240.10-FF-000006', NULL, 'Tyrosine--tRNA ligase', 108, NULL, NULL, 103747),
(103748, '1.20.1280.50-FF-000085', NULL, 'F-box domain containing protein', 52, NULL, NULL, 103748),
(103749, '1.10.287.990-FF-000008', NULL, 'Superoxide dismutase [Fe]', 67, NULL, NULL, 103749),
(103750, '2.40.70.10-FF-000505', NULL, NULL, 105, NULL, NULL, 103750),
(103751, '3.40.50.300-FF-007855', NULL, 'Dicer-1, putative', 216, NULL, NULL, 103751),
(103752, '1.10.510.10-FF-002348', NULL, NULL, 198, NULL, NULL, 103752),
(103753, '3.30.200.20-FF-000242', NULL, 'Mitogen-activated protein kinase', 94, NULL, NULL, 103753),
(103754, '2.30.30.40-FF-000630', NULL, 'EPS8-like 3a', 86, NULL, NULL, 103754),
(103755, '3.90.132.10-FF-000027', NULL, 'Predicted protein', 128, NULL, NULL, 103755),
(103756, '2.60.11.10-FF-000008', NULL, 'Cytochrome c oxidase subunit 5b-2 mitochondrial', 54, NULL, NULL, 103756),
(103757, '3.40.50.300-FF-006219', NULL, 'Uncharacterized protein', 229, NULL, NULL, 103757),
(103758, '2.30.250.10-FF-000015', NULL, 'Uncharacterized protein', 47, NULL, NULL, 103758);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(103759, '1.20.1050.10-FF-000230', NULL, 'Uncharacterized protein', 94, NULL, NULL, 103759),
(103760, '1.25.10.10-FF-000758', NULL, 'Cadmus, isoform A', 915, NULL, NULL, 103760),
(103761, '3.30.565.10-FF-000248', NULL, 'Hybrid sensor histidine kinase/response regulator', 149, NULL, NULL, 103761),
(103762, '1.20.1250.20-FF-001378', NULL, 'Uncharacterized protein', 193, NULL, NULL, 103762),
(103763, '3.10.180.10-FF-000050', NULL, 'Probable ring-cleaving dioxygenase', 130, NULL, NULL, 103763),
(103764, '3.40.50.2300-FF-001451', NULL, NULL, 17, NULL, NULL, 103764),
(103765, '2.40.10.10-FF-000322', NULL, 'Putative peptidase Cgl1093', 177, NULL, NULL, 103765),
(103766, '3.30.200.20-FF-001580', NULL, 'Uncharacterized protein', 27, NULL, NULL, 103766),
(103767, '1.20.120.1750-FF-000045', NULL, 'RBR-type E3 ubiquitin transferase', 242, NULL, NULL, 103767),
(103768, '3.30.160.60-FF-006275', NULL, NULL, 53, NULL, NULL, 103768),
(103769, '2.60.40.60-FF-000219', NULL, 'Cadherin 5', 110, NULL, NULL, 103769),
(103770, '3.40.630.10-FF-000297', NULL, 'Uncharacterized protein', 322, NULL, NULL, 103770),
(103771, '1.25.40.10-FF-002531', NULL, 'Pentatricopeptide repeat-containing protein At3g23020', 112, NULL, NULL, 103771),
(103772, '1.10.510.10-FF-002702', NULL, NULL, 103, NULL, NULL, 103772),
(103773, '1.10.418.10-FF-000043', NULL, 'Spectrin beta chain, non-erythrocytic', 119, NULL, NULL, 103773),
(103774, '1.20.120.1760-FF-000048', NULL, 'Phosphatidylcholine synthase', 173, NULL, NULL, 103774),
(103775, '3.80.10.10-FF-003246', NULL, 'Uncharacterized protein', 178, NULL, NULL, 103775),
(103776, '3.30.420.40-FF-000472', NULL, 'Related to ARP5-Actin-related protein', 161, NULL, NULL, 103776),
(103777, '3.30.1120.10-FF-000007', NULL, 'Secreted sulfatase', 80, NULL, NULL, 103777),
(103778, '1.25.40.470-FF-000011', NULL, 'Intraflagellar transport protein 140', 163, NULL, NULL, 103778),
(103779, '1.10.287.1490-FF-000019', NULL, 'RAS and EF-hand domain containing', 220, NULL, NULL, 103779),
(103780, '2.130.10.10-FF-006039', NULL, 'Predicted protein', 249, NULL, NULL, 103780),
(103781, '1.25.40.20-FF-000325', NULL, 'Ankyrin repeat-containing protein YAR1', 152, NULL, NULL, 103781),
(103782, '3.30.200.20-FF-002451', NULL, 'Uncharacterized protein', 60, NULL, NULL, 103782),
(103783, '3.70.10.10-FF-000009', NULL, 'Proliferating cell nuclear antigen', 264, NULL, NULL, 103783),
(103784, '3.40.50.300-FF-002476', NULL, 'Protein CHROMATIN REMODELING 19 isoform A', 197, NULL, NULL, 103784),
(103785, '3.30.505.10-FF-000065', NULL, 'Transcription elongation factor SPT6', 100, NULL, NULL, 103785),
(103786, '1.10.10.60-FF-000840', NULL, NULL, 73, NULL, NULL, 103786),
(103787, '1.20.58.830-FF-000027', NULL, 'Erythrocyte membrane protein 1', 119, NULL, NULL, 103787),
(103788, '3.30.1370.10-FF-000025', NULL, 'Heterogeneous nuclear ribonucleoprotein K, like', 79, NULL, NULL, 103788),
(103789, '1.20.5.1700-FF-000011', NULL, 'Homer scaffold protein 3', 78, NULL, NULL, 103789),
(103790, '3.30.830.10-FF-000236', NULL, 'Mitochondrial-processing peptidase subunit beta', 232, NULL, NULL, 103790),
(103791, '3.80.10.10-FF-003600', NULL, 'Uncharacterized protein', 127, NULL, NULL, 103791),
(103792, '3.40.50.300-FF-004067', NULL, 'Benign gonial cell neoplasm protein', 171, NULL, NULL, 103792),
(103793, '3.30.70.370-FF-000007', NULL, 'Plastid replication-repair enzyme', 114, NULL, NULL, 103793),
(103794, '3.30.1490.20-FF-000094', NULL, 'Uncharacterized protein', 51, NULL, NULL, 103794),
(103795, '2.60.40.10-FF-004319', NULL, NULL, 94, NULL, NULL, 103795),
(103796, '2.60.40.60-FF-000837', NULL, 'Uncharacterized protein', 107, NULL, NULL, 103796),
(103797, '1.10.167.10-FF-000072', NULL, 'AGAP007895-PA', 118, NULL, NULL, 103797),
(103798, '3.30.160.60-FF-001340', NULL, 'zinc finger protein 75D isoform X1', 32, NULL, NULL, 103798),
(103799, '3.90.190.20-FF-000024', NULL, 'Dihydrofolate synthetase', 138, NULL, NULL, 103799),
(103800, '3.50.50.60-FF-000437', NULL, 'FAD-binding oxidoreductase', 212, NULL, NULL, 103800),
(103801, '3.90.190.10-FF-000021', NULL, 'Receptor-type tyrosine-protein phosphatase alpha', 293, NULL, NULL, 103801);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(103802, '1.25.10.10-FF-002591', NULL, 'Uncharacterized protein', 154, NULL, NULL, 103802),
(103803, '1.20.1050.10-FF-000320', NULL, 'Uncharacterized protein', 95, NULL, NULL, 103803),
(103804, '3.10.129.10-FF-000240', NULL, '4-hydroxybenzoyl-CoA thioesterase', 141, NULL, NULL, 103804),
(103805, '2.30.29.30-FF-000202', NULL, 'rab GTPase-activating protein 1-like isoform X1', 153, NULL, NULL, 103805),
(103806, '1.25.40.10-FF-003666', NULL, 'FI18620p1', 81, NULL, NULL, 103806),
(103807, '1.10.10.10-FF-000168', NULL, 'Replication protein A 32 kDa subunit', 70, NULL, NULL, 103807),
(103808, '3.40.50.10610-FF-000008', NULL, 'Sll1835 protein', 226, NULL, NULL, 103808),
(103809, '1.25.40.10-FF-000940', NULL, 'Os06g0185700 protein', 119, NULL, NULL, 103809),
(103810, '1.20.1560.10-FF-000403', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 304, NULL, NULL, 103810),
(103811, '3.40.120.10-FF-000067', NULL, 'Phosphomannomutase PmmB', 182, NULL, NULL, 103811),
(103812, '3.30.110.20-FF-000004', NULL, 'Ribonuclease P protein subunit p25-like protein', 102, NULL, NULL, 103812),
(103813, '1.25.10.10-FF-002349', NULL, 'Predicted protein', 286, NULL, NULL, 103813),
(103814, '1.10.150.20-FF-000013', NULL, 'U5 small nuclear ribonucleoprotein kDa helicase', 57, NULL, NULL, 103814),
(103815, '4.10.60.10-FF-000260', NULL, 'Universal minicircle sequence binding protein (UMSBP), putative', 23, NULL, NULL, 103815),
(103816, '3.80.20.20-FF-000052', NULL, 'Receptor protein-tyrosine kinase', 104, NULL, NULL, 103816),
(103817, '3.40.50.150-FF-000907', NULL, 'Uncharacterized protein', 223, NULL, NULL, 103817),
(103818, '3.30.110.30-FF-000007', NULL, 'Prolyl-tRNA synthetase, putative', 94, NULL, NULL, 103818),
(103819, '4.10.60.10-FF-000203', NULL, 'Uncharacterized protein', 55, NULL, NULL, 103819),
(103820, '1.25.40.20-FF-000943', NULL, 'Os11g0199000 protein', 133, NULL, NULL, 103820),
(103821, '3.80.10.10-FF-003864', NULL, 'Uncharacterized protein', 172, NULL, NULL, 103821),
(103822, '1.10.510.10-FF-002141', NULL, 'Kinase, NEK', 207, NULL, NULL, 103822),
(103823, '2.40.30.10-FF-000385', NULL, 'Translation elongation factor G-related protein', 112, NULL, NULL, 103823),
(103824, '3.40.50.300-FF-002566', NULL, 'Translation factor GUF1 homolog, mitochondrial', 187, NULL, NULL, 103824),
(103825, '3.90.550.50-FF-000201', NULL, 'Uncharacterized protein', 182, NULL, NULL, 103825),
(103826, '2.40.30.10-FF-000328', NULL, 'Dihydroorotate dehydrogenase B (NAD(+)), electron transfer subunit', 105, NULL, NULL, 103826),
(103827, '1.10.150.20-FF-000070', NULL, 'DNA polymerase I, putative', 144, NULL, NULL, 103827),
(103828, '1.20.120.1750-FF-000135', NULL, 'RBR-type E3 ubiquitin transferase', 67, NULL, NULL, 103828),
(103829, '3.40.1810.10-FF-000029', NULL, 'MADS transcription factor', 97, NULL, NULL, 103829),
(103830, '1.20.1070.10-FF-000849', NULL, 'Si:dkey-94e7.1', 282, NULL, NULL, 103830),
(103831, '2.60.210.10-FF-000034', NULL, 'T23K8.6', 135, NULL, NULL, 103831),
(103832, '3.30.420.140-FF-000041', NULL, 'Uncharacterized protein', 151, NULL, NULL, 103832),
(103833, '1.10.287.110-FF-000296', NULL, 'Dnj-22', 97, NULL, NULL, 103833),
(103834, '1.10.1620.10-FF-000001', NULL, '60S ribosomal protein-like L39', 51, NULL, NULL, 103834),
(103835, '1.10.238.10-FF-000186', NULL, 'Secretagogin', 90, NULL, NULL, 103835),
(103836, '3.30.63.20-FF-000001', NULL, '40S ribosomal protein S25', 89, NULL, NULL, 103836),
(103837, '3.80.10.10-FF-001655', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 109, NULL, NULL, 103837),
(103838, '3.40.630.10-FF-000090', NULL, 'M18 aspartyl aminopeptidase', 351, NULL, NULL, 103838),
(103839, '2.40.160.10-FF-000017', NULL, 'Glucuronide uptake porin UidC', 396, NULL, NULL, 103839),
(103840, '2.40.110.10-FF-000014', NULL, 'Probable acyl-CoA dehydrogenase', 117, NULL, NULL, 103840),
(103841, '2.60.200.20-FF-000211', NULL, 'Kinesin-related protein 1', 116, NULL, NULL, 103841),
(103842, '3.80.10.10-FF-000430', NULL, 'Leucine-rich repeat receptor-like protein kinase PEPR1', 159, NULL, NULL, 103842);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(103843, '2.130.10.10-FF-000851', NULL, 'VPS8 subunit of CORVET complex', 183, NULL, NULL, 103843),
(103844, '3.40.50.720-FF-001910', NULL, 'Uncharacterized protein', 117, NULL, NULL, 103844),
(103845, '3.90.70.10-FF-000355', NULL, 'Ubiquitin carboxyl-terminal hydrolase, putative', 370, NULL, NULL, 103845),
(103846, '3.90.550.10-FF-000684', NULL, 'Uncharacterized protein', 80, NULL, NULL, 103846),
(103847, '3.30.200.20-FF-000152', NULL, 'Mitogen-activated protein kinase kinase kinase 7', 82, NULL, NULL, 103847),
(103848, '2.40.30.180-FF-000006', NULL, 'Ubiquitin-activating enzyme E1, putative', 86, NULL, NULL, 103848),
(103849, '1.25.40.10-FF-000406', NULL, 'Sel1 repeat family protein', 181, NULL, NULL, 103849),
(103850, '4.10.860.120-FF-000019', NULL, 'DNA-directed RNA polymerase I largest subunit', 136, NULL, NULL, 103850),
(103851, '2.30.30.40-FF-000192', NULL, 'Uncharacterized protein, isoform C', 81, NULL, NULL, 103851),
(103852, '1.10.510.10-FF-000016', NULL, 'Somatic embryogenesis receptor-like kinase 1', 218, NULL, NULL, 103852),
(103853, '2.130.10.10-FF-001599', NULL, 'Uncharacterized protein', 221, NULL, NULL, 103853),
(103854, '1.20.140.150-FF-000130', NULL, 'Uncharacterized protein', 120, NULL, NULL, 103854),
(103855, '3.90.550.10-FF-000212', NULL, 'Mannosyltransferase complex component', 140, NULL, NULL, 103855),
(103856, '1.25.40.20-FF-000409', NULL, 'TRP (Transient receptor potential) channel family', 200, NULL, NULL, 103856),
(103857, '3.30.565.10-FF-000512', NULL, 'Phosphate regulon sensor protein PhoR', 154, NULL, NULL, 103857),
(103858, '3.30.70.330-FF-001974', NULL, NULL, 101, NULL, NULL, 103858),
(103859, '3.10.110.10-FF-000214', NULL, 'Uncharacterized protein', 269, NULL, NULL, 103859),
(103860, '1.20.120.350-FF-000181', NULL, NULL, 111, NULL, NULL, 103860),
(103861, '3.30.40.10-FF-001890', NULL, 'Uncharacterized protein', 74, NULL, NULL, 103861),
(103862, '2.70.130.10-FF-000037', NULL, 'Lysosomal enzyme receptor protein', 147, NULL, NULL, 103862),
(103863, '3.20.20.10-FF-000068', NULL, 'Serine racemase', 222, NULL, NULL, 103863),
(103864, '1.10.510.10-FF-000488', NULL, 'T3SS secreted effector NleH', 90, NULL, NULL, 103864),
(103865, '3.40.50.300-FF-006837', NULL, 'GPN-loop GTPase 3', 264, NULL, NULL, 103865),
(103866, '1.25.10.10-FF-000904', NULL, 'MOT1p protein', 216, NULL, NULL, 103866),
(103867, '1.20.140.150-FF-000074', NULL, 'Outer dense fiber of sperm tails 4', 191, NULL, NULL, 103867),
(103868, '3.30.160.60-FF-004774', NULL, NULL, 18, NULL, NULL, 103868),
(103869, '3.40.1000.10-FF-000018', NULL, 'Ran-binding protein, putative', 203, NULL, NULL, 103869),
(103870, '3.30.565.10-FF-000456', NULL, 'DNA mismatch repair protein domain', 164, NULL, NULL, 103870),
(103871, '1.20.1310.10-FF-000149', NULL, NULL, 211, NULL, NULL, 103871),
(103872, '3.90.226.10-FF-000088', NULL, 'S41 family peptidase', 168, NULL, NULL, 103872),
(103873, '3.30.1520.10-FF-000026', NULL, 'Phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit gamma', 104, NULL, NULL, 103873),
(103874, '2.130.10.10-FF-000615', NULL, 'Receptor for activated C kinase 1', 310, NULL, NULL, 103874),
(103875, '2.60.120.1000-FF-000017', NULL, 'Si:dkey-21p1.3', 225, NULL, NULL, 103875),
(103876, '1.20.5.110-FF-000284', NULL, 't-SNARE domain-containing 1', 52, NULL, NULL, 103876),
(103877, '3.30.200.20-FF-000096', NULL, 'Non-specific serine/threonine protein kinase', 89, NULL, NULL, 103877),
(103878, '3.30.70.330-FF-001479', NULL, 'Os02g0602600 protein', 152, NULL, NULL, 103878),
(103879, '3.30.160.60-FF-000609', NULL, 'zinc finger protein 621', 28, NULL, NULL, 103879),
(103880, '3.90.1100.10-FF-000026', NULL, 'DNA-directed RNA polymerase subunit beta', 156, NULL, NULL, 103880),
(103881, '3.60.20.40-FF-000047', NULL, 'Gamma-glutamyltransferase 7-like Protein', 163, NULL, NULL, 103881),
(103882, '2.170.270.10-FF-000186', NULL, 'Histone-lysine N-methyltransferase', 246, NULL, NULL, 103882),
(103883, '3.30.160.60-FF-004830', NULL, NULL, 72, NULL, NULL, 103883),
(103884, '1.10.132.60-FF-000040', NULL, 'DNA polymerase', 133, NULL, NULL, 103884);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(103885, '2.30.180.10-FF-000190', NULL, NULL, 107, NULL, NULL, 103885),
(103886, '2.10.25.10-FF-000211', NULL, 'Protein kinase C-binding protein NELL1', 38, NULL, NULL, 103886),
(103887, '1.10.950.10-FF-000015', NULL, 'Erythrocyte membrane protein band 4.9, putative', 37, NULL, NULL, 103887),
(103888, '1.10.600.10-FF-000141', NULL, 'Terpene cyclase, putative', 297, NULL, NULL, 103888),
(103889, '4.10.400.10-FF-000367', NULL, 'Uncharacterized protein', 41, NULL, NULL, 103889),
(103890, '1.10.418.10-FF-000251', NULL, 'Uncharacterized protein', 97, NULL, NULL, 103890),
(103891, '3.90.1750.10-FF-000097', NULL, 'E3 ubiquitin-protein ligase UPL5', 122, NULL, NULL, 103891),
(103892, '3.40.50.300-FF-007939', NULL, 'RuvB-like helicase', 172, NULL, NULL, 103892),
(103893, '3.30.1370.10-FF-000233', NULL, 'U1 snRNP-associated protein usp108', 74, NULL, NULL, 103893),
(103894, '3.90.550.10-FF-000740', NULL, 'Uncharacterized protein', 245, NULL, NULL, 103894),
(103895, '2.40.20.10-FF-000064', NULL, 'Plasminogen activator, urokinase b', 87, NULL, NULL, 103895),
(103896, '2.40.30.170-FF-000003', NULL, 'Multidrug resistance protein A', 123, NULL, NULL, 103896),
(103897, '3.40.50.1000-FF-000178', NULL, 'Predicted phosphatase', 163, NULL, NULL, 103897),
(103898, '3.20.20.220-FF-000039', NULL, 'Proline dehydrogenase 1, mitochondrial', 349, NULL, NULL, 103898),
(103899, '2.60.40.10-FF-000963', NULL, 'Obscurin like 1', 81, NULL, NULL, 103899),
(103900, '3.40.50.40-FF-000005', NULL, 'Glutaminase-asparaginase', 114, NULL, NULL, 103900),
(103901, '3.40.50.880-FF-000008', NULL, 'Phosphoribosylformylglycinamidine synthase', 319, NULL, NULL, 103901),
(103902, '1.10.10.60-FF-000604', NULL, 'CRE-ZAG-1 protein', 65, NULL, NULL, 103902),
(103903, '3.40.1080.10-FF-000001', NULL, 'Succinyl-coa:3-ketoacid-coenzyme a transferase subunit b', 213, NULL, NULL, 103903),
(103904, '1.10.287.1490-FF-000137', NULL, 'Uncharacterized protein', 192, NULL, NULL, 103904),
(103905, '3.40.50.150-FF-000464', NULL, 'DNA (Cytosine-5)-methyltransferase CMT2', 272, NULL, NULL, 103905),
(103906, '1.10.10.10-FF-000578', NULL, 'HTH-type transcriptional regulator SarR', 84, NULL, NULL, 103906),
(103907, '3.90.226.10-FF-000206', NULL, 'Benzoyl-CoA-dihydrodiol lyase', 232, NULL, NULL, 103907),
(103908, '3.40.50.1820-FF-001407', NULL, 'Protein CBG05817', 208, NULL, NULL, 103908),
(103909, '3.40.50.1820-FF-001470', NULL, 'Uncharacterized protein', 176, NULL, NULL, 103909),
(103910, '3.30.420.110-FF-000049', NULL, 'MutS protein homolog 4', 164, NULL, NULL, 103910),
(103911, '1.10.10.10-FF-000106', NULL, 'Methionine aminopeptidase 2', 78, NULL, NULL, 103911),
(103912, '3.40.50.300-FF-005848', NULL, 'Uncharacterized protein', 207, NULL, NULL, 103912),
(103913, '2.40.10.10-FF-000092', NULL, 'Transmembrane protease serine 5', 243, NULL, NULL, 103913),
(103914, '3.40.50.10810-FF-000220', NULL, 'AEL297Wp', 72, NULL, NULL, 103914),
(103915, '2.10.50.10-FF-000163', NULL, 'Uncharacterized protein', 53, NULL, NULL, 103915),
(103916, '1.20.1070.10-FF-000759', NULL, 'Predicted protein', 146, NULL, NULL, 103916),
(103917, '3.20.20.60-FF-000089', NULL, 'Putative citrate/ citryl-CoA lyase', 284, NULL, NULL, 103917),
(103918, '3.40.190.10-FF-000190', NULL, 'Glutamate receptor, ionotropic, delta 1b', 63, NULL, NULL, 103918),
(103919, '3.20.20.60-FF-000145', NULL, 'Pyruvate kinase', 130, NULL, NULL, 103919),
(103920, '3.30.1600.10-FF-000027', NULL, 'NAD-dependent protein deacylase SIR2rp2', 129, NULL, NULL, 103920),
(103921, '3.50.50.60-FF-001483', NULL, 'Uncharacterized protein', 55, NULL, NULL, 103921),
(103922, '1.25.10.10-FF-001040', NULL, 'Uncharacterized protein', 645, NULL, NULL, 103922),
(103923, '2.10.25.10-FF-001195', NULL, 'Fibulin-1', 61, NULL, NULL, 103923),
(103924, '2.30.29.30-FF-001276', NULL, 'Predicted protein', 98, NULL, NULL, 103924),
(103925, '3.80.10.10-FF-003656', NULL, 'F-box/LRR-repeat protein 6', 111, NULL, NULL, 103925),
(103926, '2.40.30.330-FF-000017', NULL, 'Uncharacterized protein', 92, NULL, NULL, 103926),
(103927, '3.40.30.10-FF-000669', NULL, 'Sulfhydryl oxidase', 149, NULL, NULL, 103927);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(103928, '1.25.40.20-FF-000735', NULL, 'Ankyrin repeat protein', 87, NULL, NULL, 103928),
(103929, '3.40.50.300-FF-004218', NULL, 'DNA helicase related protein', 201, NULL, NULL, 103929),
(103930, '3.40.30.10-FF-000523', NULL, 'Protein disulfide isomerase PDI3', 105, NULL, NULL, 103930),
(103931, '3.40.190.290-FF-000024', NULL, 'LysR family transcriptional regulator', 201, NULL, NULL, 103931),
(103932, '1.20.58.70-FF-000121', NULL, 'Predicted protein', 107, NULL, NULL, 103932),
(103933, '3.90.700.10-FF-000005', NULL, 'Succinate dehydrogenase flavoprotein subunit', 120, NULL, NULL, 103933),
(103934, '4.10.60.10-FF-000052', NULL, 'Putative universal minicircle sequence binding protein', 28, NULL, NULL, 103934),
(103935, '1.10.20.10-FF-000141', NULL, 'Inner kinetochore subunit MHF2', 80, NULL, NULL, 103935),
(103936, '3.90.1290.10-FF-000073', NULL, 'Uncharacterized protein', 140, NULL, NULL, 103936),
(103937, '4.10.400.10-FF-000165', NULL, 'low-density lipoprotein receptor-related protein 8 isoform X1', 38, NULL, NULL, 103937),
(103938, '1.25.40.10-FF-000732', NULL, 'Small Glutamine-rich Tetratrico repeat protein', 149, NULL, NULL, 103938),
(103939, '3.30.160.60-FF-004448', NULL, NULL, 65, NULL, NULL, 103939),
(103940, '2.60.40.60-FF-000394', NULL, 'Cadherin 23', 110, NULL, NULL, 103940),
(103941, '1.10.10.60-FF-000806', NULL, NULL, 55, NULL, NULL, 103941),
(103942, '1.25.40.10-FF-001188', NULL, 'Superkiller protein 3', 148, NULL, NULL, 103942),
(103943, '2.10.50.30-FF-000056', NULL, 'Uncharacterized protein', 61, NULL, NULL, 103943),
(103944, '3.90.79.10-FF-000262', NULL, 'Uncharacterized protein', 225, NULL, NULL, 103944),
(103945, '2.60.40.2430-FF-000002', NULL, 'Sag1p', 139, NULL, NULL, 103945),
(103946, '1.20.1310.10-FF-000003', NULL, 'Cullin 4A', 114, NULL, NULL, 103946),
(103947, '3.90.1150.10-FF-000214', NULL, 'Uncharacterized protein', 140, NULL, NULL, 103947),
(103948, '1.25.40.20-FF-000089', NULL, 'serine/threonine-protein kinase TNNI3K', 117, NULL, NULL, 103948),
(103949, '1.10.510.10-FF-000342', NULL, 'L-type lectin-domain containing receptor kinase VIII.1', 213, NULL, NULL, 103949),
(103950, '3.50.50.60-FF-000022', NULL, 'Glutamate synthase [NADH], amyloplastic', 162, NULL, NULL, 103950),
(103951, '2.60.40.10-FF-003566', NULL, NULL, 117, NULL, NULL, 103951),
(103952, '3.40.50.620-FF-000161', NULL, 'Electron transfer flavoprotein subunit alpha', 197, NULL, NULL, 103952),
(103953, '1.25.40.10-FF-005347', NULL, 'Uncharacterized protein', 149, NULL, NULL, 103953),
(103954, '1.10.420.10-FF-000043', NULL, 'Uncharacterized protein', 111, NULL, NULL, 103954),
(103955, '2.60.200.20-FF-000183', NULL, 'Forkhead-associated protein', 127, NULL, NULL, 103955),
(103956, '1.25.40.10-FF-000086', NULL, 'HTH-type transcriptional regulator MalT', 373, NULL, NULL, 103956),
(103957, '2.60.40.10-FF-004706', NULL, NULL, 98, NULL, NULL, 103957),
(103958, '3.90.550.10-FF-000414', NULL, 'Cytidine monophosphate N-acetylneuraminic acid synthetase', 135, NULL, NULL, 103958),
(103959, '3.30.70.1050-FF-000010', NULL, 'Trigger factor', 117, NULL, NULL, 103959),
(103960, '2.40.460.10-FF-000001', NULL, 'Acetyl-CoA carboxylase 1', 68, NULL, NULL, 103960),
(103961, '1.20.1310.20-FF-000006', NULL, 'Erythrocyte binding antigen-140', 175, NULL, NULL, 103961),
(103962, '3.40.50.300-FF-006635', NULL, 'Uncharacterized protein (Fragment)', 91, NULL, NULL, 103962),
(103963, '3.30.10.20-FF-000014', NULL, 'Serine/threonine-protein kinase StkP', 69, NULL, NULL, 103963),
(103964, '1.25.40.20-FF-000561', NULL, 'Benign gonial cell neoplasm', 119, NULL, NULL, 103964),
(103965, '3.40.190.10-FF-000510', NULL, 'Oligopeptide ABC transporter, oligopeptide-binding protein', 116, NULL, NULL, 103965),
(103966, '3.30.40.10-FF-001564', NULL, 'Protein CBG00592', 98, NULL, NULL, 103966),
(103967, '3.30.50.10-FF-000081', NULL, 'Steroid hormone receptor family member cnr14', 97, NULL, NULL, 103967),
(103968, '3.40.50.300-FF-004544', NULL, 'Uncharacterized protein', 161, NULL, NULL, 103968),
(103969, '3.40.50.720-FF-000191', NULL, 'Methylglyoxal reductase (NADPH-dependent)', 339, NULL, NULL, 103969);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(103970, '3.90.190.10-FF-000549', NULL, 'AGAP000492-PA', 125, NULL, NULL, 103970),
(103971, '2.130.10.10-FF-004033', NULL, 'Predicted protein', 220, NULL, NULL, 103971),
(103972, '3.40.50.300-FF-002892', NULL, 'GTP-binding protein SAR1b', 152, NULL, NULL, 103972),
(103973, '1.10.510.10-FF-004029', NULL, NULL, 196, NULL, NULL, 103973),
(103974, '1.10.8.270-FF-000103', NULL, 'RabGAP', 96, NULL, NULL, 103974),
(103975, '2.20.25.220-FF-000001', NULL, 'Genome polyprotein', 86, NULL, NULL, 103975),
(103976, '1.25.40.10-FF-004419', NULL, 'Uncharacterized protein', 129, NULL, NULL, 103976),
(103977, '1.10.510.10-FF-001331', NULL, 'VRK serine/threonine kinase 3', 337, NULL, NULL, 103977),
(103978, '2.20.25.240-FF-000007', NULL, 'Uncharacterized protein, isoform A', 92, NULL, NULL, 103978),
(103979, '2.20.28.40-FF-000001', NULL, 'H/ACA ribonucleoprotein complex subunit 3', 45, NULL, NULL, 103979),
(103980, '3.10.100.10-FF-000275', NULL, NULL, 87, NULL, NULL, 103980),
(103981, '2.40.70.10-FF-000270', NULL, 'Uncharacterized protein', 157, NULL, NULL, 103981),
(103982, '3.30.470.30-FF-000028', NULL, 'mRNA capping enzyme, beta chain, putative', 221, NULL, NULL, 103982),
(103983, '2.60.120.200-FF-000210', NULL, 'Protein eyes shut homolog', 177, NULL, NULL, 103983),
(103984, '1.20.144.10-FF-000067', NULL, 'PA-phosphatase related-family protein DDB_G0275547', 249, NULL, NULL, 103984),
(103985, '3.40.50.1240-FF-000082', NULL, 'Phosphohistidine phosphatase SixA', 153, NULL, NULL, 103985),
(103986, '1.20.5.1160-FF-000012', NULL, 'Myosin heavy chain 6', 91, NULL, NULL, 103986),
(103987, '2.130.10.10-FF-003105', NULL, 'Transducin/WD40 repeat-like superfamily protein', 427, NULL, NULL, 103987),
(103988, '3.30.470.20-FF-000025', NULL, 'Propionyl-CoA carboxylase alpha chain, mitochondrial', 246, NULL, NULL, 103988),
(103989, '2.40.170.20-FF-000083', NULL, 'TonB-dependent receptor', 641, NULL, NULL, 103989),
(103990, '3.30.160.60-FF-000935', NULL, 'PLAG1 like zinc finger 1', 27, NULL, NULL, 103990),
(103991, '2.60.40.2130-FF-000007', NULL, 'Spondin-2', 35, NULL, NULL, 103991),
(103992, '1.10.10.60-FF-000430', NULL, 'Chromatin remodeling protein', 58, NULL, NULL, 103992),
(103993, '3.40.50.740-FF-000051', NULL, 'Extracellular dimethyl sulfoxide/manganese oxide reductase molybdopterin-binding subunit DmsA', 236, NULL, NULL, 103993),
(103994, '1.20.1070.10-FF-001541', NULL, 'Neuropeptides B/W receptor type 2', 178, NULL, NULL, 103994),
(103995, '1.20.1230.10-FF-000002', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 262, NULL, NULL, 103995),
(103996, '3.90.70.10-FF-000708', NULL, 'Uncharacterized protein', 207, NULL, NULL, 103996),
(103997, '3.40.50.880-FF-000160', NULL, 'Protein G75B', 302, NULL, NULL, 103997),
(103998, '3.40.50.300-FF-000649', NULL, 'Origin recognition complex subunit 4', 182, NULL, NULL, 103998),
(103999, '2.60.40.10-FF-004055', NULL, NULL, 96, NULL, NULL, 103999),
(104000, '3.10.50.40-FF-000079', NULL, 'Peptidylprolyl isomerase', 134, NULL, NULL, 104000),
(104001, '3.40.50.1820-FF-001177', NULL, 'Uncharacterized protein', 230, NULL, NULL, 104001),
(104002, '2.60.120.40-FF-000042', NULL, 'Tumor necrosis factor ligand superfamily member 9', 171, NULL, NULL, 104002),
(104003, '3.40.50.720-FF-000421', NULL, 'Probable NADP-dependent mannitol dehydrogenase', 275, NULL, NULL, 104003),
(104004, '3.30.559.70-FF-000010', NULL, 'Carnitine O-Acetyl-Transferase, isoform B', 312, NULL, NULL, 104004),
(104005, '3.40.50.1580-FF-000037', NULL, 'Uncharacterized protein', 127, NULL, NULL, 104005),
(104006, '1.10.472.10-FF-000123', NULL, 'Cyclin-Y-like protein 2', 178, NULL, NULL, 104006),
(104007, '3.30.70.60-FF-000046', NULL, 'Uncharacterized protein', 46, NULL, NULL, 104007),
(104008, '3.40.50.1820-FF-001672', NULL, 'Uncharacterized protein', 254, NULL, NULL, 104008),
(104009, '3.40.50.1240-FF-000143', NULL, NULL, 164, NULL, NULL, 104009),
(104010, '1.10.390.40-FF-000003', NULL, NULL, 70, NULL, NULL, 104010),
(104011, '3.75.10.10-FF-000010', NULL, 'Mitochondrial RNA binding protein', 292, NULL, NULL, 104011);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(104012, '4.10.800.20-FF-000007', NULL, 'AMP deaminase, putative', 82, NULL, NULL, 104012),
(104013, '1.20.58.390-FF-000086', NULL, 'Acetylcholine receptor subunit beta-type acr-2', 118, NULL, NULL, 104013),
(104014, '2.60.120.10-FF-000645', NULL, 'Uncharacterized protein', 157, NULL, NULL, 104014),
(104015, '3.40.47.10-FF-000033', NULL, 'Fatty acid synthase', 406, NULL, NULL, 104015),
(104016, '3.30.420.40-FF-000646', NULL, 'Actin-related protein 5', 68, NULL, NULL, 104016),
(104017, '4.10.800.10-FF-000004', NULL, 'SPARC-related modular calcium-binding protein 1', 74, NULL, NULL, 104017),
(104018, '1.10.3720.10-FF-000003', NULL, 'Aliphatic sulfonate ABC transporter permease', 195, NULL, NULL, 104018),
(104019, '3.90.780.10-FF-000021', NULL, 'Phosphoesterase', 184, NULL, NULL, 104019),
(104020, '3.30.780.10-FF-000006', NULL, 'Protein translation factor SUI1 homolog', 82, NULL, NULL, 104020),
(104021, '1.10.3210.10-FF-000009', NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase', 153, NULL, NULL, 104021),
(104022, '3.60.21.10-FF-000349', NULL, 'Uncharacterized protein C30A5.4', 184, NULL, NULL, 104022),
(104023, '3.40.50.150-FF-000790', NULL, 'Salicylate/benzoate carboxyl methyltransferase', 66, NULL, NULL, 104023),
(104024, '3.40.50.11660-FF-000031', NULL, NULL, 208, NULL, NULL, 104024),
(104025, '3.40.50.2020-FF-000153', NULL, 'Uncharacterized protein', 134, NULL, NULL, 104025),
(104026, '1.10.510.10-FF-002433', NULL, 'Os04g0134400 protein', 265, NULL, NULL, 104026),
(104027, '1.10.3720.10-FF-000149', NULL, 'ABC transporter permease protein', 251, NULL, NULL, 104027),
(104028, '3.30.160.60-FF-002650', NULL, 'Zinc finger protein 236 variant', 27, NULL, NULL, 104028),
(104029, '3.50.50.60-FF-000701', NULL, 'Probable flavin-containing monoamine oxidase B', 465, NULL, NULL, 104029),
(104030, '3.80.10.10-FF-001239', NULL, 'Leucine rich repeat protein', 157, NULL, NULL, 104030),
(104031, '3.40.50.1980-FF-000067', NULL, 'Hemin ABC transporter, periplasmic hemin-binding protein HutB', 123, NULL, NULL, 104031),
(104032, '3.30.1380.20-FF-000057', NULL, 'Predicted protein', 93, NULL, NULL, 104032),
(104033, '3.30.1680.10-FF-000043', NULL, 'Integrin beta', 55, NULL, NULL, 104033),
(104034, '1.25.40.10-FF-002121', NULL, 'Pentatricopeptide repeat-containing protein At1g59720, chloroplastic/mitochondrial', 121, NULL, NULL, 104034),
(104035, '3.30.160.100-FF-000008', NULL, 'Ribosomal subunit interface protein', 95, NULL, NULL, 104035),
(104036, '3.40.50.2300-FF-000641', NULL, 'Low molecular weight phosphotyrosine protein phosphatase', 153, NULL, NULL, 104036),
(104037, '1.20.1250.20-FF-001642', NULL, 'Transporter, MFS family protein', 491, NULL, NULL, 104037),
(104038, '2.40.50.90-FF-000016', NULL, 'Tudor domain containing 9', 113, NULL, NULL, 104038),
(104039, '3.30.70.1070-FF-000016', NULL, 'Endolytic peptidoglycan transglycosylase RlpA', 72, NULL, NULL, 104039),
(104040, '3.40.50.1820-FF-000688', NULL, 'Esterase/lipase/thioesterase family protein', 241, NULL, NULL, 104040),
(104041, '1.10.630.10-FF-000289', NULL, 'Cytochrome P450, family 2, subfamily j, polypeptide 13', 209, NULL, NULL, 104041),
(104042, '3.40.50.300-FF-008075', NULL, 'Atlastin GTPase 1', 118, NULL, NULL, 104042),
(104043, '1.10.472.10-FF-000269', NULL, 'Uncharacterized protein', 104, NULL, NULL, 104043),
(104044, '1.10.3130.10-FF-000008', NULL, 'Probable serine acetyltransferase 4', 147, NULL, NULL, 104044),
(104045, '2.60.120.650-FF-000120', NULL, 'Uncharacterized protein', 323, NULL, NULL, 104045),
(104046, '2.60.40.10-FF-005983', NULL, NULL, 95, NULL, NULL, 104046),
(104047, '2.130.10.10-FF-000441', NULL, 'U3 small nucleolar RNA-associated protein 4 homolog', 184, NULL, NULL, 104047),
(104048, '1.20.5.190-FF-000083', NULL, 'Myosin 10A, isoform C', 56, NULL, NULL, 104048),
(104049, '2.130.10.10-FF-003870', NULL, 'Uncharacterized protein C1F3.03', 281, NULL, NULL, 104049),
(104050, '3.30.70.590-FF-000017', NULL, 'Poly polymerase central domain containing protein', 130, NULL, NULL, 104050),
(104051, '2.70.170.10-FF-000163', NULL, 'Uncharacterized protein', 97, NULL, NULL, 104051);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(104052, '3.30.40.10-FF-000013', NULL, 'E3 ubiquitin-protein ligase MGRN1 isoform 1', 74, NULL, NULL, 104052),
(104053, '3.30.160.60-FF-000379', NULL, 'Zinc finger and BTB domain-containing protein 46', 28, NULL, NULL, 104053),
(104054, '1.25.40.720-FF-000013', NULL, 'Uncharacterized protein', 92, NULL, NULL, 104054),
(104055, '3.40.50.720-FF-001680', NULL, 'Phosphoglycerate dehydrogenase SerA2-putative NAD-dependent 2-hydroxyacid dehydrogenase', 96, NULL, NULL, 104055),
(104056, '1.20.58.60-FF-000579', NULL, 'SEC14 domain and spectrin repeat-containing protein 1-like Protein', 234, NULL, NULL, 104056),
(104057, '3.30.70.1230-FF-000233', NULL, 'Uncharacterized protein', 196, NULL, NULL, 104057),
(104058, '2.30.30.40-FF-000422', NULL, 'voltage-dependent L-type calcium channel subunit beta-1 isoform X2', 128, NULL, NULL, 104058),
(104059, '3.40.50.720-FF-001972', NULL, 'Blr5975 protein', 252, NULL, NULL, 104059),
(104060, '3.30.230.70-FF-000028', NULL, 'exosome complex component RRP41', 239, NULL, NULL, 104060),
(104061, '3.90.1150.10-FF-000416', NULL, 'Aspartate aminotransferase', 109, NULL, NULL, 104061),
(104062, '3.30.2350.20-FF-000022', NULL, 'GM25058', 230, NULL, NULL, 104062),
(104063, '1.10.1450.10-FF-000055', NULL, 'Tetraspanin', 89, NULL, NULL, 104063),
(104064, '2.60.200.20-FF-000273', NULL, 'Uncharacterized protein', 142, NULL, NULL, 104064),
(104065, '2.40.33.10-FF-000043', NULL, 'Pyruvate kinase', 39, NULL, NULL, 104065),
(104066, '1.20.120.140-FF-000027', NULL, 'Signal recognition particle receptor subunit alpha', 125, NULL, NULL, 104066),
(104067, '2.40.128.150-FF-000002', NULL, 'Arylamine N-acetyltransferase', 100, NULL, NULL, 104067),
(104068, '3.90.290.10-FF-000023', NULL, 'Latent transforming growth factor beta binding protein 3', 71, NULL, NULL, 104068),
(104069, '2.10.220.10-FF-000147', NULL, 'Putative furin-like protease 2', 44, NULL, NULL, 104069),
(104070, '2.120.10.30-FF-000352', NULL, 'Uncharacterized protein', 192, NULL, NULL, 104070),
(104071, '1.25.10.10-FF-002147', NULL, 'Uncharacterized protein', 536, NULL, NULL, 104071),
(104072, '1.10.10.60-FF-000284', NULL, 'Two-component system sensor histidine kinase/response regulator', 110, NULL, NULL, 104072),
(104073, '3.30.60.30-FF-000205', NULL, 'Uncharacterized protein', 67, NULL, NULL, 104073),
(104074, '3.90.1150.10-FF-000068', NULL, 'LPS biosynthesis protein', 132, NULL, NULL, 104074),
(104075, '3.40.50.300-FF-002919', NULL, 'Mg-protoporphyrin IX chelatase', 207, NULL, NULL, 104075),
(104076, '3.40.50.300-FF-005202', NULL, 'Ras-related protein Rab-13', 211, NULL, NULL, 104076),
(104077, '1.20.1090.10-FF-000030', NULL, '3-dehydroquinate synthase', 195, NULL, NULL, 104077),
(104078, '3.40.50.2300-FF-001597', NULL, NULL, 101, NULL, NULL, 104078),
(104079, '3.30.420.40-FF-000972', NULL, 'Uncharacterized protein', 14, NULL, NULL, 104079),
(104080, '1.20.5.4130-FF-000004', NULL, 'Disease resistance protein Pikm2-TS', 113, NULL, NULL, 104080),
(104081, '1.25.40.10-FF-000822', NULL, 'ER membrane protein complex subunit 2', 202, NULL, NULL, 104081),
(104082, '2.60.40.2030-FF-000005', NULL, 'Extracellular matrix protein FRAS1 isoform 1', 117, NULL, NULL, 104082),
(104083, '2.130.10.10-FF-004179', NULL, 'Uncharacterized protein', 164, NULL, NULL, 104083),
(104084, '2.30.29.30-FF-001366', NULL, 'Uncharacterized protein', 128, NULL, NULL, 104084),
(104085, '3.40.50.300-FF-001779', NULL, 'Nickel ABC transporter, ATP-binding protein', 267, NULL, NULL, 104085),
(104086, '3.90.980.20-FF-000005', NULL, 'Set1/Ash2 histone methyltransferase complex subunit ASH2', 168, NULL, NULL, 104086),
(104087, '2.130.10.10-FF-005758', NULL, 'Uncharacterized protein', 116, NULL, NULL, 104087),
(104088, '3.40.50.300-FF-006961', NULL, 'Uncharacterized protein', 221, NULL, NULL, 104088),
(104089, '3.30.160.60-FF-002178', NULL, 'Zinc finger protein 169', 38, NULL, NULL, 104089),
(104090, '1.25.40.10-FF-002031', NULL, 'Os03g0314400 protein', 124, NULL, NULL, 104090),
(104091, '3.90.230.10-FF-000047', NULL, NULL, 246, NULL, NULL, 104091),
(104092, '1.25.70.10-FF-000032', NULL, 'PAS domain containing serine/threonine kinase', 241, NULL, NULL, 104092);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(104093, '1.20.5.4770-FF-000016', NULL, 'Uncharacterized protein', 68, NULL, NULL, 104093),
(104094, '2.60.40.1220-FF-000010', NULL, 'Copper resistance protein CopC / Copper resistance protein CopD', 102, NULL, NULL, 104094),
(104095, '1.10.630.10-FF-000379', NULL, 'Cytochrome P450, family 4, subfamily f, polypeptide 13', 350, NULL, NULL, 104095),
(104096, '2.140.10.30-FF-000014', NULL, 'Ste13p', 498, NULL, NULL, 104096),
(104097, '1.25.40.90-FF-000008', NULL, 'VHS domain protein', 168, NULL, NULL, 104097),
(104098, '2.70.98.10-FF-000062', NULL, 'Alpha-1,2-mannosidase, putative', 331, NULL, NULL, 104098),
(104099, '1.10.10.10-FF-000724', NULL, 'Histone H1-like protein in spermatids 1', 74, NULL, NULL, 104099),
(104100, '3.30.310.50-FF-000023', NULL, 'Phosphoglucomutase', 101, NULL, NULL, 104100),
(104101, '3.60.15.10-FF-000060', NULL, 'N-acyl homoserine lactonase AiiA', 241, NULL, NULL, 104101),
(104102, '1.10.150.240-FF-000026', NULL, '2-deoxyglucose-6-phosphate phosphatase', 63, NULL, NULL, 104102),
(104103, '3.90.1750.10-FF-000092', NULL, 'Uncharacterized protein', 162, NULL, NULL, 104103),
(104104, '3.40.190.10-FF-000841', NULL, 'Uncharacterized protein', 98, NULL, NULL, 104104),
(104105, '3.50.50.60-FF-000027', NULL, 'Lysine-specific histone demethylase', 60, NULL, NULL, 104105),
(104106, '3.40.50.720-FF-001495', NULL, 'SUMO-activating enzyme subunit 1', 321, NULL, NULL, 104106),
(104107, '3.30.310.40-FF-000020', NULL, 'Uncharacterized protein', 91, NULL, NULL, 104107),
(104108, '2.10.70.10-FF-000248', NULL, 'Selectin P', 55, NULL, NULL, 104108),
(104109, '3.80.10.10-FF-003802', NULL, 'Uncharacterized protein', 89, NULL, NULL, 104109),
(104110, '1.10.510.10-FF-004057', NULL, NULL, 22, NULL, NULL, 104110),
(104111, '3.30.160.60-FF-006073', NULL, NULL, 139, NULL, NULL, 104111),
(104112, '1.10.10.2210-FF-000009', NULL, NULL, 37, NULL, NULL, 104112),
(104113, '3.30.710.10-FF-000204', NULL, 'BTB/POZ and TAZ domain-containing protein 3', 121, NULL, NULL, 104113),
(104114, '3.40.50.920-FF-000037', NULL, 'Sulfite reductase [NADPH] flavoprotein component, putative', 80, NULL, NULL, 104114),
(104115, '3.40.30.10-FF-001012', NULL, 'Uncharacterized protein', 59, NULL, NULL, 104115),
(104116, '2.40.160.110-FF-000049', NULL, 'uncharacterized protein LOC100185667', 119, NULL, NULL, 104116),
(104117, '2.80.10.50-FF-000225', NULL, 'Uncharacterized protein', 183, NULL, NULL, 104117),
(104118, '3.50.30.30-FF-000068', NULL, 'Carboxypeptidase Q', 13, NULL, NULL, 104118),
(104119, '3.10.129.10-FF-000032', NULL, 'Acyl-CoA thioester hydrolase', 159, NULL, NULL, 104119),
(104120, '3.40.640.10-FF-000472', NULL, 'Uncharacterized protein', 110, NULL, NULL, 104120),
(104121, '3.40.1110.10-FF-000465', NULL, NULL, 146, NULL, NULL, 104121),
(104122, '3.30.200.20-FF-002041', NULL, 'Uncharacterized protein', 90, NULL, NULL, 104122),
(104123, '3.30.160.60-FF-004274', NULL, NULL, 29, NULL, NULL, 104123),
(104124, '1.10.510.10-FF-000432', NULL, 'mitogen-activated protein kinase kinase 3', 197, NULL, NULL, 104124),
(104125, '3.30.160.60-FF-001868', NULL, 'Zinc finger protein 264', 30, NULL, NULL, 104125),
(104126, '1.20.120.530-FF-000021', NULL, 'Gluconate operon transcriptional repressor', 145, NULL, NULL, 104126),
(104127, '2.40.10.10-FF-000294', NULL, 'Modular serine protease', 258, NULL, NULL, 104127),
(104128, '1.10.287.2620-FF-000010', NULL, 'Dynein heavy chain', 65, NULL, NULL, 104128),
(104129, '3.90.1300.10-FF-000007', NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit A', 266, NULL, NULL, 104129),
(104130, '1.25.10.10-FF-000348', NULL, 'uncharacterized protein LOC106763108 isoform X2', 173, NULL, NULL, 104130),
(104131, '2.130.10.10-FF-002240', NULL, 'Uncharacterized protein', 344, NULL, NULL, 104131),
(104132, '2.60.120.10-FF-000792', NULL, 'Uncharacterized protein', 141, NULL, NULL, 104132),
(104133, '2.80.10.50-FF-000079', NULL, 'Ricin', 124, NULL, NULL, 104133),
(104134, '3.40.50.80-FF-000180', NULL, 'Uncharacterized protein', 221, NULL, NULL, 104134),
(104135, '2.130.10.10-FF-000817', NULL, 'WGS project CABT00000000 data, contig 2.15', 354, NULL, NULL, 104135);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(104136, '3.40.50.10810-FF-000192', NULL, 'Chromodomain helicase DNA-binding protein 3', 75, NULL, NULL, 104136),
(104137, '3.40.50.300-FF-007001', NULL, 'Os06g0503100 protein', 211, NULL, NULL, 104137),
(104138, '1.10.620.20-FF-000027', NULL, 'Ribonucleoside-diphosphate reductase small subunit', 270, NULL, NULL, 104138),
(104139, '3.10.129.110-FF-000002', NULL, 'Fatty acid synthase', 253, NULL, NULL, 104139),
(104140, '2.60.40.10-FF-000547', NULL, 'Titin a', 103, NULL, NULL, 104140),
(104141, '1.25.40.10-FF-000204', NULL, 'Purkinje cell protein 2 homolog', 72, NULL, NULL, 104141),
(104142, '3.30.70.330-FF-001772', NULL, NULL, 154, NULL, NULL, 104142),
(104143, '3.30.420.10-FF-000626', NULL, NULL, 168, NULL, NULL, 104143),
(104144, '1.25.10.10-FF-001978', NULL, 'Uncharacterized protein', 164, NULL, NULL, 104144),
(104145, '3.40.50.150-FF-000587', NULL, 'tRNA methyltransferase complex GCD14 subunit', 197, NULL, NULL, 104145),
(104146, '1.20.144.10-FF-000011', NULL, 'sphingosine-1-phosphate phosphatase 1', 105, NULL, NULL, 104146),
(104147, '2.130.10.10-FF-001397', NULL, 'AGAP002030-PA-like protein', 99, NULL, NULL, 104147),
(104148, '3.30.230.120-FF-000003', NULL, 'Probable glucuronokinase 2', 342, NULL, NULL, 104148),
(104149, '1.10.8.10-FF-000358', NULL, 'Ubiquitin-associated protein 2b', 35, NULL, NULL, 104149),
(104150, '2.170.270.10-FF-000040', NULL, 'Histone-lysine N-methyltransferase', 218, NULL, NULL, 104150),
(104151, '3.30.160.60-FF-002357', NULL, 'Zinc finger protein 782', 31, NULL, NULL, 104151),
(104152, '3.30.160.60-FF-000289', NULL, 'B-cell CLL/lymphoma 6, member B', 27, NULL, NULL, 104152),
(104153, '1.10.150.50-FF-000197', NULL, 'Receptor protein-tyrosine kinase', 75, NULL, NULL, 104153),
(104154, '1.20.140.40-FF-000056', NULL, NULL, 142, NULL, NULL, 104154),
(104155, '3.30.230.130-FF-000006', NULL, 'Cullin-4 like', 157, NULL, NULL, 104155),
(104156, '3.40.50.720-FF-001354', NULL, 'Grp1p', 336, NULL, NULL, 104156),
(104157, '2.130.10.10-FF-000295', NULL, 'Protein transport protein SEC31 homolog B', 337, NULL, NULL, 104157),
(104158, '3.90.550.10-FF-000358', NULL, 'Procollagen-lysine, 2-oxoglutarate 5-dioxygenase 3', 148, NULL, NULL, 104158),
(104159, '2.130.10.10-FF-005668', NULL, 'Uncharacterized protein', 163, NULL, NULL, 104159),
(104160, '3.40.50.10810-FF-000276', NULL, 'Uncharacterized protein', 42, NULL, NULL, 104160),
(104161, '3.30.70.330-FF-000670', NULL, 'Unplaced genomic scaffold supercont1.9, whole genome shotgun sequence', 99, NULL, NULL, 104161),
(104162, '3.80.10.10-FF-003128', NULL, 'LGI1B', 80, NULL, NULL, 104162),
(104163, '3.30.390.110-FF-000001', NULL, 'Protein MAK16 homolog', 130, NULL, NULL, 104163),
(104164, '3.90.1150.10-FF-000040', NULL, 'Tyrosine aminotransferase', 120, NULL, NULL, 104164),
(104165, '3.40.50.10900-FF-000005', NULL, 'Proteasome assembly chaperone 2', 93, NULL, NULL, 104165),
(104166, '2.130.10.10-FF-001745', NULL, '6-phosphogluconolactonase', 339, NULL, NULL, 104166),
(104167, '1.10.418.10-FF-000161', NULL, 'Fimbrin', 117, NULL, NULL, 104167),
(104168, '2.130.10.10-FF-002381', NULL, 'GM18507', 277, NULL, NULL, 104168),
(104169, '3.10.105.10-FF-000090', NULL, 'Glycine betaine/carnitine transport binding protein GbuC', 157, NULL, NULL, 104169),
(104170, '1.20.1420.30-FF-000017', NULL, 'Calcium permease family membrane transporter', 163, NULL, NULL, 104170),
(104171, '1.10.510.10-FF-001977', NULL, 'Uncharacterized protein', 182, NULL, NULL, 104171),
(104172, '3.30.160.60-FF-003341', NULL, 'Zinc finger protein 1152', 29, NULL, NULL, 104172),
(104173, '3.20.20.150-FF-000001', NULL, 'Probable endonuclease 4', 287, NULL, NULL, 104173),
(104174, '3.40.50.300-FF-004836', NULL, 'Mitochondrial Rho GTPase 3', 172, NULL, NULL, 104174),
(104175, '3.40.1050.10-FF-000027', NULL, 'Carbon disulfide hydrolase', 180, NULL, NULL, 104175),
(104176, '2.60.40.10-FF-001003', NULL, 'titin isoform X1', 100, NULL, NULL, 104176),
(104177, '3.30.160.60-FF-002852', NULL, 'Dorsal Intercalation and Elongation defect', 99, NULL, NULL, 104177),
(104178, '1.20.1270.220-FF-000002', NULL, 'Transcription factor GTE4', 82, NULL, NULL, 104178);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(104179, '1.10.760.10-FF-000006', NULL, 'Cytochrome C', 70, NULL, NULL, 104179),
(104180, '3.30.70.3290-FF-000013', NULL, '6-deoxyerythronolide-B synthase EryA2, modules 3 and 4', 125, NULL, NULL, 104180),
(104181, '3.40.350.10-FF-000045', NULL, 'Metallopeptidase, family M24', 147, NULL, NULL, 104181),
(104182, '3.40.640.10-FF-000146', NULL, 'Aspartate aminotransferase', 273, NULL, NULL, 104182),
(104183, '3.30.260.10-FF-000006', NULL, 'T-complex protein 1 subunit beta', 105, NULL, NULL, 104183),
(104184, '3.30.200.20-FF-001585', NULL, 'Protein kinase, putative', 126, NULL, NULL, 104184),
(104185, '2.60.40.150-FF-000629', NULL, 'Uncharacterized protein', 140, NULL, NULL, 104185),
(104186, '2.130.10.10-FF-005022', NULL, 'Uncharacterized protein', 309, NULL, NULL, 104186),
(104187, '2.60.40.10-FF-001649', NULL, 'T cell receptor gamma, variable 3', 106, NULL, NULL, 104187),
(104188, '1.20.5.340-FF-000061', NULL, 'Myosin-3', 88, NULL, NULL, 104188),
(104189, '2.170.270.10-FF-000181', NULL, 'Uncharacterized protein', 70, NULL, NULL, 104189),
(104190, '2.130.10.10-FF-004038', NULL, 'Uncharacterized protein', 219, NULL, NULL, 104190),
(104191, '3.40.50.1000-FF-000206', NULL, 'Probable sucrose-phosphatase 1', 177, NULL, NULL, 104191),
(104192, '3.30.70.330-FF-000046', NULL, 'RNA-binding protein 14 isoform X1', 72, NULL, NULL, 104192),
(104193, '2.60.120.10-FF-000819', NULL, 'ADR385Wp', 203, NULL, NULL, 104193),
(104194, '2.40.30.330-FF-000012', NULL, 'Protein CLP1 homolog', 111, NULL, NULL, 104194),
(104195, '1.10.510.10-FF-002910', NULL, NULL, 111, NULL, NULL, 104195),
(104196, '2.60.120.970-FF-000098', NULL, 'Maverick', 272, NULL, NULL, 104196),
(104197, '3.40.50.1010-FF-000209', NULL, NULL, 61, NULL, NULL, 104197),
(104198, '3.30.1020.10-FF-000005', NULL, 'Thiol-specific antioxidant protein', 69, NULL, NULL, 104198),
(104199, '3.30.740.10-FF-000032', NULL, NULL, 34, NULL, NULL, 104199),
(104200, '1.25.10.10-FF-000258', NULL, 'G-protein coupled receptor-associated sorting protein 2', 240, NULL, NULL, 104200),
(104201, '1.25.10.10-FF-002821', NULL, 'Wings apart-like protein homolog 1', 192, NULL, NULL, 104201),
(104202, '2.60.40.10-FF-000637', NULL, 'Basement membrane proteoglycan', 91, NULL, NULL, 104202),
(104203, '1.10.268.10-FF-000008', NULL, 'DNA gyrase subunit A', 89, NULL, NULL, 104203),
(104204, '1.25.10.10-FF-002473', NULL, 'Tubulin-specific chaperone D', 215, NULL, NULL, 104204),
(104205, '1.10.472.10-FF-000067', NULL, 'Retinoblastoma-related protein 1', 201, NULL, NULL, 104205),
(104206, '3.30.1390.20-FF-000029', NULL, 'Predicted protein', 83, NULL, NULL, 104206),
(104207, '3.40.430.10-FF-000046', NULL, 'Uncharacterized protein', 111, NULL, NULL, 104207),
(104208, '2.10.90.10-FF-000137', NULL, 'Uncharacterized protein', 116, NULL, NULL, 104208),
(104209, '3.90.70.80-FF-000010', NULL, 'OTU domain-containing protein 1', 145, NULL, NULL, 104209),
(104210, '3.40.50.300-FF-000385', NULL, 'Structural maintenance of chromosomes 2', 180, NULL, NULL, 104210),
(104211, '3.20.80.10-FF-000044', NULL, 'Uncharacterized protein', 177, NULL, NULL, 104211),
(104212, '3.80.10.10-FF-003746', NULL, 'Leucine Rich Repeat family protein', 127, NULL, NULL, 104212),
(104213, '2.30.30.490-FF-000011', NULL, 'DNA (cytosine-5)-methyltransferase 1', 167, NULL, NULL, 104213),
(104214, '1.10.1420.10-FF-000137', NULL, 'DNA mismatch repair protein', 68, NULL, NULL, 104214),
(104215, '3.20.20.140-FF-000459', NULL, 'Uncharacterized protein', 386, NULL, NULL, 104215),
(104216, '3.40.50.1000-FF-000824', NULL, NULL, 96, NULL, NULL, 104216),
(104217, '1.10.472.130-FF-000089', NULL, 'Uncharacterized protein', 169, NULL, NULL, 104217),
(104218, '3.40.50.300-FF-000475', NULL, 'GTP-binding protein Rhes', 173, NULL, NULL, 104218),
(104219, '3.30.1640.10-FF-000097', NULL, 'DNA replication licensing factor (Mcm)', 89, NULL, NULL, 104219),
(104220, '1.25.40.20-FF-000825', NULL, 'Uncharacterized protein', 291, NULL, NULL, 104220),
(104221, '3.10.20.30-FF-000069', NULL, NULL, 47, NULL, NULL, 104221),
(104222, '3.30.420.40-FF-000702', NULL, 'Acetate kinase', 205, NULL, NULL, 104222);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(104223, '3.20.20.70-FF-000474', NULL, 'Uncharacterized protein', 218, NULL, NULL, 104223),
(104224, '1.20.200.10-FF-000007', NULL, 'Adenylosuccinate lyase', 225, NULL, NULL, 104224),
(104225, '1.10.195.10-FF-000001', NULL, 'Protein Vpu', 46, NULL, NULL, 104225),
(104226, '3.90.550.50-FF-000140', NULL, 'Hexosyltransferase', 212, NULL, NULL, 104226),
(104227, '3.30.565.10-FF-000366', NULL, 'Hybrid signal transduction histidine kinase H', 189, NULL, NULL, 104227),
(104228, '3.90.550.10-FF-000268', NULL, '2-C-methyl-D-erythritol 4-phosphate cytidylyltransferase', 222, NULL, NULL, 104228),
(104229, '2.30.30.40-FF-000512', NULL, 'Alpha-(1,6)-fucosyltransferase', 48, NULL, NULL, 104229),
(104230, '2.60.40.10-FF-000019', NULL, 'receptor-type tyrosine-protein phosphatase kappa isoform X2', 102, NULL, NULL, 104230),
(104231, '3.40.532.10-FF-000007', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 225, NULL, NULL, 104231),
(104232, '2.60.120.260-FF-000126', NULL, 'Allantoicase', 199, NULL, NULL, 104232),
(104233, '1.10.150.780-FF-000008', NULL, 'Uncharacterized protein', 105, NULL, NULL, 104233),
(104234, '3.40.1110.10-FF-000139', NULL, 'Probable cation-transporting ATPase F', 202, NULL, NULL, 104234),
(104235, '1.20.1250.20-FF-001496', NULL, 'Os11g0284032 protein', 271, NULL, NULL, 104235),
(104236, '3.30.70.580-FF-000014', NULL, 'Pseudouridine synthase', 86, NULL, NULL, 104236),
(104237, '1.25.10.10-FF-002203', NULL, 'Uncharacterized protein', 437, NULL, NULL, 104237),
(104238, '3.30.160.60-FF-002234', NULL, 'Zinc finger protein 444', 52, NULL, NULL, 104238),
(104239, '3.50.50.100-FF-000042', NULL, 'Uncharacterized protein', 379, NULL, NULL, 104239),
(104240, '2.120.10.30-FF-000442', NULL, 'Predicted protein', 115, NULL, NULL, 104240),
(104241, '3.30.1140.60-FF-000006', NULL, 'F-actin-capping protein subunit alpha', 102, NULL, NULL, 104241),
(104242, '3.40.50.300-FF-006158', NULL, 'RIKEN cDNA 9930111J21 gene 1', 56, NULL, NULL, 104242),
(104243, '3.40.250.10-FF-000189', NULL, 'MBL fold metallo-hydrolase', 109, NULL, NULL, 104243),
(104244, '3.40.50.150-FF-000317', NULL, 'Putative methyltransferase', 340, NULL, NULL, 104244),
(104245, '1.10.150.770-FF-000005', NULL, NULL, 69, NULL, NULL, 104245),
(104246, '3.40.50.300-FF-002420', NULL, 'ROK1p RNA-dependent ATPase', 245, NULL, NULL, 104246),
(104247, '3.30.830.10-FF-000207', NULL, 'Uncharacterized protein', 220, NULL, NULL, 104247),
(104248, '2.60.40.150-FF-000253', NULL, 'Protostome-specific GEF, isoform C', 155, NULL, NULL, 104248),
(104249, '2.70.150.10-FF-000280', NULL, 'Phospholipid-transporting ATPase', 145, NULL, NULL, 104249),
(104250, '3.80.10.10-FF-001386', NULL, 'Protein MALE DISCOVERER 1', 183, NULL, NULL, 104250),
(104251, '3.40.390.10-FF-000261', NULL, NULL, 185, NULL, NULL, 104251),
(104252, '2.10.25.10-FF-000975', NULL, 'MAM and LDL-receptor class A domain-containing protein 1', 44, NULL, NULL, 104252),
(104253, '3.40.50.300-FF-002274', NULL, 'Si:dkeyp-69e1.8', 222, NULL, NULL, 104253),
(104254, '3.30.160.60-FF-003015', NULL, 'Si:dkey-111k8.3', 25, NULL, NULL, 104254),
(104255, '2.70.70.10-FF-000032', NULL, 'Peptidase family M23', 145, NULL, NULL, 104255),
(104256, '3.40.50.300-FF-006545', NULL, 'ATP-dependent DNA helicase', 106, NULL, NULL, 104256),
(104257, '3.40.50.970-FF-000030', NULL, '1-deoxy-D-xylulose-5-phosphate synthase', 175, NULL, NULL, 104257),
(104258, '2.40.70.10-FF-000303', NULL, NULL, 174, NULL, NULL, 104258),
(104259, '3.40.50.1460-FF-000001', NULL, 'Caspase-3 preproprotein', 257, NULL, NULL, 104259),
(104260, '3.90.70.10-FF-000063', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 304, NULL, NULL, 104260),
(104261, '3.30.1740.20-FF-000012', NULL, '40S ribosomal protein S26', 82, NULL, NULL, 104261),
(104262, '3.30.420.40-FF-000085', NULL, 'Glycerol kinase 2', 244, NULL, NULL, 104262),
(104263, '3.10.100.10-FF-000421', NULL, NULL, 84, NULL, NULL, 104263),
(104264, '2.20.28.230-FF-000006', NULL, 'Zona pellucida sperm-binding protein 3 receptor', 55, NULL, NULL, 104264),
(104265, '3.90.70.10-FF-000591', NULL, 'Uncharacterized protein', 213, NULL, NULL, 104265);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(104266, '2.130.10.10-FF-003021', NULL, 'ATG16/SAP18/CVT11/APG16, putative', 166, NULL, NULL, 104266),
(104267, '2.60.40.10-FF-002436', NULL, 'Uncharacterized protein, isoform B', 101, NULL, NULL, 104267),
(104268, '1.20.1250.20-FF-001294', NULL, 'sialin-like isoform X2', 141, NULL, NULL, 104268),
(104269, '2.60.40.3500-FF-000008', NULL, NULL, 107, NULL, NULL, 104269),
(104270, '3.30.160.60-FF-000851', NULL, 'Putative transcriptional repressor ctcf', 26, NULL, NULL, 104270),
(104271, '1.10.510.10-FF-004473', NULL, NULL, 265, NULL, NULL, 104271),
(104272, '1.20.1250.20-FF-001350', NULL, 'Solute carrier family 2 member 1b', 326, NULL, NULL, 104272),
(104273, '1.10.357.10-FF-000081', NULL, 'Transcriptional regulatory protein', 139, NULL, NULL, 104273),
(104274, '3.40.50.1470-FF-000004', NULL, 'Probable peptidyl-tRNA hydrolase', 202, NULL, NULL, 104274),
(104275, '3.40.630.10-FF-000027', NULL, 'N-fatty-acyl-amino acid synthase/hydrolase PM20D1', 206, NULL, NULL, 104275),
(104276, '3.30.565.10-FF-000164', NULL, 'Sensor histidine kinase', 143, NULL, NULL, 104276),
(104277, '3.40.50.300-FF-004359', NULL, 'Hypothetical_protein_-_conserved', 227, NULL, NULL, 104277),
(104278, '2.60.40.10-FF-000345', NULL, 'Muscle M-line assembly protein unc-89', 98, NULL, NULL, 104278),
(104279, '3.20.20.70-FF-000766', NULL, NULL, 355, NULL, NULL, 104279),
(104280, '1.10.357.20-FF-000027', NULL, 'Uncharacterized protein', 64, NULL, NULL, 104280),
(104281, '3.30.160.60-FF-006247', NULL, NULL, 28, NULL, NULL, 104281),
(104282, '3.80.10.10-FF-002965', NULL, 'Uncharacterized protein', 160, NULL, NULL, 104282),
(104283, '3.30.160.60-FF-005578', NULL, NULL, 125, NULL, NULL, 104283),
(104284, '2.30.130.40-FF-000021', NULL, 'Lon protease homolog, mitochondrial', 108, NULL, NULL, 104284),
(104285, '1.10.10.10-FF-000494', NULL, 'Blast:Protein gooseberry-neuro', 62, NULL, NULL, 104285),
(104286, '2.60.40.790-FF-000181', NULL, NULL, 121, NULL, NULL, 104286),
(104287, '3.90.1410.10-FF-000128', NULL, 'Uncharacterized protein', 328, NULL, NULL, 104287),
(104288, '1.20.1070.10-FF-000091', NULL, 'G-protein coupled receptor 161', 327, NULL, NULL, 104288),
(104289, '2.40.10.10-FF-000327', NULL, NULL, 106, NULL, NULL, 104289),
(104290, '3.40.50.1480-FF-000007', NULL, 'Adenosylhomocysteinase', 55, NULL, NULL, 104290),
(104291, '2.70.150.10-FF-000274', NULL, 'Cation-transporting ATPase', 187, NULL, NULL, 104291),
(104292, '1.10.472.10-FF-000213', NULL, 'Uncharacterized protein', 128, NULL, NULL, 104292),
(104293, '1.10.1490.10-FF-000001', NULL, 'DNA fragmentation factor subunit alpha', 83, NULL, NULL, 104293),
(104294, '2.30.29.30-FF-001192', NULL, 'Uncharacterized protein', 84, NULL, NULL, 104294),
(104295, '1.10.472.10-FF-000270', NULL, 'Uncharacterized protein', 93, NULL, NULL, 104295),
(104296, '2.40.30.10-FF-000183', NULL, 'NADPH oxidase 4', 108, NULL, NULL, 104296),
(104297, '1.10.357.10-FF-000024', NULL, 'TetR family transcriptional regulator', 170, NULL, NULL, 104297),
(104298, '3.30.420.110-FF-000021', NULL, 'DNA mismatch repair protein MSH2', 160, NULL, NULL, 104298),
(104299, '3.30.160.60-FF-004651', NULL, NULL, 28, NULL, NULL, 104299),
(104300, '1.10.10.10-FF-000550', NULL, 'Heat shock transcription factor 2', 55, NULL, NULL, 104300),
(104301, '3.40.50.300-FF-005938', NULL, 'RNA helicase', 217, NULL, NULL, 104301),
(104302, '2.60.120.10-FF-000735', NULL, 'Uncharacterized protein', 124, NULL, NULL, 104302),
(104303, '3.40.50.1440-FF-000046', NULL, 'DML1p protein', 332, NULL, NULL, 104303),
(104304, '3.90.930.12-FF-000007', NULL, '60S ribosomal protein L6', 98, NULL, NULL, 104304),
(104305, '3.40.50.300-FF-008254', NULL, 'Uncharacterized protein', 51, NULL, NULL, 104305),
(104306, '1.20.120.1750-FF-000130', NULL, 'Predicted protein', 81, NULL, NULL, 104306),
(104307, '3.80.10.10-FF-001329', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 168, NULL, NULL, 104307),
(104308, '3.20.20.140-FF-000465', NULL, 'Gll3396 protein', 106, NULL, NULL, 104308),
(104309, '1.10.10.60-FF-000514', NULL, 'Uncharacterized protein, isoform C', 55, NULL, NULL, 104309);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(104310, '1.25.40.10-FF-002205', NULL, 'Uncharacterized protein', 212, NULL, NULL, 104310),
(104311, '3.40.50.720-FF-001169', NULL, 'Hydroxysteroid (17-beta) dehydrogenase 4, isoform CRA_a', 109, NULL, NULL, 104311),
(104312, '1.10.246.60-FF-000017', NULL, NULL, 78, NULL, NULL, 104312),
(104313, '3.40.50.300-FF-008198', NULL, 'Uncharacterized protein', 75, NULL, NULL, 104313),
(104314, '3.40.140.10-FF-000119', NULL, 'Non ATPase subunit MPR1 of 26S proteasome', 227, NULL, NULL, 104314),
(104315, '1.10.10.60-FF-000458', NULL, 'Transcription factor MYB86', 75, NULL, NULL, 104315),
(104316, '2.130.10.10-FF-003398', NULL, 'Metastasis associated 1 family member 2', 205, NULL, NULL, 104316),
(104317, '2.40.10.10-FF-000653', NULL, NULL, 107, NULL, NULL, 104317),
(104318, '3.50.50.60-FF-001039', NULL, 'Uncharacterized protein', 60, NULL, NULL, 104318),
(104319, '3.40.50.2060-FF-000024', NULL, NULL, 131, NULL, NULL, 104319),
(104320, '3.40.50.300-FF-006074', NULL, 'Predicted protein', 149, NULL, NULL, 104320),
(104321, '3.60.20.10-FF-000179', NULL, NULL, 105, NULL, NULL, 104321),
(104322, '3.30.420.40-FF-000028', NULL, 'heat shock 70 kDa protein-like', 155, NULL, NULL, 104322),
(104323, '3.40.50.300-FF-006017', NULL, 'ABC transporter H family member 4', 183, NULL, NULL, 104323),
(104324, '3.40.140.10-FF-000158', NULL, '26S proteasome non-ATPase regulatory subunit 7', 109, NULL, NULL, 104324),
(104325, '3.40.30.10-FF-000377', NULL, 'Putative glutathione S-transferase', 163, NULL, NULL, 104325),
(104326, '2.60.40.4070-FF-000005', NULL, 'Minor extracellular protease VpR', 61, NULL, NULL, 104326),
(104327, '2.60.40.10-FF-004673', NULL, NULL, 94, NULL, NULL, 104327),
(104328, '3.90.182.10-FF-000002', NULL, 'N-acetylmuramoyl-L-alanine amidase family 2', 98, NULL, NULL, 104328),
(104329, '3.20.20.70-FF-000390', NULL, 'Nicotinate phosphoribosyltransferase', 65, NULL, NULL, 104329),
(104330, '3.60.15.10-FF-000234', NULL, 'Uncharacterized protein', 215, NULL, NULL, 104330),
(104331, '3.30.70.870-FF-000034', NULL, 'Ribosome-releasing factor 2, mitochondrial', 74, NULL, NULL, 104331),
(104332, '3.40.47.10-FF-000180', NULL, 'Acetyl-CoA acetyltransferase', 405, NULL, NULL, 104332),
(104333, '2.60.40.4060-FF-000002', NULL, 'Spondin-1', 148, NULL, NULL, 104333),
(104334, '3.30.200.20-FF-001872', NULL, 'Uncharacterized protein', 62, NULL, NULL, 104334),
(104335, '2.130.10.10-FF-002414', NULL, 'Notchless', 112, NULL, NULL, 104335),
(104336, '2.170.270.10-FF-000214', NULL, 'Uncharacterized protein', 141, NULL, NULL, 104336),
(104337, '1.20.1560.10-FF-000696', NULL, 'Uncharacterized protein', 327, NULL, NULL, 104337),
(104338, '2.30.42.10-FF-000132', NULL, 'disks large homolog 5 isoform X1', 80, NULL, NULL, 104338),
(104339, '1.20.58.390-FF-000176', NULL, 'Predicted protein', 64, NULL, NULL, 104339),
(104340, '1.25.70.10-FF-000088', NULL, NULL, 139, NULL, NULL, 104340),
(104341, '3.30.830.10-FF-000152', NULL, 'Metalloenzyme, LuxS/M16 peptidase-like protein', 222, NULL, NULL, 104341),
(104342, '2.40.100.10-FF-000126', NULL, 'Peptidyl-prolyl cis-trans isomerase', 105, NULL, NULL, 104342),
(104343, '3.40.50.10420-FF-000047', NULL, 'Uncharacterized protein', 110, NULL, NULL, 104343),
(104344, '1.10.238.10-FF-000714', NULL, 'Calcium-dependent protein kinase', 78, NULL, NULL, 104344),
(104345, '3.30.70.1660-FF-000007', NULL, 'Peptide chain release factor 1, mitochondrial', 140, NULL, NULL, 104345),
(104346, '3.30.70.330-FF-001827', NULL, NULL, 87, NULL, NULL, 104346),
(104347, '2.60.40.150-FF-000455', NULL, 'AT3g18370/MYF24_8', 127, NULL, NULL, 104347),
(104348, '1.10.10.60-FF-000571', NULL, 'Two-component system response regulator', 52, NULL, NULL, 104348),
(104349, '2.130.10.10-FF-000525', NULL, 'U4/U6 small nuclear ribonucleoprotein PRP4', 182, NULL, NULL, 104349),
(104350, '1.20.58.80-FF-000091', NULL, 'Calpain-like protease palB', 75, NULL, NULL, 104350),
(104351, '1.20.80.60-FF-000001', NULL, 'Sorting nexin-17 isoform1', 62, NULL, NULL, 104351),
(104352, '3.30.70.330-FF-000900', NULL, 'Nuclear transport factor 2 domain containing protein, expressed', 106, NULL, NULL, 104352); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(104353, '3.20.180.10-FF-000002', NULL, 'BnaC05g47660D protein', 91, NULL, NULL, 104353),
(104354, '3.40.30.10-FF-000490', NULL, 'Mitochondrial Ribosomal Protein, Large', 157, NULL, NULL, 104354),
(104355, '3.10.20.90-FF-000334', NULL, 'Ubiquitin', 101, NULL, NULL, 104355),
(104356, '2.30.29.30-FF-000787', NULL, 'WW domain-containing protein tag-325', 127, NULL, NULL, 104356),
(104357, '3.30.160.60-FF-006360', NULL, NULL, 41, NULL, NULL, 104357),
(104358, '3.40.1090.10-FF-000114', NULL, 'Patatin family protein', 320, NULL, NULL, 104358),
(104359, '3.30.160.60-FF-002649', NULL, NULL, 29, NULL, NULL, 104359),
(104360, '2.60.40.150-FF-000635', NULL, 'Uncharacterized protein', 134, NULL, NULL, 104360),
(104361, '2.10.110.10-FF-000291', NULL, 'Predicted protein', 81, NULL, NULL, 104361),
(104362, '3.20.180.20-FF-000005', NULL, 'Dynein heavy chain, putative', 98, NULL, NULL, 104362),
(104363, '2.130.10.10-FF-001689', NULL, 'Transcriptional regulator, AraC/XylS family', 204, NULL, NULL, 104363),
(104364, '2.40.10.10-FF-000614', NULL, NULL, 109, NULL, NULL, 104364),
(104365, '2.30.38.10-FF-000021', NULL, 'Acyl-CoA ligase easD', 71, NULL, NULL, 104365),
(104366, '3.40.50.150-FF-000643', NULL, 'Fibrillarin-like rRNA/tRNA 2''-O-methyltransferase', 179, NULL, NULL, 104366),
(104367, '3.40.50.720-FF-001528', NULL, 'Peroxisomal 2,4-dienoyl-CoA reductase', 287, NULL, NULL, 104367),
(104368, '3.90.70.200-FF-000016', NULL, 'Rtf1p', 134, NULL, NULL, 104368),
(104369, '2.130.10.10-FF-000469', NULL, 'Nucleotide binding protein', 135, NULL, NULL, 104369),
(104370, '2.20.70.10-FF-000107', NULL, 'Chromosome 19, whole genome shotgun sequence', 45, NULL, NULL, 104370),
(104371, '3.40.50.2300-FF-000293', NULL, 'Response regulator receiver domain protein', 95, NULL, NULL, 104371),
(104372, '3.30.70.1230-FF-000087', NULL, 'Predicted protein', 142, NULL, NULL, 104372),
(104373, '4.10.1240.10-FF-000082', NULL, 'Uncharacterized protein', 62, NULL, NULL, 104373),
(104374, '3.30.160.60-FF-002560', NULL, NULL, 29, NULL, NULL, 104374),
(104375, '3.30.559.30-FF-000083', NULL, 'Uncharacterized protein', 191, NULL, NULL, 104375),
(104376, '3.20.20.70-FF-000709', NULL, NULL, 138, NULL, NULL, 104376),
(104377, '1.25.40.10-FF-001896', NULL, 'Anaphase-promoting complex subunit 8', 301, NULL, NULL, 104377),
(104378, '1.10.238.10-FF-000478', NULL, 'EH domains and endocytosis-related protein', 115, NULL, NULL, 104378),
(104379, '2.130.10.10-FF-002616', NULL, 'Uncharacterized protein', 202, NULL, NULL, 104379),
(104380, '3.90.550.10-FF-000066', NULL, 'Translation initiation factor eIF-2B subunit epsilon', 294, NULL, NULL, 104380),
(104381, '3.40.850.10-FF-000100', NULL, 'Myosin F, putative', 43, NULL, NULL, 104381),
(104382, '3.10.20.90-FF-000098', NULL, 'Plexin D1', 122, NULL, NULL, 104382),
(104383, '2.10.25.10-FF-001285', NULL, 'Hepatocyte growth factor activator', 83, NULL, NULL, 104383),
(104384, '1.10.8.470-FF-000006', NULL, 'Predicted protein', 97, NULL, NULL, 104384),
(104385, '3.40.50.1820-FF-000918', NULL, 'Serine carboxypeptidase, putative', 107, NULL, NULL, 104385),
(104386, '3.40.50.12240-FF-000008', NULL, 'ATPase, H+ transporting, lysosomal 56/58kD, V1 subunit B, isoform 2 variant', 260, NULL, NULL, 104386),
(104387, '3.30.200.20-FF-001759', NULL, 'Rho-associated, coiled-coil-containing protein kinase 2b', 98, NULL, NULL, 104387),
(104388, '3.20.20.80-FF-000010', NULL, 'glucan endo-1,3-beta-glucosidase, basic', 310, NULL, NULL, 104388),
(104389, '1.20.1250.20-FF-002221', NULL, 'Uncharacterized protein', 132, NULL, NULL, 104389),
(104390, '1.20.1560.10-FF-000898', NULL, 'ATP binding cassette subfamily B member 8', 217, NULL, NULL, 104390),
(104391, '3.40.630.30-FF-000365', NULL, 'GNAT family N-acetyltransferase', 101, NULL, NULL, 104391),
(104392, '3.30.40.10-FF-002053', NULL, 'Uncharacterized protein', 92, NULL, NULL, 104392),
(104393, '3.40.50.300-FF-003111', NULL, 'Translation-associated GTPase', 205, NULL, NULL, 104393),
(104394, '1.10.730.10-FF-000145', NULL, 'Uncharacterized protein', 123, NULL, NULL, 104394),
(104395, '3.10.110.10-FF-000337', NULL, 'Uncharacterized protein', 153, NULL, NULL, 104395);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(104396, '1.25.40.10-FF-001839', NULL, 'Pentatricopeptide (PPR) repeat-containing protein-like', 212, NULL, NULL, 104396),
(104397, '1.10.1420.10-FF-000053', NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', 57, NULL, NULL, 104397),
(104398, '3.30.40.10-FF-000344', NULL, 'protein SCAF11 isoform X1', 61, NULL, NULL, 104398),
(104399, '3.90.550.10-FF-000594', NULL, 'Glycosyltransferase, putative', 231, NULL, NULL, 104399),
(104400, '2.130.10.10-FF-005904', NULL, 'Uncharacterized protein', 471, NULL, NULL, 104400),
(104401, '3.40.50.300-FF-000559', NULL, 'Nuclear/nucleolar GTPase 2', 163, NULL, NULL, 104401),
(104402, '3.60.10.10-FF-000032', NULL, 'inositol polyphosphate 5-phosphatase K isoform X1', 336, NULL, NULL, 104402),
(104403, '3.60.21.10-FF-000350', NULL, '5'' nucleotidase, putative', 82, NULL, NULL, 104403),
(104404, '3.30.160.60-FF-002088', NULL, 'Zinc finger protein ZIC 3', 46, NULL, NULL, 104404),
(104405, '1.20.58.1880-FF-000020', NULL, 'Nuclear receptor corepressor 2', 101, NULL, NULL, 104405),
(104406, '2.170.150.80-FF-000035', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 151, NULL, NULL, 104406),
(104407, '3.30.160.60-FF-006303', NULL, NULL, 75, NULL, NULL, 104407),
(104408, '3.30.1490.100-FF-000053', NULL, 'Uncharacterized protein MG360', 113, NULL, NULL, 104408),
(104409, '3.40.50.150-FF-000172', NULL, 'EEF1A lysine methyltransferase 2', 190, NULL, NULL, 104409),
(104410, '3.30.160.60-FF-006449', NULL, NULL, 67, NULL, NULL, 104410),
(104411, '3.30.420.40-FF-000556', NULL, 'Phosphotransferase', 178, NULL, NULL, 104411),
(104412, '3.40.50.12650-FF-000047', NULL, 'Predicted protein', 157, NULL, NULL, 104412),
(104413, '2.30.110.10-FF-000062', NULL, 'Monooxygenase HpaC', 164, NULL, NULL, 104413),
(104414, '3.40.50.1000-FF-000650', NULL, NULL, 107, NULL, NULL, 104414),
(104415, '3.40.50.300-FF-003201', NULL, 'AAA family ATPase, putative', 162, NULL, NULL, 104415),
(104416, '2.60.40.1280-FF-000005', NULL, 'Collagen adhesin', 142, NULL, NULL, 104416),
(104417, '3.90.180.10-FF-000110', NULL, 'Alcohol dehydrogenase (Zn containing) (Adh-13)', 309, NULL, NULL, 104417),
(104418, '1.10.510.10-FF-002764', NULL, NULL, 116, NULL, NULL, 104418),
(104419, '2.60.40.10-FF-004145', NULL, NULL, 90, NULL, NULL, 104419),
(104420, '3.30.505.10-FF-000149', NULL, NULL, 31, NULL, NULL, 104420),
(104421, '6.20.250.70-FF-000003', NULL, 'DNA-directed RNA polymerase I subunit', 112, NULL, NULL, 104421),
(104422, '3.40.50.12230-FF-000005', NULL, 'Methionyl-tRNA transformylase', 364, NULL, NULL, 104422),
(104423, '2.120.10.30-FF-000150', NULL, 'Dipeptidyl peptidase, variant', 225, NULL, NULL, 104423),
(104424, '3.30.420.40-FF-000500', NULL, 'Heat shock-related 70 kDa protein 2', 108, NULL, NULL, 104424),
(104425, '3.40.1440.60-FF-000010', NULL, 'Probable primosomal protein N''', 106, NULL, NULL, 104425),
(104426, '1.25.40.20-FF-000651', NULL, 'Rab GTPase activating protein, putative', 284, NULL, NULL, 104426),
(104427, '3.80.10.10-FF-003572', NULL, 'Uncharacterized protein', 143, NULL, NULL, 104427),
(104428, '3.30.230.10-FF-000151', NULL, 'Mevalonate kinase', 179, NULL, NULL, 104428),
(104429, '2.130.10.10-FF-003869', NULL, 'Uncharacterized protein', 281, NULL, NULL, 104429),
(104430, '1.20.1250.20-FF-002131', NULL, 'Solute carrier organic anion transporter family member', 210, NULL, NULL, 104430),
(104431, '2.60.120.260-FF-000418', NULL, 'Ephrin type-A receptor 7', 132, NULL, NULL, 104431),
(104432, '2.40.170.20-FF-000116', NULL, 'SusC homolog', 573, NULL, NULL, 104432),
(104433, '3.30.70.330-FF-001356', NULL, 'Probable splicing factor, arginine/serine-rich 7', 85, NULL, NULL, 104433),
(104434, '4.10.520.10-FF-000022', NULL, 'DNA-binding protein HU-beta', 93, NULL, NULL, 104434),
(104435, '2.30.30.140-FF-000249', NULL, 'Putative serine/threonine-protein kinase pats1', 49, NULL, NULL, 104435),
(104436, '3.90.190.10-FF-000459', NULL, 'Protein tyrosine phosphatase receptor type K', 202, NULL, NULL, 104436),
(104437, '3.30.1540.20-FF-000031', NULL, NULL, 127, NULL, NULL, 104437);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(104438, '2.60.120.920-FF-000038', NULL, 'cardiomyopathy-associated protein 5', 165, NULL, NULL, 104438),
(104439, '3.10.100.10-FF-000039', NULL, 'Secretory phospholipase A2 receptor', 131, NULL, NULL, 104439),
(104440, '2.40.50.140-FF-000442', NULL, 'Tyrosyl or methionyl-tRNA synthetase-like protein', 185, NULL, NULL, 104440),
(104441, '1.20.920.20-FF-000020', NULL, 'Dynein, axonemal, heavy chain 5', 125, NULL, NULL, 104441),
(104442, '3.90.1150.10-FF-000124', NULL, 'Histidinol-phosphate aminotransferase', 117, NULL, NULL, 104442),
(104443, '1.25.10.10-FF-002057', NULL, 'Predicted protein', 375, NULL, NULL, 104443),
(104444, '1.25.40.730-FF-000016', NULL, 'Clathrin heavy chain', 74, NULL, NULL, 104444),
(104445, '1.10.8.60-FF-000238', NULL, 'AAA family ATPase, CDC48 subfamily', 98, NULL, NULL, 104445),
(104446, '3.100.10.20-FF-000003', NULL, 'CRISPR-associated endonuclease Cas1', 79, NULL, NULL, 104446),
(104447, '3.40.50.300-FF-001110', NULL, 'F-box only protein 4', 205, NULL, NULL, 104447),
(104448, '1.10.1450.10-FF-000111', NULL, 'Tetraspanin', 100, NULL, NULL, 104448),
(104449, '3.30.200.20-FF-000326', NULL, 'Mitogen-activated protein kinase kinase kinase 14', 146, NULL, NULL, 104449),
(104450, '3.30.497.10-FF-000117', NULL, 'Serpin peptidase inhibitor 27', 254, NULL, NULL, 104450),
(104451, '2.60.34.10-FF-000106', NULL, 'Uncharacterized protein', 176, NULL, NULL, 104451),
(104452, '1.10.287.940-FF-000016', NULL, 'P2X receptor B', 14, NULL, NULL, 104452),
(104453, '3.30.9.10-FF-000249', NULL, 'Oxidase', 173, NULL, NULL, 104453),
(104454, '1.25.10.10-FF-000730', NULL, 'UTP10p Nucleolar protein', 473, NULL, NULL, 104454),
(104455, '3.40.950.10-FF-000046', NULL, NULL, 190, NULL, NULL, 104455),
(104456, '1.20.920.30-FF-000023', NULL, 'Glutathione S-transferase class-mu 26 kDa isozyme', 189, NULL, NULL, 104456),
(104457, '3.30.457.60-FF-000017', NULL, 'Spindle assembly checkpoint component MAD1', 80, NULL, NULL, 104457),
(104458, '3.40.630.10-FF-000207', NULL, 'Gamma-D-glutamyl-L-diamino acid endopeptidase 1', 296, NULL, NULL, 104458),
(104459, '1.10.167.10-FF-000009', NULL, 'G protein-coupled receptor kinase', 242, NULL, NULL, 104459),
(104460, '1.25.10.10-FF-000674', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 209, NULL, NULL, 104460),
(104461, '1.10.287.950-FF-000019', NULL, 'Biofilm dispersion protein BdlA', 190, NULL, NULL, 104461),
(104462, '1.10.565.10-FF-000047', NULL, 'Ultraspiracle, isoform B', 256, NULL, NULL, 104462),
(104463, '3.40.50.620-FF-000829', NULL, 'AGAP011744-PA', 168, NULL, NULL, 104463),
(104464, '3.90.105.10-FF-000032', NULL, 'Molybdopterin molybdenumtransferase', 51, NULL, NULL, 104464),
(104465, '3.30.2350.20-FF-000061', NULL, NULL, 115, NULL, NULL, 104465),
(104466, '3.10.100.10-FF-000191', NULL, 'Uncharacterized protein', 158, NULL, NULL, 104466),
(104467, '1.10.3110.10-FF-000007', NULL, 'Amine oxidase, variant 2', 102, NULL, NULL, 104467),
(104468, '1.20.990.10-FF-000055', NULL, 'Uncharacterized protein', 57, NULL, NULL, 104468),
(104469, '2.60.120.620-FF-000162', NULL, 'Uncharacterized protein', 86, NULL, NULL, 104469),
(104470, '3.30.160.60-FF-000087', NULL, 'Zinc finger protein 354B', 28, NULL, NULL, 104470),
(104471, '2.60.40.640-FF-000074', NULL, 'pH-response regulator protein palF/RIM8', 141, NULL, NULL, 104471),
(104472, '3.30.160.60-FF-004358', NULL, NULL, 24, NULL, NULL, 104472),
(104473, '3.50.50.60-FF-000353', NULL, 'Pipecolic acid oxidase', 157, NULL, NULL, 104473),
(104474, '3.40.140.100-FF-000019', NULL, 'Ubiquitin-like modifier-activating enzyme ATG7', 117, NULL, NULL, 104474),
(104475, '2.60.120.200-FF-000007', NULL, 'neurexin-1 isoform X1', 188, NULL, NULL, 104475),
(104476, '1.20.58.2220-FF-000072', NULL, 'Uncharacterized protein', 72, NULL, NULL, 104476),
(104477, '3.30.200.20-FF-000511', NULL, 'Leucine-rich receptor-like protein kinase family protein', 85, NULL, NULL, 104477),
(104478, '2.10.25.10-FF-001431', NULL, 'Uncharacterized protein', 49, NULL, NULL, 104478),
(104479, '1.20.930.40-FF-000037', NULL, 'Os01g0740600 protein', 86, NULL, NULL, 104479);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(104480, '3.40.190.10-FF-000217', NULL, 'Glutamate receptor', 49, NULL, NULL, 104480),
(104481, '2.40.70.10-FF-000067', NULL, 'Endopeptidase, putative', 163, NULL, NULL, 104481),
(104482, '1.25.10.10-FF-002675', NULL, 'Uncharacterized protein', 85, NULL, NULL, 104482),
(104483, '3.30.200.20-FF-001905', NULL, 'Discoidin domain receptor family, member 2, like', 94, NULL, NULL, 104483),
(104484, '2.130.10.10-FF-002094', NULL, 'Katanin p80 WD40 repeat-containing subunit B1', 78, NULL, NULL, 104484),
(104485, '2.40.160.110-FF-000050', NULL, 'Uncharacterized protein', 106, NULL, NULL, 104485),
(104486, '3.40.50.2000-FF-000231', NULL, 'Glycosyltransferase', 177, NULL, NULL, 104486),
(104487, '3.40.50.2000-FF-000141', NULL, 'Lipopolysaccharide core heptosyltransferase RfaQ', 179, NULL, NULL, 104487),
(104488, '3.30.420.270-FF-000018', NULL, 'Biopolymer transport protein ExbD', 71, NULL, NULL, 104488),
(104489, '3.40.140.10-FF-000271', NULL, 'Predicted protein', 92, NULL, NULL, 104489),
(104490, '2.120.10.80-FF-000226', NULL, 'Uncharacterized protein', 276, NULL, NULL, 104490),
(104491, '3.30.2410.10-FF-000018', NULL, 'Putative E3 ubiquitin-protein ligase HECTD3', 108, NULL, NULL, 104491),
(104492, '2.60.40.60-FF-000753', NULL, 'Fat-like cadherin-related tumor suppressor homolog', 107, NULL, NULL, 104492),
(104493, '3.60.21.10-FF-000294', NULL, 'Acid sphingomyelinase, putative', 225, NULL, NULL, 104493),
(104494, '3.40.50.720-FF-001641', NULL, 'dTDP-glucose 4,6-dehydratase', 316, NULL, NULL, 104494),
(104495, '1.10.560.10-FF-000058', NULL, 'T-complex protein 1 subunit zeta', 117, NULL, NULL, 104495),
(104496, '2.130.10.10-FF-000582', NULL, 'Echinoderm microtubule-associated protein-like 3', 200, NULL, NULL, 104496),
(104497, '3.40.50.2020-FF-000147', NULL, 'Hypoxanthine/guanine phosphoribosyltransferase', 189, NULL, NULL, 104497),
(104498, '3.30.497.10-FF-000174', NULL, 'AGAP009213-PA', 195, NULL, NULL, 104498),
(104499, '1.25.40.10-FF-003992', NULL, 'Uncharacterized protein C31F10.16', 641, NULL, NULL, 104499),
(104500, '3.90.470.20-FF-000068', NULL, 'Uncharacterized protein', 35, NULL, NULL, 104500),
(104501, '2.120.10.80-FF-000316', NULL, 'Multiple EGF like domains 8', 169, NULL, NULL, 104501),
(104502, '2.60.120.10-FF-000589', NULL, 'Mannose-1-phosphate guanylyltransferase/mannose-6-phosphate isomerase', 105, NULL, NULL, 104502),
(104503, '1.25.10.10-FF-000056', NULL, 'FH1/FH2 domain-containing protein 3 isoform X1', 327, NULL, NULL, 104503),
(104504, '2.130.10.10-FF-003959', NULL, 'Os01g0606100-like protein', 241, NULL, NULL, 104504),
(104505, '3.90.550.50-FF-000139', NULL, 'Uncharacterized protein, isoform A', 214, NULL, NULL, 104505),
(104506, '1.20.1070.10-FF-001248', NULL, 'Adhesion G-protein coupled receptor G2', 284, NULL, NULL, 104506),
(104507, '1.20.1250.20-FF-001911', NULL, 'Uncharacterized protein (Fragment)', 234, NULL, NULL, 104507),
(104508, '3.30.360.10-FF-000008', NULL, 'Alpha-aminoadipic semialdehyde synthase, mitochondrial', 163, NULL, NULL, 104508),
(104509, '1.20.1250.20-FF-000422', NULL, 'Monocarboxylate transporter 9', 190, NULL, NULL, 104509),
(104510, '1.10.510.10-FF-000724', NULL, 'Serine/threonine-protein kinase', 207, NULL, NULL, 104510),
(104511, '3.30.160.60-FF-003667', NULL, NULL, 25, NULL, NULL, 104511),
(104512, '3.90.226.10-FF-000032', NULL, 'Methylmalonyl-CoA decarboxylase', 185, NULL, NULL, 104512),
(104513, '3.30.40.10-FF-000777', NULL, 'Fife, isoform B', 114, NULL, NULL, 104513),
(104514, '3.40.630.10-FF-000117', NULL, 'Predicted protein', 324, NULL, NULL, 104514),
(104515, '3.10.20.90-FF-000952', NULL, 'Predicted protein', 64, NULL, NULL, 104515),
(104516, '3.40.30.10-FF-001158', NULL, 'Uncharacterized protein', 104, NULL, NULL, 104516),
(104517, '2.70.40.10-FF-000030', NULL, 'Predicted protein', 133, NULL, NULL, 104517),
(104518, '3.30.200.20-FF-001815', NULL, 'Myosin heavy chain kinase A, putative', 72, NULL, NULL, 104518),
(104519, '3.40.190.10-FF-000307', NULL, 'Putative periplasmic aliphatic sulfonate-binding protein', 169, NULL, NULL, 104519),
(104520, '2.40.50.60-FF-000002', NULL, 'Cicadin', 54, NULL, NULL, 104520);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(104521, '3.30.70.330-FF-003065', NULL, NULL, 104, NULL, NULL, 104521),
(104522, '1.10.238.10-FF-000063', NULL, 'Voltage-dependent N-type calcium channel subunit alpha', 124, NULL, NULL, 104522),
(104523, '1.10.560.10-FF-000019', NULL, 'McKusick-Kaufman/Bardet-Biedl syndromes putative chaperonin', 165, NULL, NULL, 104523),
(104524, '2.60.260.20-FF-000102', NULL, 'AGAP000008-PA', 79, NULL, NULL, 104524),
(104525, '2.10.70.10-FF-000046', NULL, 'Membrane cofactor protein', 62, NULL, NULL, 104525),
(104526, '2.10.25.10-FF-001341', NULL, 'Uncharacterized protein', 60, NULL, NULL, 104526),
(104527, '1.20.1250.20-FF-000799', NULL, 'MFS transporter', 191, NULL, NULL, 104527),
(104528, '3.40.50.300-FF-004691', NULL, 'DNA helicase', 186, NULL, NULL, 104528),
(104529, '2.60.40.1510-FF-000029', NULL, 'Integrin beta', 138, NULL, NULL, 104529),
(104530, '3.30.70.330-FF-002789', NULL, NULL, 45, NULL, NULL, 104530),
(104531, '3.30.70.1400-FF-000014', NULL, 'Aminomethyltransferase', 88, NULL, NULL, 104531),
(104532, '3.10.20.90-FF-001025', NULL, 'Uncharacterized protein', 65, NULL, NULL, 104532),
(104533, '2.40.70.10-FF-000123', NULL, 'Polyprotein', 116, NULL, NULL, 104533),
(104534, '1.10.10.440-FF-000091', NULL, 'Chromosome 9, whole genome shotgun sequence', 59, NULL, NULL, 104534),
(104535, '2.60.40.10-FF-003892', NULL, NULL, 89, NULL, NULL, 104535),
(104536, '2.60.40.60-FF-000714', NULL, 'Cdh-4', 100, NULL, NULL, 104536),
(104537, '2.60.34.10-FF-000016', NULL, 'Heat shock protein 70', 141, NULL, NULL, 104537),
(104538, '3.10.290.10-FF-000081', NULL, '30S ribosomal protein S4, chloroplastic', 97, NULL, NULL, 104538),
(104539, '1.20.1600.10-FF-000048', NULL, 'Outer membrane protein TolC', 417, NULL, NULL, 104539),
(104540, '1.10.238.10-FF-000681', NULL, 'Uncharacterized protein', 114, NULL, NULL, 104540),
(104541, '3.30.160.60-FF-000233', NULL, 'Putative zinc finger protein 362', 25, NULL, NULL, 104541),
(104542, '2.30.30.40-FF-000568', NULL, 'Peroxisomal membrane protein PEX13-like Protein', 93, NULL, NULL, 104542),
(104543, '1.25.10.10-FF-000820', NULL, 'Pumilio/PUF RNA binding protein 5, putative', 297, NULL, NULL, 104543),
(104544, '1.20.1250.20-FF-001440', NULL, 'MFS quinate transporter, putative (AFU_orthologue AFUA_4G14670)', 99, NULL, NULL, 104544),
(104545, '1.25.40.1030-FF-000053', NULL, 'Predicted protein', 379, NULL, NULL, 104545),
(104546, '1.20.1070.10-FF-001580', NULL, 'Tachykinin receptor 3a', 158, NULL, NULL, 104546),
(104547, '2.60.40.10-FF-002346', NULL, 'Stretchin-Mlck, isoform S', 91, NULL, NULL, 104547),
(104548, '1.10.1410.10-FF-000081', NULL, 'Uncharacterized protein', 26, NULL, NULL, 104548),
(104549, '2.60.40.150-FF-000399', NULL, 'Phosphatidylserine decarboxylase proenzyme 2', 148, NULL, NULL, 104549),
(104550, '3.90.70.10-FF-000681', NULL, 'Uncharacterized protein', 270, NULL, NULL, 104550),
(104551, '1.10.287.110-FF-000116', NULL, 'Erj5p', 89, NULL, NULL, 104551),
(104552, '3.80.10.10-FF-000082', NULL, 'Leucine-rich repeat-containing 24', 121, NULL, NULL, 104552),
(104553, '2.160.10.10-FF-000018', NULL, 'Mannose-1-phosphate guanyltransferase beta', 121, NULL, NULL, 104553),
(104554, '3.10.20.90-FF-000862', NULL, 'Protein lgg', 74, NULL, NULL, 104554),
(104555, '3.40.30.10-FF-000287', NULL, 'Protein disulfide-isomerase domain', 121, NULL, NULL, 104555),
(104556, '3.30.70.980-FF-000067', NULL, 'Probable transcriptional regulatory protein MG332', 79, NULL, NULL, 104556),
(104557, '3.80.10.10-FF-001532', NULL, 'F-box/LRR-repeat protein 4 isoform A', 100, NULL, NULL, 104557),
(104558, '1.10.150.80-FF-000008', NULL, 'Polynucleotidyl transferase ribonuclease H fold protein with HRDC domain', 105, NULL, NULL, 104558),
(104559, '1.10.533.10-FF-000294', NULL, 'Uncharacterized protein', 81, NULL, NULL, 104559),
(104560, '2.60.120.620-FF-000072', NULL, 'GD21535', 179, NULL, NULL, 104560),
(104561, '3.30.70.330-FF-002137', NULL, NULL, 100, NULL, NULL, 104561),
(104562, '3.40.1090.10-FF-000153', NULL, 'Phospholipase A2', 293, NULL, NULL, 104562),
(104563, '2.60.40.640-FF-000035', NULL, 'Carboxypeptidase Y-deficient', 184, NULL, NULL, 104563);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(104564, '3.40.30.10-FF-001214', NULL, 'Uncharacterized protein', 37, NULL, NULL, 104564),
(104565, '2.130.10.10-FF-004325', NULL, 'Uncharacterized protein', 103, NULL, NULL, 104565),
(104566, '2.60.260.20-FF-000012', NULL, 'dnaJ protein homolog', 84, NULL, NULL, 104566),
(104567, '3.40.50.300-FF-000762', NULL, 'ATP-dependent helicase BRM', 190, NULL, NULL, 104567),
(104568, '2.30.30.30-FF-000037', NULL, 'Transcription termination/antitermination factor NusG', 57, NULL, NULL, 104568),
(104569, '1.10.10.10-FF-001888', NULL, 'TraR protein', 77, NULL, NULL, 104569),
(104570, '2.60.40.60-FF-000192', NULL, 'neural-cadherin isoform X8', 106, NULL, NULL, 104570),
(104571, '3.30.40.10-FF-001272', NULL, 'Uncharacterized protein', 75, NULL, NULL, 104571),
(104572, '3.30.160.60-FF-000761', NULL, 'Zinc finger protein 449', 27, NULL, NULL, 104572),
(104573, '2.60.40.10-FF-003982', NULL, NULL, 101, NULL, NULL, 104573),
(104574, '3.30.420.10-FF-000396', NULL, NULL, 229, NULL, NULL, 104574),
(104575, '2.10.50.10-FF-000157', NULL, 'Uncharacterized protein', 59, NULL, NULL, 104575),
(104576, '2.40.50.100-FF-000037', NULL, 'Molybdenum import ATP-binding protein ModC', 63, NULL, NULL, 104576),
(104577, '3.40.190.290-FF-000114', NULL, 'Putative transcriptional regulator', 206, NULL, NULL, 104577),
(104578, '3.30.565.10-FF-000310', NULL, 'Endoplasmin-like protein', 120, NULL, NULL, 104578),
(104579, '3.30.710.10-FF-000497', NULL, 'Uncharacterized protein', 130, NULL, NULL, 104579),
(104580, '1.10.510.10-FF-000634', NULL, 'Protein kinase C', 89, NULL, NULL, 104580),
(104581, '3.30.160.60-FF-004504', NULL, NULL, 72, NULL, NULL, 104581),
(104582, '3.90.1150.50-FF-000001', NULL, 'Transcription-repair-coupling factor', 148, NULL, NULL, 104582),
(104583, '1.20.120.350-FF-000091', NULL, 'Predicted protein', 141, NULL, NULL, 104583),
(104584, '1.20.120.330-FF-000023', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 158, NULL, NULL, 104584),
(104585, '1.25.40.10-FF-004245', NULL, 'Putative cargo-transport protein ypp1', 235, NULL, NULL, 104585),
(104586, '3.40.50.300-FF-004505', NULL, 'DNA repair helicase TFIIH P90', 228, NULL, NULL, 104586),
(104587, '3.30.160.60-FF-001104', NULL, 'gastrula zinc finger protein XlCGF57.1-like', 26, NULL, NULL, 104587),
(104588, '3.30.60.20-FF-000056', NULL, 'Uncharacterized protein, isoform C', 78, NULL, NULL, 104588),
(104589, '3.10.20.90-FF-000805', NULL, 'Serine/threonine-protein kinase OSR1', 32, NULL, NULL, 104589),
(104590, '1.10.533.10-FF-000237', NULL, 'Uncharacterized protein', 101, NULL, NULL, 104590),
(104591, '3.90.70.10-FF-000534', NULL, 'Ubiquitinyl hydrolase 1', 42, NULL, NULL, 104591),
(104592, '3.40.30.10-FF-000995', NULL, 'Uncharacterized protein', 77, NULL, NULL, 104592),
(104593, '1.10.472.170-FF-000022', NULL, 'Uncharacterized protein', 128, NULL, NULL, 104593),
(104594, '3.40.50.300-FF-003055', NULL, 'GTPase', 261, NULL, NULL, 104594),
(104595, '4.10.75.10-FF-000013', NULL, 'Perlwapin', 46, NULL, NULL, 104595),
(104596, '3.30.70.240-FF-000025', NULL, 'Transcription factor', 77, NULL, NULL, 104596),
(104597, '1.10.1660.60-FF-000001', NULL, 'Phage excisionase', 71, NULL, NULL, 104597),
(104598, '3.40.50.1000-FF-000594', NULL, NULL, 141, NULL, NULL, 104598),
(104599, '1.10.533.10-FF-000147', NULL, 'Uncharacterized protein', 95, NULL, NULL, 104599),
(104600, '3.30.497.10-FF-000084', NULL, 'Uncharacterized protein', 228, NULL, NULL, 104600),
(104601, '3.40.50.300-FF-000705', NULL, 'Endoribonuclease dicer-like protein', 241, NULL, NULL, 104601),
(104602, '3.40.50.300-FF-008434', NULL, 'CHL1-like protein', 89, NULL, NULL, 104602),
(104603, '1.10.238.10-FF-000624', NULL, 'Protein kinase, putative', 85, NULL, NULL, 104603),
(104604, '1.10.20.10-FF-000135', NULL, 'Transcription initiation factor TFIID subunit 11', 90, NULL, NULL, 104604),
(104605, '3.30.420.390-FF-000003', NULL, 'DNA polymerase gamma, mitochondrial', 95, NULL, NULL, 104605),
(104606, '3.40.50.1100-FF-000236', NULL, 'Uncharacterized protein', 56, NULL, NULL, 104606),
(104607, '1.50.40.10-FF-000578', NULL, 'Solute carrier family 25 member 38', 70, NULL, NULL, 104607);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(104608, '3.40.50.2000-FF-000321', NULL, 'Glycosyltransferase', 235, NULL, NULL, 104608),
(104609, '2.130.10.10-FF-004415', NULL, 'Uncharacterized protein', 443, NULL, NULL, 104609),
(104610, '3.30.60.30-FF-000059', NULL, 'SPARC (osteonectin), cwcv and kazal like domains proteoglycan 2', 30, NULL, NULL, 104610),
(104611, '1.20.1250.20-FF-001108', NULL, 'SCR1 protein', 398, NULL, NULL, 104611),
(104612, '1.10.238.10-FF-000534', NULL, 'Putative calcium-binding protein CML41', 41, NULL, NULL, 104612),
(104613, '1.10.10.10-FF-001798', NULL, 'Histone acetyltransferase', 25, NULL, NULL, 104613),
(104614, '1.25.40.20-FF-000448', NULL, 'ankyrin repeat domain-containing protein 50', 111, NULL, NULL, 104614),
(104615, '1.10.20.10-FF-000225', NULL, NULL, 75, NULL, NULL, 104615),
(104616, '3.60.21.10-FF-000147', NULL, 'Serine/threonine-protein phosphatase', 339, NULL, NULL, 104616),
(104617, '1.20.1070.10-FF-001338', NULL, 'AGAP011452-PA', 274, NULL, NULL, 104617),
(104618, '3.30.40.10-FF-001648', NULL, 'Uncharacterized protein', 59, NULL, NULL, 104618),
(104619, '2.60.120.10-FF-000499', NULL, 'Uncharacterized protein', 139, NULL, NULL, 104619),
(104620, '3.40.50.1820-FF-001380', NULL, 'Acyl-protein thioesterase 1', 222, NULL, NULL, 104620),
(104621, '3.30.540.10-FF-000051', NULL, 'Fructose-1,6-bisphosphatase class 1', 202, NULL, NULL, 104621),
(104622, '1.20.1300.10-FF-000031', NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', 128, NULL, NULL, 104622),
(104623, '3.40.50.300-FF-005000', NULL, 'Uncharacterized protein', 64, NULL, NULL, 104623),
(104624, '2.60.40.790-FF-000029', NULL, 'Putative heat shock protein beta-6', 106, NULL, NULL, 104624),
(104625, '2.60.40.10-FF-002964', NULL, 'C-Met receptor tyrosine kinase', 87, NULL, NULL, 104625),
(104626, '3.40.50.300-FF-006489', NULL, 'Os02g0749300 protein', 115, NULL, NULL, 104626),
(104627, '2.40.70.10-FF-000157', NULL, 'Plasmepsin VI', 170, NULL, NULL, 104627),
(104628, '3.10.620.10-FF-000005', NULL, 'Uncharacterized protein', 246, NULL, NULL, 104628),
(104629, '1.10.287.110-FF-000026', NULL, 'dnaJ homolog subfamily C member 8', 101, NULL, NULL, 104629),
(104630, '1.20.140.10-FF-000098', NULL, 'Uncharacterized protein', 60, NULL, NULL, 104630),
(104631, '1.20.1070.10-FF-001395', NULL, 'Predicted protein', 242, NULL, NULL, 104631),
(104632, '3.90.550.50-FF-000229', NULL, 'Hexosyltransferase', 121, NULL, NULL, 104632),
(104633, '3.30.70.120-FF-000045', NULL, NULL, 121, NULL, NULL, 104633),
(104634, '2.60.40.10-FF-002256', NULL, 'Interferon alpha/beta receptor 1a', 107, NULL, NULL, 104634),
(104635, '2.60.40.770-FF-000023', NULL, 'Phosphorylase B kinase alpha, kpb1, putative', 108, NULL, NULL, 104635),
(104636, '1.25.40.10-FF-001952', NULL, 'Pentatricopeptide repeat protein', 156, NULL, NULL, 104636),
(104637, '1.25.40.20-FF-001432', NULL, 'Uncharacterized protein', 167, NULL, NULL, 104637),
(104638, '3.40.109.10-FF-000052', NULL, 'Polyketide synthase/nonribosomal peptide synthetase hybrid RzxB', 216, NULL, NULL, 104638),
(104639, '3.80.10.10-FF-000110', NULL, 'Leucine-rich repeat serine/threonine-protein kinase 2', 163, NULL, NULL, 104639),
(104640, '3.30.160.100-FF-000014', NULL, 'Ribosome hibernation promoting factor', 103, NULL, NULL, 104640),
(104641, '2.30.30.40-FF-000248', NULL, 'Ephexin, isoform D', 63, NULL, NULL, 104641),
(104642, '2.130.10.10-FF-000609', NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', 158, NULL, NULL, 104642),
(104643, '3.40.50.720-FF-001562', NULL, 'Oxidoreductase', 247, NULL, NULL, 104643),
(104644, '1.20.80.10-FF-000003', NULL, 'Tyrosine-protein phosphatase non-receptor type 4', 108, NULL, NULL, 104644),
(104645, '3.40.50.150-FF-001071', NULL, 'AGAP007929-PA', 242, NULL, NULL, 104645),
(104646, '3.90.1180.10-FF-000036', NULL, NULL, 143, NULL, NULL, 104646),
(104647, '3.40.50.720-FF-002130', NULL, 'L-threonine dehydrogenase', 105, NULL, NULL, 104647),
(104648, '3.30.590.10-FF-000031', NULL, 'Gamma-glutamylanilide synthase', 357, NULL, NULL, 104648),
(104649, '3.30.160.60-FF-000553', NULL, 'Zinc finger and BTB domain-containing protein 16', 28, NULL, NULL, 104649);
INSERT INTO "PUBLIC"."MODEL" VALUES
(104650, '2.60.120.650-FF-000002', NULL, 'lysine-specific demethylase 6A isoform X2', 311, NULL, NULL, 104650),
(104651, '3.10.450.50-FF-000015', NULL, 'Ras GTPase-activating protein-binding protein 2', 136, NULL, NULL, 104651),
(104652, '1.20.1310.10-FF-000155', NULL, NULL, 82, NULL, NULL, 104652),
(104653, '3.40.50.300-FF-007299', NULL, 'Uncharacterized protein', 151, NULL, NULL, 104653),
(104654, '1.10.510.10-FF-000494', NULL, 'mitotic checkpoint serine/threonine-protein kinase BUB1 beta', 265, NULL, NULL, 104654),
(104655, '2.130.10.10-FF-004297', NULL, 'Uncharacterized protein', 120, NULL, NULL, 104655),
(104656, '3.90.550.10-FF-000206', NULL, 'Glycosyl transferase family 2', 231, NULL, NULL, 104656),
(104657, '1.10.10.10-FF-000163', NULL, 'MarR family transcriptional regulator', 142, NULL, NULL, 104657),
(104658, '3.30.1370.100-FF-000009', NULL, 'DNA mismatch repair protein PMS1', 39, NULL, NULL, 104658),
(104659, '2.60.40.150-FF-000017', NULL, 'Phosphoinositide phospholipase C', 163, NULL, NULL, 104659),
(104660, '3.60.21.10-FF-000355', NULL, 'Serine/threonine protein phosphatase, putative', 168, NULL, NULL, 104660),
(104661, '3.40.190.10-FF-000302', NULL, 'Phosphate ABC transporter substrate-binding protein', 136, NULL, NULL, 104661),
(104662, '3.40.630.10-FF-000319', NULL, 'Predicted protein', 209, NULL, NULL, 104662),
(104663, '3.10.20.90-FF-000188', NULL, 'Diacylglycerol kinase', 106, NULL, NULL, 104663),
(104664, '3.40.50.300-FF-006843', NULL, 'Cytosolic Fe-S cluster assembly factor NUBP1 homolog', 263, NULL, NULL, 104664),
(104665, '1.25.10.10-FF-002029', NULL, 'Uncharacterized protein', 230, NULL, NULL, 104665),
(104666, '3.90.226.10-FF-000094', NULL, 'Enoyl-CoA hydratase EchA2', 287, NULL, NULL, 104666),
(104667, '1.10.150.780-FF-000014', NULL, 'Uncharacterized protein', 74, NULL, NULL, 104667),
(104668, '4.10.1240.30-FF-000003', NULL, 'Integrin beta', 86, NULL, NULL, 104668),
(104669, '3.30.160.60-FF-002644', NULL, 'Zinc finger protein 337', 45, NULL, NULL, 104669),
(104670, '1.25.40.10-FF-004206', NULL, 'High chlorophyll fluorescence3', 68, NULL, NULL, 104670),
(104671, '1.20.5.110-FF-000278', NULL, 'TNF receptor-associated factor', 56, NULL, NULL, 104671),
(104672, '2.40.70.10-FF-000062', NULL, 'ASpartyl Protease', 167, NULL, NULL, 104672),
(104673, '3.40.50.1820-FF-001464', NULL, 'Carboxylic ester hydrolase', 514, NULL, NULL, 104673),
(104674, '1.10.520.10-FF-000045', NULL, 'Peroxidase', 120, NULL, NULL, 104674),
(104675, '1.20.58.390-FF-000266', NULL, 'Uncharacterized protein', 89, NULL, NULL, 104675),
(104676, '2.60.40.1400-FF-000002', NULL, 'ATP-sensitive inward rectifier potassium channel 1', 180, NULL, NULL, 104676),
(104677, '3.30.540.10-FF-000045', NULL, 'Inositol monophosphatase family protein', 136, NULL, NULL, 104677),
(104678, '1.10.10.60-FF-000071', NULL, 'Retinal homeobox gene 2', 67, NULL, NULL, 104678),
(104679, '3.40.50.300-FF-004752', NULL, 'Elongation factor G, mitochondrial', 166, NULL, NULL, 104679),
(104680, '2.60.120.200-FF-000002', NULL, 'Thrombospondin 3', 222, NULL, NULL, 104680),
(104681, '2.130.10.10-FF-002173', NULL, 'WD repeat domain 90', 137, NULL, NULL, 104681),
(104682, '2.10.25.10-FF-000739', NULL, 'Blast:Protein eyes shut', 41, NULL, NULL, 104682),
(104683, '1.10.510.10-FF-001011', NULL, 'CMGC/CDK protein kinase', 225, NULL, NULL, 104683),
(104684, '1.10.238.10-FF-000473', NULL, 'CDPK-related kinase 3', 82, NULL, NULL, 104684),
(104685, '3.30.40.10-FF-001884', NULL, 'Uncharacterized protein', 75, NULL, NULL, 104685),
(104686, '2.130.10.10-FF-000082', NULL, 'WD40 repeat-containing protein SMU1', 121, NULL, NULL, 104686),
(104687, '3.60.40.10-FF-000101', NULL, 'Stage II sporulation protein E', 228, NULL, NULL, 104687),
(104688, '3.30.160.60-FF-001216', NULL, 'Splicing factor 3A subunit 2', 46, NULL, NULL, 104688),
(104689, '3.30.230.70-FF-000146', NULL, 'Exosome component 5', 108, NULL, NULL, 104689),
(104690, '3.30.420.40-FF-000433', NULL, 'Heat shock protein family A (Hsp70) member 14', 100, NULL, NULL, 104690),
(104691, '3.10.450.40-FF-000012', NULL, 'Amine oxidase', 97, NULL, NULL, 104691);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(104692, '1.20.5.1160-FF-000006', NULL, 'Myosin-XVIIIa isoform a', 117, NULL, NULL, 104692),
(104693, '1.10.287.110-FF-000291', NULL, 'Putative dnaJ chaperone family protein', 52, NULL, NULL, 104693),
(104694, '3.20.170.30-FF-000002', NULL, 'Phosphotransferase, putative', 99, NULL, NULL, 104694),
(104695, '2.30.29.30-FF-000500', NULL, 'mRNA-decapping enzyme 1B', 136, NULL, NULL, 104695),
(104696, '3.40.50.1820-FF-001790', NULL, 'Lipase, endothelial', 164, NULL, NULL, 104696),
(104697, '3.30.420.110-FF-000055', NULL, 'Muts domain V-domain-containing protein', 155, NULL, NULL, 104697),
(104698, '1.10.510.10-FF-002197', NULL, 'Predicted protein', 265, NULL, NULL, 104698),
(104699, '3.30.160.60-FF-002318', NULL, 'zinc finger protein 837 isoform X2', 25, NULL, NULL, 104699),
(104700, '1.20.272.10-FF-000061', NULL, NULL, 92, NULL, NULL, 104700),
(104701, '1.20.140.150-FF-000017', NULL, 'Claudin-12 (Predicted)', 197, NULL, NULL, 104701),
(104702, '2.130.10.10-FF-002122', NULL, 'Transducin beta-like protein 3', 192, NULL, NULL, 104702),
(104703, '3.80.10.10-FF-001571', NULL, 'Internalin', 236, NULL, NULL, 104703),
(104704, '3.30.70.330-FF-000338', NULL, 'polyadenylate-binding protein 5', 96, NULL, NULL, 104704),
(104705, '2.130.10.10-FF-004246', NULL, 'Uncharacterized protein', 140, NULL, NULL, 104705),
(104706, '3.40.50.300-FF-003988', NULL, 'Helicase, putative', 181, NULL, NULL, 104706),
(104707, '3.30.300.150-FF-000006', NULL, NULL, 125, NULL, NULL, 104707),
(104708, '3.40.50.1820-FF-001559', NULL, 'Uncharacterized protein', 119, NULL, NULL, 104708),
(104709, '1.10.3720.10-FF-000155', NULL, 'ABC transporter, permease protein', 270, NULL, NULL, 104709),
(104710, '1.10.10.10-FF-000258', NULL, 'DeoR family transcriptional regulator', 66, NULL, NULL, 104710),
(104711, '1.10.238.10-FF-000422', NULL, 'Uncharacterized protein, isoform A', 111, NULL, NULL, 104711),
(104712, '3.40.47.10-FF-000241', NULL, NULL, 45, NULL, NULL, 104712),
(104713, '3.30.40.10-FF-001558', NULL, 'Protein CBG14325', 102, NULL, NULL, 104713),
(104714, '3.30.30.10-FF-000012', NULL, 'Defensin ARD1', 44, NULL, NULL, 104714),
(104715, '3.20.20.220-FF-000045', NULL, 'Methylenetetrahydrofolate reductase', 311, NULL, NULL, 104715),
(104716, '3.40.50.1820-FF-000896', NULL, 'Predicted protein', 202, NULL, NULL, 104716),
(104717, '1.20.120.1900-FF-000017', NULL, 'Spindle pole body protein, putative', 288, NULL, NULL, 104717),
(104718, '3.30.200.20-FF-000039', NULL, 'receptor-like protein kinase FERONIA', 112, NULL, NULL, 104718),
(104719, '3.40.50.1980-FF-000005', NULL, 'Vitamin B12-binding protein', 120, NULL, NULL, 104719),
(104720, '3.30.160.60-FF-000941', NULL, 'zinc finger protein ZFP69 isoform X2', 28, NULL, NULL, 104720),
(104721, '3.40.50.300-FF-001897', NULL, 'Myosin C', 183, NULL, NULL, 104721),
(104722, '2.60.40.10-FF-004235', NULL, NULL, 49, NULL, NULL, 104722),
(104723, '1.20.930.80-FF-000021', NULL, 'DNA primase large subunit', 54, NULL, NULL, 104723),
(104724, '3.40.640.10-FF-000152', NULL, 'Serine-pyruvate aminotransferase, putative', 249, NULL, NULL, 104724),
(104725, '3.90.780.10-FF-000015', NULL, 'Trifunctional nucleotide phosphoesterase protein YfkN', 210, NULL, NULL, 104725),
(104726, '3.30.70.330-FF-001980', NULL, NULL, 111, NULL, NULL, 104726),
(104727, '3.30.30.30-FF-000018', NULL, 'Unplaced genomic scaffold supercont2.9, whole genome shotgun sequence', 52, NULL, NULL, 104727),
(104728, '3.30.160.60-FF-004089', NULL, 'Si:dkey-89b17.4', 91, NULL, NULL, 104728),
(104729, '1.10.1420.10-FF-000143', NULL, 'Predicted protein', 157, NULL, NULL, 104729),
(104730, '3.10.450.320-FF-000010', NULL, 'Uncharacterized protein', 54, NULL, NULL, 104730),
(104731, '3.40.50.740-FF-000045', NULL, 'Acetylene hydratase', 305, NULL, NULL, 104731),
(104732, '2.60.40.10-FF-002144', NULL, 'MHC class I antigen ZEA transcript variant 1', 99, NULL, NULL, 104732),
(104733, '2.30.30.380-FF-000057', NULL, 'Thioredoxin family protein, selenocysteine-containing', 34, NULL, NULL, 104733),
(104734, '3.40.50.2300-FF-000433', NULL, 'Pilus assembly protein', 130, NULL, NULL, 104734);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(104735, '3.40.50.1970-FF-000002', NULL, 'Aldehyde-alcohol dehydrogenase', 192, NULL, NULL, 104735),
(104736, '3.40.50.720-FF-001236', NULL, 'Polysaccharide biosynthesis protein', 121, NULL, NULL, 104736),
(104737, '3.80.10.10-FF-001296', NULL, 'Uncharacterized protein', 78, NULL, NULL, 104737),
(104738, '2.70.170.10-FF-000303', NULL, 'Uncharacterized protein', 116, NULL, NULL, 104738),
(104739, '3.40.50.300-FF-008193', NULL, 'Uncharacterized protein', 76, NULL, NULL, 104739),
(104740, '2.60.40.60-FF-000832', NULL, 'CaDHerin family', 123, NULL, NULL, 104740),
(104741, '3.40.630.30-FF-000477', NULL, 'Acyl-CoA N-acyltransferase', 156, NULL, NULL, 104741),
(104742, '1.25.40.20-FF-000095', NULL, 'Ankyrin 2, isoform J', 295, NULL, NULL, 104742),
(104743, '1.25.10.10-FF-001692', NULL, 'ARM repeat-containing protein', 280, NULL, NULL, 104743),
(104744, '1.20.120.1760-FF-000054', NULL, NULL, 159, NULL, NULL, 104744),
(104745, '3.40.190.10-FF-000009', NULL, 'Putative glutamate receptor ionotropic NMDA 2B', 170, NULL, NULL, 104745),
(104746, '1.20.144.10-FF-000073', NULL, 'Phospholipid phosphatase 3', 150, NULL, NULL, 104746),
(104747, '3.90.640.10-FF-000005', NULL, 'Actin-related protein 2', 92, NULL, NULL, 104747),
(104748, '3.40.50.300-FF-006517', NULL, 'Uncharacterized protein', 111, NULL, NULL, 104748),
(104749, '3.90.1750.10-FF-000007', NULL, 'E3 ubiquitin-protein ligase SMURF2', 248, NULL, NULL, 104749),
(104750, '1.20.140.100-FF-000014', NULL, 'Putative dynein heavy chain', 190, NULL, NULL, 104750),
(104751, '3.90.550.10-FF-000420', NULL, 'Uncharacterized protein', 356, NULL, NULL, 104751),
(104752, '3.10.20.90-FF-000446', NULL, 'Ubiquitin fusion protein', 80, NULL, NULL, 104752),
(104753, '2.10.25.10-FF-001633', NULL, 'Uncharacterized protein', 49, NULL, NULL, 104753),
(104754, '3.30.160.60-FF-000227', NULL, 'fez family zinc finger protein 1', 29, NULL, NULL, 104754),
(104755, '3.90.550.10-FF-000532', NULL, 'Dolichyl-phosphate beta-D-mannosyltransferase', 142, NULL, NULL, 104755),
(104756, '3.30.70.330-FF-001592', NULL, NULL, 90, NULL, NULL, 104756),
(104757, '1.20.1510.10-FF-000041', NULL, 'Putative cation transporter', 196, NULL, NULL, 104757),
(104758, '1.20.120.1750-FF-000051', NULL, 'RBR-type E3 ubiquitin transferase', 188, NULL, NULL, 104758),
(104759, '2.30.30.40-FF-000574', NULL, 'Uncharacterized protein', 123, NULL, NULL, 104759),
(104760, '2.130.10.10-FF-000935', NULL, 'Small nucleolar ribonucleoprotein complex subunit, putative', 222, NULL, NULL, 104760),
(104761, '3.30.565.10-FF-000304', NULL, 'Two-component sensor kinase', 147, NULL, NULL, 104761),
(104762, '2.80.10.50-FF-000219', NULL, 'AAL050Wp', 200, NULL, NULL, 104762),
(104763, '2.70.220.10-FF-000010', NULL, 'Putative phosphatidylglycerol/phosphatidylinositol transfer protein 1', 63, NULL, NULL, 104763),
(104764, '3.40.1280.10-FF-000044', NULL, 'Variant surface glycoprotein (VSG), putative', 176, NULL, NULL, 104764),
(104765, '3.40.50.1240-FF-000076', NULL, 'Phosphoglycerate/bisphosphoglycerate mutase', 241, NULL, NULL, 104765),
(104766, '2.60.40.10-FF-000278', NULL, 'Protein-glutamine gamma-glutamyltransferase 2', 144, NULL, NULL, 104766),
(104767, '1.20.1070.10-FF-001754', NULL, 'Uncharacterized protein', 77, NULL, NULL, 104767),
(104768, '3.30.70.1230-FF-000199', NULL, 'Adenylate cyclase 3', 133, NULL, NULL, 104768),
(104769, '2.60.120.10-FF-000179', NULL, 'Cupin domain-containing protein', 104, NULL, NULL, 104769),
(104770, '3.40.50.150-FF-000177', NULL, 'THUMP domain containing 2, isoform CRA_b', 161, NULL, NULL, 104770),
(104771, '3.30.160.60-FF-004982', NULL, NULL, 75, NULL, NULL, 104771),
(104772, '3.30.70.2280-FF-000014', NULL, 'Uncharacterized protein', 78, NULL, NULL, 104772),
(104773, '1.10.780.10-FF-000002', NULL, 'Hydrazine oxidoreductase HzoB', 197, NULL, NULL, 104773),
(104774, '3.30.420.510-FF-000017', NULL, 'Patothenate kinase, fumble family protein', 148, NULL, NULL, 104774),
(104775, '4.10.400.10-FF-000159', NULL, 'Low-density lipoprotein receptor-related protein 2', 46, NULL, NULL, 104775),
(104776, '3.40.50.150-FF-000823', NULL, 'Catechol O-methyltransferase domain-containing protein 1', 228, NULL, NULL, 104776);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(104777, '3.30.60.30-FF-000172', NULL, 'Solute carrier organic anion transporter family member', 69, NULL, NULL, 104777),
(104778, '4.10.800.20-FF-000013', NULL, 'Adenosine monophosphate deaminase, putative', 97, NULL, NULL, 104778),
(104779, '3.40.50.10810-FF-000214', NULL, 'SWI/SNF chromatin remodeling complex component', 91, NULL, NULL, 104779),
(104780, '3.40.50.620-FF-000689', NULL, 'Asparagine synthase', 292, NULL, NULL, 104780),
(104781, '3.40.640.10-FF-000505', NULL, 'Uncharacterized protein', 69, NULL, NULL, 104781),
(104782, '3.40.50.300-FF-002835', NULL, 'Predicted protein', 239, NULL, NULL, 104782),
(104783, '1.20.1560.10-FF-000201', NULL, 'ABC transporter related', 313, NULL, NULL, 104783),
(104784, '1.25.10.10-FF-002181', NULL, 'Tubulin-folding cofactor D', 466, NULL, NULL, 104784),
(104785, '1.10.10.440-FF-000085', NULL, 'YALI0D02827p', 69, NULL, NULL, 104785),
(104786, '2.90.10.10-FF-000033', NULL, 'Serine/threonine-protein kinase', 95, NULL, NULL, 104786),
(104787, '3.30.9.10-FF-000244', NULL, 'Predicted protein', 31, NULL, NULL, 104787),
(104788, '2.20.70.10-FF-000225', NULL, 'E3 ubiquitin-protein ligase', 41, NULL, NULL, 104788),
(104789, '3.75.10.10-FF-000004', NULL, 'N(G),N(G)-dimethylarginine dimethylaminohydrolase 1', 268, NULL, NULL, 104789),
(104790, '2.170.130.10-FF-000024', NULL, 'Outer membrane protein', 138, NULL, NULL, 104790),
(104791, '1.10.2020.20-FF-000003', NULL, 'Proteasomal ubiquitin receptor ADRM1 homolog', 119, NULL, NULL, 104791),
(104792, '3.30.710.10-FF-000120', NULL, 'Bric a brac 2, isoform B', 138, NULL, NULL, 104792),
(104793, '1.20.58.70-FF-000003', NULL, 'Qa-SNARE, Sso1/Syntaxin1-type, SYP12A-group', 131, NULL, NULL, 104793),
(104794, '3.40.50.920-FF-000043', NULL, 'Thiamine diphosphate-binding protein', 133, NULL, NULL, 104794),
(104795, '3.40.1350.10-FF-000005', NULL, 'tRNA-splicing endonuclease subunit Sen2-1', 98, NULL, NULL, 104795),
(104796, '4.10.800.10-FF-000010', NULL, 'Insulin-like growth factor binding protein 6', 70, NULL, NULL, 104796),
(104797, '3.10.110.10-FF-000006', NULL, 'Ubiquitin-conjugating enzyme E2 Q2', 169, NULL, NULL, 104797),
(104798, '3.30.200.20-FF-002035', NULL, NULL, 91, NULL, NULL, 104798),
(104799, '2.40.50.100-FF-000076', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 78, NULL, NULL, 104799),
(104800, '3.40.50.2300-FF-000080', NULL, 'Two-component system response regulator BaeR', 81, NULL, NULL, 104800),
(104801, '3.40.50.1240-FF-000025', NULL, '6-phosphofructo-2-kinase 1', 221, NULL, NULL, 104801),
(104802, '3.40.50.1580-FF-000043', NULL, 'Purine nucleoside phosphorylase', 267, NULL, NULL, 104802),
(104803, '3.40.50.300-FF-007978', NULL, 'Uncharacterized protein', 159, NULL, NULL, 104803),
(104804, '1.10.240.10-FF-000012', NULL, 'Tyrosyl-tRNA synthetase', 125, NULL, NULL, 104804),
(104805, '2.160.20.10-FF-000171', NULL, 'Cell surface protein', 95, NULL, NULL, 104805),
(104806, '3.40.50.300-FF-008142', NULL, 'Uncharacterized protein', 97, NULL, NULL, 104806),
(104807, '3.40.50.12550-FF-000017', NULL, 'Uncharacterized protein', 56, NULL, NULL, 104807),
(104808, '3.40.50.1010-FF-000187', NULL, NULL, 119, NULL, NULL, 104808),
(104809, '2.60.40.10-FF-003133', NULL, 'High Incidence of Males (Increased X chromosome loss)', 90, NULL, NULL, 104809),
(104810, '3.90.550.10-FF-000471', NULL, 'Glycosyl transferase family 2', 217, NULL, NULL, 104810),
(104811, '1.20.58.60-FF-000500', NULL, 'Nesprin-1', 185, NULL, NULL, 104811),
(104812, '3.40.50.150-FF-000082', NULL, 'Ribosomal RNA small subunit methyltransferase D', 198, NULL, NULL, 104812),
(104813, '1.10.10.10-FF-000584', NULL, 'RNA polymerase sigma factor', 80, NULL, NULL, 104813),
(104814, '3.30.160.60-FF-003993', NULL, NULL, 48, NULL, NULL, 104814),
(104815, '3.20.20.80-FF-000836', NULL, '1,4-alpha-glucan-branching enzyme 2, chloroplastic/amyloplastic', 36, NULL, NULL, 104815),
(104816, '1.20.1050.10-FF-000117', NULL, 'Putative methionyl-tRNA synthetase', 110, NULL, NULL, 104816),
(104817, '3.40.50.720-FF-002225', NULL, 'uncharacterized protein LOC100184381', 103, NULL, NULL, 104817); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(104818, '3.80.10.10-FF-003920', NULL, 'Leucine-rich repeat protein (LRRP), putative', 101, NULL, NULL, 104818),
(104819, '1.10.390.10-FF-000079', NULL, 'Uncharacterized protein', 134, NULL, NULL, 104819),
(104820, '3.30.70.100-FF-000028', NULL, 'N-terminal EF-hand calcium-binding protein 2', 90, NULL, NULL, 104820),
(104821, '1.20.144.10-FF-000134', NULL, 'Uncharacterized protein', 102, NULL, NULL, 104821),
(104822, '2.30.29.30-FF-001282', NULL, 'Uncharacterized protein', 94, NULL, NULL, 104822),
(104823, '3.60.15.10-FF-000200', NULL, 'Ribonuclease Z 2, mitochondrial', 159, NULL, NULL, 104823),
(104824, '2.140.10.30-FF-000008', NULL, 'inactive dipeptidyl peptidase 10 isoform X2', 461, NULL, NULL, 104824),
(104825, '3.90.180.10-FF-000200', NULL, 'Asperfuranone polyketide synthase afoG', 137, NULL, NULL, 104825),
(104826, '2.60.40.2090-FF-000001', NULL, 'Minor fimbrium anchoring subunit Mfa2', 126, NULL, NULL, 104826),
(104827, '2.60.40.3440-FF-000001', NULL, 'Gamete expressed 2', 78, NULL, NULL, 104827),
(104828, '3.40.50.1000-FF-000184', NULL, 'Uncharacterized protein', 178, NULL, NULL, 104828),
(104829, '3.40.50.300-FF-005320', NULL, 'Altered inheritance of mitochondria protein 36, mitochondrial', 157, NULL, NULL, 104829),
(104830, '3.90.1300.10-FF-000013', NULL, 'Amd2p', 530, NULL, NULL, 104830),
(104831, '3.10.600.10-FF-000009', NULL, 'Predicted protein', 59, NULL, NULL, 104831),
(104832, '1.20.1250.20-FF-001855', NULL, 'Uncharacterized protein', 129, NULL, NULL, 104832),
(104833, '3.30.70.330-FF-001687', NULL, NULL, 81, NULL, NULL, 104833),
(104834, '2.60.40.1670-FF-000004', NULL, 'SEC24 homolog D, COPII coat complex component', 86, NULL, NULL, 104834),
(104835, '1.10.10.10-FF-001944', NULL, 'Uncharacterized protein', 85, NULL, NULL, 104835),
(104836, '2.10.25.10-FF-001133', NULL, 'GD22026', 71, NULL, NULL, 104836),
(104837, '3.30.70.330-FF-000131', NULL, 'Heterogeneous nuclear ribonucleoprotein h3 isoform', 81, NULL, NULL, 104837),
(104838, '3.40.50.300-FF-004426', NULL, 'Shikimate kinase', 171, NULL, NULL, 104838),
(104839, '3.90.960.10-FF-000001', NULL, 'Proline--tRNA ligase', 143, NULL, NULL, 104839),
(104840, '3.40.50.300-FF-002740', NULL, 'p-loop hydrolase', 131, NULL, NULL, 104840),
(104841, '3.40.120.10-FF-000028', NULL, 'GlcNAc phosphomutase', 90, NULL, NULL, 104841),
(104842, '3.40.1360.10-FF-000045', NULL, 'DNA primase domain protein', 133, NULL, NULL, 104842),
(104843, '1.10.10.60-FF-000424', NULL, 'ANTP homeobox protein', 73, NULL, NULL, 104843),
(104844, '2.30.29.30-FF-001068', NULL, 'Uncharacterized protein', 75, NULL, NULL, 104844),
(104845, '2.60.40.60-FF-000332', NULL, 'Fat-like cadherin-related tumor suppressor homolog', 104, NULL, NULL, 104845),
(104846, '1.10.472.10-FF-000180', NULL, 'Cyclin Dx', 113, NULL, NULL, 104846),
(104847, '1.10.238.10-FF-000147', NULL, 'Calbindin 1', 71, NULL, NULL, 104847),
(104848, '2.40.10.10-FF-000406', NULL, NULL, 142, NULL, NULL, 104848),
(104849, '2.130.10.10-FF-003111', NULL, 'Uncharacterized protein', 277, NULL, NULL, 104849),
(104850, '3.40.50.300-FF-003937', NULL, 'Ferrous iron transport protein B', 178, NULL, NULL, 104850),
(104851, '3.20.20.70-FF-000833', NULL, NULL, 125, NULL, NULL, 104851),
(104852, '3.90.1600.10-FF-000058', NULL, 'DNA polymerase epsilon catalytic subunit', 53, NULL, NULL, 104852),
(104853, '1.10.418.10-FF-000245', NULL, 'Uncharacterized protein', 110, NULL, NULL, 104853),
(104854, '4.10.1240.50-FF-000009', NULL, 'Protein CBR-LIN-40', 119, NULL, NULL, 104854),
(104855, '3.50.50.60-FF-000235', NULL, 'Glutathione reductase', 121, NULL, NULL, 104855),
(104856, '2.40.320.10-FF-000030', NULL, 'Mediator of RNA polymerase II transcription subunit 18', 257, NULL, NULL, 104856),
(104857, '2.60.40.1660-FF-000001', NULL, 'Sodium/potassium-transporting ATPase subunit beta', 275, NULL, NULL, 104857),
(104858, '3.30.70.330-FF-000810', NULL, 'heterogeneous nuclear ribonucleoprotein Q isoform X3', 59, NULL, NULL, 104858),
(104859, '3.30.160.60-FF-002739', NULL, NULL, 28, NULL, NULL, 104859),
(104860, '3.40.640.10-FF-000090', NULL, 'Pyridoxal phosphate-dependent aminotransferase', 244, NULL, NULL, 104860);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(104861, '2.60.40.10-FF-002318', NULL, 'Cytochrome c oxidase accessory protein CcoG', 115, NULL, NULL, 104861),
(104862, '3.40.50.300-FF-000262', NULL, 'Cytidylate kinase', 227, NULL, NULL, 104862),
(104863, '3.40.50.10260-FF-000004', NULL, 'yjeF N-terminal domain-containing protein 3', 233, NULL, NULL, 104863),
(104864, '3.30.530.20-FF-000137', NULL, 'Uncharacterized protein', 225, NULL, NULL, 104864),
(104865, '3.40.50.720-FF-001736', NULL, 'D-aspartate oxidase', 185, NULL, NULL, 104865),
(104866, '3.30.60.10-FF-000014', NULL, NULL, 52, NULL, NULL, 104866),
(104867, '2.40.33.10-FF-000037', NULL, 'Uncharacterized protein', 94, NULL, NULL, 104867),
(104868, '2.30.30.40-FF-000074', NULL, 'E3 ubiquitin-protein ligase HERC2 isoform X1', 76, NULL, NULL, 104868),
(104869, '3.80.10.10-FF-000222', NULL, 'F-box and leucine rich repeat protein 18', 216, NULL, NULL, 104869),
(104870, '2.30.30.110-FF-000004', NULL, 'mRNA interferase MazF4', 103, NULL, NULL, 104870),
(104871, '3.40.50.12590-FF-000001', NULL, 'ATP phosphoribosyltransferase regulatory subunit', 69, NULL, NULL, 104871),
(104872, '1.25.60.10-FF-000003', NULL, 'Transport transmembrane protein', 116, NULL, NULL, 104872),
(104873, '2.60.120.650-FF-000114', NULL, 'Os02g0109501 protein', 202, NULL, NULL, 104873),
(104874, '3.90.1150.10-FF-000130', NULL, 'Aspartate aminotransferase', 145, NULL, NULL, 104874),
(104875, '1.10.246.60-FF-000012', NULL, NULL, 79, NULL, NULL, 104875),
(104876, '3.90.1150.10-FF-000422', NULL, 'L-threonine aldolase, low-specificity, putative', 97, NULL, NULL, 104876),
(104877, '2.30.30.100-FF-000001', NULL, 'RNA-binding protein Hfq', 75, NULL, NULL, 104877),
(104878, '3.30.160.60-FF-000441', NULL, 'zinc finger protein 410 isoform X1', 29, NULL, NULL, 104878),
(104879, '1.10.1100.10-FF-000001', NULL, 'Transcription initiation factor TFIID subunit', 59, NULL, NULL, 104879),
(104880, '3.40.50.300-FF-001054', NULL, 'ATPase, AAA family, putative', 177, NULL, NULL, 104880),
(104881, '3.30.200.20-FF-002456', NULL, 'Uncharacterized protein', 56, NULL, NULL, 104881),
(104882, '3.40.630.30-FF-000505', NULL, 'Uncharacterized protein', 109, NULL, NULL, 104882),
(104883, '3.90.70.10-FF-000175', NULL, 'Ubiquitin carboxyl-terminal hydrolase 16', 221, NULL, NULL, 104883),
(104884, '3.40.50.11860-FF-000001', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 2', 103, NULL, NULL, 104884),
(104885, '3.30.60.20-FF-000017', NULL, 'Thymidine kinase', 45, NULL, NULL, 104885),
(104886, '1.20.990.10-FF-000049', NULL, 'Uncharacterized protein', 106, NULL, NULL, 104886),
(104887, '3.10.110.10-FF-000332', NULL, 'Predicted protein', 154, NULL, NULL, 104887),
(104888, '3.40.50.1000-FF-000263', NULL, 'Unplaced genomic scaffold supercont1.6, whole genome shotgun sequence', 144, NULL, NULL, 104888),
(104889, '2.60.120.560-FF-000008', NULL, 'Sucrose-6-phosphate hydrolase', 123, NULL, NULL, 104889),
(104890, '1.20.58.2010-FF-000003', NULL, 'Rop guanine nucleotide exchange factor 14', 236, NULL, NULL, 104890),
(104891, '2.130.10.10-FF-000205', NULL, 'BTB/POZ domain-containing protein KCTD3 isoform X1', 244, NULL, NULL, 104891),
(104892, '3.40.190.10-FF-000509', NULL, 'ABC transporter substrate-binding protein', 122, NULL, NULL, 104892),
(104893, '3.20.20.70-FF-000507', NULL, 'Uncharacterized protein', 427, NULL, NULL, 104893),
(104894, '3.40.33.10-FF-000092', NULL, 'Uncharacterized protein', 165, NULL, NULL, 104894),
(104895, '2.30.29.30-FF-001309', NULL, 'Predicted protein', 76, NULL, NULL, 104895),
(104896, '2.60.40.60-FF-000427', NULL, 'Protocadherin-15', 96, NULL, NULL, 104896),
(104897, '1.10.10.1230-FF-000002', NULL, 'Penicillin-binding protein 2B', 142, NULL, NULL, 104897),
(104898, '3.30.160.60-FF-004364', NULL, NULL, 74, NULL, NULL, 104898),
(104899, '2.140.10.10-FF-000002', NULL, 'Glucose dehydrogenase', 405, NULL, NULL, 104899),
(104900, '3.30.40.10-FF-001480', NULL, 'Uncharacterized protein', 121, NULL, NULL, 104900),
(104901, '1.25.10.10-FF-000438', NULL, 'Splicing factor 3B subunit 1', 368, NULL, NULL, 104901),
(104902, '3.90.1640.10-FF-000004', NULL, 'Prune exopolyphosphatase 1', 223, NULL, NULL, 104902);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(104903, '3.40.50.620-FF-000301', NULL, 'Probable electron transfer flavoprotein subunit alpha, mitochondrial', 190, NULL, NULL, 104903),
(104904, '2.40.170.20-FF-000049', NULL, 'TonB-dependent receptor', 531, NULL, NULL, 104904),
(104905, '1.10.506.10-FF-000096', NULL, 'Uncharacterized protein', 82, NULL, NULL, 104905),
(104906, '1.10.287.370-FF-000059', NULL, 'Uncharacterized protein', 140, NULL, NULL, 104906),
(104907, '2.60.120.330-FF-000075', NULL, 'Oxidoreductase, 2OG-Fe(II) oxygenase family, putative', 380, NULL, NULL, 104907),
(104908, '4.10.400.10-FF-000098', NULL, 'low-density lipoprotein receptor-related protein 4', 43, NULL, NULL, 104908),
(104909, '3.40.30.10-FF-001006', NULL, 'Uncharacterized protein', 69, NULL, NULL, 104909),
(104910, '3.30.160.60-FF-006067', NULL, NULL, 27, NULL, NULL, 104910),
(104911, '3.30.160.60-FF-002470', NULL, 'Zinc finger protein 59', 26, NULL, NULL, 104911),
(104912, '3.30.70.580-FF-000008', NULL, 'tRNA pseudouridine synthase A', 111, NULL, NULL, 104912),
(104913, '2.60.34.10-FF-000011', NULL, 'Heat shock protein hsp88', 157, NULL, NULL, 104913),
(104914, '2.40.10.10-FF-000114', NULL, 'Protein Z, vitamin K-dependent plasma glycoprotein', 100, NULL, NULL, 104914),
(104915, '1.10.620.20-FF-000033', NULL, 'Putative N-oxidase', 313, NULL, NULL, 104915),
(104916, '1.10.30.10-FF-000046', NULL, 'High mobility group box 4', 93, NULL, NULL, 104916),
(104917, '2.30.30.30-FF-000071', NULL, 'Ribosomal protein L24/L26-like protein', 107, NULL, NULL, 104917),
(104918, '3.30.40.10-FF-001772', NULL, 'Uncharacterized protein', 107, NULL, NULL, 104918),
(104919, '3.40.140.10-FF-000237', NULL, 'Mov34/MPN/PAD-1 family protein', 162, NULL, NULL, 104919),
(104920, '2.40.70.10-FF-000218', NULL, 'Uncharacterized protein', 130, NULL, NULL, 104920),
(104921, '3.30.160.60-FF-000727', NULL, 'Spalt-like transcription factor 3a', 24, NULL, NULL, 104921),
(104922, '2.130.10.10-FF-001958', NULL, 'Uncharacterized protein', 385, NULL, NULL, 104922),
(104923, '1.25.40.20-FF-001230', NULL, 'Ankyrin repeat and SOCS box-containing 2b', 149, NULL, NULL, 104923),
(104924, '3.30.230.70-FF-000034', NULL, 'Exosome complex component RRP42', 276, NULL, NULL, 104924),
(104925, '3.40.50.300-FF-004185', NULL, 'ABC transporter A family member 11', 256, NULL, NULL, 104925),
(104926, '3.30.70.1230-FF-000227', NULL, 'Uncharacterized protein', 202, NULL, NULL, 104926),
(104927, '2.60.40.10-FF-003779', NULL, NULL, 87, NULL, NULL, 104927),
(104928, '1.10.10.60-FF-000245', NULL, 'zinc finger homeobox protein 2', 64, NULL, NULL, 104928),
(104929, '2.60.40.1210-FF-000001', NULL, 'Monooxygenase, DBH-like 1, like', 155, NULL, NULL, 104929),
(104930, '3.30.160.380-FF-000019', NULL, NULL, 86, NULL, NULL, 104930),
(104931, '3.40.1230.10-FF-000007', NULL, 'NADH:Ubiquinone oxidoreductase Assembly Factor', 118, NULL, NULL, 104931),
(104932, '2.130.10.10-FF-000256', NULL, 'WD repeat and SOCS box containing 2', 84, NULL, NULL, 104932),
(104933, '2.102.10.10-FF-000027', NULL, 'Non-heme iron oxygenase ferredoxin subunit', 103, NULL, NULL, 104933),
(104934, '2.60.40.1220-FF-000004', NULL, 'Bacterial Ig-like domain, group 2', 109, NULL, NULL, 104934),
(104935, '1.20.5.340-FF-000055', NULL, 'Protein CBR-PKD-2', 55, NULL, NULL, 104935),
(104936, '3.40.800.10-FF-000041', NULL, NULL, 282, NULL, NULL, 104936),
(104937, '3.30.565.10-FF-000243', NULL, 'Sensor histidine kinase/response regulator, putative', 156, NULL, NULL, 104937),
(104938, '3.30.160.360-FF-000013', NULL, 'Methyl-CpG-binding domain 9', 110, NULL, NULL, 104938),
(104939, '2.60.40.1230-FF-000007', NULL, 'AP-2 complex subunit alpha, putative', 130, NULL, NULL, 104939),
(104940, '1.10.287.110-FF-000447', NULL, 'Predicted protein', 65, NULL, NULL, 104940),
(104941, '3.40.50.970-FF-000029', NULL, '2-succinyl-5-enolpyruvyl-6-hydroxy-3-cyclohexene-1-carboxylate synthase', 196, NULL, NULL, 104941),
(104942, '3.40.50.2000-FF-000433', NULL, 'Cytidylyltransferase domain protein', 131, NULL, NULL, 104942),
(104943, '2.10.25.10-FF-000970', NULL, 'Peptidase domain-containing-associated with muscle regeneration 1', 39, NULL, NULL, 104943);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(104944, '3.80.10.10-FF-001099', NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', 126, NULL, NULL, 104944),
(104945, '3.40.50.10310-FF-000014', NULL, 'Creatinine amidohydrolase', 259, NULL, NULL, 104945),
(104946, '3.40.50.720-FF-000213', NULL, 'Putative 2-hydroxyacid dehydrogenase', 185, NULL, NULL, 104946),
(104947, '3.40.800.20-FF-000044', NULL, 'Histone deacetylase B', 391, NULL, NULL, 104947),
(104948, '2.120.10.30-FF-000262', NULL, 'Predicted protein', 108, NULL, NULL, 104948),
(104949, '3.40.50.300-FF-004477', NULL, 'Uncharacterized protein', 236, NULL, NULL, 104949),
(104950, '3.40.50.300-FF-004926', NULL, 'Uncharacterized protein', 179, NULL, NULL, 104950),
(104951, '3.40.630.10-FF-000145', NULL, 'zinc carboxypeptidase', 299, NULL, NULL, 104951),
(104952, '1.10.10.10-FF-000319', NULL, 'RpiR family transcriptional regulator', 79, NULL, NULL, 104952),
(104953, '2.70.98.110-FF-000012', NULL, 'Glycoside hydrolase', 296, NULL, NULL, 104953),
(104954, '2.60.200.20-FF-000216', NULL, 'Peptidyl-prolyl cis-trans isomerase', 118, NULL, NULL, 104954),
(104955, '2.130.10.10-FF-004185', NULL, 'Uncharacterized protein', 161, NULL, NULL, 104955),
(104956, '4.10.220.110-FF-000002', NULL, 'Actin cross-linking toxin VgrG1', 64, NULL, NULL, 104956),
(104957, '3.90.70.10-FF-000821', NULL, 'Uncharacterized protein', 185, NULL, NULL, 104957),
(104958, '3.40.50.10810-FF-000153', NULL, 'Helicase, putative', 274, NULL, NULL, 104958),
(104959, '1.10.400.10-FF-000047', NULL, 'Uncharacterized protein', 119, NULL, NULL, 104959),
(104960, '2.40.70.10-FF-000269', NULL, 'Uncharacterized protein', 158, NULL, NULL, 104960),
(104961, '3.40.50.300-FF-006629', NULL, 'Uncharacterized protein', 91, NULL, NULL, 104961),
(104962, '3.40.50.1820-FF-001385', NULL, 'FI18305p1', 220, NULL, NULL, 104962),
(104963, '1.25.40.10-FF-000092', NULL, 'CCR4-NOT transcription complex subunit 10 isoform X1', 188, NULL, NULL, 104963),
(104964, '1.25.40.20-FF-000948', NULL, 'Uncharacterized protein', 128, NULL, NULL, 104964),
(104965, '1.25.10.10-FF-000590', NULL, 'Condensin complex subunit 3, variant', 339, NULL, NULL, 104965),
(104966, '2.60.40.2030-FF-000011', NULL, 'Fras1-related extracellular matrix protein 2', 127, NULL, NULL, 104966),
(104967, '3.40.30.10-FF-000843', NULL, 'Protein disulfide-isomerase', 120, NULL, NULL, 104967),
(104968, '3.30.200.20-FF-000270', NULL, 'Serine/threonine-protein kinase bur1', 88, NULL, NULL, 104968),
(104969, '1.10.238.10-FF-000394', NULL, 'Calcium-dependent protein kinase 3', 68, NULL, NULL, 104969),
(104970, '1.10.287.550-FF-000023', NULL, 'Predicted protein', 53, NULL, NULL, 104970),
(104971, '1.10.510.10-FF-000168', NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', 317, NULL, NULL, 104971),
(104972, '1.10.287.110-FF-000240', NULL, 'Chaperone DnaJ-domain superfamily protein', 98, NULL, NULL, 104972),
(104973, '1.10.150.20-FF-000300', NULL, 'DNA-directed RNA polymerase, mitochondrial', 197, NULL, NULL, 104973),
(104974, '3.40.350.10-FF-000051', NULL, 'Uncharacterized protein', 154, NULL, NULL, 104974),
(104975, '1.25.40.10-FF-000384', NULL, 'Probable pre-mRNA splicing factor prp1', 153, NULL, NULL, 104975),
(104976, '3.90.70.10-FF-000203', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 294, NULL, NULL, 104976),
(104977, '3.40.47.10-FF-000292', NULL, NULL, 145, NULL, NULL, 104977),
(104978, '2.70.150.10-FF-000128', NULL, 'E1-E2 ATPase superfamily protein', 113, NULL, NULL, 104978),
(104979, '1.25.40.20-FF-000387', NULL, 'Cortactin-binding protein 2', 143, NULL, NULL, 104979),
(104980, '3.30.200.20-FF-000118', NULL, 'Non-specific serine/threonine protein kinase', 99, NULL, NULL, 104980),
(104981, '3.30.70.870-FF-000040', NULL, 'Ribosome-releasing factor 2, mitochondrial', 50, NULL, NULL, 104981),
(104982, '1.10.8.60-FF-000446', NULL, 'ATP-dependent zinc metallopeptidase, putative', 51, NULL, NULL, 104982),
(104983, '1.10.8.270-FF-000070', NULL, 'TBC domain containing protein', 110, NULL, NULL, 104983),
(104984, '3.40.640.10-FF-000382', NULL, 'Uncharacterized protein', 119, NULL, NULL, 104984);
INSERT INTO "PUBLIC"."MODEL" VALUES
(104985, '1.25.10.10-FF-000882', NULL, 'E3 ubiquitin-protein ligase HUWE1', 255, NULL, NULL, 104985),
(104986, '1.10.238.10-FF-000068', NULL, 'SPARC isoform 1', 151, NULL, NULL, 104986),
(104987, '1.20.1440.200-FF-000007', NULL, 'Vacuolar protein sorting-associated protein 28 homolog', 98, NULL, NULL, 104987),
(104988, '2.60.40.10-FF-002470', NULL, 'polycystin-1 isoform X3', 101, NULL, NULL, 104988),
(104989, '3.30.70.330-FF-001766', NULL, NULL, 83, NULL, NULL, 104989),
(104990, '1.10.10.60-FF-001301', NULL, NULL, 52, NULL, NULL, 104990),
(104991, '2.130.10.10-FF-000823', NULL, 'Cell cycle control protein (Cwf8), putative', 287, NULL, NULL, 104991),
(104992, '2.170.270.10-FF-000034', NULL, 'Histone-lysine N-methyltransferase', 241, NULL, NULL, 104992),
(104993, '2.20.70.10-FF-000051', NULL, 'probable phosphoinositide phosphatase SAC9', 33, NULL, NULL, 104993),
(104994, '3.30.450.40-FF-000210', NULL, 'Sodium/solute symporter, GAF and PP2C family protein serine/threonine phosphatase domain protein', 158, NULL, NULL, 104994),
(104995, '3.30.1120.10-FF-000069', NULL, 'N-acetylgalactosamine 6-sulfatase (GALNS)', 75, NULL, NULL, 104995),
(104996, '2.130.10.10-FF-002852', NULL, 'Uncharacterized protein', 344, NULL, NULL, 104996),
(104997, '1.10.472.80-FF-000094', NULL, 'GTPase activating protein, putative', 147, NULL, NULL, 104997),
(104998, '3.40.50.10810-FF-000102', NULL, 'Chromosome organization and biogenesis-related protein, putative', 224, NULL, NULL, 104998),
(104999, '1.20.120.1900-FF-000085', NULL, 'Predicted protein', 148, NULL, NULL, 104999),
(105000, '3.50.80.10-FF-000008', NULL, 'Putative D-tyrosyl-tRNA(Tyr) deacylase 2', 183, NULL, NULL, 105000),
(105001, '3.90.550.10-FF-000178', NULL, '2-C-methyl-D-erythritol 4-phosphate cytidylyltransferase, putative', 93, NULL, NULL, 105001),
(105002, '1.20.1070.10-FF-000231', NULL, 'Allatostatin C receptor 1', 316, NULL, NULL, 105002),
(105003, '1.20.1250.20-FF-000220', NULL, 'Probable anion transporter 7', 192, NULL, NULL, 105003),
(105004, '3.40.50.10900-FF-000011', NULL, 'Proteasome assembly factor, putative', 194, NULL, NULL, 105004),
(105005, '1.20.58.70-FF-000115', NULL, 'Predicted protein', 126, NULL, NULL, 105005),
(105006, '3.50.50.100-FF-000036', NULL, 'NADH dehydrogenase', 404, NULL, NULL, 105006),
(105007, '4.10.400.10-FF-000047', NULL, 'Prolow-density lipoprotein receptor-related protein 1', 40, NULL, NULL, 105007),
(105008, '3.40.30.10-FF-000517', NULL, 'Glutathione peroxidase', 112, NULL, NULL, 105008),
(105009, '2.130.10.10-FF-004746', NULL, 'Uncharacterized protein', 161, NULL, NULL, 105009),
(105010, '3.30.70.330-FF-002255', NULL, NULL, 84, NULL, NULL, 105010),
(105011, '3.40.50.300-FF-002414', NULL, 'Nucleolar RNA helicase II, putative', 254, NULL, NULL, 105011),
(105012, '2.60.40.10-FF-001981', NULL, 'Titin homolog', 103, NULL, NULL, 105012),
(105013, '3.50.50.60-FF-000561', NULL, 'Hydrogen cyanide synthase subunit HcnC', 195, NULL, NULL, 105013),
(105014, '3.30.160.60-FF-004038', NULL, NULL, 27, NULL, NULL, 105014),
(105015, '3.10.430.100-FF-000013', NULL, '50S ribosomal protein L9', 87, NULL, NULL, 105015),
(105016, '2.40.50.1000-FF-000016', NULL, 'Uncharacterized protein', 77, NULL, NULL, 105016),
(105017, '1.20.200.10-FF-000013', NULL, 'Argininosuccinate lyase', 201, NULL, NULL, 105017),
(105018, '1.25.10.10-FF-002467', NULL, 'Plakophilin 4', 217, NULL, NULL, 105018),
(105019, '3.30.457.60-FF-000012', NULL, 'Uncharacterized protein', 85, NULL, NULL, 105019),
(105020, '1.10.274.30-FF-000023', NULL, 'Ci-male-specific lethal 3-like protein', 103, NULL, NULL, 105020),
(105021, '3.40.50.150-FF-001520', NULL, NULL, 106, NULL, NULL, 105021),
(105022, '3.30.70.2510-FF-000004', NULL, NULL, 153, NULL, NULL, 105022),
(105023, '3.90.550.10-FF-000706', NULL, 'Dolichyl-phosphate beta-glucosyltransferase', 276, NULL, NULL, 105023),
(105024, '1.25.40.10-FF-000171', NULL, 'protein sel-1 homolog 3 isoform X1', 129, NULL, NULL, 105024),
(105025, '1.20.1270.10-FF-000100', NULL, 'Heat shock protein', 111, NULL, NULL, 105025),
(105026, '2.60.40.1180-FF-000071', NULL, 'Probable glucan 1,3-alpha-glucosidase', 146, NULL, NULL, 105026);
INSERT INTO "PUBLIC"."MODEL" VALUES
(105027, '3.40.50.2000-FF-000107', NULL, 'Glycosyltransferase', 184, NULL, NULL, 105027),
(105028, '3.30.1060.10-FF-000013', NULL, NULL, 169, NULL, NULL, 105028),
(105029, '2.120.10.80-FF-000086', NULL, 'Kelch-like protein 4 isoform 1', 159, NULL, NULL, 105029),
(105030, '3.30.70.1450-FF-000001', NULL, 'Trk system potassium transporter TrkA', 91, NULL, NULL, 105030),
(105031, '2.60.40.10-FF-002195', NULL, 'Beta-mannosidase', 108, NULL, NULL, 105031),
(105032, '3.40.50.300-FF-008316', NULL, 'tRNA dimethylallyltransferase', 251, NULL, NULL, 105032),
(105033, '2.10.70.10-FF-000254', NULL, 'Pxn-1', 34, NULL, NULL, 105033),
(105034, '2.60.120.260-FF-000531', NULL, 'Uncharacterized protein', 90, NULL, NULL, 105034),
(105035, '2.60.40.790-FF-000153', NULL, NULL, 51, NULL, NULL, 105035),
(105036, '3.30.200.20-FF-001579', NULL, 'Uncharacterized protein', 70, NULL, NULL, 105036),
(105037, '1.10.10.60-FF-000812', NULL, NULL, 54, NULL, NULL, 105037),
(105038, '3.30.450.40-FF-000261', NULL, 'Heat-inducible transcription repressor HrcA', 149, NULL, NULL, 105038),
(105039, '1.10.1070.11-FF-000049', NULL, 'Ataxia telangiectasia mutated, putative', 187, NULL, NULL, 105039),
(105040, '1.10.287.1490-FF-000143', NULL, 'Viral A-type inclusion protein, putative', 175, NULL, NULL, 105040),
(105041, '2.60.210.10-FF-000006', NULL, 'Ubiquitin carboxyl-terminal hydrolase 7', 148, NULL, NULL, 105041),
(105042, '3.60.21.10-FF-000434', NULL, 'Uncharacterized protein', 237, NULL, NULL, 105042),
(105043, '3.30.70.330-FF-000052', NULL, 'Heterogeneous nuclear ribonucleoprotein L like', 94, NULL, NULL, 105043),
(105044, '3.80.10.10-FF-003095', NULL, 'Zgc:103424', 118, NULL, NULL, 105044),
(105045, '1.10.8.60-FF-000497', NULL, 'Predicted protein', 83, NULL, NULL, 105045),
(105046, '1.10.3730.20-FF-000035', NULL, 'Drug/metabolite transporter (DMT) superfamily permease', 107, NULL, NULL, 105046),
(105047, '2.40.50.140-FF-000240', NULL, 'Uncharacterized protein At4g28440', 108, NULL, NULL, 105047),
(105048, '3.30.60.60-FF-000017', NULL, 'Histone acetyltransferase', 60, NULL, NULL, 105048),
(105049, '1.25.10.10-FF-000264', NULL, 'Protein kinase family protein / WD-40 repeat family protein', 184, NULL, NULL, 105049),
(105050, '1.20.1420.30-FF-000023', NULL, 'Mitochondrial sodium/calcium exchanger protein', 126, NULL, NULL, 105050),
(105051, '2.130.10.10-FF-002234', NULL, 'F-box-like/WD repeat-containing protein TBL1XR1', 360, NULL, NULL, 105051),
(105052, '3.10.110.10-FF-000253', NULL, 'YALI0C02365p', 121, NULL, NULL, 105052),
(105053, '2.40.50.640-FF-000002', NULL, 'Exoribonuclease 2', 75, NULL, NULL, 105053),
(105054, '3.30.2160.10-FF-000009', NULL, 'E3 ubiquitin-protein ligase HECTD1 isoform X1', 53, NULL, NULL, 105054),
(105055, '3.30.1390.20-FF-000035', NULL, 'Uncharacterized protein', 104, NULL, NULL, 105055),
(105056, '3.30.930.10-FF-000148', NULL, 'Lysine--tRNA ligase', 372, NULL, NULL, 105056),
(105057, '4.10.60.10-FF-000136', NULL, 'Glycine-rich RNA-binding protein 10', 59, NULL, NULL, 105057),
(105058, '2.130.10.10-FF-001312', NULL, 'AGAP011387-PA', 350, NULL, NULL, 105058),
(105059, '2.40.70.10-FF-000011', NULL, 'Aspartic protease', 176, NULL, NULL, 105059),
(105060, '1.20.120.980-FF-000043', NULL, 'Dipeptidyl-peptidase 7', 20, NULL, NULL, 105060),
(105061, '3.90.1290.10-FF-000039', NULL, 'VAB-10A protein', 148, NULL, NULL, 105061),
(105062, '3.30.70.330-FF-002204', NULL, NULL, 107, NULL, NULL, 105062),
(105063, '1.20.120.1490-FF-000001', NULL, 'Cell-envelope stress modulator CpxP', 116, NULL, NULL, 105063),
(105064, '3.20.20.80-FF-000302', NULL, 'Galactolipid galactosyltransferase SFR2, chloroplastic', 416, NULL, NULL, 105064),
(105065, '3.90.1640.20-FF-000007', NULL, 'Uncharacterized protein', 320, NULL, NULL, 105065),
(105066, '2.40.50.140-FF-000801', NULL, NULL, 192, NULL, NULL, 105066),
(105067, '1.20.58.760-FF-000040', NULL, 'Uncharacterized protein', 135, NULL, NULL, 105067),
(105068, '3.40.850.10-FF-000302', NULL, 'Uncharacterized protein', 170, NULL, NULL, 105068),
(105069, '2.60.260.20-FF-000164', NULL, 'Uncharacterized protein', 66, NULL, NULL, 105069);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(105070, '2.10.25.10-FF-001307', NULL, 'Transmembrane cell adhesion receptor mua-3', 35, NULL, NULL, 105070),
(105071, '3.60.21.10-FF-000029', NULL, 'UDP-2,3-diacylglucosamine hydrolase', 248, NULL, NULL, 105071),
(105072, '1.25.10.10-FF-002416', NULL, 'Sister chromatid cohesion protein PDS5 homolog', 250, NULL, NULL, 105072),
(105073, '1.20.142.10-FF-000023', NULL, 'Predicted protein', 119, NULL, NULL, 105073),
(105074, '3.40.50.300-FF-006343', NULL, 'Predicted protein', 72, NULL, NULL, 105074),
(105075, '1.20.900.10-FF-000021', NULL, 'FERM, RhoGEF and pleckstrin domain-containing protein 1', 209, NULL, NULL, 105075),
(105076, '2.60.40.60-FF-000506', NULL, 'Predicted protein', 107, NULL, NULL, 105076),
(105077, '3.40.50.2300-FF-000321', NULL, 'Glutamate receptor 1', 46, NULL, NULL, 105077),
(105078, '3.30.40.10-FF-001154', NULL, 'RING-H2 finger protein ATL2L', 77, NULL, NULL, 105078),
(105079, '3.40.50.300-FF-000823', NULL, 'Small GTPase RAB, putative', 193, NULL, NULL, 105079),
(105080, '3.30.160.60-FF-004656', NULL, NULL, 29, NULL, NULL, 105080),
(105081, '1.10.287.90-FF-000025', NULL, 'Cytochrome c oxidase subunit II', 79, NULL, NULL, 105081),
(105082, '1.10.287.80-FF-000022', NULL, 'ATP synthase subunit gamma', 105, NULL, NULL, 105082),
(105083, '3.30.70.330-FF-001715', NULL, NULL, 113, NULL, NULL, 105083),
(105084, '2.160.20.10-FF-000103', NULL, 'Pectin methylesterase, putative', 265, NULL, NULL, 105084),
(105085, '3.40.50.720-FF-001348', NULL, 'Putative enoyl reductase MmyQ', 208, NULL, NULL, 105085),
(105086, '3.80.10.10-FF-003533', NULL, 'LOC100170568 protein', 166, NULL, NULL, 105086),
(105087, '1.10.510.10-FF-002472', NULL, NULL, 121, NULL, NULL, 105087),
(105088, '2.130.10.10-FF-000323', NULL, 'U4/U6 small nuclear ribonucleoprotein Prp4 isoform X1', 115, NULL, NULL, 105088),
(105089, '2.60.40.150-FF-000309', NULL, 'Uncharacterized protein', 128, NULL, NULL, 105089),
(105090, '1.25.40.990-FF-000072', NULL, 'AGAP008902-PA', 97, NULL, NULL, 105090),
(105091, '2.40.10.170-FF-000027', NULL, 'Uncharacterized protein', 36, NULL, NULL, 105091),
(105092, '3.50.7.10-FF-000032', NULL, 'Uncharacterized protein', 50, NULL, NULL, 105092),
(105093, '1.10.1900.40-FF-000003', NULL, 'Erythrocyte membrane protein 1', 73, NULL, NULL, 105093),
(105094, '1.10.3210.40-FF-000001', NULL, 'Integrating conjugative element relaxase, PFGI-1 class', 216, NULL, NULL, 105094),
(105095, '3.10.20.820-FF-000002', NULL, 'Fumarate reductase flavoprotein subunit', 94, NULL, NULL, 105095),
(105096, '2.170.260.10-FF-000028', NULL, 'Uncharacterized protein', 106, NULL, NULL, 105096),
(105097, '1.10.533.10-FF-000092', NULL, 'Netrin receptor unc-5', 97, NULL, NULL, 105097),
(105098, '1.10.10.10-FF-002057', NULL, 'Two component transcriptional regulator, winged helix family', 100, NULL, NULL, 105098),
(105099, '1.10.555.10-FF-000187', NULL, NULL, 150, NULL, NULL, 105099),
(105100, '3.40.50.150-FF-000795', NULL, 'tRNA (guanine(37)-N1)-methyltransferase', 120, NULL, NULL, 105100),
(105101, '2.60.40.150-FF-000247', NULL, 'Phosphoinositide phospholipase C', 129, NULL, NULL, 105101),
(105102, '1.25.40.540-FF-000021', NULL, 'Uncharacterized protein (Fragment)', 70, NULL, NULL, 105102),
(105103, '3.40.50.2300-FF-000203', NULL, 'LacI family transcriptional regulator', 127, NULL, NULL, 105103),
(105104, '2.10.25.10-FF-000969', NULL, 'Predicted protein', 37, NULL, NULL, 105104),
(105105, '3.30.40.10-FF-001654', NULL, 'Uncharacterized protein', 103, NULL, NULL, 105105),
(105106, '2.60.120.40-FF-000047', NULL, 'TNF superfamily member 13', 156, NULL, NULL, 105106),
(105107, '1.10.533.10-FF-000142', NULL, 'Uncharacterized protein', 86, NULL, NULL, 105107),
(105108, '3.30.420.40-FF-000141', NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase', 173, NULL, NULL, 105108),
(105109, '2.60.120.260-FF-000093', NULL, 'Alpha-L-fucosidase 1', 119, NULL, NULL, 105109),
(105110, '3.30.200.20-FF-000450', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 100, NULL, NULL, 105110),
(105111, '3.30.40.10-FF-000131', NULL, 'tyrosine-protein kinase BAZ1B isoform X1', 51, NULL, NULL, 105111);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(105112, '3.40.50.300-FF-004365', NULL, 'Dephospho-CoA kinase', 219, NULL, NULL, 105112),
(105113, '3.40.50.300-FF-006068', NULL, 'Putative ATP-binding cassette sub-family A member 11', 140, NULL, NULL, 105113),
(105114, '3.10.50.40-FF-000080', NULL, 'Peptidylprolyl isomerase', 117, NULL, NULL, 105114),
(105115, '2.160.10.10-FF-000013', NULL, 'Acetyltransferase', 104, NULL, NULL, 105115),
(105116, '3.90.228.10-FF-000008', NULL, 'Poly [ADP-ribose] polymerase', 190, NULL, NULL, 105116),
(105117, '2.80.10.50-FF-000158', NULL, 'Dolichyl-phosphate-mannose-protein mannosyltransferase', 217, NULL, NULL, 105117),
(105118, '2.60.260.20-FF-000158', NULL, 'Chaperone protein DnaJ', 111, NULL, NULL, 105118),
(105119, '3.30.160.60-FF-005050', NULL, NULL, 55, NULL, NULL, 105119),
(105120, '3.30.450.40-FF-000209', NULL, 'Sensor cyclic diguanylate phosphodiesterase, GAF and GAF domain-containing', 162, NULL, NULL, 105120),
(105121, '3.30.830.10-FF-000146', NULL, 'Metalloprotease, insulinase family', 283, NULL, NULL, 105121),
(105122, '3.30.200.20-FF-001967', NULL, 'Uncharacterized protein', 103, NULL, NULL, 105122),
(105123, '1.25.70.10-FF-000094', NULL, NULL, 236, NULL, NULL, 105123),
(105124, '1.10.630.10-FF-000845', NULL, 'Uncharacterized protein', 101, NULL, NULL, 105124),
(105125, '3.20.14.10-FF-000003', NULL, 'L-fucose isomerase', 140, NULL, NULL, 105125),
(105126, '1.20.120.1750-FF-000017', NULL, 'RBR-type E3 ubiquitin transferase', 68, NULL, NULL, 105126),
(105127, '2.10.25.10-FF-001015', NULL, 'Fibrillin-1', 44, NULL, NULL, 105127),
(105128, '2.130.10.10-FF-004538', NULL, 'Uncharacterized protein', 225, NULL, NULL, 105128),
(105129, '2.130.10.10-FF-002408', NULL, 'Uncharacterized protein', 347, NULL, NULL, 105129),
(105130, '2.170.120.12-FF-000020', NULL, 'RNA polymerase I and III subunit C', 93, NULL, NULL, 105130),
(105131, '2.70.170.10-FF-000242', NULL, 'Cholinergic receptor, nicotinic alpha 9', 213, NULL, NULL, 105131),
(105132, '3.40.50.720-FF-001854', NULL, '15-hydroxyprostaglandin dehydrogenase, putative', 180, NULL, NULL, 105132),
(105133, '3.40.30.10-FF-000282', NULL, 'thioredoxin domain-containing protein 5', 62, NULL, NULL, 105133),
(105134, '3.40.50.150-FF-001312', NULL, NULL, 297, NULL, NULL, 105134),
(105135, '3.30.40.10-FF-002261', NULL, 'TNF receptor-associated factor', 55, NULL, NULL, 105135),
(105136, '2.60.40.150-FF-000197', NULL, 'Protein BONZAI 1 isoform A', 121, NULL, NULL, 105136),
(105137, '2.60.40.10-FF-002970', NULL, 'Mesocentin', 113, NULL, NULL, 105137),
(105138, '3.30.160.60-FF-003021', NULL, 'Zinc finger protein 1144', 24, NULL, NULL, 105138),
(105139, '2.60.120.40-FF-000008', NULL, 'Tumor necrosis factor ligand superfamily member 11', 156, NULL, NULL, 105139),
(105140, '2.40.50.140-FF-000060', NULL, 'Ribosomal protein S12 methylthiotransferase RimO', 63, NULL, NULL, 105140),
(105141, '1.10.1420.10-FF-000047', NULL, 'DNA mismatch repair protein MutS', 148, NULL, NULL, 105141),
(105142, '2.60.40.10-FF-000671', NULL, 'Vascular cell adhesion molecule 1', 111, NULL, NULL, 105142),
(105143, '2.10.25.10-FF-001700', NULL, 'Uncharacterized protein', 63, NULL, NULL, 105143),
(105144, '3.40.50.300-FF-002920', NULL, 'Toprim domain-containing protein', 281, NULL, NULL, 105144),
(105145, '1.10.1170.10-FF-000050', NULL, 'Uncharacterized protein', 102, NULL, NULL, 105145),
(105146, '2.130.10.10-FF-004651', NULL, 'Gastrulation defective protein 1', 189, NULL, NULL, 105146),
(105147, '1.25.40.990-FF-000015', NULL, 'Leukocyte receptor cluster member 8', 247, NULL, NULL, 105147),
(105148, '2.40.30.10-FF-000177', NULL, 'Eukaryotic elongation factor, selenocysteine-tRNA-specific', 82, NULL, NULL, 105148),
(105149, '3.40.50.1110-FF-000099', NULL, 'Acetylxylan esterase', 219, NULL, NULL, 105149),
(105150, '1.20.1300.10-FF-000036', NULL, 'Succinate dehydrogenase membrane subunit, putative', 104, NULL, NULL, 105150),
(105151, '1.10.10.60-FF-000312', NULL, 'Mix-type homeobox gene 1', 65, NULL, NULL, 105151),
(105152, '2.60.40.1180-FF-000065', NULL, 'Isoamylase 2, chloroplastic', 115, NULL, NULL, 105152);
INSERT INTO "PUBLIC"."MODEL" VALUES
(105153, '3.40.50.300-FF-006394', NULL, 'Uncharacterized protein', 134, NULL, NULL, 105153),
(105154, '3.40.640.10-FF-000213', NULL, 'Putative serine--glyoxylate aminotransferase', 243, NULL, NULL, 105154),
(105155, '1.20.58.670-FF-000013', NULL, 'Exocyst complex component SEC15', 151, NULL, NULL, 105155),
(105156, '3.10.310.20-FF-000024', NULL, NULL, 137, NULL, NULL, 105156),
(105157, '3.30.160.60-FF-004156', NULL, 'Uncharacterized protein', 87, NULL, NULL, 105157),
(105158, '2.30.29.30-FF-000051', NULL, 'Serine/threonine-protein phosphatase 4 regulatory subunit 3B', 122, NULL, NULL, 105158),
(105159, '1.20.1070.10-FF-000001', NULL, 'Olfactory receptor', 300, NULL, NULL, 105159),
(105160, '2.60.120.330-FF-000193', NULL, 'Uncharacterized protein', 172, NULL, NULL, 105160),
(105161, '3.10.100.10-FF-000101', NULL, 'C-type lectin domain family 12 member B', 145, NULL, NULL, 105161),
(105162, '2.60.40.1170-FF-000062', NULL, 'Coatomer subunit delta', 121, NULL, NULL, 105162),
(105163, '2.60.40.10-FF-005567', NULL, NULL, 109, NULL, NULL, 105163),
(105164, '1.20.1250.20-FF-001288', NULL, 'Phthalate transporter, putative', 105, NULL, NULL, 105164),
(105165, '3.30.70.330-FF-001148', NULL, 'RNA recognition domain-containing protein (RRM)-containing protein', 139, NULL, NULL, 105165),
(105166, '2.10.110.10-FF-000201', NULL, 'Transforming growth factor beta 1-induced transcript 1', 61, NULL, NULL, 105166),
(105167, '3.30.160.60-FF-000845', NULL, 'C2H2 type conidiation transcription factor BrlA', 26, NULL, NULL, 105167),
(105168, '2.60.120.20-FF-000002', NULL, 'Genome polyprotein', 237, NULL, NULL, 105168),
(105169, '3.40.50.11380-FF-000014', NULL, NULL, 179, NULL, NULL, 105169),
(105170, '1.10.150.20-FF-000221', NULL, 'Uncharacterized protein', 59, NULL, NULL, 105170),
(105171, '3.90.290.10-FF-000028', NULL, 'Fibrillin-1', 69, NULL, NULL, 105171),
(105172, '2.70.70.10-FF-000026', NULL, 'Peptidase M23', 132, NULL, NULL, 105172),
(105173, '1.10.290.10-FF-000009', NULL, 'DNA topoisomerase', 80, NULL, NULL, 105173),
(105174, '3.90.1410.10-FF-000072', NULL, 'Uncharacterized protein', 240, NULL, NULL, 105174),
(105175, '1.10.287.1490-FF-000109', NULL, 'Viral A-type inclusion protein, putative', 160, NULL, NULL, 105175),
(105176, '2.30.30.400-FF-000001', NULL, 'Rho-dependent transcription termination (ROF)', 77, NULL, NULL, 105176),
(105177, '3.40.50.2300-FF-001338', NULL, NULL, 74, NULL, NULL, 105177),
(105178, '1.25.40.10-FF-002407', NULL, 'Os01g0959600 protein', 134, NULL, NULL, 105178),
(105179, '3.40.50.720-FF-000331', NULL, 'Retinol dehydrogenase 14 (All-trans/9-cis/11-cis)', 297, NULL, NULL, 105179),
(105180, '2.40.10.10-FF-000440', NULL, NULL, 116, NULL, NULL, 105180),
(105181, '1.10.10.1830-FF-000002', NULL, 'Putative siderophore biosysnthesis protein', 52, NULL, NULL, 105181),
(105182, '3.40.50.1100-FF-000096', NULL, 'Related to cysteine synthase', 234, NULL, NULL, 105182),
(105183, '2.130.10.10-FF-002560', NULL, 'Predicted protein', 471, NULL, NULL, 105183),
(105184, '1.25.40.10-FF-000266', NULL, 'Pentatricopeptide repeat domain-containing protein', 196, NULL, NULL, 105184),
(105185, '3.30.40.10-FF-001266', NULL, 'Uncharacterized protein', 79, NULL, NULL, 105185),
(105186, '3.40.50.300-FF-006551', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', 105, NULL, NULL, 105186),
(105187, '3.30.160.60-FF-002026', NULL, 'Zinc finger protein 160', 29, NULL, NULL, 105187),
(105188, '3.40.50.11370-FF-000011', NULL, 'Inositol-tetrakisphosphate 1-kinase', 103, NULL, NULL, 105188),
(105189, '4.10.1240.10-FF-000076', NULL, 'Uncharacterized protein', 65, NULL, NULL, 105189),
(105190, '3.80.10.10-FF-001116', NULL, 'Toll-like receptor 7', 225, NULL, NULL, 105190),
(105191, '1.10.730.10-FF-000151', NULL, 'Leucyl-tRNA synthetase', 22, NULL, NULL, 105191),
(105192, '3.30.200.20-FF-000124', NULL, 'Cyclin-dependent kinase 4', 92, NULL, NULL, 105192),
(105193, '3.90.70.200-FF-000022', NULL, 'Predicted protein', 131, NULL, NULL, 105193),
(105194, '3.80.10.10-FF-001184', NULL, 'Acid labile subunit', 198, NULL, NULL, 105194);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(105195, '3.30.200.20-FF-002248', NULL, 'Uncharacterized protein', 28, NULL, NULL, 105195),
(105196, '3.40.50.300-FF-007799', NULL, 'MutS domain V domaincontaining protein', 45, NULL, NULL, 105196),
(105197, '2.60.40.60-FF-000950', NULL, 'Predicted protein', 108, NULL, NULL, 105197),
(105198, '2.20.70.10-FF-000113', NULL, 'Clustered-asparagine-rich protein', 29, NULL, NULL, 105198),
(105199, '2.40.160.120-FF-000058', NULL, 'Uncharacterized protein', 82, NULL, NULL, 105199),
(105200, '1.10.287.110-FF-000352', NULL, 'Uncharacterized protein', 97, NULL, NULL, 105200),
(105201, '1.20.1250.20-FF-001552', NULL, 'MFS tranporter, putative (AFU_orthologue AFUA_7G06830)', 408, NULL, NULL, 105201),
(105202, '3.40.50.170-FF-000003', NULL, 'Methionyl-tRNA formyltransferase', 209, NULL, NULL, 105202),
(105203, '1.10.3430.10-FF-000048', NULL, 'Uncharacterized protein', 344, NULL, NULL, 105203),
(105204, '2.170.270.10-FF-000208', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-9 specific', 270, NULL, NULL, 105204),
(105205, '3.30.2170.10-FF-000016', NULL, NULL, 214, NULL, NULL, 105205),
(105206, '3.90.70.10-FF-000793', NULL, 'Uncharacterized protein', 327, NULL, NULL, 105206),
(105207, '3.30.930.10-FF-000356', NULL, 'ATP phosphoribosyltransferase regulatory subunit', 317, NULL, NULL, 105207),
(105208, '3.60.15.10-FF-000021', NULL, 'Ribonuclease J', 269, NULL, NULL, 105208),
(105209, '1.10.8.720-FF-000042', NULL, 'Dynein heavy chain', 177, NULL, NULL, 105209),
(105210, '3.40.50.300-FF-004308', NULL, 'Uncharacterized protein', 53, NULL, NULL, 105210),
(105211, '3.30.70.330-FF-001480', NULL, 'AGAP003170-PA', 95, NULL, NULL, 105211),
(105212, '2.130.10.10-FF-002740', NULL, 'Katanin, putative', 277, NULL, NULL, 105212),
(105213, '3.40.50.1000-FF-000712', NULL, NULL, 97, NULL, NULL, 105213),
(105214, '2.60.120.10-FF-000297', NULL, 'Mannose-6-phosphate isomerase', 82, NULL, NULL, 105214),
(105215, '3.20.20.70-FF-000558', NULL, 'Fructose-bisphosphate aldolase', 362, NULL, NULL, 105215),
(105216, '3.40.50.300-FF-004213', NULL, 'Protein CBR-MRP-3', 70, NULL, NULL, 105216),
(105217, '1.10.3720.10-FF-000216', NULL, 'ABC transporter, permease protein, cysTW family', 197, NULL, NULL, 105217),
(105218, '1.25.10.10-FF-002063', NULL, 'Uncharacterized protein', 263, NULL, NULL, 105218),
(105219, '1.20.1250.40-FF-000046', NULL, 'Peptide-receptor component', 99, NULL, NULL, 105219),
(105220, '2.40.30.10-FF-000441', NULL, 'Elongation factor Tu', 53, NULL, NULL, 105220),
(105221, '3.10.490.10-FF-000039', NULL, 'Gamma-glutamylcyclotransferase', 182, NULL, NULL, 105221),
(105222, '3.40.50.12230-FF-000011', NULL, 'Uncharacterized protein', 184, NULL, NULL, 105222),
(105223, '3.40.50.720-FF-001118', NULL, '6-phosphogluconate dehydrogenase, decarboxylating', 184, NULL, NULL, 105223),
(105224, '1.10.510.10-FF-004271', NULL, NULL, 299, NULL, NULL, 105224),
(105225, '3.10.100.10-FF-000163', NULL, 'Mannose binding lectin 2', 142, NULL, NULL, 105225),
(105226, '1.10.510.10-FF-002085', NULL, 'Uncharacterized protein', 268, NULL, NULL, 105226),
(105227, '1.20.1070.10-FF-002125', NULL, 'Uncharacterized protein', 367, NULL, NULL, 105227),
(105228, '3.30.750.24-FF-000164', NULL, 'Sodium-independent sulfate anion transporter-like Protein', 100, NULL, NULL, 105228),
(105229, '4.10.640.10-FF-000036', NULL, 'Uncharacterized protein', 47, NULL, NULL, 105229),
(105230, '2.120.10.80-FF-000114', NULL, 'Kelch domain containing 2', 146, NULL, NULL, 105230),
(105231, '1.25.40.10-FF-004661', NULL, 'Uncharacterized protein', 114, NULL, NULL, 105231),
(105232, '1.10.1370.20-FF-000001', NULL, 'Oligoendopeptidase F', 373, NULL, NULL, 105232),
(105233, '3.10.20.90-FF-000800', NULL, 'Uncharacterized protein', 79, NULL, NULL, 105233),
(105234, '1.10.132.60-FF-000045', NULL, 'DNA polymerase', 60, NULL, NULL, 105234),
(105235, '1.10.3480.10-FF-000001', NULL, 'Nitrate reductase molybdenum cofactor assembly chaperone', 147, NULL, NULL, 105235),
(105236, '2.30.180.10-FF-000195', NULL, NULL, 100, NULL, NULL, 105236),
(105237, '3.20.20.10-FF-000063', NULL, 'Pyridoxal phosphate homeostasis protein', 228, NULL, NULL, 105237);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(105238, '2.60.40.10-FF-002762', NULL, 'Uncharacterized protein', 130, NULL, NULL, 105238),
(105239, '1.10.1450.10-FF-000083', NULL, 'TetraSPanin family', 101, NULL, NULL, 105239),
(105240, '2.60.40.10-FF-002705', NULL, 'von Willebrand factor A domain containing 1', 104, NULL, NULL, 105240),
(105241, '2.40.40.20-FF-000063', NULL, 'NADH dehydrogenase I, G subunit', 110, NULL, NULL, 105241),
(105242, '1.10.238.200-FF-000027', NULL, 'DCN1-like protein', 45, NULL, NULL, 105242),
(105243, '3.30.160.60-FF-006455', NULL, NULL, 20, NULL, NULL, 105243),
(105244, '1.25.40.70-FF-000082', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', 107, NULL, NULL, 105244),
(105245, '1.25.40.10-FF-002295', NULL, 'Predicted protein', 147, NULL, NULL, 105245),
(105246, '3.90.1480.20-FF-000023', NULL, 'ST6 (alpha-N-acetyl-neuraminyl-2,3-beta-galactosyl-1,3)-N-acetylgalactosaminide alpha-2,6-sialyltransferase 6', 243, NULL, NULL, 105246),
(105247, '1.10.730.10-FF-000212', NULL, 'Uncharacterized protein', 162, NULL, NULL, 105247),
(105248, '2.170.150.80-FF-000029', NULL, 'Uncharacterized protein', 104, NULL, NULL, 105248),
(105249, '2.60.40.10-FF-000553', NULL, 'Uncharacterized protein, isoform J', 99, NULL, NULL, 105249),
(105250, '1.20.5.190-FF-000178', NULL, NULL, 39, NULL, NULL, 105250),
(105251, '3.40.50.1480-FF-000013', NULL, 'Adenosylhomocysteinase', 93, NULL, NULL, 105251),
(105252, '3.30.500.10-FF-000048', NULL, NULL, 94, NULL, NULL, 105252),
(105253, '3.10.580.20-FF-000010', NULL, 'Chloride channel protein', 90, NULL, NULL, 105253),
(105254, '1.10.10.60-FF-000520', NULL, 'homeobox protein VENTX', 96, NULL, NULL, 105254),
(105255, '3.40.605.10-FF-000082', NULL, 'Succinate-semialdehyde dehydrogenase, mitochondrial', 225, NULL, NULL, 105255),
(105256, '1.10.287.70-FF-000699', NULL, 'Voltage-dependent N-type calcium channel subunit alpha', 151, NULL, NULL, 105256),
(105257, '1.10.238.10-FF-000708', NULL, 'Uncharacterized protein', 118, NULL, NULL, 105257),
(105258, '3.30.160.60-FF-000492', NULL, 'Zinc finger and BTB domain containing 10', 47, NULL, NULL, 105258),
(105259, '3.90.550.50-FF-000027', NULL, 'Hexosyltransferase', 238, NULL, NULL, 105259),
(105260, '3.30.559.30-FF-000077', NULL, 'Nonribosomal peptide synthase nlsA', 233, NULL, NULL, 105260),
(105261, '1.10.630.10-FF-000727', NULL, 'Cytochrome P450, putative', 96, NULL, NULL, 105261),
(105262, '3.90.1140.10-FF-000039', NULL, 'DUF455 domain-containing protein', 60, NULL, NULL, 105262),
(105263, '2.30.30.40-FF-000309', NULL, 'Purine-binding chemotaxis protein CheW', 58, NULL, NULL, 105263),
(105264, '3.20.20.70-FF-000715', NULL, NULL, 124, NULL, NULL, 105264),
(105265, '3.40.50.1470-FF-000010', NULL, 'CRS2-like protein, chloroplastic', 138, NULL, NULL, 105265),
(105266, '1.10.510.10-FF-000960', NULL, 'Protein CBG19102', 200, NULL, NULL, 105266),
(105267, '2.60.120.260-FF-000205', NULL, 'Uncharacterized protein', 151, NULL, NULL, 105267),
(105268, '1.20.1070.10-FF-001193', NULL, 'Uncharacterized protein', 143, NULL, NULL, 105268),
(105269, '1.20.1070.10-FF-001136', NULL, 'Uncharacterized protein', 300, NULL, NULL, 105269),
(105270, '3.30.40.10-FF-001446', NULL, 'Predicted protein', 83, NULL, NULL, 105270),
(105271, '1.10.1200.10-FF-000065', NULL, 'Peptide synthetase', 82, NULL, NULL, 105271),
(105272, '2.60.40.10-FF-000339', NULL, 'Plexin A2', 87, NULL, NULL, 105272),
(105273, '3.90.76.10-FF-000019', NULL, 'ABC transporter substrate-binding protein', 148, NULL, NULL, 105273),
(105274, '2.30.29.30-FF-001186', NULL, 'Uncharacterized protein', 107, NULL, NULL, 105274),
(105275, '1.10.472.130-FF-000022', NULL, 'Dynein heavy chain 6, axonemal', 145, NULL, NULL, 105275),
(105276, '3.30.200.20-FF-000770', NULL, 'SRSF protein kinase 2', 90, NULL, NULL, 105276),
(105277, '2.130.10.10-FF-002622', NULL, 'WD40 repeat-containing protein DDB_G0271002', 273, NULL, NULL, 105277),
(105278, '3.40.30.10-FF-000489', NULL, 'Uncharacterized protein', 82, NULL, NULL, 105278),
(105279, '2.40.30.10-FF-000065', NULL, '50S ribosomal protein L3, chloroplastic', 81, NULL, NULL, 105279);
INSERT INTO "PUBLIC"."MODEL" VALUES
(105280, '2.30.29.30-FF-000579', NULL, 'Kinesin, putative', 123, NULL, NULL, 105280),
(105281, '1.10.510.10-FF-002646', NULL, 'Serine/threonine-protein kinase chk-2', 312, NULL, NULL, 105281),
(105282, '3.40.190.10-FF-000223', NULL, 'Prephenate dehydratase', 86, NULL, NULL, 105282),
(105283, '1.25.10.10-FF-000343', NULL, 'RING-type E3 ubiquitin transferase', 100, NULL, NULL, 105283),
(105284, '1.10.540.10-FF-000057', NULL, 'L-prolyl-[peptidyl carrier protein] dehydrogenase', 116, NULL, NULL, 105284),
(105285, '2.60.40.10-FF-000396', NULL, 'Fibronectin type III domain containing 3B', 101, NULL, NULL, 105285),
(105286, '2.130.10.10-FF-000531', NULL, 'Probable catabolite repression protein creC', 443, NULL, NULL, 105286),
(105287, '3.30.420.10-FF-000598', NULL, NULL, 194, NULL, NULL, 105287),
(105288, '1.20.1070.10-FF-002030', NULL, 'Uncharacterized protein', 121, NULL, NULL, 105288),
(105289, '1.20.1310.10-FF-000216', NULL, NULL, 84, NULL, NULL, 105289),
(105290, '1.10.1600.10-FF-000033', NULL, 'Uncharacterized protein', 98, NULL, NULL, 105290),
(105291, '3.40.50.300-FF-000503', NULL, 'Peptide chain release factor subunit 3', 248, NULL, NULL, 105291),
(105292, '3.80.10.10-FF-001392', NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', 94, NULL, NULL, 105292),
(105293, '1.25.40.10-FF-000058', NULL, 'Pre-mRNA processing factor 6', 215, NULL, NULL, 105293),
(105294, '3.30.160.150-FF-000001', NULL, 'LPS-assembly lipoprotein LptE', 154, NULL, NULL, 105294),
(105295, '2.60.120.10-FF-000584', NULL, 'Crp/Fnr family transcriptional regulator', 133, NULL, NULL, 105295),
(105296, '3.40.50.300-FF-004831', NULL, 'YALI0F04356p', 272, NULL, NULL, 105296),
(105297, '2.60.40.1510-FF-000035', NULL, 'Integrin beta', 75, NULL, NULL, 105297),
(105298, '2.30.30.40-FF-000366', NULL, 'LIM and SH3 protein', 59, NULL, NULL, 105298),
(105299, '3.30.160.60-FF-000435', NULL, 'Zinc finger protein 827', 46, NULL, NULL, 105299),
(105300, '2.30.42.10-FF-000244', NULL, 'Uncharacterized protein, isoform A', 96, NULL, NULL, 105300),
(105301, '2.130.10.10-FF-002329', NULL, 'p21-activated protein kinase-interacting protein 1-like', 132, NULL, NULL, 105301),
(105302, '1.10.3210.10-FF-000122', NULL, 'Putative GTP diphosphokinase RSH2 chloroplastic', 48, NULL, NULL, 105302),
(105303, '1.10.533.10-FF-000024', NULL, 'caspase-2 isoform X1', 98, NULL, NULL, 105303),
(105304, '3.30.70.330-FF-002704', NULL, NULL, 164, NULL, NULL, 105304),
(105305, '3.40.50.300-FF-002386', NULL, 'Similar to mitochondrial ATPase (Afg1)', 159, NULL, NULL, 105305),
(105306, '1.25.40.10-FF-002418', NULL, 'Pre-mRNA-processing factor 6-like Protein', 223, NULL, NULL, 105306),
(105307, '1.10.510.10-FF-002028', NULL, NULL, 89, NULL, NULL, 105307),
(105308, '3.30.200.20-FF-000562', NULL, 'STE20/SPS1-related proline-alanine-rich protein kinase', 80, NULL, NULL, 105308),
(105309, '2.60.40.150-FF-000129', NULL, 'Synaptotagmin 12', 133, NULL, NULL, 105309),
(105310, '2.10.25.10-FF-001425', NULL, 'mannan-binding lectin serine protease 1-like', 53, NULL, NULL, 105310),
(105311, '3.20.20.300-FF-000030', NULL, 'Os05g0449600 protein', 318, NULL, NULL, 105311),
(105312, '1.10.506.10-FF-000057', NULL, 'Probable Ras GTPase-activating-like protein ngap', 115, NULL, NULL, 105312),
(105313, '3.40.50.1820-FF-000778', NULL, 'Esterase/lipase-like protein', 259, NULL, NULL, 105313),
(105314, '3.30.1640.10-FF-000030', NULL, 'DNA helicase', 105, NULL, NULL, 105314),
(105315, '1.25.40.10-FF-004032', NULL, 'Uncharacterized protein', 183, NULL, NULL, 105315),
(105316, '3.90.740.10-FF-000018', NULL, 'Valine--tRNA ligase', 69, NULL, NULL, 105316),
(105317, '1.20.5.110-FF-000166', NULL, 'BAP31 domain protein, putative (AFU_orthologue AFUA_1G14780)', 38, NULL, NULL, 105317),
(105318, '1.10.1450.10-FF-000049', NULL, 'Tetraspanin', 74, NULL, NULL, 105318),
(105319, '2.130.10.10-FF-004090', NULL, 'Uncharacterized protein', 199, NULL, NULL, 105319),
(105320, '1.20.1280.290-FF-000103', NULL, 'Uncharacterized protein', 74, NULL, NULL, 105320),
(105321, '3.20.20.80-FF-000595', NULL, 'Predicted protein', 200, NULL, NULL, 105321);
INSERT INTO "PUBLIC"."MODEL" VALUES
(105322, '3.40.50.300-FF-006630', NULL, 'Uncharacterized protein', 91, NULL, NULL, 105322),
(105323, '3.60.21.10-FF-000473', NULL, 'Uncharacterized protein', 38, NULL, NULL, 105323),
(105324, '3.90.740.10-FF-000075', NULL, 'Valyl-tRNA synthetase', 69, NULL, NULL, 105324),
(105325, '3.80.10.10-FF-001745', NULL, 'Os04g0675800 protein', 217, NULL, NULL, 105325),
(105326, '1.20.1250.20-FF-001563', NULL, 'Solute carrier family 22 member 18', 389, NULL, NULL, 105326),
(105327, '1.10.420.10-FF-000048', NULL, 'Os01g0378100 protein', 38, NULL, NULL, 105327),
(105328, '1.10.10.10-FF-000078', NULL, 'Transcriptional regulator AsnC', 57, NULL, NULL, 105328),
(105329, '1.25.40.10-FF-003756', NULL, 'Uncharacterized protein', 166, NULL, NULL, 105329),
(105330, '3.30.70.2740-FF-000017', NULL, 'Uncharacterized protein', 83, NULL, NULL, 105330),
(105331, '1.25.40.10-FF-000619', NULL, 'Uncharacterized protein, isoform A', 305, NULL, NULL, 105331),
(105332, '3.20.20.70-FF-000592', NULL, NULL, 237, NULL, NULL, 105332),
(105333, '1.10.760.10-FF-000040', NULL, 'Probable cytochrome c', 127, NULL, NULL, 105333),
(105334, '3.40.50.300-FF-008428', NULL, 'Uncharacterized protein', 97, NULL, NULL, 105334),
(105335, '3.30.420.340-FF-000011', NULL, 'UvrABC system protein C', 163, NULL, NULL, 105335),
(105336, '1.25.10.10-FF-002681', NULL, 'Uncharacterized protein', 82, NULL, NULL, 105336),
(105337, '1.10.8.60-FF-000289', NULL, 'Transcriptional regulator TyrR', 78, NULL, NULL, 105337),
(105338, '2.60.40.740-FF-000003', NULL, 'Cell surface antigen I/II', 188, NULL, NULL, 105338),
(105339, '2.60.40.10-FF-002077', NULL, 'TWiK family of potassium channels', 103, NULL, NULL, 105339),
(105340, '1.10.3090.10-FF-000033', NULL, 'Uncharacterized protein', 183, NULL, NULL, 105340),
(105341, '3.50.7.10-FF-000021', NULL, 'Bardet-Biedl syndrome 12 protein homolog', 129, NULL, NULL, 105341),
(105342, '2.60.40.10-FF-000519', NULL, 'Muscle M-line assembly protein unc-89', 99, NULL, NULL, 105342),
(105343, '2.40.100.10-FF-000098', NULL, 'Cyclophilin, putative', 168, NULL, NULL, 105343),
(105344, '3.30.200.20-FF-001467', NULL, 'Kinase, NEK', 85, NULL, NULL, 105344),
(105345, '1.10.472.10-FF-000275', NULL, 'CYCLIN B15', 22, NULL, NULL, 105345),
(105346, '2.130.10.10-FF-002386', NULL, 'Uncharacterized WD repeat-containing protein YOL087C', 258, NULL, NULL, 105346),
(105347, '3.20.20.450-FF-000001', NULL, 'Cyclic di-GMP phosphodiesterase yahA', 256, NULL, NULL, 105347),
(105348, '1.10.10.60-FF-000930', NULL, NULL, 32, NULL, NULL, 105348),
(105349, '1.20.58.80-FF-000006', NULL, 'Spastin', 86, NULL, NULL, 105349),
(105350, '3.90.1810.10-FF-000001', NULL, 'Outer capsid protein lambda-2', 385, NULL, NULL, 105350),
(105351, '1.10.510.10-FF-000229', NULL, 'Serine/threonine-protein kinase cot-1', 124, NULL, NULL, 105351),
(105352, '3.80.10.10-FF-002021', NULL, 'Uncharacterized protein', 49, NULL, NULL, 105352),
(105353, '2.60.40.10-FF-000839', NULL, 'granulocyte colony-stimulating factor receptor isoform X1', 102, NULL, NULL, 105353),
(105354, '3.30.830.10-FF-000067', NULL, 'Ubiquinol-cytochrome c reductase complex core protein 2 (Eurofung)', 198, NULL, NULL, 105354),
(105355, '2.40.10.220-FF-000003', NULL, 'Alginate biosynthesis protein Alg44', 111, NULL, NULL, 105355),
(105356, '3.40.50.2000-FF-000967', NULL, 'ADP-heptose--lipopolysaccharide heptosyltransferase, putative', 95, NULL, NULL, 105356),
(105357, '3.30.200.20-FF-002361', NULL, 'Uncharacterized protein', 108, NULL, NULL, 105357),
(105358, '3.30.420.40-FF-000551', NULL, 'Actin', 142, NULL, NULL, 105358),
(105359, '2.120.10.30-FF-000554', NULL, 'Uncharacterized protein', 82, NULL, NULL, 105359),
(105360, '1.10.1300.10-FF-000050', NULL, 'Phosphodiesterase', 325, NULL, NULL, 105360),
(105361, '2.130.10.10-FF-003757', NULL, 'Uncharacterized protein', 325, NULL, NULL, 105361),
(105362, '2.60.40.1700-FF-000002', NULL, 'Peptidyl arginine deiminase 6', 174, NULL, NULL, 105362),
(105363, '2.30.29.30-FF-001394', NULL, 'Uncharacterized protein', 46, NULL, NULL, 105363),
(105364, '1.10.472.10-FF-000011', NULL, 'Cyclin-Y isoform 1', 218, NULL, NULL, 105364);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(105365, '1.10.238.10-FF-000355', NULL, 'Uncharacterized calcium-binding protein B0563.7', 90, NULL, NULL, 105365),
(105366, '2.60.40.150-FF-000461', NULL, 'C2 calcium/lipid-binding plant phosphoribosyltransferase family protein', 129, NULL, NULL, 105366),
(105367, '1.10.238.10-FF-001203', NULL, 'Uncharacterized protein', 77, NULL, NULL, 105367),
(105368, '3.40.50.11380-FF-000003', NULL, 'probable UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SEC', 31, NULL, NULL, 105368),
(105369, '3.40.50.2300-FF-001395', NULL, NULL, 135, NULL, NULL, 105369),
(105370, '3.40.50.300-FF-000711', NULL, 'Si:dkey-27n6.1', 229, NULL, NULL, 105370),
(105371, '3.30.450.200-FF-000026', NULL, NULL, 138, NULL, NULL, 105371),
(105372, '1.10.418.10-FF-000133', NULL, 'Plectin b', 62, NULL, NULL, 105372),
(105373, '3.80.10.10-FF-001127', NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g06840', 128, NULL, NULL, 105373),
(105374, '3.30.360.10-FF-000104', NULL, 'Uncharacterized protein', 157, NULL, NULL, 105374),
(105375, '3.20.20.70-FF-000479', NULL, NULL, 152, NULL, NULL, 105375),
(105376, '1.25.40.20-FF-000499', NULL, 'Wide awake, isoform D', 179, NULL, NULL, 105376),
(105377, '1.25.40.20-FF-000269', NULL, 'caseinolytic peptidase B protein homolog isoform X2', 88, NULL, NULL, 105377),
(105378, '3.40.30.10-FF-000782', NULL, 'Sulfhydryl oxidase', 107, NULL, NULL, 105378),
(105379, '3.40.50.1820-FF-000036', NULL, 'Alpha/beta-Hydrolases superfamily protein', 294, NULL, NULL, 105379),
(105380, '3.30.800.10-FF-000032', NULL, NULL, 84, NULL, NULL, 105380),
(105381, '2.60.40.60-FF-000540', NULL, 'Uncharacterized protein', 96, NULL, NULL, 105381),
(105382, '3.10.20.90-FF-000626', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 89, NULL, NULL, 105382),
(105383, '3.30.70.330-FF-001648', NULL, NULL, 103, NULL, NULL, 105383),
(105384, '3.40.50.150-FF-000531', NULL, 'Glycosyl transferase', 165, NULL, NULL, 105384),
(105385, '3.40.50.150-FF-000817', NULL, 'Uncharacterized protein', 186, NULL, NULL, 105385),
(105386, '1.10.30.10-FF-000080', NULL, 'ARS-binding factor', 68, NULL, NULL, 105386),
(105387, '2.60.40.150-FF-000747', NULL, 'Uncharacterized protein', 89, NULL, NULL, 105387),
(105388, '3.40.630.30-FF-000657', NULL, 'Acteyltransferase GNAT family', 156, NULL, NULL, 105388),
(105389, '1.25.40.1030-FF-000047', NULL, 'Protein transport protein SEC31 homolog B', 264, NULL, NULL, 105389),
(105390, '2.60.40.10-FF-000632', NULL, 'Uncharacterized protein, isoform B', 95, NULL, NULL, 105390),
(105391, '3.30.160.60-FF-005792', NULL, NULL, 26, NULL, NULL, 105391),
(105392, '3.40.640.10-FF-000270', NULL, 'Aminotransferase, class V family', 266, NULL, NULL, 105392),
(105393, '1.10.510.10-FF-000286', NULL, 'Mitogen-activated protein kinase kinase kinase 1 (Predicted)', 274, NULL, NULL, 105393),
(105394, '1.10.10.10-FF-000819', NULL, 'LysR family transcriptional regulator', 83, NULL, NULL, 105394),
(105395, '2.170.270.10-FF-000129', NULL, 'Histone-lysine N-methyltransferase', 84, NULL, NULL, 105395),
(105396, '1.10.10.60-FF-000037', NULL, 'chromodomain-helicase-DNA-binding protein 3 isoform X1', 106, NULL, NULL, 105396),
(105397, '3.10.490.10-FF-000028', NULL, 'Gamma-glutamylcyclotransferase', 155, NULL, NULL, 105397),
(105398, '3.30.870.10-FF-000064', NULL, 'Phospholipase D, putative', 200, NULL, NULL, 105398),
(105399, '1.10.287.70-FF-000778', NULL, 'Uncharacterized protein', 103, NULL, NULL, 105399),
(105400, '3.30.310.50-FF-000028', NULL, 'Phosphoglucosamine mutase', 83, NULL, NULL, 105400),
(105401, '3.10.310.10-FF-000021', NULL, 'Diaminopimelate epimerase', 129, NULL, NULL, 105401),
(105402, '3.90.1150.10-FF-000208', NULL, 'Probable aminotransferase gliI', 131, NULL, NULL, 105402),
(105403, '4.10.60.10-FF-000170', NULL, 'Zinc knuckle domain protein (Byr3), putative', 37, NULL, NULL, 105403),
(105404, '4.10.640.10-FF-000025', NULL, '30S ribosomal protein S18', 65, NULL, NULL, 105404),
(105405, '1.20.870.10-FF-000052', NULL, 'Rap guanine nucleotide exchange factor 4', 65, NULL, NULL, 105405);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(105406, '3.30.70.330-FF-002143', NULL, NULL, 103, NULL, NULL, 105406),
(105407, '3.10.110.10-FF-000045', NULL, 'Ubiquitin conjugating enzyme E2 O', 247, NULL, NULL, 105407),
(105408, '1.10.132.60-FF-000006', NULL, 'DNA polymerase', 182, NULL, NULL, 105408),
(105409, '1.10.3720.10-FF-000205', NULL, 'Spermidine/putrescine transport system permease protein', 276, NULL, NULL, 105409),
(105410, '2.60.40.150-FF-000540', NULL, 'Uncharacterized protein', 131, NULL, NULL, 105410),
(105411, '3.40.50.200-FF-000119', NULL, 'Clan SB, family S8, subtilisin-like serine peptidase', 169, NULL, NULL, 105411),
(105412, '2.60.200.20-FF-000121', NULL, 'FHA domain/Ring finger domain/Zinc finger, C3HC4 type (RING finger) containing protein, putative', 101, NULL, NULL, 105412),
(105413, '3.40.50.300-FF-006276', NULL, 'Uncharacterized protein', 162, NULL, NULL, 105413),
(105414, '3.30.70.1400-FF-000008', NULL, 'Putative aminomethyltransferase', 95, NULL, NULL, 105414),
(105415, '1.20.50.20-FF-000004', NULL, 'DNA primase', 56, NULL, NULL, 105415),
(105416, '1.10.10.2660-FF-000032', NULL, 'ThiF family protein', 28, NULL, NULL, 105416),
(105417, '2.130.10.10-FF-000941', NULL, 'WD repeat domain 75', 97, NULL, NULL, 105417),
(105418, '2.130.10.10-FF-000048', NULL, 'semaphorin-5B isoform X1', 454, NULL, NULL, 105418),
(105419, '1.10.132.50-FF-000003', NULL, 'V-type proton ATPase subunit', 100, NULL, NULL, 105419),
(105420, '1.10.510.10-FF-004260', NULL, NULL, 300, NULL, NULL, 105420),
(105421, '3.30.70.20-FF-000023', NULL, 'Dihydropyrimidine dehydrogenase [NADP(+)]', 111, NULL, NULL, 105421),
(105422, '3.30.160.60-FF-001008', NULL, 'transcriptional regulator Kaiso isoform X1', 40, NULL, NULL, 105422),
(105423, '2.30.180.10-FF-000156', NULL, NULL, 137, NULL, NULL, 105423),
(105424, '3.30.70.1150-FF-000001', NULL, 'Acetolactate synthase small subunit', 76, NULL, NULL, 105424),
(105425, '3.65.10.10-FF-000027', NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', 201, NULL, NULL, 105425),
(105426, '3.90.79.10-FF-000223', NULL, 'Protein CBR-ECH-5', 174, NULL, NULL, 105426),
(105427, '1.10.238.10-FF-000630', NULL, 'BnaC05g51860D protein', 100, NULL, NULL, 105427),
(105428, '3.40.50.1000-FF-000358', NULL, 'haloacid dehalogenase-like hydrolase domain-containing 5', 161, NULL, NULL, 105428),
(105429, '3.40.47.10-FF-000207', NULL, NULL, 199, NULL, NULL, 105429),
(105430, '3.90.1750.10-FF-000058', NULL, 'Uncharacterized protein', 144, NULL, NULL, 105430),
(105431, '3.40.50.150-FF-000256', NULL, 'S-adenosyl-L-methionine-dependent methyltransferase superfamily protein', 239, NULL, NULL, 105431),
(105432, '1.20.120.720-FF-000050', NULL, 'Chitin synthase', 121, NULL, NULL, 105432),
(105433, '2.60.40.150-FF-000186', NULL, 'Protein BONZAI 3', 133, NULL, NULL, 105433),
(105434, '3.10.580.10-FF-000209', NULL, 'Uncharacterized protein', 70, NULL, NULL, 105434),
(105435, '3.50.50.60-FF-000061', NULL, 'Dihydropyrimidine dehydrogenase [NADP(+)]', 202, NULL, NULL, 105435),
(105436, '3.40.50.300-FF-002509', NULL, 'ABC transporter ATP-binding protein YtrE', 226, NULL, NULL, 105436),
(105437, '1.10.510.10-FF-001123', NULL, 'CK1/CK1/CK1-D protein kinase', 211, NULL, NULL, 105437),
(105438, '3.30.70.20-FF-000080', NULL, NULL, 52, NULL, NULL, 105438),
(105439, '1.50.40.10-FF-000584', NULL, 'Uncharacterized protein', 60, NULL, NULL, 105439),
(105440, '3.40.50.720-FF-000101', NULL, 'GDP-L-fucose synthase', 207, NULL, NULL, 105440),
(105441, '1.20.1560.10-FF-000836', NULL, 'Uncharacterized protein', 339, NULL, NULL, 105441),
(105442, '1.10.10.10-FF-000612', NULL, 'RNA polymerase sigma factor FecI', 64, NULL, NULL, 105442),
(105443, '3.30.160.60-FF-005999', NULL, NULL, 44, NULL, NULL, 105443),
(105444, '3.40.50.300-FF-000941', NULL, 'Werner syndrome RecQ like helicase', 225, NULL, NULL, 105444),
(105445, '3.40.50.300-FF-003403', NULL, 'Dynein heavy chain', 215, NULL, NULL, 105445),
(105446, '3.40.50.300-FF-004718', NULL, 'ATP-dependent DNA helicase', 199, NULL, NULL, 105446),
(105447, '3.30.1370.10-FF-000115', NULL, 'Scp160p', 79, NULL, NULL, 105447);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(105448, '3.30.710.10-FF-000412', NULL, 'Predicted protein', 151, NULL, NULL, 105448),
(105449, '1.25.40.10-FF-004650', NULL, 'Uncharacterized protein', 122, NULL, NULL, 105449),
(105450, '1.10.510.10-FF-000847', NULL, 'SCY1 protein kinase', 141, NULL, NULL, 105450),
(105451, '1.10.472.130-FF-000090', NULL, 'Dynein heavy chain, cytoplasmic', 163, NULL, NULL, 105451),
(105452, '3.30.40.10-FF-000018', NULL, 'Synaptotagmin-like 5, isoform CRA_a', 146, NULL, NULL, 105452),
(105453, '1.10.472.130-FF-000033', NULL, 'Dynein, axonemal, heavy chain 2', 99, NULL, NULL, 105453),
(105454, '1.20.120.1790-FF-000001', NULL, 'roquin-1 isoform X1', 155, NULL, NULL, 105454),
(105455, '3.40.1810.10-FF-000086', NULL, NULL, 101, NULL, NULL, 105455),
(105456, '2.40.10.10-FF-000232', NULL, 'Serine protease', 76, NULL, NULL, 105456),
(105457, '3.10.20.80-FF-000005', NULL, 'Predicted protein', 76, NULL, NULL, 105457),
(105458, '2.10.25.10-FF-001083', NULL, 'Delta-like protein', 37, NULL, NULL, 105458),
(105459, '2.40.20.10-FF-000058', NULL, 'Lipoprotein(a)', 78, NULL, NULL, 105459),
(105460, '2.60.40.10-FF-004561', NULL, NULL, 104, NULL, NULL, 105460),
(105461, '3.40.525.10-FF-000070', NULL, 'Uncharacterized protein', 134, NULL, NULL, 105461),
(105462, '1.20.1070.10-FF-001125', NULL, 'D(5)-like dopamine receptor', 303, NULL, NULL, 105462),
(105463, '3.30.70.980-FF-000073', NULL, 'Predicted protein', 30, NULL, NULL, 105463),
(105464, '3.40.630.10-FF-000033', NULL, 'M17 leucyl aminopeptidase', 330, NULL, NULL, 105464),
(105465, '3.30.1520.10-FF-000032', NULL, 'Sorting nexin 8', 110, NULL, NULL, 105465),
(105466, '1.10.287.110-FF-000239', NULL, 'DnaJ domain protein', 100, NULL, NULL, 105466),
(105467, '3.10.20.70-FF-000002', NULL, 'Glutamine synthetase I', 105, NULL, NULL, 105467),
(105468, '3.90.550.50-FF-000016', NULL, 'C1GALT1-specific chaperone 1', 192, NULL, NULL, 105468),
(105469, '3.30.70.870-FF-000039', NULL, 'Elongation factor G, mitochondrial', 79, NULL, NULL, 105469),
(105470, '3.40.525.10-FF-000013', NULL, 'Phosphatidylinositol transfer protein PDR16', 320, NULL, NULL, 105470),
(105471, '3.30.1600.10-FF-000033', NULL, 'Uncharacterized protein', 124, NULL, NULL, 105471),
(105472, '3.30.200.20-FF-000332', NULL, 'NIMA related kinase 11', 101, NULL, NULL, 105472),
(105473, '1.20.140.150-FF-000068', NULL, 'P53 apoptosis effector-related to pmp22', 160, NULL, NULL, 105473),
(105474, '3.30.160.60-FF-002565', NULL, NULL, 28, NULL, NULL, 105474),
(105475, '4.10.60.10-FF-000018', NULL, 'Splicing factor, arginine/serine-rich 7', 58, NULL, NULL, 105475),
(105476, '1.10.8.60-FF-000564', NULL, 'Predicted protein', 83, NULL, NULL, 105476),
(105477, '3.40.30.10-FF-001220', NULL, 'Protein disulfide-isomerase', 141, NULL, NULL, 105477),
(105478, '1.25.10.10-FF-000382', NULL, 'Coatomer subunit gamma', 294, NULL, NULL, 105478),
(105479, '2.60.40.10-FF-002352', NULL, 'Blast:Protein sidekick', 122, NULL, NULL, 105479),
(105480, '3.90.1140.10-FF-000028', NULL, 'RNA 2'',3''-cyclic phosphodiesterase', 179, NULL, NULL, 105480),
(105481, '2.30.30.380-FF-000063', NULL, 'Uncharacterized protein', 46, NULL, NULL, 105481),
(105482, '3.30.1370.100-FF-000015', NULL, 'DNA mismatch repair protein PMS1', 17, NULL, NULL, 105482),
(105483, '3.40.800.10-FF-000030', NULL, 'Agmatinase 1', 304, NULL, NULL, 105483),
(105484, '3.40.50.300-FF-004713', NULL, 'Ras-related protein RABG3a', 106, NULL, NULL, 105484),
(105485, '1.10.287.550-FF-000012', NULL, 'Arylsulfatase E', 64, NULL, NULL, 105485),
(105486, '3.90.70.10-FF-000293', NULL, 'WGS project CABT00000000 data, contig 2.33', 418, NULL, NULL, 105486),
(105487, '2.130.10.10-FF-005882', NULL, 'Uncharacterized protein', 299, NULL, NULL, 105487),
(105488, '3.40.190.10-FF-000285', NULL, 'LysR family transcriptional regulator', 94, NULL, NULL, 105488),
(105489, '3.40.630.10-FF-000325', NULL, 'Glutamate carboxypeptidase, putative', 147, NULL, NULL, 105489),
(105490, '3.40.47.10-FF-000202', NULL, NULL, 206, NULL, NULL, 105490),
(105491, '2.60.40.10-FF-005859', NULL, NULL, 95, NULL, NULL, 105491),
(105492, '2.60.40.10-FF-003768', NULL, NULL, 113, NULL, NULL, 105492);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(105493, '3.60.20.10-FF-000100', NULL, 'Proteasome subunit beta', 206, NULL, NULL, 105493),
(105494, '3.30.70.1230-FF-000109', NULL, 'Uncharacterized protein', 240, NULL, NULL, 105494),
(105495, '2.30.30.40-FF-000310', NULL, 'Actin polymerization protein Bzz1', 66, NULL, NULL, 105495),
(105496, '3.30.390.170-FF-000002', NULL, 'Envelope glycoprotein L', 102, NULL, NULL, 105496),
(105497, '2.60.40.10-FF-002138', NULL, 'Uncharacterized protein YeeJ', 84, NULL, NULL, 105497),
(105498, '1.20.1280.50-FF-000107', NULL, 'JmjC domain-containing histone demethylation protein 1', 39, NULL, NULL, 105498),
(105499, '3.90.1140.10-FF-000040', NULL, 'Uncharacterized protein', 263, NULL, NULL, 105499),
(105500, '3.30.2160.10-FF-000010', NULL, 'E3 ubiquitin-protein ligase HERC2 isoform X2', 77, NULL, NULL, 105500),
(105501, '2.10.25.10-FF-001346', NULL, 'Notch homolog 2', 38, NULL, NULL, 105501),
(105502, '2.60.120.10-FF-000292', NULL, 'Uncharacterized protein', 163, NULL, NULL, 105502),
(105503, '2.170.270.10-FF-000242', NULL, 'Histone-lysine N-methyltransferase', 247, NULL, NULL, 105503),
(105504, '2.60.200.10-FF-000005', NULL, 'Interferon regulatory factor 4 deltaE6', 185, NULL, NULL, 105504),
(105505, '3.80.10.10-FF-000104', NULL, 'Tubulin-specific chaperone cofactor E-like protein', 81, NULL, NULL, 105505),
(105506, '3.40.50.300-FF-002622', NULL, 'ABC transporter ATP-binding protein', 226, NULL, NULL, 105506),
(105507, '2.40.10.10-FF-000619', NULL, NULL, 249, NULL, NULL, 105507),
(105508, '1.20.1270.220-FF-000007', NULL, 'Bromodomain factor', 80, NULL, NULL, 105508),
(105509, '2.60.40.60-FF-000489', NULL, 'Cadherin 17', 103, NULL, NULL, 105509),
(105510, '3.40.1090.10-FF-000119', NULL, 'Predicted protein', 237, NULL, NULL, 105510),
(105511, '3.40.50.1980-FF-000011', NULL, 'Histidinol dehydrogenase, chloroplastic', 119, NULL, NULL, 105511),
(105512, '3.30.1010.10-FF-000010', NULL, 'serine/threonine-protein kinase SMG1 isoform X1', 146, NULL, NULL, 105512),
(105513, '1.50.40.10-FF-000258', NULL, 'Uncharacterized protein', 65, NULL, NULL, 105513),
(105514, '2.40.70.10-FF-000005', NULL, 'DNA damage inducible 1 homolog 2', 148, NULL, NULL, 105514),
(105515, '3.90.550.50-FF-000061', NULL, 'AT4g00300 protein', 235, NULL, NULL, 105515),
(105516, '3.40.50.410-FF-000002', NULL, 'Integrin beta', 250, NULL, NULL, 105516),
(105517, '2.70.98.20-FF-000037', NULL, 'Amine oxidase', 92, NULL, NULL, 105517),
(105518, '3.30.1640.10-FF-000092', NULL, 'DNA helicase', 102, NULL, NULL, 105518),
(105519, '1.20.1250.20-FF-001737', NULL, 'Uncharacterized protein', 201, NULL, NULL, 105519),
(105520, '1.25.40.10-FF-004094', NULL, 'Uncharacterized protein', 152, NULL, NULL, 105520),
(105521, '2.60.40.10-FF-004229', NULL, NULL, 63, NULL, NULL, 105521),
(105522, '3.80.10.10-FF-003870', NULL, 'Uncharacterized protein', 207, NULL, NULL, 105522),
(105523, '3.30.200.20-FF-002243', NULL, 'Pregnancy up-regulated nonubiquitous CaM kinase', 31, NULL, NULL, 105523),
(105524, '3.40.50.10810-FF-000271', NULL, 'SNF2/RAD54 family protein', 109, NULL, NULL, 105524),
(105525, '3.90.70.10-FF-000411', NULL, 'Uncharacterized protein', 309, NULL, NULL, 105525),
(105526, '3.30.70.330-FF-000400', NULL, 'Negative regulator of differentiation 1', 87, NULL, NULL, 105526),
(105527, '3.50.50.60-FF-000229', NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', 231, NULL, NULL, 105527),
(105528, '1.10.1130.10-FF-000008', NULL, 'Nitrite reductase (cytochrome; ammonia-forming)', 341, NULL, NULL, 105528),
(105529, '3.30.70.330-FF-001923', NULL, NULL, 150, NULL, NULL, 105529),
(105530, '3.40.50.300-FF-008024', NULL, 'ATP-dependent DNA helicase', 139, NULL, NULL, 105530),
(105531, '1.20.120.140-FF-000022', NULL, 'Signal recognition particle receptor FtsY', 106, NULL, NULL, 105531),
(105532, '2.70.98.10-FF-000034', NULL, 'Aldose 1-epimerase', 257, NULL, NULL, 105532),
(105533, '3.30.200.20-FF-001349', NULL, 'Predicted protein', 77, NULL, NULL, 105533),
(105534, '3.40.50.300-FF-001043', NULL, 'ciliogenesis and planar polarity effector 2', 165, NULL, NULL, 105534);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(105535, '3.40.30.10-FF-000725', NULL, 'Uncharacterized protein', 131, NULL, NULL, 105535),
(105536, '1.20.920.20-FF-000025', NULL, 'Dynein gamma chain, flagellar outer arm', 357, NULL, NULL, 105536),
(105537, '2.130.10.10-FF-002116', NULL, 'Uncharacterized protein', 151, NULL, NULL, 105537),
(105538, '2.160.20.10-FF-000165', NULL, 'Cell surface protein', 180, NULL, NULL, 105538),
(105539, '3.30.420.40-FF-001040', NULL, 'Uncharacterized protein', 21, NULL, NULL, 105539),
(105540, '3.40.50.450-FF-000059', NULL, 'Predicted protein', 191, NULL, NULL, 105540),
(105541, '2.170.150.20-FF-000028', NULL, 'Uncharacterized protein', 127, NULL, NULL, 105541),
(105542, '2.170.150.10-FF-000025', NULL, 'Uncharacterized protein', 59, NULL, NULL, 105542),
(105543, '2.20.80.10-FF-000001', NULL, 'Vitellogenin 7', 254, NULL, NULL, 105543),
(105544, '3.30.160.60-FF-002801', NULL, 'Uncharacterized protein', 29, NULL, NULL, 105544),
(105545, '1.10.3080.10-FF-000072', NULL, 'Uncharacterized protein', 95, NULL, NULL, 105545),
(105546, '1.10.1070.11-FF-000111', NULL, 'Uncharacterized protein', 195, NULL, NULL, 105546),
(105547, '3.30.70.330-FF-000018', NULL, 'Polypyrimidine tract-binding protein 2 isoform 1', 106, NULL, NULL, 105547),
(105548, '3.10.580.10-FF-000187', NULL, 'Cysteine synthase, putative', 111, NULL, NULL, 105548),
(105549, '3.30.830.10-FF-000180', NULL, 'Uncharacterized protein', 232, NULL, NULL, 105549),
(105550, '3.10.450.120-FF-000006', NULL, 'Conserved protein with predicted RNA binding PUA domain', 76, NULL, NULL, 105550),
(105551, '2.130.10.10-FF-003639', NULL, 'Gll0893 protein', 262, NULL, NULL, 105551),
(105552, '1.25.40.10-FF-004150', NULL, 'Uncharacterized protein', 111, NULL, NULL, 105552),
(105553, '3.30.230.70-FF-000152', NULL, 'Uncharacterized protein', 83, NULL, NULL, 105553),
(105554, '3.30.1010.10-FF-000061', NULL, 'Serine/threonine-protein kinase TEL1', 146, NULL, NULL, 105554),
(105555, '3.40.50.800-FF-000086', NULL, 'Histidine--tRNA ligase', 92, NULL, NULL, 105555),
(105556, '3.30.1540.20-FF-000036', NULL, NULL, 75, NULL, NULL, 105556),
(105557, '3.40.50.300-FF-004595', NULL, 'ATP-dependent DNA helicase MCM (Intein-containing)', 285, NULL, NULL, 105557),
(105558, '3.40.50.720-FF-002017', NULL, 'Gll1581 protein', 213, NULL, NULL, 105558),
(105559, '3.40.50.1000-FF-000471', NULL, 'D,D-heptose 1,7-bisphosphate phosphatase', 178, NULL, NULL, 105559),
(105560, '3.40.50.10950-FF-000003', NULL, 'Phosphate acetyltransferase', 149, NULL, NULL, 105560),
(105561, '1.20.120.1900-FF-000074', NULL, 'Chromosome 8, whole genome shotgun sequence', 290, NULL, NULL, 105561),
(105562, '3.20.20.300-FF-000035', NULL, NULL, 50, NULL, NULL, 105562),
(105563, '3.10.180.10-FF-000044', NULL, 'Methylmalonyl-CoA-ethylmalonyl-CoA epimerase protein', 128, NULL, NULL, 105563),
(105564, '3.40.50.1980-FF-000062', NULL, 'Iron(III) ABC transporter periplasmic iron-compound-binding protein', 153, NULL, NULL, 105564),
(105565, '3.40.190.10-FF-000392', NULL, 'Probable sugar-binding lipoprotein', 406, NULL, NULL, 105565),
(105566, '3.30.2010.10-FF-000010', NULL, 'M48 family peptidase', 82, NULL, NULL, 105566),
(105567, '1.10.10.10-FF-001736', NULL, 'Two-component response regulator', 110, NULL, NULL, 105567),
(105568, '2.40.50.140-FF-001246', NULL, NULL, 107, NULL, NULL, 105568),
(105569, '1.20.140.100-FF-000020', NULL, 'Dynein heavy chain, putative', 152, NULL, NULL, 105569),
(105570, '3.40.50.720-FF-001556', NULL, 'Ubiquitin-activating enzyme E1', 251, NULL, NULL, 105570),
(105571, '2.60.40.10-FF-004381', NULL, NULL, 101, NULL, NULL, 105571),
(105572, '1.10.150.80-FF-000003', NULL, 'Bloom syndrome RecQ-like helicase', 92, NULL, NULL, 105572),
(105573, '2.30.30.40-FF-000361', NULL, 'Heavy chain, Unconventional Myosin', 80, NULL, NULL, 105573),
(105574, '3.40.47.10-FF-000084', NULL, 'Beta-keto-ACP synthase', 190, NULL, NULL, 105574),
(105575, '1.10.510.10-FF-002680', NULL, NULL, 176, NULL, NULL, 105575),
(105576, '1.20.920.30-FF-000028', NULL, 'Dynein heavy chain', 166, NULL, NULL, 105576),
(105577, '1.10.510.10-FF-004501', NULL, NULL, 228, NULL, NULL, 105577);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(105578, '3.40.50.300-FF-001262', NULL, 'ABC transporter CDR4', 243, NULL, NULL, 105578),
(105579, '3.40.50.670-FF-000001', NULL, 'DNA topoisomerase 2', 220, NULL, NULL, 105579),
(105580, '3.10.20.90-FF-000452', NULL, 'Uncharacterized protein', 71, NULL, NULL, 105580),
(105581, '3.90.640.10-FF-000011', NULL, 'Heat shock protein family A (Hsp70) member 12A', 106, NULL, NULL, 105581),
(105582, '3.40.50.2300-FF-001097', NULL, NULL, 137, NULL, NULL, 105582),
(105583, '3.50.30.50-FF-000012', NULL, 'Cyclase family protein', 108, NULL, NULL, 105583),
(105584, '3.90.230.10-FF-000042', NULL, NULL, 54, NULL, NULL, 105584),
(105585, '3.40.50.11340-FF-000019', NULL, 'Uncharacterized protein', 45, NULL, NULL, 105585),
(105586, '3.30.70.330-FF-001704', NULL, NULL, 87, NULL, NULL, 105586),
(105587, '1.10.472.10-FF-000218', NULL, 'Retinoblastoma family protein', 72, NULL, NULL, 105587),
(105588, '3.40.50.1820-FF-000042', NULL, 'probable strigolactone esterase DAD2', 268, NULL, NULL, 105588),
(105589, '3.30.1380.20-FF-000001', NULL, 'Trafficking protein particle complex subunit BET3', 190, NULL, NULL, 105589),
(105590, '2.60.40.10-FF-000340', NULL, 'Carcinoembryonic antigen-related cell adhesion molecule 1', 110, NULL, NULL, 105590),
(105591, '2.40.50.140-FF-001139', NULL, NULL, 89, NULL, NULL, 105591),
(105592, '3.40.50.150-FF-000295', NULL, 'Ribosomal RNA small subunit methyltransferase H', 199, NULL, NULL, 105592),
(105593, '3.90.1420.10-FF-000022', NULL, 'AGAP002018-PA', 158, NULL, NULL, 105593),
(105594, '3.30.60.60-FF-000006', NULL, 'Histone acetyltransferase', 59, NULL, NULL, 105594),
(105595, '3.90.740.10-FF-000070', NULL, 'Uncharacterized protein', 148, NULL, NULL, 105595),
(105596, '3.30.70.2470-FF-000003', NULL, 'Uncharacterized protein, isoform C', 100, NULL, NULL, 105596),
(105597, '1.25.10.10-FF-001686', NULL, 'Expressed protein', 288, NULL, NULL, 105597),
(105598, '3.40.630.30-FF-000483', NULL, 'Uncharacterized protein', 152, NULL, NULL, 105598),
(105599, '3.90.660.20-FF-000021', NULL, 'Protoporphyrinogen oxidase', 172, NULL, NULL, 105599),
(105600, '1.20.58.1330-FF-000001', NULL, 'Early transcribed membrane protein 13', 101, NULL, NULL, 105600),
(105601, '2.130.10.10-FF-005556', NULL, 'semaphorin-4G-like isoform X3', 456, NULL, NULL, 105601),
(105602, '3.30.890.10-FF-000032', NULL, 'Uncharacterized protein', 129, NULL, NULL, 105602),
(105603, '2.160.20.10-FF-000114', NULL, 'Pectin lyase-like superfamily protein', 228, NULL, NULL, 105603),
(105604, '3.10.20.90-FF-000564', NULL, 'Autophagy-related protein', 127, NULL, NULL, 105604),
(105605, '3.40.630.30-FF-000595', NULL, 'Uncharacterized protein', 81, NULL, NULL, 105605),
(105606, '1.10.10.10-FF-000371', NULL, 'Crossover junction endonuclease MUS81', 108, NULL, NULL, 105606),
(105607, '2.70.150.10-FF-000302', NULL, 'Uncharacterized protein', 62, NULL, NULL, 105607),
(105608, '2.60.120.260-FF-000542', NULL, 'Uncharacterized protein', 71, NULL, NULL, 105608),
(105609, '3.40.850.10-FF-000313', NULL, 'Kinesin heavy chain isoform 5C', 88, NULL, NULL, 105609),
(105610, '2.60.120.200-FF-000215', NULL, 'Si:dkey-22o22.2', 169, NULL, NULL, 105610),
(105611, '1.10.510.10-FF-002528', NULL, 'Uncharacterized protein', 325, NULL, NULL, 105611),
(105612, '3.30.70.2280-FF-000008', NULL, 'Uncharacterized protein', 78, NULL, NULL, 105612),
(105613, '3.40.190.290-FF-000119', NULL, 'Transcriptional regulator, LysR family', 204, NULL, NULL, 105613),
(105614, '2.60.40.10-FF-004611', NULL, NULL, 125, NULL, NULL, 105614),
(105615, '3.40.710.10-FF-000096', NULL, 'Uncharacterized protein', 280, NULL, NULL, 105615),
(105616, '3.30.160.360-FF-000007', NULL, 'Transforming growth factor beta regulator 1', 133, NULL, NULL, 105616),
(105617, '2.60.40.10-FF-003987', NULL, NULL, 101, NULL, NULL, 105617),
(105618, '3.20.20.70-FF-000827', NULL, NULL, 143, NULL, NULL, 105618),
(105619, '2.60.40.1090-FF-000038', NULL, 'Fimbrial protein', 158, NULL, NULL, 105619),
(105620, '2.60.200.20-FF-000278', NULL, 'Uncharacterized protein', 97, NULL, NULL, 105620),
(105621, '1.25.10.10-FF-002175', NULL, 'Uncharacterized protein', 479, NULL, NULL, 105621);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(105622, '2.60.40.60-FF-000596', NULL, 'Cadherin-related cell adhesion molecule', 56, NULL, NULL, 105622),
(105623, '1.10.510.10-FF-002309', NULL, NULL, 222, NULL, NULL, 105623),
(105624, '3.30.450.40-FF-000148', NULL, 'Heat-inducible transcription repressor HrcA', 134, NULL, NULL, 105624),
(105625, '3.80.10.10-FF-002869', NULL, 'Secreted protein, putative', 124, NULL, NULL, 105625),
(105626, '3.40.50.1820-FF-001733', NULL, 'Enniatin synthase', 91, NULL, NULL, 105626),
(105627, '3.40.50.1820-FF-001621', NULL, 'Uncharacterized protein', 57, NULL, NULL, 105627),
(105628, '3.30.420.510-FF-000023', NULL, 'Uncharacterized protein', 89, NULL, NULL, 105628),
(105629, '2.60.40.10-FF-005808', NULL, NULL, 69, NULL, NULL, 105629),
(105630, '1.20.1070.10-FF-001748', NULL, 'Uncharacterized protein', 80, NULL, NULL, 105630),
(105631, '3.10.28.10-FF-000024', NULL, 'Probable intron-encoded endonuclease 2', 169, NULL, NULL, 105631),
(105632, '2.10.220.10-FF-000142', NULL, 'Proprotein convertase subtilisin/kexin type 5', 56, NULL, NULL, 105632),
(105633, '1.10.238.10-FF-000304', NULL, 'calbindin-32 isoform X2', 78, NULL, NULL, 105633),
(105634, '1.20.1070.10-FF-001636', NULL, 'Uncharacterized protein', 139, NULL, NULL, 105634),
(105635, '1.50.10.20-FF-000023', NULL, 'Thioester-containing protein 4, isoform C', 311, NULL, NULL, 105635),
(105636, '2.60.200.20-FF-000059', NULL, 'FHA domain-containing protein', 118, NULL, NULL, 105636),
(105637, '3.40.1210.10-FF-000006', NULL, '5''-nucleotidase SurE', 254, NULL, NULL, 105637),
(105638, '1.10.287.70-FF-000486', NULL, 'TWiK family of potassium channels', 176, NULL, NULL, 105638),
(105639, '3.40.50.1240-FF-000019', NULL, 'Periplasmic AppA protein', 124, NULL, NULL, 105639),
(105640, '1.25.40.10-FF-002177', NULL, 'Peptidylprolyl isomerase', 158, NULL, NULL, 105640),
(105641, '1.10.10.10-FF-000320', NULL, 'GntR family transcriptional regulator', 91, NULL, NULL, 105641),
(105642, '3.40.50.970-FF-000035', NULL, '2-succinyl-5-enolpyruvyl-6-hydroxy-3-cyclohexene-1-carboxylate synthase', 210, NULL, NULL, 105642),
(105643, '3.40.50.1070-FF-000002', NULL, 'L-fucose isomerase', 160, NULL, NULL, 105643),
(105644, '1.10.275.40-FF-000022', NULL, 'Helicase, putative', 149, NULL, NULL, 105644),
(105645, '1.10.555.10-FF-000198', NULL, NULL, 137, NULL, NULL, 105645),
(105646, '2.40.100.10-FF-000160', NULL, 'Peptidyl-prolyl cis-trans isomerase', 114, NULL, NULL, 105646),
(105647, '3.30.1640.10-FF-000029', NULL, 'DNA helicase', 95, NULL, NULL, 105647),
(105648, '2.30.30.30-FF-000032', NULL, '39S ribosomal protein L24, mitochondrial', 108, NULL, NULL, 105648),
(105649, '1.10.510.10-FF-001972', NULL, 'Serine/threonine protein kinase, putative', 165, NULL, NULL, 105649),
(105650, '3.90.226.10-FF-000330', NULL, 'Uncharacterized protein', 117, NULL, NULL, 105650),
(105651, '3.40.50.1440-FF-000080', NULL, 'Tubulin, epsilon 1', 229, NULL, NULL, 105651),
(105652, '2.160.20.10-FF-000053', NULL, 'Polygalacturonase QRT3', 351, NULL, NULL, 105652),
(105653, '2.170.130.10-FF-000030', NULL, 'TonB-dependent receptor plug domain protein', 147, NULL, NULL, 105653),
(105654, '3.30.260.10-FF-000001', NULL, '60 kDa chaperonin', 92, NULL, NULL, 105654),
(105655, '3.30.70.2260-FF-000002', NULL, 'Exopolyphosphatase', 47, NULL, NULL, 105655),
(105656, '3.30.450.20-FF-000142', NULL, 'PAS domain-containing protein', 110, NULL, NULL, 105656),
(105657, '3.40.50.300-FF-008136', NULL, 'Roco6, ROCO family protein', 102, NULL, NULL, 105657),
(105658, '2.40.50.90-FF-000140', NULL, 'RE70955p', 39, NULL, NULL, 105658),
(105659, '3.80.10.10-FF-001453', NULL, 'Leucine Rich repeat, putative', 267, NULL, NULL, 105659),
(105660, '1.25.10.10-FF-002405', NULL, 'Uncharacterized protein', 255, NULL, NULL, 105660),
(105661, '1.10.472.10-FF-000393', NULL, 'CYclin H', 141, NULL, NULL, 105661),
(105662, '2.40.50.140-FF-000560', NULL, '30S ribosomal protein S17', 77, NULL, NULL, 105662),
(105663, '3.40.50.980-FF-000038', NULL, 'Uncharacterized protein', 44, NULL, NULL, 105663),
(105664, '2.120.10.30-FF-000054', NULL, 'Peptidyl-alpha-hydroxyglycine alpha-amidating lyase 1', 319, NULL, NULL, 105664);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(105665, '3.90.70.40-FF-000010', NULL, 'Ataxin 3 variant r', 66, NULL, NULL, 105665),
(105666, '3.90.1530.30-FF-000002', NULL, 'Chromosome partitioning protein ParB', 75, NULL, NULL, 105666),
(105667, '3.30.1360.10-FF-000047', NULL, 'DNA-directed RNA polymerases II IV and V subunit 3', 40, NULL, NULL, 105667),
(105668, '2.80.10.50-FF-000276', NULL, 'Predicted protein', 90, NULL, NULL, 105668),
(105669, '3.40.190.10-FF-000341', NULL, 'Phosphonate ABC transporter, phosphate-binding protein', 117, NULL, NULL, 105669),
(105670, '2.40.70.10-FF-000331', NULL, NULL, 172, NULL, NULL, 105670),
(105671, '2.60.40.60-FF-000545', NULL, 'Uncharacterized protein', 53, NULL, NULL, 105671),
(105672, '3.30.160.60-FF-002526', NULL, 'Zinc finger protein', 27, NULL, NULL, 105672),
(105673, '3.90.260.10-FF-000044', NULL, 'XPC (Xeroderma Pigmentosum group C) DNA repair gene homolog', 276, NULL, NULL, 105673),
(105674, '3.80.10.10-FF-003544', NULL, 'Cell polarity protein alp21', 159, NULL, NULL, 105674),
(105675, '1.10.510.10-FF-002461', NULL, 'Serine/threonine protein kinase, putative', 239, NULL, NULL, 105675),
(105676, '1.25.40.10-FF-002800', NULL, 'Pentatricopeptide repeat-containing protein', 83, NULL, NULL, 105676),
(105677, '3.40.33.10-FF-000086', NULL, 'Protein CBG01185', 152, NULL, NULL, 105677),
(105678, '3.30.160.60-FF-004151', NULL, NULL, 26, NULL, NULL, 105678),
(105679, '3.40.50.300-FF-004483', NULL, 'DNA repair protein rad-50', 289, NULL, NULL, 105679),
(105680, '3.40.50.1460-FF-000086', NULL, 'Paracaspase', 217, NULL, NULL, 105680),
(105681, '2.60.200.20-FF-000008', NULL, 'smad nuclear-interacting protein 1', 162, NULL, NULL, 105681),
(105682, '1.10.510.10-FF-003989', NULL, NULL, 85, NULL, NULL, 105682),
(105683, '1.10.185.10-FF-000001', NULL, 'Gag polyprotein', 130, NULL, NULL, 105683),
(105684, '1.20.1110.10-FF-000168', NULL, NULL, 199, NULL, NULL, 105684),
(105685, '3.30.530.20-FF-000143', NULL, 'Lipid-binding START protein', 209, NULL, NULL, 105685),
(105686, '2.60.40.790-FF-000203', NULL, NULL, 54, NULL, NULL, 105686),
(105687, '1.25.40.10-FF-000620', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 118, NULL, NULL, 105687),
(105688, '3.10.450.50-FF-000021', NULL, 'Epoxide hydrolase EphG', 149, NULL, NULL, 105688),
(105689, '2.20.70.10-FF-000231', NULL, 'Transcription elongation regulator, putative', 58, NULL, NULL, 105689),
(105690, '3.30.70.1350-FF-000010', NULL, 'Cation efflux family protein, putative', 91, NULL, NULL, 105690),
(105691, '3.30.70.330-FF-000344', NULL, 'Poly [ADP-ribose] polymerase', 75, NULL, NULL, 105691),
(105692, '1.20.1060.20-FF-000003', NULL, 'Structural maintenance of chromosomes 4', 75, NULL, NULL, 105692),
(105693, '2.130.10.10-FF-005994', NULL, 'Predicted protein', 225, NULL, NULL, 105693),
(105694, '3.30.70.370-FF-000002', NULL, 'DNA polymerase gamma, catalytic subunit', 26, NULL, NULL, 105694),
(105695, '2.20.28.10-FF-000009', NULL, 'RING finger and CHY zinc finger domain-containing protein 1', 47, NULL, NULL, 105695),
(105696, '2.60.34.10-FF-000050', NULL, 'Heat shock protein 70, putative', 153, NULL, NULL, 105696),
(105697, '1.20.140.150-FF-000006', NULL, 'uncharacterized protein C16orf52 homolog', 162, NULL, NULL, 105697),
(105698, '3.40.50.2300-FF-000315', NULL, 'Glutamate receptor ionotropic, delta-1', 37, NULL, NULL, 105698),
(105699, '3.90.70.10-FF-000181', NULL, 'Ubiquitin hydrolase, putative', 183, NULL, NULL, 105699),
(105700, '3.40.50.720-FF-002012', NULL, 'Predicted protein', 219, NULL, NULL, 105700),
(105701, '2.60.40.150-FF-000427', NULL, 'Phosphoinositide phospholipase C', 132, NULL, NULL, 105701),
(105702, '3.40.930.10-FF-000039', NULL, NULL, 215, NULL, NULL, 105702),
(105703, '2.70.98.110-FF-000006', NULL, 'Glucosidase I', 314, NULL, NULL, 105703),
(105704, '3.40.50.300-FF-000554', NULL, 'ADP-ribosylation factor 1', 177, NULL, NULL, 105704),
(105705, '1.10.8.400-FF-000002', NULL, 'Enoyl-[acyl-carrier-protein] reductase [NADH]', 52, NULL, NULL, 105705),
(105706, '3.30.40.10-FF-001822', NULL, 'Uncharacterized protein', 84, NULL, NULL, 105706);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(105707, '3.40.50.10260-FF-000010', NULL, 'Edc3p', 285, NULL, NULL, 105707),
(105708, '3.30.565.10-FF-000282', NULL, 'Signal transduction histidine kinase', 148, NULL, NULL, 105708),
(105709, '3.30.2160.10-FF-000066', NULL, 'Uncharacterized protein', 41, NULL, NULL, 105709),
(105710, '1.10.1670.10-FF-000032', NULL, 'Endonuclease III, putative', 79, NULL, NULL, 105710),
(105711, '2.60.40.10-FF-005685', NULL, NULL, 78, NULL, NULL, 105711),
(105712, '2.60.120.740-FF-000023', NULL, 'Uncharacterized protein', 105, NULL, NULL, 105712),
(105713, '1.20.58.390-FF-000204', NULL, 'Neurotransmitter-gated ion-channel ligand binding domain protein', 40, NULL, NULL, 105713),
(105714, '1.20.1250.20-FF-001518', NULL, 'Solute carrier family 19 member 3b', 387, NULL, NULL, 105714),
(105715, '3.40.630.10-FF-000151', NULL, 'Blast:Carboxypeptidase B', 348, NULL, NULL, 105715),
(105716, '2.40.170.20-FF-000111', NULL, 'SusC homolog', 631, NULL, NULL, 105716),
(105717, '1.25.40.70-FF-000087', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', 204, NULL, NULL, 105717),
(105718, '2.30.30.40-FF-000068', NULL, 'Voltage-dependent L-type calcium channel subunit beta-1 isoform 1', 145, NULL, NULL, 105718),
(105719, '1.10.30.10-FF-000085', NULL, 'Chromatin-associated protein', 113, NULL, NULL, 105719),
(105720, '3.40.30.10-FF-001063', NULL, 'Uncharacterized protein', 164, NULL, NULL, 105720),
(105721, '3.30.2290.10-FF-000019', NULL, 'Sll0887 protein', 221, NULL, NULL, 105721),
(105722, '3.30.830.10-FF-000028', NULL, 'Insulin-degrading enzyme-like 1 peroxisomal', 236, NULL, NULL, 105722),
(105723, '2.60.40.4370-FF-000005', NULL, 'Transcription factor tau subunit sfc7', 105, NULL, NULL, 105723),
(105724, '2.40.30.110-FF-000013', NULL, 'Protein CBG22093', 83, NULL, NULL, 105724),
(105725, '1.25.40.10-FF-002851', NULL, 'Pentatricopeptide repeat-containing protein At2g25580', 111, NULL, NULL, 105725),
(105726, '3.30.70.330-FF-001709', NULL, NULL, 72, NULL, NULL, 105726),
(105727, '1.20.58.390-FF-000255', NULL, 'Uncharacterized protein', 107, NULL, NULL, 105727),
(105728, '1.10.510.10-FF-004226', NULL, NULL, 205, NULL, NULL, 105728),
(105729, '1.10.3470.10-FF-000051', NULL, 'ABC-3 protein', 231, NULL, NULL, 105729),
(105730, '2.130.10.10-FF-004533', NULL, 'Novel protein-containing four WD domain, G-beta repeats', 226, NULL, NULL, 105730),
(105731, '3.30.70.380-FF-000005', NULL, 'Phenylalanine--tRNA ligase beta subunit', 89, NULL, NULL, 105731),
(105732, '3.40.50.300-FF-002627', NULL, 'Gluconokinase', 191, NULL, NULL, 105732),
(105733, '3.10.20.90-FF-000126', NULL, 'unconventional myosin-X', 94, NULL, NULL, 105733),
(105734, '3.40.50.1100-FF-000175', NULL, 'Threonine synthase', 213, NULL, NULL, 105734),
(105735, '3.80.10.10-FF-001560', NULL, 'Adhesion G protein-coupled receptor A2', 120, NULL, NULL, 105735),
(105736, '1.10.20.10-FF-000197', NULL, NULL, 81, NULL, NULL, 105736),
(105737, '1.10.520.10-FF-000056', NULL, 'L-ascorbate peroxidase', 178, NULL, NULL, 105737),
(105738, '3.30.1520.10-FF-000150', NULL, 'Sorting nexin 3', 107, NULL, NULL, 105738),
(105739, '3.40.630.30-FF-000157', NULL, 'RNA cytidine acetyltransferase', 223, NULL, NULL, 105739),
(105740, '3.10.110.10-FF-000040', NULL, 'tumor susceptibility gene 101 protein', 145, NULL, NULL, 105740),
(105741, '3.30.1330.20-FF-000048', NULL, 'Uncharacterized protein', 83, NULL, NULL, 105741),
(105742, '2.40.30.130-FF-000019', NULL, 'Alanine--tRNA ligase', 94, NULL, NULL, 105742),
(105743, '1.10.10.250-FF-000028', NULL, 'Large subunit ribosomal protein L11', 96, NULL, NULL, 105743),
(105744, '1.10.533.10-FF-000299', NULL, 'NACHT, LRR and PYD domains-containing protein 9B', 74, NULL, NULL, 105744),
(105745, '3.30.40.10-FF-001148', NULL, 'FinTRIM family, member 82', 61, NULL, NULL, 105745),
(105746, '3.90.70.10-FF-000416', NULL, 'Senescence-specific cysteine protease SAG39', 76, NULL, NULL, 105746),
(105747, '1.10.10.60-FF-000632', NULL, 'Zinc finger protein 1', 84, NULL, NULL, 105747),
(105748, '3.30.40.10-FF-000136', NULL, 'E3 ubiquitin-protein ligase Topors', 67, NULL, NULL, 105748);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(105749, '2.40.100.10-FF-000008', NULL, 'Peptidyl-prolyl cis-trans isomerase', 163, NULL, NULL, 105749),
(105750, '1.25.40.20-FF-001224', NULL, 'Ankyrin repeat domain 27', 172, NULL, NULL, 105750),
(105751, '1.25.10.10-FF-003479', NULL, 'Uncharacterized protein', 91, NULL, NULL, 105751),
(105752, '3.60.21.10-FF-000142', NULL, 'Serine/threonine-protein phosphatase', 356, NULL, NULL, 105752),
(105753, '3.40.140.10-FF-000243', NULL, 'Uncharacterized protein', 151, NULL, NULL, 105753),
(105754, '1.25.40.10-FF-000327', NULL, 'Pre-mRNA-splicing factor CLF1', 234, NULL, NULL, 105754),
(105755, '3.30.497.10-FF-000022', NULL, 'SeRPin', 227, NULL, NULL, 105755),
(105756, '1.10.238.10-FF-000686', NULL, 'Glycerol-3-phosphate dehydrogenase 2', 90, NULL, NULL, 105756),
(105757, '2.60.40.180-FF-000003', NULL, 'Uric acid degradation bifunctional protein TTL', 129, NULL, NULL, 105757),
(105758, '1.10.10.10-FF-002118', NULL, 'Transcriptional regulator, AsnC family', 52, NULL, NULL, 105758),
(105759, '3.30.70.580-FF-000065', NULL, 'tRNA pseudouridine synthase', 97, NULL, NULL, 105759),
(105760, '3.30.1060.10-FF-000007', NULL, 'Peptide methionine sulfoxide reductase msrA/msrB', 165, NULL, NULL, 105760),
(105761, '1.25.40.20-FF-000656', NULL, 'Water witch, isoform D', 91, NULL, NULL, 105761),
(105762, '1.10.3260.10-FF-000018', NULL, 'ATP-dependent DNA ligase', 197, NULL, NULL, 105762),
(105763, '2.60.40.60-FF-001001', NULL, 'Uncharacterized protein', 109, NULL, NULL, 105763),
(105764, '2.120.10.30-FF-000116', NULL, 'Serine/threonine-protein kinase pknD', 245, NULL, NULL, 105764),
(105765, '1.25.40.10-FF-004217', NULL, 'Uncharacterized protein', 48, NULL, NULL, 105765),
(105766, '1.10.238.10-FF-000742', NULL, 'Uncharacterized protein', 59, NULL, NULL, 105766),
(105767, '3.90.1110.10-FF-000026', NULL, NULL, 182, NULL, NULL, 105767),
(105768, '3.40.30.10-FF-000495', NULL, 'Diphosphomevalonate decarboxylase MVD2', 83, NULL, NULL, 105768),
(105769, '3.40.50.150-FF-000290', NULL, 'Polyamine aminopropyltransferase', 228, NULL, NULL, 105769),
(105770, '1.20.58.390-FF-000148', NULL, 'Transmembrane ion channel', 142, NULL, NULL, 105770),
(105771, '3.30.160.60-FF-003987', NULL, NULL, 50, NULL, NULL, 105771),
(105772, '1.10.1410.10-FF-000086', NULL, 'Uncharacterized protein', 199, NULL, NULL, 105772),
(105773, '3.40.630.10-FF-000095', NULL, 'N-acetylated alpha-linked acidic dipeptidase like 2', 266, NULL, NULL, 105773),
(105774, '3.30.505.10-FF-000183', NULL, NULL, 86, NULL, NULL, 105774),
(105775, '2.30.29.30-FF-001074', NULL, 'Uncharacterized protein', 70, NULL, NULL, 105775),
(105776, '3.55.40.20-FF-000004', NULL, 'Superoxide dismutase [Fe]', 120, NULL, NULL, 105776),
(105777, '3.40.50.1100-FF-000231', NULL, 'Cysteine synthase', 70, NULL, NULL, 105777),
(105778, '2.10.220.10-FF-000198', NULL, 'Uncharacterized protein', 61, NULL, NULL, 105778),
(105779, '3.90.550.10-FF-000184', NULL, 'Van1p', 109, NULL, NULL, 105779),
(105780, '3.15.10.10-FF-000018', NULL, 'Nose resistant to fluoxetine protein 5', 159, NULL, NULL, 105780),
(105781, '3.30.10.20-FF-000019', NULL, 'Serine/threonine-protein kinase PrkC', 64, NULL, NULL, 105781),
(105782, '2.10.50.10-FF-000039', NULL, 'Tumor necrosis factor receptor superfamily member 19L', 73, NULL, NULL, 105782),
(105783, '1.25.40.10-FF-001957', NULL, 'Uncharacterized protein', 95, NULL, NULL, 105783),
(105784, '3.40.630.10-FF-000437', NULL, 'Uncharacterized protein', 242, NULL, NULL, 105784),
(105785, '2.70.130.10-FF-000065', NULL, NULL, 124, NULL, NULL, 105785),
(105786, '3.40.1380.20-FF-000049', NULL, 'Pyruvate kinase', 123, NULL, NULL, 105786),
(105787, '1.10.10.10-FF-000376', NULL, 'Rrf2 family transcriptional regulator', 132, NULL, NULL, 105787),
(105788, '3.40.50.300-FF-002678', NULL, 'ADP-dependent DNA helicase RecQ', 310, NULL, NULL, 105788),
(105789, '3.10.20.90-FF-000177', NULL, 'UBX domain protein 11', 175, NULL, NULL, 105789),
(105790, '1.20.140.140-FF-000003', NULL, 'Protein orai', 193, NULL, NULL, 105790),
(105791, '2.70.20.10-FF-000023', NULL, 'DNA topoisomerase 1', 142, NULL, NULL, 105791);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(105792, '4.10.400.10-FF-000339', NULL, 'Uncharacterized protein', 37, NULL, NULL, 105792),
(105793, '3.30.160.60-FF-000109', NULL, 'Transcriptional repressor protein YY1', 28, NULL, NULL, 105793),
(105794, '1.25.40.10-FF-002233', NULL, 'Protein THYLAKOID ASSEMBLY 8, chloroplastic', 171, NULL, NULL, 105794),
(105795, '3.80.10.10-FF-001408', NULL, 'Si:ch211-171l17.14', 160, NULL, NULL, 105795),
(105796, '2.40.50.140-FF-000234', NULL, 'DNA ligase', 164, NULL, NULL, 105796),
(105797, '1.20.120.350-FF-000186', NULL, NULL, 122, NULL, NULL, 105797),
(105798, '1.10.287.110-FF-000234', NULL, 'Putative DNAJ domain protein', 80, NULL, NULL, 105798),
(105799, '2.60.200.20-FF-000003', NULL, 'sarcolemmal membrane-associated protein isoform X2', 121, NULL, NULL, 105799),
(105800, '3.40.50.300-FF-000149', NULL, 'Nuclear valosin-containing protein-like', 182, NULL, NULL, 105800),
(105801, '2.40.30.270-FF-000033', NULL, 'Helicase, putative', 90, NULL, NULL, 105801),
(105802, '3.40.50.1820-FF-001346', NULL, 'Uncharacterized protein', 245, NULL, NULL, 105802),
(105803, '2.180.10.10-FF-000006', NULL, 'teneurin-a isoform X3', 151, NULL, NULL, 105803),
(105804, '1.20.58.670-FF-000018', NULL, NULL, 138, NULL, NULL, 105804),
(105805, '2.60.40.10-FF-002464', NULL, 'interleukin-3 receptor subunit alpha', 107, NULL, NULL, 105805),
(105806, '3.10.450.320-FF-000004', NULL, 'Tim21 domain-containing protein', 132, NULL, NULL, 105806),
(105807, '4.10.280.10-FF-000166', NULL, 'Transcription factor bHLH52', 60, NULL, NULL, 105807),
(105808, '1.20.1250.20-FF-001844', NULL, 'Monocarboxylate transporter, putative', 136, NULL, NULL, 105808),
(105809, '2.130.10.10-FF-000643', NULL, '60S ribosome biogenesis protein Sqt1', 462, NULL, NULL, 105809),
(105810, '3.80.10.10-FF-001234', NULL, 'AGAP013454-PA', 146, NULL, NULL, 105810),
(105811, '3.40.50.300-FF-002066', NULL, 'GPN-loop GTPase 3', 273, NULL, NULL, 105811),
(105812, '1.20.930.40-FF-000032', NULL, 'Uncharacterized protein', 112, NULL, NULL, 105812),
(105813, '1.20.1070.10-FF-001804', NULL, 'Uncharacterized protein', 315, NULL, NULL, 105813),
(105814, '1.10.418.50-FF-000004', NULL, 'Predicted protein', 99, NULL, NULL, 105814),
(105815, '3.10.20.90-FF-000738', NULL, 'Plexin A3', 113, NULL, NULL, 105815),
(105816, '3.10.20.90-FF-001020', NULL, 'Uncharacterized protein', 97, NULL, NULL, 105816),
(105817, '3.90.550.10-FF-000712', NULL, 'Uncharacterized protein', 268, NULL, NULL, 105817),
(105818, '1.10.274.30-FF-000017', NULL, 'NuA4 complex subunit EAF3 homolog', 166, NULL, NULL, 105818),
(105819, '3.20.20.70-FF-000597', NULL, NULL, 63, NULL, NULL, 105819),
(105820, '3.40.50.300-FF-007967', NULL, 'Uncharacterized protein', 164, NULL, NULL, 105820),
(105821, '2.60.40.10-FF-002812', NULL, 'KETtiN (Drosophila actin-binding) homolog', 112, NULL, NULL, 105821),
(105822, '2.60.40.10-FF-002756', NULL, 'Envelope glycoprotein E', 187, NULL, NULL, 105822),
(105823, '3.10.20.90-FF-000396', NULL, 'GABARAPL2 isoform 2', 90, NULL, NULL, 105823),
(105824, '1.10.418.60-FF-000007', NULL, 'NDC80 kinetochore complex component NUF2', 167, NULL, NULL, 105824),
(105825, '2.130.10.10-FF-004207', NULL, 'UTP4 small subunit processome component', 155, NULL, NULL, 105825),
(105826, '3.30.40.10-FF-001715', NULL, 'YALI0E27049p', 57, NULL, NULL, 105826),
(105827, '3.30.160.60-FF-004095', NULL, NULL, 29, NULL, NULL, 105827),
(105828, '2.40.70.10-FF-000275', NULL, 'Aspartic peptidase domain-containing protein', 200, NULL, NULL, 105828),
(105829, '3.30.50.10-FF-000013', NULL, 'Nuclear receptor subfamily 1 group D member 2', 93, NULL, NULL, 105829),
(105830, '3.40.50.300-FF-003696', NULL, 'Retrotransposon protein, putative, unclassified, expressed', 138, NULL, NULL, 105830),
(105831, '3.40.50.300-FF-006337', NULL, 'AAL030Cp', 228, NULL, NULL, 105831),
(105832, '1.10.238.10-FF-000416', NULL, 'Aralar1, isoform F', 126, NULL, NULL, 105832),
(105833, '1.10.287.550-FF-000017', NULL, 'Uncharacterized protein', 60, NULL, NULL, 105833),
(105834, '3.10.450.120-FF-000001', NULL, 'DUF1947 domain-containing protein', 63, NULL, NULL, 105834);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(105835, '1.25.40.790-FF-000023', NULL, 'Uncharacterized protein', 170, NULL, NULL, 105835),
(105836, '3.30.70.330-FF-001979', NULL, NULL, 169, NULL, NULL, 105836),
(105837, '1.20.1070.10-FF-001462', NULL, 'Uncharacterized protein', 216, NULL, NULL, 105837),
(105838, '3.10.20.310-FF-000029', NULL, 'Outer membrane protein assembly factor BamA', 89, NULL, NULL, 105838),
(105839, '1.10.287.110-FF-000178', NULL, 'DnaJ family protein', 64, NULL, NULL, 105839),
(105840, '1.20.1110.10-FF-000224', NULL, NULL, 21, NULL, NULL, 105840),
(105841, '1.10.510.10-FF-004445', NULL, NULL, 47, NULL, NULL, 105841),
(105842, '2.40.128.240-FF-000001', NULL, 'Transferrin binding protein 2', 158, NULL, NULL, 105842),
(105843, '2.60.40.790-FF-000147', NULL, NULL, 107, NULL, NULL, 105843),
(105844, '1.10.510.10-FF-001005', NULL, 'NAK/BIKE protein kinase', 296, NULL, NULL, 105844),
(105845, '1.10.3170.10-FF-000011', NULL, 'Exodeoxyribonuclease V subunit beta', 190, NULL, NULL, 105845),
(105846, '2.60.40.4060-FF-000007', NULL, 'Putative ferric-chelate reductase 1 homolog', 140, NULL, NULL, 105846),
(105847, '3.70.10.10-FF-000133', NULL, 'Checkpoint protein', 282, NULL, NULL, 105847),
(105848, '3.30.70.330-FF-002997', NULL, NULL, 84, NULL, NULL, 105848),
(105849, '3.30.160.60-FF-001222', NULL, 'zinc finger protein 639', 81, NULL, NULL, 105849),
(105850, '3.40.50.300-FF-008462', NULL, 'DNA replication and repair protein RecF', 147, NULL, NULL, 105850),
(105851, '3.30.2160.10-FF-000015', NULL, 'IQ and HECT domain protein', 83, NULL, NULL, 105851),
(105852, '1.10.357.10-FF-000086', NULL, 'Transcriptional regulator AguR', 187, NULL, NULL, 105852),
(105853, '2.40.50.100-FF-000065', NULL, '2-oxoglutarate dehydrogenase E2 subunit', 78, NULL, NULL, 105853),
(105854, '3.90.226.10-FF-000037', NULL, 'Retinol-binding protein 3', 203, NULL, NULL, 105854),
(105855, '3.30.160.60-FF-004443', NULL, NULL, 58, NULL, NULL, 105855),
(105856, '3.80.10.10-FF-001627', NULL, 'SCF E3 ubiquitin ligase complex F-box protein grrA', 81, NULL, NULL, 105856),
(105857, '2.60.40.60-FF-000719', NULL, 'Fat-like cadherin-related tumor suppressor homolog', 99, NULL, NULL, 105857),
(105858, '1.10.287.1080-FF-000014', NULL, 'Nucleoside triphosphate pyrophosphohydrolase', 127, NULL, NULL, 105858),
(105859, '2.60.120.380-FF-000067', NULL, 'Calpain-B-like Protein', 147, NULL, NULL, 105859),
(105860, '1.20.272.10-FF-000027', NULL, 'DNA polymerase III subunit gamma/tau', 109, NULL, NULL, 105860),
(105861, '1.10.10.1190-FF-000001', NULL, 'Antirestriction protein ArdA', 62, NULL, NULL, 105861),
(105862, '3.40.50.300-FF-004191', NULL, 'Predicted protein', 128, NULL, NULL, 105862),
(105863, '1.25.10.10-FF-000606', NULL, 'ARM repeat superfamily protein', 184, NULL, NULL, 105863),
(105864, '3.40.190.10-FF-000515', NULL, 'Glutamate receptor', 95, NULL, NULL, 105864),
(105865, '2.60.40.10-FF-004443', NULL, NULL, 120, NULL, NULL, 105865),
(105866, '3.40.50.261-FF-000043', NULL, 'Uncharacterized protein', 38, NULL, NULL, 105866),
(105867, '1.10.560.10-FF-000053', NULL, 'T-complex protein 1 subunit delta', 118, NULL, NULL, 105867),
(105868, '3.30.40.10-FF-001766', NULL, 'CiGl protein', 76, NULL, NULL, 105868),
(105869, '2.30.30.490-FF-000096', NULL, 'Uncharacterized protein', 29, NULL, NULL, 105869),
(105870, '3.40.50.10310-FF-000008', NULL, 'Creatininase', 250, NULL, NULL, 105870),
(105871, '1.20.1250.20-FF-001226', NULL, 'Uncharacterized protein', 518, NULL, NULL, 105871),
(105872, '2.60.260.20-FF-000107', NULL, 'Molecular chaperone DnaJ family', 75, NULL, NULL, 105872),
(105873, '3.60.21.10-FF-000086', NULL, 'Shewanella-like protein phosphatase 2', 282, NULL, NULL, 105873),
(105874, '2.10.109.10-FF-000006', NULL, 'DNA polymerase V subunit', 114, NULL, NULL, 105874),
(105875, '3.30.420.10-FF-000278', NULL, 'Uncharacterized protein', 209, NULL, NULL, 105875),
(105876, '1.20.120.1900-FF-000079', NULL, 'Spindle pole body component', 254, NULL, NULL, 105876),
(105877, '3.30.60.30-FF-000183', NULL, 'Agrin', 75, NULL, NULL, 105877),
(105878, '3.30.160.60-FF-000733', NULL, 'Zinc finger protein 236 variant', 29, NULL, NULL, 105878);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(105879, '1.25.40.10-FF-000108', NULL, 'Small glutamine-rich tetratricopeptide repeat-containing protein alpha', 131, NULL, NULL, 105879),
(105880, '1.25.10.10-FF-000051', NULL, 'E3 ubiquitin-protein ligase HECTD1 isoform X1', 387, NULL, NULL, 105880),
(105881, '3.30.450.40-FF-000204', NULL, 'GAF sensor methyl-accepting chemotaxis sensory transducer, class 40H', 168, NULL, NULL, 105881),
(105882, '1.10.510.10-FF-000516', NULL, 'VRK serine/threonine kinase 3', 349, NULL, NULL, 105882),
(105883, '3.40.50.150-FF-000413', NULL, 'Methyltransferase, FxLD system', 234, NULL, NULL, 105883),
(105884, '1.10.510.10-FF-000729', NULL, 'Putative cyclin-dependent kinase F-2', 219, NULL, NULL, 105884),
(105885, '3.40.50.150-FF-001599', NULL, NULL, 350, NULL, NULL, 105885),
(105886, '3.30.70.330-FF-002261', NULL, NULL, 41, NULL, NULL, 105886),
(105887, '1.25.40.10-FF-000378', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 229, NULL, NULL, 105887),
(105888, '1.20.1250.20-FF-000214', NULL, 'MFS transporter', 192, NULL, NULL, 105888),
(105889, '1.10.418.40-FF-000001', NULL, 'beclin-1 isoform X1', 182, NULL, NULL, 105889),
(105890, '3.40.30.10-FF-000169', NULL, 'DnaJ homolog subfamily C member 10', 122, NULL, NULL, 105890),
(105891, '1.10.20.10-FF-000253', NULL, NULL, 67, NULL, NULL, 105891),
(105892, '3.30.830.10-FF-000303', NULL, 'Uncharacterized protein', 169, NULL, NULL, 105892),
(105893, '1.10.472.10-FF-000511', NULL, 'Uncharacterized protein', 100, NULL, NULL, 105893),
(105894, '1.10.10.10-FF-001955', NULL, 'COP9 signalosome complex subunit 12', 77, NULL, NULL, 105894),
(105895, '3.90.70.10-FF-000467', NULL, 'Predicted protein', 204, NULL, NULL, 105895),
(105896, '3.40.50.1000-FF-000476', NULL, NULL, 127, NULL, NULL, 105896),
(105897, '3.40.50.300-FF-000880', NULL, 'Primosomal protein DnaI', 195, NULL, NULL, 105897),
(105898, '3.40.50.1000-FF-000419', NULL, 'Haloacid dehalogenase-like hydrolase family protein', 143, NULL, NULL, 105898),
(105899, '3.40.50.2300-FF-000141', NULL, 'piwi-like protein 2 isoform X1', 128, NULL, NULL, 105899),
(105900, '3.40.50.720-FF-001848', NULL, 'Ubiquitin-activating enzyme e1 1 putative', 51, NULL, NULL, 105900),
(105901, '3.30.1490.20-FF-000099', NULL, 'D-alanine--D-alanine ligase', 73, NULL, NULL, 105901),
(105902, '1.10.533.10-FF-000086', NULL, 'AO66 ankyrin', 90, NULL, NULL, 105902),
(105903, '1.20.5.190-FF-000021', NULL, 'IQ motif containing N', 44, NULL, NULL, 105903),
(105904, '3.30.530.20-FF-000199', NULL, 'Uncharacterized protein', 81, NULL, NULL, 105904),
(105905, '1.10.150.240-FF-000105', NULL, 'Phosphoglycolate phosphatase, putative (AFU_orthologue AFUA_7G00760)', 77, NULL, NULL, 105905),
(105906, '4.10.410.10-FF-000109', NULL, 'Uncharacterized protein', 60, NULL, NULL, 105906),
(105907, '3.40.50.720-FF-001904', NULL, 'Uncharacterized protein', 67, NULL, NULL, 105907),
(105908, '3.30.200.20-FF-000444', NULL, 'MDIS1-interacting receptor like kinase 1', 85, NULL, NULL, 105908),
(105909, '3.90.79.10-FF-000228', NULL, 'mRNA-decapping enzyme subunit 2', 94, NULL, NULL, 105909),
(105910, '1.10.10.60-FF-000363', NULL, 'Kismet, isoform D', 118, NULL, NULL, 105910),
(105911, '3.40.50.2300-FF-000085', NULL, 'AraC family transcriptional regulator', 144, NULL, NULL, 105911),
(105912, '2.60.40.10-FF-004050', NULL, NULL, 97, NULL, NULL, 105912),
(105913, '2.60.40.60-FF-000214', NULL, 'Dachsous cadherin-related 1', 118, NULL, NULL, 105913),
(105914, '1.10.238.10-FF-000181', NULL, 'CALML5 isoform 1', 71, NULL, NULL, 105914),
(105915, '2.130.10.10-FF-000317', NULL, 'striatin-4 isoform X2', 106, NULL, NULL, 105915),
(105916, '2.160.10.10-FF-000052', NULL, 'Translation initiation factor eIF-2B subunit epsilon', 56, NULL, NULL, 105916),
(105917, '2.130.10.10-FF-001897', NULL, 'EG:25E8.3 protein', 177, NULL, NULL, 105917),
(105918, '3.90.70.10-FF-000703', NULL, 'Cysteine proteinase, putative', 214, NULL, NULL, 105918),
(105919, '3.90.1150.10-FF-000192', NULL, 'Aminotransferase, putative', 101, NULL, NULL, 105919),
(105920, '3.10.50.40-FF-000074', NULL, 'Peptidylprolyl isomerase', 109, NULL, NULL, 105920);
INSERT INTO "PUBLIC"."MODEL" VALUES
(105921, '2.60.40.1910-FF-000003', NULL, 'Aminopeptidase', 90, NULL, NULL, 105921),
(105922, '2.30.39.10-FF-000068', NULL, 'Uncharacterized protein', 150, NULL, NULL, 105922),
(105923, '1.25.40.10-FF-003868', NULL, 'Uncharacterized protein', 99, NULL, NULL, 105923),
(105924, '1.20.1250.20-FF-002013', NULL, 'Transporter MFS superfamily', 371, NULL, NULL, 105924),
(105925, '2.40.30.10-FF-000334', NULL, 'Uncharacterized protein', 89, NULL, NULL, 105925),
(105926, '2.60.40.640-FF-000063', NULL, 'Arrestin', 124, NULL, NULL, 105926),
(105927, '2.60.40.60-FF-000158', NULL, 'Dachsous cadherin-related 1', 106, NULL, NULL, 105927),
(105928, '3.30.40.10-FF-001592', NULL, 'Histone-lysine N-methyltransferase', 102, NULL, NULL, 105928),
(105929, '3.40.50.150-FF-000812', NULL, NULL, 104, NULL, NULL, 105929),
(105930, '1.10.510.10-FF-000842', NULL, 'Nuclear receptor-binding protein', 217, NULL, NULL, 105930),
(105931, '1.25.10.10-FF-000612', NULL, 'Serine/threonine-protein kinase Nek10', 351, NULL, NULL, 105931),
(105932, '3.30.60.30-FF-000138', NULL, 'Uncharacterized protein', 46, NULL, NULL, 105932),
(105933, '3.40.140.10-FF-000063', NULL, 'DNA repair protein RadC', 124, NULL, NULL, 105933),
(105934, '3.30.1370.10-FF-000110', NULL, 'Uncharacterized protein, isoform A', 133, NULL, NULL, 105934),
(105935, '3.30.200.20-FF-000500', NULL, 'Putative aminoglycoside phosphotransferase', 102, NULL, NULL, 105935),
(105936, '1.25.40.10-FF-001688', NULL, 'Putative pentatricopeptide repeat-containing protein', 72, NULL, NULL, 105936),
(105937, '3.30.60.20-FF-000135', NULL, 'Diacylglycerol kinase', 40, NULL, NULL, 105937),
(105938, '2.160.20.70-FF-000048', NULL, 'Uncharacterized protein', 177, NULL, NULL, 105938),
(105939, '2.30.29.30-FF-001304', NULL, 'Uncharacterized protein', 79, NULL, NULL, 105939),
(105940, '1.20.140.100-FF-000019', NULL, 'Putative dynein heavy chain, cytosolic', 159, NULL, NULL, 105940),
(105941, '3.10.290.10-FF-000092', NULL, 'Pre-mRNA-processing factor 19 homolog 2', 33, NULL, NULL, 105941),
(105942, '3.40.50.10860-FF-000038', NULL, 'Quinate dehydrogenase', 95, NULL, NULL, 105942),
(105943, '1.20.58.390-FF-000081', NULL, 'Proton-gated ion channel subunit pbo-5', 142, NULL, NULL, 105943),
(105944, '1.20.1270.60-FF-000267', NULL, 'LD28528p', 112, NULL, NULL, 105944),
(105945, '2.30.30.790-FF-000011', NULL, '50S ribosomal protein L19', 128, NULL, NULL, 105945),
(105946, '3.30.750.70-FF-000005', NULL, 'Glycerol-3-phosphate regulon repressor DeoR family', 64, NULL, NULL, 105946),
(105947, '1.25.40.990-FF-000021', NULL, 'Proteasome 26S subunit, non-ATPase 8', 147, NULL, NULL, 105947),
(105948, '3.40.50.2000-FF-000113', NULL, 'Alpha,alpha-trehalose-phosphate synthase', 202, NULL, NULL, 105948),
(105949, '1.10.10.10-FF-001388', NULL, 'Predicted protein', 75, NULL, NULL, 105949),
(105950, '3.40.605.10-FF-000076', NULL, '4-hydroxybenzaldehyde dehydrogenase (NADP(+))', 272, NULL, NULL, 105950),
(105951, '3.90.70.10-FF-000742', NULL, 'Cysteine protease', 143, NULL, NULL, 105951),
(105952, '2.60.40.2130-FF-000002', NULL, 'Putative Spondin-1', 201, NULL, NULL, 105952),
(105953, '3.80.10.10-FF-001009', NULL, 'Pollen receptor-like kinase 6', 166, NULL, NULL, 105953),
(105954, '1.10.510.10-FF-002972', NULL, NULL, 125, NULL, NULL, 105954),
(105955, '1.10.260.170-FF-000007', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', 160, NULL, NULL, 105955),
(105956, '3.30.160.60-FF-002296', NULL, 'Zinc finger protein 169', 28, NULL, NULL, 105956),
(105957, '3.30.450.70-FF-000022', NULL, 'Trafficking protein particle complex subunit', 139, NULL, NULL, 105957),
(105958, '2.130.10.10-FF-001953', NULL, 'Uncharacterized protein', 386, NULL, NULL, 105958),
(105959, '1.10.533.10-FF-000029', NULL, 'Myeloid differentiation primary response protein MyD88', 109, NULL, NULL, 105959),
(105960, '3.40.1810.10-FF-000024', NULL, 'Agamous-like MADS-box protein AGL80', 86, NULL, NULL, 105960),
(105961, '2.60.40.10-FF-001008', NULL, 'Interleukin-12 subunit beta', 109, NULL, NULL, 105961),
(105962, '1.25.40.10-FF-001744', NULL, 'Outer envelope protein 64, chloroplastic', 111, NULL, NULL, 105962);
INSERT INTO "PUBLIC"."MODEL" VALUES
(105963, '1.20.1070.10-FF-001187', NULL, 'Uncharacterized protein', 266, NULL, NULL, 105963),
(105964, '1.10.1200.270-FF-000029', NULL, 'Os01g0700300 protein', 36, NULL, NULL, 105964),
(105965, '2.130.10.10-FF-006045', NULL, 'Predicted protein', 92, NULL, NULL, 105965),
(105966, '3.40.1110.10-FF-000347', NULL, NULL, 59, NULL, NULL, 105966),
(105967, '2.80.10.50-FF-000107', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 135, NULL, NULL, 105967),
(105968, '1.10.472.130-FF-000084', NULL, 'Dynein, axonemal, heavy chain 3, isoform D', 153, NULL, NULL, 105968),
(105969, '3.40.50.1820-FF-001172', NULL, 'Uncharacterized protein', 221, NULL, NULL, 105969),
(105970, '3.60.40.10-FF-000388', NULL, 'Uncharacterized protein', 119, NULL, NULL, 105970),
(105971, '1.20.120.610-FF-000011', NULL, 'Uncharacterized protein', 94, NULL, NULL, 105971),
(105972, '2.30.180.10-FF-000105', NULL, NULL, 152, NULL, NULL, 105972),
(105973, '3.40.120.10-FF-000062', NULL, 'Phosphoacetylglucosamine mutase', 153, NULL, NULL, 105973),
(105974, '2.60.40.10-FF-006067', NULL, NULL, 96, NULL, NULL, 105974),
(105975, '2.30.29.30-FF-001248', NULL, 'Guanine exchange factor for Rac 30', 110, NULL, NULL, 105975),
(105976, '3.40.50.2020-FF-000158', NULL, 'Uncharacterized protein', 94, NULL, NULL, 105976),
(105977, '1.10.8.1290-FF-000003', NULL, 'Glutamine--tRNA ligase', 115, NULL, NULL, 105977),
(105978, '3.20.80.10-FF-000049', NULL, 'Uncharacterized protein', 183, NULL, NULL, 105978),
(105979, '2.10.25.10-FF-001751', NULL, 'Neuregulin 2b', 36, NULL, NULL, 105979),
(105980, '3.30.160.60-FF-002239', NULL, 'Zinc finger protein 226', 28, NULL, NULL, 105980),
(105981, '1.10.1370.30-FF-000037', NULL, 'Angiotensin-converting enzyme', 138, NULL, NULL, 105981),
(105982, '1.25.10.10-FF-001916', NULL, 'Predicted protein', 514, NULL, NULL, 105982),
(105983, '1.10.630.10-FF-000210', NULL, 'Ent-kaurenoic acid oxidase 1', 64, NULL, NULL, 105983),
(105984, '3.80.10.10-FF-001178', NULL, 'Uncharacterized protein', 151, NULL, NULL, 105984),
(105985, '2.115.10.20-FF-000013', NULL, 'Non-reducing end alpha-L-arabinofuranosidase BoGH43A', 307, NULL, NULL, 105985),
(105986, '1.25.40.20-FF-000437', NULL, 'Lethal (2) 35Be', 89, NULL, NULL, 105986),
(105987, '1.20.120.350-FF-000259', NULL, NULL, 122, NULL, NULL, 105987),
(105988, '1.25.40.10-FF-000434', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 185, NULL, NULL, 105988),
(105989, '1.10.20.10-FF-000146', NULL, 'Histone H2A', 89, NULL, NULL, 105989),
(105990, '3.30.110.30-FF-000002', NULL, 'Proline--tRNA ligase', 77, NULL, NULL, 105990),
(105991, '3.40.525.10-FF-000075', NULL, 'Uncharacterized protein', 87, NULL, NULL, 105991),
(105992, '2.60.120.1040-FF-000012', NULL, NULL, 106, NULL, NULL, 105992),
(105993, '3.10.20.310-FF-000035', NULL, 'ShlB/FhaC/HecB family hemolysin secretion/activation protein', 90, NULL, NULL, 105993),
(105994, '3.20.20.210-FF-000008', NULL, 'Uroporphyrinogen decarboxylase', 367, NULL, NULL, 105994),
(105995, '1.10.1300.10-FF-000044', NULL, 'Phosphodiesterase', 115, NULL, NULL, 105995),
(105996, '1.20.120.1080-FF-000058', NULL, 'ATP-dependent RNA helicase', 112, NULL, NULL, 105996),
(105997, '2.60.40.10-FF-002644', NULL, 'Protease', 85, NULL, NULL, 105997),
(105998, '1.10.220.10-FF-000067', NULL, 'Annexin', 49, NULL, NULL, 105998),
(105999, '1.20.1250.20-FF-001670', NULL, 'Predicted protein', 112, NULL, NULL, 105999),
(106000, '3.40.50.300-FF-008423', NULL, 'Predicted protein', 117, NULL, NULL, 106000),
(106001, '3.90.1290.10-FF-000078', NULL, 'Uncharacterized protein', 98, NULL, NULL, 106001),
(106002, '2.20.25.80-FF-000012', NULL, 'Probable WRKY transcription factor 38', 78, NULL, NULL, 106002),
(106003, '1.10.510.10-FF-004153', NULL, NULL, 238, NULL, NULL, 106003),
(106004, '2.70.130.10-FF-000071', NULL, NULL, 116, NULL, NULL, 106004),
(106005, '2.60.40.1460-FF-000003', NULL, 'Integrin subunit alpha 7', 168, NULL, NULL, 106005),
(106006, '3.90.550.10-FF-000190', NULL, '2-phospho-L-lactate guanylyltransferase', 172, NULL, NULL, 106006),
(106007, '1.25.40.10-FF-001963', NULL, 'Pentatricopeptide repeat-containing protein isoform A', 128, NULL, NULL, 106007);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(106008, '2.40.30.170-FF-000008', NULL, 'Multidrug resistance protein MdtN', 120, NULL, NULL, 106008),
(106009, '1.10.510.10-FF-004265', NULL, NULL, 187, NULL, NULL, 106009),
(106010, '3.40.800.10-FF-000029', NULL, 'Uncharacterized protein, isoform B', 171, NULL, NULL, 106010),
(106011, '4.10.640.10-FF-000031', NULL, 'Uncharacterized protein', 66, NULL, NULL, 106011),
(106012, '3.40.50.1240-FF-000020', NULL, 'Periplasmic AppA protein', 270, NULL, NULL, 106012),
(106013, '2.20.25.90-FF-000015', NULL, NULL, 54, NULL, NULL, 106013),
(106014, '3.40.640.10-FF-000320', NULL, 'Probable L-aspartate decarboxylase', 246, NULL, NULL, 106014),
(106015, '3.40.640.10-FF-000500', NULL, 'Ornithine aminotransferase', 157, NULL, NULL, 106015),
(106016, '3.30.465.10-FF-000010', NULL, 'DUF21 domain-containing protein', 78, NULL, NULL, 106016),
(106017, '3.30.420.40-FF-000764', NULL, 'Predicted protein', 76, NULL, NULL, 106017),
(106018, '3.60.20.40-FF-000042', NULL, 'Uncharacterized protein', 117, NULL, NULL, 106018),
(106019, '3.40.50.80-FF-000202', NULL, 'Putative ferric reductase', 173, NULL, NULL, 106019),
(106020, '3.30.70.330-FF-001474', NULL, NULL, 85, NULL, NULL, 106020),
(106021, '3.10.330.20-FF-000025', NULL, 'Beta-aspartate methyltransferase (PimT), conjectural', 61, NULL, NULL, 106021),
(106022, '1.10.472.10-FF-000062', NULL, 'Origin recognition complex subunit 6', 97, NULL, NULL, 106022),
(106023, '2.60.40.10-FF-004830', NULL, NULL, 72, NULL, NULL, 106023),
(106024, '1.10.472.10-FF-000005', NULL, 'G2/mitotic-specific cyclin B', 128, NULL, NULL, 106024),
(106025, '2.60.40.2300-FF-000019', NULL, 'Neutral ceramidase-like Protein', 73, NULL, NULL, 106025),
(106026, '3.40.50.300-FF-001610', NULL, 'ABC transporter ATP-binding protein-sodium transport', 211, NULL, NULL, 106026),
(106027, '3.40.1000.10-FF-000013', NULL, 'Putative lipoprotein LpqT', 142, NULL, NULL, 106027),
(106028, '3.30.1370.130-FF-000001', NULL, 'Type IV pilus secretin PilQ', 59, NULL, NULL, 106028),
(106029, '3.30.2350.20-FF-000050', NULL, NULL, 208, NULL, NULL, 106029),
(106030, '3.90.70.40-FF-000009', NULL, 'Ataxin-3, putative', 109, NULL, NULL, 106030),
(106031, '3.40.50.1820-FF-001059', NULL, 'Lipase', 374, NULL, NULL, 106031),
(106032, '1.10.720.60-FF-000024', NULL, 'Enolase-phosphatase E1', 39, NULL, NULL, 106032),
(106033, '2.130.10.10-FF-000374', NULL, 'NACHT and WD repeat domain containing 2', 265, NULL, NULL, 106033),
(106034, '3.30.160.60-FF-005909', NULL, NULL, 47, NULL, NULL, 106034),
(106035, '3.30.565.30-FF-000001', NULL, 'Sporulation initiation phosphotransferase', 116, NULL, NULL, 106035),
(106036, '2.60.40.10-FF-001969', NULL, 'Cell surface A33 antigen', 124, NULL, NULL, 106036),
(106037, '3.40.50.1000-FF-000526', NULL, NULL, 88, NULL, NULL, 106037),
(106038, '2.60.120.260-FF-000211', NULL, 'Cytosolic endobeta-n-acetylglucosaminidase, putative', 212, NULL, NULL, 106038),
(106039, '1.10.287.4280-FF-000002', NULL, 'Transcription factor unc-3', 55, NULL, NULL, 106039),
(106040, '3.40.50.10470-FF-000067', NULL, 'Initiation factor 2 subunit family protein', 201, NULL, NULL, 106040),
(106041, '3.10.100.10-FF-000157', NULL, NULL, 125, NULL, NULL, 106041),
(106042, '1.20.1070.10-FF-001417', NULL, 'Uncharacterized protein', 231, NULL, NULL, 106042),
(106043, '3.80.10.10-FF-004033', NULL, 'Uncharacterized protein', 144, NULL, NULL, 106043),
(106044, '3.40.50.300-FF-000773', NULL, 'Replication factor C subunit 1', 189, NULL, NULL, 106044),
(106045, '2.120.10.80-FF-000260', NULL, 'Predicted protein', 333, NULL, NULL, 106045),
(106046, '1.10.486.10-FF-000003', NULL, 'ATP-dependent DNA helicase', 166, NULL, NULL, 106046),
(106047, '2.60.120.10-FF-000797', NULL, 'Uncharacterized protein', 134, NULL, NULL, 106047),
(106048, '1.10.287.470-FF-000089', NULL, 'Multidrug resistance protein A', 24, NULL, NULL, 106048),
(106049, '3.30.160.60-FF-003875', NULL, NULL, 25, NULL, NULL, 106049),
(106050, '2.60.120.920-FF-000156', NULL, 'Si:ch211-227e10.1', 176, NULL, NULL, 106050),
(106051, '2.120.10.80-FF-000108', NULL, 'Kelch repeat-containing protein', 113, NULL, NULL, 106051);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(106052, '1.25.10.10-FF-000556', NULL, 'GCN1, eIF2 alpha kinase activator homolog', 450, NULL, NULL, 106052),
(106053, '3.40.225.10-FF-000035', NULL, NULL, 212, NULL, NULL, 106053),
(106054, '1.20.1250.20-FF-001176', NULL, 'GPH family Na+:melibiose symporter', 206, NULL, NULL, 106054),
(106055, '3.40.50.11380-FF-000008', NULL, NULL, 221, NULL, NULL, 106055),
(106056, '3.30.70.3490-FF-000034', NULL, NULL, 89, NULL, NULL, 106056),
(106057, '3.40.190.10-FF-000010', NULL, 'glutamate receptor ionotropic, NMDA 1 isoform X1', 102, NULL, NULL, 106057),
(106058, '3.40.50.150-FF-000705', NULL, 'Uncharacterized protein', 250, NULL, NULL, 106058),
(106059, '3.90.1680.10-FF-000001', NULL, 'Abasic site processing protein HMCES', 275, NULL, NULL, 106059),
(106060, '3.30.160.60-FF-004482', NULL, NULL, 26, NULL, NULL, 106060),
(106061, '1.10.10.60-FF-000306', NULL, 'Muscle segmentation homeobox', 95, NULL, NULL, 106061),
(106062, '1.25.10.10-FF-001899', NULL, 'Pumilio-like 24 isoform A', 242, NULL, NULL, 106062),
(106063, '1.20.1070.10-FF-001018', NULL, 'AKH/corazonin-related peptide', 186, NULL, NULL, 106063),
(106064, '3.40.50.300-FF-007006', NULL, 'Predicted protein', 209, NULL, NULL, 106064),
(106065, '1.10.3430.10-FF-000054', NULL, 'Uncharacterized protein', 230, NULL, NULL, 106065),
(106066, '3.20.20.370-FF-000028', NULL, 'Putative Chitin deacetylase', 237, NULL, NULL, 106066),
(106067, '3.90.226.10-FF-000329', NULL, 'Uncharacterized protein', 124, NULL, NULL, 106067),
(106068, '3.30.1360.140-FF-000002', NULL, 'DNA-directed RNA polymerase subunit', 132, NULL, NULL, 106068),
(106069, '1.25.40.20-FF-001112', NULL, 'AGAP010413-PA', 232, NULL, NULL, 106069),
(106070, '2.10.25.10-FF-001190', NULL, 'Predicted protein', 40, NULL, NULL, 106070),
(106071, '1.10.510.10-FF-003658', NULL, NULL, 181, NULL, NULL, 106071),
(106072, '3.40.50.10190-FF-000197', NULL, 'Protein CBR-MUS-101', 99, NULL, NULL, 106072),
(106073, '1.20.1250.20-FF-001119', NULL, 'Arabinose efflux permease', 189, NULL, NULL, 106073),
(106074, '1.25.40.10-FF-004543', NULL, 'Uncharacterized protein', 231, NULL, NULL, 106074),
(106075, '1.10.238.10-FF-000922', NULL, 'EF-hand calcium-binding domain-containing protein 6-like', 78, NULL, NULL, 106075),
(106076, '3.10.120.10-FF-000046', NULL, 'Chitin synthase', 89, NULL, NULL, 106076),
(106077, '3.50.7.10-FF-000026', NULL, 'T-complex protein 1 subunit delta', 161, NULL, NULL, 106077),
(106078, '3.40.1080.10-FF-000006', NULL, '6-acetamido-3-oxohexanoate:acetyl-CoA CoA transferase alpha subunit', 228, NULL, NULL, 106078),
(106079, '1.10.510.10-FF-000555', NULL, 'Mitogen-activated protein kinase', 92, NULL, NULL, 106079),
(106080, '3.30.40.10-FF-000985', NULL, 'RING/U-box superfamily protein', 82, NULL, NULL, 106080),
(106081, '1.10.8.100-FF-000013', NULL, 'Ribosomal RNA small subunit methyltransferase A', 64, NULL, NULL, 106081),
(106082, '1.25.40.10-FF-002126', NULL, 'Pentatricopeptide repeat-containing protein', 170, NULL, NULL, 106082),
(106083, '1.20.210.10-FF-000013', NULL, 'Cytochrome c oxidase subunit 1', 337, NULL, NULL, 106083),
(106084, '1.25.10.10-FF-002916', NULL, 'Uncharacterized protein', 111, NULL, NULL, 106084),
(106085, '1.10.238.10-FF-000703', NULL, 'Calmodulin, putative', 97, NULL, NULL, 106085),
(106086, '1.20.1110.10-FF-000117', NULL, 'Calcium-transporting ATPase', 183, NULL, NULL, 106086),
(106087, '1.20.58.80-FF-000057', NULL, 'Vacuolar protein sorting-associated protein 4B', 82, NULL, NULL, 106087),
(106088, '2.60.40.150-FF-000135', NULL, 'Plant synaptotagmin', 143, NULL, NULL, 106088),
(106089, '3.30.519.10-FF-000012', NULL, 'Rab proteins geranylgeranyltransferase component', 195, NULL, NULL, 106089),
(106090, '2.10.25.10-FF-000857', NULL, 'Uncharacterized protein', 37, NULL, NULL, 106090),
(106091, '3.40.50.300-FF-002392', NULL, 'DnaJ-like protein subfamily C member 27', 173, NULL, NULL, 106091),
(106092, '2.60.40.150-FF-000079', NULL, 'copine-1 isoform X2', 131, NULL, NULL, 106092),
(106093, '2.40.10.10-FF-000389', NULL, NULL, 64, NULL, NULL, 106093),
(106094, '3.80.10.10-FF-003651', NULL, 'F-box and leucine-rich repeat protein 6', 172, NULL, NULL, 106094);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(106095, '1.10.533.10-FF-000316', NULL, 'Uncharacterized protein', 19, NULL, NULL, 106095),
(106096, '2.40.170.20-FF-000055', NULL, 'Heme receptor HasR', 619, NULL, NULL, 106096),
(106097, '1.20.58.70-FF-000054', NULL, 'Uncharacterized protein', 218, NULL, NULL, 106097),
(106098, '2.60.40.10-FF-002026', NULL, 'Prostaglandin F2 receptor inhibitor', 125, NULL, NULL, 106098),
(106099, '2.30.42.10-FF-000250', NULL, 'Lap1, isoform B', 105, NULL, NULL, 106099),
(106100, '1.10.418.10-FF-000127', NULL, 'Cortexillin, putative', 101, NULL, NULL, 106100),
(106101, '2.120.10.30-FF-000447', NULL, 'Uncharacterized protein', 113, NULL, NULL, 106101),
(106102, '1.10.8.270-FF-000036', NULL, 'GTPase-activating protein GYP3', 113, NULL, NULL, 106102),
(106103, '2.40.10.10-FF-000445', NULL, NULL, 69, NULL, NULL, 106103),
(106104, '3.90.940.20-FF-000003', NULL, 'Predicted protein', 72, NULL, NULL, 106104),
(106105, '3.40.50.150-FF-001829', NULL, NULL, 72, NULL, NULL, 106105),
(106106, '2.120.10.30-FF-000503', NULL, 'Uncharacterized protein', 214, NULL, NULL, 106106),
(106107, '3.40.50.10740-FF-000002', NULL, 'Microcin immunity protein MccF', 164, NULL, NULL, 106107),
(106108, '3.30.200.20-FF-001793', NULL, 'Protein kinase', 142, NULL, NULL, 106108),
(106109, '3.30.160.60-FF-002857', NULL, 'Si:dkeyp-82b4.3', 32, NULL, NULL, 106109),
(106110, '2.40.30.10-FF-000172', NULL, 'Unplaced genomic scaffold supercont1.10, whole genome shotgun sequence', 101, NULL, NULL, 106110),
(106111, '3.40.50.300-FF-006006', NULL, 'UvrABC system protein A', 191, NULL, NULL, 106111),
(106112, '2.60.120.260-FF-000031', NULL, 'DUF642 family protein', 172, NULL, NULL, 106112),
(106113, '3.60.21.60-FF-000016', NULL, 'DNA polymerase alpha subunit B-like', 174, NULL, NULL, 106113),
(106114, '3.40.50.980-FF-000044', NULL, 'Peptide synthetase', 174, NULL, NULL, 106114),
(106115, '3.30.160.60-FF-003133', NULL, 'zinc finger protein 271', 28, NULL, NULL, 106115),
(106116, '1.10.1040.10-FF-000001', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(P)+]', 145, NULL, NULL, 106116),
(106117, '1.25.10.10-FF-000500', NULL, 'VAC14 domain-containing protein', 141, NULL, NULL, 106117),
(106118, '1.10.220.60-FF-000003', NULL, 'GRIP and coiled-coil domain-containing protein 2', 62, NULL, NULL, 106118),
(106119, '3.30.420.80-FF-000023', NULL, 'YALI0E14124p', 162, NULL, NULL, 106119),
(106120, '3.40.190.10-FF-000066', NULL, 'Glutamate receptor ionotropic, NMDA 3A', 170, NULL, NULL, 106120),
(106121, '2.40.100.10-FF-000047', NULL, 'Urea amidolyase', 159, NULL, NULL, 106121),
(106122, '2.10.25.10-FF-001077', NULL, 'Notch receptor 2', 36, NULL, NULL, 106122),
(106123, '3.40.50.1820-FF-001402', NULL, 'Uncharacterized protein', 210, NULL, NULL, 106123),
(106124, '1.10.1410.10-FF-000103', NULL, 'Uncharacterized protein', 13, NULL, NULL, 106124),
(106125, '3.60.21.50-FF-000013', NULL, 'DNA polymerase epsilon subunit b domain-containing protein', 185, NULL, NULL, 106125),
(106126, '3.40.850.10-FF-000420', NULL, 'Uncharacterized protein', 203, NULL, NULL, 106126),
(106127, '3.40.50.970-FF-000041', NULL, 'Pyruvate:ferredoxin (Flavodoxin) oxidoreductase', 386, NULL, NULL, 106127),
(106128, '3.40.50.300-FF-000593', NULL, 'DNA repair protein RAD50', 163, NULL, NULL, 106128),
(106129, '3.30.1380.20-FF-000052', NULL, 'Trafficking protein particle complex 6b-like', 85, NULL, NULL, 106129),
(106130, '3.30.420.40-FF-000146', NULL, 'Type III pantothenate kinase', 89, NULL, NULL, 106130),
(106131, '2.60.40.10-FF-000845', NULL, 'Hyaluronan and proteoglycan link protein 3', 118, NULL, NULL, 106131),
(106132, '1.10.10.60-FF-000924', NULL, NULL, 70, NULL, NULL, 106132),
(106133, '2.130.10.10-FF-005663', NULL, 'Uncharacterized protein', 165, NULL, NULL, 106133),
(106134, '1.10.472.130-FF-000027', NULL, 'Dynein, axonemal, heavy chain 14', 128, NULL, NULL, 106134),
(106135, '3.30.1370.10-FF-000109', NULL, 'Heterogeneous nuclear rnp K-like protein 2', 71, NULL, NULL, 106135),
(106136, '1.20.20.10-FF-000005', NULL, 'ATP synthase subunit 9, mitochondrial', 70, NULL, NULL, 106136),
(106137, '1.10.510.10-FF-003990', NULL, NULL, 77, NULL, NULL, 106137);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(106138, '3.50.50.60-FF-001359', NULL, 'Flavin-containing monooxygenase', 86, NULL, NULL, 106138),
(106139, '3.10.110.10-FF-000219', NULL, 'Uncharacterized protein', 150, NULL, NULL, 106139),
(106140, '1.20.120.720-FF-000044', NULL, 'Chitin synthase-domain-containing protein', 22, NULL, NULL, 106140),
(106141, '1.10.10.10-FF-000426', NULL, 'Transcriptional regulator MT0503', 63, NULL, NULL, 106141),
(106142, '2.40.30.10-FF-000059', NULL, 'dual oxidase isoform X1', 99, NULL, NULL, 106142),
(106143, '3.20.20.70-FF-000266', NULL, '4-hydroxy-2-oxoglutarate aldolase/2-dehydro-3-deoxyphosphogluconate', 204, NULL, NULL, 106143),
(106144, '3.80.10.10-FF-003033', NULL, 'Uncharacterized protein', 166, NULL, NULL, 106144),
(106145, '1.25.40.10-FF-002525', NULL, 'Zinc finger family protein', 148, NULL, NULL, 106145),
(106146, '3.80.10.10-FF-001739', NULL, 'MIP30824p1', 291, NULL, NULL, 106146),
(106147, '3.10.660.10-FF-000013', NULL, 'Uncharacterized protein', 75, NULL, NULL, 106147),
(106148, '1.10.730.10-FF-000206', NULL, 'Uncharacterized protein', 60, NULL, NULL, 106148),
(106149, '3.30.420.340-FF-000005', NULL, 'UvrABC system protein C', 181, NULL, NULL, 106149),
(106150, '2.60.40.10-FF-001121', NULL, 'Fc receptor like B', 82, NULL, NULL, 106150),
(106151, '4.10.60.10-FF-000024', NULL, 'terminal uridylyltransferase 7 isoform X1', 34, NULL, NULL, 106151),
(106152, '3.10.100.10-FF-000432', NULL, NULL, 77, NULL, NULL, 106152),
(106153, '1.10.506.10-FF-000006', NULL, 'Plexin A1', 238, NULL, NULL, 106153),
(106154, '2.130.10.10-FF-002734', NULL, 'Predicted protein', 293, NULL, NULL, 106154),
(106155, '1.20.870.10-FF-000046', NULL, 'Ras guanine nucleotide exchange factor V', 143, NULL, NULL, 106155),
(106156, '1.10.472.10-FF-000623', NULL, 'Meiosis-specific cyclin rem1', 126, NULL, NULL, 106156),
(106157, '2.60.40.10-FF-000227', NULL, 'Fibronectin isoform X1', 94, NULL, NULL, 106157),
(106158, '1.20.58.60-FF-000051', NULL, 'Short stop, isoform K', 111, NULL, NULL, 106158),
(106159, '3.90.740.10-FF-000069', NULL, 'Uncharacterized protein', 37, NULL, NULL, 106159),
(106160, '3.40.50.2300-FF-001445', NULL, NULL, 55, NULL, NULL, 106160),
(106161, '1.25.40.10-FF-004324', NULL, 'Protein O-mannosyl-transferase TMTC1', 172, NULL, NULL, 106161),
(106162, '2.60.40.10-FF-004555', NULL, NULL, 127, NULL, NULL, 106162),
(106163, '3.80.10.10-FF-003538', NULL, 'Tubulin-specific chaperone cofactor E-like protein', 161, NULL, NULL, 106163),
(106164, '3.40.50.12280-FF-000003', NULL, 'NAD(P)H-quinone oxidoreductase subunit K, chloroplastic', 174, NULL, NULL, 106164),
(106165, '1.10.287.2250-FF-000017', NULL, 'Predicted protein', 61, NULL, NULL, 106165),
(106166, '3.40.50.1820-FF-001677', NULL, 'ArfGAP', 240, NULL, NULL, 106166),
(106167, '3.90.550.10-FF-000419', NULL, 'Uncharacterized protein', 157, NULL, NULL, 106167),
(106168, '1.10.10.10-FF-000084', NULL, 'paired box protein Pax-9', 72, NULL, NULL, 106168),
(106169, '2.60.40.10-FF-000284', NULL, 'interleukin-1 receptor accessory protein-like 1', 119, NULL, NULL, 106169),
(106170, '3.90.80.10-FF-000024', NULL, 'Uncharacterized protein', 105, NULL, NULL, 106170),
(106171, '3.30.870.10-FF-000070', NULL, 'Phospholipase D family protein', 203, NULL, NULL, 106171),
(106172, '2.60.40.10-FF-002425', NULL, 'Down syndrome cell adhesion molecule 3, isoform C', 82, NULL, NULL, 106172),
(106173, '3.30.2140.20-FF-000017', NULL, 'Uncharacterized protein', 281, NULL, NULL, 106173),
(106174, '1.25.40.10-FF-002183', NULL, 'GH04440p', 190, NULL, NULL, 106174),
(106175, '1.10.510.10-FF-002079', NULL, 'Serine/threonine-protein kinase, putative', 406, NULL, NULL, 106175),
(106176, '1.10.10.60-FF-000582', NULL, 'HTH-type transcriptional regulator VirS', 105, NULL, NULL, 106176),
(106177, '3.30.900.10-FF-000011', NULL, 'HORMA domain protein, putative', 193, NULL, NULL, 106177),
(106178, '2.30.30.1020-FF-000007', NULL, 'Putative not2 family protein', 183, NULL, NULL, 106178),
(106179, '3.40.50.150-FF-000525', NULL, 'S-adenosyl-methyltransferase mraW-like protein', 159, NULL, NULL, 106179),
(106180, '1.20.1250.20-FF-000102', NULL, 'Inner membrane protein ybjJ', 189, NULL, NULL, 106180);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(106181, '3.40.50.150-FF-000582', NULL, 'AflS/ pathway regulator', 278, NULL, NULL, 106181),
(106182, '3.30.60.60-FF-000012', NULL, 'Histone acetyltransferase', 63, NULL, NULL, 106182),
(106183, '1.10.150.390-FF-000009', NULL, 'DNA-directed RNA polymerase subunit', 45, NULL, NULL, 106183),
(106184, '1.50.40.10-FF-000371', NULL, 'Uncharacterized protein', 139, NULL, NULL, 106184),
(106185, '1.10.940.10-FF-000020', NULL, 'Transcription antitermination protein NusB', 138, NULL, NULL, 106185),
(106186, '2.70.170.10-FF-000135', NULL, 'Uncharacterized protein', 122, NULL, NULL, 106186),
(106187, '3.30.800.10-FF-000026', NULL, NULL, 144, NULL, NULL, 106187),
(106188, '3.40.395.10-FF-000036', NULL, 'Ubiquitin-like-specific protease ESD4', 294, NULL, NULL, 106188),
(106189, '2.40.70.10-FF-000511', NULL, NULL, 90, NULL, NULL, 106189),
(106190, '3.40.1280.10-FF-000100', NULL, 'Predicted protein', 172, NULL, NULL, 106190),
(106191, '2.130.10.10-FF-000593', NULL, 'Ribosome biogenesis protein ytm1', 386, NULL, NULL, 106191),
(106192, '1.10.1170.10-FF-000005', NULL, 'Baculoviral IAP repeat containing 2', 113, NULL, NULL, 106192),
(106193, '1.20.120.1200-FF-000021', NULL, 'NADH-quinone oxidoreductase subunit J', 162, NULL, NULL, 106193),
(106194, '3.30.160.60-FF-005786', NULL, NULL, 39, NULL, NULL, 106194),
(106195, '3.40.640.10-FF-000264', NULL, 'Kynurenine--oxoglutarate transaminase 1', 258, NULL, NULL, 106195),
(106196, '1.10.8.60-FF-000558', NULL, 'Uncharacterized protein', 51, NULL, NULL, 106196),
(106197, '3.40.50.2300-FF-001389', NULL, NULL, 80, NULL, NULL, 106197),
(106198, '3.40.140.10-FF-000282', NULL, 'Eukaryotic translation initiation factor 3 subunit H', 217, NULL, NULL, 106198),
(106199, '3.10.10.10-FF-000023', NULL, NULL, 115, NULL, NULL, 106199),
(106200, '3.30.160.150-FF-000006', NULL, NULL, 143, NULL, NULL, 106200),
(106201, '2.60.40.10-FF-005050', NULL, NULL, 102, NULL, NULL, 106201),
(106202, '3.30.160.60-FF-002970', NULL, 'Zinc finger protein', 30, NULL, NULL, 106202),
(106203, '3.40.50.300-FF-006225', NULL, 'Predicted protein', 103, NULL, NULL, 106203),
(106204, '2.60.40.150-FF-000753', NULL, 'Prkca protein', 57, NULL, NULL, 106204),
(106205, '2.60.220.30-FF-000007', NULL, 'Ankyrin-2 isoform 2', 110, NULL, NULL, 106205),
(106206, '3.65.10.10-FF-000033', NULL, 'Uncharacterized protein', 35, NULL, NULL, 106206),
(106207, '2.120.10.30-FF-000560', NULL, 'Uncharacterized protein', 226, NULL, NULL, 106207),
(106208, '1.20.1050.10-FF-000224', NULL, 'Glutathione s-transferase', 104, NULL, NULL, 106208),
(106209, '1.10.10.10-FF-001101', NULL, 'Ferric-uptake regulator', 81, NULL, NULL, 106209),
(106210, '2.70.150.10-FF-000246', NULL, 'Phospholipid-transporting ATPase', 94, NULL, NULL, 106210),
(106211, '1.10.150.20-FF-000064', NULL, 'Bifunctional 3''-5'' exonuclease/DNA polymerase', 122, NULL, NULL, 106211),
(106212, '3.30.479.30-FF-000014', NULL, 'Inner membrane protein YqiK', 120, NULL, NULL, 106212),
(106213, '1.10.510.10-FF-001859', NULL, 'Probable serine/threonine-protein kinase roco4', 183, NULL, NULL, 106213),
(106214, '3.80.10.10-FF-002757', NULL, 'Uncharacterized protein', 179, NULL, NULL, 106214),
(106215, '2.60.220.10-FF-000001', NULL, 'Chondroitin sulfate ABC exolyase', 144, NULL, NULL, 106215),
(106216, '2.60.40.10-FF-002700', NULL, 'Tyrosine-protein kinase receptor', 104, NULL, NULL, 106216),
(106217, '3.30.559.30-FF-000015', NULL, 'Nonribosomal siderophore peptide synthase SidC', 272, NULL, NULL, 106217),
(106218, '1.25.40.10-FF-002744', NULL, 'Uncharacterized protein', 210, NULL, NULL, 106218),
(106219, '3.30.559.30-FF-000072', NULL, 'Lovastatin nonaketide synthase, polyketide synthase component', 242, NULL, NULL, 106219),
(106220, '1.20.120.1900-FF-000023', NULL, 'Gamma-tubulin complex component', 311, NULL, NULL, 106220),
(106221, '1.10.510.10-FF-002354', NULL, 'Uncharacterized protein', 279, NULL, NULL, 106221),
(106222, '3.40.1230.10-FF-000002', NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex assembly factor 3', 117, NULL, NULL, 106222),
(106223, '3.80.20.20-FF-000046', NULL, 'Receptor protein-tyrosine kinase', 198, NULL, NULL, 106223); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(106224, '1.20.1090.10-FF-000002', NULL, '3-dehydroquinate synthase', 189, NULL, NULL, 106224),
(106225, '3.40.50.1000-FF-000706', NULL, NULL, 104, NULL, NULL, 106225),
(106226, '1.25.40.10-FF-003020', NULL, 'Tetratricopeptide repeat protein 30A', 111, NULL, NULL, 106226),
(106227, '1.25.10.10-FF-002355', NULL, 'Uncharacterized protein', 283, NULL, NULL, 106227),
(106228, '1.20.120.1910-FF-000026', NULL, 'Cysteine--tRNA ligase', 156, NULL, NULL, 106228),
(106229, '1.20.1250.40-FF-000041', NULL, 'DNA-directed RNA polymerase II subunit D', 126, NULL, NULL, 106229),
(106230, '1.10.3450.20-FF-000002', NULL, 'Nuclear pore complex protein', 151, NULL, NULL, 106230),
(106231, '1.20.58.340-FF-000088', NULL, 'Mg2+ transporter protein, CorA-like protein', 65, NULL, NULL, 106231),
(106232, '1.10.357.70-FF-000025', NULL, 'Uncharacterized protein', 94, NULL, NULL, 106232),
(106233, '3.40.50.12650-FF-000036', NULL, 'Uncharacterized protein', 118, NULL, NULL, 106233),
(106234, '2.70.150.10-FF-000066', NULL, 'Phospholipid-transporting ATPase', 155, NULL, NULL, 106234),
(106235, '2.60.120.260-FF-000250', NULL, 'Coagulation factor V', 64, NULL, NULL, 106235),
(106236, '2.40.30.10-FF-000391', NULL, 'Mitochondrial tRNA-specific 2-thiouridylase 1', 89, NULL, NULL, 106236),
(106237, '1.10.510.10-FF-002135', NULL, 'Tyrosine-protein kinase', 249, NULL, NULL, 106237),
(106238, '2.60.120.820-FF-000019', NULL, 'Uncharacterized protein', 111, NULL, NULL, 106238),
(106239, '3.40.50.150-FF-000469', NULL, 'Spermine/spermidine synthase', 266, NULL, NULL, 106239),
(106240, '3.40.50.1000-FF-000420', NULL, 'HAD family hydrolase', 129, NULL, NULL, 106240),
(106241, '3.40.640.10-FF-000207', NULL, 'DegT/DnrJ/EryC1/StrS aminotransferase family protein', 241, NULL, NULL, 106241),
(106242, '3.40.30.10-FF-000731', NULL, 'Uncharacterized protein', 140, NULL, NULL, 106242),
(106243, '2.160.20.10-FF-000221', NULL, 'Predicted protein', 293, NULL, NULL, 106243),
(106244, '3.40.50.150-FF-001020', NULL, NULL, 190, NULL, NULL, 106244),
(106245, '1.10.1040.30-FF-000007', NULL, 'Uncharacterized protein', 111, NULL, NULL, 106245),
(106246, '3.40.50.11410-FF-000001', NULL, 'Hydrogenase maturation GTPase HydF', 110, NULL, NULL, 106246),
(106247, '1.10.10.10-FF-000606', NULL, 'Transcription factor E', 86, NULL, NULL, 106247),
(106248, '3.30.65.10-FF-000008', NULL, 'DNA topoisomerase I', 55, NULL, NULL, 106248),
(106249, '3.10.310.20-FF-000030', NULL, NULL, 123, NULL, NULL, 106249),
(106250, '2.60.40.150-FF-000192', NULL, 'Calcium-dependent lipid-binding family protein', 158, NULL, NULL, 106250),
(106251, '1.10.760.10-FF-000034', NULL, 'Ubiquinol--cytochrome c reductase, cytochrome c1', 185, NULL, NULL, 106251),
(106252, '2.40.50.730-FF-000023', NULL, 'DNA polymerase', 88, NULL, NULL, 106252),
(106253, '2.20.110.10-FF-000030', NULL, 'MORN repeat-containing protein 1', 66, NULL, NULL, 106253),
(106254, '1.10.246.10-FF-000019', NULL, 'Uncharacterized protein', 71, NULL, NULL, 106254),
(106255, '2.120.10.30-FF-000228', NULL, 'Flagellar glycoprotein-like protein', 134, NULL, NULL, 106255),
(106256, '3.40.50.720-FF-001287', NULL, 'Fatty acyl-CoA reductase', 151, NULL, NULL, 106256),
(106257, '1.20.58.830-FF-000033', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 133, NULL, NULL, 106257),
(106258, '3.40.50.300-FF-002914', NULL, 'Shikimate kinase', 175, NULL, NULL, 106258),
(106259, '2.40.30.10-FF-000115', NULL, 'Eukaryotic translation elongation factor 1 alpha', 93, NULL, NULL, 106259),
(106260, '1.25.40.150-FF-000005', NULL, 'V-type proton ATPase subunit H', 104, NULL, NULL, 106260),
(106261, '3.30.160.60-FF-006281', NULL, NULL, 50, NULL, NULL, 106261),
(106262, '3.10.100.10-FF-000270', NULL, NULL, 102, NULL, NULL, 106262),
(106263, '3.30.160.60-FF-002352', NULL, 'Zinc finger protein 154', 28, NULL, NULL, 106263),
(106264, '3.30.160.60-FF-002913', NULL, NULL, 29, NULL, NULL, 106264),
(106265, '3.40.50.300-FF-006282', NULL, 'Uncharacterized protein', 87, NULL, NULL, 106265),
(106266, '3.30.160.60-FF-006129', NULL, NULL, 33, NULL, NULL, 106266),
(106267, '3.40.720.10-FF-000265', NULL, 'Predicted protein', 449, NULL, NULL, 106267);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(106268, '3.10.100.10-FF-000213', NULL, NULL, 113, NULL, NULL, 106268),
(106269, '3.40.50.2300-FF-001664', NULL, NULL, 175, NULL, NULL, 106269),
(106270, '2.10.220.10-FF-000086', NULL, 'R-spondin-3', 46, NULL, NULL, 106270),
(106271, '3.40.50.410-FF-000295', NULL, 'Predicted protein', 179, NULL, NULL, 106271),
(106272, '3.30.505.10-FF-000071', NULL, 'SH2 domain containing 3A', 117, NULL, NULL, 106272),
(106273, '1.10.760.10-FF-000091', NULL, 'Fructose dehydrogenase cytochrome subunit', 135, NULL, NULL, 106273),
(106274, '3.30.420.40-FF-000820', NULL, 'Os11g0187800 protein', 35, NULL, NULL, 106274),
(106275, '3.10.490.10-FF-000034', NULL, 'Gamma-glutamylcyclotransferase', 130, NULL, NULL, 106275),
(106276, '3.30.70.330-FF-000170', NULL, 'Serine/arginine-rich splicing factor 1', 101, NULL, NULL, 106276),
(106277, '2.10.110.10-FF-000313', NULL, 'Uncharacterized protein', 71, NULL, NULL, 106277),
(106278, '1.20.1280.50-FF-000091', NULL, 'F-box protein', 103, NULL, NULL, 106278),
(106279, '3.40.850.10-FF-000021', NULL, 'kinesin-like protein KIF16B isoform X1', 382, NULL, NULL, 106279),
(106280, '3.40.980.10-FF-000025', NULL, 'Molybdopterin molybdenumtransferase', 150, NULL, NULL, 106280),
(106281, '1.10.510.10-FF-002753', NULL, NULL, 205, NULL, NULL, 106281),
(106282, '2.40.50.140-FF-000122', NULL, 'Small ribosomal subunit biogenesis GTPase RsgA', 68, NULL, NULL, 106282),
(106283, '1.10.1420.10-FF-000109', NULL, 'AaceriAFR603Cp', 130, NULL, NULL, 106283),
(106284, '3.40.50.10810-FF-000158', NULL, 'Uncharacterized protein', 284, NULL, NULL, 106284),
(106285, '2.10.220.10-FF-000029', NULL, 'Proprotein convertase subtilisin/kexin type 5', 99, NULL, NULL, 106285),
(106286, '2.10.25.10-FF-001638', NULL, 'Uncharacterized protein', 77, NULL, NULL, 106286),
(106287, '3.80.10.10-FF-003252', NULL, 'Uncharacterized protein', 174, NULL, NULL, 106287),
(106288, '1.20.1070.10-FF-000113', NULL, 'probable G-protein coupled receptor 85', 321, NULL, NULL, 106288),
(106289, '1.10.150.380-FF-000006', NULL, 'Aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase subunit B', 61, NULL, NULL, 106289),
(106290, '3.10.110.10-FF-000096', NULL, 'Ubiquitin-conjugating enzyme E2-21 kDa', 166, NULL, NULL, 106290),
(106291, '3.60.15.10-FF-000026', NULL, 'metallo-beta-lactamase domain-containing protein 2', 246, NULL, NULL, 106291),
(106292, '3.30.230.130-FF-000034', NULL, 'Cullin', 155, NULL, NULL, 106292),
(106293, '1.20.1560.10-FF-000488', NULL, 'ABC transporter ATP-binding protein', 299, NULL, NULL, 106293),
(106294, '2.160.20.10-FF-000322', NULL, 'Uncharacterized protein', 157, NULL, NULL, 106294),
(106295, '2.40.50.140-FF-000245', NULL, 'Programmed cell death 11', 75, NULL, NULL, 106295),
(106296, '3.90.70.10-FF-000405', NULL, 'cathepsin L1-like isoform X3', 315, NULL, NULL, 106296),
(106297, '3.90.550.10-FF-000734', NULL, 'Uncharacterized glycosyltransferase HI_1696', 249, NULL, NULL, 106297),
(106298, '2.120.10.80-FF-000237', NULL, 'Uncharacterized protein', 227, NULL, NULL, 106298),
(106299, '1.25.40.10-FF-002008', NULL, 'Uncharacterized protein', 110, NULL, NULL, 106299),
(106300, '3.30.160.60-FF-004780', NULL, NULL, 83, NULL, NULL, 106300),
(106301, '3.30.559.30-FF-000088', NULL, 'Nonribosomal peptide synthetase 9', 64, NULL, NULL, 106301),
(106302, '4.10.860.120-FF-000025', NULL, 'DNA-directed RNA polymerase subunit', 127, NULL, NULL, 106302),
(106303, '1.10.10.10-FF-001837', NULL, 'Transcription factor, E2F and DP-related', 91, NULL, NULL, 106303),
(106304, '1.10.730.10-FF-000173', NULL, 'Uncharacterized protein', 107, NULL, NULL, 106304),
(106305, '3.30.200.20-FF-000146', NULL, 'receptor-like serine/threonine-protein kinase ALE2', 103, NULL, NULL, 106305),
(106306, '3.40.50.620-FF-000796', NULL, 'Uncharacterized protein', 145, NULL, NULL, 106306),
(106307, '2.130.10.10-FF-000621', NULL, 'Dmx like 2', 151, NULL, NULL, 106307),
(106308, '3.30.565.10-FF-000506', NULL, 'Uncharacterized protein', 79, NULL, NULL, 106308),
(106309, '3.40.50.300-FF-006315', NULL, 'DNA helicase INO80', 160, NULL, NULL, 106309),
(106310, '3.40.50.300-FF-008439', NULL, 'Uncharacterized protein', 257, NULL, NULL, 106310);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(106311, '2.40.180.10-FF-000013', NULL, 'Catalase', 538, NULL, NULL, 106311),
(106312, '1.20.140.150-FF-000080', NULL, 'Non-anchored cell wall protein 6', 136, NULL, NULL, 106312),
(106313, '3.30.750.24-FF-000080', NULL, 'Anti-sigma factor antagonist', 121, NULL, NULL, 106313),
(106314, '3.40.50.300-FF-002616', NULL, 'Exonuclease, putative', 99, NULL, NULL, 106314),
(106315, '3.40.190.290-FF-000018', NULL, 'LysR family transcriptional regulator', 196, NULL, NULL, 106315),
(106316, '3.40.50.300-FF-005213', NULL, 'Rab-like protein 3', 209, NULL, NULL, 106316),
(106317, '2.20.70.10-FF-000118', NULL, 'Transcription elongation regulator 1', 70, NULL, NULL, 106317),
(106318, '3.40.1050.10-FF-000016', NULL, 'Carbonic anhydrase', 219, NULL, NULL, 106318),
(106319, '2.130.10.10-FF-004353', NULL, 'Uncharacterized protein', 93, NULL, NULL, 106319),
(106320, '1.10.560.10-FF-000047', NULL, '60 kDa chaperonin', 245, NULL, NULL, 106320),
(106321, '2.60.120.10-FF-000286', NULL, 'DNA damage-repair/toleration protein DRT102', 111, NULL, NULL, 106321),
(106322, '3.40.50.300-FF-004180', NULL, 'Small GTPase, putative', 166, NULL, NULL, 106322),
(106323, '2.60.40.60-FF-000388', NULL, 'Cadherin EGF LAG seven-pass G-type receptor', 100, NULL, NULL, 106323),
(106324, '2.170.270.10-FF-000236', NULL, 'Uncharacterized protein', 58, NULL, NULL, 106324),
(106325, '3.40.50.880-FF-000047', NULL, 'GMP synthase [glutamine-hydrolyzing] subunit A', 194, NULL, NULL, 106325),
(106326, '1.10.132.60-FF-000034', NULL, 'Uncharacterized protein', 79, NULL, NULL, 106326),
(106327, '3.30.70.330-FF-000350', NULL, 'heterogeneous nuclear ribonucleoprotein A3 isoform X1', 90, NULL, NULL, 106327),
(106328, '3.90.1290.10-FF-000067', NULL, 'Uncharacterized protein', 171, NULL, NULL, 106328),
(106329, '1.20.1250.20-FF-001636', NULL, 'Uncharacterized protein', 84, NULL, NULL, 106329),
(106330, '3.30.450.190-FF-000011', NULL, 'Ras-like small GTPase, putative', 140, NULL, NULL, 106330),
(106331, '1.25.10.10-FF-002506', NULL, 'Uncharacterized protein', 201, NULL, NULL, 106331),
(106332, '2.10.25.10-FF-001189', NULL, 'Fibrillin 1', 30, NULL, NULL, 106332),
(106333, '3.40.50.2300-FF-001428', NULL, NULL, 15, NULL, NULL, 106333),
(106334, '3.10.20.90-FF-000295', NULL, 'AGAP008705-PA', 97, NULL, NULL, 106334),
(106335, '2.60.40.10-FF-002088', NULL, 'Polycystic kidney disease 1a', 79, NULL, NULL, 106335),
(106336, '3.30.160.60-FF-000076', NULL, 'Putative cyclic AMP-dependent transcription factor ATF-2', 28, NULL, NULL, 106336),
(106337, '3.30.2160.10-FF-000004', NULL, 'probable E3 ubiquitin-protein ligase HERC4 isoform X1', 80, NULL, NULL, 106337),
(106338, '3.80.10.10-FF-003813', NULL, 'Volume-regulated anion channel subunit LRRC8C', 82, NULL, NULL, 106338),
(106339, '1.20.1560.10-FF-000937', NULL, 'Chromosome 23, whole genome shotgun sequence', 652, NULL, NULL, 106339),
(106340, '1.10.472.170-FF-000011', NULL, 'Transcription initiation factor IIB', 190, NULL, NULL, 106340),
(106341, '3.40.50.11860-FF-000006', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', 99, NULL, NULL, 106341),
(106342, '3.40.630.10-FF-000331', NULL, 'Uncharacterized protein', 253, NULL, NULL, 106342),
(106343, '3.30.1550.10-FF-000011', NULL, 'LSU ribosomal protein L11P', 81, NULL, NULL, 106343),
(106344, '2.60.40.10-FF-000643', NULL, 'RIMS-binding protein 2 isoform X1', 92, NULL, NULL, 106344),
(106345, '3.40.50.2300-FF-000326', NULL, 'Vomeronasal 2, receptor 56', 155, NULL, NULL, 106345),
(106346, '3.30.70.610-FF-000001', NULL, 'Quinone-dependent D-lactate dehydrogenase', 85, NULL, NULL, 106346),
(106347, '1.20.120.220-FF-000012', NULL, 'ATP synthase subunit a', 195, NULL, NULL, 106347),
(106348, '2.60.40.150-FF-000124', NULL, 'extended synaptotagmin-1 isoform X1', 137, NULL, NULL, 106348),
(106349, '3.60.21.10-FF-000462', NULL, 'Serine/threonine-protein phosphatase', 143, NULL, NULL, 106349),
(106350, '3.40.50.300-FF-005798', NULL, 'Peroxisome biogenesis protein 6', 60, NULL, NULL, 106350),
(106351, '1.20.120.350-FF-000068', NULL, 'Sodium channel protein', 120, NULL, NULL, 106351);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(106352, '3.20.20.60-FF-000139', NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', 265, NULL, NULL, 106352),
(106353, '3.30.70.330-FF-000979', NULL, 'SUPpressor', 109, NULL, NULL, 106353),
(106354, '1.20.5.190-FF-000094', NULL, NULL, 68, NULL, NULL, 106354),
(106355, '1.20.1070.10-FF-001535', NULL, 'Zgo4', 182, NULL, NULL, 106355),
(106356, '1.10.20.10-FF-000337', NULL, NULL, 108, NULL, NULL, 106356),
(106357, '3.40.350.10-FF-000056', NULL, 'SPT16 homolog, facilitates chromatin-remodeling subunit', 54, NULL, NULL, 106357),
(106358, '1.10.510.10-FF-000645', NULL, 'Probable serine/threonine-protein kinase DDB_G0268078', 209, NULL, NULL, 106358),
(106359, '1.10.510.10-FF-004344', NULL, NULL, 126, NULL, NULL, 106359),
(106360, '2.60.40.1170-FF-000040', NULL, 'AP-2 complex subunit mu', 171, NULL, NULL, 106360),
(106361, '3.20.20.70-FF-000468', NULL, NULL, 32, NULL, NULL, 106361),
(106362, '3.40.50.1820-FF-001357', NULL, 'Uncharacterized protein', 237, NULL, NULL, 106362),
(106363, '1.10.238.10-FF-000366', NULL, 'Uncharacterized protein, isoform A', 125, NULL, NULL, 106363),
(106364, '1.10.287.90-FF-000020', NULL, 'Cytochrome c oxidase subunit 2', 107, NULL, NULL, 106364),
(106365, '1.10.10.60-FF-000610', NULL, 'MmsAB operon regulatory protein', 57, NULL, NULL, 106365),
(106366, '1.20.1070.10-FF-001905', NULL, 'Uncharacterized protein', 287, NULL, NULL, 106366),
(106367, '2.40.110.10-FF-000065', NULL, 'L-prolyl-[peptidyl-carrier protein] dehydrogenase', 107, NULL, NULL, 106367),
(106368, '3.30.10.10-FF-000005', NULL, 'Probable Dol-P-Man:Man(7)GlcNAc(2)-PP-Dol alpha-1,6-mannosyltransferase', 60, NULL, NULL, 106368),
(106369, '3.40.30.10-FF-000719', NULL, 'Glutathione peroxidase', 95, NULL, NULL, 106369),
(106370, '1.20.930.40-FF-000009', NULL, 'Glutamate carboxypeptidase 2 homolog', 154, NULL, NULL, 106370),
(106371, '1.10.472.10-FF-000410', NULL, 'Putative cyclin-F1-4', 103, NULL, NULL, 106371),
(106372, '2.30.180.10-FF-000184', NULL, NULL, 138, NULL, NULL, 106372),
(106373, '2.60.40.150-FF-000450', NULL, 'BON1-associated protein 1', 125, NULL, NULL, 106373),
(106374, '1.25.10.10-FF-001989', NULL, 'Uncharacterized protein', 227, NULL, NULL, 106374),
(106375, '1.20.120.230-FF-000015', NULL, 'Cas scaffold protein family member 4', 127, NULL, NULL, 106375),
(106376, '1.10.540.10-FF-000147', NULL, 'Acyl-coenzyme A oxidase', 121, NULL, NULL, 106376),
(106377, '2.130.10.10-FF-002066', NULL, 'Transducin family protein', 132, NULL, NULL, 106377),
(106378, '2.60.40.10-FF-004342', NULL, NULL, 121, NULL, NULL, 106378),
(106379, '3.30.10.20-FF-000008', NULL, 'Serine/threonine protein kinase', 69, NULL, NULL, 106379),
(106380, '3.30.2350.10-FF-000030', NULL, 'Pseudouridine synthase', 269, NULL, NULL, 106380),
(106381, '3.30.200.20-FF-002400', NULL, 'CDC7 protein kinase', 92, NULL, NULL, 106381),
(106382, '3.40.50.150-FF-000621', NULL, 'Nicotinamide N-methyltransferase, putative', 254, NULL, NULL, 106382),
(106383, '3.40.140.10-FF-000147', NULL, 'Uncharacterized protein', 181, NULL, NULL, 106383),
(106384, '3.40.1090.10-FF-000125', NULL, 'Patatin like phospholipase domain containing 3', 188, NULL, NULL, 106384),
(106385, '3.30.200.20-FF-001883', NULL, 'Uncharacterized protein', 57, NULL, NULL, 106385),
(106386, '1.10.10.10-FF-000056', NULL, 'IclR family transcriptional regulator', 74, NULL, NULL, 106386),
(106387, '2.130.10.10-FF-002745', NULL, 'Kinetoplastid kinetochore protein 15', 271, NULL, NULL, 106387),
(106388, '1.10.287.70-FF-000789', NULL, 'Uncharacterized protein', 198, NULL, NULL, 106388),
(106389, '2.80.10.50-FF-000068', NULL, 'Stromal cell-derived factor 2-like protein', 198, NULL, NULL, 106389),
(106390, '2.40.30.10-FF-000525', NULL, 'Uncharacterized protein', 131, NULL, NULL, 106390),
(106391, '2.60.40.10-FF-004712', NULL, NULL, 86, NULL, NULL, 106391),
(106392, '3.40.50.2000-FF-000017', NULL, 'alpha,alpha-trehalose-phosphate synthase [UDP-forming] 6', 260, NULL, NULL, 106392),
(106393, '1.10.472.130-FF-000095', NULL, 'Uncharacterized protein', 146, NULL, NULL, 106393),
(106394, '2.60.120.260-FF-000441', NULL, 'Uncharacterized protein', 203, NULL, NULL, 106394);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(106395, '3.90.70.10-FF-000394', NULL, 'Uncharacterized protein', 194, NULL, NULL, 106395),
(106396, '3.90.550.10-FF-000408', NULL, 'Bifunctional enzyme IspD/IspF', 229, NULL, NULL, 106396),
(106397, '3.90.1750.10-FF-000114', NULL, 'Predicted protein', 214, NULL, NULL, 106397),
(106398, '3.30.2350.20-FF-000033', NULL, 'Uncharacterized protein', 219, NULL, NULL, 106398),
(106399, '2.30.29.30-FF-001063', NULL, 'Anillin, actin-binding protein', 77, NULL, NULL, 106399),
(106400, '2.40.10.10-FF-000625', NULL, NULL, 245, NULL, NULL, 106400),
(106401, '1.50.40.10-FF-000590', NULL, 'Truncated non-functional calcium-binding mitochondrial carrier SAL1-1', 231, NULL, NULL, 106401),
(106402, '1.10.10.10-FF-000735', NULL, 'Rrf2 family transcriptional regulator', 140, NULL, NULL, 106402),
(106403, '1.10.20.10-FF-000028', NULL, 'Transcription initiation factor TFIID subunit 13', 45, NULL, NULL, 106403),
(106404, '1.20.5.190-FF-000105', NULL, NULL, 54, NULL, NULL, 106404),
(106405, '1.25.10.10-FF-002832', NULL, 'Uncharacterized protein', 186, NULL, NULL, 106405),
(106406, '3.80.10.10-FF-002032', NULL, 'Leucine rich repeat containing G protein-coupled receptor 6', 355, NULL, NULL, 106406),
(106407, '1.10.3710.10-FF-000008', NULL, 'Recombination factor protein RarA', 101, NULL, NULL, 106407),
(106408, '3.10.110.10-FF-000360', NULL, 'ESCRT-I complex subunit tsg101', 155, NULL, NULL, 106408),
(106409, '3.50.50.60-FF-000016', NULL, 'Succinate dehydrogenase flavoprotein subunit', 301, NULL, NULL, 106409),
(106410, '2.40.30.10-FF-000188', NULL, 'Ria1p', 129, NULL, NULL, 106410),
(106411, '1.10.287.630-FF-000002', NULL, 'Potassium/sodium hyperpolarization-activated cyclic nucleotide-gated channel 4', 68, NULL, NULL, 106411),
(106412, '1.10.287.110-FF-000184', NULL, 'DnaJ domain containing protein', 88, NULL, NULL, 106412),
(106413, '3.40.50.300-FF-006641', NULL, 'Uncharacterized protein', 89, NULL, NULL, 106413),
(106414, '3.30.60.20-FF-000045', NULL, 'Rho-associated protein kinase 2', 45, NULL, NULL, 106414),
(106415, '1.25.40.800-FF-000009', NULL, 'Ccr4-Not transcription complex subunit', 229, NULL, NULL, 106415),
(106416, '1.20.58.670-FF-000024', NULL, NULL, 127, NULL, NULL, 106416),
(106417, '1.25.40.10-FF-002334', NULL, 'Pentatricopeptide repeat-containing protein At5g46580, chloroplastic', 186, NULL, NULL, 106417),
(106418, '3.90.1410.10-FF-000156', NULL, 'Chromosome 9, whole genome shotgun sequence', 88, NULL, NULL, 106418),
(106419, '3.30.450.40-FF-000154', NULL, 'Heat-inducible transcription repressor HrcA', 149, NULL, NULL, 106419),
(106420, '3.20.20.80-FF-000797', NULL, 'Alpha-L-fucosidase 1', 156, NULL, NULL, 106420),
(106421, '1.25.40.10-FF-003745', NULL, 'Uncharacterized protein', 131, NULL, NULL, 106421),
(106422, '1.10.287.110-FF-000228', NULL, 'Chaperone protein DNAJ, putative', 111, NULL, NULL, 106422),
(106423, '1.10.10.10-FF-000409', NULL, 'Anaphase-promoting complex subunit ApcB', 70, NULL, NULL, 106423),
(106424, '2.40.320.10-FF-000002', NULL, 'Adenylate cyclase', 199, NULL, NULL, 106424),
(106425, '2.40.100.10-FF-000137', NULL, 'Type I inositol polyphosphate 5-phosphatase 10', 66, NULL, NULL, 106425),
(106426, '2.60.40.150-FF-000803', NULL, 'Uncharacterized protein', 153, NULL, NULL, 106426),
(106427, '3.30.565.10-FF-000136', NULL, 'DNA topoisomerase 2', 242, NULL, NULL, 106427),
(106428, '3.40.30.10-FF-000366', NULL, 'Spliceosomal U5 snRNP-specific protein, putative', 144, NULL, NULL, 106428),
(106429, '1.10.10.60-FF-000273', NULL, 'MIS18 binding protein 1', 69, NULL, NULL, 106429),
(106430, '1.20.1280.50-FF-000197', NULL, 'Predicted protein', 112, NULL, NULL, 106430),
(106431, '3.30.428.10-FF-000020', NULL, 'Histidine triad nucleotide-binding protein 3', 130, NULL, NULL, 106431),
(106432, '3.10.150.10-FF-000008', NULL, 'Proliferating cell nuclear antigen', 163, NULL, NULL, 106432),
(106433, '3.30.50.10-FF-000114', NULL, 'Uncharacterized protein', 81, NULL, NULL, 106433),
(106434, '2.60.120.260-FF-000115', NULL, 'Beta-galactosidase', 81, NULL, NULL, 106434),
(106435, '3.30.160.60-FF-004145', NULL, NULL, 24, NULL, NULL, 106435);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(106436, '2.40.70.10-FF-000325', NULL, NULL, 174, NULL, NULL, 106436),
(106437, '3.40.50.410-FF-000379', NULL, 'Uncharacterized protein', 190, NULL, NULL, 106437),
(106438, '1.20.1070.10-FF-001209', NULL, 'Predicted protein', 263, NULL, NULL, 106438),
(106439, '2.60.120.20-FF-000013', NULL, 'Genome polyprotein', 270, NULL, NULL, 106439),
(106440, '2.60.40.790-FF-000158', NULL, NULL, 73, NULL, NULL, 106440),
(106441, '3.30.160.60-FF-004454', NULL, NULL, 57, NULL, NULL, 106441),
(106442, '1.25.40.10-FF-002643', NULL, 'Uncharacterized protein', 126, NULL, NULL, 106442),
(106443, '3.30.40.10-FF-001777', NULL, 'Putative RING zinc finger domain superfamily protein', 92, NULL, NULL, 106443),
(106444, '3.30.310.40-FF-000014', NULL, 'Predicted protein', 86, NULL, NULL, 106444),
(106445, '2.60.40.640-FF-000029', NULL, 'Rod1p', 144, NULL, NULL, 106445),
(106446, '3.80.10.10-FF-001526', NULL, 'Leucine_rich_repeat/Leucine_Rich_repeat/Leucine_R ich_Repeat', 61, NULL, NULL, 106446),
(106447, '1.10.230.10-FF-000028', NULL, 'Uncharacterized protein', 91, NULL, NULL, 106447),
(106448, '3.90.70.10-FF-000731', NULL, 'Uncharacterized protein', 174, NULL, NULL, 106448),
(106449, '3.40.50.300-FF-007130', NULL, 'Uncharacterized protein', 182, NULL, NULL, 106449),
(106450, '2.60.120.40-FF-000019', NULL, 'Tumor necrosis factor ligand superfamily member 13B', 148, NULL, NULL, 106450),
(106451, '1.20.1090.10-FF-000007', NULL, 'Pentafunctional AROM polypeptide', 210, NULL, NULL, 106451),
(106452, '3.30.40.10-FF-001098', NULL, 'Tripartite motif family-like 1', 103, NULL, NULL, 106452),
(106453, '3.30.70.330-FF-002148', NULL, NULL, 86, NULL, NULL, 106453),
(106454, '1.20.930.20-FF-000003', NULL, 'DNA mismatch repair protein MLH1', 116, NULL, NULL, 106454),
(106455, '3.40.50.1440-FF-000074', NULL, 'Tubulin gamma-2 chain', 100, NULL, NULL, 106455),
(106456, '3.10.20.90-FF-000665', NULL, 'Uncharacterized protein', 80, NULL, NULL, 106456),
(106457, '3.30.310.50-FF-000017', NULL, 'Phosphomannomutase PmmB', 82, NULL, NULL, 106457),
(106458, '3.30.505.10-FF-000177', NULL, NULL, 117, NULL, NULL, 106458),
(106459, '3.30.497.10-FF-000106', NULL, 'Serpin B10', 97, NULL, NULL, 106459),
(106460, '3.60.20.30-FF-000005', NULL, 'N(4)-(Beta-N-acetylglucosaminyl)-L-asparaginase', 135, NULL, NULL, 106460),
(106461, '1.10.150.240-FF-000032', NULL, 'Hydrolase, haloacid dehalogenase-like family', 65, NULL, NULL, 106461),
(106462, '2.70.170.10-FF-000152', NULL, 'Macaca fascicularis brain cDNA clone: QflA-17345, similar to human cholinergic receptor, nicotinic, beta polypeptide 2(neuronal) (CHRNB2), mRNA, RefSeq: NM_000748.1', 69, NULL, NULL, 106462),
(106463, '3.90.550.10-FF-000381', NULL, 'Ceramide glucosyltransferase', 216, NULL, NULL, 106463),
(106464, '1.25.40.690-FF-000010', NULL, 'Nucleocytoplasmic transporter', 92, NULL, NULL, 106464),
(106465, '3.40.630.30-FF-000696', NULL, 'Uncharacterized protein', 111, NULL, NULL, 106465),
(106466, '2.30.170.40-FF-000006', NULL, 'Mitochondrial ribosomal protein L28, putative', 67, NULL, NULL, 106466),
(106467, '3.40.50.1100-FF-000186', NULL, 'Cysteine synthase', 105, NULL, NULL, 106467),
(106468, '3.40.630.10-FF-000022', NULL, 'Carboxypeptidase Z', 323, NULL, NULL, 106468),
(106469, '1.20.1070.10-FF-000124', NULL, 'Trace amine-associated receptor 20i', 323, NULL, NULL, 106469),
(106470, '2.130.10.10-FF-003847', NULL, 'Uncharacterized protein', 290, NULL, NULL, 106470),
(106471, '2.60.40.10-FF-000317', NULL, 'fibronectin isoform X1', 95, NULL, NULL, 106471),
(106472, '2.10.110.10-FF-000324', NULL, 'Protein CBR-LIM-9', 38, NULL, NULL, 106472),
(106473, '1.20.1080.10-FF-000052', NULL, 'Predicted protein', 231, NULL, NULL, 106473),
(106474, '3.30.280.10-FF-000002', NULL, 'Urease subunit gamma', 100, NULL, NULL, 106474),
(106475, '1.20.1160.11-FF-000020', NULL, NULL, 74, NULL, NULL, 106475),
(106476, '1.10.8.60-FF-000553', NULL, 'DNA polymerase III delta subunit HolA', 70, NULL, NULL, 106476),
(106477, '3.40.50.300-FF-008232', NULL, 'Putative cysteine protease RD19C', 59, NULL, NULL, 106477),
(106478, '3.30.830.10-FF-000157', NULL, 'Metalloprotease, insulinase family', 198, NULL, NULL, 106478);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(106479, '1.25.10.10-FF-000371', NULL, 'Serine/threonine-protein kinase TOR', 306, NULL, NULL, 106479),
(106480, '2.40.170.20-FF-000077', NULL, 'Transporter, outer membrane receptor (OMR) family', 545, NULL, NULL, 106480),
(106481, '1.20.58.390-FF-000064', NULL, 'Neuronal acetylcholine receptor subunit alpha-7', 63, NULL, NULL, 106481),
(106482, '1.10.506.10-FF-000068', NULL, 'Uncharacterized protein', 159, NULL, NULL, 106482),
(106483, '2.10.220.10-FF-000136', NULL, 'Proprotein convertase subtilisin/kexin type 5', 61, NULL, NULL, 106483),
(106484, '3.30.40.10-FF-001261', NULL, 'Uncharacterized protein', 82, NULL, NULL, 106484),
(106485, '3.90.120.10-FF-000022', NULL, 'DNA (cytosine-5)-methyltransferase 3', 67, NULL, NULL, 106485),
(106486, '3.20.20.70-FF-000794', NULL, NULL, 42, NULL, NULL, 106486),
(106487, '2.60.40.10-FF-003869', NULL, NULL, 107, NULL, NULL, 106487),
(106488, '3.40.30.70-FF-000001', NULL, 'Glutamate--tRNA ligase, cytoplasmic', 83, NULL, NULL, 106488),
(106489, '3.40.50.10310-FF-000019', NULL, 'Uncharacterized protein', 166, NULL, NULL, 106489),
(106490, '3.30.70.330-FF-002311', NULL, NULL, 106, NULL, NULL, 106490),
(106491, '3.40.50.300-FF-004387', NULL, 'Putative uridine kinase', 205, NULL, NULL, 106491),
(106492, '3.40.190.10-FF-000184', NULL, 'Phosphate ABC transporter, phosphate-binding protein', 70, NULL, NULL, 106492),
(106493, '3.80.10.10-FF-003117', NULL, 'Leucine rich repeat containing 6', 92, NULL, NULL, 106493),
(106494, '3.30.60.30-FF-000048', NULL, 'Solute carrier organic anion transporter family member', 59, NULL, NULL, 106494),
(106495, '3.40.50.1000-FF-000835', NULL, NULL, 78, NULL, NULL, 106495),
(106496, '3.40.830.10-FF-000003', NULL, '4,5-DOPA dioxygenase extradiol', 263, NULL, NULL, 106496),
(106497, '2.60.40.1760-FF-000003', NULL, 'Glucosidase II alpha subunit', 263, NULL, NULL, 106497),
(106498, '1.25.10.10-FF-002153', NULL, 'Uncharacterized protein', 523, NULL, NULL, 106498),
(106499, '3.30.40.10-FF-001570', NULL, 'Zinc finger protein', 132, NULL, NULL, 106499),
(106500, '3.60.21.10-FF-000136', NULL, 'Serine/threonine-protein phosphatase', 336, NULL, NULL, 106500),
(106501, '1.10.533.10-FF-000226', NULL, 'Uncharacterized protein', 89, NULL, NULL, 106501),
(106502, '3.90.1150.10-FF-000220', NULL, 'Serine--pyruvate aminotransferase', 14, NULL, NULL, 106502),
(106503, '3.40.50.300-FF-002925', NULL, 'Circadian clock protein kinase KaiC', 249, NULL, NULL, 106503),
(106504, '1.20.1280.50-FF-000208', NULL, 'Predicted protein', 53, NULL, NULL, 106504),
(106505, '3.40.47.10-FF-000022', NULL, 'Acetyl-CoA acetyltransferase', 401, NULL, NULL, 106505),
(106506, '2.10.110.10-FF-000015', NULL, 'LIM domain only 3', 93, NULL, NULL, 106506),
(106507, '2.130.10.10-FF-005764', NULL, 'Uncharacterized protein', 109, NULL, NULL, 106507),
(106508, '1.25.40.10-FF-000182', NULL, 'Pre-mRNA-splicing factor SYF1', 173, NULL, NULL, 106508),
(106509, '2.60.40.1180-FF-000060', NULL, 'Alpha-mannosidase', 104, NULL, NULL, 106509),
(106510, '1.50.40.10-FF-000573', NULL, 'Uncharacterized protein', 78, NULL, NULL, 106510),
(106511, '3.40.630.30-FF-000679', NULL, 'Uncharacterized protein', 138, NULL, NULL, 106511),
(106512, '1.25.40.20-FF-000185', NULL, 'OSMotic avoidance abnormal family member', 265, NULL, NULL, 106512),
(106513, '1.10.1450.10-FF-000061', NULL, 'KRR1 small subunit processome component homolog-like protein', 109, NULL, NULL, 106513),
(106514, '1.20.1070.10-FF-001552', NULL, 'D(1B) dopamine receptor', 174, NULL, NULL, 106514),
(106515, '1.10.150.20-FF-000210', NULL, 'DNA excision repair protein ERCC-1', 92, NULL, NULL, 106515),
(106516, '3.90.290.10-FF-000017', NULL, 'latent-transforming growth factor beta-binding protein 4 isoform X2', 70, NULL, NULL, 106516),
(106517, '1.10.8.360-FF-000001', NULL, 'Chitinase domain-containing protein 1', 33, NULL, NULL, 106517),
(106518, '3.90.930.12-FF-000002', NULL, '50S ribosomal protein L6', 83, NULL, NULL, 106518),
(106519, '2.60.40.60-FF-000079', NULL, 'FAT atypical cadherin 1', 103, NULL, NULL, 106519),
(106520, '3.30.70.3290-FF-000002', NULL, 'Non-reducing polyketide synthase nscA', 129, NULL, NULL, 106520);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(106521, '4.10.60.10-FF-000063', NULL, 'Unplaced genomic scaffold supercont1.17, whole genome shotgun sequence', 35, NULL, NULL, 106521),
(106522, '2.60.40.150-FF-000433', NULL, 'Synaptotagmin-17', 145, NULL, NULL, 106522),
(106523, '1.10.472.10-FF-000090', NULL, 'cyclin-T1 isoform X2', 35, NULL, NULL, 106523),
(106524, '3.10.110.10-FF-000034', NULL, 'Ubiquitin-conjugating enzyme E2 S', 156, NULL, NULL, 106524),
(106525, '1.10.510.10-FF-000662', NULL, 'Serine/threonine-protein kinase WAG2', 67, NULL, NULL, 106525),
(106526, '1.20.5.1760-FF-000001', NULL, 'Sfi1p', 72, NULL, NULL, 106526),
(106527, '3.40.50.300-FF-004533', NULL, 'DNA mismatch repair protein MutS type 2', 61, NULL, NULL, 106527),
(106528, '2.40.110.10-FF-000082', NULL, 'Predicted protein', 144, NULL, NULL, 106528),
(106529, '1.10.510.10-FF-004361', NULL, NULL, 111, NULL, NULL, 106529),
(106530, '1.10.510.10-FF-000954', NULL, 'Tyrosine-protein kinase-like otk', 261, NULL, NULL, 106530),
(106531, '3.80.10.10-FF-001852', NULL, 'YALI0B18759p', 87, NULL, NULL, 106531),
(106532, '3.30.470.30-FF-000051', NULL, 'GD13702', 280, NULL, NULL, 106532),
(106533, '3.30.2350.20-FF-000016', NULL, 'Unplaced genomic scaffold supercont2.23, whole genome shotgun sequence', 187, NULL, NULL, 106533),
(106534, '3.30.2350.10-FF-000013', NULL, 'TruB pseudouridine synthase family member 1', 256, NULL, NULL, 106534),
(106535, '3.40.50.720-FF-000106', NULL, 'NEDD8-activating enzyme E1 catalytic subunit, putative', 235, NULL, NULL, 106535),
(106536, '3.30.160.60-FF-002863', NULL, 'Zinc finger protein 671', 86, NULL, NULL, 106536),
(106537, '2.80.10.50-FF-000085', NULL, '''putative glucan 1,3-beta-glucosidase', 137, NULL, NULL, 106537),
(106538, '3.90.1600.10-FF-000002', NULL, 'DNA polymerase zeta subunit', 162, NULL, NULL, 106538),
(106539, '3.30.1370.10-FF-000222', NULL, 'Uncharacterized protein', 85, NULL, NULL, 106539),
(106540, '1.10.510.10-FF-002562', NULL, 'Uncharacterized protein', 264, NULL, NULL, 106540),
(106541, '2.30.30.1150-FF-000006', NULL, 'Uncharacterized protein', 109, NULL, NULL, 106541),
(106542, '3.40.50.300-FF-000790', NULL, 'C1 tetrahydrofolate synthase', 199, NULL, NULL, 106542),
(106543, '1.10.730.10-FF-000156', NULL, 'Leucine--tRNA ligase', 179, NULL, NULL, 106543),
(106544, '3.40.50.2000-FF-000034', NULL, 'Alpha-1,4 glucan phosphorylase', 460, NULL, NULL, 106544),
(106545, '1.25.10.10-FF-000680', NULL, 'BNI1p Formin', 238, NULL, NULL, 106545),
(106546, '2.40.10.10-FF-000642', NULL, NULL, 142, NULL, NULL, 106546),
(106547, '3.30.200.60-FF-000001', NULL, 'Ubiquitin thioesterase', 86, NULL, NULL, 106547),
(106548, '1.20.5.190-FF-000077', NULL, 'Class V myosin', 53, NULL, NULL, 106548),
(106549, '6.10.300.40-FF-000001', NULL, '26S proteasome non-ATPase regulatory subunit 4', 47, NULL, NULL, 106549),
(106550, '2.10.90.10-FF-000098', NULL, 'Uncharacterized protein', 50, NULL, NULL, 106550),
(106551, '3.40.190.10-FF-000521', NULL, 'GD20046', 106, NULL, NULL, 106551),
(106552, '3.40.50.150-FF-000149', NULL, 'Protein arginine N-methyltransferase', 172, NULL, NULL, 106552),
(106553, '3.30.70.330-FF-001659', NULL, NULL, 81, NULL, NULL, 106553),
(106554, '1.10.10.10-FF-000718', NULL, 'RNA polymerase sigma-70 factor, ECF subfamily', 80, NULL, NULL, 106554),
(106555, '2.60.40.10-FF-000660', NULL, 'Uncharacterized protein, isoform B', 93, NULL, NULL, 106555),
(106556, '2.40.10.10-FF-000288', NULL, 'uncharacterized protein LOC100179458 isoform X1', 111, NULL, NULL, 106556),
(106557, '2.60.40.10-FF-005977', NULL, NULL, 98, NULL, NULL, 106557),
(106558, '1.10.533.10-FF-000209', NULL, 'Uncharacterized protein', 105, NULL, NULL, 106558),
(106559, '3.40.50.150-FF-000284', NULL, 'Type I restriction enzyme StySJI M protein', 323, NULL, NULL, 106559),
(106560, '3.30.1330.60-FF-000021', NULL, 'Outer membrane protein OmpA', 123, NULL, NULL, 106560),
(106561, '3.30.420.10-FF-000593', NULL, NULL, 200, NULL, NULL, 106561),
(106562, '2.60.40.60-FF-000725', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1', 98, NULL, NULL, 106562),
(106563, '3.30.160.60-FF-002228', NULL, 'Putative transcription factor Ovo-like 2-like', 37, NULL, NULL, 106563);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(106564, '2.40.180.10-FF-000030', NULL, 'Linolenate 9R-lipoxygenase', 336, NULL, NULL, 106564),
(106565, '1.10.238.10-FF-000692', NULL, 'Calcium-binding protein E', 78, NULL, NULL, 106565),
(106566, '3.90.1410.10-FF-000139', NULL, 'Predicted protein', 168, NULL, NULL, 106566),
(106567, '1.10.238.10-FF-000512', NULL, 'Putative TPR repeat-containing protein', 203, NULL, NULL, 106567),
(106568, '3.30.70.330-FF-001805', NULL, NULL, 155, NULL, NULL, 106568),
(106569, '3.30.750.24-FF-000063', NULL, 'SulP family inorganic anion transporter', 136, NULL, NULL, 106569),
(106570, '2.60.40.60-FF-000181', NULL, 'Predicted protein', 104, NULL, NULL, 106570),
(106571, '1.10.150.530-FF-000012', NULL, 'Dual-specificity RNA methyltransferase RlmN', 59, NULL, NULL, 106571),
(106572, '3.90.1750.10-FF-000086', NULL, 'Uncharacterized protein', 151, NULL, NULL, 106572),
(106573, '3.40.50.300-FF-002279', NULL, 'RecBCD enzyme subunit RecB', 227, NULL, NULL, 106573),
(106574, '2.60.40.4060-FF-000013', NULL, 'Spondin-1-like Protein', 141, NULL, NULL, 106574),
(106575, '2.40.100.10-FF-000154', NULL, 'Peptidyl-prolyl cis-trans isomerase', 149, NULL, NULL, 106575),
(106576, '1.10.3210.10-FF-000015', NULL, 'Deoxynucleoside triphosphate triphosphohydrolase SAMHD1', 340, NULL, NULL, 106576),
(106577, '2.30.29.30-FF-001372', NULL, 'Uncharacterized protein', 124, NULL, NULL, 106577),
(106578, '3.90.79.10-FF-000251', NULL, 'Uncharacterized protein', 145, NULL, NULL, 106578),
(106579, '1.10.10.60-FF-000290', NULL, 'homeobox protein Hox-B3', 96, NULL, NULL, 106579),
(106580, '3.10.100.10-FF-000062', NULL, 'C-type lectin domain family 2 member D', 127, NULL, NULL, 106580),
(106581, '1.10.418.10-FF-000240', NULL, 'Uncharacterized protein', 39, NULL, NULL, 106581),
(106582, '2.60.120.260-FF-000132', NULL, 'Anaphase promoting complex subunit 10', 200, NULL, NULL, 106582),
(106583, '3.80.10.10-FF-003460', NULL, 'Uncharacterized protein', 233, NULL, NULL, 106583),
(106584, '1.10.132.60-FF-000051', NULL, 'DNA polymerase', 160, NULL, NULL, 106584),
(106585, '2.40.30.10-FF-000216', NULL, 'Oxidoreductase, FAD-binding', 15, NULL, NULL, 106585),
(106586, '1.20.1070.10-FF-001198', NULL, 'Olfactory receptor', 97, NULL, NULL, 106586),
(106587, '3.40.50.300-FF-005489', NULL, 'Uncharacterized protein', 196, NULL, NULL, 106587),
(106588, '2.60.40.640-FF-000046', NULL, 'RE18068p', 146, NULL, NULL, 106588),
(106589, '2.60.200.20-FF-000177', NULL, 'E3 ubiquitin-protein ligase RNF8', 89, NULL, NULL, 106589),
(106590, '1.20.1070.10-FF-001226', NULL, 'Uncharacterized protein', 270, NULL, NULL, 106590),
(106591, '1.20.120.330-FF-000045', NULL, 'Protein tyrosine kinase 2 beta', 81, NULL, NULL, 106591),
(106592, '2.60.40.10-FF-002560', NULL, 'Titin homolog', 86, NULL, NULL, 106592),
(106593, '4.10.1240.10-FF-000071', NULL, 'Uncharacterized protein', 116, NULL, NULL, 106593),
(106594, '2.130.10.10-FF-004662', NULL, 'WD repeat-containing protein JIP5', 187, NULL, NULL, 106594),
(106595, '2.60.40.10-FF-001132', NULL, 'Sidekick, isoform B', 103, NULL, NULL, 106595),
(106596, '3.30.160.60-FF-004128', NULL, NULL, 68, NULL, NULL, 106596),
(106597, '2.40.70.10-FF-000308', NULL, NULL, 201, NULL, NULL, 106597),
(106598, '3.40.1050.10-FF-000033', NULL, 'Carbonic anhydrase', 113, NULL, NULL, 106598),
(106599, '3.10.129.10-FF-000043', NULL, 'Bifunctional aldehyde dehydrogenase/enoyl-CoA hydratase', 155, NULL, NULL, 106599),
(106600, '3.20.20.210-FF-000014', NULL, 'Dimethylsulfide methyltransferase corrinoid protein', 361, NULL, NULL, 106600),
(106601, '3.40.50.1440-FF-000057', NULL, 'Tubulin delta 1', 117, NULL, NULL, 106601),
(106602, '1.10.730.10-FF-000201', NULL, 'Arginyl-tRNA synthetase, putative', 129, NULL, NULL, 106602),
(106603, '3.40.50.1000-FF-000509', NULL, NULL, 111, NULL, NULL, 106603),
(106604, '2.60.40.1360-FF-000006', NULL, 'Alpha-mannosidase 2', 96, NULL, NULL, 106604),
(106605, '2.60.40.10-FF-002234', NULL, 'Mannosidase beta', 109, NULL, NULL, 106605),
(106606, '2.60.40.2130-FF-000013', NULL, 'Uncharacterized protein', 96, NULL, NULL, 106606),
(106607, '1.20.5.430-FF-000003', NULL, 'Heat shock factor binding protein', 47, NULL, NULL, 106607);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(106608, '1.10.220.10-FF-000073', NULL, 'Annexin', 47, NULL, NULL, 106608),
(106609, '3.40.50.720-FF-001534', NULL, 'Uncharacterized protein', 359, NULL, NULL, 106609),
(106610, '3.90.780.10-FF-000010', NULL, '2'',3''-cyclic-nucleotide 2''-phosphodiesterase / 3''-nucleotidase', 209, NULL, NULL, 106610),
(106611, '1.25.40.10-FF-000726', NULL, 'TPR-repeat-containing chaperone protein DNAJ', 121, NULL, NULL, 106611),
(106612, '1.10.1660.10-FF-000014', NULL, 'MerR family transcriptional regulator', 125, NULL, NULL, 106612),
(106613, '1.20.5.440-FF-000006', NULL, 'ATP synthase epsilon chain', 41, NULL, NULL, 106613),
(106614, '3.10.280.10-FF-000029', NULL, 'Predicted protein', 182, NULL, NULL, 106614),
(106615, '2.60.40.3690-FF-000003', NULL, 'Minor fimbrium subunit Mfa1', 181, NULL, NULL, 106615),
(106616, '2.30.30.210-FF-000006', NULL, 'Ribonuclease P protein subunit p29', 96, NULL, NULL, 106616),
(106617, '1.25.40.20-FF-001011', NULL, 'ankyrin repeat and KH domain-containing protein 1-like', 68, NULL, NULL, 106617),
(106618, '3.30.200.20-FF-002254', NULL, 'Uncharacterized protein', 13, NULL, NULL, 106618),
(106619, '3.40.50.620-FF-000211', NULL, 'Dual-specific kinase DSK1-like', 155, NULL, NULL, 106619),
(106620, '2.60.40.10-FF-000334', NULL, 'vesicle-associated membrane protein-associated protein A isoform X1', 128, NULL, NULL, 106620),
(106621, '3.10.20.740-FF-000006', NULL, 'NADH-ubiquinone oxidoreductase, subunit G, putative', 84, NULL, NULL, 106621),
(106622, '1.25.40.20-FF-000729', NULL, 'Signal recognition particle 43 kDa protein, chloroplastic', 144, NULL, NULL, 106622),
(106623, '1.50.40.10-FF-000247', NULL, 'Uncharacterized protein', 126, NULL, NULL, 106623),
(106624, '1.20.930.40-FF-000026', NULL, 'N-acetylated alpha-linked acidic dipeptidase like 1', 60, NULL, NULL, 106624),
(106625, '1.10.510.10-FF-002236', NULL, 'Dual specificity mitogen-activated protein kinase kinase 1', 236, NULL, NULL, 106625),
(106626, '3.40.50.150-FF-000593', NULL, 'Fibrillarin-like protein', 178, NULL, NULL, 106626),
(106627, '1.10.10.10-FF-000073', NULL, 'E2F transcription factor 8', 77, NULL, NULL, 106627),
(106628, '3.90.1110.10-FF-000009', NULL, 'DNA-directed RNA polymerase subunit beta', 176, NULL, NULL, 106628),
(106629, '2.40.70.10-FF-000281', NULL, 'Aspartyl protease, putative', 181, NULL, NULL, 106629),
(106630, '2.40.160.60-FF-000004', NULL, 'Long-chain fatty acid transport protein', 407, NULL, NULL, 106630),
(106631, '2.60.120.200-FF-000221', NULL, 'Axotactin, isoform B', 173, NULL, NULL, 106631),
(106632, '3.60.20.30-FF-000022', NULL, NULL, 108, NULL, NULL, 106632),
(106633, '2.120.10.80-FF-000221', NULL, 'Acyl-CoA-binding domain-containing protein 4', 131, NULL, NULL, 106633),
(106634, '3.40.50.620-FF-000520', NULL, 'Uncharacterized protein', 232, NULL, NULL, 106634),
(106635, '1.10.506.10-FF-000085', NULL, 'Uncharacterized protein', 120, NULL, NULL, 106635),
(106636, '3.40.850.10-FF-000212', NULL, 'Kinesin, putative', 329, NULL, NULL, 106636),
(106637, '3.90.70.10-FF-000068', NULL, 'Cysteine protease 1', 324, NULL, NULL, 106637),
(106638, '3.20.20.70-FF-000777', NULL, NULL, 94, NULL, NULL, 106638),
(106639, '3.30.1050.10-FF-000001', NULL, 'Putative Non-specific lipid-transfer protein', 121, NULL, NULL, 106639),
(106640, '3.40.190.10-FF-000212', NULL, 'Amino acid ABC transporter, amino acid-binding protein/permease protein', 95, NULL, NULL, 106640),
(106641, '1.25.10.10-FF-000354', NULL, 'DUF1716 domain protein', 476, NULL, NULL, 106641),
(106642, '3.90.120.10-FF-000005', NULL, 'tRNA (Cytosine(38)-C(5))-methyltransferase isoform X1', 143, NULL, NULL, 106642),
(106643, '2.60.40.60-FF-000416', NULL, 'Cadherin-related hmr-1', 97, NULL, NULL, 106643),
(106644, '3.30.40.10-FF-001553', NULL, 'Protein CBR-ZHP-3', 49, NULL, NULL, 106644),
(106645, '3.40.50.80-FF-000213', NULL, 'Uncharacterized protein', 105, NULL, NULL, 106645),
(106646, '3.80.10.10-FF-003443', NULL, 'Uncharacterized protein', 54, NULL, NULL, 106646),
(106647, '3.90.550.10-FF-000055', NULL, 'Alpha-1,3-mannosyl-glycoprotein 2-beta-N-acetylglucosaminyltransferase', 226, NULL, NULL, 106647);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(106648, '3.30.830.10-FF-000174', NULL, 'ACR069Cp', 213, NULL, NULL, 106648),
(106649, '3.80.10.10-FF-003134', NULL, 'Predicted protein', 65, NULL, NULL, 106649),
(106650, '3.30.160.60-FF-002537', NULL, 'Trade embargo', 27, NULL, NULL, 106650),
(106651, '1.25.40.10-FF-001828', NULL, 'SNAP (Soluble NSF Attachment Protein) homolog', 289, NULL, NULL, 106651),
(106652, '3.90.70.10-FF-000377', NULL, 'Uncharacterized protein', 118, NULL, NULL, 106652),
(106653, '1.25.10.10-FF-000045', NULL, 'Formin-like protein 3 isoform 1', 144, NULL, NULL, 106653),
(106654, '3.55.40.20-FF-000010', NULL, 'Mitochondrial ribosomal small subunit component', 116, NULL, NULL, 106654),
(106655, '2.40.160.50-FF-000001', NULL, 'Outer membrane protein assembly factor BamA', 377, NULL, NULL, 106655),
(106656, '3.40.50.720-FF-002023', NULL, 'Uncharacterized protein', 205, NULL, NULL, 106656),
(106657, '3.40.140.10-FF-000164', NULL, 'Uncharacterized protein', 180, NULL, NULL, 106657),
(106658, '3.10.129.10-FF-000026', NULL, 'Possible 4-hydroxybenzoyl-CoA thioesterase', 137, NULL, NULL, 106658),
(106659, '3.40.50.1820-FF-000986', NULL, 'Predicted protein', 252, NULL, NULL, 106659),
(106660, '2.60.120.650-FF-000007', NULL, 'Jumonji, AT rich interactive domain 2', 286, NULL, NULL, 106660),
(106661, '3.40.50.300-FF-002942', NULL, 'Putative ATP-dependent helicase IRC3', 194, NULL, NULL, 106661),
(106662, '3.90.550.50-FF-000134', NULL, 'YALI0F23485p', 229, NULL, NULL, 106662),
(106663, '3.50.50.60-FF-000033', NULL, 'Nitrite reductase [NAD(P)H], large subunit', 137, NULL, NULL, 106663),
(106664, '1.10.3460.10-FF-000033', NULL, 'Chlorophyll a-b binding protein, chloroplastic', 118, NULL, NULL, 106664),
(106665, '3.40.50.10810-FF-000063', NULL, 'Chromosome 12, whole genome shotgun sequence', 309, NULL, NULL, 106665),
(106666, '2.70.130.10-FF-000059', NULL, NULL, 160, NULL, NULL, 106666),
(106667, '1.20.1250.20-FF-001771', NULL, 'Monocarboxylate transporter, putative', 187, NULL, NULL, 106667),
(106668, '3.40.50.2000-FF-001119', NULL, 'Uncharacterized protein', 229, NULL, NULL, 106668),
(106669, '3.30.70.330-FF-001985', NULL, NULL, 102, NULL, NULL, 106669),
(106670, '1.10.10.10-FF-000382', NULL, 'LysR family transcriptional regulator', 87, NULL, NULL, 106670),
(106671, '3.30.160.60-FF-003026', NULL, 'Uncharacterized protein', 26, NULL, NULL, 106671),
(106672, '3.30.40.10-FF-000142', NULL, 'Recombination activating gene 1', 86, NULL, NULL, 106672),
(106673, '3.30.70.1230-FF-000194', NULL, 'Predicted protein', 136, NULL, NULL, 106673),
(106674, '3.40.50.300-FF-000481', NULL, 'Structural maintenance of chromosomes 4', 178, NULL, NULL, 106674),
(106675, '1.20.1070.10-FF-001861', NULL, 'Uncharacterized protein', 295, NULL, NULL, 106675),
(106676, '1.25.40.10-FF-002317', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 97, NULL, NULL, 106676),
(106677, '1.25.40.10-FF-000417', NULL, 'Pentatricopeptide repeat-containing protein At4g38010', 91, NULL, NULL, 106677),
(106678, '3.80.10.10-FF-001189', NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At4g36180', 101, NULL, NULL, 106678),
(106679, '3.40.109.10-FF-000030', NULL, 'Nitroreductase family protein', 169, NULL, NULL, 106679),
(106680, '3.40.50.1000-FF-000818', NULL, NULL, 104, NULL, NULL, 106680),
(106681, '3.30.60.20-FF-000028', NULL, 'Thymidine kinase', 43, NULL, NULL, 106681),
(106682, '1.10.418.10-FF-000138', NULL, 'Cortexillin I', 117, NULL, NULL, 106682),
(106683, '3.10.450.50-FF-000060', NULL, 'Nuclear transport factor 2 (NTF2) family protein', 137, NULL, NULL, 106683),
(106684, '4.10.60.10-FF-000046', NULL, 'Zinc finger protein GIS2', 20, NULL, NULL, 106684),
(106685, '1.10.472.10-FF-000073', NULL, 'C-type cyclin', 132, NULL, NULL, 106685),
(106686, '3.10.150.10-FF-000025', NULL, 'DNA polymerase III, beta chain', 177, NULL, NULL, 106686),
(106687, '1.25.10.10-FF-000915', NULL, 'Beta-catenin/armadillo-related protein 1', 564, NULL, NULL, 106687),
(106688, '2.60.40.10-FF-005668', NULL, NULL, 86, NULL, NULL, 106688),
(106689, '3.30.1540.20-FF-000042', NULL, NULL, 31, NULL, NULL, 106689);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(106690, '3.10.20.90-FF-000339', NULL, 'Caspar, isoform A', 83, NULL, NULL, 106690),
(106691, '1.10.760.10-FF-000012', NULL, 'Cytochrome C', 70, NULL, NULL, 106691),
(106692, '3.30.565.10-FF-000153', NULL, 'Two component sensor kinase HK1', 142, NULL, NULL, 106692),
(106693, '4.10.860.120-FF-000008', NULL, 'DNA-directed RNA polymerase subunit', 116, NULL, NULL, 106693),
(106694, '1.25.10.10-FF-002815', NULL, 'Uncharacterized protein', 195, NULL, NULL, 106694),
(106695, '1.25.40.10-FF-003599', NULL, 'SARP family transcriptional regulator', 138, NULL, NULL, 106695),
(106696, '1.10.1220.170-FF-000003', NULL, 'Antitoxin', 48, NULL, NULL, 106696),
(106697, '3.40.50.1000-FF-000611', NULL, NULL, 138, NULL, NULL, 106697),
(106698, '1.10.510.10-FF-000971', NULL, 'CMGC/SRPK protein kinase', 119, NULL, NULL, 106698),
(106699, '3.30.70.330-FF-000703', NULL, 'Splicing factor U2AF large subunit', 106, NULL, NULL, 106699),
(106700, '1.20.1250.20-FF-000001', NULL, 'Dicarboxylate MFS transporter', 215, NULL, NULL, 106700),
(106701, '3.30.40.10-FF-001805', NULL, 'RING-type E3 ubiquitin transferase', 91, NULL, NULL, 106701),
(106702, '1.10.238.10-FF-000719', NULL, 'Calmodulin-like protein 5', 107, NULL, NULL, 106702),
(106703, '1.20.1070.10-FF-002041', NULL, 'Uncharacterized protein', 112, NULL, NULL, 106703),
(106704, '2.40.170.20-FF-000105', NULL, 'TonB-dependent ferric putrebactin siderophore receptor PutA', 541, NULL, NULL, 106704),
(106705, '1.10.287.470-FF-000078', NULL, 'Efflux pump, RND family, membrane fusion protein', 61, NULL, NULL, 106705),
(106706, '3.30.70.1360-FF-000002', NULL, 'Global nitrogen regulator NrpR', 121, NULL, NULL, 106706),
(106707, '3.40.50.300-FF-004842', NULL, 'Werner helicase interacting protein, putative (Fragment)', 141, NULL, NULL, 106707),
(106708, '3.30.160.60-FF-006253', NULL, NULL, 95, NULL, NULL, 106708),
(106709, '2.40.50.730-FF-000001', NULL, 'DNA polymerase', 73, NULL, NULL, 106709),
(106710, '2.120.10.30-FF-000346', NULL, 'Chloroplast protein HCF243', 120, NULL, NULL, 106710),
(106711, '3.10.20.90-FF-000648', NULL, 'NEDD8-like protein 1', 94, NULL, NULL, 106711),
(106712, '3.30.160.60-FF-003982', NULL, NULL, 30, NULL, NULL, 106712),
(106713, '3.90.79.10-FF-000234', NULL, 'Tellurite resistance protein', 200, NULL, NULL, 106713),
(106714, '3.40.50.2300-FF-000091', NULL, 'Chemotaxis two-component response regulator protein', 123, NULL, NULL, 106714),
(106715, '2.130.10.110-FF-000004', NULL, 'Clathrin heavy chain', 283, NULL, NULL, 106715),
(106716, '3.30.160.60-FF-004600', NULL, NULL, 28, NULL, NULL, 106716),
(106717, '1.10.340.30-FF-000031', NULL, 'Endonuclease III', 114, NULL, NULL, 106717),
(106718, '1.10.238.10-FF-000821', NULL, 'Uncharacterized protein', 108, NULL, NULL, 106718),
(106719, '3.10.50.40-FF-000068', NULL, 'Peptidyl-prolyl cis-trans isomerase', 132, NULL, NULL, 106719),
(106720, '1.10.510.10-FF-003973', NULL, NULL, 337, NULL, NULL, 106720),
(106721, '3.40.50.150-FF-000267', NULL, 'Putative methyltransferase family protein', 212, NULL, NULL, 106721),
(106722, '3.30.1330.10-FF-000028', NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase', 156, NULL, NULL, 106722),
(106723, '1.10.287.20-FF-000004', NULL, 'Cytochrome b-c1 complex subunit 6', 75, NULL, NULL, 106723),
(106724, '3.40.50.720-FF-001326', NULL, '3-oxoacyl-ACP reductase', 270, NULL, NULL, 106724),
(106725, '1.50.40.10-FF-000455', NULL, 'Uncharacterized protein', 104, NULL, NULL, 106725),
(106726, '3.90.70.10-FF-000585', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 265, NULL, NULL, 106726),
(106727, '2.130.10.10-FF-000267', NULL, 'DNA damage-binding protein 1a', 318, NULL, NULL, 106727),
(106728, '2.60.40.60-FF-000197', NULL, 'FAT atypical cadherin 2', 85, NULL, NULL, 106728),
(106729, '2.120.10.80-FF-000013', NULL, 'Kelch-like family member 7', 305, NULL, NULL, 106729),
(106730, '3.30.565.10-FF-000170', NULL, 'Two-component sensor histidine kinase', 153, NULL, NULL, 106730),
(106731, '1.10.3260.10-FF-000035', NULL, 'Uncharacterized protein', 223, NULL, NULL, 106731),
(106732, '3.40.50.300-FF-000138', NULL, 'DNA helicase', 361, NULL, NULL, 106732);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(106733, '2.130.10.120-FF-000007', NULL, 'Prolyl endopeptidase', 347, NULL, NULL, 106733),
(106734, '3.40.50.1580-FF-000048', NULL, 'S-methyl-5''-thioadenosine phosphorylase', 283, NULL, NULL, 106734),
(106735, '1.25.40.10-FF-002188', NULL, 'Pentatricopeptide repeat-containing protein At4g31850, chloroplastic', 73, NULL, NULL, 106735),
(106736, '1.10.10.440-FF-000063', NULL, 'Pre-mRNA-processing protein 40B', 68, NULL, NULL, 106736),
(106737, '3.40.50.1820-FF-001166', NULL, 'Uncharacterized protein', 312, NULL, NULL, 106737),
(106738, '1.25.10.10-FF-000562', NULL, 'Microtubule-associated protein TORTIFOLIA1', 374, NULL, NULL, 106738),
(106739, '3.50.50.100-FF-000031', NULL, 'Uncharacterized protein', 348, NULL, NULL, 106739),
(106740, '3.40.50.300-FF-002280', NULL, 'Small GTP-binding protein, putative', 191, NULL, NULL, 106740),
(106741, '2.40.50.430-FF-000001', NULL, 'DNA polymerase delta subunit 2', 125, NULL, NULL, 106741),
(106742, '2.30.130.40-FF-000015', NULL, 'Predicted protein', 126, NULL, NULL, 106742),
(106743, '2.60.200.20-FF-000194', NULL, 'Uncharacterized protein', 110, NULL, NULL, 106743),
(106744, '2.30.30.40-FF-000501', NULL, 'Uncharacterized protein', 59, NULL, NULL, 106744),
(106745, '1.10.443.10-FF-000005', NULL, 'Phage integrase', 181, NULL, NULL, 106745),
(106746, '3.40.50.300-FF-002807', NULL, 'DNA helicase 2', 154, NULL, NULL, 106746),
(106747, '1.10.472.80-FF-000178', NULL, NULL, 111, NULL, NULL, 106747),
(106748, '2.60.40.60-FF-000208', NULL, 'neural-cadherin isoform X11', 109, NULL, NULL, 106748),
(106749, '2.10.110.10-FF-000100', NULL, 'MICAL-like protein 1', 76, NULL, NULL, 106749),
(106750, '1.20.1440.130-FF-000014', NULL, 'Uncharacterized protein', 145, NULL, NULL, 106750),
(106751, '3.40.630.30-FF-000472', NULL, 'DUF482 domain-containing protein', 160, NULL, NULL, 106751),
(106752, '1.10.10.60-FF-000508', NULL, 'Homeodomain transcription factor BW10a', 63, NULL, NULL, 106752),
(106753, '3.40.120.10-FF-000056', NULL, 'Putative phosphomannomutase', 198, NULL, NULL, 106753),
(106754, '3.10.110.10-FF-000017', NULL, 'Ubiquitin-conjugating enzyme E2 2', 148, NULL, NULL, 106754),
(106755, '2.70.40.10-FF-000002', NULL, 'dUTP diphosphatase', 151, NULL, NULL, 106755),
(106756, '2.130.10.10-FF-001947', NULL, 'Probable cytosolic iron-sulfur protein assembly protein CIAO1 homolog', 331, NULL, NULL, 106756),
(106757, '3.10.100.10-FF-000415', NULL, NULL, 100, NULL, NULL, 106757),
(106758, '3.30.565.10-FF-000271', NULL, 'Anti-sigma B factor, putative', 137, NULL, NULL, 106758),
(106759, '2.60.40.10-FF-002442', NULL, 'Plexin-2', 124, NULL, NULL, 106759),
(106760, '2.10.25.10-FF-001543', NULL, 'Tissue plasminogen activator', 22, NULL, NULL, 106760),
(106761, '2.60.40.150-FF-000348', NULL, 'Copine family protein', 128, NULL, NULL, 106761),
(106762, '3.40.225.10-FF-000041', NULL, NULL, 193, NULL, NULL, 106762),
(106763, '3.10.20.90-FF-000441', NULL, 'Cytoskeleton associated protein, putative', 92, NULL, NULL, 106763),
(106764, '3.60.21.10-FF-000119', NULL, 'Sphingomyelin phosphodiesterase', 74, NULL, NULL, 106764),
(106765, '2.60.40.10-FF-002913', NULL, 'Interleukin 12 receptor beta 2.b', 98, NULL, NULL, 106765),
(106766, '3.10.110.10-FF-000343', NULL, 'Ubiquitin-conjugating enzyme E2 N-like Protein', 151, NULL, NULL, 106766),
(106767, '3.90.70.10-FF-000170', NULL, 'Ubiquitin specific peptidase 25', 243, NULL, NULL, 106767),
(106768, '3.90.79.10-FF-000133', NULL, 'Diadenosine hexaphosphate hydrolase', 122, NULL, NULL, 106768),
(106769, '3.90.1440.10-FF-000012', NULL, 'Predicted protein', 118, NULL, NULL, 106769),
(106770, '3.40.50.150-FF-000166', NULL, 'Methyltransferase', 233, NULL, NULL, 106770),
(106771, '3.40.390.10-FF-000210', NULL, 'Uncharacterized protein', 225, NULL, NULL, 106771),
(106772, '3.90.230.10-FF-000025', NULL, 'Methionine aminopeptidase', 286, NULL, NULL, 106772),
(106773, '3.40.50.300-FF-000817', NULL, 'GPN-loop GTPase 1', 259, NULL, NULL, 106773),
(106774, '3.40.50.2300-FF-000102', NULL, 'Nitrate/nitrite response regulator protein narP', 206, NULL, NULL, 106774);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(106775, '3.40.50.300-FF-007012', NULL, 'RAB36, member RAS oncogene family', 208, NULL, NULL, 106775),
(106776, '3.40.50.1000-FF-000482', NULL, NULL, 90, NULL, NULL, 106776),
(106777, '3.40.190.10-FF-000004', NULL, 'Porphobilinogen deaminase', 105, NULL, NULL, 106777),
(106778, '2.130.10.10-FF-000166', NULL, 'THO complex subunit 3', 142, NULL, NULL, 106778),
(106779, '2.10.25.10-FF-001644', NULL, 'Uncharacterized protein', 48, NULL, NULL, 106779),
(106780, '3.50.50.60-FF-000151', NULL, 'Protein CbrA', 349, NULL, NULL, 106780),
(106781, '3.10.20.30-FF-000092', NULL, NULL, 123, NULL, NULL, 106781),
(106782, '3.40.50.720-FF-001225', NULL, 'Homoserine dehydrogenase', 161, NULL, NULL, 106782),
(106783, '1.10.8.60-FF-000199', NULL, 'IQ motif containing with AAA domain 1', 50, NULL, NULL, 106783),
(106784, '3.40.30.10-FF-001001', NULL, 'Iodothyronine deiodinase', 71, NULL, NULL, 106784),
(106785, '3.50.40.10-FF-000006', NULL, 'Phenylalanine--tRNA ligase beta subunit', 196, NULL, NULL, 106785),
(106786, '1.25.40.10-FF-004442', NULL, 'Uncharacterized protein', 118, NULL, NULL, 106786),
(106787, '3.30.450.40-FF-000171', NULL, 'Stage II sporulation E family protein', 160, NULL, NULL, 106787),
(106788, '3.30.310.130-FF-000019', NULL, 'Uncharacterized protein', 55, NULL, NULL, 106788),
(106789, '2.40.10.10-FF-000333', NULL, NULL, 43, NULL, NULL, 106789),
(106790, '2.10.25.10-FF-001217', NULL, 'CD248 molecule, endosialin a', 33, NULL, NULL, 106790),
(106791, '2.40.10.10-FF-000081', NULL, 'Serine protease 56', 241, NULL, NULL, 106791),
(106792, '2.40.50.140-FF-000700', NULL, NULL, 83, NULL, NULL, 106792),
(106793, '1.20.1250.20-FF-001445', NULL, 'Uncharacterized protein', 79, NULL, NULL, 106793),
(106794, '3.40.718.10-FF-000040', NULL, 'Uncharacterized protein', 334, NULL, NULL, 106794),
(106795, '3.30.1010.10-FF-000100', NULL, 'Phosphatidyl inositol 3 kinase, putative', 144, NULL, NULL, 106795),
(106796, '3.40.50.1820-FF-001492', NULL, 'GH07181p', 164, NULL, NULL, 106796),
(106797, '2.130.10.10-FF-002521', NULL, 'Vacuolar protein sorting-associated protein 11 homolog', 267, NULL, NULL, 106797),
(106798, '3.30.230.10-FF-000100', NULL, '30s ribosomal protein s5', 92, NULL, NULL, 106798),
(106799, '3.30.70.330-FF-001777', NULL, NULL, 131, NULL, NULL, 106799),
(106800, '1.10.357.10-FF-000030', NULL, 'TetR family transcriptional regulator', 142, NULL, NULL, 106800),
(106801, '2.60.40.10-FF-000188', NULL, 'Interleukin-1 receptor accessory protein-like 1', 101, NULL, NULL, 106801),
(106802, '2.40.30.330-FF-000006', NULL, 'mRNA cleavage and polyadenylation factor CLP1', 120, NULL, NULL, 106802),
(106803, '3.30.160.60-FF-002346', NULL, 'Zinc finger protein 658', 23, NULL, NULL, 106803),
(106804, '1.25.40.10-FF-000209', NULL, 'Tetratricopeptide repeat domain 28', 112, NULL, NULL, 106804),
(106805, '3.40.30.10-FF-000484', NULL, 'GRXS13', 105, NULL, NULL, 106805),
(106806, '3.30.40.10-FF-001906', NULL, 'Uncharacterized protein', 73, NULL, NULL, 106806),
(106807, '3.40.47.10-FF-000230', NULL, NULL, 87, NULL, NULL, 106807),
(106808, '2.40.33.10-FF-000015', NULL, 'Pyruvate kinase', 97, NULL, NULL, 106808),
(106809, '3.40.1380.10-FF-000018', NULL, 'ATP synthase gamma chain', 204, NULL, NULL, 106809),
(106810, '3.30.200.20-FF-002372', NULL, 'Protein kinase protein with adenine nucleotide alpha hydrolase-like domain', 64, NULL, NULL, 106810),
(106811, '1.10.720.60-FF-000018', NULL, 'Uncharacterized protein', 89, NULL, NULL, 106811),
(106812, '2.80.10.50-FF-000214', NULL, 'Fibroblast growth factor 8', 82, NULL, NULL, 106812),
(106813, '3.40.50.300-FF-003999', NULL, 'ABC transporter, class F', 278, NULL, NULL, 106813),
(106814, '2.60.40.10-FF-005994', NULL, NULL, 127, NULL, NULL, 106814),
(106815, '1.20.58.70-FF-000082', NULL, 'Uncharacterized protein', 123, NULL, NULL, 106815),
(106816, '3.30.160.60-FF-006045', NULL, NULL, 23, NULL, NULL, 106816),
(106817, '1.10.10.10-FF-000511', NULL, 'LysR family transcriptional regulator', 88, NULL, NULL, 106817),
(106818, '3.40.50.300-FF-000346', NULL, 'RAB31, member RAS oncogene family', 192, NULL, NULL, 106818);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(106819, '2.60.40.10-FF-004358', NULL, NULL, 101, NULL, NULL, 106819),
(106820, '3.30.110.110-FF-000013', NULL, 'Uncharacterized protein', 101, NULL, NULL, 106820),
(106821, '3.90.1100.10-FF-000054', NULL, 'DNA-directed RNA polymerase I subunit, putative', 80, NULL, NULL, 106821),
(106822, '3.40.350.10-FF-000101', NULL, 'FACT complex subunit spt16-like Protein', 167, NULL, NULL, 106822),
(106823, '3.30.70.1400-FF-000020', NULL, 'Uncharacterized protein', 26, NULL, NULL, 106823),
(106824, '3.90.1150.10-FF-000102', NULL, 'Kynureninase', 144, NULL, NULL, 106824),
(106825, '3.40.50.300-FF-004078', NULL, 'MPP7 isoform 5', 124, NULL, NULL, 106825),
(106826, '3.40.50.150-FF-000475', NULL, 'Ubiquinone biosynthesis O-methyltransferase, mitochondrial', 230, NULL, NULL, 106826),
(106827, '4.10.60.10-FF-000029', NULL, 'Serine/arginine-rich splicing factor RSZ22A', 61, NULL, NULL, 106827),
(106828, '1.25.40.10-FF-000390', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 155, NULL, NULL, 106828),
(106829, '1.20.920.30-FF-000051', NULL, 'Uncharacterized protein', 123, NULL, NULL, 106829),
(106830, '2.70.98.10-FF-000051', NULL, 'Beta-galactosidase', 280, NULL, NULL, 106830),
(106831, '3.30.70.1230-FF-000093', NULL, '7TM diverse intracellular signaling', 198, NULL, NULL, 106831),
(106832, '3.30.1120.10-FF-000075', NULL, 'Predicted protein', 59, NULL, NULL, 106832),
(106833, '1.10.510.10-FF-000628', NULL, 'protein spire homolog 1 isoform X1', 78, NULL, NULL, 106833),
(106834, '1.20.120.520-FF-000012', NULL, 'Putative a receptor for ubiquitination targets', 168, NULL, NULL, 106834),
(106835, '3.40.50.150-FF-000519', NULL, 'DNA (cytosine-5)-methyltransferase DRM2', 112, NULL, NULL, 106835),
(106836, '1.10.150.40-FF-000008', NULL, 'barrier-to-autointegration factor', 88, NULL, NULL, 106836),
(106837, '2.40.160.10-FF-000028', NULL, 'Outer membrane protein OmpT', 324, NULL, NULL, 106837),
(106838, '1.20.120.230-FF-000032', NULL, 'Alpha-CaTuliN (Catenin/vinculin related)', 187, NULL, NULL, 106838),
(106839, '1.25.40.20-FF-000393', NULL, 'CRE-GLNA-3 protein', 92, NULL, NULL, 106839),
(106840, '1.25.40.10-FF-002452', NULL, 'Pentatricopeptide repeat-containing protein At3g04760, chloroplastic', 70, NULL, NULL, 106840),
(106841, '3.40.50.300-FF-004741', NULL, 'Predicted protein', 226, NULL, NULL, 106841),
(106842, '1.10.10.60-FF-000609', NULL, 'Homeobox B4', 86, NULL, NULL, 106842),
(106843, '3.30.160.60-FF-006354', NULL, NULL, 51, NULL, NULL, 106843),
(106844, '3.30.420.40-FF-000461', NULL, 'Type 4 actin', 29, NULL, NULL, 106844),
(106845, '1.10.630.10-FF-000694', NULL, 'Uncharacterized protein', 145, NULL, NULL, 106845),
(106846, '3.90.1750.10-FF-000069', NULL, 'HECT E3 ubiquitin ligase', 74, NULL, NULL, 106846),
(106847, '1.10.1000.11-FF-000028', NULL, 'Protein transport protein sec71', 120, NULL, NULL, 106847),
(106848, '3.80.10.10-FF-001644', NULL, 'LRR and NB-ARC domains-containing disease resistance protein', 174, NULL, NULL, 106848),
(106849, '3.30.40.10-FF-000979', NULL, 'E3 ubiquitin-protein ligase SINA-like 10', 58, NULL, NULL, 106849),
(106850, '3.40.190.10-FF-000313', NULL, 'LysR family transcriptional regulator', 91, NULL, NULL, 106850),
(106851, '1.20.1610.10-FF-000026', NULL, 'Uncharacterized protein', 94, NULL, NULL, 106851),
(106852, '3.40.50.300-FF-006287', NULL, 'Elongation factor G', 265, NULL, NULL, 106852),
(106853, '1.20.58.390-FF-000182', NULL, 'Predicted protein', 112, NULL, NULL, 106853),
(106854, '2.60.40.10-FF-001014', NULL, 'vascular endothelial growth factor receptor 1', 87, NULL, NULL, 106854),
(106855, '3.40.190.290-FF-000052', NULL, 'LysR family transcriptional regulator', 206, NULL, NULL, 106855),
(106856, '1.25.40.20-FF-000864', NULL, 'Transient receptor potential cation channel subfamily A member 1', 123, NULL, NULL, 106856),
(106857, '2.60.40.10-FF-004151', NULL, NULL, 89, NULL, NULL, 106857),
(106858, '2.40.30.170-FF-000014', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 68, NULL, NULL, 106858),
(106859, '3.90.550.10-FF-000279', NULL, 'Glycosyl transferase', 235, NULL, NULL, 106859);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(106860, '3.20.180.20-FF-000011', NULL, 'Dynein heavy chain', 100, NULL, NULL, 106860),
(106861, '1.10.238.10-FF-000484', NULL, 'Calmodulin-like protein', 63, NULL, NULL, 106861),
(106862, '1.20.120.530-FF-000015', NULL, 'GntR family transcriptional regulator', 149, NULL, NULL, 106862),
(106863, '1.10.510.10-FF-002770', NULL, NULL, 191, NULL, NULL, 106863),
(106864, '2.130.10.10-FF-004218', NULL, 'Uncharacterized protein', 150, NULL, NULL, 106864),
(106865, '2.40.50.100-FF-000149', NULL, 'Carbamoyl-phosphate synthase L chain, ATP binding domain protein', 77, NULL, NULL, 106865),
(106866, '1.10.132.130-FF-000002', NULL, 'Legumain preproprotein', 127, NULL, NULL, 106866),
(106867, '2.120.10.30-FF-000363', NULL, 'Superoxide dismutase (SodC), Cu-Zn family', 237, NULL, NULL, 106867),
(106868, '3.30.230.130-FF-000017', NULL, 'Cullin-3', 184, NULL, NULL, 106868),
(106869, '2.170.120.20-FF-000009', NULL, '50S ribosomal protein L25', 93, NULL, NULL, 106869),
(106870, '1.20.144.10-FF-000106', NULL, 'Predicted protein', 233, NULL, NULL, 106870),
(106871, '1.10.3430.10-FF-000060', NULL, 'Uncharacterized protein', 145, NULL, NULL, 106871),
(106872, '3.30.70.590-FF-000006', NULL, 'Poly(A) polymerase PAP, putative', 117, NULL, NULL, 106872),
(106873, '3.80.10.10-FF-001217', NULL, 'Protein halfway', 195, NULL, NULL, 106873),
(106874, '3.40.640.10-FF-000157', NULL, 'Aspartate aminotransferase', 273, NULL, NULL, 106874),
(106875, '3.30.230.120-FF-000014', NULL, 'GHMP kinase', 340, NULL, NULL, 106875),
(106876, '3.40.50.300-FF-002487', NULL, 'Guanine nucleotide-binding protein G(i) subunit alpha-1', 202, NULL, NULL, 106876),
(106877, '3.40.50.300-FF-006332', NULL, 'Cell division control protein 48 homolog C', 49, NULL, NULL, 106877),
(106878, '3.40.50.880-FF-000132', NULL, 'Uncharacterized protein', 243, NULL, NULL, 106878),
(106879, '3.30.420.40-FF-000034', NULL, 'Phosphotransferase', 169, NULL, NULL, 106879),
(106880, '2.160.20.10-FF-000305', NULL, 'Predicted protein', 140, NULL, NULL, 106880),
(106881, '1.10.510.10-FF-002219', NULL, 'Uncharacterized protein', 308, NULL, NULL, 106881),
(106882, '3.30.1680.10-FF-000015', NULL, 'semaphorin-6C isoform X1', 62, NULL, NULL, 106882),
(106883, '1.25.10.10-FF-002271', NULL, 'Uncharacterized protein', 340, NULL, NULL, 106883),
(106884, '3.30.200.20-FF-000129', NULL, 'Transient receptor potential cation channel, subfamily M, member 7', 147, NULL, NULL, 106884),
(106885, '1.20.1250.20-FF-000939', NULL, 'Uncharacterized protein', 199, NULL, NULL, 106885),
(106886, '1.10.510.10-FF-000527', NULL, 'Non-specific serine/threonine protein kinase', 197, NULL, NULL, 106886),
(106887, '1.20.120.1750-FF-000124', NULL, 'RBR-type E3 ubiquitin transferase', 111, NULL, NULL, 106887),
(106888, '3.30.70.580-FF-000003', NULL, 'Pseudouridine synthase', 85, NULL, NULL, 106888),
(106889, '2.60.40.60-FF-000517', NULL, 'Protein CBG11732', 102, NULL, NULL, 106889),
(106890, '2.60.120.10-FF-000741', NULL, 'Uncharacterized protein', 118, NULL, NULL, 106890),
(106891, '2.30.30.210-FF-000023', NULL, 'Uncharacterized protein', 98, NULL, NULL, 106891),
(106892, '2.130.10.10-FF-005747', NULL, 'Predicted protein', 121, NULL, NULL, 106892),
(106893, '3.30.200.20-FF-002271', NULL, 'Uncharacterized protein', 111, NULL, NULL, 106893),
(106894, '1.25.40.10-FF-001845', NULL, 'Thioredoxin', 82, NULL, NULL, 106894),
(106895, '3.40.630.10-FF-000229', NULL, 'Carboxypeptidase Z', 74, NULL, NULL, 106895),
(106896, '1.20.1050.10-FF-000241', NULL, 'Uncharacterized protein', 70, NULL, NULL, 106896),
(106897, '3.30.160.60-FF-002554', NULL, 'Zinc finger protein 778', 29, NULL, NULL, 106897),
(106898, '3.40.50.1240-FF-000115', NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', 365, NULL, NULL, 106898),
(106899, '1.10.150.20-FF-000002', NULL, 'DNA polymerase I', 144, NULL, NULL, 106899),
(106900, '1.10.238.10-FF-000175', NULL, 'Calpain 14', 168, NULL, NULL, 106900),
(106901, '3.80.20.20-FF-000063', NULL, 'Receptor protein-tyrosine kinase', 171, NULL, NULL, 106901),
(106902, '3.30.420.40-FF-000343', NULL, 'Chromatin remodeling Snf/Swi complex subunit', 162, NULL, NULL, 106902);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(106903, '3.90.550.10-FF-000072', NULL, 'UDP-N-acetylglucosamine diphosphorylase 2', 472, NULL, NULL, 106903),
(106904, '3.40.50.720-FF-002040', NULL, 'Probable NADPH-dependent quinone reductase tdiC', 182, NULL, NULL, 106904),
(106905, '1.10.472.10-FF-000308', NULL, 'Mitotic cyclin 6', 30, NULL, NULL, 106905),
(106906, '3.30.420.40-FF-000770', NULL, 'Heat shock protein 70 putative', 130, NULL, NULL, 106906),
(106907, '3.40.50.300-FF-008541', NULL, 'Uncharacterized protein', 202, NULL, NULL, 106907),
(106908, '3.40.50.1820-FF-000969', NULL, 'Cholinesterase, putative (AFU_orthologue AFUA_7G01710)', 536, NULL, NULL, 106908),
(106909, '3.30.160.60-FF-000093', NULL, 'zinc finger protein 668 isoform X1', 27, NULL, NULL, 106909),
(106910, '3.80.10.10-FF-001335', NULL, 'Relaxin family peptide receptor 2', 86, NULL, NULL, 106910),
(106911, '3.30.160.60-FF-004336', NULL, NULL, 35, NULL, NULL, 106911),
(106912, '2.40.70.10-FF-000516', NULL, NULL, 66, NULL, NULL, 106912),
(106913, '3.50.50.60-FF-000050', NULL, 'L-2-hydroxyglutarate dehydrogenase, mitochondrial', 202, NULL, NULL, 106913),
(106914, '1.25.10.10-FF-002580', NULL, 'Uncharacterized protein', 159, NULL, NULL, 106914),
(106915, '2.60.40.60-FF-000860', NULL, 'Uncharacterized protein', 109, NULL, NULL, 106915),
(106916, '3.40.50.300-FF-003004', NULL, 'ras-related protein Rab-39B-like isoform X2', 79, NULL, NULL, 106916),
(106917, '2.160.20.10-FF-000204', NULL, 'Uncharacterized protein', 502, NULL, NULL, 106917),
(106918, '2.40.10.10-FF-000097', NULL, 'Coagulation factor XII', 101, NULL, NULL, 106918),
(106919, '1.10.287.1490-FF-000132', NULL, 'Uncharacterized protein', 110, NULL, NULL, 106919),
(106920, '1.10.238.10-FF-000411', NULL, 'Os12g0138050 protein', 115, NULL, NULL, 106920),
(106921, '2.120.10.30-FF-000155', NULL, 'FI21413p1', 315, NULL, NULL, 106921),
(106922, '3.60.21.50-FF-000007', NULL, 'DNA polymerase epsilon subunit', 247, NULL, NULL, 106922),
(106923, '3.40.50.620-FF-000003', NULL, 'Leucine--tRNA ligase', 221, NULL, NULL, 106923),
(106924, '1.10.275.40-FF-000011', NULL, 'DNA repair helicase Rad3', 169, NULL, NULL, 106924),
(106925, '3.30.1490.110-FF-000005', NULL, 'Cell division protein FtsA', 81, NULL, NULL, 106925),
(106926, '2.30.180.10-FF-000167', NULL, NULL, 156, NULL, NULL, 106926),
(106927, '3.30.70.920-FF-000004', NULL, 'Chaperone NapD', 70, NULL, NULL, 106927),
(106928, '2.10.70.10-FF-000097', NULL, 'Uncharacterized protein, isoform A', 63, NULL, NULL, 106928),
(106929, '1.10.132.60-FF-000017', NULL, 'DNA polymerase', 150, NULL, NULL, 106929),
(106930, '1.10.472.10-FF-000426', NULL, 'Cyclin I, putative', 65, NULL, NULL, 106930),
(106931, '3.40.50.150-FF-000930', NULL, NULL, 199, NULL, NULL, 106931),
(106932, '4.10.400.10-FF-000154', NULL, 'Low-density lipoprotein receptor-related protein 2', 40, NULL, NULL, 106932),
(106933, '1.25.10.10-FF-002624', NULL, 'Predicted protein', 130, NULL, NULL, 106933),
(106934, '1.10.10.60-FF-000817', NULL, NULL, 52, NULL, NULL, 106934),
(106935, '1.10.238.10-FF-000927', NULL, 'Defective in cullin neddylation protein', 74, NULL, NULL, 106935),
(106936, '1.25.40.10-FF-000518', NULL, 'Pentatricopeptide repeat-containing protein', 108, NULL, NULL, 106936),
(106937, '1.10.533.10-FF-000198', NULL, 'Uncharacterized protein', 91, NULL, NULL, 106937),
(106938, '3.30.1490.100-FF-000002', NULL, 'DNA polymerase IV', 111, NULL, NULL, 106938),
(106939, '2.40.30.10-FF-000407', NULL, 'Eukaryotic Release FActor homolog', 42, NULL, NULL, 106939),
(106940, '3.50.50.60-FF-000460', NULL, 'Flavin-containing monooxygenase', 232, NULL, NULL, 106940),
(106941, '3.30.390.110-FF-000006', NULL, '60S ribosomal protein L28', 127, NULL, NULL, 106941),
(106942, '1.10.274.30-FF-000028', NULL, 'Predicted protein', 141, NULL, NULL, 106942),
(106943, '3.30.70.2190-FF-000009', NULL, 'FAD-linked oxidase', 117, NULL, NULL, 106943),
(106944, '1.25.40.10-FF-004560', NULL, 'Uncharacterized protein', 409, NULL, NULL, 106944),
(106945, '2.60.120.260-FF-000323', NULL, 'Uncharacterized protein', 156, NULL, NULL, 106945),
(106946, '3.90.70.10-FF-000276', NULL, 'Ubiquitinyl hydrolase 1', 218, NULL, NULL, 106946);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(106947, '2.30.42.10-FF-000300', NULL, 'Par-3 family cell polarity regulator beta', 62, NULL, NULL, 106947),
(106948, '3.40.30.10-FF-001107', NULL, 'Uncharacterized protein', 40, NULL, NULL, 106948),
(106949, '3.30.1490.120-FF-000008', NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', 99, NULL, NULL, 106949),
(106950, '1.10.238.10-FF-000057', NULL, 'Tubulin polymerization-promoting protein family member 3', 103, NULL, NULL, 106950),
(106951, '1.25.10.10-FF-000253', NULL, 'Splicing factor 3B subunit 1', 171, NULL, NULL, 106951),
(106952, '3.40.50.300-FF-000447', NULL, 'helicase SKI2W isoform X2', 258, NULL, NULL, 106952),
(106953, '1.10.510.10-FF-000319', NULL, 'Non-specific serine/threonine protein kinase', 126, NULL, NULL, 106953),
(106954, '4.10.70.10-FF-000002', NULL, 'disintegrin and metalloproteinase domain-containing protein 10', 92, NULL, NULL, 106954),
(106955, '2.60.40.10-FF-002133', NULL, 'Muscle M-line assembly protein unc-89', 100, NULL, NULL, 106955),
(106956, '2.60.40.10-FF-000761', NULL, 'palladin isoform X2', 101, NULL, NULL, 106956),
(106957, '2.60.120.40-FF-000036', NULL, 'C1qA', 134, NULL, NULL, 106957),
(106958, '3.10.110.10-FF-000225', NULL, 'Uncharacterized protein', 121, NULL, NULL, 106958),
(106959, '2.60.40.10-FF-002649', NULL, 'Hypothetical_protein_-_conserved', 104, NULL, NULL, 106959),
(106960, '3.10.450.50-FF-000026', NULL, 'Steroid isomerase, putative', 139, NULL, NULL, 106960),
(106961, '3.10.450.40-FF-000023', NULL, 'Type VI secretion system protein', 122, NULL, NULL, 106961),
(106962, '2.130.10.10-FF-000312', NULL, 'WD repeat domain 91', 184, NULL, NULL, 106962),
(106963, '1.10.20.10-FF-000219', NULL, NULL, 92, NULL, NULL, 106963),
(106964, '3.10.20.310-FF-000018', NULL, 'ShlB/FhaC/HecB family hemolysin secretion/activation protein', 68, NULL, NULL, 106964),
(106965, '3.40.50.150-FF-000828', NULL, 'tRNA wybutosine-synthesizing protein 2', 308, NULL, NULL, 106965),
(106966, '3.30.160.60-FF-000284', NULL, 'Zinc finger protein 652 isoform X1', 28, NULL, NULL, 106966),
(106967, '3.60.15.10-FF-000032', NULL, 'Metallo-hydrolase/oxidoreductase superfamily protein', 182, NULL, NULL, 106967),
(106968, '2.30.30.40-FF-000607', NULL, 'Uncharacterized protein', 55, NULL, NULL, 106968),
(106969, '3.40.50.720-FF-002141', NULL, 'Os03g0184600 protein', 94, NULL, NULL, 106969),
(106970, '1.10.287.110-FF-000419', NULL, 'Predicted protein', 97, NULL, NULL, 106970),
(106971, '2.130.10.10-FF-000828', NULL, 'Ribosomal processing protein', 132, NULL, NULL, 106971),
(106972, '3.40.50.720-FF-001635', NULL, 'Short-chain dehydrogenase, putative', 327, NULL, NULL, 106972),
(106973, '1.20.85.10-FF-000003', NULL, 'Photosystem II D2 protein, putative', 108, NULL, NULL, 106973),
(106974, '3.90.550.10-FF-000173', NULL, 'Cellulose synthase-like protein E1', 171, NULL, NULL, 106974),
(106975, '3.10.20.90-FF-000547', NULL, 'Histidine ammonia-lyase', 87, NULL, NULL, 106975),
(106976, '2.130.10.10-FF-005955', NULL, 'R-SNARE protein, tomsyn-like family', 247, NULL, NULL, 106976),
(106977, '3.40.50.1100-FF-000068', NULL, 'Catabolic L-serine/threonine dehydratase', 195, NULL, NULL, 106977),
(106978, '3.30.428.10-FF-000003', NULL, 'Purine nucleoside phosphoramidase', 119, NULL, NULL, 106978),
(106979, '3.30.200.20-FF-002063', NULL, 'Uncharacterized protein', 86, NULL, NULL, 106979),
(106980, '3.30.160.60-FF-000194', NULL, 'Fez family zinc finger protein 2', 26, NULL, NULL, 106980),
(106981, '2.30.30.40-FF-000517', NULL, 'zinc finger protein (ZZ-type)-2 isoform X1', 87, NULL, NULL, 106981),
(106982, '3.40.50.300-FF-008440', NULL, 'Predicted protein', 80, NULL, NULL, 106982),
(106983, '1.10.510.10-FF-002427', NULL, NULL, 155, NULL, NULL, 106983),
(106984, '3.40.630.30-FF-000578', NULL, 'Uncharacterized protein', 97, NULL, NULL, 106984),
(106985, '3.40.140.10-FF-000265', NULL, 'Activation-induced cytidine deaminase', 115, NULL, NULL, 106985),
(106986, '3.80.10.10-FF-003325', NULL, 'Uncharacterized protein', 103, NULL, NULL, 106986),
(106987, '3.30.70.330-FF-001468', NULL, 'U2 snRNP complex subunit', 118, NULL, NULL, 106987);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(106988, '1.25.40.10-FF-002660', NULL, 'Evolutionarily conserved signaling intermediate in Toll pathway, mitochondrial', 162, NULL, NULL, 106988),
(106989, '3.30.830.10-FF-000056', NULL, 'Falcilysin', 221, NULL, NULL, 106989),
(106990, '1.25.40.20-FF-000763', NULL, 'Uncharacterized protein', 63, NULL, NULL, 106990),
(106991, '2.40.70.10-FF-000073', NULL, 'Aspartic proteinase PCS1', 175, NULL, NULL, 106991),
(106992, '3.30.160.60-FF-004807', NULL, NULL, 25, NULL, NULL, 106992),
(106993, '2.40.340.10-FF-000003', NULL, 'Molybdopterin molybdenumtransferase', 71, NULL, NULL, 106993),
(106994, '1.20.1270.280-FF-000082', NULL, 'Dynein heavy chain, putative', 175, NULL, NULL, 106994),
(106995, '1.20.1250.20-FF-001299', NULL, 'Monocarboxylate transporter, putative', 195, NULL, NULL, 106995),
(106996, '2.30.180.10-FF-000066', NULL, 'Transforming growth factor-beta-induced protein', 140, NULL, NULL, 106996),
(106997, '1.25.40.70-FF-000059', NULL, 'Predicted protein', 178, NULL, NULL, 106997),
(106998, '1.10.510.10-FF-002118', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF a', 223, NULL, NULL, 106998),
(106999, '1.10.10.10-FF-000191', NULL, 'Transcription factor PU.1', 89, NULL, NULL, 106999),
(107000, '1.10.287.950-FF-000025', NULL, 'Methyl-accepting chemotaxis protein', 299, NULL, NULL, 107000),
(107001, '3.40.50.200-FF-000097', NULL, 'Uncharacterized protein', 297, NULL, NULL, 107001),
(107002, '1.10.10.60-FF-000301', NULL, 'Formate hydrogenlyase transcriptional activator', 60, NULL, NULL, 107002),
(107003, '1.10.287.940-FF-000022', NULL, 'Uncharacterized protein', 52, NULL, NULL, 107003),
(107004, '1.20.1070.10-FF-001653', NULL, 'Uncharacterized protein', 131, NULL, NULL, 107004),
(107005, '3.40.50.300-FF-001161', NULL, 'spermatogenesis-associated protein 5-like protein 1', 177, NULL, NULL, 107005),
(107006, '1.20.1250.20-FF-001962', NULL, 'Uncharacterized protein', 422, NULL, NULL, 107006),
(107007, '1.20.20.10-FF-000022', NULL, 'Uncharacterized protein', 63, NULL, NULL, 107007),
(107008, '3.30.590.10-FF-000003', NULL, 'Glutamine synthetase 2', 335, NULL, NULL, 107008),
(107009, '3.40.50.10470-FF-000062', NULL, 'Methylthioribose-1-phosphate isomerase', 160, NULL, NULL, 107009),
(107010, '3.10.20.90-FF-000856', NULL, 'Uncharacterized protein', 78, NULL, NULL, 107010),
(107011, '3.10.580.10-FF-000176', NULL, 'Cystathionine beta-synthase', 148, NULL, NULL, 107011),
(107012, '3.40.50.880-FF-000031', NULL, 'Multifunctional tryptophan biosynthesis protein', 192, NULL, NULL, 107012),
(107013, '3.40.50.1000-FF-000291', NULL, 'Hydrolase, haloacid dehalogenase-like family', 133, NULL, NULL, 107013),
(107014, '1.25.40.20-FF-001117', NULL, 'Uncharacterized protein', 213, NULL, NULL, 107014),
(107015, '1.20.120.140-FF-000005', NULL, 'Signal recognition particle 54 kDa protein', 106, NULL, NULL, 107015),
(107016, '2.70.150.10-FF-000252', NULL, 'Uncharacterized protein', 57, NULL, NULL, 107016),
(107017, '3.30.230.70-FF-000056', NULL, 'Exosome complex exonuclease, putative', 265, NULL, NULL, 107017),
(107018, '2.60.40.1170-FF-000023', NULL, 'AP-2 complex subunit mu', 112, NULL, NULL, 107018),
(107019, '2.130.10.10-FF-000519', NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', 146, NULL, NULL, 107019),
(107020, '2.30.30.40-FF-000046', NULL, 'Drebrin-like protein isoform B', 59, NULL, NULL, 107020),
(107021, '2.10.60.10-FF-000079', NULL, 'Serine/threonine-protein kinase receptor', 37, NULL, NULL, 107021),
(107022, '1.20.120.980-FF-000021', NULL, 'AGAP003642-PA', 139, NULL, NULL, 107022),
(107023, '1.10.10.2660-FF-000009', NULL, 'Ubiquitin-activating enzyme', 168, NULL, NULL, 107023),
(107024, '2.30.29.30-FF-000899', NULL, 'Non-specific serine/threonine protein kinase', 103, NULL, NULL, 107024),
(107025, '4.10.180.10-FF-000001', NULL, 'Rhs element Vgr protein', 16, NULL, NULL, 107025),
(107026, '3.30.460.80-FF-000014', NULL, 'Uncharacterized protein', 44, NULL, NULL, 107026),
(107027, '3.40.50.1240-FF-000014', NULL, 'Multiple inositol polyphosphate phosphatase 1', 410, NULL, NULL, 107027);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(107028, '3.30.590.20-FF-000006', NULL, 'Glutamate--cysteine ligase EgtA', 412, NULL, NULL, 107028),
(107029, '1.20.1070.10-FF-001344', NULL, 'Uncharacterized protein', 271, NULL, NULL, 107029),
(107030, '2.40.10.10-FF-000187', NULL, 'Uncharacterized protein, isoform A', 104, NULL, NULL, 107030),
(107031, '2.130.10.10-FF-004319', NULL, 'Predicted protein', 108, NULL, NULL, 107031),
(107032, '2.170.130.10-FF-000035', NULL, 'Vitamin B12 receptor', 135, NULL, NULL, 107032),
(107033, '2.130.10.10-FF-002419', NULL, 'WD repeat-containing protein 16, putative', 84, NULL, NULL, 107033),
(107034, '3.30.160.60-FF-002655', NULL, 'Uncharacterized protein, isoform D', 57, NULL, NULL, 107034),
(107035, '3.30.160.60-FF-000755', NULL, 'zinc finger protein 174', 28, NULL, NULL, 107035),
(107036, '1.10.10.1100-FF-000019', NULL, 'Nitrogen fixation protein NifU', 52, NULL, NULL, 107036),
(107037, '3.40.50.1820-FF-001374', NULL, 'Uncharacterized protein', 223, NULL, NULL, 107037),
(107038, '1.20.120.1200-FF-000015', NULL, 'NADH-ubiquinone oxidoreductase chain 6', 169, NULL, NULL, 107038),
(107039, '2.30.30.30-FF-000043', NULL, 'Transcription elongation factor SPT5', 66, NULL, NULL, 107039),
(107040, '3.90.226.10-FF-000245', NULL, 'Enoyl-CoA hydratase/isomerase family protein', 214, NULL, NULL, 107040),
(107041, '1.10.510.10-FF-004018', NULL, NULL, 123, NULL, NULL, 107041),
(107042, '1.25.40.10-FF-001946', NULL, 'Os02g0730900 protein', 49, NULL, NULL, 107042),
(107043, '1.20.1250.20-FF-001092', NULL, 'Solute carrier family 37 member 4b', 140, NULL, NULL, 107043),
(107044, '2.10.25.10-FF-001335', NULL, 'Notch receptor 3', 44, NULL, NULL, 107044),
(107045, '3.40.50.10810-FF-000164', NULL, 'Uncharacterized protein', 293, NULL, NULL, 107045),
(107046, '3.30.200.20-FF-001866', NULL, 'P21 protein (Cdc42/Rac)-activated kinase 2b', 65, NULL, NULL, 107046),
(107047, '3.40.532.10-FF-000035', NULL, NULL, 100, NULL, NULL, 107047),
(107048, '1.10.10.60-FF-000256', NULL, 'Even-skipped homeobox 1', 102, NULL, NULL, 107048),
(107049, '3.40.630.30-FF-000680', NULL, 'N-acetyltransferase, putative', 133, NULL, NULL, 107049),
(107050, '3.40.630.10-FF-000123', NULL, 'Vacuolar carboxypeptidase Cps1, putative', 204, NULL, NULL, 107050),
(107051, '2.60.40.10-FF-004903', NULL, NULL, 103, NULL, NULL, 107051),
(107052, '1.10.533.10-FF-000243', NULL, 'Uncharacterized protein', 69, NULL, NULL, 107052),
(107053, '3.40.50.1820-FF-000401', NULL, 'Carboxypeptidase', 457, NULL, NULL, 107053),
(107054, '2.60.34.10-FF-000022', NULL, 'Heat shock 70 kDa protein', 147, NULL, NULL, 107054),
(107055, '3.30.60.30-FF-000065', NULL, 'SPINK9 isoform 2', 67, NULL, NULL, 107055),
(107056, '3.30.60.20-FF-000062', NULL, 'Thymidine kinase', 46, NULL, NULL, 107056),
(107057, '1.20.1300.10-FF-000025', NULL, 'Succinate dehydrogenase cytochrome B-556 subunit', 125, NULL, NULL, 107057),
(107058, '2.20.70.10-FF-000152', NULL, 'Pre-mRNA-processing factor 40 homolog A', 38, NULL, NULL, 107058),
(107059, '3.40.50.300-FF-008131', NULL, 'Uncharacterized protein', 104, NULL, NULL, 107059),
(107060, '2.160.10.10-FF-000024', NULL, 'GDP-mannose pyrophosphorylase', 117, NULL, NULL, 107060),
(107061, '3.40.50.1820-FF-001683', NULL, 'Predicted protein', 224, NULL, NULL, 107061),
(107062, '1.10.287.110-FF-000329', NULL, 'Chaperone protein DNAj, putative', 87, NULL, NULL, 107062),
(107063, '3.40.1700.10-FF-000004', NULL, 'Diadenylate cyclase', 160, NULL, NULL, 107063),
(107064, '3.90.550.10-FF-000482', NULL, 'Glycoside transferase family 2', 197, NULL, NULL, 107064),
(107065, '3.20.20.300-FF-000041', NULL, 'Putative lipoprotein YbbD', 346, NULL, NULL, 107065),
(107066, '1.20.5.130-FF-000003', NULL, 'Bacteriocin curvaticin', 30, NULL, NULL, 107066),
(107067, '1.10.472.80-FF-000279', NULL, NULL, 141, NULL, NULL, 107067),
(107068, '1.10.1600.10-FF-000022', NULL, 'ATP-dependent DNA helicase II subunit 1', 95, NULL, NULL, 107068),
(107069, '2.20.25.10-FF-000059', NULL, 'DNA-directed RNA polymerase subunit', 55, NULL, NULL, 107069),
(107070, '1.10.20.10-FF-000129', NULL, 'Transcription factor TFIID complex subunit Taf13', 42, NULL, NULL, 107070);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(107071, '3.40.720.10-FF-000259', NULL, 'Uncharacterized protein', 52, NULL, NULL, 107071),
(107072, '3.30.70.960-FF-000010', NULL, 'Transmembrane protease serine', 111, NULL, NULL, 107072),
(107073, '3.30.160.600-FF-000001', NULL, 'DNA double-strand break repair protein Mre11', 58, NULL, NULL, 107073),
(107074, '3.40.50.170-FF-000014', NULL, 'Phosphoribosylglycinamide formyltransferase', 188, NULL, NULL, 107074),
(107075, '3.40.50.2000-FF-000225', NULL, 'Glycosyltransferase', 255, NULL, NULL, 107075),
(107076, '3.30.70.980-FF-000016', NULL, 'Probable transcriptional regulatory protein HP_0162', 75, NULL, NULL, 107076),
(107077, '3.30.1390.10-FF-000004', NULL, 'ATP-dependent Clp protease adapter protein ClpS', 94, NULL, NULL, 107077),
(107078, '1.25.70.10-FF-000037', NULL, 'Transcription termination factor MTEF1, chloroplastic', 240, NULL, NULL, 107078),
(107079, '1.10.238.10-FF-000720', NULL, 'Calmodulin-like protein 30', 111, NULL, NULL, 107079),
(107080, '3.40.50.11340-FF-000008', NULL, 'Galactoside 2-alpha-L-fucosyltransferase', 46, NULL, NULL, 107080),
(107081, '1.20.5.340-FF-000083', NULL, 'Chloroplast Rat1', 97, NULL, NULL, 107081),
(107082, '2.60.40.150-FF-000096', NULL, 'E3 ubiquitin-protein ligase Nedd-4', 173, NULL, NULL, 107082),
(107083, '1.20.1250.20-FF-001653', NULL, 'DHA2 family efflux MFS transporter permease subunit', 190, NULL, NULL, 107083),
(107084, '1.10.730.10-FF-000190', NULL, 'Uncharacterized protein', 86, NULL, NULL, 107084),
(107085, '2.60.120.650-FF-000125', NULL, 'AGAP004022-PA', 227, NULL, NULL, 107085),
(107086, '3.20.20.220-FF-000051', NULL, 'Proline dehydrogenase', 125, NULL, NULL, 107086),
(107087, '2.60.120.10-FF-000595', NULL, 'Uncharacterized protein', 233, NULL, NULL, 107087),
(107088, '3.40.50.300-FF-008086', NULL, 'Uncharacterized protein', 114, NULL, NULL, 107088),
(107089, '3.40.640.10-FF-000303', NULL, 'Si:ch211-180m24.3', 84, NULL, NULL, 107089),
(107090, '2.60.40.790-FF-000175', NULL, NULL, 126, NULL, NULL, 107090),
(107091, '3.30.200.20-FF-001557', NULL, 'Uncharacterized protein', 137, NULL, NULL, 107091),
(107092, '1.10.2020.20-FF-000014', NULL, NULL, 119, NULL, NULL, 107092),
(107093, '3.40.30.10-FF-000383', NULL, 'Thioredoxin, putative', 89, NULL, NULL, 107093),
(107094, '3.30.40.10-FF-000260', NULL, 'RING finger protein 24', 77, NULL, NULL, 107094),
(107095, '2.60.40.2560-FF-000001', NULL, 'Serine/threonine protein kinase', 78, NULL, NULL, 107095),
(107096, '2.130.10.10-FF-004561', NULL, 'Uncharacterized protein', 215, NULL, NULL, 107096),
(107097, '1.10.1130.10-FF-000014', NULL, 'Nitrite reductase (cytochrome; ammonia-forming)', 82, NULL, NULL, 107097),
(107098, '1.10.287.3510-FF-000002', NULL, 'NADH-ubiquinone oxidoreductase chain 4L', 98, NULL, NULL, 107098),
(107099, '3.40.50.300-FF-006186', NULL, 'Uncharacterized GTP-binding protein P8A3.05', 89, NULL, NULL, 107099),
(107100, '1.25.40.10-FF-004251', NULL, 'Uncharacterized protein', 233, NULL, NULL, 107100),
(107101, '1.25.40.240-FF-000004', NULL, 'KU80 protein, putative', 152, NULL, NULL, 107101),
(107102, '2.60.40.10-FF-004813', NULL, NULL, 87, NULL, NULL, 107102),
(107103, '2.60.120.200-FF-000013', NULL, 'Slit guidance ligand 2', 171, NULL, NULL, 107103),
(107104, '3.40.309.10-FF-000011', NULL, 'Delta-1-pyrroline-5-carboxylate synthase', 149, NULL, NULL, 107104),
(107105, '1.20.200.10-FF-000035', NULL, 'Uncharacterized protein', 144, NULL, NULL, 107105),
(107106, '1.10.540.10-FF-000046', NULL, 'Acyl-CoA dehydrogenase FadE17', 122, NULL, NULL, 107106),
(107107, '1.10.30.10-FF-000057', NULL, 'Protein maelstrom 2', 95, NULL, NULL, 107107),
(107108, '1.10.287.70-FF-000688', NULL, 'Predicted protein', 79, NULL, NULL, 107108),
(107109, '2.170.270.10-FF-000219', NULL, 'Uncharacterized protein', 114, NULL, NULL, 107109),
(107110, '1.10.8.1290-FF-000008', NULL, NULL, 91, NULL, NULL, 107110),
(107111, '3.30.530.20-FF-000132', NULL, 'F-box/WD repeat-containing protein A-like protein', 212, NULL, NULL, 107111),
(107112, '3.30.497.10-FF-000123', NULL, 'Uncharacterized protein', 195, NULL, NULL, 107112);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(107113, '3.40.50.11320-FF-000002', NULL, 'Carboxypeptidase', 95, NULL, NULL, 107113),
(107114, '3.40.1690.10-FF-000019', NULL, 'Flagellar biosynthesis protein FlhB', 83, NULL, NULL, 107114),
(107115, '3.40.800.20-FF-000049', NULL, 'Chromosome 16, whole genome shotgun sequence', 399, NULL, NULL, 107115),
(107116, '3.30.70.330-FF-000024', NULL, 'Heterogeneous nuclear ribonucleoprotein q isoform', 143, NULL, NULL, 107116),
(107117, '3.40.640.10-FF-000051', NULL, '1-aminocyclopropane-1-carboxylate synthase 3', 256, NULL, NULL, 107117),
(107118, '2.60.40.10-FF-005786', NULL, NULL, 90, NULL, NULL, 107118),
(107119, '2.60.40.10-FF-000851', NULL, 'interleukin-13 receptor subunit alpha-1 isoform X2', 117, NULL, NULL, 107119),
(107120, '1.25.40.250-FF-000007', NULL, 'COP9 signalosome, subunit CSN8, putative', 95, NULL, NULL, 107120),
(107121, '3.40.800.10-FF-000046', NULL, NULL, 241, NULL, NULL, 107121),
(107122, '2.130.10.10-FF-004870', NULL, 'Uncharacterized protein', 121, NULL, NULL, 107122),
(107123, '1.20.5.2440-FF-000014', NULL, 'Rab11 family-interacting protein 3', 61, NULL, NULL, 107123),
(107124, '3.40.30.10-FF-000692', NULL, 'Uncharacterized protein', 122, NULL, NULL, 107124),
(107125, '3.10.290.10-FF-000075', NULL, 'Pseudouridine synthase', 69, NULL, NULL, 107125),
(107126, '3.30.1390.20-FF-000007', NULL, '50S ribosomal protein L30', 82, NULL, NULL, 107126),
(107127, '3.10.330.70-FF-000001', NULL, 'Putative lysine-specific demethylase 4a', 54, NULL, NULL, 107127),
(107128, '2.40.30.130-FF-000036', NULL, 'Alanine--tRNA ligase', 107, NULL, NULL, 107128),
(107129, '2.60.40.10-FF-000542', NULL, 'Interleukin-6 receptor subunit beta', 88, NULL, NULL, 107129),
(107130, '1.20.1250.20-FF-000107', NULL, 'Solute carrier organic anion transporter family member', 355, NULL, NULL, 107130),
(107131, '2.40.160.10-FF-000012', NULL, 'Voltage-dependent anion-selective channel', 280, NULL, NULL, 107131),
(107132, '2.60.40.150-FF-000539', NULL, 'E3 ubiquitin-protein ligase HECW1', 139, NULL, NULL, 107132),
(107133, '2.40.20.10-FF-000019', NULL, 'Muscle, skeletal receptor tyrosine protein kinase', 98, NULL, NULL, 107133),
(107134, '3.30.1510.10-FF-000003', NULL, 'Formate--tetrahydrofolate ligase', 100, NULL, NULL, 107134),
(107135, '3.10.20.90-FF-000194', NULL, 'U11/U12 small nuclear ribonucleoprotein 25 kDa protein', 98, NULL, NULL, 107135),
(107136, '1.10.510.10-FF-000544', NULL, 'Non-specific serine/threonine protein kinase', 325, NULL, NULL, 107136),
(107137, '3.90.550.10-FF-000156', NULL, 'Cellulose synthase', 177, NULL, NULL, 107137),
(107138, '3.40.30.10-FF-000574', NULL, 'Thioredoxin related transmembrane protein 3', 93, NULL, NULL, 107138),
(107139, '3.30.497.10-FF-000005', NULL, 'serpin I2 isoform X1', 189, NULL, NULL, 107139),
(107140, '1.20.1070.10-FF-001434', NULL, 'Vomeronasal type-1 receptor', 224, NULL, NULL, 107140),
(107141, '3.30.70.330-FF-002047', NULL, NULL, 149, NULL, NULL, 107141),
(107142, '3.40.50.300-FF-001998', NULL, 'ABC transporter family protein', 265, NULL, NULL, 107142),
(107143, '1.10.1240.40-FF-000003', NULL, 'Protein EMSY-LIKE 3 isoform A', 128, NULL, NULL, 107143),
(107144, '2.40.10.10-FF-000524', NULL, NULL, 145, NULL, NULL, 107144),
(107145, '1.10.1450.10-FF-000167', NULL, 'Uncharacterized protein', 58, NULL, NULL, 107145),
(107146, '3.40.140.10-FF-000248', NULL, 'Uncharacterized protein', 147, NULL, NULL, 107146),
(107147, '1.20.1310.10-FF-000205', NULL, NULL, 96, NULL, NULL, 107147),
(107148, '2.60.40.10-FF-000109', NULL, 'obscurin isoform X5', 88, NULL, NULL, 107148),
(107149, '3.80.20.20-FF-000080', NULL, 'Predicted protein', 129, NULL, NULL, 107149),
(107150, '3.40.50.300-FF-002471', NULL, 'Rab family GTPase', 182, NULL, NULL, 107150),
(107151, '2.20.70.10-FF-000017', NULL, 'E3 ubiquitin-protein ligase', 41, NULL, NULL, 107151),
(107152, '3.40.50.720-FF-001079', NULL, 'Acylglycerone-phosphate reductase', 260, NULL, NULL, 107152),
(107153, '1.10.8.720-FF-000008', NULL, 'Dynein axonemal heavy chain 2', 165, NULL, NULL, 107153),
(107154, '2.60.40.60-FF-001113', NULL, 'Uncharacterized protein', 50, NULL, NULL, 107154);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(107155, '1.10.10.60-FF-000172', NULL, 'Homeobox and leucine zipper protein Homez', 72, NULL, NULL, 107155),
(107156, '3.20.20.70-FF-000569', NULL, 'Delta-aminolevulinic acid dehydratase', 322, NULL, NULL, 107156),
(107157, '3.50.50.60-FF-000241', NULL, 'Pyridine nucleotide-disulfide oxidoreductase', 124, NULL, NULL, 107157),
(107158, '3.30.160.60-FF-004246', NULL, NULL, 27, NULL, NULL, 107158),
(107159, '3.40.50.620-FF-000312', NULL, 'YdcF family protein', 134, NULL, NULL, 107159),
(107160, '3.30.70.330-FF-003149', NULL, NULL, 137, NULL, NULL, 107160),
(107161, '2.120.10.30-FF-000240', NULL, 'Uncharacterized protein', 42, NULL, NULL, 107161),
(107162, '3.30.460.20-FF-000002', NULL, 'Cora family metal ion transporter', 153, NULL, NULL, 107162),
(107163, '1.25.40.1010-FF-000007', NULL, 'NMDA receptor-regulated protein, putative', 74, NULL, NULL, 107163),
(107164, '3.40.50.1100-FF-000287', NULL, 'Uncharacterized protein', 11, NULL, NULL, 107164),
(107165, '3.40.309.10-FF-000101', NULL, 'NAD(P)-dependent benzaldehyde dehydrogenase', 194, NULL, NULL, 107165),
(107166, '3.40.50.1000-FF-000717', NULL, NULL, 95, NULL, NULL, 107166),
(107167, '3.10.100.10-FF-000168', NULL, 'Phospholipase A2 receptor 1', 136, NULL, NULL, 107167),
(107168, '1.10.8.710-FF-000005', NULL, 'Cytoplasmic dynein heavy chain 1', 129, NULL, NULL, 107168),
(107169, '1.10.10.60-FF-000711', NULL, 'Homeobox protein HAT3.1', 70, NULL, NULL, 107169),
(107170, '3.30.450.150-FF-000005', NULL, 'UPF0303 protein Ping_1243', 184, NULL, NULL, 107170),
(107171, '4.10.640.10-FF-000020', NULL, '37S ribosomal protein RSM18, mitochondrial', 56, NULL, NULL, 107171),
(107172, '2.70.130.10-FF-000144', NULL, NULL, 144, NULL, NULL, 107172),
(107173, '2.30.30.40-FF-000147', NULL, 'Cas scaffold protein family member 4', 65, NULL, NULL, 107173),
(107174, '1.25.40.10-FF-003970', NULL, 'Uncharacterized protein', 231, NULL, NULL, 107174),
(107175, '1.20.272.10-FF-000055', NULL, NULL, 86, NULL, NULL, 107175),
(107176, '2.70.150.10-FF-000151', NULL, 'Heavy metal translocating P-type ATPase', 91, NULL, NULL, 107176),
(107177, '3.90.550.10-FF-000633', NULL, 'Uncharacterized protein', 184, NULL, NULL, 107177),
(107178, '1.20.1310.20-FF-000057', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 198, NULL, NULL, 107178),
(107179, '2.60.210.10-FF-000040', NULL, 'Predicted protein', 203, NULL, NULL, 107179),
(107180, '3.40.630.10-FF-000230', NULL, 'Uncharacterized protein', 135, NULL, NULL, 107180),
(107181, '1.20.1310.10-FF-000054', NULL, 'Cullin-4', 116, NULL, NULL, 107181),
(107182, '1.10.1370.30-FF-000026', NULL, 'Angiotensin-converting enzyme', 432, NULL, NULL, 107182),
(107183, '3.90.550.10-FF-000263', NULL, 'Probable glycosyl transferase', 254, NULL, NULL, 107183),
(107184, '3.40.50.300-FF-006416', NULL, 'Predicted protein', 130, NULL, NULL, 107184),
(107185, '3.40.50.300-FF-008350', NULL, 'ABC transporter', 265, NULL, NULL, 107185),
(107186, '1.10.730.10-FF-000072', NULL, 'Leucyl-tRNA synthetase', 195, NULL, NULL, 107186),
(107187, '2.60.40.10-FF-006039', NULL, NULL, 87, NULL, NULL, 107187),
(107188, '3.30.505.10-FF-000059', NULL, 'hematopoietic SH2 domain-containing protein', 95, NULL, NULL, 107188),
(107189, '1.10.1410.10-FF-000058', NULL, 'Uncharacterized protein', 186, NULL, NULL, 107189),
(107190, '3.30.565.10-FF-000361', NULL, 'PMS (Post Meiotic Segregation) family', 221, NULL, NULL, 107190),
(107191, '2.60.120.10-FF-000387', NULL, 'cGMP-dependent protein kinase', 124, NULL, NULL, 107191),
(107192, '3.90.470.20-FF-000012', NULL, 'Enterobactin synthase component D', 99, NULL, NULL, 107192),
(107193, '3.30.160.60-FF-000980', NULL, 'Zinc finger protein, FOG family member 1', 30, NULL, NULL, 107193),
(107194, '3.40.50.300-FF-000907', NULL, 'Rho related BTB domain containing 3', 176, NULL, NULL, 107194),
(107195, '3.40.109.10-FF-000029', NULL, 'Molybdopterin biosynthesis protein MoeY', 245, NULL, NULL, 107195),
(107196, '3.30.40.10-FF-001362', NULL, 'Uncharacterized protein', 93, NULL, NULL, 107196),
(107197, '3.40.50.300-FF-005112', NULL, 'Uncharacterized protein', 332, NULL, NULL, 107197);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(107198, '3.40.640.10-FF-000511', NULL, 'Uncharacterized protein', 52, NULL, NULL, 107198),
(107199, '3.60.21.10-FF-000198', NULL, 'Serine/threonine-protein phosphatase 2B catalytic subunit alpha isoform', 260, NULL, NULL, 107199),
(107200, '3.40.50.1780-FF-000018', NULL, 'Iron-containing hydrogenase, putative', 157, NULL, NULL, 107200),
(107201, '2.130.10.10-FF-006017', NULL, 'Probable U3 small nucleolar RNA-associated protein 13', 166, NULL, NULL, 107201),
(107202, '1.25.40.10-FF-001929', NULL, 'Cyc8p', 79, NULL, NULL, 107202),
(107203, '1.10.10.10-FF-000308', NULL, 'DEP domain-containing mTOR-interacting protein isoform X1', 101, NULL, NULL, 107203),
(107204, '2.70.98.110-FF-000001', NULL, 'Mannosyl-oligosaccharide glucosidase', 284, NULL, NULL, 107204),
(107205, '3.40.50.300-FF-006096', NULL, 'Uncharacterized protein', 79, NULL, NULL, 107205),
(107206, '1.10.510.10-FF-000870', NULL, 'OSJNBa0016N04.16-like protein', 250, NULL, NULL, 107206),
(107207, '2.60.40.10-FF-000216', NULL, 'neogenin isoform X1', 84, NULL, NULL, 107207),
(107208, '2.30.30.40-FF-000624', NULL, 'Uncharacterized protein', 32, NULL, NULL, 107208),
(107209, '3.30.30.170-FF-000007', NULL, NULL, 58, NULL, NULL, 107209),
(107210, '3.90.1150.10-FF-000012', NULL, 'Glutamate-1-semialdehyde 2,1-aminomutase', 164, NULL, NULL, 107210),
(107211, '3.40.50.300-FF-004488', NULL, 'ATP-dependent DEAD/H RNA helicase, putative', 258, NULL, NULL, 107211),
(107212, '3.40.50.1820-FF-001609', NULL, 'Os01g0315700 protein', 71, NULL, NULL, 107212),
(107213, '1.20.58.390-FF-000272', NULL, 'Uncharacterized protein', 72, NULL, NULL, 107213),
(107214, '2.60.40.790-FF-000052', NULL, 'ArsA family ATPase', 71, NULL, NULL, 107214),
(107215, '1.10.238.10-FF-000618', NULL, 'EF-hand calcium-binding domain-containing protein 6-like', 80, NULL, NULL, 107215),
(107216, '3.40.640.10-FF-000202', NULL, 'Probable aminotransferase', 223, NULL, NULL, 107216),
(107217, '2.30.42.10-FF-000036', NULL, 'Erbin isoform 7', 102, NULL, NULL, 107217),
(107218, '3.50.30.30-FF-000175', NULL, 'Uncharacterized protein', 93, NULL, NULL, 107218),
(107219, '2.130.10.10-FF-003746', NULL, 'Uncharacterized protein', 330, NULL, NULL, 107219),
(107220, '1.10.150.240-FF-000133', NULL, 'Glycosyl hydrolase, putative', 94, NULL, NULL, 107220),
(107221, '1.10.510.10-FF-000218', NULL, 'Death-associated protein kinase 1', 178, NULL, NULL, 107221),
(107222, '3.40.50.300-FF-006523', NULL, 'Predicted protein', 111, NULL, NULL, 107222),
(107223, '1.10.1520.10-FF-000089', NULL, 'Endoribonuclease Dicer-like protein 3', 161, NULL, NULL, 107223),
(107224, '1.10.10.10-FF-002091', NULL, 'Uncharacterized protein', 66, NULL, NULL, 107224),
(107225, '2.60.40.10-FF-000744', NULL, 'Leucine rich repeat, Ig-like and transmembrane domains 1', 97, NULL, NULL, 107225),
(107226, '1.10.533.10-FF-000108', NULL, 'THO complex 1', 98, NULL, NULL, 107226),
(107227, '3.30.1370.10-FF-000014', NULL, 'KRR1 small subunit processome component', 87, NULL, NULL, 107227),
(107228, '3.30.70.370-FF-000030', NULL, NULL, 85, NULL, NULL, 107228),
(107229, '2.130.10.10-FF-000183', NULL, 'Katanin p80 WD40 repeat-containing subunit B1', 197, NULL, NULL, 107229),
(107230, '3.40.50.300-FF-000582', NULL, 'Midasin', 177, NULL, NULL, 107230),
(107231, '3.30.470.160-FF-000006', NULL, 'Kinase', 258, NULL, NULL, 107231),
(107232, '3.40.50.10860-FF-000072', NULL, 'Methylenetetrahydrofolate dehydrogenase (NADP+-dependent) 1b', 69, NULL, NULL, 107232),
(107233, '1.20.1070.10-FF-001760', NULL, 'Zg13', 73, NULL, NULL, 107233),
(107234, '2.10.25.10-FF-001088', NULL, 'Si:ch211-241f5.3', 51, NULL, NULL, 107234),
(107235, '2.60.200.20-FF-000071', NULL, 'AGAP004588-PA', 149, NULL, NULL, 107235),
(107236, '3.40.50.12440-FF-000006', NULL, 'Nitrate reductase alpha subunit (NarG)', 484, NULL, NULL, 107236),
(107237, '2.40.50.140-FF-000037', NULL, '26S protease regulatory subunit 7', 125, NULL, NULL, 107237),
(107238, '3.90.1410.10-FF-000038', NULL, 'Uncharacterized protein', 244, NULL, NULL, 107238),
(107239, '3.40.50.2000-FF-000118', NULL, 'UDP-glucuronosyltransferase', 171, NULL, NULL, 107239);
INSERT INTO "PUBLIC"."MODEL" VALUES
(107240, '1.25.40.10-FF-003863', NULL, 'Uncharacterized protein', 105, NULL, NULL, 107240),
(107241, '3.30.160.60-FF-004027', NULL, NULL, 60, NULL, NULL, 107241),
(107242, '2.130.10.10-FF-000413', NULL, 'elongator complex protein 2 isoform X4', 192, NULL, NULL, 107242),
(107243, '3.20.20.70-FF-000676', NULL, NULL, 205, NULL, NULL, 107243),
(107244, '3.30.60.20-FF-000163', NULL, 'Serine/threonine protein kinase BRAF', 30, NULL, NULL, 107244),
(107245, '1.20.140.100-FF-000008', NULL, 'Dynein heavy chain domain 1', 148, NULL, NULL, 107245),
(107246, '3.40.50.720-FF-001770', NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', 119, NULL, NULL, 107246),
(107247, '1.20.58.60-FF-000062', NULL, 'Short stop, isoform K', 109, NULL, NULL, 107247),
(107248, '1.25.40.10-FF-004352', NULL, 'Peptidylprolyl isomerase', 68, NULL, NULL, 107248),
(107249, '3.90.260.10-FF-000072', NULL, 'Uncharacterized protein', 141, NULL, NULL, 107249),
(107250, '3.40.140.10-FF-000029', NULL, 'DNA dC->dU-editing enzyme APOBEC-3G', 183, NULL, NULL, 107250),
(107251, '1.10.760.10-FF-000113', NULL, 'Methylamine utilization protein MauG, putative', 180, NULL, NULL, 107251),
(107252, '3.40.630.60-FF-000014', NULL, NULL, 94, NULL, NULL, 107252),
(107253, '2.30.110.10-FF-000039', NULL, 'Deazaflavin-dependent nitroreductase', 118, NULL, NULL, 107253),
(107254, '3.30.60.30-FF-000166', NULL, 'LOC557557 protein', 72, NULL, NULL, 107254),
(107255, '1.10.3720.10-FF-000054', NULL, 'Molybdenum transport system permease', 214, NULL, NULL, 107255),
(107256, '2.40.70.10-FF-000426', NULL, NULL, 231, NULL, NULL, 107256),
(107257, '3.40.50.720-FF-000140', NULL, '3-oxoacyl-[acyl-carrier-protein] reductase', 245, NULL, NULL, 107257),
(107258, '3.30.420.40-FF-000225', NULL, 'Phosphotransferase', 11, NULL, NULL, 107258),
(107259, '3.10.290.10-FF-000058', NULL, 'Pseudouridine synthase', 56, NULL, NULL, 107259),
(107260, '3.80.10.10-FF-001425', NULL, 'Protein windpipe', 195, NULL, NULL, 107260),
(107261, '3.40.1230.10-FF-000013', NULL, 'Uncharacterized protein', 115, NULL, NULL, 107261),
(107262, '1.20.58.80-FF-000068', NULL, 'Uncharacterized protein', 76, NULL, NULL, 107262),
(107263, '3.40.50.1240-FF-000194', NULL, NULL, 370, NULL, NULL, 107263),
(107264, '1.10.510.10-FF-000746', NULL, 'Non-specific serine/threonine protein kinase', 200, NULL, NULL, 107264),
(107265, '2.30.30.30-FF-000144', NULL, '60S ribosomal protein L26-1', 63, NULL, NULL, 107265),
(107266, '4.10.60.10-FF-000147', NULL, 'Rts protein', 28, NULL, NULL, 107266),
(107267, '1.10.10.60-FF-000391', NULL, 'Homeobox transcription factor', 69, NULL, NULL, 107267),
(107268, '3.40.30.10-FF-000467', NULL, '2-hydroxychromene-2-carboxylate isomerase', 195, NULL, NULL, 107268),
(107269, '2.130.10.10-FF-000722', NULL, 'TBC1 domain family member 31', 183, NULL, NULL, 107269),
(107270, '2.40.300.10-FF-000001', NULL, 'Head decoration protein D', 92, NULL, NULL, 107270),
(107271, '2.40.30.10-FF-000087', NULL, 'Hybrid-cluster NAD(P)-dependent oxidoreductase', 103, NULL, NULL, 107271),
(107272, '1.10.238.10-FF-000265', NULL, 'calcium-binding protein 4', 102, NULL, NULL, 107272),
(107273, '3.30.160.60-FF-000654', NULL, 'PR/SET domain 6', 27, NULL, NULL, 107273),
(107274, '1.20.58.70-FF-000065', NULL, 'Syntaxin 1A', 57, NULL, NULL, 107274),
(107275, '1.10.533.10-FF-000097', NULL, 'Death effector domain-containing 1', 73, NULL, NULL, 107275),
(107276, '3.40.50.300-FF-006214', NULL, 'GTP-binding protein 2', 138, NULL, NULL, 107276),
(107277, '3.40.50.300-FF-002364', NULL, 'DNA repair protein RadA', 214, NULL, NULL, 107277),
(107278, '1.10.10.10-FF-001938', NULL, 'CG3509 protein', 87, NULL, NULL, 107278),
(107279, '1.20.1050.10-FF-000123', NULL, 'Uncharacterized protein', 110, NULL, NULL, 107279),
(107280, '1.10.510.10-FF-000067', NULL, 'calcium-dependent protein kinase 13', 181, NULL, NULL, 107280),
(107281, '3.30.70.1170-FF-000018', NULL, 'RNA Methyltransferase', 113, NULL, NULL, 107281),
(107282, '2.120.10.80-FF-000136', NULL, 'Kelch domain containing 3', 118, NULL, NULL, 107282),
(107283, '1.10.510.10-FF-000437', NULL, 'Pseudopodium enriched atypical kinase 1', 192, NULL, NULL, 107283); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(107284, '3.40.50.1000-FF-000408', NULL, 'Trehalose-6-phosphate synthase', 119, NULL, NULL, 107284),
(107285, '3.30.200.20-FF-000371', NULL, 'Protein NSP-INTERACTING KINASE 2', 108, NULL, NULL, 107285),
(107286, '1.10.150.20-FF-000311', NULL, 'Uncharacterized protein', 48, NULL, NULL, 107286),
(107287, '3.40.190.120-FF-000001', NULL, 'Amine ABC transporter substrate-binding protein', 114, NULL, NULL, 107287),
(107288, '1.10.530.10-FF-000074', NULL, 'Uncharacterized protein', 43, NULL, NULL, 107288),
(107289, '2.40.100.10-FF-000036', NULL, 'Peptidyl-prolyl cis-trans isomerase', 172, NULL, NULL, 107289),
(107290, '2.130.10.120-FF-000024', NULL, 'Oligopeptidase B PtrB', 334, NULL, NULL, 107290),
(107291, '2.130.10.10-FF-003965', NULL, 'Autophagy-related protein 21', 238, NULL, NULL, 107291),
(107292, '3.40.50.300-FF-004269', NULL, 'Uncharacterized protein', 331, NULL, NULL, 107292),
(107293, '1.20.120.980-FF-000004', NULL, 'Thymus-specific serine protease', 152, NULL, NULL, 107293),
(107294, '1.10.287.690-FF-000014', NULL, 'DNA polymerase', 52, NULL, NULL, 107294),
(107295, '2.60.40.200-FF-000038', NULL, 'Probable copper chaperone for superoxide dismutase', 181, NULL, NULL, 107295),
(107296, '1.10.418.10-FF-000032', NULL, 'utrophin isoform X1', 124, NULL, NULL, 107296),
(107297, '3.90.79.10-FF-000043', NULL, '7,8-dihydro-8-oxoguanine triphosphatase', 156, NULL, NULL, 107297),
(107298, '2.60.120.1440-FF-000014', NULL, 'Fec operon regulator FecR', 126, NULL, NULL, 107298),
(107299, '2.130.10.110-FF-000021', NULL, 'Uncharacterized protein', 236, NULL, NULL, 107299),
(107300, '1.10.10.60-FF-000402', NULL, 'Transcription factor MYB113', 72, NULL, NULL, 107300),
(107301, '3.30.200.20-FF-001782', NULL, 'Disease resistance protein Cf-2.1-like', 42, NULL, NULL, 107301),
(107302, '2.40.70.10-FF-000207', NULL, 'Acid protease', 176, NULL, NULL, 107302),
(107303, '3.90.740.10-FF-000007', NULL, 'Valine--tRNA ligase, mitochondrial', 40, NULL, NULL, 107303),
(107304, '3.30.160.60-FF-001020', NULL, 'Uncharacterized protein', 29, NULL, NULL, 107304),
(107305, '1.10.287.1770-FF-000002', NULL, 'Ferrous iron transport protein B', 67, NULL, NULL, 107305),
(107306, '2.130.10.10-FF-004454', NULL, 'Sterol regulatory element-binding protein cleavage-activating protein', 346, NULL, NULL, 107306),
(107307, '3.90.226.10-FF-000144', NULL, 'GH11143p', 202, NULL, NULL, 107307),
(107308, '1.10.510.10-FF-004119', NULL, NULL, 104, NULL, NULL, 107308),
(107309, '3.10.129.10-FF-000251', NULL, 'Uncharacterized protein', 120, NULL, NULL, 107309),
(107310, '3.40.50.2300-FF-001653', NULL, NULL, 202, NULL, NULL, 107310),
(107311, '3.40.50.1980-FF-000106', NULL, 'Iron(III) ABC transporter, solute-binding protein', 138, NULL, NULL, 107311),
(107312, '2.60.120.330-FF-000159', NULL, 'Uncharacterized protein', 337, NULL, NULL, 107312),
(107313, '1.10.510.10-FF-001848', NULL, 'Protein kinase, putative', 181, NULL, NULL, 107313),
(107314, '2.60.40.60-FF-001006', NULL, 'Uncharacterized protein', 105, NULL, NULL, 107314),
(107315, '3.40.50.720-FF-001298', NULL, 'Uncharacterized protein', 142, NULL, NULL, 107315),
(107316, '1.50.10.140-FF-000003', NULL, 'Cyclic beta-1,2-glucan synthase', 289, NULL, NULL, 107316),
(107317, '3.20.20.80-FF-000679', NULL, 'Uncharacterized protein', 332, NULL, NULL, 107317),
(107318, '3.40.50.150-FF-000520', NULL, 'tRNA methyltransferase', 163, NULL, NULL, 107318),
(107319, '2.60.40.1120-FF-000064', NULL, 'AGAP002414-PA', 95, NULL, NULL, 107319),
(107320, '1.20.144.10-FF-000016', NULL, 'Phospholipid phosphatase 2', 261, NULL, NULL, 107320),
(107321, '3.40.1090.10-FF-000024', NULL, 'Lysophospholipase', 494, NULL, NULL, 107321),
(107322, '4.10.60.10-FF-000271', NULL, 'mRNA 3''-end-processing protein YTH1', 51, NULL, NULL, 107322),
(107323, '1.10.565.10-FF-000098', NULL, 'Protein CBR-UNC-55, isoform a', 225, NULL, NULL, 107323),
(107324, '3.30.9.10-FF-000199', NULL, 'Uncharacterized protein', 159, NULL, NULL, 107324),
(107325, '1.10.10.10-FF-000527', NULL, 'Vacuolar protein sorting protein (Vps36), putative', 84, NULL, NULL, 107325);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(107326, '2.60.120.620-FF-000156', NULL, 'Predicted protein', 203, NULL, NULL, 107326),
(107327, '2.60.40.10-FF-000435', NULL, 'Down syndrome cell adhesion molecule, isoform J', 108, NULL, NULL, 107327),
(107328, '3.10.130.10-FF-000007', NULL, 'Inactive ribonuclease-like protein 9', 116, NULL, NULL, 107328),
(107329, '1.10.30.10-FF-000164', NULL, 'Maelstrom', 54, NULL, NULL, 107329),
(107330, '3.40.50.620-FF-000110', NULL, 'Deoxyribodipyrimidine photolyase', 146, NULL, NULL, 107330),
(107331, '1.10.8.270-FF-000154', NULL, 'Uncharacterized protein', 112, NULL, NULL, 107331),
(107332, '3.40.50.720-FF-001309', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 171, NULL, NULL, 107332),
(107333, '3.30.160.60-FF-004706', NULL, NULL, 42, NULL, NULL, 107333),
(107334, '2.10.25.10-FF-001560', NULL, 'Predicted protein', 40, NULL, NULL, 107334),
(107335, '1.10.287.380-FF-000011', NULL, 'ABC transporter ATP-binding protein', 79, NULL, NULL, 107335),
(107336, '1.20.58.530-FF-000016', NULL, 'Unconventional myosin-XVI', 163, NULL, NULL, 107336),
(107337, '2.60.120.200-FF-000120', NULL, 'Axotactin, isoform B', 173, NULL, NULL, 107337),
(107338, '3.20.20.70-FF-000367', NULL, '2-isopropylmalate synthase, truncation', 109, NULL, NULL, 107338),
(107339, '3.30.70.20-FF-000102', NULL, 'Formate dehydrogenase 2 subunit beta (cytochrome c-553)', 127, NULL, NULL, 107339),
(107340, '3.50.4.10-FF-000031', NULL, 'NOmpA Homolog (Drosophila nompA: no mechanoreceptor potential A)', 88, NULL, NULL, 107340),
(107341, '3.40.50.11040-FF-000008', NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', 165, NULL, NULL, 107341),
(107342, '2.130.10.10-FF-000727', NULL, 'NACHT and WD repeat domain containing 2', 253, NULL, NULL, 107342),
(107343, '2.40.50.140-FF-000127', NULL, 'Exosome complex component RRP40', 82, NULL, NULL, 107343),
(107344, '3.40.109.10-FF-000013', NULL, '5,6-dimethylbenzimidazole synthase', 190, NULL, NULL, 107344),
(107345, '3.40.50.720-FF-001444', NULL, 'Fatty acyl-CoA reductase', 185, NULL, NULL, 107345),
(107346, '1.25.40.10-FF-003953', NULL, 'Telomere elongation protein est1', 259, NULL, NULL, 107346),
(107347, '2.120.10.80-FF-000119', NULL, 'Kelch-like 25', 300, NULL, NULL, 107347),
(107348, '3.40.50.300-FF-001060', NULL, 'ATP-dependent RNA helicase RhlE', 222, NULL, NULL, 107348),
(107349, '3.40.50.1780-FF-000013', NULL, 'Iron-sulfur cluster assembly associated protein Nar1', 15, NULL, NULL, 107349),
(107350, '3.40.50.300-FF-006433', NULL, 'Uncharacterized protein', 127, NULL, NULL, 107350),
(107351, '3.30.200.20-FF-002164', NULL, 'Uncharacterized protein', 64, NULL, NULL, 107351),
(107352, '1.20.1050.10-FF-000016', NULL, 'Glutathione S-transferase U9', 142, NULL, NULL, 107352),
(107353, '1.10.10.10-FF-000617', NULL, 'Eukaryotic translation initiation factor 3 subunit K', 102, NULL, NULL, 107353),
(107354, '1.10.1370.10-FF-000003', NULL, 'Mitochondrial intermediate peptidase', 285, NULL, NULL, 107354),
(107355, '3.30.70.1230-FF-000177', NULL, 'Predicted protein', 179, NULL, NULL, 107355),
(107356, '3.10.330.20-FF-000020', NULL, 'Uncharacterized protein', 74, NULL, NULL, 107356),
(107357, '1.10.1370.30-FF-000009', NULL, 'Angiotensin-converting enzyme', 394, NULL, NULL, 107357),
(107358, '3.40.50.300-FF-000256', NULL, 'Guanine nucleotide-binding protein G(t) subunit alpha', 190, NULL, NULL, 107358),
(107359, '3.40.50.11020-FF-000002', NULL, 'ORF1a polyprotein', 124, NULL, NULL, 107359),
(107360, '2.60.40.290-FF-000008', NULL, 'Endo-1,4-beta-xylanase B', 89, NULL, NULL, 107360),
(107361, '2.40.30.10-FF-000396', NULL, 'Mitochondrial tRNA-specific 2-thiouridylase 1-like Protein', 88, NULL, NULL, 107361),
(107362, '2.60.40.820-FF-000010', NULL, 'T-box transcription factor TBX6', 191, NULL, NULL, 107362),
(107363, '3.40.50.11030-FF-000005', NULL, 'Threonylcarbamoyl-AMP synthase', 143, NULL, NULL, 107363),
(107364, '3.30.160.60-FF-000963', NULL, 'zinc finger protein 546', 29, NULL, NULL, 107364),
(107365, '3.40.1500.10-FF-000006', NULL, 'Coproporphyrinogen III oxidase', 340, NULL, NULL, 107365),
(107366, '1.10.630.10-FF-000486', NULL, 'Cytochrome P450, putative', 471, NULL, NULL, 107366);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(107367, '2.130.10.10-FF-002291', NULL, 'At5g11240', 199, NULL, NULL, 107367),
(107368, '3.40.50.720-FF-001096', NULL, 'Putative ubiquitin activating enzyme', 135, NULL, NULL, 107368),
(107369, '2.170.270.10-FF-000130', NULL, 'Uncharacterized protein', 82, NULL, NULL, 107369),
(107370, '3.30.830.10-FF-000258', NULL, 'Uncharacterized protein T8H10.60', 93, NULL, NULL, 107370),
(107371, '3.40.50.300-FF-000902', NULL, 'Peptide chain release factor 3', 274, NULL, NULL, 107371),
(107372, '3.30.870.10-FF-000165', NULL, 'Uncharacterized protein', 233, NULL, NULL, 107372),
(107373, '1.25.40.20-FF-000954', NULL, 'Uncharacterized protein', 116, NULL, NULL, 107373),
(107374, '2.60.120.260-FF-000216', NULL, 'Glycosyltransferase', 128, NULL, NULL, 107374),
(107375, '3.40.50.1820-FF-001582', NULL, 'Alpha/beta-Hydrolases superfamily protein', 98, NULL, NULL, 107375),
(107376, '2.160.10.10-FF-000125', NULL, 'Serine acetyltransferase', 109, NULL, NULL, 107376),
(107377, '3.10.450.10-FF-000071', NULL, 'Uncharacterized protein', 76, NULL, NULL, 107377),
(107378, '2.130.10.10-FF-006034', NULL, 'Centriole proteome protein 16', 298, NULL, NULL, 107378),
(107379, '2.60.40.10-FF-004460', NULL, NULL, 105, NULL, NULL, 107379),
(107380, '1.25.40.1010-FF-000002', NULL, 'N-terminal acetyltransferase catalytic subunit (NAT1)', 222, NULL, NULL, 107380),
(107381, '3.20.20.80-FF-000696', NULL, 'Uncharacterized protein', 147, NULL, NULL, 107381),
(107382, '1.10.472.10-FF-000325', NULL, 'Uncharacterized protein', 145, NULL, NULL, 107382),
(107383, '2.60.40.10-FF-000418', NULL, 'Neural cell adhesion molecule L1-like protein', 110, NULL, NULL, 107383),
(107384, '1.20.1050.20-FF-000019', NULL, NULL, 85, NULL, NULL, 107384),
(107385, '3.30.160.60-FF-006028', NULL, NULL, 27, NULL, NULL, 107385),
(107386, '2.130.10.130-FF-000027', NULL, NULL, 166, NULL, NULL, 107386),
(107387, '1.10.455.10-FF-000016', NULL, '30S ribosomal protein S7', 186, NULL, NULL, 107387),
(107388, '1.10.3720.10-FF-000200', NULL, 'ABC transporter permease protein', 202, NULL, NULL, 107388),
(107389, '3.30.160.60-FF-006270', NULL, NULL, 57, NULL, NULL, 107389),
(107390, '3.30.70.1230-FF-000284', NULL, 'Uncharacterized protein', 239, NULL, NULL, 107390),
(107391, '1.25.10.10-FF-002731', NULL, 'Uncharacterized protein', 876, NULL, NULL, 107391),
(107392, '1.50.40.10-FF-000472', NULL, 'Uncharacterized protein', 45, NULL, NULL, 107392),
(107393, '3.30.70.890-FF-000085', NULL, 'Diphosphomevalonate decarboxylase', 14, NULL, NULL, 107393),
(107394, '2.60.120.1040-FF-000001', NULL, 'Zinc finger protein ZPR1', 141, NULL, NULL, 107394),
(107395, '3.90.79.10-FF-000015', NULL, 'Nudix hydrolase 8', 139, NULL, NULL, 107395),
(107396, '1.20.140.30-FF-000002', NULL, 'MOB-like protein phocein isoform X1', 201, NULL, NULL, 107396),
(107397, '2.70.150.10-FF-000061', NULL, 'Calcium-transporting ATPase', 163, NULL, NULL, 107397),
(107398, '3.40.50.300-FF-004179', NULL, 'Uncharacterized protein', 123, NULL, NULL, 107398),
(107399, '1.20.1530.20-FF-000062', NULL, 'Sodium-dependent transporter (Eurofung)', 277, NULL, NULL, 107399),
(107400, '3.40.30.10-FF-000793', NULL, 'Gcy-33', 62, NULL, NULL, 107400),
(107401, '1.10.3730.20-FF-000029', NULL, 'EamA/RhaT family transporter', 107, NULL, NULL, 107401),
(107402, '2.60.40.1180-FF-000161', NULL, 'Alpha amylase catalytic region', 75, NULL, NULL, 107402),
(107403, '3.30.420.40-FF-000118', NULL, 'Xylulose kinase 2', 312, NULL, NULL, 107403),
(107404, '1.20.120.1760-FF-000043', NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', 192, NULL, NULL, 107404),
(107405, '1.25.40.10-FF-000081', NULL, 'squamous cell carcinoma antigen recognized by T-cells 3', 310, NULL, NULL, 107405),
(107406, '3.90.1410.10-FF-000055', NULL, 'Cytoplasmic protein', 289, NULL, NULL, 107406),
(107407, '1.20.1250.20-FF-001861', NULL, 'Uncharacterized protein', 120, NULL, NULL, 107407),
(107408, '3.30.160.60-FF-006163', NULL, NULL, 82, NULL, NULL, 107408),
(107409, '2.60.120.330-FF-000069', NULL, 'Probable ethylene-forming enzyme', 336, NULL, NULL, 107409);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(107410, '1.10.510.10-FF-002652', NULL, NULL, 77, NULL, NULL, 107410),
(107411, '3.30.870.10-FF-000042', NULL, 'Cardiolipin synthetase domain protein', 154, NULL, NULL, 107411),
(107412, '1.20.140.50-FF-000008', NULL, 'Hydroxyproline-rich glycoprotein family protein', 181, NULL, NULL, 107412),
(107413, '3.30.420.40-FF-000444', NULL, 'Possible d-xylulose kinase xylB', 229, NULL, NULL, 107413),
(107414, '2.130.10.10-FF-004128', NULL, 'Uncharacterized protein', 185, NULL, NULL, 107414),
(107415, '1.10.533.10-FF-000125', NULL, 'Uncharacterized protein', 107, NULL, NULL, 107415),
(107416, '3.20.20.70-FF-000693', NULL, NULL, 174, NULL, NULL, 107416),
(107417, '3.10.600.10-FF-000010', NULL, 'Pyruvate carboxylase', 63, NULL, NULL, 107417),
(107418, '2.60.40.10-FF-004257', NULL, NULL, 126, NULL, NULL, 107418),
(107419, '2.10.25.10-FF-001234', NULL, 'Mucin-13', 49, NULL, NULL, 107419),
(107420, '3.40.50.1000-FF-000392', NULL, 'NLI interacting factor family phosphatase', 168, NULL, NULL, 107420),
(107421, '3.40.50.300-FF-002055', NULL, 'ATP-binding cassette protein subfamily C, member 1', 253, NULL, NULL, 107421),
(107422, '3.40.50.1240-FF-000205', NULL, NULL, 225, NULL, NULL, 107422),
(107423, '3.30.70.20-FF-000118', NULL, NULL, 64, NULL, NULL, 107423),
(107424, '2.20.70.10-FF-000034', NULL, 'syntaxin-binding protein 4 isoform X1', 33, NULL, NULL, 107424),
(107425, '3.20.20.105-FF-000009', NULL, 'Queuine tRNA-ribosyltransferase accessory subunit 2', 265, NULL, NULL, 107425),
(107426, '3.30.450.20-FF-000659', NULL, 'Two-component hybrid sensor and regulator', 154, NULL, NULL, 107426),
(107427, '2.30.29.30-FF-000062', NULL, 'growth factor receptor-bound protein 10 isoform X1', 162, NULL, NULL, 107427),
(107428, '3.30.420.40-FF-000921', NULL, 'Centractin', 157, NULL, NULL, 107428),
(107429, '3.30.160.60-FF-002762', NULL, 'Uncharacterized protein', 23, NULL, NULL, 107429),
(107430, '1.10.287.40-FF-000027', NULL, 'Seryl-tRNA synthetase 2, mitochondrial', 86, NULL, NULL, 107430),
(107431, '2.60.40.10-FF-005887', NULL, NULL, 99, NULL, NULL, 107431),
(107432, '3.80.10.10-FF-003218', NULL, 'Uncharacterized protein', 207, NULL, NULL, 107432),
(107433, '1.10.287.110-FF-000099', NULL, 'Chaperone protein DnaJ', 116, NULL, NULL, 107433),
(107434, '1.10.630.10-FF-000828', NULL, 'Uncharacterized protein', 209, NULL, NULL, 107434),
(107435, '1.10.10.60-FF-000155', NULL, 'ISWI chromatin-remodeling complex ATPase CHR11', 104, NULL, NULL, 107435),
(107436, '3.40.50.1000-FF-000734', NULL, NULL, 69, NULL, NULL, 107436),
(107437, '1.20.1310.10-FF-000200', NULL, NULL, 123, NULL, NULL, 107437),
(107438, '3.40.50.150-FF-000059', NULL, 'spermine synthase', 194, NULL, NULL, 107438),
(107439, '3.30.1460.50-FF-000022', NULL, 'AuTophaGy (Yeast Atg homolog)', 152, NULL, NULL, 107439),
(107440, '1.10.472.80-FF-000088', NULL, 'Uncharacterized protein', 122, NULL, NULL, 107440),
(107441, '1.20.140.40-FF-000005', NULL, 'Pectin methylesterase inhibitor 1', 165, NULL, NULL, 107441),
(107442, '1.10.3460.10-FF-000016', NULL, 'Fucoxanthin chlorophyll a/c light-harvesting protein, lhcr type', 173, NULL, NULL, 107442),
(107443, '1.10.10.10-FF-001000', NULL, 'Histone H1', 79, NULL, NULL, 107443),
(107444, '2.60.120.10-FF-000696', NULL, 'Uncharacterized protein', 52, NULL, NULL, 107444),
(107445, '3.30.200.20-FF-001456', NULL, 'Tyrosine-protein kinase', 30, NULL, NULL, 107445),
(107446, '1.20.1440.340-FF-000004', NULL, 'Galactokinase', 170, NULL, NULL, 107446),
(107447, '2.130.10.10-FF-001829', NULL, 'WD-40 repeat family protein', 181, NULL, NULL, 107447),
(107448, '3.30.420.110-FF-000077', NULL, 'DNA mismatch repair protein MutS', 151, NULL, NULL, 107448),
(107449, '1.25.40.20-FF-000084', NULL, 'Arf-GAP with GTPase, ANK repeat and PH domain-containing protein 2', 121, NULL, NULL, 107449),
(107450, '3.60.21.10-FF-000344', NULL, 'Protein CBG21670', 187, NULL, NULL, 107450),
(107451, '2.60.40.1180-FF-000144', NULL, 'Alpha-glucosidase', 86, NULL, NULL, 107451),
(107452, '2.160.20.10-FF-000070', NULL, 'PKHD1 like 1', 365, NULL, NULL, 107452),
(107453, '3.30.160.60-FF-006472', NULL, NULL, 47, NULL, NULL, 107453);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(107454, '1.10.287.3810-FF-000002', NULL, 'Tryptophan 2,3-dioxygenase', 55, NULL, NULL, 107454),
(107455, '3.90.740.10-FF-000002', NULL, 'Isoleucine--tRNA ligase', 161, NULL, NULL, 107455),
(107456, '3.40.50.1000-FF-000173', NULL, 'Membrane-associated phosphatidylinositol transfer protein 2', 116, NULL, NULL, 107456),
(107457, '1.10.3730.10-FF-000009', NULL, 'Pyrroline-5-carboxylate reductase', 107, NULL, NULL, 107457),
(107458, '2.40.160.210-FF-000017', NULL, 'Uncharacterized protein', 237, NULL, NULL, 107458),
(107459, '1.10.8.60-FF-000098', NULL, 'Sigma-54-dependent transcriptional regulator YgeV', 80, NULL, NULL, 107459),
(107460, '1.20.1530.20-FF-000045', NULL, 'Solute carrier family 10 member 4', 200, NULL, NULL, 107460),
(107461, '1.20.1110.10-FF-000089', NULL, 'Sodium/potassium-transporting ATPase alpha subunit', 105, NULL, NULL, 107461),
(107462, '2.130.10.10-FF-004089', NULL, 'WD repeat domain 93', 199, NULL, NULL, 107462),
(107463, '1.20.58.80-FF-000085', NULL, 'Uncharacterized protein', 127, NULL, NULL, 107463),
(107464, '3.30.1360.120-FF-000058', NULL, 'Aminomethyltransferase', 60, NULL, NULL, 107464),
(107465, '1.10.1070.11-FF-000072', NULL, 'Phosphatidylinositol kinase, putative', 174, NULL, NULL, 107465),
(107466, '2.40.100.10-FF-000019', NULL, 'Peptidyl-prolyl cis-trans isomerase', 175, NULL, NULL, 107466),
(107467, '2.70.98.10-FF-000039', NULL, 'Alpha-1,2-mannosidase', 304, NULL, NULL, 107467),
(107468, '2.120.10.80-FF-000029', NULL, 'Kelch-like family member 17', 132, NULL, NULL, 107468),
(107469, '3.40.50.150-FF-001211', NULL, NULL, 217, NULL, NULL, 107469),
(107470, '3.10.20.90-FF-000750', NULL, 'Sorting nexin-17', 96, NULL, NULL, 107470),
(107471, '3.40.50.1010-FF-000176', NULL, NULL, 175, NULL, NULL, 107471),
(107472, '2.70.170.10-FF-000253', NULL, 'Uncharacterized protein', 204, NULL, NULL, 107472),
(107473, '3.40.50.2300-FF-001327', NULL, NULL, 85, NULL, NULL, 107473),
(107474, '3.70.10.10-FF-000094', NULL, 'Putative dna repair protein rad9 protein', 78, NULL, NULL, 107474),
(107475, '1.25.10.10-FF-002254', NULL, 'Protein phosphatase, putative', 366, NULL, NULL, 107475),
(107476, '1.10.472.10-FF-000634', NULL, 'Uncharacterized protein', 120, NULL, NULL, 107476),
(107477, '3.30.200.20-FF-001765', NULL, 'Dual-specificity tyrosine-(Y)-phosphorylation-regulated kinase 1A, a', 96, NULL, NULL, 107477),
(107478, '3.40.50.2300-FF-001636', NULL, NULL, 262, NULL, NULL, 107478),
(107479, '2.130.10.10-FF-004437', NULL, 'Uncharacterized protein', 356, NULL, NULL, 107479),
(107480, '2.130.10.10-FF-002330', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit WDR4', 129, NULL, NULL, 107480),
(107481, '3.30.420.40-FF-000360', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', 168, NULL, NULL, 107481),
(107482, '3.40.50.300-FF-006107', NULL, 'Uncharacterized protein', 154, NULL, NULL, 107482),
(107483, '2.80.10.50-FF-000169', NULL, 'Predicted protein', 156, NULL, NULL, 107483),
(107484, '1.20.58.340-FF-000083', NULL, 'Uncharacterized protein', 195, NULL, NULL, 107484),
(107485, '3.40.1090.10-FF-000041', NULL, 'Lysophospholipase NTE1', 75, NULL, NULL, 107485),
(107486, '3.30.70.330-FF-000142', NULL, 'splicing regulatory glutamine/lysine-rich protein 1 isoform X1', 82, NULL, NULL, 107486),
(107487, '2.60.40.10-FF-002543', NULL, NULL, 97, NULL, NULL, 107487),
(107488, '3.30.1460.50-FF-000005', NULL, 'Ubiquitin-like-conjugating enzyme ATG10', 148, NULL, NULL, 107488),
(107489, '1.10.3120.10-FF-000002', NULL, 'Trigger factor', 210, NULL, NULL, 107489),
(107490, '1.20.58.530-FF-000033', NULL, 'Chitin synthase', 152, NULL, NULL, 107490),
(107491, '1.20.120.1750-FF-000040', NULL, 'RBR-type E3 ubiquitin transferase', 100, NULL, NULL, 107491),
(107492, '1.25.40.10-FF-004133', NULL, 'Uncharacterized protein', 120, NULL, NULL, 107492),
(107493, '1.10.30.10-FF-000181', NULL, 'High mobility group box 2', 65, NULL, NULL, 107493),
(107494, '1.10.150.240-FF-000116', NULL, 'Glycosyl hydrolase family 65 central catalytic domain/Haloacid dehalogenase-like hydrolase, putative', 33, NULL, NULL, 107494);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(107495, '1.50.40.10-FF-000556', NULL, 'Uncharacterized protein', 126, NULL, NULL, 107495),
(107496, '3.50.4.10-FF-000014', NULL, 'NOmpA Homolog (Drosophila nompA: no mechanoreceptor potential A)', 87, NULL, NULL, 107496),
(107497, '1.10.10.10-FF-000634', NULL, 'HTH-type transcriptional regulator MmpR5', 97, NULL, NULL, 107497),
(107498, '3.40.50.300-FF-006742', NULL, 'Uncharacterized protein', 68, NULL, NULL, 107498),
(107499, '2.40.70.10-FF-000410', NULL, NULL, 218, NULL, NULL, 107499),
(107500, '2.10.25.10-FF-001762', NULL, 'Uncharacterized protein', 36, NULL, NULL, 107500),
(107501, '1.10.10.60-FF-000716', NULL, NULL, 47, NULL, NULL, 107501),
(107502, '3.40.50.1240-FF-000087', NULL, 'Putative acid phosphatase', 381, NULL, NULL, 107502),
(107503, '1.25.40.550-FF-000007', NULL, 'WGS project CABT00000000 data, contig 2.18', 243, NULL, NULL, 107503),
(107504, '2.40.10.10-FF-000108', NULL, 'Genome polyprotein', 99, NULL, NULL, 107504),
(107505, '1.20.1280.290-FF-000002', NULL, 'Bidirectional sugar transporter SWEET', 94, NULL, NULL, 107505),
(107506, '1.10.10.10-FF-000292', NULL, 'O-methyltransferase ZRP4', 108, NULL, NULL, 107506),
(107507, '2.60.120.10-FF-000477', NULL, 'Cupin-like domain-domain-containing protein', 313, NULL, NULL, 107507),
(107508, '3.50.7.10-FF-000037', NULL, 'Putative phosphatidylinositol (3,5) kinase', 167, NULL, NULL, 107508),
(107509, '2.130.10.10-FF-000076', NULL, 'Coronin', 348, NULL, NULL, 107509),
(107510, '3.30.230.70-FF-000157', NULL, 'EXOSome (Multiexonuclease complex) component', 60, NULL, NULL, 107510),
(107511, '3.60.15.10-FF-000150', NULL, 'Glyoxalase II', 296, NULL, NULL, 107511),
(107512, '1.10.510.10-FF-002017', NULL, 'Protein CBG18064', 403, NULL, NULL, 107512),
(107513, '1.10.10.10-FF-002096', NULL, 'Uncharacterized protein', 53, NULL, NULL, 107513),
(107514, '2.170.270.10-FF-000091', NULL, 'Uncharacterized protein', 182, NULL, NULL, 107514),
(107515, '1.25.40.10-FF-001699', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 178, NULL, NULL, 107515),
(107516, '1.25.50.20-FF-000039', NULL, 'Aminopeptidase', 328, NULL, NULL, 107516),
(107517, '3.40.50.720-FF-001753', NULL, 'Lovastatin nonaketide synthase, enoyl reductase component', 193, NULL, NULL, 107517),
(107518, '1.20.1250.20-FF-002024', NULL, 'Putative inorganic phosphate cotransporter-like protein', 354, NULL, NULL, 107518),
(107519, '1.10.10.60-FF-000065', NULL, 'Visual system homeobox 1', 67, NULL, NULL, 107519),
(107520, '2.30.42.10-FF-000401', NULL, NULL, 48, NULL, NULL, 107520),
(107521, '3.40.50.12160-FF-000029', NULL, 'Ribosomal protein S12 methylthiotransferase RimO', 129, NULL, NULL, 107521),
(107522, '1.10.10.440-FF-000046', NULL, 'WW domain-containing protein ZK1098.1', 69, NULL, NULL, 107522),
(107523, '3.30.160.60-FF-001958', NULL, 'Zinc finger protein, putative', 28, NULL, NULL, 107523),
(107524, '1.10.8.270-FF-000047', NULL, 'TBC domain protein, putative', 116, NULL, NULL, 107524),
(107525, '2.60.40.10-FF-000289', NULL, 'Chromosome 6 open reading frame 106', 112, NULL, NULL, 107525),
(107526, '2.60.120.10-FF-000168', NULL, 'Cupin domain-containing protein', 94, NULL, NULL, 107526),
(107527, '1.25.40.530-FF-000001', NULL, 'Pleckstrin homology domain-containing family H member 2', 194, NULL, NULL, 107527),
(107528, '2.40.10.10-FF-000417', NULL, NULL, 162, NULL, NULL, 107528),
(107529, '3.40.50.300-FF-002690', NULL, 'Spermidine/putrescine ABC transporter ATP-binding protein', 267, NULL, NULL, 107529),
(107530, '3.40.190.290-FF-000136', NULL, 'Uncharacterized protein', 185, NULL, NULL, 107530),
(107531, '1.10.510.10-FF-002326', NULL, NULL, 207, NULL, NULL, 107531),
(107532, '3.40.50.2300-FF-001546', NULL, NULL, 31, NULL, NULL, 107532),
(107533, '1.25.40.540-FF-000004', NULL, 'Type 2A phosphatase-associated protein 42,putative', 229, NULL, NULL, 107533),
(107534, '3.40.640.10-FF-000421', NULL, 'Predicted protein', 36, NULL, NULL, 107534),
(107535, '2.10.25.10-FF-001453', NULL, 'Integrin beta', 63, NULL, NULL, 107535),
(107536, '3.30.200.20-FF-001675', NULL, NULL, 79, NULL, NULL, 107536);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(107537, '2.70.130.10-FF-000149', NULL, NULL, 139, NULL, NULL, 107537),
(107538, '3.90.1150.10-FF-000017', NULL, 'Ornithine aminotransferase', 133, NULL, NULL, 107538),
(107539, '3.30.200.20-FF-001984', NULL, 'Uncharacterized protein', 99, NULL, NULL, 107539),
(107540, '3.40.1360.10-FF-000034', NULL, 'Meiotic recombination protein SPO11-4', 219, NULL, NULL, 107540),
(107541, '3.30.1330.10-FF-000012', NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase', 143, NULL, NULL, 107541),
(107542, '1.25.10.10-FF-001888', NULL, 'CAND1 isoform 2', 583, NULL, NULL, 107542),
(107543, '1.20.5.170-FF-000200', NULL, 'Putative basic-leucine zipper transcription factor', 70, NULL, NULL, 107543),
(107544, '3.30.450.40-FF-000069', NULL, 'Putative transcriptional regulator', 76, NULL, NULL, 107544),
(107545, '1.10.287.600-FF-000027', NULL, 'Uncharacterized protein', 29, NULL, NULL, 107545),
(107546, '1.10.10.10-FF-000943', NULL, 'Regulatory protein RecX', 45, NULL, NULL, 107546),
(107547, '3.90.730.10-FF-000035', NULL, 'Uncharacterized protein', 76, NULL, NULL, 107547),
(107548, '1.10.520.10-FF-000039', NULL, 'Os07g0639500 protein', 74, NULL, NULL, 107548),
(107549, '3.40.50.300-FF-002381', NULL, 'Type II/IV secretion system protein', 198, NULL, NULL, 107549),
(107550, '1.10.10.60-FF-000374', NULL, 'Arginine-glutamic acid dipeptide repeat protein', 64, NULL, NULL, 107550),
(107551, '2.130.10.10-FF-000385', NULL, 'DDB1- and CUL4-associated factor 5 isoform X1', 53, NULL, NULL, 107551),
(107552, '3.40.50.150-FF-000374', NULL, 'Putative methyltransferase', 205, NULL, NULL, 107552),
(107553, '3.40.640.10-FF-000056', NULL, 'SelA-like pyridoxal phosphate-dependent enzyme', 252, NULL, NULL, 107553),
(107554, '3.40.50.1000-FF-000375', NULL, 'phosphoserine phosphatase isoform X2', 120, NULL, NULL, 107554),
(107555, '3.30.1330.60-FF-000004', NULL, 'Outer membrane protein A', 137, NULL, NULL, 107555),
(107556, '3.30.420.40-FF-000135', NULL, 'Heat shock cognate 71 kDa protein', 89, NULL, NULL, 107556),
(107557, '1.25.40.10-FF-000064', NULL, 'Putative pre-mrna-processing factor 39', 171, NULL, NULL, 107557),
(107558, '3.20.20.70-FF-000822', NULL, NULL, 216, NULL, NULL, 107558),
(107559, '3.40.30.10-FF-000922', NULL, 'Iodothyronine deiodinase', 125, NULL, NULL, 107559),
(107560, '1.10.510.10-FF-002871', NULL, NULL, 124, NULL, NULL, 107560),
(107561, '2.40.50.140-FF-000021', NULL, '30S ribosomal protein S1', 92, NULL, NULL, 107561),
(107562, '3.30.390.50-FF-000016', NULL, 'Predicted protein', 80, NULL, NULL, 107562),
(107563, '1.10.1420.10-FF-000008', NULL, 'MutS homolog 5 (E. coli)', 220, NULL, NULL, 107563),
(107564, '2.130.10.10-FF-004544', NULL, 'Uncharacterized protein', 221, NULL, NULL, 107564),
(107565, '3.40.50.300-FF-004943', NULL, 'Small GTP-binding protein, putative', 205, NULL, NULL, 107565),
(107566, '2.30.29.30-FF-001147', NULL, 'Uncharacterized protein (Fragment)', 112, NULL, NULL, 107566),
(107567, '2.10.25.10-FF-000014', NULL, 'Latent-transforming growth factor beta-binding protein 3', 86, NULL, NULL, 107567),
(107568, '3.40.532.10-FF-000030', NULL, NULL, 144, NULL, NULL, 107568),
(107569, '1.20.1110.10-FF-000179', NULL, NULL, 212, NULL, NULL, 107569),
(107570, '3.40.50.1100-FF-000107', NULL, 'Diaminopropionate ammonia-lyase', 203, NULL, NULL, 107570),
(107571, '3.40.462.20-FF-000004', NULL, 'FAD binding domain protein', 220, NULL, NULL, 107571),
(107572, '3.30.310.10-FF-000039', NULL, 'AP complex subunit beta', 44, NULL, NULL, 107572),
(107573, '2.120.10.30-FF-000037', NULL, 'Uncharacterized protein, isoform E', 104, NULL, NULL, 107573),
(107574, '3.40.50.300-FF-008215', NULL, 'Uncharacterized protein', 68, NULL, NULL, 107574),
(107575, '2.60.40.10-FF-003959', NULL, NULL, 104, NULL, NULL, 107575),
(107576, '1.10.510.10-FF-002343', NULL, NULL, 200, NULL, NULL, 107576),
(107577, '1.10.400.10-FF-000064', NULL, 'Uncharacterized protein', 47, NULL, NULL, 107577),
(107578, '2.60.200.20-FF-000093', NULL, 'Kinesin-3', 140, NULL, NULL, 107578),
(107579, '2.30.30.40-FF-000602', NULL, 'Uncharacterized protein', 57, NULL, NULL, 107579);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(107580, '2.40.50.100-FF-000060', NULL, 'Apicoplast ribosomal protein L27', 92, NULL, NULL, 107580),
(107581, '2.130.10.10-FF-001796', NULL, 'WD repeat-containing protein 55 homolog', 213, NULL, NULL, 107581),
(107582, '2.60.40.60-FF-000315', NULL, 'CaDHerin family', 118, NULL, NULL, 107582),
(107583, '2.40.30.10-FF-000290', NULL, 'Selenocysteine-specific translation elongation factor', 92, NULL, NULL, 107583),
(107584, '3.40.50.300-FF-003797', NULL, 'Protein CBG01632', 153, NULL, NULL, 107584),
(107585, '3.90.70.40-FF-000021', NULL, 'Uncharacterized protein', 132, NULL, NULL, 107585),
(107586, '3.90.105.10-FF-000009', NULL, 'Molybdopterin molybdenumtransferase', 57, NULL, NULL, 107586),
(107587, '3.30.160.60-FF-000199', NULL, 'metal regulatory transcription factor 1', 30, NULL, NULL, 107587),
(107588, '3.30.40.10-FF-001704', NULL, 'Uncharacterized protein', 63, NULL, NULL, 107588),
(107589, '1.20.58.1040-FF-000004', NULL, 'O-Glycosyl hydrolase family 17 protein', 88, NULL, NULL, 107589),
(107590, '1.20.1270.280-FF-000065', NULL, 'Uncharacterized protein', 142, NULL, NULL, 107590),
(107591, '3.30.70.920-FF-000021', NULL, 'Lrp/AsnC family transcriptional regulator', 85, NULL, NULL, 107591),
(107592, '2.40.340.10-FF-000020', NULL, NULL, 79, NULL, NULL, 107592),
(107593, '1.25.10.10-FF-002170', NULL, 'Uncharacterized protein', 1068, NULL, NULL, 107593),
(107594, '3.10.660.10-FF-000002', NULL, 'DnaJ (Hsp40) homolog, subfamily C, member 24', 59, NULL, NULL, 107594),
(107595, '1.25.40.70-FF-000076', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', 175, NULL, NULL, 107595),
(107596, '3.30.1330.50-FF-000001', NULL, '2-C-methyl-D-erythritol 2,4-cyclodiphosphate synthase', 160, NULL, NULL, 107596),
(107597, '3.30.160.360-FF-000002', NULL, 'Histone-lysine N-methyltransferase', 100, NULL, NULL, 107597),
(107598, '1.10.630.10-FF-000795', NULL, 'Predicted protein', 95, NULL, NULL, 107598),
(107599, '1.10.10.10-FF-002107', NULL, 'Uncharacterized protein', 68, NULL, NULL, 107599),
(107600, '2.60.40.60-FF-000843', NULL, 'Uncharacterized protein', 72, NULL, NULL, 107600),
(107601, '3.30.830.10-FF-000039', NULL, 'Ubiquinol-cytochrome c reductase core subunit 2', 203, NULL, NULL, 107601),
(107602, '3.30.2020.30-FF-000034', NULL, 'Predicted protein', 67, NULL, NULL, 107602),
(107603, '1.20.58.1030-FF-000001', NULL, 'DNA replication complex GINS protein PSF1', 128, NULL, NULL, 107603),
(107604, '2.120.10.30-FF-000571', NULL, 'Uncharacterized protein', 38, NULL, NULL, 107604),
(107605, '1.20.1070.10-FF-001670', NULL, 'Uncharacterized protein', 124, NULL, NULL, 107605),
(107606, '2.30.30.40-FF-000063', NULL, 'Putative E3 ubiquitin-protein ligase SH3RF1', 65, NULL, NULL, 107606),
(107607, '3.30.200.20-FF-002147', NULL, 'Uncharacterized protein', 69, NULL, NULL, 107607),
(107608, '3.40.50.150-FF-000368', NULL, 'Multisite-specific tRNA:(Cytosine-C(5))-methyltransferase trm4b', 352, NULL, NULL, 107608),
(107609, '3.30.70.3250-FF-000024', NULL, NULL, 53, NULL, NULL, 107609),
(107610, '3.30.2010.30-FF-000005', NULL, 'Uncharacterized protein', 54, NULL, NULL, 107610),
(107611, '1.20.5.190-FF-000122', NULL, NULL, 47, NULL, NULL, 107611),
(107612, '3.10.250.10-FF-000084', NULL, NULL, 107, NULL, NULL, 107612),
(107613, '1.20.1050.10-FF-000033', NULL, 'metaxin-2 isoform X1', 150, NULL, NULL, 107613),
(107614, '3.30.505.10-FF-000262', NULL, NULL, 86, NULL, NULL, 107614),
(107615, '2.130.10.10-FF-005539', NULL, 'Uncharacterized protein', 132, NULL, NULL, 107615),
(107616, '3.10.180.10-FF-000055', NULL, 'Protein yecM', 193, NULL, NULL, 107616),
(107617, '3.90.550.10-FF-000487', NULL, '2-phospho-L-lactate guanylyltransferase protein', 177, NULL, NULL, 107617),
(107618, '3.30.200.20-FF-000601', NULL, 'Protein kinase C epsilon', 96, NULL, NULL, 107618),
(107619, '2.30.30.30-FF-000060', NULL, 'Transcription elongation factor SPT5', 55, NULL, NULL, 107619),
(107620, '3.30.70.330-FF-001575', NULL, NULL, 106, NULL, NULL, 107620),
(107621, '3.30.160.60-FF-000738', NULL, 'zinc finger protein Eos isoform X1', 65, NULL, NULL, 107621);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(107622, '1.10.472.10-FF-000409', NULL, 'Cyclin-related protein FAM58A', 104, NULL, NULL, 107622),
(107623, '1.10.418.10-FF-000048', NULL, 'Short stop, isoform B', 122, NULL, NULL, 107623),
(107624, '2.30.29.240-FF-000024', NULL, 'Phosphoinositide phospholipase C', 201, NULL, NULL, 107624),
(107625, '1.25.10.10-FF-000707', NULL, 'MMS19 nucleotide excision repair protein-like protein', 228, NULL, NULL, 107625),
(107626, '3.90.550.50-FF-000252', NULL, 'Predicted protein', 105, NULL, NULL, 107626),
(107627, '1.25.40.10-FF-004335', NULL, 'Tetratricopeptide repeat domain 19', 165, NULL, NULL, 107627),
(107628, '1.25.10.10-FF-000455', NULL, 'Karyopherin beta', 1119, NULL, NULL, 107628),
(107629, '1.10.510.10-FF-002545', NULL, 'Serine/threonine-protein kinase, putative', 292, NULL, NULL, 107629),
(107630, '3.40.50.720-FF-000224', NULL, 'Hydroxysteroid 17-beta dehydrogenase 11', 240, NULL, NULL, 107630),
(107631, '3.90.226.10-FF-000228', NULL, 'ATP-dependent Clp protease proteolytic subunit', 216, NULL, NULL, 107631),
(107632, '1.10.3470.10-FF-000062', NULL, 'Probable ABC transporter permease protein HI_1471', 337, NULL, NULL, 107632),
(107633, '3.30.160.60-FF-002453', NULL, 'Zinc finger protein 687', 79, NULL, NULL, 107633),
(107634, '2.30.29.230-FF-000021', NULL, 'GTPase-activating protein gyp7', 190, NULL, NULL, 107634),
(107635, '3.40.50.300-FF-002706', NULL, 'SEPT3 isoform 5', 155, NULL, NULL, 107635),
(107636, '3.30.50.10-FF-000204', NULL, 'E78 nuclear receptor', 36, NULL, NULL, 107636),
(107637, '3.40.190.10-FF-000111', NULL, 'Hca operon transcriptional activator', 91, NULL, NULL, 107637),
(107638, '2.60.40.10-FF-004566', NULL, NULL, 102, NULL, NULL, 107638),
(107639, '3.40.50.300-FF-000672', NULL, 'Trifunctional nicotinamide-nucleotide adenylyltransferase/ribosylnicotinamide kinase/transcriptional regulator NadR', 167, NULL, NULL, 107639),
(107640, '3.90.70.10-FF-000259', NULL, 'Dipeptidyl peptidase 1', 304, NULL, NULL, 107640),
(107641, '3.90.550.10-FF-000611', NULL, 'Os04g0613700 protein', 216, NULL, NULL, 107641),
(107642, '3.30.60.90-FF-000049', NULL, 'zinc finger protein (ZZ-type)-2 isoform X1', 56, NULL, NULL, 107642),
(107643, '3.10.170.20-FF-000029', NULL, NULL, 118, NULL, NULL, 107643),
(107644, '3.40.50.1820-FF-001812', NULL, 'Uncharacterized protein', 115, NULL, NULL, 107644),
(107645, '3.80.10.10-FF-001970', NULL, 'F-box protein', 89, NULL, NULL, 107645),
(107646, '1.20.120.1750-FF-000023', NULL, 'RBR-type E3 ubiquitin transferase', 75, NULL, NULL, 107646),
(107647, '3.40.50.1580-FF-000060', NULL, 'S-methyl-5''-thioadenosine phosphorylase', 233, NULL, NULL, 107647),
(107648, '3.30.70.2820-FF-000002', NULL, 'DNA polymerase', 127, NULL, NULL, 107648),
(107649, '2.40.10.310-FF-000002', NULL, '30S ribosomal protein S8e', 70, NULL, NULL, 107649),
(107650, '3.30.160.60-FF-004690', NULL, NULL, 85, NULL, NULL, 107650),
(107651, '3.30.70.330-FF-001884', NULL, NULL, 231, NULL, NULL, 107651),
(107652, '3.30.870.10-FF-000148', NULL, 'Uncharacterized protein', 198, NULL, NULL, 107652),
(107653, '3.40.470.10-FF-000043', NULL, NULL, 51, NULL, NULL, 107653),
(107654, '2.130.10.10-FF-005848', NULL, 'Uncharacterized protein', 335, NULL, NULL, 107654),
(107655, '1.20.1070.10-FF-000956', NULL, 'Uncharacterized protein', 178, NULL, NULL, 107655),
(107656, '2.60.40.2810-FF-000003', NULL, 'Uncharacterized protein', 139, NULL, NULL, 107656),
(107657, '1.25.40.20-FF-000319', NULL, 'E3 ubiquitin-protein ligase HACE1 isoform X4', 102, NULL, NULL, 107657),
(107658, '1.20.1280.50-FF-000079', NULL, 'Unplaced genomic scaffold supercont1.46, whole genome shotgun sequence', 91, NULL, NULL, 107658),
(107659, '1.25.40.10-FF-000316', NULL, 'Pentatricopeptide repeat-containing protein', 83, NULL, NULL, 107659),
(107660, '1.10.10.60-FF-000733', NULL, 'NANOG neighbor homeobox', 66, NULL, NULL, 107660),
(107661, '2.120.10.30-FF-000239', NULL, 'Protein STRICTOSIDINE SYNTHASE-LIKE 3', 162, NULL, NULL, 107661),
(107662, '3.80.30.20-FF-000030', NULL, 'Oxidative cyclase, putative', 210, NULL, NULL, 107662),
(107663, '1.10.1070.11-FF-000066', NULL, 'NUC194_domain/Phosphatidylinositol_3-_and_4 -kinase_-_putative', 184, NULL, NULL, 107663);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(107664, '3.40.720.10-FF-000366', NULL, 'Uncharacterized protein', 137, NULL, NULL, 107664),
(107665, '3.30.559.10-FF-000110', NULL, 'O-acetyltransferase, putative', 182, NULL, NULL, 107665),
(107666, '1.10.418.10-FF-000155', NULL, 'Microtubule binding protein HOOK3, putative (AFU_orthologue AFUA_1G07490)', 154, NULL, NULL, 107666),
(107667, '3.40.50.300-FF-000924', NULL, 'tRNA modification GTPase GTPBP3, mitochondrial', 178, NULL, NULL, 107667),
(107668, '1.10.472.130-FF-000016', NULL, 'Dynein heavy chain, putative', 103, NULL, NULL, 107668),
(107669, '2.60.40.10-FF-005893', NULL, NULL, 81, NULL, NULL, 107669),
(107670, '1.10.510.10-FF-001016', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase SD3-1', 96, NULL, NULL, 107670),
(107671, '3.40.50.1820-FF-001503', NULL, 'Uncharacterized protein', 158, NULL, NULL, 107671),
(107672, '1.10.510.10-FF-000398', NULL, 'Calcium-dependent protein kinase 1', 205, NULL, NULL, 107672),
(107673, '2.40.10.10-FF-000434', NULL, NULL, 91, NULL, NULL, 107673),
(107674, '3.10.310.20-FF-000018', NULL, NULL, 128, NULL, NULL, 107674),
(107675, '2.60.120.200-FF-000030', NULL, 'FAT atypical cadherin 4', 177, NULL, NULL, 107675),
(107676, '1.25.40.10-FF-003498', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 65, NULL, NULL, 107676),
(107677, '3.10.100.10-FF-000314', NULL, NULL, 99, NULL, NULL, 107677),
(107678, '1.10.8.270-FF-000064', NULL, 'Small G protein-signaling modulator 1b', 95, NULL, NULL, 107678),
(107679, '3.60.21.10-FF-000018', NULL, 'Phosphoesterase', 183, NULL, NULL, 107679),
(107680, '1.10.30.10-FF-000074', NULL, 'SRY-related protein AMA1', 54, NULL, NULL, 107680),
(107681, '3.90.550.50-FF-000033', NULL, 'GD23186', 190, NULL, NULL, 107681),
(107682, '1.20.120.1900-FF-000091', NULL, 'Spindle pole body component', 275, NULL, NULL, 107682),
(107683, '1.20.58.760-FF-000051', NULL, 'Uncharacterized protein', 60, NULL, NULL, 107683),
(107684, '3.10.110.10-FF-000118', NULL, 'Ubiquitin-conjugating enzyme E2 N', 80, NULL, NULL, 107684),
(107685, '3.90.226.10-FF-000122', NULL, 'Serine protease SPPA, chloroplastic', 116, NULL, NULL, 107685),
(107686, '3.60.21.10-FF-000327', NULL, 'Vacuolar protein sorting-associated protein 29', 65, NULL, NULL, 107686),
(107687, '3.40.50.1820-FF-001267', NULL, 'Carboxypeptidase', 305, NULL, NULL, 107687),
(107688, '3.90.1150.10-FF-000091', NULL, 'Glutamic-oxaloacetic transaminase 1 like 1', 136, NULL, NULL, 107688),
(107689, '3.30.230.70-FF-000073', NULL, 'EXOSome (Multiexonuclease complex) component', 226, NULL, NULL, 107689),
(107690, '3.30.70.330-FF-002502', NULL, NULL, 72, NULL, NULL, 107690),
(107691, '3.40.50.1780-FF-000035', NULL, 'Uncharacterized protein', 44, NULL, NULL, 107691),
(107692, '3.10.105.10-FF-000067', NULL, 'ABC transporter substrate-binding protein', 209, NULL, NULL, 107692),
(107693, '2.30.30.140-FF-000339', NULL, 'RBB1NT (NUC162) domaincontaining protein', 96, NULL, NULL, 107693),
(107694, '3.30.2160.10-FF-000077', NULL, 'E3 ubiquitin-protein ligase', 83, NULL, NULL, 107694),
(107695, '3.90.1140.10-FF-000045', NULL, 'U6 snRNA phosphodiesterase', 123, NULL, NULL, 107695),
(107696, '4.10.90.10-FF-000003', NULL, 'Polyprotein', 61, NULL, NULL, 107696),
(107697, '3.30.519.10-FF-000001', NULL, 'Rab GDP dissociation inhibitor', 153, NULL, NULL, 107697),
(107698, '3.40.640.10-FF-000275', NULL, 'Bifunctional dethiobiotin synthetase/7,8-diamino-pelargonic acid aminotransferase, mitochondrial', 166, NULL, NULL, 107698),
(107699, '3.40.50.1010-FF-000069', NULL, 'Ribonuclease VapC', 136, NULL, NULL, 107699),
(107700, '3.40.50.1000-FF-000156', NULL, 'PhosphoGlycolate Phosphatase Homolog', 136, NULL, NULL, 107700),
(107701, '3.30.710.10-FF-000210', NULL, 'BTB/POZ domain-containing protein SR1IP1', 165, NULL, NULL, 107701),
(107702, '2.130.10.10-FF-000744', NULL, 'Transducin/WD40 repeat-like superfamily protein', 141, NULL, NULL, 107702),
(107703, '3.40.50.720-FF-001551', NULL, '3-oxoacyl-(Acyl carrier protein) reductase (FabG-6)', 255, NULL, NULL, 107703),
(107704, '2.130.10.10-FF-002184', NULL, 'Cilia and flagella-associated protein 57', 230, NULL, NULL, 107704);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(107705, '3.40.50.10810-FF-000169', NULL, 'Predicted protein', 147, NULL, NULL, 107705),
(107706, '2.40.30.130-FF-000053', NULL, 'Uncharacterized protein', 96, NULL, NULL, 107706),
(107707, '2.130.10.10-FF-000492', NULL, 'LEC14B homolog isoform X2', 117, NULL, NULL, 107707),
(107708, '2.60.40.10-FF-002217', NULL, 'Roundabout 2', 105, NULL, NULL, 107708),
(107709, '3.65.10.10-FF-000022', NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', 210, NULL, NULL, 107709),
(107710, '2.70.170.10-FF-000034', NULL, 'Ligand-Gated ion Channel', 208, NULL, NULL, 107710),
(107711, '3.60.130.20-FF-000004', NULL, 'Prolyl 3,4-dihydroxylase OGFOD1', 292, NULL, NULL, 107711),
(107712, '2.70.130.10-FF-000166', NULL, NULL, 85, NULL, NULL, 107712),
(107713, '2.10.25.10-FF-001009', NULL, 'Protein CBG02502', 73, NULL, NULL, 107713),
(107714, '3.90.70.10-FF-000478', NULL, 'Uncharacterized protein', 339, NULL, NULL, 107714),
(107715, '1.20.140.150-FF-000001', NULL, 'Claudin', 192, NULL, NULL, 107715),
(107716, '2.70.150.10-FF-000167', NULL, 'Phospholipid-transporting ATPase', 134, NULL, NULL, 107716),
(107717, '3.40.50.300-FF-000891', NULL, 'ATP-binding cassette sub-family G member', 241, NULL, NULL, 107717),
(107718, '1.25.40.10-FF-003189', NULL, 'Uncharacterized protein', 322, NULL, NULL, 107718),
(107719, '3.40.980.10-FF-000014', NULL, 'Molybdopterin molybdenumtransferase', 143, NULL, NULL, 107719),
(107720, '1.20.1640.10-FF-000045', NULL, 'Multifunctional fusion protein', 221, NULL, NULL, 107720),
(107721, '3.40.30.10-FF-000158', NULL, 'Selenoprotein W', 87, NULL, NULL, 107721),
(107722, '2.60.40.1120-FF-000042', NULL, 'Carboxypeptidase-like regulatory domain-containing protein', 78, NULL, NULL, 107722),
(107723, '2.10.220.10-FF-000018', NULL, 'Proprotein convertase subtilisin/kexin type 5', 60, NULL, NULL, 107723),
(107724, '3.30.160.60-FF-002672', NULL, 'Zinc finger protein 347', 31, NULL, NULL, 107724),
(107725, '2.40.30.10-FF-000435', NULL, 'Uncharacterized protein', 89, NULL, NULL, 107725),
(107726, '2.40.10.10-FF-000182', NULL, 'Zgc:163079', 120, NULL, NULL, 107726),
(107727, '3.40.50.10810-FF-000080', NULL, 'DNA repair protein RAD16', 311, NULL, NULL, 107727),
(107728, '3.10.490.10-FF-000045', NULL, 'Gamma-glutamylcyclotransferase', 181, NULL, NULL, 107728),
(107729, '2.10.25.10-FF-001318', NULL, 'Predicted protein', 38, NULL, NULL, 107729),
(107730, '2.60.40.790-FF-000068', NULL, '22.0 kDa class IV heat shock protein', 146, NULL, NULL, 107730),
(107731, '2.60.200.20-FF-000104', NULL, 'Serine/threonine-protein kinase RAD53', 158, NULL, NULL, 107731),
(107732, '3.30.559.30-FF-000116', NULL, 'Uncharacterized protein', 203, NULL, NULL, 107732),
(107733, '3.40.50.720-FF-001860', NULL, 'Glutamate dehydrogenase', 88, NULL, NULL, 107733),
(107734, '3.90.1110.10-FF-000021', NULL, 'DNA-directed RNA polymerase subunit beta', 187, NULL, NULL, 107734),
(107735, '1.10.510.10-FF-000089', NULL, 'Tyrosine-protein kinase receptor TYRO3', 194, NULL, NULL, 107735),
(107736, '3.40.30.10-FF-000809', NULL, 'Glutathione S-transferase', 75, NULL, NULL, 107736),
(107737, '3.40.630.10-FF-000140', NULL, 'Carboxypeptidase d', 305, NULL, NULL, 107737),
(107738, '3.30.450.40-FF-000272', NULL, 'PAS sensor protein', 166, NULL, NULL, 107738),
(107739, '1.25.40.90-FF-000031', NULL, 'Vacuolar protein sorting-associated protein 27', 157, NULL, NULL, 107739),
(107740, '2.130.10.10-FF-005871', NULL, 'WD40 repeat-containing protein', 307, NULL, NULL, 107740),
(107741, '2.60.120.650-FF-000232', NULL, 'Lid2 complex component lid2', 138, NULL, NULL, 107741),
(107742, '3.30.379.10-FF-000012', NULL, 'Beta-hexosaminidase', 185, NULL, NULL, 107742),
(107743, '1.25.40.990-FF-000009', NULL, 'Dysferlin protein', 316, NULL, NULL, 107743),
(107744, '1.25.40.10-FF-004116', NULL, 'Protein CBG21210', 131, NULL, NULL, 107744),
(107745, '3.30.160.60-FF-002981', NULL, 'Uncharacterized protein', 25, NULL, NULL, 107745),
(107746, '1.20.1250.20-FF-001546', NULL, 'MFS transporter, putative (AFU_orthologue AFUA_2G17840)', 419, NULL, NULL, 107746),
(107747, '3.30.565.10-FF-000400', NULL, 'Two-component system sensor protein', 159, NULL, NULL, 107747);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(107748, '1.25.10.10-FF-002400', NULL, 'Uncharacterized protein', 257, NULL, NULL, 107748),
(107749, '1.10.533.10-FF-000018', NULL, 'Nuclear factor NF-kappa-B p105 subunit isoform 1', 89, NULL, NULL, 107749),
(107750, '2.20.25.10-FF-000076', NULL, 'DNA-directed RNA polymerase subunit', 65, NULL, NULL, 107750),
(107751, '2.60.40.60-FF-000624', NULL, 'Desmocollin 1', 106, NULL, NULL, 107751),
(107752, '3.40.50.1820-FF-001048', NULL, 'Carboxylic ester hydrolase', 482, NULL, NULL, 107752),
(107753, '3.40.50.1480-FF-000030', NULL, NULL, 70, NULL, NULL, 107753),
(107754, '3.30.200.20-FF-000040', NULL, 'Dual specificity mitogen-activated protein kinase kinase', 97, NULL, NULL, 107754),
(107755, '1.10.10.60-FF-000481', NULL, 'Hydrogenase-4 transcriptional activator', 70, NULL, NULL, 107755),
(107756, '3.90.230.10-FF-000008', NULL, 'Proliferation-associated 2G4, b', 272, NULL, NULL, 107756),
(107757, '1.10.530.10-FF-000091', NULL, 'Uncharacterized protein', 153, NULL, NULL, 107757),
(107758, '1.25.40.10-FF-002082', NULL, 'Pentatricopeptide repeat-containing protein At4g02750', 109, NULL, NULL, 107758),
(107759, '1.25.40.10-FF-004026', NULL, 'Uncharacterized protein', 187, NULL, NULL, 107759),
(107760, '1.20.120.1900-FF-000012', NULL, 'Putative gamma-tubulin complex component', 299, NULL, NULL, 107760),
(107761, '2.30.30.40-FF-000372', NULL, 'Elongation factor 2 kinase', 59, NULL, NULL, 107761),
(107762, '3.20.20.410-FF-000001', NULL, 'Protein_of_uncharacterized_function_DUF72_-_putative', 222, NULL, NULL, 107762),
(107763, '3.30.230.10-FF-000061', NULL, 'Galactokinase', 206, NULL, NULL, 107763),
(107764, '1.10.20.10-FF-000354', NULL, NULL, 91, NULL, NULL, 107764),
(107765, '3.30.1640.10-FF-000024', NULL, 'DNA helicase', 100, NULL, NULL, 107765),
(107766, '1.10.730.10-FF-000055', NULL, 'Methionine--tRNA ligase', 161, NULL, NULL, 107766),
(107767, '1.20.1270.20-FF-000002', NULL, 'Hydroxylamine reductase', 144, NULL, NULL, 107767),
(107768, '2.40.33.40-FF-000001', NULL, 'PTS system, glucitol/sorbitol-specific, IIA component', 121, NULL, NULL, 107768),
(107769, '1.20.920.10-FF-000197', NULL, 'Uncharacterized protein', 131, NULL, NULL, 107769),
(107770, '1.20.1070.10-FF-001119', NULL, 'Tachykinin-like peptides receptor 86C', 307, NULL, NULL, 107770),
(107771, '1.20.1560.10-FF-000100', NULL, 'ABC transporter ATP-binding protein', 340, NULL, NULL, 107771),
(107772, '1.10.238.10-FF-000591', NULL, 'Uncharacterized protein', 75, NULL, NULL, 107772),
(107773, '3.20.20.80-FF-000589', NULL, 'Predicted protein', 213, NULL, NULL, 107773),
(107774, '3.30.1360.120-FF-000036', NULL, 'Putative transferase CAF17, mitochondrial', 320, NULL, NULL, 107774),
(107775, '1.10.510.10-FF-000853', NULL, 'Related to ARK1-Actin Regulating Kinase', 316, NULL, NULL, 107775),
(107776, '3.40.50.300-FF-007962', NULL, 'Uncharacterized protein', 166, NULL, NULL, 107776),
(107777, '3.40.630.10-FF-000246', NULL, 'Metal-dependent amidase/aminoacylase/carboxypeptidase', 241, NULL, NULL, 107777),
(107778, '2.160.10.10-FF-000131', NULL, 'Acetyltransferase CysE/LacA/LpxA/NodL family', 118, NULL, NULL, 107778),
(107779, '2.40.10.10-FF-000215', NULL, 'Trypsin domain-containing 1', 82, NULL, NULL, 107779),
(107780, '2.60.120.330-FF-000176', NULL, 'Uncharacterized protein', 235, NULL, NULL, 107780),
(107781, '3.90.70.10-FF-000169', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 397, NULL, NULL, 107781),
(107782, '3.40.50.1820-FF-001576', NULL, 'Acetylcholinesterase, putative', 105, NULL, NULL, 107782),
(107783, '3.40.50.1980-FF-000073', NULL, 'ABC transporter substrate-binding protein', 139, NULL, NULL, 107783),
(107784, '3.10.10.10-FF-000034', NULL, NULL, 116, NULL, NULL, 107784),
(107785, '3.30.110.20-FF-000010', NULL, 'Uncharacterized protein, isoform A', 94, NULL, NULL, 107785),
(107786, '3.30.160.60-FF-006359', NULL, NULL, 42, NULL, NULL, 107786),
(107787, '3.30.1010.10-FF-000072', NULL, 'Phosphatidylinositol 3-kinase', 74, NULL, NULL, 107787),
(107788, '4.10.60.10-FF-000254', NULL, 'Uncharacterized protein', 46, NULL, NULL, 107788),
(107789, '1.20.930.80-FF-000004', NULL, 'DNA primase large subunit', 266, NULL, NULL, 107789);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(107790, '1.20.120.1750-FF-000129', NULL, 'RBR-type E3 ubiquitin transferase', 87, NULL, NULL, 107790),
(107791, '3.40.190.10-FF-000420', NULL, 'LysR family transcriptional regulator', 106, NULL, NULL, 107791),
(107792, '3.30.110.30-FF-000013', NULL, 'Anticodon binding domain containing protein', 78, NULL, NULL, 107792),
(107793, '3.30.40.10-FF-001923', NULL, 'RING/U-box superfamily protein', 71, NULL, NULL, 107793),
(107794, '3.30.70.330-FF-001794', NULL, NULL, 150, NULL, NULL, 107794),
(107795, '1.20.930.70-FF-000001', NULL, 'Fatty acid synthase beta subunit dehydratase', 119, NULL, NULL, 107795),
(107796, '2.60.40.1760-FF-000020', NULL, NULL, 128, NULL, NULL, 107796),
(107797, '3.40.50.1000-FF-000066', NULL, 'Phosphomannomutase', 131, NULL, NULL, 107797),
(107798, '3.30.1370.10-FF-000121', NULL, 'Meiotic recombination 1 protein', 80, NULL, NULL, 107798),
(107799, '1.25.40.990-FF-000010', NULL, 'Leukocyte receptor cluster member', 231, NULL, NULL, 107799),
(107800, '3.40.47.10-FF-000213', NULL, NULL, 306, NULL, NULL, 107800),
(107801, '1.25.40.10-FF-002424', NULL, 'Pentatricopeptide repeat-containing protein At1g09410, mitochondrial', 105, NULL, NULL, 107801),
(107802, '1.25.40.10-FF-000283', NULL, 'Intraflagellar transport 88', 209, NULL, NULL, 107802),
(107803, '3.40.50.300-FF-000363', NULL, 'Secretion related GTPase srgA', 200, NULL, NULL, 107803),
(107804, '1.50.10.10-FF-000189', NULL, 'Predicted protein', 281, NULL, NULL, 107804),
(107805, '3.40.47.10-FF-000123', NULL, 'Putative hydroxymethylglutaryl-CoA synthase', 460, NULL, NULL, 107805),
(107806, '3.90.550.10-FF-000717', NULL, 'Uncharacterized protein', 263, NULL, NULL, 107806),
(107807, '1.20.144.10-FF-000090', NULL, 'Lipid A 1-phosphatase', 105, NULL, NULL, 107807),
(107808, '3.30.200.20-FF-000455', NULL, 'Non-specific serine/threonine protein kinase', 105, NULL, NULL, 107808),
(107809, '3.10.110.10-FF-000141', NULL, 'Ubiquitin-conjugating enzyme E2 8', 147, NULL, NULL, 107809),
(107810, '1.20.1070.10-FF-001451', NULL, 'Predicted protein', 219, NULL, NULL, 107810),
(107811, '1.25.40.10-FF-000625', NULL, 'Tetratricopeptide repeat protein 30A', 100, NULL, NULL, 107811),
(107812, '2.130.10.10-FF-002436', NULL, 'dmX-like protein 1', 185, NULL, NULL, 107812),
(107813, '2.130.10.10-FF-001110', NULL, 'Dynein intermediate chain 2, ciliary', 232, NULL, NULL, 107813),
(107814, '2.60.40.10-FF-000525', NULL, 'neurofascin isoform X2', 98, NULL, NULL, 107814),
(107815, '1.25.40.20-FF-000286', NULL, 'Uncharacterized protein, isoform B', 199, NULL, NULL, 107815),
(107816, '3.30.40.10-FF-001468', NULL, 'Uncharacterized protein, isoform C', 92, NULL, NULL, 107816),
(107817, '1.25.10.10-FF-000146', NULL, 'putative MO25-like protein At5g47540', 332, NULL, NULL, 107817),
(107818, '1.25.10.10-FF-000601', NULL, 'Serine/threonine-protein kinase TOR', 299, NULL, NULL, 107818),
(107819, '3.40.50.2300-FF-000220', NULL, 'Glutamate receptor, ionotropic, delta 1', 112, NULL, NULL, 107819),
(107820, '3.30.60.30-FF-000149', NULL, 'Uncharacterized protein', 58, NULL, NULL, 107820),
(107821, '3.10.20.90-FF-000749', NULL, 'Uncharacterized protein', 99, NULL, NULL, 107821),
(107822, '1.10.1510.30-FF-000015', NULL, 'Pseudouridylate synthase', 13, NULL, NULL, 107822),
(107823, '1.20.1310.10-FF-000076', NULL, 'Cullin 4A', 34, NULL, NULL, 107823),
(107824, '3.80.10.10-FF-001661', NULL, 'F-box/LRR-repeat protein 6 isoform X1', 102, NULL, NULL, 107824),
(107825, '3.30.60.20-FF-000146', NULL, 'Diacylglycerol kinase gamma', 69, NULL, NULL, 107825),
(107826, '2.10.50.30-FF-000005', NULL, 'Metabotropic glutamate receptor', 77, NULL, NULL, 107826),
(107827, '1.10.3720.10-FF-000076', NULL, 'Peptide ABC transporter, permease protein', 213, NULL, NULL, 107827),
(107828, '3.80.10.10-FF-001419', NULL, 'Leucin rich protein', 309, NULL, NULL, 107828),
(107829, '3.30.40.10-FF-001671', NULL, 'Putative e3 ubiquitin-protein ligase trim71', 81, NULL, NULL, 107829),
(107830, '3.30.590.10-FF-000020', NULL, 'Putative glutamine synthetase', 348, NULL, NULL, 107830),
(107831, '1.20.120.350-FF-000158', NULL, NULL, 121, NULL, NULL, 107831);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(107832, '1.10.472.10-FF-000303', NULL, 'Cyclin', 228, NULL, NULL, 107832),
(107833, '1.10.472.80-FF-000195', NULL, NULL, 153, NULL, NULL, 107833),
(107834, '1.20.1250.20-FF-001327', NULL, 'Uncharacterized protein', 196, NULL, NULL, 107834),
(107835, '1.10.8.710-FF-000022', NULL, NULL, 134, NULL, NULL, 107835),
(107836, '1.10.580.10-FF-000037', NULL, 'Citrate synthase-related protein DDB_G0287281', 242, NULL, NULL, 107836),
(107837, '1.10.510.10-FF-004035', NULL, NULL, 98, NULL, NULL, 107837),
(107838, '2.160.10.10-FF-000041', NULL, 'POSSIBLE TRANSFERASE', 192, NULL, NULL, 107838),
(107839, '2.20.70.10-FF-000236', NULL, 'Uncharacterized protein', 57, NULL, NULL, 107839),
(107840, '3.30.450.30-FF-000050', NULL, 'Dynein, light chain, roadblock-type 1', 46, NULL, NULL, 107840),
(107841, '3.30.200.20-FF-000910', NULL, 'Cysteine-rich receptor-like protein kinase 11', 74, NULL, NULL, 107841),
(107842, '1.10.8.720-FF-000025', NULL, 'Dynein gamma chain, flagellar outer arm', 174, NULL, NULL, 107842),
(107843, '3.60.21.10-FF-000237', NULL, 'Uncharacterized metallophosphoesterase YunD', 278, NULL, NULL, 107843),
(107844, '3.20.20.70-FF-000586', NULL, 'Ferredoxin/NAD(P)H-dependent glutamate synthase, large subunit', 348, NULL, NULL, 107844),
(107845, '3.80.10.10-FF-000947', NULL, 'Si:dkey-286j17.4', 116, NULL, NULL, 107845),
(107846, '3.30.160.60-FF-000632', NULL, 'zinc finger protein 24 isoform X1', 29, NULL, NULL, 107846),
(107847, '1.10.238.10-FF-000259', NULL, 'Polycystin 2 like 1, transient receptor potential cation channel', 78, NULL, NULL, 107847),
(107848, '1.10.10.790-FF-000044', NULL, NULL, 56, NULL, NULL, 107848),
(107849, '2.60.40.10-FF-006056', NULL, NULL, 108, NULL, NULL, 107849),
(107850, '1.25.10.10-FF-002276', NULL, 'Uncharacterized protein', 336, NULL, NULL, 107850),
(107851, '1.20.1250.20-FF-001075', NULL, 'MFS general substrate transporter', 211, NULL, NULL, 107851),
(107852, '3.40.50.2300-FF-000017', NULL, 'PTS sugar transporter subunit IIB', 100, NULL, NULL, 107852),
(107853, '1.25.40.20-FF-000628', NULL, 'Uncharacterized protein, isoform D', 236, NULL, NULL, 107853),
(107854, '2.30.30.40-FF-000169', NULL, 'Mitogen-activated protein kinase kinase kinase', 70, NULL, NULL, 107854),
(107855, '3.30.70.330-FF-002412', NULL, NULL, 92, NULL, NULL, 107855),
(107856, '3.80.10.10-FF-003549', NULL, 'Uncharacterized protein', 156, NULL, NULL, 107856),
(107857, '2.40.50.100-FF-000166', NULL, 'HAE1 family effllux pump MFP component', 69, NULL, NULL, 107857),
(107858, '3.30.420.10-FF-000486', NULL, NULL, 71, NULL, NULL, 107858),
(107859, '3.30.450.40-FF-000053', NULL, 'IclR family transcriptional regulator', 180, NULL, NULL, 107859),
(107860, '3.90.70.10-FF-000714', NULL, 'Predicted protein', 200, NULL, NULL, 107860),
(107861, '3.30.360.10-FF-000065', NULL, '4-hydroxy-tetrahydrodipicolinate reductase', 35, NULL, NULL, 107861),
(107862, '3.80.10.10-FF-000115', NULL, 'leucine-rich repeat protein SHOC-2', 144, NULL, NULL, 107862),
(107863, '3.30.565.10-FF-000254', NULL, 'Sensor protein', 149, NULL, NULL, 107863),
(107864, '1.20.1300.10-FF-000008', NULL, 'Succinate dehydrogenase cytochrome b560 subunit', 141, NULL, NULL, 107864),
(107865, '3.30.160.60-FF-000429', NULL, 'Zinc finger homeobox protein 3', 72, NULL, NULL, 107865),
(107866, '3.30.1490.20-FF-000088', NULL, 'D-alanine--D-alanine ligase', 60, NULL, NULL, 107866),
(107867, '3.40.50.450-FF-000048', NULL, 'Ysine decarboxylase-like protein', 195, NULL, NULL, 107867),
(107868, '2.130.10.10-FF-004235', NULL, 'Uncharacterized protein', 144, NULL, NULL, 107868),
(107869, '3.40.50.300-FF-004634', NULL, 'Chloroplast SRP receptor', 218, NULL, NULL, 107869),
(107870, '3.30.1370.10-FF-000031', NULL, 'ankyrin repeat domain-containing protein 17 isoform X1', 73, NULL, NULL, 107870),
(107871, '3.30.860.10-FF-000013', NULL, 'Predicted protein', 120, NULL, NULL, 107871),
(107872, '2.40.70.10-FF-000180', NULL, 'Aspartyl protease AED1', 166, NULL, NULL, 107872),
(107873, '1.10.510.10-FF-000763', NULL, 'Os01g0748600 protein', 293, NULL, NULL, 107873),
(107874, '1.10.10.390-FF-000008', NULL, 'Histone acetyltransferase type B catalytic subunit', 51, NULL, NULL, 107874);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(107875, '2.60.11.10-FF-000014', NULL, 'Uncharacterized protein', 90, NULL, NULL, 107875),
(107876, '3.30.160.60-FF-000519', NULL, 'Zinc finger protein 470', 28, NULL, NULL, 107876),
(107877, '3.90.79.10-FF-000150', NULL, 'Nudix hydrolase, putative', 138, NULL, NULL, 107877),
(107878, '3.40.525.10-FF-000007', NULL, 'rho GTPase-activating protein 1', 151, NULL, NULL, 107878),
(107879, '3.40.50.10050-FF-000014', NULL, 'Translation initiation factor IF-2', 107, NULL, NULL, 107879),
(107880, '3.40.50.1000-FF-000627', NULL, NULL, 146, NULL, NULL, 107880),
(107881, '3.30.200.20-FF-000236', NULL, 'Non-specific serine/threonine protein kinase', 93, NULL, NULL, 107881),
(107882, '3.30.420.80-FF-000012', NULL, '30S ribosomal protein S11', 134, NULL, NULL, 107882),
(107883, '3.40.605.10-FF-000065', NULL, 'Uncharacterized protein', 122, NULL, NULL, 107883),
(107884, '3.10.50.10-FF-000031', NULL, 'Chitinase, putative', 75, NULL, NULL, 107884),
(107885, '3.40.1380.20-FF-000038', NULL, 'Pyruvate kinase', 72, NULL, NULL, 107885),
(107886, '3.30.160.60-FF-000177', NULL, 'Zinc finger protein 512', 84, NULL, NULL, 107886),
(107887, '2.70.40.10-FF-000007', NULL, 'dUTP pyrophosphatase', 145, NULL, NULL, 107887),
(107888, '3.50.50.60-FF-000134', NULL, 'FAD-dependent oxidoreductase domain-containing protein 2', 231, NULL, NULL, 107888),
(107889, '3.40.50.2300-FF-000107', NULL, 'Aerobic respiration control sensor protein', 142, NULL, NULL, 107889),
(107890, '1.20.1440.180-FF-000006', NULL, 'Serine/threonine-protein kinase/endoribonuclease IRE1', 139, NULL, NULL, 107890),
(107891, '3.40.50.1820-FF-000885', NULL, 'Predicted protein', 252, NULL, NULL, 107891),
(107892, '3.40.50.720-FF-000005', NULL, 'calcium-activated potassium channel subunit alpha-1 isoform X6', 137, NULL, NULL, 107892),
(107893, '2.60.40.60-FF-000534', NULL, 'Uncharacterized protein', 114, NULL, NULL, 107893),
(107894, '1.10.287.30-FF-000002', NULL, 'Regulatory protein E2', 100, NULL, NULL, 107894),
(107895, '3.90.100.10-FF-000004', NULL, 'Lysine decarboxylase, constitutive', 121, NULL, NULL, 107895),
(107896, '1.20.58.2220-FF-000049', NULL, 'Uncharacterized protein', 214, NULL, NULL, 107896),
(107897, '1.25.40.10-FF-003969', NULL, 'Uncharacterized protein', 232, NULL, NULL, 107897),
(107898, '1.20.58.390-FF-000047', NULL, 'Resistance to dieldrin, isoform H', 63, NULL, NULL, 107898),
(107899, '3.40.50.1390-FF-000025', NULL, 'Bll5010 protein', 147, NULL, NULL, 107899),
(107900, '1.20.1160.11-FF-000003', NULL, 'Paired amphipathic helix SIN3-like protein', 72, NULL, NULL, 107900),
(107901, '2.30.29.30-FF-001169', NULL, 'PH domain containing protein', 97, NULL, NULL, 107901),
(107902, '3.40.50.150-FF-000604', NULL, 'NOL1/NOP2/sun family, putative', 350, NULL, NULL, 107902),
(107903, '1.10.560.10-FF-000148', NULL, 'Chaperonin-containing TCP1, subunit 6A (zeta 1)', 14, NULL, NULL, 107903),
(107904, '2.40.70.10-FF-000090', NULL, 'Aspartyl protease family protein', 183, NULL, NULL, 107904),
(107905, '1.10.10.370-FF-000002', NULL, 'Sulfurtransferase', 71, NULL, NULL, 107905),
(107906, '2.60.120.620-FF-000139', NULL, 'Predicted protein', 231, NULL, NULL, 107906),
(107907, '3.30.70.360-FF-000010', NULL, 'M20/M25/M40 family metallo-hydrolase', 96, NULL, NULL, 107907),
(107908, '3.40.1380.10-FF-000035', NULL, 'Uncharacterized protein', 64, NULL, NULL, 107908),
(107909, '2.30.180.10-FF-000083', NULL, 'FAS1 domain-containing protein', 174, NULL, NULL, 107909),
(107910, '3.40.30.10-FF-000938', NULL, 'Glutathione peroxidase', 198, NULL, NULL, 107910),
(107911, '3.30.30.10-FF-000006', NULL, 'Defensin DFS2', 31, NULL, NULL, 107911),
(107912, '1.20.1250.20-FF-001417', NULL, 'Siderophore iron transporter mirC', 253, NULL, NULL, 107912),
(107913, '2.30.30.40-FF-000282', NULL, 'Intersectin 2', 89, NULL, NULL, 107913),
(107914, '3.30.70.370-FF-000013', NULL, 'DNA-directed DNA polymerase', 170, NULL, NULL, 107914),
(107915, '3.30.160.60-FF-004561', NULL, NULL, 43, NULL, NULL, 107915),
(107916, '3.90.660.20-FF-000026', NULL, 'Uncharacterized protein', 61, NULL, NULL, 107916);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(107917, '1.20.58.900-FF-000020', NULL, 'RUN Domain containing protein', 239, NULL, NULL, 107917),
(107918, '2.70.130.10-FF-000060', NULL, NULL, 154, NULL, NULL, 107918),
(107919, '1.10.10.10-FF-002074', NULL, 'Fe(III)-induced transcriptional regulator IfcR', 79, NULL, NULL, 107919),
(107920, '2.60.40.1510-FF-000052', NULL, 'Integrin beta', 79, NULL, NULL, 107920),
(107921, '3.20.140.10-FF-000005', NULL, 'Nicotinate phosphoribosyltransferase', 163, NULL, NULL, 107921),
(107922, '1.10.167.10-FF-000066', NULL, 'Protein rax1', 102, NULL, NULL, 107922),
(107923, '3.90.70.10-FF-000624', NULL, 'Uncharacterized protein', 134, NULL, NULL, 107923),
(107924, '2.10.25.10-FF-000846', NULL, 'Vitamin K-dependent protein S', 40, NULL, NULL, 107924),
(107925, '1.25.40.20-FF-000538', NULL, 'E3 ubiquitin-protein ligase HACE1 isoform X3', 147, NULL, NULL, 107925),
(107926, '1.10.287.110-FF-000083', NULL, 'DnaJ and TPR domain protein', 115, NULL, NULL, 107926),
(107927, '1.10.340.30-FF-000014', NULL, 'Endonuclease III homolog', 107, NULL, NULL, 107927),
(107928, '3.40.50.300-FF-004724', NULL, 'Uncharacterized protein', 97, NULL, NULL, 107928),
(107929, '2.60.120.620-FF-000049', NULL, 'L-isoleucine-4-hydroxylase', 236, NULL, NULL, 107929),
(107930, '2.115.10.20-FF-000024', NULL, 'Levanase', 305, NULL, NULL, 107930),
(107931, '1.10.3260.10-FF-000052', NULL, 'DNA ligase', 91, NULL, NULL, 107931),
(107932, '3.40.50.1380-FF-000022', NULL, 'Phosphoribosylamine-glycine ligase', 96, NULL, NULL, 107932),
(107933, '2.120.10.80-FF-000030', NULL, 'Multiple epidermal growth factor-like domains 8', 185, NULL, NULL, 107933),
(107934, '2.30.30.40-FF-000591', NULL, 'Rho GTPase-activating protein gacII', 62, NULL, NULL, 107934),
(107935, '3.40.50.10190-FF-000186', NULL, 'Uncharacterized protein', 87, NULL, NULL, 107935),
(107936, '1.10.287.1490-FF-000025', NULL, 'golgin subfamily A member 3', 172, NULL, NULL, 107936),
(107937, '1.25.40.10-FF-000535', NULL, 'Os03g0786900 protein', 227, NULL, NULL, 107937),
(107938, '3.80.10.10-FF-001751', NULL, 'centriolin isoform X2', 171, NULL, NULL, 107938),
(107939, '3.40.50.1100-FF-000293', NULL, 'Predicted protein', 86, NULL, NULL, 107939),
(107940, '2.40.70.10-FF-000409', NULL, NULL, 100, NULL, NULL, 107940),
(107941, '1.10.10.1590-FF-000003', NULL, 'NADH dehydrogenase I, E subunit', 62, NULL, NULL, 107941),
(107942, '3.30.565.10-FF-000035', NULL, 'MORC family CW-type zinc finger protein 4', 198, NULL, NULL, 107942),
(107943, '3.90.226.10-FF-000009', NULL, 'Carnitinyl-CoA dehydratase', 201, NULL, NULL, 107943),
(107944, '3.30.160.60-FF-004229', NULL, NULL, 28, NULL, NULL, 107944),
(107945, '1.10.510.10-FF-004254', NULL, NULL, 192, NULL, NULL, 107945),
(107946, '3.40.50.300-FF-004415', NULL, 'ABC transporter family protein', 291, NULL, NULL, 107946),
(107947, '3.80.10.10-FF-001442', NULL, 'Nischarin', 85, NULL, NULL, 107947),
(107948, '3.90.260.10-FF-000055', NULL, 'Uncharacterized protein', 79, NULL, NULL, 107948),
(107949, '3.30.160.60-FF-004471', NULL, NULL, 20, NULL, NULL, 107949),
(107950, '1.25.40.20-FF-000847', NULL, 'ankyrin repeat domain-containing protein 27-like isoform X2', 199, NULL, NULL, 107950),
(107951, '1.10.10.440-FF-000068', NULL, 'Rho GTPase-activating protein 5', 70, NULL, NULL, 107951),
(107952, '3.40.50.1820-FF-001138', NULL, 'Lipase 1, putative', 96, NULL, NULL, 107952),
(107953, '1.10.510.10-FF-000292', NULL, 'Serine/threonine-protein kinase 36', 317, NULL, NULL, 107953),
(107954, '4.10.400.10-FF-000238', NULL, 'LDL receptor related protein 1B', 29, NULL, NULL, 107954),
(107955, '1.10.3210.10-FF-000116', NULL, 'Uncharacterized protein', 102, NULL, NULL, 107955),
(107956, '1.10.510.10-FF-003978', NULL, NULL, 330, NULL, NULL, 107956),
(107957, '1.20.144.10-FF-000123', NULL, 'Uncharacterized protein', 189, NULL, NULL, 107957),
(107958, '3.40.50.300-FF-007849', NULL, 'Dynein heavy chain family protein', 225, NULL, NULL, 107958),
(107959, '1.25.10.10-FF-000236', NULL, 'Vacuolar protein 8, variant', 191, NULL, NULL, 107959),
(107960, '3.30.70.3490-FF-000045', NULL, NULL, 124, NULL, NULL, 107960);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(107961, '1.20.140.150-FF-000107', NULL, 'Voltage-dependent calcium channel gamma-5 subunit-like Protein', 171, NULL, NULL, 107961),
(107962, '3.40.190.10-FF-000330', NULL, 'Ionotropic receptor IR6', 38, NULL, NULL, 107962),
(107963, '1.10.238.10-FF-000282', NULL, 'Endoplasmic reticulum-resident calcium binding protein', 77, NULL, NULL, 107963),
(107964, '3.40.30.10-FF-001181', NULL, 'Glutathione S-transferase, putative', 81, NULL, NULL, 107964),
(107965, '2.60.40.60-FF-000282', NULL, 'Cadherin 96Cb, isoform B', 104, NULL, NULL, 107965),
(107966, '4.10.640.10-FF-000019', NULL, 'Mitochondrial ribosomal protein S18', 56, NULL, NULL, 107966),
(107967, '1.20.120.350-FF-000175', NULL, NULL, 154, NULL, NULL, 107967),
(107968, '1.25.10.10-FF-000910', NULL, 'DNA repair/transcription protein, putative', 351, NULL, NULL, 107968),
(107969, '3.60.15.10-FF-000037', NULL, 'tRNAse Z4', 326, NULL, NULL, 107969),
(107970, '3.10.20.90-FF-000772', NULL, 'Ubiquitin carboxyl-terminal hydrolase 32', 84, NULL, NULL, 107970),
(107971, '1.20.5.340-FF-000072', NULL, 'Tropomyosin 2', 44, NULL, NULL, 107971),
(107972, '1.25.10.10-FF-000359', NULL, 'Protein-associating with the carboxyl-terminal domain of ezrin', 183, NULL, NULL, 107972),
(107973, '3.40.50.11710-FF-000001', NULL, 'Cyclo(L-leucyl-L-leucyl) synthase', 230, NULL, NULL, 107973),
(107974, '2.60.40.10-FF-000536', NULL, 'Hyaluronan and proteoglycan link protein 4', 120, NULL, NULL, 107974),
(107975, '2.40.30.130-FF-000042', NULL, 'Alanyl-tRNA synthetase family protein', 109, NULL, NULL, 107975),
(107976, '3.90.1170.20-FF-000016', NULL, 'Quinolinate phosphoribosyltransferase', 92, NULL, NULL, 107976),
(107977, '2.60.120.620-FF-000038', NULL, 'YJR154W-like protein', 281, NULL, NULL, 107977),
(107978, '2.70.170.10-FF-000045', NULL, 'Predicted protein', 183, NULL, NULL, 107978),
(107979, '3.30.530.20-FF-000025', NULL, 'Phosphatidylinositol transfer protein beta', 272, NULL, NULL, 107979),
(107980, '3.80.10.10-FF-003336', NULL, 'Uncharacterized protein', 122, NULL, NULL, 107980),
(107981, '2.60.120.260-FF-000334', NULL, 'LOC51668 protein, putative', 132, NULL, NULL, 107981),
(107982, '3.90.1170.10-FF-000013', NULL, 'Mitochondrial Ribosomal Protein, Large', 175, NULL, NULL, 107982),
(107983, '2.60.120.690-FF-000002', NULL, 'Proprotein convertase subtilisin/kexin type 9', 77, NULL, NULL, 107983),
(107984, '3.40.50.150-FF-000609', NULL, 'Putative nucleolar protein', 295, NULL, NULL, 107984),
(107985, '3.40.50.2300-FF-001535', NULL, NULL, 63, NULL, NULL, 107985),
(107986, '1.20.1690.10-FF-000008', NULL, 'V-type proton ATPase subunit', 116, NULL, NULL, 107986),
(107987, '1.20.120.530-FF-000010', NULL, 'Glc operon transcriptional activator', 141, NULL, NULL, 107987),
(107988, '3.10.105.10-FF-000056', NULL, 'ABC transporter substrate-binding protein', 220, NULL, NULL, 107988),
(107989, '3.30.70.330-FF-000501', NULL, 'Os04g0682400 protein', 112, NULL, NULL, 107989),
(107990, '1.10.4100.10-FF-000001', NULL, '2-methylcitrate dehydratase', 314, NULL, NULL, 107990),
(107991, '1.10.510.10-FF-004237', NULL, NULL, 202, NULL, NULL, 107991),
(107992, '1.10.418.10-FF-000150', NULL, 'Ras GTPase-activating-like protein, IQGAP family member, putative', 152, NULL, NULL, 107992),
(107993, '2.30.29.30-FF-001377', NULL, 'Uncharacterized protein', 123, NULL, NULL, 107993),
(107994, '3.90.1110.10-FF-000004', NULL, 'DNA-directed RNA polymerase subunit beta', 108, NULL, NULL, 107994),
(107995, '3.10.350.10-FF-000001', NULL, 'Peptidoglycan-binding protein LysM', 54, NULL, NULL, 107995),
(107996, '3.30.830.10-FF-000281', NULL, 'Uncharacterized protein', 215, NULL, NULL, 107996),
(107997, '1.25.40.10-FF-002536', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 258, NULL, NULL, 107997),
(107998, '3.40.850.10-FF-000105', NULL, 'Kinesin-like protein', 390, NULL, NULL, 107998),
(107999, '3.30.420.10-FF-000469', NULL, NULL, 212, NULL, NULL, 107999),
(108000, '3.40.50.300-FF-008451', NULL, 'Predicted protein', 58, NULL, NULL, 108000),
(108001, '1.20.1070.10-FF-001428', NULL, 'Uncharacterized protein', 226, NULL, NULL, 108001);
INSERT INTO "PUBLIC"."MODEL" VALUES
(108002, '3.10.450.10-FF-000048', NULL, 'AGAP002879-PB', 66, NULL, NULL, 108002),
(108003, '2.60.120.10-FF-000825', NULL, 'Uncharacterized protein', 60, NULL, NULL, 108003),
(108004, '2.40.160.60-FF-000009', NULL, 'Outer membrane protein P1', 434, NULL, NULL, 108004),
(108005, '3.40.50.300-FF-004073', NULL, 'UvrD/REP helicase N-terminal domain protein', 153, NULL, NULL, 108005),
(108006, '2.130.10.10-FF-000514', NULL, 'TORC1 growth control complex subunit Kog1', 135, NULL, NULL, 108006),
(108007, '3.40.930.10-FF-000062', NULL, NULL, 80, NULL, NULL, 108007),
(108008, '2.130.10.10-FF-005399', NULL, 'Uncharacterized protein', 147, NULL, NULL, 108008),
(108009, '2.30.30.1150-FF-000001', NULL, 'E3 ubiquitin-protein ligase UHRF2 isoform X1', 162, NULL, NULL, 108009),
(108010, '2.60.40.60-FF-001012', NULL, 'Protein CBR-CDH-7', 92, NULL, NULL, 108010),
(108011, '3.30.559.10-FF-000200', NULL, 'Predicted protein', 85, NULL, NULL, 108011),
(108012, '2.30.42.10-FF-000261', NULL, 'general receptor for phosphoinositides 1-associated scaffold protein isoform X2', 58, NULL, NULL, 108012),
(108013, '1.10.510.10-FF-000538', NULL, 'Casein kinase 1', 322, NULL, NULL, 108013),
(108014, '3.30.200.20-FF-000253', NULL, 'tribbles homolog 2', 82, NULL, NULL, 108014),
(108015, '1.20.120.1200-FF-000004', NULL, 'NADH-quinone oxidoreductase subunit J', 161, NULL, NULL, 108015),
(108016, '1.10.630.10-FF-000699', NULL, 'Uncharacterized protein', 130, NULL, NULL, 108016),
(108017, '3.20.80.10-FF-000038', NULL, 'Uncharacterized protein', 116, NULL, NULL, 108017),
(108018, '1.20.58.80-FF-000074', NULL, 'Katanin p60 ATPase-containing subunit A1', 72, NULL, NULL, 108018),
(108019, '2.20.70.10-FF-000130', NULL, 'Pre-mRNA-splicing factor dre4', 45, NULL, NULL, 108019),
(108020, '1.20.210.10-FF-000002', NULL, 'Cytochrome o ubiquinol oxidase, subunit I', 501, NULL, NULL, 108020),
(108021, '1.10.10.10-FF-000842', NULL, 'Sst2p', 94, NULL, NULL, 108021),
(108022, '3.40.50.300-FF-008546', NULL, 'Probable ribosome biogenesis GTPase A', 164, NULL, NULL, 108022),
(108023, '1.25.10.10-FF-002613', NULL, 'Predicted protein', 138, NULL, NULL, 108023),
(108024, '1.10.506.10-FF-000080', NULL, 'Uncharacterized protein', 171, NULL, NULL, 108024),
(108025, '3.90.1100.10-FF-000065', NULL, 'Uncharacterized protein', 102, NULL, NULL, 108025),
(108026, '3.40.395.10-FF-000047', NULL, 'Battenin', 177, NULL, NULL, 108026),
(108027, '1.10.30.10-FF-000063', NULL, 'High mobility group protein B3', 84, NULL, NULL, 108027),
(108028, '3.30.450.40-FF-000305', NULL, 'Putative signaling protein', 176, NULL, NULL, 108028),
(108029, '3.40.50.150-FF-000514', NULL, 'Rhamnosyl O-methyltransferase', 166, NULL, NULL, 108029),
(108030, '1.20.58.70-FF-000071', NULL, 'Putative second mitochondria-derived activator of caspase', 176, NULL, NULL, 108030),
(108031, '3.90.70.10-FF-000512', NULL, 'Predicted protein', 104, NULL, NULL, 108031),
(108032, '2.40.50.140-FF-000352', NULL, 'CST complex subunit STN1', 159, NULL, NULL, 108032),
(108033, '1.25.40.10-FF-002115', NULL, 'Pentatricopeptide repeat-containing protein At1g62720', 159, NULL, NULL, 108033),
(108034, '2.60.40.10-FF-004914', NULL, NULL, 110, NULL, NULL, 108034),
(108035, '3.40.50.880-FF-000154', NULL, 'Putative glutamine amidotransferase GAT1_2.1', 276, NULL, NULL, 108035),
(108036, '3.40.50.1000-FF-000616', NULL, NULL, 120, NULL, NULL, 108036),
(108037, '1.10.8.270-FF-000053', NULL, 'TBC domain containing protein', 88, NULL, NULL, 108037),
(108038, '1.20.1600.10-FF-000065', NULL, 'Uncharacterized protein', 376, NULL, NULL, 108038),
(108039, '2.60.40.60-FF-000074', NULL, 'Desmoglein 4', 104, NULL, NULL, 108039),
(108040, '3.20.20.70-FF-000575', NULL, NULL, 87, NULL, NULL, 108040),
(108041, '3.30.200.20-FF-001776', NULL, 'Tyrosine-protein kinase-like otk', 82, NULL, NULL, 108041),
(108042, '3.40.50.1000-FF-000830', NULL, NULL, 82, NULL, NULL, 108042),
(108043, '1.10.10.60-FF-000166', NULL, 'homeobox protein Hox-C11', 100, NULL, NULL, 108043),
(108044, '3.30.160.60-FF-006376', NULL, NULL, 76, NULL, NULL, 108044),
(108045, '1.10.472.10-FF-000292', NULL, 'Uncharacterized protein', 106, NULL, NULL, 108045);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(108046, '3.10.129.10-FF-000150', NULL, 'Acyl-CoA thioesterase', 130, NULL, NULL, 108046),
(108047, '3.40.50.300-FF-004168', NULL, 'Uncharacterized protein', 281, NULL, NULL, 108047),
(108048, '3.40.50.300-FF-000469', NULL, 'MAGUK p55 subfamily member 5', 208, NULL, NULL, 108048),
(108049, '1.10.510.10-FF-004142', NULL, NULL, 61, NULL, NULL, 108049),
(108050, '3.40.1500.10-FF-000017', NULL, 'Uncharacterized protein', 323, NULL, NULL, 108050),
(108051, '2.120.10.80-FF-000344', NULL, 'Multiple EGF-like-domains 8', 104, NULL, NULL, 108051),
(108052, '1.10.10.1540-FF-000005', NULL, 'Uncharacterized protein, isoform B', 86, NULL, NULL, 108052),
(108053, '3.40.140.10-FF-000254', NULL, 'Cytidine deaminase', 130, NULL, NULL, 108053),
(108054, '1.25.40.10-FF-000412', NULL, 'Putative pentatricopeptide repeat-containing protein', 129, NULL, NULL, 108054),
(108055, '3.40.50.2000-FF-000124', NULL, 'Glycosyltransferase', 190, NULL, NULL, 108055),
(108056, '2.130.10.10-FF-000177', NULL, 'WD repeat domain 3', 208, NULL, NULL, 108056),
(108057, '1.20.1250.20-FF-000006', NULL, 'MFS transporter', 203, NULL, NULL, 108057),
(108058, '1.20.1070.10-FF-001333', NULL, 'Uncharacterized protein', 277, NULL, NULL, 108058),
(108059, '3.30.1390.10-FF-000015', NULL, '60S ribosomal protein L7/L12, putative', 42, NULL, NULL, 108059),
(108060, '3.90.70.10-FF-000607', NULL, 'Uncharacterized protein', 175, NULL, NULL, 108060),
(108061, '1.10.238.10-FF-000731', NULL, '45 kDa calcium-binding protein', 82, NULL, NULL, 108061),
(108062, '3.10.150.10-FF-000020', NULL, 'Beta sliding clamp', 130, NULL, NULL, 108062),
(108063, '2.40.50.740-FF-000009', NULL, '30S ribosomal protein S4e', 55, NULL, NULL, 108063),
(108064, '3.90.930.12-FF-000030', NULL, NULL, 85, NULL, NULL, 108064),
(108065, '1.10.287.70-FF-000002', NULL, 'Potassium voltage-gated channel subfamily a member', 111, NULL, NULL, 108065),
(108066, '3.40.50.300-FF-001200', NULL, 'Conjugal transfer protein TraB', 193, NULL, NULL, 108066),
(108067, '3.30.565.10-FF-000260', NULL, 'Histidine kinase sensor protein', 147, NULL, NULL, 108067),
(108068, '2.60.120.200-FF-000699', NULL, 'Predicted protein', 189, NULL, NULL, 108068),
(108069, '2.30.180.10-FF-000077', NULL, 'Chromosome 1, whole genome shotgun sequence', 142, NULL, NULL, 108069),
(108070, '1.10.287.80-FF-000005', NULL, 'ATP synthase gamma chain', 140, NULL, NULL, 108070),
(108071, '3.90.79.10-FF-000144', NULL, 'MutT/nudix family protein', 145, NULL, NULL, 108071),
(108072, '2.60.40.10-FF-000750', NULL, 'Hemicentin 1', 92, NULL, NULL, 108072),
(108073, '2.60.40.790-FF-000170', NULL, NULL, 100, NULL, NULL, 108073),
(108074, '4.10.860.10-FF-000002', NULL, 'UvrABC system protein C', 37, NULL, NULL, 108074),
(108075, '2.60.40.10-FF-000862', NULL, 'interleukin-12 receptor subunit beta-2 isoform X1', 88, NULL, NULL, 108075),
(108076, '3.10.170.20-FF-000018', NULL, NULL, 145, NULL, NULL, 108076),
(108077, '3.30.1390.20-FF-000018', NULL, 'LSU ribosomal protein L7', 94, NULL, NULL, 108077),
(108078, '3.30.70.330-FF-002160', NULL, NULL, 105, NULL, NULL, 108078),
(108079, '2.40.50.730-FF-000006', NULL, 'DNA polymerase', 94, NULL, NULL, 108079),
(108080, '3.30.40.10-FF-000035', NULL, 'Histone acetyltransferase', 111, NULL, NULL, 108080),
(108081, '4.10.60.10-FF-000153', NULL, 'Cold shock domain-containing protein 3', 61, NULL, NULL, 108081),
(108082, '1.10.3720.10-FF-000060', NULL, 'Inner membrane ABC transporter permease YehY', 211, NULL, NULL, 108082),
(108083, '2.40.30.10-FF-000323', NULL, 'Translation initiation factor IF-2', 96, NULL, NULL, 108083),
(108084, '3.30.1370.10-FF-000132', NULL, 'RNA-binding protein, putative', 96, NULL, NULL, 108084),
(108085, '3.40.50.1000-FF-000279', NULL, 'Phospholipid-transporting ATPase', 189, NULL, NULL, 108085),
(108086, '3.30.420.40-FF-000803', NULL, 'Actin-related protein 3', 67, NULL, NULL, 108086),
(108087, '1.20.950.20-FF-000010', NULL, 'Nitrate reductase NarX', 218, NULL, NULL, 108087),
(108088, '2.30.39.10-FF-000158', NULL, 'Uncharacterized protein', 161, NULL, NULL, 108088),
(108089, '2.120.10.30-FF-000032', NULL, 'Protein STRICTOSIDINE SYNTHASE-LIKE 13', 336, NULL, NULL, 108089);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(108090, '1.10.510.10-FF-003040', NULL, NULL, 216, NULL, NULL, 108090),
(108091, '1.10.357.70-FF-000014', NULL, 'Exocyst complex component, putative', 194, NULL, NULL, 108091),
(108092, '2.60.260.20-FF-000181', NULL, 'Chaperone protein dnaJ 3', 61, NULL, NULL, 108092),
(108093, '3.50.50.60-FF-000140', NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase', 244, NULL, NULL, 108093),
(108094, '3.30.1330.20-FF-000026', NULL, 'Tubulin alpha chain', 115, NULL, NULL, 108094),
(108095, '1.10.287.90-FF-000008', NULL, 'Cytochrome c oxidase subunit 2, putative', 31, NULL, NULL, 108095),
(108096, '3.30.160.60-FF-004673', NULL, NULL, 50, NULL, NULL, 108096),
(108097, '3.30.160.60-FF-002902', NULL, 'KLUmpfuss related', 27, NULL, NULL, 108097),
(108098, '2.40.50.430-FF-000006', NULL, 'DNA polymerase delta small subunit, putative', 126, NULL, NULL, 108098),
(108099, '3.40.50.1820-FF-001155', NULL, 'Predicted protein', 257, NULL, NULL, 108099),
(108100, '1.20.120.1640-FF-000001', NULL, 'Sensory transduction histidine kinase', 144, NULL, NULL, 108100),
(108101, '3.40.50.300-FF-000806', NULL, 'DNA repair protein RAD51 homolog 2', 284, NULL, NULL, 108101),
(108102, '1.25.40.20-FF-000741', NULL, 'Ankyrin repeat domain 6b', 34, NULL, NULL, 108102),
(108103, '1.10.3730.10-FF-000015', NULL, 'Uncharacterized protein', 104, NULL, NULL, 108103),
(108104, '3.90.430.10-FF-000001', NULL, 'Copper fist DNA-binding protein', 42, NULL, NULL, 108104),
(108105, '4.10.860.20-FF-000005', NULL, 'LD29542p', 51, NULL, NULL, 108105),
(108106, '1.10.275.10-FF-000019', NULL, 'Putative mitochondrial-processing peptidase subunit beta mitochondrial', 78, NULL, NULL, 108106),
(108107, '3.80.10.10-FF-003662', NULL, 'Predicted protein', 87, NULL, NULL, 108107),
(108108, '3.30.1330.60-FF-000009', NULL, 'Flagellar motor protein MotB', 149, NULL, NULL, 108108),
(108109, '3.30.40.10-FF-001137', NULL, 'Vacuolar segregation protein, putative', 85, NULL, NULL, 108109),
(108110, '1.25.40.10-FF-003964', NULL, 'Uncharacterized protein', 244, NULL, NULL, 108110),
(108111, '2.130.10.10-FF-002431', NULL, 'ELP2 isoform 2', 234, NULL, NULL, 108111),
(108112, '1.10.1170.10-FF-000016', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 120, NULL, NULL, 108112),
(108113, '2.30.30.30-FF-000150', NULL, 'Uncharacterized protein', 66, NULL, NULL, 108113),
(108114, '3.40.50.300-FF-006422', NULL, 'Predicted protein', 129, NULL, NULL, 108114),
(108115, '3.30.160.60-FF-005775', NULL, NULL, 60, NULL, NULL, 108115),
(108116, '1.10.510.10-FF-000185', NULL, 'Ribosomal protein S6 kinase', 213, NULL, NULL, 108116),
(108117, '3.10.20.740-FF-000001', NULL, 'NADH-quinone oxidoreductase subunit G', 123, NULL, NULL, 108117),
(108118, '1.20.1310.10-FF-000060', NULL, 'Ubiquitin-protein ligase, putative', 111, NULL, NULL, 108118),
(108119, '3.10.100.10-FF-000067', NULL, 'lymphocyte antigen 75 isoform X1', 138, NULL, NULL, 108119),
(108120, '1.10.8.60-FF-000429', NULL, 'peroxisome biogenesis protein 1-like', 89, NULL, NULL, 108120),
(108121, '2.120.10.80-FF-000018', NULL, 'Muskelin 1', 317, NULL, NULL, 108121),
(108122, '2.160.10.10-FF-000029', NULL, 'Trimeric LpxA-like enzyme', 134, NULL, NULL, 108122),
(108123, '2.60.120.1440-FF-000008', NULL, 'FecR family protein', 135, NULL, NULL, 108123),
(108124, '2.40.10.10-FF-000086', NULL, 'serine protease hepsin', 131, NULL, NULL, 108124),
(108125, '1.25.40.20-FF-001016', NULL, 'Uncharacterized protein', 207, NULL, NULL, 108125),
(108126, '1.10.443.20-FF-000003', NULL, 'Centromere DNA-binding protein complex CBF3 subunit A', 340, NULL, NULL, 108126),
(108127, '3.30.160.60-FF-000648', NULL, 'Zinc finger protein rotund', 25, NULL, NULL, 108127),
(108128, '3.10.50.40-FF-000057', NULL, 'Peptidyl-prolyl cis-trans isomerase', 134, NULL, NULL, 108128),
(108129, '1.10.490.10-FF-000030', NULL, 'Blr4883 protein', 129, NULL, NULL, 108129),
(108130, '1.20.58.670-FF-000029', NULL, NULL, 124, NULL, NULL, 108130),
(108131, '3.40.190.290-FF-000030', NULL, 'LysR family transcriptional regulator', 206, NULL, NULL, 108131);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(108132, '3.30.1330.10-FF-000023', NULL, 'Putative selenophosphate synthetase', 123, NULL, NULL, 108132),
(108133, '1.20.120.30-FF-000001', NULL, 'Methyl-accepting chemotaxis protein II', 170, NULL, NULL, 108133),
(108134, '3.40.50.1000-FF-000504', NULL, NULL, 88, NULL, NULL, 108134),
(108135, '3.60.21.10-FF-000097', NULL, 'Serine/threonine-protein phosphatase', 329, NULL, NULL, 108135),
(108136, '3.10.100.10-FF-000281', NULL, NULL, 162, NULL, NULL, 108136),
(108137, '1.20.1260.140-FF-000009', NULL, NULL, 143, NULL, NULL, 108137),
(108138, '2.60.40.1170-FF-000028', NULL, 'Coatomer subunit delta', 136, NULL, NULL, 108138),
(108139, '3.30.505.10-FF-000267', NULL, NULL, 116, NULL, NULL, 108139),
(108140, '3.80.10.10-FF-003241', NULL, 'Uncharacterized protein', 182, NULL, NULL, 108140),
(108141, '3.40.640.10-FF-000410', NULL, 'Uncharacterized protein', 125, NULL, NULL, 108141),
(108142, '1.10.10.1100-FF-000008', NULL, 'Nitrogen fixation protein NifU', 42, NULL, NULL, 108142),
(108143, '2.130.10.10-FF-000840', NULL, 'Related to CAF4-CCR4 associated factor', 160, NULL, NULL, 108143),
(108144, '3.30.730.10-FF-000003', NULL, 'AP2-like ethylene-responsive transcription factor ANT', 70, NULL, NULL, 108144),
(108145, '3.40.850.10-FF-000010', NULL, 'Kinesin family member 13A', 372, NULL, NULL, 108145),
(108146, '3.40.50.300-FF-006197', NULL, 'Rcorf28', 145, NULL, NULL, 108146),
(108147, '3.40.50.300-FF-006208', NULL, 'Uncharacterized protein', 138, NULL, NULL, 108147),
(108148, '1.20.120.1750-FF-000146', NULL, 'Uncharacterized protein', 101, NULL, NULL, 108148),
(108149, '3.30.70.330-FF-002272', NULL, NULL, 101, NULL, NULL, 108149),
(108150, '3.40.30.10-FF-001074', NULL, 'Glutathione peroxidase', 201, NULL, NULL, 108150),
(108151, '1.20.5.4770-FF-000022', NULL, 'Uncharacterized protein', 52, NULL, NULL, 108151),
(108152, '2.10.220.10-FF-000097', NULL, 'Receptor protein-tyrosine kinase', 57, NULL, NULL, 108152),
(108153, '3.90.1310.10-FF-000002', NULL, 'Peptidoglycan D,D-transpeptidase FtsI', 120, NULL, NULL, 108153),
(108154, '1.20.1280.50-FF-000169', NULL, 'Putative f-box protein 31', 76, NULL, NULL, 108154),
(108155, '3.30.70.980-FF-000005', NULL, 'Probable transcriptional regulatory protein EDB18_6789', 79, NULL, NULL, 108155),
(108156, '3.40.390.10-FF-000300', NULL, NULL, 62, NULL, NULL, 108156),
(108157, '1.25.10.10-FF-002708', NULL, 'Uncharacterized protein', 48, NULL, NULL, 108157),
(108158, '2.130.10.10-FF-002526', NULL, 'Intraflagellar transport 172', 226, NULL, NULL, 108158),
(108159, '3.90.290.10-FF-000012', NULL, 'latent-transforming growth factor beta-binding protein 1 isoform X2', 75, NULL, NULL, 108159),
(108160, '3.90.550.10-FF-000627', NULL, 'Hexosyltransferase', 194, NULL, NULL, 108160),
(108161, '3.40.50.80-FF-000011', NULL, 'Sulfite reductase flavoprotein component', 160, NULL, NULL, 108161),
(108162, '1.10.238.10-FF-000826', NULL, 'Uncharacterized protein', 34, NULL, NULL, 108162),
(108163, '2.130.10.10-FF-001020', NULL, 'Intraflagellar transport protein 122 homolog', 214, NULL, NULL, 108163),
(108164, '2.30.30.40-FF-000153', NULL, 'rho guanine nucleotide exchange factor 26', 61, NULL, NULL, 108164),
(108165, '2.60.120.10-FF-000488', NULL, 'Uncharacterized protein', 106, NULL, NULL, 108165),
(108166, '3.40.50.300-FF-005011', NULL, 'Sulfotransferase', 88, NULL, NULL, 108166),
(108167, '3.30.70.330-FF-000029', NULL, 'U2 small nuclear ribonucleoprotein B''''', 84, NULL, NULL, 108167),
(108168, '3.40.50.300-FF-002156', NULL, 'DNA helicase, putative', 101, NULL, NULL, 108168),
(108169, '2.130.10.10-FF-000391', NULL, 'sterol regulatory element-binding protein cleavage-activating protein-like', 80, NULL, NULL, 108169),
(108170, '1.20.1250.20-FF-001760', NULL, 'Uncharacterized protein (Fragment)', 190, NULL, NULL, 108170),
(108171, '1.10.287.1490-FF-000126', NULL, 'Uncharacterized protein', 147, NULL, NULL, 108171),
(108172, '2.60.40.10-FF-000424', NULL, 'Integrin beta', 132, NULL, NULL, 108172),
(108173, '3.40.50.11030-FF-000011', NULL, NULL, 138, NULL, NULL, 108173),
(108174, '1.20.1070.10-FF-001900', NULL, 'Uncharacterized protein', 288, NULL, NULL, 108174); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(108175, '1.10.1170.10-FF-000033', NULL, 'Apoptosis inhibitor IAP, putative', 124, NULL, NULL, 108175),
(108176, '3.30.160.60-FF-003858', NULL, NULL, 27, NULL, NULL, 108176),
(108177, '1.10.486.10-FF-000020', NULL, 'DNA helicase', 137, NULL, NULL, 108177),
(108178, '1.10.10.10-FF-000275', NULL, 'CST complex subunit STN1', 73, NULL, NULL, 108178),
(108179, '1.25.40.690-FF-000015', NULL, 'Npp-10', 88, NULL, NULL, 108179),
(108180, '1.25.10.10-FF-000247', NULL, 'calcium-binding protein 39', 329, NULL, NULL, 108180),
(108181, '2.60.40.10-FF-000648', NULL, 'Intercellular adhesion molecule 1', 87, NULL, NULL, 108181),
(108182, '3.10.20.90-FF-000660', NULL, 'Uncharacterized protein', 83, NULL, NULL, 108182),
(108183, '2.130.10.10-FF-002105', NULL, 'Paralyzed flagella protein 20', 104, NULL, NULL, 108183),
(108184, '1.20.58.870-FF-000005', NULL, 'Putative DNA replication licensing factor', 96, NULL, NULL, 108184),
(108185, '2.70.170.10-FF-000157', NULL, 'CHRNA7-FAM7A fusion protein', 99, NULL, NULL, 108185),
(108186, '2.60.120.260-FF-000222', NULL, 'Beta-galactosidase', 221, NULL, NULL, 108186),
(108187, '3.80.10.10-FF-001324', NULL, 'PH domain leucine-rich repeat protein phosphatase 1', 97, NULL, NULL, 108187),
(108188, '1.20.1050.10-FF-000022', NULL, 'ganglioside-induced differentiation-associated protein 1 isoform X1', 123, NULL, NULL, 108188),
(108189, '2.30.30.140-FF-000199', NULL, 'Tudor, isoform B', 92, NULL, NULL, 108189),
(108190, '3.40.630.30-FF-000691', NULL, 'Uncharacterized protein', 62, NULL, NULL, 108190),
(108191, '3.20.20.120-FF-000015', NULL, 'Bifunctional D-altronate/D-mannonate dehydratase', 269, NULL, NULL, 108191),
(108192, '1.20.58.1180-FF-000001', NULL, 'Mitochondrial large ribosomal subunit YmL35', 147, NULL, NULL, 108192),
(108193, '3.30.420.40-FF-000680', NULL, 'Uncharacterized protein, isoform B', 150, NULL, NULL, 108193),
(108194, '1.10.1070.11-FF-000100', NULL, 'Putative actin-fragmin kinase DDB_G0279609', 176, NULL, NULL, 108194),
(108195, '1.25.40.10-FF-004453', NULL, 'Uncharacterized protein', 114, NULL, NULL, 108195),
(108196, '3.90.1410.10-FF-000151', NULL, 'Uncharacterized protein', 189, NULL, NULL, 108196),
(108197, '1.10.510.10-FF-004349', NULL, NULL, 122, NULL, NULL, 108197),
(108198, '1.10.238.10-FF-000164', NULL, 'Serine/threonine-protein phosphatase with EF-hands', 180, NULL, NULL, 108198),
(108199, '2.60.40.10-FF-002902', NULL, 'GM25484', 101, NULL, NULL, 108199),
(108200, '1.20.5.100-FF-000028', NULL, 'Predicted protein', 37, NULL, NULL, 108200),
(108201, '2.10.25.10-FF-001228', NULL, 'Fibulin 1', 41, NULL, NULL, 108201),
(108202, '3.40.30.10-FF-000259', NULL, 'Thioredoxin-like protein Clot', 135, NULL, NULL, 108202),
(108203, '3.60.21.10-FF-000338', NULL, 'Purple acid phosphatase 5', 109, NULL, NULL, 108203),
(108204, '2.60.40.1180-FF-000048', NULL, 'Isoamylase 1, chloroplastic', 110, NULL, NULL, 108204),
(108205, '2.30.29.230-FF-000004', NULL, 'TBC1 domain family, member 16', 102, NULL, NULL, 108205),
(108206, '3.40.50.2300-FF-000450', NULL, 'Response regulator', 138, NULL, NULL, 108206),
(108207, '3.90.190.20-FF-000052', NULL, 'Folylpolyglutamate synthetase, putative', 49, NULL, NULL, 108207),
(108208, '3.90.550.10-FF-000274', NULL, 'Glycosyl transferase family protein', 251, NULL, NULL, 108208),
(108209, '3.40.50.150-FF-000391', NULL, 'General transcriptional corepressor tupA', 234, NULL, NULL, 108209),
(108210, '1.10.630.10-FF-000002', NULL, 'Cytochrome P450 1A1', 473, NULL, NULL, 108210),
(108211, '3.30.450.40-FF-000182', NULL, 'IclR family transcriptional regulator', 173, NULL, NULL, 108211),
(108212, '1.20.58.860-FF-000002', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 84, NULL, NULL, 108212),
(108213, '3.30.160.60-FF-000862', NULL, 'zinc finger protein 697', 29, NULL, NULL, 108213),
(108214, '2.10.60.10-FF-000068', NULL, 'Serine/threonine-protein kinase receptor', 68, NULL, NULL, 108214),
(108215, '3.40.50.10860-FF-000061', NULL, 'Uncharacterized protein', 55, NULL, NULL, 108215),
(108216, '3.40.50.1000-FF-000493', NULL, 'Phospholipid-transporting ATPase IA, putative', 192, NULL, NULL, 108216);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(108217, '2.130.10.10-FF-001003', NULL, 'Serine/threonine protein kinase', 82, NULL, NULL, 108217),
(108218, '2.30.29.240-FF-000007', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 120, NULL, NULL, 108218),
(108219, '1.10.510.10-FF-000426', NULL, 'Receptor-type tyrosine-protein kinase FLT3', 203, NULL, NULL, 108219),
(108220, '2.60.40.1170-FF-000045', NULL, 'Probable coatomer subunit delta', 121, NULL, NULL, 108220),
(108221, '3.30.1370.240-FF-000006', NULL, 'Phenylalanyl-tRNA synthetase alpha chain B, putative', 94, NULL, NULL, 108221),
(108222, '1.10.287.110-FF-000223', NULL, 'Meiotically up-regulated gene 185 protein', 86, NULL, NULL, 108222),
(108223, '2.60.40.150-FF-000326', NULL, 'Copine i-like protein', 128, NULL, NULL, 108223),
(108224, '3.40.50.620-FF-000104', NULL, 'Mitochondrial tRNA-specific 2-thiouridylase 1', 234, NULL, NULL, 108224),
(108225, '3.30.40.10-FF-000052', NULL, 'RBR-type E3 ubiquitin transferase', 85, NULL, NULL, 108225),
(108226, '1.10.150.240-FF-000122', NULL, 'Gll0254 protein', 66, NULL, NULL, 108226),
(108227, '3.30.70.1320-FF-000007', NULL, 'Probable RND efflux transporter', 98, NULL, NULL, 108227),
(108228, '2.40.180.10-FF-000018', NULL, 'Catalase-related peroxidase', 201, NULL, NULL, 108228),
(108229, '1.10.10.60-FF-000380', NULL, 'Brinker', 59, NULL, NULL, 108229),
(108230, '3.30.9.10-FF-000098', NULL, 'FAD dependent oxidoreductase', 197, NULL, NULL, 108230),
(108231, '1.20.120.1750-FF-000034', NULL, 'RBR-type E3 ubiquitin transferase', 234, NULL, NULL, 108231),
(108232, '3.90.1290.10-FF-000062', NULL, 'Microtubule-actin crosslinking factor 1', 219, NULL, NULL, 108232),
(108233, '3.80.20.20-FF-000057', NULL, 'Tyrosine-protein kinase receptor', 166, NULL, NULL, 108233),
(108234, '3.10.20.30-FF-000114', NULL, NULL, 82, NULL, NULL, 108234),
(108235, '2.10.110.10-FF-000122', NULL, 'LIM domain and actin-binding protein', 70, NULL, NULL, 108235),
(108236, '1.20.1530.20-FF-000056', NULL, 'Uncharacterized protein', 404, NULL, NULL, 108236),
(108237, '1.50.40.10-FF-000466', NULL, 'Uncharacterized protein', 74, NULL, NULL, 108237),
(108238, '3.40.532.10-FF-000013', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 237, NULL, NULL, 108238),
(108239, '3.30.70.890-FF-000079', NULL, 'Uncharacterized protein', 75, NULL, NULL, 108239),
(108240, '1.20.120.1760-FF-000037', NULL, 'CDP-alcohol phosphatidyltransferase family protein', 216, NULL, NULL, 108240),
(108241, '2.60.40.10-FF-002453', NULL, 'KETtiN (Drosophila actin-binding) homolog', 107, NULL, NULL, 108241),
(108242, '3.90.226.10-FF-000352', NULL, '3-hydroxyisobutyryl-CoA hydrolase 1', 33, NULL, NULL, 108242),
(108243, '3.30.70.520-FF-000002', NULL, 'Formylmethanofuran--tetrahydromethanopterin formyltransferase', 148, NULL, NULL, 108243),
(108244, '3.30.200.20-FF-001990', NULL, 'Predicted protein', 98, NULL, NULL, 108244),
(108245, '2.130.10.10-FF-006028', NULL, 'Probable elongator complex protein 2', 127, NULL, NULL, 108245),
(108246, '1.25.40.120-FF-000098', NULL, 'Predicted protein', 126, NULL, NULL, 108246),
(108247, '3.80.10.10-FF-001650', NULL, 'Uncharacterized protein', 107, NULL, NULL, 108247),
(108248, '2.80.10.50-FF-000175', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 130, NULL, NULL, 108248),
(108249, '3.40.50.300-FF-006085', NULL, 'Uncharacterized protein', 145, NULL, NULL, 108249),
(108250, '3.10.450.10-FF-000065', NULL, 'Kininogen 1', 65, NULL, NULL, 108250),
(108251, '1.10.510.10-FF-000752', NULL, 'Obscurin isoform B', 195, NULL, NULL, 108251),
(108252, '3.90.550.50-FF-000050', NULL, 'Beta-1,3-galactosyltransferase 4', 219, NULL, NULL, 108252),
(108253, '3.10.100.10-FF-000404', NULL, NULL, 112, NULL, NULL, 108253),
(108254, '3.30.70.330-FF-001457', NULL, NULL, 100, NULL, NULL, 108254),
(108255, '3.30.70.1300-FF-000001', NULL, 'UPF0301 protein YqgE', 90, NULL, NULL, 108255),
(108256, '3.40.50.1820-FF-001481', NULL, 'Uncharacterized protein', 169, NULL, NULL, 108256),
(108257, '1.10.510.10-FF-002904', NULL, NULL, 228, NULL, NULL, 108257),
(108258, '2.70.150.10-FF-000257', NULL, 'E1-E2 ATPase, putative', 21, NULL, NULL, 108258);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(108259, '3.10.580.10-FF-000069', NULL, 'CBS domain-containing protein', 152, NULL, NULL, 108259),
(108260, '3.30.160.60-FF-004914', NULL, NULL, 47, NULL, NULL, 108260),
(108261, '1.10.238.10-FF-000490', NULL, 'N-terminal EF-hand calcium binding protein 3', 86, NULL, NULL, 108261),
(108262, '3.30.230.70-FF-000163', NULL, 'Exosome complex component RRP42-like Protein', 284, NULL, NULL, 108262),
(108263, '2.130.10.120-FF-000018', NULL, 'Protease 2', 342, NULL, NULL, 108263),
(108264, '3.90.79.10-FF-000032', NULL, 'Nudix hydrolase 25', 164, NULL, NULL, 108264),
(108265, '3.30.160.60-FF-000295', NULL, 'zinc finger protein 19', 30, NULL, NULL, 108265),
(108266, '1.10.40.60-FF-000005', NULL, 'Type II secretion system protein K', 107, NULL, NULL, 108266),
(108267, '1.10.40.50-FF-000002', NULL, 'Minichromosome maintenance (MCM2/3/5) family protein', 60, NULL, NULL, 108267),
(108268, '2.110.10.10-FF-000015', NULL, 'Matrix metallopeptidase 21', 98, NULL, NULL, 108268),
(108269, '3.30.70.3250-FF-000007', NULL, 'Ribonuclease P protein component 2', 116, NULL, NULL, 108269),
(108270, '2.10.110.10-FF-000105', NULL, 'Similar to LIM domain-containing protein', 63, NULL, NULL, 108270),
(108271, '1.10.490.10-FF-000013', NULL, 'Globin, protozoan/cyanobacterial family', 127, NULL, NULL, 108271),
(108272, '3.90.1140.10-FF-000062', NULL, 'Uncharacterized protein', 169, NULL, NULL, 108272),
(108273, '2.60.40.150-FF-000343', NULL, 'Tcb3p', 127, NULL, NULL, 108273),
(108274, '1.25.10.10-FF-001984', NULL, 'Uncharacterized protein', 403, NULL, NULL, 108274),
(108275, '1.10.10.60-FF-000503', NULL, 'Myb-like transcription factor 2', 69, NULL, NULL, 108275),
(108276, '1.25.10.10-FF-002260', NULL, 'Uncharacterized protein', 353, NULL, NULL, 108276),
(108277, '3.90.1100.10-FF-000048', NULL, 'DNA-directed RNA polymerase subunit beta', 156, NULL, NULL, 108277),
(108278, '2.40.50.180-FF-000010', NULL, 'Chemotaxis protein CheW', 72, NULL, NULL, 108278),
(108279, '3.40.50.300-FF-003212', NULL, 'Putative cleavage/polyadenylation factor ia subunit clp1p', 208, NULL, NULL, 108279),
(108280, '3.40.630.10-FF-000241', NULL, 'Metalloprotease', 164, NULL, NULL, 108280),
(108281, '3.10.100.10-FF-000308', NULL, NULL, 92, NULL, NULL, 108281),
(108282, '2.60.120.40-FF-000031', NULL, 'Tumor necrosis factor ligand superfamily member 14', 164, NULL, NULL, 108282),
(108283, '3.30.1370.10-FF-000020', NULL, 'RNA-binding protein Nova-1 isoform 1', 80, NULL, NULL, 108283),
(108284, '3.60.40.10-FF-000377', NULL, 'Uncharacterized protein', 70, NULL, NULL, 108284),
(108285, '1.20.144.10-FF-000005', NULL, 'phospholipid phosphatase-related protein type 1', 271, NULL, NULL, 108285),
(108286, '2.60.40.10-FF-000199', NULL, 'next to BRCA1 gene 1 protein-like', 118, NULL, NULL, 108286),
(108287, '3.30.260.10-FF-000012', NULL, 'T-complex protein 1 subunit gamma', 110, NULL, NULL, 108287),
(108288, '3.90.70.10-FF-000719', NULL, 'Uncharacterized protein', 193, NULL, NULL, 108288),
(108289, '1.10.720.60-FF-000013', NULL, 'Putative bifunctional methylthioribulose-1-phosphate dehydratase/enolase-phosphatase E1', 32, NULL, NULL, 108289),
(108290, '3.40.50.720-FF-001192', NULL, 'Short chain oxidoreductase (CsgA), putative (AFU_orthologue AFUA_4G00910)', 233, NULL, NULL, 108290),
(108291, '3.40.190.10-FF-000077', NULL, 'Peptide ABC transporter substrate-binding protein SapA', 91, NULL, NULL, 108291),
(108292, '3.40.50.1000-FF-000167', NULL, 'Sucrose-phosphate synthase 1', 114, NULL, NULL, 108292),
(108293, '2.40.30.10-FF-000306', NULL, '60S ribosomal protein L3', 60, NULL, NULL, 108293),
(108294, '3.30.497.10-FF-000101', NULL, 'AGAP007691-PB', 192, NULL, NULL, 108294),
(108295, '2.170.120.20-FF-000004', NULL, '50S ribosomal protein L25', 91, NULL, NULL, 108295),
(108296, '1.10.238.150-FF-000006', NULL, 'Uncharacterized protein', 102, NULL, NULL, 108296),
(108297, '3.40.50.300-FF-004494', NULL, 'ATP-dependent DEAD/H RNA helicase, putative', 241, NULL, NULL, 108297),
(108298, '3.40.50.300-FF-002723', NULL, 'DNA helicase', 130, NULL, NULL, 108298),
(108299, '1.20.1250.20-FF-001529', NULL, 'Uncharacterized protein', 450, NULL, NULL, 108299);
INSERT INTO "PUBLIC"."MODEL" VALUES
(108300, '1.25.10.10-FF-000573', NULL, 'Ran-binding protein 17', 664, NULL, NULL, 108300),
(108301, '2.80.10.50-FF-000192', NULL, 'Lymphocyte antigen 75', 120, NULL, NULL, 108301),
(108302, '3.40.1090.10-FF-000035', NULL, 'Lysophospholipase', 475, NULL, NULL, 108302),
(108303, '3.40.1360.10-FF-000028', NULL, 'DNA primase DnaG', 106, NULL, NULL, 108303),
(108304, '3.40.30.10-FF-001102', NULL, 'Glutathione S-transferase L2 chloroplastic', 61, NULL, NULL, 108304),
(108305, '3.90.105.10-FF-000004', NULL, 'Molybdopterin molybdenumtransferase', 34, NULL, NULL, 108305),
(108306, '2.40.10.10-FF-000423', NULL, 'Female reproductive tract protease', 234, NULL, NULL, 108306),
(108307, '1.25.40.10-FF-000075', NULL, 'Crooked neck pre-mRNA-splicing factor 1', 202, NULL, NULL, 108307),
(108308, '3.50.50.60-FF-000252', NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', 118, NULL, NULL, 108308),
(108309, '3.30.565.10-FF-000372', NULL, 'Sensor box histidine kinase', 127, NULL, NULL, 108309),
(108310, '2.30.30.40-FF-000506', NULL, 'Abl protein tyrosine kinase', 54, NULL, NULL, 108310),
(108311, '3.40.120.10-FF-000045', NULL, 'Phosphoglucomutase, putative', 195, NULL, NULL, 108311),
(108312, '2.30.310.10-FF-000009', NULL, 'RNA binding protein', 151, NULL, NULL, 108312),
(108313, '2.60.120.1190-FF-000012', NULL, 'Uncharacterized protein', 182, NULL, NULL, 108313),
(108314, '3.90.79.10-FF-000239', NULL, 'Slr2078 protein', 181, NULL, NULL, 108314),
(108315, '2.130.10.10-FF-002189', NULL, 'Protein CBR-NOL-10', 248, NULL, NULL, 108315),
(108316, '2.30.30.40-FF-000170', NULL, 'ABI gene family member 3', 69, NULL, NULL, 108316),
(108317, '4.10.400.10-FF-000356', NULL, 'Uncharacterized protein', 45, NULL, NULL, 108317),
(108318, '3.40.30.10-FF-000826', NULL, 'Protein disulfide isomerase 2', 103, NULL, NULL, 108318),
(108319, '3.40.50.1820-FF-001610', NULL, 'Uncharacterized protein', 69, NULL, NULL, 108319),
(108320, '3.40.50.150-FF-000935', NULL, NULL, 84, NULL, NULL, 108320),
(108321, '3.30.200.20-FF-000141', NULL, 'Non-specific serine/threonine protein kinase', 133, NULL, NULL, 108321),
(108322, '2.130.10.10-FF-002543', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One component system)', 303, NULL, NULL, 108322),
(108323, '3.40.50.1100-FF-000079', NULL, 'Putative pyridoxal-phosphate dependent protein F13B12.4', 215, NULL, NULL, 108323),
(108324, '3.40.1410.10-FF-000010', NULL, 'Phosphonate utilization transcriptional regulator PhnR', 158, NULL, NULL, 108324),
(108325, '1.10.287.990-FF-000003', NULL, 'Superoxide dismutase', 62, NULL, NULL, 108325),
(108326, '3.30.70.100-FF-000096', NULL, 'Putative ATP dependent copper transporter', 66, NULL, NULL, 108326),
(108327, '3.30.565.10-FF-000501', NULL, 'PMS1 homolog 1, mismatch repair system component', 127, NULL, NULL, 108327),
(108328, '3.90.550.10-FF-000403', NULL, 'Translation initiation factor eIF-2B subunit gamma', 183, NULL, NULL, 108328),
(108329, '1.20.920.30-FF-000062', NULL, 'Uncharacterized protein', 123, NULL, NULL, 108329),
(108330, '3.40.640.10-FF-000073', NULL, 'Probable 4-aminobutyrate aminotransferase', 301, NULL, NULL, 108330),
(108331, '3.40.50.2300-FF-001198', NULL, NULL, 125, NULL, NULL, 108331),
(108332, '3.30.530.20-FF-000008', NULL, 'START domain containing 10', 199, NULL, NULL, 108332),
(108333, '1.20.80.10-FF-000020', NULL, 'Unconventional myosin-X', 161, NULL, NULL, 108333),
(108334, '1.25.40.20-FF-000078', NULL, 'Inversin', 138, NULL, NULL, 108334),
(108335, '2.60.40.10-FF-004347', NULL, NULL, 134, NULL, NULL, 108335),
(108336, '1.10.533.10-FF-000119', NULL, 'Mucosa-associated lymphoid tissue lymphoma translocation protein 1', 57, NULL, NULL, 108336),
(108337, '4.10.1240.10-FF-000059', NULL, 'adhesion G protein-coupled receptor L3', 62, NULL, NULL, 108337),
(108338, '3.40.50.1240-FF-000093', NULL, 'Membrane-bound acid phosphatase 2', 373, NULL, NULL, 108338),
(108339, '3.40.50.300-FF-000571', NULL, 'Guanine nucleotide-binding protein-like NSN1', 186, NULL, NULL, 108339),
(108340, '3.30.390.10-FF-000016', NULL, 'Gluconate dehydratase (GAD)', 97, NULL, NULL, 108340);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(108341, '3.90.1150.10-FF-000113', NULL, 'Aminotransferase', 132, NULL, NULL, 108341),
(108342, '3.10.20.90-FF-000093', NULL, 'NSFL1 (P97) cofactor (P47)', 127, NULL, NULL, 108342),
(108343, '1.25.40.10-FF-004127', NULL, 'Uncharacterized protein', 122, NULL, NULL, 108343),
(108344, '1.10.10.10-FF-000730', NULL, 'RpiR family transcriptional regulator', 78, NULL, NULL, 108344),
(108345, '3.40.50.2300-FF-000012', NULL, 'Catabolite control protein A', 118, NULL, NULL, 108345),
(108346, '1.20.5.110-FF-000357', NULL, 'TNF receptor-associated factor', 64, NULL, NULL, 108346),
(108347, '2.40.70.10-FF-000320', NULL, NULL, 177, NULL, NULL, 108347),
(108348, '3.40.50.720-FF-001657', NULL, 'Cinnamate reductase', 132, NULL, NULL, 108348),
(108349, '3.30.40.10-FF-001463', NULL, 'Uncharacterized protein', 95, NULL, NULL, 108349),
(108350, '3.30.420.40-FF-000450', NULL, 'Protein CBG05834', 153, NULL, NULL, 108350),
(108351, '1.25.40.10-FF-003638', NULL, 'Tetratricopeptide repeat protein 21B', 111, NULL, NULL, 108351),
(108352, '3.20.20.70-FF-000687', NULL, NULL, 185, NULL, NULL, 108352),
(108353, '3.30.160.60-FF-004347', NULL, NULL, 33, NULL, NULL, 108353),
(108354, '1.25.40.20-FF-000971', NULL, 'YALI0F16940p', 103, NULL, NULL, 108354),
(108355, '2.20.70.10-FF-000028', NULL, 'WW domain-containing protein', 38, NULL, NULL, 108355),
(108356, '3.30.1680.10-FF-000004', NULL, 'semaphorin-6D isoform X1', 74, NULL, NULL, 108356),
(108357, '2.130.10.10-FF-004443', NULL, 'Uncharacterized protein', 352, NULL, NULL, 108357),
(108358, '3.40.50.2300-FF-001294', NULL, NULL, 139, NULL, NULL, 108358),
(108359, '1.10.30.10-FF-000175', NULL, 'Uncharacterized protein', 87, NULL, NULL, 108359),
(108360, '3.75.10.10-FF-000021', NULL, NULL, 182, NULL, NULL, 108360),
(108361, '1.10.472.10-FF-000415', NULL, 'Uncharacterized protein', 98, NULL, NULL, 108361),
(108362, '3.40.50.1820-FF-001817', NULL, 'Uncharacterized protein', 101, NULL, NULL, 108362),
(108363, '2.130.10.10-FF-004230', NULL, 'Predicted protein', 145, NULL, NULL, 108363),
(108364, '1.25.10.10-FF-002164', NULL, 'Uncharacterized protein', 506, NULL, NULL, 108364),
(108365, '1.20.58.390-FF-000171', NULL, 'Glycine receptor alpha 1 variant, putative', 137, NULL, NULL, 108365),
(108366, '3.30.200.20-FF-001888', NULL, 'Uncharacterized protein', 80, NULL, NULL, 108366),
(108367, '2.60.40.820-FF-000004', NULL, 'T-box, brain 1', 196, NULL, NULL, 108367),
(108368, '3.30.420.40-FF-000354', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', 190, NULL, NULL, 108368),
(108369, '3.30.200.20-FF-000702', NULL, 'CMGC/CDK/CRK7 protein kinase', 97, NULL, NULL, 108369),
(108370, '2.130.10.10-FF-003954', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit wuho', 243, NULL, NULL, 108370),
(108371, '3.30.230.10-FF-000201', NULL, 'Elongation factor like GTPase 1', 217, NULL, NULL, 108371),
(108372, '1.10.730.10-FF-000066', NULL, 'Isoleucine--tRNA ligase', 172, NULL, NULL, 108372),
(108373, '3.30.830.10-FF-000264', NULL, 'Uncharacterized protein', 229, NULL, NULL, 108373),
(108374, '3.90.1410.10-FF-000049', NULL, 'Uncharacterized protein', 275, NULL, NULL, 108374),
(108375, '3.40.50.11720-FF-000004', NULL, '3-deoxy-D-manno-octulosonic acid transferase', 174, NULL, NULL, 108375),
(108376, '3.30.310.50-FF-000012', NULL, 'Phosphoacetylglucosamine mutase, putative', 84, NULL, NULL, 108376),
(108377, '3.40.50.300-FF-002268', NULL, 'ABC transporter, (TAP family), putative', 153, NULL, NULL, 108377),
(108378, '3.30.70.240-FF-000008', NULL, 'Ribosome-releasing factor 2, mitochondrial', 71, NULL, NULL, 108378),
(108379, '2.60.40.3210-FF-000028', NULL, 'Zona pellucida glycoprotein 3c', 61, NULL, NULL, 108379),
(108380, '1.10.510.10-FF-000308', NULL, 'Dual specificity protein kinase TTK', 201, NULL, NULL, 108380),
(108381, '1.10.760.10-FF-000017', NULL, 'Di-heme cytochrome C peroxidase', 54, NULL, NULL, 108381),
(108382, '1.25.40.10-FF-000642', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 117, NULL, NULL, 108382),
(108383, '1.20.120.720-FF-000061', NULL, 'Myosin-J heavy chain', 152, NULL, NULL, 108383);
INSERT INTO "PUBLIC"."MODEL" VALUES
(108384, '2.60.40.3500-FF-000014', NULL, NULL, 122, NULL, NULL, 108384),
(108385, '3.90.550.10-FF-000392', NULL, 'Glycogenin (Glucosyltransferase), putative', 261, NULL, NULL, 108385),
(108386, '1.10.10.60-FF-000941', NULL, NULL, 74, NULL, NULL, 108386),
(108387, '2.60.40.60-FF-000736', NULL, 'Uncharacterized protein', 111, NULL, NULL, 108387),
(108388, '3.40.50.10810-FF-000074', NULL, 'DNA dependent ATPase, putative', 266, NULL, NULL, 108388),
(108389, '3.50.50.60-FF-000038', NULL, 'L-aspartate oxidase', 272, NULL, NULL, 108389),
(108390, '3.30.160.60-FF-006146', NULL, NULL, 24, NULL, NULL, 108390),
(108391, '1.25.10.10-FF-000129', NULL, 'sperm-associated antigen 6 isoform X1', 239, NULL, NULL, 108391),
(108392, '1.10.10.10-FF-000387', NULL, 'DNA topoisomerase 6 subunit A', 138, NULL, NULL, 108392),
(108393, '3.80.10.10-FF-001436', NULL, 'Si:ch211-15j1.4', 54, NULL, NULL, 108393),
(108394, '3.80.10.10-FF-002959', NULL, 'Uncharacterized protein', 91, NULL, NULL, 108394),
(108395, '1.10.287.1490-FF-000008', NULL, 'Kinesin-like protein', 175, NULL, NULL, 108395),
(108396, '1.10.400.10-FF-000070', NULL, 'Guanine nucleotide binding protein, alpha subunit', 61, NULL, NULL, 108396),
(108397, '1.10.287.1040-FF-000008', NULL, 'Exodeoxyribonuclease 7 small subunit', 73, NULL, NULL, 108397),
(108398, '1.10.3720.10-FF-000059', NULL, 'Oligopeptide ABC transporter, permease protein', 215, NULL, NULL, 108398),
(108399, '2.60.40.60-FF-000309', NULL, 'Protocadherin beta-8', 104, NULL, NULL, 108399),
(108400, '3.40.50.720-FF-000230', NULL, 'Oxidoreductase, short chain dehydrogenase/reductase family', 244, NULL, NULL, 108400),
(108401, '3.30.160.60-FF-002447', NULL, 'Zinc finger protein 606', 49, NULL, NULL, 108401),
(108402, '3.90.180.10-FF-000003', NULL, 'L-threonine 3-dehydrogenase', 175, NULL, NULL, 108402),
(108403, '3.30.1360.10-FF-000064', NULL, 'RNA polymerase Rpb3/Rpb11 dimerisation domain containing protein', 138, NULL, NULL, 108403),
(108404, '1.10.238.10-FF-000276', NULL, 'N-terminal EF-hand calcium binding protein 3', 76, NULL, NULL, 108404),
(108405, '2.10.25.10-FF-001116', NULL, 'Neurogenic locus protein delta', 46, NULL, NULL, 108405),
(108406, '1.25.10.10-FF-002259', NULL, 'Predicted protein', 1048, NULL, NULL, 108406),
(108407, '3.40.30.10-FF-000798', NULL, 'Uncharacterized protein', 67, NULL, NULL, 108407),
(108408, '3.40.462.20-FF-000010', NULL, 'Uncharacterized protein', 88, NULL, NULL, 108408),
(108409, '3.30.470.30-FF-000062', NULL, 'LIG3 isoform 10', 24, NULL, NULL, 108409),
(108410, '1.10.472.10-FF-000320', NULL, 'Uncharacterized cyclin-L1-like protein C1296.05c', 127, NULL, NULL, 108410),
(108411, '2.40.320.10-FF-000013', NULL, 'Mediator of RNA polymerase II transcription subunit 18', 192, NULL, NULL, 108411),
(108412, '3.40.50.300-FF-008097', NULL, 'Uncharacterized protein', 112, NULL, NULL, 108412),
(108413, '3.40.190.10-FF-000532', NULL, 'ABC transporter substrate-binding protein', 176, NULL, NULL, 108413),
(108414, '1.20.58.570-FF-000005', NULL, NULL, 45, NULL, NULL, 108414),
(108415, '3.40.50.300-FF-000239', NULL, 'Meiotic recombination protein DMC1', 256, NULL, NULL, 108415),
(108416, '3.40.190.10-FF-000105', NULL, 'Serotransferrin', 159, NULL, NULL, 108416),
(108417, '3.30.450.40-FF-000070', NULL, 'Unplaced genomic scaffold supercont1.28, whole genome shotgun sequence', 177, NULL, NULL, 108417),
(108418, '3.30.360.10-FF-000082', NULL, 'Nucleoside-diphosphate-sugar epimerase', 201, NULL, NULL, 108418),
(108419, '3.40.980.10-FF-000008', NULL, 'Molybdenum cofactor biosynthesis protein', 161, NULL, NULL, 108419),
(108420, '2.60.410.10-FF-000010', NULL, 'D-alanyl-D-alanine carboxypeptidase', 103, NULL, NULL, 108420),
(108421, '3.40.50.300-FF-006646', NULL, 'Uncharacterized protein', 88, NULL, NULL, 108421),
(108422, '2.60.120.10-FF-000729', NULL, 'Uncharacterized protein', 133, NULL, NULL, 108422),
(108423, '1.20.1280.50-FF-000186', NULL, 'SCF ubiquitin ligase complex subunit', 94, NULL, NULL, 108423),
(108424, '3.40.50.1000-FF-000381', NULL, 'Phospholipid-transporting ATPase IA, putative', 170, NULL, NULL, 108424);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(108425, '3.30.70.3530-FF-000001', NULL, 'Chorion-specific transcription factor GCMb', 56, NULL, NULL, 108425),
(108426, '3.30.497.10-FF-000090', NULL, 'serine protease inhibitor isoform X1', 215, NULL, NULL, 108426),
(108427, '1.25.40.10-FF-004341', NULL, 'Uncharacterized protein', 163, NULL, NULL, 108427),
(108428, '3.90.70.10-FF-000057', NULL, 'Cysteine protease RD19A', 330, NULL, NULL, 108428),
(108429, '1.20.1070.10-FF-001092', NULL, 'Trace amine-associated receptor 5', 318, NULL, NULL, 108429),
(108430, '1.20.5.190-FF-000116', NULL, NULL, 74, NULL, NULL, 108430),
(108431, '3.90.260.10-FF-000061', NULL, 'Uncharacterized protein', 268, NULL, NULL, 108431),
(108432, '3.40.50.300-FF-004409', NULL, 'Ribose 1,5-bisphosphate phosphokinase PhnN', 184, NULL, NULL, 108432),
(108433, '1.25.40.20-FF-000645', NULL, 'Rab GTPase activating protein, putative', 190, NULL, NULL, 108433),
(108434, '2.60.40.10-FF-004139', NULL, NULL, 90, NULL, NULL, 108434),
(108435, '1.10.10.10-FF-000404', NULL, 'DeoR family transcriptional regulator', 55, NULL, NULL, 108435),
(108436, '3.90.930.12-FF-000013', NULL, '50S ribosomal protein L6', 81, NULL, NULL, 108436),
(108437, '1.10.510.10-FF-000297', NULL, 'Non-specific serine/threonine protein kinase', 196, NULL, NULL, 108437),
(108438, '3.90.132.10-FF-000016', NULL, 'Uncharacterized protein', 112, NULL, NULL, 108438),
(108439, '1.20.1110.10-FF-000078', NULL, 'Sodium/potassium-transporting ATPase subunit alpha', 253, NULL, NULL, 108439),
(108440, '3.40.50.2000-FF-001097', NULL, 'Glycosyltransferase', 58, NULL, NULL, 108440),
(108441, '1.10.510.10-FF-003866', NULL, NULL, 96, NULL, NULL, 108441),
(108442, '1.10.760.10-FF-000118', NULL, 'Uncharacterized protein', 55, NULL, NULL, 108442),
(108443, '3.40.50.300-FF-008108', NULL, 'ATP-dependent DNA helicase', 108, NULL, NULL, 108443),
(108444, '3.40.50.300-FF-000565', NULL, 'ABC bile acid transporter', 257, NULL, NULL, 108444),
(108445, '3.30.460.90-FF-000006', NULL, 'Inositol 1,4,5-trisphosphate receptor-interacting protein', 182, NULL, NULL, 108445),
(108446, '1.10.472.10-FF-000207', NULL, 'Cyclin, putative', 128, NULL, NULL, 108446),
(108447, '3.40.50.300-FF-002695', NULL, 'ABC multidrug transporter, putative', 130, NULL, NULL, 108447),
(108448, '2.60.40.10-FF-002009', NULL, NULL, 102, NULL, NULL, 108448),
(108449, '2.40.170.20-FF-000072', NULL, 'Hemin receptor', 488, NULL, NULL, 108449),
(108450, '3.90.1420.10-FF-000005', NULL, 'Rubisco methyltransferase family protein', 164, NULL, NULL, 108450),
(108451, '2.130.10.10-FF-000952', NULL, 'Pre-mRNA-processing factor 19', 135, NULL, NULL, 108451),
(108452, '3.40.50.2300-FF-001086', NULL, NULL, 179, NULL, NULL, 108452),
(108453, '1.25.10.10-FF-002158', NULL, 'BRCA1-associated ATM activator 1', 516, NULL, NULL, 108453),
(108454, '3.40.50.200-FF-000086', NULL, 'Serin endopeptidase', 127, NULL, NULL, 108454),
(108455, '3.30.160.60-FF-004701', NULL, NULL, 24, NULL, NULL, 108455),
(108456, '3.40.50.1980-FF-000090', NULL, 'Iron(3+)-hydroxamate-binding protein YxeB', 167, NULL, NULL, 108456),
(108457, '4.10.60.10-FF-000041', NULL, 'Zinc finger CCHC domain-containing protein 7', 63, NULL, NULL, 108457),
(108458, '3.30.160.60-FF-002773', NULL, 'AGAP006061-PA-like protein', 31, NULL, NULL, 108458),
(108459, '3.10.28.10-FF-000002', NULL, 'Probable cell division protein WhiA', 211, NULL, NULL, 108459),
(108460, '3.50.50.100-FF-000019', NULL, 'NADH dehydrogenase', 404, NULL, NULL, 108460),
(108461, '1.20.1110.10-FF-000191', NULL, NULL, 144, NULL, NULL, 108461),
(108462, '1.20.58.340-FF-000066', NULL, 'Predicted protein', 182, NULL, NULL, 108462),
(108463, '3.10.150.10-FF-000019', NULL, 'Beta sliding clamp', 119, NULL, NULL, 108463),
(108464, '3.30.565.10-FF-000158', NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', 160, NULL, NULL, 108464),
(108465, '3.80.10.10-FF-001863', NULL, 'Ribonuclease inhibitor-like protein', 100, NULL, NULL, 108465),
(108466, '3.40.710.10-FF-000079', NULL, '6-aminohexanoate-dimer hydrolase', 359, NULL, NULL, 108466),
(108467, '1.20.120.980-FF-000009', NULL, 'AGAP003640-PA', 138, NULL, NULL, 108467);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(108468, '3.40.50.1820-FF-001705', NULL, 'Alpha-galactosidase', 168, NULL, NULL, 108468),
(108469, '3.30.420.10-FF-000699', NULL, NULL, 117, NULL, NULL, 108469),
(108470, '3.30.1330.30-FF-000147', NULL, 'Uncharacterized protein', 155, NULL, NULL, 108470),
(108471, '3.30.505.10-FF-000155', NULL, NULL, 122, NULL, NULL, 108471),
(108472, '3.30.200.20-FF-002052', NULL, 'Uncharacterized protein', 88, NULL, NULL, 108472),
(108473, '1.10.287.110-FF-000195', NULL, 'Tetratricopeptide repeat protein', 78, NULL, NULL, 108473),
(108474, '3.40.50.1980-FF-000101', NULL, 'Histidinol dehydrogenase', 132, NULL, NULL, 108474),
(108475, '3.30.420.40-FF-000242', NULL, '53 kDa brg1-associated factor b', 41, NULL, NULL, 108475),
(108476, '1.25.10.10-FF-002372', NULL, 'Uncharacterized protein', 276, NULL, NULL, 108476),
(108477, '1.10.510.10-FF-002438', NULL, NULL, 118, NULL, NULL, 108477),
(108478, '3.30.70.920-FF-000015', NULL, 'AsnC family transcriptional regulator', 85, NULL, NULL, 108478),
(108479, '3.30.420.40-FF-000562', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', 188, NULL, NULL, 108479),
(108480, '3.30.1330.60-FF-000010', NULL, 'Outer membrane protein class 4', 143, NULL, NULL, 108480),
(108481, '1.20.1050.10-FF-000140', NULL, 'Glutathione S-transferase', 114, NULL, NULL, 108481),
(108482, '1.25.40.10-FF-002087', NULL, 'Pentatricopeptide repeat-containing protein At5g62370', 166, NULL, NULL, 108482),
(108483, '1.25.10.10-FF-000814', NULL, 'RING-type E3 ubiquitin transferase', 183, NULL, NULL, 108483),
(108484, '3.40.630.30-FF-000359', NULL, 'GD19914', 221, NULL, NULL, 108484),
(108485, '1.20.1070.10-FF-001872', NULL, 'Uncharacterized protein', 346, NULL, NULL, 108485),
(108486, '3.60.21.10-FF-000451', NULL, 'Serine/threonine-protein phosphatase', 190, NULL, NULL, 108486),
(108487, '1.20.272.10-FF-000038', NULL, 'Replication factor C, subunit 3', 89, NULL, NULL, 108487),
(108488, '3.40.30.10-FF-000714', NULL, 'Probable dolichyl-diphosphooligosaccharide--protein glycosyltransferase subunit 3', 161, NULL, NULL, 108488),
(108489, '1.10.1600.10-FF-000011', NULL, 'Caenorhabditis KU', 96, NULL, NULL, 108489),
(108490, '1.25.10.10-FF-002490', NULL, 'Uncharacterized protein', 207, NULL, NULL, 108490),
(108491, '3.40.47.10-FF-000218', NULL, NULL, 144, NULL, NULL, 108491),
(108492, '2.60.210.10-FF-000023', NULL, 'Predicted protein', 157, NULL, NULL, 108492),
(108493, '1.20.140.150-FF-000102', NULL, 'Uncharacterized protein', 177, NULL, NULL, 108493),
(108494, '1.10.1620.20-FF-000015', NULL, 'Uncharacterized protein', 38, NULL, NULL, 108494),
(108495, '2.130.10.10-FF-005966', NULL, 'Vacuolar protein sorting/targeting protein 10', 243, NULL, NULL, 108495),
(108496, '2.60.40.10-FF-005775', NULL, NULL, 80, NULL, NULL, 108496),
(108497, '3.40.47.10-FF-000106', NULL, 'Actinorhodin polyketide putative beta-ketoacyl synthase 2', 255, NULL, NULL, 108497),
(108498, '3.40.50.1380-FF-000005', NULL, 'CAD protein-like isoform X1', 148, NULL, NULL, 108498),
(108499, '1.10.8.710-FF-000016', NULL, 'Dynein heavy chain 5, axonemal', 130, NULL, NULL, 108499),
(108500, '3.40.50.880-FF-000137', NULL, 'Catalase', 151, NULL, NULL, 108500),
(108501, '3.30.40.10-FF-000501', NULL, 'E3 ubiquitin-protein ligase ZNRF4', 73, NULL, NULL, 108501),
(108502, '2.120.10.30-FF-000245', NULL, 'Predicted protein', 126, NULL, NULL, 108502),
(108503, '3.30.750.24-FF-000102', NULL, 'Sulphate permease, putative', 168, NULL, NULL, 108503),
(108504, '3.40.800.20-FF-000061', NULL, 'Histone deacetylase', 93, NULL, NULL, 108504),
(108505, '2.10.109.10-FF-000023', NULL, 'Mitochondrial inner membrane protease subunit 2', 148, NULL, NULL, 108505),
(108506, '3.40.50.1390-FF-000008', NULL, 'DNA recombinase', 140, NULL, NULL, 108506),
(108507, '4.10.10.10-FF-000004', NULL, 'Uncharacterized protein', 56, NULL, NULL, 108507),
(108508, '3.10.110.10-FF-000236', NULL, 'Ubiquitin-conjugating enzyme E2 C', 151, NULL, NULL, 108508),
(108509, '3.10.110.10-FF-000124', NULL, 'Ubiquitin-conjugating enzyme E2, putative', 167, NULL, NULL, 108509),
(108510, '1.10.3720.10-FF-000172', NULL, 'ABC transporter, permease protein', 202, NULL, NULL, 108510);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(108511, '3.40.50.1820-FF-000879', NULL, 'Carboxylic ester hydrolase', 315, NULL, NULL, 108511),
(108512, '1.10.560.10-FF-000036', NULL, 'T-complex protein 1, theta subunit', 232, NULL, NULL, 108512),
(108513, '3.40.50.300-FF-004729', NULL, 'Predicted protein', 253, NULL, NULL, 108513),
(108514, '3.40.50.720-FF-000022', NULL, 'Cinnamyl alcohol dehydrogenase', 156, NULL, NULL, 108514),
(108515, '2.30.330.10-FF-000005', NULL, 'Flagellar motor switch protein', 81, NULL, NULL, 108515),
(108516, '2.30.29.30-FF-000303', NULL, 'Sterol 3-beta-glucosyltransferase', 110, NULL, NULL, 108516),
(108517, '1.10.10.10-FF-000067', NULL, 'Iron-dependent repressor IdeR', 73, NULL, NULL, 108517),
(108518, '2.10.25.10-FF-000599', NULL, 'multiple epidermal growth factor-like domains protein 9', 45, NULL, NULL, 108518),
(108519, '1.10.3210.10-FF-000088', NULL, 'Metal-dependent phosphohydrolase HD sub domain', 190, NULL, NULL, 108519),
(108520, '2.60.40.10-FF-000087', NULL, 'Tyrosine-protein kinase receptor', 110, NULL, NULL, 108520),
(108521, '3.30.505.10-FF-000054', NULL, 'Suppressor of cytokine signaling 1', 122, NULL, NULL, 108521),
(108522, '2.130.10.10-FF-000059', NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', 306, NULL, NULL, 108522),
(108523, '3.90.226.10-FF-000234', NULL, 'ATP-dependent Clp protease proteolytic subunit', 120, NULL, NULL, 108523),
(108524, '1.10.10.10-FF-000179', NULL, 'DNA-binding response OmpR family regulator', 93, NULL, NULL, 108524),
(108525, '1.25.40.10-FF-004240', NULL, 'Pentatricopeptide repeat protein (AFU_orthologue AFUA_2G12010)', 242, NULL, NULL, 108525),
(108526, '1.20.1310.10-FF-000059', NULL, 'Cullin-4B', 132, NULL, NULL, 108526),
(108527, '2.10.25.10-FF-001324', NULL, 'Uncharacterized protein', 40, NULL, NULL, 108527),
(108528, '3.10.180.10-FF-000061', NULL, 'Putative protein C31H2.4', 154, NULL, NULL, 108528),
(108529, '3.40.309.10-FF-000112', NULL, 'Uncharacterized protein', 104, NULL, NULL, 108529),
(108530, '2.10.25.10-FF-001436', NULL, 'Laminin beta 1 chain, putative', 48, NULL, NULL, 108530),
(108531, '3.40.50.300-FF-000470', NULL, 'ATPase family, AAA domain containing 3A', 195, NULL, NULL, 108531),
(108532, '2.120.10.30-FF-000144', NULL, 'Nhl repeat-containing protein, putative', 100, NULL, NULL, 108532),
(108533, '3.40.640.10-FF-000281', NULL, 'Gamma-aminobutyrate transaminase POP2 mitochondrial', 50, NULL, NULL, 108533),
(108534, '3.40.50.740-FF-000028', NULL, 'NADH-quinone oxidoreductase', 198, NULL, NULL, 108534),
(108535, '1.10.510.10-FF-002551', NULL, 'Protein kinase superfamily protein', 282, NULL, NULL, 108535),
(108536, '3.40.50.1370-FF-000002', NULL, 'Aspartate carbamoyltransferase 2', 158, NULL, NULL, 108536),
(108537, '1.25.10.10-FF-000461', NULL, 'Non-SMC condensin I complex, subunit G', 226, NULL, NULL, 108537),
(108538, '3.30.460.80-FF-000003', NULL, 'Formate hydrogenlyase subunit 5', 133, NULL, NULL, 108538),
(108539, '3.30.800.10-FF-000009', NULL, 'Phosphatidylinositol 4-phosphate 5-kinase its3', 182, NULL, NULL, 108539),
(108540, '3.30.590.20-FF-000017', NULL, 'Putative glutamate--cysteine ligase 2', 368, NULL, NULL, 108540),
(108541, '3.40.50.300-FF-004617', NULL, 'V-type proton ATPase catalytic subunit A', 43, NULL, NULL, 108541),
(108542, '1.10.940.10-FF-000003', NULL, 'Transcription antitermination factor NusB', 130, NULL, NULL, 108542),
(108543, '3.10.20.90-FF-000755', NULL, 'AGAP011491-PA', 94, NULL, NULL, 108543),
(108544, '1.20.58.60-FF-000888', NULL, 'Spectrin alpha 2', 65, NULL, NULL, 108544),
(108545, '1.10.3460.10-FF-000022', NULL, 'Fucoxanthin chl a/c protein-deviant sequence', 151, NULL, NULL, 108545),
(108546, '1.10.418.60-FF-000018', NULL, 'Uncharacterized protein', 166, NULL, NULL, 108546),
(108547, '3.90.70.10-FF-000484', NULL, 'Ubiquitin-specific protease, putative', 380, NULL, NULL, 108547),
(108548, '3.40.47.10-FF-000011', NULL, '3-ketoacyl-CoA thiolase', 429, NULL, NULL, 108548),
(108549, '3.40.50.720-FF-001427', NULL, 'Polyketide synthase type I', 485, NULL, NULL, 108549),
(108550, '1.10.357.10-FF-000018', NULL, 'Transcriptional regulator LuxT', 153, NULL, NULL, 108550);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(108551, '2.60.40.60-FF-000641', NULL, 'AGAP002828-PA', 122, NULL, NULL, 108551),
(108552, '2.30.29.30-FF-000888', NULL, 'Pleckstrin homology domain-containing family B member 2', 106, NULL, NULL, 108552),
(108553, '2.40.100.10-FF-000132', NULL, 'Cyclophilin-type peptidylprolyl cis-trans isomerase', 190, NULL, NULL, 108553),
(108554, '3.40.50.1440-FF-000052', NULL, 'Tubulin/FtsZ GTPase', 304, NULL, NULL, 108554),
(108555, '1.10.1240.40-FF-000008', NULL, 'Uncharacterized protein', 129, NULL, NULL, 108555),
(108556, '3.65.10.20-FF-000019', NULL, 'RNA 3''-terminal phosphate cyclase', 224, NULL, NULL, 108556),
(108557, '2.130.10.10-FF-002088', NULL, 'Vacuolar protein sorting-associated protein 41', 324, NULL, NULL, 108557),
(108558, '4.10.400.10-FF-000255', NULL, 'Uncharacterized protein', 40, NULL, NULL, 108558),
(108559, '1.10.150.240-FF-000010', NULL, 'Beta-phosphoglucomutase', 77, NULL, NULL, 108559),
(108560, '2.60.40.1360-FF-000001', NULL, 'Alpha-mannosidase', 125, NULL, NULL, 108560),
(108561, '3.65.10.10-FF-000016', NULL, 'Pentafunctional AROM polypeptide', 204, NULL, NULL, 108561),
(108562, '1.10.287.40-FF-000022', NULL, 'Serine--tRNA ligase, chloroplastic/mitochondrial', 105, NULL, NULL, 108562),
(108563, '2.60.40.10-FF-002341', NULL, 'Alpha-1-B glycoprotein', 96, NULL, NULL, 108563),
(108564, '3.30.1640.10-FF-000007', NULL, 'DNA replication licensing factor MCM7', 100, NULL, NULL, 108564),
(108565, '3.40.190.290-FF-000029', NULL, 'LysR family transcriptional regulator', 207, NULL, NULL, 108565),
(108566, '1.20.58.2220-FF-000044', NULL, 'Formin-homology and zinc finger domains protein 1', 353, NULL, NULL, 108566),
(108567, '2.60.450.20-FF-000021', NULL, 'Uncharacterized protein', 83, NULL, NULL, 108567),
(108568, '1.10.418.40-FF-000012', NULL, 'AGAP012793-PA', 128, NULL, NULL, 108568),
(108569, '2.170.270.10-FF-000113', NULL, 'Histone-lysine N-methyltransferase', 101, NULL, NULL, 108569),
(108570, '2.60.40.10-FF-004802', NULL, NULL, 102, NULL, NULL, 108570),
(108571, '3.40.50.880-FF-000042', NULL, 'Pyridoxine 2', 222, NULL, NULL, 108571),
(108572, '3.80.10.10-FF-001083', NULL, 'Ribonuclease inhibitor-like protein', 101, NULL, NULL, 108572),
(108573, '3.40.50.1000-FF-000280', NULL, 'HAD-superfamily hydrolase, subfamily IIA containing protein', 127, NULL, NULL, 108573),
(108574, '2.40.70.10-FF-000292', NULL, NULL, 35, NULL, NULL, 108574),
(108575, '1.10.1670.10-FF-000043', NULL, NULL, 93, NULL, NULL, 108575),
(108576, '3.30.70.330-FF-001569', NULL, NULL, 140, NULL, NULL, 108576),
(108577, '1.20.1500.20-FF-000004', NULL, NULL, 51, NULL, NULL, 108577),
(108578, '1.10.287.1480-FF-000005', NULL, '30S ribosomal protein S14', 88, NULL, NULL, 108578),
(108579, '1.10.238.10-FF-001102', NULL, 'Uncharacterized protein', 63, NULL, NULL, 108579),
(108580, '2.130.10.10-FF-002313', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', 215, NULL, NULL, 108580),
(108581, '3.30.565.10-FF-000259', NULL, 'Volvoxopsin-5, sensory rhodopsin with histidine kinase domain', 157, NULL, NULL, 108581),
(108582, '1.10.8.720-FF-000019', NULL, 'Dynein heavy chain family protein', 167, NULL, NULL, 108582),
(108583, '3.30.1360.120-FF-000053', NULL, 'Glycine cleavage system T protein, aminomethyltransferase', 112, NULL, NULL, 108583),
(108584, '3.40.630.10-FF-000353', NULL, 'Uncharacterized protein', 185, NULL, NULL, 108584),
(108585, '1.10.510.10-FF-002337', NULL, NULL, 203, NULL, NULL, 108585),
(108586, '3.40.50.2060-FF-000018', NULL, 'Vacuolar protein sorting 33B', 139, NULL, NULL, 108586),
(108587, '3.10.20.90-FF-000328', NULL, 'Focal adhesion kinase, isoform F', 126, NULL, NULL, 108587),
(108588, '3.30.160.60-FF-000744', NULL, 'zinc finger E-box-binding homeobox 1', 30, NULL, NULL, 108588),
(108589, '3.30.200.20-FF-002153', NULL, 'Os05g0333100 protein', 68, NULL, NULL, 108589),
(108590, '3.40.50.300-FF-004522', NULL, 'Uncharacterized protein', 193, NULL, NULL, 108590),
(108591, '2.30.30.40-FF-000057', NULL, 'Dedicator of cytokinesis protein 4', 69, NULL, NULL, 108591);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(108592, '2.120.10.80-FF-000232', NULL, 'Serine/threonine-protein phosphatase', 225, NULL, NULL, 108592),
(108593, '2.30.30.30-FF-000054', NULL, 'Transcription elongation factor SPT5', 67, NULL, NULL, 108593),
(108594, '3.90.550.10-FF-000723', NULL, 'Uncharacterized protein', 257, NULL, NULL, 108594),
(108595, '3.10.450.160-FF-000001', NULL, 'Heavy metal resistance protein', 83, NULL, NULL, 108595),
(108596, '3.40.50.300-FF-004056', NULL, 'Non-structural protein NS1', 210, NULL, NULL, 108596),
(108597, '1.20.1540.10-FF-000104', NULL, 'Uncharacterized protein', 184, NULL, NULL, 108597),
(108598, '3.30.160.20-FF-000199', NULL, 'Uncharacterized protein', 94, NULL, NULL, 108598),
(108599, '1.20.1070.10-FF-001445', NULL, 'Uncharacterized protein', 221, NULL, NULL, 108599),
(108600, '2.70.150.10-FF-000049', NULL, 'Cation-transporting ATPase', 163, NULL, NULL, 108600),
(108601, '3.30.160.60-FF-005988', NULL, NULL, 48, NULL, NULL, 108601),
(108602, '3.20.100.10-FF-000014', NULL, 'Uncharacterized protein', 272, NULL, NULL, 108602),
(108603, '1.10.555.10-FF-000069', NULL, 'Rho GTPase Activating protein', 230, NULL, NULL, 108603),
(108604, '3.40.50.150-FF-000385', NULL, 'DNA (Cytosine-5)-methyltransferase', 95, NULL, NULL, 108604),
(108605, '3.30.860.10-FF-000007', NULL, '40S ribosomal protein S15', 65, NULL, NULL, 108605),
(108606, '3.40.50.1000-FF-000487', NULL, NULL, 131, NULL, NULL, 108606),
(108607, '2.30.29.30-FF-000989', NULL, 'Uncharacterized protein', 140, NULL, NULL, 108607),
(108608, '1.10.530.10-FF-000085', NULL, 'Lyc2 protein', 103, NULL, NULL, 108608),
(108609, '1.25.40.990-FF-000004', NULL, 'Putative peptidase C48 domain family protein', 303, NULL, NULL, 108609),
(108610, '1.10.20.10-FF-000348', NULL, NULL, 95, NULL, NULL, 108610),
(108611, '1.10.10.10-FF-000281', NULL, 'MarR family transcriptional regulator', 143, NULL, NULL, 108611),
(108612, '1.10.20.10-FF-000118', NULL, 'Unplaced genomic scaffold supercont1.188, whole genome shotgun sequence', 72, NULL, NULL, 108612),
(108613, '1.10.287.690-FF-000003', NULL, 'DNA polymerase', 54, NULL, NULL, 108613),
(108614, '2.130.10.10-FF-004229', NULL, 'Uncharacterized protein', 145, NULL, NULL, 108614),
(108615, '3.10.310.20-FF-000013', NULL, 'Acidocalcisomal exopolyphosphatase, putative', 150, NULL, NULL, 108615),
(108616, '3.40.50.300-FF-002931', NULL, 'DNA repair helicase XPB-R', 237, NULL, NULL, 108616),
(108617, '1.25.70.10-FF-000026', NULL, 'Mitochondrial transcription termination factor family protein', 222, NULL, NULL, 108617),
(108618, '3.30.160.60-FF-006264', NULL, NULL, 26, NULL, NULL, 108618),
(108619, '3.40.50.300-FF-004286', NULL, 'Homolog of S. Pombe Rad', 163, NULL, NULL, 108619),
(108620, '1.10.287.110-FF-000318', NULL, 'Chaperone protein DNAj, putative', 102, NULL, NULL, 108620),
(108621, '2.60.40.3100-FF-000001', NULL, 'Arylsulfate sulfotransferase AssT', 106, NULL, NULL, 108621),
(108622, '3.30.160.750-FF-000006', NULL, NULL, 51, NULL, NULL, 108622),
(108623, '3.30.70.330-FF-001912', NULL, NULL, 71, NULL, NULL, 108623),
(108624, '3.40.50.2300-FF-001647', NULL, NULL, 233, NULL, NULL, 108624),
(108625, '3.30.40.10-FF-001575', NULL, 'Uncharacterized protein', 91, NULL, NULL, 108625),
(108626, '3.30.70.330-FF-001558', NULL, 'Polyadenylate-binding protein, cytoplasmic and nuclear', 103, NULL, NULL, 108626),
(108627, '3.30.160.60-FF-002335', NULL, 'C2H2 transcription factor', 32, NULL, NULL, 108627),
(108628, '3.40.50.150-FF-001003', NULL, 'NOL1/NOP2/sun family, putative', 362, NULL, NULL, 108628),
(108629, '2.60.40.10-FF-002548', NULL, 'Protein CBR-UNC-40', 92, NULL, NULL, 108629),
(108630, '3.10.20.480-FF-000001', NULL, 'Antirestriction protein ArdA', 61, NULL, NULL, 108630),
(108631, '2.60.40.10-FF-004690', NULL, NULL, 114, NULL, NULL, 108631),
(108632, '3.30.160.60-FF-004465', NULL, NULL, 36, NULL, NULL, 108632),
(108633, '3.30.40.10-FF-001345', NULL, 'PHD type transcription factor with transmembrane domain protein (PTM)', 58, NULL, NULL, 108633),
(108634, '1.20.1280.50-FF-000074', NULL, 'GG17121', 91, NULL, NULL, 108634),
(108635, '1.20.1280.50-FF-000175', NULL, 'Probable F-box protein At5g36000', 100, NULL, NULL, 108635);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(108636, '2.30.29.30-FF-001265', NULL, 'Uncharacterized protein', 102, NULL, NULL, 108636),
(108637, '3.20.20.100-FF-000104', NULL, 'Probable oxidoreductase (Aldo-keto reductase family protein)', 336, NULL, NULL, 108637),
(108638, '2.70.170.10-FF-000258', NULL, 'Uncharacterized protein', 163, NULL, NULL, 108638),
(108639, '2.40.37.20-FF-000010', NULL, NULL, 107, NULL, NULL, 108639),
(108640, '1.10.1420.10-FF-000126', NULL, 'Predicted protein', 121, NULL, NULL, 108640),
(108641, '3.20.20.140-FF-000448', NULL, 'Uncharacterized protein', 69, NULL, NULL, 108641),
(108642, '1.10.3970.10-FF-000004', NULL, 'General Transcription Factor homolog', 72, NULL, NULL, 108642),
(108643, '3.40.50.150-FF-000727', NULL, 'Methyltransferase', 239, NULL, NULL, 108643),
(108644, '3.30.565.10-FF-000052', NULL, 'Two-component system sensor histidine kinase UhpB', 126, NULL, NULL, 108644),
(108645, '1.20.140.40-FF-000084', NULL, NULL, 154, NULL, NULL, 108645),
(108646, '3.30.200.20-FF-000461', NULL, 'Serine/threonine-protein kinase SRPK1', 90, NULL, NULL, 108646),
(108647, '1.10.418.10-FF-000262', NULL, 'Uncharacterized protein', 63, NULL, NULL, 108647),
(108648, '4.10.970.10-FF-000005', NULL, 'Uncharacterized protein', 24, NULL, NULL, 108648),
(108649, '3.50.4.10-FF-000025', NULL, 'PAN domain protein', 78, NULL, NULL, 108649),
(108650, '3.90.226.10-FF-000026', NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', 356, NULL, NULL, 108650),
(108651, '2.130.10.10-FF-000290', NULL, 'Protein HIR', 309, NULL, NULL, 108651),
(108652, '3.10.310.10-FF-000010', NULL, 'Proline racemase', 157, NULL, NULL, 108652),
(108653, '2.70.150.10-FF-000162', NULL, 'Phospholipid-transporting ATPase IA, putative', 117, NULL, NULL, 108653),
(108654, '2.40.30.10-FF-000295', NULL, 'NADPH-dependent diflavin oxidoreductase 1', 81, NULL, NULL, 108654),
(108655, '3.40.50.720-FF-001865', NULL, 'Uncharacterized protein', 58, NULL, NULL, 108655),
(108656, '3.40.50.150-FF-000486', NULL, 'O-methyltransferase glim', 250, NULL, NULL, 108656),
(108657, '1.20.1310.10-FF-000172', NULL, NULL, 157, NULL, NULL, 108657),
(108658, '3.30.70.330-FF-001671', NULL, NULL, 90, NULL, NULL, 108658),
(108659, '1.20.5.190-FF-000004', NULL, 'calmodulin-binding transcription activator 2 isoform X1', 53, NULL, NULL, 108659),
(108660, '1.20.140.150-FF-000091', NULL, 'Transmembrane protein 178B', 125, NULL, NULL, 108660),
(108661, '2.30.130.30-FF-000001', NULL, 'UPF0267 protein YqfB', 103, NULL, NULL, 108661),
(108662, '2.130.10.10-FF-005865', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 311, NULL, NULL, 108662),
(108663, '1.10.3910.10-FF-000001', NULL, 'Iron-sulfur cluster repair protein ScdA', 64, NULL, NULL, 108663),
(108664, '2.170.270.10-FF-000231', NULL, 'BAH domaincontaining protein', 84, NULL, NULL, 108664),
(108665, '3.40.50.300-FF-006540', NULL, 'Uncharacterized protein', 108, NULL, NULL, 108665),
(108666, '3.40.50.1380-FF-000016', NULL, 'Carbamoyl phosphate synthetase II', 155, NULL, NULL, 108666),
(108667, '2.60.120.10-FF-000617', NULL, 'Uncharacterized protein', 147, NULL, NULL, 108667),
(108668, '3.90.550.10-FF-000515', NULL, 'Glycosyl transferase family 2', 253, NULL, NULL, 108668),
(108669, '3.30.590.10-FF-000014', NULL, 'arginine kinase', 272, NULL, NULL, 108669),
(108670, '1.10.10.10-FF-000180', NULL, 'Transcriptional activator NhaR', 86, NULL, NULL, 108670),
(108671, '3.30.160.60-FF-000536', NULL, 'hypermethylated in cancer 2 protein-like', 27, NULL, NULL, 108671),
(108672, '2.130.10.10-FF-000632', NULL, 'WD repeat-containing protein, putative', 317, NULL, NULL, 108672),
(108673, '3.90.1150.10-FF-000001', NULL, 'Aspartate aminotransferase', 146, NULL, NULL, 108673),
(108674, '3.80.10.10-FF-000599', NULL, 'Leucine-rich repeat-containing protein', 93, NULL, NULL, 108674),
(108675, '3.30.379.10-FF-000006', NULL, 'Extracellular xylan exo-alpha-(1->2)-glucuronosidase', 130, NULL, NULL, 108675),
(108676, '1.10.340.30-FF-000020', NULL, 'Pre-mRNA splicing factor, putative', 199, NULL, NULL, 108676),
(108677, '3.90.550.50-FF-000145', NULL, 'Chondroitin sulfate synthase mig-22', 188, NULL, NULL, 108677);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(108678, '3.90.70.10-FF-000046', NULL, 'ubiquitin carboxyl-terminal hydrolase 31', 211, NULL, NULL, 108678),
(108679, '1.25.40.10-FF-003846', NULL, 'Nuclear autoantigenic sperm protein (histone-binding)', 117, NULL, NULL, 108679),
(108680, '1.10.1420.10-FF-000025', NULL, 'DNA mismatch repair protein msh3', 177, NULL, NULL, 108680),
(108681, '2.60.40.10-FF-005876', NULL, NULL, 88, NULL, NULL, 108681),
(108682, '3.10.10.10-FF-000040', NULL, NULL, 73, NULL, NULL, 108682),
(108683, '1.10.150.20-FF-000103', NULL, 'DNA-directed RNA polymerase subunit alpha', 68, NULL, NULL, 108683),
(108684, '3.20.20.210-FF-000025', NULL, 'Uroporphyrinogen decarboxylase 1 chloroplastic', 144, NULL, NULL, 108684),
(108685, '3.30.160.60-FF-002094', NULL, 'Zinc finger and BTB domain-containing 47b', 25, NULL, NULL, 108685),
(108686, '2.70.130.10-FF-000054', NULL, NULL, 137, NULL, NULL, 108686),
(108687, '1.20.58.1880-FF-000014', NULL, 'Predicted protein', 90, NULL, NULL, 108687),
(108688, '3.30.200.20-FF-000803', NULL, 'Probable serine/threonine-protein kinase roco4', 121, NULL, NULL, 108688),
(108689, '2.60.40.150-FF-000770', NULL, 'Uncharacterized protein', 111, NULL, NULL, 108689),
(108690, '2.10.25.10-FF-001554', NULL, 'Uncharacterized protein', 33, NULL, NULL, 108690),
(108691, '1.10.10.10-FF-002080', NULL, 'Meiotic recombination protein W68', 116, NULL, NULL, 108691),
(108692, '3.30.70.330-FF-002064', NULL, NULL, 87, NULL, NULL, 108692),
(108693, '3.20.20.70-FF-000788', NULL, NULL, 61, NULL, NULL, 108693),
(108694, '3.40.50.300-FF-006860', NULL, 'Lipid exporter ABCA1, putative', 256, NULL, NULL, 108694),
(108695, '3.40.50.720-FF-001545', NULL, 'Glucose 1-dehydrogenase', 260, NULL, NULL, 108695),
(108696, '3.40.50.2300-FF-000124', NULL, 'PTS sugar transporter subunit IIB', 91, NULL, NULL, 108696),
(108697, '3.30.450.40-FF-000277', NULL, 'Phosphodiesterase', 144, NULL, NULL, 108697),
(108698, '3.40.1090.10-FF-000136', NULL, 'Patatin', 97, NULL, NULL, 108698),
(108699, '3.30.160.60-FF-004235', NULL, NULL, 33, NULL, NULL, 108699),
(108700, '2.40.70.10-FF-000415', NULL, NULL, 84, NULL, NULL, 108700),
(108701, '3.30.479.30-FF-000031', NULL, 'Sll0815 protein', 134, NULL, NULL, 108701),
(108702, '3.40.50.1820-FF-001716', NULL, 'Protein kinase family protein / WD-40 repeat family protein', 137, NULL, NULL, 108702),
(108703, '1.25.10.10-FF-002052', NULL, 'RING-type E3 ubiquitin transferase', 157, NULL, NULL, 108703),
(108704, '2.130.10.10-FF-004342', NULL, 'Uncharacterized protein', 98, NULL, NULL, 108704),
(108705, '1.20.58.390-FF-000283', NULL, 'Si:dkey-49c17.4', 53, NULL, NULL, 108705),
(108706, '3.50.50.60-FF-001455', NULL, 'Oxidoreductase, putative', 77, NULL, NULL, 108706),
(108707, '2.40.10.10-FF-000209', NULL, 'Serine protease', 244, NULL, NULL, 108707),
(108708, '3.40.50.1000-FF-000403', NULL, 'Cadmium, zinc and cobalt-transporting ATPase', 136, NULL, NULL, 108708),
(108709, '3.40.50.1390-FF-000019', NULL, 'Phage integrase family Site-specific recombinase', 138, NULL, NULL, 108709),
(108710, '3.30.160.60-FF-003959', NULL, NULL, 71, NULL, NULL, 108710),
(108711, '2.60.120.10-FF-000376', NULL, 'Germin-like protein subfamily 2 member 1', 119, NULL, NULL, 108711),
(108712, '1.25.40.980-FF-000001', NULL, 'Protein transport protein SEC31', 239, NULL, NULL, 108712),
(108713, '2.130.10.10-FF-004331', NULL, 'Uncharacterized protein', 100, NULL, NULL, 108713),
(108714, '2.30.130.40-FF-000004', NULL, 'Lon protease homolog, mitochondrial', 111, NULL, NULL, 108714),
(108715, '2.130.10.10-FF-002190', NULL, 'Uncharacterized protein', 353, NULL, NULL, 108715),
(108716, '3.40.640.10-FF-000522', NULL, 'Ornithine aminotransferase', 139, NULL, NULL, 108716),
(108717, '3.30.70.240-FF-000019', NULL, 'Elongation factor G', 71, NULL, NULL, 108717),
(108718, '1.10.1070.11-FF-000083', NULL, 'Serine/threonine-protein kinase TEL1', 183, NULL, NULL, 108718),
(108719, '1.10.10.920-FF-000004', NULL, 'Oxygen-independent coproporphyrinogen III oxidase', 89, NULL, NULL, 108719),
(108720, '2.30.30.40-FF-000265', NULL, 'Myoblast city, isoform B', 70, NULL, NULL, 108720); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(108721, '1.20.1250.20-FF-001434', NULL, 'Uncharacterized protein', 138, NULL, NULL, 108721),
(108722, '1.10.357.70-FF-000008', NULL, 'Exocyst complex component', 190, NULL, NULL, 108722),
(108723, '3.30.110.70-FF-000002', NULL, 'Heavy-metal-binding family protein', 92, NULL, NULL, 108723),
(108724, '2.60.450.20-FF-000010', NULL, 'Uncharacterized protein', 214, NULL, NULL, 108724),
(108725, '1.10.10.60-FF-000621', NULL, 'Lhx1/5 LIM homeobox protein', 67, NULL, NULL, 108725),
(108726, '3.30.420.40-FF-000449', NULL, 'Heat shock protein 70', 180, NULL, NULL, 108726),
(108727, '2.40.100.10-FF-000143', NULL, 'Peptidyl-prolyl cis-trans isomerase', 180, NULL, NULL, 108727),
(108728, '3.40.50.300-FF-000918', NULL, 'tRNA dimethylallyltransferase', 272, NULL, NULL, 108728),
(108729, '1.10.10.10-FF-000303', NULL, 'MarR family transcriptional regulator', 137, NULL, NULL, 108729),
(108730, '2.130.10.10-FF-002077', NULL, 'Protein HIR', 86, NULL, NULL, 108730),
(108731, '1.20.1560.10-FF-000004', NULL, 'ATP-binding cassette sub-family B member 7', 343, NULL, NULL, 108731),
(108732, '3.40.50.1100-FF-000197', NULL, 'Os06g0564600 protein', 166, NULL, NULL, 108732),
(108733, '1.25.40.1010-FF-000018', NULL, 'Uncharacterized protein', 97, NULL, NULL, 108733),
(108734, '1.10.10.910-FF-000001', NULL, 'ATP synthase subunit beta', 48, NULL, NULL, 108734),
(108735, '4.10.840.10-FF-000001', NULL, 'Rhodopsin', 26, NULL, NULL, 108735),
(108736, '3.10.250.10-FF-000067', NULL, 'Lysyl oxidase homolog 3A', 113, NULL, NULL, 108736),
(108737, '3.40.50.300-FF-008119', NULL, 'Uncharacterized protein', 106, NULL, NULL, 108737),
(108738, '1.20.144.10-FF-000117', NULL, 'Uncharacterized protein', 202, NULL, NULL, 108738),
(108739, '1.10.1410.10-FF-000075', NULL, 'Poly(A) polymerase alpha', 39, NULL, NULL, 108739),
(108740, '2.40.30.10-FF-000418', NULL, 'Selenocysteine-specific elongation factor SelB', 89, NULL, NULL, 108740),
(108741, '3.30.565.10-FF-000490', NULL, 'Two-component sensor kinase', 151, NULL, NULL, 108741),
(108742, '3.30.200.60-FF-000006', NULL, 'OSIGBa0113E10.15 protein', 59, NULL, NULL, 108742),
(108743, '1.20.1640.10-FF-000062', NULL, 'Patched-related protein 9', 189, NULL, NULL, 108743),
(108744, '1.25.10.10-FF-000472', NULL, 'Protein phosphatase PP2A regulatory subunit A', 400, NULL, NULL, 108744),
(108745, '1.25.40.20-FF-000853', NULL, 'Kinase, NEK', 164, NULL, NULL, 108745),
(108746, '3.20.20.220-FF-000028', NULL, 'Proline dehydrogenase', 136, NULL, NULL, 108746),
(108747, '1.10.3430.10-FF-000071', NULL, 'Uncharacterized protein', 179, NULL, NULL, 108747),
(108748, '1.10.540.10-FF-000136', NULL, 'GM09085p', 68, NULL, NULL, 108748),
(108749, '3.40.50.300-FF-002611', NULL, 'Cell cycle checkpoint protein Rad17, putative', 195, NULL, NULL, 108749),
(108750, '1.25.40.10-FF-000850', NULL, 'Pre-mRNA-splicing factor SYF1', 265, NULL, NULL, 108750),
(108751, '1.20.1440.180-FF-000012', NULL, 'Predicted protein', 116, NULL, NULL, 108751),
(108752, '2.60.40.10-FF-004252', NULL, NULL, 140, NULL, NULL, 108752),
(108753, '3.30.70.3490-FF-000051', NULL, NULL, 102, NULL, NULL, 108753),
(108754, '1.10.8.270-FF-000171', NULL, 'Uncharacterized protein', 68, NULL, NULL, 108754),
(108755, '1.10.390.10-FF-000096', NULL, 'Uncharacterized protein', 110, NULL, NULL, 108755),
(108756, '3.90.1750.10-FF-000081', NULL, 'Uncharacterized protein', 192, NULL, NULL, 108756),
(108757, '1.25.40.10-FF-000187', NULL, 'cell division cycle protein 23 homolog', 302, NULL, NULL, 108757),
(108758, '2.30.170.40-FF-000001', NULL, '50S ribosomal protein L28', 77, NULL, NULL, 108758),
(108759, '1.10.10.790-FF-000038', NULL, NULL, 58, NULL, NULL, 108759),
(108760, '1.20.58.1480-FF-000001', NULL, 'Lon protease', 126, NULL, NULL, 108760),
(108761, '3.60.130.30-FF-000002', NULL, 'Thymine dioxygenase JBP1', 180, NULL, NULL, 108761),
(108762, '2.60.40.3510-FF-000028', NULL, 'Jag2 protein', 110, NULL, NULL, 108762),
(108763, '3.30.70.3540-FF-000004', NULL, 'Polyprotein 1ab', 93, NULL, NULL, 108763),
(108764, '2.30.30.1160-FF-000004', NULL, 'GD18353', 123, NULL, NULL, 108764);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(108765, '2.60.40.150-FF-000438', NULL, 'Non-specific serine/threonine protein kinase', 128, NULL, NULL, 108765),
(108766, '3.80.30.20-FF-000013', NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase', 237, NULL, NULL, 108766),
(108767, '3.40.50.300-FF-004960', NULL, 'Uncharacterized protein', 91, NULL, NULL, 108767),
(108768, '1.10.510.10-FF-004350', NULL, NULL, 122, NULL, NULL, 108768),
(108769, '3.40.630.30-FF-000348', NULL, 'Acteyltransferase GNAT family', 135, NULL, NULL, 108769),
(108770, '3.40.50.300-FF-002257', NULL, 'ATP-dependent DNA helicase UvrD', 172, NULL, NULL, 108770),
(108771, '3.40.50.300-FF-000357', NULL, 'ATP-dependent RNA helicase DDX19B', 210, NULL, NULL, 108771),
(108772, '3.10.20.90-FF-000317', NULL, 'Polyubiquitin-B', 27, NULL, NULL, 108772),
(108773, '2.40.50.150-FF-000029', NULL, 'Os10g0495600 protein', 22, NULL, NULL, 108773),
(108774, '3.30.200.20-FF-000023', NULL, 'Receptor protein serine/threonine kinase', 123, NULL, NULL, 108774),
(108775, '2.10.110.10-FF-000010', NULL, 'PDZ and LIM domain protein 5', 63, NULL, NULL, 108775),
(108776, '2.20.70.10-FF-000242', NULL, 'Peptidyl-prolyl cis-trans isomerase', 33, NULL, NULL, 108776),
(108777, '1.10.455.10-FF-000005', NULL, 'Ribosomal protein S7', 143, NULL, NULL, 108777),
(108778, '1.10.287.110-FF-000431', NULL, 'Uncharacterized protein', 84, NULL, NULL, 108778),
(108779, '3.90.1150.10-FF-000231', NULL, 'RE58623p', 121, NULL, NULL, 108779),
(108780, '1.20.5.820-FF-000002', NULL, 'Sec61 trimeric complex component', 60, NULL, NULL, 108780),
(108781, '3.40.50.1440-FF-000158', NULL, 'Uncharacterized protein', 261, NULL, NULL, 108781),
(108782, '3.40.630.10-FF-000342', NULL, 'Clan MH, family M18, aspartyl aminopeptidase-like metallopeptidase', 247, NULL, NULL, 108782),
(108783, '3.20.180.20-FF-000022', NULL, 'Dynein heavy chain', 100, NULL, NULL, 108783),
(108784, '1.25.40.10-FF-004009', NULL, 'Uncharacterized protein', 204, NULL, NULL, 108784),
(108785, '3.90.70.10-FF-000720', NULL, 'Uncharacterized protein', 192, NULL, NULL, 108785),
(108786, '2.60.40.10-FF-003976', NULL, NULL, 102, NULL, NULL, 108786),
(108787, '3.30.70.270-FF-000101', NULL, 'DNA-directed polymerase kappa, putative (AFU_orthologue AFUA_7G01270)', 51, NULL, NULL, 108787),
(108788, '3.30.428.70-FF-000004', NULL, 'Phosphorylase, putative (AFU_orthologue AFUA_5G14690)', 288, NULL, NULL, 108788),
(108789, '2.40.10.10-FF-000541', NULL, NULL, 91, NULL, NULL, 108789),
(108790, '3.90.76.10-FF-000008', NULL, 'ABC transporter substrate-binding protein component', 144, NULL, NULL, 108790),
(108791, '2.60.40.10-FF-002661', NULL, 'Titin homolog', 115, NULL, NULL, 108791),
(108792, '2.170.8.10-FF-000001', NULL, 'Phosphoenolpyruvate carboxykinase (ATP)', 82, NULL, NULL, 108792),
(108793, '3.30.60.30-FF-000155', NULL, 'Reversion-inducing cysteine-rich protein with Kazal motifs', 48, NULL, NULL, 108793),
(108794, '2.10.25.10-FF-000498', NULL, 'Low-density lipoprotein receptor-related protein 1B', 42, NULL, NULL, 108794),
(108795, '3.40.50.1240-FF-000104', NULL, 'Uncharacterized protein', 411, NULL, NULL, 108795),
(108796, '2.60.200.20-FF-000076', NULL, 'Nuclear inhibitor of protein phosphatase 1', 123, NULL, NULL, 108796),
(108797, '2.10.110.20-FF-000013', NULL, NULL, 25, NULL, NULL, 108797),
(108798, '3.40.50.150-FF-000840', NULL, 'Putative antibiotic resistance rRNA adenine methyltransferase', 187, NULL, NULL, 108798),
(108799, '1.10.400.10-FF-000081', NULL, 'Guanine nucleotide-binding protein, putative', 90, NULL, NULL, 108799),
(108800, '3.30.70.2820-FF-000007', NULL, 'DNA polymerase', 102, NULL, NULL, 108800),
(108801, '2.40.110.10-FF-000071', NULL, 'Uncharacterized protein', 139, NULL, NULL, 108801),
(108802, '1.10.510.10-FF-000640', NULL, 'Serine/threonine-protein kinase PRR1', 312, NULL, NULL, 108802),
(108803, '3.40.140.10-FF-000046', NULL, 'AMSH-like ubiquitin thioesterase 2', 196, NULL, NULL, 108803),
(108804, '3.40.50.300-FF-002818', NULL, 'CHL1p Probable DNA helicase', 114, NULL, NULL, 108804),
(108805, '1.10.472.80-FF-000189', NULL, NULL, 131, NULL, NULL, 108805);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(108806, '3.40.50.1820-FF-001593', NULL, 'Uncharacterized protein', 88, NULL, NULL, 108806),
(108807, '2.60.40.1760-FF-000014', NULL, 'Glucoamylase 1', 240, NULL, NULL, 108807),
(108808, '1.10.357.10-FF-000007', NULL, 'TetR family transcriptional regulator', 199, NULL, NULL, 108808),
(108809, '1.25.40.20-FF-000292', NULL, 'No mechanoreceptor potential C, isoform F', 185, NULL, NULL, 108809),
(108810, '3.40.50.1000-FF-000049', NULL, 'Class B acid phosphatase', 214, NULL, NULL, 108810),
(108811, '3.30.710.10-FF-000103', NULL, 'Kelch-like 6 (Drosophila) (Predicted)', 143, NULL, NULL, 108811),
(108812, '3.10.110.10-FF-000135', NULL, 'Ubiquitin-conjugating enzyme E2 G1', 95, NULL, NULL, 108812),
(108813, '3.40.50.300-FF-008338', NULL, 'tRNA isopentenyltransferase, putative', 305, NULL, NULL, 108813),
(108814, '3.30.60.20-FF-000152', NULL, 'Diacylglycerol kinase', 76, NULL, NULL, 108814),
(108815, '2.60.40.60-FF-000186', NULL, 'FAT atypical cadherin 2', 102, NULL, NULL, 108815),
(108816, '1.10.150.240-FF-000021', NULL, 'Hydrolase, haloacid dehalogenase-like family', 67, NULL, NULL, 108816),
(108817, '1.10.8.870-FF-000025', NULL, 'Glycerol-3-phosphate dehydrogenase (FAD-dependent), putative', 82, NULL, NULL, 108817),
(108818, '1.10.1510.30-FF-000009', NULL, 'tRNA pseudouridine synthase D TruD', 88, NULL, NULL, 108818),
(108819, '1.25.40.10-FF-004902', NULL, 'Uncharacterized protein', 79, NULL, NULL, 108819),
(108820, '1.25.40.10-FF-002441', NULL, 'Pentatricopeptide repeat-containing protein At1g05670, mitochondrial', 106, NULL, NULL, 108820),
(108821, '2.60.40.1080-FF-000018', NULL, 'Uncharacterized protein', 83, NULL, NULL, 108821),
(108822, '3.30.420.80-FF-000006', NULL, '28S ribosomal protein S11, mitochondrial', 136, NULL, NULL, 108822),
(108823, '2.80.10.50-FF-000287', NULL, 'Uncharacterized protein', 169, NULL, NULL, 108823),
(108824, '2.40.50.140-FF-000026', NULL, '30S ribosomal protein S17', 84, NULL, NULL, 108824),
(108825, '3.30.160.60-FF-003150', NULL, 'Zinc finger protein 882', 29, NULL, NULL, 108825),
(108826, '3.40.140.10-FF-000260', NULL, 'Uncharacterized protein', 120, NULL, NULL, 108826),
(108827, '3.40.1450.10-FF-000001', NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase', 234, NULL, NULL, 108827),
(108828, '2.70.170.10-FF-000051', NULL, 'Ligand-Gated ion Channel', 204, NULL, NULL, 108828),
(108829, '3.40.50.300-FF-008445', NULL, 'Uncharacterized protein', 69, NULL, NULL, 108829),
(108830, '3.60.15.10-FF-000043', NULL, 'Cleavage and polyadenylation specificity factor subunit 3', 226, NULL, NULL, 108830),
(108831, '4.10.1240.10-FF-000048', NULL, 'Uncharacterized protein', 98, NULL, NULL, 108831),
(108832, '2.70.150.10-FF-000044', NULL, 'Phospholipid-transporting ATPase', 132, NULL, NULL, 108832),
(108833, '1.10.287.110-FF-000436', NULL, 'Predicted protein', 76, NULL, NULL, 108833),
(108834, '1.10.10.10-FF-000741', NULL, 'Paired box protein Pax-5', 41, NULL, NULL, 108834),
(108835, '2.60.120.260-FF-000340', NULL, 'YALI0E22825p', 219, NULL, NULL, 108835),
(108836, '3.30.530.20-FF-000019', NULL, 'Abscisic acid receptor PYR1', 192, NULL, NULL, 108836),
(108837, '1.10.10.2210-FF-000004', NULL, NULL, 32, NULL, NULL, 108837),
(108838, '2.40.30.10-FF-000531', NULL, 'Mitochondrial tRNA-specific 2-thiouridylase 1', 96, NULL, NULL, 108838),
(108839, '1.20.5.340-FF-000066', NULL, 'Myosin-9', 117, NULL, NULL, 108839),
(108840, '3.30.559.30-FF-000094', NULL, 'HC-toxin synthetase', 256, NULL, NULL, 108840),
(108841, '3.40.50.300-FF-005697', NULL, 'ORC1-type DNA replication protein 6', 177, NULL, NULL, 108841),
(108842, '3.10.490.10-FF-000056', NULL, 'Gamma-glutamylcyclotransferase', 170, NULL, NULL, 108842),
(108843, '4.10.1140.10-FF-000001', NULL, 'Receptor protein-tyrosine kinase', 40, NULL, NULL, 108843),
(108844, '1.10.10.2200-FF-000001', NULL, 'Probable serine/threonine-protein kinase pats1', 80, NULL, NULL, 108844),
(108845, '3.40.850.10-FF-000111', NULL, 'p-loop nucleoside triphosphate hydrolase superfamily protein with CH (Calponin Homology) domain', 213, NULL, NULL, 108845);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(108846, '1.20.1250.40-FF-000018', NULL, 'WGS project CABT00000000 data, contig 2.3', 133, NULL, NULL, 108846),
(108847, '2.130.10.10-FF-002751', NULL, 'Uncharacterized protein', 261, NULL, NULL, 108847),
(108848, '3.80.10.10-FF-003342', NULL, 'Uncharacterized protein', 120, NULL, NULL, 108848),
(108849, '3.40.50.300-FF-004174', NULL, 'Multidrug resistance protein, putative', 148, NULL, NULL, 108849),
(108850, '3.40.50.80-FF-000005', NULL, 'NADH-cytochrome b5 reductase', 155, NULL, NULL, 108850),
(108851, '3.80.10.10-FF-003235', NULL, 'Uncharacterized protein', 350, NULL, NULL, 108851),
(108852, '1.20.120.230-FF-000021', NULL, 'Vinculin, isoform B', 126, NULL, NULL, 108852),
(108853, '2.10.110.10-FF-000330', NULL, 'Uncharacterized protein', 109, NULL, NULL, 108853),
(108854, '3.30.420.40-FF-000904', NULL, 'Immunoglobulin heavy chain binding protein, putative', 39, NULL, NULL, 108854),
(108855, '3.40.50.620-FF-000897', NULL, 'Uncharacterized protein', 78, NULL, NULL, 108855),
(108856, '3.90.1170.10-FF-000007', NULL, 'Ribosomal protein L16', 145, NULL, NULL, 108856),
(108857, '3.40.640.10-FF-000404', NULL, 'Uncharacterized aminotransferase C1039.07c', 265, NULL, NULL, 108857),
(108858, '3.40.50.2300-FF-001529', NULL, NULL, 77, NULL, NULL, 108858),
(108859, '3.40.50.150-FF-000615', NULL, 'Ubiquinone biosynthesis O-methyltransferase, mitochondrial', 258, NULL, NULL, 108859),
(108860, '3.40.850.10-FF-000004', NULL, 'Kinesin-like protein isoform 2', 370, NULL, NULL, 108860),
(108861, '2.60.40.150-FF-000551', NULL, 'Uncharacterized protein', 136, NULL, NULL, 108861),
(108862, '2.60.40.1180-FF-000037', NULL, 'Alpha-amylase A', 98, NULL, NULL, 108862),
(108863, '1.10.510.10-FF-002096', NULL, NULL, 64, NULL, NULL, 108863),
(108864, '1.10.20.10-FF-000236', NULL, NULL, 117, NULL, NULL, 108864),
(108865, '3.30.40.10-FF-001457', NULL, 'Uncharacterized protein', 69, NULL, NULL, 108865),
(108866, '1.20.120.350-FF-000169', NULL, NULL, 155, NULL, NULL, 108866),
(108867, '2.40.70.10-FF-000533', NULL, NULL, 196, NULL, NULL, 108867),
(108868, '1.20.1250.20-FF-001209', NULL, 'Uncharacterized protein', 177, NULL, NULL, 108868),
(108869, '2.70.170.10-FF-000039', NULL, 'Ligand-Gated ion Channel', 209, NULL, NULL, 108869),
(108870, '3.30.160.60-FF-004353', NULL, NULL, 24, NULL, NULL, 108870),
(108871, '2.40.50.140-FF-000251', NULL, 'MP18 RNA editing complex protein', 116, NULL, NULL, 108871),
(108872, '1.10.167.10-FF-000077', NULL, 'G protein-coupled receptor kinase', 79, NULL, NULL, 108872),
(108873, '3.40.720.10-FF-000349', NULL, 'Uncharacterized protein', 294, NULL, NULL, 108873),
(108874, '1.10.510.10-FF-000639', NULL, 'Related to serine/threonine protein kinase', 196, NULL, NULL, 108874),
(108875, '3.40.50.150-FF-000508', NULL, 'Expressed protein', 195, NULL, NULL, 108875),
(108876, '3.40.50.2300-FF-000006', NULL, 'Two-component system response regulator ArcA', 83, NULL, NULL, 108876),
(108877, '3.10.330.20-FF-000003', NULL, 'tRNA (Adenine(58)-N(1))-methyltransferase, mitochondrial isoform X1', 73, NULL, NULL, 108877),
(108878, '2.60.40.150-FF-000444', NULL, 'Non-specific serine/threonine protein kinase', 135, NULL, NULL, 108878),
(108879, '3.30.160.60-FF-005769', NULL, NULL, 25, NULL, NULL, 108879),
(108880, '1.25.40.10-FF-002109', NULL, 'Tetratricopeptide repeat protein 30A', 64, NULL, NULL, 108880),
(108881, '1.25.10.10-FF-002607', NULL, 'ARM repeat superfamily protein', 141, NULL, NULL, 108881),
(108882, '3.90.70.10-FF-000832', NULL, 'Uncharacterized protein', 153, NULL, NULL, 108882),
(108883, '3.30.160.60-FF-005983', NULL, NULL, 57, NULL, NULL, 108883),
(108884, '3.30.70.1400-FF-000025', NULL, 'Sarcosine dehydrogenase', 56, NULL, NULL, 108884),
(108885, '1.10.418.10-FF-000144', NULL, 'Uncharacterized protein', 109, NULL, NULL, 108885),
(108886, '2.60.40.1170-FF-000034', NULL, 'Putative AP-3 complex subunit mu', 162, NULL, NULL, 108886),
(108887, '3.40.930.10-FF-000056', NULL, NULL, 350, NULL, NULL, 108887),
(108888, '1.25.40.10-FF-002435', NULL, 'Putative pentatricopeptide repeat-containing protein At3g23330', 86, NULL, NULL, 108888);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(108889, '3.30.110.110-FF-000018', NULL, 'Meiotic recombination 11', 99, NULL, NULL, 108889),
(108890, '2.40.160.50-FF-000012', NULL, 'Outer membrane protein Omp85 family', 312, NULL, NULL, 108890),
(108891, '3.80.10.10-FF-001195', NULL, 'Uncharacterized protein', 179, NULL, NULL, 108891),
(108892, '2.60.40.10-FF-002773', NULL, 'Tapasin long form', 113, NULL, NULL, 108892),
(108893, '2.20.25.10-FF-000065', NULL, 'TFIIB zinc-binding, putative', 49, NULL, NULL, 108893),
(108894, '1.10.1450.10-FF-000072', NULL, 'Tetraspanin', 94, NULL, NULL, 108894),
(108895, '2.40.30.10-FF-000205', NULL, 'NADPH oxidoreductase', 103, NULL, NULL, 108895),
(108896, '3.10.100.10-FF-000180', NULL, 'GD23749', 141, NULL, NULL, 108896),
(108897, '1.20.58.390-FF-000165', NULL, 'AGAP007707-PA', 138, NULL, NULL, 108897),
(108898, '2.60.120.260-FF-000014', NULL, 'E3 ubiquitin-protein ligase HECTD1 isoform X1', 127, NULL, NULL, 108898),
(108899, '1.25.40.10-FF-002542', NULL, 'Pre-mRNA-splicing factor CLF1', 238, NULL, NULL, 108899),
(108900, '3.40.30.10-FF-001080', NULL, 'UBX domain-containing protein 10', 155, NULL, NULL, 108900),
(108901, '3.40.50.790-FF-000009', NULL, '50S ribosomal protein L1, mitochondrial, putative', 90, NULL, NULL, 108901),
(108902, '3.40.50.80-FF-000112', NULL, 'Putative nitrate reductase', 145, NULL, NULL, 108902),
(108903, '3.30.70.330-FF-000602', NULL, 'Polyadenylate-binding protein', 165, NULL, NULL, 108903),
(108904, '2.60.40.60-FF-000287', NULL, 'Cadherin-4', 88, NULL, NULL, 108904),
(108905, '3.40.50.150-FF-000941', NULL, NULL, 104, NULL, NULL, 108905),
(108906, '3.10.450.10-FF-000054', NULL, 'Si:ch211-262h13.5', 109, NULL, NULL, 108906),
(108907, '3.30.70.3250-FF-000013', NULL, NULL, 116, NULL, NULL, 108907),
(108908, '1.10.1200.80-FF-000001', NULL, 'tRNA-dihydrouridine synthase B', 70, NULL, NULL, 108908),
(108909, '3.80.10.10-FF-001088', NULL, 'Cell surface protein', 104, NULL, NULL, 108909),
(108910, '3.20.20.110-FF-000001', NULL, 'Ribulose bisphosphate carboxylase large chain', 326, NULL, NULL, 108910),
(108911, '2.30.29.30-FF-001383', NULL, 'Uncharacterized protein', 121, NULL, NULL, 108911),
(108912, '3.40.50.300-FF-002717', NULL, 'Translation elongation factor EF-G', 272, NULL, NULL, 108912),
(108913, '1.10.1170.10-FF-000022', NULL, 'Zinc finger protein', 97, NULL, NULL, 108913),
(108914, '3.40.50.1110-FF-000088', NULL, 'Protein CBG20522', 263, NULL, NULL, 108914),
(108915, '3.90.930.12-FF-000024', NULL, NULL, 97, NULL, NULL, 108915),
(108916, '3.40.50.300-FF-006309', NULL, 'Discs, large homolog 4', 127, NULL, NULL, 108916),
(108917, '3.40.50.1100-FF-000192', NULL, 'Uncharacterized protein', 188, NULL, NULL, 108917),
(108918, '3.10.100.10-FF-000073', NULL, 'Polycystic kidney disease protein 1-like 2', 140, NULL, NULL, 108918),
(108919, '2.130.10.10-FF-002318', NULL, 'Echinoderm microtubule-associated protein-like elp-1', 317, NULL, NULL, 108919),
(108920, '3.30.70.890-FF-000068', NULL, 'Mevalonate 3-kinase', 122, NULL, NULL, 108920),
(108921, '3.30.160.60-FF-005876', NULL, NULL, 42, NULL, NULL, 108921),
(108922, '1.25.40.10-FF-003739', NULL, 'Uncharacterized protein', 135, NULL, NULL, 108922),
(108923, '3.30.1370.10-FF-000126', NULL, 'Protein CBR-SFA-1', 127, NULL, NULL, 108923),
(108924, '3.30.420.10-FF-000694', NULL, NULL, 120, NULL, NULL, 108924),
(108925, '1.25.40.10-FF-002328', NULL, 'Protein NPGR1', 55, NULL, NULL, 108925),
(108926, '1.10.357.50-FF-000002', NULL, 'calcium-dependent secretion activator 2 isoform X7', 179, NULL, NULL, 108926),
(108927, '2.30.42.10-FF-000160', NULL, 'RHPN1 isoform 1', 98, NULL, NULL, 108927),
(108928, '1.25.10.10-FF-002714', NULL, 'Importin beta-like protein kap113', 977, NULL, NULL, 108928),
(108929, '1.10.418.10-FF-000037', NULL, 'nesprin-1 isoform X1', 126, NULL, NULL, 108929),
(108930, '2.10.25.10-FF-000947', NULL, 'Fat-like cadherin-related tumor suppressor homolog', 40, NULL, NULL, 108930),
(108931, '3.30.390.10-FF-000027', NULL, 'Muconate cycloisomerase I', 121, NULL, NULL, 108931),
(108932, '3.10.150.10-FF-000014', NULL, 'Beta sliding clamp', 138, NULL, NULL, 108932);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(108933, '1.10.150.530-FF-000001', NULL, 'Dual-specificity RNA methyltransferase RlmN', 78, NULL, NULL, 108933),
(108934, '3.40.50.2000-FF-000242', NULL, 'Glycogen synthase', 211, NULL, NULL, 108934),
(108935, '2.60.120.10-FF-000494', NULL, 'Uncharacterized protein', 139, NULL, NULL, 108935),
(108936, '3.90.70.10-FF-000613', NULL, 'Uncharacterized protein', 156, NULL, NULL, 108936),
(108937, '3.30.40.10-FF-000041', NULL, 'E3 ubiquitin-protein ligase SINAT3', 59, NULL, NULL, 108937),
(108938, '1.20.1300.10-FF-000019', NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', 123, NULL, NULL, 108938),
(108939, '1.10.150.240-FF-000009', NULL, 'Alpha-D-glucose-1-phosphate phosphatase YihX', 66, NULL, NULL, 108939),
(108940, '3.40.50.1100-FF-000085', NULL, 'Threonine dehydratase', 91, NULL, NULL, 108940),
(108941, '3.30.70.20-FF-000091', NULL, NULL, 73, NULL, NULL, 108941),
(108942, '3.30.160.60-FF-004572', NULL, NULL, 28, NULL, NULL, 108942),
(108943, '1.20.1070.10-FF-001097', NULL, 'Opsin', 315, NULL, NULL, 108943),
(108944, '3.30.160.60-FF-004460', NULL, NULL, 47, NULL, NULL, 108944),
(108945, '3.10.170.20-FF-000024', NULL, NULL, 145, NULL, NULL, 108945),
(108946, '1.10.287.70-FF-000795', NULL, 'Uncharacterized protein', 142, NULL, NULL, 108946),
(108947, '2.60.40.150-FF-000337', NULL, 'U5 small nuclear ribonucleoprotein helicase, putative', 111, NULL, NULL, 108947),
(108948, '1.10.10.10-FF-002079', NULL, 'DNA topoisomerase VI, A subunit', 139, NULL, NULL, 108948),
(108949, '1.20.58.830-FF-000016', NULL, 'Erythrocyte binding antigen-181', 119, NULL, NULL, 108949),
(108950, '3.90.79.10-FF-000138', NULL, 'Uncharacterized protein', 175, NULL, NULL, 108950),
(108951, '3.30.60.20-FF-000051', NULL, 'Thymidine kinase', 43, NULL, NULL, 108951),
(108952, '1.20.1250.20-FF-001428', NULL, 'Uncharacterized protein', 156, NULL, NULL, 108952),
(108953, '3.40.50.300-FF-004393', NULL, 'Ras family-domain-containing protein', 196, NULL, NULL, 108953),
(108954, '1.20.1070.10-FF-001327', NULL, 'Vomeronasal type-1 receptor', 206, NULL, NULL, 108954),
(108955, '3.30.200.20-FF-002501', NULL, 'Uncharacterized protein', 157, NULL, NULL, 108955),
(108956, '1.10.533.10-FF-000232', NULL, 'interleukin-1 receptor-associated kinase 4', 112, NULL, NULL, 108956),
(108957, '3.30.2350.20-FF-000027', NULL, 'tRNA pseudouridine synthase d domain-containing protein', 224, NULL, NULL, 108957),
(108958, '2.80.10.50-FF-000181', NULL, 'Fascin', 72, NULL, NULL, 108958),
(108959, '3.30.60.30-FF-000054', NULL, 'Agrin', 43, NULL, NULL, 108959),
(108960, '1.20.58.390-FF-000058', NULL, 'Nicotinic acetylcholine receptor alpha6, isoform D', 78, NULL, NULL, 108960),
(108961, '3.30.1390.20-FF-000024', NULL, 'Uncharacterized protein', 74, NULL, NULL, 108961),
(108962, '2.70.70.10-FF-000043', NULL, 'Conserved hypothetical secreted protein', 132, NULL, NULL, 108962),
(108963, '2.60.260.20-FF-000080', NULL, 'DnaJ family protein', 85, NULL, NULL, 108963),
(108964, '3.30.160.60-FF-002436', NULL, NULL, 29, NULL, NULL, 108964),
(108965, '1.25.40.20-FF-001022', NULL, 'Kinase, NEK', 127, NULL, NULL, 108965),
(108966, '3.40.50.2020-FF-000029', NULL, 'Orotate phosphoribosyltransferase', 181, NULL, NULL, 108966),
(108967, '3.30.160.750-FF-000001', NULL, 'S-adenosylmethionine decarboxylase proenzyme', 63, NULL, NULL, 108967),
(108968, '1.25.40.10-FF-002216', NULL, 'Os11g0460700 protein', 114, NULL, NULL, 108968),
(108969, '2.10.110.10-FF-000111', NULL, 'Four and a half LIM domains protein 3', 32, NULL, NULL, 108969),
(108970, '3.10.20.90-FF-000873', NULL, 'Uncharacterized protein', 66, NULL, NULL, 108970),
(108971, '3.30.2350.10-FF-000024', NULL, 'Putative ribosomal large subunit pseudouridylate synthase', 224, NULL, NULL, 108971),
(108972, '1.20.1070.10-FF-000130', NULL, 'Chemokine (C-C motif) receptor 2', 300, NULL, NULL, 108972),
(108973, '3.40.50.10470-FF-000045', NULL, 'Translation initiation factor eIF2B alpha subunit', 222, NULL, NULL, 108973),
(108974, '2.70.150.10-FF-000263', NULL, 'Phospholipid-transporting ATPase', 150, NULL, NULL, 108974);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(108975, '1.25.10.10-FF-001995', NULL, 'Uncharacterized protein', 222, NULL, NULL, 108975),
(108976, '3.30.70.2170-FF-000003', NULL, 'V-type ATP synthase subunit I', 61, NULL, NULL, 108976),
(108977, '3.30.390.50-FF-000011', NULL, 'Uncharacterized protein, isoform D', 86, NULL, NULL, 108977),
(108978, '2.120.10.10-FF-000020', NULL, 'Glycoprotein G', 427, NULL, NULL, 108978),
(108979, '2.70.170.10-FF-000270', NULL, 'Uncharacterized protein', 121, NULL, NULL, 108979),
(108980, '3.30.310.10-FF-000028', NULL, 'TATA-box-binding protein', 87, NULL, NULL, 108980),
(108981, '2.60.40.10-FF-004027', NULL, NULL, 143, NULL, NULL, 108981),
(108982, '1.10.1410.10-FF-000070', NULL, 'DNA polymerase sigma-like protein', 129, NULL, NULL, 108982),
(108983, '2.40.50.430-FF-000012', NULL, 'Uncharacterized protein', 136, NULL, NULL, 108983),
(108984, '1.20.1600.10-FF-000059', NULL, 'Outer membrane efflux protein', 406, NULL, NULL, 108984),
(108985, '3.30.1330.60-FF-000015', NULL, 'Outer membrane protein OmpA', 142, NULL, NULL, 108985),
(108986, '2.60.40.150-FF-000118', NULL, 'otoferlin isoform X1', 124, NULL, NULL, 108986),
(108987, '3.40.50.300-FF-000677', NULL, 'ATP-dependent RNA helicase A', 169, NULL, NULL, 108987),
(108988, '3.30.200.20-FF-000247', NULL, 'serine/threonine-protein kinase Nek4 isoform X1', 84, NULL, NULL, 108988),
(108989, '1.20.1250.20-FF-000012', NULL, 'Nucleoside permease NupG', 185, NULL, NULL, 108989),
(108990, '1.20.1250.20-FF-001198', NULL, 'Putative 3-phenylpropionic acid transporter', 187, NULL, NULL, 108990),
(108991, '1.10.274.30-FF-000034', NULL, 'Predicted protein', 87, NULL, NULL, 108991),
(108992, '3.20.20.70-FF-000581', NULL, NULL, 141, NULL, NULL, 108992),
(108993, '2.130.10.10-FF-000278', NULL, 'WD repeat-containing protein mip1', 223, NULL, NULL, 108993),
(108994, '2.30.29.30-FF-001164', NULL, 'Si:ch211-122h15.4', 104, NULL, NULL, 108994),
(108995, '4.10.640.10-FF-000008', NULL, '28S ribosomal protein S18b, mitochondrial', 64, NULL, NULL, 108995),
(108996, '3.40.50.2000-FF-000023', NULL, 'ADP-heptose--LPS heptosyltransferase II', 176, NULL, NULL, 108996),
(108997, '1.10.150.20-FF-000081', NULL, 'Protein translocation complex component (Npl1)', 66, NULL, NULL, 108997),
(108998, '2.130.10.10-FF-002644', NULL, 'Uncharacterized protein', 289, NULL, NULL, 108998),
(108999, '3.40.50.1820-FF-001149', NULL, 'Triacylglycerol lipase, putative', 67, NULL, NULL, 108999),
(109000, '1.20.1110.10-FF-000196', NULL, NULL, 130, NULL, NULL, 109000),
(109001, '2.120.10.80-FF-000350', NULL, 'Uncharacterized protein', 67, NULL, NULL, 109001),
(109002, '3.40.140.10-FF-000153', NULL, 'JAB1/MPN/MOV34 metalloenzyme domain containing protein', 84, NULL, NULL, 109002),
(109003, '1.25.40.10-FF-000311', NULL, 'Tetratricopeptide repeat domain 38', 168, NULL, NULL, 109003),
(109004, '3.90.550.10-FF-000509', NULL, 'Exostosin-2', 259, NULL, NULL, 109004),
(109005, '3.40.30.10-FF-000927', NULL, 'Uncharacterized protein C777.12c', 122, NULL, NULL, 109005),
(109006, '3.30.200.20-FF-001877', NULL, 'Predicted protein', 84, NULL, NULL, 109006),
(109007, '3.40.50.300-FF-001301', NULL, 'Structural maintenance of chromosomes 5', 171, NULL, NULL, 109007),
(109008, '3.30.450.40-FF-000176', NULL, 'Transcriptional regulator, IclR family', 175, NULL, NULL, 109008),
(109009, '3.30.830.10-FF-000275', NULL, 'Protease of the insulinase family', 230, NULL, NULL, 109009),
(109010, '1.20.120.1750-FF-000028', NULL, 'RBR-type E3 ubiquitin transferase', 76, NULL, NULL, 109010),
(109011, '2.60.40.10-FF-006051', NULL, NULL, 96, NULL, NULL, 109011),
(109012, '2.40.30.10-FF-000317', NULL, 'Elongation factor G', 111, NULL, NULL, 109012),
(109013, '3.30.497.10-FF-000112', NULL, 'Protease nexin PN-1', 70, NULL, NULL, 109013),
(109014, '3.40.525.10-FF-000002', NULL, 'Alpha-tocopherol transfer protein-like', 146, NULL, NULL, 109014),
(109015, '3.40.50.1000-FF-000622', NULL, NULL, 176, NULL, NULL, 109015),
(109016, '1.25.40.10-FF-003958', NULL, 'Uncharacterized protein', 253, NULL, NULL, 109016),
(109017, '1.10.10.60-FF-000267', NULL, 'HTH-type transcriptional regulator GadX', 120, NULL, NULL, 109017);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(109018, '2.10.22.10-FF-000002', NULL, 'Cysteine rich transmembrane BMP regulator 1', 29, NULL, NULL, 109018),
(109019, '3.40.50.2300-FF-000118', NULL, 'Maltose regulon regulatory protein MalI', 139, NULL, NULL, 109019),
(109020, '1.10.510.10-FF-004243', NULL, NULL, 199, NULL, NULL, 109020),
(109021, '2.60.40.10-FF-004920', NULL, NULL, 102, NULL, NULL, 109021),
(109022, '2.120.10.30-FF-000026', NULL, 'hedgehog-interacting protein-like isoform X1', 383, NULL, NULL, 109022),
(109023, '2.60.120.260-FF-000233', NULL, 'Anaphase promoting complex, subunit 10-like protein', 202, NULL, NULL, 109023),
(109024, '1.10.287.110-FF-000324', NULL, 'DnaJ-like protein subfamily C member 8', 92, NULL, NULL, 109024),
(109025, '1.10.510.10-FF-000084', NULL, 'Wall-associated receptor kinase 2', 218, NULL, NULL, 109025),
(109026, '3.20.20.120-FF-000009', NULL, 'L-talarate/galactarate dehydratase', 233, NULL, NULL, 109026),
(109027, '3.10.20.90-FF-000654', NULL, 'Small ubiquitin-related modifier 5', 101, NULL, NULL, 109027),
(109028, '1.20.120.350-FF-000057', NULL, 'Sodium channel protein', 122, NULL, NULL, 109028),
(109029, '2.70.130.10-FF-000161', NULL, NULL, 104, NULL, NULL, 109029),
(109030, '3.80.10.10-FF-001318', NULL, 'Leucine-rich repeat protein kinase family protein', 69, NULL, NULL, 109030),
(109031, '2.60.40.10-FF-002554', NULL, NULL, 90, NULL, NULL, 109031),
(109032, '1.10.472.10-FF-000084', NULL, 'PCL9p Cyclin', 206, NULL, NULL, 109032),
(109033, '3.40.50.300-FF-008333', NULL, 'Uncharacterized protein', 237, NULL, NULL, 109033),
(109034, '1.25.40.10-FF-004801', NULL, 'Paf1 complex protein', 271, NULL, NULL, 109034),
(109035, '3.90.550.10-FF-000280', NULL, 'CDP-glycerol:poly(Glycerophosphate) glycerophosphotransferase', 199, NULL, NULL, 109035),
(109036, '3.90.950.10-FF-000023', NULL, 'Inosine triphosphate pyrophosphatase, putative', 183, NULL, NULL, 109036),
(109037, '3.30.70.1450-FF-000012', NULL, 'Trk system potassium uptake protein TrkA', 82, NULL, NULL, 109037),
(109038, '3.90.550.10-FF-000616', NULL, 'Uncharacterized protein', 212, NULL, NULL, 109038),
(109039, '3.20.80.10-FF-000027', NULL, 'Uncharacterized protein', 201, NULL, NULL, 109039),
(109040, '1.25.40.240-FF-000009', NULL, NULL, 146, NULL, NULL, 109040),
(109041, '2.20.70.10-FF-000141', NULL, 'Uncharacterized protein', 73, NULL, NULL, 109041),
(109042, '3.20.20.100-FF-000003', NULL, 'Aldo-keto reductase family 1 member C3', 323, NULL, NULL, 109042),
(109043, '3.40.50.1820-FF-001823', NULL, 'Triacylglycerol lipase, putative', 96, NULL, NULL, 109043),
(109044, '2.60.120.920-FF-000139', NULL, 'FinTRIM family, member 82', 184, NULL, NULL, 109044),
(109045, '3.90.550.50-FF-000044', NULL, 'Hexosyltransferase', 124, NULL, NULL, 109045),
(109046, '3.30.310.130-FF-000036', NULL, 'Predicted protein', 81, NULL, NULL, 109046),
(109047, '1.20.1070.10-FF-001546', NULL, 'Uncharacterized protein', 177, NULL, NULL, 109047),
(109048, '1.10.10.60-FF-000048', NULL, 'Distal-less homeobox 2', 70, NULL, NULL, 109048),
(109049, '2.20.100.10-FF-000001', NULL, 'semaphorin-5A isoform X1', 56, NULL, NULL, 109049),
(109050, '1.10.510.10-FF-002556', NULL, 'Putative mitogen-activated protein kinase kinase kinase 7-like', 273, NULL, NULL, 109050),
(109051, '1.10.1170.10-FF-000027', NULL, 'Baculoviral IAP repeat-containing 7', 109, NULL, NULL, 109051),
(109052, '3.30.70.330-FF-000035', NULL, '60S ribosomal protein L23a', 120, NULL, NULL, 109052),
(109053, '3.40.50.1820-FF-000300', NULL, 'Lysosomal thioesterase PPT2-B', 322, NULL, NULL, 109053),
(109054, '3.40.50.1000-FF-000841', NULL, NULL, 70, NULL, NULL, 109054),
(109055, '2.30.29.230-FF-000010', NULL, 'Uncharacterized protein', 141, NULL, NULL, 109055),
(109056, '1.10.472.10-FF-000202', NULL, 'BnaA03g50910D protein', 107, NULL, NULL, 109056),
(109057, '3.30.110.150-FF-000002', NULL, 'Cell division protein SepF', 95, NULL, NULL, 109057),
(109058, '3.80.10.10-FF-003454', NULL, 'Predicted protein', 243, NULL, NULL, 109058),
(109059, '1.10.238.10-FF-000158', NULL, 'Calcium-dependent protein kinase 28', 70, NULL, NULL, 109059);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(109060, '3.90.1290.10-FF-000056', NULL, 'Microtubule-actin crosslinking factor 1', 135, NULL, NULL, 109060),
(109061, '3.40.50.300-FF-006079', NULL, 'Elongation factor, putative', 149, NULL, NULL, 109061),
(109062, '3.40.50.10190-FF-000287', NULL, 'Uncharacterized protein', 104, NULL, NULL, 109062),
(109063, '3.30.60.190-FF-000013', NULL, 'Box C/D snoRNA processing protein, putative', 50, NULL, NULL, 109063),
(109064, '3.30.200.20-FF-001658', NULL, 'Uncharacterized protein', 86, NULL, NULL, 109064),
(109065, '3.30.70.330-FF-002171', NULL, NULL, 84, NULL, NULL, 109065),
(109066, '3.30.70.340-FF-000038', NULL, NULL, 52, NULL, NULL, 109066),
(109067, '3.10.100.10-FF-000410', NULL, NULL, 106, NULL, NULL, 109067),
(109068, '2.60.40.150-FF-000332', NULL, 'Uncharacterized protein', 165, NULL, NULL, 109068),
(109069, '3.40.50.880-FF-000036', NULL, 'Imidazole glycerol phosphate synthase hisHF', 226, NULL, NULL, 109069),
(109070, '3.90.1170.10-FF-000002', NULL, '60S ribosomal protein L10', 199, NULL, NULL, 109070),
(109071, '3.40.630.30-FF-000685', NULL, 'Uncharacterized protein', 81, NULL, NULL, 109071),
(109072, '1.25.40.10-FF-000530', NULL, 'Pentatricopeptide repeat-containing protein At1g74850, chloroplastic', 103, NULL, NULL, 109072),
(109073, '1.20.140.100-FF-000003', NULL, 'Dynein, axonemal, heavy chain 5', 153, NULL, NULL, 109073),
(109074, '1.10.20.10-FF-000124', NULL, 'CCAAT-HAP3 transcription factor', 126, NULL, NULL, 109074),
(109075, '1.25.40.20-FF-000533', NULL, 'ankyrin repeat and SAM domain-containing protein 6 isoform X1', 93, NULL, NULL, 109075),
(109076, '3.40.50.1820-FF-001475', NULL, 'Uncharacterized protein C8F11.08c', 173, NULL, NULL, 109076),
(109077, '2.30.42.10-FF-000053', NULL, 'FERM and PDZ domain-containing protein 4', 89, NULL, NULL, 109077),
(109078, '2.60.40.2860-FF-000001', NULL, '6-cysteine protein', 141, NULL, NULL, 109078),
(109079, '1.20.1250.20-FF-000231', NULL, 'EmrB/QacA subfamily drug resistance transporter', 192, NULL, NULL, 109079),
(109080, '1.10.1200.10-FF-000149', NULL, 'Polyketide synthase/nonribosomal peptide synthetase hybrid RzxA', 82, NULL, NULL, 109080),
(109081, '1.10.150.20-FF-000204', NULL, 'PIN domain-like protein', 69, NULL, NULL, 109081),
(109082, '2.10.110.10-FF-000116', NULL, 'Ap, isoform A', 75, NULL, NULL, 109082),
(109083, '1.10.238.10-FF-000832', NULL, 'Calmodulin-like protein 10', 84, NULL, NULL, 109083),
(109084, '3.30.420.40-FF-000348', NULL, 'Transcriptional regulator Mb0495', 131, NULL, NULL, 109084),
(109085, '2.60.40.10-FF-002447', NULL, 'Related to J kappa-recombination signal binding protein', 88, NULL, NULL, 109085),
(109086, '3.40.50.300-FF-008226', NULL, 'ABC transporter', 63, NULL, NULL, 109086),
(109087, '3.40.640.10-FF-000067', NULL, 'Aminotransferase, class I/classII', 239, NULL, NULL, 109087),
(109088, '3.30.830.10-FF-000270', NULL, 'Clan ME, family M16, insulinase-like metallopeptidase', 240, NULL, NULL, 109088),
(109089, '3.30.390.60-FF-000014', NULL, 'Heat-inducible transcription repressor HrcA', 101, NULL, NULL, 109089),
(109090, '1.25.10.10-FF-000921', NULL, 'USO1 (Yeast transport protein) homolog', 618, NULL, NULL, 109090),
(109091, '3.30.200.20-FF-000135', NULL, 'Tyrosine-protein kinase', 109, NULL, NULL, 109091),
(109092, '3.30.540.10-FF-000056', NULL, 'Fructose-1,6-bisphosphatase class 1', 182, NULL, NULL, 109092),
(109093, '3.10.450.720-FF-000001', NULL, 'Ribosomal RNA small subunit methyltransferase F', 169, NULL, NULL, 109093),
(109094, '3.30.40.10-FF-001238', NULL, 'Increased DNA methylation 1', 56, NULL, NULL, 109094),
(109095, '1.10.510.10-FF-000191', NULL, 'cyclin-dependent kinase-like 1 isoform X1', 207, NULL, NULL, 109095),
(109096, '3.40.50.300-FF-005005', NULL, 'Elongation factor EF-2', 125, NULL, NULL, 109096),
(109097, '3.30.70.330-FF-001895', NULL, NULL, 84, NULL, NULL, 109097),
(109098, '1.10.20.10-FF-000017', NULL, 'Ccaat-binding factor complex subunit', 119, NULL, NULL, 109098),
(109099, '2.60.40.10-FF-004353', NULL, NULL, 95, NULL, NULL, 109099),
(109100, '2.10.25.10-FF-001330', NULL, 'Uncharacterized protein', 29, NULL, NULL, 109100);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(109101, '3.40.30.10-FF-000591', NULL, 'Protein CBG18221', 131, NULL, NULL, 109101),
(109102, '3.40.50.150-FF-000048', NULL, 'Spermidine synthase 1', 239, NULL, NULL, 109102),
(109103, '2.80.10.50-FF-000186', NULL, 'Beta-galactosidase', 141, NULL, NULL, 109103),
(109104, '3.30.160.60-FF-001132', NULL, 'Zinc finger protein 341', 31, NULL, NULL, 109104),
(109105, '1.20.1250.80-FF-000002', NULL, 'Interleukin 34', 165, NULL, NULL, 109105),
(109106, '2.170.270.10-FF-000118', NULL, 'Histone-lysine N-methyltransferase', 244, NULL, NULL, 109106),
(109107, '1.10.30.10-FF-000169', NULL, 'Uncharacterized protein', 41, NULL, NULL, 109107),
(109108, '2.30.29.240-FF-000013', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 210, NULL, NULL, 109108),
(109109, '4.10.860.120-FF-000014', NULL, 'DNA-directed RNA polymerase subunit', 120, NULL, NULL, 109109),
(109110, '3.30.710.10-FF-000002', NULL, 'Potassium voltage-gated channel subfamily C member 2', 118, NULL, NULL, 109110),
(109111, '1.10.510.10-FF-004355', NULL, NULL, 114, NULL, NULL, 109111),
(109112, '2.120.10.80-FF-000131', NULL, 'Kel3p', 330, NULL, NULL, 109112),
(109113, '1.20.1270.350-FF-000001', NULL, 'dedicator of cytokinesis protein 4', 97, NULL, NULL, 109113),
(109114, '1.10.8.1190-FF-000001', NULL, 'Replicase polyprotein 1a', 124, NULL, NULL, 109114),
(109115, '3.30.200.20-FF-000028', NULL, 'Mitogen-activated protein kinase', 118, NULL, NULL, 109115),
(109116, '3.40.1090.10-FF-000029', NULL, 'Triacylglycerol lipase', 226, NULL, NULL, 109116),
(109117, '2.40.110.10-FF-000076', NULL, 'Predicted protein', 68, NULL, NULL, 109117),
(109118, '1.20.1250.20-FF-001754', NULL, 'Uncharacterized protein', 193, NULL, NULL, 109118),
(109119, '2.40.30.10-FF-000312', NULL, 'Peroxisome biogenesis protein 6', 19, NULL, NULL, 109119),
(109120, '3.30.160.60-FF-000856', NULL, 'B-box zinc finger protein 21', 98, NULL, NULL, 109120),
(109121, '1.10.510.10-FF-004462', NULL, NULL, 279, NULL, NULL, 109121),
(109122, '2.60.40.10-FF-004701', NULL, NULL, 99, NULL, NULL, 109122),
(109123, '1.10.20.120-FF-000019', NULL, 'Uncharacterized protein', 177, NULL, NULL, 109123),
(109124, '1.10.10.10-FF-001697', NULL, 'Uncharacterized protein', 104, NULL, NULL, 109124),
(109125, '2.60.120.650-FF-000024', NULL, 'Putative jumonji family transcription factor', 318, NULL, NULL, 109125),
(109126, '3.60.20.40-FF-000019', NULL, 'ACY1 bifunctional acylase', 172, NULL, NULL, 109126),
(109127, '1.20.1310.10-FF-000071', NULL, 'Ubiquitin-protein ligase, putative', 119, NULL, NULL, 109127),
(109128, '3.40.50.880-FF-000143', NULL, 'Intraflagellar transport protein IFT52, putative', 138, NULL, NULL, 109128),
(109129, '1.10.720.60-FF-000007', NULL, 'Enolase-phosphatase E1', 81, NULL, NULL, 109129),
(109130, '2.30.30.40-FF-000164', NULL, 'Cell division control protein', 59, NULL, NULL, 109130),
(109131, '3.30.200.20-FF-000354', NULL, 'AGC/YANK protein kinase', 89, NULL, NULL, 109131),
(109132, '2.130.10.10-FF-002195', NULL, 'Uncharacterized protein', 128, NULL, NULL, 109132),
(109133, '4.10.400.10-FF-000362', NULL, 'Uncharacterized protein', 56, NULL, NULL, 109133),
(109134, '1.10.1620.20-FF-000009', NULL, 'Putative ATP synthase subunit epsilon, mitochondrial', 53, NULL, NULL, 109134),
(109135, '2.60.34.10-FF-000134', NULL, 'Heat shock protein 70 (HSP70)-4, putative', 75, NULL, NULL, 109135),
(109136, '1.20.120.230-FF-000026', NULL, 'Rhea, isoform B', 123, NULL, NULL, 109136),
(109137, '2.40.160.60-FF-000010', NULL, 'Outer membrane protein P1 (OmpP1)', 436, NULL, NULL, 109137),
(109138, '3.40.50.2300-FF-000225', NULL, 'Sigma-54-dependent Fis family transcriptional regulator', 129, NULL, NULL, 109138),
(109139, '3.30.160.60-FF-000637', NULL, 'Zinc finger protein', 28, NULL, NULL, 109139),
(109140, '3.60.20.30-FF-000016', NULL, NULL, 150, NULL, NULL, 109140),
(109141, '2.110.10.10-FF-000009', NULL, 'Hemopexin', 190, NULL, NULL, 109141),
(109142, '2.30.30.30-FF-000161', NULL, 'Uncharacterized protein', 26, NULL, NULL, 109142),
(109143, '2.130.10.10-FF-002537', NULL, 'Uncharacterized protein', 270, NULL, NULL, 109143);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(109144, '3.40.190.10-FF-000083', NULL, 'HTH-type transcriptional regulator MetR', 104, NULL, NULL, 109144),
(109145, '3.90.70.10-FF-000725', NULL, 'Uncharacterized protein', 186, NULL, NULL, 109145),
(109146, '3.90.79.20-FF-000029', NULL, 'Probable NADH pyrophosphatase', 111, NULL, NULL, 109146),
(109147, '3.40.50.2000-FF-000130', NULL, 'Glycosyl transferases group 1 family protein', 288, NULL, NULL, 109147),
(109148, '3.30.70.660-FF-000010', NULL, 'tRNA pseudouridine synthase', 170, NULL, NULL, 109148),
(109149, '3.10.20.740-FF-000012', NULL, 'Formate dehydrogenase, alpha subunit', 116, NULL, NULL, 109149),
(109150, '1.25.40.20-FF-001241', NULL, 'Transient receptor potential channel pyrexia', 375, NULL, NULL, 109150),
(109151, '3.40.50.300-FF-004623', NULL, 'SNF2 family N-terminal domain-domain-containing protein', 244, NULL, NULL, 109151),
(109152, '2.40.30.170-FF-000031', NULL, 'Multidrug resistance protein, putative', 83, NULL, NULL, 109152),
(109153, '3.40.50.300-FF-002594', NULL, 'Pilus assembly protein', 225, NULL, NULL, 109153),
(109154, '2.40.30.10-FF-000194', NULL, '50S ribosomal protein L3', 80, NULL, NULL, 109154),
(109155, '2.60.40.10-FF-002228', NULL, 'EPH receptor B2', 49, NULL, NULL, 109155),
(109156, '1.10.238.10-FF-000725', NULL, 'Calmodulin-like protein, putative', 60, NULL, NULL, 109156),
(109157, '3.40.50.300-FF-008007', NULL, 'Mitogen-activated protein kinase', 147, NULL, NULL, 109157),
(109158, '3.40.47.10-FF-000112', NULL, '3-oxoacyl-(Acyl-carrier-protein) synthase II', 152, NULL, NULL, 109158),
(109159, '3.90.79.10-FF-000026', NULL, 'Adenine DNA glycosylase', 150, NULL, NULL, 109159),
(109160, '1.10.720.50-FF-000004', NULL, 'DNA (cytosine-5-)-methyltransferase 3 beta, duplicate a', 66, NULL, NULL, 109160),
(109161, '2.40.50.100-FF-000161', NULL, 'Exosome complex component CSL4', 49, NULL, NULL, 109161),
(109162, '1.10.238.10-FF-000377', NULL, 'Serine/threonine-protein phosphatase', 81, NULL, NULL, 109162),
(109163, '1.25.40.20-FF-000752', NULL, 'Si:dkey-9i23.14', 125, NULL, NULL, 109163),
(109164, '1.20.1250.20-FF-001193', NULL, 'Signal transducer', 191, NULL, NULL, 109164),
(109165, '3.80.10.10-FF-003673', NULL, 'SCF E3 ubiquitin ligase complex F-box protein pof2', 217, NULL, NULL, 109165),
(109166, '1.10.472.10-FF-000421', NULL, 'D1-type cyclin', 72, NULL, NULL, 109166),
(109167, '3.30.40.10-FF-002300', NULL, 'Uncharacterized protein', 117, NULL, NULL, 109167),
(109168, '2.60.40.1120-FF-000047', NULL, 'TonB-linked outer membrane protein, SusC/RagA family', 72, NULL, NULL, 109168),
(109169, '3.30.30.10-FF-000001', NULL, 'Drosomycin 13', 44, NULL, NULL, 109169),
(109170, '1.20.272.10-FF-000050', NULL, NULL, 116, NULL, NULL, 109170),
(109171, '3.40.50.2020-FF-000136', NULL, 'Ribose-phosphate pyrophosphokinase', 144, NULL, NULL, 109171),
(109172, '1.20.1250.20-FF-001316', NULL, 'Monocarboxylate transporter, putative', 242, NULL, NULL, 109172),
(109173, '3.30.40.10-FF-001676', NULL, 'Histone-lysine N-methyltransferase', 76, NULL, NULL, 109173),
(109174, '1.10.20.10-FF-000343', NULL, NULL, 100, NULL, NULL, 109174),
(109175, '1.25.10.10-FF-000360', NULL, 'AP-3 complex subunit delta', 575, NULL, NULL, 109175),
(109176, '1.10.238.10-FF-001001', NULL, 'Phosphoinositide phospholipase C', 84, NULL, NULL, 109176),
(109177, '3.40.50.1820-FF-001256', NULL, 'Chromosome 1, whole genome shotgun sequence', 312, NULL, NULL, 109177),
(109178, '2.40.70.10-FF-000314', NULL, NULL, 147, NULL, NULL, 109178),
(109179, '3.30.428.10-FF-000014', NULL, 'Putative histidine triad (HIT) protein', 138, NULL, NULL, 109179),
(109180, '3.10.20.90-FF-000980', NULL, 'Uncharacterized protein', 152, NULL, NULL, 109180),
(109181, '1.10.720.40-FF-000001', NULL, 'LEM domain containing 2, isoform CRA_a', 108, NULL, NULL, 109181),
(109182, '1.25.40.10-FF-002104', NULL, 'Putative pentatricopeptide repeat-containing protein At3g05240', 126, NULL, NULL, 109182),
(109183, '2.130.10.10-FF-003948', NULL, 'Predicted protein', 247, NULL, NULL, 109183),
(109184, '3.10.50.40-FF-000158', NULL, 'Peptidylprolyl isomerase', 118, NULL, NULL, 109184);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(109185, '3.30.70.1230-FF-000188', NULL, 'Predicted protein', 157, NULL, NULL, 109185),
(109186, '1.10.560.10-FF-000143', NULL, 'Chaperonin 60 subunit alpha 2 chloroplastic', 37, NULL, NULL, 109186),
(109187, '3.40.50.300-FF-004281', NULL, 'Uncharacterized protein', 300, NULL, NULL, 109187),
(109188, '3.40.50.150-FF-001689', NULL, NULL, 110, NULL, NULL, 109188),
(109189, '1.10.1510.30-FF-000010', NULL, 'Probable tRNA pseudouridine synthase D', 87, NULL, NULL, 109189),
(109190, '2.40.100.10-FF-000031', NULL, 'Peptidyl-prolyl cis-trans isomerase', 179, NULL, NULL, 109190),
(109191, '1.10.287.110-FF-000217', NULL, 'DnaJ heat shock protein family (Hsp40) member B5', 107, NULL, NULL, 109191),
(109192, '3.10.20.90-FF-000087', NULL, 'Inhibitor of nuclear factor kappa B kinase subunit beta', 88, NULL, NULL, 109192),
(109193, '3.90.70.10-FF-000506', NULL, 'Cathepsin L-like cysteine proteinase', 316, NULL, NULL, 109193),
(109194, '2.40.50.140-FF-000144', NULL, 'Aspartate--tRNA ligase, cytoplasmic', 132, NULL, NULL, 109194),
(109195, '2.40.180.10-FF-000024', NULL, 'Uncharacterized protein', 212, NULL, NULL, 109195),
(109196, '1.20.120.350-FF-000276', NULL, NULL, 37, NULL, NULL, 109196),
(109197, '2.60.40.150-FF-000556', NULL, 'C2-domain protein, putative', 118, NULL, NULL, 109197),
(109198, '2.60.40.60-FF-000961', NULL, 'Uncharacterized protein', 82, NULL, NULL, 109198),
(109199, '1.25.40.1050-FF-000002', NULL, '5''-3'' exoribonuclease', 102, NULL, NULL, 109199),
(109200, '3.10.20.90-FF-000435', NULL, 'UBX domain-containing protein 2', 83, NULL, NULL, 109200),
(109201, '2.30.180.10-FF-000178', NULL, NULL, 135, NULL, NULL, 109201),
(109202, '3.80.10.10-FF-001537', NULL, 'Si:ch211-233m11.1', 103, NULL, NULL, 109202),
(109203, '3.40.50.10860-FF-000055', NULL, 'Methenyl tetrahydrofolate cyclohydrolase / NADP-dependent methylene H4F dehydrogenase', 154, NULL, NULL, 109203),
(109204, '3.40.50.1780-FF-000030', NULL, 'Uncharacterized protein', 120, NULL, NULL, 109204),
(109205, '3.90.79.10-FF-000245', NULL, 'Isopentenyl-diphosphate Delta-isomerase', 161, NULL, NULL, 109205),
(109206, '3.30.160.60-FF-000424', NULL, 'Zinc finger protein 140', 29, NULL, NULL, 109206),
(109207, '3.90.1170.20-FF-000005', NULL, 'Nicotinate-nucleotide pyrophosphorylase [carboxylating]', 105, NULL, NULL, 109207),
(109208, '3.30.420.10-FF-000587', NULL, NULL, 212, NULL, NULL, 109208),
(109209, '3.40.50.300-FF-008552', NULL, 'Uncharacterized protein', 55, NULL, NULL, 109209),
(109210, '1.20.1250.20-FF-001535', NULL, 'Facilitated trehalose transporter Tret1-2-like protein', 443, NULL, NULL, 109210),
(109211, '2.60.40.60-FF-000068', NULL, 'Desmoglein 1', 106, NULL, NULL, 109211),
(109212, '2.40.20.10-FF-000036', NULL, 'Uncharacterized protein', 60, NULL, NULL, 109212),
(109213, '3.40.190.10-FF-000206', NULL, 'Ferric iron ABC transporter, iron-binding protein', 153, NULL, NULL, 109213),
(109214, '1.25.40.10-FF-002323', NULL, 'Lethal (2) k14710, isoform A', 87, NULL, NULL, 109214),
(109215, '3.40.630.30-FF-000466', NULL, 'Acetyltransferase, GNAT family', 166, NULL, NULL, 109215),
(109216, '1.10.510.10-FF-004136', NULL, NULL, 76, NULL, NULL, 109216),
(109217, '3.40.50.200-FF-000198', NULL, 'Putative serine protease (Putative secreted protein)', 332, NULL, NULL, 109217),
(109218, '3.90.226.10-FF-000127', NULL, 'Malonate decarboxylase, gamma subunit', 231, NULL, NULL, 109218),
(109219, '3.90.70.10-FF-000158', NULL, 'CathePsin Z', 269, NULL, NULL, 109219),
(109220, '3.40.109.10-FF-000024', NULL, 'Nitroreductase', 183, NULL, NULL, 109220),
(109221, '2.60.40.10-FF-002099', NULL, 'Glycoprotein E', 191, NULL, NULL, 109221),
(109222, '3.40.50.150-FF-000722', NULL, 'Predicted protein', 237, NULL, NULL, 109222),
(109223, '1.10.220.150-FF-000050', NULL, 'Uncharacterized protein', 130, NULL, NULL, 109223),
(109224, '3.90.120.10-FF-000011', NULL, 'Cytosine-C5 specific DNA methyltransferase', 32, NULL, NULL, 109224),
(109225, '3.40.120.10-FF-000039', NULL, 'Phosphoacetylglucosamine mutase', 147, NULL, NULL, 109225),
(109226, '3.40.50.720-FF-000123', NULL, 'Fatty acyl-CoA reductase', 348, NULL, NULL, 109226);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(109227, '2.60.40.10-FF-003858', NULL, NULL, 104, NULL, NULL, 109227),
(109228, '3.30.379.10-FF-000001', NULL, 'Beta-hexosaminidase subunit beta', 144, NULL, NULL, 109228),
(109229, '2.60.120.200-FF-000131', NULL, 'Probable alpha-L-arabinofuranosidase B', 320, NULL, NULL, 109229),
(109230, '3.10.330.10-FF-000005', NULL, 'AAA family ATPase', 83, NULL, NULL, 109230),
(109231, '1.25.40.10-FF-000069', NULL, 'CTR9 homolog, Paf1/RNA polymerase II complex component', 105, NULL, NULL, 109231),
(109232, '3.60.20.10-FF-000010', NULL, 'Proteasome subunit beta type-1', 198, NULL, NULL, 109232),
(109233, '1.10.1370.30-FF-000021', NULL, 'Angiotensin-converting enzyme', 141, NULL, NULL, 109233),
(109234, '3.30.50.10-FF-000103', NULL, 'Zinc finger protein, putative', 35, NULL, NULL, 109234),
(109235, '3.10.330.20-FF-000008', NULL, 'tRNA (Adenine-N(1)-)-methyltransferase', 62, NULL, NULL, 109235),
(109236, '2.30.130.10-FF-000029', NULL, 'tRNA pseudouridine synthase B', 60, NULL, NULL, 109236),
(109237, '3.10.100.10-FF-000292', NULL, NULL, 141, NULL, NULL, 109237),
(109238, '2.60.40.1170-FF-000039', NULL, 'Coatomer subunit delta', 113, NULL, NULL, 109238),
(109239, '3.40.50.12440-FF-000001', NULL, 'Nitrate reductase subunit alpha', 1191, NULL, NULL, 109239),
(109240, '3.40.50.1820-FF-001604', NULL, 'Uncharacterized protein', 79, NULL, NULL, 109240),
(109241, '2.60.40.790-FF-000057', NULL, 'Small heat shock protein, putative', 187, NULL, NULL, 109241),
(109242, '1.10.506.10-FF-000079', NULL, 'Uncharacterized protein', 177, NULL, NULL, 109242),
(109243, '3.40.850.20-FF-000002', NULL, 'Vegetative interaction with Kar3p', 298, NULL, NULL, 109243),
(109244, '3.10.20.30-FF-000108', NULL, NULL, 126, NULL, NULL, 109244),
(109245, '2.130.10.10-FF-000520', NULL, 'Protein CYPRO4', 296, NULL, NULL, 109245),
(109246, '1.10.238.10-FF-000506', NULL, 'Calcium-binding protein CML38', 71, NULL, NULL, 109246),
(109247, '2.60.40.10-FF-004134', NULL, NULL, 139, NULL, NULL, 109247),
(109248, '1.20.1070.10-FF-001765', NULL, 'Uncharacterized protein', 66, NULL, NULL, 109248),
(109249, '1.10.3720.10-FF-000071', NULL, 'Binding-protein dependent transport system inner membrane protein', 260, NULL, NULL, 109249),
(109250, '3.40.50.1100-FF-000208', NULL, 'Uncharacterized protein', 148, NULL, NULL, 109250),
(109251, '3.30.70.330-FF-001676', NULL, NULL, 72, NULL, NULL, 109251),
(109252, '3.30.420.510-FF-000006', NULL, 'Pantothenate kinase', 108, NULL, NULL, 109252),
(109253, '3.30.160.60-FF-002099', NULL, 'Zinc finger protein 589', 25, NULL, NULL, 109253),
(109254, '3.40.630.10-FF-000460', NULL, 'Uncharacterized protein', 130, NULL, NULL, 109254),
(109255, '1.10.132.60-FF-000028', NULL, 'DNA polymerase', 154, NULL, NULL, 109255),
(109256, '2.30.30.40-FF-000377', NULL, 'N-acetylmuramoyl-L-alanine amidase', 70, NULL, NULL, 109256),
(109257, '1.25.10.10-FF-000702', NULL, 'Putative sister chromatid cohesion and DNA repair protein', 268, NULL, NULL, 109257),
(109258, '3.10.28.10-FF-000007', NULL, 'Intron-encoded DNA endonuclease aI3', 124, NULL, NULL, 109258),
(109259, '3.30.730.20-FF-000001', NULL, 'Cell division activator CedA', 67, NULL, NULL, 109259),
(109260, '3.70.10.10-FF-000116', NULL, 'Uncharacterized protein', 241, NULL, NULL, 109260),
(109261, '2.60.40.60-FF-000742', NULL, 'Cdh-4', 109, NULL, NULL, 109261),
(109262, '1.10.340.30-FF-000025', NULL, 'Endonuclease III homolog', 105, NULL, NULL, 109262),
(109263, '3.30.160.60-FF-006152', NULL, NULL, 33, NULL, NULL, 109263),
(109264, '3.40.50.10810-FF-000068', NULL, 'SNF2 domain-containing protein / helicase domain-containing protein / zinc finger protein-like protein', 130, NULL, NULL, 109264),
(109265, '3.10.20.90-FF-000542', NULL, 'Uncharacterized protein', 81, NULL, NULL, 109265),
(109266, '1.25.40.20-FF-000639', NULL, 'Uncharacterized protein', 101, NULL, NULL, 109266),
(109267, '1.10.10.10-FF-000393', NULL, 'Oocyte-specific H1 histone', 89, NULL, NULL, 109267),
(109268, '3.40.1230.10-FF-000018', NULL, 'Predicted protein', 115, NULL, NULL, 109268),
(109269, '3.30.1370.70-FF-000009', NULL, NULL, 88, NULL, NULL, 109269);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(109270, '1.10.10.10-FF-001011', NULL, 'LuxR family transcriptional regulator', 69, NULL, NULL, 109270),
(109271, '3.30.450.50-FF-000067', NULL, 'Uncharacterized protein', 62, NULL, NULL, 109271),
(109272, '1.10.287.110-FF-000094', NULL, 'dnaJ homolog subfamily C member 28', 78, NULL, NULL, 109272),
(109273, '3.30.830.10-FF-000051', NULL, 'A-pheromone processing metallopeptidase Ste23', 256, NULL, NULL, 109273),
(109274, '3.30.160.60-FF-002880', NULL, 'Zinc finger imprinted 3', 28, NULL, NULL, 109274),
(109275, '3.30.70.1070-FF-000005', NULL, 'Endolytic peptidoglycan transglycosylase RlpA', 78, NULL, NULL, 109275),
(109276, '3.40.50.150-FF-000273', NULL, 'NOL1/NOP2/Sun domain family protein', 258, NULL, NULL, 109276),
(109277, '1.10.472.10-FF-000314', NULL, 'GD19061', 159, NULL, NULL, 109277),
(109278, '2.60.40.2170-FF-000002', NULL, 'Tyrosine-protein kinase RYK', 136, NULL, NULL, 109278),
(109279, '3.30.70.1060-FF-000002', NULL, 'Possible muconolactone isomerase', 95, NULL, NULL, 109279),
(109280, '3.40.50.1820-FF-001711', NULL, 'Oxysterol-binding protein-related protein 3B', 144, NULL, NULL, 109280),
(109281, '1.10.510.10-FF-003967', NULL, 'Uncharacterized protein', 389, NULL, NULL, 109281),
(109282, '3.30.70.330-FF-000147', NULL, 'Apoptotic chromatin condensation inducer in the nucleus', 77, NULL, NULL, 109282),
(109283, '2.40.50.100-FF-000048', NULL, 'Protein Abitram', 125, NULL, NULL, 109283),
(109284, '3.30.200.20-FF-002046', NULL, 'Uncharacterized protein', 89, NULL, NULL, 109284),
(109285, '2.70.20.10-FF-000001', NULL, 'DNA topoisomerase', 128, NULL, NULL, 109285),
(109286, '2.30.30.30-FF-000048', NULL, 'Mitochondrial ribosomal protein L2', 81, NULL, NULL, 109286),
(109287, '1.10.510.10-FF-002444', NULL, NULL, 206, NULL, NULL, 109287),
(109288, '2.130.10.130-FF-000016', NULL, 'Phosphatidylinositol-glycan-specific phospholipase D', 190, NULL, NULL, 109288),
(109289, '1.10.3720.10-FF-000065', NULL, 'Peptide ABC transporter permease', 218, NULL, NULL, 109289),
(109290, '3.40.50.150-FF-001796', NULL, NULL, 303, NULL, NULL, 109290),
(109291, '2.120.10.30-FF-000470', NULL, 'Predicted protein', 65, NULL, NULL, 109291),
(109292, '3.40.50.300-FF-004516', NULL, 'ATP-dependent DNA helicase RecQ', 211, NULL, NULL, 109292),
(109293, '3.30.160.60-FF-000750', NULL, 'replication initiator 1 isoform X2', 29, NULL, NULL, 109293),
(109294, '1.20.1420.30-FF-000051', NULL, 'Na+/Ca+ antiporter, CaCA family', 150, NULL, NULL, 109294),
(109295, '1.10.287.1040-FF-000014', NULL, 'Exodeoxyribonuclease 7 small subunit', 75, NULL, NULL, 109295),
(109296, '2.90.10.10-FF-000005', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', 128, NULL, NULL, 109296),
(109297, '3.40.630.30-FF-000573', NULL, 'Si:ch211-196f2.7', 106, NULL, NULL, 109297),
(109298, '2.60.200.20-FF-000205', NULL, 'Serine/threonine protein kinase', 115, NULL, NULL, 109298),
(109299, '2.130.10.10-FF-004117', NULL, 'Uncharacterized protein', 189, NULL, NULL, 109299),
(109300, '3.40.630.10-FF-000128', NULL, 'Protein CBG20482', 332, NULL, NULL, 109300),
(109301, '3.30.365.10-FF-000059', NULL, 'Uncharacterized protein', 11, NULL, NULL, 109301),
(109302, '3.30.1360.120-FF-000047', NULL, 'IBA57, iron-sulfur cluster assembly', 148, NULL, NULL, 109302),
(109303, '3.90.550.10-FF-000386', NULL, '2-phospho-L-lactate guanylyltransferase', 176, NULL, NULL, 109303),
(109304, '2.60.40.10-FF-000194', NULL, 'Intercellular adhesion molecule 1', 84, NULL, NULL, 109304),
(109305, '2.30.30.40-FF-000490', NULL, 'Predicted protein', 89, NULL, NULL, 109305),
(109306, '3.40.50.1010-FF-000277', NULL, NULL, 85, NULL, NULL, 109306),
(109307, '3.40.50.1980-FF-000084', NULL, 'Iron-dicitrate ABC transporter bindinglipoprotein', 167, NULL, NULL, 109307),
(109308, '3.40.50.300-FF-002369', NULL, 'GTPase HflX', 170, NULL, NULL, 109308),
(109309, '3.30.160.60-FF-000418', NULL, 'zinc finger protein 48', 31, NULL, NULL, 109309),
(109310, '3.50.50.60-FF-000145', NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme', 227, NULL, NULL, 109310),
(109311, '3.30.420.80-FF-000001', NULL, '30S ribosomal protein S11', 129, NULL, NULL, 109311);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(109312, '1.10.287.940-FF-000005', NULL, 'P2X purinoceptor', 25, NULL, NULL, 109312),
(109313, '1.10.287.930-FF-000002', NULL, 'Potassium voltage-gated channel subfamily S member 1', 24, NULL, NULL, 109313),
(109314, '2.120.10.30-FF-000138', NULL, 'Megalin, isoform A', 322, NULL, NULL, 109314),
(109315, '1.20.1070.10-FF-001771', NULL, 'Uncharacterized protein', 330, NULL, NULL, 109315),
(109316, '3.40.47.10-FF-000005', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase I', 146, NULL, NULL, 109316),
(109317, '3.90.70.10-FF-000490', NULL, 'Clan CA, family C1, cathepsin L-like cysteine peptidase', 132, NULL, NULL, 109317),
(109318, '2.30.30.40-FF-000383', NULL, 'Chemotaxis protein CheW', 58, NULL, NULL, 109318),
(109319, '2.60.120.650-FF-000131', NULL, 'Uncharacterized protein', 100, NULL, NULL, 109319),
(109320, '3.60.21.10-FF-000226', NULL, 'Purple acid phosphatase 3', 208, NULL, NULL, 109320),
(109321, '3.10.20.90-FF-000429', NULL, 'Plexin C1', 116, NULL, NULL, 109321),
(109322, '3.40.630.10-FF-000454', NULL, 'Nicastrin', 157, NULL, NULL, 109322),
(109323, '1.25.40.20-FF-000746', NULL, 'Ankyrin repeat-containing protein 2', 123, NULL, NULL, 109323),
(109324, '1.25.40.10-FF-000743', NULL, 'Pentatricopeptide repeat-containing protein', 168, NULL, NULL, 109324),
(109325, '1.20.1110.10-FF-000084', NULL, 'Calcium-transporting ATPase', 153, NULL, NULL, 109325),
(109326, '1.20.1540.10-FF-000110', NULL, 'Uncharacterized protein', 135, NULL, NULL, 109326),
(109327, '3.40.50.1240-FF-000109', NULL, 'Phosphoglycerate mutase-like protein', 394, NULL, NULL, 109327),
(109328, '3.20.20.190-FF-000098', NULL, 'Uncharacterized protein', 261, NULL, NULL, 109328),
(109329, '3.30.70.330-FF-002401', NULL, NULL, 95, NULL, NULL, 109329),
(109330, '2.60.40.830-FF-000002', NULL, 'Cytochrome f', 113, NULL, NULL, 109330),
(109331, '3.90.1720.10-FF-000039', NULL, 'Uncharacterized protein', 128, NULL, NULL, 109331),
(109332, '3.30.360.10-FF-000076', NULL, 'Aspartate-semialdehyde dehydrogenase', 177, NULL, NULL, 109332),
(109333, '3.30.70.330-FF-000260', NULL, 'Polypyrimidine tract-binding protein homolog 2', 107, NULL, NULL, 109333),
(109334, '3.30.565.10-FF-000265', NULL, 'Sensor histidine kinase', 158, NULL, NULL, 109334),
(109335, '3.40.50.10810-FF-000181', NULL, 'ATP-dependent helicase HepA', 178, NULL, NULL, 109335),
(109336, '2.40.320.10-FF-000007', NULL, 'Mediator of RNA polymerase II transcription subunit 18', 268, NULL, NULL, 109336),
(109337, '2.130.10.10-FF-004224', NULL, 'Uncharacterized protein', 146, NULL, NULL, 109337),
(109338, '1.10.560.10-FF-000137', NULL, 'T-complex protein 1 subunit gamma', 115, NULL, NULL, 109338),
(109339, '1.10.287.40-FF-000016', NULL, 'Seryl-tRNA synthetase', 109, NULL, NULL, 109339),
(109340, '3.40.190.10-FF-000431', NULL, 'Sensor domain-containing diguanylate cyclase', 97, NULL, NULL, 109340),
(109341, '2.40.70.10-FF-000191', NULL, 'Uncharacterized protein', 118, NULL, NULL, 109341),
(109342, '1.25.10.10-FF-002265', NULL, 'Uncharacterized protein', 348, NULL, NULL, 109342),
(109343, '1.25.40.10-FF-004015', NULL, 'Uncharacterized protein', 335, NULL, NULL, 109343),
(109344, '1.25.10.10-FF-000135', NULL, 'Plakophilin 1', 447, NULL, NULL, 109344),
(109345, '3.40.109.10-FF-000018', NULL, 'Uncharacterized protein', 241, NULL, NULL, 109345),
(109346, '1.10.287.3510-FF-000007', NULL, 'Na+/H+ antiporter subunit C', 101, NULL, NULL, 109346),
(109347, '2.40.50.100-FF-000155', NULL, 'Bll5772 protein', 69, NULL, NULL, 109347),
(109348, '3.30.70.20-FF-000107', NULL, NULL, 63, NULL, NULL, 109348),
(109349, '3.30.450.40-FF-000064', NULL, 'IclR family transcriptional regulator', 152, NULL, NULL, 109349),
(109350, '3.40.30.10-FF-000697', NULL, 'Predicted protein', 165, NULL, NULL, 109350),
(109351, '3.80.30.20-FF-000018', NULL, 'Anaerobic magnesium-protoporphyrin IX monomethyl ester cyclase', 207, NULL, NULL, 109351),
(109352, '1.10.1000.11-FF-000034', NULL, 'Ankyrin repeat, PH and SEC7 domain containing protein secG', 118, NULL, NULL, 109352),
(109353, '1.50.40.10-FF-000348', NULL, 'Predicted protein', 135, NULL, NULL, 109353);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(109354, '3.30.160.60-FF-001025', NULL, 'zinc finger protein 34', 28, NULL, NULL, 109354),
(109355, '3.80.10.10-FF-001543', NULL, 'Leucine-rich transmembrane protein, putative', 125, NULL, NULL, 109355),
(109356, '3.70.10.10-FF-000099', NULL, 'Predicted protein', 361, NULL, NULL, 109356),
(109357, '3.40.50.1240-FF-000216', NULL, NULL, 251, NULL, NULL, 109357),
(109358, '3.10.110.10-FF-000023', NULL, 'Ubiquitin-conjugating enzyme E2 J2', 179, NULL, NULL, 109358),
(109359, '3.30.505.10-FF-000048', NULL, 'Signal transducer and transcription activator 6', 107, NULL, NULL, 109359),
(109360, '3.30.1680.10-FF-000009', NULL, 'Semaphorin 6B isoform 3 variant', 63, NULL, NULL, 109360),
(109361, '1.25.10.10-FF-000028', NULL, 'Transportin-1 isoform 1', 890, NULL, NULL, 109361),
(109362, '3.40.50.20-FF-000010', NULL, 'Propionyl-CoA carboxylase subunit alpha', 135, NULL, NULL, 109362),
(109363, '3.30.450.30-FF-000061', NULL, 'Predicted protein', 106, NULL, NULL, 109363),
(109364, '1.20.1310.10-FF-000065', NULL, 'Cullin-like protein-like protein', 131, NULL, NULL, 109364),
(109365, '3.40.50.300-FF-006753', NULL, 'Uncharacterized protein', 66, NULL, NULL, 109365),
(109366, '3.30.160.60-FF-004802', NULL, NULL, 37, NULL, NULL, 109366),
(109367, '3.10.110.10-FF-000242', NULL, 'Uncharacterized protein', 50, NULL, NULL, 109367),
(109368, '3.40.47.10-FF-000224', NULL, NULL, 114, NULL, NULL, 109368),
(109369, '3.40.50.300-FF-000464', NULL, 'GTP-binding protein ypt5', 184, NULL, NULL, 109369),
(109370, '2.60.120.1190-FF-000006', NULL, 'Discoidin domain-containing receptor tyrosine kinase B', 176, NULL, NULL, 109370),
(109371, '2.40.70.10-FF-000078', NULL, 'Eukaryotic aspartyl protease family protein', 216, NULL, NULL, 109371),
(109372, '1.10.238.10-FF-000613', NULL, 'Putative centrin', 77, NULL, NULL, 109372),
(109373, '3.10.450.50-FF-000043', NULL, 'mRNA export factor mex67, putative', 159, NULL, NULL, 109373),
(109374, '3.30.70.330-FF-002620', NULL, NULL, 179, NULL, NULL, 109374),
(109375, '1.20.120.530-FF-000009', NULL, 'DNA-binding transcriptional repressor LldR', 134, NULL, NULL, 109375),
(109376, '3.10.110.10-FF-000130', NULL, 'Ubiquitin-conjugating enzyme E2, putative', 158, NULL, NULL, 109376),
(109377, '3.30.420.40-FF-000455', NULL, 'Heat shock protein 70', 102, NULL, NULL, 109377),
(109378, '3.40.50.1820-FF-001368', NULL, 'Uncharacterized protein', 227, NULL, NULL, 109378),
(109379, '2.40.33.10-FF-000009', NULL, 'Pyruvate kinase', 98, NULL, NULL, 109379),
(109380, '3.90.1100.10-FF-000060', NULL, 'DNA-directed RNA polymerase subunit beta', 149, NULL, NULL, 109380),
(109381, '1.10.439.10-FF-000001', NULL, 'Acyl-homoserine lactone acylase QuiP', 158, NULL, NULL, 109381),
(109382, '2.10.150.10-FF-000001', NULL, 'Urease subunit beta', 117, NULL, NULL, 109382),
(109383, '1.10.238.10-FF-000383', NULL, 'Uncharacterized protein', 76, NULL, NULL, 109383),
(109384, '3.40.50.300-FF-004735', NULL, 'Voltage-dependent L-type calcium channel subunit beta-2', 199, NULL, NULL, 109384),
(109385, '3.60.21.10-FF-000445', NULL, 'Uncharacterized protein', 195, NULL, NULL, 109385),
(109386, '2.130.10.10-FF-002083', NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', 292, NULL, NULL, 109386),
(109387, '3.30.40.10-FF-001912', NULL, 'Uncharacterized protein', 72, NULL, NULL, 109387),
(109388, '1.20.85.10-FF-000008', NULL, 'Photosynthetic reaction center subunit L', 104, NULL, NULL, 109388),
(109389, '1.20.272.10-FF-000044', NULL, 'RFC (DNA replication factor) family', 97, NULL, NULL, 109389),
(109390, '1.10.1600.10-FF-000005', NULL, 'ATP-dependent DNA helicase II subunit 1', 107, NULL, NULL, 109390),
(109391, '3.90.70.10-FF-000383', NULL, 'Uncharacterized protein', 249, NULL, NULL, 109391),
(109392, '3.90.70.10-FF-000271', NULL, 'Ubiquitin carboxyl-terminal hydrolase domain containing protein', 270, NULL, NULL, 109392),
(109393, '1.20.58.390-FF-000277', NULL, 'Uncharacterized protein', 64, NULL, NULL, 109393),
(109394, '1.20.1070.10-FF-001439', NULL, 'Olfactory receptor', 223, NULL, NULL, 109394),
(109395, '3.20.20.210-FF-000031', NULL, 'Uncharacterized protein', 41, NULL, NULL, 109395);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(109396, '3.10.20.90-FF-000199', NULL, 'fermitin family homolog 3', 80, NULL, NULL, 109396),
(109397, '1.10.1410.10-FF-000069', NULL, 'Nucleolar protein 6', 93, NULL, NULL, 109397),
(109398, '2.60.40.1400-FF-000030', NULL, NULL, 50, NULL, NULL, 109398),
(109399, '1.20.58.120-FF-000005', NULL, 'BAG family molecular chaperone regulator 1', 130, NULL, NULL, 109399),
(109400, '1.25.40.10-FF-004234', NULL, 'Uncharacterized protein', 249, NULL, NULL, 109400),
(109401, '3.20.20.220-FF-000034', NULL, 'Proline dehydrogenase', 343, NULL, NULL, 109401),
(109402, '3.40.30.10-FF-001203', NULL, 'Calsequestrin', 69, NULL, NULL, 109402),
(109403, '1.10.540.10-FF-000029', NULL, 'Acyl-CoA dehydrogenase', 129, NULL, NULL, 109403),
(109404, '1.10.510.10-FF-000533', NULL, 'cyclin-dependent kinase 10', 224, NULL, NULL, 109404),
(109405, '1.10.3210.10-FF-000094', NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase-like protein', 393, NULL, NULL, 109405),
(109406, '3.90.550.10-FF-000167', NULL, 'UDP-N-acetylglucosamine pyrophosphorylase', 497, NULL, NULL, 109406),
(109407, '1.20.58.2220-FF-000038', NULL, 'Cappuccino', 405, NULL, NULL, 109407),
(109408, '1.25.40.10-FF-003397', NULL, 'Pentatricopeptide repeat-containing protein At2g37310', 134, NULL, NULL, 109408),
(109409, '3.90.226.10-FF-000021', NULL, 'Acetyl-CoA carboxylase carboxyltransferase subunit', 258, NULL, NULL, 109409),
(109410, '2.60.40.60-FF-000635', NULL, 'AGAP002828-PA', 119, NULL, NULL, 109410),
(109411, '2.10.25.10-FF-001223', NULL, 'Nimrod C1, isoform A', 63, NULL, NULL, 109411),
(109412, '1.10.10.60-FF-000615', NULL, 'Distal-less homeobox 4', 83, NULL, NULL, 109412),
(109413, '2.60.40.60-FF-000523', NULL, 'AGAP002828-PA', 96, NULL, NULL, 109413),
(109414, '3.30.160.60-FF-002548', NULL, 'Zinc finger and SCAN domain-containing protein 29', 30, NULL, NULL, 109414),
(109415, '1.20.140.150-FF-000085', NULL, 'epithelial membrane protein 2', 164, NULL, NULL, 109415),
(109416, '1.10.287.950-FF-000008', NULL, 'Methyl-accepting chemotaxis protein', 279, NULL, NULL, 109416),
(109417, '2.60.40.10-FF-005769', NULL, NULL, 90, NULL, NULL, 109417),
(109418, '2.10.70.10-FF-000237', NULL, 'Predicted protein', 62, NULL, NULL, 109418),
(109419, '3.40.630.10-FF-000235', NULL, 'Carboxypeptidase Z', 220, NULL, NULL, 109419),
(109420, '1.20.1520.10-FF-000002', NULL, 'ADP-ribosylation factor-like protein 2-binding protein isoform X1', 128, NULL, NULL, 109420),
(109421, '3.10.20.90-FF-000761', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', 211, NULL, NULL, 109421),
(109422, '4.10.280.10-FF-000149', NULL, 'Related to centromere binding factor 1', 67, NULL, NULL, 109422),
(109423, '1.20.144.10-FF-000112', NULL, 'Acid phosphatase', 226, NULL, NULL, 109423),
(109424, '3.40.50.1000-FF-000274', NULL, 'Phosphatidyl synthase', 168, NULL, NULL, 109424),
(109425, '3.30.420.210-FF-000017', NULL, 'Uncharacterized protein', 61, NULL, NULL, 109425),
(109426, '3.30.70.920-FF-000009', NULL, 'AsnC family transcriptional regulator', 84, NULL, NULL, 109426),
(109427, '2.60.40.10-FF-002335', NULL, 'Calmodulin-binding transcription activator CBT', 97, NULL, NULL, 109427),
(109428, '2.60.34.10-FF-000027', NULL, 'Heat shock 70 kDa protein 14', 136, NULL, NULL, 109428),
(109429, '1.10.3930.10-FF-000002', NULL, 'Arginine deiminase', 82, NULL, NULL, 109429),
(109430, '2.60.11.10-FF-000003', NULL, 'Cytochrome c oxidase subunit IV', 96, NULL, NULL, 109430),
(109431, '1.25.10.10-FF-002501', NULL, 'Uncharacterized protein', 201, NULL, NULL, 109431),
(109432, '2.30.30.40-FF-000271', NULL, 'Protein BZZ1', 59, NULL, NULL, 109432),
(109433, '3.90.230.10-FF-000019', NULL, 'Methionine aminopeptidase', 302, NULL, NULL, 109433),
(109434, '1.20.58.110-FF-000002', NULL, '30S ribosomal protein S20', 84, NULL, NULL, 109434),
(109435, '2.10.25.10-FF-001442', NULL, 'Uncharacterized protein', 46, NULL, NULL, 109435),
(109436, '3.40.960.10-FF-000007', NULL, 'Very short patch repair endonuclease', 116, NULL, NULL, 109436),
(109437, '1.10.10.2390-FF-000001', NULL, 'DUF3349 domain-containing protein', 63, NULL, NULL, 109437);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(109438, '2.60.40.10-FF-005988', NULL, NULL, 88, NULL, NULL, 109438),
(109439, '1.10.418.60-FF-000024', NULL, 'Uncharacterized protein', 111, NULL, NULL, 109439),
(109440, '3.30.70.330-FF-001783', NULL, NULL, 128, NULL, NULL, 109440),
(109441, '4.10.400.10-FF-000249', NULL, 'LDL receptor protein 1, isoform F', 41, NULL, NULL, 109441),
(109442, '3.90.226.10-FF-000240', NULL, 'Enoyl-CoA hydratase', 201, NULL, NULL, 109442),
(109443, '2.130.10.10-FF-004336', NULL, 'Sortilin', 99, NULL, NULL, 109443),
(109444, '3.40.50.720-FF-001433', NULL, 'Probable polyketide synthase 32', 432, NULL, NULL, 109444),
(109445, '3.30.1330.120-FF-000007', NULL, 'Bll6362 protein', 134, NULL, NULL, 109445),
(109446, '3.30.565.10-FF-000046', NULL, 'Signal transduction histidine-protein kinase BaeS', 157, NULL, NULL, 109446),
(109447, '3.40.532.10-FF-000018', NULL, 'Ubiquitin carboxyl-terminal hydrolase isozyme L1', 172, NULL, NULL, 109447),
(109448, '3.30.200.20-FF-001664', NULL, 'Putative receptor-like protein kinase At2g30940', 116, NULL, NULL, 109448),
(109449, '1.10.10.60-FF-000054', NULL, 'One cut domain family member', 72, NULL, NULL, 109449),
(109450, '1.25.40.690-FF-000009', NULL, 'Uncharacterized protein', 121, NULL, NULL, 109450),
(109451, '3.30.870.10-FF-000047', NULL, 'Probable tyrosyl-DNA phosphodiesterase', 293, NULL, NULL, 109451),
(109452, '1.10.10.440-FF-000057', NULL, 'Transcription elongation regulator 1', 68, NULL, NULL, 109452),
(109453, '2.130.10.10-FF-003499', NULL, 'Sortilin', 260, NULL, NULL, 109453),
(109454, '3.40.50.300-FF-003898', NULL, 'ABC transporter ATP-binding protein', 244, NULL, NULL, 109454),
(109455, '2.60.40.60-FF-001130', NULL, 'Predicted protein', 99, NULL, NULL, 109455),
(109456, '1.10.3260.10-FF-000041', NULL, 'Uncharacterized protein', 209, NULL, NULL, 109456),
(109457, '3.80.10.10-FF-001762', NULL, 'Tehao, isoform A', 211, NULL, NULL, 109457),
(109458, '3.40.30.10-FF-000585', NULL, 'Glutathione S-transferase', 34, NULL, NULL, 109458),
(109459, '3.80.10.10-FF-000014', NULL, 'Leucine-rich repeat and immunoglobulin-like domain-containing nogo receptor-interacting protein 1', 368, NULL, NULL, 109459),
(109460, '3.30.540.10-FF-000062', NULL, 'Inositol polyphosphate 1-phosphatase, putative', 223, NULL, NULL, 109460),
(109461, '3.40.50.1390-FF-000014', NULL, 'DNA invertase', 134, NULL, NULL, 109461),
(109462, '3.90.132.10-FF-000022', NULL, 'GP63-like', 134, NULL, NULL, 109462),
(109463, '1.20.1560.10-FF-000111', NULL, 'ABC transporter', 306, NULL, NULL, 109463),
(109464, '3.40.50.720-FF-000016', NULL, 'GDP-mannose 4,6-dehydratase', 195, NULL, NULL, 109464),
(109465, '1.25.10.10-FF-002484', NULL, 'Uncharacterized protein', 210, NULL, NULL, 109465),
(109466, '3.30.590.10-FF-000008', NULL, 'Gamma-glutamylputrescine synthetase PuuA', 336, NULL, NULL, 109466),
(109467, '3.40.50.12160-FF-000018', NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase', 124, NULL, NULL, 109467),
(109468, '3.90.1300.10-FF-000041', NULL, 'Fatty acid amide hydrolase, gene 1', 90, NULL, NULL, 109468),
(109469, '1.10.510.10-FF-001140', NULL, 'Prr2p', 339, NULL, NULL, 109469),
(109470, '2.20.70.10-FF-000135', NULL, 'U1 snRNP protein', 33, NULL, NULL, 109470),
(109471, '3.40.50.1380-FF-000011', NULL, 'Carbamoyl-phosphate synthase large chain', 136, NULL, NULL, 109471),
(109472, '2.130.10.10-FF-000065', NULL, 'WD repeat-containing protein 82', 301, NULL, NULL, 109472),
(109473, '3.90.550.50-FF-000151', NULL, 'Hexosyltransferase', 268, NULL, NULL, 109473),
(109474, '1.20.5.1160-FF-000023', NULL, 'Intermediate filament protein ifa-1', 104, NULL, NULL, 109474),
(109475, '3.40.50.2060-FF-000013', NULL, 'SNARE docking complex subunit', 129, NULL, NULL, 109475),
(109476, '1.20.120.1750-FF-000141', NULL, 'RBR-type E3 ubiquitin transferase', 219, NULL, NULL, 109476),
(109477, '1.10.472.10-FF-000078', NULL, 'Cyclin-C1-2', 107, NULL, NULL, 109477),
(109478, '3.30.420.40-FF-000017', NULL, 'Heat shock 70 kDa protein 4', 119, NULL, NULL, 109478),
(109479, '3.30.70.330-FF-001906', NULL, NULL, 74, NULL, NULL, 109479);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(109480, '3.40.50.10420-FF-000058', NULL, '5-formyltetrahydrofolate cyclo-ligase', 180, NULL, NULL, 109480),
(109481, '1.25.40.10-FF-000524', NULL, 'Transcription elongation factor GreA', 197, NULL, NULL, 109481),
(109482, '3.30.160.60-FF-002329', NULL, 'Si:dkeyp-44b5.5', 26, NULL, NULL, 109482),
(109483, '1.50.40.10-FF-000567', NULL, 'Uncharacterized mitochondrial carrier C8C9.12c', 104, NULL, NULL, 109483),
(109484, '3.30.1370.240-FF-000012', NULL, 'Phenylalanine-tRNA ligase, alpha subunit', 76, NULL, NULL, 109484),
(109485, '2.70.150.10-FF-000156', NULL, 'Phospholipid-transporting ATPase', 138, NULL, NULL, 109485),
(109486, '2.10.25.10-FF-001661', NULL, 'Vacuolar-sorting receptor 1', 69, NULL, NULL, 109486),
(109487, '3.40.50.150-FF-000379', NULL, 'Trans-aconitate 2-methyltransferase', 174, NULL, NULL, 109487),
(109488, '1.20.1070.10-FF-000023', NULL, 'Relaxin family peptide receptor 1', 326, NULL, NULL, 109488),
(109489, '1.25.40.20-FF-000527', NULL, 'Kinase, NEK', 60, NULL, NULL, 109489),
(109490, '3.80.10.10-FF-003448', NULL, 'Uncharacterized protein', 343, NULL, NULL, 109490),
(109491, '3.30.830.10-FF-000163', NULL, 'Os01g0779100 protein', 131, NULL, NULL, 109491),
(109492, '3.30.160.60-FF-004459', NULL, NULL, 62, NULL, NULL, 109492),
(109493, '1.20.140.40-FF-000090', NULL, NULL, 72, NULL, NULL, 109493),
(109494, '1.10.275.40-FF-000005', NULL, 'TFIIH basal transcription factor complex helicase XPD subunit', 91, NULL, NULL, 109494),
(109495, '2.30.29.30-FF-000995', NULL, 'Dynamin-related GTPase', 135, NULL, NULL, 109495),
(109496, '3.30.70.920-FF-000010', NULL, 'ArsR family transcriptional regulator', 84, NULL, NULL, 109496),
(109497, '3.10.310.20-FF-000007', NULL, 'protein prune homolog', 142, NULL, NULL, 109497),
(109498, '3.40.640.10-FF-000174', NULL, 'Probable hercynylcysteine sulfoxide lyase', 232, NULL, NULL, 109498),
(109499, '1.10.357.20-FF-000016', NULL, 'Predicted protein', 72, NULL, NULL, 109499),
(109500, '3.20.20.30-FF-000012', NULL, 'Alkanesulfonate monooxygenase', 349, NULL, NULL, 109500),
(109501, '1.10.357.10-FF-000013', NULL, 'TetR family transcriptional regulator', 186, NULL, NULL, 109501),
(109502, '3.30.70.330-FF-000041', NULL, 'Epithelial splicing regulatory protein 1', 89, NULL, NULL, 109502),
(109503, '3.10.110.10-FF-000129', NULL, 'DEAD/DEAH box helicase, putative', 111, NULL, NULL, 109503),
(109504, '2.60.200.20-FF-000082', NULL, 'DNA damage response protein RcaA', 117, NULL, NULL, 109504),
(109505, '3.20.20.80-FF-000111', NULL, 'Soluble cell wall protein', 129, NULL, NULL, 109505),
(109506, '3.10.20.30-FF-000097', NULL, NULL, 64, NULL, NULL, 109506),
(109507, '3.40.630.10-FF-000016', NULL, 'IAA-amino acid hydrolase ILR1-like 4', 241, NULL, NULL, 109507),
(109508, '3.10.100.10-FF-000303', NULL, NULL, 162, NULL, NULL, 109508),
(109509, '3.40.50.720-FF-001539', NULL, 'Uncharacterized protein', 357, NULL, NULL, 109509),
(109510, '2.40.70.10-FF-000421', NULL, NULL, 47, NULL, NULL, 109510),
(109511, '2.40.50.150-FF-000035', NULL, 'DNA-directed RNA polymerase subunit beta', 121, NULL, NULL, 109511),
(109512, '3.40.640.10-FF-000516', NULL, 'Putative diaminobutyrate-pyruvate aminotransferase', 210, NULL, NULL, 109512),
(109513, '3.30.160.60-FF-000188', NULL, 'Zinc finger protein 787', 28, NULL, NULL, 109513),
(109514, '1.10.530.10-FF-000079', NULL, 'Uncharacterized protein', 64, NULL, NULL, 109514),
(109515, '2.40.160.20-FF-000026', NULL, 'Major outer membrane protein P44-11', 161, NULL, NULL, 109515),
(109516, '3.30.1600.10-FF-000016', NULL, 'Sirtuin 5 and related class III sirtuins', 65, NULL, NULL, 109516),
(109517, '3.30.40.10-FF-001569', NULL, 'Predicted zinc finger protein', 95, NULL, NULL, 109517),
(109518, '2.60.40.150-FF-000663', NULL, 'Copine VII', 91, NULL, NULL, 109518),
(109519, '2.60.40.1180-FF-000149', NULL, 'Acid Alpha Glucosidase Relate', 142, NULL, NULL, 109519),
(109520, '1.20.1510.10-FF-000052', NULL, 'Cation efflux system protein', 197, NULL, NULL, 109520),
(109521, '3.40.1090.10-FF-000142', NULL, 'Predicted protein', 78, NULL, NULL, 109521),
(109522, '3.40.50.300-FF-006534', NULL, 'Uncharacterized protein', 108, NULL, NULL, 109522); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(109523, '3.30.60.30-FF-000161', NULL, 'Uncharacterized protein', 54, NULL, NULL, 109523),
(109524, '3.30.1330.100-FF-000001', NULL, 'Coenzyme F420:L-glutamate ligase', 151, NULL, NULL, 109524),
(109525, '2.130.10.10-FF-000626', NULL, 'Katanin p80 WD40 repeat-containing subunit B1 homolog', 164, NULL, NULL, 109525),
(109526, '3.30.470.160-FF-000001', NULL, 'Kinase', 258, NULL, NULL, 109526),
(109527, '3.40.630.20-FF-000019', NULL, 'Pyrrolidone carboxyl peptidase, truncation', 97, NULL, NULL, 109527),
(109528, '1.10.1660.10-FF-000003', NULL, 'MerR family transcriptional regulator', 105, NULL, NULL, 109528),
(109529, '3.40.50.1440-FF-000164', NULL, 'Putative nucleolar protein 5-1', 102, NULL, NULL, 109529),
(109530, '1.10.10.1940-FF-000018', NULL, NULL, 42, NULL, NULL, 109530),
(109531, '2.40.160.10-FF-000023', NULL, 'Outer membrane protein II', 340, NULL, NULL, 109531),
(109532, '2.70.170.10-FF-000264', NULL, 'GABA receptor alpha 6 subunit', 141, NULL, NULL, 109532),
(109533, '2.30.30.210-FF-000017', NULL, 'Ribonuclease P protein subunit', 120, NULL, NULL, 109533),
(109534, '3.40.50.150-FF-001110', NULL, NULL, 138, NULL, NULL, 109534),
(109535, '2.130.10.10-FF-000284', NULL, 'protein NEDD1 isoform X1', 132, NULL, NULL, 109535),
(109536, '2.40.50.140-FF-000032', NULL, 'DNA helicase', 77, NULL, NULL, 109536),
(109537, '1.25.10.10-FF-001883', NULL, 'HEAT repeat-containing protein 1', 384, NULL, NULL, 109537),
(109538, '1.10.1420.10-FF-000019', NULL, 'DNA mismatch repair protein', 128, NULL, NULL, 109538),
(109539, '2.170.270.10-FF-000225', NULL, 'Histone-lysine N-methyltransferase', 97, NULL, NULL, 109539),
(109540, '3.40.190.10-FF-000318', NULL, 'LysR family transcriptional regulator', 74, NULL, NULL, 109540),
(109541, '2.40.160.210-FF-000012', NULL, 'Uncharacterized protein', 322, NULL, NULL, 109541),
(109542, '2.70.130.10-FF-000048', NULL, NULL, 119, NULL, NULL, 109542),
(109543, '1.20.1250.20-FF-001086', NULL, 'Uncharacterized protein', 282, NULL, NULL, 109543),
(109544, '2.130.10.10-FF-005859', NULL, 'Uncharacterized protein', 317, NULL, NULL, 109544),
(109545, '3.40.50.150-FF-000834', NULL, 'Ribosomal RNA small subunit methyltransferase G', 196, NULL, NULL, 109545),
(109546, '3.40.50.10210-FF-000001', NULL, 'Nicotinate-nucleotide--dimethylbenzimidazole phosphoribosyltransferase', 273, NULL, NULL, 109546),
(109547, '2.60.40.1760-FF-000008', NULL, 'Alpha-xylosidase A', 240, NULL, NULL, 109547),
(109548, '2.30.30.40-FF-000613', NULL, 'Uncharacterized protein', 53, NULL, NULL, 109548),
(109549, '3.40.50.300-FF-000683', NULL, 'Abc transporter f family member 1', 265, NULL, NULL, 109549),
(109550, '3.30.230.10-FF-000302', NULL, 'Uncharacterized protein', 73, NULL, NULL, 109550),
(109551, '1.20.1280.50-FF-000068', NULL, 'F-box domain containing protein', 76, NULL, NULL, 109551),
(109552, '2.40.10.10-FF-000316', NULL, 'GM13872', 245, NULL, NULL, 109552),
(109553, '3.30.160.60-FF-002442', NULL, 'Expressed sequence AI877918', 28, NULL, NULL, 109553),
(109554, '3.10.310.10-FF-000004', NULL, 'Diaminopimelate epimerase', 150, NULL, NULL, 109554),
(109555, '3.40.50.300-FF-002824', NULL, 'Sigma-54 dependent transcriptional regulator', 165, NULL, NULL, 109555),
(109556, '2.40.37.20-FF-000004', NULL, 'Unplaced genomic scaffold supercont1.17, whole genome shotgun sequence', 138, NULL, NULL, 109556),
(109557, '1.10.3080.10-FF-000055', NULL, 'Chloride channel protein', 207, NULL, NULL, 109557),
(109558, '2.40.37.10-FF-000001', NULL, 'Biosynthetic arginine decarboxylase', 180, NULL, NULL, 109558),
(109559, '3.40.50.720-FF-001197', NULL, 'KR domain protein', 265, NULL, NULL, 109559),
(109560, '3.30.160.60-FF-006258', NULL, NULL, 79, NULL, NULL, 109560),
(109561, '1.20.1250.20-FF-001647', NULL, 'Uncharacterized protein', 473, NULL, NULL, 109561),
(109562, '2.30.30.140-FF-000098', NULL, 'Uncharacterized protein, isoform B', 102, NULL, NULL, 109562),
(109563, '3.90.1150.10-FF-000225', NULL, 'Aminotransferase', 147, NULL, NULL, 109563),
(109564, '3.40.50.300-FF-002482', NULL, 'Large-subunit GTPase', 209, NULL, NULL, 109564);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(109565, '1.20.970.30-FF-000003', NULL, 'Uncharacterized protein', 54, NULL, NULL, 109565),
(109566, '1.20.58.60-FF-000303', NULL, 'Karst, isoform B', 185, NULL, NULL, 109566),
(109567, '2.60.120.10-FF-000269', NULL, 'DNA-binding protein', 107, NULL, NULL, 109567),
(109568, '3.40.190.290-FF-000035', NULL, 'LysR family transcriptional regulator', 199, NULL, NULL, 109568),
(109569, '1.10.510.10-FF-002225', NULL, 'Likely protein kinase', 252, NULL, NULL, 109569),
(109570, '3.50.4.10-FF-000019', NULL, 'Uncharacterized protein, isoform B', 85, NULL, NULL, 109570),
(109571, '2.160.10.10-FF-000030', NULL, 'Putative GDP-mannose pyrophosphorylase', 129, NULL, NULL, 109571),
(109572, '3.80.10.10-FF-003780', NULL, 'Predicted protein', 104, NULL, NULL, 109572),
(109573, '1.10.1420.10-FF-000132', NULL, 'Uncharacterized protein', 89, NULL, NULL, 109573),
(109574, '3.40.50.300-FF-006192', NULL, 'Helicase conserved C-terminal domain containing protein', 183, NULL, NULL, 109574),
(109575, '3.40.30.10-FF-000708', NULL, 'Protein disulfide isomerase 3, putative', 113, NULL, NULL, 109575),
(109576, '3.30.70.330-FF-001564', NULL, 'Zinc finger CCCH domain-containing protein 41', 169, NULL, NULL, 109576),
(109577, '2.60.40.10-FF-004246', NULL, NULL, 111, NULL, NULL, 109577),
(109578, '2.60.40.3500-FF-000019', NULL, NULL, 105, NULL, NULL, 109578),
(109579, '2.160.20.10-FF-000311', NULL, 'Uncharacterized protein', 96, NULL, NULL, 109579),
(109580, '1.10.510.10-FF-001949', NULL, 'Non-specific serine/threonine protein kinase', 293, NULL, NULL, 109580),
(109581, '3.40.50.2300-FF-001299', NULL, NULL, 132, NULL, NULL, 109581),
(109582, '4.10.410.10-FF-000076', NULL, 'Tissue factor pathway inhibitor', 63, NULL, NULL, 109582),
(109583, '1.25.40.10-FF-001598', NULL, 'Uncharacterized protein', 157, NULL, NULL, 109583),
(109584, '3.30.465.10-FF-000100', NULL, 'CoB--CoM heterodisulfide reductase 2 iron-sulfur subunit D', 211, NULL, NULL, 109584),
(109585, '3.10.440.10-FF-000008', NULL, 'LSU ribosomal protein L31E', 100, NULL, NULL, 109585),
(109586, '3.30.230.120-FF-000008', NULL, 'D-alpha-D-heptose-7-phosphate kinase HddA', 358, NULL, NULL, 109586),
(109587, '2.60.120.260-FF-000121', NULL, 'Beta-galactosidase 3', 160, NULL, NULL, 109587),
(109588, '2.60.40.150-FF-000225', NULL, 'WWC family member 3', 126, NULL, NULL, 109588),
(109589, '1.20.1640.10-FF-000056', NULL, 'PaTched Related family', 186, NULL, NULL, 109589),
(109590, '3.40.800.20-FF-000055', NULL, 'Predicted protein', 225, NULL, NULL, 109590),
(109591, '1.10.150.240-FF-000015', NULL, 'Acyl-CoA dehydrogenase family member 10', 73, NULL, NULL, 109591),
(109592, '3.40.50.720-FF-001652', NULL, 'NAD dependent epimerase/dehydratase, putative', 299, NULL, NULL, 109592),
(109593, '2.20.28.270-FF-000001', NULL, 'RNA polymerase-binding protein RbpA', 80, NULL, NULL, 109593),
(109594, '2.130.10.10-FF-005972', NULL, 'Predicted protein', 238, NULL, NULL, 109594),
(109595, '1.25.40.240-FF-000010', NULL, NULL, 144, NULL, NULL, 109595),
(109596, '2.130.10.10-FF-002425', NULL, 'Rabconnectin-3A', 287, NULL, NULL, 109596),
(109597, '2.170.140.10-FF-000002', NULL, 'Gasp, isoform A', 67, NULL, NULL, 109597),
(109598, '3.30.70.2820-FF-000013', NULL, NULL, 103, NULL, NULL, 109598),
(109599, '3.40.800.10-FF-000052', NULL, NULL, 326, NULL, NULL, 109599),
(109600, '1.20.5.190-FF-000111', NULL, NULL, 49, NULL, NULL, 109600),
(109601, '1.25.10.10-FF-002720', NULL, 'Predicted protein', 956, NULL, NULL, 109601),
(109602, '3.80.10.10-FF-003561', NULL, 'F-box and leucine-rich repeat protein 18', 290, NULL, NULL, 109602),
(109603, '3.40.50.1000-FF-000055', NULL, 'Haloacid dehalogenase-like hydrolase family protein', 136, NULL, NULL, 109603),
(109604, '1.20.1560.10-FF-000797', NULL, 'AGAP004600-PA', 203, NULL, NULL, 109604),
(109605, '2.60.120.10-FF-000724', NULL, 'Cyclic nucleotide-gated potassium channel', 136, NULL, NULL, 109605),
(109606, '3.30.230.70-FF-000062', NULL, 'Cell death-related nuclease 5', 213, NULL, NULL, 109606),
(109607, '3.30.160.60-FF-006039', NULL, NULL, 18, NULL, NULL, 109607);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(109608, '3.40.50.300-FF-001987', NULL, 'replication factor C subunit 5 isoform X2', 92, NULL, NULL, 109608),
(109609, '2.10.220.10-FF-000119', NULL, 'Proprotein convertase subtilisin/kexin type 5', 93, NULL, NULL, 109609),
(109610, '2.40.10.10-FF-000535', NULL, NULL, 94, NULL, NULL, 109610),
(109611, '3.90.320.20-FF-000001', NULL, 'Methyl-coenzyme M reductase I subunit gamma', 249, NULL, NULL, 109611),
(109612, '2.40.30.10-FF-000082', NULL, 'Putative translation elongation factor 2', 153, NULL, NULL, 109612),
(109613, '2.120.10.30-FF-000251', NULL, 'Uncharacterized protein', 192, NULL, NULL, 109613),
(109614, '1.10.472.10-FF-000533', NULL, 'T-type cyclin', 87, NULL, NULL, 109614),
(109615, '1.20.1270.280-FF-000076', NULL, 'Uncharacterized protein', 64, NULL, NULL, 109615),
(109616, '3.10.290.10-FF-000069', NULL, '30S ribosomal protein S4, chloroplastic', 76, NULL, NULL, 109616),
(109617, '1.25.40.20-FF-000640', NULL, 'Uncharacterized protein, isoform C', 100, NULL, NULL, 109617),
(109618, '1.10.510.10-FF-002663', NULL, NULL, 114, NULL, NULL, 109618),
(109619, '2.40.70.10-FF-000202', NULL, 'Predicted protein', 211, NULL, NULL, 109619),
(109620, '3.30.200.60-FF-000012', NULL, 'Ubiquitin thioesterase', 81, NULL, NULL, 109620),
(109621, '2.30.130.40-FF-000010', NULL, 'Lon protease homolog, mitochondrial', 118, NULL, NULL, 109621),
(109622, '3.40.50.300-FF-003100', NULL, 'Rap GTPase, putative', 166, NULL, NULL, 109622),
(109623, '2.130.10.10-FF-001588', NULL, 'Chromosome segregation protein SMC', 322, NULL, NULL, 109623),
(109624, '2.10.110.20-FF-000007', NULL, NULL, 78, NULL, NULL, 109624),
(109625, '3.30.70.1230-FF-000076', NULL, 'pH-sensitive adenylate cyclase Rv1264', 183, NULL, NULL, 109625),
(109626, '1.10.630.10-FF-000587', NULL, 'Cytochrome P450 84A1', 294, NULL, NULL, 109626),
(109627, '3.20.180.20-FF-000016', NULL, 'Dynein heavy chain, cytosolic, putative', 103, NULL, NULL, 109627),
(109628, '3.40.309.10-FF-000005', NULL, '1-pyrroline-5-carboxylate dehydrogenase 1', 193, NULL, NULL, 109628),
(109629, '3.30.530.20-FF-000126', NULL, 'Uncharacterized protein', 137, NULL, NULL, 109629),
(109630, '2.10.110.10-FF-000223', NULL, 'PDZ and LIM domain 5', 48, NULL, NULL, 109630),
(109631, '1.20.120.980-FF-000015', NULL, 'Serine carboxypeptidase (S28) family protein', 151, NULL, NULL, 109631),
(109632, '1.10.10.10-FF-000174', NULL, 'LysR family transcriptional regulator', 85, NULL, NULL, 109632),
(109633, '2.60.120.260-FF-000008', NULL, 'teneurin-3 isoform X2', 59, NULL, NULL, 109633),
(109634, '2.60.40.10-FF-005882', NULL, NULL, 96, NULL, NULL, 109634),
(109635, '1.25.40.10-FF-002093', NULL, 'Uncharacterized protein', 159, NULL, NULL, 109635),
(109636, '3.20.20.100-FF-000110', NULL, 'Uncharacterized protein', 290, NULL, NULL, 109636),
(109637, '3.30.160.60-FF-006371', NULL, NULL, 79, NULL, NULL, 109637),
(109638, '1.10.10.10-FF-000516', NULL, 'ets DNA-binding protein pokkuri', 125, NULL, NULL, 109638),
(109639, '2.10.110.10-FF-000004', NULL, 'actin-binding LIM protein 1 isoform X1', 67, NULL, NULL, 109639),
(109640, '3.40.50.150-FF-000492', NULL, 'Ribosomal RNA small subunit methyltransferase H', 197, NULL, NULL, 109640),
(109641, '1.10.10.60-FF-000492', NULL, 'AraC family transcriptional regulator', 56, NULL, NULL, 109641),
(109642, '2.60.40.10-FF-004465', NULL, NULL, 106, NULL, NULL, 109642),
(109643, '3.40.50.300-FF-002263', NULL, 'DNA repair and recombination protein RAD54', 42, NULL, NULL, 109643),
(109644, '2.60.40.2130-FF-000018', NULL, 'Spon2b protein', 64, NULL, NULL, 109644),
(109645, '3.30.870.10-FF-000160', NULL, 'Uncharacterized protein', 111, NULL, NULL, 109645),
(109646, '3.30.420.40-FF-000236', NULL, 'Chromatin remodeling complex subunit (Arp9), putative', 101, NULL, NULL, 109646),
(109647, '3.50.50.100-FF-000014', NULL, 'Hypothetical iron uptake cluster protein', 73, NULL, NULL, 109647),
(109648, '1.10.418.10-FF-000256', NULL, 'Uncharacterized protein', 80, NULL, NULL, 109648),
(109649, '3.50.50.60-FF-001449', NULL, 'Os10g0516300 protein', 86, NULL, NULL, 109649),
(109650, '2.10.25.10-FF-001329', NULL, 'Predicted protein', 41, NULL, NULL, 109650);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(109651, '1.20.58.80-FF-000080', NULL, 'Amsh, putative', 165, NULL, NULL, 109651),
(109652, '1.10.8.270-FF-000165', NULL, 'TBC1 domain family member 16', 81, NULL, NULL, 109652),
(109653, '3.30.450.40-FF-000283', NULL, 'Phosphodiesterase', 78, NULL, NULL, 109653),
(109654, '2.80.10.50-FF-000074', NULL, 'Related to J kappa-recombination signal binding protein', 107, NULL, NULL, 109654),
(109655, '4.10.375.10-FF-000004', NULL, 'Lipoxygenase6', 90, NULL, NULL, 109655),
(109656, '1.25.10.10-FF-002046', NULL, 'Translational activator GCN1', 161, NULL, NULL, 109656),
(109657, '3.30.559.30-FF-000105', NULL, 'Chromosome 19, whole genome shotgun sequence', 244, NULL, NULL, 109657),
(109658, '3.30.160.60-FF-002661', NULL, 'DAZ interacting zinc finger protein 1 like', 29, NULL, NULL, 109658),
(109659, '2.40.30.10-FF-000424', NULL, 'Predicted protein (Fragment)', 29, NULL, NULL, 109659),
(109660, '3.40.50.300-FF-002605', NULL, 'ATPase, putative', 144, NULL, NULL, 109660),
(109661, '2.130.10.120-FF-000013', NULL, 'Protease II', 320, NULL, NULL, 109661),
(109662, '1.10.1450.10-FF-000066', NULL, 'Tetraspanin', 100, NULL, NULL, 109662),
(109663, '2.60.40.10-FF-001031', NULL, 'Vascular endothelial growth factor receptor 1', 134, NULL, NULL, 109663),
(109664, '1.20.1610.10-FF-000009', NULL, 'Putative secreted protein', 156, NULL, NULL, 109664),
(109665, '2.130.10.110-FF-000010', NULL, 'Clathrin heavy chain', 365, NULL, NULL, 109665),
(109666, '1.10.472.10-FF-000191', NULL, 'Cyclin-D5-1', 70, NULL, NULL, 109666),
(109667, '3.80.10.10-FF-003903', NULL, 'Uncharacterized protein', 133, NULL, NULL, 109667),
(109668, '3.40.50.720-FF-001871', NULL, 'Beta-ketoacyl-ACP reductase, putative', 143, NULL, NULL, 109668),
(109669, '2.170.270.10-FF-000006', NULL, 'Histone-lysine N-methyltransferase', 145, NULL, NULL, 109669),
(109670, '2.40.10.10-FF-000193', NULL, 'Secreted trypsin-like serine protease', 257, NULL, NULL, 109670),
(109671, '3.30.1490.250-FF-000002', NULL, 'Glutathione synthetase', 68, NULL, NULL, 109671),
(109672, '2.30.29.30-FF-001271', NULL, 'Predicted protein', 99, NULL, NULL, 109672),
(109673, '2.60.40.10-FF-000755', NULL, 'Interleukin 5 receptor subunit alpha', 102, NULL, NULL, 109673),
(109674, '2.130.10.10-FF-002206', NULL, 'Predicted protein', 88, NULL, NULL, 109674),
(109675, '3.40.50.2000-FF-000394', NULL, 'Glycosyl transferase family 1', 232, NULL, NULL, 109675),
(109676, '1.10.10.60-FF-000705', NULL, NULL, 54, NULL, NULL, 109676),
(109677, '3.40.50.10380-FF-000001', NULL, 'NAD-dependent malic enzyme', 254, NULL, NULL, 109677),
(109678, '3.20.20.60-FF-000044', NULL, 'HPCH/HPAI aldolase family protein', 259, NULL, NULL, 109678),
(109679, '3.40.50.300-FF-000430', NULL, 'Probable Ras-related protein Rab-18', 186, NULL, NULL, 109679),
(109680, '1.20.5.220-FF-000007', NULL, 'Large-conductance mechanosensitive channel', 22, NULL, NULL, 109680),
(109681, '3.30.720.200-FF-000003', NULL, 'Glycine-tRNA ligase', 75, NULL, NULL, 109681),
(109682, '3.30.1370.120-FF-000009', NULL, 'Type III secretion outer membrane pore YscC', 71, NULL, NULL, 109682),
(109683, '3.60.20.10-FF-000050', NULL, 'Asparagine synthetase 2', 194, NULL, NULL, 109683),
(109684, '2.130.10.10-FF-001705', NULL, 'Sensor histidine kinase TodS', 269, NULL, NULL, 109684),
(109685, '3.30.200.20-FF-002288', NULL, 'Uncharacterized protein', 50, NULL, NULL, 109685),
(109686, '3.30.70.330-FF-002536', NULL, NULL, 49, NULL, NULL, 109686),
(109687, '1.10.640.10-FF-000099', NULL, 'Uncharacterized protein', 198, NULL, NULL, 109687),
(109688, '4.10.400.10-FF-000266', NULL, 'Putative vitellogenin receptor', 40, NULL, NULL, 109688),
(109689, '3.30.479.30-FF-000003', NULL, 'Flotillin 2', 118, NULL, NULL, 109689),
(109690, '2.60.40.10-FF-001048', NULL, 'Sallimus, isoform Q', 100, NULL, NULL, 109690),
(109691, '1.10.287.70-FF-000738', NULL, 'Uncharacterized protein', 110, NULL, NULL, 109691),
(109692, '3.30.70.100-FF-000135', NULL, NULL, 115, NULL, NULL, 109692),
(109693, '1.10.1200.10-FF-000025', NULL, 'Phenolpthiocerol synthesis polyketide synthase PpsA', 80, NULL, NULL, 109693);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(109694, '2.40.270.10-FF-000037', NULL, NULL, 92, NULL, NULL, 109694),
(109695, '1.20.5.2950-FF-000009', NULL, NULL, 89, NULL, NULL, 109695),
(109696, '1.20.1070.10-FF-001001', NULL, 'Uncharacterized protein', 329, NULL, NULL, 109696),
(109697, '3.30.160.60-FF-004403', NULL, 'Transcription factor IIIA', 32, NULL, NULL, 109697),
(109698, '3.30.200.20-FF-001832', NULL, NULL, 116, NULL, NULL, 109698),
(109699, '3.40.140.10-FF-000198', NULL, 'Uncharacterized protein', 149, NULL, NULL, 109699),
(109700, '1.10.3060.10-FF-000020', NULL, 'Predicted protein', 123, NULL, NULL, 109700),
(109701, '3.90.1600.10-FF-000070', NULL, 'DNA polymerase', 56, NULL, NULL, 109701),
(109702, '2.60.60.20-FF-000012', NULL, 'polycystin-1 isoform X2', 115, NULL, NULL, 109702),
(109703, '2.10.220.10-FF-000041', NULL, 'Receptor protein-tyrosine kinase', 43, NULL, NULL, 109703),
(109704, '2.20.100.10-FF-000069', NULL, 'Cellular communication network factor 4', 66, NULL, NULL, 109704),
(109705, '2.60.40.10-FF-003818', NULL, NULL, 115, NULL, NULL, 109705),
(109706, '3.40.50.150-FF-001705', NULL, NULL, 65, NULL, NULL, 109706),
(109707, '3.30.160.60-FF-003094', NULL, 'Uncharacterized protein', 29, NULL, NULL, 109707),
(109708, '2.40.30.70-FF-000015', NULL, 'Uncharacterized protein', 104, NULL, NULL, 109708),
(109709, '1.10.472.10-FF-000494', NULL, 'Uncharacterized protein', 109, NULL, NULL, 109709),
(109710, '3.40.390.10-FF-000070', NULL, 'Matrix metallopeptidase 25b', 268, NULL, NULL, 109710),
(109711, '3.40.50.1220-FF-000025', NULL, 'Pyruvate decarboxylase', 157, NULL, NULL, 109711),
(109712, '1.25.40.10-FF-002429', NULL, 'Uncharacterized protein', 121, NULL, NULL, 109712),
(109713, '3.30.565.10-FF-000411', NULL, 'Response receiver sensor histidine kinase, PAS domain-containing', 185, NULL, NULL, 109713),
(109714, '3.40.50.720-FF-002557', NULL, 'Uncharacterized protein', 53, NULL, NULL, 109714),
(109715, '3.40.50.1820-FF-000317', NULL, 'Carboxylic ester hydrolase', 533, NULL, NULL, 109715),
(109716, '3.80.10.10-FF-000475', NULL, 'Predicted gene 10436', 252, NULL, NULL, 109716),
(109717, '4.10.1240.10-FF-000003', NULL, 'Putative cadherin EGF LAG seven-pass G-type receptor 2', 54, NULL, NULL, 109717),
(109718, '3.30.70.330-FF-001108', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 82, NULL, NULL, 109718),
(109719, '1.20.1250.20-FF-001687', NULL, 'Solute carrier organic anion transporter family member', 208, NULL, NULL, 109719),
(109720, '1.10.8.10-FF-000111', NULL, 'Uncharacterized protein, isoform A', 45, NULL, NULL, 109720),
(109721, '3.30.160.60-FF-000660', NULL, 'zinc finger protein 64 isoform X1', 30, NULL, NULL, 109721),
(109722, '1.25.10.10-FF-000803', NULL, 'Predicted protein', 268, NULL, NULL, 109722),
(109723, '1.20.120.850-FF-000044', NULL, 'RAD54 homolog B', 80, NULL, NULL, 109723),
(109724, '3.40.50.1820-FF-000789', NULL, 'GPI inositol-deacylase', 227, NULL, NULL, 109724),
(109725, '1.10.560.10-FF-000098', NULL, 'T-complex protein 1 subunit eta', 211, NULL, NULL, 109725),
(109726, '3.30.70.1230-FF-000160', NULL, 'Predicted protein', 156, NULL, NULL, 109726),
(109727, '2.40.30.170-FF-000048', NULL, 'Cation efflux system protein', 95, NULL, NULL, 109727),
(109728, '4.10.280.10-FF-000177', NULL, 'Transcription factor', 62, NULL, NULL, 109728),
(109729, '2.30.29.30-FF-000186', NULL, 'Arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 1', 98, NULL, NULL, 109729),
(109730, '1.10.472.80-FF-000262', NULL, NULL, 62, NULL, NULL, 109730),
(109731, '3.40.50.720-FF-001129', NULL, 'Possible transmembrane cation transporter', 140, NULL, NULL, 109731),
(109732, '2.40.50.90-FF-000117', NULL, 'Tudor, isoform B', 38, NULL, NULL, 109732),
(109733, '2.60.120.1440-FF-000020', NULL, 'Uncharacterized protein', 123, NULL, NULL, 109733),
(109734, '3.40.50.300-FF-007990', NULL, 'Uncharacterized protein', 156, NULL, NULL, 109734),
(109735, '3.30.450.40-FF-000249', NULL, 'Phosphodiesterase', 168, NULL, NULL, 109735),
(109736, '3.40.50.1000-FF-000723', NULL, NULL, 91, NULL, NULL, 109736),
(109737, '1.20.1070.10-FF-000012', NULL, 'Olfactory receptor', 290, NULL, NULL, 109737);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(109738, '2.60.40.10-FF-005382', NULL, NULL, 57, NULL, NULL, 109738),
(109739, '3.40.50.300-FF-002667', NULL, 'ESX-5 secretion system protein EccC5', 102, NULL, NULL, 109739),
(109740, '3.50.50.60-FF-000393', NULL, 'Related to flavin-containing monooxygenase', 62, NULL, NULL, 109740),
(109741, '1.50.40.10-FF-000359', NULL, 'Mitochondrial carrier protein', 166, NULL, NULL, 109741),
(109742, '2.60.40.10-FF-002037', NULL, '1,4-alpha-glucan branching enzyme', 108, NULL, NULL, 109742),
(109743, '2.60.98.20-FF-000009', NULL, 'Flagellar hook protein FlgE', 147, NULL, NULL, 109743),
(109744, '3.90.70.10-FF-000782', NULL, 'Predicted protein', 355, NULL, NULL, 109744),
(109745, '3.30.559.30-FF-000004', NULL, 'Enterobactin synthetase component F', 237, NULL, NULL, 109745),
(109746, '2.60.120.10-FF-000191', NULL, 'Cyclic nucleotide-binding domain-containing protein', 120, NULL, NULL, 109746),
(109747, '3.30.160.60-FF-004875', NULL, NULL, 21, NULL, NULL, 109747),
(109748, '3.30.300.130-FF-000039', NULL, NULL, 76, NULL, NULL, 109748),
(109749, '3.80.10.10-FF-003229', NULL, 'Uncharacterized protein', 356, NULL, NULL, 109749),
(109750, '3.40.630.10-FF-000426', NULL, 'Uncharacterized protein', 335, NULL, NULL, 109750),
(109751, '1.10.10.750-FF-000015', NULL, 'Small G protein signaling modulator', 42, NULL, NULL, 109751),
(109752, '3.30.450.20-FF-000243', NULL, 'Cyclic di-GMP phosphodiesterase Gmr', 126, NULL, NULL, 109752),
(109753, '1.10.472.10-FF-000022', NULL, 'cyclin-J isoform X1', 107, NULL, NULL, 109753),
(109754, '1.20.1250.10-FF-000110', NULL, NULL, 189, NULL, NULL, 109754),
(109755, '4.10.1080.10-FF-000001', NULL, 'Thrombospondin 3', 119, NULL, NULL, 109755),
(109756, '3.30.200.20-FF-001040', NULL, 'Protein kinase, putative', 123, NULL, NULL, 109756),
(109757, '3.30.420.10-FF-000525', NULL, NULL, 108, NULL, NULL, 109757),
(109758, '1.20.1250.20-FF-002204', NULL, 'Uncharacterized protein', 144, NULL, NULL, 109758),
(109759, '3.40.50.1100-FF-000135', NULL, 'L-serine dehydratase/L-threonine deaminase', 23, NULL, NULL, 109759),
(109760, '1.10.238.230-FF-000002', NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit B''''alpha', 102, NULL, NULL, 109760),
(109761, '1.20.5.1010-FF-000001', NULL, 'Transient receptor potential cation channel subfamily M member 3', 55, NULL, NULL, 109761),
(109762, '3.40.50.300-FF-005601', NULL, 'Uncharacterized protein', 54, NULL, NULL, 109762),
(109763, '3.60.120.10-FF-000006', NULL, 'Anthranilate synthase component 1', 519, NULL, NULL, 109763),
(109764, '1.25.40.10-FF-004785', NULL, 'Uncharacterized protein', 180, NULL, NULL, 109764),
(109765, '3.40.250.10-FF-000060', NULL, 'Mitogen-activated protein kinase phosphatase 1', 158, NULL, NULL, 109765),
(109766, '3.90.190.10-FF-000004', NULL, 'Protein phosphatase Slingshot homolog 2', 157, NULL, NULL, 109766),
(109767, '1.10.287.10-FF-000035', NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase', 29, NULL, NULL, 109767),
(109768, '3.10.110.20-FF-000003', NULL, 'Fancl, isoform B', 99, NULL, NULL, 109768),
(109769, '3.10.270.10-FF-000006', NULL, 'GTP cyclohydrolase MptA', 287, NULL, NULL, 109769),
(109770, '3.40.50.720-FF-000320', NULL, 'ubiquitin-like modifier-activating enzyme 7', 205, NULL, NULL, 109770),
(109771, '3.70.10.10-FF-000144', NULL, 'Uncharacterized protein', 167, NULL, NULL, 109771),
(109772, '2.10.90.10-FF-000064', NULL, 'Glycoprotein hormone alpha 2', 100, NULL, NULL, 109772),
(109773, '3.80.10.10-FF-004218', NULL, 'Uncharacterized protein', 85, NULL, NULL, 109773),
(109774, '2.130.10.10-FF-005067', NULL, 'Cilia and flagella associated protein 57', 271, NULL, NULL, 109774),
(109775, '1.10.510.10-FF-001376', NULL, 'Protein kinase domain containing protein', 177, NULL, NULL, 109775),
(109776, '4.10.410.10-FF-000031', NULL, 'CRE-MEC-1 protein', 39, NULL, NULL, 109776),
(109777, '1.20.1250.20-FF-000259', NULL, 'Major facilitator family transporter', 420, NULL, NULL, 109777),
(109778, '2.10.70.10-FF-000001', NULL, 'Selectin P', 62, NULL, NULL, 109778),
(109779, '3.30.470.20-FF-000126', NULL, 'D-alanine--D-alanine ligase', 147, NULL, NULL, 109779);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(109780, '3.30.420.40-FF-000101', NULL, 'FGGY carbohydrate kinase domain-containing protein', 362, NULL, NULL, 109780),
(109781, '1.10.630.10-FF-000334', NULL, 'Cytochrome P450, putative', 421, NULL, NULL, 109781),
(109782, '3.40.50.1980-FF-000112', NULL, 'ABC transporter substrate-binding protein', 123, NULL, NULL, 109782),
(109783, '1.20.58.340-FF-000077', NULL, 'Uncharacterized protein', 177, NULL, NULL, 109783),
(109784, '3.30.230.10-FF-000342', NULL, 'Uncharacterized protein', 41, NULL, NULL, 109784),
(109785, '1.25.10.10-FF-001259', NULL, 'Armadillo/beta-catenin repeat family protein', 133, NULL, NULL, 109785),
(109786, '2.160.10.10-FF-000092', NULL, 'Serine acetyltransferase', 154, NULL, NULL, 109786),
(109787, '3.20.20.70-FF-000373', NULL, 'Putative pyridoxine biosynthesis protein pdx-1', 303, NULL, NULL, 109787),
(109788, '2.40.50.140-FF-000633', NULL, 'ABC transporter ATP-binding protein', 59, NULL, NULL, 109788),
(109789, '3.40.630.30-FF-000612', NULL, 'Glucosamine 6-phosphate N-acetyltransferase', 48, NULL, NULL, 109789),
(109790, '3.30.160.60-FF-003414', NULL, 'Zinc finger protein 1183', 28, NULL, NULL, 109790),
(109791, '3.30.40.10-FF-001665', NULL, 'Ras-like small GTPase, putative', 84, NULL, NULL, 109791),
(109792, '3.30.200.20-FF-000843', NULL, 'Non-specific serine/threonine protein kinase', 78, NULL, NULL, 109792),
(109793, '1.20.1070.10-FF-000484', NULL, 'NeuroPeptide Receptor family', 381, NULL, NULL, 109793),
(109794, '1.20.140.50-FF-000014', NULL, 'Vacuolar protein-sorting protein BRO1', 143, NULL, NULL, 109794),
(109795, '1.10.287.450-FF-000004', NULL, 'Non-homologous end-joining factor 1', 90, NULL, NULL, 109795),
(109796, '3.30.70.990-FF-000002', NULL, 'UPF0234 protein LEP1GSC067_4943', 87, NULL, NULL, 109796),
(109797, '2.10.25.10-FF-000458', NULL, 'prolow-density lipoprotein receptor-related protein 1', 39, NULL, NULL, 109797),
(109798, '6.10.140.2220-FF-000053', NULL, 'Zinc finger (MYND type) family protein / programmed cell death 2 C-terminal domain-containing protein', 49, NULL, NULL, 109798),
(109799, '2.60.120.260-FF-000227', NULL, 'Predicted protein', 218, NULL, NULL, 109799),
(109800, '1.25.10.10-FF-002248', NULL, 'Uncharacterized protein', 373, NULL, NULL, 109800),
(109801, '3.30.70.1230-FF-000008', NULL, 'Adenylate cyclase type 9', 201, NULL, NULL, 109801),
(109802, '1.10.287.110-FF-000279', NULL, 'J-type chaperone', 88, NULL, NULL, 109802),
(109803, '3.60.21.10-FF-000041', NULL, 'Serine/threonine-protein phosphatase 1', 213, NULL, NULL, 109803),
(109804, '3.30.720.50-FF-000003', NULL, 'E3 ubiquitin-protein ligase RNF146', 83, NULL, NULL, 109804),
(109805, '3.30.40.10-FF-000737', NULL, 'E3 ubiquitin-protein ligase ORTHRUS 3', 127, NULL, NULL, 109805),
(109806, '1.10.533.10-FF-000131', NULL, 'Fas-associated death domain protein', 109, NULL, NULL, 109806),
(109807, '2.30.30.140-FF-000058', NULL, 'Lamin B receptor', 62, NULL, NULL, 109807),
(109808, '1.20.58.390-FF-000159', NULL, 'Acetylcholine receptor subunit alpha-type acr-16', 99, NULL, NULL, 109808),
(109809, '1.25.40.20-FF-000460', NULL, 'Ankyrin repeat and SOCS box containing 15', 341, NULL, NULL, 109809),
(109810, '3.40.33.10-FF-000131', NULL, 'Uncharacterized protein', 185, NULL, NULL, 109810),
(109811, '2.60.120.260-FF-000666', NULL, 'Uncharacterized protein', 237, NULL, NULL, 109811),
(109812, '3.40.50.1820-FF-001306', NULL, 'Uncharacterized protein', 270, NULL, NULL, 109812),
(109813, '3.30.710.10-FF-000452', NULL, 'GEO10396p1', 142, NULL, NULL, 109813),
(109814, '3.90.70.80-FF-000050', NULL, 'OTU domain-containing protein 6B', 155, NULL, NULL, 109814),
(109815, '3.20.100.10-FF-000003', NULL, 'Unplaced genomic scaffold supercont1.18, whole genome shotgun sequence', 294, NULL, NULL, 109815),
(109816, '1.20.5.190-FF-000010', NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', 48, NULL, NULL, 109816),
(109817, '2.130.10.10-FF-000716', NULL, 'WD repeat domain 11', 188, NULL, NULL, 109817),
(109818, '1.25.40.180-FF-000177', NULL, NULL, 112, NULL, NULL, 109818),
(109819, '1.25.10.10-FF-001731', NULL, 'U3 small nucleolar RNA-associated protein 10', 196, NULL, NULL, 109819);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(109820, '3.40.50.2300-FF-000214', NULL, 'Two-component response regulator-like PRR37', 160, NULL, NULL, 109820),
(109821, '4.10.1000.40-FF-000005', NULL, 'Polyadenylated RNA binding protein', 82, NULL, NULL, 109821),
(109822, '2.60.40.10-FF-002829', NULL, 'Tyrosine-protein kinase receptor', 86, NULL, NULL, 109822),
(109823, '3.30.1370.50-FF-000026', NULL, 'Uncharacterized protein', 100, NULL, NULL, 109823),
(109824, '3.10.20.650-FF-000002', NULL, 'Uncharacterized protein', 107, NULL, NULL, 109824),
(109825, '1.10.1520.10-FF-000100', NULL, 'Secreted protein, putative', 175, NULL, NULL, 109825),
(109826, '2.40.50.510-FF-000002', NULL, 'RecQ-mediated genome instability protein 1', 98, NULL, NULL, 109826),
(109827, '2.40.10.10-FF-000221', NULL, 'Si:dkey-33m11.8', 148, NULL, NULL, 109827),
(109828, '2.60.120.290-FF-000242', NULL, 'Cubilin homolog', 125, NULL, NULL, 109828),
(109829, '3.90.70.10-FF-000310', NULL, 'Ubiquitin carboxyl-terminal hydrolase 30 homolog', 290, NULL, NULL, 109829),
(109830, '3.20.170.50-FF-000002', NULL, NULL, 117, NULL, NULL, 109830),
(109831, '3.30.40.10-FF-000676', NULL, 'E3 ubiquitin-protein ligase RNF169', 94, NULL, NULL, 109831),
(109832, '3.30.505.10-FF-000082', NULL, 'Uncharacterized protein, isoform B', 96, NULL, NULL, 109832),
(109833, '3.40.50.300-FF-003656', NULL, 'DNA repair protein RAD51 homolog 4 isoform X2', 51, NULL, NULL, 109833),
(109834, '2.60.120.480-FF-000001', NULL, 'Ureidoglycolate lyase', 160, NULL, NULL, 109834),
(109835, '2.60.40.60-FF-000293', NULL, 'DE-cadherin', 108, NULL, NULL, 109835),
(109836, '3.40.850.10-FF-000437', NULL, 'Uncharacterized protein', 140, NULL, NULL, 109836),
(109837, '3.40.605.10-FF-000121', NULL, 'Predicted protein', 234, NULL, NULL, 109837),
(109838, '2.130.10.10-FF-004578', NULL, 'Uncharacterized protein', 209, NULL, NULL, 109838),
(109839, '3.90.800.10-FF-000001', NULL, 'Glutamine--tRNA ligase', 105, NULL, NULL, 109839),
(109840, '3.80.10.10-FF-004157', NULL, 'Ras guanine nucleotide exchange factor N', 104, NULL, NULL, 109840),
(109841, '3.30.240.40-FF-000003', NULL, 'Protein E6', 68, NULL, NULL, 109841),
(109842, '1.20.5.170-FF-000296', NULL, 'Uncharacterized protein', 34, NULL, NULL, 109842),
(109843, '1.10.3500.10-FF-000037', NULL, 'Uncharacterized protein', 107, NULL, NULL, 109843),
(109844, '3.40.430.10-FF-000006', NULL, 'Riboflavin biosynthesis protein RibD', 226, NULL, NULL, 109844),
(109845, '2.40.30.10-FF-000104', NULL, '50S ribosomal protein L3', 78, NULL, NULL, 109845),
(109846, '3.30.70.330-FF-000771', NULL, 'Polyadenylate-binding protein RBP45A', 102, NULL, NULL, 109846),
(109847, '1.20.1250.20-FF-001215', NULL, 'AGAP011680-PA', 225, NULL, NULL, 109847),
(109848, '2.130.10.10-FF-002341', NULL, 'Ddb1 and cul4-associated factor 11', 159, NULL, NULL, 109848),
(109849, '3.30.428.10-FF-000054', NULL, 'Galactose-1-phosphate uridyl transferase', 163, NULL, NULL, 109849),
(109850, '1.10.238.10-FF-000787', NULL, 'Mitochondrial substrate carrier family protein', 78, NULL, NULL, 109850),
(109851, '1.10.287.1080-FF-000003', NULL, 'Nucleoside triphosphate pyrophosphohydrolase', 131, NULL, NULL, 109851),
(109852, '1.10.287.1490-FF-000036', NULL, 'Pi3K21B, isoform B', 178, NULL, NULL, 109852),
(109853, '1.10.150.50-FF-000096', NULL, 'Sterile alpha motif domain containing 9 like', 78, NULL, NULL, 109853),
(109854, '1.20.120.350-FF-000017', NULL, 'potassium voltage-gated channel subfamily KQT member 1', 147, NULL, NULL, 109854),
(109855, '2.60.120.650-FF-000193', NULL, 'Predicted protein', 63, NULL, NULL, 109855),
(109856, '3.40.630.60-FF-000008', NULL, NULL, 102, NULL, NULL, 109856),
(109857, '1.10.555.10-FF-000176', NULL, NULL, 246, NULL, NULL, 109857),
(109858, '1.20.120.230-FF-000066', NULL, 'Uncharacterized protein', 145, NULL, NULL, 109858),
(109859, '2.170.270.10-FF-000141', NULL, 'Histone-lysine N-methyltransferase', 115, NULL, NULL, 109859),
(109860, '3.30.160.60-FF-001969', NULL, 'D19B', 25, NULL, NULL, 109860),
(109861, '2.60.120.780-FF-000001', NULL, 'E3 SUMO-protein ligase PIAS2 isoform X1', 154, NULL, NULL, 109861); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(109862, '3.40.718.10-FF-000017', NULL, 'Isocitrate dehydrogenase [NADP]', 398, NULL, NULL, 109862),
(109863, '2.60.40.10-FF-004454', NULL, NULL, 108, NULL, NULL, 109863),
(109864, '2.10.25.10-FF-001094', NULL, 'Crumbs cell polarity complex component 1', 43, NULL, NULL, 109864),
(109865, '1.25.40.20-FF-001269', NULL, 'Ankyrin repeat and MYND domain-containing 2b', 194, NULL, NULL, 109865),
(109866, '3.30.160.60-FF-001469', NULL, 'zinc finger protein 37 homolog', 28, NULL, NULL, 109866),
(109867, '3.30.160.60-FF-003914', NULL, NULL, 55, NULL, NULL, 109867),
(109868, '3.40.605.10-FF-000093', NULL, 'Uncharacterized protein', 219, NULL, NULL, 109868),
(109869, '1.10.287.130-FF-000026', NULL, 'Two-component system sensor histidine kinase PmrB', 62, NULL, NULL, 109869),
(109870, '2.40.50.140-FF-000133', NULL, 'cold shock domain-containing protein E1 isoform X1', 76, NULL, NULL, 109870),
(109871, '1.10.510.10-FF-003793', NULL, NULL, 126, NULL, NULL, 109871),
(109872, '3.30.70.1170-FF-000029', NULL, 'tRNA (cytosine(49)-C(5))-methyltransferase', 97, NULL, NULL, 109872),
(109873, '3.30.420.40-FF-001057', NULL, 'Uncharacterized protein', 81, NULL, NULL, 109873),
(109874, '1.10.510.10-FF-003613', NULL, NULL, 198, NULL, NULL, 109874),
(109875, '3.10.330.20-FF-000014', NULL, 'Protein L-isoaspartate methyltransferase', 64, NULL, NULL, 109875),
(109876, '3.20.20.140-FF-000212', NULL, 'DNA-directed DNA polymerase', 281, NULL, NULL, 109876),
(109877, '1.20.1070.10-FF-000984', NULL, 'Uncharacterized protein', 342, NULL, NULL, 109877),
(109878, '1.10.10.10-FF-000331', NULL, 'Anaphase-promoting complex subunit 2', 86, NULL, NULL, 109878),
(109879, '2.120.10.80-FF-000125', NULL, 'kelch domain-containing protein 9', 223, NULL, NULL, 109879),
(109880, '2.30.30.490-FF-000051', NULL, 'PolyBRoMo domain containing', 210, NULL, NULL, 109880),
(109881, '3.40.50.300-FF-008327', NULL, 'Uncharacterized protein', 243, NULL, NULL, 109881),
(109882, '3.30.70.1770-FF-000001', NULL, 'Type III export protein PscD', 63, NULL, NULL, 109882),
(109883, '2.40.250.10-FF-000007', NULL, 'Core binding factor beta subunit isoform 7', 39, NULL, NULL, 109883),
(109884, '3.30.930.10-FF-000316', NULL, 'Ferredoxin-fold anticodon-binding domain-containing 1', 371, NULL, NULL, 109884),
(109885, '1.10.630.10-FF-000834', NULL, 'Uncharacterized protein', 165, NULL, NULL, 109885),
(109886, '1.20.90.10-FF-000049', NULL, NULL, 120, NULL, NULL, 109886),
(109887, '2.60.120.260-FF-000166', NULL, 'Beta-galactosidase', 178, NULL, NULL, 109887),
(109888, '3.30.1370.210-FF-000003', NULL, 'Zinc finger CCCH domain-containing protein 10', 89, NULL, NULL, 109888),
(109889, '1.25.40.10-FF-001620', NULL, 'probable UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SPINDLY', 199, NULL, NULL, 109889),
(109890, '3.40.50.300-FF-005101', NULL, 'Energy-coupling factor transporter ATP-binding protein EcfA2', 266, NULL, NULL, 109890),
(109891, '3.40.50.1240-FF-000183', NULL, 'Chromosome 8, whole genome shotgun sequence', 414, NULL, NULL, 109891),
(109892, '3.10.28.10-FF-000013', NULL, 'Protein RecA', 183, NULL, NULL, 109892),
(109893, '1.25.10.10-FF-000303', NULL, 'splicing factor 3B subunit 1', 216, NULL, NULL, 109893),
(109894, '1.20.1250.20-FF-001748', NULL, 'Uncharacterized protein', 274, NULL, NULL, 109894),
(109895, '3.40.50.300-FF-007046', NULL, 'ATP-dependent DNA helicase PIF4', 199, NULL, NULL, 109895),
(109896, '4.10.1000.10-FF-000081', NULL, 'Uncharacterized protein', 56, NULL, NULL, 109896),
(109897, '3.40.50.620-FF-000728', NULL, 'Predicted protein', 195, NULL, NULL, 109897),
(109898, '2.10.25.10-FF-000958', NULL, 'Abnormal pharyngeal pumping eat-20', 38, NULL, NULL, 109898),
(109899, '3.80.10.10-FF-003701', NULL, 'Leucine-rich repeat protein (LRRP), putative', 285, NULL, NULL, 109899),
(109900, '1.25.10.10-FF-000011', NULL, 'Serine/threonine-protein phosphatase 2A regulatory subunit A alpha isoform', 585, NULL, NULL, 109900),
(109901, '3.30.160.60-FF-001177', NULL, 'Zinc finger protein 33A', 28, NULL, NULL, 109901),
(109902, '1.10.10.10-FF-001079', NULL, 'O-methyltransferase', 86, NULL, NULL, 109902);
INSERT INTO "PUBLIC"."MODEL" VALUES
(109903, '2.170.11.10-FF-000003', NULL, 'DNA topoisomerase I', 124, NULL, NULL, 109903),
(109904, '2.60.40.150-FF-000236', NULL, 'Rabphilin, isoform A', 155, NULL, NULL, 109904),
(109905, '3.50.30.30-FF-000023', NULL, 'E3 ubiquitin-protein ligase RNF43 isoform X2', 76, NULL, NULL, 109905),
(109906, '1.10.150.20-FF-000261', NULL, 'Protein PARTING DANCERS', 60, NULL, NULL, 109906),
(109907, '1.20.1250.10-FF-000077', NULL, 'Colony-stimulating factor 1', 157, NULL, NULL, 109907),
(109908, '1.20.1050.130-FF-000015', NULL, 'Uncharacterized protein', 200, NULL, NULL, 109908),
(109909, '3.30.160.60-FF-005331', NULL, NULL, 29, NULL, NULL, 109909),
(109910, '3.30.930.10-FF-000024', NULL, 'Lipoate-protein ligase A', 248, NULL, NULL, 109910),
(109911, '1.20.58.760-FF-000028', NULL, 'ATP-dependent metallopeptidase Hfl', 101, NULL, NULL, 109911),
(109912, '1.20.1270.60-FF-000014', NULL, 'Protein hob3, variant', 233, NULL, NULL, 109912),
(109913, '1.20.1260.100-FF-000003', NULL, 'Protein CBG24492', 160, NULL, NULL, 109913),
(109914, '3.40.47.10-FF-000073', NULL, 'Acetyl-CoA acetyltransferase', 385, NULL, NULL, 109914),
(109915, '1.10.1300.10-FF-000089', NULL, 'Phosphodiesterase', 174, NULL, NULL, 109915),
(109916, '3.40.630.30-FF-000112', NULL, 'N-acetyltransferase Eis', 134, NULL, NULL, 109916),
(109917, '1.10.10.10-FF-001612', NULL, 'Uncharacterized protein', 76, NULL, NULL, 109917),
(109918, '3.40.50.300-FF-007338', NULL, 'Midasin', 252, NULL, NULL, 109918),
(109919, '2.130.10.10-FF-001352', NULL, 'WD repeat domain 63', 249, NULL, NULL, 109919),
(109920, '2.70.150.10-FF-000055', NULL, 'Calcium-transporting ATPase', 128, NULL, NULL, 109920),
(109921, '2.40.10.10-FF-000693', NULL, NULL, 218, NULL, NULL, 109921),
(109922, '2.10.110.10-FF-000212', NULL, 'Protein CBR-LIM-9', 63, NULL, NULL, 109922),
(109923, '3.10.450.240-FF-000031', NULL, 'Predicted protein', 108, NULL, NULL, 109923),
(109924, '2.130.10.10-FF-004078', NULL, 'Uncharacterized protein', 202, NULL, NULL, 109924),
(109925, '2.40.50.140-FF-001122', NULL, NULL, 167, NULL, NULL, 109925),
(109926, '1.10.40.30-FF-000018', NULL, 'Adenylosuccinate lyase', 85, NULL, NULL, 109926),
(109927, '3.15.10.10-FF-000007', NULL, 'BPI fold containing family C', 28, NULL, NULL, 109927),
(109928, '1.10.3080.10-FF-000083', NULL, 'Chloride channel protein', 350, NULL, NULL, 109928),
(109929, '3.40.50.150-FF-001644', NULL, NULL, 237, NULL, NULL, 109929),
(109930, '3.30.390.80-FF-000003', NULL, 'DNA repair protein RAD59', 148, NULL, NULL, 109930),
(109931, '2.10.220.10-FF-000102', NULL, 'R-spondin 2', 73, NULL, NULL, 109931),
(109932, '3.30.160.190-FF-000007', NULL, 'Uncharacterized protein', 81, NULL, NULL, 109932),
(109933, '3.40.50.2300-FF-000714', NULL, 'Sugar ABC transporter substrate-binding protein', 146, NULL, NULL, 109933),
(109934, '3.30.160.60-FF-002897', NULL, 'Zinc finger protein 623', 32, NULL, NULL, 109934),
(109935, '1.10.3720.10-FF-000048', NULL, 'Thiamine/thiamine pyrophosphate ABC transporter permease ThiP', 243, NULL, NULL, 109935),
(109936, '3.40.50.11210-FF-000020', NULL, NULL, 180, NULL, NULL, 109936),
(109937, '3.30.40.10-FF-001373', NULL, 'Uncharacterized protein', 87, NULL, NULL, 109937),
(109938, '3.20.20.150-FF-000069', NULL, 'Hydroxypyruvate isomerase (putative)', 226, NULL, NULL, 109938),
(109939, '3.30.460.10-FF-000151', NULL, 'Uncharacterized protein', 126, NULL, NULL, 109939),
(109940, '3.40.570.10-FF-000016', NULL, 'GG12061', 233, NULL, NULL, 109940),
(109941, '2.60.40.10-FF-003465', NULL, NULL, 100, NULL, NULL, 109941),
(109942, '3.40.50.300-FF-004584', NULL, 'HPr kinase/phosphorylase', 181, NULL, NULL, 109942),
(109943, '3.30.160.60-FF-004050', NULL, NULL, 24, NULL, NULL, 109943),
(109944, '2.40.70.10-FF-000230', NULL, 'ASpartyl Protease', 160, NULL, NULL, 109944),
(109945, '3.90.1420.10-FF-000033', NULL, 'Uncharacterized protein', 111, NULL, NULL, 109945),
(109946, '3.40.50.620-FF-000880', NULL, 'Uncharacterized protein', 111, NULL, NULL, 109946),
(109947, '3.10.250.10-FF-000095', NULL, NULL, 105, NULL, NULL, 109947),
(109948, '4.10.280.10-FF-000205', NULL, 'REF-1', 58, NULL, NULL, 109948);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(109949, '1.25.40.10-FF-000131', NULL, 'probable UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SEC', 103, NULL, NULL, 109949),
(109950, '1.25.40.10-FF-002368', NULL, 'Os02g0552100 protein', 101, NULL, NULL, 109950),
(109951, '3.40.50.2300-FF-001203', NULL, NULL, 100, NULL, NULL, 109951),
(109952, '3.40.50.150-FF-001352', NULL, NULL, 190, NULL, NULL, 109952),
(109953, '3.30.2320.80-FF-000004', NULL, 'Hydrogenase maturation factor HypA', 133, NULL, NULL, 109953),
(109954, '3.30.1520.10-FF-000190', NULL, 'Uncharacterized protein', 70, NULL, NULL, 109954),
(109955, '3.40.50.460-FF-000045', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit beta 2', 41, NULL, NULL, 109955),
(109956, '3.40.50.150-FF-001205', NULL, NULL, 99, NULL, NULL, 109956),
(109957, '3.40.50.720-FF-000792', NULL, 'Bifunctional dehydrogenase/ferrochelatase', 150, NULL, NULL, 109957),
(109958, '1.10.10.160-FF-000052', NULL, 'Predicted protein', 80, NULL, NULL, 109958),
(109959, '1.10.630.10-FF-000042', NULL, 'Cytochrome P450', 486, NULL, NULL, 109959),
(109960, '1.20.58.1280-FF-000003', NULL, 'DNA repair protein REV1', 103, NULL, NULL, 109960),
(109961, '3.40.50.1000-FF-000695', NULL, NULL, 133, NULL, NULL, 109961),
(109962, '1.10.340.70-FF-000026', NULL, 'Uncharacterized protein', 93, NULL, NULL, 109962),
(109963, '3.80.10.10-FF-002392', NULL, 'Uncharacterized protein', 98, NULL, NULL, 109963),
(109964, '1.25.10.10-FF-003176', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 325, NULL, NULL, 109964),
(109965, '3.30.360.10-FF-000115', NULL, 'Predicted protein', 84, NULL, NULL, 109965),
(109966, '3.30.450.20-FF-000682', NULL, 'Uncharacterized protein', 66, NULL, NULL, 109966),
(109967, '2.40.128.620-FF-000002', NULL, 'Low-density lipoprotein receptor-related protein', 42, NULL, NULL, 109967),
(109968, '2.10.25.10-FF-000166', NULL, 'laminin subunit gamma-1', 95, NULL, NULL, 109968),
(109969, '3.30.1330.30-FF-000074', NULL, 'Ribosomal protein L7Ae, putative', 185, NULL, NULL, 109969),
(109970, '3.30.70.1170-FF-000001', NULL, 'Ribosomal RNA methyltransferase Nop2', 107, NULL, NULL, 109970),
(109971, '2.60.200.10-FF-000045', NULL, 'Interferon regulatory factor 4a', 225, NULL, NULL, 109971),
(109972, '3.40.30.10-FF-000478', NULL, 'Eps1p', 168, NULL, NULL, 109972),
(109973, '1.10.132.70-FF-000003', NULL, 'Telomerase reverse transcriptase', 162, NULL, NULL, 109973),
(109974, '3.90.226.10-FF-000133', NULL, 'Enoyl-CoA hydratase/isomerase family protein', 193, NULL, NULL, 109974),
(109975, '1.20.1070.10-FF-000192', NULL, 'Latrophilin 1', 276, NULL, NULL, 109975),
(109976, '1.25.40.10-FF-003857', NULL, '1-aminocyclopropane-1-carboxylate oxidase 1', 108, NULL, NULL, 109976),
(109977, '1.20.58.60-FF-000539', NULL, 'Spectrin repeat containing nuclear envelope protein 2', 192, NULL, NULL, 109977),
(109978, '3.40.50.150-FF-000716', NULL, 'Cytosine-C5 specific DNA methyltransferase', 104, NULL, NULL, 109978),
(109979, '1.10.1300.10-FF-000061', NULL, 'Uncharacterized protein', 208, NULL, NULL, 109979),
(109980, '3.40.50.150-FF-000896', NULL, 'MraW methylase family protein', 209, NULL, NULL, 109980),
(109981, '1.20.1310.10-FF-000048', NULL, 'Cullin-like protein, putative', 106, NULL, NULL, 109981),
(109982, '1.25.40.70-FF-000042', NULL, 'Phosphatidylinositol 4-kinase', 163, NULL, NULL, 109982),
(109983, '2.40.50.140-FF-000925', NULL, NULL, 132, NULL, NULL, 109983),
(109984, '3.90.190.10-FF-000476', NULL, 'Dual specificity protein phosphatase, putative', 176, NULL, NULL, 109984),
(109985, '3.30.980.10-FF-000027', NULL, 'Threonine--tRNA ligase, chloroplastic/mitochondrial 2 isoform A', 53, NULL, NULL, 109985),
(109986, '3.80.10.10-FF-000975', NULL, 'Zyg eleven-related protein 1', 167, NULL, NULL, 109986),
(109987, '1.10.10.60-FF-000677', NULL, 'Sigma-54 dependent response regulator', 53, NULL, NULL, 109987),
(109988, '3.30.70.330-FF-000119', NULL, 'RNA-binding motif protein, X chromosome', 135, NULL, NULL, 109988),
(109989, '3.30.2090.10-FF-000026', NULL, 'Acriflavine resistance protein B', 93, NULL, NULL, 109989);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(109990, '1.25.40.10-FF-002929', NULL, 'Clathrin heavy chain', 331, NULL, NULL, 109990),
(109991, '1.20.1070.10-FF-001501', NULL, 'Si:dkey-165n16.5', 198, NULL, NULL, 109991),
(109992, '2.40.50.90-FF-000056', NULL, 'Transcriptional coactivator p100', 172, NULL, NULL, 109992),
(109993, '3.30.200.20-FF-000051', NULL, 'Peripheral plasma membrane protein CASK isoform B', 85, NULL, NULL, 109993),
(109994, '2.130.10.10-FF-000424', NULL, 'p21-activated protein kinase-interacting protein 1-like', 179, NULL, NULL, 109994),
(109995, '3.20.20.10-FF-000023', NULL, 'Pyridoxal phosphate homeostasis protein', 235, NULL, NULL, 109995),
(109996, '3.40.50.1450-FF-000009', NULL, 'Periplasmically oriented, membrane-bound [NiFe]-hydrogenase maturation protease', 155, NULL, NULL, 109996),
(109997, '1.25.40.90-FF-000048', NULL, 'Uncharacterized protein', 129, NULL, NULL, 109997),
(109998, '1.20.1270.60-FF-000194', NULL, 'Dynamin-binding protein', 222, NULL, NULL, 109998),
(109999, '1.10.510.10-FF-000387', NULL, 'Receptor protein serine/threonine kinase', 217, NULL, NULL, 109999),
(110000, '2.60.40.10-FF-002537', NULL, 'Protein sidekick homolog', 98, NULL, NULL, 110000),
(110001, '2.40.330.10-FF-000008', NULL, 'Reduced vernalization response 1', 99, NULL, NULL, 110001),
(110002, '3.40.50.300-FF-001739', NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', 138, NULL, NULL, 110002),
(110003, '1.10.510.10-FF-000207', NULL, 'serine/threonine-protein kinase dst1 isoform X1', 288, NULL, NULL, 110003),
(110004, '3.40.50.670-FF-000018', NULL, 'Predicted protein', 74, NULL, NULL, 110004),
(110005, '1.25.40.550-FF-000013', NULL, 'Uncharacterized protein', 172, NULL, NULL, 110005),
(110006, '1.25.40.10-FF-001087', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 134, NULL, NULL, 110006),
(110007, '3.40.190.10-FF-000881', NULL, 'Uncharacterized protein', 95, NULL, NULL, 110007),
(110008, '2.130.10.10-FF-000688', NULL, 'Periodic tryptophan protein 2', 221, NULL, NULL, 110008),
(110009, '3.40.50.720-FF-002057', NULL, 'ATG7 autophagy-related 7 homolog (S. cerevisiae)', 170, NULL, NULL, 110009),
(110010, '3.40.50.1780-FF-000024', NULL, 'Putative hydrogenase', 108, NULL, NULL, 110010),
(110011, '1.20.1110.10-FF-000100', NULL, NULL, 12, NULL, NULL, 110011),
(110012, '3.20.20.30-FF-000029', NULL, 'Alkanal monooxygenase alpha chain LuxA', 353, NULL, NULL, 110012),
(110013, '3.40.50.300-FF-001711', NULL, 'GTPase HflX', 160, NULL, NULL, 110013),
(110014, '1.20.5.50-FF-000004', NULL, 'Fibrinogen beta chain', 143, NULL, NULL, 110014),
(110015, '3.30.160.60-FF-003122', NULL, 'Meiotic central spindle, isoform B', 31, NULL, NULL, 110015),
(110016, '2.30.29.30-FF-000039', NULL, 'Tensin 1', 151, NULL, NULL, 110016),
(110017, '3.30.160.60-FF-005359', NULL, NULL, 59, NULL, NULL, 110017),
(110018, '3.20.20.60-FF-000105', NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', 269, NULL, NULL, 110018),
(110019, '2.60.40.10-FF-004746', NULL, NULL, 106, NULL, NULL, 110019),
(110020, '3.30.1360.10-FF-000036', NULL, 'DNA-directed RNA polymerases II IV and V subunit 11', 70, NULL, NULL, 110020),
(110021, '1.10.238.10-FF-001304', NULL, 'Uncharacterized protein', 56, NULL, NULL, 110021),
(110022, '2.30.29.150-FF-000008', NULL, 'Chromatin-specific transcription elongation factor, putative', 152, NULL, NULL, 110022),
(110023, '2.130.10.10-FF-002633', NULL, 'Uncharacterized protein', 220, NULL, NULL, 110023),
(110024, '3.30.2350.10-FF-000064', NULL, 'Pseudouridylate synthase, putative', 238, NULL, NULL, 110024),
(110025, '3.20.20.70-FF-000726', NULL, NULL, 100, NULL, NULL, 110025),
(110026, '1.10.10.580-FF-000003', NULL, 'meiotic recombination protein REC8 homolog', 65, NULL, NULL, 110026),
(110027, '3.30.1360.120-FF-000064', NULL, 'Putative transferase CAF17, mitochondrial', 305, NULL, NULL, 110027),
(110028, '2.60.120.920-FF-000145', NULL, 'Uncharacterized protein', 86, NULL, NULL, 110028),
(110029, '3.40.50.1820-FF-001778', NULL, 'Uncharacterized protein', 184, NULL, NULL, 110029),
(110030, '1.20.1250.20-FF-001187', NULL, 'Uncharacterized symporter YnaJ', 198, NULL, NULL, 110030);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(110031, '2.30.110.10-FF-000022', NULL, 'Heme utilization protein HutZ', 165, NULL, NULL, 110031),
(110032, '3.20.20.80-FF-000263', NULL, 'Chitinase, putative', 218, NULL, NULL, 110032),
(110033, '2.60.120.200-FF-000255', NULL, 'Galectin', 135, NULL, NULL, 110033),
(110034, '2.70.98.20-FF-000020', NULL, 'Amine oxidase', 189, NULL, NULL, 110034),
(110035, '2.30.39.10-FF-000118', NULL, 'Uncharacterized protein', 100, NULL, NULL, 110035),
(110036, '3.20.20.140-FF-000392', NULL, 'Predicted protein', 164, NULL, NULL, 110036),
(110037, '2.60.40.10-FF-003026', NULL, 'T-cell surface glycoprotein CD1A1 antigen', 103, NULL, NULL, 110037),
(110038, '2.60.40.1120-FF-000053', NULL, 'Uncharacterized protein', 82, NULL, NULL, 110038),
(110039, '3.80.10.10-FF-000003', NULL, 'Acidic leucine-rich nuclear phosphoprotein 32 family member A', 163, NULL, NULL, 110039),
(110040, '1.25.40.10-FF-004493', NULL, 'MKIAA0372 protein', 97, NULL, NULL, 110040),
(110041, '3.40.30.10-FF-000450', NULL, 'Probable nucleoredoxin 1', 138, NULL, NULL, 110041),
(110042, '2.30.36.70-FF-000023', NULL, 'Uncharacterized protein', 39, NULL, NULL, 110042),
(110043, '1.10.287.70-FF-000446', NULL, 'Uncharacterized protein', 107, NULL, NULL, 110043),
(110044, '3.90.245.10-FF-000025', NULL, 'Probable ribonucleoside hydrolase', 327, NULL, NULL, 110044),
(110045, '2.30.42.10-FF-000525', NULL, NULL, 59, NULL, NULL, 110045),
(110046, '3.40.50.2000-FF-000214', NULL, 'Dolichol-linked oligosaccharide biosynthesis enzyme, putative', 167, NULL, NULL, 110046),
(110047, '3.30.760.10-FF-000016', NULL, 'Translation initiation factor eIF4E, putative', 212, NULL, NULL, 110047),
(110048, '1.10.3210.30-FF-000004', NULL, 'CRISPR-associated nuclease/helicase Cas3', 263, NULL, NULL, 110048),
(110049, '3.30.70.330-FF-002828', NULL, NULL, 88, NULL, NULL, 110049),
(110050, '3.30.63.10-FF-000009', NULL, 'Guanylate kinase 1', 59, NULL, NULL, 110050),
(110051, '3.30.420.40-FF-000129', NULL, 'Actin-related protein 8', 166, NULL, NULL, 110051),
(110052, '1.25.10.10-FF-002748', NULL, 'Uncharacterized protein', 718, NULL, NULL, 110052),
(110053, '2.130.10.10-FF-001413', NULL, 'sperm-associated antigen 16 protein', 137, NULL, NULL, 110053),
(110054, '3.15.20.10-FF-000013', NULL, 'Expression site-associated gene (ESAG) protein, putative', 246, NULL, NULL, 110054),
(110055, '3.40.50.12470-FF-000010', NULL, 'Oxoglutarate dehydrogenase (Succinyl-transferring), E1 component', 221, NULL, NULL, 110055),
(110056, '1.20.1560.10-FF-000651', NULL, 'Uncharacterized protein', 119, NULL, NULL, 110056),
(110057, '1.10.10.60-FF-000885', NULL, NULL, 58, NULL, NULL, 110057),
(110058, '1.20.58.60-FF-000511', NULL, 'Spectrin repeat-containing, nuclear envelope family member 3', 207, NULL, NULL, 110058),
(110059, '3.10.290.10-FF-000041', NULL, 'Tyrosine--tRNA ligase', 77, NULL, NULL, 110059),
(110060, '3.40.50.300-FF-000722', NULL, 'Dynamin-2B isoform A', 285, NULL, NULL, 110060),
(110061, '1.20.1080.10-FF-000069', NULL, 'Aquaporin-B', 267, NULL, NULL, 110061),
(110062, '1.20.1560.10-FF-000212', NULL, 'ABC transporter, putative', 314, NULL, NULL, 110062),
(110063, '1.20.58.220-FF-000007', NULL, 'Phosphate-specific transport system accessory protein PhoU homolog 2', 127, NULL, NULL, 110063),
(110064, '3.10.290.70-FF-000008', NULL, '40S ribosomal protein S8', 89, NULL, NULL, 110064),
(110065, '3.50.50.60-FF-001090', NULL, 'Peroxisomal N1-acetyl-spermine/spermidine oxidase, putative', 73, NULL, NULL, 110065),
(110066, '1.10.10.10-FF-001551', NULL, 'Phenylalanine--tRNA ligase alpha subunit', 77, NULL, NULL, 110066),
(110067, '3.40.50.150-FF-001413', NULL, NULL, 161, NULL, NULL, 110067),
(110068, '1.10.3720.10-FF-000020', NULL, 'Histidine ABC transporter permease HisQ', 222, NULL, NULL, 110068),
(110069, '3.30.40.10-FF-001165', NULL, 'Predicted protein', 109, NULL, NULL, 110069),
(110070, '2.60.120.180-FF-000001', NULL, 'Endo-1,4-beta-xylanase', 190, NULL, NULL, 110070),
(110071, '1.10.10.2740-FF-000011', NULL, 'SH2 domain containing protein', 29, NULL, NULL, 110071),
(110072, '3.40.50.300-FF-006118', NULL, 'Uncharacterized protein', 156, NULL, NULL, 110072);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(110073, '3.80.10.10-FF-001964', NULL, 'Uncharacterized protein, isoform D', 189, NULL, NULL, 110073),
(110074, '2.40.30.10-FF-000284', NULL, 'Translation elongation factor G', 120, NULL, NULL, 110074),
(110075, '3.30.160.60-FF-004111', NULL, NULL, 30, NULL, NULL, 110075),
(110076, '3.30.930.10-FF-000255', NULL, 'Lysine--tRNA ligase cytoplasmic', 241, NULL, NULL, 110076),
(110077, '2.60.40.10-FF-005090', NULL, NULL, 100, NULL, NULL, 110077),
(110078, '1.10.1200.10-FF-000172', NULL, 'Didemethylasterriquinone D synthetase tdiA', 90, NULL, NULL, 110078),
(110079, '3.40.710.10-FF-000135', NULL, 'Penicillin-binding protein 1A', 222, NULL, NULL, 110079),
(110080, '2.60.40.150-FF-000736', NULL, 'Chromosome 1, whole genome shotgun sequence', 108, NULL, NULL, 110080),
(110081, '3.40.532.10-FF-000024', NULL, 'Uncharacterized protein', 223, NULL, NULL, 110081),
(110082, '1.10.510.10-FF-004102', NULL, NULL, 130, NULL, NULL, 110082),
(110083, '2.60.120.920-FF-000206', NULL, 'Uncharacterized protein', 131, NULL, NULL, 110083),
(110084, '3.30.460.10-FF-000179', NULL, 'Uncharacterized protein', 55, NULL, NULL, 110084),
(110085, '3.30.450.40-FF-000221', NULL, 'Phytochrome-like protein cph2', 198, NULL, NULL, 110085),
(110086, '1.25.40.10-FF-002840', NULL, 'Pentatricopeptide repeat-containing protein', 130, NULL, NULL, 110086),
(110087, '3.10.280.10-FF-000012', NULL, 'Os05g0456000 protein', 205, NULL, NULL, 110087),
(110088, '3.30.160.20-FF-000255', NULL, 'Predicted protein', 56, NULL, NULL, 110088),
(110089, '3.30.70.330-FF-002244', NULL, NULL, 135, NULL, NULL, 110089),
(110090, '3.40.50.10140-FF-000013', NULL, 'Sterile alpha and TIR motif containing 1', 121, NULL, NULL, 110090),
(110091, '3.60.10.10-FF-000313', NULL, 'Endonuclease/Exonuclease/phosphatase family protein', 294, NULL, NULL, 110091),
(110092, '2.10.70.10-FF-000029', NULL, 'Inactive serine protease PAMR1 isoform X1', 70, NULL, NULL, 110092),
(110093, '3.40.50.300-FF-004937', NULL, 'Uncharacterized protein', 221, NULL, NULL, 110093),
(110094, '2.30.30.100-FF-000125', NULL, 'Uncharacterized protein', 53, NULL, NULL, 110094),
(110095, '3.30.1330.30-FF-000102', NULL, '60S ribosomal protein L7a', 188, NULL, NULL, 110095),
(110096, '3.30.870.10-FF-000053', NULL, 'Phospholipase', 244, NULL, NULL, 110096),
(110097, '3.30.710.10-FF-000513', NULL, 'Uncharacterized protein', 76, NULL, NULL, 110097),
(110098, '3.30.460.10-FF-000090', NULL, 'DNA-directed DNA/RNA polymerase mu', 143, NULL, NULL, 110098),
(110099, '3.10.110.10-FF-000293', NULL, 'Uncharacterized protein', 110, NULL, NULL, 110099),
(110100, '3.30.40.10-FF-000176', NULL, 'MDM4 isoform 3', 64, NULL, NULL, 110100),
(110101, '1.25.40.20-FF-000016', NULL, 'Ankyrin repeat and SOCS box containing 5', 226, NULL, NULL, 110101),
(110102, '3.30.160.60-FF-000216', NULL, 'Zinc finger protein 384 like', 31, NULL, NULL, 110102),
(110103, '2.30.42.10-FF-000025', NULL, 'Glutamate receptor interacting protein 1', 105, NULL, NULL, 110103),
(110104, '2.60.40.10-FF-002329', NULL, 'Alpha-1,4-glucan:maltose-1-phosphate maltosyltransferase', 102, NULL, NULL, 110104),
(110105, '3.30.160.60-FF-000688', NULL, 'zinc finger protein 197 isoform X1', 31, NULL, NULL, 110105),
(110106, '2.130.10.10-FF-000896', NULL, 'U3 small nucleolar RNA-associated protein 4', 196, NULL, NULL, 110106),
(110107, '1.10.510.10-FF-000095', NULL, 'protein STRUBBELIG-RECEPTOR FAMILY 8', 212, NULL, NULL, 110107),
(110108, '1.10.287.110-FF-000251', NULL, 'Chaperone protein DnaJ 1', 86, NULL, NULL, 110108),
(110109, '1.10.1380.10-FF-000009', NULL, 'CRE-NEP-2 protein', 365, NULL, NULL, 110109),
(110110, '2.60.120.820-FF-000002', NULL, 'E3 ubiquitin-protein ligase MYCBP2 isoform X1', 164, NULL, NULL, 110110),
(110111, '3.40.50.1820-FF-000025', NULL, 'putative methylesterase 11, chloroplastic', 256, NULL, NULL, 110111),
(110112, '2.60.40.60-FF-000793', NULL, 'Uncharacterized protein', 107, NULL, NULL, 110112),
(110113, '3.30.300.30-FF-000117', NULL, 'AMP-dependent synthetase and ligase', 105, NULL, NULL, 110113),
(110114, '3.40.50.720-FF-002265', NULL, 'Uncharacterized protein', 251, NULL, NULL, 110114);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(110115, '3.40.50.2300-FF-001142', NULL, NULL, 133, NULL, NULL, 110115),
(110116, '1.10.287.130-FF-000257', NULL, 'Histidine kinase', 85, NULL, NULL, 110116),
(110117, '3.40.50.300-FF-002375', NULL, 'Conserved protein', 212, NULL, NULL, 110117),
(110118, '2.60.200.20-FF-000110', NULL, 'Protein kinase, putative', 114, NULL, NULL, 110118),
(110119, '3.80.10.10-FF-003201', NULL, 'NLR family member X1', 226, NULL, NULL, 110119),
(110120, '3.40.630.10-FF-000134', NULL, 'Aminopeptidase', 257, NULL, NULL, 110120),
(110121, '3.40.50.800-FF-000046', NULL, 'Proline--tRNA ligase', 108, NULL, NULL, 110121),
(110122, '3.40.1180.10-FF-000020', NULL, 'Uncharacterized protein, isoform A', 140, NULL, NULL, 110122),
(110123, '3.20.20.70-FF-000226', NULL, 'Transaldolase', 321, NULL, NULL, 110123),
(110124, '3.30.50.10-FF-000002', NULL, 'Gata transcription factor gatad', 64, NULL, NULL, 110124),
(110125, '1.25.40.10-FF-004285', NULL, 'Uncharacterized protein', 204, NULL, NULL, 110125),
(110126, '1.50.40.10-FF-000067', NULL, 'Mitochondrial substrate carrier family protein', 287, NULL, NULL, 110126),
(110127, '3.90.105.10-FF-000015', NULL, 'Molybdopterin molybdenumtransferase', 56, NULL, NULL, 110127),
(110128, '2.10.25.10-FF-000397', NULL, 'Otogelin', 65, NULL, NULL, 110128),
(110129, '3.50.50.60-FF-001202', NULL, 'Chromosome 9, whole genome shotgun sequence', 384, NULL, NULL, 110129),
(110130, '3.40.630.10-FF-000398', NULL, 'Uncharacterized protein', 299, NULL, NULL, 110130),
(110131, '3.20.20.190-FF-000002', NULL, 'Phosphoinositide phospholipase C', 231, NULL, NULL, 110131),
(110132, '2.60.40.420-FF-000132', NULL, 'Multicopper oxidase', 153, NULL, NULL, 110132),
(110133, '2.30.29.30-FF-000247', NULL, 'pleckstrin homology domain-containing family F member 1', 102, NULL, NULL, 110133),
(110134, '1.10.1040.10-FF-000018', NULL, 'Altronate oxidoreductase', 210, NULL, NULL, 110134),
(110135, '1.10.510.10-FF-003585', NULL, NULL, 211, NULL, NULL, 110135),
(110136, '3.10.20.90-FF-000109', NULL, 'Arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 3', 110, NULL, NULL, 110136),
(110137, '1.25.50.20-FF-000045', NULL, 'Aminopeptidase', 321, NULL, NULL, 110137),
(110138, '1.20.140.10-FF-000114', NULL, 'acyl-CoA dehydrogenase family member 9, mitochondrial-like', 125, NULL, NULL, 110138),
(110139, '2.60.120.260-FF-000519', NULL, 'Beta-galactosidase', 126, NULL, NULL, 110139),
(110140, '3.50.50.60-FF-000685', NULL, '2-polyprenyl-6-methoxyphenol hydroxylase', 151, NULL, NULL, 110140),
(110141, '1.25.40.420-FF-000058', NULL, 'Predicted protein', 107, NULL, NULL, 110141),
(110142, '2.60.40.60-FF-000938', NULL, 'Uncharacterized protein', 91, NULL, NULL, 110142),
(110143, '1.10.10.10-FF-000831', NULL, 'Interferon regulatory factor like protein', 110, NULL, NULL, 110143),
(110144, '1.20.1250.20-FF-000198', NULL, 'High affinity nitrate transporter 2.5', 197, NULL, NULL, 110144),
(110145, '3.20.20.150-FF-000041', NULL, 'Sugar phosphate isomerase/epimerase', 247, NULL, NULL, 110145),
(110146, '1.10.400.10-FF-000058', NULL, 'Guanine nucleotide-binding protein subunit alpha-12', 121, NULL, NULL, 110146),
(110147, '3.30.470.20-FF-000065', NULL, 'Carbamoyl-phosphate synthase, large subunit', 197, NULL, NULL, 110147),
(110148, '2.130.10.10-FF-003561', NULL, 'Uncharacterized protein', 107, NULL, NULL, 110148),
(110149, '2.130.10.10-FF-002841', NULL, 'Ribosome biogenesis protein BOP1 homolog', 356, NULL, NULL, 110149),
(110150, '3.30.2410.10-FF-000035', NULL, 'E3 ubiquitin-protein ligase', 139, NULL, NULL, 110150),
(110151, '2.10.70.10-FF-000181', NULL, 'Proclotting enzyme precursor, putative', 60, NULL, NULL, 110151),
(110152, '3.30.200.20-FF-000551', NULL, 'STE20/SPS1-related proline-alanine-rich protein kinase', 38, NULL, NULL, 110152),
(110153, '2.30.30.40-FF-000585', NULL, 'CD2-associated protein like', 65, NULL, NULL, 110153),
(110154, '1.25.10.10-FF-002692', NULL, 'Predicted protein', 69, NULL, NULL, 110154),
(110155, '1.10.510.10-FF-002865', NULL, NULL, 195, NULL, NULL, 110155),
(110156, '2.70.130.10-FF-000172', NULL, NULL, 55, NULL, NULL, 110156);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(110157, '2.60.40.60-FF-000113', NULL, 'Cadherin-related family member 1', 103, NULL, NULL, 110157),
(110158, '3.40.50.1000-FF-000223', NULL, '3-deoxy-D-manno-octulosonate 8-phosphate phosphatase KdsC', 182, NULL, NULL, 110158),
(110159, '2.60.120.10-FF-000836', NULL, 'Uncharacterized protein', 133, NULL, NULL, 110159),
(110160, '3.60.15.10-FF-000009', NULL, 'Anaerobic nitric oxide reductase flavorubredoxin', 247, NULL, NULL, 110160),
(110161, '2.130.10.10-FF-000071', NULL, 'Bromodomain and WD repeat domain containing 1', 167, NULL, NULL, 110161),
(110162, '1.25.10.10-FF-003468', NULL, 'Predicted protein', 261, NULL, NULL, 110162),
(110163, '3.40.50.300-FF-001386', NULL, 'Dynein heavy chain, putative', 182, NULL, NULL, 110163),
(110164, '3.90.190.10-FF-000184', NULL, 'Leucine rich repeat and phosphatase domain containing protein', 154, NULL, NULL, 110164),
(110165, '1.25.40.10-FF-001412', NULL, 'RE19263p', 227, NULL, NULL, 110165),
(110166, '2.130.10.10-FF-001205', NULL, 'Ribosome biogenesis protein WDR12 homolog', 53, NULL, NULL, 110166),
(110167, '1.10.10.10-FF-001287', NULL, 'Rrf2 family transcriptional regulator', 142, NULL, NULL, 110167),
(110168, '1.10.510.10-FF-003821', NULL, NULL, 114, NULL, NULL, 110168),
(110169, '2.60.34.10-FF-000090', NULL, 'Protein CBG18133', 153, NULL, NULL, 110169),
(110170, '3.30.110.60-FF-000005', NULL, 'CRM-domain containing factor CFM2, chloroplastic', 98, NULL, NULL, 110170),
(110171, '3.30.200.20-FF-001332', NULL, 'Wall-associated receptor kinase-like 10', 58, NULL, NULL, 110171),
(110172, '1.10.238.10-FF-000607', NULL, 'Calmodulin, putative', 67, NULL, NULL, 110172),
(110173, '1.10.10.10-FF-000123', NULL, 'Histone acetyltransferase', 83, NULL, NULL, 110173),
(110174, '2.40.50.690-FF-000011', NULL, 'Exosome complex exonuclease RRP44, putative', 126, NULL, NULL, 110174),
(110175, '3.30.70.330-FF-002980', NULL, NULL, 143, NULL, NULL, 110175),
(110176, '3.30.1060.10-FF-000024', NULL, NULL, 190, NULL, NULL, 110176),
(110177, '3.30.70.330-FF-000299', NULL, 'Serine/arginine-rich splicing factor RS31', 91, NULL, NULL, 110177),
(110178, '3.40.50.300-FF-000458', NULL, 'ADP-ribosylation factor-like protein 4C', 181, NULL, NULL, 110178),
(110179, '1.10.150.60-FF-000014', NULL, 'Osa, isoform C', 125, NULL, NULL, 110179),
(110180, '2.60.120.10-FF-000252', NULL, 'Glutaminase 2', 138, NULL, NULL, 110180),
(110181, '3.80.10.10-FF-001756', NULL, 'Toll-like receptor 15', 118, NULL, NULL, 110181),
(110182, '3.40.50.300-FF-003595', NULL, 'WGS project CABT00000000 data, contig 2.18', 188, NULL, NULL, 110182),
(110183, '1.10.540.10-FF-000035', NULL, 'Acyl-CoA dehydrogenase FadE21', 59, NULL, NULL, 110183),
(110184, '1.10.510.10-FF-003113', NULL, NULL, 192, NULL, NULL, 110184),
(110185, '3.60.20.10-FF-000078', NULL, 'Amidophosphoribosyltransferase', 289, NULL, NULL, 110185),
(110186, '3.40.50.2300-FF-001350', NULL, NULL, 53, NULL, NULL, 110186),
(110187, '1.25.40.10-FF-004638', NULL, 'Uncharacterized protein', 187, NULL, NULL, 110187),
(110188, '3.30.160.60-FF-003594', NULL, 'Zinc finger protein 224', 28, NULL, NULL, 110188),
(110189, '3.80.10.10-FF-002684', NULL, 'Receptor-like protein kinase HSL1', 99, NULL, NULL, 110189),
(110190, '3.90.1110.10-FF-000015', NULL, 'DNA-directed RNA polymerase subunit beta', 164, NULL, NULL, 110190),
(110191, '1.10.287.70-FF-000710', NULL, 'Uncharacterized protein', 158, NULL, NULL, 110191),
(110192, '1.20.1440.340-FF-000010', NULL, 'N-acetylgalactosamine kinase', 138, NULL, NULL, 110192),
(110193, '3.20.20.70-FF-000434', NULL, NULL, 83, NULL, NULL, 110193),
(110194, '1.50.10.10-FF-000150', NULL, 'alpha-1,2-Mannosidase', 75, NULL, NULL, 110194),
(110195, '3.40.50.300-FF-005129', NULL, 'Site-determining protein', 243, NULL, NULL, 110195),
(110196, '3.30.9.10-FF-000120', NULL, 'Expressed protein', 210, NULL, NULL, 110196),
(110197, '1.10.238.10-FF-000023', NULL, 'dystrophin isoform X1', 90, NULL, NULL, 110197),
(110198, '3.30.460.20-FF-000036', NULL, 'Magnesium transport protein CorA', 124, NULL, NULL, 110198),
(110199, '1.25.40.1030-FF-000036', NULL, 'Protein transport protein Sec31, putative', 325, NULL, NULL, 110199);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(110200, '3.30.60.270-FF-000015', NULL, 'Sortilin-related VPS10 domain-containing receptor 3', 68, NULL, NULL, 110200),
(110201, '2.60.120.200-FF-000608', NULL, 'Uncharacterized protein', 152, NULL, NULL, 110201),
(110202, '3.40.390.10-FF-000098', NULL, 'Metalloendopeptidase', 233, NULL, NULL, 110202),
(110203, '1.10.287.3510-FF-000013', NULL, 'Uncharacterized protein', 111, NULL, NULL, 110203),
(110204, '3.40.50.620-FF-000228', NULL, 'Cysteinyl-tRNA synthetase', 152, NULL, NULL, 110204),
(110205, '2.30.30.490-FF-000079', NULL, 'Uncharacterized protein', 87, NULL, NULL, 110205),
(110206, '1.20.5.650-FF-000018', NULL, NULL, 63, NULL, NULL, 110206),
(110207, '1.10.287.70-FF-000093', NULL, 'Calcium channel subunit Cch1', 128, NULL, NULL, 110207),
(110208, '3.40.50.1010-FF-000108', NULL, 'Ribonuclease VapC', 126, NULL, NULL, 110208),
(110209, '1.25.40.10-FF-004021', NULL, 'Uncharacterized protein', 192, NULL, NULL, 110209),
(110210, '3.90.1180.10-FF-000025', NULL, NULL, 159, NULL, NULL, 110210),
(110211, '2.60.40.150-FF-000028', NULL, 'Synaptotagmin 7', 142, NULL, NULL, 110211),
(110212, '3.40.50.1820-FF-000289', NULL, 'Pheromone-processing carboxypeptidase KEX1', 470, NULL, NULL, 110212),
(110213, '1.50.10.10-FF-000239', NULL, 'N-acylglucosamine 2-epimerase', 264, NULL, NULL, 110213),
(110214, '2.60.40.10-FF-003257', NULL, NULL, 97, NULL, NULL, 110214),
(110215, '3.60.10.10-FF-000105', NULL, 'Uncharacterized protein', 270, NULL, NULL, 110215),
(110216, '3.10.440.10-FF-000014', NULL, 'Uncharacterized protein', 77, NULL, NULL, 110216),
(110217, '1.10.3120.10-FF-000019', NULL, NULL, 216, NULL, NULL, 110217),
(110218, '3.30.200.20-FF-000343', NULL, 'Acyl-CoA dehydrogenase family member 10', 106, NULL, NULL, 110218),
(110219, '1.20.140.150-FF-000057', NULL, 'GH12419p1', 218, NULL, NULL, 110219),
(110220, '3.30.160.60-FF-000160', NULL, 'zinc finger homeobox protein 3', 27, NULL, NULL, 110220),
(110221, '3.40.630.30-FF-000292', NULL, 'Putative GNAT family acetyltransferase', 244, NULL, NULL, 110221),
(110222, '3.40.50.300-FF-001447', NULL, 'Ras-related protein Rab-1B', 176, NULL, NULL, 110222),
(110223, '2.110.10.10-FF-000026', NULL, 'Uncharacterized protein', 134, NULL, NULL, 110223),
(110224, '2.60.120.330-FF-000035', NULL, 'Probable fatty alcohol oxidase', 310, NULL, NULL, 110224),
(110225, '3.30.160.60-FF-000008', NULL, 'RB-associated KRAB zinc finger protein-like', 28, NULL, NULL, 110225),
(110226, '3.30.40.10-FF-001873', NULL, 'Uncharacterized protein', 115, NULL, NULL, 110226),
(110227, '3.30.1520.10-FF-000043', NULL, 'SH3 and PX domain-containing protein 2B', 87, NULL, NULL, 110227),
(110228, '3.10.105.10-FF-000016', NULL, 'Oligopeptide ABC transporter, solute-binding protein', 222, NULL, NULL, 110228),
(110229, '3.40.50.1820-FF-001806', NULL, 'Predicted protein', 134, NULL, NULL, 110229),
(110230, '3.90.25.10-FF-000003', NULL, 'GDP-mannose 4,6-dehydratase', 110, NULL, NULL, 110230),
(110231, '3.40.30.10-FF-000006', NULL, 'Glutaredoxin', 104, NULL, NULL, 110231),
(110232, '3.50.50.60-FF-001410', NULL, 'Uncharacterized protein', 139, NULL, NULL, 110232),
(110233, '3.20.20.80-FF-000494', NULL, 'Uncharacterized protein', 156, NULL, NULL, 110233),
(110234, '3.10.20.90-FF-000261', NULL, 'Auxin response factor', 86, NULL, NULL, 110234),
(110235, '3.40.50.2000-FF-000922', NULL, 'Uncharacterized protein', 159, NULL, NULL, 110235),
(110236, '1.25.40.20-FF-000488', NULL, 'Espin-like a', 105, NULL, NULL, 110236),
(110237, '2.80.10.50-FF-000034', NULL, 'Dolichyl-phosphate-mannose-protein mannosyltransferase 1', 208, NULL, NULL, 110237),
(110238, '2.30.42.10-FF-000497', NULL, NULL, 65, NULL, NULL, 110238),
(110239, '2.40.10.10-FF-000485', NULL, NULL, 220, NULL, NULL, 110239),
(110240, '2.30.42.10-FF-000233', NULL, 'Related to GRH1-acetylated protein, involved in ER to Golgi transport', 132, NULL, NULL, 110240),
(110241, '1.20.58.200-FF-000001', NULL, 'Translin-associated factor X', 85, NULL, NULL, 110241),
(110242, '3.30.70.270-FF-000079', NULL, 'Diguanylate cyclase', 177, NULL, NULL, 110242),
(110243, '3.30.420.10-FF-000025', NULL, 'Gag-Pol polyprotein', 128, NULL, NULL, 110243);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(110244, '1.20.58.120-FF-000011', NULL, 'BAG family molecular chaperone regulator 1', 108, NULL, NULL, 110244),
(110245, '2.130.10.10-FF-004639', NULL, 'Chromosome 15, whole genome shotgun sequence', 405, NULL, NULL, 110245),
(110246, '3.40.50.300-FF-005281', NULL, 'Putative gtpase rho', 178, NULL, NULL, 110246),
(110247, '3.40.50.620-FF-000380', NULL, 'Valine--tRNA ligase', 203, NULL, NULL, 110247),
(110248, '3.40.50.720-FF-000112', NULL, 'Enoyl-[acyl-carrier-protein] reductase 1, mitochondrial', 177, NULL, NULL, 110248),
(110249, '3.10.20.600-FF-000009', NULL, NULL, 70, NULL, NULL, 110249),
(110250, '3.10.100.10-FF-000320', NULL, NULL, 148, NULL, NULL, 110250),
(110251, '3.90.470.40-FF-000001', NULL, 'DNA damage-inducible transcript 4 protein', 138, NULL, NULL, 110251),
(110252, '1.10.460.10-FF-000034', NULL, 'DNA topoisomerase (TopA)', 157, NULL, NULL, 110252),
(110253, '2.60.40.60-FF-001102', NULL, 'CaDHerin family', 108, NULL, NULL, 110253),
(110254, '1.10.510.10-FF-001876', NULL, 'PH-protein kinase domain containing protein', 172, NULL, NULL, 110254),
(110255, '3.40.50.300-FF-000930', NULL, 'ORC1-type DNA replication protein', 182, NULL, NULL, 110255),
(110256, '2.130.10.10-FF-004550', NULL, 'Uncharacterized protein', 219, NULL, NULL, 110256),
(110257, '3.10.20.350-FF-000002', NULL, 'Replicase polyprotein 1a', 93, NULL, NULL, 110257),
(110258, '3.40.50.720-FF-000820', NULL, 'Putative oxidoreductase', 218, NULL, NULL, 110258),
(110259, '3.40.720.10-FF-000372', NULL, 'Arylsulfatase', 220, NULL, NULL, 110259),
(110260, '1.20.120.980-FF-000032', NULL, 'Serine peptidase, family S28, putative (AFU_orthologue AFUA_4G03790)', 158, NULL, NULL, 110260),
(110261, '2.60.110.10-FF-000015', NULL, 'Os05g0538500 protein', 112, NULL, NULL, 110261),
(110262, '2.160.20.10-FF-000238', NULL, 'Os11g0194000 protein', 203, NULL, NULL, 110262),
(110263, '3.40.640.10-FF-000371', NULL, 'PLP-dependent aminotransferase family protein', 220, NULL, NULL, 110263),
(110264, '3.10.310.10-FF-000066', NULL, 'Uncharacterized protein', 165, NULL, NULL, 110264),
(110265, '2.120.10.80-FF-000097', NULL, 'Serine/threonine-protein phosphatase', 166, NULL, NULL, 110265),
(110266, '1.25.40.10-FF-002576', NULL, 'Pentatricopeptide repeat-containing protein At5g65570', 131, NULL, NULL, 110266),
(110267, '3.40.50.300-FF-007490', NULL, 'Uncharacterized protein', 228, NULL, NULL, 110267),
(110268, '1.10.10.10-FF-000623', NULL, 'Slf1p', 86, NULL, NULL, 110268),
(110269, '2.40.20.10-FF-000047', NULL, 'Hepatocyte growth factor', 85, NULL, NULL, 110269),
(110270, '3.40.50.300-FF-007810', NULL, 'Uncharacterized protein', 30, NULL, NULL, 110270),
(110271, '3.30.160.40-FF-000002', NULL, 'Porphobilinogen deaminase', 90, NULL, NULL, 110271),
(110272, '3.90.228.20-FF-000005', NULL, 'Phosphoenolpyruvate carboxykinase [GTP], mitochondrial', 149, NULL, NULL, 110272),
(110273, '1.25.40.10-FF-002076', NULL, 'Adenylate/guanylate cyclase', 149, NULL, NULL, 110273),
(110274, '1.20.1070.10-FF-000804', NULL, 'Tachykinin receptor 3', 247, NULL, NULL, 110274),
(110275, '3.40.30.10-FF-000978', NULL, 'Uncharacterized protein', 92, NULL, NULL, 110275),
(110276, '2.60.120.520-FF-000002', NULL, '4-deoxy-L-threo-5-hexosulose-uronate ketol-isomerase', 116, NULL, NULL, 110276),
(110277, '1.50.40.10-FF-000331', NULL, 'Mitochondrial carrier protein', 277, NULL, NULL, 110277),
(110278, '3.90.740.10-FF-000030', NULL, 'valine--tRNA ligase', 80, NULL, NULL, 110278),
(110279, '3.20.20.100-FF-000195', NULL, 'Uncharacterized protein', 86, NULL, NULL, 110279),
(110280, '3.30.160.60-FF-006320', NULL, NULL, 28, NULL, NULL, 110280),
(110281, '3.30.40.10-FF-000237', NULL, 'Histone-lysine N-methyltransferase 2C', 61, NULL, NULL, 110281),
(110282, '1.25.40.10-FF-004993', NULL, 'Predicted protein', 251, NULL, NULL, 110282),
(110283, '3.30.1640.10-FF-000018', NULL, 'DNA helicase', 104, NULL, NULL, 110283),
(110284, '3.40.50.720-FF-000584', NULL, 'D-3-phosphoglycerate dehydrogenase', 194, NULL, NULL, 110284),
(110285, '3.40.190.10-FF-000942', NULL, 'Glutamate receptor, putative', 23, NULL, NULL, 110285);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(110286, '2.60.40.10-FF-004162', NULL, NULL, 89, NULL, NULL, 110286),
(110287, '3.30.200.20-FF-001068', NULL, 'Protein kinase, putative', 125, NULL, NULL, 110287),
(110288, '3.40.50.300-FF-005865', NULL, 'Uncharacterized protein', 155, NULL, NULL, 110288),
(110289, '3.40.80.10-FF-000009', NULL, 'Endolysin', 146, NULL, NULL, 110289),
(110290, '2.130.10.10-FF-003622', NULL, 'WD repeat-containing protein 3-like Protein', 235, NULL, NULL, 110290),
(110291, '1.10.510.10-FF-001168', NULL, 'Protein CBG12029', 200, NULL, NULL, 110291),
(110292, '1.20.120.1080-FF-000018', NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase prp16', 104, NULL, NULL, 110292),
(110293, '3.30.450.90-FF-000011', NULL, 'Type II secretion system protein GspE', 122, NULL, NULL, 110293),
(110294, '3.30.70.330-FF-000619', NULL, 'tRNA methyltransferase 2 homolog A', 96, NULL, NULL, 110294),
(110295, '3.40.50.300-FF-004112', NULL, 'DNA helicase', 187, NULL, NULL, 110295),
(110296, '1.20.1250.20-FF-000759', NULL, 'Drug transporter, putative', 449, NULL, NULL, 110296),
(110297, '1.10.287.370-FF-000014', NULL, 'Prefoldin subunit 3', 141, NULL, NULL, 110297),
(110298, '3.50.50.60-FF-000746', NULL, 'Dihydropyrimidine dehydrogenase [NADP(+)]', 128, NULL, NULL, 110298),
(110299, '2.130.10.120-FF-000030', NULL, 'Uncharacterized protein', 122, NULL, NULL, 110299),
(110300, '2.60.40.10-FF-002981', NULL, 'Receptor-type tyrosine-protein phosphatase beta', 103, NULL, NULL, 110300),
(110301, '3.40.50.80-FF-000129', NULL, 'GD19100', 150, NULL, NULL, 110301),
(110302, '1.25.40.10-FF-001912', NULL, 'Putative pentatricopeptide repeat-containing protein isoform A', 104, NULL, NULL, 110302),
(110303, '2.60.40.10-FF-001812', NULL, 'Jitterbug, isoform M', 89, NULL, NULL, 110303),
(110304, '3.40.50.620-FF-000436', NULL, 'Tryptophan--tRNA ligase, cytoplasmic', 120, NULL, NULL, 110304),
(110305, '3.30.200.20-FF-000904', NULL, 'Protein CBG18395', 86, NULL, NULL, 110305),
(110306, '3.20.20.300-FF-000075', NULL, NULL, 120, NULL, NULL, 110306),
(110307, '3.30.70.330-FF-003025', NULL, NULL, 59, NULL, NULL, 110307),
(110308, '2.60.40.770-FF-000006', NULL, 'Lymphocyte antigen 96', 91, NULL, NULL, 110308),
(110309, '3.30.565.10-FF-000203', NULL, 'Sensor kinase CitA', 154, NULL, NULL, 110309),
(110310, '3.30.1360.40-FF-000051', NULL, 'Uncharacterized protein', 60, NULL, NULL, 110310),
(110311, '2.10.25.10-FF-000430', NULL, 'Laminin subunit alpha 5', 46, NULL, NULL, 110311),
(110312, '1.20.58.70-FF-000104', NULL, 'Diablo, IAP-binding mitochondrial protein a', 90, NULL, NULL, 110312),
(110313, '3.40.190.290-FF-000041', NULL, 'HTH-type transcriptional regulator GltC', 202, NULL, NULL, 110313),
(110314, '1.25.40.10-FF-004846', NULL, 'Uncharacterized protein', 136, NULL, NULL, 110314),
(110315, '1.20.1070.10-FF-000692', NULL, 'NeuroPeptide Receptor family', 352, NULL, NULL, 110315),
(110316, '1.10.10.60-FF-000060', NULL, 'MYB transcription factor', 52, NULL, NULL, 110316),
(110317, '2.60.120.260-FF-000458', NULL, 'Uncharacterized protein', 76, NULL, NULL, 110317),
(110318, '2.30.29.30-FF-000511', NULL, 'AGC/RSK/RSKP90 protein kinase', 107, NULL, NULL, 110318),
(110319, '3.40.30.10-FF-000506', NULL, 'Thioredoxin, putative', 140, NULL, NULL, 110319),
(110320, '2.40.50.140-FF-000425', NULL, 'Unplaced genomic scaffold supercont1.10, whole genome shotgun sequence', 83, NULL, NULL, 110320),
(110321, '3.40.630.30-FF-000404', NULL, 'Histone acetyltransferase type B catalytic subunit', 73, NULL, NULL, 110321),
(110322, '3.30.70.270-FF-000320', NULL, NULL, 152, NULL, NULL, 110322),
(110323, '3.30.70.870-FF-000051', NULL, 'Small GTP-binding protein', 78, NULL, NULL, 110323),
(110324, '3.30.60.20-FF-000096', NULL, 'Protein kinase D, isoform H', 75, NULL, NULL, 110324),
(110325, '2.30.31.10-FF-000005', NULL, 'Putative transcriptional co-activator', 74, NULL, NULL, 110325),
(110326, '3.50.7.10-FF-000009', NULL, 'T-complex protein 1 subunit alpha', 159, NULL, NULL, 110326),
(110327, '1.10.510.10-FF-003321', NULL, NULL, 69, NULL, NULL, 110327),
(110328, '3.40.50.300-FF-003095', NULL, 'Small GTPase EhRabX36, putative', 170, NULL, NULL, 110328);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(110329, '3.40.50.10490-FF-000034', NULL, 'Fructoselysine 6-phosphate deglycase', 154, NULL, NULL, 110329),
(110330, '3.80.10.10-FF-002892', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 276, NULL, NULL, 110330),
(110331, '2.60.40.3610-FF-000002', NULL, 'Outer membrane protein SusF', 102, NULL, NULL, 110331),
(110332, '3.90.210.10-FF-000001', NULL, 'Cholera enterotoxin subunit A', 184, NULL, NULL, 110332),
(110333, '2.10.25.10-FF-001655', NULL, 'Uncharacterized protein', 47, NULL, NULL, 110333),
(110334, '2.30.30.40-FF-000321', NULL, 'JNK Interacting Protein (Scaffold protein)', 61, NULL, NULL, 110334),
(110335, '2.40.160.210-FF-000006', NULL, 'Acyl-CoA thioesterase II', 262, NULL, NULL, 110335),
(110336, '1.20.1070.10-FF-001973', NULL, 'Uncharacterized protein', 301, NULL, NULL, 110336),
(110337, '3.40.720.10-FF-000225', NULL, 'Uncharacterized protein', 61, NULL, NULL, 110337),
(110338, '3.40.50.10680-FF-000001', NULL, '2-phospho-L-lactate transferase', 193, NULL, NULL, 110338),
(110339, '3.90.79.20-FF-000012', NULL, 'NADH pyrophosphatase', 134, NULL, NULL, 110339),
(110340, '1.10.150.830-FF-000001', NULL, 'Transcription factor cep-1', 117, NULL, NULL, 110340),
(110341, '2.30.30.380-FF-000046', NULL, 'COPII vesicle coat protein', 68, NULL, NULL, 110341),
(110342, '2.60.40.150-FF-000528', NULL, 'Phosphatidylinositol 3-kinase 3', 154, NULL, NULL, 110342),
(110343, '3.30.1360.220-FF-000004', NULL, 'AGAP004049-PA-like protein', 64, NULL, NULL, 110343),
(110344, '1.10.150.240-FF-000066', NULL, 'Beta-phosphoglucomutase family hydrolase', 71, NULL, NULL, 110344),
(110345, '1.10.630.10-FF-000103', NULL, 'Steroid C26-monooxygenase', 413, NULL, NULL, 110345),
(110346, '1.25.40.470-FF-000079', NULL, 'Uncharacterized protein', 92, NULL, NULL, 110346),
(110347, '3.40.50.2300-FF-000686', NULL, 'Guanylate cyclase', 66, NULL, NULL, 110347),
(110348, '1.20.58.60-FF-000478', NULL, 'Spectrin repeat-containing, nuclear envelope 1b', 281, NULL, NULL, 110348),
(110349, '1.10.565.10-FF-000182', NULL, 'Nuclear receptor subfamily 1 group I member 3', 131, NULL, NULL, 110349),
(110350, '3.40.50.2300-FF-000422', NULL, 'Histidine kinase', 130, NULL, NULL, 110350),
(110351, '1.25.40.10-FF-000895', NULL, 'PPR-repeat protein-like', 155, NULL, NULL, 110351),
(110352, '3.40.50.300-FF-006618', NULL, 'Predicted protein', 93, NULL, NULL, 110352),
(110353, '2.60.120.330-FF-000182', NULL, 'Uncharacterized protein', 196, NULL, NULL, 110353),
(110354, '2.120.10.30-FF-000543', NULL, 'Uncharacterized protein', 71, NULL, NULL, 110354),
(110355, '3.90.70.10-FF-000102', NULL, 'Ubiquitinyl hydrolase 1', 341, NULL, NULL, 110355),
(110356, '2.20.25.10-FF-000025', NULL, 'UPF0434 protein SCO3027', 39, NULL, NULL, 110356),
(110357, '3.80.20.20-FF-000097', NULL, 'Predicted protein', 67, NULL, NULL, 110357),
(110358, '3.40.50.150-FF-001060', NULL, 'Leucine carboxyl methyltransferase 1', 385, NULL, NULL, 110358),
(110359, '1.20.5.340-FF-000105', NULL, 'Uncharacterized protein', 110, NULL, NULL, 110359),
(110360, '3.10.20.90-FF-000845', NULL, 'Predicted protein', 84, NULL, NULL, 110360),
(110361, '3.80.10.10-FF-002420', NULL, 'Leucine-rich repeat-containing 15', 85, NULL, NULL, 110361),
(110362, '3.30.70.330-FF-000563', NULL, 'Nucleolin 2 isoform A', 118, NULL, NULL, 110362),
(110363, '6.20.50.160-FF-000004', NULL, 'C5 isoform 3', 63, NULL, NULL, 110363),
(110364, '3.30.420.580-FF-000010', NULL, 'Actin-related protein 8', 46, NULL, NULL, 110364),
(110365, '3.40.50.80-FF-000073', NULL, 'ferric reduction oxidase 8, mitochondrial', 136, NULL, NULL, 110365),
(110366, '3.30.70.141-FF-000018', NULL, 'Nucleoside diphosphate kinase', 133, NULL, NULL, 110366),
(110367, '3.40.50.2000-FF-000714', NULL, 'Glycosyltransferase', 162, NULL, NULL, 110367),
(110368, '1.10.418.20-FF-000001', NULL, 'sentrin-specific protease 6 isoform X1', 58, NULL, NULL, 110368),
(110369, '2.60.40.10-FF-005443', NULL, NULL, 117, NULL, NULL, 110369),
(110370, '3.30.40.10-FF-001401', NULL, 'ZNF1', 99, NULL, NULL, 110370),
(110371, '3.30.200.20-FF-002496', NULL, 'Non-specific serine/threonine protein kinase', 18, NULL, NULL, 110371); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(110372, '1.20.930.80-FF-000010', NULL, 'Putative eukaryotic-type dna primase large subunit', 238, NULL, NULL, 110372),
(110373, '2.130.10.10-FF-001936', NULL, 'Protein HIR2', 159, NULL, NULL, 110373),
(110374, '3.30.200.20-FF-001271', NULL, 'Protein CBG21908', 89, NULL, NULL, 110374),
(110375, '3.30.450.20-FF-000474', NULL, 'Sensory box histidine kinase/response regulator', 114, NULL, NULL, 110375),
(110376, '2.40.10.10-FF-000013', NULL, 'Coagulation factor X', 100, NULL, NULL, 110376),
(110377, '3.40.850.10-FF-000229', NULL, 'Kinesin-like protein', 197, NULL, NULL, 110377),
(110378, '2.60.40.10-FF-003757', NULL, NULL, 93, NULL, NULL, 110378),
(110379, '3.40.50.1010-FF-000260', NULL, NULL, 214, NULL, NULL, 110379),
(110380, '3.40.50.300-FF-001239', NULL, 'ADP-ribosylation factor family protein', 95, NULL, NULL, 110380),
(110381, '1.20.58.80-FF-000017', NULL, 'sorting nexin-15 isoform X1', 75, NULL, NULL, 110381),
(110382, '3.90.1140.10-FF-000051', NULL, 'Uncharacterized protein', 237, NULL, NULL, 110382),
(110383, '2.40.160.110-FF-000010', NULL, 'Uncharacterized protein, isoform B', 151, NULL, NULL, 110383),
(110384, '1.10.150.850-FF-000007', NULL, 'Transcription elongation factor spt6, putative', 96, NULL, NULL, 110384),
(110385, '1.10.10.1410-FF-000005', NULL, '60S acidic ribosomal protein, putative', 61, NULL, NULL, 110385),
(110386, '2.30.40.10-FF-000043', NULL, 'Adenine deaminase', 90, NULL, NULL, 110386),
(110387, '2.40.128.320-FF-000002', NULL, 'Cytochrome c heme lyase', 147, NULL, NULL, 110387),
(110388, '3.90.870.10-FF-000034', NULL, 'Uncharacterized protein', 196, NULL, NULL, 110388),
(110389, '3.40.250.10-FF-000116', NULL, 'Sb(V)-As(V) reductase', 152, NULL, NULL, 110389),
(110390, '2.130.10.10-FF-005567', NULL, 'Uncharacterized protein', 214, NULL, NULL, 110390),
(110391, '2.170.150.10-FF-000014', NULL, 'Translationally controlled tumor protein-like protein', 151, NULL, NULL, 110391),
(110392, '1.20.5.110-FF-000121', NULL, 't-SNARE domain-containing protein 1', 89, NULL, NULL, 110392),
(110393, '3.30.465.10-FF-000139', NULL, 'UDP-N-acetylenolpyruvoylglucosamine reductase', 122, NULL, NULL, 110393),
(110394, '3.20.20.100-FF-000048', NULL, 'Probable aldo-keto reductase 4', 334, NULL, NULL, 110394),
(110395, '1.20.120.1910-FF-000009', NULL, 'Cysteine--tRNA ligase 1 cytoplasmic', 81, NULL, NULL, 110395),
(110396, '2.60.40.10-FF-001548', NULL, 'Interferon receptor 1 isoform 4', 100, NULL, NULL, 110396),
(110397, '2.60.120.200-FF-000755', NULL, 'Galectin', 107, NULL, NULL, 110397),
(110398, '3.100.10.10-FF-000040', NULL, NULL, 88, NULL, NULL, 110398),
(110399, '3.30.470.10-FF-000005', NULL, 'Branched-chain-amino-acid aminotransferase', 157, NULL, NULL, 110399),
(110400, '3.10.250.10-FF-000123', NULL, NULL, 60, NULL, NULL, 110400),
(110401, '1.20.1250.10-FF-000138', NULL, NULL, 63, NULL, NULL, 110401),
(110402, '3.30.300.30-FF-000056', NULL, 'Putative peptide synthase', 102, NULL, NULL, 110402),
(110403, '1.10.20.10-FF-000096', NULL, 'Histone H3', 134, NULL, NULL, 110403),
(110404, '1.10.340.30-FF-000065', NULL, 'Uncharacterized protein', 80, NULL, NULL, 110404),
(110405, '2.160.20.10-FF-000182', NULL, 'Uncharacterized protein', 204, NULL, NULL, 110405),
(110406, '3.30.920.10-FF-000018', NULL, 'Uncharacterized protein', 104, NULL, NULL, 110406),
(110407, '3.30.519.10-FF-000052', NULL, NULL, 18, NULL, NULL, 110407),
(110408, '2.130.10.10-FF-002133', NULL, 'WD40 repeat-like protein', 77, NULL, NULL, 110408),
(110409, '1.25.40.930-FF-000003', NULL, NULL, 112, NULL, NULL, 110409),
(110410, '1.10.1420.10-FF-000036', NULL, 'DNA mismatch repair protein Msh1', 56, NULL, NULL, 110410),
(110411, '3.30.1490.100-FF-000036', NULL, 'Uncharacterized protein', 114, NULL, NULL, 110411),
(110412, '3.20.20.80-FF-000847', NULL, 'Chitinase, putative', 183, NULL, NULL, 110412),
(110413, '1.10.760.10-FF-000107', NULL, 'Gll0910 protein', 136, NULL, NULL, 110413),
(110414, '2.40.30.10-FF-000076', NULL, 'Elongation factor family protein', 105, NULL, NULL, 110414),
(110415, '3.30.497.10-FF-000157', NULL, 'Uncharacterized protein', 60, NULL, NULL, 110415);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(110416, '1.10.510.10-FF-004041', NULL, NULL, 81, NULL, NULL, 110416),
(110417, '3.30.300.10-FF-000050', NULL, 'S-adenosylmethionine synthase', 129, NULL, NULL, 110417),
(110418, '2.60.120.970-FF-000019', NULL, 'Transforming growth factor beta-3', 183, NULL, NULL, 110418),
(110419, '3.30.70.1730-FF-000068', NULL, 'Ribosome assembly factor mrt4', 44, NULL, NULL, 110419),
(110420, '3.40.50.410-FF-000199', NULL, 'Protein transport protein SEC23', 238, NULL, NULL, 110420),
(110421, '3.30.420.40-FF-000629', NULL, 'Uncharacterized protein', 109, NULL, NULL, 110421),
(110422, '2.120.10.80-FF-000333', NULL, 'Uncharacterized protein', 128, NULL, NULL, 110422),
(110423, '2.130.10.10-FF-003061', NULL, 'WD40-repeat-containing domain protein', 137, NULL, NULL, 110423),
(110424, '3.30.160.60-FF-003706', NULL, 'Zinc finger protein 936', 25, NULL, NULL, 110424),
(110425, '2.60.40.1840-FF-000004', NULL, 'Aminopeptidase N', 100, NULL, NULL, 110425),
(110426, '2.40.50.1020-FF-000016', NULL, 'DNA-binding response regulator', 107, NULL, NULL, 110426),
(110427, '1.10.10.440-FF-000074', NULL, 'Uncharacterized protein', 65, NULL, NULL, 110427),
(110428, '3.40.50.1820-FF-000525', NULL, 'Alpha/beta hydrolase', 233, NULL, NULL, 110428),
(110429, '1.20.1560.10-FF-000151', NULL, 'Uncharacterized protein', 311, NULL, NULL, 110429),
(110430, '3.40.850.10-FF-000381', NULL, 'Kinesin, putative', 317, NULL, NULL, 110430),
(110431, '3.40.190.10-FF-000381', NULL, 'Amino acid ABC transporter substrate-binding protein', 98, NULL, NULL, 110431),
(110432, '1.25.40.20-FF-001769', NULL, 'Uncharacterized protein', 189, NULL, NULL, 110432),
(110433, '2.40.50.40-FF-000035', NULL, 'Heterochromatin protein 1', 62, NULL, NULL, 110433),
(110434, '2.130.10.10-FF-004286', NULL, 'Predicted protein', 127, NULL, NULL, 110434),
(110435, '2.30.30.650-FF-000003', NULL, NULL, 34, NULL, NULL, 110435),
(110436, '1.10.8.720-FF-000031', NULL, 'Dynein heavy chain', 73, NULL, NULL, 110436),
(110437, '1.10.3260.10-FF-000001', NULL, 'DNA ligase', 273, NULL, NULL, 110437),
(110438, '2.60.40.60-FF-000585', NULL, 'Cadherin 26, tandem duplicate 1', 121, NULL, NULL, 110438),
(110439, '3.90.550.10-FF-000459', NULL, 'Undecaprenyl-phosphate glycosyltransferase, DPM1-like family', 232, NULL, NULL, 110439),
(110440, '4.10.830.30-FF-000001', NULL, '50S ribosomal protein L31', 70, NULL, NULL, 110440),
(110441, '1.20.120.820-FF-000001', NULL, 'Phosphoprotein', 112, NULL, NULL, 110441),
(110442, '1.10.10.10-FF-002068', NULL, 'ATP-dependent DNA helicase RecQ family', 139, NULL, NULL, 110442),
(110443, '2.60.220.50-FF-000069', NULL, 'Predicted protein', 199, NULL, NULL, 110443),
(110444, '1.25.50.20-FF-000106', NULL, 'Uncharacterized protein', 99, NULL, NULL, 110444),
(110445, '1.10.630.10-FF-000626', NULL, 'Uncharacterized protein', 230, NULL, NULL, 110445),
(110446, '3.30.70.1470-FF-000001', NULL, 'Putative caspase-2', 104, NULL, NULL, 110446),
(110447, '1.10.510.10-FF-000595', NULL, 'Protein kinase, putative (AFU_orthologue AFUA_5G11840)', 254, NULL, NULL, 110447),
(110448, '4.10.240.10-FF-000023', NULL, 'Fungal specific transcription factor', 79, NULL, NULL, 110448),
(110449, '3.40.50.300-FF-007546', NULL, 'Predicted protein', 197, NULL, NULL, 110449),
(110450, '1.10.20.140-FF-000019', NULL, NULL, 54, NULL, NULL, 110450),
(110451, '2.10.110.10-FF-000184', NULL, 'DA1-related protein 7', 63, NULL, NULL, 110451),
(110452, '3.40.50.150-FF-000132', NULL, 'Protein arginine N-methyltransferase PRMT10', 146, NULL, NULL, 110452),
(110453, '3.90.640.10-FF-000230', NULL, 'Uncharacterized protein', 53, NULL, NULL, 110453),
(110454, '3.30.200.20-FF-002349', NULL, NULL, 52, NULL, NULL, 110454),
(110455, '3.90.180.10-FF-000150', NULL, 'Predicted protein', 167, NULL, NULL, 110455),
(110456, '1.10.8.60-FF-000165', NULL, 'Sigma-54-dependent transcriptional response regulator PilR', 73, NULL, NULL, 110456),
(110457, '1.25.40.10-FF-005302', NULL, 'TPR Domain containing protein', 130, NULL, NULL, 110457),
(110458, '1.25.40.180-FF-000205', NULL, NULL, 56, NULL, NULL, 110458),
(110459, '2.130.10.30-FF-000082', NULL, 'Related to FMP25-mitochondrial inner membrane protein involved in assembly of cytochrome bc1 complex', 248, NULL, NULL, 110459);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(110460, '2.60.200.40-FF-000060', NULL, 'Diacylglycerol kinase', 164, NULL, NULL, 110460),
(110461, '3.30.505.10-FF-000110', NULL, 'Cell death abnormality protein 2', 109, NULL, NULL, 110461),
(110462, '1.25.40.10-FF-000631', NULL, 'Proteinaceous RNase P 2', 297, NULL, NULL, 110462),
(110463, '1.25.40.10-FF-003357', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform A', 73, NULL, NULL, 110463),
(110464, '3.30.70.1390-FF-000011', NULL, 'Uncharacterized protein', 78, NULL, NULL, 110464),
(110465, '3.30.230.10-FF-000134', NULL, 'MeValonate Kinase', 226, NULL, NULL, 110465),
(110466, '1.10.3380.20-FF-000013', NULL, NULL, 186, NULL, NULL, 110466),
(110467, '3.40.50.300-FF-002167', NULL, 'ATP-binding membrane protein', 211, NULL, NULL, 110467),
(110468, '3.40.50.720-FF-001601', NULL, 'YALI0E05731p', 166, NULL, NULL, 110468),
(110469, '1.10.420.10-FF-000060', NULL, 'Peroxidase', 23, NULL, NULL, 110469),
(110470, '3.30.420.40-FF-000781', NULL, 'Uncharacterized protein', 37, NULL, NULL, 110470),
(110471, '3.30.1330.90-FF-000013', NULL, 'D-3-phosphoglycerate dehydrogenase', 134, NULL, NULL, 110471),
(110472, '1.20.1280.50-FF-000130', NULL, 'F-box and WD domain protein, putative', 111, NULL, NULL, 110472),
(110473, '3.40.50.11060-FF-000014', NULL, 'putative GTP-binding protein 6', 126, NULL, NULL, 110473),
(110474, '3.30.365.10-FF-000019', NULL, 'indole-3-acetaldehyde oxidase', 125, NULL, NULL, 110474),
(110475, '1.10.510.10-FF-002657', NULL, NULL, 170, NULL, NULL, 110475),
(110476, '4.10.1240.30-FF-000014', NULL, NULL, 87, NULL, NULL, 110476),
(110477, '3.40.50.300-FF-002875', NULL, '3''-5'' exonuclease DinG', 199, NULL, NULL, 110477),
(110478, '3.30.70.2390-FF-000002', NULL, 'LytR family transcriptional regulator', 84, NULL, NULL, 110478),
(110479, '1.20.990.10-FF-000038', NULL, 'Flavodoxin family protein', 137, NULL, NULL, 110479),
(110480, '1.50.10.20-FF-000040', NULL, 'Terpenoid cyclases/protein prenyltransferase alpha-alpha toroid', 364, NULL, NULL, 110480),
(110481, '1.20.58.2220-FF-000055', NULL, 'Formin 2', 136, NULL, NULL, 110481),
(110482, '3.50.50.60-FF-000893', NULL, 'Flavin-binding monooxygenase-like protein (AFU_orthologue AFUA_6G01900)', 184, NULL, NULL, 110482),
(110483, '1.25.40.10-FF-001148', NULL, 'Pre-mRNA-processing factor 6', 198, NULL, NULL, 110483),
(110484, '3.30.40.10-FF-000384', NULL, '1-phosphatidylinositol-3-phosphate 5-kinase FAB1B', 86, NULL, NULL, 110484),
(110485, '3.50.50.60-FF-000185', NULL, 'Kynurenine 3-monooxygenase', 369, NULL, NULL, 110485),
(110486, '2.60.40.60-FF-000321', NULL, 'Cadherin-related tumor suppressor', 114, NULL, NULL, 110486),
(110487, '3.60.40.10-FF-000141', NULL, 'Response regulator', 228, NULL, NULL, 110487),
(110488, '3.40.50.1480-FF-000024', NULL, NULL, 119, NULL, NULL, 110488),
(110489, '1.20.1560.10-FF-000712', NULL, 'Os06g0561800 protein', 288, NULL, NULL, 110489),
(110490, '1.10.472.10-FF-000230', NULL, 'Cyclin I', 14, NULL, NULL, 110490),
(110491, '3.30.710.10-FF-000160', NULL, 'YLR108C-like protein', 111, NULL, NULL, 110491),
(110492, '3.30.70.600-FF-000015', NULL, 'Apicoplast ribosomal protein S10', 112, NULL, NULL, 110492),
(110493, '3.40.50.300-FF-001650', NULL, 'ABC drug exporter AtrF', 330, NULL, NULL, 110493),
(110494, '3.40.50.720-FF-002118', NULL, 'Uncharacterized protein', 113, NULL, NULL, 110494),
(110495, '2.30.29.30-FF-001175', NULL, 'ArfGAP with dual PH domains 1-like', 63, NULL, NULL, 110495),
(110496, '2.10.250.10-FF-000014', NULL, 'Calreticulin-2', 52, NULL, NULL, 110496),
(110497, '2.60.40.10-FF-003234', NULL, 'Secreted protein BARF1', 98, NULL, NULL, 110497),
(110498, '3.10.400.20-FF-000014', NULL, 'Translation initiation factor SUI1, putative', 212, NULL, NULL, 110498),
(110499, '1.20.58.60-FF-000803', NULL, 'Elastin microfibril interfacer 1', 205, NULL, NULL, 110499),
(110500, '1.10.287.70-FF-000154', NULL, 'Potassium channel subfamily K member 7', 274, NULL, NULL, 110500),
(110501, '3.40.50.970-FF-000198', NULL, 'Uncharacterized protein', 114, NULL, NULL, 110501),
(110502, '2.40.180.10-FF-000007', NULL, 'lipoxygenase homology domain-containing protein 1', 132, NULL, NULL, 110502);
INSERT INTO "PUBLIC"."MODEL" VALUES
(110503, '1.10.630.10-FF-000126', NULL, 'Predicted protein', 194, NULL, NULL, 110503),
(110504, '1.25.10.10-FF-002512', NULL, 'ARM repeat superfamily protein', 197, NULL, NULL, 110504),
(110505, '3.60.110.10-FF-000091', NULL, NULL, 119, NULL, NULL, 110505),
(110506, '3.40.50.10930-FF-000003', NULL, 'RecBCD enzyme subunit RecC', 145, NULL, NULL, 110506),
(110507, '1.20.58.60-FF-000747', NULL, 'Uncharacterized protein', 70, NULL, NULL, 110507),
(110508, '3.40.50.300-FF-003072', NULL, 'Small GTPase EhRabX34, putative', 194, NULL, NULL, 110508),
(110509, '1.20.58.1880-FF-000003', NULL, 'chromatin complexes subunit BAP18 isoform X1', 83, NULL, NULL, 110509),
(110510, '1.25.10.10-FF-002456', NULL, 'Uncharacterized protein', 224, NULL, NULL, 110510),
(110511, '1.20.1740.10-FF-000069', NULL, 'Cationic amino acid transporter 4', 135, NULL, NULL, 110511),
(110512, '1.10.10.60-FF-000593', NULL, 'L-rhamnose operon transcriptional activator RhaR', 42, NULL, NULL, 110512),
(110513, '1.10.510.10-FF-001112', NULL, 'Serine/threonine-protein kinase, putative', 195, NULL, NULL, 110513),
(110514, '1.25.40.330-FF-000003', NULL, 'Adenylyl cyclase-associated protein', 173, NULL, NULL, 110514),
(110515, '3.40.50.720-FF-001040', NULL, '2-dehydropantoate 2-reductase', 160, NULL, NULL, 110515),
(110516, '3.40.800.10-FF-000018', NULL, 'Arginase', 308, NULL, NULL, 110516),
(110517, '1.25.10.10-FF-002984', NULL, 'Uncharacterized protein', 383, NULL, NULL, 110517),
(110518, '2.60.40.1110-FF-000016', NULL, 'Ptenb protein', 102, NULL, NULL, 110518),
(110519, '6.10.250.3450-FF-000005', NULL, '60S ribosomal protein L35-1', 26, NULL, NULL, 110519),
(110520, '1.10.287.70-FF-000210', NULL, 'Open rectifier potassium channel protein 1', 303, NULL, NULL, 110520),
(110521, '1.10.10.60-FF-000121', NULL, 'Myb transcription factor', 57, NULL, NULL, 110521),
(110522, '2.10.70.10-FF-000265', NULL, 'CUB and sushi domain-containing protein 1', 56, NULL, NULL, 110522),
(110523, '1.10.10.830-FF-000005', NULL, 'Mitochondrial isoleucyl-tRNA synthetase', 59, NULL, NULL, 110523),
(110524, '1.10.630.10-FF-000598', NULL, 'Uncharacterized protein', 277, NULL, NULL, 110524),
(110525, '2.20.70.10-FF-000068', NULL, 'E3 ubiquitin-protein ligase', 39, NULL, NULL, 110525),
(110526, '3.30.9.10-FF-000143', NULL, 'Oxidoreductase', 147, NULL, NULL, 110526),
(110527, '3.30.40.10-FF-000945', NULL, 'Protein translocase subunit SecA', 82, NULL, NULL, 110527),
(110528, '3.10.129.10-FF-000195', NULL, '4-hydroxybenzoyl-CoA thioesterase', 151, NULL, NULL, 110528),
(110529, '2.20.25.160-FF-000005', NULL, 'Uncharacterized protein', 25, NULL, NULL, 110529),
(110530, '4.10.520.10-FF-000005', NULL, 'Integration host factor', 93, NULL, NULL, 110530),
(110531, '2.60.120.260-FF-000435', NULL, 'Beta-glucuronidase', 165, NULL, NULL, 110531),
(110532, '1.10.510.10-FF-001584', NULL, 'Cell-cycle checkpoint protein kinase, putative', 191, NULL, NULL, 110532),
(110533, '3.30.70.2690-FF-000002', NULL, 'Uncharacterized protein', 78, NULL, NULL, 110533),
(110534, '3.40.30.10-FF-001175', NULL, 'Glutathione S-transferase, putative', 84, NULL, NULL, 110534),
(110535, '1.10.510.10-FF-004338', NULL, NULL, 132, NULL, NULL, 110535),
(110536, '3.40.50.450-FF-000008', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit beta', 276, NULL, NULL, 110536),
(110537, '1.10.10.2220-FF-000001', NULL, 'ATP-dependent RecD-like DNA helicase', 105, NULL, NULL, 110537),
(110538, '1.25.40.20-FF-000252', NULL, 'acyl-CoA-binding domain-containing protein 6 isoform X2', 78, NULL, NULL, 110538),
(110539, '2.60.120.10-FF-000336', NULL, 'Uncharacterized NTE family protein M110.7', 128, NULL, NULL, 110539),
(110540, '1.10.555.10-FF-000001', NULL, 'Rho GTPase activating protein 44', 201, NULL, NULL, 110540),
(110541, '3.30.160.60-FF-001705', NULL, 'Zinc finger and BTB domain-containing protein 21', 85, NULL, NULL, 110541),
(110542, '1.25.40.10-FF-000395', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 106, NULL, NULL, 110542),
(110543, '1.50.40.10-FF-000270', NULL, 'Mitochondrial ornithine transporter 1', 133, NULL, NULL, 110543); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(110544, '1.25.40.10-FF-003149', NULL, 'Pentatricopeptide repeat-containing protein At1g14470', 122, NULL, NULL, 110544),
(110545, '3.40.50.300-FF-007254', NULL, 'Rab GTPase', 158, NULL, NULL, 110545),
(110546, '2.130.10.10-FF-000508', NULL, 'WD repeat-containing protein 54 isoform X2', 153, NULL, NULL, 110546),
(110547, '3.40.50.300-FF-007310', NULL, 'Predicted protein', 148, NULL, NULL, 110547),
(110548, '3.90.640.10-FF-000174', NULL, 'Actin-related protein 10', 118, NULL, NULL, 110548),
(110549, '3.30.1430.10-FF-000008', NULL, '50S ribosomal protein L3', 123, NULL, NULL, 110549),
(110550, '3.30.200.20-FF-000579', NULL, 'cyclin-dependent kinase 20', 83, NULL, NULL, 110550),
(110551, '2.130.10.10-FF-003853', NULL, 'Cilia- and flagella-associated protein 43', 288, NULL, NULL, 110551),
(110552, '1.10.510.10-FF-000123', NULL, 'Tyrosine-protein kinase receptor Tie-1', 207, NULL, NULL, 110552),
(110553, '1.25.40.10-FF-001295', NULL, 'GD25498', 160, NULL, NULL, 110553),
(110554, '2.60.40.60-FF-000877', NULL, 'E-cadherin-like protein', 116, NULL, NULL, 110554),
(110555, '2.70.170.10-FF-000146', NULL, 'Uncharacterized protein', 129, NULL, NULL, 110555),
(110556, '1.25.40.680-FF-000001', NULL, 'ESAT-6 secretion machinery protein EssB', 164, NULL, NULL, 110556),
(110557, '3.30.40.10-FF-000468', NULL, 'RING/U-box superfamily protein', 75, NULL, NULL, 110557),
(110558, '1.10.10.10-FF-001348', NULL, 'Transcriptional regulatory protein', 87, NULL, NULL, 110558),
(110559, '3.40.50.12780-FF-000075', NULL, '2-succinylbenzoate--CoA ligase', 304, NULL, NULL, 110559),
(110560, '3.90.180.10-FF-000094', NULL, 'Enoyl-[acyl-carrier-protein] reductase, mitochondrial', 133, NULL, NULL, 110560),
(110561, '2.60.200.30-FF-000023', NULL, 'NAD kinase', 126, NULL, NULL, 110561),
(110562, '1.20.120.520-FF-000001', NULL, 'Iron-sulfur cluster repair protein YtfE', 146, NULL, NULL, 110562),
(110563, '2.130.10.10-FF-003358', NULL, 'Plexin B3', 63, NULL, NULL, 110563),
(110564, '3.30.230.10-FF-000078', NULL, 'DNA mismatch repair protein MutL', 113, NULL, NULL, 110564),
(110565, '1.25.10.10-FF-001523', NULL, 'RING-type E3 ubiquitin transferase', 164, NULL, NULL, 110565),
(110566, '3.80.30.20-FF-000007', NULL, 'CDK5 regulatory subunit-associated protein 1 isoform X5', 138, NULL, NULL, 110566),
(110567, '3.40.640.10-FF-000455', NULL, 'Uncharacterized protein', 234, NULL, NULL, 110567),
(110568, '3.30.2130.30-FF-000031', NULL, 'Ribosomal RNA large subunit methyltransferase K/L', 185, NULL, NULL, 110568),
(110569, '1.25.40.120-FF-000058', NULL, 'Farnesyltransferase, CAAX box, alpha', 228, NULL, NULL, 110569),
(110570, '3.60.130.10-FF-000035', NULL, 'Pyoverdine biosynthesis protein PvcB', 293, NULL, NULL, 110570),
(110571, '2.40.128.130-FF-000007', NULL, 'Autotransporting virulence factor family member', 335, NULL, NULL, 110571),
(110572, '3.40.1380.10-FF-000029', NULL, 'ATP synthase gamma chain', 213, NULL, NULL, 110572),
(110573, '3.40.50.2300-FF-001434', NULL, NULL, 128, NULL, NULL, 110573),
(110574, '3.40.50.10540-FF-000009', NULL, 'Acyl-CoA transferase/carnitine dehydratase-like protein', 289, NULL, NULL, 110574),
(110575, '2.60.120.200-FF-000047', NULL, 'Slit guidance ligand 3', 172, NULL, NULL, 110575),
(110576, '1.20.5.170-FF-000088', NULL, 'cyclic nucleotide-gated cation channel alpha-4', 71, NULL, NULL, 110576),
(110577, '3.40.50.300-FF-005365', NULL, 'Dynamin-related protein, putative', 300, NULL, NULL, 110577),
(110578, '3.80.10.10-FF-004426', NULL, 'CLL2 clavata1-like receptor S/T protein kinase protein', 244, NULL, NULL, 110578),
(110579, '1.20.1250.20-FF-000170', NULL, 'Solute carrier family 22 member 7', 406, NULL, NULL, 110579),
(110580, '1.10.730.10-FF-000167', NULL, 'Leucine--tRNA ligase', 177, NULL, NULL, 110580),
(110581, '1.25.40.10-FF-005190', NULL, 'Transcriptional activator domain', 229, NULL, NULL, 110581),
(110582, '1.25.40.20-FF-001505', NULL, 'Uncharacterized protein', 211, NULL, NULL, 110582),
(110583, '2.30.30.140-FF-000322', NULL, 'Uncharacterized protein', 49, NULL, NULL, 110583),
(110584, '1.10.510.10-FF-001640', NULL, 'Uncharacterized protein', 274, NULL, NULL, 110584); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(110585, '3.40.1190.20-FF-000175', NULL, 'Adenosine kinase', 282, NULL, NULL, 110585),
(110586, '3.40.190.10-FF-000673', NULL, 'Uncharacterized solute-binding protein OE_3270R', 78, NULL, NULL, 110586),
(110587, '3.90.740.10-FF-000058', NULL, 'Putative isoleucine-tRNA ligase', 189, NULL, NULL, 110587),
(110588, '3.40.50.300-FF-003448', NULL, 'YALI0F31845p', 271, NULL, NULL, 110588),
(110589, '3.50.50.60-FF-001174', NULL, 'Probable NADPH:adrenodoxin oxidoreductase, mitochondrial', 237, NULL, NULL, 110589),
(110590, '1.10.287.1890-FF-000004', NULL, 'tRNA (Adenine(22)-N(1))-methyltransferase', 67, NULL, NULL, 110590),
(110591, '3.80.10.10-FF-003965', NULL, 'Si:dkey-250k10.4', 185, NULL, NULL, 110591),
(110592, '3.10.20.310-FF-000046', NULL, 'Outer membrane protein', 76, NULL, NULL, 110592),
(110593, '1.10.10.10-FF-000415', NULL, 'meiotic recombination protein SPO11 isoform X1', 136, NULL, NULL, 110593),
(110594, '3.90.79.10-FF-000094', NULL, 'Adenine DNA glycosylase', 117, NULL, NULL, 110594),
(110595, '2.80.10.50-FF-000118', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 137, NULL, NULL, 110595),
(110596, '3.40.50.1000-FF-000459', NULL, 'Uncharacterized protein', 189, NULL, NULL, 110596),
(110597, '1.10.10.10-FF-000887', NULL, 'Helicase family member', 89, NULL, NULL, 110597),
(110598, '3.30.450.70-FF-000033', NULL, NULL, 132, NULL, NULL, 110598),
(110599, '2.40.50.730-FF-000012', NULL, 'DNA polymerase', 76, NULL, NULL, 110599),
(110600, '1.25.10.10-FF-000039', NULL, 'Splicing factor 3B subunit 1', 530, NULL, NULL, 110600),
(110601, '1.20.1070.10-FF-000720', NULL, 'KISS1 receptor b', 99, NULL, NULL, 110601),
(110602, '1.10.3190.10-FF-000001', NULL, 'UPF0304 protein YfbU', 112, NULL, NULL, 110602),
(110603, '2.60.40.10-FF-001784', NULL, 'Basement membrane proteoglycan', 90, NULL, NULL, 110603),
(110604, '1.20.120.720-FF-000033', NULL, 'Myosin B', 146, NULL, NULL, 110604),
(110605, '1.10.10.60-FF-000969', NULL, NULL, 51, NULL, NULL, 110605),
(110606, '1.10.287.130-FF-000234', NULL, 'Sensor histidine kinase, Cache_1 and HAMP domain-containing', 73, NULL, NULL, 110606),
(110607, '1.10.287.80-FF-000011', NULL, 'ATP synthase subunit gamma, mitochondrial', 66, NULL, NULL, 110607),
(110608, '1.20.1070.10-FF-001232', NULL, 'corticotropin-releasing factor receptor 2-like isoform X1', 311, NULL, NULL, 110608),
(110609, '2.60.40.10-FF-001256', NULL, 'Sallimus, isoform Q', 92, NULL, NULL, 110609),
(110610, '3.20.19.10-FF-000014', NULL, 'Aconitate hydratase, mitochondrial', 95, NULL, NULL, 110610),
(110611, '1.20.58.390-FF-000070', NULL, 'Glycine receptor beta', 40, NULL, NULL, 110611),
(110612, '3.40.120.10-FF-000051', NULL, 'Phosphoacetylglucosamine mutase', 192, NULL, NULL, 110612),
(110613, '1.10.730.20-FF-000024', NULL, 'Uncharacterized protein', 290, NULL, NULL, 110613),
(110614, '2.60.40.10-FF-000856', NULL, 'Obscurin like 1', 91, NULL, NULL, 110614),
(110615, '1.25.40.10-FF-002340', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 265, NULL, NULL, 110615),
(110616, '3.30.160.60-FF-005600', NULL, NULL, 42, NULL, NULL, 110616),
(110617, '3.30.1390.10-FF-000009', NULL, 'E3 ubiquitin-protein ligase UBR1', 91, NULL, NULL, 110617),
(110618, '3.40.50.1820-FF-000997', NULL, 'Putative thioesterase', 235, NULL, NULL, 110618),
(110619, '1.25.40.20-FF-000988', NULL, 'Transient receptor potential cation channel protein painless', 188, NULL, NULL, 110619),
(110620, '3.40.1110.10-FF-000010', NULL, 'Phospholipid-transporting ATPase', 174, NULL, NULL, 110620),
(110621, '3.40.50.10190-FF-000326', NULL, 'Uncharacterized protein', 67, NULL, NULL, 110621),
(110622, '3.60.21.50-FF-000002', NULL, 'DNA polymerase delta small subunit', 272, NULL, NULL, 110622),
(110623, '1.25.40.10-FF-005038', NULL, 'Pentatricopeptide repeat-containing protein At4g20090', 129, NULL, NULL, 110623),
(110624, '2.60.40.10-FF-005527', NULL, NULL, 61, NULL, NULL, 110624),
(110625, '1.10.1410.10-FF-000007', NULL, 'poly(A) RNA polymerase GLD2 isoform X1', 162, NULL, NULL, 110625),
(110626, '1.20.120.160-FF-000022', NULL, 'Histidine kinase', 115, NULL, NULL, 110626);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(110627, '3.40.50.10810-FF-000113', NULL, 'Putative snf2 family helicase atpase protein', 217, NULL, NULL, 110627),
(110628, '2.60.120.200-FF-000171', NULL, 'Adhesion G-protein coupled receptor D2', 207, NULL, NULL, 110628),
(110629, '2.170.260.40-FF-000008', NULL, '5''-3'' exoribonuclease 1', 167, NULL, NULL, 110629),
(110630, '1.20.1250.20-FF-000967', NULL, 'EmrB/QacA subfamily drug resistance transporter', 181, NULL, NULL, 110630),
(110631, '3.30.40.10-FF-000029', NULL, 'lysine-specific demethylase 4C isoform X1', 118, NULL, NULL, 110631),
(110632, '3.30.1010.10-FF-000049', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit gamma, putative', 148, NULL, NULL, 110632),
(110633, '3.40.50.12610-FF-000007', NULL, 'Uncharacterized protein', 91, NULL, NULL, 110633),
(110634, '3.40.190.80-FF-000002', NULL, 'Inositol-1-monophosphatase', 131, NULL, NULL, 110634),
(110635, '2.40.128.110-FF-000001', NULL, 'UPF0312 protein HMPREF3014_17255', 168, NULL, NULL, 110635),
(110636, '3.40.50.300-FF-000161', NULL, 'Small COPII coat GTPase', 193, NULL, NULL, 110636),
(110637, '2.20.25.10-FF-000109', NULL, 'Peptide-N(4)-(N-acetyl-beta-glucosaminyl)asparagine amidase', 58, NULL, NULL, 110637),
(110638, '3.60.10.10-FF-000369', NULL, 'Uncharacterized protein', 112, NULL, NULL, 110638),
(110639, '4.10.960.10-FF-000004', NULL, '60S ribosomal protein L3', 92, NULL, NULL, 110639),
(110640, '3.40.1380.20-FF-000061', NULL, 'Pyruvate kinase', 131, NULL, NULL, 110640),
(110641, '1.20.1270.60-FF-000278', NULL, 'Uncharacterized protein', 276, NULL, NULL, 110641),
(110642, '3.30.70.330-FF-002805', NULL, NULL, 95, NULL, NULL, 110642),
(110643, '3.90.70.10-FF-000574', NULL, 'Ubiquitinyl hydrolase 1', 312, NULL, NULL, 110643),
(110644, '3.30.1370.10-FF-000065', NULL, 'KH domain-containing protein', 194, NULL, NULL, 110644),
(110645, '2.130.10.30-FF-000138', NULL, NULL, 216, NULL, NULL, 110645),
(110646, '3.40.50.720-FF-002349', NULL, 'Predicted protein', 95, NULL, NULL, 110646),
(110647, '3.30.160.60-FF-000396', NULL, 'Zinc finger protein', 28, NULL, NULL, 110647),
(110648, '3.30.70.360-FF-000050', NULL, 'Metal-dependent amidase/aminoacylase/carboxypeptidase', 115, NULL, NULL, 110648),
(110649, '1.20.120.1770-FF-000012', NULL, 'Transmembrane ascorbate ferrireductase 1', 104, NULL, NULL, 110649),
(110650, '2.10.10.80-FF-000001', NULL, 'Catalytic beta propeller domain of endosialidase', 71, NULL, NULL, 110650),
(110651, '3.90.550.10-FF-000375', NULL, 'UDP-glucose glycoprotein glucosyltransferase 1', 157, NULL, NULL, 110651),
(110652, '1.20.140.10-FF-000030', NULL, 'Acyl-CoA dehydrogenase FadE23', 152, NULL, NULL, 110652),
(110653, '2.130.10.10-FF-002925', NULL, 'Protein CBG08107', 207, NULL, NULL, 110653),
(110654, '3.80.10.10-FF-000683', NULL, 'LRR receptor-like serine/threonine-protein kinase GSO1', 97, NULL, NULL, 110654),
(110655, '1.10.8.60-FF-000401', NULL, 'ATPase, putative', 55, NULL, NULL, 110655),
(110656, '2.130.10.10-FF-000132', NULL, 'DDB1- and CUL4-associated factor 13', 247, NULL, NULL, 110656),
(110657, '3.90.1150.10-FF-000433', NULL, 'Sphingosine Phosphate Lyase', 27, NULL, NULL, 110657),
(110658, '2.40.50.140-FF-000841', NULL, NULL, 71, NULL, NULL, 110658),
(110659, '3.40.640.10-FF-000399', NULL, 'Uncharacterized protein', 36, NULL, NULL, 110659),
(110660, '2.130.10.10-FF-003414', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 184, NULL, NULL, 110660),
(110661, '1.20.1250.20-FF-001951', NULL, 'Peptide transporter PTR2', 437, NULL, NULL, 110661),
(110662, '3.30.40.10-FF-000092', NULL, 'Lateral signaling target protein 2 homolog', 78, NULL, NULL, 110662),
(110663, '1.20.120.220-FF-000006', NULL, 'ATP synthase subunit a', 152, NULL, NULL, 110663),
(110664, '3.30.70.260-FF-000019', NULL, 'Arogenate dehydratase', 102, NULL, NULL, 110664),
(110665, '1.10.3270.10-FF-000002', NULL, '3-hydroxy-3-methylglutaryl coenzyme A reductase', 75, NULL, NULL, 110665),
(110666, '2.30.30.40-FF-000405', NULL, 'small G protein signaling modulator 3 isoform X10', 53, NULL, NULL, 110666),
(110667, '3.30.160.60-FF-002341', NULL, 'Zinc finger protein 80', 27, NULL, NULL, 110667);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(110668, '1.20.1050.10-FF-000213', NULL, 'Glutathione S-transferase GSTU6', 112, NULL, NULL, 110668),
(110669, '2.60.260.20-FF-000175', NULL, 'Chaperone protein', 64, NULL, NULL, 110669),
(110670, '2.60.20.10-FF-000001', NULL, 'Crystallin gamma S', 84, NULL, NULL, 110670),
(110671, '1.25.50.20-FF-000022', NULL, 'Aminopeptidase', 326, NULL, NULL, 110671),
(110672, '2.40.50.140-FF-000897', NULL, NULL, 85, NULL, NULL, 110672),
(110673, '1.10.10.2590-FF-000005', NULL, 'Early boundary activity protein 1', 114, NULL, NULL, 110673),
(110674, '3.30.160.60-FF-005067', NULL, NULL, 67, NULL, NULL, 110674),
(110675, '3.50.50.60-FF-000662', NULL, 'Uncharacterized protein', 313, NULL, NULL, 110675),
(110676, '3.15.10.30-FF-000018', NULL, NULL, 58, NULL, NULL, 110676),
(110677, '2.60.40.4380-FF-000002', NULL, 'Translational regulator CsrA', 62, NULL, NULL, 110677),
(110678, '3.30.160.60-FF-004667', NULL, NULL, 68, NULL, NULL, 110678),
(110679, '1.10.20.10-FF-000360', NULL, NULL, 89, NULL, NULL, 110679),
(110680, '2.60.40.790-FF-000164', NULL, NULL, 119, NULL, NULL, 110680),
(110681, '3.40.50.300-FF-000958', NULL, 'Spastin, putative', 188, NULL, NULL, 110681),
(110682, '1.10.510.10-FF-002888', NULL, NULL, 153, NULL, NULL, 110682),
(110683, '1.25.40.10-FF-001351', NULL, 'Stress-induced-phosphoprotein 1', 120, NULL, NULL, 110683),
(110684, '1.10.472.80-FF-000054', NULL, 'Chromosome 16, whole genome shotgun sequence', 125, NULL, NULL, 110684),
(110685, '3.40.50.410-FF-000227', NULL, 'Collagen alpha-1(XIV) chain-like', 102, NULL, NULL, 110685),
(110686, '3.40.50.300-FF-000222', NULL, 'RAB32, member RAS oncogene family', 180, NULL, NULL, 110686),
(110687, '3.40.50.2300-FF-000922', NULL, NULL, 79, NULL, NULL, 110687),
(110688, '1.20.1540.10-FF-000065', NULL, 'Putative rhomboid protease YdcA protein', 229, NULL, NULL, 110688),
(110689, '3.30.1910.20-FF-000003', NULL, 'Asparagine--tRNA ligase, cytoplasmic', 73, NULL, NULL, 110689),
(110690, '1.10.510.10-FF-000651', NULL, 'Serine/threonine-protein kinase RAD53', 210, NULL, NULL, 110690),
(110691, '3.30.70.560-FF-000019', NULL, 'Uncharacterized protein', 111, NULL, NULL, 110691),
(110692, '1.20.1740.10-FF-000193', NULL, 'Predicted protein', 220, NULL, NULL, 110692),
(110693, '1.10.101.10-FF-000004', NULL, 'N-acetylmuramoyl-L-alanine amidase', 60, NULL, NULL, 110693),
(110694, '2.60.120.10-FF-000752', NULL, 'Uncharacterized protein', 93, NULL, NULL, 110694),
(110695, '1.20.1740.10-FF-000013', NULL, 'Solute carrier family 12 member', 453, NULL, NULL, 110695),
(110696, '1.20.1250.20-FF-000962', NULL, 'Membrane transporter', 255, NULL, NULL, 110696),
(110697, '3.40.50.1440-FF-000063', NULL, 'Tubulin beta chain', 89, NULL, NULL, 110697),
(110698, '3.40.50.880-FF-000227', NULL, 'Carbamoyl-phosphate synthase small chain', 221, NULL, NULL, 110698),
(110699, '1.25.40.420-FF-000030', NULL, 'Uncharacterized protein', 65, NULL, NULL, 110699),
(110700, '1.10.1330.10-FF-000001', NULL, 'Endoglucanase D', 70, NULL, NULL, 110700),
(110701, '3.40.50.720-FF-000876', NULL, 'Unplaced genomic scaffold supercont1.67, whole genome shotgun sequence', 261, NULL, NULL, 110701),
(110702, '3.40.30.10-FF-000742', NULL, 'YALI0F29381p', 120, NULL, NULL, 110702),
(110703, '2.30.29.30-FF-000803', NULL, 'GD21193', 173, NULL, NULL, 110703),
(110704, '1.25.10.10-FF-003440', NULL, 'Uncharacterized protein', 49, NULL, NULL, 110704),
(110705, '2.60.120.200-FF-000547', NULL, 'Calnexin', 134, NULL, NULL, 110705),
(110706, '1.10.510.10-FF-003905', NULL, NULL, 83, NULL, NULL, 110706),
(110707, '3.20.20.140-FF-000009', NULL, 'Adenosine deaminase', 330, NULL, NULL, 110707),
(110708, '1.10.10.2030-FF-000006', NULL, 'Protein CBG23783', 62, NULL, NULL, 110708),
(110709, '2.30.29.30-FF-000747', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', 88, NULL, NULL, 110709),
(110710, '3.30.70.390-FF-000002', NULL, 'ORF73', 140, NULL, NULL, 110710),
(110711, '3.90.1410.10-FF-000004', NULL, 'N-lysine methyltransferase SETD6', 257, NULL, NULL, 110711),
(110712, '3.90.228.10-FF-000031', NULL, 'Poly [ADP-ribose] polymerase', 214, NULL, NULL, 110712);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(110713, '1.20.1280.50-FF-000219', NULL, 'F-box/kelch-repeat protein At4g19930', 60, NULL, NULL, 110713),
(110714, '3.90.190.10-FF-000392', NULL, 'Uncharacterized protein', 168, NULL, NULL, 110714),
(110715, '2.60.40.60-FF-000085', NULL, 'Calsyntenin 1', 89, NULL, NULL, 110715),
(110716, '2.10.25.10-FF-001178', NULL, 'Eyes shut homolog', 75, NULL, NULL, 110716),
(110717, '3.40.30.10-FF-000214', NULL, 'glutaredoxin-1 isoform X1', 106, NULL, NULL, 110717),
(110718, '4.10.240.30-FF-000006', NULL, 'Uncharacterized protein', 34, NULL, NULL, 110718),
(110719, '3.40.50.300-FF-001886', NULL, 'RuvB-like helicase', 143, NULL, NULL, 110719),
(110720, '3.80.10.10-FF-001987', NULL, 'Uncharacterized protein', 180, NULL, NULL, 110720),
(110721, '1.25.10.10-FF-001528', NULL, 'YALI0F08165p', 267, NULL, NULL, 110721),
(110722, '3.40.30.10-FF-001198', NULL, 'Uncharacterized protein', 79, NULL, NULL, 110722),
(110723, '1.10.132.20-FF-000005', NULL, 'Ribosome-recycling factor, mitochondrial', 99, NULL, NULL, 110723),
(110724, '3.75.10.10-FF-000049', NULL, NULL, 193, NULL, NULL, 110724),
(110725, '3.40.50.620-FF-000200', NULL, 'Nicotinamide-nucleotide adenylyltransferase', 221, NULL, NULL, 110725),
(110726, '3.90.1030.10-FF-000014', NULL, '50S ribosomal protein L17', 130, NULL, NULL, 110726),
(110727, '3.40.50.1860-FF-000014', NULL, 'Glutamate racemase', 117, NULL, NULL, 110727),
(110728, '1.20.1050.10-FF-000157', NULL, 'S-crystallin SL11', 112, NULL, NULL, 110728),
(110729, '3.20.20.70-FF-000165', NULL, 'Multifunctional fusion protein', 188, NULL, NULL, 110729),
(110730, '3.20.20.70-FF-000642', NULL, NULL, 251, NULL, NULL, 110730),
(110731, '3.30.70.330-FF-001316', NULL, 'Uncharacterized protein', 107, NULL, NULL, 110731),
(110732, '1.20.5.1930-FF-000007', NULL, 'Two-component sensor histidine kinase DesR', 88, NULL, NULL, 110732),
(110733, '1.10.10.10-FF-001904', NULL, 'Uncharacterized protein', 81, NULL, NULL, 110733),
(110734, '3.10.100.10-FF-000056', NULL, 'Pulmonary surfactant-associated protein A', 148, NULL, NULL, 110734),
(110735, '3.40.50.300-FF-005629', NULL, 'Uncharacterized protein', 92, NULL, NULL, 110735),
(110736, '1.20.1280.290-FF-000053', NULL, 'Sugar transporter SWEET', 92, NULL, NULL, 110736),
(110737, '3.40.50.1460-FF-000069', NULL, 'Uncharacterized protein', 234, NULL, NULL, 110737),
(110738, '3.10.50.10-FF-000048', NULL, 'Uncharacterized protein', 67, NULL, NULL, 110738),
(110739, '3.60.15.10-FF-000217', NULL, 'DNA repair protein, putative', 198, NULL, NULL, 110739),
(110740, '3.20.110.10-FF-000037', NULL, 'Alpha-mannosidase', 223, NULL, NULL, 110740),
(110741, '1.10.8.60-FF-000373', NULL, 'GM14570', 55, NULL, NULL, 110741),
(110742, '3.40.50.2300-FF-000978', NULL, NULL, 205, NULL, NULL, 110742),
(110743, '2.60.40.4100-FF-000020', NULL, 'Matrix metallopeptidase 15a', 156, NULL, NULL, 110743),
(110744, '1.20.120.330-FF-000039', NULL, 'Uncharacterized protein', 89, NULL, NULL, 110744),
(110745, '2.60.40.10-FF-002801', NULL, 'HERV-H LTR-associating 2a, tandem duplicate 1', 89, NULL, NULL, 110745),
(110746, '3.10.20.90-FF-000789', NULL, 'Autophagy protein 5', 67, NULL, NULL, 110746),
(110747, '2.60.120.290-FF-000034', NULL, 'complement C1s subcomponent', 116, NULL, NULL, 110747),
(110748, '1.10.8.10-FF-000139', NULL, 'UV excision repair RAD23-like protein', 42, NULL, NULL, 110748),
(110749, '1.10.565.10-FF-000210', NULL, 'Estrogen receptor beta', 126, NULL, NULL, 110749),
(110750, '3.90.550.10-FF-000667', NULL, 'Uncharacterized protein', 111, NULL, NULL, 110750),
(110751, '1.20.1560.10-FF-000920', NULL, 'Uncharacterized protein', 95, NULL, NULL, 110751),
(110752, '3.30.70.330-FF-001991', NULL, NULL, 95, NULL, NULL, 110752),
(110753, '2.70.70.10-FF-000015', NULL, 'LysM domain-containing protein', 142, NULL, NULL, 110753),
(110754, '3.30.160.60-FF-004611', NULL, NULL, 49, NULL, NULL, 110754),
(110755, '3.40.50.10810-FF-000057', NULL, 'Snf2/Rad54 family helicase', 235, NULL, NULL, 110755),
(110756, '1.10.10.440-FF-000102', NULL, 'Uncharacterized protein', 78, NULL, NULL, 110756),
(110757, '1.20.1560.10-FF-000948', NULL, 'Uncharacterized protein', 206, NULL, NULL, 110757);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(110758, '2.60.120.650-FF-000013', NULL, 'Ribosomal oxygenase 1', 242, NULL, NULL, 110758),
(110759, '1.10.150.20-FF-000289', NULL, 'DNA-directed DNA/RNA polymerase mu', 49, NULL, NULL, 110759),
(110760, '2.30.42.10-FF-000441', NULL, NULL, 103, NULL, NULL, 110760),
(110761, '3.90.730.10-FF-000001', NULL, 'Ribonuclease T2', 224, NULL, NULL, 110761),
(110762, '3.80.10.10-FF-002509', NULL, 'Uncharacterized protein', 132, NULL, NULL, 110762),
(110763, '1.25.40.120-FF-000002', NULL, 'Protein farnesyltransferase/geranylgeranyltransferase type-1 subunit alpha', 322, NULL, NULL, 110763),
(110764, '1.25.40.10-FF-000423', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 177, NULL, NULL, 110764),
(110765, '3.30.565.10-FF-000147', NULL, 'Unplaced genomic scaffold supercont2.18, whole genome shotgun sequence', 166, NULL, NULL, 110765),
(110766, '2.40.50.170-FF-000001', NULL, 'Cathepsin L1', 41, NULL, NULL, 110766),
(110767, '2.130.10.10-FF-005275', NULL, 'Uncharacterized protein', 244, NULL, NULL, 110767),
(110768, '2.40.30.10-FF-000020', NULL, 'Translation elongation factor EF-1', 90, NULL, NULL, 110768),
(110769, '1.20.1560.10-FF-000387', NULL, 'ABC transporter related', 318, NULL, NULL, 110769),
(110770, '1.10.510.10-FF-002040', NULL, 'Protein CBG10613', 232, NULL, NULL, 110770),
(110771, '4.10.1000.10-FF-000137', NULL, 'Uncharacterized protein', 54, NULL, NULL, 110771),
(110772, '1.25.40.10-FF-005066', NULL, 'Putative pentatricopeptide repeat-containing protein mitochondrial', 100, NULL, NULL, 110772),
(110773, '3.80.10.10-FF-004365', NULL, 'Cell surface protein', 175, NULL, NULL, 110773),
(110774, '2.60.40.1170-FF-000051', NULL, 'AP-3 complex subunit mu', 130, NULL, NULL, 110774),
(110775, '3.30.930.10-FF-000171', NULL, 'Phenylalanyl-tRNA synthetase beta chain, putative', 197, NULL, NULL, 110775),
(110776, '3.40.50.970-FF-000193', NULL, 'Uncharacterized protein', 207, NULL, NULL, 110776),
(110777, '3.30.160.60-FF-005595', NULL, NULL, 59, NULL, NULL, 110777),
(110778, '2.70.160.11-FF-000006', NULL, 'Protein arginine methyltransferase 9', 150, NULL, NULL, 110778),
(110779, '1.10.238.10-FF-000170', NULL, 'reticulocalbin-2 isoform X1', 67, NULL, NULL, 110779),
(110780, '1.25.10.10-FF-003092', NULL, 'Wings apart-like protein homolog 1', 224, NULL, NULL, 110780),
(110781, '2.60.40.10-FF-005151', NULL, NULL, 120, NULL, NULL, 110781),
(110782, '1.10.12.70-FF-000016', NULL, NULL, 69, NULL, NULL, 110782),
(110783, '2.60.40.1180-FF-000200', NULL, 'Uncharacterized protein', 85, NULL, NULL, 110783),
(110784, '3.40.50.720-FF-001101', NULL, 'Predicted protein', 101, NULL, NULL, 110784),
(110785, '3.30.40.10-FF-002093', NULL, 'Uncharacterized protein', 86, NULL, NULL, 110785),
(110786, '3.40.50.720-FF-001837', NULL, 'Uncharacterized protein', 98, NULL, NULL, 110786),
(110787, '2.60.15.10-FF-000023', NULL, 'ATP synthase epsilon chain', 130, NULL, NULL, 110787),
(110788, '3.10.100.10-FF-000112', NULL, 'lectin subunit alpha', 145, NULL, NULL, 110788),
(110789, '2.30.29.30-FF-000894', NULL, 'Uncharacterized protein', 84, NULL, NULL, 110789),
(110790, '3.40.50.300-FF-005781', NULL, 'Putative serine/threonine-protein kinase pats1', 94, NULL, NULL, 110790),
(110791, '1.25.40.10-FF-001356', NULL, 'Pentatricopeptide repeat-containing protein', 117, NULL, NULL, 110791),
(110792, '2.60.40.10-FF-001312', NULL, 'Interleukin 10 receptor subunit beta', 102, NULL, NULL, 110792),
(110793, '3.40.50.1010-FF-000052', NULL, 'Exosome complex exonuclease RRP44', 198, NULL, NULL, 110793),
(110794, '1.10.490.10-FF-000007', NULL, 'Diguanylate cyclase DosC', 149, NULL, NULL, 110794),
(110795, '3.40.50.300-FF-001094', NULL, 'ATP-dependent DNA helicase', 106, NULL, NULL, 110795),
(110796, '3.40.50.300-FF-001150', NULL, 'Small GTP-binding protein sar1', 192, NULL, NULL, 110796),
(110797, '2.60.40.10-FF-005943', NULL, NULL, 96, NULL, NULL, 110797),
(110798, '1.10.472.10-FF-000106', NULL, 'Cyclin-SDS', 100, NULL, NULL, 110798),
(110799, '3.30.450.230-FF-000001', NULL, 'Vacuolar v-SNARE', 149, NULL, NULL, 110799),
(110800, '2.60.40.10-FF-001492', NULL, 'Adhesion molecule with Ig-like domain 3', 99, NULL, NULL, 110800);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(110801, '3.10.580.10-FF-000108', NULL, 'Putative cation efflux protein', 146, NULL, NULL, 110801),
(110802, '1.10.10.10-FF-001343', NULL, 'Uncharacterized protein', 59, NULL, NULL, 110802),
(110803, '3.80.10.10-FF-004421', NULL, 'At5g27920', 136, NULL, NULL, 110803),
(110804, '2.30.30.180-FF-000014', NULL, 'Ribosome maturation factor RimP', 62, NULL, NULL, 110804),
(110805, '4.10.400.10-FF-000002', NULL, 'Low-density lipoprotein receptor-related protein 1', 42, NULL, NULL, 110805),
(110806, '1.20.150.20-FF-000005', NULL, 'ATP synthase subunit alpha, mitochondrial', 52, NULL, NULL, 110806),
(110807, '3.90.810.10-FF-000002', NULL, 'Non-specific serine/threonine protein kinase', 44, NULL, NULL, 110807),
(110808, '3.40.50.980-FF-000055', NULL, 'Non-ribosomal peptide synthetase', 78, NULL, NULL, 110808),
(110809, '3.30.40.10-FF-000940', NULL, 'RBR-type E3 ubiquitin transferase', 89, NULL, NULL, 110809),
(110810, '3.90.780.10-FF-000004', NULL, 'UDP-sugar hydrolase, putative', 203, NULL, NULL, 110810),
(110811, '1.10.520.10-FF-000005', NULL, 'Cytochrome c peroxidase', 139, NULL, NULL, 110811),
(110812, '3.40.309.10-FF-000106', NULL, 'Uncharacterized protein', 186, NULL, NULL, 110812),
(110813, '3.40.720.10-FF-000080', NULL, 'N-acetylgalactosamine 6-sulfatase (GALNS)', 355, NULL, NULL, 110813),
(110814, '3.30.40.10-FF-000884', NULL, 'RING finger protein PSH1', 119, NULL, NULL, 110814),
(110815, '3.50.50.60-FF-000246', NULL, 'Sulphydryl oxidase Sox', 128, NULL, NULL, 110815),
(110816, '1.25.40.10-FF-002284', NULL, 'Pentatricopeptide repeat-containing protein At5g40410, mitochondrial', 129, NULL, NULL, 110816),
(110817, '2.120.10.80-FF-000389', NULL, 'Predicted protein', 209, NULL, NULL, 110817),
(110818, '3.60.40.10-FF-000197', NULL, 'Type 2C Protein Phosphatase, putative', 369, NULL, NULL, 110818),
(110819, '3.40.50.720-FF-001045', NULL, 'Ketose-bisphosphate aldolase class-II family protein', 163, NULL, NULL, 110819),
(110820, '3.30.505.10-FF-000166', NULL, NULL, 106, NULL, NULL, 110820),
(110821, '1.10.10.60-FF-001077', NULL, NULL, 45, NULL, NULL, 110821),
(110822, '3.50.50.60-FF-000954', NULL, 'FAD-dependent glycerol-3-phosphate dehydrogenase, family protein', 203, NULL, NULL, 110822),
(110823, '1.20.1070.10-FF-000304', NULL, 'Trissin receptor, isoform C', 159, NULL, NULL, 110823),
(110824, '3.40.50.10380-FF-000029', NULL, 'NADP-dependent malic enzyme 1', 198, NULL, NULL, 110824),
(110825, '1.10.1040.50-FF-000007', NULL, '3-hydroxyacyl-CoA dehydrogenase', 177, NULL, NULL, 110825),
(110826, '2.170.260.40-FF-000003', NULL, '5''-3'' exonuclease, putative', 168, NULL, NULL, 110826),
(110827, '3.40.50.10490-FF-000011', NULL, 'Arabinose 5-phosphate isomerase', 191, NULL, NULL, 110827),
(110828, '3.90.640.10-FF-000202', NULL, 'Heat shock 70 kDa protein 14', 85, NULL, NULL, 110828),
(110829, '1.10.10.10-FF-000359', NULL, 'DNA-binding response regulator', 106, NULL, NULL, 110829),
(110830, '1.20.1270.60-FF-000306', NULL, 'Meiotically up-regulated gene 64 protein', 274, NULL, NULL, 110830),
(110831, '3.40.1800.20-FF-000015', NULL, 'FI19405p1', 94, NULL, NULL, 110831),
(110832, '4.10.320.10-FF-000001', NULL, 'Dihydrolipoyllysine-residue succinyltransferase component of 2-oxoglutarate dehydrogenase complex', 51, NULL, NULL, 110832),
(110833, '1.10.510.10-FF-002601', NULL, NULL, 176, NULL, NULL, 110833),
(110834, '3.10.280.10-FF-000035', NULL, 'Mitochondrial acidic protein mam33', 218, NULL, NULL, 110834),
(110835, '1.10.472.10-FF-000286', NULL, 'Uncharacterized protein', 127, NULL, NULL, 110835),
(110836, '2.130.10.10-FF-001060', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 231, NULL, NULL, 110836),
(110837, '3.20.20.30-FF-000001', NULL, 'Alkanesulfonate monooxygenase', 360, NULL, NULL, 110837),
(110838, '3.40.50.300-FF-000166', NULL, 'vesicle-fusing ATPase isoform X1', 172, NULL, NULL, 110838),
(110839, '2.30.30.40-FF-000113', NULL, 'unconventional myosin-VIIa', 82, NULL, NULL, 110839),
(110840, '3.10.110.10-FF-000377', NULL, 'Uncharacterized protein', 75, NULL, NULL, 110840),
(110841, '3.40.390.10-FF-000126', NULL, 'Matrix metalloproteinase 13', 148, NULL, NULL, 110841);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(110842, '1.20.1110.10-FF-000128', NULL, 'Sodium/potassium-transporting ATPase subunit alpha', 400, NULL, NULL, 110842),
(110843, '2.70.170.10-FF-000202', NULL, 'Gamma-aminobutyric acid type A receptor alpha2 subunit a', 168, NULL, NULL, 110843),
(110844, '3.40.50.10090-FF-000066', NULL, 'Predicted protein', 24, NULL, NULL, 110844),
(110845, '1.20.1310.10-FF-000020', NULL, 'Cullin-1, putative', 123, NULL, NULL, 110845),
(110846, '2.30.36.90-FF-000001', NULL, 'Actin-related protein 8', 24, NULL, NULL, 110846),
(110847, '1.20.80.10-FF-000048', NULL, 'Acyl-CoA binding domain containing 3', 73, NULL, NULL, 110847),
(110848, '3.40.50.2300-FF-000186', NULL, 'Glutamate receptor 1', 158, NULL, NULL, 110848),
(110849, '1.20.920.10-FF-000180', NULL, 'Predicted protein', 143, NULL, NULL, 110849),
(110850, '3.40.1110.10-FF-000015', NULL, 'ATPase copper transporting beta', 157, NULL, NULL, 110850),
(110851, '3.10.150.10-FF-000031', NULL, 'Proliferating cell nuclear antigen', 71, NULL, NULL, 110851),
(110852, '3.60.21.10-FF-000310', NULL, 'Ser/Thr protein phosphatase family protein, UDP-2,3-diacylglucosamine hydrolase', 254, NULL, NULL, 110852),
(110853, '3.40.50.300-FF-002111', NULL, 'Origin of replication complex subunit 1', 176, NULL, NULL, 110853),
(110854, '3.30.70.330-FF-000827', NULL, 'Related to pre-mRNA splicing factor', 124, NULL, NULL, 110854),
(110855, '3.30.1490.120-FF-000019', NULL, 'Uncharacterized protein', 96, NULL, NULL, 110855),
(110856, '1.10.8.10-FF-000291', NULL, 'Ubiquitinyl hydrolase 1', 79, NULL, NULL, 110856),
(110857, '3.30.160.60-FF-004959', NULL, NULL, 35, NULL, NULL, 110857),
(110858, '3.40.720.10-FF-000017', NULL, 'Predicted protein', 284, NULL, NULL, 110858),
(110859, '2.60.40.10-FF-005235', NULL, NULL, 89, NULL, NULL, 110859),
(110860, '2.20.70.10-FF-000124', NULL, 'DEAD box RNA helicase family protein', 56, NULL, NULL, 110860),
(110861, '1.10.1200.30-FF-000003', NULL, 'Gag polyprotein', 102, NULL, NULL, 110861),
(110862, '2.40.50.100-FF-000200', NULL, 'Uncharacterized protein', 48, NULL, NULL, 110862),
(110863, '3.90.1150.10-FF-000377', NULL, 'Methionine aminotransferase', 100, NULL, NULL, 110863),
(110864, '3.40.850.10-FF-000206', NULL, 'Putative kinesin', 349, NULL, NULL, 110864),
(110865, '1.20.920.10-FF-000028', NULL, 'Nuclear autoantigen Sp-100', 122, NULL, NULL, 110865),
(110866, '1.20.1530.20-FF-000096', NULL, 'Predicted protein', 212, NULL, NULL, 110866),
(110867, '1.10.1410.10-FF-000002', NULL, 'terminal uridylyltransferase 4 isoform X1', 168, NULL, NULL, 110867),
(110868, '3.40.1350.100-FF-000007', NULL, 'Protein TIC 22-like, chloroplastic', 109, NULL, NULL, 110868),
(110869, '2.130.10.10-FF-001088', NULL, 'Notchless homolog, putative', 377, NULL, NULL, 110869),
(110870, '3.20.20.70-FF-000018', NULL, 'Probable transaldolase', 215, NULL, NULL, 110870),
(110871, '1.10.510.10-FF-002596', NULL, NULL, 185, NULL, NULL, 110871),
(110872, '2.130.10.10-FF-005331', NULL, 'Predicted protein', 189, NULL, NULL, 110872),
(110873, '3.30.70.330-FF-001463', NULL, 'Pentatricopeptide (PPR) repeat-containing protein', 123, NULL, NULL, 110873),
(110874, '3.60.40.10-FF-000202', NULL, 'Predicted protein', 118, NULL, NULL, 110874),
(110875, '3.40.50.2300-FF-000894', NULL, NULL, 134, NULL, NULL, 110875),
(110876, '3.40.50.150-FF-000008', NULL, 'DNA (Cytosine-5)-methyltransferase 3A isoform X1', 230, NULL, NULL, 110876),
(110877, '1.20.1250.20-FF-001895', NULL, 'Uncharacterized protein', 72, NULL, NULL, 110877),
(110878, '2.130.10.10-FF-005359', NULL, 'Uncharacterized protein', 173, NULL, NULL, 110878),
(110879, '2.60.40.1460-FF-000014', NULL, 'Integrin alpha-PS3', 140, NULL, NULL, 110879),
(110880, '3.40.50.12230-FF-000022', NULL, 'Uncharacterized protein', 315, NULL, NULL, 110880),
(110881, '3.30.60.30-FF-000222', NULL, 'Uncharacterized protein', 56, NULL, NULL, 110881),
(110882, '3.30.200.20-FF-002260', NULL, 'Cell surface receptor daf-1', 114, NULL, NULL, 110882),
(110883, '2.40.30.30-FF-000031', NULL, 'Uncharacterized protein', 114, NULL, NULL, 110883),
(110884, '1.25.10.10-FF-000567', NULL, 'Karyopherin beta 2', 865, NULL, NULL, 110884);
INSERT INTO "PUBLIC"."MODEL" VALUES
(110885, '3.30.450.40-FF-000165', NULL, 'Heat-inducible transcription repressor HrcA', 144, NULL, NULL, 110885),
(110886, '1.25.40.10-FF-003296', NULL, 'Uncharacterized protein', 90, NULL, NULL, 110886),
(110887, '3.80.10.10-FF-000711', NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g12460', 143, NULL, NULL, 110887),
(110888, '3.40.50.720-FF-000084', NULL, 'Short-chain dehydrogenase reductase', 256, NULL, NULL, 110888),
(110889, '2.60.40.10-FF-000328', NULL, 'CLUMA_CG000981, isoform A', 92, NULL, NULL, 110889),
(110890, '3.30.160.810-FF-000002', NULL, '50S ribosomal protein L3', 64, NULL, NULL, 110890),
(110891, '3.40.1160.10-FF-000018', NULL, 'Glutamate 5-kinase', 263, NULL, NULL, 110891),
(110892, '3.40.50.1000-FF-000515', NULL, NULL, 142, NULL, NULL, 110892),
(110893, '3.30.70.330-FF-002300', NULL, NULL, 151, NULL, NULL, 110893),
(110894, '3.30.420.10-FF-000317', NULL, 'Polyprotein', 201, NULL, NULL, 110894),
(110895, '1.20.58.1030-FF-000041', NULL, 'Predicted protein', 48, NULL, NULL, 110895),
(110896, '2.40.170.20-FF-000066', NULL, 'Probable TonB-dependent receptor', 534, NULL, NULL, 110896),
(110897, '3.80.10.10-FF-003437', NULL, 'Uncharacterized protein', 62, NULL, NULL, 110897),
(110898, '3.30.70.330-FF-001811', NULL, NULL, 49, NULL, NULL, 110898),
(110899, '1.10.730.10-FF-000162', NULL, 'Methionyl-tRNA synthetase', 182, NULL, NULL, 110899),
(110900, '3.30.470.20-FF-000042', NULL, 'Synapsin III', 86, NULL, NULL, 110900),
(110901, '2.130.10.10-FF-001621', NULL, 'Excision repair cross-complementation group 8', 162, NULL, NULL, 110901),
(110902, '4.10.280.10-FF-000093', NULL, 'BHLH domain class transcription factor', 73, NULL, NULL, 110902),
(110903, '4.10.80.160-FF-000003', NULL, 'Uncharacterized protein, isoform B', 32, NULL, NULL, 110903),
(110904, '2.130.10.10-FF-001436', NULL, 'Putative WD-repeat family protein', 254, NULL, NULL, 110904),
(110905, '2.60.120.260-FF-000582', NULL, 'Uncharacterized protein', 166, NULL, NULL, 110905),
(110906, '3.40.50.720-FF-001332', NULL, 'NAD(P)-dependent oxidoreductase', 255, NULL, NULL, 110906),
(110907, '2.120.10.70-FF-000004', NULL, 'Putative secreted neuraminidase', 176, NULL, NULL, 110907),
(110908, '3.80.10.10-FF-002004', NULL, 'Phytosulfokine receptor 1', 97, NULL, NULL, 110908),
(110909, '3.30.1330.20-FF-000037', NULL, 'Alpha-tubulin,putative', 115, NULL, NULL, 110909),
(110910, '1.10.1900.20-FF-000003', NULL, 'Mitochondrial ribosomal protein L20', 61, NULL, NULL, 110910),
(110911, '3.40.50.300-FF-001178', NULL, 'ATP-binding cassette sub-family D member 4 isoform X1', 220, NULL, NULL, 110911),
(110912, '3.20.20.80-FF-000819', NULL, 'Alpha-L-iduronidase, putative', 79, NULL, NULL, 110912),
(110913, '1.10.12.10-FF-000021', NULL, '3-hydroxybutyryl-CoA dehydratase', 55, NULL, NULL, 110913),
(110914, '1.10.3260.10-FF-000029', NULL, 'Thermostable DNA ligase', 197, NULL, NULL, 110914),
(110915, '1.25.40.570-FF-000024', NULL, '26S proteasome non-ATPase regulatory subunit 13 homolog B', 200, NULL, NULL, 110915),
(110916, '2.160.20.80-FF-000006', NULL, 'Thylakoid lumenal 17.4 kDa protein, chloroplastic', 124, NULL, NULL, 110916),
(110917, '3.30.160.60-FF-002397', NULL, 'Zinc finger protein 320', 32, NULL, NULL, 110917),
(110918, '3.55.50.30-FF-000019', NULL, 'Probable transmembrane sensor', 75, NULL, NULL, 110918),
(110919, '3.90.1380.10-FF-000006', NULL, 'Threonine synthase', 85, NULL, NULL, 110919),
(110920, '3.40.50.300-FF-003364', NULL, 'Si:dkey-110g7.8', 214, NULL, NULL, 110920),
(110921, '3.30.160.60-FF-001413', NULL, 'tripartite motif-containing protein 47 isoform X1', 63, NULL, NULL, 110921),
(110922, '3.30.310.40-FF-000003', NULL, 'N-glycosylase/DNA lyase OGG1', 86, NULL, NULL, 110922),
(110923, '3.30.40.10-FF-000653', NULL, 'RING/U-box superfamily protein', 71, NULL, NULL, 110923),
(110924, '3.40.50.1000-FF-000431', NULL, NULL, 97, NULL, NULL, 110924),
(110925, '1.20.1560.10-FF-000156', NULL, 'Toxin secretion ABC transporter ATP-binding protein', 322, NULL, NULL, 110925),
(110926, '3.30.365.10-FF-000014', NULL, 'Selenate reductase, molybdenum-binding subunit', 107, NULL, NULL, 110926);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(110927, '2.60.40.10-FF-003526', NULL, NULL, 113, NULL, NULL, 110927),
(110928, '3.30.160.60-FF-001885', NULL, 'Zgc:174653', 25, NULL, NULL, 110928),
(110929, '2.30.29.30-FF-001203', NULL, 'Uncharacterized protein', 41, NULL, NULL, 110929),
(110930, '1.10.555.10-FF-000237', NULL, NULL, 201, NULL, NULL, 110930),
(110931, '1.20.1220.12-FF-000004', NULL, 'Malate synthase', 37, NULL, NULL, 110931),
(110932, '3.40.50.620-FF-000705', NULL, 'Nicotinamide-nucleotide adenylyltransferase', 236, NULL, NULL, 110932),
(110933, '3.10.20.30-FF-000086', NULL, NULL, 62, NULL, NULL, 110933),
(110934, '2.60.40.2160-FF-000005', NULL, 'Interleukin 17 receptor E like', 146, NULL, NULL, 110934),
(110935, '3.30.465.10-FF-000055', NULL, 'Possible alkyldihydroxyacetonephosphate synthase agpS', 215, NULL, NULL, 110935),
(110936, '2.60.120.10-FF-000044', NULL, 'Mannose-6-phosphate isomerase', 98, NULL, NULL, 110936),
(110937, '3.40.50.300-FF-003420', NULL, 'Developmentally-regulated GTP-binding protein, putative', 119, NULL, NULL, 110937),
(110938, '1.25.40.20-FF-001685', NULL, 'Ankyrin 1', 75, NULL, NULL, 110938),
(110939, '1.25.40.10-FF-001643', NULL, 'Pentatricopeptide repeat-containing protein', 143, NULL, NULL, 110939),
(110940, '3.40.50.300-FF-007107', NULL, 'Phosphoribulokinase', 187, NULL, NULL, 110940),
(110941, '1.10.287.600-FF-000010', NULL, 'Tubulin delta chain', 50, NULL, NULL, 110941),
(110942, '1.25.40.10-FF-005010', NULL, 'Tetratricopeptide repeat domain 21B', 116, NULL, NULL, 110942),
(110943, '3.40.50.1820-FF-000609', NULL, 'Arylesterase', 306, NULL, NULL, 110943),
(110944, '3.40.50.410-FF-000194', NULL, 'Collagen, type VII, alpha 1', 189, NULL, NULL, 110944),
(110945, '2.40.70.10-FF-000286', NULL, NULL, 59, NULL, NULL, 110945),
(110946, '1.20.5.2440-FF-000008', NULL, 'RAB11 family-interacting protein 5a (class I)', 47, NULL, NULL, 110946),
(110947, '3.30.530.20-FF-000160', NULL, 'Uncharacterized protein', 143, NULL, NULL, 110947),
(110948, '1.25.10.10-FF-002220', NULL, 'Uncharacterized protein', 409, NULL, NULL, 110948),
(110949, '3.50.50.100-FF-000025', NULL, 'FAD-dependent pyridine nucleotide-disulfide oxidoreductase family protein', 376, NULL, NULL, 110949),
(110950, '3.80.10.10-FF-002476', NULL, 'Uncharacterized protein', 297, NULL, NULL, 110950),
(110951, '2.120.10.30-FF-000043', NULL, 'NHL repeat containing 3', 301, NULL, NULL, 110951),
(110952, '3.90.226.10-FF-000341', NULL, 'Methylthioacryloyl-CoA hydratase', 208, NULL, NULL, 110952),
(110953, '3.30.160.60-FF-005628', NULL, NULL, 21, NULL, NULL, 110953),
(110954, '1.10.510.10-FF-001292', NULL, 'Protein kinase domain containing protein', 268, NULL, NULL, 110954),
(110955, '1.10.10.10-FF-001056', NULL, 'IclR family transcriptional regulator', 78, NULL, NULL, 110955),
(110956, '1.20.1250.20-FF-001979', NULL, 'Transporter, putative', 394, NULL, NULL, 110956),
(110957, '3.90.230.10-FF-000031', NULL, 'Proliferation-associated 2G4-like protein', 44, NULL, NULL, 110957),
(110958, '1.25.10.10-FF-001815', NULL, 'Uncharacterized protein', 309, NULL, NULL, 110958),
(110959, '3.40.720.10-FF-000309', NULL, 'Uncharacterized protein', 214, NULL, NULL, 110959),
(110960, '2.60.210.10-FF-000074', NULL, NULL, 192, NULL, NULL, 110960),
(110961, '2.10.25.10-FF-001650', NULL, 'Uncharacterized protein', 47, NULL, NULL, 110961),
(110962, '1.20.120.1080-FF-000013', NULL, 'ATP-dependent RNA helicase DHX34', 98, NULL, NULL, 110962),
(110963, '2.60.220.50-FF-000064', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', 202, NULL, NULL, 110963),
(110964, '1.20.140.100-FF-000031', NULL, 'Cytoplasmic dynein 2 heavy chain 1', 165, NULL, NULL, 110964),
(110965, '1.20.5.190-FF-000066', NULL, 'IQ calmodulin-binding motif family protein, expressed', 37, NULL, NULL, 110965),
(110966, '3.30.230.40-FF-000002', NULL, 'Imidazoleglycerol-phosphate dehydratase', 106, NULL, NULL, 110966),
(110967, '3.30.420.10-FF-000233', NULL, 'Uncharacterized protein', 205, NULL, NULL, 110967),
(110968, '1.10.600.10-FF-000006', NULL, 'Farnesyl pyrophosphate synthase', 351, NULL, NULL, 110968),
(110969, '3.60.15.10-FF-000184', NULL, 'Uncharacterized protein', 113, NULL, NULL, 110969);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(110970, '3.80.10.10-FF-000239', NULL, 'Nucleotide-binding oligomerization domain-containing 2', 293, NULL, NULL, 110970),
(110971, '2.10.25.10-FF-001594', NULL, 'Neurogenic locus protein delta-like Protein', 38, NULL, NULL, 110971),
(110972, '3.40.50.300-FF-001655', NULL, 'Sulfate/thiosulfate import ATP-binding protein CysA', 261, NULL, NULL, 110972),
(110973, '3.30.1490.20-FF-000110', NULL, 'Uncharacterized protein', 82, NULL, NULL, 110973),
(110974, '1.20.1250.20-FF-000731', NULL, 'MFS family transporter', 206, NULL, NULL, 110974),
(110975, '1.10.240.10-FF-000023', NULL, 'Tryptophan--tRNA ligase 2', 123, NULL, NULL, 110975),
(110976, '2.60.40.10-FF-000295', NULL, 'Tyrosine-protein phosphatase non-receptor type substrate 1', 115, NULL, NULL, 110976),
(110977, '1.10.510.10-FF-000887', NULL, 'Aurora B kinase', 281, NULL, NULL, 110977),
(110978, '3.10.129.10-FF-000015', NULL, 'Fatty acid synthase subunit beta', 192, NULL, NULL, 110978),
(110979, '1.20.58.60-FF-000894', NULL, 'Uncharacterized protein', 212, NULL, NULL, 110979),
(110980, '2.60.120.920-FF-000061', NULL, 'Tripartite motif containing 65', 187, NULL, NULL, 110980),
(110981, '2.40.240.130-FF-000006', NULL, 'DIX domain containing 1 (DIXDC1), mRNA protein', 86, NULL, NULL, 110981),
(110982, '3.40.50.300-FF-002959', NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', 116, NULL, NULL, 110982),
(110983, '2.70.98.40-FF-000003', NULL, 'Acid trehalase', 274, NULL, NULL, 110983),
(110984, '1.20.1250.20-FF-000675', NULL, 'Major facilitator superfamily transporter', 204, NULL, NULL, 110984),
(110985, '1.25.10.10-FF-001495', NULL, 'Uncharacterized protein', 198, NULL, NULL, 110985),
(110986, '3.30.450.20-FF-000535', NULL, 'Uncharacterized protein', 121, NULL, NULL, 110986),
(110987, '1.20.5.110-FF-000149', NULL, 'SNARE domain containing protein', 106, NULL, NULL, 110987),
(110988, '3.40.50.300-FF-005073', NULL, 'Thyroid hormone receptor interactor 13', 106, NULL, NULL, 110988),
(110989, '3.30.310.80-FF-000060', NULL, 'Uncharacterized protein', 98, NULL, NULL, 110989),
(110990, '3.40.850.10-FF-000353', NULL, 'Kinesin-like protein', 377, NULL, NULL, 110990),
(110991, '2.40.30.230-FF-000004', NULL, 'ATP-dependent helicase NAM7', 93, NULL, NULL, 110991),
(110992, '1.20.5.170-FF-000060', NULL, 'protein ABSCISIC ACID-INSENSITIVE 5 isoform X1', 57, NULL, NULL, 110992),
(110993, '3.20.20.70-FF-000081', NULL, 'Dihydrouridine synthase 1 like', 234, NULL, NULL, 110993),
(110994, '2.60.40.10-FF-005674', NULL, NULL, 83, NULL, NULL, 110994),
(110995, '3.90.1750.10-FF-000018', NULL, 'E3 ubiquitin-protein ligase HECTD1 isoform X1', 35, NULL, NULL, 110995),
(110996, '1.25.40.20-FF-001213', NULL, 'Uncharacterized protein', 78, NULL, NULL, 110996),
(110997, '3.30.70.330-FF-000794', NULL, 'Gar2 protein', 101, NULL, NULL, 110997),
(110998, '3.40.50.2000-FF-000686', NULL, 'ADP-heptose:LPS heptosyltransferase II', 189, NULL, NULL, 110998),
(110999, '2.130.10.10-FF-000216', NULL, 'Periodic tryptophan protein 2 homolog', 217, NULL, NULL, 110999),
(111000, '3.80.10.10-FF-004134', NULL, 'Uncharacterized protein', 281, NULL, NULL, 111000),
(111001, '2.30.29.30-FF-000478', NULL, 'JNK Interacting Protein (Scaffold protein)', 145, NULL, NULL, 111001),
(111002, '1.10.510.10-FF-001668', NULL, 'Tyrosine-protein kinase', 271, NULL, NULL, 111002),
(111003, '3.40.640.10-FF-000163', NULL, 'Phosphoserine transaminase, putative', 285, NULL, NULL, 111003),
(111004, '3.40.720.10-FF-000164', NULL, 'Phosphatidylinositol glycan anchor biosynthesis class N', 75, NULL, NULL, 111004),
(111005, '3.40.50.1820-FF-000761', NULL, 'Haloalkane dehalogenase', 312, NULL, NULL, 111005),
(111006, '2.40.50.140-FF-001061', NULL, NULL, 101, NULL, NULL, 111006),
(111007, '2.60.40.10-FF-002240', NULL, 'Macrophage stimulating 1 receptor b', 86, NULL, NULL, 111007),
(111008, '2.30.30.100-FF-000069', NULL, 'Small nuclear ribonucleoprotein Sm D2', 118, NULL, NULL, 111008),
(111009, '1.10.3450.40-FF-000019', NULL, NULL, 206, NULL, NULL, 111009),
(111010, '1.20.920.20-FF-000042', NULL, 'Uncharacterized protein', 338, NULL, NULL, 111010);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(111011, '2.60.40.820-FF-000044', NULL, 'Uncharacterized protein', 129, NULL, NULL, 111011),
(111012, '3.40.20.10-FF-000096', NULL, 'Protein transport protein SEC23', 106, NULL, NULL, 111012),
(111013, '2.40.160.20-FF-000037', NULL, 'Outer membrane porin', 204, NULL, NULL, 111013),
(111014, '1.50.40.10-FF-000303', NULL, 'Mitochondrial carrier protein', 255, NULL, NULL, 111014),
(111015, '1.20.120.140-FF-000011', NULL, 'Signal recognition particle 54 kDa protein', 53, NULL, NULL, 111015),
(111016, '1.10.287.3700-FF-000008', NULL, 'PAN2-PAN3 deadenylation complex subunit pan3', 108, NULL, NULL, 111016),
(111017, '3.40.50.80-FF-000101', NULL, 'Metalloreductase, putative', 166, NULL, NULL, 111017),
(111018, '3.90.199.10-FF-000001', NULL, 'DNA gyrase subunit A', 269, NULL, NULL, 111018),
(111019, '3.30.457.60-FF-000001', NULL, 'Mitotic spindle assembly checkpoint protein MAD1', 82, NULL, NULL, 111019),
(111020, '1.10.10.60-FF-001133', NULL, NULL, 61, NULL, NULL, 111020),
(111021, '3.30.559.10-FF-000234', NULL, 'Uncharacterized protein', 163, NULL, NULL, 111021),
(111022, '3.30.450.20-FF-000479', NULL, 'Uncharacterized protein', 72, NULL, NULL, 111022),
(111023, '1.10.30.10-FF-000130', NULL, 'Uncharacterized protein', 99, NULL, NULL, 111023),
(111024, '3.40.50.1000-FF-000807', NULL, NULL, 136, NULL, NULL, 111024),
(111025, '1.20.90.10-FF-000021', NULL, 'Otoconin 90', 118, NULL, NULL, 111025),
(111026, '3.40.50.10490-FF-000118', NULL, NULL, 186, NULL, NULL, 111026),
(111027, '2.10.25.10-FF-001739', NULL, 'Uncharacterized protein', 38, NULL, NULL, 111027),
(111028, '1.20.1250.20-FF-000203', NULL, 'Large neutral amino acids transporter small subunit 4', 191, NULL, NULL, 111028),
(111029, '4.10.1130.20-FF-000003', NULL, 'Cysteine and histidine-rich domain-containing protein RAR1', 72, NULL, NULL, 111029),
(111030, '1.20.120.1910-FF-000037', NULL, 'Cysteine--tRNA ligase', 151, NULL, NULL, 111030),
(111031, '3.30.1490.190-FF-000023', NULL, 'Ferric uptake regulation protein', 58, NULL, NULL, 111031),
(111032, '3.80.10.10-FF-003729', NULL, 'AGAP000340-PA', 137, NULL, NULL, 111032),
(111033, '1.10.472.10-FF-000578', NULL, 'Uncharacterized protein', 49, NULL, NULL, 111033),
(111034, '1.10.560.10-FF-000042', NULL, 'T-complex polypeptide 1', 170, NULL, NULL, 111034),
(111035, '3.30.1240.10-FF-000061', NULL, 'Uncharacterized protein', 117, NULL, NULL, 111035),
(111036, '1.10.510.10-FF-002124', NULL, 'Predicted protein', 267, NULL, NULL, 111036),
(111037, '3.20.10.10-FF-000017', NULL, 'Unplaced genomic scaffold supercont1.241, whole genome shotgun sequence', 185, NULL, NULL, 111037),
(111038, '1.20.1560.10-FF-000443', NULL, 'Uncharacterized protein', 360, NULL, NULL, 111038),
(111039, '3.30.420.40-FF-000865', NULL, 'Uncharacterized protein', 86, NULL, NULL, 111039),
(111040, '3.30.70.330-FF-000535', NULL, 'Serine/arginine-rich splicing factor SR45a', 160, NULL, NULL, 111040),
(111041, '3.30.40.10-FF-002362', NULL, 'Ubiquitinyl hydrolase 1', 135, NULL, NULL, 111041),
(111042, '3.40.30.10-FF-000181', NULL, 'Thiol-disulfide oxidoreductase ResA', 146, NULL, NULL, 111042),
(111043, '3.30.70.330-FF-001047', NULL, 'Putative RNA-binding protein', 116, NULL, NULL, 111043),
(111044, '1.10.472.30-FF-000005', NULL, 'Transcription elongation factor S-II', 120, NULL, NULL, 111044),
(111045, '1.20.1260.60-FF-000013', NULL, 'Uncharacterized protein', 55, NULL, NULL, 111045),
(111046, '3.30.450.20-FF-000390', NULL, 'Sensory transduction histidine kinase', 72, NULL, NULL, 111046),
(111047, '3.90.1460.10-FF-000007', NULL, 'General transcription factor II-I repeat domain-containing protein 1', 98, NULL, NULL, 111047),
(111048, '2.60.40.10-FF-000036', NULL, 'receptor-type tyrosine-protein phosphatase delta isoform X1', 103, NULL, NULL, 111048),
(111049, '2.40.30.20-FF-000017', NULL, 'ATP synthase subunit alpha 1', 87, NULL, NULL, 111049),
(111050, '1.20.900.10-FF-000089', NULL, 'PIX (PAK (p21-activated kinase) Interacting eXchange factor) homolog', 196, NULL, NULL, 111050),
(111051, '2.20.70.10-FF-000040', NULL, 'WW domain containing oxidoreductase', 38, NULL, NULL, 111051);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(111052, '1.20.58.60-FF-000242', NULL, 'Dystrophin', 111, NULL, NULL, 111052),
(111053, '1.20.20.10-FF-000016', NULL, 'ATP synthase subunit 9, mitochondrial', 75, NULL, NULL, 111053),
(111054, '1.10.510.10-FF-004310', NULL, NULL, 154, NULL, NULL, 111054),
(111055, '2.130.10.10-FF-006000', NULL, 'Uncharacterized protein', 82, NULL, NULL, 111055),
(111056, '3.40.50.970-FF-000226', NULL, 'Gll1094 protein', 318, NULL, NULL, 111056),
(111057, '1.20.58.400-FF-000033', NULL, 'Uncharacterized protein', 92, NULL, NULL, 111057),
(111058, '4.10.60.10-FF-000035', NULL, 'Cellular nucleic acid-binding protein', 23, NULL, NULL, 111058),
(111059, '1.10.150.20-FF-000053', NULL, 'T5 flap endonuclease', 76, NULL, NULL, 111059),
(111060, '2.30.30.380-FF-000074', NULL, 'Uncharacterized protein', 52, NULL, NULL, 111060),
(111061, '3.30.420.40-FF-000337', NULL, 'Actin-related protein 5', 32, NULL, NULL, 111061),
(111062, '1.10.10.60-FF-000149', NULL, 'AraC family transcriptional regulator', 57, NULL, NULL, 111062),
(111063, '3.30.160.20-FF-000047', NULL, 'double-stranded RNA-binding protein 1', 77, NULL, NULL, 111063),
(111064, '3.40.50.300-FF-006326', NULL, 'Uncharacterized AAA domain-containing protein P22H7.05c', 174, NULL, NULL, 111064),
(111065, '2.170.300.10-FF-000015', NULL, 'multiple epidermal growth factor-like domains protein 11 isoform X3', 112, NULL, NULL, 111065),
(111066, '3.40.47.10-FF-000157', NULL, NULL, 185, NULL, NULL, 111066),
(111067, '2.130.10.10-FF-001144', NULL, 'WD40 repeat-like protein', 262, NULL, NULL, 111067),
(111068, '2.60.98.50-FF-000001', NULL, 'Envelopment polyprotein', 133, NULL, NULL, 111068),
(111069, '1.10.8.60-FF-000081', NULL, 'AAA family ATPase/60S ribosome export protein', 127, NULL, NULL, 111069),
(111070, '2.60.40.10-FF-001817', NULL, 'Basement membrane proteoglycan', 94, NULL, NULL, 111070),
(111071, '1.20.5.520-FF-000007', NULL, 'Thymosin beta HOMOLOGUE', 34, NULL, NULL, 111071),
(111072, '1.25.40.10-FF-003065', NULL, 'Uncharacterized protein', 212, NULL, NULL, 111072),
(111073, '1.10.8.60-FF-000457', NULL, 'Uncharacterized protein', 61, NULL, NULL, 111073),
(111074, '3.40.50.720-FF-000909', NULL, 'Ornithine cyclodeaminase', 178, NULL, NULL, 111074),
(111075, '3.30.1490.20-FF-000054', NULL, 'D-alanine--D-alanine ligase', 63, NULL, NULL, 111075),
(111076, '3.40.50.150-FF-000424', NULL, 'Mitochondrial transcription factor', 250, NULL, NULL, 111076),
(111077, '3.30.160.60-FF-006051', NULL, NULL, 76, NULL, NULL, 111077),
(111078, '3.90.70.80-FF-000078', NULL, 'Predicted protein', 129, NULL, NULL, 111078),
(111079, '1.20.5.170-FF-000240', NULL, 'Cyclic AMP-dependent transcription factor ATF-4', 63, NULL, NULL, 111079),
(111080, '3.30.800.10-FF-000015', NULL, 'Phosphatidylinositol-4-phosphate 5-kinase', 186, NULL, NULL, 111080),
(111081, '1.10.840.10-FF-000024', NULL, 'Rap Guanine nucleotide Exchange Factor homolog', 269, NULL, NULL, 111081),
(111082, '1.10.167.20-FF-000001', NULL, 'Nucleoporin NUP170', 81, NULL, NULL, 111082),
(111083, '3.10.110.10-FF-000085', NULL, 'Ubiquitin-conjugating enzyme E2 C', 152, NULL, NULL, 111083),
(111084, '1.20.142.10-FF-000012', NULL, 'Poly [ADP-ribose] polymerase', 120, NULL, NULL, 111084),
(111085, '1.20.1270.60-FF-000222', NULL, 'Uncharacterized protein', 235, NULL, NULL, 111085),
(111086, '3.30.230.120-FF-000020', NULL, NULL, 361, NULL, NULL, 111086),
(111087, '3.40.50.150-FF-001588', NULL, NULL, 38, NULL, NULL, 111087),
(111088, '4.10.1230.10-FF-000002', NULL, 'Ecotin family (I11)', 52, NULL, NULL, 111088),
(111089, '2.40.30.10-FF-000492', NULL, 'Selenocysteine-specific elongation factor', 118, NULL, NULL, 111089),
(111090, '3.40.50.300-FF-001942', NULL, 'DEAD-box ATP-dependent RNA helicase 50', 238, NULL, NULL, 111090),
(111091, '3.40.190.10-FF-000526', NULL, 'Uncharacterized protein', 154, NULL, NULL, 111091),
(111092, '3.30.420.10-FF-000609', NULL, NULL, 181, NULL, NULL, 111092),
(111093, '3.90.1280.20-FF-000007', NULL, 'Chloride channel protein', 66, NULL, NULL, 111093),
(111094, '2.30.40.10-FF-000127', NULL, 'Imidazolonepropionase', 83, NULL, NULL, 111094);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(111095, '1.50.10.10-FF-000211', NULL, 'alpha-1,2-Mannosidase', 169, NULL, NULL, 111095),
(111096, '1.10.472.10-FF-000522', NULL, 'Predicted protein', 95, NULL, NULL, 111096),
(111097, '3.40.1110.10-FF-000246', NULL, NULL, 122, NULL, NULL, 111097),
(111098, '3.80.10.10-FF-002656', NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase At3g28040', 100, NULL, NULL, 111098),
(111099, '2.60.40.10-FF-001109', NULL, 'Kirre like nephrin family adhesion molecule 2', 99, NULL, NULL, 111099),
(111100, '3.30.160.60-FF-001941', NULL, 'Zinc finger protein 460', 28, NULL, NULL, 111100),
(111101, '3.40.50.300-FF-004668', NULL, 'ATP-dependent nuclease subunit A', 165, NULL, NULL, 111101),
(111102, '2.130.10.10-FF-001852', NULL, 'Peptidyl-prolyl cis-trans isomerase, putative', 397, NULL, NULL, 111102),
(111103, '3.30.70.330-FF-001608', NULL, NULL, 107, NULL, NULL, 111103),
(111104, '2.170.120.20-FF-000015', NULL, '50S ribosomal protein L25', 93, NULL, NULL, 111104),
(111105, '3.50.50.60-FF-000477', NULL, 'GMC-type oxidoreductase', 258, NULL, NULL, 111105),
(111106, '1.10.10.10-FF-001820', NULL, 'Uncharacterized protein', 111, NULL, NULL, 111106),
(111107, '2.40.50.40-FF-000119', NULL, 'Histone-lysine N-methyltransferase', 41, NULL, NULL, 111107),
(111108, '1.20.1070.10-FF-000248', NULL, '5-hydroxytryptamine receptor 1A-beta', 116, NULL, NULL, 111108),
(111109, '3.20.20.80-FF-000555', NULL, 'Chitinase, putative', 172, NULL, NULL, 111109),
(111110, '1.20.120.850-FF-000021', NULL, 'Protein CHROMATIN REMODELING 25', 114, NULL, NULL, 111110),
(111111, '3.40.50.1820-FF-000233', NULL, 'Lysosomal Pro-X carboxypeptidase-like Protein', 282, NULL, NULL, 111111),
(111112, '3.30.360.10-FF-000031', NULL, 'Trans-1,2-dihydrobenzene-1,2-diol dehydrogenase', 212, NULL, NULL, 111112),
(111113, '1.10.760.10-FF-000023', NULL, 'Cytochrome c oxidase subunit 2', 97, NULL, NULL, 111113),
(111114, '2.60.120.380-FF-000056', NULL, 'Putative calpain', 152, NULL, NULL, 111114),
(111115, '3.40.50.300-FF-006293', NULL, 'Uncharacterized protein', 298, NULL, NULL, 111115),
(111116, '1.10.10.10-FF-001112', NULL, 'Expressed protein', 103, NULL, NULL, 111116),
(111117, '1.25.40.10-FF-003773', NULL, 'Tetratricopeptide repeat domain 37', 155, NULL, NULL, 111117),
(111118, '2.60.40.10-FF-001020', NULL, 'Hemicentin 1', 93, NULL, NULL, 111118),
(111119, '1.10.246.190-FF-000002', NULL, 'Autophagy protein 5', 68, NULL, NULL, 111119),
(111120, '3.30.720.10-FF-000014', NULL, 'Related to Signal recognition particle 14 kDa protein', 140, NULL, NULL, 111120),
(111121, '2.60.120.290-FF-000181', NULL, 'Cubilin homolog', 111, NULL, NULL, 111121),
(111122, '1.10.3470.10-FF-000039', NULL, 'Manganese transport system membrane protein', 283, NULL, NULL, 111122),
(111123, '3.30.70.20-FF-000006', NULL, 'Formate dehydrogenase iron-sulfur subunit', 133, NULL, NULL, 111123),
(111124, '3.30.460.90-FF-000012', NULL, 'Uncharacterized protein', 137, NULL, NULL, 111124),
(111125, '1.20.58.830-FF-000044', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 123, NULL, NULL, 111125),
(111126, '4.10.910.10-FF-000001', NULL, '30S ribosomal protein S13', 50, NULL, NULL, 111126),
(111127, '1.25.10.10-FF-000983', NULL, 'Dynein axonemal assembly factor 5', 239, NULL, NULL, 111127),
(111128, '1.10.246.140-FF-000009', NULL, 'Transcription and mRNA export factor ENY2', 98, NULL, NULL, 111128),
(111129, '3.40.50.10190-FF-000039', NULL, 'Poly [ADP-ribose] polymerase', 100, NULL, NULL, 111129),
(111130, '3.30.160.60-FF-001233', NULL, 'Zinc finger protein 319', 31, NULL, NULL, 111130),
(111131, '1.25.10.10-FF-003384', NULL, 'Dynein, axonemal, assembly factor 5', 143, NULL, NULL, 111131),
(111132, '3.40.50.720-FF-002534', NULL, 'Uncharacterized protein', 89, NULL, NULL, 111132),
(111133, '1.10.760.10-FF-000079', NULL, 'Uncharacterized protein', 162, NULL, NULL, 111133),
(111134, '1.10.150.50-FF-000157', NULL, 'MAP kinase', 72, NULL, NULL, 111134),
(111135, '2.40.50.140-FF-000077', NULL, 'Primosomal replication protein N', 104, NULL, NULL, 111135),
(111136, '2.160.20.10-FF-000210', NULL, 'Uncharacterized protein', 345, NULL, NULL, 111136);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(111137, '3.40.50.720-FF-000404', NULL, 'SUMO-activating enzyme subunit 1B-2', 319, NULL, NULL, 111137),
(111138, '1.10.150.50-FF-000213', NULL, 'Uncharacterized protein', 40, NULL, NULL, 111138),
(111139, '3.80.10.10-FF-003881', NULL, 'Leucine-rich repeat (LRR) family protein', 162, NULL, NULL, 111139),
(111140, '2.10.50.10-FF-000090', NULL, 'signal peptide, CUB and EGF-like domain-containing protein 2 isoform X1', 51, NULL, NULL, 111140),
(111141, '3.40.50.300-FF-007815', NULL, 'Uncharacterized protein', 283, NULL, NULL, 111141),
(111142, '1.10.246.90-FF-000015', NULL, 'NOP56 ribonucleoprotein', 113, NULL, NULL, 111142),
(111143, '3.40.30.10-FF-000686', NULL, 'Glutathione transferase', 91, NULL, NULL, 111143),
(111144, '3.30.300.320-FF-000001', NULL, 'Neurogenic locus notch 1', 122, NULL, NULL, 111144),
(111145, '3.10.100.10-FF-000348', NULL, NULL, 136, NULL, NULL, 111145),
(111146, '2.30.29.30-FF-001259', NULL, 'Uncharacterized protein', 105, NULL, NULL, 111146),
(111147, '1.10.630.10-FF-000542', NULL, 'Uncharacterized protein', 354, NULL, NULL, 111147),
(111148, '3.40.50.300-FF-004292', NULL, 'Uncharacterized protein', 292, NULL, NULL, 111148),
(111149, '3.40.50.10190-FF-000242', NULL, 'Poly [ADP-ribose] polymerase', 111, NULL, NULL, 111149),
(111150, '3.30.230.10-FF-000403', NULL, 'Ribosome assembly protein 1', 196, NULL, NULL, 111150),
(111151, '1.10.1200.10-FF-000048', NULL, 'Nonribosomal peptide synthase SidE', 71, NULL, NULL, 111151),
(111152, '3.40.50.2000-FF-000630', NULL, 'Alpha-1,3/1,6-mannosyltransferase ALG2', 209, NULL, NULL, 111152),
(111153, '1.20.58.70-FF-000099', NULL, 'Predicted protein', 166, NULL, NULL, 111153),
(111154, '3.80.10.10-FF-001695', NULL, 'Leucine rich repeats and death domain containing 1', 295, NULL, NULL, 111154),
(111155, '3.40.50.300-FF-002583', NULL, 'ATP-dependent DNA helicase fml1', 168, NULL, NULL, 111155),
(111156, '3.40.50.720-FF-000348', NULL, '3-ketoacyl-ACP reductase', 234, NULL, NULL, 111156),
(111157, '3.30.420.100-FF-000029', NULL, 'Uncharacterized protein', 96, NULL, NULL, 111157),
(111158, '3.40.190.80-FF-000093', NULL, 'Fructose-bisphosphatase 1', 77, NULL, NULL, 111158),
(111159, '2.10.25.10-FF-000666', NULL, 'nidogen-1', 38, NULL, NULL, 111159),
(111160, '1.25.40.20-FF-000960', NULL, 'YALI0E26081p', 69, NULL, NULL, 111160),
(111161, '2.30.29.30-FF-000950', NULL, 'Uncharacterized protein', 117, NULL, NULL, 111161),
(111162, '1.25.40.10-FF-000715', NULL, 'Pentatricopeptide repeat-containing protein', 233, NULL, NULL, 111162),
(111163, '1.20.200.10-FF-000029', NULL, 'Uncharacterized protein', 47, NULL, NULL, 111163),
(111164, '3.40.630.30-FF-000584', NULL, 'Uncharacterized protein', 92, NULL, NULL, 111164),
(111165, '1.20.58.60-FF-000039', NULL, 'Short stop, isoform N', 107, NULL, NULL, 111165),
(111166, '2.60.120.330-FF-000119', NULL, 'Uncharacterized protein', 341, NULL, NULL, 111166),
(111167, '3.40.1380.10-FF-000001', NULL, 'ATP synthase gamma chain', 220, NULL, NULL, 111167),
(111168, '1.25.10.10-FF-003237', NULL, 'GTOR', 577, NULL, NULL, 111168),
(111169, '2.30.39.10-FF-000057', NULL, 'Angiotensinogen', 154, NULL, NULL, 111169),
(111170, '1.10.1520.10-FF-000072', NULL, 'Secreted protein, putative', 172, NULL, NULL, 111170),
(111171, '2.130.10.10-FF-003089', NULL, 'Uncharacterized protein', 86, NULL, NULL, 111171),
(111172, '2.60.40.10-FF-004510', NULL, NULL, 100, NULL, NULL, 111172),
(111173, '3.40.50.300-FF-008035', NULL, 'Uncharacterized protein', 135, NULL, NULL, 111173),
(111174, '3.40.190.10-FF-000706', NULL, 'ABC transporter, periplasmic substrate-binding protein, putative', 110, NULL, NULL, 111174),
(111175, '2.60.530.10-FF-000002', NULL, 'Oncofetal antigen', 227, NULL, NULL, 111175),
(111176, '3.30.160.20-FF-000232', NULL, 'Predicted protein', 64, NULL, NULL, 111176),
(111177, '3.30.200.20-FF-001416', NULL, 'Serine/threonine-protein kinase stt7, chloroplastic', 116, NULL, NULL, 111177),
(111178, '3.40.50.1360-FF-000050', NULL, 'Glucosamine-6-phosphate isomerase', 261, NULL, NULL, 111178),
(111179, '3.30.160.60-FF-004903', NULL, NULL, 77, NULL, NULL, 111179);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(111180, '3.10.20.90-FF-000553', NULL, 'Conserved helix-loop-helix ubiquitous kinase', 86, NULL, NULL, 111180),
(111181, '1.10.10.10-FF-002040', NULL, 'Lactamase beta 2', 69, NULL, NULL, 111181),
(111182, '1.10.1030.10-FF-000017', NULL, 'Carbamoyl-phosphate synthase large chain, N-terminal section', 137, NULL, NULL, 111182),
(111183, '3.40.50.300-FF-006854', NULL, 'Sll5042 protein', 259, NULL, NULL, 111183),
(111184, '2.70.150.10-FF-000111', NULL, 'Calcium-transporting ATPase', 161, NULL, NULL, 111184),
(111185, '1.25.40.470-FF-000051', NULL, 'IntraFlagellar Transport Associated', 136, NULL, NULL, 111185),
(111186, '3.40.50.2300-FF-000130', NULL, 'Lactose operon repressor', 113, NULL, NULL, 111186),
(111187, '1.10.510.10-FF-000179', NULL, 'MAP kinase-activated protein kinase 5 isoform X1', 204, NULL, NULL, 111187),
(111188, '1.20.1070.10-FF-000068', NULL, 'Smoothened, frizzled class receptor', 364, NULL, NULL, 111188),
(111189, '1.10.530.10-FF-000034', NULL, 'Peptidoglycan transglycosylase gp16', 148, NULL, NULL, 111189),
(111190, '2.60.40.150-FF-000764', NULL, 'Predicted protein', 129, NULL, NULL, 111190),
(111191, '3.40.50.12780-FF-000159', NULL, 'NRPS-like enzyme, putative', 158, NULL, NULL, 111191),
(111192, '3.40.50.1820-FF-000053', NULL, 'Abhydrolase domain containing 2', 309, NULL, NULL, 111192),
(111193, '2.20.100.10-FF-000046', NULL, 'Cellular communication network factor 4', 65, NULL, NULL, 111193),
(111194, '1.25.40.180-FF-000121', NULL, 'Eukaryotic Initiation Factor', 179, NULL, NULL, 111194),
(111195, '2.40.70.10-FF-000522', NULL, NULL, 46, NULL, NULL, 111195),
(111196, '3.40.50.10590-FF-000002', NULL, 'Aminopeptidase, putative', 197, NULL, NULL, 111196),
(111197, '3.40.50.620-FF-000144', NULL, 'Tryptophan--tRNA ligase', 221, NULL, NULL, 111197),
(111198, '3.80.10.10-FF-002712', NULL, 'Os06g0557700 protein', 112, NULL, NULL, 111198),
(111199, '3.30.160.60-FF-001380', NULL, 'Zinc finger protein 571', 30, NULL, NULL, 111199),
(111200, '3.60.10.10-FF-000285', NULL, 'inositol polyphosphate 5-phosphatase K isoform X2', 128, NULL, NULL, 111200),
(111201, '3.10.430.100-FF-000002', NULL, '50S ribosomal protein L9', 89, NULL, NULL, 111201),
(111202, '1.10.506.10-FF-000017', NULL, 'Neurofibromin 1', 44, NULL, NULL, 111202),
(111203, '3.30.710.10-FF-000244', NULL, 'Bath-43', 123, NULL, NULL, 111203),
(111204, '3.40.50.10330-FF-000008', NULL, 'Probable lipid kinase YegS', 126, NULL, NULL, 111204),
(111205, '2.130.10.10-FF-002869', NULL, 'RNA processing-related protein, putative', 85, NULL, NULL, 111205),
(111206, '4.10.400.10-FF-000058', NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein', 40, NULL, NULL, 111206),
(111207, '1.10.287.70-FF-000441', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 79, NULL, NULL, 111207),
(111208, '3.40.50.1820-FF-001161', NULL, 'Carboxypeptidase', 235, NULL, NULL, 111208),
(111209, '1.25.40.630-FF-000008', NULL, NULL, 73, NULL, NULL, 111209),
(111210, '1.10.10.1320-FF-000006', NULL, 'Anti-sigma-K factor RskA', 67, NULL, NULL, 111210),
(111211, '1.10.10.2670-FF-000018', NULL, 'ELL transcription elongation factor homolog', 99, NULL, NULL, 111211),
(111212, '3.30.70.1430-FF-000012', NULL, 'Putative multidrug resistance protein', 91, NULL, NULL, 111212),
(111213, '3.10.50.40-FF-000063', NULL, 'Peptidylprolyl isomerase', 127, NULL, NULL, 111213),
(111214, '1.20.58.60-FF-000186', NULL, 'nesprin-1 isoform X3', 315, NULL, NULL, 111214),
(111215, '3.90.15.10-FF-000002', NULL, 'DNA topoisomerase I', 199, NULL, NULL, 111215),
(111216, '2.130.10.10-FF-000924', NULL, 'Dynein intermediate chain 3', 162, NULL, NULL, 111216),
(111217, '2.60.120.430-FF-000003', NULL, 'FERONIA receptor-like kinase', 161, NULL, NULL, 111217),
(111218, '3.30.200.20-FF-001563', NULL, NULL, 95, NULL, NULL, 111218),
(111219, '1.10.1040.10-FF-000046', NULL, 'Ketose-bisphosphate aldolase class-II family protein', 129, NULL, NULL, 111219),
(111220, '3.30.160.60-FF-002958', NULL, NULL, 28, NULL, NULL, 111220),
(111221, '2.20.110.10-FF-000075', NULL, NULL, 46, NULL, NULL, 111221);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(111222, '2.60.40.10-FF-002745', NULL, 'Protein sidekick-like Protein', 97, NULL, NULL, 111222),
(111223, '2.30.180.10-FF-000116', NULL, NULL, 135, NULL, NULL, 111223),
(111224, '3.10.20.90-FF-000497', NULL, 'UV excision repair RAD23-like protein', 89, NULL, NULL, 111224),
(111225, '3.40.50.2020-FF-000080', NULL, 'Ribose-phosphate pyrophosphokinase', 107, NULL, NULL, 111225),
(111226, '1.10.510.10-FF-001871', NULL, 'Probable kinase CHARK', 202, NULL, NULL, 111226),
(111227, '2.130.10.10-FF-003330', NULL, 'WD domain, G-beta repeat, putative', 70, NULL, NULL, 111227),
(111228, '2.40.30.170-FF-000020', NULL, 'Membrane fusion protein (MFP) family protein', 122, NULL, NULL, 111228),
(111229, '3.90.660.10-FF-000057', NULL, 'Spermine oxidase', 205, NULL, NULL, 111229),
(111230, '3.30.70.1730-FF-000040', NULL, '39S ribosomal protein L10, mitochondrial', 167, NULL, NULL, 111230),
(111231, '1.10.10.60-FF-000205', NULL, 'Transcriptional regulator, AraC family', 57, NULL, NULL, 111231),
(111232, '3.20.20.10-FF-000046', NULL, 'Arginine decarboxylase', 279, NULL, NULL, 111232),
(111233, '3.60.20.10-FF-000111', NULL, 'Proteasome subunit beta', 197, NULL, NULL, 111233),
(111234, '3.80.10.10-FF-001223', NULL, 'Leucine-rich repeat extensin-like protein 1', 139, NULL, NULL, 111234),
(111235, '3.30.559.10-FF-000054', NULL, 'Transferase family protein', 216, NULL, NULL, 111235),
(111236, '1.25.40.10-FF-001120', NULL, 'Sel1 repeat family protein', 172, NULL, NULL, 111236),
(111237, '3.40.20.10-FF-000152', NULL, 'Uncharacterized protein', 61, NULL, NULL, 111237),
(111238, '3.40.50.1010-FF-000288', NULL, NULL, 175, NULL, NULL, 111238),
(111239, '1.10.287.70-FF-000238', NULL, 'Potassium intermediate/small conductance calcium-activated channel, subfamily N, member 4', 94, NULL, NULL, 111239),
(111240, '3.40.50.10470-FF-000056', NULL, 'Uncharacterized protein', 176, NULL, NULL, 111240),
(111241, '2.60.120.200-FF-000463', NULL, 'AGAP004993-PA', 170, NULL, NULL, 111241),
(111242, '1.10.10.60-FF-000913', NULL, NULL, 78, NULL, NULL, 111242),
(111243, '3.40.50.740-FF-000034', NULL, 'NADH Ubiquinone Oxidoreductase', 146, NULL, NULL, 111243),
(111244, '3.30.460.10-FF-000174', NULL, 'DNA polymerase', 76, NULL, NULL, 111244),
(111245, '3.30.160.60-FF-004139', NULL, NULL, 20, NULL, NULL, 111245),
(111246, '2.130.10.10-FF-004634', NULL, 'Uncharacterized protein', 195, NULL, NULL, 111246),
(111247, '1.20.1070.10-FF-000776', NULL, 'Predicted protein', 226, NULL, NULL, 111247),
(111248, '3.40.50.1820-FF-001014', NULL, 'GPI inositol-deacylase', 211, NULL, NULL, 111248),
(111249, '1.10.510.10-FF-000943', NULL, 'testis-specific serine/threonine-protein kinase 1', 296, NULL, NULL, 111249),
(111250, '1.20.1250.40-FF-000029', NULL, 'RNA polymerase Rpb4-domain-containing protein', 136, NULL, NULL, 111250),
(111251, '2.60.40.10-FF-000800', NULL, 'Cardiac titin', 95, NULL, NULL, 111251),
(111252, '3.40.50.10890-FF-000007', NULL, 'Cleavage and polyadenylation specificity factor, 73 kDa subunit', 179, NULL, NULL, 111252),
(111253, '2.40.150.20-FF-000008', NULL, '60S ribosomal protein L23', 139, NULL, NULL, 111253),
(111254, '1.20.1420.30-FF-000096', NULL, 'Uncharacterized protein', 219, NULL, NULL, 111254),
(111255, '1.10.510.10-FF-003293', NULL, NULL, 90, NULL, NULL, 111255),
(111256, '3.80.10.10-FF-000059', NULL, 'Chondroadherin like', 337, NULL, NULL, 111256),
(111257, '3.40.50.11660-FF-000014', NULL, 'Uncharacterized protein', 201, NULL, NULL, 111257),
(111258, '2.40.33.10-FF-000021', NULL, 'Pyruvate kinase', 103, NULL, NULL, 111258),
(111259, '1.10.3210.10-FF-000026', NULL, 'Metal-dependent phosphohydrolase', 258, NULL, NULL, 111259),
(111260, '3.30.70.1000-FF-000001', NULL, NULL, 146, NULL, NULL, 111260),
(111261, '1.20.1250.20-FF-001131', NULL, 'Major facilitator superfamily transporter', 211, NULL, NULL, 111261),
(111262, '3.30.70.1990-FF-000011', NULL, NULL, 16, NULL, NULL, 111262),
(111263, '2.60.40.1670-FF-000015', NULL, 'Protein transport protein SEC23', 156, NULL, NULL, 111263),
(111264, '2.60.450.10-FF-000001', NULL, 'Lipopolysaccharide export system protein LptC', 133, NULL, NULL, 111264);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(111265, '3.20.20.80-FF-000499', NULL, 'Beta-glucosidase 11', 166, NULL, NULL, 111265),
(111266, '1.20.1070.10-FF-002013', NULL, 'Uncharacterized protein', 138, NULL, NULL, 111266),
(111267, '1.25.10.10-FF-000511', NULL, 'synembryn-A isoform X1', 284, NULL, NULL, 111267),
(111268, '1.10.720.30-FF-000055', NULL, 'X-ray repair cross-complementing protein 5', 50, NULL, NULL, 111268),
(111269, '3.30.460.10-FF-000207', NULL, 'Predicted protein', 144, NULL, NULL, 111269),
(111270, '1.10.238.10-FF-000315', NULL, 'Ubiquitin carboxyl-terminal hydrolase MINDY-3', 68, NULL, NULL, 111270),
(111271, '3.30.40.10-FF-001957', NULL, 'Uncharacterized protein', 65, NULL, NULL, 111271),
(111272, '3.40.50.1820-FF-001722', NULL, 'Uncharacterized protein', 120, NULL, NULL, 111272),
(111273, '1.20.5.1190-FF-000010', NULL, 'Sodium channel protein', 46, NULL, NULL, 111273),
(111274, '3.90.79.10-FF-000127', NULL, 'Phosphohydrolase (MutT/nudix family protein)', 184, NULL, NULL, 111274),
(111275, '1.10.238.10-FF-001243', NULL, 'S100 calcium-binding protein', 89, NULL, NULL, 111275),
(111276, '3.30.750.24-FF-000052', NULL, 'Uncharacterized protein, isoform B', 140, NULL, NULL, 111276),
(111277, '3.30.40.10-FF-001249', NULL, 'Zinc finger protein', 55, NULL, NULL, 111277),
(111278, '2.40.170.20-FF-000010', NULL, 'TonB-linked outer membrane protein, SusC/RagA family', 561, NULL, NULL, 111278),
(111279, '3.30.160.60-FF-005123', NULL, NULL, 30, NULL, NULL, 111279),
(111280, '2.130.10.10-FF-003706', NULL, 'Transcription initiation factor TFIID subunit', 117, NULL, NULL, 111280),
(111281, '3.40.1110.10-FF-000302', NULL, 'Plasma membrane calcium-transporting ATPase 2', 277, NULL, NULL, 111281),
(111282, '1.20.1080.10-FF-000041', NULL, 'Aquaglyceroporin 2', 242, NULL, NULL, 111282),
(111283, '3.80.10.10-FF-000391', NULL, 'Protein toll', 177, NULL, NULL, 111283),
(111284, '3.90.660.10-FF-000113', NULL, NULL, 149, NULL, NULL, 111284),
(111285, '3.30.572.10-FF-000023', NULL, 'Thymidylate synthase', 143, NULL, NULL, 111285),
(111286, '2.30.30.40-FF-000349', NULL, 'N-acetylmuramoyl-L-alanine amidase', 72, NULL, NULL, 111286),
(111287, '3.90.550.10-FF-000431', NULL, 'Exostosin-2, putative', 247, NULL, NULL, 111287),
(111288, '3.90.70.10-FF-000282', NULL, 'Calpain-C', 139, NULL, NULL, 111288),
(111289, '3.90.640.10-FF-000258', NULL, 'Actin-related protein 2', 112, NULL, NULL, 111289),
(111290, '3.30.160.60-FF-003178', NULL, NULL, 30, NULL, NULL, 111290),
(111291, '3.40.50.1970-FF-000047', NULL, 'Phosphoribosylamidoimidazole-succinocarboxamide synthase, putative', 159, NULL, NULL, 111291),
(111292, '3.80.10.10-FF-000767', NULL, 'F-box/LRR-repeat protein 15', 95, NULL, NULL, 111292),
(111293, '1.10.287.110-FF-000335', NULL, 'Chaperone DnaJ-domain superfamily protein', 79, NULL, NULL, 111293),
(111294, '3.30.160.60-FF-000452', NULL, 'Transcription factor Ovo-like 2', 80, NULL, NULL, 111294),
(111295, '3.40.50.450-FF-000071', NULL, 'Nucleoside 2-deoxyribosyltransferase family protein', 145, NULL, NULL, 111295),
(111296, '3.30.450.50-FF-000022', NULL, 'Vesicle-associated membrane protein', 121, NULL, NULL, 111296),
(111297, '3.30.70.80-FF-000041', NULL, 'Subtilisin-like protease', 69, NULL, NULL, 111297),
(111298, '2.30.30.560-FF-000004', NULL, 'Major vault protein, putative', 59, NULL, NULL, 111298),
(111299, '1.20.5.110-FF-000205', NULL, 'Syntaxin 18', 101, NULL, NULL, 111299),
(111300, '2.10.25.10-FF-000722', NULL, 'Protein eyes shut homolog', 42, NULL, NULL, 111300),
(111301, '3.40.1190.20-FF-000231', NULL, NULL, 308, NULL, NULL, 111301),
(111302, '3.30.780.10-FF-000046', NULL, 'Density-regulated protein homolog', 92, NULL, NULL, 111302),
(111303, '3.40.50.300-FF-007782', NULL, 'Uncharacterized protein', 52, NULL, NULL, 111303),
(111304, '3.30.160.60-FF-005831', NULL, NULL, 32, NULL, NULL, 111304),
(111305, '1.10.510.10-FF-001904', NULL, 'Uncharacterized protein', 100, NULL, NULL, 111305),
(111306, '3.10.450.50-FF-000032', NULL, 'Nuclear transport factor 2', 120, NULL, NULL, 111306),
(111307, '3.40.50.200-FF-000046', NULL, 'Subtilisin-like protease 3, putative', 306, NULL, NULL, 111307);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(111308, '1.10.238.10-FF-000990', NULL, 'Calpain 9', 150, NULL, NULL, 111308),
(111309, '1.10.3430.10-FF-000065', NULL, 'Uncharacterized protein', 73, NULL, NULL, 111309),
(111310, '1.25.40.20-FF-001180', NULL, 'Ankyrin repeat protein, putative', 77, NULL, NULL, 111310),
(111311, '3.90.1170.40-FF-000011', NULL, 'MoaD family protein', 143, NULL, NULL, 111311),
(111312, '3.40.20.10-FF-000005', NULL, 'Gelsolin', 125, NULL, NULL, 111312),
(111313, '3.30.200.20-FF-000635', NULL, 'Wall-associated receptor kinase 3', 104, NULL, NULL, 111313),
(111314, '1.10.287.70-FF-000385', NULL, 'Voltage-gated sodium channel alpha subunit isoform 2', 122, NULL, NULL, 111314),
(111315, '1.20.1070.10-FF-001737', NULL, 'Uncharacterized protein', 89, NULL, NULL, 111315),
(111316, '2.10.25.10-FF-001122', NULL, 'Os10g0174548 protein', 41, NULL, NULL, 111316),
(111317, '1.25.40.10-FF-004554', NULL, 'Uncharacterized protein', 213, NULL, NULL, 111317),
(111318, '3.30.710.10-FF-000188', NULL, 'Si:rp71-39b20.4', 134, NULL, NULL, 111318),
(111319, '1.50.10.20-FF-000068', NULL, 'Protein farnesyltransferase subunit beta', 370, NULL, NULL, 111319),
(111320, '1.50.10.10-FF-000155', NULL, 'alpha-1,2-Mannosidase', 136, NULL, NULL, 111320),
(111321, '1.25.40.10-FF-004369', NULL, 'Uncharacterized protein', 151, NULL, NULL, 111321),
(111322, '2.60.120.200-FF-000316', NULL, 'Beta-porphyranase A', 269, NULL, NULL, 111322),
(111323, '2.60.40.10-FF-003673', NULL, NULL, 100, NULL, NULL, 111323),
(111324, '3.40.50.620-FF-000672', NULL, 'Uncharacterized protein', 140, NULL, NULL, 111324),
(111325, '3.40.50.1110-FF-000172', NULL, 'Predicted protein', 67, NULL, NULL, 111325),
(111326, '1.25.40.20-FF-001741', NULL, 'Kinase, NEK', 213, NULL, NULL, 111326),
(111327, '2.20.100.10-FF-000102', NULL, 'Complement component C6', 49, NULL, NULL, 111327),
(111328, '1.10.510.10-FF-003669', NULL, NULL, 176, NULL, NULL, 111328),
(111329, '1.10.8.430-FF-000005', NULL, 'Blast resistance protein Pi-ta variant 9', 88, NULL, NULL, 111329),
(111330, '2.40.70.10-FF-000466', NULL, NULL, 169, NULL, NULL, 111330),
(111331, '2.20.25.80-FF-000001', NULL, 'WRKY transcription factor 33', 67, NULL, NULL, 111331),
(111332, '3.30.40.10-FF-001581', NULL, 'E3 ubiquitin-protein ligase RNF12-B', 87, NULL, NULL, 111332),
(111333, '3.40.50.2300-FF-000506', NULL, 'Arsenic-transport integral membrane protein ARSC', 132, NULL, NULL, 111333),
(111334, '1.20.1070.10-FF-001029', NULL, 'Uncharacterized protein', 293, NULL, NULL, 111334),
(111335, '3.30.160.60-FF-003886', NULL, 'Zinc finger protein 532, isoform CRA_a', 95, NULL, NULL, 111335),
(111336, '1.20.1050.60-FF-000003', NULL, 'Alpha-1,2-mannosidase family protein', 97, NULL, NULL, 111336),
(111337, '3.40.570.10-FF-000039', NULL, 'Uncharacterized protein', 173, NULL, NULL, 111337),
(111338, '3.40.50.300-FF-006798', NULL, 'Predicted protein', 54, NULL, NULL, 111338),
(111339, '3.40.50.1240-FF-000008', NULL, 'Ubiquitin associated and SH3 domain containing B', 265, NULL, NULL, 111339),
(111340, '3.90.180.10-FF-000178', NULL, 'Sorbitol dehydrogenase', 96, NULL, NULL, 111340),
(111341, '1.25.40.10-FF-000659', NULL, 'AGAP002752-PA-like protein', 353, NULL, NULL, 111341),
(111342, '1.25.40.20-FF-000196', NULL, 'Retinoic acid induced 14', 113, NULL, NULL, 111342),
(111343, '3.40.50.1010-FF-000136', NULL, 'DNA-repair protein, putative', 179, NULL, NULL, 111343),
(111344, '3.30.160.60-FF-001121', NULL, 'zinc finger protein 3 homolog', 29, NULL, NULL, 111344),
(111345, '1.20.1250.10-FF-000054', NULL, 'Prolactin 2', 200, NULL, NULL, 111345),
(111346, '2.130.10.10-FF-002217', NULL, 'Ddb1 and cul4-associated factor 11', 174, NULL, NULL, 111346),
(111347, '3.40.50.460-FF-000017', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase', 125, NULL, NULL, 111347),
(111348, '3.40.50.300-FF-003128', NULL, 'Rad25/xp-B DNA repair helicase', 233, NULL, NULL, 111348),
(111349, '2.60.40.10-FF-001576', NULL, 'Receptor protein-tyrosine kinase', 97, NULL, NULL, 111349),
(111350, '2.130.10.10-FF-002689', NULL, 'AGAP000480-PA', 333, NULL, NULL, 111350);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(111351, '1.25.40.10-FF-002020', NULL, 'Pentatricopeptide repeat-containing protein At2g31400, chloroplastic', 105, NULL, NULL, 111351),
(111352, '1.20.5.170-FF-000301', NULL, 'Tropomyosin 3', 43, NULL, NULL, 111352),
(111353, '1.10.10.60-FF-000649', NULL, 'C. Elegans Homeobox', 63, NULL, NULL, 111353),
(111354, '1.10.268.10-FF-000019', NULL, 'DNA topoisomerase 2', 166, NULL, NULL, 111354),
(111355, '3.40.50.2000-FF-000450', NULL, 'Glycosyl transferase group 1', 168, NULL, NULL, 111355),
(111356, '3.40.367.20-FF-000013', NULL, 'Glucokinase', 201, NULL, NULL, 111356),
(111357, '2.160.20.10-FF-000266', NULL, 'Uncharacterized protein', 81, NULL, NULL, 111357),
(111358, '3.40.50.620-FF-000852', NULL, 'Probable isoleucine--tRNA ligase, mitochondrial', 239, NULL, NULL, 111358),
(111359, '4.10.400.10-FF-000322', NULL, 'sortilin-related receptor-like', 41, NULL, NULL, 111359),
(111360, '1.10.3460.10-FF-000005', NULL, 'Chlorophyll a-b binding protein, chloroplastic', 188, NULL, NULL, 111360),
(111361, '2.10.25.10-FF-000161', NULL, 'Signal peptide, CUB domain and EGF-like domain-containing 3', 43, NULL, NULL, 111361),
(111362, '1.20.120.1900-FF-000068', NULL, 'Spindle pole body component', 354, NULL, NULL, 111362),
(111363, '3.30.450.20-FF-000507', NULL, 'Sensor protein, DUF3365, HAMP and PAS domain-containing, heme-binding', 115, NULL, NULL, 111363),
(111364, '2.40.290.10-FF-000044', NULL, 'ABL117Cp', 197, NULL, NULL, 111364),
(111365, '3.40.50.1820-FF-000845', NULL, 'Carboxypeptidase', 170, NULL, NULL, 111365),
(111366, '2.40.10.10-FF-000569', NULL, NULL, 64, NULL, NULL, 111366),
(111367, '3.40.1090.10-FF-000069', NULL, 'Lysophospholipase', 438, NULL, NULL, 111367),
(111368, '3.30.160.60-FF-005336', NULL, NULL, 29, NULL, NULL, 111368),
(111369, '3.30.420.40-FF-000949', NULL, 'Uncharacterized protein', 69, NULL, NULL, 111369),
(111370, '1.10.287.100-FF-000006', NULL, 'Uncharacterized protein', 34, NULL, NULL, 111370),
(111371, '3.30.70.330-FF-003048', NULL, NULL, 114, NULL, NULL, 111371),
(111372, '1.10.287.540-FF-000003', NULL, 'Calreticulin', 42, NULL, NULL, 111372),
(111373, '1.10.30.10-FF-000158', NULL, 'HMG box family protein', 67, NULL, NULL, 111373),
(111374, '3.20.20.60-FF-000100', NULL, 'Malate synthase', 272, NULL, NULL, 111374),
(111375, '1.20.5.520-FF-000002', NULL, 'Thymosin beta', 25, NULL, NULL, 111375),
(111376, '3.40.47.10-FF-000078', NULL, 'Acetyl-CoA acetyltransferase FadA5', 211, NULL, NULL, 111376),
(111377, '3.40.50.620-FF-000413', NULL, 'Two-component sensor KdpD', 133, NULL, NULL, 111377),
(111378, '2.40.50.40-FF-000058', NULL, 'Protein SAWADEE HOMEODOMAIN HOMOLOG 1', 62, NULL, NULL, 111378),
(111379, '2.60.40.1450-FF-000005', NULL, 'Uncharacterized protein', 130, NULL, NULL, 111379),
(111380, '2.40.70.10-FF-000106', NULL, 'Plasmepsin VII', 170, NULL, NULL, 111380),
(111381, '3.40.50.300-FF-000374', NULL, 'ATP-dependent RNA helicase DeaD', 220, NULL, NULL, 111381),
(111382, '3.30.420.380-FF-000006', NULL, 'General secretion pathway protein L', 148, NULL, NULL, 111382),
(111383, '3.30.710.10-FF-000328', NULL, 'BTB domain containing 6', 71, NULL, NULL, 111383),
(111384, '3.30.200.20-FF-001304', NULL, 'Predicted protein', 112, NULL, NULL, 111384),
(111385, '1.20.120.140-FF-000016', NULL, 'Signal recognition particle receptor subunit alpha', 124, NULL, NULL, 111385),
(111386, '1.20.930.40-FF-000021', NULL, 'Peptidase', 159, NULL, NULL, 111386),
(111387, '2.130.10.10-FF-001228', NULL, 'Predicted protein', 256, NULL, NULL, 111387),
(111388, '2.60.120.290-FF-000186', NULL, 'Metalloendopeptidase', 115, NULL, NULL, 111388),
(111389, '3.90.550.10-FF-000583', NULL, 'Galactosylgalactosylxylosylprotein 3-beta-glucuronosyltransferase', 241, NULL, NULL, 111389),
(111390, '3.40.50.720-FF-002181', NULL, 'Uncharacterized protein', 56, NULL, NULL, 111390),
(111391, '1.25.40.10-FF-000507', NULL, 'Pentatricopeptide repeat-containing protein', 165, NULL, NULL, 111391),
(111392, '1.10.3380.10-FF-000004', NULL, 'U5 small nuclear ribonucleoprotein 200 kDa helicase', 136, NULL, NULL, 111392),
(111393, '2.10.25.10-FF-000902', NULL, 'AGAP000117-PA', 39, NULL, NULL, 111393);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(111394, '1.10.532.10-FF-000016', NULL, 'Signal transducer and activator of transcription', 84, NULL, NULL, 111394),
(111395, '1.10.8.60-FF-000221', NULL, 'Replication factor C subunit 1', 68, NULL, NULL, 111395),
(111396, '3.30.420.40-FF-001034', NULL, 'Uncharacterized protein', 27, NULL, NULL, 111396),
(111397, '1.20.1310.10-FF-000104', NULL, NULL, 115, NULL, NULL, 111397),
(111398, '3.40.50.11850-FF-000009', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase', 51, NULL, NULL, 111398),
(111399, '1.10.246.190-FF-000007', NULL, 'Autophagy protein 5', 59, NULL, NULL, 111399),
(111400, '2.130.10.10-FF-005983', NULL, 'Uncharacterized protein', 231, NULL, NULL, 111400),
(111401, '3.40.50.300-FF-008030', NULL, 'Uncharacterized protein', 137, NULL, NULL, 111401),
(111402, '1.10.167.10-FF-000032', NULL, 'RSG7', 153, NULL, NULL, 111402),
(111403, '3.40.20.10-FF-000157', NULL, 'Glia maturation factor', 99, NULL, NULL, 111403),
(111404, '1.20.1070.10-FF-001849', NULL, 'Uncharacterized protein', 299, NULL, NULL, 111404),
(111405, '3.30.60.190-FF-000002', NULL, 'Zinc finger HIT domain-containing protein 3', 49, NULL, NULL, 111405),
(111406, '3.40.525.10-FF-000064', NULL, 'Uncharacterized protein', 212, NULL, NULL, 111406),
(111407, '1.25.10.10-FF-001787', NULL, 'Protein phosphatase 4, regulatory subunit 4', 598, NULL, NULL, 111407),
(111408, '1.20.1050.10-FF-000005', NULL, 'Glutathione S-transferase A1', 109, NULL, NULL, 111408),
(111409, '3.30.2350.10-FF-000069', NULL, 'H/ACA ribonucleoprotein complex subunit DKC1', 30, NULL, NULL, 111409),
(111410, '1.20.120.350-FF-000080', NULL, 'Polycystic kidney disease 2', 150, NULL, NULL, 111410),
(111411, '1.10.460.10-FF-000039', NULL, 'Uncharacterized protein', 17, NULL, NULL, 111411),
(111412, '3.40.1090.10-FF-000018', NULL, 'Lysophospholipase NTE1', 90, NULL, NULL, 111412),
(111413, '3.30.260.10-FF-000107', NULL, NULL, 36, NULL, NULL, 111413),
(111414, '3.30.540.10-FF-000096', NULL, 'Inositol polyphosphate-1-phosphatase, putative', 171, NULL, NULL, 111414),
(111415, '1.20.1250.20-FF-001743', NULL, 'Uncharacterized protein', 282, NULL, NULL, 111415),
(111416, '1.10.287.950-FF-000036', NULL, 'Membrane-anchored chemotaxis sensory transducer', 299, NULL, NULL, 111416),
(111417, '3.40.1110.10-FF-000162', NULL, 'Phospholipid-transporting ATPase', 28, NULL, NULL, 111417),
(111418, '3.90.470.40-FF-000006', NULL, 'Uncharacterized protein', 140, NULL, NULL, 111418),
(111419, '1.20.144.10-FF-000022', NULL, 'Phospholipid phosphatase 5', 236, NULL, NULL, 111419),
(111420, '4.10.280.10-FF-000233', NULL, 'Uncharacterized protein', 91, NULL, NULL, 111420),
(111421, '1.50.10.20-FF-000124', NULL, 'Geranylgeranyl transferase type II beta subunit, putative', 91, NULL, NULL, 111421),
(111422, '2.40.10.10-FF-000518', NULL, NULL, 44, NULL, NULL, 111422),
(111423, '2.30.30.140-FF-000002', NULL, 'Fragile X mental retardation 1, isoform CRA_e', 50, NULL, NULL, 111423),
(111424, '2.30.230.10-FF-000025', NULL, 'Hemolymph clottable protein', 279, NULL, NULL, 111424),
(111425, '2.60.40.10-FF-001964', NULL, 'Cilia and flagella associated protein 65', 108, NULL, NULL, 111425),
(111426, '3.40.50.620-FF-000464', NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', 304, NULL, NULL, 111426),
(111427, '1.10.510.10-FF-000443', NULL, 'Testis-specific serine/threonine-protein kinase 2', 332, NULL, NULL, 111427),
(111428, '1.10.10.60-FF-001217', NULL, NULL, 79, NULL, NULL, 111428),
(111429, '2.40.50.40-FF-000007', NULL, 'Chromobox protein homolog 1', 81, NULL, NULL, 111429),
(111430, '3.30.40.10-FF-000361', NULL, 'Tripartite motif-containing protein 26', 85, NULL, NULL, 111430),
(111431, '3.50.4.10-FF-000008', NULL, 'No-mechanoreceptor potential A long isoform', 77, NULL, NULL, 111431),
(111432, '1.20.58.190-FF-000015', NULL, NULL, 110, NULL, NULL, 111432),
(111433, '2.60.40.60-FF-001107', NULL, 'Uncharacterized protein', 96, NULL, NULL, 111433),
(111434, '1.20.1250.20-FF-000383', NULL, 'Blast:Monocarboxylate transporter 13', 232, NULL, NULL, 111434),
(111435, '3.30.160.60-FF-003358', NULL, 'Zinc finger protein 1164', 29, NULL, NULL, 111435);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(111436, '3.30.470.20-FF-000250', NULL, 'Uncharacterized protein', 39, NULL, NULL, 111436),
(111437, '3.30.70.330-FF-001603', NULL, NULL, 81, NULL, NULL, 111437),
(111438, '2.130.10.10-FF-005562', NULL, 'Predicted protein', 217, NULL, NULL, 111438),
(111439, '2.60.120.590-FF-000006', NULL, 'AlkB homolog 1, histone H2A dioxygenase', 200, NULL, NULL, 111439),
(111440, '4.10.410.10-FF-000087', NULL, 'Serine peptidase inhibitor, Kunitz type, 2', 68, NULL, NULL, 111440),
(111441, '3.60.140.10-FF-000013', NULL, 'Polyphenol oxidase', 266, NULL, NULL, 111441),
(111442, '1.10.10.1050-FF-000021', NULL, 'Uncharacterized protein', 78, NULL, NULL, 111442),
(111443, '2.40.50.150-FF-000046', NULL, 'Uncharacterized protein', 70, NULL, NULL, 111443),
(111444, '1.50.40.10-FF-000415', NULL, 'Uncharacterized protein', 202, NULL, NULL, 111444),
(111445, '3.40.30.10-FF-000894', NULL, 'Predicted protein', 128, NULL, NULL, 111445),
(111446, '3.40.50.10420-FF-000030', NULL, '5-formyltetrahydrofolate cyclo-ligase', 178, NULL, NULL, 111446),
(111447, '3.50.4.10-FF-000059', NULL, NULL, 44, NULL, NULL, 111447),
(111448, '1.20.1420.30-FF-000040', NULL, 'Probable sodium/calcium exchanger antiporter', 156, NULL, NULL, 111448),
(111449, '2.40.50.140-FF-000509', NULL, 'DNA-directed RNA polymerases I, II, and III subunit RPABC3', 146, NULL, NULL, 111449),
(111450, '3.90.70.80-FF-000055', NULL, 'OTU domain-containing protein 3', 144, NULL, NULL, 111450),
(111451, '3.40.50.300-FF-006113', NULL, 'ABC transporter, putative', 177, NULL, NULL, 111451),
(111452, '3.30.40.10-FF-002177', NULL, 'Ci-Neuralized-b protein', 81, NULL, NULL, 111452),
(111453, '3.50.30.50-FF-000006', NULL, 'Putative_cyclase_-_putative', 104, NULL, NULL, 111453),
(111454, '3.40.1170.10-FF-000019', NULL, 'DNA mismatch repair protein', 157, NULL, NULL, 111454),
(111455, '1.25.40.10-FF-001064', NULL, 'Tetratricopeptide repeat-like superfamily protein', 81, NULL, NULL, 111455),
(111456, '2.60.40.10-FF-003993', NULL, NULL, 100, NULL, NULL, 111456),
(111457, '3.40.50.300-FF-001734', NULL, 'Shikimate kinase', 173, NULL, NULL, 111457),
(111458, '2.40.50.140-FF-001145', NULL, NULL, 146, NULL, NULL, 111458),
(111459, '1.20.1250.20-FF-000315', NULL, 'Glucuronide carrier protein', 204, NULL, NULL, 111459),
(111460, '1.10.287.70-FF-000362', NULL, 'Potassium channel, subfamily K, member 10', 192, NULL, NULL, 111460),
(111461, '2.30.30.100-FF-000209', NULL, 'Small nuclear ribonucleoprotein Sm D2', 88, NULL, NULL, 111461),
(111462, '3.40.190.290-FF-000125', NULL, 'LysR family transcriptional regulator', 205, NULL, NULL, 111462),
(111463, '1.10.560.10-FF-000154', NULL, 'Uncharacterized protein', 132, NULL, NULL, 111463),
(111464, '1.20.1560.10-FF-000656', NULL, 'ATP-binding cassette subfamily B member 5', 102, NULL, NULL, 111464),
(111465, '3.30.70.330-FF-001232', NULL, 'U2 snRNP auxiliary factor small subunit, putative', 107, NULL, NULL, 111465),
(111466, '3.30.460.10-FF-000095', NULL, 'RNA polymerase II, putative', 112, NULL, NULL, 111466),
(111467, '3.10.310.10-FF-000038', NULL, '2-methyl-aconitate isomerase', 194, NULL, NULL, 111467),
(111468, '2.60.120.10-FF-000067', NULL, 'Solute carrier family 9 member C1', 149, NULL, NULL, 111468),
(111469, '3.30.360.10-FF-000059', NULL, 'Oxidoreductase, Gfo/Idh/MocA family', 193, NULL, NULL, 111469),
(111470, '2.60.40.1170-FF-000079', NULL, NULL, 137, NULL, NULL, 111470),
(111471, '3.40.50.300-FF-002791', NULL, 'DEAD-box ATP-dependent RNA helicase 17', 287, NULL, NULL, 111471),
(111472, '2.30.29.30-FF-000242', NULL, 'serine/threonine-protein kinase MRCK gamma isoform X1', 118, NULL, NULL, 111472),
(111473, '2.60.120.10-FF-000128', NULL, 'Cyclic nucleotide-binding domain protein', 103, NULL, NULL, 111473),
(111474, '2.130.10.10-FF-001880', NULL, 'DDB1-and CUL4-associated factor 13', 109, NULL, NULL, 111474),
(111475, '3.40.50.720-FF-000264', NULL, '4-hydroxy-tetrahydrodipicolinate reductase 2 chloroplastic', 157, NULL, NULL, 111475),
(111476, '2.120.10.30-FF-000548', NULL, 'Glucose sorbosone dehydrogenase', 342, NULL, NULL, 111476);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(111477, '2.30.29.30-FF-001231', NULL, 'Chromosome 15, whole genome shotgun sequence', 115, NULL, NULL, 111477),
(111478, '3.90.25.10-FF-000031', NULL, 'UDP-glucose 4-epimerase', 91, NULL, NULL, 111478),
(111479, '3.40.50.300-FF-003280', NULL, 'Dynein light intermediate chain, putative', 190, NULL, NULL, 111479),
(111480, '2.60.40.420-FF-000188', NULL, 'Predicted protein', 54, NULL, NULL, 111480),
(111481, '3.40.50.300-FF-005106', NULL, 'Translocase of chloroplast 34 homolog, chloroplastic', 264, NULL, NULL, 111481),
(111482, '1.10.10.60-FF-000880', NULL, NULL, 39, NULL, NULL, 111482),
(111483, '2.40.50.1020-FF-000011', NULL, 'Two-component system response regulator', 105, NULL, NULL, 111483),
(111484, '3.10.100.10-FF-000376', NULL, NULL, 139, NULL, NULL, 111484),
(111485, '2.40.50.770-FF-000024', NULL, 'Predicted protein', 113, NULL, NULL, 111485),
(111486, '1.10.506.10-FF-000012', NULL, 'Plexin B1', 246, NULL, NULL, 111486),
(111487, '3.30.160.60-FF-001913', NULL, 'Zinc finger with KRAB and SCAN domains 4', 28, NULL, NULL, 111487),
(111488, '2.130.10.10-FF-005191', NULL, 'Uncharacterized protein', 113, NULL, NULL, 111488),
(111489, '3.30.420.10-FF-000261', NULL, '3''-5'' exonuclease, putative', 159, NULL, NULL, 111489),
(111490, '2.130.10.10-FF-000891', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', 304, NULL, NULL, 111490),
(111491, '1.10.10.1200-FF-000004', NULL, 'Melanoma-associated antigen E1', 106, NULL, NULL, 111491),
(111492, '1.10.1520.10-FF-000095', NULL, 'Predicted protein', 53, NULL, NULL, 111492),
(111493, '2.60.40.60-FF-000169', NULL, 'Cadherin 17', 101, NULL, NULL, 111493),
(111494, '3.30.710.10-FF-000480', NULL, 'Uncharacterized protein', 96, NULL, NULL, 111494),
(111495, '1.10.287.690-FF-000020', NULL, 'Uncharacterized protein', 26, NULL, NULL, 111495),
(111496, '1.20.1110.10-FF-000044', NULL, 'Phospholipid-transporting ATPase', 15, NULL, NULL, 111496),
(111497, '1.10.510.10-FF-002860', NULL, NULL, 223, NULL, NULL, 111497),
(111498, '3.30.200.20-FF-000399', NULL, 'Serine/threonine-protein kinase atg1', 90, NULL, NULL, 111498),
(111499, '1.20.120.1760-FF-000003', NULL, 'CDP-diacylglycerol--inositol 3-phosphatidyltransferase', 194, NULL, NULL, 111499),
(111500, '1.20.1270.60-FF-000250', NULL, 'Uncharacterized protein', 250, NULL, NULL, 111500),
(111501, '2.60.34.10-FF-000123', NULL, 'Uncharacterized protein', 152, NULL, NULL, 111501),
(111502, '2.60.120.200-FF-000732', NULL, 'Uncharacterized protein', 217, NULL, NULL, 111502),
(111503, '1.20.120.1780-FF-000009', NULL, 'Uncharacterized protein', 124, NULL, NULL, 111503),
(111504, '1.20.1150.12-FF-000004', NULL, 'Protein windbeutel', 112, NULL, NULL, 111504),
(111505, '3.30.470.20-FF-000149', NULL, 'Ribosomal protein S6 modification protein', 102, NULL, NULL, 111505),
(111506, '1.25.40.10-FF-002924', NULL, 'Signal recognition particle subunit SRP72', 166, NULL, NULL, 111506),
(111507, '3.30.1520.10-FF-000195', NULL, 'SH3 and PX domains 2B', 36, NULL, NULL, 111507),
(111508, '2.60.120.650-FF-000165', NULL, 'Uncharacterized protein', 208, NULL, NULL, 111508),
(111509, '3.30.200.20-FF-001355', NULL, 'Os10g0141200 protein', 106, NULL, NULL, 111509),
(111510, '2.60.40.60-FF-000669', NULL, 'Predicted protein', 110, NULL, NULL, 111510),
(111511, '3.30.160.60-FF-001172', NULL, 'Zinc finger protein rotund', 31, NULL, NULL, 111511),
(111512, '3.30.390.30-FF-000005', NULL, 'Flavoprotein disulfide reductase', 122, NULL, NULL, 111512),
(111513, '1.10.238.10-FF-000310', NULL, 'Solute carrier family 25 (Mitochondrial phosphate transporter), member 23/24/25/41', 132, NULL, NULL, 111513),
(111514, '3.40.50.300-FF-007462', NULL, 'U3 small nucleolar RNA-associated protein 25', 242, NULL, NULL, 111514),
(111515, '3.30.2400.10-FF-000001', NULL, 'Major capsid subunit', 141, NULL, NULL, 111515),
(111516, '3.40.50.200-FF-000102', NULL, 'Subtilisin-like serine peptidase (Serine peptidase, clan sb, family s8-like protein)', 414, NULL, NULL, 111516),
(111517, '2.130.10.10-FF-003566', NULL, 'Autophagy-related protein 16-2', 188, NULL, NULL, 111517);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(111518, '2.170.270.10-FF-000017', NULL, 'Histone-lysine N-methyltransferase', 131, NULL, NULL, 111518),
(111519, '1.10.150.80-FF-000048', NULL, 'ATP-dependent DNA helicase', 78, NULL, NULL, 111519),
(111520, '3.80.10.10-FF-003757', NULL, 'Predicted protein', 257, NULL, NULL, 111520),
(111521, '2.60.40.10-FF-005679', NULL, NULL, 82, NULL, NULL, 111521),
(111522, '2.60.40.200-FF-000010', NULL, 'Copper-zinc superoxide dismutase 1', 152, NULL, NULL, 111522),
(111523, '3.40.190.10-FF-000465', NULL, 'Peptide ABC transporter, solute-binding protein', 247, NULL, NULL, 111523),
(111524, '3.40.630.30-FF-000640', NULL, 'Acetyltransferase, GNAT family protein', 171, NULL, NULL, 111524),
(111525, '1.10.560.10-FF-000103', NULL, 'Uncharacterized protein', 45, NULL, NULL, 111525),
(111526, '1.25.40.20-FF-000836', NULL, 'Uncharacterized protein', 112, NULL, NULL, 111526),
(111527, '2.130.10.10-FF-005039', NULL, 'EMC Endoplasmic Membrane protein Complex (Yeast EMC) homolog', 291, NULL, NULL, 111527),
(111528, '3.30.420.10-FF-000210', NULL, 'DNA polymerase', 219, NULL, NULL, 111528),
(111529, '1.10.260.40-FF-000005', NULL, 'One cut domain family member', 77, NULL, NULL, 111529),
(111530, '3.40.50.800-FF-000041', NULL, 'Histidine--tRNA ligase', 95, NULL, NULL, 111530),
(111531, '3.30.565.10-FF-000355', NULL, 'Uncharacterized protein', 123, NULL, NULL, 111531),
(111532, '3.40.50.300-FF-005157', NULL, 'YALI0D24123p', 226, NULL, NULL, 111532),
(111533, '3.40.50.10810-FF-000265', NULL, 'Uncharacterized protein', 251, NULL, NULL, 111533),
(111534, '3.30.70.141-FF-000013', NULL, 'Nucleoside diphosphate kinase', 137, NULL, NULL, 111534),
(111535, '1.20.1420.30-FF-000091', NULL, 'Potassium-dependent sodium-calcium exchanger, putative', 177, NULL, NULL, 111535),
(111536, '3.40.30.10-FF-000034', NULL, 'glutathione S-transferase 1', 79, NULL, NULL, 111536),
(111537, '3.40.50.2300-FF-001226', NULL, NULL, 49, NULL, NULL, 111537),
(111538, '3.40.50.150-FF-001649', NULL, NULL, 180, NULL, NULL, 111538),
(111539, '3.60.10.10-FF-000280', NULL, 'Uncharacterized protein', 374, NULL, NULL, 111539),
(111540, '1.25.10.10-FF-000798', NULL, 'Armadillo repeat-containing protein gudu', 203, NULL, NULL, 111540),
(111541, '1.10.150.60-FF-000042', NULL, NULL, 78, NULL, NULL, 111541),
(111542, '1.10.640.10-FF-000104', NULL, 'Uncharacterized protein', 81, NULL, NULL, 111542),
(111543, '3.40.50.300-FF-007523', NULL, 'Uncharacterized protein', 210, NULL, NULL, 111543),
(111544, '3.40.430.10-FF-000001', NULL, 'Dihydrofolate reductase', 161, NULL, NULL, 111544),
(111545, '3.40.50.300-FF-000778', NULL, 'GTP-binding protein YjiA', 202, NULL, NULL, 111545),
(111546, '2.60.120.200-FF-000783', NULL, 'Uncharacterized protein', 139, NULL, NULL, 111546),
(111547, '1.20.910.10-FF-000027', NULL, 'Transcriptional activator, TenA family', 213, NULL, NULL, 111547),
(111548, '2.130.10.10-FF-002285', NULL, 'Peptide deformylase 2', 223, NULL, NULL, 111548),
(111549, '1.25.40.20-FF-001325', NULL, 'Uncharacterized protein', 135, NULL, NULL, 111549),
(111550, '3.20.20.330-FF-000027', NULL, 'Homocysteine S-methyltransferase, putative', 385, NULL, NULL, 111550),
(111551, '1.10.132.30-FF-000014', NULL, 'DNA-directed RNA polymerase subunit', 117, NULL, NULL, 111551),
(111552, '3.30.160.60-FF-000957', NULL, 'Zinc finger protein 12', 29, NULL, NULL, 111552),
(111553, '3.30.70.330-FF-002660', NULL, NULL, 170, NULL, NULL, 111553),
(111554, '3.50.50.60-FF-001258', NULL, 'Invasion protein IbeA', 110, NULL, NULL, 111554),
(111555, '3.30.160.60-FF-003419', NULL, 'FI01202p', 28, NULL, NULL, 111555),
(111556, '3.40.50.720-FF-002242', NULL, 'Uncharacterized protein', 87, NULL, NULL, 111556),
(111557, '1.10.510.10-FF-003557', NULL, NULL, 226, NULL, NULL, 111557),
(111558, '3.90.70.30-FF-000001', NULL, 'Glutathione gamma-glutamylcysteinyltransferase 1', 206, NULL, NULL, 111558),
(111559, '3.30.470.30-FF-000039', NULL, 'AGAP000623-PA', 212, NULL, NULL, 111559),
(111560, '2.60.120.10-FF-000516', NULL, '3-mercaptopropionate dioxygenase', 143, NULL, NULL, 111560),
(111561, '3.40.50.1820-FF-000733', NULL, 'Carboxypeptidase', 418, NULL, NULL, 111561);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(111562, '1.20.1070.10-FF-001024', NULL, 'Uncharacterized protein', 138, NULL, NULL, 111562),
(111563, '3.40.50.150-FF-001728', NULL, NULL, 246, NULL, NULL, 111563),
(111564, '3.40.30.10-FF-000394', NULL, 'Gdap1, isoform B', 100, NULL, NULL, 111564),
(111565, '3.30.420.40-FF-000837', NULL, 'Phosphotransferase', 178, NULL, NULL, 111565),
(111566, '1.10.238.10-FF-001248', NULL, 'Calcium-binding protein A', 83, NULL, NULL, 111566),
(111567, '3.30.450.20-FF-000619', NULL, 'Uncharacterized protein', 109, NULL, NULL, 111567),
(111568, '2.40.128.20-FF-000064', NULL, 'Uncharacterized protein', 78, NULL, NULL, 111568),
(111569, '3.40.50.1820-FF-001301', NULL, 'Uncharacterized protein', 274, NULL, NULL, 111569),
(111570, '3.40.50.2020-FF-000052', NULL, 'Orotate phosphoribosyltransferase', 218, NULL, NULL, 111570),
(111571, '3.40.50.10140-FF-000036', NULL, 'Uncharacterized protein', 176, NULL, NULL, 111571),
(111572, '3.30.1120.10-FF-000018', NULL, 'N-acetylgalactosamine 6-sulfate sulfatase (GALNS)', 78, NULL, NULL, 111572),
(111573, '3.20.20.220-FF-000062', NULL, 'Proline dehydrogenase', 228, NULL, NULL, 111573),
(111574, '2.130.10.10-FF-002577', NULL, 'Uncharacterized protein', 376, NULL, NULL, 111574),
(111575, '3.40.50.140-FF-000011', NULL, 'DNA topoisomerase 1', 157, NULL, NULL, 111575),
(111576, '2.60.120.200-FF-000491', NULL, 'Peptidase M23B', 203, NULL, NULL, 111576),
(111577, '3.30.70.330-FF-002952', NULL, NULL, 183, NULL, NULL, 111577),
(111578, '1.25.40.10-FF-003121', NULL, 'Pentatricopeptide repeat-containing protein At1g79490, mitochondrial', 125, NULL, NULL, 111578),
(111579, '2.60.40.10-FF-004398', NULL, NULL, 94, NULL, NULL, 111579),
(111580, '3.40.50.300-FF-002291', NULL, 'GTP-binding protein 1 (G-protein 1), putative', 179, NULL, NULL, 111580),
(111581, '1.25.40.20-FF-000044', NULL, 'CAP-Gly domain containing linker protein 3', 154, NULL, NULL, 111581),
(111582, '1.10.10.540-FF-000014', NULL, 'Ubiquitin receptor RAD23c', 34, NULL, NULL, 111582),
(111583, '3.30.420.40-FF-000096', NULL, 'xylulose kinase', 197, NULL, NULL, 111583),
(111584, '3.20.20.60-FF-000021', NULL, 'CoA ester lyase', 111, NULL, NULL, 111584),
(111585, '3.40.50.300-FF-007574', NULL, 'ABC transporter ATP-binding protein', 180, NULL, NULL, 111585),
(111586, '3.40.50.720-FF-002585', NULL, 'Uncharacterized protein', 16, NULL, NULL, 111586),
(111587, '1.20.120.20-FF-000032', NULL, 'Apolipoprotein E', 111, NULL, NULL, 111587),
(111588, '3.30.160.60-FF-005887', NULL, NULL, 30, NULL, NULL, 111588),
(111589, '3.40.390.10-FF-000042', NULL, 'Metalloendopeptidase', 245, NULL, NULL, 111589),
(111590, '3.40.630.40-FF-000025', NULL, 'Putative N-acetylmuramoyl-L-alanine amidase', 141, NULL, NULL, 111590),
(111591, '3.40.50.150-FF-000340', NULL, 'Ubiquinone/menaquinone biosynthesis methyltransferase', 229, NULL, NULL, 111591),
(111592, '3.30.1370.100-FF-000026', NULL, 'DNA mismatch repair protein MutL', 96, NULL, NULL, 111592),
(111593, '2.60.34.10-FF-000095', NULL, 'Uncharacterized protein', 151, NULL, NULL, 111593),
(111594, '1.20.120.610-FF-000028', NULL, 'V-type proton ATPase proteolipid subunit', 44, NULL, NULL, 111594),
(111595, '3.90.650.10-FF-000079', NULL, 'Uncharacterized protein', 53, NULL, NULL, 111595),
(111596, '3.20.20.60-FF-000049', NULL, 'HpcH/HpaI aldolase/citrate lyase family protein', 251, NULL, NULL, 111596),
(111597, '3.20.20.80-FF-000027', NULL, 'Alpha-L-fucosidase', 343, NULL, NULL, 111597),
(111598, '3.30.200.20-FF-001804', NULL, 'Protein CBR-ZYG-8', 88, NULL, NULL, 111598),
(111599, '1.10.1520.10-FF-000044', NULL, 'Putative RNase III', 142, NULL, NULL, 111599),
(111600, '1.10.287.810-FF-000011', NULL, 'Mitochondrial regulator of splicing 5', 83, NULL, NULL, 111600),
(111601, '3.80.10.10-FF-000891', NULL, 'adhesion G protein-coupled receptor A2', 88, NULL, NULL, 111601),
(111602, '1.25.40.20-FF-001893', NULL, 'Transient receptor potential cation channel subfamily A member 1 homolog', 238, NULL, NULL, 111602),
(111603, '1.25.10.10-FF-001236', NULL, 'Uncharacterized protein', 238, NULL, NULL, 111603),
(111604, '3.90.640.10-FF-000022', NULL, 'heat shock 70 kDa protein 13', 64, NULL, NULL, 111604);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(111605, '1.25.40.20-FF-000432', NULL, 'E3 ubiquitin-protein ligase KEG', 117, NULL, NULL, 111605),
(111606, '3.30.810.10-FF-000021', NULL, 'Phosphatidylinositol-4-phosphate 5-kinase, putative', 156, NULL, NULL, 111606),
(111607, '3.80.10.10-FF-003353', NULL, 'Uncharacterized protein', 115, NULL, NULL, 111607),
(111608, '1.25.40.10-FF-002845', NULL, 'Clustered mitochondria protein homolog', 120, NULL, NULL, 111608),
(111609, '1.25.40.20-FF-000336', NULL, 'Ankyrin repeat domain-containing protein 16', 96, NULL, NULL, 111609),
(111610, '3.30.160.60-FF-001672', NULL, 'Zinc finger protein 614', 42, NULL, NULL, 111610),
(111611, '2.10.25.10-FF-000514', NULL, 'prolow-density lipoprotein receptor-related protein 1', 46, NULL, NULL, 111611),
(111612, '2.90.10.10-FF-000016', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', 125, NULL, NULL, 111612),
(111613, '1.10.510.10-FF-003265', NULL, NULL, 109, NULL, NULL, 111613),
(111614, '1.10.238.10-FF-001299', NULL, 'Uncharacterized protein', 74, NULL, NULL, 111614),
(111615, '3.40.50.80-FF-000045', NULL, 'NADPH-cytochrome p450 reductase', 157, NULL, NULL, 111615),
(111616, '2.70.20.10-FF-000012', NULL, 'DNA topoisomerase', 129, NULL, NULL, 111616),
(111617, '3.90.226.10-FF-000217', NULL, 'Predicted protein', 84, NULL, NULL, 111617),
(111618, '3.30.160.60-FF-001964', NULL, 'Zinc finger protein 547', 28, NULL, NULL, 111618),
(111619, '3.30.40.10-FF-001721', NULL, 'TNF receptor-associated factor 1', 53, NULL, NULL, 111619),
(111620, '3.90.850.10-FF-000027', NULL, 'Fumarylacetoacetate_(FAA)_hydrolase_family_-_putative', 273, NULL, NULL, 111620),
(111621, '2.30.29.30-FF-000663', NULL, 'Uncharacterized protein', 107, NULL, NULL, 111621),
(111622, '1.20.1070.10-FF-000748', NULL, 'Predicted protein', 256, NULL, NULL, 111622),
(111623, '3.40.50.300-FF-001442', NULL, 'Si:ch211-106j21.4', 107, NULL, NULL, 111623),
(111624, '3.30.260.10-FF-000046', NULL, 'Chaperonin containing TCP1 subunit 2', 69, NULL, NULL, 111624),
(111625, '3.40.50.12470-FF-000015', NULL, 'Dehydrogenase E1 and transketolase domain containing 1', 135, NULL, NULL, 111625),
(111626, '3.30.160.60-FF-005275', NULL, NULL, 34, NULL, NULL, 111626),
(111627, '1.20.1110.10-FF-000095', NULL, 'Sodium/potassium-transporting ATPase subunit alpha-1', 416, NULL, NULL, 111627),
(111628, '3.30.40.10-FF-000209', NULL, 'E3 ubiquitin-protein ligase MARCH4', 70, NULL, NULL, 111628),
(111629, '3.90.1300.10-FF-000030', NULL, 'Putative amidase C869.01', 540, NULL, NULL, 111629),
(111630, '1.10.10.10-FF-000707', NULL, 'Vacuolar membrane-associated protein iml1', 141, NULL, NULL, 111630),
(111631, '3.40.50.2300-FF-001147', NULL, NULL, 220, NULL, NULL, 111631),
(111632, '4.10.1240.10-FF-000008', NULL, 'pituitary adenylate cyclase-activating polypeptide type I receptor', 108, NULL, NULL, 111632),
(111633, '3.90.1200.10-FF-000045', NULL, 'Uncharacterized protein, isoform A', 173, NULL, NULL, 111633),
(111634, '3.30.420.40-FF-000045', NULL, 'Glucokinase', 104, NULL, NULL, 111634),
(111635, '3.30.160.60-FF-003830', NULL, NULL, 24, NULL, NULL, 111635),
(111636, '2.40.10.10-FF-000069', NULL, 'Hyaluronan-binding protein 2', 250, NULL, NULL, 111636),
(111637, '3.40.1690.20-FF-000016', NULL, 'Mitochondrial respiratory chain complexes assembly protein, putative', 93, NULL, NULL, 111637),
(111638, '3.30.43.10-FF-000042', NULL, 'Putative FAD-dependent oxygenase EncM', 79, NULL, NULL, 111638),
(111639, '1.20.5.340-FF-000100', NULL, 'Outer capsid protein sigma-1', 127, NULL, NULL, 111639),
(111640, '3.80.10.10-FF-001228', NULL, 'Outer_row_dynein-assembly_protein_7', 59, NULL, NULL, 111640),
(111641, '1.50.40.10-FF-000483', NULL, 'Uncharacterized protein', 278, NULL, NULL, 111641),
(111642, '3.20.20.100-FF-000043', NULL, 'Pyridoxal reductase, chloroplastic', 322, NULL, NULL, 111642),
(111643, '3.40.50.970-FF-000046', NULL, '2-hydroxyacyl-CoA lyase 1', 215, NULL, NULL, 111643),
(111644, '3.70.10.10-FF-000088', NULL, 'Uncharacterized protein', 143, NULL, NULL, 111644),
(111645, '1.25.40.10-FF-004841', NULL, 'Pre-mRNA-splicing factor CLF1', 140, NULL, NULL, 111645);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(111646, '2.120.10.30-FF-000127', NULL, 'Uncharacterized protein, isoform A', 257, NULL, NULL, 111646),
(111647, '3.40.50.720-FF-000556', NULL, 'Proline utilization protein PrnX-like protein', 220, NULL, NULL, 111647),
(111648, '3.90.650.10-FF-000028', NULL, 'Phosphoribosylformylglycinamidine synthase-like Protein', 168, NULL, NULL, 111648),
(111649, '3.40.50.300-FF-003651', NULL, 'GM24810', 169, NULL, NULL, 111649),
(111650, '3.10.20.90-FF-001014', NULL, 'Uncharacterized protein', 54, NULL, NULL, 111650),
(111651, '3.40.50.150-FF-001700', NULL, NULL, 79, NULL, NULL, 111651),
(111652, '3.30.160.60-FF-003650', NULL, NULL, 28, NULL, NULL, 111652),
(111653, '3.30.70.330-FF-000355', NULL, 'Polyadenylate-binding protein', 117, NULL, NULL, 111653),
(111654, '2.60.40.10-FF-003881', NULL, NULL, 86, NULL, NULL, 111654),
(111655, '1.10.287.3240-FF-000033', NULL, 'V-type proton ATPase subunit D 1-like Protein', 212, NULL, NULL, 111655),
(111656, '3.90.230.10-FF-000036', NULL, 'X-Pro dipeptidase', 234, NULL, NULL, 111656),
(111657, '1.20.920.30-FF-000039', NULL, 'Uncharacterized protein', 38, NULL, NULL, 111657),
(111658, '1.20.920.10-FF-000213', NULL, 'Predicted protein', 103, NULL, NULL, 111658),
(111659, '3.40.50.300-FF-005545', NULL, 'ABC transporter, putative', 352, NULL, NULL, 111659),
(111660, '3.30.160.60-FF-001093', NULL, 'Zinc finger protein 236', 23, NULL, NULL, 111660),
(111661, '3.30.70.340-FF-000004', NULL, 'Carboxypeptidase A6', 90, NULL, NULL, 111661),
(111662, '3.30.428.10-FF-000059', NULL, 'Uncharacterized protein', 172, NULL, NULL, 111662),
(111663, '2.60.40.10-FF-004370', NULL, NULL, 103, NULL, NULL, 111663),
(111664, '1.10.472.10-FF-000466', NULL, 'Cyclin-dependent protein kinase complex component, putative (AFU_orthologue AFUA_2G07660)', 198, NULL, NULL, 111664),
(111665, '3.30.160.60-FF-001621', NULL, 'Uncharacterized protein', 28, NULL, NULL, 111665),
(111666, '1.10.1380.10-FF-000004', NULL, 'phosphate-regulating neutral endopeptidase isoform X2', 371, NULL, NULL, 111666),
(111667, '1.10.8.60-FF-000160', NULL, 'WGS project CABT00000000 data, contig 2.55', 93, NULL, NULL, 111667),
(111668, '3.30.200.20-FF-001276', NULL, 'Ste20-like kinase, isoform C', 87, NULL, NULL, 111668),
(111669, '2.60.40.60-FF-001046', NULL, 'Predicted protein', 93, NULL, NULL, 111669),
(111670, '3.50.50.60-FF-001354', NULL, 'FAD-binding monooxygenase ausC', 200, NULL, NULL, 111670),
(111671, '2.10.25.10-FF-000222', NULL, 'Latent transforming growth factor beta binding protein 4', 44, NULL, NULL, 111671),
(111672, '1.10.1420.10-FF-000160', NULL, 'DNA mismatch repair protein', 180, NULL, NULL, 111672),
(111673, '1.10.486.10-FF-000048', NULL, 'DNA helicase', 165, NULL, NULL, 111673),
(111674, '3.40.50.300-FF-000874', NULL, 'RNA helicase', 235, NULL, NULL, 111674),
(111675, '2.60.40.150-FF-000652', NULL, 'Predicted protein', 116, NULL, NULL, 111675),
(111676, '3.10.490.20-FF-000031', NULL, 'Uncharacterized protein', 136, NULL, NULL, 111676),
(111677, '1.25.40.10-FF-005330', NULL, 'Pentatricopeptide repeat-containing protein At1g52620', 93, NULL, NULL, 111677),
(111678, '1.10.418.10-FF-000228', NULL, 'Plectin', 106, NULL, NULL, 111678),
(111679, '3.40.190.10-FF-000386', NULL, 'LysR family transcriptional regulator', 87, NULL, NULL, 111679),
(111680, '3.40.50.2300-FF-000658', NULL, 'DNA-binding response regulator', 126, NULL, NULL, 111680),
(111681, '2.40.150.20-FF-000003', NULL, '60S ribosomal protein L23', 140, NULL, NULL, 111681),
(111682, '3.90.730.10-FF-000029', NULL, 'Uncharacterized protein', 144, NULL, NULL, 111682),
(111683, '1.25.40.10-FF-003329', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 101, NULL, NULL, 111683),
(111684, '3.40.50.200-FF-000018', NULL, 'Type VII secretion-associated serine protease mycosin', 370, NULL, NULL, 111684),
(111685, '1.10.3720.10-FF-000104', NULL, 'Peptide ABC transporter permease', 218, NULL, NULL, 111685),
(111686, '2.170.270.10-FF-000085', NULL, 'Histone-lysine N-methyltransferase family member SUVH9', 290, NULL, NULL, 111686),
(111687, '3.30.1240.20-FF-000002', NULL, 'Phosphomannomutase', 36, NULL, NULL, 111687);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(111688, '3.80.10.10-FF-001279', NULL, 'Nuclear RNA export factor 2', 154, NULL, NULL, 111688),
(111689, '1.10.287.70-FF-000070', NULL, 'Potassium channel, subfamily K, member 12 like', 294, NULL, NULL, 111689),
(111690, '3.80.10.10-FF-001015', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 125, NULL, NULL, 111690),
(111691, '1.10.10.10-FF-001556', NULL, 'Adenosine deaminase, RNA-specific', 75, NULL, NULL, 111691),
(111692, '2.40.50.140-FF-001066', NULL, NULL, 95, NULL, NULL, 111692),
(111693, '1.10.630.10-FF-000311', NULL, 'Uncharacterized protein', 468, NULL, NULL, 111693),
(111694, '4.10.240.10-FF-000175', NULL, 'Submerged protoperithecia-2', 61, NULL, NULL, 111694),
(111695, '1.10.8.10-FF-000055', NULL, 'Non-specific serine/threonine protein kinase', 60, NULL, NULL, 111695),
(111696, '3.40.50.720-FF-002293', NULL, 'dTDP-glucose 4-6-dehydratase', 184, NULL, NULL, 111696),
(111697, '1.25.10.10-FF-001675', NULL, 'Uncharacterized protein', 307, NULL, NULL, 111697),
(111698, '3.40.50.2000-FF-000719', NULL, 'Lipopolysaccharide core biosynthesis protein', 151, NULL, NULL, 111698),
(111699, '2.10.110.10-FF-000156', NULL, 'LIM Zinc finger domain containing protein', 77, NULL, NULL, 111699),
(111700, '1.20.82.10-FF-000002', NULL, 'ADP-ribosyl cyclase isoform 2', 121, NULL, NULL, 111700),
(111701, '3.10.250.10-FF-000100', NULL, NULL, 54, NULL, NULL, 111701),
(111702, '1.10.630.10-FF-000339', NULL, 'Uncharacterized protein', 243, NULL, NULL, 111702),
(111703, '3.80.10.10-FF-000739', NULL, 'Leucine rich repeat neuronal 4', 119, NULL, NULL, 111703),
(111704, '1.10.510.10-FF-001399', NULL, 'Protein kinase domain containing protein', 329, NULL, NULL, 111704),
(111705, '1.20.1250.20-FF-000883', NULL, 'AGAP012371-PA', 191, NULL, NULL, 111705),
(111706, '2.130.10.10-FF-003645', NULL, 'WD-repeat protein, putative', 126, NULL, NULL, 111706),
(111707, '3.30.160.60-FF-002110', NULL, 'Zinc finger protein 1053', 27, NULL, NULL, 111707),
(111708, '3.20.20.70-FF-000378', NULL, 'Thiazole synthase', 258, NULL, NULL, 111708),
(111709, '1.25.10.10-FF-003361', NULL, 'Uncharacterized protein', 184, NULL, NULL, 111709),
(111710, '3.30.200.20-FF-000787', NULL, 'Protein kinase, putative (AFU_orthologue AFUA_2G16620)', 127, NULL, NULL, 111710),
(111711, '3.30.1740.10-FF-000026', NULL, 'Poly [ADP-ribose] polymerase', 88, NULL, NULL, 111711),
(111712, '3.30.760.10-FF-000039', NULL, 'Uncharacterized protein', 183, NULL, NULL, 111712),
(111713, '3.30.710.10-FF-000036', NULL, 'Mod(Mdg4), isoform H', 119, NULL, NULL, 111713),
(111714, '3.30.230.10-FF-000286', NULL, 'Uncharacterized protein', 93, NULL, NULL, 111714),
(111715, '2.170.150.10-FF-000019', NULL, 'Uncharacterized protein', 96, NULL, NULL, 111715),
(111716, '3.40.33.10-FF-000075', NULL, 'Uncharacterized protein', 176, NULL, NULL, 111716),
(111717, '1.25.40.10-FF-003481', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 89, NULL, NULL, 111717),
(111718, '3.40.50.200-FF-000170', NULL, 'Uncharacterized protein', 63, NULL, NULL, 111718),
(111719, '1.20.58.60-FF-000163', NULL, 'spectrin alpha chain, erythrocytic 1', 73, NULL, NULL, 111719),
(111720, '3.30.710.10-FF-000249', NULL, 'WGS project CABT00000000 data, contig 2.12', 93, NULL, NULL, 111720),
(111721, '1.20.1250.20-FF-002199', NULL, 'Uncharacterized protein', 147, NULL, NULL, 111721),
(111722, '2.30.30.140-FF-000114', NULL, 'RING finger protein 17', 92, NULL, NULL, 111722),
(111723, '1.10.20.10-FF-000040', NULL, 'TAF6-like RNA polymerase II p300/CBP-associated factor-associated factor 65 kDa subunit 6L', 64, NULL, NULL, 111723),
(111724, '1.10.620.20-FF-000050', NULL, 'Uncharacterized protein', 90, NULL, NULL, 111724),
(111725, '2.130.10.10-FF-004134', NULL, 'Uncharacterized protein', 183, NULL, NULL, 111725),
(111726, '1.10.565.10-FF-000030', NULL, 'Ecdysone receptor (Isoform A)', 243, NULL, NULL, 111726),
(111727, '2.40.50.140-FF-000577', NULL, '50S ribosomal protein L2', 80, NULL, NULL, 111727),
(111728, '2.60.120.200-FF-000440', NULL, 'Galectin', 131, NULL, NULL, 111728);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(111729, '3.30.1610.10-FF-000022', NULL, 'Uncharacterized protein', 78, NULL, NULL, 111729),
(111730, '2.60.40.10-FF-000115', NULL, 'filamin-C isoform X1', 95, NULL, NULL, 111730),
(111731, '3.30.200.20-FF-001063', NULL, 'Non-specific serine/threonine protein kinase', 116, NULL, NULL, 111731),
(111732, '3.30.420.10-FF-000502', NULL, NULL, 129, NULL, NULL, 111732),
(111733, '3.40.1020.10-FF-000003', NULL, 'Threonine dehydratase', 176, NULL, NULL, 111733),
(111734, '2.60.40.10-FF-001525', NULL, 'Immunoglobulin-like and fibronectin type III domain-containing 1', 94, NULL, NULL, 111734),
(111735, '3.70.10.10-FF-000060', NULL, 'Checkpoint protein', 314, NULL, NULL, 111735),
(111736, '1.25.40.90-FF-000025', NULL, 'ENTH domain protein', 125, NULL, NULL, 111736),
(111737, '3.30.70.330-FF-002772', NULL, NULL, 74, NULL, NULL, 111737),
(111738, '3.30.70.1620-FF-000007', NULL, 'Structural maintenance of chromosomes protein', 92, NULL, NULL, 111738),
(111739, '3.30.70.660-FF-000050', NULL, 'tRNA pseudouridine synthase A-like protein', 79, NULL, NULL, 111739),
(111740, '3.30.420.10-FF-000710', NULL, NULL, 94, NULL, NULL, 111740),
(111741, '3.30.200.100-FF-000002', NULL, 'Sigma-E factor regulatory protein RseB', 98, NULL, NULL, 111741),
(111742, '3.40.50.150-FF-001357', NULL, NULL, 188, NULL, NULL, 111742),
(111743, '1.25.10.10-FF-002804', NULL, 'Uncharacterized protein', 739, NULL, NULL, 111743),
(111744, '3.40.50.300-FF-000666', NULL, 'ATP-dependent RNA helicase DDX50', 248, NULL, NULL, 111744),
(111745, '1.10.10.10-FF-001495', NULL, 'Cullin', 60, NULL, NULL, 111745),
(111746, '3.40.50.2000-FF-000158', NULL, 'UDP-glucuronosyltransferase 2A1', 177, NULL, NULL, 111746),
(111747, '2.10.10.10-FF-000020', NULL, 'Uncharacterized protein', 61, NULL, NULL, 111747),
(111748, '3.30.60.20-FF-000129', NULL, 'AGAP006932-PA', 83, NULL, NULL, 111748),
(111749, '2.130.10.10-FF-002397', NULL, 'Cilia and flagella associated protein 44', 175, NULL, NULL, 111749),
(111750, '1.20.5.480-FF-000001', NULL, 'Formate dehydrogenase iron-sulfur subunit', 48, NULL, NULL, 111750),
(111751, '3.40.50.2300-FF-000719', NULL, NULL, 28, NULL, NULL, 111751),
(111752, '2.60.40.10-FF-001868', NULL, 'Down syndrome cell adhesion molecule', 55, NULL, NULL, 111752),
(111753, '2.60.40.10-FF-004038', NULL, NULL, 97, NULL, NULL, 111753),
(111754, '3.90.190.10-FF-000032', NULL, 'dual specificity protein phosphatase CDC14A isoform X1', 150, NULL, NULL, 111754),
(111755, '3.40.50.300-FF-000082', NULL, 'ISWI chromatin remodeling complex ATPase ISW1', 297, NULL, NULL, 111755),
(111756, '3.40.50.2020-FF-000164', NULL, 'Ribose-phosphate pyrophosphokinase', 146, NULL, NULL, 111756),
(111757, '1.10.238.10-FF-001327', NULL, 'Calpain-B-like Protein', 174, NULL, NULL, 111757),
(111758, '2.60.120.10-FF-000628', NULL, 'Uncharacterized protein', 133, NULL, NULL, 111758),
(111759, '3.30.1330.10-FF-000040', NULL, 'Hydrogenase expression/formation protein HypE', 103, NULL, NULL, 111759),
(111760, '2.40.10.10-FF-000277', NULL, 'Trypsin domain containing 1', 74, NULL, NULL, 111760),
(111761, '2.60.40.1910-FF-000048', NULL, NULL, 108, NULL, NULL, 111761),
(111762, '3.90.79.10-FF-000178', NULL, 'Uncharacterized protein', 141, NULL, NULL, 111762),
(111763, '1.20.1080.10-FF-000125', NULL, 'Uncharacterized protein', 262, NULL, NULL, 111763),
(111764, '3.30.160.60-FF-005095', NULL, NULL, 84, NULL, NULL, 111764),
(111765, '1.20.5.190-FF-000015', NULL, 'IQ motif containing F5', 49, NULL, NULL, 111765),
(111766, '1.10.390.10-FF-000062', NULL, 'Aminopeptidase', 260, NULL, NULL, 111766),
(111767, '3.30.1300.10-FF-000004', NULL, 'Pantothenate synthetase', 114, NULL, NULL, 111767),
(111768, '3.30.1220.10-FF-000003', NULL, 'YNR029C-like protein', 124, NULL, NULL, 111768),
(111769, '2.20.100.10-FF-000254', NULL, 'Uncharacterized protein', 39, NULL, NULL, 111769),
(111770, '3.40.50.2300-FF-001670', NULL, NULL, 166, NULL, NULL, 111770),
(111771, '3.40.228.10-FF-000025', NULL, 'Molybdopterin oxidoreductase family protein', 239, NULL, NULL, 111771),
(111772, '1.10.10.790-FF-000004', NULL, 'SURP and G-patch domain-containing protein 1', 87, NULL, NULL, 111772);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(111773, '1.10.238.10-FF-000231', NULL, 'Calmodulin-like protein 3', 70, NULL, NULL, 111773),
(111774, '1.20.58.60-FF-000455', NULL, 'Dystrophin-1', 358, NULL, NULL, 111774),
(111775, '1.25.40.10-FF-003301', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 104, NULL, NULL, 111775),
(111776, '3.50.50.60-FF-001146', NULL, 'Uncharacterized protein', 78, NULL, NULL, 111776),
(111777, '2.60.40.10-FF-003381', NULL, 'Immunoglobulin heavy constant delta', 106, NULL, NULL, 111777),
(111778, '2.60.120.650-FF-000226', NULL, 'Predicted protein', 173, NULL, NULL, 111778),
(111779, '2.130.10.10-FF-002509', NULL, 'Two-component system sensor histidine kinase/response regulator', 316, NULL, NULL, 111779),
(111780, '3.30.420.40-FF-000657', NULL, 'Actin-related protein 6', 123, NULL, NULL, 111780),
(111781, '3.30.70.330-FF-000743', NULL, 'Similar to R3H domain protein', 138, NULL, NULL, 111781),
(111782, '2.10.25.10-FF-000453', NULL, 'Adhesion G protein-coupled receptor E1', 38, NULL, NULL, 111782),
(111783, '2.130.10.10-FF-000368', NULL, 'Peptidylprolyl isomerase domain and WD repeat-containing protein 1', 116, NULL, NULL, 111783),
(111784, '2.30.30.60-FF-000012', NULL, 'Uncharacterized protein', 51, NULL, NULL, 111784),
(111785, '3.30.160.60-FF-002402', NULL, 'Zinc finger protein 347', 23, NULL, NULL, 111785),
(111786, '1.10.287.470-FF-000038', NULL, 'Efflux transporter periplasmic adaptor subunit', 74, NULL, NULL, 111786),
(111787, '1.10.10.60-FF-000357', NULL, 'Motor neuron and pancreas homeobox 1', 79, NULL, NULL, 111787),
(111788, '1.20.1050.130-FF-000038', NULL, 'Bifunctional glutamate/proline--tRNA ligase', 156, NULL, NULL, 111788),
(111789, '3.40.1160.10-FF-000013', NULL, 'Delta-1-pyrroline-5-carboxylate synthase', 284, NULL, NULL, 111789),
(111790, '3.30.160.60-FF-003881', NULL, 'GD10245', 61, NULL, NULL, 111790),
(111791, '3.30.200.20-FF-000287', NULL, 'Cell division cycle 7-related protein kinase', 102, NULL, NULL, 111791),
(111792, '1.10.287.10-FF-000058', NULL, 'Uncharacterized protein', 30, NULL, NULL, 111792),
(111793, '1.10.8.590-FF-000008', NULL, NULL, 74, NULL, NULL, 111793),
(111794, '1.10.10.10-FF-002012', NULL, 'Uncharacterized protein', 112, NULL, NULL, 111794),
(111795, '2.60.40.10-FF-005730', NULL, NULL, 113, NULL, NULL, 111795),
(111796, '1.10.510.10-FF-000151', NULL, 'Serine/threonine-protein kinase', 303, NULL, NULL, 111796),
(111797, '3.40.50.11350-FF-000005', NULL, 'O-fucosyltransferase family protein', 170, NULL, NULL, 111797),
(111798, '2.160.10.10-FF-000097', NULL, 'Predicted protein', 109, NULL, NULL, 111798),
(111799, '1.10.150.240-FF-000094', NULL, 'Uncharacterized protein', 65, NULL, NULL, 111799),
(111800, '1.10.8.1080-FF-000007', NULL, 'Uncharacterized protein', 45, NULL, NULL, 111800),
(111801, '3.40.190.10-FF-000965', NULL, 'Glr3204 protein', 252, NULL, NULL, 111801),
(111802, '1.10.555.10-FF-000092', NULL, 'RhoGAP domain containing protein', 196, NULL, NULL, 111802),
(111803, '3.40.50.10190-FF-000298', NULL, 'DNA topoisomerase 2-binding protein 1-A-like Protein', 98, NULL, NULL, 111803),
(111804, '1.10.220.10-FF-000016', NULL, 'Annexin', 78, NULL, NULL, 111804),
(111805, '1.20.1510.10-FF-000024', NULL, 'Solute carrier family 30 (Zinc transporter), member 1', 158, NULL, NULL, 111805),
(111806, '3.80.10.10-FF-002864', NULL, 'Uncharacterized protein', 215, NULL, NULL, 111806),
(111807, '1.25.10.10-FF-003209', NULL, 'Serine/threonine-protein kinase TOR', 276, NULL, NULL, 111807),
(111808, '2.40.30.10-FF-000340', NULL, 'Eukaryotic peptide chain release factor GTP-binding subunit ERF3A', 86, NULL, NULL, 111808),
(111809, '3.30.420.10-FF-000553', NULL, NULL, 61, NULL, NULL, 111809),
(111810, '3.40.50.300-FF-002223', NULL, 'U5 small nuclear ribonucleoprotein helicase', 204, NULL, NULL, 111810),
(111811, '1.10.287.1060-FF-000020', NULL, 'Cogc-4', 84, NULL, NULL, 111811),
(111812, '2.30.42.10-FF-000609', NULL, NULL, 95, NULL, NULL, 111812),
(111813, '1.20.140.40-FF-000073', NULL, NULL, 155, NULL, NULL, 111813),
(111814, '2.60.40.10-FF-005179', NULL, NULL, 93, NULL, NULL, 111814);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(111815, '2.130.10.10-FF-004022', NULL, 'Uncharacterized protein', 222, NULL, NULL, 111815),
(111816, '3.40.50.10240-FF-000009', NULL, 'thiamin pyrophosphokinase 1', 148, NULL, NULL, 111816),
(111817, '1.20.58.1040-FF-000010', NULL, 'Glucan endo-13-beta-glucosidase 4', 96, NULL, NULL, 111817),
(111818, '1.20.5.1180-FF-000001', NULL, 'Truncated geminin', 78, NULL, NULL, 111818),
(111819, '2.40.250.10-FF-000002', NULL, 'Core binding factor beta subunit isoform 10', 87, NULL, NULL, 111819),
(111820, '1.20.1070.10-FF-000517', NULL, 'GoNadotropin-Releasing hormone Receptor (GnRHR) related', 320, NULL, NULL, 111820),
(111821, '2.30.110.10-FF-000106', NULL, 'Uncharacterized protein C725.03', 255, NULL, NULL, 111821),
(111822, '2.60.120.620-FF-000122', NULL, 'Uncharacterized protein', 112, NULL, NULL, 111822),
(111823, '3.40.120.10-FF-000112', NULL, 'Uncharacterized protein', 124, NULL, NULL, 111823),
(111824, '3.30.70.1600-FF-000001', NULL, 'RNA-directed RNA polymerase', 176, NULL, NULL, 111824),
(111825, '1.10.510.10-FF-001348', NULL, 'GAK Homolog', 302, NULL, NULL, 111825),
(111826, '3.30.1360.180-FF-000008', NULL, 'Uncharacterized protein', 107, NULL, NULL, 111826),
(111827, '3.90.550.10-FF-000291', NULL, '3-deoxy-D-manno-octulosonate cytidylyltransferase', 244, NULL, NULL, 111827),
(111828, '4.10.400.10-FF-000030', NULL, 'Sortilin related receptor 1', 42, NULL, NULL, 111828),
(111829, '4.10.410.10-FF-000115', NULL, 'Salivary protein KUN-5, putative', 60, NULL, NULL, 111829),
(111830, '2.60.40.10-FF-003049', NULL, 'Dyslexia-associated protein KIAA0319', 38, NULL, NULL, 111830),
(111831, '2.40.440.10-FF-000022', NULL, 'ErfK/YbiS/YcfS/YnhG family protein', 114, NULL, NULL, 111831),
(111832, '2.60.260.20-FF-000063', NULL, 'LOC100125006 protein', 81, NULL, NULL, 111832),
(111833, '3.50.30.30-FF-000079', NULL, 'Glutamate carboxypeptidase, putative', 89, NULL, NULL, 111833),
(111834, '1.10.287.370-FF-000042', NULL, 'Prefoldin, alpha subunit', 136, NULL, NULL, 111834),
(111835, '3.40.1110.10-FF-000454', NULL, NULL, 271, NULL, NULL, 111835),
(111836, '3.40.50.300-FF-005837', NULL, 'Lantibiotic mersacidin transporter system', 248, NULL, NULL, 111836),
(111837, '3.30.70.890-FF-000034', NULL, 'Diphosphomevalonate decarboxylase', 145, NULL, NULL, 111837),
(111838, '1.20.120.350-FF-000141', NULL, 'Voltage-gated Ca2+ channel, alpha subunit', 131, NULL, NULL, 111838),
(111839, '3.40.50.10330-FF-000003', NULL, 'Diacylglycerol kinase', 130, NULL, NULL, 111839),
(111840, '2.130.10.10-FF-004926', NULL, 'Uncharacterized protein', 105, NULL, NULL, 111840),
(111841, '3.80.10.10-FF-000498', NULL, 'Uncharacterized protein, isoform B', 121, NULL, NULL, 111841),
(111842, '2.120.10.80-FF-000209', NULL, 'Protein CBG01796', 180, NULL, NULL, 111842),
(111843, '2.30.29.30-FF-000955', NULL, 'Uncharacterized protein', 113, NULL, NULL, 111843),
(111844, '3.40.1080.10-FF-000012', NULL, 'Possible CoA-transferase (Beta subunit)', 243, NULL, NULL, 111844),
(111845, '3.20.80.10-FF-000055', NULL, 'Predicted protein', 153, NULL, NULL, 111845),
(111846, '3.40.50.300-FF-000986', NULL, 'rab-like protein 2B isoform X4', 210, NULL, NULL, 111846),
(111847, '3.90.640.10-FF-000253', NULL, 'Uncharacterized protein', 93, NULL, NULL, 111847),
(111848, '3.40.50.1440-FF-000147', NULL, 'Uncharacterized protein', 311, NULL, NULL, 111848),
(111849, '3.40.50.150-FF-001149', NULL, 'Uncharacterized protein', 255, NULL, NULL, 111849),
(111850, '1.10.20.10-FF-000152', NULL, 'CBF/NF-Y transcription factor family protein', 85, NULL, NULL, 111850),
(111851, '3.60.15.10-FF-000133', NULL, 'Cleavage and polyadenylation specificity factor, 73 kDa subunit', 244, NULL, NULL, 111851),
(111852, '3.40.50.1820-FF-000284', NULL, 'Triacylglycerol lipase A', 271, NULL, NULL, 111852),
(111853, '1.10.238.230-FF-000007', NULL, 'Phosphatase regulatory subunit, putative', 97, NULL, NULL, 111853),
(111854, '2.60.120.10-FF-000308', NULL, 'Phospholipase A1 member A', 164, NULL, NULL, 111854),
(111855, '3.40.1170.60-FF-000045', NULL, NULL, 50, NULL, NULL, 111855),
(111856, '3.40.50.300-FF-005657', NULL, 'ATP-dependent DNA helicase Hel308', 207, NULL, NULL, 111856);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(111857, '3.30.160.60-FF-006000', NULL, NULL, 42, NULL, NULL, 111857),
(111858, '3.10.20.310-FF-000041', NULL, 'Chloroplast outer envelope protein', 88, NULL, NULL, 111858),
(111859, '1.25.10.10-FF-000770', NULL, 'Protein phosphatase 4, regulatory subunit 1-like', 151, NULL, NULL, 111859),
(111860, '1.25.10.10-FF-001444', NULL, 'AP complex subunit beta', 643, NULL, NULL, 111860),
(111861, '3.40.50.2300-FF-001439', NULL, NULL, 79, NULL, NULL, 111861),
(111862, '3.10.20.620-FF-000015', NULL, NULL, 107, NULL, NULL, 111862),
(111863, '3.30.56.10-FF-000021', NULL, 'Phenylalanyl-tRNA synthetase beta chain', 85, NULL, NULL, 111863),
(111864, '1.20.1070.10-FF-001288', NULL, 'Predicted protein', 117, NULL, NULL, 111864),
(111865, '1.10.4160.10-FF-000027', NULL, 'Uncharacterized protein', 435, NULL, NULL, 111865),
(111866, '2.130.10.10-FF-003302', NULL, 'Transducin (beta)-like 3', 193, NULL, NULL, 111866),
(111867, '1.25.40.330-FF-000008', NULL, 'Adenylyl cyclase-associated protein', 168, NULL, NULL, 111867),
(111868, '3.30.1370.210-FF-000031', NULL, 'Uncharacterized protein', 89, NULL, NULL, 111868),
(111869, '3.40.50.620-FF-000756', NULL, 'Uncharacterized protein', 134, NULL, NULL, 111869),
(111870, '2.170.270.10-FF-000197', NULL, 'Histone-lysine N-methyltransferase', 281, NULL, NULL, 111870),
(111871, '1.20.1070.10-FF-000299', NULL, '5-hydroxytryptamine receptor 2B', 288, NULL, NULL, 111871),
(111872, '3.90.1150.220-FF-000001', NULL, 'Non-structural maintenance of chromosomes element 1 homolog', 80, NULL, NULL, 111872),
(111873, '1.10.10.2660-FF-000021', NULL, 'Ubiquitin activating enzyme, putative', 250, NULL, NULL, 111873),
(111874, '3.50.50.60-FF-001466', NULL, 'Os01g0269100 protein', 67, NULL, NULL, 111874),
(111875, '3.40.1190.20-FF-000091', NULL, 'ATP-dependent (S)-NAD(P)H-hydrate dehydratase', 287, NULL, NULL, 111875),
(111876, '1.20.120.550-FF-000021', NULL, 'Uncharacterized protein', 157, NULL, NULL, 111876),
(111877, '1.10.150.20-FF-000058', NULL, 'Helicase, POLQ like', 53, NULL, NULL, 111877),
(111878, '3.40.50.720-FF-000376', NULL, 'Fatty acyl-CoA reductase', 341, NULL, NULL, 111878),
(111879, '3.30.200.20-FF-000495', NULL, 'Nodulation receptor kinase', 111, NULL, NULL, 111879),
(111880, '3.30.830.10-FF-000247', NULL, 'Probable zinc protease', 197, NULL, NULL, 111880),
(111881, '1.10.10.10-FF-000775', NULL, 'PadR family transcriptional regulator', 88, NULL, NULL, 111881),
(111882, '3.90.39.10-FF-000001', NULL, 'Hexon protein', 112, NULL, NULL, 111882),
(111883, '2.60.40.420-FF-000076', NULL, 'Spore coat protein A', 169, NULL, NULL, 111883),
(111884, '1.20.5.2950-FF-000004', NULL, 'V-type proton ATPase subunit G', 107, NULL, NULL, 111884),
(111885, '3.30.160.60-FF-005836', NULL, NULL, 52, NULL, NULL, 111885),
(111886, '3.40.50.300-FF-007866', NULL, 'DNA helicase', 209, NULL, NULL, 111886),
(111887, '1.10.533.10-FF-000187', NULL, 'Uncharacterized protein', 98, NULL, NULL, 111887),
(111888, '3.10.20.90-FF-000637', NULL, 'Putative small ubiquitin-related modifier 7', 85, NULL, NULL, 111888),
(111889, '2.60.40.150-FF-000360', NULL, 'Phosphatidylinositol 3-kinase, putative', 174, NULL, NULL, 111889),
(111890, '3.40.50.720-FF-002473', NULL, 'Uncharacterized protein', 258, NULL, NULL, 111890),
(111891, '1.10.10.10-FF-001848', NULL, 'Uncharacterized protein', 81, NULL, NULL, 111891),
(111892, '3.30.200.20-FF-000219', NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase', 115, NULL, NULL, 111892),
(111893, '1.20.1600.10-FF-000031', NULL, 'Outer membrane protein TolC, putative', 415, NULL, NULL, 111893),
(111894, '3.40.630.30-FF-000668', NULL, 'Predicted protein', 252, NULL, NULL, 111894),
(111895, '3.40.50.300-FF-004640', NULL, 'Recombinase RecB', 123, NULL, NULL, 111895),
(111896, '3.30.160.60-FF-005679', NULL, NULL, 26, NULL, NULL, 111896),
(111897, '2.30.30.140-FF-000345', NULL, 'Histone acetyltransferase', 91, NULL, NULL, 111897),
(111898, '3.90.550.50-FF-000179', NULL, 'Uncharacterized protein', 236, NULL, NULL, 111898),
(111899, '1.25.40.10-FF-003037', NULL, 'Os01g0884800 protein', 98, NULL, NULL, 111899);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(111900, '3.80.10.10-FF-003145', NULL, 'AT02704p', 308, NULL, NULL, 111900),
(111901, '1.20.5.170-FF-000268', NULL, 'Uncharacterized protein', 71, NULL, NULL, 111901),
(111902, '2.130.10.10-FF-001728', NULL, 'Similar to DDB1B (Damaged DNA Binding protein 1 B) damaged DNA binding / protein binding', 365, NULL, NULL, 111902),
(111903, '3.30.1370.120-FF-000004', NULL, 'DNA transporter HofQ', 97, NULL, NULL, 111903),
(111904, '1.20.58.60-FF-000742', NULL, 'Uncharacterized protein', 80, NULL, NULL, 111904),
(111905, '1.10.100.10-FF-000018', NULL, NULL, 37, NULL, NULL, 111905),
(111906, '3.40.190.10-FF-000678', NULL, 'Transcriptional regulator', 110, NULL, NULL, 111906),
(111907, '1.25.40.20-FF-000224', NULL, 'SH3 and multiple ankyrin repeat domains protein 2', 119, NULL, NULL, 111907),
(111908, '2.60.40.10-FF-001233', NULL, 'Uncharacterized protein, isoform B', 92, NULL, NULL, 111908),
(111909, '2.60.40.3170-FF-000010', NULL, 'Tripeptidyl-peptidase II, putative', 130, NULL, NULL, 111909),
(111910, '4.10.280.10-FF-000121', NULL, 'Serine-rich protein TYE7', 61, NULL, NULL, 111910),
(111911, '2.40.50.140-FF-000869', NULL, NULL, 88, NULL, NULL, 111911),
(111912, '3.90.1150.10-FF-000085', NULL, 'LL-diaminopimelate aminotransferase, chloroplastic', 127, NULL, NULL, 111912),
(111913, '1.20.1730.10-FF-000035', NULL, 'High affinity choline transporter, putative', 238, NULL, NULL, 111913),
(111914, '3.30.70.1440-FF-000009', NULL, 'RND multidrug efflux transporter', 100, NULL, NULL, 111914),
(111915, '2.30.180.10-FF-000111', NULL, NULL, 139, NULL, NULL, 111915),
(111916, '3.90.550.10-FF-000015', NULL, 'Glucomannan 4-beta-mannosyltransferase 9', 229, NULL, NULL, 111916),
(111917, '1.10.510.10-FF-003377', NULL, NULL, 322, NULL, NULL, 111917),
(111918, '3.40.50.300-FF-005096', NULL, 'Energy-coupling factor transporter ATP-binding protein EcfA', 268, NULL, NULL, 111918),
(111919, '2.20.70.10-FF-000096', NULL, 'E3 ubiquitin-protein ligase NEDD4 isoform X4', 54, NULL, NULL, 111919),
(111920, '3.40.50.1820-FF-001273', NULL, 'Uncharacterized protein', 299, NULL, NULL, 111920),
(111921, '3.40.50.80-FF-000096', NULL, 'NADPH-dependent ferric siderophore reductase', 132, NULL, NULL, 111921),
(111922, '3.30.70.330-FF-000586', NULL, 'Nucleolysin TIA-1 isoform p40', 70, NULL, NULL, 111922),
(111923, '1.10.630.10-FF-000047', NULL, 'Cytochrome P450 monooxygenase', 470, NULL, NULL, 111923),
(111924, '3.30.450.20-FF-000266', NULL, 'Voltage-dependent calcium channel subunit alpha-2/delta-1', 86, NULL, NULL, 111924),
(111925, '1.20.1560.10-FF-000595', NULL, 'ABC transporter', 342, NULL, NULL, 111925),
(111926, '1.25.40.10-FF-000951', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 111, NULL, NULL, 111926),
(111927, '2.30.29.30-FF-000455', NULL, 'Psy2p', 116, NULL, NULL, 111927),
(111928, '2.130.10.10-FF-006051', NULL, 'Uncharacterized protein', 178, NULL, NULL, 111928),
(111929, '2.60.40.10-FF-005466', NULL, NULL, 103, NULL, NULL, 111929),
(111930, '1.20.1250.20-FF-001400', NULL, 'Major facilitator superfamily MFS_1', 188, NULL, NULL, 111930),
(111931, '1.10.8.10-FF-000347', NULL, 'Uncharacterized protein', 12, NULL, NULL, 111931),
(111932, '3.90.870.10-FF-000011', NULL, 'tRNA threonylcarbamoyl adenosine modification protein, Sua5/YciO/YrdC/YwlC family', 186, NULL, NULL, 111932),
(111933, '3.90.950.10-FF-000012', NULL, 'dTTP/UTP pyrophosphatase', 179, NULL, NULL, 111933),
(111934, '3.30.160.60-FF-000036', NULL, 'GLI family zinc finger 3', 32, NULL, NULL, 111934),
(111935, '1.25.10.10-FF-001287', NULL, 'Armadillo repeat-containing protein wrm-1', 652, NULL, NULL, 111935),
(111936, '2.60.40.10-FF-002857', NULL, 'GD11718', 111, NULL, NULL, 111936),
(111937, '2.60.40.10-FF-002032', NULL, 'FiLamiN (Actin binding protein) homolog', 81, NULL, NULL, 111937),
(111938, '3.30.420.10-FF-000492', NULL, NULL, 119, NULL, NULL, 111938),
(111939, '2.120.10.30-FF-000099', NULL, 'Meiotic P26, isoform C', 282, NULL, NULL, 111939),
(111940, '1.20.1740.10-FF-000249', NULL, 'Solute carrier family 7 member 8b', 311, NULL, NULL, 111940);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(111941, '3.30.200.20-FF-001124', NULL, 'S-receptor kinase1', 102, NULL, NULL, 111941),
(111942, '4.10.400.10-FF-000210', NULL, 'Serine protease nudel', 45, NULL, NULL, 111942),
(111943, '2.60.40.10-FF-001172', NULL, 'Usherin', 106, NULL, NULL, 111943),
(111944, '3.30.230.10-FF-000055', NULL, 'DNA topoisomerase (ATP-hydrolyzing)', 168, NULL, NULL, 111944),
(111945, '3.90.190.10-FF-000156', NULL, 'Inositol_hexakisphosphate', 335, NULL, NULL, 111945),
(111946, '3.30.160.60-FF-003127', NULL, 'GM26116', 29, NULL, NULL, 111946),
(111947, '3.30.450.20-FF-000327', NULL, 'Methyl-accepting chemotaxis protein', 136, NULL, NULL, 111947),
(111948, '3.40.50.1000-FF-000015', NULL, 'CTD small phosphatase-like protein 2', 181, NULL, NULL, 111948),
(111949, '2.60.120.10-FF-000460', NULL, 'Uncharacterized protein', 161, NULL, NULL, 111949),
(111950, '3.30.70.330-FF-000804', NULL, 'Poly(A) binding protein', 144, NULL, NULL, 111950),
(111951, '3.40.1110.10-FF-000274', NULL, NULL, 19, NULL, NULL, 111951),
(111952, '3.40.50.1100-FF-000219', NULL, 'Protein CBG07184', 41, NULL, NULL, 111952),
(111953, '3.30.420.40-FF-000253', NULL, 'Heat shock protein, putative', 132, NULL, NULL, 111953),
(111954, '1.25.40.10-FF-002132', NULL, 'Pentatricopeptide repeat-containing protein', 82, NULL, NULL, 111954),
(111955, '1.20.1110.10-FF-000123', NULL, NULL, 259, NULL, NULL, 111955),
(111956, '2.10.70.10-FF-000153', NULL, 'Hig-anchoring scaffold protein, isoform A', 55, NULL, NULL, 111956),
(111957, '3.40.190.10-FF-000414', NULL, 'DNA-binding transcriptional regulator, LysR family', 94, NULL, NULL, 111957),
(111958, '3.40.50.1820-FF-000492', NULL, 'Putative phospholipase', 470, NULL, NULL, 111958),
(111959, '2.40.128.180-FF-000005', NULL, NULL, 68, NULL, NULL, 111959),
(111960, '3.30.2140.20-FF-000023', NULL, 'Uncharacterized protein', 186, NULL, NULL, 111960),
(111961, '1.10.10.60-FF-001138', NULL, NULL, 59, NULL, NULL, 111961),
(111962, '2.60.40.60-FF-000141', NULL, 'Cadherin 23', 125, NULL, NULL, 111962),
(111963, '3.90.20.20-FF-000012', NULL, 'Protein GrpE', 99, NULL, NULL, 111963),
(111964, '1.25.40.10-FF-004318', NULL, 'Uncharacterized protein', 176, NULL, NULL, 111964),
(111965, '2.40.50.140-FF-000953', NULL, NULL, 63, NULL, NULL, 111965),
(111966, '3.40.50.720-FF-000056', NULL, 'ADP-L-glycero-D-manno-heptose-6-epimerase', 201, NULL, NULL, 111966),
(111967, '2.40.50.100-FF-000172', NULL, 'ABC transporter ATP-binding protein', 45, NULL, NULL, 111967),
(111968, '3.40.50.1000-FF-000690', NULL, NULL, 139, NULL, NULL, 111968),
(111969, '3.40.50.300-FF-005337', NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', 168, NULL, NULL, 111969),
(111970, '3.30.70.270-FF-000135', NULL, 'Uncharacterized protein', 28, NULL, NULL, 111970),
(111971, '1.25.10.10-FF-002568', NULL, 'Uncharacterized protein', 168, NULL, NULL, 111971),
(111972, '1.25.40.10-FF-003413', NULL, 'Os05g0305300 protein', 121, NULL, NULL, 111972),
(111973, '1.20.1070.10-FF-000164', NULL, 'Muscarinic acetylcholine receptor', 117, NULL, NULL, 111973),
(111974, '2.40.70.10-FF-000174', NULL, 'Uncharacterized protein', 125, NULL, NULL, 111974),
(111975, '3.80.10.10-FF-002364', NULL, 'Uncharacterized protein', 105, NULL, NULL, 111975),
(111976, '2.60.40.10-FF-003313', NULL, 'Cell adhesion molecule, putative', 106, NULL, NULL, 111976),
(111977, '2.130.10.10-FF-001380', NULL, 'WD repeat-containing protein 11 isoform X1', 188, NULL, NULL, 111977),
(111978, '1.10.555.10-FF-000024', NULL, 'Rho GTPase-activating protein 1', 210, NULL, NULL, 111978),
(111979, '2.10.90.10-FF-000148', NULL, 'Uncharacterized protein', 104, NULL, NULL, 111979),
(111980, '2.70.130.10-FF-000020', NULL, 'Insulin-like growth factor 2 receptor', 154, NULL, NULL, 111980),
(111981, '2.40.50.90-FF-000033', NULL, 'Transcription factor (Snd1/p100), putative', 149, NULL, NULL, 111981),
(111982, '3.30.450.30-FF-000044', NULL, 'Profilin', 123, NULL, NULL, 111982),
(111983, '1.10.8.10-FF-000167', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 47, NULL, NULL, 111983),
(111984, '1.10.287.1490-FF-000031', NULL, 'Putative WEB family protein chloroplastic', 178, NULL, NULL, 111984);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(111985, '1.10.268.20-FF-000005', NULL, NULL, 146, NULL, NULL, 111985),
(111986, '2.40.240.10-FF-000041', NULL, '50S ribosomal protein L25', 98, NULL, NULL, 111986),
(111987, '3.90.25.10-FF-000059', NULL, 'dTDP-glucose 4,6-dehydratase, putative', 56, NULL, NULL, 111987),
(111988, '4.10.410.10-FF-000036', NULL, 'Protein CBR-MEC-1', 69, NULL, NULL, 111988),
(111989, '1.20.140.150-FF-000113', NULL, 'uncharacterized protein LOC100175559', 149, NULL, NULL, 111989),
(111990, '3.30.70.100-FF-000112', NULL, 'Stress-response A/B barrel domain-containing protein DABB1', 102, NULL, NULL, 111990),
(111991, '1.25.40.10-FF-000103', NULL, 'small glutamine-rich tetratricopeptide repeat-containing protein beta', 187, NULL, NULL, 111991),
(111992, '1.10.510.10-FF-001409', NULL, 'CK1 family protein kinase', 306, NULL, NULL, 111992),
(111993, '3.90.1150.10-FF-000321', NULL, 'Uncharacterized protein', 55, NULL, NULL, 111993),
(111994, '3.40.50.300-FF-001503', NULL, 'Replication factor C subunit 3', 189, NULL, NULL, 111994),
(111995, '1.10.510.10-FF-002129', NULL, 'Uncharacterized protein', 222, NULL, NULL, 111995),
(111996, '2.70.170.10-FF-000062', NULL, 'Histamine-gated chloride channel subunit', 45, NULL, NULL, 111996),
(111997, '3.40.50.1010-FF-000075', NULL, 'Ribonuclease VapC', 126, NULL, NULL, 111997),
(111998, '1.25.40.180-FF-000093', NULL, 'Non-muscle caldesmon, putative', 247, NULL, NULL, 111998),
(111999, '3.40.640.10-FF-000039', NULL, 'Tryptophanase', 266, NULL, NULL, 111999),
(112000, '2.20.70.10-FF-000276', NULL, 'Predicted protein', 27, NULL, NULL, 112000),
(112001, '4.10.60.10-FF-000248', NULL, 'Uncharacterized protein', 49, NULL, NULL, 112001),
(112002, '3.40.50.10930-FF-000008', NULL, NULL, 142, NULL, NULL, 112002),
(112003, '3.90.70.10-FF-000366', NULL, 'Putative ubiquitin-hydrolase domain protein', 166, NULL, NULL, 112003),
(112004, '3.20.20.80-FF-000550', NULL, 'Mannan endo-1,4-beta-mannosidase', 385, NULL, NULL, 112004),
(112005, '1.20.20.10-FF-000011', NULL, 'ATP synthase subunit c', 72, NULL, NULL, 112005),
(112006, '3.30.230.10-FF-000398', NULL, 'Uncharacterized protein', 131, NULL, NULL, 112006),
(112007, '2.40.37.10-FF-000086', NULL, NULL, 50, NULL, NULL, 112007),
(112008, '3.40.850.10-FF-000414', NULL, 'Uncharacterized protein', 238, NULL, NULL, 112008),
(112009, '2.60.120.260-FF-000082', NULL, 'Sad1/UNC domain protein', 142, NULL, NULL, 112009),
(112010, '3.50.50.60-FF-000802', NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', 260, NULL, NULL, 112010),
(112011, '3.30.565.10-FF-000467', NULL, 'TNF receptor-associated protein 1', 140, NULL, NULL, 112011),
(112012, '3.30.70.1230-FF-000036', NULL, 'Adenylate/guanylate cyclase catalytic domain protein', 218, NULL, NULL, 112012),
(112013, '3.30.160.60-FF-004555', NULL, NULL, 28, NULL, NULL, 112013),
(112014, '2.60.40.10-FF-003942', NULL, NULL, 105, NULL, NULL, 112014),
(112015, '2.10.25.10-FF-000806', NULL, 'fibrillin-1', 38, NULL, NULL, 112015),
(112016, '1.25.10.10-FF-002304', NULL, 'AP-3 complex subunit delta', 321, NULL, NULL, 112016),
(112017, '3.10.110.10-FF-000169', NULL, 'Orf protein', 83, NULL, NULL, 112017),
(112018, '1.20.1560.10-FF-000095', NULL, 'ABC multidrug transporter Mdr2', 281, NULL, NULL, 112018),
(112019, '1.20.1510.10-FF-000092', NULL, NULL, 214, NULL, NULL, 112019),
(112020, '3.30.160.60-FF-005915', NULL, NULL, 77, NULL, NULL, 112020),
(112021, '2.40.30.10-FF-000109', NULL, 'NADPH--cytochrome P450 reductase', 104, NULL, NULL, 112021),
(112022, '3.40.33.10-FF-000187', NULL, 'Uncharacterized protein', 205, NULL, NULL, 112022),
(112023, '1.10.287.70-FF-000654', NULL, 'Protein CBR-TWK-17', 148, NULL, NULL, 112023),
(112024, '1.10.510.10-FF-002360', NULL, NULL, 185, NULL, NULL, 112024),
(112025, '2.60.40.60-FF-000618', NULL, 'Uncharacterized protein', 115, NULL, NULL, 112025),
(112026, '1.20.5.270-FF-000005', NULL, 'Cytochrome b-c1 complex subunit Rieske, mitochondrial', 62, NULL, NULL, 112026),
(112027, '3.80.10.10-FF-003645', NULL, 'Os08g0203400 protein', 94, NULL, NULL, 112027),
(112028, '2.40.170.10-FF-000001', NULL, 'Maltoporin', 417, NULL, NULL, 112028);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(112029, '3.40.50.11980-FF-000020', NULL, 'Uncharacterized protein', 211, NULL, NULL, 112029),
(112030, '2.130.10.10-FF-004994', NULL, 'SOF1 protein-related protein', 67, NULL, NULL, 112030),
(112031, '2.60.120.820-FF-000025', NULL, 'Uncharacterized protein', 40, NULL, NULL, 112031),
(112032, '1.25.40.420-FF-000002', NULL, 'Kelch-like family member 13', 103, NULL, NULL, 112032),
(112033, '3.40.720.10-FF-000192', NULL, 'Uncharacterized protein', 273, NULL, NULL, 112033),
(112034, '3.40.50.1240-FF-000188', NULL, NULL, 79, NULL, NULL, 112034),
(112035, '1.25.40.800-FF-000015', NULL, 'Uncharacterized protein', 91, NULL, NULL, 112035),
(112036, '1.10.357.140-FF-000012', NULL, 'Prenyltransferase, UbiA family', 151, NULL, NULL, 112036),
(112037, '2.40.160.10-FF-000040', NULL, 'Voltage-dependent anion-selective channel, putative', 275, NULL, NULL, 112037),
(112038, '1.20.58.60-FF-000663', NULL, 'Uncharacterized protein', 171, NULL, NULL, 112038),
(112039, '1.10.510.10-FF-003641', NULL, NULL, 189, NULL, NULL, 112039),
(112040, '1.10.510.10-FF-003765', NULL, NULL, 139, NULL, NULL, 112040),
(112041, '2.40.50.140-FF-000689', NULL, 'Predicted protein', 114, NULL, NULL, 112041),
(112042, '3.40.50.10190-FF-000011', NULL, 'DNA repair protein REV1', 92, NULL, NULL, 112042),
(112043, '2.30.110.10-FF-000045', NULL, 'Oxidase', 147, NULL, NULL, 112043),
(112044, '2.20.100.10-FF-000097', NULL, 'ADAMTS like 5', 54, NULL, NULL, 112044),
(112045, '3.40.50.880-FF-000019', NULL, 'Phosphoribosylformylglycinamidine synthase subunit PurQ', 221, NULL, NULL, 112045),
(112046, '2.160.20.20-FF-000011', NULL, 'Uncharacterized protein', 338, NULL, NULL, 112046),
(112047, '3.40.50.2000-FF-000006', NULL, 'Sucrose synthase', 228, NULL, NULL, 112047),
(112048, '1.25.40.180-FF-000172', NULL, NULL, 189, NULL, NULL, 112048),
(112049, '1.25.40.10-FF-002396', NULL, 'ERAD-associated E3 ubiquitin-protein ligase component HRD3A', 168, NULL, NULL, 112049),
(112050, '3.30.70.330-FF-000243', NULL, 'DNA polymerase delta-interacting protein 3', 112, NULL, NULL, 112050),
(112051, '2.120.10.80-FF-000277', NULL, 'Predicted protein', 304, NULL, NULL, 112051),
(112052, '3.40.50.620-FF-000621', NULL, 'Transport protein (Probable substrate cationic amino acids)', 146, NULL, NULL, 112052),
(112053, '2.60.200.20-FF-000166', NULL, 'Nibrin, putative', 108, NULL, NULL, 112053),
(112054, '2.130.10.10-FF-002785', NULL, 'Uncharacterized protein', 213, NULL, NULL, 112054),
(112055, '2.10.25.10-FF-000110', NULL, 'Signal peptide, CUB domain and EGF-like domain-containing 1', 40, NULL, NULL, 112055),
(112056, '3.10.100.10-FF-000264', NULL, NULL, 128, NULL, NULL, 112056),
(112057, '1.20.1070.10-FF-002193', NULL, 'Uncharacterized protein', 55, NULL, NULL, 112057),
(112058, '3.30.70.330-FF-001524', NULL, NULL, 98, NULL, NULL, 112058),
(112059, '1.20.810.10-FF-000031', NULL, 'Uncharacterized protein', 119, NULL, NULL, 112059),
(112060, '2.130.10.10-FF-001149', NULL, 'Uncharacterized protein', 85, NULL, NULL, 112060),
(112061, '2.60.120.260-FF-000643', NULL, 'Uncharacterized protein', 102, NULL, NULL, 112061),
(112062, '2.60.40.720-FF-000008', NULL, 'Runx2b splice form 4', 52, NULL, NULL, 112062),
(112063, '3.30.70.330-FF-001867', NULL, NULL, 164, NULL, NULL, 112063),
(112064, '3.10.50.10-FF-000025', NULL, 'Chitinase, putative', 34, NULL, NULL, 112064),
(112065, '3.30.1490.180-FF-000009', NULL, 'DNA-directed RNA polymerase subunit', 41, NULL, NULL, 112065),
(112066, '2.40.20.10-FF-000103', NULL, 'Uncharacterized protein', 93, NULL, NULL, 112066),
(112067, '3.10.250.10-FF-000090', NULL, NULL, 108, NULL, NULL, 112067),
(112068, '4.10.900.10-FF-000023', NULL, 'Cadherin 18, type 2a', 85, NULL, NULL, 112068),
(112069, '3.30.1340.30-FF-000007', NULL, 'Osmotically inducible protein', 66, NULL, NULL, 112069),
(112070, '3.40.50.360-FF-000072', NULL, 'Flavodoxin', 149, NULL, NULL, 112070),
(112071, '3.40.390.10-FF-000154', NULL, 'Metalloendopeptidase', 231, NULL, NULL, 112071),
(112072, '3.40.50.300-FF-007170', NULL, 'Uncharacterized protein', 173, NULL, NULL, 112072),
(112073, '3.30.70.920-FF-000049', NULL, 'Transcriptional regulator, AsnC family', 84, NULL, NULL, 112073);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(112074, '3.30.750.44-FF-000007', NULL, 'Periplasmic tail-specific protease', 91, NULL, NULL, 112074),
(112075, '3.80.10.10-FF-003988', NULL, 'Adenylate cyclase', 157, NULL, NULL, 112075),
(112076, '3.40.1620.70-FF-000004', NULL, 'Collagen, type XV, alpha 1b', 37, NULL, NULL, 112076),
(112077, '3.40.50.2300-FF-000158', NULL, 'Sensor histidine kinase/response regulator', 141, NULL, NULL, 112077),
(112078, '3.60.10.10-FF-000049', NULL, 'uncharacterized protein LOC103698197 isoform X2', 293, NULL, NULL, 112078),
(112079, '3.40.50.1370-FF-000047', NULL, NULL, 129, NULL, NULL, 112079),
(112080, '3.30.750.24-FF-000001', NULL, 'Anti-sigma factor antagonist', 111, NULL, NULL, 112080),
(112081, '3.30.930.10-FF-000311', NULL, 'tRNA synthetase-related / tRNA ligase-like protein', 64, NULL, NULL, 112081),
(112082, '3.90.70.10-FF-000630', NULL, 'Ubiquitin specific protease, putative', 123, NULL, NULL, 112082),
(112083, '2.60.40.2070-FF-000006', NULL, 'Fimbrial assembly protein', 77, NULL, NULL, 112083),
(112084, '1.25.40.20-FF-000544', NULL, 'RBR-type E3 ubiquitin transferase', 230, NULL, NULL, 112084),
(112085, '2.30.180.10-FF-000032', NULL, 'Fasciclin domain-containing protein, putative', 138, NULL, NULL, 112085),
(112086, '2.60.40.10-FF-005387', NULL, NULL, 54, NULL, NULL, 112086),
(112087, '3.40.190.10-FF-000757', NULL, 'Hydroxymethylbilane synthase (Porphobilinogen deaminase)', 40, NULL, NULL, 112087),
(112088, '2.60.40.1150-FF-000005', NULL, 'Adaptor protein (AP) family protein', 107, NULL, NULL, 112088),
(112089, '3.20.20.80-FF-000139', NULL, 'Uncharacterized protein, isoform B', 268, NULL, NULL, 112089),
(112090, '3.40.50.1980-FF-000056', NULL, 'Ferric hydroxamate receptor 1', 163, NULL, NULL, 112090),
(112091, '3.10.20.90-FF-000901', NULL, 'Uncharacterized protein', 120, NULL, NULL, 112091),
(112092, '3.40.30.10-FF-000326', NULL, 'Bacterioferritin comigratory protein', 149, NULL, NULL, 112092),
(112093, '1.10.12.10-FF-000026', NULL, '3-hydroxybutyryl-CoA dehydratase', 53, NULL, NULL, 112093),
(112094, '3.40.50.2000-FF-000681', NULL, 'Glycosyl transferase group 1', 195, NULL, NULL, 112094),
(112095, '3.90.550.20-FF-000029', NULL, 'Uncharacterized protein', 273, NULL, NULL, 112095),
(112096, '3.40.50.300-FF-004376', NULL, 'Uncharacterized protein', 204, NULL, NULL, 112096),
(112097, '1.20.58.70-FF-000048', NULL, 'Syntaxin 7-like', 124, NULL, NULL, 112097),
(112098, '3.30.1330.30-FF-000046', NULL, '60S ribosomal protein L7ae/L30e, putative', 129, NULL, NULL, 112098),
(112099, '3.30.230.70-FF-000101', NULL, '3''-5''-exoribonuclease family protein', 179, NULL, NULL, 112099),
(112100, '1.25.40.10-FF-001856', NULL, 'Pentatricopeptide repeat-containing protein', 153, NULL, NULL, 112100),
(112101, '3.90.550.10-FF-000083', NULL, 'Glucose-1-phosphate adenylyltransferase', 275, NULL, NULL, 112101),
(112102, '1.10.150.20-FF-000137', NULL, 'DNApol-iota, isoform A', 76, NULL, NULL, 112102),
(112103, '3.30.160.60-FF-002689', NULL, 'Protein suppressor of hairy wing', 26, NULL, NULL, 112103),
(112104, '3.30.420.40-FF-000596', NULL, 'Heat shock protein 70 homolog LHS1, putative', 155, NULL, NULL, 112104),
(112105, '3.30.420.100-FF-000001', NULL, '50S ribosomal protein L18', 116, NULL, NULL, 112105),
(112106, '2.10.25.10-FF-000189', NULL, 'Laminin subunit alpha 2', 46, NULL, NULL, 112106),
(112107, '1.10.3210.10-FF-000077', NULL, 'dGTP triphosphohydrolase', 353, NULL, NULL, 112107),
(112108, '3.30.1420.10-FF-000002', NULL, 'Sulfurtransferase', 36, NULL, NULL, 112108),
(112109, '1.25.40.20-FF-001393', NULL, 'Transient receptor potential channel 4, putative', 285, NULL, NULL, 112109),
(112110, '3.30.559.30-FF-000009', NULL, 'Nonribosomal peptide synthase Pes1', 221, NULL, NULL, 112110),
(112111, '3.30.200.20-FF-000848', NULL, 'Tyrosine-sulfated glycopeptide receptor 1', 111, NULL, NULL, 112111),
(112112, '3.40.50.620-FF-000060', NULL, 'Leucine--tRNA ligase', 116, NULL, NULL, 112112),
(112113, '3.30.479.30-FF-000008', NULL, 'Stomatin-like protein 2, mitochondrial', 133, NULL, NULL, 112113),
(112114, '3.30.160.60-FF-001464', NULL, 'Uncharacterized protein', 29, NULL, NULL, 112114);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(112115, '3.40.1390.10-FF-000002', NULL, 'UDP-N-acetylmuramoyl-L-alanyl-D-glutamate--2,6-diaminopimelate ligase', 103, NULL, NULL, 112115),
(112116, '1.10.10.970-FF-000002', NULL, 'Tpt1p', 77, NULL, NULL, 112116),
(112117, '3.40.50.720-FF-000617', NULL, 'NEDD8-activating enzyme E1 catalytic subunit', 228, NULL, NULL, 112117),
(112118, '2.130.10.10-FF-005270', NULL, 'Uncharacterized protein', 253, NULL, NULL, 112118),
(112119, '1.20.140.10-FF-000137', NULL, 'Uncharacterized protein', 47, NULL, NULL, 112119),
(112120, '3.30.160.60-FF-004898', NULL, NULL, 37, NULL, NULL, 112120),
(112121, '1.10.510.10-FF-000331', NULL, 'Mitogen-activated protein kinase kinase kinase 19', 268, NULL, NULL, 112121),
(112122, '3.30.1340.10-FF-000001', NULL, 'Phosphocarrier, HPr family', 85, NULL, NULL, 112122),
(112123, '3.30.479.20-FF-000062', NULL, 'Elongation factor Ts, mitochondrial', 132, NULL, NULL, 112123),
(112124, '2.60.40.150-FF-000023', NULL, 'Double C2-like domain-containing protein', 138, NULL, NULL, 112124),
(112125, '1.20.1720.10-FF-000074', NULL, 'Uncharacterized protein', 242, NULL, NULL, 112125),
(112126, '3.40.50.2300-FF-000427', NULL, 'Pheromone and odorant receptor, putative', 280, NULL, NULL, 112126),
(112127, '1.20.1560.10-FF-000943', NULL, 'Uncharacterized protein', 309, NULL, NULL, 112127),
(112128, '3.40.50.2000-FF-001018', NULL, 'Uncharacterized protein', 183, NULL, NULL, 112128),
(112129, '3.30.160.20-FF-000108', NULL, 'Double-stranded RNA-binding protein', 70, NULL, NULL, 112129),
(112130, '3.30.559.70-FF-000049', NULL, 'Uncharacterized protein', 168, NULL, NULL, 112130),
(112131, '3.30.1370.110-FF-000012', NULL, 'UBA/TS-N_domain/CUE_domain/Domain_of_uncharacterized_function_(DUF1771)/Smr_domain_containing_protein', 103, NULL, NULL, 112131),
(112132, '3.40.50.300-FF-006793', NULL, 'Uncharacterized protein', 56, NULL, NULL, 112132),
(112133, '3.10.580.10-FF-000136', NULL, 'Chloride channel protein', 73, NULL, NULL, 112133),
(112134, '3.30.70.330-FF-002480', NULL, NULL, 78, NULL, NULL, 112134),
(112135, '3.80.10.10-FF-002184', NULL, 'Leucine-rich repeat protein (LRRP), putative', 113, NULL, NULL, 112135),
(112136, '3.30.160.100-FF-000020', NULL, 'Ribosome hibernation promoting factor', 109, NULL, NULL, 112136),
(112137, '2.60.40.10-FF-005915', NULL, NULL, 43, NULL, NULL, 112137),
(112138, '1.20.1740.10-FF-000125', NULL, 'Arginine permease, putative', 488, NULL, NULL, 112138),
(112139, '3.80.10.10-FF-002240', NULL, 'Uncharacterized protein', 104, NULL, NULL, 112139),
(112140, '3.90.190.10-FF-000268', NULL, 'Si:ch1073-391i24.1', 59, NULL, NULL, 112140),
(112141, '3.40.50.2000-FF-000506', NULL, 'OSJNBb0080H08.20 protein', 75, NULL, NULL, 112141),
(112142, '3.30.40.10-FF-000417', NULL, 'E3 ubiquitin ligase BIG BROTHER-related', 82, NULL, NULL, 112142),
(112143, '2.120.10.30-FF-000279', NULL, 'Low density lipoprotein receptor-related protein 5', 145, NULL, NULL, 112143),
(112144, '3.30.720.210-FF-000012', NULL, 'ATP-dependent zinc metalloprotease FtsH', 86, NULL, NULL, 112144),
(112145, '1.20.1720.10-FF-000130', NULL, NULL, 145, NULL, NULL, 112145),
(112146, '2.10.25.10-FF-000745', NULL, 'Sushi, nidogen and EGF like domains 1', 74, NULL, NULL, 112146),
(112147, '3.30.559.70-FF-000061', NULL, 'Predicted protein', 94, NULL, NULL, 112147),
(112148, '2.20.110.10-FF-000047', NULL, 'MORN_repeat', 48, NULL, NULL, 112148),
(112149, '3.30.1050.10-FF-000018', NULL, 'Alkyl/aryl-sulfatase BDS1, putative', 127, NULL, NULL, 112149),
(112150, '3.30.1120.30-FF-000041', NULL, 'Serine/threonine-protein kinase PLK', 50, NULL, NULL, 112150),
(112151, '1.25.10.10-FF-003024', NULL, 'Predicted protein', 578, NULL, NULL, 112151),
(112152, '3.40.1170.60-FF-000040', NULL, NULL, 59, NULL, NULL, 112152),
(112153, '1.10.287.70-FF-000593', NULL, 'Uncharacterized protein', 132, NULL, NULL, 112153),
(112154, '3.20.10.10-FF-000045', NULL, 'Branched-chain amino-acid transaminase, putative (Eurofung)', 188, NULL, NULL, 112154),
(112155, '3.40.50.300-FF-005314', NULL, 'YALI0E02750p', 163, NULL, NULL, 112155),
(112156, '3.40.50.1820-FF-001514', NULL, 'Uncharacterized protein', 151, NULL, NULL, 112156);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(112157, '1.20.1050.10-FF-000281', NULL, 'Glutathione-S-transferase theta, GST, putative', 36, NULL, NULL, 112157),
(112158, '3.30.160.60-FF-002745', NULL, 'Zinc finger protein 284', 28, NULL, NULL, 112158),
(112159, '2.130.10.10-FF-001560', NULL, 'Uncharacterized protein', 348, NULL, NULL, 112159),
(112160, '1.50.40.10-FF-000207', NULL, 'Solute carrier family 25, member 33/36', 218, NULL, NULL, 112160),
(112161, '3.30.40.10-FF-001985', NULL, 'Ariadne homolog 2 (Drosophila)', 58, NULL, NULL, 112161),
(112162, '1.20.1070.10-FF-000276', NULL, 'G protein-coupled receptor 25', 297, NULL, NULL, 112162),
(112163, '1.25.40.10-FF-003537', NULL, 'Uncharacterized protein', 112, NULL, NULL, 112163),
(112164, '3.40.1010.10-FF-000002', NULL, 'Ribosomal RNA small subunit methyltransferase I', 120, NULL, NULL, 112164),
(112165, '2.70.150.10-FF-000139', NULL, 'Cation-transporting ATPase 2, putative', 103, NULL, NULL, 112165),
(112166, '3.40.50.150-FF-000076', NULL, 'probable methyltransferase PMT21', 179, NULL, NULL, 112166),
(112167, '3.10.20.90-FF-000345', NULL, 'Ubiquitin regulatory X', 84, NULL, NULL, 112167),
(112168, '3.40.50.300-FF-002515', NULL, 'ABC transporter ATP-binding protein', 196, NULL, NULL, 112168),
(112169, '1.10.238.10-FF-000523', NULL, 'CAMK/CDPK protein kinase', 80, NULL, NULL, 112169),
(112170, '1.10.510.10-FF-003826', NULL, NULL, 112, NULL, NULL, 112170),
(112171, '1.10.600.10-FF-000034', NULL, 'Farnesyl-diphosphate farnesyltransferase', 364, NULL, NULL, 112171),
(112172, '1.10.630.10-FF-000603', NULL, 'Uncharacterized protein', 271, NULL, NULL, 112172),
(112173, '3.30.160.60-FF-003206', NULL, NULL, 28, NULL, NULL, 112173),
(112174, '3.60.21.10-FF-000361', NULL, 'Uncharacterized protein', 139, NULL, NULL, 112174),
(112175, '3.40.30.10-FF-000618', NULL, 'Protein disulfide isomerase', 155, NULL, NULL, 112175),
(112176, '2.130.10.10-FF-003802', NULL, 'Uncharacterized protein', 310, NULL, NULL, 112176),
(112177, '1.10.238.10-FF-001035', NULL, 'Calcium-binding EF hand family protein', 107, NULL, NULL, 112177),
(112178, '3.40.50.12500-FF-000002', NULL, 'Maleate isomerase', 247, NULL, NULL, 112178),
(112179, '1.10.4160.10-FF-000022', NULL, 'Permease', 496, NULL, NULL, 112179),
(112180, '3.40.50.20-FF-000050', NULL, 'Formate-dependent phosphoribosylglycinamide formyltransferase', 121, NULL, NULL, 112180),
(112181, '1.25.40.720-FF-000030', NULL, 'Uncharacterized protein', 144, NULL, NULL, 112181),
(112182, '1.20.120.430-FF-000002', NULL, 'tRNA modification GTPase GTPBP3, mitochondrial', 164, NULL, NULL, 112182),
(112183, '3.80.10.10-FF-000211', NULL, 'vasorin', 192, NULL, NULL, 112183),
(112184, '2.130.10.10-FF-005831', NULL, 'Uncharacterized protein', 384, NULL, NULL, 112184),
(112185, '2.60.40.10-FF-002301', NULL, 'High Incidence of Males (Increased X chromosome loss)', 93, NULL, NULL, 112185),
(112186, '3.40.190.10-FF-000178', NULL, 'Glutamate receptor subunit', 121, NULL, NULL, 112186),
(112187, '1.10.630.10-FF-000547', NULL, 'Uncharacterized protein', 346, NULL, NULL, 112187),
(112188, '2.60.40.10-FF-001733', NULL, 'Titin', 88, NULL, NULL, 112188),
(112189, '3.10.20.90-FF-000401', NULL, 'UBX domain-containing protein 5', 138, NULL, NULL, 112189),
(112190, '1.10.10.10-FF-000590', NULL, 'Transcriptional regulator, MarR family', 153, NULL, NULL, 112190),
(112191, '3.40.50.1000-FF-000190', NULL, 'Phospholipid-transporting ATPase', 185, NULL, NULL, 112191),
(112192, '3.40.630.30-FF-000432', NULL, 'Acetyltransferase, putative', 119, NULL, NULL, 112192),
(112193, '2.40.33.10-FF-000026', NULL, 'Pyruvate kinase', 70, NULL, NULL, 112193),
(112194, '3.30.230.130-FF-000085', NULL, 'Uncharacterized protein', 148, NULL, NULL, 112194),
(112195, '1.10.1070.11-FF-000055', NULL, 'PIKK family atypical protein kinase', 184, NULL, NULL, 112195),
(112196, '3.30.230.70-FF-000045', NULL, 'Exosome-associated protein 4', 213, NULL, NULL, 112196),
(112197, '1.25.10.10-FF-001467', NULL, 'Protein CLASP-2', 249, NULL, NULL, 112197),
(112198, '2.120.10.80-FF-000092', NULL, 'Dynein heavy chain-like protein', 122, NULL, NULL, 112198);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(112199, '2.30.29.30-FF-000450', NULL, 'Oxysterol-binding protein', 105, NULL, NULL, 112199),
(112200, '1.20.1070.10-FF-001529', NULL, 'Uncharacterized protein', 186, NULL, NULL, 112200),
(112201, '1.25.10.10-FF-000270', NULL, 'Condensin complex subunit 1', 181, NULL, NULL, 112201),
(112202, '3.60.110.10-FF-000028', NULL, 'Hydrolase, putative', 299, NULL, NULL, 112202),
(112203, '1.20.1070.10-FF-000332', NULL, 'Blast:Calcitonin gene-related peptide type 1 receptor', 298, NULL, NULL, 112203),
(112204, '3.80.10.10-FF-003140', NULL, 'Uncharacterized protein', 40, NULL, NULL, 112204),
(112205, '3.30.70.1130-FF-000012', NULL, 'Uncharacterized protein', 67, NULL, NULL, 112205),
(112206, '3.30.40.10-FF-001878', NULL, 'Uncharacterized protein', 76, NULL, NULL, 112206),
(112207, '3.30.160.60-FF-006056', NULL, NULL, 48, NULL, NULL, 112207),
(112208, '1.10.510.10-FF-003141', NULL, NULL, 181, NULL, NULL, 112208),
(112209, '3.40.309.10-FF-000045', NULL, 'Gamma-glutamyl phosphate reductase-like protein', 155, NULL, NULL, 112209),
(112210, '1.10.10.10-FF-001843', NULL, 'LD29662p', 85, NULL, NULL, 112210),
(112211, '1.20.1250.20-FF-001007', NULL, 'solute carrier family 2, facilitated glucose transporter member 6 isoform X2', 99, NULL, NULL, 112211),
(112212, '3.20.20.80-FF-000471', NULL, 'Arabinogalactan endo-beta-1,4-galactanase', 347, NULL, NULL, 112212),
(112213, '3.30.160.60-FF-002638', NULL, 'Zinc finger protein 416', 47, NULL, NULL, 112213),
(112214, '3.80.10.10-FF-002925', NULL, 'Uncharacterized protein', 98, NULL, NULL, 112214),
(112215, '3.30.70.1450-FF-000046', NULL, 'Predicted protein', 76, NULL, NULL, 112215),
(112216, '1.20.1070.10-FF-000225', NULL, 'Opsin 3', 307, NULL, NULL, 112216),
(112217, '1.10.110.10-FF-000019', NULL, 'Bifunctional inhibitor/lipid-transfer protein/seed storage 2S albumin superfamily protein', 83, NULL, NULL, 112217),
(112218, '1.20.1050.10-FF-000218', NULL, 'Predicted protein', 111, NULL, NULL, 112218),
(112219, '3.40.50.300-FF-001947', NULL, 'ESX-1 secretion system protein EccCb1', 237, NULL, NULL, 112219),
(112220, '2.30.42.10-FF-000317', NULL, 'Uncharacterized protein', 61, NULL, NULL, 112220),
(112221, '1.10.8.60-FF-000452', NULL, 'Lon protease homolog, mitochondrial', 108, NULL, NULL, 112221),
(112222, '3.40.50.620-FF-000695', NULL, 'Nicotinamide-nucleotide adenylyltransferase', 261, NULL, NULL, 112222),
(112223, '3.30.160.60-FF-001441', NULL, 'Zinc finger protein 217', 56, NULL, NULL, 112223),
(112224, '2.60.40.10-FF-004662', NULL, NULL, 102, NULL, NULL, 112224),
(112225, '1.10.510.10-FF-003933', NULL, NULL, 69, NULL, NULL, 112225),
(112226, '2.70.220.10-FF-000004', NULL, 'Related to phosphatidylglycerol/phosphatidylinositol transfer protein', 70, NULL, NULL, 112226),
(112227, '3.30.160.60-FF-001385', NULL, 'zinc finger protein 774', 29, NULL, NULL, 112227),
(112228, '3.40.50.720-FF-000848', NULL, 'UDP-glucose 4-epimerase galE1', 202, NULL, NULL, 112228),
(112229, '2.130.10.10-FF-000929', NULL, 'Ribosomal assembly complex component Ipi3', 149, NULL, NULL, 112229),
(112230, '3.60.15.10-FF-000189', NULL, 'Beta-lactamase-like protein', 214, NULL, NULL, 112230),
(112231, '3.90.660.10-FF-000136', NULL, NULL, 24, NULL, NULL, 112231),
(112232, '1.20.1250.20-FF-001900', NULL, 'Predicted protein', 55, NULL, NULL, 112232),
(112233, '1.10.10.10-FF-001051', NULL, 'Carminomycin 4-O-methyltransferase DnrK', 97, NULL, NULL, 112233),
(112234, '2.40.50.140-FF-000397', NULL, 'Probable DNA-directed RNA polymerase II chain Rpb7', 89, NULL, NULL, 112234),
(112235, '3.30.310.50-FF-000040', NULL, 'Threonine aldolase', 98, NULL, NULL, 112235),
(112236, '3.20.20.190-FF-000007', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', 173, NULL, NULL, 112236),
(112237, '1.10.510.10-FF-003877', NULL, NULL, 92, NULL, NULL, 112237),
(112238, '3.50.50.60-FF-000977', NULL, 'Uncharacterized protein', 109, NULL, NULL, 112238),
(112239, '3.40.50.620-FF-000700', NULL, 'Electron transfer flavoprotein beta subunit EtfB', 248, NULL, NULL, 112239),
(112240, '2.20.25.370-FF-000001', NULL, 'IPI internal head protein', 39, NULL, NULL, 112240);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(112241, '3.40.109.10-FF-000041', NULL, 'Nitroreductase family protein', 247, NULL, NULL, 112241),
(112242, '3.30.160.60-FF-006112', NULL, NULL, 50, NULL, NULL, 112242),
(112243, '3.20.20.140-FF-000476', NULL, 'Adenosine deaminase 2', 152, NULL, NULL, 112243),
(112244, '3.30.70.330-FF-001816', NULL, NULL, 139, NULL, NULL, 112244),
(112245, '2.130.10.10-FF-002009', NULL, 'Eukaryotic translation initiation factor 2A', 152, NULL, NULL, 112245),
(112246, '3.40.50.300-FF-002408', NULL, 'Rab32 family GTPase, putative', 209, NULL, NULL, 112246),
(112247, '2.160.20.10-FF-000002', NULL, 'Endopolygalacturonase D', 337, NULL, NULL, 112247),
(112248, '3.90.1750.10-FF-000013', NULL, 'Apoptosis-resistant E3 ubiquitin protein ligase 1', 166, NULL, NULL, 112248),
(112249, '1.20.200.10-FF-000024', NULL, 'Uncharacterized protein', 121, NULL, NULL, 112249),
(112250, '1.10.510.10-FF-001909', NULL, 'Inhibitor of nuclear factor kappa B kinase subunit beta', 155, NULL, NULL, 112250),
(112251, '1.20.1280.50-FF-000214', NULL, 'Predicted protein', 46, NULL, NULL, 112251),
(112252, '3.20.20.80-FF-000319', NULL, 'Putative beta-glucosidase 15', 240, NULL, NULL, 112252),
(112253, '3.30.930.10-FF-000232', NULL, 'PEK/GCN2 protein kinase', 338, NULL, NULL, 112253),
(112254, '3.10.180.10-FF-000100', NULL, 'Glyoxalase family protein', 130, NULL, NULL, 112254),
(112255, '2.10.25.10-FF-000638', NULL, 'Uncharacterized protein, isoform A', 40, NULL, NULL, 112255),
(112256, '3.30.450.40-FF-000081', NULL, 'Vanadium nitrogenase sigma54-dependent transcriptional activator, VnfA', 176, NULL, NULL, 112256),
(112257, '2.60.40.10-FF-005230', NULL, NULL, 115, NULL, NULL, 112257),
(112258, '3.50.50.60-FF-001123', NULL, 'Predicted protein', 133, NULL, NULL, 112258),
(112259, '1.10.472.10-FF-000174', NULL, 'Cyclin-D1-1', 97, NULL, NULL, 112259),
(112260, '3.10.580.10-FF-000029', NULL, 'Chloride channel protein', 72, NULL, NULL, 112260),
(112261, '3.30.60.90-FF-000009', NULL, 'ZZ-type zinc finger-containing protein 3 isoform X1', 61, NULL, NULL, 112261),
(112262, '1.10.10.2330-FF-000006', NULL, 'Phenylalanine-tRNA ligase, alpha subunit', 48, NULL, NULL, 112262),
(112263, '1.20.5.170-FF-000032', NULL, 'UDP-3-O-(3-hydroxymyristoyl)glucosamine N-acyltransferase', 32, NULL, NULL, 112263),
(112264, '1.10.1070.11-FF-000004', NULL, 'Phosphatidylinositol 4-kinase, catalytic, beta', 200, NULL, NULL, 112264),
(112265, '1.10.150.110-FF-000027', NULL, 'Uncharacterized protein', 67, NULL, NULL, 112265),
(112266, '2.60.40.1670-FF-000010', NULL, 'Protein transport protein SEC23', 101, NULL, NULL, 112266),
(112267, '1.10.555.10-FF-000209', NULL, NULL, 76, NULL, NULL, 112267),
(112268, '2.120.10.80-FF-000041', NULL, 'kelch-like protein 10 isoform X2', 292, NULL, NULL, 112268),
(112269, '1.20.1740.10-FF-000018', NULL, 'solute carrier family 12 member 3 isoform X2', 453, NULL, NULL, 112269),
(112270, '3.30.70.240-FF-000036', NULL, 'Translation factor GUF1, mitochondrial', 129, NULL, NULL, 112270),
(112271, '3.40.50.1820-FF-000109', NULL, 'Lipase, endothelial', 319, NULL, NULL, 112271),
(112272, '3.40.50.2000-FF-001063', NULL, 'Glycogen [starch] synthase', 95, NULL, NULL, 112272),
(112273, '3.20.20.70-FF-000086', NULL, 'IMP dehydrogenase, putative', 494, NULL, NULL, 112273),
(112274, '3.40.50.2300-FF-000478', NULL, 'Hybrid sensor histidine kinase/response regulator', 120, NULL, NULL, 112274),
(112275, '3.30.200.20-FF-002029', NULL, 'calmodulin-dependent protein kinase homologue isoform X1', 91, NULL, NULL, 112275),
(112276, '3.90.190.10-FF-000217', NULL, 'Tyrosine-protein phosphatase yvh1', 145, NULL, NULL, 112276),
(112277, '2.60.40.10-FF-000795', NULL, 'Hemicentin 1', 96, NULL, NULL, 112277),
(112278, '3.30.70.1230-FF-000216', NULL, 'Predicted protein', 98, NULL, NULL, 112278),
(112279, '3.40.630.150-FF-000016', NULL, 'Uncharacterized protein', 82, NULL, NULL, 112279),
(112280, '1.20.1640.10-FF-000073', NULL, 'PaTched Related family', 169, NULL, NULL, 112280),
(112281, '3.80.10.10-FF-000323', NULL, 'Leucine-rich repeat-containing protein 49 isoform 1', 129, NULL, NULL, 112281);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(112282, '2.60.40.10-FF-002245', NULL, 'Adhesion G protein-coupled receptor F5', 101, NULL, NULL, 112282),
(112283, '1.25.40.10-FF-002637', NULL, 'Clathrin heavy chain', 146, NULL, NULL, 112283),
(112284, '2.60.200.20-FF-000222', NULL, 'Uncharacterized protein', 104, NULL, NULL, 112284),
(112285, '3.30.465.10-FF-000134', NULL, 'Putative oxidoreductase, FAD-binding', 125, NULL, NULL, 112285),
(112286, '3.40.50.1820-FF-000261', NULL, 'Tributyrin esterase', 252, NULL, NULL, 112286),
(112287, '3.40.50.720-FF-001337', NULL, 'Short-chain dehydrogenase/reductase SDR', 252, NULL, NULL, 112287),
(112288, '3.30.160.20-FF-000171', NULL, 'Endoribonuclease Dicer-like 2', 73, NULL, NULL, 112288),
(112289, '2.30.29.30-FF-000394', NULL, 'Uncharacterized protein, isoform B', 106, NULL, NULL, 112289),
(112290, '3.20.20.190-FF-000058', NULL, 'Pgc1p', 255, NULL, NULL, 112290),
(112291, '3.30.70.20-FF-000130', NULL, NULL, 57, NULL, NULL, 112291),
(112292, '1.10.472.10-FF-000674', NULL, 'Uncharacterized protein', 38, NULL, NULL, 112292),
(112293, '1.25.10.10-FF-000955', NULL, 'Related to negative regulator of mitosis', 186, NULL, NULL, 112293),
(112294, '3.40.50.150-FF-001436', NULL, NULL, 148, NULL, NULL, 112294),
(112295, '1.10.1040.50-FF-000002', NULL, 'Trifunctional enzyme subunit alpha, mitochondrial', 212, NULL, NULL, 112295),
(112296, '2.40.50.100-FF-000121', NULL, 'Molybdenum ABC transporter ATP-binding protein', 73, NULL, NULL, 112296),
(112297, '3.10.180.10-FF-000095', NULL, 'Putative N-acetyltransferase YjaB', 123, NULL, NULL, 112297),
(112298, '1.25.40.10-FF-000890', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 102, NULL, NULL, 112298),
(112299, '2.70.98.90-FF-000001', NULL, 'Membrane protein insertase YidC', 280, NULL, NULL, 112299),
(112300, '2.120.10.30-FF-000335', NULL, 'Predicted protein', 56, NULL, NULL, 112300),
(112301, '2.130.10.10-FF-002953', NULL, 'Uncharacterized protein', 289, NULL, NULL, 112301),
(112302, '3.90.79.10-FF-000099', NULL, 'Unplaced genomic scaffold supercont1.9, whole genome shotgun sequence', 224, NULL, NULL, 112302),
(112303, '3.40.50.300-FF-001099', NULL, 'Iron-sulfur cluster carrier protein', 219, NULL, NULL, 112303),
(112304, '3.10.20.90-FF-000289', NULL, 'Ubiquitin-like protein, putative', 74, NULL, NULL, 112304),
(112305, '1.25.40.120-FF-000007', NULL, 'CaaX farnesyltransferase alpha subunit Ram2', 336, NULL, NULL, 112305),
(112306, '3.20.20.140-FF-000072', NULL, 'Hydrolase, TatD family protein', 316, NULL, NULL, 112306),
(112307, '1.10.490.160-FF-000011', NULL, NULL, 161, NULL, NULL, 112307),
(112308, '3.90.1150.10-FF-000309', NULL, 'Transcriptional regulatory protein', 122, NULL, NULL, 112308),
(112309, '1.20.1070.10-FF-000220', NULL, 'Probable G-protein coupled receptor 176', 340, NULL, NULL, 112309),
(112310, '2.30.30.40-FF-000580', NULL, 'Chemotaxis protein', 63, NULL, NULL, 112310),
(112311, '3.90.980.10-FF-000008', NULL, 'DNA primase', 142, NULL, NULL, 112311),
(112312, '3.30.200.20-FF-001568', NULL, 'Uncharacterized protein', 47, NULL, NULL, 112312),
(112313, '1.20.5.170-FF-000083', NULL, 'Transcription factor VIP1', 54, NULL, NULL, 112313),
(112314, '1.25.40.10-FF-004998', NULL, 'Uncharacterized protein', 128, NULL, NULL, 112314),
(112315, '3.80.10.10-FF-002009', NULL, 'NLR family CARD domain containing 3', 75, NULL, NULL, 112315),
(112316, '3.30.497.10-FF-000073', NULL, 'Accessory gland protein Acp76A', 165, NULL, NULL, 112316),
(112317, '1.10.287.110-FF-000015', NULL, 'dnaJ homolog subfamily C member 3', 109, NULL, NULL, 112317),
(112318, '3.30.70.330-FF-001075', NULL, 'RNA-binding protein 8A', 142, NULL, NULL, 112318),
(112319, '2.10.25.10-FF-000790', NULL, 'Fat-like cadherin-related tumor suppressor homolog', 38, NULL, NULL, 112319),
(112320, '1.20.58.60-FF-000394', NULL, 'Nesprin-2', 246, NULL, NULL, 112320),
(112321, '1.10.510.10-FF-004389', NULL, NULL, 91, NULL, NULL, 112321),
(112322, '1.20.140.90-FF-000003', NULL, 'MaLonyl CoA Decarboxylase', 135, NULL, NULL, 112322),
(112323, '1.20.1560.10-FF-000072', NULL, 'ATP binding cassette subfamily B member 5', 22, NULL, NULL, 112323);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(112324, '2.130.10.10-FF-005775', NULL, 'Protein FAN', 105, NULL, NULL, 112324),
(112325, '3.40.50.300-FF-002459', NULL, 'Uncharacterized protein, isoform C', 259, NULL, NULL, 112325),
(112326, '3.30.420.10-FF-000733', NULL, NULL, 46, NULL, NULL, 112326),
(112327, '1.10.287.770-FF-000010', NULL, 'Pickpocket 23, isoform A', 60, NULL, NULL, 112327),
(112328, '3.40.50.1820-FF-001458', NULL, 'Uncharacterized protein', 181, NULL, NULL, 112328),
(112329, '1.10.10.60-FF-000918', NULL, NULL, 66, NULL, NULL, 112329),
(112330, '3.10.580.10-FF-000024', NULL, 'Chloride channel 2c', 122, NULL, NULL, 112330),
(112331, '1.25.40.10-FF-001272', NULL, 'Pentatricopeptide repeat protein', 232, NULL, NULL, 112331),
(112332, '2.60.390.10-FF-000002', NULL, 'Beta-galactosidase', 81, NULL, NULL, 112332),
(112333, '3.30.559.10-FF-000026', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 246, NULL, NULL, 112333),
(112334, '2.130.10.10-FF-000211', NULL, 'striatin isoform X1', 64, NULL, NULL, 112334),
(112335, '1.20.1250.20-FF-000670', NULL, 'MFS general substrate transporter', 246, NULL, NULL, 112335),
(112336, '3.30.40.10-FF-000529', NULL, 'Tetratricopeptide repeat domain 3', 67, NULL, NULL, 112336),
(112337, '2.130.10.10-FF-005770', NULL, 'EF hand family protein', 107, NULL, NULL, 112337),
(112338, '2.60.40.10-FF-001756', NULL, 'Uncharacterized protein, isoform B', 113, NULL, NULL, 112338),
(112339, '3.40.50.300-FF-007231', NULL, 'RAS, putative', 161, NULL, NULL, 112339),
(112340, '3.10.110.10-FF-000326', NULL, 'Uncharacterized protein', 157, NULL, NULL, 112340),
(112341, '3.90.70.10-FF-000815', NULL, 'Uncharacterized protein', 213, NULL, NULL, 112341),
(112342, '3.30.430.20-FF-000040', NULL, 'L-type lectin-domain containing receptor kinase IX.1', 107, NULL, NULL, 112342),
(112343, '1.20.1540.10-FF-000037', NULL, 'Rhomboid family intramembrane serine protease', 211, NULL, NULL, 112343),
(112344, '1.10.510.10-FF-001224', NULL, 'Serine/threonine-protein kinase ATG1t', 284, NULL, NULL, 112344),
(112345, '3.40.190.10-FF-000173', NULL, 'Probable glutamine-binding lipoprotein glnH', 89, NULL, NULL, 112345),
(112346, '3.30.160.60-FF-004662', NULL, NULL, 29, NULL, NULL, 112346),
(112347, '3.90.1150.10-FF-000080', NULL, 'Bifunctional dethiobiotin synthetase/adenosylmethionine-8-amino-7-oxononanoate aminotransferase', 85, NULL, NULL, 112347),
(112348, '2.60.120.200-FF-000108', NULL, 'collagen alpha-1(XXII) chain isoform X1', 224, NULL, NULL, 112348),
(112349, '2.10.50.10-FF-000146', NULL, 'Uncharacterized protein', 45, NULL, NULL, 112349),
(112350, '3.80.10.10-FF-000216', NULL, 'ATP synthase subunit s, mitochondrial isoform X1', 176, NULL, NULL, 112350),
(112351, '3.30.342.10-FF-000006', NULL, 'DNA-directed DNA polymerase', 148, NULL, NULL, 112351),
(112352, '3.10.20.30-FF-000018', NULL, 'Succinate dehydrogenase iron-sulfur subunit', 110, NULL, NULL, 112352),
(112353, '1.25.40.20-FF-001909', NULL, 'Ankyrin 2, isoform E', 70, NULL, NULL, 112353),
(112354, '3.40.1190.20-FF-000107', NULL, 'Bifunctional NAD(P)H-hydrate repair enzyme', 252, NULL, NULL, 112354),
(112355, '3.30.70.330-FF-001367', NULL, 'Uncharacterized protein', 98, NULL, NULL, 112355),
(112356, '2.60.40.60-FF-000377', NULL, 'Dachsous cadherin-related 1a', 102, NULL, NULL, 112356),
(112357, '1.10.720.30-FF-000032', NULL, 'Blast:SAP domain-containing ribonucleoprotein', 46, NULL, NULL, 112357),
(112358, '3.30.40.10-FF-002334', NULL, 'E3 ubiquitin-protein ligase rnf213-beta', 96, NULL, NULL, 112358),
(112359, '1.10.720.30-FF-000083', NULL, 'Predicted protein', 55, NULL, NULL, 112359),
(112360, '3.40.50.300-FF-002403', NULL, 'Ribosome biogenesis GTP-binding protein YsxC', 227, NULL, NULL, 112360),
(112361, '3.10.129.10-FF-000083', NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 152, NULL, NULL, 112361),
(112362, '1.10.220.150-FF-000033', NULL, 'stromal membrane-associated protein 1 isoform X2', 63, NULL, NULL, 112362),
(112363, '1.10.400.10-FF-000002', NULL, 'guanine nucleotide-binding protein G(Q) subunit alpha', 118, NULL, NULL, 112363);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(112364, '2.10.25.10-FF-001127', NULL, 'Fibulin 2', 41, NULL, NULL, 112364),
(112365, '2.30.29.30-FF-000399', NULL, 'Uncharacterized protein, isoform C', 145, NULL, NULL, 112365),
(112366, '1.20.1080.10-FF-000046', NULL, 'Aquaporin', 238, NULL, NULL, 112366),
(112367, '1.10.1670.10-FF-000083', NULL, NULL, 12, NULL, NULL, 112367),
(112368, '2.130.10.10-FF-004426', NULL, 'Predicted protein', 359, NULL, NULL, 112368),
(112369, '3.30.750.24-FF-000057', NULL, 'Anion transporter SULP-1a', 167, NULL, NULL, 112369),
(112370, '3.30.1330.30-FF-000107', NULL, 'selenocysteine insertion sequence-binding protein 2-like isoform X1', 174, NULL, NULL, 112370),
(112371, '2.60.40.10-FF-003605', NULL, 'Natural killer cell receptor 2B4', 112, NULL, NULL, 112371),
(112372, '3.30.40.10-FF-002042', NULL, 'Predicted protein', 95, NULL, NULL, 112372),
(112373, '3.30.110.10-FF-000007', NULL, 'Translation initiation factor IF-3', 98, NULL, NULL, 112373),
(112374, '2.130.10.10-FF-003914', NULL, 'Uncharacterized protein', 262, NULL, NULL, 112374),
(112375, '3.80.10.10-FF-000267', NULL, 'NLR family CARD domain containing 5', 121, NULL, NULL, 112375),
(112376, '3.80.10.10-FF-004505', NULL, 'Uncharacterized protein', 135, NULL, NULL, 112376),
(112377, '3.10.129.10-FF-000190', NULL, 'UPF0644 protein PB2B4.06', 165, NULL, NULL, 112377),
(112378, '1.10.287.130-FF-000173', NULL, 'Sensor histidine kinase/response regulator LuxN', 86, NULL, NULL, 112378),
(112379, '3.30.70.330-FF-001024', NULL, 'RNA-binding protein Y14B', 173, NULL, NULL, 112379),
(112380, '1.10.10.10-FF-001899', NULL, 'Uncharacterized protein', 100, NULL, NULL, 112380),
(112381, '3.40.50.300-FF-004825', NULL, 'SNF2-related domain-containing protein', 225, NULL, NULL, 112381),
(112382, '2.60.40.60-FF-000034', NULL, 'Protocadherin 1', 105, NULL, NULL, 112382),
(112383, '3.60.20.10-FF-000263', NULL, NULL, 109, NULL, NULL, 112383),
(112384, '3.90.70.10-FF-000523', NULL, 'Flagellar associated protein', 139, NULL, NULL, 112384),
(112385, '3.40.50.300-FF-004932', NULL, 'Glr0454 protein', 225, NULL, NULL, 112385),
(112386, '1.10.530.10-FF-000006', NULL, 'Flagellar assembly peptidoglycan hydrolase FlgJ', 89, NULL, NULL, 112386),
(112387, '3.40.720.10-FF-000377', NULL, 'Acid phosphatase', 278, NULL, NULL, 112387),
(112388, '3.30.160.60-FF-005623', NULL, NULL, 81, NULL, NULL, 112388),
(112389, '3.40.50.12160-FF-000041', NULL, 'Predicted protein', 73, NULL, NULL, 112389),
(112390, '1.25.70.10-FF-000099', NULL, NULL, 164, NULL, NULL, 112390),
(112391, '1.10.3210.10-FF-000021', NULL, 'HD domain-containing protein', 293, NULL, NULL, 112391),
(112392, '2.10.70.10-FF-000260', NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', 60, NULL, NULL, 112392),
(112393, '3.40.50.12760-FF-000001', NULL, 'Cap methyltransferase 1', 410, NULL, NULL, 112393),
(112394, '3.40.50.1970-FF-000019', NULL, '3-dehydroquinate synthase', 166, NULL, NULL, 112394),
(112395, '3.30.450.60-FF-000087', NULL, 'Signal recognition particle receptor', 125, NULL, NULL, 112395),
(112396, '3.40.50.12780-FF-000007', NULL, 'Acyl-coenzyme A synthetase ACSM2A, mitochondrial', 430, NULL, NULL, 112396),
(112397, '3.80.10.10-FF-000559', NULL, 'Blast:JmjC domain-containing histone demethylation protein 1', 120, NULL, NULL, 112397),
(112398, '3.40.50.300-FF-004876', NULL, 'Uncharacterized protein', 214, NULL, NULL, 112398),
(112399, '3.30.559.10-FF-000077', NULL, 'HXXXD-type acyl-transferase family protein', 213, NULL, NULL, 112399),
(112400, '3.30.1370.170-FF-000002', NULL, 'Erythronate-4-phosphate dehydrogenase', 88, NULL, NULL, 112400),
(112401, '1.20.1440.340-FF-000015', NULL, 'Protein CBG25027', 49, NULL, NULL, 112401),
(112402, '3.30.470.20-FF-000093', NULL, 'Phosphoribosylamine--glycine ligase-like protein', 210, NULL, NULL, 112402),
(112403, '1.10.10.2520-FF-000001', NULL, 'Spore cortex-lytic enzyme', 80, NULL, NULL, 112403),
(112404, '3.90.660.10-FF-000029', NULL, 'Blast:Spermine oxidase', 134, NULL, NULL, 112404),
(112405, '1.20.5.340-FF-000049', NULL, 'NHS-like protein 1', 102, NULL, NULL, 112405); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(112406, '3.30.40.10-FF-002385', NULL, 'Uncharacterized RING finger protein C57A7.09', 108, NULL, NULL, 112406),
(112407, '1.20.1070.10-FF-002018', NULL, 'Octopamine receptor beta-3R-like Protein', 132, NULL, NULL, 112407),
(112408, '2.60.40.60-FF-000326', NULL, 'cadherin-18 isoform X3', 67, NULL, NULL, 112408),
(112409, '3.30.160.60-FF-004263', NULL, NULL, 26, NULL, NULL, 112409),
(112410, '3.30.40.10-FF-000592', NULL, 'E3 ubiquitin-protein ligase MSL2', 42, NULL, NULL, 112410),
(112411, '3.40.50.300-FF-003572', NULL, 'Uncharacterized protein', 230, NULL, NULL, 112411),
(112412, '3.30.70.260-FF-000082', NULL, 'Phosphoglycerate dehydrogenase', 75, NULL, NULL, 112412),
(112413, '2.60.120.560-FF-000014', NULL, 'Sucrose-6-phosphate hydrolase', 165, NULL, NULL, 112413),
(112414, '1.10.12.10-FF-000049', NULL, 'Probable enoyl-CoA hydratase/isomerase', 58, NULL, NULL, 112414),
(112415, '3.40.50.300-FF-004140', NULL, 'Chromosomal replication initiator DnaA', 119, NULL, NULL, 112415),
(112416, '3.40.50.360-FF-000077', NULL, 'Nitric oxide synthase', 207, NULL, NULL, 112416),
(112417, '1.10.1200.270-FF-000012', NULL, 'Uncharacterized protein', 129, NULL, NULL, 112417),
(112418, '3.90.190.10-FF-000212', NULL, 'Predicted protein', 254, NULL, NULL, 112418),
(112419, '2.60.40.10-FF-003650', NULL, NULL, 113, NULL, NULL, 112419),
(112420, '1.10.287.110-FF-000127', NULL, 'Chaperone protein DnaJ', 134, NULL, NULL, 112420),
(112421, '2.40.50.140-FF-000846', NULL, NULL, 62, NULL, NULL, 112421),
(112422, '1.25.40.10-FF-005162', NULL, 'rRNA biogenesis protein rrp5', 276, NULL, NULL, 112422),
(112423, '3.40.850.10-FF-000257', NULL, 'Kinesin-like protein', 307, NULL, NULL, 112423),
(112424, '3.40.50.620-FF-000588', NULL, 'Asparagine synthetase [glutamine-hydrolyzing] 1', 73, NULL, NULL, 112424),
(112425, '3.40.50.150-FF-000632', NULL, 'DNA methyltransferase putative', 188, NULL, NULL, 112425),
(112426, '3.90.550.50-FF-000128', NULL, 'Uncharacterized protein', 246, NULL, NULL, 112426),
(112427, '1.25.10.10-FF-002809', NULL, 'Uncharacterized protein', 201, NULL, NULL, 112427),
(112428, '2.30.29.30-FF-000798', NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', 59, NULL, NULL, 112428),
(112429, '3.40.50.1910-FF-000024', NULL, 'Syntaxin binding protein, putative', 24, NULL, NULL, 112429),
(112430, '3.30.160.60-FF-004370', NULL, NULL, 25, NULL, NULL, 112430),
(112431, '3.30.40.10-FF-001081', NULL, 'Putative Peroxisome biosynthesis protein (PAS10/Peroxin-12)', 57, NULL, NULL, 112431),
(112432, '3.30.450.190-FF-000028', NULL, 'RAs-related GTP binding protein C homolog', 95, NULL, NULL, 112432),
(112433, '3.40.190.10-FF-000122', NULL, 'Transcriptional regulator, LysR family', 89, NULL, NULL, 112433),
(112434, '2.60.40.60-FF-000433', NULL, 'Kugelei, isoform E', 97, NULL, NULL, 112434),
(112435, '1.10.510.10-FF-000948', NULL, 'Related to GCN2-ser/thr protein kinase', 198, NULL, NULL, 112435),
(112436, '3.80.10.10-FF-002740', NULL, 'Leucine-rich repeat receptor-like protein kinase', 59, NULL, NULL, 112436),
(112437, '3.40.50.300-FF-007282', NULL, 'Uncharacterized protein', 154, NULL, NULL, 112437),
(112438, '3.40.50.300-FF-003864', NULL, 'Small GTP-binding protein, putative', 205, NULL, NULL, 112438),
(112439, '1.20.1540.10-FF-000088', NULL, 'Rhomboid-related protein 1', 150, NULL, NULL, 112439),
(112440, '3.30.1010.10-FF-000128', NULL, 'Uncharacterized protein', 32, NULL, NULL, 112440),
(112441, '3.40.50.300-FF-008187', NULL, 'Putative 6-phosphofructo-2-kinase/fructose-2,6-biphosphatase', 79, NULL, NULL, 112441),
(112442, '1.20.1250.20-FF-000607', NULL, 'Amino acid/peptide transporter (Peptide:H+ symporter)', 510, NULL, NULL, 112442),
(112443, '3.90.70.10-FF-000074', NULL, 'Pro-cathepsin H', 311, NULL, NULL, 112443),
(112444, '3.30.160.60-FF-002189', NULL, 'zinc finger protein ZIC 4', 26, NULL, NULL, 112444),
(112445, '3.40.250.10-FF-000228', NULL, 'Predicted protein', 56, NULL, NULL, 112445),
(112446, '3.40.50.300-FF-008243', NULL, 'Uncharacterized protein', 54, NULL, NULL, 112446),
(112447, '1.25.40.20-FF-001005', NULL, 'Palmitoyltransferase', 94, NULL, NULL, 112447);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(112448, '1.10.100.10-FF-000013', NULL, NULL, 23, NULL, NULL, 112448),
(112449, '3.40.640.10-FF-000376', NULL, 'Phosphoserineaminotransferase, putative1', 140, NULL, NULL, 112449),
(112450, '2.60.40.2300-FF-000002', NULL, 'Neutral/alkaline non-lysosomal ceramidase', 134, NULL, NULL, 112450),
(112451, '3.40.390.10-FF-000177', NULL, NULL, 250, NULL, NULL, 112451),
(112452, '3.90.640.10-FF-000197', NULL, 'Actin, alpha 1, skeletal muscle', 54, NULL, NULL, 112452),
(112453, '3.10.430.100-FF-000007', NULL, '50S ribosomal protein L9', 87, NULL, NULL, 112453),
(112454, '1.10.1370.10-FF-000043', NULL, 'Uncharacterized protein', 143, NULL, NULL, 112454),
(112455, '2.40.50.140-FF-000453', NULL, 'BRCA2, oligonucleotide/oligosaccharide-binding, domain 1 protein', 115, NULL, NULL, 112455),
(112456, '3.40.50.150-FF-000071', NULL, 'Protein arginine N-methyltransferase 7', 150, NULL, NULL, 112456),
(112457, '3.40.50.10190-FF-000247', NULL, 'DNA-repair protein XRCC1', 92, NULL, NULL, 112457),
(112458, '1.10.8.140-FF-000014', NULL, 'Os05g0546500 protein', 62, NULL, NULL, 112458),
(112459, '1.25.10.10-FF-001500', NULL, 'Predicted protein', 80, NULL, NULL, 112459),
(112460, '3.40.50.720-FF-000904', NULL, '3-oxoacyl-[acyl-carrier-protein] reductase FabG', 247, NULL, NULL, 112460),
(112461, '1.10.1030.10-FF-000012', NULL, 'Uncharacterized protein', 155, NULL, NULL, 112461),
(112462, '2.160.20.10-FF-000058', NULL, 'Right handed beta helix region', 317, NULL, NULL, 112462),
(112463, '3.40.140.10-FF-000170', NULL, 'Uncharacterized protein', 75, NULL, NULL, 112463),
(112464, '3.40.190.10-FF-000734', NULL, 'Glycine betaine transport system permease protein', 155, NULL, NULL, 112464),
(112465, '2.60.120.260-FF-000486', NULL, 'Uncharacterized protein', 268, NULL, NULL, 112465),
(112466, '2.60.40.4330-FF-000004', NULL, NULL, 47, NULL, NULL, 112466),
(112467, '3.30.70.330-FF-002328', NULL, NULL, 113, NULL, NULL, 112467),
(112468, '1.10.10.650-FF-000024', NULL, 'Predicted protein', 179, NULL, NULL, 112468),
(112469, '3.40.50.10490-FF-000062', NULL, '30S ribosomal protein S2', 191, NULL, NULL, 112469),
(112470, '1.20.1250.20-FF-002120', NULL, 'Uncharacterized protein', 219, NULL, NULL, 112470),
(112471, '1.10.10.10-FF-000595', NULL, 'Sugar-specific transcriptional regulator, TrmB family', 144, NULL, NULL, 112471),
(112472, '1.20.142.10-FF-000017', NULL, 'Poly [ADP-ribose] polymerase', 147, NULL, NULL, 112472),
(112473, '2.40.70.10-FF-000494', NULL, NULL, 127, NULL, NULL, 112473),
(112474, '1.10.3110.10-FF-000018', NULL, 'Protoporphyrinogen oxidase', 58, NULL, NULL, 112474),
(112475, '2.130.10.10-FF-002897', NULL, 'Protein HIRA homolog-like Protein', 229, NULL, NULL, 112475),
(112476, '1.25.40.10-FF-002632', NULL, 'Pentatricopeptide repeat-containing protein At3g18110, chloroplastic', 131, NULL, NULL, 112476),
(112477, '3.80.10.10-FF-003488', NULL, 'Os10g0148800 protein', 202, NULL, NULL, 112477),
(112478, '1.25.10.10-FF-003029', NULL, 'Predicted protein', 315, NULL, NULL, 112478),
(112479, '2.20.28.30-FF-000004', NULL, 'DNA-directed RNA polymerases I', 58, NULL, NULL, 112479),
(112480, '2.30.30.140-FF-000238', NULL, 'GM03859p', 70, NULL, NULL, 112480),
(112481, '3.40.50.620-FF-000644', NULL, 'Glutamine-dependent NAD(+) synthetase', 237, NULL, NULL, 112481),
(112482, '3.30.465.10-FF-000078', NULL, 'Glycolate oxidase, subunit GlcE', 120, NULL, NULL, 112482),
(112483, '3.40.50.1000-FF-000875', NULL, NULL, 164, NULL, NULL, 112483),
(112484, '3.30.565.10-FF-000063', NULL, 'DNA topoisomerase (ATP-hydrolyzing)', 208, NULL, NULL, 112484),
(112485, '1.10.8.720-FF-000036', NULL, 'Predicted protein', 95, NULL, NULL, 112485),
(112486, '3.50.50.60-FF-000741', NULL, 'NAD dehydrogenase, putative', 89, NULL, NULL, 112486),
(112487, '3.40.50.300-FF-004320', NULL, 'Ras-related protein Rab-3B', 107, NULL, NULL, 112487),
(112488, '3.40.50.360-FF-000133', NULL, 'Flavodoxin-like fold family protein', 247, NULL, NULL, 112488),
(112489, '3.90.70.10-FF-000866', NULL, 'Uncharacterized protein', 81, NULL, NULL, 112489),
(112490, '3.30.300.320-FF-000006', NULL, 'GNPTAB protein', 75, NULL, NULL, 112490);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(112491, '1.10.274.100-FF-000025', NULL, 'DNA-directed RNA polymerase subunit', 108, NULL, NULL, 112491),
(112492, '3.90.70.10-FF-000130', NULL, 'Cysteine proteinase 1', 338, NULL, NULL, 112492),
(112493, '3.30.200.20-FF-001624', NULL, 'Uncharacterized protein', 97, NULL, NULL, 112493),
(112494, '3.40.190.10-FF-000914', NULL, 'Predicted protein', 96, NULL, NULL, 112494),
(112495, '3.40.440.10-FF-000007', NULL, 'Adenylosuccinate synthetase', 59, NULL, NULL, 112495),
(112496, '3.40.50.300-FF-003920', NULL, 'Dephospho-CoA kinase', 205, NULL, NULL, 112496),
(112497, '3.40.50.300-FF-007754', NULL, 'Ras-related protein RABG3a', 73, NULL, NULL, 112497),
(112498, '2.130.10.10-FF-003297', NULL, 'Uncharacterized protein', 258, NULL, NULL, 112498),
(112499, '1.25.40.20-FF-001680', NULL, 'RE06111p', 76, NULL, NULL, 112499),
(112500, '3.30.1180.20-FF-000008', NULL, 'Uncharacterized protein', 67, NULL, NULL, 112500),
(112501, '1.20.58.60-FF-000686', NULL, 'Uncharacterized protein', 294, NULL, NULL, 112501),
(112502, '1.10.15.30-FF-000005', NULL, '60S ribosomal protein L7, putative', 56, NULL, NULL, 112502),
(112503, '3.80.10.10-FF-003089', NULL, 'Antagonist of mitotic exit network 1', 120, NULL, NULL, 112503),
(112504, '3.90.1530.10-FF-000007', NULL, 'Chromosome partitioning protein ParB', 96, NULL, NULL, 112504),
(112505, '2.170.300.10-FF-000083', NULL, 'Uncharacterized protein', 112, NULL, NULL, 112505),
(112506, '4.10.240.10-FF-000051', NULL, 'Hal9p', 69, NULL, NULL, 112506),
(112507, '3.30.300.30-FF-000033', NULL, 'Nonribosomal siderophore peptide synthase SidC', 118, NULL, NULL, 112507),
(112508, '3.40.50.1950-FF-000013', NULL, 'Flavin prenyltransferase UbiX', 188, NULL, NULL, 112508),
(112509, '3.30.70.80-FF-000013', NULL, 'Alkaline serine protease', 83, NULL, NULL, 112509),
(112510, '1.10.10.60-FF-000200', NULL, 'Homeobox-leucine zipper protein ATHB-13', 68, NULL, NULL, 112510),
(112511, '3.30.160.60-FF-000328', NULL, 'Zinc finger protein 1079', 28, NULL, NULL, 112511),
(112512, '3.30.457.60-FF-000006', NULL, 'Spindle assembly checkpoint component MAD1', 82, NULL, NULL, 112512),
(112513, '3.40.630.30-FF-000376', NULL, 'IP09891p', 168, NULL, NULL, 112513),
(112514, '1.10.437.10-FF-000036', NULL, 'bcl-2-related ovarian killer protein homolog B isoform X1', 183, NULL, NULL, 112514),
(112515, '3.80.10.10-FF-000615', NULL, 'NLR family pyrin domain containing 12', 189, NULL, NULL, 112515),
(112516, '1.20.5.4010-FF-000007', NULL, 'Uncharacterized protein', 38, NULL, NULL, 112516),
(112517, '2.60.40.10-FF-002189', NULL, 'Mesocentin', 117, NULL, NULL, 112517),
(112518, '1.10.510.10-FF-003085', NULL, NULL, 199, NULL, NULL, 112518),
(112519, '2.60.40.10-FF-003549', NULL, NULL, 105, NULL, NULL, 112519),
(112520, '3.30.9.10-FF-000064', NULL, 'Glycine oxidase', 147, NULL, NULL, 112520),
(112521, '3.40.50.2300-FF-000534', NULL, 'LacI family transcriptional regulator', 130, NULL, NULL, 112521),
(112522, '3.40.50.10190-FF-000034', NULL, 'SMC5-SMC6 complex localization factor protein 1', 119, NULL, NULL, 112522),
(112523, '1.25.40.10-FF-000783', NULL, 'Pentatricopeptide repeat-containing protein', 129, NULL, NULL, 112523),
(112524, '3.20.20.190-FF-000114', NULL, 'Uncharacterized protein', 321, NULL, NULL, 112524),
(112525, '1.10.400.10-FF-000053', NULL, 'Uncharacterized protein', 115, NULL, NULL, 112525),
(112526, '3.40.50.740-FF-000039', NULL, 'Nuo-5', 203, NULL, NULL, 112526),
(112527, '3.80.10.10-FF-002920', NULL, 'Uncharacterized protein', 433, NULL, NULL, 112527),
(112528, '3.10.450.10-FF-000020', NULL, 'Cystatin-M', 122, NULL, NULL, 112528),
(112529, '1.20.1070.10-FF-000568', NULL, 'Uncharacterized protein', 263, NULL, NULL, 112529),
(112530, '3.40.50.1260-FF-000014', NULL, 'Phosphoglycerate kinase', 126, NULL, NULL, 112530),
(112531, '2.20.100.10-FF-000041', NULL, 'ADAMTS like 1', 59, NULL, NULL, 112531),
(112532, '1.10.510.10-FF-004097', NULL, NULL, 138, NULL, NULL, 112532),
(112533, '3.40.50.300-FF-000610', NULL, 'Multidrug resistance-associated ABC transporter', 252, NULL, NULL, 112533),
(112534, '2.130.10.10-FF-002846', NULL, 'Periodic tryptophan protein 1 homolog', 429, NULL, NULL, 112534); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(112535, '1.10.238.10-FF-000467', NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', 175, NULL, NULL, 112535),
(112536, '1.20.58.390-FF-000075', NULL, 'Neuronal acetylcholine receptor subunit alpha-9-II', 73, NULL, NULL, 112536),
(112537, '3.90.550.10-FF-000307', NULL, 'Glycosyl transferase family 2', 221, NULL, NULL, 112537),
(112538, '2.170.16.10-FF-000031', NULL, 'DNA polymerase II large subunit', 166, NULL, NULL, 112538),
(112539, '2.20.90.10-FF-000007', NULL, 'Vitellogenin-3', 111, NULL, NULL, 112539),
(112540, '1.25.40.90-FF-000020', NULL, 'regulation of nuclear pre-mRNA domain-containing protein 2 isoform X1', 135, NULL, NULL, 112540),
(112541, '2.60.120.260-FF-000087', NULL, 'Cytosolic endo-beta-N-acetylglucosaminidase', 186, NULL, NULL, 112541),
(112542, '3.40.50.1820-FF-001565', NULL, 'Os11g0119100 protein', 116, NULL, NULL, 112542),
(112543, '1.25.40.20-FF-001617', NULL, 'GIT1 (Mammalian G protein-coupled receptor kinase InTeractor 1) homolog', 101, NULL, NULL, 112543),
(112544, '3.80.10.10-FF-004449', NULL, 'Uncharacterized protein', 108, NULL, NULL, 112544),
(112545, '3.30.200.20-FF-000663', NULL, 'Protein kinase C', 111, NULL, NULL, 112545),
(112546, '1.10.10.60-FF-000413', NULL, 'Myb-like DNA-binding domain containing protein', 52, NULL, NULL, 112546),
(112547, '2.30.30.40-FF-000473', NULL, 'RIM Binding protein', 65, NULL, NULL, 112547),
(112548, '1.25.10.10-FF-000663', NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit', 406, NULL, NULL, 112548),
(112549, '1.50.10.10-FF-000094', NULL, 'Uncharacterized protein', 293, NULL, NULL, 112549),
(112550, '3.30.780.10-FF-000074', NULL, 'Uncharacterized protein', 92, NULL, NULL, 112550),
(112551, '3.50.30.20-FF-000014', NULL, 'Uncharacterized protein', 128, NULL, NULL, 112551),
(112552, '1.25.40.630-FF-000003', NULL, 'Polyadenylation factor subunit CstF64, putative', 98, NULL, NULL, 112552),
(112553, '2.130.10.10-FF-003122', NULL, 'Predicted WD40 repeat protein', 264, NULL, NULL, 112553),
(112554, '3.40.50.1820-FF-000553', NULL, 'Alpha/beta hydrolase', 304, NULL, NULL, 112554),
(112555, '3.40.1190.20-FF-000170', NULL, 'Multifunctional fusion protein', 265, NULL, NULL, 112555),
(112556, '3.30.230.10-FF-000162', NULL, 'U5 small nuclear ribonucleoprotein component, putative', 146, NULL, NULL, 112556),
(112557, '4.10.400.10-FF-000053', NULL, 'Very low density lipoprotein receptor', 42, NULL, NULL, 112557),
(112558, '2.130.10.10-FF-003858', NULL, 'Uncharacterized protein', 284, NULL, NULL, 112558),
(112559, '3.40.630.10-FF-000218', NULL, 'Putative carboxypeptidase d', 312, NULL, NULL, 112559),
(112560, '3.30.465.10-FF-000027', NULL, 'D-lactate dehydrogenase [cytochrome], mitochondrial', 232, NULL, NULL, 112560),
(112561, '1.10.533.10-FF-000136', NULL, 'Interferon-induced with helicase C domain 1', 96, NULL, NULL, 112561),
(112562, '1.10.238.10-FF-000815', NULL, 'Uncharacterized protein', 85, NULL, NULL, 112562),
(112563, '2.60.120.200-FF-000671', NULL, 'Uncharacterized protein', 63, NULL, NULL, 112563),
(112564, '2.60.40.1180-FF-000172', NULL, 'Extracellular exo-alpha-L-arabinofuranosidase', 109, NULL, NULL, 112564),
(112565, '3.40.50.920-FF-000048', NULL, 'Chromosome 7, whole genome shotgun sequence', 147, NULL, NULL, 112565),
(112566, '1.20.58.1370-FF-000002', NULL, 'lysine-specific demethylase 6A isoform X6', 34, NULL, NULL, 112566),
(112567, '2.60.40.10-FF-001340', NULL, 'Polymeric immunoglobulin receptor', 114, NULL, NULL, 112567),
(112568, '3.30.497.10-FF-000185', NULL, 'Uncharacterized protein', 101, NULL, NULL, 112568),
(112569, '3.40.50.1100-FF-000051', NULL, '2-amino-4-ketopentanoate thiolase beta subunit', 109, NULL, NULL, 112569),
(112570, '1.10.238.10-FF-000759', NULL, 'Uncharacterized protein', 76, NULL, NULL, 112570),
(112571, '3.10.20.80-FF-000011', NULL, 'Translation initiation factor IF3-4, chloroplastic', 39, NULL, NULL, 112571),
(112572, '2.60.260.20-FF-000170', NULL, 'Radial spoke protein 16', 122, NULL, NULL, 112572),
(112573, '3.30.70.360-FF-000055', NULL, 'IAA-amino acid hydrolase ILR1-like 3', 121, NULL, NULL, 112573);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(112574, '3.30.450.20-FF-000215', NULL, 'Sensory box/GGDEF family protein', 121, NULL, NULL, 112574),
(112575, '3.30.160.380-FF-000002', NULL, 'Endoribonuclease Dicer isoform 1', 101, NULL, NULL, 112575),
(112576, '3.30.780.10-FF-000023', NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', 150, NULL, NULL, 112576),
(112577, '3.30.200.20-FF-001012', NULL, 'Serine/threonine-protein kinase', 110, NULL, NULL, 112577),
(112578, '2.60.40.790-FF-000080', NULL, 'Protein SHQ1 homolog', 127, NULL, NULL, 112578),
(112579, '3.40.50.11660-FF-000042', NULL, NULL, 143, NULL, NULL, 112579),
(112580, '3.40.50.1820-FF-001222', NULL, 'Uncharacterized protein', 358, NULL, NULL, 112580),
(112581, '2.40.50.120-FF-000003', NULL, 'Secreted frizzled-related protein 1', 131, NULL, NULL, 112581),
(112582, '3.30.420.270-FF-000029', NULL, 'Biopolymer transport exbD protein', 81, NULL, NULL, 112582),
(112583, '3.40.50.720-FF-000325', NULL, 'UDP-glucose 6-dehydrogenase', 57, NULL, NULL, 112583),
(112584, '4.10.60.10-FF-000243', NULL, 'Uncharacterized protein', 68, NULL, NULL, 112584),
(112585, '2.130.10.10-FF-005207', NULL, 'Uncharacterized protein', 93, NULL, NULL, 112585),
(112586, '3.50.50.60-FF-000634', NULL, 'FAD dependent oxidoreductase', 244, NULL, NULL, 112586),
(112587, '1.20.120.330-FF-000034', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 154, NULL, NULL, 112587),
(112588, '3.30.70.330-FF-001255', NULL, 'RNA-binding protein-like protein', 103, NULL, NULL, 112588),
(112589, '2.120.10.80-FF-000384', NULL, 'Uncharacterized protein', 117, NULL, NULL, 112589),
(112590, '3.40.50.410-FF-000351', NULL, 'Uncharacterized protein', 95, NULL, NULL, 112590),
(112591, '3.10.20.90-FF-000053', NULL, 'UV excision repair protein RAD23 homolog A', 80, NULL, NULL, 112591),
(112592, '3.90.190.20-FF-000041', NULL, 'Folylpolyglutamate synthase/dihydrofolate synthase', 153, NULL, NULL, 112592),
(112593, '2.40.10.10-FF-000226', NULL, 'GD10792', 232, NULL, NULL, 112593),
(112594, '3.40.50.300-FF-005606', NULL, 'Uncharacterized protein', 47, NULL, NULL, 112594),
(112595, '3.10.50.40-FF-000124', NULL, 'Peptidylprolyl isomerase', 46, NULL, NULL, 112595),
(112596, '1.10.10.10-FF-000882', NULL, 'Transcription regulator, Crp family', 86, NULL, NULL, 112596),
(112597, '2.60.120.330-FF-000187', NULL, 'Uncharacterized protein', 187, NULL, NULL, 112597),
(112598, '1.20.58.390-FF-000131', NULL, 'Predicted protein', 88, NULL, NULL, 112598),
(112599, '1.25.40.840-FF-000004', NULL, 'CCR4-NOT transcription complex subunit 1, putative', 171, NULL, NULL, 112599),
(112600, '3.90.25.10-FF-000054', NULL, 'UDP-glucose 4-epimerase', 102, NULL, NULL, 112600),
(112601, '1.25.50.20-FF-000101', NULL, 'Uncharacterized protein', 131, NULL, NULL, 112601),
(112602, '2.60.40.10-FF-001284', NULL, 'Myomesin 2', 100, NULL, NULL, 112602),
(112603, '1.20.1250.20-FF-001451', NULL, 'IP13170p', 241, NULL, NULL, 112603),
(112604, '3.30.420.40-FF-000040', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', 167, NULL, NULL, 112604),
(112605, '3.40.50.1820-FF-000497', NULL, 'KAT8 regulatory NSL complex subunit 3', 137, NULL, NULL, 112605),
(112606, '1.20.120.1750-FF-000118', NULL, 'Protein CBG20927', 136, NULL, NULL, 112606),
(112607, '2.10.90.10-FF-000036', NULL, 'Sclerostin', 97, NULL, NULL, 112607),
(112608, '1.10.3230.20-FF-000002', NULL, 'Packaged DNA stabilization protein p27', 145, NULL, NULL, 112608),
(112609, '1.25.40.550-FF-000018', NULL, 'Uncharacterized protein', 166, NULL, NULL, 112609),
(112610, '2.40.50.140-FF-000009', NULL, 'Elongation factor P', 64, NULL, NULL, 112610),
(112611, '1.25.40.10-FF-000491', NULL, 'Crooked neck-like protein 1', 205, NULL, NULL, 112611),
(112612, '1.25.10.10-FF-001231', NULL, 'GD23466', 241, NULL, NULL, 112612),
(112613, '1.10.510.10-FF-001404', NULL, 'Serine/threonine-protein kinase WARTS homolog', 134, NULL, NULL, 112613),
(112614, '3.40.50.1110-FF-000048', NULL, 'GDSL family lipase', 281, NULL, NULL, 112614),
(112615, '2.130.10.10-FF-003066', NULL, 'Histone lysine N-methyltransferase, putative', 132, NULL, NULL, 112615);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(112616, '1.25.40.90-FF-000076', NULL, 'Uncharacterized protein', 85, NULL, NULL, 112616),
(112617, '1.20.1280.170-FF-000011', NULL, 'Exocyst subunit Exo70 family protein', 550, NULL, NULL, 112617),
(112618, '3.40.605.10-FF-000126', NULL, 'Aldehyde dehydrogenase, putative', 119, NULL, NULL, 112618),
(112619, '1.25.40.10-FF-002289', NULL, 'Pentatricopeptide repeat-containing protein At2g28050', 143, NULL, NULL, 112619),
(112620, '1.10.2000.10-FF-000010', NULL, 'Smoothened, frizzled class receptor', 133, NULL, NULL, 112620),
(112621, '3.20.20.120-FF-000026', NULL, 'Enolase 2, putative', 306, NULL, NULL, 112621),
(112622, '3.40.630.30-FF-000084', NULL, 'Probable N-acetyltransferase HLS1-like', 157, NULL, NULL, 112622),
(112623, '3.90.20.20-FF-000017', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 133, NULL, NULL, 112623),
(112624, '3.80.10.10-FF-000503', NULL, 'Leucine rich repeats and transmembrane domains 1', 115, NULL, NULL, 112624),
(112625, '3.40.50.150-FF-000688', NULL, 'Methyltransferase-like protein', 181, NULL, NULL, 112625),
(112626, '3.40.50.620-FF-000172', NULL, 'Related to choline-phosphate cytidylyltransferase', 179, NULL, NULL, 112626),
(112627, '3.40.630.30-FF-000140', NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', 210, NULL, NULL, 112627),
(112628, '3.90.550.20-FF-000024', NULL, 'Uncharacterized protein', 226, NULL, NULL, 112628),
(112629, '1.25.40.20-FF-001056', NULL, 'Uncharacterized protein', 241, NULL, NULL, 112629),
(112630, '3.30.70.330-FF-001311', NULL, 'Putative RNA-binding protein ARP1', 120, NULL, NULL, 112630),
(112631, '3.30.40.10-FF-002154', NULL, 'Structure-specific endonuclease subunit SLX1 homolog', 78, NULL, NULL, 112631),
(112632, '1.25.40.10-FF-004762', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 55, NULL, NULL, 112632),
(112633, '2.60.40.10-FF-004954', NULL, NULL, 100, NULL, NULL, 112633),
(112634, '1.20.1000.10-FF-000002', NULL, 'Guanylate-binding family protein', 133, NULL, NULL, 112634),
(112635, '1.10.630.10-FF-000839', NULL, 'Uncharacterized protein', 319, NULL, NULL, 112635),
(112636, '1.25.40.10-FF-000159', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 291, NULL, NULL, 112636),
(112637, '1.10.150.50-FF-000236', NULL, 'Dual specificity protein kinase splA', 68, NULL, NULL, 112637),
(112638, '3.10.350.10-FF-000035', NULL, 'Stage VI sporulation protein D', 60, NULL, NULL, 112638),
(112639, '3.30.420.10-FF-000497', NULL, NULL, 188, NULL, NULL, 112639),
(112640, '1.20.5.110-FF-000093', NULL, 'Vesicle-trafficking protein SEC22b, putative', 86, NULL, NULL, 112640),
(112641, '1.10.510.10-FF-000735', NULL, 'serine/threonine-protein kinase 32B isoform X2', 130, NULL, NULL, 112641),
(112642, '1.25.10.10-FF-001175', NULL, 'Protein CBG06442', 117, NULL, NULL, 112642),
(112643, '3.30.160.60-FF-000952', NULL, 'RE1-silencing transcription factor B', 119, NULL, NULL, 112643),
(112644, '3.30.300.110-FF-000005', NULL, 'tRNA (guanine(37)-N1)-methyltransferase', 79, NULL, NULL, 112644),
(112645, '3.20.20.140-FF-000184', NULL, 'Putative metal-dependent phosphoesterases (PHP family)', 239, NULL, NULL, 112645),
(112646, '1.10.3330.10-FF-000001', NULL, '2-oxo-4-hydroxy-4-carboxy-5-ureidoimidazoline decarboxylase', 172, NULL, NULL, 112646),
(112647, '1.20.1250.20-FF-001395', NULL, 'Uncharacterized protein', 190, NULL, NULL, 112647),
(112648, '1.20.1070.10-FF-001237', NULL, 'Frizzled class receptor 6', 353, NULL, NULL, 112648),
(112649, '1.10.238.10-FF-000074', NULL, 'epidermal growth factor receptor substrate 15 isoform X1', 97, NULL, NULL, 112649),
(112650, '3.30.40.10-FF-000709', NULL, 'Lysine-specific demethylase 5B-B', 57, NULL, NULL, 112650),
(112651, '3.30.160.60-FF-005044', NULL, NULL, 60, NULL, NULL, 112651),
(112652, '4.10.60.10-FF-000187', NULL, 'Cold shock protein 2', 49, NULL, NULL, 112652),
(112653, '2.60.120.200-FF-000339', NULL, 'Calreticulin 3', 88, NULL, NULL, 112653),
(112654, '3.80.10.10-FF-002633', NULL, 'MDIS1-interacting receptor like kinase 2', 163, NULL, NULL, 112654),
(112655, '1.10.510.10-FF-004046', NULL, NULL, 61, NULL, NULL, 112655);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(112656, '2.40.50.140-FF-000341', NULL, 'aspartate--tRNA ligase, mitochondrial isoform X2', 130, NULL, NULL, 112656),
(112657, '3.90.70.10-FF-000579', NULL, 'Uncharacterized protein', 319, NULL, NULL, 112657),
(112658, '3.20.20.80-FF-000763', NULL, 'Glucosylceramidase', 162, NULL, NULL, 112658),
(112659, '1.20.1560.10-FF-000600', NULL, 'MDR-like ABC transporter', 322, NULL, NULL, 112659),
(112660, '3.20.20.70-FF-000721', NULL, NULL, 109, NULL, NULL, 112660),
(112661, '3.30.310.10-FF-000051', NULL, 'AP complex subunit beta', 151, NULL, NULL, 112661),
(112662, '3.30.230.10-FF-000050', NULL, 'DNA topoisomerase 6 subunit B', 226, NULL, NULL, 112662),
(112663, '1.25.40.10-FF-003981', NULL, 'Uncharacterized protein', 220, NULL, NULL, 112663),
(112664, '1.25.10.10-FF-003316', NULL, 'Kinesin-like protein', 146, NULL, NULL, 112664),
(112665, '1.20.1730.10-FF-000012', NULL, 'sodium/myo-inositol cotransporter 2 isoform X1', 521, NULL, NULL, 112665),
(112666, '1.10.1450.10-FF-000100', NULL, 'Tetraspanin', 120, NULL, NULL, 112666),
(112667, '3.90.180.10-FF-000155', NULL, 'Zinc-type alcohol dehydrogenase-like protein C16A3.02c', 149, NULL, NULL, 112667),
(112668, '3.40.640.10-FF-000483', NULL, 'Uncharacterized protein', 62, NULL, NULL, 112668),
(112669, '1.10.1200.10-FF-000109', NULL, 'Amino acid adenylation', 87, NULL, NULL, 112669),
(112670, '3.40.50.300-FF-001498', NULL, 'ATP-dependent DNA helicase', 182, NULL, NULL, 112670),
(112671, '3.20.20.140-FF-000420', NULL, 'Uncharacterized protein', 69, NULL, NULL, 112671),
(112672, '3.40.50.10980-FF-000001', NULL, 'Nibrin', 116, NULL, NULL, 112672),
(112673, '3.40.50.300-FF-008479', NULL, 'Uncharacterized protein', 203, NULL, NULL, 112673),
(112674, '3.40.50.720-FF-000612', NULL, 'Dihydrodipicolinate reductase', 124, NULL, NULL, 112674),
(112675, '3.90.470.20-FF-000023', NULL, 'L-aminoadipate-semialdehyde dehydrogenase-phosphopantetheinyl transferase', 152, NULL, NULL, 112675),
(112676, '1.10.150.50-FF-000005', NULL, 'Liprin-beta-1 isoform 1', 72, NULL, NULL, 112676),
(112677, '2.60.120.610-FF-000001', NULL, 'Probable arabinosyltransferase C', 184, NULL, NULL, 112677),
(112678, '4.10.95.10-FF-000003', NULL, 'Cytochrome c oxidase subunit 6A, mitochondrial', 86, NULL, NULL, 112678),
(112679, '3.40.1060.10-FF-000005', NULL, 'Aconitate hydratase, mitochondrial', 77, NULL, NULL, 112679),
(112680, '2.40.50.140-FF-000285', NULL, 'Exosome component 1', 102, NULL, NULL, 112680),
(112681, '1.10.150.50-FF-000129', NULL, 'Probable serine/threonine-protein kinase DDB_G0278535', 67, NULL, NULL, 112681),
(112682, '1.10.246.20-FF-000011', NULL, 'Uncharacterized protein', 84, NULL, NULL, 112682),
(112683, '3.40.50.10090-FF-000043', NULL, 'Porphyrin biosynthesis protein [includes: uroporphyrin-III C-methyltransferase and uroporphyrinogen-III synthase', 87, NULL, NULL, 112683),
(112684, '1.10.10.1180-FF-000009', NULL, 'Lap-Emerin-Man domain protein 2', 86, NULL, NULL, 112684),
(112685, '1.10.510.10-FF-000100', NULL, 'inhibitor of nuclear factor kappa-B kinase subunit epsilon', 224, NULL, NULL, 112685),
(112686, '1.25.40.10-FF-003088', NULL, 'Pentatricopeptide repeat protein', 165, NULL, NULL, 112686),
(112687, '3.40.50.1000-FF-000583', NULL, NULL, 137, NULL, NULL, 112687),
(112688, '3.40.50.300-FF-004084', NULL, 'Related to ras-related GTPase rag', 39, NULL, NULL, 112688),
(112689, '3.30.160.60-FF-002133', NULL, 'Zinc finger protein 175', 28, NULL, NULL, 112689),
(112690, '3.90.76.10-FF-000025', NULL, 'Extracellular solute-binding protein, family 5', 168, NULL, NULL, 112690),
(112691, '1.50.10.20-FF-000147', NULL, 'Terpene cyclase/mutase family member', 279, NULL, NULL, 112691),
(112692, '3.40.50.300-FF-008535', NULL, 'Uncharacterized protein', 128, NULL, NULL, 112692),
(112693, '3.30.420.110-FF-000066', NULL, 'Mismatch repair-related protein, putative', 167, NULL, NULL, 112693),
(112694, '3.40.30.10-FF-001170', NULL, 'Uncharacterized protein', 87, NULL, NULL, 112694),
(112695, '1.10.3500.10-FF-000009', NULL, 'Transcription elongation factor SPT6', 299, NULL, NULL, 112695);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(112696, '3.30.160.60-FF-001733', NULL, 'zinc finger protein 827 isoform X1', 65, NULL, NULL, 112696),
(112697, '1.10.555.10-FF-000029', NULL, 'DEP domain-containing protein 1B isoform X2', 160, NULL, NULL, 112697),
(112698, '2.60.40.10-FF-003206', NULL, 'CD83 molecule', 125, NULL, NULL, 112698),
(112699, '1.25.40.10-FF-001851', NULL, 'Mitochondrial fission 1 protein', 141, NULL, NULL, 112699),
(112700, '1.20.1250.20-FF-000091', NULL, 'Lysophospholipid transporter LplT', 381, NULL, NULL, 112700),
(112701, '2.60.40.10-FF-003318', NULL, NULL, 132, NULL, NULL, 112701),
(112702, '1.20.1560.10-FF-000420', NULL, 'ATP-binding cassette protein subfamily B, member 2, putative', 321, NULL, NULL, 112702),
(112703, '1.20.58.480-FF-000006', NULL, 'Related to BNA2-tryptophan 2,3-dioxygenase', 266, NULL, NULL, 112703),
(112704, '3.30.9.10-FF-000171', NULL, 'Bcdao11', 169, NULL, NULL, 112704),
(112705, '3.30.200.20-FF-001916', NULL, 'Non-specific serine/threonine protein kinase', 69, NULL, NULL, 112705),
(112706, '3.40.50.10190-FF-000303', NULL, 'DNA ligase', 125, NULL, NULL, 112706),
(112707, '3.40.850.10-FF-000201', NULL, 'Uncharacterized protein', 265, NULL, NULL, 112707),
(112708, '3.20.20.70-FF-000485', NULL, 'Fructose-bisphosphate aldolase', 355, NULL, NULL, 112708),
(112709, '3.40.50.620-FF-000913', NULL, 'Uncharacterized protein', 27, NULL, NULL, 112709),
(112710, '3.30.420.40-FF-000888', NULL, 'Uncharacterized protein', 284, NULL, NULL, 112710),
(112711, '3.40.50.1820-FF-001857', NULL, 'Lipase 1-like protein', 55, NULL, NULL, 112711),
(112712, '3.80.10.10-FF-003196', NULL, 'Uncharacterized protein', 228, NULL, NULL, 112712),
(112713, '1.20.1070.10-FF-002081', NULL, 'Uncharacterized protein', 270, NULL, NULL, 112713),
(112714, '4.10.280.10-FF-000172', NULL, 'Basic helix-loop-helix (BHLH) DNA-binding superfamily protein', 93, NULL, NULL, 112714),
(112715, '1.50.40.10-FF-000191', NULL, 'Solute carrier family 25 member 4', 161, NULL, NULL, 112715),
(112716, '3.40.850.10-FF-000089', NULL, 'Myosin VC', 199, NULL, NULL, 112716),
(112717, '1.10.630.10-FF-000098', NULL, 'Cytochrome P450 71A26', 465, NULL, NULL, 112717),
(112718, '1.10.10.10-FF-001264', NULL, 'Probable serine/threonine-protein kinase pats1', 81, NULL, NULL, 112718),
(112719, '3.30.710.10-FF-000305', NULL, 'Uncharacterized protein', 100, NULL, NULL, 112719),
(112720, '3.30.160.60-FF-000896', NULL, 'Zinc finger protein 805', 30, NULL, NULL, 112720),
(112721, '3.90.180.10-FF-000099', NULL, 'Uncharacterized protein', 52, NULL, NULL, 112721),
(112722, '3.40.50.2000-FF-000950', NULL, 'Glycosyltransferase 1 domain-containing protein 1', 115, NULL, NULL, 112722),
(112723, '2.60.40.1400-FF-000007', NULL, 'Inward Rectifying K (Potassium) channel family', 182, NULL, NULL, 112723),
(112724, '2.30.29.30-FF-000742', NULL, 'ESCRT-II complex subunit VPS36', 116, NULL, NULL, 112724),
(112725, '1.20.1250.20-FF-000046', NULL, '3-phenylpropionic acid MFS transporter', 185, NULL, NULL, 112725),
(112726, '3.30.70.330-FF-002036', NULL, NULL, 124, NULL, NULL, 112726),
(112727, '3.30.2090.10-FF-000021', NULL, 'RND multidrug efflux transporter', 89, NULL, NULL, 112727),
(112728, '3.80.10.10-FF-000447', NULL, 'Glucose-repressible alcohol dehydrogenase transcriptional effector', 208, NULL, NULL, 112728),
(112729, '1.20.120.350-FF-000192', NULL, NULL, 54, NULL, NULL, 112729),
(112730, '3.30.980.10-FF-000022', NULL, 'Uncharacterized protein', 153, NULL, NULL, 112730),
(112731, '3.40.50.450-FF-000003', NULL, 'ATP-dependent 6-phosphofructokinase', 221, NULL, NULL, 112731),
(112732, '1.20.920.10-FF-000096', NULL, 'PolyBRoMo domain containing', 121, NULL, NULL, 112732),
(112733, '3.10.50.10-FF-000020', NULL, 'Uncharacterized protein', 67, NULL, NULL, 112733),
(112734, '3.40.50.10540-FF-000004', NULL, 'Probable alpha-methylacyl-CoA racemase mcr', 229, NULL, NULL, 112734),
(112735, '1.10.510.10-FF-000679', NULL, 'Casein kinase, putative', 303, NULL, NULL, 112735),
(112736, '2.40.160.120-FF-000007', NULL, 'Oxysterol binding protein', 190, NULL, NULL, 112736),
(112737, '1.10.1040.10-FF-000069', NULL, '2-dehydropantoate 2-reductase', 143, NULL, NULL, 112737);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(112738, '1.10.510.10-FF-003534', NULL, NULL, 239, NULL, NULL, 112738),
(112739, '1.25.40.10-FF-000215', NULL, 'Prolyl 3-hydroxylase 2', 96, NULL, NULL, 112739),
(112740, '3.30.40.10-FF-000861', NULL, 'SH3 domain protein (AFU_orthologue AFUA_2G13880)', 111, NULL, NULL, 112740),
(112741, '3.30.420.10-FF-000385', NULL, NULL, 161, NULL, NULL, 112741),
(112742, '2.30.30.40-FF-000181', NULL, 'GRB2-related adapter protein 2', 58, NULL, NULL, 112742),
(112743, '1.20.58.530-FF-000044', NULL, NULL, 164, NULL, NULL, 112743),
(112744, '3.30.1490.80-FF-000021', NULL, 'Glutathione synthetase', 11, NULL, NULL, 112744),
(112745, '2.60.120.260-FF-000194', NULL, 'Cell wall-associated protein', 154, NULL, NULL, 112745),
(112746, '3.40.50.300-FF-006169', NULL, 'DNA helicase II', 126, NULL, NULL, 112746),
(112747, '2.130.10.10-FF-003353', NULL, 'Flagellar associated protein', 158, NULL, NULL, 112747),
(112748, '3.30.70.330-FF-000799', NULL, '31 kDa ribonucleoprotein, chloroplastic', 155, NULL, NULL, 112748),
(112749, '3.30.70.330-FF-003109', NULL, NULL, 80, NULL, NULL, 112749),
(112750, '3.80.20.20-FF-000102', NULL, 'Receptor protein-tyrosine kinase', 194, NULL, NULL, 112750),
(112751, '3.90.650.10-FF-000023', NULL, 'Selenide water dikinase', 180, NULL, NULL, 112751),
(112752, '1.10.287.370-FF-000065', NULL, 'Molecular chaperone prefoldin, subunit 2', 105, NULL, NULL, 112752),
(112753, '2.10.25.10-FF-000402', NULL, 'Integrin beta', 35, NULL, NULL, 112753),
(112754, '3.30.2290.10-FF-000002', NULL, 'Metalloprotease PmbA homolog', 232, NULL, NULL, 112754),
(112755, '1.25.40.10-FF-005274', NULL, 'Uncharacterized protein', 150, NULL, NULL, 112755),
(112756, '3.40.50.620-FF-000352', NULL, 'YdcF family protein', 136, NULL, NULL, 112756),
(112757, '3.40.30.10-FF-000219', NULL, 'NADH-ubiquinone oxidoreductase 10.5 kDa subunit', 93, NULL, NULL, 112757),
(112758, '1.20.5.490-FF-000010', NULL, 'Uncharacterized protein', 65, NULL, NULL, 112758),
(112759, '1.10.490.10-FF-000002', NULL, 'Hemoglobin subunit alpha', 141, NULL, NULL, 112759),
(112760, '1.10.418.20-FF-000006', NULL, 'Probable ubiquitin-like-specific protease 2A', 113, NULL, NULL, 112760),
(112761, '1.10.418.10-FF-000060', NULL, 'Sperm flagellar protein 1', 115, NULL, NULL, 112761),
(112762, '3.40.50.1820-FF-000784', NULL, 'Putative serine esterase-domain-containing protein', 244, NULL, NULL, 112762),
(112763, '3.10.350.10-FF-000080', NULL, 'LysM peptidoglycan-binding domain-containing protein', 71, NULL, NULL, 112763),
(112764, '3.40.50.2300-FF-000826', NULL, NULL, 135, NULL, NULL, 112764),
(112765, '2.30.33.40-FF-000002', NULL, '10 kDa chaperonin, mitochondrial', 101, NULL, NULL, 112765),
(112766, '3.90.850.10-FF-000004', NULL, 'Fumarylacetoacetase', 302, NULL, NULL, 112766),
(112767, '3.40.50.1110-FF-000104', NULL, 'SGNH/GDSL hydrolase family protein', 195, NULL, NULL, 112767),
(112768, '3.40.50.720-FF-001124', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', 163, NULL, NULL, 112768),
(112769, '1.20.1300.10-FF-000042', NULL, 'Uncharacterized protein', 68, NULL, NULL, 112769),
(112770, '2.60.120.310-FF-000029', NULL, 'Uncharacterized protein', 98, NULL, NULL, 112770),
(112771, '3.90.1150.10-FF-000372', NULL, 'O-acetylhomoserine (Thiol)-lyase MetY', 142, NULL, NULL, 112771),
(112772, '2.60.40.10-FF-001464', NULL, 'Sialic acid binding Ig like lectin 15', 129, NULL, NULL, 112772),
(112773, '3.30.365.10-FF-000082', NULL, 'Predicted protein', 38, NULL, NULL, 112773),
(112774, '2.60.220.50-FF-000041', NULL, 'Adhesion G protein-coupled receptor E5b, duplicate 3', 175, NULL, NULL, 112774),
(112775, '2.60.40.10-FF-001520', NULL, 'Uncharacterized protein, isoform D', 105, NULL, NULL, 112775),
(112776, '3.30.200.20-FF-000556', NULL, 'Stretchin-Mlck, isoform G', 107, NULL, NULL, 112776),
(112777, '2.60.110.10-FF-000010', NULL, 'Nuclear pore complex protein NUP96', 114, NULL, NULL, 112777),
(112778, '3.80.10.10-FF-002072', NULL, 'Uncharacterized protein', 153, NULL, NULL, 112778),
(112779, '1.25.40.10-FF-001564', NULL, 'Pentatricopeptide repeat-containing protein103', 108, NULL, NULL, 112779);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(112780, '2.170.140.10-FF-000036', NULL, 'Uncharacterized protein, isoform C', 59, NULL, NULL, 112780),
(112781, '3.30.1150.10-FF-000003', NULL, 'Protein TonB', 126, NULL, NULL, 112781),
(112782, '3.80.10.10-FF-003937', NULL, 'Uncharacterized protein', 90, NULL, NULL, 112782),
(112783, '3.60.40.10-FF-000225', NULL, 'Protein phosphatase 2C catalytic subunit', 299, NULL, NULL, 112783),
(112784, '3.50.50.60-FF-000454', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 60, NULL, NULL, 112784),
(112785, '1.20.1070.10-FF-000512', NULL, 'Uncharacterized protein', 243, NULL, NULL, 112785),
(112786, '3.90.1430.10-FF-000011', NULL, NULL, 102, NULL, NULL, 112786),
(112787, '3.40.33.10-FF-000136', NULL, 'Uncharacterized protein', 171, NULL, NULL, 112787),
(112788, '1.25.10.10-FF-001051', NULL, 'Tubulin folding cofactor D', 394, NULL, NULL, 112788),
(112789, '3.40.50.790-FF-000032', NULL, '39S ribosomal protein L1, mitochondrial isoform X1', 94, NULL, NULL, 112789),
(112790, '3.60.40.10-FF-000169', NULL, 'Phosphatase 2C-like domain-containing protein', 257, NULL, NULL, 112790),
(112791, '3.40.50.1010-FF-000024', NULL, 'flap endonuclease GEN homolog 1', 191, NULL, NULL, 112791),
(112792, '3.50.50.60-FF-000398', NULL, 'p-hydroxybenzoate hydroxylase', 240, NULL, NULL, 112792),
(112793, '3.40.50.150-FF-000924', NULL, 'probable 28S rRNA (Cytosine-C(5))-methyltransferase', 311, NULL, NULL, 112793),
(112794, '1.10.10.60-FF-000469', NULL, 'Homeobox protein ceh-30', 76, NULL, NULL, 112794),
(112795, '3.90.190.10-FF-000504', NULL, 'Predicted protein', 145, NULL, NULL, 112795),
(112796, '2.60.40.10-FF-006011', NULL, NULL, 112, NULL, NULL, 112796),
(112797, '1.10.472.10-FF-000281', NULL, 'Cyclin, putative', 98, NULL, NULL, 112797),
(112798, '1.10.287.950-FF-000031', NULL, 'Methyl-accepting chemotaxis protein', 307, NULL, NULL, 112798),
(112799, '2.60.120.620-FF-000061', NULL, 'GD14754', 184, NULL, NULL, 112799),
(112800, '3.40.50.11610-FF-000016', NULL, '2-oxoglutarate dehydrogenase E1 component,putative', 131, NULL, NULL, 112800),
(112801, '3.40.50.1470-FF-000015', NULL, 'Uncharacterized protein', 192, NULL, NULL, 112801),
(112802, '2.60.40.10-FF-005735', NULL, NULL, 108, NULL, NULL, 112802),
(112803, '2.40.50.140-FF-000902', NULL, NULL, 81, NULL, NULL, 112803),
(112804, '3.80.10.10-FF-004213', NULL, 'Predicted protein', 86, NULL, NULL, 112804),
(112805, '1.25.40.10-FF-003649', NULL, 'CCR4-NOT transcription complex subunit 10', 131, NULL, NULL, 112805),
(112806, '3.30.70.330-FF-000855', NULL, 'SRA stem-loop-interacting RNA-binding protein, mitochondrial', 73, NULL, NULL, 112806),
(112807, '1.10.1450.10-FF-000156', NULL, 'Tetraspanin', 81, NULL, NULL, 112807),
(112808, '1.20.930.10-FF-000034', NULL, 'Transcription elongation factor S-II', 76, NULL, NULL, 112808),
(112809, '1.10.510.10-FF-001516', NULL, 'Protein kinase, putative', 209, NULL, NULL, 112809),
(112810, '3.40.50.410-FF-000171', NULL, 'Tellurium resistance protein', 189, NULL, NULL, 112810),
(112811, '3.40.720.10-FF-000085', NULL, 'Non-specific phospholipase C3', 175, NULL, NULL, 112811),
(112812, '3.30.420.40-FF-000545', NULL, 'Endoplasmic reticulum chaperone BiP', 154, NULL, NULL, 112812),
(112813, '2.60.40.3180-FF-000007', NULL, 'Transcription factor unc-3', 225, NULL, NULL, 112813),
(112814, '3.40.50.150-FF-001200', NULL, NULL, 153, NULL, NULL, 112814),
(112815, '1.10.2000.10-FF-000078', NULL, NULL, 86, NULL, NULL, 112815),
(112816, '1.10.10.10-FF-001320', NULL, 'Uncharacterized protein', 62, NULL, NULL, 112816),
(112817, '3.90.1100.10-FF-000037', NULL, 'DNA-directed RNA polymerase subunit beta', 178, NULL, NULL, 112817),
(112818, '2.10.60.10-FF-000028', NULL, 'Lymphocyte antigen 6 complex locus G6E', 82, NULL, NULL, 112818),
(112819, '1.10.510.10-FF-001117', NULL, 'MOK protein kinase', 146, NULL, NULL, 112819),
(112820, '3.40.50.150-FF-001088', NULL, NULL, 141, NULL, NULL, 112820),
(112821, '1.10.510.10-FF-000499', NULL, 'Serine/threonine-protein kinase KIC1', 292, NULL, NULL, 112821),
(112822, '3.40.630.30-FF-000264', NULL, 'Streptothricin acetyltransferase', 186, NULL, NULL, 112822);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(112823, '3.10.20.90-FF-000233', NULL, 'Predicted NADPH oxidase activator 1', 86, NULL, NULL, 112823),
(112824, '2.160.20.10-FF-000289', NULL, 'Periplasmic copper-binding', 138, NULL, NULL, 112824),
(112825, '3.30.70.330-FF-000911', NULL, 'Unplaced genomic scaffold supercont2.5, whole genome shotgun sequence', 112, NULL, NULL, 112825),
(112826, '1.20.58.390-FF-000311', NULL, 'Uncharacterized protein', 135, NULL, NULL, 112826),
(112827, '3.90.245.10-FF-000020', NULL, 'Inosine-uridine preferring nucleoside hydrolase', 310, NULL, NULL, 112827),
(112828, '1.10.10.2660-FF-000026', NULL, 'Ubiquitin-like modifier-activating enzyme 1', 141, NULL, NULL, 112828),
(112829, '3.40.367.20-FF-000036', NULL, 'Phosphotransferase', 64, NULL, NULL, 112829),
(112830, '3.30.200.20-FF-000899', NULL, 'AGAP005471-PA', 102, NULL, NULL, 112830),
(112831, '3.30.160.60-FF-005567', NULL, NULL, 55, NULL, NULL, 112831),
(112832, '1.20.1250.20-FF-002176', NULL, 'Os11g0637000 protein', 172, NULL, NULL, 112832),
(112833, '1.20.144.10-FF-000078', NULL, 'PA-phosphatase related-family protein DDB_G0268928', 108, NULL, NULL, 112833),
(112834, '3.30.70.560-FF-000014', NULL, 'Dihydropteroate synthetase', 216, NULL, NULL, 112834),
(112835, '3.30.230.80-FF-000031', NULL, 'Uncharacterized protein', 147, NULL, NULL, 112835),
(112836, '3.30.420.10-FF-000109', NULL, 'RNA exonuclease 3', 192, NULL, NULL, 112836),
(112837, '3.30.160.60-FF-001857', NULL, 'Uncharacterized protein', 28, NULL, NULL, 112837),
(112838, '1.10.238.10-FF-000579', NULL, 'NKD2, WNT signaling pathway inhibitor', 109, NULL, NULL, 112838),
(112839, '2.10.25.10-FF-001419', NULL, 'Fibrillin 2', 37, NULL, NULL, 112839),
(112840, '3.30.420.40-FF-000601', NULL, 'Actin-related protein 6', 48, NULL, NULL, 112840),
(112841, '1.50.40.10-FF-000039', NULL, 'Solute carrier family 25 member 35', 299, NULL, NULL, 112841),
(112842, '3.30.1490.120-FF-000014', NULL, 'Related to dna-dependent rna polymerase I subunit a43 (Rpa43)', 113, NULL, NULL, 112842),
(112843, '3.40.366.10-FF-000053', NULL, 'Fatty acid synthase beta subunit aflB', 190, NULL, NULL, 112843),
(112844, '3.30.870.10-FF-000137', NULL, 'Uncharacterized protein', 117, NULL, NULL, 112844),
(112845, '3.40.50.1820-FF-000441', NULL, 'Lipoprotein lipase', 193, NULL, NULL, 112845),
(112846, '1.25.10.10-FF-000775', NULL, 'Phospholipase A-2-activating protein, putative', 278, NULL, NULL, 112846),
(112847, '1.10.3410.10-FF-000002', NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase-like protein', 113, NULL, NULL, 112847),
(112848, '3.40.1110.10-FF-000223', NULL, 'Phospholipid-transporting ATPase', 178, NULL, NULL, 112848),
(112849, '3.30.300.20-FF-000047', NULL, 'Ribosome-binding factor A', 116, NULL, NULL, 112849),
(112850, '3.40.50.300-FF-005045', NULL, 'Predicted protein', 249, NULL, NULL, 112850),
(112851, '3.30.60.30-FF-000014', NULL, 'WAP, Kazal, immunoglobulin, Kunitz and NTR domain-containing protein 2', 66, NULL, NULL, 112851),
(112852, '3.30.310.80-FF-000032', NULL, 'Non-specific serine/threonine protein kinase', 115, NULL, NULL, 112852),
(112853, '3.90.700.10-FF-000016', NULL, 'Fumarate reductase/succinate dehydrogenase flavoprotein domain protein', 132, NULL, NULL, 112853),
(112854, '1.20.1070.10-FF-000456', NULL, 'FlaMIngo (Cadherin plus 7TM domain) homolog', 258, NULL, NULL, 112854),
(112855, '1.10.510.10-FF-003372', NULL, NULL, 172, NULL, NULL, 112855),
(112856, '1.25.40.10-FF-002688', NULL, 'Signal recognition particle subunit SRP72', 149, NULL, NULL, 112856),
(112857, '3.30.9.10-FF-000019', NULL, 'Hydroxyglutarate oxidase', 155, NULL, NULL, 112857),
(112858, '2.130.10.10-FF-003010', NULL, 'Dynein intermediate chain', 177, NULL, NULL, 112858),
(112859, '3.40.30.10-FF-000057', NULL, 'NADH-quinone oxidoreductase subunit E', 102, NULL, NULL, 112859),
(112860, '3.40.50.410-FF-000019', NULL, 'SEC24 homolog B, COPII coat complex component', 240, NULL, NULL, 112860),
(112861, '1.20.120.220-FF-000001', NULL, 'ATP synthase subunit a, chloroplastic', 157, NULL, NULL, 112861),
(112862, '3.90.470.20-FF-000079', NULL, 'Chromosome 10, whole genome shotgun sequence', 102, NULL, NULL, 112862);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(112863, '2.10.10.10-FF-000025', NULL, 'Uncharacterized protein', 49, NULL, NULL, 112863),
(112864, '2.60.120.1000-FF-000028', NULL, 'Uncharacterized protein', 141, NULL, NULL, 112864),
(112865, '3.30.70.3400-FF-000007', NULL, 'Protein translocase subunit SecD', 74, NULL, NULL, 112865),
(112866, '3.40.50.1000-FF-000307', NULL, 'Polynucleotide kinase 3''-phosphatase, putative', 191, NULL, NULL, 112866),
(112867, '3.40.50.150-FF-000183', NULL, 'Geranyl diphosphate 2-C-methyltransferase', 276, NULL, NULL, 112867),
(112868, '3.40.50.300-FF-002116', NULL, 'ATP-dependent DNA helicase UvrD', 208, NULL, NULL, 112868),
(112869, '1.10.630.10-FF-000278', NULL, 'Cytochrome P450 3A12', 506, NULL, NULL, 112869),
(112870, '3.30.420.110-FF-000010', NULL, 'DNA mismatch repair protein', 181, NULL, NULL, 112870),
(112871, '1.10.220.20-FF-000002', NULL, 'Brefeldin A-inhibited guanine nucleotide-exchange protein 1', 89, NULL, NULL, 112871),
(112872, '3.60.15.10-FF-000245', NULL, 'Coenzyme PQQ synthesis protein B', 304, NULL, NULL, 112872),
(112873, '1.20.1270.250-FF-000005', NULL, 'AGAP009166-PA', 287, NULL, NULL, 112873),
(112874, '3.30.160.60-FF-006404', NULL, NULL, 82, NULL, NULL, 112874),
(112875, '3.40.50.360-FF-000021', NULL, 'Nitric oxide synthase', 163, NULL, NULL, 112875),
(112876, '2.60.15.10-FF-000028', NULL, 'ATP synthase epsilon chain', 134, NULL, NULL, 112876),
(112877, '3.30.200.20-FF-002136', NULL, 'GH04968p', 71, NULL, NULL, 112877),
(112878, '3.40.30.10-FF-000950', NULL, 'CaDmium Responsive', 108, NULL, NULL, 112878),
(112879, '2.60.120.260-FF-000374', NULL, 'Teneurin-m-like Protein', 90, NULL, NULL, 112879),
(112880, '3.40.50.300-FF-001678', NULL, 'Disks large 5', 191, NULL, NULL, 112880),
(112881, '3.30.2410.10-FF-000007', NULL, 'Putative E3 ubiquitin-protein ligase HECTD1', 115, NULL, NULL, 112881),
(112882, '3.20.20.140-FF-000364', NULL, 'Uncharacterized protein', 247, NULL, NULL, 112882),
(112883, '1.20.1250.20-FF-002232', NULL, 'Uncharacterized protein', 124, NULL, NULL, 112883),
(112884, '1.10.10.10-FF-000483', NULL, 'Transcriptional coactivator ADA2', 85, NULL, NULL, 112884),
(112885, '2.60.120.260-FF-000430', NULL, 'beta-galactosidase-1-like protein 2', 143, NULL, NULL, 112885),
(112886, '1.20.1560.10-FF-000364', NULL, 'Uncharacterized protein', 242, NULL, NULL, 112886),
(112887, '3.30.160.60-FF-001677', NULL, 'Zinc finger protein 2', 29, NULL, NULL, 112887),
(112888, '2.60.120.10-FF-000016', NULL, 'Pyrimidine/purine nucleoside phosphorylase', 94, NULL, NULL, 112888),
(112889, '3.40.190.290-FF-000069', NULL, 'LysR family transcriptional regulator', 208, NULL, NULL, 112889),
(112890, '3.30.50.10-FF-000182', NULL, 'Uncharacterized protein', 51, NULL, NULL, 112890),
(112891, '1.25.10.10-FF-002012', NULL, 'YALI0D22440p', 408, NULL, NULL, 112891),
(112892, '1.20.1510.10-FF-000029', NULL, 'Zinc transporter 7', 85, NULL, NULL, 112892),
(112893, '1.25.40.10-FF-003144', NULL, 'Uncharacterized protein', 124, NULL, NULL, 112893),
(112894, '3.40.50.720-FF-001961', NULL, 'Uncharacterized protein', 356, NULL, NULL, 112894),
(112895, '3.50.50.60-FF-001415', NULL, 'Uncharacterized protein', 131, NULL, NULL, 112895),
(112896, '1.10.510.10-FF-001792', NULL, 'Uncharacterized protein', 194, NULL, NULL, 112896),
(112897, '3.40.50.720-FF-000668', NULL, 'Unplaced genomic scaffold supercont1.13, whole genome shotgun sequence', 50, NULL, NULL, 112897),
(112898, '1.25.40.10-FF-003306', NULL, 'Uncharacterized protein', 111, NULL, NULL, 112898),
(112899, '1.25.10.10-FF-001736', NULL, 'Protein SINE1', 183, NULL, NULL, 112899),
(112900, '3.40.50.2000-FF-000219', NULL, 'Glycosyltransferase', 262, NULL, NULL, 112900),
(112901, '3.30.160.60-FF-006348', NULL, NULL, 23, NULL, NULL, 112901),
(112902, '3.20.20.70-FF-000142', NULL, 'bifunctional 3-dehydroquinate dehydratase/shikimate dehydrogenase, chloroplastic', 233, NULL, NULL, 112902),
(112903, '1.20.1250.20-FF-001956', NULL, 'Uncharacterized membrane protein C14C4.07', 427, NULL, NULL, 112903),
(112904, '2.60.40.1730-FF-000090', NULL, NULL, 170, NULL, NULL, 112904);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(112905, '3.20.20.140-FF-000240', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 302, NULL, NULL, 112905),
(112906, '3.40.50.300-FF-005949', NULL, 'DNA mismatch repair protein Msh2', 282, NULL, NULL, 112906),
(112907, '1.10.3860.10-FF-000030', NULL, 'C4-dicarboxylate transport protein', 299, NULL, NULL, 112907),
(112908, '1.20.1250.20-FF-002356', NULL, 'Uncharacterized protein', 116, NULL, NULL, 112908),
(112909, '2.60.120.650-FF-000221', NULL, 'Uncharacterized protein', 200, NULL, NULL, 112909),
(112910, '3.30.530.20-FF-000036', NULL, 'Homeobox-leucine zipper protein HDG7', 156, NULL, NULL, 112910),
(112911, '3.30.360.10-FF-000110', NULL, 'Aspartate-semialdehyde dehydrogenase', 169, NULL, NULL, 112911),
(112912, '3.90.810.10-FF-000007', NULL, 'Non-specific serine/threonine protein kinase', 79, NULL, NULL, 112912),
(112913, '1.20.58.60-FF-000450', NULL, 'Spectrin beta, non-erythrocytic 5', 100, NULL, NULL, 112913),
(112914, '3.40.720.10-FF-000141', NULL, 'Alkaline phosphatase PhoK', 375, NULL, NULL, 112914),
(112915, '3.30.40.10-FF-000024', NULL, 'RING finger protein 44 isoform X1', 79, NULL, NULL, 112915),
(112916, '1.20.5.730-FF-000003', NULL, 'rab GTPase-binding effector protein 2 isoform X1', 61, NULL, NULL, 112916),
(112917, '3.20.20.100-FF-000200', NULL, 'Aldo-keto reductase, putative', 47, NULL, NULL, 112917),
(112918, '1.20.920.30-FF-000034', NULL, 'Dynein heavy chain, putative', 49, NULL, NULL, 112918),
(112919, '1.25.40.420-FF-000053', NULL, 'BTB/POZ domain-containing protein 6-B', 104, NULL, NULL, 112919),
(112920, '1.20.920.10-FF-000152', NULL, 'Uncharacterized protein', 146, NULL, NULL, 112920),
(112921, '3.90.1200.10-FF-000022', NULL, 'Choline Kinase A', 300, NULL, NULL, 112921),
(112922, '3.30.40.10-FF-002098', NULL, 'LD43541p', 78, NULL, NULL, 112922),
(112923, '2.130.10.10-FF-005483', NULL, 'Protein CBR-ELPC-2', 135, NULL, NULL, 112923),
(112924, '3.40.50.300-FF-001155', NULL, 'minichromosome maintenance domain-containing protein 2', 331, NULL, NULL, 112924),
(112925, '1.20.120.1240-FF-000061', NULL, 'Dynamin-related GTPase', 89, NULL, NULL, 112925),
(112926, '1.10.10.10-FF-001500', NULL, 'Transcriptional regulator LdrP', 85, NULL, NULL, 112926),
(112927, '1.25.70.10-FF-000043', NULL, 'At1g61990/F8K4_18', 227, NULL, NULL, 112927),
(112928, '3.90.550.10-FF-000695', NULL, 'Uncharacterized protein', 36, NULL, NULL, 112928),
(112929, '3.80.10.10-FF-002976', NULL, 'Uncharacterized protein', 99, NULL, NULL, 112929),
(112930, '3.40.50.300-FF-004589', NULL, 'SNF2 DNA repair protein, putative', 293, NULL, NULL, 112930),
(112931, '2.60.40.10-FF-004898', NULL, NULL, 95, NULL, NULL, 112931),
(112932, '2.40.50.90-FF-000084', NULL, 'Tudor domain-containing protein 1', 91, NULL, NULL, 112932),
(112933, '3.30.70.20-FF-000074', NULL, 'DNA-directed RNA polymerase I-like protein', 75, NULL, NULL, 112933),
(112934, '3.30.420.10-FF-000441', NULL, NULL, 233, NULL, NULL, 112934),
(112935, '3.30.1360.180-FF-000003', NULL, 'Type I phosphodiesterase/nucleotide pyrophosphatase family protein', 110, NULL, NULL, 112935),
(112936, '2.60.40.10-FF-004774', NULL, NULL, 89, NULL, NULL, 112936),
(112937, '3.60.40.10-FF-000045', NULL, 'Stage II sporulation protein E', 250, NULL, NULL, 112937),
(112938, '2.60.200.20-FF-000115', NULL, 'E3 ubiquitin-protein ligase CHFR isoform X1', 59, NULL, NULL, 112938),
(112939, '1.25.40.10-FF-002868', NULL, 'Peroxisomal biogenesis factor 5', 74, NULL, NULL, 112939),
(112940, '3.90.190.10-FF-000448', NULL, 'Protein-tyrosine phosphatase, putative', 249, NULL, NULL, 112940),
(112941, '1.25.40.10-FF-003705', NULL, 'Cell division cycle protein 23 homolog', 332, NULL, NULL, 112941),
(112942, '2.60.40.10-FF-005174', NULL, NULL, 93, NULL, NULL, 112942),
(112943, '2.30.29.30-FF-000163', NULL, 'unconventional myosin-X', 96, NULL, NULL, 112943),
(112944, '1.10.10.10-FF-000207', NULL, 'Cullin 9', 90, NULL, NULL, 112944),
(112945, '3.40.850.10-FF-000145', NULL, 'Myosin XIX', 296, NULL, NULL, 112945),
(112946, '3.30.450.20-FF-000558', NULL, 'C4-dicarboxylate transport sensor protein', 110, NULL, NULL, 112946);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(112947, '3.30.70.330-FF-000294', NULL, 'Serine/arginine-rich splicing factor RS31', 85, NULL, NULL, 112947),
(112948, '3.30.450.30-FF-000095', NULL, 'Uncharacterized protein', 66, NULL, NULL, 112948),
(112949, '3.30.1680.10-FF-000032', NULL, 'Plexin A2', 53, NULL, NULL, 112949),
(112950, '3.40.50.150-FF-000868', NULL, NULL, 33, NULL, NULL, 112950),
(112951, '3.40.630.30-FF-000320', NULL, 'N-acetyltransferase', 91, NULL, NULL, 112951),
(112952, '3.90.190.10-FF-000324', NULL, 'Uncharacterized protein', 106, NULL, NULL, 112952),
(112953, '3.40.50.300-FF-008299', NULL, 'Protein CBG18556', 12, NULL, NULL, 112953),
(112954, '2.30.29.30-FF-000686', NULL, 'Kinesin', 107, NULL, NULL, 112954),
(112955, '1.10.630.10-FF-000154', NULL, 'Cytochrome P450 135B1', 429, NULL, NULL, 112955),
(112956, '3.40.50.300-FF-005388', NULL, 'Replicative DNA helicase', 286, NULL, NULL, 112956),
(112957, '3.40.50.2000-FF-000894', NULL, 'Glycosyltransferase', 174, NULL, NULL, 112957),
(112958, '3.40.50.720-FF-001629', NULL, 'Fatty acyl-CoA reductase', 335, NULL, NULL, 112958),
(112959, '3.40.50.150-FF-001144', NULL, 'N(4)-bis(aminopropyl)spermidine synthase', 232, NULL, NULL, 112959),
(112960, '3.30.450.20-FF-000035', NULL, 'Aryl hydrocarbon receptor', 164, NULL, NULL, 112960),
(112961, '1.10.8.10-FF-000116', NULL, 'Holliday junction ATP-dependent DNA helicase RuvA', 62, NULL, NULL, 112961),
(112962, '3.30.160.60-FF-005387', NULL, NULL, 25, NULL, NULL, 112962),
(112963, '3.90.1200.10-FF-000073', NULL, 'Choline/ethanolamine kinase, putative', 329, NULL, NULL, 112963),
(112964, '2.30.29.30-FF-000927', NULL, 'Cyclic GMP-binding protein D', 104, NULL, NULL, 112964),
(112965, '1.20.1070.10-FF-000872', NULL, 'C1A receptor, putative', 293, NULL, NULL, 112965),
(112966, '1.20.1270.10-FF-000061', NULL, 'Heat shock protein family A (Hsp70) member 5', 92, NULL, NULL, 112966),
(112967, '3.40.50.300-FF-008395', NULL, 'Predicted protein', 185, NULL, NULL, 112967),
(112968, '3.40.190.10-FF-000830', NULL, 'Putative ABC transporter binding lipoprotein', 136, NULL, NULL, 112968),
(112969, '3.30.160.60-FF-001065', NULL, 'PR domain zinc finger protein 15', 26, NULL, NULL, 112969),
(112970, '1.10.575.10-FF-000008', NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', 288, NULL, NULL, 112970),
(112971, '3.40.850.10-FF-000049', NULL, 'kinesin-like protein KIF20B isoform X1', 357, NULL, NULL, 112971),
(112972, '1.10.8.60-FF-000114', NULL, 'Transcriptional regulator RtcR', 82, NULL, NULL, 112972),
(112973, '2.170.270.10-FF-000192', NULL, 'Histone-lysine N-methyltransferase', 181, NULL, NULL, 112973),
(112974, '1.20.1170.10-FF-000008', NULL, NULL, 306, NULL, NULL, 112974),
(112975, '1.10.510.10-FF-003681', NULL, NULL, 171, NULL, NULL, 112975),
(112976, '3.80.10.10-FF-000054', NULL, 'FLII, actin remodeling protein', 194, NULL, NULL, 112976),
(112977, '2.60.40.10-FF-001632', NULL, 'titin isoform X1', 101, NULL, NULL, 112977),
(112978, '3.40.50.410-FF-000103', NULL, 'Sec23/sec24 transport family protein', 258, NULL, NULL, 112978),
(112979, '3.30.160.60-FF-001109', NULL, 'Zinc finger protein 407', 56, NULL, NULL, 112979),
(112980, '1.10.600.10-FF-000135', NULL, 'Uncharacterized protein', 148, NULL, NULL, 112980),
(112981, '3.30.70.1590-FF-000003', NULL, 'Myosin-Va isoform 1', 66, NULL, NULL, 112981),
(112982, '1.10.8.10-FF-000162', NULL, 'Folate receptor alpha', 42, NULL, NULL, 112982),
(112983, '2.40.37.10-FF-000063', NULL, NULL, 133, NULL, NULL, 112983),
(112984, '1.10.150.50-FF-000045', NULL, 'SAM domain, SH3 domain and nuclear localization signals 1', 75, NULL, NULL, 112984),
(112985, '3.30.70.330-FF-001968', NULL, NULL, 82, NULL, NULL, 112985),
(112986, '3.50.50.60-FF-000342', NULL, 'Pyridine nucleotide-disulfide oxidoreductase, putative', 104, NULL, NULL, 112986),
(112987, '1.10.10.10-FF-000691', NULL, 'Hydrogen peroxide-inducible genes activator', 83, NULL, NULL, 112987),
(112988, '3.40.50.300-FF-001470', NULL, 'Interferon-induced guanylate-binding protein 1', 281, NULL, NULL, 112988),
(112989, '3.40.50.1820-FF-000901', NULL, 'Uncharacterized protein', 346, NULL, NULL, 112989);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(112990, '3.30.300.180-FF-000009', NULL, 'Chromosomal replication initiator protein DnaA', 92, NULL, NULL, 112990),
(112991, '3.30.1120.90-FF-000008', NULL, 'Vacuolar sorting protein', 169, NULL, NULL, 112991),
(112992, '3.20.20.10-FF-000074', NULL, 'Os04g0136500 protein', 174, NULL, NULL, 112992),
(112993, '2.60.40.10-FF-004858', NULL, NULL, 150, NULL, NULL, 112993),
(112994, '1.20.810.10-FF-000003', NULL, 'Menaquinol-Cytochrome c reductase cytochrome b6 subunit', 224, NULL, NULL, 112994),
(112995, '2.60.120.330-FF-000114', NULL, 'Predicted protein', 301, NULL, NULL, 112995),
(112996, '2.60.120.260-FF-000278', NULL, 'Glycosyl hydrolase family 85', 223, NULL, NULL, 112996),
(112997, '3.40.50.300-FF-003605', NULL, 'GM25836', 172, NULL, NULL, 112997),
(112998, '2.60.40.10-FF-001099', NULL, 'Usherin', 87, NULL, NULL, 112998),
(112999, '3.90.1150.10-FF-000057', NULL, 'Acetylornithine aminotransferase 2', 114, NULL, NULL, 112999),
(113000, '3.90.470.10-FF-000054', NULL, 'Ribosomal protein L22, putative', 163, NULL, NULL, 113000),
(113001, '3.30.160.60-FF-005443', NULL, NULL, 27, NULL, NULL, 113001),
(113002, '3.30.420.40-FF-000961', NULL, 'ARP1 actin related protein 1 homolog B', 126, NULL, NULL, 113002),
(113003, '1.25.40.180-FF-000126', NULL, 'Zinc finger CCCH domain-containing protein 43', 233, NULL, NULL, 113003),
(113004, '3.80.10.10-FF-002780', NULL, 'Leucine-rich repeat-containing 7', 161, NULL, NULL, 113004),
(113005, '2.60.40.2690-FF-000012', NULL, 'AEL014Cp', 138, NULL, NULL, 113005),
(113006, '3.90.550.10-FF-000690', NULL, 'Uncharacterized protein', 72, NULL, NULL, 113006),
(113007, '1.10.1420.10-FF-000087', NULL, 'Endonuclease MutS2', 117, NULL, NULL, 113007),
(113008, '3.20.20.80-FF-000634', NULL, 'Uncharacterized protein', 118, NULL, NULL, 113008),
(113009, '1.20.5.370-FF-000024', NULL, NULL, 88, NULL, NULL, 113009),
(113010, '3.40.430.10-FF-000057', NULL, 'Uncharacterized protein', 32, NULL, NULL, 113010),
(113011, '1.20.1250.20-FF-000647', NULL, 'Autophagy-related protein', 301, NULL, NULL, 113011),
(113012, '1.50.40.10-FF-000308', NULL, 'Mitochondrial substrate carrier family protein', 280, NULL, NULL, 113012),
(113013, '1.50.10.10-FF-000127', NULL, 'alpha-1,2-Mannosidase', 261, NULL, NULL, 113013),
(113014, '1.10.287.890-FF-000001', NULL, 'tRNA dimethylallyltransferase', 84, NULL, NULL, 113014),
(113015, '3.40.50.300-FF-004224', NULL, 'Origin recognition complex subunit 1', 204, NULL, NULL, 113015),
(113016, '2.10.110.10-FF-000280', NULL, 'YALI0F13211p', 78, NULL, NULL, 113016),
(113017, '3.40.720.10-FF-000293', NULL, 'Chromosome 9, whole genome shotgun sequence', 262, NULL, NULL, 113017),
(113018, '3.30.1370.100-FF-000021', NULL, 'DNA mismatch repair protein MutL', 79, NULL, NULL, 113018),
(113019, '1.10.510.10-FF-002736', NULL, 'Tyrosine-protein kinase', 262, NULL, NULL, 113019),
(113020, '1.10.640.10-FF-000048', NULL, 'Uncharacterized protein', 422, NULL, NULL, 113020),
(113021, '1.25.40.10-FF-004734', NULL, 'Uncharacterized protein', 81, NULL, NULL, 113021),
(113022, '1.25.10.10-FF-000854', NULL, 'Heat repeat domain containing protein', 806, NULL, NULL, 113022),
(113023, '2.60.34.10-FF-000067', NULL, 'Luminal-binding protein 1', 215, NULL, NULL, 113023),
(113024, '3.30.160.60-FF-002054', NULL, 'Zinc finger protein 460', 31, NULL, NULL, 113024),
(113025, '2.40.50.40-FF-000114', NULL, 'Uncharacterized protein', 42, NULL, NULL, 113025),
(113026, '1.20.1270.60-FF-000082', NULL, 'Endophilin B, isoform C', 249, NULL, NULL, 113026),
(113027, '3.30.70.330-FF-002587', NULL, NULL, 136, NULL, NULL, 113027),
(113028, '2.40.20.10-FF-000070', NULL, 'Uncharacterized protein', 159, NULL, NULL, 113028),
(113029, '1.25.10.10-FF-001843', NULL, 'Uncharacterized protein', 244, NULL, NULL, 113029),
(113030, '2.60.40.150-FF-000596', NULL, 'Uncharacterized protein', 126, NULL, NULL, 113030),
(113031, '3.40.1390.10-FF-000007', NULL, 'UDP-N-acetylmuramoyl-L-alanyl-D-glutamate--2,6-diaminopimelate ligase', 105, NULL, NULL, 113031),
(113032, '1.20.1250.20-FF-000208', NULL, 'solute carrier family 2, facilitated glucose transporter member 10', 195, NULL, NULL, 113032);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(113033, '3.40.630.30-FF-000180', NULL, 'RNA cytidine acetyltransferase', 200, NULL, NULL, 113033),
(113034, '3.30.160.60-FF-001548', NULL, 'Zinc finger protein 277, isoform CRA_a', 113, NULL, NULL, 113034),
(113035, '3.80.10.10-FF-002341', NULL, 'Predicted protein', 108, NULL, NULL, 113035),
(113036, '3.30.200.20-FF-002237', NULL, 'Uncharacterized protein', 34, NULL, NULL, 113036),
(113037, '1.10.620.20-FF-000038', NULL, 'Delta-9-ACP desaturase-like protein', 147, NULL, NULL, 113037),
(113038, '2.130.10.10-FF-005016', NULL, 'Uncharacterized protein', 12, NULL, NULL, 113038),
(113039, '1.10.287.1490-FF-000087', NULL, 'Structural maintenance of chromosomes protein 5', 175, NULL, NULL, 113039),
(113040, '1.20.58.1220-FF-000013', NULL, 'Exocyst complex component 8', 104, NULL, NULL, 113040),
(113041, '3.10.110.10-FF-000197', NULL, 'Probable serine/threonine-protein kinase ifkC', 143, NULL, NULL, 113041),
(113042, '1.20.120.1110-FF-000005', NULL, 'Nervy', 107, NULL, NULL, 113042),
(113043, '1.10.3080.10-FF-000015', NULL, 'Chloride channel protein EriC', 446, NULL, NULL, 113043),
(113044, '3.30.1410.10-FF-000001', NULL, 'GTP cyclohydrolase 1 feedback regulatory protein', 83, NULL, NULL, 113044),
(113045, '2.10.25.10-FF-000407', NULL, 'Laminin subunit alpha-3', 49, NULL, NULL, 113045),
(113046, '3.30.40.10-FF-000788', NULL, 'Unplaced genomic scaffold supercont1.168, whole genome shotgun sequence', 85, NULL, NULL, 113046),
(113047, '1.20.58.2220-FF-000004', NULL, 'Formin homology 2 domain-containing 3', 386, NULL, NULL, 113047),
(113048, '3.40.50.2000-FF-000782', NULL, 'Digalactosyldiacylglycerol synthase 1, chloroplastic', 92, NULL, NULL, 113048),
(113049, '1.20.1070.10-FF-001052', NULL, 'Retinal pigment epithelium derived rhodopsin homolog (Predicted), isoform CRA_b', 198, NULL, NULL, 113049),
(113050, '3.80.10.10-FF-001835', NULL, 'Uncharacterized protein', 194, NULL, NULL, 113050),
(113051, '4.10.280.110-FF-000019', NULL, NULL, 78, NULL, NULL, 113051),
(113052, '2.60.200.20-FF-000014', NULL, 'FHA domain-containing protein FHA2', 103, NULL, NULL, 113052),
(113053, '3.20.20.80-FF-000151', NULL, 'Glucan endo-1,3-beta-glucosidase btgC', 100, NULL, NULL, 113053),
(113054, '2.10.25.140-FF-000007', NULL, 'Delta-like protein', 45, NULL, NULL, 113054),
(113055, '2.30.30.40-FF-000681', NULL, 'Variant SH3 domain containing protein', 50, NULL, NULL, 113055),
(113056, '3.40.1440.10-FF-000023', NULL, NULL, 79, NULL, NULL, 113056),
(113057, '1.10.510.10-FF-002253', NULL, 'Uncharacterized protein', 257, NULL, NULL, 113057),
(113058, '3.30.930.10-FF-000384', NULL, 'Uncharacterized protein', 222, NULL, NULL, 113058),
(113059, '3.30.70.330-FF-003093', NULL, NULL, 103, NULL, NULL, 113059),
(113060, '1.25.40.10-FF-000682', NULL, 'Pentatricopeptide repeat-containing protein At3g16610', 156, NULL, NULL, 113060),
(113061, '2.60.120.340-FF-000004', NULL, 'Histone deacetylase HDT1', 98, NULL, NULL, 113061),
(113062, '1.20.1250.20-FF-000490', NULL, 'Solute carrier family 16 member 6', 190, NULL, NULL, 113062),
(113063, '3.30.40.10-FF-001305', NULL, 'E3 ubiquitin-protein ligase MBR2', 77, NULL, NULL, 113063),
(113064, '3.30.70.330-FF-003104', NULL, NULL, 88, NULL, NULL, 113064),
(113065, '3.80.20.20-FF-000029', NULL, 'Sps22p', 102, NULL, NULL, 113065),
(113066, '3.20.20.140-FF-000280', NULL, 'Adenosine deaminase', 330, NULL, NULL, 113066),
(113067, '3.30.70.3030-FF-000003', NULL, 'U3 small nucleolar RNA-associated protein 22', 152, NULL, NULL, 113067),
(113068, '1.25.10.10-FF-001360', NULL, 'Armadillo-type protein', 217, NULL, NULL, 113068),
(113069, '1.10.238.10-FF-000675', NULL, 'Phosphoinositide phospholipase C', 46, NULL, NULL, 113069),
(113070, '1.10.10.160-FF-000001', NULL, 'ATP-dependent DNA helicase', 75, NULL, NULL, 113070),
(113071, '3.40.50.620-FF-000357', NULL, 'Nicotinate/nicotinamide mononucleotide adenyltransferase', 52, NULL, NULL, 113071),
(113072, '3.30.56.30-FF-000004', NULL, 'Signal recognition particle 19 kDa protein', 38, NULL, NULL, 113072),
(113073, '1.10.268.10-FF-000031', NULL, NULL, 179, NULL, NULL, 113073);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(113074, '3.10.290.20-FF-000010', NULL, 'NEDD8-activating enzyme E1 catalytic subunit', 92, NULL, NULL, 113074),
(113075, '3.40.50.150-FF-001273', NULL, NULL, 226, NULL, NULL, 113075),
(113076, '3.40.50.720-FF-001360', NULL, 'Prephenate dehydrogenase', 176, NULL, NULL, 113076),
(113077, '4.10.365.10-FF-000003', NULL, 'cyclin-dependent kinase inhibitor 1 isoform X1', 75, NULL, NULL, 113077),
(113078, '3.40.50.720-FF-000724', NULL, 'C-terminal-binding protein 1', 107, NULL, NULL, 113078),
(113079, '3.70.10.10-FF-000032', NULL, 'Proliferating cell nuclear antigen', 262, NULL, NULL, 113079),
(113080, '1.10.510.10-FF-000336', NULL, 'Cysteine-rich receptor-like protein kinase 2', 205, NULL, NULL, 113080),
(113081, '3.40.50.1220-FF-000076', NULL, 'N(2)-(2-carboxyethyl)arginine synthase', 164, NULL, NULL, 113081),
(113082, '3.40.50.2300-FF-000635', NULL, 'GLutamate Receptor family (AMPA)', 166, NULL, NULL, 113082),
(113083, '3.30.160.60-FF-000929', NULL, 'Uncharacterized protein, isoform B', 30, NULL, NULL, 113083),
(113084, '1.10.1040.10-FF-000102', NULL, 'Ketose-bisphosphate aldolase class-II family protein', 68, NULL, NULL, 113084),
(113085, '3.40.50.300-FF-005961', NULL, 'Ferrous iron transporter B', 176, NULL, NULL, 113085),
(113086, '3.30.70.330-FF-000187', NULL, 'Heterogeneous nuclear ribonucleoprotein Q', 84, NULL, NULL, 113086),
(113087, '3.40.910.10-FF-000004', NULL, 'Probable deoxyhypusine synthase', 329, NULL, NULL, 113087),
(113088, '3.40.50.11350-FF-000028', NULL, 'Uncharacterized protein', 192, NULL, NULL, 113088),
(113089, '3.30.360.10-FF-000003', NULL, 'Inositol-3-phosphate synthase', 84, NULL, NULL, 113089),
(113090, '3.40.50.1400-FF-000006', NULL, 'Ferrochelatase', 180, NULL, NULL, 113090),
(113091, '3.80.10.10-FF-004106', NULL, 'Predicted protein', 119, NULL, NULL, 113091),
(113092, '3.30.830.10-FF-000011', NULL, 'Presequence protease, mitochondrial', 268, NULL, NULL, 113092),
(113093, '1.25.40.10-FF-004425', NULL, 'Uncharacterized protein', 126, NULL, NULL, 113093),
(113094, '1.25.10.10-FF-003288', NULL, 'Zer1 protein', 185, NULL, NULL, 113094),
(113095, '2.30.110.10-FF-000101', NULL, 'Flavin reductase (NADPH)', 162, NULL, NULL, 113095),
(113096, '3.30.450.50-FF-000027', NULL, 'vesicle-associated membrane protein 714-like isoform X1', 125, NULL, NULL, 113096),
(113097, '3.40.50.2300-FF-000765', NULL, 'Vomeronasal 2 receptor, h32', 127, NULL, NULL, 113097),
(113098, '1.25.40.20-FF-001657', NULL, 'BTB/POZ domain and ankyrin repeat-containing protein NOOT2', 87, NULL, NULL, 113098),
(113099, '1.25.40.10-FF-003436', NULL, 'Pentatricopeptide repeat-containing protein At3g49170, chloroplastic', 108, NULL, NULL, 113099),
(113100, '3.40.50.1110-FF-000043', NULL, 'Esterase, putative', 240, NULL, NULL, 113100),
(113101, '2.60.40.420-FF-000261', NULL, 'Os11g0426400 protein', 66, NULL, NULL, 113101),
(113102, '3.40.1190.10-FF-000026', NULL, 'Bifunctional folylpolyglutamate synthase/dihydrofolate synthase', 269, NULL, NULL, 113102),
(113103, '3.30.40.10-FF-002250', NULL, 'Histone acetyltransferase', 58, NULL, NULL, 113103),
(113104, '2.20.100.10-FF-000170', NULL, 'Semaphorin-5c', 62, NULL, NULL, 113104),
(113105, '3.40.190.10-FF-000493', NULL, 'LysR family transcriptional regulator', 105, NULL, NULL, 113105),
(113106, '3.10.330.10-FF-000045', NULL, 'Uncharacterized protein', 110, NULL, NULL, 113106),
(113107, '3.40.50.150-FF-000784', NULL, 'Probable BsuMI modification methylase subunit YdiO', 203, NULL, NULL, 113107),
(113108, '3.30.70.260-FF-000042', NULL, 'Sigma-54 dependent transcriptional regulator', 83, NULL, NULL, 113108),
(113109, '3.40.50.1000-FF-000774', NULL, NULL, 96, NULL, NULL, 113109),
(113110, '2.10.25.10-FF-001043', NULL, 'von Willebrand factor D and EGF domains', 38, NULL, NULL, 113110),
(113111, '2.60.40.60-FF-000697', NULL, 'Cdh-4', 103, NULL, NULL, 113111),
(113112, '1.10.405.10-FF-000013', NULL, 'GDP dissociation inhibitor, putative', 35, NULL, NULL, 113112),
(113113, '3.40.225.10-FF-000007', NULL, 'Methylthioribulose-1-phosphate dehydratase', 203, NULL, NULL, 113113);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(113114, '3.30.420.40-FF-000652', NULL, 'Actin-related protein 6', 129, NULL, NULL, 113114),
(113115, '3.40.50.300-FF-006950', NULL, 'Telomere length regulation protein elg1', 225, NULL, NULL, 113115),
(113116, '1.10.287.70-FF-000317', NULL, 'Voltage-gated Ca2+ channel, alpha subunit', 125, NULL, NULL, 113116),
(113117, '3.20.70.20-FF-000012', NULL, 'Formate C-acetyltransferase 2', 764, NULL, NULL, 113117),
(113118, '1.20.1410.10-FF-000033', NULL, 'Uncharacterized protein', 127, NULL, NULL, 113118),
(113119, '2.130.10.10-FF-002392', NULL, 'Uncharacterized protein', 330, NULL, NULL, 113119),
(113120, '1.20.1420.30-FF-000028', NULL, 'Cation/calcium exchanger 5', 217, NULL, NULL, 113120),
(113121, '1.20.1050.10-FF-000180', NULL, 'Phi class glutathione S-transferase', 120, NULL, NULL, 113121),
(113122, '2.60.40.60-FF-000242', NULL, 'Cadherin 16, KSP-cadherin', 102, NULL, NULL, 113122),
(113123, '3.40.50.300-FF-002307', NULL, 'Guanine nucleotide-binding protein G(k) subunit alpha', 211, NULL, NULL, 113123),
(113124, '1.20.5.4820-FF-000003', NULL, 'Unconventional myosin ID', 114, NULL, NULL, 113124),
(113125, '3.40.50.300-FF-005652', NULL, 'Nucleotide-binding oligomerization domain-containing 1', 214, NULL, NULL, 113125),
(113126, '2.10.70.10-FF-000052', NULL, 'Complement factor B', 69, NULL, NULL, 113126),
(113127, '2.170.300.10-FF-000043', NULL, 'Multiple EGF-like-domains 10', 110, NULL, NULL, 113127),
(113128, '3.90.110.10-FF-000033', NULL, NULL, 165, NULL, NULL, 113128),
(113129, '2.60.40.10-FF-005814', NULL, NULL, 64, NULL, NULL, 113129),
(113130, '3.30.160.60-FF-001418', NULL, 'Zinc finger protein 770', 29, NULL, NULL, 113130),
(113131, '2.60.120.920-FF-000066', NULL, 'Si:ch211-208f21.3', 183, NULL, NULL, 113131),
(113132, '3.30.1490.20-FF-000026', NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta', 88, NULL, NULL, 113132),
(113133, '2.40.50.140-FF-000993', NULL, NULL, 182, NULL, NULL, 113133),
(113134, '2.30.30.190-FF-000028', NULL, 'DyNactin Complex component', 86, NULL, NULL, 113134),
(113135, '3.30.40.10-FF-000316', NULL, 'E3 ubiquitin-protein ligase RNF180', 119, NULL, NULL, 113135),
(113136, '2.30.29.30-FF-000618', NULL, 'Pleckstrin homology (PH) domain-containing protein', 116, NULL, NULL, 113136),
(113137, '2.30.42.10-FF-000137', NULL, 'Synaptopodin 2-like a', 98, NULL, NULL, 113137),
(113138, '3.40.50.2300-FF-001254', NULL, NULL, 171, NULL, NULL, 113138),
(113139, '1.20.58.60-FF-000270', NULL, 'Microtubule-actin cross-linking factor 1', 215, NULL, NULL, 113139),
(113140, '3.40.50.1220-FF-000137', NULL, 'Uncharacterized protein', 52, NULL, NULL, 113140),
(113141, '2.40.240.10-FF-000001', NULL, 'Glutamine--tRNA ligase', 128, NULL, NULL, 113141),
(113142, '3.40.50.261-FF-000003', NULL, 'ATP-citrate synthase subunit', 186, NULL, NULL, 113142),
(113143, '1.50.10.130-FF-000028', NULL, NULL, 108, NULL, NULL, 113143),
(113144, '3.40.47.10-FF-000185', NULL, 'BIOTIN PIMELOYL-COA SYNTHESIS PROTEIN', 326, NULL, NULL, 113144),
(113145, '3.30.200.20-FF-000955', NULL, 'Protein kinase, putative', 98, NULL, NULL, 113145),
(113146, '2.60.40.10-FF-005494', NULL, NULL, 95, NULL, NULL, 113146),
(113147, '1.10.472.80-FF-000211', NULL, NULL, 155, NULL, NULL, 113147),
(113148, '2.30.29.30-FF-001107', NULL, 'Multisubstrate adapter protein soc-1', 145, NULL, NULL, 113148),
(113149, '1.20.1070.10-FF-000433', NULL, 'Uncharacterized protein, isoform A', 253, NULL, NULL, 113149),
(113150, '2.130.10.10-FF-003538', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', 298, NULL, NULL, 113150),
(113151, '2.60.40.10-FF-000008', NULL, 'roundabout homolog 2 isoform X2', 93, NULL, NULL, 113151),
(113152, '2.40.50.140-FF-000684', NULL, NULL, 86, NULL, NULL, 113152),
(113153, '3.30.200.20-FF-000894', NULL, 'Ethanolamine kinase', 50, NULL, NULL, 113153),
(113154, '2.30.42.10-FF-000593', NULL, NULL, 104, NULL, NULL, 113154),
(113155, '3.30.540.10-FF-000101', NULL, 'Uncharacterized protein', 72, NULL, NULL, 113155),
(113156, '1.10.1200.10-FF-000093', NULL, 'Nonribosomal peptide synthase, putative', 71, NULL, NULL, 113156);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(113157, '3.30.470.30-FF-000034', NULL, 'DNA ligase', 243, NULL, NULL, 113157),
(113158, '3.10.105.10-FF-000112', NULL, 'Dipeptide-binding protein', 225, NULL, NULL, 113158),
(113159, '1.20.870.10-FF-000012', NULL, 'Rap guanine nucleotide exchange factor like 1', 161, NULL, NULL, 113159),
(113160, '3.30.230.10-FF-000393', NULL, 'Uncharacterized protein', 81, NULL, NULL, 113160),
(113161, '3.40.1110.10-FF-000459', NULL, NULL, 117, NULL, NULL, 113161),
(113162, '1.25.10.10-FF-002669', NULL, 'Predicted protein', 983, NULL, NULL, 113162),
(113163, '1.20.1070.10-FF-000063', NULL, 'C-X-C chemokine receptor type 4', 300, NULL, NULL, 113163),
(113164, '1.10.472.80-FF-000150', NULL, NULL, 140, NULL, NULL, 113164),
(113165, '3.40.50.300-FF-004696', NULL, 'Uncharacterized protein', 251, NULL, NULL, 113165),
(113166, '2.40.400.10-FF-000003', NULL, 'Protein NEOXANTHIN-DEFICIENT 1', 172, NULL, NULL, 113166),
(113167, '1.20.1510.10-FF-000097', NULL, NULL, 124, NULL, NULL, 113167),
(113168, '1.10.630.10-FF-000755', NULL, 'Uncharacterized protein', 53, NULL, NULL, 113168),
(113169, '3.40.50.300-FF-006478', NULL, 'Uncharacterized protein', 117, NULL, NULL, 113169),
(113170, '2.30.110.10-FF-000090', NULL, 'PPOX class F420-dependent oxidoreductase', 120, NULL, NULL, 113170),
(113171, '2.130.10.10-FF-001756', NULL, 'WD-repeat family protein/ BING4', 255, NULL, NULL, 113171),
(113172, '3.30.1640.10-FF-000086', NULL, 'DNA helicase', 72, NULL, NULL, 113172),
(113173, '1.25.10.10-FF-000062', NULL, 'Serine/threonine-protein phosphatase 2A regulatory subunit A alpha isoform', 580, NULL, NULL, 113173),
(113174, '2.130.10.10-FF-001301', NULL, 'Beta-alanine-activating enzyme', 237, NULL, NULL, 113174),
(113175, '2.20.25.240-FF-000013', NULL, 'Pharyngeal Enhancer Binding', 86, NULL, NULL, 113175),
(113176, '3.30.300.160-FF-000003', NULL, 'Type IV-A pilus assembly ATPase PilB', 80, NULL, NULL, 113176),
(113177, '4.10.1060.10-FF-000017', NULL, 'FUS RNA-binding protein', 42, NULL, NULL, 113177),
(113178, '1.10.510.10-FF-001325', NULL, 'Serine/threonine protein kinase RIO1, putative', 133, NULL, NULL, 113178),
(113179, '2.130.10.10-FF-004027', NULL, 'Nucleoporin 43', 221, NULL, NULL, 113179),
(113180, '3.30.420.10-FF-000637', NULL, NULL, 153, NULL, NULL, 113180),
(113181, '1.25.40.20-FF-000100', NULL, 'unconventional myosin-XVI', 159, NULL, NULL, 113181),
(113182, '1.10.8.60-FF-000244', NULL, 'AAA family ATPase, putative', 64, NULL, NULL, 113182),
(113183, '2.120.10.80-FF-000193', NULL, 'F-box/kelch-repeat protein isoform A', 149, NULL, NULL, 113183),
(113184, '3.30.710.10-FF-000401', NULL, 'BTB domain containing 2', 117, NULL, NULL, 113184),
(113185, '1.10.10.60-FF-000773', NULL, NULL, 62, NULL, NULL, 113185),
(113186, '3.30.70.580-FF-000020', NULL, 'tRNA pseudouridine synthase', 136, NULL, NULL, 113186),
(113187, '3.20.20.60-FF-000156', NULL, 'Aldolase like', 178, NULL, NULL, 113187),
(113188, '3.30.260.10-FF-000102', NULL, NULL, 71, NULL, NULL, 113188),
(113189, '3.40.50.1820-FF-000238', NULL, 'Uncharacterized protein, isoform B', 295, NULL, NULL, 113189),
(113190, '1.25.40.90-FF-000099', NULL, 'Kinesin-like protein', 150, NULL, NULL, 113190),
(113191, '1.10.1580.10-FF-000008', NULL, 'Large subunit GTPase 1', 102, NULL, NULL, 113191),
(113192, '3.20.20.80-FF-000651', NULL, 'Uncharacterized protein', 83, NULL, NULL, 113192),
(113193, '3.40.630.30-FF-000163', NULL, 'GM12182p', 176, NULL, NULL, 113193),
(113194, '3.40.50.2000-FF-000326', NULL, 'Glycosyltransferase', 224, NULL, NULL, 113194),
(113195, '1.20.1070.10-FF-001844', NULL, 'Uncharacterized protein', 301, NULL, NULL, 113195),
(113196, '2.60.40.1180-FF-000104', NULL, 'Domain_of_uncharacterized_function_(DUF1935)_-_pu tative', 113, NULL, NULL, 113196),
(113197, '3.20.90.10-FF-000005', NULL, 'Tubby-like F-box protein', 195, NULL, NULL, 113197),
(113198, '2.20.70.10-FF-000091', NULL, 'Flowering time control protein FCA isoform A', 51, NULL, NULL, 113198),
(113199, '3.40.50.150-FF-001301', NULL, NULL, 214, NULL, NULL, 113199),
(113200, '3.40.50.720-FF-002186', NULL, 'ATG7 autophagy-related 7 homolog (S. cerevisiae)', 51, NULL, NULL, 113200);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(113201, '1.10.10.10-FF-001663', NULL, 'Uncharacterized protein', 64, NULL, NULL, 113201),
(113202, '3.10.20.90-FF-000132', NULL, 'Ras association domain-containing protein 7', 90, NULL, NULL, 113202),
(113203, '1.10.3380.10-FF-000027', NULL, 'Translocation protein, putative', 149, NULL, NULL, 113203),
(113204, '1.20.1270.60-FF-000143', NULL, 'Proline-serine-threonine phosphatase-interacting protein 1b', 274, NULL, NULL, 113204),
(113205, '2.60.40.10-FF-000952', NULL, 'PZP, alpha-2-macroglobulin like', 85, NULL, NULL, 113205),
(113206, '1.10.287.70-FF-000626', NULL, 'Uncharacterized protein', 217, NULL, NULL, 113206),
(113207, '1.20.1280.20-FF-000019', NULL, 'Co-chaperone HscB, C-terminal oligomerization domain-containing protein', 83, NULL, NULL, 113207),
(113208, '3.30.10.20-FF-000025', NULL, NULL, 57, NULL, NULL, 113208),
(113209, '1.25.40.10-FF-003806', NULL, 'Peroxisomal targeting signal receptor', 316, NULL, NULL, 113209),
(113210, '2.60.40.10-FF-004403', NULL, NULL, 50, NULL, NULL, 113210),
(113211, '2.60.40.10-FF-005022', NULL, NULL, 104, NULL, NULL, 113211),
(113212, '1.25.40.10-FF-002952', NULL, 'Predicted protein', 188, NULL, NULL, 113212),
(113213, '3.30.460.10-FF-000067', NULL, 'Terminal uridylyltransferase cid1', 113, NULL, NULL, 113213),
(113214, '3.30.930.10-FF-000367', NULL, 'Uncharacterized protein', 114, NULL, NULL, 113214),
(113215, '2.10.220.10-FF-000153', NULL, 'Receptor protein-tyrosine kinase', 106, NULL, NULL, 113215),
(113216, '3.30.200.20-FF-001720', NULL, 'YALI0F23287p', 140, NULL, NULL, 113216),
(113217, '3.40.1550.20-FF-000001', NULL, 'Transcriptional regulator MraZ', 143, NULL, NULL, 113217),
(113218, '3.40.50.1820-FF-000385', NULL, 'Alpha/beta fold family hydrolase', 288, NULL, NULL, 113218),
(113219, '2.60.120.740-FF-000017', NULL, 'adhesion G protein-coupled receptor L3', 110, NULL, NULL, 113219),
(113220, '2.60.40.790-FF-000012', NULL, 'SGT1 homolog, MIS12 kinetochore complex assembly cochaperone', 110, NULL, NULL, 113220),
(113221, '1.10.287.2620-FF-000004', NULL, 'Dynein axonemal heavy chain 17', 65, NULL, NULL, 113221),
(113222, '1.25.40.10-FF-002497', NULL, 'Histone demethylase UTY', 168, NULL, NULL, 113222),
(113223, '3.40.50.2300-FF-000265', NULL, 'Guanylate cyclase', 173, NULL, NULL, 113223),
(113224, '2.30.110.10-FF-000073', NULL, 'GM21452', 212, NULL, NULL, 113224),
(113225, '3.20.20.140-FF-000263', NULL, 'Uncharacterized protein', 130, NULL, NULL, 113225),
(113226, '3.30.830.10-FF-000320', NULL, 'Uncharacterized protein', 63, NULL, NULL, 113226),
(113227, '2.130.10.10-FF-003201', NULL, 'AaceriAAL060Wp', 404, NULL, NULL, 113227),
(113228, '1.20.5.110-FF-000273', NULL, 'Uncharacterized protein', 79, NULL, NULL, 113228),
(113229, '3.40.50.300-FF-003735', NULL, 'DNA mismatch repair protein MSH3', 272, NULL, NULL, 113229),
(113230, '1.10.1740.10-FF-000015', NULL, 'RNA polymerase sigma factor SigX', 79, NULL, NULL, 113230),
(113231, '1.10.472.10-FF-000382', NULL, 'Putative cyclin-D7-1', 121, NULL, NULL, 113231),
(113232, '3.90.70.10-FF-000422', NULL, 'Uncharacterized protein', 140, NULL, NULL, 113232),
(113233, '1.10.510.10-FF-003664', NULL, NULL, 178, NULL, NULL, 113233),
(113234, '1.10.10.10-FF-000674', NULL, 'U5 small nuclear ribonucleoprotein helicase', 105, NULL, NULL, 113234),
(113235, '1.20.58.90-FF-000003', NULL, 'Centrosomal protein of 57 kDa', 78, NULL, NULL, 113235),
(113236, '3.30.70.100-FF-000056', NULL, 'Heavy metal transporting ATPase', 68, NULL, NULL, 113236),
(113237, '3.30.160.60-FF-005943', NULL, NULL, 28, NULL, NULL, 113237),
(113238, '2.60.120.260-FF-000615', NULL, 'Uncharacterized protein', 137, NULL, NULL, 113238),
(113239, '2.40.50.140-FF-000184', NULL, 'replication protein A 32 kDa subunit A-like', 135, NULL, NULL, 113239),
(113240, '3.40.630.10-FF-000494', NULL, 'Clan MH, family M18, aspartyl aminopeptidase-like metallopeptidase', 269, NULL, NULL, 113240),
(113241, '3.60.160.10-FF-000003', NULL, 'Altered inheritance of mitochondria protein 24, mitochondrial', 253, NULL, NULL, 113241),
(113242, '3.80.10.10-FF-003752', NULL, 'Uncharacterized protein', 123, NULL, NULL, 113242);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(113243, '3.20.200.10-FF-000016', NULL, 'Alpha-kinase 2', 49, NULL, NULL, 113243),
(113244, '1.10.510.10-FF-000027', NULL, 'Receptor protein-tyrosine kinase', 193, NULL, NULL, 113244),
(113245, '1.20.1480.30-FF-000004', NULL, 'Uncharacterized protein', 73, NULL, NULL, 113245),
(113246, '3.40.50.620-FF-000296', NULL, 'Universal stress protein family', 148, NULL, NULL, 113246),
(113247, '2.60.40.1120-FF-000002', NULL, 'MFS transporter', 80, NULL, NULL, 113247),
(113248, '3.40.50.720-FF-001489', NULL, 'YALI0E19657p', 23, NULL, NULL, 113248),
(113249, '2.30.30.1020-FF-000035', NULL, NULL, 181, NULL, NULL, 113249),
(113250, '3.40.50.11350-FF-000045', NULL, 'Uncharacterized protein', 164, NULL, NULL, 113250),
(113251, '3.30.2290.10-FF-000025', NULL, 'PmbA protein, putative', 212, NULL, NULL, 113251),
(113252, '3.50.50.60-FF-000325', NULL, 'Squalene monooxygenase', 130, NULL, NULL, 113252),
(113253, '2.70.130.10-FF-000104', NULL, NULL, 148, NULL, NULL, 113253),
(113254, '3.40.850.10-FF-000521', NULL, 'Protein CBR-KLP-13', 113, NULL, NULL, 113254),
(113255, '2.60.120.200-FF-000204', NULL, 'Crumbs cell polarity complex component 2', 159, NULL, NULL, 113255),
(113256, '1.20.5.110-FF-000317', NULL, 'Uncharacterized protein', 48, NULL, NULL, 113256),
(113257, '3.40.50.300-FF-007630', NULL, 'ABC transporter, putative', 145, NULL, NULL, 113257),
(113258, '1.20.58.390-FF-000108', NULL, 'Uncharacterized protein', 73, NULL, NULL, 113258),
(113259, '3.30.1360.20-FF-000005', NULL, 'Putative pterin-4-alpha-carbinolamine dehydratase', 114, NULL, NULL, 113259),
(113260, '2.60.120.10-FF-000123', NULL, 'cGMP-dependent protein kinase 14-1', 138, NULL, NULL, 113260),
(113261, '1.20.1560.10-FF-000628', NULL, 'Os02g0189800 protein', 262, NULL, NULL, 113261),
(113262, '2.60.40.10-FF-004875', NULL, NULL, 107, NULL, NULL, 113262),
(113263, '2.10.25.10-FF-001498', NULL, 'Faulty attraction, isoform F', 34, NULL, NULL, 113263),
(113264, '1.25.40.820-FF-000021', NULL, 'Uncharacterized protein', 178, NULL, NULL, 113264),
(113265, '2.130.10.10-FF-002684', NULL, 'WD-repeat protein, putative', 338, NULL, NULL, 113265),
(113266, '3.30.160.60-FF-003465', NULL, 'IP14705p', 36, NULL, NULL, 113266),
(113267, '3.40.366.10-FF-000025', NULL, 'Fatty acid synthase beta subunit aflB', 122, NULL, NULL, 113267),
(113268, '3.50.50.60-FF-001270', NULL, 'Cc2-17', 77, NULL, NULL, 113268),
(113269, '2.130.10.10-FF-004527', NULL, 'Predicted protein', 229, NULL, NULL, 113269),
(113270, '3.40.50.300-FF-003252', NULL, 'Putative SNF2 family helicase', 218, NULL, NULL, 113270),
(113271, '3.90.1300.10-FF-000018', NULL, 'Fatty acid amide hydrolase', 462, NULL, NULL, 113271),
(113272, '2.40.15.10-FF-000001', NULL, 'protein p13 MTCP-1', 107, NULL, NULL, 113272),
(113273, '2.40.30.10-FF-000497', NULL, 'Uncharacterized protein', 110, NULL, NULL, 113273),
(113274, '1.10.510.10-FF-001764', NULL, 'cyclin-dependent kinase 12-like', 132, NULL, NULL, 113274),
(113275, '1.20.1250.20-FF-001619', NULL, 'Os02g0757400 protein', 153, NULL, NULL, 113275),
(113276, '3.40.50.1000-FF-000791', NULL, NULL, 192, NULL, NULL, 113276),
(113277, '2.60.40.1680-FF-000001', NULL, 'Baseplate wedge tail fiber connector', 114, NULL, NULL, 113277),
(113278, '3.40.50.300-FF-007097', NULL, 'DNA replication and repair protein RecF', 295, NULL, NULL, 113278),
(113279, '1.20.190.60-FF-000003', NULL, 'Protein CBR-SMG-7', 41, NULL, NULL, 113279),
(113280, '3.20.20.70-FF-000294', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 377, NULL, NULL, 113280),
(113281, '1.10.287.310-FF-000007', NULL, '50S ribosomal protein L29', 61, NULL, NULL, 113281),
(113282, '3.30.2160.10-FF-000021', NULL, 'E3 ubiquitin-protein ligase HECTD1', 52, NULL, NULL, 113282),
(113283, '3.30.70.660-FF-000055', NULL, 'tRNA pseudouridine synthase', 226, NULL, NULL, 113283),
(113284, '3.30.160.60-FF-003774', NULL, NULL, 26, NULL, NULL, 113284),
(113285, '4.10.280.10-FF-000109', NULL, 'Transcription factor bHLH91-like', 71, NULL, NULL, 113285),
(113286, '3.90.470.10-FF-000037', NULL, 'Uncharacterized protein', 165, NULL, NULL, 113286);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(113287, '3.40.50.150-FF-000767', NULL, 'Uncharacterized protein', 96, NULL, NULL, 113287),
(113288, '3.30.70.1820-FF-000011', NULL, NULL, 89, NULL, NULL, 113288),
(113289, '2.30.42.10-FF-000093', NULL, 'multiple PDZ domain protein isoform X1', 127, NULL, NULL, 113289),
(113290, '3.30.160.60-FF-005460', NULL, NULL, 33, NULL, NULL, 113290),
(113291, '2.10.25.10-FF-001526', NULL, 'Sperm transmembrane protein 9', 47, NULL, NULL, 113291),
(113292, '2.70.50.30-FF-000014', NULL, NULL, 146, NULL, NULL, 113292),
(113293, '3.40.50.720-FF-002006', NULL, 'Predicted protein', 224, NULL, NULL, 113293),
(113294, '3.90.1750.20-FF-000004', NULL, 'Recombinase family protein', 163, NULL, NULL, 113294),
(113295, '3.90.190.10-FF-000116', NULL, 'YVH1p Protein phosphatase', 168, NULL, NULL, 113295),
(113296, '1.10.533.10-FF-000052', NULL, 'Putative receptor-interacting serine/threonine-protein kinase 1', 99, NULL, NULL, 113296),
(113297, '2.130.10.10-FF-000475', NULL, 'Kinesin family member 21B', 113, NULL, NULL, 113297),
(113298, '2.130.10.10-FF-001273', NULL, 'WD domain, G-beta repeat-containing protein', 152, NULL, NULL, 113298),
(113299, '3.40.525.10-FF-000069', NULL, 'Sec14p-like phosphatidylinositol transfer family protein', 150, NULL, NULL, 113299),
(113300, '2.60.120.920-FF-000049', NULL, 'Tripartite motif containing 4', 200, NULL, NULL, 113300),
(113301, '3.30.1490.20-FF-000009', NULL, 'Glutathione synthetase', 65, NULL, NULL, 113301),
(113302, '2.60.40.150-FF-000287', NULL, 'Multiple C2 domains, transmembrane 1b', 124, NULL, NULL, 113302),
(113303, '2.30.30.170-FF-000005', NULL, 'Fibronectin binding autolysin', 80, NULL, NULL, 113303),
(113304, '1.20.1720.10-FF-000034', NULL, 'MFS transporter, putative', 412, NULL, NULL, 113304),
(113305, '2.70.150.10-FF-000004', NULL, 'Plasma membrane ATPase', 85, NULL, NULL, 113305),
(113306, '1.10.10.1320-FF-000001', NULL, 'Anti-sigma-K factor RskA', 80, NULL, NULL, 113306),
(113307, '3.40.50.720-FF-000432', NULL, 'Blast:Glyoxylate reductase/hydroxypyruvate reductase', 120, NULL, NULL, 113307),
(113308, '2.40.50.90-FF-000005', NULL, 'Staphylococcal nuclease domain-containing protein', 119, NULL, NULL, 113308),
(113309, '2.40.10.10-FF-000597', NULL, NULL, 132, NULL, NULL, 113309),
(113310, '2.130.10.10-FF-005146', NULL, 'Uncharacterized protein', 163, NULL, NULL, 113310),
(113311, '1.20.1730.10-FF-000119', NULL, 'Uncharacterized protein', 79, NULL, NULL, 113311),
(113312, '3.30.420.10-FF-000154', NULL, 'RBR-type E3 ubiquitin transferase', 135, NULL, NULL, 113312),
(113313, '2.10.25.10-FF-000346', NULL, 'Cartilage oligomeric matrix protein', 39, NULL, NULL, 113313),
(113314, '3.90.920.10-FF-000027', NULL, 'Uncharacterized protein', 239, NULL, NULL, 113314),
(113315, '1.20.58.340-FF-000026', NULL, 'Metal ion channel-Mg2+, Co2+ and Ni2', 178, NULL, NULL, 113315),
(113316, '3.30.420.310-FF-000002', NULL, '2-dehydro-3-deoxygalactonate kinase', 230, NULL, NULL, 113316),
(113317, '3.30.390.30-FF-000050', NULL, 'FAD-dependent pyridine nucleotide-disulphide oxidoreductase', 123, NULL, NULL, 113317),
(113318, '1.10.150.20-FF-000165', NULL, 'Holliday junction ATP-dependent DNA helicase RuvA', 72, NULL, NULL, 113318),
(113319, '2.30.42.10-FF-000576', NULL, NULL, 116, NULL, NULL, 113319),
(113320, '3.40.50.1240-FF-000132', NULL, 'Ubiquitin associated and SH3 domain containing A', 189, NULL, NULL, 113320),
(113321, '1.10.1200.10-FF-000076', NULL, 'Nonribosomal peptide synthase GliP2', 69, NULL, NULL, 113321),
(113322, '3.40.630.10-FF-000185', NULL, 'Nicastrin', 290, NULL, NULL, 113322),
(113323, '3.30.70.270-FF-000180', NULL, NULL, 115, NULL, NULL, 113323),
(113324, '3.60.21.60-FF-000044', NULL, 'DNA polymerase alpha subunit B-like Protein', 102, NULL, NULL, 113324),
(113325, '1.10.238.10-FF-000203', NULL, 'Probable calcium-binding protein CML27', 72, NULL, NULL, 113325),
(113326, '1.10.30.50-FF-000018', NULL, 'Phage endonuclease', 105, NULL, NULL, 113326),
(113327, '3.30.420.10-FF-000284', NULL, 'Integrase/recombinase, core domain family', 111, NULL, NULL, 113327),
(113328, '1.10.274.10-FF-000005', NULL, 'Fused phosphoenolpyruvate-protein phosphotransferase PtsP/GAF domain', 125, NULL, NULL, 113328);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(113329, '1.20.1110.10-FF-000151', NULL, 'Cation-transporter ATPase I CtpI', 328, NULL, NULL, 113329),
(113330, '3.40.1280.30-FF-000011', NULL, 'tRNA (Guanine-1)-methyltransferase, putative', 210, NULL, NULL, 113330),
(113331, '2.120.10.80-FF-000176', NULL, 'Protein CBR-TAG-53', 171, NULL, NULL, 113331),
(113332, '3.30.310.210-FF-000009', NULL, 'Defective in germ line development protein 3', 153, NULL, NULL, 113332),
(113333, '1.20.1250.20-FF-001136', NULL, 'Synaptic vesicle glycoprotein 2Ba', 322, NULL, NULL, 113333),
(113334, '1.10.510.10-FF-000819', NULL, 'TKL protein kinase', 268, NULL, NULL, 113334),
(113335, '3.30.50.10-FF-000070', NULL, 'Nuclear hormone receptor family member nhr-2', 106, NULL, NULL, 113335),
(113336, '1.20.58.1120-FF-000068', NULL, NULL, 147, NULL, NULL, 113336),
(113337, '1.10.1070.11-FF-000139', NULL, 'Uncharacterized protein', 113, NULL, NULL, 113337),
(113338, '1.10.510.10-FF-001308', NULL, 'Predicted protein', 184, NULL, NULL, 113338),
(113339, '1.10.555.10-FF-000097', NULL, 'CYtoKinesis defect', 207, NULL, NULL, 113339),
(113340, '1.10.630.10-FF-000738', NULL, 'Uncharacterized protein', 89, NULL, NULL, 113340),
(113341, '1.10.630.10-FF-000093', NULL, 'Cytochrome P450 monooxygenase', 461, NULL, NULL, 113341),
(113342, '1.25.40.80-FF-000011', NULL, 'Deoxyribodipyrimidine photolyase single-strand-specific', 160, NULL, NULL, 113342),
(113343, '1.20.1310.20-FF-000017', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 227, NULL, NULL, 113343),
(113344, '3.40.50.300-FF-001127', NULL, 'Genome polyprotein', 163, NULL, NULL, 113344),
(113345, '1.10.10.10-FF-001180', NULL, 'Myelin regulatory factor homolog 1', 179, NULL, NULL, 113345),
(113346, '3.40.50.720-FF-000741', NULL, '2-dehydropantoate 2-reductase', 187, NULL, NULL, 113346),
(113347, '2.60.120.430-FF-000026', NULL, 'Os05g0261700 protein', 137, NULL, NULL, 113347),
(113348, '1.10.10.60-FF-001262', NULL, NULL, 56, NULL, NULL, 113348),
(113349, '2.130.10.10-FF-000784', NULL, 'U3 small nucleolar RNA-interacting protein 2,putative', 327, NULL, NULL, 113349),
(113350, '3.30.420.40-FF-001006', NULL, 'Uncharacterized protein', 64, NULL, NULL, 113350),
(113351, '1.25.40.10-FF-001980', NULL, 'Os02g0555100 protein', 123, NULL, NULL, 113351),
(113352, '1.20.1250.20-FF-001799', NULL, 'Uncharacterized protein', 173, NULL, NULL, 113352),
(113353, '3.90.226.10-FF-000184', NULL, 'Enoyl-CoA hydratase', 218, NULL, NULL, 113353),
(113354, '3.60.110.10-FF-000068', NULL, 'Glutamine-dependent NAD(+) synthetase', 279, NULL, NULL, 113354),
(113355, '3.40.50.1400-FF-000023', NULL, 'Ferrochelatase', 177, NULL, NULL, 113355),
(113356, '3.10.620.30-FF-000011', NULL, 'Transglutaminase family protein', 184, NULL, NULL, 113356),
(113357, '3.10.20.90-FF-000957', NULL, 'Uncharacterized protein', 60, NULL, NULL, 113357),
(113358, '1.25.40.20-FF-001218', NULL, 'Uncharacterized protein', 188, NULL, NULL, 113358),
(113359, '3.30.450.20-FF-000586', NULL, 'Predicted protein', 124, NULL, NULL, 113359),
(113360, '3.30.200.20-FF-000972', NULL, 'Mitogen-activated protein kinase', 87, NULL, NULL, 113360),
(113361, '3.40.50.620-FF-000857', NULL, 'Uncharacterized protein', 207, NULL, NULL, 113361),
(113362, '3.40.50.1820-FF-000677', NULL, 'Alpha/beta hydrolase family protein', 287, NULL, NULL, 113362),
(113363, '1.20.1250.20-FF-000310', NULL, 'SPX domain-containing membrane protein At4g11810', 403, NULL, NULL, 113363),
(113364, '2.60.40.420-FF-000244', NULL, 'Uncharacterized protein', 43, NULL, NULL, 113364),
(113365, '2.30.29.30-FF-000135', NULL, 'Myotubularin related protein 6', 98, NULL, NULL, 113365),
(113366, '3.40.50.850-FF-000016', NULL, 'Cysteine hydrolase', 190, NULL, NULL, 113366),
(113367, '3.30.160.60-FF-002846', NULL, 'Si:dkey-237m9.1', 25, NULL, NULL, 113367),
(113368, '3.40.50.720-FF-000180', NULL, '4-hydroxy-tetrahydrodipicolinate reductase', 153, NULL, NULL, 113368),
(113369, '1.10.1140.10-FF-000003', NULL, 'Vacuolar ATP synthase catalytic subunit A', 155, NULL, NULL, 113369),
(113370, '3.40.50.1820-FF-000368', NULL, 'Unplaced genomic scaffold supercont2.8, whole genome shotgun sequence', 171, NULL, NULL, 113370);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(113371, '3.30.70.850-FF-000005', NULL, 'Neuroendocrine convertase', 89, NULL, NULL, 113371),
(113372, '3.30.160.60-FF-003335', NULL, NULL, 31, NULL, NULL, 113372),
(113373, '1.20.58.390-FF-000210', NULL, 'Nicotinic acetylcholine receptor subunit', 150, NULL, NULL, 113373),
(113374, '1.10.455.10-FF-000033', NULL, 'Ribosomal protein S7, mitochondrial', 134, NULL, NULL, 113374),
(113375, '3.40.50.2300-FF-000282', NULL, 'Heme response regulator HssR', 79, NULL, NULL, 113375),
(113376, '2.10.25.10-FF-000907', NULL, 'Integrin beta', 33, NULL, NULL, 113376),
(113377, '3.10.105.10-FF-000084', NULL, 'Peptide ABC transporter, periplasmic peptide-binding protein', 217, NULL, NULL, 113377),
(113378, '2.30.180.10-FF-000004', NULL, 'periostin isoform X1', 138, NULL, NULL, 113378),
(113379, '3.30.70.60-FF-000035', NULL, 'Type IV pilus biogenesis protein PilO', 106, NULL, NULL, 113379),
(113380, '3.90.20.20-FF-000040', NULL, 'Putative molecular chaperone of the grpe family', 119, NULL, NULL, 113380),
(113381, '1.10.287.700-FF-000001', NULL, 'Alpha-synuclein', 143, NULL, NULL, 113381),
(113382, '3.30.565.10-FF-000462', NULL, 'Sensory box histidine kinase, putative', 137, NULL, NULL, 113382),
(113383, '3.40.50.300-FF-002324', NULL, 'Midasin', 74, NULL, NULL, 113383),
(113384, '1.25.40.430-FF-000027', NULL, 'Predicted protein', 105, NULL, NULL, 113384),
(113385, '1.25.40.10-FF-001671', NULL, 'AT28279p', 123, NULL, NULL, 113385),
(113386, '1.25.40.10-FF-004397', NULL, 'Uncharacterized protein', 138, NULL, NULL, 113386),
(113387, '2.130.10.10-FF-005455', NULL, 'Uncharacterized protein', 186, NULL, NULL, 113387),
(113388, '3.10.28.10-FF-000064', NULL, 'Ribonucleoside-diphosphate reductase', 126, NULL, NULL, 113388),
(113389, '1.10.245.10-FF-000006', NULL, 'SWI/SNF nucleosome remodeling complex component', 83, NULL, NULL, 113389),
(113390, '3.30.1960.10-FF-000014', NULL, 'tRNA wybutosine-synthesizing protein 3 isoform 2-like protein', 64, NULL, NULL, 113390),
(113391, '3.90.110.10-FF-000016', NULL, 'L-lactate dehydrogenase', 164, NULL, NULL, 113391),
(113392, '3.40.50.960-FF-000021', NULL, '6,7-dimethyl-8-ribityllumazine synthase', 74, NULL, NULL, 113392),
(113393, '2.10.25.10-FF-000981', NULL, 'Wing blister, isoform B', 40, NULL, NULL, 113393),
(113394, '2.170.300.10-FF-000060', NULL, 'Uncharacterized protein', 65, NULL, NULL, 113394),
(113395, '3.90.1800.10-FF-000028', NULL, 'DNA-directed RNA polymerase subunit beta', 101, NULL, NULL, 113395),
(113396, '3.30.1740.10-FF-000003', NULL, 'Poly [ADP-ribose] polymerase', 91, NULL, NULL, 113396),
(113397, '3.30.413.10-FF-000025', NULL, 'Nitrite reductase (NAD(P)H) large subunit', 129, NULL, NULL, 113397),
(113398, '1.20.1250.20-FF-001928', NULL, 'Uncharacterized protein', 216, NULL, NULL, 113398),
(113399, '1.10.3730.20-FF-000046', NULL, 'Small multidrug resistance efflux transporter', 103, NULL, NULL, 113399),
(113400, '2.130.10.10-FF-005590', NULL, 'Uncharacterized protein', 198, NULL, NULL, 113400),
(113401, '3.40.640.10-FF-000112', NULL, 'Probable cysteine desulfurase', 262, NULL, NULL, 113401),
(113402, '3.20.20.100-FF-000071', NULL, 'Aldose reductase', 312, NULL, NULL, 113402),
(113403, '3.40.250.10-FF-000200', NULL, 'Uncharacterized protein', 171, NULL, NULL, 113403),
(113404, '1.20.1270.60-FF-000273', NULL, 'Zgc:158689', 76, NULL, NULL, 113404),
(113405, '2.60.40.10-FF-002958', NULL, 'Uncharacterized protein', 104, NULL, NULL, 113405),
(113406, '3.10.20.230-FF-000033', NULL, 'Doublecortin domain-containing 2B', 108, NULL, NULL, 113406),
(113407, '3.40.50.360-FF-000049', NULL, 'FMN-dependent NADH-azoreductase', 202, NULL, NULL, 113407),
(113408, '1.20.120.610-FF-000005', NULL, 'V-type sodium ATPase subunit K', 154, NULL, NULL, 113408),
(113409, '1.25.10.10-FF-001708', NULL, 'Predicted protein', 241, NULL, NULL, 113409),
(113410, '3.40.630.30-FF-000033', NULL, 'N-alpha-acetyltransferase 40 isoform X1', 178, NULL, NULL, 113410),
(113411, '2.40.50.140-FF-000976', NULL, NULL, 134, NULL, NULL, 113411),
(113412, '3.20.20.140-FF-000133', NULL, 'Amidohydrolase family protein', 310, NULL, NULL, 113412);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(113413, '3.40.50.1820-FF-001649', NULL, 'Uncharacterized protein', 379, NULL, NULL, 113413),
(113414, '3.40.50.300-FF-002908', NULL, 'Septin CDC11', 303, NULL, NULL, 113414),
(113415, '3.40.850.10-FF-000297', NULL, 'Kinesin-related protein 11', 376, NULL, NULL, 113415),
(113416, '3.30.60.90-FF-000004', NULL, 'Putative E3 ubiquitin-protein ligase MIB2', 54, NULL, NULL, 113416),
(113417, '3.40.50.1820-FF-000710', NULL, 'FI22312p1', 69, NULL, NULL, 113417),
(113418, '1.20.1250.20-FF-001344', NULL, 'Solute carrier family 2, facilitated glucose transporter member 12', 354, NULL, NULL, 113418),
(113419, '1.20.5.110-FF-000042', NULL, 'protein BRICK 1', 67, NULL, NULL, 113419),
(113420, '3.30.40.100-FF-000011', NULL, 'Uncharacterized protein', 62, NULL, NULL, 113420),
(113421, '3.30.160.60-FF-000800', NULL, 'zinc finger protein 181 isoform X2', 32, NULL, NULL, 113421),
(113422, '3.60.15.10-FF-000240', NULL, 'Uncharacterized protein', 138, NULL, NULL, 113422),
(113423, '3.20.20.300-FF-000007', NULL, 'Lysosomal beta glucosidase', 365, NULL, NULL, 113423),
(113424, '3.40.850.10-FF-000196', NULL, 'Kinesin-like protein', 355, NULL, NULL, 113424),
(113425, '3.10.20.90-FF-000002', NULL, 'Erythrocyte protein band 4.1-like 3', 82, NULL, NULL, 113425),
(113426, '2.60.40.10-FF-001880', NULL, 'Mga2p', 146, NULL, NULL, 113426),
(113427, '3.40.50.80-FF-000197', NULL, 'Ferric reductase-like transmembrane component', 104, NULL, NULL, 113427),
(113428, '3.30.70.1350-FF-000027', NULL, NULL, 83, NULL, NULL, 113428),
(113429, '3.90.1860.10-FF-000004', NULL, 'tRNA-splicing ligase RtcB', 246, NULL, NULL, 113429),
(113430, '1.10.510.10-FF-003433', NULL, NULL, 285, NULL, NULL, 113430),
(113431, '3.30.230.30-FF-000005', NULL, 'Protein IMPACT homolog', 132, NULL, NULL, 113431),
(113432, '1.20.1070.10-FF-000624', NULL, 'Uncharacterized protein', 334, NULL, NULL, 113432),
(113433, '2.10.25.10-FF-000554', NULL, 'Cubilin', 36, NULL, NULL, 113433),
(113434, '1.20.91.20-FF-000009', NULL, 'Uncharacterized protein', 81, NULL, NULL, 113434),
(113435, '1.10.472.80-FF-000133', NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', 133, NULL, NULL, 113435),
(113436, '3.30.160.60-FF-000901', NULL, 'CCCTC-binding factor like', 22, NULL, NULL, 113436),
(113437, '2.60.40.10-FF-005623', NULL, NULL, 98, NULL, NULL, 113437),
(113438, '2.30.42.10-FF-000654', NULL, NULL, 96, NULL, NULL, 113438),
(113439, '3.30.70.330-FF-000642', NULL, 'U2 snRNP auxiliary factor large subunit', 120, NULL, NULL, 113439),
(113440, '1.10.1410.10-FF-000030', NULL, 'PAP/25A associated domain containing protein', 160, NULL, NULL, 113440),
(113441, '3.40.50.10470-FF-000005', NULL, 'translation initiation factor eIF-2B subunit beta', 207, NULL, NULL, 113441),
(113442, '2.60.120.200-FF-000176', NULL, 'Galectin', 139, NULL, NULL, 113442),
(113443, '1.20.58.60-FF-000562', NULL, 'Plectin', 112, NULL, NULL, 113443),
(113444, '3.30.420.10-FF-000654', NULL, NULL, 200, NULL, NULL, 113444),
(113445, '3.40.50.300-FF-001818', NULL, 'Probable anion transporter atpase', 376, NULL, NULL, 113445),
(113446, '2.60.120.10-FF-000640', NULL, 'Uncharacterized protein', 172, NULL, NULL, 113446),
(113447, '3.30.1360.40-FF-000028', NULL, 'DNA gyrase subunit A', 97, NULL, NULL, 113447),
(113448, '3.30.1330.230-FF-000001', NULL, 'Ribosomal protein S12 methylthiotransferase accessory factor YcaO', 88, NULL, NULL, 113448),
(113449, '3.30.1320.10-FF-000011', NULL, 'Mitochondrial ribosomal protein S16', 149, NULL, NULL, 113449),
(113450, '3.90.650.10-FF-000074', NULL, '75b', 170, NULL, NULL, 113450),
(113451, '2.60.40.10-FF-003369', NULL, NULL, 82, NULL, NULL, 113451),
(113452, '3.90.70.10-FF-000686', NULL, 'Ubiquitin-specific peptidase 36', 239, NULL, NULL, 113452),
(113453, '1.10.533.10-FF-000035', NULL, 'nucleolar protein 3 isoform X5', 95, NULL, NULL, 113453),
(113454, '3.40.50.150-FF-001256', NULL, NULL, 326, NULL, NULL, 113454),
(113455, '1.10.10.760-FF-000001', NULL, 'Malto-oligosyltrehalose trehalohydrolase', 41, NULL, NULL, 113455),
(113456, '3.40.50.880-FF-000194', NULL, 'Predicted protein', 139, NULL, NULL, 113456);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(113457, '2.130.10.10-FF-004971', NULL, 'WD repeat protein, putative', 86, NULL, NULL, 113457),
(113458, '3.40.1620.60-FF-000007', NULL, 'Sol narae, isoform D', 84, NULL, NULL, 113458),
(113459, '3.30.160.60-FF-005691', NULL, NULL, 66, NULL, NULL, 113459),
(113460, '3.40.50.2300-FF-000618', NULL, 'Chromosome 15, whole genome shotgun sequence', 129, NULL, NULL, 113460),
(113461, '1.10.10.60-FF-000464', NULL, 'DNA invertase', 44, NULL, NULL, 113461),
(113462, '3.30.2300.10-FF-000010', NULL, 'Predicted protein', 86, NULL, NULL, 113462),
(113463, '3.30.1370.10-FF-000205', NULL, 'Uncharacterized protein', 66, NULL, NULL, 113463),
(113464, '3.40.50.80-FF-000152', NULL, 'Uncharacterized protein', 167, NULL, NULL, 113464),
(113465, '1.10.3380.10-FF-000044', NULL, 'Type III restriction enzyme, res subunit family protein', 140, NULL, NULL, 113465),
(113466, '1.10.287.70-FF-000497', NULL, 'Inward Rectifying K (Potassium) channel family', 46, NULL, NULL, 113466),
(113467, '1.10.10.160-FF-000029', NULL, 'DNA helicase', 80, NULL, NULL, 113467),
(113468, '3.40.1350.10-FF-000033', NULL, 'Sen15p', 118, NULL, NULL, 113468),
(113469, '3.50.50.60-FF-001522', NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', 216, NULL, NULL, 113469),
(113470, '3.30.160.60-FF-005151', NULL, NULL, 87, NULL, NULL, 113470),
(113471, '3.40.1280.10-FF-000117', NULL, 'Uncharacterized protein', 180, NULL, NULL, 113471),
(113472, '3.30.1330.40-FF-000043', NULL, 'RidA family protein', 119, NULL, NULL, 113472),
(113473, '2.60.40.10-FF-000351', NULL, 'CD166 antigen isoform X1', 87, NULL, NULL, 113473),
(113474, '3.80.10.10-FF-004241', NULL, 'Uncharacterized protein', 75, NULL, NULL, 113474),
(113475, '3.30.1520.10-FF-000122', NULL, 'Uncharacterized protein', 142, NULL, NULL, 113475),
(113476, '3.30.200.20-FF-001591', NULL, 'Receptor tyrosine kinase Torso-like protein', 135, NULL, NULL, 113476),
(113477, '2.30.38.10-FF-000015', NULL, 'Amino acid adenylation', 76, NULL, NULL, 113477),
(113478, '3.40.30.10-FF-000427', NULL, 'Protein disulfide-isomerase A4', 113, NULL, NULL, 113478),
(113479, '1.25.40.20-FF-001320', NULL, 'Uncharacterized protein', 138, NULL, NULL, 113479),
(113480, '1.25.40.20-FF-000600', NULL, 'Uncharacterized protein', 261, NULL, NULL, 113480),
(113481, '3.30.70.330-FF-000687', NULL, '54S ribosomal protein L23, mitochondrial', 154, NULL, NULL, 113481),
(113482, '3.30.160.60-FF-001992', NULL, 'Zinc finger and SCAN domain-containing protein 4', 36, NULL, NULL, 113482),
(113483, '1.10.730.10-FF-000139', NULL, 'Leucine--tRNA ligase', 28, NULL, NULL, 113483),
(113484, '1.25.10.10-FF-001282', NULL, 'Coatomer subunit gamma', 226, NULL, NULL, 113484),
(113485, '2.30.30.140-FF-000137', NULL, 'Protein MOS2', 55, NULL, NULL, 113485),
(113486, '1.10.510.10-FF-001455', NULL, 'CAMK protein kinase', 196, NULL, NULL, 113486),
(113487, '3.30.70.580-FF-000048', NULL, 'tRNA pseudouridine synthase', 113, NULL, NULL, 113487),
(113488, '3.90.480.20-FF-000001', NULL, 'Nitrite reductase [NAD(P)H] large subunit', 94, NULL, NULL, 113488),
(113489, '3.30.250.20-FF-000003', NULL, 'Uncharacterized protein', 80, NULL, NULL, 113489),
(113490, '3.30.56.10-FF-000009', NULL, 'Phenylalanine-tRNA ligase, beta subunit', 78, NULL, NULL, 113490),
(113491, '2.60.120.650-FF-000081', NULL, 'Predicted protein', 270, NULL, NULL, 113491),
(113492, '3.40.50.1820-FF-001065', NULL, 'Predicted protein', 165, NULL, NULL, 113492),
(113493, '2.20.25.80-FF-000006', NULL, 'WRKY transcription factor', 70, NULL, NULL, 113493),
(113494, '2.20.25.10-FF-000093', NULL, 'DNA-directed RNA polymerase subunit', 76, NULL, NULL, 113494),
(113495, '1.20.58.340-FF-000009', NULL, 'Magnesium transporter MRS2-1', 61, NULL, NULL, 113495),
(113496, '1.10.10.2170-FF-000003', NULL, 'Telomeric repeat-binding factor 2-interacting protein', 45, NULL, NULL, 113496),
(113497, '1.20.1560.10-FF-000319', NULL, 'ABC transporter ATP-binding protein', 317, NULL, NULL, 113497),
(113498, '2.60.120.10-FF-000095', NULL, 'HTH-type transcriptional activator RhaR', 93, NULL, NULL, 113498);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(113499, '3.30.40.10-FF-000816', NULL, 'Uncharacterized protein, isoform A', 66, NULL, NULL, 113499),
(113500, '3.40.50.150-FF-000003', NULL, 'Blast:Protein arginine N-methyltransferase 1', 151, NULL, NULL, 113500),
(113501, '1.20.1250.20-FF-000990', NULL, 'Probable sphingolipid transporter spinster homolog 1', 432, NULL, NULL, 113501),
(113502, '1.10.8.60-FF-000036', NULL, 'Spastin', 84, NULL, NULL, 113502),
(113503, '3.30.160.60-FF-005382', NULL, NULL, 48, NULL, NULL, 113503),
(113504, '3.40.50.1820-FF-000446', NULL, 'Alpha/beta-Hydrolases superfamily protein', 155, NULL, NULL, 113504),
(113505, '2.40.30.10-FF-000008', NULL, 'Translation initiation factor IF-2', 98, NULL, NULL, 113505),
(113506, '2.60.120.620-FF-000066', NULL, 'Uncharacterized protein', 66, NULL, NULL, 113506),
(113507, '1.10.1780.10-FF-000006', NULL, 'Chaperone protein ClpB3, chloroplastic', 147, NULL, NULL, 113507),
(113508, '3.30.2130.30-FF-000008', NULL, 'THUMP domain-containing protein 3', 144, NULL, NULL, 113508),
(113509, '1.10.10.10-FF-001163', NULL, 'RNA helicase', 85, NULL, NULL, 113509),
(113510, '3.30.160.60-FF-002245', NULL, 'Zinc finger protein 473', 31, NULL, NULL, 113510),
(113511, '1.25.40.10-FF-001536', NULL, 'SYF pre-mRNA splicing factor homolog', 242, NULL, NULL, 113511),
(113512, '2.130.10.10-FF-003229', NULL, 'Cilia- and flagella-associated protein 43', 272, NULL, NULL, 113512),
(113513, '3.30.230.10-FF-000263', NULL, '30S ribosomal protein S9, chloroplastic', 189, NULL, NULL, 113513),
(113514, '3.40.50.620-FF-000812', NULL, 'Uncharacterized protein', 206, NULL, NULL, 113514),
(113515, '3.30.930.10-FF-000412', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 4-like Protein', 329, NULL, NULL, 113515),
(113516, '2.60.40.10-FF-003678', NULL, NULL, 97, NULL, NULL, 113516),
(113517, '1.10.10.10-FF-001871', NULL, 'Uncharacterized protein MJ0241', 63, NULL, NULL, 113517),
(113518, '2.40.128.330-FF-000016', NULL, 'Uncharacterized protein', 90, NULL, NULL, 113518),
(113519, '1.25.40.10-FF-003014', NULL, 'Intraflagellar transport protein IFT88', 116, NULL, NULL, 113519),
(113520, '3.30.160.60-FF-001565', NULL, 'zinc finger protein 263', 35, NULL, NULL, 113520),
(113521, '1.10.10.440-FF-000006', NULL, 'Transcription elongation regulator 1 (CA150)', 61, NULL, NULL, 113521),
(113522, '2.20.100.10-FF-000209', NULL, 'Thrombospondin type-1 domain-containing protein 7B', 57, NULL, NULL, 113522),
(113523, '1.25.40.10-FF-005223', NULL, 'Pentatricopeptide (PPR) repeat-containing protein-like', 190, NULL, NULL, 113523),
(113524, '3.30.160.60-FF-001520', NULL, 'Zinc finger protein 423', 23, NULL, NULL, 113524),
(113525, '3.30.70.870-FF-000028', NULL, 'Pre-mRNA-splicing factor SNU114', 77, NULL, NULL, 113525),
(113526, '3.90.190.10-FF-000364', NULL, 'Uncharacterized protein', 122, NULL, NULL, 113526),
(113527, '2.40.50.140-FF-000745', NULL, NULL, 94, NULL, NULL, 113527),
(113528, '3.30.200.20-FF-002428', NULL, NULL, 79, NULL, NULL, 113528),
(113529, '3.40.50.790-FF-000037', NULL, 'Putative ribosome biogenesis protein C8F11.04', 96, NULL, NULL, 113529),
(113530, '3.40.50.1010-FF-000131', NULL, 'Tegument host shutoff protein', 241, NULL, NULL, 113530),
(113531, '3.40.50.2300-FF-001462', NULL, 'Circadian clock protein KaiA', 167, NULL, NULL, 113531),
(113532, '3.10.10.10-FF-000006', NULL, 'Paternally expressed 10', 78, NULL, NULL, 113532),
(113533, '1.10.260.40-FF-000033', NULL, 'AnsR family transcriptional regulator', 117, NULL, NULL, 113533),
(113534, '3.20.20.80-FF-000712', NULL, 'Glucosylceramidase', 209, NULL, NULL, 113534),
(113535, '1.20.1530.20-FF-000028', NULL, 'Cation/H(+) antiporter 14', 409, NULL, NULL, 113535),
(113536, '3.40.50.10330-FF-000059', NULL, 'NAD kinase', 106, NULL, NULL, 113536),
(113537, '3.40.50.720-FF-000972', NULL, 'Pyrroline-5-carboxylate reductase', 150, NULL, NULL, 113537),
(113538, '1.10.287.1260-FF-000001', NULL, 'Small-conductance mechanosensitive channel MscS', 102, NULL, NULL, 113538),
(113539, '1.10.472.130-FF-000078', NULL, 'Dynein axonemal heavy chain 10', 114, NULL, NULL, 113539); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(113540, '2.40.170.20-FF-000122', NULL, 'Transporter, outer membrane receptor (OMR) family', 393, NULL, NULL, 113540),
(113541, '1.10.167.10-FF-000004', NULL, 'sorting nexin-14 isoform X1', 157, NULL, NULL, 113541),
(113542, '3.30.70.850-FF-000022', NULL, 'Uncharacterized protein', 77, NULL, NULL, 113542),
(113543, '3.40.50.11500-FF-000034', NULL, NULL, 180, NULL, NULL, 113543),
(113544, '3.40.50.1970-FF-000042', NULL, 'NADH-dependent butanol dehydrogenase A', 189, NULL, NULL, 113544),
(113545, '3.90.1520.10-FF-000001', NULL, 'Guanylate cyclase soluble subunit beta-1', 191, NULL, NULL, 113545),
(113546, '1.10.10.60-FF-001184', NULL, NULL, 30, NULL, NULL, 113546),
(113547, '1.10.1300.10-FF-000038', NULL, 'Phosphodiesterase', 205, NULL, NULL, 113547),
(113548, '2.60.120.10-FF-000432', NULL, 'Crp/Fnr family transcriptional regulator', 149, NULL, NULL, 113548),
(113549, '3.60.40.10-FF-000062', NULL, 'Protein phosphatase 1K, mitochondrial', 200, NULL, NULL, 113549),
(113550, '2.130.10.30-FF-000014', NULL, 'probable E3 ubiquitin-protein ligase HERC4 isoform X1', 121, NULL, NULL, 113550),
(113551, '1.20.1740.10-FF-000148', NULL, 'Predicted protein', 422, NULL, NULL, 113551),
(113552, '3.30.1370.10-FF-000093', NULL, 'KH domain-containing protein', 98, NULL, NULL, 113552),
(113553, '2.60.40.10-FF-003105', NULL, 'Protein sidekick-2', 101, NULL, NULL, 113553),
(113554, '3.40.50.300-FF-006450', NULL, 'Predicted ABC-type transport system, ATPase component', 123, NULL, NULL, 113554),
(113555, '3.30.160.60-FF-004763', NULL, NULL, 84, NULL, NULL, 113555),
(113556, '1.25.40.180-FF-000273', NULL, NULL, 185, NULL, NULL, 113556),
(113557, '3.40.190.10-FF-000813', NULL, 'Transferrin-a', 65, NULL, NULL, 113557),
(113558, '1.20.1720.10-FF-000135', NULL, NULL, 196, NULL, NULL, 113558),
(113559, '3.40.50.2000-FF-000635', NULL, 'Alphaalpha-trehalose-phosphate synthase [UDP-forming] 5', 130, NULL, NULL, 113559),
(113560, '3.40.50.150-FF-000576', NULL, 'Cyclopropane-fatty-acyl-phospholipid synthase', 287, NULL, NULL, 113560),
(113561, '3.90.470.20-FF-000074', NULL, 'YALI0E09306p', 139, NULL, NULL, 113561),
(113562, '1.10.10.10-FF-000090', NULL, 'Phosphatidylinositol-3,4,5-trisphosphate dependent Rac exchange factor 1', 97, NULL, NULL, 113562),
(113563, '3.50.30.30-FF-000091', NULL, 'Plr-1', 131, NULL, NULL, 113563),
(113564, '2.30.230.10-FF-000020', NULL, 'GD21667', 226, NULL, NULL, 113564),
(113565, '3.30.500.40-FF-000006', NULL, NULL, 133, NULL, NULL, 113565),
(113566, '2.130.10.10-FF-003190', NULL, 'WD repeat-containing protein 37', 117, NULL, NULL, 113566),
(113567, '3.40.630.10-FF-000286', NULL, 'Peptidase M20 domain-containing protein 2', 75, NULL, NULL, 113567),
(113568, '3.30.70.141-FF-000041', NULL, NULL, 147, NULL, NULL, 113568),
(113569, '2.60.40.10-FF-001571', NULL, 'Down syndrome cell adhesion molecule-like protein Dscam2', 107, NULL, NULL, 113569),
(113570, '2.60.40.1530-FF-000018', NULL, 'Integrin alpha-PS1', 260, NULL, NULL, 113570),
(113571, '3.40.50.10190-FF-000354', NULL, 'DNA damage response protein Mdb1', 99, NULL, NULL, 113571),
(113572, '3.20.20.10-FF-000091', NULL, 'Uncharacterized protein', 99, NULL, NULL, 113572),
(113573, '3.30.420.140-FF-000030', NULL, 'Uncharacterized protein', 167, NULL, NULL, 113573),
(113574, '3.40.50.720-FF-000663', NULL, 'Multifunctional enzyme siroheme synthase CYSG: uroporphyrin-III C-methyltransferase + precorrin-2 oxidase + ferrochelatase', 124, NULL, NULL, 113574),
(113575, '2.60.40.10-FF-004297', NULL, NULL, 95, NULL, NULL, 113575),
(113576, '1.10.510.10-FF-000836', NULL, 'Mitogen-activated protein kinase', 234, NULL, NULL, 113576),
(113577, '2.30.29.30-FF-000270', NULL, 'Pleckstrin homology-like domain family A member 3', 100, NULL, NULL, 113577),
(113578, '3.90.530.10-FF-000008', NULL, NULL, 110, NULL, NULL, 113578),
(113579, '3.30.420.110-FF-000015', NULL, 'DNA mismatch repair protein MutS', 123, NULL, NULL, 113579),
(113580, '3.30.2130.10-FF-000002', NULL, 'Aspartokinase', 161, NULL, NULL, 113580),
(113581, '1.10.860.10-FF-000031', NULL, 'Uncharacterized protein', 149, NULL, NULL, 113581);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(113582, '3.30.200.20-FF-001703', NULL, 'Calcium/calmodulin dependent protein kinase kinase 2', 53, NULL, NULL, 113582),
(113583, '3.40.30.10-FF-001046', NULL, 'Glutathione peroxidase', 185, NULL, NULL, 113583),
(113584, '2.130.10.10-FF-005910', NULL, 'ADL316Cp', 280, NULL, NULL, 113584),
(113585, '2.40.50.140-FF-001173', NULL, NULL, 135, NULL, NULL, 113585),
(113586, '2.40.70.10-FF-000573', NULL, NULL, 140, NULL, NULL, 113586),
(113587, '3.30.740.10-FF-000021', NULL, NULL, 88, NULL, NULL, 113587),
(113588, '2.20.100.10-FF-000198', NULL, 'Sema domain, seven thrombospondin repeats (type 1 and type 1-like), transmembrane domain (TM) and short cytoplasmic domain, (semaphorin) 5Ba', 50, NULL, NULL, 113588),
(113589, '2.40.240.10-FF-000029', NULL, 'Glutamine-tRNA ligase, putative', 119, NULL, NULL, 113589),
(113590, '1.10.510.10-FF-000128', NULL, 'serine/threonine-protein kinase ULK2 isoform X2', 188, NULL, NULL, 113590),
(113591, '2.130.10.10-FF-000104', NULL, 'Kinesin family member 21A', 207, NULL, NULL, 113591),
(113592, '1.10.472.10-FF-000365', NULL, 'Cyclin-D1-1', 54, NULL, NULL, 113592),
(113593, '1.20.1250.20-FF-002316', NULL, 'Inhibitor of growth family protein 2like, putative', 85, NULL, NULL, 113593),
(113594, '1.10.238.10-FF-000883', NULL, 'Calcium-binding endonuclease/exonuclease/phosphatase family', 66, NULL, NULL, 113594),
(113595, '2.10.110.10-FF-000263', NULL, 'Protein CBR-LIM-7', 118, NULL, NULL, 113595),
(113596, '3.40.50.300-FF-004241', NULL, 'HTH-type transcriptional regulator MalT', 158, NULL, NULL, 113596),
(113597, '1.10.8.10-FF-000032', NULL, 'Release factor glutamine methyltransferase', 83, NULL, NULL, 113597),
(113598, '3.40.50.11260-FF-000023', NULL, 'Uncharacterized protein', 87, NULL, NULL, 113598),
(113599, '3.30.160.60-FF-004954', NULL, NULL, 54, NULL, NULL, 113599),
(113600, '3.30.530.20-FF-000087', NULL, 'Phytohormone-binding protein CSBP', 155, NULL, NULL, 113600),
(113601, '3.30.420.40-FF-000197', NULL, 'Heat shock protein 105', 89, NULL, NULL, 113601),
(113602, '1.10.630.10-FF-000194', NULL, 'Cytochrome P450', 445, NULL, NULL, 113602),
(113603, '1.25.40.10-FF-001328', NULL, 'Superkiller 3 protein', 167, NULL, NULL, 113603),
(113604, '1.20.920.20-FF-000014', NULL, 'dynein heavy chain 2, axonemal', 339, NULL, NULL, 113604),
(113605, '2.130.10.10-FF-001195', NULL, 'Transducin/WD40 repeat-like superfamily protein', 241, NULL, NULL, 113605),
(113606, '3.40.50.2300-FF-001119', NULL, NULL, 97, NULL, NULL, 113606),
(113607, '3.30.160.60-FF-002037', NULL, 'zinc finger protein 64 isoform X3', 26, NULL, NULL, 113607),
(113608, '3.30.710.10-FF-000295', NULL, 'Uncharacterized protein', 119, NULL, NULL, 113608),
(113609, '3.40.50.2000-FF-000282', NULL, 'Putative lipopolysaccharide heptosyltransferase II', 145, NULL, NULL, 113609),
(113610, '1.10.30.10-FF-000102', NULL, 'Transcription factor Sox-7', 79, NULL, NULL, 113610),
(113611, '3.30.70.330-FF-002896', NULL, NULL, 52, NULL, NULL, 113611),
(113612, '1.25.10.10-FF-001490', NULL, 'Protein raptor homolog', 371, NULL, NULL, 113612),
(113613, '3.60.130.10-FF-000030', NULL, 'Taurine catabolism dioxygenase, TauD/TfdA family', 320, NULL, NULL, 113613),
(113614, '2.40.30.170-FF-000071', NULL, NULL, 84, NULL, NULL, 113614),
(113615, '3.60.10.10-FF-000234', NULL, 'Inositol polyphosphate 5-phosphatase', 294, NULL, NULL, 113615),
(113616, '1.10.1450.10-FF-000105', NULL, 'Tsp-20', 109, NULL, NULL, 113616),
(113617, '1.10.1040.10-FF-000086', NULL, '2-dehydropantoate 2-reductase', 145, NULL, NULL, 113617),
(113618, '1.10.565.10-FF-000053', NULL, 'Nuclear Hormone Receptor family', 183, NULL, NULL, 113618),
(113619, '3.40.50.150-FF-001195', NULL, NULL, 105, NULL, NULL, 113619),
(113620, '3.20.110.20-FF-000001', NULL, 'Flagellin modification glycoside hydrolase family 57', 337, NULL, NULL, 113620),
(113621, '1.10.3110.10-FF-000013', NULL, 'Protoporphyrinogen oxidase', 100, NULL, NULL, 113621),
(113622, '3.40.1310.20-FF-000005', NULL, 'Large T antigen', 129, NULL, NULL, 113622),
(113623, '3.90.70.10-FF-000231', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 306, NULL, NULL, 113623);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(113624, '3.90.640.10-FF-000207', NULL, 'Uncharacterized protein', 111, NULL, NULL, 113624),
(113625, '1.10.555.10-FF-000125', NULL, 'Protein CBR-OCRL-1', 160, NULL, NULL, 113625),
(113626, '1.10.10.460-FF-000001', NULL, 'Ribonuclease', 48, NULL, NULL, 113626),
(113627, '2.60.200.20-FF-000031', NULL, 'Forkhead box protein K1', 104, NULL, NULL, 113627),
(113628, '3.30.160.60-FF-000137', NULL, 'Putative zinc finger protein 143', 30, NULL, NULL, 113628),
(113629, '1.10.238.10-FF-001147', NULL, 'Uncharacterized protein', 132, NULL, NULL, 113629),
(113630, '2.40.30.10-FF-000508', NULL, 'Predicted protein', 84, NULL, NULL, 113630),
(113631, '1.25.40.10-FF-005122', NULL, 'Uncharacterized protein', 111, NULL, NULL, 113631),
(113632, '3.20.20.80-FF-000403', NULL, 'Arabinofuranosidase 2', 327, NULL, NULL, 113632),
(113633, '1.25.10.10-FF-001343', NULL, 'YALI0E12243p', 1044, NULL, NULL, 113633),
(113634, '3.20.20.80-FF-000504', NULL, 'Putative beta transglucosylase, GH17 family (Eurofung)', 145, NULL, NULL, 113634),
(113635, '3.30.9.10-FF-000255', NULL, 'Uncharacterized protein', 215, NULL, NULL, 113635),
(113636, '3.60.20.10-FF-000162', NULL, NULL, 236, NULL, NULL, 113636),
(113637, '2.20.28.10-FF-000021', NULL, 'DNA replication licensing factor, putative', 54, NULL, NULL, 113637),
(113638, '1.20.1250.20-FF-001035', NULL, 'Uncharacterized protein', 190, NULL, NULL, 113638),
(113639, '2.60.40.10-FF-003886', NULL, NULL, 140, NULL, NULL, 113639),
(113640, '2.30.30.40-FF-000664', NULL, 'Uncharacterized protein', 65, NULL, NULL, 113640),
(113641, '1.25.40.10-FF-003228', NULL, 'Protein O-mannosyl-transferase TMTC4', 57, NULL, NULL, 113641),
(113642, '3.40.1170.60-FF-000017', NULL, 'Putative DNA polymerase kappa', 51, NULL, NULL, 113642),
(113643, '2.130.10.10-FF-004718', NULL, 'WD repeat-containing protein 55 homolog', 168, NULL, NULL, 113643),
(113644, '3.50.50.60-FF-001022', NULL, 'N,N-dimethylglycine oxidase, putative (AFU_orthologue AFUA_8G06470)', 132, NULL, NULL, 113644),
(113645, '1.25.40.720-FF-000007', NULL, 'WGS project CABT00000000 data, contig 2.6', 104, NULL, NULL, 113645),
(113646, '1.20.1250.20-FF-000416', NULL, 'acetyl-coenzyme A transporter 1 isoform X1', 271, NULL, NULL, 113646),
(113647, '1.10.10.1620-FF-000001', NULL, 'Amine oxidase', 49, NULL, NULL, 113647),
(113648, '3.30.420.40-FF-000152', NULL, 'actin, alpha skeletal muscle isoform X2', 124, NULL, NULL, 113648),
(113649, '3.40.50.300-FF-006141', NULL, 'Chromodomain-helicase-DNA-binding protein 3-like Protein', 149, NULL, NULL, 113649),
(113650, '2.130.10.10-FF-005808', NULL, 'Uncharacterized protein', 85, NULL, NULL, 113650),
(113651, '3.10.180.10-FF-000027', NULL, '1,2-dihydroxynaphthalene dioxygenase', 135, NULL, NULL, 113651),
(113652, '3.30.760.10-FF-000084', NULL, 'Eukaryotic translation initiation factor 4E6, isoform A', 145, NULL, NULL, 113652),
(113653, '1.25.10.10-FF-002771', NULL, 'AP-4 complex subunit epsilon', 590, NULL, NULL, 113653),
(113654, '3.40.50.1110-FF-000121', NULL, 'Probable cytochrome c', 242, NULL, NULL, 113654),
(113655, '2.60.40.420-FF-000053', NULL, 'Laccase', 197, NULL, NULL, 113655),
(113656, '1.25.40.10-FF-000002', NULL, 'Clathrin heavy chain', 145, NULL, NULL, 113656),
(113657, '3.10.350.10-FF-000063', NULL, 'Peptidoglycan endopeptidase', 48, NULL, NULL, 113657),
(113658, '1.20.120.720-FF-000038', NULL, 'Class II myosin', 106, NULL, NULL, 113658),
(113659, '3.30.1120.10-FF-000030', NULL, 'N-acetylgalactosamine-6-sulfatase', 73, NULL, NULL, 113659),
(113660, '3.30.40.10-FF-000108', NULL, 'E3 ubiquitin-protein ligase MARCH7 isoform X1', 81, NULL, NULL, 113660),
(113661, '1.25.40.10-FF-001171', NULL, 'Os12g0557800 protein', 174, NULL, NULL, 113661),
(113662, '3.40.50.620-FF-000048', NULL, 'Isoleucine--tRNA ligase', 260, NULL, NULL, 113662),
(113663, '2.60.40.10-FF-002397', NULL, 'Immunoglobulin heavy variable 4-9', 95, NULL, NULL, 113663),
(113664, '3.90.209.20-FF-000001', NULL, 'Hemagglutinin', 216, NULL, NULL, 113664),
(113665, '3.80.10.10-FF-000407', NULL, 'leucine-rich repeat protein SHOC-2 isoform X2', 171, NULL, NULL, 113665);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(113666, '3.15.10.30-FF-000013', NULL, NULL, 133, NULL, NULL, 113666),
(113667, '3.40.140.20-FF-000004', NULL, 'Bifunctional purine biosynthesis protein PURH', 162, NULL, NULL, 113667),
(113668, '2.160.20.10-FF-000261', NULL, 'Uncharacterized protein', 124, NULL, NULL, 113668),
(113669, '1.10.390.10-FF-000039', NULL, 'thyrotropin-releasing hormone-degrading ectoenzyme', 207, NULL, NULL, 113669),
(113670, '2.130.10.10-FF-000576', NULL, 'Ribosome biogenesis protein ERB1', 366, NULL, NULL, 113670),
(113671, '2.160.10.10-FF-000069', NULL, 'Eukaryotic translation initiation factor 2B, subunit 3', 69, NULL, NULL, 113671),
(113672, '2.60.40.10-FF-001071', NULL, 'obscurin isoform X4', 92, NULL, NULL, 113672),
(113673, '2.60.120.380-FF-000005', NULL, 'calpain-type cysteine protease DEK1', 147, NULL, NULL, 113673),
(113674, '3.40.50.150-FF-000312', NULL, 'NOP2/Sun RNA methyltransferase family member 2', 148, NULL, NULL, 113674),
(113675, '3.90.1150.10-FF-000265', NULL, 'Pyridoxal phosphate-dependent aminotransferase', 132, NULL, NULL, 113675),
(113676, '1.10.8.60-FF-000345', NULL, 'Werner helicase interacting protein 1', 93, NULL, NULL, 113676),
(113677, '1.25.40.20-FF-001426', NULL, 'Uncharacterized protein', 179, NULL, NULL, 113677),
(113678, '1.10.510.10-FF-004170', NULL, NULL, 213, NULL, NULL, 113678),
(113679, '3.40.50.720-FF-000399', NULL, 'Probable oxidoreductase', 307, NULL, NULL, 113679),
(113680, '3.40.50.300-FF-003836', NULL, 'Toxin-coregulated pilus biosynthesis protein T', 279, NULL, NULL, 113680),
(113681, '2.60.40.10-FF-005123', NULL, NULL, 97, NULL, NULL, 113681),
(113682, '3.30.720.10-FF-000019', NULL, 'Signal recognition particle 9 kDa protein', 102, NULL, NULL, 113682),
(113683, '3.40.800.20-FF-000004', NULL, 'Histone deacetylase', 376, NULL, NULL, 113683),
(113684, '3.30.30.30-FF-000029', NULL, 'Heat shock protein 70kD, putative', 64, NULL, NULL, 113684),
(113685, '1.25.10.10-FF-001388', NULL, 'Uncharacterized protein', 656, NULL, NULL, 113685),
(113686, '2.60.420.10-FF-000005', NULL, 'Alpha,alpha-trehalose phosphorylase', 71, NULL, NULL, 113686),
(113687, '2.10.50.30-FF-000045', NULL, 'Uncharacterized protein', 68, NULL, NULL, 113687),
(113688, '3.90.550.50-FF-000235', NULL, 'Hexosyltransferase', 90, NULL, NULL, 113688),
(113689, '3.60.10.10-FF-000381', NULL, 'Uncharacterized protein', 78, NULL, NULL, 113689),
(113690, '3.40.1810.10-FF-000052', NULL, 'MADS-box transcription factor pvg4', 70, NULL, NULL, 113690),
(113691, '3.30.1110.10-FF-000001', NULL, 'Adenosine kinase a', 63, NULL, NULL, 113691),
(113692, '3.50.50.60-FF-000550', NULL, 'Possible oxidoreductase', 101, NULL, NULL, 113692),
(113693, '3.30.60.30-FF-000110', NULL, 'Uncharacterized protein', 54, NULL, NULL, 113693),
(113694, '1.10.472.10-FF-000573', NULL, 'Cyclin D3', 54, NULL, NULL, 113694),
(113695, '3.20.20.70-FF-000614', NULL, NULL, 40, NULL, NULL, 113695),
(113696, '3.40.50.1700-FF-000006', NULL, 'Lysosomal beta glucosidase', 242, NULL, NULL, 113696),
(113697, '3.40.50.800-FF-000125', NULL, 'Uncharacterized protein', 52, NULL, NULL, 113697),
(113698, '3.20.20.70-FF-000305', NULL, 'TIM-barrel enzyme family protein', 253, NULL, NULL, 113698),
(113699, '2.30.39.10-FF-000006', NULL, 'Plasminogen activator inhibitor 1', 154, NULL, NULL, 113699),
(113700, '1.20.5.690-FF-000002', NULL, 'Importin subunit alpha', 40, NULL, NULL, 113700),
(113701, '2.40.50.140-FF-000554', NULL, 'Yeast MCM (Licensing factor) related', 175, NULL, NULL, 113701),
(113702, '2.102.10.10-FF-000055', NULL, 'Uncharacterized protein', 94, NULL, NULL, 113702),
(113703, '2.40.420.20-FF-000007', NULL, 'HAE1 family efflux pump MFP component', 91, NULL, NULL, 113703),
(113704, '3.30.40.210-FF-000004', NULL, 'Transcription elongation factor SPT4', 103, NULL, NULL, 113704),
(113705, '3.30.160.60-FF-001626', NULL, 'Zinc finger protein 384', 29, NULL, NULL, 113705),
(113706, '1.20.1560.10-FF-000280', NULL, 'Chromosome 16, whole genome shotgun sequence', 334, NULL, NULL, 113706),
(113707, '2.60.200.40-FF-000037', NULL, 'Diacylglycerol kinase', 104, NULL, NULL, 113707);
INSERT INTO "PUBLIC"."MODEL" VALUES
(113708, '3.40.1000.30-FF-000007', NULL, 'proteasome inhibitor PI31 subunit', 159, NULL, NULL, 113708),
(113709, '1.25.10.10-FF-000871', NULL, 'HEAT repeat domain containing protein', 269, NULL, NULL, 113709),
(113710, '3.40.1000.50-FF-000002', NULL, 'Repressor of RNA polymerase III transcription MAF1', 152, NULL, NULL, 113710),
(113711, '1.20.990.10-FF-000061', NULL, 'Uncharacterized protein', 22, NULL, NULL, 113711),
(113712, '1.20.1070.10-FF-000563', NULL, 'Sex peptide receptor', 331, NULL, NULL, 113712),
(113713, '3.30.70.1290-FF-000003', NULL, 'Uncharacterized protein', 143, NULL, NULL, 113713),
(113714, '1.50.10.20-FF-000017', NULL, 'Protein farnesyltransferase subunit beta', 433, NULL, NULL, 113714),
(113715, '3.30.160.60-FF-001317', NULL, 'zinc finger protein 576 isoform X2', 26, NULL, NULL, 113715),
(113716, '1.25.40.10-FF-000608', NULL, 'Putative pre-mRNA splicing factor', 201, NULL, NULL, 113716),
(113717, '3.40.50.300-FF-000290', NULL, 'Protein-tyrosine sulfotransferase', 306, NULL, NULL, 113717),
(113718, '3.30.1470.10-FF-000005', NULL, 'Centrosomal protein 164', 108, NULL, NULL, 113718),
(113719, '1.20.120.350-FF-000085', NULL, 'potassium voltage-gated channel subfamily G member 2', 150, NULL, NULL, 113719),
(113720, '2.130.10.10-FF-000003', NULL, 'Coronin', 351, NULL, NULL, 113720),
(113721, '3.40.50.2000-FF-000534', NULL, 'Glycogen [starch] synthase', 288, NULL, NULL, 113721),
(113722, '1.20.120.640-FF-000003', NULL, 'Cysteine--tRNA ligase', 89, NULL, NULL, 113722),
(113723, '3.40.50.720-FF-002450', NULL, 'SUMO-activating enzyme subunit', 135, NULL, NULL, 113723),
(113724, '3.20.20.70-FF-000193', NULL, 'L-lactate oxidase', 357, NULL, NULL, 113724),
(113725, '2.60.40.10-FF-005831', NULL, NULL, 113, NULL, NULL, 113725),
(113726, '3.10.20.90-FF-000502', NULL, 'Ubiquitin family protein', 76, NULL, NULL, 113726),
(113727, '1.10.1520.10-FF-000021', NULL, 'RNA editing complex protein MP67', 127, NULL, NULL, 113727),
(113728, '3.40.720.10-FF-000304', NULL, 'Predicted protein', 222, NULL, NULL, 113728),
(113729, '3.40.970.10-FF-000013', NULL, NULL, 45, NULL, NULL, 113729),
(113730, '3.30.70.330-FF-001159', NULL, 'Uncharacterized protein', 145, NULL, NULL, 113730),
(113731, '2.20.25.10-FF-000104', NULL, 'Transcription factor S, archaeal', 35, NULL, NULL, 113731),
(113732, '2.40.110.10-FF-000048', NULL, 'Acyl-CoA dehydrogenase, mitochondrial, putative', 100, NULL, NULL, 113732),
(113733, '3.80.10.10-FF-000554', NULL, 'Acidic leucine-rich nuclear phosphoprotein 32-related protein', 169, NULL, NULL, 113733),
(113734, '3.40.50.1460-FF-000097', NULL, 'Uncharacterized protein', 169, NULL, NULL, 113734),
(113735, '2.10.25.10-FF-001026', NULL, 'Eater', 50, NULL, NULL, 113735),
(113736, '1.10.10.10-FF-001219', NULL, 'ATP-dependent DNA helicase', 129, NULL, NULL, 113736),
(113737, '2.30.34.10-FF-000001', NULL, 'leishmanolysin-like isoform X2', 96, NULL, NULL, 113737),
(113738, '1.20.1280.290-FF-000081', NULL, 'Uncharacterized protein', 146, NULL, NULL, 113738),
(113739, '2.20.100.10-FF-000153', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs adt-2', 54, NULL, NULL, 113739),
(113740, '1.10.840.10-FF-000029', NULL, 'Ras guanine nucleotide exchange factor E', 222, NULL, NULL, 113740),
(113741, '1.10.437.10-FF-000031', NULL, 'BH3-interacting domain death agonist', 187, NULL, NULL, 113741),
(113742, '1.25.40.10-FF-002508', NULL, 'CS_domain/TPR_repeat/Tetratricopeptide_repeat_-_putative', 96, NULL, NULL, 113742),
(113743, '3.20.20.190-FF-000137', NULL, NULL, 70, NULL, NULL, 113743),
(113744, '3.40.50.200-FF-000142', NULL, 'Uncharacterized protein', 84, NULL, NULL, 113744),
(113745, '3.30.160.60-FF-004499', NULL, NULL, 26, NULL, NULL, 113745),
(113746, '3.40.50.300-FF-003527', NULL, 'Voltage-dependent L-type calcium channel subunit beta-2', 123, NULL, NULL, 113746),
(113747, '1.10.420.10-FF-000037', NULL, 'Peroxidase 2', 72, NULL, NULL, 113747),
(113748, '3.90.550.10-FF-000116', NULL, 'Poly-beta-1,6-N-acetyl-D-glucosamine synthase', 224, NULL, NULL, 113748),
(113749, '1.25.40.10-FF-002817', NULL, 'Transcription factor Tcc1p', 156, NULL, NULL, 113749); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(113750, '1.20.1070.10-FF-001389', NULL, 'Predicted protein', 244, NULL, NULL, 113750),
(113751, '3.40.50.10880-FF-000010', NULL, NULL, 161, NULL, NULL, 113751),
(113752, '2.60.120.200-FF-000103', NULL, 'L-type lectin-domain containing receptor kinase IX.1', 248, NULL, NULL, 113752),
(113753, '3.30.300.10-FF-000027', NULL, 'GMP synthase (Glutamine-hydrolysing)', 123, NULL, NULL, 113753),
(113754, '1.20.58.60-FF-000135', NULL, 'Spectrin beta chain, non-erythrocytic', 106, NULL, NULL, 113754),
(113755, '3.80.10.10-FF-000863', NULL, 'Class II major histocompatibility complex transactivator', 90, NULL, NULL, 113755),
(113756, '3.30.230.80-FF-000014', NULL, 'Lipophosphoglycan biosynthetic protein, putative', 191, NULL, NULL, 113756),
(113757, '1.10.287.160-FF-000018', NULL, 'Tyrosine-protein kinase', 93, NULL, NULL, 113757),
(113758, '3.40.50.2000-FF-000843', NULL, 'Uncharacterized protein', 47, NULL, NULL, 113758),
(113759, '2.50.20.10-FF-000018', NULL, 'Outer-membrane lipoprotein carrier protein', 207, NULL, NULL, 113759),
(113760, '1.20.1070.10-FF-000416', NULL, 'Uncharacterized protein', 326, NULL, NULL, 113760),
(113761, '2.40.10.10-FF-000142', NULL, 'Clip-domain serine protease', 253, NULL, NULL, 113761),
(113762, '3.40.50.300-FF-005522', NULL, 'Si:dkeyp-52c3.7', 118, NULL, NULL, 113762),
(113763, '1.20.5.170-FF-000167', NULL, 'UDP-3-O-acylglucosamine N-acyltransferase', 28, NULL, NULL, 113763),
(113764, '1.10.287.70-FF-000598', NULL, 'Uncharacterized protein', 207, NULL, NULL, 113764),
(113765, '1.10.10.60-FF-000565', NULL, 'DNA methylation and regulatory protein', 109, NULL, NULL, 113765),
(113766, '3.60.21.10-FF-000153', NULL, 'Exonuclease II', 262, NULL, NULL, 113766),
(113767, '2.60.40.10-FF-000452', NULL, 'Integrin beta', 92, NULL, NULL, 113767),
(113768, '2.160.20.10-FF-000159', NULL, 'Cell surface glycoprotein (S-layer protein)', 119, NULL, NULL, 113768),
(113769, '3.30.200.20-FF-001809', NULL, 'Probable serine/threonine-protein kinase DDB_G0277071', 86, NULL, NULL, 113769),
(113770, '3.40.30.10-FF-000074', NULL, 'endoplasmic reticulum resident protein 44', 116, NULL, NULL, 113770),
(113771, '1.10.287.70-FF-000289', NULL, 'CRE-TWK-18 protein', 333, NULL, NULL, 113771),
(113772, '3.40.50.300-FF-007422', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', 137, NULL, NULL, 113772),
(113773, '4.10.280.10-FF-000065', NULL, 'class A basic helix-loop-helix protein 15', 66, NULL, NULL, 113773),
(113774, '3.40.50.1010-FF-000237', NULL, NULL, 64, NULL, NULL, 113774),
(113775, '1.10.10.10-FF-001528', NULL, 'Predicted protein', 100, NULL, NULL, 113775),
(113776, '3.40.390.10-FF-000278', NULL, NULL, 120, NULL, NULL, 113776),
(113777, '1.10.238.10-FF-001294', NULL, 'Uncharacterized protein', 77, NULL, NULL, 113777),
(113778, '1.10.287.1240-FF-000006', NULL, 'Exodeoxyribonuclease I', 55, NULL, NULL, 113778),
(113779, '2.60.40.10-FF-003577', NULL, NULL, 92, NULL, NULL, 113779),
(113780, '3.90.70.10-FF-000894', NULL, 'Uncharacterized protein', 322, NULL, NULL, 113780),
(113781, '1.20.120.1910-FF-000032', NULL, 'Cysteine--tRNA ligase', 170, NULL, NULL, 113781),
(113782, '2.20.110.10-FF-000024', NULL, 'MATH and UCH domain protein, putaitve', 51, NULL, NULL, 113782),
(113783, '3.30.260.10-FF-000091', NULL, NULL, 96, NULL, NULL, 113783),
(113784, '3.30.160.60-FF-003673', NULL, NULL, 29, NULL, NULL, 113784),
(113785, '1.10.238.20-FF-000015', NULL, 'Odorant-binding protein 56h', 116, NULL, NULL, 113785),
(113786, '3.40.50.10240-FF-000021', NULL, 'Thiamine pyrophosphokinase', 224, NULL, NULL, 113786),
(113787, '3.40.190.10-FF-000358', NULL, 'Lipoprotein LPQZ', 56, NULL, NULL, 113787),
(113788, '2.60.120.200-FF-000412', NULL, 'Laminin alpha 1', 163, NULL, NULL, 113788),
(113789, '1.50.40.10-FF-000410', NULL, 'Uncharacterized protein', 223, NULL, NULL, 113789),
(113790, '2.60.40.10-FF-000143', NULL, 'Vascular endothelial growth factor receptor 3', 104, NULL, NULL, 113790),
(113791, '2.60.120.10-FF-000331', NULL, 'AraC family transcriptional regulator', 92, NULL, NULL, 113791);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(113792, '3.40.50.150-FF-001756', NULL, NULL, 264, NULL, NULL, 113792),
(113793, '1.10.730.10-FF-000038', NULL, 'Isoleucine--tRNA ligase', 184, NULL, NULL, 113793),
(113794, '3.20.110.10-FF-000009', NULL, '1,4-alpha-glucan branching enzyme TK1436', 416, NULL, NULL, 113794),
(113795, '1.10.10.440-FF-000107', NULL, 'Uncharacterized protein', 70, NULL, NULL, 113795),
(113796, '3.30.497.10-FF-000180', NULL, 'AGAP009670-PA', 134, NULL, NULL, 113796),
(113797, '1.10.510.10-FF-001556', NULL, 'CMGC family protein kinase', 216, NULL, NULL, 113797),
(113798, '2.80.10.50-FF-000113', NULL, 'Kunitz-type serine protease inhibitor DrTI', 182, NULL, NULL, 113798),
(113799, '3.40.50.720-FF-001017', NULL, 'Related to ERG27-3-keto sterol reductase', 79, NULL, NULL, 113799),
(113800, '2.120.10.30-FF-000200', NULL, 'Low-density lipoprotein RecePtor related', 342, NULL, NULL, 113800),
(113801, '2.40.30.30-FF-000003', NULL, 'Riboflavin biosynthesis protein', 126, NULL, NULL, 113801),
(113802, '3.40.50.410-FF-000334', NULL, 'Uncharacterized protein', 161, NULL, NULL, 113802),
(113803, '2.170.190.11-FF-000006', NULL, 'Molybdopterin molybdenumtransferase', 119, NULL, NULL, 113803),
(113804, '1.20.120.20-FF-000037', NULL, 'Zgc:162608', 52, NULL, NULL, 113804),
(113805, '3.10.450.350-FF-000013', NULL, 'Cell wall endopeptidase family M23/M37', 93, NULL, NULL, 113805),
(113806, '3.40.630.30-FF-000533', NULL, 'O-GlcNAcase-like', 73, NULL, NULL, 113806),
(113807, '3.10.20.10-FF-000035', NULL, '60S ribosomal protein L18a', 43, NULL, NULL, 113807),
(113808, '3.30.420.10-FF-000093', NULL, 'DNA polymerase III subunit epsilon', 166, NULL, NULL, 113808),
(113809, '3.40.190.10-FF-000049', NULL, 'Putrescine-binding periplasmic protein', 170, NULL, NULL, 113809),
(113810, '3.30.450.20-FF-000131', NULL, 'Sensor histidine kinase', 133, NULL, NULL, 113810),
(113811, '3.30.200.20-FF-001248', NULL, 'Serine/threonine protein kinase 21', 73, NULL, NULL, 113811),
(113812, '3.30.930.10-FF-000176', NULL, 'Phenylalanyl-tRNA synthetase alpha chain B, putative', 279, NULL, NULL, 113812),
(113813, '3.10.290.10-FF-000018', NULL, '40S ribosomal protein S9', 31, NULL, NULL, 113813),
(113814, '3.40.50.2000-FF-000990', NULL, 'Uncharacterized protein', 53, NULL, NULL, 113814),
(113815, '3.80.10.10-FF-002763', NULL, 'Uncharacterized protein', 221, NULL, NULL, 113815),
(113816, '3.40.50.1100-FF-000023', NULL, 'Cysteine synthase', 183, NULL, NULL, 113816),
(113817, '1.10.510.10-FF-003242', NULL, NULL, 118, NULL, NULL, 113817),
(113818, '2.130.10.10-FF-000559', NULL, 'Coatomer subunit alpha', 320, NULL, NULL, 113818),
(113819, '3.30.160.60-FF-000031', NULL, 'GLI family zinc finger 3', 30, NULL, NULL, 113819),
(113820, '3.40.30.10-FF-000630', NULL, 'Predicted protein', 91, NULL, NULL, 113820),
(113821, '3.10.450.50-FF-000009', NULL, 'Calcium/calmodulin-dependent protein kinase type II', 145, NULL, NULL, 113821),
(113822, '3.10.450.240-FF-000008', NULL, '39S ribosomal protein L45, mitochondrial isoform X2', 55, NULL, NULL, 113822),
(113823, '3.40.50.720-FF-002080', NULL, 'Fatty acyl-CoA reductase', 345, NULL, NULL, 113823),
(113824, '3.10.580.10-FF-000092', NULL, 'D-arabinose 5-phosphate isomerase', 125, NULL, NULL, 113824),
(113825, '3.30.559.10-FF-000138', NULL, 'Glycoside hydrolase family 128 protein', 259, NULL, NULL, 113825),
(113826, '1.25.10.10-FF-001944', NULL, 'Uncharacterized protein', 305, NULL, NULL, 113826),
(113827, '3.40.50.150-FF-001065', NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', 343, NULL, NULL, 113827),
(113828, '2.10.230.10-FF-000007', NULL, 'DnaJ protein, putative', 59, NULL, NULL, 113828),
(113829, '2.130.10.10-FF-003307', NULL, 'Transducin beta-like protein 3', 244, NULL, NULL, 113829),
(113830, '4.10.240.10-FF-000074', NULL, 'Unplaced genomic scaffold supercont2.11, whole genome shotgun sequence', 76, NULL, NULL, 113830),
(113831, '1.50.40.10-FF-000163', NULL, 'Mitochondrial carrier protein', 290, NULL, NULL, 113831),
(113832, '1.10.630.10-FF-000654', NULL, 'Cytochrome P450, family 51', 200, NULL, NULL, 113832),
(113833, '2.102.10.10-FF-000038', NULL, 'Rieske (2Fe-2S) protein', 108, NULL, NULL, 113833);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(113834, '3.30.70.330-FF-000878', NULL, 'Unplaced genomic scaffold supercont1.15, whole genome shotgun sequence', 154, NULL, NULL, 113834),
(113835, '1.25.40.20-FF-001449', NULL, 'Uncharacterized protein', 133, NULL, NULL, 113835),
(113836, '2.20.25.20-FF-000011', NULL, 'Casein kinase II subunit beta', 52, NULL, NULL, 113836),
(113837, '3.30.160.60-FF-003690', NULL, 'Zinc finger and BTB domain-containing 17', 73, NULL, NULL, 113837),
(113838, '3.30.750.24-FF-000136', NULL, 'Sulfate transporter/antisigma-factor antagonist STAS', 105, NULL, NULL, 113838),
(113839, '2.10.25.10-FF-001251', NULL, 'Uncharacterized protein', 43, NULL, NULL, 113839),
(113840, '2.30.42.10-FF-000368', NULL, NULL, 117, NULL, NULL, 113840),
(113841, '3.30.2230.10-FF-000021', NULL, 'Ubiquitinyl hydrolase 1', 86, NULL, NULL, 113841),
(113842, '3.40.390.80-FF-000001', NULL, 'TRPM8 channel-associated factor 1', 125, NULL, NULL, 113842),
(113843, '3.30.1490.180-FF-000037', NULL, 'DNA-directed RNA polymerase subunit', 86, NULL, NULL, 113843),
(113844, '1.25.40.20-FF-000937', NULL, 'Ankyrin repeats (3 copies), putative', 145, NULL, NULL, 113844),
(113845, '1.20.1600.10-FF-000008', NULL, 'Periplasmic type I secretion system protein', 404, NULL, NULL, 113845),
(113846, '3.30.2350.20-FF-000078', NULL, NULL, 58, NULL, NULL, 113846),
(113847, '1.20.58.390-FF-000316', NULL, 'Uncharacterized protein', 95, NULL, NULL, 113847),
(113848, '3.40.50.2300-FF-000866', NULL, NULL, 106, NULL, NULL, 113848),
(113849, '1.10.510.10-FF-000600', NULL, 'Phosphoenolpyruvate carboxylase kinase 2', 284, NULL, NULL, 113849),
(113850, '3.40.50.150-FF-000992', NULL, 'Uncharacterized protein', 300, NULL, NULL, 113850),
(113851, '3.10.20.90-FF-000238', NULL, 'Phosphoinositide phospholipase C', 99, NULL, NULL, 113851),
(113852, '2.60.120.320-FF-000010', NULL, 'Chromosome 9, whole genome shotgun sequence', 121, NULL, NULL, 113852),
(113853, '1.20.1250.20-FF-000546', NULL, 'BSC6p protein', 196, NULL, NULL, 113853),
(113854, '1.10.510.10-FF-001539', NULL, 'HRK1p Protein kinase', 358, NULL, NULL, 113854),
(113855, '3.20.20.70-FF-000530', NULL, NULL, 250, NULL, NULL, 113855),
(113856, '1.20.1260.10-FF-000038', NULL, 'Ferritin', 183, NULL, NULL, 113856),
(113857, '2.60.40.60-FF-000450', NULL, 'Cadherin 5', 107, NULL, NULL, 113857),
(113858, '3.40.50.10190-FF-000219', NULL, 'Nibrin, putative', 103, NULL, NULL, 113858),
(113859, '2.40.10.10-FF-000041', NULL, 'kallikrein-6 isoform X2', 107, NULL, NULL, 113859),
(113860, '3.40.630.30-FF-000269', NULL, 'GNAT family N-acetyltransferase', 221, NULL, NULL, 113860),
(113861, '1.20.120.1080-FF-000086', NULL, 'Uncharacterized protein', 118, NULL, NULL, 113861),
(113862, '3.30.70.260-FF-000143', NULL, 'D-3-phosphoglycerate dehydrogenase', 81, NULL, NULL, 113862),
(113863, '1.25.40.10-FF-000827', NULL, 'Tetratricopeptide repeat protein', 103, NULL, NULL, 113863),
(113864, '3.30.160.20-FF-000120', NULL, 'RISC-loading complex subunit TARBP2', 83, NULL, NULL, 113864),
(113865, '3.30.540.30-FF-000006', NULL, 'Clan M-, family M49, dipeptidylpeptidase III-like metallopeptidase', 114, NULL, NULL, 113865),
(113866, '1.25.10.10-FF-002563', NULL, 'Uncharacterized protein', 170, NULL, NULL, 113866),
(113867, '3.30.160.20-FF-000159', NULL, 'Ribonuclease 3', 82, NULL, NULL, 113867),
(113868, '3.30.1370.10-FF-000177', NULL, 'Hydrolase', 69, NULL, NULL, 113868),
(113869, '2.60.40.10-FF-001677', NULL, 'Fasciclin 2, isoform F', 91, NULL, NULL, 113869),
(113870, '3.30.565.10-FF-000563', NULL, 'Response regulator receiver domain containing protein', 156, NULL, NULL, 113870),
(113871, '3.40.50.300-FF-006686', NULL, 'Uncharacterized protein', 81, NULL, NULL, 113871),
(113872, '1.25.10.10-FF-002877', NULL, 'Predicted protein', 151, NULL, NULL, 113872),
(113873, '3.40.50.300-FF-000273', NULL, 'GTP-binding protein Rheb homolog', 175, NULL, NULL, 113873),
(113874, '3.40.50.300-FF-008294', NULL, 'Uncharacterized protein', 28, NULL, NULL, 113874),
(113875, '1.25.40.20-FF-001292', NULL, 'Os07g0481700 protein', 167, NULL, NULL, 113875),
(113876, '3.30.430.20-FF-000023', NULL, 'Antifungal protein ginkbilobin-2', 106, NULL, NULL, 113876);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(113877, '1.10.1410.10-FF-000114', NULL, 'Trf4 poly(A) polymerase', 95, NULL, NULL, 113877),
(113878, '3.40.50.1820-FF-000469', NULL, 'Pyochelin biosynthetic protein PchC', 248, NULL, NULL, 113878),
(113879, '1.25.40.10-FF-003205', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 84, NULL, NULL, 113879),
(113880, '3.30.200.20-FF-001147', NULL, 'Uncharacterized protein', 97, NULL, NULL, 113880),
(113881, '1.20.58.60-FF-000798', NULL, 'Uncharacterized protein', 309, NULL, NULL, 113881),
(113882, '3.30.1640.10-FF-000041', NULL, 'DNA replication helicase protein MCM', 94, NULL, NULL, 113882),
(113883, '3.40.50.300-FF-004325', NULL, 'ATP synthase alpha subunit vacuolar, putative', 72, NULL, NULL, 113883),
(113884, '3.80.10.10-FF-003858', NULL, 'Toll, putative', 158, NULL, NULL, 113884),
(113885, '3.20.20.140-FF-000369', NULL, 'Uncharacterized protein', 223, NULL, NULL, 113885),
(113886, '2.40.50.140-FF-000785', NULL, NULL, 73, NULL, NULL, 113886),
(113887, '1.25.40.10-FF-001772', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 90, NULL, NULL, 113887),
(113888, '3.30.160.60-FF-005488', NULL, NULL, 23, NULL, NULL, 113888),
(113889, '1.10.640.10-FF-000003', NULL, 'chorion peroxidase', 580, NULL, NULL, 113889),
(113890, '3.40.50.1260-FF-000037', NULL, 'Phosphoglycerate kinase', 169, NULL, NULL, 113890),
(113891, '1.25.10.10-FF-002080', NULL, 'Uncharacterized protein', 377, NULL, NULL, 113891),
(113892, '3.30.2060.10-FF-000002', NULL, 'Transcription-repair-coupling factor', 86, NULL, NULL, 113892),
(113893, '3.90.1450.10-FF-000001', NULL, 'Guanylate cyclase activator 2B', 85, NULL, NULL, 113893),
(113894, '3.30.450.20-FF-000030', NULL, 'Phytochrome', 155, NULL, NULL, 113894),
(113895, '3.40.50.720-FF-000516', NULL, 'UDP-glucose 4-epimerase', 201, NULL, NULL, 113895),
(113896, '1.25.10.10-FF-000163', NULL, 'Phospholipase A-2-activating protein, putative', 264, NULL, NULL, 113896),
(113897, '3.40.50.1240-FF-000031', NULL, '6-phosphofructo-2-kinase/fructose-2, 6-bisphosphatase', 210, NULL, NULL, 113897),
(113898, '1.20.58.60-FF-000371', NULL, 'Muscle-specific protein 300 kDa, isoform L', 212, NULL, NULL, 113898),
(113899, '3.40.50.300-FF-004808', NULL, 'Uncharacterized protein', 225, NULL, NULL, 113899),
(113900, '3.10.450.30-FF-000003', NULL, 'Hirsutellin A', 130, NULL, NULL, 113900),
(113901, '2.40.50.140-FF-000892', NULL, NULL, 104, NULL, NULL, 113901),
(113902, '1.20.1250.20-FF-000063', NULL, 'MFS transporter', 419, NULL, NULL, 113902),
(113903, '3.80.10.10-FF-000638', NULL, 'Si:dkey-16p6.1', 265, NULL, NULL, 113903),
(113904, '2.30.30.30-FF-000088', NULL, 'Probable 39S ribosomal protein L24, mitochondrial', 113, NULL, NULL, 113904),
(113905, '3.30.750.210-FF-000001', NULL, 'CDK5 regulatory subunit-associated protein 1-like 1', 53, NULL, NULL, 113905),
(113906, '3.40.50.1000-FF-000083', NULL, 'Sodium/potassium-transporting ATPase subunit alpha', 165, NULL, NULL, 113906),
(113907, '1.25.40.10-FF-003700', NULL, 'Uncharacterized protein', 124, NULL, NULL, 113907),
(113908, '3.40.50.2300-FF-000490', NULL, 'Vomeronasal 2 receptor, x1', 256, NULL, NULL, 113908),
(113909, '3.10.105.10-FF-000011', NULL, 'ABC transporter, substrate-binding protein, family 5', 53, NULL, NULL, 113909),
(113910, '1.25.40.10-FF-004189', NULL, 'Uncharacterized protein', 81, NULL, NULL, 113910),
(113911, '3.90.228.10-FF-000036', NULL, 'Poly [ADP-ribose] polymerase', 105, NULL, NULL, 113911),
(113912, '1.10.630.10-FF-000177', NULL, 'Uncharacterized protein', 471, NULL, NULL, 113912),
(113913, '1.10.4200.10-FF-000003', NULL, 'Probable 2-(5''''-triphosphoribosyl)-3''-dephosphocoenzyme-A synthase', 107, NULL, NULL, 113913),
(113914, '3.40.50.12760-FF-000024', NULL, 'Uncharacterized protein', 180, NULL, NULL, 113914),
(113915, '3.50.50.60-FF-000078', NULL, 'Blast:Putative apoptosis-inducing factor 1, mitochondrial', 154, NULL, NULL, 113915),
(113916, '2.60.40.380-FF-000007', NULL, 'Probable secreted alkaline phosphatase', 102, NULL, NULL, 113916),
(113917, '3.40.50.300-FF-003943', NULL, 'GTP-binding protein ypt1', 171, NULL, NULL, 113917);
INSERT INTO "PUBLIC"."MODEL" VALUES
(113918, '3.40.50.300-FF-007675', NULL, 'Uncharacterized protein', 118, NULL, NULL, 113918),
(113919, '3.90.640.10-FF-000129', NULL, 'Actin-related protein 6', 110, NULL, NULL, 113919),
(113920, '3.40.1350.60-FF-000014', NULL, 'Predicted protein', 42, NULL, NULL, 113920),
(113921, '3.30.200.20-FF-000528', NULL, 'serine/threonine-protein kinase Nek10 isoform X1', 65, NULL, NULL, 113921),
(113922, '3.40.50.11500-FF-000011', NULL, 'Denn domain containing protein', 165, NULL, NULL, 113922),
(113923, '2.170.120.12-FF-000037', NULL, 'RNA polymerase II core subunit', 126, NULL, NULL, 113923),
(113924, '3.40.50.2300-FF-000057', NULL, 'Transcriptional regulatory protein', 142, NULL, NULL, 113924),
(113925, '1.25.40.20-FF-001073', NULL, 'Uncharacterized protein', 112, NULL, NULL, 113925),
(113926, '2.10.25.10-FF-001627', NULL, 'Uncharacterized protein', 50, NULL, NULL, 113926),
(113927, '3.10.129.10-FF-000088', NULL, 'Putative esterase F42H10.6', 138, NULL, NULL, 113927),
(113928, '3.40.250.10-FF-000184', NULL, 'Thiosulfate sulfurtransferase', 119, NULL, NULL, 113928),
(113929, '3.90.660.10-FF-000006', NULL, 'Lysine-specific histone demethylase 1 3', 217, NULL, NULL, 113929),
(113930, '1.10.150.120-FF-000024', NULL, NULL, 73, NULL, NULL, 113930),
(113931, '3.30.70.330-FF-002249', NULL, NULL, 134, NULL, NULL, 113931),
(113932, '1.50.10.10-FF-000026', NULL, 'Trehalase', 585, NULL, NULL, 113932),
(113933, '3.40.50.2300-FF-000181', NULL, 'Two-component system response regulator', 83, NULL, NULL, 113933),
(113934, '3.30.160.60-FF-000345', NULL, 'Zinc finger protein Gfi-1', 26, NULL, NULL, 113934),
(113935, '3.40.190.10-FF-000622', NULL, 'Amino acid ABC transporter substrate-binding protein', 99, NULL, NULL, 113935),
(113936, '1.10.287.470-FF-000010', NULL, 'Auxiliary transport protein, membrane fusion protein family', 76, NULL, NULL, 113936),
(113937, '3.90.650.10-FF-000051', NULL, 'Thiamine-monophosphate kinase', 155, NULL, NULL, 113937),
(113938, '3.30.565.10-FF-000198', NULL, 'Phosphoglycerate transport regulatory protein PgtB', 157, NULL, NULL, 113938),
(113939, '3.40.50.10810-FF-000001', NULL, 'chromodomain-helicase-DNA-binding protein 3 isoform X1', 245, NULL, NULL, 113939),
(113940, '3.30.200.20-FF-001512', NULL, 'Tyrosine-protein kinase', 46, NULL, NULL, 113940),
(113941, '3.40.50.1820-FF-000593', NULL, 'Alpha/beta hydrolase family protein', 332, NULL, NULL, 113941),
(113942, '1.20.1070.10-FF-002086', NULL, 'Uncharacterized protein', 171, NULL, NULL, 113942),
(113943, '3.20.20.190-FF-000131', NULL, NULL, 124, NULL, NULL, 113943),
(113944, '1.20.5.170-FF-000144', NULL, 'Male-specific lethal-1', 58, NULL, NULL, 113944),
(113945, '2.40.70.10-FF-000382', NULL, NULL, 193, NULL, NULL, 113945),
(113946, '2.130.10.10-FF-002493', NULL, 'Cell surface protein', 171, NULL, NULL, 113946),
(113947, '3.40.50.300-FF-003813', NULL, 'Transcriptional regulator', 175, NULL, NULL, 113947),
(113948, '3.40.50.300-FF-004432', NULL, 'Lipopolysaccharide biosynthesis protein', 166, NULL, NULL, 113948),
(113949, '3.80.10.10-FF-004005', NULL, 'Leucine-rich repeats and immunoglobulin-like domains 2', 150, NULL, NULL, 113949),
(113950, '3.40.50.300-FF-003504', NULL, 'Mismatch repair protein, putative', 273, NULL, NULL, 113950),
(113951, '3.30.160.60-FF-005016', NULL, NULL, 28, NULL, NULL, 113951),
(113952, '3.60.21.10-FF-000254', NULL, 'UDP-2,3-diacylglucosamine diphosphatase', 176, NULL, NULL, 113952),
(113953, '3.30.505.10-FF-000115', NULL, 'Tyrosine-protein kinase', 112, NULL, NULL, 113953),
(113954, '1.10.3210.10-FF-000133', NULL, 'Uncharacterized protein', 38, NULL, NULL, 113954),
(113955, '3.40.140.10-FF-000102', NULL, 'Uncharacterized protein', 105, NULL, NULL, 113955),
(113956, '1.25.40.10-FF-001300', NULL, 'Pentatricopeptide repeat protein PPR1106-17', 139, NULL, NULL, 113956),
(113957, '2.10.110.10-FF-000072', NULL, 'Four and a half LIM domains protein 1', 66, NULL, NULL, 113957),
(113958, '1.10.1450.10-FF-000021', NULL, 'Tetraspanin', 119, NULL, NULL, 113958),
(113959, '3.30.40.10-FF-002339', NULL, 'Uncharacterized protein', 94, NULL, NULL, 113959);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(113960, '2.30.30.40-FF-000456', NULL, 'Putative voltage-dependent l-type calcium channel subunit beta-2', 146, NULL, NULL, 113960),
(113961, '1.20.5.110-FF-000065', NULL, 'SEC22 (YLR268W)', 62, NULL, NULL, 113961),
(113962, '2.60.40.1230-FF-000018', NULL, 'AP-1 complex subunit gamma', 109, NULL, NULL, 113962),
(113963, '1.20.1250.20-FF-000439', NULL, 'Multidrug MFS transporter', 190, NULL, NULL, 113963),
(113964, '2.30.140.10-FF-000030', NULL, 'Uncharacterized protein', 60, NULL, NULL, 113964),
(113965, '2.60.40.10-FF-002296', NULL, 'Os11g0274100 protein', 131, NULL, NULL, 113965),
(113966, '3.20.20.105-FF-000026', NULL, 'Uncharacterized protein', 232, NULL, NULL, 113966),
(113967, '3.40.50.720-FF-001461', NULL, 'Malic enzyme', 72, NULL, NULL, 113967),
(113968, '3.30.310.10-FF-000056', NULL, 'Predicted protein', 83, NULL, NULL, 113968),
(113969, '2.20.25.110-FF-000002', NULL, 'D-alanine-D-alanine ligase related protein', 59, NULL, NULL, 113969),
(113970, '3.40.50.960-FF-000004', NULL, '6,7-dimethyl-8-ribityllumazine synthase', 153, NULL, NULL, 113970),
(113971, '3.90.1480.20-FF-000051', NULL, 'Uncharacterized protein', 175, NULL, NULL, 113971),
(113972, '1.20.58.80-FF-000012', NULL, 'AMSH-like protease isoform X1', 161, NULL, NULL, 113972),
(113973, '3.30.70.330-FF-002795', NULL, NULL, 149, NULL, NULL, 113973),
(113974, '3.40.50.10130-FF-000027', NULL, 'Restriction endonuclease type II-like protein', 119, NULL, NULL, 113974),
(113975, '3.40.50.620-FF-000256', NULL, 'Adenine nucleotide alpha hydrolases-like superfamily protein', 151, NULL, NULL, 113975),
(113976, '3.40.1410.10-FF-000050', NULL, 'TraR protein', 158, NULL, NULL, 113976),
(113977, '3.60.10.10-FF-000009', NULL, 'DNA-(apurinic or apyrimidinic site) lyase', 280, NULL, NULL, 113977),
(113978, '3.40.50.1820-FF-000137', NULL, 'EEB1p Acyl-coenzymeA:ethanol O-acyltransferase', 274, NULL, NULL, 113978),
(113979, '1.25.40.10-FF-001227', NULL, 'Pentatricopeptide repeat-containing protein At1g26900, mitochondrial', 109, NULL, NULL, 113979),
(113980, '3.30.200.20-FF-001017', NULL, 'Cyclin-dependent kinase G-1', 111, NULL, NULL, 113980),
(113981, '1.20.1070.10-FF-000647', NULL, 'Uncharacterized protein', 114, NULL, NULL, 113981),
(113982, '1.10.260.100-FF-000015', NULL, 'Hsc70-interacting protein', 58, NULL, NULL, 113982),
(113983, '2.60.40.650-FF-000004', NULL, 'Sulfite oxidase, putative', 130, NULL, NULL, 113983),
(113984, '1.20.1560.10-FF-000499', NULL, 'ATP-binding cassette sub-family B member 5', 30, NULL, NULL, 113984),
(113985, '3.50.50.60-FF-000117', NULL, 'Pyruvate dehydrogenase phosphatase regulatory subunit, mitochondrial', 215, NULL, NULL, 113985),
(113986, '3.10.129.10-FF-000127', NULL, 'Itaconyl-CoA hydratase', 111, NULL, NULL, 113986),
(113987, '1.10.238.10-FF-000574', NULL, 'Phosphatidylinositol-4-phosphate 5-kinase', 126, NULL, NULL, 113987),
(113988, '3.40.50.360-FF-000026', NULL, 'Flavoprotein MioC', 147, NULL, NULL, 113988),
(113989, '3.40.1190.20-FF-000124', NULL, 'Pyridoxal kina', 228, NULL, NULL, 113989),
(113990, '1.10.1670.10-FF-000015', NULL, 'Endonuclease III homolog', 71, NULL, NULL, 113990),
(113991, '3.30.160.60-FF-001756', NULL, 'Zinc finger and AT-hook domain containing', 95, NULL, NULL, 113991),
(113992, '1.20.1250.20-FF-000282', NULL, 'NarK/NasA family nitrate transporter', 176, NULL, NULL, 113992),
(113993, '3.50.50.60-FF-001062', NULL, 'Succinate dehydrogenase complex, subunit A, flavoprotein (Fp)', 48, NULL, NULL, 113993),
(113994, '1.25.40.10-FF-002391', NULL, 'Os05g0586900 protein', 180, NULL, NULL, 113994),
(113995, '2.60.120.260-FF-000379', NULL, 'Beta-galactosidase (Eurofung)', 57, NULL, NULL, 113995),
(113996, '3.30.930.10-FF-000283', NULL, 'Prolyl-tRNA synthetase', 188, NULL, NULL, 113996),
(113997, '1.10.510.10-FF-003473', NULL, NULL, 270, NULL, NULL, 113997),
(113998, '1.10.10.60-FF-000548', NULL, 'PTS-dependent dihydroxyacetone kinase operon regulatory protein', 70, NULL, NULL, 113998),
(113999, '3.80.10.10-FF-000099', NULL, 'Tropomodulin, isoform C', 169, NULL, NULL, 113999),
(114000, '3.10.20.30-FF-000030', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 74, NULL, NULL, 114000);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(114001, '1.20.58.390-FF-000007', NULL, 'Neuronal acetylcholine receptor subunit alpha-7', 117, NULL, NULL, 114001),
(114002, '2.10.25.10-FF-000306', NULL, 'Multiple epidermal growth factor-like domains 6', 37, NULL, NULL, 114002),
(114003, '3.30.40.10-FF-000889', NULL, 'Pib1p', 84, NULL, NULL, 114003),
(114004, '2.60.40.60-FF-000826', NULL, 'E-cadherin-like protein', 117, NULL, NULL, 114004),
(114005, '3.80.10.10-FF-000508', NULL, 'NLR family CARD domain containing 5', 304, NULL, NULL, 114005),
(114006, '3.30.300.30-FF-000112', NULL, 'Nonribosomal peptide synthase, putative', 129, NULL, NULL, 114006),
(114007, '1.50.40.10-FF-000382', NULL, 'Nicotinamide adenine dinucleotide transporter 1 chloroplastic', 69, NULL, NULL, 114007),
(114008, '2.60.220.30-FF-000018', NULL, 'P53-induced death domain protein 1', 111, NULL, NULL, 114008),
(114009, '2.60.40.10-FF-003780', NULL, NULL, 91, NULL, NULL, 114009),
(114010, '1.10.8.10-FF-000268', NULL, 'AT07671p', 75, NULL, NULL, 114010),
(114011, '1.25.40.120-FF-000053', NULL, 'Rab geranylgeranyl transferase like protein', 55, NULL, NULL, 114011),
(114012, '3.80.10.10-FF-002116', NULL, 'Uncharacterized protein', 98, NULL, NULL, 114012),
(114013, '2.30.30.40-FF-000080', NULL, 'Peripheral plasma membrane protein CASK isoform X2', 153, NULL, NULL, 114013),
(114014, '2.30.33.40-FF-000007', NULL, '10 kDa chaperonin', 100, NULL, NULL, 114014),
(114015, '3.40.50.300-FF-006725', NULL, 'Uncharacterized protein', 72, NULL, NULL, 114015),
(114016, '2.60.120.430-FF-000043', NULL, 'Uncharacterized protein', 97, NULL, NULL, 114016),
(114017, '1.10.3810.10-FF-000027', NULL, 'Penicillin binding protein 1C PbpC', 197, NULL, NULL, 114017),
(114018, '3.90.550.10-FF-000324', NULL, 'Glucuronokinase with putative uridyl pyrophosphorylase', 271, NULL, NULL, 114018),
(114019, '3.40.50.720-FF-001152', NULL, 'C-methyltransferase NovU', 104, NULL, NULL, 114019),
(114020, '2.60.40.1730-FF-000062', NULL, NULL, 216, NULL, NULL, 114020),
(114021, '3.40.50.300-FF-006377', NULL, 'Uncharacterized protein', 137, NULL, NULL, 114021),
(114022, '1.20.940.10-FF-000012', NULL, 'Protein transport protein SEC31', 111, NULL, NULL, 114022),
(114023, '4.10.60.10-FF-000119', NULL, 'Gag polyprotein', 42, NULL, NULL, 114023),
(114024, '1.25.40.30-FF-000002', NULL, 'Clathrin and VPS domain-containing protein', 53, NULL, NULL, 114024),
(114025, '2.70.160.11-FF-000057', NULL, 'Protein arginine methyltransferase 3', 170, NULL, NULL, 114025),
(114026, '3.40.50.970-FF-000142', NULL, 'Phenylpyruvate decarboxylase', 198, NULL, NULL, 114026),
(114027, '3.40.50.150-FF-000683', NULL, 'BnaA02g09640D protein', 197, NULL, NULL, 114027),
(114028, '1.10.730.10-FF-000111', NULL, 'Probable valine--tRNA ligase, mitochondrial', 263, NULL, NULL, 114028),
(114029, '3.60.20.10-FF-000218', NULL, NULL, 143, NULL, NULL, 114029),
(114030, '3.30.60.10-FF-000008', NULL, NULL, 40, NULL, NULL, 114030),
(114031, '1.10.8.1310-FF-000015', NULL, 'TBC1 domain family member 20/GTPase, putative', 100, NULL, NULL, 114031),
(114032, '3.30.300.30-FF-000140', NULL, 'Saframycin Mx1 synthetase B', 125, NULL, NULL, 114032),
(114033, '2.10.90.10-FF-000160', NULL, 'Uncharacterized protein', 72, NULL, NULL, 114033),
(114034, '1.25.10.10-FF-002872', NULL, 'MMS19 nucleotide excision repair protein homolog', 154, NULL, NULL, 114034),
(114035, '2.30.29.30-FF-001315', NULL, 'Diacylglycerol kinase', 72, NULL, NULL, 114035),
(114036, '3.30.310.240-FF-000001', NULL, 'CP4-57 prophage RNase LS', 92, NULL, NULL, 114036),
(114037, '2.60.40.420-FF-000160', NULL, 'Copper tolerance protein', 133, NULL, NULL, 114037),
(114038, '1.25.40.10-FF-002716', NULL, 'Kinesin Light Chain', 303, NULL, NULL, 114038),
(114039, '2.40.10.10-FF-000350', NULL, NULL, 111, NULL, NULL, 114039),
(114040, '3.40.50.620-FF-000251', NULL, 'Probable nicotinate-nucleotide adenylyltransferase', 195, NULL, NULL, 114040),
(114041, '3.40.50.2000-FF-000866', NULL, 'Uncharacterized protein', 197, NULL, NULL, 114041),
(114042, '3.30.40.10-FF-000541', NULL, 'BOI-related E3 ubiquitin-protein ligase 1', 71, NULL, NULL, 114042);
INSERT INTO "PUBLIC"."MODEL" VALUES
(114043, '1.10.287.70-FF-000525', NULL, 'Hydrolase, alpha/beta fold family protein, putative, expressed', 62, NULL, NULL, 114043),
(114044, '3.40.50.1260-FF-000054', NULL, 'Phosphoglycerate kinase', 55, NULL, NULL, 114044),
(114045, '2.70.98.30-FF-000017', NULL, 'Protein CBR-AMAN-2', 252, NULL, NULL, 114045),
(114046, '1.20.1200.10-FF-000006', NULL, 'Cobalamin adenosyltransferase', 170, NULL, NULL, 114046),
(114047, '3.80.10.10-FF-003061', NULL, 'Uncharacterized protein', 144, NULL, NULL, 114047),
(114048, '3.40.30.10-FF-000321', NULL, 'Multifunctional fusion protein', 162, NULL, NULL, 114048),
(114049, '3.40.50.720-FF-001388', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', 159, NULL, NULL, 114049),
(114050, '1.10.565.10-FF-000154', NULL, 'Nuclear Hormone Receptor family', 232, NULL, NULL, 114050),
(114051, '3.80.10.10-FF-000655', NULL, 'Putative leucine-rich repeat receptor-like protein kinase', 92, NULL, NULL, 114051),
(114052, '1.20.1070.10-FF-001597', NULL, 'Uncharacterized protein', 153, NULL, NULL, 114052),
(114053, '1.20.1070.10-FF-000208', NULL, 'Alpha-1D adrenergic receptor', 339, NULL, NULL, 114053),
(114054, '2.60.120.10-FF-000224', NULL, 'Cyclic nucleotide-binding domain-containing protein', 132, NULL, NULL, 114054),
(114055, '3.30.160.60-FF-003318', NULL, 'Protein CBR-EOR-1', 58, NULL, NULL, 114055),
(114056, '1.20.1560.10-FF-000864', NULL, 'Predicted protein', 163, NULL, NULL, 114056),
(114057, '2.60.40.10-FF-005600', NULL, NULL, 72, NULL, NULL, 114057),
(114058, '2.60.220.30-FF-000035', NULL, 'Uncharacterized protein', 133, NULL, NULL, 114058),
(114059, '1.10.8.270-FF-000137', NULL, 'TBC1 domain family member 10B', 102, NULL, NULL, 114059),
(114060, '1.10.472.10-FF-000718', NULL, 'Predicted protein', 177, NULL, NULL, 114060),
(114061, '3.20.20.80-FF-000842', NULL, '1,4-alpha-glucan branching enzyme 1', 23, NULL, NULL, 114061),
(114062, '3.40.50.150-FF-001481', NULL, NULL, 125, NULL, NULL, 114062),
(114063, '1.25.40.20-FF-000140', NULL, 'Calmodulin-binding transcription activator 2', 175, NULL, NULL, 114063),
(114064, '3.40.50.10810-FF-000006', NULL, 'Putative DNA helicase INO80', 279, NULL, NULL, 114064),
(114065, '2.60.120.650-FF-000064', NULL, 'Lysine-specific demethylase jmjd-3.1', 342, NULL, NULL, 114065),
(114066, '1.10.246.130-FF-000012', NULL, 'Protein-glutamine gamma-glutamyltransferase, putative', 104, NULL, NULL, 114066),
(114067, '3.30.710.10-FF-000300', NULL, 'Protein CBG19111', 163, NULL, NULL, 114067),
(114068, '3.40.50.2000-FF-000427', NULL, 'UDP-glucuronosyltransferase', 177, NULL, NULL, 114068),
(114069, '1.20.5.490-FF-000015', NULL, 'Uncharacterized protein', 34, NULL, NULL, 114069),
(114070, '3.50.50.60-FF-000297', NULL, 'FAD-containing monooxygenase MymA', 248, NULL, NULL, 114070),
(114071, '4.10.240.10-FF-000091', NULL, 'Multidrug resistance regulator 1', 42, NULL, NULL, 114071),
(114072, '1.20.1720.10-FF-000051', NULL, 'Major facilitator superfamily transporter', 381, NULL, NULL, 114072),
(114073, '1.20.58.780-FF-000001', NULL, 'Surface layer (S-layer) glycoprotein', 68, NULL, NULL, 114073),
(114074, '1.10.150.60-FF-000019', NULL, 'Transcription factor jumonji (JmjC) domain-containing protein', 104, NULL, NULL, 114074),
(114075, '3.30.160.60-FF-000340', NULL, 'zinc finger protein 473 isoform X1', 27, NULL, NULL, 114075),
(114076, '3.30.70.1900-FF-000001', NULL, 'CRISPR-associated endoribonuclease Cas6', 115, NULL, NULL, 114076),
(114077, '3.30.420.40-FF-000388', NULL, 'Actin family protein', 108, NULL, NULL, 114077),
(114078, '3.30.200.20-FF-000747', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 92, NULL, NULL, 114078),
(114079, '3.10.100.10-FF-000005', NULL, 'collectin-11 isoform X1', 155, NULL, NULL, 114079),
(114080, '3.30.505.10-FF-000222', NULL, NULL, 100, NULL, NULL, 114080),
(114081, '3.30.1120.130-FF-000002', NULL, 'Serine/threonine-protein kinase PLK4', 104, NULL, NULL, 114081),
(114082, '1.25.40.10-FF-001755', NULL, 'Actin binding protein, putative', 343, NULL, NULL, 114082),
(114083, '2.30.42.10-FF-000345', NULL, NULL, 104, NULL, NULL, 114083);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(114084, '3.30.559.70-FF-000044', NULL, 'Uncharacterized protein', 310, NULL, NULL, 114084),
(114085, '3.40.1160.10-FF-000069', NULL, 'Lysine-sensitive aspartokinase 3', 282, NULL, NULL, 114085),
(114086, '3.40.50.300-FF-007670', NULL, 'Uncharacterized protein', 121, NULL, NULL, 114086),
(114087, '3.40.50.1110-FF-000127', NULL, 'Uncharacterized protein', 249, NULL, NULL, 114087),
(114088, '2.60.40.10-FF-002852', NULL, 'Immunoglobulin heavy variable 6-1', 118, NULL, NULL, 114088),
(114089, '2.130.10.10-FF-001964', NULL, 'Eukaryotic translation initiation factor eif2a protein', 271, NULL, NULL, 114089),
(114090, '3.30.420.40-FF-000736', NULL, 'Actin-like protein 4', 111, NULL, NULL, 114090),
(114091, '2.10.25.10-FF-000301', NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein', 48, NULL, NULL, 114091),
(114092, '3.20.20.140-FF-000408', NULL, 'Uncharacterized protein', 98, NULL, NULL, 114092),
(114093, '2.30.29.30-FF-000371', NULL, 'Pebble, isoform B', 168, NULL, NULL, 114093),
(114094, '2.60.40.10-FF-003785', NULL, NULL, 100, NULL, NULL, 114094),
(114095, '3.90.1410.10-FF-000111', NULL, 'Uncharacterized protein', 227, NULL, NULL, 114095),
(114096, '3.40.710.10-FF-000011', NULL, 'Penicillin-binding protein AmpH', 349, NULL, NULL, 114096),
(114097, '3.40.50.12670-FF-000002', NULL, 'Carboxypeptidase', 148, NULL, NULL, 114097),
(114098, '3.40.1770.10-FF-000008', NULL, 'Uncharacterized protein', 84, NULL, NULL, 114098),
(114099, '2.60.40.10-FF-005578', NULL, NULL, 52, NULL, NULL, 114099),
(114100, '1.10.510.10-FF-003809', NULL, NULL, 117, NULL, NULL, 114100),
(114101, '1.10.1450.10-FF-000004', NULL, 'Tetraspanin', 101, NULL, NULL, 114101),
(114102, '1.25.40.10-FF-003661', NULL, 'Pentatricopeptide repeat-containing protein At1g71490', 117, NULL, NULL, 114102),
(114103, '2.30.140.10-FF-000013', NULL, 'Spermidine synthase', 62, NULL, NULL, 114103),
(114104, '3.90.190.10-FF-000347', NULL, 'Dual specificity protein phosphatase 22', 159, NULL, NULL, 114104),
(114105, '3.30.70.330-FF-000086', NULL, 'Putative Cytoplasmic polyadenylation element-binding protein 1', 97, NULL, NULL, 114105),
(114106, '3.90.550.10-FF-000010', NULL, 'Galactosylgalactosylxylosylprotein 3-beta-glucuronosyltransferase', 253, NULL, NULL, 114106),
(114107, '1.10.10.2430-FF-000002', NULL, 'BcDNA.LD23876', 122, NULL, NULL, 114107),
(114108, '3.40.50.2000-FF-000181', NULL, 'Lipopolysaccharide heptosyltransferase I', 161, NULL, NULL, 114108),
(114109, '3.40.1110.10-FF-000358', NULL, 'Putative phospholipid-transporting ATPase C4F10.16c', 273, NULL, NULL, 114109),
(114110, '2.40.30.30-FF-000008', NULL, 'Riboflavin kinase', 194, NULL, NULL, 114110),
(114111, '3.40.50.2300-FF-001018', NULL, NULL, 152, NULL, NULL, 114111),
(114112, '3.40.50.800-FF-000018', NULL, 'Proline--tRNA ligase', 121, NULL, NULL, 114112),
(114113, '1.25.40.170-FF-000005', NULL, 'Smg, isoform B', 110, NULL, NULL, 114113),
(114114, '2.60.120.970-FF-000047', NULL, 'Transforming growth factor beta', 263, NULL, NULL, 114114),
(114115, '3.30.342.10-FF-000051', NULL, 'DNA polymerase B region', 106, NULL, NULL, 114115),
(114116, '3.40.50.150-FF-001857', NULL, NULL, 282, NULL, NULL, 114116),
(114117, '2.60.260.40-FF-000001', NULL, 'NADH dehydrogenase [ubiquinone] iron-sulfur protein 6, mitochondrial', 51, NULL, NULL, 114117),
(114118, '1.25.40.10-FF-004509', NULL, 'Uncharacterized protein', 89, NULL, NULL, 114118),
(114119, '1.10.510.10-FF-002961', NULL, 'Dual specificity protein phosphatase, putative', 229, NULL, NULL, 114119),
(114120, '3.40.190.10-FF-000257', NULL, 'Uncharacterized protein', 97, NULL, NULL, 114120),
(114121, '1.10.287.2900-FF-000004', NULL, 'NADH-ubiquinone oxidoreductase', 42, NULL, NULL, 114121),
(114122, '3.40.47.10-FF-000286', NULL, NULL, 58, NULL, NULL, 114122),
(114123, '2.30.29.30-FF-000843', NULL, 'Uncharacterized protein', 119, NULL, NULL, 114123),
(114124, '3.60.10.10-FF-000026', NULL, 'Exodeoxyribonuclease III', 254, NULL, NULL, 114124),
(114125, '1.25.40.180-FF-000048', NULL, 'Uncharacterized protein, isoform A', 114, NULL, NULL, 114125);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(114126, '1.20.1270.10-FF-000089', NULL, 'Uncharacterized protein', 100, NULL, NULL, 114126),
(114127, '3.20.20.80-FF-000735', NULL, 'Linamarase family protein', 87, NULL, NULL, 114127),
(114128, '1.20.58.1970-FF-000002', NULL, 'Oligomeric Golgi complex subunit', 170, NULL, NULL, 114128),
(114129, '3.30.160.60-FF-006180', NULL, NULL, 96, NULL, NULL, 114129),
(114130, '1.20.1530.20-FF-000101', NULL, 'Malonate transporter, putative', 155, NULL, NULL, 114130),
(114131, '3.30.1370.10-FF-000194', NULL, 'Predicted protein', 109, NULL, NULL, 114131),
(114132, '1.10.1870.10-FF-000019', NULL, 'Predicted protein', 31, NULL, NULL, 114132),
(114133, '3.40.50.410-FF-000087', NULL, 'TRAP-like protein', 205, NULL, NULL, 114133),
(114134, '1.20.1050.10-FF-000286', NULL, 'Uncharacterized protein', 105, NULL, NULL, 114134),
(114135, '1.20.1070.10-FF-000664', NULL, 'Predicted protein', 295, NULL, NULL, 114135),
(114136, '2.60.40.10-FF-000688', NULL, 'Leptin receptor', 113, NULL, NULL, 114136),
(114137, '1.10.8.10-FF-000240', NULL, 'Defective in cullin neddylation protein', 49, NULL, NULL, 114137),
(114138, '2.70.170.10-FF-000197', NULL, 'Uncharacterized protein', 178, NULL, NULL, 114138),
(114139, '3.30.70.330-FF-001070', NULL, 'Eukaryotic translation initiation factor 3 subunit G', 101, NULL, NULL, 114139),
(114140, '3.80.10.10-FF-001588', NULL, 'Leucine-rich repeat receptor-like protein kinase', 141, NULL, NULL, 114140),
(114141, '3.30.450.20-FF-000367', NULL, 'Uncharacterized protein', 42, NULL, NULL, 114141),
(114142, '3.30.420.140-FF-000013', NULL, 'Putative pre-16S rRNA nuclease', 133, NULL, NULL, 114142),
(114143, '3.40.50.1820-FF-000340', NULL, 'Serine esterase (DUF676) protein', 243, NULL, NULL, 114143),
(114144, '2.30.30.70-FF-000004', NULL, 'Uncharacterized protein', 97, NULL, NULL, 114144),
(114145, '3.40.50.300-FF-005197', NULL, 'Polysaccharide biosynthesis tyrosine autokinase', 212, NULL, NULL, 114145),
(114146, '3.40.50.11580-FF-000001', NULL, 'Replicase polyprotein 1ab', 126, NULL, NULL, 114146),
(114147, '3.30.160.60-FF-005235', NULL, NULL, 72, NULL, NULL, 114147),
(114148, '3.90.960.10-FF-000018', NULL, 'HDOD domain-containing protein', 142, NULL, NULL, 114148),
(114149, '3.20.20.80-FF-000387', NULL, 'Chitinase 12', 264, NULL, NULL, 114149),
(114150, '2.130.10.10-FF-001981', NULL, 'WD repeat-containing and planar cell polarity effector protein fritz homolog', 158, NULL, NULL, 114150),
(114151, '3.40.1170.10-FF-000042', NULL, 'MutS 6 isoform 1 family protein', 104, NULL, NULL, 114151),
(114152, '3.30.420.40-FF-000753', NULL, 'AaceriAGR099Cp', 42, NULL, NULL, 114152),
(114153, '3.80.10.10-FF-002572', NULL, 'Uncharacterized protein', 118, NULL, NULL, 114153),
(114154, '3.30.40.10-FF-000760', NULL, 'Predicted protein', 86, NULL, NULL, 114154),
(114155, '3.40.1110.10-FF-000375', NULL, NULL, 157, NULL, NULL, 114155),
(114156, '3.40.50.300-FF-004797', NULL, 'Uncharacterized protein', 227, NULL, NULL, 114156),
(114157, '3.20.20.80-FF-000426', NULL, 'Glucosylceramidase', 162, NULL, NULL, 114157),
(114158, '3.40.33.10-FF-000108', NULL, 'Uncharacterized protein', 123, NULL, NULL, 114158),
(114159, '1.25.40.450-FF-000005', NULL, 'Nuclear pore complex protein Nup155', 181, NULL, NULL, 114159),
(114160, '3.30.40.10-FF-001160', NULL, 'Uncharacterized protein', 99, NULL, NULL, 114160),
(114161, '2.130.10.10-FF-004398', NULL, 'Uncharacterized protein', 57, NULL, NULL, 114161),
(114162, '3.40.50.720-FF-000769', NULL, 'Forever young oxidoreductase', 306, NULL, NULL, 114162),
(114163, '2.60.40.10-FF-001672', NULL, 'Triggering receptor expressed on myeloid cells like 2', 104, NULL, NULL, 114163),
(114164, '3.40.50.2000-FF-000557', NULL, 'UDP-glycosyltransferase 76D1', 240, NULL, NULL, 114164),
(114165, '3.60.20.10-FF-000185', NULL, NULL, 236, NULL, NULL, 114165),
(114166, '3.30.40.10-FF-000232', NULL, 'E3 ubiquitin-protein ligase TRIM11', 79, NULL, NULL, 114166),
(114167, '3.30.70.330-FF-001412', NULL, 'RNA recognition motif domain containing protein', 162, NULL, NULL, 114167),
(114168, '3.30.1120.30-FF-000013', NULL, 'Serine/threonine-protein kinase PLK', 97, NULL, NULL, 114168);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(114169, '1.10.3200.20-FF-000006', NULL, 'DNA polymerase', 229, NULL, NULL, 114169),
(114170, '1.10.8.1220-FF-000016', NULL, 'Dynein heavy chain family protein', 84, NULL, NULL, 114170),
(114171, '3.30.760.10-FF-000011', NULL, 'Eukaryotic translation initiation factor 4E', 215, NULL, NULL, 114171),
(114172, '3.40.50.300-FF-005421', NULL, 'Uncharacterized protein', 94, NULL, NULL, 114172),
(114173, '2.60.40.10-FF-000379', NULL, 'Glucans biosynthesis protein D', 120, NULL, NULL, 114173),
(114174, '1.20.1250.20-FF-002333', NULL, 'Protein NRT1/ PTR FAMILY 7.1', 139, NULL, NULL, 114174),
(114175, '1.10.510.10-FF-002944', NULL, NULL, 98, NULL, NULL, 114175),
(114176, '3.40.50.2000-FF-001046', NULL, 'Uncharacterized protein', 133, NULL, NULL, 114176),
(114177, '2.30.30.100-FF-000029', NULL, 'U6 snRNA-associated Sm-like protein LSm1', 114, NULL, NULL, 114177),
(114178, '1.20.120.1240-FF-000033', NULL, 'DNM1 isoform 12', 73, NULL, NULL, 114178),
(114179, '3.10.450.50-FF-000088', NULL, 'Isoaspartyl aminopeptidase', 119, NULL, NULL, 114179),
(114180, '3.40.50.1440-FF-000012', NULL, 'Tubulin gamma chain', 268, NULL, NULL, 114180),
(114181, '2.60.40.150-FF-000040', NULL, 'synaptotagmin-like protein 2 isoform X2', 153, NULL, NULL, 114181),
(114182, '3.40.50.300-FF-005730', NULL, 'Uncharacterized protein', 156, NULL, NULL, 114182),
(114183, '1.20.1740.10-FF-000064', NULL, 'Spore germination protein GerKB', 365, NULL, NULL, 114183),
(114184, '1.10.510.10-FF-003580', NULL, NULL, 354, NULL, NULL, 114184),
(114185, '1.25.10.10-FF-001927', NULL, 'PIKK family atypical protein kinase', 302, NULL, NULL, 114185),
(114186, '3.90.1150.170-FF-000008', NULL, 'Uncharacterized protein', 138, NULL, NULL, 114186),
(114187, '2.30.29.30-FF-001332', NULL, 'Uncharacterized protein', 58, NULL, NULL, 114187),
(114188, '1.10.30.10-FF-000001', NULL, 'transcription factor 7 isoform X2', 86, NULL, NULL, 114188),
(114189, '3.90.1010.10-FF-000002', NULL, 'Iron-sulfur cluster assembly scaffold protein NifU', 145, NULL, NULL, 114189),
(114190, '3.80.10.10-FF-002077', NULL, 'Uncharacterized protein', 135, NULL, NULL, 114190),
(114191, '3.90.1600.10-FF-000047', NULL, 'DNA polymerase alpha subunit one', 61, NULL, NULL, 114191),
(114192, '3.90.190.10-FF-000263', NULL, 'probable rhodanese domain-containing dual specificity protein phosphatase isoform X1', 149, NULL, NULL, 114192),
(114193, '1.25.40.10-FF-003880', NULL, 'Uncharacterized protein', 86, NULL, NULL, 114193),
(114194, '2.130.10.10-FF-005707', NULL, 'Uncharacterized protein', 145, NULL, NULL, 114194),
(114195, '3.40.50.150-FF-001172', NULL, NULL, 181, NULL, NULL, 114195),
(114196, '2.120.10.30-FF-000094', NULL, 'Protein CBG06215', 308, NULL, NULL, 114196),
(114197, '2.60.40.10-FF-000727', NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein', 90, NULL, NULL, 114197),
(114198, '3.20.20.80-FF-000050', NULL, 'Beta-mannosidase B', 351, NULL, NULL, 114198),
(114199, '1.25.10.10-FF-001579', NULL, 'Uncharacterized protein', 270, NULL, NULL, 114199),
(114200, '2.60.40.10-FF-004959', NULL, NULL, 76, NULL, NULL, 114200),
(114201, '3.30.40.10-FF-000917', NULL, 'E3 ubiquitin-protein ligase BOI', 59, NULL, NULL, 114201),
(114202, '3.40.50.300-FF-001835', NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', 239, NULL, NULL, 114202),
(114203, '3.20.20.70-FF-000513', NULL, 'Dihydroorotate dehydrogenase', 297, NULL, NULL, 114203),
(114204, '3.30.200.110-FF-000011', NULL, NULL, 123, NULL, NULL, 114204),
(114205, '2.10.60.10-FF-000023', NULL, 'CD59 glycoprotein preproprotein', 78, NULL, NULL, 114205),
(114206, '3.30.70.330-FF-000451', NULL, 'Polyadenylate-binding protein RBP45C', 106, NULL, NULL, 114206),
(114207, '2.40.10.10-FF-000378', NULL, NULL, 111, NULL, NULL, 114207),
(114208, '1.20.5.2210-FF-000001', NULL, 'ATP synthase F(0) complex subunit B1, mitochondrial', 93, NULL, NULL, 114208),
(114209, '3.30.70.1230-FF-000137', NULL, 'Guanylate cyclase', 111, NULL, NULL, 114209),
(114210, '2.10.70.10-FF-000158', NULL, 'Receptor protein-tyrosine kinase', 61, NULL, NULL, 114210);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(114211, '1.10.418.10-FF-000195', NULL, 'protein Hook homolog 3', 157, NULL, NULL, 114211),
(114212, '3.40.50.300-FF-005758', NULL, 'Uncharacterized protein', 123, NULL, NULL, 114212),
(114213, '1.20.1050.10-FF-000106', NULL, 'Glutathione S-transferase 3', 117, NULL, NULL, 114213),
(114214, '3.30.160.60-FF-001649', NULL, 'C2H2 transcription factor Swi5', 30, NULL, NULL, 114214),
(114215, '3.40.50.1460-FF-000018', NULL, 'Caspase-3', 147, NULL, NULL, 114215),
(114216, '2.130.10.10-FF-002021', NULL, 'WD repeat-containing protein AAC3', 131, NULL, NULL, 114216),
(114217, '3.60.110.10-FF-000040', NULL, 'Os06g0206000 protein', 242, NULL, NULL, 114217),
(114218, '3.80.10.10-FF-002425', NULL, 'Uncharacterized protein', 136, NULL, NULL, 114218),
(114219, '2.60.220.50-FF-000013', NULL, 'Adhesion G protein-coupled receptor E1', 191, NULL, NULL, 114219),
(114220, '2.60.40.10-FF-005359', NULL, NULL, 65, NULL, NULL, 114220),
(114221, '3.80.10.10-FF-004022', NULL, 'Protein CBR-LET-413', 146, NULL, NULL, 114221),
(114222, '1.25.10.10-FF-001152', NULL, 'Putative pumillio protein 4', 375, NULL, NULL, 114222),
(114223, '2.130.10.130-FF-000044', NULL, NULL, 113, NULL, NULL, 114223),
(114224, '3.30.160.60-FF-002138', NULL, 'Zinc finger transcription factor', 20, NULL, NULL, 114224),
(114225, '3.30.430.20-FF-000028', NULL, 'Putative DUF26-domain receptor-like protein kinase family protein', 97, NULL, NULL, 114225),
(114226, '1.25.40.20-FF-000701', NULL, 'Os12g0283700 protein', 77, NULL, NULL, 114226),
(114227, '3.40.1280.10-FF-000033', NULL, 'rRNA methyltransferase', 160, NULL, NULL, 114227),
(114228, '1.20.58.1610-FF-000018', NULL, NULL, 105, NULL, NULL, 114228),
(114229, '3.90.190.20-FF-000029', NULL, 'Bifunctional folylpolyglutamate synthase/dihydrofolate synthase', 130, NULL, NULL, 114229),
(114230, '3.40.50.12710-FF-000020', NULL, 'Protein arginine methyltransferase NDUFAF7', 394, NULL, NULL, 114230),
(114231, '3.30.40.10-FF-000125', NULL, 'Putative PHD finger protein 1', 60, NULL, NULL, 114231),
(114232, '1.10.750.20-FF-000003', NULL, 'WD repeat and SOCS box-containing 1, isoform CRA_b', 32, NULL, NULL, 114232),
(114233, '1.10.1520.10-FF-000105', NULL, 'Os09g0315100 protein', 84, NULL, NULL, 114233),
(114234, '2.60.40.10-FF-005128', NULL, NULL, 97, NULL, NULL, 114234),
(114235, '2.30.30.770-FF-000005', NULL, '60S ribosomal protein L27, putative', 139, NULL, NULL, 114235),
(114236, '3.40.50.300-FF-001234', NULL, 'ABC multidrug transporter SitT', 249, NULL, NULL, 114236),
(114237, '3.40.50.720-FF-002422', NULL, 'Uncharacterized protein', 35, NULL, NULL, 114237),
(114238, '1.10.287.130-FF-000150', NULL, 'Two-component system sensor histidine kinase', 120, NULL, NULL, 114238),
(114239, '1.25.10.10-FF-003260', NULL, 'Uncharacterized protein', 212, NULL, NULL, 114239),
(114240, '3.60.40.10-FF-000293', NULL, 'Pentatricopeptide repeat (PPR) superfamily protein', 130, NULL, NULL, 114240),
(114241, '2.30.30.40-FF-000006', NULL, 'RIMS-binding protein 2 isoform X1', 64, NULL, NULL, 114241),
(114242, '3.20.20.70-FF-000277', NULL, 'Phosphoribosylanthranilate isomerase', 206, NULL, NULL, 114242),
(114243, '3.30.70.980-FF-000033', NULL, 'Translational Activator of Cytochrome c Oxidase', 84, NULL, NULL, 114243),
(114244, '3.30.1780.10-FF-000023', NULL, 'Chromosome 15, whole genome shotgun sequence', 109, NULL, NULL, 114244),
(114245, '2.30.30.1020-FF-000018', NULL, 'Uncharacterized protein', 152, NULL, NULL, 114245),
(114246, '3.40.630.30-FF-000617', NULL, 'Uncharacterized protein', 191, NULL, NULL, 114246),
(114247, '3.40.50.300-FF-007653', NULL, 'Predicted protein', 133, NULL, NULL, 114247),
(114248, '3.40.50.300-FF-005505', NULL, 'ABC Transporter family', 173, NULL, NULL, 114248),
(114249, '2.130.10.10-FF-003982', NULL, 'Uncharacterized protein', 233, NULL, NULL, 114249),
(114250, '2.60.40.1930-FF-000003', NULL, 'CD109 molecule', 91, NULL, NULL, 114250),
(114251, '2.160.10.10-FF-000108', NULL, 'Eukaryotic translation initiation factor 2B subunit epsilon', 75, NULL, NULL, 114251),
(114252, '3.90.1150.10-FF-000304', NULL, 'Predicted protein', 132, NULL, NULL, 114252);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(114253, '3.30.160.60-FF-000795', NULL, 'Zinc finger homeobox protein 4', 62, NULL, NULL, 114253),
(114254, '3.30.70.80-FF-000018', NULL, 'YHR138C-like protein', 86, NULL, NULL, 114254),
(114255, '3.30.470.20-FF-000222', NULL, 'Predicted protein', 183, NULL, NULL, 114255),
(114256, '1.20.1110.10-FF-000235', NULL, 'Sodium/potassium-transporting ATPase subunit alpha', 342, NULL, NULL, 114256),
(114257, '2.50.20.10-FF-000013', NULL, 'Outer-membrane lipoprotein carrier protein', 159, NULL, NULL, 114257),
(114258, '1.25.40.10-FF-002733', NULL, 'Uncharacterized protein', 266, NULL, NULL, 114258),
(114259, '3.20.20.190-FF-000053', NULL, 'Phosphoinositide phospholipase C', 180, NULL, NULL, 114259),
(114260, '3.20.20.140-FF-000032', NULL, 'Allantoinase Dal1', 443, NULL, NULL, 114260),
(114261, '1.10.10.10-FF-000016', NULL, 'Forkhead box protein I1', 103, NULL, NULL, 114261),
(114262, '3.50.50.60-FF-000533', NULL, '2-octaprenyl-3-methyl-6-methoxy-1,4-benzoquinol hydroxylase', 221, NULL, NULL, 114262),
(114263, '2.100.10.30-FF-000010', NULL, 'natterin-like protein isoform X1', 147, NULL, NULL, 114263),
(114264, '3.30.420.10-FF-000177', NULL, 'Ribonuclease, putative', 197, NULL, NULL, 114264),
(114265, '1.25.40.70-FF-000019', NULL, 'Phosphatidylinositol 3-kinase VPS34', 215, NULL, NULL, 114265),
(114266, '1.25.40.10-FF-003352', NULL, 'TPR repeat, putative', 76, NULL, NULL, 114266),
(114267, '3.20.20.450-FF-000018', NULL, 'Probable diguanylate cyclase DgcE', 210, NULL, NULL, 114267),
(114268, '3.30.160.60-FF-004538', NULL, NULL, 46, NULL, NULL, 114268),
(114269, '3.40.50.720-FF-000168', NULL, 'Fatty acid synthase subunit alpha', 529, NULL, NULL, 114269),
(114270, '3.10.100.10-FF-000371', NULL, NULL, 142, NULL, NULL, 114270),
(114271, '1.25.40.20-FF-000595', NULL, 'Os11g0435300 protein', 88, NULL, NULL, 114271),
(114272, '3.40.50.1170-FF-000015', NULL, 'Uncharacterized protein', 150, NULL, NULL, 114272),
(114273, '2.40.30.10-FF-000233', NULL, 'Elongation factor G2-like protein', 133, NULL, NULL, 114273),
(114274, '4.10.1000.10-FF-000013', NULL, 'zinc finger CCCH domain-containing protein 4 isoform X1', 67, NULL, NULL, 114274),
(114275, '3.40.1280.10-FF-000016', NULL, 'rRNA methylase-like protein', 208, NULL, NULL, 114275),
(114276, '1.10.390.10-FF-000011', NULL, 'Transcription initiation factor TFIID subunit', 244, NULL, NULL, 114276),
(114277, '1.20.140.40-FF-000022', NULL, 'Pectinesterase', 153, NULL, NULL, 114277),
(114278, '2.60.120.10-FF-000679', NULL, 'Uncharacterized protein', 88, NULL, NULL, 114278),
(114279, '3.30.450.20-FF-000114', NULL, 'Hypoxia inducible factor 1 subunit alpha, like', 118, NULL, NULL, 114279),
(114280, '3.30.200.20-FF-002001', NULL, NULL, 96, NULL, NULL, 114280),
(114281, '1.10.8.60-FF-000261', NULL, '26S protease regulatory subunit 6B', 79, NULL, NULL, 114281),
(114282, '2.40.420.20-FF-000024', NULL, 'RagD protein', 90, NULL, NULL, 114282),
(114283, '2.30.39.10-FF-000080', NULL, 'Accessory gland protein Acp76A', 105, NULL, NULL, 114283),
(114284, '1.10.1580.10-FF-000025', NULL, 'Ribosome biogenesis GTPase A', 91, NULL, NULL, 114284),
(114285, '6.10.140.2220-FF-000058', NULL, 'Uncharacterized protein', 49, NULL, NULL, 114285),
(114286, '2.60.120.970-FF-000064', NULL, 'bone morphogenetic protein 8B-like', 150, NULL, NULL, 114286),
(114287, '3.90.190.10-FF-000572', NULL, 'Map kinase phosphatase-M B2 isoform', 146, NULL, NULL, 114287),
(114288, '3.40.50.11380-FF-000020', NULL, NULL, 21, NULL, NULL, 114288),
(114289, '3.40.50.1010-FF-000001', NULL, 'DNA polymerase I', 175, NULL, NULL, 114289),
(114290, '3.40.50.300-FF-001599', NULL, 'guanine nucleotide-binding protein G(Olf) subunit alpha', 179, NULL, NULL, 114290),
(114291, '2.60.40.10-FF-004089', NULL, NULL, 94, NULL, NULL, 114291),
(114292, '2.130.10.10-FF-005691', NULL, 'Uncharacterized protein', 155, NULL, NULL, 114292),
(114293, '1.10.8.10-FF-000015', NULL, 'Chromosome 6 C6orf106 homolog', 45, NULL, NULL, 114293),
(114294, '2.60.120.290-FF-000158', NULL, 'Uncharacterized protein', 125, NULL, NULL, 114294),
(114295, '2.60.40.10-FF-001441', NULL, 'Interleukin-18 receptor 1', 93, NULL, NULL, 114295);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(114296, '3.40.720.10-FF-000057', NULL, 'Arylsulfatase', 434, NULL, NULL, 114296),
(114297, '1.10.8.660-FF-000001', NULL, 'Uncharacterized protein', 50, NULL, NULL, 114297),
(114298, '1.20.1270.60-FF-000166', NULL, 'Sorting NeXin', 128, NULL, NULL, 114298),
(114299, '4.10.410.10-FF-000008', NULL, 'Serine peptidase inhibitor, Kunitz type 1', 58, NULL, NULL, 114299),
(114300, '3.90.190.10-FF-000133', NULL, 'Leucine rich repeat and phosphatase domain containing protein', 153, NULL, NULL, 114300),
(114301, '2.10.25.160-FF-000002', NULL, 'Cysteine protease 1', 64, NULL, NULL, 114301),
(114302, '3.40.50.360-FF-000156', NULL, 'Uncharacterized protein', 144, NULL, NULL, 114302),
(114303, '1.10.630.10-FF-000519', NULL, 'Uncharacterized protein', 408, NULL, NULL, 114303),
(114304, '3.40.50.12780-FF-000035', NULL, 'Acetyl-coenzyme A synthetase', 444, NULL, NULL, 114304),
(114305, '1.25.10.10-FF-002905', NULL, 'Uncharacterized protein', 126, NULL, NULL, 114305),
(114306, '2.30.30.100-FF-000176', NULL, 'U6 snRNA-associated Sm-like protein LSm3', 84, NULL, NULL, 114306),
(114307, '3.10.580.10-FF-000001', NULL, 'Putative metal transporter CNNM3 isoform 2', 156, NULL, NULL, 114307),
(114308, '1.10.3380.30-FF-000038', NULL, 'Probable ATP-dependent helicase MJ1401', 225, NULL, NULL, 114308),
(114309, '3.40.50.1110-FF-000149', NULL, 'Uncharacterized protein', 102, NULL, NULL, 114309),
(114310, '1.10.10.740-FF-000001', NULL, 'Cysteine-rich secretory protein 2', 43, NULL, NULL, 114310),
(114311, '1.10.287.160-FF-000013', NULL, 'Protein Kinase N (PKN) homolog', 78, NULL, NULL, 114311),
(114312, '3.30.70.330-FF-002665', NULL, NULL, 74, NULL, NULL, 114312),
(114313, '3.60.21.60-FF-000027', NULL, 'Uncharacterized protein', 115, NULL, NULL, 114313),
(114314, '2.40.20.10-FF-000098', NULL, 'Uncharacterized protein', 97, NULL, NULL, 114314),
(114315, '3.90.70.10-FF-000006', NULL, 'Cathepsin S', 317, NULL, NULL, 114315),
(114316, '3.30.70.330-FF-001631', NULL, 'Poly(A) binding protein Pab2', 142, NULL, NULL, 114316),
(114317, '1.25.40.10-FF-000479', NULL, 'Wolfram syndrome 1 (Wolframin)', 187, NULL, NULL, 114317),
(114318, '1.20.190.20-FF-000002', NULL, '14-3-3 protein epsilon', 245, NULL, NULL, 114318),
(114319, '1.25.10.10-FF-002799', NULL, 'DnaJ homolog subfamily C member 13-like Protein', 236, NULL, NULL, 114319),
(114320, '3.30.160.60-FF-003543', NULL, 'Zinc finger protein 529', 31, NULL, NULL, 114320),
(114321, '3.50.50.60-FF-000898', NULL, 'Glycerol-3-phosphate dehydrogenase', 111, NULL, NULL, 114321),
(114322, '2.130.10.10-FF-003454', NULL, 'Predicted protein', 109, NULL, NULL, 114322),
(114323, '3.30.200.20-FF-000978', NULL, 'Protein kinase, putative', 101, NULL, NULL, 114323),
(114324, '3.30.230.10-FF-000370', NULL, 'Uncharacterized protein', 79, NULL, NULL, 114324),
(114325, '3.40.1800.30-FF-000001', NULL, 'Histone deacetylase complex subunit', 67, NULL, NULL, 114325),
(114326, '3.10.50.10-FF-000008', NULL, 'Chitinase 11', 71, NULL, NULL, 114326),
(114327, '1.20.1280.50-FF-000242', NULL, 'F-box and WD repeat domain-containing 11', 40, NULL, NULL, 114327),
(114328, '2.10.50.10-FF-000067', NULL, 'Tumor necrosis factor receptor superfamily member 14', 68, NULL, NULL, 114328),
(114329, '3.30.420.40-FF-000989', NULL, 'Uncharacterized protein', 91, NULL, NULL, 114329),
(114330, '1.25.40.10-FF-003245', NULL, 'Probable pre-mRNA splicing factor prp1', 177, NULL, NULL, 114330),
(114331, '3.40.1090.10-FF-000097', NULL, 'Lysophospholipase', 466, NULL, NULL, 114331),
(114332, '3.10.250.10-FF-000027', NULL, 'Transmembrane serine protease 2', 99, NULL, NULL, 114332),
(114333, '3.30.870.10-FF-000002', NULL, 'Cardiolipin synthase A', 186, NULL, NULL, 114333),
(114334, '2.40.50.140-FF-000970', NULL, NULL, 67, NULL, NULL, 114334),
(114335, '2.10.220.10-FF-000170', NULL, 'Uncharacterized protein', 85, NULL, NULL, 114335),
(114336, '3.90.226.10-FF-000285', NULL, 'ATP-dependent Clp protease proteolytic subunit', 208, NULL, NULL, 114336),
(114337, '2.120.10.30-FF-000419', NULL, 'Predicted protein', 176, NULL, NULL, 114337),
(114338, '3.30.60.30-FF-000082', NULL, 'AGRin (Synaptic protein) homolog', 74, NULL, NULL, 114338);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(114339, '3.60.21.10-FF-000170', NULL, 'Metallophosphoesterase, phosphate-repressible', 313, NULL, NULL, 114339),
(114340, '3.30.9.10-FF-000272', NULL, 'Uncharacterized protein', 106, NULL, NULL, 114340),
(114341, '2.60.120.200-FF-000659', NULL, 'Uncharacterized protein', 86, NULL, NULL, 114341),
(114342, '2.10.25.10-FF-000290', NULL, 'EGF-containing fibulin-like extracellular matrix protein 2', 37, NULL, NULL, 114342),
(114343, '3.30.1050.10-FF-000046', NULL, 'Uncharacterized protein', 57, NULL, NULL, 114343),
(114344, '3.40.50.410-FF-000339', NULL, 'Uncharacterized protein', 145, NULL, NULL, 114344),
(114345, '1.20.1280.50-FF-000135', NULL, 'FBD, F-box and Leucine Rich Repeat domains containing protein', 49, NULL, NULL, 114345),
(114346, '2.60.120.260-FF-000306', NULL, 'AGAP011177-PA', 173, NULL, NULL, 114346),
(114347, '2.60.40.10-FF-003330', NULL, 'NPHS1 adhesion molecule, nephrin', 95, NULL, NULL, 114347),
(114348, '1.25.40.20-FF-000123', NULL, 'regulatory protein NPR3-like', 141, NULL, NULL, 114348),
(114349, '3.90.1150.10-FF-000293', NULL, 'Glycine dehydrogenase (decarboxylating)', 63, NULL, NULL, 114349),
(114350, '3.20.20.330-FF-000022', NULL, 'Homocysteine S-methyltransferase YbgG', 315, NULL, NULL, 114350),
(114351, '1.10.8.100-FF-000002', NULL, 'Ribosomal RNA small subunit methyltransferase A', 74, NULL, NULL, 114351),
(114352, '1.20.1250.20-FF-002108', NULL, 'Uncharacterized protein', 234, NULL, NULL, 114352),
(114353, '3.40.47.10-FF-000269', NULL, NULL, 133, NULL, NULL, 114353),
(114354, '1.10.472.10-FF-000157', NULL, 'Putative cyclin-F2-1', 110, NULL, NULL, 114354),
(114355, '1.10.20.10-FF-000045', NULL, 'Histone H2B', 67, NULL, NULL, 114355),
(114356, '3.40.50.300-FF-000615', NULL, 'pre-mRNA-splicing factor ATP-dependent RNA helicase DEAH7', 223, NULL, NULL, 114356),
(114357, '3.80.10.10-FF-003044', NULL, 'Uncharacterized protein', 157, NULL, NULL, 114357),
(114358, '3.90.70.10-FF-000787', NULL, 'ubiquitin carboxyl-terminal hydrolase 37', 335, NULL, NULL, 114358),
(114359, '1.25.40.10-FF-000788', NULL, 'Phosphoprotein', 177, NULL, NULL, 114359),
(114360, '2.60.120.330-FF-000086', NULL, 'Gibberellin 3-oxidase', 316, NULL, NULL, 114360),
(114361, '3.30.200.20-FF-000764', NULL, 'CMGC/MAPK protein kinase', 123, NULL, NULL, 114361),
(114362, '3.40.50.1010-FF-000232', NULL, NULL, 74, NULL, NULL, 114362),
(114363, '2.40.10.10-FF-000125', NULL, 'inactive serine protease 54', 100, NULL, NULL, 114363),
(114364, '1.25.40.470-FF-000028', NULL, 'Intraflagellar transport protein 140-like protein', 179, NULL, NULL, 114364),
(114365, '1.10.3520.10-FF-000016', NULL, 'RH52220p', 190, NULL, NULL, 114365),
(114366, '2.60.40.10-FF-003094', NULL, 'Interleukin 2 receptor gamma common.a', 95, NULL, NULL, 114366),
(114367, '3.60.10.10-FF-000156', NULL, 'DUF455 domain-containing protein', 336, NULL, NULL, 114367),
(114368, '1.10.510.10-FF-003326', NULL, NULL, 61, NULL, NULL, 114368),
(114369, '3.30.479.20-FF-000017', NULL, 'Elongation factor Ts', 97, NULL, NULL, 114369),
(114370, '3.40.1110.10-FF-000122', NULL, 'Phospholipid-transporting ATPase', 40, NULL, NULL, 114370),
(114371, '3.30.70.1230-FF-000031', NULL, 'Adenylate cyclase type 7', 197, NULL, NULL, 114371),
(114372, '3.30.200.20-FF-001164', NULL, 'Protein kinase domain containing protein', 108, NULL, NULL, 114372),
(114373, '2.60.40.10-FF-002060', NULL, 'Neuroglian, isoform D', 90, NULL, NULL, 114373),
(114374, '2.60.40.60-FF-000478', NULL, 'Cadherin-87A', 122, NULL, NULL, 114374),
(114375, '3.40.50.1820-FF-000941', NULL, 'Lipase/esterase, putative', 312, NULL, NULL, 114375),
(114376, '3.30.200.20-FF-001692', NULL, 'Serine/threonine protein kinase, putative', 66, NULL, NULL, 114376),
(114377, '1.20.1270.280-FF-000008', NULL, 'Dynein axonemal heavy chain 11', 169, NULL, NULL, 114377),
(114378, '3.40.309.10-FF-000073', NULL, 'Aldehyde dehydrogenase, putative', 78, NULL, NULL, 114378),
(114379, '2.60.40.10-FF-001076', NULL, 'Triggering receptor expressed on myeloid cells 2', 112, NULL, NULL, 114379),
(114380, '3.80.10.10-FF-002908', NULL, 'Leucine-rich repeat and death domain-containing protein 1', 98, NULL, NULL, 114380);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(114381, '3.30.160.60-FF-002829', NULL, 'Zinc finger protein 6', 65, NULL, NULL, 114381),
(114382, '1.10.10.60-FF-001189', NULL, NULL, 93, NULL, NULL, 114382),
(114383, '3.40.50.2300-FF-001563', NULL, NULL, 180, NULL, NULL, 114383),
(114384, '2.60.40.60-FF-001097', NULL, 'Cadherin 26', 117, NULL, NULL, 114384),
(114385, '1.10.287.370-FF-000093', NULL, 'Uncharacterized protein', 80, NULL, NULL, 114385),
(114386, '3.30.428.10-FF-000082', NULL, 'Uncharacterized protein', 55, NULL, NULL, 114386),
(114387, '1.10.510.10-FF-002489', NULL, 'Protein kinase, putative', 342, NULL, NULL, 114387),
(114388, '3.40.50.300-FF-001919', NULL, 'ATP-dependent protease ATPase subunit HslU1, putative', 128, NULL, NULL, 114388),
(114389, '3.40.50.800-FF-000097', NULL, 'Proline--tRNA ligase', 112, NULL, NULL, 114389),
(114390, '1.25.40.10-FF-000007', NULL, 'Clathrin heavy chain', 256, NULL, NULL, 114390),
(114391, '1.25.10.10-FF-000399', NULL, 'Uncharacterized protein', 219, NULL, NULL, 114391),
(114392, '1.10.510.10-FF-004198', NULL, NULL, 222, NULL, NULL, 114392),
(114393, '1.20.1080.10-FF-000018', NULL, 'Aquaporin', 234, NULL, NULL, 114393),
(114394, '1.10.630.10-FF-000199', NULL, 'Probable cytochrome P450 6d2', 499, NULL, NULL, 114394),
(114395, '1.20.1560.10-FF-000263', NULL, 'Multidrug resistance-associated protein 9', 350, NULL, NULL, 114395),
(114396, '1.10.10.570-FF-000017', NULL, 'Uncharacterized protein', 96, NULL, NULL, 114396),
(114397, '3.40.190.10-FF-000274', NULL, 'Nickel ABC transporter substrate-binding protein', 217, NULL, NULL, 114397),
(114398, '3.40.50.2300-FF-001035', NULL, NULL, 123, NULL, NULL, 114398),
(114399, '3.40.50.2000-FF-000973', NULL, 'Uncharacterized protein', 86, NULL, NULL, 114399),
(114400, '3.60.20.10-FF-000055', NULL, 'Proteasome subunit alpha type', 245, NULL, NULL, 114400),
(114401, '1.10.287.2620-FF-000027', NULL, 'Uncharacterized protein', 66, NULL, NULL, 114401),
(114402, '3.30.70.330-FF-001940', NULL, NULL, 183, NULL, NULL, 114402),
(114403, '3.40.50.300-FF-008378', NULL, 'Predicted protein', 85, NULL, NULL, 114403),
(114404, '2.40.50.40-FF-000030', NULL, 'Chemokine (C-C motif) ligand 44', 66, NULL, NULL, 114404),
(114405, '3.40.50.720-FF-001949', NULL, 'Uncharacterized protein', 266, NULL, NULL, 114405),
(114406, '3.40.50.720-FF-001697', NULL, 'UDP-N-acetyl-D-glucosamine 6-dehydrogenase', 207, NULL, NULL, 114406),
(114407, '4.10.240.10-FF-000107', NULL, 'Uncharacterized protein', 73, NULL, NULL, 114407),
(114408, '1.25.40.10-FF-002025', NULL, 'Tetratricopeptide repeat protein 21B', 179, NULL, NULL, 114408),
(114409, '1.20.1740.10-FF-000142', NULL, 'Amino acid transporter, putative', 134, NULL, NULL, 114409),
(114410, '3.40.50.2020-FF-000057', NULL, 'Hypoxanthine phosphoribosyltransferase', 190, NULL, NULL, 114410),
(114411, '3.40.50.1000-FF-000010', NULL, 'Phospholipid-transporting ATPase', 189, NULL, NULL, 114411),
(114412, '1.20.58.60-FF-000618', NULL, 'Uncharacterized protein', 169, NULL, NULL, 114412),
(114413, '3.30.920.20-FF-000004', NULL, 'GAS2-like protein 1 isoform X1', 89, NULL, NULL, 114413),
(114414, '1.25.10.10-FF-003041', NULL, 'Uncharacterized protein', 569, NULL, NULL, 114414),
(114415, '2.40.37.10-FF-000046', NULL, NULL, 143, NULL, NULL, 114415),
(114416, '1.10.600.10-FF-000118', NULL, 'Uncharacterized protein', 193, NULL, NULL, 114416),
(114417, '1.10.565.10-FF-000070', NULL, 'Nuclear Hormone Receptor family', 175, NULL, NULL, 114417),
(114418, '1.25.40.420-FF-000007', NULL, 'Kelch-like family member 7', 102, NULL, NULL, 114418),
(114419, '3.90.45.10-FF-000010', NULL, 'Peptide deformylase', 160, NULL, NULL, 114419),
(114420, '1.25.10.10-FF-003417', NULL, 'Uncharacterized protein', 515, NULL, NULL, 114420),
(114421, '3.20.20.70-FF-000058', NULL, '2-dehydro-3-deoxyphosphooctonate aldolase', 283, NULL, NULL, 114421),
(114422, '1.20.920.60-FF-000003', NULL, 'Uncharacterized protein', 144, NULL, NULL, 114422),
(114423, '1.25.40.450-FF-000022', NULL, 'Nuclear pore protein', 94, NULL, NULL, 114423),
(114424, '1.10.238.10-FF-001063', NULL, 'Uncharacterized protein', 81, NULL, NULL, 114424);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(114425, '2.60.120.10-FF-000100', NULL, 'CRP-like protein Clp', 134, NULL, NULL, 114425),
(114426, '1.10.1200.10-FF-000104', NULL, 'Polyketide synthase type I', 95, NULL, NULL, 114426),
(114427, '3.40.50.1460-FF-000125', NULL, 'Senescence enhanced2b', 150, NULL, NULL, 114427),
(114428, '3.30.160.60-FF-005252', NULL, NULL, 27, NULL, NULL, 114428),
(114429, '3.80.10.10-FF-002532', NULL, 'Leucine-rich repeats and immunoglobulin-like domains protein sma-10', 151, NULL, NULL, 114429),
(114430, '1.10.506.10-FF-000040', NULL, 'Plexin-2', 237, NULL, NULL, 114430),
(114431, '2.30.30.490-FF-000028', NULL, 'DNA (Cytosine-5)-methyltransferase', 185, NULL, NULL, 114431),
(114432, '2.60.220.50-FF-000120', NULL, 'Uncharacterized protein', 190, NULL, NULL, 114432),
(114433, '3.40.80.10-FF-000037', NULL, 'Uncharacterized protein', 108, NULL, NULL, 114433),
(114434, '3.30.200.20-FF-001383', NULL, 'Protein kinase superfamily protein', 32, NULL, NULL, 114434),
(114435, '3.40.50.300-FF-002982', NULL, 'Protein CBR-MRP-2', 239, NULL, NULL, 114435),
(114436, '1.25.10.10-FF-001383', NULL, 'Uncharacterized protein', 1079, NULL, NULL, 114436),
(114437, '1.25.40.990-FF-000066', NULL, 'Predicted protein', 114, NULL, NULL, 114437),
(114438, '2.80.10.50-FF-000006', NULL, 'Ryanodine receptor 2 (Cardiac)', 210, NULL, NULL, 114438),
(114439, '3.40.50.300-FF-007759', NULL, 'Uncharacterized protein', 71, NULL, NULL, 114439),
(114440, '3.30.160.60-FF-005808', NULL, NULL, 38, NULL, NULL, 114440),
(114441, '3.90.1750.10-FF-000041', NULL, 'Ubiquitin ligase (E3)', 161, NULL, NULL, 114441),
(114442, '3.40.720.10-FF-000276', NULL, 'Predicted protein', 345, NULL, NULL, 114442),
(114443, '3.90.940.40-FF-000003', NULL, 'Protein CHLORORESPIRATORY REDUCTION 7 chloroplastic', 58, NULL, NULL, 114443),
(114444, '3.10.50.30-FF-000003', NULL, 'Transcription elongation factor GreA', 81, NULL, NULL, 114444),
(114445, '1.25.40.20-FF-000229', NULL, 'protein TANC1 isoform X3', 144, NULL, NULL, 114445),
(114446, '3.40.630.10-FF-000393', NULL, 'Uncharacterized protein', 39, NULL, NULL, 114446),
(114447, '2.30.42.10-FF-000238', NULL, 'Inactivation-no-after-potential D protein', 98, NULL, NULL, 114447),
(114448, '2.40.160.10-FF-000068', NULL, 'Predicted protein', 110, NULL, NULL, 114448),
(114449, '3.30.70.890-FF-000006', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 119, NULL, NULL, 114449),
(114450, '1.20.120.730-FF-000002', NULL, 'Protein transport protein Sec24C isoform C', 137, NULL, NULL, 114450),
(114451, '1.20.5.4820-FF-000020', NULL, NULL, 65, NULL, NULL, 114451),
(114452, '3.30.420.140-FF-000035', NULL, 'Glycine rich protein', 176, NULL, NULL, 114452),
(114453, '1.20.1560.10-FF-000044', NULL, 'ABC transporter B family member 9', 334, NULL, NULL, 114453),
(114454, '3.30.40.10-FF-001053', NULL, 'TNF receptor-associated factor', 50, NULL, NULL, 114454),
(114455, '1.10.8.60-FF-000480', NULL, 'Uncharacterized protein', 58, NULL, NULL, 114455),
(114456, '1.20.5.110-FF-000172', NULL, 'Hemagglutinin-neuraminidase', 65, NULL, NULL, 114456),
(114457, '1.10.287.70-FF-000042', NULL, 'potassium voltage-gated channel subfamily H member 8', 219, NULL, NULL, 114457),
(114458, '1.25.40.10-FF-004498', NULL, 'Uncharacterized protein', 94, NULL, NULL, 114458),
(114459, '3.30.1330.40-FF-000066', NULL, 'Uncharacterized protein', 82, NULL, NULL, 114459),
(114460, '3.40.50.300-FF-000306', NULL, 'ADP-ribosylation factor-like protein 1', 174, NULL, NULL, 114460),
(114461, '1.10.540.10-FF-000063', NULL, 'Putative acyl-CoA dehydrogenase YdbM', 112, NULL, NULL, 114461),
(114462, '2.30.29.90-FF-000001', NULL, 'exocyst complex component 1 isoform X1', 108, NULL, NULL, 114462),
(114463, '2.60.40.10-FF-003706', NULL, NULL, 94, NULL, NULL, 114463),
(114464, '2.40.128.330-FF-000011', NULL, 'Magnesium transporter MRS2', 81, NULL, NULL, 114464),
(114465, '3.30.70.330-FF-002356', NULL, NULL, 165, NULL, NULL, 114465),
(114466, '1.20.58.1200-FF-000002', NULL, 'RNA silencing suppressor', 86, NULL, NULL, 114466),
(114467, '3.40.50.1820-FF-001290', NULL, 'Uncharacterized protein', 282, NULL, NULL, 114467);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(114468, '3.30.420.10-FF-000053', NULL, 'Werner syndrome ATP-dependent helicase homolog', 204, NULL, NULL, 114468),
(114469, '3.90.226.10-FF-000318', NULL, 'Uncharacterized protein', 56, NULL, NULL, 114469),
(114470, '3.40.50.300-FF-003488', NULL, 'Spermatogenesis-associated protein 5-like protein 1, variant 2', 190, NULL, NULL, 114470),
(114471, '3.20.190.10-FF-000008', NULL, 'Formamidopyrimidine-DNA glycosylase', 151, NULL, NULL, 114471),
(114472, '2.20.25.670-FF-000001', NULL, 'Chorion-specific transcription factor GCMb', 68, NULL, NULL, 114472),
(114473, '3.40.850.10-FF-000066', NULL, 'Kinesin-like protein', 335, NULL, NULL, 114473),
(114474, '1.20.5.4570-FF-000001', NULL, 'Ferulic acid decarboxylase 1', 38, NULL, NULL, 114474),
(114475, '3.30.160.60-FF-005466', NULL, NULL, 30, NULL, NULL, 114475),
(114476, '3.20.10.10-FF-000040', NULL, 'Branched-chain amino acid aminotransferase', 155, NULL, NULL, 114476),
(114477, '1.25.40.20-FF-001865', NULL, 'Poly [ADP-ribose] polymerase', 280, NULL, NULL, 114477),
(114478, '1.10.640.10-FF-000025', NULL, 'GH11385p', 560, NULL, NULL, 114478),
(114479, '2.10.25.10-FF-000323', NULL, 'EGF-containing fibulin-like extracellular matrix protein 1', 43, NULL, NULL, 114479),
(114480, '3.30.1330.20-FF-000060', NULL, 'Uncharacterized protein', 43, NULL, NULL, 114480),
(114481, '1.10.510.10-FF-003017', NULL, NULL, 152, NULL, NULL, 114481),
(114482, '2.60.120.590-FF-000057', NULL, 'Alpha-ketoglutarate-dependent dioxygenase alkB homolog 3', 154, NULL, NULL, 114482),
(114483, '2.60.260.20-FF-000046', NULL, 'Chaperone DnaJ', 111, NULL, NULL, 114483),
(114484, '3.40.50.720-FF-000747', NULL, 'NAD(P) dependent steroid dehydrogenase-like', 236, NULL, NULL, 114484),
(114485, '1.20.5.780-FF-000001', NULL, 'Fxyd domain-containing ion transport regulator', 69, NULL, NULL, 114485),
(114486, '3.90.70.10-FF-000658', NULL, 'Protein CBR-DUO-2', 75, NULL, NULL, 114486),
(114487, '3.40.390.10-FF-000238', NULL, NULL, 77, NULL, NULL, 114487),
(114488, '1.20.1270.60-FF-000042', NULL, 'Vacuolar targeting protein Atg24', 240, NULL, NULL, 114488),
(114489, '3.40.630.30-FF-000308', NULL, 'Histone acetyltransferase', 137, NULL, NULL, 114489),
(114490, '2.60.40.10-FF-003021', NULL, 'Microfibril-associated glycoprotein 3', 91, NULL, NULL, 114490),
(114491, '2.130.10.10-FF-000020', NULL, 'Guanine nucleotide-binding protein beta subunit', 341, NULL, NULL, 114491),
(114492, '1.10.10.41-FF-000009', NULL, NULL, 23, NULL, NULL, 114492),
(114493, '1.10.1270.20-FF-000004', NULL, 'tRNA (guanine-N(1)-)-methyltransferase', 63, NULL, NULL, 114493),
(114494, '1.10.8.530-FF-000013', NULL, 'DNA polymerase alpha subunit B', 78, NULL, NULL, 114494),
(114495, '1.20.1110.10-FF-000016', NULL, 'Calcium-transporting ATPase', 383, NULL, NULL, 114495),
(114496, '1.20.120.790-FF-000014', NULL, 'Heat shock protein', 142, NULL, NULL, 114496),
(114497, '3.40.50.2300-FF-000074', NULL, 'Fis family transcriptional regulator', 121, NULL, NULL, 114497),
(114498, '3.30.160.60-FF-004847', NULL, NULL, 42, NULL, NULL, 114498),
(114499, '3.30.70.2200-FF-000001', NULL, 'tRNA(Ile2) 2-agmatinylcytidine synthetase TiaS', 153, NULL, NULL, 114499),
(114500, '1.10.10.10-FF-001764', NULL, 'DNA directed RNA polymeras-like protein III subunit Rpc82', 89, NULL, NULL, 114500),
(114501, '3.30.160.60-FF-003234', NULL, 'GM13094', 27, NULL, NULL, 114501),
(114502, '3.40.50.720-FF-000533', NULL, '6-phosphogluconate dehydrogenase, decarboxylating', 186, NULL, NULL, 114502),
(114503, '2.170.260.10-FF-000011', NULL, 'Endoribonuclease Dicer-like 2 isoform B', 127, NULL, NULL, 114503),
(114504, '3.30.160.60-FF-000828', NULL, 'Zinc finger protein, FOG family member 1', 86, NULL, NULL, 114504),
(114505, '1.20.58.1370-FF-000007', NULL, NULL, 69, NULL, NULL, 114505),
(114506, '1.10.357.10-FF-000058', NULL, 'Probable transcriptional regulator', 190, NULL, NULL, 114506),
(114507, '3.80.10.10-FF-003297', NULL, 'Si:zfos-364h11.2', 212, NULL, NULL, 114507),
(114508, '3.30.450.350-FF-000003', NULL, 'Histidine kinase', 216, NULL, NULL, 114508),
(114509, '3.40.50.10490-FF-000085', NULL, 'Glucose-6-phosphate isomerase', 270, NULL, NULL, 114509);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(114510, '1.50.10.10-FF-000099', NULL, 'Cellulose 1,4-beta-cellobiosidase', 422, NULL, NULL, 114510),
(114511, '2.130.10.10-FF-001200', NULL, 'Cleavage stimulation factor subunit 1', 161, NULL, NULL, 114511),
(114512, '2.20.100.10-FF-000193', NULL, 'Uncharacterized protein', 51, NULL, NULL, 114512),
(114513, '1.20.5.220-FF-000002', NULL, 'gem-associated protein 2', 17, NULL, NULL, 114513),
(114514, '1.20.1070.10-FF-001361', NULL, 'Uncharacterized protein', 263, NULL, NULL, 114514),
(114515, '1.20.1730.10-FF-000080', NULL, 'Uncharacterized protein', 515, NULL, NULL, 114515),
(114516, '2.60.120.260-FF-000295', NULL, 'Uncharacterized protein', 110, NULL, NULL, 114516),
(114517, '3.40.50.300-FF-000981', NULL, 'ADP-ribosylation factor-like 2', 176, NULL, NULL, 114517),
(114518, '3.20.20.300-FF-000024', NULL, 'Beta-glucosidase', 333, NULL, NULL, 114518),
(114519, '3.40.50.1820-FF-001666', NULL, 'Uncharacterized protein', 272, NULL, NULL, 114519),
(114520, '2.40.50.140-FF-000661', NULL, NULL, 62, NULL, NULL, 114520),
(114521, '3.30.1540.10-FF-000005', NULL, 'succinate--hydroxymethylglutarate CoA-transferase isoform X4', 92, NULL, NULL, 114521),
(114522, '1.20.120.1080-FF-000069', NULL, 'Helicase, putative', 106, NULL, NULL, 114522),
(114523, '3.50.50.60-FF-000909', NULL, 'FAD/NAD(P)-binding domain-containing protein', 459, NULL, NULL, 114523),
(114524, '2.60.40.60-FF-000006', NULL, 'Protocadherin alpha 2', 107, NULL, NULL, 114524),
(114525, '2.60.120.650-FF-000209', NULL, 'Uncharacterized protein', 92, NULL, NULL, 114525),
(114526, '3.10.450.60-FF-000001', NULL, 'arachidonate 12-lipoxygenase, 12R-type', 115, NULL, NULL, 114526),
(114527, '2.60.120.470-FF-000004', NULL, 'PITH domain-containing protein 1', 121, NULL, NULL, 114527),
(114528, '3.40.250.10-FF-000223', NULL, 'Putative thiosulfate sulfurtransferase, mitochondrial', 122, NULL, NULL, 114528),
(114529, '3.30.70.330-FF-001176', NULL, 'Nuclear localization sequence binding protein', 160, NULL, NULL, 114529),
(114530, '1.20.5.170-FF-000184', NULL, 'Stress activated transcription factor atfs-1', 60, NULL, NULL, 114530),
(114531, '1.10.533.10-FF-000260', NULL, 'Uncharacterized protein', 68, NULL, NULL, 114531),
(114532, '2.30.30.30-FF-000127', NULL, 'Putative 60S ribosomal protein L14', 44, NULL, NULL, 114532),
(114533, '3.90.1580.10-FF-000005', NULL, 'Formylglycine-generating enzyme family protein', 296, NULL, NULL, 114533),
(114534, '2.30.39.10-FF-000113', NULL, 'Serpin peptidase inhibitor 8', 156, NULL, NULL, 114534),
(114535, '3.30.540.10-FF-000028', NULL, '3''(2''),5''-bisphosphate nucleotidase CysQ', 141, NULL, NULL, 114535),
(114536, '1.10.10.140-FF-000006', NULL, 'Cytochrome C oxidase subunit VI', 74, NULL, NULL, 114536),
(114537, '3.30.540.30-FF-000023', NULL, 'Dipeptidyl peptidase 3', 85, NULL, NULL, 114537),
(114538, '3.30.420.10-FF-000429', NULL, NULL, 109, NULL, NULL, 114538),
(114539, '3.40.50.2300-FF-000849', NULL, 'Pheromone and odorant receptor, putative', 279, NULL, NULL, 114539),
(114540, '3.40.50.1820-FF-000576', NULL, 'PPE family protein', 206, NULL, NULL, 114540),
(114541, '3.90.25.10-FF-000008', NULL, 'GDP-mannose 4,6 dehydratase', 81, NULL, NULL, 114541),
(114542, '2.110.10.10-FF-000077', NULL, 'Predicted protein', 74, NULL, NULL, 114542),
(114543, '2.40.128.20-FF-000069', NULL, 'Uncharacterized protein', 171, NULL, NULL, 114543),
(114544, '3.80.10.10-FF-000424', NULL, 'Volume-regulated anion channel subunit LRRC8E', 156, NULL, NULL, 114544),
(114545, '1.20.5.4010-FF-000002', NULL, 'Held out wings, isoform D', 60, NULL, NULL, 114545),
(114546, '2.40.50.140-FF-000329', NULL, '26S protease subunit component', 141, NULL, NULL, 114546),
(114547, '3.40.50.450-FF-000104', NULL, 'ATP-dependent 6-phosphofructokinase 3', 69, NULL, NULL, 114547),
(114548, '1.25.40.20-FF-001409', NULL, 'Uncharacterized protein', 137, NULL, NULL, 114548),
(114549, '3.30.559.10-FF-000178', NULL, 'Ferricrocin synthetase (Nonribosomal peptide siderophore synthase ) (Eurofung)', 103, NULL, NULL, 114549),
(114550, '1.20.1050.130-FF-000010', NULL, 'probable elongation factor 1-beta', 70, NULL, NULL, 114550);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(114551, '1.25.40.10-FF-004953', NULL, 'Uncharacterized protein', 167, NULL, NULL, 114551),
(114552, '1.10.10.10-FF-001399', NULL, 'LuxR family transcriptional regulator', 88, NULL, NULL, 114552),
(114553, '3.90.660.10-FF-000080', NULL, NULL, 104, NULL, NULL, 114553),
(114554, '3.90.320.10-FF-000043', NULL, 'Exodeoxyribonuclease V beta chain', 281, NULL, NULL, 114554),
(114555, '1.10.287.70-FF-000418', NULL, 'Novel protein similar to human voltage-gated L-type calcium channel subunit (Isl)', 82, NULL, NULL, 114555),
(114556, '1.50.10.20-FF-000091', NULL, 'Terpene cyclase/mutase family member', 260, NULL, NULL, 114556),
(114557, '1.10.472.80-FF-000138', NULL, 'TBC1 domain family member', 145, NULL, NULL, 114557),
(114558, '3.90.550.50-FF-000196', NULL, 'Hexosyltransferase', 191, NULL, NULL, 114558),
(114559, '3.40.50.620-FF-000273', NULL, 'Universal stress protein Rv3134c', 108, NULL, NULL, 114559),
(114560, '2.30.30.190-FF-000005', NULL, 'CAP-Gly domain containing linker protein 3', 99, NULL, NULL, 114560),
(114561, '3.30.420.10-FF-000738', NULL, NULL, 174, NULL, NULL, 114561),
(114562, '2.40.50.140-FF-001257', NULL, NULL, 65, NULL, NULL, 114562),
(114563, '3.40.190.10-FF-000021', NULL, 'DNA-binding transcriptional regulator OxyR', 94, NULL, NULL, 114563),
(114564, '3.80.20.20-FF-000001', NULL, 'Tyrosine-protein kinase receptor', 167, NULL, NULL, 114564),
(114565, '3.30.710.10-FF-000373', NULL, 'BTB (POZ) domain-containing 2', 114, NULL, NULL, 114565),
(114566, '1.10.10.820-FF-000036', NULL, 'Myh9 protein', 26, NULL, NULL, 114566),
(114567, '3.30.160.60-FF-004870', NULL, NULL, 33, NULL, NULL, 114567),
(114568, '3.30.40.10-FF-001614', NULL, 'Pre-mRNA-splicing factor CWC24', 52, NULL, NULL, 114568),
(114569, '3.30.2350.10-FF-000092', NULL, 'Uncharacterized protein', 46, NULL, NULL, 114569),
(114570, '3.40.1810.10-FF-000035', NULL, 'MADS-box transcription factor 13', 84, NULL, NULL, 114570),
(114571, '3.30.750.24-FF-000029', NULL, 'Anti-sigma factor antagonist', 115, NULL, NULL, 114571),
(114572, '3.40.50.20-FF-000055', NULL, 'Glutamate--LysW ligase ArgX', 101, NULL, NULL, 114572),
(114573, '3.40.1190.20-FF-000046', NULL, 'Adenosine kinase', 324, NULL, NULL, 114573),
(114574, '2.30.30.140-FF-000053', NULL, 'tudor domain-containing protein 7 isoform X2', 68, NULL, NULL, 114574),
(114575, '2.60.120.200-FF-000098', NULL, 'Laminin subunit alpha 1', 183, NULL, NULL, 114575),
(114576, '2.60.120.200-FF-000283', NULL, 'Adhesion G protein-coupled receptor G6', 198, NULL, NULL, 114576),
(114577, '3.90.550.20-FF-000001', NULL, 'MIPC synthase subunit (SurA)', 215, NULL, NULL, 114577),
(114578, '3.40.30.10-FF-001271', NULL, 'Calsequestrin', 64, NULL, NULL, 114578),
(114579, '1.10.8.50-FF-000016', NULL, 'Type 2 DNA topoisomerase 6 subunit B', 77, NULL, NULL, 114579),
(114580, '3.90.70.10-FF-000315', NULL, 'Uncharacterized protein', 310, NULL, NULL, 114580),
(114581, '1.25.40.10-FF-005353', NULL, 'Pentatricopeptide repeat-containing protein 10, chloroplastic', 122, NULL, NULL, 114581),
(114582, '1.10.357.150-FF-000009', NULL, 'Uncharacterized protein', 197, NULL, NULL, 114582),
(114583, '1.20.1250.20-FF-000855', NULL, 'Blast:Membrane-associated transporter protein', 207, NULL, NULL, 114583),
(114584, '3.40.20.10-FF-000129', NULL, 'Cofilin-1A', 137, NULL, NULL, 114584),
(114585, '3.30.160.60-FF-003919', NULL, NULL, 35, NULL, NULL, 114585),
(114586, '3.80.10.10-FF-001352', NULL, 'F-box/LRR-repeat protein 5', 117, NULL, NULL, 114586),
(114587, '3.30.40.10-FF-001980', NULL, 'Uncharacterized RING finger protein C16G5.03', 61, NULL, NULL, 114587),
(114588, '3.40.50.300-FF-000054', NULL, 'ABC multidrug transporter atrF', 237, NULL, NULL, 114588),
(114589, '1.10.238.10-FF-000658', NULL, 'Calmodulin-like protein, putative', 65, NULL, NULL, 114589),
(114590, '3.40.50.300-FF-004016', NULL, 'Os05g0150600 protein', 173, NULL, NULL, 114590),
(114591, '3.30.70.100-FF-000163', NULL, NULL, 108, NULL, NULL, 114591),
(114592, '1.20.120.360-FF-000003', NULL, 'Axin interactor, dorsalization-associated protein', 48, NULL, NULL, 114592);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(114593, '3.90.150.10-FF-000007', NULL, 'Variant surface glycoprotein (VSG), putative', 190, NULL, NULL, 114593),
(114594, '1.10.510.10-FF-000235', NULL, 'Serine/threonine-protein kinase ark1', 273, NULL, NULL, 114594),
(114595, '3.40.50.10990-FF-000015', NULL, 'Uncharacterized protein', 111, NULL, NULL, 114595),
(114596, '3.30.230.10-FF-000038', NULL, 'Galactokinase', 202, NULL, NULL, 114596),
(114597, '1.50.10.160-FF-000020', NULL, 'Putative geranyllinalool synthase', 21, NULL, NULL, 114597),
(114598, '2.40.50.140-FF-001038', NULL, NULL, 135, NULL, NULL, 114598),
(114599, '3.40.50.300-FF-003179', NULL, 'Dynein heavy chain 6, axonemal', 328, NULL, NULL, 114599),
(114600, '1.20.5.650-FF-000013', NULL, NULL, 47, NULL, NULL, 114600),
(114601, '3.30.300.30-FF-000005', NULL, 'Acyl-coenzyme A synthetase ACSM5, mitochondrial', 106, NULL, NULL, 114601),
(114602, '1.20.120.350-FF-000124', NULL, 'Four domain-type voltage-gated ion channel alpha-1 subunit', 138, NULL, NULL, 114602),
(114603, '2.60.40.60-FF-000933', NULL, 'Uncharacterized protein', 110, NULL, NULL, 114603),
(114604, '2.40.150.20-FF-000031', NULL, 'Protein 23 of the large ribosomal subunit', 139, NULL, NULL, 114604),
(114605, '3.40.50.300-FF-007198', NULL, 'Uncharacterized protein', 168, NULL, NULL, 114605),
(114606, '2.40.50.140-FF-000638', NULL, NULL, 104, NULL, NULL, 114606),
(114607, '1.20.1640.10-FF-000101', NULL, NULL, 162, NULL, NULL, 114607),
(114608, '2.60.40.1390-FF-000021', NULL, 'Uncharacterized protein', 128, NULL, NULL, 114608),
(114609, '1.10.555.10-FF-000108', NULL, 'Rho GTPase Activating protein', 213, NULL, NULL, 114609),
(114610, '1.10.287.70-FF-000603', NULL, 'Uncharacterized protein', 84, NULL, NULL, 114610),
(114611, '2.60.40.630-FF-000009', NULL, 'Signal transducer and activator of transcription', 109, NULL, NULL, 114611),
(114612, '1.20.5.170-FF-000037', NULL, 'cyclic AMP-responsive element-binding protein 3-like protein 2', 43, NULL, NULL, 114612),
(114613, '1.10.150.50-FF-000028', NULL, 'caskin-2 isoform X2', 67, NULL, NULL, 114613),
(114614, '3.80.10.10-FF-001043', NULL, 'Leucine-rich repeat-containing protein', 196, NULL, NULL, 114614),
(114615, '4.10.400.10-FF-000081', NULL, 'Low-density lipoprotein receptor-related protein 1B', 41, NULL, NULL, 114615),
(114616, '3.80.10.10-FF-004477', NULL, 'Leucine-rich repeat protein kinase family protein', 179, NULL, NULL, 114616),
(114617, '3.30.40.10-FF-002233', NULL, 'Uncharacterized protein', 65, NULL, NULL, 114617),
(114618, '2.60.40.60-FF-000225', NULL, 'Dachsous cadherin-related 1', 102, NULL, NULL, 114618),
(114619, '3.30.160.60-FF-004162', NULL, NULL, 78, NULL, NULL, 114619),
(114620, '3.90.180.10-FF-000054', NULL, 'Probable NADPH quinone oxidoreductase fadB4', 134, NULL, NULL, 114620),
(114621, '3.40.50.620-FF-000487', NULL, 'Leucyl-tRNA synthetase b', 250, NULL, NULL, 114621),
(114622, '3.30.40.10-FF-000996', NULL, 'Os05g0476901 protein', 80, NULL, NULL, 114622),
(114623, '1.25.40.20-FF-001556', NULL, 'Uncharacterized protein', 103, NULL, NULL, 114623),
(114624, '2.30.29.170-FF-000014', NULL, 'Putative DUF1126 protein/EF-hand domain pair, putative', 145, NULL, NULL, 114624),
(114625, '2.130.10.10-FF-003673', NULL, 'Transducin/WD40 repeat-like superfamily protein', 212, NULL, NULL, 114625),
(114626, '3.40.225.10-FF-000024', NULL, 'Class II aldolase/adducin family protein', 206, NULL, NULL, 114626),
(114627, '3.40.50.300-FF-007074', NULL, 'Uncharacterized protein', 193, NULL, NULL, 114627),
(114628, '2.10.25.10-FF-000537', NULL, 'Notch 3', 38, NULL, NULL, 114628),
(114629, '1.10.10.1020-FF-000001', NULL, 'RecBCD enzyme subunit RecD', 110, NULL, NULL, 114629),
(114630, '3.10.25.10-FF-000012', NULL, 'Methionyl-tRNA formyltransferase', 105, NULL, NULL, 114630),
(114631, '2.60.120.650-FF-000086', NULL, 'CXXC finger protein 1', 129, NULL, NULL, 114631),
(114632, '3.40.50.300-FF-002779', NULL, 'Uncharacterized protein Rv1278', 329, NULL, NULL, 114632),
(114633, '3.30.230.10-FF-000347', NULL, 'Uncharacterized protein', 16, NULL, NULL, 114633),
(114634, '1.10.10.10-FF-002017', NULL, 'Uncharacterized protein', 110, NULL, NULL, 114634);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(114635, '1.10.287.70-FF-000261', NULL, 'Outward-rectifier potassium channel TOK1', 122, NULL, NULL, 114635),
(114636, '3.10.20.90-FF-000929', NULL, 'Uncharacterized protein', 81, NULL, NULL, 114636),
(114637, '1.10.260.30-FF-000013', NULL, 'Signal recognition particle 54 kDa protein', 132, NULL, NULL, 114637),
(114638, '3.30.710.10-FF-000064', NULL, 'Ankyrin repeat and BTB/POZ domain-containing protein 1', 144, NULL, NULL, 114638),
(114639, '3.40.390.10-FF-000025', NULL, 'endothelin-converting enzyme-like 1 isoform X1', 304, NULL, NULL, 114639),
(114640, '3.40.1000.10-FF-000024', NULL, 'Putative secreted protein', 141, NULL, NULL, 114640),
(114641, '3.30.160.60-FF-002161', NULL, 'Uncharacterized protein, isoform A', 25, NULL, NULL, 114641),
(114642, '3.30.420.10-FF-000418', NULL, NULL, 162, NULL, NULL, 114642),
(114643, '2.60.40.10-FF-001104', NULL, 'Heparan sulfate proteoglycan 2', 89, NULL, NULL, 114643),
(114644, '1.10.246.140-FF-000004', NULL, 'Transcription and mRNA export factor SUS1', 96, NULL, NULL, 114644),
(114645, '1.50.10.10-FF-000234', NULL, 'alpha-1,2-Mannosidase', 142, NULL, NULL, 114645),
(114646, '3.40.30.10-FF-000085', NULL, 'Selenoprotein T', 49, NULL, NULL, 114646),
(114647, '2.60.40.150-FF-000601', NULL, 'Phosphatidylinositol 3-kinase vps34', 144, NULL, NULL, 114647),
(114648, '2.40.50.140-FF-000189', NULL, 'Polyribonucleotide nucleotidyltransferase, putative', 74, NULL, NULL, 114648),
(114649, '1.25.40.20-FF-000353', NULL, 'Bromodomain protein 1', 159, NULL, NULL, 114649),
(114650, '1.10.510.10-FF-000022', NULL, 'Serine/threonine-protein kinase 24', 202, NULL, NULL, 114650),
(114651, '2.40.37.10-FF-000069', NULL, NULL, 144, NULL, NULL, 114651),
(114652, '2.130.10.10-FF-001649', NULL, 'WD repeat domain 59', 76, NULL, NULL, 114652),
(114653, '1.25.40.10-FF-000928', NULL, 'Tetratricopeptide repeat domain 7B', 149, NULL, NULL, 114653),
(114654, '1.10.630.10-FF-000070', NULL, 'cytochrome P450 18a1', 474, NULL, NULL, 114654),
(114655, '3.20.200.10-FF-000011', NULL, 'Uncharacterized protein', 103, NULL, NULL, 114655),
(114656, '3.20.20.70-FF-000619', NULL, NULL, 305, NULL, NULL, 114656),
(114657, '2.40.160.120-FF-000024', NULL, 'Oxysterol-binding protein', 172, NULL, NULL, 114657),
(114658, '1.25.40.20-FF-001876', NULL, 'Testis expressed 14, intercellular bridge forming factor', 126, NULL, NULL, 114658),
(114659, '3.20.20.140-FF-000268', NULL, 'Ribonuclease P protein subunit drpp30', 204, NULL, NULL, 114659),
(114660, '3.40.50.1820-FF-001413', NULL, 'Uncharacterized protein C959.06c', 202, NULL, NULL, 114660),
(114661, '1.10.510.10-FF-003248', NULL, NULL, 115, NULL, NULL, 114661),
(114662, '1.10.510.10-FF-002629', NULL, NULL, 58, NULL, NULL, 114662),
(114663, '3.40.850.10-FF-000061', NULL, 'Kinesin-like protein', 370, NULL, NULL, 114663),
(114664, '3.50.50.60-FF-000769', NULL, 'Sarcosine dehydrogenase', 92, NULL, NULL, 114664),
(114665, '3.30.1490.430-FF-000005', NULL, 'Uncharacterized protein', 25, NULL, NULL, 114665),
(114666, '1.25.40.10-FF-002492', NULL, 'Putative pentatricopeptide repeat-containing protein At1g77010, mitochondrial', 81, NULL, NULL, 114666),
(114667, '3.30.200.20-FF-002344', NULL, 'Uncharacterized protein', 57, NULL, NULL, 114667),
(114668, '1.20.1070.10-FF-000439', NULL, 'Neuropeptide receptor 18', 350, NULL, NULL, 114668),
(114669, '2.60.120.10-FF-000437', NULL, 'Uncharacterized NTE family protein M110.7', 118, NULL, NULL, 114669),
(114670, '1.10.1300.10-FF-000033', NULL, 'Putative cAMP-specific phosphodiesterase', 365, NULL, NULL, 114670),
(114671, '1.25.40.10-FF-005246', NULL, 'Serine/threonine-protein kinase', 166, NULL, NULL, 114671),
(114672, '1.25.10.10-FF-001366', NULL, 'Uncharacterized protein', 178, NULL, NULL, 114672),
(114673, '1.20.58.760-FF-000023', NULL, 'Uncharacterized protein', 187, NULL, NULL, 114673),
(114674, '3.20.20.80-FF-000527', NULL, 'Chitinase domain containing 1', 188, NULL, NULL, 114674),
(114675, '1.20.1280.50-FF-000006', NULL, 'Transport inhibitor response 1', 41, NULL, NULL, 114675),
(114676, '2.40.30.10-FF-000469', NULL, 'Uncharacterized protein', 76, NULL, NULL, 114676);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(114677, '2.60.120.200-FF-000423', NULL, 'Carbonic anhydrase VI', 198, NULL, NULL, 114677),
(114678, '3.40.50.10190-FF-000118', NULL, 'DNA topoisomerase 2-binding protein 1-A-like Protein', 100, NULL, NULL, 114678),
(114679, '3.40.50.1010-FF-000092', NULL, 'Ribonuclease VapC', 140, NULL, NULL, 114679),
(114680, '3.40.50.1000-FF-000667', NULL, NULL, 203, NULL, NULL, 114680),
(114681, '2.60.120.330-FF-000007', NULL, 'Protein DMR6-like oxygenase 2', 326, NULL, NULL, 114681),
(114682, '3.40.50.720-FF-001141', NULL, 'GDP-6-deoxy-D-mannose reductase', 207, NULL, NULL, 114682),
(114683, '3.40.50.300-FF-003712', NULL, 'ATP-binding cassette efflux transporter', 83, NULL, NULL, 114683),
(114684, '1.20.90.10-FF-000026', NULL, NULL, 52, NULL, NULL, 114684),
(114685, '1.10.287.110-FF-000386', NULL, 'Uncharacterized protein', 88, NULL, NULL, 114685),
(114686, '3.40.190.10-FF-000818', NULL, 'Transcriptional regulator MetR', 105, NULL, NULL, 114686),
(114687, '3.90.850.10-FF-000044', NULL, NULL, 185, NULL, NULL, 114687),
(114688, '1.10.10.10-FF-000679', NULL, 'Forkhead transcription factor 3 (Freac-3), putative', 95, NULL, NULL, 114688),
(114689, '2.60.40.10-FF-000587', NULL, 'Immunoglobulin like domain containing receptor 1', 119, NULL, NULL, 114689),
(114690, '3.40.50.300-FF-001363', NULL, 'ATP-dependent DNA helicase RecQ', 199, NULL, NULL, 114690),
(114691, '1.10.287.70-FF-000053', NULL, 'Voltage-dependent T-type calcium channel subunit alpha', 147, NULL, NULL, 114691),
(114692, '3.40.1550.20-FF-000006', NULL, 'Transcriptional regulator MraZ', 145, NULL, NULL, 114692),
(114693, '2.10.90.10-FF-000171', NULL, 'Transforming growth factor beta', 76, NULL, NULL, 114693),
(114694, '2.10.110.10-FF-000268', NULL, 'Ttx-3', 69, NULL, NULL, 114694),
(114695, '3.40.50.300-FF-006938', NULL, 'Branched-chain amino acid ABC transporter, ATP-binding protein', 228, NULL, NULL, 114695),
(114696, '3.80.10.10-FF-000531', NULL, 'Slit guidance ligand 3', 68, NULL, NULL, 114696),
(114697, '3.40.50.410-FF-000098', NULL, 'Copine-5', 201, NULL, NULL, 114697),
(114698, '3.10.28.10-FF-000069', NULL, 'Uncharacterized protein', 105, NULL, NULL, 114698),
(114699, '2.130.10.10-FF-002268', NULL, 'U3 small nucleolar RNA interacting protein, putative', 298, NULL, NULL, 114699),
(114700, '2.130.10.10-FF-003206', NULL, 'Flagellar associated protein', 86, NULL, NULL, 114700),
(114701, '3.90.1030.20-FF-000006', NULL, 'DNA polymerase delta subunit 3', 137, NULL, NULL, 114701),
(114702, '3.30.470.20-FF-000019', NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', 203, NULL, NULL, 114702),
(114703, '3.30.160.60-FF-001981', NULL, 'Zinc finger protein 425', 27, NULL, NULL, 114703),
(114704, '3.40.33.10-FF-000119', NULL, 'Vap-1', 192, NULL, NULL, 114704),
(114705, '3.40.50.2000-FF-000287', NULL, 'UDP-glycosyltransferase 74D1', 248, NULL, NULL, 114705),
(114706, '1.10.3060.10-FF-000008', NULL, 'Protein translocase subunit SecA', 120, NULL, NULL, 114706),
(114707, '3.40.630.30-FF-000168', NULL, 'Spermidine/spermine N1-acetyltransferase 1a, duplicate 1', 103, NULL, NULL, 114707),
(114708, '3.40.50.150-FF-000891', NULL, NULL, 140, NULL, NULL, 114708),
(114709, '2.60.40.10-FF-003572', NULL, NULL, 94, NULL, NULL, 114709),
(114710, '3.30.160.60-FF-004398', NULL, NULL, 56, NULL, NULL, 114710),
(114711, '3.30.450.20-FF-000350', NULL, 'GGDEF domain-containing protein', 87, NULL, NULL, 114711),
(114712, '1.25.40.10-FF-003430', NULL, 'Pentatricopeptide repeat-containing protein', 166, NULL, NULL, 114712),
(114713, '2.40.70.10-FF-000578', NULL, NULL, 50, NULL, NULL, 114713),
(114714, '3.30.70.330-FF-001283', NULL, 'Polyadenylate-binding protein, putative', 88, NULL, NULL, 114714),
(114715, '1.20.58.390-FF-000215', NULL, 'Nicotinic acetylcholine receptor subunit', 75, NULL, NULL, 114715),
(114716, '3.80.10.10-FF-004230', NULL, 'Uncharacterized protein', 80, NULL, NULL, 114716),
(114717, '3.30.1360.210-FF-000012', NULL, '60S ribosomal protein L22-1, putative', 105, NULL, NULL, 114717),
(114718, '3.80.10.10-FF-002768', NULL, 'Predicted protein', 100, NULL, NULL, 114718);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(114719, '3.50.50.60-FF-000870', NULL, 'Digeranylgeranylglycerophospholipid reductase 1 protein', 397, NULL, NULL, 114719),
(114720, '3.40.50.1100-FF-000242', NULL, 'Si:ch73-263o4.3', 44, NULL, NULL, 114720),
(114721, '3.90.226.10-FF-000189', NULL, 'methylglutaconyl-CoA hydratase, mitochondrial-like', 211, NULL, NULL, 114721),
(114722, '1.25.40.10-FF-000024', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 251, NULL, NULL, 114722),
(114723, '1.20.1250.20-FF-001260', NULL, 'GD18866', 392, NULL, NULL, 114723),
(114724, '1.10.3780.10-FF-000001', NULL, 'Starch-binding outer membrane lipoprotein SusD', 105, NULL, NULL, 114724),
(114725, '3.40.50.300-FF-007883', NULL, 'Uncharacterized protein', 308, NULL, NULL, 114725),
(114726, '3.40.50.300-FF-000857', NULL, 'GTP-binding protein 8 isoform X1', 194, NULL, NULL, 114726),
(114727, '1.20.920.10-FF-000129', NULL, 'Bromodomain and WD repeat-containing protein 3-like Protein', 126, NULL, NULL, 114727),
(114728, '3.80.10.10-FF-001728', NULL, 'Component of U2 snRNP, putative', 161, NULL, NULL, 114728),
(114729, '3.30.70.270-FF-000152', NULL, 'Uncharacterized protein', 101, NULL, NULL, 114729),
(114730, '3.30.160.60-FF-005819', NULL, NULL, 36, NULL, NULL, 114730),
(114731, '3.90.70.10-FF-000675', NULL, 'Uncharacterized protein', 275, NULL, NULL, 114731),
(114732, '4.10.410.10-FF-000019', NULL, 'collagen alpha-1(VII) chain', 62, NULL, NULL, 114732),
(114733, '2.60.40.10-FF-001093', NULL, 'Interleukin 20 receptor subunit beta', 86, NULL, NULL, 114733),
(114734, '3.40.50.10260-FF-000038', NULL, 'YjeF N-terminal domain containing 3', 162, NULL, NULL, 114734),
(114735, '2.30.40.10-FF-000066', NULL, 'Periplasmic amidohydrolase family protein', 64, NULL, NULL, 114735),
(114736, '2.30.180.10-FF-000009', NULL, 'Fasciclin-like arabinogalactan protein 11', 161, NULL, NULL, 114736),
(114737, '3.10.290.10-FF-000013', NULL, 'Ribosome-associated protein YbcJ', 70, NULL, NULL, 114737),
(114738, '1.20.1250.20-FF-000754', NULL, 'Solute carrier organic anion transporter family member', 380, NULL, NULL, 114738),
(114739, '3.40.50.620-FF-000043', NULL, 'Phosphoadenosine phosphosulfate reductase', 215, NULL, NULL, 114739),
(114740, '2.30.42.10-FF-000098', NULL, 'regulator of G-protein signaling 3 isoform X1', 91, NULL, NULL, 114740),
(114741, '3.20.20.100-FF-000155', NULL, 'Predicted protein', 258, NULL, NULL, 114741),
(114742, '1.25.40.90-FF-000121', NULL, 'Uncharacterized protein', 76, NULL, NULL, 114742),
(114743, '1.20.1330.10-FF-000004', NULL, 'Flagellin', 99, NULL, NULL, 114743),
(114744, '3.10.350.10-FF-000052', NULL, 'Peptidase, M23/M37 family', 44, NULL, NULL, 114744),
(114745, '2.10.70.10-FF-000057', NULL, 'Pappalysin 1', 62, NULL, NULL, 114745),
(114746, '1.25.40.10-FF-001194', NULL, 'Os06g0143500 protein', 60, NULL, NULL, 114746),
(114747, '2.20.28.10-FF-000043', NULL, 'DNA helicase', 63, NULL, NULL, 114747),
(114748, '3.40.50.10860-FF-000010', NULL, 'Leucine dehydrogenase', 139, NULL, NULL, 114748),
(114749, '3.30.450.20-FF-000119', NULL, 'Serine threonine protein kinase', 107, NULL, NULL, 114749),
(114750, '1.20.1440.80-FF-000005', NULL, 'Gap junction protein', 221, NULL, NULL, 114750),
(114751, '1.10.196.10-FF-000009', NULL, 'Regulator of G-protein signaling 1', 47, NULL, NULL, 114751),
(114752, '2.20.100.10-FF-000176', NULL, 'LOC100158609 protein', 51, NULL, NULL, 114752),
(114753, '3.90.1410.10-FF-000100', NULL, 'Ribosomal lysine N-methyltransferase 4', 230, NULL, NULL, 114753),
(114754, '3.30.810.10-FF-000004', NULL, 'Phosphatidylinositol 5-phosphate 4-kinase type-2 beta', 115, NULL, NULL, 114754),
(114755, '6.10.140.2220-FF-000030', NULL, 'histone-lysine N-methyltransferase SMYD3', 48, NULL, NULL, 114755),
(114756, '2.130.10.10-FF-004151', NULL, 'Uncharacterized protein', 177, NULL, NULL, 114756),
(114757, '1.10.472.10-FF-000707', NULL, 'Uncharacterized protein', 67, NULL, NULL, 114757),
(114758, '3.30.70.330-FF-000647', NULL, 'CCCH zinc finger and RRM domain protein', 96, NULL, NULL, 114758),
(114759, '1.25.10.10-FF-000747', NULL, 'Shattered', 144, NULL, NULL, 114759);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(114760, '1.10.8.270-FF-000002', NULL, 'TBC1 domain family member 9B', 102, NULL, NULL, 114760),
(114761, '3.30.1610.10-FF-000005', NULL, 'Nucleoporin autopeptidase, putative', 131, NULL, NULL, 114761),
(114762, '3.30.40.10-FF-002126', NULL, 'General transcription and DNA repair factor IIH', 79, NULL, NULL, 114762),
(114763, '3.10.20.90-FF-000025', NULL, 'Afadin, adherens junction formation factor', 90, NULL, NULL, 114763),
(114764, '1.20.1250.20-FF-000866', NULL, 'MFS multidrug transporter, putative', 199, NULL, NULL, 114764),
(114765, '3.40.50.300-FF-007091', NULL, 'Uncharacterized protein', 190, NULL, NULL, 114765),
(114766, '3.10.20.90-FF-000137', NULL, 'Fas associated factor 1', 85, NULL, NULL, 114766),
(114767, '3.30.160.60-FF-006213', NULL, NULL, 28, NULL, NULL, 114767),
(114768, '1.20.1310.20-FF-000012', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 252, NULL, NULL, 114768),
(114769, '3.60.40.10-FF-000309', NULL, 'Predicted protein', 244, NULL, NULL, 114769),
(114770, '3.40.630.10-FF-000050', NULL, 'Carboxypeptidase O', 307, NULL, NULL, 114770),
(114771, '2.160.20.70-FF-000014', NULL, 'Adenylyl cyclase-associated protein', 163, NULL, NULL, 114771),
(114772, '1.10.1040.10-FF-000097', NULL, 'Uncharacterized protein', 41, NULL, NULL, 114772),
(114773, '3.40.50.1170-FF-000010', NULL, 'Asparaginase, putative', 149, NULL, NULL, 114773),
(114774, '3.90.1150.10-FF-000276', NULL, 'PLP-dependent transferase', 129, NULL, NULL, 114774),
(114775, '3.20.20.190-FF-000030', NULL, '1-phosphatidylinositol phosphodiesterase', 298, NULL, NULL, 114775),
(114776, '2.30.42.10-FF-000469', NULL, NULL, 82, NULL, NULL, 114776),
(114777, '1.20.5.340-FF-000021', NULL, 'Myosin heavy chain, isoform G', 122, NULL, NULL, 114777),
(114778, '3.30.230.80-FF-000003', NULL, 'endoplasmin isoform X1', 167, NULL, NULL, 114778),
(114779, '3.30.160.60-FF-000132', NULL, 'PR domain zinc finger protein 1', 27, NULL, NULL, 114779),
(114780, '1.25.40.860-FF-000027', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 148, NULL, NULL, 114780),
(114781, '2.60.120.10-FF-000651', NULL, 'Probable homogentisate 1,2-dioxygenase', 142, NULL, NULL, 114781),
(114782, '1.20.58.610-FF-000006', NULL, 'Hsp90 co-chaperone Cdc37', 129, NULL, NULL, 114782),
(114783, '2.60.120.310-FF-000001', NULL, 'peptidyl-glycine alpha-amidating monooxygenase isoform X1', 156, NULL, NULL, 114783),
(114784, '2.30.42.10-FF-000109', NULL, 'partitioning defective 3 homolog isoform X9', 103, NULL, NULL, 114784),
(114785, '3.30.1360.40-FF-000005', NULL, 'DNA topoisomerase 4 subunit A', 94, NULL, NULL, 114785),
(114786, '3.20.20.100-FF-000060', NULL, 'Putative oxidoreductase', 300, NULL, NULL, 114786),
(114787, '3.40.630.30-FF-000056', NULL, 'Glycylpeptide N-tetradecanoyltransferase', 250, NULL, NULL, 114787),
(114788, '3.40.50.300-FF-007102', NULL, 'ABC transporter family protein', 187, NULL, NULL, 114788),
(114789, '3.40.640.10-FF-000247', NULL, 'Aminotransferase, class I', 260, NULL, NULL, 114789),
(114790, '2.170.30.10-FF-000002', NULL, 'Capsid protein', 508, NULL, NULL, 114790),
(114791, '3.90.550.10-FF-000111', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 265, NULL, NULL, 114791),
(114792, '3.40.250.10-FF-000083', NULL, 'MercaptoPyruvate SulfurTransferase homolog', 147, NULL, NULL, 114792),
(114793, '1.25.10.10-FF-003283', NULL, 'Serine/threonine-protein kinase TOR', 187, NULL, NULL, 114793),
(114794, '3.30.70.1350-FF-000038', NULL, NULL, 82, NULL, NULL, 114794),
(114795, '2.60.40.420-FF-000137', NULL, 'Uncharacterized protein', 124, NULL, NULL, 114795),
(114796, '3.60.10.10-FF-000341', NULL, 'Predicted protein', 211, NULL, NULL, 114796),
(114797, '3.30.160.60-FF-002953', NULL, 'Zinc finger protein 579', 29, NULL, NULL, 114797),
(114798, '3.40.50.300-FF-000065', NULL, 'Eukaryotic translation initiation factor 2 subunit gamma', 210, NULL, NULL, 114798),
(114799, '2.60.40.60-FF-000118', NULL, 'protocadherin Fat 4', 105, NULL, NULL, 114799),
(114800, '3.30.70.330-FF-000226', NULL, 'Non-POU domain-containing octamer-binding protein', 97, NULL, NULL, 114800);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(114801, '3.40.50.300-FF-004117', NULL, 'Uncharacterized protein', 95, NULL, NULL, 114801),
(114802, '3.30.160.60-FF-001542', NULL, 'zinc finger protein 3 homolog', 29, NULL, NULL, 114802),
(114803, '2.30.30.40-FF-000669', NULL, 'Predicted protein', 64, NULL, NULL, 114803),
(114804, '2.60.40.1960-FF-000001', NULL, 'Cathepsin D', 64, NULL, NULL, 114804),
(114805, '3.80.10.10-FF-000970', NULL, 'Glycoprotein hormone receptor II', 238, NULL, NULL, 114805),
(114806, '3.60.40.10-FF-000298', NULL, 'Uncharacterized protein', 300, NULL, NULL, 114806),
(114807, '3.30.200.20-FF-001725', NULL, 'Putative serine/threonine-protein kinase haspin homolog-like Protein', 136, NULL, NULL, 114807),
(114808, '3.90.79.10-FF-000195', NULL, 'NUDIX hydrolase, conserved', 233, NULL, NULL, 114808),
(114809, '3.20.20.150-FF-000046', NULL, 'Uncharacterized protein', 148, NULL, NULL, 114809),
(114810, '2.60.40.10-FF-002953', NULL, 'Complement 4B (Chido blood group)', 89, NULL, NULL, 114810),
(114811, '3.30.160.60-FF-003779', NULL, 'Fruitless', 75, NULL, NULL, 114811),
(114812, '3.40.50.1100-FF-000130', NULL, 'Cysteine synthase', 79, NULL, NULL, 114812),
(114813, '1.10.30.10-FF-000107', NULL, 'transcription factor protein', 82, NULL, NULL, 114813),
(114814, '3.40.50.80-FF-000157', NULL, 'Uncharacterized protein', 212, NULL, NULL, 114814),
(114815, '1.25.10.10-FF-003069', NULL, 'Condensin complex subunit 1', 256, NULL, NULL, 114815),
(114816, '3.40.930.10-FF-000011', NULL, 'Anion exchange protein 4', 280, NULL, NULL, 114816),
(114817, '1.20.58.390-FF-000103', NULL, 'Si:ch211-256e16.10', 108, NULL, NULL, 114817),
(114818, '2.60.40.10-FF-004639', NULL, NULL, 95, NULL, NULL, 114818),
(114819, '2.20.25.10-FF-000020', NULL, 'DNA-directed RNA polymerase subunit', 62, NULL, NULL, 114819),
(114820, '3.50.50.60-FF-001275', NULL, 'Uncharacterized protein', 69, NULL, NULL, 114820),
(114821, '3.40.50.10240-FF-000032', NULL, 'Thiamin diphosphokinase2', 214, NULL, NULL, 114821),
(114822, '3.30.40.10-FF-001300', NULL, 'YALI0E12639p', 118, NULL, NULL, 114822),
(114823, '1.10.10.1460-FF-000003', NULL, NULL, 45, NULL, NULL, 114823),
(114824, '2.60.200.40-FF-000014', NULL, 'Ceramide kinase', 223, NULL, NULL, 114824),
(114825, '1.10.10.10-FF-001635', NULL, 'Transcriptional regulator, metal-sensing', 87, NULL, NULL, 114825),
(114826, '3.30.70.330-FF-002901', NULL, NULL, 47, NULL, NULL, 114826),
(114827, '3.80.10.10-FF-002347', NULL, 'Platelet glycoprotein V', 115, NULL, NULL, 114827),
(114828, '3.30.70.660-FF-000078', NULL, 'tRNA pseudouridine synthase', 82, NULL, NULL, 114828),
(114829, '1.10.287.130-FF-000021', NULL, 'Sensor histidine kinase KdpD', 75, NULL, NULL, 114829),
(114830, '3.30.420.40-FF-000528', NULL, 'Predicted protein', 173, NULL, NULL, 114830),
(114831, '3.30.450.30-FF-000027', NULL, 'Cell polarity determinant GTPase-activating protein MglB', 134, NULL, NULL, 114831),
(114832, '3.20.70.20-FF-000018', NULL, 'Vitamin B12-dependent ribonucleotide reductase', 573, NULL, NULL, 114832),
(114833, '2.60.40.10-FF-003442', NULL, NULL, 104, NULL, NULL, 114833),
(114834, '3.90.1150.10-FF-000181', NULL, 'Aspartate aminotransferase', 92, NULL, NULL, 114834),
(114835, '3.40.50.150-FF-001279', NULL, NULL, 222, NULL, NULL, 114835),
(114836, '3.30.70.330-FF-001171', NULL, 'Zinc finger protein containing protein', 144, NULL, NULL, 114836),
(114837, '1.10.238.10-FF-001187', NULL, 'Sodium channel protein', 84, NULL, NULL, 114837),
(114838, '2.30.34.10-FF-000006', NULL, 'Major surface protease-like protein C', 93, NULL, NULL, 114838),
(114839, '2.60.120.260-FF-000290', NULL, 'Uncharacterized protein', 137, NULL, NULL, 114839),
(114840, '3.40.50.11260-FF-000029', NULL, 'Uncharacterized protein', 84, NULL, NULL, 114840),
(114841, '1.25.40.180-FF-000250', NULL, NULL, 77, NULL, NULL, 114841),
(114842, '3.40.50.300-FF-001346', NULL, 'ATP-dependent helicase', 147, NULL, NULL, 114842),
(114843, '2.120.10.80-FF-000069', NULL, 'Multiple epidermal growth factor-like domains protein 8', 132, NULL, NULL, 114843),
(114844, '2.160.20.10-FF-000154', NULL, 'Cell surface glycoprotein (S-layer protein)', 226, NULL, NULL, 114844);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(114845, '3.40.50.740-FF-000062', NULL, 'NADH-quinone oxidoreductase', 215, NULL, NULL, 114845),
(114846, '3.40.50.1000-FF-000779', NULL, NULL, 74, NULL, NULL, 114846),
(114847, '2.60.120.200-FF-000311', NULL, 'Possible beta-1,3-glucanase', 240, NULL, NULL, 114847),
(114848, '3.40.50.360-FF-000173', NULL, 'Flavodoxin', 167, NULL, NULL, 114848),
(114849, '1.10.8.10-FF-000038', NULL, 'tudor domain-containing protein 3 isoform X1', 82, NULL, NULL, 114849),
(114850, '3.20.20.190-FF-000159', NULL, NULL, 181, NULL, NULL, 114850),
(114851, '1.10.3380.10-FF-000021', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 159, NULL, NULL, 114851),
(114852, '2.30.40.10-FF-000150', NULL, 'Uncharacterized protein MJ0699', 35, NULL, NULL, 114852),
(114853, '1.25.40.10-FF-000816', NULL, 'ALBINO3-like protein 2, chloroplastic', 175, NULL, NULL, 114853),
(114854, '1.20.120.1750-FF-000085', NULL, 'RBR-type E3 ubiquitin transferase', 165, NULL, NULL, 114854),
(114855, '1.20.1070.10-FF-001496', NULL, 'Si:ch211-137j23.8', 199, NULL, NULL, 114855),
(114856, '1.10.510.10-FF-003118', NULL, NULL, 191, NULL, NULL, 114856),
(114857, '3.30.200.20-FF-001708', NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 182', 46, NULL, NULL, 114857),
(114858, '1.20.80.10-FF-000071', NULL, 'Uncharacterized protein', 116, NULL, NULL, 114858),
(114859, '2.60.40.10-FF-001216', NULL, 'Myosin binding protein C, fast type', 117, NULL, NULL, 114859),
(114860, '3.30.160.60-FF-001525', NULL, 'Tripartite motif-containing protein 35', 39, NULL, NULL, 114860),
(114861, '3.30.200.20-FF-001372', NULL, 'Serine/threonine protein kinase, putative', 85, NULL, NULL, 114861),
(114862, '1.25.40.20-FF-001764', NULL, 'Predicted protein', 192, NULL, NULL, 114862),
(114863, '1.20.890.10-FF-000002', NULL, 'cAMP-dependent protein kinase type II-alpha regulatory subunit', 43, NULL, NULL, 114863),
(114864, '1.20.120.850-FF-000049', NULL, 'Uncharacterized protein (Fragment)', 77, NULL, NULL, 114864),
(114865, '3.90.190.10-FF-000583', NULL, 'Predicted protein', 171, NULL, NULL, 114865),
(114866, '2.60.120.200-FF-000199', NULL, 'Hydroxyproline O-galactosyltransferase GALT4', 119, NULL, NULL, 114866),
(114867, '3.20.20.80-FF-000639', NULL, 'Amylo-1,6-glucosidase, 4-alpha-glucanotransferase', 106, NULL, NULL, 114867),
(114868, '3.40.50.80-FF-000174', NULL, 'Uncharacterized protein', 107, NULL, NULL, 114868),
(114869, '1.25.40.10-FF-004739', NULL, 'Predicted protein', 76, NULL, NULL, 114869),
(114870, '3.60.21.10-FF-000046', NULL, 'Metallophosphoesterase', 209, NULL, NULL, 114870),
(114871, '3.40.50.200-FF-000153', NULL, 'Proprotein convertase subtilisin/kexin type 4, furin, putative', 316, NULL, NULL, 114871),
(114872, '2.40.440.10-FF-000005', NULL, 'L,D-transpeptidase 2', 142, NULL, NULL, 114872),
(114873, '3.40.710.10-FF-000112', NULL, 'Penicillin-binding protein 1A', 432, NULL, NULL, 114873),
(114874, '3.40.850.10-FF-000173', NULL, 'Kinesin-like protein', 348, NULL, NULL, 114874),
(114875, '1.10.3380.30-FF-000027', NULL, 'Uncharacterized protein', 40, NULL, NULL, 114875),
(114876, '2.30.250.10-FF-000004', NULL, 'Probable M18 family aminopeptidase 2', 126, NULL, NULL, 114876),
(114877, '3.40.50.11530-FF-000003', NULL, 'Interleukin-17 receptor D', 165, NULL, NULL, 114877),
(114878, '3.20.20.140-FF-000156', NULL, 'Histidinol-phosphatase', 266, NULL, NULL, 114878),
(114879, '3.40.50.620-FF-000481', NULL, 'Uncharacterized protein', 114, NULL, NULL, 114879),
(114880, '1.25.40.10-FF-005358', NULL, 'Uncharacterized protein', 108, NULL, NULL, 114880),
(114881, '1.20.1560.10-FF-000286', NULL, 'Uncharacterized protein', 326, NULL, NULL, 114881),
(114882, '3.80.10.10-FF-002785', NULL, 'Uncharacterized protein', 164, NULL, NULL, 114882),
(114883, '1.20.58.60-FF-000146', NULL, 'dystrophin isoform X2', 216, NULL, NULL, 114883),
(114884, '2.60.40.10-FF-000132', NULL, 'Inositol polyphosphate 5-phosphatase OCRL-1 isoform b', 127, NULL, NULL, 114884),
(114885, '1.10.10.440-FF-000001', NULL, 'Transcription elongation regulator 1 like', 69, NULL, NULL, 114885);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(114886, '1.10.486.10-FF-000071', NULL, 'Uncharacterized protein', 37, NULL, NULL, 114886),
(114887, '3.40.50.1000-FF-000116', NULL, 'N-acylneuraminate-9-phosphatase', 142, NULL, NULL, 114887),
(114888, '3.40.50.300-FF-003600', NULL, 'Arsenical pump-driving ATPase', 180, NULL, NULL, 114888),
(114889, '2.60.120.920-FF-000201', NULL, 'Uncharacterized protein', 111, NULL, NULL, 114889),
(114890, '1.10.287.70-FF-000278', NULL, 'Cyclic Nucleotide Gated channel', 226, NULL, NULL, 114890),
(114891, '3.40.50.12710-FF-000043', NULL, 'Protein arginine methyltransferase NDUFAF7', 68, NULL, NULL, 114891),
(114892, '2.90.10.10-FF-000067', NULL, 'Uncharacterized protein', 139, NULL, NULL, 114892),
(114893, '2.60.200.20-FF-000267', NULL, 'Uncharacterized protein', 155, NULL, NULL, 114893),
(114894, '3.40.50.1100-FF-000028', NULL, 'Tryptophan synthase beta chain', 176, NULL, NULL, 114894),
(114895, '1.20.1370.10-FF-000001', NULL, 'Phenoloxidase 2', 141, NULL, NULL, 114895),
(114896, '2.60.40.10-FF-002161', NULL, 'Cilia and flagella associated protein 65', 93, NULL, NULL, 114896),
(114897, '3.30.43.10-FF-000025', NULL, 'L-gulono-1,4-lactone dehydrogenase', 67, NULL, NULL, 114897),
(114898, '3.40.640.10-FF-000359', NULL, 'Cystathionine Beta Lyase', 122, NULL, NULL, 114898),
(114899, '1.10.238.10-FF-000782', NULL, 'Uncharacterized protein', 61, NULL, NULL, 114899),
(114900, '2.170.190.11-FF-000001', NULL, 'Molybdopterin molybdenumtransferase', 98, NULL, NULL, 114900),
(114901, '1.10.3500.10-FF-000032', NULL, 'Uncharacterized protein', 159, NULL, NULL, 114901),
(114902, '3.30.200.20-FF-000427', NULL, 'Wnk protein kinase', 97, NULL, NULL, 114902),
(114903, '3.40.350.10-FF-000028', NULL, 'Aminopeptidase', 144, NULL, NULL, 114903),
(114904, '3.40.50.720-FF-002113', NULL, 'Uncharacterized protein', 117, NULL, NULL, 114904),
(114905, '3.30.160.60-FF-000244', NULL, 'zinc finger protein 423', 59, NULL, NULL, 114905),
(114906, '3.30.465.10-FF-000050', NULL, 'Membrane protein TerC', 75, NULL, NULL, 114906),
(114907, '2.130.10.10-FF-000340', NULL, 'Rho guanine nucleotide exchange factor (GEF) 10', 294, NULL, NULL, 114907),
(114908, '3.30.530.20-FF-000188', NULL, 'Predicted protein', 82, NULL, NULL, 114908),
(114909, '2.70.98.10-FF-000118', NULL, 'Xanthan lyase', 273, NULL, NULL, 114909),
(114910, '1.20.120.350-FF-000012', NULL, 'Voltage-dependent T-type calcium channel subunit alpha', 117, NULL, NULL, 114910),
(114911, '3.30.40.10-FF-002238', NULL, 'Xnf7, putative', 63, NULL, NULL, 114911),
(114912, '3.90.550.10-FF-000223', NULL, 'DUF2064 domain-containing protein', 213, NULL, NULL, 114912),
(114913, '3.40.50.300-FF-005528', NULL, 'Uncharacterized protein', 96, NULL, NULL, 114913),
(114914, '3.40.50.11950-FF-000005', NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', 121, NULL, NULL, 114914),
(114915, '1.25.40.90-FF-000104', NULL, 'Uncharacterized protein', 133, NULL, NULL, 114915),
(114916, '1.25.40.10-FF-001435', NULL, 'Pentatricopeptide repeat-containing protein', 203, NULL, NULL, 114916),
(114917, '1.25.10.10-FF-000298', NULL, 'Serum amyloid A like 1', 384, NULL, NULL, 114917),
(114918, '3.90.76.10-FF-000042', NULL, 'Oligopeptide-binding protein AppA', 120, NULL, NULL, 114918),
(114919, '3.40.50.300-FF-004005', NULL, 'GD12861', 224, NULL, NULL, 114919),
(114920, '3.40.718.10-FF-000012', NULL, 'Homoisocitrate dehydrogenase, mitochondrial', 359, NULL, NULL, 114920),
(114921, '3.30.710.10-FF-000396', NULL, 'Predicted protein', 167, NULL, NULL, 114921),
(114922, '2.30.30.40-FF-000557', NULL, 'Uncharacterized protein', 159, NULL, NULL, 114922),
(114923, '3.30.1490.480-FF-000009', NULL, 'Endolytic murein transglycosylase', 72, NULL, NULL, 114923),
(114924, '3.40.1090.10-FF-000086', NULL, 'Uncharacterized protein', 331, NULL, NULL, 114924),
(114925, '1.20.120.1880-FF-000005', NULL, 'Nuclear pore complex protein Nup155', 285, NULL, NULL, 114925),
(114926, '3.40.1110.10-FF-000145', NULL, 'Copper-transporting ATPase', 121, NULL, NULL, 114926),
(114927, '1.10.510.10-FF-001320', NULL, 'Serine/threonine protein kinase ppk15, putative', 219, NULL, NULL, 114927);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(114928, '3.40.50.300-FF-002774', NULL, 'ATP-dependent DNA helicase chl1', 262, NULL, NULL, 114928),
(114929, '2.60.120.10-FF-000084', NULL, '(S)-ureidoglycine aminohydrolase', 261, NULL, NULL, 114929),
(114930, '2.170.270.10-FF-000068', NULL, 'SET domain-containing protein', 203, NULL, NULL, 114930),
(114931, '2.30.30.490-FF-000005', NULL, 'Arginine-glutamic acid dipeptide (RE) repeats', 181, NULL, NULL, 114931),
(114932, '1.20.1560.10-FF-000735', NULL, 'Uncharacterized protein', 182, NULL, NULL, 114932),
(114933, '3.90.1800.10-FF-000023', NULL, 'DNA-directed RNA polymerase subunit beta', 33, NULL, NULL, 114933),
(114934, '2.60.40.10-FF-001655', NULL, 'Blast:Dyslexia-associated protein KIAA0319', 82, NULL, NULL, 114934),
(114935, '1.50.40.10-FF-000174', NULL, 'Mitochondrial substrate carrier family protein', 197, NULL, NULL, 114935),
(114936, '2.60.120.200-FF-000648', NULL, 'Uncharacterized protein', 102, NULL, NULL, 114936),
(114937, '2.60.40.10-FF-004982', NULL, NULL, 109, NULL, NULL, 114937),
(114938, '2.170.130.10-FF-000007', NULL, 'Fe(3+) dicitrate transport protein FecA', 127, NULL, NULL, 114938),
(114939, '2.60.40.10-FF-004061', NULL, NULL, 96, NULL, NULL, 114939),
(114940, '3.40.605.10-FF-000109', NULL, '10-formyltetrahydrofolate dehydrogenase', 232, NULL, NULL, 114940),
(114941, '3.40.630.30-FF-000409', NULL, 'Bifunctional protein NCOAT-like protein', 205, NULL, NULL, 114941),
(114942, '3.20.20.60-FF-000072', NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', 265, NULL, NULL, 114942),
(114943, '1.10.1670.40-FF-000007', NULL, 'DNA-3-methyladenine glycosylase II', 70, NULL, NULL, 114943),
(114944, '2.40.50.140-FF-000217', NULL, 'DNA damage induced apoptosis suppressor', 133, NULL, NULL, 114944),
(114945, '1.20.5.170-FF-000291', NULL, 'Protein CBG22431', 37, NULL, NULL, 114945),
(114946, '3.40.950.10-FF-000006', NULL, 'Fe-hydrogenase, putative', 201, NULL, NULL, 114946),
(114947, '3.30.420.10-FF-000632', NULL, NULL, 159, NULL, NULL, 114947),
(114948, '2.130.10.10-FF-005674', NULL, 'Uncharacterized protein', 162, NULL, NULL, 114948),
(114949, '1.20.1260.10-FF-000010', NULL, '1,2-phenylacetyl-CoA epoxidase subunit A', 309, NULL, NULL, 114949),
(114950, '3.30.50.10-FF-000058', NULL, 'Nuclear Hormone Receptor family', 104, NULL, NULL, 114950),
(114951, '1.25.40.10-FF-002941', NULL, 'Uncharacterized protein', 134, NULL, NULL, 114951),
(114952, '3.10.105.10-FF-000117', NULL, 'ABC-type dipeptide transport system, periplasmic component', 212, NULL, NULL, 114952),
(114953, '3.40.50.300-FF-004909', NULL, 'Mitochondrial escape protein 2 homolog', 199, NULL, NULL, 114953),
(114954, '1.25.40.10-FF-003913', NULL, 'LOC100001597 protein', 307, NULL, NULL, 114954),
(114955, '3.60.21.10-FF-000389', NULL, 'Uncharacterized protein', 56, NULL, NULL, 114955),
(114956, '1.25.40.10-FF-004178', NULL, 'Uncharacterized protein', 90, NULL, NULL, 114956),
(114957, '2.60.40.10-FF-005707', NULL, NULL, 51, NULL, NULL, 114957),
(114958, '4.10.280.110-FF-000014', NULL, 'Potassium channel regulatory factor', 65, NULL, NULL, 114958),
(114959, '1.10.1520.10-FF-000027', NULL, 'Ribonuclease 3', 144, NULL, NULL, 114959),
(114960, '2.130.10.10-FF-000109', NULL, 'WD repeat domain 36', 300, NULL, NULL, 114960),
(114961, '1.25.10.10-FF-002776', NULL, 'Uncharacterized protein', 574, NULL, NULL, 114961),
(114962, '3.30.450.20-FF-000007', NULL, 'Nuclear receptor coactivator', 130, NULL, NULL, 114962),
(114963, '1.10.287.1260-FF-000012', NULL, 'Mechanosensitive ion channel family protein', 116, NULL, NULL, 114963),
(114964, '2.30.30.30-FF-000099', NULL, 'Ribosomal protein L26', 133, NULL, NULL, 114964),
(114965, '3.40.50.300-FF-007445', NULL, 'Uncharacterized protein', 248, NULL, NULL, 114965),
(114966, '3.30.70.260-FF-000065', NULL, 'Phosphoserine phosphatase SerB', 93, NULL, NULL, 114966),
(114967, '3.40.1190.20-FF-000023', NULL, 'ATP-dependent (S)-NAD(P)H-hydrate dehydratase', 295, NULL, NULL, 114967),
(114968, '3.40.50.300-FF-006034', NULL, 'Uncharacterized protein', 197, NULL, NULL, 114968),
(114969, '2.30.29.30-FF-000354', NULL, 'Lnk, isoform D', 132, NULL, NULL, 114969);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(114970, '3.40.50.1110-FF-000020', NULL, 'Esterase, putative (AFU_orthologue AFUA_1G03170)', 211, NULL, NULL, 114970),
(114971, '2.10.25.10-FF-000531', NULL, 'otogelin', 64, NULL, NULL, 114971),
(114972, '1.10.555.10-FF-000232', NULL, NULL, 255, NULL, NULL, 114972),
(114973, '1.20.1050.10-FF-000073', NULL, 'Glutathione S-transferase theta-1', 141, NULL, NULL, 114973),
(114974, '3.30.1360.70-FF-000003', NULL, 'Arginine--tRNA ligase', 117, NULL, NULL, 114974),
(114975, '2.60.40.640-FF-000102', NULL, 'Protein ttm-2', 176, NULL, NULL, 114975),
(114976, '1.10.10.10-FF-001652', NULL, '26S proteasome non-ATPase regulatory subunit 12', 77, NULL, NULL, 114976),
(114977, '1.20.1070.10-FF-000877', NULL, 'Uncharacterized protein', 274, NULL, NULL, 114977),
(114978, '2.120.10.30-FF-000436', NULL, 'Sortilin', 127, NULL, NULL, 114978),
(114979, '3.20.20.80-FF-000611', NULL, 'Uncharacterized protein', 158, NULL, NULL, 114979),
(114980, '3.30.160.60-FF-002498', NULL, 'Transcription factor Ken', 26, NULL, NULL, 114980),
(114981, '3.30.70.330-FF-002564', NULL, NULL, 190, NULL, NULL, 114981),
(114982, '2.170.200.10-FF-000002', NULL, 'Regulatory protein E2', 109, NULL, NULL, 114982),
(114983, '3.90.1150.10-FF-000164', NULL, 'Ornithine--oxo-acid transaminase', 128, NULL, NULL, 114983),
(114984, '3.30.160.60-FF-003807', NULL, NULL, 24, NULL, NULL, 114984),
(114985, '2.40.30.170-FF-000076', NULL, NULL, 64, NULL, NULL, 114985),
(114986, '1.10.10.60-FF-000992', NULL, NULL, 78, NULL, NULL, 114986),
(114987, '1.10.150.50-FF-000152', NULL, 'Ephrin type-A receptor 4-B', 75, NULL, NULL, 114987),
(114988, '2.10.25.10-FF-000661', NULL, 'Basement membrane proteoglycan', 51, NULL, NULL, 114988),
(114989, '3.20.70.20-FF-000035', NULL, 'Predicted protein', 148, NULL, NULL, 114989),
(114990, '3.40.50.150-FF-001296', NULL, NULL, 215, NULL, NULL, 114990),
(114991, '1.20.5.320-FF-000026', NULL, 'Uncharacterized protein', 36, NULL, NULL, 114991),
(114992, '2.10.25.10-FF-001150', NULL, 'Wnt inhibitory factor', 30, NULL, NULL, 114992),
(114993, '2.20.110.10-FF-000002', NULL, 'Phosphatidylinositol 4-phosphate 5-kinase 8', 46, NULL, NULL, 114993),
(114994, '3.30.160.60-FF-005707', NULL, NULL, 56, NULL, NULL, 114994),
(114995, '1.25.40.10-FF-000687', NULL, 'Pentatricopeptide repeat-containing protein At4g33170', 114, NULL, NULL, 114995),
(114996, '2.40.10.10-FF-000018', NULL, 'Genome polyprotein', 42, NULL, NULL, 114996),
(114997, '3.30.40.10-FF-001058', NULL, 'Uncharacterized protein', 84, NULL, NULL, 114997),
(114998, '1.10.555.10-FF-000102', NULL, 'Rho GTPase activating protein, putative', 215, NULL, NULL, 114998),
(114999, '3.40.30.10-FF-000877', NULL, 'Uncharacterized protein', 55, NULL, NULL, 114999),
(115000, '1.20.120.1130-FF-000005', NULL, 'Vacuolar protein sorting-associated protein 28 homolog', 96, NULL, NULL, 115000),
(115001, '2.60.40.10-FF-001885', NULL, 'Neuromusculin, isoform B', 98, NULL, NULL, 115001),
(115002, '3.30.1520.10-FF-000127', NULL, 'YALI0C16412p', 121, NULL, NULL, 115002),
(115003, '3.40.140.10-FF-000203', NULL, 'COP9 signalosome complex subunit 5', 257, NULL, NULL, 115003),
(115004, '1.25.40.180-FF-000233', NULL, NULL, 239, NULL, NULL, 115004),
(115005, '1.10.8.60-FF-000137', NULL, 'AAA-type ATPase family protein / ankyrin repeat family protein', 99, NULL, NULL, 115005),
(115006, '1.10.150.50-FF-000022', NULL, 'Transcription factor CP2 like 1', 65, NULL, NULL, 115006),
(115007, '3.30.260.10-FF-000097', NULL, NULL, 19, NULL, NULL, 115007),
(115008, '3.70.10.10-FF-000037', NULL, 'Checkpoint protein', 277, NULL, NULL, 115008),
(115009, '3.40.50.1010-FF-000215', NULL, NULL, 134, NULL, NULL, 115009),
(115010, '3.30.160.20-FF-000131', NULL, 'GM23818', 79, NULL, NULL, 115010),
(115011, '2.60.40.1180-FF-000099', NULL, 'Solute carrier family 3 member 2', 85, NULL, NULL, 115011),
(115012, '2.40.50.140-FF-001162', NULL, NULL, 79, NULL, NULL, 115012),
(115013, '2.20.28.10-FF-000026', NULL, 'DNA replication licensing factor, putative', 51, NULL, NULL, 115013),
(115014, '3.40.50.300-FF-006130', NULL, 'Predicted protein', 103, NULL, NULL, 115014);
INSERT INTO "PUBLIC"."MODEL" VALUES
(115015, '3.30.420.40-FF-000966', NULL, 'DnaK protein', 101, NULL, NULL, 115015),
(115016, '1.50.10.20-FF-000012', NULL, 'Geranylgeranyl transferase type-2 subunit beta', 317, NULL, NULL, 115016),
(115017, '3.30.70.330-FF-000664', NULL, 'RNA recognition motif domain containing protein', 95, NULL, NULL, 115017),
(115018, '3.40.50.2300-FF-000630', NULL, 'Metabotropic glutamate receptor', 276, NULL, NULL, 115018),
(115019, '3.30.1120.10-FF-000035', NULL, 'N-acetylgalactosamine 6-sulfatase (GALNS)', 59, NULL, NULL, 115019),
(115020, '3.20.20.80-FF-000078', NULL, 'Endo-beta-1,4-glucanase B', 305, NULL, NULL, 115020),
(115021, '3.30.40.10-FF-000569', NULL, 'Chromatin modification-related protein', 63, NULL, NULL, 115021),
(115022, '1.10.510.10-FF-001983', NULL, 'Serine/threonine-protein kinase-like protein At1g28390', 221, NULL, NULL, 115022),
(115023, '3.90.1290.10-FF-000011', NULL, 'Short stop, isoform H', 185, NULL, NULL, 115023),
(115024, '2.20.25.30-FF-000008', NULL, 'G protein-coupled receptor', 50, NULL, NULL, 115024),
(115025, '1.20.5.340-FF-000004', NULL, 'Myosin heavy chain', 123, NULL, NULL, 115025),
(115026, '1.20.1070.10-FF-000540', NULL, 'Uncharacterized protein', 244, NULL, NULL, 115026),
(115027, '3.60.120.10-FF-000001', NULL, 'Isochorismate synthase EntC', 392, NULL, NULL, 115027),
(115028, '2.130.10.30-FF-000003', NULL, 'E3 ubiquitin-protein ligase HERC2 isoform X1', 369, NULL, NULL, 115028),
(115029, '2.10.50.10-FF-000062', NULL, 'Cysteine repeat modular protein 1', 67, NULL, NULL, 115029),
(115030, '2.60.120.10-FF-000207', NULL, 'Cyclic nucleotide binding domain protein', 129, NULL, NULL, 115030),
(115031, '3.40.190.290-FF-000097', NULL, 'Transcriptional regulator,LysR family', 195, NULL, NULL, 115031),
(115032, '3.40.390.10-FF-000255', NULL, NULL, 235, NULL, NULL, 115032),
(115033, '2.170.300.10-FF-000066', NULL, 'Uncharacterized protein', 102, NULL, NULL, 115033),
(115034, '3.30.1140.32-FF-000022', NULL, '30S ribosomal protein S3', 142, NULL, NULL, 115034),
(115035, '3.40.50.720-FF-000764', NULL, 'Possible ketoacyl reductase', 248, NULL, NULL, 115035),
(115036, '2.60.40.10-FF-000828', NULL, 'Protogenin', 106, NULL, NULL, 115036),
(115037, '1.10.630.10-FF-000418', NULL, 'Cytochrome P450 family 26 subfamily A member 1', 85, NULL, NULL, 115037),
(115038, '1.25.40.860-FF-000010', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 192, NULL, NULL, 115038),
(115039, '1.20.58.1610-FF-000012', NULL, 'F(420)H(2) dehydrogenase subunit A', 122, NULL, NULL, 115039),
(115040, '1.25.40.10-FF-001204', NULL, 'Pentatricopeptide (PPR) repeat protein-like', 206, NULL, NULL, 115040),
(115041, '2.130.10.10-FF-005702', NULL, 'Uncharacterized protein', 148, NULL, NULL, 115041),
(115042, '3.40.50.150-FF-000323', NULL, 'Polyprotein P1234', 204, NULL, NULL, 115042),
(115043, '2.60.40.1660-FF-000029', NULL, 'Sodium/potassium-dependent ATPase beta subunit, putative', 248, NULL, NULL, 115043),
(115044, '1.50.40.10-FF-000511', NULL, 'Carnitine/acylcarnitine translocase', 202, NULL, NULL, 115044),
(115045, '3.40.1280.30-FF-000022', NULL, 'tRNA (Guanine-9-N(1)-)-methyltransferase', 199, NULL, NULL, 115045),
(115046, '1.10.10.10-FF-001539', NULL, 'Type III restriction enzyme, res subunit family protein', 86, NULL, NULL, 115046),
(115047, '3.90.640.10-FF-000101', NULL, '105/110 kDa heat shock protein/ nucleotide-binding domain', 90, NULL, NULL, 115047),
(115048, '2.10.25.10-FF-001493', NULL, 'Neurogenic locus notch-like protein 1', 35, NULL, NULL, 115048),
(115049, '2.30.42.10-FF-000126', NULL, 'Piccolo presynaptic cytomatrix protein', 116, NULL, NULL, 115049),
(115050, '1.10.510.10-FF-000252', NULL, 'Receptor-like protein kinase FERONIA', 217, NULL, NULL, 115050),
(115051, '1.10.238.10-FF-001271', NULL, 'Probable calcium-binding protein CML1', 26, NULL, NULL, 115051),
(115052, '1.20.1250.20-FF-000299', NULL, 'Major facilitator superfamily domain containing 4B', 185, NULL, NULL, 115052),
(115053, '4.10.1000.10-FF-000114', NULL, 'Predicted protein', 54, NULL, NULL, 115053),
(115054, '2.60.40.60-FF-000686', NULL, 'Cadherin-4', 116, NULL, NULL, 115054);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(115055, '1.10.357.10-FF-000075', NULL, 'Ubiquinone biosynthesis protein COQ9', 140, NULL, NULL, 115055),
(115056, '2.40.50.100-FF-000104', NULL, 'Glycerol-3-phosphate ABC transporter ATP-binding protein', 62, NULL, NULL, 115056),
(115057, '1.25.10.10-FF-001596', NULL, 'Uncharacterized protein', 849, NULL, NULL, 115057),
(115058, '3.30.70.20-FF-000057', NULL, 'Ferredoxin-type protein NapF', 80, NULL, NULL, 115058),
(115059, '1.25.40.10-FF-002828', NULL, 'Pentatricopeptide repeat-containing protein At5g50990', 144, NULL, NULL, 115059),
(115060, '1.20.1070.10-FF-000085', NULL, '5-hydroxytryptamine receptor 1F', 344, NULL, NULL, 115060),
(115061, '3.30.1740.10-FF-000009', NULL, 'Poly [ADP-ribose] polymerase', 61, NULL, NULL, 115061),
(115062, '3.30.740.10-FF-000009', NULL, 'Dynein light chain', 112, NULL, NULL, 115062),
(115063, '2.60.120.290-FF-000057', NULL, 'Uncharacterized protein, isoform B', 124, NULL, NULL, 115063),
(115064, '3.40.366.10-FF-000036', NULL, 'Malonyl CoA-acyl carrier protein transacylase', 209, NULL, NULL, 115064),
(115065, '1.10.220.110-FF-000004', NULL, 'GDNF family receptor alpha 4', 62, NULL, NULL, 115065),
(115066, '3.40.630.10-FF-000078', NULL, 'Glutamate carboxypeptidase 2', 307, NULL, NULL, 115066),
(115067, '3.30.450.40-FF-000114', NULL, 'IclR family transcriptional regulator', 176, NULL, NULL, 115067),
(115068, '3.80.10.10-FF-000874', NULL, 'Probable LRR receptor-like serine/threonine-protein kinase RFK1', 122, NULL, NULL, 115068),
(115069, '3.40.50.10130-FF-000016', NULL, 'Hef nuclease', 135, NULL, NULL, 115069),
(115070, '2.30.30.140-FF-000131', NULL, 'Histone acetyltransferase', 78, NULL, NULL, 115070),
(115071, '1.20.1270.130-FF-000003', NULL, 'Type III secretion system effector E3 ubiquitin transferase SlrP', 79, NULL, NULL, 115071),
(115072, '3.40.50.200-FF-000041', NULL, 'Proline rich membrane-anchored mycosin', 271, NULL, NULL, 115072),
(115073, '3.30.470.20-FF-000121', NULL, 'Uncharacterized protein', 284, NULL, NULL, 115073),
(115074, '1.10.565.10-FF-000159', NULL, 'Nr1d1 protein', 214, NULL, NULL, 115074),
(115075, '2.60.40.10-FF-000244', NULL, 'carcinoembryonic antigen-related cell adhesion molecule 16', 96, NULL, NULL, 115075),
(115076, '2.60.120.560-FF-000031', NULL, 'Uncharacterized protein', 150, NULL, NULL, 115076),
(115077, '1.10.150.20-FF-000266', NULL, 'Predicted protein', 61, NULL, NULL, 115077),
(115078, '2.130.10.10-FF-004494', NULL, 'Uncharacterized protein', 268, NULL, NULL, 115078),
(115079, '1.25.40.20-FF-001634', NULL, 'Kinase, NEK', 95, NULL, NULL, 115079),
(115080, '1.20.58.60-FF-000034', NULL, 'kalirin isoform X2', 297, NULL, NULL, 115080),
(115081, '3.40.1360.10-FF-000062', NULL, 'Meiotic recombination protein rec12', 204, NULL, NULL, 115081),
(115082, '1.20.140.10-FF-000058', NULL, 'Putative acyl-CoA oxidase', 129, NULL, NULL, 115082),
(115083, '3.30.300.20-FF-000019', NULL, 'Ribosome-binding factor A', 114, NULL, NULL, 115083),
(115084, '2.30.29.30-FF-000146', NULL, 'FACT complex subunit POB3', 102, NULL, NULL, 115084),
(115085, '1.25.40.410-FF-000010', NULL, 'Dck1p', 142, NULL, NULL, 115085),
(115086, '2.30.29.170-FF-000031', NULL, NULL, 54, NULL, NULL, 115086),
(115087, '3.40.50.2000-FF-000742', NULL, 'UDP-glucoronosyl and UDP-glucosyl transferase family protein, putative', 246, NULL, NULL, 115087),
(115088, '3.50.50.60-FF-001045', NULL, 'Pyridine nucleotide-disulfide oxidoreductase', 28, NULL, NULL, 115088),
(115089, '2.60.120.430-FF-000020', NULL, 'Nodulation receptor kinase', 165, NULL, NULL, 115089),
(115090, '3.30.70.330-FF-001732', NULL, NULL, 80, NULL, NULL, 115090),
(115091, '2.130.10.10-FF-000795', NULL, 'Transducin beta-like protein 3', 104, NULL, NULL, 115091),
(115092, '3.30.1010.10-FF-000145', NULL, 'Uncharacterized protein', 113, NULL, NULL, 115092),
(115093, '4.10.410.20-FF-000005', NULL, 'Endonuclease, poly(U) specific', 51, NULL, NULL, 115093),
(115094, '3.40.50.10890-FF-000002', NULL, 'Integrator complex subunit 11', 180, NULL, NULL, 115094),
(115095, '3.90.660.10-FF-000001', NULL, 'Lysine-specific histone demethylase', 182, NULL, NULL, 115095);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(115096, '3.40.190.10-FF-000482', NULL, 'GD19935', 106, NULL, NULL, 115096),
(115097, '3.40.50.2300-FF-001243', NULL, NULL, 66, NULL, NULL, 115097),
(115098, '3.60.70.12-FF-000004', NULL, 'Beta-peptidyl aminopeptidase BapA', 377, NULL, NULL, 115098),
(115099, '3.30.420.140-FF-000018', NULL, 'Uncharacterized protein', 154, NULL, NULL, 115099),
(115100, '2.60.120.740-FF-000012', NULL, 'Eva-1 homolog C', 54, NULL, NULL, 115100),
(115101, '3.40.50.1000-FF-000324', NULL, 'Putative Alpha,alpha-trehalose-phosphate synthase', 107, NULL, NULL, 115101),
(115102, '3.40.50.1010-FF-000007', NULL, 'PhoH family protein', 148, NULL, NULL, 115102),
(115103, '1.10.860.10-FF-000019', NULL, 'DNA primase', 97, NULL, NULL, 115103),
(115104, '2.60.40.150-FF-000152', NULL, 'Synaptotagmin like 3', 167, NULL, NULL, 115104),
(115105, '3.30.70.330-FF-002351', NULL, NULL, 106, NULL, NULL, 115105),
(115106, '3.40.250.10-FF-000195', NULL, 'Adenylyltransferase and sulfurtransferase UBA4', 140, NULL, NULL, 115106),
(115107, '1.10.10.60-FF-000784', NULL, 'Homeobox protein Hox-C3a', 104, NULL, NULL, 115107),
(115108, '3.40.50.1240-FF-000059', NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', 208, NULL, NULL, 115108),
(115109, '1.10.220.30-FF-000022', NULL, 'Flagellar motor switch protein FliG', 139, NULL, NULL, 115109),
(115110, '1.10.510.10-FF-001191', NULL, 'Uncharacterized protein', 265, NULL, NULL, 115110),
(115111, '2.30.29.70-FF-000012', NULL, 'Uncharacterized protein', 70, NULL, NULL, 115111),
(115112, '3.40.50.300-FF-007214', NULL, 'DNA replication protein DnaC', 165, NULL, NULL, 115112),
(115113, '1.20.1740.10-FF-000272', NULL, 'Uncharacterized protein', 208, NULL, NULL, 115113),
(115114, '1.20.1460.10-FF-000008', NULL, 'V-type proton ATPase subunit C', 119, NULL, NULL, 115114),
(115115, '3.30.460.10-FF-000191', NULL, 'Uncharacterized protein', 121, NULL, NULL, 115115),
(115116, '2.10.25.10-FF-000874', NULL, 'Thrombomodulin', 36, NULL, NULL, 115116),
(115117, '3.30.450.60-FF-000019', NULL, 'Coatomer subunit delta', 140, NULL, NULL, 115117),
(115118, '3.20.20.100-FF-000172', NULL, 'Uncharacterized protein', 171, NULL, NULL, 115118),
(115119, '1.10.285.10-FF-000008', NULL, 'Glutamate dehydrogenase', 47, NULL, NULL, 115119),
(115120, '3.30.50.10-FF-000154', NULL, 'DGATAe protein', 45, NULL, NULL, 115120),
(115121, '3.40.50.970-FF-000125', NULL, '2-oxoacid:ferredoxin oxidoreductase, beta subunit', 218, NULL, NULL, 115121),
(115122, '1.25.10.10-FF-003153', NULL, 'Serine/threonine-protein kinase TOR', 437, NULL, NULL, 115122),
(115123, '2.20.25.530-FF-000004', NULL, 'Ribonuclease H2 subunit B', 36, NULL, NULL, 115123),
(115124, '3.20.20.80-FF-000286', NULL, 'Chondroitin proteoglycan 2', 98, NULL, NULL, 115124),
(115125, '3.10.20.30-FF-000035', NULL, 'Electron transfer protein, putative', 107, NULL, NULL, 115125),
(115126, '1.10.220.150-FF-000016', NULL, 'Uncharacterized protein, isoform B', 126, NULL, NULL, 115126),
(115127, '1.10.510.10-FF-001775', NULL, 'Uncharacterized protein', 124, NULL, NULL, 115127),
(115128, '3.30.420.10-FF-000070', NULL, 'DNA polymerase nu', 171, NULL, NULL, 115128),
(115129, '1.10.630.10-FF-000750', NULL, 'Uncharacterized protein', 68, NULL, NULL, 115129),
(115130, '2.30.18.10-FF-000008', NULL, 'Transcription factor TFIIA complex large subunit', 62, NULL, NULL, 115130),
(115131, '3.40.50.12370-FF-000002', NULL, 'Cation/H(+) antiporter 14', 229, NULL, NULL, 115131),
(115132, '2.130.10.10-FF-001751', NULL, 'GM17824', 311, NULL, NULL, 115132),
(115133, '1.10.472.80-FF-000234', NULL, NULL, 134, NULL, NULL, 115133),
(115134, '2.20.70.10-FF-000208', NULL, 'Uncharacterized protein', 38, NULL, NULL, 115134),
(115135, '3.40.50.960-FF-000009', NULL, '6,7-dimethyl-8-ribityllumazine synthase', 71, NULL, NULL, 115135),
(115136, '3.40.1190.10-FF-000037', NULL, NULL, 84, NULL, NULL, 115136),
(115137, '2.20.70.10-FF-000197', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-36 specific', 53, NULL, NULL, 115137),
(115138, '3.40.50.300-FF-001812', NULL, 'C4-dicarboxylate transport transcriptional regulatory protein DctD', 157, NULL, NULL, 115138);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(115139, '2.10.50.10-FF-000174', NULL, 'Uncharacterized protein', 65, NULL, NULL, 115139),
(115140, '2.30.29.30-FF-001102', NULL, 'Uncharacterized protein', 154, NULL, NULL, 115140),
(115141, '3.60.10.10-FF-000257', NULL, 'Endonuclease', 232, NULL, NULL, 115141),
(115142, '1.20.1250.20-FF-002339', NULL, 'Uncharacterized protein', 93, NULL, NULL, 115142),
(115143, '2.40.50.100-FF-000205', NULL, 'Uncharacterized protein', 77, NULL, NULL, 115143),
(115144, '3.40.50.720-FF-001702', NULL, 'Phosphoglycerate dehydrogenase SerA2-putative NAD-dependent 2-hydroxyacid dehydrogenase', 186, NULL, NULL, 115144),
(115145, '3.30.70.270-FF-000056', NULL, 'Sister chromatid cohesion protein Eso1', 177, NULL, NULL, 115145),
(115146, '3.80.10.10-FF-004472', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 288, NULL, NULL, 115146),
(115147, '1.10.540.10-FF-000080', NULL, 'Probable acyl-coA dehydrogenase', 127, NULL, NULL, 115147),
(115148, '3.40.50.300-FF-003960', NULL, 'DNA helicase', 152, NULL, NULL, 115148),
(115149, '3.30.200.20-FF-000871', NULL, 'G2-specific protein kinase nimA', 59, NULL, NULL, 115149),
(115150, '1.10.1760.20-FF-000008', NULL, 'Substrate-specific component NiaX of predicted niacin ECF transporter', 182, NULL, NULL, 115150),
(115151, '1.20.1640.10-FF-000106', NULL, NULL, 158, NULL, NULL, 115151),
(115152, '3.30.1490.20-FF-000003', NULL, 'acetyl-CoA carboxylase isoform X1', 67, NULL, NULL, 115152),
(115153, '3.30.200.20-FF-000186', NULL, 'Serine/threonine-protein kinase PBS1', 104, NULL, NULL, 115153),
(115154, '1.20.5.110-FF-000312', NULL, 'syntaxin-17-like', 56, NULL, NULL, 115154),
(115155, '2.30.40.10-FF-000178', NULL, 'Gll3395 protein', 37, NULL, NULL, 115155),
(115156, '3.40.50.2300-FF-000287', NULL, 'Histidine kinase', 127, NULL, NULL, 115156),
(115157, '3.40.50.12390-FF-000008', NULL, 'XRN 5''-3'' exonuclease N-terminus, putative', 178, NULL, NULL, 115157),
(115158, '1.20.1280.20-FF-000014', NULL, 'J-type chaperone', 86, NULL, NULL, 115158),
(115159, '2.60.40.150-FF-000051', NULL, 'Synaptotagmin 11', 137, NULL, NULL, 115159),
(115160, '2.10.110.10-FF-000285', NULL, 'LIM-domain containing phosphatase', 117, NULL, NULL, 115160),
(115161, '3.30.9.10-FF-000047', NULL, 'tRNA 5-methylaminomethyl-2-thiouridine biosynthesis bifunctional protein MnmC', 157, NULL, NULL, 115161),
(115162, '3.30.590.10-FF-000059', NULL, 'Predicted protein', 47, NULL, NULL, 115162),
(115163, '3.90.190.10-FF-000240', NULL, 'Protein CBG16631', 286, NULL, NULL, 115163),
(115164, '2.30.30.40-FF-000220', NULL, 'FYN binding protein 2', 78, NULL, NULL, 115164),
(115165, '3.30.565.10-FF-000546', NULL, 'Protein-histidine kinase, putative', 119, NULL, NULL, 115165),
(115166, '3.40.50.2300-FF-000950', NULL, NULL, 133, NULL, NULL, 115166),
(115167, '3.30.230.10-FF-000269', NULL, 'Diphosphomevalonate decarboxylase', 184, NULL, NULL, 115167),
(115168, '2.70.98.30-FF-000012', NULL, 'Alpha-mannosidase', 251, NULL, NULL, 115168),
(115169, '3.40.30.10-FF-000534', NULL, 'Lipoyl synthase, mitochondrial', 102, NULL, NULL, 115169),
(115170, '1.10.472.80-FF-000026', NULL, 'Mitotic check point protein (Bub2)', 123, NULL, NULL, 115170),
(115171, '3.40.50.150-FF-001621', NULL, NULL, 246, NULL, NULL, 115171),
(115172, '3.30.70.260-FF-000166', NULL, 'Predicted protein', 88, NULL, NULL, 115172),
(115173, '1.10.10.820-FF-000019', NULL, 'Unconventional myosin ID', 55, NULL, NULL, 115173),
(115174, '2.60.120.650-FF-000069', NULL, 'Lysine demethylase 5A', 228, NULL, NULL, 115174),
(115175, '1.20.1250.20-FF-000624', NULL, 'Major facilitator transporter', 193, NULL, NULL, 115175),
(115176, '1.20.1250.20-FF-001243', NULL, 'Putative inorganic phosphate cotransporter-like Protein', 150, NULL, NULL, 115176),
(115177, '3.40.50.300-FF-003628', NULL, 'Si:dkeyp-52c3.7', 209, NULL, NULL, 115177),
(115178, '1.10.1380.10-FF-000021', NULL, 'NEPrilysin metallopeptidase family', 390, NULL, NULL, 115178),
(115179, '1.25.10.10-FF-000859', NULL, 'Pumilio homolog 24', 327, NULL, NULL, 115179),
(115180, '1.20.59.10-FF-000004', NULL, 'Prephenate dehydratase', 87, NULL, NULL, 115180);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(115181, '3.30.930.10-FF-000047', NULL, 'serine--tRNA ligase, mitochondrial isoform X2', 319, NULL, NULL, 115181),
(115182, '1.25.10.10-FF-000404', NULL, 'AP-3 complex subunit beta', 559, NULL, NULL, 115182),
(115183, '3.30.1490.40-FF-000009', NULL, 'SYH1p protein', 96, NULL, NULL, 115183),
(115184, '2.60.40.10-FF-003813', NULL, NULL, 86, NULL, NULL, 115184),
(115185, '1.10.760.10-FF-000074', NULL, 'Nicotinate dehydrogenase subunit B', 127, NULL, NULL, 115185),
(115186, '3.30.70.330-FF-000434', NULL, 'Bruno 2, isoform H', 114, NULL, NULL, 115186),
(115187, '2.130.10.10-FF-002829', NULL, 'Uncharacterized protein', 111, NULL, NULL, 115187),
(115188, '2.130.10.10-FF-002717', NULL, 'Retina aberrant in pattern', 311, NULL, NULL, 115188),
(115189, '1.10.287.110-FF-000043', NULL, 'J-domain protein required for chloroplast accumulation response 1', 104, NULL, NULL, 115189),
(115190, '1.10.10.10-FF-000224', NULL, 'RNA polymerase sigma factor', 55, NULL, NULL, 115190),
(115191, '1.10.510.10-FF-000460', NULL, 'Cyclin dependent kinase 19', 87, NULL, NULL, 115191),
(115192, '3.30.1140.60-FF-000023', NULL, 'F-actin-capping protein subunit alpha-1', 82, NULL, NULL, 115192),
(115193, '3.60.40.10-FF-000085', NULL, 'Uncharacterized protein', 294, NULL, NULL, 115193),
(115194, '3.30.70.330-FF-003071', NULL, NULL, 103, NULL, NULL, 115194),
(115195, '3.30.70.100-FF-000051', NULL, 'Acylphosphatase', 70, NULL, NULL, 115195),
(115196, '3.50.50.60-FF-000426', NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', 256, NULL, NULL, 115196),
(115197, '1.25.10.10-FF-001023', NULL, 'TATA-binding protein interacting (TIP20), putative', 1188, NULL, NULL, 115197),
(115198, '1.25.40.10-FF-004970', NULL, 'Uncharacterized protein', 153, NULL, NULL, 115198),
(115199, '3.30.1360.230-FF-000001', NULL, 'Suppressor of fused homolog', 132, NULL, NULL, 115199),
(115200, '1.10.287.130-FF-000049', NULL, 'C4-dicarboxylate transport sensor protein DctB', 88, NULL, NULL, 115200),
(115201, '3.80.10.10-FF-001599', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 163, NULL, NULL, 115201),
(115202, '3.30.70.330-FF-002929', NULL, NULL, 120, NULL, NULL, 115202),
(115203, '1.25.40.430-FF-000016', NULL, 'BUB1 mitotic checkpoint serine/threonine kinase', 147, NULL, NULL, 115203),
(115204, '3.30.70.3080-FF-000001', NULL, 'Trehalose-phosphatase', 96, NULL, NULL, 115204),
(115205, '3.30.200.20-FF-001259', NULL, 'Receptor-like serine/threonine-protein kinase SD1-6', 108, NULL, NULL, 115205),
(115206, '3.40.50.2000-FF-001035', NULL, 'AGAP002783-PA', 169, NULL, NULL, 115206),
(115207, '3.30.40.10-FF-000338', NULL, 'E3 ubiquitin-protein ligase, putative', 65, NULL, NULL, 115207),
(115208, '1.10.10.10-FF-000808', NULL, 'ArsR family transcriptional regulator', 97, NULL, NULL, 115208),
(115209, '3.40.50.300-FF-006826', NULL, 'Sulfotransferase', 274, NULL, NULL, 115209),
(115210, '3.40.50.300-FF-003257', NULL, 'AAA family ATPase, putative', 158, NULL, NULL, 115210),
(115211, '3.30.160.60-FF-006421', NULL, NULL, 91, NULL, NULL, 115211),
(115212, '1.25.40.180-FF-000149', NULL, 'Uncharacterized protein', 206, NULL, NULL, 115212),
(115213, '3.40.50.720-FF-002321', NULL, 'Uncharacterized protein', 121, NULL, NULL, 115213),
(115214, '3.90.1200.10-FF-000062', NULL, 'Hydroxylysine kinase', 219, NULL, NULL, 115214),
(115215, '2.10.25.10-FF-000762', NULL, 'WNT inhibitory factor 1', 34, NULL, NULL, 115215),
(115216, '2.60.40.10-FF-001447', NULL, 'Obscurin like 1', 87, NULL, NULL, 115216),
(115217, '3.30.70.330-FF-000895', NULL, 'Hsh49p', 104, NULL, NULL, 115217),
(115218, '1.20.58.340-FF-000021', NULL, 'Magnesium and cobalt transporter CorA', 108, NULL, NULL, 115218),
(115219, '1.25.40.10-FF-003560', NULL, 'Uncharacterized protein', 256, NULL, NULL, 115219),
(115220, '3.30.559.10-FF-000285', NULL, 'Carnitine O-palmitoyltransferase II, putative', 264, NULL, NULL, 115220),
(115221, '1.10.510.10-FF-003686', NULL, NULL, 169, NULL, NULL, 115221),
(115222, '3.40.50.300-FF-002431', NULL, 'Repressor protein', 169, NULL, NULL, 115222),
(115223, '1.10.800.10-FF-000010', NULL, 'Phenylalanine 4-monooxygenase', 297, NULL, NULL, 115223);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(115224, '1.25.40.10-FF-000367', NULL, 'Tetratricopeptide repeat domain 1', 150, NULL, NULL, 115224),
(115225, '2.40.10.10-FF-000709', NULL, NULL, 21, NULL, NULL, 115225),
(115226, '3.30.160.60-FF-001076', NULL, 'zinc finger protein 697', 27, NULL, NULL, 115226),
(115227, '3.40.50.150-FF-001745', NULL, NULL, 220, NULL, NULL, 115227),
(115228, '3.40.50.800-FF-000102', NULL, 'Histidine--tRNA ligase', 86, NULL, NULL, 115228),
(115229, '3.30.70.2650-FF-000001', NULL, 'PaaX domain-containing protein, C-domain protein', 82, NULL, NULL, 115229),
(115230, '3.40.50.1820-FF-001430', NULL, 'Uncharacterized protein', 195, NULL, NULL, 115230),
(115231, '2.40.350.20-FF-000001', NULL, 'Uncharacterized protein', 120, NULL, NULL, 115231),
(115232, '3.30.70.270-FF-000264', NULL, NULL, 90, NULL, NULL, 115232),
(115233, '1.20.1560.10-FF-000847', NULL, 'Uncharacterized protein', 382, NULL, NULL, 115233),
(115234, '2.40.30.10-FF-000132', NULL, 'Translation initiation factor aIF-2', 130, NULL, NULL, 115234),
(115235, '2.10.25.10-FF-001279', NULL, 'Uncharacterized protein', 88, NULL, NULL, 115235),
(115236, '1.10.10.1760-FF-000003', NULL, '60S ribosomal protein L36', 103, NULL, NULL, 115236),
(115237, '1.10.1300.10-FF-000016', NULL, 'cGMP-specific phosphodiesterase', 340, NULL, NULL, 115237),
(115238, '3.30.160.60-FF-004055', NULL, 'Zinc finger imprinted 3', 71, NULL, NULL, 115238),
(115239, '1.25.40.10-FF-004077', NULL, 'Uncharacterized protein', 158, NULL, NULL, 115239),
(115240, '3.80.10.10-FF-003853', NULL, 'PH domain and leucine-rich repeat protein phosphatase 1', 87, NULL, NULL, 115240),
(115241, '1.20.120.1900-FF-000040', NULL, 'Gamma-tubulin complex component', 288, NULL, NULL, 115241),
(115242, '3.30.70.1230-FF-000244', NULL, 'Predicted protein', 69, NULL, NULL, 115242),
(115243, '2.40.50.90-FF-000112', NULL, 'RING finger protein 17', 107, NULL, NULL, 115243),
(115244, '2.60.120.260-FF-000514', NULL, 'Beta-galactosidase', 91, NULL, NULL, 115244),
(115245, '1.10.640.10-FF-000008', NULL, 'Dual oxidase 1', 560, NULL, NULL, 115245),
(115246, '3.40.190.10-FF-000369', NULL, 'Glutamate receptor', 61, NULL, NULL, 115246),
(115247, '2.70.130.10-FF-000099', NULL, NULL, 150, NULL, NULL, 115247),
(115248, '3.30.70.3030-FF-000014', NULL, 'Uncharacterized protein', 135, NULL, NULL, 115248),
(115249, '1.10.150.460-FF-000002', NULL, NULL, 20, NULL, NULL, 115249),
(115250, '1.50.10.10-FF-000104', NULL, 'alpha-1,2-Mannosidase', 469, NULL, NULL, 115250),
(115251, '3.40.50.720-FF-000640', NULL, 'Very-long-chain 3-oxoacyl-CoA reductase', 226, NULL, NULL, 115251),
(115252, '1.25.10.10-FF-001832', NULL, 'Tubulin-specific chaperone D', 348, NULL, NULL, 115252),
(115253, '1.25.40.10-FF-000232', NULL, '28S ribosomal protein S27, mitochondrial', 166, NULL, NULL, 115253),
(115254, '6.10.140.2160-FF-000001', NULL, 'Terminase small subunit', 54, NULL, NULL, 115254),
(115255, '1.25.40.90-FF-000093', NULL, 'AaceriAEL209Wp', 126, NULL, NULL, 115255),
(115256, '3.60.90.10-FF-000020', NULL, 'S-adenosylmethionine decarboxylase proenzyme', 285, NULL, NULL, 115256),
(115257, '1.10.167.10-FF-000015', NULL, 'Regulator of G-protein signaling 17', 144, NULL, NULL, 115257),
(115258, '3.40.50.150-FF-000211', NULL, 'Methyltransferase-like protein 13', 215, NULL, NULL, 115258),
(115259, '3.30.450.50-FF-000005', NULL, 'arf-GAP domain and FG repeat-containing protein 1', 81, NULL, NULL, 115259),
(115260, '1.20.5.50-FF-000009', NULL, 'Fibrinogen gamma chain', 138, NULL, NULL, 115260),
(115261, '1.25.40.10-FF-003222', NULL, 'Protein O-mannosyl-transferase TMTC3', 64, NULL, NULL, 115261),
(115262, '2.130.10.10-FF-005466', NULL, 'Predicted protein', 168, NULL, NULL, 115262),
(115263, '3.40.525.10-FF-000047', NULL, 'CRAL/TRIO domain containing protein, putative', 254, NULL, NULL, 115263),
(115264, '2.130.10.10-FF-001537', NULL, 'Phosphoinositide 3-kinase regulatory subunit 4', 320, NULL, NULL, 115264),
(115265, '1.10.10.60-FF-001285', NULL, NULL, 54, NULL, NULL, 115265),
(115266, '2.60.40.10-FF-003358', NULL, NULL, 94, NULL, NULL, 115266),
(115267, '1.10.150.20-FF-000160', NULL, '5''-3'' exonuclease family protein', 99, NULL, NULL, 115267);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(115268, '3.40.1370.10-FF-000023', NULL, 'Ribosomal protein L4/L1 family, putative', 241, NULL, NULL, 115268),
(115269, '2.130.10.10-FF-003437', NULL, 'Protein kinase', 150, NULL, NULL, 115269),
(115270, '3.90.180.10-FF-000071', NULL, 'NAD-dependent alcohol dehydrogenase', 181, NULL, NULL, 115270),
(115271, '1.20.5.370-FF-000013', NULL, 'Ligase-interacting factor 1', 91, NULL, NULL, 115271),
(115272, '3.30.200.20-FF-000995', NULL, 'PAK4-inhibitor inka2', 44, NULL, NULL, 115272),
(115273, '3.30.160.60-FF-003330', NULL, 'C2H2 transcription factor, putative', 66, NULL, NULL, 115273),
(115274, '1.10.472.80-FF-000110', NULL, 'TBC domain containing protein', 123, NULL, NULL, 115274),
(115275, '3.30.420.10-FF-000289', NULL, 'Exonuclease-like protein', 180, NULL, NULL, 115275),
(115276, '1.25.40.700-FF-000007', NULL, 'Uncharacterized protein (Fragment)', 87, NULL, NULL, 115276),
(115277, '1.10.3080.10-FF-000004', NULL, 'Chloride channel ClC3', 460, NULL, NULL, 115277),
(115278, '3.30.160.60-FF-001773', NULL, 'zinc finger protein 827 isoform X1', 24, NULL, NULL, 115278),
(115279, '3.30.450.20-FF-000575', NULL, 'Uncharacterized protein', 84, NULL, NULL, 115279),
(115280, '3.30.565.10-FF-000338', NULL, 'Histidine kinase', 148, NULL, NULL, 115280),
(115281, '1.20.5.2210-FF-000007', NULL, 'ATP synthase F(0) complex subunit B1, mitochondrial isoform X1', 86, NULL, NULL, 115281),
(115282, '3.30.40.10-FF-000783', NULL, 'SWI/SNF family DNA-dependent ATPase Ris1, putative', 93, NULL, NULL, 115282),
(115283, '1.25.10.10-FF-000539', NULL, 'Exportin-1, putative', 778, NULL, NULL, 115283),
(115284, '3.90.190.10-FF-000341', NULL, 'Kinetoplastid-specific dual specificity phosphatase, putative', 174, NULL, NULL, 115284),
(115285, '3.30.360.10-FF-000014', NULL, 'N-acetyl-gamma-glutamyl-phosphate reductase', 167, NULL, NULL, 115285),
(115286, '3.30.160.60-FF-005027', NULL, NULL, 30, NULL, NULL, 115286),
(115287, '3.10.20.90-FF-000946', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', 71, NULL, NULL, 115287),
(115288, '3.50.50.60-FF-000218', NULL, 'Succinate dehydrogenase [ubiquinone] flavoprotein subunit, mitochondrial', 302, NULL, NULL, 115288),
(115289, '1.10.225.10-FF-000016', NULL, 'Saposin-related', 82, NULL, NULL, 115289),
(115290, '2.10.220.10-FF-000046', NULL, 'Proprotein convertase subtilisin/kexin type 5b', 58, NULL, NULL, 115290),
(115291, '1.10.238.10-FF-000208', NULL, 'Dual oxidase 1', 146, NULL, NULL, 115291),
(115292, '1.10.10.10-FF-000567', NULL, 'paired box protein Pax-6 isoform X4', 102, NULL, NULL, 115292),
(115293, '3.30.40.10-FF-000440', NULL, 'RING finger and transmembrane domain-containing protein 1', 74, NULL, NULL, 115293),
(115294, '3.40.50.300-FF-001594', NULL, 'Branched-chain-amino-acid aminotransferase-like protein 2', 210, NULL, NULL, 115294),
(115295, '1.25.40.990-FF-000049', NULL, 'AaceriAGL315Wp', 252, NULL, NULL, 115295),
(115296, '3.30.70.141-FF-000030', NULL, 'Nucleoside diphosphate kinase', 168, NULL, NULL, 115296),
(115297, '1.20.1270.10-FF-000084', NULL, 'Chaperone protein DnaK', 78, NULL, NULL, 115297),
(115298, '3.80.10.10-FF-002217', NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', 187, NULL, NULL, 115298),
(115299, '3.40.50.300-FF-005966', NULL, 'Uncharacterized protein', 213, NULL, NULL, 115299),
(115300, '1.10.287.130-FF-000133', NULL, 'Sensory box sensor histidine kinase', 125, NULL, NULL, 115300),
(115301, '3.40.50.1820-FF-000345', NULL, 'Uncharacterized protein, isoform A', 279, NULL, NULL, 115301),
(115302, '1.20.920.10-FF-000112', NULL, 'Bromodomain and WD repeat-containing DDB_G0285837', 131, NULL, NULL, 115302),
(115303, '1.20.1280.50-FF-000118', NULL, 'GD22710', 66, NULL, NULL, 115303),
(115304, '2.40.50.140-FF-001274', NULL, 'Telomere-binding protein subunit alpha', 169, NULL, NULL, 115304),
(115305, '3.40.50.300-FF-006242', NULL, 'Uncharacterized protein', 233, NULL, NULL, 115305),
(115306, '3.40.50.150-FF-001380', NULL, NULL, 175, NULL, NULL, 115306),
(115307, '1.20.1110.10-FF-000252', NULL, NULL, 222, NULL, NULL, 115307),
(115308, '1.10.357.120-FF-000001', NULL, 'DNA-directed RNA polymerase subunit', 132, NULL, NULL, 115308);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(115309, '3.40.50.1820-FF-000924', NULL, 'Uncharacterized protein', 272, NULL, NULL, 115309),
(115310, '1.25.40.10-FF-000575', NULL, 'Pre-mRNA-splicing factor, Crooked neck-like protein', 166, NULL, NULL, 115310),
(115311, '2.60.20.10-FF-000024', NULL, NULL, 47, NULL, NULL, 115311),
(115312, '3.40.50.300-FF-003049', NULL, 'Fungal_tRNA_ligase_phosphodiesterase_domain_conta ining_protein_-_putative', 168, NULL, NULL, 115312),
(115313, '3.40.50.2300-FF-000742', NULL, 'Uncharacterized protein', 143, NULL, NULL, 115313),
(115314, '1.20.1250.20-FF-000074', NULL, 'Nucleoside transporter yegT', 208, NULL, NULL, 115314),
(115315, '3.30.420.10-FF-000401', NULL, 'Uncharacterized protein', 345, NULL, NULL, 115315),
(115316, '3.30.1380.20-FF-000012', NULL, 'Trafficking protein particle complex subunit', 168, NULL, NULL, 115316),
(115317, '2.130.10.10-FF-001296', NULL, 'Unplaced genomic scaffold supercont1.219, whole genome shotgun sequence', 218, NULL, NULL, 115317),
(115318, '3.80.10.10-FF-001700', NULL, 'Uncharacterized protein', 101, NULL, NULL, 115318),
(115319, '2.40.30.20-FF-000034', NULL, 'ATP synthase subunit alpha 1', 91, NULL, NULL, 115319),
(115320, '3.30.1520.20-FF-000001', NULL, 'Exodeoxyribonuclease I', 139, NULL, NULL, 115320),
(115321, '2.40.10.10-FF-000586', NULL, NULL, 41, NULL, NULL, 115321),
(115322, '2.60.40.10-FF-005258', NULL, NULL, 87, NULL, NULL, 115322),
(115323, '3.20.20.80-FF-000162', NULL, 'Cell wall alpha-1,3-glucan synthase mok12', 190, NULL, NULL, 115323),
(115324, '2.60.40.420-FF-000267', NULL, 'Predicted protein', 144, NULL, NULL, 115324),
(115325, '2.130.10.10-FF-004847', NULL, 'Uncharacterized protein', 130, NULL, NULL, 115325),
(115326, '3.30.559.30-FF-000032', NULL, 'Aspergillus niger contig An11c0010, genomic contig', 228, NULL, NULL, 115326),
(115327, '1.25.50.20-FF-000073', NULL, 'Aminopeptidase', 284, NULL, NULL, 115327),
(115328, '3.40.50.1820-FF-001773', NULL, 'Carboxypeptidase', 193, NULL, NULL, 115328),
(115329, '1.25.10.10-FF-003277', NULL, 'Uncharacterized protein', 512, NULL, NULL, 115329),
(115330, '1.25.10.10-FF-001719', NULL, 'AGAP011454-PA', 217, NULL, NULL, 115330),
(115331, '3.90.1150.10-FF-000517', NULL, 'Lallo-threonine aldolase, putative', 83, NULL, NULL, 115331),
(115332, '3.40.30.10-FF-001254', NULL, 'Uncharacterized protein', 116, NULL, NULL, 115332),
(115333, '3.30.160.70-FF-000005', NULL, 'Methylated-DNA--protein-cysteine methyltransferase', 70, NULL, NULL, 115333),
(115334, '3.40.50.150-FF-000109', NULL, 'rRNA adenine N(6)-methyltransferase', 236, NULL, NULL, 115334),
(115335, '3.40.50.300-FF-002532', NULL, 'DEAD/H-box helicase 11', 207, NULL, NULL, 115335),
(115336, '3.10.129.10-FF-000228', NULL, 'Fatty acid synthetase beta subunit, putative (JCVI)', 236, NULL, NULL, 115336),
(115337, '3.40.50.720-FF-000185', NULL, 'peroxisomal multifunctional enzyme type 2', 243, NULL, NULL, 115337),
(115338, '2.10.110.10-FF-000055', NULL, 'Actin binding LIM protein 1', 68, NULL, NULL, 115338),
(115339, '3.40.50.300-FF-005180', NULL, 'ABC transporter', 218, NULL, NULL, 115339),
(115340, '3.40.50.620-FF-000037', NULL, 'Glutamine--tRNA ligase cytoplasmic', 341, NULL, NULL, 115340),
(115341, '3.30.750.44-FF-000030', NULL, NULL, 60, NULL, NULL, 115341),
(115342, '3.90.190.10-FF-000009', NULL, 'Receptor-type tyrosine-protein phosphatase beta', 289, NULL, NULL, 115342),
(115343, '3.80.10.10-FF-000076', NULL, 'protein lap4 isoform X23', 118, NULL, NULL, 115343),
(115344, '3.10.110.10-FF-000192', NULL, 'Ubiquitin-binding ESCRT-I subunit protein', 163, NULL, NULL, 115344),
(115345, '3.90.1480.20-FF-000034', NULL, 'CMP-N-acetylneuraminate-beta-galactosamide-alpha-2,3-sialyltransferase 1', 298, NULL, NULL, 115345),
(115346, '2.130.10.30-FF-000115', NULL, 'Serine/threonine-protein kinase-like protein CCR1', 289, NULL, NULL, 115346),
(115347, '2.60.220.50-FF-000125', NULL, 'Uncharacterized protein', 30, NULL, NULL, 115347),
(115348, '3.40.47.10-FF-000174', NULL, NULL, 49, NULL, NULL, 115348),
(115349, '1.25.40.10-FF-003801', NULL, 'TPR Domain containing protein', 143, NULL, NULL, 115349);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(115350, '1.10.10.410-FF-000003', NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit E', 59, NULL, NULL, 115350),
(115351, '2.60.120.200-FF-000631', NULL, 'Uncharacterized protein', 219, NULL, NULL, 115351),
(115352, '3.40.50.300-FF-007203', NULL, 'Uncharacterized protein', 167, NULL, NULL, 115352),
(115353, '1.10.10.10-FF-001747', NULL, 'YALI0F20724p', 98, NULL, NULL, 115353),
(115354, '3.30.70.330-FF-002452', NULL, NULL, 85, NULL, NULL, 115354),
(115355, '1.10.1740.10-FF-000010', NULL, 'RNA polymerase sigma factor', 82, NULL, NULL, 115355),
(115356, '3.40.50.300-FF-006585', NULL, 'Uncharacterized protein', 99, NULL, NULL, 115356),
(115357, '3.30.70.120-FF-000039', NULL, NULL, 102, NULL, NULL, 115357),
(115358, '1.10.533.10-FF-000288', NULL, 'I Kappa B homolog', 92, NULL, NULL, 115358),
(115359, '3.40.50.10330-FF-000071', NULL, 'NAD kinase', 115, NULL, NULL, 115359),
(115360, '3.40.50.300-FF-002190', NULL, 'ABC transporter B family member 5', 174, NULL, NULL, 115360),
(115361, '3.40.50.2000-FF-000658', NULL, 'Glycosyltransferase', 235, NULL, NULL, 115361),
(115362, '3.90.1860.10-FF-000015', NULL, 'tRNA-splicing ligase RtcB homolog', 253, NULL, NULL, 115362),
(115363, '1.20.1050.120-FF-000001', NULL, 'Fatty acid synthase beta subunit dehydratase', 134, NULL, NULL, 115363),
(115364, '3.30.160.60-FF-004510', NULL, NULL, 32, NULL, NULL, 115364),
(115365, '3.40.50.300-FF-004685', NULL, 'ATPase, putative', 120, NULL, NULL, 115365),
(115366, '3.20.110.10-FF-000032', NULL, 'Uncharacterized protein', 91, NULL, NULL, 115366),
(115367, '2.60.40.10-FF-004538', NULL, NULL, 91, NULL, NULL, 115367),
(115368, '2.70.50.30-FF-000003', NULL, 'Rho GDP-dissociation inhibitor 1', 142, NULL, NULL, 115368),
(115369, '1.10.510.10-FF-001432', NULL, 'Serine/threonine-protein kinase Nek6', 89, NULL, NULL, 115369),
(115370, '3.30.500.10-FF-000003', NULL, 'IgG receptor FcRn large subunit p51', 178, NULL, NULL, 115370),
(115371, '2.60.120.920-FF-000173', NULL, 'Ryanodine receptor 2', 87, NULL, NULL, 115371),
(115372, '3.40.50.300-FF-000402', NULL, 'Ras-related protein Rab-27A', 190, NULL, NULL, 115372),
(115373, '2.130.10.10-FF-001857', NULL, 'AGAP000602-PA', 211, NULL, NULL, 115373),
(115374, '2.60.40.1510-FF-000001', NULL, 'Integrin alpha V', 140, NULL, NULL, 115374),
(115375, '2.40.50.140-FF-000768', NULL, NULL, 76, NULL, NULL, 115375),
(115376, '2.60.120.330-FF-000215', NULL, 'Uncharacterized protein', 84, NULL, NULL, 115376),
(115377, '3.40.30.10-FF-000293', NULL, 'Maleylacetoacetate isomerase MaiA', 78, NULL, NULL, 115377),
(115378, '2.30.29.30-FF-001208', NULL, 'Predicted protein', 190, NULL, NULL, 115378),
(115379, '3.30.450.40-FF-000013', NULL, 'Sensor histidine kinase YehU', 126, NULL, NULL, 115379),
(115380, '1.25.10.10-FF-001158', NULL, 'Uncharacterized protein', 281, NULL, NULL, 115380),
(115381, '3.90.260.10-FF-000004', NULL, 'Protein-glutamine gamma-glutamyltransferase 5', 319, NULL, NULL, 115381),
(115382, '2.130.10.10-FF-005123', NULL, 'Neurobeachin/beige protein, putative', 136, NULL, NULL, 115382),
(115383, '1.20.1280.290-FF-000058', NULL, 'Sugar efflux transporter for intercellular exchange, putative', 93, NULL, NULL, 115383),
(115384, '1.10.260.40-FF-000022', NULL, 'POU domain protein', 91, NULL, NULL, 115384),
(115385, '2.60.40.10-FF-005819', NULL, NULL, 54, NULL, NULL, 115385),
(115386, '1.10.287.70-FF-000733', NULL, 'Uncharacterized protein', 116, NULL, NULL, 115386),
(115387, '3.30.160.60-FF-002610', NULL, 'Zinc finger protein 732', 25, NULL, NULL, 115387),
(115388, '3.40.50.720-FF-002085', NULL, 'Uncharacterized protein', 139, NULL, NULL, 115388),
(115389, '1.10.510.10-FF-003456', NULL, NULL, 275, NULL, NULL, 115389),
(115390, '2.40.50.140-FF-000998', NULL, NULL, 80, NULL, NULL, 115390),
(115391, '3.80.10.10-FF-004117', NULL, 'Uncharacterized protein', 115, NULL, NULL, 115391),
(115392, '2.40.30.110-FF-000002', NULL, 'Aminomethyltransferase', 76, NULL, NULL, 115392),
(115393, '2.10.25.10-FF-000773', NULL, 'Mesocentin', 38, NULL, NULL, 115393),
(115394, '1.10.405.10-FF-000002', NULL, 'Guanosine nucleotide diphosphate dissociation inhibitor', 106, NULL, NULL, 115394); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(115395, '1.20.810.10-FF-000008', NULL, 'Cytochrome b', 367, NULL, NULL, 115395),
(115396, '2.60.60.20-FF-000035', NULL, 'Lipoxygenase', 169, NULL, NULL, 115396),
(115397, '1.20.58.60-FF-000354', NULL, 'VAB-10B protein', 105, NULL, NULL, 115397),
(115398, '1.10.375.10-FF-000004', NULL, 'Gag polyprotein', 132, NULL, NULL, 115398),
(115399, '3.30.830.10-FF-000112', NULL, 'Protease, insulinase family/protease, insulinase family', 197, NULL, NULL, 115399),
(115400, '3.40.50.10420-FF-000007', NULL, '5-formyltetrahydrofolate cyclo-ligase', 201, NULL, NULL, 115400),
(115401, '2.60.40.1530-FF-000007', NULL, 'Integrin subunit alpha 10', 169, NULL, NULL, 115401),
(115402, '3.30.200.20-FF-000539', NULL, 'Tyrosine-protein kinase receptor', 90, NULL, NULL, 115402),
(115403, '1.20.1640.10-FF-000005', NULL, 'Multidrug resistance protein MdtC', 212, NULL, NULL, 115403),
(115404, '1.20.120.1760-FF-000071', NULL, NULL, 227, NULL, NULL, 115404),
(115405, '3.30.30.30-FF-000041', NULL, 'Heat shock protein 110, putative', 56, NULL, NULL, 115405),
(115406, '1.25.40.20-FF-001084', NULL, 'Diacylglycerol kinase', 106, NULL, NULL, 115406),
(115407, '1.10.238.10-FF-000894', NULL, 'Mechanosensitive ion channel protein', 154, NULL, NULL, 115407),
(115408, '1.10.10.10-FF-001404', NULL, 'Transcriptional regulator', 139, NULL, NULL, 115408),
(115409, '2.10.25.10-FF-001734', NULL, 'Uncharacterized protein', 104, NULL, NULL, 115409),
(115410, '3.40.50.2000-FF-000315', NULL, 'Glycosyltransferase, group 1 family protein', 152, NULL, NULL, 115410),
(115411, '1.10.268.10-FF-000036', NULL, NULL, 80, NULL, NULL, 115411),
(115412, '3.40.50.1220-FF-000053', NULL, 'Phenylpyruvate decarboxylase', 168, NULL, NULL, 115412),
(115413, '3.30.70.330-FF-000198', NULL, 'CUGBP Elav-like family member 6 isoform X3', 94, NULL, NULL, 115413),
(115414, '3.40.50.300-FF-001251', NULL, 'Multidrug resistance protein 1', 301, NULL, NULL, 115414),
(115415, '1.10.437.10-FF-000008', NULL, 'Bcl-2-related protein A1', 151, NULL, NULL, 115415),
(115416, '3.30.2320.80-FF-000009', NULL, 'Hydrogenase maturation factor HypA', 114, NULL, NULL, 115416),
(115417, '1.25.40.10-FF-001547', NULL, 'Pentatricopeptide repeat-containing protein 1, mitochondrial-like Protein', 145, NULL, NULL, 115417),
(115418, '1.10.10.10-FF-001186', NULL, 'DNA-directed RNA polymerase III subunit RPC6', 84, NULL, NULL, 115418),
(115419, '2.60.40.790-FF-000001', NULL, 'Nuclear migration protein nudC', 128, NULL, NULL, 115419),
(115420, '3.90.1380.10-FF-000001', NULL, 'Threonine synthase', 81, NULL, NULL, 115420),
(115421, '1.20.1050.10-FF-000185', NULL, 'Glutathione S-transferase', 117, NULL, NULL, 115421),
(115422, '3.40.50.620-FF-000835', NULL, 'Uncharacterized protein', 209, NULL, NULL, 115422),
(115423, '2.30.42.10-FF-000553', NULL, NULL, 68, NULL, NULL, 115423),
(115424, '2.130.10.10-FF-002476', NULL, 'Intraflagellar transport protein 140 homolog', 437, NULL, NULL, 115424),
(115425, '3.40.720.10-FF-000169', NULL, 'Predicted protein', 148, NULL, NULL, 115425),
(115426, '2.60.120.200-FF-000070', NULL, 'Serum amyloid P-component', 204, NULL, NULL, 115426),
(115427, '3.40.570.10-FF-000011', NULL, 'Putative endonuclease', 222, NULL, NULL, 115427),
(115428, '1.25.40.70-FF-000014', NULL, 'Phosphatidylinositol-4-phosphate 3-kinase C2 domain-containing subunit beta', 197, NULL, NULL, 115428),
(115429, '2.60.40.10-FF-003919', NULL, NULL, 108, NULL, NULL, 115429),
(115430, '2.10.25.10-FF-001599', NULL, 'Uncharacterized protein', 26, NULL, NULL, 115430),
(115431, '2.60.120.10-FF-000196', NULL, 'Mannose-6-phosphate isomerase', 87, NULL, NULL, 115431),
(115432, '3.40.50.720-FF-000308', NULL, 'NEDD8-activating enzyme E1 catalytic subunit', 231, NULL, NULL, 115432),
(115433, '3.40.220.10-FF-000047', NULL, 'Uncharacterized protein', 87, NULL, NULL, 115433),
(115434, '3.30.460.10-FF-000078', NULL, 'Topoisomerase, putative', 126, NULL, NULL, 115434),
(115435, '1.20.1560.10-FF-000527', NULL, 'ABC multidrug transporter mdr4', 28, NULL, NULL, 115435),
(115436, '2.130.10.10-FF-002818', NULL, 'Uncharacterized protein', 142, NULL, NULL, 115436);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(115437, '1.10.287.310-FF-000002', NULL, '60S ribosomal protein L35', 77, NULL, NULL, 115437),
(115438, '2.60.120.260-FF-000059', NULL, 'Probable allantoicase', 162, NULL, NULL, 115438),
(115439, '1.50.40.10-FF-000275', NULL, 'Mitochondrial phosphate carrier 1', 279, NULL, NULL, 115439),
(115440, '3.30.70.330-FF-001491', NULL, NULL, 105, NULL, NULL, 115440),
(115441, '1.20.1440.260-FF-000002', NULL, 'YALI0F07953p', 88, NULL, NULL, 115441),
(115442, '3.40.50.150-FF-001048', NULL, 'Modification methylase', 280, NULL, NULL, 115442),
(115443, '2.60.40.10-FF-004870', NULL, NULL, 95, NULL, NULL, 115443),
(115444, '1.25.40.820-FF-000026', NULL, 'RNA polymerase II-associated protein 2', 170, NULL, NULL, 115444),
(115445, '3.30.470.20-FF-000227', NULL, 'Glutathione synthetase', 108, NULL, NULL, 115445),
(115446, '1.20.91.20-FF-000003', NULL, 'Complement C4-A', 52, NULL, NULL, 115446),
(115447, '1.20.120.350-FF-000220', NULL, NULL, 52, NULL, NULL, 115447),
(115448, '3.40.50.300-FF-003151', NULL, 'Mismatch repair protein MSH8, putative', 284, NULL, NULL, 115448),
(115449, '3.30.160.60-FF-005483', NULL, NULL, 43, NULL, NULL, 115449),
(115450, '3.40.30.10-FF-000635', NULL, 'Glutathione peroxidase', 140, NULL, NULL, 115450),
(115451, '2.40.160.120-FF-000030', NULL, 'Oxysterol binding protein', 183, NULL, NULL, 115451),
(115452, '1.20.120.350-FF-000225', NULL, NULL, 136, NULL, NULL, 115452),
(115453, '2.130.10.10-FF-004842', NULL, 'Uncharacterized protein', 132, NULL, NULL, 115453),
(115454, '3.40.50.300-FF-005753', NULL, 'DNA replication licensing factor, MCM2/3/5 family', 128, NULL, NULL, 115454),
(115455, '3.80.10.10-FF-001144', NULL, 'Leucine rich repeats and death domain containing 1', 102, NULL, NULL, 115455),
(115456, '1.20.920.10-FF-000135', NULL, 'Transcription regulatory protein SNF2', 100, NULL, NULL, 115456),
(115457, '3.40.395.10-FF-000002', NULL, 'Putative sentrin-specific protease 5', 225, NULL, NULL, 115457),
(115458, '2.102.10.10-FF-000050', NULL, 'Archaeal Rieske-type ferredoxin (Arf)', 108, NULL, NULL, 115458),
(115459, '3.40.30.10-FF-000079', NULL, 'UBX domain-containing protein 7', 112, NULL, NULL, 115459),
(115460, '3.40.50.150-FF-000559', NULL, 'Proliferating-cell nucleolar antigen p120, putative', 216, NULL, NULL, 115460),
(115461, '2.60.40.150-FF-000495', NULL, 'Synaptotagmin-C', 144, NULL, NULL, 115461),
(115462, '3.80.10.10-FF-000632', NULL, 'DNA repair protein Rad7, protein', 96, NULL, NULL, 115462),
(115463, '1.10.1420.10-FF-000188', NULL, 'DNA mismatch repair protein', 131, NULL, NULL, 115463),
(115464, '3.40.640.10-FF-000348', NULL, 'Spore coat polysaccharide biosynthesis proteinSpsC', 211, NULL, NULL, 115464),
(115465, '3.30.500.40-FF-000001', NULL, 'Zinc finger, FYVE domain-containing 9a', 153, NULL, NULL, 115465),
(115466, '2.130.10.10-FF-005354', NULL, 'Uncharacterized protein', 176, NULL, NULL, 115466),
(115467, '3.40.1160.10-FF-000086', NULL, 'Amino-acid acetyltransferase, mitochondrial', 242, NULL, NULL, 115467),
(115468, '2.130.10.10-FF-001065', NULL, 'Dual oxidase maturation factor, putative', 278, NULL, NULL, 115468),
(115469, '2.20.25.20-FF-000017', NULL, 'Casein kinase II subunit beta', 73, NULL, NULL, 115469),
(115470, '3.30.40.10-FF-002025', NULL, 'Uncharacterized protein', 22, NULL, NULL, 115470),
(115471, '1.25.40.10-FF-004633', NULL, 'Serine/threonine-protein phosphatase', 144, NULL, NULL, 115471),
(115472, '3.90.370.10-FF-000001', NULL, 'Metalloproteinase inhibitor 3', 82, NULL, NULL, 115472),
(115473, '2.40.30.10-FF-000475', NULL, 'Uncharacterized protein', 58, NULL, NULL, 115473),
(115474, '3.40.50.2000-FF-000978', NULL, 'Mannosyltransferase', 80, NULL, NULL, 115474),
(115475, '3.30.420.10-FF-000424', NULL, NULL, 140, NULL, NULL, 115475),
(115476, '1.10.472.130-FF-000050', NULL, 'Dynein heavy chain, putative', 165, NULL, NULL, 115476),
(115477, '2.30.30.140-FF-000266', NULL, 'NuA4 complex subunit EAF3 homolog', 89, NULL, NULL, 115477),
(115478, '1.10.418.10-FF-000200', NULL, 'Plastin 2 putative', 70, NULL, NULL, 115478),
(115479, '1.25.40.10-FF-005145', NULL, 'Uncharacterized protein', 96, NULL, NULL, 115479);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(115480, '3.30.559.10-FF-000150', NULL, 'Siderophore peptide synthetase fer3', 187, NULL, NULL, 115480),
(115481, '2.40.110.10-FF-000020', NULL, 'Putative acyl-CoA dehydrogenase YdbM', 96, NULL, NULL, 115481),
(115482, '3.30.70.330-FF-000439', NULL, 'La-related protein 6 isoform 1', 120, NULL, NULL, 115482),
(115483, '3.30.160.60-FF-005932', NULL, NULL, 25, NULL, NULL, 115483),
(115484, '3.30.420.40-FF-000860', NULL, 'Uncharacterized protein', 108, NULL, NULL, 115484),
(115485, '3.90.810.10-FF-000030', NULL, NULL, 72, NULL, NULL, 115485),
(115486, '1.10.10.60-FF-001161', NULL, NULL, 51, NULL, NULL, 115486),
(115487, '3.30.9.10-FF-000036', NULL, 'Chromosome 15, whole genome shotgun sequence', 173, NULL, NULL, 115487),
(115488, '4.10.280.10-FF-000076', NULL, 'hypoxia-inducible factor 3-alpha isoform X1', 63, NULL, NULL, 115488),
(115489, '1.10.472.10-FF-000606', NULL, 'Uncharacterized protein', 11, NULL, NULL, 115489),
(115490, '1.10.287.370-FF-000082', NULL, 'Uncharacterized protein', 151, NULL, NULL, 115490),
(115491, '2.130.10.10-FF-001172', NULL, 'Histone acetyltransferase subunit', 401, NULL, NULL, 115491),
(115492, '2.30.29.30-FF-000826', NULL, 'FACT complex subunit POB3', 111, NULL, NULL, 115492),
(115493, '2.30.40.10-FF-000167', NULL, 'Guanine deaminase', 64, NULL, NULL, 115493),
(115494, '2.20.130.20-FF-000006', NULL, 'Alpha-2-macroglobulin', 118, NULL, NULL, 115494),
(115495, '2.60.220.30-FF-000030', NULL, 'Uncharacterized protein', 99, NULL, NULL, 115495),
(115496, '2.60.40.10-FF-003341', NULL, 'Plexin b1a', 139, NULL, NULL, 115496),
(115497, '2.60.200.40-FF-000020', NULL, 'Diacylglycerol kinase', 108, NULL, NULL, 115497),
(115498, '2.30.29.30-FF-000820', NULL, 'Phosphoinositide phospholipase C', 71, NULL, NULL, 115498),
(115499, '3.40.80.10-FF-000032', NULL, 'N-acetylmuramoyl-L-alanine amidase family 2', 174, NULL, NULL, 115499),
(115500, '3.40.50.1000-FF-000566', NULL, NULL, 107, NULL, NULL, 115500),
(115501, '1.10.10.410-FF-000008', NULL, 'Aspartyl-glutamyl-tRNA amidotransferase subunit B protein', 61, NULL, NULL, 115501),
(115502, '1.10.30.10-FF-000113', NULL, 'GH11850p', 82, NULL, NULL, 115502),
(115503, '1.25.40.180-FF-000025', NULL, 'MIF4G domain containing a', 221, NULL, NULL, 115503),
(115504, '1.10.238.10-FF-000888', NULL, 'Uncharacterized protein', 167, NULL, NULL, 115504),
(115505, '1.10.238.10-FF-000102', NULL, 'Peptidylprolyl isomerase', 81, NULL, NULL, 115505),
(115506, '2.60.120.200-FF-000524', NULL, 'Uncharacterized protein', 188, NULL, NULL, 115506),
(115507, '3.40.50.2300-FF-000973', NULL, NULL, 109, NULL, NULL, 115507),
(115508, '2.60.220.50-FF-000018', NULL, 'Adhesion G protein-coupled receptor G6', 171, NULL, NULL, 115508),
(115509, '2.20.25.10-FF-000121', NULL, 'DNA-directed RNA polymerase subunit', 37, NULL, NULL, 115509),
(115510, '1.25.40.470-FF-000005', NULL, 'Intraflagellar transport protein 122 homolog', 121, NULL, NULL, 115510),
(115511, '1.10.4020.10-FF-000012', NULL, 'Uncharacterized protein', 93, NULL, NULL, 115511),
(115512, '3.40.1110.10-FF-000482', NULL, NULL, 132, NULL, NULL, 115512),
(115513, '3.40.140.10-FF-000097', NULL, 'Cytidine deaminase-like protein', 151, NULL, NULL, 115513),
(115514, '3.80.10.10-FF-001251', NULL, 'Leucine rich repeats (6 copies)/Leucine Rich repeat', 278, NULL, NULL, 115514),
(115515, '3.30.2160.10-FF-000049', NULL, 'E3 ubiquitin-protein ligase UPL1', 26, NULL, NULL, 115515),
(115516, '3.30.160.60-FF-001750', NULL, 'Zinc finger protein 222', 31, NULL, NULL, 115516),
(115517, '2.70.160.11-FF-000034', NULL, 'Protein arginine N-methyltransferase', 191, NULL, NULL, 115517),
(115518, '3.40.50.720-FF-000409', NULL, 'NADPH HC toxin reductase', 333, NULL, NULL, 115518),
(115519, '3.90.1210.10-FF-000006', NULL, NULL, 67, NULL, NULL, 115519),
(115520, '1.10.3470.10-FF-000034', NULL, 'Iron ABC transporter permease', 335, NULL, NULL, 115520),
(115521, '2.60.120.200-FF-000417', NULL, 'Uncharacterized protein', 77, NULL, NULL, 115521),
(115522, '2.60.40.1530-FF-000013', NULL, 'Integrin alpha 4', 187, NULL, NULL, 115522),
(115523, '3.20.20.70-FF-000625', NULL, NULL, 288, NULL, NULL, 115523);
INSERT INTO "PUBLIC"."MODEL" VALUES
(115524, '3.40.220.10-FF-000024', NULL, 'Probable cytosol aminopeptidase', 154, NULL, NULL, 115524),
(115525, '3.40.50.12780-FF-000131', NULL, 'Acyl-CoA synthetase', 420, NULL, NULL, 115525),
(115526, '2.130.10.10-FF-005247', NULL, 'Uncharacterized WD repeat-containing protein C3D6.12', 295, NULL, NULL, 115526),
(115527, '1.20.1080.10-FF-000029', NULL, 'Aquaporin NIP1-1', 270, NULL, NULL, 115527),
(115528, '3.40.1390.30-FF-000013', NULL, 'GTP cyclohydrolase 1 type 2 homolog', 107, NULL, NULL, 115528),
(115529, '3.30.710.10-FF-000165', NULL, 'Blast:Protein jim lovell', 120, NULL, NULL, 115529),
(115530, '1.20.58.390-FF-000002', NULL, 'Putative gamma-aminobutyric acid receptor subunit alpha-5', 140, NULL, NULL, 115530),
(115531, '3.10.410.10-FF-000001', NULL, 'Putative formate--tetrahydrofolate ligase', 90, NULL, NULL, 115531),
(115532, '2.170.140.10-FF-000053', NULL, 'Obstructor-J', 62, NULL, NULL, 115532),
(115533, '3.40.50.720-FF-001944', NULL, 'Uncharacterized protein', 270, NULL, NULL, 115533),
(115534, '3.30.160.60-FF-003785', NULL, 'Ras-responsive element-binding protein 1b', 45, NULL, NULL, 115534),
(115535, '1.20.1270.280-FF-000025', NULL, 'Putative dynein heavy chain', 170, NULL, NULL, 115535),
(115536, '3.40.50.300-FF-002987', NULL, 'RecBCD enzyme subunit RecD', 118, NULL, NULL, 115536),
(115537, '2.60.40.420-FF-000036', NULL, 'L-ascorbate oxidase', 130, NULL, NULL, 115537),
(115538, '1.10.20.10-FF-000287', NULL, NULL, 70, NULL, NULL, 115538),
(115539, '3.30.70.330-FF-000872', NULL, 'Npl3p', 83, NULL, NULL, 115539),
(115540, '2.60.40.150-FF-000500', NULL, 'synaptotagmin-7', 137, NULL, NULL, 115540),
(115541, '2.60.40.60-FF-000017', NULL, 'Cadherin 24', 107, NULL, NULL, 115541),
(115542, '3.30.710.10-FF-000272', NULL, 'Uncharacterized protein', 155, NULL, NULL, 115542),
(115543, '3.40.50.410-FF-000204', NULL, 'ATP-dependent DNA helicase II subunit 2', 220, NULL, NULL, 115543),
(115544, '1.20.900.10-FF-000122', NULL, 'Uncharacterized protein', 143, NULL, NULL, 115544),
(115545, '3.30.499.10-FF-000004', NULL, 'Aconitate hydratase, mitochondrial', 200, NULL, NULL, 115545),
(115546, '3.40.50.720-FF-002326', NULL, 'glyoxylate reductase/hydroxypyruvate reductase', 120, NULL, NULL, 115546),
(115547, '3.40.50.10330-FF-000076', NULL, 'Inorganic polyphosphate/ATP-NAD kinase, putative', 136, NULL, NULL, 115547),
(115548, '3.20.20.70-FF-000518', NULL, 'Tungsten-containing aldehyde ferredoxin oxidoreductase cofactor modifying protein', 285, NULL, NULL, 115548),
(115549, '2.40.100.10-FF-000087', NULL, 'Peptidyl-prolyl cis-trans isomerase', 84, NULL, NULL, 115549),
(115550, '3.40.720.10-FF-000068', NULL, 'Predicted protein', 290, NULL, NULL, 115550),
(115551, '3.30.160.60-FF-003678', NULL, NULL, 30, NULL, NULL, 115551),
(115552, '1.10.510.10-FF-001533', NULL, 'Serine/threonine-protein kinase', 203, NULL, NULL, 115552),
(115553, '1.20.1560.10-FF-000504', NULL, 'Uncharacterized protein', 303, NULL, NULL, 115553),
(115554, '1.10.238.10-FF-000995', NULL, 'Defective in cullin neddylation protein 1', 88, NULL, NULL, 115554),
(115555, '1.10.8.960-FF-000001', NULL, 'Glutamate--cysteine ligase catalytic subunit', 59, NULL, NULL, 115555),
(115556, '1.20.1330.10-FF-000010', NULL, 'Flagellin', 191, NULL, NULL, 115556),
(115557, '2.60.420.10-FF-000016', NULL, 'Cyclic beta 1-2 glucan synthetase', 76, NULL, NULL, 115557),
(115558, '2.130.10.10-FF-002369', NULL, 'Chromosome 8, whole genome shotgun sequence', 137, NULL, NULL, 115558),
(115559, '2.60.40.10-FF-001424', NULL, 'Triggering receptor expressed on myeloid cells like 1', 106, NULL, NULL, 115559),
(115560, '3.40.50.2000-FF-000074', NULL, 'Alpha-(1-2)-phosphatidylinositol mannosyltransferase', 175, NULL, NULL, 115560),
(115561, '3.30.230.10-FF-000027', NULL, 'Mevalonate kinase', 224, NULL, NULL, 115561),
(115562, '1.10.472.10-FF-000713', NULL, 'G2/M mitosis-specific cyclin B, copy C-like protein', 43, NULL, NULL, 115562),
(115563, '3.40.50.12780-FF-000024', NULL, 'Nonribosomal siderophore peptide synthase SidC', 405, NULL, NULL, 115563),
(115564, '3.40.1770.10-FF-000003', NULL, 'Urocanate hydratase 1', 221, NULL, NULL, 115564);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(115565, '2.60.120.10-FF-000090', NULL, 'Sodium/hydrogen exchanger 7', 138, NULL, NULL, 115565),
(115566, '2.80.10.50-FF-000130', NULL, 'Uncharacterized protein', 96, NULL, NULL, 115566),
(115567, '3.80.10.10-FF-002993', NULL, 'Uncharacterized protein', 120, NULL, NULL, 115567),
(115568, '1.10.10.10-FF-000011', NULL, 'Phosphate regulon transcriptional regulator PhoB', 106, NULL, NULL, 115568),
(115569, '1.10.510.10-FF-002837', NULL, 'Serine/threonine-protein kinase B', 288, NULL, NULL, 115569),
(115570, '3.40.50.300-FF-002768', NULL, 'ATP-dependent DEAD/H RNA helicase, putative', 228, NULL, NULL, 115570),
(115571, '1.20.140.10-FF-000053', NULL, 'Acyl-CoA dehydrogenase', 154, NULL, NULL, 115571),
(115572, '1.25.70.10-FF-000060', NULL, NULL, 192, NULL, NULL, 115572),
(115573, '2.60.40.1970-FF-000010', NULL, 'YEATS family, putative', 164, NULL, NULL, 115573),
(115574, '2.30.180.10-FF-000015', NULL, 'Fasciclin-like arabinogalactan protein 3', 147, NULL, NULL, 115574),
(115575, '1.20.1250.20-FF-001479', NULL, 'Uncharacterized protein', 336, NULL, NULL, 115575),
(115576, '1.20.5.110-FF-000177', NULL, 'Tetratricopeptide repeat family protein', 73, NULL, NULL, 115576),
(115577, '1.20.5.320-FF-000015', NULL, 'Fibritin', 91, NULL, NULL, 115577),
(115578, '1.10.510.10-FF-002949', NULL, NULL, 82, NULL, NULL, 115578),
(115579, '3.40.50.1260-FF-000031', NULL, 'Phosphoglycerate kinase 1', 209, NULL, NULL, 115579),
(115580, '2.80.10.50-FF-000242', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 88, NULL, NULL, 115580),
(115581, '2.60.210.10-FF-000079', NULL, NULL, 131, NULL, NULL, 115581),
(115582, '3.40.1390.20-FF-000016', NULL, 'Inorganic pyrophosphatase', 109, NULL, NULL, 115582),
(115583, '2.40.30.10-FF-000368', NULL, 'Ribosome-releasing factor 2, mitochondrial', 111, NULL, NULL, 115583),
(115584, '3.40.50.1820-FF-000570', NULL, 'At5g44250', 129, NULL, NULL, 115584),
(115585, '3.40.850.10-FF-000274', NULL, 'Kinesin-like protein KIF7', 118, NULL, NULL, 115585),
(115586, '3.10.110.10-FF-000298', NULL, 'Uncharacterized protein', 102, NULL, NULL, 115586),
(115587, '3.30.160.60-FF-005128', NULL, NULL, 37, NULL, NULL, 115587),
(115588, '4.10.400.10-FF-000070', NULL, 'low-density lipoprotein receptor-related protein 1B', 38, NULL, NULL, 115588),
(115589, '3.30.930.10-FF-000159', NULL, 'Octanoyltransferase', 209, NULL, NULL, 115589),
(115590, '3.40.50.300-FF-001571', NULL, 'Deoxynucleoside kinase', 203, NULL, NULL, 115590),
(115591, '1.50.40.10-FF-000516', NULL, 'Uncharacterized mitochondrial carrier C8C9.12c', 190, NULL, NULL, 115591),
(115592, '3.90.320.10-FF-000066', NULL, 'Chromosome 15, whole genome shotgun sequence', 176, NULL, NULL, 115592),
(115593, '2.30.30.40-FF-000001', NULL, 'Sorbin and SH3 domain-containing protein 1 isoform 2', 58, NULL, NULL, 115593),
(115594, '1.25.10.10-FF-000646', NULL, 'HEAT repeat protein', 406, NULL, NULL, 115594),
(115595, '3.40.980.10-FF-000042', NULL, 'Putative molybdopterin biosynthesis protein MJ0666', 146, NULL, NULL, 115595),
(115596, '3.50.50.60-FF-000538', NULL, 'Ferredoxin--NADP reductase', 120, NULL, NULL, 115596),
(115597, '3.40.50.1820-FF-001082', NULL, 'Uncharacterized protein', 200, NULL, NULL, 115597),
(115598, '1.25.10.10-FF-001135', NULL, 'Protein CBG10339', 214, NULL, NULL, 115598),
(115599, '3.40.30.10-FF-000186', NULL, 'Thioredoxin-like protein AAED1', 151, NULL, NULL, 115599),
(115600, '1.20.1070.10-FF-000771', NULL, 'Uncharacterized protein', 307, NULL, NULL, 115600),
(115601, '3.40.50.2000-FF-000293', NULL, 'Uncharacterized protein', 15, NULL, NULL, 115601),
(115602, '3.40.50.300-FF-002083', NULL, 'Nicotinamide riboside kinase 2', 106, NULL, NULL, 115602),
(115603, '2.60.40.150-FF-000388', NULL, 'Myosin light chain kinase, putative', 138, NULL, NULL, 115603),
(115604, '3.30.200.20-FF-001141', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 91, NULL, NULL, 115604),
(115605, '1.20.120.310-FF-000005', NULL, 'Sulfhydryl oxidase', 148, NULL, NULL, 115605),
(115606, '2.60.220.50-FF-000148', NULL, 'Uncharacterized protein', 186, NULL, NULL, 115606);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(115607, '1.10.630.10-FF-000171', NULL, 'Putative cytochrome P450 128', 405, NULL, NULL, 115607),
(115608, '3.10.110.10-FF-000309', NULL, 'Uncharacterized protein', 78, NULL, NULL, 115608),
(115609, '3.40.1110.10-FF-000370', NULL, NULL, 176, NULL, NULL, 115609),
(115610, '3.40.50.12620-FF-000004', NULL, NULL, 101, NULL, NULL, 115610),
(115611, '2.130.10.10-FF-004735', NULL, 'EF hand family protein', 163, NULL, NULL, 115611),
(115612, '3.40.50.300-FF-003499', NULL, 'Dynein heavy chain family protein', 212, NULL, NULL, 115612),
(115613, '3.10.20.230-FF-000016', NULL, 'Serine/threonine-protein kinase DCLK1', 67, NULL, NULL, 115613),
(115614, '1.25.40.10-FF-002267', NULL, 'Pentatricopeptide repeat-containing protein At1g26460, mitochondrial', 221, NULL, NULL, 115614),
(115615, '2.60.40.10-FF-005590', NULL, NULL, 112, NULL, NULL, 115615),
(115616, '3.30.70.120-FF-000034', NULL, NULL, 103, NULL, NULL, 115616),
(115617, '1.25.40.20-FF-000128', NULL, 'short transient receptor potential channel 5', 162, NULL, NULL, 115617),
(115618, '2.60.260.20-FF-000147', NULL, 'DnaJ-like subfamily B member 1', 78, NULL, NULL, 115618),
(115619, '3.40.50.2000-FF-000079', NULL, 'Trehalose-6-phosphate synthase 8', 259, NULL, NULL, 115619),
(115620, '1.10.418.10-FF-000088', NULL, 'Alpha-actinin, sarcomeric', 112, NULL, NULL, 115620),
(115621, '1.20.1250.20-FF-002103', NULL, 'Uncharacterized protein', 241, NULL, NULL, 115621),
(115622, '3.30.200.20-FF-002552', NULL, 'Os11g0691300 protein', 82, NULL, NULL, 115622),
(115623, '1.10.10.10-FF-000466', NULL, 'Z-DNA binding protein 1', 71, NULL, NULL, 115623),
(115624, '2.40.240.20-FF-000010', NULL, 'Ribosomal RNA small subunit methyltransferase E', 72, NULL, NULL, 115624),
(115625, '1.20.5.350-FF-000018', NULL, NULL, 163, NULL, NULL, 115625),
(115626, '3.30.470.10-FF-000028', NULL, 'Aminodeoxychorismate lyase', 93, NULL, NULL, 115626),
(115627, '2.20.25.690-FF-000001', NULL, 'Tripeptidyl-peptidase 2', 62, NULL, NULL, 115627),
(115628, '3.30.450.20-FF-000451', NULL, 'Calcium channel, voltage-dependent, alpha 2/delta subunit 2b', 130, NULL, NULL, 115628),
(115629, '3.40.50.720-FF-001028', NULL, 'Glucose-6-phosphate 1-dehydrogenase', 175, NULL, NULL, 115629),
(115630, '2.130.10.10-FF-005224', NULL, 'Uncharacterized protein', 73, NULL, NULL, 115630),
(115631, '3.30.40.10-FF-001513', NULL, 'Uncharacterized protein', 73, NULL, NULL, 115631),
(115632, '1.20.1250.20-FF-002092', NULL, 'Uncharacterized protein', 259, NULL, NULL, 115632),
(115633, '3.30.70.330-FF-001384', NULL, 'Polyadenylate-binding protein', 104, NULL, NULL, 115633),
(115634, '3.10.450.10-FF-000003', NULL, 'Cathelicidin antimicrobial peptide', 103, NULL, NULL, 115634),
(115635, '1.10.510.10-FF-003349', NULL, NULL, 238, NULL, NULL, 115635),
(115636, '3.20.20.70-FF-000406', NULL, 'Pyridoxal 5''-phosphate synthase subunit PdxS', 335, NULL, NULL, 115636),
(115637, '3.40.50.1170-FF-000004', NULL, 'L-asparaginase, type I', 214, NULL, NULL, 115637),
(115638, '1.10.3380.30-FF-000033', NULL, 'ATP-dependent DNA helicase Hel308', 222, NULL, NULL, 115638),
(115639, '2.30.30.100-FF-000046', NULL, 'RNA-binding protein Hfq', 79, NULL, NULL, 115639),
(115640, '1.10.238.10-FF-000214', NULL, 'Calcium-binding protein CML42', 66, NULL, NULL, 115640),
(115641, '3.40.50.2020-FF-000181', NULL, 'AER083Cp', 130, NULL, NULL, 115641),
(115642, '3.30.160.60-FF-001880', NULL, 'zinc finger protein 69 homolog isoform X2', 30, NULL, NULL, 115642),
(115643, '3.30.70.270-FF-000051', NULL, 'Genome polyprotein', 68, NULL, NULL, 115643),
(115644, '1.10.8.500-FF-000009', NULL, 'HAMP domain protein', 54, NULL, NULL, 115644),
(115645, '3.40.50.300-FF-001138', NULL, 'Structural maintenance of chromosomes protein 6', 191, NULL, NULL, 115645),
(115646, '2.60.40.10-FF-001205', NULL, 'Receptor-type tyrosine-protein phosphatase O', 115, NULL, NULL, 115646),
(115647, '2.20.70.10-FF-000192', NULL, 'Uncharacterized protein', 56, NULL, NULL, 115647),
(115648, '1.20.5.10-FF-000003', NULL, 'Adenomatous polyposis coli protein 2', 54, NULL, NULL, 115648),
(115649, '1.10.510.10-FF-002152', NULL, NULL, 101, NULL, NULL, 115649); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(115650, '1.20.1070.10-FF-001260', NULL, 'Uncharacterized protein', 78, NULL, NULL, 115650),
(115651, '2.120.10.80-FF-000417', NULL, 'Uncharacterized protein', 298, NULL, NULL, 115651),
(115652, '1.10.472.80-FF-000239', NULL, NULL, 135, NULL, NULL, 115652),
(115653, '3.10.250.10-FF-000022', NULL, 'lysyl oxidase homolog 3 isoform X2', 110, NULL, NULL, 115653),
(115654, '3.30.160.60-FF-003566', NULL, NULL, 28, NULL, NULL, 115654),
(115655, '3.30.450.70-FF-000005', NULL, 'Trafficking protein particle complex subunit 2-like protein', 139, NULL, NULL, 115655),
(115656, '1.25.40.180-FF-000020', NULL, 'Eukaryotic translation initiation factor subunit', 250, NULL, NULL, 115656),
(115657, '3.80.10.10-FF-001032', NULL, 'Os06g0557100 protein', 93, NULL, NULL, 115657),
(115658, '1.20.1440.240-FF-000002', NULL, 'Amine oxidase', 96, NULL, NULL, 115658),
(115659, '3.30.310.220-FF-000001', NULL, 'Probable serine/threonine-protein kinase KCC4', 127, NULL, NULL, 115659),
(115660, '1.20.120.350-FF-000113', NULL, 'Uncharacterized protein', 126, NULL, NULL, 115660),
(115661, '3.40.630.30-FF-000393', NULL, 'Glr1099 protein', 167, NULL, NULL, 115661),
(115662, '1.25.40.10-FF-000474', NULL, 'Pentatricopeptide repeat protein PPR986-12', 216, NULL, NULL, 115662),
(115663, '1.20.5.350-FF-000013', NULL, NULL, 86, NULL, NULL, 115663),
(115664, '1.10.510.10-FF-004411', NULL, NULL, 78, NULL, NULL, 115664),
(115665, '1.10.10.10-FF-001427', NULL, 'Transcriptional regulator', 98, NULL, NULL, 115665),
(115666, '3.10.20.90-FF-000362', NULL, 'Ubiquitin-like protein ATG12', 90, NULL, NULL, 115666),
(115667, '3.30.559.10-FF-000262', NULL, 'Dihydrolipoyllysine-residue succinyltransferase component of 2-oxoglutarate dehydrogenase complex, mitochondrial', 79, NULL, NULL, 115667),
(115668, '1.10.10.160-FF-000012', NULL, 'DNA helicase', 77, NULL, NULL, 115668),
(115669, '3.30.1490.50-FF-000001', NULL, 'Glutathione synthetase', 68, NULL, NULL, 115669),
(115670, '3.30.710.10-FF-000053', NULL, 'potassium voltage-gated channel subfamily A member 4', 100, NULL, NULL, 115670),
(115671, '3.40.1090.10-FF-000092', NULL, 'Patatin-like phospholipase domain-containing protein 2', 188, NULL, NULL, 115671),
(115672, '3.10.20.90-FF-000710', NULL, 'Autophagy protein 5', 120, NULL, NULL, 115672),
(115673, '1.20.1070.10-FF-002114', NULL, 'Uncharacterized protein', 71, NULL, NULL, 115673),
(115674, '1.25.40.10-FF-004745', NULL, 'Os08g0153600 protein', 71, NULL, NULL, 115674),
(115675, '3.40.50.450-FF-000076', NULL, '6-phosphofructokinase, pyrophosphate-dependent', 215, NULL, NULL, 115675),
(115676, '3.30.70.3000-FF-000011', NULL, 'Uncharacterized protein', 97, NULL, NULL, 115676),
(115677, '3.80.10.10-FF-000762', NULL, 'probable inactive leucine-rich repeat receptor-like protein kinase At3g03770', 121, NULL, NULL, 115677),
(115678, '3.40.1350.10-FF-000016', NULL, 'tRNA-splicing endonuclease subunit Sen34', 104, NULL, NULL, 115678),
(115679, '2.60.120.380-FF-000084', NULL, 'Uncharacterized protein', 116, NULL, NULL, 115679),
(115680, '3.40.50.300-FF-000059', NULL, 'ABC transporter G family member 40', 231, NULL, NULL, 115680),
(115681, '3.40.50.300-FF-004011', NULL, 'Uncharacterized protein', 199, NULL, NULL, 115681),
(115682, '1.20.1250.20-FF-000523', NULL, 'MFS multidrug transporter, putative', 193, NULL, NULL, 115682),
(115683, '3.90.550.50-FF-000100', NULL, 'Uncharacterized protein', 265, NULL, NULL, 115683),
(115684, '3.40.50.2300-FF-000843', NULL, 'Uncharacterized protein', 270, NULL, NULL, 115684),
(115685, '1.20.5.30-FF-000009', NULL, NULL, 26, NULL, NULL, 115685),
(115686, '3.30.70.3490-FF-000017', NULL, 'Oxysterol binding protein (Orp8), putative', 84, NULL, NULL, 115686),
(115687, '2.30.30.140-FF-000154', NULL, 'Histone acetyltransferase', 125, NULL, NULL, 115687),
(115688, '1.10.3430.10-FF-000037', NULL, 'Ammonium transporter', 422, NULL, NULL, 115688),
(115689, '1.10.238.10-FF-000107', NULL, 'Troponin C, skeletal muscle', 160, NULL, NULL, 115689),
(115690, '1.20.1270.60-FF-000290', NULL, 'Protein kinase C and casein kinase substrate in neurons 1a', 163, NULL, NULL, 115690);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(115691, '2.60.40.790-FF-000113', NULL, NULL, 76, NULL, NULL, 115691),
(115692, '1.20.120.160-FF-000045', NULL, 'PAS sensor protein', 120, NULL, NULL, 115692),
(115693, '2.40.420.20-FF-000001', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 93, NULL, NULL, 115693),
(115694, '2.30.30.140-FF-000261', NULL, 'Histone acetyltransferase', 89, NULL, NULL, 115694),
(115695, '3.30.9.10-FF-000148', NULL, 'Aerobic glycerol-3-phosphate dehydrogenase', 156, NULL, NULL, 115695),
(115696, '1.25.40.10-FF-002609', NULL, 'Uncharacterized protein', 149, NULL, NULL, 115696),
(115697, '3.90.228.10-FF-000019', NULL, 'Poly [ADP-ribose] polymerase', 214, NULL, NULL, 115697),
(115698, '1.10.560.10-FF-000070', NULL, 'Uncharacterized protein', 113, NULL, NULL, 115698),
(115699, '3.30.1490.70-FF-000007', NULL, 'Unplaced genomic scaffold supercont2.7, whole genome shotgun sequence', 71, NULL, NULL, 115699),
(115700, '1.25.40.10-FF-005015', NULL, 'Pentatricopeptide repeat-containing protein At5g39710', 114, NULL, NULL, 115700),
(115701, '3.30.559.10-FF-000155', NULL, 'Non-ribosomal peptide synthetase', 195, NULL, NULL, 115701),
(115702, '1.50.10.10-FF-000003', NULL, 'Cytoplasmic trehalase', 498, NULL, NULL, 115702),
(115703, '3.40.50.300-FF-007658', NULL, 'Uncharacterized protein', 129, NULL, NULL, 115703),
(115704, '1.20.1070.10-FF-001945', NULL, 'Uncharacterized protein', 303, NULL, NULL, 115704),
(115705, '2.180.10.10-FF-000023', NULL, 'Predicted protein', 93, NULL, NULL, 115705),
(115706, '3.60.10.10-FF-000133', NULL, 'INositol Polyphosphate-5-Phosphatase', 327, NULL, NULL, 115706),
(115707, '3.40.1160.10-FF-000081', NULL, 'Aspartokinase', 300, NULL, NULL, 115707),
(115708, '3.30.750.24-FF-000153', NULL, 'Predicted protein', 122, NULL, NULL, 115708),
(115709, '2.60.40.1930-FF-000026', NULL, 'MHC-linked complement C4', 107, NULL, NULL, 115709),
(115710, '3.40.50.980-FF-000004', NULL, '2,3-dihydroxybenzoate-AMP ligase', 160, NULL, NULL, 115710),
(115711, '3.50.50.60-FF-000994', NULL, 'Probable polyamine oxidase 5', 156, NULL, NULL, 115711),
(115712, '1.25.10.10-FF-001591', NULL, 'Importin-beta N-terminal domain containing protein', 876, NULL, NULL, 115712),
(115713, '3.40.50.11660-FF-000019', NULL, 'Uncharacterized protein', 212, NULL, NULL, 115713),
(115714, '3.30.230.10-FF-000246', NULL, 'DNA topoisomerase 2', 123, NULL, NULL, 115714),
(115715, '2.60.40.10-FF-000031', NULL, 'Myosin-binding protein C, slow type', 96, NULL, NULL, 115715),
(115716, '3.10.50.40-FF-000091', NULL, 'HEN1 protein', 148, NULL, NULL, 115716),
(115717, '3.40.50.300-FF-003387', NULL, 'UMP-CMP kinase, putative', 107, NULL, NULL, 115717),
(115718, '3.50.30.30-FF-000107', NULL, 'Naaladl1 protein', 189, NULL, NULL, 115718),
(115719, '1.10.287.70-FF-000177', NULL, 'Cation channel sperm associated 4', 143, NULL, NULL, 115719),
(115720, '3.40.190.10-FF-000605', NULL, 'ABC transporter substrate-binding protein', 147, NULL, NULL, 115720),
(115721, '2.30.26.10-FF-000004', NULL, 'Dihydroorotate dehydrogenase family protein', 47, NULL, NULL, 115721),
(115722, '2.60.40.820-FF-000049', NULL, 'Uncharacterized protein', 57, NULL, NULL, 115722),
(115723, '1.10.472.80-FF-000003', NULL, 'Putative TBC1 domain family member 1', 154, NULL, NULL, 115723),
(115724, '1.10.8.10-FF-000370', NULL, 'Uncharacterized protein', 67, NULL, NULL, 115724),
(115725, '3.80.10.10-FF-002555', NULL, 'AGAP010770-PA', 143, NULL, NULL, 115725),
(115726, '3.40.30.10-FF-001147', NULL, 'Glutathione S-transferase pi 1', 43, NULL, NULL, 115726),
(115727, '1.25.40.10-FF-003565', NULL, 'Tetratricopeptide repeat, putative', 238, NULL, NULL, 115727),
(115728, '2.60.40.1910-FF-000020', NULL, 'Peptidase family m1 protein, putative', 96, NULL, NULL, 115728),
(115729, '3.40.50.410-FF-000311', NULL, 'Uncharacterized protein', 133, NULL, NULL, 115729),
(115730, '2.40.70.10-FF-000365', NULL, NULL, 104, NULL, NULL, 115730),
(115731, '2.40.70.10-FF-000258', NULL, NULL, 111, NULL, NULL, 115731),
(115732, '3.30.1050.10-FF-000035', NULL, 'Acetyltransferase', 90, NULL, NULL, 115732),
(115733, '3.40.1190.20-FF-000147', NULL, 'Carbohydrate kinase family protein', 308, NULL, NULL, 115733);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(115734, '3.90.180.10-FF-000077', NULL, 'Alcohol dehydrogenase', 46, NULL, NULL, 115734),
(115735, '1.10.287.70-FF-000284', NULL, 'Two pore potassium channel protein sup-9', 272, NULL, NULL, 115735),
(115736, '2.130.10.10-FF-004050', NULL, 'Anaphase-promoting complex subunit 4-like Protein', 216, NULL, NULL, 115736),
(115737, '2.10.25.10-FF-000329', NULL, 'Collagen and calcium-binding EGF domain-containing protein 1', 49, NULL, NULL, 115737),
(115738, '3.30.565.10-FF-000439', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', 151, NULL, NULL, 115738),
(115739, '3.30.70.270-FF-000163', NULL, 'Retrovirus-related Pol polyprotein from transposon gypsy-like Protein', 75, NULL, NULL, 115739),
(115740, '3.30.200.20-FF-002557', NULL, NULL, 68, NULL, NULL, 115740),
(115741, '1.20.1280.50-FF-000231', NULL, 'Predicted protein', 91, NULL, NULL, 115741),
(115742, '3.40.50.620-FF-000279', NULL, 'Valine-tRNA ligase', 168, NULL, NULL, 115742),
(115743, '3.40.50.200-FF-000147', NULL, 'Predicted protein', 55, NULL, NULL, 115743),
(115744, '3.40.50.880-FF-000087', NULL, 'Peptidase S51 dipeptidase E', 221, NULL, NULL, 115744),
(115745, '1.10.510.10-FF-003450', NULL, NULL, 276, NULL, NULL, 115745),
(115746, '2.170.140.10-FF-000058', NULL, 'GH13361p', 65, NULL, NULL, 115746),
(115747, '4.10.240.10-FF-000208', NULL, 'Uncharacterized protein', 68, NULL, NULL, 115747),
(115748, '3.40.50.300-FF-000514', NULL, 'Ribosome-releasing factor 2, mitochondrial', 295, NULL, NULL, 115748),
(115749, '1.25.40.20-FF-001185', NULL, 'SH3 and multiple ankyrin repeat domains 3', 84, NULL, NULL, 115749),
(115750, '1.20.5.190-FF-000167', NULL, NULL, 48, NULL, NULL, 115750),
(115751, '3.20.20.70-FF-000069', NULL, 'Dihydroorotate dehydrogenase', 301, NULL, NULL, 115751),
(115752, '3.40.50.10860-FF-000004', NULL, 'Quinate/shikimate dehydrogenase', 115, NULL, NULL, 115752),
(115753, '3.40.50.12780-FF-000136', NULL, 'L-prolyl-AMP Ligase PltF', 394, NULL, NULL, 115753),
(115754, '3.30.70.330-FF-002912', NULL, NULL, 131, NULL, NULL, 115754),
(115755, '1.25.40.1040-FF-000050', NULL, 'Uncharacterized protein', 528, NULL, NULL, 115755),
(115756, '2.60.34.10-FF-000078', NULL, 'DnaK protein', 163, NULL, NULL, 115756),
(115757, '3.30.70.330-FF-002688', NULL, NULL, 152, NULL, NULL, 115757),
(115758, '2.40.240.20-FF-000015', NULL, 'Ribosomal RNA small subunit methyltransferase E', 66, NULL, NULL, 115758),
(115759, '3.30.40.10-FF-000445', NULL, 'E3 ubiquitin-protein ligase PDZRN3 isoform X1', 61, NULL, NULL, 115759),
(115760, '3.30.230.10-FF-000139', NULL, 'DNA mismatch repair protein mlh1, putative', 125, NULL, NULL, 115760),
(115761, '3.40.20.10-FF-000028', NULL, 'Villin-like 1', 117, NULL, NULL, 115761),
(115762, '3.30.40.10-FF-000097', NULL, 'E3 ubiquitin-protein ligase DTX4', 83, NULL, NULL, 115762),
(115763, '1.20.58.60-FF-000719', NULL, 'Spectrin beta chain, non-erythrocytic 5-like Protein', 277, NULL, NULL, 115763),
(115764, '1.25.40.10-FF-001648', NULL, 'Os06g0231400 protein', 147, NULL, NULL, 115764),
(115765, '2.130.10.10-FF-000115', NULL, 'DDB1- and CUL4-associated factor 11 isoform X1', 246, NULL, NULL, 115765),
(115766, '1.10.10.41-FF-000004', NULL, 'DNA topoisomerase I', 88, NULL, NULL, 115766),
(115767, '2.60.120.470-FF-000015', NULL, NULL, 157, NULL, NULL, 115767),
(115768, '1.10.220.160-FF-000002', NULL, 'SET and MYND domain containing 1', 83, NULL, NULL, 115768),
(115769, '3.30.70.100-FF-000039', NULL, 'Carbamoyltransferase HypF', 91, NULL, NULL, 115769),
(115770, '2.40.170.20-FF-000015', NULL, 'TonB-dependent siderophore receptor', 544, NULL, NULL, 115770),
(115771, '3.90.1150.10-FF-000512', NULL, 'Protein CBG02613', 41, NULL, NULL, 115771),
(115772, '2.30.30.100-FF-000041', NULL, 'U6 snRNA-associated Sm-like protein LSm5', 76, NULL, NULL, 115772),
(115773, '3.30.200.20-FF-001933', NULL, 'Protein kinase domain-containing protein ppk3', 91, NULL, NULL, 115773),
(115774, '1.10.640.10-FF-000020', NULL, 'Heme peroxidase', 489, NULL, NULL, 115774),
(115775, '3.40.50.1820-FF-000929', NULL, 'AB-hydrolase associated lipase region containing protein', 372, NULL, NULL, 115775);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(115776, '2.30.39.10-FF-000085', NULL, 'Serine protease inhibitor serpin', 162, NULL, NULL, 115776),
(115777, '3.90.280.10-FF-000011', NULL, 'UPF0098 protein Rv2140c', 176, NULL, NULL, 115777),
(115778, '2.60.40.10-FF-005595', NULL, NULL, 86, NULL, NULL, 115778),
(115779, '1.10.238.10-FF-000091', NULL, 'Serine/threonine-protein phosphatase 2A regulatory subunit B'''' subunit gamma', 165, NULL, NULL, 115779),
(115780, '3.30.1010.10-FF-000044', NULL, 'Phosphatidylinositol 3-and 4-kinase, putative', 146, NULL, NULL, 115780),
(115781, '3.40.50.1110-FF-000144', NULL, 'Mu phage tail fiber protein GpS', 172, NULL, NULL, 115781),
(115782, '3.30.1540.20-FF-000019', NULL, 'PMS1 homolog 2, mismatch repair system component', 38, NULL, NULL, 115782),
(115783, '1.10.287.1260-FF-000006', NULL, 'Mechanosensitive ion channel protein', 115, NULL, NULL, 115783),
(115784, '1.10.565.10-FF-000058', NULL, 'Thyroid hormone receptor beta', 96, NULL, NULL, 115784),
(115785, '3.40.50.300-FF-005860', NULL, 'Uncharacterized protein', 211, NULL, NULL, 115785),
(115786, '1.20.58.60-FF-000377', NULL, 'Spectrin beta, non-erythrocytic 5', 111, NULL, NULL, 115786),
(115787, '3.90.70.10-FF-000091', NULL, 'Aminopeptidase C', 398, NULL, NULL, 115787),
(115788, '2.60.40.60-FF-000809', NULL, 'Predicted protein', 87, NULL, NULL, 115788),
(115789, '3.30.160.60-FF-004746', NULL, NULL, 73, NULL, NULL, 115789),
(115790, '3.90.640.10-FF-000106', NULL, 'Heat shock protein 70, putative', 98, NULL, NULL, 115790),
(115791, '1.10.390.10-FF-000034', NULL, 'Uncharacterized protein', 241, NULL, NULL, 115791),
(115792, '3.90.45.10-FF-000015', NULL, 'Peptide deformylase', 187, NULL, NULL, 115792),
(115793, '3.40.449.10-FF-000004', NULL, 'phosphoenolpyruvate carboxykinase [ATP]-like', 182, NULL, NULL, 115793),
(115794, '1.25.10.10-FF-003052', NULL, 'Uncharacterized protein', 276, NULL, NULL, 115794),
(115795, '1.25.40.10-FF-004526', NULL, 'Uncharacterized protein', 71, NULL, NULL, 115795),
(115796, '3.90.550.50-FF-000095', NULL, 'Beta 3-glucosyltransferase', 214, NULL, NULL, 115796),
(115797, '1.10.357.120-FF-000006', NULL, 'DNA-directed RNA polymerase subunit', 117, NULL, NULL, 115797),
(115798, '3.40.50.150-FF-000104', NULL, 'S-adenosyl-L-methionine-dependent methyltransferase', 65, NULL, NULL, 115798),
(115799, '3.30.70.240-FF-000053', NULL, 'Putative tetracycline resistance protein', 98, NULL, NULL, 115799),
(115800, '2.60.120.200-FF-000654', NULL, 'Laminin subunit alpha 5', 96, NULL, NULL, 115800),
(115801, '3.70.10.10-FF-000043', NULL, 'DNA polymerase processivity factor', 300, NULL, NULL, 115801),
(115802, '1.25.40.720-FF-000002', NULL, 'Embryo defective 2423', 137, NULL, NULL, 115802),
(115803, '2.40.40.20-FF-000074', NULL, 'DMSO reductase chain A', 167, NULL, NULL, 115803),
(115804, '3.40.50.300-FF-000301', NULL, 'Peptide transport system ATP-binding protein sapF', 262, NULL, NULL, 115804),
(115805, '1.10.8.60-FF-000013', NULL, 'DNA polymerase III subunit gamma/tau', 64, NULL, NULL, 115805),
(115806, '1.10.287.70-FF-000047', NULL, 'Sodium channel protein', 132, NULL, NULL, 115806),
(115807, '3.30.497.10-FF-000056', NULL, 'Serine protease inhibitor (SERPIN) family protein', 48, NULL, NULL, 115807),
(115808, '3.10.50.40-FF-000107', NULL, 'Peptidylprolyl isomerase', 120, NULL, NULL, 115808),
(115809, '3.40.50.1820-FF-001205', NULL, 'Uncharacterized protein', 81, NULL, NULL, 115809),
(115810, '3.30.200.20-FF-000079', NULL, 'Calcium/calmodulin-dependent protein kinase kinase 2 isoform 1', 87, NULL, NULL, 115810),
(115811, '1.20.120.340-FF-000003', NULL, 'Flagellar secretion chaperone FliS', 126, NULL, NULL, 115811),
(115812, '3.40.50.300-FF-003948', NULL, 'Transposition helper protein', 162, NULL, NULL, 115812),
(115813, '2.130.10.10-FF-005803', NULL, 'WD repeat and HMG-box DNA-binding protein 1', 88, NULL, NULL, 115813),
(115814, '3.30.70.260-FF-000059', NULL, 'Diaminopimelate decarboxylase', 73, NULL, NULL, 115814),
(115815, '3.30.40.10-FF-001406', NULL, 'Predicted protein', 76, NULL, NULL, 115815),
(115816, '1.25.40.10-FF-001305', NULL, 'Pentatricopeptide repeat-containing protein At1g14470', 79, NULL, NULL, 115816);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(115817, '3.80.10.10-FF-001936', NULL, 'Leucine-rich repeat receptor-like protein kinase PEPR1', 130, NULL, NULL, 115817),
(115818, '1.25.40.10-FF-004184', NULL, 'Uncharacterized protein', 84, NULL, NULL, 115818),
(115819, '3.40.50.10190-FF-000343', NULL, 'S-M checkpoint control protein rad4', 99, NULL, NULL, 115819),
(115820, '1.20.1070.10-FF-001153', NULL, 'Neuropeptide FF receptor 2', 345, NULL, NULL, 115820),
(115821, '2.130.10.10-FF-003431', NULL, 'Raptor, isoform B', 161, NULL, NULL, 115821),
(115822, '1.10.10.60-FF-000104', NULL, 'trihelix transcription factor ASIL2', 66, NULL, NULL, 115822),
(115823, '3.10.129.10-FF-000116', NULL, 'Thioesterase superfamily, putative', 167, NULL, NULL, 115823),
(115824, '2.60.40.2030-FF-000045', NULL, 'Adhesion G-protein-coupled receptor V1', 133, NULL, NULL, 115824),
(115825, '3.30.700.30-FF-000002', NULL, 'Propionyl-CoA carboxylase, alpha subunit', 133, NULL, NULL, 115825),
(115826, '1.10.150.300-FF-000005', NULL, 'Obg-like ATPase 1', 88, NULL, NULL, 115826),
(115827, '2.40.50.140-FF-000762', NULL, 'ABC transporter, ATP binding protein (Glucose)', 45, NULL, NULL, 115827),
(115828, '3.10.20.30-FF-000041', NULL, 'Glycine-betaine demethylase subunit GbcB', 104, NULL, NULL, 115828),
(115829, '3.80.10.10-FF-002212', NULL, 'LOC502201 protein', 154, NULL, NULL, 115829),
(115830, '4.10.240.10-FF-000079', NULL, 'TBS1p protein', 67, NULL, NULL, 115830),
(115831, '1.20.1270.280-FF-000020', NULL, 'Putative dynein heavy chain', 174, NULL, NULL, 115831),
(115832, '3.10.300.10-FF-000009', NULL, 'Uncharacterized protein', 162, NULL, NULL, 115832),
(115833, '1.20.5.170-FF-000161', NULL, 'Tropomyosin 3', 128, NULL, NULL, 115833),
(115834, '3.40.50.300-FF-008619', NULL, 'Uncharacterized protein', 208, NULL, NULL, 115834),
(115835, '3.40.50.620-FF-000149', NULL, 'Glutamate--tRNA ligase', 336, NULL, NULL, 115835),
(115836, '1.25.10.10-FF-003389', NULL, 'Nucleolar protein 9', 139, NULL, NULL, 115836),
(115837, '1.20.1250.20-FF-000175', NULL, 'Inorganic phosphate transporter 1-6', 477, NULL, NULL, 115837),
(115838, '1.10.238.10-FF-001052', NULL, 'Uncharacterized protein', 98, NULL, NULL, 115838),
(115839, '2.60.40.10-FF-003122', NULL, 'Pkd1', 91, NULL, NULL, 115839),
(115840, '2.60.120.590-FF-000034', NULL, 'Uncharacterized protein', 206, NULL, NULL, 115840),
(115841, '2.40.50.140-FF-001049', NULL, NULL, 114, NULL, NULL, 115841),
(115842, '3.80.10.10-FF-000290', NULL, 'Slit guidance ligand 1', 114, NULL, NULL, 115842),
(115843, '3.40.1280.30-FF-000016', NULL, 'tRNA methyltransferase 10 homolog A', 125, NULL, NULL, 115843),
(115844, '2.60.40.60-FF-000692', NULL, 'Predicted protein', 104, NULL, NULL, 115844),
(115845, '3.30.700.10-FF-000007', NULL, 'MSHA pilin protein MshB', 125, NULL, NULL, 115845),
(115846, '1.20.58.1030-FF-000046', NULL, 'Chromosome 7, whole genome shotgun sequence', 156, NULL, NULL, 115846),
(115847, '1.20.1050.10-FF-000078', NULL, 'Protein CBG04233', 114, NULL, NULL, 115847),
(115848, '2.130.10.10-FF-000789', NULL, 'Transcription factor (SPT8), putative', 232, NULL, NULL, 115848),
(115849, '2.30.30.1020-FF-000030', NULL, NULL, 190, NULL, NULL, 115849),
(115850, '3.30.1300.30-FF-000010', NULL, 'Serum resistance protein DrsA', 126, NULL, NULL, 115850),
(115851, '3.80.10.10-FF-000868', NULL, 'OSJNBa0064H22.13 protein', 111, NULL, NULL, 115851),
(115852, '2.40.50.140-FF-000537', NULL, 'Class II aaRS and biotin synthetase', 149, NULL, NULL, 115852),
(115853, '3.30.160.60-FF-005590', NULL, NULL, 31, NULL, NULL, 115853),
(115854, '3.40.50.970-FF-000018', NULL, '2-oxoglutarate dehydrogenase E1 component', 365, NULL, NULL, 115854),
(115855, '3.40.50.1820-FF-000132', NULL, 'caffeoylshikimate esterase', 299, NULL, NULL, 115855),
(115856, '3.40.50.10420-FF-000002', NULL, '5-formyltetrahydrofolate cyclo-ligase', 202, NULL, NULL, 115856),
(115857, '3.40.50.150-FF-001852', NULL, NULL, 30, NULL, NULL, 115857),
(115858, '3.30.200.20-FF-001484', NULL, 'AGC (cAMP-dependent, cGMP-dependent and protein kinase C) kinase family protein', 11, NULL, NULL, 115858),
(115859, '1.10.510.10-FF-003006', NULL, NULL, 94, NULL, NULL, 115859);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(115860, '2.20.25.500-FF-000001', NULL, 'Nuclear pore complex protein Nup85', 57, NULL, NULL, 115860),
(115861, '1.10.472.10-FF-000258', NULL, 'Cyclin domain-containing protein', 111, NULL, NULL, 115861),
(115862, '1.10.565.10-FF-000165', NULL, 'Nuclear Hormone Receptor family', 198, NULL, NULL, 115862),
(115863, '2.30.29.30-FF-001091', NULL, 'Uncharacterized protein', 52, NULL, NULL, 115863),
(115864, '3.60.10.10-FF-000364', NULL, 'Uncharacterized protein', 125, NULL, NULL, 115864),
(115865, '2.130.10.10-FF-003549', NULL, 'Uncharacterized protein', 126, NULL, NULL, 115865),
(115866, '1.10.510.10-FF-002388', NULL, 'Serine/threonine protein kinase-56', 275, NULL, NULL, 115866),
(115867, '3.40.250.10-FF-000088', NULL, 'Putative NADH oxidase', 95, NULL, NULL, 115867),
(115868, '1.10.287.110-FF-000150', NULL, 'Molecular chaperone DnaJ', 118, NULL, NULL, 115868),
(115869, '3.90.190.10-FF-000471', NULL, 'Uncharacterized protein', 180, NULL, NULL, 115869),
(115870, '3.30.30.30-FF-000046', NULL, 'YALI0B12474p', 53, NULL, NULL, 115870),
(115871, '2.30.30.140-FF-000030', NULL, 'Histone-lysine N-methyltransferase', 139, NULL, NULL, 115871),
(115872, '3.30.40.10-FF-001749', NULL, 'Variant in methylation102', 89, NULL, NULL, 115872),
(115873, '3.40.50.10580-FF-000010', NULL, 'V-type ATP synthase subunit F', 102, NULL, NULL, 115873),
(115874, '1.20.1070.10-FF-000203', NULL, 'gonadotropin-releasing hormone receptor', 305, NULL, NULL, 115874),
(115875, '3.40.190.80-FF-000025', NULL, 'Inositol-1-monophosphatase', 125, NULL, NULL, 115875),
(115876, '3.30.450.20-FF-000687', NULL, 'Predicted protein', 35, NULL, NULL, 115876),
(115877, '3.80.10.10-FF-003628', NULL, 'Uncharacterized protein', 224, NULL, NULL, 115877),
(115878, '3.30.160.60-FF-004639', NULL, NULL, 30, NULL, NULL, 115878),
(115879, '3.10.250.10-FF-000128', NULL, NULL, 83, NULL, NULL, 115879),
(115880, '2.60.120.200-FF-000075', NULL, 'Calreticulin', 247, NULL, NULL, 115880),
(115881, '2.60.120.10-FF-000201', NULL, 'NTE family protein', 136, NULL, NULL, 115881),
(115882, '1.20.1460.20-FF-000005', NULL, 'V-type ATP synthase subunit I', 153, NULL, NULL, 115882),
(115883, '1.10.10.10-FF-001972', NULL, 'Uncharacterized protein', 65, NULL, NULL, 115883),
(115884, '3.90.70.10-FF-000107', NULL, 'General secretion pathway protein A', 118, NULL, NULL, 115884),
(115885, '3.40.1380.20-FF-000066', NULL, 'Pyruvate kinase', 115, NULL, NULL, 115885),
(115886, '3.40.50.1450-FF-000004', NULL, 'Germination protease', 367, NULL, NULL, 115886),
(115887, '3.30.160.60-FF-001312', NULL, 'Histone-lysine N-methyltransferase PRDM9', 32, NULL, NULL, 115887),
(115888, '3.30.300.10-FF-000022', NULL, 'GMP synthase (glutamine-hydrolyzing)', 104, NULL, NULL, 115888),
(115889, '3.30.450.40-FF-000120', NULL, 'Sensory transduction histidine kinase', 168, NULL, NULL, 115889),
(115890, '1.25.10.10-FF-002321', NULL, 'Uncharacterized protein', 308, NULL, NULL, 115890),
(115891, '1.25.40.10-FF-004869', NULL, 'Protein kinase, putative', 202, NULL, NULL, 115891),
(115892, '1.10.287.110-FF-000144', NULL, 'TPR-repeat-containing chaperone protein DNAJ', 113, NULL, NULL, 115892),
(115893, '1.20.1560.10-FF-000055', NULL, 'ABC multidrug transporter (Eurofung)', 324, NULL, NULL, 115893),
(115894, '3.30.1700.10-FF-000001', NULL, 'UDP-3-O-acyl-N-acetylglucosamine deacetylase', 177, NULL, NULL, 115894),
(115895, '1.10.287.70-FF-000502', NULL, 'Uncharacterized protein', 136, NULL, NULL, 115895),
(115896, '3.40.50.300-FF-007208', NULL, 'Uncharacterized protein', 166, NULL, NULL, 115896),
(115897, '3.30.40.10-FF-000552', NULL, 'Anaphase promoting complex subunit, putative', 88, NULL, NULL, 115897),
(115898, '3.30.420.10-FF-000076', NULL, 'RBR-type E3 ubiquitin transferase', 136, NULL, NULL, 115898),
(115899, '3.90.640.10-FF-000090', NULL, 'Chaperone protein DNAK, putative', 85, NULL, NULL, 115899),
(115900, '2.60.40.1730-FF-000067', NULL, NULL, 199, NULL, NULL, 115900),
(115901, '3.40.50.11260-FF-000006', NULL, 'endoplasmin homolog', 88, NULL, NULL, 115901),
(115902, '3.30.160.60-FF-004971', NULL, NULL, 67, NULL, NULL, 115902); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(115903, '1.10.8.60-FF-000249', NULL, 'ESX-3 secretion system protein EccA3', 104, NULL, NULL, 115903),
(115904, '3.30.40.10-FF-001064', NULL, 'Uncharacterized protein', 71, NULL, NULL, 115904),
(115905, '1.25.40.10-FF-001199', NULL, 'Response regulator VieB', 168, NULL, NULL, 115905),
(115906, '3.60.40.10-FF-000192', NULL, 'Probable protein phosphatase 2C 54', 82, NULL, NULL, 115906),
(115907, '1.25.40.430-FF-000022', NULL, 'Checkpoint serine/threonine-protein kinase bub1', 174, NULL, NULL, 115907),
(115908, '2.130.10.10-FF-003881', NULL, 'Uncharacterized protein', 277, NULL, NULL, 115908),
(115909, '3.40.50.720-FF-000871', NULL, 'HydroxySteroid Dehydrogenase homolog', 342, NULL, NULL, 115909),
(115910, '2.10.80.10-FF-000007', NULL, 'Uncharacterized protein', 84, NULL, NULL, 115910),
(115911, '3.80.10.10-FF-000183', NULL, 'nuclear RNA export factor 2-like', 158, NULL, NULL, 115911),
(115912, '3.40.50.12760-FF-000029', NULL, 'Uncharacterized protein', 62, NULL, NULL, 115912),
(115913, '3.20.20.80-FF-000179', NULL, 'Chitinase', 271, NULL, NULL, 115913),
(115914, '2.130.10.10-FF-001520', NULL, 'WD domain, G-beta repeat, putative', 121, NULL, NULL, 115914),
(115915, '2.60.40.10-FF-000935', NULL, 'Uncharacterized protein, isoform I', 90, NULL, NULL, 115915),
(115916, '1.25.40.20-FF-000696', NULL, 'Ankyrin repeat family protein', 137, NULL, NULL, 115916),
(115917, '1.20.1070.10-FF-001041', NULL, 'Follicle-stimulating hormone receptor', 270, NULL, NULL, 115917),
(115918, '1.20.1250.20-FF-000411', NULL, 'Probable high-affinity nitrate transporter 2.4', 197, NULL, NULL, 115918),
(115919, '3.40.50.150-FF-000216', NULL, 'S-adenosylmethionine-dependent methyltransferase, putative', 208, NULL, NULL, 115919),
(115920, '3.30.70.330-FF-002345', NULL, NULL, 165, NULL, NULL, 115920),
(115921, '3.30.1490.40-FF-000015', NULL, NULL, 68, NULL, NULL, 115921),
(115922, '2.60.40.10-FF-005027', NULL, NULL, 104, NULL, NULL, 115922),
(115923, '1.25.40.10-FF-003672', NULL, 'Peroxisomal targeting signal 1 receptor', 128, NULL, NULL, 115923),
(115924, '2.130.10.10-FF-002026', NULL, 'Uncharacterized protein', 155, NULL, NULL, 115924),
(115925, '1.10.10.60-FF-000778', NULL, NULL, 67, NULL, NULL, 115925),
(115926, '3.60.110.10-FF-000045', NULL, 'Putative nitrilase/cyanide hydratase', 251, NULL, NULL, 115926),
(115927, '3.40.50.10130-FF-000022', NULL, 'DNA excision repair protein, putative', 122, NULL, NULL, 115927),
(115928, '1.25.40.20-FF-001533', NULL, 'Uncharacterized protein', 61, NULL, NULL, 115928),
(115929, '3.40.50.1460-FF-000102', NULL, 'AGAP012945-PA', 152, NULL, NULL, 115929),
(115930, '1.20.1540.10-FF-000060', NULL, 'Rhomboid-related protein 4', 110, NULL, NULL, 115930),
(115931, '1.10.287.700-FF-000006', NULL, 'Late embryogenesis abundant protein (LEA) family protein', 83, NULL, NULL, 115931),
(115932, '2.60.40.1290-FF-000002', NULL, 'Fibronectin-binding protein A', 168, NULL, NULL, 115932),
(115933, '3.30.70.270-FF-000287', NULL, NULL, 92, NULL, NULL, 115933),
(115934, '1.20.5.390-FF-000002', NULL, 'NF-kappa-B essential modulator isoform X1', 58, NULL, NULL, 115934),
(115935, '3.40.50.300-FF-003263', NULL, 'RecBCD enzyme subunit RecC', 149, NULL, NULL, 115935),
(115936, '2.60.120.260-FF-000626', NULL, 'EGF-like domain-containing protein', 122, NULL, NULL, 115936),
(115937, '1.20.5.110-FF-000306', NULL, 'Uncharacterized protein', 63, NULL, NULL, 115937),
(115938, '1.25.40.120-FF-000030', NULL, 'Uncharacterized protein', 292, NULL, NULL, 115938),
(115939, '1.25.40.20-FF-001640', NULL, 'Kinase, NEK', 94, NULL, NULL, 115939),
(115940, '1.10.238.10-FF-001164', NULL, 'Uncharacterized protein', 104, NULL, NULL, 115940),
(115941, '2.170.130.30-FF-000002', NULL, 'Transcobalamin-2', 105, NULL, NULL, 115941),
(115942, '1.10.520.10-FF-000073', NULL, 'Uncharacterized protein', 18, NULL, NULL, 115942),
(115943, '3.30.420.40-FF-001017', NULL, 'Uncharacterized protein', 51, NULL, NULL, 115943),
(115944, '3.30.160.20-FF-000024', NULL, 'double-stranded RNA-binding protein Staufen homolog 1 isoform X1', 77, NULL, NULL, 115944);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(115945, '1.20.1310.10-FF-000121', NULL, NULL, 109, NULL, NULL, 115945),
(115946, '1.20.1270.60-FF-000065', NULL, 'Uncharacterized protein, isoform B', 253, NULL, NULL, 115946),
(115947, '2.30.30.40-FF-000214', NULL, 'SH3 domain-containing protein 19 isoform X2', 62, NULL, NULL, 115947),
(115948, '3.40.50.1370-FF-000064', NULL, NULL, 110, NULL, NULL, 115948),
(115949, '3.30.160.60-FF-001205', NULL, 'Tripartite motif containing 45', 44, NULL, NULL, 115949),
(115950, '3.30.160.60-FF-000587', NULL, 'Zinc finger protein 711', 31, NULL, NULL, 115950),
(115951, '1.10.1740.10-FF-000004', NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', 86, NULL, NULL, 115951),
(115952, '2.30.42.10-FF-000446', NULL, NULL, 123, NULL, NULL, 115952),
(115953, '3.40.50.300-FF-007439', NULL, 'Uncharacterized protein', 328, NULL, NULL, 115953),
(115954, '1.20.1640.10-FF-000112', NULL, NULL, 127, NULL, NULL, 115954),
(115955, '3.80.10.10-FF-002324', NULL, 'Chondroadherin-like a', 128, NULL, NULL, 115955),
(115956, '3.40.50.300-FF-003156', NULL, 'Dynein heavy chain 14, axonemal', 48, NULL, NULL, 115956),
(115957, '3.40.50.300-FF-003044', NULL, 'Predicted protein', 184, NULL, NULL, 115957),
(115958, '3.40.50.300-FF-001026', NULL, 'Phosphomevalonate kinase', 192, NULL, NULL, 115958),
(115959, '3.40.850.10-FF-000510', NULL, 'Kinesin-like protein', 140, NULL, NULL, 115959),
(115960, '3.40.50.300-FF-006697', NULL, 'Uncharacterized protein', 276, NULL, NULL, 115960),
(115961, '3.40.50.2300-FF-000405', NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase', 73, NULL, NULL, 115961),
(115962, '2.130.10.10-FF-003662', NULL, 'AGAP010737-PA', 226, NULL, NULL, 115962),
(115963, '3.30.260.10-FF-000074', NULL, NULL, 125, NULL, NULL, 115963),
(115964, '3.40.50.300-FF-007315', NULL, 'ORC (Origin Recognition Complex) subunit', 147, NULL, NULL, 115964),
(115965, '3.60.130.10-FF-000058', NULL, 'Uncharacterized protein', 82, NULL, NULL, 115965),
(115966, '3.10.129.10-FF-000223', NULL, 'Uncharacterized protein', 147, NULL, NULL, 115966),
(115967, '2.60.40.4100-FF-000025', NULL, 'Uncharacterized protein', 114, NULL, NULL, 115967),
(115968, '2.130.10.10-FF-003774', NULL, 'Mitotic checkpoint protein bub3', 317, NULL, NULL, 115968),
(115969, '1.25.10.10-FF-000410', NULL, 'Mini spindles, isoform D', 247, NULL, NULL, 115969),
(115970, '1.20.1250.20-FF-001030', NULL, 'Monocarboxylate transporter, putative', 208, NULL, NULL, 115970),
(115971, '3.30.160.20-FF-000148', NULL, 'Similar to NF-kappa-B-repressing factor (NFkB-repressing factor) (Transcription factor NRF) (ITBA4 protein)', 85, NULL, NULL, 115971),
(115972, '1.20.810.10-FF-000014', NULL, 'Cytochrome b', 411, NULL, NULL, 115972),
(115973, '3.40.50.1980-FF-000039', NULL, 'Iron-hydroxamate ABC transporter substrate-binding protein', 118, NULL, NULL, 115973),
(115974, '2.20.110.10-FF-000007', NULL, 'Flagellar component', 46, NULL, NULL, 115974),
(115975, '3.40.50.20-FF-000078', NULL, 'D-alanine--D-alanine ligase', 82, NULL, NULL, 115975),
(115976, '1.50.40.10-FF-000168', NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', 307, NULL, NULL, 115976),
(115977, '3.20.20.190-FF-000154', NULL, NULL, 220, NULL, NULL, 115977),
(115978, '2.70.98.30-FF-000006', NULL, 'Endo-1,3-beta-glucanase Engl1', 220, NULL, NULL, 115978),
(115979, '3.40.50.1820-FF-000817', NULL, 'Non-ribosomal peptide synthetase', 105, NULL, NULL, 115979),
(115980, '1.20.58.60-FF-000247', NULL, 'Spectrin repeat-containing, nuclear envelope family member 3', 209, NULL, NULL, 115980),
(115981, '2.130.10.10-FF-005011', NULL, 'Uncharacterized protein', 42, NULL, NULL, 115981),
(115982, '3.30.70.330-FF-003076', NULL, NULL, 98, NULL, NULL, 115982),
(115983, '1.25.40.10-FF-000923', NULL, 'Transcription factor IIIC-gamma subunit', 171, NULL, NULL, 115983),
(115984, '3.80.10.10-FF-004466', NULL, 'Uncharacterized protein', 71, NULL, NULL, 115984),
(115985, '2.60.40.10-FF-003914', NULL, NULL, 109, NULL, NULL, 115985),
(115986, '1.10.8.50-FF-000027', NULL, '30S ribosomal protein S13', 74, NULL, NULL, 115986);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(115987, '2.60.20.10-FF-000029', NULL, NULL, 98, NULL, NULL, 115987),
(115988, '3.30.1520.10-FF-000015', NULL, 'Sorting nexin 1', 128, NULL, NULL, 115988),
(115989, '2.40.10.10-FF-000030', NULL, 'Genome polyprotein', 69, NULL, NULL, 115989),
(115990, '3.40.50.2000-FF-000422', NULL, 'GDP-mannose--glycolipid 4-beta-D-mannosyltransferase', 148, NULL, NULL, 115990),
(115991, '4.10.400.10-FF-000182', NULL, 'MAM and LDL-receptor class A domain-containing protein 1', 44, NULL, NULL, 115991),
(115992, '3.40.50.150-FF-000997', NULL, NULL, 209, NULL, NULL, 115992),
(115993, '1.10.150.80-FF-000020', NULL, 'RecQ family helicase MusN', 70, NULL, NULL, 115993),
(115994, '3.30.420.150-FF-000027', NULL, 'RNA polymerase II transcriptional coactivator KELP', 133, NULL, NULL, 115994),
(115995, '2.60.40.10-FF-004302', NULL, NULL, 105, NULL, NULL, 115995),
(115996, '3.30.160.60-FF-005258', NULL, NULL, 78, NULL, NULL, 115996),
(115997, '3.80.10.10-FF-001487', NULL, 'Receptor-like protein 33', 432, NULL, NULL, 115997),
(115998, '1.10.510.10-FF-003225', NULL, NULL, 129, NULL, NULL, 115998),
(115999, '2.40.30.270-FF-000016', NULL, 'DNA-binding protein SMUBP-2', 123, NULL, NULL, 115999),
(116000, '1.10.8.60-FF-000581', NULL, 'Nuclear VCP-like', 34, NULL, NULL, 116000),
(116001, '1.25.40.10-FF-004976', NULL, 'Uncharacterized protein', 149, NULL, NULL, 116001),
(116002, '3.40.50.2300-FF-001012', NULL, NULL, 32, NULL, NULL, 116002),
(116003, '1.10.1520.10-FF-000004', NULL, 'Endoribonuclease dicer-like 1', 176, NULL, NULL, 116003),
(116004, '1.10.10.60-FF-000672', NULL, 'Ribonuclease J', 62, NULL, NULL, 116004),
(116005, '3.10.580.10-FF-000007', NULL, 'Arabinose 5-phosphate isomerase', 124, NULL, NULL, 116005),
(116006, '1.20.960.30-FF-000008', NULL, 'Uncharacterized protein', 84, NULL, NULL, 116006),
(116007, '1.10.800.10-FF-000004', NULL, 'Tyrosine 3-monooxygenase', 434, NULL, NULL, 116007),
(116008, '3.40.50.300-FF-004792', NULL, 'Predicted protein', 93, NULL, NULL, 116008),
(116009, '3.90.1150.10-FF-000405', NULL, 'Glycine hydroxymethyltransferase', 140, NULL, NULL, 116009),
(116010, '3.40.640.10-FF-000011', NULL, 'Ornithine aminotransferase', 252, NULL, NULL, 116010),
(116011, '3.80.10.10-FF-000071', NULL, 'peroxidasin homolog', 212, NULL, NULL, 116011),
(116012, '3.20.20.100-FF-000178', NULL, 'Uncharacterized protein', 157, NULL, NULL, 116012),
(116013, '1.20.1600.10-FF-000003', NULL, 'Multidrug efflux system outer membrane subunit', 327, NULL, NULL, 116013),
(116014, '1.10.340.30-FF-000082', NULL, '3-methyladenine DNA glycosylase', 117, NULL, NULL, 116014),
(116015, '1.20.5.3070-FF-000001', NULL, 'Flavin-dependent thymidylate synthase', 57, NULL, NULL, 116015),
(116016, '3.40.630.30-FF-000516', NULL, 'Uncharacterized protein', 116, NULL, NULL, 116016),
(116017, '1.20.1250.20-FF-000068', NULL, 'MFS general substrate transporter', 195, NULL, NULL, 116017),
(116018, '3.40.50.300-FF-005410', NULL, 'ATP-dependent DNA helicase', 195, NULL, NULL, 116018),
(116019, '3.40.50.2000-FF-001041', NULL, 'Uncharacterized protein', 155, NULL, NULL, 116019),
(116020, '3.40.47.10-FF-000281', NULL, 'Gll2853 protein', 445, NULL, NULL, 116020),
(116021, '1.20.120.1160-FF-000003', NULL, 'Nucleoprotein', 56, NULL, NULL, 116021),
(116022, '1.20.960.10-FF-000002', NULL, 'Mitochondrial import receptor subunit TOM20', 68, NULL, NULL, 116022),
(116023, '2.130.10.10-FF-004393', NULL, 'Predicted protein', 61, NULL, NULL, 116023),
(116024, '2.170.270.10-FF-000169', NULL, 'Uncharacterized protein', 110, NULL, NULL, 116024),
(116025, '3.40.33.10-FF-000007', NULL, 'Venom allergen', 235, NULL, NULL, 116025),
(116026, '1.20.1110.10-FF-000140', NULL, 'Cation transporting ATPase', 412, NULL, NULL, 116026),
(116027, '2.60.40.2690-FF-000001', NULL, 'Splicing factor 3a, subunit 2', 123, NULL, NULL, 116027),
(116028, '1.10.510.10-FF-002500', NULL, NULL, 112, NULL, NULL, 116028),
(116029, '1.20.5.2650-FF-000004', NULL, '40S ribosomal protein S6', 95, NULL, NULL, 116029),
(116030, '2.40.50.140-FF-000318', NULL, '30S ribosomal protein S1', 90, NULL, NULL, 116030);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(116031, '3.30.160.60-FF-003442', NULL, NULL, 30, NULL, NULL, 116031),
(116032, '3.90.70.10-FF-000214', NULL, 'Cathepsin B-like cysteine proteinase', 259, NULL, NULL, 116032),
(116033, '3.30.70.330-FF-002457', NULL, NULL, 84, NULL, NULL, 116033),
(116034, '1.25.40.20-FF-001421', NULL, 'S-acyltransferase', 187, NULL, NULL, 116034),
(116035, '3.80.10.10-FF-004342', NULL, 'Si:dkey-118k5.3', 189, NULL, NULL, 116035),
(116036, '3.30.1490.180-FF-000026', NULL, 'DNA-directed RNA polymerase subunit', 28, NULL, NULL, 116036),
(116037, '3.30.1050.10-FF-000041', NULL, 'Stomatin-like 1', 111, NULL, NULL, 116037),
(116038, '3.30.50.10-FF-000053', NULL, 'GATA transcription factor 15', 53, NULL, NULL, 116038),
(116039, '2.40.10.10-FF-000698', NULL, NULL, 120, NULL, NULL, 116039),
(116040, '2.40.70.10-FF-000022', NULL, 'Aspartyl protease AED3', 177, NULL, NULL, 116040),
(116041, '3.40.30.120-FF-000001', NULL, 'FAD monooxygenase, PheA/TfdB family', 108, NULL, NULL, 116041),
(116042, '3.40.30.10-FF-001259', NULL, 'Uncharacterized protein', 110, NULL, NULL, 116042),
(116043, '3.30.1010.10-FF-000151', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', 38, NULL, NULL, 116043),
(116044, '1.10.10.160-FF-000006', NULL, 'ATP-dependent DNA helicase Rep', 76, NULL, NULL, 116044),
(116045, '3.20.20.80-FF-000398', NULL, 'CD98 heavy chain, isoform D', 103, NULL, NULL, 116045),
(116046, '1.10.510.10-FF-001663', NULL, 'Putative serine/threonine protein kinase', 165, NULL, NULL, 116046),
(116047, '3.90.226.10-FF-000077', NULL, 'Putative enoyl-CoA hydratase echA21', 212, NULL, NULL, 116047),
(116048, '1.10.1320.10-FF-000023', NULL, 'DNA-directed RNA polymerase', 163, NULL, NULL, 116048),
(116049, '3.100.10.10-FF-000045', NULL, NULL, 76, NULL, NULL, 116049),
(116050, '3.40.50.620-FF-000604', NULL, 'Asparagine synthetase (Eurofung)', 307, NULL, NULL, 116050),
(116051, '2.130.10.30-FF-000110', NULL, NULL, 146, NULL, NULL, 116051),
(116052, '1.20.1250.20-FF-000630', NULL, 'MFS transporter', 189, NULL, NULL, 116052),
(116053, '2.10.25.10-FF-000082', NULL, 'Laminin subunit alpha 1', 49, NULL, NULL, 116053),
(116054, '3.30.300.30-FF-000016', NULL, 'Fatty-acid-CoA ligase FadD26', 119, NULL, NULL, 116054),
(116055, '1.10.3720.10-FF-000121', NULL, 'Amino acid ABC transporter permease', 221, NULL, NULL, 116055),
(116056, '3.40.50.720-FF-000539', NULL, 'Ubiquitin-like modifier-activating enzyme 5', 255, NULL, NULL, 116056),
(116057, '1.25.10.10-FF-001607', NULL, 'Uncharacterized protein', 1040, NULL, NULL, 116057),
(116058, '3.40.50.300-FF-000407', NULL, 'Rho-related GTP-binding protein RhoE', 188, NULL, NULL, 116058),
(116059, '3.40.50.360-FF-000150', NULL, 'Predicted protein', 80, NULL, NULL, 116059),
(116060, '1.20.1250.20-FF-001827', NULL, 'Proton:peptide symporter POT family', 151, NULL, NULL, 116060),
(116061, '2.40.150.20-FF-000020', NULL, 'Mitochondrial Ribosomal Protein, Large', 135, NULL, NULL, 116061),
(116062, '3.30.70.1730-FF-000063', NULL, 'Ribosome assembly factor mrt4', 60, NULL, NULL, 116062),
(116063, '1.20.1060.20-FF-000020', NULL, NULL, 133, NULL, NULL, 116063),
(116064, '3.80.10.10-FF-002105', NULL, 'Uncharacterized protein', 464, NULL, NULL, 116064),
(116065, '2.130.10.10-FF-000008', NULL, 'Coatomer subunit beta', 290, NULL, NULL, 116065),
(116066, '1.20.1460.10-FF-000014', NULL, 'V-type proton ATPase subunit C', 122, NULL, NULL, 116066),
(116067, '3.30.70.330-FF-001620', NULL, NULL, 85, NULL, NULL, 116067),
(116068, '2.40.50.40-FF-000131', NULL, 'Uncharacterized protein', 56, NULL, NULL, 116068),
(116069, '3.60.90.10-FF-000014', NULL, 'S-adenosylmethionine decarboxylase-ornithine decarboxylase', 213, NULL, NULL, 116069),
(116070, '1.10.220.30-FF-000039', NULL, 'Flagellar motor switch protein FliG', 79, NULL, NULL, 116070),
(116071, '1.25.40.180-FF-000256', NULL, NULL, 288, NULL, NULL, 116071),
(116072, '1.20.900.10-FF-000010', NULL, 'Rho guanine nucleotide exchange factor 3 isoform 1', 214, NULL, NULL, 116072),
(116073, '1.10.840.10-FF-000001', NULL, 'Rap guanine nucleotide exchange factor (GEF) 6', 251, NULL, NULL, 116073); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(116074, '3.30.70.3310-FF-000003', NULL, 'Neurogenic locus notch 1', 171, NULL, NULL, 116074),
(116075, '1.10.287.720-FF-000001', NULL, 'Major pollen allergen Ole e 6', 50, NULL, NULL, 116075),
(116076, '2.70.150.10-FF-000212', NULL, 'ATPase, class VI, type 11B', 159, NULL, NULL, 116076),
(116077, '3.40.50.12350-FF-000013', NULL, 'Eyes absent homolog', 153, NULL, NULL, 116077),
(116078, '1.20.1070.10-FF-000309', NULL, 'Moody, isoform B', 309, NULL, NULL, 116078),
(116079, '1.10.10.10-FF-000915', NULL, 'DtxR family iron (Metal) dependent repressor', 68, NULL, NULL, 116079),
(116080, '1.10.220.10-FF-000033', NULL, 'Annexin A13,-like', 37, NULL, NULL, 116080),
(116081, '1.20.940.10-FF-000018', NULL, 'Potassium channel regulatory factor, putative', 176, NULL, NULL, 116081),
(116082, '1.10.860.10-FF-000014', NULL, 'Replicative DNA helicase', 136, NULL, NULL, 116082),
(116083, '3.30.70.3030-FF-000008', NULL, 'Nucleolar protein 6', 160, NULL, NULL, 116083),
(116084, '1.25.40.710-FF-000016', NULL, 'Predicted protein', 200, NULL, NULL, 116084),
(116085, '3.20.190.10-FF-000020', NULL, 'Uncharacterized protein', 146, NULL, NULL, 116085),
(116086, '4.10.1000.10-FF-000002', NULL, 'Zinc finger protein 36, C3H1 type-like 1', 38, NULL, NULL, 116086),
(116087, '2.130.10.10-FF-004954', NULL, 'Uncharacterized protein', 96, NULL, NULL, 116087),
(116088, '1.20.920.10-FF-000005', NULL, 'protein kinase C-binding protein 1 isoform X2', 115, NULL, NULL, 116088),
(116089, '1.20.1070.10-FF-001602', NULL, 'Predicted protein', 152, NULL, NULL, 116089),
(116090, '2.60.40.60-FF-000798', NULL, 'Uncharacterized protein', 83, NULL, NULL, 116090),
(116091, '2.60.120.290-FF-000169', NULL, 'Uncharacterized protein', 119, NULL, NULL, 116091),
(116092, '3.90.550.10-FF-000566', NULL, 'Predicted protein', 78, NULL, NULL, 116092),
(116093, '3.30.160.60-FF-005696', NULL, NULL, 63, NULL, NULL, 116093),
(116094, '3.40.190.10-FF-000594', NULL, 'Glutamate receptor 1.4', 115, NULL, NULL, 116094),
(116095, '2.60.200.30-FF-000028', NULL, 'NAD kinase', 136, NULL, NULL, 116095),
(116096, '3.90.1010.10-FF-000007', NULL, 'Cysteine desulfurase, sulfur acceptor subunit CsdE', 147, NULL, NULL, 116096),
(116097, '3.50.30.30-FF-000096', NULL, 'Receptor homology region, transmembrane domain- and RING domain-containing protein 3', 141, NULL, NULL, 116097),
(116098, '1.20.1260.10-FF-000015', NULL, 'Ferritin', 148, NULL, NULL, 116098),
(116099, '3.40.950.10-FF-000001', NULL, 'Cytosolic Fe-S cluster assembly factor narfl', 195, NULL, NULL, 116099),
(116100, '2.60.40.10-FF-004645', NULL, NULL, 101, NULL, NULL, 116100),
(116101, '3.30.1330.40-FF-000060', NULL, 'Ribonuclease UK114', 131, NULL, NULL, 116101),
(116102, '3.40.50.12660-FF-000005', NULL, 'Mca1p', 240, NULL, NULL, 116102),
(116103, '3.40.50.280-FF-000019', NULL, 'Corrinoid protein', 128, NULL, NULL, 116103),
(116104, '3.40.50.10810-FF-000248', NULL, 'Predicted protein', 178, NULL, NULL, 116104),
(116105, '3.90.190.10-FF-000577', NULL, 'Uncharacterized protein', 235, NULL, NULL, 116105),
(116106, '3.90.1150.10-FF-000169', NULL, 'Uncharacterized protein Rv1519', 60, NULL, NULL, 116106),
(116107, '1.10.150.20-FF-000154', NULL, 'Putative DNA repair protein', 70, NULL, NULL, 116107),
(116108, '2.60.40.60-FF-001074', NULL, 'Uncharacterized protein', 113, NULL, NULL, 116108),
(116109, '2.30.29.30-FF-000034', NULL, 'amyloid beta A4 precursor protein-binding family B member 2', 138, NULL, NULL, 116109),
(116110, '1.10.3520.10-FF-000027', NULL, 'Uncharacterized protein', 100, NULL, NULL, 116110),
(116111, '2.130.10.10-FF-000683', NULL, 'WD-40 repeat protein family', 337, NULL, NULL, 116111),
(116112, '2.40.10.10-FF-000592', NULL, NULL, 31, NULL, NULL, 116112),
(116113, '3.40.50.720-FF-001253', NULL, 'Alcohol dehydrogenase', 149, NULL, NULL, 116113),
(116114, '3.30.50.10-FF-000159', NULL, 'AGAP012223-PA', 100, NULL, NULL, 116114),
(116115, '3.30.470.20-FF-000233', NULL, 'Uncharacterized protein', 81, NULL, NULL, 116115),
(116116, '2.60.40.10-FF-001992', NULL, 'FiLamiN (Actin binding protein) homolog', 101, NULL, NULL, 116116);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(116117, '3.30.70.330-FF-000327', NULL, 'ras GTPase-activating protein-binding protein 2 isoform X1', 159, NULL, NULL, 116117),
(116118, '1.10.1580.10-FF-000002', NULL, 'Guanine nucleotide-binding protein-like 3 (nucleolar)-like', 93, NULL, NULL, 116118),
(116119, '2.130.10.10-FF-002824', NULL, 'Actin related protein 2/3 complex, putative', 375, NULL, NULL, 116119),
(116120, '1.25.40.860-FF-000033', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 156, NULL, NULL, 116120),
(116121, '2.60.40.10-FF-000699', NULL, 'Hemicentin 1', 89, NULL, NULL, 116121),
(116122, '3.40.50.2300-FF-001355', NULL, NULL, 28, NULL, NULL, 116122),
(116123, '3.40.50.11990-FF-000006', NULL, 'CDC73 domain-containing protein', 187, NULL, NULL, 116123),
(116124, '3.40.50.2000-FF-000765', NULL, 'UDP-glucuronosyltransferase', 174, NULL, NULL, 116124),
(116125, '3.40.50.720-FF-002433', NULL, 'Glycerol-3-phosphate dehydrogenase (NAD(P)(+))', 191, NULL, NULL, 116125),
(116126, '2.130.10.10-FF-005915', NULL, 'Serine/threonine-protein kinase ppk19', 278, NULL, NULL, 116126),
(116127, '3.40.50.2300-FF-000394', NULL, 'DNA-binding response regulator', 79, NULL, NULL, 116127),
(116128, '3.30.70.1230-FF-000132', NULL, 'Uncharacterized protein', 192, NULL, NULL, 116128),
(116129, '3.40.30.10-FF-000641', NULL, 'Rho-class glutathione S-transferase', 82, NULL, NULL, 116129),
(116130, '3.30.1360.40-FF-000011', NULL, 'DNA topoisomerase 2', 102, NULL, NULL, 116130),
(116131, '3.60.15.10-FF-000116', NULL, 'Cleavage and polyadenylation specificity factor, putative', 218, NULL, NULL, 116131),
(116132, '3.10.250.10-FF-000016', NULL, 'Scavenger receptor cysteine-rich protein type 12', 107, NULL, NULL, 116132),
(116133, '3.40.190.290-FF-000092', NULL, 'Transcriptional regulatory protein', 211, NULL, NULL, 116133),
(116134, '3.10.120.10-FF-000012', NULL, 'Mitochondrial cytochrome b2, putative', 90, NULL, NULL, 116134),
(116135, '3.10.310.10-FF-000061', NULL, 'Predicted protein', 101, NULL, NULL, 116135),
(116136, '3.10.490.20-FF-000003', NULL, 'Dynein heavy chain 5, axonemal', 137, NULL, NULL, 116136),
(116137, '2.40.160.110-FF-000038', NULL, 'Uncharacterized protein', 169, NULL, NULL, 116137),
(116138, '2.10.230.10-FF-000002', NULL, 'Molecular chaperone DnaJ', 77, NULL, NULL, 116138),
(116139, '3.30.1120.30-FF-000024', NULL, 'Serine/threonine-protein kinase PLK', 87, NULL, NULL, 116139),
(116140, '1.20.1050.10-FF-000314', NULL, 'Uncharacterized protein', 113, NULL, NULL, 116140),
(116141, '2.20.25.30-FF-000003', NULL, '50S ribosomal protein L37e', 56, NULL, NULL, 116141),
(116142, '1.10.287.1540-FF-000001', NULL, 'Activator of photopigment and puc expression', 53, NULL, NULL, 116142),
(116143, '1.20.5.1940-FF-000004', NULL, 'Vacuolar protein sorting-associated protein 27', 91, NULL, NULL, 116143),
(116144, '2.10.25.10-FF-000767', NULL, 'Vasorin a', 41, NULL, NULL, 116144),
(116145, '3.30.160.60-FF-003223', NULL, 'FI23536p1', 30, NULL, NULL, 116145),
(116146, '3.40.50.720-FF-000292', NULL, 'Putative D-lactate dehydrogenase', 197, NULL, NULL, 116146),
(116147, '1.10.8.1210-FF-000002', NULL, 'Glutamate dehydrogenase', 31, NULL, NULL, 116147),
(116148, '3.10.100.10-FF-000247', NULL, NULL, 63, NULL, NULL, 116148),
(116149, '3.80.10.10-FF-002448', NULL, 'Leucine-rich repeat protein (LRRP)', 98, NULL, NULL, 116149),
(116150, '1.10.30.10-FF-000006', NULL, 'High mobility group protein B1', 80, NULL, NULL, 116150),
(116151, '4.10.780.10-FF-000007', NULL, 'Pyruvate:ferredoxin oxidoreductase/NADPH-cytochrome P450 reductase PNO', 41, NULL, NULL, 116151),
(116152, '1.20.1070.10-FF-000641', NULL, 'Adhesion G protein-coupled receptor L3', 268, NULL, NULL, 116152),
(116153, '2.60.40.10-FF-005606', NULL, NULL, 107, NULL, NULL, 116153),
(116154, '3.40.1440.10-FF-000012', NULL, 'Structure-specific endonuclease subunit SLX1 homolog', 103, NULL, NULL, 116154),
(116155, '2.60.40.150-FF-000045', NULL, 'Dedicator of cytokinesis protein 4', 184, NULL, NULL, 116155),
(116156, '3.10.450.240-FF-000003', NULL, '39S ribosomal protein L45, mitochondrial', 171, NULL, NULL, 116156);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(116157, '3.20.20.80-FF-000055', NULL, 'Trehalose synthase', 380, NULL, NULL, 116157),
(116158, '2.120.10.30-FF-000195', NULL, 'Uncharacterized protein', 156, NULL, NULL, 116158),
(116159, '2.60.40.10-FF-002610', NULL, 'Muscle M-line assembly protein unc-89-like Protein', 91, NULL, NULL, 116159),
(116160, '3.40.1110.10-FF-000038', NULL, 'Copper-exporting P-type ATPase', 52, NULL, NULL, 116160),
(116161, '3.90.530.10-FF-000003', NULL, 'Dna repair rad14 protein', 111, NULL, NULL, 116161),
(116162, '1.50.10.10-FF-000110', NULL, 'alpha-1,2-Mannosidase', 487, NULL, NULL, 116162),
(116163, '1.10.10.10-FF-000230', NULL, 'HTH-type transcriptional regulator tdcA', 86, NULL, NULL, 116163),
(116164, '1.20.58.60-FF-000826', NULL, 'Si:ch211-207i1.2', 176, NULL, NULL, 116164),
(116165, '1.10.630.10-FF-000643', NULL, 'Uncharacterized protein', 214, NULL, NULL, 116165),
(116166, '3.30.70.330-FF-001507', NULL, NULL, 87, NULL, NULL, 116166),
(116167, '2.130.10.10-FF-001644', NULL, 'Dynein axonemal intermediate chain 1', 105, NULL, NULL, 116167),
(116168, '2.60.40.10-FF-001317', NULL, 'Immunoglobulin kappa chain variable 4-54', 107, NULL, NULL, 116168),
(116169, '3.30.450.20-FF-000581', NULL, 'Uncharacterized protein', 56, NULL, NULL, 116169),
(116170, '1.25.40.20-FF-001078', NULL, 'arf-GAP with GTPase, ANK repeat and PH domain-containing protein 3 isoform X1', 119, NULL, NULL, 116170),
(116171, '1.10.510.10-FF-001084', NULL, 'Unplaced genomic scaffold supercont1.29, whole genome shotgun sequence', 272, NULL, NULL, 116171),
(116172, '1.20.1110.10-FF-000027', NULL, 'Calcium-transporting ATPase, putative', 162, NULL, NULL, 116172),
(116173, '3.40.50.720-FF-002214', NULL, 'D-3-phosphoglycerate dehydrogenase', 26, NULL, NULL, 116173),
(116174, '3.40.50.720-FF-001596', NULL, 'Uncharacterized protein', 189, NULL, NULL, 116174),
(116175, '1.25.10.10-FF-002664', NULL, 'Uncharacterized protein', 97, NULL, NULL, 116175),
(116176, '3.30.230.130-FF-000068', NULL, 'Predicted protein', 155, NULL, NULL, 116176),
(116177, '1.20.58.90-FF-000026', NULL, NULL, 112, NULL, NULL, 116177),
(116178, '2.30.29.30-FF-000719', NULL, 'Uncharacterized protein', 201, NULL, NULL, 116178),
(116179, '3.40.50.2000-FF-000186', NULL, 'Glycosyltransferase', 261, NULL, NULL, 116179),
(116180, '3.30.70.330-FF-002800', NULL, NULL, 95, NULL, NULL, 116180),
(116181, '1.20.1740.10-FF-000041', NULL, 'Amino acid permease, putative', 431, NULL, NULL, 116181),
(116182, '3.10.110.10-FF-000186', NULL, 'Uncharacterized protein', 128, NULL, NULL, 116182),
(116183, '1.20.1740.10-FF-000165', NULL, 'Amino acid transporter (Eurofung)', 312, NULL, NULL, 116183),
(116184, '3.30.40.10-FF-000333', NULL, 'Zinc finger FYVE-type containing 19', 71, NULL, NULL, 116184),
(116185, '1.20.58.70-FF-000020', NULL, 't-SNARE domain-containing protein 1', 122, NULL, NULL, 116185),
(116186, '3.40.50.300-FF-006933', NULL, 'Cytidylate kinase', 229, NULL, NULL, 116186),
(116187, '3.40.30.10-FF-000422', NULL, 'Peroxiredoxin-like 2 family protein, selenocysteine-containing', 171, NULL, NULL, 116187),
(116188, '3.30.470.20-FF-000014', NULL, 'Carbamoyl-phosphate synthase large chain', 213, NULL, NULL, 116188),
(116189, '2.30.250.10-FF-000009', NULL, 'Aspartyl aminopeptidase', 165, NULL, NULL, 116189),
(116190, '2.30.30.100-FF-000153', NULL, 'Small nuclear ribonucleoprotein F', 79, NULL, NULL, 116190),
(116191, '3.40.50.1000-FF-000111', NULL, 'Trehalose-6-phosphate synthase 6', 152, NULL, NULL, 116191),
(116192, '2.30.29.30-FF-000377', NULL, 'Shc transforming protein', 164, NULL, NULL, 116192),
(116193, '2.40.240.10-FF-000024', NULL, 'Glutamine-tRNA ligase', 148, NULL, NULL, 116193),
(116194, '3.20.20.450-FF-000029', NULL, 'Putative diguanylate cyclase', 257, NULL, NULL, 116194),
(116195, '1.10.600.10-FF-000130', NULL, 'Os11g0474583 protein', 94, NULL, NULL, 116195),
(116196, '1.10.10.60-FF-001054', NULL, NULL, 55, NULL, NULL, 116196),
(116197, '1.20.120.1240-FF-000038', NULL, 'Dynamin related protein', 112, NULL, NULL, 116197),
(116198, '3.20.20.140-FF-000055', NULL, 'Uracil-5-carboxylate decarboxylase', 364, NULL, NULL, 116198);
INSERT INTO "PUBLIC"."MODEL" VALUES
(116199, '2.60.40.10-FF-005483', NULL, NULL, 126, NULL, NULL, 116199),
(116200, '1.20.5.320-FF-000021', NULL, 'COL24A1 isoform 5', 44, NULL, NULL, 116200),
(116201, '3.40.50.300-FF-005174', NULL, 'ATP-dependent dethiobiotin synthetase BioD', 221, NULL, NULL, 116201),
(116202, '3.30.60.20-FF-000101', NULL, 'Diacylglycerol kinase', 55, NULL, NULL, 116202),
(116203, '1.10.8.10-FF-000263', NULL, 'Death-associated inhibitor of apoptosis 2', 56, NULL, NULL, 116203),
(116204, '1.20.1070.10-FF-000080', NULL, 'probable G-protein coupled receptor 63', 333, NULL, NULL, 116204),
(116205, '3.30.740.10-FF-000004', NULL, 'Dynein light chain', 89, NULL, NULL, 116205),
(116206, '3.20.20.70-FF-000850', NULL, NULL, 364, NULL, NULL, 116206),
(116207, '1.20.1420.10-FF-000017', NULL, 'Talin', 178, NULL, NULL, 116207),
(116208, '1.10.472.10-FF-000590', NULL, 'Cyclin, N-terminal domain containing protein', 33, NULL, NULL, 116208),
(116209, '2.130.10.10-FF-004499', NULL, 'Cytoplasmic dynein 1 intermediate chain-like Protein', 241, NULL, NULL, 116209),
(116210, '3.30.1640.10-FF-000069', NULL, 'DNA helicase', 100, NULL, NULL, 116210),
(116211, '3.40.309.10-FF-000062', NULL, 'Aldehyde dehydrogenase', 189, NULL, NULL, 116211),
(116212, '3.90.190.20-FF-000018', NULL, 'Folylpolyglutamate synthase/dihydrofolate synthase', 127, NULL, NULL, 116212),
(116213, '2.60.120.10-FF-000544', NULL, 'Predicted protein', 132, NULL, NULL, 116213),
(116214, '2.60.120.260-FF-000065', NULL, 'Beta-galactosidase A', 176, NULL, NULL, 116214),
(116215, '1.10.730.10-FF-000010', NULL, 'methionine--tRNA ligase, cytoplasmic', 158, NULL, NULL, 116215),
(116216, '3.80.10.10-FF-003960', NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', 339, NULL, NULL, 116216),
(116217, '3.90.70.200-FF-000005', NULL, 'Related to Pol II transcription elongation factor', 135, NULL, NULL, 116217),
(116218, '3.30.300.130-FF-000034', NULL, NULL, 92, NULL, NULL, 116218),
(116219, '3.30.360.20-FF-000023', NULL, NULL, 98, NULL, NULL, 116219),
(116220, '3.30.70.890-FF-000017', NULL, 'MeValonate Kinase', 109, NULL, NULL, 116220),
(116221, '1.10.510.10-FF-003804', NULL, NULL, 121, NULL, NULL, 116221),
(116222, '1.20.1720.10-FF-000057', NULL, 'MFS transporter', 207, NULL, NULL, 116222),
(116223, '3.40.50.300-FF-005972', NULL, 'ATP-binding cassette alpha-factor transporter', 256, NULL, NULL, 116223),
(116224, '2.60.40.1180-FF-000205', NULL, 'Endoglycoceramidase', 98, NULL, NULL, 116224),
(116225, '1.10.510.10-FF-002045', NULL, 'Protein CBG14958', 363, NULL, NULL, 116225),
(116226, '1.25.40.570-FF-000047', NULL, 'Eukaryotic translation initiation factor 3 subunit E', 341, NULL, NULL, 116226),
(116227, '1.25.10.10-FF-001028', NULL, 'Unplaced genomic scaffold supercont1.17, whole genome shotgun sequence', 260, NULL, NULL, 116227),
(116228, '3.90.190.10-FF-000139', NULL, 'Putative dual specificity phosphatase', 132, NULL, NULL, 116228),
(116229, '3.40.50.1000-FF-000330', NULL, 'Copper-transporting ATPase', 137, NULL, NULL, 116229),
(116230, '3.40.50.720-FF-000977', NULL, 'Ornithine cyclodeaminase', 186, NULL, NULL, 116230),
(116231, '1.20.120.1080-FF-000081', NULL, 'Tudor domain containing 9', 149, NULL, NULL, 116231),
(116232, '1.10.3810.10-FF-000004', NULL, 'Biosynthetic peptidoglycan transglycosylase', 190, NULL, NULL, 116232),
(116233, '3.60.10.10-FF-000021', NULL, 'PGAP2-interacting protein isoform A', 219, NULL, NULL, 116233),
(116234, '3.30.160.60-FF-002262', NULL, 'Zinc finger protein 236', 25, NULL, NULL, 116234),
(116235, '2.40.30.10-FF-000025', NULL, 'Nitric oxide synthase', 107, NULL, NULL, 116235),
(116236, '1.10.1780.10-FF-000001', NULL, 'ATP-dependent Clp protease ATP-binding subunit', 150, NULL, NULL, 116236),
(116237, '1.10.510.10-FF-001769', NULL, 'Uncharacterized protein', 218, NULL, NULL, 116237),
(116238, '3.30.56.10-FF-000004', NULL, 'Phenylalanyl-tRNA synthetase, beta subunit', 74, NULL, NULL, 116238),
(116239, '2.30.29.30-FF-000938', NULL, 'UDP-sugar-dependent glycosyltransferase 52', 108, NULL, NULL, 116239),
(116240, '3.90.1750.10-FF-000030', NULL, 'IQ and HECT domain protein', 228, NULL, NULL, 116240);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(116241, '1.25.40.60-FF-000005', NULL, 'Vacuolar protein sorting-associated protein 45 homolog', 122, NULL, NULL, 116241),
(116242, '3.30.450.20-FF-000344', NULL, 'Uncharacterized protein', 109, NULL, NULL, 116242),
(116243, '2.30.140.10-FF-000018', NULL, 'Spermine synthase', 56, NULL, NULL, 116243),
(116244, '2.10.25.10-FF-001386', NULL, 'Uncharacterized protein', 31, NULL, NULL, 116244),
(116245, '1.20.1560.10-FF-000179', NULL, 'Abc transporter family protein', 335, NULL, NULL, 116245),
(116246, '3.30.2410.10-FF-000030', NULL, 'Predicted protein', 106, NULL, NULL, 116246),
(116247, '3.50.50.60-FF-001382', NULL, 'Uncharacterized protein', 82, NULL, NULL, 116247),
(116248, '3.30.9.10-FF-000042', NULL, 'Malate:quinone oxidoreductase, putative', 117, NULL, NULL, 116248),
(116249, '1.20.1250.20-FF-002209', NULL, 'Uncharacterized protein', 138, NULL, NULL, 116249),
(116250, '1.10.10.880-FF-000003', NULL, 'Anti-sigma-E factor RseA', 66, NULL, NULL, 116250),
(116251, '2.30.42.10-FF-000340', NULL, 'Zinc metalloprotease', 96, NULL, NULL, 116251),
(116252, '3.30.200.20-FF-002445', NULL, 'TGF-beta receptor type-2', 64, NULL, NULL, 116252),
(116253, '1.25.40.10-FF-003453', NULL, 'Putative pentatricopeptide repeat-containing protein At1g13800', 129, NULL, NULL, 116253),
(116254, '2.60.120.260-FF-000407', NULL, 'Carbohydrate-binding protein', 152, NULL, NULL, 116254),
(116255, '2.10.90.10-FF-000165', NULL, 'Uncharacterized protein', 38, NULL, NULL, 116255),
(116256, '3.30.230.70-FF-000129', NULL, 'AGAP002177-PA', 208, NULL, NULL, 116256),
(116257, '1.10.3730.20-FF-000063', NULL, 'Uncharacterized protein', 101, NULL, NULL, 116257),
(116258, '3.40.390.10-FF-000250', NULL, NULL, 246, NULL, NULL, 116258),
(116259, '1.50.40.10-FF-000062', NULL, 'mitochondrial uncoupling protein 3', 293, NULL, NULL, 116259),
(116260, '2.30.40.10-FF-000173', NULL, 'Putative formylmethanofuran dehydrogenase subunit A', 15, NULL, NULL, 116260),
(116261, '3.30.930.10-FF-000272', NULL, 'ATP phosphoribosyltransferase regulatory subunit', 329, NULL, NULL, 116261),
(116262, '3.40.50.880-FF-000199', NULL, 'Guanine monophosphate synthase', 108, NULL, NULL, 116262),
(116263, '3.50.50.60-FF-000089', NULL, 'dimethylglycine dehydrogenase, mitochondrial', 209, NULL, NULL, 116263),
(116264, '3.40.50.300-FF-001369', NULL, 'Putative pre-mRNA splicing factor', 240, NULL, NULL, 116264),
(116265, '1.25.40.90-FF-000109', NULL, 'Uncharacterized protein', 81, NULL, NULL, 116265),
(116266, '2.70.170.10-FF-000101', NULL, 'Uncharacterized protein', 191, NULL, NULL, 116266),
(116267, '3.40.50.2300-FF-000377', NULL, 'Metabotropic GLutamate receptor family', 158, NULL, NULL, 116267),
(116268, '3.60.21.10-FF-000411', NULL, 'Serine/threonine-protein phosphatase', 288, NULL, NULL, 116268),
(116269, '3.10.20.320-FF-000004', NULL, 'LPXTG cell wall anchor domain-containing protein', 74, NULL, NULL, 116269),
(116270, '3.40.50.1910-FF-000035', NULL, 'Syntaxin binding protein 1, putative', 190, NULL, NULL, 116270),
(116271, '3.40.50.300-FF-007355', NULL, 'Dicer-1', 198, NULL, NULL, 116271),
(116272, '1.25.10.10-FF-001422', NULL, 'HEAT repeat containing 1', 261, NULL, NULL, 116272),
(116273, '3.60.10.10-FF-000122', NULL, 'Frag1/DRAM/Sfk1_family_-_putative', 199, NULL, NULL, 116273),
(116274, '1.25.40.10-FF-003048', NULL, 'Pentatricopeptide repeat-containing protein At5g67570, chloroplastic', 82, NULL, NULL, 116274),
(116275, '3.30.230.10-FF-000179', NULL, 'Predicted protein', 186, NULL, NULL, 116275),
(116276, '1.10.630.10-FF-000704', NULL, 'Uncharacterized protein', 123, NULL, NULL, 116276),
(116277, '3.40.1160.10-FF-000092', NULL, 'Predicted protein', 97, NULL, NULL, 116277),
(116278, '1.20.58.1100-FF-000011', NULL, 'Uncharacterized protein', 158, NULL, NULL, 116278),
(116279, '3.40.50.12780-FF-000176', NULL, 'Uncharacterized protein', 295, NULL, NULL, 116279),
(116280, '2.130.10.10-FF-005404', NULL, 'Kinesin-Like Protein', 201, NULL, NULL, 116280),
(116281, '2.80.10.50-FF-000017', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 138, NULL, NULL, 116281);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(116282, '2.60.120.330-FF-000052', NULL, '1-aminocyclopropane-1-carboxylate oxidase 1', 301, NULL, NULL, 116282),
(116283, '3.40.50.720-FF-002074', NULL, 'Uncharacterized protein', 149, NULL, NULL, 116283),
(116284, '3.30.70.330-FF-001390', NULL, 'RNA recognition motif domain containing protein', 109, NULL, NULL, 116284),
(116285, '1.20.120.1080-FF-000092', NULL, 'ATP-dependent RNA helicase DEAH13', 190, NULL, NULL, 116285),
(116286, '1.10.510.10-FF-002202', NULL, NULL, 100, NULL, NULL, 116286),
(116287, '3.10.450.240-FF-000014', NULL, 'Meiotic recombination protein DMC1', 186, NULL, NULL, 116287),
(116288, '3.40.50.10090-FF-000021', NULL, 'Uroporphyrinogen-III synthase', 105, NULL, NULL, 116288),
(116289, '3.30.160.60-FF-000025', NULL, 'Spalt-like transcription factor 1', 30, NULL, NULL, 116289),
(116290, '1.20.1270.60-FF-000031', NULL, 'Putative DCC-interacting protein 13-beta isoform 2', 263, NULL, NULL, 116290),
(116291, '3.90.320.10-FF-000021', NULL, 'DNA helicase UvrD', 190, NULL, NULL, 116291),
(116292, '3.10.20.310-FF-000001', NULL, 'Outer membrane protein assembly factor BamA', 77, NULL, NULL, 116292),
(116293, '3.30.499.10-FF-000010', NULL, '3-isopropylmalate dehydratase large subunit, chloroplastic-like', 159, NULL, NULL, 116293),
(116294, '2.70.98.30-FF-000040', NULL, 'Uncharacterized protein', 97, NULL, NULL, 116294),
(116295, '3.40.50.300-FF-005264', NULL, 'Si:ch211-227e10.1', 183, NULL, NULL, 116295),
(116296, '3.90.1640.10-FF-000027', NULL, 'Uncharacterized protein', 230, NULL, NULL, 116296),
(116297, '3.60.40.10-FF-000096', NULL, 'Protein phosphatase PPM8, putative', 344, NULL, NULL, 116297),
(116298, '1.20.58.60-FF-000169', NULL, 'nesprin-1 isoform X1', 319, NULL, NULL, 116298),
(116299, '3.30.70.270-FF-000096', NULL, 'Uncharacterized protein', 90, NULL, NULL, 116299),
(116300, '1.20.5.540-FF-000002', NULL, 'Succinate dehydrogenase cytochrome b560 subunit, mitochondrial', 32, NULL, NULL, 116300),
(116301, '3.20.20.80-FF-000572', NULL, 'Beta-mannanase', 304, NULL, NULL, 116301),
(116302, '2.30.29.30-FF-001012', NULL, 'Uncharacterized protein', 39, NULL, NULL, 116302),
(116303, '3.30.70.260-FF-000093', NULL, 'UPF0250 protein BLA59_03950', 86, NULL, NULL, 116303),
(116304, '2.60.40.10-FF-005426', NULL, NULL, 104, NULL, NULL, 116304),
(116305, '3.40.1110.10-FF-000055', NULL, 'Phospholipid-transporting ATPase', 176, NULL, NULL, 116305),
(116306, '1.20.120.1220-FF-000004', NULL, 'Type 4 prepilin-like proteins leader peptide-processing enzyme', 163, NULL, NULL, 116306),
(116307, '3.40.1190.20-FF-000130', NULL, 'Ribokinase', 341, NULL, NULL, 116307),
(116308, '3.30.70.330-FF-000928', NULL, 'U4/U6 snRNA-associated-splicing factor', 192, NULL, NULL, 116308),
(116309, '3.40.50.1820-FF-000952', NULL, 'Slr1506 protein', 297, NULL, NULL, 116309),
(116310, '1.10.418.10-FF-000189', NULL, 'Coiled-coil domain containing 88A', 109, NULL, NULL, 116310),
(116311, '3.30.40.10-FF-002019', NULL, 'Predicted protein', 39, NULL, NULL, 116311),
(116312, '1.10.10.60-FF-000222', NULL, 'Transcription factor MYB36', 70, NULL, NULL, 116312),
(116313, '2.130.10.10-FF-003313', NULL, 'transducin beta-like protein 3', 169, NULL, NULL, 116313),
(116314, '1.10.287.520-FF-000003', NULL, 'Bone morphogenetic protein antagonist noggin', 61, NULL, NULL, 116314),
(116315, '2.30.30.280-FF-000004', NULL, 'tRNA-specific 2-thiouridylase MnmA', 60, NULL, NULL, 116315),
(116316, '2.60.40.10-FF-002200', NULL, 'Interleukin 2 receptor subunit gamma', 63, NULL, NULL, 116316),
(116317, '3.30.2350.10-FF-000081', NULL, 'tRNA pseudouridine synthase B', 232, NULL, NULL, 116317),
(116318, '3.90.640.10-FF-000275', NULL, 'Mitochondrial-type heat shock protein70 putative', 13, NULL, NULL, 116318),
(116319, '3.30.40.10-FF-000367', NULL, 'Cbl proto-oncogene C', 86, NULL, NULL, 116319),
(116320, '2.130.10.10-FF-001661', NULL, 'Periodic tryptophan protein 2 homolog', 210, NULL, NULL, 116320),
(116321, '3.40.50.2000-FF-000877', NULL, 'Mannosyltransferase, putative', 190, NULL, NULL, 116321),
(116322, '3.90.180.10-FF-000195', NULL, 'Uncharacterized protein', 120, NULL, NULL, 116322);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(116323, '1.20.58.60-FF-000702', NULL, 'CDC-42 Guanine nucleotide Exchange Factor', 288, NULL, NULL, 116323),
(116324, '1.10.533.10-FF-000001', NULL, 'Unc-5 netrin receptor B', 97, NULL, NULL, 116324),
(116325, '1.10.287.70-FF-000255', NULL, 'TWiK family of potassium channels', 328, NULL, NULL, 116325),
(116326, '2.120.10.80-FF-000288', NULL, 'Uncharacterized protein', 334, NULL, NULL, 116326),
(116327, '1.10.555.10-FF-000046', NULL, 'Rho GTPase-activating protein 5', 194, NULL, NULL, 116327),
(116328, '3.80.10.10-FF-001301', NULL, 'Leucine rich repeat and phosphatase domain containing protein', 169, NULL, NULL, 116328),
(116329, '1.20.58.60-FF-000848', NULL, 'Microtubule-actin cross-linking factor 1', 140, NULL, NULL, 116329),
(116330, '3.40.50.1010-FF-000243', NULL, NULL, 197, NULL, NULL, 116330),
(116331, '2.60.40.820-FF-000027', NULL, 'Tbx15 protein', 72, NULL, NULL, 116331),
(116332, '1.10.287.130-FF-000009', NULL, 'Two-component sensor histidine kinase', 61, NULL, NULL, 116332),
(116333, '3.40.190.10-FF-000925', NULL, 'AGAP006026-PA', 71, NULL, NULL, 116333),
(116334, '1.20.120.1630-FF-000037', NULL, 'Uncharacterized protein', 107, NULL, NULL, 116334),
(116335, '2.60.40.10-FF-001683', NULL, 'Protein tyrosine phosphatase, receptor type Q', 89, NULL, NULL, 116335),
(116336, '3.60.60.10-FF-000007', NULL, 'Dipeptidase', 215, NULL, NULL, 116336),
(116337, '3.40.50.1000-FF-000240', NULL, 'Hydrolase (HAD superfamily)', 167, NULL, NULL, 116337),
(116338, '3.40.50.150-FF-001661', NULL, NULL, 223, NULL, NULL, 116338),
(116339, '1.20.1250.20-FF-002193', NULL, 'Uncharacterized protein', 154, NULL, NULL, 116339),
(116340, '1.25.10.10-FF-000320', NULL, 'DnaJ homolog subfamily C GRV2', 197, NULL, NULL, 116340),
(116341, '3.90.1290.10-FF-000016', NULL, 'Uncharacterized protein, isoform G', 169, NULL, NULL, 116341),
(116342, '1.20.1420.30-FF-000079', NULL, 'Uncharacterized protein', 149, NULL, NULL, 116342),
(116343, '3.30.2230.10-FF-000015', NULL, 'Uncharacterized protein', 106, NULL, NULL, 116343),
(116344, '1.10.8.60-FF-000502', NULL, 'ATPase, AAA family protein', 73, NULL, NULL, 116344),
(116345, '1.20.58.1120-FF-000017', NULL, 'Dynein beta chain, putative', 133, NULL, NULL, 116345),
(116346, '3.40.50.300-FF-007029', NULL, 'Uncharacterized protein', 204, NULL, NULL, 116346),
(116347, '1.10.510.10-FF-003304', NULL, NULL, 80, NULL, NULL, 116347),
(116348, '3.30.1370.210-FF-000020', NULL, 'Zinc finger protein family member', 85, NULL, NULL, 116348),
(116349, '3.40.50.620-FF-000745', NULL, 'Glr0923 protein', 149, NULL, NULL, 116349),
(116350, '3.90.1150.10-FF-000478', NULL, 'Uncharacterized protein', 93, NULL, NULL, 116350),
(116351, '2.20.70.10-FF-000169', NULL, 'Pre-mRNA processing protein, putative', 32, NULL, NULL, 116351),
(116352, '2.40.50.140-FF-000942', NULL, NULL, 81, NULL, NULL, 116352),
(116353, '1.10.1200.270-FF-000001', NULL, 'Salicylate/benzoate carboxyl methyltransferase', 146, NULL, NULL, 116353),
(116354, '3.40.50.410-FF-000154', NULL, 'Uncharacterized protein', 219, NULL, NULL, 116354),
(116355, '1.10.10.10-FF-001096', NULL, 'Protein FEV', 94, NULL, NULL, 116355),
(116356, '3.40.50.2000-FF-000405', NULL, 'WbcM protein', 168, NULL, NULL, 116356),
(116357, '1.25.40.10-FF-004829', NULL, 'Uncharacterized protein', 146, NULL, NULL, 116357),
(116358, '2.60.120.920-FF-000015', NULL, 'LOW QUALITY PROTEIN: probable E3 ubiquitin-protein ligase HERC1', 159, NULL, NULL, 116358),
(116359, '3.30.930.10-FF-000007', NULL, 'Bifunctional glutamate/proline--tRNA ligase', 281, NULL, NULL, 116359),
(116360, '2.60.40.10-FF-005752', NULL, NULL, 133, NULL, NULL, 116360),
(116361, '3.30.160.60-FF-002588', NULL, 'Zinc finger protein 787', 26, NULL, NULL, 116361),
(116362, '2.40.240.10-FF-000052', NULL, 'Uncharacterized protein', 84, NULL, NULL, 116362),
(116363, '3.30.160.60-FF-002003', NULL, 'Uncharacterized protein', 30, NULL, NULL, 116363),
(116364, '3.40.720.10-FF-000242', NULL, 'Uncharacterized protein', 214, NULL, NULL, 116364),
(116365, '3.90.79.10-FF-000200', NULL, 'Uncharacterized protein', 144, NULL, NULL, 116365);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(116366, '1.25.40.20-FF-000151', NULL, 'Tonsoku like, DNA repair protein', 157, NULL, NULL, 116366),
(116367, '2.10.110.10-FF-000049', NULL, 'Four and a half LIM domains protein 2', 61, NULL, NULL, 116367),
(116368, '3.40.190.170-FF-000016', NULL, 'C4-dicarboxylase binding protein', 302, NULL, NULL, 116368),
(116369, '3.40.50.1460-FF-000029', NULL, 'Death related ced-3/Nedd2-like protein', 268, NULL, NULL, 116369),
(116370, '3.80.10.10-FF-000784', NULL, 'leucine-rich repeat receptor protein kinase EMS1', 150, NULL, NULL, 116370),
(116371, '3.50.50.60-FF-000084', NULL, 'Flavoprotein disulfide reductase', 218, NULL, NULL, 116371),
(116372, '2.60.120.290-FF-000079', NULL, 'Zinc metalloproteinase', 113, NULL, NULL, 116372),
(116373, '1.20.1270.60-FF-000177', NULL, 'Uncharacterized protein', 142, NULL, NULL, 116373),
(116374, '2.170.300.10-FF-000094', NULL, 'Uncharacterized protein', 66, NULL, NULL, 116374),
(116375, '3.40.50.620-FF-000099', NULL, 'cryptochrome-1 isoform X1', 129, NULL, NULL, 116375),
(116376, '1.20.1560.10-FF-000196', NULL, 'ABC transporter, putative', 316, NULL, NULL, 116376),
(116377, '3.30.160.60-FF-005494', NULL, NULL, 35, NULL, NULL, 116377),
(116378, '2.60.40.10-FF-001418', NULL, 'Uncharacterized protein, isoform B', 100, NULL, NULL, 116378),
(116379, '3.40.50.200-FF-000063', NULL, 'p-domain proprotein convertase, putative', 260, NULL, NULL, 116379),
(116380, '2.130.10.10-FF-001335', NULL, 'Guanine nucleotide-binding protein subunit beta 2-l', 306, NULL, NULL, 116380),
(116381, '3.60.140.10-FF-000019', NULL, 'Polyphenol oxidase', 235, NULL, NULL, 116381),
(116382, '1.20.1070.10-FF-000175', NULL, 'Prostaglandin D2 receptor', 334, NULL, NULL, 116382),
(116383, '3.30.160.60-FF-005229', NULL, NULL, 32, NULL, NULL, 116383),
(116384, '2.40.10.10-FF-000676', NULL, NULL, 91, NULL, NULL, 116384),
(116385, '1.25.40.10-FF-003374', NULL, 'Pentatricopeptide repeat-containing protein At5g55740, chloroplastic', 176, NULL, NULL, 116385),
(116386, '1.25.40.90-FF-000065', NULL, 'ENTH domain containing protein', 126, NULL, NULL, 116386),
(116387, '3.30.160.60-FF-003105', NULL, NULL, 32, NULL, NULL, 116387),
(116388, '3.30.780.10-FF-000063', NULL, 'Uncharacterized protein', 86, NULL, NULL, 116388),
(116389, '1.25.40.180-FF-000340', NULL, NULL, 177, NULL, NULL, 116389),
(116390, '1.20.1270.280-FF-000031', NULL, 'Putative dynein heavy chain', 193, NULL, NULL, 116390),
(116391, '3.40.50.150-FF-000233', NULL, 'Ribosomal RNA small subunit methyltransferase C', 147, NULL, NULL, 116391),
(116392, '3.20.20.70-FF-000243', NULL, 'Probable transmembrane GTPase FZO-like, chloroplastic', 137, NULL, NULL, 116392),
(116393, '3.30.420.10-FF-000216', NULL, 'Exosome complex exonuclease RRP6, putative', 275, NULL, NULL, 116393),
(116394, '1.10.10.350-FF-000002', NULL, 'Glutamate--tRNA ligase', 98, NULL, NULL, 116394),
(116395, '3.30.470.30-FF-000085', NULL, 'DNA ligase', 27, NULL, NULL, 116395),
(116396, '3.90.245.10-FF-000042', NULL, 'Uncharacterized protein', 77, NULL, NULL, 116396),
(116397, '3.40.50.620-FF-000571', NULL, 'Phosphopantetheine adenylyltransferase putative', 152, NULL, NULL, 116397),
(116398, '2.30.39.10-FF-000135', NULL, 'Serpin, putative', 67, NULL, NULL, 116398),
(116399, '1.25.40.10-FF-004476', NULL, 'Pentatricopeptide repeat-containing protein At1g61870, mitochondrial', 105, NULL, NULL, 116399),
(116400, '3.10.129.10-FF-000094', NULL, '4-hydroxybenzoyl-CoA thioesterase', 131, NULL, NULL, 116400),
(116401, '3.20.20.80-FF-000246', NULL, 'Predicted protein', 480, NULL, NULL, 116401),
(116402, '3.40.50.2000-FF-000731', NULL, 'Putative teichuronic acid biosynthesis glycosyl transferase TuaC', 62, NULL, NULL, 116402),
(116403, '2.170.210.20-FF-000005', NULL, 'Centriole protein', 161, NULL, NULL, 116403),
(116404, '3.30.70.3220-FF-000004', NULL, 'Protein translocase subunit SecD', 168, NULL, NULL, 116404),
(116405, '3.40.50.2300-FF-001220', NULL, NULL, 169, NULL, NULL, 116405),
(116406, '2.30.180.10-FF-000133', NULL, NULL, 158, NULL, NULL, 116406),
(116407, '3.40.50.300-FF-005590', NULL, 'Uncharacterized protein', 236, NULL, NULL, 116407);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(116408, '3.40.50.300-FF-007681', NULL, 'Uncharacterized protein', 114, NULL, NULL, 116408),
(116409, '3.40.50.300-FF-005910', NULL, 'Uncharacterized protein', 217, NULL, NULL, 116409),
(116410, '2.60.120.200-FF-000272', NULL, 'Laminin-like protein epi-1', 164, NULL, NULL, 116410),
(116411, '1.10.287.70-FF-000429', NULL, 'Sodium channel protein', 128, NULL, NULL, 116411),
(116412, '3.40.50.980-FF-000010', NULL, 'Non-ribosomal peptide synthetase', 175, NULL, NULL, 116412),
(116413, '1.10.630.10-FF-000025', NULL, 'Prostaglandin I2 (prostacyclin) synthase', 486, NULL, NULL, 116413),
(116414, '1.10.510.10-FF-001685', NULL, 'Protein kinase, putative', 186, NULL, NULL, 116414),
(116415, '3.30.40.10-FF-001210', NULL, 'PHD-finger domain containing protein', 88, NULL, NULL, 116415),
(116416, '2.170.210.10-FF-000002', NULL, 'DNA repair protein XRCC4', 118, NULL, NULL, 116416),
(116417, '3.30.200.20-FF-000534', NULL, 'Myosin light chain kinase', 104, NULL, NULL, 116417),
(116418, '1.10.10.10-FF-001449', NULL, 'Vacuolar-sorting protein SNF8', 81, NULL, NULL, 116418),
(116419, '3.30.470.20-FF-000082', NULL, 'D-alanine-D-alanine ligase family', 29, NULL, NULL, 116419),
(116420, '2.60.40.10-FF-001357', NULL, 'Interferon lambda receptor 1', 106, NULL, NULL, 116420),
(116421, '3.90.1410.10-FF-000105', NULL, 'Uncharacterized protein', 247, NULL, NULL, 116421),
(116422, '3.30.70.2850-FF-000027', NULL, 'DNA-directed RNA polymerase subunit', 213, NULL, NULL, 116422),
(116423, '1.10.510.10-FF-003630', NULL, NULL, 192, NULL, NULL, 116423),
(116424, '1.25.40.20-FF-001286', NULL, 'Transient receptor potential ion channel protein', 173, NULL, NULL, 116424),
(116425, '1.25.10.10-FF-002883', NULL, 'Predicted protein', 146, NULL, NULL, 116425),
(116426, '3.40.50.10330-FF-000082', NULL, 'Uncharacterized protein', 138, NULL, NULL, 116426),
(116427, '3.20.20.100-FF-000150', NULL, 'Uncharacterized oxidoreductase C28F2.05', 266, NULL, NULL, 116427),
(116428, '3.30.519.10-FF-000035', NULL, NULL, 202, NULL, NULL, 116428),
(116429, '2.60.40.10-FF-003509', NULL, NULL, 89, NULL, NULL, 116429),
(116430, '2.10.25.10-FF-000149', NULL, 'Fibrillin 2', 49, NULL, NULL, 116430),
(116431, '3.40.50.300-FF-001195', NULL, 'DNA repair protein rad50', 295, NULL, NULL, 116431),
(116432, '2.20.200.10-FF-000003', NULL, 'Multidrug efflux outer membrane protein OprN', 81, NULL, NULL, 116432),
(116433, '2.130.10.10-FF-004887', NULL, 'Uncharacterized protein', 117, NULL, NULL, 116433),
(116434, '2.30.29.170-FF-000003', NULL, 'EF-hand domain (C-terminal) containing 1', 129, NULL, NULL, 116434),
(116435, '4.10.400.10-FF-000103', NULL, 'Atrial natriuretic peptide-converting enzyme', 39, NULL, NULL, 116435),
(116436, '3.30.70.330-FF-002699', NULL, NULL, 113, NULL, NULL, 116436),
(116437, '1.25.40.10-FF-001603', NULL, 'Uncharacterized protein', 146, NULL, NULL, 116437),
(116438, '3.40.50.300-FF-003347', NULL, 'N-acetyltransferase, GNAT family protein', 161, NULL, NULL, 116438),
(116439, '1.20.1280.290-FF-000098', NULL, 'Sugar transporter SWEET', 59, NULL, NULL, 116439),
(116440, '3.40.250.10-FF-000217', NULL, 'Uncharacterized protein', 63, NULL, NULL, 116440),
(116441, '2.40.70.10-FF-000359', NULL, NULL, 130, NULL, NULL, 116441),
(116442, '3.40.50.300-FF-006692', NULL, 'Uncharacterized protein', 80, NULL, NULL, 116442),
(116443, '2.130.10.10-FF-002796', NULL, 'Uncharacterized protein', 201, NULL, NULL, 116443),
(116444, '1.20.58.1380-FF-000016', NULL, 'ADR216Wp', 88, NULL, NULL, 116444),
(116445, '1.25.10.10-FF-003193', NULL, 'Uncharacterized protein', 300, NULL, NULL, 116445),
(116446, '2.60.120.10-FF-000061', NULL, 'Potassium voltage-gated channel subfamily H member 3', 161, NULL, NULL, 116446),
(116447, '3.80.10.10-FF-004527', NULL, 'Uncharacterized protein', 256, NULL, NULL, 116447),
(116448, '3.80.10.10-FF-001886', NULL, 'MAP kinase phosphatase with leucine-rich repeats protein 2', 334, NULL, NULL, 116448),
(116449, '3.40.50.10490-FF-000051', NULL, 'Sugar isomerase, AgaS family', 176, NULL, NULL, 116449),
(116450, '3.40.190.290-FF-000086', NULL, 'Transcriptional regulatory protein', 204, NULL, NULL, 116450);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(116451, '3.30.465.10-FF-000038', NULL, 'D-lactate dehydrogenase', 225, NULL, NULL, 116451),
(116452, '1.25.40.20-FF-001606', NULL, 'Uncharacterized protein', 108, NULL, NULL, 116452),
(116453, '3.40.30.10-FF-000315', NULL, 'Glutathione peroxidase 2', 148, NULL, NULL, 116453),
(116454, '3.40.50.300-FF-005438', NULL, 'putative helicase MOV-10 isoform X1', 261, NULL, NULL, 116454),
(116455, '3.40.50.620-FF-000419', NULL, 'Tyrosine--tRNA ligase', 213, NULL, NULL, 116455),
(116456, '3.30.70.330-FF-003042', NULL, NULL, 170, NULL, NULL, 116456),
(116457, '2.30.30.140-FF-000221', NULL, 'glyoxylate/succinic semialdehyde reductase 1 isoform X2', 100, NULL, NULL, 116457),
(116458, '1.20.1050.40-FF-000008', NULL, 'Putative thimet oligopeptidase (Metallo-peptidase, clan ma(E), family m3)', 135, NULL, NULL, 116458),
(116459, '3.50.30.20-FF-000003', NULL, 'Carbamoyl-phosphate synthase arginine-specific small chain', 155, NULL, NULL, 116459),
(116460, '2.40.50.90-FF-000073', NULL, 'Tudor domain-containing protein 6', 96, NULL, NULL, 116460),
(116461, '3.30.70.1180-FF-000021', NULL, 'V-type proton ATPase subunit C', 43, NULL, NULL, 116461),
(116462, '3.30.1490.220-FF-000004', NULL, 'Inositol-tetrakisphosphate 1-kinase', 106, NULL, NULL, 116462),
(116463, '3.40.50.150-FF-000879', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', 235, NULL, NULL, 116463),
(116464, '3.40.50.300-FF-003286', NULL, 'Uncharacterized protein', 251, NULL, NULL, 116464),
(116465, '3.50.30.30-FF-000006', NULL, 'Putative signal peptide peptidase-like 2B', 110, NULL, NULL, 116465),
(116466, '1.10.150.20-FF-000244', NULL, 'Transcription termination/antitermination protein NusA', 57, NULL, NULL, 116466),
(116467, '3.30.980.10-FF-000044', NULL, 'Alanyl-tRNA editing protein AlaX-M', 129, NULL, NULL, 116467),
(116468, '2.30.30.100-FF-000142', NULL, 'Small nuclear ribonucleoprotein F, putative', 83, NULL, NULL, 116468),
(116469, '3.40.50.1820-FF-000008', NULL, 'Alpha/beta hydrolase domain-containing protein 17B', 216, NULL, NULL, 116469),
(116470, '3.30.300.350-FF-000004', NULL, 'Protein kinase superfamily protein', 63, NULL, NULL, 116470),
(116471, '3.30.420.10-FF-000542', NULL, NULL, 79, NULL, NULL, 116471),
(116472, '1.25.40.190-FF-000017', NULL, NULL, 88, NULL, NULL, 116472),
(116473, '2.60.120.230-FF-000022', NULL, NULL, 81, NULL, NULL, 116473),
(116474, '3.20.20.10-FF-000006', NULL, 'Ornithine decarboxylase 1', 232, NULL, NULL, 116474),
(116475, '2.30.30.40-FF-000130', NULL, 'Discs large 5, isoform A', 113, NULL, NULL, 116475),
(116476, '3.90.70.10-FF-000001', NULL, 'Calpain-1 catalytic subunit', 145, NULL, NULL, 116476),
(116477, '1.25.40.10-FF-000468', NULL, 'Intraflagellar transport 88 homolog', 200, NULL, NULL, 116477),
(116478, '3.30.1520.10-FF-000088', NULL, 'Atypical/BCR protein kinase', 129, NULL, NULL, 116478),
(116479, '3.10.310.40-FF-000007', NULL, 'Alanine--tRNA ligase, cytoplasmic', 110, NULL, NULL, 116479),
(116480, '3.30.40.10-FF-000193', NULL, 'lysine-specific demethylase PHF2 isoform X1', 70, NULL, NULL, 116480),
(116481, '1.25.40.180-FF-000194', NULL, 'Uncharacterized protein', 290, NULL, NULL, 116481),
(116482, '3.20.20.20-FF-000009', NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit delta', 310, NULL, NULL, 116482),
(116483, '3.90.1750.10-FF-000035', NULL, 'Circadian trip, isoform F', 109, NULL, NULL, 116483),
(116484, '2.40.30.170-FF-000065', NULL, NULL, 78, NULL, NULL, 116484),
(116485, '1.25.40.170-FF-000011', NULL, 'Uncharacterized protein', 127, NULL, NULL, 116485),
(116486, '1.20.140.10-FF-000131', NULL, 'Uncharacterized protein', 124, NULL, NULL, 116486),
(116487, '1.10.490.10-FF-000053', NULL, 'Zgc:92880 protein', 61, NULL, NULL, 116487),
(116488, '1.10.8.10-FF-000274', NULL, 'Uncharacterized protein', 71, NULL, NULL, 116488),
(116489, '3.40.50.300-FF-003965', NULL, 'Dicer-like 105', 145, NULL, NULL, 116489),
(116490, '1.20.1310.20-FF-000040', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 180, NULL, NULL, 116490),
(116491, '3.40.50.970-FF-000092', NULL, '2-oxoglutarate decarboxylase/hydro-lyase/magnesium ion-binding protein', 198, NULL, NULL, 116491);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(116492, '3.30.70.100-FF-000005', NULL, 'Copper-exporting P-type ATPase A', 71, NULL, NULL, 116492),
(116493, '1.10.510.10-FF-001713', NULL, 'Uncharacterized protein', 156, NULL, NULL, 116493),
(116494, '3.40.50.300-FF-006899', NULL, 'Uncharacterized protein', 240, NULL, NULL, 116494),
(116495, '3.40.50.300-FF-007181', NULL, 'AFR656Cp', 171, NULL, NULL, 116495),
(116496, '3.80.10.10-FF-002903', NULL, 'Uncharacterized protein', 140, NULL, NULL, 116496),
(116497, '1.10.540.10-FF-000113', NULL, 'Peroxisomal acyl-coenzyme A oxidase 1', 115, NULL, NULL, 116497),
(116498, '2.30.29.30-FF-000169', NULL, 'Fibroblast growth factor receptor substrate 2', 135, NULL, NULL, 116498),
(116499, '1.20.1250.20-FF-002367', NULL, 'Uncharacterized protein', 325, NULL, NULL, 116499),
(116500, '3.20.20.70-FF-000743', NULL, NULL, 71, NULL, NULL, 116500),
(116501, '3.40.50.300-FF-002976', NULL, 'DNA replication and repair protein RecF', 147, NULL, NULL, 116501),
(116502, '3.40.50.300-FF-001841', NULL, 'DEAD/DEAH box helicase, putative', 202, NULL, NULL, 116502),
(116503, '3.30.70.330-FF-000754', NULL, 'mRNA processing protein', 111, NULL, NULL, 116503),
(116504, '1.20.1560.10-FF-000050', NULL, 'Vacuolar ABC heavy metal transporter (Hmt1)', 323, NULL, NULL, 116504),
(116505, '3.30.565.10-FF-000102', NULL, 'Sensor histidine kinase', 155, NULL, NULL, 116505),
(116506, '3.10.105.10-FF-000033', NULL, 'ABC transporter substrate-binding protein', 211, NULL, NULL, 116506),
(116507, '3.40.50.20-FF-000027', NULL, 'D-alanine-D-alanine ligase family', 143, NULL, NULL, 116507),
(116508, '3.30.2410.10-FF-000052', NULL, 'Probable E3 ubiquitin-protein ligase mug30', 139, NULL, NULL, 116508),
(116509, '3.30.450.20-FF-000226', NULL, 'Sensory transduction histidine kinase', 118, NULL, NULL, 116509),
(116510, '1.25.10.10-FF-000966', NULL, 'Armadillo/beta-catenin repeat family protein', 108, NULL, NULL, 116510),
(116511, '3.20.20.80-FF-000746', NULL, 'Uncharacterized protein', 72, NULL, NULL, 116511),
(116512, '2.60.40.10-FF-001711', NULL, 'Platelet and endothelial cell adhesion molecule 1', 80, NULL, NULL, 116512),
(116513, '3.30.710.10-FF-000289', NULL, 'SKP1-like protein 1A isoform B', 104, NULL, NULL, 116513),
(116514, '2.10.230.10-FF-000030', NULL, 'Uncharacterized protein', 51, NULL, NULL, 116514),
(116515, '1.20.120.810-FF-000009', NULL, NULL, 243, NULL, NULL, 116515),
(116516, '1.10.10.750-FF-000032', NULL, 'Similar to GTPase-activating protein GYP5', 47, NULL, NULL, 116516),
(116517, '2.30.42.10-FF-000542', NULL, NULL, 97, NULL, NULL, 116517),
(116518, '3.80.10.10-FF-002257', NULL, 'Uncharacterized protein', 108, NULL, NULL, 116518),
(116519, '1.25.40.180-FF-000014', NULL, 'Putative regulator of nonsense transcripts 2', 312, NULL, NULL, 116519),
(116520, '1.25.40.420-FF-000075', NULL, 'Uncharacterized protein', 57, NULL, NULL, 116520),
(116521, '3.30.420.10-FF-000188', NULL, 'YALI0B06303p', 172, NULL, NULL, 116521),
(116522, '2.30.30.380-FF-000001', NULL, 'Protein transport protein SEC23', 61, NULL, NULL, 116522),
(116523, '3.30.200.20-FF-001023', NULL, 'Serine/threonine protein kinase, putative', 135, NULL, NULL, 116523),
(116524, '1.50.40.10-FF-000522', NULL, 'Mitochondrial energy transfer protein', 176, NULL, NULL, 116524),
(116525, '3.40.50.2000-FF-000377', NULL, 'Glycosyltransferase', 237, NULL, NULL, 116525),
(116526, '3.30.40.10-FF-000428', NULL, 'U-box domain-containing protein 54', 77, NULL, NULL, 116526),
(116527, '1.20.1070.10-FF-001895', NULL, 'Frizzled class receptor 7', 289, NULL, NULL, 116527),
(116528, '1.10.510.10-FF-001359', NULL, 'Serine-threonine protein kinase, putative', 151, NULL, NULL, 116528),
(116529, '1.10.287.470-FF-000027', NULL, 'HAE1 family efflux pump MFP component', 60, NULL, NULL, 116529),
(116530, '2.130.10.10-FF-003813', NULL, 'AEL063Wp', 307, NULL, NULL, 116530),
(116531, '3.40.50.720-FF-000303', NULL, 'Redox-sensing transcriptional repressor Rex', 130, NULL, NULL, 116531),
(116532, '3.30.70.2610-FF-000006', NULL, 'RNA polymerase II transcription factor B subunit 2', 76, NULL, NULL, 116532);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(116533, '2.40.20.10-FF-000002', NULL, 'Hepatocyte growth factor', 84, NULL, NULL, 116533),
(116534, '1.10.630.10-FF-000351', NULL, 'Uncharacterized protein', 475, NULL, NULL, 116534),
(116535, '3.40.50.300-FF-000121', NULL, 'RNA cytidine acetyltransferase', 138, NULL, NULL, 116535),
(116536, '2.170.240.10-FF-000004', NULL, 'Collagen type IV alpha 6 chain', 102, NULL, NULL, 116536),
(116537, '3.30.70.330-FF-000428', NULL, 'Related to WHI3-involved in regulation of cell size', 101, NULL, NULL, 116537),
(116538, '3.40.50.2300-FF-001512', NULL, NULL, 94, NULL, NULL, 116538),
(116539, '1.10.1200.10-FF-000042', NULL, 'Mrpl13p', 73, NULL, NULL, 116539),
(116540, '1.10.340.70-FF-000009', NULL, 'Gag-Pol polyprotein', 100, NULL, NULL, 116540),
(116541, '3.40.50.720-FF-000775', NULL, 'C-terminal-binding protein 2', 59, NULL, NULL, 116541),
(116542, '2.130.10.10-FF-003252', NULL, 'WD repeat protein, putative', 211, NULL, NULL, 116542),
(116543, '3.40.30.10-FF-001097', NULL, 'Uncharacterized protein', 72, NULL, NULL, 116543),
(116544, '3.40.50.720-FF-000157', NULL, 'Quinoid dihydropteridine reductase', 235, NULL, NULL, 116544),
(116545, '3.30.460.10-FF-000016', NULL, 'Multifunctional CCA protein', 124, NULL, NULL, 116545),
(116546, '2.10.25.10-FF-000475', NULL, 'latent-transforming growth factor beta-binding protein 1 isoform X3', 40, NULL, NULL, 116546),
(116547, '1.20.120.1080-FF-000119', NULL, 'YALI0C02365p', 104, NULL, NULL, 116547),
(116548, '3.40.1110.10-FF-000408', NULL, NULL, 62, NULL, NULL, 116548),
(116549, '2.20.100.10-FF-000086', NULL, 'ADAMTS like 3', 59, NULL, NULL, 116549),
(116550, '1.20.120.50-FF-000001', NULL, 'GGDEF family protein', 134, NULL, NULL, 116550),
(116551, '2.60.40.10-FF-005073', NULL, NULL, 100, NULL, NULL, 116551),
(116552, '3.30.70.330-FF-002199', NULL, NULL, 110, NULL, NULL, 116552),
(116553, '3.40.50.1820-FF-000626', NULL, 'Probable inactive carboxylesterase Os04g0669700', 228, NULL, NULL, 116553),
(116554, '3.90.190.10-FF-000493', NULL, 'Uncharacterized protein', 299, NULL, NULL, 116554),
(116555, '1.25.10.10-FF-003046', NULL, 'Uncharacterized protein', 286, NULL, NULL, 116555),
(116556, '3.50.50.60-FF-000937', NULL, 'NADH-rubredoxin oxidoreductase', 110, NULL, NULL, 116556),
(116557, '2.10.25.10-FF-000621', NULL, 'Crumbs, isoform D', 39, NULL, NULL, 116557),
(116558, '1.10.287.1150-FF-000002', NULL, '2-oxoglutarate dehydrogenase E1 component', 93, NULL, NULL, 116558),
(116559, '3.40.50.1820-FF-000334', NULL, 'S-formylglutathione hydrolase', 281, NULL, NULL, 116559),
(116560, '3.30.460.20-FF-000019', NULL, 'Magnesium and cobalt transport protein CorA, putative', 132, NULL, NULL, 116560),
(116561, '3.90.1180.10-FF-000008', NULL, '50S ribosomal protein L13', 150, NULL, NULL, 116561),
(116562, '3.60.110.10-FF-000017', NULL, 'Carbon-nitrogen hydrolase family protein', 291, NULL, NULL, 116562),
(116563, '1.20.1250.20-FF-000568', NULL, 'Transporter, major facilitator family protein', 206, NULL, NULL, 116563),
(116564, '1.20.58.60-FF-000641', NULL, 'Uncharacterized protein', 267, NULL, NULL, 116564),
(116565, '2.30.29.30-FF-000702', NULL, 'EPS8-like 3', 134, NULL, NULL, 116565),
(116566, '2.40.50.140-FF-000796', NULL, NULL, 147, NULL, NULL, 116566),
(116567, '3.30.160.60-FF-003077', NULL, 'Zinc finger protein 579', 30, NULL, NULL, 116567),
(116568, '3.30.710.10-FF-000435', NULL, 'Uncharacterized protein', 56, NULL, NULL, 116568),
(116569, '2.60.40.10-FF-000694', NULL, 'Myotilin', 98, NULL, NULL, 116569),
(116570, '3.40.1180.10-FF-000003', NULL, 'Isoprenyl transferase 2', 245, NULL, NULL, 116570),
(116571, '3.40.50.1220-FF-000008', NULL, 'Acetolactate synthase', 175, NULL, NULL, 116571),
(116572, '1.20.1250.20-FF-000922', NULL, 'Solute carrier family 2 member 13', 281, NULL, NULL, 116572),
(116573, '4.10.80.30-FF-000003', NULL, NULL, 26, NULL, NULL, 116573),
(116574, '1.25.10.10-FF-001129', NULL, 'Putative STAG3-like protein 1', 133, NULL, NULL, 116574),
(116575, '1.20.1090.10-FF-000058', NULL, 'Glycerol-1-phosphate dehydrogenase (NAD(P)(+))', 181, NULL, NULL, 116575),
(116576, '2.60.40.60-FF-000776', NULL, 'Cadherin', 119, NULL, NULL, 116576);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(116577, '3.30.420.140-FF-000007', NULL, 'Transcription elongation factor SPT6', 167, NULL, NULL, 116577),
(116578, '2.130.10.10-FF-005730', NULL, 'Uncharacterized protein', 133, NULL, NULL, 116578),
(116579, '3.90.1150.10-FF-000506', NULL, 'Glycine cleavage system P protein', 75, NULL, NULL, 116579),
(116580, '4.10.240.10-FF-000214', NULL, 'Uncharacterized protein', 56, NULL, NULL, 116580),
(116581, '2.130.10.10-FF-003459', NULL, 'AGAP008620-PA', 94, NULL, NULL, 116581),
(116582, '2.60.40.10-FF-003156', NULL, 'Two-component system sensor histidine kinase/response regulator', 130, NULL, NULL, 116582),
(116583, '1.20.1560.10-FF-000903', NULL, 'Uncharacterized protein', 189, NULL, NULL, 116583),
(116584, '1.10.2000.10-FF-000061', NULL, NULL, 64, NULL, NULL, 116584),
(116585, '2.10.25.10-FF-001577', NULL, 'Uncharacterized protein', 40, NULL, NULL, 116585),
(116586, '3.90.550.20-FF-000007', NULL, 'Glycosyltransferase, putative', 187, NULL, NULL, 116586),
(116587, '3.40.190.80-FF-000047', NULL, 'Carbohydrate phosphatase', 127, NULL, NULL, 116587),
(116588, '3.30.40.10-FF-001856', NULL, 'Uncharacterized protein', 81, NULL, NULL, 116588),
(116589, '1.10.510.10-FF-000696', NULL, 'NIMA-related kinase 10', 235, NULL, NULL, 116589),
(116590, '3.30.160.60-FF-005022', NULL, NULL, 43, NULL, NULL, 116590),
(116591, '1.10.10.10-FF-001157', NULL, 'Crp/Fnr family transcriptional regulator', 67, NULL, NULL, 116591),
(116592, '2.30.42.10-FF-000216', NULL, 'Uncharacterized protein, isoform F', 89, NULL, NULL, 116592),
(116593, '1.20.1070.10-FF-002092', NULL, 'Uncharacterized protein', 235, NULL, NULL, 116593),
(116594, '3.30.70.270-FF-000157', NULL, NULL, 83, NULL, NULL, 116594),
(116595, '3.40.1110.10-FF-000201', NULL, 'Proton motive ATPase, putative', 141, NULL, NULL, 116595),
(116596, '1.20.1070.10-FF-000349', NULL, 'prolactin-releasing peptide receptor', 336, NULL, NULL, 116596),
(116597, '3.90.550.10-FF-000004', NULL, 'UDP-glucose glycoprotein glucosyltransferase 1', 251, NULL, NULL, 116597),
(116598, '3.30.40.10-FF-002345', NULL, 'Predicted protein', 89, NULL, NULL, 116598),
(116599, '3.30.70.330-FF-002906', NULL, NULL, 40, NULL, NULL, 116599),
(116600, '1.10.287.70-FF-000194', NULL, 'Voltage-gated Ion Channel', 97, NULL, NULL, 116600),
(116601, '3.30.70.1230-FF-000143', NULL, 'Adenylate/guanylate cyclase domain-containing protein', 191, NULL, NULL, 116601),
(116602, '3.30.479.10-FF-000008', NULL, '6-pyruvoyl tetrahydrobiopterin synthase', 51, NULL, NULL, 116602),
(116603, '2.170.16.10-FF-000008', NULL, 'Protein RecA', 91, NULL, NULL, 116603),
(116604, '3.40.50.2000-FF-000905', NULL, 'UDP-N-acetylglucosamine 2-epimerase', 165, NULL, NULL, 116604),
(116605, '3.30.190.20-FF-000009', NULL, 'Ribosomal protein L10a', 119, NULL, NULL, 116605),
(116606, '3.40.50.620-FF-000806', NULL, 'Nicotinamide mononucleotide adenylyltransferase, putative', 61, NULL, NULL, 116606),
(116607, '3.30.200.20-FF-000826', NULL, 'Protein CBG09071', 72, NULL, NULL, 116607),
(116608, '3.30.230.10-FF-000325', NULL, 'Uncharacterized protein', 103, NULL, NULL, 116608),
(116609, '3.30.450.20-FF-000552', NULL, 'Sensory transduction histidine kinase', 117, NULL, NULL, 116609),
(116610, '2.60.40.640-FF-000097', NULL, 'Arrestin 3, retinal (X-arrestin)', 138, NULL, NULL, 116610),
(116611, '3.40.190.10-FF-000779', NULL, 'ABC transporter substrate-binding protein', 280, NULL, NULL, 116611),
(116612, '3.90.650.10-FF-000040', NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase', 174, NULL, NULL, 116612),
(116613, '1.10.1060.10-FF-000036', NULL, NULL, 117, NULL, NULL, 116613),
(116614, '1.25.40.10-FF-005291', NULL, 'Uncharacterized protein', 139, NULL, NULL, 116614),
(116615, '2.30.29.30-FF-000495', NULL, 'Acidic elicitin A1', 98, NULL, NULL, 116615),
(116616, '3.50.50.60-FF-000376', NULL, 'Protoporphyrinogen oxidase', 37, NULL, NULL, 116616),
(116617, '3.80.10.10-FF-001594', NULL, 'Os06g0692600 protein', 95, NULL, NULL, 116617),
(116618, '3.30.160.60-FF-000997', NULL, 'Zinc finger and BTB domain-containing protein 11', 26, NULL, NULL, 116618);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(116619, '3.40.50.9100-FF-000001', NULL, '3-dehydroquinate dehydratase', 146, NULL, NULL, 116619),
(116620, '3.30.470.20-FF-000256', NULL, 'Uncharacterized protein', 55, NULL, NULL, 116620),
(116621, '3.30.428.10-FF-000071', NULL, 'Uncharacterized protein', 142, NULL, NULL, 116621),
(116622, '2.60.40.10-FF-001183', NULL, 'Cytokine receptor common subunit gamma', 99, NULL, NULL, 116622),
(116623, '2.40.50.100-FF-000099', NULL, 'V-type ATP synthase alpha chain', 73, NULL, NULL, 116623),
(116624, '3.40.50.720-FF-000483', NULL, 'Pentafunctional AROM polypeptide', 158, NULL, NULL, 116624),
(116625, '3.40.50.150-FF-001335', NULL, NULL, 198, NULL, NULL, 116625),
(116626, '3.40.50.10330-FF-000109', NULL, 'NAD kinase', 90, NULL, NULL, 116626),
(116627, '3.40.50.300-FF-005764', NULL, 'Dynein heavy chain, cytoplasmic', 116, NULL, NULL, 116627),
(116628, '2.60.40.60-FF-000130', NULL, 'cadherin-23 isoform X1', 104, NULL, NULL, 116628),
(116629, '3.40.50.300-FF-003639', NULL, 'RAD50 DNA repair-like protein', 416, NULL, NULL, 116629),
(116630, '1.10.10.60-FF-001296', NULL, NULL, 93, NULL, NULL, 116630),
(116631, '2.60.40.10-FF-003335', NULL, 'Immunoglobulin domain-containing protein Y54G2A.25', 92, NULL, NULL, 116631),
(116632, '2.10.50.10-FF-000101', NULL, 'Uncharacterized protein', 63, NULL, NULL, 116632),
(116633, '3.90.190.10-FF-000167', NULL, 'Putative prenylated protein tyrosine phosphatase', 171, NULL, NULL, 116633),
(116634, '1.10.287.10-FF-000052', NULL, 'Asparagine--tRNA ligase, cytoplasmic 1', 49, NULL, NULL, 116634),
(116635, '3.80.10.10-FF-002083', NULL, 'Uncharacterized protein', 198, NULL, NULL, 116635),
(116636, '3.30.160.60-FF-001486', NULL, 'Zinc finger protein 174', 36, NULL, NULL, 116636),
(116637, '2.60.120.200-FF-000564', NULL, 'Galectin-10', 68, NULL, NULL, 116637),
(116638, '1.10.510.10-FF-003922', NULL, NULL, 74, NULL, NULL, 116638),
(116639, '1.10.150.110-FF-000010', NULL, 'DNA polymerase', 71, NULL, NULL, 116639),
(116640, '1.10.12.10-FF-000004', NULL, 'Delta3,5-delta2,4-dienoyl-CoA isomerase', 60, NULL, NULL, 116640),
(116641, '1.10.225.10-FF-000027', NULL, 'MGC154673 protein', 76, NULL, NULL, 116641),
(116642, '1.20.1560.10-FF-000549', NULL, 'Uncharacterized protein', 326, NULL, NULL, 116642),
(116643, '1.25.40.20-FF-001578', NULL, 'Uncharacterized protein', 165, NULL, NULL, 116643),
(116644, '1.25.40.10-FF-003520', NULL, 'Uncharacterized protein', 242, NULL, NULL, 116644),
(116645, '1.10.287.70-FF-000755', NULL, 'Uncharacterized protein', 61, NULL, NULL, 116645),
(116646, '3.30.470.20-FF-000109', NULL, 'Inositol 1,3,4-trisphosphate 5/6-kinase, putative', 198, NULL, NULL, 116646),
(116647, '3.30.930.10-FF-000333', NULL, 'Prolyl Amino-acyl tRNA Synthetase', 119, NULL, NULL, 116647),
(116648, '1.10.10.2670-FF-000012', NULL, 'Uncharacterized protein', 98, NULL, NULL, 116648),
(116649, '1.10.3200.20-FF-000012', NULL, NULL, 174, NULL, NULL, 116649),
(116650, '3.40.366.10-FF-000059', NULL, 'Malonyl-CoA--acyl carrier protein transacylase', 279, NULL, NULL, 116650),
(116651, '1.25.10.10-FF-001276', NULL, 'formin-like protein 2 isoform X2', 243, NULL, NULL, 116651),
(116652, '2.40.50.140-FF-000616', NULL, '30S ribosomal protein S1', 84, NULL, NULL, 116652),
(116653, '1.20.5.240-FF-000002', NULL, 'Matrix metalloproteinase-28-like Protein', 27, NULL, NULL, 116653),
(116654, '3.40.30.10-FF-000141', NULL, 'Thioredoxin domain-containing protein 9', 132, NULL, NULL, 116654),
(116655, '3.30.160.60-FF-003431', NULL, NULL, 28, NULL, NULL, 116655),
(116656, '3.30.450.20-FF-000373', NULL, 'Sensory transduction histidine kinase', 138, NULL, NULL, 116656),
(116657, '3.40.1110.10-FF-000381', NULL, NULL, 145, NULL, NULL, 116657),
(116658, '3.30.9.10-FF-000103', NULL, 'Opine oxidase subunit B', 145, NULL, NULL, 116658),
(116659, '2.40.128.180-FF-000016', NULL, NULL, 37, NULL, NULL, 116659),
(116660, '3.30.40.10-FF-000754', NULL, 'ATP-dependent helicase ULS1', 91, NULL, NULL, 116660),
(116661, '2.60.120.650-FF-000058', NULL, 'Lysine-specific demethylase JMJ25 isoform A', 337, NULL, NULL, 116661),
(116662, '1.10.510.10-FF-003484', NULL, NULL, 266, NULL, NULL, 116662);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(116663, '3.20.20.70-FF-000417', NULL, 'Glycerol uptake operon antiterminator regulatory protein', 182, NULL, NULL, 116663),
(116664, '3.30.70.330-FF-001064', NULL, 'GM25167', 109, NULL, NULL, 116664),
(116665, '1.10.150.130-FF-000016', NULL, 'Inner kinetochore protein/centromere binding factor Cbf3a', 106, NULL, NULL, 116665),
(116666, '1.20.1560.10-FF-000342', NULL, 'ATP-dependent bile acid transporter, putative', 337, NULL, NULL, 116666),
(116667, '3.40.50.620-FF-000245', NULL, 'FAD synthetase', 309, NULL, NULL, 116667),
(116668, '2.60.40.150-FF-000719', NULL, 'Phosphoinositide phospholipase C', 128, NULL, NULL, 116668),
(116669, '3.40.190.10-FF-000572', NULL, 'Extracellular solute-binding protein family 5', 282, NULL, NULL, 116669),
(116670, '1.20.1720.10-FF-000085', NULL, NULL, 158, NULL, NULL, 116670),
(116671, '2.30.27.10-FF-000001', NULL, 'Attachment protein G3P', 67, NULL, NULL, 116671),
(116672, '1.25.40.570-FF-000069', NULL, 'COP9 signalosome complex subunit 2, putative', 374, NULL, NULL, 116672),
(116673, '2.60.120.260-FF-000649', NULL, 'Uncharacterized protein', 96, NULL, NULL, 116673),
(116674, '1.10.510.10-FF-000050', NULL, 'Tyrosine-protein kinase receptor', 214, NULL, NULL, 116674),
(116675, '2.60.490.10-FF-000021', NULL, 'Uncharacterized protein', 76, NULL, NULL, 116675),
(116676, '1.10.287.130-FF-000156', NULL, 'Probable two-component sensor', 70, NULL, NULL, 116676),
(116677, '1.10.10.10-FF-000022', NULL, 'Histone acetyltransferase', 84, NULL, NULL, 116677),
(116678, '2.30.30.140-FF-000075', NULL, 'putative ATP-dependent RNA helicase TDRD12', 77, NULL, NULL, 116678),
(116679, '1.10.150.120-FF-000013', NULL, 'Predicted protein', 112, NULL, NULL, 116679),
(116680, '3.30.200.20-FF-000388', NULL, 'Mitogen-activated protein kinase 2', 98, NULL, NULL, 116680),
(116681, '2.30.30.40-FF-000012', NULL, 'Arf-GAP with SH3 domain, ANK repeat and PH domain-containing protein 2', 61, NULL, NULL, 116681),
(116682, '2.60.120.290-FF-000107', NULL, 'Protein CBR-MIG-13', 145, NULL, NULL, 116682),
(116683, '3.30.450.60-FF-000070', NULL, 'AP complex subunit sigma', 39, NULL, NULL, 116683),
(116684, '3.40.50.1820-FF-000126', NULL, 'Lipase', 372, NULL, NULL, 116684),
(116685, '3.40.50.720-FF-002366', NULL, 'Uncharacterized protein', 140, NULL, NULL, 116685),
(116686, '3.30.160.60-FF-000789', NULL, 'Zinc finger protein 329', 28, NULL, NULL, 116686),
(116687, '1.20.1440.100-FF-000005', NULL, 'HAD-IB family hydrolase', 73, NULL, NULL, 116687),
(116688, '3.40.50.300-FF-004893', NULL, 'Predicted protein', 167, NULL, NULL, 116688),
(116689, '3.40.50.300-FF-001756', NULL, 'Si:dkey-185m8.2', 210, NULL, NULL, 116689),
(116690, '3.40.50.620-FF-000127', NULL, 'Glutamate--tRNA ligase', 354, NULL, NULL, 116690),
(116691, '3.40.50.1820-FF-000598', NULL, 'Cholinesterase', 141, NULL, NULL, 116691),
(116692, '2.70.50.80-FF-000001', NULL, 'Transcriptional enhancer factor TEF-1, putative', 229, NULL, NULL, 116692),
(116693, '3.30.780.10-FF-000029', NULL, 'Translation initiation factor SUI1 family protein', 81, NULL, NULL, 116693),
(116694, '2.10.55.10-FF-000005', NULL, 'Leishmanolysin-like peptidase', 77, NULL, NULL, 116694),
(116695, '1.20.5.710-FF-000014', NULL, '50S ribosomal protein L7/L12', 52, NULL, NULL, 116695),
(116696, '1.20.140.10-FF-000013', NULL, 'Acyl-coenzyme A oxidase', 133, NULL, NULL, 116696),
(116697, '1.25.40.60-FF-000022', NULL, NULL, 109, NULL, NULL, 116697),
(116698, '2.60.220.50-FF-000171', NULL, 'Receptor for egg jelly 3 protein; Uncharacterized protein', 119, NULL, NULL, 116698),
(116699, '1.20.1250.20-FF-001878', NULL, 'Monocarboxylate transporter, putative', 101, NULL, NULL, 116699),
(116700, '3.40.390.10-FF-000199', NULL, NULL, 125, NULL, NULL, 116700),
(116701, '3.20.20.450-FF-000024', NULL, NULL, 244, NULL, NULL, 116701),
(116702, '3.30.40.10-FF-000075', NULL, 'Putative e3 ubiquitin-protein ligase rnf43', 99, NULL, NULL, 116702),
(116703, '2.30.170.20-FF-000017', NULL, 'Ribosomal protein L24e, putative', 69, NULL, NULL, 116703),
(116704, '2.10.10.10-FF-000008', NULL, 'Epididymal sperm-binding protein 1', 50, NULL, NULL, 116704);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(116705, '3.20.20.190-FF-000103', NULL, 'Glycerophosphoryl diester phosphodiesterase', 294, NULL, NULL, 116705),
(116706, '2.60.40.1090-FF-000015', NULL, 'Type 1 fimbrin D-mannose specific adhesin', 158, NULL, NULL, 116706),
(116707, '3.40.50.2300-FF-000731', NULL, 'Two-component response regulator,transcriptional regulatory protein LuxO', 130, NULL, NULL, 116707),
(116708, '3.50.50.60-FF-000584', NULL, 'Sulfide Quinone oxidoReDuctase', 64, NULL, NULL, 116708),
(116709, '1.25.40.10-FF-003402', NULL, 'Pentatricopeptide repeat-containing protein At2g37230', 129, NULL, NULL, 116709),
(116710, '3.40.50.720-FF-000275', NULL, 'Alcohol dehydrogenase AdhA', 131, NULL, NULL, 116710),
(116711, '3.30.460.10-FF-000134', NULL, 'Uncharacterized protein TCIL3000_9_2600', 34, NULL, NULL, 116711),
(116712, '1.10.30.10-FF-000023', NULL, 'nucleolar transcription factor 1 isoform X2', 67, NULL, NULL, 116712),
(116713, '1.20.1250.20-FF-000361', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 202, NULL, NULL, 116713),
(116714, '1.50.40.10-FF-000022', NULL, 'mitochondrial carrier homolog 1 isoform X1', 304, NULL, NULL, 116714),
(116715, '3.30.60.30-FF-000031', NULL, 'Serine protease inhibitor Kazal-type 2', 57, NULL, NULL, 116715),
(116716, '3.60.10.10-FF-000414', NULL, 'Flavin-containing monooxygenase', 207, NULL, NULL, 116716),
(116717, '2.130.10.10-FF-004595', NULL, 'Uncharacterized protein', 205, NULL, NULL, 116717),
(116718, '3.30.50.10-FF-000047', NULL, 'glucocorticoid receptor isoform X1', 107, NULL, NULL, 116718),
(116719, '3.30.428.10-FF-000037', NULL, 'AGAP010932-PA', 133, NULL, NULL, 116719),
(116720, '3.30.160.60-FF-001840', NULL, 'Paternally-expressed gene 3 protein', 28, NULL, NULL, 116720),
(116721, '4.10.400.10-FF-000075', NULL, 'Low-density lipoprotein receptor-related protein 6', 33, NULL, NULL, 116721),
(116722, '1.10.8.1220-FF-000027', NULL, NULL, 96, NULL, NULL, 116722),
(116723, '2.60.120.200-FF-000238', NULL, 'Os04g0141400 protein', 250, NULL, NULL, 116723),
(116724, '2.60.40.10-FF-005134', NULL, NULL, 122, NULL, NULL, 116724),
(116725, '1.10.10.1050-FF-000010', NULL, 'mRNA decapping protein, putative', 93, NULL, NULL, 116725),
(116726, '3.90.1150.10-FF-000299', NULL, 'Aspartate aminotransferase', 112, NULL, NULL, 116726),
(116727, '1.10.287.770-FF-000027', NULL, 'Pickpocket 14', 63, NULL, NULL, 116727),
(116728, '4.10.1060.50-FF-000001', NULL, 'ubiquitin-60S ribosomal protein L40', 50, NULL, NULL, 116728),
(116729, '2.130.10.10-FF-000907', NULL, 'WD repeat protein', 168, NULL, NULL, 116729),
(116730, '1.10.510.10-FF-001831', NULL, NULL, 96, NULL, NULL, 116730),
(116731, '3.40.50.1260-FF-000059', NULL, 'Uncharacterized protein', 25, NULL, NULL, 116731),
(116732, '2.10.60.10-FF-000045', NULL, 'Potassium inwardly-rectifying channel, subfamily J, member 11,-like', 78, NULL, NULL, 116732),
(116733, '3.80.10.10-FF-003100', NULL, 'Uncharacterized protein (Fragment)', 112, NULL, NULL, 116733),
(116734, '3.40.50.300-FF-006984', NULL, 'Dephospho-CoA kinase', 215, NULL, NULL, 116734),
(116735, '3.30.2450.30-FF-000004', NULL, 'Uncharacterized protein', 124, NULL, NULL, 116735),
(116736, '3.40.50.300-FF-003847', NULL, 'Uncharacterized protein', 225, NULL, NULL, 116736),
(116737, '3.40.50.300-FF-005556', NULL, 'Double Clp-N motif-containing P-loop nucleoside triphosphate hydrolases superfamily protein', 276, NULL, NULL, 116737),
(116738, '3.30.559.10-FF-000009', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 233, NULL, NULL, 116738),
(116739, '2.60.40.10-FF-001391', NULL, 'Beta-glucosidase', 122, NULL, NULL, 116739),
(116740, '3.40.930.10-FF-000016', NULL, 'Galactitol-specific enzyme IIA of phosphotransferase system', 146, NULL, NULL, 116740),
(116741, '3.30.70.330-FF-002671', NULL, NULL, 132, NULL, NULL, 116741),
(116742, '3.30.200.20-FF-001377', NULL, 'TAO kinase 3', 39, NULL, NULL, 116742),
(116743, '1.20.120.1920-FF-000001', NULL, 'Ubiquitin associated protein 1', 117, NULL, NULL, 116743),
(116744, '3.40.1380.20-FF-000021', NULL, 'Pyruvate kinase', 133, NULL, NULL, 116744);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(116745, '3.30.40.10-FF-000546', NULL, 'Regulating synaptic membrane exocytosis 1', 130, NULL, NULL, 116745),
(116746, '3.30.160.60-FF-001306', NULL, 'Zinc finger protein 287', 33, NULL, NULL, 116746),
(116747, '1.25.10.10-FF-002849', NULL, 'Uncharacterized protein', 512, NULL, NULL, 116747),
(116748, '3.40.1280.10-FF-000067', NULL, 'Conserved protein', 149, NULL, NULL, 116748),
(116749, '1.20.1560.10-FF-000049', NULL, 'ABC transporter B family member 6', 151, NULL, NULL, 116749),
(116750, '1.10.101.10-FF-000021', NULL, 'N-acetylmuramoyl-L-alanine amidase', 83, NULL, NULL, 116750),
(116751, '1.20.120.720-FF-000016', NULL, 'Myosin VB', 149, NULL, NULL, 116751),
(116752, '3.30.360.10-FF-000132', NULL, 'Uncharacterized protein', 43, NULL, NULL, 116752),
(116753, '2.60.40.10-FF-001239', NULL, 'Programmed cell death 1 ligand 2', 97, NULL, NULL, 116753),
(116754, '1.25.10.10-FF-001068', NULL, 'Unplaced genomic scaffold supercont2.21, whole genome shotgun sequence', 240, NULL, NULL, 116754),
(116755, '1.20.970.10-FF-000025', NULL, 'Anthranilate phosphoribosyl transferase, putative', 78, NULL, NULL, 116755),
(116756, '2.10.90.10-FF-000081', NULL, 'DAN domain family member 5', 110, NULL, NULL, 116756),
(116757, '1.20.1560.10-FF-000550', NULL, 'AGAP012467-PA', 242, NULL, NULL, 116757),
(116758, '1.10.150.250-FF-000001', NULL, 'FAD assembly factor SdhE', 88, NULL, NULL, 116758),
(116759, '3.80.10.10-FF-002583', NULL, 'Leucine-rich repeat serine/threonine-protein kinase 1', 105, NULL, NULL, 116759),
(116760, '1.25.40.10-FF-001249', NULL, 'Mitochondrial fission 1 protein', 141, NULL, NULL, 116760),
(116761, '2.130.10.10-FF-005258', NULL, 'Uncharacterized protein', 270, NULL, NULL, 116761),
(116762, '2.60.40.10-FF-003920', NULL, NULL, 108, NULL, NULL, 116762),
(116763, '3.60.40.10-FF-000242', NULL, 'Uncharacterized protein', 162, NULL, NULL, 116763),
(116764, '2.60.120.260-FF-000149', NULL, 'Leupeptin-inactivating enzyme 1', 115, NULL, NULL, 116764),
(116765, '2.60.40.4150-FF-000001', NULL, 'Type VI secretion system lipoprotein TssJ', 129, NULL, NULL, 116765),
(116766, '3.80.10.10-FF-000930', NULL, 'F-box/LRR-repeat protein 20', 87, NULL, NULL, 116766),
(116767, '1.10.150.810-FF-000006', NULL, 'Putative DNA polymerase kappa', 100, NULL, NULL, 116767),
(116768, '1.20.58.390-FF-000030', NULL, 'Acetylcholine receptor subunit alpha-L1', 79, NULL, NULL, 116768),
(116769, '2.60.470.10-FF-000019', NULL, 'Pickpocket 15', 156, NULL, NULL, 116769),
(116770, '2.30.30.490-FF-000034', NULL, 'protein polybromo-1 isoform X1', 237, NULL, NULL, 116770),
(116771, '1.10.510.10-FF-002495', NULL, NULL, 86, NULL, NULL, 116771),
(116772, '3.40.50.2300-FF-000995', NULL, NULL, 84, NULL, NULL, 116772),
(116773, '3.90.226.10-FF-000178', NULL, 'Acetyl-CoA carboxylase multifunctional enzyme AccADCB', 299, NULL, NULL, 116773),
(116774, '1.25.10.20-FF-000031', NULL, 'Predicted protein', 332, NULL, NULL, 116774),
(116775, '1.10.506.10-FF-000034', NULL, 'IRA1p GTPase-activating protein', 202, NULL, NULL, 116775),
(116776, '2.30.39.10-FF-000017', NULL, 'Serpin family A member 10', 147, NULL, NULL, 116776),
(116777, '3.30.450.20-FF-000165', NULL, 'Unplaced genomic scaffold supercont2.2, whole genome shotgun sequence', 127, NULL, NULL, 116777),
(116778, '4.10.1060.10-FF-000040', NULL, 'E3 SUMO-protein ligase RanBP2', 37, NULL, NULL, 116778),
(116779, '1.10.10.10-FF-001921', NULL, 'Transcriptional regulatory protein', 95, NULL, NULL, 116779),
(116780, '3.90.180.10-FF-000048', NULL, 'Protein YIM1', 144, NULL, NULL, 116780),
(116781, '3.30.70.260-FF-000121', NULL, 'Chorismate mutase/prephenate dehydrogenase', 77, NULL, NULL, 116781),
(116782, '3.40.50.11840-FF-000017', NULL, 'Uncharacterized protein', 74, NULL, NULL, 116782),
(116783, '1.10.10.650-FF-000002', NULL, 'Transcription elongation factor spt6', 173, NULL, NULL, 116783),
(116784, '3.40.50.11610-FF-000033', NULL, NULL, 156, NULL, NULL, 116784),
(116785, '1.10.510.10-FF-003276', NULL, NULL, 101, NULL, NULL, 116785),
(116786, '2.130.10.10-FF-005112', NULL, 'Uncharacterized protein', 244, NULL, NULL, 116786);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(116787, '3.90.190.10-FF-000521', NULL, 'Dual-specificity protein phosphatase 26', 115, NULL, NULL, 116787),
(116788, '3.30.1010.10-FF-000089', NULL, 'Phosphatidylinositol 4-kinase beta', 162, NULL, NULL, 116788),
(116789, '1.10.10.60-FF-001032', NULL, NULL, 57, NULL, NULL, 116789),
(116790, '3.30.70.1230-FF-000025', NULL, 'Adenylate cyclase 1', 198, NULL, NULL, 116790),
(116791, '3.30.450.20-FF-000108', NULL, 'Methyl-accepting chemotaxis protein signaling domain protein', 63, NULL, NULL, 116791),
(116792, '3.40.50.300-FF-008052', NULL, 'Dynein heavy chain 3', 127, NULL, NULL, 116792),
(116793, '3.40.50.2000-FF-000259', NULL, 'Glycosyl transferase', 138, NULL, NULL, 116793),
(116794, '2.130.10.10-FF-003931', NULL, 'Uncharacterized protein', 256, NULL, NULL, 116794),
(116795, '1.10.1520.10-FF-000055', NULL, 'Endoribonuclease Dicer homolog 2', 168, NULL, NULL, 116795),
(116796, '1.20.1270.60-FF-000323', NULL, 'Insulin receptor tyrosine kinase substrate, putative', 106, NULL, NULL, 116796),
(116797, '3.40.50.410-FF-000300', NULL, 'Integrin beta', 245, NULL, NULL, 116797),
(116798, '3.30.200.20-FF-001641', NULL, 'Uncharacterized protein', 89, NULL, NULL, 116798),
(116799, '2.60.40.10-FF-001918', NULL, 'Immunoglobulin light 1 constant 3', 107, NULL, NULL, 116799),
(116800, '3.80.10.10-FF-002318', NULL, 'AGAP012317-PA', 153, NULL, NULL, 116800),
(116801, '3.20.20.60-FF-000122', NULL, 'Uncharacterized protein', 233, NULL, NULL, 116801),
(116802, '1.10.238.210-FF-000007', NULL, 'Glutaminase 2a (liver, mitochondrial)', 80, NULL, NULL, 116802),
(116803, '1.10.3030.10-FF-000001', NULL, 'Gamete antigen 27/25', 186, NULL, NULL, 116803),
(116804, '2.130.10.10-FF-001043', NULL, 'WD repeat-containing protein', 183, NULL, NULL, 116804),
(116805, '3.40.50.300-FF-002004', NULL, 'ABC transporter I family member 1', 270, NULL, NULL, 116805),
(116806, '1.20.920.20-FF-000048', NULL, 'Si:dkey-11m19.5', 337, NULL, NULL, 116806),
(116807, '1.20.1270.10-FF-000095', NULL, 'Protein CBG18133', 91, NULL, NULL, 116807),
(116808, '3.20.20.70-FF-000125', NULL, 'Lipoyl synthase, mitochondrial', 228, NULL, NULL, 116808),
(116809, '1.10.8.60-FF-000210', NULL, 'Lon protease homolog, mitochondrial', 94, NULL, NULL, 116809),
(116810, '2.130.10.10-FF-003167', NULL, 'Periodic tryptophan protein 2-like protein', 227, NULL, NULL, 116810),
(116811, '1.10.8.10-FF-000066', NULL, 'Baculoviral IAP repeat containing 2', 49, NULL, NULL, 116811),
(116812, '1.25.40.10-FF-000794', NULL, 'NRDE-2, necessary for RNA interference, domain containing', 162, NULL, NULL, 116812),
(116813, '1.10.10.250-FF-000005', NULL, 'Mitochondrial 54S ribosomal protein YmL19', 80, NULL, NULL, 116813),
(116814, '2.60.40.10-FF-000986', NULL, 'Titin b', 97, NULL, NULL, 116814),
(116815, '3.40.50.2030-FF-000009', NULL, 'Carbon monoxide dehydrogenase, alpha subunit', 199, NULL, NULL, 116815),
(116816, '1.20.1250.20-FF-000097', NULL, 'protein spinster homolog 1', 428, NULL, NULL, 116816),
(116817, '3.40.50.300-FF-007501', NULL, 'ATP-dependent RNA helicase rok1', 222, NULL, NULL, 116817),
(116818, '3.40.50.300-FF-003701', NULL, 'Dynein heavy chain 14, axonemal', 60, NULL, NULL, 116818),
(116819, '1.20.920.10-FF-000045', NULL, 'protein polybromo-1', 125, NULL, NULL, 116819),
(116820, '1.10.287.370-FF-000087', NULL, 'KE2 family protein', 105, NULL, NULL, 116820),
(116821, '1.25.40.10-FF-002885', NULL, 'Predicted protein', 228, NULL, NULL, 116821),
(116822, '1.50.10.20-FF-000085', NULL, 'Cpras2, large protein with the cpRAS domain', 298, NULL, NULL, 116822),
(116823, '1.10.510.10-FF-003158', NULL, NULL, 173, NULL, NULL, 116823),
(116824, '3.30.160.60-FF-001099', NULL, 'zinc finger and BTB domain-containing protein 49', 28, NULL, NULL, 116824),
(116825, '3.30.710.10-FF-000261', NULL, 'Assembly of substrate-specific ubiquitin ligase complexes modulator, putative', 196, NULL, NULL, 116825),
(116826, '3.40.50.2300-FF-000877', NULL, NULL, 141, NULL, NULL, 116826),
(116827, '1.20.1250.20-FF-002159', NULL, 'Monocarboxylate transporter, putative', 193, NULL, NULL, 116827),
(116828, '2.60.40.10-FF-004729', NULL, NULL, 100, NULL, NULL, 116828);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(116829, '2.130.10.10-FF-005376', NULL, 'Uncharacterized protein', 161, NULL, NULL, 116829),
(116830, '3.40.1190.20-FF-000158', NULL, 'PfkB domain protein', 289, NULL, NULL, 116830),
(116831, '2.40.30.30-FF-000014', NULL, 'RNA-binding riboflavin kinase RibR', 138, NULL, NULL, 116831),
(116832, '3.30.2350.10-FF-000047', NULL, 'tRNA pseudouridine synthase B', 233, NULL, NULL, 116832),
(116833, '1.10.520.10-FF-000022', NULL, 'Peroxidase', 115, NULL, NULL, 116833),
(116834, '2.60.40.10-FF-005191', NULL, NULL, 92, NULL, NULL, 116834),
(116835, '2.30.36.70-FF-000006', NULL, 'Actin-related protein 6', 31, NULL, NULL, 116835),
(116836, '2.130.10.10-FF-004387', NULL, 'Uncharacterized protein', 68, NULL, NULL, 116836),
(116837, '3.30.1490.180-FF-000032', NULL, 'Uncharacterized protein', 52, NULL, NULL, 116837),
(116838, '3.40.50.1110-FF-000155', NULL, 'Uncharacterized protein', 310, NULL, NULL, 116838),
(116839, '2.60.40.10-FF-002054', NULL, 'Secreted and transmembrane protein 1', 101, NULL, NULL, 116839),
(116840, '3.40.50.1100-FF-000152', NULL, 'Putative 1-aminocyclopropane-1-carboxylate deaminase', 105, NULL, NULL, 116840),
(116841, '3.40.630.30-FF-000303', NULL, 'O-GlcNAcase', 123, NULL, NULL, 116841),
(116842, '3.30.420.10-FF-000334', NULL, 'DNA polymerase zeta catalytic subunit, putative', 174, NULL, NULL, 116842),
(116843, '3.40.50.150-FF-001161', NULL, NULL, 187, NULL, NULL, 116843),
(116844, '3.40.50.410-FF-000036', NULL, 'Integrin beta', 246, NULL, NULL, 116844),
(116845, '1.50.40.10-FF-000230', NULL, 'GM18585', 294, NULL, NULL, 116845),
(116846, '3.60.21.10-FF-000496', NULL, 'Serine/threonine-protein phosphatase', 367, NULL, NULL, 116846),
(116847, '3.30.70.330-FF-000962', NULL, 'RBMX2 ortholog', 110, NULL, NULL, 116847),
(116848, '1.10.10.580-FF-000020', NULL, 'Uncharacterized protein', 77, NULL, NULL, 116848),
(116849, '3.40.50.2020-FF-000006', NULL, 'Hypoxanthine phosphoribosyltransferase', 178, NULL, NULL, 116849),
(116850, '3.40.50.720-FF-000511', NULL, 'oxidoreductase HTATIP2 isoform X2', 102, NULL, NULL, 116850),
(116851, '2.60.40.10-FF-000929', NULL, 'Roundabout guidance receptor 4', 117, NULL, NULL, 116851),
(116852, '3.20.20.330-FF-000016', NULL, 'Putative uncharacterized protein YMR321C', 98, NULL, NULL, 116852),
(116853, '1.20.1740.10-FF-000114', NULL, 'Solute carrier family 12 member 1', 161, NULL, NULL, 116853),
(116854, '3.30.200.20-FF-001169', NULL, 'Non-specific serine/threonine protein kinase', 118, NULL, NULL, 116854),
(116855, '2.130.10.10-FF-001514', NULL, 'U3 small nucleolar RNA-associated protein 13', 191, NULL, NULL, 116855),
(116856, '3.60.20.10-FF-000241', NULL, NULL, 73, NULL, NULL, 116856),
(116857, '3.40.33.10-FF-000029', NULL, 'Predicted protein', 175, NULL, NULL, 116857),
(116858, '1.20.1560.10-FF-000257', NULL, 'ABC transporter ABCC.6, putative', 313, NULL, NULL, 116858),
(116859, '2.130.10.10-FF-002032', NULL, 'Protein HIRA', 146, NULL, NULL, 116859),
(116860, '2.10.50.10-FF-000073', NULL, 'TNF receptor superfamily member 9', 88, NULL, NULL, 116860),
(116861, '1.20.1070.10-FF-000793', NULL, 'Uncharacterized protein', 249, NULL, NULL, 116861),
(116862, '1.10.1200.10-FF-000008', NULL, 'Acyl carrier protein', 91, NULL, NULL, 116862),
(116863, '2.60.120.200-FF-000390', NULL, 'Glycosidase', 259, NULL, NULL, 116863),
(116864, '1.10.8.10-FF-000009', NULL, 'Putative E3 ubiquitin-protein ligase UBR5', 53, NULL, NULL, 116864),
(116865, '3.40.50.1760-FF-000029', NULL, NULL, 41, NULL, NULL, 116865),
(116866, '3.40.1340.10-FF-000010', NULL, 'Uncharacterized protein', 141, NULL, NULL, 116866),
(116867, '3.80.10.10-FF-002375', NULL, 'Uncharacterized protein', 165, NULL, NULL, 116867),
(116868, '3.40.50.300-FF-001077', NULL, 'Uncharacterized protein, isoform A', 233, NULL, NULL, 116868),
(116869, '3.30.70.330-FF-002553', NULL, NULL, 195, NULL, NULL, 116869),
(116870, '3.40.50.10140-FF-000058', NULL, 'Putative serine/threonine-protein kinase pats1', 113, NULL, NULL, 116870),
(116871, '1.10.1580.10-FF-000031', NULL, 'Mitochondrial GTPase 1', 86, NULL, NULL, 116871),
(116872, '2.60.120.260-FF-000357', NULL, 'Uncharacterized protein', 92, NULL, NULL, 116872);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(116873, '3.30.160.60-FF-004212', NULL, NULL, 35, NULL, NULL, 116873),
(116874, '1.10.442.10-FF-000003', NULL, 'Cytochrome c oxidase subunit 4 isoform 1, mitochondrial', 105, NULL, NULL, 116874),
(116875, '3.50.50.60-FF-001101', NULL, 'Protoporphyrinogen oxidase', 241, NULL, NULL, 116875),
(116876, '3.20.20.80-FF-000185', NULL, '1,4-beta-xylanase', 294, NULL, NULL, 116876),
(116877, '1.10.1740.240-FF-000001', NULL, 'Endolysin', 105, NULL, NULL, 116877),
(116878, '3.30.450.200-FF-000003', NULL, 'DENN domain containing 1A', 142, NULL, NULL, 116878),
(116879, '2.40.30.20-FF-000011', NULL, 'Riboflavin synthase alpha subunit', 96, NULL, NULL, 116879),
(116880, '3.30.1640.30-FF-000013', NULL, NULL, 66, NULL, NULL, 116880),
(116881, '3.30.200.20-FF-001170', NULL, 'Protein kinase domain containing protein', 95, NULL, NULL, 116881),
(116882, '2.60.40.1670-FF-000032', NULL, NULL, 144, NULL, NULL, 116882),
(116883, '1.10.238.10-FF-000332', NULL, 'Myosin A tail domain interacting protein', 65, NULL, NULL, 116883),
(116884, '3.80.10.10-FF-000992', NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', 189, NULL, NULL, 116884),
(116885, '1.10.1040.50-FF-000024', NULL, NULL, 106, NULL, NULL, 116885),
(116886, '3.40.50.2300-FF-001041', NULL, NULL, 148, NULL, NULL, 116886),
(116887, '2.10.50.10-FF-000016', NULL, 'Tumor necrosis factor receptor superfamily member 10B', 30, NULL, NULL, 116887),
(116888, '2.60.40.10-FF-005718', NULL, NULL, 37, NULL, NULL, 116888),
(116889, '1.10.510.10-FF-001567', NULL, 'Uncharacterized protein', 223, NULL, NULL, 116889),
(116890, '4.10.240.10-FF-000129', NULL, 'C6 finger transcription factor fumR', 67, NULL, NULL, 116890),
(116891, '3.30.160.60-FF-003285', NULL, 'Zinc finger protein 793', 37, NULL, NULL, 116891),
(116892, '3.20.20.80-FF-000128', NULL, 'Endo-1,6-beta-D-glucanase neg1', 342, NULL, NULL, 116892),
(116893, '1.10.10.10-FF-001450', NULL, 'Vacuolar-sorting protein SNF8', 81, NULL, NULL, 116893),
(116894, '1.10.238.10-FF-001226', NULL, 'Uncharacterized protein', 112, NULL, NULL, 116894),
(116895, '1.25.40.70-FF-000025', NULL, 'Phosphatidylinositol 3-kinase, putative', 208, NULL, NULL, 116895),
(116896, '2.130.10.10-FF-004948', NULL, 'Uncharacterized protein', 98, NULL, NULL, 116896),
(116897, '3.30.160.60-FF-003605', NULL, 'Early growth response 3', 26, NULL, NULL, 116897),
(116898, '1.25.10.10-FF-003254', NULL, 'ARMADILLO BTB ARABIDOPSIS PROTEIN 1', 223, NULL, NULL, 116898),
(116899, '3.80.10.10-FF-000284', NULL, 'extracellular matrix protein 2 isoform X1', 71, NULL, NULL, 116899),
(116900, '1.20.58.1250-FF-000005', NULL, 'Uncharacterized protein, isoform A', 114, NULL, NULL, 116900),
(116901, '3.20.20.70-FF-000182', NULL, 'Glycerol uptake operon antiterminator regulatory protein', 185, NULL, NULL, 116901),
(116902, '2.40.50.140-FF-000588', NULL, 'Single-stranded DNA binding protein Ssb', 119, NULL, NULL, 116902),
(116903, '1.10.8.70-FF-000005', NULL, 'Glutamate--tRNA ligase', 53, NULL, NULL, 116903),
(116904, '2.60.40.1730-FF-000073', NULL, NULL, 182, NULL, NULL, 116904),
(116905, '1.20.1250.10-FF-000094', NULL, NULL, 174, NULL, NULL, 116905),
(116906, '1.25.40.20-FF-000797', NULL, 'Ankyrin repeat-containing protein NPR4', 211, NULL, NULL, 116906),
(116907, '1.10.10.10-FF-001657', NULL, 'Helix-turn-helix transcriptional regulator, putative', 72, NULL, NULL, 116907),
(116908, '3.40.50.1220-FF-000042', NULL, 'Alpha-keto-acid decarboxylase', 154, NULL, NULL, 116908),
(116909, '4.10.280.10-FF-000194', NULL, 'Max-like protein X', 90, NULL, NULL, 116909),
(116910, '1.10.8.60-FF-000002', NULL, 'ATP-dependent Clp protease ATP-binding subunit ClpX', 101, NULL, NULL, 116910),
(116911, '1.25.40.120-FF-000103', NULL, 'Uncharacterized protein', 80, NULL, NULL, 116911),
(116912, '1.20.1250.20-FF-001996', NULL, 'Uncharacterized protein', 382, NULL, NULL, 116912),
(116913, '1.10.2000.10-FF-000027', NULL, 'Transmembrane receptor', 127, NULL, NULL, 116913),
(116914, '1.10.8.60-FF-000474', NULL, 'Uncharacterized protein', 110, NULL, NULL, 116914),
(116915, '1.50.10.10-FF-000048', NULL, 'Unsaturated chondroitin disaccharide hydrolase', 418, NULL, NULL, 116915);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(116916, '1.20.1270.60-FF-000205', NULL, 'Protein kinase C and casein kinase substrate in neurons protein 1', 291, NULL, NULL, 116916),
(116917, '3.90.1200.10-FF-000005', NULL, 'Choline kinase alpha', 266, NULL, NULL, 116917),
(116918, '3.80.10.10-FF-000520', NULL, 'Leucine rich repeat containing 15', 147, NULL, NULL, 116918),
(116919, '3.40.50.1460-FF-000063', NULL, 'Vacuolar processing enzyme', 297, NULL, NULL, 116919),
(116920, '3.40.47.10-FF-000264', NULL, NULL, 195, NULL, NULL, 116920),
(116921, '1.20.5.110-FF-000222', NULL, 'Synaptobrevin 9-2', 102, NULL, NULL, 116921),
(116922, '3.40.50.150-FF-000441', NULL, 'FkbM family methyltransferase', 177, NULL, NULL, 116922),
(116923, '3.30.160.60-FF-004420', NULL, NULL, 29, NULL, NULL, 116923),
(116924, '3.30.70.330-FF-001125', NULL, 'Flowering time control protein FPA isoform A', 107, NULL, NULL, 116924),
(116925, '2.130.10.10-FF-005522', NULL, 'Uncharacterized protein', 53, NULL, NULL, 116925),
(116926, '2.60.40.10-FF-004937', NULL, NULL, 70, NULL, NULL, 116926),
(116927, '3.30.160.60-FF-005230', NULL, NULL, 60, NULL, NULL, 116927),
(116928, '3.40.50.300-FF-004775', NULL, 'Interferon gamma-inducible protein 47', 89, NULL, NULL, 116928),
(116929, '3.40.50.300-FF-007237', NULL, 'Gtr1/RagA G protein conserved region containing protein', 161, NULL, NULL, 116929),
(116930, '3.60.10.10-FF-000004', NULL, 'Type II inositol 1,4,5-trisphosphate 5-phosphatase', 348, NULL, NULL, 116930),
(116931, '1.20.1290.10-FF-000006', NULL, 'Carboxymuconolactone decarboxylase', 209, NULL, NULL, 116931),
(116932, '2.30.30.140-FF-000160', NULL, 'Maternal protein tudor', 85, NULL, NULL, 116932),
(116933, '1.20.5.170-FF-000133', NULL, 'Uncharacterized protein', 53, NULL, NULL, 116933),
(116934, '3.30.1370.10-FF-000172', NULL, 'Uncharacterized protein', 82, NULL, NULL, 116934),
(116935, '3.90.650.10-FF-000006', NULL, 'Phosphoribosylformylglycinamidine synthase, putative', 179, NULL, NULL, 116935),
(116936, '1.10.472.80-FF-000245', NULL, NULL, 127, NULL, NULL, 116936),
(116937, '3.30.40.10-FF-002284', NULL, 'Protein CBG09969', 45, NULL, NULL, 116937),
(116938, '1.25.40.10-FF-005257', NULL, 'Uncharacterized protein', 160, NULL, NULL, 116938),
(116939, '1.20.1560.10-FF-000757', NULL, 'Uncharacterized protein', 36, NULL, NULL, 116939),
(116940, '2.130.10.10-FF-003667', NULL, 'Uncharacterized protein', 191, NULL, NULL, 116940),
(116941, '2.10.25.10-FF-001369', NULL, 'Laminin, gamma 2', 55, NULL, NULL, 116941),
(116942, '1.25.10.10-FF-001629', NULL, 'Uncharacterized protein', 486, NULL, NULL, 116942),
(116943, '1.10.287.3240-FF-000011', NULL, 'V-type proton ATPase subunit D', 211, NULL, NULL, 116943),
(116944, '2.60.120.330-FF-000226', NULL, 'Putative 2-oxoacid dependent dioxygenase', 174, NULL, NULL, 116944),
(116945, '3.30.450.20-FF-000518', NULL, 'Histidine kinase', 73, NULL, NULL, 116945),
(116946, '3.40.850.10-FF-000128', NULL, 'Dachs, isoform E', 53, NULL, NULL, 116946),
(116947, '3.40.50.720-FF-001146', NULL, 'Pantotheic acid-3 protein', 194, NULL, NULL, 116947),
(116948, '3.30.720.90-FF-000004', NULL, 'Probable 60S ribosomal protein L38', 79, NULL, NULL, 116948),
(116949, '3.90.70.10-FF-000765', NULL, 'Ubiquitin-specific peptidase 2a', 85, NULL, NULL, 116949),
(116950, '3.50.50.60-FF-001511', NULL, 'D-amino acid dehydrogenase, small chain', 144, NULL, NULL, 116950),
(116951, '3.80.10.10-FF-000166', NULL, 'Dynein assembly factor 1, axonemal', 101, NULL, NULL, 116951),
(116952, '3.30.40.10-FF-001002', NULL, 'Zinc finger domain-containing protein', 70, NULL, NULL, 116952),
(116953, '3.80.10.10-FF-004320', NULL, 'Uncharacterized protein', 206, NULL, NULL, 116953),
(116954, '3.40.1280.10-FF-000128', NULL, 'Uncharacterized protein', 178, NULL, NULL, 116954),
(116955, '2.30.42.10-FF-000188', NULL, 'PDZ domain containing 2', 142, NULL, NULL, 116955),
(116956, '1.10.3720.10-FF-000239', NULL, 'Glycine betaine/proline ABC transporter, permease protein', 195, NULL, NULL, 116956),
(116957, '3.40.50.12780-FF-000237', NULL, 'Mutant e4 ebony', 92, NULL, NULL, 116957),
(116958, '3.40.720.10-FF-000181', NULL, 'Uncharacterized protein', 92, NULL, NULL, 116958);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(116959, '3.50.50.60-FF-001308', NULL, 'Glutathione reductase', 210, NULL, NULL, 116959),
(116960, '3.40.50.300-FF-003139', NULL, 'NACHT, LRR and PYD domains-containing protein 12 isoform X1', 223, NULL, NULL, 116960),
(116961, '1.25.40.570-FF-000007', NULL, '26S proteasome non-ATPase regulatory subunit 11', 376, NULL, NULL, 116961),
(116962, '2.40.128.20-FF-000018', NULL, 'Glial lazarillo, isoform A', 173, NULL, NULL, 116962),
(116963, '3.40.50.300-FF-000413', NULL, 'Translocase of chloroplast 120, chloroplastic', 248, NULL, NULL, 116963),
(116964, '2.30.29.210-FF-000004', NULL, 'Transcription factor-like protein', 118, NULL, NULL, 116964),
(116965, '1.10.510.10-FF-001067', NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 75', 91, NULL, NULL, 116965),
(116966, '1.10.10.10-FF-001242', NULL, 'HSF33, heat shock transcription factor DNA-binding domain-containing protein, DNA binding, transcription factor', 102, NULL, NULL, 116966),
(116967, '2.170.260.10-FF-000005', NULL, 'Endoribonuclease Dicer 1', 119, NULL, NULL, 116967),
(116968, '3.40.50.300-FF-007708', NULL, 'Uncharacterized protein', 98, NULL, NULL, 116968),
(116969, '3.10.420.10-FF-000001', NULL, 'Protein-export chaperone SecB', 155, NULL, NULL, 116969),
(116970, '3.30.1120.30-FF-000018', NULL, 'PLK/PLK1 protein kinase', 102, NULL, NULL, 116970),
(116971, '3.30.70.330-FF-002519', NULL, NULL, 61, NULL, NULL, 116971),
(116972, '3.20.20.80-FF-000780', NULL, 'Predicted protein', 224, NULL, NULL, 116972),
(116973, '1.10.510.10-FF-003219', NULL, NULL, 136, NULL, NULL, 116973),
(116974, '1.10.10.60-FF-001150', NULL, NULL, 54, NULL, NULL, 116974),
(116975, '1.10.1410.40-FF-000005', NULL, 'MB21D2 isoform 1', 138, NULL, NULL, 116975),
(116976, '2.30.29.30-FF-001130', NULL, 'Uncharacterized protein', 122, NULL, NULL, 116976),
(116977, '1.10.510.10-FF-003422', NULL, NULL, 291, NULL, NULL, 116977),
(116978, '3.40.50.11990-FF-000012', NULL, NULL, 172, NULL, NULL, 116978),
(116979, '2.60.120.200-FF-000446', NULL, 'Uncharacterized protein', 184, NULL, NULL, 116979),
(116980, '2.30.29.220-FF-000007', NULL, 'FACT complex subunit POB3', 95, NULL, NULL, 116980),
(116981, '2.130.10.10-FF-001722', NULL, 'Phosphoinositide 3-kinase regulatory subunit 4', 66, NULL, NULL, 116981),
(116982, '1.25.10.10-FF-002439', NULL, 'Uncharacterized protein', 237, NULL, NULL, 116982),
(116983, '2.30.29.30-FF-001220', NULL, 'Uncharacterized protein', 93, NULL, NULL, 116983),
(116984, '1.10.286.20-FF-000002', NULL, 'Regulator of nucleoside diphosphate kinase', 44, NULL, NULL, 116984),
(116985, '3.30.200.110-FF-000016', NULL, NULL, 44, NULL, NULL, 116985),
(116986, '1.20.1280.50-FF-000028', NULL, 'Transport inhibitor response 1-like protein', 46, NULL, NULL, 116986),
(116987, '2.160.20.10-FF-000339', NULL, 'Cell surface protein', 291, NULL, NULL, 116987),
(116988, '1.25.40.10-FF-004594', NULL, 'Uncharacterized Sel1-like repeat-containing protein C1B3.10c', 170, NULL, NULL, 116988),
(116989, '2.60.40.10-FF-003543', NULL, NULL, 112, NULL, NULL, 116989),
(116990, '1.10.3860.10-FF-000013', NULL, 'Amino acid transporter', 426, NULL, NULL, 116990),
(116991, '2.60.40.1390-FF-000015', NULL, 'YALI0B14773p', 274, NULL, NULL, 116991),
(116992, '1.25.40.10-FF-001811', NULL, 'Putative pentatricopeptide repeat-containing protein At1g64310', 121, NULL, NULL, 116992),
(116993, '3.40.50.150-FF-001722', NULL, NULL, 178, NULL, NULL, 116993),
(116994, '3.40.1110.10-FF-000173', NULL, 'Phospholipid-transporting ATPase', 261, NULL, NULL, 116994),
(116995, '3.30.200.20-FF-000860', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 129, NULL, NULL, 116995),
(116996, '2.30.29.30-FF-000556', NULL, 'Serine/threonine-protein kinase dkf-1', 130, NULL, NULL, 116996),
(116997, '1.20.1070.10-FF-000293', NULL, '2-oxoglutarate receptor 1', 305, NULL, NULL, 116997),
(116998, '3.40.30.10-FF-000107', NULL, 'Protein disulfide-isomerase 5-2', 117, NULL, NULL, 116998),
(116999, '1.25.10.10-FF-001214', NULL, 'Phosphoinositide-3-kinase, regulatory subunit 4', 191, NULL, NULL, 116999);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(117000, '1.20.90.10-FF-000004', NULL, 'Group XIIA secretory phospholipase A2', 98, NULL, NULL, 117000),
(117001, '1.20.1250.20-FF-000714', NULL, 'Unplaced genomic scaffold supercont2.2, whole genome shotgun sequence', 477, NULL, NULL, 117001),
(117002, '2.30.30.140-FF-000013', NULL, 'Histone acetyltransferase', 82, NULL, NULL, 117002),
(117003, '3.60.20.10-FF-000033', NULL, 'Proteasome subunit beta', 213, NULL, NULL, 117003),
(117004, '3.10.20.90-FF-000070', NULL, 'E3 ubiquitin-protein ligase RBBP6 isoform X2', 81, NULL, NULL, 117004),
(117005, '1.25.40.20-FF-001814', NULL, 'Uncharacterized protein', 160, NULL, NULL, 117005),
(117006, '3.40.50.300-FF-002212', NULL, 'AAA family ATPase, putative', 161, NULL, NULL, 117006),
(117007, '3.40.1110.10-FF-000116', NULL, 'Sodium/potassium-transporting ATPase subunit alpha', 206, NULL, NULL, 117007),
(117008, '1.10.238.10-FF-001260', NULL, 'Uncharacterized protein', 60, NULL, NULL, 117008),
(117009, '2.60.120.10-FF-000561', NULL, 'cAMP-dependent protein kinase type II-alpha regulatory subunit', 149, NULL, NULL, 117009),
(117010, '3.80.10.10-FF-003510', NULL, 'ELRR (Extracellular Leucine-Rich Repeat) ONly', 181, NULL, NULL, 117010),
(117011, '1.20.1160.20-FF-000005', NULL, 'Grid2 interacting protein', 75, NULL, NULL, 117011),
(117012, '1.25.40.560-FF-000004', NULL, 'Zn-finger (Ran-binding)-3 isoform X1', 92, NULL, NULL, 117012),
(117013, '2.130.10.10-FF-005612', NULL, 'Uncharacterized protein', 187, NULL, NULL, 117013),
(117014, '2.60.40.60-FF-000894', NULL, 'Uncharacterized protein', 110, NULL, NULL, 117014),
(117015, '3.40.50.300-FF-001548', NULL, 'ABC efflux transporter ATP-binding protein', 233, NULL, NULL, 117015),
(117016, '2.130.10.10-FF-001161', NULL, 'Peroxisomal targeting signal 2 receptor, putative', 317, NULL, NULL, 117016),
(117017, '1.20.120.1080-FF-000120', NULL, 'Predicted protein', 101, NULL, NULL, 117017),
(117018, '1.10.238.200-FF-000004', NULL, 'Defective in cullin neddylation protein', 106, NULL, NULL, 117018),
(117019, '3.40.50.720-FF-002574', NULL, 'Uncharacterized protein', 33, NULL, NULL, 117019),
(117020, '3.90.550.10-FF-000768', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 266, NULL, NULL, 117020),
(117021, '3.40.50.300-FF-007147', NULL, 'Adenylyl-sulfate kinase', 176, NULL, NULL, 117021),
(117022, '3.30.160.20-FF-000154', NULL, 'Predicted protein', 73, NULL, NULL, 117022),
(117023, '1.25.40.10-FF-001250', NULL, 'Mitochondrial fission 1 protein', 142, NULL, NULL, 117023),
(117024, '2.20.100.10-FF-000232', NULL, 'F-spondin', 52, NULL, NULL, 117024),
(117025, '2.40.50.140-FF-000824', NULL, NULL, 106, NULL, NULL, 117025),
(117026, '3.60.10.10-FF-000268', NULL, 'DNA-(apurinic or apyrimidinic site) lyase', 95, NULL, NULL, 117026),
(117027, '1.20.1250.20-FF-000804', NULL, 'MFS family major facilitator transporter', 186, NULL, NULL, 117027),
(117028, '1.10.287.820-FF-000003', NULL, 'Blast:Sodium channel protein Nach', 81, NULL, NULL, 117028),
(117029, '1.10.3730.20-FF-000012', NULL, 'DUF803 domain-containing protein', 118, NULL, NULL, 117029),
(117030, '1.20.5.110-FF-000076', NULL, 'SNARE protein, putative', 85, NULL, NULL, 117030),
(117031, '3.40.50.300-FF-001902', NULL, 'ATP dependent DEAD-box helicase, putative', 67, NULL, NULL, 117031),
(117032, '2.60.40.60-FF-001147', NULL, 'Predicted protein', 97, NULL, NULL, 117032),
(117033, '1.20.120.1530-FF-000007', NULL, 'Two-component osmosensing histidine kinase', 143, NULL, NULL, 117033),
(117034, '1.10.8.480-FF-000020', NULL, 'Dimethyladenosine transferase', 98, NULL, NULL, 117034),
(117035, '3.20.20.80-FF-000538', NULL, 'Chitinase, putative', 89, NULL, NULL, 117035),
(117036, '3.40.50.1820-FF-000744', NULL, 'Uncharacterized protein', 63, NULL, NULL, 117036),
(117037, '3.30.9.10-FF-000221', NULL, 'Uncharacterized protein', 36, NULL, NULL, 117037),
(117038, '3.40.1110.10-FF-000263', NULL, NULL, 110, NULL, NULL, 117038),
(117039, '3.30.260.10-FF-000068', NULL, NULL, 90, NULL, NULL, 117039),
(117040, '1.10.8.10-FF-000302', NULL, 'Ubiquitin-conjugating enzyme E2Ka (UBC1 homolog, yeast)', 19, NULL, NULL, 117040);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(117041, '3.80.10.10-FF-004174', NULL, 'Uncharacterized protein', 274, NULL, NULL, 117041),
(117042, '3.40.50.20-FF-000061', NULL, 'Ribosomal protein S6 glutaminyl transferase', 113, NULL, NULL, 117042),
(117043, '3.30.160.60-FF-001806', NULL, NULL, 29, NULL, NULL, 117043),
(117044, '3.30.200.20-FF-001523', NULL, 'Ribosomal protein S6 kinase', 60, NULL, NULL, 117044),
(117045, '1.20.1260.10-FF-000066', NULL, 'Ferritin', 101, NULL, NULL, 117045),
(117046, '3.30.420.40-FF-000995', NULL, 'Uncharacterized protein', 83, NULL, NULL, 117046),
(117047, '3.40.630.10-FF-000409', NULL, 'Peptidase M20 domain containing 2', 126, NULL, NULL, 117047),
(117048, '2.20.110.10-FF-000058', NULL, NULL, 53, NULL, NULL, 117048),
(117049, '3.40.430.10-FF-000023', NULL, 'Putative dihydrofolate reductase', 186, NULL, NULL, 117049),
(117050, '3.90.980.20-FF-000028', NULL, NULL, 96, NULL, NULL, 117050),
(117051, '2.30.42.10-FF-000334', NULL, 'Mitochondrial scaffolding protein 1', 107, NULL, NULL, 117051),
(117052, '1.10.10.10-FF-001803', NULL, 'Uncharacterized protein', 38, NULL, NULL, 117052),
(117053, '3.40.190.10-FF-000690', NULL, 'Polar amino acid uptake family ABC transporter, periplasmic substrate-binding protein', 100, NULL, NULL, 117053),
(117054, '3.90.850.10-FF-000021', NULL, '2-keto-4-pentenoate hydratase', 191, NULL, NULL, 117054),
(117055, '3.30.40.10-FF-002227', NULL, 'PDZ domain containing ring finger 4', 66, NULL, NULL, 117055),
(117056, '3.20.20.70-FF-000535', NULL, NULL, 240, NULL, NULL, 117056),
(117057, '2.130.10.10-FF-000233', NULL, 'Kinesin family member 21A', 226, NULL, NULL, 117057),
(117058, '2.120.10.30-FF-000498', NULL, 'Uncharacterized protein', 228, NULL, NULL, 117058),
(117059, '3.30.420.40-FF-000938', NULL, 'Predicted protein', 74, NULL, NULL, 117059),
(117060, '3.40.50.300-FF-006927', NULL, 'ATP-binding cassette transporter, subfamily G, member 42, group PDR-like protein PpABCG42', 232, NULL, NULL, 117060),
(117061, '3.30.559.10-FF-000127', NULL, 'Amino acid adenylation', 193, NULL, NULL, 117061),
(117062, '1.10.10.10-FF-000786', NULL, 'Ribosomal protein', 50, NULL, NULL, 117062),
(117063, '1.25.40.10-FF-001457', NULL, 'Os06g0114366 protein', 120, NULL, NULL, 117063),
(117064, '2.10.270.10-FF-000004', NULL, 'Toxin B', 96, NULL, NULL, 117064),
(117065, '1.20.140.10-FF-000070', NULL, 'Acyl-CoA dehydrogenase FadE22', 147, NULL, NULL, 117065),
(117066, '3.90.520.10-FF-000002', NULL, 'Mothers against decapentaplegic homolog', 142, NULL, NULL, 117066),
(117067, '3.30.200.20-FF-002097', NULL, 'Mitogen-activated protein kinase', 80, NULL, NULL, 117067),
(117068, '1.10.150.50-FF-000174', NULL, 'Ephrin receptor', 75, NULL, NULL, 117068),
(117069, '2.60.40.10-FF-001503', NULL, 'Immunoglobulin superfamily member 5', 95, NULL, NULL, 117069),
(117070, '3.90.190.10-FF-000285', NULL, 'DUSP11 isoform 5', 144, NULL, NULL, 117070),
(117071, '1.20.5.2700-FF-000002', NULL, 'NADH-ubiquinone oxidoreductase chain 5', 78, NULL, NULL, 117071),
(117072, '3.40.50.300-FF-001341', NULL, 'NLR family pyrin domain containing 7', 199, NULL, NULL, 117072),
(117073, '3.90.1740.10-FF-000006', NULL, 'Uncharacterized protein', 219, NULL, NULL, 117073),
(117074, '1.20.58.240-FF-000002', NULL, 'Bifunctional protein NCOAT', 199, NULL, NULL, 117074),
(117075, '1.10.555.10-FF-000254', NULL, NULL, 125, NULL, NULL, 117075),
(117076, '3.20.10.10-FF-000034', NULL, '4-amino-4-deoxychorismate lyase', 169, NULL, NULL, 117076),
(117077, '1.20.120.790-FF-000020', NULL, 'Chaperone protein HtpG', 129, NULL, NULL, 117077),
(117078, '2.10.70.10-FF-000282', NULL, 'Uncharacterized protein', 60, NULL, NULL, 117078),
(117079, '3.40.50.720-FF-000983', NULL, 'Short-chain dehydrogenase/reductase family protein', 256, NULL, NULL, 117079),
(117080, '2.60.40.420-FF-000177', NULL, 'Copper-containing nitrite reductase', 144, NULL, NULL, 117080),
(117081, '3.20.20.140-FF-000403', NULL, 'Alkylphosphonate utilization protein PhnM, putative', 118, NULL, NULL, 117081),
(117082, '1.10.630.10-FF-000317', NULL, 'Uncharacterized protein', 158, NULL, NULL, 117082);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(117083, '3.40.50.720-FF-002427', NULL, 'Myo-inositol-1-phosphate synthase', 63, NULL, NULL, 117083),
(117084, '3.30.70.330-FF-001182', NULL, 'RNA recognition motif domain containing protein', 90, NULL, NULL, 117084),
(117085, '3.30.40.10-FF-000693', NULL, 'Uncharacterized protein, isoform A', 58, NULL, NULL, 117085),
(117086, '2.120.10.30-FF-000588', NULL, 'Protein STRICTOSIDINE SYNTHASE-LIKE 2', 279, NULL, NULL, 117086),
(117087, '2.40.50.140-FF-000734', NULL, NULL, 129, NULL, NULL, 117087),
(117088, '1.20.1070.10-FF-000383', NULL, 'Uncharacterized protein', 322, NULL, NULL, 117088),
(117089, '3.40.50.10810-FF-000130', NULL, 'WGS project CABT00000000 data, contig 2.20', 255, NULL, NULL, 117089),
(117090, '1.20.5.1300-FF-000009', NULL, 'Histidinol dehydrogenase', 54, NULL, NULL, 117090),
(117091, '3.40.50.1820-FF-000834', NULL, 'Predicted protein', 149, NULL, NULL, 117091),
(117092, '3.30.420.40-FF-000848', NULL, 'Chaperone protein-like protein', 16, NULL, NULL, 117092),
(117093, '2.130.10.10-FF-003460', NULL, 'Histidine kinase/response regulator hybrid protein', 93, NULL, NULL, 117093),
(117094, '3.30.160.60-FF-006011', NULL, NULL, 34, NULL, NULL, 117094),
(117095, '1.10.230.10-FF-000011', NULL, 'Citrate synthase-like protein, putative', 57, NULL, NULL, 117095),
(117096, '1.20.1070.10-FF-001310', NULL, 'Uncharacterized protein', 126, NULL, NULL, 117096),
(117097, '1.20.1600.10-FF-000020', NULL, 'Outer membrane protein TolC', 412, NULL, NULL, 117097),
(117098, '1.10.1040.10-FF-000119', NULL, 'Uncharacterized protein', 101, NULL, NULL, 117098),
(117099, '3.10.20.620-FF-000004', NULL, 'Autophagy protein 5', 129, NULL, NULL, 117099),
(117100, '1.10.287.1060-FF-000008', NULL, 'ESAT-6-like protein', 97, NULL, NULL, 117100),
(117101, '2.30.30.190-FF-000011', NULL, 'CAP-Gly domain-containing linker protein 3', 79, NULL, NULL, 117101),
(117102, '1.20.930.10-FF-000017', NULL, 'Transcription elongation factor S-II', 89, NULL, NULL, 117102),
(117103, '2.60.120.590-FF-000017', NULL, 'RNA demethylase ALKBH9B', 220, NULL, NULL, 117103),
(117104, '3.30.160.20-FF-000007', NULL, 'Double-stranded RNA-binding protein Staufen homolog 1', 78, NULL, NULL, 117104),
(117105, '2.30.29.30-FF-000910', NULL, 'Phosphoinositide phospholipase C', 129, NULL, NULL, 117105),
(117106, '3.40.190.10-FF-000780', NULL, 'Extracellular solute-binding protein family 5', 269, NULL, NULL, 117106),
(117107, '3.40.50.1370-FF-000036', NULL, 'Putative aspartate carbamoyltransferase', 134, NULL, NULL, 117107),
(117108, '3.40.50.1360-FF-000033', NULL, '6-phosphogluconolactonase', 225, NULL, NULL, 117108),
(117109, '1.20.5.110-FF-000340', NULL, 'Uncharacterized protein', 87, NULL, NULL, 117109),
(117110, '3.30.300.180-FF-000015', NULL, 'Chromosomal replication initiator protein DnaA 2', 105, NULL, NULL, 117110),
(117111, '3.30.160.60-FF-001071', NULL, 'zinc finger protein 236', 36, NULL, NULL, 117111),
(117112, '3.40.20.10-FF-000112', NULL, 'BnaC03g35080D protein', 129, NULL, NULL, 117112),
(117113, '3.30.160.60-FF-003195', NULL, 'Zinc finger protein 789', 27, NULL, NULL, 117113),
(117114, '1.25.40.10-FF-000878', NULL, 'Pentatricopeptide repeat-containing protein', 208, NULL, NULL, 117114),
(117115, '3.30.950.10-FF-000008', NULL, 'Related to MET1-siroheme synthase', 143, NULL, NULL, 117115),
(117116, '3.30.70.330-FF-001007', NULL, 'Homologous to Drosophila SQD (Squid) protein', 116, NULL, NULL, 117116),
(117117, '3.40.50.2000-FF-001012', NULL, 'Alpha-1,4 glucan phosphorylase', 188, NULL, NULL, 117117),
(117118, '4.10.240.10-FF-000130', NULL, 'Transcriptional regulatory protein, putative', 68, NULL, NULL, 117118),
(117119, '3.40.50.150-FF-000025', NULL, 'N-terminal Xaa-Pro-Lys N-methyltransferase 1', 222, NULL, NULL, 117119),
(117120, '3.30.930.10-FF-000390', NULL, 'Phenylalanyl-tRNA synthetase alpha chain', 181, NULL, NULL, 117120),
(117121, '3.40.50.10330-FF-000025', NULL, 'NAD+ kinase Utr1', 170, NULL, NULL, 117121),
(117122, '2.60.40.10-FF-003190', NULL, 'Glycoside hydrolase', 148, NULL, NULL, 117122),
(117123, '3.90.1200.10-FF-000067', NULL, 'Uncharacterized protein sll1119', 205, NULL, NULL, 117123);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(117124, '3.30.710.10-FF-000227', NULL, 'Ankyrin repeat and BTB domain containing 1', 149, NULL, NULL, 117124),
(117125, '3.40.50.620-FF-000363', NULL, 'Isoleucyl-tRNA synthetase cytoplasmic, putative', 296, NULL, NULL, 117125),
(117126, '2.60.40.60-FF-000984', NULL, 'Uncharacterized protein', 120, NULL, NULL, 117126),
(117127, '3.30.1120.30-FF-000047', NULL, 'Serine/threonine-protein kinase PLK', 96, NULL, NULL, 117127),
(117128, '1.10.8.60-FF-000064', NULL, 'IQ motif containing with AAA domain 1', 73, NULL, NULL, 117128),
(117129, '1.10.8.60-FF-000120', NULL, 'Sigma-54-dependent Fis family transcriptional regulator', 77, NULL, NULL, 117129),
(117130, '2.130.10.10-FF-001127', NULL, 'Protein kinase and ribonuclease Ire1, putative', 260, NULL, NULL, 117130),
(117131, '2.170.190.11-FF-000012', NULL, 'Molybdopterin molybdenumtransferase 2', 97, NULL, NULL, 117131),
(117132, '3.30.910.20-FF-000009', NULL, 'Skp-like protein', 144, NULL, NULL, 117132),
(117133, '2.40.10.10-FF-000468', NULL, NULL, 116, NULL, NULL, 117133),
(117134, '1.10.1200.60-FF-000001', NULL, '50S ribosomal protein L19e', 56, NULL, NULL, 117134),
(117135, '2.70.98.90-FF-000007', NULL, 'Membrane protein insertase YidC', 253, NULL, NULL, 117135),
(117136, '3.20.20.140-FF-000318', NULL, 'Guanine deaminase', 322, NULL, NULL, 117136),
(117137, '3.90.1580.10-FF-000027', NULL, 'Predicted protein', 271, NULL, NULL, 117137),
(117138, '1.10.8.270-FF-000098', NULL, 'Rab-GTPase-TBC domain containing protein, putative', 89, NULL, NULL, 117138),
(117139, '3.30.200.20-FF-000742', NULL, 'Receptor-like protein kinase ANXUR2', 114, NULL, NULL, 117139),
(117140, '3.50.50.60-FF-000819', NULL, 'Fructose dehydrogenase large subunit', 306, NULL, NULL, 117140),
(117141, '3.10.490.20-FF-000008', NULL, 'dynein heavy chain 2, axonemal', 144, NULL, NULL, 117141),
(117142, '2.30.29.30-FF-000438', NULL, 'uncharacterized protein LOC108093793 isoform X2', 141, NULL, NULL, 117142),
(117143, '3.30.230.10-FF-000241', NULL, 'Galactokinase', 201, NULL, NULL, 117143),
(117144, '1.25.40.10-FF-005083', NULL, 'Uncharacterized protein', 89, NULL, NULL, 117144),
(117145, '1.10.1750.10-FF-000010', NULL, 'Chromosomal replication initiator protein DnaA', 102, NULL, NULL, 117145),
(117146, '1.10.510.10-FF-003719', NULL, NULL, 155, NULL, NULL, 117146),
(117147, '3.30.429.10-FF-000005', NULL, 'Macrophage migration inhibitory factor', 116, NULL, NULL, 117147),
(117148, '2.130.10.10-FF-005292', NULL, 'Periodic tryptophan protein 2 homolog-related protein', 222, NULL, NULL, 117148),
(117149, '1.10.150.50-FF-000051', NULL, 'Lymphocyte cytosolic protein 2', 77, NULL, NULL, 117149),
(117150, '3.30.190.20-FF-000043', NULL, 'Ribosomal protein', 72, NULL, NULL, 117150),
(117151, '3.30.200.20-FF-001731', NULL, 'Tyrosine-protein kinase', 72, NULL, NULL, 117151),
(117152, '2.60.40.10-FF-006000', NULL, NULL, 67, NULL, NULL, 117152),
(117153, '2.40.155.10-FF-000011', NULL, 'Predicted protein', 121, NULL, NULL, 117153),
(117154, '3.60.20.10-FF-000151', NULL, 'Proteasome endopeptidase complex', 152, NULL, NULL, 117154),
(117155, '1.25.10.10-FF-003075', NULL, 'Uncharacterized protein', 245, NULL, NULL, 117155),
(117156, '2.60.40.10-FF-002728', NULL, 'Inositol polyphosphate 5-phosphatase, putative', 123, NULL, NULL, 117156),
(117157, '3.30.2130.30-FF-000019', NULL, 'Probable tRNA sulfurtransferase', 165, NULL, NULL, 117157),
(117158, '1.10.287.70-FF-000637', NULL, 'Uncharacterized protein', 193, NULL, NULL, 117158),
(117159, '3.40.50.20-FF-000089', NULL, 'Uncharacterized protein', 111, NULL, NULL, 117159),
(117160, '3.30.1120.10-FF-000041', NULL, 'Arylsulfatase A [precursor]', 79, NULL, NULL, 117160),
(117161, '2.60.120.380-FF-000016', NULL, 'Calpain 13', 136, NULL, NULL, 117161),
(117162, '1.20.1250.20-FF-001586', NULL, 'MFS transporter, putative (AFU_orthologue AFUA_5G13160)', 327, NULL, NULL, 117162),
(117163, '2.150.10.10-FF-000013', NULL, NULL, 107, NULL, NULL, 117163),
(117164, '4.10.280.110-FF-000025', NULL, NULL, 76, NULL, NULL, 117164),
(117165, '3.40.50.300-FF-005702', NULL, 'Uncharacterized protein', 175, NULL, NULL, 117165);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(117166, '1.20.930.60-FF-000015', NULL, 'Predicted protein', 119, NULL, NULL, 117166),
(117167, '1.20.1740.10-FF-000030', NULL, 'solute carrier family 12 member 8', 386, NULL, NULL, 117167),
(117168, '1.20.1740.10-FF-000176', NULL, 'Transport protein (Probable substrate cationic amino acids)', 431, NULL, NULL, 117168),
(117169, '1.25.40.10-FF-004684', NULL, 'Tetratricopeptide repeat protein 1', 221, NULL, NULL, 117169),
(117170, '3.10.580.10-FF-000041', NULL, 'Cystathionine beta-synthase', 142, NULL, NULL, 117170),
(117171, '1.10.1670.40-FF-000018', NULL, 'Uncharacterized protein', 26, NULL, NULL, 117171),
(117172, '1.25.10.10-FF-003131', NULL, 'Leucine-rich repeat kinase 2', 448, NULL, NULL, 117172),
(117173, '1.10.3080.10-FF-000009', NULL, 'Chloride voltage-gated channel 6', 467, NULL, NULL, 117173),
(117174, '1.25.10.10-FF-001837', NULL, 'Uncharacterized protein', 351, NULL, NULL, 117174),
(117175, '3.40.50.300-FF-000003', NULL, 'Elongation factor Tu', 202, NULL, NULL, 117175),
(117176, '3.20.20.380-FF-000008', NULL, 'Putative homeostasis protein', 222, NULL, NULL, 117176),
(117177, '2.60.120.10-FF-000443', NULL, 'Os05g0197200 protein', 60, NULL, NULL, 117177),
(117178, '1.20.1250.20-FF-000653', NULL, 'Polyamine transporter, putative', 427, NULL, NULL, 117178),
(117179, '2.40.50.140-FF-000678', NULL, NULL, 84, NULL, NULL, 117179),
(117180, '2.10.110.30-FF-000004', NULL, 'Ubr2p', 73, NULL, NULL, 117180),
(117181, '3.40.630.30-FF-000218', NULL, 'GCN5-related N-acetyltransferase', 200, NULL, NULL, 117181),
(117182, '3.40.50.150-FF-001604', NULL, NULL, 259, NULL, NULL, 117182),
(117183, '1.20.1740.10-FF-000232', NULL, 'Uncharacterized protein', 417, NULL, NULL, 117183),
(117184, '3.30.1240.10-FF-000044', NULL, 'Cof-type HAD-IIB family hydrolase', 97, NULL, NULL, 117184),
(117185, '3.40.1190.20-FF-000068', NULL, 'ATP-dependent (S)-NAD(P)H-hydrate dehydratase', 332, NULL, NULL, 117185),
(117186, '3.40.630.150-FF-000010', NULL, 'Uncharacterized protein', 68, NULL, NULL, 117186),
(117187, '1.20.120.350-FF-000118', NULL, 'Voltage-dependent calcium channel subunit, putative', 120, NULL, NULL, 117187),
(117188, '3.50.50.60-FF-001281', NULL, 'Uncharacterized protein', 47, NULL, NULL, 117188),
(117189, '2.70.98.70-FF-000001', NULL, 'dermatan-sulfate epimerase isoform X1', 308, NULL, NULL, 117189),
(117190, '3.30.930.10-FF-000064', NULL, 'Lysine--tRNA ligase', 362, NULL, NULL, 117190),
(117191, '1.10.472.140-FF-000002', NULL, 'RB transcriptional corepressor 1', 148, NULL, NULL, 117191),
(117192, '3.90.260.10-FF-000021', NULL, 'Transglutaminase 6', 251, NULL, NULL, 117192),
(117193, '1.20.1070.10-FF-001102', NULL, 'Prostaglandin E2 receptor EP4 subtype', 313, NULL, NULL, 117193),
(117194, '3.30.70.2000-FF-000003', NULL, 'INSOmniac (Drosophila sleep affecting) homolog', 58, NULL, NULL, 117194),
(117195, '3.40.910.10-FF-000010', NULL, 'Deoxyhypusine synthase', 342, NULL, NULL, 117195),
(117196, '3.30.160.60-FF-005286', NULL, NULL, 33, NULL, NULL, 117196),
(117197, '2.40.150.20-FF-000025', NULL, 'Uncharacterized protein', 104, NULL, NULL, 117197),
(117198, '3.30.70.330-FF-000193', NULL, 'RNA-binding motif protein 12', 90, NULL, NULL, 117198),
(117199, '2.60.120.680-FF-000011', NULL, 'Predicted protein', 106, NULL, NULL, 117199),
(117200, '2.60.40.2690-FF-000006', NULL, 'Splicing factor 3a subunit 2, putative', 126, NULL, NULL, 117200),
(117201, '3.20.20.370-FF-000005', NULL, 'Delta-lactam-biosynthetic de-N-acetylase', 240, NULL, NULL, 117201),
(117202, '3.30.160.60-FF-004302', NULL, NULL, 28, NULL, NULL, 117202),
(117203, '3.40.50.720-FF-000039', NULL, 'Alcohol dehydrogenase AdhP', 141, NULL, NULL, 117203),
(117204, '1.20.1560.10-FF-000611', NULL, 'Uncharacterized protein', 233, NULL, NULL, 117204),
(117205, '3.40.50.10190-FF-000320', NULL, 'Uncharacterized protein', 91, NULL, NULL, 117205),
(117206, '3.80.10.10-FF-001678', NULL, 'Calmodulin-binding receptor kinase CaMRLK', 116, NULL, NULL, 117206),
(117207, '3.40.50.300-FF-003757', NULL, 'Chromosome 1, whole genome shotgun sequence', 275, NULL, NULL, 117207);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(117208, '1.10.600.10-FF-000085', NULL, 'Uncharacterized protein', 261, NULL, NULL, 117208),
(117209, '1.10.287.130-FF-000190', NULL, 'Sensor histidine kinase/response regulator', 100, NULL, NULL, 117209),
(117210, '1.10.132.30-FF-000025', NULL, 'DNA-directed RNA polymerase subunit', 119, NULL, NULL, 117210),
(117211, '3.90.1750.20-FF-000010', NULL, 'DNA recombinase', 164, NULL, NULL, 117211),
(117212, '1.10.575.10-FF-000014', NULL, 'Phospholipase C', 250, NULL, NULL, 117212),
(117213, '1.20.1280.290-FF-000036', NULL, 'Sugar transporter SWEET', 92, NULL, NULL, 117213),
(117214, '1.10.132.20-FF-000022', NULL, 'Uncharacterized protein', 94, NULL, NULL, 117214),
(117215, '3.30.160.20-FF-000215', NULL, 'Uncharacterized protein', 82, NULL, NULL, 117215),
(117216, '1.10.150.20-FF-000036', NULL, 'Polymerase (DNA directed), theta', 144, NULL, NULL, 117216),
(117217, '2.40.20.10-FF-000120', NULL, 'Uncharacterized protein', 65, NULL, NULL, 117217),
(117218, '3.80.10.10-FF-002818', NULL, 'Uncharacterized protein', 86, NULL, NULL, 117218),
(117219, '1.25.40.10-FF-002969', NULL, 'Uncharacterized protein', 114, NULL, NULL, 117219),
(117220, '3.40.50.720-FF-002282', NULL, 'Inositol-3-phosphate synthase isozyme 1', 225, NULL, NULL, 117220),
(117221, '3.30.310.10-FF-000005', NULL, 'TATA box-binding protein-like 1', 85, NULL, NULL, 117221),
(117222, '2.130.10.10-FF-003049', NULL, 'WD domain, G-beta repeat, putative', 146, NULL, NULL, 117222),
(117223, '3.40.50.300-FF-004983', NULL, 'Predicted protein', 287, NULL, NULL, 117223),
(117224, '1.25.40.20-FF-000033', NULL, 'E3 ubiquitin-protein ligase HECTD1 isoform X2', 53, NULL, NULL, 117224),
(117225, '3.30.40.10-FF-000159', NULL, 'BRCA1-associated protein-like', 93, NULL, NULL, 117225),
(117226, '3.80.10.10-FF-000374', NULL, 'volume-regulated anion channel subunit LRRC8E isoform X2', 242, NULL, NULL, 117226),
(117227, '3.30.160.60-FF-005606', NULL, NULL, 30, NULL, NULL, 117227),
(117228, '2.10.80.10-FF-000018', NULL, 'Uncharacterized protein', 88, NULL, NULL, 117228),
(117229, '3.40.50.300-FF-007563', NULL, 'Uncharacterized protein', 186, NULL, NULL, 117229),
(117230, '4.10.1060.10-FF-000039', NULL, 'Zinc finger Ran-binding domain-containing protein 2', 34, NULL, NULL, 117230),
(117231, '1.10.3380.10-FF-000049', NULL, 'U5 small nuclear ribonucleoprotein 200 kDa helicase, putative', 153, NULL, NULL, 117231),
(117232, '1.10.10.10-FF-001511', NULL, 'Uncharacterized protein', 100, NULL, NULL, 117232),
(117233, '3.40.390.10-FF-000289', NULL, NULL, 92, NULL, NULL, 117233),
(117234, '1.20.1110.10-FF-000145', NULL, 'Potassium/sodium efflux P-type ATPase, fungal-type', 364, NULL, NULL, 117234),
(117235, '3.40.50.10190-FF-000017', NULL, 'PAX interacting protein 1', 98, NULL, NULL, 117235),
(117236, '1.25.40.10-FF-004947', NULL, 'Uncharacterized protein', 176, NULL, NULL, 117236),
(117237, '3.40.50.11260-FF-000001', NULL, 'Heat shock protein 90 alpha', 87, NULL, NULL, 117237),
(117238, '1.25.40.20-FF-000679', NULL, 'Uncharacterized protein', 200, NULL, NULL, 117238),
(117239, '2.60.120.1540-FF-000010', NULL, 'Alpha-2-macroglobulin-like', 86, NULL, NULL, 117239),
(117240, '3.50.30.30-FF-000124', NULL, 'Carboxypeptidase Q', 20, NULL, NULL, 117240),
(117241, '3.30.465.10-FF-000095', NULL, 'Magnesium and cobalt efflux protein', 87, NULL, NULL, 117241),
(117242, '1.10.510.10-FF-001921', NULL, 'Histone-lysine N-methyltransferase', 90, NULL, NULL, 117242),
(117243, '2.60.40.10-FF-005218', NULL, NULL, 115, NULL, NULL, 117243),
(117244, '3.20.20.100-FF-000149', NULL, 'Uncharacterized protein', 267, NULL, NULL, 117244),
(117245, '3.30.200.40-FF-000012', NULL, 'Uncharacterized protein', 39, NULL, NULL, 117245),
(117246, '3.60.21.10-FF-000203', NULL, 'Ser/Thr protein phosphatase, putative', 300, NULL, NULL, 117246),
(117247, '1.25.40.10-FF-000030', NULL, 'Tetratricopeptide repeat domain 7B', 179, NULL, NULL, 117247),
(117248, '2.30.30.140-FF-000159', NULL, 'GM21401', 92, NULL, NULL, 117248),
(117249, '3.90.70.130-FF-000001', NULL, 'Probable Ufm1-specific protease 2', 212, NULL, NULL, 117249); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(117250, '3.90.180.10-FF-000138', NULL, 'Uncharacterized protein', 178, NULL, NULL, 117250),
(117251, '2.40.50.140-FF-000532', NULL, 'Transcription elongation factor Spt6', 77, NULL, NULL, 117251),
(117252, '3.40.50.10240-FF-000026', NULL, 'Thiamine pyrophosphokinase', 138, NULL, NULL, 117252),
(117253, '1.25.40.20-FF-001724', NULL, 'Death-associated protein kinase dapk-1', 371, NULL, NULL, 117253),
(117254, '3.30.230.10-FF-000387', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 154, NULL, NULL, 117254),
(117255, '3.40.50.300-FF-001633', NULL, 'Thymidylate kinase', 214, NULL, NULL, 117255),
(117256, '2.10.25.10-FF-000357', NULL, 'cartilage acidic protein 1 isoform X2', 47, NULL, NULL, 117256),
(117257, '3.30.390.30-FF-000027', NULL, 'Nitrite reductase [NAD(P)H], large subunit', 82, NULL, NULL, 117257),
(117258, '3.30.365.10-FF-000036', NULL, 'Nicotinate dehydrogenase subunit B', 92, NULL, NULL, 117258),
(117259, '3.50.50.60-FF-001011', NULL, 'lysine-specific histone demethylase 1B', 214, NULL, NULL, 117259),
(117260, '3.40.50.150-FF-001806', NULL, NULL, 118, NULL, NULL, 117260),
(117261, '3.30.200.20-FF-000888', NULL, 'Putative cyclin-dependent kinase F-2', 97, NULL, NULL, 117261),
(117262, '3.30.830.10-FF-000005', NULL, 'nardilysin isoform X1', 228, NULL, NULL, 117262),
(117263, '1.20.1070.10-FF-001046', NULL, 'Bacteriorhodopsin', 231, NULL, NULL, 117263),
(117264, '1.10.630.10-FF-000761', NULL, 'Cytochrome P450 family 76 subfamily C polypeptide 7', 484, NULL, NULL, 117264),
(117265, '1.25.40.10-FF-002767', NULL, 'AGAP009674-PA', 174, NULL, NULL, 117265),
(117266, '2.10.25.10-FF-001200', NULL, 'mannan-binding lectin serine protease 1', 43, NULL, NULL, 117266),
(117267, '3.40.50.2300-FF-000759', NULL, 'Extracellular calcium-sensing receptor', 294, NULL, NULL, 117267),
(117268, '2.130.10.10-FF-001453', NULL, 'Ribosome biogenesis protein BOP1 homolog', 380, NULL, NULL, 117268),
(117269, '3.30.70.330-FF-001209', NULL, 'FI22004p1', 93, NULL, NULL, 117269),
(117270, '3.40.1160.10-FF-000035', NULL, 'Diaminopimelate decarboxylase, putative', 202, NULL, NULL, 117270),
(117271, '1.20.1110.10-FF-000201', NULL, NULL, 110, NULL, NULL, 117271),
(117272, '3.40.50.720-FF-002512', NULL, 'Nicotinate-nucleotide pyrophosphorylase AND conserved protein', 125, NULL, NULL, 117272),
(117273, '3.30.1330.40-FF-000032', NULL, 'RidA family protein', 123, NULL, NULL, 117273),
(117274, '1.10.1200.10-FF-000126', NULL, 'Lovastatin diketide synthase LovF', 76, NULL, NULL, 117274),
(117275, '1.20.1560.10-FF-000078', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 331, NULL, NULL, 117275),
(117276, '3.30.1490.20-FF-000032', NULL, 'D-alanine--D-alanine ligase', 60, NULL, NULL, 117276),
(117277, '1.10.630.10-FF-000233', NULL, 'Uncharacterized protein', 170, NULL, NULL, 117277),
(117278, '2.20.70.10-FF-000287', NULL, 'Uncharacterized protein', 31, NULL, NULL, 117278),
(117279, '3.50.50.60-FF-000499', NULL, 'Sarcosine oxidase, beta subunit', 207, NULL, NULL, 117279),
(117280, '1.25.40.10-FF-000676', NULL, 'Pentatricopeptide repeat-containing protein At2g41720', 71, NULL, NULL, 117280),
(117281, '2.40.50.140-FF-001021', NULL, NULL, 48, NULL, NULL, 117281),
(117282, '3.90.1860.10-FF-000009', NULL, 'RNA-splicing ligase RtcB', 388, NULL, NULL, 117282),
(117283, '2.40.10.190-FF-000005', NULL, '60S ribosomal protein L35a', 110, NULL, NULL, 117283),
(117284, '4.10.400.10-FF-000221', NULL, 'Terribly reduced optic lobes, isoform AT', 38, NULL, NULL, 117284),
(117285, '1.20.1250.20-FF-001001', NULL, 'putative inorganic phosphate cotransporter', 171, NULL, NULL, 117285),
(117286, '3.40.50.1010-FF-000035', NULL, 'Fcf1, putative', 144, NULL, NULL, 117286),
(117287, '1.25.10.10-FF-002765', NULL, 'Uncharacterized protein', 597, NULL, NULL, 117287),
(117288, '2.160.20.70-FF-000020', NULL, 'Tubulin binding cofactor C, putative', 159, NULL, NULL, 117288),
(117289, '3.10.200.10-FF-000018', NULL, NULL, 144, NULL, NULL, 117289),
(117290, '1.20.1070.10-FF-001687', NULL, 'Olfactory receptor 1461', 113, NULL, NULL, 117290);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(117291, '1.20.1050.90-FF-000001', NULL, 'DNA replication and repair protein RecF', 178, NULL, NULL, 117291),
(117292, '2.60.120.200-FF-000480', NULL, 'Putative transmembrane protein', 218, NULL, NULL, 117292),
(117293, '2.160.20.80-FF-000023', NULL, NULL, 83, NULL, NULL, 117293),
(117294, '2.60.40.10-FF-001475', NULL, 'TAP binding protein-like variant', 105, NULL, NULL, 117294),
(117295, '3.40.50.12780-FF-000119', NULL, 'AM-toxin synthetase', 77, NULL, NULL, 117295),
(117296, '3.30.1140.32-FF-000011', NULL, '40S ribosomal protein S3', 124, NULL, NULL, 117296),
(117297, '3.40.50.1000-FF-000768', NULL, NULL, 117, NULL, NULL, 117297),
(117298, '3.30.1130.10-FF-000013', NULL, 'Dihydroneopterin aldolase domain protein', 117, NULL, NULL, 117298),
(117299, '3.40.50.1820-FF-001031', NULL, 'Lipase/serine esterase, putative (AFU_orthologue AFUA_3G04240)', 164, NULL, NULL, 117299),
(117300, '3.40.50.1110-FF-000037', NULL, 'Carbohydrate esterase family 3 protein', 210, NULL, NULL, 117300),
(117301, '3.40.50.720-FF-000567', NULL, 'UDP-glucuronic acid decarboxylase Uxs1p', 322, NULL, NULL, 117301),
(117302, '3.40.50.1000-FF-000032', NULL, 'Cytosolic 5-nucleotidase 3-like', 190, NULL, NULL, 117302),
(117303, '3.40.50.1100-FF-000034', NULL, 'Diaminopropionate ammonia-lyase', 153, NULL, NULL, 117303),
(117304, '3.30.60.30-FF-000115', NULL, 'Predicted protein', 61, NULL, NULL, 117304),
(117305, '1.20.120.1080-FF-000035', NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase, putative', 103, NULL, NULL, 117305),
(117306, '3.10.250.10-FF-000050', NULL, 'Uncharacterized protein', 67, NULL, NULL, 117306),
(117307, '2.20.100.10-FF-000024', NULL, 'Spondin-1', 49, NULL, NULL, 117307),
(117308, '3.40.50.300-FF-000531', NULL, 'Preprotein translocase subunit SecA', 104, NULL, NULL, 117308),
(117309, '2.30.30.140-FF-000103', NULL, 'Fmr1, isoform J', 49, NULL, NULL, 117309),
(117310, '2.10.220.10-FF-000203', NULL, 'Receptor protein-tyrosine kinase', 57, NULL, NULL, 117310),
(117311, '3.40.50.1820-FF-000542', NULL, 'Serine carboxypeptidase1', 266, NULL, NULL, 117311),
(117312, '3.30.70.2350-FF-000001', NULL, 'Rhomboid protease GlpG', 67, NULL, NULL, 117312),
(117313, '1.25.40.10-FF-001660', NULL, 'General transcriptional corepressor CYC8', 56, NULL, NULL, 117313),
(117314, '1.10.510.10-FF-002579', NULL, NULL, 232, NULL, NULL, 117314),
(117315, '3.40.50.620-FF-000537', NULL, 'Glutamyl-Q tRNA(Asp) synthetase', 324, NULL, NULL, 117315),
(117316, '1.10.390.10-FF-000051', NULL, 'GM24727', 245, NULL, NULL, 117316),
(117317, '3.30.450.20-FF-000081', NULL, 'Dysfusion, isoform B', 121, NULL, NULL, 117317),
(117318, '3.40.228.10-FF-000008', NULL, 'Thiosulfate reductase PhsA', 201, NULL, NULL, 117318),
(117319, '1.25.40.10-FF-001721', NULL, 'Related to SGT1 protein', 113, NULL, NULL, 117319),
(117320, '3.30.200.20-FF-000798', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase SD3-1', 104, NULL, NULL, 117320),
(117321, '3.40.50.1110-FF-000065', NULL, 'Rhamnogalacturonan acetylesterase', 215, NULL, NULL, 117321),
(117322, '3.40.1800.20-FF-000032', NULL, NULL, 73, NULL, NULL, 117322),
(117323, '3.90.70.10-FF-000883', NULL, 'Uncharacterized protein', 346, NULL, NULL, 117323),
(117324, '3.30.230.10-FF-000297', NULL, 'DNA mismatch repair protein MutL', 112, NULL, NULL, 117324),
(117325, '1.25.40.20-FF-001663', NULL, 'Uncharacterized protein', 84, NULL, NULL, 117325),
(117326, '1.10.8.60-FF-000390', NULL, 'ATPase family associated with various cellular activities (AAA), putative', 77, NULL, NULL, 117326),
(117327, '3.40.390.10-FF-000019', NULL, 'Mitochondrial intermediate peptidase, mitochondrial', 152, NULL, NULL, 117327),
(117328, '3.50.50.60-FF-000971', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 102, NULL, NULL, 117328),
(117329, '3.40.50.2000-FF-000613', NULL, 'Glycosyltransferase', 170, NULL, NULL, 117329),
(117330, '3.40.50.300-FF-003229', NULL, 'Peroxisomal biogenesis factor 1', 165, NULL, NULL, 117330),
(117331, '2.20.25.390-FF-000001', NULL, 'EPIDERMAL PATTERNING FACTOR-like protein 9', 45, NULL, NULL, 117331);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(117332, '2.40.30.20-FF-000039', NULL, 'Uncharacterized protein', 51, NULL, NULL, 117332),
(117333, '3.30.160.60-FF-002796', NULL, 'Zinc finger protein 574', 67, NULL, NULL, 117333),
(117334, '1.10.510.10-FF-001421', NULL, 'Membrane-associated tyrosine-and threonine-specific cdc2-inhibitory kinase-like Protein', 185, NULL, NULL, 117334),
(117335, '3.40.720.10-FF-000326', NULL, 'Protein CBG15598', 136, NULL, NULL, 117335),
(117336, '2.130.10.10-FF-005814', NULL, 'Uncharacterized protein', 79, NULL, NULL, 117336),
(117337, '2.20.25.10-FF-000126', NULL, 'Uncharacterized protein', 92, NULL, NULL, 117337),
(117338, '3.90.70.80-FF-000095', NULL, 'Predicted protein', 178, NULL, NULL, 117338),
(117339, '3.40.50.720-FF-001500', NULL, 'Uncharacterized protein', 199, NULL, NULL, 117339),
(117340, '4.10.260.10-FF-000013', NULL, 'Guanine nucleotide-binding protein subunit gamma', 26, NULL, NULL, 117340),
(117341, '1.25.40.10-FF-001042', NULL, 'Anaphase-promoting complex subunit CDC23', 318, NULL, NULL, 117341),
(117342, '1.10.510.10-FF-002995', NULL, NULL, 202, NULL, NULL, 117342),
(117343, '1.20.80.10-FF-000065', NULL, 'Golgi resident protein GCP60', 110, NULL, NULL, 117343),
(117344, '3.30.710.10-FF-000351', NULL, 'Uncharacterized protein', 92, NULL, NULL, 117344),
(117345, '3.40.50.2300-FF-000495', NULL, 'Transcriptional regulator, LacI family', 115, NULL, NULL, 117345),
(117346, '2.40.160.50-FF-000035', NULL, '75 kDa chloroplast membrane translocon', 362, NULL, NULL, 117346),
(117347, '2.30.40.10-FF-000088', NULL, 'Amidohydrolase', 80, NULL, NULL, 117347),
(117348, '3.30.420.10-FF-000250', NULL, 'Ribonuclease', 197, NULL, NULL, 117348),
(117349, '3.50.7.10-FF-000088', NULL, NULL, 162, NULL, NULL, 117349),
(117350, '3.30.40.10-FF-000485', NULL, 'ATP-dependent RNA helicase DEAH12 chloroplastic', 83, NULL, NULL, 117350),
(117351, '2.60.40.10-FF-005308', NULL, NULL, 79, NULL, NULL, 117351),
(117352, '1.10.510.10-FF-003068', NULL, NULL, 204, NULL, NULL, 117352),
(117353, '2.60.120.10-FF-000027', NULL, 'Protein kinase cAMP-dependent type II regulatory subunit alpha', 152, NULL, NULL, 117353),
(117354, '2.30.40.10-FF-000144', NULL, 'Amidohydrolase domain protein', 27, NULL, NULL, 117354),
(117355, '1.20.120.240-FF-000001', NULL, 'Major outer surface protein C', 174, NULL, NULL, 117355),
(117356, '3.80.10.10-FF-002791', NULL, 'Uncharacterized protein', 152, NULL, NULL, 117356),
(117357, '3.40.50.800-FF-000063', NULL, 'Histidine--tRNA ligase', 96, NULL, NULL, 117357),
(117358, '3.40.50.2300-FF-000613', NULL, 'Metabotropic GLutamate receptor family', 162, NULL, NULL, 117358),
(117359, '3.90.1310.10-FF-000042', NULL, 'Cell division protein ftsI', 197, NULL, NULL, 117359),
(117360, '3.40.309.10-FF-000028', NULL, 'Gamma-glutamyl phosphate reductase', 153, NULL, NULL, 117360),
(117361, '1.20.1250.20-FF-000658', NULL, 'Hexose transporter', 487, NULL, NULL, 117361),
(117362, '3.30.420.10-FF-000008', NULL, 'Ribonuclease H', 155, NULL, NULL, 117362),
(117363, '2.60.40.420-FF-000115', NULL, 'Conidial pigment biosynthesis oxidase Arb2/brown2', 180, NULL, NULL, 117363),
(117364, '3.40.718.10-FF-000057', NULL, 'Isocitrate dehydrogenase 3 (NAD+) gamma', 342, NULL, NULL, 117364),
(117365, '1.20.1250.20-FF-002075', NULL, 'Protein NRT1/ PTR FAMILY 1.2', 279, NULL, NULL, 117365),
(117366, '3.30.420.40-FF-000787', NULL, 'Actin-related protein 4A', 136, NULL, NULL, 117366),
(117367, '1.10.460.10-FF-000017', NULL, 'DNA topoisomerase', 164, NULL, NULL, 117367),
(117368, '3.30.450.20-FF-000283', NULL, 'Helix-loop-helix 34', 116, NULL, NULL, 117368),
(117369, '1.10.510.10-FF-001893', NULL, 'Probable serine/threonine-protein kinase DDB_G0291918', 162, NULL, NULL, 117369),
(117370, '3.40.190.10-FF-000656', NULL, 'ABC transporter, binding protein', 151, NULL, NULL, 117370),
(117371, '3.40.50.2300-FF-001602', NULL, NULL, 76, NULL, NULL, 117371),
(117372, '3.50.50.60-FF-000645', NULL, 'Amine oxidase', 408, NULL, NULL, 117372),
(117373, '3.40.50.300-FF-005382', NULL, 'Dynein heavy chain family protein', 290, NULL, NULL, 117373),
(117374, '1.20.900.10-FF-000105', NULL, 'Uncharacterized protein', 187, NULL, NULL, 117374);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(117375, '3.40.50.410-FF-000070', NULL, 'sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', 192, NULL, NULL, 117375),
(117376, '1.10.287.70-FF-000463', NULL, 'Potassium voltage-gated channel protein eag', 245, NULL, NULL, 117376),
(117377, '3.30.9.10-FF-000013', NULL, 'tRNA 5-methylaminomethyl-2-thiouridine biosynthesis bifunctional protein MnmC', 150, NULL, NULL, 117377),
(117378, '3.40.50.2000-FF-000523', NULL, 'Glycosyltransferase family 1 protein', 176, NULL, NULL, 117378),
(117379, '2.80.10.50-FF-000135', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 137, NULL, NULL, 117379),
(117380, '3.90.245.10-FF-000008', NULL, 'Uridine nucleosidase', 327, NULL, NULL, 117380),
(117381, '3.20.20.190-FF-000165', NULL, NULL, 131, NULL, NULL, 117381),
(117382, '3.30.200.20-FF-001080', NULL, 'Protein kinase domain containing protein', 102, NULL, NULL, 117382),
(117383, '2.60.40.10-FF-005488', NULL, NULL, 126, NULL, NULL, 117383),
(117384, '3.80.10.10-FF-002167', NULL, 'F-box/LRR-repeat protein 3', 209, NULL, NULL, 117384),
(117385, '4.10.400.10-FF-000311', NULL, 'LDL receptor repeat-containing protein egg-1', 53, NULL, NULL, 117385),
(117386, '3.40.50.1000-FF-000122', NULL, 'Trehalose 6-phosphate phosphatase', 87, NULL, NULL, 117386),
(117387, '3.30.160.60-FF-005937', NULL, NULL, 39, NULL, NULL, 117387),
(117388, '2.60.120.260-FF-000565', NULL, 'Uncharacterized protein', 34, NULL, NULL, 117388),
(117389, '1.10.10.10-FF-000668', NULL, 'ATP-dependent DNA helicase', 112, NULL, NULL, 117389),
(117390, '1.10.8.10-FF-000217', NULL, 'Peptidyl-tRNA hydrolase, putative', 46, NULL, NULL, 117390),
(117391, '3.30.160.60-FF-003813', NULL, NULL, 51, NULL, NULL, 117391),
(117392, '3.30.160.20-FF-000069', NULL, 'Disco interacting protein isoform TO67', 85, NULL, NULL, 117392),
(117393, '2.10.25.10-FF-000183', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 2', 36, NULL, NULL, 117393),
(117394, '3.40.50.300-FF-005472', NULL, 'Uncharacterized protein, isoform B', 219, NULL, NULL, 117394),
(117395, '1.20.1070.10-FF-000613', NULL, 'Parietopsin', 268, NULL, NULL, 117395),
(117396, '3.40.50.300-FF-005674', NULL, 'Molybdopterin synthase catalytic subunit', 191, NULL, NULL, 117396),
(117397, '3.50.50.60-FF-000792', NULL, 'Flavin-containing monooxygenase', 287, NULL, NULL, 117397),
(117398, '2.60.200.10-FF-000028', NULL, 'Uncharacterized protein', 224, NULL, NULL, 117398),
(117399, '1.25.40.10-FF-001665', NULL, 'General transcription factor 3C polypeptide 3 isoform A', 172, NULL, NULL, 117399),
(117400, '1.25.40.20-FF-001668', NULL, '2-oxoisovalerate dehydrogenase subunit alpha', 83, NULL, NULL, 117400),
(117401, '3.40.50.410-FF-000272', NULL, 'Uncharacterized protein', 78, NULL, NULL, 117401),
(117402, '3.30.160.60-FF-004797', NULL, NULL, 30, NULL, NULL, 117402),
(117403, '3.40.50.1700-FF-000028', NULL, 'Glycoside hydrolase', 272, NULL, NULL, 117403),
(117404, '3.30.1340.30-FF-000001', NULL, 'Molecular chaperone OsmY', 66, NULL, NULL, 117404),
(117405, '3.30.1490.190-FF-000006', NULL, 'Fur family transcriptional regulator', 53, NULL, NULL, 117405),
(117406, '3.40.50.620-FF-000627', NULL, 'Arginyl-tRNA synthetase', 89, NULL, NULL, 117406),
(117407, '1.20.58.400-FF-000011', NULL, 'Putative Qb-SNARE protein', 119, NULL, NULL, 117407),
(117408, '3.30.40.10-FF-000631', NULL, 'Os03g0377600 protein', 76, NULL, NULL, 117408),
(117409, '3.30.1490.180-FF-000003', NULL, 'DNA-directed RNA polymerase subunit', 74, NULL, NULL, 117409),
(117410, '1.25.10.10-FF-001186', NULL, 'Condensin complex subunit 1', 222, NULL, NULL, 117410),
(117411, '1.10.486.10-FF-000065', NULL, 'UvrD/REP helicase family protein', 199, NULL, NULL, 117411),
(117412, '3.40.50.2000-FF-000995', NULL, 'Uncharacterized protein', 43, NULL, NULL, 117412),
(117413, '3.30.830.10-FF-000298', NULL, 'Uncharacterized protein', 38, NULL, NULL, 117413),
(117414, '3.80.10.10-FF-004056', NULL, 'Uncharacterized protein', 135, NULL, NULL, 117414),
(117415, '3.40.50.360-FF-000116', NULL, 'Sulfite reductase (Nadph), alpha subunit', 162, NULL, NULL, 117415);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(117416, '1.25.40.10-FF-003458', NULL, 'Os11g0109800 protein', 113, NULL, NULL, 117416),
(117417, '3.90.830.10-FF-000020', NULL, 'Vacuolar protein sorting-associated protein 45, putative', 122, NULL, NULL, 117417),
(117418, '3.60.110.10-FF-000074', NULL, NULL, 209, NULL, NULL, 117418),
(117419, '3.30.420.40-FF-001012', NULL, 'Uncharacterized protein', 56, NULL, NULL, 117419),
(117420, '2.60.40.10-FF-005016', NULL, NULL, 105, NULL, NULL, 117420),
(117421, '1.20.1560.10-FF-000465', NULL, 'ABC transporter ATP-binding protein', 323, NULL, NULL, 117421),
(117422, '1.10.565.10-FF-000103', NULL, 'Nuclear receptor 1', 230, NULL, NULL, 117422),
(117423, '3.40.50.1010-FF-000125', NULL, 'DNA-repair protein putative', 140, NULL, NULL, 117423),
(117424, '1.20.1070.10-FF-000883', NULL, 'Uncharacterized protein', 321, NULL, NULL, 117424),
(117425, '1.10.287.4070-FF-000018', NULL, 'Uncharacterized protein', 137, NULL, NULL, 117425),
(117426, '3.40.50.300-FF-006809', NULL, 'Uncharacterized protein', 48, NULL, NULL, 117426),
(117427, '3.40.50.720-FF-001410', NULL, 'UDP-glucose 4-epimerase', 177, NULL, NULL, 117427),
(117428, '3.10.20.230-FF-000011', NULL, 'Doublecortin domain containing 2B', 93, NULL, NULL, 117428),
(117429, '3.60.10.10-FF-000206', NULL, 'Uncharacterized protein', 233, NULL, NULL, 117429),
(117430, '2.130.10.10-FF-000997', NULL, 'AGAP002030-PA-like protein', 153, NULL, NULL, 117430),
(117431, '1.20.58.150-FF-000008', NULL, 'Putative clathrin assembly protein At1g33340', 143, NULL, NULL, 117431),
(117432, '3.80.10.10-FF-003010', NULL, 'Predicted protein', 193, NULL, NULL, 117432),
(117433, '3.20.20.190-FF-000075', NULL, 'Phosphoinositide phospholipase C', 286, NULL, NULL, 117433),
(117434, '3.10.110.10-FF-000068', NULL, 'Ubiquitin-conjugating enzyme E2-20 kDa', 152, NULL, NULL, 117434),
(117435, '3.40.50.300-FF-005056', NULL, 'Uncharacterized protein', 130, NULL, NULL, 117435),
(117436, '3.30.310.80-FF-000043', NULL, 'Non-specific serine/threonine protein kinase', 53, NULL, NULL, 117436),
(117437, '3.30.420.10-FF-000160', NULL, 'Cruciform cutting endonuclease', 301, NULL, NULL, 117437),
(117438, '1.20.1250.10-FF-000032', NULL, 'Interleukin-22', 151, NULL, NULL, 117438),
(117439, '3.40.50.510-FF-000004', NULL, 'Dihydroxyacetone kinase subunit DhaM', 123, NULL, NULL, 117439),
(117440, '2.60.120.290-FF-000017', NULL, 'Platelet derived growth factor C', 122, NULL, NULL, 117440),
(117441, '2.170.300.10-FF-000032', NULL, 'Platelet endothelial aggregation receptor 1', 127, NULL, NULL, 117441),
(117442, '2.80.10.50-FF-000051', NULL, 'Fascin', 134, NULL, NULL, 117442),
(117443, '1.10.10.60-FF-001239', NULL, NULL, 48, NULL, NULL, 117443),
(117444, '3.40.50.80-FF-000028', NULL, 'Respiratory burst oxidase protein E', 210, NULL, NULL, 117444),
(117445, '2.60.120.10-FF-000117', NULL, 'Mannose-6-phosphate isomerase', 87, NULL, NULL, 117445),
(117446, '3.30.160.60-FF-001924', NULL, 'Charlatan, isoform F', 77, NULL, NULL, 117446),
(117447, '1.10.150.220-FF-000009', NULL, NULL, 85, NULL, NULL, 117447),
(117448, '3.30.40.10-FF-000575', NULL, 'Cellulose synthase', 91, NULL, NULL, 117448),
(117449, '3.80.10.10-FF-004112', NULL, 'Uncharacterized protein', 117, NULL, NULL, 117449),
(117450, '4.10.1000.10-FF-000154', NULL, 'zinc finger CCCH domain-containing protein 10 isoform X2', 72, NULL, NULL, 117450),
(117451, '3.40.850.10-FF-000336', NULL, 'Kinesin-like protein', 228, NULL, NULL, 117451),
(117452, '3.30.70.330-FF-000485', NULL, 'Uncharacterized protein, isoform B', 123, NULL, NULL, 117452),
(117453, '2.60.40.10-FF-005634', NULL, NULL, 95, NULL, NULL, 117453),
(117454, '3.40.50.10490-FF-000135', NULL, NULL, 24, NULL, NULL, 117454),
(117455, '1.10.10.60-FF-000099', NULL, 'MYB transcription factor', 48, NULL, NULL, 117455),
(117456, '1.20.120.850-FF-000004', NULL, 'DNA repair and recombination protein RAD54B', 111, NULL, NULL, 117456),
(117457, '3.30.479.20-FF-000040', NULL, 'Elongation factor Ts, mitochondrial', 132, NULL, NULL, 117457),
(117458, '1.25.50.20-FF-000005', NULL, 'Aminopeptidase N-like protein', 324, NULL, NULL, 117458);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(117459, '1.10.1220.10-FF-000010', NULL, 'Putative nickel-responsive regulator', 37, NULL, NULL, 117459),
(117460, '3.30.70.330-FF-001625', NULL, NULL, 65, NULL, NULL, 117460),
(117461, '3.30.590.50-FF-000015', NULL, 'Glutamate-cysteine ligase', 154, NULL, NULL, 117461),
(117462, '3.50.50.60-FF-001191', NULL, 'Sulfide Quinone oxidoReDuctase', 60, NULL, NULL, 117462),
(117463, '1.10.510.10-FF-003220', NULL, NULL, 134, NULL, NULL, 117463),
(117464, '3.40.50.720-FF-002309', NULL, 'Uncharacterized protein', 136, NULL, NULL, 117464),
(117465, '1.25.50.10-FF-000002', NULL, 'Puromycin-sensitive aminopeptidase', 325, NULL, NULL, 117465),
(117466, '1.25.40.10-FF-003610', NULL, 'Predicted protein', 124, NULL, NULL, 117466),
(117467, '3.30.70.150-FF-000003', NULL, 'Ribulose bisphosphate carboxylase-like protein', 145, NULL, NULL, 117467),
(117468, '1.25.40.470-FF-000073', NULL, 'WD-repeat containing protein', 147, NULL, NULL, 117468),
(117469, '3.40.50.300-FF-005707', NULL, 'Dynein heavy chain domain 1', 173, NULL, NULL, 117469),
(117470, '1.25.40.10-FF-003082', NULL, 'Pentatricopeptide repeat domain 1', 177, NULL, NULL, 117470),
(117471, '3.40.50.2300-FF-000585', NULL, 'Branched-chain amino acid ABC transporter substrate-binding protein', 129, NULL, NULL, 117471),
(117472, '1.25.40.180-FF-000071', NULL, 'Eukaryotic translation initiation factor 4 gamma', 198, NULL, NULL, 117472),
(117473, '1.25.40.10-FF-002593', NULL, 'Uncharacterized protein', 96, NULL, NULL, 117473),
(117474, '3.30.900.10-FF-000034', NULL, 'DNA polymerase zeta processivity subunit', 65, NULL, NULL, 117474),
(117475, '3.30.160.20-FF-000125', NULL, 'Peptide chain release factor 2, putative', 110, NULL, NULL, 117475),
(117476, '2.30.30.1020-FF-000041', NULL, NULL, 141, NULL, NULL, 117476),
(117477, '1.20.1540.10-FF-000048', NULL, 'Rhomboid protease ROM9', 181, NULL, NULL, 117477),
(117478, '2.70.50.30-FF-000008', NULL, 'Immunoglobulin E-set', 188, NULL, NULL, 117478),
(117479, '1.10.10.60-FF-000986', NULL, NULL, 84, NULL, NULL, 117479),
(117480, '3.40.50.300-FF-006776', NULL, 'Uncharacterized protein', 60, NULL, NULL, 117480),
(117481, '3.40.50.2000-FF-000467', NULL, '3-deoxy-D-manno-octulosonic acid transferase', 185, NULL, NULL, 117481),
(117482, '2.60.120.260-FF-000621', NULL, 'Uncharacterized protein', 132, NULL, NULL, 117482),
(117483, '3.40.50.300-FF-001487', NULL, 'Shikimate kinase', 162, NULL, NULL, 117483),
(117484, '1.10.10.10-FF-001034', NULL, 'Two component transcriptional regulator, winged helix family', 113, NULL, NULL, 117484),
(117485, '1.10.510.10-FF-001275', NULL, 'Serine/threonine protein kinase', 209, NULL, NULL, 117485),
(117486, '1.10.630.10-FF-000435', NULL, 'Cytochrome P450 76A2', 52, NULL, NULL, 117486),
(117487, '3.30.56.30-FF-000010', NULL, 'Signal recognition particle sec65 subunit', 115, NULL, NULL, 117487),
(117488, '1.10.630.10-FF-000087', NULL, 'Thromboxane A synthase 1', 141, NULL, NULL, 117488),
(117489, '1.20.120.1240-FF-000067', NULL, 'Dynamin-related GTPase', 252, NULL, NULL, 117489),
(117490, '1.10.150.200-FF-000003', NULL, 'Maltooligosyl trehalose synthase', 85, NULL, NULL, 117490),
(117491, '1.10.10.60-FF-001116', NULL, NULL, 65, NULL, NULL, 117491),
(117492, '1.10.3370.10-FF-000021', NULL, 'Protein transport protein sec61 alpha subunit, putative', 488, NULL, NULL, 117492),
(117493, '2.60.40.10-FF-001273', NULL, 'Hibris, isoform B', 103, NULL, NULL, 117493),
(117494, '3.40.1170.60-FF-000028', NULL, 'DNA polymerase eta', 73, NULL, NULL, 117494),
(117495, '2.10.25.10-FF-000559', NULL, 'Crumbs 2, cell polarity complex component', 39, NULL, NULL, 117495),
(117496, '3.30.43.10-FF-000019', NULL, 'L-galactono-1,4-lactone dehydrogenase', 69, NULL, NULL, 117496),
(117497, '1.20.1070.10-FF-000703', NULL, 'Protein CBG03949', 328, NULL, NULL, 117497),
(117498, '1.10.575.10-FF-000019', NULL, 'Uncharacterized protein', 266, NULL, NULL, 117498),
(117499, '3.40.50.1820-FF-000716', NULL, 'Uncharacterized protein', 235, NULL, NULL, 117499),
(117500, '2.60.40.10-FF-001891', NULL, 'Tyrosine protein kinase receptor tie-1, putative', 101, NULL, NULL, 117500);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(117501, '1.20.120.1910-FF-000054', NULL, 'Os10g0463100 protein', 114, NULL, NULL, 117501),
(117502, '3.30.460.10-FF-000196', NULL, 'Ribosomal silencing factor RsfS', 109, NULL, NULL, 117502),
(117503, '1.10.472.10-FF-000685', NULL, 'Uncharacterized protein', 153, NULL, NULL, 117503),
(117504, '3.40.50.410-FF-000362', NULL, 'Bcl-2-associated transcription factor (BTF), putative', 53, NULL, NULL, 117504),
(117505, '2.60.40.10-FF-005544', NULL, NULL, 120, NULL, NULL, 117505),
(117506, '3.90.850.10-FF-000050', NULL, NULL, 106, NULL, NULL, 117506),
(117507, '1.10.275.10-FF-000002', NULL, 'Argininosuccinate lyase', 135, NULL, NULL, 117507),
(117508, '2.130.10.10-FF-001930', NULL, 'Transducin/WD40 repeat-like superfamily protein', 254, NULL, NULL, 117508),
(117509, '3.30.70.330-FF-000518', NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', 109, NULL, NULL, 117509),
(117510, '2.60.60.20-FF-000057', NULL, NULL, 63, NULL, NULL, 117510),
(117511, '3.40.50.300-FF-005146', NULL, 'Torsin-1A', 234, NULL, NULL, 117511),
(117512, '1.20.5.110-FF-000194', NULL, 'Synaptosomal-associated protein', 50, NULL, NULL, 117512),
(117513, '3.60.21.10-FF-000001', NULL, 'Serine/threonine-protein phosphatase', 305, NULL, NULL, 117513),
(117514, '3.40.50.720-FF-000393', NULL, 'Homoserine dehydrogenase', 194, NULL, NULL, 117514),
(117515, '2.60.40.420-FF-000059', NULL, 'L-ascorbate oxidase', 132, NULL, NULL, 117515),
(117516, '1.20.930.60-FF-000010', NULL, 'Uncharacterized protein', 137, NULL, NULL, 117516),
(117517, '2.60.120.10-FF-000353', NULL, 'Transcription regulator, CRP family', 214, NULL, NULL, 117517),
(117518, '3.30.70.660-FF-000089', NULL, 'tRNA pseudouridine synthase', 192, NULL, NULL, 117518),
(117519, '1.20.5.170-FF-000015', NULL, 'ARF GTPase-activating protein GIT2 isoform 1', 62, NULL, NULL, 117519),
(117520, '1.10.1740.10-FF-000009', NULL, 'RNA polymerase sigma factor', 89, NULL, NULL, 117520),
(117521, '1.20.950.20-FF-000027', NULL, 'Cytochrome b561', 169, NULL, NULL, 117521),
(117522, '2.60.40.420-FF-000031', NULL, 'Laccase-2 isoform A', 160, NULL, NULL, 117522),
(117523, '1.20.120.160-FF-000005', NULL, 'Histidine-containing phosphotransfer protein 4', 145, NULL, NULL, 117523),
(117524, '1.50.10.10-FF-000133', NULL, 'Uncharacterized protein', 191, NULL, NULL, 117524),
(117525, '2.60.120.970-FF-000070', NULL, 'Inhibin beta chain', 124, NULL, NULL, 117525),
(117526, '3.90.190.10-FF-000605', NULL, 'MkpA protein', 167, NULL, NULL, 117526),
(117527, '3.40.1110.10-FF-000324', NULL, NULL, 163, NULL, NULL, 117527),
(117528, '3.30.9.10-FF-000160', NULL, 'Predicted protein', 142, NULL, NULL, 117528),
(117529, '4.10.1000.10-FF-000064', NULL, 'Putative zinc finger domain-containing protein', 63, NULL, NULL, 117529),
(117530, '1.10.275.30-FF-000008', NULL, 'DNA helicase RepD', 87, NULL, NULL, 117530),
(117531, '1.10.630.10-FF-000620', NULL, 'Uncharacterized protein', 247, NULL, NULL, 117531),
(117532, '2.60.40.10-FF-001621', NULL, 'Immunoglobulin heavy variable 2-6-8', 117, NULL, NULL, 117532),
(117533, '2.40.50.700-FF-000014', NULL, NULL, 99, NULL, NULL, 117533),
(117534, '3.30.450.20-FF-000316', NULL, 'Methyl-accepting chemotaxis protein', 88, NULL, NULL, 117534),
(117535, '1.10.275.20-FF-000005', NULL, NULL, 90, NULL, NULL, 117535),
(117536, '2.30.29.30-FF-000348', NULL, 'Non-specific serine/threonine protein kinase', 102, NULL, NULL, 117536),
(117537, '3.40.50.970-FF-000209', NULL, 'Uncharacterized protein', 195, NULL, NULL, 117537),
(117538, '3.40.50.720-FF-002456', NULL, 'Methylenetetrahydrofolate dehydrogenase (NADP+-dependent) 1-like', 59, NULL, NULL, 117538),
(117539, '2.130.10.10-FF-005640', NULL, 'Uncharacterized protein', 175, NULL, NULL, 117539),
(117540, '3.40.910.10-FF-000015', NULL, 'Deoxyhypusine synthase', 115, NULL, NULL, 117540),
(117541, '1.20.1720.10-FF-000028', NULL, 'Multidrug MFS transporter', 246, NULL, NULL, 117541),
(117542, '1.20.120.150-FF-000002', NULL, 'Serine/threonine-protein kinase TOR', 89, NULL, NULL, 117542),
(117543, '3.60.20.10-FF-000095', NULL, 'Asparagine synthase (Glutamine-hydrolyzing)', 196, NULL, NULL, 117543);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(117544, '3.10.105.10-FF-000123', NULL, 'Dipeptide binding protein', 160, NULL, NULL, 117544),
(117545, '1.25.10.10-FF-002939', NULL, 'Uncharacterized protein', 82, NULL, NULL, 117545),
(117546, '2.60.40.10-FF-000778', NULL, 'Fibronectin type III domain containing 1', 106, NULL, NULL, 117546),
(117547, '2.30.29.30-FF-000641', NULL, 'Exocyst complex component', 111, NULL, NULL, 117547),
(117548, '2.10.110.10-FF-000139', NULL, 'Protein CBR-ZYX-1', 70, NULL, NULL, 117548),
(117549, '3.30.40.10-FF-002199', NULL, 'Uncharacterized protein', 74, NULL, NULL, 117549),
(117550, '1.20.120.1020-FF-000001', NULL, 'Uncharacterized protein', 233, NULL, NULL, 117550),
(117551, '2.60.120.200-FF-000715', NULL, 'Uncharacterized protein', 177, NULL, NULL, 117551),
(117552, '2.40.50.90-FF-000163', NULL, 'Tudor domain containing protein', 153, NULL, NULL, 117552),
(117553, '2.30.30.190-FF-000039', NULL, NULL, 87, NULL, NULL, 117553),
(117554, '3.40.50.150-FF-001419', NULL, NULL, 156, NULL, NULL, 117554),
(117555, '3.30.1370.50-FF-000009', NULL, 'RBS1p protein', 122, NULL, NULL, 117555),
(117556, '3.30.1360.40-FF-000034', NULL, 'ribosome-recycling factor, mitochondrial-like', 76, NULL, NULL, 117556),
(117557, '1.20.1530.20-FF-000079', NULL, 'Probable sodium/hydrogen antiporter', 342, NULL, NULL, 117557),
(117558, '3.80.10.10-FF-000402', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase IRK', 270, NULL, NULL, 117558),
(117559, '3.90.640.10-FF-000039', NULL, 'Hsp70 family chaperone Lhs1/Orp150', 92, NULL, NULL, 117559),
(117560, '3.30.160.60-FF-002503', NULL, 'Zinc finger protein 280D', 62, NULL, NULL, 117560),
(117561, '2.60.40.200-FF-000021', NULL, 'Uncharacterized protein', 118, NULL, NULL, 117561),
(117562, '2.10.25.10-FF-000503', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1', 35, NULL, NULL, 117562),
(117563, '1.25.40.860-FF-000004', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 75, NULL, NULL, 117563),
(117564, '3.40.50.2300-FF-000669', NULL, 'Uncharacterized protein', 138, NULL, NULL, 117564),
(117565, '1.25.10.10-FF-001219', NULL, 'Serine/threonine-protein kinase TOR', 398, NULL, NULL, 117565),
(117566, '1.20.120.20-FF-000015', NULL, 'Zgc:162608', 122, NULL, NULL, 117566),
(117567, '2.120.10.30-FF-000526', NULL, 'Predicted protein', 150, NULL, NULL, 117567),
(117568, '3.40.1110.10-FF-000291', NULL, NULL, 60, NULL, NULL, 117568),
(117569, '3.30.1520.10-FF-000173', NULL, 'Predicted protein', 111, NULL, NULL, 117569),
(117570, '3.20.20.140-FF-000083', NULL, 'Dihydroorotase, homodimeric type', 353, NULL, NULL, 117570),
(117571, '2.40.50.120-FF-000048', NULL, 'Metalloproteinase inhibitor 2', 102, NULL, NULL, 117571),
(117572, '2.70.160.11-FF-000080', NULL, 'Uncharacterized protein', 118, NULL, NULL, 117572),
(117573, '2.30.110.10-FF-000005', NULL, 'NAD(P)H-hydrate epimerase', 212, NULL, NULL, 117573),
(117574, '3.40.850.10-FF-000246', NULL, 'Kinesin-like protein', 317, NULL, NULL, 117574),
(117575, '1.10.3380.10-FF-000050', NULL, 'Predicted protein', 164, NULL, NULL, 117575),
(117576, '3.30.450.20-FF-000642', NULL, 'Histidine kinase response regulator hybrid protein', 129, NULL, NULL, 117576),
(117577, '3.40.30.10-FF-000433', NULL, 'Probable dolichyl-diphosphooligosaccharide--protein glycosyltransferase subunit 3', 160, NULL, NULL, 117577),
(117578, '1.25.40.530-FF-000018', NULL, 'Unconventional myosin heavy chain 6', 265, NULL, NULL, 117578),
(117579, '1.25.10.10-FF-001130', NULL, 'TORTIFOLIA1-like protein 2', 211, NULL, NULL, 117579),
(117580, '3.40.50.300-FF-002330', NULL, 'ATP-dependent RNA helicase DDX27', 257, NULL, NULL, 117580),
(117581, '3.20.20.150-FF-000029', NULL, 'L-xylulose 5-phosphate 3-epimerase', 264, NULL, NULL, 117581),
(117582, '2.130.10.10-FF-005584', NULL, 'Myosin heavy chain kinase A', 204, NULL, NULL, 117582),
(117583, '1.20.120.20-FF-000009', NULL, 'apolipoprotein A-V', 139, NULL, NULL, 117583),
(117584, '2.70.20.30-FF-000001', NULL, 'Matrix protein', 121, NULL, NULL, 117584),
(117585, '3.90.1420.10-FF-000050', NULL, 'Uncharacterized protein', 114, NULL, NULL, 117585);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(117586, '3.30.160.60-FF-003487', NULL, NULL, 21, NULL, NULL, 117586),
(117587, '2.40.50.140-FF-000386', NULL, 'rRNA biogenesis protein RRP5', 90, NULL, NULL, 117587),
(117588, '1.20.58.80-FF-000034', NULL, 'STAM binding protein like 1', 149, NULL, NULL, 117588),
(117589, '3.30.160.60-FF-001778', NULL, 'ras-responsive element-binding protein 1 isoform X1', 30, NULL, NULL, 117589),
(117590, '1.20.1560.10-FF-000752', NULL, 'Uncharacterized protein', 73, NULL, NULL, 117590),
(117591, '1.10.472.80-FF-000071', NULL, 'TBC1 domain family', 103, NULL, NULL, 117591),
(117592, '2.60.40.10-FF-004999', NULL, NULL, 136, NULL, NULL, 117592),
(117593, '2.60.120.650-FF-000176', NULL, 'PHD zinc finger-containing protein', 135, NULL, NULL, 117593),
(117594, '1.10.220.30-FF-000016', NULL, 'Flagellar motor switch protein FliG', 83, NULL, NULL, 117594),
(117595, '1.20.120.350-FF-000034', NULL, 'Sodium leak channel non-selective protein', 124, NULL, NULL, 117595),
(117596, '1.20.1510.10-FF-000075', NULL, NULL, 194, NULL, NULL, 117596),
(117597, '1.10.260.100-FF-000037', NULL, 'Uncharacterized protein', 35, NULL, NULL, 117597),
(117598, '3.40.50.11500-FF-000028', NULL, NULL, 174, NULL, NULL, 117598),
(117599, '1.10.510.10-FF-001185', NULL, 'Protein kinase, putative', 288, NULL, NULL, 117599),
(117600, '1.20.58.90-FF-000037', NULL, NULL, 104, NULL, NULL, 117600),
(117601, '1.10.510.10-FF-000201', NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase', 211, NULL, NULL, 117601),
(117602, '1.20.272.10-FF-000089', NULL, NULL, 115, NULL, NULL, 117602),
(117603, '3.40.50.970-FF-000119', NULL, '2-oxoglutarate dehydrogenase, putative', 368, NULL, NULL, 117603),
(117604, '3.40.910.10-FF-000009', NULL, 'Deoxyhypusine synthase', 192, NULL, NULL, 117604),
(117605, '1.25.40.510-FF-000012', NULL, 'Predicted protein', 134, NULL, NULL, 117605),
(117606, '2.160.20.10-FF-000137', NULL, 'Predicted protein', 349, NULL, NULL, 117606),
(117607, '2.60.40.10-FF-000401', NULL, 'Down syndrome cell adhesion molecule', 91, NULL, NULL, 117607),
(117608, '2.30.30.100-FF-000232', NULL, 'Sm-like protein LSM6A', 48, NULL, NULL, 117608),
(117609, '2.60.120.590-FF-000079', NULL, 'Uncharacterized protein', 211, NULL, NULL, 117609),
(117610, '3.40.1280.10-FF-000123', NULL, 'Similar to LOC495800 protein', 127, NULL, NULL, 117610),
(117611, '1.10.472.10-FF-000359', NULL, 'Cyclin, putative', 225, NULL, NULL, 117611),
(117612, '2.60.120.200-FF-000772', NULL, 'Uncharacterized protein', 56, NULL, NULL, 117612),
(117613, '1.25.40.10-FF-004768', NULL, 'Uncharacterized protein', 204, NULL, NULL, 117613),
(117614, '1.10.150.670-FF-000037', NULL, 'Uncharacterized protein', 63, NULL, NULL, 117614),
(117615, '1.10.3590.10-FF-000003', NULL, 'acid-sensing ion channel 3 isoform X6', 38, NULL, NULL, 117615),
(117616, '1.10.287.70-FF-000547', NULL, 'Uncharacterized protein', 121, NULL, NULL, 117616),
(117617, '3.40.50.2000-FF-000793', NULL, 'Trehalose-6-phosphate synthase/phosphatase', 12, NULL, NULL, 117617),
(117618, '2.10.25.10-FF-000560', NULL, 'Teneurin-m-like Protein', 32, NULL, NULL, 117618),
(117619, '3.40.30.10-FF-000231', NULL, 'Glutathione S-transferase PARB', 89, NULL, NULL, 117619),
(117620, '1.25.40.10-FF-002677', NULL, 'Coatomer epsilon subunit family protein', 274, NULL, NULL, 117620),
(117621, '1.10.510.10-FF-001505', NULL, 'Protein kinase, putative', 258, NULL, NULL, 117621),
(117622, '3.30.200.20-FF-001107', NULL, 'Interleukin-1 receptor-associated kinase 3', 100, NULL, NULL, 117622),
(117623, '3.50.20.20-FF-000002', NULL, 'Sex-regulated protein janus-B', 115, NULL, NULL, 117623),
(117624, '3.30.70.330-FF-003008', NULL, NULL, 81, NULL, NULL, 117624),
(117625, '3.20.20.80-FF-000336', NULL, '1,4-alpha-glucan-branching enzyme 2, chloroplastic/amyloplastic', 264, NULL, NULL, 117625),
(117626, '3.30.470.20-FF-000172', NULL, 'Bifunctional purine synthesis protein purC/E', 141, NULL, NULL, 117626),
(117627, '2.60.40.1820-FF-000010', NULL, 'Predicted protein', 125, NULL, NULL, 117627),
(117628, '3.30.70.1350-FF-000033', NULL, NULL, 81, NULL, NULL, 117628);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(117629, '2.10.10.100-FF-000002', NULL, 'UDP-N-acetylhexosamine pyrophosphorylase-like protein 1', 65, NULL, NULL, 117629),
(117630, '1.20.1070.10-FF-000467', NULL, 'NeuroPeptide Receptor family', 331, NULL, NULL, 117630),
(117631, '3.40.50.620-FF-000453', NULL, 'tRNA-specific 2-thiouridylase MnmA', 229, NULL, NULL, 117631),
(117632, '1.25.10.10-FF-001545', NULL, 'Importin beta, nuclear transport factor, putative', 562, NULL, NULL, 117632),
(117633, '1.20.1560.10-FF-000639', NULL, 'Uncharacterized protein', 173, NULL, NULL, 117633),
(117634, '3.20.110.10-FF-000015', NULL, 'Alpha-mannosidase', 343, NULL, NULL, 117634),
(117635, '3.90.650.10-FF-000068', NULL, 'AGAP002091-PA', 176, NULL, NULL, 117635),
(117636, '1.25.40.10-FF-004392', NULL, 'Uncharacterized protein', 141, NULL, NULL, 117636),
(117637, '3.20.20.70-FF-000333', NULL, 'GTP 3'',8-cyclase 1', 344, NULL, NULL, 117637),
(117638, '1.10.510.10-FF-000578', NULL, 'CAMK family protein kinase', 311, NULL, NULL, 117638),
(117639, '3.40.50.10190-FF-000348', NULL, 'Uncharacterized protein', 121, NULL, NULL, 117639),
(117640, '1.20.1250.20-FF-000984', NULL, 'Solute carrier family 16 member 9', 367, NULL, NULL, 117640),
(117641, '3.10.50.10-FF-000065', NULL, 'Uncharacterized protein', 45, NULL, NULL, 117641),
(117642, '1.10.730.10-FF-000089', NULL, 'Isoleucine--tRNA ligase', 187, NULL, NULL, 117642),
(117643, '3.40.630.30-FF-000421', NULL, 'Uncharacterized protein', 147, NULL, NULL, 117643),
(117644, '3.30.70.330-FF-002935', NULL, NULL, 117, NULL, NULL, 117644),
(117645, '3.30.2090.10-FF-000009', NULL, 'Cation efflux system protein CusA', 89, NULL, NULL, 117645),
(117646, '2.10.25.10-FF-001487', NULL, 'Uncharacterized protein', 37, NULL, NULL, 117646),
(117647, '1.20.1420.30-FF-000107', NULL, 'AGAP010976-PA', 120, NULL, NULL, 117647),
(117648, '1.10.1780.10-FF-000012', NULL, 'ATP-dependent Clp protease regulatory subunit ClpC', 141, NULL, NULL, 117648),
(117649, '3.40.390.10-FF-000109', NULL, 'Matrix metallopeptidase 19', 111, NULL, NULL, 117649),
(117650, '2.130.10.30-FF-000065', NULL, 'NEK (NEver in mitosis Kinase) Like', 346, NULL, NULL, 117650),
(117651, '3.10.20.370-FF-000002', NULL, 'Gag-Pol polyprotein', 72, NULL, NULL, 117651),
(117652, '1.10.8.10-FF-000184', NULL, 'P phosphoprotein', 56, NULL, NULL, 117652),
(117653, '3.40.50.150-FF-000115', NULL, 'Cyclopropane mycolic acid synthase 1', 287, NULL, NULL, 117653),
(117654, '1.20.1730.10-FF-000057', NULL, 'Uncharacterized protein', 497, NULL, NULL, 117654),
(117655, '1.10.418.10-FF-000279', NULL, 'Uncharacterized protein', 110, NULL, NULL, 117655),
(117656, '3.30.70.330-FF-000844', NULL, 'Proteins containing the RNA recognition motif', 90, NULL, NULL, 117656),
(117657, '1.10.640.10-FF-000059', NULL, 'Uncharacterized protein', 217, NULL, NULL, 117657),
(117658, '1.10.8.270-FF-000188', NULL, 'Uncharacterized protein', 126, NULL, NULL, 117658),
(117659, '3.30.160.60-FF-005376', NULL, NULL, 26, NULL, NULL, 117659),
(117660, '3.40.50.150-FF-001043', NULL, NULL, 143, NULL, NULL, 117660),
(117661, '2.20.25.10-FF-000042', NULL, 'Peptide-N(4)-(N-acetyl-beta-glucosaminyl)asparagine amidase', 41, NULL, NULL, 117661),
(117662, '1.20.1280.20-FF-000008', NULL, 'J-type co-chaperone JAC1, mitochondrial', 86, NULL, NULL, 117662),
(117663, '3.40.50.1820-FF-000452', NULL, 'ABHydrolase Domain containing homolog', 258, NULL, NULL, 117663),
(117664, '2.60.40.10-FF-005460', NULL, NULL, 105, NULL, NULL, 117664),
(117665, '3.20.20.220-FF-000011', NULL, 'Proline dehydrogenase', 142, NULL, NULL, 117665),
(117666, '3.40.50.10490-FF-000141', NULL, NULL, 279, NULL, NULL, 117666),
(117667, '3.30.500.10-FF-000020', NULL, 'Orla-UEA*0201 protein', 178, NULL, NULL, 117667),
(117668, '3.80.10.10-FF-003948', NULL, 'Uncharacterized protein', 70, NULL, NULL, 117668),
(117669, '3.40.50.300-FF-001964', NULL, 'Non-structural polyprotein pORF1', 120, NULL, NULL, 117669),
(117670, '1.20.1180.10-FF-000003', NULL, 'Protein ROOT HAIR DEFECTIVE 3 homolog', 57, NULL, NULL, 117670),
(117671, '2.10.109.10-FF-000074', NULL, 'Uncharacterized protein', 107, NULL, NULL, 117671);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(117672, '3.30.60.110-FF-000001', NULL, 'Probable alpha-methylacyl-CoA racemase mcr', 33, NULL, NULL, 117672),
(117673, '3.30.505.10-FF-000003', NULL, 'Signal transducer and activator of transcription', 126, NULL, NULL, 117673),
(117674, '3.40.50.150-FF-001751', NULL, NULL, 253, NULL, NULL, 117674),
(117675, '2.60.40.10-FF-004853', NULL, NULL, 101, NULL, NULL, 117675),
(117676, '3.60.40.10-FF-000124', NULL, 'Adenylate cyclase', 280, NULL, NULL, 117676),
(117677, '1.20.1070.10-FF-000411', NULL, 'Zgc:162592', 289, NULL, NULL, 117677),
(117678, '1.50.40.10-FF-000292', NULL, 'Mitochondrial carrier protein', 134, NULL, NULL, 117678),
(117679, '2.30.42.10-FF-000508', NULL, NULL, 136, NULL, NULL, 117679),
(117680, '1.20.1260.10-FF-000061', NULL, 'Hypothetical membrane protein, conserved, DUF125 family', 150, NULL, NULL, 117680),
(117681, '1.10.287.70-FF-000132', NULL, 'OSMotic avoidance abnormal family member', 136, NULL, NULL, 117681),
(117682, '3.30.1520.10-FF-000116', NULL, 'Uncharacterized protein', 135, NULL, NULL, 117682),
(117683, '1.25.40.20-FF-001376', NULL, 'Uncharacterized protein', 82, NULL, NULL, 117683),
(117684, '2.130.10.10-FF-002150', NULL, 'Predicted protein', 294, NULL, NULL, 117684),
(117685, '3.30.160.60-FF-001632', NULL, 'Uncharacterized protein', 29, NULL, NULL, 117685),
(117686, '1.10.437.10-FF-000025', NULL, 'BCL2 like 13', 159, NULL, NULL, 117686),
(117687, '1.10.1760.20-FF-000014', NULL, 'Pantothenic acid transporter pant', 196, NULL, NULL, 117687),
(117688, '1.20.1250.20-FF-000512', NULL, 'Putative inorganic phosphate cotransporter-like Protein', 226, NULL, NULL, 117688),
(117689, '3.30.420.40-FF-000410', NULL, 'Actin-related protein 5', 29, NULL, NULL, 117689),
(117690, '3.90.190.10-FF-000083', NULL, 'Dual specificity protein phosphatase 12-like', 180, NULL, NULL, 117690),
(117691, '3.30.70.270-FF-000242', NULL, NULL, 62, NULL, NULL, 117691),
(117692, '1.25.10.10-FF-002001', NULL, 'Armadillo-type protein', 250, NULL, NULL, 117692),
(117693, '1.20.1260.10-FF-000004', NULL, 'Ferritin', 164, NULL, NULL, 117693),
(117694, '1.20.1050.10-FF-000292', NULL, 'Uncharacterized protein', 22, NULL, NULL, 117694),
(117695, '1.20.5.170-FF-000217', NULL, 'Uncharacterized protein', 40, NULL, NULL, 117695),
(117696, '1.10.8.1020-FF-000001', NULL, 'RecQ-mediated genome instability protein 1', 59, NULL, NULL, 117696),
(117697, '2.40.30.20-FF-000040', NULL, 'Uncharacterized protein', 37, NULL, NULL, 117697),
(117698, '3.10.250.10-FF-000140', NULL, NULL, 61, NULL, NULL, 117698),
(117699, '1.10.630.10-FF-000143', NULL, 'Cytochrome P450 714D1', 484, NULL, NULL, 117699),
(117700, '1.10.10.10-FF-001326', NULL, 'ADP-dependent DNA helicase RecQ', 131, NULL, NULL, 117700),
(117701, '3.10.580.10-FF-000125', NULL, 'Two-component sensor histidine kinase', 121, NULL, NULL, 117701),
(117702, '1.25.40.10-FF-001373', NULL, 'Tetratricopeptide repeat domain 26', 127, NULL, NULL, 117702),
(117703, '2.60.40.10-FF-001565', NULL, 'Immunoglobulin superfamily member 22', 102, NULL, NULL, 117703),
(117704, '3.40.50.720-FF-000657', NULL, '4-hydroxy-tetrahydrodipicolinate reductase', 147, NULL, NULL, 117704),
(117705, '1.10.10.160-FF-000035', NULL, 'DNA helicase', 81, NULL, NULL, 117705),
(117706, '3.40.800.20-FF-000010', NULL, 'Histone deacetylase', 378, NULL, NULL, 117706),
(117707, '3.10.400.20-FF-000031', NULL, 'Predicted protein', 78, NULL, NULL, 117707),
(117708, '3.40.50.880-FF-000188', NULL, 'Carbamoyl-phosphate synthase small chain', 211, NULL, NULL, 117708),
(117709, '1.10.510.10-FF-001449', NULL, 'Protein kinase, putative', 258, NULL, NULL, 117709),
(117710, '2.20.25.190-FF-000003', NULL, 'Transcription elongation factor 1 homolog', 66, NULL, NULL, 117710),
(117711, '3.40.1620.60-FF-000013', NULL, NULL, 71, NULL, NULL, 117711),
(117712, '3.30.160.60-FF-003723', NULL, NULL, 26, NULL, NULL, 117712),
(117713, '1.10.1370.10-FF-000054', NULL, 'Uncharacterized protein', 24, NULL, NULL, 117713),
(117714, '3.90.640.10-FF-000152', NULL, 'Uncharacterized protein', 22, NULL, NULL, 117714),
(117715, '3.30.2070.10-FF-000008', NULL, 'Molybdopterin oxidoreductase', 64, NULL, NULL, 117715);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(117716, '3.60.40.10-FF-000034', NULL, 'PAS domain S-box protein', 221, NULL, NULL, 117716),
(117717, '3.30.960.10-FF-000009', NULL, 'Heat shock protein family A (Hsp70) member 9', 70, NULL, NULL, 117717),
(117718, '2.60.40.10-FF-005836', NULL, NULL, 109, NULL, NULL, 117718),
(117719, '2.130.10.10-FF-004977', NULL, 'Uncharacterized protein', 82, NULL, NULL, 117719),
(117720, '3.20.20.300-FF-000058', NULL, NULL, 314, NULL, NULL, 117720),
(117721, '3.30.1360.10-FF-000019', NULL, 'DNA-directed RNA polymerase-like protein', 117, NULL, NULL, 117721),
(117722, '3.30.160.60-FF-005319', NULL, NULL, 78, NULL, NULL, 117722),
(117723, '3.90.1860.10-FF-000010', NULL, 'tRNA-splicing ligase RtcB', 156, NULL, NULL, 117723),
(117724, '3.80.10.10-FF-000661', NULL, 'Extracellular matrix protein 2', 149, NULL, NULL, 117724),
(117725, '3.50.50.60-FF-000786', NULL, 'Uncharacterized protein', 218, NULL, NULL, 117725),
(117726, '3.90.190.10-FF-000370', NULL, 'Protein tyrosine phosphatase', 202, NULL, NULL, 117726),
(117727, '1.20.1250.20-FF-002277', NULL, 'Uncharacterized protein', 93, NULL, NULL, 117727),
(117728, '1.20.1070.10-FF-002176', NULL, 'Uncharacterized protein', 113, NULL, NULL, 117728),
(117729, '1.10.510.10-FF-004001', NULL, NULL, 158, NULL, NULL, 117729),
(117730, '2.130.10.10-FF-004269', NULL, 'Uncharacterized protein', 131, NULL, NULL, 117730),
(117731, '3.50.50.60-FF-000729', NULL, 'FAD dependent oxidoreductase', 97, NULL, NULL, 117731),
(117732, '3.90.190.10-FF-000313', NULL, 'Predicted protein', 203, NULL, NULL, 117732),
(117733, '1.20.1280.50-FF-000023', NULL, 'F-box/LRR-repeat protein 4', 40, NULL, NULL, 117733),
(117734, '2.130.10.10-FF-001543', NULL, 'Dug2p', 232, NULL, NULL, 117734),
(117735, '3.20.20.140-FF-000285', NULL, 'Histidinol-phosphatase', 279, NULL, NULL, 117735),
(117736, '1.10.3080.10-FF-000010', NULL, 'Voltage-gated ClC-type chloride channel ClcB', 417, NULL, NULL, 117736),
(117737, '2.120.10.30-FF-000296', NULL, 'Uncharacterized protein', 181, NULL, NULL, 117737),
(117738, '3.40.50.300-FF-000183', NULL, 'ABC transporter ATP-binding protein yjjK', 270, NULL, NULL, 117738),
(117739, '3.30.70.330-FF-001210', NULL, 'AGAP002655-PA', 76, NULL, NULL, 117739),
(117740, '3.40.50.850-FF-000027', NULL, 'Uncharacterized protein', 139, NULL, NULL, 117740),
(117741, '2.60.120.260-FF-000475', NULL, 'Anaphase-promoting complex subunit 10', 171, NULL, NULL, 117741),
(117742, '1.20.920.10-FF-000163', NULL, 'Uncharacterized protein', 118, NULL, NULL, 117742),
(117743, '1.10.8.60-FF-000148', NULL, 'Putative ATPase, AAA family', 70, NULL, NULL, 117743),
(117744, '3.30.420.10-FF-000452', NULL, 'Target of EGR1 protein 1', 321, NULL, NULL, 117744),
(117745, '3.80.10.10-FF-000604', NULL, 'Si:ch211-156p11.1', 174, NULL, NULL, 117745),
(117746, '2.40.50.140-FF-000908', NULL, NULL, 149, NULL, NULL, 117746),
(117747, '3.40.50.2000-FF-001102', NULL, 'Glycosyltransferase', 45, NULL, NULL, 117747),
(117748, '3.40.50.1260-FF-000003', NULL, 'Phosphoglycerate kinase', 190, NULL, NULL, 117748),
(117749, '1.20.920.10-FF-000106', NULL, 'Bromodomain', 136, NULL, NULL, 117749),
(117750, '2.10.25.10-FF-000267', NULL, 'pro-neuregulin-3, membrane-bound isoform', 50, NULL, NULL, 117750),
(117751, '3.40.630.10-FF-000499', NULL, 'Aspartyl aminopeptidase', 37, NULL, NULL, 117751),
(117752, '4.10.240.10-FF-000040', NULL, 'CEP3p kinetochore protein', 58, NULL, NULL, 117752),
(117753, '3.30.160.60-FF-005522', NULL, NULL, 24, NULL, NULL, 117753),
(117754, '4.10.280.10-FF-000014', NULL, 'Max dimerization protein 1', 80, NULL, NULL, 117754),
(117755, '3.40.50.150-FF-001189', NULL, NULL, 180, NULL, NULL, 117755),
(117756, '2.60.200.40-FF-000043', NULL, 'Sphingosine kinase 2', 199, NULL, NULL, 117756),
(117757, '3.40.50.300-FF-007473', NULL, 'Uncharacterized protein', 315, NULL, NULL, 117757),
(117758, '4.10.900.10-FF-000006', NULL, 'Cadherin-9 preproprotein', 97, NULL, NULL, 117758),
(117759, '1.10.10.200-FF-000013', NULL, 'Uncharacterized protein', 54, NULL, NULL, 117759),
(117760, '3.30.160.60-FF-000143', NULL, 'Zinc finger protein 521', 55, NULL, NULL, 117760);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(117761, '3.80.10.10-FF-000458', NULL, 'Leucine rich repeat containing 57', 119, NULL, NULL, 117761),
(117762, '3.50.50.60-FF-000168', NULL, 'Probable sarcosine oxidase', 163, NULL, NULL, 117762),
(117763, '2.40.50.140-FF-001167', NULL, NULL, 62, NULL, NULL, 117763),
(117764, '2.40.50.140-FF-001223', NULL, NULL, 62, NULL, NULL, 117764),
(117765, '1.20.1280.180-FF-000003', NULL, 'Uncharacterized protein', 44, NULL, NULL, 117765),
(117766, '3.30.760.10-FF-000090', NULL, 'Predicted protein', 117, NULL, NULL, 117766),
(117767, '1.25.40.10-FF-005116', NULL, 'Pentatricopeptide (PPR) repeat-containing protein-like', 114, NULL, NULL, 117767),
(117768, '3.40.1190.20-FF-000012', NULL, 'Ribokinase', 307, NULL, NULL, 117768),
(117769, '3.30.9.10-FF-000305', NULL, 'Uncharacterized protein', 105, NULL, NULL, 117769),
(117770, '2.60.200.30-FF-000040', NULL, 'Uncharacterized kinase C24B10.02c', 144, NULL, NULL, 117770),
(117771, '3.20.20.80-FF-000156', NULL, 'Chitinase', 288, NULL, NULL, 117771),
(117772, '1.25.10.10-FF-000489', NULL, 'Armadillo repeat containing 8', 162, NULL, NULL, 117772),
(117773, '1.10.10.10-FF-001365', NULL, 'DNA-binding SARP family transcriptional activator', 96, NULL, NULL, 117773),
(117774, '3.40.50.300-FF-003673', NULL, 'Dynein heavy chain family protein', 154, NULL, NULL, 117774),
(117775, '1.25.40.20-FF-001522', NULL, 'Kinase, NEK', 133, NULL, NULL, 117775),
(117776, '2.60.120.200-FF-000064', NULL, 'Laminin subunit alpha 4', 164, NULL, NULL, 117776),
(117777, '3.40.1810.10-FF-000001', NULL, 'Myocyte-specific enhancer factor 2A homolog', 83, NULL, NULL, 117777),
(117778, '3.80.10.10-FF-004443', NULL, 'MDIS1-interacting receptor like kinase 2', 121, NULL, NULL, 117778),
(117779, '3.90.190.10-FF-000403', NULL, 'Uncharacterized protein', 186, NULL, NULL, 117779),
(117780, '2.40.50.100-FF-000222', NULL, 'Uncharacterized protein', 73, NULL, NULL, 117780),
(117781, '3.80.10.10-FF-004258', NULL, 'Uncharacterized protein', 66, NULL, NULL, 117781),
(117782, '3.30.420.10-FF-000339', NULL, 'AGAP007399-PA', 238, NULL, NULL, 117782),
(117783, '2.60.40.10-FF-003420', NULL, NULL, 108, NULL, NULL, 117783),
(117784, '2.30.30.140-FF-000305', NULL, 'Uncharacterized protein', 71, NULL, NULL, 117784),
(117785, '1.20.1070.10-FF-000557', NULL, 'Melatonin receptor type 1A', 152, NULL, NULL, 117785),
(117786, '1.10.555.10-FF-000131', NULL, 'Chromosome 16, whole genome shotgun sequence', 168, NULL, NULL, 117786),
(117787, '1.25.40.10-FF-001334', NULL, 'OSJNBa0041A02.15 protein', 160, NULL, NULL, 117787),
(117788, '3.40.50.360-FF-000032', NULL, 'Bifunctional cytochrome P450/NADPH--P450 reductase', 180, NULL, NULL, 117788),
(117789, '2.130.10.30-FF-000155', NULL, NULL, 151, NULL, NULL, 117789),
(117790, '1.20.1250.20-FF-000366', NULL, 'Sucrose transport protein SUT5', 221, NULL, NULL, 117790),
(117791, '3.40.50.2300-FF-000905', NULL, NULL, 143, NULL, NULL, 117791),
(117792, '2.60.40.340-FF-000012', NULL, 'RELA proto-oncogene, NF-kB subunit', 126, NULL, NULL, 117792),
(117793, '3.40.50.720-FF-002192', NULL, 'Uncharacterized protein', 334, NULL, NULL, 117793),
(117794, '3.10.310.10-FF-000049', NULL, 'Predicted protein', 170, NULL, NULL, 117794),
(117795, '1.10.510.10-FF-003074', NULL, NULL, 203, NULL, NULL, 117795),
(117796, '1.10.287.1700-FF-000004', NULL, 'Flagellar export protein FliJ', 145, NULL, NULL, 117796),
(117797, '3.90.850.10-FF-000049', NULL, NULL, 170, NULL, NULL, 117797),
(117798, '1.10.340.30-FF-000048', NULL, 'Endonuclease III-like protein 1', 67, NULL, NULL, 117798),
(117799, '3.30.1140.32-FF-000005', NULL, '40S ribosomal protein S3', 129, NULL, NULL, 117799),
(117800, '2.40.40.20-FF-000012', NULL, 'Vesicle-fusing ATPase protein', 83, NULL, NULL, 117800),
(117801, '2.60.40.10-FF-003217', NULL, 'Uncharacterized protein', 123, NULL, NULL, 117801),
(117802, '3.30.70.660-FF-000033', NULL, 'tRNA pseudouridine synthase A', 136, NULL, NULL, 117802),
(117803, '2.10.70.10-FF-000102', NULL, 'Sushi domain containing 3', 65, NULL, NULL, 117803),
(117804, '3.90.1150.10-FF-000271', NULL, 'Glycine cleavage system P protein', 96, NULL, NULL, 117804);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(117805, '1.25.40.660-FF-000006', NULL, 'Vacuolar protein sorting-associated protein 35', 252, NULL, NULL, 117805),
(117806, '1.10.1220.10-FF-000009', NULL, 'Antitoxin EndoAI', 93, NULL, NULL, 117806),
(117807, '2.60.120.620-FF-000105', NULL, 'Os03g0166100 protein', 183, NULL, NULL, 117807),
(117808, '1.10.390.10-FF-000045', NULL, 'Aminopeptidase', 207, NULL, NULL, 117808),
(117809, '3.10.290.10-FF-000024', NULL, 'RNA pseudouridine synthase 2 chloroplastic', 71, NULL, NULL, 117809),
(117810, '1.20.1740.10-FF-000086', NULL, 'Amino acid transporter, putative', 516, NULL, NULL, 117810),
(117811, '1.20.1250.20-FF-000276', NULL, 'Sugar transporter family protein', 229, NULL, NULL, 117811),
(117812, '1.20.5.420-FF-000017', NULL, 'Maltose/maltodextrin-binding periplasmic protein', 32, NULL, NULL, 117812),
(117813, '2.30.29.110-FF-000002', NULL, 'Type II inositol 1,4,5-trisphosphate 5-phosphatase', 156, NULL, NULL, 117813),
(117814, '1.10.510.10-FF-001562', NULL, 'Predicted protein', 189, NULL, NULL, 117814),
(117815, '2.60.120.620-FF-000015', NULL, 'Prolyl 4-hydroxylase 1', 202, NULL, NULL, 117815),
(117816, '3.30.300.10-FF-000033', NULL, 'S-adenosylmethionine synthase', 68, NULL, NULL, 117816),
(117817, '1.25.40.650-FF-000003', NULL, 'Penicillin-binding protein activator', 103, NULL, NULL, 117817),
(117818, '3.30.160.60-FF-001722', NULL, 'Zinc finger protein 155', 28, NULL, NULL, 117818),
(117819, '1.10.490.30-FF-000002', NULL, 'Colicin-E1', 186, NULL, NULL, 117819),
(117820, '3.40.190.10-FF-000364', NULL, 'Si:dkey-183j2.10', 133, NULL, NULL, 117820),
(117821, '1.10.238.20-FF-000009', NULL, 'AGAP012321-PA', 117, NULL, NULL, 117821),
(117822, '1.25.10.10-FF-000202', NULL, 'HEAT repeat-containing protein 5B isoform X1', 263, NULL, NULL, 117822),
(117823, '3.40.225.10-FF-000058', NULL, NULL, 258, NULL, NULL, 117823),
(117824, '3.30.40.10-FF-000962', NULL, 'Uncharacterized protein', 56, NULL, NULL, 117824),
(117825, '2.60.120.200-FF-000154', NULL, 'Tyrosine-protein kinase receptor', 177, NULL, NULL, 117825),
(117826, '3.10.129.10-FF-000178', NULL, 'Bifunctional 3-hydroxyacyl-CoA dehydrogenase/thioesterase', 140, NULL, NULL, 117826),
(117827, '1.20.58.60-FF-000438', NULL, 'Nesprin-1', 139, NULL, NULL, 117827),
(117828, '3.40.50.2300-FF-001310', NULL, NULL, 119, NULL, NULL, 117828),
(117829, '3.30.70.330-FF-002227', NULL, NULL, 90, NULL, NULL, 117829),
(117830, '1.20.1560.10-FF-000134', NULL, 'ABC transporter transmembrane region', 334, NULL, NULL, 117830),
(117831, '1.10.238.10-FF-000006', NULL, 'Calmodulin 1', 74, NULL, NULL, 117831),
(117832, '2.60.40.60-FF-000568', NULL, 'Uncharacterized protein', 108, NULL, NULL, 117832),
(117833, '3.40.50.12780-FF-000092', NULL, 'Solute carrier family 27 member 4', 201, NULL, NULL, 117833),
(117834, '1.25.40.10-FF-002823', NULL, 'Sll0837 protein', 149, NULL, NULL, 117834),
(117835, '4.10.60.10-FF-000198', NULL, 'Cold shock domain-containing protein 4', 24, NULL, NULL, 117835),
(117836, '3.30.300.20-FF-000036', NULL, 'GTPase Der', 83, NULL, NULL, 117836),
(117837, '3.80.10.10-FF-002313', NULL, 'AGAP001470-PA', 168, NULL, NULL, 117837),
(117838, '1.10.510.10-FF-003692', NULL, NULL, 168, NULL, NULL, 117838),
(117839, '2.60.220.50-FF-000086', NULL, 'SET domain-containing protein', 183, NULL, NULL, 117839),
(117840, '2.60.40.10-FF-003835', NULL, NULL, 111, NULL, NULL, 117840),
(117841, '3.30.300.30-FF-000039', NULL, 'Benzoate-CoA ligase family', 97, NULL, NULL, 117841),
(117842, '1.20.1270.60-FF-000295', NULL, 'ArfGAP with SH3 domain, ankyrin repeat and PH domain 3', 143, NULL, NULL, 117842),
(117843, '1.10.10.800-FF-000007', NULL, 'Alpha/Beta hydrolase protein', 88, NULL, NULL, 117843),
(117844, '3.90.640.10-FF-000191', NULL, 'Protein-vacuolar targeting-related protein, putative', 65, NULL, NULL, 117844),
(117845, '3.30.499.10-FF-000009', NULL, 'Aconitate hydratase', 235, NULL, NULL, 117845),
(117846, '2.40.30.260-FF-000002', NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme GidA', 68, NULL, NULL, 117846),
(117847, '2.70.160.11-FF-000079', NULL, 'Protein arginine N-methyltransferase PRMT1, putative', 120, NULL, NULL, 117847);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(117848, '3.80.10.10-FF-000548', NULL, 'Receptor-like protein kinase HSL1', 158, NULL, NULL, 117848),
(117849, '1.10.287.70-FF-000076', NULL, 'Potassium channel subfamily K member', 278, NULL, NULL, 117849),
(117850, '1.20.1270.10-FF-000033', NULL, 'heat shock 70 kDa protein 6', 103, NULL, NULL, 117850),
(117851, '1.20.58.60-FF-000495', NULL, 'Uncharacterized protein, isoform B', 271, NULL, NULL, 117851),
(117852, '2.102.10.10-FF-000004', NULL, '3-phenylpropionate/cinnamic acid dioxygenase subunit alpha', 130, NULL, NULL, 117852),
(117853, '1.25.40.120-FF-000075', NULL, 'Uncharacterized protein', 73, NULL, NULL, 117853),
(117854, '1.10.101.10-FF-000026', NULL, 'Lytic transglycosylase', 67, NULL, NULL, 117854),
(117855, '1.25.10.10-FF-001506', NULL, 'Sorting Of Apical Proteins', 262, NULL, NULL, 117855),
(117856, '3.80.10.10-FF-000368', NULL, 'Chondroadherin like', 188, NULL, NULL, 117856),
(117857, '3.30.230.10-FF-000095', NULL, 'DNA topoisomerase 2', 182, NULL, NULL, 117857),
(117858, '2.60.40.1930-FF-000037', NULL, 'Complement component C5', 28, NULL, NULL, 117858),
(117859, '3.30.70.260-FF-000036', NULL, 'D-3-phosphoglycerate dehydrogenase', 86, NULL, NULL, 117859),
(117860, '3.30.160.60-FF-005432', NULL, NULL, 33, NULL, NULL, 117860),
(117861, '1.10.287.130-FF-000184', NULL, 'Sensor histidine kinase', 66, NULL, NULL, 117861),
(117862, '3.40.630.30-FF-000185', NULL, 'YDR391C-like protein', 180, NULL, NULL, 117862),
(117863, '4.10.280.10-FF-000104', NULL, 'Transcription factor bHLH34', 59, NULL, NULL, 117863),
(117864, '3.40.50.300-FF-003763', NULL, 'Nethylmaleimide sensitive fusion family protein', 104, NULL, NULL, 117864),
(117865, '1.25.40.10-FF-000968', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 162, NULL, NULL, 117865),
(117866, '3.40.50.1820-FF-000396', NULL, 'Acyl-protein thioesterase', 222, NULL, NULL, 117866),
(117867, '3.20.20.70-FF-000187', NULL, 'Fructose-bisphosphate aldolase', 358, NULL, NULL, 117867),
(117868, '3.40.50.150-FF-001099', NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', 332, NULL, NULL, 117868),
(117869, '3.40.50.1760-FF-000024', NULL, NULL, 138, NULL, NULL, 117869),
(117870, '2.60.40.10-FF-003925', NULL, NULL, 107, NULL, NULL, 117870),
(117871, '3.10.129.10-FF-000268', NULL, 'Uncharacterized protein', 159, NULL, NULL, 117871),
(117872, '3.40.140.70-FF-000007', NULL, 'Putative ubiquitin activating e1 enzyme-like protein', 168, NULL, NULL, 117872),
(117873, '1.25.40.10-FF-005173', NULL, 'Uncharacterized protein', 66, NULL, NULL, 117873),
(117874, '1.20.58.390-FF-000232', NULL, 'Uncharacterized protein', 123, NULL, NULL, 117874),
(117875, '2.60.120.330-FF-000142', NULL, 'Putative 2-oxoglutarate-dependent dioxygenase DIN11', 106, NULL, NULL, 117875),
(117876, '3.80.10.10-FF-002403', NULL, 'PH domain and leucine-rich repeat protein phosphatase 1', 156, NULL, NULL, 117876),
(117877, '2.60.120.590-FF-000080', NULL, 'AGAP000155-PA', 210, NULL, NULL, 117877),
(117878, '3.40.50.300-FF-007416', NULL, 'p-GlycoProtein related', 22, NULL, NULL, 117878),
(117879, '1.10.287.660-FF-000022', NULL, 'Uncharacterized protein', 79, NULL, NULL, 117879),
(117880, '1.10.150.560-FF-000004', NULL, 'Major DNA-binding protein', 97, NULL, NULL, 117880),
(117881, '3.30.70.270-FF-000039', NULL, 'Paternally expressed 10', 19, NULL, NULL, 117881),
(117882, '1.10.150.550-FF-000001', NULL, 'Nucleoprotein', 77, NULL, NULL, 117882),
(117883, '3.40.710.10-FF-000028', NULL, 'Penicillin-binding protein 1A', 378, NULL, NULL, 117883),
(117884, '2.60.40.10-FF-003274', NULL, 'Leucine-rich repeat-containing 24', 103, NULL, NULL, 117884),
(117885, '3.40.50.720-FF-000803', NULL, 'UDP-galactopyranose mutase', 116, NULL, NULL, 117885),
(117886, '3.40.250.10-FF-000133', NULL, 'M-phase inducer phosphatase, putative', 175, NULL, NULL, 117886),
(117887, '3.40.50.1220-FF-000126', NULL, 'Uncharacterized protein', 113, NULL, NULL, 117887),
(117888, '2.40.50.140-FF-000296', NULL, 'Putative DNA helicase MCM8', 82, NULL, NULL, 117888),
(117889, '1.10.287.130-FF-000217', NULL, 'Sensor histidine kinase, NtrB-related protein', 56, NULL, NULL, 117889);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(117890, '3.40.50.720-FF-000713', NULL, 'Short-chain type dehydrogenase/reductase', 278, NULL, NULL, 117890),
(117891, '3.30.70.330-FF-002755', NULL, NULL, 83, NULL, NULL, 117891),
(117892, '1.20.1270.60-FF-000328', NULL, 'Uncharacterized protein', 202, NULL, NULL, 117892),
(117893, '3.30.70.330-FF-002845', NULL, NULL, 137, NULL, NULL, 117893),
(117894, '1.20.930.60-FF-000009', NULL, 'Uncharacterized protein', 123, NULL, NULL, 117894),
(117895, '2.30.30.30-FF-000094', NULL, 'Transcription termination/antitermination protein NusG', 62, NULL, NULL, 117895),
(117896, '2.170.120.40-FF-000010', NULL, 'Putative exported protein', 87, NULL, NULL, 117896),
(117897, '1.20.120.230-FF-000049', NULL, 'breast cancer anti-estrogen resistance protein 1', 135, NULL, NULL, 117897),
(117898, '1.10.287.70-FF-000019', NULL, 'G protein-activated inward rectifier potassium channel 1', 130, NULL, NULL, 117898),
(117899, '3.40.250.10-FF-000043', NULL, 'Sulfurtransferase', 152, NULL, NULL, 117899),
(117900, '3.30.590.10-FF-000054', NULL, 'Arginine kinase, putative', 47, NULL, NULL, 117900),
(117901, '1.25.10.10-FF-000112', NULL, 'Kinesin associated protein 3', 463, NULL, NULL, 117901),
(117902, '3.10.20.870-FF-000023', NULL, NULL, 75, NULL, NULL, 117902),
(117903, '2.160.10.10-FF-000075', NULL, 'Putative nonribosomal peptide synthetase', 119, NULL, NULL, 117903),
(117904, '1.10.287.130-FF-000127', NULL, 'Two-component sensor histidine kinase', 70, NULL, NULL, 117904),
(117905, '2.102.10.10-FF-000061', NULL, 'Non-heme iron oxygenase ferredoxin subunit', 106, NULL, NULL, 117905),
(117906, '3.30.40.10-FF-001182', NULL, 'Uncharacterized protein', 82, NULL, NULL, 117906),
(117907, '2.60.34.10-FF-000073', NULL, 'Uncharacterized protein', 177, NULL, NULL, 117907),
(117908, '2.60.40.10-FF-004201', NULL, NULL, 81, NULL, NULL, 117908),
(117909, '3.40.50.2300-FF-000815', NULL, NULL, 92, NULL, NULL, 117909),
(117910, '1.20.58.60-FF-000348', NULL, 'Nesprin-2', 111, NULL, NULL, 117910),
(117911, '3.40.710.10-FF-000180', NULL, 'Multimodular transpeptidase-transglycosylase PBP 1A', 333, NULL, NULL, 117911),
(117912, '2.10.25.10-FF-000413', NULL, 'Crumbs cell polarity complex component 1', 39, NULL, NULL, 117912),
(117913, '1.10.472.80-FF-000161', NULL, NULL, 141, NULL, NULL, 117913),
(117914, '3.30.70.260-FF-000183', NULL, 'Chorismate mutase/prephenate dehydratase (P-protein)', 84, NULL, NULL, 117914),
(117915, '3.30.200.20-FF-000944', NULL, 'Leucine-rich repeat protein kinase family protein', 101, NULL, NULL, 117915),
(117916, '3.30.1370.30-FF-000003', NULL, '30S ribosomal protein S8', 71, NULL, NULL, 117916),
(117917, '3.30.160.60-FF-003577', NULL, 'Zinc finger protein 770', 30, NULL, NULL, 117917),
(117918, '1.10.238.160-FF-000003', NULL, 'DNA-binding transcriptional activator AlpA', 60, NULL, NULL, 117918),
(117919, '3.10.20.90-FF-000154', NULL, 'Large proline-rich protein BAG6', 94, NULL, NULL, 117919),
(117920, '1.10.1410.10-FF-000024', NULL, 'Uncharacterized protein', 79, NULL, NULL, 117920),
(117921, '1.20.5.710-FF-000019', NULL, '50S ribosomal protein L7/L12', 49, NULL, NULL, 117921),
(117922, '1.10.1000.11-FF-000011', NULL, 'Gluconokinase', 119, NULL, NULL, 117922),
(117923, '3.40.50.2300-FF-000872', NULL, NULL, 127, NULL, NULL, 117923),
(117924, '2.30.30.40-FF-000658', NULL, 'Predicted protein', 67, NULL, NULL, 117924),
(117925, '2.60.120.200-FF-000625', NULL, 'Putative L-type lectin-domain containing receptor kinase V.8', 132, NULL, NULL, 117925),
(117926, '3.10.590.10-FF-000007', NULL, 'YDR374C-like protein', 176, NULL, NULL, 117926),
(117927, '2.60.40.10-FF-003364', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF b', 93, NULL, NULL, 117927),
(117928, '2.60.420.10-FF-000011', NULL, 'Glycoside hydrolase family 65 protein', 51, NULL, NULL, 117928),
(117929, '3.30.70.270-FF-000186', NULL, 'Bifunctional diguanylate cyclase/phosphodiesterase', 160, NULL, NULL, 117929),
(117930, '1.20.5.1200-FF-000007', NULL, 'Retinaldehyde binding protein 1b', 15, NULL, NULL, 117930),
(117931, '3.30.565.10-FF-000220', NULL, 'Molecular chaperone/ Grp94/Hsp90', 252, NULL, NULL, 117931);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(117932, '3.90.550.10-FF-000122', NULL, 'Dolichol-phosphate mannosyltransferase subunit 1', 247, NULL, NULL, 117932),
(117933, '1.10.1240.10-FF-000011', NULL, 'Methanosarcina family methyltransferase cognate corrinoid protein', 95, NULL, NULL, 117933),
(117934, '3.40.50.1820-FF-001323', NULL, 'Uncharacterized protein', 258, NULL, NULL, 117934),
(117935, '3.30.460.10-FF-000050', NULL, 'DNA polymerase POL4', 120, NULL, NULL, 117935),
(117936, '2.60.120.200-FF-000682', NULL, 'Uncharacterized protein', 214, NULL, NULL, 117936),
(117937, '2.60.470.10-FF-000014', NULL, 'Amiloride-sensitive sodium channel subunit beta-2', 186, NULL, NULL, 117937),
(117938, '2.20.110.10-FF-000053', NULL, NULL, 65, NULL, NULL, 117938),
(117939, '4.10.240.10-FF-000124', NULL, 'C6 finger domain transcription factor gliZ', 91, NULL, NULL, 117939),
(117940, '1.20.1600.10-FF-000014', NULL, 'Alkaline protease secretion protein AprF', 421, NULL, NULL, 117940),
(117941, '1.10.238.270-FF-000008', NULL, 'GD25818', 180, NULL, NULL, 117941),
(117942, '1.10.238.260-FF-000005', NULL, 'Putative homocitrate synthase AksA', 114, NULL, NULL, 117942),
(117943, '2.130.10.30-FF-000037', NULL, 'Inhibitor of Bruton tyrosine kinase', 259, NULL, NULL, 117943),
(117944, '3.40.50.300-FF-007411', NULL, 'Uncharacterized protein', 80, NULL, NULL, 117944),
(117945, '3.90.79.20-FF-000001', NULL, 'NADH pyrophosphatase', 125, NULL, NULL, 117945),
(117946, '2.30.42.10-FF-000418', NULL, NULL, 56, NULL, NULL, 117946),
(117947, '3.20.20.70-FF-000041', NULL, 'Fructose-bisphosphate aldolase class I', 310, NULL, NULL, 117947),
(117948, '1.20.272.10-FF-000010', NULL, 'Replication factor C subunit 4', 91, NULL, NULL, 117948),
(117949, '1.20.120.1530-FF-000002', NULL, 'Two-component osmosensing histidine kinase', 115, NULL, NULL, 117949),
(117950, '2.130.10.10-FF-000031', NULL, 'Splicing factor 3b subunit 3', 329, NULL, NULL, 117950),
(117951, '1.20.1740.10-FF-000119', NULL, 'Solute carrier family 7 member 7', 313, NULL, NULL, 117951),
(117952, '1.10.640.10-FF-000093', NULL, 'Uncharacterized protein', 604, NULL, NULL, 117952),
(117953, '1.25.40.10-FF-002975', NULL, 'Uncharacterized protein', 310, NULL, NULL, 117953),
(117954, '1.20.1720.10-FF-000080', NULL, NULL, 142, NULL, NULL, 117954),
(117955, '1.25.10.10-FF-001950', NULL, 'Serine/threonine-protein kinase TOR', 277, NULL, NULL, 117955),
(117956, '3.90.190.10-FF-000318', NULL, 'Probable protein tyrosine phosphatase type IVA B', 157, NULL, NULL, 117956),
(117957, '3.20.20.80-FF-000044', NULL, 'Chitinase III C10701-rice', 271, NULL, NULL, 117957),
(117958, '3.40.850.10-FF-000544', NULL, 'Kinesin-like protein', 245, NULL, NULL, 117958),
(117959, '3.30.720.200-FF-000009', NULL, 'Glycine--tRNA ligase', 58, NULL, NULL, 117959),
(117960, '2.130.10.10-FF-005932', NULL, 'Neurobeachin/beige protein, putative', 264, NULL, NULL, 117960),
(117961, '3.50.50.60-FF-000286', NULL, 'Malate:quinone oxidoreductase, putative', 173, NULL, NULL, 117961),
(117962, '1.25.40.20-FF-000887', NULL, 'Uncharacterized protein', 163, NULL, NULL, 117962),
(117963, '3.30.1370.120-FF-000021', NULL, 'General secretion pathway protein D', 70, NULL, NULL, 117963),
(117964, '1.25.40.20-FF-001404', NULL, 'Uncharacterized protein', 160, NULL, NULL, 117964),
(117965, '2.60.40.10-FF-005275', NULL, NULL, 85, NULL, NULL, 117965),
(117966, '3.40.33.10-FF-000024', NULL, 'Protein CBG17169', 161, NULL, NULL, 117966),
(117967, '3.40.50.12780-FF-000232', NULL, 'Uncharacterized protein C56F8.02', 170, NULL, NULL, 117967),
(117968, '3.30.70.270-FF-000247', NULL, NULL, 59, NULL, NULL, 117968),
(117969, '1.25.10.10-FF-003018', NULL, 'Predicted protein', 329, NULL, NULL, 117969),
(117970, '3.40.850.10-FF-000482', NULL, 'Predicted protein', 333, NULL, NULL, 117970),
(117971, '3.30.160.60-FF-003307', NULL, 'KAISO-like zinc finger protein', 72, NULL, NULL, 117971),
(117972, '3.80.10.10-FF-004325', NULL, 'Uncharacterized protein', 203, NULL, NULL, 117972),
(117973, '3.40.50.12660-FF-000016', NULL, NULL, 141, NULL, NULL, 117973),
(117974, '3.30.160.20-FF-000070', NULL, 'Related to MRF1-peptide chain release factor, mitochondrial', 91, NULL, NULL, 117974);
INSERT INTO "PUBLIC"."MODEL" VALUES
(117975, '2.120.10.30-FF-000178', NULL, 'Gluconolactonase', 310, NULL, NULL, 117975),
(117976, '1.10.510.10-FF-003186', NULL, NULL, 153, NULL, NULL, 117976),
(117977, '1.20.1250.10-FF-000116', NULL, NULL, 157, NULL, NULL, 117977),
(117978, '1.10.630.10-FF-000553', NULL, 'Uncharacterized protein', 338, NULL, NULL, 117978),
(117979, '1.20.1070.10-FF-000377', NULL, 'DOPamine receptor', 266, NULL, NULL, 117979),
(117980, '1.10.8.60-FF-000058', NULL, 'Cell division control protein', 109, NULL, NULL, 117980),
(117981, '1.50.10.20-FF-000080', NULL, 'Mannan endo-1,6-alpha-mannosidase', 360, NULL, NULL, 117981),
(117982, '2.40.50.140-FF-000740', NULL, 'Interferon-activable protein 202', 94, NULL, NULL, 117982),
(117983, '3.30.70.3170-FF-000005', NULL, 'Ribosomal protein S5 domain 2-type protein', 80, NULL, NULL, 117983),
(117984, '3.40.50.12650-FF-000013', NULL, 'MoRTal germline', 124, NULL, NULL, 117984),
(117985, '3.40.20.10-FF-000106', NULL, 'Hypothetical_protein_-_conserved', 130, NULL, NULL, 117985),
(117986, '1.25.40.10-FF-000884', NULL, 'TPR repeat-containing protein C19B12.01', 336, NULL, NULL, 117986),
(117987, '3.90.800.10-FF-000007', NULL, NULL, 98, NULL, NULL, 117987),
(117988, '2.130.10.10-FF-004943', NULL, 'Uncharacterized protein', 100, NULL, NULL, 117988),
(117989, '3.30.300.30-FF-000157', NULL, 'Predicted protein', 102, NULL, NULL, 117989),
(117990, '3.40.1410.10-FF-000044', NULL, 'GntR family transcriptional regulator', 166, NULL, NULL, 117990),
(117991, '1.50.40.10-FF-000320', NULL, 'Uncharacterized protein', 327, NULL, NULL, 117991),
(117992, '3.80.10.10-FF-000161', NULL, 'F-box/LRR-repeat protein 17 isoform X1', 142, NULL, NULL, 117992),
(117993, '2.170.150.80-FF-000001', NULL, 'NAC domain-containing protein 73', 153, NULL, NULL, 117993),
(117994, '3.40.50.300-FF-007506', NULL, 'Uncharacterized protein', 220, NULL, NULL, 117994),
(117995, '3.90.190.10-FF-000369', NULL, 'Paladin', 221, NULL, NULL, 117995),
(117996, '3.80.10.10-FF-002285', NULL, 'Uncharacterized protein', 61, NULL, NULL, 117996),
(117997, '1.20.1250.20-FF-002311', NULL, 'Major facilitator family transporter', 237, NULL, NULL, 117997),
(117998, '1.10.287.70-FF-000199', NULL, 'Glutamate receptor ionotropic, NMDA 2B', 124, NULL, NULL, 117998),
(117999, '1.20.910.10-FF-000044', NULL, 'Putative hydroxymethylpyrimidine/phosphomethylpyrimidine kinase 1', 214, NULL, NULL, 117999),
(118000, '3.20.20.380-FF-000014', NULL, 'Uncharacterized protein', 137, NULL, NULL, 118000),
(118001, '1.10.630.10-FF-000227', NULL, 'Putative cytochrome P450', 401, NULL, NULL, 118001),
(118002, '1.10.940.10-FF-000037', NULL, 'tRNA/rRNA cytosine-C5-methylase, NOL1/NOP2/Sun family', 151, NULL, NULL, 118002),
(118003, '3.40.50.620-FF-000801', NULL, 'Cytoplasmic tRNA 2-thiolation protein 1', 109, NULL, NULL, 118003),
(118004, '3.60.15.10-FF-000088', NULL, 'Quinolone signal response protein', 301, NULL, NULL, 118004),
(118005, '3.30.900.10-FF-000028', NULL, 'AGAP001326-PA', 199, NULL, NULL, 118005),
(118006, '3.40.1280.10-FF-000095', NULL, 'Uncharacterized protein', 112, NULL, NULL, 118006),
(118007, '3.90.190.10-FF-000223', NULL, 'Putative tyrosine specific protein phosphatase', 293, NULL, NULL, 118007),
(118008, '3.40.50.450-FF-000109', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit alpha 2', 76, NULL, NULL, 118008),
(118009, '3.40.50.2300-FF-000821', NULL, NULL, 83, NULL, NULL, 118009),
(118010, '3.20.20.70-FF-000092', NULL, 'Uridine monophosphate synthetase', 258, NULL, NULL, 118010),
(118011, '3.30.559.10-FF-000251', NULL, 'Predicted protein', 54, NULL, NULL, 118011),
(118012, '3.40.50.300-FF-000323', NULL, 'Thymidine kinase', 141, NULL, NULL, 118012),
(118013, '3.30.200.20-FF-001293', NULL, 'Mitogen-activated protein kinase', 25, NULL, NULL, 118013),
(118014, '1.10.238.10-FF-001136', NULL, 'Uncharacterized protein', 151, NULL, NULL, 118014),
(118015, '2.40.270.10-FF-000031', NULL, NULL, 27, NULL, NULL, 118015),
(118016, '4.10.240.10-FF-000219', NULL, 'Uncharacterized transcriptional regulatory protein C2H10.01', 46, NULL, NULL, 118016);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(118017, '1.25.40.420-FF-000047', NULL, 'Uncharacterized protein', 59, NULL, NULL, 118017),
(118018, '1.10.510.10-FF-004288', NULL, NULL, 168, NULL, NULL, 118018),
(118019, '1.10.472.10-FF-000449', NULL, 'Uncharacterized protein', 115, NULL, NULL, 118019),
(118020, '3.30.450.20-FF-000496', NULL, 'PAS domain-containing protein', 122, NULL, NULL, 118020),
(118021, '3.40.50.300-FF-008400', NULL, 'Uncharacterized protein', 177, NULL, NULL, 118021),
(118022, '3.80.10.10-FF-004376', NULL, 'Predicted protein', 171, NULL, NULL, 118022),
(118023, '1.20.5.170-FF-000138', NULL, 'ATF (cAMP-dependent transcription factor) family', 54, NULL, NULL, 118023),
(118024, '2.60.40.10-FF-000053', NULL, 'Roundabout guidance receptor 1', 88, NULL, NULL, 118024),
(118025, '3.40.190.10-FF-000869', NULL, 'Uncharacterized protein', 155, NULL, NULL, 118025),
(118026, '3.30.70.270-FF-000298', NULL, NULL, 56, NULL, NULL, 118026),
(118027, '1.10.10.60-FF-000020', NULL, 'Ceramide synthase 5', 52, NULL, NULL, 118027),
(118028, '3.40.50.10140-FF-000053', NULL, 'Uncharacterized protein', 189, NULL, NULL, 118028),
(118029, '1.20.1070.10-FF-001479', NULL, 'Uncharacterized protein', 208, NULL, NULL, 118029),
(118030, '3.30.230.10-FF-000235', NULL, 'DNA topoisomerase 2', 63, NULL, NULL, 118030),
(118031, '3.30.1520.10-FF-000083', NULL, 'GG16618', 127, NULL, NULL, 118031),
(118032, '1.25.40.10-FF-001452', NULL, 'Vegetative storage protein', 174, NULL, NULL, 118032),
(118033, '3.10.490.10-FF-000011', NULL, 'Troponin C-akin-1 protein', 143, NULL, NULL, 118033),
(118034, '3.30.200.20-FF-000736', NULL, 'Putative serine/threonine-protein kinase At1g18390 family', 107, NULL, NULL, 118034),
(118035, '2.130.10.10-FF-005606', NULL, 'Vacuolar protein sorting/targeting protein 10', 190, NULL, NULL, 118035),
(118036, '3.60.10.10-FF-000392', NULL, 'Uncharacterized protein', 108, NULL, NULL, 118036),
(118037, '3.20.10.10-FF-000039', NULL, 'Probable branched-chain-amino-acid aminotransferase', 160, NULL, NULL, 118037),
(118038, '1.20.58.60-FF-000225', NULL, 'Spectrin beta chain', 106, NULL, NULL, 118038),
(118039, '1.10.287.70-FF-000750', NULL, 'Sodium channel protein', 80, NULL, NULL, 118039),
(118040, '3.30.70.100-FF-000180', NULL, NULL, 108, NULL, NULL, 118040),
(118041, '3.30.950.10-FF-000014', NULL, 'Bifunctional S-adenosyl-L-methionine-precorrin-2 methyl transferase/precorrin-3 methylase', 107, NULL, NULL, 118041),
(118042, '2.30.29.30-FF-000293', NULL, 'EPS8 like 3', 135, NULL, NULL, 118042),
(118043, '1.10.8.10-FF-000004', NULL, 'ubiquitin-associated protein 2-like isoform X1', 60, NULL, NULL, 118043),
(118044, '3.40.50.970-FF-000097', NULL, 'Met5 protein', 190, NULL, NULL, 118044),
(118045, '1.25.40.20-FF-001455', NULL, 'Uncharacterized protein', 125, NULL, NULL, 118045),
(118046, '1.10.10.10-FF-001505', NULL, 'Bacterial regulatory s, crp family protein', 75, NULL, NULL, 118046),
(118047, '3.10.490.20-FF-000014', NULL, 'Dynein heavy chain 2', 160, NULL, NULL, 118047),
(118048, '1.20.58.60-FF-000551', NULL, 'Predicted protein', 158, NULL, NULL, 118048),
(118049, '3.90.215.10-FF-000012', NULL, 'GH13859p', 213, NULL, NULL, 118049),
(118050, '1.10.10.1340-FF-000001', NULL, 'Mediator of RNA polymerase II transcription subunit 31', 102, NULL, NULL, 118050),
(118051, '3.30.160.60-FF-005724', NULL, NULL, 33, NULL, NULL, 118051),
(118052, '1.10.150.120-FF-000018', NULL, NULL, 93, NULL, NULL, 118052),
(118053, '1.25.40.10-FF-000558', NULL, 'Pentatricopeptide repeat-containing protein At5g39710', 107, NULL, NULL, 118053),
(118054, '1.20.1250.20-FF-001794', NULL, 'Putative transporter', 177, NULL, NULL, 118054),
(118055, '3.30.300.30-FF-000106', NULL, 'Non-ribosomal peptide synthetase', 111, NULL, NULL, 118055),
(118056, '3.30.450.60-FF-000042', NULL, 'Uncharacterized protein', 135, NULL, NULL, 118056),
(118057, '3.40.50.1220-FF-000132', NULL, 'Uncharacterized protein', 121, NULL, NULL, 118057),
(118058, '1.25.40.820-FF-000009', NULL, 'Putative RNA polymerase II subunit B1 CTD phosphatase rpap-2', 159, NULL, NULL, 118058),
(118059, '3.40.720.10-FF-000186', NULL, 'Iduronate-2-sulfatase', 439, NULL, NULL, 118059);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(118060, '3.50.30.30-FF-000130', NULL, 'Predicted protein', 133, NULL, NULL, 118060),
(118061, '3.40.50.11350-FF-000022', NULL, 'Protein MANNAN SYNTHESIS-RELATED 2', 159, NULL, NULL, 118061),
(118062, '2.60.40.10-FF-002402', NULL, 'Zwei Ig domain protein zig-4', 113, NULL, NULL, 118062),
(118063, '1.25.40.570-FF-000064', NULL, 'COP9 signalosome complex subunit 1', 133, NULL, NULL, 118063),
(118064, '4.10.1000.10-FF-000148', NULL, 'Protein CBG07225', 37, NULL, NULL, 118064),
(118065, '2.130.10.10-FF-005202', NULL, 'Uncharacterized protein', 102, NULL, NULL, 118065),
(118066, '3.30.1360.70-FF-000020', NULL, NULL, 119, NULL, NULL, 118066),
(118067, '1.20.1050.10-FF-000168', NULL, 'Tef4p', 139, NULL, NULL, 118067),
(118068, '3.40.50.10130-FF-000050', NULL, 'DNA repair protein, putative', 178, NULL, NULL, 118068),
(118069, '3.30.930.10-FF-000070', NULL, 'Proline--tRNA ligase', 253, NULL, NULL, 118069),
(118070, '1.20.1050.10-FF-000056', NULL, 'Glutathione S-transferase', 113, NULL, NULL, 118070),
(118071, '1.10.8.1220-FF-000022', NULL, 'Dynein beta chain, flagellar outer arm', 107, NULL, NULL, 118071),
(118072, '1.10.8.60-FF-000272', NULL, 'Replication factor C large subunit, putative', 62, NULL, NULL, 118072),
(118073, '1.10.287.130-FF-000072', NULL, 'Hybrid sensor histidine kinase/response regulator', 82, NULL, NULL, 118073),
(118074, '2.60.40.10-FF-005628', NULL, NULL, 123, NULL, NULL, 118074),
(118075, '3.40.50.300-FF-001846', NULL, 'ATP binding cassette subfamily A member 8', 124, NULL, NULL, 118075),
(118076, '2.60.120.920-FF-000190', NULL, 'Butyrophilin-like 7', 76, NULL, NULL, 118076),
(118077, '3.40.50.150-FF-001812', NULL, NULL, 107, NULL, NULL, 118077),
(118078, '3.30.160.60-FF-003633', NULL, 'Zinc finger protein 131', 25, NULL, NULL, 118078),
(118079, '3.40.50.150-FF-001863', NULL, NULL, 200, NULL, NULL, 118079),
(118080, '3.80.10.10-FF-000840', NULL, 'Probable inactive leucine-rich repeat receptor kinase XIAO', 99, NULL, NULL, 118080),
(118081, '1.25.40.20-FF-001730', NULL, 'Uncharacterized protein', 362, NULL, NULL, 118081),
(118082, '3.80.10.10-FF-002931', NULL, 'Uncharacterized protein', 114, NULL, NULL, 118082),
(118083, '3.30.460.10-FF-000106', NULL, 'poly(A) RNA polymerase, mitochondrial', 136, NULL, NULL, 118083),
(118084, '3.20.20.80-FF-000095', NULL, 'Endochitinase B1', 326, NULL, NULL, 118084),
(118085, '1.25.40.120-FF-000013', NULL, 'Geranylgeranyl transferase type-2 subunit alpha', 246, NULL, NULL, 118085),
(118086, '3.30.70.330-FF-002429', NULL, NULL, 88, NULL, NULL, 118086),
(118087, '2.60.120.200-FF-000569', NULL, 'Uncharacterized protein', 203, NULL, NULL, 118087),
(118088, '1.10.3380.10-FF-000055', NULL, 'AGR113Wp', 136, NULL, NULL, 118088),
(118089, '3.40.720.10-FF-000091', NULL, 'Phosphatidylinositol glycan anchor biosynthesis, class N', 102, NULL, NULL, 118089),
(118090, '3.40.630.30-FF-000426', NULL, 'Uncharacterized protein', 138, NULL, NULL, 118090),
(118091, '2.30.30.40-FF-000299', NULL, 'Endophilin B, isoform A', 77, NULL, NULL, 118091),
(118092, '3.40.50.11210-FF-000008', NULL, 'Rap-GAP domain-containing protein', 210, NULL, NULL, 118092),
(118093, '3.40.50.2000-FF-000175', NULL, 'Glycogen synthase', 207, NULL, NULL, 118093),
(118094, '1.20.1740.10-FF-000024', NULL, 'High affinity cationic amino acid transporter 1', 143, NULL, NULL, 118094),
(118095, '1.25.10.10-FF-000961', NULL, 'integrator complex subunit 4', 293, NULL, NULL, 118095),
(118096, '1.20.5.5160-FF-000004', NULL, 'Pab1p-dependent poly(A) ribonuclease subunit, putative', 45, NULL, NULL, 118096),
(118097, '1.25.40.20-FF-001781', NULL, 'Uncharacterized protein', 181, NULL, NULL, 118097),
(118098, '3.40.140.70-FF-000002', NULL, 'Autophagy-related protein 7', 196, NULL, NULL, 118098),
(118099, '3.10.580.10-FF-000035', NULL, 'Protein SDS23', 142, NULL, NULL, 118099),
(118100, '1.10.8.1320-FF-000001', NULL, 'Envelope glycoprotein', 77, NULL, NULL, 118100),
(118101, '3.40.50.360-FF-000122', NULL, 'Sulfite reductase', 138, NULL, NULL, 118101),
(118102, '3.40.1190.10-FF-000003', NULL, 'UDP-N-acetylmuramate--L-alanyl-gamma-D-glutamyl-meso-2,6-diaminoheptandioate ligase', 223, NULL, NULL, 118102);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(118103, '3.30.300.20-FF-000042', NULL, 'Ribosome-binding factor A', 105, NULL, NULL, 118103),
(118104, '3.40.1190.20-FF-000006', NULL, 'Adenosine kinase 2', 257, NULL, NULL, 118104),
(118105, '1.10.1200.270-FF-000006', NULL, 'Os06g0313320 protein', 133, NULL, NULL, 118105),
(118106, '3.90.245.10-FF-000014', NULL, 'Nucleoside hydrolase, putative', 352, NULL, NULL, 118106),
(118107, '3.20.20.80-FF-000370', NULL, 'Cyanidin 3-O-glucoside 5-O-glucosyltransferase (acyl-glucose)', 468, NULL, NULL, 118107),
(118108, '1.20.1560.10-FF-000605', NULL, 'ABC transporter', 164, NULL, NULL, 118108),
(118109, '3.40.50.300-FF-006051', NULL, 'Dynamin 2b', 108, NULL, NULL, 118109),
(118110, '2.60.40.60-FF-001063', NULL, 'Uncharacterized protein', 65, NULL, NULL, 118110),
(118111, '2.60.40.10-FF-001913', NULL, 'Mast/stem cell growth factor receptor Kit', 90, NULL, NULL, 118111),
(118112, '1.10.510.10-FF-001915', NULL, 'Dual specificity protein kinase zak2', 234, NULL, NULL, 118112),
(118113, '3.30.1330.90-FF-000024', NULL, 'D-3-phosphoglycerate dehydrogenase', 107, NULL, NULL, 118113),
(118114, '3.40.50.11660-FF-000059', NULL, NULL, 183, NULL, NULL, 118114),
(118115, '3.60.40.10-FF-000152', NULL, 'Protein phosphatase 2C, putative', 252, NULL, NULL, 118115),
(118116, '1.20.1250.20-FF-000445', NULL, 'putative inorganic phosphate cotransporter', 202, NULL, NULL, 118116),
(118117, '3.30.1330.80-FF-000021', NULL, 'Predicted protein', 66, NULL, NULL, 118117),
(118118, '3.30.40.10-FF-002340', NULL, 'Uncharacterized protein', 94, NULL, NULL, 118118),
(118119, '3.30.505.10-FF-000121', NULL, 'FYN isoform 7', 47, NULL, NULL, 118119),
(118120, '2.60.40.10-FF-005224', NULL, NULL, 90, NULL, NULL, 118120),
(118121, '3.30.160.60-FF-000502', NULL, 'Zinc finger protein 710', 29, NULL, NULL, 118121),
(118122, '3.40.720.10-FF-000040', NULL, 'Alkaline phosphatase', 449, NULL, NULL, 118122),
(118123, '2.60.130.10-FF-000005', NULL, 'Catechol 1,2-dioxygenase, putative', 299, NULL, NULL, 118123),
(118124, '2.60.220.50-FF-000047', NULL, 'Si:ch211-241f5.3', 155, NULL, NULL, 118124),
(118125, '3.40.50.150-FF-001245', NULL, NULL, 29, NULL, NULL, 118125),
(118126, '2.60.120.10-FF-000230', NULL, 'cAMP-dependent protein kinase regulatory subunit', 145, NULL, NULL, 118126),
(118127, '3.80.10.10-FF-002408', NULL, 'Toll receptor 13', 165, NULL, NULL, 118127),
(118128, '4.10.260.10-FF-000007', NULL, 'Guanine nucleotide-binding protein subunit gamma', 44, NULL, NULL, 118128),
(118129, '1.10.510.10-FF-002989', NULL, NULL, 143, NULL, NULL, 118129),
(118130, '3.30.160.20-FF-000002', NULL, '40S ribosomal protein S2', 106, NULL, NULL, 118130),
(118131, '1.20.1270.60-FF-000087', NULL, 'Rho guanyl nucleotide exchange factor', 199, NULL, NULL, 118131),
(118132, '3.30.1640.30-FF-000018', NULL, NULL, 61, NULL, NULL, 118132),
(118133, '3.30.70.270-FF-000326', NULL, NULL, 137, NULL, NULL, 118133),
(118134, '3.30.420.10-FF-000047', NULL, 'Ribonuclease HIII', 218, NULL, NULL, 118134),
(118135, '1.10.8.10-FF-000330', NULL, 'Ubiquitinyl hydrolase 1', 45, NULL, NULL, 118135),
(118136, '1.10.10.1800-FF-000010', NULL, 'Glucose-inhibited division family A protein', 80, NULL, NULL, 118136),
(118137, '2.30.29.30-FF-000225', NULL, 'GRAM domain containing 4', 125, NULL, NULL, 118137),
(118138, '3.50.30.20-FF-000008', NULL, 'CRE-PYR-1 protein', 157, NULL, NULL, 118138),
(118139, '2.130.10.10-FF-005820', NULL, 'Uncharacterized protein', 68, NULL, NULL, 118139),
(118140, '1.20.58.60-FF-000293', NULL, 'Spectrin, beta, non-erythrocytic 5', 103, NULL, NULL, 118140),
(118141, '3.30.1330.30-FF-000113', NULL, 'Uncharacterized protein', 104, NULL, NULL, 118141),
(118142, '1.20.58.1780-FF-000018', NULL, 'Uncharacterized protein', 234, NULL, NULL, 118142),
(118143, '2.10.25.10-FF-000565', NULL, 'Predicted protein', 38, NULL, NULL, 118143),
(118144, '3.30.160.60-FF-003375', NULL, 'Uncharacterized protein', 26, NULL, NULL, 118144),
(118145, '3.90.226.10-FF-000268', NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', 115, NULL, NULL, 118145),
(118146, '1.25.40.10-FF-003464', NULL, 'Pentatricopeptide repeat-containing protein', 104, NULL, NULL, 118146);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(118147, '1.25.40.20-FF-000999', NULL, 'Ankyrin repeat domain-containing protein 49', 120, NULL, NULL, 118147),
(118148, '3.40.50.800-FF-000024', NULL, 'Proline--tRNA ligase', 107, NULL, NULL, 118148),
(118149, '3.40.50.2020-FF-000001', NULL, 'Ribose-phosphate pyrophosphokinase', 155, NULL, NULL, 118149),
(118150, '3.40.50.150-FF-000969', NULL, NULL, 161, NULL, NULL, 118150),
(118151, '3.30.160.60-FF-005224', NULL, NULL, 28, NULL, NULL, 118151),
(118152, '2.10.25.10-FF-000273', NULL, 'Putative latent-transforming growth factor beta-binding protein 2', 42, NULL, NULL, 118152),
(118153, '3.90.550.60-FF-000002', NULL, 'Galactofuranosyl transferase GlfT1', 219, NULL, NULL, 118153),
(118154, '3.90.1720.10-FF-000005', NULL, 'Amidase', 154, NULL, NULL, 118154),
(118155, '2.60.120.260-FF-000273', NULL, 'Beta-galactosidase', 147, NULL, NULL, 118155),
(118156, '1.25.40.10-FF-000996', NULL, 'Small kernel1', 224, NULL, NULL, 118156),
(118157, '3.20.20.190-FF-000108', NULL, NULL, 182, NULL, NULL, 118157),
(118158, '2.60.40.10-FF-001508', NULL, 'Uncharacterized protein, isoform D', 104, NULL, NULL, 118158),
(118159, '1.10.630.10-FF-000441', NULL, 'Uncharacterized protein', 402, NULL, NULL, 118159),
(118160, '3.30.2020.30-FF-000011', NULL, 'Trimethyllysine hydroxylase, epsilon', 91, NULL, NULL, 118160),
(118161, '3.40.50.11900-FF-000002', NULL, '(R)-2-hydroxyisocaproyl-CoA dehydratase beta subunit', 143, NULL, NULL, 118161),
(118162, '1.10.40.30-FF-000030', NULL, 'Uncharacterized protein', 27, NULL, NULL, 118162),
(118163, '3.40.50.410-FF-000356', NULL, 'Uncharacterized protein', 79, NULL, NULL, 118163),
(118164, '3.40.50.620-FF-000189', NULL, 'Probable nicotinate-nucleotide adenylyltransferase', 188, NULL, NULL, 118164),
(118165, '2.40.50.140-FF-000852', NULL, NULL, 147, NULL, NULL, 118165),
(118166, '1.10.10.10-FF-000988', NULL, 'Histone acetyltransferase', 86, NULL, NULL, 118166),
(118167, '2.40.50.140-FF-000498', NULL, 'sn-glycerol-3-phosphate ABC transporter ATP-binding protein UgpC', 60, NULL, NULL, 118167),
(118168, '3.90.1150.210-FF-000009', NULL, 'F-actin-capping protein subunit alpha', 170, NULL, NULL, 118168),
(118169, '3.40.50.2300-FF-001164', NULL, NULL, 135, NULL, NULL, 118169),
(118170, '3.20.20.100-FF-000094', NULL, 'AGAP012038-PA', 207, NULL, NULL, 118170),
(118171, '3.30.470.20-FF-000087', NULL, 'Inositol-tetrakisphosphate 1-kinase', 203, NULL, NULL, 118171),
(118172, '3.30.200.20-FF-001225', NULL, 'Pim-1 proto-oncogene, serine/threonine kinase', 37, NULL, NULL, 118172),
(118173, '1.20.120.900-FF-000008', NULL, 'Putative peroxisomal biogenesis factor 19', 88, NULL, NULL, 118173),
(118174, '3.40.50.300-FF-005820', NULL, 'Hydin, axonemal central pair apparatus protein', 239, NULL, NULL, 118174),
(118175, '3.40.50.720-FF-001787', NULL, 'Uncharacterized protein', 202, NULL, NULL, 118175),
(118176, '2.130.10.10-FF-001666', NULL, 'Vegetative incompatibility WD repeat protein, putative', 102, NULL, NULL, 118176),
(118177, '3.90.660.10-FF-000035', NULL, 'Uncharacterized protein', 47, NULL, NULL, 118177),
(118178, '3.60.40.10-FF-000040', NULL, 'Protein serine/threonine phosphatase 2C', 379, NULL, NULL, 118178),
(118179, '2.60.120.260-FF-000559', NULL, 'Uncharacterized protein', 47, NULL, NULL, 118179),
(118180, '3.50.50.60-FF-000639', NULL, 'Glucose-methanol-choline oxidoreductase', 243, NULL, NULL, 118180),
(118181, '3.30.40.10-FF-000923', NULL, 'FI06144p', 85, NULL, NULL, 118181),
(118182, '4.10.240.10-FF-000045', NULL, 'Stb5p', 57, NULL, NULL, 118182),
(118183, '3.40.50.2300-FF-000372', NULL, 'DNA-binding response regulator', 80, NULL, NULL, 118183),
(118184, '2.40.50.140-FF-000526', NULL, 'Exoribonuclease 2', 86, NULL, NULL, 118184),
(118185, '2.60.40.10-FF-005550', NULL, NULL, 138, NULL, NULL, 118185),
(118186, '1.25.40.1040-FF-000033', NULL, 'N(alpha)-acetyltransferase 15, NatA auxiliary subunit', 183, NULL, NULL, 118186),
(118187, '1.25.40.1030-FF-000030', NULL, 'Protein transport protein SEC31', 445, NULL, NULL, 118187),
(118188, '2.60.40.420-FF-000025', NULL, 'FET5p Multicopper oxidase', 179, NULL, NULL, 118188);
INSERT INTO "PUBLIC"."MODEL" VALUES
(118189, '3.40.50.10190-FF-000202', NULL, 'DNA ligase', 63, NULL, NULL, 118189),
(118190, '3.30.2010.10-FF-000027', NULL, 'Uncharacterized protein', 42, NULL, NULL, 118190),
(118191, '3.80.10.10-FF-000609', NULL, 'Tsukushi, small leucine rich proteoglycan', 147, NULL, NULL, 118191),
(118192, '1.20.1560.10-FF-000870', NULL, 'Uncharacterized protein', 131, NULL, NULL, 118192),
(118193, '3.90.1310.10-FF-000036', NULL, 'Peptidoglycan D,D-transpeptidase FtsI', 121, NULL, NULL, 118193),
(118194, '3.40.50.1460-FF-000024', NULL, 'Caspase 21', 239, NULL, NULL, 118194),
(118195, '1.25.10.10-FF-002759', NULL, 'AP-3 complex subunit beta', 627, NULL, NULL, 118195),
(118196, '1.10.630.10-FF-000053', NULL, 'Cytochrome P450 benzoate 4-monooxygenase', 486, NULL, NULL, 118196),
(118197, '3.40.50.2030-FF-000004', NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit alpha 1', 197, NULL, NULL, 118197),
(118198, '3.30.70.330-FF-000698', NULL, '33 kDa ribonucleoprotein, chloroplastic', 105, NULL, NULL, 118198),
(118199, '3.30.230.10-FF-000409', NULL, 'Predicted protein', 54, NULL, NULL, 118199),
(118200, '3.40.850.10-FF-000044', NULL, 'p-loop containing nucleoside triphosphate hydrolases superfamily protein', 389, NULL, NULL, 118200),
(118201, '3.40.710.10-FF-000146', NULL, 'Penicillin-binding protein 4', 330, NULL, NULL, 118201),
(118202, '3.30.50.10-FF-000137', NULL, 'GR', 34, NULL, NULL, 118202),
(118203, '1.10.150.20-FF-000249', NULL, 'DNA-directed RNA polymerase subunit alpha', 79, NULL, NULL, 118203),
(118204, '1.25.40.10-FF-003604', NULL, 'YALI0B12408p', 128, NULL, NULL, 118204),
(118205, '1.20.140.10-FF-000075', NULL, 'Acyl-CoA dehydrogenase', 165, NULL, NULL, 118205),
(118206, '2.30.29.30-FF-001017', NULL, 'Predicted protein', 130, NULL, NULL, 118206),
(118207, '3.40.50.410-FF-000126', NULL, 'Voltage-dependent calcium channel subunit alpha-2/delta-1', 183, NULL, NULL, 118207),
(118208, '3.40.50.720-FF-001062', NULL, 'D-3-phosphoglycerate dehydrogenase', 116, NULL, NULL, 118208),
(118209, '1.25.40.20-FF-001281', NULL, 'Uncharacterized protein', 177, NULL, NULL, 118209),
(118210, '2.60.40.10-FF-003504', NULL, NULL, 91, NULL, NULL, 118210),
(118211, '2.130.10.10-FF-003515', NULL, 'Elongator complex protein 2', 97, NULL, NULL, 118211),
(118212, '3.90.70.10-FF-000124', NULL, 'ubiquitin carboxyl-terminal hydrolase 26', 283, NULL, NULL, 118212),
(118213, '1.20.1560.10-FF-000426', NULL, 'ATP-binding cassette permease', 76, NULL, NULL, 118213),
(118214, '2.60.40.10-FF-002987', NULL, 'GG16886', 101, NULL, NULL, 118214),
(118215, '3.30.930.10-FF-000423', NULL, 'Lysine--tRNA ligase', 371, NULL, NULL, 118215),
(118216, '3.30.420.10-FF-000098', NULL, 'Polynucleotidyl transferase ribonuclease H-like superfamily protein', 183, NULL, NULL, 118216),
(118217, '2.20.25.10-FF-000132', NULL, 'DNA-directed RNA polymerase II 15.1 kDa polypeptide-related protein', 62, NULL, NULL, 118217),
(118218, '3.90.550.50-FF-000078', NULL, 'Hexosyltransferase', 240, NULL, NULL, 118218),
(118219, '3.40.50.300-FF-002009', NULL, 'Ribosome biogenesis GTPase A, putative', 198, NULL, NULL, 118219),
(118220, '1.20.1250.20-FF-002069', NULL, 'Solute carrier organic anion transporter family member', 282, NULL, NULL, 118220),
(118221, '3.80.10.10-FF-003887', NULL, 'Leucine-rich repeat protein (LRRP), putative', 156, NULL, NULL, 118221),
(118222, '3.40.50.2300-FF-000607', NULL, 'Sensory box sensor histidine kinase/response regulator VieS', 142, NULL, NULL, 118222),
(118223, '3.40.50.720-FF-000505', NULL, 'Shikimate dehydrogenase (NADP(+))', 146, NULL, NULL, 118223),
(118224, '3.30.160.60-FF-001576', NULL, 'HKR1, GLI-Kruppel zinc finger family member', 28, NULL, NULL, 118224),
(118225, '3.80.10.10-FF-002459', NULL, 'Uncharacterized protein', 94, NULL, NULL, 118225),
(118226, '2.60.210.10-FF-000057', NULL, NULL, 154, NULL, NULL, 118226),
(118227, '2.130.10.10-FF-000874', NULL, 'U3 small nucleolar RNA-associated protein 15', 175, NULL, NULL, 118227),
(118228, '1.10.10.60-FF-000863', NULL, NULL, 82, NULL, NULL, 118228),
(118229, '2.40.50.140-FF-001015', NULL, NULL, 60, NULL, NULL, 118229);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(118230, '1.25.40.180-FF-000284', NULL, NULL, 149, NULL, NULL, 118230),
(118231, '1.20.1070.10-FF-000670', NULL, 'Orexin receptor type 1', 325, NULL, NULL, 118231),
(118232, '1.25.40.10-FF-001126', NULL, 'Daf-16-Dependent Longevity (WT but not daf-16 lifespan increased)', 133, NULL, NULL, 118232),
(118233, '1.20.1070.10-FF-001928', NULL, 'Uncharacterized protein', 279, NULL, NULL, 118233),
(118234, '3.40.190.10-FF-000920', NULL, 'Predicted protein', 79, NULL, NULL, 118234),
(118235, '3.30.420.10-FF-000340', NULL, 'DNA polymerase I', 187, NULL, NULL, 118235),
(118236, '1.10.274.100-FF-000019', NULL, 'DNA-directed RNA polymerase subunit beta', 179, NULL, NULL, 118236),
(118237, '1.20.58.1030-FF-000018', NULL, 'Uncharacterized protein', 159, NULL, NULL, 118237),
(118238, '3.40.50.10490-FF-000056', NULL, 'Ribosomal protein S2', 203, NULL, NULL, 118238),
(118239, '3.40.50.1820-FF-000278', NULL, 'Esterase LipF', 274, NULL, NULL, 118239),
(118240, '1.10.1030.10-FF-000006', NULL, 'Carbamoyl-phosphate synthase, large subunit', 146, NULL, NULL, 118240),
(118241, '3.10.20.230-FF-000005', NULL, 'Doublecortin domain containing 2', 110, NULL, NULL, 118241),
(118242, '2.60.120.290-FF-000023', NULL, 'Multiple epidermal growth factor-like domains 8', 114, NULL, NULL, 118242),
(118243, '3.90.640.10-FF-000073', NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', 85, NULL, NULL, 118243),
(118244, '3.30.160.60-FF-005550', NULL, NULL, 23, NULL, NULL, 118244),
(118245, '2.10.25.10-FF-000891', NULL, 'Calcium binding EGF domain containing protein, expressed', 38, NULL, NULL, 118245),
(118246, '3.40.50.300-FF-001672', NULL, 'Multidrug ABC transporter ATP-binding protein', 219, NULL, NULL, 118246),
(118247, '2.60.120.970-FF-000013', NULL, 'Bone morphogenetic protein 10', 221, NULL, NULL, 118247),
(118248, '1.10.8.20-FF-000007', NULL, 'Sec14p-like phosphatidylinositol transfer family protein', 67, NULL, NULL, 118248),
(118249, '1.20.5.930-FF-000001', NULL, 'Integrin subunit alpha V', 46, NULL, NULL, 118249),
(118250, '3.40.50.300-FF-004134', NULL, 'GM21411', 189, NULL, NULL, 118250),
(118251, '1.10.510.10-FF-001803', NULL, 'Predicted protein', 103, NULL, NULL, 118251),
(118252, '3.30.465.10-FF-000033', NULL, 'L-gulonolactone oxidase 5', 121, NULL, NULL, 118252),
(118253, '1.10.10.10-FF-000781', NULL, 'Meiotic recombination protein spo11', 143, NULL, NULL, 118253),
(118254, '2.40.128.20-FF-000013', NULL, 'OsWRKY4 family protein', 144, NULL, NULL, 118254),
(118255, '1.10.150.910-FF-000008', NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', 99, NULL, NULL, 118255),
(118256, '1.10.287.610-FF-000002', NULL, 'DNA ligase', 66, NULL, NULL, 118256),
(118257, '1.20.1560.10-FF-000252', NULL, 'ABC transporter, ATP-binding protein', 315, NULL, NULL, 118257),
(118258, '3.60.10.10-FF-000212', NULL, 'Uncharacterized protein', 283, NULL, NULL, 118258),
(118259, '1.20.120.1320-FF-000006', NULL, 'Aspartate kinase /homoserine dehydrogenase', 99, NULL, NULL, 118259),
(118260, '2.30.30.140-FF-000165', NULL, 'Tudor, isoform B', 85, NULL, NULL, 118260),
(118261, '1.20.120.160-FF-000011', NULL, 'Histidine kinase', 110, NULL, NULL, 118261),
(118262, '2.40.420.20-FF-000029', NULL, 'Efflux transporter periplasmic adaptor subunit', 90, NULL, NULL, 118262),
(118263, '3.50.50.60-FF-001303', NULL, 'Mercuric reductase', 131, NULL, NULL, 118263),
(118264, '1.10.510.10-FF-003214', NULL, NULL, 138, NULL, NULL, 118264),
(118265, '2.60.40.10-FF-002936', NULL, 'DLEC1, cilia and flagella associated protein', 98, NULL, NULL, 118265),
(118266, '3.50.50.60-FF-001516', NULL, 'D-amino acid dehydrogenase, small chain', 81, NULL, NULL, 118266),
(118267, '3.80.10.10-FF-002734', NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At2g02780', 117, NULL, NULL, 118267),
(118268, '1.25.10.10-FF-002113', NULL, 'Formin-3', 259, NULL, NULL, 118268),
(118269, '1.25.40.10-FF-005049', NULL, 'Uncharacterized protein', 117, NULL, NULL, 118269),
(118270, '3.90.228.10-FF-000042', NULL, 'Poly [ADP-ribose] polymerase', 220, NULL, NULL, 118270);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(118271, '3.10.20.410-FF-000003', NULL, 'Fimbrial outer membrane usher protein', 112, NULL, NULL, 118271),
(118272, '1.10.150.900-FF-000005', NULL, 'Predicted protein', 93, NULL, NULL, 118272),
(118273, '1.10.510.10-FF-001680', NULL, 'Kinase, NEK', 201, NULL, NULL, 118273),
(118274, '2.30.30.100-FF-000086', NULL, 'SNRPF isoform 1', 48, NULL, NULL, 118274),
(118275, '3.80.10.10-FF-003836', NULL, 'Uncharacterized protein', 56, NULL, NULL, 118275),
(118276, '2.60.40.10-FF-003212', NULL, NULL, 68, NULL, NULL, 118276),
(118277, '3.90.1800.10-FF-000006', NULL, 'DNA-directed RNA polymerase subunit beta', 115, NULL, NULL, 118277),
(118278, '2.70.160.11-FF-000023', NULL, 'Protein arginine methyltransferase 9', 182, NULL, NULL, 118278),
(118279, '3.40.30.10-FF-000051', NULL, 'endoplasmic reticulum resident protein 44', 163, NULL, NULL, 118279),
(118280, '3.30.70.2850-FF-000022', NULL, 'DNA-directed RNA polymerase subunit', 229, NULL, NULL, 118280),
(118281, '1.10.287.570-FF-000001', NULL, 'Anion exchange protein', 42, NULL, NULL, 118281),
(118282, '3.30.260.10-FF-000063', NULL, NULL, 109, NULL, NULL, 118282),
(118283, '3.40.50.10190-FF-000253', NULL, 'YALI0B15576p', 93, NULL, NULL, 118283),
(118284, '3.30.9.10-FF-000070', NULL, 'FAD dependent oxidoreductase', 196, NULL, NULL, 118284),
(118285, '2.20.100.10-FF-000108', NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif, 13', 58, NULL, NULL, 118285),
(118286, '1.10.565.10-FF-000081', NULL, 'Nuclear receptor', 191, NULL, NULL, 118286),
(118287, '3.90.190.10-FF-000611', NULL, 'Uncharacterized protein', 113, NULL, NULL, 118287),
(118288, '1.25.10.10-FF-001624', NULL, 'Wings apart-like protein-like protein', 498, NULL, NULL, 118288),
(118289, '3.90.1150.10-FF-000473', NULL, 'Putative L-allo-threonine aldolase', 110, NULL, NULL, 118289),
(118290, '3.40.50.300-FF-000211', NULL, 'Elongation factor 1-alpha', 236, NULL, NULL, 118290),
(118291, '1.10.150.170-FF-000005', NULL, 'Probable methyltransferase-like protein 15', 84, NULL, NULL, 118291),
(118292, '3.55.50.10-FF-000002', NULL, 'Late control gene D protein', 85, NULL, NULL, 118292),
(118293, '1.20.1070.10-FF-001979', NULL, 'G protein-coupled receptor 33', 167, NULL, NULL, 118293),
(118294, '2.60.120.290-FF-000074', NULL, 'Metalloendopeptidase', 123, NULL, NULL, 118294),
(118295, '3.90.830.10-FF-000014', NULL, 'Syntaxin binding protein, putative', 104, NULL, NULL, 118295),
(118296, '1.10.510.10-FF-003832', NULL, NULL, 110, NULL, NULL, 118296),
(118297, '1.25.40.10-FF-004892', NULL, 'Uncharacterized protein', 95, NULL, NULL, 118297),
(118298, '3.40.250.10-FF-000015', NULL, 'Sulfurtransferase', 147, NULL, NULL, 118298),
(118299, '1.25.10.10-FF-003215', NULL, 'Predicted protein', 271, NULL, NULL, 118299),
(118300, '1.50.40.10-FF-000432', NULL, 'Uncharacterized protein', 177, NULL, NULL, 118300),
(118301, '2.60.40.10-FF-003425', NULL, NULL, 107, NULL, NULL, 118301),
(118302, '3.90.1410.10-FF-000021', NULL, 'SET_domain_containing_protein', 260, NULL, NULL, 118302),
(118303, '1.25.40.10-FF-001401', NULL, 'General transcription factor 3C polypeptide 3 isoform A', 244, NULL, NULL, 118303),
(118304, '3.20.20.80-FF-000662', NULL, 'Glucosylceramidase', 52, NULL, NULL, 118304),
(118305, '1.25.40.10-FF-002587', NULL, 'Os12g0490100 protein', 64, NULL, NULL, 118305),
(118306, '3.80.10.10-FF-002173', NULL, 'Predicted protein', 188, NULL, NULL, 118306),
(118307, '3.40.50.300-FF-001493', NULL, 'Mitochondrial ATPase (Afg1), putative', 154, NULL, NULL, 118307),
(118308, '2.20.70.30-FF-000006', NULL, 'Nascent polypeptide-associated complex alpha subunit Egd2', 52, NULL, NULL, 118308),
(118309, '3.40.50.1000-FF-000881', NULL, NULL, 221, NULL, NULL, 118309),
(118310, '3.20.20.140-FF-000026', NULL, 'D-phenylhydantoinase', 369, NULL, NULL, 118310),
(118311, '3.40.50.300-FF-001397', NULL, 'Primosomal protein N''', 162, NULL, NULL, 118311),
(118312, '3.40.50.720-FF-000831', NULL, 'D-3-phosphoglycerate dehydrogenase, putative', 115, NULL, NULL, 118312),
(118313, '1.10.110.10-FF-000025', NULL, 'At4g12360', 74, NULL, NULL, 118313);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(118314, '3.40.50.1910-FF-000030', NULL, 'Syntaxin-binding protein 2', 82, NULL, NULL, 118314),
(118315, '1.20.5.170-FF-000189', NULL, 'Uncharacterized protein', 71, NULL, NULL, 118315),
(118316, '1.10.472.80-FF-000043', NULL, 'Pollux, isoform A', 153, NULL, NULL, 118316),
(118317, '1.20.1250.20-FF-000271', NULL, 'Monocarboxylate transporter', 217, NULL, NULL, 118317),
(118318, '2.60.120.340-FF-000027', NULL, 'Uncharacterized protein', 119, NULL, NULL, 118318),
(118319, '2.60.40.60-FF-000040', NULL, 'cadherin EGF LAG seven-pass G-type receptor 3', 107, NULL, NULL, 118319),
(118320, '3.40.1110.10-FF-000111', NULL, 'Phospholipid-transporting ATPase, putative', 117, NULL, NULL, 118320),
(118321, '3.40.50.2300-FF-000933', NULL, NULL, 187, NULL, NULL, 118321),
(118322, '1.10.510.10-FF-003427', NULL, NULL, 288, NULL, NULL, 118322),
(118323, '3.40.5.10-FF-000016', NULL, '50S ribosomal protein L9', 59, NULL, NULL, 118323),
(118324, '2.60.40.10-FF-003830', NULL, NULL, 107, NULL, NULL, 118324),
(118325, '2.80.10.50-FF-000141', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 140, NULL, NULL, 118325),
(118326, '1.10.510.10-FF-002938', NULL, NULL, 144, NULL, NULL, 118326),
(118327, '3.30.50.10-FF-000188', NULL, 'Uncharacterized protein', 96, NULL, NULL, 118327),
(118328, '3.30.40.10-FF-002109', NULL, 'Uncharacterized protein', 53, NULL, NULL, 118328),
(118329, '1.10.510.10-FF-001062', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 197, NULL, NULL, 118329),
(118330, '2.30.42.10-FF-000486', NULL, NULL, 51, NULL, NULL, 118330),
(118331, '3.60.40.10-FF-000326', NULL, 'Os12g0198200 protein', 173, NULL, NULL, 118331),
(118332, '3.50.50.60-FF-000409', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 187, NULL, NULL, 118332),
(118333, '2.30.30.490-FF-000039', NULL, 'Histone-lysine N-methyltransferase ash1', 236, NULL, NULL, 118333),
(118334, '3.30.1240.10-FF-000050', NULL, 'HAD-superfamily hydrolase, subfamily IIB', 129, NULL, NULL, 118334),
(118335, '2.60.120.330-FF-000024', NULL, 'Probable 2-oxoglutarate-dependent dioxygenase At3g49630', 324, NULL, NULL, 118335),
(118336, '3.60.20.10-FF-000038', NULL, 'Proteasome subunit beta', 204, NULL, NULL, 118336),
(118337, '3.30.160.60-FF-001834', NULL, 'Zinc finger protein 836', 29, NULL, NULL, 118337),
(118338, '3.30.310.80-FF-000037', NULL, 'Non-specific serine/threonine protein kinase', 90, NULL, NULL, 118338),
(118339, '1.20.90.10-FF-000009', NULL, 'Otoconin-90', 121, NULL, NULL, 118339),
(118340, '1.25.10.10-FF-001006', NULL, 'Predicted protein', 307, NULL, NULL, 118340),
(118341, '3.90.80.10-FF-000001', NULL, 'Inorganic pyrophosphatase', 176, NULL, NULL, 118341),
(118342, '2.30.40.10-FF-000032', NULL, 'Imidazolonepropionase', 89, NULL, NULL, 118342),
(118343, '1.10.238.10-FF-000765', NULL, 'Lysophospholipid acyltransferase LPEAT2', 158, NULL, NULL, 118343),
(118344, '1.20.190.50-FF-000011', NULL, 'Nuclear pore complex protein', 243, NULL, NULL, 118344),
(118345, '2.40.420.20-FF-000030', NULL, 'RND family efflux transporter, MFP subunit', 88, NULL, NULL, 118345),
(118346, '2.90.10.30-FF-000011', NULL, 'Uncharacterized protein', 70, NULL, NULL, 118346),
(118347, '2.30.140.10-FF-000035', NULL, 'Uncharacterized protein', 68, NULL, NULL, 118347),
(118348, '3.40.50.1400-FF-000028', NULL, 'Ferrochelatase', 17, NULL, NULL, 118348),
(118349, '3.30.1370.10-FF-000048', NULL, 'RNA-binding protein PNO1 isoform X2', 82, NULL, NULL, 118349),
(118350, '3.40.720.10-FF-000214', NULL, 'Choline-sulfatase', 452, NULL, NULL, 118350),
(118351, '1.25.40.10-FF-001160', NULL, 'Pentatricopeptide repeat-containing protein', 103, NULL, NULL, 118351),
(118352, '1.25.40.20-FF-001163', NULL, 'Glycerophosphocholine phosphodiesterase Gde1, putative (AFU_orthologue AFUA_5G11590)', 412, NULL, NULL, 118352),
(118353, '3.40.50.300-FF-007703', NULL, 'Predicted protein', 102, NULL, NULL, 118353),
(118354, '3.80.10.10-FF-004084', NULL, 'Uncharacterized protein', 125, NULL, NULL, 118354),
(118355, '2.40.50.90-FF-000157', NULL, 'Blr1266 protein', 118, NULL, NULL, 118355);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(118356, '3.40.120.10-FF-000011', NULL, 'Alpha-D-glucose phosphate-specific phosphoglucomutase', 98, NULL, NULL, 118356),
(118357, '1.20.1560.10-FF-000218', NULL, 'Putative ABC transporter', 327, NULL, NULL, 118357),
(118358, '3.40.50.300-FF-001228', NULL, 'GTP-binding nuclear protein', 213, NULL, NULL, 118358),
(118359, '3.30.470.20-FF-000166', NULL, 'Uncharacterized protein', 94, NULL, NULL, 118359),
(118360, '1.10.3200.20-FF-000017', NULL, NULL, 114, NULL, NULL, 118360),
(118361, '1.20.1560.10-FF-000701', NULL, 'ABC transporter', 329, NULL, NULL, 118361),
(118362, '3.30.1330.30-FF-000001', NULL, '60S ribosomal protein L30', 107, NULL, NULL, 118362),
(118363, '2.60.40.420-FF-000233', NULL, 'Periplasmic cell division protein (SufI)', 146, NULL, NULL, 118363),
(118364, '3.80.10.10-FF-002526', NULL, 'Uncharacterized protein', 219, NULL, NULL, 118364),
(118365, '1.20.1440.100-FF-000011', NULL, 'HAD-IB family hydrolase', 74, NULL, NULL, 118365),
(118366, '1.20.1070.10-FF-000669', NULL, 'Uncharacterized protein', 295, NULL, NULL, 118366),
(118367, '1.25.10.10-FF-003198', NULL, 'Predicted protein', 296, NULL, NULL, 118367),
(118368, '3.30.450.20-FF-000221', NULL, 'Sensor kinase CitA', 139, NULL, NULL, 118368),
(118369, '3.40.50.300-FF-007057', NULL, 'ATP-dependent DNA helicase', 197, NULL, NULL, 118369),
(118370, '1.25.10.10-FF-001124', NULL, 'Protein CBG09895', 927, NULL, NULL, 118370),
(118371, '1.20.1090.10-FF-000053', NULL, '3-dehydroquinate synthase', 190, NULL, NULL, 118371),
(118372, '1.25.40.10-FF-003290', NULL, 'Vacuolar protein sorting-associated protein 41 homolog', 264, NULL, NULL, 118372),
(118373, '1.10.1040.10-FF-000063', NULL, 'D-mannonate oxidoreductase', 207, NULL, NULL, 118373),
(118374, '1.10.510.10-FF-001303', NULL, 'Uncharacterized protein', 338, NULL, NULL, 118374),
(118375, '1.20.1070.10-FF-002182', NULL, 'Uncharacterized protein', 97, NULL, NULL, 118375),
(118376, '3.40.1180.10-FF-000008', NULL, 'NUS1, dehydrodolichyl diphosphate synthase subunit', 190, NULL, NULL, 118376),
(118377, '3.40.50.300-FF-003319', NULL, 'Dephospho-CoA kinase', 197, NULL, NULL, 118377),
(118378, '3.10.350.10-FF-000086', NULL, 'Lytic transglycosylase, SLT, LysM and LysM domain-containing', 66, NULL, NULL, 118378),
(118379, '1.10.510.10-FF-003540', NULL, NULL, 235, NULL, NULL, 118379),
(118380, '3.40.1260.10-FF-000009', NULL, 'Sulfur relay protein DsrH', 87, NULL, NULL, 118380),
(118381, '3.10.50.40-FF-000023', NULL, 'Peptidylprolyl isomerase', 119, NULL, NULL, 118381),
(118382, '2.30.39.10-FF-000130', NULL, 'Uncharacterized protein', 108, NULL, NULL, 118382),
(118383, '3.40.50.1820-FF-001121', NULL, 'Lipase family member K', 78, NULL, NULL, 118383),
(118384, '1.10.472.10-FF-000679', NULL, 'Meiotically up-regulated gene 80 protein', 191, NULL, NULL, 118384),
(118385, '1.10.340.70-FF-000037', NULL, 'Transposon Tf2-6 polyprotein-like Protein', 95, NULL, NULL, 118385),
(118386, '3.40.630.30-FF-000134', NULL, 'Probable acetyltransferase', 141, NULL, NULL, 118386),
(118387, '1.25.40.10-FF-003251', NULL, 'Uncharacterized protein', 168, NULL, NULL, 118387),
(118388, '3.40.50.410-FF-000244', NULL, 'Uncharacterized protein', 138, NULL, NULL, 118388),
(118389, '3.20.20.70-FF-000327', NULL, 'At4g21320p-like protein', 268, NULL, NULL, 118389),
(118390, '3.10.20.90-FF-000103', NULL, 'Merlin isoform 2', 78, NULL, NULL, 118390),
(118391, '3.30.780.10-FF-000068', NULL, 'Protein translation factor SUI1-like protein', 58, NULL, NULL, 118391),
(118392, '2.60.120.200-FF-000620', NULL, 'Predicted protein', 142, NULL, NULL, 118392),
(118393, '1.10.555.10-FF-000136', NULL, 'T-cell activation GTPase activating protein', 248, NULL, NULL, 118393),
(118394, '2.60.120.260-FF-000481', NULL, 'Uncharacterized protein', 140, NULL, NULL, 118394),
(118395, '2.60.40.10-FF-003419', NULL, 'Tyrosine-protein kinase receptor cam-1', 107, NULL, NULL, 118395),
(118396, '1.10.10.10-FF-001118', NULL, 'Transcriptional regulator, LysR family', 86, NULL, NULL, 118396),
(118397, '1.25.10.10-FF-003423', NULL, 'Uncharacterized protein', 304, NULL, NULL, 118397);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(118398, '3.30.1490.80-FF-000027', NULL, 'Glutathione synthetase', 89, NULL, NULL, 118398),
(118399, '2.60.200.40-FF-000048', NULL, 'Ceramide kinase-like isoform 31', 77, NULL, NULL, 118399),
(118400, '1.20.990.10-FF-000032', NULL, 'GD19100', 132, NULL, NULL, 118400),
(118401, '1.25.40.10-FF-001047', NULL, 'Chlororespiratory reduction 4', 63, NULL, NULL, 118401),
(118402, '2.10.70.10-FF-000074', NULL, 'CUB and Sushi multiple domains 3', 64, NULL, NULL, 118402),
(118403, '1.10.150.50-FF-000230', NULL, 'Predicted protein', 100, NULL, NULL, 118403),
(118404, '3.40.950.10-FF-000023', NULL, 'Iron hydrogenase', 221, NULL, NULL, 118404),
(118405, '6.10.140.2220-FF-000007', NULL, 'Zinc finger MYND domain-containing protein 19', 46, NULL, NULL, 118405),
(118406, '2.70.160.11-FF-000074', NULL, 'Uncharacterized protein', 174, NULL, NULL, 118406),
(118407, '1.50.10.10-FF-000043', NULL, 'Family 65 glycosyl hydrolase', 362, NULL, NULL, 118407),
(118408, '2.60.220.50-FF-000114', NULL, 'Uncharacterized protein', 96, NULL, NULL, 118408),
(118409, '3.30.160.60-FF-001508', NULL, 'E3 ubiquitin-protein ligase TRIM62', 73, NULL, NULL, 118409),
(118410, '3.40.50.300-FF-001285', NULL, 'galactose-3-O-sulfotransferase 3', 269, NULL, NULL, 118410),
(118411, '3.60.21.10-FF-000063', NULL, 'Calcineurin-like phosphoesterase domain-containing protein 1', 255, NULL, NULL, 118411),
(118412, '3.20.20.140-FF-000234', NULL, 'AMP deaminase', 54, NULL, NULL, 118412),
(118413, '3.50.30.80-FF-000004', NULL, NULL, 70, NULL, NULL, 118413),
(118414, '2.10.109.10-FF-000068', NULL, 'Signal peptidase I', 149, NULL, NULL, 118414),
(118415, '3.40.190.10-FF-000577', NULL, 'ABC transporter substrate-binding protein', 273, NULL, NULL, 118415),
(118416, '6.10.140.2220-FF-000064', NULL, 'GM03859p', 47, NULL, NULL, 118416),
(118417, '3.20.20.80-FF-000656', NULL, 'Uncharacterized protein', 64, NULL, NULL, 118417),
(118418, '3.40.50.1110-FF-000003', NULL, 'GDSL esterase/lipase APG', 329, NULL, NULL, 118418),
(118419, '3.40.50.1820-FF-000654', NULL, 'Expressed protein', 239, NULL, NULL, 118419),
(118420, '2.40.50.120-FF-000054', NULL, 'Uncharacterized protein', 115, NULL, NULL, 118420),
(118421, '3.30.710.10-FF-000137', NULL, 'Keap1, isoform A', 132, NULL, NULL, 118421),
(118422, '2.30.30.490-FF-000073', NULL, 'Zinc finger protein', 174, NULL, NULL, 118422),
(118423, '3.40.220.10-FF-000013', NULL, 'Poly [ADP-ribose] polymerase', 199, NULL, NULL, 118423),
(118424, '1.10.150.170-FF-000011', NULL, 'S-adenosyl-methyltransferase mraW-like protein', 114, NULL, NULL, 118424),
(118425, '3.30.9.10-FF-000165', NULL, 'Uncharacterized protein', 14, NULL, NULL, 118425),
(118426, '2.60.120.330-FF-000136', NULL, 'Uncharacterized protein', 98, NULL, NULL, 118426),
(118427, '1.50.10.160-FF-000014', NULL, 'Uncharacterized protein', 142, NULL, NULL, 118427),
(118428, '2.130.10.10-FF-003291', NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', 310, NULL, NULL, 118428),
(118429, '2.60.40.10-FF-003476', NULL, NULL, 98, NULL, NULL, 118429),
(118430, '3.20.20.140-FF-000077', NULL, 'putative deoxyribonuclease TATDN1 isoform X4', 203, NULL, NULL, 118430),
(118431, '2.30.42.10-FF-000598', NULL, NULL, 102, NULL, NULL, 118431),
(118432, '1.10.3370.10-FF-000015', NULL, 'Accessory Sec system protein translocase subunit SecY2', 394, NULL, NULL, 118432),
(118433, '3.90.25.10-FF-000048', NULL, 'Novel protein similar to bacterial GDP-mannose 4,6-dehydratases', 35, NULL, NULL, 118433),
(118434, '1.25.10.10-FF-003462', NULL, 'Uncharacterized protein', 220, NULL, NULL, 118434),
(118435, '3.40.140.10-FF-000012', NULL, 'nuclear protein localization protein 4 homolog', 212, NULL, NULL, 118435),
(118436, '1.25.40.10-FF-003138', NULL, 'Putative pentatricopeptide repeat-containing protein', 117, NULL, NULL, 118436),
(118437, '2.60.120.200-FF-000570', NULL, 'Sex hormone-binding globulin', 24, NULL, NULL, 118437),
(118438, '3.30.1240.10-FF-000016', NULL, 'Cof-type HAD-IIB family hydrolase', 107, NULL, NULL, 118438),
(118439, '2.40.50.140-FF-000291', NULL, 'mRNA-capping enzyme', 90, NULL, NULL, 118439);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(118440, '3.90.1150.10-FF-000147', NULL, 'Aminotransferase', 159, NULL, NULL, 118440),
(118441, '3.80.10.10-FF-000453', NULL, 'Leucine-rich receptor-like protein kinase family protein', 99, NULL, NULL, 118441),
(118442, '2.30.30.550-FF-000018', NULL, NULL, 59, NULL, NULL, 118442),
(118443, '1.50.10.10-FF-000138', NULL, 'N-acylglucosamine 2-epimerase', 388, NULL, NULL, 118443),
(118444, '4.10.280.10-FF-000216', NULL, 'BHLH transcription factor', 41, NULL, NULL, 118444),
(118445, '1.25.40.180-FF-000104', NULL, 'Nonsense-mediated mRNA decay protein 2', 200, NULL, NULL, 118445),
(118446, '1.10.8.60-FF-000154', NULL, 'Heat shock protein 101', 97, NULL, NULL, 118446),
(118447, '3.30.300.130-FF-000017', NULL, 'Iron-sulfur cluster carrier protein', 95, NULL, NULL, 118447),
(118448, '1.25.40.180-FF-000216', NULL, NULL, 181, NULL, NULL, 118448),
(118449, '3.40.50.300-FF-002122', NULL, 'ABC transporter ATP-binding protein', 81, NULL, NULL, 118449),
(118450, '2.20.100.10-FF-000029', NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif, 6', 57, NULL, NULL, 118450),
(118451, '3.40.50.10330-FF-000115', NULL, 'NAD kinase b', 190, NULL, NULL, 118451),
(118452, '3.40.50.150-FF-001037', NULL, NULL, 156, NULL, NULL, 118452),
(118453, '3.20.20.20-FF-000037', NULL, '6-hydroxymethyl-7,8-dihydropterin pyrophosphokinase', 145, NULL, NULL, 118453),
(118454, '1.10.238.10-FF-000973', NULL, 'Uncharacterized protein', 112, NULL, NULL, 118454),
(118455, '3.30.160.60-FF-006298', NULL, NULL, 36, NULL, NULL, 118455),
(118456, '3.40.1190.20-FF-000214', NULL, NULL, 323, NULL, NULL, 118456),
(118457, '3.40.50.10380-FF-000023', NULL, 'Malic enzyme', 255, NULL, NULL, 118457),
(118458, '1.20.900.10-FF-000038', NULL, 'Myosin-M heavy chain', 221, NULL, NULL, 118458),
(118459, '2.130.10.30-FF-000071', NULL, 'Claret, isoform A', 184, NULL, NULL, 118459),
(118460, '2.130.10.10-FF-005314', NULL, 'WD repeat-containing protein 16-like Protein', 205, NULL, NULL, 118460),
(118461, '2.70.160.11-FF-000017', NULL, 'Protein arginine N-methyltransferase 1.6', 187, NULL, NULL, 118461),
(118462, '3.80.10.10-FF-000610', NULL, 'Plant intracellular Ras-group-related LRR protein 9', 184, NULL, NULL, 118462),
(118463, '3.40.640.10-FF-000438', NULL, 'Uncharacterized protein', 273, NULL, NULL, 118463),
(118464, '1.20.1280.50-FF-000141', NULL, 'F-box only protein 7', 42, NULL, NULL, 118464),
(118465, '3.50.50.60-FF-000735', NULL, 'Oxidoreductase', 206, NULL, NULL, 118465),
(118466, '1.25.10.10-FF-001332', NULL, 'Uncharacterized protein', 468, NULL, NULL, 118466),
(118467, '3.40.850.10-FF-000095', NULL, 'Kinesin-like protein', 253, NULL, NULL, 118467),
(118468, '1.25.40.610-FF-000014', NULL, 'Uncharacterized protein', 95, NULL, NULL, 118468),
(118469, '2.40.70.10-FF-000449', NULL, NULL, 57, NULL, NULL, 118469),
(118470, '3.40.30.10-FF-000225', NULL, 'Thioredoxin-like protein AAED1 chloroplastic', 179, NULL, NULL, 118470),
(118471, '2.60.40.10-FF-003751', NULL, NULL, 106, NULL, NULL, 118471),
(118472, '2.170.120.40-FF-000015', NULL, 'YbbR family protein', 92, NULL, NULL, 118472),
(118473, '3.10.350.10-FF-000029', NULL, 'Membrane-bound lytic murein transglycosylase D', 65, NULL, NULL, 118473),
(118474, '1.20.1250.20-FF-002283', NULL, 'Uncharacterized protein', 87, NULL, NULL, 118474),
(118475, '1.10.510.10-FF-001511', NULL, 'Serine/threonine-protein kinase, putative', 220, NULL, NULL, 118475),
(118476, '2.60.40.10-FF-005342', NULL, NULL, 72, NULL, NULL, 118476),
(118477, '1.20.1270.60-FF-000036', NULL, 'Arf-GAP with SH3 domain, ANK repeat and PH domain-containing protein 3', 253, NULL, NULL, 118477),
(118478, '1.20.5.110-FF-000250', NULL, 'Uncharacterized protein', 99, NULL, NULL, 118478),
(118479, '1.20.58.1120-FF-000045', NULL, NULL, 102, NULL, NULL, 118479),
(118480, '2.60.120.920-FF-000105', NULL, 'Protein CBG15934', 153, NULL, NULL, 118480),
(118481, '3.30.300.110-FF-000011', NULL, 'tRNA(Phe) (4-demethylwyosine(37)-C(7)) aminocarboxypropyltransferase', 79, NULL, NULL, 118481),
(118482, '3.30.67.10-FF-000001', NULL, 'Envelope glycoprotein', 80, NULL, NULL, 118482);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(118483, '1.25.40.470-FF-000034', NULL, 'Coatomer alpha subunit putative', 172, NULL, NULL, 118483),
(118484, '4.10.240.10-FF-000096', NULL, 'C6 transcription factor, putative', 86, NULL, NULL, 118484),
(118485, '1.10.20.140-FF-000031', NULL, NULL, 79, NULL, NULL, 118485),
(118486, '1.20.58.80-FF-000040', NULL, 'MIT domain containing protein', 71, NULL, NULL, 118486),
(118487, '1.10.630.10-FF-000261', NULL, 'Cytochrome P450 52E1', 476, NULL, NULL, 118487),
(118488, '2.60.40.10-FF-002487', NULL, 'Immunoglobulin heavy variable 13-2', 103, NULL, NULL, 118488),
(118489, '1.25.40.10-FF-003930', NULL, 'Coatomer subunit epsilon', 288, NULL, NULL, 118489),
(118490, '1.20.58.90-FF-000043', NULL, NULL, 113, NULL, NULL, 118490),
(118491, '3.40.20.10-FF-000045', NULL, 'Actin binding protein, putative', 158, NULL, NULL, 118491),
(118492, '3.40.50.720-FF-001579', NULL, 'Uncharacterized oxidoreductase SPBC1348.09', 232, NULL, NULL, 118492),
(118493, '3.30.200.20-FF-001113', NULL, 'Serine/threonine-protein kinase D1044.8', 110, NULL, NULL, 118493),
(118494, '3.40.50.2000-FF-000787', NULL, 'Uncharacterized protein', 160, NULL, NULL, 118494),
(118495, '3.40.850.10-FF-000038', NULL, 'chromosome-associated kinesin KIF4A', 349, NULL, NULL, 118495),
(118496, '3.30.2090.10-FF-000015', NULL, 'Resistance-Nodulation-cell Division (RND) efflux transporter', 93, NULL, NULL, 118496),
(118497, '2.30.30.100-FF-000018', NULL, 'Small nuclear ribonucleoprotein Sm D2', 109, NULL, NULL, 118497),
(118498, '3.50.50.60-FF-000640', NULL, 'Probable polyamine oxidase 5', 163, NULL, NULL, 118498),
(118499, '2.130.10.10-FF-001048', NULL, 'BnaA09g40460D protein', 163, NULL, NULL, 118499),
(118500, '2.60.40.1180-FF-000003', NULL, '1,4-alpha-glucan-branching enzyme, chloroplastic/amyloplastic', 101, NULL, NULL, 118500),
(118501, '1.25.10.10-FF-002647', NULL, 'Predicted protein', 110, NULL, NULL, 118501),
(118502, '1.20.1250.20-FF-000563', NULL, 'Proton-dependent Oligopeptide Transporter (POT) Family', 506, NULL, NULL, 118502),
(118503, '3.40.50.410-FF-000064', NULL, 'RNA polymerase II transcription factor B subunit 4', 212, NULL, NULL, 118503),
(118504, '3.30.70.330-FF-001423', NULL, 'Feminization Of Germline', 106, NULL, NULL, 118504),
(118505, '3.10.580.10-FF-000131', NULL, 'CBS domain containing protein', 150, NULL, NULL, 118505),
(118506, '3.10.129.10-FF-000184', NULL, 'Acyl-ACP thioesterase family protein', 245, NULL, NULL, 118506),
(118507, '3.30.980.10-FF-000016', NULL, 'Threonine--tRNA ligase', 97, NULL, NULL, 118507),
(118508, '4.10.70.30-FF-000002', NULL, 'Disintegrin and metalloproteinase domain-containing protein 17', 62, NULL, NULL, 118508),
(118509, '3.50.50.60-FF-000847', NULL, 'Electron-transferring-flavoprotein dehydrogenase', 254, NULL, NULL, 118509),
(118510, '1.25.40.10-FF-004386', NULL, 'Uncharacterized protein', 143, NULL, NULL, 118510),
(118511, '1.20.1070.10-FF-000405', NULL, 'G-protein coupled receptor GRL101 precursor-like isoform X1', 302, NULL, NULL, 118511),
(118512, '3.30.40.10-FF-000715', NULL, 'E3 ubiquitin-protein ligase RING1', 66, NULL, NULL, 118512),
(118513, '1.20.1250.20-FF-000506', NULL, 'MFS transporter, putative', 205, NULL, NULL, 118513),
(118514, '1.10.1050.10-FF-000002', NULL, '30S ribosomal protein S4, chloroplastic', 100, NULL, NULL, 118514),
(118515, '3.30.1010.10-FF-000027', NULL, 'Atypical/PI4K protein kinase', 93, NULL, NULL, 118515),
(118516, '4.10.60.10-FF-000086', NULL, 'ATP-dependent DNA helicase Q4', 37, NULL, NULL, 118516),
(118517, '3.80.10.10-FF-003302', NULL, 'NLR family member X1', 71, NULL, NULL, 118517),
(118518, '3.30.160.60-FF-001784', NULL, 'Zinc finger protein 768', 35, NULL, NULL, 118518),
(118519, '3.30.9.100-FF-000003', NULL, 'Probable alkylhalidase homolog', 152, NULL, NULL, 118519),
(118520, '1.10.10.60-FF-001094', NULL, NULL, 71, NULL, NULL, 118520),
(118521, '2.60.120.620-FF-000010', NULL, 'Prolyl 3-hydroxylase OGFOD1 isoform 1', 222, NULL, NULL, 118521),
(118522, '3.40.50.720-FF-001270', NULL, 'ApbA-domain-containing protein', 133, NULL, NULL, 118522),
(118523, '3.40.140.10-FF-000220', NULL, 'Uncharacterized protein', 184, NULL, NULL, 118523);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(118524, '1.20.1280.170-FF-000005', NULL, 'Exocyst complex component 7', 449, NULL, NULL, 118524),
(118525, '2.120.10.80-FF-000378', NULL, 'Uncharacterized protein', 144, NULL, NULL, 118525),
(118526, '1.50.40.10-FF-000140', NULL, 'Mitochondriale tricarboxylate carrier protein', 285, NULL, NULL, 118526),
(118527, '3.40.630.30-FF-000213', NULL, 'GNAT family N-acetyltransferase', 158, NULL, NULL, 118527),
(118528, '1.20.1250.10-FF-000037', NULL, 'Prolactin', 189, NULL, NULL, 118528),
(118529, '3.40.850.10-FF-000252', NULL, 'Kinesin-like protein', 233, NULL, NULL, 118529),
(118530, '3.40.50.300-FF-003471', NULL, 'GG17442', 215, NULL, NULL, 118530),
(118531, '3.30.160.60-FF-005106', NULL, NULL, 24, NULL, NULL, 118531),
(118532, '2.130.10.30-FF-000149', NULL, NULL, 181, NULL, NULL, 118532),
(118533, '3.30.1490.20-FF-000037', NULL, 'D-alanine-D-alanine ligase family', 60, NULL, NULL, 118533),
(118534, '2.130.10.10-FF-003139', NULL, 'Tomosyn-like protein', 243, NULL, NULL, 118534),
(118535, '4.10.900.10-FF-000012', NULL, 'Putative DE-cadherin', 96, NULL, NULL, 118535),
(118536, '3.40.50.300-FF-003196', NULL, 'UvrABC system protein A', 148, NULL, NULL, 118536),
(118537, '1.20.1270.60-FF-000093', NULL, 'Rho GTPase-activating protein 92B', 221, NULL, NULL, 118537),
(118538, '3.30.470.10-FF-000051', NULL, 'Uncharacterized protein', 76, NULL, NULL, 118538),
(118539, '1.20.1070.10-FF-000462', NULL, 'Predicted protein', 321, NULL, NULL, 118539),
(118540, '3.30.200.20-FF-000618', NULL, 'Serine/threonine-protein kinase CTR1', 94, NULL, NULL, 118540),
(118541, '3.10.450.50-FF-000083', NULL, 'YALI0F00638p', 129, NULL, NULL, 118541),
(118542, '2.10.50.10-FF-000140', NULL, 'TNF receptor superfamily member 10c', 33, NULL, NULL, 118542),
(118543, '3.30.160.60-FF-005174', NULL, NULL, 38, NULL, NULL, 118543),
(118544, '3.30.70.330-FF-001069', NULL, 'Eukaryotic translation initiation factor 4H', 125, NULL, NULL, 118544),
(118545, '1.25.40.10-FF-001570', NULL, 'Tetratricopeptide-like helical', 120, NULL, NULL, 118545),
(118546, '2.60.40.10-FF-000896', NULL, 'kin of IRRE-like protein 2 isoform X2', 105, NULL, NULL, 118546),
(118547, '1.20.5.170-FF-000077', NULL, 'LAO/AO transport system kinase', 51, NULL, NULL, 118547),
(118548, '3.40.50.1820-FF-001110', NULL, 'Predicted protein', 171, NULL, NULL, 118548),
(118549, '2.20.100.10-FF-000142', NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 13', 60, NULL, NULL, 118549),
(118550, '3.60.130.10-FF-000018', NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', 307, NULL, NULL, 118550),
(118551, '3.30.710.10-FF-000148', NULL, 'Ribbon', 151, NULL, NULL, 118551),
(118552, '1.25.40.20-FF-001573', NULL, 'Uncharacterized protein', 47, NULL, NULL, 118552),
(118553, '3.40.33.10-FF-000142', NULL, 'Predicted protein', 147, NULL, NULL, 118553),
(118554, '3.40.50.300-FF-001880', NULL, 'Structural maintenance of chromosomes protein', 204, NULL, NULL, 118554),
(118555, '1.10.260.40-FF-000056', NULL, 'Transcriptional regulator', 77, NULL, NULL, 118555),
(118556, '3.30.40.10-FF-001530', NULL, 'Putative E3 ubiquitin-protein ligase UBR7', 67, NULL, NULL, 118556),
(118557, '1.25.10.10-FF-003187', NULL, 'Valyl-tRNA synthetase', 310, NULL, NULL, 118557),
(118558, '3.80.10.10-FF-004494', NULL, 'Leucine-rich repeat receptor-like tyrosine-protein kinase PXC3', 79, NULL, NULL, 118558),
(118559, '1.20.1540.10-FF-000043', NULL, 'Rhomboid family protease GlpG', 186, NULL, NULL, 118559),
(118560, '3.20.20.80-FF-000218', NULL, 'Chitinase domain-containing protein 1', 34, NULL, NULL, 118560),
(118561, '3.30.930.10-FF-000131', NULL, 'Proline--tRNA ligase, cytoplasmic', 259, NULL, NULL, 118561),
(118562, '3.10.50.40-FF-000012', NULL, 'Peptidylprolyl isomerase', 119, NULL, NULL, 118562),
(118563, '1.10.1060.10-FF-000008', NULL, 'Glycerol-3-phosphate dehydrogenase, anaerobic, C subunit', 87, NULL, NULL, 118563),
(118564, '3.40.850.10-FF-000370', NULL, 'Kinesin-like protein', 201, NULL, NULL, 118564),
(118565, '3.60.40.10-FF-000270', NULL, 'Stp1/IreP family PP2C-type Ser/Thr phosphatase', 272, NULL, NULL, 118565);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(118566, '2.20.50.20-FF-000002', NULL, 'Vitellogenin', 75, NULL, NULL, 118566),
(118567, '3.20.20.70-FF-000215', NULL, 'Dihydroorotate dehydrogenase A (fumarate)', 250, NULL, NULL, 118567),
(118568, '2.60.60.20-FF-000001', NULL, 'DENN domain containing 5B', 121, NULL, NULL, 118568),
(118569, '1.10.510.10-FF-001180', NULL, 'Cdc2-related kinase 8', 207, NULL, NULL, 118569),
(118570, '1.10.1370.10-FF-000048', NULL, 'Uncharacterized protein', 102, NULL, NULL, 118570),
(118571, '2.60.40.10-FF-005842', NULL, NULL, 106, NULL, NULL, 118571),
(118572, '3.30.160.60-FF-005516', NULL, NULL, 67, NULL, NULL, 118572),
(118573, '2.40.40.20-FF-000006', NULL, 'vesicle-fusing ATPase isoform X1', 81, NULL, NULL, 118573),
(118574, '2.30.29.30-FF-000854', NULL, 'Insulin receptor substrate 1-A', 57, NULL, NULL, 118574),
(118575, '2.60.40.10-FF-001413', NULL, 'Vasorin', 106, NULL, NULL, 118575),
(118576, '3.40.50.10330-FF-000104', NULL, 'NAD kinase', 124, NULL, NULL, 118576),
(118577, '3.40.250.10-FF-000127', NULL, 'Sulfurtransferase', 135, NULL, NULL, 118577),
(118578, '3.30.160.60-FF-001284', NULL, 'Zinc finger protein 236', 31, NULL, NULL, 118578),
(118579, '3.30.1360.40-FF-000039', NULL, 'Arginine repressor', 76, NULL, NULL, 118579),
(118580, '2.60.120.200-FF-000502', NULL, 'Agrin', 183, NULL, NULL, 118580),
(118581, '2.60.60.30-FF-000004', NULL, 'Tellurium resistance protein TerA', 163, NULL, NULL, 118581),
(118582, '3.50.50.60-FF-001067', NULL, 'Uncharacterized protein', 174, NULL, NULL, 118582),
(118583, '3.10.290.10-FF-000030', NULL, 'RNA pseudouridylate synthase', 57, NULL, NULL, 118583),
(118584, '1.10.510.10-FF-003720', NULL, NULL, 154, NULL, NULL, 118584),
(118585, '1.20.5.500-FF-000013', NULL, NULL, 49, NULL, NULL, 118585),
(118586, '1.20.1250.20-FF-000771', NULL, 'Blast:UNC93-like protein', 184, NULL, NULL, 118586),
(118587, '3.30.70.330-FF-002761', NULL, NULL, 80, NULL, NULL, 118587),
(118588, '3.90.810.10-FF-000013', NULL, 'Non-specific serine/threonine protein kinase', 69, NULL, NULL, 118588),
(118589, '1.20.1070.10-FF-000905', NULL, 'Uncharacterized protein', 318, NULL, NULL, 118589),
(118590, '2.40.40.10-FF-000003', NULL, 'Endolytic peptidoglycan transglycosylase RlpA', 94, NULL, NULL, 118590),
(118591, '3.30.70.330-FF-002497', NULL, NULL, 74, NULL, NULL, 118591),
(118592, '3.20.20.140-FF-000291', NULL, 'Probable histidinol-phosphatase', 227, NULL, NULL, 118592),
(118593, '1.25.40.20-FF-001516', NULL, 'Uncharacterized protein', 339, NULL, NULL, 118593),
(118594, '1.25.40.10-FF-001513', NULL, 'OSJNBa0060P14.4 protein', 90, NULL, NULL, 118594),
(118595, '3.40.50.720-FF-000455', NULL, 'Putative mitochondrial saccharopine dehydrogenase-like oxidoreductase', 177, NULL, NULL, 118595),
(118596, '3.30.365.10-FF-000031', NULL, 'Xanthine dehydrogenase', 232, NULL, NULL, 118596),
(118597, '2.60.40.10-FF-003487', NULL, NULL, 92, NULL, NULL, 118597),
(118598, '1.10.472.80-FF-000155', NULL, 'Putative rab-like GTPase activating protein', 142, NULL, NULL, 118598),
(118599, '3.30.60.30-FF-000121', NULL, 'Predicted protein', 53, NULL, NULL, 118599),
(118600, '1.20.1280.270-FF-000002', NULL, 'bifunctional arginine demethylase and lysyl-hydroxylase JMJD6 isoform X3', 26, NULL, NULL, 118600),
(118601, '3.40.50.11000-FF-000002', NULL, 'Fe-S cluster assembly protein DRE2', 138, NULL, NULL, 118601),
(118602, '3.40.50.300-FF-007911', NULL, 'Cytochrome P450 71A26', 185, NULL, NULL, 118602),
(118603, '1.25.40.10-FF-002795', NULL, 'Uncharacterized protein', 127, NULL, NULL, 118603),
(118604, '1.10.600.10-FF-000113', NULL, 'Predicted protein', 271, NULL, NULL, 118604),
(118605, '1.20.5.470-FF-000009', NULL, 'Argininosuccinate synthase', 36, NULL, NULL, 118605),
(118606, '3.40.50.150-FF-000874', NULL, NULL, 165, NULL, NULL, 118606),
(118607, '3.40.190.80-FF-000042', NULL, 'Inositol-1-monophosphatase', 122, NULL, NULL, 118607),
(118608, '1.10.10.10-FF-001039', NULL, 'LysR family transcriptional regulator', 85, NULL, NULL, 118608),
(118609, '1.25.40.10-FF-003312', NULL, 'Predicted protein', 116, NULL, NULL, 118609),
(118610, '3.30.465.10-FF-000128', NULL, 'Glycolate oxidase subunit glcE', 189, NULL, NULL, 118610); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(118611, '2.60.40.10-FF-004847', NULL, NULL, 122, NULL, NULL, 118611),
(118612, '3.60.40.10-FF-000118', NULL, 'Phosphatase 2C-like domain-containing protein', 269, NULL, NULL, 118612),
(118613, '1.25.40.10-FF-002475', NULL, 'Pentatricopeptide repeat-containing protein At4g01030, mitochondrial', 94, NULL, NULL, 118613),
(118614, '1.25.40.610-FF-000003', NULL, 'adhesion G protein-coupled receptor L3', 106, NULL, NULL, 118614),
(118615, '2.30.30.140-FF-000070', NULL, 'Scm like with four mbt domains 2', 119, NULL, NULL, 118615),
(118616, '2.130.10.10-FF-003280', NULL, 'Cilia- and flagella-associated protein 44', 153, NULL, NULL, 118616),
(118617, '2.60.40.10-FF-002695', NULL, 'High Incidence of Males (Increased X chromosome loss)', 92, NULL, NULL, 118617),
(118618, '1.20.58.760-FF-000006', NULL, 'ATP-dependent zinc metalloprotease FTSH 7, chloroplastic', 207, NULL, NULL, 118618),
(118619, '2.40.50.90-FF-000078', NULL, 'Nuclease homologue', 124, NULL, NULL, 118619),
(118620, '3.40.50.10190-FF-000135', NULL, 'DNA topoisomerase II-binding protein 1', 98, NULL, NULL, 118620),
(118621, '3.30.450.20-FF-000428', NULL, 'Sensor histidine kinase, PAS, PAS and PAS domain-containing', 132, NULL, NULL, 118621),
(118622, '1.20.1740.10-FF-000204', NULL, 'Uncharacterized protein', 152, NULL, NULL, 118622),
(118623, '3.90.320.10-FF-000026', NULL, 'ATP-dependent DNA helicase Dna2', 189, NULL, NULL, 118623),
(118624, '1.20.1420.10-FF-000034', NULL, NULL, 156, NULL, NULL, 118624),
(118625, '2.130.10.10-FF-005432', NULL, 'Uncharacterized protein', 339, NULL, NULL, 118625),
(118626, '3.40.50.150-FF-001537', NULL, NULL, 95, NULL, NULL, 118626),
(118627, '2.60.40.650-FF-000010', NULL, 'Nitrate reductase', 200, NULL, NULL, 118627),
(118628, '3.10.290.70-FF-000019', NULL, NULL, 56, NULL, NULL, 118628),
(118629, '3.40.630.10-FF-000387', NULL, 'Peptidase M20 domain-containing protein 2', 64, NULL, NULL, 118629),
(118630, '3.20.20.190-FF-000013', NULL, 'Glycerophosphodiester phosphodiesterase GDPDL3', 301, NULL, NULL, 118630),
(118631, '4.10.400.10-FF-000108', NULL, 'Low-density lipoprotein receptor-related protein 2', 46, NULL, NULL, 118631),
(118632, '1.10.530.10-FF-000051', NULL, 'Lytic transglycosylase, SLT, LysM and LysM domain-containing', 157, NULL, NULL, 118632),
(118633, '1.20.920.10-FF-000101', NULL, 'GM23532', 110, NULL, NULL, 118633),
(118634, '2.102.10.10-FF-000010', NULL, 'Ubiquinol-cytochrome c reductase iron-sulfur subunit', 154, NULL, NULL, 118634),
(118635, '1.25.40.20-FF-000145', NULL, 'NF-kappa-B inhibitor-like protein 1 isoform X1', 134, NULL, NULL, 118635),
(118636, '1.25.10.10-FF-001742', NULL, 'Pdr6p', 999, NULL, NULL, 118636),
(118637, '3.40.630.30-FF-000191', NULL, 'Hydrolase, NUDIX family protein', 88, NULL, NULL, 118637),
(118638, '3.30.1490.80-FF-000038', NULL, 'Glutathione synthetase-like Protein', 14, NULL, NULL, 118638),
(118639, '2.30.30.90-FF-000010', NULL, 'Iron-dependent repressor IdeR/DtxR', 76, NULL, NULL, 118639),
(118640, '1.20.1250.20-FF-002362', NULL, 'Predicted protein', 67, NULL, NULL, 118640),
(118641, '3.40.50.720-FF-002394', NULL, 'Uncharacterized protein', 86, NULL, NULL, 118641),
(118642, '1.10.8.10-FF-000122', NULL, 'Elongation factor Ts, mitochondrial', 65, NULL, NULL, 118642),
(118643, '3.40.50.450-FF-000110', NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase LOG7', 59, NULL, NULL, 118643),
(118644, '3.90.215.10-FF-000006', NULL, 'Fibrinogen beta chain', 262, NULL, NULL, 118644),
(118645, '1.10.630.10-FF-000148', NULL, 'Os05g0515200 protein', 492, NULL, NULL, 118645),
(118646, '1.10.260.100-FF-000032', NULL, 'Uncharacterized protein', 54, NULL, NULL, 118646),
(118647, '1.20.1070.10-FF-001400', NULL, 'Uncharacterized protein', 238, NULL, NULL, 118647),
(118648, '2.130.10.10-FF-002908', NULL, 'Uncharacterized protein', 170, NULL, NULL, 118648),
(118649, '3.30.499.10-FF-000015', NULL, 'Aconitate hydratase 1', 351, NULL, NULL, 118649),
(118650, '1.10.630.10-FF-000502', NULL, 'Obtusifoliol 14-alpha demethylase', 445, NULL, NULL, 118650),
(118651, '1.10.510.10-FF-003927', NULL, NULL, 73, NULL, NULL, 118651);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(118652, '1.20.58.1800-FF-000002', NULL, 'Trehalose-phosphatase', 117, NULL, NULL, 118652),
(118653, '3.60.10.10-FF-000324', NULL, 'Fgr14p', 261, NULL, NULL, 118653),
(118654, '3.40.50.300-FF-007068', NULL, 'Uncharacterized protein', 194, NULL, NULL, 118654),
(118655, '3.30.70.1730-FF-000023', NULL, '50S ribosomal protein L10', 134, NULL, NULL, 118655),
(118656, '1.20.1560.10-FF-000370', NULL, 'Novel protein similar to human transporter 2, ATP-binding cassette, sub-family B (MDR/TAP2)', 145, NULL, NULL, 118656),
(118657, '1.20.5.110-FF-000109', NULL, 'Vesicle-associated membrane protein 722', 47, NULL, NULL, 118657),
(118658, '3.30.460.10-FF-000044', NULL, 'ATPase synthesis protein 25, mitochondrial', 175, NULL, NULL, 118658),
(118659, '2.40.37.10-FF-000041', NULL, 'Alanine racemase', 136, NULL, NULL, 118659),
(118660, '2.30.29.170-FF-000008', NULL, 'EF-hand domain-containing protein 1', 135, NULL, NULL, 118660),
(118661, '1.10.510.10-FF-004203', NULL, NULL, 220, NULL, NULL, 118661),
(118662, '2.60.120.10-FF-000229', NULL, 'Uncharacterized protein, isoform C', 79, NULL, NULL, 118662),
(118663, '1.20.5.460-FF-000006', NULL, 'Malate/L-lactate dehydrogenase', 25, NULL, NULL, 118663),
(118664, '1.10.287.70-FF-000424', NULL, 'Sodium channel protein', 133, NULL, NULL, 118664),
(118665, '1.25.40.10-FF-001901', NULL, 'GM26497', 266, NULL, NULL, 118665),
(118666, '1.20.1250.20-FF-000153', NULL, 'MFS transporter', 212, NULL, NULL, 118666),
(118667, '3.30.160.60-FF-002301', NULL, 'Uncharacterized protein', 30, NULL, NULL, 118667),
(118668, '2.130.10.10-FF-003128', NULL, 'Protein CBG19705', 356, NULL, NULL, 118668),
(118669, '3.30.200.20-FF-000950', NULL, 'Os09g0559900 protein', 115, NULL, NULL, 118669),
(118670, '3.30.559.10-FF-000184', NULL, 'Brassinosteroid-related acyltransferase 1', 228, NULL, NULL, 118670),
(118671, '1.10.840.10-FF-000041', NULL, 'Cyclic GMP-binding protein C', 279, NULL, NULL, 118671),
(118672, '1.20.58.60-FF-000843', NULL, 'Uncharacterized protein', 146, NULL, NULL, 118672),
(118673, '3.100.10.10-FF-000028', NULL, 'LSU ribosomal protein L18E', 179, NULL, NULL, 118673),
(118674, '3.40.50.300-FF-008485', NULL, 'Putative multidrug resistance-associated protein lethal(2)03659-like Protein', 166, NULL, NULL, 118674),
(118675, '3.40.50.1820-FF-000216', NULL, 'Alpha/beta-Hydrolases superfamily protein', 219, NULL, NULL, 118675),
(118676, '3.30.590.10-FF-000048', NULL, 'Uncharacterized protein', 83, NULL, NULL, 118676),
(118677, '1.10.287.130-FF-000004', NULL, 'Ethylene receptor 1', 97, NULL, NULL, 118677),
(118678, '3.90.660.10-FF-000074', NULL, NULL, 69, NULL, NULL, 118678),
(118679, '3.10.590.10-FF-000013', NULL, 'RNA-binding protein, putative', 141, NULL, NULL, 118679),
(118680, '1.20.58.930-FF-000001', NULL, 'Biosynthetic arginine decarboxylase', 96, NULL, NULL, 118680),
(118681, '2.60.120.290-FF-000141', NULL, 'GD12774', 116, NULL, NULL, 118681),
(118682, '3.10.20.90-FF-000160', NULL, 'Polyubiquitin-C', 76, NULL, NULL, 118682),
(118683, '1.25.40.20-FF-001904', NULL, 'Uncharacterized protein', 208, NULL, NULL, 118683),
(118684, '3.20.20.370-FF-000011', NULL, 'Carbohydrate deacetylase', 233, NULL, NULL, 118684),
(118685, '3.30.413.10-FF-000014', NULL, 'Sulfite reductase [ferredoxin], chloroplastic', 151, NULL, NULL, 118685),
(118686, '6.10.250.3360-FF-000001', NULL, NULL, 44, NULL, NULL, 118686),
(118687, '3.40.50.2000-FF-000349', NULL, 'UDP-glucuronosyltransferase', 195, NULL, NULL, 118687),
(118688, '1.25.10.10-FF-002967', NULL, 'Uncharacterized protein', 419, NULL, NULL, 118688),
(118689, '3.30.900.10-FF-000062', NULL, 'Meiosis-specific protein hop1', 170, NULL, NULL, 118689),
(118690, '1.10.8.60-FF-000507', NULL, 'Uncharacterized protein', 62, NULL, NULL, 118690),
(118691, '1.10.10.10-FF-001152', NULL, 'Bacteriochlorophyllide d C-20 methyltransferase', 155, NULL, NULL, 118691),
(118692, '3.10.196.10-FF-000007', NULL, 'Methionine synthase', 202, NULL, NULL, 118692),
(118693, '2.10.25.10-FF-000065', NULL, 'Laminin subunit beta 1', 48, NULL, NULL, 118693),
(118694, '3.40.50.300-FF-006894', NULL, 'ABC-type sodium efflux system ATPase component NatA', 242, NULL, NULL, 118694);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(118695, '3.30.160.60-FF-003925', NULL, NULL, 82, NULL, NULL, 118695),
(118696, '3.40.50.720-FF-002517', NULL, 'D-3-phosphoglycerate dehydrogenase', 118, NULL, NULL, 118696),
(118697, '3.60.130.10-FF-000075', NULL, 'Predicted protein', 298, NULL, NULL, 118697),
(118698, '3.20.20.140-FF-000313', NULL, 'Amidohydrolase family protein', 305, NULL, NULL, 118698),
(118699, '2.60.40.10-FF-006005', NULL, NULL, 113, NULL, NULL, 118699),
(118700, '1.20.1250.20-FF-002305', NULL, 'Permeases of the major facilitator superfamily', 190, NULL, NULL, 118700),
(118701, '3.30.190.10-FF-000001', NULL, 'Ribulose bisphosphate carboxylase small chain, chloroplastic', 126, NULL, NULL, 118701),
(118702, '2.40.50.140-FF-000791', NULL, NULL, 96, NULL, NULL, 118702),
(118703, '3.50.50.60-FF-000527', NULL, 'Long-chain-alcohol oxidase', 168, NULL, NULL, 118703),
(118704, '3.90.190.10-FF-000111', NULL, 'Putative phosphatase', 159, NULL, NULL, 118704),
(118705, '1.10.10.10-FF-000876', NULL, 'Response regulator protein TodT', 67, NULL, NULL, 118705),
(118706, '2.60.40.10-FF-003712', NULL, NULL, 98, NULL, NULL, 118706),
(118707, '1.10.510.10-FF-003309', NULL, NULL, 77, NULL, NULL, 118707),
(118708, '1.10.1760.20-FF-000019', NULL, NULL, 169, NULL, NULL, 118708),
(118709, '2.60.120.200-FF-000277', NULL, 'Galectin', 139, NULL, NULL, 118709),
(118710, '1.10.510.10-FF-003366', NULL, NULL, 196, NULL, NULL, 118710),
(118711, '1.20.5.170-FF-000190', NULL, 'Cyclic AMP-responsive element-binding protein', 21, NULL, NULL, 118711),
(118712, '3.30.40.10-FF-000636', NULL, 'Protein CBG17014', 67, NULL, NULL, 118712),
(118713, '1.20.120.450-FF-000002', NULL, 'Maleylpyruvate isomerase family mycothiol-dependent enzyme', 155, NULL, NULL, 118713),
(118714, '2.130.10.10-FF-003403', NULL, 'Uncharacterized protein', 200, NULL, NULL, 118714),
(118715, '2.60.40.10-FF-001059', NULL, 'Uncharacterized protein, isoform C', 101, NULL, NULL, 118715),
(118716, '2.40.160.30-FF-000001', NULL, 'oxygen-evolving enhancer protein 1, chloroplastic', 163, NULL, NULL, 118716),
(118717, '3.40.710.10-FF-000034', NULL, 'D-alanyl-D-alanine carboxypeptidase', 262, NULL, NULL, 118717),
(118718, '1.10.510.10-FF-001741', NULL, 'Uncharacterized protein', 221, NULL, NULL, 118718),
(118719, '3.80.10.10-FF-004264', NULL, 'Protein-lysine N-methyltransferase EFM4', 259, NULL, NULL, 118719),
(118720, '3.40.50.300-FF-003460', NULL, 'Putative ribosome biogenesis GTPase RsgA', 185, NULL, NULL, 118720),
(118721, '2.10.25.10-FF-000683', NULL, 'Blast:Protein eyes shut', 50, NULL, NULL, 118721),
(118722, '3.30.70.1820-FF-000016', NULL, NULL, 88, NULL, NULL, 118722),
(118723, '1.25.10.10-FF-000848', NULL, 'Epoxyqueuosine reductase', 120, NULL, NULL, 118723),
(118724, '3.30.70.260-FF-000087', NULL, 'Aspartokinase', 73, NULL, NULL, 118724),
(118725, '3.30.70.360-FF-000061', NULL, 'Peptidase M20', 168, NULL, NULL, 118725),
(118726, '3.40.605.10-FF-000014', NULL, 'aldehyde dehydrogenase 22A1', 266, NULL, NULL, 118726),
(118727, '1.10.10.10-FF-001713', NULL, 'ATP-dependent DNA helicase', 174, NULL, NULL, 118727),
(118728, '1.10.10.10-FF-001770', NULL, 'ORC1-type DNA replication protein 10', 110, NULL, NULL, 118728),
(118729, '3.40.50.300-FF-005612', NULL, 'YALI0D15246p', 320, NULL, NULL, 118729),
(118730, '1.20.58.400-FF-000016', NULL, 'GD13885', 95, NULL, NULL, 118730),
(118731, '2.60.120.590-FF-000074', NULL, 'Os06g0286310 protein', 67, NULL, NULL, 118731),
(118732, '3.30.160.20-FF-000064', NULL, 'Uncharacterized protein, isoform A', 83, NULL, NULL, 118732),
(118733, '3.80.10.10-FF-004207', NULL, 'Uncharacterized protein', 88, NULL, NULL, 118733),
(118734, '1.25.40.10-FF-005167', NULL, 'Uncharacterized protein', 75, NULL, NULL, 118734),
(118735, '3.50.50.60-FF-001421', NULL, 'Rab proteins geranylgeranyltransferase', 125, NULL, NULL, 118735),
(118736, '3.20.20.70-FF-000035', NULL, 'Putative N-acetylmannosamine-6-phosphate 2-epimerase', 224, NULL, NULL, 118736),
(118737, '2.10.25.10-FF-000801', NULL, 'Notch homolog 2 N-terminal-like protein C', 38, NULL, NULL, 118737),
(118738, '1.20.1740.10-FF-000081', NULL, 'Uncharacterized protein, isoform A', 146, NULL, NULL, 118738);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(118739, '3.20.20.80-FF-000038', NULL, '1,3-beta-glucanosyltransferase', 318, NULL, NULL, 118739),
(118740, '3.90.380.10-FF-000024', NULL, NULL, 231, NULL, NULL, 118740),
(118741, '3.40.50.300-FF-007349', NULL, 'Uncharacterized protein', 158, NULL, NULL, 118741),
(118742, '2.30.42.10-FF-000424', NULL, NULL, 96, NULL, NULL, 118742),
(118743, '3.30.160.60-FF-003257', NULL, NULL, 27, NULL, NULL, 118743),
(118744, '3.80.10.10-FF-000048', NULL, 'BDNF/NT-3 growth factors receptor', 154, NULL, NULL, 118744),
(118745, '2.60.40.10-FF-001626', NULL, 'titin isoform X1', 88, NULL, NULL, 118745),
(118746, '1.25.40.370-FF-000009', NULL, 'Apaf-1/CED-4-related caspase activator Dapaf-1S', 95, NULL, NULL, 118746),
(118747, '1.20.1640.10-FF-000022', NULL, 'Dispatched RND transporter family member 3', 180, NULL, NULL, 118747),
(118748, '3.40.50.1910-FF-000029', NULL, 'Sec1 family domain-containing protein MIP3', 97, NULL, NULL, 118748),
(118749, '2.130.10.10-FF-000992', NULL, 'WD repeat-containing protein 16', 180, NULL, NULL, 118749),
(118750, '1.25.40.10-FF-003582', NULL, 'histone demethylase UTY', 170, NULL, NULL, 118750),
(118751, '3.30.160.60-FF-006005', NULL, NULL, 39, NULL, NULL, 118751),
(118752, '1.20.1250.20-FF-002249', NULL, 'Uncharacterized protein', 111, NULL, NULL, 118752),
(118753, '3.30.160.60-FF-003313', NULL, 'transcription factor grauzone isoform X2', 22, NULL, NULL, 118753),
(118754, '2.30.29.30-FF-000287', NULL, 'TBC1 domain family member 4 isoform X1', 173, NULL, NULL, 118754),
(118755, '1.20.120.1220-FF-000010', NULL, 'Putative type 4 prepilin-like proteins leader peptide-processing enzyme', 148, NULL, NULL, 118755),
(118756, '3.30.930.10-FF-000013', NULL, 'Aspartate--tRNA ligase, cytoplasmic', 351, NULL, NULL, 118756),
(118757, '3.40.190.10-FF-000919', NULL, 'Uncharacterized protein', 80, NULL, NULL, 118757),
(118758, '1.10.150.650-FF-000003', NULL, 'Php domain n-terminal region:php domain c-terminal region', 72, NULL, NULL, 118758),
(118759, '3.40.33.10-FF-000030', NULL, 'Cysteine-rich secretory protein, putative', 142, NULL, NULL, 118759),
(118760, '3.40.630.10-FF-000269', NULL, 'Uncharacterized protein YqgT', 290, NULL, NULL, 118760),
(118761, '3.40.50.150-FF-001655', NULL, NULL, 205, NULL, NULL, 118761),
(118762, '2.60.40.10-FF-003717', NULL, NULL, 108, NULL, NULL, 118762),
(118763, '3.30.230.70-FF-000096', NULL, 'YALI0E06039p', 262, NULL, NULL, 118763),
(118764, '3.60.40.10-FF-000039', NULL, 'Stage II sporulation protein E', 219, NULL, NULL, 118764),
(118765, '3.30.70.141-FF-000007', NULL, 'Protein XRP2', 121, NULL, NULL, 118765),
(118766, '3.10.450.240-FF-000020', NULL, 'Uncharacterized protein', 160, NULL, NULL, 118766),
(118767, '3.80.10.10-FF-004382', NULL, 'Uncharacterized protein', 365, NULL, NULL, 118767),
(118768, '2.40.240.10-FF-000046', NULL, 'Glutaminyl-tRNA synthetase', 132, NULL, NULL, 118768),
(118769, '3.40.309.10-FF-000096', NULL, 'Aldehyde dehydrogenase', 199, NULL, NULL, 118769),
(118770, '3.40.50.300-FF-005270', NULL, 'Gluconokinase', 182, NULL, NULL, 118770),
(118771, '2.130.10.10-FF-001604', NULL, 'WD domain, G-beta repeat-containing protein', 352, NULL, NULL, 118771),
(118772, '3.30.70.330-FF-000288', NULL, 'Splicing factor 3b subunit 4', 95, NULL, NULL, 118772),
(118773, '3.30.505.10-FF-000008', NULL, 'SH2B adapter protein 1 isoform 2', 112, NULL, NULL, 118773),
(118774, '1.20.5.170-FF-000251', NULL, 'Predicted protein', 68, NULL, NULL, 118774),
(118775, '1.10.10.60-FF-000599', NULL, 'Two-component system sensor histidine kinase', 54, NULL, NULL, 118775),
(118776, '3.90.1150.10-FF-000484', NULL, 'GH27315p', 60, NULL, NULL, 118776),
(118777, '3.40.30.10-FF-001237', NULL, 'Protein disulfide-isomerase', 95, NULL, NULL, 118777),
(118778, '1.10.150.670-FF-000009', NULL, 'Methyl methanesulfonate sensitivity 4', 98, NULL, NULL, 118778),
(118779, '2.130.10.10-FF-000025', NULL, 'FIZZY-related 2 isoform 1', 303, NULL, NULL, 118779),
(118780, '3.40.20.10-FF-000163', NULL, 'Twinfilin', 129, NULL, NULL, 118780),
(118781, '3.40.50.300-FF-003134', NULL, 'Hypothetical alanine and arginine rich protein', 201, NULL, NULL, 118781);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(118782, '1.10.565.10-FF-000024', NULL, 'Nuclear receptor subfamily 1 group I member 2', 292, NULL, NULL, 118782),
(118783, '3.40.50.720-FF-000893', NULL, 'Quinone reductase-like protein', 148, NULL, NULL, 118783),
(118784, '3.30.1490.100-FF-000019', NULL, 'Putative DNA polymerase iota', 153, NULL, NULL, 118784),
(118785, '3.40.50.2300-FF-001046', NULL, NULL, 149, NULL, NULL, 118785),
(118786, '1.25.40.120-FF-000070', NULL, 'Uncharacterized protein', 171, NULL, NULL, 118786),
(118787, '1.20.1720.10-FF-000023', NULL, 'Tetracycline resistance protein TETA(L)/TETK', 235, NULL, NULL, 118787),
(118788, '1.10.10.500-FF-000007', NULL, NULL, 52, NULL, NULL, 118788),
(118789, '3.40.250.10-FF-000009', NULL, 'tRNA 2-selenouridine/geranyl-2-thiouridine synthase', 130, NULL, NULL, 118789),
(118790, '3.30.70.1230-FF-000210', NULL, 'Uncharacterized protein', 128, NULL, NULL, 118790),
(118791, '4.10.280.10-FF-000227', NULL, 'Transcription factor bHLH14', 77, NULL, NULL, 118791),
(118792, '1.20.58.2220-FF-000010', NULL, 'Uncharacterized protein, isoform C', 393, NULL, NULL, 118792),
(118793, '1.25.40.10-FF-001339', NULL, 'Prolyl 3-hydroxylase 2', 106, NULL, NULL, 118793),
(118794, '1.20.1250.10-FF-000099', NULL, NULL, 164, NULL, NULL, 118794),
(118795, '1.10.238.10-FF-001142', NULL, 'Uncharacterized protein', 144, NULL, NULL, 118795),
(118796, '3.40.1410.10-FF-000038', NULL, 'GntR family transcriptional regulator', 170, NULL, NULL, 118796),
(118797, '3.80.10.10-FF-002139', NULL, 'Predicted protein', 136, NULL, NULL, 118797),
(118798, '2.40.50.140-FF-000408', NULL, 'Ribonuclease R', 108, NULL, NULL, 118798),
(118799, '3.90.190.10-FF-000375', NULL, 'Paladin', 337, NULL, NULL, 118799),
(118800, '3.20.190.10-FF-000003', NULL, 'endonuclease 8-like 1 isoform X1', 133, NULL, NULL, 118800),
(118801, '3.30.300.30-FF-000163', NULL, 'Hydroxamate-type ferrichrome siderophore peptide synthetase', 83, NULL, NULL, 118801),
(118802, '1.25.10.10-FF-000899', NULL, 'Microtubule associated protein, putative', 225, NULL, NULL, 118802),
(118803, '3.90.1150.10-FF-000439', NULL, 'Putative transcriptional regulator, GntR family', 163, NULL, NULL, 118803),
(118804, '1.10.357.140-FF-000029', NULL, '1,4-dihydroxy-2-naphthoate prenyltransferase', 155, NULL, NULL, 118804),
(118805, '6.10.250.3310-FF-000003', NULL, 'Signal transducer and activator of transcription 1', 42, NULL, NULL, 118805),
(118806, '1.10.565.10-FF-000075', NULL, 'Retinoic acid receptor', 244, NULL, NULL, 118806),
(118807, '2.30.29.30-FF-000236', NULL, 'Unconventional myosin-X', 109, NULL, NULL, 118807),
(118808, '1.10.10.440-FF-000023', NULL, 'Uncharacterized protein, isoform C', 68, NULL, NULL, 118808),
(118809, '2.40.50.770-FF-000018', NULL, 'Uncharacterized protein', 136, NULL, NULL, 118809),
(118810, '3.30.450.260-FF-000004', NULL, 'Soluble guanylate cyclase 88E', 138, NULL, NULL, 118810),
(118811, '3.30.450.250-FF-000001', NULL, 'Signal transduction histidine kinase', 87, NULL, NULL, 118811),
(118812, '3.40.50.1820-FF-000946', NULL, 'YALI0F16687p', 304, NULL, NULL, 118812),
(118813, '3.40.50.12230-FF-000028', NULL, 'Uncharacterized protein', 133, NULL, NULL, 118813),
(118814, '3.40.850.10-FF-000538', NULL, 'Uncharacterized protein', 328, NULL, NULL, 118814),
(118815, '1.20.5.170-FF-000195', NULL, 'Intermediate filament protein ifb-2', 58, NULL, NULL, 118815),
(118816, '2.60.40.60-FF-001057', NULL, 'Uncharacterized protein', 72, NULL, NULL, 118816),
(118817, '1.10.238.10-FF-001086', NULL, 'Uncharacterized protein', 89, NULL, NULL, 118817),
(118818, '2.30.29.30-FF-000343', NULL, 'Calcium-dependent secretion activator', 114, NULL, NULL, 118818),
(118819, '3.60.21.70-FF-000002', NULL, 'YGR266W-like protein', 415, NULL, NULL, 118819),
(118820, '3.30.200.20-FF-000793', NULL, 'Serine/threonine protein kinase', 116, NULL, NULL, 118820),
(118821, '3.30.1360.200-FF-000009', NULL, 'Bifunctional preprotein translocase subunit SecD/SecF', 155, NULL, NULL, 118821),
(118822, '3.30.200.20-FF-002187', NULL, 'Uncharacterized protein', 55, NULL, NULL, 118822),
(118823, '3.80.10.10-FF-004319', NULL, 'Uncharacterized protein', 206, NULL, NULL, 118823);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(118824, '1.10.8.10-FF-000061', NULL, 'ubiquitin-associated domain-containing protein 1', 81, NULL, NULL, 118824),
(118825, '2.60.120.10-FF-000241', NULL, 'Cyclic nucleotide-binding domain containing protein, putative', 135, NULL, NULL, 118825),
(118826, '1.25.40.20-FF-001494', NULL, 'Uncharacterized protein', 77, NULL, NULL, 118826),
(118827, '1.20.120.1240-FF-000016', NULL, 'Dynamin GTPase', 243, NULL, NULL, 118827),
(118828, '3.40.50.300-FF-005258', NULL, 'Uncharacterized protein', 294, NULL, NULL, 118828),
(118829, '3.40.50.1820-FF-000839', NULL, 'Serine carboxypeptidase S28 family protein', 130, NULL, NULL, 118829),
(118830, '1.25.40.180-FF-000278', NULL, NULL, 166, NULL, NULL, 118830),
(118831, '3.40.50.300-FF-003078', NULL, 'Rho family GTPase', 187, NULL, NULL, 118831),
(118832, '2.130.10.10-FF-001548', NULL, 'Autophagy-related protein 16 isoform A', 143, NULL, NULL, 118832),
(118833, '1.10.246.80-FF-000001', NULL, 'CCA-adding enzyme', 57, NULL, NULL, 118833),
(118834, '2.130.10.10-FF-001329', NULL, 'Set1 WD40 repeat protein', 303, NULL, NULL, 118834),
(118835, '1.10.10.2770-FF-000003', NULL, 'Selenocysteine-specific elongation factor', 131, NULL, NULL, 118835),
(118836, '3.40.50.10420-FF-000024', NULL, '5-formyltetrahydrofolate cyclo-ligase', 206, NULL, NULL, 118836),
(118837, '1.25.40.180-FF-000334', NULL, NULL, 186, NULL, NULL, 118837),
(118838, '1.25.10.10-FF-001630', NULL, 'Plakophilin 2', 475, NULL, NULL, 118838),
(118839, '3.30.450.70-FF-000039', NULL, NULL, 81, NULL, NULL, 118839),
(118840, '3.30.310.130-FF-000002', NULL, 'SUMO specific peptidase 6', 78, NULL, NULL, 118840),
(118841, '3.40.50.2300-FF-001153', NULL, NULL, 140, NULL, NULL, 118841),
(118842, '3.30.70.330-FF-000069', NULL, 'CUGBP Elav-like family member 5 isoform X1', 101, NULL, NULL, 118842),
(118843, '1.10.8.60-FF-000266', NULL, 'Related to RIX7-AAA-type ATPase required for biogenesis and nuclear export of 60S ribosomal subunits', 124, NULL, NULL, 118843),
(118844, '2.40.50.90-FF-000191', NULL, 'AT14886p', 63, NULL, NULL, 118844),
(118845, '1.25.40.10-FF-003256', NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', 162, NULL, NULL, 118845),
(118846, '2.60.120.590-FF-000012', NULL, 'AlkB homolog 8, tRNA methyltransferase', 219, NULL, NULL, 118846),
(118847, '1.10.8.10-FF-000010', NULL, 'Putative ubiquitin-conjugating enzyme e2 k', 42, NULL, NULL, 118847),
(118848, '1.10.10.60-FF-000981', NULL, NULL, 92, NULL, NULL, 118848),
(118849, '3.40.390.10-FF-000233', NULL, NULL, 83, NULL, NULL, 118849),
(118850, '1.10.220.30-FF-000011', NULL, 'Flagellar motor switch protein FliG', 87, NULL, NULL, 118850),
(118851, '2.60.40.150-FF-000697', NULL, 'Protein kinase N3', 155, NULL, NULL, 118851),
(118852, '3.40.50.1820-FF-000098', NULL, 'palmitoyl-protein thioesterase 1', 285, NULL, NULL, 118852),
(118853, '3.30.710.10-FF-000429', NULL, 'Transmembrane 9 superfamily member 4-like Protein', 99, NULL, NULL, 118853),
(118854, '3.30.450.60-FF-000036', NULL, 'Clathrin adaptor complex small chain subfamily protein', 148, NULL, NULL, 118854),
(118855, '1.25.40.820-FF-000015', NULL, 'Uncharacterized protein', 161, NULL, NULL, 118855),
(118856, '3.30.450.20-FF-000608', NULL, 'Sensor histidine kinase, Cache_1 and HAMP domain-containing', 137, NULL, NULL, 118856),
(118857, '3.40.50.720-FF-000718', NULL, 'Putative oxidoreductase', 221, NULL, NULL, 118857),
(118858, '3.30.160.60-FF-004100', NULL, NULL, 26, NULL, NULL, 118858),
(118859, '3.40.50.800-FF-000035', NULL, 'Prolyl-tRNA synthetase', 110, NULL, NULL, 118859),
(118860, '2.10.25.10-FF-000060', NULL, 'Neurogenic locus notch protein 1', 38, NULL, NULL, 118860),
(118861, '3.20.20.80-FF-000252', NULL, 'Putative myosin class II heavy chain', 135, NULL, NULL, 118861),
(118862, '2.60.40.2030-FF-000028', NULL, 'Adhesion G-protein coupled receptor V1', 120, NULL, NULL, 118862),
(118863, '1.20.1070.10-FF-001170', NULL, 'Predicted protein', 290, NULL, NULL, 118863),
(118864, '1.25.40.10-FF-002918', NULL, 'Pentatricopeptide repeat-containing protein', 176, NULL, NULL, 118864);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(118865, '2.130.10.10-FF-005090', NULL, 'Uncharacterized protein', 359, NULL, NULL, 118865),
(118866, '3.20.20.80-FF-000364', NULL, 'Glucosylceramidase', 74, NULL, NULL, 118866),
(118867, '3.80.10.10-FF-002465', NULL, 'Uncharacterized protein', 123, NULL, NULL, 118867),
(118868, '3.10.310.10-FF-000044', NULL, 'Diaminopimelate epimerase', 156, NULL, NULL, 118868),
(118869, '1.10.565.10-FF-000131', NULL, 'Nuclear receptor', 213, NULL, NULL, 118869),
(118870, '3.40.50.300-FF-003353', NULL, 'Dynein heavy chain', 334, NULL, NULL, 118870),
(118871, '1.20.1070.10-FF-002148', NULL, 'Olfactory receptor', 181, NULL, NULL, 118871),
(118872, '1.10.150.20-FF-000238', NULL, 'Ubiquitin carrier protein 7', 85, NULL, NULL, 118872),
(118873, '2.40.420.20-FF-000035', NULL, 'ABC transporter substrate-binding protein', 67, NULL, NULL, 118873),
(118874, '2.40.10.480-FF-000002', NULL, 'Cell surface protein', 61, NULL, NULL, 118874),
(118875, '3.20.20.100-FF-000088', NULL, 'Uncharacterized protein', 112, NULL, NULL, 118875),
(118876, '3.40.1130.10-FF-000005', NULL, 'Glycerol-3-phosphate acyltransferase', 105, NULL, NULL, 118876),
(118877, '3.60.10.10-FF-000274', NULL, 'CCR4-NOT transcription complex subunit 6-like isoform X1', 403, NULL, NULL, 118877),
(118878, '1.20.1070.10-FF-000057', NULL, 'Beta-1 adrenergic receptor', 326, NULL, NULL, 118878),
(118879, '1.20.80.10-FF-000060', NULL, 'Acyl CoA binding protein, putative', 97, NULL, NULL, 118879),
(118880, '3.30.710.10-FF-000474', NULL, 'Uncharacterized protein', 101, NULL, NULL, 118880),
(118881, '1.20.58.1030-FF-000024', NULL, 'DNA replication complex GINS protein SLD5', 205, NULL, NULL, 118881),
(118882, '3.40.50.2000-FF-000669', NULL, 'Glycosyl transferase group 1', 209, NULL, NULL, 118882),
(118883, '1.20.1250.20-FF-000158', NULL, 'Solute carrier family 15 member 2', 142, NULL, NULL, 118883),
(118884, '1.20.1420.30-FF-000085', NULL, 'Putative cation exchanger C3A12.06c', 124, NULL, NULL, 118884),
(118885, '3.40.50.620-FF-000751', NULL, 'Uncharacterized protein', 145, NULL, NULL, 118885),
(118886, '1.25.40.10-FF-001165', NULL, 'Predicted TPR repeat protein', 133, NULL, NULL, 118886),
(118887, '3.30.559.10-FF-000189', NULL, 'Predicted protein', 74, NULL, NULL, 118887),
(118888, '1.25.40.20-FF-001168', NULL, 'Uncharacterized protein', 70, NULL, NULL, 118888),
(118889, '2.60.120.650-FF-000171', NULL, 'Lysine demethylase 4C', 167, NULL, NULL, 118889),
(118890, '1.25.40.10-FF-004942', NULL, 'Uncharacterized protein', 185, NULL, NULL, 118890),
(118891, '3.40.50.720-FF-000781', NULL, 'YML131W-like protein', 186, NULL, NULL, 118891),
(118892, '2.60.120.260-FF-000593', NULL, 'Uncharacterized protein', 152, NULL, NULL, 118892),
(118893, '3.40.1180.10-FF-000042', NULL, 'Uncharacterized protein', 261, NULL, NULL, 118893),
(118894, '2.60.40.10-FF-005960', NULL, NULL, 84, NULL, NULL, 118894),
(118895, '3.30.160.60-FF-001166', NULL, 'Phage integrase', 64, NULL, NULL, 118895),
(118896, '3.30.70.330-FF-002435', NULL, NULL, 156, NULL, NULL, 118896),
(118897, '3.30.70.2850-FF-000033', NULL, 'DNA-directed RNA polymerase subunit', 140, NULL, NULL, 118897),
(118898, '3.40.50.2000-FF-000169', NULL, 'UDP-Glycosyltransferase superfamily protein', 195, NULL, NULL, 118898),
(118899, '1.20.1110.10-FF-000050', NULL, 'Cation transporting P-ATPase', 174, NULL, NULL, 118899),
(118900, '3.30.40.10-FF-001204', NULL, 'Putative E3 ubiquitin-protein ligase RHY1A', 89, NULL, NULL, 118900),
(118901, '3.30.1110.10-FF-000006', NULL, 'adenosine kinase', 65, NULL, NULL, 118901),
(118902, '3.90.1290.10-FF-000022', NULL, 'Dystonin', 110, NULL, NULL, 118902),
(118903, '3.40.50.2300-FF-001102', NULL, 'Taste receptor type 1 member 2', 293, NULL, NULL, 118903),
(118904, '3.30.519.10-FF-000029', NULL, NULL, 164, NULL, NULL, 118904),
(118905, '1.10.8.60-FF-000215', NULL, 'BMA-SPAS-1, isoform e', 83, NULL, NULL, 118905),
(118906, '3.90.190.10-FF-000431', NULL, 'Uncharacterized protein', 73, NULL, NULL, 118906),
(118907, '1.20.1560.10-FF-000139', NULL, 'ATP-binding Cassette (ABC) Superfamily', 332, NULL, NULL, 118907);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(118908, '3.100.10.10-FF-000023', NULL, '50S ribosomal protein L15', 83, NULL, NULL, 118908),
(118909, '2.60.40.10-FF-005067', NULL, NULL, 101, NULL, NULL, 118909),
(118910, '3.40.140.20-FF-000010', NULL, NULL, 43, NULL, NULL, 118910),
(118911, '3.40.1110.10-FF-000061', NULL, 'Potassium-transporting ATPase alpha chain 1', 220, NULL, NULL, 118911),
(118912, '1.25.40.660-FF-000001', NULL, 'Vacuolar protein sorting-associated protein 35', 311, NULL, NULL, 118912),
(118913, '3.60.110.10-FF-000079', NULL, NULL, 269, NULL, NULL, 118913),
(118914, '3.20.20.300-FF-000086', NULL, NULL, 35, NULL, NULL, 118914),
(118915, '2.60.40.10-FF-005281', NULL, NULL, 84, NULL, NULL, 118915),
(118916, '2.60.40.4100-FF-000003', NULL, 'Transforming growth factor beta receptor type 3', 176, NULL, NULL, 118916),
(118917, '1.20.1050.10-FF-000174', NULL, 'Glutathione S-transferase', 132, NULL, NULL, 118917),
(118918, '3.40.50.720-FF-002068', NULL, 'Ubiquitin-like modifier-activating enzyme 1', 155, NULL, NULL, 118918),
(118919, '1.20.1250.20-FF-001052', NULL, 'High-affinity nicotinic acid transporter, putative', 208, NULL, NULL, 118919),
(118920, '1.10.8.10-FF-000280', NULL, 'Putative BOI-related E3 ubiquitin-protein ligase 3', 33, NULL, NULL, 118920),
(118921, '3.50.50.60-FF-000292', NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase', 256, NULL, NULL, 118921),
(118922, '3.30.160.60-FF-005437', NULL, NULL, 54, NULL, NULL, 118922),
(118923, '3.90.1170.50-FF-000025', NULL, 'Uncharacterized protein', 35, NULL, NULL, 118923),
(118924, '1.10.510.10-FF-003192', NULL, NULL, 242, NULL, NULL, 118924),
(118925, '1.10.10.60-FF-001037', NULL, NULL, 64, NULL, NULL, 118925),
(118926, '3.40.50.300-FF-001728', NULL, 'Ras related protein1', 108, NULL, NULL, 118926),
(118927, '1.20.1250.20-FF-001788', NULL, 'Allantoate transporter', 180, NULL, NULL, 118927),
(118928, '3.40.50.2300-FF-001372', NULL, NULL, 77, NULL, NULL, 118928),
(118929, '3.30.450.50-FF-000033', NULL, 'Putative SNARE protein', 64, NULL, NULL, 118929),
(118930, '3.30.160.60-FF-002060', NULL, NULL, 28, NULL, NULL, 118930),
(118931, '3.40.30.10-FF-000500', NULL, 'TCHQD class glutathione S-transferase', 78, NULL, NULL, 118931),
(118932, '3.30.450.40-FF-000030', NULL, 'IclR family transcriptional regulator', 177, NULL, NULL, 118932),
(118933, '3.90.180.10-FF-000043', NULL, 'Alcohol dehydrogenase, variant', 172, NULL, NULL, 118933),
(118934, '2.70.98.10-FF-000085', NULL, 'Beta-galactosidase', 290, NULL, NULL, 118934),
(118935, '1.25.40.10-FF-003812', NULL, 'Uncharacterized protein', 137, NULL, NULL, 118935),
(118936, '2.60.120.290-FF-000085', NULL, 'Uncharacterized protein', 114, NULL, NULL, 118936),
(118937, '2.30.30.830-FF-000006', NULL, 'Competence protein D', 80, NULL, NULL, 118937),
(118938, '3.30.200.20-FF-000101', NULL, 'CDPK-related kinase 1', 96, NULL, NULL, 118938),
(118939, '3.90.1170.40-FF-000022', NULL, 'Os02g0517366 protein', 80, NULL, NULL, 118939),
(118940, '1.20.1310.20-FF-000034', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 177, NULL, NULL, 118940),
(118941, '3.30.70.100-FF-000011', NULL, 'Acylphosphatase', 99, NULL, NULL, 118941),
(118942, '3.40.50.2300-FF-000259', NULL, 'Uncharacterized protein', 178, NULL, NULL, 118942),
(118943, '2.30.42.10-FF-000194', NULL, 'ligand of Numb protein X 2', 122, NULL, NULL, 118943),
(118944, '3.30.160.60-FF-004948', NULL, NULL, 35, NULL, NULL, 118944),
(118945, '1.20.58.60-FF-000343', NULL, 'SMAll', 106, NULL, NULL, 118945),
(118946, '3.40.720.10-FF-000034', NULL, 'Membrane-associated phospholipase C', 170, NULL, NULL, 118946),
(118947, '3.40.50.620-FF-000239', NULL, 'Leucine--tRNA ligase', 60, NULL, NULL, 118947),
(118948, '3.30.160.60-FF-003083', NULL, 'Zinc finger and SCAN domain containing protein 4F', 29, NULL, NULL, 118948),
(118949, '3.30.160.60-FF-003369', NULL, 'Zinc finger protein 778', 31, NULL, NULL, 118949),
(118950, '3.40.50.2300-FF-000990', NULL, NULL, 86, NULL, NULL, 118950),
(118951, '3.10.250.10-FF-000145', NULL, NULL, 105, NULL, NULL, 118951),
(118952, '3.40.50.300-FF-003971', NULL, 'Holdfast attachment protein C', 228, NULL, NULL, 118952);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(118953, '3.40.50.12780-FF-000058', NULL, 'Acetyl-coenzyme A synthetase', 430, NULL, NULL, 118953),
(118954, '3.40.50.150-FF-001251', NULL, NULL, 207, NULL, NULL, 118954),
(118955, '3.30.930.10-FF-000069', NULL, 'Seryl-tRNA synthetase', 339, NULL, NULL, 118955),
(118956, '2.60.120.920-FF-000100', NULL, 'Uncharacterized protein', 154, NULL, NULL, 118956),
(118957, '1.25.10.10-FF-003136', NULL, 'Diguanylate cyclase', 116, NULL, NULL, 118957),
(118958, '3.30.160.60-FF-003425', NULL, 'Zinc finger protein 655', 30, NULL, NULL, 118958),
(118959, '2.10.25.10-FF-000913', NULL, 'Coagulation factor VII', 37, NULL, NULL, 118959),
(118960, '2.20.25.350-FF-000006', NULL, NULL, 42, NULL, NULL, 118960),
(118961, '3.90.70.10-FF-000759', NULL, 'Uncharacterized protein', 98, NULL, NULL, 118961),
(118962, '3.30.40.10-FF-000187', NULL, 'E3 ubiquitin-protein ligase ATL6', 89, NULL, NULL, 118962),
(118963, '1.10.132.30-FF-000020', NULL, 'DNA-directed RNA polymerase subunit', 102, NULL, NULL, 118963),
(118964, '3.30.70.120-FF-000017', NULL, 'Periplasmic divalent cation tolerance protein', 107, NULL, NULL, 118964),
(118965, '1.20.1560.10-FF-000813', NULL, 'AGAP004602-PA', 136, NULL, NULL, 118965),
(118966, '3.30.70.260-FF-000031', NULL, 'LDLR chaperone MESD', 97, NULL, NULL, 118966),
(118967, '3.30.930.10-FF-000417', NULL, 'Uncharacterized protein', 351, NULL, NULL, 118967),
(118968, '1.50.40.10-FF-000084', NULL, 'Mitochondrial carrier protein, expressed', 192, NULL, NULL, 118968),
(118969, '1.25.40.10-FF-004268', NULL, 'Uncharacterized protein', 216, NULL, NULL, 118969),
(118970, '2.20.100.10-FF-000092', NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 13', 54, NULL, NULL, 118970),
(118971, '3.30.420.40-FF-000495', NULL, 'Heat shock protein 4b', 147, NULL, NULL, 118971),
(118972, '3.40.190.10-FF-000459', NULL, 'Glycine cleavage operon activator', 99, NULL, NULL, 118972),
(118973, '3.40.50.720-FF-000163', NULL, '6-phospho-beta-glucosidase', 170, NULL, NULL, 118973),
(118974, '3.30.70.270-FF-000034', NULL, 'Diguanylate cyclase domain protein', 171, NULL, NULL, 118974),
(118975, '1.20.1730.10-FF-000029', NULL, 'GM16419', 470, NULL, NULL, 118975),
(118976, '3.60.110.10-FF-000023', NULL, 'Related to NIT3-nitrilase', 336, NULL, NULL, 118976),
(118977, '2.60.120.200-FF-000777', NULL, 'Uncharacterized protein', 240, NULL, NULL, 118977),
(118978, '2.30.30.620-FF-000005', NULL, 'Major vault protein', 72, NULL, NULL, 118978),
(118979, '1.20.5.110-FF-000216', NULL, 'Uncharacterized protein', 68, NULL, NULL, 118979),
(118980, '4.10.80.340-FF-000001', NULL, 'Protein V', 52, NULL, NULL, 118980),
(118981, '2.40.50.140-FF-000178', NULL, 'Polyribonucleotide nucleotidyltransferase', 75, NULL, NULL, 118981),
(118982, '3.90.15.10-FF-000008', NULL, 'DNA topoisomerase I', 232, NULL, NULL, 118982),
(118983, '1.10.150.50-FF-000056', NULL, 'Ectoderm-expressed 4, isoform D', 70, NULL, NULL, 118983),
(118984, '1.20.58.1030-FF-000029', NULL, 'DNA replication complex GINS protein SLD5', 152, NULL, NULL, 118984),
(118985, '2.40.40.20-FF-000040', NULL, 'AAA family ATPase, CDC48 subfamily', 91, NULL, NULL, 118985),
(118986, '1.10.10.10-FF-001270', NULL, 'RpiR family transcriptional regulator', 76, NULL, NULL, 118986),
(118987, '1.10.287.810-FF-000005', NULL, 'Mitochondrial import inner membrane translocase subunit Tim8 B', 83, NULL, NULL, 118987),
(118988, '3.40.50.300-FF-007624', NULL, 'Uncharacterized protein', 147, NULL, NULL, 118988),
(118989, '3.40.50.150-FF-000020', NULL, 'Ribosomal RNA large subunit methyltransferase M', 182, NULL, NULL, 118989),
(118990, '3.30.70.100-FF-000062', NULL, 'Copper resistance-associated P-type ATPase', 71, NULL, NULL, 118990),
(118991, '1.10.287.470-FF-000033', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 70, NULL, NULL, 118991),
(118992, '3.40.50.300-FF-005770', NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 9', 107, NULL, NULL, 118992),
(118993, '2.70.50.80-FF-000006', NULL, 'Transcriptional enhancer factor TEF-1', 31, NULL, NULL, 118993),
(118994, '1.50.40.10-FF-000202', NULL, 'AT11877p', 305, NULL, NULL, 118994);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(118995, '3.40.50.2000-FF-000383', NULL, 'Glycosyltransferase', 236, NULL, NULL, 118995),
(118996, '3.30.160.60-FF-004999', NULL, NULL, 49, NULL, NULL, 118996),
(118997, '2.10.230.10-FF-000024', NULL, 'Uncharacterized protein', 55, NULL, NULL, 118997),
(118998, '3.60.40.10-FF-000332', NULL, 'Uncharacterized protein', 157, NULL, NULL, 118998),
(118999, '1.10.10.10-FF-000994', NULL, 'DNA-directed RNA polymerase III subunit RPC3, putative', 72, NULL, NULL, 118999),
(119000, '2.60.40.4100-FF-000008', NULL, 'Zona pellucida-like domain containing 1a', 160, NULL, NULL, 119000),
(119001, '2.60.120.290-FF-000080', NULL, 'Zinc metalloproteinase', 123, NULL, NULL, 119001),
(119002, '1.25.40.10-FF-004616', NULL, 'AGAP010426-PA', 265, NULL, NULL, 119002),
(119003, '1.25.40.20-FF-000038', NULL, 'Arf-GAP with GTPase, ANK repeat and PH domain-containing protein 3', 100, NULL, NULL, 119003),
(119004, '2.40.50.140-FF-001072', NULL, NULL, 89, NULL, NULL, 119004),
(119005, '1.20.1270.10-FF-000038', NULL, 'Heat shock protein 110', 109, NULL, NULL, 119005),
(119006, '1.20.1720.10-FF-000079', NULL, NULL, 186, NULL, NULL, 119006),
(119007, '3.40.50.720-FF-002579', NULL, 'Uncharacterized protein', 23, NULL, NULL, 119007),
(119008, '1.10.630.10-FF-000109', NULL, 'Heme peroxidase', 432, NULL, NULL, 119008),
(119009, '1.20.1600.10-FF-000025', NULL, 'Multidrug efflux outer membrane protein OprN', 372, NULL, NULL, 119009),
(119010, '2.130.10.10-FF-004825', NULL, 'Uncharacterized protein', 137, NULL, NULL, 119010),
(119011, '3.40.50.300-FF-001509', NULL, 'Cytoplasmic dynein 1 light intermediate chain', 180, NULL, NULL, 119011),
(119012, '2.130.10.10-FF-005371', NULL, 'Uncharacterized protein', 165, NULL, NULL, 119012),
(119013, '3.40.50.2300-FF-000664', NULL, 'Sensory box sensor histidine kinase/response regulator', 135, NULL, NULL, 119013),
(119014, '3.40.50.1820-FF-000391', NULL, 'Putative acetyl hydrolase', 273, NULL, NULL, 119014),
(119015, '3.30.70.330-FF-000748', NULL, 'RNA Binding Motif protein homolog', 84, NULL, NULL, 119015),
(119016, '3.30.565.10-FF-000012', NULL, 'Heat shock cognate protein', 227, NULL, NULL, 119016),
(119017, '2.40.30.170-FF-000059', NULL, NULL, 56, NULL, NULL, 119017),
(119018, '3.40.1170.20-FF-000005', NULL, 'tRNA-splicing endonuclease', 68, NULL, NULL, 119018),
(119019, '2.130.10.10-FF-004477', NULL, 'GH20665p', 271, NULL, NULL, 119019),
(119020, '4.10.87.10-FF-000001', NULL, 'mRNA-capping enzyme', 48, NULL, NULL, 119020),
(119021, '3.40.1170.10-FF-000002', NULL, 'DNA mismatch repair protein', 166, NULL, NULL, 119021),
(119022, '3.40.50.300-FF-007175', NULL, 'Uncharacterized protein', 173, NULL, NULL, 119022),
(119023, '1.25.40.10-FF-000906', NULL, 'BnaA09g39930D protein', 117, NULL, NULL, 119023),
(119024, '2.60.40.10-FF-005286', NULL, NULL, 83, NULL, NULL, 119024),
(119025, '2.130.10.10-FF-003572', NULL, 'Os02g0539900 protein', 202, NULL, NULL, 119025),
(119026, '3.30.70.330-FF-002547', NULL, NULL, 37, NULL, NULL, 119026),
(119027, '1.10.287.70-FF-000761', NULL, 'Uncharacterized protein', 40, NULL, NULL, 119027),
(119028, '6.10.250.3260-FF-000004', NULL, 'LSU ribosomal protein L21E', 59, NULL, NULL, 119028),
(119029, '2.60.120.260-FF-000267', NULL, 'SCO-spondin', 160, NULL, NULL, 119029),
(119030, '3.30.200.20-FF-000949', NULL, 'Os11g0150700 protein', 86, NULL, NULL, 119030),
(119031, '1.10.150.50-FF-000112', NULL, 'Phospholipase DDHD2', 68, NULL, NULL, 119031),
(119032, '2.30.29.30-FF-000517', NULL, 'Adaptin earbinding coat-associated protein 2 (Necap-2) isoform', 122, NULL, NULL, 119032),
(119033, '3.30.1520.10-FF-000094', NULL, 'Kinesin family member 16B', 63, NULL, NULL, 119033),
(119034, '3.40.50.700-FF-000005', NULL, NULL, 169, NULL, NULL, 119034),
(119035, '4.10.1240.10-FF-000014', NULL, 'Growth hormone-releasing hormone receptor 2', 71, NULL, NULL, 119035),
(119036, '2.130.10.10-FF-003465', NULL, 'Expressed protein', 394, NULL, NULL, 119036),
(119037, '2.40.50.90-FF-000039', NULL, 'Tudor staphylococcal nuclease', 151, NULL, NULL, 119037),
(119038, '1.25.40.10-FF-004886', NULL, 'Uncharacterized protein', 101, NULL, NULL, 119038);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(119039, '3.20.70.20-FF-000052', NULL, 'Ribonucleoside-diphosphate reductase', 249, NULL, NULL, 119039),
(119040, '3.40.50.2000-FF-000725', NULL, 'Uncharacterized protein', 128, NULL, NULL, 119040),
(119041, '3.40.50.300-FF-005500', NULL, 'DNA helicase', 179, NULL, NULL, 119041),
(119042, '3.40.190.10-FF-000858', NULL, 'Uncharacterized protein', 54, NULL, NULL, 119042),
(119043, '2.40.50.140-FF-000739', NULL, NULL, 111, NULL, NULL, 119043),
(119044, '3.40.50.720-FF-002287', NULL, 'Uncharacterized protein', 200, NULL, NULL, 119044),
(119045, '3.40.50.300-FF-005551', NULL, 'Uncharacterized protein', 269, NULL, NULL, 119045),
(119046, '3.30.1960.10-FF-000020', NULL, 'Uncharacterized protein', 115, NULL, NULL, 119046),
(119047, '1.10.3090.10-FF-000010', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 286, NULL, NULL, 119047),
(119048, '1.10.287.130-FF-000066', NULL, 'PAS domain-containing sensor histidine kinase', 92, NULL, NULL, 119048),
(119049, '1.10.10.250-FF-000011', NULL, 'Rpl-12', 83, NULL, NULL, 119049),
(119050, '4.10.280.10-FF-000042', NULL, 'transcription factor bHLH48-like isoform X1', 73, NULL, NULL, 119050),
(119051, '1.20.1440.170-FF-000009', NULL, NULL, 119, NULL, NULL, 119051),
(119052, '1.10.510.10-FF-000044', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 208, NULL, NULL, 119052),
(119053, '3.60.10.10-FF-000386', NULL, 'Uncharacterized protein', 40, NULL, NULL, 119053),
(119054, '2.70.130.10-FF-000121', NULL, NULL, 170, NULL, NULL, 119054),
(119055, '2.40.50.100-FF-000014', NULL, 'Maltose/maltodextrin import ATP-binding protein MalK', 109, NULL, NULL, 119055),
(119056, '3.30.160.60-FF-005730', NULL, NULL, 32, NULL, NULL, 119056),
(119057, '1.10.8.60-FF-000322', NULL, 'Uncharacterized protein', 116, NULL, NULL, 119057),
(119058, '2.60.120.330-FF-000018', NULL, '2-oxoglutarate (2OG) and Fe(II)-dependent oxygenase superfamily protein', 328, NULL, NULL, 119058),
(119059, '1.10.287.130-FF-000122', NULL, 'Sensor histidine kinase', 134, NULL, NULL, 119059),
(119060, '1.10.287.110-FF-000060', NULL, 'DnaJ (Hsp40) homolog, subfamily C, member 30', 82, NULL, NULL, 119060),
(119061, '1.10.20.10-FF-000202', NULL, NULL, 105, NULL, NULL, 119061),
(119062, '2.130.10.10-FF-003173', NULL, 'Uncharacterized protein', 234, NULL, NULL, 119062),
(119063, '3.20.20.100-FF-000037', NULL, 'L-galactose dehydrogenase (L-GalDH)', 297, NULL, NULL, 119063),
(119064, '3.40.5.50-FF-000005', NULL, 'DNA replication complex GINS protein PSF2', 66, NULL, NULL, 119064),
(119065, '3.80.10.10-FF-000666', NULL, 'Nucleotide-binding oligomerization domain-containing protein 1', 181, NULL, NULL, 119065),
(119066, '1.25.40.10-FF-004835', NULL, 'Uncharacterized protein', 144, NULL, NULL, 119066),
(119067, '3.40.50.720-FF-000270', NULL, 'ubiquitin-conjugating enzyme E2 variant 3 isoform X2', 150, NULL, NULL, 119067),
(119068, '2.170.150.80-FF-000012', NULL, 'NAC with transmembrane motif1', 146, NULL, NULL, 119068),
(119069, '3.10.450.590-FF-000001', NULL, NULL, 96, NULL, NULL, 119069),
(119070, '1.10.510.10-FF-001623', NULL, 'Uncharacterized protein', 346, NULL, NULL, 119070),
(119071, '3.40.50.150-FF-001874', NULL, NULL, 235, NULL, NULL, 119071),
(119072, '3.40.50.850-FF-000022', NULL, 'SA0181 protein', 164, NULL, NULL, 119072),
(119073, '3.30.160.60-FF-003695', NULL, NULL, 31, NULL, NULL, 119073),
(119074, '2.130.10.10-FF-003521', NULL, 'Elongator complex protein 2', 80, NULL, NULL, 119074),
(119075, '2.130.10.10-FF-003807', NULL, 'Uncharacterized protein', 308, NULL, NULL, 119075),
(119076, '3.10.129.10-FF-000206', NULL, 'Thioesterase superfamily protein', 135, NULL, NULL, 119076),
(119077, '2.60.120.200-FF-000507', NULL, 'Uncharacterized protein', 180, NULL, NULL, 119077),
(119078, '1.10.10.60-FF-000014', NULL, 'SWI/SNF complex subunit SMARCC2 isoform C', 52, NULL, NULL, 119078),
(119079, '3.30.70.330-FF-002379', NULL, NULL, 101, NULL, NULL, 119079),
(119080, '2.60.40.420-FF-000238', NULL, 'Bll2293 protein', 127, NULL, NULL, 119080),
(119081, '3.90.550.10-FF-000240', NULL, 'N-acylneuraminate cytidylyltransferase', 228, NULL, NULL, 119081); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(119082, '1.10.472.80-FF-000037', NULL, 'TBC1 domain family member 21', 127, NULL, NULL, 119082),
(119083, '3.90.640.10-FF-000067', NULL, 'Actin-related protein 2', 92, NULL, NULL, 119083),
(119084, '3.40.50.300-FF-000205', NULL, 'ABC transporter B family member 4', 252, NULL, NULL, 119084),
(119085, '3.30.710.10-FF-000255', NULL, 'Elc1 elongin C', 94, NULL, NULL, 119085),
(119086, '3.40.5.60-FF-000008', NULL, 'DNA replication complex GINS protein SLD5', 53, NULL, NULL, 119086),
(119087, '4.10.280.10-FF-000222', NULL, 'Transcription factor bHLH99', 84, NULL, NULL, 119087),
(119088, '1.20.1070.10-FF-000169', NULL, 'Retinal pigment epithelium-derived rhodopsin homolog', 320, NULL, NULL, 119088),
(119089, '1.10.238.10-FF-000130', NULL, 'TBC1 domain family member 9B isoform X1', 189, NULL, NULL, 119089),
(119090, '2.10.25.10-FF-000508', NULL, 'Eyes shut homolog', 40, NULL, NULL, 119090),
(119091, '1.25.40.10-FF-005111', NULL, 'Tetratricopeptide repeat domain 3', 116, NULL, NULL, 119091),
(119092, '2.20.70.10-FF-000175', NULL, 'Uncharacterized protein', 48, NULL, NULL, 119092),
(119093, '3.40.50.620-FF-000863', NULL, 'Glutamine-dependent NAD(+) synthetase', 165, NULL, NULL, 119093),
(119094, '3.30.70.330-FF-002727', NULL, NULL, 97, NULL, NULL, 119094),
(119095, '3.30.70.330-FF-002873', NULL, NULL, 71, NULL, NULL, 119095),
(119096, '3.80.10.10-FF-001161', NULL, 'Putative leucine-rich repeat receptor-like protein kinase', 183, NULL, NULL, 119096),
(119097, '2.30.42.10-FF-000429', NULL, NULL, 62, NULL, NULL, 119097),
(119098, '1.20.120.350-FF-000242', NULL, NULL, 72, NULL, NULL, 119098),
(119099, '3.40.50.300-FF-003027', NULL, 'DNA helicase', 84, NULL, NULL, 119099),
(119100, '1.10.287.820-FF-000008', NULL, 'Pickpocket 10', 92, NULL, NULL, 119100),
(119101, '3.30.559.10-FF-000245', NULL, 'Uncharacterized protein', 108, NULL, NULL, 119101),
(119102, '3.40.50.300-FF-007916', NULL, 'Uncharacterized protein', 182, NULL, NULL, 119102),
(119103, '3.40.605.10-FF-000132', NULL, 'Uncharacterized protein', 85, NULL, NULL, 119103),
(119104, '1.10.150.850-FF-000001', NULL, 'Transcription elongation factor spt6', 104, NULL, NULL, 119104),
(119105, '2.130.10.10-FF-003246', NULL, 'Probable cleavage and polyadenylation specificity factor subunit 1', 220, NULL, NULL, 119105),
(119106, '2.60.120.200-FF-000558', NULL, 'Uncharacterized protein', 96, NULL, NULL, 119106),
(119107, '2.60.40.1730-FF-000101', NULL, NULL, 75, NULL, NULL, 119107),
(119108, '1.20.120.1750-FF-000068', NULL, 'RBR-type E3 ubiquitin transferase', 252, NULL, NULL, 119108),
(119109, '1.10.10.800-FF-000002', NULL, 'OpdE downstream ORF 2, putative', 91, NULL, NULL, 119109),
(119110, '3.30.200.20-FF-001405', NULL, 'MAP kinase-like protein', 98, NULL, NULL, 119110),
(119111, '1.10.510.10-FF-004496', NULL, NULL, 231, NULL, NULL, 119111),
(119112, '3.40.250.10-FF-000161', NULL, 'YALI0F15367p', 134, NULL, NULL, 119112),
(119113, '2.10.25.10-FF-000352', NULL, 'Hemicentin 1', 46, NULL, NULL, 119113),
(119114, '3.40.50.620-FF-000458', NULL, 'NH(3)-dependent NAD(+) synthetase', 278, NULL, NULL, 119114),
(119115, '3.30.40.10-FF-001030', NULL, 'MIB (MIndBomb) ubiquitin ligase homolog', 65, NULL, NULL, 119115),
(119116, '1.20.1250.20-FF-000484', NULL, 'MFS general substrate transporter', 226, NULL, NULL, 119116),
(119117, '1.10.1080.10-FF-000009', NULL, 'Glutathione synthetase', 47, NULL, NULL, 119117),
(119118, '1.25.40.10-FF-005324', NULL, 'Pentatricopeptide repeat-containing protein At1g52620', 109, NULL, NULL, 119118),
(119119, '2.130.10.10-FF-003791', NULL, 'Uncharacterized protein', 313, NULL, NULL, 119119),
(119120, '1.10.246.190-FF-000013', NULL, NULL, 58, NULL, NULL, 119120),
(119121, '2.60.40.640-FF-000012', NULL, 'vacuolar protein sorting-associated protein 26A', 155, NULL, NULL, 119121),
(119122, '2.60.40.10-FF-001177', NULL, 'Receptor-type tyrosine-protein phosphatase beta', 102, NULL, NULL, 119122),
(119123, '3.30.70.330-FF-003003', NULL, NULL, 82, NULL, NULL, 119123),
(119124, '3.30.160.60-FF-000210', NULL, 'Zinc finger RNA-binding protein 2', 49, NULL, NULL, 119124);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(119125, '1.10.287.70-FF-000137', NULL, 'Slowpoke 2, isoform E', 264, NULL, NULL, 119125),
(119126, '1.10.287.70-FF-000542', NULL, 'Uncharacterized protein', 134, NULL, NULL, 119126),
(119127, '3.30.160.60-FF-003644', NULL, NULL, 61, NULL, NULL, 119127),
(119128, '1.10.640.10-FF-000054', NULL, 'Uncharacterized protein', 387, NULL, NULL, 119128),
(119129, '3.80.10.10-FF-002521', NULL, 'Uncharacterized protein', 176, NULL, NULL, 119129),
(119130, '2.30.30.1190-FF-000013', NULL, 'Zinc finger nuclease 2', 73, NULL, NULL, 119130),
(119131, '1.10.510.10-FF-000786', NULL, 'caM kinase-like vesicle-associated protein isoform X2', 110, NULL, NULL, 119131),
(119132, '1.20.58.60-FF-000287', NULL, 'Utrophin', 187, NULL, NULL, 119132),
(119133, '1.20.58.340-FF-000032', NULL, 'Magnesium and cobalt transport protein CorA, putative', 114, NULL, NULL, 119133),
(119134, '3.40.710.10-FF-000152', NULL, 'Probable peptidoglycan D,D-transpeptidase PbpC', 181, NULL, NULL, 119134),
(119135, '3.40.1000.30-FF-000002', NULL, 'Proteasome inhibitor PI31 subunit', 158, NULL, NULL, 119135),
(119136, '2.60.40.650-FF-000015', NULL, 'Sulfite dehydrogenase molybdopterin-binding subunit SorA', 117, NULL, NULL, 119136),
(119137, '3.40.50.300-FF-003645', NULL, 'Uncharacterized protein', 213, NULL, NULL, 119137),
(119138, '2.30.39.10-FF-000051', NULL, 'Serpin-Z2A', 152, NULL, NULL, 119138),
(119139, '1.10.3550.10-FF-000001', NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase-like protein', 114, NULL, NULL, 119139),
(119140, '3.90.1150.210-FF-000015', NULL, 'Unplaced genomic scaffold supercont2.11, whole genome shotgun sequence', 137, NULL, NULL, 119140),
(119141, '1.25.10.10-FF-003428', NULL, 'Uncharacterized protein', 173, NULL, NULL, 119141),
(119142, '1.25.40.1040-FF-000027', NULL, 'mRNA 3''-end-processing protein RNA14', 543, NULL, NULL, 119142),
(119143, '1.10.418.10-FF-000110', NULL, 'Unplaced genomic scaffold supercont2.13, whole genome shotgun sequence', 161, NULL, NULL, 119143),
(119144, '3.40.50.300-FF-007568', NULL, 'Uncharacterized protein', 185, NULL, NULL, 119144),
(119145, '2.60.120.200-FF-000159', NULL, 'Glycosidase', 253, NULL, NULL, 119145),
(119146, '2.70.150.10-FF-000010', NULL, 'Potassium-transporting ATPase ATP-binding subunit', 123, NULL, NULL, 119146),
(119147, '3.30.1370.50-FF-000037', NULL, 'Uncharacterized protein', 59, NULL, NULL, 119147),
(119148, '2.60.40.60-FF-001052', NULL, 'Uncharacterized protein', 80, NULL, NULL, 119148),
(119149, '2.10.50.30-FF-000028', NULL, 'metabotropic glutamate receptor 3-like', 80, NULL, NULL, 119149),
(119150, '1.20.1420.10-FF-000039', NULL, NULL, 149, NULL, NULL, 119150),
(119151, '1.20.58.240-FF-000007', NULL, 'protein O-GlcNAcase-like isoform X2', 177, NULL, NULL, 119151),
(119152, '2.40.30.200-FF-000001', NULL, 'Distal tail protein', 149, NULL, NULL, 119152),
(119153, '1.25.10.10-FF-002698', NULL, 'Uncharacterized protein', 62, NULL, NULL, 119153),
(119154, '3.30.160.60-FF-000261', NULL, 'Zinc finger protein 521', 51, NULL, NULL, 119154),
(119155, '1.10.390.10-FF-000056', NULL, 'Protein CBG20905', 237, NULL, NULL, 119155),
(119156, '1.10.150.240-FF-000049', NULL, 'AT11641p', 68, NULL, NULL, 119156),
(119157, '1.20.58.1070-FF-000013', NULL, 'Gem-associated protein 2', 84, NULL, NULL, 119157),
(119158, '3.30.420.10-FF-000660', NULL, NULL, 191, NULL, NULL, 119158),
(119159, '1.20.1270.60-FF-000317', NULL, 'Variant SH3 domain containing protein', 242, NULL, NULL, 119159),
(119160, '2.60.40.1390-FF-000010', NULL, 'Related to acid phosphatase', 201, NULL, NULL, 119160),
(119161, '3.30.413.10-FF-000019', NULL, 'Nitrite/sulfite reductase, 4Fe-4S iron-sulfur cluster-binding domain protein', 160, NULL, NULL, 119161),
(119162, '3.40.1110.10-FF-000403', NULL, NULL, 75, NULL, NULL, 119162),
(119163, '1.10.150.810-FF-000012', NULL, 'DINP protein, human muc B family', 92, NULL, NULL, 119163),
(119164, '3.40.50.150-FF-001363', NULL, NULL, 184, NULL, NULL, 119164),
(119165, '3.40.50.11210-FF-000003', NULL, 'RAP1 GTPase activating protein 2', 185, NULL, NULL, 119165),
(119166, '3.40.50.720-FF-000269', NULL, 'Trans-1,2-dihydrobenzene-1,2-diol dehydrogenase', 122, NULL, NULL, 119166);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(119167, '3.40.605.10-FF-000019', NULL, 'probable aldehyde dehydrogenase', 259, NULL, NULL, 119167),
(119168, '1.20.58.60-FF-000517', NULL, 'Spectrin repeat containing, nuclear envelope 1a', 183, NULL, NULL, 119168),
(119169, '1.25.40.70-FF-000031', NULL, 'Putative phosphatidylinositol 3-kinase', 171, NULL, NULL, 119169),
(119170, '3.30.200.20-FF-000394', NULL, 'Leucine-rich repeat receptor-like protein kinase', 98, NULL, NULL, 119170),
(119171, '3.40.720.10-FF-000208', NULL, 'Type I phosphodiesterase/nucleotide pyrophosphatase family protein', 276, NULL, NULL, 119171),
(119172, '3.40.140.20-FF-000009', NULL, NULL, 158, NULL, NULL, 119172),
(119173, '3.30.70.330-FF-000636', NULL, 'Cell wall integrity protein scw1, putative', 100, NULL, NULL, 119173),
(119174, '3.30.200.20-FF-002535', NULL, 'Cyclin dependent kinase 20', 19, NULL, NULL, 119174),
(119175, '1.10.510.10-FF-003478', NULL, NULL, 358, NULL, NULL, 119175),
(119176, '3.30.450.20-FF-000159', NULL, 'Alkaline phosphatase synthesis sensor protein PhoR', 115, NULL, NULL, 119176),
(119177, '1.25.50.20-FF-000090', NULL, 'Uncharacterized protein', 278, NULL, NULL, 119177),
(119178, '3.40.50.300-FF-002858', NULL, 'DNA repair helicase rad3/xp-D, putative', 261, NULL, NULL, 119178),
(119179, '3.80.10.10-FF-001919', NULL, 'Protein phosphatase 2C-like protein', 246, NULL, NULL, 119179),
(119180, '3.40.50.1700-FF-000023', NULL, 'Glucan 1,4-beta-glucosidase', 114, NULL, NULL, 119180),
(119181, '1.10.510.10-FF-001354', NULL, 'Serine/threonine protein kinase sid1, putative', 283, NULL, NULL, 119181),
(119182, '2.10.25.10-FF-000391', NULL, 'Weary, isoform C', 38, NULL, NULL, 119182),
(119183, '3.90.1740.10-FF-000001', NULL, 'Tetratricopeptide repeat protein 25', 218, NULL, NULL, 119183),
(119184, '3.50.50.80-FF-000005', NULL, 'Ubiquitin-activating enzyme E1', 121, NULL, NULL, 119184),
(119185, '3.30.1330.40-FF-000037', NULL, 'Chorismate mutase AroH', 123, NULL, NULL, 119185),
(119186, '2.60.40.10-FF-003482', NULL, NULL, 122, NULL, NULL, 119186),
(119187, '2.60.40.420-FF-000183', NULL, 'Predicted protein', 110, NULL, NULL, 119187),
(119188, '1.20.5.110-FF-000104', NULL, 'Synaptobrevin family protein', 86, NULL, NULL, 119188),
(119189, '1.10.1090.10-FF-000004', NULL, 'Probable cytochrome b-c1 complex subunit 7', 115, NULL, NULL, 119189),
(119190, '1.20.1080.10-FF-000119', NULL, 'Uncharacterized protein', 98, NULL, NULL, 119190),
(119191, '1.20.1250.20-FF-000832', NULL, 'L-Proline/Glycine betaine transporter ProP', 386, NULL, NULL, 119191),
(119192, '1.10.390.10-FF-000112', NULL, 'Uncharacterized protein', 260, NULL, NULL, 119192),
(119193, '3.40.50.1400-FF-000034', NULL, 'Sirohydrochlorin cobaltochelatase CbiKP', 124, NULL, NULL, 119193),
(119194, '2.60.220.50-FF-000165', NULL, 'Uncharacterized protein', 147, NULL, NULL, 119194),
(119195, '3.30.70.960-FF-000027', NULL, 'Uncharacterized protein', 104, NULL, NULL, 119195),
(119196, '2.30.40.10-FF-000026', NULL, 'Imidazolonepropionase', 95, NULL, NULL, 119196),
(119197, '3.30.70.60-FF-000018', NULL, '30S ribosomal protein S6', 107, NULL, NULL, 119197),
(119198, '1.20.58.390-FF-000024', NULL, 'Glutamate-gated chloride channel alpha', 139, NULL, NULL, 119198),
(119199, '3.30.930.10-FF-000305', NULL, 'Serine--tRNA ligase, mitochondrial', 324, NULL, NULL, 119199),
(119200, '2.60.40.650-FF-000009', NULL, 'probable sulfite oxidase, mitochondrial', 127, NULL, NULL, 119200),
(119201, '2.10.50.10-FF-000022', NULL, 'Signal peptide, CUB domain and EGF-like domain-containing 1', 53, NULL, NULL, 119201),
(119202, '1.20.1070.10-FF-000731', NULL, 'Predicted protein', 321, NULL, NULL, 119202),
(119203, '4.10.1060.10-FF-000034', NULL, 'Nucleoporin 153kD, isoform D', 43, NULL, NULL, 119203),
(119204, '2.10.25.10-FF-000059', NULL, 'Mannan-binding lectin serine protease 1', 44, NULL, NULL, 119204),
(119205, '2.30.40.10-FF-000083', NULL, 'Cytosine deaminase', 87, NULL, NULL, 119205),
(119206, '3.40.50.10470-FF-000011', NULL, 'Methylthioribose-1-phosphate isomerase', 213, NULL, NULL, 119206),
(119207, '1.10.10.10-FF-001444', NULL, 'Transcriptional regulator, LysR family', 84, NULL, NULL, 119207);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(119208, '2.60.220.50-FF-000108', NULL, 'Uncharacterized protein', 120, NULL, NULL, 119208),
(119209, '3.30.160.60-FF-001458', NULL, 'INSM transcriptional repressor 1', 83, NULL, NULL, 119209),
(119210, '3.40.50.2000-FF-000057', NULL, 'Glycosyltransferase', 250, NULL, NULL, 119210),
(119211, '3.40.50.300-FF-001279', NULL, 'ATP-dependent RNA helicase DEAH12 chloroplastic', 174, NULL, NULL, 119211),
(119212, '3.40.50.1820-FF-001115', NULL, 'Predicted protein', 96, NULL, NULL, 119212),
(119213, '3.40.50.300-FF-001335', NULL, 'DNA mismatch repair protein', 255, NULL, NULL, 119213),
(119214, '3.40.50.10480-FF-000014', NULL, 'Brix domain containing protein', 169, NULL, NULL, 119214),
(119215, '3.30.420.10-FF-000603', NULL, NULL, 186, NULL, NULL, 119215),
(119216, '3.10.20.10-FF-000029', NULL, '60S ribosomal protein L18a', 65, NULL, NULL, 119216),
(119217, '3.30.40.10-FF-000698', NULL, 'Tripartite motif containing 15', 58, NULL, NULL, 119217),
(119218, '3.40.50.300-FF-003465', NULL, 'AAA family ATPase, putative', 142, NULL, NULL, 119218),
(119219, '3.40.50.1820-FF-000547', NULL, 'Uncharacterized protein', 234, NULL, NULL, 119219),
(119220, '3.40.1370.10-FF-000040', NULL, '50S ribosomal protein L4, chloroplastic', 200, NULL, NULL, 119220),
(119221, '1.20.1250.20-FF-001501', NULL, 'Solute carrier organic anion transporter family member', 247, NULL, NULL, 119221),
(119222, '1.20.58.60-FF-000556', NULL, 'Predicted protein', 110, NULL, NULL, 119222),
(119223, '3.10.50.40-FF-000017', NULL, 'Peptidylprolyl isomerase', 122, NULL, NULL, 119223),
(119224, '1.10.1040.10-FF-000125', NULL, 'Uncharacterized protein', 96, NULL, NULL, 119224),
(119225, '3.40.720.10-FF-000321', NULL, 'Iduronate-2-sulfatase', 510, NULL, NULL, 119225),
(119226, '3.30.200.20-FF-002479', NULL, 'Predicted protein', 40, NULL, NULL, 119226),
(119227, '3.30.160.60-FF-003931', NULL, NULL, 27, NULL, NULL, 119227),
(119228, '1.20.1050.40-FF-000003', NULL, 'Oligopeptidase A, putative', 129, NULL, NULL, 119228),
(119229, '1.25.40.10-FF-005055', NULL, 'Pentatricopeptide repeat-containing protein At4g20090', 108, NULL, NULL, 119229),
(119230, '1.25.40.10-FF-005105', NULL, 'TPR domain protein', 120, NULL, NULL, 119230),
(119231, '3.40.120.10-FF-000005', NULL, 'Phosphoglucomutase 5', 194, NULL, NULL, 119231),
(119232, '3.30.70.940-FF-000021', NULL, 'Transcription termination/antitermination protein NusG', 111, NULL, NULL, 119232),
(119233, '1.10.238.10-FF-000124', NULL, 'Calpain-1 catalytic subunit', 178, NULL, NULL, 119233),
(119234, '3.40.190.10-FF-000684', NULL, 'Uncharacterized protein', 50, NULL, NULL, 119234),
(119235, '3.50.30.30-FF-000129', NULL, 'Uncharacterized protein', 136, NULL, NULL, 119235),
(119236, '1.25.40.20-FF-001786', NULL, 'Poly [ADP-ribose] polymerase', 177, NULL, NULL, 119236),
(119237, '3.30.710.10-FF-000087', NULL, 'Kelch-like family member 15', 150, NULL, NULL, 119237),
(119238, '2.130.10.10-FF-002791', NULL, 'DDB1- and CUL4-associated factor 10', 209, NULL, NULL, 119238),
(119239, '1.20.900.10-FF-000044', NULL, 'Uncharacterized protein, isoform B', 200, NULL, NULL, 119239),
(119240, '3.50.50.60-FF-000578', NULL, 'FAD-dependent monooxygenase ausM', 383, NULL, NULL, 119240),
(119241, '3.30.60.20-FF-000079', NULL, 'Heavy chain, Unconventional Myosin', 75, NULL, NULL, 119241),
(119242, '3.40.50.10490-FF-000017', NULL, '40S ribosomal protein SA', 207, NULL, NULL, 119242),
(119243, '4.10.900.10-FF-000017', NULL, 'Transcription factor 7 like 1', 63, NULL, NULL, 119243),
(119244, '3.10.20.90-FF-000688', NULL, 'Uncharacterized protein', 78, NULL, NULL, 119244),
(119245, '3.40.50.720-FF-000562', NULL, 'Short-chain dehydrogenase/reductase SDR', 252, NULL, NULL, 119245),
(119246, '3.80.10.10-FF-000492', NULL, 'Si:dkey-16p6.1', 227, NULL, NULL, 119246),
(119247, '1.20.900.10-FF-000100', NULL, 'Uncharacterized protein', 114, NULL, NULL, 119247),
(119248, '1.25.40.180-FF-000222', NULL, NULL, 108, NULL, NULL, 119248),
(119249, '3.40.50.1820-FF-000328', NULL, 'Alpha/beta fold hydrolase', 285, NULL, NULL, 119249),
(119250, '3.20.20.10-FF-000040', NULL, 'Alanine racemase', 218, NULL, NULL, 119250);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(119251, '3.40.1190.20-FF-000220', NULL, NULL, 288, NULL, NULL, 119251),
(119252, '3.10.20.620-FF-000009', NULL, 'Autophagy protein 5', 133, NULL, NULL, 119252),
(119253, '3.30.160.60-FF-005842', NULL, NULL, 64, NULL, NULL, 119253),
(119254, '1.10.486.10-FF-000060', NULL, 'DNA helicase', 179, NULL, NULL, 119254),
(119255, '3.40.190.10-FF-000864', NULL, 'Uncharacterized protein', 34, NULL, NULL, 119255),
(119256, '2.40.40.20-FF-000001', NULL, 'DNA-directed RNA polymerase subunit', 122, NULL, NULL, 119256),
(119257, '2.60.120.380-FF-000050', NULL, 'Glycoside hydrolase family 3 domain protein', 131, NULL, NULL, 119257),
(119258, '2.60.60.20-FF-000052', NULL, NULL, 115, NULL, NULL, 119258),
(119259, '3.60.10.10-FF-000094', NULL, 'Sphingomyelin phosphodiesterase 2', 271, NULL, NULL, 119259),
(119260, '3.80.10.10-FF-000722', NULL, 'Leucine-rich repeat receptor-like protein kinase', 95, NULL, NULL, 119260),
(119261, '3.30.70.890-FF-000040', NULL, 'Mevalonate kinase, putative', 125, NULL, NULL, 119261),
(119262, '3.30.40.10-FF-001423', NULL, 'Tripartite motif-containing 38', 88, NULL, NULL, 119262),
(119263, '3.40.50.1820-FF-000508', NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', 308, NULL, NULL, 119263),
(119264, '3.30.2130.30-FF-000014', NULL, 'Putative RNA methylase', 171, NULL, NULL, 119264),
(119265, '3.90.640.10-FF-000247', NULL, 'Actin-related protein 8', 13, NULL, NULL, 119265),
(119266, '3.30.160.60-FF-003818', NULL, NULL, 25, NULL, NULL, 119266),
(119267, '3.30.420.10-FF-000328', NULL, 'GM25386', 208, NULL, NULL, 119267),
(119268, '1.10.287.70-FF-000250', NULL, 'Small conductance calcium-activated potassium channel-like protein 3', 99, NULL, NULL, 119268),
(119269, '3.40.50.720-FF-001000', NULL, 'Gluconate 5-dehydrogenase', 233, NULL, NULL, 119269),
(119270, '3.40.50.10190-FF-000141', NULL, 'RNA Polymerase II CTD phosphatase Fcp1', 93, NULL, NULL, 119270),
(119271, '1.10.510.10-FF-001573', NULL, 'Protein kinase domain containing protein', 159, NULL, NULL, 119271),
(119272, '3.30.1330.30-FF-000091', NULL, 'Pelo protein', 106, NULL, NULL, 119272),
(119273, '1.25.40.10-FF-004599', NULL, 'Uncharacterized protein', 168, NULL, NULL, 119273),
(119274, '2.60.120.200-FF-000384', NULL, 'Crumbs family member 1, photoreceptor morphogenesis associated', 177, NULL, NULL, 119274),
(119275, '1.10.287.2720-FF-000006', NULL, 'Similar to oxysterol-binding protein', 72, NULL, NULL, 119275),
(119276, '3.50.50.60-FF-000853', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 81, NULL, NULL, 119276),
(119277, '2.40.70.10-FF-000567', NULL, NULL, 77, NULL, NULL, 119277),
(119278, '3.60.20.10-FF-000117', NULL, 'Proteasome endopeptidase complex', 245, NULL, NULL, 119278),
(119279, '3.30.420.10-FF-000547', NULL, NULL, 71, NULL, NULL, 119279),
(119280, '4.10.1240.10-FF-000020', NULL, 'Adhesion G protein-coupled receptor F3', 51, NULL, NULL, 119280),
(119281, '1.25.40.20-FF-001842', NULL, 'AGAP003151-PA', 143, NULL, NULL, 119281),
(119282, '1.20.920.10-FF-000039', NULL, 'Transcription initiation factor TFIID subunit', 155, NULL, NULL, 119282),
(119283, '1.25.10.10-FF-001450', NULL, 'Uncharacterized protein', 260, NULL, NULL, 119283),
(119284, '2.130.10.10-FF-001099', NULL, 'Coronin', 348, NULL, NULL, 119284),
(119285, '2.20.100.10-FF-000147', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs gon-1', 56, NULL, NULL, 119285),
(119286, '3.40.50.300-FF-002010', NULL, 'IstB-like ATP-binding protein', 191, NULL, NULL, 119286),
(119287, '1.20.1250.20-FF-002070', NULL, 'RH14816p', 281, NULL, NULL, 119287),
(119288, '1.10.150.210-FF-000001', NULL, 'Phosphoserine phosphatase', 63, NULL, NULL, 119288),
(119289, '2.130.10.10-FF-002678', NULL, 'Uncharacterized protein', 282, NULL, NULL, 119289),
(119290, '3.30.200.20-FF-001231', NULL, 'Cysteine-rich receptor-like protein kinase 10', 105, NULL, NULL, 119290),
(119291, '3.40.50.300-FF-000031', NULL, 'Eukaryotic initiation factor 4A-III', 167, NULL, NULL, 119291),
(119292, '3.30.710.10-FF-000143', NULL, 'Uncharacterized protein, isoform B', 142, NULL, NULL, 119292); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(119293, '3.40.220.10-FF-000007', NULL, 'O-acetyl-ADP-ribose deacetylase 1', 144, NULL, NULL, 119293),
(119294, '1.20.1560.10-FF-000544', NULL, 'ATP-binding cassette (ABC) transporter, putative', 386, NULL, NULL, 119294),
(119295, '2.20.70.30-FF-000001', NULL, 'Transcription factor BTF3 homolog', 58, NULL, NULL, 119295),
(119296, '3.30.170.10-FF-000005', NULL, 'Cyclin-dependent kinases regulatory subunit', 105, NULL, NULL, 119296),
(119297, '3.40.20.10-FF-000051', NULL, 'Actin-depolymerizing factor 2', 143, NULL, NULL, 119297),
(119298, '3.30.160.60-FF-003190', NULL, 'zinc finger protein 235 isoform X2', 32, NULL, NULL, 119298),
(119299, '1.20.5.500-FF-000007', NULL, 'ATPase inhibitor, putative', 65, NULL, NULL, 119299),
(119300, '1.20.58.60-FF-000736', NULL, 'Uncharacterized protein', 265, NULL, NULL, 119300),
(119301, '1.20.1270.10-FF-000044', NULL, 'Heat shock 70 kDa protein BIP2', 74, NULL, NULL, 119301),
(119302, '2.10.70.10-FF-000080', NULL, 'Membrane cofactor protein', 62, NULL, NULL, 119302),
(119303, '3.30.160.60-FF-005281', NULL, NULL, 63, NULL, NULL, 119303),
(119304, '3.40.1160.10-FF-000007', NULL, 'Carbamate kinase', 311, NULL, NULL, 119304),
(119305, '3.90.79.10-FF-000285', NULL, 'Uncharacterized protein', 63, NULL, NULL, 119305),
(119306, '3.30.70.2760-FF-000006', NULL, NULL, 138, NULL, NULL, 119306),
(119307, '2.10.25.10-FF-000239', NULL, 'Sushi, nidogen and EGF-like domain-containing protein 1', 39, NULL, NULL, 119307),
(119308, '3.30.1520.10-FF-000049', NULL, 'Vacuolar sorting protein VPS1', 148, NULL, NULL, 119308),
(119309, '3.20.70.20-FF-000046', NULL, 'Uncharacterized protein', 62, NULL, NULL, 119309),
(119310, '2.70.130.10-FF-000014', NULL, 'glucosidase 2 subunit beta isoform X1', 105, NULL, NULL, 119310),
(119311, '3.40.190.10-FF-000807', NULL, 'Uncharacterized protein', 82, NULL, NULL, 119311),
(119312, '3.40.50.150-FF-001582', NULL, NULL, 357, NULL, NULL, 119312),
(119313, '2.30.30.100-FF-000024', NULL, 'U6 snRNA-associated Sm-like protein LSm4', 83, NULL, NULL, 119313),
(119314, '1.10.8.640-FF-000001', NULL, 'Cytochrome c-type biogenesis protein', 81, NULL, NULL, 119314),
(119315, '3.90.1760.10-FF-000002', NULL, 'Calmodulin-sensitive adenylate cyclase', 140, NULL, NULL, 119315),
(119316, '3.80.10.10-FF-004090', NULL, 'Brassinosteroid-insensitive 1', 124, NULL, NULL, 119316),
(119317, '3.30.160.60-FF-001571', NULL, 'Zinc finger protein 687', 70, NULL, NULL, 119317),
(119318, '1.25.40.10-FF-003200', NULL, 'Uncharacterized protein', 89, NULL, NULL, 119318),
(119319, '1.20.5.710-FF-000008', NULL, '50S ribosomal protein L7/L12', 54, NULL, NULL, 119319),
(119320, '3.30.710.10-FF-000199', NULL, 'Blast:BTB/POZ domain-containing protein 19', 164, NULL, NULL, 119320),
(119321, '3.40.50.1820-FF-000660', NULL, 'ArylForMamiDase', 234, NULL, NULL, 119321),
(119322, '1.20.58.1120-FF-000051', NULL, NULL, 133, NULL, NULL, 119322),
(119323, '3.40.50.2300-FF-000883', NULL, NULL, 179, NULL, NULL, 119323),
(119324, '2.10.70.10-FF-000023', NULL, 'protein kinase C-binding protein NELL2', 36, NULL, NULL, 119324),
(119325, '1.20.5.700-FF-000005', NULL, 'Cytochrome b6-f complex iron-sulfur subunit 1', 40, NULL, NULL, 119325),
(119326, '3.80.10.10-FF-002813', NULL, 'Leucine Rich Repeat family protein', 222, NULL, NULL, 119326),
(119327, '1.20.58.2190-FF-000012', NULL, 'Wall-associated receptor kinase 1', 102, NULL, NULL, 119327),
(119328, '2.60.120.330-FF-000131', NULL, 'Aspartate beta-hydroxylase domain-containing 1', 103, NULL, NULL, 119328),
(119329, '3.40.50.1820-FF-001003', NULL, 'Lipase domain protein, putative', 230, NULL, NULL, 119329),
(119330, '3.30.160.60-FF-001514', NULL, 'Zinc finger protein 407', 30, NULL, NULL, 119330),
(119331, '3.40.50.300-FF-007063', NULL, 'Uncharacterized protein', 195, NULL, NULL, 119331),
(119332, '3.40.50.300-FF-003752', NULL, 'Predicted protein', 317, NULL, NULL, 119332),
(119333, '2.130.10.10-FF-005320', NULL, 'Uncharacterized protein', 200, NULL, NULL, 119333),
(119334, '3.30.2230.10-FF-000010', NULL, 'Ubiquitinyl hydrolase 1', 97, NULL, NULL, 119334);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(119335, '1.25.40.610-FF-000008', NULL, 'Adhesion G protein-coupled receptor F1', 119, NULL, NULL, 119335),
(119336, '2.60.40.10-FF-004212', NULL, NULL, 74, NULL, NULL, 119336),
(119337, '3.50.7.10-FF-000083', NULL, NULL, 26, NULL, NULL, 119337),
(119338, '3.30.70.2750-FF-000003', NULL, 'V-type ATP synthase subunit I', 78, NULL, NULL, 119338),
(119339, '3.30.200.20-FF-002299', NULL, 'Uncharacterized protein', 18, NULL, NULL, 119339),
(119340, '3.30.160.60-FF-003751', NULL, NULL, 26, NULL, NULL, 119340),
(119341, '1.20.1250.20-FF-000776', NULL, 'Putative multidrug transporter', 205, NULL, NULL, 119341),
(119342, '3.30.70.330-FF-002766', NULL, NULL, 78, NULL, NULL, 119342),
(119343, '1.20.1070.10-FF-000675', NULL, 'Uncharacterized protein', 307, NULL, NULL, 119343),
(119344, '1.20.58.1080-FF-000016', NULL, 'ATP-dependent RNA helicase suv3, mitochondrial', 100, NULL, NULL, 119344),
(119345, '3.40.50.1110-FF-000161', NULL, 'Uncharacterized protein', 86, NULL, NULL, 119345),
(119346, '1.20.1070.10-FF-000618', NULL, 'Uncharacterized protein', 308, NULL, NULL, 119346),
(119347, '3.30.40.10-FF-000928', NULL, 'Putative E3 ubiquitin-protein ligase UNKL', 52, NULL, NULL, 119347),
(119348, '3.30.160.60-FF-001239', NULL, 'Zinc finger protein 615', 27, NULL, NULL, 119348),
(119349, '3.40.47.10-FF-000258', NULL, NULL, 287, NULL, NULL, 119349),
(119350, '3.40.50.720-FF-002304', NULL, 'Uncharacterized protein', 145, NULL, NULL, 119350),
(119351, '3.20.20.70-FF-000209', NULL, 'Deoxyribose-phosphate aldolase (putative)', 104, NULL, NULL, 119351),
(119352, '3.30.470.10-FF-000045', NULL, 'Uncharacterized protein', 166, NULL, NULL, 119352),
(119353, '4.10.240.10-FF-000006', NULL, 'Positive regulator of purine utilization', 61, NULL, NULL, 119353),
(119354, '3.40.50.720-FF-002248', NULL, 'Putative dehydrogenase', 78, NULL, NULL, 119354),
(119355, '3.30.1370.10-FF-000166', NULL, 'Vigilin 1', 73, NULL, NULL, 119355),
(119356, '2.10.110.10-FF-000257', NULL, 'Transcription factor Lmx1b', 111, NULL, NULL, 119356),
(119357, '3.40.50.2000-FF-000618', NULL, 'Uncharacterized protein', 93, NULL, NULL, 119357),
(119358, '2.30.39.10-FF-000012', NULL, 'Serpin family E member 3', 154, NULL, NULL, 119358),
(119359, '2.30.30.140-FF-000007', NULL, 'Lethal(3)malignant brain tumor-like protein 1', 107, NULL, NULL, 119359),
(119360, '2.30.42.10-FF-000536', NULL, NULL, 106, NULL, NULL, 119360),
(119361, '3.80.10.10-FF-001796', NULL, 'Uncharacterized protein', 119, NULL, NULL, 119361),
(119362, '3.40.50.12780-FF-000114', NULL, 'Aspergillus niger contig An11c0010, genomic contig', 410, NULL, NULL, 119362),
(119363, '3.30.930.10-FF-000125', NULL, 'Prolyl-tRNA synthetase', 135, NULL, NULL, 119363),
(119364, '3.30.230.10-FF-000117', NULL, 'Mevalonate kinase', 168, NULL, NULL, 119364),
(119365, '3.50.50.60-FF-001016', NULL, 'Salicylate hydroxylase, putative (AFU_orthologue AFUA_7G00590)', 155, NULL, NULL, 119365),
(119366, '3.10.110.10-FF-000276', NULL, 'ubiquitin-conjugating enzyme E2 J1-like', 185, NULL, NULL, 119366),
(119367, '3.40.50.150-FF-001543', NULL, NULL, 91, NULL, NULL, 119367),
(119368, '1.10.10.60-FF-001088', NULL, NULL, 74, NULL, NULL, 119368),
(119369, '2.130.10.10-FF-005045', NULL, 'Chromosome 12, whole genome shotgun sequence', 285, NULL, NULL, 119369),
(119370, '1.10.472.10-FF-000567', NULL, 'Predicted protein', 62, NULL, NULL, 119370),
(119371, '2.30.29.30-FF-001124', NULL, 'AGAP008316-PA', 189, NULL, NULL, 119371),
(119372, '3.30.70.2050-FF-000001', NULL, 'Copper chaperone NosL', 51, NULL, NULL, 119372),
(119373, '3.30.70.330-FF-001131', NULL, 'Putative RRM RNA binding protein NSAP1', 122, NULL, NULL, 119373),
(119374, '3.30.70.330-FF-001417', NULL, 'Predicted protein', 114, NULL, NULL, 119374),
(119375, '1.10.510.10-FF-002697', NULL, NULL, 144, NULL, NULL, 119375),
(119376, '3.60.20.10-FF-000156', NULL, NULL, 242, NULL, NULL, 119376),
(119377, '3.20.20.140-FF-000021', NULL, 'Guanine deaminase', 311, NULL, NULL, 119377),
(119378, '1.25.40.470-FF-000039', NULL, 'Intraflagellar transport protein 80, putative', 159, NULL, NULL, 119378);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(119379, '1.20.1560.10-FF-000763', NULL, 'Uncharacterized protein', 323, NULL, NULL, 119379),
(119380, '1.10.238.10-FF-001254', NULL, 'Calcium-binding protein F', 67, NULL, NULL, 119380),
(119381, '3.20.20.150-FF-000024', NULL, 'L-rhamnose isomerase', 377, NULL, NULL, 119381),
(119382, '2.60.40.10-FF-003594', NULL, NULL, 95, NULL, NULL, 119382),
(119383, '3.40.1110.10-FF-000167', NULL, 'Probable cation-transporting P-type ATPase', 113, NULL, NULL, 119383),
(119384, '3.30.470.20-FF-000048', NULL, 'D-alanine--D-alanine ligase family', 158, NULL, NULL, 119384),
(119385, '3.10.20.620-FF-000010', NULL, 'Autophagy protein 5', 95, NULL, NULL, 119385),
(119386, '3.40.50.1820-FF-000840', NULL, 'LIPA isoform 8', 268, NULL, NULL, 119386),
(119387, '1.20.120.1630-FF-000032', NULL, 'Predicted protein', 222, NULL, NULL, 119387),
(119388, '3.10.450.50-FF-000077', NULL, 'Uncharacterized protein', 169, NULL, NULL, 119388),
(119389, '1.10.8.1080-FF-000002', NULL, 'Glucokinase regulatory protein', 125, NULL, NULL, 119389),
(119390, '2.130.10.10-FF-001773', NULL, 'Striatin-4-like', 163, NULL, NULL, 119390),
(119391, '3.40.50.720-FF-000449', NULL, 'Ubiquitin-activating enzyme (E1), putative', 263, NULL, NULL, 119391),
(119392, '1.10.510.10-FF-003714', NULL, NULL, 159, NULL, NULL, 119392),
(119393, '1.10.238.10-FF-000978', NULL, 'Calcium-dependent protein kinase 25', 70, NULL, NULL, 119393),
(119394, '3.40.50.300-FF-005444', NULL, 'Oligopeptide/dipeptide ABC transporter, ATPase subunit', 326, NULL, NULL, 119394),
(119395, '1.20.1250.20-FF-000720', NULL, 'Aflatoxin efflux pump AFLT, putative', 203, NULL, NULL, 119395),
(119396, '3.90.190.10-FF-000049', NULL, 'Dual specificity protein phosphatase 14', 171, NULL, NULL, 119396),
(119397, '2.130.10.10-FF-001374', NULL, 'Unplaced genomic scaffold supercont2.8, whole genome shotgun sequence', 169, NULL, NULL, 119397),
(119398, '3.30.200.20-FF-001175', NULL, 'STE20-related kinase adapter protein alpha isoform 1', 88, NULL, NULL, 119398),
(119399, '3.60.130.10-FF-000081', NULL, 'Uncharacterized protein', 161, NULL, NULL, 119399),
(119400, '2.60.40.150-FF-000478', NULL, 'Uncharacterized protein', 154, NULL, NULL, 119400),
(119401, '2.60.40.10-FF-000789', NULL, 'Interleukin 12 receptor subunit beta 2', 99, NULL, NULL, 119401),
(119402, '3.20.20.80-FF-000600', NULL, 'Novel protein similar to vertebrate hexosaminidase A (Alpha polypeptide) (HEXA)', 192, NULL, NULL, 119402),
(119403, '3.30.420.40-FF-000202', NULL, 'pantothenate kinase 1 isoform X2', 43, NULL, NULL, 119403),
(119404, '3.40.50.300-FF-006568', NULL, 'Small GTPase RhoQ, putative', 102, NULL, NULL, 119404),
(119405, '2.20.70.10-FF-000282', NULL, 'Uncharacterized protein', 46, NULL, NULL, 119405),
(119406, '2.30.29.30-FF-000904', NULL, 'insulin receptor substrate 1-like', 109, NULL, NULL, 119406),
(119407, '2.10.70.80-FF-000016', NULL, 'Sortilin', 54, NULL, NULL, 119407),
(119408, '3.90.640.10-FF-000028', NULL, 'Actin-related protein 4', 84, NULL, NULL, 119408),
(119409, '3.30.160.60-FF-001278', NULL, 'C2H2 finger domain protein FlbC', 35, NULL, NULL, 119409),
(119410, '2.30.29.30-FF-000848', NULL, 'Uncharacterized protein', 132, NULL, NULL, 119410),
(119411, '3.30.559.10-FF-000133', NULL, 'Nonribosomal peptide synthase GliP', 163, NULL, NULL, 119411),
(119412, '2.60.40.10-FF-004499', NULL, NULL, 145, NULL, NULL, 119412),
(119413, '2.130.10.10-FF-004769', NULL, 'WD repeat protein, putative', 155, NULL, NULL, 119413),
(119414, '3.40.605.10-FF-000020', NULL, 'Aldehyde dehydrogenase', 248, NULL, NULL, 119414),
(119415, '3.30.200.20-FF-001517', NULL, 'Predicted protein', 91, NULL, NULL, 119415),
(119416, '1.20.1070.10-FF-000911', NULL, 'Uncharacterized protein', 180, NULL, NULL, 119416),
(119417, '2.60.40.10-FF-001065', NULL, 'Immunoglobulin superfamily member 10', 89, NULL, NULL, 119417),
(119418, '2.10.25.10-FF-001818', NULL, 'Sperm transmembrane protein 9', 42, NULL, NULL, 119418),
(119419, '3.40.30.10-FF-000551', NULL, 'Protein disulfide isomerase', 122, NULL, NULL, 119419),
(119420, '2.60.40.10-FF-005393', NULL, NULL, 52, NULL, NULL, 119420);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(119421, '3.30.160.60-FF-005168', NULL, NULL, 34, NULL, NULL, 119421),
(119422, '3.40.850.10-FF-000364', NULL, 'Chitin synthase', 198, NULL, NULL, 119422),
(119423, '2.30.30.140-FF-000283', NULL, 'Histone-lysine N-methyltransferase', 93, NULL, NULL, 119423),
(119424, '4.10.110.10-FF-000002', NULL, 'Maltase-glucoamylase, intestinal', 41, NULL, NULL, 119424),
(119425, '3.80.10.10-FF-003595', NULL, 'Uncharacterized protein', 129, NULL, NULL, 119425),
(119426, '3.30.40.10-FF-002278', NULL, 'Uncharacterized protein', 49, NULL, NULL, 119426),
(119427, '3.30.470.20-FF-000104', NULL, 'ATP-grasp domain protein', 103, NULL, NULL, 119427),
(119428, '3.40.50.2000-FF-000675', NULL, 'Glycosyltransferase', 205, NULL, NULL, 119428),
(119429, '1.10.510.10-FF-002410', NULL, 'Uncharacterized protein', 351, NULL, NULL, 119429),
(119430, '3.30.450.20-FF-000378', NULL, 'Sensory transduction histidine kinase', 127, NULL, NULL, 119430),
(119431, '2.60.40.10-FF-005336', NULL, NULL, 74, NULL, NULL, 119431),
(119432, '1.20.120.420-FF-000016', NULL, 'Methylthioribose-1-phosphate isomerase', 182, NULL, NULL, 119432),
(119433, '3.40.390.10-FF-000284', NULL, NULL, 111, NULL, NULL, 119433),
(119434, '1.25.10.10-FF-002973', NULL, 'Beta-tubulin cofactor D family protein', 403, NULL, NULL, 119434),
(119435, '1.10.472.10-FF-000680', NULL, 'Uncharacterized protein', 243, NULL, NULL, 119435),
(119436, '3.30.200.20-FF-001118', NULL, 'Os07g0129900 protein', 92, NULL, NULL, 119436),
(119437, '3.60.130.10-FF-000024', NULL, 'Pentalenolactone F synthase', 297, NULL, NULL, 119437),
(119438, '1.10.510.10-FF-000898', NULL, 'Cyclin-dependent kinase F-1', 179, NULL, NULL, 119438),
(119439, '2.60.40.10-FF-003195', NULL, 'Immunoglobulin light 4 variable 9', 110, NULL, NULL, 119439),
(119440, '3.90.190.10-FF-000162', NULL, 'Tyrosine-protein phosphatase vhp-1', 161, NULL, NULL, 119440),
(119441, '3.90.190.10-FF-000105', NULL, 'Protein tyrosine phosphatase type IVA 3', 172, NULL, NULL, 119441),
(119442, '3.20.20.100-FF-000144', NULL, 'Uncharacterized protein', 275, NULL, NULL, 119442),
(119443, '3.40.50.200-FF-000001', NULL, 'Furin 2, isoform B', 325, NULL, NULL, 119443),
(119444, '1.20.900.10-FF-000083', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF a', 182, NULL, NULL, 119444),
(119445, '3.40.50.300-FF-004769', NULL, 'Predicted protein', 98, NULL, NULL, 119445),
(119446, '3.40.390.10-FF-000227', NULL, NULL, 113, NULL, NULL, 119446),
(119447, '2.40.128.180-FF-000011', NULL, NULL, 82, NULL, NULL, 119447),
(119448, '3.30.2460.20-FF-000002', NULL, 'Protein Wnt', 57, NULL, NULL, 119448),
(119449, '1.10.1050.10-FF-000007', NULL, '30S ribosomal protein S4 B', 103, NULL, NULL, 119449),
(119450, '1.25.40.180-FF-000166', NULL, NULL, 216, NULL, NULL, 119450),
(119451, '1.10.840.10-FF-000035', NULL, 'Drosophila SOS homolog', 216, NULL, NULL, 119451),
(119452, '2.30.29.30-FF-000961', NULL, 'Exocyst complex component EXO84', 108, NULL, NULL, 119452),
(119453, '2.70.170.10-FF-000011', NULL, 'Gamma-aminobutyric acid receptor subunit pi isoform X1', 207, NULL, NULL, 119453),
(119454, '3.30.70.1230-FF-000261', NULL, 'Predicted protein', 155, NULL, NULL, 119454),
(119455, '1.10.238.210-FF-000013', NULL, 'Ankyrin repeat-containing protein', 75, NULL, NULL, 119455),
(119456, '2.60.120.290-FF-000135', NULL, 'GD12774', 121, NULL, NULL, 119456),
(119457, '3.30.160.60-FF-001391', NULL, 'Zinc finger protein 25', 30, NULL, NULL, 119457),
(119458, '3.40.50.800-FF-000029', NULL, 'Glycine--tRNA ligase', 95, NULL, NULL, 119458),
(119459, '2.60.40.60-FF-000888', NULL, 'Uncharacterized protein', 110, NULL, NULL, 119459),
(119460, '2.30.30.90-FF-000004', NULL, 'Ferrous iron transport protein B', 82, NULL, NULL, 119460),
(119461, '3.20.20.80-FF-000325', NULL, 'GPI-anchored cell wall beta-1,3-endoglucanase EglC', 113, NULL, NULL, 119461),
(119462, '2.130.10.10-FF-000879', NULL, 'Pre-mrna-splicing factor rse1', 328, NULL, NULL, 119462),
(119463, '3.40.50.720-FF-002580', NULL, 'D-3-phosphoglycerate dehydrogenase', 20, NULL, NULL, 119463),
(119464, '1.20.120.1080-FF-000114', NULL, 'Putative deah-box rna helicase', 127, NULL, NULL, 119464);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(119465, '1.20.1070.10-FF-002187', NULL, 'Uncharacterized protein', 85, NULL, NULL, 119465),
(119466, '1.10.238.200-FF-000010', NULL, 'Defective in cullin neddylation protein 1', 90, NULL, NULL, 119466),
(119467, '1.20.1420.10-FF-000040', NULL, NULL, 137, NULL, NULL, 119467),
(119468, '2.60.120.380-FF-000011', NULL, 'Calpain 12', 161, NULL, NULL, 119468),
(119469, '3.40.30.10-FF-000113', NULL, 'ganglioside-induced differentiation-associated protein 1 isoform X1', 110, NULL, NULL, 119469),
(119470, '3.20.20.70-FF-000322', NULL, 'Alpha-galactosidase', 359, NULL, NULL, 119470),
(119471, '3.30.930.10-FF-000182', NULL, 'Alanine--tRNA ligase', 138, NULL, NULL, 119471),
(119472, '2.130.10.10-FF-005084', NULL, 'Cell division cycle protein cdt2', 264, NULL, NULL, 119472),
(119473, '4.10.1000.10-FF-000036', NULL, 'Zinc finger CCCH domain-containing protein 4', 60, NULL, NULL, 119473),
(119474, '3.30.450.20-FF-000491', NULL, 'Histidine kinase', 125, NULL, NULL, 119474),
(119475, '2.130.10.10-FF-005264', NULL, 'Uncharacterized protein', 259, NULL, NULL, 119475),
(119476, '3.30.565.10-FF-000299', NULL, 'Putative postmeiotic segregation increased 2-like protein 11', 84, NULL, NULL, 119476),
(119477, '2.10.25.140-FF-000002', NULL, 'Delta-like protein', 39, NULL, NULL, 119477),
(119478, '3.30.420.10-FF-000042', NULL, 'poly(A)-specific ribonuclease PARN', 211, NULL, NULL, 119478),
(119479, '3.15.10.20-FF-000004', NULL, 'Hsp90 co-chaperone AHA1', 145, NULL, NULL, 119479),
(119480, '1.10.1200.10-FF-000003', NULL, 'Acyl carrier protein', 89, NULL, NULL, 119480),
(119481, '3.30.450.20-FF-000434', NULL, 'Uncharacterized protein', 98, NULL, NULL, 119481),
(119482, '3.80.10.10-FF-002291', NULL, 'Uncharacterized protein', 224, NULL, NULL, 119482),
(119483, '3.80.10.10-FF-002577', NULL, 'Receptor-like protein kinase BRI1-like 3', 115, NULL, NULL, 119483),
(119484, '1.10.10.350-FF-000041', NULL, NULL, 91, NULL, NULL, 119484),
(119485, '1.10.12.10-FF-000032', NULL, 'Enoyl-CoA hydratase', 58, NULL, NULL, 119485),
(119486, '1.25.40.570-FF-000013', NULL, 'Proteasome regulatory particle subunit (RpnG)', 91, NULL, NULL, 119486),
(119487, '1.50.10.10-FF-000200', NULL, 'Uncharacterized protein', 207, NULL, NULL, 119487),
(119488, '1.25.40.570-FF-000070', NULL, 'Uncharacterized protein', 387, NULL, NULL, 119488),
(119489, '3.60.10.10-FF-000055', NULL, 'Putative calcium-binding protein', 426, NULL, NULL, 119489),
(119490, '1.10.150.20-FF-000188', NULL, 'Restriction endonuclease type II-like protein', 84, NULL, NULL, 119490),
(119491, '3.80.10.10-FF-000902', NULL, 'F-box protein SKIP19', 213, NULL, NULL, 119491),
(119492, '1.10.600.10-FF-000107', NULL, 'Uncharacterized protein', 318, NULL, NULL, 119492),
(119493, '3.15.10.10-FF-000001', NULL, 'phospholipid transfer protein-like', 178, NULL, NULL, 119493),
(119494, '1.20.120.1320-FF-000001', NULL, 'Aspartokinase', 97, NULL, NULL, 119494),
(119495, '3.40.50.11840-FF-000012', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase', 83, NULL, NULL, 119495),
(119496, '3.40.50.300-FF-005882', NULL, 'DNA helicase', 151, NULL, NULL, 119496),
(119497, '3.40.50.2000-FF-000495', NULL, 'UDP-glucuronosyltransferase', 178, NULL, NULL, 119497),
(119498, '1.10.287.1150-FF-000007', NULL, '2-oxoglutarate dehydrogenase E1 component', 78, NULL, NULL, 119498),
(119499, '3.40.50.11850-FF-000015', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', 99, NULL, NULL, 119499),
(119500, '1.10.10.60-FF-000868', NULL, NULL, 83, NULL, NULL, 119500),
(119501, '2.160.20.10-FF-000345', NULL, 'Protein CBG11506', 253, NULL, NULL, 119501),
(119502, '2.60.120.290-FF-000192', NULL, 'AGAP005526-PA', 127, NULL, NULL, 119502),
(119503, '4.10.410.10-FF-000042', NULL, 'CBN-MEC-1 protein', 57, NULL, NULL, 119503),
(119504, '3.30.413.10-FF-000020', NULL, 'Sulfite reductase', 145, NULL, NULL, 119504),
(119505, '3.40.50.410-FF-000238', NULL, 'TROVE domain protein', 176, NULL, NULL, 119505),
(119506, '1.10.10.10-FF-000140', NULL, 'Histone H1.0', 90, NULL, NULL, 119506),
(119507, '3.15.10.30-FF-000007', NULL, 'GD18997', 209, NULL, NULL, 119507);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(119508, '3.30.160.60-FF-005729', NULL, NULL, 32, NULL, NULL, 119508),
(119509, '2.40.50.40-FF-000108', NULL, 'Uncharacterized protein', 68, NULL, NULL, 119509),
(119510, '2.30.30.380-FF-000006', NULL, 'TGF-beta activated kinase 1 (MAP3K7) binding protein 2', 32, NULL, NULL, 119510),
(119511, '2.40.50.150-FF-000001', NULL, 'DNA-directed RNA polymerase subunit beta', 106, NULL, NULL, 119511),
(119512, '2.30.29.30-FF-000562', NULL, 'Protein kinase D4', 107, NULL, NULL, 119512),
(119513, '3.50.50.60-FF-001073', NULL, 'Putative lysine-specific histone demethylase 1-like Protein', 160, NULL, NULL, 119513),
(119514, '3.20.20.10-FF-000001', NULL, 'Biosynthetic arginine decarboxylase', 280, NULL, NULL, 119514),
(119515, '1.50.40.10-FF-000314', NULL, 'Mitochondrial carrier protein, putative (AFU_orthologue AFUA_4G06390)', 205, NULL, NULL, 119515),
(119516, '6.10.140.2220-FF-000070', NULL, 'Uncharacterized protein', 46, NULL, NULL, 119516),
(119517, '1.25.40.10-FF-002469', NULL, 'Os08g0131000 protein', 81, NULL, NULL, 119517),
(119518, '2.30.30.370-FF-000003', NULL, NULL, 47, NULL, NULL, 119518),
(119519, '2.60.40.10-FF-005516', NULL, NULL, 75, NULL, NULL, 119519),
(119520, '3.30.70.330-FF-000693', NULL, 'RNA-binding protein, putative', 83, NULL, NULL, 119520),
(119521, '1.10.510.10-FF-001393', NULL, 'Calmodulin-binding receptor kinase CaMRLK', 102, NULL, NULL, 119521),
(119522, '2.60.120.10-FF-000235', NULL, 'Mannose-6-phosphate isomerase type 1', 78, NULL, NULL, 119522),
(119523, '2.130.10.10-FF-004589', NULL, 'Inner dynein arm I1 intermediate chain IC140', 207, NULL, NULL, 119523),
(119524, '1.10.238.10-FF-001198', NULL, 'Uncharacterized protein', 78, NULL, NULL, 119524),
(119525, '6.10.140.2220-FF-000013', NULL, 'N-lysine methyltransferase SMYD2 isoform X1', 49, NULL, NULL, 119525),
(119526, '3.90.1520.10-FF-000018', NULL, 'Uncharacterized protein', 77, NULL, NULL, 119526),
(119527, '3.20.20.70-FF-000541', NULL, NULL, 219, NULL, NULL, 119527),
(119528, '3.30.505.10-FF-000014', NULL, 'Phosphatidylinositol 3-kinase regulatory subunit alpha', 111, NULL, NULL, 119528),
(119529, '1.10.1900.10-FF-000011', NULL, 'Polyadenylate-binding protein', 93, NULL, NULL, 119529),
(119530, '1.25.10.10-FF-001337', NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit', 404, NULL, NULL, 119530),
(119531, '2.40.37.10-FF-000035', NULL, 'Ornithine decarboxylase', 114, NULL, NULL, 119531),
(119532, '3.60.10.10-FF-000330', NULL, 'Uncharacterized protein', 243, NULL, NULL, 119532),
(119533, '3.30.420.40-FF-000944', NULL, 'Uncharacterized protein', 51, NULL, NULL, 119533),
(119534, '3.50.50.60-FF-000797', NULL, 'Flavin-containing monooxygenase', 185, NULL, NULL, 119534),
(119535, '3.90.190.10-FF-000381', NULL, 'Dual specificity phosphatase', 152, NULL, NULL, 119535),
(119536, '1.25.10.10-FF-001394', NULL, 'Transportin 2', 169, NULL, NULL, 119536),
(119537, '1.20.5.470-FF-000015', NULL, 'Argininosuccinate synthase-like Protein', 40, NULL, NULL, 119537),
(119538, '3.90.930.40-FF-000003', NULL, 'Cupin_superfamily_protein/Cupin-like_domain_containing_protein_-_putative', 142, NULL, NULL, 119538),
(119539, '3.60.15.10-FF-000083', NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', 102, NULL, NULL, 119539),
(119540, '3.40.930.10-FF-000022', NULL, 'Frv operon regulatory protein', 131, NULL, NULL, 119540),
(119541, '1.20.1280.50-FF-000034', NULL, 'Coronatine-insensitive protein homolog 2', 48, NULL, NULL, 119541),
(119542, '3.40.50.300-FF-004988', NULL, 'Predicted protein', 162, NULL, NULL, 119542),
(119543, '1.25.40.180-FF-000109', NULL, 'Predicted protein', 175, NULL, NULL, 119543),
(119544, '3.30.70.330-FF-001530', NULL, NULL, 74, NULL, NULL, 119544),
(119545, '3.40.50.10330-FF-000110', NULL, 'NAD kinase', 89, NULL, NULL, 119545),
(119546, '3.20.20.80-FF-000544', NULL, 'Di-N-acetylchitobiase', 171, NULL, NULL, 119546),
(119547, '1.20.1070.10-FF-000170', NULL, 'Free fatty acid receptor 4', 324, NULL, NULL, 119547),
(119548, '1.20.970.10-FF-000031', NULL, 'Pyrimidine-nucleoside phosphorylase', 67, NULL, NULL, 119548);
INSERT INTO "PUBLIC"."MODEL" VALUES
(119549, '1.10.10.60-FF-001144', NULL, NULL, 58, NULL, NULL, 119549),
(119550, '2.130.10.10-FF-001155', NULL, 'UTP13p Nucleolar protein', 288, NULL, NULL, 119550),
(119551, '3.40.50.300-FF-001554', NULL, 'Translation elongation factor Tu', 204, NULL, NULL, 119551),
(119552, '3.30.40.10-FF-000423', NULL, 'Ring finger protein 122', 63, NULL, NULL, 119552),
(119553, '2.160.10.30-FF-000002', NULL, 'UTP--glucose-1-phosphate uridylyltransferase, putative', 142, NULL, NULL, 119553),
(119554, '3.40.50.80-FF-000146', NULL, 'NADPH--cytochrome P450 reductase 2', 81, NULL, NULL, 119554),
(119555, '2.10.25.10-FF-001695', NULL, 'Adhesion G protein-coupled receptor E1', 42, NULL, NULL, 119555),
(119556, '2.130.10.10-FF-004792', NULL, 'Protein phosphatase PP2A regulatory subunit B', 149, NULL, NULL, 119556),
(119557, '3.40.50.1950-FF-000002', NULL, 'Coenzyme A biosynthesis bifunctional protein CoaBC', 185, NULL, NULL, 119557),
(119558, '1.20.58.60-FF-000753', NULL, 'Uncharacterized protein', 260, NULL, NULL, 119558),
(119559, '3.90.1170.40-FF-000016', NULL, 'Molybdopterin synthase catalytic subunit', 173, NULL, NULL, 119559),
(119560, '1.10.287.570-FF-000006', NULL, 'Predicted protein', 42, NULL, NULL, 119560),
(119561, '2.70.98.10-FF-000079', NULL, 'Beta-galactosidase', 281, NULL, NULL, 119561),
(119562, '1.25.40.180-FF-000082', NULL, 'Uncharacterized protein, isoform A', 200, NULL, NULL, 119562),
(119563, '3.40.800.20-FF-000021', NULL, 'histone deacetylase 6 isoform X1', 384, NULL, NULL, 119563),
(119564, '3.30.160.20-FF-000058', NULL, 'Small RNA 2', 84, NULL, NULL, 119564),
(119565, '4.10.280.10-FF-000126', NULL, 'Protein WBSCR14 homolog', 92, NULL, NULL, 119565),
(119566, '3.40.50.10330-FF-000031', NULL, 'Diacylglycerol kinase', 129, NULL, NULL, 119566),
(119567, '1.10.8.60-FF-000070', NULL, 'DNA polymerase clamp loader subunit', 67, NULL, NULL, 119567),
(119568, '3.30.70.100-FF-000073', NULL, 'NIPSNAP', 107, NULL, NULL, 119568),
(119569, '1.20.1310.10-FF-000099', NULL, 'SCF ubiquitin ligase subunit CulC, putative', 107, NULL, NULL, 119569),
(119570, '1.10.8.10-FF-000206', NULL, 'Uncharacterized protein', 54, NULL, NULL, 119570),
(119571, '3.40.50.10190-FF-000163', NULL, 'BRCT domain-containing protein', 125, NULL, NULL, 119571),
(119572, '1.10.510.10-FF-003725', NULL, NULL, 152, NULL, NULL, 119572),
(119573, '2.40.40.20-FF-000017', NULL, 'Formate dehydrogenase, alpha subunit', 176, NULL, NULL, 119573),
(119574, '1.20.5.990-FF-000002', NULL, 'Optineurin', 91, NULL, NULL, 119574),
(119575, '2.30.30.230-FF-000001', NULL, 'Fumarylacetoacetase', 116, NULL, NULL, 119575),
(119576, '1.20.5.110-FF-000334', NULL, 'Synaptobrevin family protein', 95, NULL, NULL, 119576),
(119577, '1.20.5.170-FF-000245', NULL, 'FBJ murine osteosarcoma viral oncogene homolog B', 50, NULL, NULL, 119577),
(119578, '3.10.400.20-FF-000008', NULL, 'RNA binding protein Ligatin/Tma64, putative', 223, NULL, NULL, 119578),
(119579, '3.30.70.330-FF-001013', NULL, 'TIA-1/TIAL RNA binding protein homolog', 105, NULL, NULL, 119579),
(119580, '3.60.110.10-FF-000085', NULL, NULL, 161, NULL, NULL, 119580),
(119581, '3.90.1170.50-FF-000019', NULL, 'Isoquinoline 1-oxidoreductase, beta subunit, putative', 81, NULL, NULL, 119581),
(119582, '3.40.50.300-FF-006787', NULL, 'Uncharacterized protein', 58, NULL, NULL, 119582),
(119583, '3.40.50.2000-FF-000456', NULL, 'Glycosyltransferase family 9 protein', 148, NULL, NULL, 119583),
(119584, '1.25.40.470-FF-000062', NULL, 'Predicted protein', 180, NULL, NULL, 119584),
(119585, '2.30.30.140-FF-000316', NULL, 'Histone-lysine N-methyltransferase', 61, NULL, NULL, 119585),
(119586, '3.40.50.300-FF-001953', NULL, 'ATP-dependent RNA helicase DBP1', 289, NULL, NULL, 119586),
(119587, '3.80.10.10-FF-002824', NULL, 'Predicted protein', 165, NULL, NULL, 119587),
(119588, '3.40.50.12780-FF-000081', NULL, 'Possible fatty-acid-CoA ligase fadD10', 423, NULL, NULL, 119588),
(119589, '1.10.600.10-FF-000091', NULL, 'Os05g0235701 protein', 84, NULL, NULL, 119589),
(119590, '2.120.10.30-FF-000285', NULL, 'E3 ubiquitin-protein ligase TRIM71', 105, NULL, NULL, 119590);
INSERT INTO "PUBLIC"."MODEL" VALUES
(119591, '3.40.50.720-FF-002169', NULL, 'Os08g0516100 protein', 72, NULL, NULL, 119591),
(119592, '3.40.309.10-FF-000039', NULL, 'Aldehyde dehydrogenase ALDC', 185, NULL, NULL, 119592),
(119593, '3.40.50.300-FF-003561', NULL, 'ras-related protein Rab-22A', 136, NULL, NULL, 119593),
(119594, '1.25.10.10-FF-001517', NULL, 'Formin-H', 297, NULL, NULL, 119594),
(119595, '1.10.472.10-FF-000556', NULL, 'Predicted protein', 71, NULL, NULL, 119595),
(119596, '1.20.1280.50-FF-000051', NULL, 'F-box and WD-40 domain-containing protein MET30', 61, NULL, NULL, 119596),
(119597, '1.20.58.400-FF-000022', NULL, 'Uncharacterized protein', 100, NULL, NULL, 119597),
(119598, '1.10.540.10-FF-000001', NULL, 'Very long-chain-specific acyl-CoA dehydrogenase, mitochondrial', 117, NULL, NULL, 119598),
(119599, '3.50.50.60-FF-001331', NULL, 'Uncharacterized protein', 109, NULL, NULL, 119599),
(119600, '3.30.450.20-FF-000294', NULL, 'GGDEF domain-containing protein', 144, NULL, NULL, 119600),
(119601, '3.40.50.10490-FF-000146', NULL, NULL, 188, NULL, NULL, 119601),
(119602, '1.25.10.10-FF-003125', NULL, 'HEAT repeat-containing protein 2-like Protein', 205, NULL, NULL, 119602),
(119603, '2.40.50.140-FF-001190', NULL, NULL, 125, NULL, NULL, 119603),
(119604, '1.20.120.550-FF-000010', NULL, 'Uncharacterized protein', 139, NULL, NULL, 119604),
(119605, '2.130.10.10-FF-003690', NULL, 'F-box and WD domain protein, putative', 186, NULL, NULL, 119605),
(119606, '2.60.120.680-FF-000005', NULL, 'Golgi resident protein GCP60', 128, NULL, NULL, 119606),
(119607, '3.90.340.10-FF-000016', NULL, 'Nitric oxide synthase, inducible', 26, NULL, NULL, 119607),
(119608, '3.30.160.60-FF-003156', NULL, 'Uncharacterized protein, isoform B', 29, NULL, NULL, 119608),
(119609, '3.30.110.10-FF-000018', NULL, 'Uncharacterized protein', 93, NULL, NULL, 119609),
(119610, '1.25.40.10-FF-001019', NULL, 'ATPase expression protein', 126, NULL, NULL, 119610),
(119611, '1.20.1070.10-FF-000916', NULL, 'Olfactory receptor 893', 148, NULL, NULL, 119611),
(119612, '1.25.40.20-FF-001511', NULL, 'Uncharacterized protein', 194, NULL, NULL, 119612),
(119613, '3.80.10.10-FF-004432', NULL, 'Uncharacterized protein', 204, NULL, NULL, 119613),
(119614, '3.40.50.720-FF-001989', NULL, 'Short chain dehydrogenase', 242, NULL, NULL, 119614),
(119615, '2.40.160.20-FF-000003', NULL, 'Outer membrane protein A', 206, NULL, NULL, 119615),
(119616, '3.30.559.10-FF-000239', NULL, 'Chromosome 19, whole genome shotgun sequence', 133, NULL, NULL, 119616),
(119617, '2.10.25.10-FF-000700', NULL, 'Basement membrane proteoglycan', 55, NULL, NULL, 119617),
(119618, '3.40.50.300-FF-002133', NULL, 'Ras family protein', 179, NULL, NULL, 119618),
(119619, '1.10.357.140-FF-000035', NULL, 'UbiA prenyltransferase', 156, NULL, NULL, 119619),
(119620, '3.60.10.10-FF-000217', NULL, 'Sphingomyelinase DDB_G0288017', 356, NULL, NULL, 119620),
(119621, '1.25.10.10-FF-003451', NULL, 'Splicing factor subunit, putative', 221, NULL, NULL, 119621),
(119622, '1.20.1740.10-FF-000226', NULL, 'Uncharacterized protein', 445, NULL, NULL, 119622),
(119623, '3.40.1160.10-FF-000041', NULL, 'Glutamate 5-kinase, putative', 195, NULL, NULL, 119623),
(119624, '3.30.70.330-FF-002957', NULL, NULL, 154, NULL, NULL, 119624),
(119625, '1.10.287.2720-FF-000001', NULL, 'Oxysterol-binding OBPalpha', 66, NULL, NULL, 119625),
(119626, '3.40.50.300-FF-007260', NULL, 'Uncharacterized protein', 157, NULL, NULL, 119626),
(119627, '2.30.42.10-FF-000267', NULL, 'Protein CBR-STN-1', 82, NULL, NULL, 119627),
(119628, '1.20.120.1080-FF-000041', NULL, 'RNA HelicAse', 102, NULL, NULL, 119628),
(119629, '1.10.10.60-FF-000756', NULL, 'Uncharacterized protein', 104, NULL, NULL, 119629),
(119630, '4.10.240.10-FF-000017', NULL, 'Transcriptional regulator UME6', 40, NULL, NULL, 119630),
(119631, '1.20.1250.20-FF-000501', NULL, 'Multidrug resistance protein B', 400, NULL, NULL, 119631),
(119632, '1.10.10.10-FF-001680', NULL, 'Winged helix-turn-helix transcriptional regulator, Rrf2 family', 152, NULL, NULL, 119632),
(119633, '3.40.710.10-FF-000039', NULL, 'D-alanyl-D-alanine carboxypeptidase', 344, NULL, NULL, 119633);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(119634, '2.10.109.10-FF-000046', NULL, 'Mitochondrial inner membrane protease subunit', 131, NULL, NULL, 119634),
(119635, '1.25.40.20-FF-001348', NULL, 'Uncharacterized protein', 109, NULL, NULL, 119635),
(119636, '2.60.40.10-FF-003077', NULL, 'Sensory AXon guidance', 133, NULL, NULL, 119636),
(119637, '3.90.180.10-FF-000144', NULL, 'Uncharacterized protein', 201, NULL, NULL, 119637),
(119638, '2.60.60.20-FF-000063', NULL, NULL, 109, NULL, NULL, 119638),
(119639, '2.40.50.140-FF-000728', NULL, NULL, 108, NULL, NULL, 119639),
(119640, '3.40.50.300-FF-003235', NULL, 'ABC transporter family protein', 228, NULL, NULL, 119640),
(119641, '1.25.40.10-FF-001345', NULL, 'ETO1-like protein 1', 190, NULL, NULL, 119641),
(119642, '1.10.10.60-FF-001099', NULL, NULL, 70, NULL, NULL, 119642),
(119643, '1.10.486.10-FF-000043', NULL, 'ATP-dependent DNA helicase UvrD', 127, NULL, NULL, 119643),
(119644, '3.30.160.60-FF-003835', NULL, NULL, 29, NULL, NULL, 119644),
(119645, '2.30.29.30-FF-000770', NULL, 'Sprouty-related, EVH1 domain containing 1', 107, NULL, NULL, 119645),
(119646, '2.60.120.200-FF-000367', NULL, 'Laminin, alpha 1', 179, NULL, NULL, 119646),
(119647, '1.20.58.60-FF-000118', NULL, 'Dystrophin', 109, NULL, NULL, 119647),
(119648, '3.30.160.60-FF-001711', NULL, 'Flt3-interacting zinc finger protein 1', 28, NULL, NULL, 119648),
(119649, '1.10.4160.10-FF-000016', NULL, 'Purine-cytosine related permease', 447, NULL, NULL, 119649),
(119650, '3.80.10.10-FF-001998', NULL, 'Toll-like receptor 22', 143, NULL, NULL, 119650),
(119651, '1.10.238.10-FF-001029', NULL, 'Myosin regulatory light chain 1', 61, NULL, NULL, 119651),
(119652, '2.60.40.10-FF-005005', NULL, NULL, 106, NULL, NULL, 119652),
(119653, '2.60.120.380-FF-000022', NULL, 'AGAP012066-PA', 151, NULL, NULL, 119653),
(119654, '3.80.10.10-FF-004269', NULL, 'Mesoderm induction early response, putative', 58, NULL, NULL, 119654),
(119655, '4.10.400.10-FF-000215', NULL, 'Uncharacterized protein', 38, NULL, NULL, 119655),
(119656, '1.20.1560.10-FF-000454', NULL, 'HlyB/MsbA family ABC transporter', 338, NULL, NULL, 119656),
(119657, '3.30.9.10-FF-000300', NULL, 'Uncharacterized protein', 196, NULL, NULL, 119657),
(119658, '3.30.40.10-FF-000951', NULL, 'Blast:SEC23-interacting protein', 100, NULL, NULL, 119658),
(119659, '3.10.20.770-FF-000004', NULL, 'Phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit beta isoform A', 184, NULL, NULL, 119659),
(119660, '3.40.50.300-FF-001627', NULL, 'Nuclear DNA helicase II', 228, NULL, NULL, 119660),
(119661, '2.20.100.10-FF-000018', NULL, 'Thrombospondin type 1 domain containing 7A', 57, NULL, NULL, 119661),
(119662, '3.40.50.1370-FF-000042', NULL, 'Ornithine carbamoyltransferase', 141, NULL, NULL, 119662),
(119663, '3.90.190.10-FF-000425', NULL, 'Conserved expressed protein', 81, NULL, NULL, 119663),
(119664, '3.40.50.1010-FF-000029', NULL, 'DNA repair protein UVH3', 121, NULL, NULL, 119664),
(119665, '3.80.10.10-FF-002178', NULL, 'Uncharacterized protein', 171, NULL, NULL, 119665),
(119666, '1.10.1740.10-FF-000032', NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', 90, NULL, NULL, 119666),
(119667, '1.10.510.10-FF-001590', NULL, 'STE family protein kinase', 167, NULL, NULL, 119667),
(119668, '3.30.70.330-FF-000833', NULL, 'Galectin', 79, NULL, NULL, 119668),
(119669, '2.60.40.10-FF-001262', NULL, 'Immunoglobulin superfamily member 10', 84, NULL, NULL, 119669),
(119670, '2.60.220.50-FF-000075', NULL, 'Putative class b secretin-like g-protein coupled receptor gprcir1', 208, NULL, NULL, 119670),
(119671, '1.10.630.10-FF-000446', NULL, 'Uncharacterized protein', 235, NULL, NULL, 119671),
(119672, '1.10.287.70-FF-000008', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 145, NULL, NULL, 119672),
(119673, '3.40.50.720-FF-002506', NULL, 'Probable polyketide synthase 2', 376, NULL, NULL, 119673),
(119674, '1.10.238.10-FF-000849', NULL, 'EF-hand superfamily Ca2+-modulated protein (AFU_orthologue AFUA_5G13630)', 117, NULL, NULL, 119674),
(119675, '2.130.10.10-FF-001447', NULL, 'Nucleoporin NUP159', 387, NULL, NULL, 119675);
INSERT INTO "PUBLIC"."MODEL" VALUES
(119676, '3.80.10.10-FF-000380', NULL, 'Putative inactive leucine-rich repeat receptor-like protein kinase', 125, NULL, NULL, 119676),
(119677, '3.40.50.410-FF-000249', NULL, 'Uncharacterized protein', 166, NULL, NULL, 119677),
(119678, '3.40.720.10-FF-000130', NULL, 'GPI ethanolamine phosphate transferase 1', 164, NULL, NULL, 119678),
(119679, '1.10.40.70-FF-000002', NULL, 'Type II secretion system protein', 59, NULL, NULL, 119679),
(119680, '3.40.630.10-FF-000477', NULL, 'Uncharacterized protein', 317, NULL, NULL, 119680),
(119681, '3.90.105.20-FF-000001', NULL, '60S acidic ribosomal protein P0', 74, NULL, NULL, 119681),
(119682, '1.20.58.60-FF-000427', NULL, 'Nesprin-2', 282, NULL, NULL, 119682),
(119683, '1.25.10.10-FF-001197', NULL, 'ARM repeat superfamily protein', 151, NULL, NULL, 119683),
(119684, '1.10.10.10-FF-001045', NULL, 'ELL complex EAP30 subunit, putative', 71, NULL, NULL, 119684),
(119685, '1.10.510.10-FF-001264', NULL, 'Putative serine/threonine-protein kinase C01C4.3', 340, NULL, NULL, 119685),
(119686, '3.60.40.10-FF-000371', NULL, 'Uncharacterized protein', 368, NULL, NULL, 119686),
(119687, '2.60.120.200-FF-000693', NULL, 'Predicted protein', 197, NULL, NULL, 119687),
(119688, '2.10.25.10-FF-000054', NULL, 'Slit guidance ligand 2', 42, NULL, NULL, 119688),
(119689, '3.40.50.2000-FF-000826', NULL, 'Sucrose synthase 3', 170, NULL, NULL, 119689),
(119690, '2.60.40.10-FF-000160', NULL, 'Titin a', 99, NULL, NULL, 119690),
(119691, '2.130.10.10-FF-000767', NULL, 'WD repeat-containing protein 65', 170, NULL, NULL, 119691),
(119692, '2.30.30.1020-FF-000052', NULL, NULL, 171, NULL, NULL, 119692),
(119693, '3.40.718.10-FF-000068', NULL, 'Isocitrate dehydrogenase [NADP]', 190, NULL, NULL, 119693),
(119694, '3.40.390.10-FF-000295', NULL, NULL, 73, NULL, NULL, 119694),
(119695, '2.10.70.10-FF-000113', NULL, 'Uncharacterized protein, isoform C', 57, NULL, NULL, 119695),
(119696, '3.40.50.360-FF-000083', NULL, 'NADPH-dependent oxidoreductase', 192, NULL, NULL, 119696),
(119697, '3.30.1330.40-FF-000009', NULL, 'Endoribonuclease', 145, NULL, NULL, 119697),
(119698, '1.25.10.10-FF-001208', NULL, 'Sister chromatid cohesion protein PDS5 homolog A', 254, NULL, NULL, 119698),
(119699, '3.40.1110.10-FF-000313', NULL, NULL, 145, NULL, NULL, 119699),
(119700, '3.30.40.10-FF-000625', NULL, 'E3 ubiquitin ligase Rnf157', 67, NULL, NULL, 119700),
(119701, '2.30.29.30-FF-000118', NULL, 'GULP PTB domain containing engulfment adaptor 1', 157, NULL, NULL, 119701),
(119702, '3.30.160.60-FF-005073', NULL, NULL, 70, NULL, NULL, 119702),
(119703, '3.30.70.330-FF-002278', NULL, NULL, 62, NULL, NULL, 119703),
(119704, '3.10.100.10-FF-000399', NULL, NULL, 118, NULL, NULL, 119704),
(119705, '3.40.50.300-FF-000216', NULL, 'Type VII secretion ATPase EccA', 190, NULL, NULL, 119705),
(119706, '3.10.250.10-FF-000044', NULL, 'Protein bark beetle', 111, NULL, NULL, 119706),
(119707, '3.30.1240.10-FF-000038', NULL, 'Cof-like hydrolase', 118, NULL, NULL, 119707),
(119708, '3.30.450.20-FF-000614', NULL, 'Uncharacterized protein', 117, NULL, NULL, 119708),
(119709, '3.40.630.30-FF-000550', NULL, 'Predicted protein', 137, NULL, NULL, 119709),
(119710, '1.20.5.100-FF-000005', NULL, 'Penicillin-binding protein 1b', 39, NULL, NULL, 119710),
(119711, '3.30.1330.30-FF-000006', NULL, 'Peptide chain release factor subunit 1', 159, NULL, NULL, 119711),
(119712, '3.30.430.20-FF-000068', NULL, 'Uncharacterized protein', 102, NULL, NULL, 119712),
(119713, '3.30.1330.20-FF-000003', NULL, 'Tubulin gamma chain', 112, NULL, NULL, 119713),
(119714, '1.20.5.110-FF-000008', NULL, 'Syntaxin 132', 101, NULL, NULL, 119714),
(119715, '2.60.40.10-FF-001469', NULL, 'protein sidekick isoform X9', 94, NULL, NULL, 119715),
(119716, '2.40.50.90-FF-000168', NULL, 'Tudor domain containing protein', 138, NULL, NULL, 119716),
(119717, '3.30.70.330-FF-000496', NULL, 'RNA binding protein', 93, NULL, NULL, 119717),
(119718, '3.30.70.1020-FF-000001', NULL, 'Alpha,alpha-trehalose-phosphate synthase [UDP-forming] 1', 80, NULL, NULL, 119718),
(119719, '2.60.120.200-FF-000704', NULL, 'Uncharacterized protein', 185, NULL, NULL, 119719);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(119720, '3.90.660.10-FF-000063', NULL, NULL, 227, NULL, NULL, 119720),
(119721, '1.10.10.2330-FF-000012', NULL, NULL, 68, NULL, NULL, 119721),
(119722, '1.20.1250.10-FF-000009', NULL, 'Growth hormone', 190, NULL, NULL, 119722),
(119723, '1.10.10.10-FF-001354', NULL, 'Putative disease resistance protein At3g14460', 88, NULL, NULL, 119723),
(119724, '1.10.287.130-FF-000077', NULL, 'Sensor histidine kinase SaeS', 77, NULL, NULL, 119724),
(119725, '2.70.170.10-FF-000298', NULL, 'Uncharacterized protein', 137, NULL, NULL, 119725),
(119726, '3.40.470.10-FF-000020', NULL, 'Type-5 uracil-DNA glycosylase', 219, NULL, NULL, 119726),
(119727, '3.100.10.10-FF-000017', NULL, 'Mrpl10p', 89, NULL, NULL, 119727),
(119728, '2.30.40.10-FF-000105', NULL, 'Uncharacterized protein', 58, NULL, NULL, 119728),
(119729, '3.40.50.300-FF-003870', NULL, 'Putative elongator complex protein 4', 312, NULL, NULL, 119729),
(119730, '3.80.10.10-FF-000907', NULL, 'Volume-regulated anion channel subunit LRRC8E isoform X1', 102, NULL, NULL, 119730),
(119731, '1.20.1560.10-FF-000780', NULL, 'Uncharacterized protein', 288, NULL, NULL, 119731),
(119732, '1.20.1050.130-FF-000049', NULL, 'Uncharacterized protein', 67, NULL, NULL, 119732),
(119733, '3.40.1190.20-FF-000181', NULL, NULL, 359, NULL, NULL, 119733),
(119734, '3.40.1690.20-FF-000011', NULL, 'ParaPleGiN AAA protease family', 97, NULL, NULL, 119734),
(119735, '1.20.1720.10-FF-000017', NULL, 'Drug resistance MFS transporter', 210, NULL, NULL, 119735),
(119736, '2.130.10.10-FF-003701', NULL, 'Uncharacterized protein', 269, NULL, NULL, 119736),
(119737, '3.30.200.20-FF-000585', NULL, 'Mitogen-activated protein kinase', 24, NULL, NULL, 119737),
(119738, '1.20.1250.20-FF-002255', NULL, 'Uncharacterized protein', 106, NULL, NULL, 119738),
(119739, '3.30.559.10-FF-000195', NULL, 'At5g02890', 207, NULL, NULL, 119739),
(119740, '3.30.70.1320-FF-000001', NULL, 'Efflux pump membrane transporter', 100, NULL, NULL, 119740),
(119741, '1.20.1270.60-FF-000126', NULL, 'SIP3p Transcription cofactor', 254, NULL, NULL, 119741),
(119742, '1.25.40.10-FF-002789', NULL, 'U3 small nucleolar RNA-associated protein 6 homolog-like Protein', 222, NULL, NULL, 119742),
(119743, '3.30.420.40-FF-000798', NULL, 'Major actin', 109, NULL, NULL, 119743),
(119744, '1.10.840.10-FF-000046', NULL, 'Phospholipase C epsilon, putative', 199, NULL, NULL, 119744),
(119745, '3.30.450.20-FF-000305', NULL, 'GGDEF family protein', 132, NULL, NULL, 119745),
(119746, '1.10.275.20-FF-000016', NULL, NULL, 65, NULL, NULL, 119746),
(119747, '2.60.40.10-FF-003723', NULL, NULL, 92, NULL, NULL, 119747),
(119748, '1.20.58.340-FF-000043', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 102, NULL, NULL, 119748),
(119749, '2.30.230.10-FF-000048', NULL, 'Uncharacterized protein', 266, NULL, NULL, 119749),
(119750, '2.10.25.10-FF-000363', NULL, 'Meprin A subunit', 45, NULL, NULL, 119750),
(119751, '3.80.10.10-FF-002471', NULL, 'Probable serine/threonine-protein kinase roco4', 198, NULL, NULL, 119751),
(119752, '3.30.390.30-FF-000033', NULL, 'Putative pyridine nucleotide-disulfide oxidoreductase', 113, NULL, NULL, 119752),
(119753, '3.30.479.20-FF-000051', NULL, 'Elongation factor Ts', 102, NULL, NULL, 119753),
(119754, '1.20.950.20-FF-000016', NULL, 'Formate dehydrogenase-N subunit gamma', 210, NULL, NULL, 119754),
(119755, '3.20.20.140-FF-000015', NULL, 'CAD protein isoform X2', 368, NULL, NULL, 119755),
(119756, '3.20.20.150-FF-000018', NULL, 'Protein arginine N-methyltransferase', 333, NULL, NULL, 119756),
(119757, '1.25.10.10-FF-002299', NULL, 'Uncharacterized protein', 323, NULL, NULL, 119757),
(119758, '3.20.20.140-FF-000324', NULL, 'Dihydroorotase, putative', 162, NULL, NULL, 119758),
(119759, '1.10.3660.10-FF-000009', NULL, 'Prephenate dehydrogenase tyrA', 103, NULL, NULL, 119759),
(119760, '3.30.230.10-FF-000084', NULL, 'Diphosphomevalonate decarboxylase', 174, NULL, NULL, 119760),
(119761, '2.60.40.10-FF-001941', NULL, 'Tyrosine-protein kinase receptor', 112, NULL, NULL, 119761),
(119762, '1.10.510.10-FF-003416', NULL, NULL, 294, NULL, NULL, 119762);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(119763, '3.50.50.60-FF-000516', NULL, 'FAD-dependent oxidoreductase', 90, NULL, NULL, 119763),
(119764, '2.40.50.700-FF-000003', NULL, 'DIS3-like exonuclease 2', 81, NULL, NULL, 119764),
(119765, '3.60.20.10-FF-000145', NULL, 'Proteasome subunit alpha type', 99, NULL, NULL, 119765),
(119766, '3.50.50.60-FF-000825', NULL, 'Sll0703 protein', 118, NULL, NULL, 119766),
(119767, '1.10.10.10-FF-000865', NULL, 'LysR family transcriptional regulator', 80, NULL, NULL, 119767),
(119768, '2.30.39.10-FF-000040', NULL, 'Serpin peptidase inhibitor 7', 130, NULL, NULL, 119768),
(119769, '3.30.470.20-FF-000177', NULL, 'Tubulin-tyrosine ligase family-domain-containing protein', 207, NULL, NULL, 119769),
(119770, '3.50.50.60-FF-001005', NULL, 'Lysine-specific histone demethylase 2', 92, NULL, NULL, 119770),
(119771, '3.30.160.60-FF-003509', NULL, 'Zinc finger protein 829', 28, NULL, NULL, 119771),
(119772, '1.10.275.10-FF-000013', NULL, 'Argininosuccinate lyase', 105, NULL, NULL, 119772),
(119773, '3.40.50.720-FF-002495', NULL, 'UDP-glucose 4-epimerase 4', 156, NULL, NULL, 119773),
(119774, '2.40.420.20-FF-000041', NULL, 'RND efflux membrane fusion protein', 91, NULL, NULL, 119774),
(119775, '3.40.1030.10-FF-000003', NULL, 'Pyrimidine-nucleoside phosphorylase', 268, NULL, NULL, 119775),
(119776, '1.10.1040.10-FF-000041', NULL, '2-dehydropantoate 2-reductase', 130, NULL, NULL, 119776),
(119777, '6.10.140.2220-FF-000002', NULL, 'Protein kinase C-binding protein 1 isoform C', 50, NULL, NULL, 119777),
(119778, '3.90.640.10-FF-000180', NULL, 'Actin, putative', 55, NULL, NULL, 119778),
(119779, '3.40.50.720-FF-000354', NULL, 'UDP-galactopyranose mutase', 99, NULL, NULL, 119779),
(119780, '3.30.420.40-FF-000489', NULL, 'Heat shock protein, putative', 90, NULL, NULL, 119780),
(119781, '1.20.1270.420-FF-000011', NULL, 'Uncharacterized protein', 152, NULL, NULL, 119781),
(119782, '1.25.40.20-FF-001039', NULL, 'Os09g0331600 protein', 191, NULL, NULL, 119782),
(119783, '1.20.930.50-FF-000001', NULL, NULL, 102, NULL, NULL, 119783),
(119784, '2.30.29.30-FF-000753', NULL, 'Amyloid beta precursor protein binding family B member 1', 82, NULL, NULL, 119784),
(119785, '1.25.10.10-FF-003434', NULL, 'Maestro heat-like repeat-containing protein family member 1', 320, NULL, NULL, 119785),
(119786, '3.40.50.880-FF-000177', NULL, 'Imidazole glycerol phosphate synthase subunit HisH 2', 202, NULL, NULL, 119786),
(119787, '1.20.5.1160-FF-000029', NULL, 'Uncharacterized protein', 119, NULL, NULL, 119787),
(119788, '3.40.1160.10-FF-000024', NULL, 'Uridylate kinase', 247, NULL, NULL, 119788),
(119789, '2.60.40.3120-FF-000001', NULL, 'cytosolic carboxypeptidase 1 isoform X1', 151, NULL, NULL, 119789),
(119790, '3.40.50.1820-FF-000194', NULL, 'Alpha/beta hydrolase, putative', 294, NULL, NULL, 119790),
(119791, '3.20.140.10-FF-000028', NULL, 'Nicotinate phosphoribosyltransferase', 154, NULL, NULL, 119791),
(119792, '3.90.1150.10-FF-000366', NULL, 'UDP-2-acetamido-2-deoxy-3-oxo-D-glucuronate aminotransferase', 115, NULL, NULL, 119792),
(119793, '3.30.1600.10-FF-000010', NULL, 'NAD-dependent protein deacetylase', 94, NULL, NULL, 119793),
(119794, '3.40.470.10-FF-000003', NULL, 'G/U mismatch-specific DNA glycosylase', 168, NULL, NULL, 119794),
(119795, '1.20.120.1380-FF-000007', NULL, 'Flagellar biosynthesis regulator FlhF', 50, NULL, NULL, 119795),
(119796, '3.30.70.330-FF-002648', NULL, NULL, 120, NULL, NULL, 119796),
(119797, '1.20.58.400-FF-000005', NULL, 'Vesicle transport through interaction with t-snares 1a', 100, NULL, NULL, 119797),
(119798, '1.20.58.100-FF-000022', NULL, NULL, 114, NULL, NULL, 119798),
(119799, '2.160.20.10-FF-000098', NULL, 'Pectinesterase', 275, NULL, NULL, 119799),
(119800, '3.40.710.10-FF-000056', NULL, 'D-alanyl-D-alanine carboxypeptidase DacB', 260, NULL, NULL, 119800),
(119801, '2.60.40.10-FF-003414', NULL, NULL, 83, NULL, NULL, 119801),
(119802, '3.60.10.10-FF-000190', NULL, 'Predicted protein', 326, NULL, NULL, 119802),
(119803, '2.10.109.10-FF-000063', NULL, 'Probable signal peptidase I-2', 131, NULL, NULL, 119803); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(119804, '3.30.40.10-FF-002087', NULL, 'Uncharacterized protein', 77, NULL, NULL, 119804),
(119805, '1.20.120.1240-FF-000078', NULL, 'Uncharacterized protein', 227, NULL, NULL, 119805),
(119806, '2.40.290.10-FF-000021', NULL, 'Caenorhabditis KU', 102, NULL, NULL, 119806),
(119807, '1.20.930.60-FF-000004', NULL, 'Protein-glutamate O-methyltransferase', 120, NULL, NULL, 119807),
(119808, '3.30.1440.10-FF-000003', NULL, 'Ribosomal protein L5', 175, NULL, NULL, 119808),
(119809, '3.10.590.10-FF-000002', NULL, 'YTH domain-containing protein 1 isoform X1', 183, NULL, NULL, 119809),
(119810, '2.60.40.10-FF-005314', NULL, NULL, 79, NULL, NULL, 119810),
(119811, '1.20.1560.10-FF-000471', NULL, 'ABC transporter permease', 320, NULL, NULL, 119811),
(119812, '1.20.5.170-FF-000228', NULL, 'Predicted protein', 72, NULL, NULL, 119812),
(119813, '2.150.10.10-FF-000002', NULL, 'Leukotoxin', 218, NULL, NULL, 119813),
(119814, '3.40.50.10140-FF-000081', NULL, 'Uncharacterized protein', 142, NULL, NULL, 119814),
(119815, '1.20.58.930-FF-000006', NULL, 'Arginine decarboxylase', 69, NULL, NULL, 119815),
(119816, '2.40.160.50-FF-000029', NULL, 'Surface antigen', 347, NULL, NULL, 119816),
(119817, '3.40.50.10190-FF-000180', NULL, 'DNA ligase', 109, NULL, NULL, 119817),
(119818, '2.130.10.10-FF-004999', NULL, 'Uncharacterized protein', 65, NULL, NULL, 119818),
(119819, '2.70.160.11-FF-000012', NULL, 'Protein arginine N-methyltransferase PRMT10', 208, NULL, NULL, 119819),
(119820, '2.10.90.10-FF-000013', NULL, 'Gremlin', 119, NULL, NULL, 119820),
(119821, '1.10.1820.10-FF-000016', NULL, 'Casein kinase II beta2 subunit', 103, NULL, NULL, 119821),
(119822, '2.130.10.10-FF-004819', NULL, 'Uncharacterized protein', 138, NULL, NULL, 119822),
(119823, '3.40.50.12160-FF-000001', NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase', 128, NULL, NULL, 119823),
(119824, '3.30.450.60-FF-000047', NULL, 'AP-1 complex subunit mu-2', 116, NULL, NULL, 119824),
(119825, '1.25.40.770-FF-000028', NULL, 'Uncharacterized protein', 211, NULL, NULL, 119825),
(119826, '2.60.220.50-FF-000103', NULL, 'Uncharacterized protein', 184, NULL, NULL, 119826),
(119827, '3.40.50.300-FF-004050', NULL, 'DNA mismatch repair protein', 230, NULL, NULL, 119827),
(119828, '3.30.40.10-FF-000479', NULL, 'E3 ubiquitin-protein ligase Arkadia', 83, NULL, NULL, 119828),
(119829, '3.90.640.10-FF-000163', NULL, 'Actin-related protein 4', 127, NULL, NULL, 119829),
(119830, '2.60.40.10-FF-001615', NULL, 'Tyrosine-protein kinase receptor Tie-1 isoform B', 96, NULL, NULL, 119830),
(119831, '1.10.8.60-FF-000053', NULL, 'DNA polymerase epsilon subunit', 74, NULL, NULL, 119831),
(119832, '1.20.1070.10-FF-000933', NULL, 'Uncharacterized protein', 110, NULL, NULL, 119832),
(119833, '3.10.20.90-FF-000795', NULL, 'AT15685p', 88, NULL, NULL, 119833),
(119834, '1.25.40.180-FF-000065', NULL, 'Nuclear cap-binding protein subunit 1-B', 203, NULL, NULL, 119834),
(119835, '3.40.50.1360-FF-000022', NULL, 'DNA-binding transcriptional regulator', 262, NULL, NULL, 119835),
(119836, '1.25.40.10-FF-004908', NULL, 'Os09g0555400 protein', 73, NULL, NULL, 119836),
(119837, '2.10.25.10-FF-000037', NULL, 'Signal peptide, CUB domain and EGF-like domain-containing 2', 42, NULL, NULL, 119837),
(119838, '1.10.150.50-FF-000062', NULL, 'Sterile alpha and TIR motif containing 1', 69, NULL, NULL, 119838),
(119839, '3.30.450.20-FF-000631', NULL, 'Hybrid sensor kinase RscS', 142, NULL, NULL, 119839),
(119840, '3.40.50.2000-FF-000473', NULL, 'Glycosyl transferase', 160, NULL, NULL, 119840),
(119841, '2.60.120.290-FF-000130', NULL, 'Uncharacterized protein', 144, NULL, NULL, 119841),
(119842, '3.30.160.60-FF-002200', NULL, 'zinc finger protein 341 isoform X1', 71, NULL, NULL, 119842),
(119843, '2.40.50.120-FF-000026', NULL, 'AGAP000228-PA', 139, NULL, NULL, 119843),
(119844, '3.30.160.60-FF-001918', NULL, NULL, 28, NULL, NULL, 119844),
(119845, '1.10.510.10-FF-003742', NULL, NULL, 148, NULL, NULL, 119845),
(119846, '1.20.1070.10-FF-002171', NULL, 'AGAP013324-PA', 120, NULL, NULL, 119846),
(119847, '3.10.50.10-FF-000054', NULL, 'Chitinase, putative', 43, NULL, NULL, 119847);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(119848, '3.40.50.300-FF-005152', NULL, 'ABC transporter, ATP-binding protein', 231, NULL, NULL, 119848),
(119849, '1.10.10.10-FF-001028', NULL, 'LuxR family transcriptional regulator', 61, NULL, NULL, 119849),
(119850, '3.40.1110.10-FF-000330', NULL, NULL, 222, NULL, NULL, 119850),
(119851, '3.30.70.270-FF-000028', NULL, 'Diguanylate cyclase domain protein', 157, NULL, NULL, 119851),
(119852, '1.10.510.10-FF-001281', NULL, 'NNK1p Protein kinase', 161, NULL, NULL, 119852),
(119853, '3.40.850.10-FF-000549', NULL, 'Kinesin-like protein', 203, NULL, NULL, 119853),
(119854, '3.30.1330.40-FF-000026', NULL, 'Translation initiation inhibitor', 120, NULL, NULL, 119854),
(119855, '3.30.420.10-FF-000137', NULL, 'ISPsy4, transposase', 182, NULL, NULL, 119855),
(119856, '3.40.50.360-FF-000127', NULL, 'Chromosome 8, whole genome shotgun sequence', 200, NULL, NULL, 119856),
(119857, '2.60.40.10-FF-004797', NULL, NULL, 128, NULL, NULL, 119857),
(119858, '3.30.1360.120-FF-000030', NULL, 'GTPase MSS1, mitochondrial', 136, NULL, NULL, 119858),
(119859, '3.30.930.10-FF-000075', NULL, 'probable asparagine--tRNA ligase, mitochondrial isoform X1', 348, NULL, NULL, 119859),
(119860, '2.60.40.10-FF-004488', NULL, NULL, 113, NULL, NULL, 119860),
(119861, '3.40.50.300-FF-003914', NULL, 'Putative recombinase rad51', 306, NULL, NULL, 119861),
(119862, '1.25.10.10-FF-002962', NULL, 'Exportin-4-like Protein', 435, NULL, NULL, 119862),
(119863, '3.30.1330.30-FF-000023', NULL, 'rRNA methyltransferase 3, mitochondrial', 93, NULL, NULL, 119863),
(119864, '1.25.10.10-FF-001534', NULL, 'Coatomer subunit gamma', 154, NULL, NULL, 119864),
(119865, '3.30.70.260-FF-000025', NULL, 'Probable septum site-determining protein MinC', 114, NULL, NULL, 119865),
(119866, '3.30.70.330-FF-002750', NULL, NULL, 132, NULL, NULL, 119866),
(119867, '3.80.10.10-FF-000037', NULL, 'Toll-like receptor 7', 807, NULL, NULL, 119867),
(119868, '3.10.580.10-FF-000030', NULL, 'Chloride channel protein', 100, NULL, NULL, 119868),
(119869, '1.10.260.40-FF-000078', NULL, 'Helix-turn-helix domain protein', 93, NULL, NULL, 119869),
(119870, '3.30.70.330-FF-001322', NULL, 'Uncharacterized protein', 153, NULL, NULL, 119870),
(119871, '3.40.50.300-FF-007922', NULL, 'Uncharacterized protein', 176, NULL, NULL, 119871),
(119872, '2.40.50.90-FF-000185', NULL, 'Tudor domain containing protein', 77, NULL, NULL, 119872),
(119873, '2.40.50.100-FF-000020', NULL, '50S ribosomal protein L27', 77, NULL, NULL, 119873),
(119874, '3.30.160.60-FF-003173', NULL, 'AGAP007915-PA', 20, NULL, NULL, 119874),
(119875, '1.25.40.10-FF-001036', NULL, 'Putative pentatricopeptide repeat-containing protein At1g03510', 150, NULL, NULL, 119875),
(119876, '3.30.70.250-FF-000022', NULL, NULL, 46, NULL, NULL, 119876),
(119877, '3.80.10.10-FF-004415', NULL, 'Lumican, putative', 62, NULL, NULL, 119877),
(119878, '1.25.10.10-FF-001860', NULL, 'Os02g0146400 protein', 177, NULL, NULL, 119878),
(119879, '3.30.70.330-FF-000850', NULL, 'Serine/arginine-rich splicing factor SR45a', 161, NULL, NULL, 119879),
(119880, '2.60.40.10-FF-003386', NULL, NULL, 114, NULL, NULL, 119880),
(119881, '1.20.1250.10-FF-000026', NULL, 'Interferon beta', 165, NULL, NULL, 119881),
(119882, '1.10.10.390-FF-000002', NULL, 'Histone acetyltransferase type B catalytic subunit', 59, NULL, NULL, 119882),
(119883, '3.40.50.1010-FF-000046', NULL, 'RAD2p Single-stranded DNA endonuclease', 141, NULL, NULL, 119883),
(119884, '3.30.70.100-FF-000101', NULL, 'Cation transport ATPase, E1-E2 family', 88, NULL, NULL, 119884),
(119885, '2.60.120.10-FF-000140', NULL, 'Bacilysin biosynthesis protein', 105, NULL, NULL, 119885),
(119886, '2.40.50.120-FF-000043', NULL, 'Meteorin-like, glial cell differentiation regulator a', 123, NULL, NULL, 119886),
(119887, '3.40.50.2020-FF-000012', NULL, 'Phosphoribosyl pyrophosphate synthase-associated protein 2 isoform 1', 156, NULL, NULL, 119887),
(119888, '3.40.50.620-FF-000650', NULL, 'Uncharacterized protein', 156, NULL, NULL, 119888),
(119889, '3.40.50.1260-FF-000008', NULL, 'Phosphoglycerate kinase', 177, NULL, NULL, 119889);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(119890, '4.10.400.10-FF-000232', NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein-like Protein', 38, NULL, NULL, 119890),
(119891, '3.30.160.60-FF-003482', NULL, NULL, 20, NULL, NULL, 119891),
(119892, '2.60.40.10-FF-002588', NULL, 'Suppressor protein SPT23, putative', 126, NULL, NULL, 119892),
(119893, '3.40.50.300-FF-007613', NULL, 'Uncharacterized protein', 155, NULL, NULL, 119893),
(119894, '3.30.160.60-FF-002071', NULL, 'Zinc finger protein 570', 34, NULL, NULL, 119894),
(119895, '1.25.40.10-FF-001362', NULL, 'RNA splicing factor', 220, NULL, NULL, 119895),
(119896, '2.40.50.140-FF-001201', NULL, NULL, 94, NULL, NULL, 119896),
(119897, '3.30.200.20-FF-001411', NULL, 'Uncharacterized protein', 87, NULL, NULL, 119897),
(119898, '3.40.366.10-FF-000008', NULL, 'Mycocerosic acid synthase-like polyketide synthase', 333, NULL, NULL, 119898),
(119899, '1.10.3720.10-FF-000099', NULL, 'Inner membrane ABC transporter permease ynjC', 220, NULL, NULL, 119899),
(119900, '3.60.20.10-FF-000128', NULL, 'Proteasome subunit beta', 205, NULL, NULL, 119900),
(119901, '1.25.40.10-FF-003262', NULL, 'Transmembrane and tetratricopeptide repeat-containing 1', 154, NULL, NULL, 119901),
(119902, '3.30.470.20-FF-000205', NULL, 'Inositol-tetrakisphosphate 1-kinase b', 44, NULL, NULL, 119902),
(119903, '1.10.510.10-FF-003181', NULL, NULL, 155, NULL, NULL, 119903),
(119904, '1.20.5.500-FF-000018', NULL, NULL, 57, NULL, NULL, 119904),
(119905, '1.10.472.140-FF-000013', NULL, 'Retinoblastoma family protein', 148, NULL, NULL, 119905),
(119906, '3.30.160.60-FF-005308', NULL, NULL, 27, NULL, NULL, 119906),
(119907, '3.40.1170.60-FF-000051', NULL, NULL, 63, NULL, NULL, 119907),
(119908, '2.30.30.1190-FF-000007', NULL, 'DExH-box helicase 57', 52, NULL, NULL, 119908),
(119909, '3.30.1360.120-FF-000013', NULL, 'Sarcosine dehydrogenase, mitochondrial', 188, NULL, NULL, 119909),
(119910, '1.25.40.20-FF-001365', NULL, 'Uncharacterized protein', 93, NULL, NULL, 119910),
(119911, '3.30.450.20-FF-000322', NULL, 'Sensory box histidine kinase', 132, NULL, NULL, 119911),
(119912, '3.30.479.30-FF-000037', NULL, 'stomatin-like protein 1', 130, NULL, NULL, 119912),
(119913, '3.20.20.140-FF-000341', NULL, 'ACR238Wp', 356, NULL, NULL, 119913),
(119914, '3.30.200.40-FF-000006', NULL, 'Scavenger mRNA-decapping enzyme DcpS', 103, NULL, NULL, 119914),
(119915, '3.80.10.10-FF-004286', NULL, 'Uncharacterized protein', 243, NULL, NULL, 119915),
(119916, '3.40.20.10-FF-000090', NULL, 'Variant sh3 domain containing protein', 130, NULL, NULL, 119916),
(119917, '2.20.100.10-FF-000035', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 12', 52, NULL, NULL, 119917),
(119918, '3.80.10.10-FF-002515', NULL, 'Adenylate cyclase', 83, NULL, NULL, 119918),
(119919, '3.30.420.270-FF-000001', NULL, 'Tol-Pal system protein TolR', 74, NULL, NULL, 119919),
(119920, '1.10.10.10-FF-001337', NULL, 'Response regulator receiver', 110, NULL, NULL, 119920),
(119921, '2.60.40.10-FF-003740', NULL, NULL, 111, NULL, NULL, 119921),
(119922, '2.30.30.140-FF-000300', NULL, 'Predicted protein', 75, NULL, NULL, 119922),
(119923, '3.40.50.1370-FF-000025', NULL, 'Aspartate carbamoyltransferase', 147, NULL, NULL, 119923),
(119924, '2.60.40.10-FF-002897', NULL, 'Deleted in lung and esophageal cancer protein 1', 92, NULL, NULL, 119924),
(119925, '3.30.200.20-FF-001309', NULL, 'Vesicle-associated protein 1-1', 92, NULL, NULL, 119925),
(119926, '2.60.40.1730-FF-000005', NULL, 'Aminopeptidase N', 184, NULL, NULL, 119926),
(119927, '3.40.50.1820-FF-000059', NULL, 'Fatty acid synthase', 170, NULL, NULL, 119927),
(119928, '3.40.50.12780-FF-000097', NULL, 'AMP-dependent synthetase and ligase', 373, NULL, NULL, 119928),
(119929, '1.10.238.10-FF-000866', NULL, 'RabGAP/TBC domain-containing protein', 224, NULL, NULL, 119929),
(119930, '3.40.605.10-FF-000042', NULL, 'Succinate semialdehyde dehydrogenase', 269, NULL, NULL, 119930),
(119931, '3.40.720.10-FF-000113', NULL, 'Phosphonoacetate hydrolase', 287, NULL, NULL, 119931),
(119932, '3.80.10.10-FF-000363', NULL, 'Leucine-rich repeat family protein', 155, NULL, NULL, 119932);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(119933, '3.30.160.60-FF-000300', NULL, 'PR domain zinc finger protein 10', 82, NULL, NULL, 119933),
(119934, '1.10.10.200-FF-000002', NULL, 'Probable transcriptional regulatory protein CLM62_37755', 79, NULL, NULL, 119934),
(119935, '1.10.510.10-FF-003079', NULL, NULL, 202, NULL, NULL, 119935),
(119936, '2.30.130.10-FF-000001', NULL, 'H/ACA ribonucleoprotein complex subunit CBF5', 125, NULL, NULL, 119936),
(119937, '1.10.1080.10-FF-000015', NULL, 'Glutathione synthetase', 88, NULL, NULL, 119937),
(119938, '3.40.50.2000-FF-000809', NULL, 'Putative alpha,alpha-trehalose-phosphate synthase [UDP-forming] 106 kDa subunit', 200, NULL, NULL, 119938),
(119939, '3.30.190.20-FF-000032', NULL, '50S ribosomal protein L1', 107, NULL, NULL, 119939),
(119940, '2.10.70.10-FF-000130', NULL, 'Complement factor H', 71, NULL, NULL, 119940),
(119941, '3.60.10.10-FF-000173', NULL, 'Putative endonuclease/exonuclease/phosphatase', 153, NULL, NULL, 119941),
(119942, '1.50.40.10-FF-000090', NULL, 'Folate transporter 1, chloroplastic', 205, NULL, NULL, 119942),
(119943, '3.30.160.20-FF-000221', NULL, 'HEN1 protein', 53, NULL, NULL, 119943),
(119944, '1.20.120.850-FF-000010', NULL, 'E1A-binding protein p400 isoform X4', 84, NULL, NULL, 119944),
(119945, '3.40.50.300-FF-005359', NULL, 'Dynein axonemal heavy chain 3', 188, NULL, NULL, 119945),
(119946, '3.40.50.2300-FF-001080', NULL, 'Uncharacterized protein', 296, NULL, NULL, 119946),
(119947, '1.20.1070.10-FF-000046', NULL, '5-hydroxytryptamine receptor 4', 324, NULL, NULL, 119947),
(119948, '1.20.1250.20-FF-000338', NULL, 'Putative plastidic glucose transporter 1', 440, NULL, NULL, 119948),
(119949, '3.30.450.50-FF-000044', NULL, 'Synaptobrevin 9-2', 124, NULL, NULL, 119949),
(119950, '1.10.510.10-FF-001617', NULL, 'Ser/thr protein kinase', 302, NULL, NULL, 119950),
(119951, '1.20.140.10-FF-000108', NULL, 'Acyl-CoA dehydrogenase long chain', 91, NULL, NULL, 119951),
(119952, '1.20.920.10-FF-000174', NULL, 'Predicted protein', 121, NULL, NULL, 119952),
(119953, '3.30.479.20-FF-000034', NULL, 'Elongation factor Ts, mitochondrial', 118, NULL, NULL, 119953),
(119954, '3.50.50.60-FF-000960', NULL, 'Glycine oxidase', 175, NULL, NULL, 119954),
(119955, '1.20.1050.10-FF-000163', NULL, 'Glutathione S-transferase', 105, NULL, NULL, 119955),
(119956, '1.10.1220.10-FF-000004', NULL, 'Macrodomain Ter protein', 53, NULL, NULL, 119956),
(119957, '1.20.1070.10-FF-000607', NULL, '5-hydroxytryptamine receptor 4-like', 322, NULL, NULL, 119957),
(119958, '2.60.40.10-FF-005331', NULL, NULL, 75, NULL, NULL, 119958),
(119959, '1.10.1200.120-FF-000001', NULL, 'Large-conductance mechanosensitive channel', 132, NULL, NULL, 119959),
(119960, '1.10.510.10-FF-002899', NULL, NULL, 179, NULL, NULL, 119960),
(119961, '2.60.40.1090-FF-000021', NULL, 'Fimbrial-like adhesin protein', 135, NULL, NULL, 119961),
(119962, '3.40.50.2300-FF-000591', NULL, 'Two-component system sensor molecule', 147, NULL, NULL, 119962),
(119963, '1.10.405.10-FF-000030', NULL, 'PLATZ transcription factor family protein', 30, NULL, NULL, 119963),
(119964, '3.80.10.10-FF-000924', NULL, 'Receptor like protein 39', 152, NULL, NULL, 119964),
(119965, '3.80.10.10-FF-000672', NULL, 'Leucine Rich Repeat family protein, expressed', 99, NULL, NULL, 119965),
(119966, '3.30.420.10-FF-000463', NULL, NULL, 246, NULL, NULL, 119966),
(119967, '2.60.40.10-FF-001486', NULL, 'Interleukin-1 receptor accessory protein-like 1', 96, NULL, NULL, 119967),
(119968, '3.30.200.20-FF-001102', NULL, 'Mitochondrial ribosomal protein L48, putative', 84, NULL, NULL, 119968),
(119969, '3.30.70.1430-FF-000017', NULL, NULL, 93, NULL, NULL, 119969),
(119970, '3.30.450.20-FF-000277', NULL, 'Two-component sensor histidine kinase', 137, NULL, NULL, 119970),
(119971, '2.30.29.30-FF-000444', NULL, 'Decapping enzyme Dcp1, putative', 139, NULL, NULL, 119971),
(119972, '2.60.40.10-FF-005640', NULL, NULL, 94, NULL, NULL, 119972),
(119973, '3.10.129.10-FF-000173', NULL, 'Uncharacterized protein', 151, NULL, NULL, 119973),
(119974, '1.20.1250.20-FF-000029', NULL, 'solute carrier family 2, facilitated glucose transporter member 4', 471, NULL, NULL, 119974);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(119975, '3.10.250.10-FF-000061', NULL, 'Macrophage scavenger receptor 1', 61, NULL, NULL, 119975),
(119976, '2.130.10.10-FF-001582', NULL, 'WD domain', 342, NULL, NULL, 119976),
(119977, '3.30.40.10-FF-000608', NULL, 'E3 ubiquitin-protein ligase', 56, NULL, NULL, 119977),
(119978, '3.30.70.330-FF-000479', NULL, 'Splicing factor 3B subunit 4', 77, NULL, NULL, 119978),
(119979, '1.10.220.150-FF-000078', NULL, 'Uncharacterized protein', 65, NULL, NULL, 119979),
(119980, '1.25.50.20-FF-000011', NULL, 'Aminopeptidase', 328, NULL, NULL, 119980),
(119981, '3.40.1280.10-FF-000090', NULL, 'Putative methyltransferase', 151, NULL, NULL, 119981),
(119982, '2.60.450.10-FF-000007', NULL, 'Lipopolysaccharide export system protein LptC', 127, NULL, NULL, 119982),
(119983, '3.40.50.10490-FF-000129', NULL, NULL, 128, NULL, NULL, 119983),
(119984, '1.25.40.10-FF-004925', NULL, 'Pre-mRNA-processing factor 6-like Protein', 59, NULL, NULL, 119984),
(119985, '1.10.287.470-FF-000050', NULL, 'Resistance-Nodulation-Cell Division (RND) efflux membrane fusion protein', 66, NULL, NULL, 119985),
(119986, '1.20.120.790-FF-000031', NULL, 'Uncharacterized protein', 102, NULL, NULL, 119986),
(119987, '3.90.640.10-FF-000045', NULL, 'Actin-related protein 8', 102, NULL, NULL, 119987),
(119988, '3.80.10.10-FF-000346', NULL, 'Leucine rich repeat containing 1', 126, NULL, NULL, 119988),
(119989, '2.60.120.200-FF-000721', NULL, 'MshA pili-associated adhesin MshQ', 246, NULL, NULL, 119989),
(119990, '3.10.50.10-FF-000071', NULL, 'CHItinase-Like', 11, NULL, NULL, 119990),
(119991, '3.20.20.100-FF-000127', NULL, 'Glycerol dehydrogenase (GCY1), putative', 65, NULL, NULL, 119991),
(119992, '3.40.250.10-FF-000138', NULL, 'AGAP000552-PA', 125, NULL, NULL, 119992),
(119993, '3.30.160.60-FF-005634', NULL, NULL, 28, NULL, NULL, 119993),
(119994, '3.40.605.10-FF-000025', NULL, 'NADP-dependent glyceraldehyde-3-phosphate dehydrogenase', 252, NULL, NULL, 119994),
(119995, '1.10.8.60-FF-000406', NULL, 'RuvB-like helicase', 102, NULL, NULL, 119995),
(119996, '2.30.29.30-FF-000635', NULL, 'BPH1p Protein', 127, NULL, NULL, 119996),
(119997, '1.50.10.100-FF-000002', NULL, 'Alginate lyase', 335, NULL, NULL, 119997),
(119998, '2.60.40.650-FF-000021', NULL, 'Sulfite-dehydrogenase, putative', 126, NULL, NULL, 119998),
(119999, '1.20.1250.20-FF-000782', NULL, 'Proton-dependent oligopeptide transport family protein', 496, NULL, NULL, 119999),
(120000, '1.20.1050.90-FF-000012', NULL, 'DNA replication and repair protein RecF', 196, NULL, NULL, 120000),
(120001, '2.60.40.200-FF-000015', NULL, 'Copper/zinc superoxide dismutase', 150, NULL, NULL, 120001),
(120002, '1.25.10.10-FF-001652', NULL, 'TORTIFOLIA1-like protein 3', 384, NULL, NULL, 120002),
(120003, '3.20.20.80-FF-000813', NULL, 'Uncharacterized protein', 109, NULL, NULL, 120003),
(120004, '3.30.428.40-FF-000001', NULL, 'AT3G19900 protein', 110, NULL, NULL, 120004),
(120005, '4.10.1000.10-FF-000058', NULL, 'putative cleavage and polyadenylation specificity factor subunit 4-like protein', 34, NULL, NULL, 120005),
(120006, '2.60.40.1390-FF-000004', NULL, 'Myelin regulatory factor', 132, NULL, NULL, 120006),
(120007, '3.60.40.10-FF-000337', NULL, 'Uncharacterized protein', 138, NULL, NULL, 120007),
(120008, '3.40.50.1400-FF-000040', NULL, 'Uncharacterized protein', 67, NULL, NULL, 120008),
(120009, '1.10.1420.10-FF-000002', NULL, 'DNA mismatch repair protein MutS', 117, NULL, NULL, 120009),
(120010, '2.60.120.290-FF-000113', NULL, 'Uncharacterized protein', 126, NULL, NULL, 120010),
(120011, '3.10.50.40-FF-000130', NULL, 'Trigger factor', 36, NULL, NULL, 120011),
(120012, '3.40.50.300-FF-003426', NULL, 'Related to Ras-like G protein RagD', 77, NULL, NULL, 120012),
(120013, '2.30.30.140-FF-000081', NULL, 'Tudor domain-containing protein 1', 56, NULL, NULL, 120013),
(120014, '3.40.50.150-FF-001790', NULL, NULL, 172, NULL, NULL, 120014),
(120015, '3.30.40.10-FF-001699', NULL, 'Histone-lysine N-methyltransferase', 67, NULL, NULL, 120015),
(120016, '3.90.190.10-FF-000616', NULL, 'Uncharacterized protein', 87, NULL, NULL, 120016);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(120017, '1.25.40.20-FF-001691', NULL, 'Predicted protein', 73, NULL, NULL, 120017),
(120018, '3.30.70.330-FF-001193', NULL, 'Os07g0615400 protein', 109, NULL, NULL, 120018),
(120019, '2.40.50.140-FF-000493', NULL, 'DIS3 exonuclease 2', 92, NULL, NULL, 120019),
(120020, '3.30.70.660-FF-000038', NULL, 'tRNA pseudouridine synthase A', 138, NULL, NULL, 120020),
(120021, '3.30.310.80-FF-000015', NULL, 'Non-specific serine/threonine protein kinase', 121, NULL, NULL, 120021),
(120022, '3.40.50.300-FF-007158', NULL, 'Os01g0681100 protein', 175, NULL, NULL, 120022),
(120023, '3.30.200.20-FF-002529', NULL, 'Uncharacterized protein', 55, NULL, NULL, 120023),
(120024, '1.25.40.10-FF-001800', NULL, 'Pentatricopeptide repeat-containing protein', 133, NULL, NULL, 120024),
(120025, '3.30.310.20-FF-000003', NULL, 'DNA-3-methyladenine glycosylase', 119, NULL, NULL, 120025),
(120026, '3.30.70.330-FF-001204', NULL, NULL, 108, NULL, NULL, 120026),
(120027, '1.20.5.110-FF-000143', NULL, 'Syntaxin 8', 43, NULL, NULL, 120027),
(120028, '1.10.418.20-FF-000012', NULL, 'Unplaced genomic scaffold supercont1.23, whole genome shotgun sequence', 48, NULL, NULL, 120028),
(120029, '3.40.50.2000-FF-000591', NULL, 'Glycosyltransferase', 260, NULL, NULL, 120029),
(120030, '3.30.465.10-FF-000117', NULL, 'Uncharacterized protein', 89, NULL, NULL, 120030),
(120031, '3.30.300.20-FF-000064', NULL, 'Uncharacterized protein', 63, NULL, NULL, 120031),
(120032, '1.10.418.40-FF-000018', NULL, 'Uncharacterized protein', 190, NULL, NULL, 120032),
(120033, '2.130.10.10-FF-002993', NULL, 'Transducin/WD40 repeat-like superfamily protein', 198, NULL, NULL, 120033),
(120034, '2.60.40.10-FF-001823', NULL, 'Down syndrome cell adhesion molecule 2, isoform Q', 82, NULL, NULL, 120034),
(120035, '2.70.50.30-FF-000031', NULL, NULL, 69, NULL, NULL, 120035),
(120036, '2.40.128.20-FF-000041', NULL, 'Uncharacterized protein', 161, NULL, NULL, 120036),
(120037, '1.10.510.10-FF-003490', NULL, NULL, 263, NULL, NULL, 120037),
(120038, '1.20.58.1070-FF-000007', NULL, 'Chromosome 23, whole genome shotgun sequence', 206, NULL, NULL, 120038),
(120039, '2.60.40.10-FF-003532', NULL, 'Polycystic kidney disease 1 like 1', 112, NULL, NULL, 120039),
(120040, '3.90.650.10-FF-000017', NULL, 'Probable phosphoribosylformylglycinamidine synthase, chloroplastic/mitochondrial', 166, NULL, NULL, 120040),
(120041, '3.90.70.80-FF-000027', NULL, 'Predicted protein', 155, NULL, NULL, 120041),
(120042, '1.20.120.1770-FF-000017', NULL, 'Uncharacterized protein', 170, NULL, NULL, 120042),
(120043, '3.40.50.2000-FF-000164', NULL, 'Lipopolysaccharide heptosyltransferase I', 152, NULL, NULL, 120043),
(120044, '3.50.30.30-FF-000135', NULL, 'Uncharacterized protein', 168, NULL, NULL, 120044),
(120045, '1.20.58.2190-FF-000006', NULL, 'N-glycanase 1', 67, NULL, NULL, 120045),
(120046, '3.60.15.10-FF-000178', NULL, 'Hydroxyacylglutathione hydrolase 3, mitochondrial', 168, NULL, NULL, 120046),
(120047, '3.40.50.970-FF-000069', NULL, '1-deoxy-D-xylulose 5-phosphate synthase', 280, NULL, NULL, 120047),
(120048, '2.60.220.50-FF-000058', NULL, 'Uncharacterized protein', 107, NULL, NULL, 120048),
(120049, '3.90.640.10-FF-000146', NULL, 'Actin-related protein 3-1', 101, NULL, NULL, 120049),
(120050, '3.90.550.20-FF-000030', NULL, 'Uncharacterized protein', 229, NULL, NULL, 120050),
(120051, '1.20.120.350-FF-000040', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 146, NULL, NULL, 120051),
(120052, '3.90.1240.10-FF-000002', NULL, 'Botulinum neurotoxin type A', 426, NULL, NULL, 120052),
(120053, '2.60.40.2860-FF-000024', NULL, '6-cysteine protein', 165, NULL, NULL, 120053),
(120054, '3.30.160.20-FF-000193', NULL, 'Adenosine deaminase domain containing 1', 78, NULL, NULL, 120054),
(120055, '1.25.40.570-FF-000075', NULL, 'Protein CBR-CSN-2', 119, NULL, NULL, 120055),
(120056, '1.20.1070.10-FF-000681', NULL, 'GoNadotropin-Releasing hormone Receptor (GnRHR) related', 356, NULL, NULL, 120056),
(120057, '2.60.40.1180-FF-000121', NULL, 'Maltase B1, isoform A', 85, NULL, NULL, 120057),
(120058, '1.10.287.130-FF-000105', NULL, 'Putative sensory histidine kinase in two-component regulatory system', 69, NULL, NULL, 120058);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(120059, '2.170.300.10-FF-000009', NULL, 'Terribly reduced optic lobes, isoform AK', 72, NULL, NULL, 120059),
(120060, '3.50.7.10-FF-000077', NULL, NULL, 65, NULL, NULL, 120060),
(120061, '3.40.50.300-FF-008586', NULL, 'Uncharacterized protein', 179, NULL, NULL, 120061),
(120062, '3.90.245.10-FF-000019', NULL, 'Putative nucleoside hydrolase', 322, NULL, NULL, 120062),
(120063, '3.75.10.10-FF-000044', NULL, NULL, 302, NULL, NULL, 120063),
(120064, '3.30.1490.20-FF-000060', NULL, 'Phosphoglucan, water dikinase, chloroplastic', 193, NULL, NULL, 120064),
(120065, '1.25.40.20-FF-001803', NULL, 'Uncharacterized protein', 166, NULL, NULL, 120065),
(120066, '2.60.120.260-FF-000469', NULL, 'Glycosyl hydrolases family 2, sugar binding domain containing protein', 192, NULL, NULL, 120066),
(120067, '3.80.10.10-FF-003898', NULL, 'Uncharacterized protein', 135, NULL, NULL, 120067),
(120068, '3.30.420.40-FF-001080', NULL, 'Uncharacterized protein', 131, NULL, NULL, 120068),
(120069, '1.20.910.10-FF-000022', NULL, 'Uncharacterized protein', 240, NULL, NULL, 120069),
(120070, '1.10.287.70-FF-000025', NULL, 'Voltage-dependent R-type calcium channel subunit alpha', 156, NULL, NULL, 120070),
(120071, '3.30.300.30-FF-000067', NULL, 'Nonribosomal peptide synthase GliP2', 98, NULL, NULL, 120071),
(120072, '2.130.10.10-FF-001801', NULL, 'Transducin/WD40 repeat-like superfamily protein', 185, NULL, NULL, 120072),
(120073, '1.10.1370.40-FF-000001', NULL, 'Dipeptidyl carboxypeptidase II', 413, NULL, NULL, 120073),
(120074, '1.25.40.10-FF-000974', NULL, 'Putative pentatricopeptide repeat-containing protein mitochondrial', 227, NULL, NULL, 120074),
(120075, '1.25.10.10-FF-001225', NULL, 'Serine/threonine-protein kinase TOR', 500, NULL, NULL, 120075),
(120076, '1.20.58.60-FF-000399', NULL, 'VAB-10B protein', 211, NULL, NULL, 120076),
(120077, '2.60.40.10-FF-001278', NULL, 'Defective proboscis extension response', 95, NULL, NULL, 120077),
(120078, '3.90.180.10-FF-000009', NULL, 'Reticulon-4-interacting protein 1, mitochondrial', 158, NULL, NULL, 120078),
(120079, '1.50.40.10-FF-000117', NULL, 'SLC25A32 isoform 3', 138, NULL, NULL, 120079),
(120080, '3.40.50.1110-FF-000060', NULL, 'GDSL-like Lipase/Acylhydrolase', 247, NULL, NULL, 120080),
(120081, '3.30.160.60-FF-001683', NULL, 'Zinc finger protein 467', 32, NULL, NULL, 120081),
(120082, '3.30.1460.20-FF-000024', NULL, 'Actin-related protein 2/3 complex subunit 2B', 86, NULL, NULL, 120082),
(120083, '3.50.50.80-FF-000011', NULL, NULL, 114, NULL, NULL, 120083),
(120084, '1.10.3860.10-FF-000024', NULL, 'Amino acid transporter', 315, NULL, NULL, 120084),
(120085, '3.30.930.10-FF-000103', NULL, 'Lipoate-protein ligase A type 2', 312, NULL, NULL, 120085),
(120086, '2.30.29.30-FF-001141', NULL, 'Uncharacterized protein', 116, NULL, NULL, 120086),
(120087, '3.30.160.60-FF-001935', NULL, NULL, 29, NULL, NULL, 120087),
(120088, '1.20.1410.10-FF-000016', NULL, 'Uncharacterized protein', 156, NULL, NULL, 120088),
(120089, '3.40.1110.10-FF-000184', NULL, 'Cation transporting ATPase', 166, NULL, NULL, 120089),
(120090, '1.20.120.1750-FF-000169', NULL, 'RBR-type E3 ubiquitin transferase', 89, NULL, NULL, 120090),
(120091, '1.10.565.10-FF-000114', NULL, 'Nuclear Hormone Receptor family', 248, NULL, NULL, 120091),
(120092, '1.10.287.610-FF-000007', NULL, 'DNA ligase', 71, NULL, NULL, 120092),
(120093, '3.90.640.90-FF-000012', NULL, 'Uncharacterized protein', 117, NULL, NULL, 120093),
(120094, '2.60.120.10-FF-000038', NULL, 'cGMP-dependent protein kinase', 146, NULL, NULL, 120094),
(120095, '3.40.50.300-FF-004033', NULL, 'DNA replication helicase Dna2', 257, NULL, NULL, 120095),
(120096, '2.60.120.290-FF-000012', NULL, 'mannan-binding lectin serine protease 1 isoform X1', 120, NULL, NULL, 120096),
(120097, '3.10.20.870-FF-000017', NULL, NULL, 74, NULL, NULL, 120097),
(120098, '3.90.79.10-FF-000279', NULL, 'Uncharacterized protein', 68, NULL, NULL, 120098),
(120099, '3.40.33.10-FF-000052', NULL, 'SCP-Like extracellular protein', 214, NULL, NULL, 120099),
(120100, '3.40.50.1460-FF-000052', NULL, 'GPI8 transamidase isoform 2', 281, NULL, NULL, 120100);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(120101, '3.40.50.300-FF-005461', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 231, NULL, NULL, 120101),
(120102, '2.130.10.10-FF-001790', NULL, 'Uncharacterized protein', 126, NULL, NULL, 120102),
(120103, '3.40.50.2300-FF-000248', NULL, 'LacI family transcriptional regulator', 142, NULL, NULL, 120103),
(120104, '1.10.287.600-FF-000004', NULL, 'Tubulin gamma chain', 61, NULL, NULL, 120104),
(120105, '1.20.80.10-FF-000043', NULL, 'Protein expanded', 111, NULL, NULL, 120105),
(120106, '3.40.850.10-FF-000460', NULL, 'Kinesin family member C1', 378, NULL, NULL, 120106),
(120107, '3.30.160.60-FF-001256', NULL, 'zinc finger protein 664', 24, NULL, NULL, 120107),
(120108, '3.30.559.10-FF-000240', NULL, 'Choline O-acetyltransferase', 131, NULL, NULL, 120108),
(120109, '1.10.8.140-FF-000020', NULL, 'Predicted protein', 104, NULL, NULL, 120109),
(120110, '3.80.10.10-FF-001060', NULL, 'OSJNBa0064H22.13 protein', 96, NULL, NULL, 120110),
(120111, '3.40.50.1360-FF-000005', NULL, '6-phosphogluconolactonase', 249, NULL, NULL, 120111),
(120112, '3.80.10.10-FF-000716', NULL, 'LRR receptor-like serine/threonine-protein kinase GSO1', 273, NULL, NULL, 120112),
(120113, '1.10.287.70-FF-000126', NULL, 'Uncharacterized protein, isoform C', 260, NULL, NULL, 120113),
(120114, '2.120.10.80-FF-000159', NULL, 'tRNA wybutosine-synthesizing protein 2/3/4', 301, NULL, NULL, 120114),
(120115, '4.10.240.10-FF-000034', NULL, 'Chromosome 16, whole genome shotgun sequence', 66, NULL, NULL, 120115),
(120116, '1.10.20.120-FF-000002', NULL, 'Ribonuclease H2 subunit B', 140, NULL, NULL, 120116),
(120117, '3.30.160.60-FF-001727', NULL, 'Zinc finger protein 350', 36, NULL, NULL, 120117),
(120118, '1.10.10.10-FF-000657', NULL, 'Two-component system response regulator', 101, NULL, NULL, 120118),
(120119, '1.10.20.140-FF-000008', NULL, 'tRNA dimethylallyltransferase', 70, NULL, NULL, 120119),
(120120, '3.90.190.10-FF-000408', NULL, 'Uncharacterized protein', 80, NULL, NULL, 120120),
(120121, '1.10.510.10-FF-001146', NULL, 'Protein CBG08226', 353, NULL, NULL, 120121),
(120122, '3.30.70.270-FF-000236', NULL, NULL, 180, NULL, NULL, 120122),
(120123, '1.25.40.10-FF-005061', NULL, 'Pentatricopeptide repeat-containing protein At1g62670, mitochondrial', 105, NULL, NULL, 120123),
(120124, '1.20.920.10-FF-000157', NULL, 'Uncharacterized protein', 128, NULL, NULL, 120124),
(120125, '3.40.50.300-FF-005713', NULL, 'Uncharacterized protein', 166, NULL, NULL, 120125),
(120126, '3.30.40.10-FF-001013', NULL, 'Uncharacterized protein, isoform B', 96, NULL, NULL, 120126),
(120127, '1.20.1070.10-FF-000254', NULL, 'Cholecystokinin receptor type A', 107, NULL, NULL, 120127),
(120128, '1.20.1250.20-FF-002064', NULL, 'Os11g0284300 protein', 290, NULL, NULL, 120128),
(120129, '3.30.40.10-FF-000507', NULL, 'Transcription factor jumonji (JmjC) domain-containing protein', 59, NULL, NULL, 120129),
(120130, '3.40.50.720-FF-000606', NULL, 'Chromosome 15, whole genome shotgun sequence', 201, NULL, NULL, 120130),
(120131, '1.10.1280.10-FF-000013', NULL, 'Tyrosinase domain protein', 457, NULL, NULL, 120131),
(120132, '3.20.20.80-FF-000033', NULL, 'Glucan 1,3-beta-glucosidase A', 400, NULL, NULL, 120132),
(120133, '1.20.1730.10-FF-000063', NULL, 'High-affinity choline transporter', 466, NULL, NULL, 120133),
(120134, '1.10.630.10-FF-000800', NULL, 'Uncharacterized protein', 85, NULL, NULL, 120134),
(120135, '3.40.50.620-FF-000874', NULL, 'Valine--tRNA ligase', 125, NULL, NULL, 120135),
(120136, '3.30.420.10-FF-000446', NULL, NULL, 202, NULL, NULL, 120136),
(120137, '3.30.40.10-FF-000934', NULL, 'Os03g0648600 protein', 88, NULL, NULL, 120137),
(120138, '2.30.29.30-FF-000427', NULL, 'Adaptin ear-binding coat-associated protein 1', 111, NULL, NULL, 120138),
(120139, '3.40.50.1820-FF-000755', NULL, 'Protein CBG02889', 537, NULL, NULL, 120139),
(120140, '1.20.1070.10-FF-000372', NULL, 'Uncharacterized protein', 262, NULL, NULL, 120140),
(120141, '1.10.600.10-FF-000057', NULL, 'Geranylgeranyl pyrophosphate synthetase, putative [includes: dimethylallyltranstransferase (Ec 2.5.1.1) geranyltranstransferase (Ec 2.5.1.10) farnesyltranstransferas (Ec 2.5.1.29)]', 330, NULL, NULL, 120141);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(120142, '3.30.190.20-FF-000015', NULL, '50S ribosomal protein L1', 113, NULL, NULL, 120142),
(120143, '2.10.25.10-FF-000245', NULL, 'latent-transforming growth factor beta-binding protein 3 isoform X2', 41, NULL, NULL, 120143),
(120144, '3.10.460.20-FF-000001', NULL, 'Matrix protein', 173, NULL, NULL, 120144),
(120145, '3.90.1280.20-FF-000013', NULL, NULL, 59, NULL, NULL, 120145),
(120146, '1.20.1250.20-FF-000681', NULL, 'Sugar efflux transporter', 189, NULL, NULL, 120146),
(120147, '2.10.25.10-FF-000924', NULL, 'Notch 3', 39, NULL, NULL, 120147),
(120148, '3.90.190.10-FF-000307', NULL, 'Uncharacterized protein', 166, NULL, NULL, 120148),
(120149, '3.20.20.70-FF-000030', NULL, 'Nicotinate-nucleotide pyrophosphorylase, carboxylating', 142, NULL, NULL, 120149),
(120150, '2.130.10.10-FF-001138', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 286, NULL, NULL, 120150),
(120151, '3.90.1580.10-FF-000022', NULL, 'Uncharacterized protein', 318, NULL, NULL, 120151),
(120152, '1.10.10.60-FF-001127', NULL, NULL, 101, NULL, NULL, 120152),
(120153, '3.40.50.720-FF-000915', NULL, 'Pyrroline-5-carboxylate reductase', 168, NULL, NULL, 120153),
(120154, '1.10.630.10-FF-000137', NULL, 'Uncharacterized protein', 471, NULL, NULL, 120154),
(120155, '3.30.40.10-FF-001322', NULL, 'GD24619', 54, NULL, NULL, 120155),
(120156, '1.10.20.130-FF-000005', NULL, 'Poly [ADP-ribose] polymerase', 76, NULL, NULL, 120156),
(120157, '3.10.20.410-FF-000008', NULL, 'Fimbrial biogenesis outer membrane usher protein', 126, NULL, NULL, 120157),
(120158, '2.60.120.590-FF-000085', NULL, 'Uncharacterized protein', 93, NULL, NULL, 120158),
(120159, '3.30.160.20-FF-000075', NULL, 'Os04g0529500 protein', 66, NULL, NULL, 120159),
(120160, '3.20.140.10-FF-000045', NULL, 'Nicotinate phosphoribosyltransferase', 14, NULL, NULL, 120160),
(120161, '3.40.50.150-FF-001094', NULL, NULL, 225, NULL, NULL, 120161),
(120162, '1.10.8.10-FF-000223', NULL, 'K7_Rup1p', 56, NULL, NULL, 120162),
(120163, '3.40.50.970-FF-000187', NULL, 'Uncharacterized protein', 68, NULL, NULL, 120163),
(120164, '1.10.150.50-FF-000106', NULL, 'Diacylglycerol kinase', 70, NULL, NULL, 120164),
(120165, '3.30.710.10-FF-000356', NULL, 'AaceriACR082Cp', 146, NULL, NULL, 120165),
(120166, '3.30.70.600-FF-000026', NULL, 'Uncharacterized protein', 104, NULL, NULL, 120166),
(120167, '3.40.50.300-FF-007276', NULL, 'Uncharacterized protein', 155, NULL, NULL, 120167),
(120168, '3.20.20.80-FF-000342', NULL, 'Malto-oligosyltrehalose synthase', 68, NULL, NULL, 120168),
(120169, '3.30.420.40-FF-000927', NULL, 'Actin-like protein 3, putative', 115, NULL, NULL, 120169),
(120170, '3.40.50.300-FF-001661', NULL, 'RAD17 checkpoint clamp loader component', 181, NULL, NULL, 120170),
(120171, '2.170.140.10-FF-000019', NULL, 'Mucin 26B', 62, NULL, NULL, 120171),
(120172, '1.25.10.70-FF-000001', NULL, 'Nucleoporin NUP188', 294, NULL, NULL, 120172),
(120173, '3.40.710.10-FF-000073', NULL, 'D-alanyl-D-alanine carboxypeptidase', 278, NULL, NULL, 120173),
(120174, '3.30.40.10-FF-002216', NULL, 'Uncharacterized protein', 69, NULL, NULL, 120174),
(120175, '1.25.10.10-FF-003097', NULL, 'CLIP-associating protein', 223, NULL, NULL, 120175),
(120176, '1.20.58.60-FF-000298', NULL, 'Spectrin repeat containing nuclear envelope protein 1', 114, NULL, NULL, 120176),
(120177, '3.30.70.330-FF-002087', NULL, NULL, 171, NULL, NULL, 120177),
(120178, '3.40.50.150-FF-000975', NULL, NULL, 224, NULL, NULL, 120178),
(120179, '1.20.120.1070-FF-000004', NULL, 'GH22202', 104, NULL, NULL, 120179),
(120180, '1.20.1260.10-FF-000055', NULL, 'Ferritin', 171, NULL, NULL, 120180),
(120181, '3.30.50.10-FF-000199', NULL, 'C2C2-GATA transcription factor', 52, NULL, NULL, 120181),
(120182, '3.40.50.300-FF-001970', NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', 185, NULL, NULL, 120182),
(120183, '3.40.50.2000-FF-000944', NULL, 'Predicted protein', 125, NULL, NULL, 120183),
(120184, '2.120.10.30-FF-000577', NULL, 'Protein STRICTOSIDINE SYNTHASE-LIKE 3', 180, NULL, NULL, 120184),
(120185, '1.25.40.20-FF-001382', NULL, 'Calmodulin-binding transcription activator 4', 75, NULL, NULL, 120185);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(120186, '1.10.510.10-FF-000893', NULL, 'CAMK/CAMK1 protein kinase', 353, NULL, NULL, 120186),
(120187, '2.60.40.60-FF-000051', NULL, 'FAT atypical cadherin 1', 98, NULL, NULL, 120187),
(120188, '3.40.1190.20-FF-000063', NULL, 'Pyridoxal kinase', 110, NULL, NULL, 120188),
(120189, '3.30.710.10-FF-000238', NULL, 'Probable voltage-gated potassium channel subunit kvs-4', 128, NULL, NULL, 120189),
(120190, '3.30.1520.10-FF-000167', NULL, 'Uncharacterized protein', 122, NULL, NULL, 120190),
(120191, '2.130.10.10-FF-005533', NULL, 'Predicted protein', 276, NULL, NULL, 120191),
(120192, '2.130.10.10-FF-005281', NULL, 'Uncharacterized protein', 235, NULL, NULL, 120192),
(120193, '2.60.40.10-FF-004696', NULL, NULL, 111, NULL, NULL, 120193),
(120194, '1.25.40.270-FF-000002', NULL, 'callose synthase 3', 158, NULL, NULL, 120194),
(120195, '3.40.50.2300-FF-000456', NULL, 'Gamma-aminobutyric acid type B receptor subunit 2', 192, NULL, NULL, 120195),
(120196, '1.25.10.10-FF-000837', NULL, 'Importin subunit alpha-3, putative', 408, NULL, NULL, 120196),
(120197, '3.30.70.330-FF-002396', NULL, NULL, 95, NULL, NULL, 120197),
(120198, '1.10.510.10-FF-002927', NULL, 'Predicted protein', 363, NULL, NULL, 120198),
(120199, '2.60.40.420-FF-000109', NULL, 'Conserved protein', 143, NULL, NULL, 120199),
(120200, '1.20.120.1080-FF-000007', NULL, 'Probable ATP-dependent RNA helicase DHX35', 158, NULL, NULL, 120200),
(120201, '1.10.640.10-FF-000065', NULL, 'Oxidase/peroxidase, putative', 189, NULL, NULL, 120201),
(120202, '1.20.920.10-FF-000202', NULL, 'Bromodomain and WD repeat domain-containing 1', 126, NULL, NULL, 120202),
(120203, '1.10.274.100-FF-000008', NULL, 'DNA-directed RNA polymerase subunit', 169, NULL, NULL, 120203),
(120204, '2.60.110.10-FF-000004', NULL, 'THAUMATIN-LIKE PROTEIN 1', 221, NULL, NULL, 120204),
(120205, '3.30.2130.30-FF-000042', NULL, 'Probable tRNA sulfurtransferase', 171, NULL, NULL, 120205),
(120206, '3.40.1380.20-FF-000010', NULL, 'Pyruvate kinase', 127, NULL, NULL, 120206),
(120207, '2.60.120.10-FF-000802', NULL, 'Uncharacterized protein', 127, NULL, NULL, 120207),
(120208, '2.60.40.10-FF-001514', NULL, 'CD8 alpha chain', 118, NULL, NULL, 120208),
(120209, '1.10.10.10-FF-001371', NULL, 'GntR family transcriptional regulator', 77, NULL, NULL, 120209),
(120210, '2.30.30.100-FF-000193', NULL, 'Uncharacterized protein', 101, NULL, NULL, 120210),
(120211, '1.10.150.50-FF-000207', NULL, 'Sec-23 interacting protein P125, putative', 57, NULL, NULL, 120211),
(120212, '2.60.40.420-FF-000098', NULL, 'Putative multicopper oxidase', 154, NULL, NULL, 120212),
(120213, '1.10.630.10-FF-000480', NULL, 'Uncharacterized protein', 476, NULL, NULL, 120213),
(120214, '2.60.120.290-FF-000219', NULL, 'CUB domaincontaining protein', 114, NULL, NULL, 120214),
(120215, '2.60.40.1730-FF-000106', NULL, NULL, 198, NULL, NULL, 120215),
(120216, '3.40.50.300-FF-007467', NULL, 'RNA helicase', 317, NULL, NULL, 120216),
(120217, '3.20.20.140-FF-000442', NULL, 'ADR119Wp', 83, NULL, NULL, 120217),
(120218, '3.40.920.10-FF-000010', NULL, 'Phenylglyoxylate acceptor oxidoreductase', 189, NULL, NULL, 120218),
(120219, '1.20.120.690-FF-000001', NULL, 'Protein RDM1', 122, NULL, NULL, 120219),
(120220, '3.40.50.620-FF-000195', NULL, 'Tryptophan--tRNA ligase', 215, NULL, NULL, 120220),
(120221, '1.20.58.2220-FF-000021', NULL, 'Formin 3, isoform B', 406, NULL, NULL, 120221),
(120222, '1.20.1250.20-FF-002272', NULL, 'Galactoside permease', 95, NULL, NULL, 120222),
(120223, '1.10.630.10-FF-000238', NULL, 'Cytochrome P450 2A6', 476, NULL, NULL, 120223),
(120224, '2.130.10.10-FF-005180', NULL, 'Ribosome biogenesis protein WDR12 homolog', 124, NULL, NULL, 120224),
(120225, '3.40.220.10-FF-000002', NULL, 'Core histone macro-H2A', 195, NULL, NULL, 120225),
(120226, '3.40.50.300-FF-007821', NULL, 'Predicted protein', 276, NULL, NULL, 120226),
(120227, '3.30.900.10-FF-000039', NULL, 'Spindle assembly checkpoint component MAD2', 211, NULL, NULL, 120227),
(120228, '3.90.180.10-FF-000127', NULL, 'Alcohol dehydrogenase-like 6', 122, NULL, NULL, 120228);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(120229, '2.130.10.10-FF-001239', NULL, 'Transducin family protein / WD-40 repeat family protein', 179, NULL, NULL, 120229),
(120230, '2.130.10.30-FF-000161', NULL, NULL, 118, NULL, NULL, 120230),
(120231, '2.130.10.10-FF-001481', NULL, 'PRP4p Splicing factor', 192, NULL, NULL, 120231),
(120232, '2.130.10.10-FF-000975', NULL, 'Dynein, axonemal, intermediate chain 2a', 181, NULL, NULL, 120232),
(120233, '2.40.50.40-FF-000069', NULL, 'Chromatin remodeling factor CHD3 (PICKLE)', 91, NULL, NULL, 120233),
(120234, '3.40.50.2300-FF-000557', NULL, 'Glutamate receptor', 122, NULL, NULL, 120234),
(120235, '3.40.1800.20-FF-000026', NULL, 'LD47721p', 76, NULL, NULL, 120235),
(120236, '2.40.50.140-FF-000599', NULL, 'tRNA binding domain containing protein, putative', 166, NULL, NULL, 120236),
(120237, '4.10.280.10-FF-000008', NULL, 'Nuclear receptor coactivator', 90, NULL, NULL, 120237),
(120238, '1.10.246.90-FF-000021', NULL, 'U4/U6 small nuclear ribonucleoprotein Prp31', 45, NULL, NULL, 120238),
(120239, '1.20.1250.20-FF-000473', NULL, 'MFS transporter', 223, NULL, NULL, 120239),
(120240, '3.30.2310.20-FF-000002', NULL, 'mRNA interferase toxin RelE', 95, NULL, NULL, 120240),
(120241, '2.130.10.10-FF-003381', NULL, 'Sortilin', 121, NULL, NULL, 120241),
(120242, '2.60.40.10-FF-003841', NULL, NULL, 99, NULL, NULL, 120242),
(120243, '3.60.40.10-FF-000028', NULL, 'Protein phosphatase 1H', 352, NULL, NULL, 120243),
(120244, '1.10.510.10-FF-001808', NULL, 'Uncharacterized protein', 319, NULL, NULL, 120244),
(120245, '3.40.50.300-FF-005567', NULL, 'Uncharacterized protein', 193, NULL, NULL, 120245),
(120246, '2.10.50.10-FF-000084', NULL, 'Tumor necrosis factor receptor superfamily member 18', 75, NULL, NULL, 120246),
(120247, '2.30.29.30-FF-000326', NULL, 'TBC1 domain family member 2B', 108, NULL, NULL, 120247),
(120248, '1.10.8.1120-FF-000003', NULL, 'Histone RNA hairpin-binding protein, putative', 75, NULL, NULL, 120248),
(120249, '3.40.50.11890-FF-000004', NULL, '(R)-2-hydroxyacyl-CoA dehydratase', 126, NULL, NULL, 120249),
(120250, '3.30.505.10-FF-000031', NULL, 'Tyrosine-protein kinase', 115, NULL, NULL, 120250),
(120251, '1.20.5.400-FF-000005', NULL, 'Centrosomal protein 164', 48, NULL, NULL, 120251),
(120252, '2.30.30.100-FF-000237', NULL, 'Enhancer of mRNA-decapping protein 3', 94, NULL, NULL, 120252),
(120253, '3.30.70.330-FF-002749', NULL, NULL, 176, NULL, NULL, 120253),
(120254, '3.40.50.1010-FF-000030', NULL, 'flap endonuclease GEN-like 2', 198, NULL, NULL, 120254),
(120255, '1.25.40.1030-FF-000002', NULL, 'Protein transport protein sec16', 397, NULL, NULL, 120255),
(120256, '3.30.70.100-FF-000202', NULL, NULL, 80, NULL, NULL, 120256),
(120257, '2.10.25.10-FF-000716', NULL, 'Crumbs, isoform D', 41, NULL, NULL, 120257),
(120258, '3.80.10.10-FF-003589', NULL, 'Predicted protein', 133, NULL, NULL, 120258),
(120259, '3.40.50.10190-FF-000045', NULL, 'DNA ligase', 77, NULL, NULL, 120259),
(120260, '1.25.10.10-FF-001961', NULL, 'SYmmetrical Sister cell hermaphrodite gonad defect', 551, NULL, NULL, 120260),
(120261, '3.30.70.330-FF-000951', NULL, 'nucleolysin TIA-1 isoform X7', 92, NULL, NULL, 120261),
(120262, '1.10.1520.10-FF-000066', NULL, 'Mitochondrial ribosomal protein L44', 151, NULL, NULL, 120262),
(120263, '1.20.1270.60-FF-000334', NULL, 'Rho GTPase-activating protein 44', 183, NULL, NULL, 120263),
(120264, '2.70.150.10-FF-000297', NULL, 'Uncharacterized protein', 111, NULL, NULL, 120264),
(120265, '3.40.50.150-FF-001138', NULL, NULL, 122, NULL, NULL, 120265),
(120266, '1.20.1270.60-FF-000244', NULL, 'Rho-GTPase-activating protein 8', 206, NULL, NULL, 120266),
(120267, '3.40.50.1820-FF-000093', NULL, 'protein ABHD14A isoform X1', 198, NULL, NULL, 120267),
(120268, '3.30.450.20-FF-000086', NULL, 'PAS domain-containing sensor histidine kinase', 123, NULL, NULL, 120268),
(120269, '2.130.10.10-FF-003038', NULL, 'Uncharacterized WD repeat-containing protein slr1410', 151, NULL, NULL, 120269),
(120270, '3.30.160.60-FF-001374', NULL, 'zinc finger and BTB domain-containing protein 39', 27, NULL, NULL, 120270);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(120271, '3.30.70.330-FF-002839', NULL, NULL, 85, NULL, NULL, 120271),
(120272, '1.20.1250.10-FF-000127', NULL, NULL, 118, NULL, NULL, 120272),
(120273, '3.30.450.20-FF-000176', NULL, 'Serine/threonine phosphatase containing a PAS domain', 123, NULL, NULL, 120273),
(120274, '3.30.450.30-FF-000089', NULL, 'Uncharacterized protein', 63, NULL, NULL, 120274),
(120275, '3.20.20.80-FF-000460', NULL, 'Putative metal-nicotianamine transporter YSL6', 76, NULL, NULL, 120275),
(120276, '1.25.40.10-FF-003071', NULL, 'Uncharacterized protein', 197, NULL, NULL, 120276),
(120277, '2.60.120.200-FF-000676', NULL, 'Predicted protein', 47, NULL, NULL, 120277),
(120278, '1.25.40.10-FF-000665', NULL, 'Pre-mRNA-processing factor 6', 158, NULL, NULL, 120278),
(120279, '3.90.190.10-FF-000055', NULL, 'mRNA capping enzyme family protein', 215, NULL, NULL, 120279),
(120280, '3.90.190.10-FF-000510', NULL, 'Uncharacterized protein', 140, NULL, NULL, 120280),
(120281, '3.40.50.10190-FF-000146', NULL, 'BRCT domain protein (Eurofung)', 118, NULL, NULL, 120281),
(120282, '3.30.200.20-FF-000377', NULL, 'Serine threonine protein kinase', 114, NULL, NULL, 120282),
(120283, '3.40.50.620-FF-000666', NULL, 'Uncharacterized protein', 106, NULL, NULL, 120283),
(120284, '1.10.10.60-FF-001228', NULL, NULL, 45, NULL, NULL, 120284),
(120285, '3.30.930.10-FF-000221', NULL, 'Biotin--acetyl-CoA-carboxylase ligase, putative', 198, NULL, NULL, 120285),
(120286, '1.20.1250.20-FF-000372', NULL, 'Monocarboxylate transporter', 211, NULL, NULL, 120286),
(120287, '2.40.270.10-FF-000020', NULL, 'DNA-directed RNA polymerase subunit 2', 216, NULL, NULL, 120287),
(120288, '3.50.50.60-FF-000617', NULL, 'Prenylcysteine oxidase', 301, NULL, NULL, 120288),
(120289, '3.30.70.360-FF-000038', NULL, 'Dipeptidase, putative', 94, NULL, NULL, 120289),
(120290, '3.30.70.330-FF-000378', NULL, 'Cleavage stimulating factor 64', 117, NULL, NULL, 120290),
(120291, '2.10.109.10-FF-000029', NULL, 'Signal peptidase I', 137, NULL, NULL, 120291),
(120292, '3.10.129.10-FF-000274', NULL, 'Acyl-[acyl-carrier-protein] hydrolase', 95, NULL, NULL, 120292),
(120293, '1.10.510.10-FF-003080', NULL, NULL, 201, NULL, NULL, 120293),
(120294, '3.30.365.10-FF-000042', NULL, 'Glyceraldehyde dehydrogenase large chain', 109, NULL, NULL, 120294),
(120295, '1.10.10.10-FF-000966', NULL, 'Transcriptional regulator, LysR family', 90, NULL, NULL, 120295),
(120296, '3.40.50.10490-FF-000163', NULL, NULL, 160, NULL, NULL, 120296),
(120297, '2.60.120.260-FF-000587', NULL, 'Reelin', 157, NULL, NULL, 120297),
(120298, '3.30.40.10-FF-001131', NULL, 'Uncharacterized protein', 79, NULL, NULL, 120298),
(120299, '3.30.2440.10-FF-000003', NULL, 'SPI-2 type III secretion system effector SifA', 115, NULL, NULL, 120299),
(120300, '3.55.30.10-FF-000001', NULL, '33 kDa chaperonin', 176, NULL, NULL, 120300),
(120301, '1.20.990.10-FF-000004', NULL, 'Sulfite reductase [NADPH] flavoprotein alpha-component', 105, NULL, NULL, 120301),
(120302, '3.20.20.190-FF-000070', NULL, 'Phosphoinositide phospholipase C', 189, NULL, NULL, 120302),
(120303, '1.25.10.10-FF-001079', NULL, 'Serine/threonine-protein kinase TOR', 194, NULL, NULL, 120303),
(120304, '1.10.287.70-FF-000334', NULL, 'Uncharacterized protein', 158, NULL, NULL, 120304),
(120305, '4.10.240.10-FF-000152', NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', 71, NULL, NULL, 120305),
(120306, '2.60.40.10-FF-001470', NULL, 'Advanced glycosylation end product-specific receptor', 90, NULL, NULL, 120306),
(120307, '3.40.50.300-FF-001318', NULL, 'DNA repair protein RAD51', 267, NULL, NULL, 120307),
(120308, '1.10.101.10-FF-000032', NULL, 'ErfK/YbiS/YcfS/YnhG family protein', 71, NULL, NULL, 120308),
(120309, '1.25.40.20-FF-000201', NULL, 'NF-kappa-B inhibitor beta', 220, NULL, NULL, 120309),
(120310, '3.60.15.10-FF-000077', NULL, 'Ribonuclease J', 283, NULL, NULL, 120310),
(120311, '3.30.160.60-FF-000401', NULL, 'Zinc finger and AT-hook domain containing', 79, NULL, NULL, 120311),
(120312, '2.30.30.830-FF-000001', NULL, 'Type 4 fimbrial biogenesis protein PilP', 93, NULL, NULL, 120312);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(120313, '2.30.40.10-FF-000122', NULL, 'Prolidase (Xaa-Pro dipeptidase) (PepQ-like1)', 87, NULL, NULL, 120313),
(120314, '3.30.390.130-FF-000001', NULL, 'Probable E3 ubiquitin-protein ligase DTX3', 137, NULL, NULL, 120314),
(120315, '3.10.200.10-FF-000007', NULL, 'Alpha carbonic anhydrase 3', 239, NULL, NULL, 120315),
(120316, '3.10.129.110-FF-000019', NULL, 'Polyketide synthase', 293, NULL, NULL, 120316),
(120317, '1.10.287.130-FF-000178', NULL, 'Sensory transduction histidine kinase', 81, NULL, NULL, 120317),
(120318, '2.60.40.10-FF-003268', NULL, 'Cytokine receptor', 101, NULL, NULL, 120318),
(120319, '3.40.50.300-FF-003218', NULL, 'ABC a-pheromone efflux pump AtrD', 242, NULL, NULL, 120319),
(120320, '3.40.50.2300-FF-001271', NULL, NULL, 185, NULL, NULL, 120320),
(120321, '3.30.390.150-FF-000007', NULL, 'Tenomodulin', 98, NULL, NULL, 120321),
(120322, '3.40.190.10-FF-000976', NULL, 'Maltose ABC transporter, maltose binding protein', 146, NULL, NULL, 120322),
(120323, '3.40.367.20-FF-000053', NULL, 'Phosphotransferase', 58, NULL, NULL, 120323),
(120324, '3.30.200.20-FF-000938', NULL, 'Uncharacterized protein', 101, NULL, NULL, 120324),
(120325, '1.25.40.20-FF-001483', NULL, 'Uncharacterized protein', 94, NULL, NULL, 120325),
(120326, '2.40.37.10-FF-000029', NULL, 'Arginine decarboxylase', 186, NULL, NULL, 120326),
(120327, '3.10.20.770-FF-000021', NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', 156, NULL, NULL, 120327),
(120328, '3.30.420.610-FF-000002', NULL, 'Meiosis regulator and mRNA stability factor 1', 75, NULL, NULL, 120328),
(120329, '3.40.190.10-FF-000667', NULL, 'Uncharacterized protein', 101, NULL, NULL, 120329),
(120330, '1.10.1240.10-FF-000005', NULL, 'Methionine synthase', 32, NULL, NULL, 120330),
(120331, '1.20.1560.10-FF-000437', NULL, 'Protein CBR-PGP-7', 185, NULL, NULL, 120331),
(120332, '2.10.10.10-FF-000019', NULL, 'Uncharacterized protein', 52, NULL, NULL, 120332),
(120333, '3.80.10.10-FF-002616', NULL, 'Leucine-rich repeat serine/threonine-protein kinase 1', 219, NULL, NULL, 120333),
(120334, '2.10.25.10-FF-001689', NULL, 'Uncharacterized protein', 43, NULL, NULL, 120334),
(120335, '2.60.470.10-FF-000008', NULL, 'Pickpocket 26', 179, NULL, NULL, 120335),
(120336, '3.40.30.10-FF-000236', NULL, 'Chloride intracellular channel 1', 66, NULL, NULL, 120336),
(120337, '3.40.50.1820-FF-001020', NULL, 'protein ABHD14B', 200, NULL, NULL, 120337),
(120338, '3.40.50.410-FF-000025', NULL, 'Vitrin', 201, NULL, NULL, 120338),
(120339, '2.170.120.30-FF-000001', NULL, 'YbbR-like protein', 90, NULL, NULL, 120339),
(120340, '1.25.40.10-FF-001480', NULL, 'Pentatricopeptide repeat-containing protein', 88, NULL, NULL, 120340),
(120341, '1.25.40.10-FF-002874', NULL, 'YALI0F27753p', 262, NULL, NULL, 120341),
(120342, '2.60.40.10-FF-005522', NULL, NULL, 65, NULL, NULL, 120342),
(120343, '3.30.470.20-FF-000194', NULL, 'Synapsin III', 49, NULL, NULL, 120343),
(120344, '1.50.10.10-FF-000161', NULL, 'Family 48 cellulase', 312, NULL, NULL, 120344),
(120345, '3.40.50.10140-FF-000047', NULL, 'Uncharacterized protein', 109, NULL, NULL, 120345),
(120346, '1.20.1560.10-FF-000128', NULL, 'ABC transporter B family member 21', 602, NULL, NULL, 120346),
(120347, '3.40.50.150-FF-001447', NULL, NULL, 141, NULL, NULL, 120347),
(120348, '1.20.58.60-FF-000192', NULL, 'coiled-coil domain-containing protein 141 isoform X2', 277, NULL, NULL, 120348),
(120349, '2.10.90.10-FF-000114', NULL, 'Uncharacterized protein', 109, NULL, NULL, 120349),
(120350, '3.40.50.720-FF-000707', NULL, 'Trk system potassium uptake protein TrkA', 133, NULL, NULL, 120350),
(120351, '3.40.50.300-FF-007731', NULL, 'Uncharacterized protein', 87, NULL, NULL, 120351),
(120352, '3.40.250.10-FF-000037', NULL, 'Dual-specificity phosphatase CDC25', 131, NULL, NULL, 120352),
(120353, '3.40.50.10130-FF-000044', NULL, 'Predicted protein', 112, NULL, NULL, 120353),
(120354, '3.30.870.10-FF-000188', NULL, 'Predicted protein', 112, NULL, NULL, 120354),
(120355, '3.40.1670.10-FF-000006', NULL, '3-octaprenyl-4-hydroxybenzoate carboxy-lyase', 109, NULL, NULL, 120355);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(120356, '4.10.1000.10-FF-000159', NULL, 'Uncharacterized protein', 64, NULL, NULL, 120356),
(120357, '1.25.40.20-FF-001792', NULL, 'Uncharacterized protein', 173, NULL, NULL, 120357),
(120358, '2.130.10.30-FF-000059', NULL, 'Alpha tubulin suppressor', 227, NULL, NULL, 120358),
(120359, '3.40.50.2300-FF-000809', NULL, NULL, 128, NULL, NULL, 120359),
(120360, '3.30.160.60-FF-003526', NULL, 'Chromosome undetermined SCAF9247, whole genome shotgun sequence', 66, NULL, NULL, 120360),
(120361, '2.170.120.40-FF-000004', NULL, 'CdaA regulatory protein CdaR', 89, NULL, NULL, 120361),
(120362, '1.20.1270.10-FF-000027', NULL, 'Heat shock protein 70', 84, NULL, NULL, 120362),
(120363, '3.40.50.150-FF-001801', NULL, NULL, 133, NULL, NULL, 120363),
(120364, '1.25.10.10-FF-003333', NULL, 'AEL006Wp', 270, NULL, NULL, 120364),
(120365, '3.40.630.30-FF-000224', NULL, 'N-acetyltransferase Eis', 156, NULL, NULL, 120365),
(120366, '3.80.10.10-FF-000245', NULL, 'Leucine rich repeat containing 55', 100, NULL, NULL, 120366),
(120367, '3.40.20.10-FF-000101', NULL, 'Actin-depolymerizing factor 2, isoform c', 152, NULL, NULL, 120367),
(120368, '2.30.42.10-FF-000059', NULL, 'unconventional myosin-XVIIIa isoform X1', 100, NULL, NULL, 120368),
(120369, '1.25.40.1040-FF-000005', NULL, 'Cleavage stimulation factor subunit 77', 508, NULL, NULL, 120369),
(120370, '3.30.200.20-FF-001091', NULL, 'Dual specificity mitogen-activated protein kinase kinase 4', 63, NULL, NULL, 120370),
(120371, '3.40.50.300-FF-007512', NULL, 'Uncharacterized protein', 215, NULL, NULL, 120371),
(120372, '3.40.50.10330-FF-000014', NULL, 'NAD kinase a', 170, NULL, NULL, 120372),
(120373, '1.25.10.10-FF-003243', NULL, 'Protein CELLULOSE SYNTHASE INTERACTIVE 3', 235, NULL, NULL, 120373),
(120374, '2.60.220.50-FF-000092', NULL, 'Adhesion G protein-coupled receptor L1', 206, NULL, NULL, 120374),
(120375, '1.20.5.110-FF-000351', NULL, 'Uncharacterized protein', 31, NULL, NULL, 120375),
(120376, '3.60.10.10-FF-000291', NULL, 'Uncharacterized protein', 444, NULL, NULL, 120376),
(120377, '1.25.40.470-FF-000045', NULL, 'Intraflagellar transport 140', 143, NULL, NULL, 120377),
(120378, '2.130.10.10-FF-002875', NULL, 'NACHT and WD40 domain protein', 105, NULL, NULL, 120378),
(120379, '2.40.50.140-FF-001010', NULL, NULL, 87, NULL, NULL, 120379),
(120380, '1.20.58.60-FF-000444', NULL, 'AGAP009554-PA', 313, NULL, NULL, 120380),
(120381, '1.10.10.60-FF-000964', NULL, NULL, 54, NULL, NULL, 120381),
(120382, '1.25.10.10-FF-001181', NULL, 'Epoxyqueuosine reductase', 125, NULL, NULL, 120382),
(120383, '3.40.850.10-FF-000358', NULL, 'Uncharacterized protein', 350, NULL, NULL, 120383),
(120384, '1.10.510.10-FF-001247', NULL, 'Myosin Light Chain Kinase related', 217, NULL, NULL, 120384),
(120385, '1.10.287.130-FF-000223', NULL, 'GAF domain-containing protein', 83, NULL, NULL, 120385),
(120386, '3.30.70.560-FF-000008', NULL, '2-amino-4-hydroxy-6-hydroxymethyldihydropteridine pyrophosphokinase', 159, NULL, NULL, 120386),
(120387, '2.40.50.140-FF-000392', NULL, 'RecQ mediated genome instability 2', 64, NULL, NULL, 120387),
(120388, '3.30.160.60-FF-005735', NULL, NULL, 67, NULL, NULL, 120388),
(120389, '3.30.160.60-FF-003274', NULL, 'Zinc finger protein 408', 28, NULL, NULL, 120389),
(120390, '3.30.420.10-FF-000345', NULL, NULL, 164, NULL, NULL, 120390),
(120391, '1.25.40.660-FF-000012', NULL, 'Vacuolar protein sorting-associated protein 35', 343, NULL, NULL, 120391),
(120392, '3.40.50.300-FF-005360', NULL, 'Uncharacterized protein', 281, NULL, NULL, 120392),
(120393, '1.10.132.30-FF-000019', NULL, 'DNA-directed RNA polymerase IV subunit 1', 84, NULL, NULL, 120393),
(120394, '3.80.10.10-FF-002706', NULL, 'Receptor-like protein kinase HSL1', 184, NULL, NULL, 120394),
(120395, '3.30.70.330-FF-000849', NULL, 'Os03g0374575 protein', 121, NULL, NULL, 120395),
(120396, '2.60.40.10-FF-005213', NULL, NULL, 91, NULL, NULL, 120396),
(120397, '3.30.342.10-FF-000017', NULL, 'DNA polymerase epsilon catalytic subunit', 173, NULL, NULL, 120397),
(120398, '1.10.565.10-FF-000215', NULL, 'Uncharacterized protein', 115, NULL, NULL, 120398);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(120399, '1.20.920.10-FF-000056', NULL, 'Bromodomain protein 1', 141, NULL, NULL, 120399),
(120400, '1.10.238.10-FF-001237', NULL, 'Uncharacterized protein', 98, NULL, NULL, 120400),
(120401, '3.90.25.10-FF-000071', NULL, 'dTDP-4-dehydrorhamnose reductase', 71, NULL, NULL, 120401),
(120402, '3.40.50.1760-FF-000018', NULL, NULL, 48, NULL, NULL, 120402),
(120403, '2.10.10.100-FF-000007', NULL, NULL, 87, NULL, NULL, 120403),
(120404, '1.20.1070.10-FF-000725', NULL, '5-hydroxytryptamine (Serotonin) receptor 2B, isoform D', 159, NULL, NULL, 120404),
(120405, '1.20.58.1020-FF-000010', NULL, 'DNA replication complex GINS protein PSF2', 106, NULL, NULL, 120405),
(120406, '2.120.10.80-FF-000367', NULL, 'Multiple EGF like domains 8', 242, NULL, NULL, 120406),
(120407, '3.40.50.10320-FF-000011', NULL, 'N-acetylglucosaminylphosphatidylinositol deacetylase', 258, NULL, NULL, 120407),
(120408, '3.30.160.60-FF-006399', NULL, NULL, 31, NULL, NULL, 120408),
(120409, '3.40.50.12780-FF-000108', NULL, 'NonRibosomal Peptide Synthetase', 352, NULL, NULL, 120409),
(120410, '2.60.120.10-FF-000022', NULL, 'Patatin like phospholipase domain containing 7', 132, NULL, NULL, 120410),
(120411, '3.30.160.60-FF-005426', NULL, NULL, 36, NULL, NULL, 120411),
(120412, '1.25.40.10-FF-004717', NULL, 'Tetratricopeptide repeat protein 1', 90, NULL, NULL, 120412),
(120413, '1.10.8.10-FF-000077', NULL, 'Ubiquilin like', 60, NULL, NULL, 120413),
(120414, '1.20.5.1430-FF-000020', NULL, 'Microtubule plus-end binding protein', 84, NULL, NULL, 120414),
(120415, '1.20.1270.330-FF-000001', NULL, 'EscN/YscN/HrcN family type III secretion system ATPase', 75, NULL, NULL, 120415),
(120416, '2.130.10.10-FF-001902', NULL, 'AGAP008620-PA', 192, NULL, NULL, 120416),
(120417, '3.40.50.1000-FF-000757', NULL, NULL, 143, NULL, NULL, 120417),
(120418, '1.50.40.10-FF-000101', NULL, 'SLC (SoLute Carrier) homolog', 294, NULL, NULL, 120418),
(120419, '3.40.140.70-FF-000013', NULL, 'Ubiquitin-like modifier-activating enzyme atg7', 159, NULL, NULL, 120419),
(120420, '3.30.420.10-FF-000036', NULL, 'DNA polymerase', 232, NULL, NULL, 120420),
(120421, '1.20.920.20-FF-000059', NULL, 'Uncharacterized protein', 138, NULL, NULL, 120421),
(120422, '3.40.1450.10-FF-000007', NULL, 'Uncharacterized protein', 151, NULL, NULL, 120422),
(120423, '3.40.630.30-FF-000325', NULL, 'Putative acetyltransferase', 195, NULL, NULL, 120423),
(120424, '3.30.70.330-FF-000934', NULL, 'Polyadenylate-binding protein, putative', 86, NULL, NULL, 120424),
(120425, '2.170.130.10-FF-000081', NULL, NULL, 138, NULL, NULL, 120425),
(120426, '1.20.1270.60-FF-000025', NULL, 'arf-GAP with coiled-coil, ANK repeat and PH domain-containing protein 2', 252, NULL, NULL, 120426),
(120427, '3.40.50.450-FF-000020', NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase', 180, NULL, NULL, 120427),
(120428, '3.90.640.10-FF-000281', NULL, 'Predicted protein', 26, NULL, NULL, 120428),
(120429, '3.30.559.10-FF-000094', NULL, 'Mitochondrial carnitine O-acetyltransferase, putative', 142, NULL, NULL, 120429),
(120430, '3.40.50.10090-FF-000015', NULL, 'Uroporphyrinogen III synthase', 90, NULL, NULL, 120430),
(120431, '1.20.1720.10-FF-000118', NULL, 'Bcr/CflA family efflux transporter', 376, NULL, NULL, 120431),
(120432, '1.25.40.1040-FF-000022', NULL, 'Uncharacterized protein', 537, NULL, NULL, 120432),
(120433, '1.20.1270.10-FF-000117', NULL, 'DnaK protein', 81, NULL, NULL, 120433),
(120434, '3.40.50.460-FF-000023', NULL, 'Phosphofructokinase family protein', 115, NULL, NULL, 120434),
(120435, '1.10.10.10-FF-001781', NULL, 'Predicted protein', 123, NULL, NULL, 120435),
(120436, '3.40.20.10-FF-000056', NULL, 'Quail, isoform C', 83, NULL, NULL, 120436),
(120437, '1.20.1250.20-FF-000602', NULL, 'MFS family transporter', 429, NULL, NULL, 120437),
(120438, '3.30.1950.10-FF-000002', NULL, 'Periplasmic polysaccharide biosynthesis/export protein', 67, NULL, NULL, 120438),
(120439, '2.20.100.10-FF-000119', NULL, 'Circumsporozoite-and TRAP-related protein', 49, NULL, NULL, 120439),
(120440, '2.60.120.920-FF-000021', NULL, 'Si:dkey-16p6.1', 180, NULL, NULL, 120440);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(120441, '3.40.50.300-FF-001526', NULL, 'GPN-loop GTPase 2', 258, NULL, NULL, 120441),
(120442, '1.10.287.70-FF-000216', NULL, 'Polycystic kidney disease 1b', 124, NULL, NULL, 120442),
(120443, '1.10.287.70-FF-000098', NULL, 'Potassium two pore domain channel subfamily K member 16', 254, NULL, NULL, 120443),
(120444, '3.30.420.10-FF-000362', NULL, NULL, 184, NULL, NULL, 120444),
(120445, '3.90.360.10-FF-000017', NULL, 'Uncharacterized protein', 122, NULL, NULL, 120445),
(120446, '1.10.630.10-FF-000710', NULL, 'Uncharacterized protein', 118, NULL, NULL, 120446),
(120447, '1.10.510.10-FF-001056', NULL, 'STE/STE20/MST protein kinase', 291, NULL, NULL, 120447),
(120448, '1.10.10.10-FF-001253', NULL, 'Crp/Fnr family transcriptional regulator', 69, NULL, NULL, 120448),
(120449, '3.20.20.30-FF-000035', NULL, 'Natural product biosynthesis luciferase-like monooxygenase domain-containing protein', 351, NULL, NULL, 120449),
(120450, '1.10.560.10-FF-000002', NULL, '60 kDa chaperonin', 242, NULL, NULL, 120450),
(120451, '3.30.450.20-FF-000406', NULL, 'C4-dicarboxylate transport sensor protein dctB', 112, NULL, NULL, 120451),
(120452, '3.90.190.10-FF-000280', NULL, 'Protein-tyrosine phosphatase-like protein', 179, NULL, NULL, 120452),
(120453, '3.30.420.40-FF-000899', NULL, 'DnaK protein', 84, NULL, NULL, 120453),
(120454, '1.20.58.60-FF-000219', NULL, 'Uncharacterized protein, isoform J', 264, NULL, NULL, 120454),
(120455, '3.30.70.330-FF-000395', NULL, 'Polyadenylate-binding protein RBP47', 119, NULL, NULL, 120455),
(120456, '1.10.10.2670-FF-000001', NULL, 'E3 ubiquitin-protein ligase UBR2 isoform X1', 96, NULL, NULL, 120456),
(120457, '3.20.20.140-FF-000425', NULL, 'Allantoinase', 44, NULL, NULL, 120457),
(120458, '2.130.10.10-FF-001711', NULL, 'Transducin beta-like protein 3', 137, NULL, NULL, 120458),
(120459, '3.40.190.10-FF-000875', NULL, 'Predicted protein', 44, NULL, NULL, 120459),
(120460, '3.40.50.620-FF-000902', NULL, 'Os01g0691500 protein', 67, NULL, NULL, 120460),
(120461, '1.20.920.20-FF-000076', NULL, 'Uncharacterized protein', 59, NULL, NULL, 120461),
(120462, '1.20.920.10-FF-000073', NULL, 'Chromatin structure-remodeling complex subunit rsc4', 132, NULL, NULL, 120462),
(120463, '1.10.2000.10-FF-000050', NULL, NULL, 122, NULL, NULL, 120463),
(120464, '3.40.50.300-FF-007361', NULL, 'Transcription factor, putative', 159, NULL, NULL, 120464),
(120465, '3.40.1490.10-FF-000009', NULL, 'Uncharacterized protein', 65, NULL, NULL, 120465),
(120466, '3.20.20.20-FF-000032', NULL, '4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase (flavodoxin)', 270, NULL, NULL, 120466),
(120467, '1.25.10.10-FF-001416', NULL, 'Proteasome-associated protein ECM29 homolog', 373, NULL, NULL, 120467),
(120468, '1.20.1310.20-FF-000051', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 205, NULL, NULL, 120468),
(120469, '1.10.287.3240-FF-000022', NULL, 'V-type proton ATPase subunit D', 214, NULL, NULL, 120469),
(120470, '3.40.50.12780-FF-000182', NULL, 'Uncharacterized protein', 173, NULL, NULL, 120470),
(120471, '3.40.50.300-FF-006888', NULL, 'Sulfotransferase', 326, NULL, NULL, 120471),
(120472, '1.10.287.70-FF-000109', NULL, 'Voltage-gated potassium channel', 216, NULL, NULL, 120472),
(120473, '2.130.10.10-FF-004893', NULL, 'Uncharacterized protein', 116, NULL, NULL, 120473),
(120474, '2.60.120.290-FF-000236', NULL, 'Metalloendopeptidase', 73, NULL, NULL, 120474),
(120475, '3.40.30.10-FF-000028', NULL, 'Glutaredoxin family protein', 101, NULL, NULL, 120475),
(120476, '1.10.8.60-FF-000171', NULL, 'Lon protease', 103, NULL, NULL, 120476),
(120477, '3.30.70.1180-FF-000015', NULL, 'V-type proton ATPase subunit C', 70, NULL, NULL, 120477),
(120478, '1.10.8.10-FF-000307', NULL, 'Doublesex- and mab-3-related transcription factor A2', 66, NULL, NULL, 120478),
(120479, '3.80.10.10-FF-000155', NULL, 'Putative inactive leucine-rich repeat receptor-like protein kinase', 223, NULL, NULL, 120479),
(120480, '3.90.950.10-FF-000046', NULL, 'Uncharacterized protein', 161, NULL, NULL, 120480),
(120481, '3.40.50.1220-FF-000019', NULL, 'NAD-dependent protein deacetylase sirtuin-1', 148, NULL, NULL, 120481);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(120482, '2.70.100.10-FF-000001', NULL, 'Glucanase', 438, NULL, NULL, 120482),
(120483, '3.90.190.10-FF-000173', NULL, 'Dual specificity protein phosphatase putative', 197, NULL, NULL, 120483),
(120484, '3.40.50.10490-FF-000045', NULL, '30S ribosomal protein S2', 207, NULL, NULL, 120484),
(120485, '2.60.40.4230-FF-000002', NULL, 'Resistin-like alpha', 63, NULL, NULL, 120485),
(120486, '3.40.630.10-FF-000376', NULL, 'Uncharacterized protein', 102, NULL, NULL, 120486),
(120487, '1.10.510.10-FF-003287', NULL, NULL, 96, NULL, NULL, 120487),
(120488, '3.30.200.20-FF-001203', NULL, 'Leucine-rich repeat protein kinase family protein', 123, NULL, NULL, 120488),
(120489, '3.40.50.20-FF-000038', NULL, 'Biotin carboxylase subunit of acetyl CoA carboxylase', 183, NULL, NULL, 120489),
(120490, '3.30.450.20-FF-000513', NULL, 'Transcription activator of gluconeogenesis ERT1', 108, NULL, NULL, 120490),
(120491, '3.50.50.60-FF-000926', NULL, '3-hydroxybenzoate 4-monooxygenase', 246, NULL, NULL, 120491),
(120492, '3.40.430.10-FF-000012', NULL, 'Riboflavin biosynthesis protein RibD', 220, NULL, NULL, 120492),
(120493, '3.30.40.10-FF-000524', NULL, 'Uncharacterized protein, isoform C', 61, NULL, NULL, 120493),
(120494, '3.30.460.10-FF-000005', NULL, 'terminal uridylyltransferase 4 isoform X1', 120, NULL, NULL, 120494),
(120495, '3.40.50.1820-FF-000323', NULL, 'Homoserine O-acetyltransferase', 367, NULL, NULL, 120495),
(120496, '3.80.10.10-FF-000481', NULL, 'F-box/LRR-repeat protein 2', 86, NULL, NULL, 120496),
(120497, '1.20.1560.10-FF-000027', NULL, 'ATP-binding cassette subfamily C member 4', 329, NULL, NULL, 120497),
(120498, '1.20.58.60-FF-000854', NULL, 'Spectrin beta chain, non-erythrocytic 5-like Protein', 136, NULL, NULL, 120498),
(120499, '3.40.1110.10-FF-000105', NULL, 'Calcium-translocating P-type ATPase, PMCA-type', 207, NULL, NULL, 120499),
(120500, '3.40.50.150-FF-001548', NULL, NULL, 87, NULL, NULL, 120500),
(120501, '3.60.40.10-FF-000146', NULL, 'Protein phosphatase 2C', 275, NULL, NULL, 120501),
(120502, '3.30.420.10-FF-000255', NULL, 'Reverse transcriptase, RNaseH, putative', 162, NULL, NULL, 120502),
(120503, '1.10.3370.10-FF-000026', NULL, 'Uncharacterized protein', 137, NULL, NULL, 120503),
(120504, '3.30.200.20-FF-001310', NULL, NULL, 88, NULL, NULL, 120504),
(120505, '2.60.40.10-FF-003622', NULL, 'Hemocyte protein-glutamine gamma-glutamyltransferase-like Protein', 161, NULL, NULL, 120505),
(120506, '3.40.1110.10-FF-000212', NULL, 'Calcium-transporting ATPase', 162, NULL, NULL, 120506),
(120507, '2.40.50.140-FF-000583', NULL, 'Holliday junction ATP-dependent DNA helicase RuvA', 66, NULL, NULL, 120507),
(120508, '1.10.1200.10-FF-000031', NULL, 'Acyl carrier protein', 100, NULL, NULL, 120508),
(120509, '3.30.200.20-FF-002294', NULL, 'Spore coat protein I', 113, NULL, NULL, 120509),
(120510, '3.30.450.40-FF-000199', NULL, 'Stage II sporulation E family protein', 170, NULL, NULL, 120510),
(120511, '1.20.58.860-FF-000019', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 89, NULL, NULL, 120511),
(120512, '3.30.160.60-FF-003408', NULL, 'H0806H05.6 protein', 51, NULL, NULL, 120512),
(120513, '2.40.20.10-FF-000013', NULL, 'Plasminogen', 164, NULL, NULL, 120513),
(120514, '3.40.190.80-FF-000053', NULL, 'Fructose-1,6-bisphosphatase', 47, NULL, NULL, 120514),
(120515, '3.30.230.10-FF-000292', NULL, 'Uncharacterized protein', 138, NULL, NULL, 120515),
(120516, '1.10.10.10-FF-001146', NULL, 'Cyclic AMP receptor protein', 78, NULL, NULL, 120516),
(120517, '1.50.10.20-FF-000074', NULL, 'F3F9.1', 85, NULL, NULL, 120517),
(120518, '2.60.40.10-FF-001054', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', 91, NULL, NULL, 120518),
(120519, '3.90.1530.10-FF-000002', NULL, 'Putative transcriptional regulator', 70, NULL, NULL, 120519),
(120520, '1.20.1560.10-FF-000881', NULL, 'ABC multidrug transporter, putative', 279, NULL, NULL, 120520),
(120521, '1.10.510.10-FF-001163', NULL, 'Serine/threonine protein kinase', 173, NULL, NULL, 120521),
(120522, '3.60.40.10-FF-000253', NULL, 'Serine phosphatase, SpoIIE domain-containing', 216, NULL, NULL, 120522);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(120523, '3.30.160.60-FF-005179', NULL, NULL, 56, NULL, NULL, 120523),
(120524, '3.40.50.720-FF-000146', NULL, 'Ketol-acid reductoisomerase', 228, NULL, NULL, 120524),
(120525, '3.30.200.20-FF-000686', NULL, 'Ribosomal protein S6 kinase', 105, NULL, NULL, 120525),
(120526, '1.10.1530.10-FF-000005', NULL, 'L-malate dehydrogenase', 84, NULL, NULL, 120526),
(120527, '3.30.230.10-FF-000185', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 164, NULL, NULL, 120527),
(120528, '3.30.420.40-FF-000697', NULL, 'Carbohydrate kinase FGGY', 243, NULL, NULL, 120528),
(120529, '1.10.418.70-FF-000004', NULL, 'Intraflagellar transport protein 81', 126, NULL, NULL, 120529),
(120530, '1.25.40.210-FF-000001', NULL, 'Telomeric repeat-binding factor', 210, NULL, NULL, 120530),
(120531, '3.40.50.300-FF-000110', NULL, 'tight junction protein ZO-1 isoform X1', 176, NULL, NULL, 120531),
(120532, '1.50.10.10-FF-000071', NULL, 'Non-lysosomal glucosylceramidase', 292, NULL, NULL, 120532),
(120533, '2.10.25.10-FF-000155', NULL, 'Integrin beta', 49, NULL, NULL, 120533),
(120534, '1.25.10.10-FF-003350', NULL, 'Uncharacterized protein', 206, NULL, NULL, 120534),
(120535, '3.30.70.2460-FF-000006', NULL, NULL, 70, NULL, NULL, 120535),
(120536, '1.10.10.60-FF-000857', NULL, NULL, 49, NULL, NULL, 120536),
(120537, '3.60.10.10-FF-000318', NULL, 'Salivary nitrophorin', 282, NULL, NULL, 120537),
(120538, '1.10.10.1200-FF-000010', NULL, 'Melanoma antigen, family A, 4', 104, NULL, NULL, 120538),
(120539, '2.60.120.200-FF-000805', NULL, 'Uncharacterized protein', 93, NULL, NULL, 120539),
(120540, '3.80.10.10-FF-000262', NULL, 'F-box/LRR-repeat protein 16', 244, NULL, NULL, 120540),
(120541, '1.20.120.1320-FF-000012', NULL, NULL, 105, NULL, NULL, 120541),
(120542, '2.20.28.290-FF-000001', NULL, 'Leucine--tRNA ligase', 56, NULL, NULL, 120542),
(120543, '1.50.10.160-FF-000003', NULL, 'Aphidicolan-16-beta-ol synthase', 223, NULL, NULL, 120543),
(120544, '2.130.10.10-FF-003600', NULL, 'p21-activated protein kinase-interacting protein 1-like', 151, NULL, NULL, 120544),
(120545, '2.60.120.200-FF-000575', NULL, 'Predicted protein', 174, NULL, NULL, 120545),
(120546, '1.10.150.510-FF-000001', NULL, 'Receptor activity modifying protein 3', 93, NULL, NULL, 120546),
(120547, '2.130.10.10-FF-004584', NULL, 'Predicted protein', 208, NULL, NULL, 120547),
(120548, '2.60.40.10-FF-005106', NULL, NULL, 98, NULL, NULL, 120548),
(120549, '3.40.50.2020-FF-000130', NULL, 'Uncharacterized protein', 178, NULL, NULL, 120549),
(120550, '3.40.50.300-FF-006995', NULL, 'Sulfotransferase', 307, NULL, NULL, 120550),
(120551, '3.30.450.20-FF-000193', NULL, 'Transcriptional regulator, LuxR family', 122, NULL, NULL, 120551),
(120552, '3.90.70.10-FF-000023', NULL, 'Senescence-specific cysteine protease SAG39', 325, NULL, NULL, 120552),
(120553, '3.80.10.10-FF-004533', NULL, 'F-box domain containing protein, expressed', 193, NULL, NULL, 120553),
(120554, '1.20.58.830-FF-000010', NULL, 'Erythrocyte-binding antigen 175', 108, NULL, NULL, 120554),
(120555, '3.30.70.2450-FF-000003', NULL, 'p-nitrophenol monooxygenase', 86, NULL, NULL, 120555),
(120556, '1.20.910.10-FF-000005', NULL, 'Heme oxygenase 1', 204, NULL, NULL, 120556),
(120557, '2.130.10.10-FF-005724', NULL, 'Uncharacterized protein', 137, NULL, NULL, 120557),
(120558, '1.25.40.20-FF-001612', NULL, 'Predicted protein', 105, NULL, NULL, 120558),
(120559, '1.25.40.570-FF-000002', NULL, 'COP9 signalosome complex subunit 1', 366, NULL, NULL, 120559),
(120560, '2.30.30.140-FF-000215', NULL, 'Chromatin modification-related protein EAF3', 121, NULL, NULL, 120560),
(120561, '3.40.50.300-FF-001852', NULL, 'Peroxisomal biogenesis factor 1', 172, NULL, NULL, 120561),
(120562, '3.30.160.60-FF-003627', NULL, 'Zinc finger protein PAG-3', 43, NULL, NULL, 120562),
(120563, '2.40.128.260-FF-000001', NULL, 'Type IV secretion system protein', 180, NULL, NULL, 120563),
(120564, '3.40.250.10-FF-000240', NULL, 'Rhodanese homology domain pair protein', 152, NULL, NULL, 120564),
(120565, '2.10.60.10-FF-000040', NULL, 'Lymphocyte antigen 6 complex locus G6D', 95, NULL, NULL, 120565);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(120566, '2.170.16.10-FF-000014', NULL, 'DNA-directed RNA polymerase subunit beta', 154, NULL, NULL, 120566),
(120567, '1.25.10.10-FF-001096', NULL, 'Predicted protein', 301, NULL, NULL, 120567),
(120568, '1.20.58.60-FF-000528', NULL, 'Uncharacterized protein', 204, NULL, NULL, 120568),
(120569, '3.40.50.1460-FF-000035', NULL, 'Predicted protein', 238, NULL, NULL, 120569),
(120570, '2.10.70.10-FF-000214', NULL, 'Protein lev-9', 59, NULL, NULL, 120570),
(120571, '3.40.850.10-FF-000443', NULL, 'Os11g0581000 protein', 126, NULL, NULL, 120571),
(120572, '3.50.50.60-FF-000387', NULL, 'Probable monooxygenase', 222, NULL, NULL, 120572),
(120573, '2.40.128.270-FF-000004', NULL, 'Uncharacterized protein', 104, NULL, NULL, 120573),
(120574, '3.30.342.10-FF-000034', NULL, 'DNA polymerase 3', 140, NULL, NULL, 120574),
(120575, '3.40.50.1820-FF-000632', NULL, 'Protein CBR-LIPL-6', 373, NULL, NULL, 120575),
(120576, '1.20.990.10-FF-000021', NULL, 'NADPH-dependent diflavin oxidoreductase 1', 137, NULL, NULL, 120576),
(120577, '1.25.40.10-FF-004791', NULL, 'Pentatricopeptide repeat-containing protein At4g21170', 173, NULL, NULL, 120577),
(120578, '2.120.10.30-FF-000386', NULL, 'Uncharacterized protein', 342, NULL, NULL, 120578),
(120579, '3.30.1520.10-FF-000077', NULL, 'Phosphoinositide-binding protein, putative', 142, NULL, NULL, 120579),
(120580, '1.20.1250.20-FF-000911', NULL, 'Similar to MFS sugar transporter', 468, NULL, NULL, 120580),
(120581, '3.40.50.12710-FF-000003', NULL, 'Protein arginine methyltransferase NDUFAF7', 363, NULL, NULL, 120581),
(120582, '3.40.50.300-FF-005904', NULL, 'tRNA modification GTPase MnmE', 164, NULL, NULL, 120582),
(120583, '1.10.10.10-FF-001472', NULL, 'Forkhead domain protein 1', 105, NULL, NULL, 120583),
(120584, '2.40.50.140-FF-001116', NULL, NULL, 136, NULL, NULL, 120584),
(120585, '3.90.640.10-FF-000062', NULL, 'Lhs1p', 87, NULL, NULL, 120585),
(120586, '1.10.510.10-FF-000061', NULL, 'Putative cyclin-dependent kinase 17', 239, NULL, NULL, 120586),
(120587, '1.10.8.10-FF-000105', NULL, 'Protein NBR1 homolog', 47, NULL, NULL, 120587),
(120588, '3.30.160.60-FF-005651', NULL, NULL, 39, NULL, NULL, 120588),
(120589, '3.10.20.90-FF-000879', NULL, 'Uncharacterized protein', 62, NULL, NULL, 120589),
(120590, '2.60.220.50-FF-000176', NULL, 'Uncharacterized protein', 85, NULL, NULL, 120590),
(120591, '1.20.1050.10-FF-000269', NULL, 'Uncharacterized protein', 115, NULL, NULL, 120591),
(120592, '1.25.40.10-FF-003407', NULL, 'Pentatricopeptide repeat-containing protein', 124, NULL, NULL, 120592),
(120593, '3.40.50.10190-FF-000264', NULL, 'DNA topoisomerase 2-binding protein 1-A', 89, NULL, NULL, 120593),
(120594, '1.20.1560.10-FF-000662', NULL, 'Uncharacterized protein', 68, NULL, NULL, 120594),
(120595, '1.10.287.70-FF-000435', NULL, 'Voltage-dependent T-type calcium channel subunit alpha-1H', 139, NULL, NULL, 120595),
(120596, '1.10.150.20-FF-000087', NULL, 'Flap endonuclease 1', 64, NULL, NULL, 120596),
(120597, '3.40.50.2300-FF-000708', NULL, 'Predicted protein', 160, NULL, NULL, 120597),
(120598, '1.25.10.10-FF-001635', NULL, 'Uncharacterized protein', 459, NULL, NULL, 120598),
(120599, '1.25.40.10-FF-001137', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 104, NULL, NULL, 120599),
(120600, '3.40.50.410-FF-000160', NULL, 'Caenorhabditis KU', 173, NULL, NULL, 120600),
(120601, '3.30.40.10-FF-000743', NULL, 'PHD finger and BAH domain-containing protein', 136, NULL, NULL, 120601),
(120602, '1.20.58.1120-FF-000023', NULL, 'Dynein heavy chain at 16F', 146, NULL, NULL, 120602),
(120603, '2.60.120.200-FF-000266', NULL, 'Beta 1, 3 galactosyltransferase', 131, NULL, NULL, 120603),
(120604, '1.20.1250.20-FF-000591', NULL, 'Transporter, major facilitator family protein', 223, NULL, NULL, 120604),
(120605, '4.10.400.10-FF-000007', NULL, 'Low density lipoprotein receptor-related protein 1', 42, NULL, NULL, 120605),
(120606, '1.20.1560.10-FF-000353', NULL, 'ABC a-pheromone efflux pump AtrD', 316, NULL, NULL, 120606),
(120607, '1.10.510.10-FF-001691', NULL, 'Kinase, NEK', 290, NULL, NULL, 120607);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(120608, '3.60.130.10-FF-000086', NULL, 'Uncharacterized protein', 81, NULL, NULL, 120608),
(120609, '2.70.98.30-FF-000034', NULL, 'Alpha-mannosidase 2c1, putative', 91, NULL, NULL, 120609),
(120610, '3.40.50.620-FF-000565', NULL, 'Cytoplasmic tRNA 2-thiolation protein 1', 336, NULL, NULL, 120610),
(120611, '3.30.160.60-FF-003381', NULL, NULL, 26, NULL, NULL, 120611),
(120612, '3.30.200.20-FF-000837', NULL, 'AGC family protein kinase', 86, NULL, NULL, 120612),
(120613, '3.20.20.70-FF-000221', NULL, 'tRNA-dihydrouridine synthase', 236, NULL, NULL, 120613),
(120614, '1.10.510.10-FF-001702', NULL, 'Os11g0549300 protein', 211, NULL, NULL, 120614),
(120615, '2.60.120.650-FF-000047', NULL, 'Putative jumonji family transcription factor', 144, NULL, NULL, 120615),
(120616, '3.40.720.10-FF-000219', NULL, 'Arylsulfatase A', 371, NULL, NULL, 120616),
(120617, '3.40.50.2000-FF-000574', NULL, 'Probable glycosyltransferase WbpH', 173, NULL, NULL, 120617),
(120618, '3.30.160.60-FF-003936', NULL, NULL, 30, NULL, NULL, 120618),
(120619, '1.10.246.90-FF-000009', NULL, 'Putative snoRNA binding domain containing protein', 127, NULL, NULL, 120619),
(120620, '1.10.510.10-FF-001382', NULL, 'Protein STRUBBELIG-RECEPTOR FAMILY 4', 194, NULL, NULL, 120620),
(120621, '3.30.70.330-FF-000625', NULL, 'myelin expression factor 2 isoform X1', 172, NULL, NULL, 120621),
(120622, '1.20.1070.10-FF-000490', NULL, 'Growth hormone releasing hormone receptor 2', 291, NULL, NULL, 120622),
(120623, '3.40.1110.10-FF-000431', NULL, NULL, 214, NULL, NULL, 120623),
(120624, '2.70.70.10-FF-000049', NULL, 'Putative lipoprotein NlpD', 153, NULL, NULL, 120624),
(120625, '1.10.150.810-FF-000001', NULL, 'DNA polymerase kappa', 138, NULL, NULL, 120625),
(120626, '2.60.120.200-FF-000603', NULL, 'Predicted protein', 155, NULL, NULL, 120626),
(120627, '3.30.160.20-FF-000176', NULL, 'Putative endoribonuclease dicer', 63, NULL, NULL, 120627),
(120628, '3.10.310.40-FF-000013', NULL, 'Alanine--tRNA ligase', 104, NULL, NULL, 120628),
(120629, '3.40.50.970-FF-000086', NULL, 'Sulfite reductase (NADPH) hemoprotein, beta-component', 302, NULL, NULL, 120629),
(120630, '1.10.490.10-FF-000047', NULL, 'Uncharacterized globin-like protein aq_211', 139, NULL, NULL, 120630),
(120631, '3.90.1200.10-FF-000011', NULL, 'Spore coat protein YutH', 223, NULL, NULL, 120631),
(120632, '1.10.10.1800-FF-000004', NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', 85, NULL, NULL, 120632),
(120633, '1.25.40.210-FF-000006', NULL, 'Telomeric repeat-binding factor a', 201, NULL, NULL, 120633),
(120634, '1.20.1070.10-FF-000810', NULL, 'Uncharacterized protein', 312, NULL, NULL, 120634),
(120635, '1.20.58.60-FF-000635', NULL, 'Uncharacterized protein', 300, NULL, NULL, 120635),
(120636, '2.60.40.790-FF-000198', NULL, NULL, 67, NULL, NULL, 120636),
(120637, '1.10.510.10-FF-003271', NULL, NULL, 105, NULL, NULL, 120637),
(120638, '1.25.40.10-FF-000766', NULL, 'Prolyl 4-hydroxylase alpha subunit, putative', 111, NULL, NULL, 120638),
(120639, '3.30.300.20-FF-000081', NULL, 'Predicted protein', 99, NULL, NULL, 120639),
(120640, '3.30.110.170-FF-000002', NULL, 'Interleukin-1 receptor-associated kinase 1-binding protein 1', 93, NULL, NULL, 120640),
(120641, '1.20.120.1920-FF-000006', NULL, 'Ubiquitin-associated protein 1', 112, NULL, NULL, 120641),
(120642, '3.40.50.80-FF-000135', NULL, 'Ferric reductase transmembrane component, putative', 192, NULL, NULL, 120642),
(120643, '2.60.120.200-FF-000485', NULL, 'Uncharacterized protein', 217, NULL, NULL, 120643),
(120644, '2.60.40.60-FF-001136', NULL, 'Uncharacterized protein', 58, NULL, NULL, 120644),
(120645, '3.30.300.30-FF-000084', NULL, 'Enniatin synthase', 104, NULL, NULL, 120645),
(120646, '3.30.420.40-FF-001063', NULL, 'Uncharacterized protein', 19, NULL, NULL, 120646),
(120647, '1.20.58.1120-FF-000040', NULL, NULL, 30, NULL, NULL, 120647),
(120648, '2.60.120.200-FF-000261', NULL, 'Galectin', 151, NULL, NULL, 120648),
(120649, '2.30.29.30-FF-001023', NULL, 'Predicted protein', 139, NULL, NULL, 120649),
(120650, '2.30.29.30-FF-000219', NULL, 'Arf-GAP with GTPase, ANK repeat and PH domain-containing protein 3', 127, NULL, NULL, 120650);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(120651, '2.10.25.10-FF-000615', NULL, 'Laminin subunit gamma-3', 56, NULL, NULL, 120651),
(120652, '3.50.50.60-FF-000696', NULL, 'Protoporphyrinogen oxidase', 135, NULL, NULL, 120652),
(120653, '1.25.40.10-FF-003514', NULL, 'Uncharacterized protein, isoform F', 149, NULL, NULL, 120653),
(120654, '2.30.42.10-FF-000492', NULL, NULL, 103, NULL, NULL, 120654),
(120655, '2.30.30.490-FF-000045', NULL, 'Predicted protein', 104, NULL, NULL, 120655),
(120656, '3.10.280.10-FF-000001', NULL, 'Complement component 1 Q subcomponent-binding protein, mitochondrial', 207, NULL, NULL, 120656),
(120657, '3.20.180.20-FF-000039', NULL, 'Predicted protein', 96, NULL, NULL, 120657),
(120658, '2.130.10.10-FF-000868', NULL, 'WD repeat protein', 144, NULL, NULL, 120658),
(120659, '3.60.10.10-FF-000425', NULL, 'Calcium-dependent lipid-binding (CaLB domain) family protein', 107, NULL, NULL, 120659),
(120660, '1.20.120.1080-FF-000125', NULL, 'Uncharacterized protein', 113, NULL, NULL, 120660),
(120661, '1.20.120.1910-FF-000003', NULL, 'Cysteine--tRNA ligase CPS1, chloroplastic/mitochondrial', 183, NULL, NULL, 120661),
(120662, '3.30.40.10-FF-000833', NULL, 'Suppressor 2 of zeste 4-31', 105, NULL, NULL, 120662),
(120663, '3.40.850.10-FF-000459', NULL, 'Kinesin-like protein', 392, NULL, NULL, 120663),
(120664, '1.20.1560.10-FF-000336', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 349, NULL, NULL, 120664),
(120665, '1.20.140.10-FF-000081', NULL, 'GD25894', 147, NULL, NULL, 120665),
(120666, '1.10.510.10-FF-001365', NULL, 'Serine/threonine protein kinase cds1, putative', 283, NULL, NULL, 120666),
(120667, '2.60.120.970-FF-000103', NULL, 'Uncharacterized protein', 109, NULL, NULL, 120667),
(120668, '3.40.50.150-FF-001239', NULL, NULL, 93, NULL, NULL, 120668),
(120669, '3.20.20.140-FF-000206', NULL, 'Triazine hydrolase', 324, NULL, NULL, 120669),
(120670, '3.40.33.10-FF-000035', NULL, 'CRISP3: cysteine-rich secretory protein, putative', 233, NULL, NULL, 120670),
(120671, '3.40.50.300-FF-001217', NULL, 'Ras-related protein RABA3', 194, NULL, NULL, 120671),
(120672, '4.10.1240.10-FF-000025', NULL, 'Corticotropin releasing hormone receptor 2', 81, NULL, NULL, 120672),
(120673, '2.60.40.10-FF-001363', NULL, 'Interleukin 10 receptor subunit beta', 91, NULL, NULL, 120673),
(120674, '1.10.630.10-FF-000345', NULL, 'Uncharacterized protein', 128, NULL, NULL, 120674),
(120675, '1.10.150.110-FF-000004', NULL, 'DNA polymerase lambda', 97, NULL, NULL, 120675),
(120676, '3.40.630.40-FF-000019', NULL, 'N-acetylmuramoyl-L-alanine amidase, putative', 187, NULL, NULL, 120676),
(120677, '1.25.40.10-FF-003059', NULL, 'PPR domain-containing protein/PPR_2 domain-containing protein', 66, NULL, NULL, 120677),
(120678, '2.30.40.10-FF-000021', NULL, 'Dihydropyrimidinase-related protein 2', 122, NULL, NULL, 120678),
(120679, '2.30.30.380-FF-000040', NULL, 'Putative cysteine peptidase, Clan CA, family C19', 33, NULL, NULL, 120679),
(120680, '1.10.150.120-FF-000007', NULL, 'indole-3-acetaldehyde oxidase', 121, NULL, NULL, 120680),
(120681, '3.40.50.2300-FF-000366', NULL, 'Ethylene receptor', 143, NULL, NULL, 120681),
(120682, '2.130.10.10-FF-001346', NULL, 'Uncharacterized protein C3H8.05c', 360, NULL, NULL, 120682),
(120683, '1.20.1720.10-FF-000091', NULL, 'MFS multidrug transporter, putative', 409, NULL, NULL, 120683),
(120684, '3.40.50.720-FF-000825', NULL, '3-beta hydroxysteroid dehydrogenase/isomerase family protein', 317, NULL, NULL, 120684),
(120685, '3.40.50.720-FF-002405', NULL, 'Uncharacterized protein', 63, NULL, NULL, 120685),
(120686, '3.50.50.60-FF-000589', NULL, 'FAD-dependent oxidoreductase domain-containing 1', 40, NULL, NULL, 120686),
(120687, '3.40.30.10-FF-000118', NULL, 'Peroxiredoxin AhpE', 151, NULL, NULL, 120687),
(120688, '2.60.40.10-FF-001705', NULL, 'Uncharacterized protein, isoform B', 86, NULL, NULL, 120688),
(120689, '3.40.630.30-FF-000016', NULL, 'nudix hydrolase 2', 87, NULL, NULL, 120689),
(120690, '3.30.1330.90-FF-000018', NULL, 'L-serine dehydratase', 148, NULL, NULL, 120690),
(120691, '2.130.10.10-FF-001672', NULL, 'Periodic tryptophan protein 2-like protein', 293, NULL, NULL, 120691);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(120692, '3.80.10.10-FF-002263', NULL, 'Uncharacterized protein', 104, NULL, NULL, 120692),
(120693, '1.10.1060.10-FF-000042', NULL, NULL, 62, NULL, NULL, 120693),
(120694, '1.20.1070.10-FF-000271', NULL, 'Octopamine receptor beta-2R', 351, NULL, NULL, 120694),
(120695, '3.20.20.80-FF-000549', NULL, 'Predicted protein', 333, NULL, NULL, 120695),
(120696, '2.60.120.920-FF-000004', NULL, 'Butyrophilin subfamily 1 member A1', 187, NULL, NULL, 120696),
(120697, '3.30.60.90-FF-000021', NULL, 'Unplaced genomic scaffold supercont1.18, whole genome shotgun sequence', 61, NULL, NULL, 120697),
(120698, '1.10.630.10-FF-000671', NULL, 'Uncharacterized protein', 176, NULL, NULL, 120698),
(120699, '2.60.34.20-FF-000002', NULL, 'A1 cistron-splicing factor AAR2', 143, NULL, NULL, 120699),
(120700, '3.40.50.12780-FF-000209', NULL, 'Acyl-CoA synthetase, putative', 232, NULL, NULL, 120700),
(120701, '2.130.10.10-FF-005073', NULL, 'Uncharacterized protein', 269, NULL, NULL, 120701),
(120702, '3.30.950.10-FF-000003', NULL, 'Ribosomal RNA small subunit methyltransferase I', 117, NULL, NULL, 120702),
(120703, '3.90.1720.10-FF-000011', NULL, 'Trypanothione synthetase, putative', 198, NULL, NULL, 120703),
(120704, '1.20.1560.10-FF-000572', NULL, 'ABC transporter B family member 28', 12, NULL, NULL, 120704),
(120705, '3.40.50.720-FF-000477', NULL, 'Peroxisomal 2,4-dienoyl-CoA reductase', 276, NULL, NULL, 120705),
(120706, '3.30.160.60-FF-003717', NULL, NULL, 28, NULL, NULL, 120706),
(120707, '3.40.50.2300-FF-000927', NULL, NULL, 70, NULL, NULL, 120707),
(120708, '3.40.630.20-FF-000013', NULL, 'Pyroglutamyl-peptidase I', 211, NULL, NULL, 120708),
(120709, '2.130.10.10-FF-005617', NULL, 'Sperm associated antigen 9a', 185, NULL, NULL, 120709),
(120710, '1.10.10.750-FF-000026', NULL, 'GM26567', 58, NULL, NULL, 120710),
(120711, '3.30.160.60-FF-005325', NULL, NULL, 30, NULL, NULL, 120711),
(120712, '3.20.20.140-FF-000116', NULL, 'N-acyl-D-amino acid deacylase protein', 303, NULL, NULL, 120712),
(120713, '1.10.510.10-FF-001707', NULL, 'Mitogen-activated protein kinase kinase kinase kinase', 111, NULL, NULL, 120713),
(120714, '1.10.8.870-FF-000002', NULL, 'Glycerol-3-phosphate dehydrogenase', 71, NULL, NULL, 120714),
(120715, '3.90.1150.10-FF-000467', NULL, 'dTDP-3-amino-3,4,6-trideoxy-alpha-D-glucose transaminase', 126, NULL, NULL, 120715),
(120716, '3.40.50.720-FF-000786', NULL, 'Adenylyltransferase and sulfurtransferase MOCS3', 91, NULL, NULL, 120716),
(120717, '2.60.40.10-FF-001840', NULL, 'Roundabout 2', 100, NULL, NULL, 120717),
(120718, '1.10.8.10-FF-000324', NULL, 'UBA/TS-N domain containing protein', 51, NULL, NULL, 120718),
(120719, '2.130.10.10-FF-005382', NULL, 'Uncharacterized protein', 156, NULL, NULL, 120719),
(120720, '1.10.287.10-FF-000029', NULL, 'Glycine--tRNA ligase, mitochondrial 1', 47, NULL, NULL, 120720),
(120721, '3.65.10.20-FF-000013', NULL, 'TatD related DNase', 240, NULL, NULL, 120721),
(120722, '1.10.565.10-FF-000007', NULL, 'Hepatocyte nuclear factor 4 alpha', 232, NULL, NULL, 120722),
(120723, '4.10.860.10-FF-000019', NULL, 'UvrABC system protein C', 51, NULL, NULL, 120723),
(120724, '3.90.70.80-FF-000044', NULL, 'Ubiquitin thioesterase OTU1', 179, NULL, NULL, 120724),
(120725, '1.20.1080.10-FF-000097', NULL, 'Aquaporin-like Protein', 234, NULL, NULL, 120725),
(120726, '6.10.140.2220-FF-000075', NULL, 'Predicted protein', 41, NULL, NULL, 120726),
(120727, '3.40.50.720-FF-002063', NULL, 'Uncharacterized protein', 158, NULL, NULL, 120727),
(120728, '1.10.10.10-FF-001562', NULL, 'EAP30/Vps36 family-domain-containing protein', 72, NULL, NULL, 120728),
(120729, '2.130.10.10-FF-002976', NULL, 'UTP15 C terminal, putative', 212, NULL, NULL, 120729),
(120730, '1.20.58.60-FF-000545', NULL, 'Uncharacterized protein', 224, NULL, NULL, 120730),
(120731, '2.60.40.10-FF-004004', NULL, NULL, 99, NULL, NULL, 120731),
(120732, '1.10.150.910-FF-000014', NULL, 'Uncharacterized protein', 97, NULL, NULL, 120732),
(120733, '3.30.980.10-FF-000033', NULL, 'Probable threonine--tRNA ligase 2, cytoplasmic', 155, NULL, NULL, 120733);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(120734, '3.40.50.2000-FF-000248', NULL, 'Alpha,alpha-trehalose-phosphate synthase [UDP-forming] 1', 277, NULL, NULL, 120734),
(120735, '2.160.20.10-FF-000188', NULL, 'Uncharacterized protein', 337, NULL, NULL, 120735),
(120736, '2.60.40.3180-FF-000002', NULL, 'transcription factor COE2 isoform X1', 237, NULL, NULL, 120736),
(120737, '3.40.50.300-FF-001436', NULL, 'Developmentally-regulated GTP-binding protein', 122, NULL, NULL, 120737),
(120738, '2.60.120.260-FF-000672', NULL, 'Beta-galactosidase', 129, NULL, NULL, 120738),
(120739, '3.40.50.150-FF-001329', NULL, NULL, 201, NULL, NULL, 120739),
(120740, '3.30.70.2850-FF-000016', NULL, 'DNA-directed RNA polymerase subunit', 237, NULL, NULL, 120740),
(120741, '1.25.40.180-FF-000290', NULL, NULL, 119, NULL, NULL, 120741),
(120742, '1.20.58.1020-FF-000009', NULL, 'DNA replication complex GINS protein PSF2', 96, NULL, NULL, 120742),
(120743, '1.10.340.70-FF-000032', NULL, 'Uncharacterized protein', 92, NULL, NULL, 120743),
(120744, '3.30.470.20-FF-000076', NULL, 'Glutamine-hydrolysing carbamoyl-phosphate synthase', 199, NULL, NULL, 120744),
(120745, '2.130.10.10-FF-001037', NULL, 'Blast:DDB1-and CUL4-associated factor 12', 155, NULL, NULL, 120745),
(120746, '1.10.287.370-FF-000019', NULL, 'Prefoldin subunit alpha', 141, NULL, NULL, 120746),
(120747, '3.30.160.60-FF-005544', NULL, NULL, 82, NULL, NULL, 120747),
(120748, '2.60.490.10-FF-000015', NULL, 'P2X purinoceptor', 169, NULL, NULL, 120748),
(120749, '3.30.450.20-FF-000529', NULL, 'Putative diguanylate cyclase', 108, NULL, NULL, 120749),
(120750, '1.10.630.10-FF-000036', NULL, 'CYtochrome P450 family', 477, NULL, NULL, 120750),
(120751, '1.10.20.70-FF-000001', NULL, 'Cleavage stimulation factor subunit 2', 45, NULL, NULL, 120751),
(120752, '3.90.190.10-FF-000190', NULL, 'Protein-tyrosine-phosphatase', 282, NULL, NULL, 120752),
(120753, '3.40.1110.10-FF-000066', NULL, 'Cadmium-translocating P-type ATPase', 113, NULL, NULL, 120753),
(120754, '3.30.1310.20-FF-000002', NULL, 'Phosphoribosyl transferase', 63, NULL, NULL, 120754),
(120755, '3.40.50.2000-FF-000490', NULL, 'Glycosyl transferase', 185, NULL, NULL, 120755),
(120756, '3.40.50.460-FF-000039', NULL, 'Uncharacterized protein', 33, NULL, NULL, 120756),
(120757, '3.40.50.410-FF-000143', NULL, 'ATP-dependent DNA helicase II subunit 2', 218, NULL, NULL, 120757),
(120758, '1.10.2000.10-FF-000055', NULL, NULL, 126, NULL, NULL, 120758),
(120759, '1.20.58.1880-FF-000037', NULL, 'REST corepressor 3', 90, NULL, NULL, 120759),
(120760, '3.30.70.1180-FF-000010', NULL, 'V-type proton ATPase subunit C', 45, NULL, NULL, 120760),
(120761, '3.30.470.30-FF-000079', NULL, 'Putative DNA ligase 4', 95, NULL, NULL, 120761),
(120762, '3.40.190.10-FF-000566', NULL, 'Molybdenum cofactor biosynthesis protein', 111, NULL, NULL, 120762),
(120763, '2.130.10.10-FF-002667', NULL, 'Guanine nucleotide-binding protein negative regulator 1', 328, NULL, NULL, 120763),
(120764, '2.60.40.420-FF-000008', NULL, 'Ubiquinol oxidase subunit 2', 170, NULL, NULL, 120764),
(120765, '3.30.160.20-FF-000092', NULL, 'Related to MRPL3-Mitochondrial ribosomal protein, large subunit', 81, NULL, NULL, 120765),
(120766, '1.20.1560.10-FF-000555', NULL, 'Uncharacterized protein', 224, NULL, NULL, 120766),
(120767, '1.25.10.20-FF-000003', NULL, 'Vitellogenin C', 338, NULL, NULL, 120767),
(120768, '2.30.42.10-FF-000531', NULL, NULL, 110, NULL, NULL, 120768),
(120769, '3.50.50.60-FF-001230', NULL, 'Uncharacterized protein', 230, NULL, NULL, 120769),
(120770, '2.60.120.330-FF-000030', NULL, 'Thymine dioxygenase', 334, NULL, NULL, 120770),
(120771, '3.80.10.10-FF-000801', NULL, 'Outer arm dynein light chain 1', 164, NULL, NULL, 120771),
(120772, '3.30.160.60-FF-005196', NULL, NULL, 26, NULL, NULL, 120772),
(120773, '2.120.10.30-FF-000493', NULL, 'Uncharacterized protein', 238, NULL, NULL, 120773),
(120774, '3.40.630.10-FF-000100', NULL, 'Arginine utilization protein RocB', 218, NULL, NULL, 120774),
(120775, '3.60.40.10-FF-000236', NULL, 'Uncharacterized protein', 310, NULL, NULL, 120775),
(120776, '1.25.10.10-FF-001309', NULL, 'Uncharacterized protein', 270, NULL, NULL, 120776);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(120777, '1.50.10.20-FF-000046', NULL, 'Protein geranylgeranyltransferase type I subunit beta', 145, NULL, NULL, 120777),
(120778, '2.130.10.10-FF-005308', NULL, 'U3 small nucleolar RNA-associated protein 4', 209, NULL, NULL, 120778),
(120779, '3.40.50.2300-FF-001170', NULL, NULL, 152, NULL, NULL, 120779),
(120780, '1.20.1250.20-FF-002171', NULL, 'Uncharacterized protein', 178, NULL, NULL, 120780),
(120781, '1.10.260.40-FF-000095', NULL, 'MBF1 transcription factor', 54, NULL, NULL, 120781),
(120782, '2.30.30.140-FF-000108', NULL, 'Histone-lysine N-methyltransferase', 107, NULL, NULL, 120782),
(120783, '1.25.10.10-FF-001551', NULL, 'Uncharacterized protein', 181, NULL, NULL, 120783),
(120784, '1.20.1280.50-FF-000152', NULL, 'F-box/LRR-repeat protein 6 isoform X1', 50, NULL, NULL, 120784),
(120785, '3.40.50.300-FF-001745', NULL, 'DEAD/DEAH box helicase, putative', 158, NULL, NULL, 120785),
(120786, '1.20.1270.60-FF-000020', NULL, 'SLIT-ROBO Rho GTPase activating protein 3', 327, NULL, NULL, 120786),
(120787, '2.10.110.10-FF-000246', NULL, 'LIM domain-containing protein WLIM2a', 126, NULL, NULL, 120787),
(120788, '3.30.930.10-FF-000120', NULL, 'Proline--tRNA ligase', 68, NULL, NULL, 120788),
(120789, '1.25.40.90-FF-000071', NULL, 'Clathrin assembly factor-like protein', 161, NULL, NULL, 120789),
(120790, '3.30.160.60-FF-001273', NULL, 'Zinc finger protein', 29, NULL, NULL, 120790),
(120791, '2.70.70.10-FF-000066', NULL, 'Zinc metalloendopeptidase, M23 family', 132, NULL, NULL, 120791),
(120792, '3.40.1110.10-FF-000414', NULL, NULL, 48, NULL, NULL, 120792),
(120793, '2.60.40.1180-FF-000014', NULL, '1,4-alpha-glucan-branching enzyme', 104, NULL, NULL, 120793),
(120794, '2.60.120.10-FF-000701', NULL, 'Predicted protein', 220, NULL, NULL, 120794),
(120795, '3.30.160.60-FF-005853', NULL, NULL, 68, NULL, NULL, 120795),
(120796, '3.40.50.10090-FF-000032', NULL, 'Uroporphyrinogen III synthase/methyltransferase', 136, NULL, NULL, 120796),
(120797, '3.40.630.30-FF-000106', NULL, 'Acetyltransferase At1g77540', 99, NULL, NULL, 120797),
(120798, '2.60.40.10-FF-000997', NULL, 'Colony stimulating factor 3 receptor (Granulocyte)', 89, NULL, NULL, 120798),
(120799, '3.20.20.60-FF-000111', NULL, 'Isocitrate lyase 1', 105, NULL, NULL, 120799),
(120800, '3.30.2460.20-FF-000007', NULL, 'Protein Wnt', 60, NULL, NULL, 120800),
(120801, '3.90.215.10-FF-000001', NULL, 'Tenascin isoform 1', 220, NULL, NULL, 120801),
(120802, '2.60.40.60-FF-000989', NULL, 'Uncharacterized protein', 110, NULL, NULL, 120802),
(120803, '2.30.42.10-FF-000183', NULL, 'Golgi reassembly-stacking protein 2', 99, NULL, NULL, 120803),
(120804, '2.30.30.100-FF-000092', NULL, 'Small nuclear ribonucleoprotein E', 94, NULL, NULL, 120804),
(120805, '1.20.58.60-FF-000326', NULL, 'Muscle-specific protein 300 kDa, isoform D', 211, NULL, NULL, 120805),
(120806, '3.20.20.70-FF-000114', NULL, 'Decarboxylase,orotidine phosphate', 263, NULL, NULL, 120806),
(120807, '2.30.29.30-FF-000192', NULL, 'SH2B adapter protein 1 isoform X1', 146, NULL, NULL, 120807),
(120808, '3.40.640.10-FF-000197', NULL, 'Glycine dehydrogenase (decarboxylating)', 265, NULL, NULL, 120808),
(120809, '3.90.190.10-FF-000509', NULL, 'Uncharacterized protein', 140, NULL, NULL, 120809),
(120810, '3.30.160.60-FF-001492', NULL, 'Zinc finger protein 444', 31, NULL, NULL, 120810),
(120811, '3.30.160.60-FF-001582', NULL, 'zinc finger protein 197', 29, NULL, NULL, 120811),
(120812, '1.10.510.10-FF-000999', NULL, 'Si:dkey-8e10.3', 303, NULL, NULL, 120812),
(120813, '1.10.1200.10-FF-000121', NULL, 'Saframycin Mx1 synthetase B', 84, NULL, NULL, 120813),
(120814, '3.40.50.300-FF-007052', NULL, 'ABC transporter ATP-binding protein, putative', 198, NULL, NULL, 120814),
(120815, '3.40.50.300-FF-002015', NULL, 'SWIM-type zinc finger 7 associated protein 1', 145, NULL, NULL, 120815),
(120816, '3.30.505.10-FF-000132', NULL, 'Tyrosine-protein kinase', 115, NULL, NULL, 120816),
(120817, '1.10.510.10-FF-001926', NULL, 'Uncharacterized protein', 207, NULL, NULL, 120817),
(120818, '1.10.357.90-FF-000008', NULL, NULL, 139, NULL, NULL, 120818);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(120819, '3.20.10.10-FF-000062', NULL, 'Uncharacterized protein', 80, NULL, NULL, 120819),
(120820, '1.20.1070.10-FF-000355', NULL, 'Predicted protein', 311, NULL, NULL, 120820),
(120821, '1.20.1070.10-FF-002069', NULL, 'Uncharacterized protein', 72, NULL, NULL, 120821),
(120822, '1.10.1520.10-FF-000050', NULL, 'Uncharacterized protein', 72, NULL, NULL, 120822),
(120823, '3.20.20.80-FF-000117', NULL, 'Lactase', 196, NULL, NULL, 120823),
(120824, '3.40.190.10-FF-000785', NULL, 'Hydroxymethylbilane synthase', 56, NULL, NULL, 120824),
(120825, '1.25.40.70-FF-000036', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', 224, NULL, NULL, 120825),
(120826, '1.20.900.10-FF-000049', NULL, 'Rho guanine nucleotide exchange factor 38', 155, NULL, NULL, 120826),
(120827, '1.25.40.10-FF-002683', NULL, 'Putative peroxisomal targeting signal 1 receptor', 323, NULL, NULL, 120827),
(120828, '3.60.15.10-FF-000268', NULL, 'Uncharacterized protein', 78, NULL, NULL, 120828),
(120829, '1.20.1560.10-FF-000246', NULL, 'Probable multidrug resistance ABC transporter ATP-binding/permease protein YheH', 323, NULL, NULL, 120829),
(120830, '3.30.40.10-FF-000850', NULL, 'Pep7p', 108, NULL, NULL, 120830),
(120831, '1.20.120.1080-FF-000142', NULL, 'Uncharacterized protein', 104, NULL, NULL, 120831),
(120832, '3.40.50.20-FF-000033', NULL, 'Carbamoyl-phosphate synthase, large subunit', 154, NULL, NULL, 120832),
(120833, '3.80.10.10-FF-001897', NULL, 'Tubulin-specific chaperone', 147, NULL, NULL, 120833),
(120834, '3.80.10.10-FF-002386', NULL, 'Protein phosphatase 1, regulatory subunit, putative', 111, NULL, NULL, 120834),
(120835, '2.30.42.10-FF-000076', NULL, 'Protein lin-7 homolog', 110, NULL, NULL, 120835),
(120836, '3.70.10.10-FF-000110', NULL, 'Rad1 DNA damage checkpoint protein, putative', 258, NULL, NULL, 120836),
(120837, '3.40.50.12470-FF-000004', NULL, '2-oxoglutarate dehydrogenase E1 component', 221, NULL, NULL, 120837),
(120838, '2.40.10.480-FF-000007', NULL, 'Cell surface protein', 66, NULL, NULL, 120838),
(120839, '1.20.1540.10-FF-000099', NULL, 'Uncharacterized protein', 191, NULL, NULL, 120839),
(120840, '3.40.50.300-FF-001184', NULL, 'Chromatin complex subunit A 106', 232, NULL, NULL, 120840),
(120841, '3.30.160.60-FF-001357', NULL, 'Zinc finger protein 580', 31, NULL, NULL, 120841),
(120842, '1.25.40.10-FF-001154', NULL, 'Protein CBG09283', 109, NULL, NULL, 120842),
(120843, '4.10.410.10-FF-000053', NULL, 'Protein CBG09606', 64, NULL, NULL, 120843),
(120844, '1.10.287.10-FF-000007', NULL, 'Glycyl-tRNA synthetase', 46, NULL, NULL, 120844),
(120845, '3.30.40.10-FF-000069', NULL, 'E3 ubiquitin-protein ligase RNF115', 82, NULL, NULL, 120845),
(120846, '1.10.1520.10-FF-000049', NULL, '60S ribosomal protein L3, mitochondrial, putative', 225, NULL, NULL, 120846),
(120847, '2.130.10.10-FF-001363', NULL, 'Tex1p', 193, NULL, NULL, 120847),
(120848, '1.25.40.20-FF-001157', NULL, 'Serine/threonine protein kinase', 136, NULL, NULL, 120848),
(120849, '3.30.40.10-FF-001215', NULL, 'RBR-type E3 ubiquitin transferase', 83, NULL, NULL, 120849),
(120850, '3.30.710.10-FF-000463', NULL, 'Uncharacterized protein', 168, NULL, NULL, 120850),
(120851, '1.20.1080.10-FF-000075', NULL, 'Uncharacterized protein', 247, NULL, NULL, 120851),
(120852, '1.10.287.130-FF-000094', NULL, 'Two-component sensor histidine kinase', 107, NULL, NULL, 120852),
(120853, '2.40.128.80-FF-000008', NULL, 'Dipeptidyl-peptidase I', 130, NULL, NULL, 120853),
(120854, '2.60.40.10-FF-001924', NULL, 'KETtiN (Drosophila actin-binding) homolog', 95, NULL, NULL, 120854),
(120855, '2.130.10.10-FF-002892', NULL, 'WD repeat-containing protein AAC3', 236, NULL, NULL, 120855),
(120856, '3.90.1150.10-FF-000248', NULL, 'Kynureninase', 152, NULL, NULL, 120856),
(120857, '1.10.10.750-FF-000043', NULL, 'Uncharacterized protein', 57, NULL, NULL, 120857),
(120858, '3.30.460.10-FF-000140', NULL, 'ATPase synthesis protein 25, mitochondrial', 129, NULL, NULL, 120858),
(120859, '1.10.1060.10-FF-000025', NULL, 'Dihydropyrimidine dehydrogenase, putative', 136, NULL, NULL, 120859); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(120860, '3.90.1310.10-FF-000019', NULL, 'Penicillin-binding membrane protein PbpB', 186, NULL, NULL, 120860),
(120861, '3.40.50.620-FF-000649', NULL, 'Predicted protein', 74, NULL, NULL, 120861),
(120862, '3.30.70.330-FF-002194', NULL, NULL, 119, NULL, NULL, 120862),
(120863, '1.20.5.460-FF-000001', NULL, 'Bifunctional protein PutA', 26, NULL, NULL, 120863),
(120864, '2.10.10.10-FF-000014', NULL, 'Uncharacterized protein', 57, NULL, NULL, 120864),
(120865, '3.30.40.10-FF-000597', NULL, 'RING finger protein', 74, NULL, NULL, 120865),
(120866, '1.25.40.10-FF-003823', NULL, 'Peroxisomal biogenesis factor 5 like', 315, NULL, NULL, 120866),
(120867, '1.20.5.1300-FF-000015', NULL, 'Histidinol dehydrogenase', 17, NULL, NULL, 120867),
(120868, '3.30.930.10-FF-000204', NULL, 'Uncharacterized protein', 308, NULL, NULL, 120868),
(120869, '1.10.10.60-FF-000947', NULL, NULL, 105, NULL, NULL, 120869),
(120870, '3.40.50.720-FF-002372', NULL, 'Uncharacterized protein', 11, NULL, NULL, 120870),
(120871, '2.130.10.10-FF-003510', NULL, 'Uncharacterized protein', 226, NULL, NULL, 120871),
(120872, '3.30.50.10-FF-000098', NULL, 'Farnesoid X receptor beta splice variant 5', 108, NULL, NULL, 120872),
(120873, '1.50.40.10-FF-000016', NULL, 'Solute carrier family 25 member 23', 297, NULL, NULL, 120873),
(120874, '3.40.50.300-FF-005449', NULL, 'Uncharacterized protein', 248, NULL, NULL, 120874),
(120875, '4.10.400.10-FF-000024', NULL, 'Low-density lipoprotein RecePtor related', 39, NULL, NULL, 120875),
(120876, '1.25.40.820-FF-000004', NULL, 'Putative RNA polymerase II subunit B1 CTD phosphatase rtr1', 179, NULL, NULL, 120876),
(120877, '4.10.1000.10-FF-000070', NULL, 'Uncharacterized protein', 35, NULL, NULL, 120877),
(120878, '1.10.10.60-FF-001026', NULL, NULL, 80, NULL, NULL, 120878),
(120879, '3.30.1360.180-FF-000014', NULL, 'Alkaline-phosphatase-like family protein', 51, NULL, NULL, 120879),
(120880, '2.60.120.10-FF-000050', NULL, 'AraC family transcriptional regulator', 106, NULL, NULL, 120880),
(120881, '3.90.245.10-FF-000031', NULL, 'AT5g18860/F17K4_110', 365, NULL, NULL, 120881),
(120882, '3.50.30.30-FF-000028', NULL, 'N-acetylated alpha-linked acidic dipeptidase like 2', 196, NULL, NULL, 120882),
(120883, '2.60.40.420-FF-000227', NULL, 'Chromosome 12, whole genome shotgun sequence', 185, NULL, NULL, 120883),
(120884, '2.130.10.10-FF-005056', NULL, 'Uncharacterized protein', 278, NULL, NULL, 120884),
(120885, '3.40.960.10-FF-000001', NULL, 'Very short patch repair endonuclease', 136, NULL, NULL, 120885),
(120886, '3.40.720.10-FF-000220', NULL, 'Arylsulfatase', 369, NULL, NULL, 120886),
(120887, '3.60.150.10-FF-000014', NULL, 'Chorismate synthase', 364, NULL, NULL, 120887),
(120888, '3.30.160.60-FF-005089', NULL, NULL, 23, NULL, NULL, 120888),
(120889, '1.20.1070.10-FF-000580', NULL, 'probable G-protein coupled receptor Mth-like 9', 278, NULL, NULL, 120889),
(120890, '1.10.287.70-FF-000351', NULL, 'Uncharacterized protein', 158, NULL, NULL, 120890),
(120891, '1.10.10.10-FF-000983', NULL, 'Uncharacterized protein', 82, NULL, NULL, 120891),
(120892, '2.90.10.30-FF-000005', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase LECRK1', 135, NULL, NULL, 120892),
(120893, '1.10.720.30-FF-000021', NULL, 'ATP-dependent DNA helicase 2 subunit KU70', 52, NULL, NULL, 120893),
(120894, '3.90.190.10-FF-000515', NULL, 'MAP kinase phosphatase 2', 127, NULL, NULL, 120894),
(120895, '1.20.140.10-FF-000120', NULL, 'Predicted protein', 72, NULL, NULL, 120895),
(120896, '2.40.50.150-FF-000012', NULL, 'DNA-directed RNA polymerase subunit beta', 56, NULL, NULL, 120896),
(120897, '3.80.10.10-FF-004078', NULL, 'Protein phosphatase 2C, putative', 127, NULL, NULL, 120897),
(120898, '3.50.50.60-FF-001084', NULL, 'Polyamine oxidase (exo-N4-amino)', 166, NULL, NULL, 120898),
(120899, '1.10.1040.10-FF-000024', NULL, 'Glycerol-3-phosphate dehydrogenase', 142, NULL, NULL, 120899),
(120900, '3.30.930.10-FF-000193', NULL, 'DNA polymerase gamma 35kD', 185, NULL, NULL, 120900),
(120901, '1.10.10.350-FF-000007', NULL, 'Glutamate--tRNA ligase', 102, NULL, NULL, 120901);
INSERT INTO "PUBLIC"."MODEL" VALUES
(120902, '3.40.190.170-FF-000005', NULL, 'C4-dicarboxylate ABC transporter permease', 298, NULL, NULL, 120902),
(120903, '2.60.40.150-FF-000202', NULL, 'Uncharacterized protein, isoform B', 137, NULL, NULL, 120903),
(120904, '3.40.50.300-FF-006978', NULL, 'Uncharacterized protein', 217, NULL, NULL, 120904),
(120905, '1.10.287.1060-FF-000014', NULL, 'conserved oligomeric Golgi complex subunit 4', 88, NULL, NULL, 120905),
(120906, '1.10.630.10-FF-000255', NULL, 'Uncharacterized protein', 189, NULL, NULL, 120906),
(120907, '3.30.30.30-FF-000001', NULL, 'heat shock 70 kDa protein-like', 55, NULL, NULL, 120907),
(120908, '3.40.190.160-FF-000002', NULL, 'Integral membrane indolylacetylinositol arabinosyltransferase embA', 103, NULL, NULL, 120908),
(120909, '3.40.350.10-FF-000096', NULL, 'Predicted protein', 156, NULL, NULL, 120909),
(120910, '1.25.40.180-FF-000317', NULL, NULL, 124, NULL, NULL, 120910),
(120911, '1.25.40.20-FF-000162', NULL, 'Ankyrin repeat domain-containing protein 54', 76, NULL, NULL, 120911),
(120912, '1.25.40.10-FF-000749', NULL, 'U3 snoRNP protein', 156, NULL, NULL, 120912),
(120913, '3.20.20.100-FF-000026', NULL, 'Gamma-cysteine synthetase regulatory subunit, putative', 195, NULL, NULL, 120913),
(120914, '3.60.130.10-FF-000013', NULL, 'Alpha-ketoglutarate-dependent L-arginine hydroxylase', 328, NULL, NULL, 120914),
(120915, '3.40.50.1820-FF-000177', NULL, 'Group XV phospholipase A2', 227, NULL, NULL, 120915),
(120916, '1.10.8.60-FF-000513', NULL, 'Regulatory protease', 55, NULL, NULL, 120916),
(120917, '4.10.480.10-FF-000001', NULL, 'Hydrogenase 2 small subunit', 90, NULL, NULL, 120917),
(120918, '3.40.50.720-FF-002259', NULL, 'Uncharacterized protein', 55, NULL, NULL, 120918),
(120919, '2.60.40.10-FF-001385', NULL, 'titin isoform X1', 93, NULL, NULL, 120919),
(120920, '1.10.150.510-FF-000017', NULL, 'Uncharacterized protein', 53, NULL, NULL, 120920),
(120921, '3.40.390.10-FF-000216', NULL, NULL, 211, NULL, NULL, 120921),
(120922, '2.40.50.40-FF-000086', NULL, 'C-C motif chemokine 4 homolog', 70, NULL, NULL, 120922),
(120923, '3.30.420.10-FF-000031', NULL, 'RNA exonuclease 1', 165, NULL, NULL, 120923),
(120924, '1.10.150.50-FF-000180', NULL, 'Arrestin domain-containing protein B', 79, NULL, NULL, 120924),
(120925, '1.25.10.10-FF-002855', NULL, 'Anaphase-promoting complex subunit, putative', 168, NULL, NULL, 120925),
(120926, '2.30.29.30-FF-000528', NULL, 'FACT complex subunit POB3', 110, NULL, NULL, 120926),
(120927, '1.10.287.110-FF-000301', NULL, 'Heat shock protein DnaJ family protein', 91, NULL, NULL, 120927),
(120928, '2.130.10.10-FF-001256', NULL, 'Unplaced genomic scaffold supercont1.223, whole genome shotgun sequence', 315, NULL, NULL, 120928),
(120929, '3.60.20.10-FF-000235', NULL, NULL, 99, NULL, NULL, 120929),
(120930, '1.20.1050.10-FF-000247', NULL, 'Uncharacterized protein', 46, NULL, NULL, 120930),
(120931, '2.60.120.920-FF-000111', NULL, 'Protein TRAUCO', 146, NULL, NULL, 120931),
(120932, '3.10.330.10-FF-000028', NULL, 'Vesicle-fusing ATPase', 124, NULL, NULL, 120932),
(120933, '1.20.140.10-FF-000007', NULL, 'Acyl-coenzyme A oxidase', 130, NULL, NULL, 120933),
(120934, '3.40.1340.10-FF-000004', NULL, 'DNA-directed RNA polymerases I, II, and III subunit RPABC1', 58, NULL, NULL, 120934),
(120935, '2.60.40.420-FF-000082', NULL, 'Extracellular dihydrogeodin oxidase/laccase', 214, NULL, NULL, 120935),
(120936, '3.50.50.60-FF-000948', NULL, 'Uncharacterized protein', 217, NULL, NULL, 120936),
(120937, '3.40.50.410-FF-000250', NULL, 'Uncharacterized protein', 191, NULL, NULL, 120937),
(120938, '3.30.460.10-FF-000027', NULL, 'Poly(A) polymerase PAP', 156, NULL, NULL, 120938),
(120939, '2.30.30.100-FF-000119', NULL, 'LSM domain containing protein, putative', 70, NULL, NULL, 120939),
(120940, '3.20.20.80-FF-000443', NULL, 'Uncharacterized protein', 216, NULL, NULL, 120940),
(120941, '1.20.1090.10-FF-000047', NULL, 'Iron-containing alcohol dehydrogenase', 204, NULL, NULL, 120941),
(120942, '1.10.10.10-FF-001601', NULL, 'Uncharacterized protein', 96, NULL, NULL, 120942);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(120943, '3.30.450.20-FF-000058', NULL, 'neuronal PAS domain-containing protein 4', 96, NULL, NULL, 120943),
(120944, '3.80.10.10-FF-000823', NULL, 'F-box/LRR-repeat protein 15', 149, NULL, NULL, 120944),
(120945, '2.40.50.140-FF-000931', NULL, NULL, 91, NULL, NULL, 120945),
(120946, '2.20.28.100-FF-000001', NULL, 'Desulforedoxin, putative', 37, NULL, NULL, 120946),
(120947, '3.40.50.300-FF-001762', NULL, 'Sulfotransferase 3, isoform A', 303, NULL, NULL, 120947),
(120948, '1.10.510.10-FF-003635', NULL, NULL, 191, NULL, NULL, 120948),
(120949, '1.10.630.10-FF-000362', NULL, 'Predicted protein', 462, NULL, NULL, 120949),
(120950, '3.20.20.70-FF-000440', NULL, 'dTDP-4-amino-4,6-dideoxy-D-glucose ammonia-lyase', 253, NULL, NULL, 120950),
(120951, '1.10.8.1220-FF-000033', NULL, NULL, 44, NULL, NULL, 120951),
(120952, '2.60.40.1490-FF-000006', NULL, 'ASF1 like histone chaperone, putative', 151, NULL, NULL, 120952),
(120953, '3.30.70.330-FF-002974', NULL, NULL, 97, NULL, NULL, 120953),
(120954, '3.40.630.30-FF-000241', NULL, 'Acetyltransferase GNAT family protein, putative', 155, NULL, NULL, 120954),
(120955, '1.25.40.420-FF-000064', NULL, 'Uncharacterized protein', 51, NULL, NULL, 120955),
(120956, '2.40.50.140-FF-000167', NULL, 'Minichromosome maintenance 10 replication initiation factor', 180, NULL, NULL, 120956),
(120957, '1.20.920.10-FF-000051', NULL, 'Transcription initiation factor TFIID subunit', 133, NULL, NULL, 120957),
(120958, '1.20.1740.10-FF-000209', NULL, 'Uncharacterized protein', 140, NULL, NULL, 120958),
(120959, '2.60.40.150-FF-000579', NULL, 'Activating signal cointegrator 1 complex subunit 3', 122, NULL, NULL, 120959),
(120960, '3.30.200.20-FF-001326', NULL, 'Serine/threonine-protein kinase cbk1', 155, NULL, NULL, 120960),
(120961, '3.10.20.90-FF-000210', NULL, 'Putative Sorting nexin-27', 95, NULL, NULL, 120961),
(120962, '1.10.630.10-FF-000564', NULL, 'Uncharacterized protein', 325, NULL, NULL, 120962),
(120963, '2.60.40.1730-FF-000022', NULL, 'Aminopeptidase', 214, NULL, NULL, 120963),
(120964, '1.10.238.20-FF-000032', NULL, 'Odorant binding protein 24', 116, NULL, NULL, 120964),
(120965, '3.30.70.330-FF-000956', NULL, 'Protein CBR-SPN-4', 96, NULL, NULL, 120965),
(120966, '1.20.58.60-FF-000309', NULL, 'Spectrin beta non-erythrocytic 5', 107, NULL, NULL, 120966),
(120967, '3.40.1190.20-FF-000102', NULL, 'Ribokinase', 327, NULL, NULL, 120967),
(120968, '3.30.160.60-FF-005960', NULL, NULL, 83, NULL, NULL, 120968),
(120969, '1.10.10.60-FF-001245', NULL, NULL, 43, NULL, NULL, 120969),
(120970, '1.20.1070.10-FF-000832', NULL, 'Vomeronasal type-1 receptor', 306, NULL, NULL, 120970),
(120971, '1.10.8.10-FF-000072', NULL, 'Activating signal cointegrator 1 complex subunit 2', 46, NULL, NULL, 120971),
(120972, '3.20.20.70-FF-000131', NULL, 'Transaldolase', 318, NULL, NULL, 120972),
(120973, '1.20.58.150-FF-000014', NULL, NULL, 76, NULL, NULL, 120973),
(120974, '3.40.50.10330-FF-000121', NULL, 'Predicted protein', 70, NULL, NULL, 120974),
(120975, '1.10.3080.10-FF-000032', NULL, 'Chloride channel protein', 395, NULL, NULL, 120975),
(120976, '1.10.510.10-FF-001724', NULL, 'Putative WAK family receptor-like protein kinase', 146, NULL, NULL, 120976),
(120977, '3.40.30.10-FF-000012', NULL, 'Monothiol glutaredoxin', 98, NULL, NULL, 120977),
(120978, '2.40.270.10-FF-000003', NULL, 'DNA-directed RNA polymerase subunit beta', 35, NULL, NULL, 120978),
(120979, '2.60.40.10-FF-005415', NULL, NULL, 115, NULL, NULL, 120979),
(120980, '2.40.50.140-FF-000818', NULL, NULL, 118, NULL, NULL, 120980),
(120981, '3.90.228.10-FF-000053', NULL, 'Poly [ADP-ribose] polymerase', 59, NULL, NULL, 120981),
(120982, '3.40.50.20-FF-000016', NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', 109, NULL, NULL, 120982),
(120983, '3.30.160.60-FF-003291', NULL, 'Histone-lysine N-methyltransferase PRDM9', 28, NULL, NULL, 120983),
(120984, '1.10.1200.10-FF-000014', NULL, 'Multifunctional mycocerosic acid synthase', 82, NULL, NULL, 120984),
(120985, '1.10.565.10-FF-000013', NULL, 'Peroxisome proliferator-activated receptor delta', 273, NULL, NULL, 120985);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(120986, '3.80.10.10-FF-002280', NULL, 'Leucine-rich repeat protein (LRRP), putative', 259, NULL, NULL, 120986),
(120987, '3.30.160.60-FF-005409', NULL, NULL, 44, NULL, NULL, 120987),
(120988, '1.25.40.10-FF-002879', NULL, 'Uncharacterized protein', 241, NULL, NULL, 120988),
(120989, '3.20.20.80-FF-000134', NULL, 'Glycoside hydrolase', 205, NULL, NULL, 120989),
(120990, '3.30.40.10-FF-000182', NULL, 'rabphilin-3A isoform X1', 134, NULL, NULL, 120990),
(120991, '2.60.120.290-FF-000214', NULL, 'C-type LECtin', 115, NULL, NULL, 120991),
(120992, '1.25.40.10-FF-003043', NULL, 'Os06g0694300 protein', 88, NULL, NULL, 120992),
(120993, '3.30.230.10-FF-000218', NULL, 'Mitochondrial elongation factor G2', 122, NULL, NULL, 120993),
(120994, '3.40.50.12110-FF-000003', NULL, 'Possible DNA repair photolyase', 112, NULL, NULL, 120994),
(120995, '3.30.300.30-FF-000168', NULL, 'Uncharacterized protein', 122, NULL, NULL, 120995),
(120996, '3.30.160.60-FF-001609', NULL, 'Zinc finger protein 236', 23, NULL, NULL, 120996),
(120997, '2.130.10.10-FF-001565', NULL, 'Semaphorin-2A', 458, NULL, NULL, 120997),
(120998, '2.130.10.10-FF-005415', NULL, 'Uncharacterized protein', 252, NULL, NULL, 120998),
(120999, '2.60.40.1480-FF-000003', NULL, 'Coatomer subunit gamma', 175, NULL, NULL, 120999),
(121000, '3.30.470.10-FF-000056', NULL, 'Branched-chain-amino-acid aminotransferase', 67, NULL, NULL, 121000),
(121001, '1.25.40.10-FF-004824', NULL, 'Pentatricopeptide repeat-containing protein At3g46610', 149, NULL, NULL, 121001),
(121002, '3.80.10.10-FF-002369', NULL, 'At1g80630', 212, NULL, NULL, 121002),
(121003, '3.40.50.2000-FF-000265', NULL, 'D-inositol 3-phosphate glycosyltransferase', 169, NULL, NULL, 121003),
(121004, '3.40.50.300-FF-005562', NULL, 'Uncharacterized protein', 135, NULL, NULL, 121004),
(121005, '2.30.29.30-FF-000860', NULL, 'Protein loc100159627 isoform 1', 146, NULL, NULL, 121005),
(121006, '3.30.470.20-FF-000059', NULL, 'Synapsin-3', 119, NULL, NULL, 121006),
(121007, '3.20.80.10-FF-000004', NULL, 'DNA gyrase inhibitor', 157, NULL, NULL, 121007),
(121008, '3.40.50.300-FF-005814', NULL, 'Dicer Related Helicase', 245, NULL, NULL, 121008),
(121009, '1.20.58.100-FF-000005', NULL, 'Succinate dehydrogenase flavoprotein subunit', 117, NULL, NULL, 121009),
(121010, '3.40.1180.10-FF-000014', NULL, 'Uncharacterized protein', 49, NULL, NULL, 121010),
(121011, '4.10.280.10-FF-000143', NULL, 'Rtg1p', 81, NULL, NULL, 121011),
(121012, '3.30.530.20-FF-000210', NULL, 'Predicted protein', 232, NULL, NULL, 121012),
(121013, '1.25.40.10-FF-002790', NULL, 'Predicted protein', 106, NULL, NULL, 121013),
(121014, '3.40.50.300-FF-001543', NULL, 'GTPase Era', 182, NULL, NULL, 121014),
(121015, '1.10.287.370-FF-000036', NULL, 'Prefoldin, alpha subunit, putative', 133, NULL, NULL, 121015),
(121016, '3.30.1360.170-FF-000011', NULL, 'Cation efflux system protein', 199, NULL, NULL, 121016),
(121017, '2.70.150.10-FF-000021', NULL, 'Phospholipid-transporting ATPase', 168, NULL, NULL, 121017),
(121018, '2.60.40.10-FF-005437', NULL, NULL, 75, NULL, NULL, 121018),
(121019, '1.20.1740.10-FF-000120', NULL, 'Y+L amino acid transporter 2', 54, NULL, NULL, 121019),
(121020, '2.130.10.10-FF-005163', NULL, 'Predicted protein', 136, NULL, NULL, 121020),
(121021, '3.40.50.620-FF-000234', NULL, 'Methionine--tRNA ligase, putative', 127, NULL, NULL, 121021),
(121022, '2.130.10.10-FF-000958', NULL, 'Elongator acetyltransferase complex subunit 2', 314, NULL, NULL, 121022),
(121023, '2.40.290.10-FF-000004', NULL, 'Non-homologous end joining protein Ku', 174, NULL, NULL, 121023),
(121024, '1.10.287.380-FF-000039', NULL, 'Chromosome 9, whole genome shotgun sequence', 72, NULL, NULL, 121024),
(121025, '1.10.10.10-FF-001236', NULL, 'Iron dependent repressor', 65, NULL, NULL, 121025),
(121026, '2.60.40.10-FF-002003', NULL, 'Transmembrane and immunoglobulin domain containing 2', 126, NULL, NULL, 121026),
(121027, '1.20.58.110-FF-000008', NULL, '30S ribosomal protein S20', 92, NULL, NULL, 121027),
(121028, '1.25.10.10-FF-001326', NULL, 'AP complex subunit beta', 592, NULL, NULL, 121028);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(121029, '1.25.10.10-FF-001074', NULL, 'Formin like 1', 87, NULL, NULL, 121029),
(121030, '1.10.510.10-FF-003164', NULL, NULL, 168, NULL, NULL, 121030),
(121031, '2.30.31.10-FF-000011', NULL, 'RNA polymerase II transcriptional coactivator KELP', 73, NULL, NULL, 121031),
(121032, '1.10.8.140-FF-000019', NULL, 'Programmed cell death, putative', 106, NULL, NULL, 121032),
(121033, '2.30.29.30-FF-000309', NULL, 'Uncharacterized protein, isoform B', 124, NULL, NULL, 121033),
(121034, '3.40.850.10-FF-000465', NULL, 'Kinesin-like protein tea2', 366, NULL, NULL, 121034),
(121035, '2.60.120.10-FF-000246', NULL, 'Uncharacterized protein', 138, NULL, NULL, 121035),
(121036, '3.80.10.10-FF-004314', NULL, 'Uncharacterized protein', 210, NULL, NULL, 121036),
(121037, '3.30.450.20-FF-000423', NULL, 'Uncharacterized protein', 134, NULL, NULL, 121037),
(121038, '3.30.160.60-FF-003072', NULL, NULL, 28, NULL, NULL, 121038),
(121039, '3.80.10.10-FF-002841', NULL, 'Uncharacterized protein', 109, NULL, NULL, 121039),
(121040, '3.40.50.300-FF-005253', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 189, NULL, NULL, 121040),
(121041, '3.50.50.60-FF-001314', NULL, 'Amine oxidase', 143, NULL, NULL, 121041),
(121042, '2.30.29.30-FF-000298', NULL, 'FACT complex subunit SSRP1', 93, NULL, NULL, 121042),
(121043, '3.40.50.12780-FF-000215', NULL, 'Uncharacterized protein', 38, NULL, NULL, 121043),
(121044, '2.30.30.140-FF-000182', NULL, 'Transcription factor, Tudor domain, putative', 87, NULL, NULL, 121044),
(121045, '3.40.50.150-FF-001464', NULL, NULL, 135, NULL, NULL, 121045),
(121046, '2.60.120.970-FF-000120', NULL, 'Bone morphogenetic protein 7', 227, NULL, NULL, 121046),
(121047, '2.60.40.10-FF-005185', NULL, NULL, 93, NULL, NULL, 121047),
(121048, '3.30.1370.210-FF-000025', NULL, 'Zinc finger cx8-c-x5-c-x3-h type (and similar) domain-containing protein', 81, NULL, NULL, 121048),
(121049, '3.40.190.10-FF-000892', NULL, 'Transcriptional regulator LysR family', 99, NULL, NULL, 121049),
(121050, '3.30.450.60-FF-000064', NULL, 'Uncharacterized protein', 155, NULL, NULL, 121050),
(121051, '3.30.160.60-FF-001048', NULL, 'replication initiator 1 isoform X1', 28, NULL, NULL, 121051),
(121052, '3.40.50.10230-FF-000001', NULL, 'Precorrin-8X methylmutase', 208, NULL, NULL, 121052),
(121053, '1.25.10.10-FF-003108', NULL, 'Protein peg1', 218, NULL, NULL, 121053),
(121054, '3.60.10.10-FF-000408', NULL, 'Uncharacterized protein', 124, NULL, NULL, 121054),
(121055, '1.50.40.10-FF-000325', NULL, 'Uncharacterized protein', 293, NULL, NULL, 121055),
(121056, '3.20.20.20-FF-000015', NULL, 'Probable bifunctional folylpolyglutamate synthase/dihydropteroate synthase', 283, NULL, NULL, 121056),
(121057, '3.30.70.600-FF-000021', NULL, '30S ribosomal protein S10', 101, NULL, NULL, 121057),
(121058, '2.60.40.2860-FF-000007', NULL, 'Transmission-blocking target antigen S230', 119, NULL, NULL, 121058),
(121059, '2.60.40.10-FF-001694', NULL, 'Basement membrane proteoglycan', 94, NULL, NULL, 121059),
(121060, '3.40.50.1010-FF-000254', NULL, NULL, 144, NULL, NULL, 121060),
(121061, '3.40.50.720-FF-000590', NULL, 'Glucose-6-phosphate dehydrogenase', 127, NULL, NULL, 121061),
(121062, '3.40.50.720-FF-002478', NULL, 'Uncharacterized protein', 243, NULL, NULL, 121062),
(121063, '2.30.40.10-FF-000094', NULL, 'Cytosine deaminase', 77, NULL, NULL, 121063),
(121064, '3.40.50.300-FF-006669', NULL, 'Uncharacterized protein', 85, NULL, NULL, 121064),
(121065, '1.10.472.80-FF-000048', NULL, 'TBC domain containing protein', 127, NULL, NULL, 121065),
(121066, '1.10.2000.10-FF-000033', NULL, NULL, 119, NULL, NULL, 121066),
(121067, '3.20.20.10-FF-000012', NULL, 'Carboxynorspermidine/carboxyspermidine decarboxylase', 224, NULL, NULL, 121067),
(121068, '3.30.200.20-FF-001074', NULL, 'Predicted protein', 123, NULL, NULL, 121068),
(121069, '3.40.50.10240-FF-000004', NULL, 'Thiamin pyrophosphokinase 1', 228, NULL, NULL, 121069),
(121070, '3.40.50.10490-FF-000028', NULL, 'HTH-type transcriptional regulator MurR', 183, NULL, NULL, 121070),
(121071, '3.40.50.300-FF-005343', NULL, 'Anion-transporting ATPase', 259, NULL, NULL, 121071);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(121072, '2.60.40.2840-FF-000001', NULL, 'E3 ubiquitin-protein ligase HECW2 isoform X1', 106, NULL, NULL, 121072),
(121073, '3.30.160.60-FF-003852', NULL, NULL, 29, NULL, NULL, 121073),
(121074, '1.25.10.10-FF-001107', NULL, 'Serine/threonine-protein kinase TOR', 347, NULL, NULL, 121074),
(121075, '1.10.486.10-FF-000026', NULL, 'DNA helicase', 149, NULL, NULL, 121075),
(121076, '3.40.50.150-FF-001773', NULL, NULL, 199, NULL, NULL, 121076),
(121077, '1.25.40.20-FF-001808', NULL, 'Kinase, NEK', 163, NULL, NULL, 121077),
(121078, '1.10.510.10-FF-001472', NULL, 'Protein kinase, putative', 354, NULL, NULL, 121078),
(121079, '1.10.287.70-FF-000570', NULL, 'Uncharacterized protein', 130, NULL, NULL, 121079),
(121080, '1.10.3370.10-FF-000043', NULL, 'Uncharacterized protein', 183, NULL, NULL, 121080),
(121081, '3.90.550.10-FF-000032', NULL, 'xyloglucan 6-xylosyltransferase 2', 152, NULL, NULL, 121081),
(121082, '3.40.50.2000-FF-000916', NULL, 'Uncharacterized protein', 162, NULL, NULL, 121082),
(121083, '3.30.1460.20-FF-000007', NULL, 'Arp2/3 complex 34 kDa subunit', 175, NULL, NULL, 121083),
(121084, '3.80.10.10-FF-003696', NULL, 'Uncharacterized protein', 172, NULL, NULL, 121084),
(121085, '1.20.5.1430-FF-000003', NULL, 'microtubule-associated protein RP/EB family member 3 isoform X1', 82, NULL, NULL, 121085),
(121086, '1.10.287.370-FF-000020', NULL, 'Unplaced genomic scaffold supercont2.2, whole genome shotgun sequence', 130, NULL, NULL, 121086),
(121087, '1.10.10.350-FF-000030', NULL, NULL, 119, NULL, NULL, 121087),
(121088, '3.40.50.2300-FF-000692', NULL, NULL, 35, NULL, NULL, 121088),
(121089, '1.10.510.10-FF-002798', NULL, NULL, 192, NULL, NULL, 121089),
(121090, '2.130.10.10-FF-002998', NULL, 'Uncharacterized protein', 193, NULL, NULL, 121090),
(121091, '2.130.10.10-FF-003274', NULL, 'Notchless', 165, NULL, NULL, 121091),
(121092, '2.60.40.10-FF-003493', NULL, NULL, 93, NULL, NULL, 121092),
(121093, '2.10.25.10-FF-000138', NULL, 'Laminin subunit beta 1', 59, NULL, NULL, 121093),
(121094, '1.10.287.10-FF-000030', NULL, 'Related to ataxin-3', 42, NULL, NULL, 121094),
(121095, '4.10.60.10-FF-000069', NULL, 'Glycine-rich RNA-binding protein RZ1A', 61, NULL, NULL, 121095),
(121096, '1.25.40.10-FF-001805', NULL, 'Pentatricopeptide repeat-containing protein', 195, NULL, NULL, 121096),
(121097, '3.90.550.20-FF-000035', NULL, 'Uncharacterized protein', 202, NULL, NULL, 121097),
(121098, '3.10.20.10-FF-000018', NULL, 'Sulfur carrier protein FdhD', 83, NULL, NULL, 121098),
(121099, '3.10.20.90-FF-000896', NULL, 'BAG family molecular chaperone regulator 1', 78, NULL, NULL, 121099),
(121100, '2.60.40.10-FF-002689', NULL, NULL, 94, NULL, NULL, 121100),
(121101, '1.20.80.10-FF-000026', NULL, 'Enoyl-CoA delta isomerase 2, mitochondrial', 93, NULL, NULL, 121101),
(121102, '3.40.50.620-FF-000543', NULL, 'Glutamyl-Q tRNA(Asp) synthetase', 291, NULL, NULL, 121102),
(121103, '2.60.40.10-FF-005095', NULL, NULL, 99, NULL, NULL, 121103),
(121104, '2.10.25.10-FF-000380', NULL, 'EGF-containing fibulin-like extracellular matrix protein 1', 38, NULL, NULL, 121104),
(121105, '1.20.58.60-FF-000770', NULL, 'Uncharacterized protein', 317, NULL, NULL, 121105),
(121106, '3.40.50.1220-FF-000093', NULL, 'NAD-dependent protein deacylase SIR2rp2', 141, NULL, NULL, 121106),
(121107, '3.40.50.300-FF-003089', NULL, 'Rab family GTPase', 179, NULL, NULL, 121107),
(121108, '2.60.40.3210-FF-000011', NULL, 'Placenta-specific protein 1', 120, NULL, NULL, 121108),
(121109, '3.30.420.10-FF-000671', NULL, NULL, 173, NULL, NULL, 121109),
(121110, '3.30.1370.50-FF-000032', NULL, 'Uncharacterized protein', 84, NULL, NULL, 121110),
(121111, '3.30.40.10-FF-000378', NULL, 'TRAF-type zinc finger domain-containing 1', 56, NULL, NULL, 121111),
(121112, '1.10.8.60-FF-000423', NULL, 'DNA polymerase III subunit delta', 68, NULL, NULL, 121112),
(121113, '2.60.120.330-FF-000029', NULL, 'KAR-UP oxidoreductase 1', 304, NULL, NULL, 121113),
(121114, '3.30.70.330-FF-003121', NULL, NULL, 128, NULL, NULL, 121114),
(121115, '3.30.413.10-FF-000008', NULL, 'Sulfite reductase [ferredoxin], chloroplastic', 210, NULL, NULL, 121115);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(121116, '2.60.40.10-FF-004111', NULL, NULL, 93, NULL, NULL, 121116),
(121117, '2.60.120.200-FF-000592', NULL, 'Collagen type XVI alpha 1 chain', 221, NULL, NULL, 121117),
(121118, '3.30.499.10-FF-000032', NULL, NULL, 172, NULL, NULL, 121118),
(121119, '3.80.10.10-FF-000571', NULL, 'Kek6, isoform B', 114, NULL, NULL, 121119),
(121120, '1.10.20.140-FF-000025', NULL, NULL, 75, NULL, NULL, 121120),
(121121, '2.30.150.10-FF-000002', NULL, 'DNA-directed RNA polymerase subunit beta', 69, NULL, NULL, 121121),
(121122, '3.40.50.460-FF-000040', NULL, 'Uncharacterized protein', 145, NULL, NULL, 121122),
(121123, '1.10.1300.10-FF-000067', NULL, 'Uncharacterized protein', 129, NULL, NULL, 121123),
(121124, '1.25.40.20-FF-001466', NULL, 'Uncharacterized protein', 110, NULL, NULL, 121124),
(121125, '4.10.1060.10-FF-000062', NULL, 'Uncharacterized protein', 32, NULL, NULL, 121125),
(121126, '3.80.10.10-FF-004387', NULL, 'NACHT, LRR and PYD domains-containing protein 3', 168, NULL, NULL, 121126),
(121127, '2.20.100.10-FF-000136', NULL, 'SPONdin (Extracellular matrix glycoprotein) family', 57, NULL, NULL, 121127),
(121128, '1.20.1080.10-FF-000108', NULL, 'Uncharacterized protein', 153, NULL, NULL, 121128),
(121129, '4.10.110.10-FF-000013', NULL, 'Uncharacterized protein', 69, NULL, NULL, 121129),
(121130, '1.25.40.180-FF-000211', NULL, NULL, 194, NULL, NULL, 121130),
(121131, '2.30.42.10-FF-000385', NULL, NULL, 110, NULL, NULL, 121131),
(121132, '3.50.30.30-FF-000051', NULL, 'Extracellular serine protease', 126, NULL, NULL, 121132),
(121133, '3.30.465.10-FF-000089', NULL, 'Protein CBG09729', 227, NULL, NULL, 121133),
(121134, '3.80.10.10-FF-002370', NULL, 'GH01279p', 210, NULL, NULL, 121134),
(121135, '3.30.1460.10-FF-000004', NULL, 'Type III secretion chaperone SycN', 123, NULL, NULL, 121135),
(121136, '3.40.50.300-FF-003544', NULL, 'Arl_B38 protein', 163, NULL, NULL, 121136),
(121137, '1.20.5.110-FF-000025', NULL, 'Putative WASH complex subunit CCDC53', 55, NULL, NULL, 121137),
(121138, '1.20.1250.20-FF-000237', NULL, 'Solute carrier family 2 (Facilitated glucose transporter), member 12', 133, NULL, NULL, 121138),
(121139, '1.10.555.10-FF-000260', NULL, NULL, 105, NULL, NULL, 121139),
(121140, '1.20.5.170-FF-000127', NULL, 'Protein CBR-ATF-2', 72, NULL, NULL, 121140),
(121141, '3.20.20.300-FF-000081', NULL, NULL, 190, NULL, NULL, 121141),
(121142, '2.30.42.10-FF-000637', NULL, NULL, 64, NULL, NULL, 121142),
(121143, '1.10.287.3240-FF-000005', NULL, 'coiled-coil domain-containing protein 115', 170, NULL, NULL, 121143),
(121144, '3.90.20.20-FF-000006', NULL, 'GrpE protein homolog', 117, NULL, NULL, 121144),
(121145, '2.40.50.140-FF-000476', NULL, '26S proteasome regulatory subunit 8', 58, NULL, NULL, 121145),
(121146, '1.25.40.10-FF-001463', NULL, 'tetratricopeptide repeat protein 30 homolog', 63, NULL, NULL, 121146),
(121147, '1.25.40.20-FF-001718', NULL, 'Inhibitor of Bruton tyrosine kinase', 43, NULL, NULL, 121147),
(121148, '3.30.160.60-FF-005090', NULL, NULL, 23, NULL, NULL, 121148),
(121149, '1.20.5.100-FF-000022', NULL, 'Ubiquinol-cytochrome c reductase cytochrome c1 subunit', 39, NULL, NULL, 121149),
(121150, '3.40.50.720-FF-000932', NULL, '3-oxoacyl-[acyl-carrier protein] reductase', 248, NULL, NULL, 121150),
(121151, '1.25.40.20-FF-001921', NULL, 'Ion channel NompC', 258, NULL, NULL, 121151),
(121152, '3.40.50.10470-FF-000022', NULL, 'Translation initiation factor EIF-2b alpha subunit, putative', 203, NULL, NULL, 121152),
(121153, '3.40.250.10-FF-000262', NULL, 'ACR158Wp', 141, NULL, NULL, 121153),
(121154, '2.60.300.12-FF-000004', NULL, 'Fe/S biogenesis protein NfuA', 98, NULL, NULL, 121154),
(121155, '2.130.10.10-FF-003145', NULL, 'Uncharacterized protein', 180, NULL, NULL, 121155),
(121156, '3.40.710.10-FF-000157', NULL, 'Penicillin-binding protein, 1A family', 241, NULL, NULL, 121156),
(121157, '1.20.1430.10-FF-000001', NULL, '1,4-alpha-glucan branching enzyme TK1436', 110, NULL, NULL, 121157),
(121158, '1.10.238.10-FF-000967', NULL, 'EHS-1', 95, NULL, NULL, 121158),
(121159, '1.10.8.60-FF-000204', NULL, 'Replication factor C subunit 5', 64, NULL, NULL, 121159);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(121160, '3.40.50.720-FF-000680', NULL, 'AflX/ ordB/ monooxygenase/ oxidase', 225, NULL, NULL, 121160),
(121161, '1.20.1250.10-FF-000144', NULL, NULL, 163, NULL, NULL, 121161),
(121162, '3.40.50.300-FF-007383', NULL, 'atlastin-2', 311, NULL, NULL, 121162),
(121163, '2.10.70.10-FF-000231', NULL, 'Uncharacterized protein', 64, NULL, NULL, 121163),
(121164, '1.25.40.10-FF-001244', NULL, 'HCP-like protein', 181, NULL, NULL, 121164),
(121165, '1.10.287.520-FF-000008', NULL, 'Uncharacterized protein', 66, NULL, NULL, 121165),
(121166, '2.130.10.10-FF-003055', NULL, 'Transducin-like protein', 140, NULL, NULL, 121166),
(121167, '3.30.300.30-FF-000062', NULL, 'RfbL protein', 101, NULL, NULL, 121167),
(121168, '2.30.280.10-FF-000006', NULL, NULL, 213, NULL, NULL, 121168),
(121169, '1.10.10.10-FF-001455', NULL, 'VIRF-1', 108, NULL, NULL, 121169),
(121170, '3.30.420.40-FF-001085', NULL, 'Uncharacterized protein', 114, NULL, NULL, 121170),
(121171, '3.40.50.300-FF-008001', NULL, 'Uncharacterized protein', 150, NULL, NULL, 121171),
(121172, '1.20.1250.20-FF-000147', NULL, 'Protein NRT1/ PTR family 5.10', 548, NULL, NULL, 121172),
(121173, '2.170.300.10-FF-000088', NULL, 'Uncharacterized protein', 101, NULL, NULL, 121173),
(121174, '1.25.40.10-FF-004897', NULL, 'Uncharacterized protein', 90, NULL, NULL, 121174),
(121175, '3.75.10.10-FF-000027', NULL, NULL, 126, NULL, NULL, 121175),
(121176, '2.60.40.10-FF-003616', NULL, NULL, 88, NULL, NULL, 121176),
(121177, '2.60.40.10-FF-002998', NULL, 'AGAP003656-PB', 92, NULL, NULL, 121177),
(121178, '1.20.1270.60-FF-000109', NULL, 'Rho-GTPase-activating protein RGD2', 144, NULL, NULL, 121178),
(121179, '3.40.50.2300-FF-000782', NULL, NULL, 112, NULL, NULL, 121179),
(121180, '1.25.40.20-FF-000994', NULL, 'Ankyrin repeat family protein', 303, NULL, NULL, 121180),
(121181, '3.30.160.320-FF-000001', NULL, 'Antimicrobial protein 1', 104, NULL, NULL, 121181),
(121182, '3.30.200.20-FF-001220', NULL, 'ABL protein', 42, NULL, NULL, 121182),
(121183, '2.40.50.1020-FF-000022', NULL, 'Carbon monoxide dehydrogenase operon C protein', 112, NULL, NULL, 121183),
(121184, '3.40.50.360-FF-000009', NULL, 'NADPH--cytochrome P450 reductase', 180, NULL, NULL, 121184),
(121185, '3.40.1190.20-FF-000208', NULL, NULL, 75, NULL, NULL, 121185),
(121186, '2.130.10.10-FF-003583', NULL, 'CDH1-B', 187, NULL, NULL, 121186),
(121187, '1.10.287.70-FF-000660', NULL, 'Uncharacterized protein', 134, NULL, NULL, 121187),
(121188, '2.30.39.10-FF-000023', NULL, 'SeRPin', 123, NULL, NULL, 121188),
(121189, '3.30.160.60-FF-001812', NULL, 'Uncharacterized protein', 27, NULL, NULL, 121189),
(121190, '3.20.20.100-FF-000099', NULL, 'Oxidoreductase, aldo/keto reductase family protein', 459, NULL, NULL, 121190),
(121191, '3.30.70.270-FF-000219', NULL, NULL, 91, NULL, NULL, 121191),
(121192, '1.20.5.110-FF-000115', NULL, 'Protein transport protein SEC22', 86, NULL, NULL, 121192),
(121193, '1.10.640.10-FF-000082', NULL, 'Uncharacterized protein', 219, NULL, NULL, 121193),
(121194, '4.10.400.10-FF-000114', NULL, 'Suppressor of tumorigenicity 14 protein homolog', 37, NULL, NULL, 121194),
(121195, '1.20.930.10-FF-000023', NULL, 'Transcription elongation factor (TFIIS) family protein', 86, NULL, NULL, 121195),
(121196, '3.10.129.10-FF-000049', NULL, 'PaaI family thioesterase', 145, NULL, NULL, 121196),
(121197, '1.25.40.10-FF-000991', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 73, NULL, NULL, 121197),
(121198, '1.25.40.10-FF-004588', NULL, 'Uncharacterized protein', 173, NULL, NULL, 121198),
(121199, '2.20.25.350-FF-000001', NULL, 'Eukaryotic translation initiation factor 5', 41, NULL, NULL, 121199),
(121200, '3.50.50.60-FF-000842', NULL, 'Protoporphyrinogen oxidase', 156, NULL, NULL, 121200),
(121201, '3.10.129.10-FF-000291', NULL, 'Uncharacterized protein', 208, NULL, NULL, 121201),
(121202, '3.30.160.60-FF-000053', NULL, 'zinc finger protein 182 isoform X1', 28, NULL, NULL, 121202),
(121203, '2.40.70.10-FF-000556', NULL, NULL, 200, NULL, NULL, 121203),
(121204, '3.40.50.720-FF-000371', NULL, 'Inositol-3-phosphate synthase', 278, NULL, NULL, 121204); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(121205, '3.80.10.10-FF-000790', NULL, 'Leucine-rich repeat receptor-like protein kinase PEPR1', 79, NULL, NULL, 121205),
(121206, '3.40.1410.10-FF-000033', NULL, 'Probable chorismate pyruvate-lyase', 167, NULL, NULL, 121206),
(121207, '3.40.50.300-FF-003454', NULL, 'Translation initiation factor IF-2, putative', 249, NULL, NULL, 121207),
(121208, '3.40.1280.10-FF-000089', NULL, 'Uncharacterized protein', 111, NULL, NULL, 121208),
(121209, '1.10.20.10-FF-000101', NULL, 'Transcriptional activator SPT7', 93, NULL, NULL, 121209),
(121210, '3.40.50.2300-FF-000473', NULL, 'Uncharacterized protein', 24, NULL, NULL, 121210),
(121211, '3.30.160.60-FF-004937', NULL, NULL, 35, NULL, NULL, 121211),
(121212, '3.30.2130.30-FF-000025', NULL, 'THUMP domain-containing 2', 124, NULL, NULL, 121212),
(121213, '1.20.1160.20-FF-000011', NULL, 'Regulator of telomere elongation helicase 1 homolog', 93, NULL, NULL, 121213),
(121214, '1.20.58.1070-FF-000002', NULL, 'Survival motor neuron containing protein', 149, NULL, NULL, 121214),
(121215, '3.30.760.10-FF-000067', NULL, 'Eukaryotic translation initiation factor 4E family member 1c', 117, NULL, NULL, 121215),
(121216, '3.30.40.10-FF-000288', NULL, 'Probable E3 ubiquitin ligase SUD1', 74, NULL, NULL, 121216),
(121217, '2.60.40.10-FF-003307', NULL, 'Leukemia inhibitory factor receptor alpha b', 80, NULL, NULL, 121217),
(121218, '3.40.50.620-FF-000088', NULL, 'Ethanolamine-phosphate cytidylyltransferase isoform 2', 170, NULL, NULL, 121218),
(121219, '2.40.30.170-FF-000054', NULL, NULL, 67, NULL, NULL, 121219),
(121220, '3.90.79.20-FF-000006', NULL, 'Zinc finger protein', 126, NULL, NULL, 121220),
(121221, '3.40.50.1820-FF-000429', NULL, 'Alpha/beta hydrolase', 108, NULL, NULL, 121221),
(121222, '3.40.50.300-FF-007692', NULL, 'Protein CBG10112', 107, NULL, NULL, 121222),
(121223, '3.40.50.2020-FF-000113', NULL, 'Probable adenine phosphoribosyltransferase', 195, NULL, NULL, 121223),
(121224, '3.30.900.10-FF-000056', NULL, 'Him-Three Paralog', 224, NULL, NULL, 121224),
(121225, '2.10.50.10-FF-000123', NULL, 'Uncharacterized protein', 60, NULL, NULL, 121225),
(121226, '1.25.10.20-FF-000025', NULL, 'Vitellogenin 7', 127, NULL, NULL, 121226),
(121227, '3.30.750.24-FF-000119', NULL, 'Solute carrier family 26 member 10', 78, NULL, NULL, 121227),
(121228, '2.60.40.10-FF-002779', NULL, 'Short-form leptin receptor 1', 108, NULL, NULL, 121228),
(121229, '1.20.58.1080-FF-000005', NULL, 'Mitochondrial ATP-dependent RNA helicase Suv3, putative', 113, NULL, NULL, 121229),
(121230, '1.20.5.170-FF-000094', NULL, 'Beaded filament structural protein 1', 84, NULL, NULL, 121230),
(121231, '1.10.390.10-FF-000101', NULL, 'Uncharacterized protein', 74, NULL, NULL, 121231),
(121232, '1.20.58.1770-FF-000004', NULL, 'Rab interacting lysosomal protein', 84, NULL, NULL, 121232),
(121233, '2.20.100.10-FF-000226', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs gon-1', 56, NULL, NULL, 121233),
(121234, '1.25.40.10-FF-005206', NULL, 'PH domain containing protein', 204, NULL, NULL, 121234),
(121235, '3.30.70.270-FF-000129', NULL, 'GGDEF family protein', 163, NULL, NULL, 121235),
(121236, '1.20.1250.20-FF-000708', NULL, 'Unplaced genomic scaffold supercont1.134, whole genome shotgun sequence', 418, NULL, NULL, 121236),
(121237, '1.10.260.40-FF-000073', NULL, 'transcription factor protein', 59, NULL, NULL, 121237),
(121238, '3.40.50.2300-FF-001400', NULL, NULL, 129, NULL, NULL, 121238),
(121239, '1.20.1070.10-FF-000686', NULL, '5-hydroxytryptamine receptor 7', 186, NULL, NULL, 121239),
(121240, '2.40.50.140-FF-000947', NULL, NULL, 77, NULL, NULL, 121240),
(121241, '3.40.50.2000-FF-000720', NULL, 'Lipopolysaccharide heptosyltransferase-1', 148, NULL, NULL, 121241),
(121242, '1.20.1250.20-FF-000456', NULL, 'Solute carrier family 45 member 2', 151, NULL, NULL, 121242),
(121243, '1.10.580.10-FF-000003', NULL, 'Citrate synthase 2', 141, NULL, NULL, 121243),
(121244, '2.130.10.10-FF-003616', NULL, 'EF hand family protein', 250, NULL, NULL, 121244),
(121245, '3.30.160.60-FF-001503', NULL, 'zinc finger protein 33B isoform X2', 28, NULL, NULL, 121245);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(121246, '3.10.20.710-FF-000003', NULL, 'DNA-binding protein SATB', 52, NULL, NULL, 121246),
(121247, '2.130.10.10-FF-003364', NULL, 'Uncharacterized protein', 306, NULL, NULL, 121247),
(121248, '3.40.50.1820-FF-000738', NULL, 'Probable protein phosphatase methylesterase 1', 294, NULL, NULL, 121248),
(121249, '3.30.70.1730-FF-000017', NULL, '60S acidic ribosomal protein P0', 132, NULL, NULL, 121249),
(121250, '3.30.160.20-FF-000103', NULL, 'Ribonuclease 3', 77, NULL, NULL, 121250),
(121251, '1.25.40.20-FF-001247', NULL, 'Uncharacterized protein', 355, NULL, NULL, 121251),
(121252, '3.40.50.10190-FF-000062', NULL, 'Pebble, isoform C', 95, NULL, NULL, 121252),
(121253, '2.10.25.10-FF-000470', NULL, 'Stabilin 2', 42, NULL, NULL, 121253),
(121254, '3.30.70.330-FF-003031', NULL, NULL, 50, NULL, NULL, 121254),
(121255, '2.10.70.10-FF-000012', NULL, 'Seizure related 6 homolog like', 63, NULL, NULL, 121255),
(121256, '3.80.10.10-FF-004168', NULL, 'Uncharacterized protein', 274, NULL, NULL, 121256),
(121257, '1.10.10.500-FF-000002', NULL, 'Prospero homeobox 3', 169, NULL, NULL, 121257),
(121258, '3.30.160.60-FF-004105', NULL, NULL, 28, NULL, NULL, 121258),
(121259, '1.20.1270.60-FF-000019', NULL, 'rho GTPase-activating protein 17 isoform X1', 243, NULL, NULL, 121259),
(121260, '3.30.70.260-FF-000126', NULL, 'Homoserine dehydrogenase', 74, NULL, NULL, 121260),
(121261, '3.50.50.60-FF-000932', NULL, 'Nitrate reductase, NADH oxidase subunit', 169, NULL, NULL, 121261),
(121262, '1.25.40.10-FF-004678', NULL, 'Pentatricopeptide repeat-containing protein', 108, NULL, NULL, 121262),
(121263, '1.10.555.10-FF-000041', NULL, 'Rho GTPase activator (Rgd1)', 198, NULL, NULL, 121263),
(121264, '2.60.40.10-FF-003184', NULL, 'Alpha-2-macroglobulin-like', 86, NULL, NULL, 121264),
(121265, '3.65.10.20-FF-000002', NULL, 'GM19193', 229, NULL, NULL, 121265),
(121266, '3.60.10.10-FF-000066', NULL, 'Inositol polyphosphate-5-phosphatase Kb', 346, NULL, NULL, 121266),
(121267, '3.40.50.300-FF-005803', NULL, 'Interferon-induced with helicase C domain 1', 31, NULL, NULL, 121267),
(121268, '2.60.40.60-FF-000978', NULL, 'Uncharacterized protein', 108, NULL, NULL, 121268),
(121269, '2.160.20.10-FF-000328', NULL, 'Uncharacterized protein', 124, NULL, NULL, 121269),
(121270, '3.30.1550.10-FF-000017', NULL, 'Uncharacterized protein', 81, NULL, NULL, 121270),
(121271, '1.10.630.10-FF-000132', NULL, 'Benzoate 4-monooxygenase cytochrome P450', 443, NULL, NULL, 121271),
(121272, '3.30.479.20-FF-000039', NULL, 'Elongation factor Ts', 41, NULL, NULL, 121272),
(121273, '3.40.50.150-FF-000031', NULL, 'Putative Histone-arginine methyltransferase CARM1', 145, NULL, NULL, 121273),
(121274, '3.40.50.170-FF-000037', NULL, 'Phosphoribosylglycinamide formyltransferase', 207, NULL, NULL, 121274),
(121275, '2.10.25.10-FF-001779', NULL, 'Uncharacterized protein', 96, NULL, NULL, 121275),
(121276, '1.20.900.10-FF-000072', NULL, 'Putative Rho guanine nucleotide exchange factor FGD-1', 205, NULL, NULL, 121276),
(121277, '2.170.130.10-FF-000075', NULL, NULL, 126, NULL, NULL, 121277),
(121278, '3.40.50.1360-FF-000027', NULL, '6-phosphogluconolactonase', 266, NULL, NULL, 121278),
(121279, '3.30.70.330-FF-000389', NULL, 'RNA binding motif protein 19', 126, NULL, NULL, 121279),
(121280, '3.40.190.10-FF-000774', NULL, 'Oligopeptide Binding Lipoprotein', 327, NULL, NULL, 121280),
(121281, '2.10.25.10-FF-000256', NULL, 'Signal peptide, CUB domain and EGF like domain containing 2', 52, NULL, NULL, 121281),
(121282, '3.30.40.10-FF-000939', NULL, 'TFIIH basal transcription factor complex p44 subunit, putative', 72, NULL, NULL, 121282),
(121283, '3.40.630.30-FF-000331', NULL, 'GCN5-related N-acetyltransferase-like', 159, NULL, NULL, 121283),
(121284, '1.10.150.50-FF-000101', NULL, 'Sterile alpha and TIR motif-containing protein tir-1', 71, NULL, NULL, 121284),
(121285, '1.50.10.10-FF-000172', NULL, 'Uncharacterized protein', 419, NULL, NULL, 121285),
(121286, '1.10.600.10-FF-000079', NULL, '2-methylisoborneol synthase', 320, NULL, NULL, 121286),
(121287, '3.10.20.90-FF-000300', NULL, 'UV excision repair protein Rad23', 74, NULL, NULL, 121287);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(121288, '3.60.130.10-FF-000092', NULL, 'Clavaminate synthase-like protein', 210, NULL, NULL, 121288),
(121289, '1.25.40.1040-FF-000016', NULL, 'N-alpha-acetyltransferase 16, NatA auxiliary subunit isoform X6', 372, NULL, NULL, 121289),
(121290, '3.40.50.410-FF-000047', NULL, 'von Willebrand factor A domain containing 2', 189, NULL, NULL, 121290),
(121291, '3.40.50.2300-FF-000916', NULL, NULL, 188, NULL, NULL, 121291),
(121292, '3.30.40.10-FF-000844', NULL, 'E3 ubiquitin-protein ligase RNF187', 110, NULL, NULL, 121292),
(121293, '1.20.1250.20-FF-002148', NULL, 'Putative transport protein', 198, NULL, NULL, 121293),
(121294, '1.10.238.20-FF-000037', NULL, 'AGAP000580-PA', 120, NULL, NULL, 121294),
(121295, '3.30.160.60-FF-001604', NULL, 'Zinc finger and SCAN domain containing 1', 27, NULL, NULL, 121295),
(121296, '2.40.50.1070-FF-000014', NULL, 'GD12311', 171, NULL, NULL, 121296),
(121297, '3.40.50.150-FF-001554', NULL, NULL, 79, NULL, NULL, 121297),
(121298, '3.80.10.10-FF-004281', NULL, 'Uncharacterized protein', 255, NULL, NULL, 121298),
(121299, '1.25.40.1030-FF-000013', NULL, 'Protein transport protein sec16', 401, NULL, NULL, 121299),
(121300, '1.10.1300.10-FF-000084', NULL, 'Uncharacterized protein', 268, NULL, NULL, 121300),
(121301, '3.30.70.1230-FF-000053', NULL, 'Guanylate cyclase, putative', 224, NULL, NULL, 121301),
(121302, '2.170.8.10-FF-000018', NULL, 'Phosphoenol pyruvate carboxykinase, putative', 25, NULL, NULL, 121302),
(121303, '3.10.390.10-FF-000009', NULL, 'Histone-lysine N-methyltransferase', 85, NULL, NULL, 121303),
(121304, '3.30.160.60-FF-005292', NULL, NULL, 30, NULL, NULL, 121304),
(121305, '3.30.160.60-FF-001593', NULL, 'Zinc finger protein 513a', 27, NULL, NULL, 121305),
(121306, '3.40.1110.10-FF-000206', NULL, 'Phospholipid-transporting ATPase IIB, putative', 125, NULL, NULL, 121306),
(121307, '1.25.40.10-FF-004583', NULL, 'Pentatricopeptide repeat-containing protein At5g59600', 175, NULL, NULL, 121307),
(121308, '1.20.1260.10-FF-000077', NULL, 'Predicted protein', 146, NULL, NULL, 121308),
(121309, '2.40.37.10-FF-000018', NULL, 'S-adenosylmethionine decarboxylase/ornithine decarboxylase', 150, NULL, NULL, 121309),
(121310, '3.30.1930.10-FF-000001', NULL, 'Major capsid protein E', 125, NULL, NULL, 121310),
(121311, '3.90.320.10-FF-000009', NULL, 'Exonuclease V, mitochondrial, putative', 203, NULL, NULL, 121311),
(121312, '2.130.10.10-FF-003162', NULL, 'Predicted protein', 113, NULL, NULL, 121312),
(121313, '3.40.50.1820-FF-000424', NULL, 'YDL057W-like protein', 255, NULL, NULL, 121313),
(121314, '3.80.10.10-FF-000582', NULL, 'NLR family CARD domain containing 3', 83, NULL, NULL, 121314),
(121315, '1.25.40.10-FF-005184', NULL, 'Uncharacterized protein', 408, NULL, NULL, 121315),
(121316, '1.20.1730.10-FF-000052', NULL, 'High affinity choline transporter, putative', 168, NULL, NULL, 121316),
(121317, '2.60.40.10-FF-005319', NULL, NULL, 78, NULL, NULL, 121317),
(121318, '2.130.10.10-FF-005511', NULL, 'Uncharacterized WD repeat-containing protein C1306.02', 86, NULL, NULL, 121318),
(121319, '3.40.50.300-FF-001425', NULL, 'Dynamin GTPase, putative', 361, NULL, NULL, 121319),
(121320, '2.30.29.30-FF-000972', NULL, 'Pleckstrin homology domain-containing family A member 8', 98, NULL, NULL, 121320),
(121321, '2.10.70.10-FF-000220', NULL, 'Protein lev-9', 61, NULL, NULL, 121321),
(121322, '3.40.50.10190-FF-000056', NULL, 'Pescadillo homolog', 100, NULL, NULL, 121322),
(121323, '3.30.70.330-FF-002643', NULL, NULL, 173, NULL, NULL, 121323),
(121324, '3.40.50.150-FF-001228', NULL, NULL, 112, NULL, NULL, 121324),
(121325, '2.60.40.10-FF-001481', NULL, 'CD101 molecule', 124, NULL, NULL, 121325),
(121326, '3.60.20.40-FF-000002', NULL, 'gamma-glutamyltransferase 7', 189, NULL, NULL, 121326),
(121327, '3.40.30.50-FF-000001', NULL, '15 kDa selenoprotein', 75, NULL, NULL, 121327),
(121328, '1.10.287.3240-FF-000016', NULL, 'V-type ATPase d subunit putative', 212, NULL, NULL, 121328),
(121329, '3.40.50.720-FF-000573', NULL, 'GDP-mannose 6-dehydrogenase', 202, NULL, NULL, 121329);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(121330, '3.40.50.10490-FF-000039', NULL, 'Glucose-6-phosphate isomerase', 222, NULL, NULL, 121330),
(121331, '3.10.450.50-FF-000066', NULL, 'Nuclear transport factor 2 (NTF2) family protein with RNA binding (RRM-RBD-RNP motifs) domain', 133, NULL, NULL, 121331),
(121332, '2.150.10.10-FF-000007', NULL, 'Bifunctional hemolysin/adenylate cyclase', 147, NULL, NULL, 121332),
(121333, '3.90.640.10-FF-000168', NULL, 'Actin-related protein 5', 44, NULL, NULL, 121333),
(121334, '1.20.1560.10-FF-000347', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 381, NULL, NULL, 121334),
(121335, '3.40.50.1820-FF-000750', NULL, 'Valacyclovir hydrolase, putative', 271, NULL, NULL, 121335),
(121336, '3.40.50.2000-FF-000607', NULL, 'UDP-glucose iridoid glucosyltransferase', 233, NULL, NULL, 121336),
(121337, '3.20.100.30-FF-000003', NULL, 'Vacuolar transporter chaperone 4 catalytic subunit, putative', 293, NULL, NULL, 121337),
(121338, '1.10.3860.10-FF-000002', NULL, 'Amino acid transporter', 467, NULL, NULL, 121338),
(121339, '3.30.70.340-FF-000021', NULL, NULL, 70, NULL, NULL, 121339),
(121340, '3.10.310.40-FF-000002', NULL, 'alanine--tRNA ligase, cytoplasmic', 107, NULL, NULL, 121340),
(121341, '3.30.1330.30-FF-000130', NULL, 'Uncharacterized protein', 115, NULL, NULL, 121341),
(121342, '1.10.8.10-FF-000313', NULL, 'Predicted protein', 83, NULL, NULL, 121342),
(121343, '3.90.1580.10-FF-000033', NULL, 'Uncharacterized protein', 149, NULL, NULL, 121343),
(121344, '2.30.39.10-FF-000028', NULL, 'Uncharacterized protein', 153, NULL, NULL, 121344),
(121345, '3.40.50.1460-FF-000041', NULL, 'DRaptor', 214, NULL, NULL, 121345),
(121346, '3.30.930.10-FF-000114', NULL, 'Glycine-tRNA ligase', 207, NULL, NULL, 121346),
(121347, '2.20.100.10-FF-000125', NULL, 'Circumsporozoite-and TRAP-related protein', 61, NULL, NULL, 121347),
(121348, '2.40.50.140-FF-000835', NULL, NULL, 82, NULL, NULL, 121348),
(121349, '3.40.50.720-FF-000359', NULL, 'hydroxysteroid 11-beta-dehydrogenase 1-like protein isoform X1', 270, NULL, NULL, 121349),
(121350, '3.20.20.190-FF-000081', NULL, 'Glycosylphosphatidylinositol-specific phospholipase C', 327, NULL, NULL, 121350),
(121351, '1.25.40.20-FF-001825', NULL, 'Uncharacterized protein', 153, NULL, NULL, 121351),
(121352, '2.10.25.10-FF-000582', NULL, 'sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', 29, NULL, NULL, 121352),
(121353, '2.60.120.920-FF-000122', NULL, 'F-box/SPRY domain-containing protein 1', 172, NULL, NULL, 121353),
(121354, '1.10.510.10-FF-001483', NULL, 'Serine/threonine protein kinase US3', 257, NULL, NULL, 121354),
(121355, '1.25.40.10-FF-003060', NULL, 'Pentatricopeptide repeat-containing protein At5g11310, mitochondrial', 227, NULL, NULL, 121355),
(121356, '3.90.1720.10-FF-000022', NULL, 'Phage tail fiber protein', 124, NULL, NULL, 121356),
(121357, '1.50.40.10-FF-000106', NULL, 'NAD+ transporter', 128, NULL, NULL, 121357),
(121358, '3.30.160.60-FF-003728', NULL, NULL, 33, NULL, NULL, 121358),
(121359, '3.40.50.1820-FF-000519', NULL, 'Protein CBG05033', 582, NULL, NULL, 121359),
(121360, '2.60.120.200-FF-000474', NULL, 'Uncharacterized protein', 157, NULL, NULL, 121360),
(121361, '1.20.1250.20-FF-000703', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 446, NULL, NULL, 121361),
(121362, '3.40.630.20-FF-000002', NULL, 'Pyroglutamyl-peptidase 1', 205, NULL, NULL, 121362),
(121363, '3.40.140.100-FF-000002', NULL, 'Ubiquitin-like modifier-activating enzyme atg7', 140, NULL, NULL, 121363),
(121364, '1.10.510.10-FF-003411', NULL, NULL, 296, NULL, NULL, 121364),
(121365, '3.30.54.20-FF-000008', NULL, 'Alanine--tRNA ligase', 56, NULL, NULL, 121365),
(121366, '1.10.287.210-FF-000005', NULL, 'Envelope glycoprotein', 105, NULL, NULL, 121366),
(121367, '1.25.40.10-FF-001822', NULL, 'Pentatricopeptide repeat-containing family protein', 115, NULL, NULL, 121367),
(121368, '1.20.1070.10-FF-000602', NULL, 'Predicted protein', 342, NULL, NULL, 121368),
(121369, '3.40.640.10-FF-000298', NULL, 'Glycine cleavage system P-protein', 256, NULL, NULL, 121369);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(121370, '3.30.70.360-FF-000027', NULL, 'N-carbamoyl-L-amino acid hydrolase', 114, NULL, NULL, 121370),
(121371, '3.30.190.20-FF-000037', NULL, 'Predicted protein', 98, NULL, NULL, 121371),
(121372, '3.40.630.30-FF-000005', NULL, 'Ribosomal protein alanine acetyltransferase', 179, NULL, NULL, 121372),
(121373, '3.30.160.60-FF-000070', NULL, 'zinc finger protein 689 isoform X1', 28, NULL, NULL, 121373),
(121374, '1.20.1560.10-FF-000561', NULL, 'Multidrug resistance protein 1, putative', 303, NULL, NULL, 121374),
(121375, '2.60.40.420-FF-000093', NULL, 'Copper-containing nitrite reductase', 311, NULL, NULL, 121375),
(121376, '3.40.50.10190-FF-000270', NULL, 'DNA topoisomerase 2-binding protein 1-A', 98, NULL, NULL, 121376),
(121377, '1.10.287.1060-FF-000003', NULL, 'Alpha-(1,6)-fucosyltransferase', 67, NULL, NULL, 121377),
(121378, '1.25.10.10-FF-002838', NULL, 'Uncharacterized protein', 179, NULL, NULL, 121378),
(121379, '1.25.10.10-FF-003232', NULL, 'Protein aardvark', 252, NULL, NULL, 121379),
(121380, '1.20.1450.10-FF-000002', NULL, 'Ammonia monooxygenase subunit A', 209, NULL, NULL, 121380),
(121381, '1.10.10.10-FF-001573', NULL, 'Transcriptional regulator', 71, NULL, NULL, 121381),
(121382, '3.30.160.60-FF-001267', NULL, 'Zinc finger protein 236', 24, NULL, NULL, 121382),
(121383, '1.20.58.900-FF-000037', NULL, 'RUN domaincontaining protein', 107, NULL, NULL, 121383),
(121384, '3.40.50.300-FF-004977', NULL, 'Predicted protein', 203, NULL, NULL, 121384),
(121385, '2.30.29.30-FF-000551', NULL, 'Inactive tyrosine-protein kinase kin-32', 109, NULL, NULL, 121385),
(121386, '3.40.630.40-FF-000008', NULL, 'N-acetylmuramoyl-L-alanine amidase LytC', 218, NULL, NULL, 121386),
(121387, '3.40.50.2300-FF-000579', NULL, 'Uncharacterized protein', 212, NULL, NULL, 121387),
(121388, '2.40.50.140-FF-001083', NULL, NULL, 80, NULL, NULL, 121388),
(121389, '1.20.5.1030-FF-000001', NULL, 'Preprotein translocase subunit SecE', 57, NULL, NULL, 121389),
(121390, '3.50.50.60-FF-001224', NULL, 'Uncharacterized protein', 243, NULL, NULL, 121390),
(121391, '1.20.930.10-FF-000006', NULL, 'Serine/threonine-protein phosphatase 1 regulatory subunit 10', 116, NULL, NULL, 121391),
(121392, '1.20.5.110-FF-000132', NULL, 'Syntaxin 8', 62, NULL, NULL, 121392),
(121393, '3.40.50.720-FF-002276', NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase, putative', 24, NULL, NULL, 121393),
(121394, '4.10.1060.10-FF-000045', NULL, 'Zinc finger RANBP2-type containing 1', 37, NULL, NULL, 121394),
(121395, '1.25.10.10-FF-003344', NULL, 'Chromosome 7, whole genome shotgun sequence', 625, NULL, NULL, 121395),
(121396, '3.30.70.330-FF-002738', NULL, NULL, 95, NULL, NULL, 121396),
(121397, '2.120.10.30-FF-000599', NULL, 'Acylamino acid-releasing enzyme', 143, NULL, NULL, 121397),
(121398, '3.80.10.10-FF-000256', NULL, 'NLR family pyrin domain containing 1', 201, NULL, NULL, 121398),
(121399, '2.60.40.10-FF-005533', NULL, NULL, 54, NULL, NULL, 121399),
(121400, '3.30.420.10-FF-000570', NULL, NULL, 254, NULL, NULL, 121400),
(121401, '2.10.90.10-FF-000120', NULL, 'Brain-derived neurotrophic factor', 81, NULL, NULL, 121401),
(121402, '3.30.160.60-FF-003049', NULL, NULL, 29, NULL, NULL, 121402),
(121403, '3.40.50.300-FF-002240', NULL, 'ATP-dependent DEAD/H RNA helicase', 181, NULL, NULL, 121403),
(121404, '3.30.760.10-FF-000056', NULL, 'Eukaryotic translation initiation factor 4E', 208, NULL, NULL, 121404),
(121405, '2.10.50.10-FF-000106', NULL, 'Si:ch211-261n11.8', 82, NULL, NULL, 121405),
(121406, '2.70.160.11-FF-000091', NULL, 'Protein arginine N-methyltransferase', 169, NULL, NULL, 121406),
(121407, '3.30.710.10-FF-000019', NULL, 'Potassium voltage-gated channel, subfamily G, member 1', 126, NULL, NULL, 121407),
(121408, '2.60.120.200-FF-000148', NULL, 'Collagen, type XIX, alpha 1', 212, NULL, NULL, 121408),
(121409, '2.120.10.30-FF-000487', NULL, 'Uncharacterized protein', 279, NULL, NULL, 121409),
(121410, '3.40.710.10-FF-000163', NULL, 'Penicillin-binding protein 1C (PBP-1c)', 362, NULL, NULL, 121410),
(121411, '3.80.10.10-FF-002622', NULL, 'Nuclear factor of kappa light polypeptide gene enhancer in B-cells inhibitor-like 2', 183, NULL, NULL, 121411);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(121412, '3.60.40.10-FF-000247', NULL, 'Uncharacterized protein', 203, NULL, NULL, 121412),
(121413, '3.90.120.10-FF-000028', NULL, 'DNA-cytosine methyltransferase', 171, NULL, NULL, 121413),
(121414, '1.10.400.10-FF-000098', NULL, 'Predicted protein', 27, NULL, NULL, 121414),
(121415, '3.20.20.140-FF-000105', NULL, 'Amidohydrolase family protein', 290, NULL, NULL, 121415),
(121416, '3.30.450.30-FF-000078', NULL, 'Late endosomal/lysosomal adaptor, MAPK and MTOR activator 2', 103, NULL, NULL, 121416),
(121417, '1.20.1070.10-FF-000809', NULL, 'Uncharacterized protein', 307, NULL, NULL, 121417),
(121418, '1.20.5.1040-FF-000004', NULL, 'Sensor protein qseC', 58, NULL, NULL, 121418),
(121419, '3.30.70.330-FF-001120', NULL, 'RNA-binding protein rnp24, putative', 136, NULL, NULL, 121419),
(121420, '3.40.710.10-FF-000051', NULL, 'Penicillin-binding protein 4', 290, NULL, NULL, 121420),
(121421, '3.30.420.40-FF-000579', NULL, 'Cell growth defect factor 2', 14, NULL, NULL, 121421),
(121422, '3.10.310.50-FF-000005', NULL, 'Protein CBG08983', 172, NULL, NULL, 121422),
(121423, '3.30.450.20-FF-000075', NULL, 'Methyl-accepting chemotaxis protein', 120, NULL, NULL, 121423),
(121424, '1.25.40.10-FF-003155', NULL, 'Os08g0494350 protein', 119, NULL, NULL, 121424),
(121425, '2.30.30.490-FF-000056', NULL, 'Ash1 (absent, small, or homeotic)-like', 150, NULL, NULL, 121425),
(121426, '1.10.150.50-FF-000090', NULL, 'Bem1 interacting protein', 61, NULL, NULL, 121426),
(121427, '1.10.510.10-FF-002000', NULL, 'Kinase-like domain-containing protein', 189, NULL, NULL, 121427),
(121428, '2.30.29.30-FF-000646', NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', 107, NULL, NULL, 121428),
(121429, '3.30.160.60-FF-003942', NULL, NULL, 33, NULL, NULL, 121429),
(121430, '4.10.280.10-FF-000019', NULL, 'Myc proto-oncogene protein', 84, NULL, NULL, 121430),
(121431, '3.40.50.300-FF-007153', NULL, 'N-deacetylase/N-sulfotransferase (heparan glucosaminyl) 2a', 176, NULL, NULL, 121431),
(121432, '2.30.30.100-FF-000198', NULL, 'Uncharacterized protein', 98, NULL, NULL, 121432),
(121433, '1.10.510.10-FF-003506', NULL, NULL, 254, NULL, NULL, 121433),
(121434, '1.10.3370.10-FF-000032', NULL, 'Protein translocase subunit SecY', 418, NULL, NULL, 121434),
(121435, '1.10.555.10-FF-000170', NULL, NULL, 205, NULL, NULL, 121435),
(121436, '1.10.132.30-FF-000031', NULL, 'DNA-directed RNA polymerase subunit', 31, NULL, NULL, 121436),
(121437, '3.40.1670.10-FF-000001', NULL, '3-octaprenyl-4-hydroxybenzoate carboxy-lyase', 118, NULL, NULL, 121437),
(121438, '3.40.390.10-FF-000076', NULL, 'membrane metallo-endopeptidase-like 1', 42, NULL, NULL, 121438),
(121439, '1.20.1270.10-FF-000016', NULL, 'Heat shock protein 70', 74, NULL, NULL, 121439),
(121440, '2.10.25.10-FF-001684', NULL, 'Latent transforming growth factor beta binding protein 2', 44, NULL, NULL, 121440),
(121441, '3.90.640.10-FF-000056', NULL, 'Heat shock 70 kDa protein 4L', 84, NULL, NULL, 121441),
(121442, '3.40.50.720-FF-000685', NULL, 'Uncharacterized protein, isoform A', 233, NULL, NULL, 121442),
(121443, '3.40.50.300-FF-007832', NULL, 'Uncharacterized protein', 78, NULL, NULL, 121443),
(121444, '3.30.160.20-FF-000209', NULL, 'Uncharacterized protein', 131, NULL, NULL, 121444),
(121445, '1.10.510.10-FF-001820', NULL, 'Uncharacterized protein', 299, NULL, NULL, 121445),
(121446, '2.60.40.10-FF-003279', NULL, NULL, 98, NULL, NULL, 121446),
(121447, '1.20.58.60-FF-000646', NULL, 'Nesprin-1', 212, NULL, NULL, 121447),
(121448, '3.40.50.1010-FF-000041', NULL, 'Unplaced genomic scaffold supercont1.259, whole genome shotgun sequence', 221, NULL, NULL, 121448),
(121449, '3.80.10.10-FF-002510', NULL, 'Uncharacterized protein', 224, NULL, NULL, 121449),
(121450, '1.20.1560.10-FF-000235', NULL, 'Multidrug resistance-associated protein, putative', 355, NULL, NULL, 121450),
(121451, '3.40.50.300-FF-003780', NULL, 'Uncharacterized protein', 278, NULL, NULL, 121451),
(121452, '3.10.20.90-FF-000997', NULL, 'Phosphoinositide phospholipase C', 87, NULL, NULL, 121452),
(121453, '3.40.30.10-FF-000343', NULL, 'Protein disulfide isomerase', 117, NULL, NULL, 121453); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(121454, '1.20.1070.10-FF-001203', NULL, 'Parietopsin', 282, NULL, NULL, 121454),
(121455, '1.20.970.10-FF-000020', NULL, 'Anthranilate phosphoribosyltransferase', 66, NULL, NULL, 121455),
(121456, '2.30.42.10-FF-000632', NULL, NULL, 70, NULL, NULL, 121456),
(121457, '2.60.40.2170-FF-000019', NULL, 'Uncharacterized protein', 153, NULL, NULL, 121457),
(121458, '1.10.1200.10-FF-000132', NULL, 'Uncharacterized protein', 94, NULL, NULL, 121458),
(121459, '2.60.40.650-FF-000026', NULL, 'Sulfite oxidase', 134, NULL, NULL, 121459),
(121460, '3.30.40.10-FF-000491', NULL, 'RING-type E3 ubiquitin transferase', 85, NULL, NULL, 121460),
(121461, '3.80.10.10-FF-002717', NULL, 'Uncharacterized protein', 98, NULL, NULL, 121461),
(121462, '4.10.1000.10-FF-000053', NULL, 'Putative zinc finger CCCH domain-containing protein 48', 35, NULL, NULL, 121462),
(121463, '1.25.10.10-FF-003439', NULL, 'Splicing factor subunit, putative', 81, NULL, NULL, 121463),
(121464, '2.60.120.10-FF-000033', NULL, 'Centromere protein C 1', 89, NULL, NULL, 121464),
(121465, '3.40.50.300-FF-005466', NULL, 'ATP-dependent DEAD/H RNA helicase, putative', 225, NULL, NULL, 121465),
(121466, '3.30.70.330-FF-001541', NULL, NULL, 77, NULL, NULL, 121466),
(121467, '1.20.58.1480-FF-000018', NULL, 'AGAP005299-PA', 65, NULL, NULL, 121467),
(121468, '3.30.342.10-FF-000028', NULL, 'DNA polymerase', 155, NULL, NULL, 121468),
(121469, '1.10.287.660-FF-000005', NULL, 'Vacuolar protein-sorting-associated protein 37 homolog 1', 70, NULL, NULL, 121469),
(121470, '1.25.40.180-FF-000312', NULL, NULL, 276, NULL, NULL, 121470),
(121471, '1.20.58.60-FF-000860', NULL, 'Uncharacterized protein', 126, NULL, NULL, 121471),
(121472, '2.60.40.1090-FF-000010', NULL, 'Fimbrial adhesin FimH', 137, NULL, NULL, 121472),
(121473, '3.90.25.10-FF-000082', NULL, 'Uncharacterized protein', 93, NULL, NULL, 121473),
(121474, '1.25.40.10-FF-000979', NULL, 'tetratricopeptide repeat protein 28', 134, NULL, NULL, 121474),
(121475, '1.20.1250.20-FF-000815', NULL, 'Membrane-associated transporter protein', 447, NULL, NULL, 121475),
(121476, '1.20.1070.10-FF-000714', NULL, 'G protein-coupled receptor 55', 293, NULL, NULL, 121476),
(121477, '2.20.100.10-FF-000237', NULL, 'Thrombospondin, type I, domain-containing 7Ba', 54, NULL, NULL, 121477),
(121478, '3.40.50.410-FF-000373', NULL, 'Predicted protein', 78, NULL, NULL, 121478),
(121479, '1.20.930.20-FF-000009', NULL, 'Os12g0249900 protein', 114, NULL, NULL, 121479),
(121480, '1.10.1710.10-FF-000002', NULL, 'RNA chaperone ProQ', 148, NULL, NULL, 121480),
(121481, '2.130.10.10-FF-003257', NULL, 'Periodic tryptophan protein 2-like protein', 198, NULL, NULL, 121481),
(121482, '3.40.630.30-FF-000117', NULL, 'GCN5-related N-acetyltransferase protein-like', 195, NULL, NULL, 121482),
(121483, '3.30.200.20-FF-002395', NULL, 'Uncharacterized protein', 95, NULL, NULL, 121483),
(121484, '3.30.420.40-FF-000011', NULL, 'Actin isoform 2', 109, NULL, NULL, 121484),
(121485, '1.20.1110.10-FF-000061', NULL, 'Cation transporting ATPase', 408, NULL, NULL, 121485),
(121486, '3.90.230.10-FF-000002', NULL, 'Xaa-Pro aminopeptidase 3', 268, NULL, NULL, 121486),
(121487, '3.40.390.10-FF-000093', NULL, 'Disintegrin and metalloproteinase domain-containing protein B', 233, NULL, NULL, 121487),
(121488, '3.40.350.10-FF-000079', NULL, 'Uncharacterized peptidase C18A7.01', 164, NULL, NULL, 121488),
(121489, '3.30.160.20-FF-000182', NULL, 'Ribosomal protein S5, C-terminal domain-domain-containing protein', 64, NULL, NULL, 121489),
(121490, '3.40.50.2300-FF-001405', NULL, NULL, 119, NULL, NULL, 121490),
(121491, '1.20.1420.30-FF-000074', NULL, 'Uncharacterized protein', 133, NULL, NULL, 121491),
(121492, '3.40.250.10-FF-000032', NULL, 'Rhodanese-like domain-containing protein 14, chloroplastic', 159, NULL, NULL, 121492),
(121493, '3.40.20.10-FF-000174', NULL, 'ABR105Cp', 132, NULL, NULL, 121493),
(121494, '3.40.1280.10-FF-000078', NULL, 'Uncharacterized protein', 199, NULL, NULL, 121494),
(121495, '1.10.275.20-FF-000011', NULL, NULL, 37, NULL, NULL, 121495),
(121496, '1.10.101.10-FF-000010', NULL, 'Murein L,D-transpeptidase', 62, NULL, NULL, 121496);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(121497, '1.20.1740.10-FF-000007', NULL, 'APC family permease', 432, NULL, NULL, 121497),
(121498, '1.50.10.10-FF-000060', NULL, 'Glycosyl hydrolase family 65 central catalytic domain/Haloacid dehalogenase-like hydrolase, putative', 366, NULL, NULL, 121498),
(121499, '2.60.40.10-FF-005196', NULL, NULL, 92, NULL, NULL, 121499),
(121500, '1.10.472.80-FF-000060', NULL, 'TBC domain protein, putative', 134, NULL, NULL, 121500),
(121501, '1.10.10.10-FF-001910', NULL, 'Uncharacterized protein', 113, NULL, NULL, 121501),
(121502, '1.25.40.10-FF-002666', NULL, 'Uncharacterized protein', 192, NULL, NULL, 121502),
(121503, '1.20.1070.10-FF-002159', NULL, 'Uncharacterized protein', 144, NULL, NULL, 121503),
(121504, '1.25.40.10-FF-005307', NULL, 'Uncharacterized protein', 127, NULL, NULL, 121504),
(121505, '1.20.1070.10-FF-000265', NULL, 'Blast:Neuropeptide Y receptor', 357, NULL, NULL, 121505),
(121506, '1.20.970.10-FF-000003', NULL, 'Anthranilate phosphoribosyltransferase', 84, NULL, NULL, 121506),
(121507, '3.40.50.2000-FF-000580', NULL, '1,2-diacylglycerol 3-glucosyltransferase', 160, NULL, NULL, 121507),
(121508, '3.30.70.940-FF-000004', NULL, 'Transcription antitermination protein RfaH', 162, NULL, NULL, 121508),
(121509, '3.40.50.2300-FF-000804', NULL, NULL, 80, NULL, NULL, 121509),
(121510, '3.20.20.70-FF-000350', NULL, 'Glutamate synthase, large subunit', 325, NULL, NULL, 121510),
(121511, '3.40.50.1700-FF-000034', NULL, 'Beta-glucosidase (Gentiobiase)', 114, NULL, NULL, 121511),
(121512, '1.20.1300.20-FF-000005', NULL, 'Ubiquitin thioesterase otubain-like', 145, NULL, NULL, 121512),
(121513, '3.40.50.300-FF-007720', NULL, 'DsRNA-specific nuclease dicer and related ribonuclease', 94, NULL, NULL, 121513),
(121514, '3.40.50.1110-FF-000071', NULL, 'Esterase', 206, NULL, NULL, 121514),
(121515, '1.20.1160.11-FF-000026', NULL, NULL, 24, NULL, NULL, 121515),
(121516, '3.30.420.220-FF-000003', NULL, 'Nop family pre-rRNA processing protein', 136, NULL, NULL, 121516),
(121517, '3.30.1240.10-FF-000033', NULL, 'Cof family hydrolase subfamily protein', 103, NULL, NULL, 121517),
(121518, '3.30.420.60-FF-000017', NULL, 'ERF1 domain 3 family protein', 133, NULL, NULL, 121518),
(121519, '3.40.720.10-FF-000332', NULL, 'Uncharacterized protein', 122, NULL, NULL, 121519),
(121520, '1.10.418.20-FF-000023', NULL, 'Uncharacterized protein', 113, NULL, NULL, 121520),
(121521, '2.30.170.20-FF-000006', NULL, '50S ribosomal protein L24e', 61, NULL, NULL, 121521),
(121522, '3.30.70.930-FF-000001', NULL, 'ECM15p protein', 104, NULL, NULL, 121522),
(121523, '1.20.1560.10-FF-000914', NULL, 'ATP-binding cassette transporter, subfamily B, member 7, group TAP protein PpABCB7', 136, NULL, NULL, 121523),
(121524, '3.30.70.3270-FF-000002', NULL, 'NADH-quinone oxidoreductase subunit I', 144, NULL, NULL, 121524),
(121525, '2.130.10.10-FF-005623', NULL, 'Uncharacterized protein', 182, NULL, NULL, 121525),
(121526, '4.10.400.10-FF-000013', NULL, 'Prolow-density lipoprotein receptor-related protein 1', 41, NULL, NULL, 121526),
(121527, '3.50.50.60-FF-000595', NULL, 'FAD/NAD(P)-binding domain-containing protein', 275, NULL, NULL, 121527),
(121528, '3.40.50.1820-FF-000536', NULL, 'Abhydrolase domain containing 1', 263, NULL, NULL, 121528),
(121529, '1.25.40.10-FF-005072', NULL, 'Tetratricopeptide repeat domain 37', 196, NULL, NULL, 121529),
(121530, '1.25.10.10-FF-001192', NULL, 'Uncharacterized protein', 168, NULL, NULL, 121530),
(121531, '3.20.20.80-FF-000353', NULL, 'Glycoside hydrolase family 2 sugar binding', 333, NULL, NULL, 121531),
(121532, '3.30.2460.20-FF-000013', NULL, 'Protein Wnt', 57, NULL, NULL, 121532),
(121533, '1.10.510.10-FF-001269', NULL, 'Cyclin dependent kinase 6', 192, NULL, NULL, 121533),
(121534, '4.10.240.10-FF-000141', NULL, 'Ty1 enhancer activator, putative', 86, NULL, NULL, 121534),
(121535, '2.60.40.10-FF-003167', NULL, 'Anosmin 1a', 118, NULL, NULL, 121535),
(121536, '3.60.10.10-FF-000083', NULL, 'Putative inositol polyphosphate phosphatase (Synaptogenin-like) family protein', 124, NULL, NULL, 121536);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(121537, '1.10.730.10-FF-000196', NULL, 'Uncharacterized protein', 113, NULL, NULL, 121537),
(121538, '2.130.10.30-FF-000054', NULL, 'Scf associated factor', 163, NULL, NULL, 121538),
(121539, '3.30.70.890-FF-000051', NULL, 'Diphosphomevalonate decarboxylase', 130, NULL, NULL, 121539),
(121540, '1.10.287.70-FF-000227', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 153, NULL, NULL, 121540),
(121541, '1.25.40.10-FF-001143', NULL, 'Pol II transcription elongation factor, putative', 139, NULL, NULL, 121541),
(121542, '3.30.160.60-FF-003521', NULL, 'Zinc finger protein 541', 39, NULL, NULL, 121542),
(121543, '3.80.10.10-FF-004067', NULL, 'Uncharacterized protein', 132, NULL, NULL, 121543),
(121544, '2.30.29.30-FF-000079', NULL, 'unconventional myosin-VIIa', 96, NULL, NULL, 121544),
(121545, '2.10.50.10-FF-000011', NULL, 'Tumor necrosis factor receptor superfamily member 21', 90, NULL, NULL, 121545),
(121546, '3.80.10.10-FF-004404', NULL, 'Uncharacterized protein', 96, NULL, NULL, 121546),
(121547, '2.60.40.690-FF-000010', NULL, 'C3 and PZP-like alpha-2-macroglobulin domain-containing protein 8', 162, NULL, NULL, 121547),
(121548, '2.40.128.20-FF-000030', NULL, 'Chloroplastic lipocalin', 181, NULL, NULL, 121548),
(121549, '1.10.10.10-FF-001814', NULL, 'Transcriptional regulator', 76, NULL, NULL, 121549),
(121550, '2.10.90.10-FF-000103', NULL, 'Bone morphogenetic protein 16', 103, NULL, NULL, 121550),
(121551, '3.80.10.10-FF-000705', NULL, 'Glucose-repressible alcohol dehydrogenase transcriptional effector', 153, NULL, NULL, 121551),
(121552, '1.20.900.10-FF-000055', NULL, 'UNC-112-Interacting Guanine nucleotide exchange factor', 230, NULL, NULL, 121552),
(121553, '1.20.1070.10-FF-000591', NULL, 'Predicted protein', 284, NULL, NULL, 121553),
(121554, '2.30.40.10-FF-000015', NULL, 'Imidazolonepropionase', 93, NULL, NULL, 121554),
(121555, '3.40.33.10-FF-000041', NULL, 'GD25808', 240, NULL, NULL, 121555),
(121556, '3.40.50.300-FF-001751', NULL, 'ABC bile acid transporter', 232, NULL, NULL, 121556),
(121557, '3.80.10.10-FF-002605', NULL, 'Leucine rich repeat kinase 1', 66, NULL, NULL, 121557),
(121558, '3.20.20.70-FF-000120', NULL, 'Pyruvate carboxylase', 503, NULL, NULL, 121558),
(121559, '1.20.1250.20-FF-002165', NULL, 'Uncharacterized protein', 185, NULL, NULL, 121559),
(121560, '2.40.420.20-FF-000046', NULL, 'Component of multidrug efflux system', 87, NULL, NULL, 121560),
(121561, '3.90.190.10-FF-000532', NULL, 'Uncharacterized protein', 189, NULL, NULL, 121561),
(121562, '1.10.3180.10-FF-000006', NULL, 'Os04g0456900 protein', 100, NULL, NULL, 121562),
(121563, '2.130.10.10-FF-003824', NULL, 'Meiotic recombination protein rec14', 302, NULL, NULL, 121563),
(121564, '1.50.10.20-FF-000063', NULL, 'Protein farnesyltransferase subunit beta', 529, NULL, NULL, 121564),
(121565, '3.80.10.10-FF-004308', NULL, 'Uncharacterized protein', 214, NULL, NULL, 121565),
(121566, '2.60.40.10-FF-001267', NULL, 'Immunoglobulin-like and fibronectin type III domain containing 1', 101, NULL, NULL, 121566),
(121567, '3.40.50.620-FF-000773', NULL, 'Phosphopantetheine adenylyltransferase', 109, NULL, NULL, 121567),
(121568, '2.130.10.10-FF-001907', NULL, 'Mitotic checkpoint protein, putative', 310, NULL, NULL, 121568),
(121569, '1.10.510.10-FF-003169', NULL, NULL, 166, NULL, NULL, 121569),
(121570, '1.20.1250.20-FF-001889', NULL, 'Uncharacterized protein', 85, NULL, NULL, 121570),
(121571, '3.40.50.10090-FF-000026', NULL, 'GG16951', 95, NULL, NULL, 121571),
(121572, '1.25.40.10-FF-000867', NULL, 'ETO1-like protein 1', 185, NULL, NULL, 121572),
(121573, '3.30.300.30-FF-000078', NULL, 'Nonribosomal peptide synthetase 7', 106, NULL, NULL, 121573),
(121574, '3.30.420.10-FF-000244', NULL, 'Exonuclease mut-7', 258, NULL, NULL, 121574),
(121575, '1.10.3380.10-FF-000072', NULL, 'Uncharacterized protein', 172, NULL, NULL, 121575),
(121576, '3.40.50.2000-FF-000821', NULL, 'Uncharacterized protein', 202, NULL, NULL, 121576),
(121577, '3.30.200.20-FF-001321', NULL, 'Protein kinase, putative', 88, NULL, NULL, 121577);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(121578, '4.10.1070.10-FF-000001', NULL, 'Short tail fiber protein gp12', 122, NULL, NULL, 121578),
(121579, '1.10.555.10-FF-000153', NULL, NULL, 210, NULL, NULL, 121579),
(121580, '2.130.10.10-FF-004100', NULL, 'Uncharacterized protein', 196, NULL, NULL, 121580),
(121581, '1.20.58.390-FF-000041', NULL, 'Neuronal acetylcholine receptor subunit alpha-5', 73, NULL, NULL, 121581),
(121582, '1.25.10.10-FF-001641', NULL, 'Synembryn-A', 442, NULL, NULL, 121582),
(121583, '1.10.20.140-FF-000014', NULL, 'tRNA dimethylallyltransferase', 69, NULL, NULL, 121583),
(121584, '2.130.10.10-FF-004797', NULL, 'Uncharacterized protein', 148, NULL, NULL, 121584),
(121585, '3.40.50.300-FF-006989', NULL, 'ATP-binding cassette transporter, subfamily G, member 6, group WBC protein PpABCG6', 214, NULL, NULL, 121585),
(121586, '3.40.50.2300-FF-000349', NULL, 'PTS fructose transporter subunit IIB', 109, NULL, NULL, 121586),
(121587, '2.60.40.10-FF-002110', NULL, 'Calmodulin-binding transcription activator 4', 97, NULL, NULL, 121587),
(121588, '2.60.40.1180-FF-000020', NULL, 'Pancreatic alpha-amylase', 93, NULL, NULL, 121588),
(121589, '3.30.1490.20-FF-000071', NULL, 'Succinyl-CoA synthetase beta subunit, putative', 90, NULL, NULL, 121589),
(121590, '3.30.40.10-FF-001007', NULL, 'Zinc finger domain containing protein', 94, NULL, NULL, 121590),
(121591, '3.40.50.1910-FF-000007', NULL, 'syntaxin-binding protein 3 isoform X1', 209, NULL, NULL, 121591),
(121592, '1.20.1270.60-FF-000233', NULL, 'Uncharacterized protein', 221, NULL, NULL, 121592),
(121593, '1.25.40.280-FF-000016', NULL, 'pH-response regulator protein palA/RIM20', 369, NULL, NULL, 121593),
(121594, '3.30.40.10-FF-002289', NULL, 'Predicted protein', 118, NULL, NULL, 121594),
(121595, '1.20.1160.20-FF-000016', NULL, 'Regulator of telomere elongation helicase 1', 99, NULL, NULL, 121595),
(121596, '1.20.990.10-FF-000015', NULL, 'NADPH-dependent diflavin oxidoreductase 1', 131, NULL, NULL, 121596),
(121597, '2.60.120.650-FF-000148', NULL, 'Uncharacterized protein', 217, NULL, NULL, 121597),
(121598, '1.20.5.110-FF-000020', NULL, 'synaptobrevin homolog YKT6', 58, NULL, NULL, 121598),
(121599, '2.60.40.10-FF-003728', NULL, NULL, 83, NULL, NULL, 121599),
(121600, '2.60.40.10-FF-004010', NULL, NULL, 99, NULL, NULL, 121600),
(121601, '2.60.40.10-FF-005421', NULL, NULL, 141, NULL, NULL, 121601),
(121602, '3.30.1520.10-FF-000178', NULL, 'Predicted protein', 103, NULL, NULL, 121602),
(121603, '3.60.20.10-FF-000140', NULL, 'Proteasome endopeptidase complex', 232, NULL, NULL, 121603),
(121604, '2.60.40.10-FF-001834', NULL, 'Blast:Twitchin', 111, NULL, NULL, 121604),
(121605, '3.60.40.10-FF-000017', NULL, 'phosphatase 1L isoform X1', 277, NULL, NULL, 121605),
(121606, '1.20.1740.10-FF-000103', NULL, 'Uncharacterized protein', 311, NULL, NULL, 121606),
(121607, '1.20.1250.20-FF-000580', NULL, 'Unplaced genomic scaffold supercont2.27, whole genome shotgun sequence', 189, NULL, NULL, 121607),
(121608, '1.10.238.10-FF-001119', NULL, 'Uncharacterized protein', 41, NULL, NULL, 121608),
(121609, '3.50.50.60-FF-000718', NULL, 'Probable oxidoreductase', 136, NULL, NULL, 121609),
(121610, '1.20.5.110-FF-000227', NULL, 'Uncharacterized protein', 101, NULL, NULL, 121610),
(121611, '3.90.190.10-FF-000302', NULL, 'Tyrosine specific protein phosphatase family protein', 70, NULL, NULL, 121611),
(121612, '1.20.58.60-FF-000197', NULL, 'Alpha spectrin, isoform B', 108, NULL, NULL, 121612),
(121613, '1.10.287.380-FF-000028', NULL, 'Valine-tRNA ligase', 70, NULL, NULL, 121613),
(121614, '3.40.50.300-FF-003342', NULL, 'DNA polymerase III subunit gamma/tau', 153, NULL, NULL, 121614),
(121615, '3.40.30.10-FF-000360', NULL, 'Glutathione S-transferase', 98, NULL, NULL, 121615),
(121616, '1.20.1610.10-FF-000003', NULL, 'Glycoside hydrolase family 92 protein', 160, NULL, NULL, 121616),
(121617, '3.40.50.300-FF-005236', NULL, 'Slr1428 protein', 198, NULL, NULL, 121617),
(121618, '1.50.40.10-FF-000123', NULL, 'Solute carrier family 25 (Mitochondrial S-adenosylmethionine transporter), member 26', 157, NULL, NULL, 121618);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(121619, '2.60.40.10-FF-003521', NULL, NULL, 85, NULL, NULL, 121619),
(121620, '1.25.10.70-FF-000012', NULL, 'Predicted protein', 298, NULL, NULL, 121620),
(121621, '3.40.50.970-FF-000176', NULL, 'Pyruvate dehydrogenase E1 component alpha subunit, putative', 199, NULL, NULL, 121621),
(121622, '4.10.1240.10-FF-000031', NULL, 'Growth hormone-releasing hormone receptor a', 85, NULL, NULL, 121622),
(121623, '3.30.40.10-FF-000518', NULL, 'Ubiquitin conjugation factor E4 A', 76, NULL, NULL, 121623),
(121624, '2.30.29.30-FF-000534', NULL, 'TBC1 (tre-2/USP6, BUB2, cdc16) domain family, member 1', 190, NULL, NULL, 121624),
(121625, '3.30.450.20-FF-000187', NULL, 'Hypoxia-inducible factor 1-alpha', 65, NULL, NULL, 121625),
(121626, '1.10.287.370-FF-000025', NULL, 'Prefoldin subunit 2', 101, NULL, NULL, 121626),
(121627, '3.40.50.300-FF-007265', NULL, 'Predicted protein', 156, NULL, NULL, 121627),
(121628, '2.30.42.10-FF-000177', NULL, 'delphilin isoform X1', 92, NULL, NULL, 121628),
(121629, '1.10.10.10-FF-000758', NULL, 'GntR family transcriptional regulator', 68, NULL, NULL, 121629),
(121630, '3.60.10.10-FF-000419', NULL, 'Uncharacterized protein', 147, NULL, NULL, 121630),
(121631, '2.40.50.140-FF-000268', NULL, 'Mitochondrial ribosomal protein S17', 102, NULL, NULL, 121631),
(121632, '1.25.40.10-FF-002992', NULL, 'Pentatricopeptide repeat-containing protein', 135, NULL, NULL, 121632),
(121633, '1.10.357.50-FF-000019', NULL, 'Exocyst complex component 3', 240, NULL, NULL, 121633),
(121634, '1.25.40.20-FF-000302', NULL, 'Ankyrin repeat containing protein', 124, NULL, NULL, 121634),
(121635, '3.90.70.80-FF-000038', NULL, 'OTU domain-containing protein', 159, NULL, NULL, 121635),
(121636, '3.30.70.1230-FF-000070', NULL, 'Probable lignin peroxidase lipJ', 177, NULL, NULL, 121636),
(121637, '3.40.1110.10-FF-000420', NULL, NULL, 27, NULL, NULL, 121637),
(121638, '3.50.50.60-FF-001207', NULL, 'Uncharacterized protein', 371, NULL, NULL, 121638),
(121639, '1.25.10.10-FF-001315', NULL, 'Raptor_N-terminal_CASPase_like_domain_containing_protein_-_putative', 194, NULL, NULL, 121639),
(121640, '3.30.590.50-FF-000009', NULL, 'Glutamate--cysteine ligase', 90, NULL, NULL, 121640),
(121641, '3.40.1380.20-FF-000015', NULL, 'Pyruvate kinase', 122, NULL, NULL, 121641),
(121642, '1.25.40.10-FF-002896', NULL, 'Pre-mRNA-splicing factor SYF1', 475, NULL, NULL, 121642),
(121643, '1.25.40.10-FF-001710', NULL, 'Os01g0977400 protein', 70, NULL, NULL, 121643),
(121644, '1.10.357.20-FF-000010', NULL, 'Solute carrier family 41 (magnesium transporter), member 2a', 195, NULL, NULL, 121644),
(121645, '3.40.1190.20-FF-000074', NULL, '6-phosphofructokinase pfkb (Phosphohexokinase) (Phosphofructokinase)', 306, NULL, NULL, 121645),
(121646, '3.30.1390.30-FF-000010', NULL, NULL, 76, NULL, NULL, 121646),
(121647, '1.10.1040.50-FF-000013', NULL, NULL, 123, NULL, NULL, 121647),
(121648, '3.30.70.330-FF-001103', NULL, 'Putative RNA-binding protein', 138, NULL, NULL, 121648),
(121649, '3.40.50.1820-FF-000862', NULL, 'Carboxypeptidase', 435, NULL, NULL, 121649),
(121650, '3.40.50.1700-FF-000051', NULL, 'Beta-glucosidase', 27, NULL, NULL, 121650),
(121651, '3.40.50.720-FF-000247', NULL, 'NADPH-dependent 2,4-dienoyl-CoA reductase', 134, NULL, NULL, 121651),
(121652, '1.25.40.20-FF-001713', NULL, 'Uncharacterized protein', 49, NULL, NULL, 121652),
(121653, '1.10.357.30-FF-000013', NULL, NULL, 184, NULL, NULL, 121653),
(121654, '3.40.718.10-FF-000063', NULL, 'Isocitrate/isopropylmalate dehydrogenase family protein', 115, NULL, NULL, 121654),
(121655, '3.40.50.150-FF-001571', NULL, NULL, 67, NULL, NULL, 121655),
(121656, '1.10.520.10-FF-000011', NULL, 'L-ascorbate peroxidase', 117, NULL, NULL, 121656),
(121657, '1.10.510.10-FF-001371', NULL, 'Protein kinase, putative', 114, NULL, NULL, 121657),
(121658, '3.40.50.300-FF-003549', NULL, 'ABC transporter family-like protein', 257, NULL, NULL, 121658),
(121659, '3.40.50.300-FF-001088', NULL, 'uncharacterized protein ycf45 isoform X2', 218, NULL, NULL, 121659),
(121660, '1.10.510.10-FF-003523', NULL, NULL, 244, NULL, NULL, 121660);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(121661, '3.90.360.10-FF-000006', NULL, 'Histone acetyltransferase type B catalytic subunit', 131, NULL, NULL, 121661),
(121662, '1.10.10.10-FF-001247', NULL, 'IclR family transcriptional regulator', 75, NULL, NULL, 121662),
(121663, '1.25.40.10-FF-003172', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 110, NULL, NULL, 121663),
(121664, '3.40.50.740-FF-000011', NULL, 'Molybdopterin oxidoreductase, alpha subunit', 170, NULL, NULL, 121664),
(121665, '3.30.710.10-FF-000345', NULL, 'BTB/POZ domain-containing protein 9-like', 164, NULL, NULL, 121665),
(121666, '3.20.20.140-FF-000431', NULL, 'Multidrug resistance protein B', 186, NULL, NULL, 121666),
(121667, '3.30.200.20-FF-000478', NULL, 'Serine/threonine-protein kinase N2', 90, NULL, NULL, 121667),
(121668, '2.60.220.50-FF-000070', NULL, 'Flamingo 1b', 38, NULL, NULL, 121668),
(121669, '3.80.10.10-FF-001993', NULL, 'Predicted protein', 294, NULL, NULL, 121669),
(121670, '3.30.160.60-FF-001930', NULL, 'Zinc finger protein 44', 27, NULL, NULL, 121670),
(121671, '1.10.510.10-FF-004012', NULL, NULL, 132, NULL, NULL, 121671),
(121672, '2.130.10.10-FF-001357', NULL, 'WD repeat-containing protein 26 homolog', 55, NULL, NULL, 121672),
(121673, '2.60.40.10-FF-005078', NULL, NULL, 100, NULL, NULL, 121673),
(121674, '3.90.660.10-FF-000052', NULL, NULL, 118, NULL, NULL, 121674),
(121675, '3.40.50.720-FF-000808', NULL, 'Iridoid synthase', 366, NULL, NULL, 121675),
(121676, '1.10.630.10-FF-000356', NULL, 'Cytochrome P450 4F12', 470, NULL, NULL, 121676),
(121677, '2.60.120.260-FF-000576', NULL, 'Uncharacterized protein', 182, NULL, NULL, 121677),
(121678, '1.10.10.1940-FF-000001', NULL, 'Matrix metallopeptidase 23B', 36, NULL, NULL, 121678),
(121679, '2.30.110.10-FF-000011', NULL, 'Chromosome 7, whole genome shotgun sequence', 203, NULL, NULL, 121679),
(121680, '3.30.160.60-FF-001363', NULL, NULL, 29, NULL, NULL, 121680),
(121681, '3.30.200.20-FF-001534', NULL, 'Receptor protein serine/threonine kinase', 112, NULL, NULL, 121681),
(121682, '3.30.40.10-FF-001221', NULL, 'Putative e3 ubiquitin-protein ligase', 96, NULL, NULL, 121682),
(121683, '3.30.70.250-FF-000011', NULL, 'Related to Malonyl CoA-acyl carrier protein transacylase', 74, NULL, NULL, 121683),
(121684, '3.40.50.360-FF-000105', NULL, 'Homolog to NAD(P)H dehydrogenase (Quinone)', 187, NULL, NULL, 121684),
(121685, '1.10.1080.10-FF-000026', NULL, 'Glutathione synthetase', 55, NULL, NULL, 121685),
(121686, '2.60.120.200-FF-000709', NULL, 'Uncharacterized protein', 183, NULL, NULL, 121686),
(121687, '1.10.150.20-FF-000328', NULL, 'Uncharacterized protein', 52, NULL, NULL, 121687),
(121688, '3.40.50.1220-FF-000098', NULL, 'Uncharacterized protein', 205, NULL, NULL, 121688),
(121689, '3.40.50.620-FF-000655', NULL, 'Valyl Amino-acyl tRNA Synthetase', 232, NULL, NULL, 121689),
(121690, '3.30.200.20-FF-000927', NULL, 'Cyclin-dependent kinase 2', 84, NULL, NULL, 121690),
(121691, '3.50.30.30-FF-000034', NULL, 'Probable glutamate carboxypeptidase VP8', 198, NULL, NULL, 121691),
(121692, '3.40.50.2300-FF-000580', NULL, 'TMAO reductase system periplasmic protein TorT', 128, NULL, NULL, 121692),
(121693, '1.20.1250.20-FF-000254', NULL, 'MAL31p Maltose permease', 470, NULL, NULL, 121693),
(121694, '1.10.10.750-FF-000037', NULL, 'Plant adhesion molecule 1', 50, NULL, NULL, 121694),
(121695, '1.20.5.170-FF-000009', NULL, 'probable transcription factor PosF21', 54, NULL, NULL, 121695),
(121696, '2.170.16.10-FF-000003', NULL, 'Homothallism endonuclease', 191, NULL, NULL, 121696),
(121697, '3.40.50.2000-FF-000692', NULL, 'UDP-glucuronosyltransferase', 185, NULL, NULL, 121697),
(121698, '3.30.70.330-FF-001092', NULL, 'serine/arginine-rich splicing factor 2', 157, NULL, NULL, 121698),
(121699, '3.40.50.300-FF-005028', NULL, 'Gluconokinase', 176, NULL, NULL, 121699),
(121700, '2.130.10.10-FF-002886', NULL, 'U3 small nucleolar RNA-associated protein 15 homolog', 167, NULL, NULL, 121700),
(121701, '3.30.160.60-FF-004010', NULL, NULL, 32, NULL, NULL, 121701),
(121702, '3.30.420.10-FF-000126', NULL, '3''-5'' exonuclease domain protein', 191, NULL, NULL, 121702);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(121703, '3.10.50.10-FF-000059', NULL, 'Predicted protein', 72, NULL, NULL, 121703),
(121704, '1.10.510.10-FF-001932', NULL, 'Protein CBG11137', 176, NULL, NULL, 121704),
(121705, '1.10.1200.120-FF-000012', NULL, 'Uncharacterized protein', 80, NULL, NULL, 121705),
(121706, '3.30.260.10-FF-000029', NULL, 'Chaperonin containing TCP1 subunit 6B', 67, NULL, NULL, 121706),
(121707, '1.25.40.10-FF-001581', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 130, NULL, NULL, 121707),
(121708, '2.40.50.450-FF-000001', NULL, 'Fe(3+) ions import ATP-binding protein FbpC', 44, NULL, NULL, 121708),
(121709, '1.20.1560.10-FF-000802', NULL, 'Uncharacterized protein', 197, NULL, NULL, 121709),
(121710, '1.20.1320.30-FF-000004', NULL, 'Retinoic acid inducible protein I transcript variant 2', 138, NULL, NULL, 121710),
(121711, '2.60.120.10-FF-000151', NULL, 'Cupin domain-containing protein', 153, NULL, NULL, 121711),
(121712, '2.60.470.10-FF-000031', NULL, 'Uncharacterized protein', 190, NULL, NULL, 121712),
(121713, '3.60.130.10-FF-000007', NULL, 'Alpha-ketoglutarate-dependent taurine dioxygenase', 283, NULL, NULL, 121713),
(121714, '3.20.20.80-FF-000241', NULL, 'Glycoside hydrolase', 350, NULL, NULL, 121714),
(121715, '3.10.260.10-FF-000005', NULL, 'Transcriptional repressor, putative', 117, NULL, NULL, 121715),
(121716, '1.25.40.20-FF-001584', NULL, 'Kinase, NEK', 118, NULL, NULL, 121716),
(121717, '1.20.1320.20-FF-000001', NULL, 'Fanconi anemia, complementation group M', 126, NULL, NULL, 121717),
(121718, '2.60.40.150-FF-000686', NULL, 'Phosphoinositide phospholipase C', 172, NULL, NULL, 121718),
(121719, '3.50.50.60-FF-000483', NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', 246, NULL, NULL, 121719),
(121720, '3.40.850.10-FF-000347', NULL, 'Centromere protein E', 122, NULL, NULL, 121720),
(121721, '1.10.287.130-FF-000212', NULL, 'Two-component hybrid sensor and regulator', 104, NULL, NULL, 121721),
(121722, '1.10.1060.10-FF-000031', NULL, 'Formate dehydrogenase subunit beta', 118, NULL, NULL, 121722),
(121723, '3.90.1260.10-FF-000003', NULL, 'Argininosuccinate synthase', 231, NULL, NULL, 121723),
(121724, '3.40.50.300-FF-001649', NULL, 'DNA repair protein RAD50', 298, NULL, NULL, 121724),
(121725, '3.40.50.2000-FF-000579', NULL, 'Glycosyl transferase', 162, NULL, NULL, 121725),
(121726, '3.30.420.40-FF-001068', NULL, 'Hsp70', 46, NULL, NULL, 121726),
(121727, '2.130.10.10-FF-005741', NULL, 'Uncharacterized protein', 124, NULL, NULL, 121727),
(121728, '3.90.190.10-FF-000077', NULL, 'Myotubularin related protein 14', 140, NULL, NULL, 121728),
(121729, '3.40.1800.20-FF-000037', NULL, NULL, 73, NULL, NULL, 121729),
(121730, '1.20.120.1630-FF-000015', NULL, '3-oxo-5-alpha-steroid 4-dehydrogenase (DUF1295)', 201, NULL, NULL, 121730),
(121731, '2.10.25.10-FF-000610', NULL, 'protein HEG homolog 1 isoform X1', 43, NULL, NULL, 121731),
(121732, '2.40.50.140-FF-001206', NULL, NULL, 89, NULL, NULL, 121732),
(121733, '3.40.50.150-FF-001458', NULL, NULL, 281, NULL, NULL, 121733),
(121734, '2.30.130.110-FF-000006', NULL, 'Altronate dehydratase', 77, NULL, NULL, 121734),
(121735, '3.30.1370.10-FF-000149', NULL, 'Uncharacterized protein', 91, NULL, NULL, 121735),
(121736, '1.20.1250.20-FF-001985', NULL, 'Uncharacterized protein', 391, NULL, NULL, 121736),
(121737, '1.10.287.70-FF-000345', NULL, 'GM20581', 226, NULL, NULL, 121737),
(121738, '3.30.160.60-FF-003066', NULL, 'GH13825', 28, NULL, NULL, 121738),
(121739, '2.30.30.100-FF-000226', NULL, 'Uncharacterized protein', 56, NULL, NULL, 121739),
(121740, '3.30.70.1730-FF-000012', NULL, 'Mitochondrial Ribosomal Protein, Large', 170, NULL, NULL, 121740),
(121741, '3.30.1390.30-FF-000004', NULL, 'Penicillin-binding protein 3', 72, NULL, NULL, 121741),
(121742, '1.25.40.10-FF-004818', NULL, 'Tetratricopeptide repeat domain 21B', 152, NULL, NULL, 121742),
(121743, '3.30.160.60-FF-005527', NULL, NULL, 76, NULL, NULL, 121743),
(121744, '3.30.160.60-FF-003493', NULL, NULL, 30, NULL, NULL, 121744),
(121745, '3.60.60.10-FF-000018', NULL, 'Slr1772 protein', 324, NULL, NULL, 121745);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(121746, '2.30.130.10-FF-000006', NULL, 'putative methyltransferase NSUN6 isoform X2', 99, NULL, NULL, 121746),
(121747, '3.30.70.330-FF-002188', NULL, NULL, 38, NULL, NULL, 121747),
(121748, '1.20.58.60-FF-000079', NULL, 'Spectrin alpha chain, non-erythrocytic 1', 102, NULL, NULL, 121748),
(121749, '3.30.160.60-FF-005207', NULL, NULL, 29, NULL, NULL, 121749),
(121750, '4.10.280.50-FF-000003', NULL, 'Glutamate decarboxylase', 62, NULL, NULL, 121750),
(121751, '3.30.40.10-FF-002317', NULL, 'zinc finger protein isoform X1', 104, NULL, NULL, 121751),
(121752, '3.30.70.260-FF-000014', NULL, 'Methionine import ATP-binding protein MetN', 98, NULL, NULL, 121752),
(121753, '1.10.10.350-FF-000013', NULL, 'Glutamine-tRNA ligase', 107, NULL, NULL, 121753),
(121754, '2.60.490.10-FF-000026', NULL, 'Uncharacterized protein', 14, NULL, NULL, 121754),
(121755, '3.40.50.1000-FF-000858', NULL, NULL, 50, NULL, NULL, 121755),
(121756, '3.40.50.2300-FF-000675', NULL, 'Uncharacterized protein', 266, NULL, NULL, 121756),
(121757, '1.25.40.10-FF-002784', NULL, 'Uncharacterized protein', 480, NULL, NULL, 121757),
(121758, '3.40.50.620-FF-000560', NULL, 'Probable nicotinate-nucleotide adenylyltransferase', 213, NULL, NULL, 121758),
(121759, '2.60.40.10-FF-002919', NULL, 'Interleukin 10 receptor, beta', 105, NULL, NULL, 121759),
(121760, '3.30.40.10-FF-001120', NULL, 'Chromatin modification-related protein', 86, NULL, NULL, 121760),
(121761, '1.20.1250.20-FF-002378', NULL, 'Solute carrier organic anion transporter family member', 211, NULL, NULL, 121761),
(121762, '2.40.50.140-FF-001111', NULL, NULL, 114, NULL, NULL, 121762),
(121763, '3.30.710.10-FF-000457', NULL, 'Uncharacterized protein', 132, NULL, NULL, 121763),
(121764, '1.10.1400.10-FF-000001', NULL, 'Acyl-homoserine lactone acylase QuiP', 153, NULL, NULL, 121764),
(121765, '2.130.10.30-FF-000172', NULL, NULL, 303, NULL, NULL, 121765),
(121766, '3.20.80.10-FF-000010', NULL, 'SOUL heme-binding family protein', 78, NULL, NULL, 121766),
(121767, '3.40.50.300-FF-003903', NULL, 'Uncharacterized protein', 321, NULL, NULL, 121767),
(121768, '3.40.50.300-FF-007602', NULL, 'DEAD-box ATP-dependent RNA helicase rde-12', 161, NULL, NULL, 121768),
(121769, '3.30.930.10-FF-000210', NULL, 'Mitochondrial lysyl-tRNA synthetase, putative', 342, NULL, NULL, 121769),
(121770, '1.20.1070.10-FF-000826', NULL, 'Cannabinoid receptor 2', 317, NULL, NULL, 121770),
(121771, '2.20.70.10-FF-000158', NULL, 'Predicted protein', 51, NULL, NULL, 121771),
(121772, '1.10.3730.20-FF-000001', NULL, 'Quaternary ammonium compound resistance transporter SugE', 106, NULL, NULL, 121772),
(121773, '2.130.10.10-FF-003611', NULL, 'Uncharacterized protein', 153, NULL, NULL, 121773),
(121774, '1.10.510.10-FF-001718', NULL, 'Protein kinase superfamily protein', 153, NULL, NULL, 121774),
(121775, '1.25.40.950-FF-000003', NULL, 'Uncharacterized protein, isoform B', 72, NULL, NULL, 121775),
(121776, '1.10.150.50-FF-000073', NULL, 'Gemini, isoform C', 78, NULL, NULL, 121776),
(121777, '2.130.10.10-FF-005062', NULL, 'Uncharacterized protein', 273, NULL, NULL, 121777),
(121778, '1.20.58.100-FF-000011', NULL, 'Fumarate reductase flavoprotein subunit', 118, NULL, NULL, 121778),
(121779, '2.120.10.30-FF-000369', NULL, 'Predicted protein', 111, NULL, NULL, 121779),
(121780, '1.10.357.90-FF-000003', NULL, 'Telomerase reverse transcriptase', 166, NULL, NULL, 121780),
(121781, '3.40.50.300-FF-007271', NULL, 'Uncharacterized protein', 155, NULL, NULL, 121781),
(121782, '3.20.20.70-FF-000007', NULL, 'Chromosome 19 SCAF14664, whole genome shotgun sequence', 498, NULL, NULL, 121782),
(121783, '3.40.50.720-FF-002164', NULL, 'Uncharacterized protein', 75, NULL, NULL, 121783),
(121784, '3.20.20.60-FF-000004', NULL, '5-keto-4-deoxy-D-glucarate aldolase', 257, NULL, NULL, 121784),
(121785, '3.40.1410.10-FF-000027', NULL, 'GntR family transcriptional regulator', 158, NULL, NULL, 121785),
(121786, '1.25.40.420-FF-000070', NULL, 'Predicted protein', 103, NULL, NULL, 121786),
(121787, '3.30.559.10-FF-000228', NULL, 'Hydroxamate-type ferrichrome siderophore peptide synthetase', 175, NULL, NULL, 121787);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(121788, '3.80.10.10-FF-002156', NULL, 'F-box protein At5g51370', 409, NULL, NULL, 121788),
(121789, '2.60.40.10-FF-001604', NULL, 'Down syndrome cell adhesion molecule 3, isoform C', 100, NULL, NULL, 121789),
(121790, '3.40.720.10-FF-000006', NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase family member 2', 396, NULL, NULL, 121790),
(121791, '3.10.450.40-FF-000046', NULL, NULL, 133, NULL, NULL, 121791),
(121792, '3.40.50.2000-FF-000478', NULL, 'UDP-glycosyltransferase 88F4', 68, NULL, NULL, 121792),
(121793, '1.20.1070.10-FF-001996', NULL, 'Zgc:123156 protein', 150, NULL, NULL, 121793),
(121794, '2.30.30.380-FF-000023', NULL, 'Vesicle coat component', 67, NULL, NULL, 121794),
(121795, '3.30.40.10-FF-000283', NULL, '1-phosphatidylinositol-3-phosphate 5-kinase (Fab1)', 78, NULL, NULL, 121795),
(121796, '2.10.25.10-FF-000705', NULL, 'Notch 2', 38, NULL, NULL, 121796),
(121797, '2.60.40.10-FF-003280', NULL, NULL, 91, NULL, NULL, 121797),
(121798, '3.30.559.10-FF-000116', NULL, 'Putative diacyglycerol O-acyltransferase Rv2484c', 154, NULL, NULL, 121798),
(121799, '3.30.40.10-FF-000395', NULL, 'Putative Peroxisome biosynthesis protein (Peroxin-10)', 60, NULL, NULL, 121799),
(121800, '3.10.20.770-FF-000009', NULL, 'Phosphatidylinositol 3-kinase, putative', 147, NULL, NULL, 121800),
(121801, '3.90.1150.10-FF-000456', NULL, 'Aspartate aminotransferase', 134, NULL, NULL, 121801),
(121802, '1.20.1740.10-FF-000215', NULL, 'Uncharacterized protein', 103, NULL, NULL, 121802),
(121803, '1.10.600.10-FF-000080', NULL, 'Isoprenoid synthase domain-containing protein', 280, NULL, NULL, 121803),
(121804, '2.60.40.10-FF-001722', NULL, 'Sidekick, isoform B', 97, NULL, NULL, 121804),
(121805, '2.30.30.230-FF-000006', NULL, 'Fumarylacetoacetase', 130, NULL, NULL, 121805),
(121806, '3.40.50.300-FF-005348', NULL, 'AGAP002836-PA', 221, NULL, NULL, 121806),
(121807, '1.10.260.40-FF-000090', NULL, '2-hydroxyethylphosphonate dioxygenase', 86, NULL, NULL, 121807),
(121808, '2.60.120.1020-FF-000006', NULL, 'Peptide-N(4)-(N-acetyl-beta-glucosaminyl)asparagine amidase', 156, NULL, NULL, 121808),
(121809, '2.40.290.10-FF-000010', NULL, 'X-ray repair cross-complementing protein 6', 126, NULL, NULL, 121809),
(121810, '1.10.510.10-FF-001612', NULL, 'CAMK family protein kinase', 299, NULL, NULL, 121810),
(121811, '2.20.110.10-FF-000069', NULL, NULL, 66, NULL, NULL, 121811),
(121812, '2.60.40.10-FF-003633', NULL, NULL, 81, NULL, NULL, 121812),
(121813, '1.25.40.10-FF-003722', NULL, 'Os06g0228900 protein', 74, NULL, NULL, 121813),
(121814, '1.25.40.10-FF-003621', NULL, 'Uncharacterized protein', 104, NULL, NULL, 121814),
(121815, '3.80.10.10-FF-004185', NULL, 'Uncharacterized protein', 95, NULL, NULL, 121815),
(121816, '3.20.20.80-FF-000561', NULL, 'Uncharacterized protein', 115, NULL, NULL, 121816),
(121817, '3.40.50.620-FF-000447', NULL, 'Lysine--tRNA ligase', 195, NULL, NULL, 121817),
(121818, '3.30.70.260-FF-000109', NULL, 'Aspartokinase', 78, NULL, NULL, 121818),
(121819, '3.30.200.20-FF-000719', NULL, 'CMGC/GSK protein kinase', 80, NULL, NULL, 121819),
(121820, '1.25.40.660-FF-000023', NULL, 'Vacuolar protein sorting 35, putative', 225, NULL, NULL, 121820),
(121821, '3.30.70.330-FF-003014', NULL, NULL, 173, NULL, NULL, 121821),
(121822, '1.25.40.20-FF-001264', NULL, 'Ankyrin repeat and SOCS box-containing 12', 200, NULL, NULL, 121822),
(121823, '1.10.472.100-FF-000007', NULL, NULL, 69, NULL, NULL, 121823),
(121824, '1.10.8.10-FF-000190', NULL, 'Vacuolar protein sorting 13 homolog D', 72, NULL, NULL, 121824),
(121825, '1.25.40.10-FF-001261', NULL, 'Protein NASP homolog', 179, NULL, NULL, 121825),
(121826, '3.40.50.12780-FF-000086', NULL, 'O-succinylbenzoic acid--CoA ligase', 360, NULL, NULL, 121826),
(121827, '1.25.10.10-FF-002956', NULL, 'Uncharacterized protein', 449, NULL, NULL, 121827),
(121828, '3.40.250.10-FF-000245', NULL, 'Predicted protein', 117, NULL, NULL, 121828),
(121829, '1.25.40.510-FF-000006', NULL, 'Predicted protein', 213, NULL, NULL, 121829),
(121830, '1.20.1720.10-FF-000107', NULL, NULL, 151, NULL, NULL, 121830);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(121831, '3.40.50.300-FF-005680', NULL, 'Dynein-1-beta heavy chain, flagellar inner arm I1 complex', 187, NULL, NULL, 121831),
(121832, '1.20.58.60-FF-000764', NULL, 'Predicted protein', 253, NULL, NULL, 121832),
(121833, '1.10.287.950-FF-000002', NULL, 'Methyl-accepting chemotaxis protein', 226, NULL, NULL, 121833),
(121834, '3.10.580.10-FF-000153', NULL, 'Predicted protein', 131, NULL, NULL, 121834),
(121835, '4.10.80.300-FF-000001', NULL, 'H/ACA ribonucleoprotein complex subunit 3', 30, NULL, NULL, 121835),
(121836, '2.20.110.10-FF-000070', NULL, NULL, 114, NULL, NULL, 121836),
(121837, '3.40.50.360-FF-000004', NULL, 'NAD(P)H dehydrogenase (quinone)', 197, NULL, NULL, 121837),
(121838, '1.10.4050.10-FF-000002', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 108, NULL, NULL, 121838),
(121839, '3.40.1110.10-FF-000083', NULL, 'Phospholipid-transporting ATPase', 134, NULL, NULL, 121839),
(121840, '3.30.230.70-FF-000079', NULL, 'Exosome non-catalytic core subunit', 348, NULL, NULL, 121840),
(121841, '3.40.50.300-FF-007366', NULL, 'Uncharacterized protein', 35, NULL, NULL, 121841),
(121842, '1.10.101.10-FF-000009', NULL, 'Peptidoglycan hydrolase', 86, NULL, NULL, 121842),
(121843, '2.170.130.10-FF-000058', NULL, NULL, 140, NULL, NULL, 121843),
(121844, '3.30.70.2840-FF-000002', NULL, 'Genome polyprotein', 68, NULL, NULL, 121844),
(121845, '3.80.10.10-FF-000817', NULL, 'P53-induced death domain protein 1', 269, NULL, NULL, 121845),
(121846, '3.40.850.10-FF-000561', NULL, 'Kinesin-like protein', 80, NULL, NULL, 121846),
(121847, '1.10.8.10-FF-000201', NULL, 'Ubiquitin carboxyl-terminal hydrolase 28', 62, NULL, NULL, 121847),
(121848, '3.10.450.700-FF-000012', NULL, 'Histone acetyltransferase', 73, NULL, NULL, 121848),
(121849, '1.10.1220.10-FF-000015', NULL, 'Antitoxin VapB2', 65, NULL, NULL, 121849),
(121850, '3.30.160.60-FF-005415', NULL, NULL, 39, NULL, NULL, 121850),
(121851, '1.10.10.10-FF-001702', NULL, 'Transcriptional regulator', 84, NULL, NULL, 121851),
(121852, '1.20.120.1080-FF-000131', NULL, 'Uncharacterized protein', 86, NULL, NULL, 121852),
(121853, '3.10.129.10-FF-000066', NULL, 'Acyl-acyl carrier protein thioesterase ATL3 chloroplastic', 142, NULL, NULL, 121853),
(121854, '3.30.450.20-FF-000636', NULL, 'Uncharacterized protein', 145, NULL, NULL, 121854),
(121855, '1.10.720.30-FF-000015', NULL, '3''-5'' exoribonuclease 1', 70, NULL, NULL, 121855),
(121856, '1.20.1510.10-FF-000069', NULL, 'Zinc transporter 33D, isoform B', 199, NULL, NULL, 121856),
(121857, '3.90.380.10-FF-000002', NULL, 'Carnitine monooxygenase oxygenase subunit', 128, NULL, NULL, 121857),
(121858, '2.130.10.10-FF-003723', NULL, 'Uncharacterized protein C18E5.01', 340, NULL, NULL, 121858),
(121859, '1.10.40.30-FF-000013', NULL, 'Adenylosuccinate lyase', 87, NULL, NULL, 121859),
(121860, '2.130.10.10-FF-005409', NULL, 'Poly(A) specific ribonuclease subunit PAN2', 94, NULL, NULL, 121860),
(121861, '2.30.29.30-FF-001040', NULL, 'ArfGAP with GTPase domain, ankyrin repeat and PH domain 2', 109, NULL, NULL, 121861),
(121862, '3.30.720.150-FF-000005', NULL, 'UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase 110 kDa subunit', 95, NULL, NULL, 121862),
(121863, '2.60.450.10-FF-000018', NULL, 'LPS ABC transporter periplasmic component', 141, NULL, NULL, 121863),
(121864, '3.30.160.60-FF-006022', NULL, NULL, 30, NULL, NULL, 121864),
(121865, '1.10.150.120-FF-000002', NULL, 'xanthine dehydrogenase/oxidase', 128, NULL, NULL, 121865),
(121866, '1.10.287.70-FF-000553', NULL, 'Predicted protein', 161, NULL, NULL, 121866),
(121867, '3.30.70.330-FF-000838', NULL, 'Gbp2p', 104, NULL, NULL, 121867),
(121868, '3.30.1480.10-FF-000005', NULL, 'Transcription termination/antitermination protein NusA', 125, NULL, NULL, 121868),
(121869, '2.60.120.290-FF-000220', NULL, 'Uncharacterized protein', 127, NULL, NULL, 121869),
(121870, '3.40.33.10-FF-000153', NULL, 'Predicted protein', 133, NULL, NULL, 121870),
(121871, '2.60.120.920-FF-000010', NULL, 'E3 ubiquitin-protein ligase Midline-1', 175, NULL, NULL, 121871); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(121872, '4.10.400.10-FF-000131', NULL, 'Low-density lipoprotein receptor-related protein 1B', 40, NULL, NULL, 121872),
(121873, '2.130.10.10-FF-001571', NULL, 'WGS project CABT00000000 data, contig 2.25', 320, NULL, NULL, 121873),
(121874, '3.30.160.20-FF-000210', NULL, 'Double-stranded RNA-binding protein Staufen homolog', 73, NULL, NULL, 121874),
(121875, '3.40.250.10-FF-000150', NULL, 'Adenylyltransferase and sulfurtransferase MOCS3 homolog', 122, NULL, NULL, 121875),
(121876, '3.40.50.2300-FF-000787', NULL, 'Periplasmic binding abc transporter protein', 162, NULL, NULL, 121876),
(121877, '1.10.630.10-FF-000570', NULL, 'Uncharacterized protein', 318, NULL, NULL, 121877),
(121878, '3.30.70.2850-FF-000005', NULL, 'DNA-directed RNA polymerase subunit', 97, NULL, NULL, 121878),
(121879, '1.20.1250.20-FF-000349', NULL, 'Major facilitator superfamily domain-containing 12a', 205, NULL, NULL, 121879),
(121880, '1.25.40.10-FF-005313', NULL, 'Eukaryotic elongation factor 2 kinase', 122, NULL, NULL, 121880),
(121881, '1.20.5.170-FF-000122', NULL, 'Oncoprotein MEQ', 69, NULL, NULL, 121881),
(121882, '1.10.12.10-FF-000015', NULL, 'Enoyl-CoA hydratase/isomerase family protein', 57, NULL, NULL, 121882),
(121883, '2.60.40.1730-FF-000016', NULL, 'Aminopeptidase', 217, NULL, NULL, 121883),
(121884, '3.40.50.1220-FF-000109', NULL, 'Uncharacterized protein', 46, NULL, NULL, 121884),
(121885, '2.40.50.140-FF-000723', NULL, NULL, 62, NULL, NULL, 121885),
(121886, '1.10.287.10-FF-000013', NULL, 'Glutamyl(E) Amino-acyl tRNA Synthetase', 57, NULL, NULL, 121886),
(121887, '1.25.10.10-FF-001753', NULL, 'Uncharacterized protein', 106, NULL, NULL, 121887),
(121888, '3.40.30.10-FF-000130', NULL, 'Thioredoxin', 105, NULL, NULL, 121888),
(121889, '3.40.1180.10-FF-000031', NULL, 'Cis-prenyltransferase, putative', 134, NULL, NULL, 121889),
(121890, '3.40.50.720-FF-002484', NULL, 'Uncharacterized protein', 186, NULL, NULL, 121890),
(121891, '2.40.50.40-FF-000081', NULL, 'Chromatin-associated protein swi6', 90, NULL, NULL, 121891),
(121892, '3.40.50.720-FF-000926', NULL, 'Short-chain dehydrogenase', 264, NULL, NULL, 121892),
(121893, '1.20.120.1080-FF-000030', NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase PRP2, putative', 105, NULL, NULL, 121893),
(121894, '1.10.10.200-FF-000007', NULL, 'Probable transcriptional regulatory protein AC801_15750', 63, NULL, NULL, 121894),
(121895, '1.10.150.670-FF-000032', NULL, 'Uncharacterized protein', 97, NULL, NULL, 121895),
(121896, '3.80.10.10-FF-000464', NULL, 'P53-induced death domain protein 1', 82, NULL, NULL, 121896),
(121897, '3.40.50.300-FF-001296', NULL, 'Vacuolar membrane ATPase subunit a', 187, NULL, NULL, 121897),
(121898, '1.25.10.10-FF-000005', NULL, 'CLIP-associating protein 1 isoform 2', 257, NULL, NULL, 121898),
(121899, '2.40.50.140-FF-000369', NULL, 'ATP-dependent DNA helicase RecG', 97, NULL, NULL, 121899),
(121900, '2.60.40.10-FF-003072', NULL, 'Protein CBR-SAX-3', 89, NULL, NULL, 121900),
(121901, '3.60.10.10-FF-000178', NULL, 'Tyrosyl-DNA phosphodiesterase 2', 61, NULL, NULL, 121901),
(121902, '2.40.270.10-FF-000008', NULL, 'DNA-directed RNA polymerase subunit beta', 234, NULL, NULL, 121902),
(121903, '1.20.1070.10-FF-001788', NULL, 'Uncharacterized protein', 324, NULL, NULL, 121903),
(121904, '3.30.2090.10-FF-000004', NULL, 'Multidrug resistance protein MdtC', 89, NULL, NULL, 121904),
(121905, '1.20.1720.10-FF-000006', NULL, 'Multidrug resistance protein D', 375, NULL, NULL, 121905),
(121906, '3.30.1460.20-FF-000013', NULL, 'Arp2/3 complex 34 kDa subunit', 121, NULL, NULL, 121906),
(121907, '3.40.50.720-FF-001202', NULL, '2-deoxy-D-gluconate 3-dehydrogenase', 255, NULL, NULL, 121907),
(121908, '3.30.450.20-FF-000530', NULL, 'Response regulator', 90, NULL, NULL, 121908),
(121909, '1.25.50.20-FF-000016', NULL, 'Aminopeptidase', 324, NULL, NULL, 121909),
(121910, '2.60.40.10-FF-002796', NULL, 'Platelet-derived growth factor receptor alpha', 97, NULL, NULL, 121910),
(121911, '1.20.5.110-FF-000019', NULL, 'Vesicle-trafficking protein SEC22b', 84, NULL, NULL, 121911);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(121912, '1.10.8.60-FF-000530', NULL, 'ATPase, AAA family protein', 80, NULL, NULL, 121912),
(121913, '1.25.10.20-FF-000008', NULL, 'Uncharacterized protein', 296, NULL, NULL, 121913),
(121914, '3.60.15.10-FF-000167', NULL, 'Uncharacterized protein', 22, NULL, NULL, 121914),
(121915, '3.40.50.300-FF-001638', NULL, 'NACHT and WD40 domain protein', 174, NULL, NULL, 121915),
(121916, '1.10.357.140-FF-000046', NULL, 'Uncharacterized protein', 103, NULL, NULL, 121916),
(121917, '3.20.80.10-FF-000021', NULL, 'Uncharacterized protein', 192, NULL, NULL, 121917),
(121918, '3.40.190.10-FF-000886', NULL, 'Uncharacterized protein', 27, NULL, NULL, 121918),
(121919, '3.30.9.10-FF-000210', NULL, 'Dehydrogenase', 95, NULL, NULL, 121919),
(121920, '3.40.50.300-FF-005921', NULL, 'ABC transporter (Eurofung)', 267, NULL, NULL, 121920),
(121921, '1.10.10.440-FF-000040', NULL, 'Pre-mRNA-processing factor 40, putative', 73, NULL, NULL, 121921),
(121922, '1.25.40.20-FF-001472', NULL, 'Uncharacterized protein', 103, NULL, NULL, 121922),
(121923, '1.10.510.10-FF-003495', NULL, NULL, 258, NULL, NULL, 121923),
(121924, '3.30.780.10-FF-000052', NULL, 'Translation machinery-associated protein 22', 86, NULL, NULL, 121924),
(121925, '3.10.100.10-FF-000298', NULL, NULL, 135, NULL, NULL, 121925),
(121926, '3.80.10.10-FF-004393', NULL, 'Leucine-rich repeats and immunoglobulin-like domains 2', 165, NULL, NULL, 121926),
(121927, '1.10.3820.10-FF-000005', NULL, 'Cytochrome C', 143, NULL, NULL, 121927),
(121928, '3.30.70.330-FF-000277', NULL, 'RNA binding motif protein 19', 110, NULL, NULL, 121928),
(121929, '1.10.1370.40-FF-000012', NULL, 'Clan MA, family M3, oligopeptidase A-like metallopeptidase', 152, NULL, NULL, 121929),
(121930, '3.30.160.60-FF-002998', NULL, 'Uncharacterized protein', 29, NULL, NULL, 121930),
(121931, '2.30.42.10-FF-000391', NULL, NULL, 99, NULL, NULL, 121931),
(121932, '3.40.1190.20-FF-000192', NULL, NULL, 259, NULL, NULL, 121932),
(121933, '3.30.40.10-FF-000726', NULL, 'Os11g0142900 protein', 80, NULL, NULL, 121933),
(121934, '2.20.100.10-FF-000243', NULL, 'Uncharacterized protein', 49, NULL, NULL, 121934),
(121935, '2.10.70.10-FF-000006', NULL, 'Fibronectin 1', 51, NULL, NULL, 121935),
(121936, '3.40.50.1820-FF-000963', NULL, 'Uncharacterized protein', 279, NULL, NULL, 121936),
(121937, '1.10.560.10-FF-000120', NULL, 'T-complex protein 1 subunit eta', 154, NULL, NULL, 121937),
(121938, '2.130.10.10-FF-005168', NULL, 'AEL269Cp', 131, NULL, NULL, 121938),
(121939, '3.80.10.10-FF-000806', NULL, 'Transforming growth factor beta activator LRRC33', 272, NULL, NULL, 121939),
(121940, '1.25.40.10-FF-004695', NULL, 'Uncharacterized protein', 100, NULL, NULL, 121940),
(121941, '1.10.8.430-FF-000011', NULL, 'Disease resistance RPP13-like protein 4', 96, NULL, NULL, 121941),
(121942, '3.40.50.300-FF-003550', NULL, 'Uncharacterized protein', 91, NULL, NULL, 121942),
(121943, '3.40.50.150-FF-001666', NULL, NULL, 131, NULL, NULL, 121943),
(121944, '1.10.10.10-FF-001129', NULL, 'Transcription factor ets-4', 115, NULL, NULL, 121944),
(121945, '2.60.40.420-FF-000222', NULL, 'Uncharacterized protein', 205, NULL, NULL, 121945),
(121946, '2.20.70.140-FF-000001', NULL, NULL, 45, NULL, NULL, 121946),
(121947, '3.40.50.460-FF-000034', NULL, 'Phosphofructokinase family protein', 128, NULL, NULL, 121947),
(121948, '3.40.605.10-FF-000143', NULL, 'Uncharacterized protein', 71, NULL, NULL, 121948),
(121949, '1.10.10.160-FF-000057', NULL, 'DNA helicase', 66, NULL, NULL, 121949),
(121950, '3.40.30.10-FF-000017', NULL, 'Protein disulfide-isomerase A4', 115, NULL, NULL, 121950),
(121951, '3.40.50.300-FF-001537', NULL, 'Secretion related GTPase SrgD', 187, NULL, NULL, 121951),
(121952, '1.10.238.110-FF-000011', NULL, 'Diacylglycerol kinase', 96, NULL, NULL, 121952),
(121953, '1.10.8.60-FF-000300', NULL, 'Transitional endoplasmic reticulum ATPase TER94-like Protein', 107, NULL, NULL, 121953),
(121954, '3.40.50.450-FF-000031', NULL, 'ATP-dependent 6-phosphofructokinase', 200, NULL, NULL, 121954),
(121955, '3.10.170.20-FF-000001', NULL, 'Peptidase M8, leishmanolysin', 191, NULL, NULL, 121955); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(121956, '3.40.390.10-FF-000188', NULL, NULL, 116, NULL, NULL, 121956),
(121957, '1.10.510.10-FF-002894', NULL, NULL, 224, NULL, NULL, 121957),
(121958, '3.90.640.10-FF-000264', NULL, 'Actin family protein', 78, NULL, NULL, 121958),
(121959, '1.20.58.60-FF-000534', NULL, 'Uncharacterized protein', 312, NULL, NULL, 121959),
(121960, '3.30.710.10-FF-000446', NULL, 'Uncharacterized protein', 153, NULL, NULL, 121960),
(121961, '2.60.120.290-FF-000118', NULL, 'Metalloendopeptidase', 119, NULL, NULL, 121961),
(121962, '3.60.40.10-FF-000360', NULL, 'Uncharacterized protein', 290, NULL, NULL, 121962),
(121963, '3.30.70.660-FF-000027', NULL, 'tRNA pseudouridine synthase A', 137, NULL, NULL, 121963),
(121964, '3.80.10.10-FF-003111', NULL, 'Uncharacterized protein', 102, NULL, NULL, 121964),
(121965, '1.20.1410.10-FF-000005', NULL, 'cyclin-D1-binding protein 1', 186, NULL, NULL, 121965),
(121966, '2.30.30.140-FF-000311', NULL, 'Uncharacterized protein', 63, NULL, NULL, 121966),
(121967, '2.60.120.200-FF-000356', NULL, 'Galectin', 140, NULL, NULL, 121967),
(121968, '1.20.920.20-FF-000071', NULL, 'Uncharacterized protein', 178, NULL, NULL, 121968),
(121969, '2.30.42.10-FF-000289', NULL, 'Glutamate receptor-interacting protein 2-like Protein', 92, NULL, NULL, 121969),
(121970, '1.20.1250.60-FF-000007', NULL, 'Uncharacterized protein', 53, NULL, NULL, 121970),
(121971, '3.60.40.10-FF-000129', NULL, 'Stage II sporulation protein E', 244, NULL, NULL, 121971),
(121972, '1.10.720.80-FF-000002', NULL, 'Peptidylprolyl isomerase', 87, NULL, NULL, 121972),
(121973, '1.20.1050.10-FF-000264', NULL, 'Uncharacterized protein', 129, NULL, NULL, 121973),
(121974, '3.30.70.330-FF-001215', NULL, 'Mud1p', 86, NULL, NULL, 121974),
(121975, '1.10.238.10-FF-001018', NULL, 'Uncharacterized protein', 67, NULL, NULL, 121975),
(121976, '1.10.10.650-FF-000013', NULL, 'Transcription elongation factor Spt6', 148, NULL, NULL, 121976),
(121977, '3.30.1330.30-FF-000012', NULL, 'growth arrest and DNA damage-inducible protein GADD45 alpha', 159, NULL, NULL, 121977),
(121978, '1.10.540.10-FF-000012', NULL, 'Acyl-CoA dehydrogenase short/branched chain', 124, NULL, NULL, 121978),
(121979, '1.10.510.10-FF-001270', NULL, 'Uncharacterized protein', 112, NULL, NULL, 121979),
(121980, '2.40.50.140-FF-001100', NULL, NULL, 157, NULL, NULL, 121980),
(121981, '2.10.25.10-FF-000144', NULL, 'Low-density lipoprotein receptor-related protein 1', 44, NULL, NULL, 121981),
(121982, '3.10.50.40-FF-000141', NULL, 'Peptidyl-prolyl cis-trans isomerase', 68, NULL, NULL, 121982),
(121983, '3.40.50.300-FF-003437', NULL, 'ABC transporter, ATP-binding protein', 245, NULL, NULL, 121983),
(121984, '1.10.510.10-FF-000994', NULL, 'Hypoxia Inhibited Receptor tyrosine kinase', 206, NULL, NULL, 121984),
(121985, '1.10.1200.10-FF-000020', NULL, 'Peptide synthetase mbtE', 83, NULL, NULL, 121985),
(121986, '3.30.460.10-FF-000123', NULL, 'DNA polymerase', 111, NULL, NULL, 121986),
(121987, '3.40.50.620-FF-000094', NULL, 'Tryptophan--tRNA ligase', 216, NULL, NULL, 121987),
(121988, '1.10.10.350-FF-000024', NULL, 'Glutamate--tRNA ligase 2', 88, NULL, NULL, 121988),
(121989, '2.60.220.50-FF-000182', NULL, 'Predicted protein', 53, NULL, NULL, 121989),
(121990, '3.30.160.60-FF-005645', NULL, NULL, 32, NULL, NULL, 121990),
(121991, '1.10.8.60-FF-000075', NULL, 'Spermatogenesis-associated protein 5-like protein 1', 83, NULL, NULL, 121991),
(121992, '4.10.280.10-FF-000020', NULL, 'class E basic helix-loop-helix protein 40', 65, NULL, NULL, 121992),
(121993, '1.20.1070.10-FF-002064', NULL, 'Uncharacterized protein', 79, NULL, NULL, 121993),
(121994, '3.80.10.10-FF-002594', NULL, 'Cyclic nucleotide-binding domain-containing protein', 79, NULL, NULL, 121994),
(121995, '1.20.140.10-FF-000103', NULL, 'Uncharacterized protein', 144, NULL, NULL, 121995),
(121996, '3.30.1330.40-FF-000015', NULL, 'Fanconi anemia group J protein', 120, NULL, NULL, 121996),
(121997, '1.20.1250.40-FF-000001', NULL, 'DNA-directed RNA polymerase II subunit RPB4', 129, NULL, NULL, 121997),
(121998, '2.40.50.770-FF-000007', NULL, 'Uncharacterized protein', 151, NULL, NULL, 121998);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(121999, '3.40.50.300-FF-000014', NULL, 'DNA polymerase III subunit gamma/tau', 177, NULL, NULL, 121999),
(122000, '3.20.20.80-FF-000802', NULL, 'Uncharacterized protein', 142, NULL, NULL, 122000),
(122001, '3.40.50.10380-FF-000012', NULL, 'Malic enzyme', 232, NULL, NULL, 122001),
(122002, '3.30.230.10-FF-000089', NULL, 'Type 2 DNA topoisomerase 6 subunit B', 160, NULL, NULL, 122002),
(122003, '2.30.42.10-FF-000278', NULL, 'DEGP protease 2', 105, NULL, NULL, 122003),
(122004, '1.20.1270.60-FF-000115', NULL, 'Putative Dynamin-binding protein', 229, NULL, NULL, 122004),
(122005, '3.30.160.60-FF-001155', NULL, 'Zinc finger 30C', 29, NULL, NULL, 122005),
(122006, '3.10.580.10-FF-000052', NULL, 'Cystathionine beta-synthase', 153, NULL, NULL, 122006),
(122007, '1.20.5.170-FF-000223', NULL, 'YALI0D23287p', 77, NULL, NULL, 122007),
(122008, '3.40.50.2300-FF-000467', NULL, 'Probable two-component response regulator', 166, NULL, NULL, 122008),
(122009, '2.40.240.130-FF-000001', NULL, 'Segment polarity protein dishevelled homolog DVL-1', 82, NULL, NULL, 122009),
(122010, '1.25.40.120-FF-000081', NULL, 'Uncharacterized protein', 323, NULL, NULL, 122010),
(122011, '3.30.200.20-FF-000596', NULL, 'Possible aminoglycoside phosphotransferase', 91, NULL, NULL, 122011),
(122012, '3.30.1440.10-FF-000008', NULL, 'Ribosomal L5P family protein', 159, NULL, NULL, 122012),
(122013, '3.60.20.10-FF-000252', NULL, NULL, 181, NULL, NULL, 122013),
(122014, '2.60.40.10-FF-001368', NULL, 'Leucine rich repeat, Ig-like and transmembrane domains 3', 77, NULL, NULL, 122014),
(122015, '3.30.1520.10-FF-000066', NULL, 'Related to BEM3-GTPase-activating protein', 137, NULL, NULL, 122015),
(122016, '1.10.418.70-FF-000010', NULL, 'Uncharacterized protein', 121, NULL, NULL, 122016),
(122017, '3.50.50.60-FF-001112', NULL, 'Predicted protein', 164, NULL, NULL, 122017),
(122018, '3.30.540.10-FF-000079', NULL, 'Inositol monophosphatase family protein', 152, NULL, NULL, 122018),
(122019, '1.20.1250.20-FF-000692', NULL, 'SLC (SoLute Carrier) homolog', 216, NULL, NULL, 122019),
(122020, '3.30.420.40-FF-001079', NULL, 'Uncharacterized protein', 133, NULL, NULL, 122020),
(122021, '1.10.10.10-FF-001461', NULL, 'RIO-like kinase', 89, NULL, NULL, 122021),
(122022, '1.25.10.10-FF-000938', NULL, 'protein penguin', 281, NULL, NULL, 122022),
(122023, '1.10.10.2330-FF-000017', NULL, NULL, 57, NULL, NULL, 122023),
(122024, '3.40.50.10140-FF-000070', NULL, 'Toll-like receptor 19', 100, NULL, NULL, 122024),
(122025, '3.40.850.10-FF-000448', NULL, 'Predicted protein', 102, NULL, NULL, 122025),
(122026, '1.20.58.2130-FF-000005', NULL, 'Uncharacterized protein', 66, NULL, NULL, 122026),
(122027, '3.40.190.10-FF-000448', NULL, 'ABC transporter, substrate-binding protein', 103, NULL, NULL, 122027),
(122028, '3.30.70.330-FF-000597', NULL, 'Putative RNA-binding protein', 84, NULL, NULL, 122028),
(122029, '1.25.10.10-FF-001091', NULL, 'Hypothetical_protein_-_conserved', 294, NULL, NULL, 122029),
(122030, '1.10.1040.10-FF-000029', NULL, '6-phosphogluconate dehydrogenase (Decarboxylating)', 153, NULL, NULL, 122030),
(122031, '3.30.160.60-FF-005084', NULL, NULL, 32, NULL, NULL, 122031),
(122032, '3.60.110.10-FF-000096', NULL, NULL, 301, NULL, NULL, 122032),
(122033, '3.30.60.90-FF-000032', NULL, 'E3 ubiquitin-protein ligase HERC2', 54, NULL, NULL, 122033),
(122034, '3.50.50.60-FF-000494', NULL, 'FAD-dependent monooxygenase', 171, NULL, NULL, 122034),
(122035, '2.130.10.10-FF-001812', NULL, 'Transducin/WD40 repeat-like superfamily protein', 126, NULL, NULL, 122035),
(122036, '1.20.58.2140-FF-000008', NULL, 'Translin family protein', 201, NULL, NULL, 122036),
(122037, '1.20.1070.10-FF-000473', NULL, 'Uncharacterized protein', 302, NULL, NULL, 122037),
(122038, '1.20.1250.20-FF-000462', NULL, 'Monocarboxylate transporter, putative', 193, NULL, NULL, 122038),
(122039, '3.30.70.330-FF-000939', NULL, 'Putative polypyrimidine tract binding protein', 106, NULL, NULL, 122039),
(122040, '3.30.1370.210-FF-000008', NULL, 'zinc finger CCCH domain-containing protein 11A isoform X1', 62, NULL, NULL, 122040);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(122041, '3.90.340.10-FF-000005', NULL, 'Nitric oxide synthase', 174, NULL, NULL, 122041),
(122042, '2.130.10.10-FF-005303', NULL, 'Uncharacterized protein', 214, NULL, NULL, 122042),
(122043, '1.50.40.10-FF-000011', NULL, 'Mitochondrial thiamine pyrophosphate carrier 1', 307, NULL, NULL, 122043),
(122044, '2.70.160.11-FF-000085', NULL, 'Uncharacterized protein', 191, NULL, NULL, 122044),
(122045, '3.40.50.2000-FF-000372', NULL, 'UDP-Glycosyltransferase superfamily protein', 272, NULL, NULL, 122045),
(122046, '2.60.120.200-FF-000811', NULL, 'Calreticulin', 171, NULL, NULL, 122046),
(122047, '1.25.40.20-FF-000510', NULL, 'Ankyrin repeat family protein', 366, NULL, NULL, 122047),
(122048, '3.30.310.10-FF-000011', NULL, 'Coatomer subunit gamma', 117, NULL, NULL, 122048),
(122049, '3.90.1170.50-FF-000008', NULL, 'Xanthine dehydrogenase, molybdenum binding subunit', 102, NULL, NULL, 122049),
(122050, '3.30.930.10-FF-000209', NULL, 'ATP phosphoribosyltransferase regulatory subunit', 322, NULL, NULL, 122050),
(122051, '1.25.40.10-FF-003267', NULL, 'Pentatricopeptide repeat-containing protein isoform A', 145, NULL, NULL, 122051),
(122052, '3.90.1170.40-FF-000005', NULL, 'Putative molybdenum cofactor biosynthesis protein e2 moaE2', 138, NULL, NULL, 122052),
(122053, '2.130.10.10-FF-003370', NULL, 'Selective LIM binding factor, putative', 273, NULL, NULL, 122053),
(122054, '2.60.300.12-FF-000021', NULL, NULL, 106, NULL, NULL, 122054),
(122055, '1.10.630.10-FF-000811', NULL, 'Predicted protein', 290, NULL, NULL, 122055),
(122056, '1.10.510.10-FF-003618', NULL, NULL, 196, NULL, NULL, 122056),
(122057, '1.20.1740.10-FF-000092', NULL, 'Putative L-type amino acid transporter 1-like protein MLAS', 138, NULL, NULL, 122057),
(122058, '1.20.1080.10-FF-000092', NULL, 'Aquaporin-2, putative', 118, NULL, NULL, 122058),
(122059, '1.10.10.60-FF-001240', NULL, NULL, 46, NULL, NULL, 122059),
(122060, '3.90.1170.30-FF-000002', NULL, 'Pyrimidine-nucleoside phosphorylase', 88, NULL, NULL, 122060),
(122061, '1.10.287.10-FF-000024', NULL, 'Protein phosphatase', 41, NULL, NULL, 122061),
(122062, '3.90.1150.10-FF-000355', NULL, 'dTDP-4-amino-4,6-dideoxygalactose transaminase', 122, NULL, NULL, 122062),
(122063, '3.10.450.40-FF-000057', NULL, NULL, 75, NULL, NULL, 122063),
(122064, '2.40.50.90-FF-000180', NULL, 'Enhanced RNAI (RNA interference)', 95, NULL, NULL, 122064),
(122065, '1.10.510.10-FF-001157', NULL, 'Calcium/calmodulin-dependent protein kinase type II delta 1 chain', 82, NULL, NULL, 122065),
(122066, '1.20.1250.20-FF-001777', NULL, 'Uncharacterized protein', 185, NULL, NULL, 122066),
(122067, '3.80.10.10-FF-002055', NULL, 'Leucine-rich repeat receptor-like protein kinase PEPR1', 173, NULL, NULL, 122067),
(122068, '1.10.510.10-FF-003950', NULL, NULL, 55, NULL, NULL, 122068),
(122069, '3.30.559.10-FF-000217', NULL, 'Uncharacterized protein', 192, NULL, NULL, 122069),
(122070, '2.130.10.10-FF-001458', NULL, 'Os01g0606133 protein', 125, NULL, NULL, 122070),
(122071, '3.30.70.330-FF-002851', NULL, NULL, 82, NULL, NULL, 122071),
(122072, '3.30.1640.30-FF-000002', NULL, 'Spaetzle-processing enzyme', 67, NULL, NULL, 122072),
(122073, '3.30.310.130-FF-000013', NULL, 'Related to protease ULP2 protein', 54, NULL, NULL, 122073),
(122074, '1.10.640.10-FF-000076', NULL, 'Uncharacterized protein', 58, NULL, NULL, 122074),
(122075, '2.60.40.420-FF-000087', NULL, 'Spore coat protein A', 174, NULL, NULL, 122075),
(122076, '3.80.10.10-FF-001779', NULL, 'F-box/LRR-repeat protein 14-like Protein', 145, NULL, NULL, 122076),
(122077, '3.40.50.2300-FF-001304', NULL, NULL, 253, NULL, NULL, 122077),
(122078, '3.40.50.720-FF-000365', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', 195, NULL, NULL, 122078),
(122079, '3.30.160.60-FF-001716', NULL, 'Zinc finger protein 516', 26, NULL, NULL, 122079),
(122080, '3.80.10.10-FF-004516', NULL, 'Uncharacterized protein', 64, NULL, NULL, 122080),
(122081, '1.20.1560.10-FF-000460', NULL, 'ABC transporter D family member 1', 284, NULL, NULL, 122081),
(122082, '3.30.160.60-FF-004589', NULL, NULL, 75, NULL, NULL, 122082);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(122083, '2.60.120.920-FF-000116', NULL, 'Uncharacterized protein', 163, NULL, NULL, 122083),
(122084, '3.40.50.2000-FF-000933', NULL, 'Mannosyltransferase, putative', 149, NULL, NULL, 122084),
(122085, '3.90.190.10-FF-000420', NULL, 'Uncharacterized protein', 92, NULL, NULL, 122085),
(122086, '3.50.50.60-FF-000836', NULL, 'Probable FAD-dependent oxidoreductase PA4991', 99, NULL, NULL, 122086),
(122087, '2.60.260.20-FF-000097', NULL, 'Chaperone protein DNAJ-like protein', 119, NULL, NULL, 122087),
(122088, '1.10.720.30-FF-000004', NULL, 'heterogeneous nuclear ribonucleoprotein U isoform X1', 52, NULL, NULL, 122088),
(122089, '2.10.25.10-FF-000374', NULL, 'Integrin subunit beta like 1', 46, NULL, NULL, 122089),
(122090, '3.30.390.30-FF-000022', NULL, 'Nitrite reductase large subunit', 82, NULL, NULL, 122090),
(122091, '3.50.30.30-FF-000045', NULL, 'Predicted protein', 222, NULL, NULL, 122091),
(122092, '3.30.40.10-FF-002194', NULL, 'Uncharacterized protein', 76, NULL, NULL, 122092),
(122093, '3.30.160.60-FF-003616', NULL, 'histone H4 transcription factor', 79, NULL, NULL, 122093),
(122094, '3.20.20.140-FF-000004', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 288, NULL, NULL, 122094),
(122095, '2.10.220.10-FF-000001', NULL, 'Receptor protein-tyrosine kinase', 119, NULL, NULL, 122095),
(122096, '1.25.40.10-FF-002907', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 194, NULL, NULL, 122096),
(122097, '2.130.10.10-FF-003712', NULL, 'Uncharacterized protein', 60, NULL, NULL, 122097),
(122098, '3.30.930.10-FF-000002', NULL, 'Threonine--tRNA ligase', 309, NULL, NULL, 122098),
(122099, '3.80.10.10-FF-003679', NULL, 'Predicted protein', 201, NULL, NULL, 122099),
(122100, '3.30.200.20-FF-001433', NULL, 'Homoserine kinase', 104, NULL, NULL, 122100),
(122101, '2.60.120.290-FF-000231', NULL, 'Metalloendopeptidase', 81, NULL, NULL, 122101),
(122102, '1.10.8.10-FF-000212', NULL, 'GD19730', 72, NULL, NULL, 122102),
(122103, '3.40.50.1820-FF-000183', NULL, 'Phosphatidylcholine-sterol acyltransferase', 206, NULL, NULL, 122103),
(122104, '3.30.160.60-FF-000879', NULL, 'Chromosome alignment maintaining phosphoprotein 1', 81, NULL, NULL, 122104),
(122105, '1.25.10.10-FF-001433', NULL, 'TSC complex subunit 2', 317, NULL, NULL, 122105),
(122106, '2.60.120.620-FF-000021', NULL, 'WGS project CABT00000000 data, contig 2.8', 207, NULL, NULL, 122106),
(122107, '2.130.10.10-FF-001251', NULL, 'Autophagy-related protein 18', 144, NULL, NULL, 122107),
(122108, '3.30.390.80-FF-000008', NULL, 'Uncharacterized protein', 64, NULL, NULL, 122108),
(122109, '2.40.30.300-FF-000003', NULL, 'DEAD-box family ATP dependent helicase', 124, NULL, NULL, 122109),
(122110, '3.20.20.80-FF-000448', NULL, 'Mannosidase, endo-alpha', 135, NULL, NULL, 122110),
(122111, '1.10.150.510-FF-000012', NULL, 'Si:ch73-334d15.2', 93, NULL, NULL, 122111),
(122112, '2.130.10.10-FF-004685', NULL, 'Uncharacterized protein', 179, NULL, NULL, 122112),
(122113, '1.10.630.10-FF-000250', NULL, 'Cytochrome P450, family 71, subfamily B, polypeptide 37', 474, NULL, NULL, 122113),
(122114, '1.10.510.10-FF-003057', NULL, NULL, 252, NULL, NULL, 122114),
(122115, '2.30.29.30-FF-000871', NULL, 'Chromosome 7, whole genome shotgun sequence', 126, NULL, NULL, 122115),
(122116, '3.40.50.300-FF-002032', NULL, 'DNA repair helicase RAD3, putative', 98, NULL, NULL, 122116),
(122117, '3.80.10.10-FF-000576', NULL, 'Leucine rich repeats and transmembrane domains 2', 177, NULL, NULL, 122117),
(122118, '2.130.10.10-FF-005410', NULL, 'BEACH domain-containing protein lvsA', 187, NULL, NULL, 122118),
(122119, '4.10.280.10-FF-000132', NULL, 'CRE-HLH-2 protein', 82, NULL, NULL, 122119),
(122120, '1.10.1200.10-FF-000019', NULL, 'Phenolpthiocerol synthesis type-I polyketide synthase PPSA', 83, NULL, NULL, 122120),
(122121, '3.40.50.720-FF-000472', NULL, 'Conserved protein', 195, NULL, NULL, 122121),
(122122, '3.30.160.60-FF-001587', NULL, 'Zinc finger protein 57', 27, NULL, NULL, 122122),
(122123, '2.40.40.10-FF-000020', NULL, NULL, 112, NULL, NULL, 122123),
(122124, '2.10.25.10-FF-001785', NULL, 'Uncharacterized protein', 32, NULL, NULL, 122124);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(122125, '3.40.50.1820-FF-000418', NULL, 'Lpx1p', 354, NULL, NULL, 122125),
(122126, '1.20.120.560-FF-000007', NULL, 'pH-response regulator protein palA/RIM20', 160, NULL, NULL, 122126),
(122127, '2.130.10.10-FF-004786', NULL, 'Uncharacterized protein', 150, NULL, NULL, 122127),
(122128, '3.30.9.10-FF-000081', NULL, 'FAD dependent oxidoreductase', 150, NULL, NULL, 122128),
(122129, '3.40.30.10-FF-000135', NULL, 'DnaJ homolog subfamily C member 10', 105, NULL, NULL, 122129),
(122130, '1.25.40.180-FF-000076', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 164, NULL, NULL, 122130),
(122131, '1.25.40.10-FF-004577', NULL, 'Uncharacterized protein', 184, NULL, NULL, 122131),
(122132, '3.20.20.140-FF-000330', NULL, 'Uncharacterized protein', 60, NULL, NULL, 122132),
(122133, '3.30.70.330-FF-001440', NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', 152, NULL, NULL, 122133),
(122134, '3.60.20.10-FF-000139', NULL, 'Proteasome subunit beta', 234, NULL, NULL, 122134),
(122135, '1.25.40.10-FF-003054', NULL, 'Pentatricopeptide repeat-containing protein', 72, NULL, NULL, 122135),
(122136, '1.10.287.3550-FF-000008', NULL, 'Uncharacterized protein', 93, NULL, NULL, 122136),
(122137, '2.60.120.200-FF-000468', NULL, 'Heparan sulfate proteoglycan 2', 163, NULL, NULL, 122137),
(122138, '3.30.479.30-FF-000048', NULL, 'Predicted protein', 45, NULL, NULL, 122138),
(122139, '1.25.40.1030-FF-000007', NULL, 'Protein transport protein (SEC31), putative', 433, NULL, NULL, 122139),
(122140, '1.20.900.10-FF-000066', NULL, 'RhoGAP domain containing protein', 165, NULL, NULL, 122140),
(122141, '2.40.50.1070-FF-000020', NULL, NULL, 52, NULL, NULL, 122141),
(122142, '2.130.10.10-FF-003263', NULL, 'RNA polymerase II Elongator subunit', 190, NULL, NULL, 122142),
(122143, '3.40.50.300-FF-003662', NULL, 'Dynein heavy chain 5, axonemal', 333, NULL, NULL, 122143),
(122144, '2.20.100.10-FF-000131', NULL, 'papilin isoform X3', 58, NULL, NULL, 122144),
(122145, '1.10.510.10-FF-002101', NULL, 'Protein kinase, putative', 223, NULL, NULL, 122145),
(122146, '2.40.50.140-FF-000829', NULL, NULL, 101, NULL, NULL, 122146),
(122147, '3.40.190.10-FF-000768', NULL, 'ABC-type transport system periplasmic substrate-binding protein (Probable substrate dipeptide/oligopeptide)', 276, NULL, NULL, 122147),
(122148, '3.40.50.2000-FF-000927', NULL, 'Uncharacterized protein', 156, NULL, NULL, 122148),
(122149, '3.30.40.10-FF-000838', NULL, 'Uncharacterized protein', 59, NULL, NULL, 122149),
(122150, '3.40.1190.20-FF-000080', NULL, 'BnaC05g04640D protein', 336, NULL, NULL, 122150),
(122151, '3.30.450.20-FF-000395', NULL, 'Methyl-accepting chemotaxis protein', 88, NULL, NULL, 122151),
(122152, '3.30.479.20-FF-000045', NULL, 'Elongation factor Ts, mitochondrial 1', 98, NULL, NULL, 122152),
(122153, '2.60.40.10-FF-001149', NULL, 'Turtle, isoform H', 94, NULL, NULL, 122153),
(122154, '3.30.70.330-FF-002637', NULL, NULL, 123, NULL, NULL, 122154),
(122155, '3.30.200.20-FF-001192', NULL, 'Probable kinase CHARK', 97, NULL, NULL, 122155),
(122156, '3.30.160.60-FF-003734', NULL, 'Kruppel-Like Factor (Zinc finger protein)', 46, NULL, NULL, 122156),
(122157, '3.40.630.30-FF-000230', NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', 204, NULL, NULL, 122157),
(122158, '1.10.510.10-FF-001477', NULL, 'Protein CBG16284', 345, NULL, NULL, 122158),
(122159, '3.80.10.10-FF-002723', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 71, NULL, NULL, 122159),
(122160, '1.20.1560.10-FF-000448', NULL, 'Uncharacterized protein', 282, NULL, NULL, 122160),
(122161, '2.60.15.10-FF-000006', NULL, 'ATP synthase epsilon chain', 122, NULL, NULL, 122161),
(122162, '3.40.50.150-FF-001127', NULL, NULL, 233, NULL, NULL, 122162),
(122163, '2.60.40.10-FF-003178', NULL, '4-alpha-glucanotransferase DPE2', 114, NULL, NULL, 122163),
(122164, '1.25.40.180-FF-000183', NULL, NULL, 91, NULL, NULL, 122164),
(122165, '1.20.58.60-FF-000652', NULL, 'Uncharacterized protein', 157, NULL, NULL, 122165),
(122166, '1.20.1290.10-FF-000017', NULL, '4-carboxymuconolactone decarboxylase, putative', 132, NULL, NULL, 122166);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(122167, '1.20.58.150-FF-000003', NULL, 'Putative clathrin assembly protein', 149, NULL, NULL, 122167),
(122168, '2.30.42.10-FF-000519', NULL, NULL, 71, NULL, NULL, 122168),
(122169, '1.10.10.10-FF-001360', NULL, 'Rho-GTPase-activating protein 8', 92, NULL, NULL, 122169),
(122170, '3.30.160.60-FF-003841', NULL, NULL, 67, NULL, NULL, 122170),
(122171, '3.30.160.60-FF-001694', NULL, 'zinc finger protein with KRAB and SCAN domains 5 isoform X1', 51, NULL, NULL, 122171),
(122172, '1.20.58.160-FF-000006', NULL, 'TOM1-like protein 1', 97, NULL, NULL, 122172),
(122173, '3.40.50.150-FF-001234', NULL, NULL, 169, NULL, NULL, 122173),
(122174, '3.30.200.20-FF-002389', NULL, 'Uncharacterized protein', 101, NULL, NULL, 122174),
(122175, '1.10.510.10-FF-003624', NULL, NULL, 195, NULL, NULL, 122175),
(122176, '2.130.10.10-FF-003156', NULL, 'Chromatin assembly factor 1, subunit B', 203, NULL, NULL, 122176),
(122177, '1.25.10.10-FF-000697', NULL, 'Sister chromatid cohesion protein', 169, NULL, NULL, 122177),
(122178, '3.30.420.60-FF-000006', NULL, 'Protein pelota homolog', 135, NULL, NULL, 122178),
(122179, '3.30.70.330-FF-002963', NULL, NULL, 153, NULL, NULL, 122179),
(122180, '3.20.20.10-FF-000017', NULL, 'Alanine racemase', 246, NULL, NULL, 122180),
(122181, '3.80.10.10-FF-004180', NULL, 'Uncharacterized protein', 97, NULL, NULL, 122181),
(122182, '1.20.1070.10-FF-000815', NULL, 'Predicted protein', 270, NULL, NULL, 122182),
(122183, '3.40.50.300-FF-003555', NULL, 'RAB43, member RAS oncogene family', 132, NULL, NULL, 122183),
(122184, '1.20.1070.10-FF-000478', NULL, 'DihydroCaffeic Acid Receptor', 311, NULL, NULL, 122184),
(122185, '1.10.2000.10-FF-000038', NULL, NULL, 82, NULL, NULL, 122185),
(122186, '1.20.5.100-FF-000011', NULL, 'Integrin beta', 73, NULL, NULL, 122186),
(122187, '3.30.70.330-FF-001333', NULL, 'ACINus (Mammalian Apoptotic Chromatin condensation Inducer in the Nucleus) homolog', 158, NULL, NULL, 122187),
(122188, '1.25.40.10-FF-003380', NULL, 'Os03g0861900 protein', 153, NULL, NULL, 122188),
(122189, '3.40.30.10-FF-000242', NULL, 'Ypt homolog1', 82, NULL, NULL, 122189),
(122190, '2.10.25.10-FF-000262', NULL, 'Thrombospondin 4', 47, NULL, NULL, 122190),
(122191, '2.30.30.490-FF-000062', NULL, 'PolyBRoMo domain containing', 217, NULL, NULL, 122191),
(122192, '1.20.930.10-FF-000012', NULL, 'Protein IWS1 homolog 1', 148, NULL, NULL, 122192),
(122193, '1.10.287.370-FF-000031', NULL, 'Prefoldin subunit 6, putative', 105, NULL, NULL, 122193),
(122194, '3.60.20.10-FF-000246', NULL, NULL, 61, NULL, NULL, 122194),
(122195, '3.30.930.10-FF-000434', NULL, 'Uncharacterized protein', 103, NULL, NULL, 122195),
(122196, '3.30.760.10-FF-000062', NULL, 'eukaryotic translation initiation factor 4E-1A', 189, NULL, NULL, 122196),
(122197, '1.20.1250.20-FF-002154', NULL, 'Uncharacterized protein', 197, NULL, NULL, 122197),
(122198, '3.40.50.10490-FF-000152', NULL, NULL, 141, NULL, NULL, 122198),
(122199, '3.90.320.10-FF-000015', NULL, 'ATP-dependent helicase/nuclease subunit A', 235, NULL, NULL, 122199),
(122200, '1.20.5.110-FF-000014', NULL, 'Transport protein sec22', 62, NULL, NULL, 122200),
(122201, '1.10.1670.10-FF-000066', NULL, NULL, 86, NULL, NULL, 122201),
(122202, '3.50.50.60-FF-000724', NULL, 'Dihydrolipoamide dehydrogenase, putative', 135, NULL, NULL, 122202),
(122203, '1.25.40.10-FF-005201', NULL, 'Uncharacterized protein', 211, NULL, NULL, 122203),
(122204, '1.25.10.10-FF-001321', NULL, 'IMportin Beta family', 1057, NULL, NULL, 122204),
(122205, '1.10.287.380-FF-000034', NULL, 'tRNA synthetases class I-domain-containing protein', 72, NULL, NULL, 122205),
(122206, '1.20.1270.60-FF-000227', NULL, 'Uncharacterized protein', 171, NULL, NULL, 122206),
(122207, '3.20.20.140-FF-000223', NULL, 'TatD DNase', 318, NULL, NULL, 122207),
(122208, '2.40.40.20-FF-000023', NULL, 'Tetrathionate reductase subunit A', 153, NULL, NULL, 122208),
(122209, '3.30.160.60-FF-002211', NULL, 'Tripartite motif-containing protein 14', 70, NULL, NULL, 122209),
(122210, '3.90.190.10-FF-000066', NULL, 'Dual specificity protein phosphatase 1', 146, NULL, NULL, 122210); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(122211, '2.60.40.10-FF-005432', NULL, NULL, 97, NULL, NULL, 122211),
(122212, '1.10.1300.10-FF-000078', NULL, 'Uncharacterized protein', 48, NULL, NULL, 122212),
(122213, '1.10.510.10-FF-003731', NULL, NULL, 151, NULL, NULL, 122213),
(122214, '3.60.10.10-FF-000072', NULL, 'Extracellular nuclease', 314, NULL, NULL, 122214),
(122215, '3.40.630.30-FF-000123', NULL, 'N-terminal acetyltransferase A complex catalytic subunit ARD1', 152, NULL, NULL, 122215),
(122216, '1.10.287.1150-FF-000024', NULL, 'Uncharacterized protein', 78, NULL, NULL, 122216),
(122217, '1.10.533.10-FF-000102', NULL, 'Imd', 106, NULL, NULL, 122217),
(122218, '1.10.357.40-FF-000005', NULL, 'Uncharacterized protein', 159, NULL, NULL, 122218),
(122219, '3.30.780.10-FF-000057', NULL, 'Uncharacterized protein', 77, NULL, NULL, 122219),
(122220, '2.10.50.10-FF-000112', NULL, 'Tumor necrosis factor receptor superfamily member 6', 63, NULL, NULL, 122220),
(122221, '3.40.50.720-FF-001888', NULL, 'Uncharacterized protein', 186, NULL, NULL, 122221),
(122222, '1.25.10.70-FF-000006', NULL, 'Nucleoporin subcomplex protein binding to Pom34-domain-containing protein', 281, NULL, NULL, 122222),
(122223, '2.60.40.10-FF-001380', NULL, 'Peripheral-type benzodiazepine receptor-associated protein 1', 88, NULL, NULL, 122223),
(122224, '3.90.190.20-FF-000069', NULL, 'Folylpolyglutamate synthase', 172, NULL, NULL, 122224),
(122225, '3.30.70.330-FF-002744', NULL, NULL, 92, NULL, NULL, 122225),
(122226, '1.25.40.90-FF-000059', NULL, 'Uncharacterized protein', 130, NULL, NULL, 122226),
(122227, '1.10.510.10-FF-001258', NULL, 'Protein CBG18395', 197, NULL, NULL, 122227),
(122228, '3.30.70.330-FF-002856', NULL, NULL, 80, NULL, NULL, 122228),
(122229, '1.25.10.10-FF-003226', NULL, 'Uncharacterized protein', 260, NULL, NULL, 122229),
(122230, '3.30.40.10-FF-000619', NULL, 'Putative E3 ubiquitin-protein ligase HERC1', 69, NULL, NULL, 122230),
(122231, '3.10.200.10-FF-000013', NULL, 'Carbonic AnHydrase', 255, NULL, NULL, 122231),
(122232, '3.90.190.10-FF-000526', NULL, 'Uncharacterized protein', 270, NULL, NULL, 122232),
(122233, '3.40.50.410-FF-000255', NULL, 'Predicted protein', 194, NULL, NULL, 122233),
(122234, '2.60.220.50-FF-000081', NULL, 'Predicted protein', 79, NULL, NULL, 122234),
(122235, '2.60.40.550-FF-000002', NULL, 'Ecotin, putative', 79, NULL, NULL, 122235),
(122236, '3.30.413.10-FF-000003', NULL, 'Sulfite reductase [NADPH] hemoprotein beta-component', 142, NULL, NULL, 122236),
(122237, '2.30.30.100-FF-000097', NULL, 'U6 snRNA-associated Sm-like protein LSm8', 109, NULL, NULL, 122237),
(122238, '1.25.40.20-FF-001819', NULL, 'Skeletrophin, putative', 158, NULL, NULL, 122238),
(122239, '2.30.42.10-FF-000626', NULL, NULL, 75, NULL, NULL, 122239),
(122240, '2.10.25.10-FF-000481', NULL, 'Integrin subunit beta like 1', 37, NULL, NULL, 122240),
(122241, '2.40.50.140-FF-000936', NULL, NULL, 87, NULL, NULL, 122241),
(122242, '2.30.29.30-FF-000545', NULL, 'Phosphoinositide 3-phosphatase', 97, NULL, NULL, 122242),
(122243, '3.90.25.10-FF-000076', NULL, 'UDP-glucose 4-epimerase', 110, NULL, NULL, 122243),
(122244, '3.30.1370.30-FF-000014', NULL, 'Uncharacterized protein', 34, NULL, NULL, 122244),
(122245, '2.30.39.10-FF-000034', NULL, 'Serine proteinase inhibitor 2', 118, NULL, NULL, 122245),
(122246, '3.30.160.60-FF-003515', NULL, NULL, 31, NULL, NULL, 122246),
(122247, '2.40.50.90-FF-000067', NULL, 'Tudor domain-containing protein 6', 55, NULL, NULL, 122247),
(122248, '1.10.150.50-FF-000202', NULL, 'Uncharacterized protein', 84, NULL, NULL, 122248),
(122249, '3.40.1110.10-FF-000307', NULL, NULL, 235, NULL, NULL, 122249),
(122250, '1.20.1070.10-FF-000708', NULL, 'Uncharacterized protein', 306, NULL, NULL, 122250),
(122251, '3.30.40.10-FF-002295', NULL, 'Histone-lysine N-methyltransferase', 33, NULL, NULL, 122251),
(122252, '1.10.510.10-FF-000769', NULL, 'Uncharacterized protein', 212, NULL, NULL, 122252),
(122253, '2.40.50.120-FF-000037', NULL, 'Predicted protein', 147, NULL, NULL, 122253),
(122254, '1.10.287.660-FF-000011', NULL, 'Protein SRN2', 82, NULL, NULL, 122254);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(122255, '1.20.1070.10-FF-000585', NULL, 'Uncharacterized protein', 116, NULL, NULL, 122255),
(122256, '3.80.10.10-FF-002504', NULL, 'ADR009Wp', 118, NULL, NULL, 122256),
(122257, '3.40.50.2000-FF-000708', NULL, 'Lipopolysaccharide core biosynthesis protein rfaQ', 170, NULL, NULL, 122257),
(122258, '3.40.50.300-FF-004859', NULL, 'Mismatch repair protein MSH5, putative', 290, NULL, NULL, 122258),
(122259, '2.10.25.10-FF-001678', NULL, 'Uncharacterized protein', 67, NULL, NULL, 122259),
(122260, '1.10.486.10-FF-000037', NULL, 'DNA helicase', 157, NULL, NULL, 122260),
(122261, '3.30.70.2150-FF-000003', NULL, 'GlcNAc-binding protein A', 108, NULL, NULL, 122261),
(122262, '2.10.90.10-FF-000002', NULL, 'Brain-derived neurotrophic factor', 119, NULL, NULL, 122262),
(122263, '3.20.20.80-FF-000673', NULL, 'Predicted protein', 351, NULL, NULL, 122263),
(122264, '1.20.970.10-FF-000014', NULL, 'Anthranilate phosphoribosyltransferase', 64, NULL, NULL, 122264),
(122265, '3.40.720.10-FF-000124', NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase 1', 120, NULL, NULL, 122265),
(122266, '1.25.10.10-FF-003445', NULL, 'Uncharacterized protein', 232, NULL, NULL, 122266),
(122267, '2.60.120.330-FF-000153', NULL, 'Uncharacterized protein', 115, NULL, NULL, 122267),
(122268, '3.40.1690.20-FF-000005', NULL, 'Paraplegin, putative', 95, NULL, NULL, 122268),
(122269, '3.40.50.300-FF-001419', NULL, 'Macrolide ABC transporter ATP-binding protein', 222, NULL, NULL, 122269),
(122270, '2.60.40.10-FF-003285', NULL, 'Mcam protein', 98, NULL, NULL, 122270),
(122271, '1.10.1370.10-FF-000026', NULL, 'Si:ch73-1a9.4', 160, NULL, NULL, 122271),
(122272, '1.10.555.10-FF-000052', NULL, 'Rho GTPase-activating protein REN1', 225, NULL, NULL, 122272),
(122273, '1.20.1410.10-FF-000011', NULL, 'Cyclin-D1-binding protein', 193, NULL, NULL, 122273),
(122274, '3.40.390.10-FF-000194', NULL, 'Metalloendopeptidase', 236, NULL, NULL, 122274),
(122275, '1.10.510.10-FF-003512', NULL, NULL, 250, NULL, NULL, 122275),
(122276, '1.10.287.470-FF-000061', NULL, 'Putative multidrug resistance protein', 74, NULL, NULL, 122276),
(122277, '3.40.1690.10-FF-000002', NULL, 'SPI-1 type III secretion system export apparatus protein SpaS', 98, NULL, NULL, 122277),
(122278, '2.130.10.110-FF-000027', NULL, 'Clathrin heavy chain', 117, NULL, NULL, 122278),
(122279, '2.60.120.230-FF-000011', NULL, NULL, 152, NULL, NULL, 122279),
(122280, '1.10.10.160-FF-000063', NULL, 'Probable DNA helicase II homolog', 79, NULL, NULL, 122280),
(122281, '3.40.720.10-FF-000343', NULL, 'Uncharacterized protein', 82, NULL, NULL, 122281),
(122282, '2.30.29.30-FF-000764', NULL, 'Uncharacterized protein', 124, NULL, NULL, 122282),
(122283, '3.40.50.150-FF-001346', NULL, NULL, 193, NULL, NULL, 122283),
(122284, '3.40.50.720-FF-002377', NULL, 'Uncharacterized protein', 165, NULL, NULL, 122284),
(122285, '2.40.128.20-FF-000024', NULL, 'Neutrophil gelatinase-associated lipocalin', 178, NULL, NULL, 122285),
(122286, '1.20.1560.10-FF-000229', NULL, 'ABC transporter, putative', 136, NULL, NULL, 122286),
(122287, '1.20.140.10-FF-000002', NULL, 'Acyl-CoA dehydrogenase short/branched chain', 148, NULL, NULL, 122287),
(122288, '3.10.390.10-FF-000015', NULL, 'Uncharacterized protein', 82, NULL, NULL, 122288),
(122289, '1.10.10.650-FF-000007', NULL, 'Transcription elongation factor Spt6', 152, NULL, NULL, 122289),
(122290, '1.10.630.10-FF-000019', NULL, 'Cytochrome P450 family protein', 472, NULL, NULL, 122290),
(122291, '2.130.10.10-FF-003044', NULL, 'Small nucleolar ribonucleoprotein complex subunit', 149, NULL, NULL, 122291),
(122292, '3.80.10.10-FF-002493', NULL, 'Tubulin-specific chaperone E', 71, NULL, NULL, 122292),
(122293, '1.50.40.10-FF-000112', NULL, 'Mitochondrial carrier protein (Pet8), putative', 133, NULL, NULL, 122293),
(122294, '1.20.1270.10-FF-000022', NULL, 'Heat shock protein 70', 95, NULL, NULL, 122294),
(122295, '3.30.1150.10-FF-000020', NULL, NULL, 98, NULL, NULL, 122295),
(122296, '4.10.280.10-FF-000025', NULL, 'protein atonal homolog 7', 67, NULL, NULL, 122296),
(122297, '3.30.450.20-FF-000288', NULL, 'Development and carotenogenesis control-1 protein', 126, NULL, NULL, 122297);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(122298, '3.30.930.10-FF-000108', NULL, 'Octanoyltransferase', 255, NULL, NULL, 122298),
(122299, '2.60.120.200-FF-000710', NULL, 'Uncharacterized protein', 181, NULL, NULL, 122299),
(122300, '3.30.160.60-FF-005191', NULL, NULL, 18, NULL, NULL, 122300),
(122301, '1.20.140.20-FF-000005', NULL, 'Pkp1p', 176, NULL, NULL, 122301),
(122302, '3.40.50.1700-FF-000040', NULL, 'Periplasmic beta-glucosidase', 262, NULL, NULL, 122302),
(122303, '1.20.5.110-FF-000126', NULL, 'Protein CBR-SYX-2', 105, NULL, NULL, 122303),
(122304, '2.130.10.10-FF-001913', NULL, 'Transducin/WD40 repeat-like superfamily protein', 233, NULL, NULL, 122304),
(122305, '2.30.29.30-FF-000085', NULL, 'Pleckstrin homology domain-containing family A member 8', 100, NULL, NULL, 122305),
(122306, '1.10.10.60-FF-001009', NULL, NULL, 48, NULL, NULL, 122306),
(122307, '3.40.718.10-FF-000074', NULL, 'Isopropylmalate dehydrogenase1', 107, NULL, NULL, 122307),
(122308, '3.40.50.150-FF-001560', NULL, NULL, 75, NULL, NULL, 122308),
(122309, '3.50.50.60-FF-001432', NULL, 'Uncharacterized protein', 112, NULL, NULL, 122309),
(122310, '3.30.160.60-FF-000986', NULL, 'Zinc finger protein 541', 26, NULL, NULL, 122310),
(122311, '1.10.10.790-FF-000021', NULL, 'RNA splicing factor', 66, NULL, NULL, 122311),
(122312, '3.30.1330.30-FF-000124', NULL, '40S ribosomal protein S12', 128, NULL, NULL, 122312),
(122313, '1.25.40.470-FF-000056', NULL, 'Selective LIM binding factor, putative', 164, NULL, NULL, 122313),
(122314, '2.60.40.10-FF-005651', NULL, NULL, 122, NULL, NULL, 122314),
(122315, '1.25.40.10-FF-003161', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 115, NULL, NULL, 122315),
(122316, '3.20.20.140-FF-000111', NULL, 'Membrane dipeptidase', 336, NULL, NULL, 122316),
(122317, '3.80.10.10-FF-000469', NULL, 'Receptor-like protein 2', 72, NULL, NULL, 122317),
(122318, '1.20.1250.20-FF-002373', NULL, 'Uncharacterized protein', 260, NULL, NULL, 122318),
(122319, '1.10.357.30-FF-000002', NULL, 'Exocyst complex component', 169, NULL, NULL, 122319),
(122320, '2.30.40.10-FF-000009', NULL, '5-methylthioadenosine/S-adenosylhomocysteine deaminase', 118, NULL, NULL, 122320),
(122321, '3.30.930.10-FF-000322', NULL, 'Predicted protein', 197, NULL, NULL, 122321),
(122322, '3.50.30.30-FF-000152', NULL, 'F10A2.10 protein', 141, NULL, NULL, 122322),
(122323, '3.40.50.300-FF-007714', NULL, 'Uncharacterized protein', 97, NULL, NULL, 122323),
(122324, '1.20.58.60-FF-000433', NULL, 'AGAP009554-PA', 109, NULL, NULL, 122324),
(122325, '3.30.70.330-FF-001114', NULL, 'Ribonucleoprotein, putative', 150, NULL, NULL, 122325),
(122326, '3.60.10.10-FF-000184', NULL, 'CCR4-NOT transcription complex, subunit 6-like protein', 313, NULL, NULL, 122326),
(122327, '3.40.50.12430-FF-000009', NULL, 'Uncharacterized protein', 87, NULL, NULL, 122327),
(122328, '1.50.10.10-FF-000054', NULL, 'alpha-1,2-Mannosidase', 187, NULL, NULL, 122328),
(122329, '1.25.40.180-FF-000306', NULL, NULL, 63, NULL, NULL, 122329),
(122330, '1.20.58.100-FF-000016', NULL, NULL, 57, NULL, NULL, 122330),
(122331, '3.40.50.1820-FF-000188', NULL, 'putative lipase ROG1 isoform X1', 244, NULL, NULL, 122331),
(122332, '3.40.1280.10-FF-000084', NULL, 'tRNA/rRNA methyltransferase', 159, NULL, NULL, 122332),
(122333, '3.30.2130.30-FF-000036', NULL, 'Uncharacterized protein', 202, NULL, NULL, 122333),
(122334, '3.90.640.10-FF-000157', NULL, 'Cysteinyl-tRNA synthetase, putative', 27, NULL, NULL, 122334),
(122335, '1.10.437.10-FF-000053', NULL, 'BCL2-associated X, apoptosis regulator a', 105, NULL, NULL, 122335),
(122336, '3.30.160.60-FF-001475', NULL, 'Zinc finger protein 585A', 28, NULL, NULL, 122336),
(122337, '2.60.40.10-FF-003408', NULL, NULL, 91, NULL, NULL, 122337),
(122338, '3.30.70.330-FF-002418', NULL, NULL, 92, NULL, NULL, 122338),
(122339, '3.50.50.60-FF-000943', NULL, 'Glycerol-3-phosphate dehydrogenase', 149, NULL, NULL, 122339),
(122340, '2.130.10.10-FF-003375', NULL, 'Uncharacterized protein', 193, NULL, NULL, 122340),
(122341, '3.30.710.10-FF-000339', NULL, 'Uncharacterized protein', 121, NULL, NULL, 122341);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(122342, '3.30.460.10-FF-000022', NULL, 'poly(A) RNA polymerase GLD2 isoform X1', 123, NULL, NULL, 122342),
(122343, '1.25.40.10-FF-003166', NULL, 'Putative pentatricopeptide repeat-containing protein At3g01580', 114, NULL, NULL, 122343),
(122344, '1.20.58.60-FF-000871', NULL, 'Spectrin repeat containing nuclear envelope protein 2', 299, NULL, NULL, 122344),
(122345, '3.40.50.720-FF-000702', NULL, 'NADH dehydrogenase (Ubiquinone)', 289, NULL, NULL, 122345),
(122346, '1.25.10.10-FF-001540', NULL, 'Adaptin N terminal region family protein', 573, NULL, NULL, 122346),
(122347, '3.40.1160.10-FF-000030', NULL, 'Uridylate kinase', 224, NULL, NULL, 122347),
(122348, '3.40.390.10-FF-000087', NULL, 'Uncharacterized protein, isoform A', 209, NULL, NULL, 122348),
(122349, '3.40.50.2300-FF-001063', NULL, NULL, 96, NULL, NULL, 122349),
(122350, '3.10.350.10-FF-000018', NULL, 'Peptidoglycan endopeptidase', 55, NULL, NULL, 122350),
(122351, '1.20.1250.20-FF-000467', NULL, 'Putative MFS transporter', 191, NULL, NULL, 122351),
(122352, '2.60.120.230-FF-000016', NULL, NULL, 150, NULL, NULL, 122352),
(122353, '1.20.1250.20-FF-000809', NULL, 'Proline/betaine transporter (ProP)', 206, NULL, NULL, 122353),
(122354, '3.40.50.300-FF-003774', NULL, 'DNA repair helicase, putative', 207, NULL, NULL, 122354),
(122355, '2.60.120.200-FF-000249', NULL, 'Calsyntenin-1, isoform C', 207, NULL, NULL, 122355),
(122356, '2.60.40.1080-FF-000001', NULL, 'Bacterial Ig-like domain, group 2', 91, NULL, NULL, 122356),
(122357, '3.40.710.10-FF-000062', NULL, 'Peptidase M15', 255, NULL, NULL, 122357),
(122358, '3.40.50.2000-FF-000815', NULL, 'Predicted protein', 164, NULL, NULL, 122358),
(122359, '3.30.420.10-FF-000238', NULL, 'Retrovirus-related Pol polyprotein from transposon 412-like Protein', 166, NULL, NULL, 122359),
(122360, '2.60.40.200-FF-000032', NULL, 'Superoxide dismutase [Cu-Zn]', 101, NULL, NULL, 122360),
(122361, '1.50.10.20-FF-000057', NULL, 'Glutinol synthase', 174, NULL, NULL, 122361),
(122362, '2.60.40.1090-FF-000004', NULL, 'Fimbrial protein BcfF', 151, NULL, NULL, 122362),
(122363, '3.80.10.10-FF-002611', NULL, 'Nuclear pore complex protein NUP107', 238, NULL, NULL, 122363),
(122364, '2.60.40.10-FF-003066', NULL, 'Myosin-light-chain kinase', 100, NULL, NULL, 122364),
(122365, '3.30.900.10-FF-000051', NULL, 'Autophagy-related protein 13', 81, NULL, NULL, 122365),
(122366, '3.40.630.30-FF-000342', NULL, 'Acetylglutamate kinase', 141, NULL, NULL, 122366),
(122367, '3.30.160.60-FF-001817', NULL, 'Zinc finger protein 275', 32, NULL, NULL, 122367),
(122368, '3.30.160.60-FF-005421', NULL, NULL, 38, NULL, NULL, 122368),
(122369, '2.30.170.20-FF-000012', NULL, 'Uncharacterized protein', 46, NULL, NULL, 122369),
(122370, '1.10.510.10-FF-001039', NULL, 'Casein kinase I isoform delta', 330, NULL, NULL, 122370),
(122371, '1.10.287.130-FF-000083', NULL, 'Putative two-component sensor histidine kinase', 63, NULL, NULL, 122371),
(122372, '2.60.40.10-FF-003173', NULL, 'Platelet-derived growth factor receptor, alpha polypeptide', 89, NULL, NULL, 122372),
(122373, '1.20.900.10-FF-000061', NULL, 'TIAM (Mammalian Tumor Invasion And Metastasis factor) homolog', 196, NULL, NULL, 122373),
(122374, '3.40.1190.20-FF-000203', NULL, NULL, 155, NULL, NULL, 122374),
(122375, '2.10.10.10-FF-000003', NULL, 'binder of sperm protein homolog 1', 51, NULL, NULL, 122375),
(122376, '1.20.81.10-FF-000005', NULL, 'GG17180', 99, NULL, NULL, 122376),
(122377, '3.40.50.720-FF-001303', NULL, 'Pyrroline-5-carboxylate reductase', 160, NULL, NULL, 122377),
(122378, '2.40.240.10-FF-000063', NULL, 'Ribosomal protein L25/Gln-tRNA synthetase, anti-codon-binding domain-containing protein', 99, NULL, NULL, 122378),
(122379, '3.40.50.1820-FF-000637', NULL, 'AGAP011682-PA', 275, NULL, NULL, 122379),
(122380, '2.60.40.1730-FF-000011', NULL, 'Arginyl aminopeptidase', 203, NULL, NULL, 122380),
(122381, '3.30.1490.220-FF-000010', NULL, 'Uncharacterized protein', 68, NULL, NULL, 122381),
(122382, '3.30.470.20-FF-000183', NULL, 'Uncharacterized protein', 17, NULL, NULL, 122382);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(122383, '2.60.40.10-FF-001609', NULL, 'Centrosomal protein 192', 89, NULL, NULL, 122383),
(122384, '2.30.39.10-FF-000141', NULL, 'Uncharacterized protein', 47, NULL, NULL, 122384),
(122385, '4.10.1060.10-FF-000051', NULL, 'Nuclear pore complex protein Nup153-like Protein', 38, NULL, NULL, 122385),
(122386, '3.40.190.10-FF-000549', NULL, 'LysR family transcriptional regulator', 96, NULL, NULL, 122386),
(122387, '3.30.190.20-FF-000026', NULL, 'Mitochondrial ribosomal protein L1', 89, NULL, NULL, 122387),
(122388, '3.30.1480.10-FF-000011', NULL, 'Transcription termination/antitermination protein NusA', 94, NULL, NULL, 122388),
(122389, '3.30.1240.10-FF-000027', NULL, 'HAD family phosphatase', 56, NULL, NULL, 122389),
(122390, '1.10.357.30-FF-000007', NULL, 'Exocyst complex component', 177, NULL, NULL, 122390),
(122391, '2.20.70.70-FF-000001', NULL, 'Penicillin-binding protein 2X', 45, NULL, NULL, 122391),
(122392, '3.20.20.80-FF-000347', NULL, 'Probable glucosyl transferase', 105, NULL, NULL, 122392),
(122393, '2.60.40.60-FF-001029', NULL, 'Uncharacterized protein', 116, NULL, NULL, 122393),
(122394, '1.25.10.20-FF-000020', NULL, 'Predicted protein', 300, NULL, NULL, 122394),
(122395, '1.10.238.10-FF-001125', NULL, 'Uncharacterized protein', 26, NULL, NULL, 122395),
(122396, '1.20.58.1120-FF-000028', NULL, 'Putative dynein heavy chain', 166, NULL, NULL, 122396),
(122397, '2.60.40.10-FF-003515', NULL, NULL, 86, NULL, NULL, 122397),
(122398, '1.25.40.90-FF-000054', NULL, 'Putative clathrin assembly protein', 155, NULL, NULL, 122398),
(122399, '2.30.30.100-FF-000108', NULL, 'Small nuclear ribonucleoprotein E', 88, NULL, NULL, 122399),
(122400, '2.60.120.380-FF-000033', NULL, 'Uncharacterized protein', 146, NULL, NULL, 122400),
(122401, '3.20.20.70-FF-000344', NULL, 'Conserved protein', 379, NULL, NULL, 122401),
(122402, '3.40.50.1820-FF-000295', NULL, 'neurotactin', 483, NULL, NULL, 122402),
(122403, '3.80.10.10-FF-000357', NULL, 'F-box/LRR-repeat protein 15', 252, NULL, NULL, 122403),
(122404, '3.50.50.60-FF-001213', NULL, 'Uncharacterized protein', 349, NULL, NULL, 122404),
(122405, '1.20.1420.30-FF-000068', NULL, 'Uncharacterized protein', 50, NULL, NULL, 122405),
(122406, '1.20.1300.20-FF-000011', NULL, 'Chromosome undetermined SCAF10229, whole genome shotgun sequence', 23, NULL, NULL, 122406),
(122407, '1.20.990.10-FF-000009', NULL, 'NADPH--cytochrome P450 reductase', 122, NULL, NULL, 122407),
(122408, '2.30.42.10-FF-000396', NULL, NULL, 108, NULL, NULL, 122408),
(122409, '1.25.40.660-FF-000017', NULL, 'Vacuolar protein sorting-associated protein 35', 305, NULL, NULL, 122409),
(122410, '3.30.70.360-FF-000033', NULL, 'Acetylornithine deacetylase', 118, NULL, NULL, 122410),
(122411, '1.25.40.270-FF-000007', NULL, 'Vta1 like, putative', 162, NULL, NULL, 122411),
(122412, '3.40.50.300-FF-007607', NULL, 'Uncharacterized protein', 159, NULL, NULL, 122412),
(122413, '3.40.50.150-FF-001565', NULL, NULL, 73, NULL, NULL, 122413),
(122414, '2.40.420.20-FF-000052', NULL, 'Membrane protein', 90, NULL, NULL, 122414),
(122415, '3.40.50.1700-FF-000045', NULL, 'Beta-D-glucan exohydrolase-like protein', 242, NULL, NULL, 122415),
(122416, '1.20.58.1460-FF-000001', NULL, 'Phenylacetic acid degradation operon negative regulatory protein paaX', 78, NULL, NULL, 122416),
(122417, '2.130.10.10-FF-003830', NULL, 'Uncharacterized protein', 299, NULL, NULL, 122417),
(122418, '2.60.40.10-FF-003392', NULL, NULL, 93, NULL, NULL, 122418),
(122419, '4.10.240.10-FF-000028', NULL, 'Uncharacterized transcriptional regulatory protein C1773.12', 63, NULL, NULL, 122419),
(122420, '1.10.10.900-FF-000004', NULL, 'Shwachman-Bodian-Diamond syndrome (SBDS) protein/SBDS protein C-terminal domain containing protein, putative', 76, NULL, NULL, 122420),
(122421, '1.20.1250.20-FF-000916', NULL, 'Cis,cis-muconate transporter MucK', 400, NULL, NULL, 122421),
(122422, '1.25.40.20-FF-001707', NULL, 'Uncharacterized protein', 53, NULL, NULL, 122422),
(122423, '3.10.129.10-FF-000167', NULL, 'Thioesterase superfamily protein', 118, NULL, NULL, 122423);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(122424, '3.40.190.80-FF-000070', NULL, 'Inositol-1-monophosphatase', 115, NULL, NULL, 122424),
(122425, '1.25.40.20-FF-001371', NULL, 'Uncharacterized protein', 88, NULL, NULL, 122425),
(122426, '1.10.510.10-FF-003394', NULL, NULL, 307, NULL, NULL, 122426),
(122427, '1.20.1250.20-FF-000574', NULL, 'Unplaced genomic scaffold supercont2.19, whole genome shotgun sequence', 296, NULL, NULL, 122427),
(122428, '3.30.70.330-FF-003126', NULL, NULL, 174, NULL, NULL, 122428),
(122429, '1.10.510.10-FF-003517', NULL, NULL, 247, NULL, NULL, 122429),
(122430, '3.30.200.210-FF-000007', NULL, 'Molybdopterin oxidoreductase Fe4S4 region', 134, NULL, NULL, 122430),
(122431, '1.25.40.10-FF-000873', NULL, 'Clustered mitochondria protein homolog', 125, NULL, NULL, 122431),
(122432, '1.10.20.140-FF-000020', NULL, NULL, 61, NULL, NULL, 122432),
(122433, '2.10.70.10-FF-000107', NULL, 'Complement factor H', 59, NULL, NULL, 122433),
(122434, '3.90.1280.20-FF-000002', NULL, 'Chloride channel protein', 84, NULL, NULL, 122434),
(122435, '1.10.510.10-FF-003175', NULL, NULL, 162, NULL, NULL, 122435),
(122436, '3.30.1520.10-FF-000184', NULL, 'Ribosomal protein S6 kinase C1', 87, NULL, NULL, 122436),
(122437, '1.10.60.30-FF-000003', NULL, 'UPF0307 protein XC_1511', 74, NULL, NULL, 122437),
(122438, '3.40.50.620-FF-000335', NULL, 'Tyrosyl-tRNA synthetase', 221, NULL, NULL, 122438),
(122439, '1.25.10.10-FF-003338', NULL, 'YALI0D22440p', 250, NULL, NULL, 122439),
(122440, '3.80.10.10-FF-004073', NULL, 'Protein kinase, putative', 299, NULL, NULL, 122440),
(122441, '3.30.230.10-FF-000319', NULL, 'Uncharacterized protein', 139, NULL, NULL, 122441),
(122442, '1.10.400.10-FF-000087', NULL, 'Si:ch211-207c7.2', 59, NULL, NULL, 122442),
(122443, '3.90.360.10-FF-000012', NULL, 'Uncharacterized protein', 22, NULL, NULL, 122443),
(122444, '1.25.40.10-FF-001704', NULL, 'Os03g0314400 protein', 80, NULL, NULL, 122444),
(122445, '3.60.40.10-FF-000023', NULL, 'Protein phosphatase, Mg2+/Mn2+-dependent, 1G', 271, NULL, NULL, 122445),
(122446, '3.30.70.1450-FF-000029', NULL, 'Potassium transporter peripheral membrane component', 77, NULL, NULL, 122446),
(122447, '3.10.20.90-FF-000311', NULL, 'UBX domain-containing protein 1', 126, NULL, NULL, 122447),
(122448, '3.40.50.740-FF-000005', NULL, 'Anaerobic dimethyl sulfoxide reductase, A subunit', 204, NULL, NULL, 122448),
(122449, '3.40.50.300-FF-003881', NULL, 'Capsular polysaccharide biosynthesis homolog', 276, NULL, NULL, 122449),
(122450, '3.90.180.10-FF-000026', NULL, 'Chlorophyll synthesis pathway protein BchC', 171, NULL, NULL, 122450),
(122451, '3.80.10.10-FF-003797', NULL, 'Uncharacterized protein', 92, NULL, NULL, 122451),
(122452, '2.30.110.10-FF-000016', NULL, 'Flavin reductase-like protein', 159, NULL, NULL, 122452),
(122453, '2.130.10.10-FF-003482', NULL, 'enhancer of mRNA-decapping protein 4-like isoform X1', 301, NULL, NULL, 122453),
(122454, '3.30.1460.20-FF-000018', NULL, 'Arp2/3 complex 34 kDa subunit', 153, NULL, NULL, 122454),
(122455, '3.30.40.10-FF-002076', NULL, 'Uncharacterized protein', 86, NULL, NULL, 122455),
(122456, '4.10.1030.10-FF-000004', NULL, 'Cullin-1', 72, NULL, NULL, 122456),
(122457, '3.40.50.300-FF-004966', NULL, 'Rab_B73 protein', 216, NULL, NULL, 122457),
(122458, '3.40.50.1370-FF-000019', NULL, 'Aspartate carbamoyltransferase', 140, NULL, NULL, 122458),
(122459, '2.30.29.30-FF-000540', NULL, 'sesquipedalian-1-like', 104, NULL, NULL, 122459),
(122460, '2.40.10.330-FF-000002', NULL, 'Peptidyl-prolyl cis-trans isomerase', 57, NULL, NULL, 122460),
(122461, '3.30.460.50-FF-000005', NULL, NULL, 114, NULL, NULL, 122461),
(122462, '3.40.50.12780-FF-000187', NULL, 'Uncharacterized protein', 195, NULL, NULL, 122462),
(122463, '3.60.10.10-FF-000077', NULL, 'Carbon catabolite repressor protein 4 1', 384, NULL, NULL, 122463),
(122464, '2.40.50.90-FF-000062', NULL, 'Tudor domain containing protein', 155, NULL, NULL, 122464),
(122465, '3.30.450.50-FF-000050', NULL, '25.3 kDa vesicle transport protein', 72, NULL, NULL, 122465),
(122466, '1.25.40.10-FF-004796', NULL, 'TPR Domain containing protein', 172, NULL, NULL, 122466);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(122467, '3.80.10.10-FF-002830', NULL, 'SCF E3 ubiquitin ligase complex F-box protein pof2', 101, NULL, NULL, 122467),
(122468, '3.90.70.10-FF-000040', NULL, 'Ubiquitin carboxyl-terminal hydrolase 37', 286, NULL, NULL, 122468),
(122469, '1.10.287.70-FF-000233', NULL, 'Uncharacterized protein, isoform A', 131, NULL, NULL, 122469),
(122470, '3.30.200.20-FF-001315', NULL, 'Uncharacterized protein', 62, NULL, NULL, 122470),
(122471, '3.40.50.300-FF-000115', NULL, 'DNA helicase', 331, NULL, NULL, 122471),
(122472, '1.20.1070.10-FF-001889', NULL, 'Uncharacterized protein', 369, NULL, NULL, 122472),
(122473, '1.10.8.720-FF-000002', NULL, 'Dynein heavy chain 9, axonemal', 163, NULL, NULL, 122473),
(122474, '3.30.450.60-FF-000053', NULL, 'Protein CBG13942', 132, NULL, NULL, 122474),
(122475, '3.30.160.60-FF-003392', NULL, 'Hermaphrodite, isoform A', 85, NULL, NULL, 122475),
(122476, '1.10.238.10-FF-000040', NULL, 'Ryanodine receptor 2', 70, NULL, NULL, 122476),
(122477, '3.80.10.10-FF-004292', NULL, 'Si:dkey-51d8.1', 235, NULL, NULL, 122477),
(122478, '3.30.70.330-FF-002289', NULL, NULL, 97, NULL, NULL, 122478),
(122479, '1.25.10.10-FF-003119', NULL, 'Uncharacterized protein', 210, NULL, NULL, 122479),
(122480, '2.60.40.10-FF-003734', NULL, NULL, 89, NULL, NULL, 122480),
(122481, '3.40.50.300-FF-007259', NULL, 'Uncharacterized protein', 157, NULL, NULL, 122481),
(122482, '1.20.1730.10-FF-000046', NULL, 'Uncharacterized protein', 474, NULL, NULL, 122482),
(122483, '3.40.1650.10-FF-000005', NULL, 'Fucose mutarotase', 150, NULL, NULL, 122483),
(122484, '3.10.50.40-FF-000040', NULL, 'Trigger factor', 97, NULL, NULL, 122484),
(122485, '3.40.50.300-FF-003336', NULL, 'Heparan-sulfate 6-O-sulfotransferase', 172, NULL, NULL, 122485),
(122486, '1.20.1070.10-FF-002165', NULL, 'AGAP013324-PA', 135, NULL, NULL, 122486),
(122487, '2.30.30.140-FF-000210', NULL, 'Histone acetyltransferase', 120, NULL, NULL, 122487),
(122488, '1.20.1070.10-FF-000259', NULL, 'G-protein coupled receptor', 352, NULL, NULL, 122488),
(122489, '2.40.10.340-FF-000005', NULL, 'Rod shape-determining protein MreC', 86, NULL, NULL, 122489),
(122490, '2.60.40.10-FF-000300', NULL, 'fibronectin isoform X1', 98, NULL, NULL, 122490),
(122491, '2.10.50.10-FF-000005', NULL, 'signal peptide, CUB and EGF-like domain-containing protein 2 isoform X1', 46, NULL, NULL, 122491),
(122492, '2.40.10.350-FF-000008', NULL, 'Cell shape-determining protein MreC', 91, NULL, NULL, 122492),
(122493, '3.60.20.10-FF-000134', NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', 233, NULL, NULL, 122493),
(122494, '1.10.238.20-FF-000043', NULL, 'AGAP003307-PB', 122, NULL, NULL, 122494),
(122495, '3.80.10.10-FF-001200', NULL, 'Uncharacterized protein', 144, NULL, NULL, 122495),
(122496, '3.40.50.1360-FF-000016', NULL, 'Central glycolytic genes regulator', 248, NULL, NULL, 122496),
(122497, '2.130.10.10-FF-004909', NULL, 'Uncharacterized protein', 318, NULL, NULL, 122497),
(122498, '1.20.5.110-FF-000233', NULL, 'Uncharacterized protein', 67, NULL, NULL, 122498),
(122499, '2.130.10.30-FF-000060', NULL, 'Regulator of chromosome condensation', 429, NULL, NULL, 122499),
(122500, '3.30.70.240-FF-000002', NULL, 'GTP-binding protein TypA', 93, NULL, NULL, 122500),
(122501, '3.40.50.360-FF-000111', NULL, 'SPbeta prophage-derived protein NrdI', 129, NULL, NULL, 122501),
(122502, '2.60.40.3510-FF-000011', NULL, 'Delta-like protein', 165, NULL, NULL, 122502),
(122503, '3.90.660.10-FF-000046', NULL, 'Flavin monoamine oxidase-related protein', 191, NULL, NULL, 122503),
(122504, '3.90.70.80-FF-000033', NULL, 'Predicted protein', 158, NULL, NULL, 122504),
(122505, '3.40.50.720-FF-000814', NULL, 'Probable short chain alcohol dehydrogenase/reductase', 259, NULL, NULL, 122505),
(122506, '1.20.120.1770-FF-000023', NULL, 'Uncharacterized protein', 236, NULL, NULL, 122506),
(122507, '3.40.50.300-FF-007591', NULL, 'Dead/deah box helicase domain protein', 170, NULL, NULL, 122507),
(122508, '1.25.40.20-FF-000061', NULL, 'Diacylglycerol kinase', 147, NULL, NULL, 122508),
(122509, '3.40.250.10-FF-000144', NULL, 'Thiosulfate sulfurtransferase', 160, NULL, NULL, 122509);
INSERT INTO "PUBLIC"."MODEL" VALUES
(122510, '3.40.50.1820-FF-000076', NULL, 'phospholipase A1', 300, NULL, NULL, 122510),
(122511, '1.20.120.1760-FF-000020', NULL, 'cardiolipin synthase (CMP-forming), mitochondrial', 197, NULL, NULL, 122511),
(122512, '1.10.287.110-FF-000200', NULL, 'DnaJ domain containing protein', 72, NULL, NULL, 122512),
(122513, '2.120.10.90-FF-000004', NULL, 'DNA gyrase subunit A', 311, NULL, NULL, 122513),
(122514, '1.10.287.130-FF-000206', NULL, 'HAMP domain protein', 60, NULL, NULL, 122514),
(122515, '3.40.390.10-FF-000317', NULL, NULL, 118, NULL, NULL, 122515),
(122516, '3.30.1330.70-FF-000001', NULL, 'Crossover junction endodeoxyribonuclease RusA', 120, NULL, NULL, 122516),
(122517, '1.10.287.1490-FF-000002', NULL, 'epidermal growth factor receptor substrate 15-like 1 isoform X2', 207, NULL, NULL, 122517),
(122518, '3.10.10.10-FF-000057', NULL, NULL, 104, NULL, NULL, 122518),
(122519, '1.10.1520.10-FF-000061', NULL, 'Ribonuclease 3', 181, NULL, NULL, 122519),
(122520, '2.60.40.10-FF-005084', NULL, NULL, 100, NULL, NULL, 122520),
(122521, '2.10.60.10-FF-000051', NULL, 'Receptor protein serine/threonine kinase', 83, NULL, NULL, 122521),
(122522, '2.30.130.10-FF-000012', NULL, 'tRNA pseudouridine synthase B', 61, NULL, NULL, 122522),
(122523, '2.60.40.150-FF-000787', NULL, 'Uncharacterized protein', 93, NULL, NULL, 122523),
(122524, '3.60.15.10-FF-000279', NULL, 'Uncharacterized protein', 137, NULL, NULL, 122524),
(122525, '2.40.50.140-FF-001105', NULL, NULL, 53, NULL, NULL, 122525),
(122526, '1.10.472.80-FF-000172', NULL, 'Chromosome 16, whole genome shotgun sequence', 139, NULL, NULL, 122526),
(122527, '2.40.50.140-FF-000487', NULL, 'Minichromosome maintenance 8 homologous recombination repair factor', 116, NULL, NULL, 122527),
(122528, '3.30.310.80-FF-000009', NULL, 'Non-specific serine/threonine protein kinase', 111, NULL, NULL, 122528),
(122529, '2.20.70.10-FF-000259', NULL, 'Uncharacterized protein', 44, NULL, NULL, 122529),
(122530, '1.10.720.30-FF-000009', NULL, 'E3 SUMO-protein ligase PIAS4', 65, NULL, NULL, 122530),
(122531, '3.30.160.60-FF-005640', NULL, NULL, 39, NULL, NULL, 122531),
(122532, '1.20.1250.20-FF-000355', NULL, 'SLC (SoLute Carrier) homolog', 198, NULL, NULL, 122532),
(122533, '3.40.50.620-FF-000554', NULL, 'Electron transfer flavoprotein beta-subunit', 247, NULL, NULL, 122533),
(122534, '3.30.390.30-FF-000016', NULL, 'Putidaredoxin reductase CamA', 87, NULL, NULL, 122534),
(122535, '3.60.10.10-FF-000420', NULL, 'Uncharacterized protein', 139, NULL, NULL, 122535),
(122536, '2.130.10.10-FF-003605', NULL, 'Guanine nucleotide-binding protein subunit beta-like protein', 97, NULL, NULL, 122536),
(122537, '1.10.12.10-FF-000009', NULL, 'Methylmalonyl-CoA decarboxylase', 59, NULL, NULL, 122537),
(122538, '3.30.930.10-FF-000092', NULL, 'Histidyl-tRNA synthetase putative', 351, NULL, NULL, 122538),
(122539, '1.25.40.10-FF-002778', NULL, 'TPR-repeat-containing chaperone protein DNAJ, putative', 374, NULL, NULL, 122539),
(122540, '3.40.50.2300-FF-000681', NULL, 'Metabotropic glutamate receptor-like Protein', 163, NULL, NULL, 122540),
(122541, '1.10.40.30-FF-000007', NULL, 'Adenylosuccinate lyase', 83, NULL, NULL, 122541),
(122542, '3.30.470.20-FF-000071', NULL, 'methylcrotonoyl-CoA carboxylase subunit alpha, mitochondrial isoform X4', 254, NULL, NULL, 122542),
(122543, '1.20.120.1320-FF-000017', NULL, NULL, 103, NULL, NULL, 122543),
(122544, '1.10.287.70-FF-000452', NULL, 'Sodium channel protein', 140, NULL, NULL, 122544),
(122545, '3.40.50.620-FF-000548', NULL, 'Asparagine synthase (Glutamine-hydrolyzing)', 269, NULL, NULL, 122545),
(122546, '3.30.1330.90-FF-000007', NULL, 'L-serine dehydratase, iron-sulfur-dependent, beta subunit', 79, NULL, NULL, 122546),
(122547, '3.30.1010.10-FF-000095', NULL, 'Uncharacterized protein', 158, NULL, NULL, 122547),
(122548, '3.90.1150.10-FF-000349', NULL, 'Uncharacterized protein', 133, NULL, NULL, 122548),
(122549, '3.30.70.260-FF-000008', NULL, 'D-3-phosphoglycerate dehydrogenase, chloroplastic', 74, NULL, NULL, 122549),
(122550, '2.60.450.10-FF-000024', NULL, 'Uncharacterized protein', 138, NULL, NULL, 122550);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(122551, '3.40.50.360-FF-000094', NULL, 'Flavodoxin', 169, NULL, NULL, 122551),
(122552, '2.120.10.10-FF-000037', NULL, 'Probable sialidase', 278, NULL, NULL, 122552),
(122553, '1.25.40.10-FF-004919', NULL, 'Predicted protein', 66, NULL, NULL, 122553),
(122554, '3.30.70.250-FF-000005', NULL, 'Malonyl-CoA-acyl carrier protein transacylase, mitochondrial', 77, NULL, NULL, 122554),
(122555, '3.30.40.10-FF-001114', NULL, 'RING/FYVE/PHD-type zinc finger family protein', 68, NULL, NULL, 122555),
(122556, '3.80.10.10-FF-002049', NULL, 'Os11g0695000 protein', 148, NULL, NULL, 122556),
(122557, '3.75.10.10-FF-000038', NULL, NULL, 149, NULL, NULL, 122557),
(122558, '2.10.25.10-FF-000604', NULL, 'otogelin-like protein', 55, NULL, NULL, 122558),
(122559, '1.10.8.60-FF-000412', NULL, 'Peroxisome biogenesis protein 6', 102, NULL, NULL, 122559),
(122560, '2.120.10.90-FF-000010', NULL, 'DNA topoisomerase 4 subunit A', 236, NULL, NULL, 122560),
(122561, '3.30.1330.80-FF-000004', NULL, 'AT-hook motif nuclear-localized protein', 142, NULL, NULL, 122561),
(122562, '2.10.25.10-FF-000930', NULL, 'Meprin A subunit', 78, NULL, NULL, 122562),
(122563, '3.10.280.10-FF-000006', NULL, 'Mitochondrial glycoprotein, expressed', 188, NULL, NULL, 122563),
(122564, '3.40.50.1220-FF-000115', NULL, 'Uncharacterized protein', 94, NULL, NULL, 122564),
(122565, '2.60.120.200-FF-000816', NULL, 'Sex hormone-binding globulin', 92, NULL, NULL, 122565),
(122566, '3.40.50.300-FF-007484', NULL, 'Uncharacterized protein', 310, NULL, NULL, 122566),
(122567, '3.80.10.10-FF-004522', NULL, 'Predicted protein', 331, NULL, NULL, 122567),
(122568, '3.10.450.700-FF-000006', NULL, 'Pur alpha Like Protein', 70, NULL, NULL, 122568),
(122569, '1.20.910.10-FF-000016', NULL, 'Heme oxygenase', 214, NULL, NULL, 122569),
(122570, '3.30.160.60-FF-004004', NULL, NULL, 31, NULL, NULL, 122570),
(122571, '3.30.342.10-FF-000023', NULL, 'DNA polymerase epsilon catalytic subunit', 179, NULL, NULL, 122571),
(122572, '3.40.50.720-FF-000921', NULL, 'Putative short chain dehydrogenase', 256, NULL, NULL, 122572),
(122573, '3.60.110.10-FF-000006', NULL, 'Bifunctional nitrilase/nitrile hydratase NIT4B', 295, NULL, NULL, 122573),
(122574, '3.40.250.10-FF-000251', NULL, 'probable rhodanese domain-containing dual specificity protein phosphatase isoform X1', 124, NULL, NULL, 122574),
(122575, '1.20.5.170-FF-000116', NULL, 'Transcription regulatory protein SNF2', 76, NULL, NULL, 122575),
(122576, '2.40.10.340-FF-000011', NULL, 'Cell shape-determining protein MreC', 71, NULL, NULL, 122576),
(122577, '1.20.58.1020-FF-000004', NULL, 'GINS complex protein, putative', 131, NULL, NULL, 122577),
(122578, '3.60.10.10-FF-000307', NULL, 'Endonuclease/Exonuclease/phosphatase family protein', 307, NULL, NULL, 122578),
(122579, '1.10.10.1500-FF-000004', NULL, 'Uncharacterized protein', 109, NULL, NULL, 122579),
(122580, '3.30.160.60-FF-003386', NULL, 'Endolytic murein transglycosylase', 29, NULL, NULL, 122580),
(122581, '3.30.70.2850-FF-000011', NULL, 'DNA-directed RNA polymerase subunit', 231, NULL, NULL, 122581),
(122582, '3.50.50.60-FF-001000', NULL, 'Electron-transferring-flavoprotein dehydrogenase', 108, NULL, NULL, 122582),
(122583, '1.10.510.10-FF-001825', NULL, 'Hypothetical_protein_-_conserved', 223, NULL, NULL, 122583),
(122584, '2.130.10.10-FF-002987', NULL, 'YALI0B17798p', 201, NULL, NULL, 122584),
(122585, '1.20.1070.10-FF-000147', NULL, 'Histamine H1 receptor', 103, NULL, NULL, 122585),
(122586, '3.80.10.10-FF-002381', NULL, 'AGAP000340-PA', 121, NULL, NULL, 122586),
(122587, '3.40.50.300-FF-005354', NULL, 'Uncharacterized protein', 244, NULL, NULL, 122587),
(122588, '1.20.1050.80-FF-000003', NULL, 'rab5 GDP/GTP exchange factor isoform X2', 170, NULL, NULL, 122588),
(122589, '3.30.70.330-FF-002295', NULL, NULL, 87, NULL, NULL, 122589),
(122590, '1.25.40.20-FF-001590', NULL, 'Uncharacterized protein', 117, NULL, NULL, 122590),
(122591, '2.60.120.10-FF-000145', NULL, 'Vicilin-like antimicrobial peptides 2-2', 212, NULL, NULL, 122591),
(122592, '3.40.50.10140-FF-000064', NULL, 'Uncharacterized protein PHLOEM PROTEIN 2-LIKE A7', 155, NULL, NULL, 122592);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(122593, '1.20.58.1030-FF-000007', NULL, 'GINS complex subunit 4', 93, NULL, NULL, 122593),
(122594, '1.20.1250.20-FF-000248', NULL, 'Inner membrane transporter ydiN', 197, NULL, NULL, 122594),
(122595, '1.10.890.20-FF-000007', NULL, NULL, 26, NULL, NULL, 122595),
(122596, '1.25.40.10-FF-002891', NULL, 'Fanconi anemia group G protein', 369, NULL, NULL, 122596),
(122597, '3.30.160.60-FF-005314', NULL, NULL, 32, NULL, NULL, 122597),
(122598, '3.50.30.30-FF-000040', NULL, 'Aminopeptidase YwaD', 132, NULL, NULL, 122598),
(122599, '2.30.29.30-FF-000197', NULL, 'obscurin isoform X5', 122, NULL, NULL, 122599),
(122600, '3.40.1360.10-FF-000011', NULL, 'Type 2 DNA topoisomerase 6 subunit A', 224, NULL, NULL, 122600),
(122601, '3.30.70.270-FF-000337', NULL, NULL, 127, NULL, NULL, 122601),
(122602, '3.40.50.10130-FF-000061', NULL, 'Uncharacterized protein', 171, NULL, NULL, 122602),
(122603, '1.20.1050.90-FF-000006', NULL, 'DNA replication and repair protein RecF', 180, NULL, NULL, 122603),
(122604, '3.30.40.10-FF-000496', NULL, 'E3 ubiquitin-protein ligase RNF185 isoform X2', 44, NULL, NULL, 122604),
(122605, '1.20.80.10-FF-000037', NULL, 'E3 ubiquitin-protein ligase MYLIP-A', 117, NULL, NULL, 122605),
(122606, '3.30.200.20-FF-001208', NULL, 'Putative DUF26-domain receptor-like protein kinase family protein', 107, NULL, NULL, 122606),
(122607, '3.40.50.300-FF-000340', NULL, 'Bloom syndrome, RecQ helicase', 207, NULL, NULL, 122607),
(122608, '1.10.10.60-FF-000739', NULL, 'Arginine-fifty homeobox', 81, NULL, NULL, 122608),
(122609, '3.20.20.70-FF-000119', NULL, 'tRNA-dihydrouridine(16) synthase', 242, NULL, NULL, 122609),
(122610, '2.10.25.10-FF-000711', NULL, 'Laminin-like protein epi-1', 43, NULL, NULL, 122610),
(122611, '3.90.1150.10-FF-000462', NULL, '2''-deamino-2''-hydroxyneamine transaminase', 118, NULL, NULL, 122611),
(122612, '3.40.50.300-FF-006877', NULL, 'Type IV secretion system protein VirB4', 247, NULL, NULL, 122612),
(122613, '3.30.160.60-FF-003279', NULL, NULL, 31, NULL, NULL, 122613),
(122614, '1.20.1160.20-FF-000022', NULL, 'Predicted protein', 75, NULL, NULL, 122614),
(122615, '3.80.10.10-FF-000138', NULL, 'geranylgeranyl transferase type-2 subunit alpha', 136, NULL, NULL, 122615),
(122616, '3.30.40.10-FF-000389', NULL, 'E3 ubiquitin-protein ligase TRIM62', 81, NULL, NULL, 122616),
(122617, '3.30.160.60-FF-003167', NULL, 'Zinc finger protein 521', 77, NULL, NULL, 122617),
(122618, '3.90.70.10-FF-000849', NULL, 'Uncharacterized protein', 352, NULL, NULL, 122618),
(122619, '3.40.50.2000-FF-000366', NULL, 'Glycoside hydrolase', 160, NULL, NULL, 122619),
(122620, '3.30.40.10-FF-000277', NULL, 'TNF receptor-associated factor', 53, NULL, NULL, 122620),
(122621, '1.25.40.20-FF-001477', NULL, 'Transient receptor potential cation channel subfamily V member 5', 97, NULL, NULL, 122621),
(122622, '1.20.1720.10-FF-000096', NULL, NULL, 230, NULL, NULL, 122622),
(122623, '3.30.70.330-FF-003132', NULL, NULL, 75, NULL, NULL, 122623),
(122624, '3.30.160.20-FF-000204', NULL, 'STAUfen (DsRNA binding protein) homolog', 96, NULL, NULL, 122624),
(122625, '2.10.25.10-FF-000823', NULL, 'Epidermal growth factor', 37, NULL, NULL, 122625),
(122626, '3.30.1440.10-FF-000014', NULL, 'Uncharacterized protein', 121, NULL, NULL, 122626),
(122627, '3.30.70.330-FF-003020', NULL, NULL, 68, NULL, NULL, 122627),
(122628, '1.10.260.40-FF-000084', NULL, 'Phage repressor-like protein', 61, NULL, NULL, 122628),
(122629, '1.10.132.30-FF-000036', NULL, 'DNA-directed RNA polymerase subunit', 101, NULL, NULL, 122629),
(122630, '2.30.29.30-FF-000433', NULL, 'Non-specific serine/threonine protein kinase', 123, NULL, NULL, 122630),
(122631, '1.10.565.10-FF-000108', NULL, 'Uncharacterized protein', 266, NULL, NULL, 122631),
(122632, '3.40.50.620-FF-000329', NULL, 'Glutamate--tRNA ligase', 331, NULL, NULL, 122632),
(122633, '2.60.40.10-FF-001610', NULL, 'titin isoform X1', 99, NULL, NULL, 122633),
(122634, '3.40.50.300-FF-005135', NULL, 'Site-determining protein', 242, NULL, NULL, 122634),
(122635, '1.10.510.10-FF-000988', NULL, 'Leucine-rich repeat protein kinase family protein', 282, NULL, NULL, 122635); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(122636, '1.10.640.10-FF-000071', NULL, 'Uncharacterized protein', 123, NULL, NULL, 122636),
(122637, '3.90.340.10-FF-000011', NULL, 'Uncharacterized protein', 162, NULL, NULL, 122637),
(122638, '3.30.1520.10-FF-000072', NULL, 'YKR078W-like protein', 142, NULL, NULL, 122638),
(122639, '1.25.40.10-FF-002997', NULL, 'Pentatricopeptide repeat-containing protein At5g08510', 127, NULL, NULL, 122639),
(122640, '1.10.1220.10-FF-000021', NULL, 'ACP thioesterase', 82, NULL, NULL, 122640),
(122641, '1.20.58.60-FF-000085', NULL, 'dystonin isoform X2', 128, NULL, NULL, 122641),
(122642, '2.130.10.10-FF-001700', NULL, 'NACHT and WD repeat domain-containing 2', 167, NULL, NULL, 122642),
(122643, '2.40.50.140-FF-000594', NULL, 'Ribosomal protein S28e', 51, NULL, NULL, 122643),
(122644, '3.80.10.10-FF-004409', NULL, 'Uncharacterized protein', 80, NULL, NULL, 122644),
(122645, '3.40.50.720-FF-002158', NULL, 'Fatty acyl-CoA reductase', 80, NULL, NULL, 122645),
(122646, '2.10.110.40-FF-000002', NULL, 'CBN-CBP-1 protein', 76, NULL, NULL, 122646),
(122647, '3.30.160.60-FF-004696', NULL, NULL, 35, NULL, NULL, 122647),
(122648, '2.30.42.10-FF-000284', NULL, 'Inactivation-no-after-potential D protein', 94, NULL, NULL, 122648),
(122649, '2.60.120.280-FF-000003', NULL, 'MmsAB operon regulatory protein', 141, NULL, NULL, 122649),
(122650, '3.30.420.10-FF-000019', NULL, 'RNA exonuclease NEF-sp', 165, NULL, NULL, 122650),
(122651, '1.10.101.10-FF-000015', NULL, 'Putative lipoprotein', 74, NULL, NULL, 122651),
(122652, '1.10.510.10-FF-003282', NULL, NULL, 99, NULL, NULL, 122652),
(122653, '4.10.240.10-FF-000135', NULL, 'Zinc finger-containing transcription factor, putative', 105, NULL, NULL, 122653),
(122654, '3.30.1640.30-FF-000007', NULL, 'GD17179', 74, NULL, NULL, 122654),
(122655, '2.60.120.330-FF-000041', NULL, 'Hyoscyamine 6-dioxygenase', 317, NULL, NULL, 122655),
(122656, '3.40.720.10-FF-000012', NULL, 'N-acetylglucosamine-6-sulfatase', 447, NULL, NULL, 122656),
(122657, '1.10.287.70-FF-000671', NULL, 'Predicted protein', 113, NULL, NULL, 122657),
(122658, '3.40.50.300-FF-007372', NULL, 'Sulfate adenylyltransferase', 101, NULL, NULL, 122658),
(122659, '2.60.120.380-FF-000027', NULL, 'Protein kinase, putative', 129, NULL, NULL, 122659),
(122660, '1.10.287.70-FF-000339', NULL, 'polycystic kidney disease 2-like 2 protein isoform X3', 115, NULL, NULL, 122660),
(122661, '1.25.40.10-FF-001255', NULL, 'Coatomer subunit epsilon', 285, NULL, NULL, 122661),
(122662, '1.10.287.130-FF-000195', NULL, 'Hybrid sensory kinase', 85, NULL, NULL, 122662),
(122663, '3.30.300.30-FF-000073', NULL, 'Surfactin synthase subunit 3', 105, NULL, NULL, 122663),
(122664, '1.10.8.60-FF-000305', NULL, 'AAA-domain-containing protein', 82, NULL, NULL, 122664),
(122665, '2.60.120.290-FF-000006', NULL, 'Mannan-binding lectin serine protease 1', 112, NULL, NULL, 122665),
(122666, '2.60.40.10-FF-001593', NULL, 'Isoamylase 1, chloroplastic', 142, NULL, NULL, 122666),
(122667, '3.30.160.60-FF-005533', NULL, NULL, 29, NULL, NULL, 122667),
(122668, '2.60.40.2860-FF-000018', NULL, 'Membrane protein pf12', 133, NULL, NULL, 122668),
(122669, '3.10.400.20-FF-000003', NULL, 'Eukaryotic translation initiation factor 2D isoform A', 184, NULL, NULL, 122669),
(122670, '1.20.1270.60-FF-000008', NULL, 'Sorting nexin', 203, NULL, NULL, 122670),
(122671, '2.130.10.30-FF-000166', NULL, NULL, 77, NULL, NULL, 122671),
(122672, '3.40.20.10-FF-000073', NULL, 'Protein transport protein Sec24C, putative', 131, NULL, NULL, 122672),
(122673, '3.40.50.460-FF-000028', NULL, 'ATP-dependent 6-phosphofructokinase 2', 145, NULL, NULL, 122673),
(122674, '2.60.470.10-FF-000025', NULL, 'Pickpocket 22, isoform B', 179, NULL, NULL, 122674),
(122675, '3.40.50.2300-FF-000574', NULL, 'Response regulator PleD', 288, NULL, NULL, 122675),
(122676, '2.60.120.970-FF-000002', NULL, 'Transforming growth factor beta', 285, NULL, NULL, 122676),
(122677, '1.25.40.20-FF-001258', NULL, 'Uncharacterized protein', 211, NULL, NULL, 122677),
(122678, '1.20.1720.10-FF-000113', NULL, NULL, 240, NULL, NULL, 122678);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(122679, '3.80.10.10-FF-004179', NULL, 'Uncharacterized protein', 97, NULL, NULL, 122679),
(122680, '3.10.129.10-FF-000279', NULL, 'Acyl-CoA thioesterase 11a', 59, NULL, NULL, 122680),
(122681, '1.20.1270.50-FF-000005', NULL, 'Alpha-mannosidase', 108, NULL, NULL, 122681),
(122682, '3.30.70.260-FF-000115', NULL, 'Phenylalanine-4-hydroxylase, putative', 89, NULL, NULL, 122682),
(122683, '3.30.559.10-FF-000099', NULL, 'Nonribosomal peptide synthase SidC', 183, NULL, NULL, 122683),
(122684, '1.20.1070.10-FF-000366', NULL, 'Olfactory receptor family 52 subfamily D member 1', 165, NULL, NULL, 122684),
(122685, '3.60.20.10-FF-000027', NULL, 'Proteasome subunit beta type-6', 221, NULL, NULL, 122685),
(122686, '2.130.10.10-FF-002768', NULL, 'YALI0A04653p', 234, NULL, NULL, 122686),
(122687, '1.10.132.70-FF-000020', NULL, 'Telomerase reverse transcriptase', 184, NULL, NULL, 122687),
(122688, '1.10.220.150-FF-000067', NULL, 'Uncharacterized protein', 122, NULL, NULL, 122688),
(122689, '1.25.40.10-FF-004689', NULL, 'Uncharacterized protein', 103, NULL, NULL, 122689),
(122690, '1.10.510.10-FF-001606', NULL, 'Uncharacterized protein', 204, NULL, NULL, 122690),
(122691, '3.30.460.10-FF-000128', NULL, 'Speckle targeted PIP5K1A-regulated poly(A) polymerase', 143, NULL, NULL, 122691),
(122692, '3.30.70.1730-FF-000006', NULL, '39S ribosomal protein L10, mitochondrial', 168, NULL, NULL, 122692),
(122693, '3.30.200.20-FF-001540', NULL, 'Uncharacterized protein', 105, NULL, NULL, 122693),
(122694, '3.40.50.10190-FF-000051', NULL, 'Poly [ADP-ribose] polymerase', 105, NULL, NULL, 122694),
(122695, '3.30.70.270-FF-000118', NULL, 'GGDEF family protein', 179, NULL, NULL, 122695),
(122696, '3.40.50.410-FF-000042', NULL, 'Copine 4', 118, NULL, NULL, 122696),
(122697, '3.40.50.620-FF-000661', NULL, 'Uncharacterized protein', 180, NULL, NULL, 122697),
(122698, '3.30.200.20-FF-000933', NULL, 'CAMK/CAMKL protein kinase', 121, NULL, NULL, 122698),
(122699, '3.30.750.24-FF-000097', NULL, 'Uncharacterized protein', 105, NULL, NULL, 122699),
(122700, '2.60.40.2840-FF-000012', NULL, 'E3 ubiquitin-protein ligase hecw-1', 101, NULL, NULL, 122700),
(122701, '3.10.260.10-FF-000011', NULL, NULL, 110, NULL, NULL, 122701),
(122702, '2.60.120.200-FF-000362', NULL, 'Non-reducing end alpha-L-arabinofuranosidase BoGH43A', 205, NULL, NULL, 122702),
(122703, '2.40.50.140-FF-001212', NULL, NULL, 80, NULL, NULL, 122703),
(122704, '3.30.420.40-FF-001074', NULL, 'Predicted protein', 160, NULL, NULL, 122704),
(122705, '3.40.50.2300-FF-001411', NULL, NULL, 81, NULL, NULL, 122705),
(122706, '3.30.300.20-FF-000070', NULL, 'Chromosomal replication initiator protein DnaA', 87, NULL, NULL, 122706),
(122707, '3.90.190.10-FF-000178', NULL, 'Dual specificity protein phosphatase putative', 161, NULL, NULL, 122707),
(122708, '3.80.10.10-FF-002162', NULL, 'Uncharacterized protein', 234, NULL, NULL, 122708),
(122709, '3.40.50.450-FF-000025', NULL, 'ATP-dependent 6-phosphofructokinase', 203, NULL, NULL, 122709),
(122710, '2.160.20.10-FF-000199', NULL, 'Predicted protein', 153, NULL, NULL, 122710),
(122711, '2.60.40.10-FF-003627', NULL, NULL, 96, NULL, NULL, 122711),
(122712, '1.20.1250.10-FF-000133', NULL, NULL, 99, NULL, NULL, 122712),
(122713, '1.10.510.10-FF-003843', NULL, NULL, 106, NULL, NULL, 122713),
(122714, '1.10.630.10-FF-000244', NULL, 'Cytochrome P450 family 7 subfamily B member 1', 323, NULL, NULL, 122714),
(122715, '1.10.357.140-FF-000052', NULL, 'Os08g0389300 protein', 83, NULL, NULL, 122715),
(122716, '3.40.50.2000-FF-001080', NULL, 'Granule-bound starch synthase 1 chloroplastic/amyloplastic', 132, NULL, NULL, 122716),
(122717, '2.130.10.10-FF-001245', NULL, 'Putative poly(A) export protein', 303, NULL, NULL, 122717),
(122718, '3.30.900.10-FF-000045', NULL, 'Mitotic spindle assembly checkpoint protein MAD2B', 156, NULL, NULL, 122718),
(122719, '1.10.10.10-FF-001135', NULL, 'Vacuolar protein sorting 36, putative', 67, NULL, NULL, 122719),
(122720, '2.60.120.260-FF-000464', NULL, 'Putative beta-glucosidase', 167, NULL, NULL, 122720),
(122721, '3.40.50.300-FF-008569', NULL, 'Uncharacterized protein', 121, NULL, NULL, 122721);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(122722, '3.40.50.300-FF-005915', NULL, 'Uncharacterized protein', 276, NULL, NULL, 122722),
(122723, '1.10.150.670-FF-000026', NULL, 'Uncharacterized protein', 52, NULL, NULL, 122723),
(122724, '1.20.120.1380-FF-000013', NULL, 'Flagellar GTP-binding protein, putative', 16, NULL, NULL, 122724),
(122725, '3.90.180.10-FF-000133', NULL, 'Uncharacterized protein', 28, NULL, NULL, 122725),
(122726, '4.10.1090.10-FF-000002', NULL, 'Neck appendage protein', 79, NULL, NULL, 122726),
(122727, '2.40.50.40-FF-000075', NULL, 'Like heterochromatin protein (LHP1)', 72, NULL, NULL, 122727),
(122728, '3.40.50.720-FF-002490', NULL, 'Polyketide synthase', 444, NULL, NULL, 122728),
(122729, '1.10.8.60-FF-000182', NULL, 'AAA-type ATPase family protein', 102, NULL, NULL, 122729),
(122730, '3.40.50.11060-FF-000008', NULL, 'GTPase HflX', 96, NULL, NULL, 122730),
(122731, '1.25.40.510-FF-000001', NULL, 'Nucleoporin GLE1 isoform 1', 305, NULL, NULL, 122731),
(122732, '2.10.25.10-FF-000368', NULL, 'Delta-like 3 (Drosophila), isoform CRA_b', 38, NULL, NULL, 122732),
(122733, '2.130.10.10-FF-004898', NULL, 'Pre-mRNA-processing factor 4', 114, NULL, NULL, 122733),
(122734, '3.20.20.300-FF-000069', NULL, NULL, 170, NULL, NULL, 122734),
(122735, '3.30.70.330-FF-003019', NULL, NULL, 69, NULL, NULL, 122735),
(122736, '3.30.40.10-FF-000732', NULL, 'Zinc finger FYVE domain-containing protein 16', 76, NULL, NULL, 122736),
(122737, '3.10.180.10-FF-000078', NULL, 'Methylmalonyl-CoA epimerase', 130, NULL, NULL, 122737),
(122738, '2.40.270.10-FF-000014', NULL, 'DNA-directed RNA polymerase subunit beta', 200, NULL, NULL, 122738),
(122739, '2.40.50.140-FF-000375', NULL, 'DNA ligase k alpha, putative', 89, NULL, NULL, 122739),
(122740, '2.60.120.290-FF-000225', NULL, 'C-type LECtin', 111, NULL, NULL, 122740),
(122741, '1.25.40.20-FF-001820', NULL, 'Predicted protein', 155, NULL, NULL, 122741),
(122742, '3.40.50.620-FF-000442', NULL, 'Asparagine synthetase, glutamine-hydrolyzing', 297, NULL, NULL, 122742),
(122743, '3.30.160.60-FF-005752', NULL, NULL, 26, NULL, NULL, 122743),
(122744, '1.10.10.10-FF-000859', NULL, 'COP9 signalosome', 70, NULL, NULL, 122744),
(122745, '1.20.1070.10-FF-002058', NULL, 'Growth hormone-releasing hormone receptor b', 92, NULL, NULL, 122745),
(122746, '1.20.1320.30-FF-000009', NULL, NULL, 145, NULL, NULL, 122746),
(122747, '3.40.1500.20-FF-000003', NULL, 'Os10g0389300 protein', 213, NULL, NULL, 122747),
(122748, '3.40.50.300-FF-003443', NULL, 'Eukaryotic initiation factor 4A-III', 125, NULL, NULL, 122748),
(122749, '1.20.990.10-FF-000010', NULL, 'Sulfite reductase [NADPH] flavoprotein component', 122, NULL, NULL, 122749),
(122750, '3.20.20.80-FF-000454', NULL, 'Glycoside hydrolase superfamily', 106, NULL, NULL, 122750),
(122751, '3.40.50.2300-FF-000793', NULL, NULL, 101, NULL, NULL, 122751),
(122752, '3.40.50.300-FF-000008', NULL, 'ATP-dependent RNA helicase RhlB', 175, NULL, NULL, 122752),
(122753, '2.130.10.10-FF-005516', NULL, 'Small nucleolar ribonucleoprotein complex subunit (Pwp2), putative (AFU_orthologue AFUA_5G03090)', 65, NULL, NULL, 122753),
(122754, '3.80.10.10-FF-002942', NULL, 'Uncharacterized protein', 65, NULL, NULL, 122754),
(122755, '1.10.3860.10-FF-000007', NULL, 'Dicarboxylate/amino acid:cation symporter', 383, NULL, NULL, 122755),
(122756, '3.30.450.20-FF-000182', NULL, 'Magnesium or manganese-dependent protein phosphatase', 64, NULL, NULL, 122756),
(122757, '1.10.150.510-FF-000006', NULL, 'Receptor (G protein-coupled) activity-modifying protein 3', 95, NULL, NULL, 122757),
(122758, '3.40.50.300-FF-001644', NULL, 'ABC transporter G family member 5', 261, NULL, NULL, 122758),
(122759, '1.10.287.70-FF-000340', NULL, 'ATP-sensitive inward rectifier potassium channel 8', 60, NULL, NULL, 122759),
(122760, '2.40.50.140-FF-000717', NULL, NULL, 80, NULL, NULL, 122760),
(122761, '3.30.40.10-FF-000390', NULL, 'E3 ubiquitin-protein ligase TRIM50', 78, NULL, NULL, 122761),
(122762, '1.20.120.1080-FF-000024', NULL, 'ATP-dependent RNA helicase DHX8', 100, NULL, NULL, 122762),
(122763, '2.130.10.10-FF-000969', NULL, 'WD repeat protein', 450, NULL, NULL, 122763);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(122764, '3.30.160.60-FF-003622', NULL, 'Zinc finger E-box-binding homeobox 2', 46, NULL, NULL, 122764),
(122765, '3.40.50.80-FF-000236', NULL, 'Uncharacterized protein', 98, NULL, NULL, 122765),
(122766, '1.20.1270.60-FF-000340', NULL, 'Uncharacterized PH domain-containing protein C19A8.02', 255, NULL, NULL, 122766),
(122767, '3.80.10.10-FF-000470', NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', 70, NULL, NULL, 122767),
(122768, '2.120.10.30-FF-000594', NULL, 'Uncharacterized protein', 98, NULL, NULL, 122768),
(122769, '1.25.40.10-FF-002559', NULL, 'Putative pentatricopeptide repeat-containing protein At3g18840', 151, NULL, NULL, 122769),
(122770, '1.20.1050.10-FF-000258', NULL, 'glutathione S-transferase 1', 136, NULL, NULL, 122770),
(122771, '3.30.160.20-FF-000081', NULL, 'Ribonuclease 3', 78, NULL, NULL, 122771),
(122772, '1.25.40.180-FF-000295', NULL, NULL, 110, NULL, NULL, 122772),
(122773, '3.20.20.140-FF-000094', NULL, 'Probable antibiotic-resistance protein', 269, NULL, NULL, 122773),
(122774, '3.90.190.10-FF-000291', NULL, 'Dual specificity protein phosphatase CDC14A-like Protein', 151, NULL, NULL, 122774),
(122775, '3.40.50.720-FF-000691', NULL, 'NAD-dependent alcohol dehydrogenase', 155, NULL, NULL, 122775),
(122776, '3.30.160.60-FF-001481', NULL, 'zinc finger protein 696', 25, NULL, NULL, 122776),
(122777, '3.40.50.11040-FF-000002', NULL, 'RNA cytidine acetyltransferase', 233, NULL, NULL, 122777),
(122778, '2.60.40.10-FF-005207', NULL, 'Alpha-amylase SusG', 116, NULL, NULL, 122778),
(122779, '3.40.850.10-FF-000235', NULL, 'Kinesin-like protein', 350, NULL, NULL, 122779),
(122780, '3.30.40.10-FF-000058', NULL, 'E3 ubiquitin-protein ligase Arkadia isoform X4', 83, NULL, NULL, 122780),
(122781, '3.30.530.20-FF-000002', NULL, 'Coenzyme Q-binding protein COQ10 homolog, mitochondrial', 147, NULL, NULL, 122781),
(122782, '1.10.8.10-FF-000083', NULL, 'Ubiquitin-conjugating enzyme E2', 41, NULL, NULL, 122782),
(122783, '3.40.50.10330-FF-000020', NULL, 'Diacylglycerol kinase', 127, NULL, NULL, 122783),
(122784, '2.60.40.10-FF-002211', NULL, 'GL25248', 95, NULL, NULL, 122784),
(122785, '1.20.1740.10-FF-000108', NULL, 'Serine transporter', 392, NULL, NULL, 122785),
(122786, '1.20.58.530-FF-000010', NULL, 'Myosin IIIA', 150, NULL, NULL, 122786),
(122787, '3.40.720.10-FF-000231', NULL, 'Non-specific phospholipase C4', 161, NULL, NULL, 122787),
(122788, '2.30.29.30-FF-000652', NULL, 'Coronin', 117, NULL, NULL, 122788),
(122789, '1.10.10.60-FF-001234', NULL, NULL, 52, NULL, NULL, 122789),
(122790, '1.20.920.20-FF-000065', NULL, 'Uncharacterized protein', 240, NULL, NULL, 122790),
(122791, '1.10.287.10-FF-000018', NULL, 'Ataxin-3 homolog', 37, NULL, NULL, 122791),
(122792, '3.30.420.10-FF-000351', NULL, 'DNA polymerase', 234, NULL, NULL, 122792),
(122793, '2.40.50.90-FF-000174', NULL, 'Uncharacterized protein', 161, NULL, NULL, 122793),
(122794, '3.90.640.10-FF-000270', NULL, 'Uncharacterized protein', 108, NULL, NULL, 122794),
(122795, '3.40.50.300-FF-001189', NULL, 'DAR GTPase 3 chloroplastic', 174, NULL, NULL, 122795),
(122796, '1.20.1080.10-FF-000086', NULL, 'Uncharacterized protein', 183, NULL, NULL, 122796),
(122797, '1.25.10.10-FF-003007', NULL, 'Uncharacterized protein', 588, NULL, NULL, 122797),
(122798, '1.10.1040.10-FF-000035', NULL, '2-dehydropantoate 2-reductase', 142, NULL, NULL, 122798),
(122799, '3.90.380.10-FF-000007', NULL, 'Naphthalene 1,2-dioxygenase system, large oxygenase component', 317, NULL, NULL, 122799),
(122800, '2.20.110.10-FF-000064', NULL, NULL, 46, NULL, NULL, 122800),
(122801, '1.50.40.10-FF-000224', NULL, 'WGS project CABT00000000 data, contig 2.3', 203, NULL, NULL, 122801),
(122802, '3.50.50.60-FF-000269', NULL, 'FAD-dependent urate hydroxylase', 367, NULL, NULL, 122802),
(122803, '3.40.50.1010-FF-000153', NULL, NULL, 134, NULL, NULL, 122803),
(122804, '1.25.40.10-FF-003615', NULL, 'Pentatricopeptide repeat-containing protein 10, chloroplastic', 67, NULL, NULL, 122804),
(122805, '1.20.920.10-FF-000062', NULL, 'RSC complex member', 114, NULL, NULL, 122805);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(122806, '2.60.40.10-FF-005645', NULL, NULL, 93, NULL, NULL, 122806),
(122807, '3.40.50.410-FF-000261', NULL, 'Predicted protein', 204, NULL, NULL, 122807),
(122808, '3.30.70.330-FF-001002', NULL, 'Multiple RNA-binding domain-containing protein 1', 179, NULL, NULL, 122808),
(122809, '3.20.20.70-FF-000451', NULL, 'N-(5''-phosphoribosyl)anthranilate isomerase', 198, NULL, NULL, 122809),
(122810, '1.10.8.480-FF-000003', NULL, 'rRNA adenine N(6)-methyltransferase', 112, NULL, NULL, 122810),
(122811, '3.40.50.150-FF-001672', NULL, NULL, 165, NULL, NULL, 122811),
(122812, '1.10.600.10-FF-000074', NULL, 'NADH dehydrogenase (ubiquinone) complex I, assembly factor 6 homolog', 266, NULL, NULL, 122812),
(122813, '3.60.21.10-FF-000102', NULL, 'Serine/threonine-protein phosphatase', 288, NULL, NULL, 122813),
(122814, '3.30.9.10-FF-000204', NULL, 'FAD dependent oxidoreductase', 200, NULL, NULL, 122814),
(122815, '1.10.4030.10-FF-000001', NULL, 'Chaperone SurA', 47, NULL, NULL, 122815),
(122816, '1.25.40.10-FF-003273', NULL, 'Uncharacterized protein', 139, NULL, NULL, 122816),
(122817, '3.80.10.10-FF-000812', NULL, 'Zinc finger protein family member, putative', 107, NULL, NULL, 122817),
(122818, '1.10.238.110-FF-000005', NULL, 'Diacylglycerol kinase', 39, NULL, NULL, 122818),
(122819, '3.30.160.60-FF-003280', NULL, 'Zinc finger protein 586', 27, NULL, NULL, 122819),
(122820, '3.20.20.70-FF-000013', NULL, 'Class II fructose-bisphosphate aldolase', 359, NULL, NULL, 122820),
(122821, '1.10.4160.10-FF-000005', NULL, 'Thiamine transporter', 484, NULL, NULL, 122821),
(122822, '1.10.287.470-FF-000055', NULL, 'RND family resistance-nodulation-cell division efflux pump', 74, NULL, NULL, 122822),
(122823, '2.60.40.10-FF-001374', NULL, 'Echinoid, isoform C', 111, NULL, NULL, 122823),
(122824, '3.30.565.10-FF-000389', NULL, 'Sensory transduction histidine kinase', 150, NULL, NULL, 122824),
(122825, '3.30.450.20-FF-000524', NULL, 'Histidine kinase', 61, NULL, NULL, 122825),
(122826, '1.20.1050.130-FF-000055', NULL, 'Uncharacterized protein', 138, NULL, NULL, 122826),
(122827, '1.20.58.1710-FF-000003', NULL, 'Mediator of RNA polymerase II transcription subunit 8', 69, NULL, NULL, 122827),
(122828, '4.10.770.10-FF-000001', NULL, 'Runt-related transcription factor', 40, NULL, NULL, 122828),
(122829, '2.60.120.10-FF-000600', NULL, 'Uncharacterized protein', 167, NULL, NULL, 122829),
(122830, '1.20.1250.20-FF-000810', NULL, 'Protein CBG12142', 417, NULL, NULL, 122830),
(122831, '3.80.10.10-FF-002268', NULL, 'Uncharacterized protein', 99, NULL, NULL, 122831),
(122832, '2.30.40.10-FF-000116', NULL, 'Uncharacterized protein', 98, NULL, NULL, 122832),
(122833, '1.20.970.10-FF-000008', NULL, 'Anthranilate phosphoribosyltransferase', 68, NULL, NULL, 122833),
(122834, '3.30.160.60-FF-001149', NULL, 'Zinc finger protein 571', 27, NULL, NULL, 122834),
(122835, '3.50.50.60-FF-001106', NULL, 'Protoporphyrinogen oxidase', 207, NULL, NULL, 122835),
(122836, '1.20.1270.60-FF-000121', NULL, 'GTPase activating protein, putative', 134, NULL, NULL, 122836),
(122837, '3.30.450.20-FF-000069', NULL, 'Aryl hydrocarbon receptor', 115, NULL, NULL, 122837),
(122838, '1.10.3460.10-FF-000039', NULL, 'Fucoxanthin chl a/c protein, lhca clade', 212, NULL, NULL, 122838),
(122839, '2.60.40.10-FF-001716', NULL, 'Usherin', 88, NULL, NULL, 122839),
(122840, '3.40.630.30-FF-000011', NULL, 'Diamine acetyltransferase 1', 170, NULL, NULL, 122840),
(122841, '3.50.50.60-FF-000488', NULL, '2-octaprenyl-6-methoxyphenyl hydroxylase', 128, NULL, NULL, 122841),
(122842, '3.90.190.10-FF-000072', NULL, 'Phosphoglucan phosphatase LSF1 chloroplastic', 169, NULL, NULL, 122842),
(122843, '3.30.70.330-FF-000726', NULL, 'UBP1-associated protein 2A', 142, NULL, NULL, 122843),
(122844, '3.40.720.10-FF-000118', NULL, 'Lipid A phosphoethanolamine transferase', 306, NULL, NULL, 122844),
(122845, '1.10.720.30-FF-000010', NULL, 'SAFB-like transcription modulator isoform X2', 59, NULL, NULL, 122845),
(122846, '1.10.510.10-FF-003405', NULL, NULL, 300, NULL, NULL, 122846),
(122847, '1.20.1280.120-FF-000002', NULL, 'Catalase-related peroxidase', 84, NULL, NULL, 122847);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(122848, '1.10.510.10-FF-002787', NULL, NULL, 202, NULL, NULL, 122848),
(122849, '3.40.50.150-FF-001453', NULL, NULL, 139, NULL, NULL, 122849),
(122850, '1.20.1280.130-FF-000005', NULL, 'Putative vacuolar sorting protein vps45', 91, NULL, NULL, 122850),
(122851, '3.20.20.60-FF-000010', NULL, 'Phosphoenolpyruvate synthase', 312, NULL, NULL, 122851),
(122852, '1.20.1260.10-FF-000072', NULL, 'Dichlorochromopyrrolate synthase', 259, NULL, NULL, 122852),
(122853, '3.90.190.10-FF-000414', NULL, 'Uncharacterized protein', 105, NULL, NULL, 122853),
(122854, '2.10.110.10-FF-000347', NULL, 'Uncharacterized protein', 64, NULL, NULL, 122854),
(122855, '3.60.60.10-FF-000024', NULL, 'Secernin 2', 210, NULL, NULL, 122855),
(122856, '3.30.1370.210-FF-000014', NULL, 'Muscleblind-like protein 1', 54, NULL, NULL, 122856),
(122857, '1.20.1250.20-FF-002047', NULL, 'Uncharacterized protein', 314, NULL, NULL, 122857),
(122858, '3.40.50.150-FF-000958', NULL, 'Uncharacterized protein', 257, NULL, NULL, 122858),
(122859, '2.30.29.30-FF-000539', NULL, 'Uncharacterized protein, isoform A', 120, NULL, NULL, 122859),
(122860, '1.10.510.10-FF-003063', NULL, NULL, 205, NULL, NULL, 122860),
(122861, '1.25.10.10-FF-001427', NULL, 'STU2-like protein', 213, NULL, NULL, 122861),
(122862, '3.20.20.140-FF-000217', NULL, 'Dihydropyrimidinase-related protein 1', 373, NULL, NULL, 122862),
(122863, '3.60.40.10-FF-000135', NULL, 'Ser/Thr phosphatase 2C, putative', 246, NULL, NULL, 122863),
(122864, '2.130.10.10-FF-004679', NULL, 'Uncharacterized protein', 181, NULL, NULL, 122864),
(122865, '3.40.50.10380-FF-000006', NULL, 'Malic enzyme', 255, NULL, NULL, 122865),
(122866, '3.40.50.1820-FF-000531', NULL, 'Carboxypeptidase', 468, NULL, NULL, 122866),
(122867, '1.25.10.10-FF-001085', NULL, 'HEAT repeat-containing protein 2', 145, NULL, NULL, 122867),
(122868, '3.30.160.60-FF-005297', NULL, NULL, 31, NULL, NULL, 122868),
(122869, '3.30.70.3270-FF-000007', NULL, 'NADH-quinone oxidoreductase subunit I', 155, NULL, NULL, 122869),
(122870, '3.40.850.10-FF-000454', NULL, 'Predicted protein', 74, NULL, NULL, 122870),
(122871, '1.20.1740.10-FF-000221', NULL, 'Uncharacterized protein', 67, NULL, NULL, 122871),
(122872, '3.90.190.20-FF-000075', NULL, 'FolC bifunctional protein', 135, NULL, NULL, 122872),
(122873, '3.40.50.410-FF-000148', NULL, 'Midasin', 159, NULL, NULL, 122873),
(122874, '2.60.40.150-FF-000101', NULL, 'Synaptotagmin 13', 146, NULL, NULL, 122874),
(122875, '3.40.1110.10-FF-000190', NULL, 'Copper-transporting ATPase RAN1', 144, NULL, NULL, 122875),
(122876, '3.30.40.10-FF-002188', NULL, 'Predicted protein', 78, NULL, NULL, 122876),
(122877, '2.60.40.10-FF-000879', NULL, 'Colony stimulating factor 3 receptor', 106, NULL, NULL, 122877),
(122878, '4.10.640.40-FF-000006', NULL, 'Cytoplasmic polyadenylation element-binding protein 1', 59, NULL, NULL, 122878),
(122879, '1.10.10.60-FF-000958', NULL, NULL, 61, NULL, NULL, 122879),
(122880, '1.20.1070.10-FF-000821', NULL, 'AGAP008703-PA', 86, NULL, NULL, 122880),
(122881, '3.30.200.20-FF-001085', NULL, 'serine/threonine-protein kinase 10 isoform X2', 96, NULL, NULL, 122881),
(122882, '1.10.630.10-FF-000463', NULL, 'Uncharacterized protein', 120, NULL, NULL, 122882),
(122883, '1.10.10.350-FF-000018', NULL, 'Glutamate--tRNA ligase 2', 106, NULL, NULL, 122883),
(122884, '3.90.1220.10-FF-000001', NULL, NULL, 43, NULL, NULL, 122884),
(122885, '1.20.58.60-FF-000540', NULL, 'Uncharacterized protein', 164, NULL, NULL, 122885),
(122886, '1.20.120.1630-FF-000009', NULL, 'C-14 sterol reductase', 199, NULL, NULL, 122886),
(122887, '3.40.50.1460-FF-000046', NULL, 'Putative inactive caspase B', 148, NULL, NULL, 122887),
(122888, '2.60.40.10-FF-001155', NULL, 'Down syndrome cell adhesion molecule 4, isoform D', 93, NULL, NULL, 122888),
(122889, '3.30.1330.40-FF-000021', NULL, 'ATP binding L-PSP endoribonuclease family protein', 144, NULL, NULL, 122889),
(122890, '1.20.1050.10-FF-000039', NULL, 'Glutathione S-transferase theta-1', 141, NULL, NULL, 122890),
(122891, '1.10.630.10-FF-000805', NULL, 'Uncharacterized protein', 34, NULL, NULL, 122891);
INSERT INTO "PUBLIC"."MODEL" VALUES
(122892, '2.30.42.10-FF-000407', NULL, NULL, 85, NULL, NULL, 122892),
(122893, '1.10.287.3990-FF-000005', NULL, '26S proteasome regulatory subunit RPN10', 63, NULL, NULL, 122893),
(122894, '3.40.50.720-FF-001995', NULL, 'Blr6358 protein', 235, NULL, NULL, 122894),
(122895, '2.130.10.10-FF-001464', NULL, 'Ubiquitin-binding TORC1 subunit', 232, NULL, NULL, 122895),
(122896, '3.40.50.300-FF-001863', NULL, 'Heparan sulfate 2-o-sulfotransferase', 281, NULL, NULL, 122896),
(122897, '2.60.120.680-FF-000016', NULL, 'Uncharacterized protein', 82, NULL, NULL, 122897),
(122898, '3.40.50.2000-FF-000585', NULL, 'Beta-1,6-galactofuranosyltransferase WbbI', 155, NULL, NULL, 122898),
(122899, '3.30.160.60-FF-005078', NULL, NULL, 87, NULL, NULL, 122899),
(122900, '3.60.40.10-FF-000354', NULL, 'Uncharacterized protein', 315, NULL, NULL, 122900),
(122901, '2.130.10.10-FF-005174', NULL, 'AGAP006092-PA', 127, NULL, NULL, 122901),
(122902, '3.30.930.10-FF-000215', NULL, 'Proline--tRNA ligase cytoplasmic', 106, NULL, NULL, 122902),
(122903, '2.60.40.420-FF-000216', NULL, 'Laccase family multicopper oxidase', 232, NULL, NULL, 122903),
(122904, '1.10.287.3980-FF-000002', NULL, '50S ribosomal protein L34', 59, NULL, NULL, 122904),
(122905, '3.40.309.10-FF-000129', NULL, 'Uncharacterized protein', 104, NULL, NULL, 122905),
(122906, '3.40.50.800-FF-000052', NULL, 'Glycine--tRNA ligase', 110, NULL, NULL, 122906),
(122907, '3.20.20.80-FF-000235', NULL, 'Uncharacterized protein, isoform B', 325, NULL, NULL, 122907),
(122908, '1.50.40.10-FF-000005', NULL, 'Mitochondrial phosphate carrier protein 2', 276, NULL, NULL, 122908),
(122909, '1.10.472.10-FF-000657', NULL, 'Uncharacterized protein', 97, NULL, NULL, 122909),
(122910, '3.30.70.330-FF-001221', NULL, 'Ras-Gtpase-activating protein SH3 (Three) domain-Binding Protein', 148, NULL, NULL, 122910),
(122911, '2.30.31.10-FF-000022', NULL, 'Uncharacterized protein', 77, NULL, NULL, 122911),
(122912, '3.40.30.10-FF-000023', NULL, 'Protein disulfide-isomerase', 115, NULL, NULL, 122912),
(122913, '1.10.150.20-FF-000098', NULL, 'RNA polymerase alpha subunit domain protein', 71, NULL, NULL, 122913),
(122914, '3.40.50.10490-FF-000040', NULL, 'RpiR family transcriptional regulator', 186, NULL, NULL, 122914),
(122915, '1.20.120.550-FF-000004', NULL, 'Microsomal glutathione S-transferase 3', 139, NULL, NULL, 122915),
(122916, '1.20.1250.20-FF-002266', NULL, 'Uncharacterized protein', 100, NULL, NULL, 122916),
(122917, '1.10.565.10-FF-000002', NULL, 'Retinoic acid receptor RXR-alpha', 239, NULL, NULL, 122917),
(122918, '3.40.50.300-FF-005573', NULL, 'C-1-tetrahydrofolate synthase, mitochondrial', 199, NULL, NULL, 122918),
(122919, '3.10.580.10-FF-000046', NULL, 'SNF1-related protein kinase regulatory subunit gamma-1-like', 150, NULL, NULL, 122919),
(122920, '3.30.60.90-FF-000026', NULL, 'Unplaced genomic scaffold supercont1.170, whole genome shotgun sequence', 56, NULL, NULL, 122920),
(122921, '3.30.420.10-FF-000132', NULL, 'CAF1 family ribonuclease, putative', 268, NULL, NULL, 122921),
(122922, '2.130.10.10-FF-001806', NULL, 'U4/U6 small nuclear ribonuclear protein, putative', 175, NULL, NULL, 122922),
(122923, '3.40.1180.10-FF-000025', NULL, 'Alkyl transferase', 171, NULL, NULL, 122923),
(122924, '3.20.20.70-FF-000232', NULL, 'Deoxyribose-phosphate aldolase', 258, NULL, NULL, 122924),
(122925, '2.60.40.10-FF-004589', NULL, NULL, 84, NULL, NULL, 122925),
(122926, '3.40.50.720-FF-002271', NULL, 'Predicted protein', 31, NULL, NULL, 122926),
(122927, '3.30.70.330-FF-000945', NULL, 'Os04g0682400 protein', 88, NULL, NULL, 122927),
(122928, '1.20.1560.10-FF-000673', NULL, 'Uncharacterized protein TagC', 28, NULL, NULL, 122928),
(122929, '3.40.50.720-FF-000578', NULL, '3-ketodihydrosphingosine reductase', 268, NULL, NULL, 122929),
(122930, '3.30.160.60-FF-001368', NULL, 'Zinc finger protein 547', 25, NULL, NULL, 122930),
(122931, '1.20.120.540-FF-000001', NULL, 'Blast:Putative inorganic phosphate cotransporter', 118, NULL, NULL, 122931),
(122932, '2.10.25.10-FF-000751', NULL, 'Crumbs family member 1, photoreceptor morphogenesis associated', 37, NULL, NULL, 122932);
INSERT INTO "PUBLIC"."MODEL" VALUES
(122933, '3.40.50.150-FF-000037', NULL, 'Ribosomal RNA large subunit methyltransferase J', 280, NULL, NULL, 122933),
(122934, '3.30.540.30-FF-000012', NULL, 'Dipeptidyl peptidase 3', 94, NULL, NULL, 122934),
(122935, '3.30.70.330-FF-000884', NULL, 'Nucleotide/nucleic acid binding protein', 96, NULL, NULL, 122935),
(122936, '2.130.10.10-FF-005360', NULL, 'WD repeat-containing protein 91 homolog', 172, NULL, NULL, 122936),
(122937, '1.10.287.850-FF-000001', NULL, 'PE_PGRS39', 98, NULL, NULL, 122937),
(122938, '3.30.565.10-FF-000524', NULL, 'Histidine kinase', 168, NULL, NULL, 122938),
(122939, '2.30.30.140-FF-000290', NULL, 'AT14886p', 84, NULL, NULL, 122939),
(122940, '2.70.130.10-FF-000105', NULL, NULL, 148, NULL, NULL, 122940),
(122941, '1.25.10.10-FF-000916', NULL, 'AGAP003548-PA', 301, NULL, NULL, 122941),
(122942, '3.90.79.10-FF-000004', NULL, 'NADH pyrophosphatase', 132, NULL, NULL, 122942),
(122943, '3.40.50.2000-FF-001024', NULL, 'Os02g0206400 protein', 244, NULL, NULL, 122943),
(122944, '3.30.420.310-FF-000003', NULL, NULL, 215, NULL, NULL, 122944),
(122945, '1.25.40.470-FF-000080', NULL, 'Uncharacterized protein', 81, NULL, NULL, 122945),
(122946, '2.60.120.200-FF-000429', NULL, 'Galectin', 135, NULL, NULL, 122946),
(122947, '1.10.510.10-FF-000028', NULL, 'serine/threonine-protein kinase D6PK-like', 68, NULL, NULL, 122947),
(122948, '3.90.70.10-FF-000423', NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', 443, NULL, NULL, 122948),
(122949, '2.130.10.10-FF-000037', NULL, 'Putative echinoderm microtubule-associated protein-like 6', 279, NULL, NULL, 122949),
(122950, '3.30.160.20-FF-000076', NULL, 'Class I peptide chain release factor', 82, NULL, NULL, 122950),
(122951, '3.30.160.60-FF-005944', NULL, NULL, 27, NULL, NULL, 122951),
(122952, '1.10.730.10-FF-000191', NULL, 'Uncharacterized protein', 56, NULL, NULL, 122952),
(122953, '3.30.70.330-FF-000412', NULL, 'Mitochondrial ribosomal protein L23, putative', 117, NULL, NULL, 122953),
(122954, '3.10.100.10-FF-000141', NULL, 'Uncharacterized protein', 135, NULL, NULL, 122954),
(122955, '3.30.450.20-FF-000356', NULL, 'Sensor histidine kinase', 123, NULL, NULL, 122955),
(122956, '3.30.559.10-FF-000111', NULL, 'Trichothecene 3-O-acetyltransferase', 228, NULL, NULL, 122956),
(122957, '1.10.8.10-FF-000224', NULL, 'GH08043p', 46, NULL, NULL, 122957),
(122958, '3.40.50.1100-FF-000248', NULL, 'Predicted protein', 22, NULL, NULL, 122958),
(122959, '3.90.70.10-FF-000895', NULL, 'Uncharacterized protein AT4g22410', 254, NULL, NULL, 122959),
(122960, '3.90.550.10-FF-000752', NULL, 'Uncharacterized protein', 211, NULL, NULL, 122960),
(122961, '3.40.50.300-FF-001532', NULL, 'Translation elongation factor G', 296, NULL, NULL, 122961),
(122962, '1.10.10.140-FF-000007', NULL, 'Cytochrome oxidase c subunit VIb', 78, NULL, NULL, 122962),
(122963, '3.40.50.1440-FF-000092', NULL, 'Putative delta-like tubulin', 385, NULL, NULL, 122963),
(122964, '2.30.29.30-FF-000299', NULL, 'SH2B adapter protein 3 isoform X2', 127, NULL, NULL, 122964),
(122965, '3.30.200.20-FF-000164', NULL, 'Mitogen-activated protein kinase', 81, NULL, NULL, 122965),
(122966, '3.30.200.20-FF-001153', NULL, 'Protein kinase, putative', 91, NULL, NULL, 122966),
(122967, '1.10.1420.10-FF-000149', NULL, 'DNA mismatch repair protein Msh2', 128, NULL, NULL, 122967),
(122968, '1.25.10.10-FF-001905', NULL, 'Proteasome-associated protein ECM29 homolog', 544, NULL, NULL, 122968),
(122969, '1.25.40.10-FF-005095', NULL, 'Pentatricopeptide repeat-containing protein At1g32415, mitochondrial', 65, NULL, NULL, 122969),
(122970, '3.30.2160.10-FF-000022', NULL, 'E3 ubiquitin-protein ligase HECTD1', 84, NULL, NULL, 122970),
(122971, '3.80.10.10-FF-000116', NULL, 'Leucine-rich repeat-containing protein 40', 109, NULL, NULL, 122971),
(122972, '3.40.50.300-FF-001971', NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', 137, NULL, NULL, 122972),
(122973, '1.20.5.1430-FF-000004', NULL, 'Microtubule-associated protein RP/EB family member 1B', 76, NULL, NULL, 122973),
(122974, '1.10.8.1310-FF-000004', NULL, 'GTPase-activating protein', 150, NULL, NULL, 122974);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(122975, '2.10.90.10-FF-000177', NULL, 'Uncharacterized protein', 63, NULL, NULL, 122975),
(122976, '1.20.1250.20-FF-002317', NULL, 'Uncharacterized protein', 84, NULL, NULL, 122976),
(122977, '2.20.110.10-FF-000008', NULL, 'Junctophilin', 65, NULL, NULL, 122977),
(122978, '2.30.30.1150-FF-000007', NULL, 'RING/FYVE/PHD-type zinc finger family protein', 146, NULL, NULL, 122978),
(122979, '3.40.50.1000-FF-000044', NULL, 'CTD nuclear envelope phosphatase 1', 189, NULL, NULL, 122979),
(122980, '3.80.10.10-FF-001105', NULL, 'Leucine rich repeat protein phosphatase 2c domain containing protein', 107, NULL, NULL, 122980),
(122981, '3.30.70.330-FF-001401', NULL, 'Uncharacterized protein', 102, NULL, NULL, 122981),
(122982, '2.130.10.10-FF-004371', NULL, 'Uncharacterized protein', 83, NULL, NULL, 122982),
(122983, '1.25.40.10-FF-003650', NULL, 'Tetratricopeptide repeat protein 37', 166, NULL, NULL, 122983),
(122984, '2.60.40.790-FF-000013', NULL, 'Very-long-chain (3R)-3-hydroxyacyl-CoA dehydratase', 122, NULL, NULL, 122984),
(122985, '3.80.10.10-FF-004450', NULL, 'Leucine-rich repeat protein kinase family protein', 106, NULL, NULL, 122985),
(122986, '1.10.510.10-FF-001017', NULL, 'SPA1-related 4', 201, NULL, NULL, 122986),
(122987, '3.40.50.300-FF-005714', NULL, 'Predicted protein', 165, NULL, NULL, 122987),
(122988, '3.30.160.60-FF-004163', NULL, NULL, 68, NULL, NULL, 122988),
(122989, '1.10.287.70-FF-000498', NULL, 'Inward rectifier potassium channel Kirbac3.1', 104, NULL, NULL, 122989),
(122990, '2.130.10.10-FF-001818', NULL, 'WD domain, G-beta repeat-containing protein', 244, NULL, NULL, 122990),
(122991, '3.30.70.3550-FF-000002', NULL, 'Leucyl/phenylalanyl-tRNA--protein transferase', 59, NULL, NULL, 122991),
(122992, '1.25.40.20-FF-001562', NULL, 'Ankyrin repeat domain 6', 88, NULL, NULL, 122992),
(122993, '3.40.50.150-FF-001818', NULL, NULL, 93, NULL, NULL, 122993),
(122994, '3.60.40.10-FF-000107', NULL, 'Protein phosphatase 2C 21', 306, NULL, NULL, 122994),
(122995, '3.40.50.1460-FF-000098', NULL, 'Uncharacterized protein', 168, NULL, NULL, 122995),
(122996, '3.30.559.70-FF-000022', NULL, 'Choline O-acyltransferase, putative', 99, NULL, NULL, 122996),
(122997, '1.20.1250.20-FF-000991', NULL, 'MFS transporter, putative', 413, NULL, NULL, 122997),
(122998, '1.20.1310.20-FF-000018', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 252, NULL, NULL, 122998),
(122999, '1.50.10.10-FF-000032', NULL, 'Vacuolar acid trehalase', 332, NULL, NULL, 122999),
(123000, '2.40.50.140-FF-000746', NULL, 'Uncharacterized protein', 191, NULL, NULL, 123000),
(123001, '3.20.20.70-FF-000486', NULL, NULL, 177, NULL, NULL, 123001),
(123002, '3.80.10.10-FF-000588', NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase isoform B', 105, NULL, NULL, 123002),
(123003, '1.25.10.10-FF-002041', NULL, 'Cytoskeleton-associated protein 5', 249, NULL, NULL, 123003),
(123004, '3.40.50.2000-FF-000035', NULL, 'Trehalose-6-phosphate synthase', 255, NULL, NULL, 123004),
(123005, '1.20.1560.10-FF-000472', NULL, 'Uncharacterized protein', 320, NULL, NULL, 123005),
(123006, '3.40.420.10-FF-000001', NULL, 'Ricin', 174, NULL, NULL, 123006),
(123007, '3.30.10.20-FF-000026', NULL, NULL, 66, NULL, NULL, 123007),
(123008, '1.20.1160.11-FF-000021', NULL, NULL, 68, NULL, NULL, 123008),
(123009, '3.90.215.10-FF-000018', NULL, 'Techylectin-5A', 151, NULL, NULL, 123009),
(123010, '3.60.110.10-FF-000001', NULL, 'biotinidase isoform X1', 297, NULL, NULL, 123010),
(123011, '1.10.287.110-FF-000072', NULL, 'DnaJ family protein', 120, NULL, NULL, 123011),
(123012, '3.30.1360.20-FF-000006', NULL, NULL, 105, NULL, NULL, 123012),
(123013, '3.40.50.300-FF-007159', NULL, 'Predicted protein', 175, NULL, NULL, 123013),
(123014, '1.20.144.10-FF-000079', NULL, 'Glucose-6-phosphatase a, catalytic subunit, tandem duplicate 1', 97, NULL, NULL, 123014),
(123015, '3.40.850.10-FF-000230', NULL, 'Kinesin-5', 385, NULL, NULL, 123015),
(123016, '3.30.160.60-FF-006080', NULL, NULL, 65, NULL, NULL, 123016),
(123017, '3.30.1330.40-FF-000044', NULL, 'Ribonuclease UK114', 101, NULL, NULL, 123017);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(123018, '1.10.8.60-FF-000278', NULL, 'Smallminded, isoform H', 112, NULL, NULL, 123018),
(123019, '3.50.30.30-FF-000136', NULL, 'Uncharacterized protein', 144, NULL, NULL, 123019),
(123020, '3.30.70.20-FF-000035', NULL, 'Iron hydrogenase 1', 78, NULL, NULL, 123020),
(123021, '2.60.40.10-FF-005495', NULL, NULL, 95, NULL, NULL, 123021),
(123022, '3.30.70.1230-FF-000273', NULL, 'Uncharacterized protein', 117, NULL, NULL, 123022),
(123023, '2.10.70.20-FF-000004', NULL, 'Type II secretion system protein J', 47, NULL, NULL, 123023),
(123024, '3.40.50.10240-FF-000038', NULL, 'Uncharacterized protein', 121, NULL, NULL, 123024),
(123025, '1.10.287.130-FF-000078', NULL, 'Heme sensor histidine kinase HssS', 64, NULL, NULL, 123025),
(123026, '3.40.50.620-FF-000049', NULL, 'Probable glutamine--tRNA ligase', 347, NULL, NULL, 123026),
(123027, '2.130.10.10-FF-005208', NULL, 'Uncharacterized protein', 93, NULL, NULL, 123027),
(123028, '3.30.930.10-FF-000076', NULL, 'Threonine--tRNA ligase', 306, NULL, NULL, 123028),
(123029, '1.25.10.10-FF-001052', NULL, 'Pumilio domain-containing protein 12', 223, NULL, NULL, 123029),
(123030, '3.80.10.10-FF-002533', NULL, 'F-box and leucine rich repeat protein 5', 83, NULL, NULL, 123030),
(123031, '2.60.40.10-FF-000352', NULL, 'Cell adhesion molecule-related/down-regulated by oncogenes', 100, NULL, NULL, 123031),
(123032, '2.30.170.20-FF-000001', NULL, 'probable ribosome biogenesis protein RLP24', 67, NULL, NULL, 123032),
(123033, '1.20.960.10-FF-000003', NULL, 'Translocase of outer mitochondrial membrane 20 like', 94, NULL, NULL, 123033),
(123034, '4.10.60.10-FF-000064', NULL, 'Unplaced genomic scaffold supercont1.38, whole genome shotgun sequence', 29, NULL, NULL, 123034),
(123035, '2.130.10.10-FF-003382', NULL, 'Syntaxin-binding protein 5', 311, NULL, NULL, 123035),
(123036, '3.30.70.1660-FF-000020', NULL, 'Peptide chain release factor 2', 157, NULL, NULL, 123036),
(123037, '3.40.50.1220-FF-000138', NULL, 'Sirtuin 1', 43, NULL, NULL, 123037),
(123038, '3.20.20.190-FF-000087', NULL, 'Glycerophosphodiester phosphodiesterase, putative', 312, NULL, NULL, 123038),
(123039, '1.10.1200.10-FF-000138', NULL, 'Nonribosomal peptide synthase, putative (JCVI)', 91, NULL, NULL, 123039),
(123040, '2.30.42.10-FF-000638', NULL, NULL, 63, NULL, NULL, 123040),
(123041, '3.40.50.150-FF-001465', NULL, NULL, 135, NULL, NULL, 123041),
(123042, '3.40.50.300-FF-007631', NULL, 'Uncharacterized protein', 144, NULL, NULL, 123042),
(123043, '1.25.40.20-FF-000101', NULL, 'Transient receptor potential cation channel subfamily V member 3', 304, NULL, NULL, 123043),
(123044, '2.60.40.1960-FF-000007', NULL, 'Nothepsin', 48, NULL, NULL, 123044),
(123045, '3.40.50.720-FF-002350', NULL, 'Predicted protein', 94, NULL, NULL, 123045),
(123046, '1.25.10.10-FF-000063', NULL, 'Putative cytoskeleton-associated protein 5', 250, NULL, NULL, 123046),
(123047, '3.30.1370.10-FF-000094', NULL, 'Exosome complex component RRP40, putative', 86, NULL, NULL, 123047),
(123048, '1.10.10.60-FF-000026', NULL, 'Nuclear receptor corepressor 2 isoform 1', 73, NULL, NULL, 123048),
(123049, '3.80.10.10-FF-003022', NULL, 'Chromosome 1, whole genome shotgun sequence', 146, NULL, NULL, 123049),
(123050, '3.40.50.2300-FF-000827', NULL, NULL, 131, NULL, NULL, 123050),
(123051, '3.60.10.10-FF-000398', NULL, 'Uncharacterized protein', 54, NULL, NULL, 123051),
(123052, '1.20.1110.10-FF-000213', NULL, NULL, 64, NULL, NULL, 123052),
(123053, '3.30.160.60-FF-000773', NULL, 'Zinc finger protein 44', 29, NULL, NULL, 123053),
(123054, '3.55.50.30-FF-000020', NULL, 'Fec operon regulator FecR', 75, NULL, NULL, 123054),
(123055, '3.30.420.40-FF-000714', NULL, 'Actin-related protein 4', 151, NULL, NULL, 123055),
(123056, '1.20.1050.10-FF-000242', NULL, 'Uncharacterized protein', 65, NULL, NULL, 123056),
(123057, '2.170.300.10-FF-000044', NULL, 'Multiple epidermal growth factor-like domains protein 6', 128, NULL, NULL, 123057),
(123058, '3.20.20.70-FF-000839', NULL, NULL, 96, NULL, NULL, 123058),
(123059, '1.20.1300.10-FF-000043', NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', 136, NULL, NULL, 123059);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(123060, '3.50.50.60-FF-001495', NULL, 'Uncharacterized protein', 38, NULL, NULL, 123060),
(123061, '3.40.50.1110-FF-000105', NULL, 'SGNH-hydrolase lipoprotein, lysophospholipase L1-like subgroup', 183, NULL, NULL, 123061),
(123062, '3.10.129.10-FF-000044', NULL, 'Acyl-ACP thioesterase', 246, NULL, NULL, 123062),
(123063, '2.30.29.30-FF-001288', NULL, 'Uncharacterized protein', 90, NULL, NULL, 123063),
(123064, '3.40.50.10130-FF-000005', NULL, 'crossover junction endonuclease MUS81 isoform X1', 147, NULL, NULL, 123064),
(123065, '3.30.420.10-FF-000638', NULL, NULL, 151, NULL, NULL, 123065),
(123066, '2.60.40.1660-FF-000007', NULL, 'Sodium/potassium-transporting ATPase subunit beta', 217, NULL, NULL, 123066),
(123067, '3.20.20.80-FF-000376', NULL, 'Glycosyl hydrolase family 17 protein', 321, NULL, NULL, 123067),
(123068, '3.30.160.60-FF-001762', NULL, 'zinc finger protein 140 isoform X3', 31, NULL, NULL, 123068),
(123069, '2.60.490.10-FF-000004', NULL, 'Expressed protein', 33, NULL, NULL, 123069),
(123070, '3.40.50.1000-FF-000836', NULL, NULL, 203, NULL, NULL, 123070),
(123071, '1.10.287.130-FF-000139', NULL, 'Sensor histidine kinase', 108, NULL, NULL, 123071),
(123072, '3.20.20.60-FF-000157', NULL, 'Aldolase like', 53, NULL, NULL, 123072),
(123073, '3.30.830.10-FF-000192', NULL, 'Metalloprotease', 284, NULL, NULL, 123073),
(123074, '3.30.160.60-FF-003999', NULL, NULL, 30, NULL, NULL, 123074),
(123075, '1.20.1000.10-FF-000031', NULL, NULL, 297, NULL, NULL, 123075),
(123076, '2.160.20.10-FF-000031', NULL, 'PKHD1 like 1', 294, NULL, NULL, 123076),
(123077, '3.90.25.10-FF-000088', NULL, 'Uncharacterized protein', 32, NULL, NULL, 123077),
(123078, '3.90.120.10-FF-000023', NULL, 'DNA (cytosine-5)-methyltransferase', 62, NULL, NULL, 123078),
(123079, '3.40.50.300-FF-006703', NULL, 'Uncharacterized protein', 78, NULL, NULL, 123079),
(123080, '3.40.50.300-FF-002960', NULL, 'RecBCD enzyme subunit RecB', 82, NULL, NULL, 123080),
(123081, '1.25.10.10-FF-003289', NULL, 'Aminopeptidase', 184, NULL, NULL, 123081),
(123082, '2.60.40.10-FF-003139', NULL, NULL, 106, NULL, NULL, 123082),
(123083, '1.20.120.1080-FF-000103', NULL, 'Putative ATP-dependent RNA helicase DHX37', 109, NULL, NULL, 123083),
(123084, '3.30.300.20-FF-000048', NULL, 'Ribosome-binding factor A', 113, NULL, NULL, 123084),
(123085, '1.20.1070.10-FF-000625', NULL, 'Chemokine (C-C motif) receptor 10', 299, NULL, NULL, 123085),
(123086, '3.90.1300.10-FF-000019', NULL, 'Uncharacterized protein', 128, NULL, NULL, 123086),
(123087, '3.40.1160.10-FF-000103', NULL, 'Uncharacterized protein', 57, NULL, NULL, 123087),
(123088, '3.40.50.1820-FF-000610', NULL, 'LIPaSe related', 291, NULL, NULL, 123088),
(123089, '3.30.160.60-FF-005505', NULL, NULL, 31, NULL, NULL, 123089),
(123090, '1.10.287.70-FF-000059', NULL, 'Voltage-dependent N-type calcium channel subunit alpha', 155, NULL, NULL, 123090),
(123091, '2.30.29.30-FF-000832', NULL, 'Kinesin-3 motor protein', 106, NULL, NULL, 123091),
(123092, '1.20.1280.50-FF-000243', NULL, 'LOC100145488 protein', 90, NULL, NULL, 123092),
(123093, '1.25.40.10-FF-001233', NULL, 'Pentatricopeptide repeat-containing protein At3g50420', 95, NULL, NULL, 123093),
(123094, '1.10.510.10-FF-000680', NULL, 'Mitogen-activated protein kinase', 136, NULL, NULL, 123094),
(123095, '2.60.40.1180-FF-000105', NULL, 'Calpain family cysteine protease-like protein', 111, NULL, NULL, 123095),
(123096, '3.80.10.10-FF-003522', NULL, 'Leucine-rich repeat protein (LRRP), putative', 172, NULL, NULL, 123096),
(123097, '1.10.238.10-FF-000428', NULL, 'Probable SAC6-actin filament bundling protein, fimbrin', 83, NULL, NULL, 123097),
(123098, '3.30.1330.10-FF-000029', NULL, 'Trifunctional purine biosynthetic protein adenosine-3', 163, NULL, NULL, 123098),
(123099, '3.30.70.330-FF-002649', NULL, NULL, 172, NULL, NULL, 123099),
(123100, '1.25.70.10-FF-000100', NULL, NULL, 159, NULL, NULL, 123100),
(123101, '1.25.40.20-FF-000601', NULL, 'Uncharacterized protein', 209, NULL, NULL, 123101),
(123102, '1.25.40.10-FF-000744', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 176, NULL, NULL, 123102);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(123103, '3.40.50.150-FF-000829', NULL, 'mRNA cap guanine-N7 methyltransferase', 297, NULL, NULL, 123103),
(123104, '3.40.390.10-FF-000211', NULL, 'Metalloendopeptidase', 244, NULL, NULL, 123104),
(123105, '3.40.640.10-FF-000012', NULL, 'alanine aminotransferase 2', 248, NULL, NULL, 123105),
(123106, '2.30.30.40-FF-000434', NULL, 'Tyrosine-protein kinase', 85, NULL, NULL, 123106),
(123107, '3.90.550.50-FF-000005', NULL, 'Hydroxyproline O-galactosyltransferase', 244, NULL, NULL, 123107),
(123108, '3.30.930.10-FF-000137', NULL, 'Histidine--tRNA ligase', 105, NULL, NULL, 123108),
(123109, '3.10.50.40-FF-000001', NULL, 'Trigger factor', 96, NULL, NULL, 123109),
(123110, '1.20.58.60-FF-000771', NULL, 'Predicted protein', 241, NULL, NULL, 123110),
(123111, '2.60.40.1400-FF-000008', NULL, 'ATP-sensitive inward rectifier potassium channel 10', 179, NULL, NULL, 123111),
(123112, '3.40.50.10860-FF-000016', NULL, 'Shikimate dehydrogenase (NADP(+))', 119, NULL, NULL, 123112),
(123113, '1.20.1280.170-FF-000012', NULL, 'Exocyst subunit Exo70 family protein', 521, NULL, NULL, 123113),
(123114, '1.20.1070.10-FF-001114', NULL, 'Rhodopsin', 355, NULL, NULL, 123114),
(123115, '3.40.1060.10-FF-000006', NULL, 'Aconitate hydratase 1', 113, NULL, NULL, 123115),
(123116, '1.20.58.70-FF-000009', NULL, 'Syntaxin 12', 126, NULL, NULL, 123116),
(123117, '3.40.50.300-FF-000190', NULL, 'ATP-dependent RNA helicase', 212, NULL, NULL, 123117),
(123118, '3.40.50.800-FF-000098', NULL, 'Anticodon binding domain of tRNAs-domain-containing protein', 105, NULL, NULL, 123118),
(123119, '1.20.1250.20-FF-001980', NULL, 'Uncharacterized protein', 393, NULL, NULL, 123119),
(123120, '2.40.170.20-FF-000123', NULL, 'SusC homolog', 656, NULL, NULL, 123120),
(123121, '3.30.200.20-FF-001945', NULL, 'Uncharacterized protein', 108, NULL, NULL, 123121),
(123122, '3.40.50.920-FF-000049', NULL, 'Indolepyruvate oxidoreductase subunit IorA', 96, NULL, NULL, 123122),
(123123, '3.40.50.410-FF-000284', NULL, 'Protein transport protein SEC23', 28, NULL, NULL, 123123),
(123124, '1.10.510.10-FF-002006', NULL, 'Predicted protein', 177, NULL, NULL, 123124),
(123125, '2.70.150.10-FF-000168', NULL, 'Phospholipid-transporting ATPase', 136, NULL, NULL, 123125),
(123126, '3.30.70.330-FF-001340', NULL, 'GD18742', 93, NULL, NULL, 123126),
(123127, '1.10.565.10-FF-000115', NULL, 'Nuclear Hormone Receptor family', 222, NULL, NULL, 123127),
(123128, '3.80.10.10-FF-004511', NULL, 'Pollen receptor-like kinase 1', 98, NULL, NULL, 123128),
(123129, '1.10.8.100-FF-000019', NULL, 'Ribosomal RNA small subunit methyltransferase A', 76, NULL, NULL, 123129),
(123130, '3.40.50.300-FF-006203', NULL, 'DNA helicase', 171, NULL, NULL, 123130),
(123131, '1.25.40.10-FF-000244', NULL, 'SGT1 homolog, MIS12 kinetochore complex assembly cochaperone', 123, NULL, NULL, 123131),
(123132, '3.40.50.11840-FF-000001', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', 86, NULL, NULL, 123132),
(123133, '3.50.50.60-FF-001523', NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', 215, NULL, NULL, 123133),
(123134, '2.40.240.10-FF-000002', NULL, '50S ribosomal protein L25', 94, NULL, NULL, 123134),
(123135, '1.10.238.10-FF-000075', NULL, 'synergin gamma isoform X2', 88, NULL, NULL, 123135),
(123136, '1.10.10.440-FF-000007', NULL, 'Putative rho GTPase-activating protein 5', 63, NULL, NULL, 123136),
(123137, '1.25.10.10-FF-001844', NULL, 'AGAP004535-PA', 363, NULL, NULL, 123137),
(123138, '3.30.1490.70-FF-000013', NULL, 'DNA ligase 3', 73, NULL, NULL, 123138),
(123139, '1.10.3370.10-FF-000004', NULL, 'Protein translocase subunit SecY', 412, NULL, NULL, 123139),
(123140, '1.10.10.10-FF-001872', NULL, 'Selenocysteine-specific elongation factor', 62, NULL, NULL, 123140),
(123141, '2.30.29.30-FF-000771', NULL, 'CCM2-like scaffold protein', 99, NULL, NULL, 123141),
(123142, '1.20.5.190-FF-000095', NULL, NULL, 55, NULL, NULL, 123142),
(123143, '1.10.472.10-FF-000635', NULL, 'cyclin-H', 119, NULL, NULL, 123143),
(123144, '1.10.287.110-FF-000100', NULL, 'DnaJ domain containing protein', 70, NULL, NULL, 123144); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(123145, '1.10.8.270-FF-000110', NULL, 'Rab-GTPase-TBC domain-domain-containing protein', 114, NULL, NULL, 123145),
(123146, '1.10.10.10-FF-001725', NULL, 'Expressed protein', 61, NULL, NULL, 123146),
(123147, '2.60.40.10-FF-003078', NULL, 'Vascular endothelial growth factor receptor 2', 107, NULL, NULL, 123147),
(123148, '2.60.120.970-FF-000020', NULL, 'growth/differentiation factor 3', 227, NULL, NULL, 123148),
(123149, '3.90.132.10-FF-000011', NULL, 'Cell surface protease gp63, putative', 119, NULL, NULL, 123149),
(123150, '3.10.450.50-FF-000089', NULL, 'Nuclear export factor-b', 139, NULL, NULL, 123150),
(123151, '3.30.40.10-FF-000497', NULL, 'RING-H2 finger protein ATL73', 74, NULL, NULL, 123151),
(123152, '3.30.200.20-FF-002081', NULL, 'Uncharacterized protein', 83, NULL, NULL, 123152),
(123153, '3.30.40.10-FF-001014', NULL, 'Lysine (K)-specific demethylase 5C', 64, NULL, NULL, 123153),
(123154, '1.10.390.10-FF-000091', NULL, 'Protease m1 zinc metalloprotease, putative', 233, NULL, NULL, 123154),
(123155, '3.40.50.2300-FF-001316', NULL, NULL, 108, NULL, NULL, 123155),
(123156, '2.10.110.10-FF-000033', NULL, 'LIM/homeobox protein Lhx9 isoform X2', 67, NULL, NULL, 123156),
(123157, '3.40.50.1460-FF-000131', NULL, 'Uncharacterized protein', 85, NULL, NULL, 123157),
(123158, '3.30.1050.10-FF-000047', NULL, 'Uncharacterized protein', 49, NULL, NULL, 123158),
(123159, '3.30.420.40-FF-000214', NULL, 'Pantothenate kinase 1', 105, NULL, NULL, 123159),
(123160, '3.90.400.10-FF-000005', NULL, 'Trehalose synthase TreS', 70, NULL, NULL, 123160),
(123161, '2.60.40.10-FF-002330', NULL, 'Myotactin form B', 92, NULL, NULL, 123161),
(123162, '1.10.260.100-FF-000021', NULL, 'Heat shock protein STI1, putative', 62, NULL, NULL, 123162),
(123163, '3.40.1160.10-FF-000042', NULL, 'Delta-1-pyrroline-5-carboxylate synthase', 282, NULL, NULL, 123163),
(123164, '1.25.40.180-FF-000318', NULL, NULL, 123, NULL, NULL, 123164),
(123165, '3.60.20.10-FF-000224', NULL, NULL, 128, NULL, NULL, 123165),
(123166, '2.130.10.10-FF-003882', NULL, 'Uncharacterized protein', 276, NULL, NULL, 123166),
(123167, '1.20.1560.10-FF-000825', NULL, 'ABC protein, subfamily ABCB/MDR', 29, NULL, NULL, 123167),
(123168, '1.10.510.10-FF-000972', NULL, 'Protein kinase domain containing protein', 286, NULL, NULL, 123168),
(123169, '3.80.10.10-FF-002033', NULL, 'F-box/LRR-repeat protein 4', 96, NULL, NULL, 123169),
(123170, '2.10.70.10-FF-000294', NULL, 'Uncharacterized protein', 51, NULL, NULL, 123170),
(123171, '3.40.50.300-FF-002460', NULL, 'Regulator of nonsense transcripts 1', 260, NULL, NULL, 123171),
(123172, '3.40.30.70-FF-000002', NULL, 'Glutamyl-tRNA synthetase', 89, NULL, NULL, 123172),
(123173, '3.30.70.850-FF-000006', NULL, 'Endoprotease bli', 77, NULL, NULL, 123173),
(123174, '1.10.10.10-FF-001433', NULL, 'DNA-binding response regulator', 104, NULL, NULL, 123174),
(123175, '3.40.50.880-FF-000048', NULL, 'DJ-1 family protein', 185, NULL, NULL, 123175),
(123176, '3.40.50.450-FF-000037', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase', 193, NULL, NULL, 123176),
(123177, '1.20.1740.10-FF-000098', NULL, 'Arginine/ornithine antiporter', 471, NULL, NULL, 123177),
(123178, '2.30.30.140-FF-000351', NULL, 'Uncharacterized protein', 131, NULL, NULL, 123178),
(123179, '1.20.1050.80-FF-000010', NULL, 'protein sprint isoform X2', 145, NULL, NULL, 123179),
(123180, '3.40.50.300-FF-008148', NULL, 'Uncharacterized protein', 95, NULL, NULL, 123180),
(123181, '2.60.120.10-FF-000657', NULL, 'Uncharacterized protein', 130, NULL, NULL, 123181),
(123182, '2.10.70.10-FF-000114', NULL, 'Uncharacterized protein, isoform B', 47, NULL, NULL, 123182),
(123183, '3.40.50.1580-FF-000049', NULL, 'Purine nucleoside phosphorylase', 282, NULL, NULL, 123183),
(123184, '3.30.750.24-FF-000081', NULL, 'Sodium-independent anion transporter', 116, NULL, NULL, 123184),
(123185, '1.10.1040.10-FF-000103', NULL, 'Oxidoreductase subunit', 65, NULL, NULL, 123185),
(123186, '3.40.30.10-FF-000271', NULL, 'Thioredoxin reductase 1, cytoplasmic', 106, NULL, NULL, 123186);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(123187, '3.40.50.2300-FF-001463', NULL, NULL, 163, NULL, NULL, 123187),
(123188, '3.30.559.10-FF-000083', NULL, 'Probable non-ribosomal peptide synthetase', 187, NULL, NULL, 123188),
(123189, '3.30.200.20-FF-000956', NULL, 'Protein kinase, putative', 103, NULL, NULL, 123189),
(123190, '1.20.190.20-FF-000003', NULL, 'Casparian strip membrane protein 4', 57, NULL, NULL, 123190),
(123191, '2.130.10.10-FF-003735', NULL, 'Uncharacterized protein', 334, NULL, NULL, 123191),
(123192, '3.30.160.60-FF-006433', NULL, NULL, 41, NULL, NULL, 123192),
(123193, '1.10.10.790-FF-000033', NULL, NULL, 95, NULL, NULL, 123193),
(123194, '2.40.100.10-FF-000172', NULL, 'Uncharacterized protein', 168, NULL, NULL, 123194),
(123195, '3.30.730.10-FF-000009', NULL, 'AP2 domain containing protein, expressed', 60, NULL, NULL, 123195),
(123196, '3.20.20.70-FF-000547', NULL, NULL, 209, NULL, NULL, 123196),
(123197, '1.20.1070.10-FF-000125', NULL, 'growth hormone secretagogue receptor type 1', 304, NULL, NULL, 123197),
(123198, '3.40.309.10-FF-000074', NULL, 'Succinate-semialdehyde dehydrogenase [NADP(+)] GabD', 217, NULL, NULL, 123198),
(123199, '2.60.120.200-FF-000076', NULL, 'basement membrane-specific heparan sulfate proteoglycan core protein-like', 186, NULL, NULL, 123199),
(123200, '2.40.160.10-FF-000029', NULL, 'Porin, putative', 320, NULL, NULL, 123200),
(123201, '2.60.220.50-FF-000154', NULL, 'Adhesion G protein-coupled receptor L4', 173, NULL, NULL, 123201),
(123202, '3.40.50.720-FF-001361', NULL, 'Prephenate dehydrogenase', 159, NULL, NULL, 123202),
(123203, '3.30.430.20-FF-000001', NULL, 'cysteine-rich repeat secretory protein 3', 106, NULL, NULL, 123203),
(123204, '3.40.50.2300-FF-000799', NULL, 'Guanylate cyclase', 182, NULL, NULL, 123204),
(123205, '2.70.160.11-FF-000063', NULL, 'Protein arginine N-methyltransferase 6', 187, NULL, NULL, 123205),
(123206, '3.40.50.1820-FF-000110', NULL, 'Hormone-sensitive lipase', 201, NULL, NULL, 123206),
(123207, '1.10.287.4310-FF-000001', NULL, 'Coupling of ubiquitin conjugation to ER degradation', 54, NULL, NULL, 123207),
(123208, '1.25.10.10-FF-000124', NULL, 'lisH domain-containing protein ARMC9 isoform X1', 203, NULL, NULL, 123208),
(123209, '3.40.50.300-FF-002308', NULL, 'Similar to Rho-like small GTPase', 173, NULL, NULL, 123209),
(123210, '2.30.170.40-FF-000007', NULL, '50S ribosomal protein L28', 75, NULL, NULL, 123210),
(123211, '3.30.559.30-FF-000089', NULL, 'Nonribosomal peptide synthase 2', 48, NULL, NULL, 123211),
(123212, '3.30.470.20-FF-000239', NULL, 'Inositol-tetrakisphosphate 1-kinase', 68, NULL, NULL, 123212),
(123213, '2.30.30.770-FF-000006', NULL, '60S ribosomal protein L27', 80, NULL, NULL, 123213),
(123214, '3.80.10.10-FF-000908', NULL, 'Receptor like protein 41', 323, NULL, NULL, 123214),
(123215, '1.10.510.10-FF-000180', NULL, 'Receptor protein serine/threonine kinase', 239, NULL, NULL, 123215),
(123216, '3.90.190.10-FF-000297', NULL, 'Protein-tyrosine phosphatase-like protein', 250, NULL, NULL, 123216),
(123217, '1.10.8.60-FF-000306', NULL, 'AAA ATPase central domain protein', 76, NULL, NULL, 123217),
(123218, '3.40.50.12780-FF-000160', NULL, 'Nonribosomal peptide synthase, putative (JCVI)', 137, NULL, NULL, 123218),
(123219, '1.20.930.20-FF-000004', NULL, 'E3 ubiquitin-protein ligase CBL-C', 134, NULL, NULL, 123219),
(123220, '3.30.60.90-FF-000038', NULL, 'E3_ubiquitin-protein_ligase_KCMF1_-_putative', 55, NULL, NULL, 123220),
(123221, '2.10.110.10-FF-000325', NULL, 'AGAP012744-PA', 33, NULL, NULL, 123221),
(123222, '2.40.50.140-FF-001235', NULL, NULL, 38, NULL, NULL, 123222),
(123223, '3.40.50.300-FF-004225', NULL, 'Homolog to translation elongation factor aEF-1 alpha subunit', 226, NULL, NULL, 123223),
(123224, '3.50.7.10-FF-000010', NULL, 'T-complex protein 1 subunit delta', 159, NULL, NULL, 123224),
(123225, '3.40.1810.10-FF-000013', NULL, 'Transcription factor, MADS-box', 82, NULL, NULL, 123225),
(123226, '2.40.160.10-FF-000001', NULL, 'Voltage-dependent anion-selective channel protein 2', 283, NULL, NULL, 123226),
(123227, '2.60.40.10-FF-005848', NULL, NULL, 122, NULL, NULL, 123227);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(123228, '3.40.50.12160-FF-000002', NULL, 'Ribosomal protein S12 methylthiotransferase RimO', 118, NULL, NULL, 123228),
(123229, '3.40.50.620-FF-000549', NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', 358, NULL, NULL, 123229),
(123230, '1.20.1170.10-FF-000009', NULL, NULL, 295, NULL, NULL, 123230),
(123231, '2.60.40.2690-FF-000013', NULL, 'Predicted protein', 95, NULL, NULL, 123231),
(123232, '3.30.160.60-FF-000301', NULL, 'Zinc finger protein 236', 30, NULL, NULL, 123232),
(123233, '2.60.40.10-FF-003611', NULL, NULL, 105, NULL, NULL, 123233),
(123234, '1.25.10.10-FF-001552', NULL, 'Uncharacterized protein', 363, NULL, NULL, 123234),
(123235, '3.30.450.60-FF-000048', NULL, 'AP complex subunit sigma', 146, NULL, NULL, 123235),
(123236, '1.25.40.80-FF-000012', NULL, 'Deoxyribodipyrimidine photolyase', 206, NULL, NULL, 123236),
(123237, '2.60.200.20-FF-000195', NULL, 'Uncharacterized protein', 139, NULL, NULL, 123237),
(123238, '4.10.800.10-FF-000016', NULL, 'Thyroglobulin', 66, NULL, NULL, 123238),
(123239, '3.50.50.60-FF-000859', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 113, NULL, NULL, 123239),
(123240, '1.20.1440.90-FF-000003', NULL, 'Phosphoenolpyruvate carboxylase 4', 121, NULL, NULL, 123240),
(123241, '3.30.230.70-FF-000074', NULL, 'EXOSome (Multiexonuclease complex) component', 302, NULL, NULL, 123241),
(123242, '2.30.30.30-FF-000105', NULL, 'Apicoplast ribosomal protein L2', 78, NULL, NULL, 123242),
(123243, '1.25.40.10-FF-004959', NULL, 'Uncharacterized protein', 162, NULL, NULL, 123243),
(123244, '3.40.20.10-FF-000034', NULL, 'protein flightless-1 homolog isoform X1', 166, NULL, NULL, 123244),
(123245, '3.40.980.10-FF-000003', NULL, 'Molybdenum cofactor biosynthesis protein B', 170, NULL, NULL, 123245),
(123246, '2.30.30.90-FF-000016', NULL, 'Ferrous iron transport protein A', 79, NULL, NULL, 123246),
(123247, '2.10.220.10-FF-000154', NULL, 'Proprotein convertase subtilisin/kexin type 5', 78, NULL, NULL, 123247),
(123248, '3.40.1110.10-FF-000331', NULL, NULL, 141, NULL, NULL, 123248),
(123249, '1.25.40.120-FF-000087', NULL, 'Uncharacterized protein', 272, NULL, NULL, 123249),
(123250, '3.30.160.60-FF-005152', NULL, NULL, 74, NULL, NULL, 123250),
(123251, '1.20.1070.10-FF-002042', NULL, 'Uncharacterized protein', 110, NULL, NULL, 123251),
(123252, '3.30.565.10-FF-000496', NULL, 'Uncharacterized protein', 138, NULL, NULL, 123252),
(123253, '2.40.10.10-FF-000334', NULL, NULL, 43, NULL, NULL, 123253),
(123254, '3.30.160.60-FF-002690', NULL, 'Uncharacterized protein', 25, NULL, NULL, 123254),
(123255, '2.60.60.20-FF-000064', NULL, NULL, 105, NULL, NULL, 123255),
(123256, '3.30.70.330-FF-001368', NULL, 'Conserved protein', 155, NULL, NULL, 123256),
(123257, '2.60.260.20-FF-000024', NULL, 'Mitochondrial protein import protein MAS5', 82, NULL, NULL, 123257),
(123258, '2.70.150.10-FF-000140', NULL, 'Sarco/endoplasmic reticulum Ca2+ -ATPase', 163, NULL, NULL, 123258),
(123259, '3.30.310.10-FF-000017', NULL, 'Ribonuclease HIII', 83, NULL, NULL, 123259),
(123260, '3.80.10.10-FF-002825', NULL, 'Protein CBG03541', 142, NULL, NULL, 123260),
(123261, '3.10.110.10-FF-000198', NULL, 'Ubiquitin-conjugating enzyme family protein', 152, NULL, NULL, 123261),
(123262, '3.90.660.10-FF-000142', NULL, NULL, 160, NULL, NULL, 123262),
(123263, '3.40.50.300-FF-002016', NULL, 'Uncharacterized protein', 144, NULL, NULL, 123263),
(123264, '1.10.630.10-FF-000508', NULL, 'Epoxyalcohol synthase CYP443D1', 431, NULL, NULL, 123264),
(123265, '3.40.390.10-FF-000183', NULL, NULL, 191, NULL, NULL, 123265),
(123266, '3.65.10.10-FF-000039', NULL, 'Uncharacterized protein', 120, NULL, NULL, 123266),
(123267, '3.40.50.150-FF-000537', NULL, 'tRNA/rRNA cytosine-C5-methylase RsmB', 296, NULL, NULL, 123267),
(123268, '3.30.160.60-FF-004516', NULL, NULL, 37, NULL, NULL, 123268),
(123269, '3.90.260.10-FF-000033', NULL, 'Uncharacterized protein', 314, NULL, NULL, 123269),
(123270, '3.40.250.10-FF-000201', NULL, 'ACL041Cp', 148, NULL, NULL, 123270),
(123271, '2.130.10.10-FF-005860', NULL, 'Two-component system sensor histidine kinase', 317, NULL, NULL, 123271);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(123272, '3.30.450.40-FF-000042', NULL, 'Probable diguanylate cyclase YeaP', 160, NULL, NULL, 123272),
(123273, '4.10.240.10-FF-000052', NULL, 'Activator of stress genes', 56, NULL, NULL, 123273),
(123274, '3.80.10.10-FF-000088', NULL, 'Putative leucine-rich repeat-containing protein 41', 131, NULL, NULL, 123274),
(123275, '2.60.120.330-FF-000148', NULL, 'Tetraspanin', 88, NULL, NULL, 123275),
(123276, '3.30.70.260-FF-000104', NULL, 'Threonine dehydratase (IlvA)', 77, NULL, NULL, 123276),
(123277, '3.30.60.30-FF-000127', NULL, 'Uncharacterized protein', 50, NULL, NULL, 123277),
(123278, '3.10.450.50-FF-000061', NULL, 'Uncharacterized protein', 126, NULL, NULL, 123278),
(123279, '3.80.10.10-FF-000616', NULL, 'Tubulin-specific chaperone E', 101, NULL, NULL, 123279),
(123280, '2.130.10.10-FF-002454', NULL, 'WD repeat domain 3', 246, NULL, NULL, 123280),
(123281, '2.70.50.30-FF-000015', NULL, NULL, 109, NULL, NULL, 123281),
(123282, '3.30.230.10-FF-000163', NULL, 'DNA repair protein RadA', 172, NULL, NULL, 123282),
(123283, '2.30.42.10-FF-000346', NULL, 'LIM domain kinase 1b', 106, NULL, NULL, 123283),
(123284, '3.40.50.12370-FF-000008', NULL, 'Chloride channel protein', 277, NULL, NULL, 123284),
(123285, '3.30.200.20-FF-000664', NULL, 'Cyclin-dependent kinase F-1', 95, NULL, NULL, 123285),
(123286, '2.60.40.10-FF-004567', NULL, NULL, 102, NULL, NULL, 123286),
(123287, '2.130.10.10-FF-001526', NULL, 'WD domain, G-beta repeat-containing protein', 236, NULL, NULL, 123287),
(123288, '3.40.50.300-FF-003769', NULL, 'ABC transporter, multidrug resistance associated protein', 220, NULL, NULL, 123288),
(123289, '3.30.70.330-FF-001901', NULL, NULL, 79, NULL, NULL, 123289),
(123290, '2.60.40.150-FF-000821', NULL, 'Uncharacterized protein', 53, NULL, NULL, 123290),
(123291, '1.25.40.10-FF-001672', NULL, 'Intraflagellar transport protein IFT88, putative', 72, NULL, NULL, 123291),
(123292, '2.20.28.120-FF-000013', NULL, 'RM33, ribosomal protein 33 mitochondrial large ribosomal subunit', 62, NULL, NULL, 123292),
(123293, '2.60.40.10-FF-005056', NULL, NULL, 101, NULL, NULL, 123293),
(123294, '3.30.200.20-FF-001592', NULL, 'Os11g0485700 protein', 109, NULL, NULL, 123294),
(123295, '1.10.530.10-FF-000063', NULL, 'Lysozyme g', 193, NULL, NULL, 123295),
(123296, '1.10.10.60-FF-000318', NULL, 'homeobox protein notochord', 88, NULL, NULL, 123296),
(123297, '1.10.2000.10-FF-000011', NULL, 'Corin, serine peptidase', 129, NULL, NULL, 123297),
(123298, '1.10.533.10-FF-000305', NULL, 'Retinoic acid-inducible protein Ia', 63, NULL, NULL, 123298),
(123299, '3.60.15.10-FF-000274', NULL, 'DNA repair metallo-beta-lactamase family protein', 59, NULL, NULL, 123299),
(123300, '3.60.21.10-FF-000215', NULL, 'Serine/threonine-protein phosphatase with EF-hands', 333, NULL, NULL, 123300),
(123301, '1.10.287.310-FF-000008', NULL, 'Uncharacterized protein', 77, NULL, NULL, 123301),
(123302, '2.30.30.40-FF-000081', NULL, 'Tight junction protein ZO-2 isoform 2', 129, NULL, NULL, 123302),
(123303, '3.40.50.80-FF-000214', NULL, 'Uncharacterized protein', 101, NULL, NULL, 123303),
(123304, '3.40.50.720-FF-000433', NULL, 'Alanine dehydrogenase 1', 158, NULL, NULL, 123304),
(123305, '3.40.50.1820-FF-000902', NULL, 'S-formylglutathione hydrolase', 83, NULL, NULL, 123305),
(123306, '1.20.1250.20-FF-000491', NULL, 'Major facilitator transporter', 173, NULL, NULL, 123306),
(123307, '1.20.5.990-FF-000003', NULL, 'NF-kappa-B essential modulator isoform X1', 88, NULL, NULL, 123307),
(123308, '3.10.580.10-FF-000081', NULL, 'Chloride channel protein', 144, NULL, NULL, 123308),
(123309, '2.40.40.10-FF-000015', NULL, NULL, 104, NULL, NULL, 123309),
(123310, '1.25.40.990-FF-000027', NULL, 'SAC3/GANP family protein, putative', 240, NULL, NULL, 123310),
(123311, '1.20.1070.10-FF-000917', NULL, 'Uncharacterized protein', 90, NULL, NULL, 123311),
(123312, '3.30.890.10-FF-000021', NULL, 'Bromodomain adjacent to zinc finger domain protein 2A', 120, NULL, NULL, 123312),
(123313, '1.25.10.10-FF-001405', NULL, 'Pumilio homolog 23', 168, NULL, NULL, 123313),
(123314, '1.10.10.60-FF-000498', NULL, 'Transcription factor', 59, NULL, NULL, 123314);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(123315, '2.170.260.10-FF-000017', NULL, 'Ago1p', 115, NULL, NULL, 123315),
(123316, '1.20.1080.10-FF-000070', NULL, 'Water-specific aquaporin', 233, NULL, NULL, 123316),
(123317, '1.20.1740.10-FF-000070', NULL, 'Amino acid transporter (Eurofung)', 462, NULL, NULL, 123317),
(123318, '3.40.50.2300-FF-001024', NULL, NULL, 122, NULL, NULL, 123318),
(123319, '1.20.1250.20-FF-002025', NULL, 'Zgc:63767', 354, NULL, NULL, 123319),
(123320, '1.25.40.10-FF-002189', NULL, 'Pentatricopeptide repeat-containing protein At3g18110, chloroplastic', 73, NULL, NULL, 123320),
(123321, '3.20.20.140-FF-000033', NULL, 'Adenosine deaminase-like protein', 345, NULL, NULL, 123321),
(123322, '3.30.40.10-FF-000789', NULL, 'Os03g0380900 protein', 84, NULL, NULL, 123322),
(123323, '3.90.190.10-FF-000117', NULL, 'Unplaced genomic scaffold supercont1.162, whole genome shotgun sequence', 240, NULL, NULL, 123323),
(123324, '1.10.510.10-FF-001489', NULL, 'Kinase, CAMK CAMKL', 344, NULL, NULL, 123324),
(123325, '2.160.20.10-FF-000323', NULL, 'Uncharacterized protein', 157, NULL, NULL, 123325),
(123326, '1.10.220.30-FF-000028', NULL, 'Flagellar motor switch protein FliG', 138, NULL, NULL, 123326),
(123327, '1.10.150.50-FF-000242', NULL, 'Uncharacterized protein', 58, NULL, NULL, 123327),
(123328, '3.30.420.270-FF-000002', NULL, 'TonB system transport protein ExbD', 70, NULL, NULL, 123328),
(123329, '3.40.50.300-FF-000482', NULL, 'Multidrug resistance-associated protein member 4', 261, NULL, NULL, 123329),
(123330, '3.40.50.1820-FF-001419', NULL, 'Uncharacterized protein', 200, NULL, NULL, 123330),
(123331, '1.20.58.920-FF-000004', NULL, 'Histidine kinase', 138, NULL, NULL, 123331),
(123332, '3.30.160.60-FF-000481', NULL, 'zinc finger protein 236', 31, NULL, NULL, 123332),
(123333, '3.60.10.10-FF-000426', NULL, 'Uncharacterized protein', 103, NULL, NULL, 123333),
(123334, '1.10.472.130-FF-000011', NULL, 'dynein heavy chain 12, axonemal', 160, NULL, NULL, 123334),
(123335, '3.40.30.10-FF-000119', NULL, 'Maleylacetoacetate isomerase', 85, NULL, NULL, 123335),
(123336, '1.20.1640.10-FF-000034', NULL, 'Protein-export membrane protein SecF', 168, NULL, NULL, 123336),
(123337, '3.40.50.300-FF-006350', NULL, 'Uncharacterized protein', 142, NULL, NULL, 123337),
(123338, '3.90.1480.20-FF-000012', NULL, 'ST6 beta-galactoside alpha-2,6-sialyltransferase 1', 318, NULL, NULL, 123338),
(123339, '1.20.1720.10-FF-000035', NULL, 'Bcr/CflA family efflux transporter', 381, NULL, NULL, 123339),
(123340, '3.20.20.370-FF-000017', NULL, 'Lactam utilization protein lamB', 244, NULL, NULL, 123340),
(123341, '1.10.287.20-FF-000005', NULL, 'Cytochrome b-c1 complex subunit 6', 77, NULL, NULL, 123341),
(123342, '1.25.70.10-FF-000072', NULL, NULL, 109, NULL, NULL, 123342),
(123343, '1.10.286.20-FF-000014', NULL, NULL, 43, NULL, NULL, 123343),
(123344, '2.130.10.10-FF-003090', NULL, 'Putative U4/U6 small nuclear ribonucleoprotein', 86, NULL, NULL, 123344),
(123345, '1.10.510.10-FF-003434', NULL, NULL, 285, NULL, NULL, 123345),
(123346, '1.25.40.20-FF-000573', NULL, 'Uncharacterized protein, isoform F', 45, NULL, NULL, 123346),
(123347, '3.30.505.10-FF-000223', NULL, NULL, 98, NULL, NULL, 123347),
(123348, '2.60.40.60-FF-000698', NULL, 'Fat-like cadherin-related tumor suppressor homolog', 103, NULL, NULL, 123348),
(123349, '3.30.565.10-FF-000232', NULL, 'Two-component sensor histidine kinase', 152, NULL, NULL, 123349),
(123350, '1.25.10.10-FF-003322', NULL, 'Uncharacterized protein', 141, NULL, NULL, 123350),
(123351, '3.40.50.300-FF-007131', NULL, 'Uncharacterized protein', 182, NULL, NULL, 123351),
(123352, '2.130.10.10-FF-002954', NULL, 'Uncharacterized protein', 313, NULL, NULL, 123352),
(123353, '2.30.42.10-FF-000138', NULL, 'Uncharacterized protein, isoform C', 110, NULL, NULL, 123353),
(123354, '1.25.40.20-FF-000129', NULL, 'Fibronectin type 3 and ankyrin repeat domains 1 protein', 106, NULL, NULL, 123354),
(123355, '3.90.550.10-FF-000460', NULL, 'Glycosyl transferase family 2', 232, NULL, NULL, 123355),
(123356, '2.60.40.1390-FF-000022', NULL, 'Uncharacterized protein', 92, NULL, NULL, 123356);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(123357, '3.90.1370.10-FF-000001', NULL, 'Outer capsid protein mu-1', 145, NULL, NULL, 123357),
(123358, '2.20.28.200-FF-000003', NULL, 'NAD-dependent protein deacetylase SRT1', 50, NULL, NULL, 123358),
(123359, '3.40.120.10-FF-000017', NULL, 'glucose 1,6-bisphosphate synthase', 131, NULL, NULL, 123359),
(123360, '3.40.190.10-FF-000022', NULL, 'ATP phosphoribosyltransferase', 82, NULL, NULL, 123360),
(123361, '3.30.160.60-FF-000273', NULL, 'Odd-skipped-related transciption factor 2', 22, NULL, NULL, 123361),
(123362, '3.30.50.10-FF-000115', NULL, 'Protein CBG20719', 69, NULL, NULL, 123362),
(123363, '1.25.40.20-FF-000073', NULL, 'Ankyrin repeat domain-containing protein 13C', 105, NULL, NULL, 123363),
(123364, '3.40.50.720-FF-002378', NULL, 'Dehydrogenase orsE', 165, NULL, NULL, 123364),
(123365, '3.20.20.70-FF-000339', NULL, 'Dihydroorotate dehydrogenase family protein', 235, NULL, NULL, 123365),
(123366, '2.60.40.150-FF-000321', NULL, '16 kDa phloem protein 1', 133, NULL, NULL, 123366),
(123367, '1.10.472.80-FF-000083', NULL, 'Oxidant-induced cell-cycle arrest protein 5', 127, NULL, NULL, 123367),
(123368, '3.30.160.60-FF-000329', NULL, 'E3 ubiquitin-protein ligase TRIM9 isoform X2', 77, NULL, NULL, 123368),
(123369, '3.40.190.10-FF-000494', NULL, 'Transcriptional regulator, LysR family', 103, NULL, NULL, 123369),
(123370, '3.90.25.10-FF-000060', NULL, 'UDP-glucose 4-epimerase 4', 69, NULL, NULL, 123370),
(123371, '3.40.50.1820-FF-001599', NULL, 'Methyl esterase 11', 81, NULL, NULL, 123371),
(123372, '1.10.10.10-FF-000944', NULL, 'O-methyltransferase', 89, NULL, NULL, 123372),
(123373, '3.30.470.20-FF-000178', NULL, 'CPSase', 202, NULL, NULL, 123373),
(123374, '2.60.300.12-FF-000005', NULL, 'Fe-S cluster assembly scaffold SufA', 106, NULL, NULL, 123374),
(123375, '2.60.120.200-FF-000137', NULL, 'Multiplexin collagen isoform Ap3', 208, NULL, NULL, 123375),
(123376, '3.80.10.10-FF-001869', NULL, 'Leucine-rich repeat protein kinase family protein', 142, NULL, NULL, 123376),
(123377, '3.30.160.60-FF-003499', NULL, 'Protein suppressor of hairy wing', 24, NULL, NULL, 123377),
(123378, '3.60.10.10-FF-000370', NULL, 'Uncharacterized protein', 111, NULL, NULL, 123378),
(123379, '2.60.40.10-FF-001841', NULL, 'Neuromusculin, isoform H', 104, NULL, NULL, 123379),
(123380, '3.30.200.20-FF-000456', NULL, 'Myosin IIIA', 98, NULL, NULL, 123380),
(123381, '3.40.630.10-FF-000039', NULL, 'Peptidase M20 domain-containing protein 2', 226, NULL, NULL, 123381),
(123382, '3.20.20.190-FF-000115', NULL, NULL, 209, NULL, NULL, 123382),
(123383, '1.10.10.1940-FF-000013', NULL, NULL, 47, NULL, NULL, 123383),
(123384, '1.10.287.70-FF-000470', NULL, 'Uncharacterized protein', 70, NULL, NULL, 123384),
(123385, '1.25.40.10-FF-004398', NULL, 'Uncharacterized protein', 138, NULL, NULL, 123385),
(123386, '3.40.1110.10-FF-000359', NULL, NULL, 85, NULL, NULL, 123386),
(123387, '3.40.50.300-FF-005894', NULL, 'GTPase HflX', 167, NULL, NULL, 123387),
(123388, '2.60.40.60-FF-000226', NULL, 'Dachsous, isoform B', 108, NULL, NULL, 123388),
(123389, '1.20.120.1760-FF-000032', NULL, 'Choline/ethanolamine phosphotransferase, putative', 183, NULL, NULL, 123389),
(123390, '1.25.40.10-FF-002689', NULL, 'YALI0C01397p', 149, NULL, NULL, 123390),
(123391, '3.40.30.10-FF-000771', NULL, 'Peroxiredoxin domain protein', 164, NULL, NULL, 123391),
(123392, '3.30.1230.20-FF-000002', NULL, '40S ribosomal protein S21', 81, NULL, NULL, 123392),
(123393, '3.10.100.10-FF-000433', NULL, NULL, 74, NULL, NULL, 123393),
(123394, '2.130.10.10-FF-001965', NULL, 'Raptor_N-terminal_CASPase_like_domain_containing_protein_-_putative', 257, NULL, NULL, 123394),
(123395, '1.10.418.20-FF-000030', NULL, 'Ubiquitin-like-specific protease 2', 113, NULL, NULL, 123395),
(123396, '2.40.128.20-FF-000002', NULL, 'Outer membrane lipoprotein Blc', 168, NULL, NULL, 123396),
(123397, '3.60.40.10-FF-000254', NULL, 'Uncharacterized protein', 146, NULL, NULL, 123397),
(123398, '2.60.40.420-FF-000245', NULL, 'Spore coat protein', 219, NULL, NULL, 123398),
(123399, '1.25.10.10-FF-002333', NULL, 'Uncharacterized protein', 297, NULL, NULL, 123399);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(123400, '1.10.3210.10-FF-000111', NULL, 'Uncharacterized protein', 188, NULL, NULL, 123400),
(123401, '1.20.58.60-FF-000624', NULL, 'Microtubule-actin crosslinking factor 1', 118, NULL, NULL, 123401),
(123402, '1.25.10.10-FF-001613', NULL, 'Uncharacterized protein', 445, NULL, NULL, 123402),
(123403, '1.20.1560.10-FF-000764', NULL, 'Putative multidrug resistance-associated protein lethal(2)03659-like Protein', 323, NULL, NULL, 123403),
(123404, '2.30.29.30-FF-001316', NULL, 'Predicted protein', 70, NULL, NULL, 123404),
(123405, '3.40.50.360-FF-000162', NULL, 'NADPH-cytochrome P450 reductase', 170, NULL, NULL, 123405),
(123406, '1.10.3720.10-FF-000133', NULL, 'Iron ABC transporter permease', 256, NULL, NULL, 123406),
(123407, '3.30.30.30-FF-000007', NULL, 'Heat shock 70 kDa protein 13', 54, NULL, NULL, 123407),
(123408, '1.10.1040.10-FF-000075', NULL, '2-dehydropantoate 2-reductase', 125, NULL, NULL, 123408),
(123409, '3.30.710.10-FF-000418', NULL, 'BTB/POZ domain-containing protein 1', 125, NULL, NULL, 123409),
(123410, '2.60.98.20-FF-000010', NULL, 'Flagellar hook protein FlgE', 192, NULL, NULL, 123410),
(123411, '3.40.710.10-FF-000192', NULL, 'Penicillin-binding protein', 347, NULL, NULL, 123411),
(123412, '6.10.250.3340-FF-000001', NULL, NULL, 26, NULL, NULL, 123412),
(123413, '2.60.40.10-FF-002830', NULL, 'Uncharacterized protein', 87, NULL, NULL, 123413),
(123414, '1.10.510.10-FF-002506', NULL, 'Uncharacterized protein', 324, NULL, NULL, 123414),
(123415, '3.30.450.200-FF-000015', NULL, 'Predicted protein', 78, NULL, NULL, 123415),
(123416, '2.60.40.10-FF-003550', NULL, NULL, 118, NULL, NULL, 123416),
(123417, '3.40.50.300-FF-008120', NULL, 'Uncharacterized protein', 106, NULL, NULL, 123417),
(123418, '3.40.50.720-FF-000725', NULL, '2-ketogluconate reductase', 104, NULL, NULL, 123418),
(123419, '3.40.50.1470-FF-000016', NULL, 'Uncharacterized protein', 160, NULL, NULL, 123419),
(123420, '3.40.50.150-FF-000184', NULL, 'Protein-lysine N-methyltransferase Os01g0121100', 212, NULL, NULL, 123420),
(123421, '1.10.510.10-FF-003934', NULL, NULL, 68, NULL, NULL, 123421),
(123422, '2.130.10.10-FF-004399', NULL, 'Pre-mRNA-processing factor 19 homolog 2', 57, NULL, NULL, 123422),
(123423, '3.10.20.70-FF-000008', NULL, 'Gamma-glutamylputrescine synthetase PuuA', 99, NULL, NULL, 123423),
(123424, '3.30.40.10-FF-000997', NULL, 'Male-specific lethal 2', 117, NULL, NULL, 123424),
(123425, '1.25.40.10-FF-003206', NULL, 'Uncharacterized protein', 84, NULL, NULL, 123425),
(123426, '3.30.830.10-FF-000220', NULL, 'Uncharacterized protein', 231, NULL, NULL, 123426),
(123427, '3.40.190.80-FF-000031', NULL, 'Inositol-monophosphatase ImpA', 121, NULL, NULL, 123427),
(123428, '3.10.20.90-FF-000874', NULL, 'Ubiquitin-like protein ATG12', 65, NULL, NULL, 123428),
(123429, '2.130.10.110-FF-000022', NULL, 'Clathrin heavy chain, putative', 194, NULL, NULL, 123429),
(123430, '1.10.8.620-FF-000001', NULL, 'Beta-lactamase', 53, NULL, NULL, 123430),
(123431, '3.40.50.1450-FF-000010', NULL, 'Methyl viologen-reducing hydrogenase maturation protease', 153, NULL, NULL, 123431),
(123432, '3.30.470.30-FF-000068', NULL, 'DNA ligase', 259, NULL, NULL, 123432),
(123433, '3.60.10.10-FF-000218', NULL, 'Uncharacterized protein', 276, NULL, NULL, 123433),
(123434, '3.40.50.150-FF-001526', NULL, NULL, 103, NULL, NULL, 123434),
(123435, '3.40.50.300-FF-007659', NULL, 'PDR12 (PLEIOTROPIC DRUG RESISTANCE 12)', 129, NULL, NULL, 123435),
(123436, '3.40.50.1580-FF-000021', NULL, 'MTA/SAH nucleosidase, putative', 233, NULL, NULL, 123436),
(123437, '3.40.50.1460-FF-000070', NULL, 'cell death protein 3-like isoform X1', 166, NULL, NULL, 123437),
(123438, '3.30.70.330-FF-002149', NULL, NULL, 68, NULL, NULL, 123438),
(123439, '1.10.506.10-FF-000102', NULL, 'Neurofibromin-A', 313, NULL, NULL, 123439),
(123440, '2.115.10.20-FF-000025', NULL, 'Uncharacterized protein', 97, NULL, NULL, 123440),
(123441, '3.40.470.10-FF-000004', NULL, 'Uracil-DNA glycosylase', 235, NULL, NULL, 123441),
(123442, '1.10.730.10-FF-000011', NULL, 'Leucine--tRNA ligase chloroplastic/mitochondrial', 261, NULL, NULL, 123442);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(123443, '1.20.1070.10-FF-000097', NULL, 'olfactory receptor 2A12-like', 291, NULL, NULL, 123443),
(123444, '1.10.10.60-FF-000998', NULL, NULL, 55, NULL, NULL, 123444),
(123445, '3.30.160.60-FF-002307', NULL, NULL, 28, NULL, NULL, 123445),
(123446, '1.10.1200.10-FF-000077', NULL, 'Non-ribosomal peptide synthetase', 89, NULL, NULL, 123446),
(123447, '3.30.160.60-FF-005652', NULL, NULL, 37, NULL, NULL, 123447),
(123448, '3.30.160.60-FF-004224', NULL, NULL, 31, NULL, NULL, 123448),
(123449, '1.25.40.10-FF-002953', NULL, 'Uncharacterized protein', 107, NULL, NULL, 123449),
(123450, '1.20.1070.10-FF-001878', NULL, 'Uncharacterized protein', 372, NULL, NULL, 123450),
(123451, '1.20.1270.50-FF-000006', NULL, 'Alpha-mannosidase mngB', 96, NULL, NULL, 123451),
(123452, '2.102.10.10-FF-000016', NULL, 'Nitrite reductase/ring-hydroxylating ferredoxin subunit', 106, NULL, NULL, 123452),
(123453, '2.60.40.150-FF-000057', NULL, 'active breakpoint cluster region-related protein isoform X1', 143, NULL, NULL, 123453),
(123454, '3.40.50.720-FF-001130', NULL, 'Possible dehydrogenase', 78, NULL, NULL, 123454),
(123455, '3.30.160.60-FF-005444', NULL, NULL, 40, NULL, NULL, 123455),
(123456, '3.10.20.360-FF-000005', NULL, NULL, 86, NULL, NULL, 123456),
(123457, '2.60.40.10-FF-002122', NULL, 'High Incidence of Males (Increased X chromosome loss)', 95, NULL, NULL, 123457),
(123458, '3.10.20.90-FF-000166', NULL, 'serine/threonine-protein kinase WNK3 isoform X1', 91, NULL, NULL, 123458),
(123459, '2.70.130.10-FF-000077', NULL, NULL, 128, NULL, NULL, 123459),
(123460, '3.40.1440.10-FF-000024', NULL, NULL, 87, NULL, NULL, 123460),
(123461, '1.20.58.60-FF-000271', NULL, 'Spectrin repeat containing nuclear envelope protein 2', 179, NULL, NULL, 123461),
(123462, '4.10.40.10-FF-000001', NULL, 'Omega-agatoxin-Aa4a', 48, NULL, NULL, 123462),
(123463, '3.30.1410.10-FF-000002', NULL, 'GCHFR, GFRP: GTP cyclohydrolase 1 feedback regulatory protein, putative', 81, NULL, NULL, 123463),
(123464, '2.130.10.10-FF-002746', NULL, 'Os09g0477800 protein', 270, NULL, NULL, 123464),
(123465, '3.30.420.40-FF-000894', NULL, 'Acetate kinase', 197, NULL, NULL, 123465),
(123466, '3.40.50.720-FF-001714', NULL, 'Glyoxylate reductase/hydroxypyruvate reductase', 133, NULL, NULL, 123466),
(123467, '1.10.3090.10-FF-000022', NULL, 'Uncharacterized protein', 226, NULL, NULL, 123467),
(123468, '3.30.70.330-FF-003138', NULL, NULL, 92, NULL, NULL, 123468),
(123469, '1.25.40.20-FF-000281', NULL, 'Oxysterol binding protein (Osh1)', 136, NULL, NULL, 123469),
(123470, '3.40.50.410-FF-000104', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 220, NULL, NULL, 123470),
(123471, '2.60.40.10-FF-003286', NULL, NULL, 96, NULL, NULL, 123471),
(123472, '2.60.200.20-FF-000015', NULL, 'E3 ubiquitin-protein ligase RNF8', 131, NULL, NULL, 123472),
(123473, '3.40.190.10-FF-000230', NULL, 'Prephenate dehydratase', 85, NULL, NULL, 123473),
(123474, '1.20.1310.10-FF-000133', NULL, NULL, 117, NULL, NULL, 123474),
(123475, '3.40.1190.20-FF-000108', NULL, 'PfkB domain protein', 226, NULL, NULL, 123475),
(123476, '3.40.50.1440-FF-000120', NULL, 'Tubulin alpha chain', 132, NULL, NULL, 123476),
(123477, '1.10.287.660-FF-000034', NULL, 'Uncharacterized protein', 75, NULL, NULL, 123477),
(123478, '1.10.1670.10-FF-000049', NULL, NULL, 89, NULL, NULL, 123478),
(123479, '1.10.600.10-FF-000119', NULL, 'Uncharacterized protein', 164, NULL, NULL, 123479),
(123480, '1.10.10.10-FF-001664', NULL, 'Predicted protein', 63, NULL, NULL, 123480),
(123481, '3.80.10.10-FF-001252', NULL, 'Fish-lips, isoform C', 144, NULL, NULL, 123481),
(123482, '3.40.50.300-FF-000835', NULL, 'DNA replication licensing factor MCM7', 333, NULL, NULL, 123482),
(123483, '3.20.20.10-FF-000075', NULL, 'Ornithine decarboxylase 1', 69, NULL, NULL, 123483),
(123484, '1.10.287.70-FF-000559', NULL, 'Cyclic nucleotide-gated cation channel', 69, NULL, NULL, 123484),
(123485, '3.40.30.10-FF-000063', NULL, '2-Cys peroxiredoxin BAS1, chloroplastic', 200, NULL, NULL, 123485),
(123486, '1.25.40.10-FF-001441', NULL, 'Putative TPR repeat family protein', 226, NULL, NULL, 123486);
INSERT INTO "PUBLIC"."MODEL" VALUES
(123487, '3.40.50.300-FF-005186', NULL, 'Shikimate kinase', 216, NULL, NULL, 123487),
(123488, '1.20.1270.10-FF-000045', NULL, 'Heat shock protein, putative', 75, NULL, NULL, 123488),
(123489, '2.120.10.80-FF-000238', NULL, 'Peptidase S8 and S53 subtilisin kexin sedolisin', 196, NULL, NULL, 123489),
(123490, '1.20.1730.10-FF-000125', NULL, 'Uncharacterized protein', 149, NULL, NULL, 123490),
(123491, '2.60.40.10-FF-004275', NULL, NULL, 106, NULL, NULL, 123491),
(123492, '1.20.1530.20-FF-000001', NULL, 'Glutathione-regulated potassium-efflux system protein KefB', 383, NULL, NULL, 123492),
(123493, '3.40.640.10-FF-000276', NULL, '40S ribosomal protein S4-3', 100, NULL, NULL, 123493),
(123494, '2.130.10.10-FF-000537', NULL, 'Ribosome biogenesis protein ENP2', 337, NULL, NULL, 123494),
(123495, '3.50.50.60-FF-001315', NULL, 'Glutathione reductase', 80, NULL, NULL, 123495),
(123496, '3.40.50.1240-FF-000032', NULL, 'Blast:Protein UBASH3A homolog', 258, NULL, NULL, 123496),
(123497, '1.20.1070.10-FF-001053', NULL, 'Uncharacterized protein', 197, NULL, NULL, 123497),
(123498, '3.30.70.330-FF-000912', NULL, 'Probable RNA-binding protein ARP1', 84, NULL, NULL, 123498),
(123499, '3.40.720.10-FF-000277', NULL, 'Predicted protein', 330, NULL, NULL, 123499),
(123500, '3.60.130.10-FF-000064', NULL, 'Uncharacterized protein', 247, NULL, NULL, 123500),
(123501, '3.30.710.10-FF-000273', NULL, 'Hypermethylated in cancer 1-like', 147, NULL, NULL, 123501),
(123502, '3.30.40.10-FF-001514', NULL, 'Zinc finger domain containing protein', 111, NULL, NULL, 123502),
(123503, '2.60.40.60-FF-000434', NULL, 'Cadherin-4', 107, NULL, NULL, 123503),
(123504, '1.20.1070.10-FF-001261', NULL, 'Uncharacterized protein', 272, NULL, NULL, 123504),
(123505, '1.10.10.60-FF-000526', NULL, 'Transcriptional regulator, TetR family', 64, NULL, NULL, 123505),
(123506, '2.60.40.790-FF-000193', NULL, NULL, 89, NULL, NULL, 123506),
(123507, '2.60.40.10-FF-000413', NULL, 'Down syndrome cell adhesion molecule, isoform F', 92, NULL, NULL, 123507),
(123508, '3.30.342.10-FF-000035', NULL, 'DNA polymerase epsilon catalytic subunit', 180, NULL, NULL, 123508),
(123509, '3.30.160.60-FF-003819', NULL, NULL, 32, NULL, NULL, 123509),
(123510, '3.10.400.10-FF-000006', NULL, 'Sulfate adenylyltransferase', 185, NULL, NULL, 123510),
(123511, '2.10.70.10-FF-000086', NULL, 'Hig-anchoring scaffold protein, isoform A', 64, NULL, NULL, 123511),
(123512, '2.60.120.20-FF-000014', NULL, 'Structural polyprotein', 286, NULL, NULL, 123512),
(123513, '1.10.1070.11-FF-000089', NULL, 'Uncharacterized protein', 92, NULL, NULL, 123513),
(123514, '1.10.238.10-FF-000400', NULL, 'EF hand family protein', 146, NULL, NULL, 123514),
(123515, '3.40.50.11540-FF-000001', NULL, 'NADH dehydrogenase [ubiquinone] flavoprotein 1, mitochondrial', 180, NULL, NULL, 123515),
(123516, '3.30.70.330-FF-003077', NULL, NULL, 97, NULL, NULL, 123516),
(123517, '2.30.40.10-FF-000095', NULL, 'Guanine deaminase', 148, NULL, NULL, 123517),
(123518, '3.40.50.10330-FF-000032', NULL, 'NADH kinase pos5, mitochondrial', 40, NULL, NULL, 123518),
(123519, '1.10.287.470-FF-000011', NULL, 'Efflux transporter, RND family, MFP subunit', 74, NULL, NULL, 123519),
(123520, '1.10.620.20-FF-000039', NULL, 'Uncharacterized protein', 103, NULL, NULL, 123520),
(123521, '3.40.50.300-FF-000251', NULL, 'ABC transporter B family member 19', 249, NULL, NULL, 123521),
(123522, '3.30.70.1590-FF-000004', NULL, 'unconventional myosin-XVIIIa isoform X1', 74, NULL, NULL, 123522),
(123523, '3.40.1360.10-FF-000023', NULL, 'DNA topoisomerase, putative', 141, NULL, NULL, 123523),
(123524, '1.10.510.10-FF-003726', NULL, NULL, 152, NULL, NULL, 123524),
(123525, '3.90.1450.10-FF-000002', NULL, 'Guanylate cyclase activator 2A', 90, NULL, NULL, 123525),
(123526, '3.40.50.2300-FF-001255', NULL, NULL, 96, NULL, NULL, 123526),
(123527, '2.60.40.10-FF-002622', NULL, 'Immunoglobulin light 3 variable 2', 108, NULL, NULL, 123527),
(123528, '3.60.160.10-FF-000004', NULL, 'Altered inheritance of mitochondria protein 24, mitochondrial', 238, NULL, NULL, 123528);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(123529, '2.40.30.10-FF-000189', NULL, 'Cytochrome C', 123, NULL, NULL, 123529),
(123530, '2.30.280.10-FF-000001', NULL, 'E3 ubiquitin-protein ligase UHRF1 isoform 1', 211, NULL, NULL, 123530),
(123531, '2.60.40.10-FF-005348', NULL, NULL, 69, NULL, NULL, 123531),
(123532, '3.90.1150.180-FF-000001', NULL, 'L-seryl-tRNA(Sec) selenium transferase', 108, NULL, NULL, 123532),
(123533, '3.30.200.20-FF-000809', NULL, 'Ser/Thr Kinase', 127, NULL, NULL, 123533),
(123534, '2.60.40.1730-FF-000023', NULL, 'Aminopeptidase', 203, NULL, NULL, 123534),
(123535, '3.30.1330.30-FF-000007', NULL, '23S rRNA methyltransferase', 76, NULL, NULL, 123535),
(123536, '3.40.50.10490-FF-000147', NULL, NULL, 180, NULL, NULL, 123536),
(123537, '3.30.160.60-FF-003235', NULL, 'Blast:Transcription factor grauzone', 66, NULL, NULL, 123537),
(123538, '3.30.1330.10-FF-000001', NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase', 165, NULL, NULL, 123538),
(123539, '2.60.120.10-FF-000157', NULL, 'Crp/Fnr family transcriptional regulator', 116, NULL, NULL, 123539),
(123540, '3.40.1280.30-FF-000028', NULL, 'tRNA methyltransferase 10 homolog C', 157, NULL, NULL, 123540),
(123541, '3.40.50.150-FF-001318', NULL, NULL, 207, NULL, NULL, 123541),
(123542, '1.20.1270.280-FF-000009', NULL, 'Dynein, axonemal, heavy chain 6', 171, NULL, NULL, 123542),
(123543, '1.20.58.1610-FF-000024', NULL, NULL, 107, NULL, NULL, 123543),
(123544, '3.40.1010.10-FF-000003', NULL, 'Putative Uroporphyrinogen-III C-methyltransferase', 128, NULL, NULL, 123544),
(123545, '1.10.10.10-FF-001080', NULL, 'S-adenosyl-L-methionine-dependent methyltransferase', 86, NULL, NULL, 123545),
(123546, '1.10.510.10-FF-001517', NULL, 'Protein kinase domain containing protein expressed', 209, NULL, NULL, 123546),
(123547, '3.90.190.10-FF-000089', NULL, 'Cyclin dependent kinase inhibitor 3', 122, NULL, NULL, 123547),
(123548, '2.160.20.10-FF-000295', NULL, 'Uncharacterized protein', 168, NULL, NULL, 123548),
(123549, '3.40.367.20-FF-000042', NULL, 'Uncharacterized protein', 244, NULL, NULL, 123549),
(123550, '1.20.1250.20-FF-001480', NULL, 'Solute carrier family 22 member 7b, tandem duplicate 2', 230, NULL, NULL, 123550),
(123551, '3.20.20.105-FF-000027', NULL, 'Uncharacterized protein', 184, NULL, NULL, 123551),
(123552, '3.30.160.60-FF-004724', NULL, NULL, 70, NULL, NULL, 123552),
(123553, '3.30.70.100-FF-000017', NULL, 'Protein NipSnap homolog 3A', 108, NULL, NULL, 123553),
(123554, '1.20.1070.10-FF-001614', NULL, 'Uncharacterized protein', 147, NULL, NULL, 123554),
(123555, '3.30.710.10-FF-000065', NULL, 'zinc finger and BTB domain-containing protein 21', 136, NULL, NULL, 123555),
(123556, '3.30.450.40-FF-000250', NULL, 'Uncharacterized protein', 74, NULL, NULL, 123556),
(123557, '1.20.80.10-FF-000077', NULL, 'Myosin-I heavy chain', 101, NULL, NULL, 123557),
(123558, '3.30.300.30-FF-000146', NULL, 'Uncharacterized protein', 95, NULL, NULL, 123558),
(123559, '1.10.510.10-FF-004131', NULL, NULL, 88, NULL, NULL, 123559),
(123560, '2.40.50.40-FF-000087', NULL, 'Chemokine (C-C motif) ligand 34b, duplicate 4', 72, NULL, NULL, 123560),
(123561, '1.10.10.160-FF-000018', NULL, 'DNA helicase', 76, NULL, NULL, 123561),
(123562, '3.40.720.10-FF-000338', NULL, 'Uncharacterized protein', 107, NULL, NULL, 123562),
(123563, '1.20.1060.20-FF-000009', NULL, 'Chromosome partition protein Smc', 97, NULL, NULL, 123563),
(123564, '1.10.890.20-FF-000002', NULL, 'Chalcone-flavonone isomerase family protein', 46, NULL, NULL, 123564),
(123565, '3.30.9.10-FF-000172', NULL, 'N-methyl-L-tryptophan oxidase', 205, NULL, NULL, 123565),
(123566, '3.10.20.90-FF-000374', NULL, 'Motor AXon guidance', 97, NULL, NULL, 123566),
(123567, '3.80.10.10-FF-001044', NULL, 'F-box protein isoform A', 302, NULL, NULL, 123567),
(123568, '3.40.718.10-FF-000069', NULL, 'Isocitrate dehydrogenase [NADP]', 180, NULL, NULL, 123568),
(123569, '3.40.630.10-FF-000511', NULL, 'Uncharacterized protein', 174, NULL, NULL, 123569),
(123570, '1.25.40.10-FF-000536', NULL, 'Regulator of microtubule dynamics protein 2', 124, NULL, NULL, 123570);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(123571, '3.30.9.10-FF-000025', NULL, 'Oxidoreductase, FAD dependent', 143, NULL, NULL, 123571),
(123572, '3.40.1090.10-FF-000098', NULL, 'Phospholipase A2', 374, NULL, NULL, 123572),
(123573, '1.10.418.80-FF-000002', NULL, 'Ubiquitin C-terminal hydrolase L3', 95, NULL, NULL, 123573),
(123574, '1.10.150.120-FF-000025', NULL, NULL, 61, NULL, NULL, 123574),
(123575, '1.25.10.10-FF-001260', NULL, 'Serine/threonine-protein kinase TOR', 126, NULL, NULL, 123575),
(123576, '3.80.10.10-FF-002325', NULL, 'Leucine-rich repeat protein (LRRP), putative', 128, NULL, NULL, 123576),
(123577, '2.130.10.10-FF-003151', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', 302, NULL, NULL, 123577),
(123578, '1.50.40.10-FF-000591', NULL, 'Uncharacterized protein', 246, NULL, NULL, 123578),
(123579, '3.30.450.30-FF-000005', NULL, 'Ragulator complex protein LAMTOR5 homolog', 91, NULL, NULL, 123579),
(123580, '3.10.120.10-FF-000024', NULL, 'L-lactate dehydrogenase (Cytochrome), putative', 93, NULL, NULL, 123580),
(123581, '1.10.238.10-FF-000900', NULL, 'Uncharacterized protein', 200, NULL, NULL, 123581),
(123582, '2.60.120.330-FF-000087', NULL, 'OSJNBa0073E02.10 protein', 128, NULL, NULL, 123582),
(123583, '2.40.10.10-FF-000126', NULL, 'TISP43 isoform 4', 38, NULL, NULL, 123583),
(123584, '3.40.640.10-FF-000484', NULL, 'Uncharacterized protein', 61, NULL, NULL, 123584),
(123585, '3.40.50.970-FF-000103', NULL, '2-succinyl-5-enolpyruvyl-6-hydroxy-3-cyclohexene-1-carboxylate synthase', 205, NULL, NULL, 123585),
(123586, '1.10.287.380-FF-000017', NULL, 'Holdfast attachment protein C', 81, NULL, NULL, 123586),
(123587, '3.40.50.2000-FF-000827', NULL, 'Uncharacterized protein', 161, NULL, NULL, 123587),
(123588, '3.40.50.620-FF-000493', NULL, 'Probable electron transfer flavoprotein alpha subunit', 166, NULL, NULL, 123588),
(123589, '3.40.50.10190-FF-000063', NULL, 'Pebble, isoform B', 86, NULL, NULL, 123589),
(123590, '1.10.287.130-FF-000050', NULL, 'Related to histidine kinase', 78, NULL, NULL, 123590),
(123591, '2.70.170.10-FF-000231', NULL, 'Predicted protein', 80, NULL, NULL, 123591),
(123592, '1.20.58.60-FF-000832', NULL, 'Uncharacterized protein', 164, NULL, NULL, 123592),
(123593, '3.40.50.1010-FF-000165', NULL, NULL, 222, NULL, NULL, 123593),
(123594, '1.10.1200.10-FF-000110', NULL, 'Acyl carrier protein', 95, NULL, NULL, 123594),
(123595, '2.60.40.10-FF-004067', NULL, NULL, 96, NULL, NULL, 123595),
(123596, '3.40.50.80-FF-000186', NULL, 'Uncharacterized protein', 170, NULL, NULL, 123596),
(123597, '3.40.50.2300-FF-000327', NULL, 'Guanylate cyclase', 176, NULL, NULL, 123597),
(123598, '3.60.40.10-FF-000046', NULL, 'Probable protein phosphatase 2C 9', 304, NULL, NULL, 123598),
(123599, '3.30.70.330-FF-002621', NULL, NULL, 128, NULL, NULL, 123599),
(123600, '3.10.129.110-FF-000008', NULL, 'Phenolpthiocerol synthesis type-I polyketide synthase ppsA', 278, NULL, NULL, 123600),
(123601, '3.90.660.10-FF-000081', NULL, NULL, 91, NULL, NULL, 123601),
(123602, '2.130.10.10-FF-002246', NULL, 'Autophagy-related protein 18', 240, NULL, NULL, 123602),
(123603, '2.30.40.10-FF-000156', NULL, 'Amidohydrolase', 68, NULL, NULL, 123603),
(123604, '3.40.50.720-FF-000225', NULL, 'Dihydrofolate reductase FolM', 232, NULL, NULL, 123604),
(123605, '3.30.200.20-FF-001384', NULL, 'Mitogen-activated protein kinase', 12, NULL, NULL, 123605),
(123606, '3.30.40.10-FF-001306', NULL, 'Uncharacterized protein', 114, NULL, NULL, 123606),
(123607, '2.10.220.10-FF-000215', NULL, 'Erb-b2 receptor tyrosine kinase 3a', 50, NULL, NULL, 123607),
(123608, '3.40.30.10-FF-000563', NULL, 'Thiol-dependent reductase 1', 85, NULL, NULL, 123608),
(123609, '3.90.70.80-FF-000016', NULL, 'Putative ubiquitin thioesterase otu1', 179, NULL, NULL, 123609),
(123610, '4.10.400.10-FF-000115', NULL, 'integral membrane protein DGCR2/IDD isoform X1', 43, NULL, NULL, 123610),
(123611, '3.10.250.10-FF-000028', NULL, 'T-cell surface glycoprotein CD5', 100, NULL, NULL, 123611),
(123612, '3.40.30.10-FF-000619', NULL, 'Protein disulfide isomerase family A member 2', 128, NULL, NULL, 123612);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(123613, '1.50.40.10-FF-000444', NULL, 'Uncharacterized protein', 148, NULL, NULL, 123613),
(123614, '3.90.1150.10-FF-000193', NULL, '8-amino-7-oxononanoate synthase', 102, NULL, NULL, 123614),
(123615, '2.60.120.10-FF-000365', NULL, 'cAMP-dependent protein kinase regulatory chain', 125, NULL, NULL, 123615),
(123616, '2.10.25.10-FF-001768', NULL, 'Brevican', 35, NULL, NULL, 123616),
(123617, '4.10.240.10-FF-000113', NULL, 'C6 finger domain protein, putative', 84, NULL, NULL, 123617),
(123618, '3.40.140.10-FF-000283', NULL, 'Uncharacterized protein', 101, NULL, NULL, 123618),
(123619, '3.40.50.300-FF-005394', NULL, 'ABC transporter G family member 16', 251, NULL, NULL, 123619),
(123620, '1.10.630.10-FF-000155', NULL, 'Uncharacterized protein', 481, NULL, NULL, 123620),
(123621, '1.10.287.550-FF-000001', NULL, 'Arylsulfatase E', 59, NULL, NULL, 123621),
(123622, '3.30.160.60-FF-000981', NULL, 'ras-responsive element-binding protein 1 isoform X1', 27, NULL, NULL, 123622),
(123623, '3.10.580.10-FF-000137', NULL, 'Chloride channel protein', 72, NULL, NULL, 123623),
(123624, '2.40.40.20-FF-000052', NULL, 'Transitional endoplasmic reticulum ATPase', 96, NULL, NULL, 123624),
(123625, '3.40.190.10-FF-000847', NULL, 'Polar amino acid uptake family ABC transporter, periplasmic substrate-binding protein, putative', 96, NULL, NULL, 123625),
(123626, '1.10.287.370-FF-000071', NULL, 'Prefoldin subunit 3', 145, NULL, NULL, 123626),
(123627, '3.30.70.330-FF-001429', NULL, 'Polyadenylate-binding protein 2', 169, NULL, NULL, 123627),
(123628, '3.30.43.10-FF-000003', NULL, 'Alkylglycerone-phosphate synthase', 113, NULL, NULL, 123628),
(123629, '3.50.50.60-FF-000798', NULL, 'FAD/NAD(P)-binding oxidoreductase family protein', 131, NULL, NULL, 123629),
(123630, '2.30.30.100-FF-000154', NULL, 'U6 snRNA-associated Sm-like protein LSm3', 83, NULL, NULL, 123630),
(123631, '1.25.40.1040-FF-000039', NULL, 'Uncharacterized protein', 458, NULL, NULL, 123631),
(123632, '1.10.238.10-FF-001064', NULL, 'Uncharacterized protein', 79, NULL, NULL, 123632),
(123633, '2.80.10.50-FF-000147', NULL, 'Botulinum neurotoxin type C', 191, NULL, NULL, 123633),
(123634, '3.30.70.3250-FF-000002', NULL, 'ribonuclease P protein subunit p14', 104, NULL, NULL, 123634),
(123635, '2.60.40.10-FF-005556', NULL, NULL, 114, NULL, NULL, 123635),
(123636, '3.30.160.60-FF-006169', NULL, NULL, 72, NULL, NULL, 123636),
(123637, '3.90.380.10-FF-000008', NULL, 'Aromatic ring-hydroxylating dioxygenase subunit alpha', 190, NULL, NULL, 123637),
(123638, '2.10.25.10-FF-000279', NULL, 'Neurogenic locus notch 1', 38, NULL, NULL, 123638),
(123639, '3.40.630.30-FF-000517', NULL, 'Histone acetyltransferase', 77, NULL, NULL, 123639),
(123640, '3.30.420.40-FF-000686', NULL, 'N-acetylmuramic acid/N-acetylglucosamine kinase', 122, NULL, NULL, 123640),
(123641, '3.90.190.10-FF-000589', NULL, 'Si:ch1073-391i24.1', 72, NULL, NULL, 123641),
(123642, '3.10.100.10-FF-000169', NULL, NULL, 128, NULL, NULL, 123642),
(123643, '3.40.50.2300-FF-001608', NULL, NULL, 62, NULL, NULL, 123643),
(123644, '1.10.287.570-FF-000007', NULL, 'Borate transporter', 42, NULL, NULL, 123644),
(123645, '1.10.1520.10-FF-000005', NULL, 'Putative endoribonuclease dicer', 197, NULL, NULL, 123645),
(123646, '3.40.33.10-FF-000013', NULL, 'SCP-Like extracellular protein', 197, NULL, NULL, 123646),
(123647, '3.40.50.300-FF-001499', NULL, 'Origin recognition complex subunit 4, putative', 191, NULL, NULL, 123647),
(123648, '1.20.1420.10-FF-000023', NULL, 'Talin', 155, NULL, NULL, 123648),
(123649, '3.80.10.10-FF-002797', NULL, 'Predicted protein', 164, NULL, NULL, 123649),
(123650, '1.10.510.10-FF-000500', NULL, 'serine/threonine-protein kinase SBK1', 348, NULL, NULL, 123650),
(123651, '3.30.40.10-FF-001778', NULL, 'Uncharacterized protein', 93, NULL, NULL, 123651),
(123652, '1.25.40.20-FF-000781', NULL, 'Uncharacterized protein', 152, NULL, NULL, 123652),
(123653, '2.30.30.40-FF-000226', NULL, 'Chemotaxis protein CheV', 49, NULL, NULL, 123653),
(123654, '1.20.1420.30-FF-000029', NULL, 'Calcium/proton exchanger', 125, NULL, NULL, 123654);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(123655, '1.10.510.10-FF-003226', NULL, NULL, 129, NULL, NULL, 123655),
(123656, '1.25.40.570-FF-000053', NULL, 'Uncharacterized protein', 330, NULL, NULL, 123656),
(123657, '1.20.1270.10-FF-000106', NULL, 'Uncharacterized protein', 118, NULL, NULL, 123657),
(123658, '1.20.120.340-FF-000009', NULL, 'Perilipin', 43, NULL, NULL, 123658),
(123659, '1.20.58.760-FF-000052', NULL, 'Uncharacterized protein', 169, NULL, NULL, 123659),
(123660, '3.30.70.3270-FF-000008', NULL, 'NADH-quinone oxidoreductase subunit I', 121, NULL, NULL, 123660),
(123661, '3.40.250.10-FF-000173', NULL, 'Rhodanese homology domain superfamily protein', 116, NULL, NULL, 123661),
(123662, '1.10.1440.10-FF-000004', NULL, 'Plant Late Embryo Abundant (LEA) related', 65, NULL, NULL, 123662),
(123663, '3.40.50.10900-FF-000017', NULL, 'Proteasome assembly chaperone 2', 221, NULL, NULL, 123663),
(123664, '3.90.550.10-FF-000252', NULL, 'Protein O-linked-mannose beta-1,2-N-acetylglucosaminyltransferase 1', 217, NULL, NULL, 123664),
(123665, '3.30.160.60-FF-004988', NULL, NULL, 78, NULL, NULL, 123665),
(123666, '2.40.50.90-FF-000085', NULL, 'Tudor, isoform B', 83, NULL, NULL, 123666),
(123667, '3.90.640.10-FF-000079', NULL, 'Chaperone protein HscA homolog', 64, NULL, NULL, 123667),
(123668, '2.60.40.10-FF-000060', NULL, 'Myosin-binding protein C, slow type', 98, NULL, NULL, 123668),
(123669, '3.40.50.300-FF-004989', NULL, 'Predicted protein', 204, NULL, NULL, 123669),
(123670, '1.10.3210.10-FF-000050', NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase-like protein', 390, NULL, NULL, 123670),
(123671, '2.60.120.650-FF-000042', NULL, 'Transcription factor jumonji (JmjC) domain-containing protein', 104, NULL, NULL, 123671),
(123672, '1.20.5.110-FF-000026', NULL, 'BET1 homolog', 62, NULL, NULL, 123672),
(123673, '1.20.120.1110-FF-000006', NULL, 'TAF (TBP-associated transcription factor) family', 110, NULL, NULL, 123673),
(123674, '2.40.70.10-FF-000343', NULL, NULL, 159, NULL, NULL, 123674),
(123675, '1.10.418.30-FF-000004', NULL, 'Kinetochore protein ndc-80', 115, NULL, NULL, 123675),
(123676, '2.10.25.10-FF-000543', NULL, 'Merozoite surface antigen 1', 54, NULL, NULL, 123676),
(123677, '3.40.1190.20-FF-000052', NULL, 'Multifunctional fusion protein', 265, NULL, NULL, 123677),
(123678, '1.10.10.60-FF-001307', NULL, NULL, 45, NULL, NULL, 123678),
(123679, '3.40.50.300-FF-006411', NULL, 'Uncharacterized protein', 131, NULL, NULL, 123679),
(123680, '2.60.40.640-FF-000108', NULL, 'Down syndrome critical region protein 3 homolog', 128, NULL, NULL, 123680),
(123681, '3.40.630.10-FF-000247', NULL, 'N-acetyl-L,L-diaminopimelate deacetylase', 231, NULL, NULL, 123681),
(123682, '2.40.150.20-FF-000032', NULL, 'Predicted protein', 138, NULL, NULL, 123682),
(123683, '2.40.170.20-FF-000095', NULL, 'TonB-dependent receptor', 607, NULL, NULL, 123683),
(123684, '3.30.70.330-FF-001840', NULL, NULL, 117, NULL, NULL, 123684),
(123685, '1.20.1260.10-FF-000016', NULL, 'Ferritin heavy chain', 183, NULL, NULL, 123685),
(123686, '3.30.450.80-FF-000003', NULL, 'LuxR family transcriptional regulator', 175, NULL, NULL, 123686),
(123687, '3.30.160.60-FF-002779', NULL, 'Zinc fingers and homeoboxes 3', 85, NULL, NULL, 123687),
(123688, '2.130.10.10-FF-001465', NULL, 'Chromatin assembly factor 1 subunit FAS2 homolog', 136, NULL, NULL, 123688),
(123689, '3.10.105.10-FF-000129', NULL, 'Putative bifunctional protein [include methyl-accepting chemotaxis protein and an extracellular solute-binding protein]', 215, NULL, NULL, 123689),
(123690, '3.30.420.40-FF-000422', NULL, 'Chaperone protein DNAK, putative', 92, NULL, NULL, 123690),
(123691, '3.90.190.10-FF-000325', NULL, 'Uncharacterized protein', 105, NULL, NULL, 123691),
(123692, '1.20.1280.50-FF-000035', NULL, 'F-box/LRR-repeat protein 6 isoform X2', 51, NULL, NULL, 123692),
(123693, '1.25.40.10-FF-003150', NULL, 'Pentatricopeptide repeat-containing protein At4g30700', 122, NULL, NULL, 123693),
(123694, '3.40.50.1820-FF-000582', NULL, 'Chlorophyllase-1', 297, NULL, NULL, 123694),
(123695, '1.10.510.10-FF-000236', NULL, 'Casein kinase 1-like protein', 348, NULL, NULL, 123695);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(123696, '2.30.140.10-FF-000019', NULL, 'SPermiDine Synthase', 89, NULL, NULL, 123696),
(123697, '3.30.70.1170-FF-000030', NULL, 'NOL1/NOP2/Sun (TRNA and rRNA cytosine-C5-methyltransferase) family protein', 95, NULL, NULL, 123697),
(123698, '3.40.50.300-FF-001740', NULL, 'Obg-like ATPase 1', 128, NULL, NULL, 123698),
(123699, '4.10.830.40-FF-000004', NULL, 'Uncharacterized protein, isoform A', 62, NULL, NULL, 123699),
(123700, '1.20.970.10-FF-000032', NULL, 'Anthranilate synthase component II', 81, NULL, NULL, 123700),
(123701, '3.40.50.720-FF-000933', NULL, 'Putative beta-ketoacyl-(Acyl-carrier-protein) reductase', 245, NULL, NULL, 123701),
(123702, '3.40.930.10-FF-000023', NULL, 'HPr family phosphocarrier protein', 141, NULL, NULL, 123702),
(123703, '3.30.40.10-FF-000289', NULL, 'TNF receptor-associated factor', 50, NULL, NULL, 123703),
(123704, '1.10.472.10-FF-000135', NULL, 'Cyclin G', 70, NULL, NULL, 123704),
(123705, '2.60.40.10-FF-001341', NULL, 'Sidestep, isoform B', 119, NULL, NULL, 123705),
(123706, '3.30.505.10-FF-000015', NULL, 'Growth factor receptor-bound protein 10 isoform X1', 119, NULL, NULL, 123706),
(123707, '3.30.450.20-FF-000564', NULL, 'Uncharacterized protein', 64, NULL, NULL, 123707),
(123708, '3.90.660.20-FF-000027', NULL, 'Protoporphyrinogen oxidase', 57, NULL, NULL, 123708),
(123709, '1.25.10.10-FF-000708', NULL, 'Probable SPO76 protein', 192, NULL, NULL, 123709),
(123710, '1.10.510.10-FF-001989', NULL, 'Protein kinase, putative', 255, NULL, NULL, 123710),
(123711, '3.40.50.1260-FF-000043', NULL, 'Phosphoglycerate kinase', 138, NULL, NULL, 123711),
(123712, '1.10.10.10-FF-000736', NULL, 'transcription factor Spi-C-like isoform X3', 88, NULL, NULL, 123712),
(123713, '3.40.50.300-FF-008620', NULL, 'Uncharacterized protein', 162, NULL, NULL, 123713),
(123714, '2.130.10.10-FF-003674', NULL, 'WD repeat domain 62', 219, NULL, NULL, 123714),
(123715, '3.30.930.10-FF-000401', NULL, 'Predicted protein', 112, NULL, NULL, 123715),
(123716, '3.30.760.10-FF-000068', NULL, 'Eukaryotic translation initiation factor 4E-like protein', 107, NULL, NULL, 123716),
(123717, '1.20.900.10-FF-000027', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', 203, NULL, NULL, 123717),
(123718, '1.20.5.730-FF-000004', NULL, 'SGO1 isoform 1', 47, NULL, NULL, 123718),
(123719, '2.30.29.170-FF-000015', NULL, 'GM23827', 95, NULL, NULL, 123719),
(123720, '2.60.120.260-FF-000251', NULL, 'Beta-galactosidase', 136, NULL, NULL, 123720),
(123721, '3.80.10.10-FF-003814', NULL, 'Uncharacterized protein', 81, NULL, NULL, 123721),
(123722, '3.90.700.10-FF-000017', NULL, '3-ketosteroid dehydrogenase, putative', 143, NULL, NULL, 123722),
(123723, '1.25.40.10-FF-003706', NULL, 'Uncharacterized protein', 99, NULL, NULL, 123723),
(123724, '3.90.226.10-FF-000162', NULL, 'Similar to propionyl-CoA carboxylase', 255, NULL, NULL, 123724),
(123725, '3.80.20.20-FF-000002', NULL, 'Tyrosine-protein kinase receptor', 237, NULL, NULL, 123725),
(123726, '3.40.50.20-FF-000011', NULL, 'CAD protein-like isoform X1', 111, NULL, NULL, 123726),
(123727, '3.80.10.10-FF-004478', NULL, 'Putative leucine-rich repeat receptor-like serine/threonine-protein kinase', 149, NULL, NULL, 123727),
(123728, '2.130.10.10-FF-001318', NULL, 'RNA polymerase II Elongator subunit, putative', 157, NULL, NULL, 123728),
(123729, '1.25.10.10-FF-002541', NULL, 'Uncharacterized protein', 181, NULL, NULL, 123729),
(123730, '3.90.1580.10-FF-000011', NULL, 'Gliding motility lipoprotein GldK', 139, NULL, NULL, 123730),
(123731, '2.60.40.10-FF-006012', NULL, NULL, 110, NULL, NULL, 123731),
(123732, '2.130.10.10-FF-004899', NULL, 'Uncharacterized protein', 113, NULL, NULL, 123732),
(123733, '1.20.1070.10-FF-000597', NULL, 'Predicted protein', 291, NULL, NULL, 123733),
(123734, '1.20.1070.10-FF-000333', NULL, 'Relaxin receptor 1', 307, NULL, NULL, 123734),
(123735, '2.10.25.10-FF-000690', NULL, 'Uncharacterized protein', 55, NULL, NULL, 123735),
(123736, '3.20.190.10-FF-000009', NULL, 'Unplaced genomic scaffold supercont1.232, whole genome shotgun sequence', 156, NULL, NULL, 123736);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(123737, '1.20.120.730-FF-000003', NULL, 'Protein transport protein SEC23', 120, NULL, NULL, 123737),
(123738, '1.10.555.10-FF-000261', NULL, NULL, 100, NULL, NULL, 123738),
(123739, '1.25.40.10-FF-004898', NULL, 'Uncharacterized protein', 88, NULL, NULL, 123739),
(123740, '2.60.40.1120-FF-000082', NULL, 'Peptidase S8 and S53 subtilisin kexin sedolisin', 78, NULL, NULL, 123740),
(123741, '1.10.287.1490-FF-000121', NULL, 'Predicted protein', 154, NULL, NULL, 123741),
(123742, '1.10.150.50-FF-000181', NULL, 'Uncharacterized protein', 92, NULL, NULL, 123742),
(123743, '3.80.10.10-FF-001605', NULL, 'Inactive leucine-rich repeat receptor-like protein kinase isoform A', 56, NULL, NULL, 123743),
(123744, '3.30.160.60-FF-004016', NULL, NULL, 29, NULL, NULL, 123744),
(123745, '2.60.40.10-FF-001902', NULL, 'Biofilm-promoting protein BpfA', 102, NULL, NULL, 123745),
(123746, '3.30.1520.10-FF-000156', NULL, 'Sorting nexin 6', 73, NULL, NULL, 123746),
(123747, '1.10.437.10-FF-000065', NULL, 'BCL2-associated X, apoptosis regulator a', 164, NULL, NULL, 123747),
(123748, '2.130.10.10-FF-000801', NULL, 'Sortilin', 130, NULL, NULL, 123748),
(123749, '1.25.10.10-FF-003058', NULL, 'Uncharacterized protein', 267, NULL, NULL, 123749),
(123750, '1.10.630.10-FF-000716', NULL, 'Uncharacterized protein', 107, NULL, NULL, 123750),
(123751, '2.120.10.30-FF-000072', NULL, 'Blast:Prolow-density lipoprotein receptor-related protein 1', 316, NULL, NULL, 123751),
(123752, '1.20.1250.20-FF-000552', NULL, 'Pantothenate transporter', 215, NULL, NULL, 123752),
(123753, '3.30.1370.10-FF-000239', NULL, 'Uncharacterized protein', 50, NULL, NULL, 123753),
(123754, '3.30.70.940-FF-000033', NULL, 'Predicted protein', 51, NULL, NULL, 123754),
(123755, '1.25.40.180-FF-000262', NULL, NULL, 226, NULL, NULL, 123755),
(123756, '1.10.486.10-FF-000077', NULL, 'Predicted protein', 64, NULL, NULL, 123756),
(123757, '1.10.565.10-FF-000087', NULL, 'Estrogen-related receptor alpha', 55, NULL, NULL, 123757),
(123758, '1.10.238.10-FF-000136', NULL, 'Calpain small subunit 1', 173, NULL, NULL, 123758),
(123759, '2.20.100.10-FF-000070', NULL, 'SCO-spondin', 56, NULL, NULL, 123759),
(123760, '3.40.50.300-FF-002516', NULL, 'YDR020C-like protein', 197, NULL, NULL, 123760),
(123761, '1.10.630.10-FF-000008', NULL, 'Cytochrome P450 71D8', 470, NULL, NULL, 123761),
(123762, '1.25.40.860-FF-000016', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 135, NULL, NULL, 123762),
(123763, '3.30.1010.10-FF-000073', NULL, 'Putative phosphatidylinositol 4-kinase alpha-like protein P2', 44, NULL, NULL, 123763),
(123764, '3.30.70.330-FF-002357', NULL, NULL, 105, NULL, NULL, 123764),
(123765, '3.30.70.270-FF-000225', NULL, NULL, 52, NULL, NULL, 123765),
(123766, '2.130.10.10-FF-005416', NULL, 'Uncharacterized protein', 228, NULL, NULL, 123766),
(123767, '3.40.50.1360-FF-000039', NULL, 'Putative Transcriptional regulator', 264, NULL, NULL, 123767),
(123768, '2.60.40.10-FF-004831', NULL, NULL, 60, NULL, NULL, 123768),
(123769, '1.10.10.60-FF-001223', NULL, NULL, 76, NULL, NULL, 123769),
(123770, '2.10.25.10-FF-000807', NULL, 'Low-density lipoprotein receptor domain class A', 40, NULL, NULL, 123770),
(123771, '2.40.170.10-FF-000002', NULL, 'Cryptic outer membrane porin BglH', 413, NULL, NULL, 123771),
(123772, '3.30.70.270-FF-000164', NULL, NULL, 80, NULL, NULL, 123772),
(123773, '3.90.370.10-FF-000007', NULL, 'Uncharacterized protein', 75, NULL, NULL, 123773),
(123774, '3.30.70.1230-FF-000065', NULL, 'Photoactivated adenylate cyclase subunit alpha-like protein ST-', 197, NULL, NULL, 123774),
(123775, '3.20.20.540-FF-000001', NULL, 'Phosphomethylpyrimidine synthase', 314, NULL, NULL, 123775),
(123776, '1.20.890.10-FF-000031', NULL, 'Uncharacterized protein', 43, NULL, NULL, 123776),
(123777, '2.110.10.10-FF-000055', NULL, 'Paraflagellar rod component, putative', 192, NULL, NULL, 123777),
(123778, '3.40.1110.10-FF-000123', NULL, 'Calcium motive P-type ATPase, putative', 227, NULL, NULL, 123778),
(123779, '3.30.559.30-FF-000061', NULL, 'Nonribosomal peptide synthase, putative', 227, NULL, NULL, 123779); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(123780, '3.40.850.10-FF-000022', NULL, 'Kinesin-like protein', 375, NULL, NULL, 123780),
(123781, '2.60.40.10-FF-000560', NULL, 'Nectin cell adhesion molecule 4', 93, NULL, NULL, 123781),
(123782, '1.20.1250.40-FF-000030', NULL, 'Uncharacterized protein', 132, NULL, NULL, 123782),
(123783, '3.30.190.20-FF-000049', NULL, 'Uncharacterized protein', 32, NULL, NULL, 123783),
(123784, '3.30.160.60-FF-005360', NULL, NULL, 59, NULL, NULL, 123784),
(123785, '3.40.50.300-FF-004141', NULL, 'Protein CBR-PRX-6', 155, NULL, NULL, 123785),
(123786, '3.10.450.40-FF-000024', NULL, 'Amine oxidase', 96, NULL, NULL, 123786),
(123787, '1.10.510.10-FF-003198', NULL, NULL, 148, NULL, NULL, 123787),
(123788, '2.60.40.150-FF-000613', NULL, 'Meiotically up-regulated gene 190 protein', 150, NULL, NULL, 123788),
(123789, '3.30.230.70-FF-000158', NULL, 'Predicted protein', 59, NULL, NULL, 123789),
(123790, '2.60.120.330-FF-000064', NULL, 'Predicted protein', 328, NULL, NULL, 123790),
(123791, '3.40.50.12650-FF-000025', NULL, 'Uncharacterized protein', 105, NULL, NULL, 123791),
(123792, '2.40.30.10-FF-000009', NULL, 'Eukaryotic translation initiation factor 2 subunit gamma', 116, NULL, NULL, 123792),
(123793, '2.120.10.80-FF-000210', NULL, 'F-box/kelch-repeat protein At4g19330', 240, NULL, NULL, 123793),
(123794, '2.40.10.10-FF-000103', NULL, 'Protease Do-like 1, chloroplastic', 117, NULL, NULL, 123794),
(123795, '3.30.160.60-FF-001554', NULL, 'Zinc finger 202 m1', 25, NULL, NULL, 123795),
(123796, '1.10.150.50-FF-000006', NULL, 'SH3 and multiple ankyrin repeat domains protein 2', 67, NULL, NULL, 123796),
(123797, '3.40.1110.10-FF-000067', NULL, 'Phospholipid-transporting ATPase', 169, NULL, NULL, 123797),
(123798, '1.25.40.10-FF-001464', NULL, 'Protein CTR9-like protein', 320, NULL, NULL, 123798),
(123799, '3.40.50.1820-FF-000374', NULL, 'DiAcylGlycerol Lipase homolog', 247, NULL, NULL, 123799),
(123800, '3.10.450.10-FF-000009', NULL, 'Alpha-2-HS-glycoprotein 2', 112, NULL, NULL, 123800),
(123801, '3.80.10.10-FF-003253', NULL, 'Leucine-rich repeat-containing protein sog2', 174, NULL, NULL, 123801),
(123802, '3.40.710.10-FF-000012', NULL, 'Beta-lactamase', 359, NULL, NULL, 123802),
(123803, '3.10.330.10-FF-000006', NULL, 'Peroxisome biogenesis factor 1', 80, NULL, NULL, 123803),
(123804, '3.30.1520.10-FF-000100', NULL, 'Uncharacterized protein, isoform B', 55, NULL, NULL, 123804),
(123805, '2.60.260.40-FF-000002', NULL, 'NADH dehydrogenase [ubiquinone] iron-sulfur protein 6, mitochondrial', 52, NULL, NULL, 123805),
(123806, '2.60.40.10-FF-004775', NULL, NULL, 88, NULL, NULL, 123806),
(123807, '1.10.238.20-FF-000049', NULL, 'AGAP005182-PA', 125, NULL, NULL, 123807),
(123808, '2.130.10.10-FF-005888', NULL, 'Uncharacterized protein', 296, NULL, NULL, 123808),
(123809, '2.60.40.10-FF-005287', NULL, NULL, 83, NULL, NULL, 123809),
(123810, '1.10.246.140-FF-000010', NULL, 'Transcription and mRNA export factor SUS1', 91, NULL, NULL, 123810),
(123811, '3.40.50.300-FF-008412', NULL, 'Regulator of nonsense transcripts putative', 148, NULL, NULL, 123811),
(123812, '3.50.50.60-FF-000298', NULL, 'Succinate dehydrogenase complex flavoprotein subunit A', 88, NULL, NULL, 123812),
(123813, '1.25.40.10-FF-001025', NULL, 'Protein KINESIN LIGHT CHAIN-RELATED 2', 118, NULL, NULL, 123813),
(123814, '3.40.50.620-FF-000813', NULL, 'Uncharacterized protein', 205, NULL, NULL, 123814),
(123815, '2.60.200.40-FF-000026', NULL, 'Diacylglycerol kinase', 154, NULL, NULL, 123815),
(123816, '3.30.160.60-FF-001993', NULL, 'Zinc finger protein 467', 43, NULL, NULL, 123816),
(123817, '2.60.40.10-FF-005820', NULL, NULL, 52, NULL, NULL, 123817),
(123818, '2.170.130.10-FF-000036', NULL, 'Outer membrane protein', 108, NULL, NULL, 123818),
(123819, '1.25.40.20-FF-001793', NULL, 'CARD- and ANK-containing Inflammasome Adaptor Protein', 171, NULL, NULL, 123819),
(123820, '2.40.50.40-FF-000064', NULL, 'Signal recognition particle 43 kDa protein, chloroplastic', 52, NULL, NULL, 123820),
(123821, '3.40.50.2000-FF-000299', NULL, 'Glycosyltransferase', 238, NULL, NULL, 123821);
INSERT INTO "PUBLIC"."MODEL" VALUES
(123822, '1.20.5.390-FF-000003', NULL, 'NF-kappa-B essential modulator isoform X1', 69, NULL, NULL, 123822),
(123823, '3.30.70.330-FF-002593', NULL, NULL, 135, NULL, NULL, 123823),
(123824, '3.30.9.30-FF-000003', NULL, 'FAD/NAD(P)-binding domain-containing protein', 99, NULL, NULL, 123824),
(123825, '2.30.29.30-FF-001024', NULL, 'Predicted protein', 133, NULL, NULL, 123825),
(123826, '3.40.50.300-FF-005130', NULL, 'ATPase involved in chromosome partitioning-like protein', 243, NULL, NULL, 123826),
(123827, '1.10.1000.11-FF-000023', NULL, 'ARFGEF1', 45, NULL, NULL, 123827),
(123828, '3.20.20.140-FF-000241', NULL, 'Selenium metabolism SsnA family protein', 299, NULL, NULL, 123828),
(123829, '1.10.238.10-FF-000636', NULL, 'calmodulin-like protein 4', 70, NULL, NULL, 123829),
(123830, '3.40.430.10-FF-000030', NULL, 'Dihydrofolate reductase', 207, NULL, NULL, 123830),
(123831, '1.25.40.20-FF-001298', NULL, 'GA binding protein transcription factor subunit beta 2b', 157, NULL, NULL, 123831),
(123832, '1.10.30.10-FF-000119', NULL, 'High mobility group protein homolog TDP-1', 94, NULL, NULL, 123832),
(123833, '1.25.40.10-FF-000952', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 97, NULL, NULL, 123833),
(123834, '2.60.40.1860-FF-000011', NULL, NULL, 90, NULL, NULL, 123834),
(123835, '3.40.50.300-FF-003185', NULL, 'Zinc finger, NFX1-type-containing 1, gene 2', 217, NULL, NULL, 123835),
(123836, '2.60.40.1730-FF-000107', NULL, NULL, 185, NULL, NULL, 123836),
(123837, '1.10.10.10-FF-001164', NULL, 'SirA family protein', 74, NULL, NULL, 123837),
(123838, '3.30.70.330-FF-002121', NULL, NULL, 109, NULL, NULL, 123838),
(123839, '3.80.10.10-FF-003730', NULL, 'Leucine-rich repeat-containing protein let-4', 136, NULL, NULL, 123839),
(123840, '2.130.10.10-FF-001673', NULL, 'GM19772', 250, NULL, NULL, 123840),
(123841, '3.90.80.10-FF-000013', NULL, 'Pyrophosphatase (inorganic) 2', 117, NULL, NULL, 123841),
(123842, '1.10.418.10-FF-000257', NULL, 'Flagellar associated protein', 75, NULL, NULL, 123842),
(123843, '2.40.110.10-FF-000026', NULL, '4-hydroxyphenylacetate 3-monooxygenase oxygenase component', 129, NULL, NULL, 123843),
(123844, '3.40.525.10-FF-000025', NULL, 'PATELLIN 2', 241, NULL, NULL, 123844),
(123845, '3.40.720.10-FF-000310', NULL, 'Uncharacterized protein', 211, NULL, NULL, 123845),
(123846, '1.10.238.200-FF-000011', NULL, 'DCN1-like protein 1', 84, NULL, NULL, 123846),
(123847, '1.20.1070.10-FF-000389', NULL, 'Galanin-like G-protein coupled receptor npr-9', 347, NULL, NULL, 123847),
(123848, '1.10.510.10-FF-002214', NULL, 'Uncharacterized protein', 188, NULL, NULL, 123848),
(123849, '3.40.50.10490-FF-000063', NULL, 'SIS domain-containing protein', 175, NULL, NULL, 123849),
(123850, '3.10.590.10-FF-000019', NULL, 'Uncharacterized protein', 61, NULL, NULL, 123850),
(123851, '4.10.1240.10-FF-000060', NULL, 'Adhesion G protein-coupled receptor B3', 61, NULL, NULL, 123851),
(123852, '3.40.640.10-FF-000220', NULL, 'Kynureninase', 277, NULL, NULL, 123852),
(123853, '2.60.40.10-FF-004303', NULL, NULL, 103, NULL, NULL, 123853),
(123854, '3.30.160.60-FF-003319', NULL, 'U1 zinc finger family protein', 52, NULL, NULL, 123854),
(123855, '1.10.472.10-FF-000719', NULL, 'G1/S-specific cyclin-E-like Protein', 130, NULL, NULL, 123855),
(123856, '1.20.58.60-FF-000563', NULL, 'Uncharacterized protein', 111, NULL, NULL, 123856),
(123857, '3.40.50.1820-FF-001627', NULL, 'Carboxylic ester hydrolase', 491, NULL, NULL, 123857),
(123858, '3.40.50.620-FF-000318', NULL, 'YML096W-like protein', 305, NULL, NULL, 123858),
(123859, '1.10.555.10-FF-000114', NULL, 'RhoGAP domain containing protein', 192, NULL, NULL, 123859),
(123860, '1.20.1250.20-FF-002261', NULL, 'Potassium channel, putative', 103, NULL, NULL, 123860),
(123861, '3.30.200.20-FF-001737', NULL, 'Serine/threonine-protein kinase Chk1', 97, NULL, NULL, 123861),
(123862, '3.30.450.20-FF-000620', NULL, 'Uncharacterized protein', 105, NULL, NULL, 123862),
(123863, '2.60.40.150-FF-000557', NULL, 'C2 domain containing protein', 110, NULL, NULL, 123863);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(123864, '3.30.70.660-FF-000016', NULL, 'tRNA pseudouridine synthase A', 137, NULL, NULL, 123864),
(123865, '3.20.20.80-FF-000112', NULL, 'Alpha-glucosidase AglA', 397, NULL, NULL, 123865),
(123866, '2.60.34.10-FF-000028', NULL, 'Heat shock protein 4b', 177, NULL, NULL, 123866),
(123867, '2.30.30.40-FF-000642', NULL, 'Uncharacterized protein', 78, NULL, NULL, 123867),
(123868, '2.130.10.10-FF-005944', NULL, 'Predicted protein', 252, NULL, NULL, 123868),
(123869, '3.40.50.300-FF-001268', NULL, 'RAP1B, member of RAS oncogene family', 118, NULL, NULL, 123869),
(123870, '3.10.20.90-FF-000458', NULL, 'Erythrocyte membrane protein band 4.1a', 75, NULL, NULL, 123870),
(123871, '2.30.30.100-FF-000215', NULL, 'RNA-binding protein Hfq', 80, NULL, NULL, 123871),
(123872, '1.20.1330.10-FF-000016', NULL, 'Flagellin', 43, NULL, NULL, 123872),
(123873, '3.10.350.10-FF-000064', NULL, 'Putative cell wall hydrolase', 46, NULL, NULL, 123873),
(123874, '3.20.20.70-FF-000750', NULL, NULL, 67, NULL, NULL, 123874),
(123875, '1.20.1510.10-FF-000053', NULL, 'Solute carrier family 30 member 1', 82, NULL, NULL, 123875),
(123876, '3.10.290.10-FF-000093', NULL, '40S ribosomal protein S4-3', 74, NULL, NULL, 123876),
(123877, '2.90.10.10-FF-000045', NULL, 'Os06g0619600 protein', 134, NULL, NULL, 123877),
(123878, '2.60.120.650-FF-000098', NULL, 'Jumonji domain-containing protein, putative', 254, NULL, NULL, 123878),
(123879, '1.20.1250.20-FF-001272', NULL, 'Uncharacterized protein', 210, NULL, NULL, 123879),
(123880, '1.10.150.240-FF-000095', NULL, 'Haloacid dehalogenase-like hydrolase', 64, NULL, NULL, 123880),
(123881, '3.40.1770.10-FF-000009', NULL, 'Uncharacterized protein', 174, NULL, NULL, 123881),
(123882, '3.40.630.30-FF-000489', NULL, 'GNAT family N-acetyltransferase', 147, NULL, NULL, 123882),
(123883, '2.40.50.90-FF-000141', NULL, 'YALI0B03960p', 149, NULL, NULL, 123883),
(123884, '2.10.25.10-FF-000487', NULL, 'Fibulin 5', 37, NULL, NULL, 123884),
(123885, '2.30.40.10-FF-000072', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 81, NULL, NULL, 123885),
(123886, '1.25.10.10-FF-001636', NULL, 'Imb-3', 1065, NULL, NULL, 123886),
(123887, '2.60.120.200-FF-000637', NULL, 'Uncharacterized protein', 115, NULL, NULL, 123887),
(123888, '1.10.220.10-FF-000017', NULL, 'Annexin', 80, NULL, NULL, 123888),
(123889, '1.10.3660.10-FF-000015', NULL, 'Prephenate dehydrogenase', 108, NULL, NULL, 123889),
(123890, '1.20.58.1930-FF-000002', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 229, NULL, NULL, 123890),
(123891, '1.10.8.10-FF-000016', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 48, NULL, NULL, 123891),
(123892, '1.10.357.20-FF-000005', NULL, 'Magnesium transporter MgtE', 174, NULL, NULL, 123892),
(123893, '3.40.50.1700-FF-000012', NULL, 'Glycoside hydrolase family 3 protein', 176, NULL, NULL, 123893),
(123894, '3.30.40.10-FF-002183', NULL, 'Ubiquitinyl hydrolase 1', 127, NULL, NULL, 123894),
(123895, '3.30.200.20-FF-001361', NULL, 'Calcium-dependent protein kinase 1 isoform A', 84, NULL, NULL, 123895),
(123896, '2.40.50.140-FF-001151', NULL, NULL, 100, NULL, NULL, 123896),
(123897, '3.40.50.850-FF-000005', NULL, 'Isochorismatase hydrolase', 188, NULL, NULL, 123897),
(123898, '3.40.50.2000-FF-000619', NULL, 'Uncharacterized protein', 246, NULL, NULL, 123898),
(123899, '2.60.40.10-FF-002886', NULL, 'Leptin receptor', 99, NULL, NULL, 123899),
(123900, '3.60.21.60-FF-000005', NULL, 'DNA polymerase alpha subunit B', 176, NULL, NULL, 123900),
(123901, '3.40.50.2300-FF-001232', NULL, NULL, 120, NULL, NULL, 123901),
(123902, '3.30.70.330-FF-000204', NULL, 'Synaptojanin 2', 87, NULL, NULL, 123902),
(123903, '1.20.272.10-FF-000073', NULL, NULL, 120, NULL, NULL, 123903),
(123904, '1.10.630.10-FF-000363', NULL, 'Chromosome 16, whole genome shotgun sequence', 512, NULL, NULL, 123904),
(123905, '1.10.3120.10-FF-000020', NULL, NULL, 208, NULL, NULL, 123905),
(123906, '2.30.42.10-FF-000110', NULL, 'multiple PDZ domain protein isoform X2', 113, NULL, NULL, 123906),
(123907, '1.20.1250.20-FF-000288', NULL, 'Solute carrier family 45, member 2', 212, NULL, NULL, 123907);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(123908, '1.20.1250.20-FF-002109', NULL, 'Uncharacterized protein', 234, NULL, NULL, 123908),
(123909, '3.80.10.10-FF-001313', NULL, 'Leucine-rich repeat receptor-like protein kinase', 237, NULL, NULL, 123909),
(123910, '3.40.50.720-FF-000641', NULL, 'D-amino acid oxidase', 98, NULL, NULL, 123910),
(123911, '3.90.530.10-FF-000009', NULL, NULL, 82, NULL, NULL, 123911),
(123912, '3.40.720.10-FF-000254', NULL, 'Uncharacterized protein', 75, NULL, NULL, 123912),
(123913, '2.60.40.10-FF-003347', NULL, 'Immunoglobulin domain-containing protein Y54G2A.25', 93, NULL, NULL, 123913),
(123914, '3.90.1410.10-FF-000112', NULL, 'Uncharacterized protein (Fragment)', 226, NULL, NULL, 123914),
(123915, '1.10.287.770-FF-000011', NULL, 'Sodium channel epithelial 1 delta subunit', 59, NULL, NULL, 123915),
(123916, '3.30.160.60-FF-003471', NULL, NULL, 28, NULL, NULL, 123916),
(123917, '3.30.450.20-FF-000148', NULL, 'PTS-dependent dihydroxyacetone kinase operon regulatory protein', 105, NULL, NULL, 123917),
(123918, '3.40.50.300-FF-001763', NULL, 'Ras family gtpase', 171, NULL, NULL, 123918),
(123919, '3.20.20.140-FF-000117', NULL, 'Probable phosphatase C1142_00695', 240, NULL, NULL, 123919),
(123920, '2.60.120.10-FF-000096', NULL, '2-aminoethanethiol dioxygenase', 193, NULL, NULL, 123920),
(123921, '1.20.58.390-FF-000008', NULL, 'Cholinergic receptor nicotinic beta 4 subunit', 114, NULL, NULL, 123921),
(123922, '1.20.120.1070-FF-000005', NULL, 'Translation initiation factor EIF-2b alpha subunit, putative', 121, NULL, NULL, 123922),
(123923, '2.40.50.120-FF-000032', NULL, 'netrin-4', 127, NULL, NULL, 123923),
(123924, '3.30.70.2740-FF-000001', NULL, 'D-lactate dehydrogenase mitochondrial', 82, NULL, NULL, 123924),
(123925, '3.40.50.2300-FF-000119', NULL, 'Maltose regulon regulatory protein MalI', 117, NULL, NULL, 123925),
(123926, '3.20.20.70-FF-000311', NULL, 'Probable galactinol--sucrose galactosyltransferase 5', 340, NULL, NULL, 123926),
(123927, '3.40.50.300-FF-002252', NULL, 'Type IV secretion system protein', 281, NULL, NULL, 123927),
(123928, '3.40.50.150-FF-000245', NULL, 'Methyltransferase domain containing protein', 217, NULL, NULL, 123928),
(123929, '3.40.50.300-FF-005506', NULL, 'Putative DEAD/DEAH box helicase', 173, NULL, NULL, 123929),
(123930, '1.10.287.470-FF-000039', NULL, 'Efflux transporter, RND family, MFP subunit', 60, NULL, NULL, 123930),
(123931, '3.30.710.10-FF-000334', NULL, 'Ankyrin repeat containing protein', 76, NULL, NULL, 123931),
(123932, '2.60.40.60-FF-001131', NULL, 'Protocadherin beta-6, putative', 96, NULL, NULL, 123932),
(123933, '3.40.50.720-FF-001153', NULL, 'Expressed protein', 154, NULL, NULL, 123933),
(123934, '1.20.1250.20-FF-000783', NULL, 'MFS general substrate transporter', 202, NULL, NULL, 123934),
(123935, '1.10.246.60-FF-000001', NULL, 'Eukaryotic translation initiation factor 3 subunit J', 80, NULL, NULL, 123935),
(123936, '1.10.555.10-FF-000058', NULL, 'GTPase-activating protein pac-1', 220, NULL, NULL, 123936),
(123937, '1.20.1250.10-FF-000015', NULL, 'thrombopoietin isoform X2', 163, NULL, NULL, 123937),
(123938, '3.40.50.620-FF-000757', NULL, 'Uncharacterized protein', 132, NULL, NULL, 123938),
(123939, '3.90.76.10-FF-000026', NULL, 'Peptide ABC transporter substrate-binding protein', 165, NULL, NULL, 123939),
(123940, '3.30.160.60-FF-001026', NULL, 'zinc finger protein 383', 27, NULL, NULL, 123940),
(123941, '3.40.140.10-FF-000103', NULL, 'WGS project CABT00000000 data, contig 2.3', 131, NULL, NULL, 123941),
(123942, '2.60.120.10-FF-000101', NULL, 'Cyclic nucleotide-binding domain protein', 131, NULL, NULL, 123942),
(123943, '3.90.650.10-FF-000052', NULL, 'Uncharacterized protein', 128, NULL, NULL, 123943),
(123944, '3.40.50.2300-FF-001108', NULL, 'Uncharacterized protein', 254, NULL, NULL, 123944),
(123945, '3.30.300.20-FF-000020', NULL, 'Transcription termination/antitermination protein NusA', 92, NULL, NULL, 123945),
(123946, '3.30.300.30-FF-000169', NULL, 'Ferrichrome siderophore peptide synthetase', 121, NULL, NULL, 123946),
(123947, '2.130.10.10-FF-004955', NULL, 'Uncharacterized protein', 93, NULL, NULL, 123947);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(123948, '2.130.10.10-FF-001234', NULL, 'Predicted protein', 105, NULL, NULL, 123948),
(123949, '3.30.420.40-FF-000006', NULL, 'Molecular chaperone DnaK', 94, NULL, NULL, 123949),
(123950, '3.30.390.50-FF-000017', NULL, 'Uncharacterized protein', 78, NULL, NULL, 123950),
(123951, '3.30.160.60-FF-002807', NULL, NULL, 30, NULL, NULL, 123951),
(123952, '2.60.120.590-FF-000063', NULL, 'Uncharacterized protein P8A3.02c', 183, NULL, NULL, 123952),
(123953, '3.30.390.30-FF-000011', NULL, 'Apoptosis-inducing factor, mitochondrion-associated, 3', 83, NULL, NULL, 123953),
(123954, '3.40.50.150-FF-000801', NULL, NULL, 47, NULL, NULL, 123954),
(123955, '3.30.70.330-FF-002065', NULL, NULL, 87, NULL, NULL, 123955),
(123956, '1.10.10.10-FF-000652', NULL, 'ArsR family transcriptional regulator', 82, NULL, NULL, 123956),
(123957, '3.40.50.10140-FF-000065', NULL, 'Uncharacterized protein', 140, NULL, NULL, 123957),
(123958, '1.10.260.40-FF-000034', NULL, 'LexA family transcriptional repressor', 92, NULL, NULL, 123958),
(123959, '3.80.10.10-FF-004186', NULL, 'Uncharacterized protein', 95, NULL, NULL, 123959),
(123960, '3.40.1690.10-FF-000008', NULL, 'FlhB-like flagellar biosynthesis protein', 85, NULL, NULL, 123960),
(123961, '3.90.1290.10-FF-000028', NULL, 'AGAP011396-PA', 175, NULL, NULL, 123961),
(123962, '1.20.58.370-FF-000002', NULL, 'Binding-protein-dependent transport systems inner membrane component', 89, NULL, NULL, 123962),
(123963, '3.40.33.10-FF-000160', NULL, 'Protein CBG21986', 124, NULL, NULL, 123963),
(123964, '2.30.30.100-FF-000210', NULL, 'Sm protein', 88, NULL, NULL, 123964),
(123965, '2.60.40.1530-FF-000019', NULL, 'Integrin alpha 5', 216, NULL, NULL, 123965),
(123966, '3.30.160.60-FF-002010', NULL, 'Zinc finger, C2H2 type', 32, NULL, NULL, 123966),
(123967, '1.25.40.10-FF-001817', NULL, 'Type 4 fimbrial biogenesis protein PilF', 219, NULL, NULL, 123967),
(123968, '3.40.50.11500-FF-000012', NULL, 'Uncharacterized protein', 194, NULL, NULL, 123968),
(123969, '3.30.70.2850-FF-000034', NULL, 'DNA-directed RNA polymerase subunit', 134, NULL, NULL, 123969),
(123970, '1.25.40.20-FF-001354', NULL, 'Ankyrin repeat family protein', 102, NULL, NULL, 123970),
(123971, '3.60.10.10-FF-000134', NULL, 'Sphingomyelinase C, putative', 326, NULL, NULL, 123971),
(123972, '3.90.190.10-FF-000061', NULL, 'tyrosine-protein phosphatase non-receptor type 23 isoform X1', 303, NULL, NULL, 123972),
(123973, '3.30.200.20-FF-001209', NULL, 'Serine/threonine-protein kinase MRCK beta', 214, NULL, NULL, 123973),
(123974, '2.40.30.10-FF-000161', NULL, 'Elongation factor Tu, mitochondrial', 103, NULL, NULL, 123974),
(123975, '1.20.120.1220-FF-000016', NULL, NULL, 123, NULL, NULL, 123975),
(123976, '2.20.80.10-FF-000007', NULL, 'Apolipophorin, isoform B', 193, NULL, NULL, 123976),
(123977, '2.60.40.1510-FF-000013', NULL, 'Integrin, alpha 9', 146, NULL, NULL, 123977),
(123978, '2.40.70.10-FF-000427', NULL, NULL, 164, NULL, NULL, 123978),
(123979, '1.10.520.10-FF-000057', NULL, 'Catalase/peroxidase', 146, NULL, NULL, 123979),
(123980, '3.40.50.300-FF-008356', NULL, 'Putative ABC transporter, ATP-binding protein', 141, NULL, NULL, 123980),
(123981, '1.25.10.10-FF-001760', NULL, 'Uncharacterized protein', 971, NULL, NULL, 123981),
(123982, '1.20.58.390-FF-000160', NULL, '5-hydroxytryptamine (serotonin) receptor 3B', 173, NULL, NULL, 123982),
(123983, '1.25.40.10-FF-003442', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 155, NULL, NULL, 123983),
(123984, '2.10.110.10-FF-000117', NULL, 'CBN-TAG-273 protein', 68, NULL, NULL, 123984),
(123985, '3.40.33.10-FF-000036', NULL, 'Uncharacterized protein', 183, NULL, NULL, 123985),
(123986, '2.10.70.10-FF-000030', NULL, 'Sushi domain-containing protein 4', 64, NULL, NULL, 123986),
(123987, '3.40.50.2000-FF-000243', NULL, 'Glycosyl transferase family 1', 165, NULL, NULL, 123987),
(123988, '3.40.50.720-FF-000169', NULL, 'Enoyl-[acyl-carrier-protein] reductase [NADH]', 193, NULL, NULL, 123988),
(123989, '1.10.620.20-FF-000011', NULL, 'Ribonucleotide reductase', 325, NULL, NULL, 123989);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(123990, '2.10.25.10-FF-001471', NULL, 'slit homolog 2 protein isoform X1', 39, NULL, NULL, 123990),
(123991, '1.20.1560.10-FF-000264', NULL, 'ABC transporter', 151, NULL, NULL, 123991),
(123992, '2.40.160.120-FF-000036', NULL, 'Oxysterol binding protein like 8', 166, NULL, NULL, 123992),
(123993, '3.40.50.10730-FF-000005', NULL, 'Urocanate hydratase', 218, NULL, NULL, 123993),
(123994, '1.25.40.10-FF-005331', NULL, 'Pentatricopeptide repeat-containing protein At5g62370', 91, NULL, NULL, 123994),
(123995, '1.20.1070.10-FF-001322', NULL, 'Vomeronasal type-1 receptor', 245, NULL, NULL, 123995),
(123996, '3.40.50.300-FF-003741', NULL, 'WGS project CABT00000000 data, contig 2.29', 351, NULL, NULL, 123996),
(123997, '1.10.287.110-FF-000280', NULL, 'DnaJ domain containing protein', 112, NULL, NULL, 123997),
(123998, '2.60.40.10-FF-003903', NULL, NULL, 82, NULL, NULL, 123998),
(123999, '4.10.280.10-FF-000026', NULL, 'Basic helix-loop-helix family, member e23', 70, NULL, NULL, 123999),
(124000, '3.40.50.300-FF-003505', NULL, 'Protein SUPPRESSOR OF MAX2 1', 214, NULL, NULL, 124000),
(124001, '3.40.50.10260-FF-000016', NULL, 'Pyridoxamine 5-phosphate oxidase, putative', 236, NULL, NULL, 124001),
(124002, '1.50.10.10-FF-000116', NULL, 'alpha-1,2-Mannosidase', 163, NULL, NULL, 124002),
(124003, '3.60.110.10-FF-000029', NULL, 'Protein N-terminal amidase', 252, NULL, NULL, 124003),
(124004, '3.30.420.10-FF-000554', NULL, NULL, 61, NULL, NULL, 124004),
(124005, '1.10.533.10-FF-000036', NULL, 'Ankyrin 2, isoform M', 90, NULL, NULL, 124005),
(124006, '2.40.10.10-FF-000598', NULL, NULL, 131, NULL, NULL, 124006),
(124007, '3.40.190.80-FF-000054', NULL, 'Fructose-1,6-bisphosphatase/inositol-1-monophosphatase', 121, NULL, NULL, 124007),
(124008, '3.90.550.10-FF-000044', NULL, 'Galactosylgalactosylxylosylprotein 3-beta-glucuronosyltransferase', 246, NULL, NULL, 124008),
(124009, '4.10.60.10-FF-000272', NULL, 'Putative germ-line specific RNA helicase vasa protein', 51, NULL, NULL, 124009),
(124010, '3.40.50.1000-FF-000752', NULL, NULL, 107, NULL, NULL, 124010),
(124011, '2.40.70.10-FF-000135', NULL, 'Peptidase, putative', 160, NULL, NULL, 124011),
(124012, '2.130.10.10-FF-002538', NULL, 'Os04g0619700 protein', 116, NULL, NULL, 124012),
(124013, '3.30.70.330-FF-002913', NULL, NULL, 130, NULL, NULL, 124013),
(124014, '1.20.1050.10-FF-000034', NULL, 'Transcriptional regulator URE2', 151, NULL, NULL, 124014),
(124015, '1.10.640.10-FF-000037', NULL, 'Uncharacterized protein', 276, NULL, NULL, 124015),
(124016, '1.10.472.10-FF-000343', NULL, 'Cyclin B-like protein', 141, NULL, NULL, 124016),
(124017, '3.40.50.150-FF-001257', NULL, NULL, 301, NULL, NULL, 124017),
(124018, '3.40.50.300-FF-003685', NULL, 'DEAD/DEAH box helicase', 184, NULL, NULL, 124018),
(124019, '1.10.3380.30-FF-000039', NULL, 'DEAD/DEAH box helicase family protein', 230, NULL, NULL, 124019),
(124020, '3.30.420.140-FF-000047', NULL, 'Predicted protein', 75, NULL, NULL, 124020),
(124021, '2.60.40.60-FF-000203', NULL, 'Cadherin 23', 106, NULL, NULL, 124021),
(124022, '3.30.530.20-FF-000149', NULL, 'Uncharacterized protein', 178, NULL, NULL, 124022),
(124023, '1.20.1070.10-FF-001030', NULL, 'Relaxin family peptide receptor 3', 168, NULL, NULL, 124023),
(124024, '3.30.40.10-FF-002211', NULL, 'Lysine-specific demethylase 7 homolog', 70, NULL, NULL, 124024),
(124025, '3.30.470.30-FF-000012', NULL, 'Probable DNA ligase', 202, NULL, NULL, 124025),
(124026, '3.40.50.1980-FF-000141', NULL, 'Putative ferrichrome-binding protein', 111, NULL, NULL, 124026),
(124027, '3.30.450.20-FF-000587', NULL, 'Uncharacterized protein', 119, NULL, NULL, 124027),
(124028, '3.40.190.290-FF-000098', NULL, 'LysR family transcriptional regulator', 210, NULL, NULL, 124028),
(124029, '3.30.760.10-FF-000045', NULL, 'Eukaryotic initiation factor 4E family protein', 174, NULL, NULL, 124029),
(124030, '1.20.5.170-FF-000201', NULL, 'Filament-like plant protein 6', 118, NULL, NULL, 124030),
(124031, '3.40.50.1220-FF-000110', NULL, 'Histone deacetylase HDAC silent information regulator protein 2 Sir2 sirtuin', 155, NULL, NULL, 124031);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(124032, '3.40.50.300-FF-004489', NULL, 'ATP-dependent DNA helicase', 251, NULL, NULL, 124032),
(124033, '3.10.129.10-FF-000252', NULL, 'Uncharacterized protein', 120, NULL, NULL, 124033),
(124034, '3.60.130.10-FF-000087', NULL, 'Butyrobetaine (gamma), 2-oxoglutarate dioxygenase (gamma-butyrobetaine hydroxylase) 1', 57, NULL, NULL, 124034),
(124035, '3.40.50.720-FF-002439', NULL, '2-dehydropantoate 2-reductase', 171, NULL, NULL, 124035),
(124036, '3.20.20.80-FF-000168', NULL, 'Chitodextrinase', 344, NULL, NULL, 124036),
(124037, '3.30.40.10-FF-001194', NULL, 'Uncharacterized protein AT4g35070', 63, NULL, NULL, 124037),
(124038, '3.40.50.720-FF-000697', NULL, 'Shikimate dehydrogenase (NADP(+))', 140, NULL, NULL, 124038),
(124039, '3.40.50.300-FF-007428', NULL, 'ATP-dependent DEAD/H RNA helicase, putative', 261, NULL, NULL, 124039),
(124040, '2.160.20.10-FF-000059', NULL, 'E1B 55 kDa protein', 240, NULL, NULL, 124040),
(124041, '3.30.160.60-FF-003735', NULL, NULL, 24, NULL, NULL, 124041),
(124042, '1.10.1080.10-FF-000021', NULL, 'Glutathione synthetase chloroplastic', 101, NULL, NULL, 124042),
(124043, '2.30.29.30-FF-000624', NULL, 'Protein CBG23324', 120, NULL, NULL, 124043),
(124044, '1.10.510.10-FF-003670', NULL, NULL, 176, NULL, NULL, 124044),
(124045, '1.25.40.10-FF-001964', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 167, NULL, NULL, 124045),
(124046, '3.90.550.10-FF-000191', NULL, '2-C-methyl-D-erythritol 4-phosphate cytidylyltransferase, putative', 225, NULL, NULL, 124046),
(124047, '3.30.420.10-FF-000407', NULL, NULL, 184, NULL, NULL, 124047),
(124048, '3.10.20.600-FF-000010', NULL, NULL, 50, NULL, NULL, 124048),
(124049, '3.40.1490.10-FF-000004', NULL, 'Peptidyl-tRNA hydrolase PTH2, putative', 152, NULL, NULL, 124049),
(124050, '2.10.25.10-FF-000482', NULL, 'Shifted, isoform B', 34, NULL, NULL, 124050),
(124051, '2.40.50.90-FF-000146', NULL, 'YALI0B03960p', 115, NULL, NULL, 124051),
(124052, '3.20.20.140-FF-000297', NULL, 'Uncharacterized protein', 85, NULL, NULL, 124052),
(124053, '1.20.85.10-FF-000009', NULL, 'Predicted protein', 129, NULL, NULL, 124053),
(124054, '3.30.70.330-FF-002857', NULL, NULL, 135, NULL, NULL, 124054),
(124055, '2.130.10.10-FF-002162', NULL, 'Two-component system sensor histidine kinase-response regulator hybrid protein', 120, NULL, NULL, 124055),
(124056, '2.40.50.140-FF-000038', NULL, 'Exosome complex component RRP4', 92, NULL, NULL, 124056),
(124057, '3.40.605.10-FF-000026', NULL, 'Aldehyde dehydrogenase, putative', 27, NULL, NULL, 124057),
(124058, '1.20.1720.10-FF-000119', NULL, 'Uncharacterized protein', 403, NULL, NULL, 124058),
(124059, '1.20.920.10-FF-000118', NULL, 'GD10895', 77, NULL, NULL, 124059),
(124060, '3.30.470.20-FF-000094', NULL, 'D-alanine--D-alanine ligase', 120, NULL, NULL, 124060),
(124061, '1.10.10.750-FF-000044', NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', 47, NULL, NULL, 124061),
(124062, '1.10.510.10-FF-003518', NULL, NULL, 246, NULL, NULL, 124062),
(124063, '3.30.413.10-FF-000026', NULL, 'Sulfite reductase-related protein', 134, NULL, NULL, 124063),
(124064, '2.20.80.10-FF-000002', NULL, 'Apolipoprotein B-100', 202, NULL, NULL, 124064),
(124065, '1.25.40.10-FF-004370', NULL, 'Chromosome 1, whole genome shotgun sequence', 260, NULL, NULL, 124065),
(124066, '3.30.70.330-FF-001137', NULL, 'Multiple RNA-binding domain-containing protein 1', 149, NULL, NULL, 124066),
(124067, '3.40.50.300-FF-003213', NULL, 'Multidrug resistance-associated protein lethal(2)03659', 233, NULL, NULL, 124067),
(124068, '1.20.1250.20-FF-000344', NULL, 'Feline leukemia virus subgroup C cellular receptor family member 2', 271, NULL, NULL, 124068),
(124069, '1.10.630.10-FF-000739', NULL, 'Uncharacterized protein', 86, NULL, NULL, 124069),
(124070, '3.40.30.10-FF-000299', NULL, 'Protein disulfide-isomerase', 115, NULL, NULL, 124070),
(124071, '3.10.20.620-FF-000016', NULL, NULL, 125, NULL, NULL, 124071),
(124072, '3.40.50.720-FF-002586', NULL, 'NmrA-like family domain-containing protein 1', 12, NULL, NULL, 124072),
(124073, '2.60.40.10-FF-001925', NULL, 'KETtiN (Drosophila actin-binding) homolog', 99, NULL, NULL, 124073);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(124074, '2.160.10.10-FF-000002', NULL, 'Serine acetyltransferase', 122, NULL, NULL, 124074),
(124075, '3.80.10.10-FF-003314', NULL, 'Uncharacterized protein', 175, NULL, NULL, 124075),
(124076, '2.60.120.920-FF-000022', NULL, 'E3 ubiquitin-protein ligase NEURL1 isoform X2', 152, NULL, NULL, 124076),
(124077, '1.10.10.10-FF-001580', NULL, 'Sialic acid utilization regulator, RpiR family', 78, NULL, NULL, 124077),
(124078, '3.90.550.50-FF-000213', NULL, 'Hexosyltransferase', 149, NULL, NULL, 124078),
(124079, '2.60.40.10-FF-002414', NULL, 'Myotactin form A', 98, NULL, NULL, 124079),
(124080, '1.10.3380.10-FF-000033', NULL, 'ATP-dependent RNA helicase', 132, NULL, NULL, 124080),
(124081, '3.40.390.10-FF-000003', NULL, 'endothelin-converting enzyme 1 isoform X1', 313, NULL, NULL, 124081),
(124082, '3.20.20.240-FF-000001', NULL, 'Probable methylmalonyl-coa mutase', 562, NULL, NULL, 124082),
(124083, '3.60.21.10-FF-000362', NULL, 'Uncharacterized protein', 139, NULL, NULL, 124083),
(124084, '2.30.42.10-FF-000054', NULL, 'multiple PDZ domain protein isoform X1', 116, NULL, NULL, 124084),
(124085, '1.10.3460.10-FF-000034', NULL, 'Early light-inducible protein', 117, NULL, NULL, 124085),
(124086, '2.40.30.20-FF-000023', NULL, 'Riboflavin synthase subunit alpha', 94, NULL, NULL, 124086),
(124087, '3.40.630.30-FF-000197', NULL, 'Possible 8-amino-7-oxononanoate synthase bioF2', 154, NULL, NULL, 124087),
(124088, '1.20.5.170-FF-000145', NULL, 'ATG16-domain-containing protein', 74, NULL, NULL, 124088),
(124089, '3.20.20.70-FF-000255', NULL, 'Dihydroorotate dehydrogenase, mitochondrial', 382, NULL, NULL, 124089),
(124090, '1.10.287.110-FF-000128', NULL, 'Co-chaperone protein HscB homolog', 77, NULL, NULL, 124090),
(124091, '3.30.1120.10-FF-000019', NULL, 'Arylsulfatase', 91, NULL, NULL, 124091),
(124092, '3.30.70.330-FF-000968', NULL, 'Eukaryotic translation initiation factor 3 subunit G', 124, NULL, NULL, 124092),
(124093, '3.30.30.110-FF-000001', NULL, 'Antibacterial factor-related peptide 2', 53, NULL, NULL, 124093),
(124094, '1.10.630.10-FF-000216', NULL, 'Cytochrome P450 2C23a', 246, NULL, NULL, 124094),
(124095, '2.60.40.10-FF-002358', NULL, 'Follistatin like 4', 81, NULL, NULL, 124095),
(124096, '3.40.570.10-FF-000040', NULL, 'Uncharacterized protein', 169, NULL, NULL, 124096),
(124097, '1.10.238.200-FF-000016', NULL, 'Defective in cullin neddylation protein', 82, NULL, NULL, 124097),
(124098, '1.20.1070.10-FF-001406', NULL, 'Uncharacterized protein', 235, NULL, NULL, 124098),
(124099, '1.25.10.10-FF-000832', NULL, 'Importin subunit alpha-2, putative', 416, NULL, NULL, 124099),
(124100, '1.50.40.10-FF-000091', NULL, 'Mitochondrial carrier protein', 197, NULL, NULL, 124100),
(124101, '3.30.530.20-FF-000065', NULL, 'Ribosome association toxin RatA', 142, NULL, NULL, 124101),
(124102, '3.90.1200.10-FF-000051', NULL, 'Spore coat protein CotS', 224, NULL, NULL, 124102),
(124103, '1.25.40.10-FF-003881', NULL, 'p60=60 kDa stress-related protein', 85, NULL, NULL, 124103),
(124104, '3.30.160.60-FF-002015', NULL, 'ZNF596 isoform 2', 26, NULL, NULL, 124104),
(124105, '1.20.58.390-FF-000244', NULL, 'Uncharacterized protein', 157, NULL, NULL, 124105),
(124106, '3.40.630.30-FF-000017', NULL, 'RNA cytidine acetyltransferase', 221, NULL, NULL, 124106),
(124107, '3.40.350.10-FF-000001', NULL, 'Putative xaa-Pro aminopeptidase 1', 154, NULL, NULL, 124107),
(124108, '1.20.5.170-FF-000229', NULL, 'Uncharacterized protein', 76, NULL, NULL, 124108),
(124109, '3.60.20.40-FF-000031', NULL, 'Uncharacterized protein', 209, NULL, NULL, 124109),
(124110, '3.20.20.80-FF-000084', NULL, 'Beta-mannosidase A', 384, NULL, NULL, 124110),
(124111, '3.30.497.10-FF-000186', NULL, 'Uncharacterized protein', 90, NULL, NULL, 124111),
(124112, '2.60.40.10-FF-003342', NULL, 'Fibronectin 1b', 91, NULL, NULL, 124112),
(124113, '3.40.50.150-FF-001173', NULL, NULL, 165, NULL, NULL, 124113),
(124114, '1.25.40.20-FF-000337', NULL, 'AF4/FMR2 family member 4 isoform X1', 117, NULL, NULL, 124114),
(124115, '1.25.40.10-FF-003386', NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', 145, NULL, NULL, 124115);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(124116, '2.60.40.10-FF-001869', NULL, 'Fimbrial chaperone protein ElfD', 80, NULL, NULL, 124116),
(124117, '3.40.50.300-FF-003180', NULL, 'Putative ABC transporter ATP-binding protein', 245, NULL, NULL, 124117),
(124118, '1.20.58.60-FF-000855', NULL, 'Uncharacterized protein', 136, NULL, NULL, 124118),
(124119, '3.30.1520.10-FF-000095', NULL, 'Rho GTPase-activating protein 33', 103, NULL, NULL, 124119),
(124120, '2.60.40.60-FF-000018', NULL, 'Protocadherin gamma c3', 109, NULL, NULL, 124120),
(124121, '3.80.10.10-FF-003258', NULL, 'Predicted protein', 170, NULL, NULL, 124121),
(124122, '3.40.950.10-FF-000030', NULL, NULL, 209, NULL, NULL, 124122),
(124123, '1.10.10.10-FF-001956', NULL, 'Uncharacterized protein', 76, NULL, NULL, 124123),
(124124, '1.10.10.2430-FF-000003', NULL, 'Uncharacterized protein', 128, NULL, NULL, 124124),
(124125, '1.10.287.810-FF-000012', NULL, 'Mitochondrial import inner membrane translocase subunit TIM13, putative', 61, NULL, NULL, 124125),
(124126, '2.60.120.200-FF-000784', NULL, 'Predicted protein', 133, NULL, NULL, 124126),
(124127, '3.40.30.10-FF-000355', NULL, 'Glutathione S-transferase U10', 91, NULL, NULL, 124127),
(124128, '3.40.140.70-FF-000019', NULL, 'Putative ubiquitin activating E1 enzyme', 167, NULL, NULL, 124128),
(124129, '3.20.20.220-FF-000023', NULL, 'Proline dehydrogenase', 140, NULL, NULL, 124129),
(124130, '1.25.40.430-FF-000028', NULL, 'Uncharacterized protein', 64, NULL, NULL, 124130),
(124131, '3.40.50.300-FF-007923', NULL, 'Uncharacterized protein', 175, NULL, NULL, 124131),
(124132, '3.30.2460.20-FF-000008', NULL, 'Protein Wnt-4', 40, NULL, NULL, 124132),
(124133, '3.40.930.10-FF-000028', NULL, 'PTS system, nitrogen regulatory IIA component', 138, NULL, NULL, 124133),
(124134, '1.10.287.1490-FF-000060', NULL, 'Phosphoinositide-3-kinase, regulatory subunit 3a (gamma)', 79, NULL, NULL, 124134),
(124135, '2.30.30.190-FF-000017', NULL, 'Pac2p', 76, NULL, NULL, 124135),
(124136, '4.10.400.20-FF-000005', NULL, 'Uncharacterized protein', 44, NULL, NULL, 124136),
(124137, '1.20.970.10-FF-000037', NULL, 'Anthranilate phosphoribosyltransferase', 68, NULL, NULL, 124137),
(124138, '2.130.10.10-FF-003651', NULL, 'Protein sof1', 91, NULL, NULL, 124138),
(124139, '3.40.630.10-FF-000011', NULL, 'cytosolic carboxypeptidase 2 isoform X1', 264, NULL, NULL, 124139),
(124140, '3.10.250.10-FF-000005', NULL, 'Neurotrypsin isoform A', 106, NULL, NULL, 124140),
(124141, '3.10.20.90-FF-000930', NULL, 'Plexin A, putative', 120, NULL, NULL, 124141),
(124142, '1.20.58.60-FF-000416', NULL, 'Spectrin repeat containing nuclear envelope family member 3', 302, NULL, NULL, 124142),
(124143, '2.40.15.10-FF-000002', NULL, 'T-cell leukemia/lymphoma protein 1A', 112, NULL, NULL, 124143),
(124144, '2.60.120.620-FF-000027', NULL, 'Oxidoreductase, 2OG-Fe(II) oxygenase family family', 211, NULL, NULL, 124144),
(124145, '1.25.40.10-FF-002897', NULL, 'Intraflagellar transport particle protein 88', 206, NULL, NULL, 124145),
(124146, '1.10.1410.20-FF-000005', NULL, 'Predicted protein', 183, NULL, NULL, 124146),
(124147, '2.60.120.10-FF-000573', NULL, 'Cyclic nucleotide-binding', 144, NULL, NULL, 124147),
(124148, '3.40.1650.10-FF-000006', NULL, 'Fucose operon FucU protein', 142, NULL, NULL, 124148),
(124149, '2.60.40.10-FF-005764', NULL, NULL, 144, NULL, NULL, 124149),
(124150, '1.10.287.70-FF-000762', NULL, 'Predicted protein', 28, NULL, NULL, 124150),
(124151, '1.25.40.10-FF-003734', NULL, 'Uncharacterized protein', 182, NULL, NULL, 124151),
(124152, '1.25.10.10-FF-000271', NULL, 'HEAT repeat-containing protein 3', 546, NULL, NULL, 124152),
(124153, '1.10.560.10-FF-000003', NULL, 'T-complex protein 1 subunit eta', 231, NULL, NULL, 124153),
(124154, '3.30.70.330-FF-001929', NULL, NULL, 188, NULL, NULL, 124154),
(124155, '3.30.420.100-FF-000030', NULL, 'Uncharacterized protein', 68, NULL, NULL, 124155),
(124156, '1.25.10.10-FF-002597', NULL, 'Uncharacterized protein', 150, NULL, NULL, 124156),
(124157, '1.10.10.10-FF-000236', NULL, 'Cell division protein FtsK', 63, NULL, NULL, 124157);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(124158, '3.40.630.30-FF-000202', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 232, NULL, NULL, 124158),
(124159, '3.30.40.10-FF-000266', NULL, 'Peroxisome assembly protein 12', 56, NULL, NULL, 124159),
(124160, '3.80.10.10-FF-004242', NULL, 'Leucine Rich Repeat family protein', 74, NULL, NULL, 124160),
(124161, '3.40.50.300-FF-005978', NULL, 'CRISPR-associated helicase Cas3', 190, NULL, NULL, 124161),
(124162, '3.30.70.660-FF-000011', NULL, 'tRNA pseudouridine synthase', 206, NULL, NULL, 124162),
(124163, '1.20.120.1900-FF-000029', NULL, 'Gamma-tubulin complex component', 299, NULL, NULL, 124163),
(124164, '2.30.29.30-FF-000568', NULL, 'Related to Stress-activated map kinase interacting protein 1', 84, NULL, NULL, 124164),
(124165, '3.30.1360.40-FF-000017', NULL, 'DNA topoisomerase 4 subunit A', 117, NULL, NULL, 124165),
(124166, '2.180.10.10-FF-000007', NULL, 'Si:ch211-12m10.1', 526, NULL, NULL, 124166),
(124167, '3.20.20.60-FF-000073', NULL, 'HpcH/HpaI aldolase/citrate lyase family, putative', 334, NULL, NULL, 124167),
(124168, '3.30.450.20-FF-000064', NULL, 'Vivid PAS protein VVD', 149, NULL, NULL, 124168),
(124169, '3.40.50.720-FF-002147', NULL, 'ATG7 autophagy-related 7 homolog (S. cerevisiae)', 89, NULL, NULL, 124169),
(124170, '1.20.120.350-FF-000102', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 127, NULL, NULL, 124170),
(124171, '2.30.30.790-FF-000017', NULL, 'Mitochondrial 54S ribosomal protein IMG1', 130, NULL, NULL, 124171),
(124172, '1.10.3260.10-FF-000030', NULL, 'Uncharacterized protein', 187, NULL, NULL, 124172),
(124173, '3.30.70.250-FF-000006', NULL, 'Malonyl CoA-acyl carrier protein transacylase', 89, NULL, NULL, 124173),
(124174, '3.40.50.150-FF-001549', NULL, NULL, 84, NULL, NULL, 124174),
(124175, '3.40.50.150-FF-001734', NULL, NULL, 174, NULL, NULL, 124175),
(124176, '3.30.200.20-FF-000400', NULL, 'Tyrosine kinase non receptor 1', 115, NULL, NULL, 124176),
(124177, '1.25.40.570-FF-000076', NULL, 'Protein CBR-CSN-2', 116, NULL, NULL, 124177),
(124178, '2.60.120.470-FF-000016', NULL, NULL, 182, NULL, NULL, 124178),
(124179, '3.40.50.300-FF-002196', NULL, 'ABC transporter B family member 5', 106, NULL, NULL, 124179),
(124180, '2.60.120.330-FF-000120', NULL, 'Uncharacterized protein', 262, NULL, NULL, 124180),
(124181, '3.30.1490.20-FF-000015', NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', 74, NULL, NULL, 124181),
(124182, '3.80.10.10-FF-002297', NULL, 'F-box/LRR-repeat protein 12', 208, NULL, NULL, 124182),
(124183, '2.120.10.90-FF-000011', NULL, 'DNA topoisomerase 4 subunit A', 216, NULL, NULL, 124183),
(124184, '3.30.40.10-FF-000761', NULL, 'Os01g0844700 protein', 83, NULL, NULL, 124184),
(124185, '3.30.930.10-FF-000368', NULL, 'Uncharacterized protein', 76, NULL, NULL, 124185),
(124186, '1.20.1510.10-FF-000058', NULL, 'Metal tolerance protein 6', 164, NULL, NULL, 124186),
(124187, '1.10.357.140-FF-000041', NULL, 'Uncharacterized protein', 88, NULL, NULL, 124187),
(124188, '1.10.8.1080-FF-000008', NULL, 'Uncharacterized protein', 28, NULL, NULL, 124188),
(124189, '3.30.40.10-FF-001250', NULL, 'Uncharacterized protein', 68, NULL, NULL, 124189),
(124190, '2.30.42.10-FF-000582', NULL, NULL, 110, NULL, NULL, 124190),
(124191, '3.80.10.10-FF-000296', NULL, 'mRNA export factor MEX67', 164, NULL, NULL, 124191),
(124192, '2.30.30.40-FF-000018', NULL, 'Brain-specific angiogenesis inhibitor 1-associated protein 2', 66, NULL, NULL, 124192),
(124193, '1.20.1050.130-FF-000044', NULL, 'Uncharacterized protein', 137, NULL, NULL, 124193),
(124194, '2.130.10.10-FF-005596', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 195, NULL, NULL, 124194),
(124195, '3.60.21.10-FF-000131', NULL, 'Serine/threonine-protein phosphatase', 341, NULL, NULL, 124195),
(124196, '3.30.40.10-FF-001722', NULL, 'E3 ubiquitin-protein ligase RNF34', 51, NULL, NULL, 124196),
(124197, '1.10.510.10-FF-002361', NULL, NULL, 185, NULL, NULL, 124197),
(124198, '1.25.40.10-FF-004403', NULL, 'Pentatricopeptide repeat-containing protein At3g21470', 136, NULL, NULL, 124198);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(124199, '2.130.10.10-FF-005124', NULL, 'Os07g0693700 protein', 156, NULL, NULL, 124199),
(124200, '2.30.30.30-FF-000021', NULL, 'DNA/RNA-binding protein KIN17, putative', 57, NULL, NULL, 124200),
(124201, '2.60.120.560-FF-000043', NULL, 'Uncharacterized protein', 56, NULL, NULL, 124201),
(124202, '3.40.50.1110-FF-000021', NULL, 'Lysophospholipase L1', 221, NULL, NULL, 124202),
(124203, '3.40.50.1820-FF-000138', NULL, 'Neuroligin-1-like Protein', 567, NULL, NULL, 124203),
(124204, '2.40.50.140-FF-000510', NULL, 'DNA-directed RNA polymerases I, II, and III subunit RPABC3', 139, NULL, NULL, 124204),
(124205, '3.40.640.10-FF-000068', NULL, 'Putative aminotransferase', 227, NULL, NULL, 124205),
(124206, '3.90.1150.10-FF-000198', NULL, 'Aminotransferase', 133, NULL, NULL, 124206),
(124207, '2.60.120.290-FF-000119', NULL, 'AGAP011909-PA', 110, NULL, NULL, 124207),
(124208, '2.30.130.10-FF-000018', NULL, 'Glutamate 5-kinase, variant', 72, NULL, NULL, 124208),
(124209, '2.10.25.10-FF-001499', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1', 34, NULL, NULL, 124209),
(124210, '2.60.40.10-FF-005579', NULL, NULL, 106, NULL, NULL, 124210),
(124211, '3.80.10.10-FF-000352', NULL, 'Erbb2 interacting protein', 113, NULL, NULL, 124211),
(124212, '1.10.150.20-FF-000290', NULL, 'DNA nucleotidylexotransferase', 60, NULL, NULL, 124212),
(124213, '2.130.10.10-FF-005652', NULL, 'Uncharacterized protein', 169, NULL, NULL, 124213),
(124214, '2.60.40.2170-FF-000008', NULL, 'Derailed 2, isoform B', 141, NULL, NULL, 124214),
(124215, '3.40.50.150-FF-000329', NULL, 'tRNA (guanine-N(7)-)-methyltransferase', 231, NULL, NULL, 124215),
(124216, '3.30.160.60-FF-001846', NULL, 'ZNF121 isoform 1', 25, NULL, NULL, 124216),
(124217, '1.20.120.340-FF-000004', NULL, 'Perilipin', 146, NULL, NULL, 124217),
(124218, '2.10.60.10-FF-000057', NULL, 'Receptor protein serine/threonine kinase', 88, NULL, NULL, 124218),
(124219, '2.30.42.10-FF-000615', NULL, NULL, 91, NULL, NULL, 124219),
(124220, '2.30.130.40-FF-000033', NULL, 'Protein cereblon', 122, NULL, NULL, 124220),
(124221, '4.10.410.10-FF-000121', NULL, 'Uncharacterized protein', 74, NULL, NULL, 124221),
(124222, '1.25.10.10-FF-000040', NULL, 'Importin subunit alpha', 424, NULL, NULL, 124222),
(124223, '6.10.140.2220-FF-000019', NULL, 'Putative MYND finger protein', 54, NULL, NULL, 124223),
(124224, '2.40.50.140-FF-000454', NULL, 'Replication factor A protein 2', 134, NULL, NULL, 124224),
(124225, '1.25.40.20-FF-001646', NULL, 'Uncharacterized protein', 90, NULL, NULL, 124225),
(124226, '1.25.40.10-FF-001172', NULL, 'Signal peptidase I', 137, NULL, NULL, 124226),
(124227, '3.90.20.20-FF-000041', NULL, 'GrpE protein homolog 2, mitochondrial', 72, NULL, NULL, 124227),
(124228, '3.40.50.1820-FF-000666', NULL, 'Alpha/beta hydrolase', 294, NULL, NULL, 124228),
(124229, '3.30.40.10-FF-000614', NULL, 'Unplaced genomic scaffold supercont2.21, whole genome shotgun sequence', 110, NULL, NULL, 124229),
(124230, '2.10.25.10-FF-001027', NULL, 'Transmembrane matrix receptor MUP-4', 45, NULL, NULL, 124230),
(124231, '3.30.70.330-FF-000592', NULL, 'CUGBP Elav-like family member 4', 88, NULL, NULL, 124231),
(124232, '3.30.420.10-FF-000138', NULL, 'DNA polymerase I', 251, NULL, NULL, 124232),
(124233, '3.10.20.30-FF-000047', NULL, 'Adenylate/guanylate cyclase catalytic domain protein', 94, NULL, NULL, 124233),
(124234, '3.40.50.12760-FF-000002', NULL, 'Cap methyltransferase 2', 366, NULL, NULL, 124234),
(124235, '2.40.50.100-FF-000021', NULL, 'DNA-binding transcriptional regulator ModE', 76, NULL, NULL, 124235),
(124236, '1.10.30.10-FF-000035', NULL, 'Maelstrom spermatogenic transposon silencer', 61, NULL, NULL, 124236),
(124237, '3.80.10.10-FF-004039', NULL, 'Uncharacterized protein', 315, NULL, NULL, 124237),
(124238, '3.10.290.20-FF-000011', NULL, 'Ubiquitin-activating enzyme E1-like', 130, NULL, NULL, 124238),
(124239, '2.30.30.170-FF-000006', NULL, 'Fibronectin binding autolysin', 70, NULL, NULL, 124239),
(124240, '3.40.50.300-FF-003269', NULL, 'ATP binding cassette subfamily G member 5', 244, NULL, NULL, 124240);
INSERT INTO "PUBLIC"."MODEL" VALUES
(124241, '1.10.10.10-FF-001017', NULL, 'LysR family transcriptional regulator', 85, NULL, NULL, 124241),
(124242, '3.40.850.10-FF-000258', NULL, 'Hypothetical_protein_-_conserved', 229, NULL, NULL, 124242),
(124243, '1.10.10.60-FF-001038', NULL, NULL, 83, NULL, NULL, 124243),
(124244, '1.10.400.10-FF-000082', NULL, 'Uncharacterized protein', 81, NULL, NULL, 124244),
(124245, '1.10.510.10-FF-001253', NULL, 'Protein kinase, putative', 204, NULL, NULL, 124245),
(124246, '3.10.200.10-FF-000002', NULL, 'Carbonic anhydrase-related protein 10', 283, NULL, NULL, 124246),
(124247, '2.60.40.1090-FF-000027', NULL, 'Fimbrial-like adhesin protein YadK', 168, NULL, NULL, 124247),
(124248, '3.30.710.10-FF-000481', NULL, 'Uncharacterized protein', 91, NULL, NULL, 124248),
(124249, '1.25.40.20-FF-001118', NULL, 'Ankyrin repeat', 208, NULL, NULL, 124249),
(124250, '1.25.40.10-FF-000660', NULL, 'Protein SLOW GREEN 1, chloroplastic', 78, NULL, NULL, 124250),
(124251, '2.60.120.260-FF-000487', NULL, 'Uncharacterized protein', 129, NULL, NULL, 124251),
(124252, '1.10.510.10-FF-004070', NULL, NULL, 189, NULL, NULL, 124252),
(124253, '1.20.58.80-FF-000046', NULL, 'Protein spartin', 93, NULL, NULL, 124253),
(124254, '2.30.110.10-FF-000074', NULL, 'Protease synthase and sporulation negative regulatory protein PAI 2', 203, NULL, NULL, 124254),
(124255, '1.10.405.10-FF-000014', NULL, 'Amine oxidase', 93, NULL, NULL, 124255),
(124256, '1.20.140.10-FF-000082', NULL, 'Acyl-coenzyme A oxidase', 141, NULL, NULL, 124256),
(124257, '1.10.245.10-FF-000012', NULL, 'Uncharacterized protein', 89, NULL, NULL, 124257),
(124258, '3.40.50.620-FF-000521', NULL, 'Isoleucine--tRNA ligase', 168, NULL, NULL, 124258),
(124259, '3.30.870.10-FF-000166', NULL, 'Tyrosyl-DNA phosphodiesterase 1', 227, NULL, NULL, 124259),
(124260, '1.10.510.10-FF-002978', NULL, NULL, 42, NULL, NULL, 124260),
(124261, '1.10.238.10-FF-000928', NULL, 'Calcium-binding allergen Ole e 8', 103, NULL, NULL, 124261),
(124262, '3.40.50.1000-FF-000336', NULL, 'Alpha,alpha-trehalose phosphate synthase subunit, putative', 131, NULL, NULL, 124262),
(124263, '3.40.50.2300-FF-000743', NULL, 'Uncharacterized protein', 267, NULL, NULL, 124263),
(124264, '3.90.226.10-FF-000246', NULL, 'Uncharacterized protein', 143, NULL, NULL, 124264),
(124265, '1.25.40.10-FF-003678', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 85, NULL, NULL, 124265),
(124266, '3.30.9.10-FF-000233', NULL, 'Uncharacterized protein', 80, NULL, NULL, 124266),
(124267, '1.20.1250.20-FF-002289', NULL, 'Uncharacterized protein', 74, NULL, NULL, 124267),
(124268, '1.20.1050.120-FF-000002', NULL, 'Fatty acid synthase subunit beta', 139, NULL, NULL, 124268),
(124269, '1.10.287.130-FF-000055', NULL, 'Two-component sensor histidine kinase', 63, NULL, NULL, 124269),
(124270, '1.25.10.10-FF-002069', NULL, 'Coatomer subunit gamma', 291, NULL, NULL, 124270),
(124271, '3.20.20.80-FF-000404', NULL, 'Alpha-L-fucosidase', 99, NULL, NULL, 124271),
(124272, '2.30.30.140-FF-000087', NULL, 'Putative ATP-dependent RNA helicase TDRD12', 77, NULL, NULL, 124272),
(124273, '2.10.220.10-FF-000131', NULL, 'Uncharacterized protein', 68, NULL, NULL, 124273),
(124274, '2.130.10.10-FF-001381', NULL, 'cleavage and polyadenylation specificity factor subunit 1', 341, NULL, NULL, 124274),
(124275, '3.30.420.40-FF-000153', NULL, 'Putative fructokinase', 107, NULL, NULL, 124275),
(124276, '3.30.40.10-FF-002267', NULL, 'TNF receptor-associated factor', 54, NULL, NULL, 124276),
(124277, '1.20.1090.10-FF-000008', NULL, '3-dehydroquinate synthase', 187, NULL, NULL, 124277),
(124278, '2.30.30.40-FF-000350', NULL, 'Sorting nexin', 70, NULL, NULL, 124278),
(124279, '1.10.510.10-FF-002029', NULL, 'Protein kinase superfamily protein', 284, NULL, NULL, 124279),
(124280, '3.30.60.30-FF-000043', NULL, 'Protein BM-40', 88, NULL, NULL, 124280),
(124281, '1.20.1250.20-FF-001800', NULL, 'Siderophore iron transporter 2', 172, NULL, NULL, 124281),
(124282, '1.10.1420.10-FF-000065', NULL, 'MutS family protein', 173, NULL, NULL, 124282),
(124283, '3.30.160.60-FF-003027', NULL, 'GDNF-inducible zinc finger protein 1', 29, NULL, NULL, 124283);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(124284, '2.170.16.10-FF-000015', NULL, 'DNA-directed RNA polymerase subunit beta', 94, NULL, NULL, 124284),
(124285, '1.10.472.10-FF-000427', NULL, 'G1 cyclin CYD-1', 63, NULL, NULL, 124285),
(124286, '3.30.70.141-FF-000047', NULL, NULL, 67, NULL, NULL, 124286),
(124287, '3.30.160.60-FF-003504', NULL, NULL, 27, NULL, NULL, 124287),
(124288, '2.40.30.10-FF-000397', NULL, 'Nitrate reductase [NAD(P)H]', 83, NULL, NULL, 124288),
(124289, '2.10.50.10-FF-000028', NULL, 'Signal peptide, CUB domain and EGF like domain containing 2', 49, NULL, NULL, 124289),
(124290, '1.10.8.10-FF-000196', NULL, 'Ubiquitin-conjugating enzyme, putative', 39, NULL, NULL, 124290),
(124291, '3.40.50.300-FF-004961', NULL, 'Uncharacterized protein', 168, NULL, NULL, 124291),
(124292, '1.10.20.10-FF-000006', NULL, 'Nuclear transcription factor Y subunit gamma', 110, NULL, NULL, 124292),
(124293, '2.20.25.10-FF-000054', NULL, 'DNA-directed RNA polymerase subunit', 53, NULL, NULL, 124293),
(124294, '3.90.70.10-FF-000131', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 318, NULL, NULL, 124294),
(124295, '3.90.640.10-FF-000107', NULL, 'Actin-57B-like Protein', 94, NULL, NULL, 124295),
(124296, '3.40.850.10-FF-000314', NULL, 'Myosin', 87, NULL, NULL, 124296),
(124297, '2.60.40.420-FF-000189', NULL, 'Uncharacterized protein', 131, NULL, NULL, 124297),
(124298, '3.30.1380.20-FF-000041', NULL, 'Uncharacterized protein', 178, NULL, NULL, 124298),
(124299, '3.40.50.300-FF-006142', NULL, 'Uncharacterized protein', 67, NULL, NULL, 124299),
(124300, '1.10.510.10-FF-003703', NULL, NULL, 164, NULL, NULL, 124300),
(124301, '3.30.160.60-FF-004808', NULL, NULL, 49, NULL, NULL, 124301),
(124302, '3.30.70.270-FF-000080', NULL, 'Bifunctional diguanylate cyclase/phosphodiesterase', 175, NULL, NULL, 124302),
(124303, '2.60.120.1040-FF-000018', NULL, NULL, 141, NULL, NULL, 124303),
(124304, '3.30.70.330-FF-002626', NULL, NULL, 126, NULL, NULL, 124304),
(124305, '3.30.70.330-FF-001424', NULL, 'RNA-binding protein, putative', 122, NULL, NULL, 124305),
(124306, '3.30.900.10-FF-000017', NULL, 'Autophagy-related protein 13', 186, NULL, NULL, 124306),
(124307, '3.30.420.10-FF-000290', NULL, 'DNA polymerase III, epsilon chain', 176, NULL, NULL, 124307),
(124308, '3.30.70.1290-FF-000004', NULL, NULL, 134, NULL, NULL, 124308),
(124309, '2.30.29.30-FF-000799', NULL, 'Rho guanine nucleotide exchange factor 25', 53, NULL, NULL, 124309),
(124310, '3.30.710.10-FF-000149', NULL, 'Blast:Protein bric-a-brac 1', 120, NULL, NULL, 124310),
(124311, '1.25.10.10-FF-000888', NULL, 'HEAT repeat domain containing protein', 243, NULL, NULL, 124311),
(124312, '2.70.130.10-FF-000021', NULL, 'Protein OS-9 homolog', 121, NULL, NULL, 124312),
(124313, '2.130.10.10-FF-001049', NULL, 'CG1109', 103, NULL, NULL, 124313),
(124314, '1.20.1270.60-FF-000127', NULL, 'Protein CBG03954', 72, NULL, NULL, 124314),
(124315, '1.20.58.60-FF-000799', NULL, 'Uncharacterized protein', 207, NULL, NULL, 124315),
(124316, '1.20.1250.20-FF-000636', NULL, 'Multidrug MFS transporter', 181, NULL, NULL, 124316),
(124317, '3.40.50.1360-FF-000011', NULL, 'Deoxyribose operon repressor', 156, NULL, NULL, 124317),
(124318, '1.10.510.10-FF-004215', NULL, NULL, 213, NULL, NULL, 124318),
(124319, '1.25.10.10-FF-000416', NULL, 'Armadillo repeat-containing protein 8', 370, NULL, NULL, 124319),
(124320, '1.20.1250.20-FF-001036', NULL, 'Monocarboxylate transporter, putative', 187, NULL, NULL, 124320),
(124321, '1.10.10.10-FF-000091', NULL, 'Cullin 3', 83, NULL, NULL, 124321),
(124322, '1.20.1560.10-FF-000909', NULL, 'Uncharacterized protein', 155, NULL, NULL, 124322),
(124323, '3.40.50.1100-FF-000220', NULL, 'Predicted protein', 40, NULL, NULL, 124323),
(124324, '3.40.50.300-FF-002488', NULL, 'Ras family GTPase (Rab4b), putative', 179, NULL, NULL, 124324),
(124325, '1.20.58.1120-FF-000057', NULL, NULL, 141, NULL, NULL, 124325),
(124326, '1.10.510.10-FF-000472', NULL, 'Receptor interacting serine/threonine kinase 1', 322, NULL, NULL, 124326),
(124327, '3.40.50.1380-FF-000017', NULL, 'Carbamoyl-phosphate synthase large chain', 126, NULL, NULL, 124327);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(124328, '2.20.25.10-FF-000110', NULL, 'Bacterial MDR-like protein', 71, NULL, NULL, 124328),
(124329, '3.40.50.1100-FF-000164', NULL, 'Uncharacterized protein', 14, NULL, NULL, 124329),
(124330, '3.90.1100.10-FF-000010', NULL, 'DNA-directed RNA polymerase subunit beta', 308, NULL, NULL, 124330),
(124331, '1.10.1420.10-FF-000121', NULL, 'MutS domain V domaincontaining protein', 192, NULL, NULL, 124331),
(124332, '3.90.320.10-FF-000004', NULL, 'Probable exonuclease V', 252, NULL, NULL, 124332),
(124333, '3.40.50.1000-FF-000191', NULL, 'Calcium-transporting ATPase', 177, NULL, NULL, 124333),
(124334, '2.60.40.10-FF-001633', NULL, 'Uncharacterized protein, isoform A', 99, NULL, NULL, 124334),
(124335, '3.90.850.10-FF-000033', NULL, NULL, 209, NULL, NULL, 124335),
(124336, '3.40.630.30-FF-000433', NULL, 'Cilia- and flagella-associated protein 61', 115, NULL, NULL, 124336),
(124337, '1.10.8.60-FF-000222', NULL, 'Replication factor C, subunit 2', 64, NULL, NULL, 124337),
(124338, '3.10.20.90-FF-000402', NULL, 'Ubiquitin-like protein DSK2', 86, NULL, NULL, 124338),
(124339, '1.20.1250.20-FF-000108', NULL, 'Monosaccharide-sensing protein 2', 250, NULL, NULL, 124339),
(124340, '2.130.10.10-FF-003235', NULL, 'Uncharacterized protein', 254, NULL, NULL, 124340),
(124341, '2.40.50.1060-FF-000001', NULL, 'Twist neighbor protein', 192, NULL, NULL, 124341),
(124342, '3.80.10.10-FF-001128', NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At2g16250', 132, NULL, NULL, 124342),
(124343, '1.25.10.10-FF-001288', NULL, 'Proteasome activator complex subunit 4', 222, NULL, NULL, 124343),
(124344, '2.60.40.10-FF-005472', NULL, NULL, 102, NULL, NULL, 124344),
(124345, '3.30.1360.140-FF-000008', NULL, 'DNA-directed RNA polymerase subunit', 137, NULL, NULL, 124345),
(124346, '2.130.10.10-FF-001757', NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', 252, NULL, NULL, 124346),
(124347, '2.40.70.10-FF-000051', NULL, 'Putative aspartic protease', 192, NULL, NULL, 124347),
(124348, '3.50.50.60-FF-000803', NULL, 'Monooxygenase', 250, NULL, NULL, 124348),
(124349, '3.40.140.100-FF-000003', NULL, 'Autophagy ubiquitin-activating enzyme ApgG', 156, NULL, NULL, 124349),
(124350, '2.30.29.30-FF-001260', NULL, 'Phosphoinositide phospholipase C', 105, NULL, NULL, 124350),
(124351, '2.130.10.10-FF-003943', NULL, 'Uncharacterized protein', 249, NULL, NULL, 124351),
(124352, '3.40.50.300-FF-005686', NULL, 'L-seryl-tRNA(Sec) kinase', 184, NULL, NULL, 124352),
(124353, '1.10.10.60-FF-001190', NULL, NULL, 90, NULL, NULL, 124353),
(124354, '1.25.40.10-FF-001880', NULL, 'Protein kinase', 146, NULL, NULL, 124354),
(124355, '2.60.120.10-FF-000281', NULL, 'Crp/Fnr family transcriptional regulator', 129, NULL, NULL, 124355),
(124356, '1.50.40.10-FF-000360', NULL, 'Mitochondrial carrier domain-containing protein', 166, NULL, NULL, 124356),
(124357, '4.10.400.10-FF-000351', NULL, 'Uncharacterized protein', 33, NULL, NULL, 124357),
(124358, '3.40.720.10-FF-000069', NULL, 'Phosphate starvation-inducible protein PsiE', 303, NULL, NULL, 124358),
(124359, '2.30.29.30-FF-001108', NULL, 'Uncharacterized protein', 145, NULL, NULL, 124359),
(124360, '3.80.10.10-FF-003786', NULL, 'Uncharacterized protein', 99, NULL, NULL, 124360),
(124361, '1.25.10.10-FF-002125', NULL, 'Gamma-adaptin', 76, NULL, NULL, 124361),
(124362, '1.20.58.1120-FF-000001', NULL, 'dynein heavy chain 2, axonemal', 139, NULL, NULL, 124362),
(124363, '1.10.510.10-FF-003142', NULL, NULL, 181, NULL, NULL, 124363),
(124364, '2.10.230.10-FF-000008', NULL, 'Apj1p', 64, NULL, NULL, 124364),
(124365, '1.25.40.20-FF-000865', NULL, 'Ankyrin-like with transmembrane domains protein 1', 98, NULL, NULL, 124365),
(124366, '3.40.50.1010-FF-000137', NULL, NULL, 141, NULL, NULL, 124366),
(124367, '2.60.120.260-FF-000543', NULL, 'Uncharacterized protein', 66, NULL, NULL, 124367),
(124368, '3.30.450.20-FF-000295', NULL, 'GGDEF family protein', 132, NULL, NULL, 124368),
(124369, '3.90.1600.10-FF-000008', NULL, 'DNA polymerase', 173, NULL, NULL, 124369),
(124370, '3.90.470.20-FF-000052', NULL, 'Probable phosphopantetheinyltransferase', 109, NULL, NULL, 124370);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(124371, '3.80.10.10-FF-001460', NULL, 'Jetlag, isoform A', 91, NULL, NULL, 124371),
(124372, '1.50.40.10-FF-000208', NULL, 'Mitochondrial ornithine carrier protein', 153, NULL, NULL, 124372),
(124373, '3.30.559.10-FF-000139', NULL, 'Putative alcohol O-acetyltransferase', 225, NULL, NULL, 124373),
(124374, '3.30.67.10-FF-000002', NULL, 'Envelope glycoprotein', 71, NULL, NULL, 124374),
(124375, '3.40.50.920-FF-000021', NULL, 'Unplaced genomic scaffold supercont2.7, whole genome shotgun sequence', 148, NULL, NULL, 124375),
(124376, '2.60.120.1000-FF-000001', NULL, 'Collagen alpha-1 type I chain', 237, NULL, NULL, 124376),
(124377, '3.30.230.10-FF-000308', NULL, 'DNA topoisomerase 2', 123, NULL, NULL, 124377),
(124378, '3.40.50.300-FF-007867', NULL, 'ATP-dependent DNA helicase Hel308', 208, NULL, NULL, 124378),
(124379, '3.40.50.11860-FF-000007', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase', 101, NULL, NULL, 124379),
(124380, '4.10.640.10-FF-000037', NULL, 'Uncharacterized protein', 45, NULL, NULL, 124380),
(124381, '3.30.40.10-FF-000558', NULL, 'Cellulose synthase', 92, NULL, NULL, 124381),
(124382, '2.120.10.30-FF-000364', NULL, 'Uncharacterized protein', 198, NULL, NULL, 124382),
(124383, '3.40.50.1820-FF-000290', NULL, 'Alpha/Beta hydrolase protein', 282, NULL, NULL, 124383),
(124384, '3.10.105.10-FF-000045', NULL, 'ABC transporter, periplasmic component', 238, NULL, NULL, 124384),
(124385, '3.40.50.10190-FF-000147', NULL, 'DNA ligase', 141, NULL, NULL, 124385),
(124386, '3.90.1520.10-FF-000007', NULL, 'Soluble guanylate cyclase 88E', 188, NULL, NULL, 124386),
(124387, '1.10.510.10-FF-001197', NULL, 'Serine/threonine protein kinase', 367, NULL, NULL, 124387),
(124388, '2.80.10.50-FF-000063', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 136, NULL, NULL, 124388),
(124389, '3.30.160.60-FF-004432', NULL, NULL, 34, NULL, NULL, 124389),
(124390, '3.30.190.20-FF-000021', NULL, 'Uncharacterized protein', 75, NULL, NULL, 124390),
(124391, '2.40.30.110-FF-000019', NULL, NULL, 76, NULL, NULL, 124391),
(124392, '3.40.50.300-FF-004433', NULL, 'LP07781p', 165, NULL, NULL, 124392),
(124393, '3.40.50.300-FF-006759', NULL, 'Uncharacterized protein', 65, NULL, NULL, 124393),
(124394, '1.25.40.10-FF-000188', NULL, 'adenosine monophosphate-protein transferase FICD', 101, NULL, NULL, 124394),
(124395, '1.10.510.10-FF-001961', NULL, 'Uncharacterized protein', 241, NULL, NULL, 124395),
(124396, '3.90.70.10-FF-000187', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 206, NULL, NULL, 124396),
(124397, '3.90.550.10-FF-000336', NULL, 'Glycosyltransferase 25 family member', 211, NULL, NULL, 124397),
(124398, '2.130.10.10-FF-006052', NULL, 'Chromosome 7, whole genome shotgun sequence', 171, NULL, NULL, 124398),
(124399, '3.40.50.300-FF-003977', NULL, 'Guanine nucleotide-binding protein G(q) subunit alpha', 207, NULL, NULL, 124399),
(124400, '3.10.20.90-FF-000082', NULL, 'Tyrosine-protein phosphatase non-receptor type 13', 94, NULL, NULL, 124400),
(124401, '1.25.40.20-FF-001826', NULL, 'Transient receptor potential cation channel subfamily V member 2', 301, NULL, NULL, 124401),
(124402, '1.20.5.1180-FF-000002', NULL, 'Centrosomal protein of 55 kDa', 62, NULL, NULL, 124402),
(124403, '2.120.10.30-FF-000420', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 173, NULL, NULL, 124403),
(124404, '1.10.150.190-FF-000001', NULL, 'Eukaryotic translation initiation factor 2 subunit 1', 92, NULL, NULL, 124404),
(124405, '2.60.40.10-FF-000144', NULL, 'receptor-type tyrosine-protein phosphatase delta isoform X1', 85, NULL, NULL, 124405),
(124406, '2.20.100.10-FF-000154', NULL, 'GD10853', 56, NULL, NULL, 124406),
(124407, '1.10.10.10-FF-001669', NULL, 'Transcriptional regulator MarR family', 138, NULL, NULL, 124407),
(124408, '1.20.1560.10-FF-000533', NULL, 'ABC multidrug transporter (Eurofung)', 11, NULL, NULL, 124408),
(124409, '3.30.70.1440-FF-000015', NULL, NULL, 106, NULL, NULL, 124409),
(124410, '2.130.10.10-FF-000453', NULL, 'Telomerase Cajal body protein 1', 183, NULL, NULL, 124410),
(124411, '3.30.2280.10-FF-000002', NULL, 'Clustered mitochondria protein homolog', 96, NULL, NULL, 124411);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(124412, '3.30.160.60-FF-002302', NULL, 'Zinc finger protein 517', 26, NULL, NULL, 124412),
(124413, '2.20.100.10-FF-000007', NULL, 'Thrombospondin 1', 56, NULL, NULL, 124413),
(124414, '3.40.50.2300-FF-000035', NULL, 'metabotropic glutamate receptor 1 isoform X1', 156, NULL, NULL, 124414),
(124415, '3.30.40.10-FF-001486', NULL, 'LD46221p', 82, NULL, NULL, 124415),
(124416, '1.10.275.20-FF-000017', NULL, NULL, 60, NULL, NULL, 124416),
(124417, '1.25.40.180-FF-000026', NULL, 'Regulator of nonsense transcripts UPF2', 239, NULL, NULL, 124417),
(124418, '3.30.420.10-FF-000610', NULL, NULL, 181, NULL, NULL, 124418),
(124419, '1.10.287.70-FF-000531', NULL, 'Potassium channel, KvQLT family', 119, NULL, NULL, 124419),
(124420, '3.30.200.20-FF-001092', NULL, 'Cyclin dependent kinase 9', 56, NULL, NULL, 124420),
(124421, '1.10.510.10-FF-001433', NULL, 'Protein CBG20555', 199, NULL, NULL, 124421),
(124422, '3.40.50.10810-FF-000018', NULL, 'Putative DNA excision repair protein ERCC-6', 271, NULL, NULL, 124422),
(124423, '3.40.50.1820-FF-001066', NULL, 'Uncharacterized protein', 117, NULL, NULL, 124423),
(124424, '3.30.160.60-FF-002246', NULL, 'Uncharacterized protein', 29, NULL, NULL, 124424),
(124425, '3.40.50.300-FF-004197', NULL, 'Guanylate kinase', 113, NULL, NULL, 124425),
(124426, '1.10.472.10-FF-000051', NULL, 'Retinoblastoma-like 2, isoform CRA_a', 178, NULL, NULL, 124426),
(124427, '2.40.50.590-FF-000004', NULL, 'DNA polymerase', 67, NULL, NULL, 124427),
(124428, '4.10.1060.10-FF-000023', NULL, 'Ran-binding zinc finger protein', 38, NULL, NULL, 124428),
(124429, '1.10.287.70-FF-000475', NULL, 'Uncharacterized protein', 65, NULL, NULL, 124429),
(124430, '1.10.3450.40-FF-000020', NULL, NULL, 182, NULL, NULL, 124430),
(124431, '1.25.10.10-FF-002833', NULL, 'Transportin MOS14', 185, NULL, NULL, 124431),
(124432, '1.10.510.10-FF-002181', NULL, NULL, 90, NULL, NULL, 124432),
(124433, '3.10.105.10-FF-000101', NULL, 'ABC-type dipeptide transport system periplasmic component', 221, NULL, NULL, 124433),
(124434, '2.60.40.10-FF-004359', NULL, NULL, 99, NULL, NULL, 124434),
(124435, '2.130.10.10-FF-004871', NULL, 'Predicted protein', 121, NULL, NULL, 124435),
(124436, '2.130.10.10-FF-004668', NULL, 'WD repeat-containing protein JIP5', 185, NULL, NULL, 124436),
(124437, '2.60.120.290-FF-000086', NULL, 'LOW QUALITY PROTEIN: putative DMBT1-like protein', 53, NULL, NULL, 124437),
(124438, '3.40.50.1820-FF-001594', NULL, 'Uncharacterized protein', 87, NULL, NULL, 124438),
(124439, '3.30.200.20-FF-000872', NULL, 'Serine/threonine protein kinase', 40, NULL, NULL, 124439),
(124440, '2.60.120.200-FF-000368', NULL, 'Adhesion G protein-coupled receptor D1', 257, NULL, NULL, 124440),
(124441, '3.40.190.10-FF-000763', NULL, 'Predicted protein', 168, NULL, NULL, 124441),
(124442, '3.30.40.210-FF-000005', NULL, 'Transcription elongation factor SPT4', 107, NULL, NULL, 124442),
(124443, '1.20.144.10-FF-000051', NULL, 'Phospholipid phosphatase homolog 1.2 homolog', 222, NULL, NULL, 124443),
(124444, '1.20.5.190-FF-000100', NULL, NULL, 51, NULL, NULL, 124444),
(124445, '3.40.50.800-FF-000131', NULL, 'Uncharacterized protein', 76, NULL, NULL, 124445),
(124446, '3.60.40.10-FF-000338', NULL, 'Uncharacterized protein', 134, NULL, NULL, 124446),
(124447, '3.50.50.60-FF-000770', NULL, 'Flavin-containing monooxygenase', 33, NULL, NULL, 124447),
(124448, '3.70.10.10-FF-000049', NULL, 'DNA polymerase III subunit beta', 195, NULL, NULL, 124448),
(124449, '1.20.1410.10-FF-000017', NULL, 'Os05g0554500 protein', 193, NULL, NULL, 124449),
(124450, '3.30.160.60-FF-006141', NULL, NULL, 65, NULL, NULL, 124450),
(124451, '1.20.1420.30-FF-000001', NULL, 'sodium/calcium exchanger 1 isoform X1', 130, NULL, NULL, 124451),
(124452, '3.40.20.10-FF-000057', NULL, 'Gelsolin, isoform A', 117, NULL, NULL, 124452),
(124453, '2.60.60.20-FF-000041', NULL, NULL, 100, NULL, NULL, 124453),
(124454, '1.25.10.10-FF-002305', NULL, 'mRNA cleavage and polyadenylation specificity factor complex subunit pta1', 321, NULL, NULL, 124454),
(124455, '3.30.420.610-FF-000003', NULL, 'Meiosis regulator and mRNA stability factor 1', 71, NULL, NULL, 124455);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(124456, '2.10.25.10-FF-000774', NULL, 'von Willebrand factor D and EGF domains', 37, NULL, NULL, 124456),
(124457, '3.20.20.150-FF-000070', NULL, 'Uncharacterized protein', 182, NULL, NULL, 124457),
(124458, '3.40.50.80-FF-000006', NULL, 'Dual oxidase 2', 179, NULL, NULL, 124458),
(124459, '3.30.470.20-FF-000150', NULL, 'Uncharacterized protein', 217, NULL, NULL, 124459),
(124460, '1.10.630.10-FF-000071', NULL, 'Cytochrome P450 703A2', 493, NULL, NULL, 124460),
(124461, '3.30.1640.10-FF-000042', NULL, 'DNA replication licensing factor MCM7', 96, NULL, NULL, 124461),
(124462, '1.20.1730.10-FF-000041', NULL, 'sodium/glucose cotransporter 5-like', 513, NULL, NULL, 124462),
(124463, '3.20.10.10-FF-000074', NULL, 'Predicted protein', 75, NULL, NULL, 124463),
(124464, '3.40.50.300-FF-005158', NULL, 'Predicted protein', 226, NULL, NULL, 124464),
(124465, '1.10.472.130-FF-000034', NULL, 'Dynein beta chain, flagellar outer arm', 147, NULL, NULL, 124465),
(124466, '2.160.20.10-FF-000115', NULL, 'Polygalacturonase', 379, NULL, NULL, 124466),
(124467, '2.130.10.10-FF-005091', NULL, 'Uncharacterized protein', 259, NULL, NULL, 124467),
(124468, '3.30.830.10-FF-000276', NULL, 'Phosphoglycan beta 1,3 galactosyltransferase 5', 229, NULL, NULL, 124468),
(124469, '3.40.1050.10-FF-000005', NULL, 'Carbonic anhydrase', 181, NULL, NULL, 124469),
(124470, '3.30.230.70-FF-000102', NULL, 'Exosome complex exonuclease RRP42', 92, NULL, NULL, 124470),
(124471, '2.60.40.60-FF-000967', NULL, 'Predicted protein', 45, NULL, NULL, 124471),
(124472, '4.10.860.120-FF-000003', NULL, 'DNA-directed RNA polymerase subunit', 125, NULL, NULL, 124472),
(124473, '3.40.50.1110-FF-000077', NULL, 'Uncharacterized protein', 220, NULL, NULL, 124473),
(124474, '3.50.50.60-FF-000567', NULL, 'Paromamine 6''-oxidase', 91, NULL, NULL, 124474),
(124475, '1.10.3730.20-FF-000047', NULL, 'EamA/RhaT family transporter', 103, NULL, NULL, 124475),
(124476, '1.25.40.10-FF-001733', NULL, 'Os04g0218100 protein', 100, NULL, NULL, 124476),
(124477, '1.10.630.10-FF-000447', NULL, 'Premnaspirodiene oxygenase', 169, NULL, NULL, 124477),
(124478, '1.25.40.10-FF-004459', NULL, 'Tetratricopeptide repeat protein 30 homolog', 112, NULL, NULL, 124478),
(124479, '3.90.190.10-FF-000617', NULL, 'LD15107p', 84, NULL, NULL, 124479),
(124480, '2.60.40.150-FF-000052', NULL, 'RAS p21 protein activator 1', 128, NULL, NULL, 124480),
(124481, '2.30.29.30-FF-000855', NULL, 'MMS19 nucleotide excision repair protein-like protein', 52, NULL, NULL, 124481),
(124482, '3.30.160.20-FF-000137', NULL, 'Putative RNase III', 70, NULL, NULL, 124482),
(124483, '1.10.443.10-FF-000006', NULL, 'Prophage integrase IntS', 181, NULL, NULL, 124483),
(124484, '3.90.1150.10-FF-000485', NULL, 'Uncharacterized protein', 57, NULL, NULL, 124484),
(124485, '3.30.1550.10-FF-000012', NULL, 'Probable 39S ribosomal protein L11, mitochondrial', 66, NULL, NULL, 124485),
(124486, '2.10.25.10-FF-000251', NULL, 'sushi, nidogen and EGF-like domain-containing protein 1', 39, NULL, NULL, 124486),
(124487, '1.10.2000.10-FF-000067', NULL, NULL, 125, NULL, NULL, 124487),
(124488, '3.40.50.170-FF-000015', NULL, 'Putative methionyl-tRNA formyltransferase', 210, NULL, NULL, 124488),
(124489, '3.40.50.1220-FF-000054', NULL, 'Putative acetolactate synthase IlvG', 152, NULL, NULL, 124489),
(124490, '3.80.10.10-FF-001280', NULL, 'Leucine rich repeats and immunoglobulin like domains 2', 143, NULL, NULL, 124490),
(124491, '3.30.1340.10-FF-000002', NULL, 'PTS phosphocarrier protein NPr', 85, NULL, NULL, 124491),
(124492, '1.10.8.270-FF-000082', NULL, 'TBC domain containing protein', 104, NULL, NULL, 124492),
(124493, '1.20.5.110-FF-000262', NULL, 'Vesicle-associated membrane protein 7b', 108, NULL, NULL, 124493),
(124494, '3.30.1360.70-FF-000032', NULL, NULL, 104, NULL, NULL, 124494),
(124495, '2.20.50.20-FF-000003', NULL, 'Microsomal triglyceride transfer protein large subunit', 94, NULL, NULL, 124495),
(124496, '1.10.8.60-FF-000042', NULL, '4-hydroxy-2-oxovalerate aldolase', 63, NULL, NULL, 124496),
(124497, '3.30.2440.10-FF-000004', NULL, 'Type III secretion system effector SopD2', 119, NULL, NULL, 124497);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(124498, '3.90.1150.10-FF-000518', NULL, 'Uncharacterized protein', 75, NULL, NULL, 124498),
(124499, '3.30.830.10-FF-000309', NULL, 'Uncharacterized protein', 94, NULL, NULL, 124499),
(124500, '3.40.1180.10-FF-000009', NULL, 'Alkyl transferase', 103, NULL, NULL, 124500),
(124501, '1.20.1250.20-FF-001564', NULL, 'Predicted protein', 530, NULL, NULL, 124501),
(124502, '1.10.150.650-FF-000004', NULL, 'PHP domain protein', 73, NULL, NULL, 124502),
(124503, '1.10.10.250-FF-000017', NULL, 'Uncharacterized protein', 84, NULL, NULL, 124503),
(124504, '3.30.160.60-FF-005736', NULL, NULL, 31, NULL, NULL, 124504),
(124505, '3.40.50.300-FF-007687', NULL, 'Predicted protein', 110, NULL, NULL, 124505),
(124506, '2.130.10.10-FF-003179', NULL, 'Uncharacterized protein', 148, NULL, NULL, 124506),
(124507, '3.40.50.2020-FF-000018', NULL, 'Phosphoribosyl pyrophosphate synthase-associated protein 2', 147, NULL, NULL, 124507),
(124508, '2.60.40.2560-FF-000002', NULL, 'Serine/threonine protein kinase', 81, NULL, NULL, 124508),
(124509, '3.90.1310.10-FF-000020', NULL, 'Cell division protein/Peptidoglycan synthetase', 198, NULL, NULL, 124509),
(124510, '1.10.510.10-FF-004159', NULL, NULL, 198, NULL, NULL, 124510),
(124511, '3.40.1000.10-FF-000002', NULL, 'Protein dcrB', 138, NULL, NULL, 124511),
(124512, '1.10.287.610-FF-000008', NULL, 'Apicoplast ribosomal protein S2', 49, NULL, NULL, 124512),
(124513, '3.40.350.10-FF-000057', NULL, 'xaa-Pro aminopeptidase 1', 151, NULL, NULL, 124513),
(124514, '1.25.40.770-FF-000017', NULL, 'Uncharacterized protein', 196, NULL, NULL, 124514),
(124515, '1.25.40.10-FF-002661', NULL, 'Uncharacterized protein', 307, NULL, NULL, 124515),
(124516, '3.30.70.360-FF-000039', NULL, 'Vacuolar carboxypeptidase Cps1, putative (AFU_orthologue AFUA_3G07040)', 134, NULL, NULL, 124516),
(124517, '3.30.200.20-FF-001653', NULL, 'STE20-related kinase adapter protein alpha isoform X2', 87, NULL, NULL, 124517),
(124518, '1.10.510.10-FF-001809', NULL, 'Serine/threonine protein kinase-41', 211, NULL, NULL, 124518),
(124519, '1.10.1070.11-FF-000084', NULL, 'Phosphatidylinositol 3-kinase, putative', 183, NULL, NULL, 124519),
(124520, '3.40.1370.10-FF-000024', NULL, '50S ribosomal protein L4', 208, NULL, NULL, 124520),
(124521, '3.40.50.2300-FF-001339', NULL, NULL, 73, NULL, NULL, 124521),
(124522, '1.10.3200.20-FF-000018', NULL, NULL, 94, NULL, NULL, 124522),
(124523, '2.10.25.10-FF-000195', NULL, 'versican core protein-like', 38, NULL, NULL, 124523),
(124524, '3.80.10.10-FF-002241', NULL, 'Receptor like protein 29', 241, NULL, NULL, 124524),
(124525, '3.40.1000.30-FF-000008', NULL, 'Uncharacterized protein, isoform H', 196, NULL, NULL, 124525),
(124526, '1.10.2020.20-FF-000015', NULL, NULL, 126, NULL, NULL, 124526),
(124527, '3.30.160.60-FF-001470', NULL, 'zinc finger protein 699 isoform X2', 27, NULL, NULL, 124527),
(124528, '2.60.40.10-FF-003578', NULL, NULL, 91, NULL, NULL, 124528),
(124529, '3.60.90.10-FF-000021', NULL, 'S-adenosylmethionine decarboxylase proenzyme', 191, NULL, NULL, 124529),
(124530, '3.40.50.300-FF-001471', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 252, NULL, NULL, 124530),
(124531, '2.130.10.10-FF-000829', NULL, 'Polyadenylation factor subunit 2, putative', 92, NULL, NULL, 124531),
(124532, '3.40.50.300-FF-005922', NULL, 'ATP-binding cassette (ABC) transporter, putative', 315, NULL, NULL, 124532),
(124533, '3.60.20.10-FF-000016', NULL, 'Proteasome subunit alpha type-6', 232, NULL, NULL, 124533),
(124534, '3.30.1360.120-FF-000093', NULL, 'Uncharacterized protein aq_2005', 141, NULL, NULL, 124534),
(124535, '3.40.190.10-FF-000578', NULL, 'ABC transporter peptide-binding protein', 257, NULL, NULL, 124535),
(124536, '3.40.50.410-FF-000340', NULL, 'Anthrax toxin receptor', 140, NULL, NULL, 124536),
(124537, '1.25.50.20-FF-000074', NULL, 'Aminopeptidase', 262, NULL, NULL, 124537),
(124538, '2.130.10.10-FF-004163', NULL, 'Protein CBG20697', 170, NULL, NULL, 124538),
(124539, '3.40.50.720-FF-001422', NULL, 'Uncharacterized protein', 145, NULL, NULL, 124539);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(124540, '3.30.160.60-FF-000357', NULL, 'GLIS family zinc finger 2', 29, NULL, NULL, 124540),
(124541, '3.30.70.340-FF-000033', NULL, NULL, 65, NULL, NULL, 124541),
(124542, '3.40.50.2300-FF-001524', NULL, NULL, 84, NULL, NULL, 124542),
(124543, '1.10.418.10-FF-000173', NULL, 'Gelation factor', 112, NULL, NULL, 124543),
(124544, '3.40.718.10-FF-000041', NULL, 'Isocitrate dehydrogenase [NAD] subunit, mitochondrial', 344, NULL, NULL, 124544),
(124545, '3.40.50.300-FF-000543', NULL, 'Dynein axonemal heavy chain 5', 216, NULL, NULL, 124545),
(124546, '3.30.450.60-FF-000025', NULL, 'Coatomer subunit zeta, putative', 178, NULL, NULL, 124546),
(124547, '3.60.20.10-FF-000163', NULL, NULL, 227, NULL, NULL, 124547),
(124548, '3.40.50.2300-FF-001671', NULL, NULL, 165, NULL, NULL, 124548),
(124549, '4.10.400.10-FF-000295', NULL, 'Low-density lipoprotein receptor, putative', 40, NULL, NULL, 124549),
(124550, '1.20.1560.10-FF-000680', NULL, 'Uncharacterized protein TagB', 16, NULL, NULL, 124550),
(124551, '1.10.287.1490-FF-000149', NULL, 'Low-CO2-inducible protein', 203, NULL, NULL, 124551),
(124552, '2.60.40.10-FF-003055', NULL, 'GM25453', 93, NULL, NULL, 124552),
(124553, '2.60.40.10-FF-000705', NULL, 'Plexin B1', 89, NULL, NULL, 124553),
(124554, '2.30.30.140-FF-000143', NULL, 'SAGA-associated factor 29', 84, NULL, NULL, 124554),
(124555, '2.30.39.10-FF-000147', NULL, 'Uncharacterized protein', 142, NULL, NULL, 124555),
(124556, '3.90.1580.10-FF-000039', NULL, 'Chaperonin containing TCP1 subunit 6A', 112, NULL, NULL, 124556),
(124557, '3.40.50.300-FF-005214', NULL, 'Iron(III)-transport ATP-binding protein sfuC', 209, NULL, NULL, 124557),
(124558, '3.30.160.60-FF-005921', NULL, NULL, 28, NULL, NULL, 124558),
(124559, '1.25.40.1010-FF-000019', NULL, 'Tetratricopeptide repeat (TPR)-containing protein', 60, NULL, NULL, 124559),
(124560, '3.30.2360.10-FF-000003', NULL, 'Uncharacterized protein', 82, NULL, NULL, 124560),
(124561, '3.30.230.80-FF-000015', NULL, 'Histidine kinase', 155, NULL, NULL, 124561),
(124562, '1.10.10.60-FF-000442', NULL, 'DNA methyltransferase 1-associated protein 1', 90, NULL, NULL, 124562),
(124563, '1.10.10.60-FF-000818', NULL, 'Zinc fingers and homeoboxes 3', 83, NULL, NULL, 124563),
(124564, '3.40.250.10-FF-000257', NULL, 'Uncharacterized protein', 57, NULL, NULL, 124564),
(124565, '3.40.50.2000-FF-000535', NULL, 'Uncharacterized protein', 98, NULL, NULL, 124565),
(124566, '3.50.50.60-FF-001023', NULL, 'Rab proteins geranylgeranyltransferase component A', 131, NULL, NULL, 124566),
(124567, '2.120.10.80-FF-000154', NULL, 'Blast:Kelch-like protein 18', 128, NULL, NULL, 124567),
(124568, '3.20.20.190-FF-000143', NULL, NULL, 87, NULL, NULL, 124568),
(124569, '3.30.505.50-FF-000004', NULL, 'Dormancy associated translation inhibitor', 47, NULL, NULL, 124569),
(124570, '2.20.100.10-FF-000098', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 7', 49, NULL, NULL, 124570),
(124571, '3.40.50.2300-FF-000563', NULL, 'Receptor-type guanylate cyclase gcy-4', 200, NULL, NULL, 124571),
(124572, '3.30.1490.180-FF-000015', NULL, 'DNA-directed RNA polymerase subunit', 53, NULL, NULL, 124572),
(124573, '3.30.160.60-FF-001318', NULL, 'zinc finger protein 641', 33, NULL, NULL, 124573),
(124574, '1.10.1070.11-FF-000117', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', 125, NULL, NULL, 124574),
(124575, '3.90.920.10-FF-000005', NULL, 'DNA primase', 409, NULL, NULL, 124575),
(124576, '3.80.10.10-FF-002617', NULL, 'Uncharacterized protein', 212, NULL, NULL, 124576),
(124577, '3.80.10.10-FF-002802', NULL, 'At5g27920', 144, NULL, NULL, 124577),
(124578, '3.30.70.330-FF-000120', NULL, 'Negative regulator of differentiation 1', 93, NULL, NULL, 124578),
(124579, '1.25.10.10-FF-001344', NULL, 'Uncharacterized protein CaJ7.0091', 333, NULL, NULL, 124579),
(124580, '2.60.40.10-FF-005000', NULL, NULL, 106, NULL, NULL, 124580),
(124581, '1.10.238.10-FF-001148', NULL, 'Ras-related protein', 209, NULL, NULL, 124581),
(124582, '3.40.50.300-FF-000919', NULL, 'Midasin', 159, NULL, NULL, 124582);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(124583, '1.50.40.10-FF-000175', NULL, 'Mitochondrial carrier protein, putative', 94, NULL, NULL, 124583),
(124584, '3.90.550.10-FF-000224', NULL, 'Probable molybdenum cofactor guanylyltransferase', 189, NULL, NULL, 124584),
(124585, '2.60.40.10-FF-002206', NULL, 'V-set and immunoglobulin domain containing 10 like', 80, NULL, NULL, 124585),
(124586, '1.10.8.270-FF-000166', NULL, 'Uncharacterized protein', 80, NULL, NULL, 124586),
(124587, '2.40.50.140-FF-000802', NULL, NULL, 152, NULL, NULL, 124587),
(124588, '2.30.29.30-FF-000355', NULL, 'protein SPIRRIG isoform X1', 105, NULL, NULL, 124588),
(124589, '1.20.120.980-FF-000061', NULL, 'Uncharacterized protein', 12, NULL, NULL, 124589),
(124590, '2.10.25.10-FF-000695', NULL, 'Plasminogen activator', 41, NULL, NULL, 124590),
(124591, '3.40.50.10090-FF-000027', NULL, 'Uroporphyrinogen-III synthase', 88, NULL, NULL, 124591),
(124592, '2.40.240.10-FF-000058', NULL, 'Uncharacterized protein', 82, NULL, NULL, 124592),
(124593, '2.30.30.380-FF-000075', NULL, 'Chromosome 7, whole genome shotgun sequence', 51, NULL, NULL, 124593),
(124594, '1.20.140.150-FF-000086', NULL, 'uncharacterized protein LOC100186803', 119, NULL, NULL, 124594),
(124595, '3.30.70.1590-FF-000009', NULL, NULL, 50, NULL, NULL, 124595),
(124596, '3.40.50.1820-FF-000907', NULL, 'Lipase member H-like Protein', 285, NULL, NULL, 124596),
(124597, '3.30.70.3460-FF-000003', NULL, 'Heme d1 biosynthesis protein NirL', 141, NULL, NULL, 124597),
(124598, '3.30.750.24-FF-000086', NULL, 'RNA recognition motif-containing protein RRM', 153, NULL, NULL, 124598),
(124599, '3.30.70.330-FF-000356', NULL, 'Translation initiation factor 4B', 95, NULL, NULL, 124599),
(124600, '1.20.5.990-FF-000008', NULL, 'Uncharacterized protein', 71, NULL, NULL, 124600),
(124601, '1.10.20.10-FF-000153', NULL, 'histone H3-like centromeric protein A isoform X2', 44, NULL, NULL, 124601),
(124602, '1.25.10.10-FF-001428', NULL, 'AGAP000770-PA-like protein', 204, NULL, NULL, 124602),
(124603, '3.40.50.300-FF-001004', NULL, 'DNA excision repair protein ERCC-6-like isoform X1', 301, NULL, NULL, 124603),
(124604, '3.40.50.2300-FF-001440', NULL, NULL, 76, NULL, NULL, 124604),
(124605, '2.130.10.10-FF-003758', NULL, 'Uncharacterized protein', 324, NULL, NULL, 124605),
(124606, '3.30.230.130-FF-000046', NULL, 'Cullin-5', 172, NULL, NULL, 124606),
(124607, '3.30.160.20-FF-000132', NULL, 'Peptide chain release factor H', 105, NULL, NULL, 124607),
(124608, '3.30.160.60-FF-003263', NULL, 'Zinc finger protein 479', 37, NULL, NULL, 124608),
(124609, '1.10.10.10-FF-001748', NULL, 'GntR family transcriptional regulator', 81, NULL, NULL, 124609),
(124610, '3.30.1130.10-FF-000025', NULL, 'Predicted protein', 33, NULL, NULL, 124610),
(124611, '1.20.1600.10-FF-000032', NULL, 'Outer membrane efflux protein', 414, NULL, NULL, 124611),
(124612, '3.90.190.10-FF-000241', NULL, 'Protein tyrosine phosphatase domain-containing protein 1', 76, NULL, NULL, 124612),
(124613, '3.40.50.720-FF-000961', NULL, '4-hydroxy-tetrahydrodipicolinate reductase', 30, NULL, NULL, 124613),
(124614, '1.10.510.10-FF-000977', NULL, 'Fibroblast growth factor receptor', 101, NULL, NULL, 124614),
(124615, '1.20.1740.10-FF-000093', NULL, 'Amino acid permease', 453, NULL, NULL, 124615),
(124616, '1.20.80.10-FF-000021', NULL, 'pleckstrin homology domain-containing family H member 2', 123, NULL, NULL, 124616),
(124617, '1.25.40.10-FF-003594', NULL, 'SARP family transcriptional regulator', 148, NULL, NULL, 124617),
(124618, '3.40.630.150-FF-000022', NULL, 'Uncharacterized protein', 110, NULL, NULL, 124618),
(124619, '3.40.50.1000-FF-000100', NULL, 'Alpha,alpha-trehalose-phosphate synthase', 80, NULL, NULL, 124619),
(124620, '1.20.58.390-FF-000328', NULL, 'Uncharacterized protein', 122, NULL, NULL, 124620),
(124621, '3.30.110.70-FF-000003', NULL, 'Heavy-metal-binding family protein', 91, NULL, NULL, 124621),
(124622, '2.20.70.10-FF-000029', NULL, 'pre-mRNA-processing factor 40 homolog A isoform X1', 41, NULL, NULL, 124622),
(124623, '3.30.420.390-FF-000009', NULL, 'POLG (Mitochondrial DNA POLymerase Gamma)', 213, NULL, NULL, 124623); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(124624, '3.40.50.1370-FF-000048', NULL, NULL, 87, NULL, NULL, 124624),
(124625, '1.10.287.550-FF-000024', NULL, 'Uncharacterized protein', 16, NULL, NULL, 124625),
(124626, '3.20.20.70-FF-000103', NULL, 'Putative deoxyribose-phosphate aldolase', 275, NULL, NULL, 124626),
(124627, '1.20.1250.20-FF-000496', NULL, 'Cyanate transporter family protein', 182, NULL, NULL, 124627),
(124628, '2.60.40.10-FF-001638', NULL, 'Eph receptor tyrosine kinase', 106, NULL, NULL, 124628),
(124629, '1.20.1070.10-FF-002047', NULL, 'Uncharacterized protein', 108, NULL, NULL, 124629),
(124630, '1.10.630.10-FF-000571', NULL, 'Uncharacterized protein', 318, NULL, NULL, 124630),
(124631, '1.10.238.10-FF-001092', NULL, 'Follistatin like 4', 71, NULL, NULL, 124631),
(124632, '1.20.1310.10-FF-000217', NULL, NULL, 78, NULL, NULL, 124632),
(124633, '1.20.5.4820-FF-000009', NULL, 'Myosin B', 116, NULL, NULL, 124633),
(124634, '1.10.150.670-FF-000015', NULL, 'Essential Meiotic Endonuclease', 92, NULL, NULL, 124634),
(124635, '3.30.1410.10-FF-000007', NULL, 'Uncharacterized protein', 47, NULL, NULL, 124635),
(124636, '1.20.120.1910-FF-000038', NULL, 'Cysteine--tRNA ligase', 140, NULL, NULL, 124636),
(124637, '2.40.170.20-FF-000100', NULL, NULL, 265, NULL, NULL, 124637),
(124638, '2.60.40.10-FF-005972', NULL, NULL, 103, NULL, NULL, 124638),
(124639, '2.130.10.10-FF-003707', NULL, 'Uncharacterized protein', 419, NULL, NULL, 124639),
(124640, '3.80.10.10-FF-004394', NULL, 'Uncharacterized protein', 165, NULL, NULL, 124640),
(124641, '3.30.420.10-FF-000323', NULL, 'Uncharacterized protein', 337, NULL, NULL, 124641),
(124642, '3.40.50.300-FF-001055', NULL, 'putative pre-mRNA-splicing factor ATP-dependent RNA helicase DHX32', 176, NULL, NULL, 124642),
(124643, '1.10.510.10-FF-001984', NULL, 'Kinase, CMGC RCK', 218, NULL, NULL, 124643),
(124644, '3.40.50.2060-FF-000002', NULL, 'sec1 family domain-containing protein 1', 133, NULL, NULL, 124644),
(124645, '3.40.50.880-FF-000172', NULL, 'Glutamine amidotransferase (Homolog to GMP synthase subunit A)', 217, NULL, NULL, 124645),
(124646, '3.30.70.270-FF-000309', NULL, NULL, 37, NULL, NULL, 124646),
(124647, '1.10.472.10-FF-000079', NULL, 'Putative cyclin-T1 family protein', 101, NULL, NULL, 124647),
(124648, '1.10.287.70-FF-000554', NULL, 'Uncharacterized protein', 150, NULL, NULL, 124648),
(124649, '3.40.50.1010-FF-000249', NULL, NULL, 168, NULL, NULL, 124649),
(124650, '3.30.160.60-FF-006017', NULL, NULL, 33, NULL, NULL, 124650),
(124651, '3.40.50.800-FF-000103', NULL, 'Histidine--tRNA ligase', 84, NULL, NULL, 124651),
(124652, '1.20.5.1160-FF-000024', NULL, 'Putative keratin-87 protein', 79, NULL, NULL, 124652),
(124653, '2.30.29.30-FF-000304', NULL, 'Beta-1-syntrophin isoform 1', 86, NULL, NULL, 124653),
(124654, '1.10.167.20-FF-000002', NULL, 'Nuclear pore complex subunit', 75, NULL, NULL, 124654),
(124655, '3.40.50.300-FF-002432', NULL, 'ATP synthase subunit alpha, mitochondrial', 286, NULL, NULL, 124655),
(124656, '2.60.40.10-FF-005180', NULL, NULL, 93, NULL, NULL, 124656),
(124657, '3.30.70.260-FF-000099', NULL, 'Aspartokinase', 67, NULL, NULL, 124657),
(124658, '2.130.10.130-FF-000056', NULL, NULL, 125, NULL, NULL, 124658),
(124659, '1.25.40.10-FF-000800', NULL, 'Protein STABILIZED1', 85, NULL, NULL, 124659),
(124660, '2.40.50.140-FF-001207', NULL, NULL, 87, NULL, NULL, 124660),
(124661, '1.25.40.10-FF-002133', NULL, 'U4/U6-U5 snRNP complex subunit', 196, NULL, NULL, 124661),
(124662, '3.40.50.300-FF-001908', NULL, 'DNA replication and repair protein RecF', 151, NULL, NULL, 124662),
(124663, '2.70.98.30-FF-000046', NULL, 'Alpha-mannosidase', 297, NULL, NULL, 124663),
(124664, '1.20.1250.20-FF-001064', NULL, 'Uncharacterized protein', 188, NULL, NULL, 124664),
(124665, '1.20.1050.10-FF-000186', NULL, 'Bus-18', 115, NULL, NULL, 124665),
(124666, '3.30.200.20-FF-001417', NULL, 'Mitogen-activated kinase kinase (MAKK), putative', 116, NULL, NULL, 124666),
(124667, '3.30.200.20-FF-000220', NULL, 'mitogen-activated protein kinase kinase kinase 20 isoform X1', 85, NULL, NULL, 124667);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(124668, '2.130.10.10-FF-003319', NULL, 'Uncharacterized protein', 148, NULL, NULL, 124668),
(124669, '2.30.24.10-FF-000001', NULL, 'Cryptic beta-glucoside bgl operon antiterminator', 67, NULL, NULL, 124669),
(124670, '3.40.50.1970-FF-000020', NULL, 'Alcohol dehydrogenase, iron-dependent', 182, NULL, NULL, 124670),
(124671, '1.25.40.10-FF-004111', NULL, 'Uncharacterized protein', 137, NULL, NULL, 124671),
(124672, '3.40.50.2300-FF-000451', NULL, 'Two-component response regulator ORR33', 134, NULL, NULL, 124672),
(124673, '3.30.420.220-FF-000004', NULL, 'Uncharacterized NOP5 family protein MJ0694', 119, NULL, NULL, 124673),
(124674, '3.40.50.150-FF-000532', NULL, 'Chemotaxis protein methyltransferase', 198, NULL, NULL, 124674),
(124675, '3.30.160.60-FF-005449', NULL, NULL, 24, NULL, NULL, 124675),
(124676, '2.10.25.10-FF-001263', NULL, 'Receptor tyrosine kinase', 37, NULL, NULL, 124676),
(124677, '2.30.42.10-FF-000374', NULL, NULL, 72, NULL, NULL, 124677),
(124678, '1.10.437.10-FF-000060', NULL, 'Uncharacterized protein', 183, NULL, NULL, 124678),
(124679, '3.20.20.80-FF-000432', NULL, 'Uncharacterized protein', 340, NULL, NULL, 124679),
(124680, '3.40.50.80-FF-000219', NULL, 'Uncharacterized protein', 120, NULL, NULL, 124680),
(124681, '3.30.40.10-FF-001042', NULL, 'Protein CBR-CBP-1', 41, NULL, NULL, 124681),
(124682, '3.90.780.10-FF-000033', NULL, '5'' nucleotidase family protein', 109, NULL, NULL, 124682),
(124683, '3.40.50.300-FF-006647', NULL, 'Torsin, putative', 88, NULL, NULL, 124683),
(124684, '3.30.1490.180-FF-000010', NULL, 'DNA-directed RNA polymerase subunit', 41, NULL, NULL, 124684),
(124685, '3.80.10.10-FF-001600', NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase At5g58150', 149, NULL, NULL, 124685),
(124686, '3.80.10.10-FF-002089', NULL, 'Cell surface glycoprotein gp138', 346, NULL, NULL, 124686),
(124687, '3.40.50.300-FF-005219', NULL, 'U3 small nucleolar RNA-associated protein 25', 207, NULL, NULL, 124687),
(124688, '3.90.740.10-FF-000019', NULL, 'Isoleucine--tRNA ligase, cytoplasmic', 148, NULL, NULL, 124688),
(124689, '2.60.200.20-FF-000251', NULL, 'Uncharacterized protein', 114, NULL, NULL, 124689),
(124690, '3.90.660.10-FF-000018', NULL, 'Renalase', 175, NULL, NULL, 124690),
(124691, '1.20.1530.20-FF-000057', NULL, 'Na(+)/H(+) antiporter NhaS2', 387, NULL, NULL, 124691),
(124692, '3.40.50.300-FF-000066', NULL, 'ABC transporter B family member 1', 250, NULL, NULL, 124692),
(124693, '1.10.510.10-FF-002501', NULL, NULL, 68, NULL, NULL, 124693),
(124694, '3.90.1150.10-FF-000226', NULL, 'Adenosylmethionine--8-amino-7-oxononanoate transaminase', 140, NULL, NULL, 124694),
(124695, '3.10.10.10-FF-000035', NULL, NULL, 110, NULL, NULL, 124695),
(124696, '1.50.10.150-FF-000012', NULL, 'Voltage-dependent anion channel', 328, NULL, NULL, 124696),
(124697, '2.130.10.10-FF-002870', NULL, 'Related to KOG1-Subunit of TORC1, a rapamycin-sensitive complex involved in growth control', 178, NULL, NULL, 124697),
(124698, '3.30.70.80-FF-000002', NULL, 'Subtilisin-like protease SBT5.3', 91, NULL, NULL, 124698),
(124699, '3.20.20.100-FF-000217', NULL, 'Aldo-keto-reductase-like protein', 62, NULL, NULL, 124699),
(124700, '3.40.50.720-FF-001366', NULL, 'Formate dehydrogenase chloroplastic/mitochondrial', 55, NULL, NULL, 124700),
(124701, '1.10.418.40-FF-000013', NULL, 'Beclin-1-like protein A', 225, NULL, NULL, 124701),
(124702, '3.80.10.10-FF-002038', NULL, 'Uncharacterized protein', 213, NULL, NULL, 124702),
(124703, '1.25.40.20-FF-000157', NULL, 'short transient receptor potential channel 6 isoform X1', 273, NULL, NULL, 124703),
(124704, '1.20.1250.20-FF-001856', NULL, 'Uncharacterized protein', 129, NULL, NULL, 124704),
(124705, '3.30.505.10-FF-000251', NULL, NULL, 51, NULL, NULL, 124705),
(124706, '2.10.220.10-FF-000210', NULL, 'Proprotein convertase subtilisin/kexin type 5', 52, NULL, NULL, 124706),
(124707, '3.90.1150.10-FF-000338', NULL, 'Histidinol-phosphate aminotransferase', 120, NULL, NULL, 124707),
(124708, '1.10.565.10-FF-000143', NULL, 'Peroxisome proliferator-activated receptor alpha', 189, NULL, NULL, 124708);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(124709, '2.40.320.10-FF-000008', NULL, 'Zinc phosphodiesterase ELAC protein 2', 163, NULL, NULL, 124709),
(124710, '3.40.50.300-FF-003825', NULL, 'Putative DNA helicase', 284, NULL, NULL, 124710),
(124711, '1.10.285.10-FF-000009', NULL, 'Glutamate dehydrogenase', 45, NULL, NULL, 124711),
(124712, '3.30.160.60-FF-005680', NULL, NULL, 25, NULL, NULL, 124712),
(124713, '1.25.40.10-FF-001256', NULL, 'Alpha-soluble NSF attachment protein, putative', 282, NULL, NULL, 124713),
(124714, '1.25.40.180-FF-000346', NULL, NULL, 96, NULL, NULL, 124714),
(124715, '3.30.1380.20-FF-000013', NULL, 'Trafficking protein particle complex subunit', 178, NULL, NULL, 124715),
(124716, '1.20.1070.10-FF-000069', NULL, 'Prokineticin receptor 2', 326, NULL, NULL, 124716),
(124717, '3.40.50.300-FF-008143', NULL, 'Fanconi anemia group M protein', 96, NULL, NULL, 124717),
(124718, '3.10.20.870-FF-000006', NULL, 'Related to DOA1-involved in ubiquitin-dependent proteolysis', 75, NULL, NULL, 124718),
(124719, '1.10.150.850-FF-000013', NULL, 'Uncharacterized protein', 69, NULL, NULL, 124719),
(124720, '1.10.220.30-FF-000023', NULL, 'Flagellar motor switch protein FliG', 86, NULL, NULL, 124720),
(124721, '1.20.1110.10-FF-000236', NULL, NULL, 335, NULL, NULL, 124721),
(124722, '1.20.80.10-FF-000072', NULL, 'Uncharacterized protein', 108, NULL, NULL, 124722),
(124723, '3.30.230.10-FF-000399', NULL, 'Putative tetracycline resistance protein', 113, NULL, NULL, 124723),
(124724, '2.60.40.1730-FF-000051', NULL, 'Aminopeptidase', 210, NULL, NULL, 124724),
(124725, '3.40.50.720-FF-000910', NULL, 'Predicted protein', 155, NULL, NULL, 124725),
(124726, '2.40.50.100-FF-000026', NULL, '50S ribosomal protein L27', 66, NULL, NULL, 124726),
(124727, '3.30.160.60-FF-001234', NULL, 'Zinc finger protein 394', 34, NULL, NULL, 124727),
(124728, '2.20.100.10-FF-000238', NULL, 'Uncharacterized protein', 37, NULL, NULL, 124728),
(124729, '1.10.8.60-FF-000334', NULL, 'Vesicle-fusing ATPase', 72, NULL, NULL, 124729),
(124730, '3.40.50.1820-FF-000054', NULL, 'Alpha/beta-Hydrolases superfamily protein', 292, NULL, NULL, 124730),
(124731, '3.40.50.300-FF-008204', NULL, 'Uncharacterized protein', 73, NULL, NULL, 124731),
(124732, '1.10.10.440-FF-000035', NULL, 'Putative ff domain protein', 73, NULL, NULL, 124732),
(124733, '3.40.50.1820-FF-000166', NULL, 'group XV phospholipase A2 isoform X1', 69, NULL, NULL, 124733),
(124734, '3.40.50.300-FF-003472', NULL, 'GTP-binding nuclear protein', 128, NULL, NULL, 124734),
(124735, '3.40.50.12370-FF-000003', NULL, 'Os05g0276100 protein', 241, NULL, NULL, 124735),
(124736, '1.25.10.10-FF-000068', NULL, 'cytoskeleton-associated protein 5 isoform X1', 245, NULL, NULL, 124736),
(124737, '3.30.420.80-FF-000030', NULL, '40S ribosomal protein S14-3', 95, NULL, NULL, 124737),
(124738, '3.90.1150.10-FF-000277', NULL, 'Predicted protein', 106, NULL, NULL, 124738),
(124739, '3.40.30.10-FF-000535', NULL, 'Nitroreductase', 138, NULL, NULL, 124739),
(124740, '1.20.1560.10-FF-000848', NULL, 'Predicted protein', 328, NULL, NULL, 124740),
(124741, '1.10.150.490-FF-000001', NULL, 'Gag polyprotein', 98, NULL, NULL, 124741),
(124742, '2.10.70.10-FF-000058', NULL, 'sushi repeat-containing protein SRPX2', 57, NULL, NULL, 124742),
(124743, '3.90.228.10-FF-000060', NULL, 'Poly [ADP-ribose] polymerase', 141, NULL, NULL, 124743),
(124744, '2.40.20.10-FF-000076', NULL, 'Uncharacterized protein', 106, NULL, NULL, 124744),
(124745, '1.10.12.10-FF-000050', NULL, 'Enoyl-CoA hydratase domain containing 2', 39, NULL, NULL, 124745),
(124746, '2.40.240.10-FF-000007', NULL, 'Glutamine--tRNA ligase', 117, NULL, NULL, 124746),
(124747, '3.20.20.80-FF-000320', NULL, 'Glucan endo-1,3-beta-glucosidase', 260, NULL, NULL, 124747),
(124748, '3.30.870.10-FF-000082', NULL, 'Cardiolipin synthase family enzyme', 204, NULL, NULL, 124748),
(124749, '3.40.50.11370-FF-000012', NULL, 'Uncharacterized protein', 92, NULL, NULL, 124749),
(124750, '2.30.29.30-FF-000708', NULL, 'Uncharacterized protein', 114, NULL, NULL, 124750),
(124751, '1.50.40.10-FF-000596', NULL, 'Predicted protein', 145, NULL, NULL, 124751);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(124752, '1.20.1250.20-FF-001805', NULL, 'Siderophore iron transporter 1', 169, NULL, NULL, 124752),
(124753, '1.10.3720.10-FF-000217', NULL, 'Sulfate ABC transport system permease protein', 263, NULL, NULL, 124753),
(124754, '3.40.50.970-FF-000159', NULL, 'Oxoglutarate dehydrogenase', 184, NULL, NULL, 124754),
(124755, '3.30.420.40-FF-000158', NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase', 71, NULL, NULL, 124755),
(124756, '2.60.40.10-FF-000649', NULL, 'Advanced glycosylation end product-specific receptor', 98, NULL, NULL, 124756),
(124757, '1.10.132.80-FF-000001', NULL, 'Terminase small subunit', 139, NULL, NULL, 124757),
(124758, '3.60.21.10-FF-000210', NULL, 'Phosphoesterase', 232, NULL, NULL, 124758),
(124759, '3.90.550.50-FF-000180', NULL, 'Hexosyltransferase', 234, NULL, NULL, 124759),
(124760, '3.30.1300.30-FF-000011', NULL, 'Type II secretion system protein K', 74, NULL, NULL, 124760),
(124761, '1.20.58.60-FF-000276', NULL, 'Utrophin', 305, NULL, NULL, 124761),
(124762, '3.40.50.1460-FF-000103', NULL, 'Uncharacterized protein', 146, NULL, NULL, 124762),
(124763, '1.20.1540.10-FF-000094', NULL, 'Rhomboid family protease', 216, NULL, NULL, 124763),
(124764, '2.30.30.30-FF-000100', NULL, 'Uncharacterized protein', 50, NULL, NULL, 124764),
(124765, '3.40.50.300-FF-006698', NULL, 'Obg-like ATPase 1', 79, NULL, NULL, 124765),
(124766, '3.20.20.100-FF-000156', NULL, 'Predicted protein', 255, NULL, NULL, 124766),
(124767, '2.130.10.10-FF-001521', NULL, 'CPSF A subunit region protein, putative', 336, NULL, NULL, 124767),
(124768, '2.60.40.10-FF-001689', NULL, 'Myoblast growth factor receptor egl-15', 112, NULL, NULL, 124768),
(124769, '3.40.720.10-FF-000041', NULL, 'GPI ethanolamine phosphate transferase 3', 288, NULL, NULL, 124769),
(124770, '2.130.10.10-FF-002010', NULL, 'WD40 repeat-like protein', 212, NULL, NULL, 124770),
(124771, '3.40.50.10420-FF-000031', NULL, '5-formyltetrahydrofolate cyclo-ligase family, putative', 267, NULL, NULL, 124771),
(124772, '3.10.20.90-FF-000790', NULL, 'Uncharacterized protein', 178, NULL, NULL, 124772),
(124773, '2.60.40.150-FF-000765', NULL, 'Uncharacterized protein', 160, NULL, NULL, 124773),
(124774, '1.10.510.10-FF-000505', NULL, 'Serine/threonine protein kinase', 249, NULL, NULL, 124774),
(124775, '4.10.410.20-FF-000006', NULL, 'proteoglycan 4 isoform X1', 44, NULL, NULL, 124775),
(124776, '1.25.40.10-FF-002245', NULL, 'Tetratricopeptide repeat, putative', 195, NULL, NULL, 124776),
(124777, '3.30.70.260-FF-000048', NULL, 'Prephenate dehydratase', 86, NULL, NULL, 124777),
(124778, '1.10.10.350-FF-000008', NULL, 'Glutamate--tRNA ligase', 90, NULL, NULL, 124778),
(124779, '1.20.1280.50-FF-000119', NULL, 'Related to pyrimidine 5-nucleotidase', 96, NULL, NULL, 124779),
(124780, '3.40.50.1760-FF-000007', NULL, 'Glutathione synthetase', 125, NULL, NULL, 124780),
(124781, '2.130.10.130-FF-000005', NULL, 'Integrin alpha L', 313, NULL, NULL, 124781),
(124782, '2.60.40.10-FF-004123', NULL, NULL, 92, NULL, NULL, 124782),
(124783, '3.40.50.11950-FF-000006', NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', 79, NULL, NULL, 124783),
(124784, '1.10.510.10-FF-003850', NULL, NULL, 103, NULL, NULL, 124784),
(124785, '3.80.10.10-FF-000291', NULL, 'F-box and leucine rich repeat protein 13', 131, NULL, NULL, 124785),
(124786, '3.40.1080.10-FF-000013', NULL, 'Citrate lyase alpha chain', 236, NULL, NULL, 124786),
(124787, '3.40.640.10-FF-000040', NULL, 'UDP-4-amino-4-deoxy-L-arabinose--oxoglutarate aminotransferase', 252, NULL, NULL, 124787),
(124788, '3.40.50.300-FF-003421', NULL, 'tRNA isopentenyltransferase putative', 275, NULL, NULL, 124788),
(124789, '3.30.1370.100-FF-000027', NULL, 'DNA mismatch repair protein MutL', 96, NULL, NULL, 124789),
(124790, '1.10.287.70-FF-000503', NULL, 'Uncharacterized protein', 147, NULL, NULL, 124790),
(124791, '3.30.70.330-FF-002773', NULL, NULL, 74, NULL, NULL, 124791),
(124792, '2.130.10.10-FF-002398', NULL, 'Protein CBG10826', 275, NULL, NULL, 124792),
(124793, '2.170.270.10-FF-000198', NULL, 'Histone-lysine N-methyltransferase', 218, NULL, NULL, 124793); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(124794, '2.130.10.10-FF-000161', NULL, 'DNA damage-binding protein 2', 321, NULL, NULL, 124794),
(124795, '3.40.920.10-FF-000022', NULL, NULL, 150, NULL, NULL, 124795),
(124796, '3.60.70.12-FF-000005', NULL, 'Arginine biosynthesis bifunctional protein ArgJ', 199, NULL, NULL, 124796),
(124797, '3.30.1610.10-FF-000006', NULL, 'Nuclear pore complex protein Nup98', 139, NULL, NULL, 124797),
(124798, '1.10.730.10-FF-000067', NULL, 'Leucine--tRNA ligase', 24, NULL, NULL, 124798),
(124799, '3.30.160.60-FF-005528', NULL, NULL, 31, NULL, NULL, 124799),
(124800, '2.10.25.10-FF-001151', NULL, 'Platelet endothelial aggregation receptor 1', 49, NULL, NULL, 124800),
(124801, '3.40.50.300-FF-007187', NULL, 'Cytosolic Fe-S cluster assembly factor NUBP1 homolog', 285, NULL, NULL, 124801),
(124802, '3.30.1330.30-FF-000131', NULL, 'Uncharacterized protein', 115, NULL, NULL, 124802),
(124803, '1.10.238.10-FF-000423', NULL, 'Polcalcin Jun o 2', 80, NULL, NULL, 124803),
(124804, '3.30.342.10-FF-000012', NULL, 'DNA polymerase epsilon catalytic subunit', 145, NULL, NULL, 124804),
(124805, '3.30.160.60-FF-002774', NULL, 'Uncharacterized protein, isoform B', 26, NULL, NULL, 124805),
(124806, '3.40.720.10-FF-000102', NULL, 'Cofactor-independent phosphoglycerate mutase', 271, NULL, NULL, 124806),
(124807, '3.30.40.10-FF-001542', NULL, 'Ring finger domain containing protein, putative', 104, NULL, NULL, 124807),
(124808, '3.20.20.190-FF-000082', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', 233, NULL, NULL, 124808),
(124809, '1.10.565.10-FF-000059', NULL, 'Nuclear Hormone Receptor family', 243, NULL, NULL, 124809),
(124810, '3.80.10.10-FF-000240', NULL, 'Leucine rich repeat containing 3C', 163, NULL, NULL, 124810),
(124811, '4.10.480.10-FF-000002', NULL, 'Hydrogenase-1 small chain', 111, NULL, NULL, 124811),
(124812, '1.10.8.50-FF-000005', NULL, 'Endonuclease 8', 136, NULL, NULL, 124812),
(124813, '3.30.1400.10-FF-000001', NULL, 'Cell division protein ZipA', 141, NULL, NULL, 124813),
(124814, '2.130.10.30-FF-000167', NULL, NULL, 65, NULL, NULL, 124814),
(124815, '2.60.40.60-FF-000350', NULL, 'Predicted protein', 104, NULL, NULL, 124815),
(124816, '3.40.30.10-FF-001024', NULL, 'Uncharacterized protein', 52, NULL, NULL, 124816),
(124817, '1.10.510.10-FF-001141', NULL, 'Os01g0155500 protein', 218, NULL, NULL, 124817),
(124818, '1.10.287.3240-FF-000017', NULL, 'GM21350', 208, NULL, NULL, 124818),
(124819, '3.30.110.10-FF-000013', NULL, 'Translation initiation factor IF-3 domain-containing protein', 87, NULL, NULL, 124819),
(124820, '3.40.50.150-FF-001442', NULL, NULL, 145, NULL, NULL, 124820),
(124821, '3.40.50.12280-FF-000009', NULL, 'NADH dehydrogenase [ubiquinone] iron-sulfur protein 7, mitochondrial', 84, NULL, NULL, 124821),
(124822, '3.10.100.10-FF-000017', NULL, 'collectin-12 isoform X1', 137, NULL, NULL, 124822),
(124823, '3.40.190.10-FF-000078', NULL, 'glutamate receptor ionotropic, NMDA 3B', 181, NULL, NULL, 124823),
(124824, '3.30.200.20-FF-000580', NULL, 'Mitogen-activated protein kinase', 94, NULL, NULL, 124824),
(124825, '1.10.472.10-FF-000579', NULL, 'Uncharacterized protein', 45, NULL, NULL, 124825),
(124826, '2.130.10.10-FF-001442', NULL, 'Nucleoporin 214', 397, NULL, NULL, 124826),
(124827, '3.40.395.10-FF-000031', NULL, 'YALI0E21153p', 237, NULL, NULL, 124827),
(124828, '1.10.490.10-FF-000008', NULL, 'non-symbiotic hemoglobin 1', 149, NULL, NULL, 124828),
(124829, '1.25.10.10-FF-001057', NULL, 'Clathrin-coated vesicle protein, putative', 189, NULL, NULL, 124829),
(124830, '1.10.230.10-FF-000023', NULL, 'Citrate synthase', 120, NULL, NULL, 124830),
(124831, '3.30.40.10-FF-002391', NULL, 'Uncharacterized protein', 84, NULL, NULL, 124831),
(124832, '3.80.10.10-FF-004455', NULL, 'Uncharacterized protein', 99, NULL, NULL, 124832),
(124833, '3.40.50.10330-FF-000116', NULL, 'Ceramide kinase-like isoform 9', 128, NULL, NULL, 124833),
(124834, '1.25.40.20-FF-001534', NULL, 'Kinase, NEK', 36, NULL, NULL, 124834),
(124835, '1.10.287.70-FF-000054', NULL, 'Voltage-dependent T-type calcium channel subunit alpha', 152, NULL, NULL, 124835);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(124836, '2.30.30.40-FF-000378', NULL, 'Elongation factor 2 kinase', 64, NULL, NULL, 124836),
(124837, '1.10.510.10-FF-002473', NULL, NULL, 211, NULL, NULL, 124837),
(124838, '3.60.10.10-FF-000393', NULL, 'Uncharacterized protein', 95, NULL, NULL, 124838),
(124839, '1.10.555.10-FF-000266', NULL, NULL, 72, NULL, NULL, 124839),
(124840, '3.30.160.60-FF-006085', NULL, NULL, 64, NULL, NULL, 124840),
(124841, '1.10.510.10-FF-003378', NULL, NULL, 322, NULL, NULL, 124841),
(124842, '2.130.10.10-FF-005383', NULL, 'CPSF A subunit region family protein', 361, NULL, NULL, 124842),
(124843, '2.60.40.10-FF-003555', NULL, NULL, 110, NULL, NULL, 124843),
(124844, '2.20.110.10-FF-000036', NULL, 'MORN repeat, putative', 58, NULL, NULL, 124844),
(124845, '1.25.10.10-FF-003053', NULL, 'Uncharacterized protein', 272, NULL, NULL, 124845),
(124846, '2.60.40.640-FF-000103', NULL, 'Uncharacterized protein', 147, NULL, NULL, 124846),
(124847, '2.60.40.1170-FF-000012', NULL, 'Stonin 2', 152, NULL, NULL, 124847),
(124848, '3.40.190.10-FF-000819', NULL, 'Glutamate ionotropic receptor delta type subunit 2', 70, NULL, NULL, 124848),
(124849, '1.20.1250.20-FF-000867', NULL, 'Monocarboxylate transporter, putative', 186, NULL, NULL, 124849),
(124850, '1.20.5.730-FF-000009', NULL, 'Rabaptin, RAB GTPase binding effector protein 2', 30, NULL, NULL, 124850),
(124851, '1.20.58.480-FF-000030', NULL, 'Uncharacterized protein', 88, NULL, NULL, 124851),
(124852, '3.40.50.1820-FF-000846', NULL, 'Uncharacterized protein', 303, NULL, NULL, 124852),
(124853, '2.60.40.2170-FF-000003', NULL, 'Shifted, isoform B', 148, NULL, NULL, 124853),
(124854, '1.25.10.10-FF-002777', NULL, 'Uncharacterized protein', 572, NULL, NULL, 124854),
(124855, '2.60.120.260-FF-000043', NULL, 'Beta-galactosidase', 166, NULL, NULL, 124855),
(124856, '3.40.1190.20-FF-000075', NULL, 'Mak32p', 321, NULL, NULL, 124856),
(124857, '2.60.40.10-FF-003263', NULL, NULL, 88, NULL, NULL, 124857),
(124858, '3.20.20.70-FF-000603', NULL, NULL, 128, NULL, NULL, 124858),
(124859, '3.60.15.10-FF-000038', NULL, 'DNA cross-link repair protein pso2/snm1', 205, NULL, NULL, 124859),
(124860, '2.60.40.1960-FF-000002', NULL, 'Pepsin-like aspartic protease A1', 71, NULL, NULL, 124860),
(124861, '1.25.40.10-FF-004050', NULL, 'Uncharacterized protein', 172, NULL, NULL, 124861),
(124862, '1.20.1270.60-FF-000312', NULL, 'Uncharacterized protein', 56, NULL, NULL, 124862),
(124863, '1.10.10.10-FF-000500', NULL, 'Phenylacetic acid degradation operon negative regulatory protein', 81, NULL, NULL, 124863),
(124864, '1.20.1070.10-FF-001137', NULL, 'Substance-K receptor', 350, NULL, NULL, 124864),
(124865, '3.40.50.300-FF-000515', NULL, 'GTPase Obg', 184, NULL, NULL, 124865),
(124866, '3.30.40.10-FF-000845', NULL, 'RING-H2 finger protein ATL75-like', 49, NULL, NULL, 124866),
(124867, '2.60.120.200-FF-000132', NULL, 'Tyrosine-protein kinase receptor', 174, NULL, NULL, 124867),
(124868, '3.40.250.10-FF-000145', NULL, 'Sulfurtransferase', 123, NULL, NULL, 124868),
(124869, '3.30.505.10-FF-000190', NULL, NULL, 84, NULL, NULL, 124869),
(124870, '3.20.20.70-FF-000042', NULL, 'Pyridoxine 5''-phosphate synthase', 243, NULL, NULL, 124870),
(124871, '2.60.40.10-FF-002706', NULL, 'AGAP009061-PA', 94, NULL, NULL, 124871),
(124872, '2.60.40.10-FF-006017', NULL, NULL, 99, NULL, NULL, 124872),
(124873, '3.10.260.10-FF-000006', NULL, 'Swi4p', 133, NULL, NULL, 124873),
(124874, '3.80.10.10-FF-002477', NULL, 'Si:ch1073-82l19.1', 271, NULL, NULL, 124874),
(124875, '3.10.180.10-FF-000005', NULL, 'YecM family protein', 188, NULL, NULL, 124875),
(124876, '1.10.510.10-FF-001192', NULL, 'SH3 domain-binding kinase 1', 306, NULL, NULL, 124876),
(124877, '3.30.40.10-FF-002239', NULL, 'Zinc finger protein', 62, NULL, NULL, 124877),
(124878, '3.10.50.40-FF-000024', NULL, 'Peptidyl-prolyl cis-trans isomerase FKBP1A', 108, NULL, NULL, 124878),
(124879, '3.30.1010.10-FF-000078', NULL, 'Uncharacterized protein', 203, NULL, NULL, 124879),
(124880, '3.60.10.10-FF-000342', NULL, 'Predicted protein', 210, NULL, NULL, 124880),
(124881, '3.40.50.20-FF-000067', NULL, 'Carbamoyl-phosphate synthetase 2, aspartate transcarbamylase, and dihydroorotase', 62, NULL, NULL, 124881);
INSERT INTO "PUBLIC"."MODEL" VALUES
(124882, '1.25.10.10-FF-001349', NULL, 'Nucleotide exchange factor SIL1', 283, NULL, NULL, 124882),
(124883, '1.25.40.860-FF-000011', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 128, NULL, NULL, 124883),
(124884, '3.50.50.60-FF-001028', NULL, 'Rab proteins geranylgeranyltransferase', 115, NULL, NULL, 124884),
(124885, '2.130.10.10-FF-002510', NULL, 'Uncharacterized protein', 305, NULL, NULL, 124885),
(124886, '3.40.50.970-FF-000047', NULL, 'Probable pyruvate-flavodoxin oxidoreductase', 374, NULL, NULL, 124886),
(124887, '3.20.20.190-FF-000031', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 324, NULL, NULL, 124887),
(124888, '1.20.1740.10-FF-000154', NULL, 'Solute carrier family 7 member 3', 140, NULL, NULL, 124888),
(124889, '2.130.10.10-FF-005624', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', 182, NULL, NULL, 124889),
(124890, '3.40.47.10-FF-000219', NULL, NULL, 143, NULL, NULL, 124890),
(124891, '2.60.40.10-FF-004623', NULL, NULL, 67, NULL, NULL, 124891),
(124892, '3.60.20.10-FF-000168', NULL, NULL, 211, NULL, NULL, 124892),
(124893, '1.20.1250.20-FF-000575', NULL, 'Vba1p', 196, NULL, NULL, 124893),
(124894, '1.20.120.720-FF-000062', NULL, 'Myosin, heavy chain 15', 152, NULL, NULL, 124894),
(124895, '3.40.50.300-FF-007136', NULL, 'Uncharacterized protein', 384, NULL, NULL, 124895),
(124896, '1.25.40.10-FF-004662', NULL, 'Uncharacterized protein', 226, NULL, NULL, 124896),
(124897, '1.20.120.1080-FF-000126', NULL, 'Uncharacterized protein', 109, NULL, NULL, 124897),
(124898, '3.60.21.10-FF-000159', NULL, 'Bifunctional 5-nucleotidase/2,3-cyclic phosphodiesterase', 261, NULL, NULL, 124898),
(124899, '2.40.50.140-FF-000010', NULL, 'Transcription termination factor Rho', 75, NULL, NULL, 124899),
(124900, '3.40.50.1820-FF-001122', NULL, 'Carboxylic ester hydrolase', 309, NULL, NULL, 124900),
(124901, '2.60.40.1450-FF-000006', NULL, 'Uncharacterized protein', 80, NULL, NULL, 124901),
(124902, '3.40.50.360-FF-000038', NULL, 'NADPH-dependent FMN reductase', 196, NULL, NULL, 124902),
(124903, '2.130.10.10-FF-005332', NULL, 'WD-40 repeat protein', 188, NULL, NULL, 124903),
(124904, '3.30.60.60-FF-000018', NULL, 'Histone acetyltransferase', 57, NULL, NULL, 124904),
(124905, '1.10.8.720-FF-000060', NULL, 'Si:dkey-11m19.5', 163, NULL, NULL, 124905),
(124906, '1.20.80.60-FF-000007', NULL, 'Uncharacterized protein', 52, NULL, NULL, 124906),
(124907, '1.10.565.10-FF-000031', NULL, 'Nuclear receptor subfamily 0 group B member 1', 206, NULL, NULL, 124907),
(124908, '2.60.40.10-FF-004915', NULL, NULL, 95, NULL, NULL, 124908),
(124909, '3.90.660.10-FF-000086', NULL, NULL, 57, NULL, NULL, 124909),
(124910, '1.10.510.10-FF-001933', NULL, 'Guanylate cyclase', 247, NULL, NULL, 124910),
(124911, '3.30.1450.10-FF-000004', NULL, 'Outer membrane protein assembly factor BamE', 77, NULL, NULL, 124911),
(124912, '2.130.10.10-FF-002802', NULL, 'Uncharacterized protein', 178, NULL, NULL, 124912),
(124913, '2.40.30.10-FF-000453', NULL, 'Uncharacterized protein', 160, NULL, NULL, 124913),
(124914, '3.30.230.40-FF-000003', NULL, 'Imidazoleglycerol-phosphate dehydratase HisB', 90, NULL, NULL, 124914),
(124915, '2.30.30.30-FF-000049', NULL, 'Uncharacterized protein', 62, NULL, NULL, 124915),
(124916, '3.30.365.10-FF-000048', NULL, 'Molybdopterin-binding domain of aldehyde dehydrogenase', 141, NULL, NULL, 124916),
(124917, '3.90.640.10-FF-000023', NULL, 'Hsp70 chaperone (BiP)', 80, NULL, NULL, 124917),
(124918, '2.120.10.30-FF-000280', NULL, 'Uncharacterized protein', 145, NULL, NULL, 124918),
(124919, '1.25.40.180-FF-000234', NULL, NULL, 231, NULL, NULL, 124919),
(124920, '2.40.50.100-FF-000105', NULL, 'sn-glycerol-3-phosphate ABC transporter ATP-binding protein UgpC', 63, NULL, NULL, 124920),
(124921, '3.10.105.10-FF-000040', NULL, 'Probable glycine betaine-binding protein', 68, NULL, NULL, 124921),
(124922, '3.30.70.330-FF-001896', NULL, NULL, 83, NULL, NULL, 124922),
(124923, '2.60.40.150-FF-000473', NULL, 'YALI0B13904p', 104, NULL, NULL, 124923);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(124924, '1.20.1250.20-FF-000524', NULL, 'MFS transporter, putative', 180, NULL, NULL, 124924),
(124925, '1.25.40.10-FF-000688', NULL, 'Pentatricopeptide repeat-containing protein', 109, NULL, NULL, 124925),
(124926, '2.40.230.10-FF-000001', NULL, 'Phospholipase A(1)', 257, NULL, NULL, 124926),
(124927, '2.10.25.10-FF-001763', NULL, 'Uncharacterized protein', 36, NULL, NULL, 124927),
(124928, '3.30.70.940-FF-000005', NULL, 'Transcription elongation factor SPT5', 107, NULL, NULL, 124928),
(124929, '3.40.50.10190-FF-000091', NULL, 'Regulator of Ty1 transposition', 120, NULL, NULL, 124929),
(124930, '3.30.160.60-FF-004168', NULL, NULL, 29, NULL, NULL, 124930),
(124931, '3.40.50.10190-FF-000040', NULL, 'Mediator of DNA damage checkpoint protein 1', 110, NULL, NULL, 124931),
(124932, '1.10.600.10-FF-000063', NULL, 'Farnesyl-diphosphate farnesyltransferase', 335, NULL, NULL, 124932),
(124933, '1.10.10.1000-FF-000001', NULL, 'YopR family type III secretion effector', 101, NULL, NULL, 124933),
(124934, '3.80.10.10-FF-003045', NULL, 'Slit3 protein', 156, NULL, NULL, 124934),
(124935, '1.10.10.60-FF-000942', NULL, NULL, 74, NULL, NULL, 124935),
(124936, '3.30.70.920-FF-000050', NULL, 'Leucine-responsive regulatory protein', 59, NULL, NULL, 124936),
(124937, '3.40.50.1820-FF-000458', NULL, 'LDH1p Serine hydrolase', 294, NULL, NULL, 124937),
(124938, '2.60.40.60-FF-000962', NULL, 'Predicted protein', 79, NULL, NULL, 124938),
(124939, '3.40.190.10-FF-000027', NULL, 'DNA-binding transcriptional regulator OxyR', 104, NULL, NULL, 124939),
(124940, '2.120.10.80-FF-000002', NULL, 'Kelch-like family member 2', 302, NULL, NULL, 124940),
(124941, '3.60.10.10-FF-000050', NULL, 'Type I inositol polyphosphate 5-phosphatase 8', 347, NULL, NULL, 124941),
(124942, '2.130.10.10-FF-000953', NULL, 'Putative peptidyl-prolyl cis-trans isomerase and WD40 repeat domain family protein', 100, NULL, NULL, 124942),
(124943, '3.20.100.20-FF-000001', NULL, 'mRNA-capping enzyme catalytic subunit', 207, NULL, NULL, 124943),
(124944, '1.20.120.1300-FF-000001', NULL, '5,10-methenyltetrahydromethanopterin hydrogenase', 90, NULL, NULL, 124944),
(124945, '2.60.40.10-FF-002145', NULL, 'Major histocompatibility complex class I LDA', 99, NULL, NULL, 124945),
(124946, '1.10.287.1390-FF-000001', NULL, 'DNA polymerase', 60, NULL, NULL, 124946),
(124947, '3.30.160.60-FF-000245', NULL, 'zinc finger protein Gfi-1', 29, NULL, NULL, 124947),
(124948, '1.25.10.10-FF-001928', NULL, 'Serine/threonine-protein kinase TOR', 446, NULL, NULL, 124948),
(124949, '3.80.10.10-FF-002769', NULL, 'Uncharacterized protein', 170, NULL, NULL, 124949),
(124950, '3.90.226.10-FF-000010', NULL, 'acetyl-CoA carboxylase isoform X2', 405, NULL, NULL, 124950),
(124951, '3.30.70.330-FF-001716', NULL, NULL, 111, NULL, NULL, 124951),
(124952, '3.60.15.10-FF-000089', NULL, 'Possible hydrolase', 186, NULL, NULL, 124952),
(124953, '2.10.25.10-FF-001712', NULL, 'Protein kinase superfamily protein', 40, NULL, NULL, 124953),
(124954, '3.30.63.20-FF-000007', NULL, 'Uncharacterized protein', 93, NULL, NULL, 124954),
(124955, '3.30.200.20-FF-002378', NULL, 'Meiosis-specific serine/threonine-protein kinase mek1', 83, NULL, NULL, 124955),
(124956, '1.20.920.10-FF-000034', NULL, 'Bromodomain and WD repeat domain containing 3', 155, NULL, NULL, 124956),
(124957, '1.20.58.2230-FF-000002', NULL, 'AFR652Wp', 232, NULL, NULL, 124957),
(124958, '1.10.10.10-FF-001248', NULL, 'Transcriptional regulatory protein', 73, NULL, NULL, 124958),
(124959, '2.30.30.100-FF-000182', NULL, 'Like-Sm ribonucleoprotein core', 78, NULL, NULL, 124959),
(124960, '3.30.160.60-FF-003651', NULL, NULL, 29, NULL, NULL, 124960),
(124961, '3.75.10.10-FF-000022', NULL, NULL, 220, NULL, NULL, 124961),
(124962, '1.25.10.10-FF-002417', NULL, 'Uncharacterized protein', 250, NULL, NULL, 124962),
(124963, '1.20.120.1320-FF-000007', NULL, 'Aspartokinase', 97, NULL, NULL, 124963),
(124964, '3.30.60.30-FF-000190', NULL, 'Osteonectin; SPARC; Uncharacterized protein', 84, NULL, NULL, 124964),
(124965, '3.40.140.10-FF-000075', NULL, 'COP9 signalosome complex subunit 6', 183, NULL, NULL, 124965);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(124966, '3.30.300.210-FF-000002', NULL, 'Ger(X)C family spore germination protein', 156, NULL, NULL, 124966),
(124967, '3.30.160.60-FF-001346', NULL, 'zinc finger protein 398', 27, NULL, NULL, 124967),
(124968, '2.60.40.1390-FF-000027', NULL, 'Transcriptional regulator PacG/VIB-1', 150, NULL, NULL, 124968),
(124969, '3.40.1000.10-FF-000025', NULL, 'RGM domain family, member D', 140, NULL, NULL, 124969),
(124970, '2.30.30.140-FF-000295', NULL, 'Protein lin-61', 79, NULL, NULL, 124970),
(124971, '2.130.10.10-FF-005675', NULL, 'Uncharacterized protein', 161, NULL, NULL, 124971),
(124972, '2.40.30.10-FF-000402', NULL, 'Uncharacterized protein', 86, NULL, NULL, 124972),
(124973, '3.50.50.60-FF-001079', NULL, 'Succinate dehydrogenase (quinone)', 295, NULL, NULL, 124973),
(124974, '2.60.40.60-FF-000911', NULL, 'Uncharacterized protein', 103, NULL, NULL, 124974),
(124975, '3.60.40.10-FF-000170', NULL, 'Type 2C protein phosphatase', 318, NULL, NULL, 124975),
(124976, '3.30.70.330-FF-002385', NULL, NULL, 160, NULL, NULL, 124976),
(124977, '3.30.70.3040-FF-000001', NULL, 'Cell division protein FtsX', 113, NULL, NULL, 124977),
(124978, '1.20.1250.20-FF-001013', NULL, 'Os04g0452600 protein', 129, NULL, NULL, 124978),
(124979, '1.25.40.10-FF-001177', NULL, 'Putative pentatricopeptide repeat-containing protein', 120, NULL, NULL, 124979),
(124980, '3.80.10.10-FF-000583', NULL, '18w protein', 172, NULL, NULL, 124980),
(124981, '2.20.100.10-FF-000159', NULL, 'spondin-1 isoform X1', 82, NULL, NULL, 124981),
(124982, '3.40.250.10-FF-000196', NULL, 'Adenylyltransferase and sulfurtransferase UBA4', 112, NULL, NULL, 124982),
(124983, '1.25.40.10-FF-002537', NULL, 'Pentatricopeptide repeat-containing protein', 164, NULL, NULL, 124983),
(124984, '2.60.98.10-FF-000001', NULL, 'Envelope glycoprotein', 133, NULL, NULL, 124984),
(124985, '3.40.50.1460-FF-000075', NULL, 'Uncharacterized protein', 80, NULL, NULL, 124985),
(124986, '2.30.180.10-FF-000061', NULL, 'Vacuolar membrane protein, putative', 166, NULL, NULL, 124986),
(124987, '3.30.1520.10-FF-000128', NULL, 'Uncharacterized protein', 121, NULL, NULL, 124987),
(124988, '2.40.70.10-FF-000399', NULL, NULL, 179, NULL, NULL, 124988),
(124989, '3.30.70.240-FF-000060', NULL, 'Uncharacterized protein', 35, NULL, NULL, 124989),
(124990, '3.30.200.20-FF-001529', NULL, 'Uncharacterized protein', 107, NULL, NULL, 124990),
(124991, '3.40.190.10-FF-000639', NULL, 'Predicted protein', 109, NULL, NULL, 124991),
(124992, '3.40.1800.20-FF-000021', NULL, 'GD13125', 76, NULL, NULL, 124992),
(124993, '3.10.180.10-FF-000056', NULL, 'Predicted enzyme related to lactoylglutathione lyase', 130, NULL, NULL, 124993),
(124994, '1.10.10.60-FF-000993', NULL, NULL, 76, NULL, NULL, 124994),
(124995, '1.10.533.10-FF-000272', NULL, 'Uncharacterized protein', 125, NULL, NULL, 124995),
(124996, '3.40.50.2000-FF-000563', NULL, 'Glycosyltransferase WbuB', 213, NULL, NULL, 124996),
(124997, '1.10.510.10-FF-002422', NULL, NULL, 176, NULL, NULL, 124997),
(124998, '1.20.1560.10-FF-000769', NULL, 'Uncharacterized protein', 313, NULL, NULL, 124998),
(124999, '1.25.40.20-FF-001585', NULL, 'Uncharacterized protein', 265, NULL, NULL, 124999),
(125000, '3.40.50.720-FF-000809', NULL, 'Very-long-chain 3-oxoacyl-CoA reductase-like protein', 245, NULL, NULL, 125000),
(125001, '3.40.1190.20-FF-000024', NULL, 'Ribokinase', 296, NULL, NULL, 125001),
(125002, '1.25.40.10-FF-005359', NULL, 'Uncharacterized protein', 103, NULL, NULL, 125002),
(125003, '2.130.10.10-FF-001493', NULL, 'WD domain, G-beta repeat-containing protein', 120, NULL, NULL, 125003),
(125004, '3.40.50.1820-FF-000407', NULL, 'Protein FAM135A', 206, NULL, NULL, 125004),
(125005, '1.10.10.10-FF-001809', NULL, 'Uncharacterized protein', 73, NULL, NULL, 125005),
(125006, '3.40.50.1100-FF-000304', NULL, 'Uncharacterized protein', 24, NULL, NULL, 125006),
(125007, '1.20.1260.10-FF-000044', NULL, 'Ferritin', 169, NULL, NULL, 125007),
(125008, '3.30.465.10-FF-000084', NULL, 'Transporter, HlyC/CorC family', 83, NULL, NULL, 125008),
(125009, '2.40.440.10-FF-000006', NULL, 'L,D-transpeptidase catalytic domain', 118, NULL, NULL, 125009);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(125010, '2.60.120.10-FF-000360', NULL, 'Uncharacterized protein', 153, NULL, NULL, 125010),
(125011, '2.10.25.10-FF-000987', NULL, 'Transmembrane cell adhesion receptor mua-3', 37, NULL, NULL, 125011),
(125012, '3.30.365.10-FF-000020', NULL, 'Selenate reductase subunit YgfN', 152, NULL, NULL, 125012),
(125013, '3.30.1360.70-FF-000004', NULL, 'Probable arginine--tRNA ligase, mitochondrial', 111, NULL, NULL, 125013),
(125014, '3.40.50.300-FF-007075', NULL, 'Uncharacterized protein', 297, NULL, NULL, 125014),
(125015, '1.20.58.1070-FF-000019', NULL, 'Survival motor neuron interacting protein', 103, NULL, NULL, 125015),
(125016, '2.30.39.10-FF-000142', NULL, 'Uncharacterized protein', 36, NULL, NULL, 125016),
(125017, '2.60.260.20-FF-000176', NULL, 'Zgc:122979', 64, NULL, NULL, 125017),
(125018, '2.40.10.10-FF-000250', NULL, 'AGAP009216-PA', 119, NULL, NULL, 125018),
(125019, '1.25.10.10-FF-003266', NULL, 'Serine/threonine-protein kinase TOR', 209, NULL, NULL, 125019),
(125020, '2.10.110.10-FF-000089', NULL, 'LIM and SH3 domain protein 1', 64, NULL, NULL, 125020),
(125021, '2.40.50.140-FF-000982', NULL, NULL, 79, NULL, NULL, 125021),
(125022, '2.70.70.10-FF-000044', NULL, 'Protease LasA', 182, NULL, NULL, 125022),
(125023, '2.130.10.10-FF-003027', NULL, 'Protein HIR2', 161, NULL, NULL, 125023),
(125024, '2.30.29.30-FF-000063', NULL, 'Phosphoinositide phospholipase C', 120, NULL, NULL, 125024),
(125025, '1.25.40.10-FF-001705', NULL, 'Pentatricopeptide repeat-containing protein At1g74850, chloroplastic', 118, NULL, NULL, 125025),
(125026, '1.10.287.2250-FF-000012', NULL, 'Senescence-specific cysteine protease SAG39', 83, NULL, NULL, 125026),
(125027, '2.60.220.50-FF-000177', NULL, 'Uncharacterized protein', 73, NULL, NULL, 125027),
(125028, '3.40.50.11210-FF-000009', NULL, 'Uncharacterized protein, isoform H', 149, NULL, NULL, 125028),
(125029, '1.10.510.10-FF-004007', NULL, NULL, 155, NULL, NULL, 125029),
(125030, '2.60.40.150-FF-000265', NULL, 'Inn1p', 128, NULL, NULL, 125030),
(125031, '1.20.140.40-FF-000034', NULL, 'Invertase/pectin methylesterase inhibitor family protein', 172, NULL, NULL, 125031),
(125032, '3.40.50.300-FF-007715', NULL, 'Uncharacterized protein', 97, NULL, NULL, 125032),
(125033, '3.50.50.60-FF-001107', NULL, 'Uncharacterized protein', 207, NULL, NULL, 125033),
(125034, '1.20.1260.110-FF-000001', NULL, 'DNA integrity scanning protein DisA', 146, NULL, NULL, 125034),
(125035, '3.40.50.2000-FF-000804', NULL, 'Uncharacterized protein', 282, NULL, NULL, 125035),
(125036, '3.40.718.10-FF-000046', NULL, 'Isocitrate dehydrogenase [NAD] regulatory subunit 1, mitochondrial', 207, NULL, NULL, 125036),
(125037, '2.40.30.10-FF-000245', NULL, 'Terephthalate 1,2-dioxygenase, reductase component 2', 99, NULL, NULL, 125037),
(125038, '3.40.50.720-FF-002434', NULL, '2-dehydropantoate 2-reductase', 186, NULL, NULL, 125038),
(125039, '3.30.70.1350-FF-000039', NULL, NULL, 81, NULL, NULL, 125039),
(125040, '3.30.160.60-FF-002987', NULL, 'Zinc finger protein 945', 24, NULL, NULL, 125040),
(125041, '3.30.360.20-FF-000001', NULL, 'RNA terminal phosphate cyclase-like 1', 101, NULL, NULL, 125041),
(125042, '1.10.10.10-FF-001456', NULL, 'Transcription initiation factor IIF subunit alpha', 80, NULL, NULL, 125042),
(125043, '2.60.120.10-FF-000601', NULL, 'Mannose-1-phosphate guanylyltransferase/mannose-6-phosphate isomerase', 118, NULL, NULL, 125043),
(125044, '1.20.5.780-FF-000002', NULL, 'FXYD domain-containing ion transport regulator', 72, NULL, NULL, 125044),
(125045, '3.40.570.10-FF-000045', NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase 1', 323, NULL, NULL, 125045),
(125046, '1.20.1070.10-FF-001581', NULL, 'Uncharacterized protein', 158, NULL, NULL, 125046),
(125047, '2.130.10.10-FF-005175', NULL, 'Uncharacterized protein', 127, NULL, NULL, 125047),
(125048, '3.30.70.20-FF-000030', NULL, 'Putative oxidoreductase', 66, NULL, NULL, 125048),
(125049, '1.10.225.10-FF-000005', NULL, 'prosaposin isoform X2', 80, NULL, NULL, 125049),
(125050, '3.40.50.300-FF-003764', NULL, 'Protein CBG17574', 148, NULL, NULL, 125050); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(125051, '2.60.40.1170-FF-000080', NULL, NULL, 116, NULL, NULL, 125051),
(125052, '2.10.70.10-FF-000142', NULL, 'Coagulation factor XIII B chain', 60, NULL, NULL, 125052),
(125053, '3.40.1120.10-FF-000005', NULL, NULL, 108, NULL, NULL, 125053),
(125054, '1.20.1250.20-FF-001513', NULL, 'Uncharacterized protein', 106, NULL, NULL, 125054),
(125055, '3.20.20.70-FF-000671', NULL, NULL, 209, NULL, NULL, 125055),
(125056, '1.25.10.10-FF-002709', NULL, 'Uncharacterized protein', 47, NULL, NULL, 125056),
(125057, '2.40.170.20-FF-000128', NULL, NULL, 120, NULL, NULL, 125057),
(125058, '3.30.200.20-FF-001940', NULL, NULL, 109, NULL, NULL, 125058),
(125059, '3.80.10.10-FF-001021', NULL, 'Leucine-rich receptor-like protein kinase family protein', 98, NULL, NULL, 125059),
(125060, '3.40.50.1820-FF-001190', NULL, 'AGAP004013-PA', 294, NULL, NULL, 125060),
(125061, '3.10.50.40-FF-000092', NULL, 'Peptidylprolyl isomerase', 129, NULL, NULL, 125061),
(125062, '1.20.5.110-FF-000003', NULL, '60S ribosomal protein L13', 46, NULL, NULL, 125062),
(125063, '3.40.50.1700-FF-000035', NULL, 'Beta-N-acetylglucosaminidase, putative', 204, NULL, NULL, 125063),
(125064, '2.60.40.640-FF-000075', NULL, 'pH-response regulator protein palF/RIM8', 140, NULL, NULL, 125064),
(125065, '3.30.70.2740-FF-000006', NULL, 'NAD-independent D-lactate dehydrogenase', 85, NULL, NULL, 125065),
(125066, '3.70.10.10-FF-000021', NULL, 'DNA damage checkpoint', 154, NULL, NULL, 125066),
(125067, '2.60.120.330-FF-000204', NULL, 'Uncharacterized protein', 129, NULL, NULL, 125067),
(125068, '3.40.50.300-FF-000779', NULL, 'Probable ATP-dependent RNA helicase DHR1', 177, NULL, NULL, 125068),
(125069, '3.40.50.80-FF-000158', NULL, 'YALI0F29161p', 129, NULL, NULL, 125069),
(125070, '2.60.40.10-FF-000700', NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein', 91, NULL, NULL, 125070),
(125071, '2.60.40.10-FF-004011', NULL, NULL, 99, NULL, NULL, 125071),
(125072, '2.60.40.1910-FF-000009', NULL, 'Aminopeptidase', 91, NULL, NULL, 125072),
(125073, '3.20.20.140-FF-000038', NULL, 'Adenosine deaminase', 356, NULL, NULL, 125073),
(125074, '3.30.160.60-FF-000806', NULL, 'Zinc finger protein', 28, NULL, NULL, 125074),
(125075, '3.20.180.20-FF-000017', NULL, 'Ciliary dynein heavy chain 11', 109, NULL, NULL, 125075),
(125076, '2.60.40.10-FF-003494', NULL, NULL, 93, NULL, NULL, 125076),
(125077, '3.50.50.60-FF-001259', NULL, 'Uncharacterized protein', 109, NULL, NULL, 125077),
(125078, '1.10.287.70-FF-000615', NULL, 'Uncharacterized protein', 244, NULL, NULL, 125078),
(125079, '3.40.190.120-FF-000002', NULL, 'Osmoprotectant ABC transporter, permease protein', 104, NULL, NULL, 125079),
(125080, '3.40.50.300-FF-007979', NULL, 'Uncharacterized protein', 159, NULL, NULL, 125080),
(125081, '3.40.50.1820-FF-000615', NULL, 'Meta cleavage compound hydrolase', 289, NULL, NULL, 125081),
(125082, '1.10.3430.10-FF-000066', NULL, 'Predicted protein', 68, NULL, NULL, 125082),
(125083, '3.90.730.10-FF-000030', NULL, 'Ribonuclease T2, like', 140, NULL, NULL, 125083),
(125084, '1.25.40.180-FF-000285', NULL, NULL, 146, NULL, NULL, 125084),
(125085, '3.40.50.300-FF-001616', NULL, 'Lsa family ABC-F type ribosomal protection protein', 243, NULL, NULL, 125085),
(125086, '3.30.1520.10-FF-000179', NULL, 'Uncharacterized protein', 98, NULL, NULL, 125086),
(125087, '1.10.533.10-FF-000160', NULL, 'Uncharacterized protein', 91, NULL, NULL, 125087),
(125088, '3.30.200.20-FF-000512', NULL, 'Receptor-like protein kinase HSL1', 100, NULL, NULL, 125088),
(125089, '2.60.40.10-FF-005528', NULL, NULL, 60, NULL, NULL, 125089),
(125090, '3.30.70.330-FF-002885', NULL, NULL, 61, NULL, NULL, 125090),
(125091, '1.20.5.1040-FF-000005', NULL, 'Sensor histidine kinase', 39, NULL, NULL, 125091),
(125092, '3.90.180.10-FF-000116', NULL, 'Alcohol dehydrogenase, zinc-containing', 174, NULL, NULL, 125092),
(125093, '3.80.10.10-FF-000791', NULL, 'F-box/LRR-repeat protein 6 isoform X1', 253, NULL, NULL, 125093),
(125094, '3.40.50.2020-FF-000069', NULL, 'Zgc:174895', 185, NULL, NULL, 125094);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(125095, '3.30.160.60-FF-005972', NULL, NULL, 67, NULL, NULL, 125095),
(125096, '3.10.290.10-FF-000098', NULL, 'Pseudouridine synthase', 54, NULL, NULL, 125096),
(125097, '2.80.10.50-FF-000271', NULL, 'Predicted protein', 111, NULL, NULL, 125097),
(125098, '3.90.1410.10-FF-000033', NULL, 'histone-lysine N-methyltransferase setd3-like isoform X2', 210, NULL, NULL, 125098),
(125099, '2.60.40.60-FF-000170', NULL, 'FAT atypical cadherin 4', 103, NULL, NULL, 125099),
(125100, '3.30.70.330-FF-000648', NULL, 'Polyadenylate-binding protein', 105, NULL, NULL, 125100),
(125101, '3.40.50.300-FF-006355', NULL, 'Uncharacterized protein', 141, NULL, NULL, 125101),
(125102, '1.25.40.10-FF-004611', NULL, 'Uncharacterized protein', 163, NULL, NULL, 125102),
(125103, '1.25.40.180-FF-000054', NULL, 'MIF4G domain containing', 105, NULL, NULL, 125103),
(125104, '3.90.1580.10-FF-000034', NULL, 'Zgc:136465 protein', 112, NULL, NULL, 125104),
(125105, '2.130.10.10-FF-000009', NULL, 'Protein transport protein Sec31A isoform A', 334, NULL, NULL, 125105),
(125106, '2.60.220.30-FF-000019', NULL, 'AGAP009061-PA', 156, NULL, NULL, 125106),
(125107, '3.30.930.10-FF-000424', NULL, 'Lysine--tRNA ligase', 364, NULL, NULL, 125107),
(125108, '4.10.280.10-FF-000054', NULL, 'hairy and enhancer of split-related protein HELT', 66, NULL, NULL, 125108),
(125109, '3.30.590.10-FF-000009', NULL, 'Lengsin, lens protein with glutamine synthetase domain', 329, NULL, NULL, 125109),
(125110, '2.40.40.10-FF-000010', NULL, NULL, 107, NULL, NULL, 125110),
(125111, '2.60.40.10-FF-001138', NULL, 'Sallimus, isoform P', 95, NULL, NULL, 125111),
(125112, '3.40.50.720-FF-001006', NULL, 'GD20759', 198, NULL, NULL, 125112),
(125113, '3.90.550.10-FF-000196', NULL, 'Glycosyl transferase', 202, NULL, NULL, 125113),
(125114, '3.30.200.20-FF-000248', NULL, 'Serine/threonine-protein kinase PBS1', 104, NULL, NULL, 125114),
(125115, '3.30.70.1400-FF-000026', NULL, 'Uncharacterized protein', 55, NULL, NULL, 125115),
(125116, '2.130.10.10-FF-005916', NULL, 'Serine/threonine-protein kinase', 277, NULL, NULL, 125116),
(125117, '1.25.40.10-FF-003094', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 265, NULL, NULL, 125117),
(125118, '1.10.555.10-FF-000053', NULL, 'RhoGAP domain containing protein', 236, NULL, NULL, 125118),
(125119, '3.40.1160.10-FF-000070', NULL, 'Predicted protein', 137, NULL, NULL, 125119),
(125120, '1.10.1270.20-FF-000005', NULL, 'tRNA (guanine-N(1)-)-methyltransferase', 68, NULL, NULL, 125120),
(125121, '3.30.160.60-FF-000065', NULL, 'B-cell CLL/lymphoma 6, member B', 28, NULL, NULL, 125121),
(125122, '3.30.2350.20-FF-000062', NULL, NULL, 241, NULL, NULL, 125122),
(125123, '3.30.40.10-FF-001334', NULL, 'Ubiquitin conjugating enzyme interacting protein, putative', 88, NULL, NULL, 125123),
(125124, '3.30.160.60-FF-001577', NULL, 'Crooked legs, isoform F', 28, NULL, NULL, 125124),
(125125, '1.20.1300.10-FF-000048', NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', 121, NULL, NULL, 125125),
(125126, '3.40.50.850-FF-000028', NULL, 'Nicotinamidase', 211, NULL, NULL, 125126),
(125127, '1.10.510.10-FF-002130', NULL, 'Tyrosine-protein kinase', 273, NULL, NULL, 125127),
(125128, '1.10.8.10-FF-000140', NULL, 'UBX domain-containing protein 2', 64, NULL, NULL, 125128),
(125129, '2.60.40.10-FF-002774', NULL, 'MHC class II antigen beta chain', 106, NULL, NULL, 125129),
(125130, '1.20.58.1590-FF-000001', NULL, 'Tethering factor for nuclear proteasome STS1', 201, NULL, NULL, 125130),
(125131, '1.25.40.10-FF-001969', NULL, 'Pentatricopeptide repeat-containing protein At1g06140, mitochondrial', 100, NULL, NULL, 125131),
(125132, '1.20.58.60-FF-000804', NULL, 'Predicted protein', 203, NULL, NULL, 125132),
(125133, '2.60.120.380-FF-000062', NULL, 'Calpain-5', 144, NULL, NULL, 125133),
(125134, '3.60.10.10-FF-000162', NULL, 'Predicted protein', 403, NULL, NULL, 125134),
(125135, '1.10.287.110-FF-000420', NULL, 'DnaJ-like protein', 95, NULL, NULL, 125135),
(125136, '1.20.1250.20-FF-001305', NULL, 'Uncharacterized protein', 187, NULL, NULL, 125136);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(125137, '2.30.34.10-FF-000007', NULL, 'Predicted protein', 86, NULL, NULL, 125137),
(125138, '3.20.20.80-FF-000399', NULL, 'Lactase-like protein', 358, NULL, NULL, 125138),
(125139, '2.30.29.30-FF-000804', NULL, 'ADR388Cp', 172, NULL, NULL, 125139),
(125140, '3.10.100.10-FF-000113', NULL, 'CD72 molecule', 131, NULL, NULL, 125140),
(125141, '3.40.50.150-FF-001650', NULL, NULL, 127, NULL, NULL, 125141),
(125142, '3.40.50.10190-FF-000271', NULL, 'DNA topoisomerase 2-binding protein 1-A', 98, NULL, NULL, 125142),
(125143, '3.10.100.10-FF-000225', NULL, NULL, 152, NULL, NULL, 125143),
(125144, '3.20.20.140-FF-000302', NULL, 'Uncharacterized protein', 220, NULL, NULL, 125144),
(125145, '3.40.50.720-FF-000017', NULL, 'Malate dehydrogenase', 145, NULL, NULL, 125145),
(125146, '1.10.1200.10-FF-000133', NULL, 'Uncharacterized protein', 69, NULL, NULL, 125146),
(125147, '3.50.50.60-FF-000915', NULL, 'L-lysine 6-monooxygenase', 437, NULL, NULL, 125147),
(125148, '3.60.20.10-FF-000247', NULL, NULL, 55, NULL, NULL, 125148),
(125149, '3.30.70.330-FF-002677', NULL, NULL, 150, NULL, NULL, 125149),
(125150, '1.25.10.10-FF-000411', NULL, 'protein VAC14 homolog', 125, NULL, NULL, 125150),
(125151, '2.60.40.10-FF-005680', NULL, NULL, 82, NULL, NULL, 125151),
(125152, '1.25.40.20-FF-001877', NULL, 'Kinase, NEK', 123, NULL, NULL, 125152),
(125153, '1.10.10.830-FF-000006', NULL, 'Isoleucine--tRNA ligase', 51, NULL, NULL, 125153),
(125154, '1.20.1270.60-FF-000104', NULL, 'Unplaced genomic scaffold supercont1.20, whole genome shotgun sequence', 273, NULL, NULL, 125154),
(125155, '1.10.2000.10-FF-000016', NULL, 'Frizzled', 124, NULL, NULL, 125155),
(125156, '1.10.510.10-FF-001692', NULL, 'Gamma-glutamylcyclotransferase', 94, NULL, NULL, 125156),
(125157, '1.10.10.10-FF-000096', NULL, 'Rap guanine nucleotide exchange factor 4', 105, NULL, NULL, 125157),
(125158, '3.30.420.10-FF-000615', NULL, NULL, 176, NULL, NULL, 125158),
(125159, '3.30.160.20-FF-000053', NULL, 'protein SON isoform X1', 77, NULL, NULL, 125159),
(125160, '3.30.200.20-FF-001237', NULL, 'Os04g0370100 protein', 104, NULL, NULL, 125160),
(125161, '3.40.50.300-FF-000627', NULL, 'Methylenetetrahydrofolate dehydrogenase (NADP+ dependent) 1 like', 250, NULL, NULL, 125161),
(125162, '1.10.20.10-FF-000057', NULL, 'ankyrin repeat and BTB/POZ domain-containing protein 2', 188, NULL, NULL, 125162),
(125163, '1.10.10.650-FF-000008', NULL, 'Transcription elongation factor SPT6', 164, NULL, NULL, 125163),
(125164, '2.40.70.10-FF-000079', NULL, 'Putative aspartic proteinase nepenthesin II', 176, NULL, NULL, 125164),
(125165, '1.20.120.160-FF-000023', NULL, 'Gliding motility regulatory protein', 127, NULL, NULL, 125165),
(125166, '1.20.120.350-FF-000046', NULL, 'Potassium voltage-gated channel subfamily F member 1', 152, NULL, NULL, 125166),
(125167, '3.40.50.2000-FF-000119', NULL, 'Glycosyl transferase group 1', 188, NULL, NULL, 125167),
(125168, '2.130.10.10-FF-003207', NULL, 'Uncharacterized protein', 81, NULL, NULL, 125168),
(125169, '3.40.190.10-FF-000319', NULL, 'LysR family transcriptional regulator', 104, NULL, NULL, 125169),
(125170, '3.30.70.330-FF-000468', NULL, 'Related to single-stranded DNA-binding protein MSSP-1', 100, NULL, NULL, 125170),
(125171, '1.20.1050.10-FF-000298', NULL, 'Glutathione s-transferase', 74, NULL, NULL, 125171),
(125172, '2.30.42.10-FF-000262', NULL, 'Golgi reassembly stacking protein', 100, NULL, NULL, 125172),
(125173, '3.40.50.1100-FF-000012', NULL, 'Threonine synthase', 100, NULL, NULL, 125173),
(125174, '3.30.479.20-FF-000023', NULL, 'Elongation factor Ts', 97, NULL, NULL, 125174),
(125175, '1.25.40.10-FF-005128', NULL, 'Uncharacterized protein', 106, NULL, NULL, 125175),
(125176, '3.80.10.10-FF-002589', NULL, 'Leucine-rich repeat-containing protein 29', 93, NULL, NULL, 125176),
(125177, '1.25.10.10-FF-002985', NULL, 'Proteasome component ecm29', 382, NULL, NULL, 125177),
(125178, '4.10.1240.10-FF-000083', NULL, 'Uncharacterized protein (Fragment)', 56, NULL, NULL, 125178),
(125179, '3.40.50.300-FF-005630', NULL, 'ABC transporter, putative', 46, NULL, NULL, 125179);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(125180, '3.30.1330.100-FF-000002', NULL, 'Coenzyme F420:L-glutamate ligase', 44, NULL, NULL, 125180),
(125181, '3.40.50.2300-FF-000794', NULL, NULL, 128, NULL, NULL, 125181),
(125182, '3.30.1330.20-FF-000061', NULL, 'Uncharacterized protein', 41, NULL, NULL, 125182),
(125183, '3.40.50.10330-FF-000060', NULL, 'NAD kinase', 105, NULL, NULL, 125183),
(125184, '3.40.50.1110-FF-000072', NULL, 'Lipase/acylhydrolase, GDSL family', 197, NULL, NULL, 125184),
(125185, '2.60.40.10-FF-001077', NULL, 'T-lymphocyte activation antigen CD80', 105, NULL, NULL, 125185),
(125186, '1.50.10.10-FF-000055', NULL, 'alpha-1,2-Mannosidase', 467, NULL, NULL, 125186),
(125187, '1.25.40.10-FF-004454', NULL, 'Predicted protein', 114, NULL, NULL, 125187),
(125188, '1.10.10.60-FF-000150', NULL, 'POU domain protein', 59, NULL, NULL, 125188),
(125189, '3.30.160.60-FF-003943', NULL, NULL, 21, NULL, NULL, 125189),
(125190, '1.25.40.10-FF-003673', NULL, 'Putative pentatricopeptide repeat-containing protein At1g12700, mitochondrial', 67, NULL, NULL, 125190),
(125191, '2.40.50.140-FF-000870', NULL, NULL, 93, NULL, NULL, 125191),
(125192, '1.25.40.10-FF-000008', NULL, 'Peptidylprolyl isomerase', 156, NULL, NULL, 125192),
(125193, '2.10.25.10-FF-000919', NULL, 'Uncharacterized protein', 36, NULL, NULL, 125193),
(125194, '3.60.40.10-FF-000231', NULL, 'Stage II sporulation E family protein', 253, NULL, NULL, 125194),
(125195, '1.10.10.60-FF-000493', NULL, 'Homeobox protein Ved', 60, NULL, NULL, 125195),
(125196, '1.20.140.150-FF-000018', NULL, 'Transmembrane protein 178B', 128, NULL, NULL, 125196),
(125197, '2.10.109.10-FF-000075', NULL, 'Uncharacterized protein HI_1546', 104, NULL, NULL, 125197),
(125198, '3.60.130.10-FF-000036', NULL, 'Uncharacterized protein', 285, NULL, NULL, 125198),
(125199, '3.30.40.10-FF-001834', NULL, 'Uncharacterized protein', 57, NULL, NULL, 125199),
(125200, '3.30.160.60-FF-005000', NULL, NULL, 47, NULL, NULL, 125200),
(125201, '2.60.120.330-FF-000143', NULL, 'Gibberellin 2-beta-dioxygenase 8', 106, NULL, NULL, 125201),
(125202, '1.10.3470.10-FF-000063', NULL, 'Putative ABC transporter permease protein MJ0876', 348, NULL, NULL, 125202),
(125203, '3.90.1150.10-FF-000434', NULL, 'Glutamic-oxaloacetic transaminase 1, soluble', 27, NULL, NULL, 125203),
(125204, '1.20.58.60-FF-000647', NULL, 'Uncharacterized protein', 204, NULL, NULL, 125204),
(125205, '3.40.50.720-FF-001978', NULL, '(S)-1-Phenylethanol dehydrogenase', 249, NULL, NULL, 125205),
(125206, '3.40.50.300-FF-000274', NULL, 'ras-related protein RABA5a', 212, NULL, NULL, 125206),
(125207, '3.40.1170.10-FF-000020', NULL, 'Predicted protein', 121, NULL, NULL, 125207),
(125208, '3.30.160.60-FF-004668', NULL, NULL, 26, NULL, NULL, 125208),
(125209, '2.60.40.10-FF-003847', NULL, NULL, 69, NULL, NULL, 125209),
(125210, '2.60.40.2030-FF-000023', NULL, 'Adhesion G protein-coupled receptor V1', 126, NULL, NULL, 125210),
(125211, '3.90.70.10-FF-000479', NULL, 'Cathepsin K-like', 316, NULL, NULL, 125211),
(125212, '1.10.1410.10-FF-000115', NULL, 'Nucleolar protein 6', 87, NULL, NULL, 125212),
(125213, '2.60.370.10-FF-000001', NULL, 'COX11 cytochrome c oxidase assembly homolog', 135, NULL, NULL, 125213),
(125214, '3.30.70.580-FF-000026', NULL, 'Pseudouridine synthase', 79, NULL, NULL, 125214),
(125215, '1.20.1310.20-FF-000046', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 240, NULL, NULL, 125215),
(125216, '3.40.50.200-FF-000070', NULL, 'Gob-1', 293, NULL, NULL, 125216),
(125217, '3.40.50.410-FF-000368', NULL, 'Uncharacterized protein', 206, NULL, NULL, 125217),
(125218, '3.40.20.10-FF-000006', NULL, 'Protein transport protein SEC23', 106, NULL, NULL, 125218),
(125219, '3.40.50.150-FF-001493', NULL, NULL, 118, NULL, NULL, 125219),
(125220, '1.10.630.10-FF-000683', NULL, 'Cytochrome P450, family 2, subfamily j, polypeptide 13', 156, NULL, NULL, 125220),
(125221, '3.40.50.1820-FF-000397', NULL, 'YAL049C-like protein', 220, NULL, NULL, 125221),
(125222, '2.40.50.1060-FF-000006', NULL, 'TWIST neighbor', 167, NULL, NULL, 125222),
(125223, '3.20.180.10-FF-000003', NULL, 'Heme oxygenase HugZ', 81, NULL, NULL, 125223);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(125224, '3.40.50.880-FF-000200', NULL, 'CTP synthase', 107, NULL, NULL, 125224),
(125225, '1.10.20.10-FF-000265', NULL, NULL, 60, NULL, NULL, 125225),
(125226, '3.30.160.60-FF-000453', NULL, 'GLIS family zinc finger 3', 30, NULL, NULL, 125226),
(125227, '3.40.50.1000-FF-000331', NULL, 'Phospholipid-transporting ATPase', 143, NULL, NULL, 125227),
(125228, '2.10.110.10-FF-000269', NULL, 'LIM and senescent cell antigen-like-containing domain protein 1', 61, NULL, NULL, 125228),
(125229, '3.30.160.60-FF-002482', NULL, 'Uncharacterized protein', 28, NULL, NULL, 125229),
(125230, '1.20.1110.10-FF-000028', NULL, 'ATPase, P-type, K/Mg/Cd/Cu/Zn/Na/Ca/Na/H-transporter', 319, NULL, NULL, 125230),
(125231, '3.30.530.20-FF-000060', NULL, 'Polyketide cyclase/dehydrase/lipid transport superfamily protein', 201, NULL, NULL, 125231),
(125232, '1.10.540.10-FF-000125', NULL, 'Uncharacterized protein', 122, NULL, NULL, 125232),
(125233, '1.25.10.10-FF-002209', NULL, 'Uncharacterized protein', 427, NULL, NULL, 125233),
(125234, '2.60.40.10-FF-000621', NULL, 'Immunoglobulin superfamily member 10', 88, NULL, NULL, 125234),
(125235, '1.10.510.10-FF-001484', NULL, 'Predicted protein', 188, NULL, NULL, 125235),
(125236, '3.30.420.10-FF-000115', NULL, 'Ribonuclease H', 153, NULL, NULL, 125236),
(125237, '3.40.50.620-FF-000605', NULL, 'Two-component hybrid sensor and regulator', 141, NULL, NULL, 125237),
(125238, '2.60.40.150-FF-000501', NULL, 'Predicted protein', 125, NULL, NULL, 125238),
(125239, '1.20.58.900-FF-000021', NULL, 'GM19009', 226, NULL, NULL, 125239),
(125240, '1.10.287.70-FF-000767', NULL, 'Uncharacterized protein', 98, NULL, NULL, 125240),
(125241, '3.40.50.2000-FF-000187', NULL, 'Glycogen synthase', 262, NULL, NULL, 125241),
(125242, '1.10.287.700-FF-000007', NULL, 'Tail tape measure protein gp18', 99, NULL, NULL, 125242),
(125243, '3.30.420.40-FF-001018', NULL, 'Protein CBG19479', 51, NULL, NULL, 125243),
(125244, '1.10.1370.10-FF-000009', NULL, 'Putative mitochondrial intermediate peptidase', 279, NULL, NULL, 125244),
(125245, '1.10.579.10-FF-000001', NULL, 'Cryptochrome 1', 195, NULL, NULL, 125245),
(125246, '3.20.20.70-FF-000519', NULL, 'Imidazole glycerol phosphate synthase subunit HisF', 272, NULL, NULL, 125246),
(125247, '2.60.450.10-FF-000002', NULL, 'Lipopolysaccharide export system protein LptA', 137, NULL, NULL, 125247),
(125248, '3.50.50.100-FF-000054', NULL, 'Predicted protein', 415, NULL, NULL, 125248),
(125249, '1.25.10.10-FF-002485', NULL, 'ARM repeat superfamily protein', 209, NULL, NULL, 125249),
(125250, '2.30.30.100-FF-000098', NULL, 'U6 snRNA-associated Sm-like protein LSm7', 102, NULL, NULL, 125250),
(125251, '3.40.50.300-FF-005450', NULL, 'ATP-binding cassette sub-family A member 3-like isoform X3', 245, NULL, NULL, 125251),
(125252, '1.20.58.60-FF-000304', NULL, 'Microtubule-actin cross-linking factor 1', 225, NULL, NULL, 125252),
(125253, '2.60.120.430-FF-000004', NULL, 'Putative leucine-rich repeat receptor-like serine/threonine-protein kinase', 192, NULL, NULL, 125253),
(125254, '1.20.1070.10-FF-000709', NULL, 'Uncharacterized protein', 305, NULL, NULL, 125254),
(125255, '1.20.1070.10-FF-000861', NULL, 'Uncharacterized protein', 266, NULL, NULL, 125255),
(125256, '1.25.40.20-FF-000106', NULL, 'Ankyrin repeat domain-containing protein 2', 78, NULL, NULL, 125256),
(125257, '1.25.40.10-FF-002037', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform A', 117, NULL, NULL, 125257),
(125258, '2.30.130.10-FF-000013', NULL, 'H/ACA ribonucleoprotein complex subunit DKC1', 33, NULL, NULL, 125258),
(125259, '3.30.200.20-FF-001029', NULL, 'Serine/threonine protein kinase, putative', 89, NULL, NULL, 125259),
(125260, '3.40.50.10810-FF-000114', NULL, 'DNA repair protein rad8', 262, NULL, NULL, 125260),
(125261, '1.20.120.350-FF-000254', NULL, NULL, 132, NULL, NULL, 125261),
(125262, '1.25.40.10-FF-004954', NULL, 'TPR Domain containing protein', 315, NULL, NULL, 125262),
(125263, '3.40.190.10-FF-000527', NULL, 'Norspermidine sensor', 151, NULL, NULL, 125263),
(125264, '3.30.70.330-FF-000709', NULL, 'RNA binding motif protein 28', 109, NULL, NULL, 125264);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(125265, '2.10.70.10-FF-000266', NULL, 'Uncharacterized protein', 68, NULL, NULL, 125265),
(125266, '3.30.160.60-FF-003443', NULL, NULL, 32, NULL, NULL, 125266),
(125267, '2.60.40.60-FF-001007', NULL, 'Uncharacterized protein', 103, NULL, NULL, 125267),
(125268, '3.80.10.10-FF-001572', NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', 197, NULL, NULL, 125268),
(125269, '3.40.50.720-FF-002355', NULL, 'Uncharacterized protein', 202, NULL, NULL, 125269),
(125270, '3.40.50.1820-FF-001414', NULL, 'Uncharacterized protein', 202, NULL, NULL, 125270),
(125271, '3.30.160.60-FF-003763', NULL, NULL, 30, NULL, NULL, 125271),
(125272, '3.40.50.2000-FF-000451', NULL, 'Group 1 glycosyl transferase', 167, NULL, NULL, 125272),
(125273, '2.40.50.100-FF-000077', NULL, 'Glycoside hydrolase family 43', 63, NULL, NULL, 125273),
(125274, '3.60.10.10-FF-000403', NULL, 'Os05g0535600 protein', 182, NULL, NULL, 125274),
(125275, '3.40.50.10490-FF-000124', NULL, 'Predicted protein', 300, NULL, NULL, 125275),
(125276, '1.20.1560.10-FF-000056', NULL, 'Alpha-hemolysin translocation ATP-binding protein HlyB', 312, NULL, NULL, 125276),
(125277, '3.30.1330.80-FF-000005', NULL, 'AT-hook motif nuclear-localized protein', 149, NULL, NULL, 125277),
(125278, '2.40.10.10-FF-000070', NULL, 'Urokinase-type plasminogen activator', 113, NULL, NULL, 125278),
(125279, '1.20.5.190-FF-000151', NULL, NULL, 50, NULL, NULL, 125279),
(125280, '2.60.40.10-FF-004331', NULL, NULL, 77, NULL, NULL, 125280),
(125281, '1.10.1030.10-FF-000018', NULL, 'Carbamoyl phosphate synthase, large subunit', 118, NULL, NULL, 125281),
(125282, '3.40.50.300-FF-001684', NULL, 'Intraflagellar transport 27 homolog (Chlamydomonas)', 185, NULL, NULL, 125282),
(125283, '3.40.50.11350-FF-000034', NULL, 'Galactoside 2-alpha-L-fucosyltransferase', 149, NULL, NULL, 125283),
(125284, '2.30.39.10-FF-000063', NULL, 'Leukocyte elastase inhibitor, putative', 145, NULL, NULL, 125284),
(125285, '3.40.50.11380-FF-000021', NULL, NULL, 11, NULL, NULL, 125285),
(125286, '3.40.50.620-FF-000869', NULL, 'Putative tRNA synthetase', 347, NULL, NULL, 125286),
(125287, '1.25.40.10-FF-003330', NULL, 'Uncharacterized protein', 100, NULL, NULL, 125287),
(125288, '2.60.40.1670-FF-000016', NULL, 'SEC24 family, member B', 54, NULL, NULL, 125288),
(125289, '3.30.2160.10-FF-000078', NULL, 'Probable ubiquitin fusion degradation protein C12B10.01c', 82, NULL, NULL, 125289),
(125290, '3.30.40.10-FF-000553', NULL, 'Zinc finger, C3HC4 type family protein', 65, NULL, NULL, 125290),
(125291, '2.10.220.10-FF-000159', NULL, 'Uncharacterized protein', 103, NULL, NULL, 125291),
(125292, '3.10.129.10-FF-000100', NULL, 'Related to acyl-coa thioester hydrolase', 148, NULL, NULL, 125292),
(125293, '2.60.120.1540-FF-000022', NULL, 'Uncharacterized protein', 56, NULL, NULL, 125293),
(125294, '3.40.50.150-FF-000301', NULL, 'Calmodulin-lysine N-methyltransferase isoform B', 274, NULL, NULL, 125294),
(125295, '3.90.810.10-FF-000031', NULL, NULL, 67, NULL, NULL, 125295),
(125296, '3.90.15.10-FF-000003', NULL, 'DNA topoisomerase I', 149, NULL, NULL, 125296),
(125297, '2.170.270.10-FF-000102', NULL, 'AGAP013275-PA', 179, NULL, NULL, 125297),
(125298, '1.10.10.750-FF-000021', NULL, 'Predicted protein', 45, NULL, NULL, 125298),
(125299, '3.40.390.10-FF-000059', NULL, 'Oligopeptidase, putative', 153, NULL, NULL, 125299),
(125300, '1.10.510.10-FF-004507', NULL, NULL, 42, NULL, NULL, 125300),
(125301, '2.130.10.10-FF-005736', NULL, 'Uncharacterized protein', 131, NULL, NULL, 125301),
(125302, '3.40.1190.20-FF-000232', NULL, NULL, 357, NULL, NULL, 125302),
(125303, '1.25.40.60-FF-000006', NULL, 'Sec1 family superfamily', 126, NULL, NULL, 125303),
(125304, '1.25.10.10-FF-001580', NULL, 'AP complex subunit beta', 531, NULL, NULL, 125304),
(125305, '1.20.930.40-FF-000038', NULL, 'Glutamate carboxypeptidase, putative', 84, NULL, NULL, 125305),
(125306, '3.50.50.60-FF-000983', NULL, 'FAD/NAD(P)-binding domain-containing protein', 75, NULL, NULL, 125306),
(125307, '1.10.3520.10-FF-000028', NULL, 'Uncharacterized protein', 172, NULL, NULL, 125307);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(125308, '2.60.40.10-FF-004511', NULL, NULL, 100, NULL, NULL, 125308),
(125309, '1.10.510.10-FF-000056', NULL, 'calcium-dependent protein kinase 1', 180, NULL, NULL, 125309),
(125310, '2.70.130.10-FF-000133', NULL, NULL, 115, NULL, NULL, 125310),
(125311, '3.40.50.720-FF-001074', NULL, 'Predicted protein', 301, NULL, NULL, 125311),
(125312, '1.20.120.1600-FF-000001', NULL, 'HAD hydrolase, family IA', 87, NULL, NULL, 125312),
(125313, '1.20.1280.50-FF-000220', NULL, 'Uncharacterized protein', 55, NULL, NULL, 125313),
(125314, '1.25.40.20-FF-000449', NULL, 'Ankyrin repeat domain-containing protein 50', 109, NULL, NULL, 125314),
(125315, '3.90.180.10-FF-000055', NULL, 'GroES-like protein', 342, NULL, NULL, 125315),
(125316, '3.90.640.10-FF-000135', NULL, 'Uncharacterized protein', 79, NULL, NULL, 125316),
(125317, '2.40.70.10-FF-000287', NULL, 'Pepsin A', 157, NULL, NULL, 125317),
(125318, '1.20.1070.10-FF-002098', NULL, 'Uncharacterized protein', 376, NULL, NULL, 125318),
(125319, '1.10.8.430-FF-000006', NULL, 'Disease resistance protein Piks-2', 91, NULL, NULL, 125319),
(125320, '1.20.1110.10-FF-000180', NULL, NULL, 211, NULL, NULL, 125320),
(125321, '2.60.40.2130-FF-000019', NULL, 'Uncharacterized protein', 57, NULL, NULL, 125321),
(125322, '3.20.140.10-FF-000006', NULL, 'Nicotinate phosphoribosyltransferase', 163, NULL, NULL, 125322),
(125323, '3.40.50.300-FF-002140', NULL, 'Small GTP-binding protein Rab11', 203, NULL, NULL, 125323),
(125324, '1.10.287.1890-FF-000005', NULL, 'tRNA-m1A22 methylase', 66, NULL, NULL, 125324),
(125325, '1.20.58.1120-FF-000006', NULL, 'cytoplasmic dynein 2 heavy chain 1', 155, NULL, NULL, 125325),
(125326, '2.10.25.10-FF-000015', NULL, 'neurexin-1 isoform X1', 41, NULL, NULL, 125326),
(125327, '1.20.140.100-FF-000032', NULL, 'Inner dynein arm 1 heavy chain 1-ALPHa', 153, NULL, NULL, 125327),
(125328, '2.70.160.11-FF-000035', NULL, 'Protein arginine N-methyltransferase', 161, NULL, NULL, 125328),
(125329, '4.10.280.10-FF-000234', NULL, 'Helix Loop Helix', 67, NULL, NULL, 125329),
(125330, '2.10.60.10-FF-000052', NULL, 'Irditoxin subunit B', 77, NULL, NULL, 125330),
(125331, '3.30.1120.30-FF-000025', NULL, 'Serine/threonine-protein kinase', 51, NULL, NULL, 125331),
(125332, '3.40.1170.60-FF-000006', NULL, 'DNA polymerase iota', 58, NULL, NULL, 125332),
(125333, '3.20.20.10-FF-000052', NULL, 'Pyridoxal phosphate homeostasis protein', 212, NULL, NULL, 125333),
(125334, '3.90.550.10-FF-000432', NULL, 'Uncharacterized protein', 201, NULL, NULL, 125334),
(125335, '3.30.40.10-FF-000474', NULL, 'CLUMA_CG009069, isoform A', 78, NULL, NULL, 125335),
(125336, '1.10.630.10-FF-000340', NULL, 'Cytochrome P450 1A1', 74, NULL, NULL, 125336),
(125337, '2.40.50.140-FF-000459', NULL, 'ATP-dependent DNA helicase RecG', 90, NULL, NULL, 125337),
(125338, '3.40.630.30-FF-000438', NULL, 'Acetyltransferase', 85, NULL, NULL, 125338),
(125339, '1.50.40.10-FF-000500', NULL, 'Uncharacterized protein', 262, NULL, NULL, 125339),
(125340, '3.30.70.3490-FF-000046', NULL, NULL, 140, NULL, NULL, 125340),
(125341, '1.25.40.120-FF-000031', NULL, 'RAB geranylgeranyl transferase alpha subunit, putative', 298, NULL, NULL, 125341),
(125342, '1.20.1560.10-FF-000617', NULL, 'Protein CBR-PGP-8', 21, NULL, NULL, 125342),
(125343, '3.40.30.10-FF-000243', NULL, 'Prostamide/prostaglandin F synthase', 174, NULL, NULL, 125343),
(125344, '4.10.400.10-FF-000059', NULL, 'Prolow-density lipoprotein receptor-related protein 1', 38, NULL, NULL, 125344),
(125345, '3.30.230.10-FF-000168', NULL, 'Putative kinase', 134, NULL, NULL, 125345),
(125346, '3.30.230.120-FF-000009', NULL, 'D-glycero-alpha-D-manno-heptose 7-phosphate kinase', 347, NULL, NULL, 125346),
(125347, '2.60.40.420-FF-000037', NULL, 'Ceruloplasmin', 152, NULL, NULL, 125347),
(125348, '3.40.50.1000-FF-000196', NULL, 'HAD family hydrolase', 129, NULL, NULL, 125348),
(125349, '1.20.1560.10-FF-000320', NULL, 'ABC transporter ATP-binding protein', 316, NULL, NULL, 125349),
(125350, '1.10.287.70-FF-000262', NULL, 'Cyclic nucleotide-gated ion channel 2', 223, NULL, NULL, 125350);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(125351, '3.10.20.90-FF-000407', NULL, 'Small ubiquitin-related modifier 2 isoform A', 95, NULL, NULL, 125351),
(125352, '4.10.240.10-FF-000057', NULL, 'Transcription factor PDR3', 61, NULL, NULL, 125352),
(125353, '2.102.10.10-FF-000039', NULL, 'Rieske (2Fe-2S) domain-containing protein', 126, NULL, NULL, 125353),
(125354, '2.60.120.200-FF-000284', NULL, 'Cadherin-related hmr-1', 196, NULL, NULL, 125354),
(125355, '2.60.120.10-FF-000421', NULL, 'bifunctional peptidase and (3S)-lysyl hydroxylase JMJD7 isoform X1', 77, NULL, NULL, 125355),
(125356, '1.20.58.60-FF-000568', NULL, 'Uncharacterized protein', 277, NULL, NULL, 125356),
(125357, '3.40.50.12760-FF-000007', NULL, 'CMTR1 isoform 3', 64, NULL, NULL, 125357),
(125358, '2.60.120.260-FF-000627', NULL, 'Reelin', 121, NULL, NULL, 125358),
(125359, '1.20.5.1940-FF-000005', NULL, 'Hse1p', 87, NULL, NULL, 125359),
(125360, '2.40.20.10-FF-000008', NULL, 'Hepatocyte growth factor', 92, NULL, NULL, 125360),
(125361, '2.60.40.10-FF-000357', NULL, 'Fc receptor like 1', 92, NULL, NULL, 125361),
(125362, '3.30.505.10-FF-000200', NULL, NULL, 103, NULL, NULL, 125362),
(125363, '3.90.70.10-FF-000136', NULL, 'Ubiquitin C-terminal hydrolase, putative', 340, NULL, NULL, 125363),
(125364, '1.20.5.110-FF-000211', NULL, 'Si:ch211-208k15.1', 104, NULL, NULL, 125364),
(125365, '2.30.29.30-FF-000416', NULL, 'Cell 12A endoglucanase', 119, NULL, NULL, 125365),
(125366, '3.40.50.1820-FF-000958', NULL, 'Alpha/beta hydrolase fold-containing protein', 286, NULL, NULL, 125366),
(125367, '3.40.50.300-FF-007636', NULL, 'Uncharacterized protein', 142, NULL, NULL, 125367),
(125368, '3.30.430.20-FF-000057', NULL, 'Plasmodesmata-located protein 4', 97, NULL, NULL, 125368),
(125369, '3.30.1490.120-FF-000020', NULL, 'Uncharacterized protein', 47, NULL, NULL, 125369),
(125370, '1.10.30.10-FF-000007', NULL, 'Transcription factor SOX', 80, NULL, NULL, 125370),
(125371, '3.10.20.700-FF-000001', NULL, 'Group 4 capsule (G4C) polysaccharide, YmcB', 74, NULL, NULL, 125371),
(125372, '3.80.10.10-FF-002269', NULL, 'F-box protein At-B', 98, NULL, NULL, 125372),
(125373, '2.130.10.10-FF-002302', NULL, 'Coatomer protein complex, subunit alpha', 130, NULL, NULL, 125373),
(125374, '3.30.40.10-FF-000210', NULL, 'E3 ubiquitin-protein ligase TRAF7 isoform X1', 47, NULL, NULL, 125374),
(125375, '3.40.1390.20-FF-000005', NULL, 'HPr kinase/phosphorylase', 128, NULL, NULL, 125375),
(125376, '3.40.640.10-FF-000517', NULL, 'Uncharacterized protein', 59, NULL, NULL, 125376),
(125377, '3.30.1330.40-FF-000049', NULL, 'Predicted protein', 109, NULL, NULL, 125377),
(125378, '2.40.50.140-FF-001258', NULL, NULL, 55, NULL, NULL, 125378),
(125379, '3.30.70.330-FF-000148', NULL, 'Putative CUGBP Elav-like family member 3', 114, NULL, NULL, 125379),
(125380, '3.50.50.60-FF-000011', NULL, 'Glycerol-3-phosphate dehydrogenase', 205, NULL, NULL, 125380),
(125381, '2.60.40.10-FF-005028', NULL, NULL, 104, NULL, NULL, 125381),
(125382, '3.80.10.10-FF-003106', NULL, 'Uncharacterized protein', 106, NULL, NULL, 125382),
(125383, '3.40.50.300-FF-004202', NULL, 'tRNA isopentenyltransferase, putative (AFU_orthologue AFUA_6G05070)', 168, NULL, NULL, 125383),
(125384, '2.130.10.10-FF-003527', NULL, 'Probable U3 small nucleolar RNA-associated protein 13', 137, NULL, NULL, 125384),
(125385, '1.10.8.60-FF-000514', NULL, 'Uncharacterized protein', 55, NULL, NULL, 125385),
(125386, '2.60.120.970-FF-000109', NULL, 'Uncharacterized protein', 133, NULL, NULL, 125386),
(125387, '3.40.1500.20-FF-000004', NULL, 'Os10g0389100 protein', 153, NULL, NULL, 125387),
(125388, '1.25.10.10-FF-000332', NULL, 'Ran-binding protein 17', 398, NULL, NULL, 125388),
(125389, '3.90.190.10-FF-000292', NULL, 'Uncharacterized protein', 149, NULL, NULL, 125389),
(125390, '1.20.1740.10-FF-000042', NULL, 'Similar to amino acid transporter', 452, NULL, NULL, 125390),
(125391, '2.60.40.10-FF-001717', NULL, 'Interleukin 12 receptor subunit beta 1', 105, NULL, NULL, 125391),
(125392, '2.40.110.10-FF-000021', NULL, 'Flavin-dependent monooxygenase, oxygenase subunit', 95, NULL, NULL, 125392);
INSERT INTO "PUBLIC"."MODEL" VALUES
(125393, '3.40.50.300-FF-001408', NULL, 'GTP-binding protein homolog', 224, NULL, NULL, 125393),
(125394, '3.40.50.12780-FF-000165', NULL, 'Uncharacterized protein', 408, NULL, NULL, 125394),
(125395, '1.10.1200.10-FF-000054', NULL, 'Fatty-acid-CoA ligase FadD9', 87, NULL, NULL, 125395),
(125396, '3.30.70.360-FF-000011', NULL, 'Succinyl-diaminopimelate desuccinylase', 113, NULL, NULL, 125396),
(125397, '3.30.470.20-FF-000234', NULL, 'Predicted protein', 81, NULL, NULL, 125397),
(125398, '3.40.1550.20-FF-000007', NULL, 'Transcriptional regulator MraZ', 139, NULL, NULL, 125398),
(125399, '1.20.5.170-FF-000257', NULL, 'Uncharacterized protein', 48, NULL, NULL, 125399),
(125400, '3.40.50.620-FF-000526', NULL, 'Putative pantetheine-phosphate adenylyltransferase', 152, NULL, NULL, 125400),
(125401, '2.170.300.10-FF-000100', NULL, 'Scavenger receptor class F, member 1', 43, NULL, NULL, 125401),
(125402, '3.40.1810.10-FF-000036', NULL, 'Agamous-like MADS-box protein AGL3 isoform A', 65, NULL, NULL, 125402),
(125403, '3.40.50.720-FF-002086', NULL, 'Nicotinamide nucleotide transhydrogenase 2', 139, NULL, NULL, 125403),
(125404, '3.40.850.10-FF-000550', NULL, 'Kinesin-like protein', 186, NULL, NULL, 125404),
(125405, '3.30.70.330-FF-003110', NULL, NULL, 78, NULL, NULL, 125405),
(125406, '3.80.10.10-FF-003781', NULL, 'Uncharacterized protein', 103, NULL, NULL, 125406),
(125407, '3.60.21.10-FF-000423', NULL, '3'',5''-cyclic adenosine monophosphate phosphodiesterase CpdA', 270, NULL, NULL, 125407),
(125408, '1.25.40.10-FF-002981', NULL, 'Pentatricopeptide repeat-containing protein At5g13770, chloroplastic', 149, NULL, NULL, 125408),
(125409, '3.30.160.60-FF-001077', NULL, 'Zinc finger protein 1026', 28, NULL, NULL, 125409),
(125410, '2.40.160.180-FF-000003', NULL, 'Porin', 431, NULL, NULL, 125410),
(125411, '3.40.850.10-FF-000494', NULL, 'Uncharacterized protein', 53, NULL, NULL, 125411),
(125412, '3.30.70.330-FF-001508', NULL, NULL, 81, NULL, NULL, 125412),
(125413, '3.40.50.300-FF-007367', NULL, 'MCM3', 175, NULL, NULL, 125413),
(125414, '3.20.20.60-FF-000050', NULL, 'Citrate lyase beta subunit', 217, NULL, NULL, 125414),
(125415, '3.40.309.10-FF-000107', NULL, 'Methylmalonate semialdehyde dehydrogenase, putative', 156, NULL, NULL, 125415),
(125416, '3.80.10.10-FF-002246', NULL, 'Uncharacterized protein', 124, NULL, NULL, 125416),
(125417, '1.10.472.170-FF-000023', NULL, 'Uncharacterized protein', 83, NULL, NULL, 125417),
(125418, '4.10.400.10-FF-000290', NULL, 'Megalin, isoform A', 44, NULL, NULL, 125418),
(125419, '1.50.10.20-FF-000092', NULL, 'Terpene synthase family protein (AFU_orthologue AFUA_5G15060)', 259, NULL, NULL, 125419),
(125420, '1.10.1740.10-FF-000044', NULL, 'Probable sigma-70 factor, ECF subfamily', 72, NULL, NULL, 125420),
(125421, '3.40.50.620-FF-000369', NULL, 'Nicotinate-nicotinamide nucleotide adenylyltransferase', 173, NULL, NULL, 125421),
(125422, '3.40.20.10-FF-000118', NULL, 'Uncharacterized protein', 146, NULL, NULL, 125422),
(125423, '2.40.70.10-FF-000023', NULL, 'Aspartic protease', 163, NULL, NULL, 125423),
(125424, '3.20.20.240-FF-000006', NULL, 'Predicted protein', 340, NULL, NULL, 125424),
(125425, '3.40.50.300-FF-006911', NULL, 'Uncharacterized protein', 322, NULL, NULL, 125425),
(125426, '1.10.510.10-FF-003147', NULL, NULL, 178, NULL, NULL, 125426),
(125427, '3.10.129.110-FF-000003', NULL, 'Probable polyketide synthase pks1', 289, NULL, NULL, 125427),
(125428, '3.30.230.70-FF-000107', NULL, 'Nucleolar autoantigen-like protein, putative', 257, NULL, NULL, 125428),
(125429, '1.10.560.10-FF-000008', NULL, 'T-complex protein 1 subunit delta', 230, NULL, NULL, 125429),
(125430, '3.30.2230.10-FF-000027', NULL, 'Ubiquitinyl hydrolase 1', 85, NULL, NULL, 125430),
(125431, '3.50.50.60-FF-000303', NULL, 'L-amino-acid oxidase', 276, NULL, NULL, 125431),
(125432, '1.25.40.660-FF-000007', NULL, 'Vacuolar protein sorting-associated protein 35', 335, NULL, NULL, 125432),
(125433, '3.10.129.10-FF-000257', NULL, 'Uncharacterized protein', 95, NULL, NULL, 125433),
(125434, '2.130.10.10-FF-002241', NULL, 'Predicted protein', 227, NULL, NULL, 125434);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(125435, '3.30.540.10-FF-000057', NULL, 'Inositol monophosphatase', 140, NULL, NULL, 125435),
(125436, '2.40.50.140-FF-000690', NULL, 'Putative methyltransferase', 128, NULL, NULL, 125436),
(125437, '3.40.50.300-FF-007423', NULL, 'Uncharacterized protein', 178, NULL, NULL, 125437),
(125438, '1.20.810.10-FF-000015', NULL, 'Cytochrome b', 120, NULL, NULL, 125438),
(125439, '1.20.58.1120-FF-000029', NULL, 'Dynein heavy chain 5, axonemal', 157, NULL, NULL, 125439),
(125440, '1.20.1110.10-FF-000005', NULL, 'Plasma membrane ATPase', 337, NULL, NULL, 125440),
(125441, '1.20.1270.60-FF-000043', NULL, 'Brain-specific angiogenesis inhibitor 1-associated protein 2-like 1', 228, NULL, NULL, 125441),
(125442, '3.30.9.10-FF-000205', NULL, 'Zgc:172341', 53, NULL, NULL, 125442),
(125443, '2.60.40.10-FF-003786', NULL, NULL, 65, NULL, NULL, 125443),
(125444, '3.10.110.10-FF-000170', NULL, 'Uncharacterized protein', 146, NULL, NULL, 125444),
(125445, '3.30.160.60-FF-000565', NULL, 'Zinc finger protein 575', 31, NULL, NULL, 125445),
(125446, '3.40.50.720-FF-002142', NULL, 'Biliverdin reductase A', 94, NULL, NULL, 125446),
(125447, '3.40.50.410-FF-000020', NULL, 'protein transport protein Sec24D isoform X1', 245, NULL, NULL, 125447),
(125448, '3.40.50.300-FF-000335', NULL, 'ATP binding cassette subfamily A member 5', 264, NULL, NULL, 125448),
(125449, '3.40.50.720-FF-001630', NULL, 'Short-chain dehydrogenase, putative', 333, NULL, NULL, 125449),
(125450, '2.130.10.10-FF-002134', NULL, 'WD domain containing protein', 73, NULL, NULL, 125450),
(125451, '3.20.20.80-FF-000056', NULL, 'Pancreatic alpha-amylase', 403, NULL, NULL, 125451),
(125452, '3.40.50.150-FF-001673', NULL, NULL, 159, NULL, NULL, 125452),
(125453, '2.10.25.10-FF-001420', NULL, 'Uncharacterized protein', 47, NULL, NULL, 125453),
(125454, '3.40.50.300-FF-006170', NULL, 'Putative ABC transporter ATP-binding protein MG187', 148, NULL, NULL, 125454),
(125455, '3.30.70.3000-FF-000012', NULL, 'Uncharacterized protein', 72, NULL, NULL, 125455),
(125456, '2.60.40.10-FF-000121', NULL, 'Collagen type XII alpha 1 chain', 90, NULL, NULL, 125456),
(125457, '1.20.5.4570-FF-000002', NULL, 'Ferulic acid decarboxylase 1', 37, NULL, NULL, 125457),
(125458, '1.10.10.60-FF-001274', NULL, NULL, 77, NULL, NULL, 125458),
(125459, '3.40.50.880-FF-000020', NULL, 'AraC family transcriptional regulator', 200, NULL, NULL, 125459),
(125460, '2.60.40.10-FF-003842', NULL, NULL, 88, NULL, NULL, 125460),
(125461, '2.40.70.10-FF-000130', NULL, 'Retrovirus-related Pol polyprotein from transposon opus-like Protein', 106, NULL, NULL, 125461),
(125462, '3.30.230.10-FF-000303', NULL, 'MutL homolog 1', 71, NULL, NULL, 125462),
(125463, '3.30.200.20-FF-000804', NULL, 'Non-specific serine/threonine protein kinase', 15, NULL, NULL, 125463),
(125464, '1.10.287.70-FF-000267', NULL, 'Uncharacterized protein, isoform A', 137, NULL, NULL, 125464),
(125465, '1.10.3500.10-FF-000010', NULL, 'Transcription elongation factor SPT6', 287, NULL, NULL, 125465),
(125466, '1.20.1070.10-FF-001873', NULL, 'Uncharacterized protein', 346, NULL, NULL, 125466),
(125467, '2.40.290.10-FF-000005', NULL, 'X-ray repair cross-complementing protein 5', 199, NULL, NULL, 125467),
(125468, '1.20.5.170-FF-000206', NULL, 'Sodium/potassium-transporting ATPase subunit beta-2-like Protein', 40, NULL, NULL, 125468),
(125469, '1.10.150.650-FF-000009', NULL, 'Metal-dependent phosphoesterase, PHP family', 73, NULL, NULL, 125469),
(125470, '3.90.1010.10-FF-000008', NULL, 'Iron-sulfur cluster assembly enzyme', 132, NULL, NULL, 125470),
(125471, '3.30.260.10-FF-000075', NULL, NULL, 110, NULL, NULL, 125471),
(125472, '3.40.30.10-FF-000743', NULL, 'Thioredoxin', 118, NULL, NULL, 125472),
(125473, '3.40.50.10050-FF-000015', NULL, 'Translation initiation factor IF-2', 108, NULL, NULL, 125473),
(125474, '1.20.58.60-FF-000068', NULL, 'Short stop, isoform K', 110, NULL, NULL, 125474),
(125475, '3.60.20.10-FF-000011', NULL, 'Amidophosphoribosyltransferase', 290, NULL, NULL, 125475),
(125476, '3.30.160.60-FF-000514', NULL, 'Uncharacterized protein', 28, NULL, NULL, 125476);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(125477, '3.30.160.60-FF-000621', NULL, 'FLT3-interacting zinc finger 1', 27, NULL, NULL, 125477),
(125478, '1.25.40.10-FF-001413', NULL, 'Tetratricopeptide repeat, putative', 227, NULL, NULL, 125478),
(125479, '1.20.120.140-FF-000040', NULL, 'Signal recognition particle receptor FtsY', 72, NULL, NULL, 125479),
(125480, '4.10.470.10-FF-000001', NULL, 'Ricin', 90, NULL, NULL, 125480),
(125481, '3.40.50.12780-FF-000188', NULL, 'Uncharacterized protein', 168, NULL, NULL, 125481),
(125482, '2.60.120.970-FF-000104', NULL, 'Predicted protein', 92, NULL, NULL, 125482),
(125483, '1.10.287.70-FF-000323', NULL, 'Large conductance calcium-activated potassium (BK) channel alpha subunit a', 68, NULL, NULL, 125483),
(125484, '2.60.40.10-FF-002482', NULL, 'Uncharacterized protein', 86, NULL, NULL, 125484),
(125485, '3.50.50.60-FF-000247', NULL, 'Flavin-binding monooxygenase-like protein', 339, NULL, NULL, 125485),
(125486, '1.20.58.110-FF-000003', NULL, '30S ribosomal protein S20, chloroplastic', 108, NULL, NULL, 125486),
(125487, '1.10.472.10-FF-000399', NULL, 'YALI0C10516p', 145, NULL, NULL, 125487),
(125488, '1.25.40.10-FF-001520', NULL, 'histone-lysine N-methyltransferase SMYD3', 73, NULL, NULL, 125488),
(125489, '3.90.550.10-FF-000600', NULL, 'Uncharacterized protein', 223, NULL, NULL, 125489),
(125490, '2.160.20.10-FF-000290', NULL, 'Uncharacterized protein', 137, NULL, NULL, 125490),
(125491, '1.20.272.10-FF-000022', NULL, 'Replication factor C subunit 3', 94, NULL, NULL, 125491),
(125492, '2.160.20.10-FF-000183', NULL, 'Cell surface glycoprotein (S-layer protein)', 146, NULL, NULL, 125492),
(125493, '3.30.40.10-FF-001273', NULL, 'SNF2 family N-terminal domain-domain-containing protein', 87, NULL, NULL, 125493),
(125494, '3.30.70.330-FF-003054', NULL, NULL, 111, NULL, NULL, 125494),
(125495, '3.40.50.720-FF-001574', NULL, 'Oxidoreductase, short chain dehydrogenase/reductase family', 239, NULL, NULL, 125495),
(125496, '3.30.460.10-FF-000112', NULL, 'Speckle targeted PIP5K1A-regulated poly(A) polymerase', 71, NULL, NULL, 125496),
(125497, '2.60.40.2860-FF-000002', NULL, 'Transmission-blocking target antigen s230', 120, NULL, NULL, 125497),
(125498, '3.30.160.60-FF-001818', NULL, 'GDNF-inducible zinc finger protein 1 isoform X1', 28, NULL, NULL, 125498),
(125499, '3.40.50.2300-FF-000771', NULL, NULL, 123, NULL, NULL, 125499),
(125500, '3.90.55.10-FF-000005', NULL, 'Biotin sulfoxide reductas2', 70, NULL, NULL, 125500),
(125501, '1.10.150.80-FF-000021', NULL, 'ATP-dependent DNA helicase RecQ', 71, NULL, NULL, 125501),
(125502, '1.20.120.1750-FF-000063', NULL, 'RBR-type E3 ubiquitin transferase', 70, NULL, NULL, 125502),
(125503, '3.30.565.10-FF-000204', NULL, 'Heat shock protein HSP 90-beta', 232, NULL, NULL, 125503),
(125504, '1.20.58.340-FF-000050', NULL, 'Cation transporter', 88, NULL, NULL, 125504),
(125505, '3.40.50.11240-FF-000001', NULL, 'Ethanolamine ammonia-lyase light chain', 183, NULL, NULL, 125505),
(125506, '1.20.5.4130-FF-000005', NULL, 'NBS-LRR class disease resistance protein', 112, NULL, NULL, 125506),
(125507, '1.20.1310.10-FF-000009', NULL, 'Cullin 5', 119, NULL, NULL, 125507),
(125508, '3.30.160.60-FF-002982', NULL, 'Zinc finger protein 1009', 28, NULL, NULL, 125508),
(125509, '3.30.310.130-FF-000008', NULL, 'Ubiquitin-like-specific protease 1', 105, NULL, NULL, 125509),
(125510, '3.90.228.20-FF-000006', NULL, 'Phosphoenolpyruvate carboxykinase [GTP], mitochondrial', 87, NULL, NULL, 125510),
(125511, '3.90.1750.10-FF-000019', NULL, 'E3 ubiquitin-protein ligase HACE1 isoform X1', 183, NULL, NULL, 125511),
(125512, '3.30.450.350-FF-000004', NULL, 'Histidine kinase', 214, NULL, NULL, 125512),
(125513, '3.30.70.1730-FF-000041', NULL, 'Uncharacterized protein', 161, NULL, NULL, 125513),
(125514, '3.30.1380.10-FF-000004', NULL, 'Endolysin', 134, NULL, NULL, 125514),
(125515, '3.10.20.230-FF-000017', NULL, 'Serine/threonine-protein kinase GA29083', 89, NULL, NULL, 125515),
(125516, '2.60.120.260-FF-000548', NULL, 'Uncharacterized protein', 61, NULL, NULL, 125516),
(125517, '2.30.29.90-FF-000002', NULL, 'syntaxin-binding protein 6', 131, NULL, NULL, 125517);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(125518, '3.30.420.10-FF-000054', NULL, 'Werner Syndrome-like exonuclease', 193, NULL, NULL, 125518),
(125519, '2.20.70.10-FF-000237', NULL, 'Uncharacterized protein', 49, NULL, NULL, 125519),
(125520, '2.60.120.290-FF-000147', NULL, 'AGAP005526-PA', 120, NULL, NULL, 125520),
(125521, '3.90.550.10-FF-000544', NULL, 'Predicted protein', 235, NULL, NULL, 125521),
(125522, '1.10.238.10-FF-000215', NULL, 'CDPK-related kinase 3', 84, NULL, NULL, 125522),
(125523, '1.25.40.10-FF-002829', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 144, NULL, NULL, 125523),
(125524, '3.40.390.10-FF-000239', NULL, NULL, 70, NULL, NULL, 125524),
(125525, '1.10.510.10-FF-000348', NULL, 'serine/threonine-protein kinase VRK1 isoform X1', 396, NULL, NULL, 125525),
(125526, '3.20.20.150-FF-000075', NULL, 'Chromosome 1, whole genome shotgun sequence', 343, NULL, NULL, 125526),
(125527, '3.40.50.11260-FF-000007', NULL, 'Heat shock protein 90', 91, NULL, NULL, 125527),
(125528, '1.10.510.10-FF-001753', NULL, 'Protein kinase superfamily protein', 228, NULL, NULL, 125528),
(125529, '3.90.1750.20-FF-000016', NULL, NULL, 201, NULL, NULL, 125529),
(125530, '3.90.190.10-FF-000561', NULL, 'Uncharacterized protein', 90, NULL, NULL, 125530),
(125531, '3.20.20.80-FF-000163', NULL, 'Putative beta-mannosidase', 341, NULL, NULL, 125531),
(125532, '1.10.1040.10-FF-000070', NULL, '3-hydroxyisobutyrate dehydrogenase, mitochondrial, putative', 133, NULL, NULL, 125532),
(125533, '3.90.70.10-FF-000215', NULL, 'Ubiquitin carboxyl-terminal hydrolase 16', 416, NULL, NULL, 125533),
(125534, '1.25.40.10-FF-000160', NULL, 'Peptidylprolyl isomerase', 148, NULL, NULL, 125534),
(125535, '2.60.40.60-FF-000670', NULL, 'Uncharacterized protein', 63, NULL, NULL, 125535),
(125536, '1.10.510.10-FF-001697', NULL, 'Uncharacterized protein', 202, NULL, NULL, 125536),
(125537, '2.60.120.590-FF-000086', NULL, 'Uncharacterized protein', 34, NULL, NULL, 125537),
(125538, '1.25.10.20-FF-000009', NULL, 'Microsomal triacylglycerol transfer protein', 303, NULL, NULL, 125538),
(125539, '1.25.40.10-FF-003318', NULL, 'Pentatricopeptide repeat-containing protein At2g22070', 106, NULL, NULL, 125539),
(125540, '3.30.310.80-FF-000049', NULL, '5''-AMP-activated protein kinase catalytic subunit alpha-1', 122, NULL, NULL, 125540),
(125541, '1.10.20.10-FF-000001', NULL, 'Histone H3', 135, NULL, NULL, 125541),
(125542, '1.10.10.10-FF-001517', NULL, 'General transcription factor IIE subunit 1', 90, NULL, NULL, 125542),
(125543, '1.10.240.10-FF-000024', NULL, 'Uncharacterized protein', 117, NULL, NULL, 125543),
(125544, '3.40.190.80-FF-000059', NULL, 'Fructose-1,6-bisphosphatase class 1', 129, NULL, NULL, 125544),
(125545, '1.10.640.10-FF-000009', NULL, 'Peroxidase, isoform B', 578, NULL, NULL, 125545),
(125546, '3.40.50.1240-FF-000144', NULL, NULL, 163, NULL, NULL, 125546),
(125547, '1.10.1400.10-FF-000002', NULL, NULL, 137, NULL, NULL, 125547),
(125548, '2.60.120.380-FF-000085', NULL, 'Predicted protein', 105, NULL, NULL, 125548),
(125549, '3.30.63.10-FF-000010', NULL, 'Uncharacterized protein', 49, NULL, NULL, 125549),
(125550, '2.40.128.20-FF-000025', NULL, 'UPF0678 fatty acid-binding protein-like protein Rv0813c', 200, NULL, NULL, 125550),
(125551, '3.30.470.20-FF-000155', NULL, 'Predicted protein', 255, NULL, NULL, 125551),
(125552, '3.60.10.10-FF-000185', NULL, 'Uncharacterized protein', 373, NULL, NULL, 125552),
(125553, '1.20.1560.10-FF-000213', NULL, 'Predicted protein', 319, NULL, NULL, 125553),
(125554, '3.80.10.10-FF-000852', NULL, 'Blast:Chaoptin', 160, NULL, NULL, 125554),
(125555, '1.50.40.10-FF-000383', NULL, 'Mitochondrial carrier protein, putative', 278, NULL, NULL, 125555),
(125556, '3.30.50.10-FF-000031', NULL, 'Ecdysone receptor A1', 106, NULL, NULL, 125556),
(125557, '3.30.300.30-FF-000118', NULL, 'Phenylacetate--coenzyme A ligase', 104, NULL, NULL, 125557),
(125558, '2.170.270.10-FF-000046', NULL, 'SET-domain containing protein lysine methyltransferase family protein', 311, NULL, NULL, 125558),
(125559, '2.60.40.10-FF-003050', NULL, 'Tapasin long form', 149, NULL, NULL, 125559);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(125560, '1.10.10.10-FF-001113', NULL, 'Putative plectin/S10 domain protein', 103, NULL, NULL, 125560),
(125561, '1.10.472.80-FF-000055', NULL, 'TBC domain-containing protein C1778.09', 148, NULL, NULL, 125561),
(125562, '3.30.160.60-FF-002931', NULL, 'zinc finger protein 585A-like', 27, NULL, NULL, 125562),
(125563, '3.30.360.10-FF-000060', NULL, 'Unplaced genomic scaffold supercont2.12, whole genome shotgun sequence', 188, NULL, NULL, 125563),
(125564, '3.30.70.1440-FF-000010', NULL, 'Transporter, AcrB/D/F family', 111, NULL, NULL, 125564),
(125565, '2.60.120.200-FF-000340', NULL, 'Si:dkey-1m11.6', 154, NULL, NULL, 125565),
(125566, '1.10.560.10-FF-000071', NULL, 'TCP-1/cpn60 chaperonin family protein', 117, NULL, NULL, 125566),
(125567, '2.90.10.10-FF-000040', NULL, 'Mannose-binding lectin', 109, NULL, NULL, 125567),
(125568, '3.30.160.60-FF-006293', NULL, NULL, 105, NULL, NULL, 125568),
(125569, '3.40.50.300-FF-000279', NULL, 'peripheral plasma membrane protein CASK isoform X2', 102, NULL, NULL, 125569),
(125570, '4.10.400.10-FF-000227', NULL, 'Uncharacterized protein', 32, NULL, NULL, 125570),
(125571, '1.10.3660.10-FF-000010', NULL, 'Prephenate dehydrogenase', 93, NULL, NULL, 125571),
(125572, '1.20.1050.90-FF-000007', NULL, 'DNA replication and repair protein RecF', 185, NULL, NULL, 125572),
(125573, '1.20.1230.10-FF-000008', NULL, 'Phosphoinositide phospholipase C', 113, NULL, NULL, 125573),
(125574, '1.10.630.10-FF-000239', NULL, 'Uncharacterized protein', 114, NULL, NULL, 125574),
(125575, '2.30.42.10-FF-000610', NULL, NULL, 94, NULL, NULL, 125575),
(125576, '3.30.1460.10-FF-000005', NULL, 'Uncharacterized protein', 134, NULL, NULL, 125576),
(125577, '1.10.1420.10-FF-000060', NULL, 'DNA mismatch repair protein spellchecker 1', 125, NULL, NULL, 125577),
(125578, '2.70.40.10-FF-000031', NULL, 'Uncharacterized protein', 114, NULL, NULL, 125578),
(125579, '3.30.1480.10-FF-000012', NULL, 'Transcription termination/antitermination protein NusA', 122, NULL, NULL, 125579),
(125580, '3.40.190.120-FF-000007', NULL, 'Possible osmoprotectant (Glycine betaine/carnitine/choline/L-proline) binding lipoprotein ProX', 109, NULL, NULL, 125580),
(125581, '3.40.30.10-FF-000799', NULL, 'Uncharacterized protein', 72, NULL, NULL, 125581),
(125582, '2.130.10.10-FF-001785', NULL, 'Uncharacterized protein', 87, NULL, NULL, 125582),
(125583, '2.60.40.10-FF-001425', NULL, 'Interferon gamma receptor 1', 106, NULL, NULL, 125583),
(125584, '3.40.850.10-FF-000319', NULL, 'Kinesin-like protein KIF26B', 379, NULL, NULL, 125584),
(125585, '1.10.1320.10-FF-000001', NULL, 'DNA-directed RNA polymerase', 340, NULL, NULL, 125585),
(125586, '3.15.10.10-FF-000013', NULL, 'Expression site-associated gene (ESAG) protein, putative', 167, NULL, NULL, 125586),
(125587, '1.20.59.10-FF-000005', NULL, 'Chorismate mutase', 88, NULL, NULL, 125587),
(125588, '2.60.40.1230-FF-000019', NULL, 'Golgi-localized, ADP-ribosylation factor binding protein, putative', 111, NULL, NULL, 125588),
(125589, '2.40.50.140-FF-000538', NULL, 'ABC transporter ATP-binding protein', 57, NULL, NULL, 125589),
(125590, '3.20.20.70-FF-000278', NULL, 'Lactate oxidase', 366, NULL, NULL, 125590),
(125591, '3.40.50.2300-FF-001283', NULL, NULL, 165, NULL, NULL, 125591),
(125592, '3.30.559.10-FF-000263', NULL, 'Dihydrolipoyllysine-residue succinyltransferase component of 2-oxoglutarate dehydrogenase complex, mitochondrial', 42, NULL, NULL, 125592),
(125593, '3.30.230.10-FF-000247', NULL, 'Uncharacterized protein', 121, NULL, NULL, 125593),
(125594, '3.30.1360.120-FF-000025', NULL, 'tRNA modification GTPase MnmE', 125, NULL, NULL, 125594),
(125595, '2.130.10.10-FF-005096', NULL, 'Predicted protein', 254, NULL, NULL, 125595),
(125596, '3.40.50.1980-FF-000017', NULL, 'ABC transporter substrate-binding protein', 123, NULL, NULL, 125596),
(125597, '3.40.50.300-FF-001639', NULL, 'Multifunctional fusion protein', 199, NULL, NULL, 125597),
(125598, '3.40.50.1820-FF-000638', NULL, 'Dipeptidyl peptidase IV-like protein', 262, NULL, NULL, 125598),
(125599, '3.30.200.20-FF-000748', NULL, 'LRR receptor-like serine/threonine-protein kinase RCH1', 103, NULL, NULL, 125599);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(125600, '4.10.240.10-FF-000136', NULL, 'Uncharacterized transcriptional regulatory protein YFL052W', 59, NULL, NULL, 125600),
(125601, '2.30.29.30-FF-001136', NULL, 'Uncharacterized protein', 118, NULL, NULL, 125601),
(125602, '3.20.20.60-FF-000005', NULL, 'Isocitrate lyase', 426, NULL, NULL, 125602),
(125603, '3.40.50.1000-FF-000252', NULL, 'Enolase-phosphatase E1', 120, NULL, NULL, 125603),
(125604, '2.40.50.140-FF-001027', NULL, NULL, 155, NULL, NULL, 125604),
(125605, '2.60.40.10-FF-000065', NULL, 'roundabout homolog 1 isoform X3', 114, NULL, NULL, 125605),
(125606, '3.40.1230.10-FF-000019', NULL, 'Predicted protein', 97, NULL, NULL, 125606),
(125607, '3.40.50.200-FF-000131', NULL, 'Uncharacterized protein', 131, NULL, NULL, 125607),
(125608, '1.50.40.10-FF-000332', NULL, 'Mitochondrial dicarboxylate carrier', 275, NULL, NULL, 125608),
(125609, '2.10.25.10-FF-000982', NULL, 'Fibrillin-1', 40, NULL, NULL, 125609),
(125610, '1.20.140.10-FF-000087', NULL, 'Flavin-dependent monooxygenase', 171, NULL, NULL, 125610),
(125611, '1.20.58.60-FF-000063', NULL, 'Short stop, isoform K', 112, NULL, NULL, 125611),
(125612, '3.30.200.20-FF-000012', NULL, 'microtubule-associated serine/threonine-protein kinase 2 isoform X1', 109, NULL, NULL, 125612),
(125613, '3.30.2350.10-FF-000025', NULL, 'Related to DRAP deaminase RIB2', 223, NULL, NULL, 125613),
(125614, '1.20.1250.20-FF-000232', NULL, 'Organic cation/carnitine transporter 7', 462, NULL, NULL, 125614),
(125615, '1.10.520.20-FF-000003', NULL, 'ATP synthase F1, delta subunit', 96, NULL, NULL, 125615),
(125616, '1.10.540.10-FF-000064', NULL, 'Acyl-coenzyme A oxidase', 128, NULL, NULL, 125616),
(125617, '3.40.50.300-FF-006855', NULL, 'Uncharacterized protein', 259, NULL, NULL, 125617),
(125618, '4.10.410.10-FF-000060', NULL, 'Tissue factor pathway inhibitor', 68, NULL, NULL, 125618),
(125619, '3.30.450.40-FF-000222', NULL, 'GAF domain-containing protein', 192, NULL, NULL, 125619),
(125620, '3.30.310.220-FF-000002', NULL, 'Serine/threonine protein kinase (Kcc4)', 134, NULL, NULL, 125620),
(125621, '1.25.10.10-FF-003261', NULL, 'Ras guanine nucleotide exchange factor L', 212, NULL, NULL, 125621),
(125622, '3.40.50.620-FF-000021', NULL, 'Riboflavin biosynthesis protein', 185, NULL, NULL, 125622),
(125623, '1.20.1070.10-FF-001822', NULL, 'melatonin receptor type 1B-A-like isoform X1', 309, NULL, NULL, 125623),
(125624, '1.20.58.2220-FF-000016', NULL, 'Formin 2', 380, NULL, NULL, 125624),
(125625, '2.30.30.910-FF-000003', NULL, 'Basal-body rod modification protein FlgD', 44, NULL, NULL, 125625),
(125626, '1.20.5.110-FF-000234', NULL, 'BET1-like protein', 64, NULL, NULL, 125626),
(125627, '1.10.1450.10-FF-000117', NULL, 'Tetraspanin', 90, NULL, NULL, 125627),
(125628, '1.20.1270.60-FF-000099', NULL, 'Rho guanine nucleotide exchange factor 37', 216, NULL, NULL, 125628),
(125629, '1.20.120.730-FF-000008', NULL, 'Protein transport protein SEC23', 138, NULL, NULL, 125629),
(125630, '2.40.30.170-FF-000077', NULL, NULL, 55, NULL, NULL, 125630),
(125631, '1.10.510.10-FF-002765', NULL, NULL, 207, NULL, NULL, 125631),
(125632, '1.20.5.110-FF-000178', NULL, 'Qc-SNARE protein, putative', 68, NULL, NULL, 125632),
(125633, '3.30.160.60-FF-005236', NULL, NULL, 58, NULL, NULL, 125633),
(125634, '3.40.50.300-FF-007479', NULL, 'Uncharacterized protein', 236, NULL, NULL, 125634),
(125635, '1.10.287.160-FF-000002', NULL, 'Putative serine/threonine-protein kinase N2', 84, NULL, NULL, 125635),
(125636, '3.80.10.10-FF-001813', NULL, 'Os06g0179800 protein', 324, NULL, NULL, 125636),
(125637, '1.10.8.60-FF-000014', NULL, 'DNA-binding transcriptional regulator NtrC', 73, NULL, NULL, 125637),
(125638, '1.10.2000.10-FF-000039', NULL, NULL, 129, NULL, NULL, 125638),
(125639, '1.20.210.10-FF-000031', NULL, 'Cytochrome c oxidase subunit 1', 83, NULL, NULL, 125639),
(125640, '3.30.200.20-FF-001861', NULL, 'Os11g0691300 protein', 49, NULL, NULL, 125640),
(125641, '2.40.50.140-FF-001090', NULL, NULL, 69, NULL, NULL, 125641),
(125642, '3.40.50.10140-FF-000042', NULL, 'Phosphoinositide-3-kinase adaptor protein 1', 137, NULL, NULL, 125642);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(125643, '3.80.10.10-FF-004163', NULL, 'Predicted protein', 100, NULL, NULL, 125643),
(125644, '3.40.630.10-FF-000455', NULL, 'Uncharacterized protein', 154, NULL, NULL, 125644),
(125645, '3.30.760.10-FF-000096', NULL, 'Uncharacterized protein', 196, NULL, NULL, 125645),
(125646, '3.40.630.10-FF-000399', NULL, 'Predicted protein', 296, NULL, NULL, 125646),
(125647, '1.10.760.10-FF-000052', NULL, 'L-cysteine S-thiosulfotransferase subunit SoxA', 128, NULL, NULL, 125647),
(125648, '3.30.1680.10-FF-000044', NULL, 'Macrophage-stimulating 1 receptor', 46, NULL, NULL, 125648),
(125649, '3.40.50.410-FF-000132', NULL, '60 kDa SS-A/Ro ribonucleoprotein homolog', 196, NULL, NULL, 125649),
(125650, '2.30.30.140-FF-000019', NULL, 'MBT domain-containing protein 1 isoform X1', 104, NULL, NULL, 125650),
(125651, '3.40.50.300-FF-008480', NULL, 'ABC transporter C family member 14', 199, NULL, NULL, 125651),
(125652, '3.40.50.2300-FF-000619', NULL, 'Vomeronasal 2, receptor 120', 35, NULL, NULL, 125652),
(125653, '2.30.29.90-FF-000007', NULL, 'Exocyst complex component SEC3', 151, NULL, NULL, 125653),
(125654, '3.40.50.2020-FF-000013', NULL, 'Amidophosphoribosyltransferase', 130, NULL, NULL, 125654),
(125655, '1.25.40.10-FF-000957', NULL, 'Pentatricopeptide repeat-containing protein At4g39530', 94, NULL, NULL, 125655),
(125656, '3.80.10.10-FF-001757', NULL, 'NLR family CARD domain-containing 8', 122, NULL, NULL, 125656),
(125657, '3.30.40.230-FF-000011', NULL, 'Glycine--tRNA ligase', 79, NULL, NULL, 125657),
(125658, '2.60.40.10-FF-003898', NULL, NULL, 90, NULL, NULL, 125658),
(125659, '3.30.160.60-FF-003387', NULL, 'Zinc finger protein 764', 28, NULL, NULL, 125659),
(125660, '3.40.50.300-FF-003264', NULL, 'RecBCD enzyme subunit RecC', 208, NULL, NULL, 125660),
(125661, '3.30.1370.10-FF-000178', NULL, 'DDX53 isoform 1', 67, NULL, NULL, 125661),
(125662, '1.20.1050.70-FF-000001', NULL, NULL, 114, NULL, NULL, 125662),
(125663, '3.30.1340.10-FF-000007', NULL, 'HPr family phosphocarrier protein', 85, NULL, NULL, 125663),
(125664, '3.40.1110.10-FF-000179', NULL, 'Probable cadmium/zinc-transporting ATPase HMA1, chloroplastic', 150, NULL, NULL, 125664),
(125665, '1.10.238.10-FF-001209', NULL, 'EF hand family protein', 163, NULL, NULL, 125665),
(125666, '3.40.50.2000-FF-000294', NULL, 'Uncharacterized protein', 254, NULL, NULL, 125666),
(125667, '2.10.25.10-FF-000931', NULL, 'Uncharacterized protein', 42, NULL, NULL, 125667),
(125668, '3.60.21.60-FF-000028', NULL, 'DNA polymerase alpha subunit B', 101, NULL, NULL, 125668),
(125669, '3.80.10.10-FF-001864', NULL, 'Leucine rich repeat containing 40', 99, NULL, NULL, 125669),
(125670, '2.60.40.1180-FF-000021', NULL, 'Alpha-amylase', 58, NULL, NULL, 125670),
(125671, '1.25.40.10-FF-001469', NULL, 'Putative pentatricopeptide repeat-containing protein', 103, NULL, NULL, 125671),
(125672, '2.40.30.10-FF-000133', NULL, 'Flavodoxin reductase Hmp', 109, NULL, NULL, 125672),
(125673, '3.40.50.300-FF-002988', NULL, 'Dynein heavy chain family protein', 227, NULL, NULL, 125673),
(125674, '3.30.160.60-FF-001970', NULL, 'Uncharacterized protein', 28, NULL, NULL, 125674),
(125675, '2.60.420.10-FF-000017', NULL, 'Glycosyl hydrolase family 65 central catalytic domain/Haloacid dehalogenase-like hydrolase, putative', 67, NULL, NULL, 125675),
(125676, '1.20.58.2010-FF-000015', NULL, 'Rop guanine nucleotide exchange factor 7', 36, NULL, NULL, 125676),
(125677, '2.60.40.10-FF-001133', NULL, 'Hemicentin 1', 92, NULL, NULL, 125677),
(125678, '3.40.1190.10-FF-000015', NULL, 'Dihydrofolate synthase/folylpolyglutamate synthase', 279, NULL, NULL, 125678),
(125679, '2.60.120.200-FF-000688', NULL, 'Protein eyes shut homolog', 203, NULL, NULL, 125679),
(125680, '2.100.10.50-FF-000005', NULL, 'Uncharacterized protein', 87, NULL, NULL, 125680),
(125681, '3.20.20.80-FF-000556', NULL, 'Chitinase 3 like 1', 227, NULL, NULL, 125681),
(125682, '1.20.1410.10-FF-000045', NULL, 'Kynureninase', 131, NULL, NULL, 125682),
(125683, '1.50.40.10-FF-000388', NULL, 'Mitochondrial amino acid carrier', 69, NULL, NULL, 125683);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(125684, '2.40.30.40-FF-000001', NULL, 'Peptidase M28', 88, NULL, NULL, 125684),
(125685, '2.30.29.30-FF-000916', NULL, 'Rho GTPase-activating protein gacEE', 111, NULL, NULL, 125685),
(125686, '3.10.250.10-FF-000056', NULL, 'CD6 antigen', 113, NULL, NULL, 125686),
(125687, '1.10.220.110-FF-000005', NULL, 'GDNF family receptor alpha 2b', 57, NULL, NULL, 125687),
(125688, '3.30.2230.10-FF-000022', NULL, 'ubiquitin carboxyl-terminal hydrolase 32', 132, NULL, NULL, 125688),
(125689, '1.10.1900.10-FF-000023', NULL, 'Predicted protein', 81, NULL, NULL, 125689),
(125690, '1.10.10.10-FF-000152', NULL, 'FadR family transcriptional regulator', 69, NULL, NULL, 125690),
(125691, '3.40.50.720-FF-001029', NULL, 'Enoyl-[acyl-carrier-protein] reductase, mitochondrial', 178, NULL, NULL, 125691),
(125692, '3.30.1390.30-FF-000011', NULL, NULL, 78, NULL, NULL, 125692),
(125693, '1.10.10.60-FF-000650', NULL, 'Ventral homeobox', 77, NULL, NULL, 125693),
(125694, '1.20.1070.10-FF-001081', NULL, 'Alpha-1A adrenergic receptor', 325, NULL, NULL, 125694),
(125695, '2.10.25.10-FF-000190', NULL, 'fibulin-5 isoform X2', 44, NULL, NULL, 125695),
(125696, '1.10.418.10-FF-000201', NULL, 'Interaptin', 115, NULL, NULL, 125696),
(125697, '1.10.8.60-FF-000065', NULL, 'Loader of gp41 DNA helicase', 100, NULL, NULL, 125697),
(125698, '2.60.40.10-FF-000857', NULL, 'PKHD1 like 1', 98, NULL, NULL, 125698),
(125699, '3.40.50.300-FF-006018', NULL, 'Origin recognition complex subunit 1', 109, NULL, NULL, 125699),
(125700, '3.40.1450.10-FF-000002', NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase', 238, NULL, NULL, 125700),
(125701, '3.30.2020.30-FF-000023', NULL, 'YALI0C10604p', 83, NULL, NULL, 125701),
(125702, '3.40.50.1820-FF-000790', NULL, 'Oxidoreductase', 225, NULL, NULL, 125702),
(125703, '3.40.50.300-FF-004438', NULL, 'ARF2', 161, NULL, NULL, 125703),
(125704, '1.10.268.10-FF-000020', NULL, 'DNA topoisomerase 2', 170, NULL, NULL, 125704),
(125705, '2.60.120.200-FF-000396', NULL, 'vitamin K-dependent protein S-like isoform X2', 192, NULL, NULL, 125705),
(125706, '3.40.50.300-FF-005006', NULL, 'Predicted protein', 107, NULL, NULL, 125706),
(125707, '1.25.40.570-FF-000025', NULL, '26S proteasome regulatory subunit RPN6', 217, NULL, NULL, 125707),
(125708, '3.10.130.10-FF-000002', NULL, 'Inactive ribonuclease-like protein 10', 122, NULL, NULL, 125708),
(125709, '2.60.40.10-FF-005404', NULL, NULL, 43, NULL, NULL, 125709),
(125710, '3.30.70.270-FF-000085', NULL, 'Endogenous retrovirus group K member 10 Pol protein', 94, NULL, NULL, 125710),
(125711, '1.20.5.110-FF-000285', NULL, 'Protein transport protein sec9', 69, NULL, NULL, 125711),
(125712, '3.30.420.10-FF-000059', NULL, 'Exosome complex exonuclease Rrp6', 297, NULL, NULL, 125712),
(125713, '4.10.1240.10-FF-000032', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', 53, NULL, NULL, 125713),
(125714, '3.30.1370.10-FF-000234', NULL, 'Uncharacterized protein', 73, NULL, NULL, 125714),
(125715, '2.20.28.10-FF-000027', NULL, 'Rubredoxin family protein', 38, NULL, NULL, 125715),
(125716, '2.60.40.10-FF-000913', NULL, 'Interleukin 31 receptor A', 87, NULL, NULL, 125716),
(125717, '3.40.50.1240-FF-000088', NULL, 'F13K23.10 protein', 225, NULL, NULL, 125717),
(125718, '1.25.40.20-FF-001242', NULL, 'Predicted protein', 245, NULL, NULL, 125718),
(125719, '1.10.3720.10-FF-000009', NULL, 'Amino acid ABC transporter permease', 215, NULL, NULL, 125719),
(125720, '1.20.120.1780-FF-000010', NULL, 'Naringenin 8-dimethylallyltransferase 2, chloroplastic', 115, NULL, NULL, 125720),
(125721, '2.40.37.10-FF-000047', NULL, NULL, 118, NULL, NULL, 125721),
(125722, '3.40.50.2000-FF-000743', NULL, 'Protein CBG06545', 173, NULL, NULL, 125722),
(125723, '1.10.540.10-FF-000069', NULL, 'Acyl-CoA dehydrogenase type 2', 87, NULL, NULL, 125723),
(125724, '3.40.850.10-FF-000090', NULL, 'Kinesin-like protein', 384, NULL, NULL, 125724),
(125725, '3.40.190.80-FF-000003', NULL, 'PAP-specific phosphatase HAL2-like', 133, NULL, NULL, 125725),
(125726, '4.10.280.10-FF-000077', NULL, 'transcription factor HES-3 isoform X2', 63, NULL, NULL, 125726);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(125727, '1.10.472.80-FF-000223', NULL, NULL, 129, NULL, NULL, 125727),
(125728, '1.25.40.450-FF-000006', NULL, 'Putative nuclear pore complex protein (NUP155)', 155, NULL, NULL, 125728),
(125729, '2.20.50.20-FF-000008', NULL, 'Vitellogenin A2', 121, NULL, NULL, 125729),
(125730, '3.80.10.10-FF-003606', NULL, 'Uncharacterized protein', 126, NULL, NULL, 125730),
(125731, '3.40.50.720-FF-002198', NULL, 'NAD-dependent epimerase/dehydratase', 321, NULL, NULL, 125731),
(125732, '3.30.70.330-FF-002565', NULL, NULL, 146, NULL, NULL, 125732),
(125733, '3.30.1370.10-FF-000127', NULL, 'RNA-binding KH domain-containing protein', 81, NULL, NULL, 125733),
(125734, '3.40.50.2300-FF-001171', NULL, NULL, 125, NULL, NULL, 125734),
(125735, '3.90.550.10-FF-000488', NULL, '2-phospho-L-lactate guanylyltransferase', 172, NULL, NULL, 125735),
(125736, '3.30.420.10-FF-000110', NULL, 'DNA polymerase III polC-type', 172, NULL, NULL, 125736),
(125737, '2.40.10.10-FF-000570', NULL, NULL, 64, NULL, NULL, 125737),
(125738, '3.40.50.1820-FF-001751', NULL, 'Prolylcarboxypeptidase, putative', 32, NULL, NULL, 125738),
(125739, '2.130.10.10-FF-004876', NULL, 'Transducin/WD40 repeat-like superfamily protein', 120, NULL, NULL, 125739),
(125740, '2.70.170.10-FF-000023', NULL, 'Acetylcholine receptor subunit beta-like 1', 219, NULL, NULL, 125740),
(125741, '2.130.10.10-FF-005500', NULL, 'Uncharacterized protein', 111, NULL, NULL, 125741),
(125742, '2.120.10.30-FF-000572', NULL, 'Uncharacterized protein', 204, NULL, NULL, 125742),
(125743, '2.60.40.10-FF-000172', NULL, 'Down syndrome cell adhesion molecule b', 87, NULL, NULL, 125743),
(125744, '1.10.287.110-FF-000364', NULL, 'Chaperone protein DNAj, putative', 95, NULL, NULL, 125744),
(125745, '3.30.40.10-FF-000710', NULL, 'mitogen-activated protein kinase kinase kinase 1 isoform X1', 79, NULL, NULL, 125745),
(125746, '2.30.30.140-FF-000082', NULL, 'Fragile X mental retardation syndrome-related protein 1', 47, NULL, NULL, 125746),
(125747, '3.40.50.300-FF-003949', NULL, 'Large subunit GTPase 1', 162, NULL, NULL, 125747),
(125748, '3.10.20.90-FF-000582', NULL, 'Ubiquitin-like protein ATG12', 96, NULL, NULL, 125748),
(125749, '1.25.40.10-FF-005235', NULL, 'Uncharacterized protein', 173, NULL, NULL, 125749),
(125750, '3.30.710.10-FF-000093', NULL, 'Potassium voltage-gated channel subfamily V member 2', 123, NULL, NULL, 125750),
(125751, '3.30.450.50-FF-000051', NULL, 'Vesicle-associated membrane protein 7-like Protein', 69, NULL, NULL, 125751),
(125752, '3.40.50.1220-FF-000082', NULL, 'Chromosome 16, whole genome shotgun sequence', 96, NULL, NULL, 125752),
(125753, '2.40.40.20-FF-000075', NULL, 'Uncharacterized protein', 93, NULL, NULL, 125753),
(125754, '2.130.10.10-FF-004039', NULL, 'Uncharacterized protein', 219, NULL, NULL, 125754),
(125755, '3.90.230.10-FF-000060', NULL, NULL, 127, NULL, NULL, 125755),
(125756, '3.40.50.2000-FF-000687', NULL, 'UDP-glycosyltransferase 89C1', 188, NULL, NULL, 125756),
(125757, '3.30.420.40-FF-000001', NULL, 'Actin, muscle', 109, NULL, NULL, 125757),
(125758, '3.40.50.200-FF-000075', NULL, 'Proprotein convertase subtilisin/kexin type 6', 111, NULL, NULL, 125758),
(125759, '2.30.40.10-FF-000151', NULL, 'Glr3518 protein', 33, NULL, NULL, 125759),
(125760, '1.20.1440.240-FF-000003', NULL, 'WGS project CABT00000000 data, contig 2.11', 119, NULL, NULL, 125760),
(125761, '2.60.120.970-FF-000048', NULL, 'Nodal-related 1', 149, NULL, NULL, 125761),
(125762, '3.40.1350.10-FF-000017', NULL, 'Restriction system protein MRR', 155, NULL, NULL, 125762),
(125763, '2.70.170.10-FF-000203', NULL, 'Uncharacterized protein', 167, NULL, NULL, 125763),
(125764, '3.80.20.20-FF-000058', NULL, 'Tyrosine-protein kinase receptor', 163, NULL, NULL, 125764),
(125765, '1.10.472.130-FF-000039', NULL, 'Dynein heavy chain domain 1', 150, NULL, NULL, 125765),
(125766, '2.60.120.290-FF-000203', NULL, 'Uncharacterized protein', 124, NULL, NULL, 125766),
(125767, '3.40.1370.10-FF-000001', NULL, '50S ribosomal protein L4', 201, NULL, NULL, 125767),
(125768, '3.40.50.300-FF-001347', NULL, 'Putative ATPase', 77, NULL, NULL, 125768);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(125769, '3.30.9.10-FF-000020', NULL, 'L-2-hydroxyglutarate dehydrogenase', 157, NULL, NULL, 125769),
(125770, '2.60.120.200-FF-000345', NULL, 'Laminin subunit alpha', 159, NULL, NULL, 125770),
(125771, '2.130.10.10-FF-005152', NULL, 'Uncharacterized protein', 143, NULL, NULL, 125771),
(125772, '3.20.20.70-FF-000334', NULL, 'CNX2', 329, NULL, NULL, 125772),
(125773, '2.80.10.50-FF-000119', NULL, 'C-type mannose receptor 2 isoform X3', 83, NULL, NULL, 125773),
(125774, '3.90.70.80-FF-000011', NULL, 'tumor necrosis factor alpha-induced protein 3', 194, NULL, NULL, 125774),
(125775, '3.30.460.10-FF-000056', NULL, 'Poly(A) polymerase gamma', 156, NULL, NULL, 125775),
(125776, '1.20.1560.10-FF-000505', NULL, 'ABC transporter', 341, NULL, NULL, 125776),
(125777, '1.20.1070.10-FF-001766', NULL, 'Uncharacterized protein', 65, NULL, NULL, 125777),
(125778, '1.20.5.340-FF-000005', NULL, 'Forkhead box P1, isoform CRA_f', 71, NULL, NULL, 125778),
(125779, '1.10.510.10-FF-001461', NULL, 'PRKACB isoform 6', 54, NULL, NULL, 125779),
(125780, '3.50.30.30-FF-000080', NULL, 'Predicted protein', 139, NULL, NULL, 125780),
(125781, '2.10.25.10-FF-000419', NULL, 'Complement C1r subcomponent', 49, NULL, NULL, 125781),
(125782, '1.10.472.80-FF-000167', NULL, NULL, 123, NULL, NULL, 125782),
(125783, '1.10.540.10-FF-000120', NULL, 'Acyl CoA DeHydrogenase', 60, NULL, NULL, 125783),
(125784, '1.50.40.10-FF-000040', NULL, 'mitochondrial carnitine/acylcarnitine carrier protein', 106, NULL, NULL, 125784),
(125785, '3.10.450.40-FF-000029', NULL, 'Elastase', 80, NULL, NULL, 125785),
(125786, '1.20.1160.20-FF-000017', NULL, 'Delphilin', 81, NULL, NULL, 125786),
(125787, '3.20.20.80-FF-000612', NULL, 'Predicted protein', 157, NULL, NULL, 125787),
(125788, '1.10.486.10-FF-000021', NULL, 'DNA helicase', 62, NULL, NULL, 125788),
(125789, '3.30.1490.50-FF-000002', NULL, 'Glutathione synthetase', 67, NULL, NULL, 125789),
(125790, '1.25.40.10-FF-003830', NULL, 'AGAP010928-PA', 125, NULL, NULL, 125790),
(125791, '1.20.1270.60-FF-000048', NULL, 'BAR adaptor protein RVS167', 248, NULL, NULL, 125791),
(125792, '2.130.10.10-FF-004663', NULL, 'Uncharacterized protein', 187, NULL, NULL, 125792),
(125793, '3.40.220.10-FF-000025', NULL, 'Polyprotein 1a', 171, NULL, NULL, 125793),
(125794, '2.60.34.10-FF-000079', NULL, 'Uncharacterized protein', 147, NULL, NULL, 125794),
(125795, '3.30.300.130-FF-000012', NULL, 'NifU-like protein 1 chloroplastic', 64, NULL, NULL, 125795),
(125796, '1.10.630.10-FF-000840', NULL, 'Uncharacterized protein', 298, NULL, NULL, 125796),
(125797, '3.40.50.1240-FF-000037', NULL, 'Sedoheptulose 1,7-bisphosphatase', 260, NULL, NULL, 125797),
(125798, '3.30.40.10-FF-001278', NULL, 'Putative RING zinc finger domain superfamily protein', 81, NULL, NULL, 125798),
(125799, '3.40.50.10810-FF-000226', NULL, 'Uncharacterized protein', 256, NULL, NULL, 125799),
(125800, '2.170.270.10-FF-000041', NULL, 'Histone-lysine N-methyltransferase SETMAR', 288, NULL, NULL, 125800),
(125801, '3.40.50.300-FF-002640', NULL, 'DEAD-box ATP-dependent RNA helicase 25', 253, NULL, NULL, 125801),
(125802, '3.30.70.100-FF-000192', NULL, NULL, 74, NULL, NULL, 125802),
(125803, '1.10.238.10-FF-001272', NULL, 'Serine/threonine-protein phosphatase 2A regulatory subunit rsa-1', 169, NULL, NULL, 125803),
(125804, '2.30.30.1020-FF-000019', NULL, 'CCR4-NOT transcription complex subunit 2, putative', 229, NULL, NULL, 125804),
(125805, '3.30.160.60-FF-001869', NULL, 'Snail family zinc finger 1', 84, NULL, NULL, 125805),
(125806, '1.20.1560.10-FF-000556', NULL, 'p-GlycoProtein related', 346, NULL, NULL, 125806),
(125807, '3.30.110.110-FF-000002', NULL, 'Double-strand break repair protein', 99, NULL, NULL, 125807),
(125808, '3.30.160.60-FF-005860', NULL, NULL, 64, NULL, NULL, 125808),
(125809, '3.40.720.10-FF-000333', NULL, 'Uncharacterized protein', 119, NULL, NULL, 125809),
(125810, '2.60.40.150-FF-000260', NULL, 'Nicotinic receptor-associated protein 1', 161, NULL, NULL, 125810),
(125811, '1.10.418.10-FF-000021', NULL, 'Leucine-rich repeat and calponin homology domain-containing protein 1 isoform 3', 128, NULL, NULL, 125811);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(125812, '3.40.50.150-FF-000324', NULL, 'N2,N2-dimethylguanosine tRNA methyltransferase', 168, NULL, NULL, 125812),
(125813, '3.30.420.610-FF-000008', NULL, 'Tudor domain-containing protein 7', 82, NULL, NULL, 125813),
(125814, '3.30.1490.20-FF-000111', NULL, 'Succinate--CoA ligase [GDP-forming] subunit beta, mitochondrial', 44, NULL, NULL, 125814),
(125815, '3.30.310.80-FF-000044', NULL, 'Non-specific serine/threonine protein kinase', 55, NULL, NULL, 125815),
(125816, '3.80.10.10-FF-000796', NULL, 'Uncharacterized protein, isoform B', 237, NULL, NULL, 125816),
(125817, '1.25.40.20-FF-001798', NULL, 'Protein CBG15247', 168, NULL, NULL, 125817),
(125818, '3.40.640.10-FF-000332', NULL, 'Saframycin Mx1 synthetase B', 237, NULL, NULL, 125818),
(125819, '3.30.1640.10-FF-000047', NULL, 'DNA helicase', 86, NULL, NULL, 125819),
(125820, '2.60.120.620-FF-000078', NULL, 'Phytanoyl-CoA alpha-hydroxylase, putative', 260, NULL, NULL, 125820),
(125821, '3.70.10.10-FF-000044', NULL, 'Proliferating cell nuclear antigen', 283, NULL, NULL, 125821),
(125822, '2.60.40.4130-FF-000001', NULL, 'Peptidase Vpr Serine peptidase MEROPS family S08A', 156, NULL, NULL, 125822),
(125823, '3.30.70.580-FF-000021', NULL, 'tRNA pseudouridine synthase', 153, NULL, NULL, 125823),
(125824, '3.80.10.10-FF-001072', NULL, 'F-box/LRR-repeat protein 3', 246, NULL, NULL, 125824),
(125825, '1.50.10.20-FF-000097', NULL, 'Complement component C5', 153, NULL, NULL, 125825),
(125826, '3.30.428.10-FF-000015', NULL, 'm7GpppX diphosphatase', 219, NULL, NULL, 125826),
(125827, '1.10.1300.10-FF-000062', NULL, 'Calcium/calmodulin-dependent 3'',5''-cyclic nucleotide phosphodiesterase 1B', 199, NULL, NULL, 125827),
(125828, '1.25.40.10-FF-001525', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 147, NULL, NULL, 125828),
(125829, '3.30.565.10-FF-000316', NULL, 'Sensor histidine kinase VirS', 147, NULL, NULL, 125829),
(125830, '3.40.50.300-FF-005950', NULL, 'DNA mismatch repair protein Msh3', 286, NULL, NULL, 125830),
(125831, '1.10.3520.10-FF-000005', NULL, 'Accelerated cell death 11', 205, NULL, NULL, 125831),
(125832, '1.10.8.10-FF-000308', NULL, 'Uncharacterized protein', 65, NULL, NULL, 125832),
(125833, '1.25.40.70-FF-000043', NULL, 'Phosphatidylinositol 4-kinase', 147, NULL, NULL, 125833),
(125834, '3.40.30.10-FF-000350', NULL, 'Blast:Thioredoxin, mitochondrial', 119, NULL, NULL, 125834),
(125835, '3.30.70.330-FF-000704', NULL, 'Ribosome biogenesis (Nop4)', 117, NULL, NULL, 125835),
(125836, '3.30.70.2140-FF-000001', NULL, 'Endoplasmin, putative', 41, NULL, NULL, 125836),
(125837, '2.40.50.90-FF-000169', NULL, 'Uncharacterized protein', 138, NULL, NULL, 125837),
(125838, '2.30.39.10-FF-000086', NULL, 'GM20003', 126, NULL, NULL, 125838),
(125839, '1.25.10.10-FF-000624', NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', 351, NULL, NULL, 125839),
(125840, '1.10.730.20-FF-000008', NULL, 'Isoleucine--tRNA ligase', 277, NULL, NULL, 125840),
(125841, '3.40.1110.10-FF-000415', NULL, NULL, 45, NULL, NULL, 125841),
(125842, '2.10.70.10-FF-000035', NULL, 'Seizure related 6 homolog', 57, NULL, NULL, 125842),
(125843, '2.30.29.30-FF-000647', NULL, 'Putative GDP-GTP exchange factor', 156, NULL, NULL, 125843),
(125844, '1.10.1450.10-FF-000005', NULL, 'Tetraspanin', 105, NULL, NULL, 125844),
(125845, '1.20.1250.20-FF-001356', NULL, 'MFS sugar transporter, putative (AFU_orthologue AFUA_3G02890)', 297, NULL, NULL, 125845),
(125846, '1.20.1270.60-FF-000279', NULL, 'Uncharacterized protein', 228, NULL, NULL, 125846),
(125847, '1.20.58.530-FF-000005', NULL, 'unconventional myosin-IXa isoform X1', 129, NULL, NULL, 125847),
(125848, '2.60.120.920-FF-000174', NULL, 'Uncharacterized protein', 85, NULL, NULL, 125848),
(125849, '1.20.5.110-FF-000054', NULL, 'Protein transport protein BOS1', 74, NULL, NULL, 125849),
(125850, '1.25.10.10-FF-000568', NULL, 'Tubulin folding cofactor D', 431, NULL, NULL, 125850),
(125851, '3.40.50.720-FF-001866', NULL, 'Uncharacterized protein', 259, NULL, NULL, 125851),
(125852, '3.40.50.410-FF-000256', NULL, 'Voltage-dependent calcium channel subunit alpha-2/delta-3', 184, NULL, NULL, 125852);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(125853, '3.10.350.10-FF-000092', NULL, 'Predicted protein', 47, NULL, NULL, 125853),
(125854, '2.60.120.10-FF-000652', NULL, 'Uncharacterized protein', 285, NULL, NULL, 125854),
(125855, '3.40.140.10-FF-000024', NULL, 'AMSH-like ubiquitin thioesterase 3', 192, NULL, NULL, 125855),
(125856, '3.40.30.10-FF-000294', NULL, 'Glutathione S-transferase, N-terminal domain containing protein, expressed', 89, NULL, NULL, 125856),
(125857, '1.20.1250.20-FF-000900', NULL, 'Proton-dependent oligopeptide transporter, POT family', 219, NULL, NULL, 125857),
(125858, '3.50.7.10-FF-000038', NULL, 'Uncharacterized protein', 70, NULL, NULL, 125858),
(125859, '3.30.70.330-FF-002834', NULL, NULL, 86, NULL, NULL, 125859),
(125860, '1.20.1270.60-FF-000335', NULL, 'Uncharacterized protein', 177, NULL, NULL, 125860),
(125861, '1.20.58.390-FF-000036', NULL, 'Nicotinic acetylcholine receptor subunit gamma', 77, NULL, NULL, 125861),
(125862, '1.20.1250.20-FF-000844', NULL, 'Os09g0297300 protein', 478, NULL, NULL, 125862),
(125863, '3.80.10.10-FF-000408', NULL, 'Adenylate cyclase', 155, NULL, NULL, 125863),
(125864, '3.10.290.10-FF-000103', NULL, 'Tyrosine--tRNA ligase, mitochondrial', 67, NULL, NULL, 125864),
(125865, '1.20.1250.20-FF-000788', NULL, 'MFS transporter', 198, NULL, NULL, 125865),
(125866, '4.10.1060.10-FF-000046', NULL, 'Si:ch1073-55a19.2', 43, NULL, NULL, 125866),
(125867, '3.40.50.410-FF-000312', NULL, 'Uncharacterized protein', 132, NULL, NULL, 125867),
(125868, '2.60.120.260-FF-000099', NULL, 'Uncharacterized protein, isoform C', 137, NULL, NULL, 125868),
(125869, '3.30.160.60-FF-000857', NULL, 'Zinc finger protein 512B', 99, NULL, NULL, 125869),
(125870, '3.90.1410.10-FF-000084', NULL, 'Uncharacterized protein', 262, NULL, NULL, 125870),
(125871, '3.30.1370.30-FF-000009', NULL, 'Putative 30S ribosomal protein S8', 68, NULL, NULL, 125871),
(125872, '3.90.1860.10-FF-000016', NULL, 'tRNA-splicing ligase RtcB homolog', 251, NULL, NULL, 125872),
(125873, '3.90.190.20-FF-000002', NULL, 'UDP-N-acetylmuramate--L-alanyl-gamma-D-glutamyl-meso-2,6-diaminoheptandioate ligase', 138, NULL, NULL, 125873),
(125874, '2.60.40.10-FF-004062', NULL, NULL, 96, NULL, NULL, 125874),
(125875, '3.20.20.140-FF-000089', NULL, 'Amidohydrolase 2', 269, NULL, NULL, 125875),
(125876, '1.10.150.50-FF-000186', NULL, 'Leucine-rich repeat and sterile alpha motif-containing 1', 71, NULL, NULL, 125876),
(125877, '2.60.40.200-FF-000027', NULL, 'Superoxide dismutase [Cu-Zn]', 114, NULL, NULL, 125877),
(125878, '2.30.30.190-FF-000012', NULL, 'CAP-Gly domain-containing linker protein 4 isoform X1', 87, NULL, NULL, 125878),
(125879, '1.20.1260.100-FF-000004', NULL, NULL, 158, NULL, NULL, 125879),
(125880, '3.30.1330.20-FF-000010', NULL, 'Cell division protein FtsZ 1, chloroplastic', 107, NULL, NULL, 125880),
(125881, '2.60.40.10-FF-002881', NULL, 'CD166 antigen homolog A', 108, NULL, NULL, 125881),
(125882, '3.30.160.60-FF-002370', NULL, NULL, 28, NULL, NULL, 125882),
(125883, '3.30.70.330-FF-001216', NULL, 'RNA binding motif protein 3', 118, NULL, NULL, 125883),
(125884, '1.10.1740.220-FF-000001', NULL, 'Protein phosphatase fem-2', 146, NULL, NULL, 125884),
(125885, '2.30.40.10-FF-000044', NULL, 'Guanine deaminase', 122, NULL, NULL, 125885),
(125886, '4.10.60.10-FF-000204', NULL, 'Uncharacterized protein', 53, NULL, NULL, 125886),
(125887, '3.40.50.410-FF-000363', NULL, 'Uncharacterized protein', 217, NULL, NULL, 125887),
(125888, '3.10.20.90-FF-000014', NULL, 'Ubiquitin-60S ribosomal L40 fusion', 78, NULL, NULL, 125888),
(125889, '3.30.160.60-FF-000222', NULL, 'Putative transcriptional repressor ctcf', 27, NULL, NULL, 125889),
(125890, '1.25.40.540-FF-000033', NULL, 'Uncharacterized protein', 103, NULL, NULL, 125890),
(125891, '2.60.40.640-FF-000024', NULL, 'Down syndrome critical region protein 3', 136, NULL, NULL, 125891),
(125892, '1.10.510.10-FF-004390', NULL, NULL, 90, NULL, NULL, 125892),
(125893, '2.60.220.50-FF-000126', NULL, 'Uncharacterized protein', 218, NULL, NULL, 125893),
(125894, '3.40.50.620-FF-000077', NULL, 'Leucine--tRNA ligase', 208, NULL, NULL, 125894);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(125895, '3.40.630.30-FF-000045', NULL, 'N-acetylglutamate synthase, mitochondrial', 157, NULL, NULL, 125895),
(125896, '3.40.190.10-FF-000971', NULL, 'ABC-type dipeptide/oligopeptide transport system, probable periplasmic component', 149, NULL, NULL, 125896),
(125897, '1.25.50.20-FF-000051', NULL, 'GM17926', 77, NULL, NULL, 125897),
(125898, '2.130.10.10-FF-000329', NULL, 'WD repeat-containing protein 44', 268, NULL, NULL, 125898),
(125899, '3.30.160.60-FF-006309', NULL, NULL, 30, NULL, NULL, 125899),
(125900, '3.80.10.10-FF-002538', NULL, 'Uncharacterized protein', 231, NULL, NULL, 125900),
(125901, '3.40.190.290-FF-000070', NULL, 'HTH-type transcriptional regulator ArgP', 219, NULL, NULL, 125901),
(125902, '3.50.50.60-FF-001490', NULL, 'Uncharacterized protein', 44, NULL, NULL, 125902),
(125903, '3.20.20.80-FF-000724', NULL, '1,3-beta-glucanosyltransferase', 146, NULL, NULL, 125903),
(125904, '2.60.40.790-FF-000041', NULL, 'Protein SGT1 homolog A', 105, NULL, NULL, 125904),
(125905, '1.10.287.380-FF-000012', NULL, 'Valine-tRNA ligase, putative', 72, NULL, NULL, 125905),
(125906, '3.40.50.300-FF-000043', NULL, 'Vacuolar protein sorting-associated protein 4', 181, NULL, NULL, 125906),
(125907, '3.30.310.180-FF-000001', NULL, 'Mediator of RNA polymerase II transcription subunit 20', 121, NULL, NULL, 125907),
(125908, '3.40.120.10-FF-000080', NULL, 'Phosphohexomutase (Phosphoglucomutase / phosphomannomutase)', 146, NULL, NULL, 125908),
(125909, '3.30.2350.20-FF-000011', NULL, 'Pseudouridine synthase', 181, NULL, NULL, 125909),
(125910, '1.10.630.10-FF-000003', NULL, 'cytochrome P450 3A12-like isoform X2', 484, NULL, NULL, 125910),
(125911, '2.60.40.1180-FF-000133', NULL, 'Alpha-N-arabinofuranosidase 1', 89, NULL, NULL, 125911),
(125912, '4.10.280.10-FF-000003', NULL, 'microphthalmia-associated transcription factor isoform X1', 83, NULL, NULL, 125912),
(125913, '1.25.40.10-FF-001812', NULL, 'Pentatricopeptide repeat-containing protein At2g29760, chloroplastic', 161, NULL, NULL, 125913),
(125914, '1.20.58.900-FF-000026', NULL, 'Small G protein signaling modulator 1', 166, NULL, NULL, 125914),
(125915, '1.25.40.10-FF-003942', NULL, 'Probable coatomer subunit epsilon', 277, NULL, NULL, 125915),
(125916, '3.50.50.60-FF-000646', NULL, 'Glycerol3-phosphate dehydrogenase, putative', 179, NULL, NULL, 125916),
(125917, '3.40.50.1000-FF-000488', NULL, NULL, 103, NULL, NULL, 125917),
(125918, '1.10.8.60-FF-000519', NULL, 'Uncharacterized protein', 40, NULL, NULL, 125918),
(125919, '3.20.20.140-FF-000145', NULL, '2-amino-3-carboxymuconate-6-semialdehyde decarboxylase, putative', 368, NULL, NULL, 125919),
(125920, '1.25.50.20-FF-000006', NULL, 'Aminopeptidase', 326, NULL, NULL, 125920),
(125921, '3.40.710.10-FF-000040', NULL, 'Methicillin resistance protein FmtA', 314, NULL, NULL, 125921),
(125922, '3.30.70.360-FF-000016', NULL, 'Peptidase family M20/M25/M40', 171, NULL, NULL, 125922),
(125923, '2.10.25.10-FF-000127', NULL, 'Neurogenic locus notch protein 1', 39, NULL, NULL, 125923),
(125924, '3.30.760.10-FF-000040', NULL, 'Uncharacterized protein', 195, NULL, NULL, 125924),
(125925, '3.40.50.150-FF-001381', NULL, NULL, 175, NULL, NULL, 125925),
(125926, '3.40.80.10-FF-000010', NULL, 'N-acetylmuramoyl-L-alanine amidase', 154, NULL, NULL, 125926),
(125927, '3.40.50.720-FF-001922', NULL, 'Predicted protein', 48, NULL, NULL, 125927),
(125928, '3.30.70.1470-FF-000002', NULL, 'Caspase-3', 102, NULL, NULL, 125928),
(125929, '3.30.310.10-FF-000012', NULL, 'Beta-adaptin-like protein', 116, NULL, NULL, 125929),
(125930, '2.130.10.10-FF-000661', NULL, 'Uncharacterized protein, isoform A', 180, NULL, NULL, 125930),
(125931, '3.30.160.60-FF-001526', NULL, 'zinc finger protein 282', 27, NULL, NULL, 125931),
(125932, '3.50.50.60-FF-000539', NULL, 'Protoporphyrinogen oxidase', 139, NULL, NULL, 125932),
(125933, '3.40.50.300-FF-002191', NULL, 'Putative DEAD/DEAH box helicase', 168, NULL, NULL, 125933),
(125934, '1.10.510.10-FF-001309', NULL, 'GM12753', 189, NULL, NULL, 125934),
(125935, '1.10.510.10-FF-003439', NULL, NULL, 283, NULL, NULL, 125935);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(125936, '3.30.230.10-FF-000011', NULL, 'DNA repair protein RadA', 158, NULL, NULL, 125936),
(125937, '1.20.1560.10-FF-000269', NULL, 'ABC transporter', 345, NULL, NULL, 125937),
(125938, '3.30.40.10-FF-000766', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 93, NULL, NULL, 125938),
(125939, '3.90.1480.20-FF-000035', NULL, 'Lactosylceramide alpha-2,3-sialyltransferase-like protein', 181, NULL, NULL, 125939),
(125940, '3.90.1410.10-FF-000140', NULL, 'Rubisco small subunit N-methyltransferase', 160, NULL, NULL, 125940),
(125941, '3.40.50.300-FF-003533', NULL, 'ADP-ribosylation factor-like protein 13B', 220, NULL, NULL, 125941),
(125942, '2.60.40.10-FF-001189', NULL, 'Semaphorin 4C', 77, NULL, NULL, 125942),
(125943, '3.30.60.90-FF-000010', NULL, 'auxin transport protein BIG', 65, NULL, NULL, 125943),
(125944, '3.40.50.300-FF-006462', NULL, 'Uncharacterized protein', 120, NULL, NULL, 125944),
(125945, '1.25.10.10-FF-001136', NULL, 'Beta-catenin-like protein 1', 490, NULL, NULL, 125945),
(125946, '2.30.40.10-FF-000100', NULL, 'N-formimino-L-glutamate deiminase', 104, NULL, NULL, 125946),
(125947, '1.20.890.10-FF-000003', NULL, 'protein dpy-30 homolog', 56, NULL, NULL, 125947),
(125948, '3.30.200.20-FF-000405', NULL, 'T3SS secreted effector NleH', 77, NULL, NULL, 125948),
(125949, '2.60.120.200-FF-000289', NULL, 'Emp46p', 226, NULL, NULL, 125949),
(125950, '1.10.555.10-FF-000210', NULL, NULL, 74, NULL, NULL, 125950),
(125951, '2.30.29.30-FF-000012', NULL, 'Arf-GAP with SH3 domain, ANK repeat and PH domain-containing protein 2', 114, NULL, NULL, 125951),
(125952, '4.10.60.10-FF-000148', NULL, 'Replication protein A subunit', 71, NULL, NULL, 125952),
(125953, '1.10.150.20-FF-000082', NULL, 'DNA-directed RNA polymerase, mitochondrial', 193, NULL, NULL, 125953),
(125954, '1.25.40.20-FF-001910', NULL, 'Uncharacterized protein', 125, NULL, NULL, 125954),
(125955, '1.20.5.2950-FF-000010', NULL, NULL, 104, NULL, NULL, 125955),
(125956, '1.20.1250.40-FF-000002', NULL, 'DNA-directed RNA polymerase III subunit RPC9', 124, NULL, NULL, 125956),
(125957, '1.20.1070.10-FF-001474', NULL, 'Uncharacterized protein', 209, NULL, NULL, 125957),
(125958, '1.20.120.350-FF-000097', NULL, 'Calcium channel subunit Cch1', 66, NULL, NULL, 125958),
(125959, '2.130.10.10-FF-005444', NULL, 'Protein CBR-ELPC-2', 206, NULL, NULL, 125959),
(125960, '3.30.920.10-FF-000024', NULL, 'Uncharacterized protein (Fragment)', 73, NULL, NULL, 125960),
(125961, '2.60.40.10-FF-000464', NULL, 'Putative obscurin-like protein 1', 89, NULL, NULL, 125961),
(125962, '1.10.486.10-FF-000072', NULL, 'Uncharacterized protein', 25, NULL, NULL, 125962),
(125963, '3.30.420.10-FF-000402', NULL, NULL, 193, NULL, NULL, 125963),
(125964, '3.10.20.90-FF-000290', NULL, 'Autophagy protein 5', 110, NULL, NULL, 125964),
(125965, '3.30.160.430-FF-000001', NULL, 'Spindle pole component', 56, NULL, NULL, 125965),
(125966, '3.20.20.70-FF-000626', NULL, NULL, 287, NULL, NULL, 125966),
(125967, '1.25.40.20-FF-001854', NULL, 'Uncharacterized protein', 136, NULL, NULL, 125967),
(125968, '3.40.50.300-FF-003657', NULL, 'DEAD-box ATP-dependent RNA helicase 22', 277, NULL, NULL, 125968),
(125969, '2.70.150.10-FF-000084', NULL, 'Probable cation-transporting ATPase HI_0290', 112, NULL, NULL, 125969),
(125970, '2.60.120.690-FF-000003', NULL, 'Uncharacterized protein', 112, NULL, NULL, 125970),
(125971, '3.30.565.10-FF-000024', NULL, 'heat shock protein 90-5, chloroplastic', 244, NULL, NULL, 125971),
(125972, '3.30.200.20-FF-001709', NULL, 'Uncharacterized protein', 43, NULL, NULL, 125972),
(125973, '2.60.40.10-FF-004859', NULL, NULL, 126, NULL, NULL, 125973),
(125974, '1.25.40.10-FF-004667', NULL, 'Os03g0435200 protein', 113, NULL, NULL, 125974),
(125975, '1.10.510.10-FF-001641', NULL, 'Os06g0191500 protein', 257, NULL, NULL, 125975),
(125976, '3.40.50.1000-FF-000600', NULL, NULL, 129, NULL, NULL, 125976),
(125977, '1.25.40.10-FF-005179', NULL, 'Antiporter/ drug transporter', 47, NULL, NULL, 125977),
(125978, '1.20.5.340-FF-000050', NULL, 'Myosin heavy chain, muscle', 110, NULL, NULL, 125978);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(125979, '3.30.450.20-FF-000272', NULL, 'Sensor histidine kinase RcsC', 122, NULL, NULL, 125979),
(125980, '3.40.50.620-FF-000818', NULL, 'Uncharacterized protein', 158, NULL, NULL, 125980),
(125981, '1.25.40.10-FF-005067', NULL, 'Uncharacterized protein', 100, NULL, NULL, 125981),
(125982, '4.10.75.10-FF-000002', NULL, 'WAP, Kazal, immunoglobulin, Kunitz and NTR domain-containing protein 2', 51, NULL, NULL, 125982),
(125983, '3.40.50.300-FF-005681', NULL, 'Dynein heavy chain', 187, NULL, NULL, 125983),
(125984, '3.40.50.300-FF-003477', NULL, 'Mitochondrial ribosome-associated GTPase 1', 142, NULL, NULL, 125984),
(125985, '1.20.1560.10-FF-000325', NULL, 'ABC transporter ATP-binding protein', 302, NULL, NULL, 125985),
(125986, '3.80.20.20-FF-000007', NULL, 'Receptor protein-tyrosine kinase', 196, NULL, NULL, 125986),
(125987, '2.130.10.10-FF-003258', NULL, 'Transducin, putative', 195, NULL, NULL, 125987),
(125988, '3.30.40.10-FF-002003', NULL, 'Putative RING zinc finger domain superfamily protein', 52, NULL, NULL, 125988),
(125989, '3.40.1110.10-FF-000128', NULL, 'Cation-transporting ATPase', 186, NULL, NULL, 125989),
(125990, '3.40.50.300-FF-007928', NULL, 'Uncharacterized protein', 295, NULL, NULL, 125990),
(125991, '2.20.100.10-FF-000215', NULL, 'Semaphorin-5A, putative', 66, NULL, NULL, 125991),
(125992, '2.40.160.20-FF-000010', NULL, 'Outer membrane porin F', 171, NULL, NULL, 125992),
(125993, '1.10.510.10-FF-002153', NULL, NULL, 90, NULL, NULL, 125993),
(125994, '3.30.1360.230-FF-000002', NULL, 'Suppressor of fused homolog', 96, NULL, NULL, 125994),
(125995, '3.50.50.60-FF-000691', NULL, 'FAD dependent oxidoreductase', 97, NULL, NULL, 125995),
(125996, '3.30.559.30-FF-000033', NULL, 'Nonribosomal peptide synthase GliP', 214, NULL, NULL, 125996),
(125997, '2.40.70.10-FF-000579', NULL, NULL, 49, NULL, NULL, 125997),
(125998, '1.20.5.4820-FF-000004', NULL, 'Myosin IE', 116, NULL, NULL, 125998),
(125999, '3.30.70.1230-FF-000060', NULL, 'Adenylate cyclase', 198, NULL, NULL, 125999),
(126000, '1.10.3380.30-FF-000011', NULL, 'DEAD/DEAH box RNA helicase', 78, NULL, NULL, 126000),
(126001, '3.30.479.30-FF-000032', NULL, 'Protein HflK', 132, NULL, NULL, 126001),
(126002, '3.30.450.40-FF-000278', NULL, 'Diguanylate cyclase with PAS/PAC sensor', 142, NULL, NULL, 126002),
(126003, '2.60.120.310-FF-000030', NULL, 'Uncharacterized protein', 88, NULL, NULL, 126003),
(126004, '2.10.25.10-FF-000307', NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein', 48, NULL, NULL, 126004),
(126005, '2.10.109.10-FF-000024', NULL, 'Signal peptidase I', 153, NULL, NULL, 126005),
(126006, '3.20.20.140-FF-000325', NULL, 'Os07g0157900 protein', 61, NULL, NULL, 126006),
(126007, '2.60.260.40-FF-000007', NULL, 'Uncharacterized protein', 48, NULL, NULL, 126007),
(126008, '2.10.90.10-FF-000093', NULL, 'AGAP000859-PA', 133, NULL, NULL, 126008),
(126009, '3.40.50.720-FF-001181', NULL, 'Pyrroline-5-carboxylate reductase', 150, NULL, NULL, 126009),
(126010, '3.90.550.10-FF-000201', NULL, 'Probable Csh5-chitin synthase 5', 110, NULL, NULL, 126010),
(126011, '1.20.1560.10-FF-000612', NULL, 'Protein CBR-PGP-12', 215, NULL, NULL, 126011),
(126012, '3.40.50.2300-FF-000951', NULL, NULL, 132, NULL, NULL, 126012),
(126013, '2.60.120.200-FF-000576', NULL, 'Predicted protein', 174, NULL, NULL, 126013),
(126014, '3.40.50.720-FF-000517', NULL, '2-dehydropantoate 2-reductase', 176, NULL, NULL, 126014),
(126015, '1.25.40.1030-FF-000042', NULL, 'Protein transport protein sec16', 405, NULL, NULL, 126015),
(126016, '3.40.50.10240-FF-000033', NULL, 'Uncharacterized protein', 168, NULL, NULL, 126016),
(126017, '3.30.9.80-FF-000001', NULL, NULL, 141, NULL, NULL, 126017),
(126018, '3.90.70.10-FF-000428', NULL, 'Cell surface protein', 270, NULL, NULL, 126018),
(126019, '3.40.140.10-FF-000131', NULL, 'Sulfurylase', 141, NULL, NULL, 126019),
(126020, '1.10.510.10-FF-002714', NULL, NULL, 235, NULL, NULL, 126020),
(126021, '1.10.10.60-FF-001162', NULL, NULL, 50, NULL, NULL, 126021),
(126022, '3.30.1130.10-FF-000020', NULL, 'Folic acid synthesis protein fol1', 124, NULL, NULL, 126022);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(126023, '3.40.50.150-FF-000032', NULL, 'Ribosomal RNA small subunit methyltransferase G', 206, NULL, NULL, 126023),
(126024, '1.10.472.10-FF-000130', NULL, 'G2/mitotic-specific cyclin S13-7', 104, NULL, NULL, 126024),
(126025, '1.10.287.810-FF-000017', NULL, 'Mitochondrial import inner membrane translocase subunit TIM8', 76, NULL, NULL, 126025),
(126026, '3.30.160.60-FF-004275', NULL, NULL, 33, NULL, NULL, 126026),
(126027, '1.10.555.10-FF-000030', NULL, 'rho GTPase-activating protein 9 isoform X1', 230, NULL, NULL, 126027),
(126028, '3.50.50.60-FF-000359', NULL, 'Methylenetetrahydrofolate--tRNA-(uracil-5-)-methyltransferase TrmFO', 178, NULL, NULL, 126028),
(126029, '1.10.1370.10-FF-000004', NULL, 'Mitochondrial intermediate peptidase', 354, NULL, NULL, 126029),
(126030, '1.20.58.760-FF-000001', NULL, 'ATP-dependent zinc metalloprotease FtsH', 203, NULL, NULL, 126030),
(126031, '3.40.50.10190-FF-000208', NULL, 'Uncharacterized protein', 98, NULL, NULL, 126031),
(126032, '1.25.40.700-FF-000008', NULL, 'Uncharacterized protein', 63, NULL, NULL, 126032),
(126033, '3.40.50.460-FF-000006', NULL, 'ATP-dependent 6-phosphofructokinase', 113, NULL, NULL, 126033),
(126034, '3.30.160.60-FF-002038', NULL, 'ZFP42 zinc finger protein', 27, NULL, NULL, 126034),
(126035, '1.10.20.10-FF-000214', NULL, NULL, 249, NULL, NULL, 126035),
(126036, '3.90.190.10-FF-000409', NULL, 'Uncharacterized protein', 99, NULL, NULL, 126036),
(126037, '3.30.160.60-FF-001638', NULL, 'Zinc finger protein 668', 29, NULL, NULL, 126037),
(126038, '1.10.260.40-FF-000062', NULL, 'Predicted transcriptional regulator', 69, NULL, NULL, 126038),
(126039, '3.40.50.1820-FF-001127', NULL, 'Dipeptidyl aminopeptidase 4', 260, NULL, NULL, 126039),
(126040, '1.10.8.10-FF-000191', NULL, 'RAD23 protein, putative', 81, NULL, NULL, 126040),
(126041, '3.40.720.10-FF-000226', NULL, 'Uncharacterized protein', 318, NULL, NULL, 126041),
(126042, '3.40.50.150-FF-001105', NULL, NULL, 86, NULL, NULL, 126042),
(126043, '3.40.50.2000-FF-000979', NULL, 'Uncharacterized protein', 75, NULL, NULL, 126043),
(126044, '1.25.40.20-FF-001293', NULL, 'Ankyrin repeat and zinc finger domain-containing 1', 167, NULL, NULL, 126044),
(126045, '3.40.50.2000-FF-000855', NULL, 'Granule bound starch synthase', 230, NULL, NULL, 126045),
(126046, '1.25.40.10-FF-001756', NULL, 'Histidine kinase', 165, NULL, NULL, 126046),
(126047, '3.50.4.10-FF-000060', NULL, NULL, 87, NULL, NULL, 126047),
(126048, '3.30.40.10-FF-002059', NULL, 'Uncharacterized protein', 90, NULL, NULL, 126048),
(126049, '2.130.10.10-FF-003819', NULL, 'Uncharacterized protein', 304, NULL, NULL, 126049),
(126050, '1.10.155.10-FF-000005', NULL, 'Chemotaxis protein methyltransferase', 77, NULL, NULL, 126050),
(126051, '1.20.58.1420-FF-000001', NULL, 'RINT-1 family protein', 125, NULL, NULL, 126051),
(126052, '1.10.10.10-FF-001169', NULL, 'Uncharacterized HTH-type transcriptional regulator YbbH', 83, NULL, NULL, 126052),
(126053, '1.20.920.10-FF-000113', NULL, 'Uncharacterized protein', 121, NULL, NULL, 126053),
(126054, '2.130.10.10-FF-001173', NULL, 'Transcription factor tau 91 kDa subunit', 311, NULL, NULL, 126054),
(126055, '1.25.40.10-FF-000396', NULL, 'Pentatricopeptide repeat-containing protein At2g36730', 100, NULL, NULL, 126055),
(126056, '3.40.850.10-FF-000106', NULL, 'Kinesin-like protein KAR3', 345, NULL, NULL, 126056),
(126057, '3.40.640.10-FF-000225', NULL, 'Glycine dehydrogenase [decarboxylating], mitochondrial', 148, NULL, NULL, 126057),
(126058, '3.10.50.40-FF-000029', NULL, 'Peptidylprolyl isomerase', 125, NULL, NULL, 126058),
(126059, '1.20.58.60-FF-000355', NULL, 'Spectrin, beta, non-erythrocytic 5', 140, NULL, NULL, 126059),
(126060, '1.25.20.10-FF-000001', NULL, 'Soluble lytic murein transglycosylase', 362, NULL, NULL, 126060),
(126061, '2.60.120.650-FF-000126', NULL, 'C-module-binding factor A', 224, NULL, NULL, 126061),
(126062, '1.20.1250.20-FF-001300', NULL, 'Solute carrier family 16 member 9b', 151, NULL, NULL, 126062),
(126063, '2.130.10.10-FF-003590', NULL, 'Zinc finger protein 106a', 110, NULL, NULL, 126063);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(126064, '1.20.140.10-FF-000143', NULL, 'Acyl-coenzyme A oxidase', 76, NULL, NULL, 126064),
(126065, '3.10.20.90-FF-000138', NULL, 'ubiquitin domain-containing protein UBFD1 isoform X2', 92, NULL, NULL, 126065),
(126066, '3.40.30.10-FF-000512', NULL, 'Thioredoxin', 88, NULL, NULL, 126066),
(126067, '1.25.40.10-FF-003381', NULL, 'Pentatricopeptide repeat (PPR-like) superfamily protein', 151, NULL, NULL, 126067),
(126068, '1.20.58.60-FF-000299', NULL, 'Spectrin beta chain', 104, NULL, NULL, 126068),
(126069, '2.30.30.40-FF-000086', NULL, 'signal transducing adapter molecule 2', 73, NULL, NULL, 126069),
(126070, '1.20.1250.20-FF-001244', NULL, 'Uncharacterized protein', 134, NULL, NULL, 126070),
(126071, '1.20.1060.10-FF-000012', NULL, 'AGAP007533-PA', 108, NULL, NULL, 126071),
(126072, '1.10.30.10-FF-000114', NULL, 'Gcf1p', 76, NULL, NULL, 126072),
(126073, '3.40.720.10-FF-000046', NULL, 'DUF229 domain-containing protein', 377, NULL, NULL, 126073),
(126074, '3.40.850.10-FF-000382', NULL, 'Kinesin-like protein', 316, NULL, NULL, 126074),
(126075, '1.20.58.60-FF-000411', NULL, 'Nesprin-1', 239, NULL, NULL, 126075),
(126076, '1.10.1140.10-FF-000015', NULL, 'Vacuolar ATP synthase catalytic subunit-related / V-ATPase-related / vacuolar proton pump-like protein', 56, NULL, NULL, 126076),
(126077, '2.30.30.40-FF-000142', NULL, 'melanoma inhibitory activity protein 2 isoform X2', 99, NULL, NULL, 126077),
(126078, '3.30.70.260-FF-000043', NULL, 'Phosphoserine phosphatase SerB', 81, NULL, NULL, 126078),
(126079, '1.25.10.10-FF-002592', NULL, 'Uncharacterized protein', 153, NULL, NULL, 126079),
(126080, '1.20.5.1430-FF-000009', NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', 80, NULL, NULL, 126080),
(126081, '1.25.10.10-FF-003210', NULL, 'Predicted protein', 276, NULL, NULL, 126081),
(126082, '3.40.470.10-FF-000009', NULL, 'Uracil-DNA glycosylase', 234, NULL, NULL, 126082),
(126083, '3.40.50.300-FF-001791', NULL, 'RAD3-like DNA-binding helicase protein', 63, NULL, NULL, 126083),
(126084, '3.40.630.30-FF-000225', NULL, 'Histone acetyltransferase', 72, NULL, NULL, 126084),
(126085, '3.40.630.30-FF-000169', NULL, 'N-acetylglutamate synthase', 136, NULL, NULL, 126085),
(126086, '3.40.50.620-FF-000257', NULL, 'Universal stress protein Rv1636', 145, NULL, NULL, 126086),
(126087, '3.20.20.70-FF-000227', NULL, 'Nicotinate phosphoribosyltransferase', 91, NULL, NULL, 126087),
(126088, '2.130.10.10-FF-001734', NULL, 'WD domain, G-beta repeat, putative', 374, NULL, NULL, 126088),
(126089, '3.30.420.40-FF-000506', NULL, 'Actin-related protein 8', 136, NULL, NULL, 126089),
(126090, '3.80.10.10-FF-001521', NULL, 'F-box/LRR-repeat protein 3 isoform A', 92, NULL, NULL, 126090),
(126091, '1.20.1250.20-FF-002137', NULL, 'Uncharacterized protein', 204, NULL, NULL, 126091),
(126092, '3.30.160.60-FF-003151', NULL, NULL, 24, NULL, NULL, 126092),
(126093, '2.60.120.920-FF-000050', NULL, 'Neuralized E3 ubiquitin protein ligase 3', 154, NULL, NULL, 126093),
(126094, '3.30.56.10-FF-000038', NULL, 'AGAP003517-PA', 72, NULL, NULL, 126094),
(126095, '3.30.200.20-FF-002373', NULL, 'Uncharacterized protein', 109, NULL, NULL, 126095),
(126096, '1.10.287.660-FF-000006', NULL, 'Protein GET1', 80, NULL, NULL, 126096),
(126097, '1.10.10.1180-FF-000010', NULL, 'Uncharacterized protein', 54, NULL, NULL, 126097),
(126098, '3.30.2160.10-FF-000027', NULL, 'Ubiquitin-protein ligase, putative', 81, NULL, NULL, 126098),
(126099, '3.30.160.60-FF-000060', NULL, 'zinc finger protein 436', 28, NULL, NULL, 126099),
(126100, '3.80.10.10-FF-004270', NULL, 'Si:zfos-364h11.2', 56, NULL, NULL, 126100),
(126101, '3.40.30.10-FF-001075', NULL, 'Selenoprotein U', 150, NULL, NULL, 126101),
(126102, '3.40.50.1820-FF-000689', NULL, 'Alpha/beta hydrolase', 233, NULL, NULL, 126102),
(126103, '3.40.50.300-FF-000223', NULL, 'Dynein heavy chain 3, axonemal', 173, NULL, NULL, 126103),
(126104, '3.30.365.10-FF-000043', NULL, 'Aldehyde oxidase and xanthine dehydrogenase, a/b hammerhead domain', 130, NULL, NULL, 126104),
(126105, '1.20.58.390-FF-000216', NULL, 'Nicotinic acetylcholine receptor subunit', 70, NULL, NULL, 126105);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(126106, '3.30.70.2350-FF-000002', NULL, 'GlpG protein', 70, NULL, NULL, 126106),
(126107, '1.10.1670.10-FF-000044', NULL, NULL, 89, NULL, NULL, 126107),
(126108, '1.20.58.80-FF-000018', NULL, 'nuclear receptor-binding factor 2 isoform X1', 92, NULL, NULL, 126108),
(126109, '1.20.1270.60-FF-000155', NULL, 'Uncharacterized protein', 221, NULL, NULL, 126109),
(126110, '3.60.20.40-FF-000003', NULL, 'Gamma-glutamyltranspeptidase', 190, NULL, NULL, 126110),
(126111, '3.80.10.10-FF-000228', NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM1', 156, NULL, NULL, 126111),
(126112, '3.40.50.10090-FF-000004', NULL, 'Uroporphyrinogen-III synthase', 109, NULL, NULL, 126112),
(126113, '2.10.50.10-FF-000107', NULL, 'Tumor necrosis factor receptor superfamily member 5', 81, NULL, NULL, 126113),
(126114, '3.80.10.10-FF-003994', NULL, 'Uncharacterized protein', 155, NULL, NULL, 126114),
(126115, '3.60.40.10-FF-000282', NULL, 'Protein phosphatase, Mg2+/Mn2+ dependent 1F', 138, NULL, NULL, 126115),
(126116, '1.10.135.10-FF-000010', NULL, 'Creatine kinase B', 35, NULL, NULL, 126116),
(126117, '3.30.70.80-FF-000025', NULL, 'Probable endopeptidase K', 69, NULL, NULL, 126117),
(126118, '3.20.20.80-FF-000848', NULL, 'Uncharacterized protein', 179, NULL, NULL, 126118),
(126119, '3.40.800.10-FF-000047', NULL, NULL, 193, NULL, NULL, 126119),
(126120, '3.40.140.70-FF-000014', NULL, 'Uncharacterized protein', 68, NULL, NULL, 126120),
(126121, '1.50.40.10-FF-000152', NULL, 'Mitochondrial carrier domain-containing protein', 201, NULL, NULL, 126121),
(126122, '1.10.10.10-FF-000444', NULL, 'Rrf2 family transcriptional regulator', 141, NULL, NULL, 126122),
(126123, '2.60.120.260-FF-000335', NULL, 'Uncharacterized protein', 197, NULL, NULL, 126123),
(126124, '1.10.730.10-FF-000224', NULL, 'Os06g0645400 protein', 131, NULL, NULL, 126124),
(126125, '1.10.405.10-FF-000042', NULL, 'Uncharacterized protein', 32, NULL, NULL, 126125),
(126126, '1.50.40.10-FF-000096', NULL, 'ADP,ATP carrier protein 1, mitochondrial', 289, NULL, NULL, 126126),
(126127, '3.40.30.10-FF-000911', NULL, 'Predicted protein', 132, NULL, NULL, 126127),
(126128, '1.10.510.10-FF-002658', NULL, NULL, 166, NULL, NULL, 126128),
(126129, '1.10.3470.10-FF-000012', NULL, 'Zinc ABC transporter, permease', 231, NULL, NULL, 126129),
(126130, '1.20.1280.50-FF-000271', NULL, 'Predicted protein', 41, NULL, NULL, 126130),
(126131, '1.10.1220.10-FF-000016', NULL, 'DNA-damage-inducible protein J', 81, NULL, NULL, 126131),
(126132, '1.10.630.10-FF-000391', NULL, 'Os11g0469900 protein', 184, NULL, NULL, 126132),
(126133, '3.40.50.300-FF-002752', NULL, 'Septum formation initiator', 213, NULL, NULL, 126133),
(126134, '1.10.238.10-FF-000760', NULL, 'Predicted dual oxidase-D', 173, NULL, NULL, 126134),
(126135, '3.40.50.300-FF-002696', NULL, 'ATP-binding cassette protein, putative', 247, NULL, NULL, 126135),
(126136, '2.40.10.230-FF-000012', NULL, 'Uncharacterized protein', 171, NULL, NULL, 126136),
(126137, '2.60.120.330-FF-000036', NULL, 'Oxidoreductase, 2OG-Fe(II) oxygenase family', 322, NULL, NULL, 126137),
(126138, '1.10.510.10-FF-000005', NULL, 'cAMP-dependent protein kinase catalytic subunit alpha', 191, NULL, NULL, 126138),
(126139, '3.30.70.330-FF-002273', NULL, NULL, 105, NULL, NULL, 126139),
(126140, '1.20.1250.20-FF-000283', NULL, 'MFS sugar transporter', 480, NULL, NULL, 126140),
(126141, '2.40.50.140-FF-000807', NULL, NULL, 141, NULL, NULL, 126141),
(126142, '3.30.1060.10-FF-000025', NULL, NULL, 168, NULL, NULL, 126142),
(126143, '1.20.58.60-FF-000012', NULL, 'Microtubule-actin cross-linking factor 1', 109, NULL, NULL, 126143),
(126144, '3.30.40.10-FF-000261', NULL, 'Mindbomb E3 ubiquitin protein ligase 2', 60, NULL, NULL, 126144),
(126145, '2.40.50.140-FF-000302', NULL, 'rRNA biogenesis protein rrp5', 84, NULL, NULL, 126145),
(126146, '2.170.16.10-FF-000043', NULL, 'DNA-directed RNA polymerase subunit beta', 134, NULL, NULL, 126146),
(126147, '3.30.160.60-FF-003095', NULL, NULL, 31, NULL, NULL, 126147),
(126148, '3.30.2410.10-FF-000064', NULL, 'Uncharacterized protein', 70, NULL, NULL, 126148);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(126149, '3.30.160.60-FF-002190', NULL, 'Zinc finger protein 658', 29, NULL, NULL, 126149),
(126150, '3.30.40.10-FF-001166', NULL, 'Uncharacterized protein', 76, NULL, NULL, 126150),
(126151, '2.30.42.10-FF-000498', NULL, NULL, 81, NULL, NULL, 126151),
(126152, '3.40.50.300-FF-000622', NULL, 'ATP-binding cassette sub-family G member 2', 243, NULL, NULL, 126152),
(126153, '3.30.70.100-FF-000080', NULL, 'Copper-transporting ATPase', 69, NULL, NULL, 126153),
(126154, '3.30.50.10-FF-000087', NULL, 'Mineralocorticoid receptor', 68, NULL, NULL, 126154),
(126155, '1.10.150.50-FF-000130', NULL, 'Serine/threonine-protein kinase, putative', 69, NULL, NULL, 126155),
(126156, '3.80.10.10-FF-000560', NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3', 106, NULL, NULL, 126156),
(126157, '3.40.50.1820-FF-001307', NULL, 'Hydrolase, alpha/beta fold family protein', 268, NULL, NULL, 126157),
(126158, '3.40.50.1820-FF-000402', NULL, 'Putative siderophore biosysnthesis protein', 251, NULL, NULL, 126158),
(126159, '3.30.420.10-FF-000166', NULL, 'Exonuclease family protein', 181, NULL, NULL, 126159),
(126160, '3.40.50.300-FF-001392', NULL, 'GTPase IMAP family member GIMD1', 209, NULL, NULL, 126160),
(126161, '3.40.50.300-FF-006967', NULL, 'Uncharacterized protein ABCG27', 311, NULL, NULL, 126161),
(126162, '1.20.1260.10-FF-000067', NULL, 'Ferritin', 99, NULL, NULL, 126162),
(126163, '3.40.710.10-FF-000164', NULL, 'Penicillin-binding protein, class 1A', 329, NULL, NULL, 126163),
(126164, '3.20.20.140-FF-000269', NULL, 'Uncharacterized protein', 174, NULL, NULL, 126164),
(126165, '1.20.1070.10-FF-000417', NULL, 'CCK-like receptor', 336, NULL, NULL, 126165),
(126166, '3.90.120.30-FF-000001', NULL, 'Cytosine-specific methyltransferase', 110, NULL, NULL, 126166),
(126167, '1.10.1060.10-FF-000014', NULL, 'DgcB, Dimethylglycine catabolism', 140, NULL, NULL, 126167),
(126168, '3.40.630.10-FF-000163', NULL, 'Aminoacyl-histidine dipeptidase', 104, NULL, NULL, 126168),
(126169, '3.20.20.100-FF-000105', NULL, 'Predicted protein', 336, NULL, NULL, 126169),
(126170, '3.40.50.410-FF-000076', NULL, 'general transcription factor IIH subunit 3', 212, NULL, NULL, 126170),
(126171, '3.10.620.30-FF-000023', NULL, 'Predicted protein', 156, NULL, NULL, 126171),
(126172, '1.10.10.10-FF-001225', NULL, 'EAP30/Vps36 family, putative', 67, NULL, NULL, 126172),
(126173, '3.30.360.10-FF-000015', NULL, 'Glucose-6-phosphate 1-dehydrogenase', 272, NULL, NULL, 126173),
(126174, '3.30.420.10-FF-000346', NULL, 'Polynucleotidyl transferase, ribonuclease H-like superfamily protein', 163, NULL, NULL, 126174),
(126175, '1.20.920.10-FF-000057', NULL, 'Polybromo 1', 133, NULL, NULL, 126175),
(126176, '3.30.70.330-FF-001492', NULL, NULL, 104, NULL, NULL, 126176),
(126177, '2.70.170.10-FF-000259', NULL, 'Uncharacterized protein', 161, NULL, NULL, 126177),
(126178, '1.25.40.10-FF-004847', NULL, 'Anaphase-promoting complex subunit 6', 136, NULL, NULL, 126178),
(126179, '3.40.1090.10-FF-000070', NULL, 'Patatin', 214, NULL, NULL, 126179),
(126180, '3.20.20.100-FF-000049', NULL, 'Oxidoreductase, aldo/keto reductase family protein', 300, NULL, NULL, 126180),
(126181, '3.30.160.60-FF-003712', NULL, NULL, 28, NULL, NULL, 126181),
(126182, '6.20.50.160-FF-000005', NULL, 'Thioester-containing protein 6', 55, NULL, NULL, 126182),
(126183, '3.40.50.300-FF-003713', NULL, 'DNA helicase', 67, NULL, NULL, 126183),
(126184, '1.10.10.10-FF-000949', NULL, 'Contig184, whole genome shotgun sequence', 101, NULL, NULL, 126184),
(126185, '3.40.50.150-FF-001049', NULL, NULL, 93, NULL, NULL, 126185),
(126186, '2.60.40.3710-FF-000004', NULL, 'POSSIBLE CONSERVED EXPORTED PROTEIN', 92, NULL, NULL, 126186),
(126187, '3.30.60.30-FF-000251', NULL, 'Agrin-like Protein', 39, NULL, NULL, 126187),
(126188, '2.30.110.10-FF-000051', NULL, 'YKL070W-like protein', 168, NULL, NULL, 126188),
(126189, '2.130.10.10-FF-005388', NULL, 'Uncharacterized protein', 154, NULL, NULL, 126189),
(126190, '1.10.287.110-FF-000252', NULL, 'Uncharacterized protein', 54, NULL, NULL, 126190);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(126191, '3.30.9.10-FF-000256', NULL, 'Uncharacterized protein', 160, NULL, NULL, 126191),
(126192, '3.30.40.10-FF-000822', NULL, 'Chromatin modification-related protein', 67, NULL, NULL, 126192),
(126193, '4.10.1240.10-FF-000088', NULL, 'Uncharacterized protein', 55, NULL, NULL, 126193),
(126194, '1.25.40.10-FF-005123', NULL, 'Uncharacterized protein', 111, NULL, NULL, 126194),
(126195, '2.60.120.20-FF-000019', NULL, 'Genome polyprotein', 224, NULL, NULL, 126195),
(126196, '3.90.660.10-FF-000030', NULL, 'Unplaced genomic scaffold supercont1.10, whole genome shotgun sequence', 228, NULL, NULL, 126196),
(126197, '1.20.1070.10-FF-001530', NULL, 'Uncharacterized protein', 186, NULL, NULL, 126197),
(126198, '3.30.40.10-FF-001222', NULL, 'Histone-lysine N-methyltransferase', 45, NULL, NULL, 126198),
(126199, '1.10.10.10-FF-001405', NULL, 'Iron dependent repressor', 139, NULL, NULL, 126199),
(126200, '1.20.1070.10-FF-000237', NULL, 'Uncharacterized protein', 313, NULL, NULL, 126200),
(126201, '1.20.990.10-FF-000044', NULL, '(methionine synthase) reductase', 134, NULL, NULL, 126201),
(126202, '2.60.40.10-FF-004679', NULL, NULL, 114, NULL, NULL, 126202),
(126203, '1.25.40.820-FF-000027', NULL, 'Uncharacterized protein', 166, NULL, NULL, 126203),
(126204, '3.40.50.1820-FF-000346', NULL, 'Oleoyl-ACP hydrolase', 77, NULL, NULL, 126204),
(126205, '2.60.120.620-FF-000022', NULL, 'Prolyl 4-hydroxylase alpha subunit', 193, NULL, NULL, 126205),
(126206, '1.20.120.350-FF-000041', NULL, 'Transmembrane protein 266', 129, NULL, NULL, 126206),
(126207, '3.30.420.140-FF-000019', NULL, 'Transcription modulator/accessory protein,putative', 124, NULL, NULL, 126207),
(126208, '2.60.120.10-FF-000073', NULL, 'Glycinin G1', 166, NULL, NULL, 126208),
(126209, '3.40.50.2000-FF-000799', NULL, 'Uncharacterized protein', 68, NULL, NULL, 126209),
(126210, '3.10.28.10-FF-000042', NULL, 'Replicative DNA helicase', 219, NULL, NULL, 126210),
(126211, '1.10.287.130-FF-000134', NULL, 'Two-component sensor histidine kinase', 112, NULL, NULL, 126211),
(126212, '3.80.10.10-FF-000740', NULL, 'Leucine rich repeat neuronal 4', 208, NULL, NULL, 126212),
(126213, '3.30.505.10-FF-000195', NULL, NULL, 96, NULL, NULL, 126213),
(126214, '2.40.20.10-FF-000071', NULL, 'Uncharacterized protein', 71, NULL, NULL, 126214),
(126215, '1.25.40.10-FF-004903', NULL, 'Uncharacterized protein', 79, NULL, NULL, 126215),
(126216, '3.40.50.300-FF-006063', NULL, 'Uncharacterized protein', 80, NULL, NULL, 126216),
(126217, '3.40.950.10-FF-000035', NULL, NULL, 174, NULL, NULL, 126217),
(126218, '1.25.40.10-FF-000452', NULL, 'pentatricopeptide repeat-containing protein At2g03880, mitochondrial', 99, NULL, NULL, 126218),
(126219, '1.50.10.20-FF-000041', NULL, 'Geranylgeranyltransferase I beta subunit, putative', 318, NULL, NULL, 126219),
(126220, '3.30.160.70-FF-000006', NULL, 'Methylated-DNA--protein-cysteine methyltransferase', 81, NULL, NULL, 126220),
(126221, '3.30.70.330-FF-000199', NULL, 'Putative peroxisome proliferator-activated receptor gamma coactivator-related protein 1', 158, NULL, NULL, 126221),
(126222, '3.30.160.60-FF-003494', NULL, 'Zinc finger and BTB domain containing 41', 28, NULL, NULL, 126222),
(126223, '2.30.29.30-FF-000068', NULL, 'Son of sevenless homolog 1 (Drosophila)', 110, NULL, NULL, 126223),
(126224, '2.60.40.10-FF-005079', NULL, NULL, 100, NULL, NULL, 126224),
(126225, '3.60.21.10-FF-000154', NULL, 'Uncharacterized protein, isoform B', 253, NULL, NULL, 126225),
(126226, '1.10.580.10-FF-000010', NULL, 'Citrate synthase', 223, NULL, NULL, 126226),
(126227, '2.60.40.1180-FF-000077', NULL, 'Maltase A7', 81, NULL, NULL, 126227),
(126228, '2.60.40.10-FF-000969', NULL, 'Advanced glycosylation end product-specific receptor', 111, NULL, NULL, 126228),
(126229, '3.90.180.10-FF-000004', NULL, 'probable cinnamyl alcohol dehydrogenase', 181, NULL, NULL, 126229),
(126230, '1.25.10.10-FF-002193', NULL, 'Coatomer subunit beta', 448, NULL, NULL, 126230),
(126231, '1.10.8.190-FF-000001', NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit alpha 1', 124, NULL, NULL, 126231);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(126232, '1.10.238.20-FF-000021', NULL, 'Odorant-binding protein 13', 123, NULL, NULL, 126232),
(126233, '3.30.540.10-FF-000001', NULL, 'Fructose-1,6-bisphosphatase', 149, NULL, NULL, 126233),
(126234, '1.10.10.10-FF-000388', NULL, 'plectin isoform X1', 96, NULL, NULL, 126234),
(126235, '3.40.109.10-FF-000002', NULL, 'Oxygen-insensitive NAD(P)H nitroreductase', 217, NULL, NULL, 126235),
(126236, '3.30.160.60-FF-000801', NULL, 'zinc finger protein 461 isoform X2', 28, NULL, NULL, 126236),
(126237, '3.30.160.60-FF-004511', NULL, NULL, 33, NULL, NULL, 126237),
(126238, '2.60.120.260-FF-000279', NULL, 'Glycoside hydrolase family 29', 97, NULL, NULL, 126238),
(126239, '1.25.40.10-FF-003886', NULL, 'Uncharacterized protein', 80, NULL, NULL, 126239),
(126240, '3.30.930.10-FF-000429', NULL, 'Uncharacterized protein', 167, NULL, NULL, 126240),
(126241, '3.40.50.1100-FF-000243', NULL, 'Cysteine synthase, putative', 44, NULL, NULL, 126241),
(126242, '1.25.40.120-FF-000082', NULL, 'Uncharacterized protein', 375, NULL, NULL, 126242),
(126243, '1.10.10.1210-FF-000002', NULL, 'melanoma-associated antigen E1', 122, NULL, NULL, 126243),
(126244, '1.25.40.10-FF-004162', NULL, 'Signal recognition particle subunit SRP72', 104, NULL, NULL, 126244),
(126245, '3.90.740.10-FF-000031', NULL, 'valine--tRNA ligase, chloroplastic/mitochondrial 2 isoform X3', 70, NULL, NULL, 126245),
(126246, '3.20.20.80-FF-000668', NULL, 'Gll2003 protein', 388, NULL, NULL, 126246),
(126247, '3.40.50.620-FF-000313', NULL, 'DUF218 domain', 126, NULL, NULL, 126247),
(126248, '1.10.287.70-FF-000610', NULL, 'Uncharacterized protein', 265, NULL, NULL, 126248),
(126249, '1.10.167.10-FF-000016', NULL, 'Regulator of G protein signaling 22', 148, NULL, NULL, 126249),
(126250, '2.40.50.140-FF-000246', NULL, 'DNA helicase MCM8', 76, NULL, NULL, 126250),
(126251, '3.40.30.10-FF-000855', NULL, 'Zgc:136472', 129, NULL, NULL, 126251),
(126252, '2.30.42.10-FF-000554', NULL, NULL, 67, NULL, NULL, 126252),
(126253, '3.40.50.1000-FF-000544', NULL, NULL, 209, NULL, NULL, 126253),
(126254, '1.10.3370.10-FF-000027', NULL, 'Sec61 protein, putative', 73, NULL, NULL, 126254),
(126255, '2.60.40.10-FF-001369', NULL, 'Muscle M-line assembly protein unc-89', 109, NULL, NULL, 126255),
(126256, '3.30.420.270-FF-000030', NULL, 'Biopolymer transport protein ExbD/TolR', 69, NULL, NULL, 126256),
(126257, '3.40.50.1010-FF-000081', NULL, 'Ribonuclease VapC', 130, NULL, NULL, 126257),
(126258, '1.10.287.70-FF-000211', NULL, 'Uncharacterized protein', 157, NULL, NULL, 126258),
(126259, '2.110.10.10-FF-000050', NULL, 'Uncharacterized protein', 65, NULL, NULL, 126259),
(126260, '2.30.29.30-FF-001029', NULL, 'Uncharacterized protein', 75, NULL, NULL, 126260),
(126261, '2.130.10.10-FF-001678', NULL, 'WD domain containing protein', 158, NULL, NULL, 126261),
(126262, '3.90.79.20-FF-000013', NULL, 'NADH pyrophosphatase', 126, NULL, NULL, 126262),
(126263, '2.60.120.200-FF-000632', NULL, 'Uncharacterized protein', 126, NULL, NULL, 126263),
(126264, '3.90.260.10-FF-000005', NULL, 'DNA repair protein rhp41', 301, NULL, NULL, 126264),
(126265, '3.90.210.10-FF-000002', NULL, 'Pierisin', 271, NULL, NULL, 126265),
(126266, '3.30.1360.10-FF-000065', NULL, 'DNA-directed RNA polymerase, alpha subunit, putative', 131, NULL, NULL, 126266),
(126267, '3.20.20.70-FF-000047', NULL, '3-dehydroquinate dehydratase', 252, NULL, NULL, 126267),
(126268, '3.30.70.270-FF-000321', NULL, NULL, 147, NULL, NULL, 126268),
(126269, '1.10.10.1900-FF-000001', NULL, NULL, 66, NULL, NULL, 126269),
(126270, '2.70.160.11-FF-000086', NULL, 'Uncharacterized protein', 183, NULL, NULL, 126270),
(126271, '3.30.497.10-FF-000034', NULL, 'SERPINH1 isoform 13', 201, NULL, NULL, 126271),
(126272, '1.10.472.80-FF-000111', NULL, 'TBC domain containing protein', 123, NULL, NULL, 126272),
(126273, '3.80.10.10-FF-004118', NULL, 'Uncharacterized protein', 115, NULL, NULL, 126273),
(126274, '3.40.50.300-FF-006271', NULL, 'Mitochondrial Rho GTPase', 171, NULL, NULL, 126274),
(126275, '1.10.246.120-FF-000004', NULL, 'Vacuolar sorting protein', 109, NULL, NULL, 126275);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(126276, '2.130.10.10-FF-001077', NULL, 'Elongator protein 2', 114, NULL, NULL, 126276),
(126277, '1.20.5.500-FF-000002', NULL, 'Lamin A/C', 76, NULL, NULL, 126277),
(126278, '3.60.20.10-FF-000112', NULL, 'Proteasome subunit beta', 188, NULL, NULL, 126278),
(126279, '3.30.420.10-FF-000430', NULL, NULL, 103, NULL, NULL, 126279),
(126280, '1.20.920.10-FF-000141', NULL, 'Putative polybromo 1', 142, NULL, NULL, 126280),
(126281, '1.20.80.10-FF-000009', NULL, 'FERM and PDZ domain containing 4', 127, NULL, NULL, 126281),
(126282, '1.10.630.10-FF-000076', NULL, 'Cytochrome P450 monooxygenase', 480, NULL, NULL, 126282),
(126283, '1.10.510.10-FF-004311', NULL, NULL, 153, NULL, NULL, 126283),
(126284, '1.10.238.10-FF-000479', NULL, 'EH domains and endocytosis-related protein', 103, NULL, NULL, 126284),
(126285, '3.40.50.150-FF-001077', NULL, NULL, 238, NULL, NULL, 126285),
(126286, '2.40.30.30-FF-000015', NULL, 'Riboflavin kinase/fmn adenylyltransferase-like protein', 168, NULL, NULL, 126286),
(126287, '3.10.20.90-FF-000262', NULL, 'E3 ubiquitin-protein ligase MYLIP', 52, NULL, NULL, 126287),
(126288, '2.30.29.30-FF-000411', NULL, 'Blast:Rho GTPase-activating protein 26', 106, NULL, NULL, 126288),
(126289, '3.40.50.2300-FF-000878', NULL, 'Uncharacterized protein', 205, NULL, NULL, 126289),
(126290, '3.30.160.60-FF-002167', NULL, 'Si:ch211-269m15.3', 28, NULL, NULL, 126290),
(126291, '1.20.1560.10-FF-000421', NULL, 'ATP-binding cassette protein subfamily B, member 2, putative', 237, NULL, NULL, 126291),
(126292, '3.20.20.60-FF-000106', NULL, 'Uncharacterized protein', 269, NULL, NULL, 126292),
(126293, '3.80.10.10-FF-001156', NULL, 'Protein STRUBBELIG-RECEPTOR FAMILY 6 isoform A', 109, NULL, NULL, 126293),
(126294, '1.25.10.10-FF-001956', NULL, 'DNA-directed RNA polymerase subunit beta', 270, NULL, NULL, 126294),
(126295, '4.10.400.10-FF-000328', NULL, 'Uncharacterized protein', 39, NULL, NULL, 126295),
(126296, '3.30.70.260-FF-000155', NULL, 'ribose-5-phosphate isomerase-like', 84, NULL, NULL, 126296),
(126297, '2.130.10.10-FF-003814', NULL, 'Peroxisomal targeting signal 2 receptor', 306, NULL, NULL, 126297),
(126298, '3.40.50.1000-FF-000095', NULL, 'haloacid dehalogenase-like hydrolase domain-containing protein 2', 136, NULL, NULL, 126298),
(126299, '3.40.50.20-FF-000062', NULL, 'D-alanine--D-alanine ligase', 113, NULL, NULL, 126299),
(126300, '3.30.40.10-FF-001418', NULL, 'Uncharacterized protein', 60, NULL, NULL, 126300),
(126301, '3.10.450.240-FF-000032', NULL, 'Predicted protein', 86, NULL, NULL, 126301),
(126302, '1.25.40.10-FF-004055', NULL, 'Predicted protein', 167, NULL, NULL, 126302),
(126303, '3.30.70.120-FF-000046', NULL, NULL, 53, NULL, NULL, 126303),
(126304, '3.30.420.40-FF-000282', NULL, 'Actin-like protein, putative', 117, NULL, NULL, 126304),
(126305, '1.10.238.210-FF-000008', NULL, 'Uncharacterized protein', 38, NULL, NULL, 126305),
(126306, '2.20.25.10-FF-000026', NULL, 'DNA-directed RNA polymerase subunit', 52, NULL, NULL, 126306),
(126307, '1.20.58.60-FF-000720', NULL, 'Uncharacterized protein', 108, NULL, NULL, 126307),
(126308, '3.90.550.10-FF-000701', NULL, 'Uncharacterized protein', 289, NULL, NULL, 126308),
(126309, '1.10.510.10-FF-002057', NULL, 'Kinase, STE Dicty2', 292, NULL, NULL, 126309),
(126310, '3.30.1370.110-FF-000024', NULL, 'Uncharacterized protein', 103, NULL, NULL, 126310),
(126311, '3.40.50.620-FF-000280', NULL, 'DUF218 domain', 138, NULL, NULL, 126311),
(126312, '3.40.50.2300-FF-000395', NULL, 'Two-component response regulator', 87, NULL, NULL, 126312),
(126313, '2.130.10.10-FF-003331', NULL, 'Uncharacterized protein', 67, NULL, NULL, 126313),
(126314, '2.40.50.140-FF-000797', NULL, NULL, 162, NULL, NULL, 126314),
(126315, '3.30.70.141-FF-000019', NULL, 'Nucleoside diphosphate kinase, putative', 145, NULL, NULL, 126315),
(126316, '2.10.70.10-FF-000182', NULL, 'thyroid peroxidase', 56, NULL, NULL, 126316),
(126317, '1.20.1720.10-FF-000086', NULL, 'Bcr/CflA family efflux transporter', 382, NULL, NULL, 126317),
(126318, '3.40.50.2000-FF-000895', NULL, 'ADP-heptose:LPS heptosyltransferase II, putative', 174, NULL, NULL, 126318);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(126319, '1.10.150.60-FF-000048', NULL, NULL, 90, NULL, NULL, 126319),
(126320, '3.40.50.2300-FF-000439', NULL, 'Transcription factor SKN7', 149, NULL, NULL, 126320),
(126321, '1.25.10.10-FF-001473', NULL, 'Uncharacterized protein', 180, NULL, NULL, 126321),
(126322, '1.10.238.10-FF-000007', NULL, 'Putative myosin regulatory light chain sqh', 86, NULL, NULL, 126322),
(126323, '3.30.710.10-FF-000177', NULL, 'Protein CBR-KVS-5', 130, NULL, NULL, 126323),
(126324, '1.10.472.130-FF-000062', NULL, 'Inner dynein arm 1 heavy chain 1-ALPHa', 169, NULL, NULL, 126324),
(126325, '1.10.10.10-FF-001321', NULL, 'Two component transcriptional regulator, winged helix family', 101, NULL, NULL, 126325),
(126326, '1.20.1070.10-FF-001974', NULL, 'Uncharacterized protein', 177, NULL, NULL, 126326),
(126327, '3.40.50.180-FF-000001', NULL, 'Protein-glutamate methylesterase/protein-glutamine glutaminase', 198, NULL, NULL, 126327),
(126328, '3.40.50.150-FF-000088', NULL, 'Polyamine aminopropyltransferase', 246, NULL, NULL, 126328),
(126329, '1.25.40.180-FF-000239', NULL, NULL, 187, NULL, NULL, 126329),
(126330, '1.10.510.10-FF-003838', NULL, NULL, 107, NULL, NULL, 126330),
(126331, '2.170.270.10-FF-000203', NULL, 'Uncharacterized protein', 175, NULL, NULL, 126331),
(126332, '3.30.70.1450-FF-000007', NULL, 'K(+)/H(+) antiporter NhaP2', 74, NULL, NULL, 126332),
(126333, '1.10.8.140-FF-000003', NULL, 'Programmed cell death 5', 101, NULL, NULL, 126333),
(126334, '3.40.50.10090-FF-000072', NULL, 'Uncharacterized protein', 46, NULL, NULL, 126334),
(126335, '3.80.10.10-FF-003410', NULL, 'Predicted protein', 86, NULL, NULL, 126335),
(126336, '3.60.110.10-FF-000052', NULL, 'Uncharacterized protein', 295, NULL, NULL, 126336),
(126337, '2.10.25.10-FF-000330', NULL, 'usherin', 51, NULL, NULL, 126337),
(126338, '3.60.21.10-FF-000266', NULL, 'Ser/Thr protein phosphatase family protein', 366, NULL, NULL, 126338),
(126339, '2.40.70.10-FF-000394', NULL, NULL, 184, NULL, NULL, 126339),
(126340, '1.25.40.770-FF-000012', NULL, 'TAF6-like protein', 201, NULL, NULL, 126340),
(126341, '2.40.100.10-FF-000104', NULL, 'Cyclophilin-like peptidyl-prolyl cis-trans isomerase family protein', 179, NULL, NULL, 126341),
(126342, '3.20.20.140-FF-000393', NULL, 'Uncharacterized protein', 163, NULL, NULL, 126342),
(126343, '3.30.40.10-FF-002363', NULL, 'Ubiquitinyl hydrolase 1', 114, NULL, NULL, 126343),
(126344, '3.40.50.1110-FF-000156', NULL, 'Uncharacterized protein', 196, NULL, NULL, 126344),
(126345, '3.90.190.10-FF-000229', NULL, 'Dual specificity phosphatase 10', 85, NULL, NULL, 126345),
(126346, '3.80.10.10-FF-002584', NULL, 'Uncharacterized protein', 104, NULL, NULL, 126346),
(126347, '3.40.50.300-FF-005326', NULL, 'Uncharacterized protein', 151, NULL, NULL, 126347),
(126348, '3.20.20.70-FF-000098', NULL, 'Bifunctional 3-deoxy-7-phosphoheptulonate synthase/chorismate mutase', 264, NULL, NULL, 126348),
(126349, '2.60.40.150-FF-000080', NULL, 'Putative synaptotagmin-12', 143, NULL, NULL, 126349),
(126350, '3.30.420.40-FF-000765', NULL, 'Uncharacterized protein', 136, NULL, NULL, 126350),
(126351, '2.40.50.1000-FF-000011', NULL, '30S ribosomal protein S17', 113, NULL, NULL, 126351),
(126352, '1.25.40.10-FF-004538', NULL, 'Uncharacterized protein', 57, NULL, NULL, 126352),
(126353, '1.25.40.10-FF-005044', NULL, 'Tetratricopeptide repeat protein 21B', 124, NULL, NULL, 126353),
(126354, '1.10.287.110-FF-000021', NULL, 'DnaJ (Hsp40) homolog, subfamily B, member 2', 114, NULL, NULL, 126354),
(126355, '3.40.190.10-FF-000943', NULL, 'Uncharacterized protein', 23, NULL, NULL, 126355),
(126356, '2.130.10.30-FF-000144', NULL, NULL, 112, NULL, NULL, 126356),
(126357, '1.25.10.10-FF-003081', NULL, 'Pumilio/PUF RNA binding protein 8, putative', 239, NULL, NULL, 126357),
(126358, '3.30.200.20-FF-000113', NULL, 'Putative tyrosine-protein kinase receptor Tie-1', 103, NULL, NULL, 126358),
(126359, '3.30.559.10-FF-000162', NULL, 'Enniatin synthetase', 178, NULL, NULL, 126359),
(126360, '3.30.230.70-FF-000006', NULL, 'polyribonucleotide nucleotidyltransferase 1, mitochondrial', 230, NULL, NULL, 126360); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(126361, '3.40.50.2300-FF-001384', NULL, NULL, 83, NULL, NULL, 126361),
(126362, '4.10.60.10-FF-000013', NULL, 'Zinc finger CCHC domain-containing protein 9', 26, NULL, NULL, 126362),
(126363, '3.40.1190.20-FF-000029', NULL, 'Ribokinase', 310, NULL, NULL, 126363),
(126364, '2.10.230.10-FF-000031', NULL, 'Putative dnaJ chaperone family protein', 41, NULL, NULL, 126364),
(126365, '2.30.30.40-FF-000322', NULL, 'Myosin I', 58, NULL, NULL, 126365),
(126366, '3.40.630.30-FF-000293', NULL, 'Acetyltransferase, GNAT family', 104, NULL, NULL, 126366),
(126367, '2.10.25.10-FF-001156', NULL, 'Uncharacterized protein', 42, NULL, NULL, 126367),
(126368, '3.30.70.1430-FF-000001', NULL, 'Efflux pump membrane transporter', 105, NULL, NULL, 126368),
(126369, '3.10.430.100-FF-000019', NULL, '50S ribosomal protein L9', 89, NULL, NULL, 126369),
(126370, '3.40.367.20-FF-000019', NULL, 'Glucokinase', 228, NULL, NULL, 126370),
(126371, '3.80.10.10-FF-000976', NULL, 'Adhesion G protein-coupled receptor A2', 121, NULL, NULL, 126371),
(126372, '1.10.150.50-FF-000158', NULL, 'Leucine-rich repeat and sterile alpha motif-containing 1', 68, NULL, NULL, 126372),
(126373, '2.60.40.60-FF-000355', NULL, 'Cadherin 16, KSP-cadherin', 111, NULL, NULL, 126373),
(126374, '1.20.5.520-FF-000008', NULL, 'thymosin beta-12', 27, NULL, NULL, 126374),
(126375, '3.30.1120.30-FF-000053', NULL, 'CAMK family protein kinase', 115, NULL, NULL, 126375),
(126376, '1.20.1070.10-FF-000193', NULL, 'Mas-related G-protein coupled receptor member E', 273, NULL, NULL, 126376),
(126377, '1.10.132.70-FF-000004', NULL, 'Telomerase reverse transcriptase', 275, NULL, NULL, 126377),
(126378, '3.30.70.330-FF-000463', NULL, 'Nuclear acid binding', 94, NULL, NULL, 126378),
(126379, '3.40.30.10-FF-000203', NULL, 'Protein disulfide isomerase family A member 2', 128, NULL, NULL, 126379),
(126380, '1.25.40.10-FF-002610', NULL, 'Putative pentatricopeptide repeat-containing protein At2g01510', 99, NULL, NULL, 126380),
(126381, '2.40.50.1020-FF-000017', NULL, 'Two-component system response regulator', 115, NULL, NULL, 126381),
(126382, '3.40.50.300-FF-003718', NULL, 'Cystic Fibrosis Transmembrane conductance regulator homolog', 267, NULL, NULL, 126382),
(126383, '2.60.120.200-FF-000008', NULL, 'Collagen type XII alpha 1 chain', 228, NULL, NULL, 126383),
(126384, '2.60.40.1840-FF-000005', NULL, 'Membrane alanine aminopeptidase', 87, NULL, NULL, 126384),
(126385, '1.20.1070.10-FF-000676', NULL, 'Predicted protein', 282, NULL, NULL, 126385),
(126386, '2.130.10.10-FF-005568', NULL, 'Predicted protein', 213, NULL, NULL, 126386),
(126387, '3.30.360.20-FF-000006', NULL, '18S rRNA biogenesis protein RCL1', 96, NULL, NULL, 126387),
(126388, '3.40.50.2000-FF-000086', NULL, 'Glycosyltransferase', 197, NULL, NULL, 126388),
(126389, '1.20.5.110-FF-000094', NULL, 'SNARE protein', 62, NULL, NULL, 126389),
(126390, '3.20.20.80-FF-000747', NULL, 'Uncharacterized protein', 71, NULL, NULL, 126390),
(126391, '1.25.10.10-FF-002092', NULL, 'Uncharacterized protein', 620, NULL, NULL, 126391),
(126392, '3.30.230.10-FF-000404', NULL, 'Elongation factor G, domain IV family protein', 145, NULL, NULL, 126392),
(126393, '1.10.150.20-FF-000306', NULL, 'DNA polymerase eta', 61, NULL, NULL, 126393),
(126394, '2.60.120.330-FF-000227', NULL, 'Uncharacterized protein', 159, NULL, NULL, 126394),
(126395, '3.30.200.20-FF-000905', NULL, 'Death associated protein kinase', 84, NULL, NULL, 126395),
(126396, '3.40.250.10-FF-000122', NULL, 'Uncharacterized protein', 102, NULL, NULL, 126396),
(126397, '3.40.50.720-FF-000854', NULL, 'Malic enzyme', 216, NULL, NULL, 126397),
(126398, '2.60.120.430-FF-000009', NULL, 'Receptor like protein 4', 154, NULL, NULL, 126398),
(126399, '3.40.449.10-FF-000016', NULL, 'Uncharacterized protein', 216, NULL, NULL, 126399),
(126400, '3.30.30.30-FF-000030', NULL, 'Chaperone protein DNAK, putative', 56, NULL, NULL, 126400),
(126401, '1.10.8.1220-FF-000028', NULL, NULL, 87, NULL, NULL, 126401),
(126402, '4.10.1000.40-FF-000006', NULL, 'Zinc finger CCCH domain-containing protein 14', 51, NULL, NULL, 126402);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(126403, '3.50.50.60-FF-000455', NULL, 'Prenylcysteine lyase, putative', 107, NULL, NULL, 126403),
(126404, '3.30.930.10-FF-000188', NULL, 'Phenylalanine--tRNA ligase beta subunit', 196, NULL, NULL, 126404),
(126405, '1.25.10.10-FF-001164', NULL, 'Uncharacterized protein', 1016, NULL, NULL, 126405),
(126406, '3.40.50.300-FF-008199', NULL, 'Transitional endoplasmic reticulum ATPase', 74, NULL, NULL, 126406),
(126407, '3.90.180.10-FF-000111', NULL, 'Putative NADP-dependent alcohol dehydrogenase', 125, NULL, NULL, 126407),
(126408, '3.40.390.10-FF-000262', NULL, NULL, 181, NULL, NULL, 126408),
(126409, '2.130.10.10-FF-005129', NULL, 'Uncharacterized protein', 197, NULL, NULL, 126409),
(126410, '3.30.160.60-FF-000722', NULL, 'zinc finger protein 346 isoform X1', 57, NULL, NULL, 126410),
(126411, '2.170.240.10-FF-000005', NULL, 'Uncharacterized protein', 222, NULL, NULL, 126411),
(126412, '2.30.30.40-FF-000485', NULL, 'Peripheral-type benzodiazepine receptor-associated protein 1', 65, NULL, NULL, 126412),
(126413, '2.130.10.10-FF-002033', NULL, 'Predicted protein', 236, NULL, NULL, 126413),
(126414, '1.10.418.10-FF-000105', NULL, 'Microtubule End Binding Protein', 133, NULL, NULL, 126414),
(126415, '2.10.110.10-FF-000084', NULL, 'transforming growth factor beta-1-induced transcript 1 protein', 58, NULL, NULL, 126415),
(126416, '3.30.70.330-FF-001289', NULL, 'Peptidyl-prolyl cis-trans isomerase', 150, NULL, NULL, 126416),
(126417, '3.10.20.540-FF-000003', NULL, 'Replicase polyprotein 1ab', 56, NULL, NULL, 126417),
(126418, '1.25.40.10-FF-001784', NULL, 'Pentatricopeptide repeat-containing protein At2g22070', 108, NULL, NULL, 126418),
(126419, '3.30.505.10-FF-000127', NULL, 'Signal transducer and activator of transcription 1', 116, NULL, NULL, 126419),
(126420, '2.130.10.10-FF-002858', NULL, 'PRP19-like protein, putative', 314, NULL, NULL, 126420),
(126421, '3.60.10.10-FF-000286', NULL, 'Uncharacterized protein', 360, NULL, NULL, 126421),
(126422, '3.40.718.10-FF-000018', NULL, 'Isocitrate dehydrogenase [NADP]', 406, NULL, NULL, 126422),
(126423, '3.90.550.10-FF-000331', NULL, 'Uncharacterized protein', 250, NULL, NULL, 126423),
(126424, '1.10.287.130-FF-000027', NULL, 'Sensor histidine kinase KdpD', 73, NULL, NULL, 126424),
(126425, '1.20.1070.10-FF-001165', NULL, 'Tachykinin-like peptides receptor 99D', 341, NULL, NULL, 126425),
(126426, '1.10.510.10-FF-003355', NULL, NULL, 304, NULL, NULL, 126426),
(126427, '1.10.510.10-FF-001877', NULL, 'Uncharacterized protein', 169, NULL, NULL, 126427),
(126428, '1.20.5.780-FF-000007', NULL, 'FXYD domain-containing ion transport regulator', 67, NULL, NULL, 126428),
(126429, '1.10.565.10-FF-000166', NULL, 'Uncharacterized protein', 196, NULL, NULL, 126429),
(126430, '3.40.50.1820-FF-001650', NULL, 'Triacylglycerol lipase', 249, NULL, NULL, 126430),
(126431, '1.10.510.10-FF-002866', NULL, NULL, 192, NULL, NULL, 126431),
(126432, '1.10.8.50-FF-000028', NULL, 'Type 2 DNA topoisomerase 6 subunit B', 84, NULL, NULL, 126432),
(126433, '3.40.50.300-FF-003848', NULL, 'Pleiotropic drug resistance 12 isoform 3', 188, NULL, NULL, 126433),
(126434, '3.30.70.1230-FF-000222', NULL, 'Uncharacterized protein', 57, NULL, NULL, 126434),
(126435, '3.40.850.10-FF-000281', NULL, 'Kinesin motor subunit-like protein', 424, NULL, NULL, 126435),
(126436, '1.25.40.20-FF-001641', NULL, 'Kinase, NEK', 93, NULL, NULL, 126436),
(126437, '1.20.120.1760-FF-000009', NULL, 'Phosphatidylcholine synthase', 170, NULL, NULL, 126437),
(126438, '3.30.300.10-FF-000011', NULL, 'S-adenosylmethionine synthase', 23, NULL, NULL, 126438),
(126439, '3.40.50.300-FF-001920', NULL, 'RAB5B, member RAS oncogene family', 69, NULL, NULL, 126439),
(126440, '3.30.70.330-FF-001761', NULL, NULL, 79, NULL, NULL, 126440),
(126441, '2.10.90.10-FF-000065', NULL, 'Brain-derived neurotrophic factor', 85, NULL, NULL, 126441),
(126442, '1.10.510.10-FF-004002', NULL, NULL, 322, NULL, NULL, 126442),
(126443, '3.40.50.300-FF-005282', NULL, 'AAA family ATPase', 177, NULL, NULL, 126443),
(126444, '3.40.50.2300-FF-000086', NULL, 'Two-component system response regulator ChvI', 80, NULL, NULL, 126444);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(126445, '3.40.250.10-FF-000089', NULL, 'DOA4p Ubiquitin hydrolase', 147, NULL, NULL, 126445),
(126446, '1.20.1070.10-FF-000985', NULL, 'Uncharacterized protein', 306, NULL, NULL, 126446),
(126447, '1.10.533.10-FF-000165', NULL, 'Ankyrin', 96, NULL, NULL, 126447),
(126448, '3.40.50.12280-FF-000004', NULL, 'NADH-quinone oxidoreductase subunit B', 171, NULL, NULL, 126448),
(126449, '3.40.50.620-FF-000633', NULL, 'Cysteine--tRNA ligase', 345, NULL, NULL, 126449),
(126450, '1.10.10.60-FF-001066', NULL, NULL, 88, NULL, NULL, 126450),
(126451, '1.10.10.1740-FF-000004', NULL, 'YJR085C-like protein', 102, NULL, NULL, 126451),
(126452, '2.80.10.50-FF-000035', NULL, 'Mannose receptor C type 2', 134, NULL, NULL, 126452),
(126453, '1.20.120.330-FF-000012', NULL, 'SPI-1 type III secretion system needle tip complex protein SipB', 158, NULL, NULL, 126453),
(126454, '3.30.160.60-FF-002959', NULL, NULL, 28, NULL, NULL, 126454),
(126455, '2.130.10.10-FF-005259', NULL, 'Uncharacterized protein', 269, NULL, NULL, 126455),
(126456, '3.60.10.10-FF-000347', NULL, 'Uncharacterized protein', 179, NULL, NULL, 126456),
(126457, '3.40.50.150-FF-001869', NULL, NULL, 112, NULL, NULL, 126457),
(126458, '3.30.160.60-FF-003595', NULL, NULL, 30, NULL, NULL, 126458),
(126459, '2.30.29.30-FF-000248', NULL, 'TBC1 domain family member 2A isoform X1', 100, NULL, NULL, 126459),
(126460, '3.20.20.70-FF-000435', NULL, NULL, 101, NULL, NULL, 126460),
(126461, '3.80.10.10-FF-003882', NULL, 'Leucine-rich repeat-containing 32', 161, NULL, NULL, 126461),
(126462, '3.80.10.10-FF-000537', NULL, 'F-box domain containing protein', 255, NULL, NULL, 126462),
(126463, '2.130.10.10-FF-000897', NULL, 'Katanin p80 WD40 repeat-containing subunit B1 homolog', 101, NULL, NULL, 126463),
(126464, '2.130.10.10-FF-003022', NULL, 'Uncharacterized protein', 165, NULL, NULL, 126464),
(126465, '1.20.1110.10-FF-000264', NULL, NULL, 78, NULL, NULL, 126465),
(126466, '3.20.20.190-FF-000036', NULL, 'Glycerophosphodiester phosphodiesterase, cytosolic', 235, NULL, NULL, 126466),
(126467, '1.20.58.760-FF-000029', NULL, 'ATP-dependent zinc metalloprotease FtsH', 202, NULL, NULL, 126467),
(126468, '3.90.640.10-FF-000130', NULL, 'Actin-related protein 3, putative arp3', 101, NULL, NULL, 126468),
(126469, '3.30.160.20-FF-000025', NULL, 'APOBEC1 complementation factor isoform X1', 75, NULL, NULL, 126469),
(126470, '3.40.50.150-FF-001414', NULL, NULL, 159, NULL, NULL, 126470),
(126471, '1.10.10.60-FF-000886', NULL, NULL, 59, NULL, NULL, 126471),
(126472, '3.30.450.70-FF-000017', NULL, 'Sybindin-like family protein', 134, NULL, NULL, 126472),
(126473, '3.40.50.10810-FF-000030', NULL, 'ATP-dependent DNA helicase DDM1', 245, NULL, NULL, 126473),
(126474, '3.40.50.300-FF-004337', NULL, 'Septum site-determining protein MinD', 251, NULL, NULL, 126474),
(126475, '2.170.150.80-FF-000007', NULL, 'NAC domain-containing protein 35', 145, NULL, NULL, 126475),
(126476, '3.40.50.300-FF-002100', NULL, 'DEAD/DEAH box helicase, putative', 223, NULL, NULL, 126476),
(126477, '3.30.720.50-FF-000004', NULL, 'Probable E3 ubiquitin-protein ligase DTX2', 69, NULL, NULL, 126477),
(126478, '3.40.50.300-FF-007682', NULL, 'ATPase family AAA domaincontaining protein 5-like, putative', 113, NULL, NULL, 126478),
(126479, '1.20.940.10-FF-000024', NULL, 'Expressed protein', 101, NULL, NULL, 126479),
(126480, '2.60.40.10-FF-005135', NULL, NULL, 122, NULL, NULL, 126480),
(126481, '1.10.10.10-FF-000495', NULL, 'RecQ family helicase MusN', 114, NULL, NULL, 126481),
(126482, '3.40.1380.10-FF-000002', NULL, 'ATP synthase gamma chain', 217, NULL, NULL, 126482),
(126483, '3.30.450.50-FF-000011', NULL, 'Vesicle-associated membrane protein 714', 124, NULL, NULL, 126483),
(126484, '2.10.50.10-FF-000152', NULL, 'Predicted protein', 62, NULL, NULL, 126484),
(126485, '3.30.230.90-FF-000001', NULL, 'Proteasome chaperone 3', 179, NULL, NULL, 126485),
(126486, '3.40.50.300-FF-004837', NULL, 'Type II/IV secretion system ATPase TadZ/CpaE, associated with Flp pilus assembly', 241, NULL, NULL, 126486),
(126487, '3.40.50.300-FF-005635', NULL, 'Uncharacterized protein', 215, NULL, NULL, 126487);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(126488, '1.10.420.10-FF-000021', NULL, 'Peroxidase', 39, NULL, NULL, 126488),
(126489, '3.20.110.10-FF-000010', NULL, 'Alpha-mannosidase', 364, NULL, NULL, 126489),
(126490, '3.30.565.10-FF-000120', NULL, 'Pkp2p', 202, NULL, NULL, 126490),
(126491, '3.40.50.450-FF-000088', NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase', 187, NULL, NULL, 126491),
(126492, '3.90.79.10-FF-000072', NULL, 'Nucleoside diphosphate-linked moiety X motif 19', 250, NULL, NULL, 126492),
(126493, '3.30.750.24-FF-000030', NULL, 'STAS domain protein', 109, NULL, NULL, 126493),
(126494, '1.10.510.10-FF-000921', NULL, 'Serine/threonine-protein kinase STE7', 215, NULL, NULL, 126494),
(126495, '1.25.10.10-FF-002120', NULL, 'Cell division control protein 7', 261, NULL, NULL, 126495),
(126496, '2.60.120.780-FF-000002', NULL, 'E3 SUMO-protein ligase PIAS4', 149, NULL, NULL, 126496),
(126497, '3.30.200.20-FF-000568', NULL, 'Putative serine threonine-protein kinase', 44, NULL, NULL, 126497),
(126498, '3.30.1330.30-FF-000075', NULL, 'H/ACA ribonucleoprotein complex subunit 2 family protein', 130, NULL, NULL, 126498),
(126499, '1.10.840.10-FF-000013', NULL, 'Kinase non-catalytic C-lobe domain-containing 1', 258, NULL, NULL, 126499),
(126500, '3.80.10.10-FF-000184', NULL, 'leucine-rich repeat-containing protein 24', 119, NULL, NULL, 126500),
(126501, '1.10.225.10-FF-000028', NULL, 'Ecdysone dependent glycoprotein', 106, NULL, NULL, 126501),
(126502, '3.20.20.70-FF-000418', NULL, 'Glycerol uptake operon antiterminator-related protein', 176, NULL, NULL, 126502),
(126503, '2.60.40.10-FF-001762', NULL, 'Basement membrane proteoglycan', 106, NULL, NULL, 126503),
(126504, '3.40.50.2300-FF-001367', NULL, NULL, 138, NULL, NULL, 126504),
(126505, '3.30.160.60-FF-004084', NULL, NULL, 40, NULL, NULL, 126505),
(126506, '3.40.50.1820-FF-000161', NULL, 'Epoxide hydrolase', 318, NULL, NULL, 126506),
(126507, '3.30.559.30-FF-000038', NULL, 'Probable non-ribosomal peptide synthetase', 246, NULL, NULL, 126507),
(126508, '2.60.40.420-FF-000065', NULL, 'Fibrocystin-L', 99, NULL, NULL, 126508),
(126509, '3.40.50.1100-FF-000136', NULL, 'L-threonine dehydratase catabolic TdcB', 198, NULL, NULL, 126509),
(126510, '3.40.50.410-FF-000233', NULL, 'Uncharacterized protein', 192, NULL, NULL, 126510),
(126511, '3.30.430.20-FF-000052', NULL, 'Uncharacterized protein', 111, NULL, NULL, 126511),
(126512, '3.40.50.150-FF-000588', NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', 339, NULL, NULL, 126512),
(126513, '3.50.50.60-FF-000808', NULL, 'FAD-dependent oxidoreductase domain-containing protein 2-like', 223, NULL, NULL, 126513),
(126514, '3.80.10.10-FF-000667', NULL, 'Leucine-rich repeat family protein', 141, NULL, NULL, 126514),
(126515, '3.90.190.10-FF-000168', NULL, 'Protein tyrosine phosphatase', 249, NULL, NULL, 126515),
(126516, '3.30.160.60-FF-000352', NULL, 'zinc finger protein 3 homolog', 30, NULL, NULL, 126516),
(126517, '1.10.220.150-FF-000045', NULL, 'Ultradian oscillation regulator, putative', 135, NULL, NULL, 126517),
(126518, '3.40.30.10-FF-000220', NULL, 'Selenoprotein V', 85, NULL, NULL, 126518),
(126519, '3.30.310.10-FF-000068', NULL, 'Uncharacterized protein', 112, NULL, NULL, 126519),
(126520, '3.40.50.300-FF-004354', NULL, 'Bacitracin ABC transporter ATP-binding protein', 236, NULL, NULL, 126520),
(126521, '3.10.20.90-FF-000615', NULL, 'Probable ubiquitin carboxyl-terminal hydrolase 5', 93, NULL, NULL, 126521),
(126522, '3.40.50.300-FF-005782', NULL, 'Probable serine/threonine-protein kinase pats1', 94, NULL, NULL, 126522),
(126523, '1.10.472.80-FF-000263', NULL, NULL, 182, NULL, NULL, 126523),
(126524, '2.60.120.970-FF-000071', NULL, 'Bone morphogenetic protein 7', 178, NULL, NULL, 126524),
(126525, '3.30.450.20-FF-000244', NULL, 'Sensor histidine kinase', 177, NULL, NULL, 126525),
(126526, '1.20.1600.10-FF-000037', NULL, 'Outer membrane efflux protein', 425, NULL, NULL, 126526),
(126527, '2.40.50.140-FF-000667', NULL, NULL, 55, NULL, NULL, 126527),
(126528, '3.40.630.30-FF-000646', NULL, 'Uncharacterized N-acetyltransferase C9.02c', 164, NULL, NULL, 126528); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(126529, '3.40.50.1820-FF-001779', NULL, 'Predicted protein', 180, NULL, NULL, 126529),
(126530, '4.10.1000.10-FF-000143', NULL, 'Uncharacterized protein', 57, NULL, NULL, 126530),
(126531, '3.90.180.10-FF-000083', NULL, 'Zinc-binding dehydrogenase-like protein', 199, NULL, NULL, 126531),
(126532, '3.10.20.30-FF-000042', NULL, 'Ferredoxin', 102, NULL, NULL, 126532),
(126533, '3.40.50.11980-FF-000009', NULL, 'Antiporter/ drug transporter', 72, NULL, NULL, 126533),
(126534, '2.60.40.1180-FF-000217', NULL, 'Glycogen isoamylase GlgX', 112, NULL, NULL, 126534),
(126535, '2.70.130.10-FF-000026', NULL, 'cation-independent mannose-6-phosphate receptor isoform X2', 151, NULL, NULL, 126535),
(126536, '2.60.60.20-FF-000013', NULL, 'lipoxygenase homology domain-containing protein 1', 124, NULL, NULL, 126536),
(126537, '3.40.190.290-FF-000002', NULL, 'HTH-type transcriptional regulator ArgP', 220, NULL, NULL, 126537),
(126538, '1.20.58.390-FF-000031', NULL, 'Cholinergic receptor nicotinic beta 1 subunit', 133, NULL, NULL, 126538),
(126539, '1.10.150.20-FF-000295', NULL, 'DNA polymerase I family protein', 130, NULL, NULL, 126539),
(126540, '1.10.1420.10-FF-000200', NULL, 'MutS homolog 6', 93, NULL, NULL, 126540),
(126541, '3.30.450.40-FF-000121', NULL, 'Serine/threonine protein phosphatase', 205, NULL, NULL, 126541),
(126542, '2.60.40.10-FF-003027', NULL, 'Granulocyte-macrophage colony-stimulating factor receptor subunit alpha', 101, NULL, NULL, 126542),
(126543, '3.90.70.10-FF-000344', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 117, NULL, NULL, 126543),
(126544, '1.10.510.10-FF-001540', NULL, 'CAMK family protein kinase', 195, NULL, NULL, 126544),
(126545, '3.30.300.30-FF-000017', NULL, 'Acyl-CoA synthetase short-chain family member 3', 131, NULL, NULL, 126545),
(126546, '2.60.120.260-FF-000419', NULL, 'Hect domain and RLD 2-like protein', 132, NULL, NULL, 126546),
(126547, '3.90.25.10-FF-000037', NULL, 'NAD-dependent epimerase/dehydratase', 103, NULL, NULL, 126547),
(126548, '1.20.5.220-FF-000008', NULL, 'Exosome complex exonuclease RRP6', 20, NULL, NULL, 126548),
(126549, '2.130.10.10-FF-004303', NULL, 'Predicted protein', 116, NULL, NULL, 126549),
(126550, '3.20.20.100-FF-000212', NULL, 'Uncharacterized protein', 104, NULL, NULL, 126550),
(126551, '3.40.50.2300-FF-000895', NULL, NULL, 147, NULL, NULL, 126551),
(126552, '1.10.510.10-FF-001568', NULL, 'uncharacterized protein LOC106771884 isoform X8', 264, NULL, NULL, 126552),
(126553, '2.130.10.10-FF-000116', NULL, 'DDB1- and CUL4-associated factor 10', 169, NULL, NULL, 126553),
(126554, '2.130.10.10-FF-005731', NULL, 'Uncharacterized protein', 133, NULL, NULL, 126554),
(126555, '3.40.50.10420-FF-000019', NULL, '5-formyltetrahydrofolate cyclo-ligase', 187, NULL, NULL, 126555),
(126556, '3.30.40.10-FF-000581', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 116, NULL, NULL, 126556),
(126557, '3.30.830.10-FF-000124', NULL, 'Mitochondrial processing peptidase alpha subunit, putative', 179, NULL, NULL, 126557),
(126558, '3.90.1380.10-FF-000007', NULL, 'Predicted protein', 64, NULL, NULL, 126558),
(126559, '1.25.10.10-FF-003401', NULL, 'Uncharacterized protein', 114, NULL, NULL, 126559),
(126560, '1.10.530.10-FF-000012', NULL, 'Endochitinase EP3', 142, NULL, NULL, 126560),
(126561, '3.30.1150.10-FF-000015', NULL, 'Protein TonB', 91, NULL, NULL, 126561),
(126562, '2.130.10.10-FF-002403', NULL, 'U3 small nucleolar RNA-associated protein 4 homolog isoform 1', 145, NULL, NULL, 126562),
(126563, '3.30.40.10-FF-000446', NULL, 'Autoimmune regulator', 65, NULL, NULL, 126563),
(126564, '2.40.10.10-FF-000255', NULL, 'Uncharacterized protein', 174, NULL, NULL, 126564),
(126565, '1.10.8.10-FF-000292', NULL, 'Ubiquitinyl hydrolase 1', 64, NULL, NULL, 126565),
(126566, '2.130.10.10-FF-001886', NULL, 'Transducin beta protein 3', 172, NULL, NULL, 126566),
(126567, '2.60.40.10-FF-004516', NULL, NULL, 94, NULL, NULL, 126567),
(126568, '3.30.1640.10-FF-000070', NULL, 'DNA helicase', 100, NULL, NULL, 126568),
(126569, '3.40.50.300-FF-003409', NULL, 'Dynein heavy chain', 174, NULL, NULL, 126569);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(126570, '2.60.120.920-FF-000179', NULL, 'Si:dkeyp-123a12.2', 50, NULL, NULL, 126570),
(126571, '2.60.40.10-FF-002201', NULL, 'sialoadhesin isoform X1', 95, NULL, NULL, 126571),
(126572, '3.40.50.720-FF-000793', NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', 149, NULL, NULL, 126572),
(126573, '2.30.29.30-FF-000720', NULL, 'UNC-34', 118, NULL, NULL, 126573),
(126574, '3.40.50.1820-FF-000498', NULL, 'AGAP010390-PA', 577, NULL, NULL, 126574),
(126575, '3.30.710.10-FF-000514', NULL, 'Protein CBG12958', 75, NULL, NULL, 126575),
(126576, '1.10.238.10-FF-000024', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 91, NULL, NULL, 126576),
(126577, '2.60.40.10-FF-005944', NULL, NULL, 96, NULL, NULL, 126577),
(126578, '3.40.50.980-FF-000011', NULL, 'Long-chain-fatty-acid--CoA ligase FadD1', 150, NULL, NULL, 126578),
(126579, '3.80.10.10-FF-003101', NULL, 'Protein CBG03663', 112, NULL, NULL, 126579),
(126580, '3.30.9.90-FF-000010', NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase, putative', 31, NULL, NULL, 126580),
(126581, '2.30.30.140-FF-000059', NULL, 'Histone-lysine N-methyltransferase', 118, NULL, NULL, 126581),
(126582, '1.20.1250.20-FF-000440', NULL, 'Peptide transporter PTR2', 499, NULL, NULL, 126582),
(126583, '1.20.5.170-FF-000049', NULL, 'X-box binding protein 1', 55, NULL, NULL, 126583),
(126584, '1.20.1270.60-FF-000195', NULL, 'Age1p', 201, NULL, NULL, 126584),
(126585, '1.20.5.190-FF-000044', NULL, 'Neuromodulin isoform 1', 72, NULL, NULL, 126585),
(126586, '3.30.70.20-FF-000086', NULL, NULL, 77, NULL, NULL, 126586),
(126587, '1.10.10.10-FF-000023', NULL, 'Two-component response regulator OmpR', 110, NULL, NULL, 126587),
(126588, '1.10.238.10-FF-001305', NULL, 'Uncharacterized protein', 55, NULL, NULL, 126588),
(126589, '1.10.510.10-FF-003485', NULL, NULL, 264, NULL, NULL, 126589),
(126590, '3.30.710.10-FF-000205', NULL, 'Eor-1', 120, NULL, NULL, 126590),
(126591, '3.30.830.10-FF-000141', NULL, 'Catalytic/ metal ion binding / metalloendopeptidase/ zinc ion binding protein', 159, NULL, NULL, 126591),
(126592, '1.10.357.140-FF-000018', NULL, 'Protoheme IX farnesyltransferase', 148, NULL, NULL, 126592),
(126593, '1.10.510.10-FF-002849', NULL, 'Protein kinase, putative', 263, NULL, NULL, 126593),
(126594, '1.20.1050.130-FF-000016', NULL, 'Glutathione S-transferase 1', 217, NULL, NULL, 126594),
(126595, '2.130.10.10-FF-005276', NULL, 'WD40-repeat protein', 242, NULL, NULL, 126595),
(126596, '3.20.20.140-FF-000084', NULL, 'Peptidase M38', 306, NULL, NULL, 126596),
(126597, '3.30.160.60-FF-004876', NULL, NULL, 43, NULL, NULL, 126597),
(126598, '1.20.58.60-FF-000383', NULL, 'Spectrin beta chain, non-erythrocytic', 303, NULL, NULL, 126598),
(126599, '2.30.29.30-FF-001237', NULL, 'Phosphoinositide phospholipase C', 113, NULL, NULL, 126599),
(126600, '1.10.510.10-FF-004283', NULL, NULL, 170, NULL, NULL, 126600),
(126601, '2.130.10.30-FF-000127', NULL, NULL, 137, NULL, NULL, 126601),
(126602, '3.30.420.40-FF-000310', NULL, 'Chromosome 19, whole genome shotgun sequence', 108, NULL, NULL, 126602),
(126603, '3.40.50.10420-FF-000036', NULL, '5-formyltetrahydrofolate cyclo-ligase', 187, NULL, NULL, 126603),
(126604, '1.10.10.60-FF-001083', NULL, NULL, 85, NULL, NULL, 126604),
(126605, '1.10.579.10-FF-000006', NULL, 'Cryptochrome DASH', 133, NULL, NULL, 126605),
(126606, '1.20.1560.10-FF-000084', NULL, 'Multidrug resistance-associated protein ABC domain protein', 319, NULL, NULL, 126606),
(126607, '1.10.10.60-FF-000105', NULL, 'Zinc finger E-box binding homeobox 2', 68, NULL, NULL, 126607),
(126608, '1.20.1250.20-FF-002368', NULL, 'Synaptic vesicle glycoprotein 2B-like Protein', 321, NULL, NULL, 126608),
(126609, '1.10.290.10-FF-000004', NULL, 'DNA topoisomerase 3', 128, NULL, NULL, 126609),
(126610, '1.25.10.10-FF-000175', NULL, 'lisH domain and HEAT repeat-containing protein KIAA1468 homolog', 256, NULL, NULL, 126610),
(126611, '1.10.8.10-FF-000275', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 42, NULL, NULL, 126611),
(126612, '3.40.50.720-FF-001973', NULL, 'Uncharacterized protein', 252, NULL, NULL, 126612); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(126613, '3.40.50.300-FF-001583', NULL, 'RAB42, member RAS oncogene family', 180, NULL, NULL, 126613),
(126614, '3.50.50.60-FF-001427', NULL, 'Uncharacterized protein', 117, NULL, NULL, 126614),
(126615, '1.10.8.60-FF-000357', NULL, 'AAA ATPase central domain protein', 69, NULL, NULL, 126615),
(126616, '1.10.510.10-FF-001438', NULL, 'CMGC family protein kinase', 232, NULL, NULL, 126616),
(126617, '3.90.320.10-FF-000055', NULL, 'Uncharacterized protein', 167, NULL, NULL, 126617),
(126618, '3.40.50.150-FF-000560', NULL, 'Mitochondrial N(5)-glutamine methyltransferase MTQ1, putative', 252, NULL, NULL, 126618),
(126619, '1.10.510.10-FF-000949', NULL, 'Serine/threonine-protein kinase PTK1/STK1', 349, NULL, NULL, 126619),
(126620, '1.10.472.10-FF-000023', NULL, 'Transcription initiation factor IIB', 91, NULL, NULL, 126620),
(126621, '1.10.10.10-FF-001776', NULL, 'Selenocysteine-specific translation elongation factor', 58, NULL, NULL, 126621),
(126622, '3.90.1480.20-FF-000063', NULL, 'Uncharacterized protein', 330, NULL, NULL, 126622),
(126623, '1.10.12.10-FF-000055', NULL, 'Uncharacterized protein', 50, NULL, NULL, 126623),
(126624, '3.40.50.720-FF-002462', NULL, 'Putative NADP-dependent alcohol dehydrogenase', 70, NULL, NULL, 126624),
(126625, '3.40.50.10810-FF-000013', NULL, 'E3 ubiquitin-protein ligase SHPRH isoform X2', 218, NULL, NULL, 126625),
(126626, '2.40.240.10-FF-000053', NULL, 'Glutaminyl-tRNA synthetase', 88, NULL, NULL, 126626),
(126627, '1.20.120.1770-FF-000001', NULL, 'Cytochrome b reductase 1', 224, NULL, NULL, 126627),
(126628, '1.10.510.10-FF-003794', NULL, NULL, 126, NULL, NULL, 126628),
(126629, '1.25.10.10-FF-003429', NULL, 'Splicing factor subunit, putative', 171, NULL, NULL, 126629),
(126630, '3.40.50.1460-FF-000108', NULL, 'Uncharacterized protein', 119, NULL, NULL, 126630),
(126631, '1.20.1560.10-FF-000393', NULL, 'ABC superfamily ATP binding cassette transporter, ABC/membrane protein', 340, NULL, NULL, 126631),
(126632, '3.40.50.1000-FF-000123', NULL, 'glycerol-3-phosphate phosphatase', 135, NULL, NULL, 126632),
(126633, '1.50.40.10-FF-000068', NULL, 'Mitochondrial brown fat uncoupling protein 1', 293, NULL, NULL, 126633),
(126634, '2.130.10.10-FF-001869', NULL, 'AGAP011163-PA-like protein', 252, NULL, NULL, 126634),
(126635, '3.40.50.300-FF-000431', NULL, 'Regulator of telomere elongation helicase 1', 210, NULL, NULL, 126635),
(126636, '2.102.10.10-FF-000067', NULL, 'Uncharacterized protein', 123, NULL, NULL, 126636),
(126637, '3.40.980.10-FF-000054', NULL, 'Uncharacterized protein', 81, NULL, NULL, 126637),
(126638, '3.40.1110.10-FF-000382', NULL, NULL, 145, NULL, NULL, 126638),
(126639, '2.60.40.1930-FF-000032', NULL, 'Complement component 4A (Rodgers blood group)', 121, NULL, NULL, 126639),
(126640, '3.30.565.10-FF-000103', NULL, 'Sensor histidine kinase/response regulator', 153, NULL, NULL, 126640),
(126641, '1.20.1250.20-FF-001749', NULL, 'Uncharacterized protein', 195, NULL, NULL, 126641),
(126642, '1.25.10.10-FF-001501', NULL, 'U3 small nucleolar RNA-associated protein 10', 213, NULL, NULL, 126642),
(126643, '2.40.30.30-FF-000032', NULL, 'Riboflavin kinase', 159, NULL, NULL, 126643),
(126644, '2.60.40.650-FF-000016', NULL, 'Oxidoreductase molybdopterin binding', 94, NULL, NULL, 126644),
(126645, '3.40.570.10-FF-000017', NULL, 'IP10440p', 212, NULL, NULL, 126645),
(126646, '1.10.510.10-FF-001129', NULL, 'Serine/threonine protein kinase', 185, NULL, NULL, 126646),
(126647, '3.40.50.1220-FF-000059', NULL, 'NAD-dependent protein deacetylase sirtuin-6 isoform X3', 41, NULL, NULL, 126647),
(126648, '3.10.20.870-FF-000001', NULL, 'Phospholipase A-2-activating protein-like', 79, NULL, NULL, 126648),
(126649, '3.30.1380.20-FF-000018', NULL, 'Unplaced genomic scaffold supercont1.170, whole genome shotgun sequence', 175, NULL, NULL, 126649),
(126650, '2.130.10.10-FF-001094', NULL, 'Regulator of (H+)-ATPase in vacuolar membrane', 242, NULL, NULL, 126650),
(126651, '1.20.58.60-FF-000692', NULL, 'Nesprin-1', 293, NULL, NULL, 126651),
(126652, '2.60.120.200-FF-000660', NULL, 'Laminin subunit alpha 5', 85, NULL, NULL, 126652);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(126653, '1.10.630.10-FF-000559', NULL, 'Predicted protein', 331, NULL, NULL, 126653),
(126654, '1.10.8.10-FF-000145', NULL, 'AAA-type ATPase family protein', 50, NULL, NULL, 126654),
(126655, '3.40.1810.10-FF-000064', NULL, NULL, 82, NULL, NULL, 126655),
(126656, '1.10.287.110-FF-000151', NULL, 'Unplaced genomic scaffold supercont2.14, whole genome shotgun sequence', 127, NULL, NULL, 126656),
(126657, '1.20.1070.10-FF-002019', NULL, 'Uncharacterized protein', 127, NULL, NULL, 126657),
(126658, '3.40.50.360-FF-000050', NULL, 'NAD(P)H-dependent oxidoreductase', 187, NULL, NULL, 126658),
(126659, '2.60.40.10-FF-001892', NULL, 'Bent, isoform H', 104, NULL, NULL, 126659),
(126660, '3.30.70.330-FF-001317', NULL, 'GM11898', 166, NULL, NULL, 126660),
(126661, '1.20.120.310-FF-000017', NULL, NULL, 118, NULL, NULL, 126661),
(126662, '2.60.200.20-FF-000144', NULL, 'Transcription factor 19-like protein', 111, NULL, NULL, 126662),
(126663, '2.60.40.630-FF-000010', NULL, 'Signal transducer and activator of transcription', 143, NULL, NULL, 126663),
(126664, '1.20.120.1810-FF-000002', NULL, 'RNA polymerase sigma factor', 107, NULL, NULL, 126664),
(126665, '3.40.1000.50-FF-000014', NULL, 'Repressor of RNA polymerase III transcription MAF1', 134, NULL, NULL, 126665),
(126666, '2.60.40.10-FF-002381', NULL, 'Muscle M-line assembly protein unc-89', 99, NULL, NULL, 126666),
(126667, '2.60.120.1560-FF-000005', NULL, 'YHR212W-A-like protein', 56, NULL, NULL, 126667),
(126668, '3.10.450.50-FF-000010', NULL, 'Ras GTPase-activating protein-binding protein', 137, NULL, NULL, 126668),
(126669, '1.10.357.100-FF-000001', NULL, 'Protein transport protein TIP20', 174, NULL, NULL, 126669),
(126670, '3.40.50.300-FF-007760', NULL, 'Protein CBR-RAB-30', 71, NULL, NULL, 126670),
(126671, '3.30.40.10-FF-001065', NULL, 'Uncharacterized protein', 69, NULL, NULL, 126671),
(126672, '1.10.287.70-FF-000290', NULL, 'TWiK family of potassium channels', 271, NULL, NULL, 126672),
(126673, '3.40.440.10-FF-000013', NULL, NULL, 45, NULL, NULL, 126673),
(126674, '3.40.50.410-FF-000216', NULL, 'von Willebrand factor', 187, NULL, NULL, 126674),
(126675, '1.25.40.10-FF-001312', NULL, 'RNA polymerase-associated protein CTR9', 139, NULL, NULL, 126675),
(126676, '3.40.50.2300-FF-000748', NULL, 'Uncharacterized protein', 166, NULL, NULL, 126676),
(126677, '3.30.479.10-FF-000009', NULL, '6-carboxy-5,6,7,8-tetrahydropterin synthase', 110, NULL, NULL, 126677),
(126678, '1.10.510.10-FF-002074', NULL, NULL, 125, NULL, NULL, 126678),
(126679, '3.90.190.10-FF-000477', NULL, 'Uncharacterized protein', 172, NULL, NULL, 126679),
(126680, '1.20.1250.20-FF-002238', NULL, 'Solute carrier family 22 member 7b, tandem duplicate 1', 118, NULL, NULL, 126680),
(126681, '1.10.510.10-FF-000612', NULL, 'Serine/threonine-protein kinase AFC2', 253, NULL, NULL, 126681),
(126682, '3.30.300.320-FF-000007', NULL, 'Uncharacterized protein', 66, NULL, NULL, 126682),
(126683, '3.40.50.150-FF-000897', NULL, 'tRNA (cytosine(38)-C(5))-methyltransferase 2', 173, NULL, NULL, 126683),
(126684, '3.40.50.150-FF-001386', NULL, NULL, 172, NULL, NULL, 126684),
(126685, '3.30.160.60-FF-005056', NULL, NULL, 80, NULL, NULL, 126685),
(126686, '3.10.450.240-FF-000015', NULL, 'Uncharacterized protein', 157, NULL, NULL, 126686),
(126687, '2.170.11.10-FF-000004', NULL, 'DNA topoisomerase I,-like', 70, NULL, NULL, 126687),
(126688, '1.10.390.10-FF-000040', NULL, 'Aminopeptidase M1', 107, NULL, NULL, 126688),
(126689, '3.40.50.300-FF-005765', NULL, 'Guanylate kinase, putative', 115, NULL, NULL, 126689),
(126690, '4.10.240.10-FF-000001', NULL, 'Fungal specific transcription factor, putative', 43, NULL, NULL, 126690),
(126691, '4.10.900.10-FF-000001', NULL, 'Cadherin 2', 95, NULL, NULL, 126691),
(126692, '1.20.1070.10-FF-001502', NULL, 'MCG116182, isoform CRA_a', 198, NULL, NULL, 126692),
(126693, '1.10.357.120-FF-000007', NULL, 'DNA-directed RNA polymerase subunit', 127, NULL, NULL, 126693),
(126694, '3.90.280.10-FF-000012', NULL, 'YLR179C-like protein', 193, NULL, NULL, 126694),
(126695, '1.10.510.10-FF-003338', NULL, NULL, 49, NULL, NULL, 126695);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(126696, '3.30.750.24-FF-000058', NULL, 'Anti-sigma factor antagonist', 117, NULL, NULL, 126696),
(126697, '3.40.50.300-FF-006254', NULL, 'Type III restriction enzyme, res subunit family protein', 165, NULL, NULL, 126697),
(126698, '2.10.70.10-FF-000165', NULL, 'Complement C1r subcomponent-like protein', 65, NULL, NULL, 126698),
(126699, '2.130.10.10-FF-004612', NULL, 'Uncharacterized protein', 201, NULL, NULL, 126699),
(126700, '2.60.40.10-FF-005635', NULL, NULL, 95, NULL, NULL, 126700),
(126701, '3.40.50.300-FF-003865', NULL, 'Dynamin-like protein B', 365, NULL, NULL, 126701),
(126702, '2.30.29.30-FF-000591', NULL, 'Ran-specific GTPase-activating protein 1', 155, NULL, NULL, 126702),
(126703, '3.40.50.720-FF-001282', NULL, 'Auxin-responsive protein', 87, NULL, NULL, 126703),
(126704, '2.130.10.10-FF-003994', NULL, 'Transducin family protein / WD-40 repeat family protein', 230, NULL, NULL, 126704),
(126705, '2.60.40.1930-FF-000015', NULL, 'Complement C5', 130, NULL, NULL, 126705),
(126706, '2.40.420.20-FF-000036', NULL, 'Hemolysin secretion protein D', 67, NULL, NULL, 126706),
(126707, '2.60.40.10-FF-000256', NULL, 'myopalladin isoform X1', 105, NULL, NULL, 126707),
(126708, '3.40.50.10890-FF-000008', NULL, 'Cleavage and polyadenylation specificity factor, putative', 157, NULL, NULL, 126708),
(126709, '2.30.30.100-FF-000075', NULL, 'Small nuclear ribonucleoprotein Sm D2', 99, NULL, NULL, 126709),
(126710, '3.90.226.10-FF-000297', NULL, 'Acetyl CoA carboxylase', 152, NULL, NULL, 126710),
(126711, '3.40.50.720-FF-000192', NULL, 'Enoyl-[acyl-carrier-protein] reductase [NADH]', 227, NULL, NULL, 126711),
(126712, '3.40.50.12710-FF-000032', NULL, 'Protein arginine methyltransferase NDUFAF7', 268, NULL, NULL, 126712),
(126713, '2.160.20.80-FF-000012', NULL, 'thylakoid lumenal protein TL20.3, chloroplastic', 133, NULL, NULL, 126713),
(126714, '3.30.300.30-FF-000034', NULL, 'Fatty-acid-CoA ligase FadD17', 103, NULL, NULL, 126714),
(126715, '1.10.390.10-FF-000068', NULL, 'Glutamyl aminopeptidase-like Protein', 197, NULL, NULL, 126715),
(126716, '2.60.40.1180-FF-000234', NULL, 'Alpha-galactosidase', 95, NULL, NULL, 126716),
(126717, '3.30.70.80-FF-000042', NULL, 'Uncharacterized protein', 67, NULL, NULL, 126717),
(126718, '1.10.10.60-FF-000369', NULL, 'Intestine specific homeobox', 80, NULL, NULL, 126718),
(126719, '3.30.740.10-FF-000033', NULL, NULL, 93, NULL, NULL, 126719),
(126720, '3.30.200.20-FF-001496', NULL, 'Predicted protein', 114, NULL, NULL, 126720),
(126721, '3.30.420.40-FF-000102', NULL, 'Putative glycerol kinase 5', 266, NULL, NULL, 126721),
(126722, '1.10.390.10-FF-000023', NULL, 'Chromosome 9 open reading frame 3', 172, NULL, NULL, 126722),
(126723, '2.120.10.30-FF-000004', NULL, 'Tripartite motif containing 2', 84, NULL, NULL, 126723),
(126724, '3.30.1360.120-FF-000109', NULL, 'Aminomethyltransferase', 41, NULL, NULL, 126724),
(126725, '1.20.120.1490-FF-000007', NULL, 'Periplasmic stress adaptor protein CpxP', 116, NULL, NULL, 126725),
(126726, '1.10.10.10-FF-001984', NULL, 'Peroxisomal membrane protein pex14', 52, NULL, NULL, 126726),
(126727, '1.20.1540.10-FF-000066', NULL, 'Uncharacterized protein', 203, NULL, NULL, 126727),
(126728, '1.10.287.130-FF-000162', NULL, 'Two component system histidine kinase', 88, NULL, NULL, 126728),
(126729, '1.50.40.10-FF-000523', NULL, 'Putative mitochondrial carrier protein', 171, NULL, NULL, 126729),
(126730, '3.30.360.50-FF-000004', NULL, 'S-adenosylmethionine decarboxylase proenzyme', 59, NULL, NULL, 126730),
(126731, '3.40.50.2020-FF-000081', NULL, 'Putative ribose-phosphate pyrophosphokinase', 15, NULL, NULL, 126731),
(126732, '3.30.230.10-FF-000376', NULL, '40S ribosomal protein S2, putative', 43, NULL, NULL, 126732),
(126733, '1.25.10.10-FF-000203', NULL, 'HEAT repeat containing 5B', 261, NULL, NULL, 126733),
(126734, '1.20.1270.60-FF-000178', NULL, 'Cell division control protein, putative', 275, NULL, NULL, 126734),
(126735, '3.30.450.20-FF-000699', NULL, 'Methyl accepting sensory transducer with Cache_2 small molecule binding domain', 174, NULL, NULL, 126735);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(126736, '3.30.870.10-FF-000115', NULL, 'Phospholipase D1', 187, NULL, NULL, 126736),
(126737, '2.10.60.10-FF-000006', NULL, 'Receptor protein serine/threonine kinase', 101, NULL, NULL, 126737),
(126738, '1.20.5.170-FF-000066', NULL, 'DNA damage-inducible transcript 3 protein', 44, NULL, NULL, 126738),
(126739, '2.60.40.1910-FF-000021', NULL, NULL, 107, NULL, NULL, 126739),
(126740, '2.60.40.10-FF-005152', NULL, NULL, 95, NULL, NULL, 126740),
(126741, '3.30.1140.32-FF-000028', NULL, 'Uncharacterized protein', 101, NULL, NULL, 126741),
(126742, '2.60.40.4060-FF-000008', NULL, 'Defense protein l(2)34Fc', 137, NULL, NULL, 126742),
(126743, '1.20.1250.20-FF-000423', NULL, 'Putative inorganic phosphate cotransporter-like Protein', 203, NULL, NULL, 126743),
(126744, '2.120.10.30-FF-000105', NULL, 'Low-density lipoprotein receptor-related protein', 341, NULL, NULL, 126744),
(126745, '3.30.450.70-FF-000034', NULL, NULL, 171, NULL, NULL, 126745),
(126746, '3.30.40.10-FF-001082', NULL, 'TRAF-type zinc finger domain-containing protein 1', 55, NULL, NULL, 126746),
(126747, '1.10.132.30-FF-000003', NULL, 'DNA-directed RNA polymerase subunit beta', 153, NULL, NULL, 126747),
(126748, '3.10.290.10-FF-000002', NULL, '40S ribosomal protein S4', 117, NULL, NULL, 126748),
(126749, '1.10.274.30-FF-000012', NULL, 'Chromatin modification-related protein EAF3', 174, NULL, NULL, 126749),
(126750, '1.20.1250.20-FF-000895', NULL, 'YDR387C-like protein', 244, NULL, NULL, 126750),
(126751, '1.20.1050.40-FF-000009', NULL, 'Uncharacterized protein', 53, NULL, NULL, 126751),
(126752, '1.20.1270.280-FF-000032', NULL, 'Predicted protein', 203, NULL, NULL, 126752),
(126753, '2.30.29.30-FF-000748', NULL, 'Rho guanine nucleotide exchange factor 25', 63, NULL, NULL, 126753),
(126754, '2.60.40.4380-FF-000003', NULL, 'Carbon storage regulator', 71, NULL, NULL, 126754),
(126755, '1.25.10.10-FF-000675', NULL, 'Phosphoinositide 3-kinase regulatory subunit 4', 158, NULL, NULL, 126755),
(126756, '3.20.20.100-FF-000184', NULL, 'Aldo-keto reductase, putative', 124, NULL, NULL, 126756),
(126757, '3.10.580.10-FF-000013', NULL, 'Arabinose 5-phosphate isomerase', 125, NULL, NULL, 126757),
(126758, '3.30.420.110-FF-000027', NULL, 'DNA mismatch repair protein', 188, NULL, NULL, 126758),
(126759, '2.40.50.840-FF-000001', NULL, 'Acetyl-CoA acetyltransferase', 70, NULL, NULL, 126759),
(126760, '2.40.50.90-FF-000118', NULL, 'Transcription factor, putative', 151, NULL, NULL, 126760),
(126761, '1.10.8.270-FF-000031', NULL, 'TBC1 domain family member 5', 125, NULL, NULL, 126761),
(126762, '2.30.29.30-FF-000692', NULL, 'Tectonin beta-propeller repeat-containing protein 1', 83, NULL, NULL, 126762),
(126763, '3.40.250.10-FF-000105', NULL, 'Rodhanase family domain containing protein', 150, NULL, NULL, 126763),
(126764, '3.30.70.330-FF-001261', NULL, 'Nucleic acid binding protein, putative', 127, NULL, NULL, 126764),
(126765, '1.25.40.10-FF-000031', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 112, NULL, NULL, 126765),
(126766, '2.10.25.10-FF-000358', NULL, 'protein HEG homolog 1 isoform X1', 38, NULL, NULL, 126766),
(126767, '2.60.40.640-FF-000131', NULL, 'Predicted protein', 198, NULL, NULL, 126767),
(126768, '3.30.230.40-FF-000008', NULL, 'Imidazoleglycerol-phosphate dehydratase', 102, NULL, NULL, 126768),
(126769, '1.10.10.2010-FF-000001', NULL, 'Nuclear valosin-containing protein-like', 74, NULL, NULL, 126769),
(126770, '1.10.840.10-FF-000030', NULL, 'SH2 domain-containing 3Cb', 315, NULL, NULL, 126770),
(126771, '3.40.850.10-FF-000207', NULL, 'Putative kinesin', 114, NULL, NULL, 126771),
(126772, '3.30.930.10-FF-000317', NULL, 'Uncharacterized protein', 210, NULL, NULL, 126772),
(126773, '1.25.40.10-FF-001121', NULL, 'Co-chaperone YbbN', 74, NULL, NULL, 126773),
(126774, '1.25.40.20-FF-000713', NULL, 'E3 ubiquitin-protein ligase KEG', 231, NULL, NULL, 126774),
(126775, '1.10.418.10-FF-000122', NULL, 'Coiled-coil domain containing 88C', 67, NULL, NULL, 126775),
(126776, '3.40.605.10-FF-000094', NULL, 'Predicted protein', 56, NULL, NULL, 126776);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(126777, '3.30.470.20-FF-000026', NULL, 'Carbamoyl-phosphate synthase large chain', 199, NULL, NULL, 126777),
(126778, '1.25.10.10-FF-001029', NULL, 'LD28549p', 260, NULL, NULL, 126778),
(126779, '3.30.200.20-FF-002013', NULL, 'Serine/threonine-protein kinase', 94, NULL, NULL, 126779),
(126780, '3.60.15.10-FF-000145', NULL, 'Predicted protein', 63, NULL, NULL, 126780),
(126781, '2.30.180.10-FF-000016', NULL, 'Stabilin 2', 137, NULL, NULL, 126781),
(126782, '1.10.287.370-FF-000003', NULL, 'Prefoldin subunit 6', 116, NULL, NULL, 126782),
(126783, '2.30.30.40-FF-000030', NULL, 'rho GTPase-activating protein 32 isoform X2', 61, NULL, NULL, 126783),
(126784, '3.30.200.20-FF-001602', NULL, 'Uncharacterized protein', 128, NULL, NULL, 126784),
(126785, '3.40.50.200-FF-000047', NULL, 'Dipeptidyl aminopeptidase', 388, NULL, NULL, 126785),
(126786, '2.60.40.10-FF-002510', NULL, 'SNF1 protein kinase subunit beta-1', 63, NULL, NULL, 126786),
(126787, '3.40.50.2000-FF-000647', NULL, 'Glycosyl transferase, family 9', 161, NULL, NULL, 126787),
(126788, '3.30.160.60-FF-000913', NULL, 'zinc finger protein 235 isoform X1', 29, NULL, NULL, 126788),
(126789, '2.60.40.10-FF-001993', NULL, 'Muscle M-line assembly protein unc-89', 101, NULL, NULL, 126789),
(126790, '2.30.42.10-FF-000559', NULL, NULL, 53, NULL, NULL, 126790),
(126791, '3.40.50.10190-FF-000259', NULL, 'Esc4p', 125, NULL, NULL, 126791),
(126792, '3.40.50.10310-FF-000003', NULL, 'Creatinine amidohydrolase', 240, NULL, NULL, 126792),
(126793, '3.40.50.1760-FF-000002', NULL, 'Glutathione synthetase', 124, NULL, NULL, 126793),
(126794, '3.30.930.10-FF-000160', NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', 231, NULL, NULL, 126794),
(126795, '3.80.10.10-FF-003382', NULL, 'Uncharacterized protein', 103, NULL, NULL, 126795),
(126796, '1.25.40.10-FF-004982', NULL, 'Tetratricopeptide repeat domain 21A', 144, NULL, NULL, 126796),
(126797, '2.60.40.60-FF-000810', NULL, 'Uncharacterized protein', 137, NULL, NULL, 126797),
(126798, '3.40.50.300-FF-002084', NULL, 'Adenylate kinase 2', 258, NULL, NULL, 126798),
(126799, '1.25.40.20-FF-000461', NULL, 'Ankyrin repeat domain-containing protein, chloroplastic', 98, NULL, NULL, 126799),
(126800, '1.20.1250.20-FF-001249', NULL, 'Sugar transporter, putative', 468, NULL, NULL, 126800),
(126801, '3.30.160.60-FF-003786', NULL, 'Transcription factor IIIA', 31, NULL, NULL, 126801),
(126802, '3.60.10.10-FF-000038', NULL, 'type IV inositol polyphosphate 5-phosphatase 3', 305, NULL, NULL, 126802),
(126803, '3.40.50.880-FF-000099', NULL, 'Para-aminobenzoate synthase PabaA', 223, NULL, NULL, 126803),
(126804, '2.10.25.10-FF-000667', NULL, 'Delta/notch like EGF repeat containing', 49, NULL, NULL, 126804),
(126805, '3.40.50.10330-FF-000009', NULL, 'NAD kinase', 98, NULL, NULL, 126805),
(126806, '3.30.70.270-FF-000304', NULL, NULL, 50, NULL, NULL, 126806),
(126807, '2.40.50.90-FF-000017', NULL, 'Ribonuclease', 161, NULL, NULL, 126807),
(126808, '2.40.20.10-FF-000109', NULL, 'Uncharacterized protein', 124, NULL, NULL, 126808),
(126809, '1.25.10.10-FF-000776', NULL, 'TORC1 subunit', 175, NULL, NULL, 126809),
(126810, '3.30.70.1230-FF-000161', NULL, 'Predicted protein', 220, NULL, NULL, 126810),
(126811, '1.10.287.70-FF-000739', NULL, 'Uncharacterized protein', 104, NULL, NULL, 126811),
(126812, '3.40.50.300-FF-002128', NULL, 'AAA family ATPase, putative', 181, NULL, NULL, 126812),
(126813, '2.60.120.10-FF-000444', NULL, 'Germin-like protein subfamily 1 member 13', 175, NULL, NULL, 126813),
(126814, '3.30.160.60-FF-005848', NULL, NULL, 21, NULL, NULL, 126814),
(126815, '1.25.40.180-FF-000178', NULL, NULL, 82, NULL, NULL, 126815),
(126816, '3.20.70.20-FF-000047', NULL, 'Uncharacterized protein', 42, NULL, NULL, 126816),
(126817, '2.20.25.80-FF-000018', NULL, NULL, 59, NULL, NULL, 126817),
(126818, '3.90.190.10-FF-000246', NULL, 'Protein CBG22522', 301, NULL, NULL, 126818),
(126819, '3.30.160.60-FF-004404', NULL, NULL, 23, NULL, NULL, 126819),
(126820, '1.25.40.20-FF-001539', NULL, 'Ankyrin repeat family protein', 129, NULL, NULL, 126820);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(126821, '2.60.120.200-FF-000525', NULL, 'Galectin', 154, NULL, NULL, 126821),
(126822, '2.130.10.10-FF-000560', NULL, 'LLGL scribble cell polarity complex component 1', 162, NULL, NULL, 126822),
(126823, '3.40.50.300-FF-004146', NULL, 'Uncharacterized protein', 184, NULL, NULL, 126823),
(126824, '3.30.200.20-FF-000776', NULL, 'Flk-1 receptor', 104, NULL, NULL, 126824),
(126825, '2.40.30.10-FF-000037', NULL, 'Sulfite reductase flavoprotein component', 103, NULL, NULL, 126825),
(126826, '3.40.50.300-FF-002437', NULL, 'ATP-dependent DNA helicase RecQ', 198, NULL, NULL, 126826),
(126827, '3.30.70.1130-FF-000001', NULL, 'Eukaryotic translation initiation factor 2 subunit 1', 123, NULL, NULL, 126827),
(126828, '1.20.1250.10-FF-000111', NULL, NULL, 183, NULL, NULL, 126828),
(126829, '3.40.1110.10-FF-000252', NULL, 'ATPase 2 plasma membrane-type', 145, NULL, NULL, 126829),
(126830, '1.25.40.20-FF-000814', NULL, 'Os09g0331600 protein', 117, NULL, NULL, 126830),
(126831, '1.20.1050.20-FF-000003', NULL, 'Signal transducer and activator of transcription', 185, NULL, NULL, 126831),
(126832, '2.120.10.30-FF-000313', NULL, 'SMP-30/gluconolactonase/LRE family protein', 283, NULL, NULL, 126832),
(126833, '3.30.40.10-FF-000929', NULL, 'GM23514', 81, NULL, NULL, 126833),
(126834, '2.30.42.40-FF-000001', NULL, 'Trafficking protein particle complex 4', 93, NULL, NULL, 126834),
(126835, '1.25.40.610-FF-000009', NULL, 'Adhesion G protein-coupled receptor L3', 120, NULL, NULL, 126835),
(126836, '3.90.1070.20-FF-000009', NULL, 'Polymerase (RNA) II (DNA directed) polypeptide B', 28, NULL, NULL, 126836),
(126837, '3.90.70.80-FF-000084', NULL, 'Uncharacterized protein', 100, NULL, NULL, 126837),
(126838, '4.10.960.10-FF-000005', NULL, '60S ribosomal protein L3', 26, NULL, NULL, 126838),
(126839, '2.130.10.10-FF-005231', NULL, 'WD-repeat protein, putative', 45, NULL, NULL, 126839),
(126840, '1.10.3500.10-FF-000038', NULL, 'Transcription elongation factor spt6', 104, NULL, NULL, 126840),
(126841, '2.60.40.1120-FF-000014', NULL, 'Carboxypeptidase M', 107, NULL, NULL, 126841),
(126842, '1.10.150.20-FF-000031', NULL, 'DNA-directed RNA polymerase', 186, NULL, NULL, 126842),
(126843, '3.40.50.720-FF-000293', NULL, 'NADPH-dependent F420 reductase', 227, NULL, NULL, 126843),
(126844, '1.20.1250.20-FF-000631', NULL, 'Predicted arabinose efflux permease, MFS family', 181, NULL, NULL, 126844),
(126845, '2.130.10.10-FF-004983', NULL, 'Uncharacterized protein', 78, NULL, NULL, 126845),
(126846, '1.20.20.10-FF-000017', NULL, 'ATP synthase subunit c', 65, NULL, NULL, 126846),
(126847, '2.60.120.480-FF-000002', NULL, 'Probable ureidoglycolate hydrolase', 230, NULL, NULL, 126847),
(126848, '2.130.10.10-FF-005601', NULL, 'Uncharacterized protein', 192, NULL, NULL, 126848),
(126849, '1.10.10.10-FF-000040', NULL, 'segment polarity protein dishevelled homolog DVL-3', 105, NULL, NULL, 126849),
(126850, '3.40.1190.20-FF-000131', NULL, 'Ribokinase', 292, NULL, NULL, 126850),
(126851, '3.30.710.10-FF-000306', NULL, 'Putative skp1 protein', 164, NULL, NULL, 126851),
(126852, '3.30.160.60-FF-004859', NULL, NULL, 28, NULL, NULL, 126852),
(126853, '1.20.120.1080-FF-000093', NULL, 'Uncharacterized protein', 104, NULL, NULL, 126853),
(126854, '3.90.550.10-FF-000229', NULL, 'Glycosyltransferase-like protein LARGE', 207, NULL, NULL, 126854),
(126855, '4.10.1130.20-FF-000004', NULL, 'integrin beta-1-binding protein 2 isoform X1', 74, NULL, NULL, 126855),
(126856, '1.10.486.10-FF-000009', NULL, 'ATP-dependent helicase/nuclease subunit A', 161, NULL, NULL, 126856),
(126857, '3.50.50.60-FF-001282', NULL, 'Uncharacterized protein', 46, NULL, NULL, 126857),
(126858, '3.40.1160.10-FF-000093', NULL, 'Aspartokinase', 92, NULL, NULL, 126858),
(126859, '3.30.70.270-FF-000293', NULL, NULL, 67, NULL, NULL, 126859),
(126860, '1.10.510.10-FF-000157', NULL, 'Ribosomal protein S6 kinase', 271, NULL, NULL, 126860),
(126861, '2.20.25.190-FF-000004', NULL, 'Transcription elongation factor 1 homolog', 59, NULL, NULL, 126861),
(126862, '3.40.50.300-FF-007991', NULL, 'Uncharacterized protein', 155, NULL, NULL, 126862);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(126863, '3.90.660.10-FF-000013', NULL, 'Renalase isoform 1', 181, NULL, NULL, 126863),
(126864, '1.25.40.20-FF-000505', NULL, 'Regulatory protein NPR3', 142, NULL, NULL, 126864),
(126865, '2.70.98.70-FF-000002', NULL, 'Heparin and heparin-sulfate lyase', 320, NULL, NULL, 126865),
(126866, '1.20.1250.20-FF-001148', NULL, 'Uncharacterized protein', 199, NULL, NULL, 126866),
(126867, '3.30.200.20-FF-002221', NULL, 'Uncharacterized protein', 40, NULL, NULL, 126867),
(126868, '3.40.395.10-FF-000003', NULL, 'Sentrin-specific protease 8', 212, NULL, NULL, 126868),
(126869, '2.70.170.10-FF-000102', NULL, 'Predicted protein', 217, NULL, NULL, 126869),
(126870, '1.20.1740.10-FF-000177', NULL, 'Solute carrier family 12 member 8', 218, NULL, NULL, 126870),
(126871, '2.10.210.10-FF-000001', NULL, 'Cytochrome b-c1 complex subunit Rieske, mitochondrial', 78, NULL, NULL, 126871),
(126872, '3.40.50.1820-FF-000823', NULL, 'Protein CBG23034', 212, NULL, NULL, 126872),
(126873, '2.60.200.40-FF-000021', NULL, 'Diacylglycerol kinase catalytic subunit', 173, NULL, NULL, 126873),
(126874, '1.20.80.60-FF-000002', NULL, 'sorting nexin-27 isoform X2', 59, NULL, NULL, 126874),
(126875, '2.40.170.20-FF-000027', NULL, 'Heme transport protein HutA', 528, NULL, NULL, 126875),
(126876, '3.40.50.300-FF-001611', NULL, 'Probable GTP-binding protein EngB', 201, NULL, NULL, 126876),
(126877, '3.40.30.10-FF-000187', NULL, 'Thiol:disulfide interchange protein', 145, NULL, NULL, 126877),
(126878, '1.20.1070.10-FF-000529', NULL, 'Si:ch211-240b21.4', 287, NULL, NULL, 126878),
(126879, '2.60.40.10-FF-004308', NULL, NULL, 101, NULL, NULL, 126879),
(126880, '1.20.1730.10-FF-000092', NULL, 'Solute carrier family 5 member 7', 366, NULL, NULL, 126880),
(126881, '1.20.58.60-FF-000248', NULL, 'Synaptic nuclear envelope 1', 87, NULL, NULL, 126881),
(126882, '2.10.80.10-FF-000019', NULL, 'Uncharacterized protein', 86, NULL, NULL, 126882),
(126883, '3.40.50.300-FF-000094', NULL, 'GTPase Era', 181, NULL, NULL, 126883),
(126884, '2.10.25.10-FF-000459', NULL, 'Axotactin, isoform B', 39, NULL, NULL, 126884),
(126885, '3.40.430.10-FF-000007', NULL, 'Bifunctional dihydrofolate reductase-thymidylate synthase', 229, NULL, NULL, 126885),
(126886, '1.25.40.420-FF-000036', NULL, 'Uncharacterized protein', 62, NULL, NULL, 126886),
(126887, '2.60.120.200-FF-000789', NULL, 'Predicted protein', 92, NULL, NULL, 126887),
(126888, '3.30.70.870-FF-000012', NULL, 'Elongation factor G', 73, NULL, NULL, 126888),
(126889, '2.60.120.10-FF-000236', NULL, 'Uncharacterized NTE family protein ZK370.4', 130, NULL, NULL, 126889),
(126890, '3.20.20.380-FF-000003', NULL, 'Copper homeostasis protein CutC', 209, NULL, NULL, 126890),
(126891, '1.25.10.10-FF-000984', NULL, 'U-box domain-containing protein 2', 233, NULL, NULL, 126891),
(126892, '3.30.70.330-FF-002380', NULL, NULL, 206, NULL, NULL, 126892),
(126893, '1.20.58.60-FF-000591', NULL, 'Spectrin beta chain', 206, NULL, NULL, 126893),
(126894, '3.30.1360.140-FF-000003', NULL, 'DNA-directed RNA polymerase subunit', 138, NULL, NULL, 126894),
(126895, '1.20.1070.10-FF-000468', NULL, 'Uncharacterized protein', 307, NULL, NULL, 126895),
(126896, '2.30.33.40-FF-000019', NULL, 'Co-chaperonin GroES', 110, NULL, NULL, 126896),
(126897, '1.25.40.20-FF-000005', NULL, 'Neurogenic locus notch 1', 258, NULL, NULL, 126897),
(126898, '3.10.110.10-FF-000338', NULL, 'Ubiquitin-conjugating enzyme E2 D/E', 153, NULL, NULL, 126898),
(126899, '3.40.50.150-FF-000217', NULL, 'Methyltransferase protein 13', 194, NULL, NULL, 126899),
(126900, '3.20.20.300-FF-000036', NULL, 'Beta-N-acetylglucosaminidase, putative', 366, NULL, NULL, 126900),
(126901, '3.40.50.300-FF-000330', NULL, 'Septum-promoting GTP-binding protein 1', 186, NULL, NULL, 126901),
(126902, '3.40.50.150-FF-000689', NULL, '4-dimethylallyltryptophan N-methyltransferase easF', 179, NULL, NULL, 126902),
(126903, '1.10.20.10-FF-000321', NULL, NULL, 151, NULL, NULL, 126903),
(126904, '2.60.120.200-FF-000317', NULL, 'Drosophila CRumBs homolog', 174, NULL, NULL, 126904),
(126905, '2.40.10.10-FF-000710', NULL, NULL, 114, NULL, NULL, 126905);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(126906, '1.20.5.1930-FF-000013', NULL, 'Sensory box histidine kinase, putative', 90, NULL, NULL, 126906),
(126907, '3.50.50.60-FF-000663', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 195, NULL, NULL, 126907),
(126908, '3.30.160.60-FF-003578', NULL, NULL, 27, NULL, NULL, 126908),
(126909, '1.25.40.10-FF-005027', NULL, 'Predicted protein', 163, NULL, NULL, 126909),
(126910, '1.20.58.1540-FF-000003', NULL, 'Bud site selection protein', 141, NULL, NULL, 126910),
(126911, '3.80.10.10-FF-003073', NULL, 'Os12g0157550 protein', 132, NULL, NULL, 126911),
(126912, '3.40.640.10-FF-000141', NULL, 'Glutamate decarboxylase', 275, NULL, NULL, 126912),
(126913, '2.60.40.10-FF-003370', NULL, 'Receptor protein-tyrosine kinase', 103, NULL, NULL, 126913),
(126914, '3.30.200.20-FF-001041', NULL, 'Tyrosine-protein kinase receptor', 85, NULL, NULL, 126914),
(126915, '3.30.160.60-FF-001678', NULL, 'Zinc finger protein rotund', 70, NULL, NULL, 126915),
(126916, '2.60.40.60-FF-000046', NULL, 'Protocadherin beta 5', 107, NULL, NULL, 126916),
(126917, '2.60.40.150-FF-000400', NULL, 'Phosphoinositide phospholipase C', 142, NULL, NULL, 126917),
(126918, '3.10.580.10-FF-000221', NULL, 'Uncharacterized protein', 109, NULL, NULL, 126918),
(126919, '1.20.140.150-FF-000030', NULL, 'lens fiber membrane intrinsic protein-like', 46, NULL, NULL, 126919),
(126920, '1.10.510.10-FF-003810', NULL, NULL, 117, NULL, NULL, 126920),
(126921, '3.40.710.10-FF-000124', NULL, 'Uncharacterized protein MT1414', 372, NULL, NULL, 126921),
(126922, '2.40.50.100-FF-000133', NULL, 'Sodium:proton antiporter', 63, NULL, NULL, 126922),
(126923, '1.25.10.10-FF-003390', NULL, 'Uncharacterized protein', 138, NULL, NULL, 126923),
(126924, '3.60.120.10-FF-000007', NULL, 'Salicylate synthase Irp9', 434, NULL, NULL, 126924),
(126925, '1.20.58.340-FF-000010', NULL, 'Magnesium transporter MRS2-I', 181, NULL, NULL, 126925),
(126926, '3.30.160.60-FF-005573', NULL, NULL, 43, NULL, NULL, 126926),
(126927, '3.30.30.30-FF-000075', NULL, 'Uncharacterized protein', 21, NULL, NULL, 126927),
(126928, '3.90.800.10-FF-000002', NULL, 'Glutamine--tRNA ligase', 109, NULL, NULL, 126928),
(126929, '3.40.720.10-FF-000097', NULL, 'Predicted protein', 365, NULL, NULL, 126929),
(126930, '3.30.160.150-FF-000007', NULL, NULL, 146, NULL, NULL, 126930),
(126931, '3.40.50.720-FF-000545', NULL, 'Dehydrogenase, putative', 125, NULL, NULL, 126931),
(126932, '2.30.30.1020-FF-000047', NULL, NULL, 178, NULL, NULL, 126932),
(126933, '3.30.1490.190-FF-000024', NULL, 'Ferric uptake regulator, Fur family', 63, NULL, NULL, 126933),
(126934, '1.25.10.10-FF-001395', NULL, 'Uncharacterized protein', 159, NULL, NULL, 126934),
(126935, '2.20.70.10-FF-000102', NULL, 'Pre-mRNA-processing factor 40 homolog B', 46, NULL, NULL, 126935),
(126936, '1.20.1250.20-FF-001957', NULL, 'Facilitated trehalose transporter Tret1-2 homolog-like Protein', 427, NULL, NULL, 126936),
(126937, '3.30.710.10-FF-000194', NULL, 'Os12g0595600 protein', 134, NULL, NULL, 126937),
(126938, '1.10.472.80-FF-000162', NULL, NULL, 97, NULL, NULL, 126938),
(126939, '1.10.8.60-FF-000149', NULL, 'AAA family ATPase/60S ribosome export protein Rix7', 67, NULL, NULL, 126939),
(126940, '3.80.10.10-FF-001173', NULL, 'Si:ch211-213a13.2', 168, NULL, NULL, 126940),
(126941, '1.10.238.10-FF-000788', NULL, 'Predicted protein', 142, NULL, NULL, 126941),
(126942, '3.30.1370.30-FF-000004', NULL, '30S ribosomal protein S8, chloroplastic', 75, NULL, NULL, 126942),
(126943, '2.20.100.10-FF-000103', NULL, 'SCO-spondin', 55, NULL, NULL, 126943),
(126944, '3.80.10.10-FF-004354', NULL, 'Uncharacterized protein', 179, NULL, NULL, 126944),
(126945, '2.30.30.50-FF-000004', NULL, 'Cobalt-containing nitrile hydratase subunit beta', 104, NULL, NULL, 126945),
(126946, '1.20.58.60-FF-000748', NULL, 'Spectrin, beta, non-erythrocytic 5', 68, NULL, NULL, 126946),
(126947, '1.25.40.10-FF-003127', NULL, 'Uncharacterized protein', 303, NULL, NULL, 126947),
(126948, '3.60.10.10-FF-000139', NULL, 'Type II inositol-1-1,4,5-trisphosphate 5-phosphatase rlated, putative', 330, NULL, NULL, 126948);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(126949, '3.30.70.60-FF-000047', NULL, 'Fimbrial assembly membrane protein, putative', 115, NULL, NULL, 126949),
(126950, '1.20.1330.10-FF-000011', NULL, 'Flagellin', 53, NULL, NULL, 126950),
(126951, '1.25.40.20-FF-000152', NULL, 'neurogenic locus notch homolog protein 4', 246, NULL, NULL, 126951),
(126952, '3.80.10.10-FF-001948', NULL, 'Predicted protein', 79, NULL, NULL, 126952),
(126953, '1.10.10.880-FF-000004', NULL, 'Anti-sigma-E factor RseA', 66, NULL, NULL, 126953),
(126954, '3.40.50.300-FF-007108', NULL, 'Small GTP-binding protein, putative', 186, NULL, NULL, 126954),
(126955, '3.20.20.80-FF-000308', NULL, 'Glycoside hydrolase', 371, NULL, NULL, 126955),
(126956, '3.40.50.1820-FF-001015', NULL, 'Lecithin-cholesterol acyltransferase-like 1', 209, NULL, NULL, 126956),
(126957, '3.40.50.1000-FF-000595', NULL, NULL, 141, NULL, NULL, 126957),
(126958, '1.10.287.70-FF-000391', NULL, 'Potassium channel, putative', 198, NULL, NULL, 126958),
(126959, '3.10.105.10-FF-000096', NULL, 'ABC transporter substrate-binding protein', 220, NULL, NULL, 126959),
(126960, '1.10.555.10-FF-000238', NULL, NULL, 211, NULL, NULL, 126960),
(126961, '3.40.50.2300-FF-000956', NULL, 'Uncharacterized protein', 241, NULL, NULL, 126961),
(126962, '3.50.50.60-FF-001074', NULL, 'Uncharacterized protein', 70, NULL, NULL, 126962),
(126963, '3.30.1490.20-FF-000010', NULL, 'Phosphoenolpyruvate synthase', 192, NULL, NULL, 126963),
(126964, '3.30.40.10-FF-002054', NULL, 'Uncharacterized protein', 91, NULL, NULL, 126964),
(126965, '3.30.572.10-FF-000024', NULL, 'Uncharacterized protein', 302, NULL, NULL, 126965),
(126966, '1.20.1250.20-FF-000529', NULL, 'Membrane transporter, putative', 322, NULL, NULL, 126966),
(126967, '3.40.50.1460-FF-000002', NULL, 'GPI-anchor transamidase', 282, NULL, NULL, 126967),
(126968, '3.20.20.80-FF-000617', NULL, 'Glucosylceramidase', 148, NULL, NULL, 126968),
(126969, '3.60.40.10-FF-000175', NULL, 'Protein phosphatase 2C', 247, NULL, NULL, 126969),
(126970, '3.30.70.890-FF-000018', NULL, 'Phosphomevalonate kinase', 135, NULL, NULL, 126970),
(126971, '3.40.50.150-FF-000116', NULL, 'probable protein arginine N-methyltransferase 1', 153, NULL, NULL, 126971),
(126972, '2.130.10.10-FF-001285', NULL, 'Transducin beta-like protein 2', 294, NULL, NULL, 126972),
(126973, '1.10.510.10-FF-001085', NULL, 'Serine/threonine-protein kinase NIM1', 334, NULL, NULL, 126973),
(126974, '1.10.287.600-FF-000011', NULL, 'Tubulin gamma chain', 62, NULL, NULL, 126974),
(126975, '3.30.200.20-FF-002322', NULL, 'Uncharacterized protein', 87, NULL, NULL, 126975),
(126976, '3.30.50.10-FF-000183', NULL, 'Protein CBG24391', 99, NULL, NULL, 126976),
(126977, '1.25.10.10-FF-002884', NULL, 'Uncharacterized protein', 146, NULL, NULL, 126977),
(126978, '3.10.20.90-FF-000031', NULL, 'Partitioning defective 6 homolog alpha', 85, NULL, NULL, 126978),
(126979, '1.10.510.10-FF-000820', NULL, 'ULK/ULK protein kinase, variant 1', 355, NULL, NULL, 126979),
(126980, '3.40.630.30-FF-000062', NULL, 'Nucleoside diphosphate-linked moiety X motif 6', 92, NULL, NULL, 126980),
(126981, '1.10.510.10-FF-001910', NULL, 'Uncharacterized protein', 324, NULL, NULL, 126981),
(126982, '3.40.50.300-FF-005973', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 254, NULL, NULL, 126982),
(126983, '2.60.40.10-FF-001318', NULL, 'T cell receptor alpha constant', 93, NULL, NULL, 126983),
(126984, '3.30.160.60-FF-006192', NULL, NULL, 54, NULL, NULL, 126984),
(126985, '2.10.25.10-FF-001639', NULL, 'Uncharacterized protein', 48, NULL, NULL, 126985),
(126986, '1.25.40.10-FF-004555', NULL, 'Os11g0266800 protein', 213, NULL, NULL, 126986),
(126987, '3.40.1190.20-FF-000176', NULL, NULL, 107, NULL, NULL, 126987),
(126988, '1.10.630.10-FF-000284', NULL, 'Uncharacterized protein', 195, NULL, NULL, 126988),
(126989, '4.10.400.10-FF-000300', NULL, 'low-density lipoprotein receptor 1', 36, NULL, NULL, 126989),
(126990, '3.30.70.270-FF-000192', NULL, NULL, 93, NULL, NULL, 126990),
(126991, '1.25.40.1040-FF-000062', NULL, 'AGAP003595-PA', 100, NULL, NULL, 126991);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(126992, '2.30.29.30-FF-000383', NULL, 'Uncharacterized protein, isoform B', 112, NULL, NULL, 126992),
(126993, '3.50.50.60-FF-001383', NULL, 'Uncharacterized protein', 71, NULL, NULL, 126993),
(126994, '2.60.40.10-FF-002190', NULL, 'Mesocentin', 94, NULL, NULL, 126994),
(126995, '2.60.40.200-FF-000022', NULL, 'Uncharacterized protein', 79, NULL, NULL, 126995),
(126996, '1.20.142.10-FF-000029', NULL, 'Poly (ADP-ribose) polymerase 2', 55, NULL, NULL, 126996),
(126997, '3.30.160.60-FF-004292', NULL, NULL, 57, NULL, NULL, 126997),
(126998, '1.10.287.70-FF-000082', NULL, 'Cytochrome c oxidase subunit 3', 74, NULL, NULL, 126998),
(126999, '2.20.110.10-FF-000031', NULL, 'Phosphatidylinositol 4-phosphate 5-kinase', 68, NULL, NULL, 126999),
(127000, '3.40.47.10-FF-000298', NULL, NULL, 51, NULL, NULL, 127000),
(127001, '2.30.42.10-FF-000458', NULL, NULL, 122, NULL, NULL, 127001),
(127002, '3.30.160.60-FF-005264', NULL, NULL, 40, NULL, NULL, 127002),
(127003, '3.40.50.300-FF-001156', NULL, 'Polynucleotide 5-hydroxyl-kinase grc3', 235, NULL, NULL, 127003),
(127004, '2.80.10.50-FF-000018', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 130, NULL, NULL, 127004),
(127005, '3.30.420.390-FF-000004', NULL, 'DNA polymerase subunit gamma-1, mitochondrial', 97, NULL, NULL, 127005),
(127006, '1.20.120.1240-FF-000062', NULL, 'Interferon-induced GTP-binding protein Mx1', 87, NULL, NULL, 127006),
(127007, '3.40.50.1110-FF-000173', NULL, 'Phospholipase B1', 295, NULL, NULL, 127007),
(127008, '2.60.40.10-FF-002965', NULL, NULL, 101, NULL, NULL, 127008),
(127009, '3.90.70.10-FF-000799', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 323, NULL, NULL, 127009),
(127010, '1.25.40.10-FF-002301', NULL, 'OSJNBb0012E08.2 protein', 149, NULL, NULL, 127010),
(127011, '2.40.30.130-FF-000020', NULL, 'Alanine--tRNA ligase', 105, NULL, NULL, 127011),
(127012, '3.40.50.300-FF-003056', NULL, 'Nucleotide binding protein 2 putative', 259, NULL, NULL, 127012),
(127013, '3.30.70.330-FF-002941', NULL, NULL, 111, NULL, NULL, 127013),
(127014, '3.40.190.10-FF-000151', NULL, 'Phosphate ABC transporter periplasmic phosphate-binding protein', 144, NULL, NULL, 127014),
(127015, '1.10.1420.10-FF-000172', NULL, 'Mismatch repair protein MSH5, putative', 158, NULL, NULL, 127015),
(127016, '3.40.50.10470-FF-000012', NULL, 'Eukaryotic translation initiation factor 2B, subunit 2 beta', 67, NULL, NULL, 127016),
(127017, '1.25.40.20-FF-001433', NULL, 'Uncharacterized protein', 166, NULL, NULL, 127017),
(127018, '2.60.40.10-FF-001684', NULL, 'Terribly reduced optic lobes, isoform BA', 92, NULL, NULL, 127018),
(127019, '1.10.510.10-FF-002265', NULL, NULL, 195, NULL, NULL, 127019),
(127020, '2.60.120.920-FF-000078', NULL, 'GD12021', 163, NULL, NULL, 127020),
(127021, '3.90.245.10-FF-000003', NULL, 'Pyrimidine-specific ribonucleoside hydrolase RihB', 313, NULL, NULL, 127021),
(127022, '3.30.160.60-FF-003364', NULL, 'Zinc finger protein 860', 23, NULL, NULL, 127022),
(127023, '3.90.640.10-FF-000259', NULL, 'Actin-17', 90, NULL, NULL, 127023),
(127024, '2.180.10.10-FF-000035', NULL, 'Teneurin-4', 195, NULL, NULL, 127024),
(127025, '3.80.10.10-FF-000459', NULL, 'Leucine-rich repeat-containing protein 45', 127, NULL, NULL, 127025),
(127026, '4.10.280.10-FF-000110', NULL, 'Aspartyl-phosphate phosphatase Spo0E', 56, NULL, NULL, 127026),
(127027, '1.10.10.60-FF-000094', NULL, 'Homeobox protein Hox-A3', 106, NULL, NULL, 127027),
(127028, '3.10.300.10-FF-000010', NULL, 'Uncharacterized protein', 154, NULL, NULL, 127028),
(127029, '1.10.472.10-FF-000478', NULL, 'Cyclin-F', 144, NULL, NULL, 127029),
(127030, '3.20.20.330-FF-000005', NULL, 'AdoMet-homocysteine methyltransferase', 314, NULL, NULL, 127030),
(127031, '3.30.420.10-FF-000661', NULL, NULL, 190, NULL, NULL, 127031),
(127032, '3.30.60.30-FF-000015', NULL, 'Transmembrane agrin', 64, NULL, NULL, 127032),
(127033, '1.50.10.10-FF-000111', NULL, 'lanC-like protein 1 isoform X2', 231, NULL, NULL, 127033),
(127034, '2.70.170.10-FF-000208', NULL, 'Uncharacterized protein', 159, NULL, NULL, 127034);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(127035, '1.25.40.10-FF-004510', NULL, 'Protein NPGR1', 87, NULL, NULL, 127035),
(127036, '2.60.40.10-FF-005736', NULL, NULL, 137, NULL, NULL, 127036),
(127037, '2.130.10.10-FF-004511', NULL, 'Uncharacterized protein', 235, NULL, NULL, 127037),
(127038, '1.20.920.10-FF-000006', NULL, 'protein polybromo-1 isoform X1', 121, NULL, NULL, 127038),
(127039, '1.50.10.10-FF-000009', NULL, 'mannosyl-oligosaccharide glucosidase', 468, NULL, NULL, 127039),
(127040, '2.60.200.30-FF-000029', NULL, 'NAD kinase 1', 145, NULL, NULL, 127040),
(127041, '3.20.20.140-FF-000185', NULL, 'Uncharacterized protein', 217, NULL, NULL, 127041),
(127042, '3.20.20.80-FF-000764', NULL, 'Beta-glucosidase 32', 142, NULL, NULL, 127042),
(127043, '1.10.730.10-FF-000140', NULL, 'Uncharacterized protein', 167, NULL, NULL, 127043),
(127044, '3.30.420.10-FF-000559', NULL, NULL, 57, NULL, NULL, 127044),
(127045, '1.10.287.160-FF-000025', NULL, 'Uncharacterized protein', 73, NULL, NULL, 127045),
(127046, '2.60.40.790-FF-000125', NULL, NULL, 125, NULL, NULL, 127046),
(127047, '1.25.40.10-FF-005174', NULL, 'Uncharacterized protein', 65, NULL, NULL, 127047),
(127048, '3.40.720.10-FF-000209', NULL, 'Uncharacterized protein', 267, NULL, NULL, 127048),
(127049, '3.40.605.10-FF-000138', NULL, 'Uncharacterized protein', 201, NULL, NULL, 127049),
(127050, '2.130.10.10-FF-005337', NULL, 'Uncharacterized protein', 183, NULL, NULL, 127050),
(127051, '1.10.8.720-FF-000065', NULL, 'Dynein heavy chain 9', 167, NULL, NULL, 127051),
(127052, '3.40.50.12660-FF-000011', NULL, 'Putative metacaspase family protein', 259, NULL, NULL, 127052),
(127053, '3.60.21.10-FF-000058', NULL, 'Serine/threonine-protein phosphatase', 317, NULL, NULL, 127053),
(127054, '3.40.30.10-FF-001159', NULL, 'Predicted protein', 104, NULL, NULL, 127054),
(127055, '2.20.25.10-FF-000009', NULL, 'DNA-directed RNA polymerase subunit', 55, NULL, NULL, 127055),
(127056, '3.90.370.10-FF-000002', NULL, 'Uncharacterized protein', 94, NULL, NULL, 127056),
(127057, '3.30.70.330-FF-003009', NULL, NULL, 80, NULL, NULL, 127057),
(127058, '3.40.50.2000-FF-000439', NULL, 'UDP-glucuronosyltransferase', 172, NULL, NULL, 127058),
(127059, '3.30.70.100-FF-000040', NULL, 'Stress-response A/B barrel domain-containing protein HS1', 109, NULL, NULL, 127059),
(127060, '2.60.220.50-FF-000042', NULL, 'Uncharacterized protein', 67, NULL, NULL, 127060),
(127061, '2.10.50.10-FF-000091', NULL, 'EPH receptor B6', 57, NULL, NULL, 127061),
(127062, '3.60.20.10-FF-000067', NULL, 'Glutamine-fructose-6-phosphate transaminase (Isomerizing)', 239, NULL, NULL, 127062),
(127063, '3.40.50.2300-FF-001575', NULL, NULL, 149, NULL, NULL, 127063),
(127064, '3.30.465.10-FF-000056', NULL, 'Uncharacterized protein', 109, NULL, NULL, 127064),
(127065, '3.30.460.10-FF-000213', NULL, 'U Six snRNA Interacting Protein', 124, NULL, NULL, 127065),
(127066, '3.40.50.720-FF-001473', NULL, 'Hypothetical pyrroline-5-carboxylate reductase (Eurofung)', 188, NULL, NULL, 127066),
(127067, '1.20.5.340-FF-000033', NULL, 'Stromal interaction molecule', 97, NULL, NULL, 127067),
(127068, '2.60.40.1730-FF-000091', NULL, NULL, 106, NULL, NULL, 127068),
(127069, '1.10.472.80-FF-000015', NULL, 'TBC domain-containing protein kinase-like protein', 127, NULL, NULL, 127069),
(127070, '3.80.10.10-FF-002454', NULL, 'Leucine-rich repeat-like protein', 77, NULL, NULL, 127070),
(127071, '3.80.10.10-FF-000768', NULL, 'Toll-like protein', 160, NULL, NULL, 127071),
(127072, '2.130.10.10-FF-002050', NULL, 'Conserved protein', 177, NULL, NULL, 127072),
(127073, '2.130.10.10-FF-005028', NULL, 'DNA damage-binding protein CMR1', 305, NULL, NULL, 127073),
(127074, '3.30.40.10-FF-001435', NULL, 'TNF receptor-associated factor 4', 67, NULL, NULL, 127074),
(127075, '3.30.160.60-FF-000705', NULL, 'zinc finger protein 2 homolog', 27, NULL, NULL, 127075),
(127076, '3.40.50.1010-FF-000244', NULL, NULL, 191, NULL, NULL, 127076),
(127077, '1.20.890.10-FF-000008', NULL, 'Nucleoside diphosphate kinase homolog 5', 45, NULL, NULL, 127077),
(127078, '2.60.200.10-FF-000023', NULL, 'Interferon regulatory factor 4a', 194, NULL, NULL, 127078);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(127079, '1.20.58.60-FF-000703', NULL, 'Uncharacterized protein', 110, NULL, NULL, 127079),
(127080, '3.40.50.1110-FF-000026', NULL, 'GDSL esterase/lipase At3g14220', 308, NULL, NULL, 127080),
(127081, '3.30.70.260-FF-000094', NULL, 'Homoserine dehydrogenase', 70, NULL, NULL, 127081),
(127082, '3.40.30.10-FF-000642', NULL, 'Glutaredoxin-like protein, putative', 103, NULL, NULL, 127082),
(127083, '3.30.720.200-FF-000004', NULL, 'Glycyl-tRNA synthetase, putative', 67, NULL, NULL, 127083),
(127084, '2.60.120.10-FF-000545', NULL, 'uncharacterized protein LOC100180193 isoform X2', 129, NULL, NULL, 127084),
(127085, '1.20.1070.10-FF-001182', NULL, 'Predicted protein', 318, NULL, NULL, 127085),
(127086, '1.20.1070.10-FF-001957', NULL, 'Uncharacterized protein', 202, NULL, NULL, 127086),
(127087, '1.10.720.30-FF-000061', NULL, '3''-5'' exoribonuclease 1', 66, NULL, NULL, 127087),
(127088, '3.40.50.2000-FF-000748', NULL, 'Uncharacterized protein', 113, NULL, NULL, 127088),
(127089, '3.90.228.10-FF-000020', NULL, 'Zinc finger CCCH-type containing, antiviral 1', 173, NULL, NULL, 127089),
(127090, '1.10.287.70-FF-000638', NULL, 'AGAP010806-PA', 188, NULL, NULL, 127090),
(127091, '3.30.160.60-FF-004320', NULL, NULL, 25, NULL, NULL, 127091),
(127092, '3.30.1140.60-FF-000024', NULL, 'F-actin-capping protein subunit alpha', 41, NULL, NULL, 127092),
(127093, '2.130.10.10-FF-004848', NULL, 'Protein SLOW WALKER 1', 129, NULL, NULL, 127093),
(127094, '1.25.40.180-FF-000138', NULL, 'Nuclear cap-binding protein subunit 1', 248, NULL, NULL, 127094),
(127095, '3.30.980.10-FF-000005', NULL, 'Threonyl-tRNA synthetase, mitochondrial', 158, NULL, NULL, 127095),
(127096, '1.10.8.60-FF-000126', NULL, 'Vacuolar protein sorting-associated protein 4', 115, NULL, NULL, 127096),
(127097, '3.40.50.300-FF-005181', NULL, 'ATP-dependent dethiobiotin synthetase BioD', 218, NULL, NULL, 127097),
(127098, '3.40.50.620-FF-000864', NULL, 'Valine--tRNA ligase', 163, NULL, NULL, 127098),
(127099, '2.40.30.170-FF-000009', NULL, 'Efflux transporter, RND family, MFP subunit', 63, NULL, NULL, 127099),
(127100, '1.25.40.10-FF-004639', NULL, '40 kDa peptidyl-prolyl cis-trans isomerase', 155, NULL, NULL, 127100),
(127101, '3.30.70.1230-FF-000121', NULL, 'Adenylate/guanylate cyclase domain-containing protein', 216, NULL, NULL, 127101),
(127102, '1.20.1250.20-FF-001704', NULL, 'Solute carrier family 2 (Facilitated glucose transporter), member 6 (Predicted)', 313, NULL, NULL, 127102),
(127103, '3.90.810.10-FF-000036', NULL, NULL, 51, NULL, NULL, 127103),
(127104, '3.40.50.150-FF-001622', NULL, NULL, 246, NULL, NULL, 127104),
(127105, '3.10.490.10-FF-000023', NULL, 'Gliotoxin biosynthesis protein GliK', 193, NULL, NULL, 127105),
(127106, '2.30.29.30-FF-000939', NULL, 'Uncharacterized protein', 129, NULL, NULL, 127106),
(127107, '3.90.1600.10-FF-000031', NULL, 'DNA polymerase', 117, NULL, NULL, 127107),
(127108, '1.20.1270.10-FF-000073', NULL, 'Cytosolic HSP70', 117, NULL, NULL, 127108),
(127109, '3.30.560.10-FF-000013', NULL, 'Dehydrogenase pkfF', 322, NULL, NULL, 127109),
(127110, '1.20.1250.10-FF-000066', NULL, 'Prolactin-3C1', 177, NULL, NULL, 127110),
(127111, '3.30.300.160-FF-000015', NULL, 'Type II secretion system protein E', 74, NULL, NULL, 127111),
(127112, '3.20.20.80-FF-000533', NULL, 'Maltase-glucoamylase, intestinal', 67, NULL, NULL, 127112),
(127113, '3.40.5.120-FF-000001', NULL, 'probable global transcription activator SNF2L2 isoform X1', 42, NULL, NULL, 127113),
(127114, '1.10.10.820-FF-000020', NULL, 'Myosin B', 59, NULL, NULL, 127114),
(127115, '2.30.30.40-FF-000221', NULL, 'SH3 and cysteine-rich domain-containing protein 2', 71, NULL, NULL, 127115),
(127116, '1.20.1070.10-FF-000338', NULL, 'Uncharacterized protein', 319, NULL, NULL, 127116),
(127117, '3.30.40.10-FF-001519', NULL, 'Putative ring finger protein 10', 73, NULL, NULL, 127117),
(127118, '3.40.525.10-FF-000076', NULL, 'Sec14p-like phosphatidylinositol transfer family protein', 64, NULL, NULL, 127118),
(127119, '3.30.540.10-FF-000006', NULL, 'Fructose-1,6-bisphosphatase class 1', 197, NULL, NULL, 127119);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(127120, '1.10.510.10-FF-001646', NULL, 'Serine/threonine-protein kinase-like protein', 200, NULL, NULL, 127120),
(127121, '1.10.1300.10-FF-000045', NULL, '3'',5''-cyclic-nucleotide phosphodiesterase regA', 334, NULL, NULL, 127121),
(127122, '1.10.520.10-FF-000006', NULL, 'Peroxidase', 153, NULL, NULL, 127122),
(127123, '3.40.1110.10-FF-000174', NULL, 'Cation-transporting ATPase', 181, NULL, NULL, 127123),
(127124, '3.30.70.330-FF-001497', NULL, NULL, 113, NULL, NULL, 127124),
(127125, '3.40.47.10-FF-000051', NULL, '3-oxoacyl-Acyl-carrier-protein synthase III', 214, NULL, NULL, 127125),
(127126, '3.40.50.620-FF-000381', NULL, 'Isoleucyl-tRNA synthetase', 290, NULL, NULL, 127126),
(127127, '1.10.10.10-FF-000231', NULL, 'HTH-type transcriptional activator AllS', 92, NULL, NULL, 127127),
(127128, '3.30.160.60-FF-002066', NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', 44, NULL, NULL, 127128),
(127129, '1.10.287.2620-FF-000011', NULL, 'Dynein heavy chain, cytoplasmic', 70, NULL, NULL, 127129),
(127130, '1.20.1070.10-FF-000884', NULL, 'Olfactory receptor', 184, NULL, NULL, 127130),
(127131, '1.10.287.70-FF-000655', NULL, 'Uncharacterized protein', 143, NULL, NULL, 127131),
(127132, '2.120.10.80-FF-000098', NULL, 'Acyl-CoA-binding domain-containing protein 4', 234, NULL, NULL, 127132),
(127133, '1.10.135.10-FF-000015', NULL, 'Creatine kinase, M-type', 72, NULL, NULL, 127133),
(127134, '1.10.8.10-FF-000067', NULL, 'E3 ubiquitin-protein ligase UPL1', 74, NULL, NULL, 127134),
(127135, '4.10.1240.30-FF-000015', NULL, NULL, 86, NULL, NULL, 127135),
(127136, '2.60.120.290-FF-000198', NULL, 'Uncharacterized protein', 131, NULL, NULL, 127136),
(127137, '3.90.640.10-FF-000236', NULL, 'Uncharacterized protein', 38, NULL, NULL, 127137),
(127138, '1.10.510.10-FF-002158', NULL, 'Calcium/calmodulin dependent protein kinase kinase 1', 313, NULL, NULL, 127138),
(127139, '1.25.40.10-FF-001992', NULL, 'GM24226', 98, NULL, NULL, 127139),
(127140, '3.30.70.330-FF-002486', NULL, NULL, 77, NULL, NULL, 127140),
(127141, '3.40.50.261-FF-000015', NULL, 'Acyl-CoA synthetase FdrA', 166, NULL, NULL, 127141),
(127142, '3.40.140.10-FF-000215', NULL, 'Eukaryotic translation initiation factor 3 subunit F', 202, NULL, NULL, 127142),
(127143, '2.130.10.10-FF-005467', NULL, 'Uncharacterized protein', 167, NULL, NULL, 127143),
(127144, '1.10.10.10-FF-000124', NULL, 'Redox-sensing transcriptional repressor Rex', 79, NULL, NULL, 127144),
(127145, '3.90.1030.10-FF-000015', NULL, 'Mitochondrial Ribosomal Protein, Large', 101, NULL, NULL, 127145),
(127146, '2.130.10.10-FF-001178', NULL, 'YNL035C-like protein', 197, NULL, NULL, 127146),
(127147, '2.40.70.10-FF-000500', NULL, NULL, 111, NULL, NULL, 127147),
(127148, '3.10.110.10-FF-000063', NULL, 'CDC34p Ubiquitin-conjugating enzyme (E2)', 165, NULL, NULL, 127148),
(127149, '1.25.40.10-FF-005258', NULL, 'S1 RNA binding domain containing protein', 336, NULL, NULL, 127149),
(127150, '4.10.400.10-FF-000183', NULL, 'Prolow-density lipoprotein receptor-related protein 1', 39, NULL, NULL, 127150),
(127151, '3.90.1150.10-FF-000069', NULL, 'L-threonine aldolase', 89, NULL, NULL, 127151),
(127152, '3.40.50.300-FF-005866', NULL, 'Uncharacterized protein', 186, NULL, NULL, 127152),
(127153, '3.40.50.410-FF-000008', NULL, 'Protein transport protein SEC23', 254, NULL, NULL, 127153),
(127154, '3.40.50.1820-FF-000267', NULL, 'Alpha/beta-Hydrolases superfamily protein', 285, NULL, NULL, 127154),
(127155, '2.40.240.20-FF-000016', NULL, NULL, 62, NULL, NULL, 127155),
(127156, '4.10.240.10-FF-000181', NULL, 'Zcf14p', 44, NULL, NULL, 127156),
(127157, '2.60.120.10-FF-000461', NULL, 'Uncharacterized protein', 137, NULL, NULL, 127157),
(127158, '1.20.1070.10-FF-000445', NULL, 'Predicted protein', 292, NULL, NULL, 127158),
(127159, '1.10.10.10-FF-000596', NULL, 'MarR family transcriptional regulator', 149, NULL, NULL, 127159),
(127160, '1.10.880.10-FF-000004', NULL, 'Nuclear factor, erythroid 2', 87, NULL, NULL, 127160),
(127161, '1.10.10.10-FF-001220', NULL, 'Transcriptional regulatory protein', 88, NULL, NULL, 127161); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(127162, '3.30.70.1230-FF-000014', NULL, 'adenylate cyclase type 9', 224, NULL, NULL, 127162),
(127163, '2.60.40.10-FF-002307', NULL, 'PLeXin', 88, NULL, NULL, 127163),
(127164, '3.80.10.10-FF-000745', NULL, 'Trophoblast glycoprotein', 291, NULL, NULL, 127164),
(127165, '1.10.510.10-FF-003254', NULL, NULL, 113, NULL, NULL, 127165),
(127166, '3.40.1010.10-FF-000008', NULL, 'Similar to nucleoside triphosphate pyrophosphohydrolase, MazG', 117, NULL, NULL, 127166),
(127167, '3.30.1490.80-FF-000005', NULL, 'Glutathione synthetase, isoform K', 39, NULL, NULL, 127167),
(127168, '3.30.1520.10-FF-000044', NULL, 'Kinesin-like protein KIF16B', 133, NULL, NULL, 127168),
(127169, '1.25.40.10-FF-003021', NULL, 'Pentatricopeptide repeat-containing protein', 111, NULL, NULL, 127169),
(127170, '2.70.98.20-FF-000004', NULL, 'Amine oxidase', 416, NULL, NULL, 127170),
(127171, '3.40.50.300-FF-002201', NULL, 'DNA helicase', 231, NULL, NULL, 127171),
(127172, '3.30.1640.10-FF-000098', NULL, 'DNA helicase', 87, NULL, NULL, 127172),
(127173, '3.40.50.2300-FF-000294', NULL, 'Stage II sporulation protein E', 132, NULL, NULL, 127173),
(127174, '3.30.70.100-FF-000141', NULL, NULL, 98, NULL, NULL, 127174),
(127175, '3.40.50.10810-FF-000277', NULL, 'Uncharacterized protein', 161, NULL, NULL, 127175),
(127176, '1.10.10.60-FF-001167', NULL, NULL, 47, NULL, NULL, 127176),
(127177, '3.30.1520.10-FF-000151', NULL, 'Predicted protein', 106, NULL, NULL, 127177),
(127178, '3.40.50.12500-FF-000008', NULL, 'Hydantoin racemase', 215, NULL, NULL, 127178),
(127179, '1.20.1110.10-FF-000056', NULL, 'Cation transporting ATPase', 152, NULL, NULL, 127179),
(127180, '2.60.40.60-FF-001075', NULL, 'Protocadherin fat, putative', 112, NULL, NULL, 127180),
(127181, '3.30.70.1560-FF-000012', NULL, 'Pseudouridine synthase', 87, NULL, NULL, 127181),
(127182, '3.30.386.10-FF-000001', NULL, 'Chitosanase', 94, NULL, NULL, 127182),
(127183, '3.50.50.60-FF-000354', NULL, 'Similar to fructosyl-amino acid oxidase', 214, NULL, NULL, 127183),
(127184, '1.25.40.70-FF-000003', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', 245, NULL, NULL, 127184),
(127185, '3.30.710.10-FF-000385', NULL, 'Uncharacterized protein', 177, NULL, NULL, 127185),
(127186, '1.10.510.10-FF-003939', NULL, NULL, 65, NULL, NULL, 127186),
(127187, '3.40.50.1860-FF-000015', NULL, 'Aspartate racemase', 109, NULL, NULL, 127187),
(127188, '1.10.10.10-FF-002029', NULL, 'Uncharacterized protein', 104, NULL, NULL, 127188),
(127189, '2.10.25.10-FF-000431', NULL, 'Delta-like protein', 37, NULL, NULL, 127189),
(127190, '1.25.40.10-FF-001076', NULL, 'protein SMG5-like', 223, NULL, NULL, 127190),
(127191, '2.60.40.10-FF-005719', NULL, NULL, 37, NULL, NULL, 127191),
(127192, '1.10.510.10-FF-004103', NULL, NULL, 128, NULL, NULL, 127192),
(127193, '2.130.10.10-FF-005040', NULL, 'Uncharacterized protein', 290, NULL, NULL, 127193),
(127194, '3.40.50.300-FF-008305', NULL, 'Uncharacterized protein', 261, NULL, NULL, 127194),
(127195, '3.30.1220.10-FF-000004', NULL, 'COBW domain-containing protein C15D4.05', 115, NULL, NULL, 127195),
(127196, '3.10.20.90-FF-000514', NULL, 'Carboxypeptidase', 72, NULL, NULL, 127196),
(127197, '3.30.160.60-FF-001886', NULL, 'Uncharacterized protein', 27, NULL, NULL, 127197),
(127198, '3.50.30.30-FF-000012', NULL, 'E3 ubiquitin-protein ligase RNF13', 139, NULL, NULL, 127198),
(127199, '3.40.50.2300-FF-001159', NULL, NULL, 141, NULL, NULL, 127199),
(127200, '1.50.10.20-FF-000029', NULL, 'Geranylgeranyl transferase type-2 subunit beta', 313, NULL, NULL, 127200),
(127201, '1.10.238.10-FF-001193', NULL, 'Uncharacterized protein', 81, NULL, NULL, 127201),
(127202, '3.80.10.10-FF-000875', NULL, 'Blast:F-box/LRR-repeat protein 4', 97, NULL, NULL, 127202),
(127203, '1.20.140.10-FF-000059', NULL, 'Acyl-CoA dehydrogenase, C-terminal domain protein', 147, NULL, NULL, 127203),
(127204, '2.40.50.140-FF-000111', NULL, 'mRNA-capping enzyme', 90, NULL, NULL, 127204),
(127205, '3.30.70.390-FF-000003', NULL, 'Immediate-early protein', 140, NULL, NULL, 127205),
(127206, '3.80.10.10-FF-001364', NULL, 'Uncharacterized protein', 113, NULL, NULL, 127206);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(127207, '3.30.70.660-FF-000084', NULL, 'tRNA pseudouridine synthase', 134, NULL, NULL, 127207),
(127208, '2.10.70.10-FF-000081', NULL, 'Cellular communication network factor 6', 34, NULL, NULL, 127208),
(127209, '3.30.160.60-FF-002375', NULL, 'Zinc finger protein 268', 32, NULL, NULL, 127209),
(127210, '1.25.40.90-FF-000009', NULL, 'Putative signal transducing adapter molecule 1', 149, NULL, NULL, 127210),
(127211, '3.40.50.410-FF-000317', NULL, 'Uncharacterized protein', 110, NULL, NULL, 127211),
(127212, '3.40.50.300-FF-003292', NULL, 'DEAH-box helicase 40', 95, NULL, NULL, 127212),
(127213, '2.60.40.10-FF-004090', NULL, NULL, 94, NULL, NULL, 127213),
(127214, '3.30.1360.40-FF-000012', NULL, 'DNA topoisomerase (ATP-hydrolyzing)', 90, NULL, NULL, 127214),
(127215, '3.40.190.10-FF-000398', NULL, 'Si:dkey-183j2.10', 106, NULL, NULL, 127215),
(127216, '2.30.30.40-FF-000586', NULL, 'Uncharacterized protein', 90, NULL, NULL, 127216),
(127217, '3.40.50.620-FF-000072', NULL, 'Protein FixA homolog', 256, NULL, NULL, 127217),
(127218, '3.40.630.30-FF-000545', NULL, 'ABC-type transporter, ATPase component, fused to acetyltransferase domain', 163, NULL, NULL, 127218),
(127219, '3.80.10.10-FF-002353', NULL, 'Receptor-like protein 52', 225, NULL, NULL, 127219),
(127220, '2.130.10.10-FF-004056', NULL, 'Predicted protein', 212, NULL, NULL, 127220),
(127221, '3.30.200.20-FF-000799', NULL, 'AGC protein kinase', 104, NULL, NULL, 127221),
(127222, '1.10.15.40-FF-000003', NULL, 'Sulfite reductase', 51, NULL, NULL, 127222),
(127223, '3.40.50.2000-FF-000664', NULL, 'Glycosyl transferase family 28', 226, NULL, NULL, 127223),
(127224, '3.30.780.10-FF-000007', NULL, 'Putative eukaryotic translation initiation factor 2d', 86, NULL, NULL, 127224),
(127225, '2.60.40.1660-FF-000030', NULL, 'Sodium/potassium-transporting ATPase subunit beta', 212, NULL, NULL, 127225),
(127226, '1.10.418.20-FF-000007', NULL, 'Blast:Sentrin-specific protease 7', 44, NULL, NULL, 127226),
(127227, '1.10.1520.10-FF-000033', NULL, 'Uncharacterized protein', 180, NULL, NULL, 127227),
(127228, '3.40.50.2300-FF-000647', NULL, 'Guanylate cyclase', 173, NULL, NULL, 127228),
(127229, '1.10.10.10-FF-000601', NULL, 'GntR family transcriptional regulator', 73, NULL, NULL, 127229),
(127230, '3.30.70.330-FF-002806', NULL, NULL, 95, NULL, NULL, 127230),
(127231, '2.60.40.150-FF-000181', NULL, 'Synaptotagmin 4', 139, NULL, NULL, 127231),
(127232, '3.30.160.60-FF-001447', NULL, 'Zinc finger protein 585B', 24, NULL, NULL, 127232),
(127233, '3.30.70.270-FF-000057', NULL, 'DNA polymerase eta isoform X2', 42, NULL, NULL, 127233),
(127234, '2.10.25.10-FF-000122', NULL, 'Protein crumbs homolog 2', 38, NULL, NULL, 127234),
(127235, '3.30.310.80-FF-000061', NULL, 'Non-specific serine/threonine protein kinase', 94, NULL, NULL, 127235),
(127236, '3.40.50.300-FF-005074', NULL, 'ABC transporter, putative', 106, NULL, NULL, 127236),
(127237, '3.40.1190.10-FF-000038', NULL, NULL, 240, NULL, NULL, 127237),
(127238, '3.10.290.10-FF-000042', NULL, 'Pseudouridine synthase', 60, NULL, NULL, 127238),
(127239, '2.130.10.10-FF-002959', NULL, 'Uncharacterized WD repeat-containing protein sll1491', 242, NULL, NULL, 127239),
(127240, '3.40.50.1980-FF-000068', NULL, 'Adhesion protein', 100, NULL, NULL, 127240),
(127241, '1.10.150.240-FF-000100', NULL, 'HAD-superfamily hydrolase, subfamily IA, variant 3', 79, NULL, NULL, 127241),
(127242, '2.40.50.260-FF-000001', NULL, 'Baseplate hub subunit and tail lysozyme', 128, NULL, NULL, 127242),
(127243, '1.25.40.10-FF-000587', NULL, 'Outer membrane protein assembly factor BamD', 251, NULL, NULL, 127243),
(127244, '3.30.450.50-FF-000039', NULL, 'V-SNARE', 126, NULL, NULL, 127244),
(127245, '1.10.238.10-FF-001204', NULL, 'Protofilament ribbon protein of flagellar microtubules', 76, NULL, NULL, 127245),
(127246, '3.40.20.10-FF-000169', NULL, 'Uncharacterized protein', 48, NULL, NULL, 127246),
(127247, '2.10.50.10-FF-000051', NULL, 'Cysteine repeat modular protein 1', 69, NULL, NULL, 127247),
(127248, '1.25.10.10-FF-002221', NULL, 'Beta-catenin hmp-2', 406, NULL, NULL, 127248);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(127249, '3.50.50.60-FF-000882', NULL, 'FAD-dependent monooxygenase fmqB', 358, NULL, NULL, 127249),
(127250, '3.40.50.720-FF-000753', NULL, 'Predicted protein', 262, NULL, NULL, 127250),
(127251, '3.30.160.60-FF-005629', NULL, NULL, 21, NULL, NULL, 127251),
(127252, '3.40.50.1820-FF-001678', NULL, 'Biotin biosynthesis bifunctional protein BioHC', 238, NULL, NULL, 127252),
(127253, '3.30.420.40-FF-001046', NULL, 'Uncharacterized protein', 12, NULL, NULL, 127253),
(127254, '3.40.50.2000-FF-000794', NULL, 'Glycosyltransferase family 20-domain-containing protein', 302, NULL, NULL, 127254),
(127255, '3.30.565.10-FF-000209', NULL, 'Sensor histidine kinase', 160, NULL, NULL, 127255),
(127256, '3.30.200.20-FF-002558', NULL, 'Uncharacterized protein', 68, NULL, NULL, 127256),
(127257, '1.20.1270.60-FF-000094', NULL, 'SLIT-ROBO Rho GTPase-activating 2 protein', 308, NULL, NULL, 127257),
(127258, '1.20.58.90-FF-000015', NULL, 'SNARE protein, putative', 104, NULL, NULL, 127258),
(127259, '1.10.10.160-FF-000013', NULL, 'RecBCD enzyme subunit RecC', 87, NULL, NULL, 127259),
(127260, '3.30.50.10-FF-000082', NULL, 'NR2E3 isoform 1', 55, NULL, NULL, 127260),
(127261, '3.30.70.3030-FF-000015', NULL, 'Predicted protein', 133, NULL, NULL, 127261),
(127262, '2.40.50.170-FF-000002', NULL, 'Dipeptidyl aminopeptidase 3', 81, NULL, NULL, 127262),
(127263, '3.30.310.130-FF-000003', NULL, 'SUMO specific peptidase 7', 131, NULL, NULL, 127263),
(127264, '3.20.19.10-FF-000015', NULL, 'Uncharacterized protein', 138, NULL, NULL, 127264),
(127265, '3.40.1170.10-FF-000025', NULL, 'DNA mismatch repair protein', 167, NULL, NULL, 127265),
(127266, '3.40.1170.60-FF-000046', NULL, NULL, 78, NULL, NULL, 127266),
(127267, '3.30.1780.10-FF-000001', NULL, 'Ketimine reductase mu-crystallin', 123, NULL, NULL, 127267),
(127268, '2.60.120.920-FF-000095', NULL, 'Ryanodine receptor 1', 125, NULL, NULL, 127268),
(127269, '2.60.40.10-FF-003471', NULL, NULL, 125, NULL, NULL, 127269),
(127270, '2.60.120.330-FF-000013', NULL, 'Gibberellin 3-beta-dioxygenase 1', 320, NULL, NULL, 127270),
(127271, '3.30.200.20-FF-002249', NULL, 'Uncharacterized protein', 26, NULL, NULL, 127271),
(127272, '3.30.40.10-FF-002155', NULL, 'Structure-specific endonuclease subunit SLX1 homolog', 75, NULL, NULL, 127272),
(127273, '3.40.50.1000-FF-000679', NULL, NULL, 165, NULL, NULL, 127273),
(127274, '2.30.42.10-FF-000475', NULL, NULL, 115, NULL, NULL, 127274),
(127275, '2.60.40.60-FF-000147', NULL, 'Cadherin 23', 111, NULL, NULL, 127275),
(127276, '1.20.1050.10-FF-000085', NULL, 'Probable glutathione S-transferase', 116, NULL, NULL, 127276),
(127277, '2.60.120.590-FF-000035', NULL, 'AFR741Wp', 229, NULL, NULL, 127277),
(127278, '1.25.40.10-FF-002402', NULL, 'Pentatricopeptide repeat-containing protein At3g46610', 145, NULL, NULL, 127278),
(127279, '2.60.98.50-FF-000002', NULL, 'Envelopment polyprotein', 91, NULL, NULL, 127279),
(127280, '3.40.50.2300-FF-000979', NULL, NULL, 124, NULL, NULL, 127280),
(127281, '3.30.300.70-FF-000006', NULL, 'Ribosome maturation factor RimP', 80, NULL, NULL, 127281),
(127282, '3.30.160.60-FF-006118', NULL, NULL, 84, NULL, NULL, 127282),
(127283, '2.10.50.30-FF-000057', NULL, 'Uncharacterized protein', 54, NULL, NULL, 127283),
(127284, '3.90.450.1-FF-000001', NULL, 'Attachment protein G3P', 104, NULL, NULL, 127284),
(127285, '1.10.220.120-FF-000002', NULL, 'RNA polymerase sigma factor SigA', 64, NULL, NULL, 127285),
(127286, '3.90.550.10-FF-000595', NULL, 'Gll2190 protein', 231, NULL, NULL, 127286),
(127287, '3.40.120.10-FF-000085', NULL, 'Phosphomannomutase', 108, NULL, NULL, 127287),
(127288, '2.60.120.10-FF-000680', NULL, 'uncharacterized protein LOC100184049 isoform X1', 87, NULL, NULL, 127288),
(127289, '3.40.30.10-FF-000411', NULL, 'Protein disulfide isomerase MPD2', 116, NULL, NULL, 127289),
(127290, '3.90.640.80-FF-000004', NULL, 'Poly [ADP-ribose] polymerase', 135, NULL, NULL, 127290),
(127291, '3.40.50.150-FF-001841', NULL, NULL, 53, NULL, NULL, 127291),
(127292, '1.25.40.10-FF-002857', NULL, 'Tetratricopeptide repeat, putative', 104, NULL, NULL, 127292);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(127293, '3.30.160.60-FF-005472', NULL, NULL, 59, NULL, NULL, 127293),
(127294, '3.40.80.10-FF-000015', NULL, 'PGRP-LA, isoform B', 161, NULL, NULL, 127294),
(127295, '3.90.980.20-FF-000023', NULL, 'Cysteine-rich protein 2-binding protein-like Protein', 166, NULL, NULL, 127295),
(127296, '1.20.1070.10-FF-000754', NULL, '5-hydroxytryptamine (Serotonin) receptor 2B, isoform E', 138, NULL, NULL, 127296),
(127297, '3.90.550.10-FF-000100', NULL, 'translation initiation factor eIF-2B subunit epsilon', 305, NULL, NULL, 127297),
(127298, '3.30.160.60-FF-003920', NULL, NULL, 24, NULL, NULL, 127298),
(127299, '2.20.100.10-FF-000210', NULL, 'Thrombospondin type-1 domain-containing protein 7B', 55, NULL, NULL, 127299),
(127300, '3.30.420.40-FF-000990', NULL, 'Heat shock cognate 70 kDa protein', 90, NULL, NULL, 127300),
(127301, '1.25.40.10-FF-005275', NULL, 'AGR352Cp', 149, NULL, NULL, 127301),
(127302, '1.10.10.60-FF-001297', NULL, NULL, 88, NULL, NULL, 127302),
(127303, '2.40.50.540-FF-000001', NULL, 'Copper homeostasis/adhesion lipoprotein NlpE', 90, NULL, NULL, 127303),
(127304, '3.20.20.80-FF-000663', NULL, 'Uncharacterized protein', 35, NULL, NULL, 127304),
(127305, '3.30.60.30-FF-000223', NULL, 'Predicted protein', 55, NULL, NULL, 127305),
(127306, '1.10.3110.10-FF-000019', NULL, 'Protoporphyrinogen oxidase', 51, NULL, NULL, 127306),
(127307, '1.20.120.220-FF-000007', NULL, 'ATP synthase subunit a', 173, NULL, NULL, 127307),
(127308, '3.60.21.10-FF-000491', NULL, 'Protein CBG05769', 81, NULL, NULL, 127308),
(127309, '2.40.10.120-FF-000007', NULL, 'Periplasmic serine endoprotease DegP-like', 244, NULL, NULL, 127309),
(127310, '3.30.160.60-FF-000161', NULL, 'Zinc finger protein 366', 28, NULL, NULL, 127310),
(127311, '3.40.50.720-FF-002546', NULL, 'Uncharacterized protein', 70, NULL, NULL, 127311),
(127312, '3.40.190.10-FF-000718', NULL, 'Sll1762 protein', 92, NULL, NULL, 127312),
(127313, '2.10.220.10-FF-000058', NULL, 'Fraser extracellular matrix complex subunit 1', 66, NULL, NULL, 127313),
(127314, '1.10.10.10-FF-000579', NULL, 'Transcriptional regulator, MarR family', 145, NULL, NULL, 127314),
(127315, '3.80.10.10-FF-003657', NULL, 'F-box/leucine rich repeat protein, putative', 108, NULL, NULL, 127315),
(127316, '3.90.199.10-FF-000002', NULL, 'DNA topoisomerase 2', 183, NULL, NULL, 127316),
(127317, '3.40.50.720-FF-002018', NULL, '3beta-hydroxysteroid-dehydrogenase/decarboxylase isoform 2', 213, NULL, NULL, 127317),
(127318, '1.10.150.770-FF-000006', NULL, NULL, 67, NULL, NULL, 127318),
(127319, '2.60.40.10-FF-005399', NULL, NULL, 46, NULL, NULL, 127319),
(127320, '3.40.50.1000-FF-000696', NULL, NULL, 129, NULL, NULL, 127320),
(127321, '2.40.128.20-FF-000070', NULL, 'Uncharacterized protein', 171, NULL, NULL, 127321),
(127322, '3.30.70.330-FF-000569', NULL, 'ELAV-Type RNA binding-protein family', 109, NULL, NULL, 127322),
(127323, '3.40.50.11850-FF-000010', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', 119, NULL, NULL, 127323),
(127324, '3.40.50.80-FF-000079', NULL, 'Fre7p', 207, NULL, NULL, 127324),
(127325, '3.30.1490.80-FF-000022', NULL, 'Glutathione synthetase', 92, NULL, NULL, 127325),
(127326, '3.30.2320.80-FF-000010', NULL, 'Hydrogenase maturation factor HypA', 130, NULL, NULL, 127326),
(127327, '1.10.510.10-FF-000051', NULL, 'Receptor-like serine/threonine-protein kinase ALE2', 214, NULL, NULL, 127327),
(127328, '4.10.280.10-FF-000211', NULL, 'Uncharacterized protein', 53, NULL, NULL, 127328),
(127329, '3.40.1170.60-FF-000029', NULL, NULL, 79, NULL, NULL, 127329),
(127330, '3.10.310.10-FF-000067', NULL, 'Uncharacterized protein', 184, NULL, NULL, 127330),
(127331, '3.90.245.10-FF-000026', NULL, 'Protein CBG02610', 346, NULL, NULL, 127331),
(127332, '2.60.40.10-FF-004887', NULL, NULL, 71, NULL, NULL, 127332),
(127333, '3.60.21.10-FF-000311', NULL, 'Metallophosphoesterase', 251, NULL, NULL, 127333),
(127334, '3.30.160.60-FF-003679', NULL, 'Zinc finger and SCAN domain containing 4, pseudogene 3', 29, NULL, NULL, 127334),
(127335, '1.25.40.10-FF-003818', NULL, 'Si:dkey-206p8.1', 132, NULL, NULL, 127335);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(127336, '2.40.50.140-FF-000089', NULL, 'DNA replication licensing factor MCM7', 74, NULL, NULL, 127336),
(127337, '3.40.630.30-FF-000068', NULL, 'Tabtoxin resistance protein', 177, NULL, NULL, 127337),
(127338, '1.10.510.10-FF-003563', NULL, NULL, 223, NULL, NULL, 127338),
(127339, '2.60.120.620-FF-000123', NULL, 'Uncharacterized protein', 97, NULL, NULL, 127339),
(127340, '3.40.50.300-FF-003157', NULL, 'RecBCD enzyme subunit RecB', 232, NULL, NULL, 127340),
(127341, '2.60.40.10-FF-000964', NULL, 'Stretchin-Mlck, isoform T', 94, NULL, NULL, 127341),
(127342, '1.20.1070.10-FF-001373', NULL, 'Uncharacterized protein', 257, NULL, NULL, 127342),
(127343, '1.10.510.10-FF-001669', NULL, 'Serine/threonine-protein kinase', 300, NULL, NULL, 127343),
(127344, '3.30.260.10-FF-000007', NULL, 'Chaperonin 60 subunit beta 2', 91, NULL, NULL, 127344),
(127345, '3.30.160.60-FF-004303', NULL, NULL, 30, NULL, NULL, 127345),
(127346, '3.40.630.10-FF-000404', NULL, 'Bll2698 protein', 216, NULL, NULL, 127346),
(127347, '2.60.120.260-FF-000655', NULL, 'Beta-galactosidase', 101, NULL, NULL, 127347),
(127348, '3.40.50.300-FF-003612', NULL, 'MAGUK p55 subfamily member 3', 214, NULL, NULL, 127348),
(127349, '1.10.150.900-FF-000006', NULL, 'Peptidase M20/M25/M40 family protein', 57, NULL, NULL, 127349),
(127350, '3.30.930.10-FF-000391', NULL, 'Glycyl-tRNA synthetase, putative', 175, NULL, NULL, 127350),
(127351, '1.10.10.2480-FF-000006', NULL, NULL, 66, NULL, NULL, 127351),
(127352, '1.10.287.770-FF-000016', NULL, 'Degenerin-like protein unc-105', 60, NULL, NULL, 127352),
(127353, '2.40.70.10-FF-000478', NULL, NULL, 155, NULL, NULL, 127353),
(127354, '2.30.30.490-FF-000012', NULL, 'metastasis-associated protein MTA3 isoform X1', 81, NULL, NULL, 127354),
(127355, '6.10.250.3450-FF-000006', NULL, 'Uncharacterized protein', 22, NULL, NULL, 127355),
(127356, '4.10.410.10-FF-000048', NULL, 'Protein CBR-MLT-11', 79, NULL, NULL, 127356),
(127357, '3.40.225.10-FF-000036', NULL, NULL, 211, NULL, NULL, 127357),
(127358, '1.20.58.390-FF-000115', NULL, 'GABA/Glycine Receptor family (See gbr)', 76, NULL, NULL, 127358),
(127359, '2.60.40.10-FF-003718', NULL, NULL, 105, NULL, NULL, 127359),
(127360, '3.80.10.10-FF-002662', NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', 235, NULL, NULL, 127360),
(127361, '3.30.300.180-FF-000010', NULL, 'Chromosomal replication initiator protein DnaA', 81, NULL, NULL, 127361),
(127362, '3.10.450.10-FF-000004', NULL, 'Cystatin C', 115, NULL, NULL, 127362),
(127363, '2.60.270.20-FF-000002', NULL, 'Predicted protein', 144, NULL, NULL, 127363),
(127364, '1.10.1200.10-FF-000009', NULL, 'Isochorismatase', 76, NULL, NULL, 127364),
(127365, '1.10.150.300-FF-000006', NULL, NULL, 47, NULL, NULL, 127365),
(127366, '2.30.30.140-FF-000031', NULL, 'DNA/RNA-binding protein KIN17 isoform X1', 53, NULL, NULL, 127366),
(127367, '3.40.50.1100-FF-000035', NULL, 'Serine dehydratase-like protein', 91, NULL, NULL, 127367),
(127368, '1.10.287.70-FF-000402', NULL, 'Predicted protein', 147, NULL, NULL, 127368),
(127369, '1.10.472.80-FF-000116', NULL, 'Rab GTPase activating protein, putative', 143, NULL, NULL, 127369),
(127370, '2.130.10.10-FF-003106', NULL, 'Mono-functional DNA-alkylating methyl methanesulfonate N-term-domain-containing protein', 294, NULL, NULL, 127370),
(127371, '3.30.230.10-FF-000359', NULL, 'Uncharacterized protein', 199, NULL, NULL, 127371),
(127372, '3.30.500.10-FF-000032', NULL, NULL, 171, NULL, NULL, 127372),
(127373, '2.40.160.120-FF-000031', NULL, 'Oxysterol-binding protein 2', 171, NULL, NULL, 127373),
(127374, '1.10.1040.50-FF-000008', NULL, '3-hydroxyacyl-CoA dehydrogenase PaaC', 188, NULL, NULL, 127374),
(127375, '3.30.70.1170-FF-000002', NULL, 'Ribosomal RNA small subunit methyltransferase B', 58, NULL, NULL, 127375),
(127376, '3.60.10.10-FF-000246', NULL, 'Uncharacterized protein', 280, NULL, NULL, 127376),
(127377, '3.40.50.300-FF-007890', NULL, 'Uncharacterized protein', 193, NULL, NULL, 127377),
(127378, '1.25.40.990-FF-000050', NULL, 'Uncharacterized protein', 299, NULL, NULL, 127378);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(127379, '1.10.1040.10-FF-000007', NULL, 'Ketol-acid reductoisomerase (NADP(+))', 283, NULL, NULL, 127379),
(127380, '3.40.720.10-FF-000203', NULL, 'N-acetylgalactosamine 6-sulfate sulfatase (GALNS)', 365, NULL, NULL, 127380),
(127381, '4.10.400.10-FF-000222', NULL, 'Low-density lipoprotein receptor-related protein 2', 45, NULL, NULL, 127381),
(127382, '1.25.10.10-FF-000220', NULL, 'inverted formin-2 isoform X2', 224, NULL, NULL, 127382),
(127383, '1.10.1040.30-FF-000002', NULL, 'ISWI chromatin-remodeling complex ATPase CHR11', 99, NULL, NULL, 127383),
(127384, '3.40.50.150-FF-001206', NULL, NULL, 137, NULL, NULL, 127384),
(127385, '6.10.140.2150-FF-000010', NULL, 'Aspartate aminotransferase family protein', 15, NULL, NULL, 127385),
(127386, '2.130.10.10-FF-000689', NULL, 'U4/U6 small nuclear ribonucleoprotein PRP4-like protein', 170, NULL, NULL, 127386),
(127387, '1.10.10.430-FF-000010', NULL, 'Uncharacterized protein', 61, NULL, NULL, 127387),
(127388, '3.40.50.1000-FF-000140', NULL, 'Pyridoxal phosphate phosphatase', 129, NULL, NULL, 127388),
(127389, '3.30.980.10-FF-000028', NULL, 'Threonyl/alanyl tRNA synthetase SAD', 155, NULL, NULL, 127389),
(127390, '1.20.1070.10-FF-001749', NULL, 'Uncharacterized protein', 79, NULL, NULL, 127390),
(127391, '1.10.10.60-FF-000678', NULL, 'C. Elegans Homeobox', 72, NULL, NULL, 127391),
(127392, '4.10.280.110-FF-000020', NULL, NULL, 72, NULL, NULL, 127392),
(127393, '2.60.120.260-FF-000436', NULL, 'Glycoside hydrolase family 2 sugar binding', 159, NULL, NULL, 127393),
(127394, '2.20.25.530-FF-000005', NULL, 'ribonuclease H2 subunit B', 75, NULL, NULL, 127394),
(127395, '3.90.70.10-FF-000327', NULL, 'Vignain', 194, NULL, NULL, 127395),
(127396, '1.25.10.10-FF-003182', NULL, 'Uncharacterized protein', 316, NULL, NULL, 127396),
(127397, '3.90.550.20-FF-000013', NULL, 'Alpha1,4-N-acetylgalactosaminyltransferase', 249, NULL, NULL, 127397),
(127398, '3.30.70.330-FF-001536', NULL, NULL, 65, NULL, NULL, 127398),
(127399, '2.130.10.10-FF-002139', NULL, 'Protein kinase family protein / WD-40 repeat family protein', 136, NULL, NULL, 127399),
(127400, '3.40.50.12230-FF-000023', NULL, 'Uncharacterized protein', 309, NULL, NULL, 127400),
(127401, '2.20.70.30-FF-000007', NULL, 'Nascent polypeptide-associated complex protein', 64, NULL, NULL, 127401),
(127402, '2.30.30.100-FF-000159', NULL, 'U6 snRNA-associated Sm-like protein LSm3', 118, NULL, NULL, 127402),
(127403, '3.40.720.10-FF-000198', NULL, 'Uncharacterized protein', 313, NULL, NULL, 127403),
(127404, '2.20.70.10-FF-000001', NULL, 'Membrane-associated guanylate kinase, WW and PDZ domain-containing protein 1', 33, NULL, NULL, 127404),
(127405, '1.25.10.10-FF-000304', NULL, 'MAP3K epsilon protein kinase 1-like', 347, NULL, NULL, 127405),
(127406, '1.10.1670.40-FF-000013', NULL, '3-methyladenine DNA glycosylase', 70, NULL, NULL, 127406),
(127407, '3.30.200.20-FF-000304', NULL, 'eIF-2-alpha kinase GCN2', 131, NULL, NULL, 127407),
(127408, '1.20.58.60-FF-000147', NULL, 'utrophin isoform X2', 114, NULL, NULL, 127408),
(127409, '1.10.1760.20-FF-000020', NULL, NULL, 161, NULL, NULL, 127409),
(127410, '1.25.40.20-FF-000360', NULL, 'Ankyrin repeat domain 33', 180, NULL, NULL, 127410),
(127411, '4.10.240.10-FF-000220', NULL, 'Chromosome 12, whole genome shotgun sequence', 43, NULL, NULL, 127411),
(127412, '3.40.50.1100-FF-000052', NULL, 'Threonine synthase', 227, NULL, NULL, 127412),
(127413, '3.30.160.60-FF-000121', NULL, 'zinc finger protein 385B isoform X1', 46, NULL, NULL, 127413),
(127414, '1.20.1310.10-FF-000021', NULL, 'Cullin-1, putative', 137, NULL, NULL, 127414),
(127415, '3.80.10.10-FF-003281', NULL, 'Toll-like receptor22', 124, NULL, NULL, 127415),
(127416, '2.60.40.420-FF-000149', NULL, 'PKHD1 like 1', 96, NULL, NULL, 127416),
(127417, '1.10.3330.10-FF-000007', NULL, '2-oxo-4-hydroxy-4-carboxy-5-ureidoimidazoline decarboxylase', 172, NULL, NULL, 127417),
(127418, '3.30.60.20-FF-000130', NULL, 'Rho kinase', 70, NULL, NULL, 127418),
(127419, '3.30.470.20-FF-000043', NULL, 'acetyl-CoA carboxylase 1-like', 259, NULL, NULL, 127419);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(127420, '1.10.510.10-FF-000360', NULL, 'Ephrin type-A receptor 10', 187, NULL, NULL, 127420),
(127421, '3.20.20.70-FF-000204', NULL, 'Peroxisomal (S)-2-hydroxy-acid oxidase GLO4', 361, NULL, NULL, 127421),
(127422, '3.10.50.40-FF-000108', NULL, 'Trigger factor', 104, NULL, NULL, 127422),
(127423, '1.20.1740.10-FF-000194', NULL, 'Uncharacterized protein', 216, NULL, NULL, 127423),
(127424, '3.40.50.1820-FF-000806', NULL, 'Carboxypeptidase', 306, NULL, NULL, 127424),
(127425, '2.130.10.10-FF-003123', NULL, 'YALI0D06435p', 264, NULL, NULL, 127425),
(127426, '3.30.70.330-FF-001188', NULL, 'Cold sensitive u2 snRNA suppressor', 106, NULL, NULL, 127426),
(127427, '3.20.20.70-FF-000199', NULL, 'Phosphoribosylanthranilate isomerase', 210, NULL, NULL, 127427),
(127428, '2.130.10.10-FF-004051', NULL, 'Uncharacterized protein', 214, NULL, NULL, 127428),
(127429, '3.30.40.10-FF-001626', NULL, 'Ret finger protein-like 4', 83, NULL, NULL, 127429),
(127430, '1.25.10.10-FF-002693', NULL, 'Predicted protein', 69, NULL, NULL, 127430),
(127431, '1.20.1280.290-FF-000087', NULL, 'Maltose exporter-like protein', 85, NULL, NULL, 127431),
(127432, '3.40.50.1100-FF-000271', NULL, 'Threonine synthase', 141, NULL, NULL, 127432),
(127433, '1.20.58.60-FF-000512', NULL, 'Spectrin beta chain', 107, NULL, NULL, 127433),
(127434, '2.30.42.10-FF-000003', NULL, 'Regulating synaptic membrane exocytosis protein 1, putative', 123, NULL, NULL, 127434),
(127435, '3.30.70.2280-FF-000003', NULL, 'DEAD-box ATP-dependent RNA helicase 7', 73, NULL, NULL, 127435),
(127436, '6.10.140.2220-FF-000042', NULL, 'GD11837', 45, NULL, NULL, 127436),
(127437, '3.80.10.10-FF-000436', NULL, 'Si:dkey-16p6.1', 152, NULL, NULL, 127437),
(127438, '3.40.50.1000-FF-000701', NULL, NULL, 115, NULL, NULL, 127438),
(127439, '1.20.1250.20-FF-000215', NULL, 'Solute carrier organic anion transporter family member', 330, NULL, NULL, 127439),
(127440, '3.40.50.2300-FF-000850', NULL, NULL, 134, NULL, NULL, 127440),
(127441, '3.40.50.360-FF-000078', NULL, 'Chromate reductase', 194, NULL, NULL, 127441),
(127442, '1.20.120.350-FF-000226', NULL, NULL, 133, NULL, NULL, 127442),
(127443, '3.30.160.60-FF-003903', NULL, NULL, 46, NULL, NULL, 127443),
(127444, '3.40.30.10-FF-000451', NULL, 'glutaredoxin-3', 80, NULL, NULL, 127444),
(127445, '3.30.2410.10-FF-000036', NULL, 'Ubiquitin-protein ligase, putative', 113, NULL, NULL, 127445),
(127446, '3.30.56.10-FF-000033', NULL, 'Phenylalanine--tRNA ligase beta subunit', 71, NULL, NULL, 127446),
(127447, '1.10.3720.10-FF-000021', NULL, 'Glutamate/aspartate ABC transporter, permease protein GltJ', 222, NULL, NULL, 127447),
(127448, '1.20.5.170-FF-000196', NULL, 'AGAP006031-PA-like protein', 42, NULL, NULL, 127448),
(127449, '3.90.70.10-FF-000108', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 359, NULL, NULL, 127449),
(127450, '1.10.30.20-FF-000004', NULL, 'DNA helicase RepD', 87, NULL, NULL, 127450),
(127451, '2.60.40.4330-FF-000005', NULL, NULL, 125, NULL, NULL, 127451),
(127452, '3.30.420.40-FF-000973', NULL, 'Uncharacterized protein', 13, NULL, NULL, 127452),
(127453, '1.25.40.420-FF-000059', NULL, 'AT19737p', 119, NULL, NULL, 127453),
(127454, '1.10.287.1260-FF-000013', NULL, NULL, 121, NULL, NULL, 127454),
(127455, '3.50.50.60-FF-000910', NULL, 'Protoporphyrinogen oxidase', 458, NULL, NULL, 127455),
(127456, '2.20.25.160-FF-000006', NULL, 'Aspartoacylase', 52, NULL, NULL, 127456),
(127457, '3.10.20.90-FF-000037', NULL, 'Gamma-aminobutyric acid receptor-associated protein-like 1', 116, NULL, NULL, 127457),
(127458, '3.60.21.10-FF-000182', NULL, 'Serine/threonine-protein phosphatase', 413, NULL, NULL, 127458),
(127459, '1.20.120.790-FF-000026', NULL, 'Heat shock protein 90, putative', 147, NULL, NULL, 127459),
(127460, '3.20.20.80-FF-000516', NULL, 'Glycoside hydrolase, putative', 186, NULL, NULL, 127460),
(127461, '3.60.40.10-FF-000074', NULL, 'Protein phosphatase 2C 11', 317, NULL, NULL, 127461),
(127462, '3.80.10.10-FF-000892', NULL, 'Os08g0322500 protein', 69, NULL, NULL, 127462),
(127463, '2.60.40.780-FF-000004', NULL, 'AGAP002496-PA', 90, NULL, NULL, 127463);
INSERT INTO "PUBLIC"."MODEL" VALUES
(127464, '1.10.238.10-FF-000108', NULL, 'Calbindin 1', 87, NULL, NULL, 127464),
(127465, '2.10.25.10-FF-000914', NULL, 'Crumbs 1, cell polarity complex component', 42, NULL, NULL, 127465),
(127466, '2.60.40.150-FF-000506', NULL, 'synaptotagmin-12', 89, NULL, NULL, 127466),
(127467, '3.30.160.60-FF-003555', NULL, NULL, 43, NULL, NULL, 127467),
(127468, '3.30.70.330-FF-000699', NULL, 'U2 small nuclear ribonucleoprotein B', 78, NULL, NULL, 127468),
(127469, '3.30.70.330-FF-002481', NULL, NULL, 78, NULL, NULL, 127469),
(127470, '3.10.180.90-FF-000001', NULL, 'ATP-dependent 6-phosphofructokinase', 156, NULL, NULL, 127470),
(127471, '3.90.1720.10-FF-000006', NULL, 'Lecithin retinol acyltransferase', 143, NULL, NULL, 127471),
(127472, '3.40.50.1820-FF-001206', NULL, 'Phosphatidylcholine-sterol acyltransferase', 46, NULL, NULL, 127472),
(127473, '3.30.70.330-FF-000917', NULL, 'Unplaced genomic scaffold supercont1.45, whole genome shotgun sequence', 115, NULL, NULL, 127473),
(127474, '3.40.630.10-FF-000062', NULL, 'Cytosolic carboxypeptidase 6', 271, NULL, NULL, 127474),
(127475, '3.40.850.10-FF-000078', NULL, 'Putative Kinesin-7', 416, NULL, NULL, 127475),
(127476, '1.25.40.20-FF-000921', NULL, 'S-acyltransferase', 217, NULL, NULL, 127476),
(127477, '1.25.40.10-FF-004746', NULL, 'Uncharacterized protein', 69, NULL, NULL, 127477),
(127478, '3.40.50.12780-FF-000137', NULL, 'Probable L-prolyl-AMP ligase PigI', 383, NULL, NULL, 127478),
(127479, '2.40.50.150-FF-000007', NULL, 'DNA-directed RNA polymerase subunit beta', 138, NULL, NULL, 127479),
(127480, '1.10.220.160-FF-000003', NULL, 'Histone-lysine N-methyltransferase SMYD3', 86, NULL, NULL, 127480),
(127481, '2.60.40.690-FF-000005', NULL, 'CD109 molecule', 144, NULL, NULL, 127481),
(127482, '3.40.50.200-FF-000024', NULL, 'Subtilisin-like protease 2', 307, NULL, NULL, 127482),
(127483, '1.25.40.10-FF-003335', NULL, 'TPR repeat, putative', 97, NULL, NULL, 127483),
(127484, '1.20.1270.10-FF-000101', NULL, 'Hsp70 family chaperone', 109, NULL, NULL, 127484),
(127485, '2.40.30.10-FF-000054', NULL, 'Translation initiation factor IF-2', 118, NULL, NULL, 127485),
(127486, '1.10.472.10-FF-000287', NULL, 'G1/S-specific cyclin-E', 149, NULL, NULL, 127486),
(127487, '3.30.780.10-FF-000024', NULL, 'Translation_initiation_factor_SUI1_-_putative', 109, NULL, NULL, 127487),
(127488, '3.30.1680.10-FF-000061', NULL, 'Uncharacterized protein', 35, NULL, NULL, 127488),
(127489, '1.25.10.10-FF-002018', NULL, 'Dynein axonemal assembly factor 5', 145, NULL, NULL, 127489),
(127490, '3.40.630.30-FF-000629', NULL, 'Uncharacterized protein', 181, NULL, NULL, 127490),
(127491, '1.10.437.10-FF-000037', NULL, 'apoptosis regulator Bcl-2', 175, NULL, NULL, 127491),
(127492, '2.60.120.200-FF-000109', NULL, 'Laminin subunit alpha 3', 156, NULL, NULL, 127492),
(127493, '2.30.30.40-FF-000114', NULL, 'Rho GTPase activating protein 42', 64, NULL, NULL, 127493),
(127494, '3.40.50.10490-FF-000012', NULL, '40S ribosomal protein SA', 207, NULL, NULL, 127494),
(127495, '3.30.60.30-FF-000094', NULL, 'GD12589', 52, NULL, NULL, 127495),
(127496, '3.10.20.70-FF-000031', NULL, 'Uncharacterized protein', 95, NULL, NULL, 127496),
(127497, '3.40.30.10-FF-000304', NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', 114, NULL, NULL, 127497),
(127498, '3.30.9.10-FF-000284', NULL, 'Uncharacterized protein', 179, NULL, NULL, 127498),
(127499, '2.60.120.380-FF-000017', NULL, 'Putative kinesin', 154, NULL, NULL, 127499),
(127500, '3.40.50.300-FF-006962', NULL, 'ABC transporter ATP-binding protein', 221, NULL, NULL, 127500),
(127501, '3.40.50.300-FF-007451', NULL, 'Uncharacterized protein', 246, NULL, NULL, 127501),
(127502, '1.10.1520.10-FF-000117', NULL, 'Dicer-like protein', 120, NULL, NULL, 127502),
(127503, '3.30.572.10-FF-000001', NULL, 'Thymidylate synthase', 264, NULL, NULL, 127503),
(127504, '3.10.490.10-FF-000006', NULL, 'Gamma-glutamylcyclotransferase', 164, NULL, NULL, 127504),
(127505, '3.40.850.10-FF-000426', NULL, 'Uncharacterized protein', 167, NULL, NULL, 127505);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(127506, '1.10.167.10-FF-000044', NULL, 'Rgs2p', 147, NULL, NULL, 127506),
(127507, '3.30.1120.10-FF-000042', NULL, 'Uncharacterized protein', 38, NULL, NULL, 127507),
(127508, '2.60.40.150-FF-000164', NULL, 'Protein unc-13 homolog D', 144, NULL, NULL, 127508),
(127509, '2.30.29.30-FF-000967', NULL, 'TBC1 domain family member 2B-like', 106, NULL, NULL, 127509),
(127510, '1.10.10.10-FF-001905', NULL, 'O-methyltransferase', 81, NULL, NULL, 127510),
(127511, '3.40.20.10-FF-000130', NULL, 'Uncharacterized protein', 142, NULL, NULL, 127511),
(127512, '3.30.420.10-FF-000189', NULL, 'Uncharacterized protein', 138, NULL, NULL, 127512),
(127513, '3.60.40.10-FF-000198', NULL, 'Predicted protein', 309, NULL, NULL, 127513),
(127514, '2.60.40.60-FF-000602', NULL, 'Uncharacterized protein', 106, NULL, NULL, 127514),
(127515, '3.40.850.10-FF-000387', NULL, 'Uncharacterized protein', 304, NULL, NULL, 127515),
(127516, '1.25.40.10-FF-003026', NULL, 'Uncharacterized protein', 107, NULL, NULL, 127516),
(127517, '2.60.40.790-FF-000142', NULL, NULL, 129, NULL, NULL, 127517),
(127518, '2.60.40.10-FF-001346', NULL, 'Uncharacterized protein, isoform D', 99, NULL, NULL, 127518),
(127519, '3.30.360.10-FF-000043', NULL, 'Dihydrodiol dehydrogenase', 85, NULL, NULL, 127519),
(127520, '3.30.1360.80-FF-000001', NULL, 'S-ribosylhomocysteine lyase', 171, NULL, NULL, 127520),
(127521, '3.10.290.70-FF-000014', NULL, NULL, 83, NULL, NULL, 127521),
(127522, '1.25.40.990-FF-000078', NULL, 'Uncharacterized protein', 248, NULL, NULL, 127522),
(127523, '3.30.420.10-FF-000666', NULL, NULL, 183, NULL, NULL, 127523),
(127524, '1.25.40.10-FF-003785', NULL, 'PPR repeat protein', 153, NULL, NULL, 127524),
(127525, '3.40.50.300-FF-000200', NULL, 'Uridine-cytidine kinase', 214, NULL, NULL, 127525),
(127526, '1.10.238.10-FF-000243', NULL, 'EF-hand calcium binding domain 6', 78, NULL, NULL, 127526),
(127527, '2.60.120.650-FF-000194', NULL, 'Putative lysine-specific demethylase ELF6', 59, NULL, NULL, 127527),
(127528, '3.70.10.10-FF-000072', NULL, 'Uncharacterized protein', 122, NULL, NULL, 127528),
(127529, '3.30.40.10-FF-000137', NULL, 'RanBP-type and C3HC4-type zinc finger-containing protein 1', 88, NULL, NULL, 127529),
(127530, '3.30.160.60-FF-001902', NULL, 'Uncharacterized protein', 28, NULL, NULL, 127530),
(127531, '3.60.21.10-FF-000075', NULL, 'Glideosome-associated protein 50', 342, NULL, NULL, 127531),
(127532, '3.30.70.330-FF-001160', NULL, 'RNA recognition motif domain containing protein', 140, NULL, NULL, 127532),
(127533, '2.60.40.3230-FF-000001', NULL, 'DUF1425 domain-containing protein', 103, NULL, NULL, 127533),
(127534, '3.30.30.30-FF-000070', NULL, 'Heat shock protein 70 family', 51, NULL, NULL, 127534),
(127535, '3.55.40.20-FF-000005', NULL, 'Superoxide dismutase', 133, NULL, NULL, 127535),
(127536, '3.90.190.10-FF-000038', NULL, 'Tyrosine-protein phosphatase CDC14', 169, NULL, NULL, 127536),
(127537, '3.30.1320.10-FF-000023', NULL, '30S ribosomal protein S16', 112, NULL, NULL, 127537),
(127538, '2.170.300.10-FF-000072', NULL, 'Multiple epidermal growth factor-like domains 6', 128, NULL, NULL, 127538),
(127539, '1.10.10.10-FF-001557', NULL, 'Pca regulon regulatory protein', 75, NULL, NULL, 127539),
(127540, '2.10.25.10-FF-001611', NULL, 'Uncharacterized protein', 53, NULL, NULL, 127540),
(127541, '3.40.50.11660-FF-000048', NULL, NULL, 109, NULL, NULL, 127541),
(127542, '3.30.160.60-FF-004067', NULL, NULL, 41, NULL, NULL, 127542),
(127543, '3.30.160.60-FF-003448', NULL, NULL, 34, NULL, NULL, 127543),
(127544, '3.50.50.60-FF-001152', NULL, 'Choline dehydrogenase, like protein', 67, NULL, NULL, 127544),
(127545, '3.30.530.20-FF-000172', NULL, 'Uncharacterized protein', 115, NULL, NULL, 127545),
(127546, '1.25.40.20-FF-000606', NULL, 'Os01g0943800 protein', 206, NULL, NULL, 127546),
(127547, '3.80.10.10-FF-002437', NULL, 'F-box/LRR-repeat protein 3 isoform A', 148, NULL, NULL, 127547),
(127548, '3.40.50.10860-FF-000011', NULL, 'Shikimate dehydrogenase (NADP(+))', 117, NULL, NULL, 127548),
(127549, '3.60.10.10-FF-000263', NULL, 'Deoxyribonuclease 1-like 4, tandem duplicate 2', 163, NULL, NULL, 127549);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(127550, '1.50.10.10-FF-000004', NULL, 'Phosphorylase b kinase regulatory subunit', 391, NULL, NULL, 127550),
(127551, '2.160.20.70-FF-000021', NULL, 'Adenylyl cyclase-associated protein', 174, NULL, NULL, 127551),
(127552, '3.30.160.60-FF-005157', NULL, NULL, 60, NULL, NULL, 127552),
(127553, '2.40.50.120-FF-000009', NULL, 'Complement C4-A', 157, NULL, NULL, 127553),
(127554, '3.30.70.1730-FF-000069', NULL, 'Uncharacterized protein', 37, NULL, NULL, 127554),
(127555, '3.20.20.80-FF-000191', NULL, 'Mannosylglycoprotein endo-beta-mannosidase', 354, NULL, NULL, 127555),
(127556, '3.30.70.980-FF-000045', NULL, 'Probable transcriptional regulatory protein A1E_02520', 73, NULL, NULL, 127556),
(127557, '1.25.40.10-FF-000132', NULL, 'Histone-lysine N-methyltransferase SMYD1 isoform 1', 213, NULL, NULL, 127557),
(127558, '3.40.640.10-FF-000489', NULL, 'Uncharacterized protein', 46, NULL, NULL, 127558),
(127559, '1.10.238.10-FF-001277', NULL, 'Uncharacterized protein', 141, NULL, NULL, 127559),
(127560, '3.90.45.10-FF-000022', NULL, 'Peptide deformylase', 183, NULL, NULL, 127560),
(127561, '3.40.50.720-FF-002327', NULL, 'AGAP009611-PA', 120, NULL, NULL, 127561),
(127562, '3.20.20.150-FF-000047', NULL, 'Xylose isomerase domain protein TIM barrel', 273, NULL, NULL, 127562),
(127563, '3.40.50.150-FF-001280', NULL, NULL, 222, NULL, NULL, 127563),
(127564, '1.20.120.610-FF-000017', NULL, 'V-type proton ATPase proteolipid subunit', 149, NULL, NULL, 127564),
(127565, '3.30.50.10-FF-000166', NULL, 'Protein CBG26996', 84, NULL, NULL, 127565),
(127566, '3.80.10.10-FF-003966', NULL, 'Si:dkey-27n6.4', 257, NULL, NULL, 127566),
(127567, '3.90.226.10-FF-000302', NULL, 'Uncharacterized protein', 135, NULL, NULL, 127567),
(127568, '1.10.10.440-FF-000030', NULL, 'Pre-mRNA-processing protein 40C', 75, NULL, NULL, 127568),
(127569, '1.10.565.10-FF-000082', NULL, 'Uncharacterized protein', 189, NULL, NULL, 127569),
(127570, '3.40.50.300-FF-001139', NULL, 'Orf1ab polyprotein', 173, NULL, NULL, 127570),
(127571, '3.40.50.11530-FF-000004', NULL, 'Interleukin 17 receptor B', 162, NULL, NULL, 127571),
(127572, '3.30.1360.120-FF-000020', NULL, 'Aminomethyltransferase', 140, NULL, NULL, 127572),
(127573, '1.25.40.420-FF-000019', NULL, 'Kelch-like 11 (Drosophila) (Predicted)', 106, NULL, NULL, 127573),
(127574, '3.30.70.330-FF-001845', NULL, NULL, 115, NULL, NULL, 127574),
(127575, '1.10.287.460-FF-000002', NULL, 'Peptidyl-prolyl cis-trans isomerase', 117, NULL, NULL, 127575),
(127576, '1.20.120.1760-FF-000083', NULL, NULL, 156, NULL, NULL, 127576),
(127577, '1.20.960.10-FF-000008', NULL, 'Translocase of outer mitochondrial membrane 20 like', 70, NULL, NULL, 127577),
(127578, '3.30.200.20-FF-001069', NULL, 'Os12g0427100 protein', 114, NULL, NULL, 127578),
(127579, '3.40.50.300-FF-002229', NULL, 'ABC transporter, ATP-binding protein', 242, NULL, NULL, 127579),
(127580, '2.60.120.620-FF-000090', NULL, '2-oxoglutarate and iron-dependent oxygenase domain-containing protein', 231, NULL, NULL, 127580),
(127581, '3.40.50.1820-FF-000470', NULL, 'Dipeptidyl-peptidase 5, putative', 244, NULL, NULL, 127581),
(127582, '3.10.100.10-FF-000276', NULL, NULL, 173, NULL, NULL, 127582),
(127583, '3.10.20.90-FF-000059', NULL, 'Microtubule-associated proteins 1A/1B light chain 3B', 119, NULL, NULL, 127583),
(127584, '3.30.1370.10-FF-000099', NULL, 'Pbp2p', 74, NULL, NULL, 127584),
(127585, '3.40.50.300-FF-008272', NULL, 'ATP-dependent DNA helicase', 40, NULL, NULL, 127585),
(127586, '1.10.10.750-FF-000004', NULL, 'Putative rab gtpase-activating protein 1', 49, NULL, NULL, 127586),
(127587, '3.40.50.1820-FF-000245', NULL, 'Alpha/beta fold hydrolase', 321, NULL, NULL, 127587),
(127588, '3.90.440.10-FF-000002', NULL, 'Nitric oxide synthase oxygenase', 94, NULL, NULL, 127588),
(127589, '1.25.40.10-FF-001548', NULL, 'Pentatricopeptide repeat-containing protein At4g30825, chloroplastic', 111, NULL, NULL, 127589),
(127590, '1.20.58.390-FF-000137', NULL, 'Predicted protein', 82, NULL, NULL, 127590),
(127591, '3.40.640.10-FF-000124', NULL, 'Acetylornithine aminotransferase', 252, NULL, NULL, 127591);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(127592, '1.10.287.70-FF-000508', NULL, 'Uncharacterized protein', 146, NULL, NULL, 127592),
(127593, '1.10.510.10-FF-000848', NULL, 'Uncharacterized protein', 167, NULL, NULL, 127593),
(127594, '1.10.210.20-FF-000002', NULL, '1H-3-hydroxy-4-oxoquinoline 2,4-dioxygenase', 69, NULL, NULL, 127594),
(127595, '1.25.40.10-FF-002638', NULL, 'Im:7136784 protein', 342, NULL, NULL, 127595),
(127596, '3.20.20.10-FF-000007', NULL, 'Pyridoxal phosphate homeostasis protein', 249, NULL, NULL, 127596),
(127597, '1.25.40.20-FF-000230', NULL, 'transient receptor potential cation channel subfamily V member 6', 77, NULL, NULL, 127597),
(127598, '2.30.31.10-FF-000006', NULL, 'Putative RNA polymerase II transcriptional coactivator', 79, NULL, NULL, 127598),
(127599, '3.40.50.10330-FF-000083', NULL, 'NAD kinase', 93, NULL, NULL, 127599),
(127600, '3.40.1110.10-FF-000027', NULL, 'Cation-transporting ATPase', 185, NULL, NULL, 127600),
(127601, '1.10.510.10-FF-003119', NULL, NULL, 190, NULL, NULL, 127601),
(127602, '3.40.50.1820-FF-000722', NULL, 'Carboxylic ester hydrolase', 245, NULL, NULL, 127602),
(127603, '1.10.630.10-FF-000323', NULL, 'Cytochrome P450 71B10', 398, NULL, NULL, 127603),
(127604, '1.20.1560.10-FF-000657', NULL, 'Uncharacterized protein', 93, NULL, NULL, 127604),
(127605, '3.30.450.20-FF-000019', NULL, 'Aryl hydrocarbon receptor 1', 117, NULL, NULL, 127605),
(127606, '3.40.50.1820-FF-000953', NULL, 'Uncharacterized protein', 294, NULL, NULL, 127606),
(127607, '3.40.50.200-FF-000154', NULL, 'Subtilisin-like serine peptidase', 312, NULL, NULL, 127607),
(127608, '1.10.30.10-FF-000142', NULL, 'PMS1 homolog 1, mismatch repair system component', 88, NULL, NULL, 127608),
(127609, '1.20.1740.10-FF-000047', NULL, 'Amino acid transporter AVT1A', 389, NULL, NULL, 127609),
(127610, '1.20.120.1080-FF-000070', NULL, 'ATP-dependent RNA helicase DQX1 isoform X1', 101, NULL, NULL, 127610),
(127611, '3.30.60.270-FF-000021', NULL, 'Uncharacterized protein', 77, NULL, NULL, 127611),
(127612, '3.20.70.20-FF-000041', NULL, 'Ribonucleotide reductase catalytic subunit M1', 117, NULL, NULL, 127612),
(127613, '1.20.1250.20-FF-001620', NULL, 'Uncharacterized protein', 152, NULL, NULL, 127613),
(127614, '1.25.40.10-FF-001913', NULL, 'Pentatricopeptide repeat-containing protein', 136, NULL, NULL, 127614),
(127615, '2.60.120.10-FF-000314', NULL, 'Cyclic nucleotide dependent protein kinase', 141, NULL, NULL, 127615),
(127616, '3.30.70.330-FF-002464', NULL, NULL, 82, NULL, NULL, 127616),
(127617, '3.90.550.10-FF-000140', NULL, 'Procollagen-lysine,2-oxoglutarate 5-dioxygenase 2', 206, NULL, NULL, 127617),
(127618, '2.40.128.620-FF-000008', NULL, 'Uncharacterized protein', 77, NULL, NULL, 127618),
(127619, '2.70.170.10-FF-000091', NULL, 'Gamma-aminobutyric acid type A receptor alpha2 subunit', 130, NULL, NULL, 127619),
(127620, '3.40.30.10-FF-001176', NULL, 'Uncharacterized protein', 128, NULL, NULL, 127620),
(127621, '1.25.40.20-FF-001450', NULL, 'AGAP001061-PB', 132, NULL, NULL, 127621),
(127622, '3.60.40.10-FF-000091', NULL, 'Stage II sporulation protein E', 252, NULL, NULL, 127622),
(127623, '2.40.50.510-FF-000003', NULL, 'Predicted protein', 96, NULL, NULL, 127623),
(127624, '3.80.10.10-FF-004371', NULL, 'Uncharacterized protein', 173, NULL, NULL, 127624),
(127625, '2.60.220.50-FF-000025', NULL, 'Adhesion G protein-coupled receptor G7', 188, NULL, NULL, 127625),
(127626, '2.40.50.100-FF-000217', NULL, 'Sugar ABC transportor, ATP-binding protein', 37, NULL, NULL, 127626),
(127627, '2.40.30.10-FF-000138', NULL, 'Eukaryotic peptide chain release factor GTP-binding subunit', 110, NULL, NULL, 127627),
(127628, '3.40.1090.10-FF-000002', NULL, 'Phospholipase A2', 507, NULL, NULL, 127628),
(127629, '1.10.10.10-FF-001293', NULL, 'Putative zinc-dependent repressor ZntR, DtxR superfamily', 131, NULL, NULL, 127629),
(127630, '2.40.20.10-FF-000003', NULL, 'Inactive tyrosine-protein kinase transmembrane receptor ROR1', 97, NULL, NULL, 127630),
(127631, '3.30.70.330-FF-001952', NULL, NULL, 78, NULL, NULL, 127631),
(127632, '3.30.200.20-FF-001597', NULL, 'Receptor-like serine/threonine-protein kinase SD1-8', 129, NULL, NULL, 127632);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(127633, '1.20.1280.50-FF-000147', NULL, 'Os05g0139300 protein', 55, NULL, NULL, 127633),
(127634, '3.30.9.10-FF-000177', NULL, 'FAD dependent oxidoreductase', 156, NULL, NULL, 127634),
(127635, '1.10.472.80-FF-000032', NULL, 'TBC1 domain family member 24 isoform X1', 150, NULL, NULL, 127635),
(127636, '2.40.70.10-FF-000028', NULL, 'Eukaryotic aspartyl protease family protein', 194, NULL, NULL, 127636),
(127637, '3.30.230.10-FF-000275', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 159, NULL, NULL, 127637),
(127638, '1.10.8.10-FF-000252', NULL, 'inhibitor of apoptosis protein isoform X1', 64, NULL, NULL, 127638),
(127639, '2.60.120.10-FF-000005', NULL, 'Germin-like protein subfamily 1 member 8', 198, NULL, NULL, 127639),
(127640, '3.40.50.800-FF-000108', NULL, 'AER105Wp', 122, NULL, NULL, 127640),
(127641, '3.10.129.10-FF-000229', NULL, 'Acyl-CoA thioesterase 12', 93, NULL, NULL, 127641),
(127642, '3.10.20.90-FF-000823', NULL, 'Predicted protein', 108, NULL, NULL, 127642),
(127643, '2.130.10.10-FF-003359', NULL, 'Apoptotic protease-activating factor, putative', 223, NULL, NULL, 127643),
(127644, '2.60.120.920-FF-000073', NULL, 'Butyrophilin like 3', 187, NULL, NULL, 127644),
(127645, '3.30.40.10-FF-001290', NULL, 'Uncharacterized protein', 79, NULL, NULL, 127645),
(127646, '4.10.1080.10-FF-000002', NULL, 'Thrombospondin 3', 71, NULL, NULL, 127646),
(127647, '2.60.40.10-FF-003235', NULL, 'Erythropoietin receptor', 95, NULL, NULL, 127647),
(127648, '3.30.40.10-FF-000890', NULL, 'PHD finger protein EHD3', 61, NULL, NULL, 127648),
(127649, '2.40.50.140-FF-000875', NULL, NULL, 91, NULL, NULL, 127649),
(127650, '3.40.50.880-FF-000205', NULL, 'Uncharacterized protein', 223, NULL, NULL, 127650),
(127651, '1.20.5.170-FF-000274', NULL, 'Uncharacterized protein', 67, NULL, NULL, 127651),
(127652, '2.60.40.10-FF-001453', NULL, 'Turtle, isoform G', 100, NULL, NULL, 127652),
(127653, '4.10.110.10-FF-000008', NULL, 'mucin-5AC isoform X3', 53, NULL, NULL, 127653),
(127654, '3.30.200.20-FF-001288', NULL, 'Spore coat protein', 100, NULL, NULL, 127654),
(127655, '1.25.10.10-FF-001400', NULL, 'Protein VAC14 homolog-like Protein', 255, NULL, NULL, 127655),
(127656, '3.40.50.10470-FF-000017', NULL, 'eIF2B 34 kDa alpha subunit', 200, NULL, NULL, 127656),
(127657, '3.40.1030.10-FF-000010', NULL, 'Anthranilate phosphoribosyltransferase', 263, NULL, NULL, 127657),
(127658, '3.30.160.60-FF-000014', NULL, 'Transcription factor Sp3', 31, NULL, NULL, 127658),
(127659, '3.40.50.300-FF-007344', NULL, 'RNA helicase, putative', 240, NULL, NULL, 127659),
(127660, '1.20.1560.10-FF-000876', NULL, 'Predicted protein', 69, NULL, NULL, 127660),
(127661, '1.20.5.270-FF-000006', NULL, 'Cytochrome b-c1 complex subunit Rieske, mitochondrial', 59, NULL, NULL, 127661),
(127662, '1.10.510.10-FF-004182', NULL, NULL, 95, NULL, NULL, 127662),
(127663, '3.40.120.10-FF-000124', NULL, 'Uncharacterized protein', 167, NULL, NULL, 127663),
(127664, '1.10.150.80-FF-000026', NULL, 'ATP-dependent DEAD/H DNA helicase recQ, putative', 84, NULL, NULL, 127664),
(127665, '4.10.280.110-FF-000003', NULL, 'Pre-mRNA splicing factor, variant', 72, NULL, NULL, 127665),
(127666, '1.10.238.10-FF-000552', NULL, 'Probable mitochondrial carrier protein ARALAR1', 134, NULL, NULL, 127666),
(127667, '2.40.50.690-FF-000012', NULL, 'DIS3-like exonuclease 2', 89, NULL, NULL, 127667),
(127668, '1.25.40.120-FF-000036', NULL, 'GM18897', 238, NULL, NULL, 127668),
(127669, '2.60.40.10-FF-002982', NULL, 'Uncharacterized protein', 128, NULL, NULL, 127669),
(127670, '3.40.50.720-FF-001057', NULL, 'Pyrroline-5-carboxylate reductase', 148, NULL, NULL, 127670),
(127671, '1.25.40.10-FF-003566', NULL, 'Tetratricopeptide repeat protein 21B', 235, NULL, NULL, 127671),
(127672, '3.90.70.10-FF-000552', NULL, 'Uncharacterized protein', 249, NULL, NULL, 127672),
(127673, '3.90.190.10-FF-000584', NULL, 'Si:ch1073-391i24.1', 114, NULL, NULL, 127673),
(127674, '3.40.50.1000-FF-000224', NULL, 'Hydrolase, haloacid dehalogenase-like family', 101, NULL, NULL, 127674),
(127675, '1.20.1250.20-FF-002345', NULL, 'Solute carrier organic anion transporter family member', 200, NULL, NULL, 127675);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(127676, '3.40.390.10-FF-000054', NULL, 'Blast:Endothelin-converting enzyme 1', 274, NULL, NULL, 127676),
(127677, '3.50.30.10-FF-000001', NULL, 'Phosphoenolpyruvate-protein phosphotransferase', 106, NULL, NULL, 127677),
(127678, '3.40.50.300-FF-003634', NULL, 'Os11g0649000 protein', 327, NULL, NULL, 127678),
(127679, '3.30.810.10-FF-000005', NULL, 'Phosphatidylinositol 4-phosphate 5-kinase', 179, NULL, NULL, 127679),
(127680, '2.60.40.1180-FF-000009', NULL, 'Alpha-mannosidase', 115, NULL, NULL, 127680),
(127681, '2.170.130.20-FF-000005', NULL, 'Multidomain scavenger receptor', 105, NULL, NULL, 127681),
(127682, '3.30.930.10-FF-000261', NULL, 'Phenylalanine--tRNA ligase alpha subunit', 334, NULL, NULL, 127682),
(127683, '2.10.220.10-FF-000075', NULL, 'Fraser extracellular matrix complex subunit 1', 58, NULL, NULL, 127683),
(127684, '1.25.40.180-FF-000155', NULL, 'Nonsense-mediated mRNA decay protein 2', 334, NULL, NULL, 127684),
(127685, '1.10.472.10-FF-000394', NULL, 'Uncharacterized protein', 108, NULL, NULL, 127685),
(127686, '3.30.70.330-FF-001391', NULL, 'Cytoplasmic polyadenylation element-binding protein 1', 101, NULL, NULL, 127686),
(127687, '1.20.1310.20-FF-000041', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 180, NULL, NULL, 127687),
(127688, '3.30.470.20-FF-000127', NULL, 'ATP-citrate synthase alpha chain protein 3', 49, NULL, NULL, 127688),
(127689, '1.25.40.10-FF-000929', NULL, 'Uncharacterized protein', 97, NULL, NULL, 127689),
(127690, '3.40.50.300-FF-003073', NULL, 'Lipopolysaccharide biosynthesis protein', 194, NULL, NULL, 127690),
(127691, '4.10.60.10-FF-000249', NULL, 'Rothmund-thomson syndrome DNA helicase recq4, putative', 48, NULL, NULL, 127691),
(127692, '3.40.50.2300-FF-001468', NULL, NULL, 213, NULL, NULL, 127692),
(127693, '1.10.555.10-FF-000002', NULL, 'rho GTPase-activating protein 32 isoform X1', 207, NULL, NULL, 127693),
(127694, '2.60.120.920-FF-000106', NULL, 'Ring finger protein 123', 96, NULL, NULL, 127694),
(127695, '1.25.40.10-FF-003257', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 161, NULL, NULL, 127695),
(127696, '1.10.220.10-FF-000040', NULL, 'Annexin', 60, NULL, NULL, 127696),
(127697, '1.10.10.10-FF-001304', NULL, 'Transcriptional regulatory protein', 86, NULL, NULL, 127697),
(127698, '3.90.550.50-FF-000101', NULL, 'Hexosyltransferase', 229, NULL, NULL, 127698),
(127699, '3.40.30.10-FF-000226', NULL, 'Thioredoxin domain containing 16', 108, NULL, NULL, 127699),
(127700, '3.30.160.60-FF-003139', NULL, 'Zinc finger protein 1144', 25, NULL, NULL, 127700),
(127701, '3.40.710.10-FF-000141', NULL, 'D-alanyl-D-alanine carboxypeptidase', 282, NULL, NULL, 127701),
(127702, '3.40.50.1010-FF-000013', NULL, 'Constitutive coactivator of peroxisome proliferator-activated receptor gamma', 204, NULL, NULL, 127702),
(127703, '2.40.40.20-FF-000007', NULL, 'AAA family ATPase', 88, NULL, NULL, 127703),
(127704, '1.10.472.80-FF-000246', NULL, NULL, 126, NULL, NULL, 127704),
(127705, '1.20.1560.10-FF-000168', NULL, 'ABC transporter ATP-binding protein/permease', 302, NULL, NULL, 127705),
(127706, '2.60.40.10-FF-005505', NULL, NULL, 86, NULL, NULL, 127706),
(127707, '2.60.40.10-FF-001998', NULL, 'Unc-89 protein', 96, NULL, NULL, 127707),
(127708, '1.25.10.10-FF-003165', NULL, 'Uncharacterized protein', 352, NULL, NULL, 127708),
(127709, '3.90.70.10-FF-000243', NULL, 'Ubiquitin carboxyl-terminal hydrolase, putative', 360, NULL, NULL, 127709),
(127710, '3.90.640.10-FF-000219', NULL, 'Actin-related protein 10', 76, NULL, NULL, 127710),
(127711, '3.40.50.300-FF-000414', NULL, 'ATP-dependent RNA helicase DHX30 isoform X1', 208, NULL, NULL, 127711),
(127712, '3.80.10.10-FF-001712', NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', 175, NULL, NULL, 127712),
(127713, '3.40.50.410-FF-000099', NULL, 'Yku70p', 232, NULL, NULL, 127713),
(127714, '2.60.120.200-FF-000553', NULL, 'Uncharacterized protein', 94, NULL, NULL, 127714),
(127715, '3.40.1110.10-FF-000483', NULL, NULL, 233, NULL, NULL, 127715),
(127716, '3.30.160.60-FF-002830', NULL, 'Zinc finger protein ZAT11', 73, NULL, NULL, 127716);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(127717, '1.10.730.10-FF-000123', NULL, 'Leucine--tRNA ligase', 114, NULL, NULL, 127717),
(127718, '1.10.238.10-FF-001171', NULL, 'Secreted protein, acidic, cysteine-rich (osteonectin)', 95, NULL, NULL, 127718),
(127719, '3.30.70.330-FF-000772', NULL, 'Putative RNA binding ribonucleoprotein', 174, NULL, NULL, 127719),
(127720, '1.25.40.470-FF-000012', NULL, 'intraflagellar transport protein 172 homolog', 176, NULL, NULL, 127720),
(127721, '1.20.5.350-FF-000019', NULL, NULL, 128, NULL, NULL, 127721),
(127722, '3.90.1150.10-FF-000086', NULL, 'Putative acetylornithine aminotransferase', 139, NULL, NULL, 127722),
(127723, '3.30.70.1230-FF-000245', NULL, 'Atrial natriuretic peptide receptor, putative', 40, NULL, NULL, 127723),
(127724, '3.20.20.140-FF-000168', NULL, 'Predicted metal-dependent hydrolase, TIM-barrel fold', 276, NULL, NULL, 127724),
(127725, '3.40.50.11260-FF-000035', NULL, 'Uncharacterized protein', 52, NULL, NULL, 127725),
(127726, '3.10.110.10-FF-000102', NULL, 'Os02g0721100 protein', 155, NULL, NULL, 127726),
(127727, '2.30.39.10-FF-000018', NULL, 'Angiotensinogen', 142, NULL, NULL, 127727),
(127728, '3.30.450.20-FF-000480', NULL, 'Uncharacterized protein', 146, NULL, NULL, 127728),
(127729, '2.60.40.640-FF-000092', NULL, 'Uncharacterized protein', 143, NULL, NULL, 127729),
(127730, '1.10.1870.10-FF-000020', NULL, 'Predicted protein', 28, NULL, NULL, 127730),
(127731, '3.30.559.10-FF-000268', NULL, 'Uncharacterized protein', 170, NULL, NULL, 127731),
(127732, '1.20.1070.10-FF-001266', NULL, 'low-density lipoprotein receptor-related protein 2-like', 218, NULL, NULL, 127732),
(127733, '1.10.10.60-FF-000785', NULL, NULL, 65, NULL, NULL, 127733),
(127734, '3.30.70.270-FF-000276', NULL, NULL, 119, NULL, NULL, 127734),
(127735, '3.40.50.300-FF-001847', NULL, 'ABC transporter, putative', 239, NULL, NULL, 127735),
(127736, '1.20.90.10-FF-000055', NULL, NULL, 61, NULL, NULL, 127736),
(127737, '2.70.98.20-FF-000026', NULL, 'Amine oxidase', 325, NULL, NULL, 127737),
(127738, '2.60.120.480-FF-000007', NULL, 'Ureidoglycolate hydrolase', 238, NULL, NULL, 127738),
(127739, '3.40.1550.10-FF-000010', NULL, 'Chemotaxis protein CheX', 152, NULL, NULL, 127739),
(127740, '3.30.70.370-FF-000008', NULL, 'DNA polymerase nu', 140, NULL, NULL, 127740),
(127741, '1.10.238.10-FF-000895', NULL, 'Uncharacterized protein', 153, NULL, NULL, 127741),
(127742, '3.40.605.10-FF-000099', NULL, 'Uncharacterized protein', 151, NULL, NULL, 127742),
(127743, '3.40.50.300-FF-004253', NULL, 'Spermatogenesis-associated 5', 165, NULL, NULL, 127743),
(127744, '2.40.50.140-FF-000566', NULL, 'Unplaced genomic scaffold supercont1.10, whole genome shotgun sequence', 88, NULL, NULL, 127744),
(127745, '3.90.730.10-FF-000013', NULL, 'Ribonuclease T', 192, NULL, NULL, 127745),
(127746, '3.40.50.150-FF-000352', NULL, 'tRNA (guanine-N(7)-)-methyltransferase', 224, NULL, NULL, 127746),
(127747, '1.10.400.10-FF-000059', NULL, 'AGAP005773-PA', 121, NULL, NULL, 127747),
(127748, '1.10.1200.270-FF-000018', NULL, 'S-adenosyl-L-methionine-dependent methyltransferases superfamily protein', 142, NULL, NULL, 127748),
(127749, '2.60.40.1730-FF-000074', NULL, NULL, 147, NULL, NULL, 127749),
(127750, '3.30.460.10-FF-000079', NULL, 'PAP-associated domain containing protein', 105, NULL, NULL, 127750),
(127751, '1.20.5.170-FF-000089', NULL, 'Putative global transcription activator SNF2L2', 76, NULL, NULL, 127751),
(127752, '3.40.50.1440-FF-000024', NULL, 'Tubulin alpha chain', 128, NULL, NULL, 127752),
(127753, '1.20.58.1210-FF-000005', NULL, 'EXOCyst component', 116, NULL, NULL, 127753),
(127754, '1.20.1250.20-FF-002093', NULL, 'Uncharacterized protein', 257, NULL, NULL, 127754),
(127755, '2.130.10.10-FF-003578', NULL, 'Regulatory-associated protein of TOR 1', 156, NULL, NULL, 127755),
(127756, '3.30.40.10-FF-000901', NULL, 'RING finger protein B', 61, NULL, NULL, 127756),
(127757, '3.80.10.10-FF-000329', NULL, 'Tonsoku like, DNA repair protein', 99, NULL, NULL, 127757),
(127758, '1.25.40.70-FF-000020', NULL, 'Phosphatidylinositol 4-kinase', 118, NULL, NULL, 127758);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(127759, '3.90.930.1-FF-000005', NULL, NULL, 80, NULL, NULL, 127759),
(127760, '2.60.40.10-FF-000273', NULL, 'contactin-3 isoform X1', 92, NULL, NULL, 127760),
(127761, '3.40.50.300-FF-005742', NULL, 'ATP-dependent nuclease subunit A', 146, NULL, NULL, 127761),
(127762, '3.30.160.60-FF-004775', NULL, NULL, 33, NULL, NULL, 127762),
(127763, '2.170.300.10-FF-000049', NULL, 'Adhesion G protein-coupled receptor L3', 112, NULL, NULL, 127763),
(127764, '3.30.300.10-FF-000051', NULL, 'S-adenosylmethionine synthase', 124, NULL, NULL, 127764),
(127765, '3.30.200.20-FF-001524', NULL, 'Cyclin-dependent kinase G-1', 80, NULL, NULL, 127765),
(127766, '3.30.70.260-FF-000178', NULL, 'Aspartokinase 1 chloroplastic', 31, NULL, NULL, 127766),
(127767, '1.25.40.90-FF-000026', NULL, 'RNA binding protein Nrd1', 160, NULL, NULL, 127767),
(127768, '1.20.120.1240-FF-000045', NULL, 'Dynamin-related protein,putative', 262, NULL, NULL, 127768),
(127769, '3.40.50.720-FF-000309', NULL, 'synaptic vesicle membrane protein VAT-1 homolog', 146, NULL, NULL, 127769),
(127770, '1.20.1560.10-FF-000404', NULL, 'ABC transporter protein AtrC', 33, NULL, NULL, 127770),
(127771, '2.80.10.50-FF-000243', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 83, NULL, NULL, 127771),
(127772, '2.10.25.10-FF-001050', NULL, 'Uncharacterized protein', 77, NULL, NULL, 127772),
(127773, '3.30.160.60-FF-001341', NULL, 'Zinc finger and SCAN domain containing 10', 30, NULL, NULL, 127773),
(127774, '2.130.10.10-FF-001633', NULL, 'Chromosome transmission fidelity 4', 184, NULL, NULL, 127774),
(127775, '1.10.630.10-FF-000632', NULL, 'Uncharacterized protein', 227, NULL, NULL, 127775),
(127776, '2.130.10.10-FF-000796', NULL, 'Splicing factor 3B subunit 3', 326, NULL, NULL, 127776),
(127777, '3.40.50.720-FF-001602', NULL, 'NT5C1B-RDH14 readthrough', 166, NULL, NULL, 127777),
(127778, '3.40.1280.30-FF-000023', NULL, 'Uncharacterized protein', 195, NULL, NULL, 127778),
(127779, '3.40.50.150-FF-001313', NULL, NULL, 297, NULL, NULL, 127779),
(127780, '3.40.50.970-FF-000154', NULL, 'Predicted protein', 277, NULL, NULL, 127780),
(127781, '1.10.390.10-FF-000063', NULL, 'Uncharacterized protein', 30, NULL, NULL, 127781),
(127782, '3.40.190.10-FF-000179', NULL, 'Glycine/betaine ABC transporter substrate-binding protein', 154, NULL, NULL, 127782),
(127783, '1.10.560.10-FF-000076', NULL, 'T-complex protein 1 subunit gamma', 118, NULL, NULL, 127783),
(127784, '1.25.40.20-FF-001085', NULL, 'Kinase, NEK', 104, NULL, NULL, 127784),
(127785, '4.10.900.10-FF-000024', NULL, 'Uncharacterized protein', 89, NULL, NULL, 127785),
(127786, '1.50.40.10-FF-000540', NULL, 'Uncharacterized protein', 149, NULL, NULL, 127786),
(127787, '3.15.20.10-FF-000014', NULL, 'Lipid-binding serum glycoprotein family protein', 251, NULL, NULL, 127787),
(127788, '2.40.10.10-FF-000362', NULL, 'Coagulation factor VII', 243, NULL, NULL, 127788),
(127789, '1.10.10.790-FF-000005', NULL, 'Splicing factor, suppressor of white-apricot homolog', 59, NULL, NULL, 127789),
(127790, '3.30.1360.70-FF-000009', NULL, 'Arginine-tRNA ligase', 110, NULL, NULL, 127790),
(127791, '2.30.29.30-FF-000147', NULL, 'SH3 domain-binding protein 2 isoform X2', 115, NULL, NULL, 127791),
(127792, '3.40.50.2000-FF-000878', NULL, 'Glycosyl transferase, group 1 family protein', 190, NULL, NULL, 127792),
(127793, '3.40.50.10140-FF-000014', NULL, 'TIR domain-containing adapter molecule 2', 158, NULL, NULL, 127793),
(127794, '3.40.630.10-FF-000298', NULL, 'Predicted protein', 287, NULL, NULL, 127794),
(127795, '3.30.530.20-FF-000205', NULL, 'Predicted protein', 223, NULL, NULL, 127795),
(127796, '3.40.50.450-FF-000009', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit alpha', 292, NULL, NULL, 127796),
(127797, '1.20.1270.140-FF-000001', NULL, 'Type III effector protein AvrPto1', 101, NULL, NULL, 127797),
(127798, '3.40.50.300-FF-002123', NULL, 'ATP-binding cassette bilirubin transporter', 276, NULL, NULL, 127798),
(127799, '3.30.200.20-FF-001833', NULL, 'Putative muscle m-line assembly protein unc-89', 116, NULL, NULL, 127799);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(127800, '3.40.50.12550-FF-000001', NULL, 'Ubiquitin-activating enzyme E1 1', 207, NULL, NULL, 127800),
(127801, '3.30.450.40-FF-000014', NULL, 'Phosphodiesterase', 174, NULL, NULL, 127801),
(127802, '1.10.1070.11-FF-000140', NULL, 'Uncharacterized protein', 85, NULL, NULL, 127802),
(127803, '3.40.190.10-FF-000634', NULL, 'Transcriptional regulator, LysR family', 87, NULL, NULL, 127803),
(127804, '3.80.10.10-FF-002893', NULL, 'Uncharacterized protein', 72, NULL, NULL, 127804),
(127805, '3.40.140.10-FF-000232', NULL, 'Uncharacterized protein', 167, NULL, NULL, 127805),
(127806, '2.70.150.10-FF-000016', NULL, 'Calcium-transporting P-type ATPase putative', 157, NULL, NULL, 127806),
(127807, '2.60.120.260-FF-000200', NULL, 'Beta-mannosidase A', 200, NULL, NULL, 127807),
(127808, '3.40.50.300-FF-005557', NULL, 'Protein SMAX1-LIKE 5', 257, NULL, NULL, 127808),
(127809, '1.10.510.10-FF-002613', NULL, NULL, 138, NULL, NULL, 127809),
(127810, '3.30.160.60-FF-006012', NULL, NULL, 34, NULL, NULL, 127810),
(127811, '2.130.10.10-FF-001780', NULL, 'Cirrhosis, autosomal recessive 1A (Cirhin)', 165, NULL, NULL, 127811),
(127812, '3.30.2130.10-FF-000014', NULL, 'Aspartate kinase, monofunctional class', 164, NULL, NULL, 127812),
(127813, '2.130.10.10-FF-001105', NULL, 'WD40-repeat-containing domain protein', 246, NULL, NULL, 127813),
(127814, '1.20.1530.20-FF-000113', NULL, 'K(+) efflux antiporter 3 chloroplastic', 124, NULL, NULL, 127814),
(127815, '3.40.366.10-FF-000037', NULL, 'Malonyl CoA-acyl carrier protein transacylase', 208, NULL, NULL, 127815),
(127816, '3.80.10.10-FF-001965', NULL, 'F-box/LRR-repeat protein At3g48880', 184, NULL, NULL, 127816),
(127817, '3.40.50.720-FF-000438', NULL, 'Os06g0299100 protein', 244, NULL, NULL, 127817),
(127818, '3.30.110.20-FF-000005', NULL, 'Uncharacterized protein At2g34160', 112, NULL, NULL, 127818),
(127819, '1.20.58.2220-FF-000011', NULL, 'Inverted formin, FH2 and WH2 domain containing', 382, NULL, NULL, 127819),
(127820, '1.10.8.60-FF-000166', NULL, 'DNA polymerase III subunit gamma/tau', 62, NULL, NULL, 127820),
(127821, '1.10.196.10-FF-000015', NULL, 'Axin-1', 33, NULL, NULL, 127821),
(127822, '1.20.1640.10-FF-000006', NULL, 'Protein-export membrane protein SecF', 202, NULL, NULL, 127822),
(127823, '1.20.58.340-FF-000038', NULL, 'Magnesium transporter MRS2-C', 189, NULL, NULL, 127823),
(127824, '2.60.40.60-FF-000838', NULL, 'Uncharacterized protein', 106, NULL, NULL, 127824),
(127825, '2.30.29.30-FF-001131', NULL, 'Uncharacterized protein', 121, NULL, NULL, 127825),
(127826, '3.40.50.300-FF-000178', NULL, 'Arf-GAP with GTPase, ANK repeat and PH domain-containing protein 1', 181, NULL, NULL, 127826),
(127827, '3.40.50.300-FF-000886', NULL, 'Putative GTP-binding protein 6', 167, NULL, NULL, 127827),
(127828, '3.30.40.10-FF-002138', NULL, 'Predicted protein', 88, NULL, NULL, 127828),
(127829, '3.40.50.300-FF-007996', NULL, 'Uncharacterized protein', 153, NULL, NULL, 127829),
(127830, '3.40.50.720-FF-000984', NULL, 'Dihydroflavonol 4-reductase family', 327, NULL, NULL, 127830),
(127831, '1.25.40.10-FF-001677', NULL, 'Putative pentatricopeptide repeat-containing protein At3g49142', 116, NULL, NULL, 127831),
(127832, '2.60.40.10-FF-003454', NULL, NULL, 102, NULL, NULL, 127832),
(127833, '1.20.1730.10-FF-000018', NULL, 'Transporter, SSS family', 544, NULL, NULL, 127833),
(127834, '2.10.270.10-FF-000005', NULL, 'Lysozyme', 82, NULL, NULL, 127834),
(127835, '3.40.50.150-FF-000661', NULL, 'NOL1/NOP2/sun family, putative', 243, NULL, NULL, 127835),
(127836, '2.130.10.10-FF-001414', NULL, 'Enhancer of mRNA-decapping protein 4 homolog', 382, NULL, NULL, 127836),
(127837, '3.30.43.10-FF-000054', NULL, 'Xanthine dehydrogenase, A subunit', 48, NULL, NULL, 127837),
(127838, '1.10.3810.10-FF-000011', NULL, 'Transglycosylase', 158, NULL, NULL, 127838),
(127839, '3.30.1140.32-FF-000023', NULL, '40S ribosomal protein S3-1', 50, NULL, NULL, 127839),
(127840, '2.40.30.10-FF-000032', NULL, 'NADH-cytochrome b5 reductase', 100, NULL, NULL, 127840),
(127841, '3.30.160.60-FF-001650', NULL, 'zinc finger protein 524', 29, NULL, NULL, 127841);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(127842, '3.80.10.10-FF-002218', NULL, 'Uncharacterized protein', 143, NULL, NULL, 127842),
(127843, '3.30.200.20-FF-000669', NULL, 'Inactive leucine-rich repeat receptor-like protein kinase CORYNE', 92, NULL, NULL, 127843),
(127844, '1.10.8.60-FF-000019', NULL, 'AFG3-like AAA ATPase 2', 77, NULL, NULL, 127844),
(127845, '1.20.900.10-FF-000123', NULL, 'Uncharacterized protein', 233, NULL, NULL, 127845),
(127846, '3.40.50.300-FF-004562', NULL, 'Uncharacterized protein', 125, NULL, NULL, 127846),
(127847, '3.40.50.150-FF-000133', NULL, '2-methoxy-6-polyprenyl-1,4-benzoquinol methylase, mitochondrial', 242, NULL, NULL, 127847),
(127848, '1.10.238.260-FF-000006', NULL, 'Homocitrate synthase', 118, NULL, NULL, 127848),
(127849, '2.30.30.100-FF-000070', NULL, 'Small nuclear ribonucleoprotein F', 83, NULL, NULL, 127849),
(127850, '1.20.1250.20-FF-000979', NULL, 'Major facilitator superfamily domain-containing protein', 192, NULL, NULL, 127850),
(127851, '2.30.29.30-FF-000512', NULL, 'Dynein beta chain', 121, NULL, NULL, 127851),
(127852, '1.20.1510.10-FF-000002', NULL, 'zinc transporter 3 isoform X1', 207, NULL, NULL, 127852),
(127853, '3.30.70.1400-FF-000009', NULL, 'Aminomethyltransferase', 89, NULL, NULL, 127853),
(127854, '2.40.170.20-FF-000044', NULL, 'SusC homolog', 554, NULL, NULL, 127854),
(127855, '1.10.510.10-FF-001776', NULL, 'Predicted protein', 170, NULL, NULL, 127855),
(127856, '1.10.8.270-FF-000115', NULL, 'Plant adhesion molecule 1', 106, NULL, NULL, 127856),
(127857, '3.30.870.10-FF-000110', NULL, 'PhosphoLipase D', 227, NULL, NULL, 127857),
(127858, '3.30.70.100-FF-000068', NULL, 'V-type proton ATPase subunit C', 99, NULL, NULL, 127858),
(127859, '3.90.230.10-FF-000065', NULL, NULL, 142, NULL, NULL, 127859),
(127860, '1.25.10.10-FF-000759', NULL, 'AGAP007568-PA', 365, NULL, NULL, 127860),
(127861, '1.20.91.10-FF-000001', NULL, 'Matrix protein 1', 79, NULL, NULL, 127861),
(127862, '3.30.710.10-FF-000278', NULL, 'Uncharacterized protein', 99, NULL, NULL, 127862),
(127863, '2.40.50.90-FF-000034', NULL, 'Unplaced genomic scaffold supercont1.17, whole genome shotgun sequence', 176, NULL, NULL, 127863),
(127864, '3.80.10.10-FF-001257', NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', 162, NULL, NULL, 127864),
(127865, '3.40.1390.30-FF-000014', NULL, 'GTP cyclohydrolase 1 type 2 homolog', 127, NULL, NULL, 127865),
(127866, '1.10.287.3490-FF-000007', NULL, 'Mediator of RNA polymerase II transcription subunit 11', 112, NULL, NULL, 127866),
(127867, '1.10.3730.20-FF-000070', NULL, 'Uncharacterized protein', 79, NULL, NULL, 127867),
(127868, '3.30.160.60-FF-006321', NULL, NULL, 27, NULL, NULL, 127868),
(127869, '3.80.10.10-FF-003202', NULL, 'Uncharacterized protein', 225, NULL, NULL, 127869),
(127870, '2.30.30.90-FF-000011', NULL, 'Metalloregulator ScaR', 75, NULL, NULL, 127870),
(127871, '3.40.50.620-FF-000178', NULL, 'YdcF family protein', 155, NULL, NULL, 127871),
(127872, '3.30.450.20-FF-000351', NULL, 'Two-component sensor histidine kinase', 130, NULL, NULL, 127872),
(127873, '3.90.228.10-FF-000048', NULL, 'Predicted protein', 148, NULL, NULL, 127873),
(127874, '3.30.70.660-FF-000067', NULL, 'tRNA pseudouridine synthase', 168, NULL, NULL, 127874),
(127875, '2.60.120.200-FF-000188', NULL, 'Os08g0124000 protein', 247, NULL, NULL, 127875),
(127876, '1.20.5.110-FF-000077', NULL, 'Putative SNARE protein', 84, NULL, NULL, 127876),
(127877, '1.20.1250.20-FF-001165', NULL, 'Uncharacterized protein', 218, NULL, NULL, 127877),
(127878, '2.10.60.10-FF-000001', NULL, 'Receptor protein serine/threonine kinase', 98, NULL, NULL, 127878),
(127879, '2.130.10.10-FF-003887', NULL, 'Predicted protein', 275, NULL, NULL, 127879),
(127880, '3.30.830.10-FF-000332', NULL, 'Protein CBG17023', 120, NULL, NULL, 127880),
(127881, '3.50.50.60-FF-000438', NULL, 'Oxidoreductase', 170, NULL, NULL, 127881),
(127882, '3.40.50.1240-FF-000189', NULL, NULL, 69, NULL, NULL, 127882),
(127883, '1.10.418.10-FF-000206', NULL, 'Uncharacterized protein', 115, NULL, NULL, 127883),
(127884, '3.40.50.1820-FF-001195', NULL, 'Uncharacterized protein', 167, NULL, NULL, 127884);
INSERT INTO "PUBLIC"."MODEL" VALUES
(127885, '3.40.50.300-FF-001504', NULL, 'RuvB-like helicase', 245, NULL, NULL, 127885),
(127886, '3.10.50.40-FF-000097', NULL, 'Peptidylprolyl isomerase', 109, NULL, NULL, 127886),
(127887, '2.10.25.10-FF-000228', NULL, 'agrin isoform X1', 40, NULL, NULL, 127887),
(127888, '2.60.40.10-FF-004415', NULL, NULL, 98, NULL, NULL, 127888),
(127889, '1.20.1270.10-FF-000090', NULL, 'Heat shock 70 kDa protein A', 74, NULL, NULL, 127889),
(127890, '3.30.160.60-FF-005028', NULL, NULL, 62, NULL, NULL, 127890),
(127891, '2.10.90.10-FF-000172', NULL, 'Transforming growth factor, beta 2', 49, NULL, NULL, 127891),
(127892, '1.10.246.130-FF-000024', NULL, NULL, 107, NULL, NULL, 127892),
(127893, '3.40.50.720-FF-000770', NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', 296, NULL, NULL, 127893),
(127894, '1.25.50.20-FF-000107', NULL, 'Peptidase family m1 protein, putative', 89, NULL, NULL, 127894),
(127895, '3.30.565.10-FF-000092', NULL, 'DNA topoisomerase 2', 249, NULL, NULL, 127895),
(127896, '3.40.1350.10-FF-000045', NULL, 'Predicted protein', 29, NULL, NULL, 127896),
(127897, '2.130.10.10-FF-004539', NULL, 'WD40-repeat protein', 224, NULL, NULL, 127897),
(127898, '1.10.630.10-FF-000104', NULL, 'Cytochrome P450 family 81 subfamily D polypeptide 8', 281, NULL, NULL, 127898),
(127899, '1.10.3890.10-FF-000004', NULL, 'High frequency lysogenization protein HflD homolog', 203, NULL, NULL, 127899),
(127900, '2.30.30.140-FF-000267', NULL, 'Uncharacterized protein', 104, NULL, NULL, 127900),
(127901, '3.40.50.800-FF-000002', NULL, 'Glycine--tRNA ligase', 96, NULL, NULL, 127901),
(127902, '3.30.160.20-FF-000160', NULL, 'Double-stranded RNA-specific adenosine deaminase adr-2', 88, NULL, NULL, 127902),
(127903, '2.130.10.10-FF-005832', NULL, 'Uncharacterized protein', 377, NULL, NULL, 127903),
(127904, '3.40.50.300-FF-004938', NULL, 'ATP-dependent DNA helicase', 166, NULL, NULL, 127904),
(127905, '3.90.1200.10-FF-000079', NULL, 'Uncharacterized protein', 146, NULL, NULL, 127905),
(127906, '2.60.40.60-FF-000462', NULL, 'Cadherin 2', 89, NULL, NULL, 127906),
(127907, '1.25.40.20-FF-001894', NULL, 'Uncharacterized protein', 138, NULL, NULL, 127907),
(127908, '1.25.10.10-FF-002468', NULL, 'Uncharacterized protein', 217, NULL, NULL, 127908),
(127909, '1.20.900.10-FF-000134', NULL, 'BAR domaincontaining protein', 226, NULL, NULL, 127909),
(127910, '3.40.1160.10-FF-000098', NULL, 'Aspartate/glutamate/uridylate kinase', 244, NULL, NULL, 127910),
(127911, '3.30.565.10-FF-000468', NULL, 'Uncharacterized protein', 137, NULL, NULL, 127911),
(127912, '1.10.10.10-FF-001309', NULL, 'Transcriptional regulatory protein', 87, NULL, NULL, 127912),
(127913, '2.70.170.10-FF-000107', NULL, 'Uncharacterized protein', 214, NULL, NULL, 127913),
(127914, '1.20.5.500-FF-000008', NULL, 'Lamin, isoform B', 68, NULL, NULL, 127914),
(127915, '3.20.20.70-FF-000542', NULL, NULL, 217, NULL, NULL, 127915),
(127916, '2.60.40.10-FF-000020', NULL, 'Fibroblast growth factor receptor', 113, NULL, NULL, 127916),
(127917, '1.10.530.10-FF-000035', NULL, 'Lytic murein transglycosylase B', 178, NULL, NULL, 127917),
(127918, '2.30.30.140-FF-000278', NULL, 'Predicted protein', 66, NULL, NULL, 127918),
(127919, '3.90.550.10-FF-000696', NULL, 'UDP-N-acetylglucosamine pyrophosphorylase, putative', 549, NULL, NULL, 127919),
(127920, '3.40.50.300-FF-001476', NULL, 'Dynein heavy chain domain 1', 176, NULL, NULL, 127920),
(127921, '1.20.1260.60-FF-000014', NULL, 'Actin domain-containing protein', 177, NULL, NULL, 127921),
(127922, '1.20.120.350-FF-000237', NULL, NULL, 169, NULL, NULL, 127922),
(127923, '2.102.10.10-FF-000062', NULL, 'Cytochrome b/b6 complex, iron-sulfur cluster-binding subunit', 103, NULL, NULL, 127923),
(127924, '3.30.420.340-FF-000006', NULL, 'UvrABC system protein C', 165, NULL, NULL, 127924),
(127925, '1.20.120.1080-FF-000098', NULL, 'Putative pre-mRNA-splicing factor ATP-dependent RNA helicase C20H4.09', 102, NULL, NULL, 127925),
(127926, '3.40.50.1820-FF-001431', NULL, 'Dynein light chain, putative', 195, NULL, NULL, 127926),
(127927, '3.30.40.10-FF-001430', NULL, 'E3 ubiquitin-protein ligase', 61, NULL, NULL, 127927);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(127928, '3.40.50.1100-FF-000260', NULL, 'Uncharacterized protein', 139, NULL, NULL, 127928),
(127929, '1.10.510.10-FF-001545', NULL, 'Receptor protein serine/threonine kinase', 149, NULL, NULL, 127929),
(127930, '1.10.287.370-FF-000094', NULL, 'Uncharacterized protein', 79, NULL, NULL, 127930),
(127931, '2.60.40.10-FF-003246', NULL, 'Uncharacterized protein', 98, NULL, NULL, 127931),
(127932, '2.10.25.10-FF-000223', NULL, 'Fibrillin 2', 39, NULL, NULL, 127932),
(127933, '1.10.8.10-FF-000168', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 64, NULL, NULL, 127933),
(127934, '3.50.50.60-FF-001388', NULL, 'Expressed protein', 215, NULL, NULL, 127934),
(127935, '1.20.1560.10-FF-000409', NULL, 'Multidrug resistance-associated protein 1', 336, NULL, NULL, 127935),
(127936, '3.30.200.20-FF-001260', NULL, 'Protein_kinase_-_putative', 108, NULL, NULL, 127936),
(127937, '3.40.50.2300-FF-000400', NULL, 'Signal transduction histidine kinase', 138, NULL, NULL, 127937),
(127938, '3.40.50.300-FF-008513', NULL, 'Uncharacterized protein', 159, NULL, NULL, 127938),
(127939, '3.30.479.10-FF-000003', NULL, '6-pyruvoyl tetrahydrobiopterin synthase', 139, NULL, NULL, 127939),
(127940, '3.80.10.10-FF-000644', NULL, 'Putative inactive leucine-rich repeat receptor-like protein kinase isoform A', 119, NULL, NULL, 127940),
(127941, '1.10.238.230-FF-000008', NULL, 'Serine/threonine-protein phosphatase 2A regulatory subunit B'''' subunit beta', 97, NULL, NULL, 127941),
(127942, '3.30.160.60-FF-001655', NULL, 'FinTRIM family, member 82', 46, NULL, NULL, 127942),
(127943, '3.30.40.10-FF-000906', NULL, 'Histone acetyltransferase', 131, NULL, NULL, 127943),
(127944, '2.120.10.80-FF-000311', NULL, 'Leucine carboxyl methyltransferase 2', 318, NULL, NULL, 127944),
(127945, '2.70.150.10-FF-000112', NULL, 'Calcium-transporting ATPase', 113, NULL, NULL, 127945),
(127946, '3.30.479.30-FF-000009', NULL, 'Erlin-2 isoform 1', 139, NULL, NULL, 127946),
(127947, '3.40.50.410-FF-000109', NULL, 'Protein transport protein SEC23', 258, NULL, NULL, 127947),
(127948, '3.30.70.330-FF-001396', NULL, 'APOBEC1 complementation factor', 111, NULL, NULL, 127948),
(127949, '3.40.50.720-FF-000540', NULL, 'Oxidoreductase, short chain dehydrogenase/reductase family protein', 216, NULL, NULL, 127949),
(127950, '4.10.240.10-FF-000080', NULL, 'Transcriptional regulatory protein EDS1', 64, NULL, NULL, 127950),
(127951, '1.10.287.70-FF-000166', NULL, 'Voltage-gated Ca2+ channel, alpha subunit', 125, NULL, NULL, 127951),
(127952, '2.60.40.420-FF-000060', NULL, 'L-ascorbate oxidase', 214, NULL, NULL, 127952),
(127953, '3.90.70.10-FF-000788', NULL, 'Predicted protein', 335, NULL, NULL, 127953),
(127954, '1.20.120.1880-FF-000006', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 209, NULL, NULL, 127954),
(127955, '1.20.58.1290-FF-000001', NULL, 'CarD family transcriptional regulator', 102, NULL, NULL, 127955),
(127956, '1.20.140.150-FF-000035', NULL, 'LHFPL tetraspan subfamily member 4 protein', 183, NULL, NULL, 127956),
(127957, '2.60.120.200-FF-000441', NULL, 'Galectin', 150, NULL, NULL, 127957),
(127958, '2.60.40.60-FF-000041', NULL, 'FAT atypical cadherin 1', 101, NULL, NULL, 127958),
(127959, '1.25.40.20-FF-000949', NULL, 'Transcription factor TOXE', 122, NULL, NULL, 127959),
(127960, '2.30.40.10-FF-000179', NULL, 'Predicted protein', 54, NULL, NULL, 127960),
(127961, '3.30.1610.10-FF-000023', NULL, 'Uncharacterized protein', 53, NULL, NULL, 127961),
(127962, '3.90.70.10-FF-000900', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 235, NULL, NULL, 127962),
(127963, '2.130.10.10-FF-004747', NULL, 'WD repeat domain-containing protein 83 homolog', 161, NULL, NULL, 127963),
(127964, '2.60.40.10-FF-001217', NULL, 'phosphatidylinositol phosphatase PTPRQ isoform X2', 109, NULL, NULL, 127964),
(127965, '2.60.40.10-FF-005500', NULL, NULL, 94, NULL, NULL, 127965),
(127966, '2.30.29.30-FF-001344', NULL, 'Uncharacterized protein', 178, NULL, NULL, 127966),
(127967, '1.10.10.1760-FF-000004', NULL, '60S ribosomal protein L36', 114, NULL, NULL, 127967);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(127968, '1.20.1530.20-FF-000006', NULL, 'Putative transporter YfdV', 151, NULL, NULL, 127968),
(127969, '3.80.10.10-FF-001049', NULL, 'Uncharacterized protein', 216, NULL, NULL, 127969),
(127970, '1.20.58.60-FF-000708', NULL, 'Uncharacterized protein', 283, NULL, NULL, 127970),
(127971, '3.30.470.10-FF-000034', NULL, 'Probable branched-chain-amino-acid aminotransferase', 126, NULL, NULL, 127971),
(127972, '3.30.40.10-FF-000002', NULL, 'Histone-lysine N-methyltransferase', 114, NULL, NULL, 127972),
(127973, '3.30.450.20-FF-000463', NULL, 'Hypoxia-inducible factor 1 alpha, putative', 119, NULL, NULL, 127973),
(127974, '3.40.50.300-FF-002095', NULL, 'mRNA cleavage and polyadenylation factor clp1', 249, NULL, NULL, 127974),
(127975, '2.130.10.10-FF-001993', NULL, 'Serine/threonine-protein kinase PRP4', 104, NULL, NULL, 127975),
(127976, '1.20.920.60-FF-000004', NULL, 'Uncharacterized protein', 92, NULL, NULL, 127976),
(127977, '2.60.120.10-FF-000781', NULL, 'Uncharacterized protein', 325, NULL, NULL, 127977),
(127978, '1.10.8.50-FF-000022', NULL, 'Fibronectin/fibrinogen-binding protein', 68, NULL, NULL, 127978),
(127979, '3.10.100.10-FF-000034', NULL, 'secretory phospholipase A2 receptor', 136, NULL, NULL, 127979),
(127980, '2.160.10.10-FF-000098', NULL, 'Serine acetyltransferase', 105, NULL, NULL, 127980),
(127981, '3.30.9.10-FF-000048', NULL, 'Glycine oxidase ThiO', 145, NULL, NULL, 127981),
(127982, '3.60.10.10-FF-000033', NULL, 'sphingomyelin phosphodiesterase 2', 274, NULL, NULL, 127982),
(127983, '3.30.230.10-FF-000039', NULL, 'Lon protease homolog 2, peroxisomal', 196, NULL, NULL, 127983),
(127984, '1.10.287.70-FF-000071', NULL, 'Two pore calcium channel protein 1', 163, NULL, NULL, 127984),
(127985, '3.50.30.10-FF-000006', NULL, 'UDP-glucose 4-epimerase GalE4', 109, NULL, NULL, 127985),
(127986, '3.30.830.10-FF-000017', NULL, 'nardilysin isoform X1', 218, NULL, NULL, 127986),
(127987, '3.30.200.20-FF-002457', NULL, 'Uncharacterized protein', 56, NULL, NULL, 127987),
(127988, '3.40.33.10-FF-000137', NULL, 'Uncharacterized protein', 169, NULL, NULL, 127988),
(127989, '3.40.1190.20-FF-000136', NULL, 'Adenosine kinase-like protein', 274, NULL, NULL, 127989),
(127990, '3.30.160.60-FF-005837', NULL, NULL, 31, NULL, NULL, 127990),
(127991, '3.40.50.2300-FF-001491', NULL, NULL, 127, NULL, NULL, 127991),
(127992, '3.50.50.60-FF-000674', NULL, '3-dehydro-bile acid delta(4,6)-reductase', 232, NULL, NULL, 127992),
(127993, '3.30.2080.10-FF-000009', NULL, 'Glycoside hydrolase family 92 protein', 27, NULL, NULL, 127993),
(127994, '3.30.160.60-FF-004409', NULL, NULL, 83, NULL, NULL, 127994),
(127995, '3.30.70.1860-FF-000001', NULL, 'EMB3143', 113, NULL, NULL, 127995),
(127996, '1.25.40.10-FF-005151', NULL, 'Uncharacterized protein', 93, NULL, NULL, 127996),
(127997, '3.60.40.10-FF-000214', NULL, 'Phosphoprotein phosphatase', 278, NULL, NULL, 127997),
(127998, '2.60.120.610-FF-000002', NULL, 'Probable arabinosyltransferase B', 174, NULL, NULL, 127998),
(127999, '3.30.559.10-FF-000055', NULL, 'Nonribosomal peptide synthetase sidC', 174, NULL, NULL, 127999),
(128000, '1.10.1450.10-FF-000033', NULL, 'Tetraspanin', 110, NULL, NULL, 128000),
(128001, '3.20.20.80-FF-000741', NULL, 'Chitinase 3, putative', 77, NULL, NULL, 128001),
(128002, '1.20.5.170-FF-000061', NULL, 'Sodium/potassium-transporting ATPase subunit beta', 61, NULL, NULL, 128002),
(128003, '2.40.100.10-FF-000099', NULL, 'Putative peptidyl prolyl cis trans isomerase', 165, NULL, NULL, 128003),
(128004, '2.30.110.10-FF-000107', NULL, 'Uncharacterized protein', 241, NULL, NULL, 128004),
(128005, '3.30.450.200-FF-000010', NULL, 'DENN/MADD domain-containing 3a', 173, NULL, NULL, 128005),
(128006, '1.20.120.720-FF-000045', NULL, 'Myosin IHb', 95, NULL, NULL, 128006),
(128007, '3.30.160.60-FF-004640', NULL, NULL, 29, NULL, NULL, 128007),
(128008, '3.30.200.20-FF-001046', NULL, 'Serine/threonine-protein kinase PknK', 89, NULL, NULL, 128008),
(128009, '1.20.1270.280-FF-000037', NULL, 'Dynein, axonemal, heavy chain 7', 102, NULL, NULL, 128009),
(128010, '3.40.1110.10-FF-000275', NULL, NULL, 182, NULL, NULL, 128010);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(128011, '1.20.120.1760-FF-000004', NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', 189, NULL, NULL, 128011),
(128012, '1.20.120.610-FF-000012', NULL, 'Uncharacterized protein', 70, NULL, NULL, 128012),
(128013, '1.10.1410.10-FF-000019', NULL, 'Nuclear poly(A) polymerase 3', 175, NULL, NULL, 128013),
(128014, '3.40.1390.30-FF-000025', NULL, 'Predicted protein', 51, NULL, NULL, 128014),
(128015, '3.40.50.720-FF-000326', NULL, 'NADH-ubiquinone oxidoreductase 39 kD subunit, putative', 255, NULL, NULL, 128015),
(128016, '1.10.1200.260-FF-000004', NULL, 'Potassium voltage-gated channel protein eag', 41, NULL, NULL, 128016),
(128017, '3.40.50.300-FF-004461', NULL, 'Developmentally-regulated GTP-binding protein 2, variant', 168, NULL, NULL, 128017),
(128018, '2.60.120.330-FF-000221', NULL, 'Os06g0176650 protein', 66, NULL, NULL, 128018),
(128019, '3.30.40.140-FF-000001', NULL, 'E3 ubiquitin-protein ligase CHFR isoform X1', 105, NULL, NULL, 128019),
(128020, '1.25.40.10-FF-004971', NULL, 'Developmental protein DG1091', 279, NULL, NULL, 128020),
(128021, '2.130.10.10-FF-005692', NULL, 'Uncharacterized protein', 154, NULL, NULL, 128021),
(128022, '3.30.1740.10-FF-000010', NULL, 'Putative DNA repair protein', 102, NULL, NULL, 128022),
(128023, '3.10.290.20-FF-000016', NULL, 'SUMO-activating enzyme subunit', 143, NULL, NULL, 128023),
(128024, '1.10.1040.10-FF-000108', NULL, 'Glycerol-3-phosphate dehydrogenase (NAD(P)(+))', 152, NULL, NULL, 128024),
(128025, '3.40.50.1820-FF-001094', NULL, 'Uncharacterized protein', 152, NULL, NULL, 128025),
(128026, '3.40.50.300-FF-000650', NULL, 'DNA helicase MCM8 isoform X1', 334, NULL, NULL, 128026),
(128027, '1.20.1050.10-FF-000118', NULL, 'Chloride intracellular channel 3', 94, NULL, NULL, 128027),
(128028, '3.40.50.620-FF-000173', NULL, 'tRNA(Ile)-lysidine synthase', 225, NULL, NULL, 128028),
(128029, '3.30.160.60-FF-002274', NULL, 'Zinc finger protein 432', 28, NULL, NULL, 128029),
(128030, '3.40.50.12780-FF-000036', NULL, 'Acetoacetyl-CoA synthetase', 517, NULL, NULL, 128030),
(128031, '1.25.40.10-FF-001565', NULL, 'PPR superfamily protein', 134, NULL, NULL, 128031),
(128032, '3.90.175.10-FF-000003', NULL, 'Grass carp reovirus (GCRV)-induced gene 2p', 112, NULL, NULL, 128032),
(128033, '1.20.58.80-FF-000041', NULL, 'ATPase, AAA family protein', 79, NULL, NULL, 128033),
(128034, '1.10.533.10-FF-000300', NULL, 'Uncharacterized protein', 73, NULL, NULL, 128034),
(128035, '2.170.260.10-FF-000012', NULL, 'Endoribonuclease Dicer-like 2 isoform B', 126, NULL, NULL, 128035),
(128036, '1.10.10.10-FF-001540', NULL, 'Predicted protein', 128, NULL, NULL, 128036),
(128037, '3.30.70.330-FF-000777', NULL, 'Os01g0765300 protein', 84, NULL, NULL, 128037),
(128038, '2.130.10.10-FF-005253', NULL, 'Uncharacterized protein', 276, NULL, NULL, 128038),
(128039, '3.30.60.30-FF-000234', NULL, 'Uncharacterized protein', 50, NULL, NULL, 128039),
(128040, '2.80.10.50-FF-000254', NULL, 'Fascin', 107, NULL, NULL, 128040),
(128041, '2.60.120.650-FF-000199', NULL, 'Uncharacterized protein', 340, NULL, NULL, 128041),
(128042, '3.40.720.10-FF-000092', NULL, 'Alkaline phosphatase PafA', 393, NULL, NULL, 128042),
(128043, '2.60.120.780-FF-000007', NULL, 'E3 SUMO-protein ligase gei-17', 151, NULL, NULL, 128043),
(128044, '3.40.605.10-FF-000127', NULL, 'Aldehyde dehydrogenase 3 family member B1', 43, NULL, NULL, 128044),
(128045, '1.20.120.310-FF-000012', NULL, 'Sulfhydryl oxidase', 139, NULL, NULL, 128045),
(128046, '3.40.50.2020-FF-000086', NULL, 'Erythromycin esterase', 139, NULL, NULL, 128046),
(128047, '3.10.50.30-FF-000004', NULL, 'Transcription elongation factor GreA', 79, NULL, NULL, 128047),
(128048, '1.25.40.10-FF-002296', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 155, NULL, NULL, 128048),
(128049, '2.60.40.640-FF-000120', NULL, 'Protein ste7', 144, NULL, NULL, 128049),
(128050, '2.60.40.10-FF-004983', NULL, NULL, 109, NULL, NULL, 128050),
(128051, '2.60.40.150-FF-000405', NULL, 'Uncharacterized protein', 122, NULL, NULL, 128051),
(128052, '1.10.510.10-FF-001916', NULL, 'Uncharacterized protein', 180, NULL, NULL, 128052);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(128053, '3.40.50.10330-FF-000088', NULL, 'Uncharacterized protein', 175, NULL, NULL, 128053),
(128054, '2.40.440.10-FF-000023', NULL, 'Slr0769 protein', 129, NULL, NULL, 128054),
(128055, '1.25.10.10-FF-001849', NULL, 'Importin beta', 503, NULL, NULL, 128055),
(128056, '3.30.40.10-FF-001851', NULL, 'RING finger protein mug145', 81, NULL, NULL, 128056),
(128057, '3.30.420.10-FF-000211', NULL, 'Uncharacterized protein', 200, NULL, NULL, 128057),
(128058, '2.30.29.30-FF-001232', NULL, 'Predicted protein', 115, NULL, NULL, 128058),
(128059, '1.10.3810.10-FF-000016', NULL, 'Penicillin-binding protein 1B', 207, NULL, NULL, 128059),
(128060, '2.70.70.10-FF-000027', NULL, 'Glycyl-glycine endopeptidase LytM', 160, NULL, NULL, 128060),
(128061, '3.30.60.30-FF-000122', NULL, 'Agrin', 67, NULL, NULL, 128061),
(128062, '3.50.50.60-FF-001500', NULL, 'Predicted protein', 31, NULL, NULL, 128062),
(128063, '1.25.10.10-FF-002889', NULL, 'Predicted protein', 145, NULL, NULL, 128063),
(128064, '1.20.1070.10-FF-000653', NULL, 'Predicted protein', 119, NULL, NULL, 128064),
(128065, '3.40.50.300-FF-005658', NULL, 'Bifunctional 3''-phosphoadenosine 5''-phosphosulfate synthase', 206, NULL, NULL, 128065),
(128066, '2.60.120.10-FF-000129', NULL, 'Transcriptional regulator FixK', 118, NULL, NULL, 128066),
(128067, '1.10.238.210-FF-000002', NULL, 'Blast:Glutaminase kidney isoform, mitochondrial', 88, NULL, NULL, 128067),
(128068, '3.30.160.60-FF-005045', NULL, NULL, 26, NULL, NULL, 128068),
(128069, '3.40.140.10-FF-000007', NULL, 'Cytidine deaminase', 151, NULL, NULL, 128069),
(128070, '2.120.10.30-FF-000549', NULL, 'Uncharacterized protein', 381, NULL, NULL, 128070),
(128071, '2.130.10.10-FF-001881', NULL, 'WD repeat and HMG-box DNA binding protein 1', 134, NULL, NULL, 128071),
(128072, '2.60.40.10-FF-001329', NULL, 'Basigin', 95, NULL, NULL, 128072),
(128073, '2.40.420.20-FF-000013', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 92, NULL, NULL, 128073),
(128074, '2.20.25.20-FF-000023', NULL, NULL, 31, NULL, NULL, 128074),
(128075, '1.20.1250.20-FF-000075', NULL, 'Lactose permease', 205, NULL, NULL, 128075),
(128076, '1.20.1270.60-FF-000200', NULL, 'Uncharacterized protein', 74, NULL, NULL, 128076),
(128077, '4.10.1000.10-FF-000149', NULL, 'Uncharacterized protein', 35, NULL, NULL, 128077),
(128078, '3.40.50.1820-FF-000475', NULL, 'YPR147C-like protein', 170, NULL, NULL, 128078),
(128079, '3.40.50.980-FF-000016', NULL, 'Non-ribosomal peptide synthetase', 163, NULL, NULL, 128079),
(128080, '3.40.50.10190-FF-000332', NULL, 'Predicted protein', 110, NULL, NULL, 128080),
(128081, '2.130.10.10-FF-000936', NULL, 'Periodic tryptophan protein 2', 199, NULL, NULL, 128081),
(128082, '1.25.40.20-FF-000466', NULL, 'Mann-cup, isoform B', 134, NULL, NULL, 128082),
(128083, '1.10.10.60-FF-000925', NULL, NULL, 65, NULL, NULL, 128083),
(128084, '3.90.1180.10-FF-000003', NULL, '60S ribosomal protein L13a-4', 147, NULL, NULL, 128084),
(128085, '2.70.220.10-FF-000011', NULL, 'Uncharacterized protein', 111, NULL, NULL, 128085),
(128086, '3.10.20.90-FF-000481', NULL, 'NSFL1 cofactor p47, putative', 119, NULL, NULL, 128086),
(128087, '1.25.40.20-FF-001197', NULL, 'Predicted protein', 130, NULL, NULL, 128087),
(128088, '3.80.10.10-FF-002898', NULL, 'Uncharacterized protein', 161, NULL, NULL, 128088),
(128089, '6.10.140.2220-FF-000059', NULL, 'Putative MYND finger domain protein', 48, NULL, NULL, 128089),
(128090, '2.30.30.100-FF-000053', NULL, 'U6 snRNA-associated Sm-like protein LSm2', 98, NULL, NULL, 128090),
(128091, '1.10.2020.10-FF-000001', NULL, 'Uronate isomerase', 94, NULL, NULL, 128091),
(128092, '3.90.25.10-FF-000032', NULL, 'Predicted protein', 101, NULL, NULL, 128092),
(128093, '1.20.920.10-FF-000017', NULL, 'Bromodomain and WD repeat domain containing 1', 129, NULL, NULL, 128093),
(128094, '1.25.40.10-FF-001205', NULL, 'Pentatricopeptide repeat domain 3', 148, NULL, NULL, 128094),
(128095, '1.10.238.10-FF-000001', NULL, 'Calmodulin 1', 148, NULL, NULL, 128095),
(128096, '1.10.405.10-FF-000019', NULL, 'Guanosine nucleotide diphosphate dissociation inhibitor', 16, NULL, NULL, 128096);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(128097, '3.30.160.60-FF-006326', NULL, NULL, 67, NULL, NULL, 128097),
(128098, '3.90.228.10-FF-000043', NULL, 'Poly [ADP-ribose] polymerase', 215, NULL, NULL, 128098),
(128099, '1.20.900.10-FF-000022', NULL, 'protein ECT2 isoform X1', 210, NULL, NULL, 128099),
(128100, '1.10.287.110-FF-000044', NULL, 'DnaJ (Hsp40) homolog, subfamily C, member 1', 81, NULL, NULL, 128100),
(128101, '3.40.190.10-FF-000948', NULL, 'ABC transporter permease fused to pyrimidine biosynthesis enzyme', 153, NULL, NULL, 128101),
(128102, '3.30.1490.40-FF-000010', NULL, 'Smy2p', 100, NULL, NULL, 128102),
(128103, '3.30.70.330-FF-001284', NULL, 'RNA-binding protein', 82, NULL, NULL, 128103),
(128104, '1.10.238.10-FF-000131', NULL, 'Dystrophin, isoform E', 87, NULL, NULL, 128104),
(128105, '1.10.1040.10-FF-000098', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)] 1', 156, NULL, NULL, 128105),
(128106, '3.40.50.300-FF-002887', NULL, 'Si:ch211-197g15.6', 207, NULL, NULL, 128106),
(128107, '1.50.40.10-FF-000287', NULL, 'Mitochondrial carrier protein MTM1', 286, NULL, NULL, 128107),
(128108, '3.20.20.70-FF-000654', NULL, NULL, 231, NULL, NULL, 128108),
(128109, '2.70.150.10-FF-000224', NULL, 'Uncharacterized protein', 78, NULL, NULL, 128109),
(128110, '2.60.40.10-FF-002274', NULL, 'CD4', 71, NULL, NULL, 128110),
(128111, '3.30.160.60-FF-003572', NULL, 'Zinc finger protein 639', 57, NULL, NULL, 128111),
(128112, '1.10.510.10-FF-003911', NULL, NULL, 79, NULL, NULL, 128112),
(128113, '2.30.30.140-FF-000166', NULL, 'Probable ATP-dependent RNA helicase spindle-E', 84, NULL, NULL, 128113),
(128114, '1.10.20.10-FF-000074', NULL, 'dr1-associated corepressor', 74, NULL, NULL, 128114),
(128115, '3.40.50.300-FF-001364', NULL, 'Circadian clock protein kinase KaiC', 251, NULL, NULL, 128115),
(128116, '2.60.120.310-FF-000002', NULL, 'DBH-like monooxygenase protein 1', 161, NULL, NULL, 128116),
(128117, '2.10.25.10-FF-000335', NULL, 'protocadherin Fat 4 isoform X2', 42, NULL, NULL, 128117),
(128118, '3.40.50.1980-FF-000040', NULL, 'ABC transporter substrate-binding protein-iron transport', 166, NULL, NULL, 128118),
(128119, '3.20.20.70-FF-000171', NULL, 'Ribulose-phosphate 3-epimerase', 217, NULL, NULL, 128119),
(128120, '3.40.50.1110-FF-000133', NULL, 'O-ACyltransferase homolog', 221, NULL, NULL, 128120),
(128121, '2.60.40.10-FF-005163', NULL, NULL, 94, NULL, NULL, 128121),
(128122, '3.90.190.10-FF-000353', NULL, 'Tyrosine phosphatase', 294, NULL, NULL, 128122),
(128123, '1.20.1250.20-FF-000428', NULL, 'Solute carrier family 2 (Facilitated glucose transporter), member 6', 214, NULL, NULL, 128123),
(128124, '3.60.140.10-FF-000014', NULL, 'Polyphenol oxidase', 237, NULL, NULL, 128124),
(128125, '3.30.230.130-FF-000063', NULL, 'Cullin, putative', 151, NULL, NULL, 128125),
(128126, '1.10.246.20-FF-000012', NULL, 'Os08g0523600 protein', 63, NULL, NULL, 128126),
(128127, '2.130.10.10-FF-003336', NULL, 'YALI0E28226p', 121, NULL, NULL, 128127),
(128128, '3.40.640.10-FF-000377', NULL, 'Kynureninase', 115, NULL, NULL, 128128),
(128129, '3.80.10.10-FF-000532', NULL, '18w protein', 111, NULL, NULL, 128129),
(128130, '3.90.1410.10-FF-000016', NULL, 'Lysine methyltransferase', 296, NULL, NULL, 128130),
(128131, '1.20.1250.20-FF-000092', NULL, 'Feline leukemia virus subgroup C receptor-related protein 2 isoform 1', 200, NULL, NULL, 128131),
(128132, '3.40.50.10190-FF-000248', NULL, 'YALI0E31273p', 134, NULL, NULL, 128132),
(128133, '3.40.50.2000-FF-000872', NULL, 'Glycogen [starch] synthase', 317, NULL, NULL, 128133),
(128134, '2.130.10.10-FF-003679', NULL, 'IntraFlagellar Transport Associated', 219, NULL, NULL, 128134),
(128135, '1.10.800.10-FF-000011', NULL, 'Tyrosine 3-monooxygenase', 407, NULL, NULL, 128135),
(128136, '3.80.10.10-FF-002561', NULL, 'At1g77550', 136, NULL, NULL, 128136),
(128137, '3.30.160.60-FF-004191', NULL, NULL, 27, NULL, NULL, 128137),
(128138, '3.30.70.1290-FF-000009', NULL, NULL, 155, NULL, NULL, 128138),
(128139, '1.10.418.10-FF-000100', NULL, 'Kinesin-like protein KIN-14H', 125, NULL, NULL, 128139),
(128140, '3.30.160.60-FF-001785', NULL, 'Zinc finger protein 425', 31, NULL, NULL, 128140);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(128141, '3.40.50.150-FF-000110', NULL, 'methyltransferase-like protein 13 isoform X1', 207, NULL, NULL, 128141),
(128142, '1.20.1070.10-FF-000569', NULL, 'Uncharacterized protein', 123, NULL, NULL, 128142),
(128143, '2.30.29.30-FF-000276', NULL, 'pleckstrin homology domain-containing family H member 3', 117, NULL, NULL, 128143),
(128144, '1.25.40.10-FF-000379', NULL, 'Tetratricopeptide repeat domain 30B', 137, NULL, NULL, 128144),
(128145, '3.40.50.150-FF-000453', NULL, 'Histidine N-alpha-methyltransferase', 56, NULL, NULL, 128145),
(128146, '3.40.50.720-FF-000298', NULL, 'Voltage-gated potassium channel Kch', 153, NULL, NULL, 128146),
(128147, '3.40.50.200-FF-000171', NULL, 'Uncharacterized protein', 51, NULL, NULL, 128147),
(128148, '1.20.1280.50-FF-000136', NULL, 'F-box/WD repeat-containing protein sel-10', 87, NULL, NULL, 128148),
(128149, '1.10.287.2900-FF-000005', NULL, 'Mic14p', 44, NULL, NULL, 128149),
(128150, '1.25.10.10-FF-001496', NULL, 'Coatomer subunit gamma', 141, NULL, NULL, 128150),
(128151, '3.50.50.60-FF-000899', NULL, 'Flavin-containing monooxygenase FMO GS-OX-like 8', 107, NULL, NULL, 128151),
(128152, '1.20.5.690-FF-000008', NULL, 'Importin subunit alpha', 43, NULL, NULL, 128152),
(128153, '1.10.10.60-FF-000021', NULL, 'CDC5 cell division cycle 5-like', 54, NULL, NULL, 128153),
(128154, '3.30.70.80-FF-000053', NULL, 'Uncharacterized protein', 58, NULL, NULL, 128154),
(128155, '4.10.170.10-FF-000001', NULL, 'Cellular tumor antigen p53', 58, NULL, NULL, 128155),
(128156, '3.30.920.10-FF-000007', NULL, 'Iron-sulfur cluster assembly protein CyaY', 104, NULL, NULL, 128156),
(128157, '2.30.29.30-FF-000372', NULL, 'Uncharacterized protein, isoform B', 100, NULL, NULL, 128157),
(128158, '2.60.120.200-FF-000424', NULL, 'AGAP004993-PA', 192, NULL, NULL, 128158),
(128159, '1.10.565.10-FF-000160', NULL, 'Uncharacterized protein', 214, NULL, NULL, 128159),
(128160, '3.40.449.10-FF-000011', NULL, 'Phosphoenolpyruvate carboxykinase [ATP]', 107, NULL, NULL, 128160),
(128161, '3.40.50.300-FF-000419', NULL, 'Probable helicase with zinc finger domain', 224, NULL, NULL, 128161),
(128162, '2.10.25.10-FF-001280', NULL, 'Predicted protein', 42, NULL, NULL, 128162),
(128163, '2.60.120.370-FF-000008', NULL, 'Putative sugar isomerase involved in processing of exogenous sialic acid', 153, NULL, NULL, 128163),
(128164, '1.25.40.10-FF-003914', NULL, 'Cell division cycle protein 16 homolog', 468, NULL, NULL, 128164),
(128165, '3.40.120.10-FF-000012', NULL, 'Phosphoglucomutase, alpha-D-glucose phosphate-specific', 207, NULL, NULL, 128165),
(128166, '1.20.5.110-FF-000071', NULL, 'pH-gated potassium channel KcsA', 40, NULL, NULL, 128166),
(128167, '2.60.40.10-FF-001577', NULL, 'Fasciclin 2, isoform D', 100, NULL, NULL, 128167),
(128168, '1.20.1070.10-FF-001721', NULL, 'Predicted protein', 100, NULL, NULL, 128168),
(128169, '3.30.30.30-FF-000053', NULL, 'Uncharacterized protein', 50, NULL, NULL, 128169),
(128170, '3.40.50.12230-FF-000006', NULL, '10-formyltetrahydrofolate dehydrogenase', 176, NULL, NULL, 128170),
(128171, '3.40.50.12660-FF-000017', NULL, NULL, 85, NULL, NULL, 128171),
(128172, '1.20.1250.20-FF-001373', NULL, 'MFS general substrate transporter', 196, NULL, NULL, 128172),
(128173, '3.40.1350.10-FF-000040', NULL, 'Uncharacterized protein C824.03c, mitochondrial', 128, NULL, NULL, 128173),
(128174, '3.30.70.330-FF-002817', NULL, NULL, 92, NULL, NULL, 128174),
(128175, '1.10.3060.10-FF-000009', NULL, 'Protein translocase subunit SecA 2', 200, NULL, NULL, 128175),
(128176, '3.40.30.10-FF-000647', NULL, 'Phosducin-like protein (Eurofung)', 121, NULL, NULL, 128176),
(128177, '3.30.710.10-FF-000172', NULL, 'BTB/POZ domain-containing protein', 112, NULL, NULL, 128177),
(128178, '3.30.9.10-FF-000065', NULL, 'FAD-dependent oxidoreductase', 160, NULL, NULL, 128178),
(128179, '1.20.58.60-FF-000164', NULL, 'Uncharacterized protein, isoform B', 98, NULL, NULL, 128179),
(128180, '3.30.70.330-FF-000339', NULL, 'RNA binding protein Jsn1', 97, NULL, NULL, 128180),
(128181, '3.40.50.300-FF-004702', NULL, 'Uncharacterized protein', 265, NULL, NULL, 128181);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(128182, '3.30.450.90-FF-000017', NULL, 'Twitching motility pilus retraction protein', 101, NULL, NULL, 128182),
(128183, '3.40.50.1110-FF-000049', NULL, 'Protein CBG16394', 275, NULL, NULL, 128183),
(128184, '3.30.420.40-FF-000658', NULL, 'Actin-like protein 6A', 122, NULL, NULL, 128184),
(128185, '1.20.80.10-FF-000004', NULL, 'Protein-tyrosine kinase 2-beta isoform 1', 124, NULL, NULL, 128185),
(128186, '3.40.50.1240-FF-000060', NULL, 'Bifunctional RNase H/acid phosphatase', 200, NULL, NULL, 128186),
(128187, '2.130.10.10-FF-005236', NULL, 'Predicted protein', 323, NULL, NULL, 128187),
(128188, '2.170.150.80-FF-000002', NULL, 'Nac domain-containing protein 86', 145, NULL, NULL, 128188),
(128189, '2.20.25.80-FF-000013', NULL, 'Probable WRKY transcription factor 70', 72, NULL, NULL, 128189),
(128190, '3.40.50.10890-FF-000019', NULL, 'Uncharacterized protein', 61, NULL, NULL, 128190),
(128191, '3.40.50.150-FF-000902', NULL, NULL, 140, NULL, NULL, 128191),
(128192, '1.25.40.20-FF-000045', NULL, 'Ankyrin repeat and BTB/POZ domain-containing protein 2', 312, NULL, NULL, 128192),
(128193, '2.60.260.20-FF-000159', NULL, 'Predicted protein', 81, NULL, NULL, 128193),
(128194, '3.40.50.2000-FF-001047', NULL, 'Uncharacterized protein', 131, NULL, NULL, 128194),
(128195, '3.30.160.60-FF-002723', NULL, 'Zinc finger protein 597', 22, NULL, NULL, 128195),
(128196, '1.10.510.10-FF-004316', NULL, NULL, 147, NULL, NULL, 128196),
(128197, '1.10.3260.10-FF-000007', NULL, 'DNA ligase', 220, NULL, NULL, 128197),
(128198, '2.40.30.110-FF-000014', NULL, 'Aminomethyltransferase', 83, NULL, NULL, 128198),
(128199, '1.10.4020.10-FF-000001', NULL, 'zinc finger protein 263 isoform X1', 91, NULL, NULL, 128199),
(128200, '3.30.810.10-FF-000022', NULL, 'Phosphatidylinositol-4-phosphate 5-kinase, putative', 195, NULL, NULL, 128200),
(128201, '3.40.50.150-FF-000009', NULL, '23S rRNA (Uracil(1939)-C(5))-methyltransferase RlmD', 210, NULL, NULL, 128201),
(128202, '3.40.50.300-FF-007215', NULL, 'Uncharacterized protein', 165, NULL, NULL, 128202),
(128203, '1.10.720.30-FF-000084', NULL, 'Uncharacterized protein', 53, NULL, NULL, 128203),
(128204, '1.25.10.10-FF-000540', NULL, 'Importin-5', 1088, NULL, NULL, 128204),
(128205, '3.90.1150.10-FF-000294', NULL, 'Glycine cleavage system P protein', 66, NULL, NULL, 128205),
(128206, '3.30.420.360-FF-000001', NULL, 'Carbamoyltransferase HypF', 112, NULL, NULL, 128206),
(128207, '3.40.850.10-FF-000174', NULL, 'Kinesin-like protein', 389, NULL, NULL, 128207),
(128208, '3.40.50.10480-FF-000003', NULL, 'Ribosome biogenesis protein BRX1', 179, NULL, NULL, 128208),
(128209, '3.40.50.11660-FF-000043', NULL, NULL, 128, NULL, NULL, 128209),
(128210, '3.10.580.10-FF-000114', NULL, 'Chloride channel protein', 80, NULL, NULL, 128210),
(128211, '3.40.30.10-FF-000086', NULL, 'Glutathione S-transferase theta-1', 81, NULL, NULL, 128211),
(128212, '1.20.120.1900-FF-000052', NULL, 'Spindle pole body component', 301, NULL, NULL, 128212),
(128213, '3.40.20.10-FF-000158', NULL, 'Uncharacterized protein', 63, NULL, NULL, 128213),
(128214, '1.20.58.60-FF-000725', NULL, 'Uncharacterized protein', 270, NULL, NULL, 128214),
(128215, '1.20.1250.20-FF-000884', NULL, 'MFS transporter of unkown specificity', 253, NULL, NULL, 128215),
(128216, '3.30.70.270-FF-000068', NULL, 'Putative diguanylate cyclase', 166, NULL, NULL, 128216),
(128217, '3.40.50.300-FF-006939', NULL, 'Uncharacterized protein', 228, NULL, NULL, 128217),
(128218, '1.10.510.10-FF-001096', NULL, 'Raf homolog serine/threonine-protein kinase', 191, NULL, NULL, 128218),
(128219, '4.10.1110.10-FF-000011', NULL, 'AN1-type zinc finger protein 3', 64, NULL, NULL, 128219),
(128220, '3.20.20.100-FF-000173', NULL, 'Uncharacterized protein', 169, NULL, NULL, 128220),
(128221, '3.50.70.10-FF-000003', NULL, 'Altered inheritance of mitochondria protein 46, mitochondrial', 187, NULL, NULL, 128221),
(128222, '4.10.1080.10-FF-000007', NULL, 'Uncharacterized protein', 78, NULL, NULL, 128222),
(128223, '3.40.50.300-FF-001925', NULL, 'DNA helicase, putative', 162, NULL, NULL, 128223);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(128224, '3.30.500.10-FF-000015', NULL, 'RT1 class I, M6, gene 1', 67, NULL, NULL, 128224),
(128225, '2.30.30.190-FF-000040', NULL, NULL, 77, NULL, NULL, 128225),
(128226, '2.20.25.30-FF-000009', NULL, '50S ribosomal protein L37e', 53, NULL, NULL, 128226),
(128227, '1.20.1070.10-FF-001058', NULL, 'Olfactory receptor family 51 subfamily B member 4', 169, NULL, NULL, 128227),
(128228, '2.20.25.10-FF-000003', NULL, 'Alkylphosphonate utilization protein PhnA', 42, NULL, NULL, 128228),
(128229, '3.90.1100.10-FF-000015', NULL, 'DNA-directed RNA polymerase subunit beta', 182, NULL, NULL, 128229),
(128230, '3.30.230.70-FF-000130', NULL, 'Exosome complex component rrp46', 205, NULL, NULL, 128230),
(128231, '3.30.160.60-FF-005500', NULL, NULL, 81, NULL, NULL, 128231),
(128232, '3.30.470.10-FF-000017', NULL, 'Branched-chain amino acid aminotransferase', 154, NULL, NULL, 128232),
(128233, '2.130.10.10-FF-000032', NULL, 'F-box/WD repeat-containing protein 7 isoform X1', 340, NULL, NULL, 128233),
(128234, '1.25.40.20-FF-001438', NULL, 'Uncharacterized protein', 153, NULL, NULL, 128234),
(128235, '2.80.10.50-FF-000142', NULL, 'Uncharacterized protein', 103, NULL, NULL, 128235),
(128236, '3.30.70.330-FF-002694', NULL, NULL, 123, NULL, NULL, 128236),
(128237, '2.20.25.10-FF-000133', NULL, 'Predicted protein', 52, NULL, NULL, 128237),
(128238, '3.30.572.10-FF-000029', NULL, 'Os11g0615250 protein', 110, NULL, NULL, 128238),
(128239, '3.40.50.300-FF-008064', NULL, 'Uncharacterized protein', 123, NULL, NULL, 128239),
(128240, '1.20.940.10-FF-000013', NULL, 'Pre-mRNA-splicing factor 18', 175, NULL, NULL, 128240),
(128241, '3.40.50.300-FF-000083', NULL, 'ATP-dependent RNA helicase DOB1', 206, NULL, NULL, 128241),
(128242, '3.20.20.140-FF-000409', NULL, 'TatD related DNase', 95, NULL, NULL, 128242),
(128243, '3.10.490.20-FF-000015', NULL, 'Axonemal dynein heavy chain', 147, NULL, NULL, 128243),
(128244, '1.20.142.10-FF-000024', NULL, 'Poly [ADP-ribose] polymerase', 94, NULL, NULL, 128244),
(128245, '1.10.730.10-FF-000016', NULL, 'Arginine--tRNA ligase, cytoplasmic', 133, NULL, NULL, 128245),
(128246, '1.10.630.10-FF-000183', NULL, 'Cytochrome P450', 476, NULL, NULL, 128246),
(128247, '3.40.50.720-FF-001607', NULL, 'Ubiquitin activating enzyme, putative', 150, NULL, NULL, 128247),
(128248, '3.50.30.30-FF-000113', NULL, 'Uncharacterized protein', 229, NULL, NULL, 128248),
(128249, '2.40.10.120-FF-000024', NULL, 'Adhesion and penetration protein autotransporter', 299, NULL, NULL, 128249),
(128250, '3.30.40.10-FF-001413', NULL, 'Uncharacterized protein', 79, NULL, NULL, 128250),
(128251, '3.40.50.1110-FF-000150', NULL, 'Uncharacterized protein', 85, NULL, NULL, 128251),
(128252, '3.30.200.20-FF-001838', NULL, 'eIF-2-alpha kinase GCN2', 105, NULL, NULL, 128252),
(128253, '3.10.110.10-FF-000203', NULL, 'Chromosome 15, whole genome shotgun sequence', 132, NULL, NULL, 128253),
(128254, '3.30.60.270-FF-000004', NULL, 'Sortilin', 77, NULL, NULL, 128254),
(128255, '1.10.3210.10-FF-000055', NULL, 'HD domain-containing protein', 124, NULL, NULL, 128255),
(128256, '3.40.50.300-FF-002544', NULL, 'P-loop containing nucleoside triphosphate hydrolases superfamily protein', 184, NULL, NULL, 128256),
(128257, '3.40.950.10-FF-000007', NULL, 'Putative cytosolic Fe-S cluster assembly factor NAR1', 20, NULL, NULL, 128257),
(128258, '2.60.120.290-FF-000170', NULL, 'Cubilin homolog', 118, NULL, NULL, 128258),
(128259, '4.10.1240.10-FF-000009', NULL, 'Glucagon receptor', 96, NULL, NULL, 128259),
(128260, '1.25.40.420-FF-000031', NULL, 'Uncharacterized protein, isoform A', 116, NULL, NULL, 128260),
(128261, '1.10.10.1600-FF-000001', NULL, 'DNA polymerase III subunit alpha', 78, NULL, NULL, 128261),
(128262, '2.60.40.10-FF-002757', NULL, 'Cd8 beta', 93, NULL, NULL, 128262),
(128263, '3.50.50.60-FF-001051', NULL, 'D-amino acid dehydrogenase 2', 148, NULL, NULL, 128263),
(128264, '2.60.40.10-FF-004191', NULL, NULL, 83, NULL, NULL, 128264),
(128265, '1.10.601.10-FF-000003', NULL, 'RNA polymerase sigma factor SigA', 36, NULL, NULL, 128265),
(128266, '1.20.5.320-FF-000027', NULL, 'Predicted protein', 53, NULL, NULL, 128266);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(128267, '2.60.40.1820-FF-000005', NULL, 'Expressed protein', 134, NULL, NULL, 128267),
(128268, '3.30.1960.10-FF-000021', NULL, 'Uncharacterized protein', 107, NULL, NULL, 128268),
(128269, '3.40.50.2300-FF-001148', NULL, NULL, 76, NULL, NULL, 128269),
(128270, '3.40.190.10-FF-000387', NULL, 'LysR family transcriptional regulator', 103, NULL, NULL, 128270),
(128271, '3.40.50.300-FF-007575', NULL, 'Predicted protein', 180, NULL, NULL, 128271),
(128272, '3.40.50.300-FF-003393', NULL, 'GD15502', 272, NULL, NULL, 128272),
(128273, '3.40.50.150-FF-001521', NULL, NULL, 105, NULL, NULL, 128273),
(128274, '3.40.395.10-FF-000014', NULL, 'Ulp1 protease family protein', 237, NULL, NULL, 128274),
(128275, '3.30.300.90-FF-000001', NULL, 'Transcriptional regulator BolA', 88, NULL, NULL, 128275),
(128276, '3.50.50.60-FF-000562', NULL, 'FAD-dependent oxidoreductase', 195, NULL, NULL, 128276),
(128277, '3.60.20.10-FF-000191', NULL, NULL, 245, NULL, NULL, 128277),
(128278, '3.40.50.20-FF-000090', NULL, 'Predicted protein', 80, NULL, NULL, 128278),
(128279, '1.25.40.10-FF-003122', NULL, 'Pentatricopeptide repeat-containing protein At2g46050, mitochondrial', 138, NULL, NULL, 128279),
(128280, '3.10.430.100-FF-000014', NULL, '50S ribosomal protein L9', 86, NULL, NULL, 128280),
(128281, '1.20.1070.10-FF-000209', NULL, 'p2Y purinoceptor 6', 306, NULL, NULL, 128281),
(128282, '3.30.200.20-FF-002114', NULL, 'Uncharacterized protein', 77, NULL, NULL, 128282),
(128283, '1.25.40.470-FF-000017', NULL, 'Uncharacterized protein, isoform B', 165, NULL, NULL, 128283),
(128284, '3.30.160.60-FF-003342', NULL, NULL, 28, NULL, NULL, 128284),
(128285, '1.20.1560.10-FF-000865', NULL, 'Uncharacterized protein', 162, NULL, NULL, 128285),
(128286, '1.25.40.10-FF-004875', NULL, 'TPR Domain containing protein', 108, NULL, NULL, 128286),
(128287, '3.30.300.10-FF-000034', NULL, 'S-adenosylmethionine synthetase', 101, NULL, NULL, 128287),
(128288, '3.40.50.150-FF-001864', NULL, NULL, 197, NULL, NULL, 128288),
(128289, '3.90.1420.10-FF-000062', NULL, 'Predicted protein', 150, NULL, NULL, 128289),
(128290, '3.75.10.10-FF-000005', NULL, 'Glycine amidinotransferase, mitochondrial', 360, NULL, NULL, 128290),
(128291, '1.10.510.10-FF-001793', NULL, 'Putative serine/threonine-protein kinase ZK507.1', 373, NULL, NULL, 128291),
(128292, '1.10.287.110-FF-000156', NULL, 'Unplaced genomic scaffold supercont1.57, whole genome shotgun sequence', 134, NULL, NULL, 128292),
(128293, '1.10.10.60-FF-000897', NULL, NULL, 64, NULL, NULL, 128293),
(128294, '2.10.220.10-FF-000182', NULL, 'Uncharacterized protein', 134, NULL, NULL, 128294),
(128295, '3.40.50.300-FF-006035', NULL, 'ABC transporter', 246, NULL, NULL, 128295),
(128296, '3.40.50.360-FF-000061', NULL, 'Flavodoxin family protein', 173, NULL, NULL, 128296),
(128297, '3.40.630.30-FF-000540', NULL, 'Predicted protein', 32, NULL, NULL, 128297),
(128298, '3.30.420.10-FF-000082', NULL, 'DNA polymerase', 294, NULL, NULL, 128298),
(128299, '2.60.120.260-FF-000060', NULL, 'Probable beta-mannosidase', 193, NULL, NULL, 128299),
(128300, '3.40.720.10-FF-000170', NULL, 'Predicted protein', 86, NULL, NULL, 128300),
(128301, '2.60.40.10-FF-005051', NULL, NULL, 102, NULL, NULL, 128301),
(128302, '1.10.472.80-FF-000139', NULL, 'Plant adhesion molecule 1', 139, NULL, NULL, 128302),
(128303, '3.30.200.20-FF-001501', NULL, 'Uncharacterized protein', 36, NULL, NULL, 128303),
(128304, '3.30.70.330-FF-002256', NULL, NULL, 82, NULL, NULL, 128304),
(128305, '3.20.20.100-FF-000077', NULL, 'Alcohol dehydrogenase, putative', 185, NULL, NULL, 128305),
(128306, '3.40.50.300-FF-002336', NULL, 'Histone-lysine N-methyltransferase Su(var)3-9', 88, NULL, NULL, 128306),
(128307, '3.30.420.40-FF-000630', NULL, 'Hexokinase 2', 56, NULL, NULL, 128307),
(128308, '3.10.20.90-FF-000610', NULL, 'Sorting nexin-31', 98, NULL, NULL, 128308),
(128309, '3.80.10.10-FF-004146', NULL, 'Uncharacterized protein', 108, NULL, NULL, 128309),
(128310, '3.60.15.10-FF-000246', NULL, 'ElaC ribonuclease Z 1', 301, NULL, NULL, 128310),
(128311, '3.40.50.150-FF-000240', NULL, 'Type I restriction-modification system, M subunit', 304, NULL, NULL, 128311);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(128312, '1.25.40.20-FF-001225', NULL, 'Uncharacterized protein', 65, NULL, NULL, 128312),
(128313, '1.10.8.60-FF-000273', NULL, 'AAA family ATPase putative', 69, NULL, NULL, 128313),
(128314, '3.40.50.10420-FF-000014', NULL, '5-formyltetrahydrofolate cyclo-ligase', 191, NULL, NULL, 128314),
(128315, '2.10.80.10-FF-000013', NULL, 'Uncharacterized protein', 96, NULL, NULL, 128315),
(128316, '2.130.10.10-FF-000240', NULL, 'THO complex subunit 6 homolog isoform X1', 319, NULL, NULL, 128316),
(128317, '2.40.50.140-FF-001067', NULL, NULL, 94, NULL, NULL, 128317),
(128318, '3.30.50.10-FF-000059', NULL, 'Similar to transcription factor Zn, GATA', 66, NULL, NULL, 128318),
(128319, '1.25.10.10-FF-000091', NULL, 'Catenin, beta like 1', 489, NULL, NULL, 128319),
(128320, '1.10.840.10-FF-000036', NULL, 'YALI0F32043p', 213, NULL, NULL, 128320),
(128321, '1.10.510.10-FF-000264', NULL, 'dual specificity tyrosine-phosphorylation-regulated kinase 1B isoform X3', 283, NULL, NULL, 128321),
(128322, '3.40.710.10-FF-000147', NULL, '1A family penicillin-binding protein', 413, NULL, NULL, 128322),
(128323, '1.20.1270.420-FF-000001', NULL, 'Serine/threonine-protein kinase TBK1', 252, NULL, NULL, 128323),
(128324, '3.40.250.10-FF-000206', NULL, 'Putative dual specificity protein phosphatase 10', 136, NULL, NULL, 128324),
(128325, '3.30.465.10-FF-000067', NULL, 'Probable aldehyde oxidase gad-3', 121, NULL, NULL, 128325),
(128326, '2.30.29.30-FF-000164', NULL, 'Putative E3 ubiquitin-protein ligase MYLIP', 94, NULL, NULL, 128326),
(128327, '2.130.10.10-FF-003466', NULL, 'Alkaline phosphatase', 71, NULL, NULL, 128327),
(128328, '3.30.200.20-FF-000984', NULL, 'Putative cdc2-related kinase', 94, NULL, NULL, 128328),
(128329, '1.10.10.10-FF-000028', NULL, 'Fumarate/nitrate reduction transcriptional regulator Fnr', 81, NULL, NULL, 128329),
(128330, '2.10.50.10-FF-000079', NULL, 'tumor necrosis factor receptor superfamily member 3', 83, NULL, NULL, 128330),
(128331, '3.40.50.300-FF-007119', NULL, 'Uncharacterized protein', 184, NULL, NULL, 128331),
(128332, '1.10.506.10-FF-000046', NULL, 'Uncharacterized protein', 208, NULL, NULL, 128332),
(128333, '3.30.160.60-FF-005596', NULL, NULL, 57, NULL, NULL, 128333),
(128334, '3.30.160.60-FF-001897', NULL, 'Zinc finger and BTB domain containing 11', 30, NULL, NULL, 128334),
(128335, '2.130.10.10-FF-001419', NULL, 'Actin-interacting protein 1', 279, NULL, NULL, 128335),
(128336, '2.130.10.10-FF-005607', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 189, NULL, NULL, 128336),
(128337, '2.60.40.1730-FF-000079', NULL, NULL, 198, NULL, NULL, 128337),
(128338, '3.40.390.10-FF-000267', NULL, NULL, 175, NULL, NULL, 128338),
(128339, '4.10.410.10-FF-000020', NULL, 'Collagen, type VI, alpha 3', 67, NULL, NULL, 128339),
(128340, '3.40.50.10130-FF-000028', NULL, 'YALI0C14960p', 150, NULL, NULL, 128340),
(128341, '3.10.20.590-FF-000001', NULL, 'Leucine--tRNA ligase', 63, NULL, NULL, 128341),
(128342, '1.20.58.200-FF-000007', NULL, NULL, 104, NULL, NULL, 128342),
(128343, '1.25.10.10-FF-000995', NULL, 'Condensin-2 complex subunit D3', 146, NULL, NULL, 128343),
(128344, '3.40.50.300-FF-000195', NULL, 'ATP-dependent zinc metalloprotease FTSH 11', 186, NULL, NULL, 128344),
(128345, '1.10.510.10-FF-003350', NULL, NULL, 238, NULL, NULL, 128345),
(128346, '3.40.50.720-FF-000669', NULL, 'SUMO-activating enzyme subunit', 203, NULL, NULL, 128346),
(128347, '1.20.142.10-FF-000018', NULL, 'Poly [ADP-ribose] polymerase', 144, NULL, NULL, 128347),
(128348, '1.20.5.3600-FF-000003', NULL, 'Related to nuclear pore protein NUP57', 54, NULL, NULL, 128348),
(128349, '1.10.1410.10-FF-000036', NULL, 'Nuclear poly(A) polymerase 1', 32, NULL, NULL, 128349),
(128350, '3.30.70.1660-FF-000025', NULL, 'Peptide chain release factor-like protein', 108, NULL, NULL, 128350),
(128351, '3.30.450.50-FF-000034', NULL, 'Longin-type vesicle-associated membrane protein putative', 131, NULL, NULL, 128351),
(128352, '1.10.238.10-FF-000344', NULL, 'Protein S100-A8', 93, NULL, NULL, 128352),
(128353, '3.40.366.10-FF-000054', NULL, 'Malonyl CoA-acyl carrier protein transacylase', 215, NULL, NULL, 128353);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(128354, '2.60.120.10-FF-000213', NULL, 'Malonyl-CoA decarboxylase (MCD), putative', 96, NULL, NULL, 128354),
(128355, '2.60.40.10-FF-004640', NULL, NULL, 94, NULL, NULL, 128355),
(128356, '2.10.25.10-FF-001504', NULL, 'Laminin subunit alpha-1-like Protein', 54, NULL, NULL, 128356),
(128357, '1.20.1070.10-FF-000541', NULL, 'Uncharacterized protein', 313, NULL, NULL, 128357),
(128358, '2.40.50.140-FF-000561', NULL, 'DNA helicase', 40, NULL, NULL, 128358),
(128359, '3.30.420.10-FF-000183', NULL, 'Putative phage transposase', 240, NULL, NULL, 128359),
(128360, '3.40.630.30-FF-000641', NULL, 'Uncharacterized protein', 222, NULL, NULL, 128360),
(128361, '1.10.510.10-FF-001888', NULL, 'Putative cyclin-dependent protein kinase family protein', 138, NULL, NULL, 128361),
(128362, '3.30.505.10-FF-000116', NULL, 'SH2 domain-containing protein 4B', 118, NULL, NULL, 128362),
(128363, '2.60.120.740-FF-000024', NULL, 'Uncharacterized protein', 121, NULL, NULL, 128363),
(128364, '1.10.510.10-FF-000365', NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase At1g17230', 212, NULL, NULL, 128364),
(128365, '2.60.120.970-FF-000076', NULL, 'Uncharacterized protein', 240, NULL, NULL, 128365),
(128366, '2.30.42.10-FF-000239', NULL, 'Golgi reassembly-stacking protein 1 isoform X3', 61, NULL, NULL, 128366),
(128367, '1.50.40.10-FF-000416', NULL, 'Uncharacterized protein', 200, NULL, NULL, 128367),
(128368, '4.10.1000.10-FF-000019', NULL, 'cleavage and polyadenylation specificity factor subunit 4 isoform X2', 47, NULL, NULL, 128368),
(128369, '3.30.1850.10-FF-000001', NULL, 'LOG family protein YgdH', 112, NULL, NULL, 128369),
(128370, '2.60.40.10-FF-000149', NULL, 'neural cell adhesion molecule 1 isoform X2', 102, NULL, NULL, 128370),
(128371, '3.40.50.300-FF-004798', NULL, 'Uncharacterized protein', 179, NULL, NULL, 128371),
(128372, '1.10.1070.11-FF-000033', NULL, 'Serine/threonine-protein kinase MEC1', 185, NULL, NULL, 128372),
(128373, '3.40.50.10810-FF-000035', NULL, 'DsDNA-dependent ATPase (Rad54b)', 265, NULL, NULL, 128373),
(128374, '1.10.230.10-FF-000006', NULL, 'Citrate synthase 2', 101, NULL, NULL, 128374),
(128375, '3.80.10.10-FF-001504', NULL, 'AGAP012425-PA', 106, NULL, NULL, 128375),
(128376, '2.120.10.80-FF-000070', NULL, 'kelch-like protein 8 isoform X1', 298, NULL, NULL, 128376),
(128377, '3.40.50.1820-FF-001335', NULL, '3-oxoadipate enol-lactonase family protein', 253, NULL, NULL, 128377),
(128378, '3.30.160.60-FF-003134', NULL, 'Zinc finger protein 790', 25, NULL, NULL, 128378),
(128379, '1.10.357.10-FF-000087', NULL, 'HTH-type transcriptional regulator BetI', 184, NULL, NULL, 128379),
(128380, '1.10.220.30-FF-000040', NULL, 'Flagellar motor switch protein FliG', 78, NULL, NULL, 128380),
(128381, '3.40.50.800-FF-000007', NULL, 'Histidine--tRNA ligase', 98, NULL, NULL, 128381),
(128382, '3.30.1150.10-FF-000004', NULL, 'TonB-dependent receptor', 99, NULL, NULL, 128382),
(128383, '2.40.50.100-FF-000009', NULL, 'Acetyltransferase component of pyruvate dehydrogenase complex', 81, NULL, NULL, 128383),
(128384, '3.30.60.20-FF-000001', NULL, 'Protein unc-13 homolog B', 57, NULL, NULL, 128384),
(128385, '3.80.10.10-FF-003062', NULL, 'Uncharacterized protein', 144, NULL, NULL, 128385),
(128386, '3.90.280.10-FF-000017', NULL, 'PEBP-like protein', 215, NULL, NULL, 128386),
(128387, '3.40.47.10-FF-000287', NULL, NULL, 56, NULL, NULL, 128387),
(128388, '3.40.50.1970-FF-000048', NULL, NULL, 142, NULL, NULL, 128388),
(128389, '3.90.660.10-FF-000114', NULL, NULL, 145, NULL, NULL, 128389),
(128390, '3.30.40.10-FF-002374', NULL, 'Chromatin modification-related protein', 73, NULL, NULL, 128390),
(128391, '2.30.42.10-FF-000470', NULL, 'Putative serine protease HhoA', 112, NULL, NULL, 128391),
(128392, '3.40.50.300-FF-000206', NULL, 'Ras-related protein Rab-3C', 186, NULL, NULL, 128392),
(128393, '3.30.70.260-FF-000071', NULL, 'GTP pyrophosphokinase', 80, NULL, NULL, 128393),
(128394, '1.10.472.80-FF-000038', NULL, 'TBC1 domain family member 5', 121, NULL, NULL, 128394),
(128395, '3.40.640.10-FF-000017', NULL, 'Glutamate decarboxylase', 295, NULL, NULL, 128395);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(128396, '3.55.20.10-FF-000001', NULL, 'Protein-L-isoaspartate O-methyltransferase', 116, NULL, NULL, 128396),
(128397, '3.60.40.10-FF-000310', NULL, 'Os11g0242200 protein', 236, NULL, NULL, 128397),
(128398, '1.25.40.10-FF-002745', NULL, 'Uncharacterized protein', 210, NULL, NULL, 128398),
(128399, '1.10.555.10-FF-000249', NULL, NULL, 148, NULL, NULL, 128399),
(128400, '1.25.40.10-FF-001317', NULL, 'Anaphase-promoting complex subunit CDC27', 184, NULL, NULL, 128400),
(128401, '3.40.50.12670-FF-000003', NULL, 'Carboxypeptidase', 78, NULL, NULL, 128401),
(128402, '3.40.630.10-FF-000303', NULL, 'Uncharacterized protein', 144, NULL, NULL, 128402),
(128403, '1.20.1250.20-FF-000996', NULL, 'Sugar transporter', 388, NULL, NULL, 128403),
(128404, '2.60.40.10-FF-002066', NULL, 'Turtle, isoform G', 74, NULL, NULL, 128404),
(128405, '3.40.50.300-FF-005321', NULL, 'Si:ch211-113e8.9', 157, NULL, NULL, 128405),
(128406, '1.25.10.10-FF-003070', NULL, 'Armadillo repeat-containing protein', 254, NULL, NULL, 128406),
(128407, '1.10.560.10-FF-000104', NULL, 'Predicted protein', 129, NULL, NULL, 128407),
(128408, '2.40.240.10-FF-000030', NULL, 'Putative glutaminyl-trna synthetase', 82, NULL, NULL, 128408),
(128409, '2.40.10.10-FF-000502', NULL, NULL, 102, NULL, NULL, 128409),
(128410, '3.30.70.1230-FF-000149', NULL, 'Uncharacterized protein', 192, NULL, NULL, 128410),
(128411, '3.80.10.10-FF-004377', NULL, 'Predicted protein', 366, NULL, NULL, 128411),
(128412, '3.40.50.1000-FF-000229', NULL, 'NLI interacting factor-like phosphatase', 228, NULL, NULL, 128412),
(128413, '1.10.1780.10-FF-000018', NULL, 'Chaperone protein ClpB', 140, NULL, NULL, 128413),
(128414, '2.10.25.10-FF-000791', NULL, 'Uninflatable, isoform C', 40, NULL, NULL, 128414),
(128415, '1.25.40.10-FF-003465', NULL, 'Pentatricopeptide repeat-containing protein At5g52850, chloroplastic', 104, NULL, NULL, 128415),
(128416, '2.40.50.140-FF-000662', NULL, 'DNA-directed RNA polymerase III subunit,putative', 125, NULL, NULL, 128416),
(128417, '1.10.10.10-FF-000129', NULL, 'Helix-turn-helix transcriptional regulator', 74, NULL, NULL, 128417),
(128418, '2.60.40.10-FF-005371', NULL, NULL, 60, NULL, NULL, 128418),
(128419, '1.20.5.390-FF-000008', NULL, 'Inhibitor of kappa light polypeptide gene enhancer in B-cells, kinase gamma', 69, NULL, NULL, 128419),
(128420, '3.40.50.1820-FF-000829', NULL, 'Alpha/beta-hydrolase', 337, NULL, NULL, 128420),
(128421, '1.50.40.10-FF-000079', NULL, 'Mitochondrial carrier protein RIM2', 108, NULL, NULL, 128421),
(128422, '3.40.50.2300-FF-001047', NULL, NULL, 145, NULL, NULL, 128422),
(128423, '1.25.10.10-FF-002440', NULL, 'Uncharacterized protein', 236, NULL, NULL, 128423),
(128424, '3.40.50.720-FF-002226', NULL, 'Uncharacterized protein', 102, NULL, NULL, 128424),
(128425, '3.30.160.60-FF-001998', NULL, 'Transcription factor IIIA', 30, NULL, NULL, 128425),
(128426, '3.30.70.100-FF-000063', NULL, 'N-terminal EF-hand calcium-binding protein 1-like', 134, NULL, NULL, 128426),
(128427, '2.170.270.10-FF-000170', NULL, 'Uncharacterized protein', 107, NULL, NULL, 128427),
(128428, '3.40.190.10-FF-000286', NULL, 'Transcriptional regulator, LysR family', 83, NULL, NULL, 128428),
(128429, '1.10.246.170-FF-000002', NULL, 'AEL162Wp', 82, NULL, NULL, 128429),
(128430, '1.20.1270.60-FF-000071', NULL, 'Uncharacterized protein, isoform U', 247, NULL, NULL, 128430),
(128431, '3.40.50.11260-FF-000030', NULL, 'Heat shock protein', 87, NULL, NULL, 128431),
(128432, '3.30.497.10-FF-000051', NULL, 'Serine protease inhibitor (serpin) 12', 141, NULL, NULL, 128432),
(128433, '3.30.1520.10-FF-000027', NULL, 'Phospholipase', 128, NULL, NULL, 128433),
(128434, '3.30.160.60-FF-002162', NULL, 'E3 ubiquitin-protein ligase TRIM69', 35, NULL, NULL, 128434),
(128435, '3.30.70.330-FF-001053', NULL, 'Protein CBG12231', 94, NULL, NULL, 128435),
(128436, '3.40.800.20-FF-000011', NULL, 'Histone deacetylase HOS3', 460, NULL, NULL, 128436),
(128437, '2.60.40.10-FF-004432', NULL, NULL, 91, NULL, NULL, 128437),
(128438, '2.80.10.50-FF-000012', NULL, 'Protein O-mannosyl-transferase 1', 202, NULL, NULL, 128438);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(128439, '3.20.20.190-FF-000160', NULL, NULL, 177, NULL, NULL, 128439),
(128440, '3.60.110.10-FF-000057', NULL, 'Nit1p', 197, NULL, NULL, 128440),
(128441, '2.60.40.60-FF-001108', NULL, 'Uncharacterized protein', 92, NULL, NULL, 128441),
(128442, '1.10.246.190-FF-000008', NULL, NULL, 54, NULL, NULL, 128442),
(128443, '1.20.1740.10-FF-000171', NULL, 'Amino acid transporter (Eurofung)', 94, NULL, NULL, 128443),
(128444, '3.80.10.10-FF-000189', NULL, 'Tyrosine-protein kinase receptor', 97, NULL, NULL, 128444),
(128445, '2.30.29.30-FF-000484', NULL, 'Transcription initiation factor TFIIH subunit', 115, NULL, NULL, 128445),
(128446, '1.25.40.720-FF-000014', NULL, 'Uncharacterized protein', 162, NULL, NULL, 128446),
(128447, '3.90.1600.10-FF-000059', NULL, 'REV3 like, DNA directed polymerase zeta catalytic subunit', 122, NULL, NULL, 128447),
(128448, '3.30.70.270-FF-000169', NULL, 'Putative diguanylate cyclase', 172, NULL, NULL, 128448),
(128449, '2.130.10.10-FF-002038', NULL, 'Transcriptional corepressor LEUNIG', 220, NULL, NULL, 128449),
(128450, '3.40.50.620-FF-000285', NULL, 'Leucyl-tRNA synthetase', 212, NULL, NULL, 128450),
(128451, '3.30.200.20-FF-001176', NULL, 'WGS project CABT00000000 data, contig 2.13', 143, NULL, NULL, 128451),
(128452, '3.30.200.20-FF-000557', NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', 115, NULL, NULL, 128452),
(128453, '1.25.40.10-FF-004302', NULL, 'Putative pentatricopeptide repeat-containing protein', 193, NULL, NULL, 128453),
(128454, '2.130.10.10-FF-005815', NULL, 'Predicted protein', 78, NULL, NULL, 128454),
(128455, '3.90.1750.10-FF-000042', NULL, 'E3 ubiquitin-protein ligase HECTD1', 35, NULL, NULL, 128455),
(128456, '3.20.20.70-FF-000087', NULL, 'Anaerobic ribonucleoside-triphosphate reductase-activating protein', 152, NULL, NULL, 128456),
(128457, '3.40.1190.20-FF-000153', NULL, 'PfkB-type carbohydrate kinase', 348, NULL, NULL, 128457),
(128458, '3.30.160.100-FF-000009', NULL, 'Ribosome hibernation promoting factor', 103, NULL, NULL, 128458),
(128459, '1.10.287.1490-FF-000065', NULL, 'Nuclear mitotic apparatus protein 1', 190, NULL, NULL, 128459),
(128460, '1.10.196.10-FF-000010', NULL, 'regulator of G-protein signaling 10 isoform X2', 36, NULL, NULL, 128460),
(128461, '2.10.25.10-FF-000886', NULL, 'LDL receptor protein 1, isoform G', 40, NULL, NULL, 128461),
(128462, '3.90.550.10-FF-000353', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 397, NULL, NULL, 128462),
(128463, '3.40.50.1000-FF-000128', NULL, 'Calcium-transporting ATPase', 156, NULL, NULL, 128463),
(128464, '3.40.367.20-FF-000014', NULL, 'Phosphotransferase', 273, NULL, NULL, 128464),
(128465, '1.25.40.10-FF-001109', NULL, 'Pentatricopeptide repeat-containing protein At4g31850, chloroplastic', 105, NULL, NULL, 128465),
(128466, '2.60.120.1680-FF-000002', NULL, 'Polyprotein ORF1ab', 139, NULL, NULL, 128466),
(128467, '3.60.40.10-FF-000102', NULL, 'Protein phosphatase PPM3, putative', 282, NULL, NULL, 128467),
(128468, '1.20.58.60-FF-000372', NULL, 'nesprin-2 isoform X2', 302, NULL, NULL, 128468),
(128469, '3.90.76.10-FF-000054', NULL, 'Peptide ABC transporter, peptide-binding protein', 51, NULL, NULL, 128469),
(128470, '3.30.70.330-FF-001637', NULL, 'Peptidyl-prolyl cis-trans isomerase-like 4', 157, NULL, NULL, 128470),
(128471, '1.10.472.10-FF-000500', NULL, 'Uncharacterized protein', 106, NULL, NULL, 128471),
(128472, '4.10.400.10-FF-000323', NULL, 'Complement component C9', 47, NULL, NULL, 128472),
(128473, '2.60.40.10-FF-000037', NULL, 'Unc-5 netrin receptor C', 110, NULL, NULL, 128473),
(128474, '2.40.50.100-FF-000122', NULL, 'Exosome complex exonuclease RRP4', 53, NULL, NULL, 128474),
(128475, '3.10.450.60-FF-000002', NULL, 'Lipoxygenase', 135, NULL, NULL, 128475),
(128476, '1.10.540.10-FF-000092', NULL, 'Acyl-CoA dehydrogenase FadE32', 115, NULL, NULL, 128476),
(128477, '3.90.70.200-FF-000017', NULL, 'Paf1 complex component', 138, NULL, NULL, 128477),
(128478, '3.40.50.150-FF-001066', NULL, NULL, 250, NULL, NULL, 128478),
(128479, '3.40.30.10-FF-000439', NULL, 'Electron carrier/ oxidoreductase', 197, NULL, NULL, 128479);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(128480, '1.10.8.100-FF-000014', NULL, 'RNA polymerase specificity factor', 69, NULL, NULL, 128480),
(128481, '3.40.50.300-FF-003972', NULL, 'Uncharacterized protein', 145, NULL, NULL, 128481),
(128482, '1.20.1070.10-FF-001513', NULL, 'Oxytocin receptor', 194, NULL, NULL, 128482),
(128483, '2.70.98.20-FF-000009', NULL, 'Amine oxidase', 417, NULL, NULL, 128483),
(128484, '3.90.640.10-FF-000006', NULL, 'Actin-related protein 3 (ARP3)', 99, NULL, NULL, 128484),
(128485, '3.40.50.2300-FF-000428', NULL, 'Guanylate cyclase', 102, NULL, NULL, 128485),
(128486, '3.30.40.10-FF-001879', NULL, 'Uncharacterized protein', 76, NULL, NULL, 128486),
(128487, '1.25.10.10-FF-001821', NULL, 'Predicted protein', 378, NULL, NULL, 128487),
(128488, '2.160.20.10-FF-000267', NULL, 'Pectin lyase-like superfamily protein', 74, NULL, NULL, 128488),
(128489, '3.40.309.10-FF-000079', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', 191, NULL, NULL, 128489),
(128490, '1.10.510.10-FF-003018', NULL, NULL, 138, NULL, NULL, 128490),
(128491, '2.60.40.10-FF-001785', NULL, 'Basement membrane proteoglycan', 92, NULL, NULL, 128491),
(128492, '3.80.10.10-FF-003174', NULL, 'Uncharacterized protein', 411, NULL, NULL, 128492),
(128493, '1.25.40.20-FF-000253', NULL, 'Serine/threonine-protein phosphatase 6 regulatory ankyrin repeat subunit A', 56, NULL, NULL, 128493),
(128494, '1.20.190.20-FF-000008', NULL, 'F-box protein GID2', 65, NULL, NULL, 128494),
(128495, '2.30.30.140-FF-000036', NULL, 'PWWP domain-containing protein 2A', 117, NULL, NULL, 128495),
(128496, '1.50.10.20-FF-000125', NULL, 'Uncharacterized protein', 66, NULL, NULL, 128496),
(128497, '1.10.287.370-FF-000104', NULL, 'Uncharacterized protein', 137, NULL, NULL, 128497),
(128498, '2.130.10.10-FF-002370', NULL, 'Axonemal Inner Arm I1 Intermediate Chain Dynein', 139, NULL, NULL, 128498),
(128499, '1.10.630.10-FF-000211', NULL, 'CYtochrome P450 family', 354, NULL, NULL, 128499),
(128500, '3.30.40.10-FF-000345', NULL, 'Vacuolar protein sorting-associated protein 27', 67, NULL, NULL, 128500),
(128501, '3.40.50.720-FF-000877', NULL, 'NAD(P)-dependent oxidoreductase', 254, NULL, NULL, 128501),
(128502, '3.20.10.10-FF-000023', NULL, 'Branched-chain amino acid aminotransferase', 178, NULL, NULL, 128502),
(128503, '1.10.510.10-FF-000601', NULL, 'Atypical/RIO/RIO2 protein kinase', 133, NULL, NULL, 128503),
(128504, '1.10.630.10-FF-000762', NULL, 'Uncharacterized protein', 484, NULL, NULL, 128504),
(128505, '2.70.98.40-FF-000015', NULL, NULL, 261, NULL, NULL, 128505),
(128506, '3.30.460.10-FF-000096', NULL, 'Tailor, isoform A', 110, NULL, NULL, 128506),
(128507, '1.10.287.70-FF-000183', NULL, 'KCNN (Potassium K ChaNNel, calcium activated)-Like', 258, NULL, NULL, 128507),
(128508, '1.20.5.340-FF-000022', NULL, 'Rabaptin, RAB GTPase-binding effector protein 1', 92, NULL, NULL, 128508),
(128509, '3.40.50.261-FF-000032', NULL, 'ATP-citrate synthase subunit alpha chain protein 1', 40, NULL, NULL, 128509),
(128510, '3.40.50.2000-FF-000428', NULL, 'Glycosyltransferase', 232, NULL, NULL, 128510),
(128511, '1.25.10.10-FF-001945', NULL, 'Predicted protein', 298, NULL, NULL, 128511),
(128512, '3.30.450.40-FF-000126', NULL, 'Serine/threonine-protein phosphatase', 177, NULL, NULL, 128512),
(128513, '3.40.630.30-FF-000309', NULL, 'Increased DNA methylation 1', 119, NULL, NULL, 128513),
(128514, '3.30.160.60-FF-000374', NULL, 'Zinc finger protein 208', 28, NULL, NULL, 128514),
(128515, '3.10.100.10-FF-000377', NULL, NULL, 174, NULL, NULL, 128515),
(128516, '3.30.260.10-FF-000108', NULL, NULL, 35, NULL, NULL, 128516),
(128517, '1.10.220.10-FF-000045', NULL, 'Uncharacterized protein', 79, NULL, NULL, 128517),
(128518, '1.10.287.1130-FF-000002', NULL, 'cx9C motif-containing protein 4 isoform X2', 68, NULL, NULL, 128518),
(128519, '2.130.10.10-FF-005484', NULL, 'Uncharacterized protein', 133, NULL, NULL, 128519),
(128520, '1.10.287.130-FF-000038', NULL, 'Sensory transduction histidine kinase', 90, NULL, NULL, 128520),
(128521, '3.20.20.380-FF-000009', NULL, 'Copper homeostasis protein CutC', 252, NULL, NULL, 128521);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(128522, '2.30.30.380-FF-000007', NULL, 'RanBP-type and C3HC4-type zinc finger-containing protein 1', 64, NULL, NULL, 128522),
(128523, '3.80.10.10-FF-002909', NULL, 'Uncharacterized protein', 97, NULL, NULL, 128523),
(128524, '3.40.50.720-FF-001506', NULL, 'Uncharacterized protein', 135, NULL, NULL, 128524),
(128525, '3.30.830.10-FF-000225', NULL, 'Mitochondrial presequence protease', 96, NULL, NULL, 128525),
(128526, '3.20.20.360-FF-000003', NULL, 'Malate synthase G', 237, NULL, NULL, 128526),
(128527, '3.90.1290.10-FF-000023', NULL, 'microtubule-actin cross-linking factor 1 isoform X12', 283, NULL, NULL, 128527),
(128528, '3.30.420.10-FF-000306', NULL, 'DNA polymerase', 264, NULL, NULL, 128528),
(128529, '3.90.70.10-FF-000007', NULL, 'Probable ubiquitin carboxyl-terminal hydrolase FAF-X', 366, NULL, NULL, 128529),
(128530, '3.40.50.300-FF-006147', NULL, 'Uncharacterized ATP-dependent helicase MG140', 333, NULL, NULL, 128530),
(128531, '1.20.120.350-FF-000125', NULL, 'Protein CBR-SHW-1', 172, NULL, NULL, 128531),
(128532, '2.30.30.360-FF-000001', NULL, 'Myosin heavy chain', 50, NULL, NULL, 128532),
(128533, '1.10.10.160-FF-000030', NULL, 'DNA helicase', 61, NULL, NULL, 128533),
(128534, '1.20.1250.20-FF-000187', NULL, 'Solute carrier family 16 member 11', 390, NULL, NULL, 128534),
(128535, '1.10.510.10-FF-003799', NULL, NULL, 124, NULL, NULL, 128535),
(128536, '1.10.167.10-FF-000033', NULL, 'CRE-EAT-16 protein', 159, NULL, NULL, 128536),
(128537, '3.30.230.10-FF-000270', NULL, 'Mevalonate kinase', 171, NULL, NULL, 128537),
(128538, '3.40.50.1820-FF-001543', NULL, 'Uncharacterized protein', 130, NULL, NULL, 128538),
(128539, '2.60.200.20-FF-000279', NULL, 'Probable serine/threonine-protein kinase fhkB', 192, NULL, NULL, 128539),
(128540, '3.40.50.300-FF-008300', NULL, 'Uncharacterized protein', 11, NULL, NULL, 128540),
(128541, '3.40.50.1820-FF-000262', NULL, 'Carboxypeptidase', 421, NULL, NULL, 128541),
(128542, '3.90.550.50-FF-000106', NULL, 'Hexosyltransferase', 194, NULL, NULL, 128542),
(128543, '3.40.1110.10-FF-000044', NULL, 'Phospholipid-transporting ATPase', 53, NULL, NULL, 128543),
(128544, '1.10.860.10-FF-000020', NULL, 'Replicative DNA helicase', 159, NULL, NULL, 128544),
(128545, '3.80.10.10-FF-003415', NULL, 'Uncharacterized protein', 82, NULL, NULL, 128545),
(128546, '3.40.50.2300-FF-000855', NULL, NULL, 94, NULL, NULL, 128546),
(128547, '1.20.1560.10-FF-000185', NULL, 'ABC transporter ATP-binding protein/permease', 335, NULL, NULL, 128547),
(128548, '2.60.40.10-FF-005157', NULL, NULL, 119, NULL, NULL, 128548),
(128549, '1.25.40.10-FF-001773', NULL, 'Pentatricopeptide repeat-containing protein At2g36730', 163, NULL, NULL, 128549),
(128550, '2.40.50.140-FF-001179', NULL, NULL, 102, NULL, NULL, 128550),
(128551, '1.10.287.1150-FF-000008', NULL, 'Oxoglutarate dehydrogenase (Succinyl-transferring), E1 component', 95, NULL, NULL, 128551),
(128552, '3.40.50.10180-FF-000003', NULL, 'GLYCTK isoform 4', 203, NULL, NULL, 128552),
(128553, '3.30.900.10-FF-000012', NULL, 'Hop1p', 254, NULL, NULL, 128553),
(128554, '1.10.510.10-FF-004075', NULL, NULL, 178, NULL, NULL, 128554),
(128555, '3.80.10.10-FF-003758', NULL, 'Uncharacterized protein', 118, NULL, NULL, 128555),
(128556, '2.160.20.10-FF-000166', NULL, 'Uncharacterized protein', 150, NULL, NULL, 128556),
(128557, '1.20.1070.10-FF-000996', NULL, 'Uncharacterized protein', 366, NULL, NULL, 128557),
(128558, '1.10.3330.10-FF-000002', NULL, 'Uric acid degradation bifunctional protein TTL', 155, NULL, NULL, 128558),
(128559, '3.40.50.300-FF-007007', NULL, 'Uncharacterized protein', 209, NULL, NULL, 128559),
(128560, '3.10.50.10-FF-000009', NULL, 'CTS2p putative chitinase', 59, NULL, NULL, 128560),
(128561, '4.10.365.10-FF-000010', NULL, 'Cyclin-dependent kinase inhibitor 1', 86, NULL, NULL, 128561),
(128562, '3.30.230.10-FF-000371', NULL, 'Uncharacterized protein', 77, NULL, NULL, 128562),
(128563, '2.70.220.10-FF-000005', NULL, 'Putative phosphatidylglycerol/phosphatidylinositol transfer protein DDB_G0282107', 123, NULL, NULL, 128563);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(128564, '3.30.450.60-FF-000008', NULL, 'Coatomer subunit zeta-1 isoform 1', 146, NULL, NULL, 128564),
(128565, '1.20.58.670-FF-000002', NULL, 'Exocyst complex component', 149, NULL, NULL, 128565),
(128566, '3.40.50.2300-FF-001131', NULL, NULL, 134, NULL, NULL, 128566),
(128567, '4.10.1000.40-FF-000017', NULL, 'Uncharacterized protein', 72, NULL, NULL, 128567),
(128568, '1.10.510.10-FF-002630', NULL, NULL, 41, NULL, NULL, 128568),
(128569, '1.20.1250.20-FF-002233', NULL, 'Uncharacterized protein', 123, NULL, NULL, 128569),
(128570, '1.50.40.10-FF-000192', NULL, 'Mitochondrial Carrier (MC) Family', 146, NULL, NULL, 128570),
(128571, '1.25.10.10-FF-001737', NULL, 'Uncharacterized protein', 183, NULL, NULL, 128571),
(128572, '2.40.50.120-FF-000004', NULL, 'WAP, Kazal, immunoglobulin, Kunitz and NTR domain-containing protein 2', 129, NULL, NULL, 128572),
(128573, '1.20.1560.10-FF-000640', NULL, 'Uncharacterized protein', 158, NULL, NULL, 128573),
(128574, '3.60.21.10-FF-000390', NULL, 'Protein phosphatase 5, catalytic subunit', 46, NULL, NULL, 128574),
(128575, '3.80.10.10-FF-000083', NULL, 'Leiomodin 1', 187, NULL, NULL, 128575),
(128576, '1.10.630.10-FF-000099', NULL, 'Uncharacterized protein', 446, NULL, NULL, 128576),
(128577, '2.10.25.10-FF-000678', NULL, 'Uromodulin', 45, NULL, NULL, 128577),
(128578, '3.60.21.10-FF-000070', NULL, '5`-nucleotidase family protein', 340, NULL, NULL, 128578),
(128579, '3.50.50.60-FF-001416', NULL, 'Uncharacterized protein', 130, NULL, NULL, 128579),
(128580, '2.40.50.140-FF-001281', NULL, NULL, 135, NULL, NULL, 128580),
(128581, '2.70.98.90-FF-000002', NULL, 'Membrane protein insertase YidC', 267, NULL, NULL, 128581),
(128582, '1.20.1250.10-FF-000089', NULL, NULL, 176, NULL, NULL, 128582),
(128583, '3.30.70.1560-FF-000001', NULL, 'Pseudouridine synthase', 84, NULL, NULL, 128583),
(128584, '3.40.850.10-FF-000527', NULL, 'Uncharacterized protein', 94, NULL, NULL, 128584),
(128585, '3.90.180.10-FF-000184', NULL, 'Uncharacterized protein', 54, NULL, NULL, 128585),
(128586, '3.80.10.10-FF-004034', NULL, 'Uncharacterized protein', 144, NULL, NULL, 128586),
(128587, '1.25.10.10-FF-002013', NULL, 'Splicing factor 3B subunit 1', 404, NULL, NULL, 128587),
(128588, '1.10.510.10-FF-001337', NULL, 'Uncharacterized protein', 256, NULL, NULL, 128588),
(128589, '3.30.1490.480-FF-000010', NULL, 'Endolytic murein transglycosylase', 81, NULL, NULL, 128589),
(128590, '3.40.50.410-FF-000239', NULL, 'Uncharacterized protein', 170, NULL, NULL, 128590),
(128591, '3.30.1780.10-FF-000006', NULL, 'Proline utilization protein PrnX, putative', 132, NULL, NULL, 128591),
(128592, '3.40.1280.10-FF-000045', NULL, 'Apicoplast RNA methyltransferase', 188, NULL, NULL, 128592),
(128593, '3.30.700.20-FF-000005', NULL, 'Uncharacterized protein', 103, NULL, NULL, 128593),
(128594, '2.70.50.40-FF-000006', NULL, 'Retinal protein, putative', 192, NULL, NULL, 128594),
(128595, '1.25.10.10-FF-000309', NULL, 'NOP9 nucleolar protein', 327, NULL, NULL, 128595),
(128596, '1.10.287.130-FF-000151', NULL, 'Sensor histidine kinase KdpD', 74, NULL, NULL, 128596),
(128597, '3.40.50.1000-FF-000460', NULL, NULL, 152, NULL, NULL, 128597),
(128598, '3.40.50.300-FF-007783', NULL, '26S protease regulatory subunit 6B, putative', 52, NULL, NULL, 128598),
(128599, '1.10.10.10-FF-001765', NULL, 'Uncharacterized protein', 89, NULL, NULL, 128599),
(128600, '3.90.190.10-FF-000269', NULL, 'Predicted protein', 55, NULL, NULL, 128600),
(128601, '3.40.850.10-FF-000286', NULL, 'Uncharacterized protein', 95, NULL, NULL, 128601),
(128602, '1.20.1600.10-FF-000015', NULL, 'Outer membrane efflux protein', 410, NULL, NULL, 128602),
(128603, '3.40.50.2000-FF-000771', NULL, 'Glucuronosyltransferase', 171, NULL, NULL, 128603),
(128604, '1.10.150.50-FF-000034', NULL, 'ankyrin repeat and SAM domain-containing protein 4B', 73, NULL, NULL, 128604),
(128605, '3.40.50.1820-FF-001200', NULL, 'Uncharacterized protein', 100, NULL, NULL, 128605),
(128606, '2.130.10.30-FF-000122', NULL, NULL, 225, NULL, NULL, 128606),
(128607, '2.130.10.10-FF-003095', NULL, 'WD repeat domain 90', 47, NULL, NULL, 128607);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(128608, '3.10.20.30-FF-000064', NULL, 'SDHB isoform 7', 85, NULL, NULL, 128608),
(128609, '3.40.50.300-FF-006046', NULL, 'DNA polymerase theta', 196, NULL, NULL, 128609),
(128610, '1.10.220.160-FF-000008', NULL, 'Down and out, isoform A', 81, NULL, NULL, 128610),
(128611, '2.30.30.790-FF-000012', NULL, 'Related to 50S ribosomal protein L19', 144, NULL, NULL, 128611),
(128612, '1.10.150.50-FF-000169', NULL, 'Protein Smaug homolog 2', 30, NULL, NULL, 128612),
(128613, '2.60.40.10-FF-000380', NULL, 'obscurin isoform X3', 95, NULL, NULL, 128613),
(128614, '3.40.50.1400-FF-000035', NULL, 'Ferrochelatase', 172, NULL, NULL, 128614),
(128615, '3.30.565.10-FF-000108', NULL, 'Putative heat shock protein HSP 90-beta 2', 113, NULL, NULL, 128615),
(128616, '3.30.200.20-FF-002002', NULL, NULL, 96, NULL, NULL, 128616),
(128617, '1.10.630.10-FF-000554', NULL, 'Uncharacterized protein', 337, NULL, NULL, 128617),
(128618, '3.90.550.20-FF-000002', NULL, 'Initiation-specific alpha-1,6-mannosyltransferase', 231, NULL, NULL, 128618),
(128619, '1.50.10.20-FF-000024', NULL, 'Geranylgeranyl transferase type-2 subunit beta', 130, NULL, NULL, 128619),
(128620, '3.10.50.40-FF-000102', NULL, 'Peptidyl-prolyl cis-trans isomerase', 142, NULL, NULL, 128620),
(128621, '3.40.50.300-FF-007327', NULL, 'Os05g0563100 protein', 144, NULL, NULL, 128621),
(128622, '2.30.29.30-FF-000725', NULL, 'Target of rapamycin complex 2 subunit MAPKAP1', 122, NULL, NULL, 128622),
(128623, '4.10.400.10-FF-000082', NULL, 'Transmembrane serine protease 6', 33, NULL, NULL, 128623),
(128624, '2.10.90.10-FF-000076', NULL, 'Interleukin 17c', 111, NULL, NULL, 128624),
(128625, '1.10.238.10-FF-000799', NULL, 'Phosphoinositide phospholipase C', 79, NULL, NULL, 128625),
(128626, '3.30.160.60-FF-005388', NULL, NULL, 25, NULL, NULL, 128626),
(128627, '1.50.40.10-FF-000315', NULL, 'AaceriACR260Wp', 200, NULL, NULL, 128627),
(128628, '3.30.565.10-FF-000440', NULL, 'Signal-transducing histidine kinase homolog', 149, NULL, NULL, 128628),
(128629, '3.10.290.10-FF-000025', NULL, '30S ribosomal subunit S4', 133, NULL, NULL, 128629),
(128630, '1.10.30.10-FF-000030', NULL, 'HMG domain-containing protein 4 isoform X1', 103, NULL, NULL, 128630),
(128631, '2.60.40.10-FF-005955', NULL, NULL, 90, NULL, NULL, 128631),
(128632, '3.40.720.10-FF-000086', NULL, 'CRE-SUL-1 protein', 436, NULL, NULL, 128632),
(128633, '1.10.10.60-FF-001089', NULL, NULL, 74, NULL, NULL, 128633),
(128634, '2.10.70.10-FF-000187', NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing 1', 69, NULL, NULL, 128634),
(128635, '3.30.460.10-FF-000180', NULL, 'DNA polymerase sigma-like protein', 53, NULL, NULL, 128635),
(128636, '3.30.200.20-FF-000080', NULL, 'Protein kinase C', 141, NULL, NULL, 128636),
(128637, '4.10.60.10-FF-000120', NULL, 'Zinc knuckle (CCHC-type) family protein', 51, NULL, NULL, 128637),
(128638, '1.20.1540.10-FF-000077', NULL, 'Rhomboid family intramembrane serine protease', 219, NULL, NULL, 128638),
(128639, '2.30.29.30-FF-001001', NULL, 'Phosphoinositide phospholipase C', 128, NULL, NULL, 128639),
(128640, '2.40.50.690-FF-000017', NULL, 'Mitotic control protein dis3', 96, NULL, NULL, 128640),
(128641, '3.10.580.10-FF-000002', NULL, 'Magnesium/cobalt efflux protein CorC', 148, NULL, NULL, 128641),
(128642, '1.20.58.90-FF-000032', NULL, NULL, 103, NULL, NULL, 128642),
(128643, '1.20.58.60-FF-000259', NULL, 'Spectrin beta, non-erythrocytic 5', 111, NULL, NULL, 128643),
(128644, '3.90.45.10-FF-000027', NULL, 'Peptide deformylase', 135, NULL, NULL, 128644),
(128645, '3.40.1110.10-FF-000387', NULL, NULL, 133, NULL, NULL, 128645),
(128646, '3.30.720.50-FF-000009', NULL, 'E3 ubiquitin-protein ligase HUWE1 isoform X2', 80, NULL, NULL, 128646),
(128647, '1.10.238.10-FF-001199', NULL, 'Phosphatidylserine decarboxylase proenzyme 2', 78, NULL, NULL, 128647),
(128648, '3.90.1430.10-FF-000012', NULL, NULL, 74, NULL, NULL, 128648),
(128649, '1.10.8.60-FF-000481', NULL, 'Uncharacterized protein', 53, NULL, NULL, 128649),
(128650, '3.40.50.1100-FF-000147', NULL, 'Cystathionine beta-synthase', 188, NULL, NULL, 128650);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(128651, '2.130.10.10-FF-003550', NULL, 'Anaphase-promoting complex subunit 4', 177, NULL, NULL, 128651),
(128652, '2.40.30.30-FF-000037', NULL, 'Uncharacterized protein', 139, NULL, NULL, 128652),
(128653, '1.10.10.1320-FF-000007', NULL, 'Putative transmembrane anti-sigma factor', 95, NULL, NULL, 128653),
(128654, '3.40.30.10-FF-000198', NULL, 'Glutathione S-transferase family protein', 175, NULL, NULL, 128654),
(128655, '1.10.510.10-FF-002973', NULL, NULL, 90, NULL, NULL, 128655),
(128656, '3.30.450.20-FF-000255', NULL, 'Sensory transduction histidine kinase', 112, NULL, NULL, 128656),
(128657, '3.40.50.10490-FF-000091', NULL, 'Iron dicitrate transport regulator FecR', 175, NULL, NULL, 128657),
(128658, '2.130.10.10-FF-001650', NULL, 'Transducin/WD40 repeat-like superfamily protein', 76, NULL, NULL, 128658),
(128659, '1.10.390.10-FF-000046', NULL, 'Aminopeptidase', 250, NULL, NULL, 128659),
(128660, '3.30.450.20-FF-000036', NULL, 'Putative LOV domain-containing protein', 157, NULL, NULL, 128660),
(128661, '3.80.10.10-FF-000987', NULL, 'Uncharacterized protein', 107, NULL, NULL, 128661),
(128662, '2.60.40.10-FF-000048', NULL, 'receptor-type tyrosine-protein phosphatase U isoform X1', 99, NULL, NULL, 128662),
(128663, '4.10.900.10-FF-000007', NULL, 'Cadherin 22', 94, NULL, NULL, 128663),
(128664, '1.25.10.10-FF-002917', NULL, 'ARM repeat superfamily protein', 110, NULL, NULL, 128664),
(128665, '2.120.10.30-FF-000448', NULL, 'Uncharacterized protein', 112, NULL, NULL, 128665),
(128666, '3.90.190.10-FF-000145', NULL, 'receptor-type tyrosine-protein phosphatase epsilon-like isoform X1', 284, NULL, NULL, 128666),
(128667, '3.30.450.20-FF-000379', NULL, 'Sensory box histidine kinase, putative', 127, NULL, NULL, 128667),
(128668, '1.10.405.20-FF-000005', NULL, NULL, 118, NULL, NULL, 128668),
(128669, '2.10.60.10-FF-000029', NULL, 'Receptor protein serine/threonine kinase', 104, NULL, NULL, 128669),
(128670, '3.30.70.330-FF-002918', NULL, NULL, 127, NULL, NULL, 128670),
(128671, '2.20.28.10-FF-000055', NULL, 'Uncharacterized MCM-type protein MJ1489', 55, NULL, NULL, 128671),
(128672, '3.20.20.80-FF-000640', NULL, 'Uncharacterized protein', 104, NULL, NULL, 128672),
(128673, '1.25.40.80-FF-000017', NULL, 'Cryptochrome DASH', 173, NULL, NULL, 128673),
(128674, '1.25.40.10-FF-000137', NULL, 'Pre-mRNA-splicing factor syf1', 147, NULL, NULL, 128674),
(128675, '3.40.47.10-FF-000079', NULL, 'Acetyl-CoA acetyltransferase, putative', 393, NULL, NULL, 128675),
(128676, '2.60.120.200-FF-000536', NULL, 'Galectin', 139, NULL, NULL, 128676),
(128677, '1.10.400.10-FF-000031', NULL, 'Guanine nucleotide-binding protein alpha-10 subunit', 120, NULL, NULL, 128677),
(128678, '1.20.120.1150-FF-000012', NULL, 'Serine/threonine-protein phosphatase 2A activator', 117, NULL, NULL, 128678),
(128679, '2.60.40.10-FF-003926', NULL, NULL, 107, NULL, NULL, 128679),
(128680, '1.20.1720.10-FF-000063', NULL, 'MFS multidrug transporter, putative (AFU_orthologue AFUA_2G05840)', 300, NULL, NULL, 128680),
(128681, '1.20.91.20-FF-000010', NULL, 'Uncharacterized protein', 81, NULL, NULL, 128681),
(128682, '3.30.870.10-FF-000014', NULL, 'Cardiolipin synthase', 189, NULL, NULL, 128682),
(128683, '2.60.40.1930-FF-000038', NULL, 'Uncharacterized protein', 116, NULL, NULL, 128683),
(128684, '3.30.930.10-FF-000183', NULL, 'Phenylalanine--tRNA ligase alpha subunit', 332, NULL, NULL, 128684),
(128685, '2.60.40.1910-FF-000032', NULL, NULL, 85, NULL, NULL, 128685),
(128686, '2.130.10.10-FF-002611', NULL, 'Predicted protein', 431, NULL, NULL, 128686),
(128687, '3.40.50.300-FF-004910', NULL, 'GTP-binding nuclear protein Ran', 215, NULL, NULL, 128687),
(128688, '2.170.190.11-FF-000013', NULL, 'Molybdopterin molybdenumtransferase', 92, NULL, NULL, 128688),
(128689, '3.60.40.10-FF-000208', NULL, 'Stage II sporulation protein E', 221, NULL, NULL, 128689),
(128690, '2.60.40.10-FF-004202', NULL, NULL, 80, NULL, NULL, 128690),
(128691, '2.60.40.10-FF-001009', NULL, 'Interleukin-12 subunit beta', 91, NULL, NULL, 128691),
(128692, '3.40.50.300-FF-000307', NULL, 'Phosphoribulokinase', 289, NULL, NULL, 128692);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(128693, '1.20.90.10-FF-000038', NULL, NULL, 81, NULL, NULL, 128693),
(128694, '1.20.1070.10-FF-000198', NULL, 'Prostaglandin I2 receptor', 320, NULL, NULL, 128694),
(128695, '1.20.190.50-FF-000006', NULL, 'Nuclear pore complex protein', 168, NULL, NULL, 128695),
(128696, '3.30.56.30-FF-000016', NULL, 'Uncharacterized protein', 122, NULL, NULL, 128696),
(128697, '2.70.98.40-FF-000004', NULL, 'Alpha,alpha-trehalose glucohydrolase TreA/Ath1', 282, NULL, NULL, 128697),
(128698, '2.60.40.10-FF-005612', NULL, NULL, 103, NULL, NULL, 128698),
(128699, '3.40.50.300-FF-001717', NULL, 'ATPase family AAA domain-containing protein', 193, NULL, NULL, 128699),
(128700, '3.40.50.720-FF-001849', NULL, 'Uncharacterized protein', 49, NULL, NULL, 128700),
(128701, '3.30.160.60-FF-006225', NULL, NULL, 52, NULL, NULL, 128701),
(128702, '3.90.199.10-FF-000013', NULL, NULL, 183, NULL, NULL, 128702),
(128703, '3.40.50.300-FF-004017', NULL, 'DRS1-like protein', 173, NULL, NULL, 128703),
(128704, '3.30.70.100-FF-000164', NULL, NULL, 78, NULL, NULL, 128704),
(128705, '1.10.1420.10-FF-000205', NULL, 'Predicted protein', 75, NULL, NULL, 128705),
(128706, '3.40.50.300-FF-003617', NULL, 'Guanylate-binding family protein', 111, NULL, NULL, 128706),
(128707, '2.60.40.10-FF-002302', NULL, 'Titin homolog', 106, NULL, NULL, 128707),
(128708, '1.20.1110.10-FF-000157', NULL, NULL, 91, NULL, NULL, 128708),
(128709, '3.20.20.140-FF-000061', NULL, 'Adenine deaminase', 249, NULL, NULL, 128709),
(128710, '2.30.110.10-FF-000079', NULL, 'Nitroreductase family deazaflavin-dependent oxidoreductase', 134, NULL, NULL, 128710),
(128711, '3.40.50.300-FF-005427', NULL, 'DEAQ box RNA-dependent ATPase 1', 162, NULL, NULL, 128711),
(128712, '1.20.1270.60-FF-000172', NULL, 'Protein kinase C and casein kinase substrate in neurons 3', 70, NULL, NULL, 128712),
(128713, '3.30.160.60-FF-005949', NULL, NULL, 40, NULL, NULL, 128713),
(128714, '1.10.10.10-FF-000360', NULL, 'Transcription factor Dp-1, a', 92, NULL, NULL, 128714),
(128715, '3.40.50.1240-FF-000161', NULL, NULL, 162, NULL, NULL, 128715),
(128716, '1.10.8.60-FF-000379', NULL, 'Origin recognition complex subunit 1', 121, NULL, NULL, 128716),
(128717, '3.30.2170.10-FF-000005', NULL, 'Predicted protein', 256, NULL, NULL, 128717),
(128718, '2.40.10.10-FF-000047', NULL, 'Trypsin eta', 233, NULL, NULL, 128718),
(128719, '2.30.30.40-FF-000569', NULL, 'Uncharacterized protein', 91, NULL, NULL, 128719),
(128720, '3.30.160.60-FF-002515', NULL, 'Zinc finger protein 143', 32, NULL, NULL, 128720),
(128721, '3.30.479.30-FF-000015', NULL, 'Flotillin-like protein 2', 117, NULL, NULL, 128721),
(128722, '3.30.160.60-FF-000037', NULL, 'B-cell lymphoma/leukemia 11A isoform X1', 33, NULL, NULL, 128722),
(128723, '1.20.1070.10-FF-001390', NULL, 'Protein CBG05486', 244, NULL, NULL, 128723),
(128724, '3.20.20.140-FF-000292', NULL, 'Phosphotransferase domain-containing protein', 217, NULL, NULL, 128724),
(128725, '3.10.450.10-FF-000021', NULL, 'Retinoic acid receptor responder (tazarotene-induced) 1', 98, NULL, NULL, 128725),
(128726, '2.170.190.11-FF-000018', NULL, 'Molybdopterin molybdenumtransferase', 95, NULL, NULL, 128726),
(128727, '4.10.110.10-FF-000003', NULL, 'Maltase-glucoamylase, intestinal', 45, NULL, NULL, 128727),
(128728, '3.40.50.720-FF-001046', NULL, 'D-aspartate oxidase', 87, NULL, NULL, 128728),
(128729, '1.10.555.10-FF-000007', NULL, 'rho GTPase-activating protein 7 isoform X2', 223, NULL, NULL, 128729),
(128730, '2.40.70.10-FF-000495', NULL, NULL, 126, NULL, NULL, 128730),
(128731, '3.20.20.80-FF-000539', NULL, 'Chitinase, putative', 195, NULL, NULL, 128731),
(128732, '1.10.510.10-FF-003693', NULL, NULL, 168, NULL, NULL, 128732),
(128733, '1.25.40.330-FF-000009', NULL, 'Adenylyl cyclase-associated protein', 176, NULL, NULL, 128733),
(128734, '3.80.10.10-FF-002685', NULL, 'Leucine-rich repeat protein kinase family protein', 92, NULL, NULL, 128734),
(128735, '3.30.1120.10-FF-000047', NULL, 'Iduronate-sulfatase or arylsulfatase A', 56, NULL, NULL, 128735),
(128736, '2.60.40.1180-FF-000004', NULL, 'neutral alpha-glucosidase AB isoform X1', 138, NULL, NULL, 128736);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(128737, '3.30.2350.10-FF-000093', NULL, 'TruB pseudouridine (psi) synthase family member 1', 32, NULL, NULL, 128737),
(128738, '2.130.10.10-FF-003230', NULL, 'Uncharacterized protein', 269, NULL, NULL, 128738),
(128739, '3.30.930.10-FF-000396', NULL, 'Uncharacterized protein', 140, NULL, NULL, 128739),
(128740, '1.20.870.10-FF-000024', NULL, 'Rap guanine nucleotide exchange factor', 135, NULL, NULL, 128740),
(128741, '1.20.900.10-FF-000128', NULL, 'Son of sevenless 1', 78, NULL, NULL, 128741),
(128742, '3.30.160.60-FF-004308', NULL, NULL, 41, NULL, NULL, 128742),
(128743, '1.10.246.130-FF-000013', NULL, 'Putative gamma-glutamyltranspeptidase GgtB', 114, NULL, NULL, 128743),
(128744, '3.30.1060.10-FF-000008', NULL, 'Peptide methionine sulfoxide reductase MsrA', 156, NULL, NULL, 128744),
(128745, '2.10.110.10-FF-000292', NULL, 'Uncharacterized protein', 78, NULL, NULL, 128745),
(128746, '2.10.109.10-FF-000007', NULL, 'Chloroplast thylakoidal processing peptidase', 124, NULL, NULL, 128746),
(128747, '1.25.10.10-FF-001372', NULL, 'Armadillo-type protein', 958, NULL, NULL, 128747),
(128748, '3.50.50.60-FF-000775', NULL, 'Amine oxidase', 233, NULL, NULL, 128748),
(128749, '1.20.1730.10-FF-000120', NULL, 'Uncharacterized protein', 64, NULL, NULL, 128749),
(128750, '3.50.50.60-FF-001287', NULL, 'Predicted protein', 59, NULL, NULL, 128750),
(128751, '1.20.1250.20-FF-002098', NULL, 'Uncharacterized protein', 244, NULL, NULL, 128751),
(128752, '1.20.1280.50-FF-000012', NULL, 'F-box only protein 9', 93, NULL, NULL, 128752),
(128753, '3.90.770.10-FF-000004', NULL, '3-hydroxy-3-methylglutaryl coenzyme A reductase', 201, NULL, NULL, 128753),
(128754, '1.25.40.10-FF-002397', NULL, 'Pentatricopeptide repeat-containing protein', 160, NULL, NULL, 128754),
(128755, '2.40.37.10-FF-000075', NULL, NULL, 199, NULL, NULL, 128755),
(128756, '1.25.40.10-FF-001885', NULL, 'TeTratriCopeptide repeat domain protein related', 258, NULL, NULL, 128756),
(128757, '3.40.50.300-FF-007900', NULL, 'Expressed protein', 303, NULL, NULL, 128757),
(128758, '3.40.50.10490-FF-000107', NULL, NULL, 145, NULL, NULL, 128758),
(128759, '3.40.850.10-FF-000073', NULL, 'Kinesin-like protein', 381, NULL, NULL, 128759),
(128760, '3.90.730.10-FF-000002', NULL, 'Ribonuclease I', 245, NULL, NULL, 128760),
(128761, '3.40.50.720-FF-002569', NULL, 'Uncharacterized protein', 38, NULL, NULL, 128761),
(128762, '4.10.1240.10-FF-000015', NULL, 'Vasoactive intestinal polypeptide receptor 2', 70, NULL, NULL, 128762),
(128763, '2.70.150.10-FF-000011', NULL, 'Plasma membrane ATPase', 86, NULL, NULL, 128763),
(128764, '3.30.70.890-FF-000035', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 102, NULL, NULL, 128764),
(128765, '3.30.160.60-FF-004415', NULL, NULL, 23, NULL, NULL, 128765),
(128766, '1.10.1780.10-FF-000013', NULL, 'ClpB protein', 153, NULL, NULL, 128766),
(128767, '2.70.130.10-FF-000004', NULL, 'Insulin-like growth factor 2 receptor', 147, NULL, NULL, 128767),
(128768, '3.10.105.10-FF-000124', NULL, 'Predicted protein', 147, NULL, NULL, 128768),
(128769, '4.10.280.10-FF-000094', NULL, 'Blast:Carbohydrate-responsive element-binding protein', 93, NULL, NULL, 128769),
(128770, '3.40.50.80-FF-000074', NULL, 'Plasma membrane ferric-chelate reductase (Fre2), putative', 171, NULL, NULL, 128770),
(128771, '2.60.40.60-FF-000939', NULL, 'Uncharacterized protein', 90, NULL, NULL, 128771),
(128772, '3.40.80.10-FF-000038', NULL, 'Peptidoglycan recognition protein, putative', 105, NULL, NULL, 128772),
(128773, '1.20.5.2210-FF-000002', NULL, 'ATP synthase subunit 4 mitochondrial', 104, NULL, NULL, 128773),
(128774, '2.60.120.620-FF-000100', NULL, 'Uncharacterized protein', 207, NULL, NULL, 128774),
(128775, '3.20.70.20-FF-000024', NULL, 'Anaerobic ribonucleoside triphosphate reductase', 526, NULL, NULL, 128775),
(128776, '2.60.40.10-FF-004882', NULL, NULL, 111, NULL, NULL, 128776),
(128777, '2.130.10.10-FF-005461', NULL, 'Uncharacterized protein', 179, NULL, NULL, 128777),
(128778, '1.20.90.10-FF-000050', NULL, NULL, 117, NULL, NULL, 128778),
(128779, '1.10.510.10-FF-003586', NULL, NULL, 211, NULL, NULL, 128779);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(128780, '2.40.50.140-FF-000903', NULL, NULL, 80, NULL, NULL, 128780),
(128781, '3.20.20.70-FF-000643', NULL, NULL, 250, NULL, NULL, 128781),
(128782, '3.30.160.810-FF-000003', NULL, '50S ribosomal protein L3', 64, NULL, NULL, 128782),
(128783, '1.10.510.10-FF-004210', NULL, NULL, 216, NULL, NULL, 128783),
(128784, '1.10.30.10-FF-000131', NULL, 'HMG box protein, putative (AFU_orthologue AFUA_1G10040)', 94, NULL, NULL, 128784),
(128785, '1.25.40.20-FF-000258', NULL, 'centaurin-gamma-1A isoform X1', 116, NULL, NULL, 128785),
(128786, '3.40.50.150-FF-001178', NULL, NULL, 148, NULL, NULL, 128786),
(128787, '2.60.120.260-FF-000195', NULL, 'C-type LECtin', 150, NULL, NULL, 128787),
(128788, '3.40.50.300-FF-001375', NULL, 'Dynein heavy chain, putative', 234, NULL, NULL, 128788),
(128789, '1.20.1070.10-FF-000777', NULL, 'Uncharacterized protein', 77, NULL, NULL, 128789),
(128790, '3.90.550.10-FF-000123', NULL, 'Cell wall biosynthesis glycosyltransferase', 238, NULL, NULL, 128790),
(128791, '3.30.70.330-FF-000783', NULL, 'Glorund, isoform C', 98, NULL, NULL, 128791),
(128792, '3.30.160.60-FF-000144', NULL, 'zinc finger protein 181 isoform X1', 28, NULL, NULL, 128792),
(128793, '1.20.140.150-FF-000041', NULL, 'Transmembrane protein 202', 171, NULL, NULL, 128793),
(128794, '3.50.50.60-FF-001394', NULL, 'Uncharacterized protein', 195, NULL, NULL, 128794),
(128795, '1.10.10.60-FF-000234', NULL, 'ISWI chromatin-remodeling complex ATPase ISW2', 109, NULL, NULL, 128795),
(128796, '3.30.200.20-FF-001844', NULL, 'Uncharacterized protein', 165, NULL, NULL, 128796),
(128797, '1.50.10.10-FF-000139', NULL, 'Uncharacterized protein', 372, NULL, NULL, 128797),
(128798, '3.30.160.60-FF-001661', NULL, 'Zinc finger and SCAN domain-containing 26', 29, NULL, NULL, 128798),
(128799, '1.20.1070.10-FF-001401', NULL, 'Uncharacterized protein', 238, NULL, NULL, 128799),
(128800, '3.30.60.30-FF-000228', NULL, 'Uncharacterized protein', 54, NULL, NULL, 128800),
(128801, '2.60.40.2950-FF-000001', NULL, 'Thioester-containing protein 2, isoform B', 88, NULL, NULL, 128801),
(128802, '1.10.630.10-FF-000767', NULL, 'Uncharacterized protein', 500, NULL, NULL, 128802),
(128803, '2.20.100.10-FF-000075', NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 17', 56, NULL, NULL, 128803),
(128804, '3.40.50.10190-FF-000124', NULL, 'DNA topoisomerase 2-binding protein 1-A', 111, NULL, NULL, 128804),
(128805, '2.60.120.330-FF-000019', NULL, 'Predicted protein', 352, NULL, NULL, 128805),
(128806, '1.25.40.20-FF-000472', NULL, 'Uncharacterized protein', 96, NULL, NULL, 128806),
(128807, '3.40.50.300-FF-004129', NULL, 'AAA family ATPase', 184, NULL, NULL, 128807),
(128808, '3.40.50.10190-FF-000231', NULL, 'YALI0B17006p', 89, NULL, NULL, 128808),
(128809, '2.60.40.420-FF-000054', NULL, 'Uncharacterized protein, isoform A', 158, NULL, NULL, 128809),
(128810, '1.25.40.180-FF-000150', NULL, NULL, 166, NULL, NULL, 128810),
(128811, '3.10.50.30-FF-000010', NULL, 'Transcription elongation factor GreA', 80, NULL, NULL, 128811),
(128812, '3.30.70.330-FF-002014', NULL, NULL, 70, NULL, NULL, 128812),
(128813, '1.20.58.90-FF-000038', NULL, NULL, 103, NULL, NULL, 128813),
(128814, '1.10.510.10-FF-000713', NULL, 'Non-specific serine/threonine protein kinase', 193, NULL, NULL, 128814),
(128815, '3.30.1490.20-FF-000038', NULL, 'D-alanine--D-alanine ligase', 72, NULL, NULL, 128815),
(128816, '2.60.40.60-FF-000035', NULL, 'Protocadherin Fat 3', 103, NULL, NULL, 128816),
(128817, '2.60.120.310-FF-000013', NULL, 'Uncharacterized protein', 145, NULL, NULL, 128817),
(128818, '2.60.120.920-FF-000090', NULL, 'Si:ch211-214c20.1', 179, NULL, NULL, 128818),
(128819, '1.20.5.650-FF-000019', NULL, NULL, 51, NULL, NULL, 128819),
(128820, '3.90.245.10-FF-000009', NULL, 'Inosine-uridine preferring nucleoside hydrolase', 311, NULL, NULL, 128820),
(128821, '2.20.100.10-FF-000182', NULL, 'Thrombospondin type-1 domain-containing protein 7A', 53, NULL, NULL, 128821),
(128822, '2.60.40.10-FF-000604', NULL, 'immunoglobulin superfamily member 3', 112, NULL, NULL, 128822);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(128823, '3.40.50.11500-FF-000017', NULL, 'DENN (AEX-3) domain containing protein', 167, NULL, NULL, 128823),
(128824, '1.25.40.20-FF-000365', NULL, 'Start control protein cdc10', 235, NULL, NULL, 128824),
(128825, '3.60.15.10-FF-000010', NULL, 'DNA cross-link repair 1A', 163, NULL, NULL, 128825),
(128826, '3.20.20.70-FF-000862', NULL, NULL, 185, NULL, NULL, 128826),
(128827, '1.20.58.70-FF-000032', NULL, 'DIABLO isoform 9', 139, NULL, NULL, 128827),
(128828, '1.10.10.60-FF-000341', NULL, 'Zinc finger homeobox 2', 65, NULL, NULL, 128828),
(128829, '1.10.506.10-FF-000041', NULL, 'Ras GTPase-activating-like protein IQG1', 342, NULL, NULL, 128829),
(128830, '3.40.30.10-FF-000434', NULL, 'ThioredoXin Domain Containing protein homolog', 147, NULL, NULL, 128830),
(128831, '1.25.10.10-FF-003188', NULL, 'Predicted protein', 307, NULL, NULL, 128831),
(128832, '1.20.1080.10-FF-000047', NULL, 'Formate/nitrite transporter', 256, NULL, NULL, 128832),
(128833, '3.10.20.90-FF-000054', NULL, 'Ubiquitin-like protein 5', 73, NULL, NULL, 128833),
(128834, '1.20.120.720-FF-000039', NULL, 'Chitin synthase 8', 162, NULL, NULL, 128834),
(128835, '6.10.140.2220-FF-000065', NULL, 'SET domain containing protein, putative', 16, NULL, NULL, 128835),
(128836, '3.30.160.60-FF-002510', NULL, NULL, 30, NULL, NULL, 128836),
(128837, '1.25.40.10-FF-003813', NULL, 'Uncharacterized protein', 136, NULL, NULL, 128837),
(128838, '3.60.40.10-FF-000315', NULL, 'Uncharacterized protein', 226, NULL, NULL, 128838),
(128839, '1.10.8.270-FF-000014', NULL, 'Putative TBC1 domain family member 2B', 105, NULL, NULL, 128839),
(128840, '1.10.287.470-FF-000016', NULL, 'Efflux transporter, RND family, MFP subunit', 74, NULL, NULL, 128840),
(128841, '3.40.570.10-FF-000028', NULL, 'AGAP004948-PA', 246, NULL, NULL, 128841),
(128842, '3.30.160.60-FF-002858', NULL, NULL, 28, NULL, NULL, 128842),
(128843, '1.25.40.10-FF-000036', NULL, 'interferon-induced protein with tetratricopeptide repeats 5', 277, NULL, NULL, 128843),
(128844, '2.120.10.30-FF-000100', NULL, 'NHL repeat-containing protein', 182, NULL, NULL, 128844),
(128845, '3.90.79.10-FF-000212', NULL, 'Nucleoside diphosphate-linked moiety X motif 13', 148, NULL, NULL, 128845),
(128846, '3.30.70.330-FF-000676', NULL, 'U2 snRNP auxiliary factor large subunit', 57, NULL, NULL, 128846),
(128847, '2.40.10.170-FF-000005', NULL, 'ATP synthase subunit beta', 82, NULL, NULL, 128847),
(128848, '3.40.50.150-FF-001285', NULL, NULL, 220, NULL, NULL, 128848),
(128849, '3.40.50.1820-FF-001223', NULL, 'Predicted protein', 357, NULL, NULL, 128849),
(128850, '1.20.58.390-FF-000132', NULL, 'Uncharacterized protein', 126, NULL, NULL, 128850),
(128851, '2.10.50.10-FF-000074', NULL, 'Tumor necrosis factor receptor superfamily member 5', 40, NULL, NULL, 128851),
(128852, '3.30.70.330-FF-000564', NULL, 'Polyadenylate-binding protein', 81, NULL, NULL, 128852),
(128853, '3.30.420.40-FF-000181', NULL, 'Plasmid segregation protein ParM', 161, NULL, NULL, 128853),
(128854, '3.40.50.2300-FF-001592', NULL, NULL, 125, NULL, NULL, 128854),
(128855, '1.10.1200.270-FF-000013', NULL, 'Uncharacterized protein', 85, NULL, NULL, 128855),
(128856, '2.60.120.10-FF-000556', NULL, 'Uncharacterized protein', 157, NULL, NULL, 128856),
(128857, '3.40.605.10-FF-000003', NULL, 'Methylmalonate-semialdehyde dehydrogenase [acylating]', 249, NULL, NULL, 128857),
(128858, '3.90.190.10-FF-000488', NULL, 'Uncharacterized protein', 160, NULL, NULL, 128858),
(128859, '3.50.50.60-FF-000668', NULL, 'Uncharacterized protein', 248, NULL, NULL, 128859),
(128860, '1.25.50.20-FF-000079', NULL, 'Aminopeptidase', 209, NULL, NULL, 128860),
(128861, '2.60.40.10-FF-003477', NULL, 'Guanine nucleotide exchange factor UNC-73A', 98, NULL, NULL, 128861),
(128862, '3.40.50.300-FF-005990', NULL, 'cell cycle checkpoint protein RAD17', 179, NULL, NULL, 128862),
(128863, '1.20.120.610-FF-000006', NULL, 'ATP synthase subunit c', 91, NULL, NULL, 128863),
(128864, '2.30.180.10-FF-000145', NULL, NULL, 116, NULL, NULL, 128864),
(128865, '3.40.1390.30-FF-000019', NULL, 'GTP cyclohydrolase 1 type 2 homolog', 125, NULL, NULL, 128865); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(128866, '3.40.50.300-FF-002679', NULL, 'Ste6p', 238, NULL, NULL, 128866),
(128867, '2.60.120.620-FF-000095', NULL, 'Prolyl 4-hydroxylase alpha subunit 1, putative', 92, NULL, NULL, 128867),
(128868, '3.90.190.10-FF-000033', NULL, 'receptor-type tyrosine-protein phosphatase C isoform X1', 294, NULL, NULL, 128868),
(128869, '1.10.10.10-FF-001641', NULL, 'YALI0B16280p', 84, NULL, NULL, 128869),
(128870, '1.25.10.10-FF-001265', NULL, 'Uncharacterized protein', 387, NULL, NULL, 128870),
(128871, '3.90.1480.20-FF-000052', NULL, 'Uncharacterized protein', 174, NULL, NULL, 128871),
(128872, '3.30.70.330-FF-001076', NULL, 'RNA-binding protein CP29B chloroplastic', 104, NULL, NULL, 128872),
(128873, '3.40.50.150-FF-000796', NULL, 'Protein CBG04220', 157, NULL, NULL, 128873),
(128874, '3.10.105.10-FF-000017', NULL, 'Oligopeptide ABC transporter, periplasmic oligopeptide-binding protein', 242, NULL, NULL, 128874),
(128875, '1.25.40.20-FF-001669', NULL, 'Uncharacterized protein', 82, NULL, NULL, 128875),
(128876, '1.10.10.10-FF-002041', NULL, 'Uncharacterized protein', 90, NULL, NULL, 128876),
(128877, '3.80.10.10-FF-000324', NULL, 'Protein phosphatase 1 regulatory subunit 37', 386, NULL, NULL, 128877),
(128878, '2.130.10.10-FF-005591', NULL, 'Predicted protein', 198, NULL, NULL, 128878),
(128879, '2.40.50.140-FF-000898', NULL, NULL, 110, NULL, NULL, 128879),
(128880, '3.30.1360.10-FF-000048', NULL, 'DNA-directed RNA polymerases II IV and V subunit 3', 33, NULL, NULL, 128880),
(128881, '1.20.1730.10-FF-000013', NULL, 'sodium/myo-inositol cotransporter isoform X1', 537, NULL, NULL, 128881),
(128882, '1.10.10.60-FF-000919', NULL, NULL, 61, NULL, NULL, 128882),
(128883, '2.60.120.200-FF-000761', NULL, 'Uncharacterized protein', 84, NULL, NULL, 128883),
(128884, '3.30.930.10-FF-000289', NULL, 'Lysine--tRNA ligase', 373, NULL, NULL, 128884),
(128885, '3.80.10.10-FF-004135', NULL, 'Uncharacterized protein', 110, NULL, NULL, 128885),
(128886, '3.30.1330.30-FF-000086', NULL, 'Ribosomal protein S12', 115, NULL, NULL, 128886),
(128887, '1.25.40.70-FF-000026', NULL, 'Phosphatidylinositol 3-kinase piki-1', 185, NULL, NULL, 128887),
(128888, '2.120.10.30-FF-000555', NULL, 'Uncharacterized protein', 81, NULL, NULL, 128888),
(128889, '3.90.550.10-FF-000016', NULL, 'LARGE xylosyl- and glucuronyltransferase 2', 265, NULL, NULL, 128889),
(128890, '3.40.50.1820-FF-000481', NULL, 'Carboxylic ester hydrolase', 282, NULL, NULL, 128890),
(128891, '3.30.360.10-FF-000032', NULL, 'GDH/6PGL endoplasmic bifunctional protein', 312, NULL, NULL, 128891),
(128892, '2.30.30.30-FF-000004', NULL, '50S ribosomal protein L24', 102, NULL, NULL, 128892),
(128893, '1.20.120.850-FF-000050', NULL, 'Uncharacterized protein', 78, NULL, NULL, 128893),
(128894, '3.40.50.300-FF-005534', NULL, 'RAB40C, member RAS oncogene family', 68, NULL, NULL, 128894),
(128895, '2.60.40.10-FF-002061', NULL, 'Uncharacterized protein, isoform B', 114, NULL, NULL, 128895),
(128896, '3.30.9.10-FF-000273', NULL, 'D-Amino acid dehydrogenase', 105, NULL, NULL, 128896),
(128897, '3.70.10.10-FF-000061', NULL, 'Uncharacterized protein', 258, NULL, NULL, 128897),
(128898, '3.40.50.720-FF-002563', NULL, 'Uncharacterized protein', 45, NULL, NULL, 128898),
(128899, '3.30.300.10-FF-000039', NULL, 'Methionine S-adenosyl transferase', 149, NULL, NULL, 128899),
(128900, '3.40.50.720-FF-000197', NULL, 'Bifunctional polymyxin resistance protein ArnA', 347, NULL, NULL, 128900),
(128901, '3.30.200.20-FF-000321', NULL, 'serine/threonine-protein kinase N3 isoform X1', 116, NULL, NULL, 128901),
(128902, '1.25.40.10-FF-005252', NULL, 'Uncharacterized protein', 339, NULL, NULL, 128902),
(128903, '1.20.1250.20-FF-000659', NULL, 'Unplaced genomic scaffold supercont2.2, whole genome shotgun sequence', 474, NULL, NULL, 128903),
(128904, '3.40.50.1400-FF-000012', NULL, 'Ferrochelatase', 169, NULL, NULL, 128904),
(128905, '3.30.70.330-FF-002930', NULL, NULL, 163, NULL, NULL, 128905),
(128906, '3.90.70.10-FF-000794', NULL, 'Uncharacterized protein', 325, NULL, NULL, 128906),
(128907, '3.30.60.20-FF-000113', NULL, 'Kinase suppressor of ras 1', 26, NULL, NULL, 128907);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(128908, '3.40.50.300-FF-007895', NULL, 'Uncharacterized protein', 191, NULL, NULL, 128908),
(128909, '3.40.50.300-FF-002224', NULL, 'V-type ATP synthase alpha chain', 291, NULL, NULL, 128909),
(128910, '3.30.70.980-FF-000062', NULL, 'Uncharacterized protein', 67, NULL, NULL, 128910),
(128911, '1.50.10.10-FF-000240', NULL, 'alpha-1,2-Mannosidase', 264, NULL, NULL, 128911),
(128912, '3.20.20.80-FF-000409', NULL, 'Beta-glucosidase 11', 87, NULL, NULL, 128912),
(128913, '3.40.250.10-FF-000100', NULL, 'Rhodanese-like/PpiC domain-containing protein 12, chloroplastic', 110, NULL, NULL, 128913),
(128914, '2.60.40.420-FF-000166', NULL, 'Coagulation factor V', 132, NULL, NULL, 128914),
(128915, '2.60.120.620-FF-000106', NULL, 'Uncharacterized protein', 181, NULL, NULL, 128915),
(128916, '2.80.10.50-FF-000248', NULL, 'Uncharacterized protein', 146, NULL, NULL, 128916),
(128917, '2.40.10.10-FF-000154', NULL, 'Family with sequence similarity 111 member A', 91, NULL, NULL, 128917),
(128918, '3.40.1350.10-FF-000034', NULL, 'tRNA-splicing endonuclease subunit Sen2', 106, NULL, NULL, 128918),
(128919, '1.10.420.10-FF-000049', NULL, 'Peroxidase', 31, NULL, NULL, 128919),
(128920, '3.40.1110.10-FF-000488', NULL, NULL, 62, NULL, NULL, 128920),
(128921, '1.20.1070.10-FF-000092', NULL, 'Galanin receptor type 2', 318, NULL, NULL, 128921),
(128922, '4.10.60.10-FF-000221', NULL, 'Uncharacterized protein', 23, NULL, NULL, 128922),
(128923, '1.10.20.10-FF-000310', NULL, NULL, 41, NULL, NULL, 128923),
(128924, '3.40.630.30-FF-000085', NULL, 'Putative N-acetyltransferase complex ARD1 subunit', 195, NULL, NULL, 128924),
(128925, '1.20.1560.10-FF-000634', NULL, 'p-glycoprotein-2, putative', 213, NULL, NULL, 128925),
(128926, '3.40.950.10-FF-000018', NULL, NULL, 49, NULL, NULL, 128926),
(128927, '1.10.510.10-FF-001332', NULL, 'Serine/threonine-protein kinase Nek1', 335, NULL, NULL, 128927),
(128928, '1.25.10.10-FF-002676', NULL, 'Uncharacterized protein', 85, NULL, NULL, 128928),
(128929, '3.40.50.2300-FF-001603', NULL, NULL, 76, NULL, NULL, 128929),
(128930, '3.40.190.10-FF-000842', NULL, 'Polar amino acid uptake family ABC transporter, periplasmic substrate-binding protein', 98, NULL, NULL, 128930),
(128931, '3.10.50.40-FF-000125', NULL, 'Peptidyl-prolyl cis-trans isomerase', 74, NULL, NULL, 128931),
(128932, '2.130.10.10-FF-003915', NULL, 'Uncharacterized protein', 262, NULL, NULL, 128932),
(128933, '3.40.1190.10-FF-000032', NULL, 'UDP-N-acetylmuramoyl-L-alanyl-D-glutamate--2,6-diaminopimelate ligase', 239, NULL, NULL, 128933),
(128934, '2.60.120.200-FF-000216', NULL, 'Blast:Protein eyes shut', 203, NULL, NULL, 128934),
(128935, '1.10.10.1760-FF-000010', NULL, 'Ribosomal protein L36e, putative', 71, NULL, NULL, 128935),
(128936, '3.30.420.40-FF-000866', NULL, 'Uncharacterized protein', 83, NULL, NULL, 128936),
(128937, '2.170.150.10-FF-000026', NULL, 'Uncharacterized protein', 76, NULL, NULL, 128937),
(128938, '3.30.70.141-FF-000042', NULL, NULL, 146, NULL, NULL, 128938),
(128939, '2.10.220.10-FF-000070', NULL, 'Erb-b2 receptor tyrosine kinase 3b', 114, NULL, NULL, 128939),
(128940, '3.40.50.720-FF-000646', NULL, 'Uncharacterized protein, isoform A', 273, NULL, NULL, 128940),
(128941, '3.40.190.10-FF-000954', NULL, 'Peptide/opine/nickel uptake family ABC transporter, periplasmic substrate-binding protein', 170, NULL, NULL, 128941),
(128942, '3.30.930.10-FF-000284', NULL, 'Proline--tRNA ligase cytoplasmic', 150, NULL, NULL, 128942),
(128943, '3.30.160.60-FF-006332', NULL, NULL, 78, NULL, NULL, 128943),
(128944, '1.25.40.20-FF-001770', NULL, 'Uncharacterized protein', 188, NULL, NULL, 128944),
(128945, '1.10.10.1760-FF-000015', NULL, 'Uncharacterized protein', 71, NULL, NULL, 128945),
(128946, '3.40.190.290-FF-000103', NULL, 'LysR family transcriptional regulator', 206, NULL, NULL, 128946),
(128947, '3.90.1750.10-FF-000047', NULL, 'HECT, C2 and WW domain-containing E3 ubiquitin protein ligase 1', 137, NULL, NULL, 128947),
(128948, '1.10.150.20-FF-000166', NULL, 'DNA-directed RNA polymerase subunit alpha', 77, NULL, NULL, 128948);
INSERT INTO "PUBLIC"."MODEL" VALUES
(128949, '3.20.20.140-FF-000162', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 287, NULL, NULL, 128949),
(128950, '3.30.70.340-FF-000005', NULL, 'Carboxypeptidase A', 88, NULL, NULL, 128950),
(128951, '3.30.70.330-FF-001632', NULL, NULL, 142, NULL, NULL, 128951),
(128952, '3.30.450.60-FF-000020', NULL, 'Coatomer subunit delta', 120, NULL, NULL, 128952),
(128953, '3.40.1370.10-FF-000029', NULL, 'Uncharacterized protein', 265, NULL, NULL, 128953),
(128954, '1.20.1280.50-FF-000142', NULL, 'Uncharacterized protein', 118, NULL, NULL, 128954),
(128955, '1.10.10.10-FF-001085', NULL, 'transcription factor protein isoform X1', 106, NULL, NULL, 128955),
(128956, '1.25.40.10-FF-004763', NULL, 'Uncharacterized protein', 53, NULL, NULL, 128956),
(128957, '1.10.1580.10-FF-000014', NULL, 'GTP-binding proteins, putative, expressed', 62, NULL, NULL, 128957),
(128958, '1.10.10.2010-FF-000006', NULL, NULL, 61, NULL, NULL, 128958),
(128959, '3.40.50.300-FF-000751', NULL, 'Rab family GTPase, putative', 197, NULL, NULL, 128959),
(128960, '3.40.50.300-FF-001370', NULL, 'p-GlycoProtein related', 247, NULL, NULL, 128960),
(128961, '2.20.25.80-FF-000007', NULL, 'WRKY transcription factor 22', 72, NULL, NULL, 128961),
(128962, '3.10.430.100-FF-000008', NULL, '50S ribosomal protein L9', 104, NULL, NULL, 128962),
(128963, '2.10.25.10-FF-000094', NULL, 'Laminin subunit alpha-2', 45, NULL, NULL, 128963),
(128964, '1.10.3730.20-FF-000075', NULL, 'Uncharacterized transporter HI_0878', 120, NULL, NULL, 128964),
(128965, '3.30.160.60-FF-001442', NULL, 'zinc finger protein 696', 29, NULL, NULL, 128965),
(128966, '3.30.200.20-FF-001277', NULL, 'Protein kinase-like protein', 83, NULL, NULL, 128966),
(128967, '1.10.287.70-FF-000632', NULL, 'Uncharacterized protein', 200, NULL, NULL, 128967),
(128968, '3.10.20.90-FF-000958', NULL, 'Predicted protein', 58, NULL, NULL, 128968),
(128969, '2.60.40.10-FF-001661', NULL, 'Down syndrome cell adhesion molecule 3, isoform C', 102, NULL, NULL, 128969),
(128970, '3.30.40.10-FF-000682', NULL, 'E3 ubiquitin-protein ligase HRD1', 77, NULL, NULL, 128970),
(128971, '3.50.50.60-FF-001175', NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', 237, NULL, NULL, 128971),
(128972, '2.30.27.10-FF-000002', NULL, 'Attachment protein G3P', 25, NULL, NULL, 128972),
(128973, '3.40.50.300-FF-001263', NULL, 'ADP-ribosylation factor 2-like Protein', 85, NULL, NULL, 128973),
(128974, '1.10.8.60-FF-000250', NULL, 'Replication factor C subunit 4, putative', 64, NULL, NULL, 128974),
(128975, '3.30.160.60-FF-002061', NULL, 'Uncharacterized protein', 29, NULL, NULL, 128975),
(128976, '3.90.228.10-FF-000037', NULL, 'Poly [ADP-ribose] polymerase', 77, NULL, NULL, 128976),
(128977, '2.130.10.10-FF-000352', NULL, 'WD repeat-containing protein DWA2', 333, NULL, NULL, 128977),
(128978, '2.130.10.10-FF-004972', NULL, 'Cell division cycle protein cdt2', 86, NULL, NULL, 128978),
(128979, '3.60.90.10-FF-000026', NULL, 'S-adenosylmethionine decarboxylase proenzyme', 337, NULL, NULL, 128979),
(128980, '3.80.20.20-FF-000030', NULL, 'LD35811p', 217, NULL, NULL, 128980),
(128981, '3.40.50.12650-FF-000020', NULL, 'Predicted protein', 146, NULL, NULL, 128981),
(128982, '3.30.1960.10-FF-000015', NULL, 'Uncharacterized protein', 144, NULL, NULL, 128982),
(128983, '2.30.39.10-FF-000119', NULL, 'Uncharacterized protein', 95, NULL, NULL, 128983),
(128984, '3.40.250.10-FF-000229', NULL, 'Uncharacterized protein', 54, NULL, NULL, 128984),
(128985, '1.20.1250.20-FF-002340', NULL, 'Synaptic vesicle protein, putative', 175, NULL, NULL, 128985),
(128986, '3.30.160.60-FF-005820', NULL, NULL, 74, NULL, NULL, 128986),
(128987, '3.30.160.60-FF-000149', NULL, 'Zinc finger protein 569', 27, NULL, NULL, 128987),
(128988, '2.30.180.10-FF-000140', NULL, NULL, 179, NULL, NULL, 128988),
(128989, '3.30.365.10-FF-000003', NULL, 'Aldehyde oxidase 1', 170, NULL, NULL, 128989),
(128990, '3.90.1520.10-FF-000002', NULL, 'Guanylate cyclase soluble subunit alpha-3 isoform A', 163, NULL, NULL, 128990),
(128991, '3.40.50.720-FF-001265', NULL, 'Altronate oxidoreductase', 268, NULL, NULL, 128991);
INSERT INTO "PUBLIC"."MODEL" VALUES
(128992, '3.30.70.270-FF-000181', NULL, NULL, 115, NULL, NULL, 128992),
(128993, '4.10.830.10-FF-000001', NULL, '30S ribosomal protein S14 type Z', 61, NULL, NULL, 128993),
(128994, '3.10.20.90-FF-000273', NULL, 'Wide awake, isoform B', 145, NULL, NULL, 128994),
(128995, '2.160.20.70-FF-000026', NULL, 'TuBulin folding Cofactor C homolog', 156, NULL, NULL, 128995),
(128996, '3.40.50.10700-FF-000002', NULL, 'D-aminoacyl-tRNA deacylase', 85, NULL, NULL, 128996),
(128997, '3.30.160.60-FF-005713', NULL, NULL, 46, NULL, NULL, 128997),
(128998, '3.100.10.10-FF-000057', NULL, NULL, 81, NULL, NULL, 128998),
(128999, '2.60.120.10-FF-000337', NULL, 'Germin-like protein subfamily 1 member 8', 142, NULL, NULL, 128999),
(129000, '1.10.730.20-FF-000025', NULL, 'Uncharacterized protein', 283, NULL, NULL, 129000),
(129001, '2.40.10.10-FF-000603', NULL, NULL, 211, NULL, NULL, 129001),
(129002, '3.40.50.720-FF-000989', NULL, 'Short-chain dehydrogenase/reductase family protein', 270, NULL, NULL, 129002),
(129003, '1.10.10.60-FF-001302', NULL, NULL, 51, NULL, NULL, 129003),
(129004, '2.130.10.10-FF-001206', NULL, 'Polyadenylation factor I', 142, NULL, NULL, 129004),
(129005, '3.20.20.80-FF-000180', NULL, 'Glycoside hydrolase', 346, NULL, NULL, 129005),
(129006, '1.20.1270.10-FF-000096', NULL, 'Uncharacterized protein', 92, NULL, NULL, 129006),
(129007, '1.10.168.10-FF-000001', NULL, 'phosducin-like protein', 93, NULL, NULL, 129007),
(129008, '1.10.8.60-FF-000143', NULL, 'DNA replication factor C subunit Rfc2', 87, NULL, NULL, 129008),
(129009, '3.30.450.20-FF-000143', NULL, 'Unplaced genomic scaffold supercont2.18, whole genome shotgun sequence', 124, NULL, NULL, 129009),
(129010, '3.40.50.620-FF-000386', NULL, 'Nicotinamide-nucleotide adenylyltransferase', 210, NULL, NULL, 129010),
(129011, '1.10.246.10-FF-000003', NULL, 'Serum albumin', 112, NULL, NULL, 129011),
(129012, '3.30.56.30-FF-000011', NULL, 'Uncharacterized protein', 117, NULL, NULL, 129012),
(129013, '2.130.10.10-FF-001313', NULL, 'Predicted protein', 162, NULL, NULL, 129013),
(129014, '1.10.630.10-FF-000312', NULL, 'Uncharacterized protein', 442, NULL, NULL, 129014),
(129015, '3.40.5.120-FF-000006', NULL, 'Brahma, isoform F', 45, NULL, NULL, 129015),
(129016, '3.40.950.10-FF-000013', NULL, 'Hydrogenase, putative', 188, NULL, NULL, 129016),
(129017, '2.10.110.10-FF-000297', NULL, 'Uncharacterized protein', 68, NULL, NULL, 129017),
(129018, '3.90.226.10-FF-000089', NULL, 'Membrane-bound serine protease', 225, NULL, NULL, 129018),
(129019, '2.40.10.10-FF-000042', NULL, 'Kallikrein 1-related peptidase C9', 119, NULL, NULL, 129019),
(129020, '3.40.50.300-FF-001712', NULL, 'ATP-binding cassette protein putative', 258, NULL, NULL, 129020),
(129021, '3.40.50.620-FF-000734', NULL, 'Uncharacterized protein', 170, NULL, NULL, 129021),
(129022, '3.40.50.1820-FF-001442', NULL, 'Uncharacterized protein', 188, NULL, NULL, 129022),
(129023, '3.30.40.10-FF-001643', NULL, 'Predicted protein', 146, NULL, NULL, 129023),
(129024, '1.25.40.340-FF-000001', NULL, 'Dihydroxyacetone kinase 1', 203, NULL, NULL, 129024),
(129025, '3.30.460.10-FF-000073', NULL, 'ATPase synthesis protein 25, mitochondrial', 126, NULL, NULL, 129025),
(129026, '1.20.1440.100-FF-000006', NULL, 'HAD-IB family hydrolase', 74, NULL, NULL, 129026),
(129027, '2.60.40.10-FF-005713', NULL, NULL, 44, NULL, NULL, 129027),
(129028, '1.25.40.10-FF-001093', NULL, 'Pentatricopeptide repeat-containing protein At2g34400', 248, NULL, NULL, 129028),
(129029, '3.40.50.300-FF-005315', NULL, 'DRL1 protein', 163, NULL, NULL, 129029),
(129030, '2.10.25.10-FF-000436', NULL, 'matrilin-2 isoform X2', 40, NULL, NULL, 129030),
(129031, '3.20.10.10-FF-000046', NULL, 'Branched-chain-amino-acid aminotransferase', 176, NULL, NULL, 129031),
(129032, '3.40.140.10-FF-000108', NULL, 'Splicing factor Prp8, putative', 269, NULL, NULL, 129032),
(129033, '3.40.50.720-FF-001613', NULL, '3-ketodihydrosphingosine reductase', 123, NULL, NULL, 129033),
(129034, '3.30.160.60-FF-002403', NULL, 'zinc finger protein 420', 64, NULL, NULL, 129034);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(129035, '2.30.30.190-FF-000034', NULL, NULL, 48, NULL, NULL, 129035),
(129036, '2.60.40.640-FF-000007', NULL, 'Arrestin domain-containing protein 3 mRNA', 163, NULL, NULL, 129036),
(129037, '3.90.1140.10-FF-000012', NULL, 'A-kinase anchoring protein 18 gamma', 222, NULL, NULL, 129037),
(129038, '3.30.70.330-FF-002469', NULL, NULL, 81, NULL, NULL, 129038),
(129039, '3.40.50.1010-FF-000221', NULL, NULL, 119, NULL, NULL, 129039),
(129040, '3.60.40.10-FF-000203', NULL, 'Predicted protein', 269, NULL, NULL, 129040),
(129041, '3.30.40.10-FF-001986', NULL, 'TNF receptor-associated factor, putative', 58, NULL, NULL, 129041),
(129042, '1.20.1250.20-FF-000760', NULL, 'Beta-alanine transporter', 409, NULL, NULL, 129042),
(129043, '2.10.25.10-FF-001403', NULL, 'Uncharacterized protein', 36, NULL, NULL, 129043),
(129044, '1.10.238.10-FF-000687', NULL, 'EF hand family protein, expressed', 86, NULL, NULL, 129044),
(129045, '3.40.50.140-FF-000012', NULL, 'DNA topoisomerase', 162, NULL, NULL, 129045),
(129046, '3.40.50.1480-FF-000002', NULL, 'Adenosylhomocysteinase', 150, NULL, NULL, 129046),
(129047, '1.20.1250.20-FF-001160', NULL, 'MFS sugar transporte, putative', 274, NULL, NULL, 129047),
(129048, '2.70.130.10-FF-000009', NULL, 'Insulin-like growth factor 2 receptor', 145, NULL, NULL, 129048),
(129049, '4.10.1110.10-FF-000005', NULL, 'Zinc finger AN1-type containing 1', 60, NULL, NULL, 129049),
(129050, '1.20.1050.120-FF-000007', NULL, NULL, 57, NULL, NULL, 129050),
(129051, '3.40.850.10-FF-000522', NULL, 'Kinesin-like protein', 111, NULL, NULL, 129051),
(129052, '3.40.50.80-FF-000181', NULL, 'Ferric reductase NAD binding domain-domain-containing protein', 186, NULL, NULL, 129052),
(129053, '1.10.600.10-FF-000142', NULL, 'Os04g0612000 protein', 152, NULL, NULL, 129053),
(129054, '2.60.40.60-FF-000254', NULL, 'Dachsous cadherin-related 1', 107, NULL, NULL, 129054),
(129055, '2.60.40.10-FF-001442', NULL, 'von Willebrand factor A domain containing 1', 89, NULL, NULL, 129055),
(129056, '1.20.1560.10-FF-000871', NULL, 'Uncharacterized protein', 131, NULL, NULL, 129056),
(129057, '3.30.1490.180-FF-000038', NULL, 'DNA-directed RNA polymerase subunit', 82, NULL, NULL, 129057),
(129058, '3.40.50.300-FF-000644', NULL, 'GpmB, Fructose-2,6-bisphosphatase', 208, NULL, NULL, 129058),
(129059, '3.40.50.2300-FF-000187', NULL, 'Biodegradative arginine decarboxylase', 140, NULL, NULL, 129059),
(129060, '3.30.160.20-FF-000036', NULL, 'Double-stranded RNA-binding protein 2', 72, NULL, NULL, 129060),
(129061, '2.130.10.10-FF-001656', NULL, 'WD_domain_-_G-beta_repeat /Utp13_specific_WD40_associated_domain_containing_protein_-_putative', 184, NULL, NULL, 129061),
(129062, '2.60.40.420-FF-000161', NULL, 'Ubiquinol oxidase subunit 2', 168, NULL, NULL, 129062),
(129063, '2.40.37.10-FF-000070', NULL, NULL, 143, NULL, NULL, 129063),
(129064, '4.10.1080.10-FF-000013', NULL, 'Cartilage oligomeric matrix protein', 33, NULL, NULL, 129064),
(129065, '1.20.1560.10-FF-000741', NULL, 'Uncharacterized protein', 139, NULL, NULL, 129065),
(129066, '2.130.10.10-FF-000245', NULL, 'WD repeat-containing protein 70', 244, NULL, NULL, 129066),
(129067, '3.90.70.10-FF-000687', NULL, 'Uncharacterized protein', 238, NULL, NULL, 129067),
(129068, '1.20.1270.420-FF-000006', NULL, 'ikappaB kinase isoform X1', 268, NULL, NULL, 129068),
(129069, '3.90.1410.10-FF-000005', NULL, 'Ribulose-1,5 bisphosphate carboxylase/oxygenase large subunit N-methyltransferase, chloroplastic', 253, NULL, NULL, 129069),
(129070, '1.10.8.60-FF-000593', NULL, 'Uncharacterized protein', 91, NULL, NULL, 129070),
(129071, '3.10.450.60-FF-000007', NULL, 'Uncharacterized protein', 128, NULL, NULL, 129071),
(129072, '3.40.910.10-FF-000016', NULL, 'Deoxyhypusine synthase', 228, NULL, NULL, 129072),
(129073, '3.40.190.10-FF-000050', NULL, 'Sulfonate ABC transporter substrate-binding protein', 100, NULL, NULL, 129073),
(129074, '3.90.190.10-FF-000140', NULL, 'Unplaced genomic scaffold supercont2.7, whole genome shotgun sequence', 157, NULL, NULL, 129074),
(129075, '3.40.50.2300-FF-000535', NULL, 'Transcriptional regulator, LacI family', 177, NULL, NULL, 129075);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(129076, '3.40.50.20-FF-000084', NULL, 'Predicted protein', 71, NULL, NULL, 129076),
(129077, '1.20.5.50-FF-000010', NULL, 'Cell division protein ZapA', 52, NULL, NULL, 129077),
(129078, '3.50.30.20-FF-000015', NULL, 'Predicted protein', 98, NULL, NULL, 129078),
(129079, '3.90.550.10-FF-000128', NULL, 'Glycosyl transferase family 2', 232, NULL, NULL, 129079),
(129080, '3.30.110.200-FF-000001', NULL, 'Diguanylate cyclase/phosphodiesterase', 79, NULL, NULL, 129080),
(129081, '1.25.10.10-FF-001153', NULL, 'RIC8', 360, NULL, NULL, 129081),
(129082, '3.20.20.330-FF-000028', NULL, '5-methyltetrahydrofolate:homocysteine methyltransferase, putative', 178, NULL, NULL, 129082),
(129083, '3.30.430.20-FF-000029', NULL, 'Cysteine-rich receptor-like protein kinase 42', 75, NULL, NULL, 129083),
(129084, '2.30.29.30-FF-001007', NULL, 'EAP30/Vps36 family, putative', 123, NULL, NULL, 129084),
(129085, '3.30.70.80-FF-000047', NULL, 'Fervidolysin', 78, NULL, NULL, 129085),
(129086, '2.40.50.90-FF-000129', NULL, 'Uncharacterized protein', 96, NULL, NULL, 129086),
(129087, '3.40.190.10-FF-000393', NULL, 'Peptide/nickel transport system substrate-binding protein', 269, NULL, NULL, 129087),
(129088, '2.70.98.20-FF-000021', NULL, 'Amine oxidase', 181, NULL, NULL, 129088),
(129089, '1.10.510.10-FF-003698', NULL, NULL, 165, NULL, NULL, 129089),
(129090, '1.20.920.10-FF-000130', NULL, 'PolyBRoMo domain containing', 147, NULL, NULL, 129090),
(129091, '1.20.58.340-FF-000033', NULL, 'Magnesium and cobalt transport protein CorA, putative', 78, NULL, NULL, 129091),
(129092, '3.90.660.10-FF-000119', NULL, NULL, 125, NULL, NULL, 129092),
(129093, '1.10.1450.10-FF-000134', NULL, 'Tetraspanin', 103, NULL, NULL, 129093),
(129094, '3.80.10.10-FF-002792', NULL, 'Predicted protein', 301, NULL, NULL, 129094),
(129095, '3.40.190.10-FF-000735', NULL, 'Pca operon transcriptional activator PcaQ', 88, NULL, NULL, 129095),
(129096, '1.10.10.10-FF-002046', NULL, 'DNA-directed RNA polymerase III subunit rpc3', 112, NULL, NULL, 129096),
(129097, '1.20.1250.20-FF-001721', NULL, 'Uncharacterized protein', 230, NULL, NULL, 129097),
(129098, '2.60.40.10-FF-000481', NULL, 'Leucine-rich repeat neuronal protein 1', 94, NULL, NULL, 129098),
(129099, '3.40.50.11580-FF-000002', NULL, 'Replicase polyprotein 1ab', 131, NULL, NULL, 129099),
(129100, '3.30.160.60-FF-005365', NULL, NULL, 56, NULL, NULL, 129100),
(129101, '3.30.160.60-FF-001094', NULL, 'Zinc finger and BTB domain containing 22', 25, NULL, NULL, 129101),
(129102, '2.10.25.10-FF-000566', NULL, 'delta and Notch-like epidermal growth factor-related receptor', 45, NULL, NULL, 129102),
(129103, '3.30.70.330-FF-000671', NULL, 'Splicing factor 1', 163, NULL, NULL, 129103),
(129104, '3.40.50.300-FF-007788', NULL, 'Ras, putative', 50, NULL, NULL, 129104),
(129105, '1.10.238.10-FF-001176', NULL, 'Uncharacterized protein', 91, NULL, NULL, 129105),
(129106, '1.20.1250.10-FF-000083', NULL, 'Interferon kappa', 166, NULL, NULL, 129106),
(129107, '3.40.50.300-FF-006602', NULL, 'Zgc:194443', 97, NULL, NULL, 129107),
(129108, '3.30.70.1230-FF-000144', NULL, 'Adenylate cyclase 3', 161, NULL, NULL, 129108),
(129109, '4.10.1220.10-FF-000002', NULL, 'Transmembrane serine protease 7', 27, NULL, NULL, 129109),
(129110, '1.25.40.10-FF-002846', NULL, 'Mitochondrial group I intron splicing factor CCM1', 119, NULL, NULL, 129110),
(129111, '1.25.10.10-FF-000883', NULL, 'BNR1p Formin', 236, NULL, NULL, 129111),
(129112, '1.25.10.10-FF-000208', NULL, '26S proteasome non-ATPase regulatory subunit 5', 298, NULL, NULL, 129112),
(129113, '1.10.510.10-FF-001770', NULL, 'Protein CBG24817', 247, NULL, NULL, 129113),
(129114, '2.40.128.620-FF-000003', NULL, 'Uncharacterized protein', 40, NULL, NULL, 129114),
(129115, '1.10.630.10-FF-000655', NULL, 'Os01g0227400 protein', 199, NULL, NULL, 129115),
(129116, '1.10.510.10-FF-001225', NULL, 'Protein kinase superfamily protein', 221, NULL, NULL, 129116),
(129117, '1.10.630.10-FF-000531', NULL, 'Uncharacterized protein', 382, NULL, NULL, 129117),
(129118, '1.10.150.50-FF-000057', NULL, 'Arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 3', 63, NULL, NULL, 129118);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(129119, '3.80.10.10-FF-001381', NULL, 'Uncharacterized protein', 205, NULL, NULL, 129119),
(129120, '3.30.1490.480-FF-000015', NULL, NULL, 60, NULL, NULL, 129120),
(129121, '3.40.50.1010-FF-000002', NULL, 'Exonuclease 1, putative', 207, NULL, NULL, 129121),
(129122, '3.30.450.40-FF-000019', NULL, 'Heat-inducible transcription repressor HrcA', 131, NULL, NULL, 129122),
(129123, '2.10.25.10-FF-001055', NULL, 'Wall-associated receptor kinase-like 8', 44, NULL, NULL, 129123),
(129124, '3.10.350.10-FF-000069', NULL, 'Putative cell wall hydrolase', 57, NULL, NULL, 129124),
(129125, '3.40.50.10140-FF-000019', NULL, '18w protein', 140, NULL, NULL, 129125),
(129126, '3.30.530.20-FF-000200', NULL, 'Predicted protein', 77, NULL, NULL, 129126),
(129127, '3.20.110.10-FF-000038', NULL, 'Uncharacterized protein', 218, NULL, NULL, 129127),
(129128, '2.40.30.70-FF-000021', NULL, 'Uncharacterized protein', 44, NULL, NULL, 129128),
(129129, '2.20.25.30-FF-000015', NULL, 'Uncharacterized protein', 65, NULL, NULL, 129129),
(129130, '3.30.200.20-FF-001625', NULL, 'Uncharacterized protein', 121, NULL, NULL, 129130),
(129131, '3.40.50.300-FF-001931', NULL, 'Blast:Carbohydrate sulfotransferase 4', 297, NULL, NULL, 129131),
(129132, '3.30.40.10-FF-002262', NULL, 'Uncharacterized protein', 55, NULL, NULL, 129132),
(129133, '2.10.25.10-FF-000779', NULL, 'Eyes shut homolog', 39, NULL, NULL, 129133),
(129134, '3.40.50.300-FF-002331', NULL, 'ATP-dependent RNA helicase MSS116, mitochondrial', 247, NULL, NULL, 129134),
(129135, '1.10.1740.10-FF-000016', NULL, 'RNA polymerase sigma factor', 92, NULL, NULL, 129135),
(129136, '3.40.50.150-FF-000228', NULL, 'Ribosomal RNA small subunit methyltransferase C', 184, NULL, NULL, 129136),
(129137, '1.20.920.30-FF-000012', NULL, 'Dynein heavy chain, putative', 179, NULL, NULL, 129137),
(129138, '1.10.555.10-FF-000137', NULL, 'rho GTPase-activating protein 18 isoform X2', 270, NULL, NULL, 129138),
(129139, '4.10.1000.10-FF-000014', NULL, 'Zinc finger CCCH domain-containing protein 1', 35, NULL, NULL, 129139),
(129140, '3.40.50.410-FF-000003', NULL, 'Collagen type VI alpha 3 chain', 188, NULL, NULL, 129140),
(129141, '1.10.565.10-FF-000183', NULL, 'Nuclear Hormone Receptor family', 120, NULL, NULL, 129141),
(129142, '1.25.10.10-FF-001714', NULL, 'Nuclear condensing complex subunit', 234, NULL, NULL, 129142),
(129143, '3.30.710.10-FF-000519', NULL, 'GH14381p', 125, NULL, NULL, 129143),
(129144, '3.30.70.330-FF-001744', NULL, NULL, 130, NULL, NULL, 129144),
(129145, '3.40.50.300-FF-006041', NULL, 'Excision repair cross-complementing rodent repair deficiency, complementation group 2', 130, NULL, NULL, 129145),
(129146, '3.40.50.10880-FF-000011', NULL, NULL, 170, NULL, NULL, 129146),
(129147, '3.90.70.10-FF-000119', NULL, 'Ubiquitin specific peptidase 36', 118, NULL, NULL, 129147),
(129148, '3.20.20.80-FF-000303', NULL, 'Uncharacterized protein', 366, NULL, NULL, 129148),
(129149, '1.10.150.20-FF-000278', NULL, 'FA core complex-associated protein 24', 70, NULL, NULL, 129149),
(129150, '2.60.120.290-FF-000063', NULL, 'LDL receptor related protein 10', 110, NULL, NULL, 129150),
(129151, '2.60.120.260-FF-000644', NULL, 'Uncharacterized protein', 100, NULL, NULL, 129151),
(129152, '2.50.20.10-FF-000019', NULL, 'Sigma-E factor regulatory protein RseB', 185, NULL, NULL, 129152),
(129153, '3.40.50.720-FF-000776', NULL, 'Multi-functional enzyme with acyl-CoA-reductase activity ACRA1', 339, NULL, NULL, 129153),
(129154, '1.10.8.530-FF-000002', NULL, 'DNA polymerase alpha subunit B', 75, NULL, NULL, 129154),
(129155, '2.130.10.10-FF-001425', NULL, 'Damaged DNA binding protein', 327, NULL, NULL, 129155),
(129156, '1.10.3720.10-FF-000026', NULL, 'Phosphate transport system permease protein PstA', 266, NULL, NULL, 129156),
(129157, '2.60.120.590-FF-000046', NULL, 'DNA oxidative demethylase ALKBH2', 67, NULL, NULL, 129157),
(129158, '2.130.10.10-FF-005708', NULL, 'Putative CPSF-domain protein', 145, NULL, NULL, 129158),
(129159, '2.20.28.10-FF-000050', NULL, 'DNA replication licensing factor MCM4 protein', 51, NULL, NULL, 129159);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(129160, '3.40.50.1460-FF-000007', NULL, 'Caspase-1', 276, NULL, NULL, 129160),
(129161, '2.60.120.10-FF-000106', NULL, 'Nucleoside diphosphate kinase 7', 96, NULL, NULL, 129161),
(129162, '3.30.300.20-FF-000025', NULL, 'Transcription termination/antitermination protein NusA', 69, NULL, NULL, 129162),
(129163, '3.40.50.1440-FF-000013', NULL, 'Tubulin beta chain', 191, NULL, NULL, 129163),
(129164, '3.40.50.150-FF-000341', NULL, 'Ribosomal RNA large subunit methyltransferase K/L', 216, NULL, NULL, 129164),
(129165, '3.30.200.20-FF-000877', NULL, 'Serine/threonine-protein kinase PLK', 83, NULL, NULL, 129165),
(129166, '1.20.1560.10-FF-000073', NULL, 'ATP binding cassette subfamily B member 8', 296, NULL, NULL, 129166),
(129167, '2.60.40.150-FF-000748', NULL, 'Predicted protein', 86, NULL, NULL, 129167),
(129168, '1.20.1280.50-FF-000248', NULL, 'Uncharacterized protein', 48, NULL, NULL, 129168),
(129169, '3.20.20.70-FF-000194', NULL, 'Oxaloacetate decarboxylase alpha subunit', 463, NULL, NULL, 129169),
(129170, '1.25.40.10-FF-002161', NULL, 'ER organization and biogenesis-related protein, putative', 143, NULL, NULL, 129170),
(129171, '3.40.50.2300-FF-001154', NULL, NULL, 113, NULL, NULL, 129171),
(129172, '1.10.1520.10-FF-000022', NULL, 'Unplaced genomic scaffold supercont2.5, whole genome shotgun sequence', 175, NULL, NULL, 129172),
(129173, '1.20.1250.20-FF-000316', NULL, 'Solute carrier family 15, member 5', 521, NULL, NULL, 129173),
(129174, '1.10.510.10-FF-002405', NULL, NULL, 204, NULL, NULL, 129174),
(129175, '2.30.30.1020-FF-000042', NULL, NULL, 132, NULL, NULL, 129175),
(129176, '3.30.160.60-FF-006220', NULL, NULL, 88, NULL, NULL, 129176),
(129177, '1.10.472.80-FF-000240', NULL, NULL, 133, NULL, NULL, 129177),
(129178, '3.40.50.2300-FF-000642', NULL, 'Arsenate reductase', 141, NULL, NULL, 129178),
(129179, '3.30.1740.10-FF-000015', NULL, 'PARP-type zinc finger-containing protein C2A9.07c', 120, NULL, NULL, 129179),
(129180, '3.30.40.10-FF-000570', NULL, 'Os11g0144800 protein', 75, NULL, NULL, 129180),
(129181, '2.30.30.140-FF-000042', NULL, 'male-specific lethal 3 homolog', 90, NULL, NULL, 129181),
(129182, '1.25.10.10-FF-001720', NULL, 'Armadillo repeat-containing protein 6', 216, NULL, NULL, 129182),
(129183, '3.10.20.90-FF-000503', NULL, 'Steroid 5 alpha reductase, putative', 73, NULL, NULL, 129183),
(129184, '1.10.10.2480-FF-000001', NULL, 'Translation initiation factor IF-2', 88, NULL, NULL, 129184),
(129185, '3.40.50.360-FF-000055', NULL, 'FMN-dependent NADH-azoreductase 2', 211, NULL, NULL, 129185),
(129186, '2.40.50.140-FF-000555', NULL, 'Methionyl-tRNA synthetase', 175, NULL, NULL, 129186),
(129187, '3.40.630.30-FF-000534', NULL, 'Histone acetyltransferase', 60, NULL, NULL, 129187),
(129188, '3.30.565.10-FF-000333', NULL, 'Histidine kinase', 152, NULL, NULL, 129188),
(129189, '3.40.47.10-FF-000293', NULL, NULL, 99, NULL, NULL, 129189),
(129190, '3.30.360.10-FF-000144', NULL, 'Predicted protein', 71, NULL, NULL, 129190),
(129191, '3.30.30.30-FF-000058', NULL, 'Uncharacterized protein', 56, NULL, NULL, 129191),
(129192, '1.20.1310.10-FF-000026', NULL, 'Cullin 1', 115, NULL, NULL, 129192),
(129193, '1.25.40.10-FF-002852', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 110, NULL, NULL, 129193),
(129194, '3.30.505.10-FF-000122', NULL, 'Tyrosine-protein kinase', 160, NULL, NULL, 129194),
(129195, '2.60.40.60-FF-000597', NULL, 'Uncharacterized protein', 110, NULL, NULL, 129195),
(129196, '2.60.120.430-FF-000032', NULL, 'Chondroitin sulfate ABC exolyase', 180, NULL, NULL, 129196),
(129197, '2.30.30.40-FF-000119', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', 64, NULL, NULL, 129197),
(129198, '1.10.3130.10-FF-000009', NULL, 'Serine O-acetyltransferase 2', 139, NULL, NULL, 129198),
(129199, '3.30.450.50-FF-000028', NULL, 'Yeast SEC homolog', 126, NULL, NULL, 129199),
(129200, '3.90.1150.10-FF-000417', NULL, 'Aspartate aminotransferase', 104, NULL, NULL, 129200),
(129201, '3.40.50.1000-FF-000016', NULL, 'HAD family hydrolase', 104, NULL, NULL, 129201);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(129202, '3.50.30.30-FF-000001', NULL, 'Vacuolar-sorting receptor 1', 165, NULL, NULL, 129202),
(129203, '3.40.50.280-FF-000020', NULL, 'Uncharacterized protein', 113, NULL, NULL, 129203),
(129204, '2.30.42.60-FF-000001', NULL, 'Probable periplasmic serine endoprotease DegP-like', 104, NULL, NULL, 129204),
(129205, '1.25.40.10-FF-003690', NULL, 'Pentatricopeptide repeat-containing protein', 135, NULL, NULL, 129205),
(129206, '1.20.58.340-FF-000027', NULL, 'CorA family metal ion transporter (Eurofung)', 119, NULL, NULL, 129206),
(129207, '3.40.50.300-FF-005422', NULL, 'Uncharacterized protein', 213, NULL, NULL, 129207),
(129208, '3.40.50.150-FF-001757', NULL, NULL, 258, NULL, NULL, 129208),
(129209, '3.40.33.10-FF-000120', NULL, 'LOC100135358 protein', 97, NULL, NULL, 129209),
(129210, '4.10.400.10-FF-000087', NULL, 'low-density lipoprotein receptor class A domain-containing protein 3', 43, NULL, NULL, 129210),
(129211, '3.40.50.2000-FF-000327', NULL, 'Predicted protein', 204, NULL, NULL, 129211),
(129212, '3.10.20.120-FF-000001', NULL, 'Enterotoxin type A', 135, NULL, NULL, 129212),
(129213, '3.40.50.720-FF-000085', NULL, 'Dihydroflavonol reductase', 321, NULL, NULL, 129213),
(129214, '3.10.129.10-FF-000128', NULL, 'Acyl-CoA thioester hydrolase', 150, NULL, NULL, 129214),
(129215, '3.90.10.10-FF-000003', NULL, NULL, 107, NULL, NULL, 129215),
(129216, '3.40.50.11260-FF-000024', NULL, 'Chaperone protein HtpG', 87, NULL, NULL, 129216),
(129217, '2.90.10.10-FF-000062', NULL, 'Uncharacterized protein', 97, NULL, NULL, 129217),
(129218, '1.10.800.10-FF-000016', NULL, 'Uncharacterized protein', 337, NULL, NULL, 129218),
(129219, '3.30.200.20-FF-001389', NULL, NULL, 90, NULL, NULL, 129219),
(129220, '2.60.40.60-FF-000703', NULL, 'Cdh-4', 102, NULL, NULL, 129220),
(129221, '3.30.160.60-FF-005495', NULL, NULL, 35, NULL, NULL, 129221),
(129222, '1.25.40.10-FF-003358', NULL, 'Putative pentatricopeptide repeat-containing protein At3g16890, mitochondrial', 71, NULL, NULL, 129222),
(129223, '3.30.930.10-FF-000053', NULL, 'Phenylalanyl-tRNA synthetase mitochondrial', 318, NULL, NULL, 129223),
(129224, '3.80.10.10-FF-002117', NULL, 'Nodulin-like protein', 195, NULL, NULL, 129224),
(129225, '3.30.160.60-FF-006113', NULL, NULL, 47, NULL, NULL, 129225),
(129226, '1.20.1560.10-FF-000180', NULL, 'ABC transporter ATP-binding protein', 320, NULL, NULL, 129226),
(129227, '3.80.10.10-FF-002342', NULL, 'Leucine rich repeat containing 29, isoform CRA_c', 111, NULL, NULL, 129227),
(129228, '3.30.2160.10-FF-000050', NULL, 'E3 ubiquitin-protein ligase UBR5 isoform X1', 85, NULL, NULL, 129228),
(129229, '1.20.1280.290-FF-000082', NULL, 'L-cystine transporter, putative', 112, NULL, NULL, 129229),
(129230, '3.40.50.10140-FF-000025', NULL, 'Disease resistance protein (TIR-NBS-LRR class)', 153, NULL, NULL, 129230),
(129231, '3.30.160.60-FF-003347', NULL, 'Zinc finger protein 169', 26, NULL, NULL, 129231),
(129232, '4.10.1000.10-FF-000126', NULL, 'Uncharacterized protein', 73, NULL, NULL, 129232),
(129233, '1.25.10.10-FF-000192', NULL, 'Interferon related developmental regulator 1', 218, NULL, NULL, 129233),
(129234, '1.10.10.1050-FF-000022', NULL, 'Uncharacterized protein', 77, NULL, NULL, 129234),
(129235, '3.90.1490.10-FF-000004', NULL, 'ATP binding L-PSP endoribonuclease family protein', 113, NULL, NULL, 129235),
(129236, '3.30.70.330-FF-000221', NULL, 'calcipressin-1 isoform X1', 99, NULL, NULL, 129236),
(129237, '3.30.450.30-FF-000022', NULL, 'Related to Dynein light chain 2B, cytoplasmic', 115, NULL, NULL, 129237),
(129238, '3.40.50.300-FF-003281', NULL, 'Predicted protein', 194, NULL, NULL, 129238),
(129239, '3.30.40.10-FF-000457', NULL, 'RING-H2 finger protein ATL3', 73, NULL, NULL, 129239),
(129240, '1.20.150.20-FF-000006', NULL, 'Mitochondrial F1F0 ATP synthase, alpha subunit', 150, NULL, NULL, 129240),
(129241, '2.60.40.10-FF-004207', NULL, NULL, 78, NULL, NULL, 129241),
(129242, '1.10.8.60-FF-000374', NULL, 'ATP-dependent zinc metalloprotease FtsH', 83, NULL, NULL, 129242),
(129243, '1.20.1110.10-FF-000045', NULL, 'ATPase 4 plasma membrane-type', 258, NULL, NULL, 129243);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(129244, '3.20.20.190-FF-000059', NULL, 'Glycerophosphodiester phosphodiesterase domain containing 1', 99, NULL, NULL, 129244),
(129245, '3.40.50.300-FF-007552', NULL, 'SMC domain protein', 192, NULL, NULL, 129245),
(129246, '3.30.160.60-FF-001217', NULL, 'zinc finger protein 319', 33, NULL, NULL, 129246),
(129247, '3.20.20.190-FF-000166', NULL, NULL, 129, NULL, NULL, 129247),
(129248, '1.10.287.110-FF-000049', NULL, 'DnaJ homolog subfamily C member 12', 94, NULL, NULL, 129248),
(129249, '2.130.10.10-FF-005023', NULL, 'Uncharacterized WD repeat-containing protein C343.17c', 308, NULL, NULL, 129249),
(129250, '3.40.50.10810-FF-000142', NULL, 'RAD54B DNA helicase splice variant', 270, NULL, NULL, 129250),
(129251, '1.20.1110.10-FF-000152', NULL, 'Putative proton motive ATPase', 324, NULL, NULL, 129251),
(129252, '2.70.98.10-FF-000012', NULL, 'Aldose 1-epimerase', 337, NULL, NULL, 129252),
(129253, '1.10.260.40-FF-000039', NULL, 'LacI family transcriptional regulator', 65, NULL, NULL, 129253),
(129254, '3.90.70.10-FF-000451', NULL, 'Calpain 10', 113, NULL, NULL, 129254),
(129255, '1.25.10.10-FF-002226', NULL, 'Uncharacterized protein', 399, NULL, NULL, 129255),
(129256, '1.20.1070.10-FF-000440', NULL, 'NeuroPeptide Receptor family', 330, NULL, NULL, 129256),
(129257, '3.30.70.1230-FF-000037', NULL, 'Guanylate cyclase', 195, NULL, NULL, 129257),
(129258, '1.20.5.170-FF-000297', NULL, 'Uncharacterized protein', 33, NULL, NULL, 129258),
(129259, '1.20.5.110-FF-000318', NULL, 'Uncharacterized protein', 44, NULL, NULL, 129259),
(129260, '3.60.21.10-FF-000283', NULL, 'Debranching enzyme, putative', 270, NULL, NULL, 129260),
(129261, '4.10.400.10-FF-000194', NULL, 'Ecdysone-inducible gene E1', 41, NULL, NULL, 129261),
(129262, '3.40.50.2300-FF-000299', NULL, 'Uncharacterized protein', 142, NULL, NULL, 129262),
(129263, '1.50.40.10-FF-000309', NULL, 'Mitochondrial glycine transporter', 290, NULL, NULL, 129263),
(129264, '1.10.10.60-FF-000577', NULL, 'Homeobox-leucine zipper protein 18', 78, NULL, NULL, 129264),
(129265, '1.10.10.10-FF-000135', NULL, 'forkhead box protein G1', 109, NULL, NULL, 129265),
(129266, '3.30.70.100-FF-000169', NULL, NULL, 44, NULL, NULL, 129266),
(129267, '3.30.1490.300-FF-000001', NULL, 'Type 4 fimbrial biogenesis protein PilM', 60, NULL, NULL, 129267),
(129268, '2.60.40.10-FF-005843', NULL, NULL, 105, NULL, NULL, 129268),
(129269, '2.30.29.30-FF-000271', NULL, 'pleckstrin homology domain-containing family M member 3', 126, NULL, NULL, 129269),
(129270, '3.40.47.10-FF-000186', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 3', 325, NULL, NULL, 129270),
(129271, '3.40.50.300-FF-003168', NULL, 'Putative RNA guanylyltransferase', 185, NULL, NULL, 129271),
(129272, '3.30.160.60-FF-002622', NULL, 'Zinc finger protein 1026', 86, NULL, NULL, 129272),
(129273, '3.40.50.720-FF-001490', NULL, 'Uncharacterized cyclodeaminase', 202, NULL, NULL, 129273),
(129274, '3.60.20.10-FF-000084', NULL, 'Class II glutamine amidotransferase', 281, NULL, NULL, 129274),
(129275, '2.60.34.10-FF-000096', NULL, 'ER-located HSP110/SSE-like protein', 184, NULL, NULL, 129275),
(129276, '2.70.98.30-FF-000018', NULL, 'Alpha-mannosidase', 200, NULL, NULL, 129276),
(129277, '2.130.10.30-FF-000015', NULL, 'alsin isoform X1', 219, NULL, NULL, 129277),
(129278, '3.60.40.10-FF-000097', NULL, 'Blast:Protein phosphatase 1H', 368, NULL, NULL, 129278),
(129279, '1.20.5.170-FF-000173', NULL, 'Slo1p', 70, NULL, NULL, 129279),
(129280, '2.10.70.10-FF-000305', NULL, 'Complement factor B-like protease', 73, NULL, NULL, 129280),
(129281, '2.130.10.10-FF-000133', NULL, 'Serine-threonine kinase receptor-associated protein', 313, NULL, NULL, 129281),
(129282, '1.25.40.20-FF-001326', NULL, 'Uncharacterized protein', 134, NULL, NULL, 129282),
(129283, '1.10.510.10-FF-000371', NULL, 'Guanylate cyclase', 273, NULL, NULL, 129283),
(129284, '3.30.230.70-FF-000023', NULL, 'exosome complex component MTR3', 243, NULL, NULL, 129284),
(129285, '1.10.20.10-FF-000181', NULL, NULL, 98, NULL, NULL, 129285),
(129286, '1.25.10.10-FF-001951', NULL, 'ARM repeat superfamily protein', 275, NULL, NULL, 129286);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(129287, '3.40.50.620-FF-000509', NULL, 'Putative arginine--tRNA ligase, mitochondrial', 141, NULL, NULL, 129287),
(129288, '3.30.40.10-FF-002368', NULL, 'Ubiquitinyl hydrolase 1', 76, NULL, NULL, 129288),
(129289, '2.40.50.140-FF-001174', NULL, NULL, 129, NULL, NULL, 129289),
(129290, '3.30.300.30-FF-000141', NULL, 'HC-toxin synthetase', 139, NULL, NULL, 129290),
(129291, '2.70.98.40-FF-000009', NULL, 'Glycoside hydrolase family 65 protein', 276, NULL, NULL, 129291),
(129292, '1.10.150.60-FF-000043', NULL, NULL, 121, NULL, NULL, 129292),
(129293, '2.130.10.10-FF-004298', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 119, NULL, NULL, 129293),
(129294, '3.90.190.10-FF-000376', NULL, 'Protein-tyrosine phosphatase', 150, NULL, NULL, 129294),
(129295, '3.10.110.10-FF-000310', NULL, 'Predicted protein', 77, NULL, NULL, 129295),
(129296, '3.40.1800.20-FF-000004', NULL, 'Zinc finger protein 234-like Protein', 75, NULL, NULL, 129296),
(129297, '1.10.238.10-FF-001069', NULL, 'Uncharacterized protein', 76, NULL, NULL, 129297),
(129298, '3.40.50.2000-FF-000434', NULL, 'Alpha,alpha-trehalose-phosphate synthase [UDP-forming] A', 254, NULL, NULL, 129298),
(129299, '2.120.10.30-FF-000212', NULL, 'low-density lipoprotein receptor-related protein 1B-like', 210, NULL, NULL, 129299),
(129300, '2.40.50.140-FF-000774', NULL, 'Probable replication factor A 73 kDa subunit', 185, NULL, NULL, 129300),
(129301, '1.25.40.10-FF-002054', NULL, 'Pentatricopeptide repeat-containing protein At2g15820 family', 84, NULL, NULL, 129301),
(129302, '1.25.10.10-FF-000989', NULL, 'Protein CLASP-1', 221, NULL, NULL, 129302),
(129303, '3.40.50.12780-FF-000148', NULL, 'Chromosome 19, whole genome shotgun sequence', 226, NULL, NULL, 129303),
(129304, '3.40.1110.10-FF-000151', NULL, 'Phospholipid-transporting ATPase', 88, NULL, NULL, 129304),
(129305, '3.40.800.20-FF-000016', NULL, 'Histone deacetylase 2', 223, NULL, NULL, 129305),
(129306, '3.40.50.150-FF-001072', NULL, NULL, 241, NULL, NULL, 129306),
(129307, '3.40.50.300-FF-004697', NULL, 'Atlastin-1', 304, NULL, NULL, 129307),
(129308, '2.130.10.10-FF-003786', NULL, 'Uncharacterized protein', 314, NULL, NULL, 129308),
(129309, '1.25.40.10-FF-001542', NULL, 'Pentatricopeptide repeat protein PPR868-14', 122, NULL, NULL, 129309),
(129310, '3.80.10.10-FF-004247', NULL, 'Protein CBG22476', 261, NULL, NULL, 129310),
(129311, '3.80.10.10-FF-000195', NULL, 'Toll-like receptor 4', 608, NULL, NULL, 129311),
(129312, '2.70.150.10-FF-000117', NULL, 'Probable cation-transporting P-type ATPase', 113, NULL, NULL, 129312),
(129313, '2.60.40.10-FF-000043', NULL, 'roundabout homolog 2 isoform X2', 96, NULL, NULL, 129313),
(129314, '1.10.10.60-FF-000122', NULL, 'Zinc finger E-box binding homeobox 1', 47, NULL, NULL, 129314),
(129315, '3.30.200.20-FF-001732', NULL, NULL, 132, NULL, NULL, 129315),
(129316, '3.30.830.10-FF-000012', NULL, 'Protease 3', 240, NULL, NULL, 129316),
(129317, '2.130.10.10-FF-004859', NULL, 'Uncharacterized protein', 125, NULL, NULL, 129317),
(129318, '3.30.750.24-FF-000165', NULL, 'Predicted protein', 100, NULL, NULL, 129318),
(129319, '3.40.1190.20-FF-000159', NULL, 'Bud site selection protein, putative', 287, NULL, NULL, 129319),
(129320, '2.60.20.10-FF-000030', NULL, NULL, 91, NULL, NULL, 129320),
(129321, '3.40.20.10-FF-000141', NULL, 'Gelsolin-related protein of 125 kDa', 122, NULL, NULL, 129321),
(129322, '3.30.70.270-FF-000299', NULL, NULL, 56, NULL, NULL, 129322),
(129323, '1.20.1070.10-FF-000889', NULL, 'Vomeronasal type-1 receptor', 249, NULL, NULL, 129323),
(129324, '3.90.280.10-FF-000023', NULL, NULL, 291, NULL, NULL, 129324),
(129325, '2.130.10.10-FF-003567', NULL, 'Uncharacterized protein', 273, NULL, NULL, 129325),
(129326, '3.30.160.60-FF-005601', NULL, NULL, 37, NULL, NULL, 129326),
(129327, '2.130.10.10-FF-000588', NULL, 'WD repeat and SOCS box-containing 1, isoform CRA_b', 82, NULL, NULL, 129327),
(129328, '2.30.230.10-FF-000026', NULL, 'Uncharacterized protein', 182, NULL, NULL, 129328),
(129329, '2.170.150.20-FF-000012', NULL, 'Peptide methionine sulfoxide reductase MsrB', 145, NULL, NULL, 129329);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(129330, '1.10.287.110-FF-000381', NULL, 'Predicted protein', 91, NULL, NULL, 129330),
(129331, '2.10.250.10-FF-000015', NULL, 'Calreticulin family protein', 123, NULL, NULL, 129331),
(129332, '3.30.160.60-FF-004983', NULL, NULL, 83, NULL, NULL, 129332),
(129333, '3.40.630.30-FF-000298', NULL, 'Acetyltransferase-like protein', 153, NULL, NULL, 129333),
(129334, '4.10.280.10-FF-000217', NULL, 'Uncharacterized protein', 41, NULL, NULL, 129334),
(129335, '3.40.850.10-FF-000415', NULL, 'Uncharacterized protein', 233, NULL, NULL, 129335),
(129336, '3.10.20.90-FF-000267', NULL, 'Blast:Serine/threonine-protein kinase TBK1', 88, NULL, NULL, 129336),
(129337, '3.80.10.10-FF-002229', NULL, 'F-box and leucine rich repeat protein 14', 89, NULL, NULL, 129337),
(129338, '1.20.1560.10-FF-000292', NULL, 'p-GlycoProtein related', 333, NULL, NULL, 129338),
(129339, '3.30.70.260-FF-000172', NULL, 'Aspartate kinase', 78, NULL, NULL, 129339),
(129340, '3.40.50.300-FF-000987', NULL, 'DEAD/DEAH box RNA helicase', 263, NULL, NULL, 129340),
(129341, '3.40.50.200-FF-000159', NULL, 'Uncharacterized protein', 265, NULL, NULL, 129341),
(129342, '3.40.50.12500-FF-000003', NULL, 'Hydantoin racemase (Dcg1), putative', 246, NULL, NULL, 129342),
(129343, '1.10.3380.10-FF-000056', NULL, 'Putative U5 small nuclear ribonucleoprotein 200 kDa helicase-like protein', 137, NULL, NULL, 129343),
(129344, '1.10.10.720-FF-000001', NULL, 'Leucine--tRNA ligase', 54, NULL, NULL, 129344),
(129345, '1.10.10.10-FF-001877', NULL, 'Integrating conjugative element relaxase, PFGI-1 class', 50, NULL, NULL, 129345),
(129346, '1.10.8.60-FF-000486', NULL, 'Peroxisomal biogenesis factor 6', 96, NULL, NULL, 129346),
(129347, '3.30.1490.190-FF-000029', NULL, 'Ferric uptake regulator, Fur family', 57, NULL, NULL, 129347),
(129348, '1.10.287.130-FF-000263', NULL, 'Sensor histidine kinase, copper metabolism, putative', 65, NULL, NULL, 129348),
(129349, '1.10.287.70-FF-000407', NULL, 'Predicted protein', 117, NULL, NULL, 129349),
(129350, '3.40.50.300-FF-001824', NULL, 'ATP-dependent DNA helicase', 208, NULL, NULL, 129350),
(129351, '1.10.3060.10-FF-000003', NULL, 'Protein translocase subunit SecA', 211, NULL, NULL, 129351),
(129352, '2.30.29.30-FF-000956', NULL, 'Exocyst complex component 8', 112, NULL, NULL, 129352),
(129353, '3.90.480.20-FF-000013', NULL, NULL, 176, NULL, NULL, 129353),
(129354, '3.40.50.300-FF-008171', NULL, 'Uncharacterized protein', 85, NULL, NULL, 129354),
(129355, '1.10.630.10-FF-000424', NULL, 'Uncharacterized protein', 236, NULL, NULL, 129355),
(129356, '2.70.50.40-FF-000001', NULL, 'protein unc-119 homolog A', 192, NULL, NULL, 129356),
(129357, '3.30.70.100-FF-000057', NULL, 'Diguanylate cyclase/phosphodiesterase domain 2 (EAL)', 140, NULL, NULL, 129357),
(129358, '3.30.559.10-FF-000167', NULL, 'Uncharacterized protein', 171, NULL, NULL, 129358),
(129359, '1.10.150.20-FF-000059', NULL, 'DNA polymerase', 62, NULL, NULL, 129359),
(129360, '2.60.40.790-FF-000018', NULL, 'Heat shock protein Hsp20', 149, NULL, NULL, 129360),
(129361, '1.20.1070.10-FF-002126', NULL, 'Uncharacterized protein', 281, NULL, NULL, 129361),
(129362, '1.10.132.20-FF-000006', NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', 88, NULL, NULL, 129362),
(129363, '2.130.10.10-FF-004404', NULL, 'Pleiotropic regulator 1', 37, NULL, NULL, 129363),
(129364, '2.60.40.10-FF-003819', NULL, NULL, 115, NULL, NULL, 129364),
(129365, '3.40.50.720-FF-001501', NULL, 'Fatty acyl-CoA reductase', 237, NULL, NULL, 129365),
(129366, '2.60.120.740-FF-000018', NULL, 'Beta-galactosidase', 93, NULL, NULL, 129366),
(129367, '1.10.10.60-FF-001291', NULL, NULL, 39, NULL, NULL, 129367),
(129368, '1.25.40.120-FF-000059', NULL, 'Uncharacterized protein', 227, NULL, NULL, 129368),
(129369, '1.25.40.720-FF-000019', NULL, 'Liquid facets-Related, isoform D', 136, NULL, NULL, 129369),
(129370, '1.10.1040.10-FF-000092', NULL, '2-dehydropantoate 2-reductase family protein, putative', 130, NULL, NULL, 129370),
(129371, '3.30.420.110-FF-000044', NULL, 'MSH (MutS Homolog) family', 155, NULL, NULL, 129371);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(129372, '3.20.20.370-FF-000012', NULL, 'YdjC chitooligosaccharide deacetylase homolog', 140, NULL, NULL, 129372),
(129373, '1.20.200.10-FF-000002', NULL, 'Argininosuccinate lyase', 217, NULL, NULL, 129373),
(129374, '3.30.450.20-FF-000486', NULL, 'Histidine kinase', 128, NULL, NULL, 129374),
(129375, '3.40.50.11530-FF-000015', NULL, 'Interleukin 17 receptor A1b', 121, NULL, NULL, 129375),
(129376, '1.10.225.10-FF-000022', NULL, 'Saposin-related', 81, NULL, NULL, 129376),
(129377, '3.40.50.720-FF-001158', NULL, 'ThiF family protein', 115, NULL, NULL, 129377),
(129378, '3.30.450.260-FF-000005', NULL, 'Soluble guanylate cyclase 89Da', 132, NULL, NULL, 129378),
(129379, '1.10.510.10-FF-004423', NULL, NULL, 65, NULL, NULL, 129379),
(129380, '2.20.70.10-FF-000097', NULL, 'Dystrophin-1', 40, NULL, NULL, 129380),
(129381, '1.25.40.10-FF-001104', NULL, 'Uncharacterized protein', 223, NULL, NULL, 129381),
(129382, '3.30.160.60-FF-000930', NULL, 'Zinc finger protein 335', 42, NULL, NULL, 129382),
(129383, '3.30.710.10-FF-000413', NULL, 'Potassium voltage-gated channel, shaker-related subfamily, member 7', 148, NULL, NULL, 129383),
(129384, '3.20.20.70-FF-000412', NULL, '1-(5-phosphoribosyl)-5-[(5-phosphoribosylamino)methylideneamino] imidazole-4-carboxamide isomerase', 241, NULL, NULL, 129384),
(129385, '2.60.40.10-FF-003134', NULL, 'Solute carrier family 35 member C2', 89, NULL, NULL, 129385),
(129386, '2.60.200.40-FF-000049', NULL, 'Diacylglycerol kinase, putative', 113, NULL, NULL, 129386),
(129387, '3.40.970.10-FF-000014', NULL, NULL, 50, NULL, NULL, 129387),
(129388, '3.90.640.10-FF-000231', NULL, 'Uncharacterized protein', 51, NULL, NULL, 129388),
(129389, '3.40.50.1440-FF-000125', NULL, 'Tubulin alpha-8 chain', 26, NULL, NULL, 129389),
(129390, '3.30.200.20-FF-000771', NULL, 'AGC family protein kinase', 97, NULL, NULL, 129390),
(129391, '2.60.40.10-FF-002858', NULL, NULL, 87, NULL, NULL, 129391),
(129392, '1.20.1050.10-FF-000219', NULL, 'Uncharacterized protein', 149, NULL, NULL, 129392),
(129393, '3.40.710.10-FF-000017', NULL, 'Stage V sporulation protein D', 196, NULL, NULL, 129393),
(129394, '1.10.287.2620-FF-000016', NULL, 'dynein heavy chain 6, axonemal isoform X1', 68, NULL, NULL, 129394),
(129395, '2.130.10.10-FF-001549', NULL, 'NACHT and WD repeat domain containing 2', 233, NULL, NULL, 129395),
(129396, '1.10.630.10-FF-000548', NULL, 'Uncharacterized protein', 342, NULL, NULL, 129396),
(129397, '2.130.10.10-FF-003443', NULL, 'Intraflagellar transport protein osm-1', 140, NULL, NULL, 129397),
(129398, '3.10.20.90-FF-000722', NULL, 'Fimbrin', 82, NULL, NULL, 129398),
(129399, '1.25.10.10-FF-000315', NULL, 'Sister chromatid cohesion protein', 204, NULL, NULL, 129399),
(129400, '1.10.238.10-FF-000119', NULL, 'TBC1 domain family member 9', 169, NULL, NULL, 129400),
(129401, '1.50.10.20-FF-000018', NULL, 'Geranylgeranyl transferase type-2 subunit beta', 335, NULL, NULL, 129401),
(129402, '3.90.420.10-FF-000012', NULL, 'Sulfite dehydrogenase molybdopterin-binding subunit SorA', 246, NULL, NULL, 129402),
(129403, '3.80.10.10-FF-000431', NULL, 'Leucine-rich repeat receptor-like protein kinase', 111, NULL, NULL, 129403),
(129404, '2.60.120.290-FF-000187', NULL, 'AGAP005526-PA', 151, NULL, NULL, 129404),
(129405, '1.10.3430.10-FF-000049', NULL, 'Uncharacterized protein', 323, NULL, NULL, 129405),
(129406, '3.30.230.10-FF-000264', NULL, 'Ribonuclease P protein component', 109, NULL, NULL, 129406),
(129407, '1.10.510.10-FF-000152', NULL, 'kalirin isoform X1', 210, NULL, NULL, 129407),
(129408, '3.40.50.300-FF-001948', NULL, 'ATP-dependent RNA helicase DBP5', 230, NULL, NULL, 129408),
(129409, '3.30.470.20-FF-000251', NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta mitochondrial', 37, NULL, NULL, 129409),
(129410, '3.40.50.12670-FF-000008', NULL, 'Carboxypeptidase', 171, NULL, NULL, 129410),
(129411, '3.20.20.140-FF-000398', NULL, 'Chlorohydrolase, conjectural', 130, NULL, NULL, 129411),
(129412, '1.20.920.20-FF-000026', NULL, 'Dynein heavy chain', 339, NULL, NULL, 129412),
(129413, '1.20.120.640-FF-000004', NULL, 'Predicted protein', 106, NULL, NULL, 129413);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(129414, '3.30.160.60-FF-003926', NULL, 'transcription factor Ouib', 69, NULL, NULL, 129414),
(129415, '3.40.50.11980-FF-000021', NULL, 'Uncharacterized protein', 99, NULL, NULL, 129415),
(129416, '1.20.120.350-FF-000018', NULL, 'Potassium voltage-gated channel subfamily B member', 153, NULL, NULL, 129416),
(129417, '3.30.1920.10-FF-000001', NULL, 'Mu phage baseplate assembly protein GpP', 74, NULL, NULL, 129417),
(129418, '1.10.8.10-FF-000044', NULL, 'UBX domain-containing protein 1', 44, NULL, NULL, 129418),
(129419, '2.60.40.10-FF-005264', NULL, NULL, 86, NULL, NULL, 129419),
(129420, '2.60.200.20-FF-000043', NULL, 'FHA domain containing protein, expressed', 97, NULL, NULL, 129420),
(129421, '3.40.390.10-FF-000155', NULL, NULL, 119, NULL, NULL, 129421),
(129422, '3.30.70.330-FF-001525', NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', 112, NULL, NULL, 129422),
(129423, '3.30.2130.10-FF-000003', NULL, 'Cytosolic arginine sensor for mTORC1 subunit 1', 149, NULL, NULL, 129423),
(129424, '3.40.50.720-FF-002119', NULL, 'Uncharacterized protein', 112, NULL, NULL, 129424),
(129425, '1.10.10.10-FF-001192', NULL, 'Forkhead box protein F1', 70, NULL, NULL, 129425),
(129426, '1.20.58.60-FF-000484', NULL, 'Spectrin beta chain', 123, NULL, NULL, 129426),
(129427, '2.40.50.40-FF-000036', NULL, 'Interleukin-8', 67, NULL, NULL, 129427),
(129428, '2.115.10.20-FF-000008', NULL, 'Extracellular endo-inulinase', 335, NULL, NULL, 129428),
(129429, '1.20.1070.10-FF-001507', NULL, 'Uncharacterized protein', 196, NULL, NULL, 129429),
(129430, '3.40.50.300-FF-003842', NULL, 'Predicted protein', 116, NULL, NULL, 129430),
(129431, '1.20.58.200-FF-000002', NULL, 'Putative translin', 93, NULL, NULL, 129431),
(129432, '1.20.120.1750-FF-000102', NULL, 'RBR-type E3 ubiquitin transferase', 87, NULL, NULL, 129432),
(129433, '3.40.50.620-FF-000841', NULL, 'Uncharacterized protein', 360, NULL, NULL, 129433),
(129434, '3.40.50.880-FF-000104', NULL, 'Catalase', 167, NULL, NULL, 129434),
(129435, '3.40.50.10190-FF-000355', NULL, 'Uncharacterized protein', 92, NULL, NULL, 129435),
(129436, '3.20.20.150-FF-000058', NULL, 'Protein arginine N-methyltransferase 5', 284, NULL, NULL, 129436),
(129437, '1.10.10.10-FF-001534', NULL, 'Uncharacterized protein', 90, NULL, NULL, 129437),
(129438, '1.10.3080.10-FF-000016', NULL, 'Chloride channel protein', 230, NULL, NULL, 129438),
(129439, '2.30.30.100-FF-000058', NULL, 'Small nuclear ribonucleoprotein Sm D3', 84, NULL, NULL, 129439),
(129440, '1.25.40.10-FF-002958', NULL, 'Predicted protein', 168, NULL, NULL, 129440),
(129441, '2.30.30.40-FF-000013', NULL, 'Alkylphosphonate utilization protein PhnA', 70, NULL, NULL, 129441),
(129442, '2.60.40.10-FF-002173', NULL, 'TRADV8 protein', 103, NULL, NULL, 129442),
(129443, '3.40.30.10-FF-000327', NULL, 'C-type cytochrome biogenesis protein', 116, NULL, NULL, 129443),
(129444, '3.40.720.10-FF-000193', NULL, 'Putative ethanolamine phosphotransferase', 341, NULL, NULL, 129444),
(129445, '3.40.50.720-FF-002451', NULL, 'Predicted protein', 49, NULL, NULL, 129445),
(129446, '3.30.70.330-FF-001183', NULL, 'RNA recognition motif domain containing protein', 143, NULL, NULL, 129446),
(129447, '3.40.630.30-FF-000410', NULL, 'Uncharacterized protein', 205, NULL, NULL, 129447),
(129448, '1.10.437.10-FF-000014', NULL, 'Bcl-2-like protein 10', 156, NULL, NULL, 129448),
(129449, '1.10.8.1220-FF-000005', NULL, 'Dynein heavy chain, putative', 90, NULL, NULL, 129449),
(129450, '3.40.190.10-FF-000499', NULL, 'GM24642', 125, NULL, NULL, 129450),
(129451, '1.10.287.370-FF-000099', NULL, 'Uncharacterized protein', 63, NULL, NULL, 129451),
(129452, '3.90.650.10-FF-000057', NULL, 'Selenide, water dikinase', 173, NULL, NULL, 129452),
(129453, '1.25.40.10-FF-000828', NULL, 'Pentatricopeptide repeat protein', 199, NULL, NULL, 129453),
(129454, '2.60.40.1150-FF-000006', NULL, 'AP complex subunit beta', 127, NULL, NULL, 129454),
(129455, '1.25.40.10-FF-003234', NULL, 'Pentatricopeptide repeat-containing protein At4g15720', 198, NULL, NULL, 129455),
(129456, '1.20.120.790-FF-000021', NULL, 'Chaperone protein HtpG', 132, NULL, NULL, 129456); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(129457, '3.20.20.70-FF-000070', NULL, 'Alpha-galactosidase', 293, NULL, NULL, 129457),
(129458, '3.40.718.10-FF-000029', NULL, 'Isocitrate dehydrogenase [NAD] subunit alpha, mitochondrial', 251, NULL, NULL, 129458),
(129459, '2.40.50.140-FF-001050', NULL, NULL, 171, NULL, NULL, 129459),
(129460, '3.40.1170.60-FF-000023', NULL, 'DNA repair protein REV1', 70, NULL, NULL, 129460),
(129461, '1.10.510.10-FF-002282', NULL, NULL, 182, NULL, NULL, 129461),
(129462, '2.60.40.10-FF-001897', NULL, 'Uncharacterized protein', 112, NULL, NULL, 129462),
(129463, '4.10.410.10-FF-000037', NULL, 'Protein CBR-MLT-11', 61, NULL, NULL, 129463),
(129464, '3.90.1200.10-FF-000074', NULL, 'Uncharacterized protein', 237, NULL, NULL, 129464),
(129465, '3.30.1120.30-FF-000042', NULL, 'Serine/threonine-protein kinase plk-3', 104, NULL, NULL, 129465),
(129466, '1.20.140.40-FF-000051', NULL, 'Probable pectinesterase/pectinesterase inhibitor 40', 152, NULL, NULL, 129466),
(129467, '1.20.810.10-FF-000032', NULL, 'Cytochrome b6-f complex subunit 4', 67, NULL, NULL, 129467),
(129468, '1.10.533.10-FF-000064', NULL, 'NLR family pyrin domain containing 12', 99, NULL, NULL, 129468),
(129469, '2.40.10.10-FF-000497', NULL, NULL, 111, NULL, NULL, 129469),
(129470, '2.40.30.10-FF-000262', NULL, 'tRNA-specific 2-thiouridylase MnmA', 75, NULL, NULL, 129470),
(129471, '1.10.472.10-FF-000495', NULL, 'Uncharacterized protein', 109, NULL, NULL, 129471),
(129472, '2.60.120.920-FF-000207', NULL, 'E3 ubiquitin-protein ligase NEURL1B-like protein', 121, NULL, NULL, 129472),
(129473, '3.40.50.150-FF-001633', NULL, NULL, 237, NULL, NULL, 129473),
(129474, '3.40.50.300-FF-005877', NULL, 'Uncharacterized protein', 170, NULL, NULL, 129474),
(129475, '1.20.5.190-FF-000179', NULL, NULL, 58, NULL, NULL, 129475),
(129476, '3.30.420.40-FF-000978', NULL, 'Uncharacterized protein', 128, NULL, NULL, 129476),
(129477, '3.40.850.10-FF-000179', NULL, 'KIF27 isoform 6', 172, NULL, NULL, 129477),
(129478, '1.10.600.10-FF-000035', NULL, 'Ent-copalyl diphosphate synthase, chloroplastic', 281, NULL, NULL, 129478),
(129479, '3.80.10.10-FF-003865', NULL, 'Glucose-repressible alcohol dehydrogenase transcriptional effector', 180, NULL, NULL, 129479),
(129480, '3.40.50.720-FF-002338', NULL, 'Uncharacterized protein', 162, NULL, NULL, 129480),
(129481, '1.25.10.10-FF-003406', NULL, 'Uncharacterized protein', 94, NULL, NULL, 129481),
(129482, '3.30.40.10-FF-001750', NULL, 'Uncharacterized protein', 88, NULL, NULL, 129482),
(129483, '3.40.120.10-FF-000113', NULL, 'Phosphoglucosamine mutase family protein', 90, NULL, NULL, 129483),
(129484, '1.10.238.10-FF-000451', NULL, 'Blast:Pyrazinamidase/nicotinamidase', 84, NULL, NULL, 129484),
(129485, '3.30.450.210-FF-000001', NULL, 'Sensor histidine kinase CpxA', 121, NULL, NULL, 129485),
(129486, '2.40.50.690-FF-000023', NULL, 'Exoribonuclease II', 110, NULL, NULL, 129486),
(129487, '3.20.20.60-FF-000078', NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', 265, NULL, NULL, 129487),
(129488, '4.10.280.110-FF-000026', NULL, NULL, 75, NULL, NULL, 129488),
(129489, '3.40.50.1820-FF-000711', NULL, 'Lipase', 125, NULL, NULL, 129489),
(129490, '1.20.5.690-FF-000003', NULL, 'Importin subunit alpha', 43, NULL, NULL, 129490),
(129491, '3.80.10.10-FF-004141', NULL, 'Predicted protein', 109, NULL, NULL, 129491),
(129492, '2.60.40.420-FF-000273', NULL, 'Uncharacterized protein', 79, NULL, NULL, 129492),
(129493, '3.40.50.1010-FF-000114', NULL, 'rRNA-processing protein FCF1', 174, NULL, NULL, 129493),
(129494, '3.30.260.10-FF-000092', NULL, NULL, 94, NULL, NULL, 129494),
(129495, '2.60.40.10-FF-005949', NULL, NULL, 94, NULL, NULL, 129495),
(129496, '1.25.40.10-FF-003919', NULL, 'Predicted protein', 294, NULL, NULL, 129496),
(129497, '2.60.40.60-FF-000142', NULL, 'Cadherin 23', 106, NULL, NULL, 129497),
(129498, '2.60.40.10-FF-001554', NULL, 'B-cell antigen receptor complex-associated protein beta chain', 117, NULL, NULL, 129498),
(129499, '3.10.650.10-FF-000002', NULL, 'Binding-protein-dependent transport systems inner membrane component', 77, NULL, NULL, 129499);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(129500, '2.30.30.490-FF-000017', NULL, 'Bromo-adjacent homology (BAH) domain-containing protein', 152, NULL, NULL, 129500),
(129501, '3.90.79.10-FF-000100', NULL, 'Adenine DNA glycosylase', 151, NULL, NULL, 129501),
(129502, '1.20.272.10-FF-000005', NULL, 'Replication factor C subunit 1', 113, NULL, NULL, 129502),
(129503, '2.30.180.10-FF-000033', NULL, 'Stabilin 1', 123, NULL, NULL, 129503),
(129504, '3.30.450.20-FF-000249', NULL, 'Serine phosphatase RsbU (Regulator of sigma subunit)', 110, NULL, NULL, 129504),
(129505, '3.90.199.10-FF-000007', NULL, 'DNA topoisomerase 2', 192, NULL, NULL, 129505),
(129506, '1.10.640.10-FF-000032', NULL, 'Uncharacterized protein', 569, NULL, NULL, 129506),
(129507, '1.10.10.10-FF-001771', NULL, 'ORC1-type DNA replication protein 5', 104, NULL, NULL, 129507),
(129508, '1.20.1070.10-FF-000546', NULL, 'DOPamine receptor', 308, NULL, NULL, 129508),
(129509, '3.30.930.10-FF-000177', NULL, 'Lysine--tRNA ligase', 369, NULL, NULL, 129509),
(129510, '3.30.420.40-FF-000074', NULL, 'Heat shock protein family A (Hsp70) member 12A', 94, NULL, NULL, 129510),
(129511, '3.20.20.100-FF-000072', NULL, 'Aldose reductase, putative', 301, NULL, NULL, 129511),
(129512, '1.10.510.10-FF-003243', NULL, NULL, 118, NULL, NULL, 129512),
(129513, '3.40.50.300-FF-006838', NULL, 'Uncharacterized protein', 264, NULL, NULL, 129513),
(129514, '2.30.42.10-FF-000245', NULL, 'Sip1', 89, NULL, NULL, 129514),
(129515, '3.40.1090.10-FF-000103', NULL, 'Patatin', 36, NULL, NULL, 129515),
(129516, '3.30.70.3340-FF-000001', NULL, 'Sulfite reductase, beta subunit', 81, NULL, NULL, 129516),
(129517, '3.30.420.140-FF-000042', NULL, 'Uncharacterized protein', 121, NULL, NULL, 129517),
(129518, '3.40.50.1000-FF-000235', NULL, 'Haloacid dehalogenase-like hydrolase (HAD) superfamily protein', 220, NULL, NULL, 129518),
(129519, '3.60.21.10-FF-000406', NULL, 'Serine/threonine-protein phosphatase', 302, NULL, NULL, 129519),
(129520, '1.10.238.10-FF-000232', NULL, 'Centrin-2, putative', 79, NULL, NULL, 129520),
(129521, '1.25.10.10-FF-002569', NULL, 'Sister chromatid cohesion protein', 168, NULL, NULL, 129521),
(129522, '3.40.50.1820-FF-000930', NULL, 'Os11g0431700 protein', 364, NULL, NULL, 129522),
(129523, '1.50.40.10-FF-000528', NULL, 'Solute carrier family 25 (mitochondrial carrier; phosphate carrier), member 24, like', 161, NULL, NULL, 129523),
(129524, '1.25.40.20-FF-000022', NULL, 'protein TANC2 isoform X1', 226, NULL, NULL, 129524),
(129525, '2.170.270.10-FF-000063', NULL, 'SET domain protein, putative', 112, NULL, NULL, 129525),
(129526, '3.10.20.90-FF-000161', NULL, 'Uncharacterized protein, isoform C', 84, NULL, NULL, 129526),
(129527, '3.30.1540.20-FF-000020', NULL, NULL, 83, NULL, NULL, 129527),
(129528, '3.30.420.10-FF-000531', NULL, NULL, 98, NULL, NULL, 129528),
(129529, '1.10.405.20-FF-000011', NULL, NULL, 120, NULL, NULL, 129529),
(129530, '2.60.120.10-FF-000449', NULL, 'Phosphomannose isomerase type I', 178, NULL, NULL, 129530),
(129531, '3.10.20.230-FF-000034', NULL, 'Uncharacterized protein', 101, NULL, NULL, 129531),
(129532, '2.60.120.340-FF-000005', NULL, 'nucleoplasmin-like protein', 111, NULL, NULL, 129532),
(129533, '3.40.50.300-FF-003404', NULL, 'Uncharacterized protein, isoform C', 206, NULL, NULL, 129533),
(129534, '1.10.357.140-FF-000013', NULL, 'Protoheme IX farnesyltransferase', 149, NULL, NULL, 129534),
(129535, '3.90.70.10-FF-000232', NULL, 'Ubiquitin carboxyl-terminal hydrolase, putative', 356, NULL, NULL, 129535),
(129536, '2.60.40.10-FF-004988', NULL, NULL, 108, NULL, NULL, 129536),
(129537, '3.30.70.330-FF-002705', NULL, NULL, 107, NULL, NULL, 129537),
(129538, '2.60.40.10-FF-002515', NULL, 'Alpha-amylase', 114, NULL, NULL, 129538),
(129539, '3.30.505.10-FF-000228', NULL, NULL, 93, NULL, NULL, 129539),
(129540, '3.20.20.80-FF-000292', NULL, 'Lactase-like a', 222, NULL, NULL, 129540),
(129541, '3.20.20.70-FF-000755', NULL, NULL, 64, NULL, NULL, 129541),
(129542, '1.10.510.10-FF-003462', NULL, NULL, 273, NULL, NULL, 129542),
(129543, '2.60.40.10-FF-005388', NULL, NULL, 54, NULL, NULL, 129543);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(129544, '3.30.160.60-FF-003128', NULL, 'zinc finger protein 213-like isoform X1', 27, NULL, NULL, 129544),
(129545, '2.60.120.650-FF-000093', NULL, 'Uncharacterized protein AT4g21430', 365, NULL, NULL, 129545),
(129546, '1.25.40.10-FF-000143', NULL, 'E3 ubiquitin-protein ligase TTC3 isoform X2', 115, NULL, NULL, 129546),
(129547, '3.40.50.300-FF-005079', NULL, 'Uncharacterized protein', 92, NULL, NULL, 129547),
(129548, '3.90.1410.10-FF-000117', NULL, 'SET domain-containing 4', 209, NULL, NULL, 129548),
(129549, '3.40.605.10-FF-000110', NULL, 'Uncharacterized protein', 218, NULL, NULL, 129549),
(129550, '3.30.499.10-FF-000016', NULL, 'Homoaconitase, mitochondrial', 286, NULL, NULL, 129550),
(129551, '3.40.50.10190-FF-000012', NULL, 'X-ray repair cross complementing 1', 105, NULL, NULL, 129551),
(129552, '3.30.760.10-FF-000017', NULL, 'Eukaryotic translation initiation factor 4E-1', 195, NULL, NULL, 129552),
(129553, '3.60.10.10-FF-000269', NULL, 'Uncharacterized protein', 182, NULL, NULL, 129553),
(129554, '3.30.1780.10-FF-000012', NULL, 'Ketimine reductase mu-crystallin', 13, NULL, NULL, 129554),
(129555, '3.90.550.50-FF-000112', NULL, 'Hexosyltransferase', 160, NULL, NULL, 129555),
(129556, '1.10.3260.10-FF-000002', NULL, 'DNA ligase', 205, NULL, NULL, 129556),
(129557, '3.40.30.10-FF-000080', NULL, 'Sulfhydryl oxidase', 109, NULL, NULL, 129557),
(129558, '1.25.40.10-FF-003577', NULL, 'Mitogen-activated protein kinase kinase kinase 15', 177, NULL, NULL, 129558),
(129559, '3.40.50.10480-FF-000009', NULL, 'Ribosome biogenesis protein, putative', 184, NULL, NULL, 129559),
(129560, '3.40.630.30-FF-000192', NULL, 'Putative N-acetyltransferase C9.02c', 158, NULL, NULL, 129560),
(129561, '2.10.110.10-FF-000185', NULL, 'Homeobox protein ceh-14', 72, NULL, NULL, 129561),
(129562, '3.40.50.1820-FF-000037', NULL, 'Lysosomal thioesterase PPT2 homolog', 268, NULL, NULL, 129562),
(129563, '3.30.40.10-FF-000238', NULL, 'PHD finger family protein', 63, NULL, NULL, 129563),
(129564, '1.25.40.10-FF-004870', NULL, 'Pentatricopeptide repeat-containing protein At5g39710', 110, NULL, NULL, 129564),
(129565, '3.30.450.90-FF-000012', NULL, 'P-type conjugative transfer ATPase TrbB', 104, NULL, NULL, 129565),
(129566, '2.40.20.10-FF-000104', NULL, 'Putative macrophage stimulating 1-like protein', 126, NULL, NULL, 129566),
(129567, '3.40.50.1820-FF-001330', NULL, 'Uncharacterized protein', 256, NULL, NULL, 129567),
(129568, '2.130.10.10-FF-002263', NULL, 'Transducin/WD40 repeat-like superfamily protein', 310, NULL, NULL, 129568),
(129569, '3.30.420.40-FF-001035', NULL, 'Uncharacterized protein', 27, NULL, NULL, 129569),
(129570, '1.10.1410.10-FF-000031', NULL, 'Poly(A) polymerase, putative', 159, NULL, NULL, 129570),
(129571, '3.40.50.620-FF-000622', NULL, 'Transport protein (Probable substrate cationic amino acids)', 136, NULL, NULL, 129571),
(129572, '3.30.470.20-FF-000138', NULL, 'Uncharacterized protein', 226, NULL, NULL, 129572),
(129573, '3.30.60.20-FF-000006', NULL, 'Protein kinase C', 70, NULL, NULL, 129573),
(129574, '1.10.4160.10-FF-000034', NULL, 'Uncharacterized protein', 379, NULL, NULL, 129574),
(129575, '3.40.30.10-FF-000580', NULL, 'Thiol:disulfide interchange protein DsbD', 119, NULL, NULL, 129575),
(129576, '3.20.20.140-FF-000342', NULL, 'Resiniferatoxin-binding, phosphotriesterase-related protein', 353, NULL, NULL, 129576),
(129577, '2.30.30.140-FF-000334', NULL, 'Uncharacterized protein', 76, NULL, NULL, 129577),
(129578, '3.60.40.10-FF-000063', NULL, 'Probable protein phosphatase 2C 12', 317, NULL, NULL, 129578),
(129579, '2.60.40.10-FF-003741', NULL, NULL, 116, NULL, NULL, 129579),
(129580, '1.10.630.10-FF-000138', NULL, 'Os10g0167200 protein', 180, NULL, NULL, 129580),
(129581, '2.60.120.260-FF-000296', NULL, 'Coagulation factor V', 155, NULL, NULL, 129581),
(129582, '2.130.10.10-FF-003752', NULL, 'Uncharacterized protein', 326, NULL, NULL, 129582),
(129583, '1.10.287.70-FF-000661', NULL, 'Uncharacterized protein', 130, NULL, NULL, 129583),
(129584, '3.10.400.20-FF-000026', NULL, 'Uncharacterized protein', 200, NULL, NULL, 129584); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(129585, '3.40.309.10-FF-000057', NULL, 'ALdehyde deHydrogenase', 151, NULL, NULL, 129585),
(129586, '3.80.10.10-FF-002196', NULL, 'Toll-like receptor 5b', 70, NULL, NULL, 129586),
(129587, '3.30.160.60-FF-006450', NULL, NULL, 71, NULL, NULL, 129587),
(129588, '1.20.1070.10-FF-000934', NULL, 'Uncharacterized protein', 281, NULL, NULL, 129588),
(129589, '1.20.58.60-FF-000815', NULL, 'Uncharacterized protein', 306, NULL, NULL, 129589),
(129590, '2.60.120.10-FF-000348', NULL, 'Nucleotide-binding protein', 148, NULL, NULL, 129590),
(129591, '1.10.3450.40-FF-000003', NULL, 'Signal recognition particle subunit SRP68,putative', 208, NULL, NULL, 129591),
(129592, '1.10.3080.10-FF-000033', NULL, 'Chloride channel, voltage-sensitive 1', 266, NULL, NULL, 129592),
(129593, '3.40.50.2300-FF-001007', NULL, NULL, 147, NULL, NULL, 129593),
(129594, '1.10.150.50-FF-000107', NULL, 'MAPKKK cascade protein kinase regulator Ste50 (AFU_orthologue AFUA_2G17130)', 70, NULL, NULL, 129594),
(129595, '3.40.50.620-FF-000858', NULL, 'Uncharacterized protein', 192, NULL, NULL, 129595),
(129596, '3.40.1170.60-FF-000052', NULL, NULL, 97, NULL, NULL, 129596),
(129597, '3.40.50.10190-FF-000225', NULL, 'AGAP003213-PA', 95, NULL, NULL, 129597),
(129598, '1.10.238.10-FF-001047', NULL, 'Uncharacterized protein', 39, NULL, NULL, 129598),
(129599, '2.40.40.20-FF-000035', NULL, 'DMSO reductase', 148, NULL, NULL, 129599),
(129600, '1.10.510.10-FF-003743', NULL, NULL, 148, NULL, NULL, 129600),
(129601, '1.25.40.10-FF-003487', NULL, 'Putative pentatricopeptide repeat-containing protein At1g13800', 186, NULL, NULL, 129601),
(129602, '1.20.1280.50-FF-000113', NULL, 'F-box domain containing protein, expressed', 83, NULL, NULL, 129602),
(129603, '1.10.260.40-FF-000079', NULL, 'Virulence-associated protein I', 102, NULL, NULL, 129603),
(129604, '2.40.160.20-FF-000021', NULL, 'Lipid A deacylase', 146, NULL, NULL, 129604),
(129605, '2.40.50.140-FF-001252', NULL, NULL, 62, NULL, NULL, 129605),
(129606, '1.10.510.10-FF-003097', NULL, NULL, 198, NULL, NULL, 129606),
(129607, '3.50.50.60-FF-000197', NULL, 'Polyamine oxidase FMS1', 232, NULL, NULL, 129607),
(129608, '3.30.160.60-FF-003218', NULL, 'Serendipity locus protein delta', 31, NULL, NULL, 129608),
(129609, '3.30.70.1560-FF-000006', NULL, 'RNA pseudouridylate synthase', 80, NULL, NULL, 129609),
(129610, '3.40.50.12780-FF-000143', NULL, 'Uncharacterized protein', 208, NULL, NULL, 129610),
(129611, '3.40.50.10490-FF-000164', NULL, NULL, 140, NULL, NULL, 129611),
(129612, '2.110.10.10-FF-000010', NULL, 'vitronectin', 172, NULL, NULL, 129612),
(129613, '2.60.40.1730-FF-000006', NULL, 'Aminopeptidase', 219, NULL, NULL, 129613),
(129614, '1.20.1070.10-FF-000288', NULL, 'Muscarinic acetylcholine receptor', 122, NULL, NULL, 129614),
(129615, '3.40.50.200-FF-000176', NULL, 'Uncharacterized protein', 339, NULL, NULL, 129615),
(129616, '3.40.50.2000-FF-000518', NULL, 'Processive diacylglycerol beta-glucosyltransferase', 163, NULL, NULL, 129616),
(129617, '4.10.170.10-FF-000006', NULL, 'Serine/threonine kinase 3', 57, NULL, NULL, 129617),
(129618, '3.40.720.10-FF-000355', NULL, 'Uncharacterized protein', 58, NULL, NULL, 129618),
(129619, '3.50.50.60-FF-000876', NULL, 'FAD-dependent oxidoreductase domain containing 2', 373, NULL, NULL, 129619),
(129620, '2.60.20.10-FF-000013', NULL, 'Crystallin beta-gamma domain containing 3', 78, NULL, NULL, 129620),
(129621, '3.40.50.300-FF-007322', NULL, 'Putative DNA mismatch repair ATPase Msh3', 145, NULL, NULL, 129621),
(129622, '2.60.210.10-FF-000001', NULL, 'TNF receptor-associated factor', 187, NULL, NULL, 129622),
(129623, '3.30.70.330-FF-002020', NULL, NULL, 167, NULL, NULL, 129623),
(129624, '1.20.58.400-FF-000040', NULL, 'Vesicle transport through interaction with t-SNAREs 1B', 89, NULL, NULL, 129624),
(129625, '3.40.50.720-FF-001052', NULL, 'Glutamate dehydrogenase', 293, NULL, NULL, 129625),
(129626, '1.10.1450.10-FF-000140', NULL, 'Tetraspanin', 96, NULL, NULL, 129626),
(129627, '1.10.560.10-FF-000109', NULL, 'Uncharacterized protein', 117, NULL, NULL, 129627); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(129628, '1.25.40.20-FF-001399', NULL, 'Uncharacterized protein', 65, NULL, NULL, 129628),
(129629, '2.60.40.10-FF-005865', NULL, NULL, 107, NULL, NULL, 129629),
(129630, '2.130.10.10-FF-005517', NULL, 'Protein CBR-ELPC-2', 63, NULL, NULL, 129630),
(129631, '3.40.50.720-FF-002187', NULL, 'Os05g0595100 protein', 51, NULL, NULL, 129631),
(129632, '3.40.50.300-FF-006220', NULL, 'Uncharacterized protein', 220, NULL, NULL, 129632),
(129633, '3.40.720.10-FF-000029', NULL, 'ectonucleotide pyrophosphatase/phosphodiesterase family member 6', 271, NULL, NULL, 129633),
(129634, '3.90.180.10-FF-000162', NULL, 'Uncharacterized protein', 138, NULL, NULL, 129634),
(129635, '1.20.1560.10-FF-000842', NULL, 'Predicted protein', 334, NULL, NULL, 129635),
(129636, '2.70.98.40-FF-000010', NULL, 'Putative glycosyl hydrolase', 243, NULL, NULL, 129636),
(129637, '1.25.10.10-FF-001535', NULL, 'Coatomer subunit gamma', 132, NULL, NULL, 129637),
(129638, '3.30.420.10-FF-000329', NULL, 'Exonuclease', 205, NULL, NULL, 129638),
(129639, '1.20.5.340-FF-000027', NULL, 'myosin-11 isoform X2', 117, NULL, NULL, 129639),
(129640, '2.60.260.20-FF-000041', NULL, 'HSP40/DnaJ peptide-binding protein', 82, NULL, NULL, 129640),
(129641, '2.60.40.60-FF-000889', NULL, 'Uncharacterized protein', 104, NULL, NULL, 129641),
(129642, '1.10.167.10-FF-000038', NULL, 'Regulator of G-protein signaling rgs-7', 151, NULL, NULL, 129642),
(129643, '2.60.40.10-FF-004876', NULL, NULL, 49, NULL, NULL, 129643),
(129644, '3.30.750.170-FF-000001', NULL, 'Peptidase S41', 120, NULL, NULL, 129644),
(129645, '1.10.3090.10-FF-000005', NULL, 'Bifunctional uridylyltransferase/uridylyl-removing enzyme', 231, NULL, NULL, 129645),
(129646, '3.30.70.270-FF-000063', NULL, 'Zinc knuckle domaincontaining protein', 87, NULL, NULL, 129646),
(129647, '4.10.520.10-FF-000017', NULL, 'Integration host factor alpha-subunit', 97, NULL, NULL, 129647),
(129648, '3.30.70.260-FF-000060', NULL, 'ACT domain repeat 6', 77, NULL, NULL, 129648),
(129649, '1.25.10.10-FF-000433', NULL, 'Nuclear cohesin complex subunit (Psc3), putative', 186, NULL, NULL, 129649),
(129650, '4.10.240.10-FF-000035', NULL, 'C6 transcription factor, putative (AFU_orthologue AFUA_4G12570)', 84, NULL, NULL, 129650),
(129651, '2.60.40.10-FF-003095', NULL, NULL, 107, NULL, NULL, 129651),
(129652, '2.40.30.10-FF-000060', NULL, 'elongation factor 1-alpha isoform X4', 110, NULL, NULL, 129652),
(129653, '3.40.850.10-FF-000393', NULL, 'Unconventional myosin 29D short isoform', 292, NULL, NULL, 129653),
(129654, '3.30.70.330-FF-001031', NULL, 'Nop8p', 87, NULL, NULL, 129654),
(129655, '3.40.50.300-FF-002151', NULL, 'SNF2 domain-containing protein CLASSY 3', 274, NULL, NULL, 129655),
(129656, '1.25.10.10-FF-001861', NULL, 'Condensin complex subunit 1', 174, NULL, NULL, 129656),
(129657, '3.30.565.10-FF-000041', NULL, 'Sensor histidine kinase DcuS', 146, NULL, NULL, 129657),
(129658, '3.30.1640.10-FF-000002', NULL, 'DNA helicase', 101, NULL, NULL, 129658),
(129659, '1.25.40.10-FF-001363', NULL, 'Pentatricopeptide repeat-containing protein ATP4 homolog, chloroplastic', 123, NULL, NULL, 129659),
(129660, '1.10.820.10-FF-000001', NULL, 'Genome polyprotein', 133, NULL, NULL, 129660),
(129661, '1.25.40.10-FF-004004', NULL, 'Uncharacterized protein', 338, NULL, NULL, 129661),
(129662, '3.90.810.10-FF-000042', NULL, NULL, 78, NULL, NULL, 129662),
(129663, '1.10.630.10-FF-000817', NULL, 'Uncharacterized protein', 255, NULL, NULL, 129663),
(129664, '2.130.10.10-FF-003426', NULL, 'Protein GFS12', 175, NULL, NULL, 129664),
(129665, '3.30.230.10-FF-000146', NULL, 'Elongation factor 2 putative', 168, NULL, NULL, 129665),
(129666, '3.30.200.20-FF-000647', NULL, 'Mitogen-activated protein kinase', 88, NULL, NULL, 129666),
(129667, '3.40.50.1010-FF-000210', NULL, NULL, 47, NULL, NULL, 129667),
(129668, '2.130.10.10-FF-005197', NULL, 'SOF1 protein', 104, NULL, NULL, 129668),
(129669, '3.10.120.10-FF-000041', NULL, 'Acyl-lipid omega-13 desaturase', 72, NULL, NULL, 129669),
(129670, '3.30.420.40-FF-000231', NULL, 'Heat shock protein family A (Hsp70) member 2', 95, NULL, NULL, 129670);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(129671, '1.10.530.10-FF-000080', NULL, 'Uncharacterized protein', 57, NULL, NULL, 129671),
(129672, '2.130.10.10-FF-001509', NULL, 'Protein NEDD1', 87, NULL, NULL, 129672),
(129673, '1.20.1250.20-FF-001171', NULL, 'Uncharacterized protein', 205, NULL, NULL, 129673),
(129674, '1.25.40.1030-FF-000019', NULL, 'AGAP011214-PA', 237, NULL, NULL, 129674),
(129675, '2.130.10.10-FF-004854', NULL, 'Protein CBG07276', 321, NULL, NULL, 129675),
(129676, '3.30.1640.30-FF-000008', NULL, 'Serine protease grass', 78, NULL, NULL, 129676),
(129677, '1.10.10.10-FF-001416', NULL, 'Transcriptional regulator, GntR family', 75, NULL, NULL, 129677),
(129678, '3.30.40.10-FF-001323', NULL, 'Zinc finger family protein', 51, NULL, NULL, 129678),
(129679, '3.30.365.10-FF-000060', NULL, 'Uncharacterized protein', 73, NULL, NULL, 129679),
(129680, '2.60.120.380-FF-000040', NULL, 'Uncharacterized protein', 98, NULL, NULL, 129680),
(129681, '3.80.10.10-FF-004287', NULL, 'Predicted protein', 241, NULL, NULL, 129681),
(129682, '1.10.8.720-FF-000014', NULL, 'Putative dynein heavy chain', 176, NULL, NULL, 129682),
(129683, '3.40.50.300-FF-007794', NULL, 'Predicted protein', 48, NULL, NULL, 129683),
(129684, '3.30.70.100-FF-000091', NULL, 'Uncharacterized protein', 71, NULL, NULL, 129684),
(129685, '2.60.120.200-FF-000385', NULL, 'AGAP003873-PA', 176, NULL, NULL, 129685),
(129686, '3.40.50.2000-FF-000198', NULL, 'Glycosyltransferase', 261, NULL, NULL, 129686),
(129687, '3.40.50.300-FF-000060', NULL, 'ATP-dependent DNA helicase', 192, NULL, NULL, 129687),
(129688, '1.10.220.20-FF-000008', NULL, 'BRag/Iqsec/Schizo related Arf GEF family member', 94, NULL, NULL, 129688),
(129689, '3.30.160.60-FF-006124', NULL, NULL, 36, NULL, NULL, 129689),
(129690, '2.60.120.10-FF-000202', NULL, '5-deoxy-glucuronate isomerase', 147, NULL, NULL, 129690),
(129691, '1.10.3170.10-FF-000006', NULL, 'DNA helicase', 200, NULL, NULL, 129691),
(129692, '2.10.90.10-FF-000014', NULL, 'Noggin', 123, NULL, NULL, 129692),
(129693, '2.30.39.10-FF-000102', NULL, 'Serpin-Z1', 61, NULL, NULL, 129693),
(129694, '2.60.120.10-FF-000674', NULL, 'Uncharacterized protein', 99, NULL, NULL, 129694),
(129695, '3.30.70.330-FF-001710', NULL, NULL, 53, NULL, NULL, 129695),
(129696, '3.30.160.60-FF-003544', NULL, NULL, 31, NULL, NULL, 129696),
(129697, '3.40.50.300-FF-005377', NULL, 'Uncharacterized protein', 110, NULL, NULL, 129697),
(129698, '1.10.287.70-FF-000368', NULL, 'Voltage-gated Ca2+ channel, alpha subunit', 158, NULL, NULL, 129698),
(129699, '3.20.20.140-FF-000016', NULL, 'Adenine deaminase', 245, NULL, NULL, 129699),
(129700, '1.10.10.790-FF-000050', NULL, NULL, 66, NULL, NULL, 129700),
(129701, '1.10.10.10-FF-000899', NULL, 'MarR family transcriptional regulator', 145, NULL, NULL, 129701),
(129702, '2.60.40.10-FF-003448', NULL, NULL, 103, NULL, NULL, 129702),
(129703, '3.10.50.40-FF-000131', NULL, 'Peptidyl-prolyl cis-trans isomerase', 165, NULL, NULL, 129703),
(129704, '1.50.40.10-FF-000017', NULL, 'Solute carrier family 25 member 22a', 308, NULL, NULL, 129704),
(129705, '3.40.50.150-FF-001774', NULL, NULL, 199, NULL, NULL, 129705),
(129706, '3.40.190.80-FF-000014', NULL, 'CysQ protein', 105, NULL, NULL, 129706),
(129707, '2.60.120.200-FF-000059', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1', 189, NULL, NULL, 129707),
(129708, '2.60.40.10-FF-005539', NULL, NULL, 46, NULL, NULL, 129708),
(129709, '2.10.25.10-FF-001105', NULL, 'Fbn3 protein', 32, NULL, NULL, 129709),
(129710, '3.20.20.80-FF-000685', NULL, 'Uncharacterized protein', 315, NULL, NULL, 129710),
(129711, '2.60.40.10-FF-000222', NULL, 'Myomesin 1', 99, NULL, NULL, 129711),
(129712, '3.30.40.10-FF-000660', NULL, 'RING/U-box superfamily protein', 67, NULL, NULL, 129712),
(129713, '1.25.40.20-FF-001692', NULL, 'Calmodulin-binding transcription activator 5', 244, NULL, NULL, 129713),
(129714, '1.10.510.10-FF-002315', NULL, NULL, 218, NULL, NULL, 129714),
(129715, '3.40.30.10-FF-000254', NULL, 'DUF255 domain-containing protein', 102, NULL, NULL, 129715),
(129716, '2.60.120.330-FF-000165', NULL, 'Predicted protein', 327, NULL, NULL, 129716);
INSERT INTO "PUBLIC"."MODEL" VALUES
(129717, '3.90.190.10-FF-000134', NULL, 'Uncharacterized protein', 161, NULL, NULL, 129717),
(129718, '3.60.10.10-FF-000409', NULL, 'Alpha-galactosidase', 319, NULL, NULL, 129718),
(129719, '3.30.160.60-FF-004033', NULL, NULL, 31, NULL, NULL, 129719),
(129720, '1.10.510.10-FF-001326', NULL, 'Protein kinase domain containing protein', 99, NULL, NULL, 129720),
(129721, '3.20.20.120-FF-000010', NULL, 'Dipeptide epimerase', 207, NULL, NULL, 129721),
(129722, '1.25.10.10-FF-000107', NULL, 'Importin-13', 886, NULL, NULL, 129722),
(129723, '2.60.40.200-FF-000016', NULL, 'Extracellular superoxide dismutase [Cu-Zn] 3', 144, NULL, NULL, 129723),
(129724, '3.40.190.10-FF-000100', NULL, 'LysR family transcriptional regulator', 89, NULL, NULL, 129724),
(129725, '4.10.1000.10-FF-000059', NULL, 'Putative zinc finger CCCH domain-containing protein 48', 34, NULL, NULL, 129725),
(129726, '3.80.10.10-FF-000751', NULL, 'Si:dkey-16p6.1', 179, NULL, NULL, 129726),
(129727, '3.40.50.1110-FF-000094', NULL, 'YALI0B07227p', 242, NULL, NULL, 129727),
(129728, '3.40.50.150-FF-001509', NULL, NULL, 111, NULL, NULL, 129728),
(129729, '2.30.30.140-FF-000008', NULL, 'Bromodomain containing 1, isoform CRA_b', 131, NULL, NULL, 129729),
(129730, '2.60.40.10-FF-005186', NULL, NULL, 93, NULL, NULL, 129730),
(129731, '3.90.1410.10-FF-000011', NULL, 'Transcription factor, E2F and DP-related', 249, NULL, NULL, 129731),
(129732, '2.60.40.10-FF-002959', NULL, 'High Incidence of Males (Increased X chromosome loss)', 93, NULL, NULL, 129732),
(129733, '4.10.1060.10-FF-000068', NULL, 'Uncharacterized protein', 45, NULL, NULL, 129733),
(129734, '3.40.1170.10-FF-000031', NULL, 'DNA mismatch repair protein MutS', 125, NULL, NULL, 129734),
(129735, '1.10.437.10-FF-000048', NULL, 'Uncharacterized protein', 132, NULL, NULL, 129735),
(129736, '3.30.310.10-FF-000034', NULL, 'Uncharacterized protein', 62, NULL, NULL, 129736),
(129737, '3.30.160.60-FF-005635', NULL, NULL, 34, NULL, NULL, 129737),
(129738, '2.60.40.60-FF-000304', NULL, 'Dachsous cadherin-related 2', 121, NULL, NULL, 129738),
(129739, '3.90.640.90-FF-000013', NULL, 'Uncharacterized protein', 128, NULL, NULL, 129739),
(129740, '2.40.50.700-FF-000004', NULL, 'Exosome complex exonuclease RRP44 homolog A', 77, NULL, NULL, 129740),
(129741, '1.20.1510.10-FF-000098', NULL, NULL, 103, NULL, NULL, 129741),
(129742, '1.10.510.10-FF-003417', NULL, NULL, 293, NULL, NULL, 129742),
(129743, '2.60.120.920-FF-000128', NULL, 'Neuralized-like protein 4', 191, NULL, NULL, 129743),
(129744, '1.25.40.20-FF-000590', NULL, 'Protein CBG13985', 172, NULL, NULL, 129744),
(129745, '1.10.285.10-FF-000003', NULL, 'Glutamate dehydrogenase', 37, NULL, NULL, 129745),
(129746, '2.30.29.30-FF-000669', NULL, 'Uncharacterized protein', 98, NULL, NULL, 129746),
(129747, '1.10.630.10-FF-000290', NULL, 'Cytochrome P-450 IIC5, putative', 153, NULL, NULL, 129747),
(129748, '2.70.160.11-FF-000046', NULL, 'PRotein arginine MethylTransferase', 159, NULL, NULL, 129748),
(129749, '3.30.450.60-FF-000065', NULL, 'Mu-adaptin 4, putative', 150, NULL, NULL, 129749),
(129750, '2.130.10.10-FF-003073', NULL, 'Uncharacterized protein', 123, NULL, NULL, 129750),
(129751, '2.60.120.200-FF-000738', NULL, 'Uncharacterized protein', 173, NULL, NULL, 129751),
(129752, '2.30.29.30-FF-000462', NULL, 'TeNSin homolog', 159, NULL, NULL, 129752),
(129753, '3.80.10.10-FF-002842', NULL, 'Predicted protein', 92, NULL, NULL, 129753),
(129754, '3.40.190.10-FF-000685', NULL, 'Uncharacterized protein', 36, NULL, NULL, 129754),
(129755, '3.40.20.10-FF-000017', NULL, 'Supervillin', 147, NULL, NULL, 129755),
(129756, '3.90.105.20-FF-000002', NULL, 'Ribosome assembly factor mrt4', 74, NULL, NULL, 129756),
(129757, '1.20.920.10-FF-000192', NULL, 'Uncharacterized protein', 76, NULL, NULL, 129757),
(129758, '3.30.450.50-FF-000062', NULL, 'Vesicle-associated membrane protein, putative', 127, NULL, NULL, 129758),
(129759, '3.40.50.300-FF-004888', NULL, 'Uncharacterized protein', 205, NULL, NULL, 129759),
(129760, '3.30.450.20-FF-000665', NULL, 'Glr3986 protein', 109, NULL, NULL, 129760);
INSERT INTO "PUBLIC"."MODEL" VALUES
(129761, '1.25.40.20-FF-000090', NULL, 'inhibitor of Bruton tyrosine kinase isoform X1', 120, NULL, NULL, 129761),
(129762, '1.25.40.10-FF-005106', NULL, 'Uncharacterized protein', 120, NULL, NULL, 129762),
(129763, '1.20.58.60-FF-000462', NULL, 'AGAP004440-PA', 100, NULL, NULL, 129763),
(129764, '1.10.630.10-FF-000790', NULL, 'Uncharacterized protein', 109, NULL, NULL, 129764),
(129765, '2.130.10.10-FF-005843', NULL, 'Apoptotic protease-activating factor 1', 345, NULL, NULL, 129765),
(129766, '3.40.50.300-FF-007468', NULL, 'Uncharacterized protein', 240, NULL, NULL, 129766),
(129767, '3.30.200.20-FF-001636', NULL, 'AFR372Wp', 91, NULL, NULL, 129767),
(129768, '3.50.50.60-FF-001040', NULL, 'Uncharacterized protein', 54, NULL, NULL, 129768),
(129769, '3.10.20.90-FF-000211', NULL, 'Polyubiquitin 9', 78, NULL, NULL, 129769),
(129770, '1.20.1270.60-FF-000318', NULL, 'Uncharacterized protein', 234, NULL, NULL, 129770),
(129771, '3.40.630.30-FF-000242', NULL, 'Acetyltransferase, GNAT family protein', 159, NULL, NULL, 129771),
(129772, '3.30.1490.20-FF-000061', NULL, 'Trifunctional purine biosynthetic protein adenosine-3', 67, NULL, NULL, 129772),
(129773, '2.30.42.10-FF-000329', NULL, 'Carboxy-terminal processing protease', 87, NULL, NULL, 129773),
(129774, '3.30.160.60-FF-005135', NULL, NULL, 74, NULL, NULL, 129774),
(129775, '3.30.420.10-FF-000481', NULL, NULL, 110, NULL, NULL, 129775),
(129776, '1.10.510.10-FF-001826', NULL, 'Uncharacterized protein', 220, NULL, NULL, 129776),
(129777, '2.60.120.970-FF-000003', NULL, 'Growth differentiation factor 11', 233, NULL, NULL, 129777),
(129778, '1.20.1560.10-FF-000516', NULL, 'Multidrug resistance-associated protein 1', 320, NULL, NULL, 129778),
(129779, '3.30.70.890-FF-000041', NULL, 'Diphosphomevalonate decarboxylase', 142, NULL, NULL, 129779),
(129780, '3.40.850.10-FF-000067', NULL, 'Kinesin-like protein', 206, NULL, NULL, 129780),
(129781, '3.30.70.330-FF-001238', NULL, 'Likely mitochondrial ribosomal protein', 151, NULL, NULL, 129781),
(129782, '1.10.472.10-FF-000152', NULL, 'Cyclin T 13', 97, NULL, NULL, 129782),
(129783, '3.50.50.60-FF-001186', NULL, 'Uncharacterized protein', 79, NULL, NULL, 129783),
(129784, '3.90.1280.20-FF-000014', NULL, NULL, 59, NULL, NULL, 129784),
(129785, '3.40.640.10-FF-000467', NULL, 'Uncharacterized protein', 138, NULL, NULL, 129785),
(129786, '3.40.220.10-FF-000036', NULL, 'Cytosolic leucyl aminopeptidase, putative', 120, NULL, NULL, 129786),
(129787, '3.40.50.720-FF-000916', NULL, 'Pyrroline-5-carboxylate reductase', 164, NULL, NULL, 129787),
(129788, '1.10.418.10-FF-000010', NULL, 'Plastin-3 isoform 1', 111, NULL, NULL, 129788),
(129789, '3.30.70.330-FF-002812', NULL, NULL, 93, NULL, NULL, 129789),
(129790, '3.80.10.10-FF-001061', NULL, 'F-box and leucine-rich repeat protein 15', 89, NULL, NULL, 129790),
(129791, '2.60.40.10-FF-001824', NULL, 'Leukocyte-associated immunoglobulin-like receptor 1', 105, NULL, NULL, 129791),
(129792, '1.10.287.2620-FF-000005', NULL, 'Dynein heavy chain 1, axonemal', 65, NULL, NULL, 129792),
(129793, '3.30.160.60-FF-001919', NULL, 'Replication initiator 1', 79, NULL, NULL, 129793),
(129794, '1.10.418.20-FF-000013', NULL, 'Related to protease ULP2 protein', 57, NULL, NULL, 129794),
(129795, '3.30.160.60-FF-001599', NULL, 'ZFP69 zinc finger protein B', 27, NULL, NULL, 129795),
(129796, '2.130.10.10-FF-000200', NULL, 'U3 small nucleolar RNA-associated protein 21', 326, NULL, NULL, 129796),
(129797, '3.30.1240.10-FF-000039', NULL, 'Cof-type HAD-IIB family hydrolase', 114, NULL, NULL, 129797),
(129798, '3.30.505.10-FF-000032', NULL, 'Transcription elongation factor spt6', 95, NULL, NULL, 129798),
(129799, '1.10.1280.10-FF-000014', NULL, 'hemocyanin A-type, units Ode to Odg-like', 267, NULL, NULL, 129799),
(129800, '2.60.40.10-FF-002313', NULL, 'T cell receptor alpha variable 18', 115, NULL, NULL, 129800),
(129801, '2.60.40.10-FF-004084', NULL, NULL, 95, NULL, NULL, 129801),
(129802, '3.30.920.10-FF-000002', NULL, 'Frataxin, mitochondrial', 128, NULL, NULL, 129802),
(129803, '3.30.2130.30-FF-000043', NULL, 'Probable tRNA sulfurtransferase', 171, NULL, NULL, 129803);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(129804, '3.30.70.850-FF-000023', NULL, 'Uncharacterized protein', 63, NULL, NULL, 129804),
(129805, '3.40.50.720-FF-001405', NULL, 'NAD-dependent epimerase/dehydratase', 195, NULL, NULL, 129805),
(129806, '2.60.40.420-FF-000262', NULL, 'Uncharacterized protein', 65, NULL, NULL, 129806),
(129807, '3.40.50.300-FF-000560', NULL, 'CLP protease regulatory subunit CLPX3 mitochondrial', 280, NULL, NULL, 129807),
(129808, '2.160.10.10-FF-000103', NULL, 'Uncharacterized protein', 130, NULL, NULL, 129808),
(129809, '3.40.50.300-FF-007529', NULL, 'AGAP008714-PA', 207, NULL, NULL, 129809),
(129810, '1.10.287.2610-FF-000002', NULL, 'Uncharacterized protein', 110, NULL, NULL, 129810),
(129811, '3.40.50.1000-FF-000027', NULL, 'ATPase copper transporting beta', 164, NULL, NULL, 129811),
(129812, '4.10.400.10-FF-000216', NULL, 'Terribly reduced optic lobes, isoform AN', 41, NULL, NULL, 129812),
(129813, '3.40.50.720-FF-000416', NULL, 'Multifunctional mycocerosic acid synthase', 230, NULL, NULL, 129813),
(129814, '3.60.40.10-FF-000237', NULL, 'Predicted protein', 380, NULL, NULL, 129814),
(129815, '3.40.50.300-FF-005405', NULL, 'ADP-ribosylation factor 2-like Protein', 171, NULL, NULL, 129815),
(129816, '3.40.50.720-FF-000596', NULL, '2,3-diaminopropionate biosynthesis protein SbnB', 173, NULL, NULL, 129816),
(129817, '1.10.8.1310-FF-000021', NULL, 'Uncharacterized protein', 63, NULL, NULL, 129817),
(129818, '1.25.10.10-FF-002350', NULL, 'Nucleotide exchange factor SIL1', 285, NULL, NULL, 129818),
(129819, '3.10.50.30-FF-000009', NULL, 'Transcription elongation factor GreA', 73, NULL, NULL, 129819),
(129820, '1.20.1720.10-FF-000018', NULL, 'Putative MFS multidrug transporter', 191, NULL, NULL, 129820),
(129821, '2.60.40.10-FF-001178', NULL, 'Sallimus, isoform Q', 93, NULL, NULL, 129821),
(129822, '2.60.40.790-FF-000030', NULL, 'Co-chaperone protein p23-2', 105, NULL, NULL, 129822),
(129823, '3.30.160.60-FF-003870', NULL, NULL, 30, NULL, NULL, 129823),
(129824, '1.50.40.10-FF-000343', NULL, 'Predicted protein', 193, NULL, NULL, 129824),
(129825, '1.10.3720.10-FF-000150', NULL, 'Molybdenum ABC transporter permease', 219, NULL, NULL, 129825),
(129826, '1.20.1250.20-FF-002334', NULL, 'Uncharacterized protein', 135, NULL, NULL, 129826),
(129827, '2.60.120.200-FF-000559', NULL, 'Predicted protein', 201, NULL, NULL, 129827),
(129828, '3.40.50.620-FF-000684', NULL, 'Uncharacterized protein', 150, NULL, NULL, 129828),
(129829, '2.10.25.10-FF-000088', NULL, 'Prolow-density lipoprotein receptor-related protein 1', 36, NULL, NULL, 129829),
(129830, '1.10.287.3490-FF-000002', NULL, 'Mediator of RNA polymerase II transcription subunit 11', 69, NULL, NULL, 129830),
(129831, '3.30.70.380-FF-000011', NULL, NULL, 94, NULL, NULL, 129831),
(129832, '1.20.1560.10-FF-000781', NULL, 'Uncharacterized protein', 287, NULL, NULL, 129832),
(129833, '3.30.420.110-FF-000050', NULL, 'Mismatch repair ATPase', 137, NULL, NULL, 129833),
(129834, '1.20.1070.10-FF-000760', NULL, 'Adhesion G protein-coupled receptor G4', 114, NULL, NULL, 129834),
(129835, '3.90.1150.10-FF-000384', NULL, 'Uncharacterized HTH-type transcriptional regulator YisV', 135, NULL, NULL, 129835),
(129836, '3.30.70.600-FF-000027', NULL, '40S ribosomal protein S20-1', 52, NULL, NULL, 129836),
(129837, '1.10.8.10-FF-000241', NULL, 'Uncharacterized protein', 41, NULL, NULL, 129837),
(129838, '3.40.50.1820-FF-000447', NULL, 'Polyhydroxyalkanoic acid synthase', 348, NULL, NULL, 129838),
(129839, '3.30.160.20-FF-000093', NULL, 'Mrpl3p', 92, NULL, NULL, 129839),
(129840, '3.30.200.20-FF-001283', NULL, 'Protein kinase, putative', 175, NULL, NULL, 129840),
(129841, '2.20.100.10-FF-000199', NULL, 'Thrombospondin type 1 domain containing 7A', 49, NULL, NULL, 129841),
(129842, '1.25.10.10-FF-003452', NULL, 'Uncharacterized protein', 220, NULL, NULL, 129842),
(129843, '2.130.10.10-FF-001835', NULL, 'AGAP005915-PA-like protein', 332, NULL, NULL, 129843),
(129844, '3.30.460.10-FF-000129', NULL, 'Putative DNA polymerase X', 134, NULL, NULL, 129844),
(129845, '1.20.5.650-FF-000002', NULL, 'Cyclin/Brf1-like TBP-binding protein', 51, NULL, NULL, 129845);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(129846, '2.60.120.10-FF-000174', NULL, 'Cyclic nucleotide-binding domain-containing protein', 160, NULL, NULL, 129846),
(129847, '1.10.630.10-FF-000610', NULL, 'Cytochrome P450 1A2', 257, NULL, NULL, 129847),
(129848, '1.20.1640.10-FF-000051', NULL, 'PaTched Related family', 200, NULL, NULL, 129848),
(129849, '3.40.1340.10-FF-000005', NULL, 'Putative DNA-directed RNA polymerases II', 158, NULL, NULL, 129849),
(129850, '3.10.20.90-FF-000183', NULL, 'Ubiquitin domain-containing protein DSK2b', 87, NULL, NULL, 129850),
(129851, '2.60.40.10-FF-003948', NULL, NULL, 105, NULL, NULL, 129851),
(129852, '3.40.1110.10-FF-000229', NULL, NULL, 52, NULL, NULL, 129852),
(129853, '1.10.10.1760-FF-000009', NULL, 'Uncharacterized protein', 110, NULL, NULL, 129853),
(129854, '4.10.1240.50-FF-000004', NULL, 'arginine-glutamic acid dipeptide repeats protein-like', 116, NULL, NULL, 129854),
(129855, '2.130.10.10-FF-002937', NULL, 'Uncharacterized protein', 199, NULL, NULL, 129855),
(129856, '3.40.50.360-FF-000084', NULL, 'Low temperature-responsive protein', 195, NULL, NULL, 129856),
(129857, '3.30.40.140-FF-000006', NULL, 'FHA domain containing protein, putative', 87, NULL, NULL, 129857),
(129858, '1.20.58.1070-FF-000008', NULL, 'Gem-associated protein 2', 167, NULL, NULL, 129858),
(129859, '2.10.25.10-FF-000734', NULL, 'Uncharacterized protein', 38, NULL, NULL, 129859),
(129860, '3.90.260.10-FF-000050', NULL, 'DNA repair protein xp-C / rad4, putative', 165, NULL, NULL, 129860),
(129861, '1.20.1310.10-FF-000150', NULL, NULL, 129, NULL, NULL, 129861),
(129862, '1.10.287.70-FF-000722', NULL, 'Uncharacterized protein', 240, NULL, NULL, 129862),
(129863, '1.10.510.10-FF-000045', NULL, 'Receptor protein serine/threonine kinase', 219, NULL, NULL, 129863),
(129864, '3.40.50.300-FF-003786', NULL, 'Zgc:172091 protein', 202, NULL, NULL, 129864),
(129865, '4.10.280.10-FF-000127', NULL, 'Helix-loop-helix protein 11', 63, NULL, NULL, 129865),
(129866, '3.30.70.1230-FF-000110', NULL, 'Adenylate/guanylate cyclase catalytic domain protein', 210, NULL, NULL, 129866),
(129867, '1.10.730.20-FF-000031', NULL, 'Isoleucyl tRNA synthetase, putative', 97, NULL, NULL, 129867),
(129868, '1.10.472.80-FF-000212', NULL, NULL, 145, NULL, NULL, 129868),
(129869, '3.40.50.150-FF-001156', NULL, NULL, 57, NULL, NULL, 129869),
(129870, '3.90.1170.40-FF-000017', NULL, 'Molybdopterin converting factor, large subunit', 155, NULL, NULL, 129870),
(129871, '3.40.50.300-FF-001662', NULL, 'Predicted protein', 170, NULL, NULL, 129871),
(129872, '1.20.58.390-FF-000261', NULL, 'Uncharacterized protein', 93, NULL, NULL, 129872),
(129873, '3.30.160.60-FF-004533', NULL, NULL, 86, NULL, NULL, 129873),
(129874, '2.30.130.10-FF-000035', NULL, 'Glutamate 5-kinase', 43, NULL, NULL, 129874),
(129875, '1.10.1200.120-FF-000002', NULL, 'Large-conductance mechanosensitive channel', 94, NULL, NULL, 129875),
(129876, '2.40.50.140-FF-000437', NULL, '26S protease regulatory subunit, putative', 87, NULL, NULL, 129876),
(129877, '1.20.1110.10-FF-000230', NULL, 'Predicted protein', 396, NULL, NULL, 129877),
(129878, '2.120.10.80-FF-000429', NULL, 'Serine/threonine-protein phosphatase', 130, NULL, NULL, 129878),
(129879, '3.40.50.2300-FF-000518', NULL, 'Guanylate cyclase', 93, NULL, NULL, 129879),
(129880, '1.25.40.20-FF-001192', NULL, 'Uncharacterized protein', 111, NULL, NULL, 129880),
(129881, '2.30.42.10-FF-000655', NULL, NULL, 92, NULL, NULL, 129881),
(129882, '2.10.220.10-FF-000024', NULL, 'Receptor protein-tyrosine kinase', 116, NULL, NULL, 129882),
(129883, '6.10.140.2220-FF-000036', NULL, 'SET domain-containing protein', 45, NULL, NULL, 129883),
(129884, '2.130.10.10-FF-000700', NULL, 'Sperm-associated antigen 9a', 232, NULL, NULL, 129884),
(129885, '2.70.50.30-FF-000032', NULL, NULL, 42, NULL, NULL, 129885),
(129886, '1.10.1200.10-FF-000155', NULL, 'Chromosome 19, whole genome shotgun sequence', 76, NULL, NULL, 129886),
(129887, '1.25.40.10-FF-003341', NULL, 'Putative pentatricopeptide repeat-containing protein', 92, NULL, NULL, 129887),
(129888, '2.60.40.60-FF-001086', NULL, 'Predicted protein', 108, NULL, NULL, 129888);
INSERT INTO "PUBLIC"."MODEL" VALUES
(129889, '3.40.50.300-FF-004303', NULL, 'Probable gluconokinase', 187, NULL, NULL, 129889),
(129890, '3.30.530.20-FF-000020', NULL, 'homeobox-leucine zipper protein ATHB-15', 182, NULL, NULL, 129890),
(129891, '3.80.10.10-FF-002516', NULL, 'Uncharacterized protein', 68, NULL, NULL, 129891),
(129892, '3.40.50.300-FF-007940', NULL, 'Uncharacterized protein', 172, NULL, NULL, 129892),
(129893, '3.40.50.300-FF-005731', NULL, 'Os03g0743800 protein', 155, NULL, NULL, 129893),
(129894, '1.10.8.430-FF-000017', NULL, 'Uncharacterized protein', 93, NULL, NULL, 129894),
(129895, '2.70.130.10-FF-000122', NULL, NULL, 167, NULL, NULL, 129895),
(129896, '3.90.1170.30-FF-000014', NULL, 'Thymidine phosphorylase', 58, NULL, NULL, 129896),
(129897, '3.30.200.20-FF-001136', NULL, 'At3g62220', 113, NULL, NULL, 129897),
(129898, '3.30.420.10-FF-000155', NULL, 'Transposon Tf2-4 polyprotein', 205, NULL, NULL, 129898),
(129899, '2.70.170.10-FF-000040', NULL, 'Cholinergic receptor nicotinic gamma subunit', 80, NULL, NULL, 129899),
(129900, '1.10.150.50-FF-000080', NULL, 'Eph receptor tyrosine kinase', 59, NULL, NULL, 129900),
(129901, '3.30.200.20-FF-002564', NULL, 'Uncharacterized protein', 39, NULL, NULL, 129901),
(129902, '1.10.10.10-FF-000927', NULL, 'LysR family transcriptional regulator', 87, NULL, NULL, 129902),
(129903, '3.90.1170.20-FF-000011', NULL, 'Nicotinate-mononucleotide pyrophosphorylase', 137, NULL, NULL, 129903),
(129904, '1.20.58.1060-FF-000005', NULL, 'Plectin b', 151, NULL, NULL, 129904),
(129905, '3.30.70.330-FF-003094', NULL, NULL, 102, NULL, NULL, 129905),
(129906, '1.10.10.60-FF-001263', NULL, NULL, 68, NULL, NULL, 129906),
(129907, '1.10.405.10-FF-000031', NULL, 'Uncharacterized protein', 134, NULL, NULL, 129907),
(129908, '1.20.1070.10-FF-000788', NULL, 'Uncharacterized protein', 346, NULL, NULL, 129908),
(129909, '3.30.300.20-FF-000065', NULL, 'Uncharacterized protein', 93, NULL, NULL, 129909),
(129910, '1.20.1070.10-FF-001070', NULL, 'Melatonin receptor type 1A', 329, NULL, NULL, 129910),
(129911, '1.10.510.10-FF-001591', NULL, NULL, 72, NULL, NULL, 129911),
(129912, '3.40.50.790-FF-000010', NULL, '50S ribosomal protein L1', 102, NULL, NULL, 129912),
(129913, '2.10.70.10-FF-000131', NULL, 'Complement factor H-related protein 1', 59, NULL, NULL, 129913),
(129914, '1.20.1070.10-FF-000608', NULL, 'NeuroPeptide Receptor family', 339, NULL, NULL, 129914),
(129915, '3.30.200.20-FF-000973', NULL, 'Kinase, CMGC CDK', 116, NULL, NULL, 129915),
(129916, '3.40.50.2300-FF-000844', NULL, 'Uncharacterized protein', 271, NULL, NULL, 129916),
(129917, '3.30.1490.100-FF-000048', NULL, 'Uncharacterized protein', 105, NULL, NULL, 129917),
(129918, '1.10.510.10-FF-003125', NULL, NULL, 186, NULL, NULL, 129918),
(129919, '2.60.220.50-FF-000137', NULL, 'Adhesion G protein-coupled receptor G1', 154, NULL, NULL, 129919),
(129920, '3.30.300.30-FF-000068', NULL, 'Nonribosomal peptide synthase SidE', 120, NULL, NULL, 129920),
(129921, '3.40.50.12550-FF-000012', NULL, 'ThiF family protein', 98, NULL, NULL, 129921),
(129922, '3.40.50.1000-FF-000353', NULL, 'GM26347', 197, NULL, NULL, 129922),
(129923, '3.40.50.720-FF-000742', NULL, 'probable bifunctional methylenetetrahydrofolate dehydrogenase/cyclohydrolase 2', 101, NULL, NULL, 129923),
(129924, '1.10.340.30-FF-000077', NULL, 'Predicted protein', 114, NULL, NULL, 129924),
(129925, '3.40.710.10-FF-000057', NULL, 'D-alanyl-D-alanine carboxypeptidase', 259, NULL, NULL, 129925),
(129926, '3.30.160.60-FF-000610', NULL, 'B-box zinc finger protein 19', 91, NULL, NULL, 129926),
(129927, '1.20.1560.10-FF-000163', NULL, 'ABC transporter B family protein', 54, NULL, NULL, 129927),
(129928, '3.40.50.1820-FF-000773', NULL, 'Uncharacterized_conserved_protein_(DUF2305)/Alpha /beta_hydrolase_family_-_putative', 283, NULL, NULL, 129928),
(129929, '2.40.10.10-FF-000204', NULL, 'Membrane-associated serine protease', 91, NULL, NULL, 129929),
(129930, '3.40.1360.10-FF-000040', NULL, 'Spo11p', 196, NULL, NULL, 129930),
(129931, '3.40.50.200-FF-000030', NULL, 'Uncharacterized protein', 307, NULL, NULL, 129931);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(129932, '3.40.50.410-FF-000267', NULL, 'Collagen, type XII, alpha 1b', 121, NULL, NULL, 129932),
(129933, '3.30.200.20-FF-001462', NULL, 'Receptor protein-tyrosine kinase', 138, NULL, NULL, 129933),
(129934, '3.10.105.10-FF-000028', NULL, 'ABC transporter, periplasmic substrate-binding protein', 228, NULL, NULL, 129934),
(129935, '2.60.40.10-FF-005365', NULL, NULL, 63, NULL, NULL, 129935),
(129936, '3.30.1330.20-FF-000021', NULL, 'Cell division protein FtsZ', 116, NULL, NULL, 129936),
(129937, '2.60.40.10-FF-001796', NULL, 'Dpr-interacting protein gamma', 108, NULL, NULL, 129937),
(129938, '3.40.50.10190-FF-000164', NULL, 'PAX transcription activation domain interacting protein', 103, NULL, NULL, 129938),
(129939, '3.80.10.10-FF-001414', NULL, 'Leucine_Rich_Repeat/Leucine_rich_repeat_-_putative', 148, NULL, NULL, 129939),
(129940, '3.30.70.3320-FF-000001', NULL, 'Fatty acid synthase', 81, NULL, NULL, 129940),
(129941, '2.40.37.10-FF-000064', NULL, NULL, 132, NULL, NULL, 129941),
(129942, '1.20.1250.20-FF-000389', NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', 206, NULL, NULL, 129942),
(129943, '1.25.10.10-FF-002024', NULL, 'YALI0B20724p', 321, NULL, NULL, 129943),
(129944, '1.10.10.10-FF-002052', NULL, 'Uncharacterized protein', 191, NULL, NULL, 129944),
(129945, '2.40.50.140-FF-000763', NULL, NULL, 44, NULL, NULL, 129945),
(129946, '3.30.160.60-FF-004207', NULL, NULL, 28, NULL, NULL, 129946),
(129947, '1.10.510.10-FF-002023', NULL, 'Protein kinase', 383, NULL, NULL, 129947),
(129948, '3.80.10.10-FF-000925', NULL, 'F-box protein At5g67140', 170, NULL, NULL, 129948),
(129949, '3.90.190.10-FF-000426', NULL, 'Uncharacterized protein', 80, NULL, NULL, 129949),
(129950, '2.10.25.10-FF-000908', NULL, 'low-density lipoprotein receptor-related protein 2', 35, NULL, NULL, 129950),
(129951, '3.30.160.60-FF-003718', NULL, NULL, 29, NULL, NULL, 129951),
(129952, '3.40.50.720-FF-001231', NULL, 'Glyoxylate/hydroxypyruvate reductase HPR3 isoform A', 91, NULL, NULL, 129952),
(129953, '2.40.50.90-FF-000186', NULL, 'AT14886p', 72, NULL, NULL, 129953),
(129954, '3.30.160.60-FF-005461', NULL, NULL, 79, NULL, NULL, 129954),
(129955, '2.60.40.10-FF-002021', NULL, 'Jitterbug, isoform N', 87, NULL, NULL, 129955),
(129956, '1.25.40.10-FF-000261', NULL, 'protein fem-1 homolog A', 171, NULL, NULL, 129956),
(129957, '3.40.50.11610-FF-000028', NULL, NULL, 97, NULL, NULL, 129957),
(129958, '1.10.287.110-FF-000055', NULL, 'DnaJ subfamily C member 7', 110, NULL, NULL, 129958),
(129959, '3.30.390.30-FF-000051', NULL, 'Glutathione reductase', 79, NULL, NULL, 129959),
(129960, '4.10.410.10-FF-000014', NULL, 'Serine peptidase inhibitor, Kunitz type, 2', 57, NULL, NULL, 129960),
(129961, '2.10.50.10-FF-000129', NULL, 'Tumor necrosis factor receptor superfamily, member 1a', 41, NULL, NULL, 129961),
(129962, '3.30.70.1730-FF-000052', NULL, 'Uncharacterized protein', 130, NULL, NULL, 129962),
(129963, '3.30.1330.30-FF-000024', NULL, 'Putative tRNA/rRNA methyltransferase', 82, NULL, NULL, 129963),
(129964, '3.40.50.150-FF-000200', NULL, 'Citrate synthase lysine methyltransferase', 215, NULL, NULL, 129964),
(129965, '3.30.1330.40-FF-000027', NULL, 'Endoribonuclease L-PSP', 112, NULL, NULL, 129965),
(129966, '3.80.10.10-FF-002696', NULL, 'Uncharacterized protein', 74, NULL, NULL, 129966),
(129967, '1.20.1270.60-FF-000144', NULL, 'Uncharacterized protein', 270, NULL, NULL, 129967),
(129968, '1.10.510.10-FF-004232', NULL, NULL, 203, NULL, NULL, 129968),
(129969, '3.30.2140.20-FF-000012', NULL, 'Uncharacterized acetyltransferase YvcN', 252, NULL, NULL, 129969),
(129970, '1.10.10.10-FF-001742', NULL, 'Bifunctional ligase/repressor BirA', 65, NULL, NULL, 129970),
(129971, '1.20.810.10-FF-000037', NULL, 'Cytochrome b/b6 domain', 176, NULL, NULL, 129971),
(129972, '1.25.40.20-FF-000264', NULL, 'Fem-1 homolog B', 154, NULL, NULL, 129972),
(129973, '4.10.410.20-FF-000017', NULL, 'poly(U)-specific endoribonuclease', 53, NULL, NULL, 129973),
(129974, '3.30.200.20-FF-000001', NULL, 'Ephrin type-A receptor 5', 107, NULL, NULL, 129974);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(129975, '2.40.50.140-FF-001073', NULL, NULL, 89, NULL, NULL, 129975),
(129976, '3.40.50.1100-FF-000265', NULL, 'Serine/threonine dehydratase', 105, NULL, NULL, 129976),
(129977, '1.25.40.10-FF-002498', NULL, 'Prolyl 4-hydroxylase alpha subunit, putative', 100, NULL, NULL, 129977),
(129978, '3.40.50.300-FF-007614', NULL, 'Uncharacterized protein', 153, NULL, NULL, 129978),
(129979, '3.30.200.160-FF-000004', NULL, 'Os01g0528000 protein', 103, NULL, NULL, 129979),
(129980, '1.10.600.10-FF-000136', NULL, 'Terpenoid synthases superfamily protein', 130, NULL, NULL, 129980),
(129981, '3.40.33.10-FF-000114', NULL, 'Uncharacterized protein', 168, NULL, NULL, 129981),
(129982, '3.40.50.150-FF-001482', NULL, NULL, 124, NULL, NULL, 129982),
(129983, '3.90.1750.20-FF-000005', NULL, 'Serine recombinase', 160, NULL, NULL, 129983),
(129984, '1.20.920.10-FF-000220', NULL, 'Uncharacterized protein', 74, NULL, NULL, 129984),
(129985, '1.10.1420.10-FF-000020', NULL, 'DNA mismatch repair protein', 128, NULL, NULL, 129985),
(129986, '3.40.50.2300-FF-001333', NULL, NULL, 76, NULL, NULL, 129986),
(129987, '1.20.1270.10-FF-000062', NULL, 'Glucose-regulated protein', 77, NULL, NULL, 129987),
(129988, '1.10.20.10-FF-000107', NULL, 'Chromatin accessibility complex subunit 1', 52, NULL, NULL, 129988),
(129989, '1.20.1740.10-FF-000227', NULL, 'Predicted protein', 441, NULL, NULL, 129989),
(129990, '3.30.1360.120-FF-000014', NULL, 'Aminomethyltransferase', 94, NULL, NULL, 129990),
(129991, '1.20.1250.20-FF-000182', NULL, 'Sucrose transporter SUC2', 226, NULL, NULL, 129991),
(129992, '3.90.1750.10-FF-000002', NULL, 'E3 ubiquitin-protein ligase', 226, NULL, NULL, 129992),
(129993, '3.40.1110.10-FF-000022', NULL, 'Calcium-transporting ATPase', 150, NULL, NULL, 129993),
(129994, '1.10.510.10-FF-001798', NULL, 'Uncharacterized protein', 180, NULL, NULL, 129994),
(129995, '2.30.180.10-FF-000100', NULL, NULL, 154, NULL, NULL, 129995),
(129996, '2.60.40.10-FF-004230', NULL, NULL, 112, NULL, NULL, 129996),
(129997, '3.30.710.10-FF-000256', NULL, 'SKP1-like_protein', 159, NULL, NULL, 129997),
(129998, '3.30.160.60-FF-001745', NULL, 'Zinc finger protein 658', 29, NULL, NULL, 129998),
(129999, '1.25.10.10-FF-002996', NULL, 'Uncharacterized protein', 362, NULL, NULL, 129999),
(130000, '3.60.130.10-FF-000047', NULL, 'Gamma Butyrobetaine Hydroxylase', 286, NULL, NULL, 130000),
(130001, '2.130.10.10-FF-001920', NULL, 'Transducin-like enhancer protein 2', 224, NULL, NULL, 130001),
(130002, '3.40.30.10-FF-000400', NULL, 'Thioredoxin', 94, NULL, NULL, 130002),
(130003, '3.20.20.150-FF-000053', NULL, 'Hydroxypyruvate isomerase', 244, NULL, NULL, 130003),
(130004, '1.20.1560.10-FF-000663', NULL, 'ATP-binding cassette transporter, subfamily B, member 21, group MDR/PGP protein PpABCB21', 62, NULL, NULL, 130004),
(130005, '1.20.58.1360-FF-000005', NULL, 'F-box and leucine-rich repeat protein 11', 97, NULL, NULL, 130005),
(130006, '2.60.40.10-FF-001296', NULL, 'Usherin', 96, NULL, NULL, 130006),
(130007, '1.20.1070.10-FF-000642', NULL, 'GD11003', 267, NULL, NULL, 130007),
(130008, '3.60.40.10-FF-000355', NULL, 'Uncharacterized protein', 307, NULL, NULL, 130008),
(130009, '3.30.70.330-FF-002784', NULL, NULL, 55, NULL, NULL, 130009),
(130010, '1.25.10.10-FF-002232', NULL, 'Uncharacterized protein', 387, NULL, NULL, 130010),
(130011, '2.40.128.260-FF-000002', NULL, 'Type IV secretion system protein VirB10', 119, NULL, NULL, 130011),
(130012, '1.20.58.80-FF-000001', NULL, 'PTS system, lactose-specific IIa component', 103, NULL, NULL, 130012),
(130013, '3.30.360.10-FF-000037', NULL, '4-hydroxy-tetrahydrodipicolinate reductase 2, chloroplastic', 108, NULL, NULL, 130013),
(130014, '3.40.710.10-FF-000091', NULL, 'Uncharacterized protein', 278, NULL, NULL, 130014),
(130015, '1.10.510.10-FF-003389', NULL, 'AGAP001933-PA', 406, NULL, NULL, 130015),
(130016, '3.20.20.80-FF-000831', NULL, 'Uncharacterized protein', 46, NULL, NULL, 130016),
(130017, '3.30.200.20-FF-001018', NULL, 'Uncharacterized protein', 81, NULL, NULL, 130017),
(130018, '3.20.20.140-FF-000050', NULL, 'Adenosine/AMP deaminase family protein', 354, NULL, NULL, 130018);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(130019, '3.30.40.10-FF-000659', NULL, 'Peroxisome assembly protein 12', 76, NULL, NULL, 130019),
(130020, '3.90.245.10-FF-000037', NULL, 'Putative inosine-uridine preferring nucleoside hydrolase', 284, NULL, NULL, 130020),
(130021, '1.10.506.10-FF-000001', NULL, 'Ras GTPase-activating protein nGAP isoform 2', 173, NULL, NULL, 130021),
(130022, '1.10.238.10-FF-000237', NULL, 'Calcium-binding protein CML38', 71, NULL, NULL, 130022),
(130023, '3.30.300.70-FF-000001', NULL, 'Ribosome maturation factor RimP', 80, NULL, NULL, 130023),
(130024, '3.30.60.90-FF-000055', NULL, 'Uncharacterized protein', 59, NULL, NULL, 130024),
(130025, '3.30.160.60-FF-003398', NULL, 'AGAP000062-PA-like protein', 80, NULL, NULL, 130025),
(130026, '2.60.40.10-FF-004112', NULL, NULL, 93, NULL, NULL, 130026),
(130027, '3.30.70.250-FF-000023', NULL, NULL, 73, NULL, NULL, 130027),
(130028, '3.30.2410.10-FF-000047', NULL, 'E3 ubiquitin-protein ligase', 84, NULL, NULL, 130028),
(130029, '1.10.8.60-FF-000323', NULL, 'Putative vesicular transport protein (CDC48 homologue)', 95, NULL, NULL, 130029),
(130030, '2.60.220.50-FF-000076', NULL, 'Latrophilin-like protein LAT-2', 209, NULL, NULL, 130030),
(130031, '3.80.10.10-FF-000779', NULL, 'Probable inactive serine/threonine-protein kinase DDB_G0278909', 93, NULL, NULL, 130031),
(130032, '3.80.10.10-FF-002488', NULL, 'Uncharacterized protein', 75, NULL, NULL, 130032),
(130033, '3.40.120.10-FF-000118', NULL, 'Uncharacterized protein', 56, NULL, NULL, 130033),
(130034, '1.20.58.390-FF-000143', NULL, '5-hydroxytryptamine receptor 3D', 142, NULL, NULL, 130034),
(130035, '2.60.40.150-FF-000220', NULL, 'Phosphoinositide phospholipase C', 154, NULL, NULL, 130035),
(130036, '1.25.40.10-FF-001750', NULL, 'Uncharacterized protein', 73, NULL, NULL, 130036),
(130037, '2.10.25.10-FF-000942', NULL, 'Integrin beta', 56, NULL, NULL, 130037),
(130038, '1.25.40.20-FF-001753', NULL, 'Uncharacterized protein', 329, NULL, NULL, 130038),
(130039, '1.10.3730.20-FF-000007', NULL, 'Multidrug ABC transporter', 112, NULL, NULL, 130039),
(130040, '3.30.70.240-FF-000020', NULL, 'Translation factor GUF1 homolog, mitochondrial', 111, NULL, NULL, 130040),
(130041, '1.20.5.170-FF-000128', NULL, 'Citron rho-interacting serine/threonine kinase b', 138, NULL, NULL, 130041),
(130042, '1.10.8.60-FF-000380', NULL, 'Chromosome 9, whole genome shotgun sequence', 129, NULL, NULL, 130042),
(130043, '3.70.10.10-FF-000066', NULL, 'Rad9-domain-containing protein', 300, NULL, NULL, 130043),
(130044, '1.25.10.10-FF-000141', NULL, 'rap1 GTPase-GDP dissociation stimulator 1 isoform X1', 309, NULL, NULL, 130044),
(130045, '3.40.50.300-FF-007176', NULL, 'Uncharacterized protein', 172, NULL, NULL, 130045),
(130046, '3.40.630.10-FF-000202', NULL, 'Uncharacterized protein', 25, NULL, NULL, 130046),
(130047, '1.20.5.110-FF-000217', NULL, 'Uncharacterized protein', 78, NULL, NULL, 130047),
(130048, '3.40.1390.30-FF-000020', NULL, 'Metal-binding protein', 117, NULL, NULL, 130048),
(130049, '1.10.565.10-FF-000132', NULL, 'uncharacterized protein LOC100187213', 181, NULL, NULL, 130049),
(130050, '1.10.510.10-FF-004440', NULL, NULL, 52, NULL, NULL, 130050),
(130051, '1.20.1250.20-FF-000743', NULL, 'MFS transporter', 187, NULL, NULL, 130051),
(130052, '2.60.210.10-FF-000086', NULL, NULL, 174, NULL, NULL, 130052),
(130053, '3.40.50.300-FF-006512', NULL, 'ATP-dependent RNA helicase DDX3X', 112, NULL, NULL, 130053),
(130054, '3.30.1330.40-FF-000061', NULL, 'Uncharacterized protein', 128, NULL, NULL, 130054),
(130055, '3.50.30.30-FF-000153', NULL, 'Gll4423 protein', 93, NULL, NULL, 130055),
(130056, '1.10.10.440-FF-000024', NULL, 'Pre-mRNA-processing protein 40A', 74, NULL, NULL, 130056),
(130057, '3.40.980.10-FF-000020', NULL, 'Molybdopterin molybdenumtransferase', 153, NULL, NULL, 130057),
(130058, '2.20.100.10-FF-000171', NULL, 'Thrombospondin type 1 domain containing 4', 62, NULL, NULL, 130058),
(130059, '1.20.58.60-FF-000580', NULL, 'Plectin', 232, NULL, NULL, 130059),
(130060, '1.20.5.350-FF-000002', NULL, 'troponin I, fast skeletal muscle', 127, NULL, NULL, 130060);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(130061, '2.130.10.10-FF-003365', NULL, 'Uncharacterized protein', 331, NULL, NULL, 130061),
(130062, '1.25.10.10-FF-003159', NULL, 'Uncharacterized protein', 401, NULL, NULL, 130062),
(130063, '1.10.220.70-FF-000001', NULL, 'Ethanolamine ammonia-lyase heavy chain', 87, NULL, NULL, 130063),
(130064, '1.10.10.10-FF-001708', NULL, 'Probable nitrogen assimilation transcriptional activator', 87, NULL, NULL, 130064),
(130065, '1.10.630.10-FF-000525', NULL, 'Cytochrome P450, putative', 389, NULL, NULL, 130065),
(130066, '3.40.630.30-FF-000208', NULL, 'Acetyltransferase', 142, NULL, NULL, 130066),
(130067, '3.30.70.1730-FF-000018', NULL, '50S ribosomal protein L10', 130, NULL, NULL, 130067),
(130068, '3.30.200.20-FF-001075', NULL, 'Snf1-like protein kinase', 90, NULL, NULL, 130068),
(130069, '2.40.50.140-FF-000881', NULL, NULL, 113, NULL, NULL, 130069),
(130070, '1.20.1070.10-FF-001305', NULL, 'Uncharacterized protein', 63, NULL, NULL, 130070),
(130071, '2.40.70.10-FF-000152', NULL, 'Protease', 116, NULL, NULL, 130071),
(130072, '2.60.40.10-FF-005247', NULL, NULL, 88, NULL, NULL, 130072),
(130073, '3.50.50.60-FF-000489', NULL, 'Flavin-containing monooxygenase', 302, NULL, NULL, 130073),
(130074, '3.40.50.2300-FF-000636', NULL, 'GLutamate Receptor family (AMPA)', 143, NULL, NULL, 130074),
(130075, '1.10.287.950-FF-000014', NULL, 'Methyl-accepting chemotaxis protein', 301, NULL, NULL, 130075),
(130076, '3.80.10.10-FF-003005', NULL, 'Uncharacterized protein', 73, NULL, NULL, 130076),
(130077, '1.10.555.10-FF-000160', NULL, NULL, 235, NULL, NULL, 130077),
(130078, '2.60.120.10-FF-000056', NULL, 'Acireductone dioxygenase', 164, NULL, NULL, 130078),
(130079, '3.50.50.60-FF-000112', NULL, 'FAD-dependent oxidoreductase domain-containing protein 1', 227, NULL, NULL, 130079),
(130080, '2.130.10.10-FF-001274', NULL, 'WD_domain_-_G-beta_repeat/Utp21_specific_WD40_ass ociated_putative_domain_containing_protein_-_putative', 331, NULL, NULL, 130080),
(130081, '3.90.45.10-FF-000016', NULL, 'Peptide deformylase', 177, NULL, NULL, 130081),
(130082, '3.40.50.720-FF-002333', NULL, 'Uncharacterized protein', 51, NULL, NULL, 130082),
(130083, '1.10.287.600-FF-000022', NULL, 'Alpha tubulin,putative', 51, NULL, NULL, 130083),
(130084, '3.90.70.10-FF-000501', NULL, 'Ubiquitin carboxyl-terminal hydrolase 36', 323, NULL, NULL, 130084),
(130085, '3.40.50.150-FF-001274', NULL, NULL, 316, NULL, NULL, 130085),
(130086, '3.40.50.1100-FF-000057', NULL, 'Threonine dehydratase', 95, NULL, NULL, 130086),
(130087, '3.40.50.800-FF-000114', NULL, 'Predicted protein', 93, NULL, NULL, 130087),
(130088, '3.40.20.10-FF-000164', NULL, 'ABR105Cp', 127, NULL, NULL, 130088),
(130089, '1.20.120.350-FF-000001', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 124, NULL, NULL, 130089),
(130090, '3.60.21.10-FF-000024', NULL, 'Vacuolar protein sorting-associated protein 29', 194, NULL, NULL, 130090),
(130091, '1.20.120.360-FF-000004', NULL, 'Uncharacterized protein', 52, NULL, NULL, 130091),
(130092, '3.30.160.60-FF-001953', NULL, 'Zinc finger protein 221', 28, NULL, NULL, 130092),
(130093, '3.10.129.10-FF-000235', NULL, 'Chromosome 1, whole genome shotgun sequence', 149, NULL, NULL, 130093),
(130094, '1.25.40.10-FF-003195', NULL, 'YALI0A15686p', 93, NULL, NULL, 130094),
(130095, '1.10.287.1490-FF-000020', NULL, 'TBC1 domain family member 2B isoform X2', 186, NULL, NULL, 130095),
(130096, '2.10.25.10-FF-001398', NULL, 'Uncharacterized protein', 40, NULL, NULL, 130096),
(130097, '3.40.50.720-FF-002479', NULL, 'Putative enoyl-CoA hydratase/Enoyl-CoA isomerase/3-hydroxyacyl-CoA dehydrogenase', 220, NULL, NULL, 130097),
(130098, '1.25.40.10-FF-003515', NULL, 'Histone demethylase, putative', 242, NULL, NULL, 130098),
(130099, '1.20.1410.10-FF-000034', NULL, 'Uncharacterized protein', 110, NULL, NULL, 130099),
(130100, '3.30.1240.10-FF-000073', NULL, 'Hydrolase (HAD superfamily)', 107, NULL, NULL, 130100),
(130101, '3.30.1330.120-FF-000002', NULL, 'Aconitate decarboxylase 1', 134, NULL, NULL, 130101),
(130102, '2.60.120.10-FF-000320', NULL, 'Oxalate decarboxylase', 183, NULL, NULL, 130102);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(130103, '1.10.3520.10-FF-000022', NULL, 'Uncharacterized protein', 145, NULL, NULL, 130103),
(130104, '3.40.50.450-FF-000054', NULL, 'Phosphofructokinase, platelet', 60, NULL, NULL, 130104),
(130105, '3.60.20.10-FF-000146', NULL, NULL, 147, NULL, NULL, 130105),
(130106, '3.30.70.330-FF-002458', NULL, NULL, 83, NULL, NULL, 130106),
(130107, '3.40.50.1820-FF-000947', NULL, 'Alpha/beta hydrolase family, putative', 302, NULL, NULL, 130107),
(130108, '3.80.10.10-FF-003859', NULL, 'AGAP012385-PA', 84, NULL, NULL, 130108),
(130109, '3.40.50.1000-FF-000061', NULL, 'Histidine biosynthesis bifunctional protein HisB', 162, NULL, NULL, 130109),
(130110, '3.30.160.60-FF-006006', NULL, NULL, 38, NULL, NULL, 130110),
(130111, '3.40.50.720-FF-000388', NULL, 'Cinnamoyl-CoA reductase-like SNL6', 317, NULL, NULL, 130111),
(130112, '3.30.420.610-FF-000020', NULL, 'Maternal effect protein oskar', 106, NULL, NULL, 130112),
(130113, '3.50.50.60-FF-000697', NULL, 'Blr3003 protein', 95, NULL, NULL, 130113),
(130114, '2.60.40.10-FF-000104', NULL, 'Down syndrome cell adhesion molecule b', 99, NULL, NULL, 130114),
(130115, '1.20.1740.10-FF-000053', NULL, 'Cationic amino acid transporter 3', 452, NULL, NULL, 130115),
(130116, '3.20.20.140-FF-000196', NULL, 'Ribonuclease P protein component 3', 210, NULL, NULL, 130116),
(130117, '3.40.50.1010-FF-000064', NULL, 'DNA polymerase I', 175, NULL, NULL, 130117),
(130118, '1.25.40.10-FF-000935', NULL, 'Predicted TPR repeat protein', 195, NULL, NULL, 130118),
(130119, '3.40.50.300-FF-005905', NULL, 'DNA replication and repair protein RecF', 149, NULL, NULL, 130119),
(130120, '3.30.230.80-FF-000032', NULL, 'Heat shock protein, putative', 91, NULL, NULL, 130120),
(130121, '1.10.30.10-FF-000136', NULL, 'HMG1/2 (High mobility group) box-containing protein', 82, NULL, NULL, 130121),
(130122, '1.10.510.10-FF-001208', NULL, 'Cyclin dependent kinase 20', 111, NULL, NULL, 130122),
(130123, '1.25.40.10-FF-002060', NULL, 'Pentatricopeptide repeat-containing protein At5g04810, chloroplastic', 71, NULL, NULL, 130123),
(130124, '1.20.58.60-FF-000669', NULL, 'Uncharacterized protein', 139, NULL, NULL, 130124),
(130125, '1.20.5.370-FF-000008', NULL, 'Myosin heavy chain', 51, NULL, NULL, 130125),
(130126, '3.50.50.60-FF-001006', NULL, 'AMine oXidase family', 169, NULL, NULL, 130126),
(130127, '3.40.50.150-FF-001627', NULL, NULL, 241, NULL, NULL, 130127),
(130128, '1.10.287.70-FF-000161', NULL, 'Intermediate conductance calcium-activated potassium channel protein 4', 156, NULL, NULL, 130128),
(130129, '3.40.50.410-FF-000093', NULL, 'Transcription initiation factor TFIIH subunit', 229, NULL, NULL, 130129),
(130130, '3.90.940.40-FF-000004', NULL, 'Protein CHLORORESPIRATORY REDUCTION 7 chloroplastic', 47, NULL, NULL, 130130),
(130131, '4.10.910.10-FF-000007', NULL, '37S ribosomal protein subunit sws2, mitochondrial', 40, NULL, NULL, 130131),
(130132, '1.10.10.10-FF-001355', NULL, 'Telomere repeat-binding factor 5', 91, NULL, NULL, 130132),
(130133, '1.25.40.10-FF-000699', NULL, 'Pentatricopeptide repeat domain 2, isoform CRA_a', 171, NULL, NULL, 130133),
(130134, '1.10.1740.10-FF-000033', NULL, 'Probable sigma-70 factor, ECF subfamily', 79, NULL, NULL, 130134),
(130135, '1.20.1720.10-FF-000052', NULL, 'Bcr/CflA family efflux transporter', 379, NULL, NULL, 130135),
(130136, '1.20.1310.10-FF-000032', NULL, 'Anaphase-promoting complex subunit 2', 114, NULL, NULL, 130136),
(130137, '1.20.1560.10-FF-000455', NULL, 'Uncharacterized protein', 334, NULL, NULL, 130137),
(130138, '1.20.1310.20-FF-000035', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 209, NULL, NULL, 130138),
(130139, '1.25.40.1030-FF-000020', NULL, 'Yeast SEC homolog', 419, NULL, NULL, 130139),
(130140, '3.20.20.370-FF-000034', NULL, 'Uncharacterized protein', 149, NULL, NULL, 130140),
(130141, '2.30.31.10-FF-000012', NULL, 'Transcriptional Coactivator p15-domain-containing protein', 63, NULL, NULL, 130141),
(130142, '1.20.1070.10-FF-000434', NULL, 'Lysophosphatidic acid receptor 5a', 286, NULL, NULL, 130142),
(130143, '3.40.50.1820-FF-000239', NULL, 'Peptidase, putative', 242, NULL, NULL, 130143);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(130144, '2.60.40.10-FF-000161', NULL, 'Leucine rich repeats and immunoglobulin like domains 2', 92, NULL, NULL, 130144),
(130145, '3.20.20.60-FF-000027', NULL, 'Pyruvate kinase 2', 128, NULL, NULL, 130145),
(130146, '2.130.10.10-FF-003573', NULL, 'Uncharacterized protein', 210, NULL, NULL, 130146),
(130147, '1.25.10.10-FF-001361', NULL, 'Apoptosis inhibitor', 209, NULL, NULL, 130147),
(130148, '1.10.238.10-FF-000030', NULL, 'DCN1-like protein', 90, NULL, NULL, 130148),
(130149, '2.30.30.30-FF-000122', NULL, '60S ribosomal protein L14-1', 59, NULL, NULL, 130149),
(130150, '3.40.50.720-FF-002069', NULL, 'Carbonyl reductase 4', 154, NULL, NULL, 130150),
(130151, '1.20.5.170-FF-000246', NULL, 'UPF0612 protein C569.003', 50, NULL, NULL, 130151),
(130152, '1.25.40.170-FF-000006', NULL, 'Smaug', 49, NULL, NULL, 130152),
(130153, '1.25.40.180-FF-000009', NULL, 'programmed cell death protein 4', 154, NULL, NULL, 130153),
(130154, '2.40.50.140-FF-000937', NULL, NULL, 168, NULL, NULL, 130154),
(130155, '3.80.10.10-FF-002724', NULL, 'Probable inactive leucine-rich repeat receptor-like protein kinase At3g03770', 67, NULL, NULL, 130155),
(130156, '3.30.70.330-FF-000867', NULL, 'RNA-binding protein squid', 76, NULL, NULL, 130156),
(130157, '1.10.530.10-FF-000046', NULL, 'Lytic murein transglycosylase', 161, NULL, NULL, 130157),
(130158, '3.40.720.10-FF-000063', NULL, 'Alkaline phosphatase', 331, NULL, NULL, 130158),
(130159, '1.20.140.10-FF-000126', NULL, 'Uncharacterized protein', 91, NULL, NULL, 130159),
(130160, '3.30.420.10-FF-000363', NULL, NULL, 170, NULL, NULL, 130160),
(130161, '3.30.40.10-FF-001969', NULL, 'Putative E3 ubiquitin-protein ligase UBR7-like Protein', 62, NULL, NULL, 130161),
(130162, '1.20.1070.10-FF-001423', NULL, 'Vomeronasal type-1 receptor', 228, NULL, NULL, 130162),
(130163, '1.10.510.10-FF-001944', NULL, 'Salt-inducible kinase 1', 341, NULL, NULL, 130163),
(130164, '2.30.30.40-FF-000125', NULL, 'Tyrosine-protein kinase', 89, NULL, NULL, 130164),
(130165, '1.10.8.10-FF-000095', NULL, 'Uncharacterized protein, isoform F', 64, NULL, NULL, 130165),
(130166, '3.30.40.10-FF-000188', NULL, 'RING finger and CHY zinc finger domain-containing protein 1', 51, NULL, NULL, 130166),
(130167, '3.30.70.260-FF-000026', NULL, 'Homoserine dehydrogenase', 73, NULL, NULL, 130167),
(130168, '1.25.40.470-FF-000063', NULL, 'AGAP010418-PA', 139, NULL, NULL, 130168),
(130169, '3.30.160.60-FF-005753', NULL, NULL, 25, NULL, NULL, 130169),
(130170, '3.40.1110.10-FF-000314', NULL, NULL, 124, NULL, NULL, 130170),
(130171, '1.25.40.120-FF-000042', NULL, 'Geranylgeranyl transferase type-2 subunit alpha', 322, NULL, NULL, 130171),
(130172, '2.130.10.10-FF-005017', NULL, 'WD repeat domain 90', 12, NULL, NULL, 130172),
(130173, '3.80.10.10-FF-000690', NULL, 'F-box/LRR-repeat protein 14', 267, NULL, NULL, 130173),
(130174, '3.30.70.100-FF-000118', NULL, 'Ssr2857 protein', 64, NULL, NULL, 130174),
(130175, '1.20.1110.10-FF-000051', NULL, 'Calcium-transporting ATPase', 115, NULL, NULL, 130175),
(130176, '3.80.10.10-FF-000633', NULL, 'Blast:Protein slit', 121, NULL, NULL, 130176),
(130177, '3.40.50.300-FF-001454', NULL, 'Dynein heavy chain 12, axonemal', 221, NULL, NULL, 130177),
(130178, '3.40.50.300-FF-007440', NULL, 'Uncharacterized protein', 254, NULL, NULL, 130178),
(130179, '3.30.2080.10-FF-000004', NULL, 'Carbohydrate-binding protein', 159, NULL, NULL, 130179),
(130180, '2.30.42.10-FF-000447', NULL, NULL, 88, NULL, NULL, 130180),
(130181, '1.10.10.10-FF-001916', NULL, 'MarR family transcriptional regulatory protein', 145, NULL, NULL, 130181),
(130182, '3.40.1500.10-FF-000012', NULL, 'Oxygen-dependent coproporphyrinogen-III oxidase', 309, NULL, NULL, 130182),
(130183, '3.30.110.10-FF-000019', NULL, 'Probable mitochondrial translation initiation factor', 92, NULL, NULL, 130183),
(130184, '3.40.50.300-FF-003606', NULL, 'ATP-binding protein', 171, NULL, NULL, 130184),
(130185, '2.60.40.10-FF-005039', NULL, NULL, 130, NULL, NULL, 130185),
(130186, '1.20.1070.10-FF-002087', NULL, 'RE24343p', 148, NULL, NULL, 130186);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(130187, '2.80.10.50-FF-000102', NULL, 'Ryanodine receptor 2', 142, NULL, NULL, 130187),
(130188, '3.30.160.380-FF-000014', NULL, NULL, 104, NULL, NULL, 130188),
(130189, '1.20.1110.10-FF-000022', NULL, 'copper-transporting ATPase 1 isoform X2', 52, NULL, NULL, 130189),
(130190, '1.10.3720.10-FF-000032', NULL, 'General amino acid ABC transporter permease', 217, NULL, NULL, 130190),
(130191, '3.30.160.60-FF-003662', NULL, 'GM15530', 34, NULL, NULL, 130191),
(130192, '3.30.60.30-FF-000144', NULL, 'follistatin-related protein 5 isoform X1', 67, NULL, NULL, 130192),
(130193, '3.20.20.70-FF-000648', NULL, NULL, 238, NULL, NULL, 130193),
(130194, '3.40.50.2300-FF-001507', NULL, NULL, 186, NULL, NULL, 130194),
(130195, '2.130.10.10-FF-004180', NULL, 'WD-repeat protein, putative', 163, NULL, NULL, 130195),
(130196, '2.60.40.10-FF-003595', NULL, NULL, 95, NULL, NULL, 130196),
(130197, '3.90.1150.80-FF-000005', NULL, NULL, 106, NULL, NULL, 130197),
(130198, '1.20.1250.20-FF-002188', NULL, 'Solute carrier family 2, facilitated glucose transporter member 4', 161, NULL, NULL, 130198),
(130199, '3.20.20.220-FF-000040', NULL, 'Proline dehydrogenase', 254, NULL, NULL, 130199),
(130200, '2.60.34.10-FF-000101', NULL, 'Heat shock protein belonging to the HSP70 family', 160, NULL, NULL, 130200),
(130201, '3.60.21.10-FF-000232', NULL, 'Serine/threonine phosphatase type 1', 267, NULL, NULL, 130201),
(130202, '1.20.920.10-FF-000074', NULL, 'Chromatin structure-remodeling complex subunit RSC4', 145, NULL, NULL, 130202),
(130203, '1.20.58.1220-FF-000014', NULL, 'Putative exocyst complex subunit', 104, NULL, NULL, 130203),
(130204, '3.60.20.10-FF-000180', NULL, NULL, 87, NULL, NULL, 130204),
(130205, '2.130.10.10-FF-003926', NULL, 'Uncharacterized protein', 259, NULL, NULL, 130205),
(130206, '1.20.1280.290-FF-000065', NULL, 'LOC100036889 protein', 90, NULL, NULL, 130206),
(130207, '3.90.230.10-FF-000014', NULL, 'Aminopeptidase P family protein', 228, NULL, NULL, 130207),
(130208, '1.25.40.470-FF-000006', NULL, 'WD repeat-containing protein 19 isoform X1', 194, NULL, NULL, 130208),
(130209, '3.40.30.10-FF-000462', NULL, 'Thioredoxin 3', 133, NULL, NULL, 130209),
(130210, '3.20.70.20-FF-000013', NULL, 'YjjI family glycine radical enzyme', 444, NULL, NULL, 130210),
(130211, '2.60.120.10-FF-000466', NULL, 'Gll3853 protein', 212, NULL, NULL, 130211),
(130212, '1.20.1250.20-FF-000390', NULL, 'MFS transporter', 195, NULL, NULL, 130212),
(130213, '1.10.238.10-FF-001165', NULL, 'Putative calmodulin-related protein', 103, NULL, NULL, 130213),
(130214, '3.30.900.10-FF-000057', NULL, 'Uncharacterized protein', 221, NULL, NULL, 130214),
(130215, '1.25.40.480-FF-000009', NULL, 'Fance protein', 140, NULL, NULL, 130215),
(130216, '1.10.510.10-FF-003625', NULL, NULL, 195, NULL, NULL, 130216),
(130217, '2.30.29.30-FF-000815', NULL, 'Uncharacterized protein', 161, NULL, NULL, 130217),
(130218, '2.30.110.10-FF-000091', NULL, 'Uncharacterized protein', 211, NULL, NULL, 130218),
(130219, '1.10.101.10-FF-000016', NULL, 'N-acetylmuramoyl-L-alanine amidase', 73, NULL, NULL, 130219),
(130220, '3.30.160.60-FF-005814', NULL, NULL, 33, NULL, NULL, 130220),
(130221, '2.40.10.10-FF-000412', NULL, NULL, 74, NULL, NULL, 130221),
(130222, '2.30.30.140-FF-000216', NULL, 'Uncharacterized protein', 88, NULL, NULL, 130222),
(130223, '3.30.1370.210-FF-000015', NULL, 'putative ATP-dependent RNA helicase DHX57', 66, NULL, NULL, 130223),
(130224, '1.25.10.10-FF-003160', NULL, 'Ubiquitin-binding serine/threonine protein kinase', 379, NULL, NULL, 130224),
(130225, '3.40.50.720-FF-000888', NULL, 'Myo-inositol-1-phosphate synthase', 307, NULL, NULL, 130225),
(130226, '3.40.50.1820-FF-000739', NULL, 'Protein CBG14567', 281, NULL, NULL, 130226),
(130227, '3.20.20.140-FF-000460', NULL, 'Periplasmic amidohydrolase family protein', 283, NULL, NULL, 130227),
(130228, '1.20.58.1210-FF-000011', NULL, 'Exocyst complex component 8', 121, NULL, NULL, 130228),
(130229, '3.30.70.330-FF-002666', NULL, NULL, 63, NULL, NULL, 130229),
(130230, '1.10.287.130-FF-000241', NULL, 'Sensor histidine kinase', 86, NULL, NULL, 130230);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(130231, '1.20.58.80-FF-000063', NULL, 'Ubiquitin Specific Protease', 128, NULL, NULL, 130231),
(130232, '3.30.200.20-FF-001428', NULL, 'Protein kinase, putative', 142, NULL, NULL, 130232),
(130233, '2.60.120.290-FF-000193', NULL, 'AGAP005526-PA', 105, NULL, NULL, 130233),
(130234, '3.40.630.30-FF-000360', NULL, 'Uncharacterized protein', 208, NULL, NULL, 130234),
(130235, '1.10.10.2360-FF-000004', NULL, 'Nuclear pore complex protein Nup98-Nup96', 50, NULL, NULL, 130235),
(130236, '2.60.120.1440-FF-000003', NULL, 'Sigma factor regulatory protein, FecR/PupR family', 141, NULL, NULL, 130236),
(130237, '3.90.640.10-FF-000181', NULL, 'AaceriACR184Cp', 106, NULL, NULL, 130237),
(130238, '2.60.40.10-FF-003656', NULL, NULL, 98, NULL, NULL, 130238),
(130239, '2.60.120.10-FF-000820', NULL, 'ADR385Wp', 89, NULL, NULL, 130239),
(130240, '3.20.20.80-FF-000067', NULL, 'Glucan 1,3-beta-glucosidase A', 321, NULL, NULL, 130240),
(130241, '3.80.10.10-FF-000897', NULL, 'Leucine Rich Repeat family protein, expressed', 115, NULL, NULL, 130241),
(130242, '3.30.160.60-FF-001392', NULL, 'zinc finger protein 34 isoform X2', 28, NULL, NULL, 130242),
(130243, '1.25.40.20-FF-000382', NULL, 'Ankyrin repeat domain-containing protein 42', 47, NULL, NULL, 130243),
(130244, '3.30.810.10-FF-000027', NULL, 'Phosphatidylinositol-5-phosphate 4-kinase, type II, alpha a', 50, NULL, NULL, 130244),
(130245, '3.30.9.10-FF-000216', NULL, 'Uncharacterized protein', 159, NULL, NULL, 130245),
(130246, '3.30.200.20-FF-000765', NULL, 'Cdc7 kinase, isoform B', 105, NULL, NULL, 130246),
(130247, '2.60.120.970-FF-000121', NULL, 'Uncharacterized protein', 226, NULL, NULL, 130247),
(130248, '3.80.10.10-FF-004169', NULL, 'Uncharacterized protein', 99, NULL, NULL, 130248),
(130249, '3.40.50.150-FF-000700', NULL, 'Methyltransferase-like protein', 138, NULL, NULL, 130249),
(130250, '3.40.50.300-FF-002117', NULL, 'Axonemal dynein heavy chain', 137, NULL, NULL, 130250),
(130251, '3.40.50.150-FF-001835', NULL, NULL, 60, NULL, NULL, 130251),
(130252, '2.40.50.140-FF-000729', NULL, NULL, 132, NULL, NULL, 130252),
(130253, '2.70.98.20-FF-000032', NULL, 'Amine oxidase', 181, NULL, NULL, 130253),
(130254, '2.60.40.10-FF-000722', NULL, 'Tenascin R', 89, NULL, NULL, 130254),
(130255, '3.20.20.70-FF-000064', NULL, 'Thiamine-phosphate synthase', 199, NULL, NULL, 130255),
(130256, '1.20.5.700-FF-000006', NULL, 'Cytochrome b6-f complex iron-sulfur subunit 2', 47, NULL, NULL, 130256),
(130257, '3.30.300.160-FF-000004', NULL, 'Type II secretory pathway ATPase', 80, NULL, NULL, 130257),
(130258, '2.130.10.10-FF-001156', NULL, 'Syntaxin-binding protein 5 isoform B', 234, NULL, NULL, 130258),
(130259, '3.30.160.60-FF-000110', NULL, 'Zinc finger protein-like', 28, NULL, NULL, 130259),
(130260, '2.60.15.10-FF-000029', NULL, 'ATP synthase epsilon chain', 131, NULL, NULL, 130260),
(130261, '2.70.150.10-FF-000123', NULL, 'Cation-transporting ATPase', 144, NULL, NULL, 130261),
(130262, '3.40.605.10-FF-000104', NULL, 'ALdehyde deHydrogenase', 209, NULL, NULL, 130262),
(130263, '2.60.120.470-FF-000010', NULL, 'Uncharacterized protein', 159, NULL, NULL, 130263),
(130264, '3.30.300.150-FF-000001', NULL, 'DNA polymerase III subunit gamma/tau', 128, NULL, NULL, 130264),
(130265, '1.20.5.710-FF-000009', NULL, 'Ribosomal protein L12-B', 56, NULL, NULL, 130265),
(130266, '2.60.120.380-FF-000039', NULL, 'Putative calpain', 166, NULL, NULL, 130266),
(130267, '3.30.70.330-FF-001531', NULL, NULL, 76, NULL, NULL, 130267),
(130268, '4.10.280.10-FF-000099', NULL, 'Myc-family transcription factor', 62, NULL, NULL, 130268),
(130269, '3.40.50.1440-FF-000018', NULL, 'Tubulin beta chain, putative', 100, NULL, NULL, 130269),
(130270, '2.40.50.1070-FF-000021', NULL, NULL, 168, NULL, NULL, 130270),
(130271, '3.40.20.10-FF-000135', NULL, 'Twinfilin-2', 147, NULL, NULL, 130271),
(130272, '3.80.10.10-FF-000279', NULL, 'Oligodendrocyte-myelin glycoprotein', 100, NULL, NULL, 130272),
(130273, '3.30.70.360-FF-000056', NULL, 'Uncharacterized protein', 106, NULL, NULL, 130273),
(130274, '3.30.70.1230-FF-000082', NULL, 'Adenylate cyclase type 6', 89, NULL, NULL, 130274);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(130275, '3.40.50.740-FF-000017', NULL, 'NADH-quinone oxidoreductase', 62, NULL, NULL, 130275),
(130276, '2.30.110.10-FF-000034', NULL, 'BnaC05g47660D protein', 157, NULL, NULL, 130276),
(130277, '1.25.40.20-FF-001871', NULL, 'Uncharacterized protein', 129, NULL, NULL, 130277),
(130278, '1.20.5.170-FF-000280', NULL, 'Uncharacterized protein', 55, NULL, NULL, 130278),
(130279, '1.20.5.110-FF-000335', NULL, 'Uncharacterized protein', 83, NULL, NULL, 130279),
(130280, '1.10.390.10-FF-000102', NULL, 'RE34731p', 68, NULL, NULL, 130280),
(130281, '3.80.10.10-FF-000425', NULL, 'Leucine-rich repeat-containing protein 2', 183, NULL, NULL, 130281),
(130282, '3.30.930.10-FF-000093', NULL, 'Histidine--tRNA ligase', 356, NULL, NULL, 130282),
(130283, '1.10.357.20-FF-000022', NULL, 'Uncharacterized protein', 186, NULL, NULL, 130283),
(130284, '3.30.200.20-FF-001670', NULL, 'Uncharacterized protein', 81, NULL, NULL, 130284),
(130285, '3.90.1530.10-FF-000019', NULL, 'Plasmid partitioning protein', 110, NULL, NULL, 130285),
(130286, '3.40.47.10-FF-000169', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase', 489, NULL, NULL, 130286),
(130287, '1.20.1050.10-FF-000079', NULL, 'Glutathione S-transferase Gst', 117, NULL, NULL, 130287),
(130288, '1.20.1610.10-FF-000015', NULL, 'Putative alpha-1,2-mannosidase', 147, NULL, NULL, 130288),
(130289, '3.30.40.10-FF-001205', NULL, 'GM18390', 86, NULL, NULL, 130289),
(130290, '1.25.40.10-FF-002998', NULL, 'Pentatricopeptide repeat-containing protein At3g60960, mitochondrial', 127, NULL, NULL, 130290),
(130291, '3.30.160.60-FF-005343', NULL, NULL, 28, NULL, NULL, 130291),
(130292, '1.20.1250.10-FF-000145', NULL, NULL, 92, NULL, NULL, 130292),
(130293, '2.70.98.30-FF-000035', NULL, 'Alpha-mannosidase', 132, NULL, NULL, 130293),
(130294, '3.30.470.10-FF-000012', NULL, 'Branched-chain-amino-acid aminotransferase', 156, NULL, NULL, 130294),
(130295, '3.30.160.20-FF-000059', NULL, 'DExH-box ATP-dependent RNA helicase DExH3', 90, NULL, NULL, 130295),
(130296, '1.25.40.10-FF-005140', NULL, 'DnaJ domain containing protein', 99, NULL, NULL, 130296),
(130297, '2.60.40.10-FF-003241', NULL, 'CD244 isoform 1', 110, NULL, NULL, 130297),
(130298, '3.80.10.10-FF-002224', NULL, 'Protein CBG17991', 167, NULL, NULL, 130298),
(130299, '3.30.160.60-FF-005961', NULL, NULL, 60, NULL, NULL, 130299),
(130300, '2.30.29.30-FF-000962', NULL, 'Sterol 3-beta-glucosyltransferase', 108, NULL, NULL, 130300),
(130301, '3.90.70.10-FF-000878', NULL, 'Uncharacterized protein', 40, NULL, NULL, 130301),
(130302, '2.60.40.10-FF-002521', NULL, 'Fibroblast growth factor receptor', 101, NULL, NULL, 130302),
(130303, '1.10.8.10-FF-000207', NULL, 'UV excision repair RAD23 protein, putative', 69, NULL, NULL, 130303),
(130304, '1.10.720.30-FF-000038', NULL, 'Myocardin related transcription factor Ba', 69, NULL, NULL, 130304),
(130305, '3.40.50.12650-FF-000042', NULL, 'Artemis-related DNA-crosslink repair exonuclease', 159, NULL, NULL, 130305),
(130306, '2.20.28.230-FF-000001', NULL, 'Interleukin 15 receptor subunit alpha', 55, NULL, NULL, 130306),
(130307, '3.30.390.10-FF-000011', NULL, 'Mandelate racemase/muconate lactonizing enzyme family protein', 141, NULL, NULL, 130307),
(130308, '3.40.50.300-FF-003494', NULL, 'Predicted protein', 163, NULL, NULL, 130308),
(130309, '1.20.1740.10-FF-000261', NULL, 'Uncharacterized protein', 112, NULL, NULL, 130309),
(130310, '3.30.1370.10-FF-000077', NULL, 'vigilin isoform X2', 65, NULL, NULL, 130310),
(130311, '2.40.50.150-FF-000002', NULL, 'DNA-directed RNA polymerase subunit beta', 136, NULL, NULL, 130311),
(130312, '3.90.190.10-FF-000016', NULL, 'receptor-type tyrosine-protein phosphatase gamma isoform X1', 296, NULL, NULL, 130312),
(130313, '3.10.129.10-FF-000089', NULL, 'Putative esterase F42H10.6', 133, NULL, NULL, 130313),
(130314, '2.170.150.80-FF-000030', NULL, 'NAC domain-containing protein 6', 99, NULL, NULL, 130314),
(130315, '3.40.850.10-FF-000275', NULL, 'Myosin IK', 131, NULL, NULL, 130315),
(130316, '1.10.533.10-FF-000114', NULL, 'Caspase Dronc', 101, NULL, NULL, 130316);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(130317, '1.25.10.10-FF-001922', NULL, 'Uncharacterized protein', 215, NULL, NULL, 130317),
(130318, '3.30.390.30-FF-000017', NULL, 'Mycothione reductase', 116, NULL, NULL, 130318),
(130319, '3.40.50.300-FF-001954', NULL, 'DEAD box helicase, putative', 81, NULL, NULL, 130319),
(130320, '2.130.10.10-FF-001420', NULL, 'Small nucleolar ribonucleoprotein complex subunit, putative', 246, NULL, NULL, 130320),
(130321, '3.40.1190.20-FF-000097', NULL, 'Hydroxymethylpyrimidine phosphate kinase', 270, NULL, NULL, 130321),
(130322, '3.30.70.1450-FF-000058', NULL, 'Uncharacterized protein', 67, NULL, NULL, 130322),
(130323, '1.10.10.60-FF-001145', NULL, NULL, 57, NULL, NULL, 130323),
(130324, '3.40.50.620-FF-000892', NULL, 'Predicted protein', 91, NULL, NULL, 130324),
(130325, '3.80.10.10-FF-004433', NULL, 'Leucine-rich repeat receptor protein kinase EMS1', 194, NULL, NULL, 130325),
(130326, '3.30.980.10-FF-000039', NULL, 'Alanyl-tRNA editing protein AlaX-S', 68, NULL, NULL, 130326),
(130327, '1.25.40.10-FF-003925', NULL, 'Uncharacterized protein', 291, NULL, NULL, 130327),
(130328, '3.30.40.10-FF-000952', NULL, 'Ubiquitin ligase E3 alpha, putative', 99, NULL, NULL, 130328),
(130329, '2.10.25.10-FF-000381', NULL, 'Low-density lipoprotein receptor-related protein 6', 40, NULL, NULL, 130329),
(130330, '1.20.58.2220-FF-000005', NULL, 'Formin 1', 407, NULL, NULL, 130330),
(130331, '2.60.220.30-FF-000013', NULL, 'Unc-5 family C-terminal like', 152, NULL, NULL, 130331),
(130332, '2.30.29.30-FF-001125', NULL, 'Uncharacterized protein', 125, NULL, NULL, 130332),
(130333, '1.10.555.10-FF-000159', NULL, 'T cell activation RhoGTPase-activating protein a', 239, NULL, NULL, 130333),
(130334, '3.40.50.1820-FF-000891', NULL, 'Uncharacterized protein', 199, NULL, NULL, 130334),
(130335, '1.50.40.10-FF-000135', NULL, 'Adenine nucleotide transporter', 302, NULL, NULL, 130335),
(130336, '3.20.20.140-FF-000308', NULL, 'AMP deaminase, putative', 363, NULL, NULL, 130336),
(130337, '2.60.220.50-FF-000019', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1', 200, NULL, NULL, 130337),
(130338, '3.40.50.720-FF-000624', NULL, 'Fatty acyl-CoA reductase', 353, NULL, NULL, 130338),
(130339, '1.20.1740.10-FF-000109', NULL, 'Na(+)-linked D-alanine glycine permease', 383, NULL, NULL, 130339),
(130340, '3.40.50.300-FF-008311', NULL, 'Chromosome 7, whole genome shotgun sequence', 255, NULL, NULL, 130340),
(130341, '3.40.630.30-FF-000450', NULL, 'Uncharacterized protein', 232, NULL, NULL, 130341),
(130342, '3.90.850.10-FF-000016', NULL, '2-keto-4-pentenoate hydratase/2-oxohepta-3-ene-1,7-dioic acid hydratase (Catechol pathway)', 199, NULL, NULL, 130342),
(130343, '1.10.4040.10-FF-000002', NULL, 'Penicillinase repressor BlaI', 54, NULL, NULL, 130343),
(130344, '1.10.3810.10-FF-000005', NULL, 'Penicillin-binding protein 1A', 210, NULL, NULL, 130344),
(130345, '1.10.600.10-FF-000018', NULL, 'Probable geranylgeranyl-diphosphate geranylgeranyltransferase (AL-2)', 304, NULL, NULL, 130345),
(130346, '3.40.50.300-FF-001807', NULL, 'ABC transporter ATP-binding protein', 233, NULL, NULL, 130346),
(130347, '2.130.10.10-FF-003308', NULL, 'Protein CBR-ELPC-2', 234, NULL, NULL, 130347),
(130348, '3.30.40.10-FF-000598', NULL, 'E3 SUMO-protein ligase PIAS, putative', 133, NULL, NULL, 130348),
(130349, '1.10.1040.50-FF-000019', NULL, NULL, 229, NULL, NULL, 130349),
(130350, '1.20.120.160-FF-000034', NULL, 'Hybrid sensor histidine kinase/response regulator', 95, NULL, NULL, 130350),
(130351, '1.10.520.10-FF-000017', NULL, 'Os01g0293900 protein', 21, NULL, NULL, 130351),
(130352, '4.10.410.10-FF-000043', NULL, 'CRE-MLT-11 protein', 68, NULL, NULL, 130352),
(130353, '2.130.10.10-FF-001627', NULL, 'WD repeat-containing protein, putative', 213, NULL, NULL, 130353),
(130354, '1.20.1270.60-FF-000262', NULL, 'Predicted protein', 173, NULL, NULL, 130354),
(130355, '3.40.50.1820-FF-001144', NULL, 'Liver carboxylesterase 1', 93, NULL, NULL, 130355),
(130356, '1.25.40.10-FF-001716', NULL, 'Pentatricopeptide repeat-containing protein At2g37230', 74, NULL, NULL, 130356);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(130357, '1.10.630.10-FF-000464', NULL, 'Uncharacterized protein', 101, NULL, NULL, 130357),
(130358, '2.60.40.10-FF-003802', NULL, NULL, 108, NULL, NULL, 130358),
(130359, '2.40.50.140-FF-001044', NULL, NULL, 121, NULL, NULL, 130359),
(130360, '3.30.160.810-FF-000008', NULL, '50S ribosomal protein L3', 64, NULL, NULL, 130360),
(130361, '1.10.441.10-FF-000007', NULL, 'Mannose-6-phosphate isomerase type 1', 114, NULL, NULL, 130361),
(130362, '1.10.150.50-FF-000079', NULL, 'transcription factor CP2-like protein 1 isoform X1', 55, NULL, NULL, 130362),
(130363, '3.10.50.40-FF-000046', NULL, 'Peptidyl-prolyl cis-trans isomerase NIMA-interacting 4', 59, NULL, NULL, 130363),
(130364, '3.40.50.1220-FF-000037', NULL, 'Transcriptional regulatory protein sir2b', 54, NULL, NULL, 130364),
(130365, '3.30.70.1230-FF-000172', NULL, 'Predicted protein', 191, NULL, NULL, 130365),
(130366, '3.30.420.40-FF-000113', NULL, 'Heat shock 70 kDa protein 4', 119, NULL, NULL, 130366),
(130367, '2.60.40.150-FF-000012', NULL, 'Kinase C alpha type', 137, NULL, NULL, 130367),
(130368, '2.10.70.10-FF-000013', NULL, 'Collagen, type I, alpha 1', 36, NULL, NULL, 130368),
(130369, '1.25.40.20-FF-001719', NULL, 'Death-associated protein kinase 1', 42, NULL, NULL, 130369),
(130370, '1.10.20.120-FF-000020', NULL, 'Uncharacterized protein', 150, NULL, NULL, 130370),
(130371, '1.10.8.60-FF-000115', NULL, 'N-ethylmaleimide-sensitive fusion protein, putative', 92, NULL, NULL, 130371),
(130372, '2.10.25.10-FF-000588', NULL, 'Notch homolog 4, [Drosophila]', 53, NULL, NULL, 130372),
(130373, '3.40.50.300-FF-006102', NULL, 'Uncharacterized protein', 57, NULL, NULL, 130373),
(130374, '1.20.1250.20-FF-000861', NULL, 'Integral membrane transport protein, putative', 188, NULL, NULL, 130374),
(130375, '3.40.50.300-FF-007294', NULL, 'ABC transporter, putative', 151, NULL, NULL, 130375),
(130376, '2.60.40.290-FF-000003', NULL, 'Secreted cellulose binding protein', 103, NULL, NULL, 130376),
(130377, '3.30.1120.10-FF-000064', NULL, 'Uncharacterized protein', 32, NULL, NULL, 130377),
(130378, '2.40.50.1020-FF-000023', NULL, 'Putative response regulator of the competence regulon, ComE response regulator of sakacin A production', 110, NULL, NULL, 130378),
(130379, '3.30.710.10-FF-000374', NULL, 'Uncharacterized protein', 110, NULL, NULL, 130379),
(130380, '3.40.630.30-FF-000096', NULL, 'Mycothiol acetyltransferase', 189, NULL, NULL, 130380),
(130381, '1.20.120.1080-FF-000025', NULL, 'Dosage compensation regulator', 160, NULL, NULL, 130381),
(130382, '2.170.300.10-FF-000089', NULL, 'Uncharacterized protein', 96, NULL, NULL, 130382),
(130383, '1.20.1250.20-FF-000709', NULL, 'Dityrosine transporter 1', 414, NULL, NULL, 130383),
(130384, '2.60.40.10-FF-005394', NULL, NULL, 51, NULL, NULL, 130384),
(130385, '3.10.20.90-FF-000065', NULL, 'Cordon-bleu WH2 repeat protein', 90, NULL, NULL, 130385),
(130386, '3.30.160.60-FF-002116', NULL, 'Zinc finger protein 571', 33, NULL, NULL, 130386),
(130387, '1.25.10.10-FF-003367', NULL, 'Uncharacterized protein', 166, NULL, NULL, 130387),
(130388, '1.10.640.10-FF-000083', NULL, 'Uncharacterized protein', 215, NULL, NULL, 130388),
(130389, '1.10.275.10-FF-000031', NULL, NULL, 109, NULL, NULL, 130389),
(130390, '1.20.1270.290-FF-000001', NULL, 'MLLT3, super elongation complex subunit', 92, NULL, NULL, 130390),
(130391, '1.10.3730.10-FF-000004', NULL, 'Pyrroline-5-carboxylate reductase', 102, NULL, NULL, 130391),
(130392, '1.20.1730.10-FF-000081', NULL, 'Uncharacterized protein', 498, NULL, NULL, 130392),
(130393, '3.40.50.150-FF-000346', NULL, 'Phospholipid N-methyltransferase', 175, NULL, NULL, 130393),
(130394, '3.30.160.60-FF-004325', NULL, NULL, 27, NULL, NULL, 130394),
(130395, '1.10.3860.10-FF-000008', NULL, 'Amino acid transporter', 471, NULL, NULL, 130395),
(130396, '2.180.10.10-FF-000001', NULL, 'Teneurin transmembrane protein 4', 664, NULL, NULL, 130396),
(130397, '1.10.1620.20-FF-000004', NULL, 'Related to atp synthase epsilon chain, mitochondrial', 57, NULL, NULL, 130397),
(130398, '1.10.287.130-FF-000095', NULL, 'Two-component sensor histidine kinase', 68, NULL, NULL, 130398);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(130399, '3.40.50.10860-FF-000033', NULL, 'Shikimate dehydrogenase (NADP(+))', 105, NULL, NULL, 130399),
(130400, '2.60.120.920-FF-000213', NULL, 'Uncharacterized protein', 137, NULL, NULL, 130400),
(130401, '1.10.20.140-FF-000026', NULL, NULL, 72, NULL, NULL, 130401),
(130402, '1.10.287.70-FF-000514', NULL, 'Uncharacterized protein', 164, NULL, NULL, 130402),
(130403, '2.60.40.10-FF-001650', NULL, 'titin isoform X1', 97, NULL, NULL, 130403),
(130404, '3.80.10.10-FF-004079', NULL, 'Uncharacterized protein', 127, NULL, NULL, 130404),
(130405, '2.130.10.10-FF-001717', NULL, 'Angio-associated migratory cell protein, putative', 169, NULL, NULL, 130405),
(130406, '3.15.20.10-FF-000020', NULL, 'Uncharacterized protein', 12, NULL, NULL, 130406),
(130407, '2.60.40.60-FF-000012', NULL, 'Cadherin 24', 117, NULL, NULL, 130407),
(130408, '3.40.1110.10-FF-000168', NULL, 'Cation transport ATPase, E1-E2 family', 120, NULL, NULL, 130408),
(130409, '1.25.40.10-FF-003307', NULL, 'Pentatricopeptide repeat-containing protein At1g22830', 148, NULL, NULL, 130409),
(130410, '1.10.1090.10-FF-000005', NULL, 'Ubiquinol-cytochrome c reductase complex 14kD subunit, putative', 110, NULL, NULL, 130410),
(130411, '1.10.1750.10-FF-000005', NULL, 'Chromosomal replication initiator protein DnaA', 100, NULL, NULL, 130411),
(130412, '3.90.730.10-FF-000007', NULL, 'Ribonuclease T2', 210, NULL, NULL, 130412),
(130413, '2.40.50.140-FF-001134', NULL, NULL, 116, NULL, NULL, 130413),
(130414, '2.130.10.10-FF-003218', NULL, 'Uncharacterized protein', 323, NULL, NULL, 130414),
(130415, '2.40.50.140-FF-001191', NULL, NULL, 122, NULL, NULL, 130415),
(130416, '3.40.50.12710-FF-000021', NULL, 'Protein arginine methyltransferase NDUFAF7', 393, NULL, NULL, 130416),
(130417, '3.40.50.410-FF-000149', NULL, 'Predicted protein', 190, NULL, NULL, 130417),
(130418, '2.30.29.70-FF-000007', NULL, 'Proteasome complex subunit Rpn13 ubiquitin receptor, putative', 111, NULL, NULL, 130418),
(130419, '3.90.810.10-FF-000008', NULL, 'wiskott-Aldrich syndrome protein', 66, NULL, NULL, 130419),
(130420, '3.30.559.10-FF-000274', NULL, 'Uncharacterized protein', 123, NULL, NULL, 130420),
(130421, '1.25.40.10-FF-001155', NULL, 'Pentatricopeptide repeat protein PPR1106-17', 125, NULL, NULL, 130421),
(130422, '3.30.200.20-FF-000855', NULL, 'Protein CBG11187', 141, NULL, NULL, 130422),
(130423, '3.40.50.300-FF-006012', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 187, NULL, NULL, 130423),
(130424, '2.10.25.10-FF-000324', NULL, 'Fibulin 2', 43, NULL, NULL, 130424),
(130425, '2.130.10.10-FF-001774', NULL, 'Connector of kinase to AP-1, isoform G', 118, NULL, NULL, 130425),
(130426, '3.30.420.40-FF-000023', NULL, 'Guanosine-5''-triphosphate,3''-diphosphate pyrophosphatase', 112, NULL, NULL, 130426),
(130427, '2.60.120.290-FF-000046', NULL, 'Attractin-like protein 1', 132, NULL, NULL, 130427),
(130428, '1.25.40.10-FF-004589', NULL, 'Pentatricopeptide repeat-containing protein 4, mitochondrial', 173, NULL, NULL, 130428),
(130429, '2.60.120.200-FF-000593', NULL, 'Uncharacterized protein', 159, NULL, NULL, 130429),
(130430, '3.40.1190.20-FF-000209', NULL, NULL, 69, NULL, NULL, 130430),
(130431, '3.40.50.300-FF-006720', NULL, 'Uncharacterized protein', 72, NULL, NULL, 130431),
(130432, '2.60.40.150-FF-000630', NULL, 'Uncharacterized protein', 177, NULL, NULL, 130432),
(130433, '3.30.365.10-FF-000026', NULL, 'Xanthine dehydrogenase, molybdenum binding subunit', 130, NULL, NULL, 130433),
(130434, '2.40.10.230-FF-000001', NULL, 'H/ACA ribonucleoprotein complex subunit', 92, NULL, NULL, 130434),
(130435, '2.30.29.30-FF-000877', NULL, 'Pleckstrin homology domain containing protein', 117, NULL, NULL, 130435),
(130436, '1.10.8.480-FF-000010', NULL, 'rRNA adenine N(6)-methyltransferase', 108, NULL, NULL, 130436),
(130437, '3.30.70.330-FF-002548', NULL, NULL, 37, NULL, NULL, 130437),
(130438, '3.40.50.10380-FF-000013', NULL, 'Malic enzyme, putative', 254, NULL, NULL, 130438),
(130439, '2.130.10.10-FF-003808', NULL, 'SVP1-like protein 2', 308, NULL, NULL, 130439);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(130440, '3.30.200.20-FF-001198', NULL, 'Mitogen-activated protein kinase', 68, NULL, NULL, 130440),
(130441, '1.20.1560.10-FF-000371', NULL, 'Uncharacterized protein', 340, NULL, NULL, 130441),
(130442, '2.60.40.60-FF-000512', NULL, 'CaDHerin family', 104, NULL, NULL, 130442),
(130443, '2.60.60.20-FF-000024', NULL, 'Lipoprotein lipase', 117, NULL, NULL, 130443),
(130444, '2.60.120.10-FF-000410', NULL, 'cGMP-dependent protein kinase', 122, NULL, NULL, 130444),
(130445, '2.40.10.240-FF-000004', NULL, 'S-adenosylmethionine:tRNA ribosyltransferase-isomerase', 113, NULL, NULL, 130445),
(130446, '1.10.560.10-FF-000020', NULL, 'T-complex protein theta subunit', 234, NULL, NULL, 130446),
(130447, '3.40.1050.10-FF-000022', NULL, 'Carbonic anhydrase', 198, NULL, NULL, 130447),
(130448, '3.40.50.300-FF-005815', NULL, 'Dethiobiotin synthase', 244, NULL, NULL, 130448),
(130449, '3.30.70.330-FF-001446', NULL, 'GD20965', 131, NULL, NULL, 130449),
(130450, '2.10.230.10-FF-000025', NULL, 'dnaJ homolog subfamily A member 4 isoform X5', 42, NULL, NULL, 130450),
(130451, '3.90.190.10-FF-000191', NULL, 'Uncharacterized protein', 197, NULL, NULL, 130451),
(130452, '1.20.1250.20-FF-002216', NULL, 'Uncharacterized protein', 136, NULL, NULL, 130452),
(130453, '3.20.20.80-FF-000477', NULL, 'Uncharacterized protein', 284, NULL, NULL, 130453),
(130454, '3.30.70.330-FF-001502', NULL, 'Predicted protein', 124, NULL, NULL, 130454),
(130455, '3.30.559.10-FF-000156', NULL, 'Lovastatin nonaketide synthase, polyketide synthase component', 191, NULL, NULL, 130455),
(130456, '1.20.1050.10-FF-000287', NULL, 'Uncharacterized protein', 70, NULL, NULL, 130456),
(130457, '1.20.1720.10-FF-000136', NULL, NULL, 190, NULL, NULL, 130457),
(130458, '3.40.50.720-FF-000534', NULL, 'mRNA, clone: RTFL01-28-L12', 298, NULL, NULL, 130458),
(130459, '2.60.40.10-FF-000014', NULL, 'H-2 class I histocompatibility antigen, alpha chain', 101, NULL, NULL, 130459),
(130460, '1.10.1240.10-FF-000006', NULL, 'Methanol-5-hydroxybenzimidazolylcobamide methyltransferase', 100, NULL, NULL, 130460),
(130461, '3.40.50.720-FF-000478', NULL, 'Dehydrogenase/reductase SDR family member 7', 284, NULL, NULL, 130461),
(130462, '3.30.160.20-FF-000031', NULL, 'Endoribonuclease Dicer-like protein 1', 79, NULL, NULL, 130462),
(130463, '2.20.25.10-FF-000032', NULL, 'DNA-directed RNA polymerase subunit', 52, NULL, NULL, 130463),
(130464, '3.30.160.60-FF-005843', NULL, NULL, 27, NULL, NULL, 130464),
(130465, '3.30.450.20-FF-000457', NULL, 'GAF sensor signal transduction histidine kinase', 119, NULL, NULL, 130465),
(130466, '1.20.1250.20-FF-000597', NULL, 'MFS transporter, putative', 457, NULL, NULL, 130466),
(130467, '1.10.630.10-FF-000672', NULL, 'Cytochrome P450, family 2, subfamily AA, polypeptide 12', 172, NULL, NULL, 130467),
(130468, '3.40.50.150-FF-001566', NULL, NULL, 73, NULL, NULL, 130468),
(130469, '3.30.200.20-FF-001254', NULL, 'AGC family protein kinase', 102, NULL, NULL, 130469),
(130470, '1.10.10.1100-FF-000014', NULL, 'BFD domain protein (2Fe-2S)-binding domain protein', 55, NULL, NULL, 130470),
(130471, '1.10.10.10-FF-001271', NULL, 'RpiR family transcriptional regulator', 73, NULL, NULL, 130471),
(130472, '3.90.550.50-FF-000230', NULL, 'Uncharacterized protein', 111, NULL, NULL, 130472),
(130473, '1.10.287.3240-FF-000040', NULL, 'Uncharacterized protein', 55, NULL, NULL, 130473),
(130474, '3.40.50.620-FF-000920', NULL, 'Tyrosine--tRNA ligase', 211, NULL, NULL, 130474),
(130475, '1.25.40.10-FF-001508', NULL, 'Pentatricopeptide repeat-containing protein', 135, NULL, NULL, 130475),
(130476, '3.60.20.30-FF-000011', NULL, NULL, 112, NULL, NULL, 130476),
(130477, '3.40.20.10-FF-000074', NULL, 'Protein transport protein Sec24A', 132, NULL, NULL, 130477),
(130478, '3.80.10.10-FF-001206', NULL, 'GD21911', 401, NULL, NULL, 130478),
(130479, '1.20.58.1700-FF-000001', NULL, 'DUR1,2p Urea amidolyase', 76, NULL, NULL, 130479),
(130480, '2.10.25.10-FF-000796', NULL, 'Crumbs cell polarity complex component 2b', 42, NULL, NULL, 130480),
(130481, '1.10.510.10-FF-003209', NULL, NULL, 143, NULL, NULL, 130481);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(130482, '1.10.220.10-FF-000062', NULL, 'Annexin A1', 73, NULL, NULL, 130482),
(130483, '2.10.25.10-FF-000650', NULL, 'fibropellin-1-like isoform X1', 37, NULL, NULL, 130483),
(130484, '3.30.300.110-FF-000012', NULL, 'tRNA 4-demethylwyosine(37)-methyltransferase Taw21', 78, NULL, NULL, 130484),
(130485, '2.60.40.150-FF-000074', NULL, 'E3 ubiquitin-protein ligase', 128, NULL, NULL, 130485),
(130486, '1.25.40.180-FF-000189', NULL, NULL, 227, NULL, NULL, 130486),
(130487, '2.60.40.10-FF-005450', NULL, NULL, 63, NULL, NULL, 130487),
(130488, '1.20.5.170-FF-000162', NULL, 'SPeCtrin', 32, NULL, NULL, 130488),
(130489, '3.90.79.10-FF-000105', NULL, 'ADP-ribose pyrophosphatase', 171, NULL, NULL, 130489),
(130490, '2.10.25.10-FF-000852', NULL, 'Uncharacterized protein, isoform A', 38, NULL, NULL, 130490),
(130491, '2.40.170.20-FF-000050', NULL, 'Iron(III) compound receptor', 531, NULL, NULL, 130491),
(130492, '2.130.10.10-FF-000138', NULL, 'Enhancer of mRNA-decapping protein 4', 375, NULL, NULL, 130492),
(130493, '2.30.29.30-FF-000254', NULL, 'Ran-specific GTPase-activating protein 1', 158, NULL, NULL, 130493),
(130494, '3.40.430.10-FF-000018', NULL, 'Dihydrofolate reductase', 177, NULL, NULL, 130494),
(130495, '3.40.50.800-FF-000053', NULL, 'Neosin, isoform A', 112, NULL, NULL, 130495),
(130496, '2.60.40.10-FF-002105', NULL, 'V-set and immunoglobulin domain containing 10 like', 111, NULL, NULL, 130496),
(130497, '1.25.40.10-FF-005314', NULL, 'Uncharacterized protein', 121, NULL, NULL, 130497),
(130498, '3.40.190.10-FF-000893', NULL, 'Transcriptional activator GpuR', 99, NULL, NULL, 130498),
(130499, '3.30.160.60-FF-005253', NULL, NULL, 22, NULL, NULL, 130499),
(130500, '3.30.160.60-FF-005197', NULL, NULL, 22, NULL, NULL, 130500),
(130501, '3.20.20.70-FF-000148', NULL, 'tRNA-dihydrouridine(20) synthase [NAD(P)+]-like isoform X1', 250, NULL, NULL, 130501),
(130502, '2.60.40.150-FF-000130', NULL, 'synaptotagmin-4 isoform X1', 160, NULL, NULL, 130502),
(130503, '3.40.50.300-FF-003668', NULL, 'Dynein heavy chain 9, axonemal', 97, NULL, NULL, 130503),
(130504, '2.60.120.230-FF-000017', NULL, NULL, 126, NULL, NULL, 130504),
(130505, '1.10.510.10-FF-002107', NULL, NULL, 100, NULL, NULL, 130505),
(130506, '3.30.70.141-FF-000025', NULL, 'Nucleoside diphosphate kinase', 142, NULL, NULL, 130506),
(130507, '3.40.190.80-FF-000071', NULL, 'Inositol monophosphatase family protein', 114, NULL, NULL, 130507),
(130508, '1.10.1420.10-FF-000104', NULL, 'DNA mismatch repair protein Msh3', 199, NULL, NULL, 130508),
(130509, '3.40.30.10-FF-000046', NULL, 'GSH-dependent disulfide bond oxidoreductase', 85, NULL, NULL, 130509),
(130510, '1.20.1730.10-FF-000108', NULL, 'Uncharacterized protein', 178, NULL, NULL, 130510),
(130511, '1.20.1250.20-FF-001114', NULL, 'Major Facilitator Superfamily protein', 370, NULL, NULL, 130511),
(130512, '1.10.287.660-FF-000017', NULL, 'Tryptophan-rich protein, putative', 73, NULL, NULL, 130512),
(130513, '3.20.20.210-FF-000003', NULL, '5-methyltetrahydropteroyltriglutamate--homocysteine methyltransferase', 400, NULL, NULL, 130513),
(130514, '3.30.1370.10-FF-000195', NULL, 'Predicted protein', 66, NULL, NULL, 130514),
(130515, '1.10.10.60-FF-000127', NULL, 'homeobox protein aristaless-like 4', 74, NULL, NULL, 130515),
(130516, '1.10.287.130-FF-000033', NULL, 'Sporulation initiation phosphotransferase', 57, NULL, NULL, 130516),
(130517, '1.10.540.10-FF-000108', NULL, 'Acyl-CoA dehydrogenase, putative', 84, NULL, NULL, 130517),
(130518, '3.40.1350.10-FF-000011', NULL, 'tRNA-splicing endonuclease subunit Sen2', 91, NULL, NULL, 130518),
(130519, '1.25.40.10-FF-000789', NULL, 'NEDD8-activating enzyme E1 catalytic subunit', 156, NULL, NULL, 130519),
(130520, '1.20.58.60-FF-000872', NULL, 'Spectrin, beta, non-erythrocytic 5', 117, NULL, NULL, 130520),
(130521, '3.40.605.10-FF-000133', NULL, 'Aldehyde dehydrogenase, putative', 84, NULL, NULL, 130521),
(130522, '2.10.25.10-FF-000173', NULL, 'Neurogenic locus notch protein 2', 37, NULL, NULL, 130522),
(130523, '3.40.50.300-FF-001577', NULL, 'ABC bile acid transporter', 237, NULL, NULL, 130523); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(130524, '3.40.50.300-FF-007737', NULL, 'Uncharacterized protein', 83, NULL, NULL, 130524),
(130525, '2.30.29.30-FF-000933', NULL, 'Uncharacterized protein', 98, NULL, NULL, 130525),
(130526, '3.40.50.80-FF-000169', NULL, 'Uncharacterized protein', 158, NULL, NULL, 130526),
(130527, '3.40.50.2300-FF-001541', NULL, NULL, 53, NULL, NULL, 130527),
(130528, '1.20.1270.10-FF-000028', NULL, 'Heat shock 70 kDa protein', 110, NULL, NULL, 130528),
(130529, '3.20.20.220-FF-000006', NULL, 'Proline dehydrogenase', 272, NULL, NULL, 130529),
(130530, '1.20.1070.10-FF-001013', NULL, 'Predicted protein', 308, NULL, NULL, 130530),
(130531, '3.40.1440.60-FF-000005', NULL, 'Primosomal protein N''', 111, NULL, NULL, 130531),
(130532, '2.60.120.290-FF-000254', NULL, 'Cubilin-like Protein', 117, NULL, NULL, 130532),
(130533, '3.30.70.100-FF-000034', NULL, 'Cyclic diguanylate phosphodiesterase (EAL) domain protein', 143, NULL, NULL, 130533),
(130534, '3.40.1110.10-FF-000230', NULL, 'Phospholipid-transporting ATPase', 151, NULL, NULL, 130534),
(130535, '2.60.40.1080-FF-000002', NULL, 'nuclear pore membrane glycoprotein 210-like', 66, NULL, NULL, 130535),
(130536, '2.60.40.10-FF-005601', NULL, NULL, 59, NULL, NULL, 130536),
(130537, '1.10.238.10-FF-001255', NULL, 'Uncharacterized protein', 66, NULL, NULL, 130537),
(130538, '3.40.50.360-FF-000027', NULL, 'Arsenical resistance protein ArsH', 238, NULL, NULL, 130538),
(130539, '4.10.400.10-FF-000132', NULL, 'Low-density lipoprotein receptor-related protein', 29, NULL, NULL, 130539),
(130540, '1.25.40.10-FF-003751', NULL, 'Pentatricopeptide repeat-containing protein At4g31850, chloroplastic', 124, NULL, NULL, 130540),
(130541, '1.10.287.10-FF-000047', NULL, 'Uncharacterized protein', 59, NULL, NULL, 130541),
(130542, '2.60.120.430-FF-000015', NULL, 'Putative receptor-like protein kinase', 156, NULL, NULL, 130542),
(130543, '2.40.128.200-FF-000001', NULL, 'C-type lysozyme inhibitor', 82, NULL, NULL, 130543),
(130544, '3.80.10.10-FF-001004', NULL, 'Leucine-rich repeat receptor-like protein kinase TDR isoform A', 256, NULL, NULL, 130544),
(130545, '3.30.160.60-FF-000407', NULL, 'Zinc finger protein', 29, NULL, NULL, 130545),
(130546, '3.30.360.20-FF-000012', NULL, NULL, 101, NULL, NULL, 130546),
(130547, '2.30.30.100-FF-000047', NULL, 'Small nuclear ribonucleoprotein SmB, putative', 95, NULL, NULL, 130547),
(130548, '3.40.50.300-FF-006597', NULL, 'Uncharacterized protein', 97, NULL, NULL, 130548),
(130549, '1.50.40.10-FF-000427', NULL, 'Uncharacterized protein', 182, NULL, NULL, 130549),
(130550, '4.10.1000.10-FF-000121', NULL, 'Uncharacterized protein', 35, NULL, NULL, 130550),
(130551, '3.30.160.60-FF-003426', NULL, 'PR domain zinc finger protein 13-like', 72, NULL, NULL, 130551),
(130552, '1.25.40.10-FF-001571', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 136, NULL, NULL, 130552),
(130553, '2.130.10.10-FF-004000', NULL, 'Chromosome 21, whole genome shotgun sequence', 228, NULL, NULL, 130553),
(130554, '3.30.60.30-FF-000021', NULL, 'reversion-inducing cysteine-rich protein with Kazal motifs isoform X1', 33, NULL, NULL, 130554),
(130555, '2.30.39.10-FF-000164', NULL, 'Uncharacterized protein', 68, NULL, NULL, 130555),
(130556, '2.30.30.140-FF-000126', NULL, 'tudor domain-containing protein 6', 57, NULL, NULL, 130556),
(130557, '1.20.1560.10-FF-000573', NULL, 'ABC transporter H family member 4', 320, NULL, NULL, 130557),
(130558, '2.160.20.70-FF-000043', NULL, 'Adenylyl cyclase-associated protein', 99, NULL, NULL, 130558),
(130559, '1.25.40.10-FF-003223', NULL, 'Pentatricopeptide repeat-containing protein At3g26782, mitochondrial', 64, NULL, NULL, 130559),
(130560, '3.30.70.980-FF-000011', NULL, 'Putative transcriptional regulatory protein', 86, NULL, NULL, 130560),
(130561, '1.10.8.10-FF-000325', NULL, 'Baculoviral IAP repeat containing 7', 50, NULL, NULL, 130561),
(130562, '2.130.10.10-FF-001919', NULL, 'Seven WD repeats, AN11 family', 340, NULL, NULL, 130562),
(130563, '1.10.760.10-FF-000001', NULL, 'Cytochrome c iso-1', 105, NULL, NULL, 130563);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(130564, '1.10.3260.10-FF-000013', NULL, 'DNA ligase', 273, NULL, NULL, 130564),
(130565, '1.10.10.60-FF-000892', NULL, NULL, 83, NULL, NULL, 130565),
(130566, '1.20.1110.10-FF-000112', NULL, 'Plasma membrane calcium-transporting ATPase 2', 298, NULL, NULL, 130566),
(130567, '3.30.160.20-FF-000177', NULL, 'Endoribonuclease Dicer', 62, NULL, NULL, 130567),
(130568, '3.90.1240.10-FF-000003', NULL, 'Botulinum neurotoxin type C', 430, NULL, NULL, 130568),
(130569, '3.40.50.300-FF-004034', NULL, 'AGAP011982-PA', 282, NULL, NULL, 130569),
(130570, '2.130.10.10-FF-003544', NULL, 'Uncharacterized protein', 223, NULL, NULL, 130570),
(130571, '3.80.10.10-FF-002634', NULL, 'Slit homolog 1b (Drosophila)', 58, NULL, NULL, 130571),
(130572, '1.20.5.110-FF-000127', NULL, 'Syntaxin-121', 73, NULL, NULL, 130572),
(130573, '1.20.1280.50-FF-000170', NULL, 'F-box protein At3g44326', 74, NULL, NULL, 130573),
(130574, '3.10.100.10-FF-000040', NULL, 'Secretory phospholipase A2 receptor', 159, NULL, NULL, 130574),
(130575, '3.10.560.10-FF-000001', NULL, 'Group 4 capsule (G4C) polysaccharide, YmcB', 70, NULL, NULL, 130575),
(130576, '2.10.90.10-FF-000132', NULL, 'Uncharacterized protein', 91, NULL, NULL, 130576),
(130577, '1.10.840.10-FF-000002', NULL, 'Rap guanine nucleotide exchange factor 4', 251, NULL, NULL, 130577),
(130578, '2.130.10.10-FF-001364', NULL, 'Protein HIRA', 190, NULL, NULL, 130578),
(130579, '1.25.10.10-FF-001327', NULL, 'Uncharacterized protein', 571, NULL, NULL, 130579),
(130580, '1.10.238.10-FF-000153', NULL, 'TBC1 domain family member 8 isoform X2', 206, NULL, NULL, 130580),
(130581, '3.20.20.140-FF-000078', NULL, 'Inactive deaminase YBR284W', 444, NULL, NULL, 130581),
(130582, '4.10.280.10-FF-000245', NULL, 'Transcription factor, putative', 59, NULL, NULL, 130582),
(130583, '1.25.40.70-FF-000054', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', 204, NULL, NULL, 130583),
(130584, '1.50.10.10-FF-000077', NULL, 'Sga1p', 479, NULL, NULL, 130584),
(130585, '2.80.10.50-FF-000041', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 128, NULL, NULL, 130585),
(130586, '3.20.20.70-FF-000441', NULL, 'NADPH dehydrogenase, putative', 382, NULL, NULL, 130586),
(130587, '2.30.30.140-FF-000065', NULL, 'tudor domain-containing protein 7', 72, NULL, NULL, 130587),
(130588, '3.40.50.300-FF-003994', NULL, 'Predicted protein', 169, NULL, NULL, 130588),
(130589, '1.25.40.180-FF-000245', NULL, NULL, 138, NULL, NULL, 130589),
(130590, '2.130.10.10-FF-005725', NULL, 'Uncharacterized protein', 137, NULL, NULL, 130590),
(130591, '2.130.10.10-FF-005107', NULL, 'MIP10235p', 246, NULL, NULL, 130591),
(130592, '3.40.50.300-FF-003724', NULL, 'AAA family ATPase', 164, NULL, NULL, 130592),
(130593, '3.50.50.60-FF-001129', NULL, 'Uncharacterized protein', 121, NULL, NULL, 130593),
(130594, '3.60.20.40-FF-000014', NULL, 'Gamma-glutamyltranspeptidase', 181, NULL, NULL, 130594),
(130595, '1.10.150.20-FF-000273', NULL, 'Meiotic 9', 81, NULL, NULL, 130595),
(130596, '3.30.505.10-FF-000150', NULL, NULL, 108, NULL, NULL, 130596),
(130597, '1.10.357.70-FF-000020', NULL, 'Uncharacterized protein', 180, NULL, NULL, 130597),
(130598, '2.30.30.380-FF-000030', NULL, 'Ubiquitin thioesterase trabid', 61, NULL, NULL, 130598),
(130599, '1.25.40.10-FF-003279', NULL, 'pre-mRNA-splicing factor SYF1 isoform X2', 241, NULL, NULL, 130599),
(130600, '3.80.10.10-FF-000689', NULL, 'Leucine rich repeats and death domain containing 1', 316, NULL, NULL, 130600),
(130601, '3.30.530.20-FF-000082', NULL, 'START domain protein', 180, NULL, NULL, 130601),
(130602, '2.60.120.1190-FF-000001', NULL, 'Discoidin domain receptor tyrosine kinase 2', 186, NULL, NULL, 130602),
(130603, '2.60.40.1080-FF-000007', NULL, 'Nuclear Pore complex Protein', 72, NULL, NULL, 130603),
(130604, '3.30.497.10-FF-000169', NULL, 'Uncharacterized protein', 20, NULL, NULL, 130604),
(130605, '3.40.50.2020-FF-000092', NULL, 'Adenine phosphoribosyltransferase', 236, NULL, NULL, 130605),
(130606, '3.40.50.10190-FF-000080', NULL, 'S-M checkpoint control protein rad4', 87, NULL, NULL, 130606);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(130607, '3.40.1370.10-FF-000041', NULL, 'RM4, ribosomal protein 4', 199, NULL, NULL, 130607),
(130608, '1.20.120.310-FF-000006', NULL, 'Sulfhydryl oxidase', 174, NULL, NULL, 130608),
(130609, '3.60.20.10-FF-000269', NULL, NULL, 110, NULL, NULL, 130609),
(130610, '3.30.200.20-FF-001518', NULL, 'Uncharacterized protein', 96, NULL, NULL, 130610),
(130611, '1.10.630.10-FF-000609', NULL, 'Os03g0367101 protein', 259, NULL, NULL, 130611),
(130612, '3.40.630.30-FF-000124', NULL, 'N-acetyltransferase, putative', 154, NULL, NULL, 130612),
(130613, '3.40.718.10-FF-000024', NULL, 'Isocitrate dehydrogenase (NADP(+)) 2, mitochondrial', 41, NULL, NULL, 130613),
(130614, '3.80.10.10-FF-004495', NULL, 'Stkq', 70, NULL, NULL, 130614),
(130615, '2.20.28.290-FF-000002', NULL, 'Leucine--tRNA ligase', 47, NULL, NULL, 130615),
(130616, '2.130.10.10-FF-003634', NULL, 'Uncharacterized protein', 96, NULL, NULL, 130616),
(130617, '3.50.30.30-FF-000063', NULL, 'Uncharacterized protein', 184, NULL, NULL, 130617),
(130618, '3.30.260.10-FF-000058', NULL, 'Uncharacterized protein', 62, NULL, NULL, 130618),
(130619, '3.30.1460.20-FF-000025', NULL, 'Actin-related protein 2/3 complex subunit 2B', 79, NULL, NULL, 130619),
(130620, '3.40.1380.20-FF-000016', NULL, 'Pyruvate kinase', 141, NULL, NULL, 130620),
(130621, '1.20.120.1910-FF-000021', NULL, 'Cysteinyl-tRNA synthetase 2, mitochondrial', 166, NULL, NULL, 130621),
(130622, '3.40.50.2300-FF-001069', NULL, NULL, 79, NULL, NULL, 130622),
(130623, '3.40.1380.10-FF-000013', NULL, 'ATP synthase F1, gamma subunit', 212, NULL, NULL, 130623),
(130624, '1.10.840.10-FF-000007', NULL, 'SH2 domain containing 3C (Predicted)', 321, NULL, NULL, 130624),
(130625, '3.40.50.880-FF-000003', NULL, 'Anthranilate synthase component II', 189, NULL, NULL, 130625),
(130626, '1.50.40.10-FF-000051', NULL, 'Mitochondrial carnitine/acylcarnitine carrier protein', 194, NULL, NULL, 130626),
(130627, '3.90.1210.10-FF-000001', NULL, 'Flagella basal body P-ring formation protein FlgA', 63, NULL, NULL, 130627),
(130628, '3.30.160.60-FF-003628', NULL, 'GM11232', 29, NULL, NULL, 130628),
(130629, '3.20.90.10-FF-000011', NULL, NULL, 209, NULL, NULL, 130629),
(130630, '3.40.50.620-FF-000504', NULL, 'Predicted protein', 139, NULL, NULL, 130630),
(130631, '1.25.40.510-FF-000007', NULL, 'Glutamic acid-rich protein putative', 185, NULL, NULL, 130631),
(130632, '3.30.1150.10-FF-000009', NULL, 'Protein TonB', 89, NULL, NULL, 130632),
(130633, '3.80.10.10-FF-002078', NULL, 'Neuronal leucine rich repeat-4', 140, NULL, NULL, 130633),
(130634, '2.10.220.10-FF-000114', NULL, 'Proprotein convertase subtilisin/kexin type 5', 102, NULL, NULL, 130634),
(130635, '3.30.40.10-FF-000452', NULL, 'Histone acetyltransferase HAC1', 45, NULL, NULL, 130635),
(130636, '3.40.50.300-FF-008103', NULL, 'Uncharacterized protein', 110, NULL, NULL, 130636),
(130637, '1.10.20.10-FF-000080', NULL, 'transcription initiation factor TFIID subunit 11 isoform X2', 37, NULL, NULL, 130637),
(130638, '3.40.630.30-FF-000511', NULL, 'Glucosamine 6-phosphate N-acetyltransferase', 94, NULL, NULL, 130638),
(130639, '1.10.150.50-FF-000225', NULL, 'Uncharacterized protein', 70, NULL, NULL, 130639),
(130640, '3.40.50.150-FF-001392', NULL, NULL, 170, NULL, NULL, 130640),
(130641, '3.40.50.10490-FF-000046', NULL, '40S ribosomal protein SA', 133, NULL, NULL, 130641),
(130642, '3.40.50.1010-FF-000272', NULL, NULL, 137, NULL, NULL, 130642),
(130643, '1.10.287.10-FF-000042', NULL, 'Uncharacterized protein', 49, NULL, NULL, 130643),
(130644, '3.40.50.10190-FF-000107', NULL, 'RNA polymerase II subunit A domain phosphatase', 89, NULL, NULL, 130644),
(130645, '2.40.110.10-FF-000043', NULL, 'Acyl CoA DeHydrogenase', 90, NULL, NULL, 130645),
(130646, '1.25.40.10-FF-003425', NULL, 'Tetratricopeptide repeat domain 21B', 330, NULL, NULL, 130646),
(130647, '3.30.160.60-FF-003336', NULL, 'Zinc finger protein', 27, NULL, NULL, 130647),
(130648, '3.40.50.1100-FF-000001', NULL, 'Tryptophan synthase beta chain', 164, NULL, NULL, 130648),
(130649, '2.60.40.1230-FF-000013', NULL, 'ADP-ribosylation factor-binding protein GGA1', 125, NULL, NULL, 130649);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(130650, '3.40.50.2300-FF-001417', NULL, NULL, 52, NULL, NULL, 130650),
(130651, '3.30.479.20-FF-000068', NULL, 'Elongation factor Ts, mitochondrial', 54, NULL, NULL, 130651),
(130652, '3.40.850.10-FF-000477', NULL, 'Predicted protein', 350, NULL, NULL, 130652),
(130653, '2.20.25.10-FF-000037', NULL, 'Transcription initiation factor IIB', 51, NULL, NULL, 130653),
(130654, '2.70.170.10-FF-000130', NULL, 'Uncharacterized protein', 112, NULL, NULL, 130654),
(130655, '3.30.70.890-FF-000012', NULL, 'Mevalonate kinase', 134, NULL, NULL, 130655),
(130656, '3.30.930.10-FF-000328', NULL, 'Lipoate-protein ligase B, putative', 157, NULL, NULL, 130656),
(130657, '1.10.8.10-FF-000179', NULL, 'Defective in cullin neddylation protein', 59, NULL, NULL, 130657),
(130658, '1.20.58.60-FF-000546', NULL, 'Uncharacterized protein', 113, NULL, NULL, 130658),
(130659, '3.40.50.300-FF-005293', NULL, 'G5-interacting protein', 175, NULL, NULL, 130659),
(130660, '1.25.40.10-FF-004999', NULL, 'Genomes uncoupled1', 127, NULL, NULL, 130660),
(130661, '1.25.40.500-FF-000004', NULL, 'Transcription initiation factor TFIID subunit', 151, NULL, NULL, 130661),
(130662, '3.40.50.200-FF-000114', NULL, 'Os06g0163500 protein', 109, NULL, NULL, 130662),
(130663, '3.40.1110.10-FF-000286', NULL, NULL, 86, NULL, NULL, 130663),
(130664, '3.40.50.10190-FF-000310', NULL, 'Nbs', 99, NULL, NULL, 130664),
(130665, '2.80.10.50-FF-000046', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 134, NULL, NULL, 130665),
(130666, '2.30.30.490-FF-000063', NULL, 'Origin recognition complex subunit 1', 171, NULL, NULL, 130666),
(130667, '3.30.420.10-FF-000447', NULL, NULL, 202, NULL, NULL, 130667),
(130668, '1.20.920.10-FF-000158', NULL, 'Lex-1', 124, NULL, NULL, 130668),
(130669, '1.20.58.60-FF-000254', NULL, 'VAB-10B protein', 220, NULL, NULL, 130669),
(130670, '3.40.630.10-FF-000320', NULL, 'Predicted protein', 292, NULL, NULL, 130670),
(130671, '3.40.570.10-FF-000023', NULL, 'MIP05340p', 160, NULL, NULL, 130671),
(130672, '3.40.720.10-FF-000147', NULL, 'Arylsulfatase', 449, NULL, NULL, 130672),
(130673, '3.40.50.300-FF-004360', NULL, 'Uncharacterized ABC transporter ATP-binding protein HI_0354', 226, NULL, NULL, 130673),
(130674, '3.40.50.300-FF-007086', NULL, 'Uncharacterized protein', 191, NULL, NULL, 130674),
(130675, '3.30.710.10-FF-000166', NULL, 'BTB/POZ domain-containing protein 8', 107, NULL, NULL, 130675),
(130676, '1.10.565.10-FF-000188', NULL, 'Uncharacterized protein', 71, NULL, NULL, 130676),
(130677, '3.40.50.10490-FF-000102', NULL, NULL, 120, NULL, NULL, 130677),
(130678, '3.40.630.30-FF-000034', NULL, 'N-alpha-acetyltransferase 20', 160, NULL, NULL, 130678),
(130679, '1.25.40.10-FF-003077', NULL, 'Pentatricopeptide repeat-containing protein', 187, NULL, NULL, 130679),
(130680, '3.40.390.10-FF-000256', NULL, NULL, 234, NULL, NULL, 130680),
(130681, '1.10.1520.10-FF-000084', NULL, 'Endoribonuclease dcr-1', 197, NULL, NULL, 130681),
(130682, '3.40.20.10-FF-000079', NULL, 'Secretory 24CD, isoform C', 120, NULL, NULL, 130682),
(130683, '2.30.180.10-FF-000038', NULL, 'fasciclin-1 isoform X2', 133, NULL, NULL, 130683),
(130684, '3.30.70.330-FF-000659', NULL, 'RNA-binding protein, putative', 105, NULL, NULL, 130684),
(130685, '3.10.20.90-FF-000621', NULL, 'Ubiquitin carboxyl-terminal hydrolase, putative', 90, NULL, NULL, 130685),
(130686, '2.10.60.10-FF-000074', NULL, 'Receptor protein serine/threonine kinase', 77, NULL, NULL, 130686),
(130687, '2.170.16.10-FF-000032', NULL, 'Uncharacterized protein', 111, NULL, NULL, 130687),
(130688, '1.25.40.820-FF-000038', NULL, 'Predicted protein', 42, NULL, NULL, 130688),
(130689, '1.25.10.10-FF-003249', NULL, 'Serine/threonine-protein kinase TOR', 228, NULL, NULL, 130689),
(130690, '2.10.25.10-FF-000824', NULL, 'Delta-like protein', 36, NULL, NULL, 130690),
(130691, '2.130.10.10-FF-005635', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', 176, NULL, NULL, 130691),
(130692, '1.20.1250.20-FF-001053', NULL, 'Sugar transporter', 206, NULL, NULL, 130692); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(130693, '4.10.410.10-FF-000104', NULL, 'Uncharacterized protein', 53, NULL, NULL, 130693),
(130694, '3.10.20.90-FF-000003', NULL, 'Polyubiquitin 10', 76, NULL, NULL, 130694),
(130695, '3.40.50.200-FF-000058', NULL, 'Predicted protein', 219, NULL, NULL, 130695),
(130696, '3.60.10.10-FF-000353', NULL, 'Predicted protein', 156, NULL, NULL, 130696),
(130697, '1.25.40.10-FF-003369', NULL, 'Putative pentatricopeptide repeat-containing protein', 211, NULL, NULL, 130697),
(130698, '3.30.40.10-FF-000396', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 104, NULL, NULL, 130698),
(130699, '3.80.10.10-FF-001330', NULL, 'Leucine-rich repeat-containing 29', 154, NULL, NULL, 130699),
(130700, '3.40.50.1820-FF-000683', NULL, 'Putative esterase', 266, NULL, NULL, 130700),
(130701, '3.40.630.30-FF-000652', NULL, 'Predicted protein', 162, NULL, NULL, 130701),
(130702, '3.30.930.10-FF-000238', NULL, 'Lysine--tRNA ligase', 373, NULL, NULL, 130702),
(130703, '3.40.50.12780-FF-000227', NULL, 'Uncharacterized protein', 239, NULL, NULL, 130703),
(130704, '2.60.40.10-FF-001616', NULL, 'Sortilin related receptor 1', 96, NULL, NULL, 130704),
(130705, '3.90.70.80-FF-000062', NULL, 'ubiquitin thioesterase OTU1', 184, NULL, NULL, 130705),
(130706, '3.30.420.40-FF-001097', NULL, 'Uncharacterized protein', 70, NULL, NULL, 130706),
(130707, '2.60.120.260-FF-000178', NULL, 'Secreted protein', 139, NULL, NULL, 130707),
(130708, '3.65.10.20-FF-000031', NULL, 'Uncharacterized protein', 131, NULL, NULL, 130708),
(130709, '1.20.1070.10-FF-000698', NULL, 'Olfactory receptor', 157, NULL, NULL, 130709),
(130710, '2.130.10.10-FF-002055', NULL, 'EG:63B12.7 protein', 158, NULL, NULL, 130710),
(130711, '1.20.1270.60-FF-000060', NULL, 'Actin polymerization protein Bzz1', 293, NULL, NULL, 130711),
(130712, '3.90.20.20-FF-000024', NULL, 'Protein GrpE', 115, NULL, NULL, 130712),
(130713, '3.40.50.10470-FF-000040', NULL, 'Related to translation initiation factor GCD7', 195, NULL, NULL, 130713),
(130714, '3.80.10.10-FF-000190', NULL, 'Receptor-like kinase TMK4', 294, NULL, NULL, 130714),
(130715, '1.20.120.550-FF-000027', NULL, 'Uncharacterized protein', 83, NULL, NULL, 130715),
(130716, '3.60.21.10-FF-000440', NULL, 'Mre11, putative', 223, NULL, NULL, 130716),
(130717, '1.10.30.10-FF-000052', NULL, 'Non-histone chromosomal protein 6 homolog', 93, NULL, NULL, 130717),
(130718, '1.10.10.10-FF-001473', NULL, 'Interferon regulatory factor 8', 112, NULL, NULL, 130718),
(130719, '2.60.40.1730-FF-000096', NULL, NULL, 204, NULL, NULL, 130719),
(130720, '3.30.780.10-FF-000058', NULL, 'Predicted protein', 166, NULL, NULL, 130720),
(130721, '2.10.50.10-FF-000006', NULL, 'Signal peptide, CUB domain and EGF like domain containing 3', 58, NULL, NULL, 130721),
(130722, '3.30.342.10-FF-000052', NULL, 'DNA polymerase epsilon catalytic subunit', 145, NULL, NULL, 130722),
(130723, '3.30.160.60-FF-003954', NULL, NULL, 24, NULL, NULL, 130723),
(130724, '3.40.30.10-FF-000664', NULL, 'Uncharacterized protein', 149, NULL, NULL, 130724),
(130725, '3.40.50.620-FF-000830', NULL, 'Tyrosine--tRNA ligase', 128, NULL, NULL, 130725),
(130726, '2.130.10.10-FF-003960', NULL, 'Uncharacterized protein', 240, NULL, NULL, 130726),
(130727, '2.40.420.20-FF-000002', NULL, 'Multidrug resistance protein MdtE', 92, NULL, NULL, 130727),
(130728, '3.90.1150.160-FF-000006', NULL, 'Glutamate decarboxylase', 87, NULL, NULL, 130728),
(130729, '3.40.50.620-FF-000774', NULL, 'Uncharacterized protein', 107, NULL, NULL, 130729),
(130730, '3.40.50.300-FF-005669', NULL, 'DNA helicase', 195, NULL, NULL, 130730),
(130731, '1.10.1200.10-FF-000032', NULL, 'Acyl carrier protein MbtL', 81, NULL, NULL, 130731),
(130732, '2.60.40.1090-FF-000005', NULL, 'Type 1 fimbrial protein', 153, NULL, NULL, 130732),
(130733, '1.10.287.470-FF-000084', NULL, 'Efflux pump, RND family, membrane fusion lipoprotein', 88, NULL, NULL, 130733),
(130734, '3.20.20.80-FF-000567', NULL, 'Glutamate carboxypeptidase, putative', 54, NULL, NULL, 130734),
(130735, '1.10.1040.10-FF-000058', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(P)+]', 137, NULL, NULL, 130735);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(130736, '2.60.40.10-FF-001088', NULL, 'Macrophage colony-stimulating factor 1 receptor', 99, NULL, NULL, 130736),
(130737, '2.130.10.10-FF-003718', NULL, 'Uncharacterized protein', 125, NULL, NULL, 130737),
(130738, '2.40.290.10-FF-000022', NULL, 'Putative KU70 protein', 114, NULL, NULL, 130738),
(130739, '1.25.40.10-FF-003695', NULL, 'Uncharacterized protein', 165, NULL, NULL, 130739),
(130740, '3.40.50.300-FF-001398', NULL, 'Replicative DNA helicase', 279, NULL, NULL, 130740),
(130741, '3.40.140.10-FF-000120', NULL, 'Mov34/MPN/PAD-1 family protein, expressed', 199, NULL, NULL, 130741),
(130742, '3.20.20.70-FF-000564', NULL, 'Bll6350 protein', 332, NULL, NULL, 130742),
(130743, '1.25.40.20-FF-000207', NULL, 'Calmodulin-binding transcription activator 1', 129, NULL, NULL, 130743),
(130744, '1.10.10.10-FF-001181', NULL, 'Transcriptional regulatory protein', 144, NULL, NULL, 130744),
(130745, '3.90.1290.10-FF-000045', NULL, 'VAB-10A protein', 155, NULL, NULL, 130745),
(130746, '2.30.29.30-FF-001243', NULL, 'Uncharacterized protein', 112, NULL, NULL, 130746),
(130747, '3.30.9.10-FF-000250', NULL, 'Uncharacterized protein', 172, NULL, NULL, 130747),
(130748, '1.10.10.410-FF-000009', NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit B, mitochondrial', 59, NULL, NULL, 130748),
(130749, '1.10.630.10-FF-000582', NULL, 'Uncharacterized protein', 301, NULL, NULL, 130749),
(130750, '3.80.10.10-FF-002639', NULL, 'F-box/LRR-repeat protein 15', 89, NULL, NULL, 130750),
(130751, '3.30.160.60-FF-002324', NULL, 'Uncharacterized protein', 28, NULL, NULL, 130751),
(130752, '3.60.10.10-FF-000117', NULL, 'Inositol polyphosphate 5-phosphatase', 329, NULL, NULL, 130752),
(130753, '3.30.450.20-FF-000278', NULL, 'PAS domain-containing sensor histidine kinase', 118, NULL, NULL, 130753),
(130754, '2.60.40.3510-FF-000012', NULL, 'Delta-like protein', 132, NULL, NULL, 130754),
(130755, '1.20.1070.10-FF-000850', NULL, 'Muscarinic acetylcholine receptor gar-2', 164, NULL, NULL, 130755),
(130756, '1.10.290.10-FF-000010', NULL, 'DNA topoisomerase', 38, NULL, NULL, 130756),
(130757, '2.130.10.10-FF-001892', NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', 136, NULL, NULL, 130757),
(130758, '2.60.120.290-FF-000164', NULL, 'Cubilin homolog', 120, NULL, NULL, 130758),
(130759, '3.60.10.10-FF-000297', NULL, 'Predicted protein', 337, NULL, NULL, 130759),
(130760, '2.60.40.1510-FF-000030', NULL, 'Integrin beta', 111, NULL, NULL, 130760),
(130761, '3.40.630.30-FF-000326', NULL, 'Putative acetyltransferase', 234, NULL, NULL, 130761),
(130762, '4.10.240.10-FF-000119', NULL, 'Probable sucrose utilization protein SUC1', 74, NULL, NULL, 130762),
(130763, '3.40.50.800-FF-000058', NULL, 'Threonyl-tRNA synthetase, cytoplasmic, putative', 104, NULL, NULL, 130763),
(130764, '1.20.120.1080-FF-000143', NULL, 'ATP-dependent RNA helicase, putative', 93, NULL, NULL, 130764),
(130765, '1.50.40.10-FF-000253', NULL, 'Predicted protein', 148, NULL, NULL, 130765),
(130766, '1.50.10.10-FF-000223', NULL, 'Uncharacterized protein', 65, NULL, NULL, 130766),
(130767, '1.10.132.70-FF-000010', NULL, 'Telomerase reverse transcriptase', 281, NULL, NULL, 130767),
(130768, '1.10.510.10-FF-004322', NULL, NULL, 144, NULL, NULL, 130768),
(130769, '2.20.25.240-FF-000002', NULL, 'FLYWCH zinc finger transcription factor homolog', 70, NULL, NULL, 130769),
(130770, '2.40.240.10-FF-000047', NULL, '50S ribosomal protein L25', 89, NULL, NULL, 130770),
(130771, '3.40.50.1820-FF-001700', NULL, 'Predicted protein', 186, NULL, NULL, 130771),
(130772, '2.60.40.10-FF-001739', NULL, 'Ig gamma-2A chain C region', 99, NULL, NULL, 130772),
(130773, '3.30.70.1230-FF-000048', NULL, 'Phospholipid-transporting ATPase, putative', 193, NULL, NULL, 130773),
(130774, '1.25.40.10-FF-005022', NULL, 'Uncharacterized protein', 55, NULL, NULL, 130774),
(130775, '3.30.420.10-FF-000071', NULL, 'DNA polymerase-3 subunit epsilon', 171, NULL, NULL, 130775),
(130776, '3.30.160.860-FF-000001', NULL, 'IpI internal head protein', 37, NULL, NULL, 130776),
(130777, '1.20.58.60-FF-000198', NULL, 'Uncharacterized protein, isoform I', 100, NULL, NULL, 130777);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(130778, '1.10.150.240-FF-000078', NULL, 'Putative 2-deoxyglucose-6-phosphate phosphatase', 69, NULL, NULL, 130778),
(130779, '3.30.450.60-FF-000003', NULL, 'Coatomer subunit delta', 139, NULL, NULL, 130779),
(130780, '1.20.58.1100-FF-000006', NULL, 'Unc-13 homolog B', 92, NULL, NULL, 130780),
(130781, '3.30.1330.30-FF-000114', NULL, 'Peptide chain release factor subunit 1', 118, NULL, NULL, 130781),
(130782, '3.90.70.10-FF-000350', NULL, 'Ubiquitinyl hydrolase 1', 237, NULL, NULL, 130782),
(130783, '1.25.40.180-FF-000099', NULL, 'Uncharacterized protein', 193, NULL, NULL, 130783),
(130784, '2.30.40.10-FF-000055', NULL, 'Conserved protein', 44, NULL, NULL, 130784),
(130785, '1.20.1250.40-FF-000013', NULL, 'RNA_polymerase_Rpb4', 121, NULL, NULL, 130785),
(130786, '3.60.10.10-FF-000027', NULL, 'Type IV inositol polyphosphate 5-phosphatase 7', 285, NULL, NULL, 130786),
(130787, '3.40.50.1110-FF-000004', NULL, 'Platelet-activating factor acetylhydrolase IB subunit beta', 229, NULL, NULL, 130787),
(130788, '3.30.70.2970-FF-000002', NULL, 'interleukin-1 receptor-associated kinase 1-binding protein 1', 101, NULL, NULL, 130788),
(130789, '2.60.40.10-FF-000599', NULL, 'obscurin isoform X3', 90, NULL, NULL, 130789),
(130790, '3.80.10.10-FF-000835', NULL, 'Protein phosphatase type 1 regulator-like protein', 133, NULL, NULL, 130790),
(130791, '1.10.540.10-FF-000018', NULL, 'Acyl-coenzyme A oxidase', 116, NULL, NULL, 130791),
(130792, '2.130.10.10-FF-003157', NULL, 'U3 small nucleolar RNA-associated protein 4 homolog', 282, NULL, NULL, 130792),
(130793, '2.30.29.30-FF-000259', NULL, 'TBC1 domain family member 8', 110, NULL, NULL, 130793),
(130794, '3.90.830.10-FF-000015', NULL, 'SEC1 family transport protein SLY1', 145, NULL, NULL, 130794),
(130795, '3.40.50.10190-FF-000254', NULL, 'YALI0B15576p', 90, NULL, NULL, 130795),
(130796, '2.60.40.10-FF-005455', NULL, NULL, 108, NULL, NULL, 130796),
(130797, '3.40.720.10-FF-000237', NULL, 'Phosphoglycerate mutase, 2,3-bisphosphoglycerate-independent, putative', 211, NULL, NULL, 130797),
(130798, '1.20.58.390-FF-000025', NULL, 'Cholinergic receptor nicotinic beta 3 subunit', 69, NULL, NULL, 130798),
(130799, '1.10.287.70-FF-000453', NULL, 'Potassium inwardly-rectifying channel', 137, NULL, NULL, 130799),
(130800, '3.30.9.10-FF-000071', NULL, 'Sarcosine oxidase subunit beta', 152, NULL, NULL, 130800),
(130801, '1.20.1250.20-FF-000890', NULL, 'MFS transporter', 183, NULL, NULL, 130801),
(130802, '3.40.50.300-FF-002235', NULL, 'Guanylate-binding protein', 294, NULL, NULL, 130802),
(130803, '2.60.120.10-FF-000264', NULL, 'Sensor histidine kinase', 124, NULL, NULL, 130803),
(130804, '1.20.58.1000-FF-000004', NULL, 'Copper-sensing transcriptional repressor CsoR', 88, NULL, NULL, 130804),
(130805, '3.20.20.10-FF-000030', NULL, 'Alanine racemase', 210, NULL, NULL, 130805),
(130806, '1.10.510.10-FF-003451', NULL, NULL, 276, NULL, NULL, 130806),
(130807, '3.10.250.10-FF-000045', NULL, 'neurotrypsin-like isoform X1', 108, NULL, NULL, 130807),
(130808, '1.10.3210.10-FF-000010', NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase', 105, NULL, NULL, 130808),
(130809, '3.40.50.300-FF-005523', NULL, 'Repair helicase UvrD', 116, NULL, NULL, 130809),
(130810, '3.30.420.10-FF-000716', NULL, NULL, 86, NULL, NULL, 130810),
(130811, '1.25.40.10-FF-003841', NULL, 'Pentatricopeptide repeat-containing protein 8, mitochondrial', 119, NULL, NULL, 130811),
(130812, '4.10.400.10-FF-000042', NULL, 'Corin, serine peptidase', 37, NULL, NULL, 130812),
(130813, '1.10.287.110-FF-000206', NULL, 'Predicted protein', 74, NULL, NULL, 130813),
(130814, '2.60.120.10-FF-000590', NULL, 'Uncharacterized protein', 176, NULL, NULL, 130814),
(130815, '2.10.25.10-FF-000465', NULL, 'Axotactin, isoform B', 36, NULL, NULL, 130815),
(130816, '1.10.730.20-FF-000002', NULL, 'isoleucine--tRNA ligase, mitochondrial', 300, NULL, NULL, 130816),
(130817, '1.20.1280.50-FF-000260', NULL, 'Uncharacterized protein', 56, NULL, NULL, 130817),
(130818, '3.40.50.300-FF-000144', NULL, 'ATP-binding cassette sub-family E member 1', 264, NULL, NULL, 130818);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(130819, '3.40.50.300-FF-005995', NULL, 'RuvB-like helicase', 114, NULL, NULL, 130819),
(130820, '3.40.50.300-FF-000088', NULL, 'Ras-related C3 botulinum toxin substrate 1', 182, NULL, NULL, 130820),
(130821, '3.80.10.10-FF-000841', NULL, 'Toll-like receptor 5', 140, NULL, NULL, 130821),
(130822, '3.10.50.40-FF-000041', NULL, 'FK506-binding nuclear protein', 137, NULL, NULL, 130822),
(130823, '3.30.200.20-FF-000939', NULL, 'Fructosamine kinase', 84, NULL, NULL, 130823),
(130824, '2.60.40.10-FF-005629', NULL, NULL, 96, NULL, NULL, 130824),
(130825, '2.60.120.200-FF-000677', NULL, 'Uncharacterized protein', 47, NULL, NULL, 130825),
(130826, '2.30.29.30-FF-000585', NULL, 'target of rapamycin complex 2 subunit MAPKAP1 isoform X3', 125, NULL, NULL, 130826),
(130827, '3.50.50.60-FF-001096', NULL, 'Flavin-dependent monoxygenase', 245, NULL, NULL, 130827),
(130828, '3.40.605.10-FF-000043', NULL, 'Succinate-semialdehyde dehydrogenase [NADP+]', 254, NULL, NULL, 130828),
(130829, '2.30.30.100-FF-000137', NULL, 'U6 snRNA-associated Sm-like protein LSm2', 95, NULL, NULL, 130829),
(130830, '1.25.40.10-FF-004297', NULL, 'ACL160Cp', 195, NULL, NULL, 130830),
(130831, '2.30.180.10-FF-000010', NULL, 'Fasciclin-like arabinogalactan protein 2', 143, NULL, NULL, 130831),
(130832, '3.30.470.20-FF-000077', NULL, 'Glutathione biosynthesis bifunctional protein GshAB', 100, NULL, NULL, 130832),
(130833, '1.10.10.10-FF-001563', NULL, 'ESCRT-II subunit protein', 69, NULL, NULL, 130833),
(130834, '2.30.42.10-FF-000565', NULL, NULL, 108, NULL, NULL, 130834),
(130835, '3.60.15.10-FF-000196', NULL, 'Protein artemis', 185, NULL, NULL, 130835),
(130836, '3.40.50.2000-FF-000754', NULL, 'Uncharacterized protein', 85, NULL, NULL, 130836),
(130837, '3.40.50.980-FF-000033', NULL, 'Nonribosomal peptide synthase inpB', 161, NULL, NULL, 130837),
(130838, '3.30.40.10-FF-001233', NULL, 'Uncharacterized protein', 70, NULL, NULL, 130838),
(130839, '3.40.50.1820-FF-001228', NULL, 'Uncharacterized protein', 347, NULL, NULL, 130839),
(130840, '3.40.50.11350-FF-000017', NULL, 'O-fucosyltransferase 23', 156, NULL, NULL, 130840),
(130841, '3.30.930.10-FF-000154', NULL, 'Aspartate--tRNA ligase', 257, NULL, NULL, 130841),
(130842, '1.20.1420.10-FF-000006', NULL, 'Talin 2', 163, NULL, NULL, 130842),
(130843, '1.10.10.350-FF-000025', NULL, NULL, 93, NULL, NULL, 130843),
(130844, '4.10.760.10-FF-000001', NULL, 'Agouti-related protein', 46, NULL, NULL, 130844),
(130845, '3.90.228.10-FF-000014', NULL, 'Poly [ADP-ribose] polymerase', 179, NULL, NULL, 130845),
(130846, '3.40.50.720-FF-000186', NULL, 'Acetaldehyde dehydrogenase', 150, NULL, NULL, 130846),
(130847, '1.25.40.570-FF-000036', NULL, 'PCI_domain_containing_protein_-_putative', 370, NULL, NULL, 130847),
(130848, '3.40.50.11340-FF-000014', NULL, 'Uncharacterized protein', 85, NULL, NULL, 130848),
(130849, '3.20.20.190-FF-000014', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 319, NULL, NULL, 130849),
(130850, '3.40.1190.20-FF-000007', NULL, 'Pyridoxal kinase', 304, NULL, NULL, 130850),
(130851, '1.10.510.10-FF-000163', NULL, '3-phosphoinositide-dependent protein kinase 1', 192, NULL, NULL, 130851),
(130852, '1.20.1250.20-FF-000889', NULL, '3-phenylpropionic acid transporter', 184, NULL, NULL, 130852),
(130853, '1.10.10.10-FF-001506', NULL, 'Crp/Fnr family transcriptional regulator', 73, NULL, NULL, 130853),
(130854, '2.60.40.10-FF-001942', NULL, 'Uncharacterized protein, isoform B', 92, NULL, NULL, 130854),
(130855, '3.40.50.300-FF-005467', NULL, 'PDR-like ABC transporter', 225, NULL, NULL, 130855),
(130856, '3.20.20.70-FF-000238', NULL, 'Tryptophan synthase alpha chain', 253, NULL, NULL, 130856),
(130857, '3.30.70.330-FF-001154', NULL, 'GD23003', 106, NULL, NULL, 130857),
(130858, '3.20.20.80-FF-000769', NULL, 'Chitinase, putative', 161, NULL, NULL, 130858),
(130859, '2.60.40.10-FF-000306', NULL, 'fibronectin isoform X1', 90, NULL, NULL, 130859),
(130860, '3.90.70.10-FF-000024', NULL, 'Ubiquitin carboxyl-terminal hydrolase 2', 347, NULL, NULL, 130860),
(130861, '2.30.39.10-FF-000041', NULL, 'Serpin-Z1', 138, NULL, NULL, 130861);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(130862, '3.40.50.300-FF-003814', NULL, 'DNA helicase related protein', 184, NULL, NULL, 130862),
(130863, '1.20.1250.20-FF-000945', NULL, 'MFS transporter', 202, NULL, NULL, 130863),
(130864, '3.90.640.10-FF-000096', NULL, 'Heat shock 70 kDa protein', 102, NULL, NULL, 130864),
(130865, '2.30.29.30-FF-000546', NULL, 'target of rapamycin complex 2 subunit MAPKAP1 isoform X3', 35, NULL, NULL, 130865),
(130866, '1.20.1070.10-FF-001631', NULL, 'Predicted protein', 140, NULL, NULL, 130866),
(130867, '1.20.920.10-FF-000012', NULL, 'zinc finger MYND domain-containing protein 11 isoform X1', 112, NULL, NULL, 130867),
(130868, '1.25.40.720-FF-000008', NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', 154, NULL, NULL, 130868),
(130869, '3.50.50.60-FF-000966', NULL, 'Uncharacterized protein', 91, NULL, NULL, 130869),
(130870, '3.10.20.90-FF-000391', NULL, 'Heavy chain, Unconventional Myosin', 114, NULL, NULL, 130870),
(130871, '1.25.40.700-FF-000002', NULL, 'Nup133', 127, NULL, NULL, 130871),
(130872, '3.30.310.130-FF-000025', NULL, 'Uncharacterized protein', 57, NULL, NULL, 130872),
(130873, '3.40.50.720-FF-002277', NULL, 'Uncharacterized protein', 24, NULL, NULL, 130873),
(130874, '2.130.10.10-FF-005489', NULL, 'WD repeat domain 3', 124, NULL, NULL, 130874),
(130875, '3.90.550.10-FF-000027', NULL, 'Cellulose synthase-like protein D4', 139, NULL, NULL, 130875),
(130876, '1.10.8.10-FF-000033', NULL, 'Next to BRCA1 gene 1 protein', 51, NULL, NULL, 130876),
(130877, '2.60.40.640-FF-000125', NULL, 'Uncharacterized protein', 126, NULL, NULL, 130877),
(130878, '2.60.40.10-FF-005742', NULL, NULL, 105, NULL, NULL, 130878),
(130879, '4.10.280.10-FF-000009', NULL, 'Transcription factor HES-1', 69, NULL, NULL, 130879),
(130880, '2.10.25.10-FF-000408', NULL, 'Cartilage matrix protein', 32, NULL, NULL, 130880),
(130881, '3.30.9.10-FF-000008', NULL, 'Glycerol-3-phosphate dehydrogenase', 155, NULL, NULL, 130881),
(130882, '1.10.167.10-FF-000010', NULL, 'Rho guanine nucleotide exchange factor (GEF) 11', 203, NULL, NULL, 130882),
(130883, '2.40.50.90-FF-000124', NULL, 'Uncharacterized protein', 93, NULL, NULL, 130883),
(130884, '2.40.50.90-FF-000068', NULL, 'GM14014p', 109, NULL, NULL, 130884),
(130885, '3.90.228.20-FF-000017', NULL, NULL, 117, NULL, NULL, 130885),
(130886, '3.30.460.10-FF-000045', NULL, 'Ribosomal silencing factor RsfS', 112, NULL, NULL, 130886),
(130887, '3.30.40.10-FF-001031', NULL, 'Recombination activating gene 1', 85, NULL, NULL, 130887),
(130888, '2.40.128.20-FF-000008', NULL, 'Major urinary protein', 163, NULL, NULL, 130888),
(130889, '3.10.620.30-FF-000012', NULL, 'Coiled-coil domain-containing protein lobo', 121, NULL, NULL, 130889),
(130890, '3.40.50.300-FF-001869', NULL, 'Small GTP-binding protein', 178, NULL, NULL, 130890),
(130891, '1.20.1270.60-FF-000234', NULL, 'YALI0E13904p', 234, NULL, NULL, 130891),
(130892, '3.40.50.12470-FF-000022', NULL, NULL, 144, NULL, NULL, 130892),
(130893, '1.20.1280.50-FF-000203', NULL, 'Predicted protein', 77, NULL, NULL, 130893),
(130894, '1.10.246.190-FF-000014', NULL, NULL, 55, NULL, NULL, 130894),
(130895, '1.20.1050.10-FF-000197', NULL, 'Glutathione transferase37', 38, NULL, NULL, 130895),
(130896, '1.10.630.10-FF-000380', NULL, 'Cytochrome P450 monooxygenase, putative', 349, NULL, NULL, 130896),
(130897, '3.40.50.300-FF-001780', NULL, 'Putative ATP-dependent RNA helicase', 213, NULL, NULL, 130897),
(130898, '3.60.40.10-FF-000029', NULL, 'Protein phosphatase, Mg2+/Mn2+-dependent, 1G', 138, NULL, NULL, 130898),
(130899, '2.60.120.200-FF-000531', NULL, 'Galectin', 135, NULL, NULL, 130899),
(130900, '3.80.10.10-FF-000307', NULL, 'Leucine-rich repeats and death domain-containing 1', 107, NULL, NULL, 130900),
(130901, '3.40.50.1010-FF-000182', NULL, NULL, 78, NULL, NULL, 130901),
(130902, '3.40.50.410-FF-000211', NULL, 'von Willebrand factor', 205, NULL, NULL, 130902),
(130903, '3.40.50.300-FF-003871', NULL, 'DExH-box ATP-dependent RNA helicase DExH18 mitochondrial', 92, NULL, NULL, 130903),
(130904, '3.30.420.10-FF-000301', NULL, 'Uncharacterized protein', 210, NULL, NULL, 130904); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(130905, '1.10.510.10-FF-003827', NULL, NULL, 112, NULL, NULL, 130905),
(130906, '3.30.1330.30-FF-000108', NULL, 'Growth arrest and DNA damage-inducible beta', 158, NULL, NULL, 130906),
(130907, '1.25.40.20-FF-000180', NULL, 'Ankyrin repeat and zinc finger domain containing 1', 184, NULL, NULL, 130907),
(130908, '3.20.20.80-FF-000393', NULL, 'Chitinase-like 5', 54, NULL, NULL, 130908),
(130909, '1.25.40.180-FF-000335', NULL, NULL, 156, NULL, NULL, 130909),
(130910, '2.170.300.10-FF-000027', NULL, 'Multiple epidermal growth factor-like domains 6', 126, NULL, NULL, 130910),
(130911, '1.25.40.710-FF-000005', NULL, 'Tripeptidyl peptidase 2', 139, NULL, NULL, 130911),
(130912, '3.40.30.10-FF-000338', NULL, 'Disulfide-isomerase 5-4 protein', 137, NULL, NULL, 130912),
(130913, '3.40.50.10190-FF-000309', NULL, 'Uncharacterized protein', 100, NULL, NULL, 130913),
(130914, '2.30.40.10-FF-000139', NULL, 'Bll5570 protein', 101, NULL, NULL, 130914),
(130915, '1.10.630.10-FF-000048', NULL, '3-epi-6-deoxocathasterone 23-monooxygenase CYP90D1', 451, NULL, NULL, 130915),
(130916, '2.60.40.10-FF-005781', NULL, NULL, 93, NULL, NULL, 130916),
(130917, '1.10.10.10-FF-000253', NULL, 'AT-rich interactive domain-containing protein 2', 80, NULL, NULL, 130917),
(130918, '2.60.40.820-FF-000056', NULL, 'Eomesodermin', 40, NULL, NULL, 130918),
(130919, '1.20.1070.10-FF-000844', NULL, 'Olfactory receptor', 289, NULL, NULL, 130919),
(130920, '1.10.510.10-FF-000106', NULL, 'Non-specific serine/threonine protein kinase', 120, NULL, NULL, 130920),
(130921, '3.30.160.60-FF-003780', NULL, 'AGAP007883-PA', 28, NULL, NULL, 130921),
(130922, '2.60.40.3170-FF-000011', NULL, 'Tripeptidyl-peptidase 2 homolog', 126, NULL, NULL, 130922),
(130923, '1.20.90.10-FF-000033', NULL, NULL, 135, NULL, NULL, 130923),
(130924, '2.60.40.1180-FF-000032', NULL, 'Alpha-galactosidase', 105, NULL, NULL, 130924),
(130925, '1.20.1250.20-FF-000474', NULL, 'Sugar transporter, putative', 462, NULL, NULL, 130925),
(130926, '1.10.510.10-FF-003597', NULL, NULL, 353, NULL, NULL, 130926),
(130927, '3.20.20.80-FF-000623', NULL, 'Glucan 1,3-beta-glucosidase', 133, NULL, NULL, 130927),
(130928, '1.20.1070.10-FF-000316', NULL, 'Bradykinin receptor B1', 207, NULL, NULL, 130928),
(130929, '2.30.26.10-FF-000005', NULL, 'Dihydroorotate dehydrogenase (fumarate)', 56, NULL, NULL, 130929),
(130930, '3.40.50.300-FF-002561', NULL, 'Protein kinase family protein', 159, NULL, NULL, 130930),
(130931, '2.30.30.380-FF-000029', NULL, 'Protein transport protein Sec24-like At4g32640', 75, NULL, NULL, 130931),
(130932, '3.20.20.70-FF-000620', NULL, NULL, 305, NULL, NULL, 130932),
(130933, '3.20.20.60-FF-000090', NULL, 'GD12403', 112, NULL, NULL, 130933),
(130934, '2.40.20.10-FF-000115', NULL, 'Uncharacterized protein', 73, NULL, NULL, 130934),
(130935, '1.10.8.480-FF-000009', NULL, 'rRNA adenine N(6)-methyltransferase', 98, NULL, NULL, 130935),
(130936, '1.10.150.50-FF-000141', NULL, 'Uncharacterized protein', 74, NULL, NULL, 130936),
(130937, '1.25.40.20-FF-001427', NULL, 'Uncharacterized protein', 178, NULL, NULL, 130937),
(130938, '3.30.70.100-FF-000181', NULL, NULL, 146, NULL, NULL, 130938),
(130939, '3.40.50.620-FF-000358', NULL, 'Cysteinyl-tRNA synthetase, putative', 128, NULL, NULL, 130939),
(130940, '1.20.58.740-FF-000001', NULL, 'dedicator of cytokinesis protein 9 isoform X1', 122, NULL, NULL, 130940),
(130941, '3.80.10.10-FF-004348', NULL, 'Uncharacterized protein', 382, NULL, NULL, 130941),
(130942, '2.40.50.140-FF-001218', NULL, NULL, 71, NULL, NULL, 130942),
(130943, '2.60.120.330-FF-000103', NULL, 'Predicted protein', 313, NULL, NULL, 130943),
(130944, '3.40.30.10-FF-000136', NULL, 'methionine--tRNA ligase, cytoplasmic', 98, NULL, NULL, 130944),
(130945, '1.25.40.20-FF-000410', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 115, NULL, NULL, 130945),
(130946, '1.10.8.60-FF-000531', NULL, 'Cell division control protein 48', 78, NULL, NULL, 130946),
(130947, '3.30.40.10-FF-000867', NULL, 'Pre-mRNA-splicing factor SAD1', 93, NULL, NULL, 130947);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(130948, '3.30.160.60-FF-000380', NULL, 'zinc finger protein 2 isoform X2', 28, NULL, NULL, 130948),
(130949, '3.40.50.300-FF-002033', NULL, 'tRNA delta(2)-isopentenylpyrophosphate transferase, putative', 261, NULL, NULL, 130949),
(130950, '3.40.50.2000-FF-001064', NULL, 'Uncharacterized protein', 91, NULL, NULL, 130950),
(130951, '3.30.1490.120-FF-000003', NULL, 'DNA-directed RNA polymerase I subunit RPA43', 93, NULL, NULL, 130951),
(130952, '2.30.30.40-FF-000243', NULL, 'Non-receptor tyrosine-protein kinase TNK1 isoform X1', 52, NULL, NULL, 130952),
(130953, '3.80.10.10-FF-003331', NULL, 'Uncharacterized protein', 124, NULL, NULL, 130953),
(130954, '3.30.70.330-FF-001115', NULL, 'RNP domain protein', 168, NULL, NULL, 130954),
(130955, '3.80.10.10-FF-000509', NULL, 'Tonsoku like, DNA repair protein', 130, NULL, NULL, 130955),
(130956, '3.10.580.10-FF-000182', NULL, 'Uncharacterized protein', 81, NULL, NULL, 130956),
(130957, '1.10.1200.10-FF-000071', NULL, 'Nonribosomal peptide synthase GliP2', 77, NULL, NULL, 130957),
(130958, '2.60.40.3180-FF-000014', NULL, 'Uncharacterized protein', 201, NULL, NULL, 130958),
(130959, '2.40.30.10-FF-000503', NULL, 'Ferredoxin:NADP oxidoreductase, beta subunit', 93, NULL, NULL, 130959),
(130960, '2.130.10.10-FF-003691', NULL, 'Uncharacterized protein', 180, NULL, NULL, 130960),
(130961, '3.30.420.10-FF-000245', NULL, 'RNA exonuclease 4 isoform A', 183, NULL, NULL, 130961),
(130962, '1.10.10.2670-FF-000002', NULL, 'RNA polymerase II elongation factor ELL2', 103, NULL, NULL, 130962),
(130963, '2.60.120.820-FF-000008', NULL, 'E3 ubiquitin-protein ligase rpm-1', 158, NULL, NULL, 130963),
(130964, '3.90.180.10-FF-000072', NULL, 'Crystallin zeta', 29, NULL, NULL, 130964),
(130965, '3.10.110.10-FF-000299', NULL, 'Uncharacterized protein', 100, NULL, NULL, 130965),
(130966, '3.30.70.270-FF-000147', NULL, 'DNA polymerase Y family protein', 87, NULL, NULL, 130966),
(130967, '3.40.50.720-FF-002097', NULL, 'Uncharacterized protein', 130, NULL, NULL, 130967),
(130968, '3.90.79.10-FF-000021', NULL, 'ADP-ribose pyrophosphatase, mitochondrial isoform X1', 171, NULL, NULL, 130968),
(130969, '3.40.50.300-FF-006304', NULL, 'Uncharacterized protein', 166, NULL, NULL, 130969),
(130970, '3.30.160.60-FF-002032', NULL, 'Uncharacterized protein', 30, NULL, NULL, 130970),
(130971, '3.30.70.330-FF-000749', NULL, 'eukaryotic translation initiation factor 4B isoform X1', 104, NULL, NULL, 130971),
(130972, '3.30.160.60-FF-004123', NULL, NULL, 29, NULL, NULL, 130972),
(130973, '3.40.1190.10-FF-000004', NULL, 'Dihydrofolate synthase/folylpolyglutamate synthase', 290, NULL, NULL, 130973),
(130974, '2.70.170.10-FF-000124', NULL, 'Uncharacterized protein', 85, NULL, NULL, 130974),
(130975, '2.60.40.10-FF-003325', NULL, 'Uncharacterized protein', 92, NULL, NULL, 130975),
(130976, '3.30.760.10-FF-000085', NULL, 'Uncharacterized protein', 139, NULL, NULL, 130976),
(130977, '2.40.50.960-FF-000003', NULL, 'ACD shelterin complex subunit and telomerase recruitment factor', 153, NULL, NULL, 130977),
(130978, '3.40.50.10140-FF-000087', NULL, 'Uncharacterized protein', 130, NULL, NULL, 130978),
(130979, '3.30.1520.10-FF-000078', NULL, 'Sorting nexin-17 homolog', 108, NULL, NULL, 130979),
(130980, '3.40.50.620-FF-000448', NULL, 'DUF218 domain protein', 165, NULL, NULL, 130980),
(130981, '3.30.160.60-FF-002408', NULL, 'myeloid zinc finger 1', 29, NULL, NULL, 130981),
(130982, '3.30.420.40-FF-000315', NULL, 'Actin-related protein 3', 28, NULL, NULL, 130982),
(130983, '3.40.50.2000-FF-000698', NULL, 'ADP-heptose:LPS heptosyltransferase II', 180, NULL, NULL, 130983),
(130984, '1.20.1250.20-FF-000417', NULL, 'Organic cation/carnitine transporter 1', 464, NULL, NULL, 130984),
(130985, '3.40.50.1820-FF-000357', NULL, 'Alpha/beta hydrolase', 251, NULL, NULL, 130985),
(130986, '3.20.20.70-FF-000093', NULL, 'Alpha-galactosidase', 274, NULL, NULL, 130986),
(130987, '3.90.79.20-FF-000024', NULL, 'Peroxisomal NADH pyrophosphatase NUDT12', 163, NULL, NULL, 130987),
(130988, '1.50.40.10-FF-000197', NULL, 'Ugo1p', 385, NULL, NULL, 130988);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(130989, '3.40.50.150-FF-001656', NULL, NULL, 201, NULL, NULL, 130989),
(130990, '3.30.70.260-FF-000144', NULL, 'Aspartokinase', 73, NULL, NULL, 130990),
(130991, '1.20.1690.20-FF-000001', NULL, 'CP', 73, NULL, NULL, 130991),
(130992, '3.100.10.10-FF-000052', NULL, NULL, 86, NULL, NULL, 130992),
(130993, '3.30.450.20-FF-000547', NULL, 'ATPase, putative', 97, NULL, NULL, 130993),
(130994, '1.25.40.10-FF-005224', NULL, 'Uncharacterized protein', 189, NULL, NULL, 130994),
(130995, '3.40.50.10090-FF-000049', NULL, 'Putative uroporphyrinogen-III synthase', 122, NULL, NULL, 130995),
(130996, '1.20.900.10-FF-000067', NULL, 'Rho guanyl nucleotide exchange factor, putative (AFU_orthologue AFUA_5G11890)', 239, NULL, NULL, 130996),
(130997, '1.10.560.10-FF-000110', NULL, 'Uncharacterized protein', 114, NULL, NULL, 130997),
(130998, '3.20.10.10-FF-000001', NULL, 'Branched-chain-amino-acid aminotransferase', 152, NULL, NULL, 130998),
(130999, '1.20.58.60-FF-000585', NULL, 'Plectin', 215, NULL, NULL, 130999),
(131000, '3.20.20.140-FF-000224', NULL, 'Amidohydrolase family protein', 284, NULL, NULL, 131000),
(131001, '2.170.120.40-FF-000005', NULL, 'CdaA regulatory protein CdaR', 86, NULL, NULL, 131001),
(131002, '1.25.40.10-FF-001278', NULL, 'pentatricopeptide repeat-containing protein At4g21065-like', 104, NULL, NULL, 131002),
(131003, '3.60.40.10-FF-000181', NULL, 'Protein phosphatase 1K, mitochondrial', 140, NULL, NULL, 131003),
(131004, '1.10.10.60-FF-001061', NULL, NULL, 46, NULL, NULL, 131004),
(131005, '2.170.120.30-FF-000002', NULL, 'YbbR-like domain-containing protein ybbR', 102, NULL, NULL, 131005),
(131006, '1.10.287.1490-FF-000082', NULL, 'Ift-81', 157, NULL, NULL, 131006),
(131007, '3.40.30.10-FF-001266', NULL, 'Thioredoxin domain containing 5', 84, NULL, NULL, 131007),
(131008, '3.40.50.720-FF-001170', NULL, 'CurH', 259, NULL, NULL, 131008),
(131009, '3.30.70.2740-FF-000023', NULL, 'Uncharacterized protein', 68, NULL, NULL, 131009),
(131010, '3.40.50.1820-FF-000975', NULL, 'Alpha/beta hydrolase family protein', 266, NULL, NULL, 131010),
(131011, '3.40.50.720-FF-000708', NULL, 'D-3-phosphoglycerate dehydrogenase', 116, NULL, NULL, 131011),
(131012, '1.10.555.10-FF-000075', NULL, 'Rho GTPase-activating protein', 216, NULL, NULL, 131012),
(131013, '3.20.20.70-FF-000710', NULL, NULL, 137, NULL, NULL, 131013),
(131014, '2.30.29.30-FF-001041', NULL, 'ArfGAP with GTPase domain, ankyrin repeat and PH domain 2', 134, NULL, NULL, 131014),
(131015, '1.10.1000.11-FF-000006', NULL, 'HOPM interactor 7', 121, NULL, NULL, 131015),
(131016, '2.130.10.10-FF-005490', NULL, 'Nuclear pre-mRNA splicing factor, component of splicing factor 3b', 122, NULL, NULL, 131016),
(131017, '3.40.50.2300-FF-001125', NULL, NULL, 119, NULL, NULL, 131017),
(131018, '1.10.510.10-FF-002523', NULL, 'Probable serine/threonine-protein kinase DDB_G0280111', 313, NULL, NULL, 131018),
(131019, '3.40.50.300-FF-000324', NULL, 'pre-mRNA-splicing factor ATP-dependent RNA helicase DHX15', 229, NULL, NULL, 131019),
(131020, '3.30.160.60-FF-001684', NULL, 'zinc finger protein 33B-like', 28, NULL, NULL, 131020),
(131021, '1.25.40.20-FF-001484', NULL, 'Uncharacterized protein', 94, NULL, NULL, 131021),
(131022, '2.130.10.10-FF-001690', NULL, 'Uncharacterized protein, isoform A', 182, NULL, NULL, 131022),
(131023, '2.60.40.1180-FF-000122', NULL, 'Alpha-glucosidase', 72, NULL, NULL, 131023),
(131024, '1.10.132.20-FF-000017', NULL, 'Ribosome-recycling factor chloroplastic', 107, NULL, NULL, 131024),
(131025, '1.25.10.10-FF-000017', NULL, '26S proteasome non-ATPase regulatory subunit 1', 442, NULL, NULL, 131025),
(131026, '1.20.910.10-FF-000039', NULL, 'Chromosome 1, whole genome shotgun sequence', 238, NULL, NULL, 131026),
(131027, '1.20.58.340-FF-000004', NULL, 'Magnesium transport protein CorA', 72, NULL, NULL, 131027),
(131028, '3.40.50.2300-FF-001272', NULL, NULL, 183, NULL, NULL, 131028),
(131029, '1.10.510.10-FF-001091', NULL, 'STE family protein kinase', 263, NULL, NULL, 131029),
(131030, '3.30.70.260-FF-000088', NULL, 'Aspartokinase', 73, NULL, NULL, 131030);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(131031, '1.10.472.80-FF-000066', NULL, 'Uncharacterized protein', 144, NULL, NULL, 131031),
(131032, '2.10.220.10-FF-000108', NULL, 'Fraser extracellular matrix complex subunit 1', 52, NULL, NULL, 131032),
(131033, '3.80.10.10-FF-001622', NULL, 'Leucine-rich repeat-containing protein egg-6', 198, NULL, NULL, 131033),
(131034, '3.40.30.10-FF-000810', NULL, 'Glutathione S-transferase epsilon', 69, NULL, NULL, 131034),
(131035, '1.25.10.10-FF-001743', NULL, 'Uncharacterized protein', 999, NULL, NULL, 131035),
(131036, '3.40.33.10-FF-000053', NULL, 'Uncharacterized protein', 180, NULL, NULL, 131036),
(131037, '3.30.70.250-FF-000028', NULL, NULL, 70, NULL, NULL, 131037),
(131038, '1.10.1710.10-FF-000003', NULL, 'RNA chaperone ProQ', 117, NULL, NULL, 131038),
(131039, '3.40.470.10-FF-000021', NULL, 'Type-4 uracil-DNA glycosylase', 189, NULL, NULL, 131039),
(131040, '3.30.160.60-FF-004090', NULL, NULL, 26, NULL, NULL, 131040),
(131041, '1.25.40.10-FF-002728', NULL, 'YALI0D23573p', 282, NULL, NULL, 131041),
(131042, '2.60.40.60-FF-000153', NULL, 'Dachsous cadherin-related 2', 101, NULL, NULL, 131042),
(131043, '3.80.10.10-FF-001999', NULL, 'Receptor like protein 45', 174, NULL, NULL, 131043),
(131044, '1.20.1740.10-FF-000025', NULL, 'High-affinity methionine permease', 454, NULL, NULL, 131044),
(131045, '2.20.70.10-FF-000198', NULL, 'transcriptional coactivator YAP1 isoform X2', 48, NULL, NULL, 131045),
(131046, '3.90.190.10-FF-000460', NULL, 'Uncharacterized protein', 202, NULL, NULL, 131046),
(131047, '3.40.50.10090-FF-000050', NULL, 'Uncharacterized protein', 120, NULL, NULL, 131047),
(131048, '3.90.190.10-FF-000218', NULL, 'Protein tyrosine phosphatase A', 273, NULL, NULL, 131048),
(131049, '3.30.70.1820-FF-000017', NULL, NULL, 88, NULL, NULL, 131049),
(131050, '2.40.160.120-FF-000053', NULL, 'Oxysterol binding protein 9, putative', 77, NULL, NULL, 131050),
(131051, '3.40.50.2000-FF-000934', NULL, 'Macrolide glycosyltransferase', 149, NULL, NULL, 131051),
(131052, '2.130.10.10-FF-005961', NULL, 'Uncharacterized protein', 245, NULL, NULL, 131052),
(131053, '2.130.10.30-FF-000116', NULL, 'Uncharacterized protein', 249, NULL, NULL, 131053),
(131054, '3.30.200.20-FF-001962', NULL, 'Uncharacterized protein', 104, NULL, NULL, 131054),
(131055, '1.20.5.1430-FF-000021', NULL, 'Uncharacterized protein', 75, NULL, NULL, 131055),
(131056, '3.30.160.60-FF-005427', NULL, NULL, 36, NULL, NULL, 131056),
(131057, '3.30.2170.10-FF-000011', NULL, 'Endonuclease V protein-like', 172, NULL, NULL, 131057),
(131058, '3.30.505.10-FF-000240', NULL, NULL, 74, NULL, NULL, 131058),
(131059, '1.10.287.110-FF-000173', NULL, 'DnaJ domain protein', 121, NULL, NULL, 131059),
(131060, '3.50.50.60-FF-001422', NULL, 'Predicted protein', 120, NULL, NULL, 131060),
(131061, '3.10.20.310-FF-000024', NULL, 'Outer membrane protein assembly factor BamA', 74, NULL, NULL, 131061),
(131062, '1.10.150.20-FF-000267', NULL, 'Uncharacterized protein', 60, NULL, NULL, 131062),
(131063, '2.130.10.10-FF-000110', NULL, 'striatin-3 isoform X2', 101, NULL, NULL, 131063),
(131064, '1.20.1250.20-FF-002183', NULL, 'Uncharacterized protein', 166, NULL, NULL, 131064),
(131065, '3.40.50.300-FF-007378', NULL, 'AFR093Wp', 163, NULL, NULL, 131065),
(131066, '3.40.50.2000-FF-001007', NULL, 'Glycosyltransferase', 250, NULL, NULL, 131066),
(131067, '2.40.30.20-FF-000001', NULL, 'ATP synthase subunit alpha', 93, NULL, NULL, 131067),
(131068, '2.60.120.1540-FF-000005', NULL, 'C3 and PZP like, alpha-2-macroglobulin domain containing 8', 89, NULL, NULL, 131068),
(131069, '3.90.190.10-FF-000550', NULL, 'Uncharacterized protein', 124, NULL, NULL, 131069),
(131070, '1.20.5.110-FF-000043', NULL, 'Protein transport protein sec9', 64, NULL, NULL, 131070),
(131071, '3.30.160.60-FF-000290', NULL, 'Zinc finger protein 697 isoform X1', 29, NULL, NULL, 131071),
(131072, '1.10.8.60-FF-000295', NULL, 'Peroxisomal biogenesis factor 1', 83, NULL, NULL, 131072),
(131073, '1.25.40.10-FF-003280', NULL, 'Pentatricopeptide repeat-containing protein At3g14730', 134, NULL, NULL, 131073);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(131074, '1.10.472.80-FF-000009', NULL, 'TBC1 domain family member 13', 120, NULL, NULL, 131074),
(131075, '1.10.8.60-FF-000385', NULL, 'Probable stage V sporulation protein K-putative ATPase of the AAA family', 88, NULL, NULL, 131075),
(131076, '2.60.40.150-FF-000304', NULL, 'C2 domain-containing protein', 130, NULL, NULL, 131076),
(131077, '3.90.550.10-FF-000679', NULL, 'Fringe-related protein', 89, NULL, NULL, 131077),
(131078, '3.40.50.720-FF-001023', NULL, 'Glyceraldehyde 3-phosphate dehydrogenase', 170, NULL, NULL, 131078),
(131079, '1.25.40.20-FF-001899', NULL, 'Uncharacterized protein', 107, NULL, NULL, 131079),
(131080, '2.60.40.10-FF-003269', NULL, 'Interleukin 13 receptor, alpha 2', 96, NULL, NULL, 131080),
(131081, '1.10.472.80-FF-000156', NULL, 'Uncharacterized protein', 118, NULL, NULL, 131081),
(131082, '1.10.555.10-FF-000036', NULL, 'T-cell activation Rho GTPase-activating protein', 201, NULL, NULL, 131082),
(131083, '3.30.160.60-FF-000048', NULL, 'GLI family zinc finger 3', 34, NULL, NULL, 131083),
(131084, '1.25.40.10-FF-004858', NULL, 'Uncharacterized protein', 128, NULL, NULL, 131084),
(131085, '2.130.10.10-FF-001072', NULL, 'Transcription factor unc-37', 330, NULL, NULL, 131085),
(131086, '2.130.10.10-FF-001448', NULL, 'WD domain, G-beta repeat-containing protein', 276, NULL, NULL, 131086),
(131087, '3.40.120.10-FF-000034', NULL, 'Phosphomannomutase', 90, NULL, NULL, 131087),
(131088, '2.60.40.770-FF-000018', NULL, 'Putative phosphatidylglycerol/phosphatidylinositol transfer protein 3', 130, NULL, NULL, 131088),
(131089, '3.40.50.720-FF-000950', NULL, 'C-terminal binding protein AN', 195, NULL, NULL, 131089),
(131090, '2.60.120.330-FF-000047', NULL, 'Similar to oxidoreductase', 329, NULL, NULL, 131090),
(131091, '1.10.20.10-FF-000315', NULL, NULL, 137, NULL, NULL, 131091),
(131092, '3.40.710.10-FF-000118', NULL, 'D-alanyl-D-alanine carboxypeptidase', 216, NULL, NULL, 131092),
(131093, '1.10.8.60-FF-000441', NULL, 'Peroxisome biogenesis protein 6', 70, NULL, NULL, 131093),
(131094, '1.10.555.10-FF-000221', NULL, NULL, 192, NULL, NULL, 131094),
(131095, '2.40.50.100-FF-000127', NULL, 'Sugar ABC transporter, ATP-binding protein', 34, NULL, NULL, 131095),
(131096, '3.40.50.2300-FF-001182', NULL, NULL, 60, NULL, NULL, 131096),
(131097, '1.25.40.10-FF-001481', NULL, 'Os01g0176300 protein', 183, NULL, NULL, 131097),
(131098, '2.60.300.12-FF-000022', NULL, NULL, 110, NULL, NULL, 131098),
(131099, '3.30.70.330-FF-002992', NULL, NULL, 86, NULL, NULL, 131099),
(131100, '1.25.40.10-FF-001424', NULL, 'Shc1p', 267, NULL, NULL, 131100),
(131101, '1.20.970.10-FF-000015', NULL, 'Anthranilate phosphoribosyltransferase', 70, NULL, NULL, 131101),
(131102, '3.10.450.10-FF-000026', NULL, 'CST8 isoform 2', 118, NULL, NULL, 131102),
(131103, '3.40.1110.10-FF-000084', NULL, 'Probable copper-transporting ATPase HMA5', 79, NULL, NULL, 131103),
(131104, '3.40.710.10-FF-000175', NULL, '6-aminohexanoate-dimer hydrolase', 236, NULL, NULL, 131104),
(131105, '3.90.190.10-FF-000308', NULL, 'Uncharacterized protein', 276, NULL, NULL, 131105),
(131106, '1.10.287.130-FF-000179', NULL, 'GAF sensor signal transduction histidine kinase', 77, NULL, NULL, 131106),
(131107, '2.60.40.10-FF-004758', NULL, NULL, 99, NULL, NULL, 131107),
(131108, '3.40.50.140-FF-000017', NULL, 'DNA topoisomerase (TopA)', 153, NULL, NULL, 131108),
(131109, '1.25.40.20-FF-000500', NULL, 'ankyrin repeat and KH domain-containing protein 1 isoform X3', 87, NULL, NULL, 131109),
(131110, '3.40.250.10-FF-000038', NULL, 'Rhodanese-like domain-containing protein 9, chloroplastic', 143, NULL, NULL, 131110),
(131111, '3.40.50.620-FF-000919', NULL, 'Cysteine--tRNA ligase', 289, NULL, NULL, 131111),
(131112, '3.40.50.150-FF-000262', NULL, 'S-adenosyl-L-methionine-dependent methyltransferases superfamily protein', 255, NULL, NULL, 131112),
(131113, '2.60.40.10-FF-001324', NULL, 'Cell surface glycoprotein MUC18', 69, NULL, NULL, 131113),
(131114, '3.40.30.10-FF-000900', NULL, 'UBX domain-containing protein 3', 185, NULL, NULL, 131114),
(131115, '3.30.1130.10-FF-000008', NULL, 'GTP cyclohydrolase 1', 132, NULL, NULL, 131115);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(131116, '3.10.580.10-FF-000215', NULL, 'Voltage-gated chloride channel, CBS domain pair-containing, putative', 137, NULL, NULL, 131116),
(131117, '2.130.10.10-FF-005343', NULL, 'Uncharacterized protein', 182, NULL, NULL, 131117),
(131118, '3.20.20.140-FF-000134', NULL, 'Inactive deaminase YBR284W', 198, NULL, NULL, 131118),
(131119, '3.20.20.80-FF-000713', NULL, 'Uncharacterized protein', 185, NULL, NULL, 131119),
(131120, '3.60.40.10-FF-000271', NULL, 'Protein phosphatase PTC7-like protein fig', 272, NULL, NULL, 131120),
(131121, '3.30.160.60-FF-001537', NULL, 'Tramtrack, isoform C', 30, NULL, NULL, 131121),
(131122, '3.20.20.80-FF-000770', NULL, 'Predicted protein', 132, NULL, NULL, 131122),
(131123, '3.80.10.10-FF-003421', NULL, 'Uncharacterized protein', 78, NULL, NULL, 131123),
(131124, '1.10.1370.10-FF-000049', NULL, 'Uncharacterized protein', 102, NULL, NULL, 131124),
(131125, '2.10.25.10-FF-001521', NULL, 'Fibulin 1', 49, NULL, NULL, 131125),
(131126, '3.10.110.10-FF-000012', NULL, 'Ubiquitin-conjugating enzyme E2 variant 2', 146, NULL, NULL, 131126),
(131127, '3.90.1150.10-FF-000176', NULL, '4-aminobutyrate aminotransferase', 148, NULL, NULL, 131127),
(131128, '1.20.120.350-FF-000029', NULL, 'Potassium voltage-gated channel subfamily S member 2', 152, NULL, NULL, 131128),
(131129, '3.40.1690.20-FF-000028', NULL, 'Uncharacterized protein', 45, NULL, NULL, 131129),
(131130, '2.30.90.10-FF-000002', NULL, 'GM14327', 44, NULL, NULL, 131130),
(131131, '3.90.228.10-FF-000071', NULL, 'Poly [ADP-ribose] polymerase', 215, NULL, NULL, 131131),
(131132, '1.10.3500.10-FF-000021', NULL, 'Transcription elongation factor Spt6', 282, NULL, NULL, 131132),
(131133, '3.30.40.10-FF-001087', NULL, 'Uncharacterized protein', 91, NULL, NULL, 131133),
(131134, '2.40.270.10-FF-000021', NULL, 'Late expression factor 8', 93, NULL, NULL, 131134),
(131135, '2.130.10.10-FF-004938', NULL, 'Uncharacterized protein', 102, NULL, NULL, 131135),
(131136, '3.30.1150.10-FF-000010', NULL, 'Energy transducer TonB', 94, NULL, NULL, 131136),
(131137, '2.40.50.360-FF-000008', NULL, 'RuvB-like helicase', 22, NULL, NULL, 131137),
(131138, '3.40.50.2300-FF-001215', NULL, NULL, 21, NULL, NULL, 131138),
(131139, '2.10.70.10-FF-000193', NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', 59, NULL, NULL, 131139),
(131140, '3.40.33.10-FF-000143', NULL, 'Uncharacterized protein', 146, NULL, NULL, 131140),
(131141, '1.25.40.1040-FF-000056', NULL, 'Uncharacterized protein', 238, NULL, NULL, 131141),
(131142, '3.40.50.300-FF-000234', NULL, 'DNA helicase', 348, NULL, NULL, 131142),
(131143, '1.10.287.370-FF-000054', NULL, 'Prefoldin subunit family protein', 110, NULL, NULL, 131143),
(131144, '3.30.160.60-FF-001627', NULL, 'Zinc finger protein 655', 28, NULL, NULL, 131144),
(131145, '2.60.40.1730-FF-000040', NULL, 'Protein CBG20905', 217, NULL, NULL, 131145),
(131146, '3.30.1740.20-FF-000007', NULL, '40S ribosomal protein S26', 101, NULL, NULL, 131146),
(131147, '3.30.1370.110-FF-000013', NULL, 'Endonuclease MutS2', 123, NULL, NULL, 131147),
(131148, '3.30.1370.120-FF-000016', NULL, 'Type II secretion system protein D', 79, NULL, NULL, 131148),
(131149, '1.10.8.10-FF-000090', NULL, 'Si:dkey-19e4.5', 45, NULL, NULL, 131149),
(131150, '3.90.1720.10-FF-000028', NULL, 'Secreted antigen GbpB/SagA/PcsB peptidoglycan hydrolase', 96, NULL, NULL, 131150),
(131151, '3.40.1800.20-FF-000027', NULL, 'Dorsal interacting protein 1, isoform B', 83, NULL, NULL, 131151),
(131152, '3.40.50.720-FF-001731', NULL, '4-hydroxy-tetrahydrodipicolinate reductase', 141, NULL, NULL, 131152),
(131153, '4.10.1240.10-FF-000043', NULL, 'Parathyroid hormone 1 receptor', 70, NULL, NULL, 131153),
(131154, '3.30.1740.10-FF-000004', NULL, 'Poly [ADP-ribose] polymerase', 102, NULL, NULL, 131154),
(131155, '1.25.40.10-FF-005168', NULL, 'Uncharacterized protein', 74, NULL, NULL, 131155),
(131156, '3.20.20.80-FF-000803', NULL, 'Glutamate carboxypeptidase, putative', 142, NULL, NULL, 131156),
(131157, '3.30.565.10-FF-000125', NULL, 'Phytochrome', 163, NULL, NULL, 131157);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(131158, '3.40.50.300-FF-005613', NULL, 'Dynein heavy chain 14, axonemal', 69, NULL, NULL, 131158),
(131159, '3.40.50.1460-FF-000053', NULL, 'Uncharacterized protein', 137, NULL, NULL, 131159),
(131160, '1.20.1560.10-FF-000281', NULL, 'Uncharacterized protein', 319, NULL, NULL, 131160),
(131161, '2.40.420.20-FF-000058', NULL, 'Acriflavin resistance protein E', 92, NULL, NULL, 131161),
(131162, '1.50.10.100-FF-000003', NULL, 'Secreted protein', 241, NULL, NULL, 131162),
(131163, '3.40.250.10-FF-000190', NULL, 'Uncharacterized protein', 106, NULL, NULL, 131163),
(131164, '3.40.50.150-FF-001712', NULL, NULL, 235, NULL, NULL, 131164),
(131165, '1.10.510.10-FF-001742', NULL, 'MAP kinase kinase kinase win1', 189, NULL, NULL, 131165),
(131166, '3.20.20.70-FF-000800', NULL, NULL, 185, NULL, NULL, 131166),
(131167, '3.90.1800.10-FF-000029', NULL, 'Zgc:66298 protein', 98, NULL, NULL, 131167),
(131168, '3.30.450.40-FF-000143', NULL, 'Phosphodiesterase', 155, NULL, NULL, 131168),
(131169, '3.40.50.720-FF-000860', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 176, NULL, NULL, 131169),
(131170, '3.40.50.2300-FF-000962', NULL, NULL, 220, NULL, NULL, 131170),
(131171, '3.30.1660.10-FF-000003', NULL, 'DUF1471 domain-containing protein', 63, NULL, NULL, 131171),
(131172, '3.40.50.720-FF-001203', NULL, 'NADH-ubiquinone oxidoreductase family protein', 255, NULL, NULL, 131172),
(131173, '3.10.20.30-FF-000070', NULL, 'Protein FeSII', 122, NULL, NULL, 131173),
(131174, '2.130.10.10-FF-000054', NULL, 'Putative WD repeat-containing protein 48', 253, NULL, NULL, 131174),
(131175, '3.80.10.10-FF-002926', NULL, 'Uncharacterized protein', 204, NULL, NULL, 131175),
(131176, '2.130.10.10-FF-000144', NULL, 'DDB1- and CUL4-associated factor 8', 333, NULL, NULL, 131176),
(131177, '3.40.50.720-FF-001113', NULL, 'Erythronate-4-phosphate dehydrogenase', 161, NULL, NULL, 131177),
(131178, '3.40.190.10-FF-000977', NULL, 'Putative binding protein HI_0213', 106, NULL, NULL, 131178),
(131179, '1.20.1560.10-FF-000932', NULL, 'Uncharacterized protein', 19, NULL, NULL, 131179),
(131180, '4.10.280.10-FF-000071', NULL, 'spermatogenesis- and oogenesis-specific basic helix-loop-helix-containing protein 2', 62, NULL, NULL, 131180),
(131181, '3.40.1110.10-FF-000140', NULL, 'Copper-translocating P-type ATPase', 120, NULL, NULL, 131181),
(131182, '2.130.10.10-FF-005433', NULL, 'Uncharacterized protein', 222, NULL, NULL, 131182),
(131183, '3.30.300.30-FF-000129', NULL, 'AMP-binding enzyme, putative', 108, NULL, NULL, 131183),
(131184, '3.30.1370.240-FF-000001', NULL, 'phenylalanine--tRNA ligase alpha subunit', 92, NULL, NULL, 131184),
(131185, '1.20.1260.100-FF-000015', NULL, NULL, 28, NULL, NULL, 131185),
(131186, '3.80.10.10-FF-002550', NULL, 'Protein CBG01587', 150, NULL, NULL, 131186),
(131187, '3.30.1370.100-FF-000010', NULL, 'DNA mismatch repair protein MutL', 96, NULL, NULL, 131187),
(131188, '2.150.10.10-FF-000008', NULL, 'Adhesin', 100, NULL, NULL, 131188),
(131189, '1.20.58.340-FF-000061', NULL, 'Mitochondrial inner membrane magnesium transporter MRS2', 173, NULL, NULL, 131189),
(131190, '3.40.50.300-FF-001870', NULL, 'SNF2 family helicase/ATPase, putative', 212, NULL, NULL, 131190),
(131191, '3.30.160.60-FF-001717', NULL, 'Zinc finger and SCAN domain containing 5A', 25, NULL, NULL, 131191),
(131192, '4.10.280.10-FF-000161', NULL, 'Predicted protein', 72, NULL, NULL, 131192),
(131193, '1.25.10.10-FF-001653', NULL, 'sister chromatid cohesion protein PDS5 homolog A-B-like isoform X1', 383, NULL, NULL, 131193),
(131194, '3.30.70.330-FF-003155', NULL, NULL, 79, NULL, NULL, 131194),
(131195, '3.40.190.10-FF-000269', NULL, 'Transcriptional regulator', 104, NULL, NULL, 131195),
(131196, '1.25.10.10-FF-001035', NULL, 'Binding protein', 158, NULL, NULL, 131196),
(131197, '3.40.50.300-FF-003578', NULL, 'Gluconokinase', 220, NULL, NULL, 131197),
(131198, '3.80.10.10-FF-002308', NULL, 'Uncharacterized protein', 187, NULL, NULL, 131198),
(131199, '3.40.50.10130-FF-000045', NULL, 'Uncharacterized protein', 109, NULL, NULL, 131199),
(131200, '1.25.40.90-FF-000116', NULL, 'Uncharacterized protein', 149, NULL, NULL, 131200);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(131201, '1.10.8.10-FF-000123', NULL, 'Related to DSK2-ubiquitin-like protein', 58, NULL, NULL, 131201),
(131202, '2.130.10.10-FF-003488', NULL, 'Uncharacterized protein', 286, NULL, NULL, 131202),
(131203, '1.10.1900.50-FF-000001', NULL, 'NLR family CARD domain-containing protein 4', 57, NULL, NULL, 131203),
(131204, '1.25.40.10-FF-005078', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 94, NULL, NULL, 131204),
(131205, '2.120.10.30-FF-000111', NULL, 'EGF-like domain containing protein', 329, NULL, NULL, 131205),
(131206, '1.10.132.10-FF-000014', NULL, NULL, 130, NULL, NULL, 131206),
(131207, '1.10.8.60-FF-000351', NULL, 'Lon protease homolog', 89, NULL, NULL, 131207),
(131208, '3.40.50.10140-FF-000048', NULL, 'Uncharacterized protein', 151, NULL, NULL, 131208),
(131209, '3.40.50.10810-FF-000041', NULL, 'Chromatin remodeling protein', 250, NULL, NULL, 131209),
(131210, '1.10.10.60-FF-000043', NULL, 'Hepatocyte nuclear factor 1-beta', 95, NULL, NULL, 131210),
(131211, '1.10.287.3240-FF-000039', NULL, 'Uncharacterized protein', 71, NULL, NULL, 131211),
(131212, '1.10.510.10-FF-001652', NULL, 'SR protein kinase, isoform D', 175, NULL, NULL, 131212),
(131213, '3.40.50.300-FF-005580', NULL, 'SNF2 histone linker PHD RING helicase, E3 ubiquitin protein ligase', 143, NULL, NULL, 131213),
(131214, '2.40.30.130-FF-000014', NULL, 'Alanine--tRNA ligase', 86, NULL, NULL, 131214),
(131215, '3.40.50.2000-FF-000844', NULL, 'Uncharacterized protein', 252, NULL, NULL, 131215),
(131216, '2.60.40.10-FF-003179', NULL, 'GM15804', 113, NULL, NULL, 131216),
(131217, '3.50.50.60-FF-001332', NULL, 'Uncharacterized protein', 90, NULL, NULL, 131217),
(131218, '1.10.287.70-FF-000784', NULL, 'Uncharacterized protein', 78, NULL, NULL, 131218),
(131219, '3.40.1180.10-FF-000032', NULL, 'Alkyl transferase', 234, NULL, NULL, 131219),
(131220, '3.30.200.20-FF-001344', NULL, NULL, 50, NULL, NULL, 131220),
(131221, '3.30.750.24-FF-000148', NULL, 'Uncharacterized protein', 139, NULL, NULL, 131221),
(131222, '1.10.1740.10-FF-000038', NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', 83, NULL, NULL, 131222),
(131223, '1.20.1740.10-FF-000137', NULL, 'Protein CBR-AAT-4', 232, NULL, NULL, 131223),
(131224, '2.40.30.180-FF-000012', NULL, 'Uncharacterized protein', 69, NULL, NULL, 131224),
(131225, '3.10.490.20-FF-000032', NULL, 'Cytoplasmic dynein 2 heavy chain 1', 135, NULL, NULL, 131225),
(131226, '3.10.580.10-FF-000148', NULL, 'Os04g0644800 protein', 95, NULL, NULL, 131226),
(131227, '3.40.50.300-FF-000436', NULL, 'ATP binding cassette subfamily A member 9', 262, NULL, NULL, 131227),
(131228, '1.20.58.60-FF-000759', NULL, 'Uncharacterized protein', 318, NULL, NULL, 131228),
(131229, '2.30.30.230-FF-000007', NULL, 'Fumarylacetoacetase', 122, NULL, NULL, 131229),
(131230, '3.20.20.80-FF-000483', NULL, 'Maltase A2', 307, NULL, NULL, 131230),
(131231, '3.40.50.1820-FF-000863', NULL, 'GPI inositol-deacylase', 267, NULL, NULL, 131231),
(131232, '1.25.40.10-FF-003605', NULL, 'SET and MYND domain containing, class 4, member 1, isoform B', 128, NULL, NULL, 131232),
(131233, '3.40.50.1000-FF-000151', NULL, 'Copper-translocating P-type ATPase', 137, NULL, NULL, 131233),
(131234, '3.40.50.880-FF-000121', NULL, 'Glutamine amidotransferase', 197, NULL, NULL, 131234),
(131235, '1.25.40.10-FF-003543', NULL, 'AAA ATPase domain protein', 95, NULL, NULL, 131235),
(131236, '3.40.50.300-FF-005175', NULL, 'Cytidylate kinase', 220, NULL, NULL, 131236),
(131237, '3.10.110.10-FF-000220', NULL, 'Predicted protein', 129, NULL, NULL, 131237),
(131238, '3.20.10.10-FF-000057', NULL, 'Predicted protein', 124, NULL, NULL, 131238),
(131239, '1.10.520.10-FF-000012', NULL, 'Peroxidase', 154, NULL, NULL, 131239),
(131240, '3.20.20.220-FF-000012', NULL, 'Proline dehydrogenase', 275, NULL, NULL, 131240),
(131241, '2.60.40.10-FF-001594', NULL, 'Immunoglobulin heavy variable 9-4', 98, NULL, NULL, 131241),
(131242, '3.40.50.10380-FF-000007', NULL, 'Malic enzyme', 249, NULL, NULL, 131242),
(131243, '2.40.10.10-FF-000002', NULL, 'Transmembrane protease serine', 124, NULL, NULL, 131243); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(131244, '3.40.50.1460-FF-000092', NULL, 'Uncharacterized protein', 189, NULL, NULL, 131244),
(131245, '1.10.630.10-FF-000615', NULL, 'Uncharacterized protein', 252, NULL, NULL, 131245),
(131246, '3.30.300.160-FF-000009', NULL, 'General secretion pathway protein E', 87, NULL, NULL, 131246),
(131247, '3.40.50.1010-FF-000154', NULL, NULL, 71, NULL, NULL, 131247),
(131248, '1.10.287.3280-FF-000001', NULL, 'DNA damage-binding protein 2', 39, NULL, NULL, 131248),
(131249, '1.10.510.10-FF-001596', NULL, 'Protein kinase, putative', 215, NULL, NULL, 131249),
(131250, '1.10.4050.10-FF-000003', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 113, NULL, NULL, 131250),
(131251, '4.10.400.10-FF-000340', NULL, 'Uncharacterized protein', 37, NULL, NULL, 131251),
(131252, '3.40.50.800-FF-000092', NULL, 'Threonyl-tRNA synthetase', 116, NULL, NULL, 131252),
(131253, '3.30.160.60-FF-000615', NULL, 'Zinc finger protein 536', 32, NULL, NULL, 131253),
(131254, '1.50.40.10-FF-000219', NULL, 'Putative mitochondrial carrier protein', 252, NULL, NULL, 131254),
(131255, '1.20.1070.10-FF-002109', NULL, 'Uncharacterized protein', 135, NULL, NULL, 131255),
(131256, '2.130.10.10-FF-001572', NULL, 'Zgc:171857', 200, NULL, NULL, 131256),
(131257, '2.30.30.380-FF-000024', NULL, 'Vacuolar protein sorting protein (Vps36), putative', 66, NULL, NULL, 131257),
(131258, '3.90.640.10-FF-000186', NULL, 'Actin7-2 (Actin-related protein)', 100, NULL, NULL, 131258),
(131259, '3.30.70.1230-FF-000115', NULL, 'Soluble guanylate cyclase gcy-35', 163, NULL, NULL, 131259),
(131260, '3.80.10.10-FF-004343', NULL, 'Protein phosphatase 2C, putative', 189, NULL, NULL, 131260),
(131261, '3.20.20.70-FF-000480', NULL, 'Lipoyl synthase 2', 218, NULL, NULL, 131261),
(131262, '3.40.50.740-FF-000012', NULL, 'NADH dehydrogenase [ubiquinone] iron-sulfur protein 1 mitochondrial', 124, NULL, NULL, 131262),
(131263, '1.25.10.10-FF-003036', NULL, 'Uncharacterized protein', 300, NULL, NULL, 131263),
(131264, '1.10.10.60-FF-000133', NULL, 'zinc fingers and homeoboxes protein 3', 68, NULL, NULL, 131264),
(131265, '3.30.70.270-FF-000265', NULL, NULL, 88, NULL, NULL, 131265),
(131266, '3.40.50.2300-FF-000288', NULL, 'Uncharacterized protein', 302, NULL, NULL, 131266),
(131267, '3.30.590.20-FF-000001', NULL, 'Glutamate--cysteine ligase', 501, NULL, NULL, 131267),
(131268, '1.10.10.2330-FF-000018', NULL, NULL, 55, NULL, NULL, 131268),
(131269, '3.90.1200.10-FF-000028', NULL, 'Homoserine kinase', 200, NULL, NULL, 131269),
(131270, '3.40.190.10-FF-000887', NULL, 'Uncharacterized protein', 14, NULL, NULL, 131270),
(131271, '3.30.9.10-FF-000211', NULL, 'Dehydrogenase', 47, NULL, NULL, 131271),
(131272, '3.80.10.10-FF-002640', NULL, 'F-box family protein', 87, NULL, NULL, 131272),
(131273, '3.90.1150.10-FF-000389', NULL, 'Cc2-5', 18, NULL, NULL, 131273),
(131274, '3.60.21.10-FF-000322', NULL, 'Uncharacterized protein', 303, NULL, NULL, 131274),
(131275, '3.40.50.300-FF-006164', NULL, 'Uncharacterized protein', 125, NULL, NULL, 131275),
(131276, '2.10.25.10-FF-000706', NULL, 'Heparan sulfate proteoglycan 2', 49, NULL, NULL, 131276),
(131277, '3.60.10.10-FF-000179', NULL, 'Uncharacterized protein', 328, NULL, NULL, 131277),
(131278, '1.10.10.10-FF-001686', NULL, 'Exopolysaccharide II synthesis transcriptional activator ExpG', 150, NULL, NULL, 131278),
(131279, '3.30.420.40-FF-000967', NULL, 'ADR128Cp', 100, NULL, NULL, 131279),
(131280, '1.20.5.170-FF-000156', NULL, 'Uncharacterized protein', 55, NULL, NULL, 131280),
(131281, '1.10.472.80-FF-000010', NULL, 'Putative TBC1 domain family member 5', 123, NULL, NULL, 131281),
(131282, '3.40.50.300-FF-007524', NULL, 'Uncharacterized protein', 210, NULL, NULL, 131282),
(131283, '3.40.50.150-FF-000144', NULL, 'Putative methyltransferase, chloroplastic', 212, NULL, NULL, 131283),
(131284, '2.30.30.140-FF-000183', NULL, 'GD19236', 96, NULL, NULL, 131284),
(131285, '1.10.10.10-FF-001911', NULL, 'Protein let-99', 103, NULL, NULL, 131285),
(131286, '1.25.40.10-FF-005308', NULL, 'Pentatricopeptide repeat-containing protein', 126, NULL, NULL, 131286);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(131287, '2.60.40.10-FF-000071', NULL, 'Plexin A2', 139, NULL, NULL, 131287),
(131288, '3.10.450.350-FF-000019', NULL, 'Family M23 zinc metallopeptidase with OapA domain', 90, NULL, NULL, 131288),
(131289, '2.40.50.140-FF-000639', NULL, 'ATP-dependent DNA helicase RecG', 100, NULL, NULL, 131289),
(131290, '1.20.1250.20-FF-000507', NULL, 'Solute carrier organic anion transporter family member', 382, NULL, NULL, 131290),
(131291, '2.20.28.10-FF-000010', NULL, 'Anaerobic nitric oxide reductase flavorubredoxin', 57, NULL, NULL, 131291),
(131292, '3.60.90.10-FF-000004', NULL, 'S-adenosylmethionine decarboxylase proenzyme', 267, NULL, NULL, 131292),
(131293, '3.40.50.300-FF-001538', NULL, 'Adenylate kinase 8', 207, NULL, NULL, 131293),
(131294, '1.10.20.10-FF-000102', NULL, 'Histone H3-like centromeric protein CSE4', 142, NULL, NULL, 131294),
(131295, '3.80.10.10-FF-004017', NULL, 'Uncharacterized protein', 147, NULL, NULL, 131295),
(131296, '3.30.160.20-FF-000183', NULL, 'Uncharacterized protein', 76, NULL, NULL, 131296),
(131297, '3.30.1360.120-FF-000019', NULL, 'Sarcosine oxidase gamma subunit', 86, NULL, NULL, 131297),
(131298, '1.10.3380.10-FF-000022', NULL, 'Putative RNA helicase', 152, NULL, NULL, 131298),
(131299, '1.25.10.10-FF-000231', NULL, 'serine/threonine-protein kinase ULK4 isoform X1', 209, NULL, NULL, 131299),
(131300, '2.130.10.10-FF-003696', NULL, 'Uncharacterized protein', 239, NULL, NULL, 131300),
(131301, '3.90.190.10-FF-000336', NULL, 'Tyrosine-protein phosphatase', 245, NULL, NULL, 131301),
(131302, '3.20.20.80-FF-000062', NULL, 'Klotho', 437, NULL, NULL, 131302),
(131303, '3.40.390.10-FF-000138', NULL, 'Uncharacterized protein', 193, NULL, NULL, 131303),
(131304, '1.25.40.420-FF-000065', NULL, 'Uncharacterized protein', 63, NULL, NULL, 131304),
(131305, '3.40.50.300-FF-004040', NULL, 'Cytosolic Fe-S cluster assembly factor NUBP1 homolog', 255, NULL, NULL, 131305),
(131306, '2.40.50.140-FF-001196', NULL, NULL, 104, NULL, NULL, 131306),
(131307, '1.20.1280.50-FF-000057', NULL, 'F-box only protein 22', 45, NULL, NULL, 131307),
(131308, '2.60.120.260-FF-000498', NULL, 'Uncharacterized protein', 93, NULL, NULL, 131308),
(131309, '1.20.1270.10-FF-000067', NULL, 'Bip', 74, NULL, NULL, 131309),
(131310, '3.20.20.140-FF-000140', NULL, 'hydrolase TatD family protein', 302, NULL, NULL, 131310),
(131311, '3.50.50.100-FF-000003', NULL, 'Apoptosis-inducing factor, mitochondrion-associated, 2', 360, NULL, NULL, 131311),
(131312, '4.10.400.10-FF-000014', NULL, 'Relaxin family peptide receptor 1', 43, NULL, NULL, 131312),
(131313, '3.30.200.20-FF-000006', NULL, 'TRAF2 and NCK-interacting protein kinase isoform 4', 107, NULL, NULL, 131313),
(131314, '1.10.1040.10-FF-000064', NULL, '2-dehydropantoate 2-reductase', 126, NULL, NULL, 131314),
(131315, '2.60.40.10-FF-001268', NULL, 'Blast:Protein CEPU-1', 102, NULL, NULL, 131315),
(131316, '2.60.40.10-FF-003943', NULL, NULL, 105, NULL, NULL, 131316),
(131317, '3.40.50.300-FF-008081', NULL, 'Uncharacterized protein', 117, NULL, NULL, 131317),
(131318, '3.30.870.10-FF-000031', NULL, 'Tyrosyl-DNA phosphodiesterase 1', 273, NULL, NULL, 131318),
(131319, '3.30.10.20-FF-000020', NULL, NULL, 65, NULL, NULL, 131319),
(131320, '1.10.101.10-FF-000044', NULL, 'Putative serine/threonine protein kinase', 76, NULL, NULL, 131320),
(131321, '3.30.200.160-FF-000009', NULL, 'RNA polymerase III transcription factor IIIC subunit', 125, NULL, NULL, 131321),
(131322, '2.60.120.200-FF-000183', NULL, 'Protein eyes shut homolog', 181, NULL, NULL, 131322),
(131323, '2.30.29.170-FF-000026', NULL, NULL, 118, NULL, NULL, 131323),
(131324, '1.10.472.80-FF-000061', NULL, 'GTPase-activating protein, putative', 133, NULL, NULL, 131324),
(131325, '3.90.228.20-FF-000012', NULL, 'Phosphoenolpyruvate carboxykinase [GTP]', 216, NULL, NULL, 131325),
(131326, '1.10.510.10-FF-003945', NULL, NULL, 60, NULL, NULL, 131326),
(131327, '1.25.40.410-FF-000011', NULL, 'DOCK-like protein, putative', 141, NULL, NULL, 131327),
(131328, '2.30.170.20-FF-000007', NULL, '60S ribosomal protein L24', 64, NULL, NULL, 131328);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(131329, '1.10.245.10-FF-000001', NULL, 'SWI/SNF-related matrix-associated regulator of chromatin subfamily D member 3 isoform 1', 84, NULL, NULL, 131329),
(131330, '1.25.40.420-FF-000014', NULL, 'kelch repeat and BTB domain-containing protein 8', 117, NULL, NULL, 131330),
(131331, '3.40.50.620-FF-000482', NULL, 'Tyrosine--tRNA ligase', 207, NULL, NULL, 131331),
(131332, '3.30.9.10-FF-000306', NULL, 'Uncharacterized protein', 99, NULL, NULL, 131332),
(131333, '3.40.50.360-FF-000089', NULL, 'Uncharacterized protein', 54, NULL, NULL, 131333),
(131334, '3.30.420.40-FF-000107', NULL, 'Heat shock 70 kDa protein 14', 90, NULL, NULL, 131334),
(131335, '3.40.50.620-FF-000594', NULL, '(6-4) photolyase', 159, NULL, NULL, 131335),
(131336, '3.40.50.720-FF-000686', NULL, '3 beta-hydroxysteroid dehydrogenase/Delta 5-->4-isomerase', 347, NULL, NULL, 131336),
(131337, '1.10.287.470-FF-000090', NULL, 'Multidrug resistance efflux pump, RND family, membrane fusion protein EmrA', 20, NULL, NULL, 131337),
(131338, '2.60.300.12-FF-000016', NULL, 'Iron-sulfur assembly protein, putative', 111, NULL, NULL, 131338),
(131339, '1.50.40.10-FF-000545', NULL, 'Mitochondrial carrier-like protein', 137, NULL, NULL, 131339),
(131340, '3.40.250.10-FF-000128', NULL, 'Thiosulfate sulfurtransferase', 132, NULL, NULL, 131340),
(131341, '4.10.1000.10-FF-000115', NULL, 'Zinc finger CCCH domain-containing protein 3 isoform A', 49, NULL, NULL, 131341),
(131342, '3.20.80.10-FF-000005', NULL, 'Transcriptional regulator, effector binding domain protein', 155, NULL, NULL, 131342),
(131343, '2.60.120.290-FF-000041', NULL, 'Kremen protein', 118, NULL, NULL, 131343),
(131344, '3.40.710.10-FF-000113', NULL, 'Cell division protein/Peptidoglycan synthetase', 195, NULL, NULL, 131344),
(131345, '2.30.180.10-FF-000044', NULL, 'Uncharacterized protein, isoform A', 133, NULL, NULL, 131345),
(131346, '2.40.50.700-FF-000009', NULL, NULL, 90, NULL, NULL, 131346),
(131347, '3.30.70.330-FF-000098', NULL, 'TAR DNA-binding protein 43', 94, NULL, NULL, 131347),
(131348, '1.25.40.570-FF-000031', NULL, 'Proteasome regulatory subunit putative', 206, NULL, NULL, 131348),
(131349, '1.10.472.80-FF-000268', NULL, NULL, 158, NULL, NULL, 131349),
(131350, '3.20.20.80-FF-000157', NULL, 'Alpha-glucosidase', 306, NULL, NULL, 131350),
(131351, '2.130.10.10-FF-004213', NULL, 'Hypothetical WD40 domain protein', 152, NULL, NULL, 131351),
(131352, '1.20.1110.10-FF-000174', NULL, NULL, 148, NULL, NULL, 131352),
(131353, '2.30.42.10-FF-000599', NULL, NULL, 102, NULL, NULL, 131353),
(131354, '1.10.472.80-FF-000217', NULL, NULL, 132, NULL, NULL, 131354),
(131355, '3.40.50.300-FF-007592', NULL, 'ATP-dependent RNA helicase dbp6', 170, NULL, NULL, 131355),
(131356, '3.40.50.2300-FF-001277', NULL, NULL, 175, NULL, NULL, 131356),
(131357, '1.25.40.20-FF-000062', NULL, 'ankyrin repeat domain-containing protein 17', 110, NULL, NULL, 131357),
(131358, '3.90.79.10-FF-000111', NULL, 'Hydrolase, NUDIX family protein', 129, NULL, NULL, 131358),
(131359, '2.30.110.10-FF-000096', NULL, 'Putative oxidoreductase, MmyF', 172, NULL, NULL, 131359),
(131360, '3.30.60.220-FF-000001', NULL, 'Probable ATP-dependent RNA helicase DDX59', 60, NULL, NULL, 131360),
(131361, '2.10.50.10-FF-000045', NULL, 'Cysteine repeat modular protein 2', 63, NULL, NULL, 131361),
(131362, '1.20.1560.10-FF-000786', NULL, 'Uncharacterized protein', 263, NULL, NULL, 131362),
(131363, '1.10.287.1490-FF-000110', NULL, 'Uncharacterized protein', 159, NULL, NULL, 131363),
(131364, '3.40.50.300-FF-001690', NULL, 'tRNA ligase', 189, NULL, NULL, 131364),
(131365, '2.30.30.490-FF-000006', NULL, 'DNA (cytosine-5)-methyltransferase', 138, NULL, NULL, 131365),
(131366, '1.10.510.10-FF-001854', NULL, 'Protein_kinase_-_putative', 275, NULL, NULL, 131366),
(131367, '1.10.238.110-FF-000006', NULL, 'Diacylglycerol kinase', 113, NULL, NULL, 131367),
(131368, '1.10.10.160-FF-000007', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', 94, NULL, NULL, 131368),
(131369, '2.30.42.10-FF-000099', NULL, 'Phosphatidylinositol-3,4,5-trisphosphate dependent Rac exchange factor 1', 83, NULL, NULL, 131369);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(131370, '3.30.70.330-FF-000839', NULL, 'Multiple RNA-binding domain-containing protein 1', 116, NULL, NULL, 131370),
(131371, '1.20.1250.20-FF-001401', NULL, 'Uncharacterized protein', 188, NULL, NULL, 131371),
(131372, '3.40.50.1220-FF-000099', NULL, '2-hydroxyphytanoyl-CoA lyase, putative', 77, NULL, NULL, 131372),
(131373, '3.30.70.3030-FF-000009', NULL, 'U3 small nucleolar RNA-associated protein 22', 133, NULL, NULL, 131373),
(131374, '3.30.70.330-FF-000991', NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', 134, NULL, NULL, 131374),
(131375, '1.10.565.10-FF-000194', NULL, 'Uncharacterized protein', 97, NULL, NULL, 131375),
(131376, '3.40.630.10-FF-000112', NULL, 'Carboxypeptidase Q', 53, NULL, NULL, 131376),
(131377, '1.10.238.100-FF-000003', NULL, 'Transcription factor', 82, NULL, NULL, 131377),
(131378, '3.40.30.10-FF-000905', NULL, 'Chromosome 8, whole genome shotgun sequence', 138, NULL, NULL, 131378),
(131379, '3.40.1190.20-FF-000187', NULL, NULL, 289, NULL, NULL, 131379),
(131380, '2.130.10.10-FF-001358', NULL, 'Retinoblastoma-binding-like protein E', 103, NULL, NULL, 131380),
(131381, '1.20.1410.10-FF-000039', NULL, 'Predicted protein', 202, NULL, NULL, 131381),
(131382, '1.10.10.140-FF-000001', NULL, 'Cytochrome c oxidase subunit 6B1', 83, NULL, NULL, 131382),
(131383, '3.40.50.2000-FF-000642', NULL, 'Mannosyltransferase', 105, NULL, NULL, 131383),
(131384, '1.20.5.300-FF-000004', NULL, 'Uncharacterized protein, isoform B', 49, NULL, NULL, 131384),
(131385, '3.40.50.2000-FF-001131', NULL, 'Uncharacterized protein', 79, NULL, NULL, 131385),
(131386, '1.10.1520.10-FF-000106', NULL, 'Uncharacterized protein', 190, NULL, NULL, 131386),
(131387, '3.30.450.60-FF-000093', NULL, 'AP complex subunit sigma', 58, NULL, NULL, 131387),
(131388, '3.40.50.300-FF-003876', NULL, 'RecA/RadA recombinase', 126, NULL, NULL, 131388),
(131389, '1.20.120.350-FF-000142', NULL, NULL, 80, NULL, NULL, 131389),
(131390, '1.10.510.10-FF-002956', NULL, NULL, 61, NULL, NULL, 131390),
(131391, '3.30.460.10-FF-000157', NULL, 'Uncharacterized protein', 31, NULL, NULL, 131391),
(131392, '1.10.287.70-FF-000492', NULL, 'Predicted protein', 116, NULL, NULL, 131392),
(131393, '1.25.40.10-FF-001514', NULL, 'Leucine Rich Repeat domain protein (AFU_orthologue AFUA_7G02000)', 125, NULL, NULL, 131393),
(131394, '2.60.40.150-FF-000310', NULL, 'AGAP005288-PA', 193, NULL, NULL, 131394),
(131395, '3.40.50.2300-FF-001070', NULL, NULL, 65, NULL, NULL, 131395),
(131396, '3.40.50.300-FF-001785', NULL, 'Early gene transcription factor VETF small subunit', 175, NULL, NULL, 131396),
(131397, '1.10.1580.10-FF-000003', NULL, 'Ribosome biogenesis GTPase A', 93, NULL, NULL, 131397),
(131398, '2.30.31.50-FF-000001', NULL, 'ErpC', 141, NULL, NULL, 131398),
(131399, '1.20.1070.10-FF-001075', NULL, 'Uncharacterized protein', 327, NULL, NULL, 131399),
(131400, '3.20.20.70-FF-000154', NULL, 'Probable nitronate monooxygenase', 351, NULL, NULL, 131400),
(131401, '3.60.15.10-FF-000229', NULL, 'Ribonuclease Z', 338, NULL, NULL, 131401),
(131402, '1.25.40.790-FF-000012', NULL, 'Domain_of_uncharacterized_function_(DUF3819)/CCR4 -Not_complex_component_-_Not1_-_putative', 333, NULL, NULL, 131402),
(131403, '1.10.10.1940-FF-000002', NULL, 'PHAryngeal gland Toxin-related', 45, NULL, NULL, 131403),
(131404, '1.10.860.10-FF-000003', NULL, 'DNA primase', 148, NULL, NULL, 131404),
(131405, '1.10.150.50-FF-000231', NULL, 'Predicted protein', 76, NULL, NULL, 131405),
(131406, '3.30.160.60-FF-004005', NULL, NULL, 29, NULL, NULL, 131406),
(131407, '2.30.30.490-FF-000057', NULL, 'Predicted protein', 152, NULL, NULL, 131407),
(131408, '1.10.555.10-FF-000215', NULL, NULL, 286, NULL, NULL, 131408),
(131409, '3.40.50.1820-FF-001060', NULL, 'Triacylglycerol lipase', 341, NULL, NULL, 131409),
(131410, '1.10.630.10-FF-000520', NULL, 'Os10g0172100 protein', 405, NULL, NULL, 131410),
(131411, '1.25.40.20-FF-001517', NULL, 'Uncharacterized protein', 286, NULL, NULL, 131411),
(131412, '2.30.30.210-FF-000001', NULL, 'Ribonuclease P protein subunit p29', 104, NULL, NULL, 131412);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(131413, '3.30.1360.40-FF-000006', NULL, 'Arginine repressor', 82, NULL, NULL, 131413),
(131414, '3.20.20.60-FF-000151', NULL, 'Uncharacterized protein', 93, NULL, NULL, 131414),
(131415, '3.60.20.10-FF-000056', NULL, 'NAD(P)H-dependent glutamate synthase, putative', 295, NULL, NULL, 131415),
(131416, '2.60.60.20-FF-000018', NULL, 'Lipoxygenase', 161, NULL, NULL, 131416),
(131417, '3.30.2310.20-FF-000014', NULL, 'DNA helicase', 87, NULL, NULL, 131417),
(131418, '2.40.50.140-FF-000965', NULL, NULL, 144, NULL, NULL, 131418),
(131419, '3.90.1100.10-FF-000032', NULL, 'DNA-directed RNA polymerase subunit beta', 170, NULL, NULL, 131419),
(131420, '3.80.10.10-FF-004438', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 139, NULL, NULL, 131420),
(131421, '2.30.30.140-FF-000132', NULL, 'Histone acetyltransferase', 194, NULL, NULL, 131421),
(131422, '1.25.40.10-FF-005281', NULL, 'Uncharacterized protein', 146, NULL, NULL, 131422),
(131423, '2.10.25.10-FF-000644', NULL, 'Uromodulin', 34, NULL, NULL, 131423),
(131424, '3.90.640.10-FF-000091', NULL, 'Uncharacterized protein', 52, NULL, NULL, 131424),
(131425, '3.30.1360.30-FF-000003', NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit E', 129, NULL, NULL, 131425),
(131426, '1.20.140.10-FF-000093', NULL, 'Very long chain acyl-CoA dehydrogenase', 129, NULL, NULL, 131426),
(131427, '2.30.30.100-FF-000199', NULL, 'Uncharacterized protein', 97, NULL, NULL, 131427),
(131428, '2.10.25.10-FF-000583', NULL, 'Os02g0633066 protein', 39, NULL, NULL, 131428),
(131429, '1.50.40.10-FF-000107', NULL, 'Mitochondrial dicarboxylate carrier', 282, NULL, NULL, 131429),
(131430, '2.10.50.10-FF-000096', NULL, 'Hematopoietic death receptor', 60, NULL, NULL, 131430),
(131431, '1.20.144.10-FF-000101', NULL, 'Predicted protein', 197, NULL, NULL, 131431),
(131432, '3.40.50.200-FF-000120', NULL, 'Uncharacterized protein', 367, NULL, NULL, 131432),
(131433, '1.25.40.10-FF-003717', NULL, 'Uncharacterized protein', 167, NULL, NULL, 131433),
(131434, '3.40.50.300-FF-005349', NULL, 'endoribonuclease Dicer', 170, NULL, NULL, 131434),
(131435, '3.90.1720.10-FF-000023', NULL, 'NLP/P60 family protein', 185, NULL, NULL, 131435),
(131436, '3.40.1380.10-FF-000007', NULL, 'ATP synthase gamma chain', 220, NULL, NULL, 131436),
(131437, '3.40.50.1010-FF-000266', NULL, NULL, 149, NULL, NULL, 131437),
(131438, '3.40.50.720-FF-000068', NULL, 'Sorbitol dehydrogenase', 141, NULL, NULL, 131438),
(131439, '2.60.40.4370-FF-000011', NULL, NULL, 97, NULL, NULL, 131439),
(131440, '3.40.50.10470-FF-000034', NULL, 'Unplaced genomic scaffold supercont1.24, whole genome shotgun sequence', 218, NULL, NULL, 131440),
(131441, '3.40.50.300-FF-005287', NULL, 'Elongator complex protein 5', 177, NULL, NULL, 131441),
(131442, '3.30.65.10-FF-000003', NULL, 'DNA topoisomerase 1', 42, NULL, NULL, 131442),
(131443, '1.25.40.10-FF-003431', NULL, 'Pentatricopeptide repeat-containing protein At1g62670, mitochondrial', 114, NULL, NULL, 131443),
(131444, '3.40.50.2000-FF-000288', NULL, 'ALG11p Alpha-1,2-mannosyltransferase', 188, NULL, NULL, 131444),
(131445, '1.20.1070.10-FF-000518', NULL, 'G-protein coupled receptor daf-38', 316, NULL, NULL, 131445),
(131446, '3.30.1360.170-FF-000006', NULL, 'Thymidylate synthase ThyX', 164, NULL, NULL, 131446),
(131447, '3.40.30.50-FF-000002', NULL, 'Selenoprotein M', 101, NULL, NULL, 131447),
(131448, '3.30.160.60-FF-002240', NULL, 'Zinc finger protein 26-like Protein', 27, NULL, NULL, 131448),
(131449, '3.30.310.80-FF-000038', NULL, 'Non-specific serine/threonine protein kinase', 213, NULL, NULL, 131449),
(131450, '3.40.50.1820-FF-001352', NULL, 'Dihydromonacolin L-[lovastatin nonaketide synthase] thioesterase', 240, NULL, NULL, 131450),
(131451, '3.30.1360.180-FF-000009', NULL, 'Putative ectonucleotide pyrophosphatase/phosphodiesterase, [includes: alkaline phosphodiesterase (Ec 3.1.4.1) nucleotide pyrophosphatase (Ec 3.6.1.9)]', 118, NULL, NULL, 131451),
(131452, '2.130.10.10-FF-002061', NULL, 'Putative beta propeller protein', 147, NULL, NULL, 131452),
(131453, '3.30.980.10-FF-000034', NULL, 'Uncharacterized protein', 126, NULL, NULL, 131453);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(131454, '3.30.230.80-FF-000037', NULL, 'Uncharacterized protein', 40, NULL, NULL, 131454),
(131455, '1.10.3730.20-FF-000002', NULL, 'Probable 4-amino-4-deoxy-L-arabinose-phosphoundecaprenol flippase subunit ArnE', 108, NULL, NULL, 131455),
(131456, '2.60.40.10-FF-001526', NULL, 'Alpha-L-iduronidase', 108, NULL, NULL, 131456),
(131457, '2.130.10.10-FF-005287', NULL, 'Uncharacterized protein', 228, NULL, NULL, 131457),
(131458, '1.25.40.1040-FF-000051', NULL, 'Uncharacterized protein', 189, NULL, NULL, 131458),
(131459, '3.30.40.10-FF-001121', NULL, 'TRAF6', 94, NULL, NULL, 131459),
(131460, '2.30.42.10-FF-000453', NULL, NULL, 99, NULL, NULL, 131460),
(131461, '3.40.50.150-FF-001504', NULL, NULL, 111, NULL, NULL, 131461),
(131462, '3.30.420.40-FF-000321', NULL, 'Phosphotransferase', 168, NULL, NULL, 131462),
(131463, '2.10.70.10-FF-000221', NULL, 'Uncharacterized protein', 74, NULL, NULL, 131463),
(131464, '1.20.1270.280-FF-000003', NULL, 'Dynein axonemal heavy chain 17', 169, NULL, NULL, 131464),
(131465, '3.80.10.10-FF-002426', NULL, 'Uncharacterized protein', 112, NULL, NULL, 131465),
(131466, '2.60.34.20-FF-000014', NULL, NULL, 119, NULL, NULL, 131466),
(131467, '3.30.420.10-FF-000453', NULL, NULL, 172, NULL, NULL, 131467),
(131468, '1.10.441.10-FF-000002', NULL, 'Mannose-6-phosphate isomerase', 115, NULL, NULL, 131468),
(131469, '1.20.140.10-FF-000042', NULL, 'Acyl-CoA dehydrogenase FadE10', 112, NULL, NULL, 131469),
(131470, '3.30.70.1230-FF-000054', NULL, 'Guanylate cyclase', 193, NULL, NULL, 131470),
(131471, '2.10.25.10-FF-001100', NULL, 'Transmembrane cell adhesion receptor mua-3', 61, NULL, NULL, 131471),
(131472, '1.20.920.10-FF-000164', NULL, 'Pbrm-1', 117, NULL, NULL, 131472),
(131473, '3.40.50.11660-FF-000026', NULL, 'Alpha3-fucosyltransferase', 199, NULL, NULL, 131473),
(131474, '3.40.50.150-FF-000987', NULL, NULL, 216, NULL, NULL, 131474),
(131475, '1.50.10.10-FF-000217', NULL, 'alpha-1,2-Mannosidase', 121, NULL, NULL, 131475),
(131476, '3.40.50.300-FF-002802', NULL, 'Helicase in mitochondria', 207, NULL, NULL, 131476),
(131477, '3.10.20.90-FF-000301', NULL, 'Small ubiquitin-related modifier 1', 77, NULL, NULL, 131477),
(131478, '3.30.1390.30-FF-000005', NULL, 'Peptidoglycan D,D-transpeptidase MrdA', 77, NULL, NULL, 131478),
(131479, '3.40.720.10-FF-000153', NULL, 'Heparan N-sulfatase', 478, NULL, NULL, 131479),
(131480, '1.20.1270.280-FF-000054', NULL, 'Uncharacterized protein', 147, NULL, NULL, 131480),
(131481, '3.30.160.60-FF-003393', NULL, 'Zinc finger protein 347', 29, NULL, NULL, 131481),
(131482, '2.10.25.20-FF-000001', NULL, 'Fiber', 69, NULL, NULL, 131482),
(131483, '3.30.830.10-FF-000034', NULL, 'presequence protease 1, chloroplastic/mitochondrial', 259, NULL, NULL, 131483),
(131484, '1.10.8.10-FF-000185', NULL, 'Tdpt-1', 85, NULL, NULL, 131484),
(131485, '3.80.10.10-FF-002718', NULL, 'Predicted protein', 95, NULL, NULL, 131485),
(131486, '3.40.50.150-FF-001779', NULL, NULL, 188, NULL, NULL, 131486),
(131487, '1.20.5.740-FF-000001', NULL, 'nudC domain-containing protein 2', 32, NULL, NULL, 131487),
(131488, '3.30.505.10-FF-000037', NULL, 'Tyrosine-protein kinase', 111, NULL, NULL, 131488),
(131489, '1.10.1280.10-FF-000019', NULL, 'Grixazone synthase', 305, NULL, NULL, 131489),
(131490, '3.90.870.10-FF-000023', NULL, 'Uncharacterized protein', 48, NULL, NULL, 131490),
(131491, '1.10.8.60-FF-000413', NULL, 'Sigma-54-dependent transcriptional response regulator', 77, NULL, NULL, 131491),
(131492, '3.60.40.10-FF-000068', NULL, 'Protein phosphatase 2C 29 isoform A', 377, NULL, NULL, 131492),
(131493, '3.30.1390.20-FF-000002', NULL, '60S ribosomal protein L7', 55, NULL, NULL, 131493),
(131494, '3.40.50.1100-FF-000181', NULL, 'Threonine synthase', 182, NULL, NULL, 131494),
(131495, '2.130.10.10-FF-001779', NULL, 'Uncharacterized protein', 222, NULL, NULL, 131495),
(131496, '1.10.238.10-FF-000035', NULL, 'Calcium and integrin-binding family member 2', 180, NULL, NULL, 131496),
(131497, '1.25.40.10-FF-005229', NULL, 'Uncharacterized protein', 181, NULL, NULL, 131497),
(131498, '1.10.287.1250-FF-000004', NULL, 'Phosphotransferase', 57, NULL, NULL, 131498);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(131499, '3.40.630.30-FF-000332', NULL, 'Toxin resistance protein', 167, NULL, NULL, 131499),
(131500, '2.30.30.40-FF-000041', NULL, 'Intersectin 1', 70, NULL, NULL, 131500),
(131501, '3.40.50.10190-FF-000220', NULL, 'DNA repair protein XRCC1', 102, NULL, NULL, 131501),
(131502, '1.10.287.1260-FF-000007', NULL, 'Small conductance mechanosensitive ion channel', 124, NULL, NULL, 131502),
(131503, '1.10.10.1200-FF-000005', NULL, 'Necdin homolog (Mouse)', 107, NULL, NULL, 131503),
(131504, '2.40.50.90-FF-000096', NULL, 'Qin', 95, NULL, NULL, 131504),
(131505, '3.30.1490.430-FF-000006', NULL, 'mRNA-capping enzyme', 15, NULL, NULL, 131505),
(131506, '3.40.50.2000-FF-000693', NULL, 'UDP-glucoronosyl and UDP-glucosyl transferase family protein, putative', 185, NULL, NULL, 131506),
(131507, '1.25.40.10-FF-001918', NULL, 'Intraflagellar transport protein 56', 106, NULL, NULL, 131507),
(131508, '3.40.930.10-FF-000045', NULL, NULL, 267, NULL, NULL, 131508),
(131509, '2.10.25.10-FF-000532', NULL, 'Multiple epidermal growth factor-like domains 8', 79, NULL, NULL, 131509),
(131510, '3.90.550.10-FF-000145', NULL, 'Cellulose synthase-like protein H1', 160, NULL, NULL, 131510),
(131511, '3.80.10.10-FF-001066', NULL, 'Leucine-rich repeat containing protein', 155, NULL, NULL, 131511),
(131512, '3.50.50.60-FF-000871', NULL, 'Digeranylgeranylglycerophospholipid reductase', 393, NULL, NULL, 131512),
(131513, '3.40.50.150-FF-001830', NULL, NULL, 69, NULL, NULL, 131513),
(131514, '3.20.20.140-FF-000252', NULL, 'WGS project CABT00000000 data, contig 2.6', 320, NULL, NULL, 131514),
(131515, '3.40.30.10-FF-000670', NULL, 'Sulfhydryl oxidase', 105, NULL, NULL, 131515),
(131516, '3.40.250.10-FF-000066', NULL, 'MercaptoPyruvate SulfurTransferase homolog', 116, NULL, NULL, 131516),
(131517, '3.40.50.300-FF-005675', NULL, 'Dynein-1-beta heavy chain, flagellar inner arm I1 complex', 191, NULL, NULL, 131517),
(131518, '4.10.400.10-FF-000126', NULL, 'low-density lipoprotein receptor class A domain-containing protein 4', 39, NULL, NULL, 131518),
(131519, '3.30.160.60-FF-000115', NULL, 'Zinc finger and BTB domain containing 7C', 26, NULL, NULL, 131519),
(131520, '2.60.120.200-FF-000475', NULL, 'Laminin subunit alpha-1-like Protein', 151, NULL, NULL, 131520),
(131521, '3.30.70.890-FF-000046', NULL, 'GHMP kinase domain protein', 143, NULL, NULL, 131521),
(131522, '1.10.510.10-FF-003653', NULL, NULL, 184, NULL, NULL, 131522),
(131523, '3.30.930.10-FF-000244', NULL, 'Phenylalanine-tRNA ligase, beta subunit', 200, NULL, NULL, 131523),
(131524, '2.60.40.10-FF-000520', NULL, 'ephrin type-B receptor 3', 107, NULL, NULL, 131524),
(131525, '3.30.420.610-FF-000014', NULL, 'Tudor domain-containing protein 5', 100, NULL, NULL, 131525),
(131526, '3.30.160.60-FF-001397', NULL, 'Datilografo, isoform A', 28, NULL, NULL, 131526),
(131527, '3.30.710.10-FF-000379', NULL, 'SD03430p', 126, NULL, NULL, 131527),
(131528, '2.60.120.10-FF-000258', NULL, '3-hydroxyanthranilate 3,4-dioxygenase', 277, NULL, NULL, 131528),
(131529, '2.60.40.1770-FF-000001', NULL, 'Ephrin type-A receptor 5', 55, NULL, NULL, 131529),
(131530, '3.30.300.30-FF-000124', NULL, 'Acetyl-CoA synthetase (Acetate-CoA ligase) amino-end. (AcsA-3)', 44, NULL, NULL, 131530),
(131531, '1.20.5.1500-FF-000008', NULL, 'Testis-specific Y-encoded-like protein 5', 82, NULL, NULL, 131531),
(131532, '1.10.287.1240-FF-000001', NULL, 'Exodeoxyribonuclease I', 55, NULL, NULL, 131532),
(131533, '2.60.40.10-FF-000166', NULL, 'E3 ubiquitin-protein ligase MYCBP2 isoform X1', 90, NULL, NULL, 131533),
(131534, '1.50.40.10-FF-000433', NULL, 'Solute carrier family 25 member 11', 173, NULL, NULL, 131534),
(131535, '1.10.510.10-FF-000522', NULL, 'L-type lectin-domain containing receptor kinase IX.1', 204, NULL, NULL, 131535),
(131536, '2.60.120.920-FF-000005', NULL, 'Putative E3 ubiquitin-protein ligase NEURL1B', 154, NULL, NULL, 131536),
(131537, '1.20.58.400-FF-000045', NULL, 'Uncharacterized protein', 52, NULL, NULL, 131537),
(131538, '3.40.630.30-FF-000040', NULL, 'N-acetyltransferase 9 (putative)', 167, NULL, NULL, 131538);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(131539, '1.10.510.10-FF-003833', NULL, NULL, 109, NULL, NULL, 131539),
(131540, '1.20.1560.10-FF-000718', NULL, 'Uncharacterized protein', 253, NULL, NULL, 131540),
(131541, '1.10.3380.10-FF-000073', NULL, 'Predicted protein', 155, NULL, NULL, 131541),
(131542, '2.10.25.10-FF-000257', NULL, 'Fibulin-1', 45, NULL, NULL, 131542),
(131543, '1.10.287.130-FF-000246', NULL, 'Uncharacterized protein', 82, NULL, NULL, 131543),
(131544, '1.10.1040.50-FF-000014', NULL, NULL, 233, NULL, NULL, 131544),
(131545, '3.20.20.140-FF-000432', NULL, 'AMP deaminase', 154, NULL, NULL, 131545),
(131546, '1.10.437.10-FF-000043', NULL, 'Predicted protein', 157, NULL, NULL, 131546),
(131547, '1.10.1420.10-FF-000110', NULL, 'DNA mismatch repair protein Msh2', 205, NULL, NULL, 131547),
(131548, '3.20.10.10-FF-000006', NULL, 'Branched-chain amino acid aminotransferase', 181, NULL, NULL, 131548),
(131549, '3.40.50.720-FF-000394', NULL, 'GDP-L-fucose synthase', 161, NULL, NULL, 131549),
(131550, '3.40.430.10-FF-000052', NULL, 'Riboflavin biosynthesis protein RibD', 206, NULL, NULL, 131550),
(131551, '3.90.700.10-FF-000011', NULL, 'Putative FAD-binding dehydrogenase', 184, NULL, NULL, 131551),
(131552, '2.60.40.10-FF-004966', NULL, NULL, 62, NULL, NULL, 131552),
(131553, '3.40.850.10-FF-000483', NULL, 'Uncharacterized protein', 330, NULL, NULL, 131553),
(131554, '3.90.245.10-FF-000032', NULL, 'AT5g18860/F17K4_110', 360, NULL, NULL, 131554),
(131555, '3.40.50.300-FF-007266', NULL, 'RAB20, member RAS oncogene family', 156, NULL, NULL, 131555),
(131556, '3.30.420.10-FF-000683', NULL, NULL, 148, NULL, NULL, 131556),
(131557, '1.10.8.870-FF-000003', NULL, 'Glycerol-3-phosphate dehydrogenase', 142, NULL, NULL, 131557),
(131558, '1.25.40.10-FF-003482', NULL, 'Pentatricopeptide repeat-containing protein', 89, NULL, NULL, 131558),
(131559, '1.20.120.550-FF-000033', NULL, 'Arachidonate 5-lipoxygenase-activating protein', 61, NULL, NULL, 131559),
(131560, '1.25.40.20-FF-000174', NULL, 'Espin', 352, NULL, NULL, 131560),
(131561, '3.40.1110.10-FF-000292', NULL, NULL, 58, NULL, NULL, 131561),
(131562, '2.60.40.10-FF-005242', NULL, NULL, 88, NULL, NULL, 131562),
(131563, '2.30.40.10-FF-000049', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 67, NULL, NULL, 131563),
(131564, '1.10.510.10-FF-003092', NULL, NULL, 198, NULL, NULL, 131564),
(131565, '2.10.25.10-FF-000818', NULL, 'Neurogenic locus notch homolog protein 1', 42, NULL, NULL, 131565),
(131566, '2.60.40.10-FF-005860', NULL, NULL, 95, NULL, NULL, 131566),
(131567, '2.30.40.10-FF-000145', NULL, 'Uncharacterized protein', 48, NULL, NULL, 131567),
(131568, '3.30.420.10-FF-000065', NULL, 'Protein RRP6-like 2 isoform A', 271, NULL, NULL, 131568),
(131569, '3.40.50.360-FF-000140', NULL, 'NAD(P)H-dependent FAD/FMN reductase GTNG_3158', 174, NULL, NULL, 131569),
(131570, '1.10.3710.10-FF-000003', NULL, 'ATPase, AAA family protein', 95, NULL, NULL, 131570),
(131571, '2.130.10.30-FF-000088', NULL, 'Regulator of chromosome condensation 1/beta-lactamase-inhibitor protein II', 346, NULL, NULL, 131571),
(131572, '1.20.1270.60-FF-000054', NULL, 'Proline-serine-threonine phosphatase interacting protein 2', 275, NULL, NULL, 131572),
(131573, '2.10.25.10-FF-000206', NULL, 'Slit guidance ligand 3', 36, NULL, NULL, 131573),
(131574, '3.30.30.170-FF-000013', NULL, NULL, 64, NULL, NULL, 131574),
(131575, '1.10.287.70-FF-000666', NULL, 'Uncharacterized protein', 119, NULL, NULL, 131575),
(131576, '1.25.10.10-FF-001187', NULL, 'cilia- and flagella-associated protein 69 isoform X2', 363, NULL, NULL, 131576),
(131577, '3.20.20.70-FF-000328', NULL, 'Triosephosphate isomerase 2', 253, NULL, NULL, 131577),
(131578, '1.10.510.10-FF-001528', NULL, 'Probable bifunctional tRNA threonylcarbamoyladenosine biosynthesis protein', 107, NULL, NULL, 131578),
(131579, '3.40.50.1700-FF-000029', NULL, 'Beta-glucosidase', 270, NULL, NULL, 131579),
(131580, '3.30.160.60-FF-000520', NULL, 'zinc finger protein 629 isoform X2', 27, NULL, NULL, 131580),
(131581, '3.30.160.60-FF-002291', NULL, 'Zinc finger protein 648', 34, NULL, NULL, 131581);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(131582, '1.10.8.60-FF-000290', NULL, 'Replication factor C small subunit protein', 64, NULL, NULL, 131582),
(131583, '3.30.40.10-FF-000665', NULL, 'Predicted protein', 112, NULL, NULL, 131583),
(131584, '3.30.9.10-FF-000014', NULL, 'L-2-hydroxyglutarate dehydrogenase, mitochondrial', 162, NULL, NULL, 131584),
(131585, '1.20.120.1130-FF-000006', NULL, 'Vacuolar protein sorting-associated protein 28 homolog', 41, NULL, NULL, 131585),
(131586, '3.40.50.620-FF-000156', NULL, 'Phosphopantetheine adenylyltransferase 1-like', 151, NULL, NULL, 131586),
(131587, '1.10.3860.10-FF-000036', NULL, 'Proton/sodium:glutamate symporter DAACS family', 408, NULL, NULL, 131587),
(131588, '3.40.50.300-FF-001959', NULL, 'Putative dynein beta chain', 223, NULL, NULL, 131588),
(131589, '3.40.50.410-FF-000177', NULL, 'Uncharacterized protein', 209, NULL, NULL, 131589),
(131590, '3.30.530.20-FF-000104', NULL, 'START domain containing protein', 204, NULL, NULL, 131590),
(131591, '2.120.10.80-FF-000396', NULL, 'F-box/kelch-repeat protein', 185, NULL, NULL, 131591),
(131592, '1.10.630.10-FF-000492', NULL, 'Uncharacterized protein', 465, NULL, NULL, 131592),
(131593, '3.40.30.10-FF-000052', NULL, 'Thiol:disulfide interchange protein', 115, NULL, NULL, 131593),
(131594, '1.20.58.1610-FF-000013', NULL, 'NADH-quinone oxidoreductase subunit A 2', 119, NULL, NULL, 131594),
(131595, '1.20.1250.20-FF-000737', NULL, 'Major facilitator superfamily transporter', 195, NULL, NULL, 131595),
(131596, '3.40.50.620-FF-000768', NULL, 'Predicted protein', 116, NULL, NULL, 131596),
(131597, '1.10.287.370-FF-000026', NULL, 'Bud site selection protein', 118, NULL, NULL, 131597),
(131598, '3.30.70.1470-FF-000007', NULL, 'Non-catalytic caspase homolog csp-3', 97, NULL, NULL, 131598),
(131599, '1.25.40.20-FF-000612', NULL, 'Ankyrin repeat domain 2', 115, NULL, NULL, 131599),
(131600, '3.40.50.150-FF-000470', NULL, 'mRNA capping enzyme-like protein', 241, NULL, NULL, 131600),
(131601, '3.40.630.150-FF-000005', NULL, 'Malonyl-coa decarboxylase-like protein', 330, NULL, NULL, 131601),
(131602, '3.30.70.330-FF-003127', NULL, NULL, 102, NULL, NULL, 131602),
(131603, '3.20.20.80-FF-000775', NULL, 'Putative secreted beta-galactosidase', 272, NULL, NULL, 131603),
(131604, '3.15.20.10-FF-000019', NULL, 'Uncharacterized protein', 13, NULL, NULL, 131604),
(131605, '1.10.287.470-FF-000056', NULL, 'Efflux transporter, RND family, MFP subunit', 70, NULL, NULL, 131605),
(131606, '2.10.90.10-FF-000042', NULL, 'Cerberus 1 homolog (Xenopus laevis)', 109, NULL, NULL, 131606),
(131607, '3.40.140.10-FF-000030', NULL, 'Cytidine and dCMP deaminase domain-containing protein 1', 105, NULL, NULL, 131607),
(131608, '3.60.21.10-FF-000081', NULL, 'Metallophosphoesterase 1 homolog', 272, NULL, NULL, 131608),
(131609, '3.40.630.30-FF-000039', NULL, 'Probable N-acetyltransferase 16', 113, NULL, NULL, 131609),
(131610, '1.20.58.60-FF-000467', NULL, 'Uncharacterized protein', 224, NULL, NULL, 131610),
(131611, '3.40.30.10-FF-000344', NULL, 'Calsequestrin', 102, NULL, NULL, 131611),
(131612, '3.40.50.410-FF-000262', NULL, 'Uncharacterized protein', 145, NULL, NULL, 131612),
(131613, '3.30.70.660-FF-000062', NULL, 'tRNA pseudouridine synthase', 212, NULL, NULL, 131613),
(131614, '2.60.40.60-FF-000220', NULL, 'neural-cadherin isoform X5', 97, NULL, NULL, 131614),
(131615, '3.40.50.1820-FF-000571', NULL, 'Epoxide hydrolase', 401, NULL, NULL, 131615),
(131616, '3.40.50.300-FF-001246', NULL, 'ATPase family AAA domain-containing protein 5', 110, NULL, NULL, 131616),
(131617, '2.20.28.200-FF-000009', NULL, 'GG17292', 57, NULL, NULL, 131617),
(131618, '3.40.1110.10-FF-000353', NULL, NULL, 37, NULL, NULL, 131618),
(131619, '3.10.250.10-FF-000051', NULL, 'Si:dkey-242e21.3', 105, NULL, NULL, 131619),
(131620, '1.10.510.10-FF-003445', NULL, NULL, 278, NULL, NULL, 131620),
(131621, '3.90.640.90-FF-000018', NULL, 'Uncharacterized protein', 123, NULL, NULL, 131621),
(131622, '3.20.20.70-FF-000772', NULL, NULL, 315, NULL, NULL, 131622),
(131623, '1.25.10.10-FF-003328', NULL, 'Uncharacterized protein', 129, NULL, NULL, 131623);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(131624, '3.90.650.10-FF-000029', NULL, 'Phosphoribosylformylglycinamidine synthase', 186, NULL, NULL, 131624),
(131625, '2.10.70.10-FF-000041', NULL, 'Complement factor H', 57, NULL, NULL, 131625),
(131626, '2.30.30.190-FF-000006', NULL, 'Putative ubiquitin carboxyl-terminal hydrolase CYLD', 92, NULL, NULL, 131626),
(131627, '3.30.160.60-FF-003549', NULL, NULL, 28, NULL, NULL, 131627),
(131628, '1.10.10.10-FF-000894', NULL, 'Caffeic acid O-methyltransferase', 123, NULL, NULL, 131628),
(131629, '3.40.50.300-FF-003376', NULL, 'Uncharacterized protein', 224, NULL, NULL, 131629),
(131630, '2.60.40.4070-FF-000011', NULL, 'Basal-body rod modification protein FlgD', 86, NULL, NULL, 131630),
(131631, '4.10.60.10-FF-000199', NULL, 'Uncharacterized protein', 62, NULL, NULL, 131631),
(131632, '3.40.50.300-FF-002241', NULL, 'Arsenical pump-driving ATPase', 288, NULL, NULL, 131632),
(131633, '1.10.533.10-FF-000204', NULL, 'Uncharacterized protein', 103, NULL, NULL, 131633),
(131634, '2.130.10.10-FF-005219', NULL, 'Proteasomal ATPase associated factor 1', 81, NULL, NULL, 131634),
(131635, '1.20.5.110-FF-000099', NULL, 'SNARE protein, putative', 91, NULL, NULL, 131635),
(131636, '1.10.390.10-FF-000080', NULL, 'Aminopeptidase N', 54, NULL, NULL, 131636),
(131637, '3.40.50.1100-FF-000113', NULL, '1-aminocyclopropane-1-carboxylate deaminase', 117, NULL, NULL, 131637),
(131638, '2.10.25.10-FF-001072', NULL, 'Notch receptor 2', 38, NULL, NULL, 131638),
(131639, '2.60.40.10-FF-003393', NULL, NULL, 91, NULL, NULL, 131639),
(131640, '1.25.40.20-FF-001068', NULL, 'Uncharacterized protein', 155, NULL, NULL, 131640),
(131641, '3.30.60.30-FF-000200', NULL, 'Predicted protein', 32, NULL, NULL, 131641),
(131642, '3.50.50.60-FF-000545', NULL, 'FAD monooxygenase, PheA/TfdB family', 220, NULL, NULL, 131642),
(131643, '1.20.1270.60-FF-000228', NULL, 'Protein kinase C and casein kinase substrate in neurons protein 1', 287, NULL, NULL, 131643),
(131644, '3.40.50.620-FF-000717', NULL, 'Predicted protein', 215, NULL, NULL, 131644),
(131645, '2.60.120.200-FF-000683', NULL, 'Uncharacterized protein', 214, NULL, NULL, 131645),
(131646, '3.10.250.10-FF-000101', NULL, NULL, 88, NULL, NULL, 131646),
(131647, '3.30.70.330-FF-002790', NULL, NULL, 45, NULL, NULL, 131647),
(131648, '1.10.10.10-FF-001394', NULL, 'ArsR family transcriptional regulator', 95, NULL, NULL, 131648),
(131649, '3.40.140.10-FF-000125', NULL, 'Hypothetical_protein', 196, NULL, NULL, 131649),
(131650, '3.40.50.300-FF-000150', NULL, 'Chromosomal replication initiator protein DnaA', 172, NULL, NULL, 131650),
(131651, '3.30.60.90-FF-000016', NULL, 'Refractory to sigma P', 53, NULL, NULL, 131651),
(131652, '1.10.10.790-FF-000022', NULL, 'RNA binding protein, putative', 60, NULL, NULL, 131652),
(131653, '2.60.40.60-FF-000799', NULL, 'Desmocollin 3', 82, NULL, NULL, 131653),
(131654, '3.40.50.10240-FF-000027', NULL, 'Thiamin pyrophosphokinase 1-like Protein', 148, NULL, NULL, 131654),
(131655, '3.40.1180.10-FF-000026', NULL, 'Isoprenyl transferase', 238, NULL, NULL, 131655),
(131656, '3.30.40.10-FF-000991', NULL, 'E3 ubiquitin-protein ligase RBX1', 59, NULL, NULL, 131656),
(131657, '2.10.220.10-FF-000081', NULL, 'Proprotein convertase subtilisin/kexin type 5', 53, NULL, NULL, 131657),
(131658, '2.10.25.10-FF-000414', NULL, 'von Willebrand factor', 64, NULL, NULL, 131658),
(131659, '1.10.510.10-FF-002310', NULL, 'Serine/threonine protein kinase, putative (AFU_orthologue AFUA_5G07950)', 302, NULL, NULL, 131659),
(131660, '2.130.10.10-FF-005545', NULL, 'Uncharacterized protein', 224, NULL, NULL, 131660),
(131661, '3.30.420.10-FF-000571', NULL, NULL, 320, NULL, NULL, 131661),
(131662, '2.60.40.10-FF-003117', NULL, 'Uncharacterized protein', 96, NULL, NULL, 131662),
(131663, '1.10.238.10-FF-000878', NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit B'''' subunit alpha, putative', 164, NULL, NULL, 131663),
(131664, '3.40.720.10-FF-000327', NULL, 'Uncharacterized protein', 133, NULL, NULL, 131664),
(131665, '3.40.50.720-FF-001175', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 52, NULL, NULL, 131665);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(131666, '1.20.5.100-FF-000012', NULL, 'CYtochrome C', 42, NULL, NULL, 131666),
(131667, '3.40.50.2000-FF-000849', NULL, 'Glr3757 protein', 235, NULL, NULL, 131667),
(131668, '3.40.50.1110-FF-000116', NULL, 'Uncharacterized protein', 186, NULL, NULL, 131668),
(131669, '1.25.40.10-FF-002588', NULL, 'Pentatricopeptide repeat-containing protein', 96, NULL, NULL, 131669),
(131670, '1.10.510.10-FF-001416', NULL, 'Protein kinase, putative', 197, NULL, NULL, 131670),
(131671, '1.10.10.10-FF-001068', NULL, 'Cullin family protein', 76, NULL, NULL, 131671),
(131672, '2.60.110.10-FF-000027', NULL, 'Uncharacterized protein', 128, NULL, NULL, 131672),
(131673, '1.25.40.10-FF-001065', NULL, 'Putative Heat shock protein STI', 154, NULL, NULL, 131673),
(131674, '3.40.720.10-FF-000232', NULL, 'Predicted protein', 438, NULL, NULL, 131674),
(131675, '1.20.1260.100-FF-000010', NULL, NULL, 52, NULL, NULL, 131675),
(131676, '3.30.160.60-FF-004117', NULL, 'AGAP001646-PA', 78, NULL, NULL, 131676),
(131677, '1.25.40.10-FF-001694', NULL, 'putative pentatricopeptide repeat-containing protein At2g01510 isoform X7', 99, NULL, NULL, 131677),
(131678, '3.30.160.60-FF-002414', NULL, 'Zinc finger protein 610', 28, NULL, NULL, 131678),
(131679, '3.40.950.10-FF-000041', NULL, NULL, 50, NULL, NULL, 131679),
(131680, '3.90.640.10-FF-000214', NULL, 'Heat shock protein 70 homolog lhs1', 83, NULL, NULL, 131680),
(131681, '3.40.50.11340-FF-000020', NULL, 'Predicted protein', 92, NULL, NULL, 131681),
(131682, '3.40.50.11350-FF-000023', NULL, 'Uncharacterized protein', 82, NULL, NULL, 131682),
(131683, '2.30.30.180-FF-000003', NULL, 'Ribosome maturation factor RimP', 67, NULL, NULL, 131683),
(131684, '1.25.40.20-FF-001697', NULL, 'Predicted protein', 68, NULL, NULL, 131684),
(131685, '2.30.40.10-FF-000050', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 78, NULL, NULL, 131685),
(131686, '3.80.10.10-FF-002544', NULL, 'protein NLRC3', 157, NULL, NULL, 131686),
(131687, '1.25.40.10-FF-003156', NULL, 'Pentatricopeptide repeat-containing protein At1g03540', 119, NULL, NULL, 131687),
(131688, '1.10.150.200-FF-000004', NULL, 'Maltooligosyltrehalose synthase', 42, NULL, NULL, 131688),
(131689, '3.90.25.10-FF-000009', NULL, 'dTDP-glucose 4,6-dehydratase', 77, NULL, NULL, 131689),
(131690, '2.60.220.50-FF-000132', NULL, 'Adhesion G protein-coupled receptor E2', 171, NULL, NULL, 131690),
(131691, '3.90.25.10-FF-000066', NULL, 'NmrA-like negative transcriptional regulator, putative', 83, NULL, NULL, 131691),
(131692, '1.10.555.10-FF-000103', NULL, 'RhoGAP domain containing protein', 212, NULL, NULL, 131692),
(131693, '3.40.720.10-FF-000271', NULL, 'Uncharacterized protein', 402, NULL, NULL, 131693),
(131694, '1.10.8.10-FF-000246', NULL, 'Uncharacterized protein', 60, NULL, NULL, 131694),
(131695, '3.40.190.10-FF-000595', NULL, 'Transferrin', 119, NULL, NULL, 131695),
(131696, '3.40.50.410-FF-000357', NULL, 'Vwa2 protein', 78, NULL, NULL, 131696),
(131697, '3.30.9.10-FF-000183', NULL, 'Uncharacterized protein', 122, NULL, NULL, 131697),
(131698, '1.25.40.10-FF-005016', NULL, 'Uncharacterized protein', 112, NULL, NULL, 131698),
(131699, '1.25.40.10-FF-003835', NULL, 'Uncharacterized protein', 123, NULL, NULL, 131699),
(131700, '2.60.200.20-FF-000060', NULL, 'Probable serine/threonine-protein kinase DDB_G0280133', 134, NULL, NULL, 131700),
(131701, '3.40.50.1820-FF-001026', NULL, 'KAT8 regulatory NSL complex subunit 3-like Protein', 184, NULL, NULL, 131701),
(131702, '3.80.10.10-FF-002932', NULL, 'Uncharacterized protein', 113, NULL, NULL, 131702),
(131703, '2.60.40.150-FF-000422', NULL, 'Bud/polarization protein, putative', 144, NULL, NULL, 131703),
(131704, '3.40.220.10-FF-000031', NULL, 'Macro domain containing protein', 266, NULL, NULL, 131704),
(131705, '3.20.20.140-FF-000426', NULL, 'Protein trpH, mRNA', 40, NULL, NULL, 131705),
(131706, '2.40.10.10-FF-000620', NULL, NULL, 249, NULL, NULL, 131706),
(131707, '1.20.1560.10-FF-000511', NULL, 'Uncharacterized protein', 324, NULL, NULL, 131707),
(131708, '2.60.120.200-FF-000407', NULL, 'LAMinin related. See also lmb', 188, NULL, NULL, 131708);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(131709, '2.60.120.260-FF-000386', NULL, 'Ephrin receptor like protein', 193, NULL, NULL, 131709),
(131710, '2.30.29.30-FF-000793', NULL, 'CARMIL (Capping, ARp2/3, Myosin I Linker protein) homolog', 102, NULL, NULL, 131710),
(131711, '3.100.10.10-FF-000046', NULL, NULL, 71, NULL, NULL, 131711),
(131712, '1.10.630.10-FF-000166', NULL, 'cytochrome P450 315a1, mitochondrial', 470, NULL, NULL, 131712),
(131713, '3.30.420.10-FF-000514', NULL, NULL, 125, NULL, NULL, 131713),
(131714, '1.20.920.10-FF-000225', NULL, 'Uncharacterized protein', 49, NULL, NULL, 131714),
(131715, '1.25.40.10-FF-005073', NULL, 'Uncharacterized protein', 96, NULL, NULL, 131715),
(131716, '3.40.1090.10-FF-000120', NULL, 'Patatin', 220, NULL, NULL, 131716),
(131717, '1.20.1070.10-FF-000962', NULL, 'Pituitary adenylate cyclase-activating peptide', 59, NULL, NULL, 131717),
(131718, '1.20.120.1080-FF-000064', NULL, 'ATP-dependent RNA helicase', 170, NULL, NULL, 131718),
(131719, '3.20.20.80-FF-000511', NULL, 'Uncharacterized protein', 417, NULL, NULL, 131719),
(131720, '3.40.50.720-FF-000568', NULL, 'Polysaccharide biosynthesis protein', 332, NULL, NULL, 131720),
(131721, '2.60.120.200-FF-000295', NULL, 'NeuReXin related', 174, NULL, NULL, 131721),
(131722, '2.30.30.140-FF-000250', NULL, 'Metal-response element-binding transcription factor 2', 47, NULL, NULL, 131722),
(131723, '3.30.450.20-FF-000334', NULL, 'PAS domain-containing sensor histidine kinase', 118, NULL, NULL, 131723),
(131724, '1.25.40.10-FF-001418', NULL, 'Separin, putative', 127, NULL, NULL, 131724),
(131725, '1.20.990.10-FF-000050', NULL, 'Uncharacterized protein', 140, NULL, NULL, 131725),
(131726, '1.10.630.10-FF-000054', NULL, 'Cytochrome P450 84A1', 479, NULL, NULL, 131726),
(131727, '3.40.50.300-FF-004101', NULL, 'Helicase with zinc finger domain 2', 214, NULL, NULL, 131727),
(131728, '1.10.486.10-FF-000066', NULL, 'DNA helicase', 154, NULL, NULL, 131728),
(131729, '2.30.30.490-FF-000091', NULL, 'Uncharacterized protein', 103, NULL, NULL, 131729),
(131730, '1.10.238.20-FF-000038', NULL, 'AGAP000580-PA', 114, NULL, NULL, 131730),
(131731, '3.30.160.60-FF-005904', NULL, NULL, 29, NULL, NULL, 131731),
(131732, '2.40.30.70-FF-000004', NULL, 'Uncharacterized protein, isoform A', 147, NULL, NULL, 131732),
(131733, '3.40.50.1820-FF-000296', NULL, 'Probable esterase afoC', 253, NULL, NULL, 131733),
(131734, '3.40.50.300-FF-007816', NULL, 'Uncharacterized protein', 282, NULL, NULL, 131734),
(131735, '2.60.120.620-FF-000134', NULL, 'Predicted protein', 258, NULL, NULL, 131735),
(131736, '1.10.3080.10-FF-000038', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', 143, NULL, NULL, 131736),
(131737, '3.80.10.10-FF-002191', NULL, 'Uncharacterized protein', 278, NULL, NULL, 131737),
(131738, '3.80.10.10-FF-003207', NULL, 'Uncharacterized protein', 223, NULL, NULL, 131738),
(131739, '1.10.287.810-FF-000023', NULL, NULL, 73, NULL, NULL, 131739),
(131740, '1.10.20.10-FF-000220', NULL, NULL, 115, NULL, NULL, 131740),
(131741, '3.30.760.10-FF-000091', NULL, 'Uncharacterized protein', 107, NULL, NULL, 131741),
(131742, '3.40.1480.10-FF-000009', NULL, 'Glycerate kinase', 163, NULL, NULL, 131742),
(131743, '3.65.10.20-FF-000003', NULL, 'RNA terminal phosphate cyclase domain 1', 223, NULL, NULL, 131743),
(131744, '2.60.40.420-FF-000138', NULL, 'Uncharacterized protein', 178, NULL, NULL, 131744),
(131745, '3.40.50.410-FF-000205', NULL, 'Integrin beta', 218, NULL, NULL, 131745),
(131746, '3.40.50.10490-FF-000080', NULL, 'Uncharacterized HTH-type transcriptional regulator YbbH', 188, NULL, NULL, 131746),
(131747, '3.30.499.10-FF-000033', NULL, NULL, 38, NULL, NULL, 131747),
(131748, '3.40.850.10-FF-000157', NULL, 'Kinesin family member 27', 395, NULL, NULL, 131748),
(131749, '1.10.1370.40-FF-000007', NULL, 'Oligopeptidase A', 152, NULL, NULL, 131749),
(131750, '1.25.40.180-FF-000133', NULL, 'Eukaryotic translation initiation factor 5, putative', 168, NULL, NULL, 131750),
(131751, '2.20.100.10-FF-000058', NULL, 'Thrombospondin type 1 domain containing 4', 59, NULL, NULL, 131751);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(131752, '3.30.70.330-FF-001362', NULL, 'RNA binding protein, putative', 104, NULL, NULL, 131752),
(131753, '2.40.20.10-FF-000121', NULL, 'Uncharacterized protein', 61, NULL, NULL, 131753),
(131754, '1.10.3500.10-FF-000015', NULL, 'S1 RNA binding domain 1', 30, NULL, NULL, 131754),
(131755, '1.10.1370.30-FF-000004', NULL, 'Angiotensin-converting enzyme', 453, NULL, NULL, 131755),
(131756, '3.40.50.300-FF-005725', NULL, 'ATP-dependent DNA helicase Dna2', 160, NULL, NULL, 131756),
(131757, '3.40.50.720-FF-002535', NULL, 'LRRGT00043', 86, NULL, NULL, 131757),
(131758, '2.130.10.10-FF-005495', NULL, 'Uncharacterized protein', 116, NULL, NULL, 131758),
(131759, '2.10.25.10-FF-000083', NULL, 'Laminin subunit alpha', 48, NULL, NULL, 131759),
(131760, '3.30.160.60-FF-001689', NULL, 'zinc finger protein 407', 94, NULL, NULL, 131760),
(131761, '3.10.450.10-FF-000032', NULL, 'MGC116429 protein', 109, NULL, NULL, 131761),
(131762, '2.130.10.10-FF-006001', NULL, 'Spliceosomal protein sap, putative', 78, NULL, NULL, 131762),
(131763, '3.30.420.10-FF-000391', NULL, NULL, 109, NULL, NULL, 131763),
(131764, '3.10.20.90-FF-000121', NULL, 'unconventional myosin-IXa isoform X1', 123, NULL, NULL, 131764),
(131765, '2.60.40.1180-FF-000127', NULL, 'Calpain-like cysteine peptidase, Clan CA, family C2', 107, NULL, NULL, 131765),
(131766, '1.20.120.850-FF-000022', NULL, 'SNF2 family N-terminal domain-domain-containing protein', 82, NULL, NULL, 131766),
(131767, '3.30.200.20-FF-001760', NULL, 'Uncharacterized protein', 83, NULL, NULL, 131767),
(131768, '2.60.120.820-FF-000014', NULL, 'Predicted protein', 158, NULL, NULL, 131768),
(131769, '3.40.50.150-FF-000026', NULL, 'Polyamine aminopropyltransferase', 233, NULL, NULL, 131769),
(131770, '1.20.1560.10-FF-000606', NULL, 'Uncharacterized protein', 78, NULL, NULL, 131770),
(131771, '3.40.630.30-FF-000152', NULL, 'Uncharacterized N-acetyltransferase MT2743', 155, NULL, NULL, 131771),
(131772, '3.40.50.1360-FF-000062', NULL, 'Uncharacterized protein', 113, NULL, NULL, 131772),
(131773, '1.20.870.10-FF-000041', NULL, 'Ras guanine nucleotide exchange factor L', 169, NULL, NULL, 131773),
(131774, '3.40.50.300-FF-004270', NULL, 'Uncharacterized protein', 174, NULL, NULL, 131774),
(131775, '1.25.40.90-FF-000088', NULL, 'Uncharacterized protein', 136, NULL, NULL, 131775),
(131776, '3.40.50.2300-FF-001631', NULL, NULL, 269, NULL, NULL, 131776),
(131777, '2.130.10.10-FF-003196', NULL, 'NLE (NUC135) domain/WD domain, G-beta repeat, putative', 110, NULL, NULL, 131777),
(131778, '3.80.10.10-FF-002752', NULL, 'F-box only protein 39-like', 374, NULL, NULL, 131778),
(131779, '3.30.310.10-FF-000006', NULL, 'Coatomer subunit gamma', 115, NULL, NULL, 131779),
(131780, '3.20.20.80-FF-000718', NULL, '1,3-beta-glucanosyltransferase', 162, NULL, NULL, 131780),
(131781, '3.30.420.10-FF-000239', NULL, 'Uncharacterized protein', 77, NULL, NULL, 131781),
(131782, '2.130.10.10-FF-003421', NULL, 'Sortilin', 179, NULL, NULL, 131782),
(131783, '3.30.160.60-FF-005287', NULL, NULL, 69, NULL, NULL, 131783),
(131784, '2.40.30.60-FF-000001', NULL, 'Ribosome maturation factor RimM', 97, NULL, NULL, 131784),
(131785, '3.90.70.10-FF-000030', NULL, 'U4/U6.U5 tri-snRNP-associated protein 2', 363, NULL, NULL, 131785),
(131786, '3.40.50.1260-FF-000032', NULL, 'Phosphoglycerate kinase', 127, NULL, NULL, 131786),
(131787, '3.40.50.2000-FF-001070', NULL, 'Putative galacturonosyltransferase-like 9', 73, NULL, NULL, 131787),
(131788, '2.170.140.10-FF-000048', NULL, 'Mucin 68E', 56, NULL, NULL, 131788),
(131789, '2.60.120.970-FF-000031', NULL, 'growth/differentiation factor 11', 163, NULL, NULL, 131789),
(131790, '3.90.1410.10-FF-000134', NULL, 'Uncharacterized protein', 269, NULL, NULL, 131790),
(131791, '3.30.160.60-FF-001425', NULL, 'Zinc finger protein 331', 31, NULL, NULL, 131791),
(131792, '1.10.8.60-FF-000525', NULL, 'Uncharacterized protein', 17, NULL, NULL, 131792),
(131793, '2.10.25.10-FF-000178', NULL, 'vacuolar-sorting receptor 1', 57, NULL, NULL, 131793),
(131794, '3.20.20.140-FF-000139', NULL, 'Histidinol-phosphatase', 275, NULL, NULL, 131794);
INSERT INTO "PUBLIC"."MODEL" VALUES
(131795, '1.10.287.3440-FF-000004', NULL, 'Biosynthetic arginine decarboxylase', 55, NULL, NULL, 131795),
(131796, '3.90.190.10-FF-000224', NULL, 'receptor Tyrosine phosphatase-like', 176, NULL, NULL, 131796),
(131797, '1.25.10.10-FF-001237', NULL, 'Uncharacterized protein', 233, NULL, NULL, 131797),
(131798, '3.80.10.10-FF-000515', NULL, 'Leucine-rich repeat receptor-like protein kinase', 103, NULL, NULL, 131798),
(131799, '3.40.50.300-FF-008598', NULL, 'RuvB-like helicase', 57, NULL, NULL, 131799),
(131800, '3.30.70.330-FF-000013', NULL, 'CUGBP Elav-like family member 1 isoform 2', 99, NULL, NULL, 131800),
(131801, '3.40.50.300-FF-002061', NULL, 'RecQ family DNA helicase', 212, NULL, NULL, 131801),
(131802, '1.20.90.10-FF-000027', NULL, NULL, 132, NULL, NULL, 131802),
(131803, '1.20.1250.20-FF-000687', NULL, 'Major facilitator family transporter', 182, NULL, NULL, 131803),
(131804, '2.60.120.330-FF-000042', NULL, 'Flavanone 3-dioxygenase 3', 322, NULL, NULL, 131804),
(131805, '2.70.150.10-FF-000241', NULL, 'Calcium-transporting ATPase', 102, NULL, NULL, 131805),
(131806, '1.10.150.50-FF-000135', NULL, 'Protein matrimony', 63, NULL, NULL, 131806),
(131807, '3.30.40.10-FF-000839', NULL, 'Ring finger protein 212', 81, NULL, NULL, 131807),
(131808, '1.10.1130.10-FF-000003', NULL, 'Fumarate reductase flavoprotein subunit', 96, NULL, NULL, 131808),
(131809, '3.40.50.2000-FF-001013', NULL, 'Uncharacterized protein', 186, NULL, NULL, 131809),
(131810, '1.20.1070.10-FF-000586', NULL, 'Predicted protein', 333, NULL, NULL, 131810),
(131811, '3.40.50.1370-FF-000065', NULL, NULL, 76, NULL, NULL, 131811),
(131812, '2.40.100.10-FF-000014', NULL, 'Peptidyl-prolyl cis-trans isomerase cyp65', 181, NULL, NULL, 131812),
(131813, '3.30.70.340-FF-000016', NULL, NULL, 92, NULL, NULL, 131813),
(131814, '3.40.630.30-FF-000270', NULL, 'N-terminal acetyltransferase complex ARD1 subunit, putative', 164, NULL, NULL, 131814),
(131815, '3.40.50.300-FF-003663', NULL, 'Replication-associated protein', 150, NULL, NULL, 131815),
(131816, '1.10.8.60-FF-000059', NULL, 'peroxisome biogenesis factor 6', 96, NULL, NULL, 131816),
(131817, '3.40.50.300-FF-004601', NULL, 'Helicase-like protein', 121, NULL, NULL, 131817),
(131818, '1.20.1270.60-FF-000149', NULL, 'GH04442p', 206, NULL, NULL, 131818),
(131819, '3.80.10.10-FF-003949', NULL, 'Uncharacterized protein', 68, NULL, NULL, 131819),
(131820, '3.40.1360.10-FF-000012', NULL, 'DNA primase', 124, NULL, NULL, 131820),
(131821, '1.10.10.10-FF-000051', NULL, 'Fur family transcriptional regulator', 87, NULL, NULL, 131821),
(131822, '1.10.10.60-FF-000779', NULL, 'Ladybird homeobox 2', 86, NULL, NULL, 131822),
(131823, '1.10.132.20-FF-000023', NULL, 'Ribosome-recycling factor chloroplastic', 29, NULL, NULL, 131823),
(131824, '3.30.160.60-FF-001189', NULL, 'Zinc finger protein 222', 28, NULL, NULL, 131824),
(131825, '1.20.5.1430-FF-000015', NULL, 'Microtubule-associated protein RP/EB family member 1', 93, NULL, NULL, 131825),
(131826, '1.10.132.30-FF-000026', NULL, 'RNA polymerase I largest subunit', 102, NULL, NULL, 131826),
(131827, '1.10.238.10-FF-000889', NULL, 'Uncharacterized protein', 224, NULL, NULL, 131827),
(131828, '2.30.29.30-FF-000759', NULL, 'ArfGAP with GTPase domain, ankyrin repeat and PH domain 2', 86, NULL, NULL, 131828),
(131829, '1.20.5.170-FF-000095', NULL, 'Transcription factor SPN1', 42, NULL, NULL, 131829),
(131830, '3.10.580.10-FF-000036', NULL, 'Chloride channel protein', 135, NULL, NULL, 131830),
(131831, '2.30.29.30-FF-001035', NULL, 'Rho guanine nucleotide exchange factor 17, putative', 151, NULL, NULL, 131831),
(131832, '1.10.510.10-FF-003327', NULL, NULL, 61, NULL, NULL, 131832),
(131833, '2.20.25.630-FF-000001', NULL, 'Poly [ADP-ribose] polymerase', 60, NULL, NULL, 131833),
(131834, '3.30.1440.10-FF-000015', NULL, 'Uncharacterized protein', 76, NULL, NULL, 131834),
(131835, '2.60.40.60-FF-000102', NULL, 'Dachsous cadherin-related 1b', 108, NULL, NULL, 131835),
(131836, '1.20.1250.20-FF-000676', NULL, 'Putative sugar transporter', 202, NULL, NULL, 131836);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(131837, '3.10.450.350-FF-000020', NULL, 'Uncharacterized metalloprotease HI_0409', 89, NULL, NULL, 131837),
(131838, '3.30.930.10-FF-000036', NULL, 'phenylalanine--tRNA ligase alpha subunit', 326, NULL, NULL, 131838),
(131839, '1.25.40.10-FF-001626', NULL, 'Os03g0216400 protein', 174, NULL, NULL, 131839),
(131840, '3.30.160.20-FF-000244', NULL, 'RNA interference promoting factor', 105, NULL, NULL, 131840),
(131841, '3.20.20.140-FF-000218', NULL, 'Amidohydrolase', 27, NULL, NULL, 131841),
(131842, '3.30.60.30-FF-000026', NULL, 'Insulin-like growth factor-binding protein 7', 47, NULL, NULL, 131842),
(131843, '1.10.260.30-FF-000014', NULL, 'Signal recognition particle protein', 136, NULL, NULL, 131843),
(131844, '1.20.910.10-FF-000045', NULL, 'Heme oxygenase 2', 119, NULL, NULL, 131844),
(131845, '1.10.418.70-FF-000005', NULL, 'IFT complex B', 141, NULL, NULL, 131845),
(131846, '1.10.287.130-FF-000185', NULL, 'Bacteriophytochrome protein', 87, NULL, NULL, 131846),
(131847, '3.20.20.190-FF-000126', NULL, NULL, 219, NULL, NULL, 131847),
(131848, '2.130.10.10-FF-001684', NULL, 'WD domain, G-beta repeat-containing protein', 240, NULL, NULL, 131848),
(131849, '2.60.40.10-FF-003617', NULL, NULL, 88, NULL, NULL, 131849),
(131850, '3.40.50.10130-FF-000051', NULL, 'Uncharacterized protein', 155, NULL, NULL, 131850),
(131851, '3.30.450.20-FF-000345', NULL, 'Uncharacterized protein', 123, NULL, NULL, 131851),
(131852, '1.10.418.60-FF-000002', NULL, 'Nuf2 family protein, expressed', 167, NULL, NULL, 131852),
(131853, '1.10.260.40-FF-000017', NULL, 'DNA-binding transcriptional regulator SfsB', 70, NULL, NULL, 131853),
(131854, '2.10.110.10-FF-000168', NULL, 'LIM Zinc finger domain containing protein', 68, NULL, NULL, 131854),
(131855, '3.30.70.330-FF-001328', NULL, 'Nuclear cap-binding protein subunit 2', 134, NULL, NULL, 131855),
(131856, '3.20.20.70-FF-000233', NULL, 'NAD(P)H-dependent glutamate synthase, putative', 354, NULL, NULL, 131856),
(131857, '2.40.50.140-FF-001078', NULL, NULL, 86, NULL, NULL, 131857),
(131858, '1.50.40.10-FF-000045', NULL, 'peroxisomal membrane protein PMP34 isoform X1', 95, NULL, NULL, 131858),
(131859, '1.10.405.10-FF-000036', NULL, 'Predicted protein', 114, NULL, NULL, 131859),
(131860, '1.10.10.10-FF-001618', NULL, 'Uncharacterized protein', 102, NULL, NULL, 131860),
(131861, '3.40.1190.20-FF-000119', NULL, 'Multifunctional fusion protein', 280, NULL, NULL, 131861),
(131862, '4.10.410.20-FF-000012', NULL, 'Poly(U)-specific endoribonuclease', 43, NULL, NULL, 131862),
(131863, '2.10.25.10-FF-000291', NULL, 'Transmembrane matrix receptor MUP-4', 47, NULL, NULL, 131863),
(131864, '3.30.60.20-FF-000023', NULL, 'RAS guanyl-releasing protein 1 isoform X1', 65, NULL, NULL, 131864),
(131865, '3.40.50.2300-FF-001620', NULL, NULL, 293, NULL, NULL, 131865),
(131866, '1.20.58.90-FF-000009', NULL, 'Tubulin-specific chaperone A', 108, NULL, NULL, 131866),
(131867, '2.70.150.10-FF-000033', NULL, 'Potassium-transporting ATPase ATP-binding subunit', 137, NULL, NULL, 131867),
(131868, '3.30.43.40-FF-000001', NULL, 'Pre-mRNA-processing-splicing factor 8', 120, NULL, NULL, 131868),
(131869, '2.40.50.140-FF-000971', NULL, NULL, 65, NULL, NULL, 131869),
(131870, '3.40.367.20-FF-000048', NULL, 'Phosphotransferase', 136, NULL, NULL, 131870),
(131871, '2.60.120.10-FF-000707', NULL, 'Chromosome 10, whole genome shotgun sequence', 129, NULL, NULL, 131871),
(131872, '3.40.630.30-FF-000118', NULL, 'N-acetyltransferase family 8 member 3', 131, NULL, NULL, 131872),
(131873, '1.25.40.70-FF-000048', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', 85, NULL, NULL, 131873),
(131874, '2.60.40.1940-FF-000007', NULL, 'Murinoglobulin-1', 119, NULL, NULL, 131874),
(131875, '1.25.40.10-FF-005230', NULL, 'Uncharacterized protein', 180, NULL, NULL, 131875),
(131876, '1.20.5.5260-FF-000001', NULL, 'Two-component-system connector protein AriR', 64, NULL, NULL, 131876),
(131877, '3.30.70.260-FF-000150', NULL, 'Uncharacterized protein', 86, NULL, NULL, 131877),
(131878, '2.40.10.10-FF-000699', NULL, NULL, 111, NULL, NULL, 131878);
INSERT INTO "PUBLIC"."MODEL" VALUES
(131879, '3.10.250.10-FF-000112', NULL, NULL, 113, NULL, NULL, 131879),
(131880, '2.40.10.230-FF-000006', NULL, 'H/ACA ribonucleoprotein complex subunit', 92, NULL, NULL, 131880),
(131881, '1.20.5.170-FF-000038', NULL, 'Short coiled-coil protein a', 82, NULL, NULL, 131881),
(131882, '3.30.160.60-FF-005079', NULL, NULL, 66, NULL, NULL, 131882),
(131883, '3.40.30.10-FF-000405', NULL, 'Thioredoxin 2', 87, NULL, NULL, 131883),
(131884, '3.40.50.2000-FF-000928', NULL, 'Glycosyltransferase', 156, NULL, NULL, 131884),
(131885, '1.25.10.10-FF-000113', NULL, 'Beta-adaptin-like protein A', 584, NULL, NULL, 131885),
(131886, '2.60.120.920-FF-000044', NULL, 'Tripartite motif-containing protein 10', 190, NULL, NULL, 131886),
(131887, '2.60.40.1930-FF-000004', NULL, 'Complement C4-A', 123, NULL, NULL, 131887),
(131888, '3.40.50.10190-FF-000192', NULL, 'Protein CBG13622', 107, NULL, NULL, 131888),
(131889, '3.30.70.330-FF-001087', NULL, 'RNA recognition motif domain-containing protein', 92, NULL, NULL, 131889),
(131890, '3.90.320.10-FF-000044', NULL, 'DNA replication ATP-dependent helicase/nuclease DNA2', 184, NULL, NULL, 131890),
(131891, '3.30.9.10-FF-000126', NULL, 'tRNA 5-methylaminomethyl-2-thiouridine biosynthesis bifunctional protein MnmC', 149, NULL, NULL, 131891),
(131892, '3.90.190.10-FF-000454', NULL, 'Protein-tyrosine phosphatase, putative', 219, NULL, NULL, 131892),
(131893, '2.20.100.10-FF-000047', NULL, 'Thrombospondin type 1 domain containing 4', 59, NULL, NULL, 131893),
(131894, '3.30.40.10-FF-002189', NULL, 'Uncharacterized protein', 78, NULL, NULL, 131894),
(131895, '1.50.10.10-FF-000156', NULL, 'alpha-1,2-Mannosidase', 287, NULL, NULL, 131895),
(131896, '1.10.472.30-FF-000017', NULL, NULL, 31, NULL, NULL, 131896),
(131897, '2.60.40.3210-FF-000012', NULL, 'deleted in malignant brain tumors 1 protein-like isoform X1', 107, NULL, NULL, 131897),
(131898, '3.30.1140.32-FF-000006', NULL, '30S ribosomal protein S3', 126, NULL, NULL, 131898),
(131899, '3.40.30.10-FF-000164', NULL, 'Thioredoxin domain containing 5', 134, NULL, NULL, 131899),
(131900, '1.20.58.340-FF-000055', NULL, 'Predicted protein', 185, NULL, NULL, 131900),
(131901, '3.40.50.620-FF-000364', NULL, 'Putative isoleucyl-tRNA synthetase', 279, NULL, NULL, 131901),
(131902, '1.25.10.10-FF-003480', NULL, 'eIF-2-alpha kinase activator GCN1', 228, NULL, NULL, 131902),
(131903, '1.25.40.20-FF-001629', NULL, 'Uncharacterized protein', 96, NULL, NULL, 131903),
(131904, '2.60.40.4100-FF-000026', NULL, 'ZP3 homolog', 88, NULL, NULL, 131904),
(131905, '2.60.40.1090-FF-000044', NULL, 'Probable fimbrial subunit CupB1', 156, NULL, NULL, 131905),
(131906, '2.60.40.150-FF-000102', NULL, 'Synaptotagmin-2 isoform A', 157, NULL, NULL, 131906),
(131907, '1.25.40.20-FF-001686', NULL, 'Poly [ADP-ribose] polymerase', 388, NULL, NULL, 131907),
(131908, '1.10.472.30-FF-000006', NULL, 'Transcription elongation factor S-II', 112, NULL, NULL, 131908),
(131909, '2.60.40.1480-FF-000004', NULL, 'Coatomer subunit gamma', 119, NULL, NULL, 131909),
(131910, '3.50.30.30-FF-000029', NULL, 'Glutamate carboxypeptidase Tre2, putative', 217, NULL, NULL, 131910),
(131911, '4.10.1000.10-FF-000087', NULL, 'Zinc finger CCCH domain-containing protein 33', 54, NULL, NULL, 131911),
(131912, '3.40.50.300-FF-002027', NULL, 'ABC transporter ATP-binding protein', 285, NULL, NULL, 131912),
(131913, '2.60.40.1470-FF-000001', NULL, 'DNA polymerase delta-interacting protein 2', 127, NULL, NULL, 131913),
(131914, '3.20.20.60-FF-000117', NULL, '2,4-dihydroxyhept-2-ene-1,7-dioic acid aldolase', 109, NULL, NULL, 131914),
(131915, '3.30.160.60-FF-002083', NULL, 'zinc finger protein 606', 27, NULL, NULL, 131915),
(131916, '1.20.5.5270-FF-000004', NULL, 'Lon protease', 49, NULL, NULL, 131916),
(131917, '3.40.50.720-FF-000798', NULL, '2-hydroxyacid dehydrogenase', 92, NULL, NULL, 131917),
(131918, '1.25.10.10-FF-001866', NULL, 'Uncharacterized protein', 166, NULL, NULL, 131918),
(131919, '3.20.20.140-FF-000370', NULL, 'Uncharacterized protein', 223, NULL, NULL, 131919),
(131920, '3.40.1380.20-FF-000044', NULL, 'Pyruvate kinase', 141, NULL, NULL, 131920);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(131921, '2.30.30.140-FF-000306', NULL, 'DNA mismatch repair protein', 124, NULL, NULL, 131921),
(131922, '1.10.287.110-FF-000122', NULL, 'DnaJ domain protein', 95, NULL, NULL, 131922),
(131923, '3.30.300.20-FF-000003', NULL, 'GTPase Era', 114, NULL, NULL, 131923),
(131924, '3.50.50.60-FF-000753', NULL, 'Alcohol dehydrogenase', 319, NULL, NULL, 131924),
(131925, '1.10.287.370-FF-000060', NULL, 'Prefoldin, alpha subunit', 133, NULL, NULL, 131925),
(131926, '1.20.120.850-FF-000033', NULL, 'RAD54 homolog B', 28, NULL, NULL, 131926),
(131927, '3.30.2290.10-FF-000014', NULL, 'TldD protein, part of TldE/TldD proteolytic complex', 209, NULL, NULL, 131927),
(131928, '3.30.310.130-FF-000020', NULL, 'Uncharacterized protein', 48, NULL, NULL, 131928),
(131929, '1.10.287.130-FF-000128', NULL, 'Sensory box sensor histidine kinase', 125, NULL, NULL, 131929),
(131930, '1.25.40.10-FF-004499', NULL, 'Uncharacterized protein', 93, NULL, NULL, 131930),
(131931, '3.40.50.2300-FF-000726', NULL, 'Heme response regulator HssR', 129, NULL, NULL, 131931),
(131932, '3.40.50.360-FF-000139', NULL, 'Quinone oxidoreductase family protein', 179, NULL, NULL, 131932),
(131933, '3.80.10.10-FF-000392', NULL, 'centrosomal protein of 97 kDa isoform X1', 84, NULL, NULL, 131933),
(131934, '2.40.270.10-FF-000015', NULL, 'DNA-directed RNA polymerase subunit beta', 224, NULL, NULL, 131934),
(131935, '1.10.150.110-FF-000033', NULL, 'Uncharacterized protein', 71, NULL, NULL, 131935),
(131936, '2.60.120.10-FF-000146', NULL, 'Cupin-like protein, putative', 113, NULL, NULL, 131936),
(131937, '2.60.40.60-FF-000720', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1', 99, NULL, NULL, 131937),
(131938, '3.30.160.60-FF-003842', NULL, NULL, 31, NULL, NULL, 131938),
(131939, '2.130.10.10-FF-006012', NULL, 'Probable U3 small nucleolar RNA-associated protein 13', 185, NULL, NULL, 131939),
(131940, '3.30.70.1170-FF-000007', NULL, 'Putative 28S rRNA (Cytosine-C(5))-methyltransferase', 65, NULL, NULL, 131940),
(131941, '1.25.10.10-FF-002142', NULL, 'Uncharacterized protein', 551, NULL, NULL, 131941),
(131942, '3.40.50.300-FF-005793', NULL, 'Discs, large homolog 4', 67, NULL, NULL, 131942),
(131943, '1.10.10.10-FF-001894', NULL, 'Predicted protein', 75, NULL, NULL, 131943),
(131944, '1.10.1200.120-FF-000007', NULL, 'Large-conductance mechanosensitive channel', 141, NULL, NULL, 131944),
(131945, '3.40.1110.10-FF-000078', NULL, 'Calcium-transporting ATPase', 149, NULL, NULL, 131945),
(131946, '1.25.40.10-FF-003217', NULL, 'Pentatricopeptide repeat-containing protein At1g10910, chloroplastic', 69, NULL, NULL, 131946),
(131947, '3.30.60.90-FF-000027', NULL, 'Related to ADA2-general transcriptional adaptor or co-activator', 55, NULL, NULL, 131947),
(131948, '3.30.40.10-FF-001093', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 65, NULL, NULL, 131948),
(131949, '2.130.10.10-FF-001807', NULL, 'p21-activated protein kinase-interacting protein 1', 173, NULL, NULL, 131949),
(131950, '2.120.10.80-FF-000103', NULL, 'F-box/kelch-repeat protein At5g42360', 206, NULL, NULL, 131950),
(131951, '3.40.50.300-FF-002302', NULL, 'Sulfotransferase', 277, NULL, NULL, 131951),
(131952, '3.30.160.60-FF-001863', NULL, 'zinc finger protein 407', 77, NULL, NULL, 131952),
(131953, '3.40.50.10190-FF-000315', NULL, 'Predicted protein', 94, NULL, NULL, 131953),
(131954, '2.60.40.2300-FF-000014', NULL, 'Ceramidase, putative', 48, NULL, NULL, 131954),
(131955, '3.30.230.10-FF-000348', NULL, 'Elongation factor G, mitochondrial', 11, NULL, NULL, 131955),
(131956, '1.20.1560.10-FF-000494', NULL, 'Os01g0911300 protein', 114, NULL, NULL, 131956),
(131957, '2.30.29.30-FF-000872', NULL, 'LOC100124981 protein', 121, NULL, NULL, 131957),
(131958, '2.30.29.30-FF-000198', NULL, 'Myotubularin related protein 10', 119, NULL, NULL, 131958),
(131959, '1.20.120.1770-FF-000024', NULL, 'Uncharacterized protein', 90, NULL, NULL, 131959),
(131960, '3.40.50.450-FF-000015', NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase', 177, NULL, NULL, 131960),
(131961, '3.30.420.270-FF-000024', NULL, 'Transport energizing protein, ExbD/TolR family', 68, NULL, NULL, 131961);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(131962, '3.40.50.300-FF-003584', NULL, 'GD25570', 212, NULL, NULL, 131962),
(131963, '1.10.2000.10-FF-000084', NULL, NULL, 132, NULL, NULL, 131963),
(131964, '3.30.1310.10-FF-000011', NULL, 'Nucleoid-associated protein D6716_02630', 97, NULL, NULL, 131964),
(131965, '1.10.533.10-FF-000081', NULL, 'Apoptotic protease-activating factor 1', 94, NULL, NULL, 131965),
(131966, '2.60.40.1290-FF-000003', NULL, 'Cell wall surface anchor family protein', 164, NULL, NULL, 131966),
(131967, '1.20.5.1200-FF-000008', NULL, 'Cellular retinaldehyde binding protein', 30, NULL, NULL, 131967),
(131968, '2.170.16.10-FF-000037', NULL, 'Large helicase-related protein', 155, NULL, NULL, 131968),
(131969, '2.60.40.10-FF-005360', NULL, NULL, 65, NULL, NULL, 131969),
(131970, '2.40.10.240-FF-000009', NULL, NULL, 99, NULL, NULL, 131970),
(131971, '3.10.350.10-FF-000047', NULL, 'Predicted protein', 51, NULL, NULL, 131971),
(131972, '3.10.450.580-FF-000004', NULL, 'Mediator of RNA polymerase II transcription subunit 6', 143, NULL, NULL, 131972),
(131973, '2.60.40.790-FF-000035', NULL, '22.0 kDa heat shock protein', 143, NULL, NULL, 131973),
(131974, '1.10.8.60-FF-000172', NULL, 'Nuclear valosin-containing protein-like', 97, NULL, NULL, 131974),
(131975, '2.30.29.30-FF-001310', NULL, 'Predicted protein', 76, NULL, NULL, 131975),
(131976, '1.20.1260.100-FF-000009', NULL, NULL, 52, NULL, NULL, 131976),
(131977, '3.40.50.300-FF-005736', NULL, 'Ciliary dynein heavy chain 11', 151, NULL, NULL, 131977),
(131978, '3.40.50.1780-FF-000002', NULL, 'Cytosolic Fe-S cluster assembly factor nar1', 142, NULL, NULL, 131978),
(131979, '3.30.160.60-FF-000054', NULL, 'Zinc finger protein 711', 31, NULL, NULL, 131979),
(131980, '1.10.10.790-FF-000011', NULL, 'Splicing factor, suppressor of white-apricot', 73, NULL, NULL, 131980),
(131981, '2.30.30.1020-FF-000013', NULL, 'CCR4-NOT transcriptional complex subunit', 151, NULL, NULL, 131981),
(131982, '1.20.120.1240-FF-000039', NULL, 'Protein CBG20134', 207, NULL, NULL, 131982),
(131983, '1.20.1250.20-FF-000951', NULL, 'AmpG protein, beta-lactamase induction signal transducer', 197, NULL, NULL, 131983),
(131984, '2.130.10.10-FF-001066', NULL, 'WD repeat domain 90', 286, NULL, NULL, 131984),
(131985, '3.10.620.30-FF-000017', NULL, 'Centrosomal protein of 76 kDa', 107, NULL, NULL, 131985),
(131986, '1.25.40.20-FF-001809', NULL, 'Uncharacterized protein', 163, NULL, NULL, 131986),
(131987, '1.10.630.10-FF-000407', NULL, 'Chromosome 1, whole genome shotgun sequence', 523, NULL, NULL, 131987),
(131988, '3.30.70.330-FF-001441', NULL, 'Bruno 2, isoform F', 58, NULL, NULL, 131988),
(131989, '3.30.565.10-FF-000131', NULL, 'Sensor histidine kinase/response regulator, putative', 184, NULL, NULL, 131989),
(131990, '3.90.550.20-FF-000036', NULL, 'Predicted protein', 192, NULL, NULL, 131990),
(131991, '1.20.1050.10-FF-000192', NULL, 'Uncharacterized protein', 117, NULL, NULL, 131991),
(131992, '3.40.50.300-FF-001864', NULL, 'DNA repair protein RAD16', 194, NULL, NULL, 131992),
(131993, '3.30.40.10-FF-001036', NULL, 'Lysine-specific demethylase 5B', 69, NULL, NULL, 131993),
(131994, '2.60.120.920-FF-000123', NULL, 'Uncharacterized protein', 172, NULL, NULL, 131994),
(131995, '3.30.70.330-FF-000547', NULL, 'Serine/arginine-rich splicing factor 4', 83, NULL, NULL, 131995),
(131996, '3.40.720.10-FF-000119', NULL, 'GM20960', 214, NULL, NULL, 131996),
(131997, '3.40.50.2020-FF-000114', NULL, 'Orotate phosphoribosyltransferase', 184, NULL, NULL, 131997),
(131998, '3.30.160.60-FF-002206', NULL, NULL, 27, NULL, NULL, 131998),
(131999, '1.20.1250.20-FF-000058', NULL, 'ascorbate transporter, chloroplastic isoform X1', 201, NULL, NULL, 131999),
(132000, '1.20.120.1760-FF-000021', NULL, 'CDP-diacylglycerol--inositol 3-phosphatidyltransferase', 181, NULL, NULL, 132000),
(132001, '2.60.40.2840-FF-000002', NULL, 'Tax1-binding protein 1 isoform 2', 114, NULL, NULL, 132001),
(132002, '4.10.900.10-FF-000030', NULL, 'Cadherin 19, type 2', 87, NULL, NULL, 132002),
(132003, '1.20.1250.20-FF-000619', NULL, 'Unplaced genomic scaffold supercont2.3, whole genome shotgun sequence', 208, NULL, NULL, 132003);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(132004, '1.10.132.70-FF-000009', NULL, 'Telomerase reverse transcriptase', 225, NULL, NULL, 132004),
(132005, '3.10.50.40-FF-000136', NULL, 'Peptidylprolyl isomerase', 101, NULL, NULL, 132005),
(132006, '3.40.50.2300-FF-001002', NULL, NULL, 145, NULL, NULL, 132006),
(132007, '1.25.10.10-FF-001248', NULL, 'Adenomatous polyposis coli protein, putative', 292, NULL, NULL, 132007),
(132008, '3.80.10.10-FF-000953', NULL, 'Leucine-rich repeat containing protein', 99, NULL, NULL, 132008),
(132009, '3.30.200.20-FF-001131', NULL, 'Protein CBG00447', 70, NULL, NULL, 132009),
(132010, '3.40.50.1400-FF-000001', NULL, 'Ferrochelatase', 143, NULL, NULL, 132010),
(132011, '2.60.120.970-FF-000042', NULL, 'AGAP011934-PA', 253, NULL, NULL, 132011),
(132012, '1.10.390.10-FF-000012', NULL, 'Thermolysin', 161, NULL, NULL, 132012),
(132013, '3.10.20.90-FF-000008', NULL, 'Ubiquitin-40S ribosomal protein S27a', 79, NULL, NULL, 132013),
(132014, '1.10.10.10-FF-001411', NULL, 'Transcriptional regulator, ArsR family', 114, NULL, NULL, 132014),
(132015, '3.30.160.60-FF-003488', NULL, NULL, 31, NULL, NULL, 132015),
(132016, '1.20.1250.10-FF-000055', NULL, 'Predicted gene 13275', 147, NULL, NULL, 132016),
(132017, '3.40.1010.10-FF-000014', NULL, 'Uroporphyrinogen-III C-methyltransferase', 119, NULL, NULL, 132017),
(132018, '3.30.559.10-FF-000089', NULL, 'Putative carnitine/choline acetyltransferase', 269, NULL, NULL, 132018),
(132019, '3.10.20.310-FF-000030', NULL, 'Outer membrane protein assembly factor', 81, NULL, NULL, 132019),
(132020, '1.20.120.20-FF-000044', NULL, 'Tail tape measure protein gp18', 116, NULL, NULL, 132020),
(132021, '1.10.1200.270-FF-000024', NULL, 'Uncharacterized protein', 28, NULL, NULL, 132021),
(132022, '3.40.50.80-FF-000057', NULL, 'FAD-binding domain-domain-containing protein', 179, NULL, NULL, 132022),
(132023, '3.60.21.60-FF-000022', NULL, 'DNA polymerase alpha subunit B', 162, NULL, NULL, 132023),
(132024, '1.10.510.10-FF-004108', NULL, NULL, 126, NULL, NULL, 132024),
(132025, '2.60.40.10-FF-005921', NULL, NULL, 109, NULL, NULL, 132025),
(132026, '3.60.10.10-FF-000241', NULL, 'Uncharacterized protein', 299, NULL, NULL, 132026),
(132027, '1.10.10.60-FF-001055', NULL, NULL, 55, NULL, NULL, 132027),
(132028, '3.40.605.10-FF-000071', NULL, '2-aminomuconic acid semialdehyde dehydrogenase', 256, NULL, NULL, 132028),
(132029, '1.25.40.10-FF-001806', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 93, NULL, NULL, 132029),
(132030, '3.90.550.10-FF-000033', NULL, 'Exostosin-like glycosyltransferase 3', 254, NULL, NULL, 132030),
(132031, '3.40.50.1820-FF-001234', NULL, 'Protein phosphatase methylesterase 1', 334, NULL, NULL, 132031),
(132032, '1.50.40.10-FF-000225', NULL, 'Mitochondrial ornithine transporter 1', 202, NULL, NULL, 132032),
(132033, '1.20.5.990-FF-000014', NULL, 'Kenny, isoform B', 79, NULL, NULL, 132033),
(132034, '2.40.50.40-FF-000019', NULL, 'C-C motif chemokine 27', 57, NULL, NULL, 132034),
(132035, '3.60.20.10-FF-000062', NULL, 'Proteasome subunit alpha type', 246, NULL, NULL, 132035),
(132036, '4.10.400.10-FF-000334', NULL, 'Uncharacterized protein', 39, NULL, NULL, 132036),
(132037, '1.20.58.190-FF-000021', NULL, NULL, 105, NULL, NULL, 132037),
(132038, '1.20.1070.10-FF-000928', NULL, 'Predicted gene 5127', 218, NULL, NULL, 132038),
(132039, '2.60.40.1120-FF-000031', NULL, 'Colicin I receptor', 74, NULL, NULL, 132039),
(132040, '2.60.40.10-FF-001588', NULL, 'Neuregulin 2a', 102, NULL, NULL, 132040),
(132041, '1.10.540.10-FF-000013', NULL, 'Acyl-CoA dehydrogenase', 117, NULL, NULL, 132041),
(132042, '3.40.50.1000-FF-000145', NULL, 'HAD family hydrolase', 154, NULL, NULL, 132042),
(132043, '1.10.10.60-FF-001229', NULL, NULL, 39, NULL, NULL, 132043),
(132044, '3.80.10.10-FF-000066', NULL, 'Nuclear RNA export factor 1', 160, NULL, NULL, 132044),
(132045, '3.40.50.200-FF-000182', NULL, 'Predicted protein', 292, NULL, NULL, 132045),
(132046, '3.40.50.1000-FF-000201', NULL, 'Piso0_001792 protein', 55, NULL, NULL, 132046),
(132047, '2.40.50.140-FF-000696', NULL, NULL, 107, NULL, NULL, 132047);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(132048, '3.30.1490.180-FF-000004', NULL, 'DNA-directed RNA polymerase subunit', 53, NULL, NULL, 132048),
(132049, '3.10.580.10-FF-000154', NULL, 'Uncharacterized protein', 176, NULL, NULL, 132049),
(132050, '3.40.50.300-FF-000442', NULL, 'NACHT, LRR and PYD domains-containing protein 3', 207, NULL, NULL, 132050),
(132051, '2.10.25.10-FF-001313', NULL, 'Uncharacterized protein', 28, NULL, NULL, 132051),
(132052, '1.10.510.10-FF-000511', NULL, 'Serine/threonine-protein kinase Chk1', 179, NULL, NULL, 132052),
(132053, '3.30.1370.110-FF-000018', NULL, 'SMR domain protein', 132, NULL, NULL, 132053),
(132054, '1.20.1740.10-FF-000087', NULL, 'Proline permease, putative', 457, NULL, NULL, 132054),
(132055, '3.90.226.10-FF-000111', NULL, 'Serine protease SPPA, chloroplastic', 149, NULL, NULL, 132055),
(132056, '3.30.1490.190-FF-000007', NULL, 'Fur family transcriptional regulator', 58, NULL, NULL, 132056),
(132057, '3.40.1030.10-FF-000015', NULL, 'Bifunctional protein TrpGD', 269, NULL, NULL, 132057),
(132058, '1.20.1740.10-FF-000143', NULL, 'Uncharacterized protein', 444, NULL, NULL, 132058),
(132059, '3.60.40.10-FF-000057', NULL, 'Phosphatase', 226, NULL, NULL, 132059),
(132060, '2.60.40.10-FF-003735', NULL, NULL, 89, NULL, NULL, 132060),
(132061, '1.20.1070.10-FF-000294', NULL, 'Glucose-dependent insulinotropic receptor', 296, NULL, NULL, 132061),
(132062, '2.60.20.10-FF-000007', NULL, 'Crystallin gamma N', 89, NULL, NULL, 132062),
(132063, '3.30.200.20-FF-001316', NULL, 'Protein kinase, putative', 119, NULL, NULL, 132063),
(132064, '3.90.190.10-FF-000286', NULL, 'Tyrosine-protein phosphatase', 138, NULL, NULL, 132064),
(132065, '2.40.30.10-FF-000003', NULL, 'Elongation factor 1-alpha', 88, NULL, NULL, 132065),
(132066, '2.40.30.20-FF-000006', NULL, 'Riboflavin synthase, alpha subunit', 95, NULL, NULL, 132066),
(132067, '3.30.40.10-FF-000328', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 94, NULL, NULL, 132067),
(132068, '3.30.505.10-FF-000026', NULL, 'adapter molecule crk isoform X1', 122, NULL, NULL, 132068),
(132069, '1.10.1280.10-FF-000008', NULL, 'Protein CBR-TYR-2', 279, NULL, NULL, 132069),
(132070, '2.130.10.10-FF-001622', NULL, 'Dynein intermediate chain, putative', 194, NULL, NULL, 132070),
(132071, '1.10.520.10-FF-000051', NULL, 'Uncharacterized protein', 59, NULL, NULL, 132071),
(132072, '2.40.30.30-FF-000009', NULL, 'Riboflavin biosynthesis protein', 138, NULL, NULL, 132072),
(132073, '1.25.40.10-FF-003493', NULL, 'Pentatricopeptide repeat-containing protein At5g12100, mitochondrial', 72, NULL, NULL, 132073),
(132074, '1.10.510.10-FF-001708', NULL, 'Protein kinase superfamily protein', 117, NULL, NULL, 132074),
(132075, '3.40.50.1010-FF-000204', NULL, NULL, 184, NULL, NULL, 132075),
(132076, '3.40.1010.10-FF-000020', NULL, NULL, 108, NULL, NULL, 132076),
(132077, '3.40.50.300-FF-006799', NULL, 'Uncharacterized protein', 54, NULL, NULL, 132077),
(132078, '3.30.70.330-FF-000985', NULL, 'YGR250C-like protein', 119, NULL, NULL, 132078),
(132079, '1.25.40.10-FF-001357', NULL, 'Cell division cycle 27, isoform A', 77, NULL, NULL, 132079),
(132080, '3.40.50.1820-FF-000913', NULL, 'Uncharacterized serine carboxypeptidase C08H9.1', 476, NULL, NULL, 132080),
(132081, '3.20.10.10-FF-000063', NULL, 'Aminotransferase, class IV family protein', 77, NULL, NULL, 132081),
(132082, '1.20.58.60-FF-000809', NULL, 'Uncharacterized protein', 196, NULL, NULL, 132082),
(132083, '3.40.50.150-FF-000138', NULL, 'BCDIN3 domain containing RNA methyltransferase', 241, NULL, NULL, 132083),
(132084, '3.40.50.2000-FF-001069', NULL, 'Uncharacterized protein', 76, NULL, NULL, 132084),
(132085, '3.40.50.720-FF-000629', NULL, 'UDP-glucose 4-epimerase', 216, NULL, NULL, 132085),
(132086, '3.60.110.10-FF-000046', NULL, 'YIL165C', 116, NULL, NULL, 132086),
(132087, '1.10.150.20-FF-000149', NULL, 'DNA ligase', 67, NULL, NULL, 132087),
(132088, '2.130.10.10-FF-005837', NULL, 'Uncharacterized protein', 364, NULL, NULL, 132088),
(132089, '1.10.565.10-FF-000042', NULL, 'Nuclear receptor subfamily 1, group H, member 5', 265, NULL, NULL, 132089);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(132090, '3.90.1750.10-FF-000064', NULL, 'E3 ubiquitin-protein ligase HACE1', 127, NULL, NULL, 132090),
(132091, '1.10.357.140-FF-000047', NULL, 'Uncharacterized protein', 97, NULL, NULL, 132091),
(132092, '3.40.850.10-FF-000449', NULL, 'Uncharacterized protein', 98, NULL, NULL, 132092),
(132093, '1.25.40.120-FF-000076', NULL, 'Uncharacterized protein', 410, NULL, NULL, 132093),
(132094, '3.90.1200.10-FF-000034', NULL, 'hydroxylysine kinase', 211, NULL, NULL, 132094),
(132095, '1.10.560.10-FF-000115', NULL, 'Uncharacterized protein', 250, NULL, NULL, 132095),
(132096, '3.40.50.1440-FF-000142', NULL, 'Uncharacterized protein', 50, NULL, NULL, 132096),
(132097, '3.60.10.10-FF-000229', NULL, 'Uncharacterized protein', 237, NULL, NULL, 132097),
(132098, '3.60.21.10-FF-000316', NULL, 'Putative integral membrane protein, with calcineurin-like phosphoesterase domain', 207, NULL, NULL, 132098),
(132099, '3.30.420.10-FF-000273', NULL, 'DNA polymerase 3', 209, NULL, NULL, 132099),
(132100, '2.60.40.10-FF-001537', NULL, 'Fasciclin 2, isoform D', 98, NULL, NULL, 132100),
(132101, '3.30.160.60-FF-005399', NULL, NULL, 22, NULL, NULL, 132101),
(132102, '2.130.10.10-FF-001566', NULL, 'WD_domain_-_G-beta_repeat_-_putative', 179, NULL, NULL, 132102),
(132103, '1.25.40.20-FF-001309', NULL, 'Uncharacterized protein', 431, NULL, NULL, 132103),
(132104, '3.40.50.2300-FF-001064', NULL, NULL, 93, NULL, NULL, 132104),
(132105, '3.90.226.10-FF-000004', NULL, 'Methylcrotonoyl-CoA carboxylase beta chain', 262, NULL, NULL, 132105),
(132106, '1.20.120.160-FF-000028', NULL, 'Chemotaxis protein CheA', 140, NULL, NULL, 132106),
(132107, '3.30.160.20-FF-000126', NULL, 'RF-1 domain-domain-containing protein', 115, NULL, NULL, 132107),
(132108, '1.10.287.70-FF-000604', NULL, 'Uncharacterized protein', 300, NULL, NULL, 132108),
(132109, '2.60.40.10-FF-001644', NULL, 'Eph receptor tyrosine kinase', 113, NULL, NULL, 132109),
(132110, '3.90.190.10-FF-000393', NULL, 'TeNSin homolog', 161, NULL, NULL, 132110),
(132111, '3.40.50.300-FF-005169', NULL, 'Uncharacterized protein', 222, NULL, NULL, 132111),
(132112, '2.130.10.30-FF-000094', NULL, NULL, 137, NULL, NULL, 132112),
(132113, '3.30.70.260-FF-000149', NULL, 'Tyrosine/tryptophan monooxygenase, putative', 81, NULL, NULL, 132113),
(132114, '1.10.510.10-FF-000404', NULL, 'Guanylate cyclase', 254, NULL, NULL, 132114),
(132115, '3.40.50.20-FF-000056', NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', 117, NULL, NULL, 132115),
(132116, '3.40.50.1820-FF-000857', NULL, 'Carboxypeptidase', 330, NULL, NULL, 132116),
(132117, '1.10.630.10-FF-000458', NULL, 'Cyp2d34 protein', 227, NULL, NULL, 132117),
(132118, '3.40.50.2000-FF-001125', NULL, 'Alpha-1,4 glucan phosphorylase', 147, NULL, NULL, 132118),
(132119, '1.50.40.10-FF-000551', NULL, 'Uncharacterized protein', 132, NULL, NULL, 132119),
(132120, '3.40.800.20-FF-000033', NULL, 'Histone deacetylase HOS3', 446, NULL, NULL, 132120),
(132121, '3.40.50.150-FF-000998', NULL, NULL, 209, NULL, NULL, 132121),
(132122, '3.40.50.300-FF-007474', NULL, 'Ribose ABC transporter, ATP-binding protein', 238, NULL, NULL, 132122),
(132123, '3.40.532.10-FF-000002', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 238, NULL, NULL, 132123),
(132124, '3.30.160.60-FF-006242', NULL, NULL, 34, NULL, NULL, 132124),
(132125, '1.10.220.10-FF-000011', NULL, 'Annexin', 72, NULL, NULL, 132125),
(132126, '3.40.50.150-FF-001780', NULL, NULL, 187, NULL, NULL, 132126),
(132127, '1.10.10.10-FF-001057', NULL, 'IclR family transcriptional regulator', 77, NULL, NULL, 132127),
(132128, '1.25.10.10-FF-001574', NULL, 'Uncharacterized protein', 340, NULL, NULL, 132128),
(132129, '3.20.20.100-FF-000055', NULL, 'Putative oxidoreductase, chloroplastic', 327, NULL, NULL, 132129),
(132130, '3.30.30.30-FF-000024', NULL, '105/110 kDa heat shock protein/ nucleotide-binding domain', 58, NULL, NULL, 132130),
(132131, '1.25.40.420-FF-000008', NULL, 'BTB/POZ domain-containing protein POB1', 105, NULL, NULL, 132131),
(132132, '1.25.40.400-FF-000002', NULL, 'Transcriptional regulator, MutR family', 170, NULL, NULL, 132132);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(132133, '3.30.505.10-FF-000245', NULL, NULL, 60, NULL, NULL, 132133),
(132134, '3.30.1340.30-FF-000002', NULL, 'LysM domain/BON superfamily protein', 67, NULL, NULL, 132134),
(132135, '2.20.25.690-FF-000002', NULL, 'Tripeptidyl peptidase 2', 55, NULL, NULL, 132135),
(132136, '3.40.50.300-FF-005495', NULL, 'Septin 7', 187, NULL, NULL, 132136),
(132137, '3.20.20.470-FF-000002', NULL, 'Dextransucrase', 290, NULL, NULL, 132137),
(132138, '1.10.10.10-FF-001950', NULL, 'Uncharacterized protein', 81, NULL, NULL, 132138),
(132139, '1.10.287.1490-FF-000104', NULL, 'GRIP1-associated protein 1', 170, NULL, NULL, 132139),
(132140, '2.130.10.10-FF-003606', NULL, 'Katanin p80 WD40 repeat-containing subunit B1 homolog', 236, NULL, NULL, 132140),
(132141, '3.40.50.620-FF-000706', NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', 344, NULL, NULL, 132141),
(132142, '1.10.510.10-FF-000230', NULL, 'protein-tyrosine kinase 2-beta isoform X2', 183, NULL, NULL, 132142),
(132143, '3.90.70.10-FF-000029', NULL, 'ubiquitin carboxyl-terminal hydrolase 48 isoform X1', 336, NULL, NULL, 132143),
(132144, '3.40.50.300-FF-003819', NULL, 'Hsp70 subfamily B suppressor 1', 245, NULL, NULL, 132144),
(132145, '1.25.40.410-FF-000005', NULL, 'Uncharacterized protein, isoform G', 152, NULL, NULL, 132145),
(132146, '4.10.400.10-FF-000008', NULL, 'Low density lipoprotein receptor-related protein 1', 40, NULL, NULL, 132146),
(132147, '3.30.450.380-FF-000007', NULL, 'Type VI secretion protein', 227, NULL, NULL, 132147),
(132148, '3.40.50.300-FF-007530', NULL, 'Uncharacterized protein', 207, NULL, NULL, 132148),
(132149, '1.10.630.10-FF-000402', NULL, 'Uncharacterized protein', 488, NULL, NULL, 132149),
(132150, '3.20.20.70-FF-000272', NULL, 'Glycerol uptake operon antiterminator regulatory protein', 187, NULL, NULL, 132150),
(132151, '1.10.437.10-FF-000054', NULL, 'Predicted protein', 105, NULL, NULL, 132151),
(132152, '3.30.2410.10-FF-000013', NULL, 'Apoptosis-resistant E3 ubiquitin protein ligase 1', 115, NULL, NULL, 132152),
(132153, '2.130.10.10-FF-001515', NULL, 'Transducin family protein / WD-40 repeat family protein', 234, NULL, NULL, 132153),
(132154, '3.30.70.850-FF-000017', NULL, 'Uncharacterized protein', 51, NULL, NULL, 132154),
(132155, '3.20.80.10-FF-000011', NULL, 'Heme-binding-like protein, chloroplastic', 76, NULL, NULL, 132155),
(132156, '2.60.40.10-FF-002431', NULL, 'Si:ch211-222k6.3', 106, NULL, NULL, 132156),
(132157, '3.20.20.80-FF-000275', NULL, 'Mannan endo-1,4-beta-mannosidase. Glycosyl Hydrolase family 5', 357, NULL, NULL, 132157),
(132158, '3.70.10.10-FF-000100', NULL, 'Uncharacterized protein', 323, NULL, NULL, 132158),
(132159, '2.60.40.10-FF-005129', NULL, NULL, 97, NULL, NULL, 132159),
(132160, '2.40.50.140-FF-000589', NULL, 'Single-stranded DNA-binding protein, mitochondrial', 121, NULL, NULL, 132160),
(132161, '1.25.40.10-FF-004853', NULL, 'Pentatricopeptide repeat-containing protein', 131, NULL, NULL, 132161),
(132162, '3.30.200.20-FF-001423', NULL, 'Cell division protein kinase 6', 49, NULL, NULL, 132162),
(132163, '1.25.40.210-FF-000007', NULL, 'Telomeric repeat-binding factor 2', 63, NULL, NULL, 132163),
(132164, '1.10.287.110-FF-000201', NULL, 'Heat shock protein binding protein', 47, NULL, NULL, 132164),
(132165, '1.10.10.160-FF-000064', NULL, 'UvrD/REP helicase family protein', 65, NULL, NULL, 132165),
(132166, '3.30.200.20-FF-001642', NULL, NULL, 89, NULL, NULL, 132166),
(132167, '3.30.230.10-FF-000298', NULL, 'ATPase, putative', 138, NULL, NULL, 132167),
(132168, '3.80.10.10-FF-000285', NULL, 'F-box/LRR-repeat protein 2 isoform X1', 71, NULL, NULL, 132168),
(132169, '3.40.50.300-FF-001802', NULL, 'Uridine-cytidine kinase 1', 208, NULL, NULL, 132169),
(132170, '1.10.287.70-FF-000374', NULL, 'Ion_transport_protein_-_putative', 106, NULL, NULL, 132170),
(132171, '3.40.50.360-FF-000151', NULL, 'AGAP008256-PA', 61, NULL, NULL, 132171),
(132172, '1.10.1380.10-FF-000016', NULL, 'BcDNA.GH07188', 336, NULL, NULL, 132172),
(132173, '2.40.50.140-FF-001213', NULL, NULL, 80, NULL, NULL, 132173),
(132174, '3.40.710.10-FF-000170', NULL, 'Penicillin-binding protein 2', 195, NULL, NULL, 132174);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(132175, '3.60.21.10-FF-000204', NULL, 'Metallo-dependent phosphatase-like protein', 304, NULL, NULL, 132175),
(132176, '3.40.850.10-FF-000505', NULL, 'Putative kinesin', 292, NULL, NULL, 132176),
(132177, '2.30.30.40-FF-000035', NULL, 'SH3 domain containing protein', 71, NULL, NULL, 132177),
(132178, '1.20.1250.20-FF-001699', NULL, 'Predicted protein', 126, NULL, NULL, 132178),
(132179, '3.30.70.270-FF-000271', NULL, NULL, 147, NULL, NULL, 132179),
(132180, '3.30.460.10-FF-000163', NULL, 'Uncharacterized protein', 146, NULL, NULL, 132180),
(132181, '1.10.8.60-FF-000177', NULL, 'AAA family ATPase', 27, NULL, NULL, 132181),
(132182, '3.40.50.720-FF-002193', NULL, 'Nedd8-activating enzyme E1 regulatory subunit-like Protein', 332, NULL, NULL, 132182),
(132183, '1.10.510.10-FF-003384', NULL, NULL, 319, NULL, NULL, 132183),
(132184, '2.130.10.10-FF-002004', NULL, 'Uncharacterized protein', 136, NULL, NULL, 132184),
(132185, '2.30.29.30-FF-000580', NULL, 'Exocyst complex component', 109, NULL, NULL, 132185),
(132186, '3.60.40.10-FF-000276', NULL, 'Protein phosphatase', 251, NULL, NULL, 132186),
(132187, '3.40.50.720-FF-001523', NULL, 'Uncharacterized protein', 291, NULL, NULL, 132187),
(132188, '3.30.450.20-FF-000671', NULL, 'Uncharacterized protein', 95, NULL, NULL, 132188),
(132189, '2.10.25.10-FF-000526', NULL, 'Dumpy, isoform J', 42, NULL, NULL, 132189),
(132190, '3.30.450.20-FF-000519', NULL, 'Sll0779 protein', 73, NULL, NULL, 132190),
(132191, '1.10.472.80-FF-000274', NULL, NULL, 132, NULL, NULL, 132191),
(132192, '1.25.40.20-FF-001635', NULL, 'Uncharacterized protein', 95, NULL, NULL, 132192),
(132193, '2.60.40.1730-FF-000045', NULL, 'Transcription initiation factor TFIID subunit 2', 227, NULL, NULL, 132193),
(132194, '2.40.50.40-FF-000126', NULL, 'Histone-lysine N-methyltransferase', 62, NULL, NULL, 132194),
(132195, '3.40.50.300-FF-007316', NULL, 'Uncharacterized protein', 147, NULL, NULL, 132195),
(132196, '3.50.30.30-FF-000035', NULL, 'Signal peptide peptidase like 2C', 122, NULL, NULL, 132196),
(132197, '1.10.8.60-FF-000407', NULL, 'RuvB-like helicase 1', 87, NULL, NULL, 132197),
(132198, '3.90.190.10-FF-000342', NULL, 'Possible dual specificity protein phosphatase 3 (AFU_orthologue AFUA_1G13040)', 173, NULL, NULL, 132198),
(132199, '3.40.50.150-FF-001717', NULL, NULL, 203, NULL, NULL, 132199),
(132200, '2.40.50.100-FF-000032', NULL, 'sn-glycerol-3-phosphate import ATP-binding protein UgpC', 57, NULL, NULL, 132200),
(132201, '1.25.10.10-FF-000225', NULL, 'Nipped-B protein', 178, NULL, NULL, 132201),
(132202, '1.20.58.400-FF-000034', NULL, 'Uncharacterized protein', 92, NULL, NULL, 132202),
(132203, '4.10.270.10-FF-000008', NULL, 'CRE-LET-75 protein', 60, NULL, NULL, 132203),
(132204, '3.30.1620.10-FF-000001', NULL, 'Ribonucleoside-triphosphate reductase, adenosylcobalamin-dependent', 76, NULL, NULL, 132204),
(132205, '2.60.40.10-FF-001970', NULL, 'Jitterbug, isoform N', 100, NULL, NULL, 132205),
(132206, '3.40.250.10-FF-000246', NULL, 'Predicted protein', 94, NULL, NULL, 132206),
(132207, '2.60.110.10-FF-000022', NULL, 'Predicted protein', 170, NULL, NULL, 132207),
(132208, '1.10.472.80-FF-000004', NULL, 'Small G protein signaling modulator 1', 131, NULL, NULL, 132208),
(132209, '1.10.510.10-FF-000281', NULL, 'Cyclin-dependent kinase 2', 210, NULL, NULL, 132209),
(132210, '3.30.40.10-FF-000654', NULL, 'RING-H2 finger protein ATL33', 68, NULL, NULL, 132210),
(132211, '3.40.190.80-FF-000008', NULL, 'Sedoheptulose-1,7-bisphosphatase, chloroplastic', 141, NULL, NULL, 132211),
(132212, '3.30.40.10-FF-001115', NULL, 'PHD finger protein EHD3 isoform B', 67, NULL, NULL, 132212),
(132213, '1.25.40.10-FF-001632', NULL, 'Os02g0550400 protein', 89, NULL, NULL, 132213),
(132214, '1.25.40.20-FF-000623', NULL, 'Ankyrin repeat-containing protein ITN1', 55, NULL, NULL, 132214),
(132215, '3.40.50.620-FF-000476', NULL, 'Asparagine synthase, putative', 194, NULL, NULL, 132215),
(132216, '3.20.20.190-FF-000132', NULL, NULL, 99, NULL, NULL, 132216),
(132217, '3.30.160.60-FF-005348', NULL, NULL, 62, NULL, NULL, 132217);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(132218, '1.10.287.660-FF-000012', NULL, 'Vacuolar protein-sorting protein, putative', 70, NULL, NULL, 132218),
(132219, '2.60.120.200-FF-000177', NULL, 'Wing blister, isoform C', 192, NULL, NULL, 132219),
(132220, '3.30.160.20-FF-000238', NULL, 'Spliced leader RNA PSE-promoter transcription factor, putative', 65, NULL, NULL, 132220),
(132221, '3.40.50.300-FF-007586', NULL, 'Uncharacterized protein YfjK', 176, NULL, NULL, 132221),
(132222, '1.25.40.10-FF-004212', NULL, 'Uncharacterized protein', 60, NULL, NULL, 132222),
(132223, '1.10.220.20-FF-000014', NULL, 'Uncharacterized protein', 56, NULL, NULL, 132223),
(132224, '1.10.220.30-FF-000017', NULL, 'Flagellar motor switch protein FliG', 134, NULL, NULL, 132224),
(132225, '2.40.50.120-FF-000038', NULL, 'Uncharacterized protein', 91, NULL, NULL, 132225),
(132226, '2.60.40.3210-FF-000017', NULL, 'Si:ch211-14a17.7', 108, NULL, NULL, 132226),
(132227, '1.20.1280.50-FF-000265', NULL, 'Predicted protein', 53, NULL, NULL, 132227),
(132228, '2.60.40.10-FF-005803', NULL, NULL, 76, NULL, NULL, 132228),
(132229, '1.20.1070.10-FF-000524', NULL, 'Tyramine receptor tyra-2', 299, NULL, NULL, 132229),
(132230, '1.10.10.10-FF-000101', NULL, 'DNA-binding response OmpR family regulator', 97, NULL, NULL, 132230),
(132231, '1.10.10.60-FF-000251', NULL, 'Zinc finger protein 541', 63, NULL, NULL, 132231),
(132232, '3.20.20.105-FF-000021', NULL, 'Predicted protein', 265, NULL, NULL, 132232),
(132233, '1.10.1410.10-FF-000053', NULL, 'Nrap protein, putative', 178, NULL, NULL, 132233),
(132234, '3.60.20.10-FF-000174', NULL, NULL, 192, NULL, NULL, 132234),
(132235, '2.60.40.10-FF-005747', NULL, NULL, 104, NULL, NULL, 132235),
(132236, '3.40.1340.10-FF-000011', NULL, 'DNA-directed RNA polymerase II/III subunit, putative', 135, NULL, NULL, 132236),
(132237, '3.40.50.300-FF-007535', NULL, 'ATP-dependent DNA helicase', 205, NULL, NULL, 132237),
(132238, '3.80.10.10-FF-004225', NULL, 'Uncharacterized protein', 81, NULL, NULL, 132238),
(132239, '3.30.428.10-FF-000066', NULL, 'Uncharacterized protein', 69, NULL, NULL, 132239),
(132240, '1.20.1560.10-FF-000775', NULL, 'ATP-binding cassette transporter, subfamily C, member 1, group MRP protein PpABCC1', 296, NULL, NULL, 132240),
(132241, '2.60.120.10-FF-000522', NULL, 'Blr1670 protein', 134, NULL, NULL, 132241),
(132242, '3.40.50.1000-FF-000033', NULL, 'Sugar phosphatase YfbT', 140, NULL, NULL, 132242),
(132243, '3.30.160.60-FF-004966', NULL, NULL, 63, NULL, NULL, 132243),
(132244, '3.40.430.10-FF-000013', NULL, 'Dihydrofolate reductase', 222, NULL, NULL, 132244),
(132245, '3.40.50.2300-FF-000277', NULL, 'Response regulator receiver domain protein', 80, NULL, NULL, 132245),
(132246, '2.60.40.10-FF-006023', NULL, NULL, 91, NULL, NULL, 132246),
(132247, '1.10.287.70-FF-000048', NULL, 'Cytochrome c oxidase subunit 3', 70, NULL, NULL, 132247),
(132248, '2.60.40.10-FF-002100', NULL, 'Fibronectin type III domain containing 8', 117, NULL, NULL, 132248),
(132249, '1.10.3210.10-FF-000072', NULL, 'Metal dependent phosphohydrolase', 278, NULL, NULL, 132249),
(132250, '2.60.120.10-FF-000180', NULL, 'Potassium voltage-gated channel subfamily H member 6', 121, NULL, NULL, 132250),
(132251, '2.60.40.10-FF-001818', NULL, 'Tyrosine-protein phosphatase 69D', 102, NULL, NULL, 132251),
(132252, '3.90.190.10-FF-000398', NULL, 'Protein-tyrosine-phosphatase, putative', 297, NULL, NULL, 132252),
(132253, '1.10.150.390-FF-000010', NULL, 'DNA-directed RNA polymerase subunit', 45, NULL, NULL, 132253),
(132254, '3.90.1750.20-FF-000011', NULL, 'Recombinase family protein', 156, NULL, NULL, 132254),
(132255, '1.10.630.10-FF-000784', NULL, 'Uncharacterized protein', 119, NULL, NULL, 132255),
(132256, '3.30.1490.20-FF-000055', NULL, 'Succinate-CoA ligase, beta subunit', 76, NULL, NULL, 132256),
(132257, '1.10.150.50-FF-000074', NULL, 'Stromal interaction molecule', 67, NULL, NULL, 132257),
(132258, '3.30.70.330-FF-002964', NULL, NULL, 101, NULL, NULL, 132258),
(132259, '2.60.40.10-FF-004224', NULL, NULL, 112, NULL, NULL, 132259),
(132260, '3.20.20.190-FF-000076', NULL, 'Phosphoinositide phospholipase C', 328, NULL, NULL, 132260); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(132261, '3.30.70.1730-FF-000046', NULL, 'Predicted protein', 151, NULL, NULL, 132261),
(132262, '1.10.10.1200-FF-000011', NULL, 'Uncharacterized protein', 86, NULL, NULL, 132262),
(132263, '2.40.10.10-FF-000171', NULL, 'trypsin-1', 110, NULL, NULL, 132263),
(132264, '3.50.50.60-FF-001034', NULL, 'Probable lysine-specific histone demethylase 1', 80, NULL, NULL, 132264),
(132265, '3.40.50.720-FF-001411', NULL, '3-hydroxyisobutyrate dehydrogenase, mitochondrial, putative', 194, NULL, NULL, 132265),
(132266, '2.60.40.550-FF-000003', NULL, 'Ecotin family (I11)', 76, NULL, NULL, 132266),
(132267, '2.130.10.10-FF-002589', NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', 148, NULL, NULL, 132267),
(132268, '1.25.40.10-FF-001576', NULL, 'Pentatricopeptide repeat-containing protein At2g42920, chloroplastic', 162, NULL, NULL, 132268),
(132269, '3.80.10.10-FF-002376', NULL, 'Protein CBR-EGG-6', 154, NULL, NULL, 132269),
(132270, '2.60.40.10-FF-004117', NULL, NULL, 93, NULL, NULL, 132270),
(132271, '3.40.33.10-FF-000204', NULL, 'Protein CBR-SCL-22', 156, NULL, NULL, 132271),
(132272, '1.25.40.10-FF-001183', NULL, 'Putative pentatricopeptide repeat-containing protein', 109, NULL, NULL, 132272),
(132273, '2.60.40.10-FF-001476', NULL, 'titin isoform X1', 94, NULL, NULL, 132273),
(132274, '1.10.510.10-FF-001534', NULL, 'Putative WAK-related receptor-like protein kinase family protein', 190, NULL, NULL, 132274),
(132275, '2.60.120.200-FF-000795', NULL, 'Galectin', 55, NULL, NULL, 132275),
(132276, '3.30.70.1430-FF-000018', NULL, NULL, 93, NULL, NULL, 132276),
(132277, '3.30.530.20-FF-000110', NULL, 'S-norcoclaurine synthase 1', 166, NULL, NULL, 132277),
(132278, '1.20.1420.10-FF-000001', NULL, 'Talin 2', 152, NULL, NULL, 132278),
(132279, '3.40.50.1360-FF-000056', NULL, '6-phosphogluconolactonase', 276, NULL, NULL, 132279),
(132280, '1.25.10.10-FF-001681', NULL, 'Synembryn-A', 293, NULL, NULL, 132280),
(132281, '1.25.40.10-FF-002200', NULL, 'CCR4-NOT transcription complex subunit 10', 155, NULL, NULL, 132281),
(132282, '2.102.10.10-FF-000033', NULL, 'Similar to rieske domain-containing protein', 114, NULL, NULL, 132282),
(132283, '1.10.510.10-FF-001860', NULL, 'Probable serine/threonine-protein kinase DDB_G0280133', 333, NULL, NULL, 132283),
(132284, '1.20.1270.280-FF-000060', NULL, 'Dynein heavy chain family protein', 135, NULL, NULL, 132284),
(132285, '1.20.1250.20-FF-000917', NULL, 'MFS transporter', 387, NULL, NULL, 132285),
(132286, '3.40.190.10-FF-000769', NULL, 'Predicted protein', 176, NULL, NULL, 132286),
(132287, '2.60.120.200-FF-000744', NULL, 'Beta-agarase B', 301, NULL, NULL, 132287),
(132288, '2.30.110.10-FF-000006', NULL, 'PPOX class F420-dependent enzyme', 143, NULL, NULL, 132288),
(132289, '1.10.287.70-FF-000099', NULL, 'glutamate receptor 2 isoform X1', 53, NULL, NULL, 132289),
(132290, '3.40.50.1370-FF-000059', NULL, NULL, 136, NULL, NULL, 132290),
(132291, '3.40.190.10-FF-000477', NULL, 'Glutamate receptor', 32, NULL, NULL, 132291),
(132292, '2.40.10.170-FF-000022', NULL, 'ATP synthase subunit beta, mitochondrial', 108, NULL, NULL, 132292),
(132293, '3.40.1190.20-FF-000069', NULL, 'Ribokinase', 315, NULL, NULL, 132293),
(132294, '1.20.1270.10-FF-000056', NULL, 'Putative Hsp70 family ATPase KAR2', 74, NULL, NULL, 132294),
(132295, '3.40.50.2300-FF-001513', NULL, NULL, 94, NULL, NULL, 132295),
(132296, '3.30.710.10-FF-000492', NULL, 'Uncharacterized protein', 61, NULL, NULL, 132296),
(132297, '3.30.300.20-FF-000008', NULL, '30S ribosomal protein S3, chloroplastic', 102, NULL, NULL, 132297),
(132298, '2.130.10.10-FF-000262', NULL, 'Tubby like protein 4', 224, NULL, NULL, 132298),
(132299, '1.20.1560.10-FF-000724', NULL, 'Half-ABC transporter, putative', 241, NULL, NULL, 132299),
(132300, '3.40.50.1460-FF-000081', NULL, 'Zgc:194469', 243, NULL, NULL, 132300),
(132301, '3.30.40.10-FF-000098', NULL, 'RBR-type E3 ubiquitin transferase', 88, NULL, NULL, 132301),
(132302, '2.40.420.20-FF-000053', NULL, 'Efflux transporter periplasmic adaptor subunit', 91, NULL, NULL, 132302);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(132303, '3.30.160.60-FF-001925', NULL, 'ZNF595 isoform 1', 27, NULL, NULL, 132303),
(132304, '3.80.10.10-FF-000577', NULL, 'Uncharacterized protein, isoform B', 173, NULL, NULL, 132304),
(132305, '1.25.40.20-FF-001579', NULL, 'Uncharacterized protein', 156, NULL, NULL, 132305),
(132306, '1.20.1730.10-FF-000047', NULL, 'Putative sodium/solute symporter', 459, NULL, NULL, 132306),
(132307, '1.20.140.10-FF-000036', NULL, 'Acyl-CoA dehydrogenase FadE29', 156, NULL, NULL, 132307),
(132308, '3.80.10.10-FF-000919', NULL, 'Leucine-rich repeat receptor-like protein kinase PEPR1', 287, NULL, NULL, 132308),
(132309, '3.40.50.2000-FF-000636', NULL, 'UDP-glucuronosyltransferase', 210, NULL, NULL, 132309),
(132310, '1.10.150.50-FF-000023', NULL, 'Epidermal growth factor receptor kinase substrate 8', 85, NULL, NULL, 132310),
(132311, '3.30.200.20-FF-001193', NULL, 'Putative tyrosine-protein kinase Wsck', 94, NULL, NULL, 132311),
(132312, '1.10.150.60-FF-000026', NULL, 'SWI/SNF chromatin-remodeling complex subunit sol1', 119, NULL, NULL, 132312),
(132313, '3.40.50.410-FF-000183', NULL, 'Predicted protein', 135, NULL, NULL, 132313),
(132314, '3.40.33.10-FF-000148', NULL, 'AGAP006737-PA', 229, NULL, NULL, 132314),
(132315, '3.30.1360.170-FF-000012', NULL, 'Flavin-dependent thymidylate synthase', 234, NULL, NULL, 132315),
(132316, '2.40.50.140-FF-000757', NULL, NULL, 142, NULL, NULL, 132316),
(132317, '1.20.1280.50-FF-000046', NULL, 'F-box protein 43', 76, NULL, NULL, 132317),
(132318, '1.20.1600.10-FF-000043', NULL, 'Outer membrane efflux protein', 405, NULL, NULL, 132318),
(132319, '3.90.170.10-FF-000009', NULL, 'Adenylosuccinate synthetase', 60, NULL, NULL, 132319),
(132320, '2.60.40.2840-FF-000007', NULL, 'E3 ubiquitin-protein ligase HECW2 isoform X2', 31, NULL, NULL, 132320),
(132321, '3.30.300.10-FF-000005', NULL, 'S-adenosylmethionine synthase', 145, NULL, NULL, 132321),
(132322, '2.130.10.10-FF-003483', NULL, 'Histidine kinase/response regulator hybrid protein', 300, NULL, NULL, 132322),
(132323, '3.30.160.60-FF-005129', NULL, NULL, 29, NULL, NULL, 132323),
(132324, '3.30.200.20-FF-000967', NULL, 'Predicted protein', 115, NULL, NULL, 132324),
(132325, '3.40.50.1010-FF-000036', NULL, 'Endonuclease, putative', 245, NULL, NULL, 132325),
(132326, '3.40.50.10190-FF-000085', NULL, 'Pebble, isoform B', 97, NULL, NULL, 132326),
(132327, '1.20.58.400-FF-000039', NULL, 'Chromosome 16, whole genome shotgun sequence', 89, NULL, NULL, 132327),
(132328, '2.40.10.10-FF-000120', NULL, 'Putative serine protease', 242, NULL, NULL, 132328),
(132329, '3.30.1360.180-FF-000015', NULL, 'Uncharacterized protein', 45, NULL, NULL, 132329),
(132330, '1.20.1560.10-FF-000376', NULL, 'ABC-type multidrug transport system, ATPase and permease components', 313, NULL, NULL, 132330),
(132331, '3.40.50.300-FF-000116', NULL, 'probable global transcription activator SNF2L2 isoform X1', 237, NULL, NULL, 132331),
(132332, '1.10.10.750-FF-000027', NULL, 'TBC domain containing protein', 46, NULL, NULL, 132332),
(132333, '2.60.40.10-FF-000514', NULL, 'Collagen alpha-1(XIV) chain isoform X2', 93, NULL, NULL, 132333),
(132334, '1.25.40.10-FF-004797', NULL, 'Paf1 complex component', 172, NULL, NULL, 132334),
(132335, '3.40.50.12550-FF-000006', NULL, 'Uncharacterized protein', 183, NULL, NULL, 132335),
(132336, '3.40.50.720-FF-000736', NULL, 'Uncharacterized protein', 182, NULL, NULL, 132336),
(132337, '3.30.300.20-FF-000059', NULL, 'Probable transcription termination protein NusA', 72, NULL, NULL, 132337),
(132338, '3.30.450.20-FF-000626', NULL, 'Sensory transduction histidine kinase', 123, NULL, NULL, 132338),
(132339, '3.30.160.60-FF-005674', NULL, NULL, 27, NULL, NULL, 132339),
(132340, '1.10.260.30-FF-000019', NULL, 'Uncharacterized protein', 73, NULL, NULL, 132340),
(132341, '3.30.70.330-FF-000980', NULL, 'RNA-binding protein', 90, NULL, NULL, 132341),
(132342, '2.60.200.30-FF-000006', NULL, 'probable NAD kinase 1', 144, NULL, NULL, 132342),
(132343, '2.60.120.10-FF-000028', NULL, 'Pirin family protein', 99, NULL, NULL, 132343),
(132344, '1.10.510.10-FF-001585', NULL, 'Uncharacterized protein', 181, NULL, NULL, 132344);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(132345, '3.30.300.10-FF-000056', NULL, 'S-adenosylmethionine synthase', 63, NULL, NULL, 132345),
(132346, '3.40.250.10-FF-000072', NULL, 'mRNA, clone: RTFL01-06-I08', 139, NULL, NULL, 132346),
(132347, '1.25.40.10-FF-001306', NULL, 'Pentatricopeptide repeat-containing protein At1g28690, mitochondrial', 130, NULL, NULL, 132347),
(132348, '2.60.120.200-FF-000469', NULL, 'Cadherin-4', 162, NULL, NULL, 132348),
(132349, '3.30.160.60-FF-006130', NULL, NULL, 32, NULL, NULL, 132349),
(132350, '1.25.10.10-FF-001804', NULL, 'RING-type E3 ubiquitin transferase', 145, NULL, NULL, 132350),
(132351, '1.25.10.10-FF-001748', NULL, 'Rotatin', 145, NULL, NULL, 132351),
(132352, '1.10.260.100-FF-000038', NULL, 'Hsc70-interacting protein 2-like Protein', 61, NULL, NULL, 132352),
(132353, '2.60.200.40-FF-000009', NULL, 'Diacylglycerol kinase', 80, NULL, NULL, 132353),
(132354, '1.20.1250.20-FF-000176', NULL, 'Major facilitator superfamily domain containing 3', 398, NULL, NULL, 132354),
(132355, '1.10.3730.20-FF-000041', NULL, 'EamA family transporter', 102, NULL, NULL, 132355),
(132356, '1.25.40.180-FF-000240', NULL, NULL, 173, NULL, NULL, 132356),
(132357, '3.40.1210.10-FF-000001', NULL, '5''/3''-nucleotidase SurE', 249, NULL, NULL, 132357),
(132358, '3.40.1110.10-FF-000016', NULL, 'Phospholipid-transporting ATPase', 137, NULL, NULL, 132358),
(132359, '3.40.50.2300-FF-000496', NULL, 'LacI family transcriptional regulator', 101, NULL, NULL, 132359),
(132360, '3.40.50.2300-FF-001120', NULL, NULL, 165, NULL, NULL, 132360),
(132361, '3.40.33.10-FF-000081', NULL, 'Uncharacterized protein', 188, NULL, NULL, 132361),
(132362, '3.80.10.10-FF-002483', NULL, 'Uncharacterized protein', 177, NULL, NULL, 132362),
(132363, '1.10.3380.10-FF-000016', NULL, 'Translocation protein SEC63', 134, NULL, NULL, 132363),
(132364, '3.40.1810.10-FF-000030', NULL, 'Agamous-like MADS-box protein AGL13', 67, NULL, NULL, 132364),
(132365, '1.20.120.350-FF-000153', NULL, NULL, 130, NULL, NULL, 132365),
(132366, '2.10.220.10-FF-000030', NULL, 'Proprotein convertase subtilisin/kexin type 5', 58, NULL, NULL, 132366),
(132367, '3.40.50.300-FF-004039', NULL, 'ATP synthase subunit alpha, mitochondrial', 286, NULL, NULL, 132367),
(132368, '1.10.238.10-FF-000996', NULL, 'Uncharacterized protein', 84, NULL, NULL, 132368),
(132369, '2.20.100.10-FF-000165', NULL, 'CCN family member 3', 61, NULL, NULL, 132369),
(132370, '1.10.510.10-FF-002080', NULL, 'Uncharacterized protein', 328, NULL, NULL, 132370),
(132371, '1.20.58.1610-FF-000007', NULL, 'NADH-quinone oxidoreductase subunit', 131, NULL, NULL, 132371),
(132372, '2.130.10.10-FF-000610', NULL, 'Autophagy-related protein 18c', 119, NULL, NULL, 132372),
(132373, '3.30.160.60-FF-001184', NULL, 'zinc finger protein 574', 29, NULL, NULL, 132373),
(132374, '3.80.10.10-FF-000397', NULL, 'Transforming growth factor beta activator LRRC32', 121, NULL, NULL, 132374),
(132375, '4.10.280.10-FF-000133', NULL, 'BHLH transcription factor', 96, NULL, NULL, 132375),
(132376, '3.30.70.330-FF-001323', NULL, 'RNA-binding protein 27, putative', 87, NULL, NULL, 132376),
(132377, '3.90.550.10-FF-000151', NULL, 'O antigen biosynthesis rhamnosyltransferase', 222, NULL, NULL, 132377),
(132378, '1.25.40.10-FF-002936', NULL, 'Pentatricopeptide repeat-containing protein', 75, NULL, NULL, 132378),
(132379, '2.70.130.10-FF-000032', NULL, 'Lysosomal enzyme receptor protein', 151, NULL, NULL, 132379),
(132380, '3.40.190.10-FF-000825', NULL, 'Glutamate receptor, ionotropic, AMPA 4', 125, NULL, NULL, 132380),
(132381, '3.20.20.80-FF-000270', NULL, 'Oligo-1,6-glucosidase', 128, NULL, NULL, 132381),
(132382, '3.30.160.60-FF-000172', NULL, 'Zinc finger and SCAN domain containing 21', 27, NULL, NULL, 132382),
(132383, '3.30.930.10-FF-000031', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 4', 336, NULL, NULL, 132383),
(132384, '1.25.10.10-FF-001529', NULL, 'YALI0F08165p', 262, NULL, NULL, 132384),
(132385, '2.60.40.10-FF-003954', NULL, NULL, 132, NULL, NULL, 132385),
(132386, '2.30.29.30-FF-000754', NULL, 'Predicted protein', 134, NULL, NULL, 132386);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(132387, '1.25.40.10-FF-001924', NULL, 'Pentatricopeptide repeat-containing protein isoform A', 152, NULL, NULL, 132387),
(132388, '1.20.1300.20-FF-000006', NULL, 'Uncharacterized protein', 152, NULL, NULL, 132388),
(132389, '3.40.50.2000-FF-000962', NULL, 'OSJNBb0056F09.12 protein', 99, NULL, NULL, 132389),
(132390, '3.80.10.10-FF-002432', NULL, 'Uncharacterized protein', 105, NULL, NULL, 132390),
(132391, '3.50.50.60-FF-001360', NULL, 'Uncharacterized protein', 81, NULL, NULL, 132391),
(132392, '2.130.10.10-FF-001841', NULL, 'Transducin family protein', 155, NULL, NULL, 132392),
(132393, '3.30.499.10-FF-000038', NULL, NULL, 56, NULL, NULL, 132393),
(132394, '1.10.8.60-FF-000233', NULL, 'Peroxisome assembly factor, putative', 92, NULL, NULL, 132394),
(132395, '1.25.40.20-FF-001186', NULL, 'Kinase, NEK', 58, NULL, NULL, 132395),
(132396, '1.10.287.70-FF-000609', NULL, 'Uncharacterized protein', 270, NULL, NULL, 132396),
(132397, '1.20.1250.20-FF-000395', NULL, 'Carboxylic acid transporter protein homolog', 200, NULL, NULL, 132397),
(132398, '4.10.900.10-FF-000029', NULL, 'Predicted protein', 94, NULL, NULL, 132398),
(132399, '3.30.160.60-FF-005455', NULL, NULL, 36, NULL, NULL, 132399),
(132400, '3.40.1190.20-FF-000237', NULL, NULL, 160, NULL, NULL, 132400),
(132401, '3.50.50.60-FF-001208', NULL, 'Protoporphyrinogen oxidase', 368, NULL, NULL, 132401),
(132402, '2.130.10.10-FF-001280', NULL, 'WD repeat-containing protein 55 homolog', 116, NULL, NULL, 132402),
(132403, '3.10.580.10-FF-000210', NULL, 'Putative transport integral membrane protein', 70, NULL, NULL, 132403),
(132404, '3.20.20.60-FF-000112', NULL, 'Uncharacterized protein', 288, NULL, NULL, 132404),
(132405, '3.40.50.10190-FF-000158', NULL, 'Uncharacterized protein', 85, NULL, NULL, 132405),
(132406, '3.40.50.10420-FF-000042', NULL, '5-formyltetrahydrofolate cyclo-ligase', 163, NULL, NULL, 132406),
(132407, '1.10.510.10-FF-001186', NULL, 'Uncharacterized protein', 335, NULL, NULL, 132407),
(132408, '3.40.1110.10-FF-000235', NULL, 'Uncharacterized protein', 226, NULL, NULL, 132408),
(132409, '1.20.1300.10-FF-000003', NULL, 'Fumarate reductase subunit C', 130, NULL, NULL, 132409),
(132410, '1.20.1560.10-FF-000157', NULL, 'ABC transporter ATP-binding protein', 318, NULL, NULL, 132410),
(132411, '2.60.40.10-FF-001532', NULL, 'Immunoglobulin heavy variable 1-3', 104, NULL, NULL, 132411),
(132412, '3.40.50.300-FF-005057', NULL, 'ABC transporter, putative', 119, NULL, NULL, 132412),
(132413, '3.40.50.2300-FF-001390', NULL, NULL, 80, NULL, NULL, 132413),
(132414, '3.90.320.10-FF-000049', NULL, 'Uncharacterized protein', 79, NULL, NULL, 132414),
(132415, '2.30.230.10-FF-000009', NULL, 'Vitellogenin-1', 300, NULL, NULL, 132415),
(132416, '3.90.190.10-FF-000516', NULL, 'Uncharacterized protein', 126, NULL, NULL, 132416),
(132417, '3.10.105.10-FF-000034', NULL, 'Oligopeptide ABC transporter, periplasmic oligopeptide-binding protein', 247, NULL, NULL, 132417),
(132418, '3.40.50.300-FF-001746', NULL, 'ATP-dependent DNA helicase recQ', 132, NULL, NULL, 132418),
(132419, '1.10.630.10-FF-000346', NULL, 'Predicted protein', 479, NULL, NULL, 132419),
(132420, '2.130.10.10-FF-005551', NULL, 'Uncharacterized protein', 222, NULL, NULL, 132420),
(132421, '3.30.200.20-FF-001810', NULL, 'Uncharacterized protein', 85, NULL, NULL, 132421),
(132422, '1.20.5.110-FF-000048', NULL, 'Protein transport protein SEC9', 70, NULL, NULL, 132422),
(132423, '2.60.120.330-FF-000081', NULL, 'Os08g0249900 protein', 159, NULL, NULL, 132423),
(132424, '3.40.50.720-FF-000955', NULL, 'Oxidoreductase family protein', 132, NULL, NULL, 132424),
(132425, '3.30.450.20-FF-000227', NULL, 'AGC protein kinase, variant', 118, NULL, NULL, 132425),
(132426, '3.40.1160.10-FF-000025', NULL, 'Aspartokinase', 289, NULL, NULL, 132426),
(132427, '1.20.58.90-FF-000004', NULL, 'Syntaxin 10', 106, NULL, NULL, 132427),
(132428, '3.30.70.660-FF-000056', NULL, 'tRNA pseudouridine synthase', 183, NULL, NULL, 132428),
(132429, '3.30.70.330-FF-002778', NULL, NULL, 68, NULL, NULL, 132429),
(132430, '3.30.70.330-FF-000654', NULL, 'Ribosomal protein L23', 103, NULL, NULL, 132430);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(132431, '3.40.50.12710-FF-000026', NULL, 'Gll2384 protein', 384, NULL, NULL, 132431),
(132432, '2.10.50.10-FF-000040', NULL, 'Tumor necrosis factor receptor superfamily member 14', 44, NULL, NULL, 132432),
(132433, '1.20.1070.10-FF-000636', NULL, 'Proctolin receptor, isoform A', 204, NULL, NULL, 132433),
(132434, '3.30.70.330-FF-000598', NULL, 'Oligouridylate-binding protein 1C', 150, NULL, NULL, 132434),
(132435, '3.10.290.10-FF-000053', NULL, 'Uncharacterized RNA pseudouridine synthase jhp_0682', 58, NULL, NULL, 132435),
(132436, '2.60.40.10-FF-005573', NULL, NULL, 58, NULL, NULL, 132436),
(132437, '1.20.1250.20-FF-001406', NULL, 'Uncharacterized protein', 186, NULL, NULL, 132437),
(132438, '1.10.510.10-FF-001298', NULL, 'STE20-like kinase', 211, NULL, NULL, 132438),
(132439, '2.80.10.50-FF-000220', NULL, 'protein O-mannosyl-transferase 1-like isoform X1', 192, NULL, NULL, 132439),
(132440, '2.10.90.10-FF-000104', NULL, 'Uncharacterized protein', 115, NULL, NULL, 132440),
(132441, '1.10.418.10-FF-000015', NULL, 'Parvin beta', 130, NULL, NULL, 132441),
(132442, '2.130.10.10-FF-001914', NULL, 'DNA damage-binding protein 1', 368, NULL, NULL, 132442),
(132443, '3.30.70.1620-FF-000013', NULL, 'Structural maintenance of chromosomes protein 3', 68, NULL, NULL, 132443),
(132444, '3.40.50.720-FF-002428', NULL, 'Myo-inositol-1-phosphate synthase', 104, NULL, NULL, 132444),
(132445, '3.30.160.60-FF-001419', NULL, 'Zinc finger protein 581', 30, NULL, NULL, 132445),
(132446, '3.10.290.10-FF-000047', NULL, 'Tyrosine--tRNA ligase', 97, NULL, NULL, 132446),
(132447, '3.40.50.300-FF-007709', NULL, 'Glycerate kinase', 98, NULL, NULL, 132447),
(132448, '6.10.140.2220-FF-000031', NULL, 'SET (Trithorax/polycomb) domain containing', 52, NULL, NULL, 132448),
(132449, '1.10.287.600-FF-000016', NULL, 'Tubulin gamma chain', 61, NULL, NULL, 132449),
(132450, '3.40.1810.10-FF-000081', NULL, NULL, 51, NULL, NULL, 132450),
(132451, '3.30.160.380-FF-000020', NULL, NULL, 101, NULL, NULL, 132451),
(132452, '3.30.470.20-FF-000228', NULL, 'Glutathione synthetase', 107, NULL, NULL, 132452),
(132453, '3.90.25.10-FF-000015', NULL, 'SDR family oxidoreductase', 102, NULL, NULL, 132453),
(132454, '3.40.50.1100-FF-000063', NULL, 'Putative cysteine synthase B', 144, NULL, NULL, 132454),
(132455, '1.20.58.90-FF-000010', NULL, 'Tubulin-specific chaperone A', 109, NULL, NULL, 132455),
(132456, '1.10.555.10-FF-000154', NULL, NULL, 186, NULL, NULL, 132456),
(132457, '3.40.50.1110-FF-000009', NULL, 'GDSL esterase/lipase At1g09390', 346, NULL, NULL, 132457),
(132458, '3.30.200.110-FF-000017', NULL, NULL, 158, NULL, NULL, 132458),
(132459, '1.25.40.10-FF-001071', NULL, 'pre-mRNA-splicing factor SYF1-like', 125, NULL, NULL, 132459),
(132460, '2.60.40.60-FF-000164', NULL, 'cadherin-23 isoform X1', 102, NULL, NULL, 132460),
(132461, '3.40.50.1110-FF-000066', NULL, 'Lipolytic enzyme, G-D-S-L family', 196, NULL, NULL, 132461),
(132462, '3.30.1330.30-FF-000052', NULL, '23S rRNA (guanosine-2''-O-)-methyltransferase RlmB', 76, NULL, NULL, 132462),
(132463, '2.60.120.10-FF-000702', NULL, 'Uncharacterized protein', 211, NULL, NULL, 132463),
(132464, '2.60.40.1930-FF-000009', NULL, 'Complement C3', 131, NULL, NULL, 132464),
(132465, '3.30.1330.40-FF-000055', NULL, 'Uncharacterized protein', 115, NULL, NULL, 132465),
(132466, '3.90.650.10-FF-000035', NULL, 'Phosphoribosylformylglycinamidine synthase', 168, NULL, NULL, 132466),
(132467, '3.40.50.1100-FF-000006', NULL, 'Cysteine synthase', 191, NULL, NULL, 132467),
(132468, '2.30.29.30-FF-000703', NULL, 'Sorting nexin-17 homolog', 102, NULL, NULL, 132468),
(132469, '3.50.50.60-FF-001214', NULL, 'Flavin-containing monooxygenase', 322, NULL, NULL, 132469),
(132470, '1.10.275.10-FF-000003', NULL, 'Adenylosuccinate lyase', 117, NULL, NULL, 132470),
(132471, '3.40.630.20-FF-000003', NULL, 'Pyrrolidone-carboxylate peptidase isoform A', 211, NULL, NULL, 132471),
(132472, '1.20.5.110-FF-000161', NULL, 'Syntaxin 1A/ snare domain', 107, NULL, NULL, 132472),
(132473, '3.30.420.10-FF-000565', NULL, NULL, 44, NULL, NULL, 132473);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(132474, '2.60.40.10-FF-003443', NULL, NULL, 102, NULL, NULL, 132474),
(132475, '3.10.20.90-FF-000071', NULL, 'Protein kinase C', 90, NULL, NULL, 132475),
(132476, '3.30.160.60-FF-000166', NULL, 'Zinc finger and BTB domain-containing 49', 27, NULL, NULL, 132476),
(132477, '3.30.70.2740-FF-000012', NULL, 'D-lactate dehydrogenase (Dld)', 84, NULL, NULL, 132477),
(132478, '1.20.120.1080-FF-000019', NULL, 'ATP-dependent RNA helicase DHX8', 103, NULL, NULL, 132478),
(132479, '1.10.1450.10-FF-000050', NULL, 'Tetraspanin', 101, NULL, NULL, 132479),
(132480, '3.30.200.20-FF-000299', NULL, 'Receptor-like serine/threonine-protein kinase ALE2', 98, NULL, NULL, 132480),
(132481, '1.20.1070.10-FF-002093', NULL, 'Uncharacterized protein', 220, NULL, NULL, 132481),
(132482, '3.40.1160.10-FF-000019', NULL, 'Uridylate kinase', 244, NULL, NULL, 132482),
(132483, '1.20.900.10-FF-000005', NULL, 'Ras-specific guanine nucleotide-releasing factor 1 isoform 2', 204, NULL, NULL, 132483),
(132484, '1.20.1070.10-FF-001311', NULL, 'G-protein coupled receptor, putative', 132, NULL, NULL, 132484),
(132485, '3.30.930.10-FF-000323', NULL, 'Uncharacterized protein', 192, NULL, NULL, 132485),
(132486, '1.25.40.10-FF-005286', NULL, 'Uncharacterized protein', 141, NULL, NULL, 132486),
(132487, '1.10.510.10-FF-004114', NULL, NULL, 113, NULL, NULL, 132487),
(132488, '2.130.10.10-FF-003078', NULL, 'Guanine nucleotide-binding protein subunit beta, putative', 111, NULL, NULL, 132488),
(132489, '2.20.28.60-FF-000002', NULL, 'Citrate synthase 1', 52, NULL, NULL, 132489),
(132490, '3.30.70.340-FF-000022', NULL, NULL, 108, NULL, NULL, 132490),
(132491, '3.30.160.60-FF-001751', NULL, 'Zinc finger protein 599', 26, NULL, NULL, 132491),
(132492, '2.60.40.2140-FF-000005', NULL, '3-glucan binding protein', 104, NULL, NULL, 132492),
(132493, '3.50.30.30-FF-000147', NULL, 'Sortilin', 135, NULL, NULL, 132493),
(132494, '1.20.120.1070-FF-000016', NULL, 'Uncharacterized protein', 86, NULL, NULL, 132494),
(132495, '1.50.10.10-FF-000049', NULL, 'alpha-1,2-Mannosidase', 454, NULL, NULL, 132495),
(132496, '2.130.10.10-FF-005225', NULL, 'Uncharacterized protein', 66, NULL, NULL, 132496),
(132497, '2.130.10.10-FF-005169', NULL, 'Uncharacterized protein', 129, NULL, NULL, 132497),
(132498, '2.60.120.40-FF-000014', NULL, 'Tumor necrosis factor ligand superfamily member', 164, NULL, NULL, 132498),
(132499, '1.25.10.10-FF-001243', NULL, 'RING-type E3 ubiquitin transferase', 290, NULL, NULL, 132499),
(132500, '1.20.58.60-FF-000574', NULL, 'ACTN4 isoform 9', 83, NULL, NULL, 132500),
(132501, '1.25.40.20-FF-001747', NULL, 'Uncharacterized protein', 207, NULL, NULL, 132501),
(132502, '1.10.8.10-FF-000353', NULL, 'Uncharacterized protein', 42, NULL, NULL, 132502),
(132503, '2.30.140.10-FF-000002', NULL, 'Polyamine aminopropyltransferase', 54, NULL, NULL, 132503),
(132504, '3.30.70.590-FF-000012', NULL, 'Poly(A) polymerase', 125, NULL, NULL, 132504),
(132505, '3.80.10.10-FF-000684', NULL, 'Transforming growth factor beta activator LRRC33', 70, NULL, NULL, 132505),
(132506, '1.10.390.10-FF-000074', NULL, 'Aminopeptidase, putative', 239, NULL, NULL, 132506),
(132507, '3.40.50.10190-FF-000046', NULL, 'PAX interacting protein 1', 91, NULL, NULL, 132507),
(132508, '3.30.70.1180-FF-000016', NULL, 'V-type proton ATPase subunit C', 69, NULL, NULL, 132508),
(132509, '3.40.30.10-FF-000018', NULL, 'Glutaredoxin', 83, NULL, NULL, 132509),
(132510, '1.10.510.10-FF-001259', NULL, 'Eukaryotic initiation factor 2alpha kinase 1', 194, NULL, NULL, 132510),
(132511, '3.40.50.1820-FF-000565', NULL, 'Alpha/beta-Hydrolases superfamily protein', 220, NULL, NULL, 132511),
(132512, '3.40.50.2300-FF-000838', NULL, 'Vomeronasal 2, receptor 18', 313, NULL, NULL, 132512),
(132513, '1.10.418.20-FF-000018', NULL, 'SUMO-specific peptidase 6b', 50, NULL, NULL, 132513),
(132514, '2.80.10.50-FF-000164', NULL, 'Uncharacterized protein', 120, NULL, NULL, 132514),
(132515, '1.10.10.790-FF-000016', NULL, 'Suppressor of white-apricot, isoform G', 55, NULL, NULL, 132515),
(132516, '1.10.1200.10-FF-000127', NULL, 'Enniatin synthase', 74, NULL, NULL, 132516);
INSERT INTO "PUBLIC"."MODEL" VALUES
(132517, '1.10.132.70-FF-000015', NULL, 'Telomerase reverse transcriptase', 257, NULL, NULL, 132517),
(132518, '2.30.180.10-FF-000162', NULL, NULL, 79, NULL, NULL, 132518),
(132519, '3.30.420.10-FF-000621', NULL, NULL, 172, NULL, NULL, 132519),
(132520, '2.30.30.140-FF-000244', NULL, 'ARID (AT-rich Interactive Domain-containing protein) homolog', 119, NULL, NULL, 132520),
(132521, '3.40.50.1260-FF-000026', NULL, 'Phosphoglycerate kinase A', 114, NULL, NULL, 132521),
(132522, '4.10.900.10-FF-000035', NULL, 'Uncharacterized protein', 59, NULL, NULL, 132522),
(132523, '3.40.1110.10-FF-000308', NULL, NULL, 16, NULL, NULL, 132523),
(132524, '3.30.70.1170-FF-000013', NULL, 'Putative 28S rRNA (Cytosine-C(5))-methyltransferase', 90, NULL, NULL, 132524),
(132525, '3.40.50.2020-FF-000119', NULL, 'Phosphoribosyl pyrophosphate synthetase', 157, NULL, NULL, 132525),
(132526, '2.60.40.10-FF-003387', NULL, NULL, 95, NULL, NULL, 132526),
(132527, '3.60.40.10-FF-000349', NULL, 'Uncharacterized protein', 347, NULL, NULL, 132527),
(132528, '2.10.25.10-FF-001021', NULL, 'Predicted protein', 39, NULL, NULL, 132528),
(132529, '1.25.10.10-FF-003373', NULL, 'Predicted protein', 157, NULL, NULL, 132529),
(132530, '3.30.710.10-FF-000048', NULL, 'zinc finger and BTB domain-containing protein 17', 141, NULL, NULL, 132530),
(132531, '1.10.132.60-FF-000012', NULL, 'DNA polymerase', 199, NULL, NULL, 132531),
(132532, '1.10.390.10-FF-000017', NULL, 'Uncharacterized protein, isoform A', 241, NULL, NULL, 132532),
(132533, '3.40.1160.10-FF-000064', NULL, 'Acetylglutamate kinase', 286, NULL, NULL, 132533),
(132534, '3.30.40.210-FF-000016', NULL, 'Transcription elongation factor SPT4', 95, NULL, NULL, 132534),
(132535, '1.20.120.350-FF-000147', NULL, NULL, 120, NULL, NULL, 132535),
(132536, '2.130.10.10-FF-005282', NULL, 'Flagellar associated protein', 235, NULL, NULL, 132536),
(132537, '2.60.40.1480-FF-000009', NULL, 'Coatomer subunit gamma', 38, NULL, NULL, 132537),
(132538, '1.10.10.1460-FF-000004', NULL, NULL, 38, NULL, NULL, 132538),
(132539, '2.60.200.40-FF-000015', NULL, 'Diacylglycerol kinase', 155, NULL, NULL, 132539),
(132540, '3.30.160.60-FF-005966', NULL, NULL, 76, NULL, NULL, 132540),
(132541, '1.20.1250.20-FF-002194', NULL, 'Uncharacterized protein', 153, NULL, NULL, 132541),
(132542, '3.40.50.300-FF-005843', NULL, 'Uncharacterized protein', 167, NULL, NULL, 132542),
(132543, '3.40.50.1820-FF-001869', NULL, 'Uncharacterized protein', 244, NULL, NULL, 132543),
(132544, '1.10.630.10-FF-000172', NULL, 'Cytochrome P450 130', 405, NULL, NULL, 132544),
(132545, '3.40.50.450-FF-000060', NULL, 'Rossmann fold nucleotide-binding protein', 189, NULL, NULL, 132545),
(132546, '3.90.180.10-FF-000167', NULL, 'Uncharacterized protein', 95, NULL, NULL, 132546),
(132547, '1.20.120.850-FF-000027', NULL, 'DNA repair and recombination protein RAD54', 31, NULL, NULL, 132547),
(132548, '3.30.1240.10-FF-000067', NULL, 'Putative phosphatase MG265', 117, NULL, NULL, 132548),
(132549, '1.10.10.1450-FF-000001', NULL, 'SETMAR isoform 5', 49, NULL, NULL, 132549),
(132550, '3.80.10.10-FF-001122', NULL, 'LRR receptor-like serine/threonine-protein kinase ERECTA', 159, NULL, NULL, 132550),
(132551, '1.10.287.110-FF-000414', NULL, 'Predicted protein', 99, NULL, NULL, 132551),
(132552, '1.20.1280.50-FF-000052', NULL, 'F-box protein (Pof7), putative', 111, NULL, NULL, 132552),
(132553, '2.60.120.620-FF-000128', NULL, 'Predicted protein', 64, NULL, NULL, 132553),
(132554, '3.40.1190.20-FF-000182', NULL, NULL, 317, NULL, NULL, 132554),
(132555, '1.25.10.10-FF-002030', NULL, 'Uncharacterized protein', 221, NULL, NULL, 132555),
(132556, '3.30.160.60-FF-001476', NULL, 'Zinc finger protein 516', 58, NULL, NULL, 132556),
(132557, '1.20.1730.10-FF-000086', NULL, 'Solute carrier family 5 (sodium/glucose cotransporter), member 1', 466, NULL, NULL, 132557),
(132558, '2.10.25.10-FF-000296', NULL, 'Sushi, nidogen and EGF like domains 1', 38, NULL, NULL, 132558),
(132559, '3.40.50.300-FF-007861', NULL, 'Uncharacterized protein', 211, NULL, NULL, 132559),
(132560, '2.30.30.140-FF-000188', NULL, 'Tapas, isoform B', 73, NULL, NULL, 132560);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(132561, '2.60.40.2580-FF-000002', NULL, 'Minor fimbrium subunit Mfa1', 171, NULL, NULL, 132561),
(132562, '1.25.40.10-FF-003105', NULL, 'peptidyl-prolyl cis-trans isomerase D', 159, NULL, NULL, 132562),
(132563, '3.40.50.2300-FF-001625', NULL, NULL, 278, NULL, NULL, 132563),
(132564, '3.40.50.2300-FF-000788', NULL, NULL, 151, NULL, NULL, 132564),
(132565, '1.10.287.70-FF-000155', NULL, 'potassium channel subfamily K member 16', 313, NULL, NULL, 132565),
(132566, '4.10.280.10-FF-000240', NULL, 'Uncharacterized protein', 62, NULL, NULL, 132566),
(132567, '1.20.1250.20-FF-000569', NULL, 'Transmembrane transporter, putative', 208, NULL, NULL, 132567),
(132568, '3.30.160.60-FF-003656', NULL, 'AGAP011758-PA', 57, NULL, NULL, 132568),
(132569, '3.30.160.60-FF-002201', NULL, 'Uncharacterized protein', 28, NULL, NULL, 132569),
(132570, '1.10.150.50-FF-000017', NULL, 'Liprin-beta-1 isoform 1', 113, NULL, NULL, 132570),
(132571, '1.20.120.350-FF-000203', NULL, NULL, 106, NULL, NULL, 132571),
(132572, '2.20.100.10-FF-000053', NULL, 'ADAMTS-like protein 2', 63, NULL, NULL, 132572),
(132573, '3.30.200.20-FF-001754', NULL, 'Uncharacterized protein', 80, NULL, NULL, 132573),
(132574, '3.90.870.10-FF-000017', NULL, 'Threonylcarbamoyl-AMP synthase', 181, NULL, NULL, 132574),
(132575, '1.20.58.60-FF-000793', NULL, 'Uncharacterized protein', 212, NULL, NULL, 132575),
(132576, '3.30.160.60-FF-005747', NULL, NULL, 88, NULL, NULL, 132576),
(132577, '3.30.450.20-FF-000452', NULL, 'Voltage-dependent calcium channel subunit alpha-2/delta-3', 109, NULL, NULL, 132577),
(132578, '3.30.70.330-FF-000873', NULL, 'Putative RNA-binding protein', 74, NULL, NULL, 132578),
(132579, '2.60.200.30-FF-000012', NULL, 'NAD kinase', 124, NULL, NULL, 132579),
(132580, '3.50.50.60-FF-001253', NULL, 'Os04g0692800 protein', 133, NULL, NULL, 132580),
(132581, '1.25.40.90-FF-000094', NULL, 'Putative clathrin assembly protein', 155, NULL, NULL, 132581),
(132582, '3.40.50.80-FF-000164', NULL, 'Chromosome 1, whole genome shotgun sequence', 188, NULL, NULL, 132582),
(132583, '1.25.40.470-FF-000057', NULL, 'Uncharacterized protein', 140, NULL, NULL, 132583),
(132584, '3.90.470.10-FF-000049', NULL, 'Uncharacterized protein', 55, NULL, NULL, 132584),
(132585, '3.30.300.160-FF-000010', NULL, 'General secretion pathway protein E', 85, NULL, NULL, 132585),
(132586, '2.70.98.30-FF-000041', NULL, 'Uncharacterized protein', 86, NULL, NULL, 132586),
(132587, '3.40.1110.10-FF-000460', NULL, NULL, 191, NULL, NULL, 132587),
(132588, '3.80.10.10-FF-002870', NULL, 'Leucine-rich repeat protein (LRRP), putative', 101, NULL, NULL, 132588),
(132589, '2.60.40.10-FF-005534', NULL, NULL, 52, NULL, NULL, 132589),
(132590, '1.25.40.10-FF-005342', NULL, 'Uncharacterized protein', 64, NULL, NULL, 132590),
(132591, '1.25.10.10-FF-001355', NULL, 'Uncharacterized protein', 242, NULL, NULL, 132591),
(132592, '1.25.10.10-FF-001973', NULL, 'Predicted protein', 180, NULL, NULL, 132592),
(132593, '2.60.40.60-FF-000271', NULL, 'Cadherin-related 23', 106, NULL, NULL, 132593),
(132594, '2.60.40.420-FF-000144', NULL, 'Ephrin', 148, NULL, NULL, 132594),
(132595, '3.50.50.60-FF-000758', NULL, 'Fumarate reductase flavoprotein subunit', 87, NULL, NULL, 132595),
(132596, '1.10.472.30-FF-000012', NULL, NULL, 126, NULL, NULL, 132596),
(132597, '3.30.1490.20-FF-000004', NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta, mitochondrial', 97, NULL, NULL, 132597),
(132598, '3.40.1000.30-FF-000019', NULL, 'Uncharacterized protein', 141, NULL, NULL, 132598),
(132599, '2.30.29.30-FF-000810', NULL, 'Rho GTPase-activating protein (RhoGAP), putative', 125, NULL, NULL, 132599),
(132600, '1.25.70.10-FF-000004', NULL, 'Transcription termination factor mterf4, chloroplastic', 140, NULL, NULL, 132600),
(132601, '1.10.510.10-FF-001478', NULL, 'Os02g0106900 protein', 304, NULL, NULL, 132601),
(132602, '3.40.390.30-FF-000003', NULL, 'YBEY isoform 1', 149, NULL, NULL, 132602),
(132603, '1.10.238.10-FF-000029', NULL, 'Signal transducer and transcription activator 6', 122, NULL, NULL, 132603),
(132604, '2.30.120.10-FF-000001', NULL, 'Acyl-homoserine lactone acylase QuiP', 82, NULL, NULL, 132604);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(132605, '3.40.50.720-FF-002541', NULL, 'Lysine-ketoglutarate reductase, putative', 73, NULL, NULL, 132605),
(132606, '1.20.1560.10-FF-000449', NULL, 'ATP-binding cassette transporter, subfamily B, member 19, group MDR/PGP protein PpABCB19', 140, NULL, NULL, 132606),
(132607, '3.40.930.10-FF-000040', NULL, NULL, 219, NULL, NULL, 132607),
(132608, '1.10.287.70-FF-000716', NULL, 'Uncharacterized protein', 144, NULL, NULL, 132608),
(132609, '3.90.20.20-FF-000029', NULL, 'Protein GrpE', 99, NULL, NULL, 132609),
(132610, '3.30.40.10-FF-001328', NULL, 'Nucleic acid binding', 93, NULL, NULL, 132610),
(132611, '1.20.1050.10-FF-000309', NULL, 'Glutathione s-transferase', 134, NULL, NULL, 132611),
(132612, '3.40.50.300-FF-001572', NULL, 'ESX-1 secretion system protein eccCa1', 305, NULL, NULL, 132612),
(132613, '1.20.5.110-FF-000009', NULL, 'Synaptosomal-associated protein', 87, NULL, NULL, 132613),
(132614, '3.20.20.70-FF-000502', NULL, 'Radical SAM domain protein', 284, NULL, NULL, 132614),
(132615, '1.10.287.1150-FF-000025', NULL, 'Uncharacterized protein', 74, NULL, NULL, 132615),
(132616, '1.25.40.180-FF-000184', NULL, NULL, 107, NULL, NULL, 132616),
(132617, '3.40.50.300-FF-004152', NULL, 'Uncharacterized protein', 231, NULL, NULL, 132617),
(132618, '3.20.20.80-FF-000505', NULL, 'Beta-1,4-endoglucanase (Eurofung)', 128, NULL, NULL, 132618),
(132619, '2.120.10.80-FF-000289', NULL, 'Uncharacterized protein', 334, NULL, NULL, 132619),
(132620, '3.20.20.80-FF-000562', NULL, 'Uncharacterized protein', 203, NULL, NULL, 132620),
(132621, '3.80.10.10-FF-003213', NULL, 'Uncharacterized protein', 214, NULL, NULL, 132621),
(132622, '3.30.200.20-FF-001024', NULL, 'Protein kinase domain-containing protein', 132, NULL, NULL, 132622),
(132623, '2.30.39.10-FF-000136', NULL, 'Uncharacterized protein', 51, NULL, NULL, 132623),
(132624, '3.90.1580.10-FF-000028', NULL, 'Uncharacterized protein', 249, NULL, NULL, 132624),
(132625, '1.25.40.180-FF-000127', NULL, 'Polyadenylate-binding protein-interacting protein 1, putative', 227, NULL, NULL, 132625),
(132626, '1.20.5.100-FF-000006', NULL, 'Integrin beta', 72, NULL, NULL, 132626),
(132627, '1.20.58.60-FF-000810', NULL, 'Uncharacterized protein', 194, NULL, NULL, 132627),
(132628, '3.60.90.10-FF-000009', NULL, 'S-adenosylmethionine decarboxylase proenzyme', 279, NULL, NULL, 132628),
(132629, '3.30.70.330-FF-002958', NULL, NULL, 181, NULL, NULL, 132629),
(132630, '1.25.40.10-FF-003723', NULL, 'Pentatricopeptide repeat-containing protein', 78, NULL, NULL, 132630),
(132631, '1.25.10.10-FF-003154', NULL, 'Thiamin pyrophosphokinase-like protein', 432, NULL, NULL, 132631),
(132632, '3.40.50.1820-FF-000801', NULL, 'Carboxylic ester hydrolase', 477, NULL, NULL, 132632),
(132633, '4.10.400.10-FF-000160', NULL, 'Low-density lipoprotein receptor-related protein', 36, NULL, NULL, 132633),
(132634, '3.10.450.350-FF-000014', NULL, 'Cell wall endopeptidase family M23/M37', 105, NULL, NULL, 132634),
(132635, '1.10.510.10-FF-003619', NULL, NULL, 196, NULL, NULL, 132635),
(132636, '1.10.238.10-FF-000361', NULL, 'Sodium/calcium exchanger NCL2', 121, NULL, NULL, 132636),
(132637, '1.10.510.10-FF-003333', NULL, NULL, 53, NULL, NULL, 132637),
(132638, '2.130.10.10-FF-003932', NULL, 'Uncharacterized protein', 255, NULL, NULL, 132638),
(132639, '2.10.70.10-FF-000215', NULL, 'Protein lev-9', 58, NULL, NULL, 132639),
(132640, '1.20.1070.10-FF-000816', NULL, 'Serpentine receptor class alpha-13', 229, NULL, NULL, 132640),
(132641, '1.25.10.10-FF-003098', NULL, 'Condensin complex subunit 1', 223, NULL, NULL, 132641),
(132642, '3.60.130.10-FF-000042', NULL, 'Uncharacterized protein', 278, NULL, NULL, 132642),
(132643, '1.20.1250.20-FF-000682', NULL, 'Probable MFS transporter', 189, NULL, NULL, 132643),
(132644, '3.80.10.10-FF-004517', NULL, 'Uncharacterized protein', 41, NULL, NULL, 132644),
(132645, '2.30.29.30-FF-000467', NULL, 'Blown fuse, isoform B', 113, NULL, NULL, 132645),
(132646, '1.10.3580.10-FF-000003', NULL, 'BnaA04g10520D protein', 176, NULL, NULL, 132646),
(132647, '1.10.1200.10-FF-000060', NULL, 'Nonribosomal peptide synthase GliP', 74, NULL, NULL, 132647);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(132648, '1.20.1280.290-FF-000059', NULL, 'Cystinosin-like', 100, NULL, NULL, 132648),
(132649, '3.10.129.10-FF-000095', NULL, 'Acyl-CoA thioesterase', 137, NULL, NULL, 132649),
(132650, '1.10.510.10-FF-003277', NULL, NULL, 101, NULL, NULL, 132650),
(132651, '1.10.533.10-FF-000030', NULL, 'Interleukin-1 receptor-associated kinase-like 2', 92, NULL, NULL, 132651),
(132652, '2.60.120.10-FF-000814', NULL, 'Uncharacterized protein', 107, NULL, NULL, 132652),
(132653, '3.40.30.10-FF-000456', NULL, 'Protein disulfide-isomerase', 118, NULL, NULL, 132653),
(132654, '1.25.40.20-FF-000730', NULL, 'Kinase, NEK', 127, NULL, NULL, 132654),
(132655, '3.40.1360.10-FF-000006', NULL, 'Ribonuclease M5', 121, NULL, NULL, 132655),
(132656, '1.10.472.10-FF-000585', NULL, 'Uncharacterized protein', 38, NULL, NULL, 132656),
(132657, '1.25.10.10-FF-002878', NULL, 'Predicted protein', 151, NULL, NULL, 132657),
(132658, '3.40.50.1820-FF-001021', NULL, 'GPI inositol-deacylase', 199, NULL, NULL, 132658),
(132659, '2.30.29.30-FF-000809', NULL, 'Putative peptidyl-prolyl cis-trans isomerase', 166, NULL, NULL, 132659),
(132660, '1.10.285.20-FF-000001', NULL, 'Protein-glutamate O-methyltransferase', 72, NULL, NULL, 132660),
(132661, '3.20.70.20-FF-000007', NULL, 'Vitamin B12-dependent ribonucleotide reductase', 650, NULL, NULL, 132661),
(132662, '1.20.1740.10-FF-000255', NULL, 'Uncharacterized protein', 278, NULL, NULL, 132662),
(132663, '3.30.40.10-FF-001109', NULL, 'Ring finger domain containing protein', 67, NULL, NULL, 132663),
(132664, '3.40.50.300-FF-003258', NULL, 'Elongation factor G', 289, NULL, NULL, 132664),
(132665, '1.20.1740.10-FF-000199', NULL, 'Uncharacterized protein', 179, NULL, NULL, 132665),
(132666, '1.20.5.300-FF-000010', NULL, 'Striatin Pro11', 47, NULL, NULL, 132666),
(132667, '3.30.40.10-FF-000547', NULL, 'Chromatin modification-related protein', 56, NULL, NULL, 132667),
(132668, '1.10.630.10-FF-000733', NULL, 'Uncharacterized protein', 92, NULL, NULL, 132668),
(132669, '2.30.31.10-FF-000017', NULL, 'RNA polymerase II transcriptional coactivator KIWI', 55, NULL, NULL, 132669),
(132670, '1.20.120.350-FF-000260', NULL, NULL, 122, NULL, NULL, 132670),
(132671, '1.20.1440.200-FF-000002', NULL, 'Vacuolar protein sorting-associated protein 28 homolog', 95, NULL, NULL, 132671),
(132672, '3.40.50.300-FF-002353', NULL, 'Type I restriction-modification system endonuclease', 224, NULL, NULL, 132672),
(132673, '3.90.190.10-FF-000067', NULL, 'Phosphatase domain-containing, paladin 1', 309, NULL, NULL, 132673),
(132674, '2.40.50.140-FF-001140', NULL, NULL, 88, NULL, NULL, 132674),
(132675, '3.30.470.10-FF-000006', NULL, 'Branched-chain-amino-acid aminotransferase', 124, NULL, NULL, 132675),
(132676, '3.30.1490.10-FF-000001', NULL, '30S ribosomal protein S8', 58, NULL, NULL, 132676),
(132677, '4.10.1000.10-FF-000093', NULL, 'Key regulator in ER unfolded protein response', 76, NULL, NULL, 132677),
(132678, '1.20.1070.10-FF-001131', NULL, 'Rhodopsin, GQ-coupled', 351, NULL, NULL, 132678),
(132679, '1.10.720.30-FF-000044', NULL, 'Poly [ADP-ribose] polymerase', 44, NULL, NULL, 132679),
(132680, '2.60.40.1730-FF-000118', NULL, NULL, 78, NULL, NULL, 132680),
(132681, '3.40.50.2020-FF-000120', NULL, 'Uridine kinase', 139, NULL, NULL, 132681),
(132682, '3.30.559.10-FF-000038', NULL, 'Nonribosomal siderophore peptide synthase SidC', 192, NULL, NULL, 132682),
(132683, '3.30.342.10-FF-000057', NULL, 'DNA polymerase', 46, NULL, NULL, 132683),
(132684, '3.40.20.10-FF-000012', NULL, 'Twinfilin-1 isoform 1', 142, NULL, NULL, 132684),
(132685, '3.90.320.10-FF-000050', NULL, 'CRISPR-associated exonuclease Cas4', 200, NULL, NULL, 132685),
(132686, '3.40.30.10-FF-000170', NULL, 'Chloride intracellular channel 3', 96, NULL, NULL, 132686),
(132687, '3.30.420.40-FF-000849', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', 161, NULL, NULL, 132687),
(132688, '1.10.10.10-FF-001568', NULL, 'Histone acetyltransferase', 33, NULL, NULL, 132688),
(132689, '1.10.8.870-FF-000008', NULL, 'Glycerol-3-phosphate dehydrogenase', 92, NULL, NULL, 132689);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(132690, '3.30.160.60-FF-002532', NULL, 'Zinc finger protein 473', 25, NULL, NULL, 132690),
(132691, '3.30.390.10-FF-000005', NULL, 'o-succinylbenzoate synthase', 113, NULL, NULL, 132691),
(132692, '2.30.130.10-FF-000007', NULL, 'Glutamate 5-kinase', 102, NULL, NULL, 132692),
(132693, '1.10.565.10-FF-000216', NULL, 'Uncharacterized protein', 103, NULL, NULL, 132693),
(132694, '2.60.40.10-FF-005753', NULL, NULL, 69, NULL, NULL, 132694),
(132695, '3.30.342.10-FF-000018', NULL, 'DNA polymerase', 162, NULL, NULL, 132695),
(132696, '2.40.10.10-FF-000064', NULL, 'Hepatocyte growth factor-like protein', 99, NULL, NULL, 132696),
(132697, '3.30.470.20-FF-000009', NULL, 'tubulin polyglutamylase TTLL5 isoform X1', 226, NULL, NULL, 132697),
(132698, '1.20.120.20-FF-000038', NULL, 'Apolipophorin-3', 164, NULL, NULL, 132698),
(132699, '1.10.1200.270-FF-000030', NULL, 'Uncharacterized protein', 94, NULL, NULL, 132699),
(132700, '2.60.40.10-FF-002083', NULL, 'Protein CBR-UNC-22', 99, NULL, NULL, 132700),
(132701, '1.20.120.1750-FF-000012', NULL, 'ranBP-type and C3HC4-type zinc finger-containing protein 1 isoform X1', 86, NULL, NULL, 132701),
(132702, '1.25.40.10-FF-000053', NULL, 'Tetratricopeptide repeat domain 17', 171, NULL, NULL, 132702),
(132703, '3.40.50.720-FF-002209', NULL, 'DeHydrogenases, Short chain', 302, NULL, NULL, 132703),
(132704, '3.40.50.10330-FF-000054', NULL, 'ceramide kinase', 153, NULL, NULL, 132704),
(132705, '3.30.160.60-FF-004331', NULL, NULL, 29, NULL, NULL, 132705),
(132706, '1.10.630.10-FF-000059', NULL, 'Cytochrome P450 monooxygenase', 448, NULL, NULL, 132706),
(132707, '3.30.1140.60-FF-000001', NULL, 'F-actin-capping protein subunit alpha', 113, NULL, NULL, 132707),
(132708, '1.20.120.1760-FF-000015', NULL, 'CDP-alcohol phosphatidyltransferase family protein', 206, NULL, NULL, 132708),
(132709, '1.20.1250.20-FF-000625', NULL, 'Related to TNA1-high affinity nicotinic acid plasma membrane permease', 190, NULL, NULL, 132709),
(132710, '3.40.50.300-FF-001459', NULL, 'ATPase ASNA1 homolog', 325, NULL, NULL, 132710),
(132711, '2.60.40.10-FF-001083', NULL, 'T cell receptor gamma constant 2', 122, NULL, NULL, 132711),
(132712, '1.10.10.400-FF-000001', NULL, 'Polyribonucleotide nucleotidyltransferase 1, mitochondrial', 99, NULL, NULL, 132712),
(132713, '1.20.1560.10-FF-000668', NULL, 'Uncharacterized protein', 46, NULL, NULL, 132713),
(132714, '1.20.5.110-FF-000341', NULL, 'Synaptobrevin', 87, NULL, NULL, 132714),
(132715, '2.60.120.430-FF-000010', NULL, 'Di-glucose binding protein with Leucine-rich repeat domain', 166, NULL, NULL, 132715),
(132716, '2.170.300.10-FF-000095', NULL, 'Uncharacterized protein', 61, NULL, NULL, 132716),
(132717, '3.60.10.10-FF-000292', NULL, 'Uncharacterized protein', 356, NULL, NULL, 132717),
(132718, '2.130.10.10-FF-001392', NULL, 'Damaged DNA binding protein', 180, NULL, NULL, 132718),
(132719, '3.40.1190.20-FF-000125', NULL, 'Pyridoxal kinase family protein', 278, NULL, NULL, 132719),
(132720, '1.25.10.10-FF-001299', NULL, 'Protein CBG08524', 160, NULL, NULL, 132720),
(132721, '3.10.250.10-FF-000106', NULL, NULL, 105, NULL, NULL, 132721),
(132722, '1.25.40.20-FF-000056', NULL, 'Death associated protein kinase 1', 153, NULL, NULL, 132722),
(132723, '2.10.110.10-FF-000275', NULL, 'LIM and senescent cell antigen-like-containing domain protein 1', 64, NULL, NULL, 132723),
(132724, '3.30.2350.10-FF-000076', NULL, 'Uncharacterized protein', 185, NULL, NULL, 132724),
(132725, '1.20.1070.10-FF-000855', NULL, 'Olfactory receptor', 99, NULL, NULL, 132725),
(132726, '3.90.70.10-FF-000142', NULL, 'Cysteine proteinase-like', 335, NULL, NULL, 132726),
(132727, '3.40.50.300-FF-003932', NULL, 'DNA polymerase III subunit delta', 188, NULL, NULL, 132727),
(132728, '1.25.40.20-FF-000112', NULL, 'synphilin-1 isoform X1', 239, NULL, NULL, 132728),
(132729, '3.40.50.10490-FF-000074', NULL, 'RpiR family transcriptional regulator', 179, NULL, NULL, 132729),
(132730, '3.40.50.150-FF-001448', NULL, NULL, 141, NULL, NULL, 132730),
(132731, '3.30.1330.30-FF-000119', NULL, '23S rRNA (guanosine-2''-O-)-methyltransferase RlmB', 75, NULL, NULL, 132731);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(132732, '3.30.450.20-FF-000339', NULL, 'Methyl-accepting chemotaxis transmembrane protein', 109, NULL, NULL, 132732),
(132733, '3.30.9.10-FF-000076', NULL, 'FAD-binding oxidoreductase', 151, NULL, NULL, 132733),
(132734, '2.10.60.10-FF-000046', NULL, 'RIKEN cDNA 1810065E05 gene', 75, NULL, NULL, 132734),
(132735, '1.25.10.10-FF-002991', NULL, 'AP-3 complex subunit delta', 373, NULL, NULL, 132735),
(132736, '1.10.1520.10-FF-000112', NULL, 'Uncharacterized protein', 77, NULL, NULL, 132736),
(132737, '2.130.10.10-FF-003191', NULL, 'Uncharacterized protein', 117, NULL, NULL, 132737),
(132738, '3.30.420.40-FF-001069', NULL, 'Uncharacterized protein', 40, NULL, NULL, 132738),
(132739, '2.60.120.970-FF-000093', NULL, 'AGAP000342-PA', 183, NULL, NULL, 132739),
(132740, '1.10.8.60-FF-000121', NULL, 'DnaA regulatory inactivator Hda', 66, NULL, NULL, 132740),
(132741, '2.40.128.20-FF-000019', NULL, 'LiPocalin-Related protein', 159, NULL, NULL, 132741),
(132742, '3.30.70.330-FF-002672', NULL, NULL, 132, NULL, NULL, 132742),
(132743, '2.130.10.10-FF-006006', NULL, 'Uncharacterized protein', 18, NULL, NULL, 132743),
(132744, '3.80.10.10-FF-000627', NULL, 'Probable leucine-rich repeat receptor-like protein kinase At2g33170', 157, NULL, NULL, 132744),
(132745, '1.10.418.70-FF-000011', NULL, 'Uncharacterized protein', 49, NULL, NULL, 132745),
(132746, '1.20.120.1770-FF-000018', NULL, 'Predicted protein', 168, NULL, NULL, 132746),
(132747, '1.10.10.10-FF-000045', NULL, 'ROK family transcriptional regulator', 79, NULL, NULL, 132747),
(132748, '1.10.506.10-FF-000063', NULL, 'Ras GTPase-activating protein gap-1', 221, NULL, NULL, 132748),
(132749, '3.40.50.150-FF-001487', NULL, NULL, 122, NULL, NULL, 132749),
(132750, '4.10.240.10-FF-000063', NULL, 'AaceriADR404Cp', 66, NULL, NULL, 132750),
(132751, '3.30.1370.210-FF-000009', NULL, 'Zinc finger CCCH domain-containing protein 66', 69, NULL, NULL, 132751),
(132752, '1.25.40.10-FF-003049', NULL, 'YALI0C19426p', 80, NULL, NULL, 132752),
(132753, '2.60.120.10-FF-000415', NULL, 'Uncharacterized protein', 142, NULL, NULL, 132753),
(132754, '2.60.120.10-FF-000472', NULL, 'cAMP-dependent protein kinase type II-alpha regulatory subunit', 143, NULL, NULL, 132754),
(132755, '3.30.450.20-FF-000396', NULL, 'PAS domain containing serine/threonine kinase', 91, NULL, NULL, 132755),
(132756, '3.40.50.300-FF-005787', NULL, 'Os06g0120732 protein', 85, NULL, NULL, 132756),
(132757, '3.40.50.620-FF-000712', NULL, 'Nicotinamide-nucleotide adenylyltransferase', 220, NULL, NULL, 132757),
(132758, '3.30.160.60-FF-003550', NULL, NULL, 33, NULL, NULL, 132758),
(132759, '2.130.10.10-FF-001279', NULL, 'Protein HIRA', 114, NULL, NULL, 132759),
(132760, '3.90.70.80-FF-000067', NULL, 'Uncharacterized protein', 154, NULL, NULL, 132760),
(132761, '1.10.10.160-FF-000058', NULL, 'ADR113Wp', 65, NULL, NULL, 132761),
(132762, '3.30.2290.10-FF-000020', NULL, 'Predicted Zn-dependent protease', 220, NULL, NULL, 132762),
(132763, '3.40.50.360-FF-000145', NULL, 'Ribosyldihydronicotinamide dehydrogenase [quinone]', 139, NULL, NULL, 132763),
(132764, '3.30.160.60-FF-003836', NULL, NULL, 29, NULL, NULL, 132764),
(132765, '3.30.70.330-FF-001654', NULL, 'YALI0B00616p', 174, NULL, NULL, 132765),
(132766, '1.10.8.430-FF-000012', NULL, 'Disease resistance protein RGA5', 91, NULL, NULL, 132766),
(132767, '3.40.50.10320-FF-000012', NULL, 'Uncharacterized protein', 266, NULL, NULL, 132767),
(132768, '2.30.29.30-FF-001361', NULL, 'Myosin-M heavy chain', 132, NULL, NULL, 132768),
(132769, '1.10.10.10-FF-001063', NULL, 'Hypothetical_protein_-_conserved', 83, NULL, NULL, 132769),
(132770, '3.30.40.10-FF-000946', NULL, 'Serine/threonine-protein phosphatase', 63, NULL, NULL, 132770),
(132771, '1.20.920.10-FF-000219', NULL, 'Uncharacterized protein', 78, NULL, NULL, 132771),
(132772, '3.40.50.620-FF-000656', NULL, 'Asparagine synthetase domain-containing protein C4F6.11c', 324, NULL, NULL, 132772),
(132773, '3.40.1380.20-FF-000050', NULL, 'Pyruvate kinase', 121, NULL, NULL, 132773),
(132774, '3.40.50.10330-FF-000015', NULL, 'acylglycerol kinase, mitochondrial', 139, NULL, NULL, 132774);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(132775, '1.10.510.10-FF-003951', NULL, NULL, 55, NULL, NULL, 132775),
(132776, '1.10.10.10-FF-001349', NULL, 'Transcriptional regulator, Crp/Fnr family', 80, NULL, NULL, 132776),
(132777, '2.60.120.290-FF-000097', NULL, 'SOL-1 related protein', 118, NULL, NULL, 132777),
(132778, '3.40.50.300-FF-007822', NULL, 'Predicted protein', 273, NULL, NULL, 132778),
(132779, '1.10.10.10-FF-000787', NULL, 'Methylated-DNA--protein-cysteine methyltransferase', 81, NULL, NULL, 132779),
(132780, '3.40.50.300-FF-003371', NULL, 'Related to ATP-binding multidrug cassette transport protein', 238, NULL, NULL, 132780),
(132781, '3.30.1120.10-FF-000013', NULL, 'Arylsulfatase A', 72, NULL, NULL, 132781),
(132782, '1.50.10.20-FF-000108', NULL, 'CAAX farnesyl transferase', 258, NULL, NULL, 132782),
(132783, '2.60.40.10-FF-005298', NULL, NULL, 81, NULL, NULL, 132783),
(132784, '3.90.550.50-FF-000022', NULL, 'Hexosyltransferase', 230, NULL, NULL, 132784),
(132785, '1.20.1250.10-FF-000061', NULL, 'Prolactin-2B1', 200, NULL, NULL, 132785),
(132786, '3.20.20.80-FF-000269', NULL, 'Probable glucan endo-1,6-beta-glucosidase B', 372, NULL, NULL, 132786),
(132787, '3.20.20.70-FF-000446', NULL, 'Heme chaperone HemW', 216, NULL, NULL, 132787),
(132788, '3.80.10.10-FF-001302', NULL, 'Tonsoku-like protein', 346, NULL, NULL, 132788),
(132789, '3.60.10.10-FF-000235', NULL, 'Putative transcriptional effector ccr4-related protein', 348, NULL, NULL, 132789),
(132790, '3.40.50.720-FF-002485', NULL, 'SUMO-activating enzyme subunit', 182, NULL, NULL, 132790),
(132791, '1.20.1070.10-FF-000075', NULL, 'orexin receptor type 2', 379, NULL, NULL, 132791),
(132792, '3.30.9.10-FF-000132', NULL, 'Glycerol-3-phosphate dehydrogenase', 161, NULL, NULL, 132792),
(132793, '1.10.1520.10-FF-000056', NULL, 'Putative RNase III', 148, NULL, NULL, 132793),
(132794, '3.40.1310.20-FF-000006', NULL, 'Initiator protein NS1', 181, NULL, NULL, 132794),
(132795, '3.40.390.10-FF-000189', NULL, NULL, 108, NULL, NULL, 132795),
(132796, '1.20.1270.330-FF-000002', NULL, NULL, 74, NULL, NULL, 132796),
(132797, '3.40.850.10-FF-000269', NULL, 'Kinesin family member 13A', 265, NULL, NULL, 132797),
(132798, '3.20.20.80-FF-000449', NULL, 'Uncharacterized protein', 123, NULL, NULL, 132798),
(132799, '2.130.10.10-FF-002696', NULL, 'Epg-6', 325, NULL, NULL, 132799),
(132800, '3.30.40.10-FF-001441', NULL, 'RNA binding (RRM/RBD/RNP motifs) family protein', 60, NULL, NULL, 132800),
(132801, '3.40.50.10190-FF-000102', NULL, 'Rad9p', 148, NULL, NULL, 132801),
(132802, '3.30.750.44-FF-000013', NULL, 'Carboxyl-terminal protease', 62, NULL, NULL, 132802),
(132803, '3.30.70.3020-FF-000001', NULL, 'U3 small nucleolar RNA-associated protein 22', 125, NULL, NULL, 132803),
(132804, '1.20.58.60-FF-000754', NULL, 'Si:ch211-165e15.1', 56, NULL, NULL, 132804),
(132805, '3.30.930.10-FF-000362', NULL, 'Phenylalanyl-tRNA synthetase alpha chain, putative', 69, NULL, NULL, 132805),
(132806, '1.20.1170.10-FF-000003', NULL, 'E3 ubiquitin protein ligase', 245, NULL, NULL, 132806),
(132807, '1.20.245.10-FF-000004', NULL, 'Linolenate 9R-lipoxygenase', 269, NULL, NULL, 132807),
(132808, '1.10.510.10-FF-003771', NULL, NULL, 137, NULL, NULL, 132808),
(132809, '3.30.420.10-FF-000508', NULL, NULL, 180, NULL, NULL, 132809),
(132810, '2.170.150.80-FF-000024', NULL, 'At1g64105', 148, NULL, NULL, 132810),
(132811, '3.40.50.300-FF-007642', NULL, 'Uncharacterized protein', 138, NULL, NULL, 132811),
(132812, '3.90.1290.10-FF-000040', NULL, 'VAB-10A protein', 125, NULL, NULL, 132812),
(132813, '2.130.10.10-FF-003713', NULL, 'Uncharacterized protein', 42, NULL, NULL, 132813),
(132814, '1.10.287.410-FF-000004', NULL, 'Carboxypeptidase', 75, NULL, NULL, 132814),
(132815, '3.30.70.1230-FF-000166', NULL, 'Predicted protein', 200, NULL, NULL, 132815),
(132816, '1.20.5.170-FF-000044', NULL, 'cAMP-responsive element-binding protein-like 2 isoform X2', 53, NULL, NULL, 132816),
(132817, '3.60.21.10-FF-000030', NULL, 'Trifunctional nucleotide phosphoesterase protein YfkN', 310, NULL, NULL, 132817),
(132818, '3.40.50.12760-FF-000013', NULL, 'Uncharacterized protein', 248, NULL, NULL, 132818);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(132819, '4.10.280.50-FF-000004', NULL, 'Glutamate decarboxylase', 63, NULL, NULL, 132819),
(132820, '2.30.110.10-FF-000118', NULL, 'Uncharacterized protein', 95, NULL, NULL, 132820),
(132821, '1.20.1070.10-FF-000693', NULL, '5-hydroxytryptamine receptor 1-like Protein', 308, NULL, NULL, 132821),
(132822, '1.10.3450.40-FF-000008', NULL, 'Signal recognition particle 68 kDa protein, putative', 195, NULL, NULL, 132822),
(132823, '2.40.50.1070-FF-000015', NULL, 'tRNA (Uracil-5-)-methyltransferase domain protein', 51, NULL, NULL, 132823),
(132824, '1.10.10.60-FF-001268', NULL, NULL, 84, NULL, NULL, 132824),
(132825, '1.10.8.10-FF-000297', NULL, 'Uncharacterized protein', 57, NULL, NULL, 132825),
(132826, '3.90.640.10-FF-000208', NULL, 'Actin-related protein 5-like protein', 51, NULL, NULL, 132826),
(132827, '3.40.50.150-FF-001268', NULL, NULL, 231, NULL, NULL, 132827),
(132828, '3.30.710.10-FF-000380', NULL, 'LD01876p', 130, NULL, NULL, 132828),
(132829, '3.30.70.330-FF-001093', NULL, 'THO complex subunit 4D', 81, NULL, NULL, 132829),
(132830, '1.10.630.10-FF-000677', NULL, 'Uncharacterized protein', 164, NULL, NULL, 132830),
(132831, '1.10.1370.40-FF-000002', NULL, 'Mitochondrial intermediate peptidase', 147, NULL, NULL, 132831),
(132832, '3.10.20.90-FF-000413', NULL, 'Ubiquitin_family_-_putative', 65, NULL, NULL, 132832),
(132833, '1.10.287.400-FF-000001', NULL, 'Argininosuccinate synthase', 66, NULL, NULL, 132833),
(132834, '2.60.40.420-FF-000088', NULL, 'Multicopper oxidase, putative', 149, NULL, NULL, 132834),
(132835, '3.30.1120.10-FF-000070', NULL, 'N-acetylgalactosamine-6-sulfatase, putative', 75, NULL, NULL, 132835),
(132836, '2.40.50.1060-FF-000012', NULL, 'YALI0F06182p', 164, NULL, NULL, 132836),
(132837, '3.30.160.60-FF-000402', NULL, 'IKAROS family zinc finger 5', 27, NULL, NULL, 132837),
(132838, '3.30.70.100-FF-000203', NULL, NULL, 68, NULL, NULL, 132838),
(132839, '3.30.70.330-FF-001036', NULL, 'Putative rna-binding protein fus', 136, NULL, NULL, 132839),
(132840, '1.50.10.10-FF-000162', NULL, 'alpha-1,2-Mannosidase', 278, NULL, NULL, 132840),
(132841, '1.10.10.10-FF-001681', NULL, 'Interferon regulatory factor 1', 118, NULL, NULL, 132841),
(132842, '3.40.50.12780-FF-000019', NULL, 'Long-chain fatty acid transporter', 431, NULL, NULL, 132842),
(132843, '1.10.260.30-FF-000020', NULL, 'Signal recognition particle 54 kDa protein', 50, NULL, NULL, 132843),
(132844, '3.30.930.10-FF-000087', NULL, 'Lysine--tRNA ligase', 376, NULL, NULL, 132844),
(132845, '1.50.10.10-FF-000105', NULL, 'Glycoside hydrolase family 95', 469, NULL, NULL, 132845),
(132846, '1.25.40.20-FF-000331', NULL, 'Ankyrin repeat family protein', 138, NULL, NULL, 132846),
(132847, '1.10.10.10-FF-001624', NULL, 'Transcription factor E', 99, NULL, NULL, 132847),
(132848, '3.90.640.10-FF-000265', NULL, 'Heat shock protein, Hsp70 family', 77, NULL, NULL, 132848),
(132849, '3.80.10.10-FF-000807', NULL, 'PRELP isoform 1', 98, NULL, NULL, 132849),
(132850, '1.10.4160.10-FF-000039', NULL, 'Uncharacterized protein', 476, NULL, NULL, 132850),
(132851, '2.40.50.140-FF-000645', NULL, NULL, 60, NULL, NULL, 132851),
(132852, '1.10.600.10-FF-000069', NULL, 'Farnesyl diphosphate synthase', 381, NULL, NULL, 132852),
(132853, '3.90.850.10-FF-000022', NULL, 'Hypothetical_protein_-_conserved', 254, NULL, NULL, 132853),
(132854, '3.40.630.30-FF-000444', NULL, 'Nat4p', 196, NULL, NULL, 132854),
(132855, '2.60.40.1930-FF-000010', NULL, 'C3 and PZP like, alpha-2-macroglobulin domain containing 8', 41, NULL, NULL, 132855),
(132856, '3.40.1440.10-FF-000007', NULL, 'I-TevI homing endonuclease', 98, NULL, NULL, 132856),
(132857, '3.40.50.1240-FF-000200', NULL, NULL, 78, NULL, NULL, 132857),
(132858, '2.130.10.10-FF-003314', NULL, 'Uncharacterized protein', 162, NULL, NULL, 132858),
(132859, '3.40.50.1110-FF-000122', NULL, 'Uncharacterized protein', 219, NULL, NULL, 132859),
(132860, '3.10.490.20-FF-000037', NULL, 'Dynein heavy chain family protein', 174, NULL, NULL, 132860),
(132861, '2.60.40.10-FF-001863', NULL, 'Muscle M-line assembly protein unc-89', 99, NULL, NULL, 132861);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(132862, '3.10.200.10-FF-000008', NULL, 'Carbonic anhydrase, putative', 300, NULL, NULL, 132862),
(132863, '3.40.50.1820-FF-000745', NULL, 'Serine protease K12H4.7-related protein', 113, NULL, NULL, 132863),
(132864, '2.20.110.10-FF-000059', NULL, NULL, 82, NULL, NULL, 132864),
(132865, '3.40.50.1010-FF-000148', NULL, NULL, 138, NULL, NULL, 132865),
(132866, '3.30.1120.30-FF-000019', NULL, 'PLK/PLK1 protein kinase', 76, NULL, NULL, 132866),
(132867, '3.60.110.10-FF-000097', NULL, NULL, 290, NULL, NULL, 132867),
(132868, '3.40.50.300-FF-007081', NULL, 'Ras-related protein RabU', 192, NULL, NULL, 132868),
(132869, '3.30.160.60-FF-004112', NULL, NULL, 26, NULL, NULL, 132869),
(132870, '3.30.230.10-FF-000354', NULL, 'Uncharacterized protein', 134, NULL, NULL, 132870),
(132871, '1.20.120.1240-FF-000028', NULL, 'Dynamin 1', 100, NULL, NULL, 132871),
(132872, '1.10.10.1410-FF-000006', NULL, NULL, 56, NULL, NULL, 132872),
(132873, '3.10.20.90-FF-000306', NULL, 'Putative ubiquitin-like protein', 78, NULL, NULL, 132873),
(132874, '1.20.1560.10-FF-000893', NULL, 'Uncharacterized protein', 17, NULL, NULL, 132874),
(132875, '1.20.1250.20-FF-000614', NULL, 'MFS transporter', 198, NULL, NULL, 132875),
(132876, '3.30.70.330-FF-001452', NULL, 'RNA Binding Motif protein homolog', 133, NULL, NULL, 132876),
(132877, '3.65.10.20-FF-000008', NULL, 'RNA 3''-terminal phosphate cyclase', 222, NULL, NULL, 132877),
(132878, '3.40.50.300-FF-005809', NULL, 'Bifunctional dethiobiotin synthetase/adenosylmethionine-8-amino-7-oxononanoate aminotransferase', 253, NULL, NULL, 132878),
(132879, '3.65.10.10-FF-000005', NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', 210, NULL, NULL, 132879),
(132880, '1.10.10.1420-FF-000009', NULL, NULL, 134, NULL, NULL, 132880),
(132881, '1.10.10.2670-FF-000013', NULL, 'ATP-dependent Clp protease adaptor protein ClpS', 122, NULL, NULL, 132881),
(132882, '3.40.50.720-FF-000484', NULL, 'Pentafunctional AROM polypeptide', 156, NULL, NULL, 132882),
(132883, '1.10.8.480-FF-000004', NULL, 'rRNA adenine N(6)-methyltransferase', 98, NULL, NULL, 132883),
(132884, '3.40.20.10-FF-000068', NULL, 'TWF1p Twinfilin', 125, NULL, NULL, 132884),
(132885, '1.50.40.10-FF-000231', NULL, 'Mitochondrial RNA-splicing protein MRS3', 148, NULL, NULL, 132885),
(132886, '3.30.160.60-FF-005882', NULL, NULL, 36, NULL, NULL, 132886),
(132887, '3.10.580.10-FF-000204', NULL, 'Hemolysin', 146, NULL, NULL, 132887),
(132888, '3.40.630.30-FF-000337', NULL, 'L-2,4-diaminobutyric acid acetyltransferase', 159, NULL, NULL, 132888),
(132889, '1.20.900.10-FF-000078', NULL, 'Guanine nucleotide exchange factor UNC-73B', 192, NULL, NULL, 132889),
(132890, '2.30.29.30-FF-000883', NULL, 'Uncharacterized protein', 111, NULL, NULL, 132890),
(132891, '2.60.120.1000-FF-000023', NULL, 'Predicted protein', 123, NULL, NULL, 132891),
(132892, '3.30.9.10-FF-000104', NULL, 'Putative transcriptional regulator', 116, NULL, NULL, 132892),
(132893, '3.40.850.10-FF-000488', NULL, 'Predicted protein', 70, NULL, NULL, 132893),
(132894, '1.20.120.1530-FF-000008', NULL, 'Methyl-accepting chemotaxis protein', 90, NULL, NULL, 132894),
(132895, '1.10.10.1100-FF-000020', NULL, 'Glycerol-3-phosphate dehydrogenase', 70, NULL, NULL, 132895),
(132896, '1.10.150.50-FF-000012', NULL, 'Poly [ADP-ribose] polymerase', 76, NULL, NULL, 132896),
(132897, '1.10.10.2660-FF-000010', NULL, 'SUMO-activating enzyme subunit', 58, NULL, NULL, 132897),
(132898, '2.130.10.10-FF-004320', NULL, 'Uncharacterized protein', 107, NULL, NULL, 132898),
(132899, '3.40.50.300-FF-007373', NULL, 'Uncharacterized protein', 190, NULL, NULL, 132899),
(132900, '2.10.25.10-FF-000167', NULL, 'neurexin-1 isoform X1', 38, NULL, NULL, 132900),
(132901, '3.30.200.20-FF-001215', NULL, 'Cyclin dependent kinase like 2', 75, NULL, NULL, 132901),
(132902, '1.10.1660.20-FF-000001', NULL, 'Excisionase', 72, NULL, NULL, 132902),
(132903, '3.30.9.10-FF-000093', NULL, 'FAD monooxygenase, PheA/TfdB family', 111, NULL, NULL, 132903),
(132904, '1.25.40.10-FF-000795', NULL, 'Tetratricopeptide repeat protein 25', 222, NULL, NULL, 132904); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(132905, '3.30.1150.10-FF-000032', NULL, NULL, 173, NULL, NULL, 132905),
(132906, '3.90.640.10-FF-000293', NULL, 'Heat shock protein, putative', 37, NULL, NULL, 132906),
(132907, '2.60.120.620-FF-000050', NULL, 'Uncharacterized protein', 193, NULL, NULL, 132907),
(132908, '2.130.10.10-FF-001723', NULL, 'Dynein intermediate chain 3, ciliary', 195, NULL, NULL, 132908),
(132909, '3.40.50.2000-FF-000939', NULL, 'Glycosyltransferase', 138, NULL, NULL, 132909),
(132910, '3.30.40.10-FF-000429', NULL, 'E3 ubiquitin-protein ligase RNF13', 70, NULL, NULL, 132910),
(132911, '4.10.1240.10-FF-000054', NULL, 'Adenylate cyclase-activating polypeptide 1 (pituitary) receptor type I', 105, NULL, NULL, 132911),
(132912, '3.60.40.10-FF-000158', NULL, 'Protein phosphatase, Mg2+/Mn2+ dependent, 1D', 225, NULL, NULL, 132912),
(132913, '3.30.450.20-FF-000418', NULL, 'Sensory box sensor histidine kinase', 129, NULL, NULL, 132913),
(132914, '1.20.1250.20-FF-001120', NULL, 'MFS multidrug transporter, putative', 184, NULL, NULL, 132914),
(132915, '3.30.70.330-FF-000946', NULL, 'Predicted protein', 118, NULL, NULL, 132915),
(132916, '2.130.10.10-FF-005422', NULL, 'ADR293Cp', 293, NULL, NULL, 132916),
(132917, '2.30.29.30-FF-001400', NULL, 'Uncharacterized protein', 125, NULL, NULL, 132917),
(132918, '2.60.120.200-FF-000290', NULL, 'CNE1p Calnexin', 219, NULL, NULL, 132918),
(132919, '3.80.10.10-FF-000493', NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At5g63710', 159, NULL, NULL, 132919),
(132920, '1.10.630.10-FF-000722', NULL, 'Uncharacterized protein', 102, NULL, NULL, 132920),
(132921, '1.25.40.10-FF-003066', NULL, 'YALI0B00528p', 207, NULL, NULL, 132921),
(132922, '2.70.130.10-FF-000043', NULL, 'Insulin like growth factor 2 receptor', 145, NULL, NULL, 132922),
(132923, '2.10.220.10-FF-000103', NULL, 'Tyrosine-protein kinase receptor', 75, NULL, NULL, 132923),
(132924, '1.10.510.10-FF-001068', NULL, 'G2-specific protein kinase nimA', 62, NULL, NULL, 132924),
(132925, '3.40.1110.10-FF-000117', NULL, 'Phospholipid-transporting ATPase', 148, NULL, NULL, 132925),
(132926, '1.10.8.470-FF-000001', NULL, 'GTP-binding protein homolog', 89, NULL, NULL, 132926),
(132927, '3.20.80.10-FF-000050', NULL, 'Uncharacterized protein', 178, NULL, NULL, 132927),
(132928, '2.60.40.1180-FF-000043', NULL, 'Isoamylase 3, chloroplastic', 95, NULL, NULL, 132928),
(132929, '1.25.10.10-FF-000967', NULL, 'Armadillo/beta-catenin repeat family protein', 88, NULL, NULL, 132929),
(132930, '3.40.50.720-FF-001001', NULL, 'NADP-dependent 3-hydroxy acid dehydrogenase YdfG', 231, NULL, NULL, 132930),
(132931, '3.50.50.60-FF-000938', NULL, 'Glutathione reductase', 207, NULL, NULL, 132931),
(132932, '1.10.1370.10-FF-000038', NULL, 'Predicted protein', 164, NULL, NULL, 132932),
(132933, '3.20.20.140-FF-000437', NULL, 'Non-ATP-dependent L-selective hydantoinase, putative', 141, NULL, NULL, 132933),
(132934, '3.30.160.60-FF-001178', NULL, 'zinc finger protein 287', 29, NULL, NULL, 132934),
(132935, '3.10.310.40-FF-000008', NULL, 'Alanine--tRNA ligase', 102, NULL, NULL, 132935),
(132936, '1.10.275.60-FF-000001', NULL, 'Adenylosuccinate lyase', 138, NULL, NULL, 132936),
(132937, '1.20.1420.30-FF-000097', NULL, 'Potassium-dependent sodium-calcium exchanger, putative', 194, NULL, NULL, 132937),
(132938, '3.30.40.10-FF-000755', NULL, 'RING-H2 finger protein ATL57', 78, NULL, NULL, 132938),
(132939, '3.40.50.2000-FF-001075', NULL, 'Alpha-1,4 glucan phosphorylase', 43, NULL, NULL, 132939),
(132940, '3.40.50.800-FF-000047', NULL, 'Histidine--tRNA ligase', 92, NULL, NULL, 132940),
(132941, '2.60.120.520-FF-000003', NULL, '4-deoxy-L-threo-5-hexosulose-uronate ketol-isomerase', 111, NULL, NULL, 132941),
(132942, '1.10.565.10-FF-000036', NULL, 'Nuclear hormone receptor FTZ-F1 beta', 231, NULL, NULL, 132942),
(132943, '3.80.10.10-FF-003090', NULL, 'Uncharacterized protein', 120, NULL, NULL, 132943),
(132944, '1.10.10.10-FF-001793', NULL, 'DNA-directed RNA polymerase III subunit RPC3-like Protein', 84, NULL, NULL, 132944),
(132945, '3.40.50.12780-FF-000238', NULL, 'Uncharacterized protein', 425, NULL, NULL, 132945);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(132946, '2.60.120.920-FF-000033', NULL, 'Si:dkeyp-100h4.1', 181, NULL, NULL, 132946),
(132947, '1.10.510.10-FF-001394', NULL, 'Calmodulin-binding receptor kinase CaMRLK', 94, NULL, NULL, 132947),
(132948, '1.20.1730.10-FF-000058', NULL, 'Uncharacterized protein', 336, NULL, NULL, 132948),
(132949, '1.20.1280.50-FF-000164', NULL, 'uncharacterized protein LOC106571384 isoform X2', 173, NULL, NULL, 132949),
(132950, '3.40.720.10-FF-000260', NULL, 'Predicted protein', 48, NULL, NULL, 132950),
(132951, '1.10.10.10-FF-001804', NULL, 'Transcriptional regulator (IclR family)', 72, NULL, NULL, 132951),
(132952, '3.40.50.300-FF-003039', NULL, 'Nicotinamide-nucleotide adenylyltransferase', 163, NULL, NULL, 132952),
(132953, '2.60.40.10-FF-001392', NULL, 'Interleukin 23 receptor', 98, NULL, NULL, 132953),
(132954, '2.30.30.570-FF-000002', NULL, 'Major vault protein-alpha', 52, NULL, NULL, 132954),
(132955, '1.20.58.1120-FF-000035', NULL, 'Dynein heavy chain, putative', 138, NULL, NULL, 132955),
(132956, '3.30.930.10-FF-000025', NULL, 'Aspartate--ammonia ligase', 330, NULL, NULL, 132956),
(132957, '3.50.50.60-FF-001444', NULL, 'Predicted protein', 95, NULL, NULL, 132957),
(132958, '1.10.555.10-FF-000064', NULL, 'Rho GTPase activating protein at 15B, isoform B', 200, NULL, NULL, 132958),
(132959, '3.30.160.60-FF-003639', NULL, 'C2H2 and C2HC zinc fingers superfamily protein', 67, NULL, NULL, 132959),
(132960, '1.20.1050.10-FF-000293', NULL, 'Uncharacterized protein', 18, NULL, NULL, 132960),
(132961, '1.10.472.10-FF-000669', NULL, 'Uncharacterized protein', 69, NULL, NULL, 132961),
(132962, '3.40.50.300-FF-007417', NULL, 'p-glycoprotein/multidrug resistance protein', 14, NULL, NULL, 132962),
(132963, '2.60.40.10-FF-005770', NULL, NULL, 115, NULL, NULL, 132963),
(132964, '2.170.180.11-FF-000001', NULL, 'G-protein coupled receptor Mth', 127, NULL, NULL, 132964),
(132965, '3.40.50.410-FF-000172', NULL, 'Uncharacterized protein', 153, NULL, NULL, 132965),
(132966, '1.10.472.80-FF-000280', NULL, NULL, 127, NULL, NULL, 132966),
(132967, '1.25.10.10-FF-003238', NULL, 'Serine/threonine-protein kinase TOR', 247, NULL, NULL, 132967),
(132968, '2.10.90.10-FF-000126', NULL, 'Growth/differentiation factor 8', 107, NULL, NULL, 132968),
(132969, '3.30.420.10-FF-000576', NULL, NULL, 235, NULL, NULL, 132969),
(132970, '2.140.10.30-FF-000003', NULL, 'Probable dipeptidyl peptidase 4', 455, NULL, NULL, 132970),
(132971, '3.90.70.10-FF-000035', NULL, 'Ubiquitin carboxyl-terminal hydrolase 3', 357, NULL, NULL, 132971),
(132972, '3.30.160.60-FF-001824', NULL, 'zinc finger protein 628', 60, NULL, NULL, 132972),
(132973, '3.40.50.360-FF-000033', NULL, 'Nitric oxide synthase', 224, NULL, NULL, 132973),
(132974, '3.80.10.10-FF-002937', NULL, 'CLL4A clavata1-like receptor S/T protein kinase protein', 96, NULL, NULL, 132974),
(132975, '2.30.30.1020-FF-000002', NULL, 'CCR4-NOT transcription complex subunit 3', 146, NULL, NULL, 132975),
(132976, '3.60.21.60-FF-000011', NULL, 'DNA polymerase alpha subunit B', 236, NULL, NULL, 132976),
(132977, '1.20.1250.20-FF-000940', NULL, 'MFS sugar transporter, putative', 233, NULL, NULL, 132977),
(132978, '3.40.50.300-FF-002246', NULL, 'DEAD box helicase, putative', 241, NULL, NULL, 132978),
(132979, '3.80.10.10-FF-001010', NULL, 'S-phase kinase-associated protein 2', 326, NULL, NULL, 132979),
(132980, '3.40.50.1820-FF-000661', NULL, 'Putative phospholipase', 429, NULL, NULL, 132980),
(132981, '3.40.50.10130-FF-000056', NULL, 'Uncharacterized protein', 96, NULL, NULL, 132981),
(132982, '2.130.10.10-FF-002988', NULL, 'WD40-repeat-containing domain protein', 200, NULL, NULL, 132982),
(132983, '3.30.200.20-FF-001541', NULL, 'Nonspecific serine/threonine protein kinase', 133, NULL, NULL, 132983),
(132984, '1.20.58.60-FF-000557', NULL, 'Spectrin beta, non-erythrocytic 5', 180, NULL, NULL, 132984),
(132985, '3.30.465.10-FF-000039', NULL, 'CBS domain membrane protein', 84, NULL, NULL, 132985),
(132986, '2.120.10.30-FF-000398', NULL, 'Uncharacterized protein', 233, NULL, NULL, 132986),
(132987, '3.60.150.10-FF-000009', NULL, 'Chorismate synthase', 105, NULL, NULL, 132987);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(132988, '3.40.50.200-FF-000125', NULL, 'Os01g0795400 protein', 199, NULL, NULL, 132988),
(132989, '1.20.970.10-FF-000026', NULL, 'Anthranilate phosphoribosyltransferase', 64, NULL, NULL, 132989),
(132990, '2.170.16.10-FF-000026', NULL, 'MCM / cell division control protein 21', 180, NULL, NULL, 132990),
(132991, '1.20.1560.10-FF-000258', NULL, 'Putative abc a-pheromone efflux pump protein', 277, NULL, NULL, 132991),
(132992, '3.40.50.10140-FF-000059', NULL, 'Disease resistance protein (TIR-NBS class)', 167, NULL, NULL, 132992),
(132993, '3.30.200.20-FF-002030', NULL, 'Uncharacterized protein', 91, NULL, NULL, 132993),
(132994, '3.40.50.300-FF-007743', NULL, 'Uncharacterized protein', 79, NULL, NULL, 132994),
(132995, '3.50.30.30-FF-000057', NULL, 'Protein CBG07640', 145, NULL, NULL, 132995),
(132996, '3.40.250.10-FF-000252', NULL, 'Tyrosine-protein phosphatase 2', 121, NULL, NULL, 132996),
(132997, '1.10.3730.20-FF-000030', NULL, 'Putative multidrug transporter EmrE', 109, NULL, NULL, 132997),
(132998, '3.50.50.60-FF-001091', NULL, 'Uncharacterized protein', 271, NULL, NULL, 132998),
(132999, '3.40.50.720-FF-001310', NULL, 'Trk system potassium uptake protein trkA', 134, NULL, NULL, 132999),
(133000, '1.20.58.60-FF-000866', NULL, 'Predicted protein', 122, NULL, NULL, 133000),
(133001, '1.20.1560.10-FF-000567', NULL, 'Protein CBR-HMT-1', 153, NULL, NULL, 133001),
(133002, '3.10.170.20-FF-000030', NULL, NULL, 101, NULL, NULL, 133002),
(133003, '3.80.10.10-FF-004192', NULL, 'Uncharacterized protein', 92, NULL, NULL, 133003),
(133004, '3.40.50.1820-FF-000970', NULL, 'Chlorophyllase I', 274, NULL, NULL, 133004),
(133005, '3.40.50.1010-FF-000261', NULL, NULL, 238, NULL, NULL, 133005),
(133006, '2.30.29.30-FF-000557', NULL, 'FERM domain (Protein4.1-ezrin-radixin-moesin) family', 96, NULL, NULL, 133006),
(133007, '3.40.50.300-FF-004500', NULL, 'ABC transporter', 314, NULL, NULL, 133007),
(133008, '3.40.630.30-FF-000028', NULL, 'N-alpha-acetyltransferase 60 isoform X1', 182, NULL, NULL, 133008),
(133009, '3.20.20.80-FF-000590', NULL, 'Uncharacterized protein', 212, NULL, NULL, 133009),
(133010, '3.30.930.10-FF-000351', NULL, 'Uncharacterized protein', 51, NULL, NULL, 133010),
(133011, '2.60.120.10-FF-000253', NULL, 'Cyclic nucleotide-gated potassium channel', 131, NULL, NULL, 133011),
(133012, '2.60.120.10-FF-000623', NULL, 'Uncharacterized protein', 60, NULL, NULL, 133012),
(133013, '3.80.10.10-FF-000167', NULL, 'epiphycan', 209, NULL, NULL, 133013),
(133014, '2.30.110.10-FF-000040', NULL, 'Deazaflavin-dependent nitroreductase', 116, NULL, NULL, 133014),
(133015, '3.20.20.80-FF-000808', NULL, 'Predicted protein', 118, NULL, NULL, 133015),
(133016, '4.10.280.10-FF-000239', NULL, 'Predicted protein', 63, NULL, NULL, 133016),
(133017, '2.130.10.10-FF-005629', NULL, 'Uncharacterized protein', 178, NULL, NULL, 133017),
(133018, '3.60.20.40-FF-000008', NULL, 'Gamma-glutamyltranspeptidase (Eurofung)', 194, NULL, NULL, 133018),
(133019, '3.40.630.20-FF-000025', NULL, 'Pyroglutamyl-peptidase I', 136, NULL, NULL, 133019),
(133020, '3.30.160.60-FF-003965', NULL, 'Hermaphrodite, isoform A', 79, NULL, NULL, 133020),
(133021, '2.130.10.10-FF-001386', NULL, 'U3 small nucleolar RNA-associated protein 12,putative', 210, NULL, NULL, 133021),
(133022, '2.60.40.10-FF-001419', NULL, 'Uncharacterized protein, isoform C', 97, NULL, NULL, 133022),
(133023, '1.10.510.10-FF-002220', NULL, 'Non-specific serine/threonine protein kinase', 349, NULL, NULL, 133023),
(133024, '1.10.1200.10-FF-000043', NULL, 'Polyketide synthase Pks13', 84, NULL, NULL, 133024),
(133025, '3.30.70.330-FF-001143', NULL, 'la protein homolog', 100, NULL, NULL, 133025),
(133026, '2.60.120.330-FF-000070', NULL, '2-oxoglutarate (2OG) and Fe(II)-dependent oxygenase superfamily protein', 151, NULL, NULL, 133026),
(133027, '1.10.8.10-FF-000319', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 55, NULL, NULL, 133027),
(133028, '3.20.20.70-FF-000805', NULL, NULL, 119, NULL, NULL, 133028),
(133029, '1.10.8.60-FF-000183', NULL, 'Replication factor C, subunit 1, putative', 69, NULL, NULL, 133029);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(133030, '1.10.10.250-FF-000006', NULL, '50S ribosomal protein L11', 86, NULL, NULL, 133030),
(133031, '2.60.40.10-FF-005444', NULL, NULL, 104, NULL, NULL, 133031),
(133032, '3.90.1750.10-FF-000070', NULL, 'Hect domain and RLD 3', 31, NULL, NULL, 133032),
(133033, '1.50.10.10-FF-000083', NULL, 'Non-lysosomal glucosylceramidase', 289, NULL, NULL, 133033),
(133034, '2.120.10.30-FF-000122', NULL, 'Signal peptide protein', 340, NULL, NULL, 133034),
(133035, '3.40.710.10-FF-000169', NULL, 'Cell division protein FtsI [Peptidoglycan synthetase]', 186, NULL, NULL, 133035),
(133036, '3.40.50.300-FF-001757', NULL, 'Adenylate kinase 9', 195, NULL, NULL, 133036),
(133037, '1.10.10.350-FF-000036', NULL, NULL, 77, NULL, NULL, 133037),
(133038, '3.90.830.10-FF-000004', NULL, 'vacuolar protein sorting-associated protein 33B isoform X1', 113, NULL, NULL, 133038),
(133039, '2.70.160.11-FF-000097', NULL, 'TPR domain protein', 139, NULL, NULL, 133039),
(133040, '3.90.190.10-FF-000185', NULL, 'Predicted protein', 178, NULL, NULL, 133040),
(133041, '3.20.20.10-FF-000041', NULL, 'Predicted amino acid aldolase or racemase', 233, NULL, NULL, 133041),
(133042, '3.10.580.10-FF-000160', NULL, 'AMP-activated protein kinase, gamma regulatory subunit', 141, NULL, NULL, 133042),
(133043, '3.40.50.10190-FF-000293', NULL, 'Probable DNA polymerase III polC-type', 101, NULL, NULL, 133043),
(133044, '3.80.10.10-FF-002628', NULL, 'Uncharacterized protein', 170, NULL, NULL, 133044),
(133045, '1.50.10.20-FF-000086', NULL, 'Ubiquitin domain-containing protein', 288, NULL, NULL, 133045),
(133046, '3.40.190.80-FF-000065', NULL, 'Uncharacterized protein', 124, NULL, NULL, 133046),
(133047, '3.40.33.10-FF-000182', NULL, 'Uncharacterized protein', 76, NULL, NULL, 133047),
(133048, '2.60.40.10-FF-003499', NULL, NULL, 89, NULL, NULL, 133048),
(133049, '3.30.420.10-FF-000267', NULL, 'Putative ribonuclease', 176, NULL, NULL, 133049),
(133050, '3.30.70.1230-FF-000059', NULL, 'Guanylate cyclase', 210, NULL, NULL, 133050),
(133051, '1.25.10.20-FF-000015', NULL, 'Putative vitellogenin 2', 343, NULL, NULL, 133051),
(133052, '1.10.560.10-FF-000014', NULL, '60 kDa chaperonin', 240, NULL, NULL, 133052),
(133053, '2.40.50.100-FF-000150', NULL, 'Acetyl-CoA carboxylase/pyruvate carboxylase fusion protein, putative', 77, NULL, NULL, 133053),
(133054, '1.20.1250.40-FF-000024', NULL, 'DNA-directed RNA polymerases IV and V subunit 4', 143, NULL, NULL, 133054),
(133055, '2.60.40.1770-FF-000006', NULL, 'Eph receptor A2 a', 50, NULL, NULL, 133055),
(133056, '1.10.3370.10-FF-000038', NULL, 'Uncharacterized protein', 247, NULL, NULL, 133056),
(133057, '1.10.630.10-FF-000385', NULL, 'Cytochrome P450, putative', 263, NULL, NULL, 133057),
(133058, '3.30.160.60-FF-000413', NULL, 'PR domain zinc finger protein 10', 60, NULL, NULL, 133058),
(133059, '1.10.150.650-FF-000015', NULL, 'Predicted protein', 47, NULL, NULL, 133059),
(133060, '3.80.10.10-FF-000846', NULL, 'Predicted protein', 97, NULL, NULL, 133060),
(133061, '2.130.10.10-FF-003168', NULL, 'Uncharacterized protein', 322, NULL, NULL, 133061),
(133062, '1.25.10.10-FF-000012', NULL, 'Dishevelled associated activator of morphogenesis 2', 306, NULL, NULL, 133062),
(133063, '1.25.40.510-FF-000013', NULL, 'Uncharacterized protein', 80, NULL, NULL, 133063),
(133064, '3.90.190.10-FF-000555', NULL, 'Uncharacterized protein', 104, NULL, NULL, 133064),
(133065, '3.60.110.10-FF-000035', NULL, 'Glutamine-dependent NAD(+) synthetase', 251, NULL, NULL, 133065),
(133066, '3.40.1180.10-FF-000037', NULL, 'Uncharacterized protein', 138, NULL, NULL, 133066),
(133067, '1.10.8.870-FF-000014', NULL, 'Glycerol-3-phosphate dehydrogenase', 70, NULL, NULL, 133067),
(133068, '3.50.50.60-FF-000955', NULL, 'FAD-binding oxidoreductase', 203, NULL, NULL, 133068),
(133069, '2.10.220.10-FF-000120', NULL, 'Proprotein convertase subtilisin/kexin type 5', 87, NULL, NULL, 133069),
(133070, '3.30.450.40-FF-000300', NULL, 'Uncharacterized protein', 178, NULL, NULL, 133070),
(133071, '3.30.930.10-FF-000334', NULL, 'Seryl tRNA synthetase', 119, NULL, NULL, 133071);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(133072, '2.60.40.2840-FF-000013', NULL, 'Phosphatidylethanolamine N-methyltransferase', 112, NULL, NULL, 133072),
(133073, '3.30.70.20-FF-000001', NULL, 'Photosystem I iron-sulfur center', 81, NULL, NULL, 133073),
(133074, '3.40.50.300-FF-005591', NULL, 'Uncharacterized protein', 114, NULL, NULL, 133074),
(133075, '1.20.5.170-FF-000151', NULL, 'Putative Cyclic AMP-dependent transcription factor ATF-3', 68, NULL, NULL, 133075),
(133076, '1.20.120.1630-FF-000038', NULL, 'Uncharacterized protein', 226, NULL, NULL, 133076),
(133077, '1.10.10.10-FF-002001', NULL, 'Uncharacterized protein', 156, NULL, NULL, 133077),
(133078, '2.40.100.10-FF-000121', NULL, 'Peptidyl-prolyl cis-trans isomerase-like 3', 161, NULL, NULL, 133078),
(133079, '3.40.50.2000-FF-001092', NULL, 'UDP-glycosyltransferase 73D1', 74, NULL, NULL, 133079),
(133080, '3.40.50.720-FF-001208', NULL, 'Short chain dehydrogenase/reductase family protein', 250, NULL, NULL, 133080),
(133081, '3.30.40.10-FF-002346', NULL, 'Uncharacterized protein', 135, NULL, NULL, 133081),
(133082, '3.30.460.90-FF-000001', NULL, 'protein mab-21-like 2', 167, NULL, NULL, 133082),
(133083, '3.40.1380.20-FF-000022', NULL, 'Pyruvate kinase PyKII', 154, NULL, NULL, 133083),
(133084, '3.30.800.10-FF-000004', NULL, '1-phosphatidylinositol 3-phosphate 5-kinase isoform X1', 170, NULL, NULL, 133084),
(133085, '1.10.150.50-FF-000219', NULL, 'Uncharacterized protein', 69, NULL, NULL, 133085),
(133086, '1.10.540.10-FF-000131', NULL, 'Uncharacterized protein', 107, NULL, NULL, 133086),
(133087, '3.80.10.10-FF-004219', NULL, 'Predicted protein', 84, NULL, NULL, 133087),
(133088, '2.60.40.10-FF-005461', NULL, NULL, 105, NULL, NULL, 133088),
(133089, '1.10.8.60-FF-000536', NULL, 'ATP-dependent protease ClpE', 103, NULL, NULL, 133089),
(133090, '3.30.2320.30-FF-000001', NULL, 'V-type proton atpase subunit e 1', 134, NULL, NULL, 133090),
(133091, '1.10.1520.10-FF-000090', NULL, 'Predicted protein', 159, NULL, NULL, 133091),
(133092, '3.40.50.2300-FF-000569', NULL, 'Histidine kinase', 122, NULL, NULL, 133092),
(133093, '3.30.70.330-FF-002863', NULL, NULL, 77, NULL, NULL, 133093),
(133094, '1.10.10.650-FF-000019', NULL, 'SUPT6H,-like protein to suppressor of ty 6', 163, NULL, NULL, 133094),
(133095, '3.90.20.20-FF-000018', NULL, 'GrpE protein homolog', 129, NULL, NULL, 133095),
(133096, '2.60.120.830-FF-000006', NULL, 'Uncharacterized protein, isoform A', 157, NULL, NULL, 133096),
(133097, '3.30.70.260-FF-000138', NULL, 'Prephenate dehydratase, putative', 86, NULL, NULL, 133097),
(133098, '2.60.40.10-FF-003662', NULL, NULL, 102, NULL, NULL, 133098),
(133099, '3.40.720.10-FF-000243', NULL, 'Predicted protein', 213, NULL, NULL, 133099),
(133100, '1.20.1070.10-FF-000176', NULL, 'N-arachidonyl glycine receptor', 302, NULL, NULL, 133100),
(133101, '1.20.1250.40-FF-000007', NULL, 'DNA-directed RNA polymerase II subunit RPB4', 129, NULL, NULL, 133101),
(133102, '1.10.2000.10-FF-000045', NULL, NULL, 126, NULL, NULL, 133102),
(133103, '3.30.160.60-FF-002004', NULL, 'Zinc finger protein 473', 32, NULL, NULL, 133103),
(133104, '3.20.20.10-FF-000024', NULL, 'Pyridoxal phosphate homeostasis protein', 222, NULL, NULL, 133104),
(133105, '3.30.40.10-FF-001244', NULL, 'Binding protein', 87, NULL, NULL, 133105),
(133106, '2.60.220.50-FF-000188', NULL, 'Uncharacterized protein', 199, NULL, NULL, 133106),
(133107, '2.60.120.820-FF-000003', NULL, 'E3 ubiquitin-protein ligase MYCBP2 isoform X2', 170, NULL, NULL, 133107),
(133108, '1.10.3370.10-FF-000055', NULL, 'Uncharacterized protein', 215, NULL, NULL, 133108),
(133109, '2.60.110.10-FF-000016', NULL, 'Os09g0498300 protein', 226, NULL, NULL, 133109),
(133110, '2.40.128.180-FF-000017', NULL, NULL, 32, NULL, NULL, 133110),
(133111, '1.25.40.70-FF-000060', NULL, 'Phosphatidylinositol 4-kinase stt4', 219, NULL, NULL, 133111),
(133112, '2.10.25.10-FF-000830', NULL, 'Protein eyes shut homolog', 39, NULL, NULL, 133112),
(133113, '3.30.160.60-FF-003286', NULL, 'Paternally-expressed gene 3 protein', 63, NULL, NULL, 133113),
(133114, '1.10.287.70-FF-000582', NULL, 'Uncharacterized protein', 142, NULL, NULL, 133114);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(133115, '1.10.472.10-FF-000686', NULL, 'Predicted protein', 111, NULL, NULL, 133115),
(133116, '2.130.10.10-FF-003505', NULL, 'AGAP000686-PA', 242, NULL, NULL, 133116),
(133117, '3.30.2230.10-FF-000016', NULL, 'Uncharacterized protein', 105, NULL, NULL, 133117),
(133118, '3.10.105.10-FF-000051', NULL, 'ABC transporter substrate-binding protein', 213, NULL, NULL, 133118),
(133119, '3.40.20.10-FF-000085', NULL, 'Uncharacterized protein', 129, NULL, NULL, 133119),
(133120, '3.30.710.10-FF-000486', NULL, 'Uncharacterized protein', 83, NULL, NULL, 133120),
(133121, '1.25.10.10-FF-003255', NULL, 'Protein CELLULOSE SYNTHASE INTERACTIVE 3', 219, NULL, NULL, 133121),
(133122, '2.30.29.30-FF-000574', NULL, 'Rho1 guanine nucleotide exchange factor TUS1', 138, NULL, NULL, 133122),
(133123, '1.20.120.1080-FF-000137', NULL, 'Predicted protein', 145, NULL, NULL, 133123),
(133124, '3.40.50.720-FF-000175', NULL, 'UDP-glucose 4-epimerase Gal10', 234, NULL, NULL, 133124),
(133125, '2.60.40.10-FF-000301', NULL, 'Sidekick cell adhesion molecule 2', 100, NULL, NULL, 133125),
(133126, '1.10.490.160-FF-000006', NULL, 'Protein CBR-LIPL-6', 166, NULL, NULL, 133126),
(133127, '3.80.10.10-FF-002954', NULL, 'Disease resistance protein RPP13', 326, NULL, NULL, 133127),
(133128, '1.25.40.10-FF-001519', NULL, 'Motility protein FimV', 80, NULL, NULL, 133128),
(133129, '1.20.1160.20-FF-000023', NULL, 'Regulator of telomere elongation helicase 1 homolog', 71, NULL, NULL, 133129),
(133130, '2.10.25.10-FF-001010', NULL, 'Nimrod C3', 59, NULL, NULL, 133130),
(133131, '3.40.50.300-FF-002600', NULL, 'Predicted protein', 161, NULL, NULL, 133131),
(133132, '1.10.10.10-FF-001484', NULL, 'Selenocysteine-specific translation elongation factor SelB', 63, NULL, NULL, 133132),
(133133, '1.10.10.1100-FF-000003', NULL, 'Glycerol-3-phosphate dehydrogenase', 73, NULL, NULL, 133133),
(133134, '2.60.40.1090-FF-000016', NULL, 'Long polar fimbrial protein LpfE', 146, NULL, NULL, 133134),
(133135, '1.10.10.10-FF-001821', NULL, 'Uncharacterized protein', 111, NULL, NULL, 133135),
(133136, '1.25.40.10-FF-005218', NULL, 'Uncharacterized protein', 195, NULL, NULL, 133136),
(133137, '1.20.1250.20-FF-000923', NULL, 'Biotin transporter', 201, NULL, NULL, 133137),
(133138, '1.20.1690.10-FF-000003', NULL, 'V-type proton ATPase subunit', 115, NULL, NULL, 133138),
(133139, '2.60.40.1080-FF-000013', NULL, 'Kappa-carrageenase', 85, NULL, NULL, 133139),
(133140, '2.130.10.10-FF-003831', NULL, 'Protein HIR', 299, NULL, NULL, 133140),
(133141, '2.10.25.10-FF-000184', NULL, 'nephronectin isoform X2', 29, NULL, NULL, 133141),
(133142, '1.10.10.10-FF-000202', NULL, 'RNA polymerase sigma factor', 75, NULL, NULL, 133142),
(133143, '3.30.70.330-FF-003043', NULL, NULL, 122, NULL, NULL, 133143),
(133144, '3.40.50.1820-FF-000644', NULL, 'Acyl-protein thioesterase 1', 232, NULL, NULL, 133144),
(133145, '3.20.20.20-FF-000027', NULL, 'Dihydropteroate synthase', 278, NULL, NULL, 133145),
(133146, '3.60.21.10-FF-000092', NULL, 'Sphingomyelin phosphodiesterase', 180, NULL, NULL, 133146),
(133147, '3.40.50.11350-FF-000012', NULL, 'Galactoside 2-alpha-L-fucosyltransferase', 173, NULL, NULL, 133147),
(133148, '2.60.120.620-FF-000033', NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', 269, NULL, NULL, 133148),
(133149, '1.25.40.10-FF-003419', NULL, 'Pentatricopeptide repeat-containing protein DOT4, chloroplastic', 112, NULL, NULL, 133149),
(133150, '2.60.120.290-FF-000243', NULL, 'Corticotropin-releasing factor-binding protein-like Protein', 125, NULL, NULL, 133150),
(133151, '1.25.40.10-FF-000778', NULL, 'Protein SGT1 homolog', 128, NULL, NULL, 133151),
(133152, '1.10.20.10-FF-000130', NULL, 'Nuclear transcription factor Y subunit B-4', 132, NULL, NULL, 133152),
(133153, '3.40.50.200-FF-000108', NULL, 'Clan SB, family S8, subtilisin-like serine peptidase', 231, NULL, NULL, 133153),
(133154, '3.50.50.60-FF-001135', NULL, 'Uncharacterized protein', 301, NULL, NULL, 133154),
(133155, '3.40.30.10-FF-000349', NULL, 'Glutathione peroxidase', 177, NULL, NULL, 133155);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(133156, '3.40.1190.10-FF-000009', NULL, 'Folylpolyglutamate synthase', 299, NULL, NULL, 133156),
(133157, '3.30.160.60-FF-001487', NULL, 'zinc finger protein 527 isoform X1', 26, NULL, NULL, 133157),
(133158, '3.30.40.10-FF-000738', NULL, 'Lysine-specific demethylase rbr-2 isoform A', 46, NULL, NULL, 133158),
(133159, '3.40.50.2000-FF-000956', NULL, 'Uncharacterized protein', 105, NULL, NULL, 133159),
(133160, '3.90.550.10-FF-000038', NULL, 'protein O-linked-mannose beta-1,2-N-acetylglucosaminyltransferase 1 isoform X1', 216, NULL, NULL, 133160),
(133161, '1.20.1250.20-FF-001103', NULL, 'Os07g0190650 protein', 532, NULL, NULL, 133161),
(133162, '3.20.20.220-FF-000017', NULL, 'Proline dehydrogenase', 371, NULL, NULL, 133162),
(133163, '1.10.510.10-FF-003176', NULL, NULL, 162, NULL, NULL, 133163),
(133164, '3.40.50.2300-FF-001075', NULL, NULL, 146, NULL, NULL, 133164),
(133165, '3.30.160.60-FF-000059', NULL, 'U1 small nuclear ribonucleoprotein C', 61, NULL, NULL, 133165),
(133166, '1.10.287.10-FF-000036', NULL, 'Fcp-1', 46, NULL, NULL, 133166),
(133167, '2.10.25.10-FF-000493', NULL, 'von Willebrand factor', 55, NULL, NULL, 133167),
(133168, '1.20.1540.10-FF-000049', NULL, 'Rhomboid family intramembrane serine protease', 204, NULL, NULL, 133168),
(133169, '3.30.160.60-FF-005186', NULL, NULL, 30, NULL, NULL, 133169),
(133170, '2.130.10.10-FF-004011', NULL, 'Uncharacterized protein', 225, NULL, NULL, 133170),
(133171, '3.30.200.20-FF-001232', NULL, 'Uncharacterized protein', 149, NULL, NULL, 133171),
(133172, '1.10.12.10-FF-000038', NULL, 'Putative enoyl-CoA hydratase', 58, NULL, NULL, 133172),
(133173, '1.25.10.10-FF-001456', NULL, 'Uncharacterized protein', 216, NULL, NULL, 133173),
(133174, '1.10.287.110-FF-000330', NULL, 'Uncharacterized protein', 86, NULL, NULL, 133174),
(133175, '2.60.120.10-FF-000606', NULL, 'Mannose-6-phosphate isomerase', 56, NULL, NULL, 133175),
(133176, '3.20.20.80-FF-000573', NULL, 'Predicted protein', 129, NULL, NULL, 133176),
(133177, '2.60.40.150-FF-000107', NULL, 'Synaptotagmin-like 5, isoform CRA_a', 189, NULL, NULL, 133177),
(133178, '3.80.10.10-FF-004545', NULL, 'Uncharacterized protein', 468, NULL, NULL, 133178),
(133179, '3.30.160.60-FF-003948', NULL, NULL, 29, NULL, NULL, 133179),
(133180, '1.10.10.10-FF-001467', NULL, 'Transcriptional regulator, AsnC family', 63, NULL, NULL, 133180),
(133181, '2.170.270.10-FF-000220', NULL, 'Uncharacterized protein', 114, NULL, NULL, 133181),
(133182, '3.20.20.70-FF-000570', NULL, 'Inosine-5''-monophosphate dehydrogenase', 471, NULL, NULL, 133182),
(133183, '2.60.120.10-FF-000270', NULL, 'Transcriptional regulator, HTH_3 family', 95, NULL, NULL, 133183),
(133184, '3.60.20.40-FF-000025', NULL, 'Gamma-glutamyltransferase', 194, NULL, NULL, 133184),
(133185, '1.50.40.10-FF-000601', NULL, 'Aspartate/glutamate carrier protein, putative', 103, NULL, NULL, 133185),
(133186, '3.40.630.20-FF-000008', NULL, 'Pyroglutamyl-peptidase 1', 199, NULL, NULL, 133186),
(133187, '3.50.50.60-FF-000629', NULL, 'Dihydrolipoyl dehydrogenase', 120, NULL, NULL, 133187),
(133188, '3.40.630.10-FF-000005', NULL, 'Succinyl-diaminopimelate desuccinylase', 242, NULL, NULL, 133188),
(133189, '1.10.1200.10-FF-000026', NULL, 'Nonribosomal peptide synthase Pes1', 74, NULL, NULL, 133189),
(133190, '1.10.287.70-FF-000138', NULL, 'Two-pore potassium channel 2-like', 98, NULL, NULL, 133190),
(133191, '3.60.20.10-FF-000258', NULL, NULL, 51, NULL, NULL, 133191),
(133192, '3.50.30.30-FF-000074', NULL, 'Uncharacterized protein', 180, NULL, NULL, 133192),
(133193, '1.10.287.110-FF-000004', NULL, 'DnaJ (Hsp40) homolog, subfamily B, member 14', 113, NULL, NULL, 133193),
(133194, '3.40.30.10-FF-000142', NULL, 'Elongation factor 1 gamma', 76, NULL, NULL, 133194),
(133195, '3.40.50.300-FF-000122', NULL, 'Cytoplasmic dynein 1 heavy chain', 172, NULL, NULL, 133195),
(133196, '3.40.50.300-FF-007389', NULL, 'Si:ch211-207c7.2', 106, NULL, NULL, 133196),
(133197, '1.20.1270.10-FF-000039', NULL, 'Heat shock 70 kDa protein, putative', 73, NULL, NULL, 133197),
(133198, '1.25.40.20-FF-000522', NULL, 'Ankyrin repeat domain-containing protein 16', 84, NULL, NULL, 133198);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(133199, '1.10.287.70-FF-000447', NULL, 'Uncharacterized protein', 33, NULL, NULL, 133199),
(133200, '3.40.50.1100-FF-000214', NULL, 'Threonine synthase like 2', 82, NULL, NULL, 133200),
(133201, '1.10.10.10-FF-000978', NULL, 'Transcriptional regulatory protein', 78, NULL, NULL, 133201),
(133202, '1.25.70.10-FF-000021', NULL, 'PTAC15', 211, NULL, NULL, 133202),
(133203, '3.30.499.10-FF-000044', NULL, NULL, 235, NULL, NULL, 133203),
(133204, '1.10.510.10-FF-000303', NULL, 'Non-specific serine/threonine protein kinase', 182, NULL, NULL, 133204),
(133205, '2.40.70.10-FF-000101', NULL, 'Uncharacterized protein', 132, NULL, NULL, 133205),
(133206, '3.80.10.10-FF-002645', NULL, 'Receptor like protein 39', 58, NULL, NULL, 133206),
(133207, '3.20.20.190-FF-000019', NULL, 'Phosphoinositide phospholipase C', 158, NULL, NULL, 133207),
(133208, '1.20.58.100-FF-000017', NULL, NULL, 129, NULL, NULL, 133208),
(133209, '1.10.510.10-FF-001747', NULL, 'Uncharacterized protein', 275, NULL, NULL, 133209),
(133210, '2.60.120.230-FF-000023', NULL, NULL, 45, NULL, NULL, 133210),
(133211, '3.20.20.70-FF-000261', NULL, 'L-lactate dehydrogenase (Cytochrome)', 374, NULL, NULL, 133211),
(133212, '3.40.140.100-FF-000008', NULL, 'AuTophaGy (Yeast Atg homolog)', 122, NULL, NULL, 133212),
(133213, '1.20.1110.10-FF-000101', NULL, 'Calcium-transporting ATPase', 257, NULL, NULL, 133213),
(133214, '1.20.5.110-FF-000138', NULL, 'Structural maintenance of chromosomes', 73, NULL, NULL, 133214),
(133215, '3.30.1600.10-FF-000005', NULL, 'NAD-dependent protein deacylase sirtuin-5, mitochondrial', 115, NULL, NULL, 133215),
(133216, '2.60.120.1000-FF-000006', NULL, 'collagen alpha-1(XXVII) chain isoform X1', 122, NULL, NULL, 133216),
(133217, '3.50.50.60-FF-001118', NULL, 'Uncharacterized protein', 147, NULL, NULL, 133217),
(133218, '3.40.50.1820-FF-000189', NULL, 'Esterase yjfP', 248, NULL, NULL, 133218),
(133219, '1.10.10.750-FF-000050', NULL, 'Uncharacterized protein', 58, NULL, NULL, 133219),
(133220, '1.10.555.10-FF-000047', NULL, 'rho GTPase-activating protein 190 isoform X3', 207, NULL, NULL, 133220),
(133221, '2.10.25.10-FF-000476', NULL, 'nephronectin isoform X1', 41, NULL, NULL, 133221),
(133222, '1.10.418.60-FF-000013', NULL, 'Predicted protein', 167, NULL, NULL, 133222),
(133223, '3.40.50.1360-FF-000017', NULL, '6-phosphogluconolactonase-like protein', 244, NULL, NULL, 133223),
(133224, '3.20.20.80-FF-000264', NULL, 'Uncharacterized protein', 277, NULL, NULL, 133224),
(133225, '1.25.40.10-FF-003212', NULL, 'TPR repeat, putative', 77, NULL, NULL, 133225),
(133226, '1.10.287.100-FF-000001', NULL, 'Transcription initiation factor IIA subunit', 54, NULL, NULL, 133226),
(133227, '3.30.450.20-FF-000098', NULL, 'Sensor histidine kinase ResE', 108, NULL, NULL, 133227),
(133228, '1.25.40.10-FF-000210', NULL, 'Hsp70/Hsp90 organizing protein', 121, NULL, NULL, 133228),
(133229, '3.40.1170.60-FF-000001', NULL, 'DNA polymerase IV', 53, NULL, NULL, 133229),
(133230, '1.25.40.20-FF-000213', NULL, 'APSES transcription factor (MbpA)', 241, NULL, NULL, 133230),
(133231, '3.30.930.10-FF-000008', NULL, 'Glycine--tRNA ligase', 281, NULL, NULL, 133231),
(133232, '3.30.160.60-FF-000430', NULL, 'zinc finger protein 596 isoform X1', 28, NULL, NULL, 133232),
(133233, '1.10.8.60-FF-000227', NULL, 'ATPase, putative', 52, NULL, NULL, 133233),
(133234, '1.10.268.10-FF-000014', NULL, 'DNA topoisomerase 2', 194, NULL, NULL, 133234),
(133235, '3.90.830.10-FF-000021', NULL, 'Vacuolar protein-sorting-associated protein 33 homolog', 108, NULL, NULL, 133235),
(133236, '1.20.1250.20-FF-002059', NULL, 'Os03g0823100 protein', 300, NULL, NULL, 133236),
(133237, '1.10.287.10-FF-000053', NULL, 'Uncharacterized protein', 45, NULL, NULL, 133237),
(133238, '2.60.120.200-FF-000508', NULL, 'Agrin', 180, NULL, NULL, 133238),
(133239, '1.25.40.10-FF-005292', NULL, 'Predicted protein', 138, NULL, NULL, 133239),
(133240, '2.10.90.10-FF-000143', NULL, 'transforming growth factor beta superfamily signaling ligand isoform X1', 109, NULL, NULL, 133240),
(133241, '3.10.310.20-FF-000002', NULL, 'Prune homolog 2 with BCH domain', 139, NULL, NULL, 133241);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(133242, '1.25.40.10-FF-001930', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 260, NULL, NULL, 133242),
(133243, '1.20.1300.20-FF-000012', NULL, 'Ubiquitin thioesterase', 145, NULL, NULL, 133243),
(133244, '3.30.30.30-FF-000013', NULL, 'Heat shock 70 kDa protein 16', 75, NULL, NULL, 133244),
(133245, '2.60.40.3500-FF-000003', NULL, 'N-acetylmuramoyl-L-alanine amidase', 115, NULL, NULL, 133245),
(133246, '1.20.58.730-FF-000003', NULL, 'Protein zwilch homolog', 108, NULL, NULL, 133246),
(133247, '3.40.50.720-FF-000467', NULL, 'Steroid dehydrogenase 4', 241, NULL, NULL, 133247),
(133248, '3.40.50.2000-FF-000069', NULL, 'Alpha-(1-6)-phosphatidylinositol monomannoside mannosyltransferase', 192, NULL, NULL, 133248),
(133249, '1.10.10.10-FF-001158', NULL, 'Transcriptional regulator, Crp/Fnr family', 60, NULL, NULL, 133249),
(133250, '3.30.160.60-FF-003741', NULL, NULL, 28, NULL, NULL, 133250),
(133251, '3.40.50.1000-FF-000302', NULL, 'Na+/K+ ATPase alpha subunit isoform 1', 48, NULL, NULL, 133251),
(133252, '3.30.412.10-FF-000001', NULL, 'Aerolysin', 170, NULL, NULL, 133252),
(133253, '1.25.40.10-FF-003392', NULL, 'Pentatricopeptide repeat-containing protein At2g36980, mitochondrial', 139, NULL, NULL, 133253),
(133254, '1.10.8.770-FF-000001', NULL, 'Methylenetetrahydrofolate dehydrogenase (NADP+ dependent) 1 like', 65, NULL, NULL, 133254),
(133255, '2.60.40.10-FF-001745', NULL, 'Platelet and endothelial cell adhesion molecule 1', 99, NULL, NULL, 133255),
(133256, '3.10.20.310-FF-000002', NULL, 'Outer membrane protein assembly factor BamA', 90, NULL, NULL, 133256),
(133257, '1.20.120.50-FF-000002', NULL, 'Methyl-accepting chemotaxis sensory transducer', 135, NULL, NULL, 133257),
(133258, '2.60.120.260-FF-000493', NULL, 'Uncharacterized protein', 104, NULL, NULL, 133258),
(133259, '1.20.58.740-FF-000006', NULL, 'Blast:Dedicator of cytokinesis protein 3', 128, NULL, NULL, 133259),
(133260, '3.30.230.10-FF-000197', NULL, 'Mlh1-like protein', 114, NULL, NULL, 133260),
(133261, '3.30.200.20-FF-000698', NULL, 'Myoblast growth factor receptor egl-15', 124, NULL, NULL, 133261),
(133262, '1.25.40.180-FF-000195', NULL, 'YALI0D16313p', 257, NULL, NULL, 133262),
(133263, '3.40.50.12780-FF-000194', NULL, 'Uncharacterized protein', 106, NULL, NULL, 133263),
(133264, '3.30.1520.10-FF-000089', NULL, 'neutrophil cytosolic factor 1 isoform X1', 142, NULL, NULL, 133264),
(133265, '3.40.30.10-FF-000703', NULL, 'Thioredoxin domain-containing protein 5', 122, NULL, NULL, 133265),
(133266, '3.40.50.2020-FF-000142', NULL, 'Uncharacterized protein', 204, NULL, NULL, 133266),
(133267, '3.30.70.330-FF-002880', NULL, NULL, 132, NULL, NULL, 133267),
(133268, '3.40.50.300-FF-004045', NULL, 'Dicer-like protein', 99, NULL, NULL, 133268),
(133269, '1.25.40.10-FF-003083', NULL, 'AaceriAFR663Wp', 177, NULL, NULL, 133269),
(133270, '1.10.150.250-FF-000002', NULL, 'Succinate dehydrogenase assembly factor 2, mitochondrial', 90, NULL, NULL, 133270),
(133271, '2.40.50.140-FF-000488', NULL, 'Predicted protein', 113, NULL, NULL, 133271),
(133272, '1.20.120.1210-FF-000002', NULL, 'T3SS2 effector VopL nucleation of actin polymerization', 66, NULL, NULL, 133272),
(133273, '2.170.16.10-FF-000009', NULL, 'Pre-mRNA splicing factor (Prp8)', 92, NULL, NULL, 133273),
(133274, '1.10.2000.10-FF-000062', NULL, NULL, 131, NULL, NULL, 133274),
(133275, '3.30.160.60-FF-002021', NULL, 'Transcription factor', 31, NULL, NULL, 133275),
(133276, '3.80.10.10-FF-002084', NULL, 'Uncharacterized protein', 287, NULL, NULL, 133276),
(133277, '3.40.50.300-FF-001892', NULL, 'Putative dynein heavy chain', 235, NULL, NULL, 133277),
(133278, '3.30.160.60-FF-002330', NULL, 'PR domain zinc finger protein 15', 59, NULL, NULL, 133278),
(133279, '3.80.10.10-FF-002393', NULL, 'YALI0C14740p', 96, NULL, NULL, 133279),
(133280, '2.10.60.10-FF-000080', NULL, 'Serine/threonine-protein kinase receptor', 110, NULL, NULL, 133280),
(133281, '4.10.410.10-FF-000110', NULL, 'Kunitz-type serine protease inhibitor BmKTT-1', 58, NULL, NULL, 133281),
(133282, '3.40.50.10140-FF-000076', NULL, 'TIR-domain containing adaptor inducing INF-beta', 64, NULL, NULL, 133282);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(133283, '3.40.50.150-FF-001695', NULL, NULL, 85, NULL, NULL, 133283),
(133284, '1.25.40.10-FF-002110', NULL, 'Pentatricopeptide repeat-containing protein At2g15820, chloroplastic', 166, NULL, NULL, 133284),
(133285, '3.10.170.20-FF-000013', NULL, NULL, 82, NULL, NULL, 133285),
(133286, '2.40.50.740-FF-000004', NULL, '40S ribosomal protein S4', 51, NULL, NULL, 133286),
(133287, '2.60.120.200-FF-000817', NULL, 'Galectin', 80, NULL, NULL, 133287),
(133288, '2.60.40.3510-FF-000006', NULL, 'Delta-like protein', 172, NULL, NULL, 133288),
(133289, '1.20.5.110-FF-000240', NULL, 'Uncharacterized protein', 62, NULL, NULL, 133289),
(133290, '3.40.50.200-FF-000081', NULL, 'Extracellular serine protease', 302, NULL, NULL, 133290),
(133291, '3.40.50.620-FF-000807', NULL, 'Predicted protein', 50, NULL, NULL, 133291),
(133292, '1.25.40.10-FF-001621', NULL, 'Trafficking protein particle complex 12', 107, NULL, NULL, 133292),
(133293, '3.30.1460.20-FF-000019', NULL, 'Arp2/3 complex 34 kDa subunit', 102, NULL, NULL, 133293),
(133294, '1.20.1560.10-FF-000904', NULL, 'Os05g0548300 protein', 179, NULL, NULL, 133294),
(133295, '1.20.120.1220-FF-000005', NULL, 'Prepilin peptidase', 146, NULL, NULL, 133295),
(133296, '3.40.50.10380-FF-000035', NULL, 'Malic enzyme', 255, NULL, NULL, 133296),
(133297, '3.30.160.60-FF-001841', NULL, 'Zinc finger protein 646', 78, NULL, NULL, 133297),
(133298, '1.10.533.10-FF-000002', NULL, 'Ankyrin-3 isoform 2', 99, NULL, NULL, 133298),
(133299, '1.25.40.20-FF-001624', NULL, 'Uncharacterized protein', 98, NULL, NULL, 133299),
(133300, '2.30.42.10-FF-000397', NULL, NULL, 107, NULL, NULL, 133300),
(133301, '3.30.1490.220-FF-000005', NULL, 'Inositol-tetrakisphosphate 1-kinase', 103, NULL, NULL, 133301),
(133302, '1.10.1060.10-FF-000037', NULL, NULL, 143, NULL, NULL, 133302),
(133303, '2.30.110.10-FF-000023', NULL, 'Putative flavoprotein oxidoreductase', 164, NULL, NULL, 133303),
(133304, '3.30.460.10-FF-000152', NULL, 'Uncharacterized protein', 108, NULL, NULL, 133304),
(133305, '2.130.10.10-FF-005646', NULL, 'Uncharacterized protein', 171, NULL, NULL, 133305),
(133306, '3.40.50.300-FF-005473', NULL, 'Uncharacterized protein', 219, NULL, NULL, 133306),
(133307, '3.80.10.10-FF-002971', NULL, 'Uncharacterized protein', 112, NULL, NULL, 133307),
(133308, '2.60.40.1090-FF-000033', NULL, 'Fimbrial-like adhesin protein', 172, NULL, NULL, 133308),
(133309, '3.40.50.620-FF-000572', NULL, 'Os12g0181200 protein', 152, NULL, NULL, 133309),
(133310, '2.10.10.10-FF-000026', NULL, 'Matrix metallopeptidase 9', 46, NULL, NULL, 133310),
(133311, '1.10.287.110-FF-000212', NULL, 'Chaperone protein dnaJ 13', 86, NULL, NULL, 133311),
(133312, '1.20.140.10-FF-000031', NULL, 'Acyl-CoA dehydrogenase FadE1', 155, NULL, NULL, 133312),
(133313, '2.170.270.10-FF-000012', NULL, 'PR domain zinc finger protein 8', 123, NULL, NULL, 133313),
(133314, '2.60.40.640-FF-000030', NULL, 'Intracellular protein transport protein (Sat1)', 108, NULL, NULL, 133314),
(133315, '1.20.1250.20-FF-000794', NULL, 'Allantoate transporter', 197, NULL, NULL, 133315),
(133316, '1.20.1250.20-FF-001412', NULL, 'Predicted arabinose efflux permease, MFS family', 183, NULL, NULL, 133316),
(133317, '2.40.30.10-FF-000301', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 92, NULL, NULL, 133317),
(133318, '3.30.70.990-FF-000003', NULL, 'UPF0234 protein MIP_06774', 86, NULL, NULL, 133318),
(133319, '3.30.390.70-FF-000001', NULL, 'Type III secretion system effector SifA', 111, NULL, NULL, 133319),
(133320, '1.25.40.20-FF-001169', NULL, 'Ankyrin repeat family protein', 64, NULL, NULL, 133320),
(133321, '2.80.10.50-FF-000170', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 137, NULL, NULL, 133321),
(133322, '3.40.850.10-FF-000264', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 344, NULL, NULL, 133322),
(133323, '2.40.10.10-FF-000300', NULL, NULL, 94, NULL, NULL, 133323),
(133324, '1.25.40.20-FF-001596', NULL, 'Poly [ADP-ribose] polymerase', 114, NULL, NULL, 133324),
(133325, '2.10.50.10-FF-000034', NULL, 'TNF receptor superfamily member 25', 87, NULL, NULL, 133325);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(133326, '3.30.390.30-FF-000028', NULL, 'Rubredoxin-NAD(+) reductase', 69, NULL, NULL, 133326),
(133327, '1.10.10.350-FF-000019', NULL, 'Glutamate--tRNA ligase 1', 102, NULL, NULL, 133327),
(133328, '1.20.1090.10-FF-000059', NULL, '3-dehydroquinate synthase', 178, NULL, NULL, 133328),
(133329, '2.10.60.10-FF-000063', NULL, 'Receptor protein serine/threonine kinase', 54, NULL, NULL, 133329),
(133330, '3.10.50.40-FF-000035', NULL, 'Peptidylprolyl isomerase', 81, NULL, NULL, 133330),
(133331, '1.25.40.180-FF-000341', NULL, NULL, 177, NULL, NULL, 133331),
(133332, '3.40.1110.10-FF-000297', NULL, NULL, 12, NULL, NULL, 133332),
(133333, '3.40.50.2020-FF-000125', NULL, 'Hypoxanthine phosphoribosyltransferase', 188, NULL, NULL, 133333),
(133334, '2.130.10.10-FF-002420', NULL, 'Guanine nucleotide-binding protein subunit beta-like protein 1-like protein', 80, NULL, NULL, 133334),
(133335, '2.60.40.1230-FF-000002', NULL, 'AP-1 complex subunit gamma', 121, NULL, NULL, 133335),
(133336, '1.10.150.110-FF-000011', NULL, 'Hydrolase', 80, NULL, NULL, 133336),
(133337, '1.10.1050.10-FF-000008', NULL, '30S ribosomal protein S4', 107, NULL, NULL, 133337),
(133338, '1.10.20.10-FF-000012', NULL, 'Histone H4', 102, NULL, NULL, 133338),
(133339, '3.40.33.10-FF-000165', NULL, 'Uncharacterized protein', 113, NULL, NULL, 133339),
(133340, '3.30.420.510-FF-000012', NULL, 'Pantothenate kinase subunit, putative', 161, NULL, NULL, 133340),
(133341, '3.10.280.10-FF-000030', NULL, 'Complement C1q binding protein', 58, NULL, NULL, 133341),
(133342, '3.60.10.10-FF-000432', NULL, 'Uncharacterized protein', 58, NULL, NULL, 133342),
(133343, '3.80.10.10-FF-000358', NULL, 'F-box/LRR-repeat protein 17 isoform X1', 237, NULL, NULL, 133343),
(133344, '3.10.620.30-FF-000006', NULL, 'Transglutaminase domain-containing protein', 193, NULL, NULL, 133344),
(133345, '4.10.400.10-FF-000036', NULL, 'Sortilin related receptor 1', 39, NULL, NULL, 133345),
(133346, '3.30.160.60-FF-001369', NULL, 'pH-response transcription factor pacC/RIM101', 30, NULL, NULL, 133346),
(133347, '2.30.29.30-FF-001254', NULL, 'Neurobeachin/beige protein, putative', 106, NULL, NULL, 133347),
(133348, '3.90.660.10-FF-000058', NULL, NULL, 93, NULL, NULL, 133348),
(133349, '3.30.200.20-FF-001439', NULL, 'Os04g0134501 protein', 92, NULL, NULL, 133349),
(133350, '1.10.287.10-FF-000019', NULL, 'Ataxin-3, putative', 40, NULL, NULL, 133350),
(133351, '3.40.50.1820-FF-000559', NULL, 'Hydrolase, alpha/beta fold family domain containing protein', 271, NULL, NULL, 133351),
(133352, '3.30.930.10-FF-000216', NULL, 'Phenylalanine--tRNA ligase beta subunit', 181, NULL, NULL, 133352),
(133353, '3.80.10.10-FF-000829', NULL, 'H0305E08.2 protein', 82, NULL, NULL, 133353),
(133354, '3.30.70.360-FF-000067', NULL, 'Predicted protein', 98, NULL, NULL, 133354),
(133355, '3.50.50.60-FF-000972', NULL, 'Uncharacterized protein', 28, NULL, NULL, 133355),
(133356, '2.60.120.290-FF-000125', NULL, 'AGAP005526-PA', 115, NULL, NULL, 133356),
(133357, '3.30.70.330-FF-000755', NULL, 'RNA-binding protein 8A', 106, NULL, NULL, 133357),
(133358, '1.25.10.10-FF-001765', NULL, 'YALI0E29909p', 948, NULL, NULL, 133358),
(133359, '3.30.2090.10-FF-000027', NULL, 'Acriflavine resistance protein B', 89, NULL, NULL, 133359),
(133360, '3.30.460.10-FF-000051', NULL, 'DNA2/NAM7 helicase family protein', 110, NULL, NULL, 133360),
(133361, '1.10.510.10-FF-004120', NULL, NULL, 104, NULL, NULL, 133361),
(133362, '2.60.120.200-FF-000626', NULL, 'MAM and LDL-receptor class A domain-containing protein 1', 132, NULL, NULL, 133362),
(133363, '2.10.50.10-FF-000135', NULL, 'TNF receptor superfamily member 10d', 39, NULL, NULL, 133363),
(133364, '3.40.50.300-FF-005618', NULL, 'Uncharacterized protein', 73, NULL, NULL, 133364),
(133365, '3.50.7.10-FF-000089', NULL, NULL, 114, NULL, NULL, 133365),
(133366, '2.30.39.10-FF-000035', NULL, 'Serine protease inhibitor (serpin) 16', 60, NULL, NULL, 133366),
(133367, '3.40.50.300-FF-005574', NULL, 'Uncharacterized protein', 345, NULL, NULL, 133367),
(133368, '3.50.20.20-FF-000008', NULL, 'Predicted protein', 82, NULL, NULL, 133368);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(133369, '1.10.287.70-FF-000790', NULL, 'Uncharacterized protein', 191, NULL, NULL, 133369),
(133370, '2.30.30.140-FF-000205', NULL, 'Lysine-specific demethylase 4C', 27, NULL, NULL, 133370),
(133371, '2.60.40.10-FF-003870', NULL, NULL, 81, NULL, NULL, 133371),
(133372, '1.10.238.160-FF-000004', NULL, NULL, 47, NULL, NULL, 133372),
(133373, '3.30.800.10-FF-000021', NULL, NULL, 138, NULL, NULL, 133373),
(133374, '3.10.129.10-FF-000078', NULL, 'Beta-hydroxyacyl-(Acyl-carrier-protein) dehydratase FabZ', 153, NULL, NULL, 133374),
(133375, '3.30.760.10-FF-000079', NULL, 'Eukaryotic initiation factor 4E family protein', 172, NULL, NULL, 133375),
(133376, '3.40.50.300-FF-005944', NULL, 'ATP-dependent helicase HrpB', 168, NULL, NULL, 133376),
(133377, '3.30.450.20-FF-000553', NULL, 'Sensor histidine kinase PilS, PAS domain-containing', 122, NULL, NULL, 133377),
(133378, '3.30.70.100-FF-000006', NULL, 'Antibiotic biosynthesis monooxygenase', 104, NULL, NULL, 133378),
(133379, '1.10.20.10-FF-000113', NULL, 'Transcription initiation factor TFIID subunit 13', 43, NULL, NULL, 133379),
(133380, '1.10.510.10-FF-003294', NULL, NULL, 89, NULL, NULL, 133380),
(133381, '3.30.70.330-FF-001109', NULL, 'UBP1-associated protein 2C isoform A', 141, NULL, NULL, 133381),
(133382, '3.40.50.2300-FF-001103', NULL, 'Extracellular calcium-sensing receptor', 292, NULL, NULL, 133382),
(133383, '2.60.40.10-FF-001936', NULL, 'KETtiN (Drosophila actin-binding) homolog', 97, NULL, NULL, 133383),
(133384, '2.30.30.40-FF-000400', NULL, 'Peripheral-type benzodiazepine receptor-associated protein 1', 68, NULL, NULL, 133384),
(133385, '1.10.10.10-FF-001512', NULL, 'non-structural maintenance of chromosomes element 1 homolog', 93, NULL, NULL, 133385),
(133386, '1.20.970.10-FF-000043', NULL, 'Thymidine phosphorylase', 70, NULL, NULL, 133386),
(133387, '1.20.1250.20-FF-000159', NULL, 'Solute carrier family 22 member 17', 450, NULL, NULL, 133387),
(133388, '3.40.50.1820-FF-001133', NULL, '2210023G05Rik protein', 161, NULL, NULL, 133388),
(133389, '3.20.20.70-FF-000244', NULL, 'tRNA-dihydrouridine(20) synthase [NAD(P)+]-like isoform X3', 134, NULL, NULL, 133389),
(133390, '2.120.10.90-FF-000016', NULL, 'DNA topoisomerase (ATP-hydrolyzing)', 261, NULL, NULL, 133390),
(133391, '1.10.287.130-FF-000218', NULL, 'Ethylene response sensor 1', 50, NULL, NULL, 133391),
(133392, '3.80.10.10-FF-002292', NULL, 'Uncharacterized protein', 218, NULL, NULL, 133392),
(133393, '3.30.40.10-FF-001227', NULL, 'Histone-lysine N-methyltransferase', 79, NULL, NULL, 133393),
(133394, '1.20.1270.60-FF-000341', NULL, 'Uncharacterized protein', 212, NULL, NULL, 133394),
(133395, '1.10.720.30-FF-000027', NULL, 'E3 SUMO-protein ligase SIZ1', 55, NULL, NULL, 133395),
(133396, '1.10.1520.10-FF-000073', NULL, 'Ribonuclease-III-like-domain-containing protein', 157, NULL, NULL, 133396),
(133397, '2.30.30.140-FF-000194', NULL, 'Uncharacterized protein', 84, NULL, NULL, 133397),
(133398, '3.40.605.10-FF-000037', NULL, 'NADP-dependent fatty aldehyde dehydrogenase', 251, NULL, NULL, 133398),
(133399, '1.10.510.10-FF-000112', NULL, 'Putative dual specificity tyrosine-phosphorylation-regulated kinase 2', 230, NULL, NULL, 133399),
(133400, '1.20.1250.20-FF-002076', NULL, 'Uncharacterized protein', 278, NULL, NULL, 133400),
(133401, '1.20.1250.20-FF-000838', NULL, 'Battenin', 289, NULL, NULL, 133401),
(133402, '1.20.5.110-FF-000256', NULL, 'YALI0E11825p', 103, NULL, NULL, 133402),
(133403, '3.30.65.10-FF-000014', NULL, 'DNA topoisomerase', 66, NULL, NULL, 133403),
(133404, '3.20.20.80-FF-000247', NULL, 'Expressed protein', 99, NULL, NULL, 133404),
(133405, '3.40.1690.10-FF-000003', NULL, 'Flagellar biosynthesis protein FlhB', 79, NULL, NULL, 133405),
(133406, '1.25.10.10-FF-001086', NULL, 'Uncharacterized protein, isoform A', 206, NULL, NULL, 133406),
(133407, '3.40.50.2000-FF-000277', NULL, 'Glucosyltransferase 3', 150, NULL, NULL, 133407),
(133408, '1.20.1600.10-FF-000054', NULL, 'Type I secretion outer membrane protein', 440, NULL, NULL, 133408),
(133409, '3.30.70.330-FF-001098', NULL, 'Nuclear cap-binding protein subunit 2', 86, NULL, NULL, 133409);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(133410, '2.60.40.3170-FF-000005', NULL, 'Related to Tripeptidyl-peptidase II', 121, NULL, NULL, 133410),
(133411, '1.10.510.10-FF-003546', NULL, NULL, 233, NULL, NULL, 133411),
(133412, '1.25.40.10-FF-005336', NULL, 'Uncharacterized protein', 71, NULL, NULL, 133412),
(133413, '3.30.390.10-FF-000022', NULL, 'Enolase 4', 150, NULL, NULL, 133413),
(133414, '1.20.1270.370-FF-000002', NULL, 'Lactoyl-CoA dehydratase subunit beta', 86, NULL, NULL, 133414),
(133415, '1.20.920.10-FF-000107', NULL, 'Transcription factor', 119, NULL, NULL, 133415),
(133416, '1.20.900.10-FF-000106', NULL, 'Uncharacterized protein', 185, NULL, NULL, 133416),
(133417, '3.30.420.10-FF-000458', NULL, NULL, 107, NULL, NULL, 133417),
(133418, '3.30.70.3400-FF-000002', NULL, 'Protein translocase subunit SecD', 76, NULL, NULL, 133418),
(133419, '3.30.190.20-FF-000027', NULL, 'Ribosomal protein L10a', 101, NULL, NULL, 133419),
(133420, '2.30.29.30-FF-000439', NULL, 'Protein kinase C', 127, NULL, NULL, 133420),
(133421, '3.40.50.10330-FF-000127', NULL, 'Uncharacterized protein', 58, NULL, NULL, 133421),
(133422, '2.40.160.120-FF-000002', NULL, 'Oxysterol-binding protein', 196, NULL, NULL, 133422),
(133423, '3.30.420.40-FF-000956', NULL, 'Actin-related protein 8', 38, NULL, NULL, 133423),
(133424, '1.10.1370.10-FF-000055', NULL, 'Uncharacterized protein', 221, NULL, NULL, 133424),
(133425, '2.10.70.10-FF-000243', NULL, 'Uncharacterized protein', 59, NULL, NULL, 133425),
(133426, '3.40.50.10090-FF-000055', NULL, 'Uncharacterized protein', 97, NULL, NULL, 133426),
(133427, '3.40.50.2300-FF-001530', NULL, NULL, 74, NULL, NULL, 133427),
(133428, '2.60.40.10-FF-001728', NULL, 'Plexin-A1', 71, NULL, NULL, 133428),
(133429, '3.40.50.800-FF-000064', NULL, 'Proline--tRNA ligase', 112, NULL, NULL, 133429),
(133430, '3.30.70.2050-FF-000002', NULL, 'Nitrous oxide reductase accessory protein', 60, NULL, NULL, 133430),
(133431, '3.90.228.10-FF-000065', NULL, 'Poly [ADP-ribose] polymerase', 101, NULL, NULL, 133431),
(133432, '1.20.1250.20-FF-000468', NULL, 'Os11g0620400 protein', 260, NULL, NULL, 133432),
(133433, '3.40.50.11730-FF-000002', NULL, 'Peroxisome assembly protein 22', 115, NULL, NULL, 133433),
(133434, '1.20.1070.10-FF-000838', NULL, 'Uncharacterized protein', 299, NULL, NULL, 133434),
(133435, '3.40.50.300-FF-001566', NULL, 'Dynein heavy chain domain 1', 260, NULL, NULL, 133435),
(133436, '1.10.565.10-FF-000019', NULL, 'Nuclear receptor subfamily 2 group E member 1', 230, NULL, NULL, 133436),
(133437, '3.40.50.300-FF-007934', NULL, 'Dicer-1, putative', 173, NULL, NULL, 133437),
(133438, '3.10.580.10-FF-000058', NULL, 'Chloride channel protein', 129, NULL, NULL, 133438),
(133439, '1.10.8.10-FF-000128', NULL, 'Ubiquitin family protein', 53, NULL, NULL, 133439),
(133440, '1.20.120.290-FF-000011', NULL, 'Predicted protein', 75, NULL, NULL, 133440),
(133441, '3.30.559.10-FF-000145', NULL, 'Peptide synthetase', 169, NULL, NULL, 133441),
(133442, '2.60.120.290-FF-000226', NULL, 'Uncharacterized protein', 110, NULL, NULL, 133442),
(133443, '1.10.600.10-FF-000086', NULL, 'Uncharacterized protein', 250, NULL, NULL, 133443),
(133444, '3.30.160.60-FF-003078', NULL, NULL, 31, NULL, NULL, 133444),
(133445, '1.50.10.10-FF-000212', NULL, 'Uncharacterized protein', 164, NULL, NULL, 133445),
(133446, '3.40.50.2000-FF-000395', NULL, 'Glycosyltransferase', 230, NULL, NULL, 133446),
(133447, '2.10.110.20-FF-000002', NULL, 'lysine-specific demethylase 6A isoform X2', 64, NULL, NULL, 133447),
(133448, '2.130.10.10-FF-001695', NULL, 'WD domain containing protein', 323, NULL, NULL, 133448),
(133449, '1.10.1790.10-FF-000002', NULL, 'Cryptic beta-glucoside bgl operon antiterminator', 109, NULL, NULL, 133449),
(133450, '3.40.50.2300-FF-001412', NULL, NULL, 75, NULL, NULL, 133450),
(133451, '2.130.10.10-FF-005438', NULL, 'Uncharacterized protein', 216, NULL, NULL, 133451),
(133452, '3.40.50.1390-FF-000020', NULL, 'DNA recombinase', 100, NULL, NULL, 133452),
(133453, '3.40.50.10380-FF-000018', NULL, 'Malic enzyme', 207, NULL, NULL, 133453),
(133454, '1.10.510.10-FF-003193', NULL, NULL, 150, NULL, NULL, 133454);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(133455, '2.30.29.30-FF-001046', NULL, 'Uncharacterized protein', 74, NULL, NULL, 133455),
(133456, '3.40.430.10-FF-000041', NULL, 'Riboflavin biosynthesis protein RibD', 216, NULL, NULL, 133456),
(133457, '1.10.132.70-FF-000021', NULL, 'Telomerase reverse transcriptase', 167, NULL, NULL, 133457),
(133458, '1.10.167.10-FF-000061', NULL, 'Uncharacterized protein', 151, NULL, NULL, 133458),
(133459, '1.20.920.10-FF-000169', NULL, 'Polybromo 1,-like', 54, NULL, NULL, 133459),
(133460, '3.30.70.1180-FF-000022', NULL, 'V-type proton ATPase subunit C', 30, NULL, NULL, 133460),
(133461, '3.40.50.300-FF-001875', NULL, 'RAB15, member RAS oncogene family', 117, NULL, NULL, 133461),
(133462, '1.20.910.10-FF-000034', NULL, 'Uncharacterized protein C530.07c', 228, NULL, NULL, 133462),
(133463, '3.30.160.60-FF-005539', NULL, NULL, 45, NULL, NULL, 133463),
(133464, '3.20.20.140-FF-000471', NULL, '2-amino-3-carboxymuconate-6-semialdehyde decarboxylase', 202, NULL, NULL, 133464),
(133465, '1.25.40.10-FF-003420', NULL, 'Heat shock protein DnaJ domain protein', 97, NULL, NULL, 133465),
(133466, '3.40.50.300-FF-006080', NULL, 'Protein CBR-GSA-1', 99, NULL, NULL, 133466),
(133467, '3.40.50.620-FF-000881', NULL, 'Tryptophan--tRNA ligase', 110, NULL, NULL, 133467),
(133468, '3.40.1190.10-FF-000010', NULL, 'Dihydrofolate synthetase', 265, NULL, NULL, 133468),
(133469, '2.10.25.10-FF-000622', NULL, 'Laminin-like protein epi-1', 48, NULL, NULL, 133469),
(133470, '3.40.50.10420-FF-000053', NULL, '5-formyltetrahydrofolate cyclo-ligase', 197, NULL, NULL, 133470),
(133471, '1.20.5.110-FF-000155', NULL, 'Vesicle-associated membrane protein, putative', 85, NULL, NULL, 133471),
(133472, '2.60.120.200-FF-000582', NULL, 'Laminin subunit alpha 5', 166, NULL, NULL, 133472),
(133473, '1.20.5.2050-FF-000004', NULL, 'Transcription factor with AP2 domain(S) (AP2-G)', 63, NULL, NULL, 133473),
(133474, '3.90.640.10-FF-000158', NULL, 'ARP1 actin related protein 1 homolog B', 38, NULL, NULL, 133474),
(133475, '3.90.810.10-FF-000019', NULL, 'Serine/threonine-protein kinase PAK', 72, NULL, NULL, 133475),
(133476, '3.40.50.300-FF-003820', NULL, 'Elongation factor 1-alpha', 139, NULL, NULL, 133476),
(133477, '3.30.1360.170-FF-000017', NULL, 'Thymidylate synthase complementing protein ThyX', 149, NULL, NULL, 133477),
(133478, '3.40.50.620-FF-000779', NULL, 'Uncharacterized protein', 93, NULL, NULL, 133478),
(133479, '1.20.900.10-FF-000095', NULL, 'Rho GTPase-activating protein 20', 216, NULL, NULL, 133479),
(133480, '3.40.1110.10-FF-000089', NULL, 'Phospholipid-transporting ATPase', 159, NULL, NULL, 133480),
(133481, '4.10.400.10-FF-000345', NULL, 'Uncharacterized protein', 35, NULL, NULL, 133481),
(133482, '3.40.1110.10-FF-000090', NULL, 'Phospholipid-transporting ATPase', 194, NULL, NULL, 133482),
(133483, '2.10.110.30-FF-000005', NULL, 'E3 ubiquitin-protein ligase ubr-1', 70, NULL, NULL, 133483),
(133484, '2.10.110.10-FF-000359', NULL, 'Uncharacterized protein', 136, NULL, NULL, 133484),
(133485, '1.10.510.10-FF-000320', NULL, 'Serine/threonine protein kinase', 167, NULL, NULL, 133485),
(133486, '1.25.40.10-FF-001593', NULL, 'TPR Domain containing protein', 140, NULL, NULL, 133486),
(133487, '1.20.1130.10-FF-000001', NULL, 'Photosystem I P700 chlorophyll a apoprotein A2', 735, NULL, NULL, 133487),
(133488, '1.10.630.10-FF-000705', NULL, 'Uncharacterized protein', 122, NULL, NULL, 133488),
(133489, '1.25.40.10-FF-001475', NULL, 'Selenium-binding protein-like', 91, NULL, NULL, 133489),
(133490, '1.10.150.50-FF-000192', NULL, 'Putative sh3 and multiple ankyrin repeat 3', 66, NULL, NULL, 133490),
(133491, '1.25.40.20-FF-001478', NULL, 'Uncharacterized protein', 96, NULL, NULL, 133491),
(133492, '3.30.1600.10-FF-000022', NULL, 'Uncharacterized protein', 63, NULL, NULL, 133492),
(133493, '2.130.10.10-FF-001706', NULL, 'Rho guanine nucleotide exchange factor 17', 181, NULL, NULL, 133493),
(133494, '3.30.300.110-FF-000017', NULL, 'Predicted protein', 87, NULL, NULL, 133494),
(133495, '1.10.1200.270-FF-000035', NULL, 'Salicylate/benzoate carboxyl methyltransferase', 46, NULL, NULL, 133495);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(133496, '1.20.1070.10-FF-000159', NULL, 'C-X-C chemokine receptor type 3', 300, NULL, NULL, 133496),
(133497, '1.20.930.10-FF-000035', NULL, 'Uncharacterized protein', 149, NULL, NULL, 133497),
(133498, '2.40.50.140-FF-001123', NULL, NULL, 61, NULL, NULL, 133498),
(133499, '2.30.30.140-FF-000093', NULL, 'DNA mismatch repair protein', 55, NULL, NULL, 133499),
(133500, '3.40.50.300-FF-000037', NULL, '26S protease regulatory subunit 6A', 182, NULL, NULL, 133500),
(133501, '1.10.238.10-FF-000979', NULL, 'CAMK/CDPK protein kinase', 69, NULL, NULL, 133501),
(133502, '3.90.870.50-FF-000001', NULL, 'Carbamoyltransferase', 299, NULL, NULL, 133502),
(133503, '2.40.30.10-FF-000200', NULL, 'Ferric reductase like transmembrane component protein', 96, NULL, NULL, 133503),
(133504, '1.10.510.10-FF-002102', NULL, 'Serine/threonine-protein kinase', 185, NULL, NULL, 133504),
(133505, '3.60.10.10-FF-000095', NULL, 'RNA-editing complex protein MP100', 277, NULL, NULL, 133505),
(133506, '2.10.25.10-FF-000829', NULL, 'Crumbs homolog 2', 39, NULL, NULL, 133506),
(133507, '1.25.40.10-FF-001166', NULL, 'Os07g0239600 protein', 161, NULL, NULL, 133507),
(133508, '1.25.10.10-FF-003446', NULL, 'eIF-2-alpha kinase activator gcn1', 408, NULL, NULL, 133508),
(133509, '1.25.40.20-FF-001848', NULL, 'C.Elegans Chromodomain protein', 139, NULL, NULL, 133509),
(133510, '2.60.120.40-FF-000020', NULL, 'complement C1q tumor necrosis factor-related protein 4', 140, NULL, NULL, 133510),
(133511, '3.40.50.300-FF-005164', NULL, 'Lipoprotein-releasing system ATP-binding protein LolD 1', 225, NULL, NULL, 133511),
(133512, '3.80.30.30-FF-000005', NULL, 'DNA repair photolyase', 214, NULL, NULL, 133512),
(133513, '2.20.100.10-FF-000148', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs gon-1', 55, NULL, NULL, 133513),
(133514, '3.80.10.10-FF-004399', NULL, 'Uncharacterized protein', 163, NULL, NULL, 133514),
(133515, '2.90.10.10-FF-000011', NULL, 'Serine/threonine-protein kinase', 145, NULL, NULL, 133515),
(133516, '1.25.40.10-FF-003627', NULL, 'Pentatricopeptide repeat-containing protein At3g23020', 72, NULL, NULL, 133516),
(133517, '2.130.10.10-FF-003640', NULL, 'Predicted protein', 132, NULL, NULL, 133517),
(133518, '3.30.70.330-FF-001570', NULL, NULL, 111, NULL, NULL, 133518),
(133519, '3.40.30.10-FF-000804', NULL, 'Glutathione S-transferase, putative', 79, NULL, NULL, 133519),
(133520, '3.40.1160.10-FF-000036', NULL, 'Glutamate 5-kinase', 272, NULL, NULL, 133520),
(133521, '3.30.200.20-FF-001911', NULL, 'Protein kinase C', 114, NULL, NULL, 133521),
(133522, '1.10.3860.10-FF-000031', NULL, 'Amino acid transporter', 239, NULL, NULL, 133522),
(133523, '2.60.40.60-FF-000400', NULL, 'cadherin EGF LAG seven-pass G-type receptor 2 isoform X2', 110, NULL, NULL, 133523),
(133524, '2.40.170.20-FF-000061', NULL, 'Ferripyoverdine receptor', 566, NULL, NULL, 133524),
(133525, '3.40.470.10-FF-000015', NULL, 'Uracil-DNA glycosylase', 248, NULL, NULL, 133525),
(133526, '3.30.160.20-FF-000188', NULL, 'Ribonuclease 3 1', 75, NULL, NULL, 133526),
(133527, '1.50.10.10-FF-000066', NULL, 'alpha-1,2-Mannosidase', 453, NULL, NULL, 133527),
(133528, '3.40.50.10190-FF-000304', NULL, 'Uncharacterized protein', 102, NULL, NULL, 133528),
(133529, '2.130.10.10-FF-005540', NULL, 'Uncharacterized protein', 128, NULL, NULL, 133529),
(133530, '3.30.420.210-FF-000012', NULL, 'Plant UBX domain-containing protein 6', 60, NULL, NULL, 133530),
(133531, '1.20.58.60-FF-000349', NULL, 'Spectrin beta chain', 107, NULL, NULL, 133531),
(133532, '3.40.50.1820-FF-000453', NULL, 'Carboxypeptidase', 426, NULL, NULL, 133532),
(133533, '1.10.510.10-FF-001955', NULL, 'Putative serine/threonine-protein kinase', 280, NULL, NULL, 133533),
(133534, '1.10.8.10-FF-000336', NULL, 'Uncharacterized protein', 40, NULL, NULL, 133534),
(133535, '1.10.510.10-FF-003855', NULL, NULL, 102, NULL, NULL, 133535),
(133536, '3.40.33.10-FF-000047', NULL, 'Antares, isoform A', 231, NULL, NULL, 133536),
(133537, '1.20.1250.20-FF-000732', NULL, 'MFS transporter', 200, NULL, NULL, 133537);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(133538, '3.40.50.300-FF-000801', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 239, NULL, NULL, 133538),
(133539, '1.10.275.10-FF-000008', NULL, 'Histidine ammonia-lyase', 195, NULL, NULL, 133539),
(133540, '2.40.50.140-FF-001005', NULL, NULL, 124, NULL, NULL, 133540),
(133541, '2.10.25.10-FF-000049', NULL, 'Fibrillin 2', 43, NULL, NULL, 133541),
(133542, '3.40.50.2000-FF-001103', NULL, 'UDP-glycosyltransferase 88A1', 42, NULL, NULL, 133542),
(133543, '2.130.10.30-FF-000066', NULL, 'Putative receptor protein kinase CRINKLY4', 261, NULL, NULL, 133543),
(133544, '1.10.287.70-FF-000481', NULL, 'Potassium channel subfamily K member', 297, NULL, NULL, 133544),
(133545, '1.50.10.20-FF-000069', NULL, 'Protein farnesyltransferase subunit beta', 464, NULL, NULL, 133545),
(133546, '4.10.410.10-FF-000082', NULL, 'Tissue factor pathway inhibitor', 71, NULL, NULL, 133546),
(133547, '3.50.50.60-FF-001326', NULL, 'Uncharacterized protein', 137, NULL, NULL, 133547),
(133548, '4.10.60.10-FF-000030', NULL, 'Branchpoint-bridging protein', 54, NULL, NULL, 133548),
(133549, '1.10.287.70-FF-000239', NULL, 'TWiK family of potassium channels', 205, NULL, NULL, 133549),
(133550, '2.30.30.870-FF-000002', NULL, 'Protein pelota homolog', 131, NULL, NULL, 133550),
(133551, '3.90.79.20-FF-000030', NULL, 'Uncharacterized protein', 105, NULL, NULL, 133551),
(133552, '1.25.40.10-FF-001284', NULL, 'Tetratricopeptide repeat protein', 348, NULL, NULL, 133552),
(133553, '2.60.40.10-FF-001375', NULL, 'Obscurin-like protein 1 isoform X2', 90, NULL, NULL, 133553),
(133554, '1.10.8.60-FF-000435', NULL, 'Peroxisome biogenesis factor 1, putative', 124, NULL, NULL, 133554),
(133555, '3.80.10.10-FF-002499', NULL, 'Predicted protein', 172, NULL, NULL, 133555),
(133556, '3.40.50.150-FF-000060', NULL, 'tRNA (guanine-N(7)-)-methyltransferase', 215, NULL, NULL, 133556),
(133557, '3.90.1200.10-FF-000023', NULL, 'Aminoglycoside phosphotransferase', 198, NULL, NULL, 133557),
(133558, '1.20.120.540-FF-000002', NULL, 'Uncharacterized protein', 87, NULL, NULL, 133558),
(133559, '3.30.420.10-FF-000604', NULL, NULL, 185, NULL, NULL, 133559),
(133560, '2.20.110.10-FF-000076', NULL, NULL, 81, NULL, NULL, 133560),
(133561, '2.40.290.10-FF-000033', NULL, 'ATP-dependent DNA helicase', 217, NULL, NULL, 133561),
(133562, '1.25.40.20-FF-001287', NULL, 'Os09g0334900 protein', 306, NULL, NULL, 133562),
(133563, '3.40.250.10-FF-000044', NULL, 'Rhodanese-like domain-containing protein 4, chloroplastic', 132, NULL, NULL, 133563),
(133564, '1.10.555.10-FF-000081', NULL, 'Rho GTPase Activating protein', 197, NULL, NULL, 133564),
(133565, '3.40.1170.10-FF-000008', NULL, 'DNA mismatch repair protein', 102, NULL, NULL, 133565),
(133566, '1.10.472.10-FF-000101', NULL, 'Cyclin, putative', 99, NULL, NULL, 133566),
(133567, '1.20.58.1120-FF-000052', NULL, NULL, 39, NULL, NULL, 133567),
(133568, '3.40.120.10-FF-000040', NULL, 'Phosphoglucomutase A', 100, NULL, NULL, 133568),
(133569, '2.60.120.650-FF-000177', NULL, 'Predicted protein', 129, NULL, NULL, 133569),
(133570, '1.20.120.550-FF-000005', NULL, 'Inorganic phosphate transporter 1-6', 156, NULL, NULL, 133570),
(133571, '2.10.90.10-FF-000109', NULL, 'Nodal homolog 2-A', 112, NULL, NULL, 133571),
(133572, '2.130.10.10-FF-000060', NULL, 'WD repeat-containing protein 44', 320, NULL, NULL, 133572),
(133573, '2.60.40.10-FF-004033', NULL, NULL, 97, NULL, NULL, 133573),
(133574, '2.60.40.3210-FF-000023', NULL, 'Uncharacterized protein', 119, NULL, NULL, 133574),
(133575, '1.50.40.10-FF-000146', NULL, 'Uncharacterized protein, isoform B', 288, NULL, NULL, 133575),
(133576, '2.60.40.10-FF-001627', NULL, 'titin isoform X1', 87, NULL, NULL, 133576),
(133577, '2.30.31.10-FF-000023', NULL, 'RNA polymerase II transcriptional coactivator KELP', 45, NULL, NULL, 133577),
(133578, '3.10.490.10-FF-000040', NULL, 'Gamma-glutamylcyclotransferase', 194, NULL, NULL, 133578),
(133579, '2.40.20.10-FF-000020', NULL, 'Uncharacterized protein', 86, NULL, NULL, 133579),
(133580, '1.20.1070.10-FF-000367', NULL, 'Serotonin receptor 5-HT2 subtype', 119, NULL, NULL, 133580);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(133581, '1.10.555.10-FF-000182', NULL, NULL, 217, NULL, NULL, 133581),
(133582, '3.30.470.20-FF-000189', NULL, 'Predicted protein', 106, NULL, NULL, 133582),
(133583, '3.40.50.20-FF-000045', NULL, 'D-alanine--D-alanine ligase', 119, NULL, NULL, 133583),
(133584, '3.40.50.300-FF-007726', NULL, 'Uncharacterized protein', 91, NULL, NULL, 133584),
(133585, '3.40.50.1820-FF-000868', NULL, 'Carboxylic ester hydrolase', 253, NULL, NULL, 133585),
(133586, '3.40.50.2000-FF-000586', NULL, 'Glycogen synthase', 155, NULL, NULL, 133586),
(133587, '1.25.40.10-FF-003184', NULL, 'TPR repeat, putative', 98, NULL, NULL, 133587),
(133588, '3.40.50.150-FF-001594', NULL, 'Leucine carboxyl methyltransferase 1', 387, NULL, NULL, 133588),
(133589, '3.30.450.20-FF-000289', NULL, 'Sensory box histidine kinase/response regulator', 139, NULL, NULL, 133589),
(133590, '2.40.50.150-FF-000041', NULL, 'DNA-directed RNA polymerase subunit beta', 14, NULL, NULL, 133590),
(133591, '2.130.10.10-FF-001594', NULL, 'Coiled-coil protein/ WD40 domain', 281, NULL, NULL, 133591),
(133592, '3.30.70.2850-FF-000028', NULL, 'DNA-directed RNA polymerase subunit', 206, NULL, NULL, 133592),
(133593, '1.10.630.10-FF-000593', NULL, 'Os09g0441600 protein', 284, NULL, NULL, 133593),
(133594, '1.25.40.10-FF-000401', NULL, 'Cytochrome c oxidase assembly factor 7', 219, NULL, NULL, 133594),
(133595, '3.40.50.2300-FF-001221', NULL, NULL, 157, NULL, NULL, 133595),
(133596, '3.30.40.210-FF-000011', NULL, 'Transcription initiation protein SPT4, putative', 100, NULL, NULL, 133596),
(133597, '3.30.200.20-FF-001086', NULL, 'Kinase, CMGC CDK', 89, NULL, NULL, 133597),
(133598, '3.30.1370.110-FF-000007', NULL, 'Endonuclease MutS2', 121, NULL, NULL, 133598),
(133599, '3.30.40.10-FF-000873', NULL, 'E3 ubiquitin-protein ligase SGR9, amyloplastic', 77, NULL, NULL, 133599),
(133600, '3.10.450.350-FF-000008', NULL, 'Cell wall endopeptidase family M23/M37', 93, NULL, NULL, 133600),
(133601, '3.40.1110.10-FF-000191', NULL, 'Membrane H(+)-ATPase1', 61, NULL, NULL, 133601),
(133602, '3.30.505.10-FF-000144', NULL, 'SH2 domain protein 2A', 120, NULL, NULL, 133602),
(133603, '3.30.450.20-FF-000435', NULL, 'Predicted protein', 90, NULL, NULL, 133603),
(133604, '2.150.10.10-FF-000014', NULL, 'Immunoglobulin-binding protein EibD', 135, NULL, NULL, 133604),
(133605, '3.30.1370.100-FF-000004', NULL, 'DNA mismatch repair endonuclease MutL', 95, NULL, NULL, 133605),
(133606, '3.30.70.330-FF-001660', NULL, NULL, 51, NULL, NULL, 133606),
(133607, '3.30.160.60-FF-001633', NULL, 'GDNF inducible zinc finger protein 1', 86, NULL, NULL, 133607),
(133608, '1.25.40.20-FF-001832', NULL, 'Kinase, NEK-frag', 148, NULL, NULL, 133608),
(133609, '1.25.40.20-FF-000404', NULL, 'Ankyrin repeat-containing protein At5g02620', 154, NULL, NULL, 133609),
(133610, '3.30.479.20-FF-000046', NULL, 'Elongation factor Ts', 90, NULL, NULL, 133610),
(133611, '2.60.40.3180-FF-000008', NULL, 'Uncharacterized protein', 162, NULL, NULL, 133611),
(133612, '3.40.630.30-FF-000129', NULL, 'Acetyltransferase', 94, NULL, NULL, 133612),
(133613, '3.60.21.10-FF-000103', NULL, 'Unplaced genomic scaffold supercont1.18, whole genome shotgun sequence', 251, NULL, NULL, 133613),
(133614, '2.60.40.10-FF-000290', NULL, 'Tyrosine-protein kinase receptor', 94, NULL, NULL, 133614),
(133615, '2.130.10.10-FF-005394', NULL, 'Uncharacterized protein', 149, NULL, NULL, 133615),
(133616, '3.20.20.80-FF-000455', NULL, 'Beta-galactosidase 8 isoform A', 100, NULL, NULL, 133616),
(133617, '3.40.50.300-FF-005265', NULL, 'Uncharacterized protein', 183, NULL, NULL, 133617),
(133618, '1.25.40.120-FF-000019', NULL, 'Geranylgeranyl transferase type-2 subunit alpha', 320, NULL, NULL, 133618),
(133619, '3.30.70.1230-FF-000205', NULL, 'Adenylyl cyclase class-3/4/guanylyl cyclase', 203, NULL, NULL, 133619),
(133620, '1.25.40.20-FF-001742', NULL, 'Uncharacterized protein', 213, NULL, NULL, 133620),
(133621, '1.20.1250.20-FF-000586', NULL, 'Sialic acid-transport membrane protein nanT', 182, NULL, NULL, 133621),
(133622, '2.60.40.10-FF-005427', NULL, NULL, 103, NULL, NULL, 133622);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(133623, '3.20.20.70-FF-000452', NULL, NULL, 150, NULL, NULL, 133623),
(133624, '3.80.10.10-FF-003016', NULL, 'Uncharacterized protein', 169, NULL, NULL, 133624),
(133625, '2.10.220.10-FF-000092', NULL, 'Epidermal growth factor receptor a (erythroblastic leukemia viral (v-erb-b) oncogene homolog, avian)', 45, NULL, NULL, 133625),
(133626, '1.10.10.250-FF-000023', NULL, '50S ribosomal protein L11-2/L11-3', 61, NULL, NULL, 133626),
(133627, '3.40.1110.10-FF-000443', NULL, NULL, 171, NULL, NULL, 133627),
(133628, '3.40.50.10490-FF-000068', NULL, 'MurR/RpiR family transcriptional regulator', 188, NULL, NULL, 133628),
(133629, '1.25.10.10-FF-001338', NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit', 400, NULL, NULL, 133629),
(133630, '3.30.420.10-FF-000352', NULL, 'Uncharacterized protein', 180, NULL, NULL, 133630),
(133631, '1.20.920.10-FF-000063', NULL, 'histone acetyltransferase KAT2A', 123, NULL, NULL, 133631),
(133632, '2.130.10.10-FF-004112', NULL, 'Aladin-like Protein', 190, NULL, NULL, 133632),
(133633, '3.30.70.2580-FF-000003', NULL, 'tRNA (Guanine(37)-N(1))-methyltransferase', 57, NULL, NULL, 133633),
(133634, '2.60.120.330-FF-000053', NULL, 'Unplaced genomic scaffold supercont1.31, whole genome shotgun sequence', 338, NULL, NULL, 133634),
(133635, '3.40.630.30-FF-000371', NULL, 'Acyl-CoA N-acyltransferases (NAT) superfamily protein', 190, NULL, NULL, 133635),
(133636, '3.40.190.10-FF-000926', NULL, 'SMN (Human Survival Motor Neuron gene) homolog', 67, NULL, NULL, 133636),
(133637, '2.40.50.140-FF-000960', NULL, NULL, 132, NULL, NULL, 133637),
(133638, '3.40.50.740-FF-000040', NULL, 'Dimethyl sulfoxide reductase subunit A', 89, NULL, NULL, 133638),
(133639, '1.20.1270.60-FF-000239', NULL, 'Uncharacterized protein', 333, NULL, NULL, 133639),
(133640, '3.10.20.90-FF-000340', NULL, 'Polyubiquitin containing 7 ubiquitin monomers', 74, NULL, NULL, 133640),
(133641, '2.130.10.10-FF-003494', NULL, 'Serine/threonine-protein kinase VPS15', 266, NULL, NULL, 133641),
(133642, '2.60.40.1180-FF-000026', NULL, 'Solute carrier family 3 (amino acid transporter heavy chain), member 1', 83, NULL, NULL, 133642),
(133643, '3.30.70.1020-FF-000013', NULL, NULL, 80, NULL, NULL, 133643),
(133644, '1.20.1250.20-FF-000277', NULL, 'Solute carrier family 16 member 4', 212, NULL, NULL, 133644),
(133645, '2.30.30.490-FF-000068', NULL, 'Putative pre-initiation complex subunit cdc6 aaa+ superfamily atpase', 104, NULL, NULL, 133645),
(133646, '1.10.287.370-FF-000048', NULL, 'Prefoldin subunit 2', 104, NULL, NULL, 133646),
(133647, '3.40.50.1910-FF-000036', NULL, 'Protein transport protein sec1', 214, NULL, NULL, 133647),
(133648, '1.10.510.10-FF-000421', NULL, 'Serine/threonine-protein kinase PAK 6', 196, NULL, NULL, 133648),
(133649, '1.20.1740.10-FF-000132', NULL, 'Nitrogen-sensing and cell-morphology modulator, general aminoacid permease, putative', 463, NULL, NULL, 133649),
(133650, '3.30.1330.30-FF-000136', NULL, 'Uncharacterized protein', 88, NULL, NULL, 133650),
(133651, '2.60.40.10-FF-005118', NULL, NULL, 98, NULL, NULL, 133651),
(133652, '2.40.50.140-FF-000297', NULL, 'Protein BREAST CANCER SUSCEPTIBILITY 2 homolog B', 138, NULL, NULL, 133652),
(133653, '3.30.200.20-FF-001350', NULL, 'Rho-associated kinase, putative', 111, NULL, NULL, 133653),
(133654, '1.10.1420.10-FF-000115', NULL, 'DNA mismatch repair protein MSH3', 190, NULL, NULL, 133654),
(133655, '3.40.720.10-FF-000142', NULL, 'Predicted protein', 260, NULL, NULL, 133655),
(133656, '3.40.50.300-FF-003365', NULL, 'DNA repair protein RecN', 247, NULL, NULL, 133656),
(133657, '2.130.10.10-FF-002212', NULL, 'Elongator complex protein 2', 258, NULL, NULL, 133657),
(133658, '3.20.10.10-FF-000068', NULL, 'Uncharacterized protein', 106, NULL, NULL, 133658),
(133659, '3.40.50.2020-FF-000024', NULL, 'Putative phosphoribosyl pyrophosphate synthase-associated protein 1', 147, NULL, NULL, 133659),
(133660, '3.20.20.140-FF-000128', NULL, 'TatD family hydrolase', 252, NULL, NULL, 133660),
(133661, '2.40.128.20-FF-000036', NULL, 'Luciferase', 157, NULL, NULL, 133661);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(133662, '3.90.80.10-FF-000007', NULL, 'Inorganic pyrophosphatase, mitochondrial', 242, NULL, NULL, 133662),
(133663, '1.10.520.10-FF-000040', NULL, 'Peroxidase', 145, NULL, NULL, 133663),
(133664, '3.20.80.10-FF-000016', NULL, 'Probable transcriptional regulator', 147, NULL, NULL, 133664),
(133665, '1.20.120.150-FF-000008', NULL, 'Serine/threonine-protein kinase TOR', 89, NULL, NULL, 133665),
(133666, '1.10.10.60-FF-000869', NULL, NULL, 70, NULL, NULL, 133666),
(133667, '1.25.40.10-FF-003274', NULL, 'TPR repeat, putative', 139, NULL, NULL, 133667),
(133668, '3.30.310.50-FF-000001', NULL, 'Phosphoglucosamine mutase', 76, NULL, NULL, 133668),
(133669, '2.130.10.10-FF-003185', NULL, 'NLE (NUC135) domain/WD domain, G-beta repeat, putative', 136, NULL, NULL, 133669),
(133670, '1.10.238.150-FF-000001', NULL, 'Dishevelled associated activator of morphogenesis 1', 86, NULL, NULL, 133670),
(133671, '2.30.39.10-FF-000153', NULL, 'Uncharacterized protein', 116, NULL, NULL, 133671),
(133672, '1.25.10.10-FF-001647', NULL, 'Predicted protein', 429, NULL, NULL, 133672),
(133673, '3.90.1150.10-FF-000479', NULL, 'Predicted protein', 92, NULL, NULL, 133673),
(133674, '1.10.10.10-FF-001276', NULL, 'ETS class transcription factor', 107, NULL, NULL, 133674),
(133675, '1.20.1250.20-FF-002267', NULL, 'Os01g0142800 protein', 99, NULL, NULL, 133675),
(133676, '1.25.40.180-FF-000077', NULL, 'Unplaced genomic scaffold supercont2.8, whole genome shotgun sequence', 324, NULL, NULL, 133676),
(133677, '3.40.50.300-FF-003926', NULL, 'Septin 14', 287, NULL, NULL, 133677),
(133678, '3.40.50.300-FF-005826', NULL, 'tRNA dimethylallyltransferase', 230, NULL, NULL, 133678),
(133679, '1.20.5.4770-FF-000011', NULL, 'Zinc finger A20 and AN1 domain-containing stress-associated protein 1', 53, NULL, NULL, 133679),
(133680, '3.30.70.240-FF-000031', NULL, 'Mitochondrial elongation factor G2', 94, NULL, NULL, 133680),
(133681, '3.40.50.300-FF-003674', NULL, 'Predicted protein', 201, NULL, NULL, 133681),
(133682, '3.30.40.10-FF-001126', NULL, 'G protein-coupled receptor', 67, NULL, NULL, 133682),
(133683, '3.40.50.2300-FF-001176', NULL, NULL, 105, NULL, NULL, 133683),
(133684, '1.20.1250.20-FF-002177', NULL, 'Uncharacterized protein', 172, NULL, NULL, 133684),
(133685, '4.10.240.10-FF-000147', NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', 75, NULL, NULL, 133685),
(133686, '1.10.10.800-FF-000008', NULL, 'Uncharacterized protein', 51, NULL, NULL, 133686),
(133687, '3.40.720.10-FF-000361', NULL, 'Predicted protein', 173, NULL, NULL, 133687),
(133688, '3.40.50.300-FF-001774', NULL, 'ATPase component of energizing module ofqueuosine-regulated ECF transporter', 217, NULL, NULL, 133688),
(133689, '1.20.970.10-FF-000009', NULL, 'Anthranilate phosphoribosyltransferase, chloroplastic', 81, NULL, NULL, 133689),
(133690, '3.40.50.720-FF-002299', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 163, NULL, NULL, 133690),
(133691, '2.60.40.10-FF-003527', NULL, NULL, 81, NULL, NULL, 133691),
(133692, '3.50.50.60-FF-001236', NULL, 'Os06g0203400 protein', 200, NULL, NULL, 133692),
(133693, '3.40.50.1370-FF-000054', NULL, NULL, 107, NULL, NULL, 133693),
(133694, '3.30.70.340-FF-000027', NULL, NULL, 81, NULL, NULL, 133694),
(133695, '3.40.50.1460-FF-000047', NULL, 'Caspase Nc-like Protein', 256, NULL, NULL, 133695),
(133696, '3.20.20.60-FF-000140', NULL, 'Citrate lyase subunit beta-like protein', 234, NULL, NULL, 133696),
(133697, '1.20.1110.10-FF-000090', NULL, 'Sodium/potassium-transporting ATPase subunit alpha', 417, NULL, NULL, 133697),
(133698, '3.90.1720.10-FF-000034', NULL, 'Probable cell wall associated hydrolase', 137, NULL, NULL, 133698),
(133699, '2.40.50.140-FF-000858', NULL, NULL, 150, NULL, NULL, 133699),
(133700, '3.90.290.10-FF-000001', NULL, 'Latent-transforming growth factor beta-binding protein 3 isoform 1', 70, NULL, NULL, 133700),
(133701, '3.30.70.260-FF-000037', NULL, 'Acetoin utilization protein AcuB', 66, NULL, NULL, 133701),
(133702, '3.20.20.80-FF-000146', NULL, 'Maltodextrin glucosidase', 393, NULL, NULL, 133702);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(133703, '3.40.50.1440-FF-000041', NULL, 'Tubulin gamma chain', 266, NULL, NULL, 133703),
(133704, '3.40.50.300-FF-002701', NULL, 'Predicted protein', 190, NULL, NULL, 133704),
(133705, '3.40.50.300-FF-000240', NULL, 'ABC transporter B family member 20', 249, NULL, NULL, 133705),
(133706, '3.30.470.20-FF-000099', NULL, 'Inositol-tetrakisphosphate 1-kinase', 109, NULL, NULL, 133706),
(133707, '1.20.1560.10-FF-000584', NULL, 'Uncharacterized protein', 327, NULL, NULL, 133707),
(133708, '1.10.10.10-FF-001585', NULL, 'Uncharacterized protein', 115, NULL, NULL, 133708),
(133709, '2.60.40.10-FF-003218', NULL, NULL, 90, NULL, NULL, 133709),
(133710, '3.40.50.150-FF-001706', NULL, NULL, 64, NULL, NULL, 133710),
(133711, '1.10.472.80-FF-000072', NULL, 'TBC domain-containing protein C23D3.03c', 130, NULL, NULL, 133711),
(133712, '2.130.10.10-FF-005085', NULL, 'Utp4p', 359, NULL, NULL, 133712),
(133713, '1.10.8.10-FF-000084', NULL, 'E3 ubiquitin-protein ligase XIAP', 62, NULL, NULL, 133713),
(133714, '4.10.1240.10-FF-000037', NULL, 'Latrophilin-like protein 1', 57, NULL, NULL, 133714),
(133715, '3.20.20.70-FF-000143', NULL, 'EF-P beta-lysylation protein EpmB', 284, NULL, NULL, 133715),
(133716, '2.30.40.10-FF-000027', NULL, 'Guanine deaminase', 118, NULL, NULL, 133716),
(133717, '1.10.150.550-FF-000002', NULL, 'Nucleoprotein', 94, NULL, NULL, 133717),
(133718, '1.10.1280.10-FF-000020', NULL, 'Tyrosinase', 169, NULL, NULL, 133718),
(133719, '2.40.40.20-FF-000029', NULL, 'NADH-quinone oxidoreductase subunit G', 94, NULL, NULL, 133719),
(133720, '1.10.510.10-FF-003737', NULL, NULL, 149, NULL, NULL, 133720),
(133721, '1.20.5.110-FF-000346', NULL, 'Predicted protein', 42, NULL, NULL, 133721),
(133722, '3.20.20.140-FF-000336', NULL, 'Uncharacterized protein', 37, NULL, NULL, 133722),
(133723, '3.40.50.450-FF-000026', NULL, 'Lysine decarboxylase-like protein', 174, NULL, NULL, 133723),
(133724, '3.40.50.150-FF-000043', NULL, 'probable methyltransferase PMT3', 168, NULL, NULL, 133724),
(133725, '3.30.70.100-FF-000085', NULL, 'V-type proton ATPase subunit C', 89, NULL, NULL, 133725),
(133726, '2.60.120.200-FF-000391', NULL, 'Lectin, putative', 234, NULL, NULL, 133726),
(133727, '2.60.40.10-FF-005871', NULL, NULL, 144, NULL, NULL, 133727),
(133728, '4.10.280.10-FF-000138', NULL, 'Basic helix-loop-helix (BHLH) DNA-binding superfamily protein', 75, NULL, NULL, 133728),
(133729, '3.80.10.10-FF-004293', NULL, 'Uncharacterized protein', 235, NULL, NULL, 133729),
(133730, '1.20.58.480-FF-000001', NULL, 'Tryptophan 2,3-dioxygenase', 260, NULL, NULL, 133730),
(133731, '3.40.50.10330-FF-000043', NULL, 'Ceramide kinase-like protein', 155, NULL, NULL, 133731),
(133732, '3.50.50.60-FF-000837', NULL, 'Uncharacterized protein', 86, NULL, NULL, 133732),
(133733, '1.20.58.60-FF-000765', NULL, 'AGAP009554-PA', 318, NULL, NULL, 133733),
(133734, '3.40.1190.20-FF-000086', NULL, 'Fructokinase', 327, NULL, NULL, 133734),
(133735, '3.40.50.460-FF-000029', NULL, 'Phosphofructokinase, platelet b', 21, NULL, NULL, 133735),
(133736, '1.10.580.10-FF-000015', NULL, 'Citrate synthase', 239, NULL, NULL, 133736),
(133737, '2.10.220.10-FF-000002', NULL, 'Receptor protein-tyrosine kinase', 139, NULL, NULL, 133737),
(133738, '2.130.10.10-FF-003269', NULL, 'YALI0B01078p', 174, NULL, NULL, 133738),
(133739, '2.40.160.20-FF-000015', NULL, 'WGS project CABT00000000 data, contig 2.20', 164, NULL, NULL, 133739),
(133740, '2.60.120.380-FF-000034', NULL, 'Putative calpain', 160, NULL, NULL, 133740),
(133741, '2.60.120.680-FF-000017', NULL, 'Uncharacterized protein', 96, NULL, NULL, 133741),
(133742, '2.130.10.10-FF-000998', NULL, 'VPS10 homolog 2', 115, NULL, NULL, 133742),
(133743, '1.20.1280.50-FF-000063', NULL, 'F-box domain containing protein, expressed', 50, NULL, NULL, 133743),
(133744, '3.40.50.1010-FF-000160', NULL, NULL, 131, NULL, NULL, 133744),
(133745, '3.30.230.130-FF-000001', NULL, 'Cullin 4A', 157, NULL, NULL, 133745),
(133746, '2.10.25.10-FF-000268', NULL, 'nephronectin isoform X2', 61, NULL, NULL, 133746),
(133747, '3.10.400.20-FF-000032', NULL, 'Uncharacterized protein', 189, NULL, NULL, 133747);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(133748, '2.60.40.4100-FF-000009', NULL, 'Uncharacterized protein, isoform B', 134, NULL, NULL, 133748),
(133749, '1.25.10.10-FF-002035', NULL, 'Armadillo/beta-catenin-like repeat, putative', 156, NULL, NULL, 133749),
(133750, '3.40.50.1360-FF-000051', NULL, 'Probable 6-phosphogluconolactonase', 252, NULL, NULL, 133750),
(133751, '3.90.870.10-FF-000012', NULL, '3,4-dihydroxy-2-butanone 4-phosphate synthase', 223, NULL, NULL, 133751),
(133752, '1.10.10.2520-FF-000002', NULL, 'Cell wall hydrolase CwlJ', 85, NULL, NULL, 133752),
(133753, '1.25.40.20-FF-000899', NULL, 'Kinase, NEK', 153, NULL, NULL, 133753),
(133754, '3.60.10.10-FF-000078', NULL, 'Endonuclease/exonuclease/phosphatase family protein, putative', 374, NULL, NULL, 133754),
(133755, '3.40.50.1000-FF-000050', NULL, 'Ubiquitin-like domain-containing CTD phosphatase 1', 227, NULL, NULL, 133755),
(133756, '3.30.160.60-FF-005781', NULL, NULL, 55, NULL, NULL, 133756),
(133757, '1.25.40.10-FF-003644', NULL, 'Tetratricopeptide repeat protein 37', 153, NULL, NULL, 133757),
(133758, '2.30.29.30-FF-000349', NULL, 'Transcription factor SipA3', 120, NULL, NULL, 133758),
(133759, '1.10.3860.10-FF-000014', NULL, 'Amino acid transporter', 335, NULL, NULL, 133759),
(133760, '3.90.70.10-FF-000260', NULL, 'Cathepsin L', 231, NULL, NULL, 133760),
(133761, '3.40.50.1010-FF-000053', NULL, 'Protein MKT1', 215, NULL, NULL, 133761),
(133762, '2.40.30.10-FF-000110', NULL, 'Elongation factor 2', 128, NULL, NULL, 133762),
(133763, '3.100.10.10-FF-000029', NULL, '60S ribosomal protein L18, putative', 168, NULL, NULL, 133763),
(133764, '1.20.1720.10-FF-000029', NULL, 'Multidrug resistance membrane efflux protein emrB', 237, NULL, NULL, 133764),
(133765, '2.60.40.10-FF-003089', NULL, 'Cell adhesion molecule, putative', 90, NULL, NULL, 133765),
(133766, '1.20.1560.10-FF-000792', NULL, 'Predicted protein', 224, NULL, NULL, 133766),
(133767, '3.40.1190.20-FF-000193', NULL, NULL, 256, NULL, NULL, 133767),
(133768, '3.60.21.10-FF-000002', NULL, 'Serine/threonine-protein phosphatase', 418, NULL, NULL, 133768),
(133769, '2.30.29.30-FF-000456', NULL, 'Type II inositol-3,4-bisphosphate 4-phosphatase', 111, NULL, NULL, 133769),
(133770, '3.30.1240.10-FF-000062', NULL, 'Cof-type HAD-IIB family hydrolase', 115, NULL, NULL, 133770),
(133771, '3.10.20.90-FF-000205', NULL, '2''-5''-oligoadenylate synthase-like protein 2', 74, NULL, NULL, 133771),
(133772, '3.40.50.300-FF-002145', NULL, 'ABC transporter (MsbA subfamily)', 248, NULL, NULL, 133772),
(133773, '3.60.20.10-FF-000157', NULL, NULL, 70, NULL, NULL, 133773),
(133774, '3.30.70.330-FF-001553', NULL, NULL, 87, NULL, NULL, 133774),
(133775, '1.20.1250.20-FF-001221', NULL, 'Multidrug resistance protein B', 210, NULL, NULL, 133775),
(133776, '3.30.70.270-FF-000259', NULL, NULL, 178, NULL, NULL, 133776),
(133777, '3.30.2130.30-FF-000037', NULL, 'Uncharacterized protein', 132, NULL, NULL, 133777),
(133778, '3.40.50.300-FF-003466', NULL, 'ATPase, AAA family protein', 115, NULL, NULL, 133778),
(133779, '3.40.50.2000-FF-000850', NULL, 'Cell wall alpha-1,3-glucan synthase mok14', 234, NULL, NULL, 133779),
(133780, '3.40.50.300-FF-005720', NULL, 'Endoribonuclease dcr-1', 163, NULL, NULL, 133780),
(133781, '2.60.40.10-FF-005236', NULL, NULL, 89, NULL, NULL, 133781),
(133782, '1.25.40.10-FF-000896', NULL, 'SEL1 protein', 157, NULL, NULL, 133782),
(133783, '3.40.50.2020-FF-000041', NULL, 'Hypoxanthine-guanine phosphoribosyltransferase', 182, NULL, NULL, 133783),
(133784, '1.20.1740.10-FF-000250', NULL, 'Glycoprotein-associated amino acid transporter, putative', 294, NULL, NULL, 133784),
(133785, '2.10.25.10-FF-000066', NULL, 'FAT atypical cadherin 4', 37, NULL, NULL, 133785),
(133786, '3.80.10.10-FF-002729', NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', 226, NULL, NULL, 133786),
(133787, '3.30.160.20-FF-000233', NULL, 'Uncharacterized protein', 90, NULL, NULL, 133787),
(133788, '2.130.10.10-FF-003067', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit TRM82', 128, NULL, NULL, 133788),
(133789, '3.50.50.60-FF-001017', NULL, 'Heterodisulfide reductase, subunit A/methylviologen reducing hydrogenase, subunit delta', 153, NULL, NULL, 133789);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(133790, '3.90.1280.20-FF-000008', NULL, 'Chloride channel protein', 64, NULL, NULL, 133790),
(133791, '2.130.10.10-FF-003376', NULL, 'Bromodomain and WD repeat-containing DDB_G0285837', 170, NULL, NULL, 133791),
(133792, '1.25.10.10-FF-001911', NULL, 'Uncharacterized protein', 269, NULL, NULL, 133792),
(133793, '1.10.260.40-FF-000085', NULL, 'Uncharacterized protein', 84, NULL, NULL, 133793),
(133794, '1.10.8.60-FF-000082', NULL, 'Origin recognition complex subunit 1', 93, NULL, NULL, 133794),
(133795, '3.30.70.1730-FF-000029', NULL, '50S ribosomal protein L10', 129, NULL, NULL, 133795),
(133796, '3.30.2140.20-FF-000006', NULL, 'Arylamine N-acetyltransferase 4', 259, NULL, NULL, 133796),
(133797, '3.40.630.30-FF-000236', NULL, 'Histone acetyltransferase', 121, NULL, NULL, 133797),
(133798, '1.10.510.10-FF-002321', NULL, 'Serine/threonine protein kinase-54', 293, NULL, NULL, 133798),
(133799, '1.10.238.110-FF-000012', NULL, 'Diacylglycerol kinase', 151, NULL, NULL, 133799),
(133800, '3.40.50.1950-FF-000014', NULL, 'Flavin prenyltransferase UbiX', 191, NULL, NULL, 133800),
(133801, '3.80.10.10-FF-002836', NULL, 'Predicted protein', 98, NULL, NULL, 133801),
(133802, '3.10.450.580-FF-000021', NULL, 'Mediator of RNA polymerase II transcription subunit 6', 69, NULL, NULL, 133802),
(133803, '2.60.40.10-FF-005343', NULL, NULL, 71, NULL, NULL, 133803),
(133804, '3.30.530.20-FF-000031', NULL, 'StAR-related lipid transfer protein 5', 211, NULL, NULL, 133804),
(133805, '3.30.160.60-FF-002122', NULL, 'Rgm1p', 31, NULL, NULL, 133805),
(133806, '1.20.1070.10-FF-000940', NULL, 'Olfactory receptor family 1 subfamily L member 1', 106, NULL, NULL, 133806),
(133807, '1.10.287.70-FF-000711', NULL, 'Uncharacterized protein', 156, NULL, NULL, 133807),
(133808, '3.40.50.300-FF-003775', NULL, 'Circularly permutated Ras protein 1', 145, NULL, NULL, 133808),
(133809, '1.10.3210.10-FF-000100', NULL, 'GTP pyrophosphokinase', 196, NULL, NULL, 133809),
(133810, '2.30.30.140-FF-000340', NULL, 'Predicted protein', 54, NULL, NULL, 133810),
(133811, '2.30.29.30-FF-000675', NULL, 'Protein expanded', 101, NULL, NULL, 133811),
(133812, '3.40.50.300-FF-005383', NULL, 'Dynein heavy chain 11', 122, NULL, NULL, 133812),
(133813, '3.90.70.10-FF-000153', NULL, 'NHLP family bacteriocin export ABC transporter peptidase/permease/ATPase', 148, NULL, NULL, 133813),
(133814, '1.50.10.160-FF-000009', NULL, 'P(E)-nerolidol/(E,E)-geranyl linalool synthase', 209, NULL, NULL, 133814),
(133815, '3.40.50.300-FF-000228', NULL, 'dynamin-related protein 1E', 309, NULL, NULL, 133815),
(133816, '1.20.1560.10-FF-000803', NULL, 'Uncharacterized protein', 190, NULL, NULL, 133816),
(133817, '2.60.120.180-FF-000002', NULL, 'Endo-1,4-beta-xylanase A', 183, NULL, NULL, 133817),
(133818, '2.10.90.10-FF-000008', NULL, 'Bone morphogenetic protein 3', 117, NULL, NULL, 133818),
(133819, '3.40.50.1110-FF-000111', NULL, 'Putative O-antigen related protein', 221, NULL, NULL, 133819),
(133820, '3.40.50.410-FF-000290', NULL, 'X-ray repair cross-complementing protein 5-like Protein', 196, NULL, NULL, 133820),
(133821, '3.10.200.10-FF-000019', NULL, NULL, 108, NULL, NULL, 133821),
(133822, '1.10.150.510-FF-000007', NULL, 'Receptor activity modifying protein 2', 95, NULL, NULL, 133822),
(133823, '2.30.30.140-FF-000014', NULL, 'Metal-response element-binding transcription factor 2', 60, NULL, NULL, 133823),
(133824, '1.50.10.150-FF-000006', NULL, 'C4-dicarboxylate transporter/malic acid transport protein', 299, NULL, NULL, 133824),
(133825, '1.25.10.10-FF-000130', NULL, 'Exportin 4', 494, NULL, NULL, 133825),
(133826, '1.20.1070.10-FF-001120', NULL, 'Angiotensin II receptor, type 2', 307, NULL, NULL, 133826),
(133827, '3.30.70.2890-FF-000001', NULL, 'Factor of DNA methylation 2', 170, NULL, NULL, 133827),
(133828, '3.30.160.60-FF-003538', NULL, 'Si:ch73-221f6.3', 27, NULL, NULL, 133828),
(133829, '1.10.1040.50-FF-000025', NULL, NULL, 85, NULL, NULL, 133829),
(133830, '2.40.50.90-FF-000197', NULL, 'Uncharacterized protein', 53, NULL, NULL, 133830),
(133831, '1.25.50.20-FF-000023', NULL, 'Aminopeptidase', 113, NULL, NULL, 133831);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(133832, '3.30.160.60-FF-001942', NULL, 'IKAROS family zinc finger 4', 59, NULL, NULL, 133832),
(133833, '1.10.260.80-FF-000001', NULL, 'Haloacid dehalogenase-like hydrolase domain-containing protein', 62, NULL, NULL, 133833),
(133834, '2.60.40.10-FF-003628', NULL, NULL, 96, NULL, NULL, 133834),
(133835, '1.10.510.10-FF-002012', NULL, NULL, 43, NULL, NULL, 133835),
(133836, '3.40.30.10-FF-000248', NULL, 'Thioredoxin', 108, NULL, NULL, 133836),
(133837, '3.90.190.10-FF-000437', NULL, 'Uncharacterized protein', 62, NULL, NULL, 133837),
(133838, '1.10.10.790-FF-000027', NULL, 'Surp module, putative', 57, NULL, NULL, 133838),
(133839, '1.25.40.10-FF-003167', NULL, 'Uncharacterized protein', 226, NULL, NULL, 133839),
(133840, '1.25.40.10-FF-001727', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform A', 99, NULL, NULL, 133840),
(133841, '1.20.58.1610-FF-000002', NULL, 'NADH-quinone oxidoreductase subunit A', 118, NULL, NULL, 133841),
(133842, '2.130.10.10-FF-000779', NULL, 'WD repeat protein 68', 317, NULL, NULL, 133842),
(133843, '2.130.10.10-FF-005630', NULL, 'Predicted protein', 178, NULL, NULL, 133843),
(133844, '1.10.10.10-FF-001703', NULL, 'Transcriptional regulator, LysR family', 84, NULL, NULL, 133844),
(133845, '3.40.250.10-FF-000151', NULL, 'Predicted protein', 135, NULL, NULL, 133845),
(133846, '3.40.50.200-FF-000007', NULL, 'Subtilisin-like serine protease', 291, NULL, NULL, 133846),
(133847, '2.60.40.60-FF-000080', NULL, 'FAT atypical cadherin 1', 105, NULL, NULL, 133847),
(133848, '2.30.29.30-FF-000984', NULL, 'Vacuolar protein sorting protein (Vps36), putative', 39, NULL, NULL, 133848),
(133849, '3.30.300.20-FF-000071', NULL, 'Uncharacterized protein', 64, NULL, NULL, 133849),
(133850, '1.20.58.1070-FF-000014', NULL, 'Gem-associated protein 2', 94, NULL, NULL, 133850),
(133851, '3.90.180.10-FF-000049', NULL, 'NADPH-dependent oxidoreductase 2-alkenal reductase', 163, NULL, NULL, 133851),
(133852, '3.40.720.10-FF-000035', NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase 4 (Putative)', 266, NULL, NULL, 133852),
(133853, '2.130.10.130-FF-000011', NULL, 'Glycosylphosphatidylinositol specific phospholipase D1', 248, NULL, NULL, 133853),
(133854, '3.30.470.20-FF-000217', NULL, 'Uncharacterized protein', 148, NULL, NULL, 133854),
(133855, '2.10.50.10-FF-000118', NULL, 'Predicted protein', 64, NULL, NULL, 133855),
(133856, '1.10.101.10-FF-000038', NULL, 'Amidase', 79, NULL, NULL, 133856),
(133857, '3.30.450.20-FF-000643', NULL, 'Two-component hybrid sensor and regulator', 127, NULL, NULL, 133857),
(133858, '3.40.50.790-FF-000021', NULL, 'Predicted protein', 121, NULL, NULL, 133858),
(133859, '3.90.76.10-FF-000020', NULL, 'ABC transporter substrate-binding protein', 145, NULL, NULL, 133859),
(133860, '3.30.200.20-FF-000962', NULL, 'probable L-type lectin-domain containing receptor kinase S.5', 92, NULL, NULL, 133860),
(133861, '2.20.70.10-FF-000288', NULL, 'Uncharacterized protein', 50, NULL, NULL, 133861),
(133862, '3.40.50.720-FF-000383', NULL, 'SDR family oxidoreductase', 252, NULL, NULL, 133862),
(133863, '2.60.40.2700-FF-000005', NULL, NULL, 97, NULL, NULL, 133863),
(133864, '3.30.2130.10-FF-000031', NULL, 'Uncharacterized protein', 103, NULL, NULL, 133864),
(133865, '2.60.40.10-FF-005562', NULL, NULL, 111, NULL, NULL, 133865),
(133866, '2.60.120.260-FF-000599', NULL, 'Uncharacterized protein', 146, NULL, NULL, 133866),
(133867, '1.25.40.10-FF-004948', NULL, 'Uncharacterized protein', 175, NULL, NULL, 133867),
(133868, '1.25.40.850-FF-000002', NULL, 'Vacuolar protein sorting-associated protein 33A', 92, NULL, NULL, 133868),
(133869, '3.30.460.10-FF-000135', NULL, 'Protein CBG18550', 166, NULL, NULL, 133869),
(133870, '1.10.10.60-FF-000768', NULL, NULL, 106, NULL, NULL, 133870),
(133871, '2.60.40.10-FF-001291', NULL, 'Uncharacterized protein, isoform B', 91, NULL, NULL, 133871),
(133872, '1.25.40.860-FF-000005', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 88, NULL, NULL, 133872),
(133873, '1.20.5.110-FF-000037', NULL, 'Putative syntaxin-71-like', 62, NULL, NULL, 133873);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(133874, '2.30.110.50-FF-000001', NULL, 'Rhs element Vgr protein', 131, NULL, NULL, 133874),
(133875, '1.10.4030.10-FF-000002', NULL, 'Chaperone SurA', 128, NULL, NULL, 133875),
(133876, '3.40.50.410-FF-000071', NULL, 'ATP-dependent DNA helicase II subunit 1', 241, NULL, NULL, 133876),
(133877, '1.10.1200.10-FF-000161', NULL, 'NonRibosomal Peptide Synthetase', 74, NULL, NULL, 133877),
(133878, '3.80.10.10-FF-003000', NULL, 'Predicted protein', 95, NULL, NULL, 133878),
(133879, '1.10.8.60-FF-000312', NULL, 'ATPase family associated with various cellular activities (AAA)', 79, NULL, NULL, 133879),
(133880, '2.10.25.10-FF-000392', NULL, 'neurogenic locus notch homolog protein 2', 37, NULL, NULL, 133880),
(133881, '1.10.287.70-FF-000346', NULL, 'GM20581', 171, NULL, NULL, 133881),
(133882, '2.60.40.2880-FF-000002', NULL, 'Putative membrane protein mmpS5', 88, NULL, NULL, 133882),
(133883, '2.40.50.1060-FF-000023', NULL, 'Uncharacterized protein', 66, NULL, NULL, 133883),
(133884, '2.60.40.10-FF-004241', NULL, NULL, 111, NULL, NULL, 133884),
(133885, '3.40.50.2300-FF-001322', NULL, NULL, 102, NULL, NULL, 133885),
(133886, '1.20.1250.20-FF-000378', NULL, 'MFS transporter', 388, NULL, NULL, 133886),
(133887, '3.30.40.10-FF-001143', NULL, 'Predicted protein', 116, NULL, NULL, 133887),
(133888, '1.10.10.10-FF-001692', NULL, 'Heat shock transcription factor, putative', 106, NULL, NULL, 133888),
(133889, '1.10.1750.10-FF-000016', NULL, NULL, 99, NULL, NULL, 133889),
(133890, '2.60.120.290-FF-000035', NULL, 'Discoidin, CUB and LCCL domain-containing protein 2', 125, NULL, NULL, 133890),
(133891, '3.30.160.20-FF-000082', NULL, 'Uncharacterized protein', 70, NULL, NULL, 133891),
(133892, '3.30.50.10-FF-000149', NULL, 'Estrogen receptor alpha', 76, NULL, NULL, 133892),
(133893, '1.20.80.10-FF-000066', NULL, 'Golgi resident protein GCP60', 106, NULL, NULL, 133893),
(133894, '2.130.10.10-FF-003595', NULL, 'Uncharacterized protein', 193, NULL, NULL, 133894),
(133895, '3.40.50.720-FF-000692', NULL, 'Quinone oxidoreductase', 143, NULL, NULL, 133895),
(133896, '1.10.565.10-FF-000137', NULL, 'RAR related orphan receptor C', 52, NULL, NULL, 133896),
(133897, '1.10.4160.10-FF-000028', NULL, 'Uracil transporter (Eurofung)', 354, NULL, NULL, 133897),
(133898, '3.90.180.10-FF-000139', NULL, 'Quinone oxidoreductase, putative', 87, NULL, NULL, 133898),
(133899, '2.40.50.1070-FF-000026', NULL, NULL, 161, NULL, NULL, 133899),
(133900, '1.20.1250.20-FF-001002', NULL, 'Solute carrier family 22 member 10', 108, NULL, NULL, 133900),
(133901, '1.10.8.10-FF-000230', NULL, 'Predicted protein', 43, NULL, NULL, 133901),
(133902, '3.40.630.30-FF-000455', NULL, 'GCN5-related N-acetyltransferase', 183, NULL, NULL, 133902),
(133903, '3.40.50.2300-FF-000833', NULL, NULL, 120, NULL, NULL, 133903),
(133904, '1.10.275.10-FF-000020', NULL, 'Adenylosuccinate lyase', 92, NULL, NULL, 133904),
(133905, '3.40.50.410-FF-000380', NULL, 'Collagen alpha 3 chain type VI', 137, NULL, NULL, 133905),
(133906, '3.30.830.10-FF-000040', NULL, 'Stromal processing peptidase, chloroplastic', 220, NULL, NULL, 133906),
(133907, '3.20.20.190-FF-000093', NULL, 'Phosphoinositide phospholipase C', 265, NULL, NULL, 133907),
(133908, '2.10.10.10-FF-000009', NULL, 'Epididymal sperm-binding protein 1', 57, NULL, NULL, 133908),
(133909, '3.40.50.150-FF-000150', NULL, 'methyltransferase-like protein 13 isoform X1', 233, NULL, NULL, 133909),
(133910, '3.30.160.60-FF-003847', NULL, NULL, 31, NULL, NULL, 133910),
(133911, '3.30.70.330-FF-001025', NULL, 'Tag-262 protein', 134, NULL, NULL, 133911),
(133912, '2.110.10.10-FF-000004', NULL, '72 kDa type IV collagenase', 200, NULL, NULL, 133912),
(133913, '3.40.1110.10-FF-000342', NULL, NULL, 130, NULL, NULL, 133913),
(133914, '3.10.20.90-FF-000424', NULL, 'Autophagy protein 5', 88, NULL, NULL, 133914),
(133915, '1.10.510.10-FF-001293', NULL, 'Mitogen-activated protein kinase', 128, NULL, NULL, 133915),
(133916, '3.90.1150.10-FF-000378', NULL, 'Glycine cleavage system P protein', 90, NULL, NULL, 133916),
(133917, '3.30.40.10-FF-000980', NULL, 'Transcriptional regulator of yeast form adherence 3', 105, NULL, NULL, 133917);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(133918, '1.20.58.2220-FF-000033', NULL, 'CYtoKinesis defect', 305, NULL, NULL, 133918),
(133919, '2.60.40.10-FF-001184', NULL, 'Ephrin type-A receptor 6', 82, NULL, NULL, 133919),
(133920, '3.40.50.620-FF-000690', NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', 288, NULL, NULL, 133920),
(133921, '3.40.50.1260-FF-000021', NULL, 'Phosphoglycerate kinase', 204, NULL, NULL, 133921),
(133922, '3.30.160.60-FF-003864', NULL, NULL, 27, NULL, NULL, 133922),
(133923, '3.90.1480.20-FF-000006', NULL, 'ST3 beta-galactoside alpha-2,3-sialyltransferase 5', 311, NULL, NULL, 133923),
(133924, '1.10.560.10-FF-000132', NULL, 'Uncharacterized protein', 152, NULL, NULL, 133924),
(133925, '1.10.10.10-FF-001719', NULL, 'Disease resistance protein RGA4', 91, NULL, NULL, 133925),
(133926, '1.25.10.10-FF-001546', NULL, 'Cell differentiation family, Rcd1-like protein', 275, NULL, NULL, 133926),
(133927, '2.130.10.10-FF-000503', NULL, 'Glucose repression regulatory protein TUP1', 375, NULL, NULL, 133927),
(133928, '3.40.920.10-FF-000016', NULL, 'Sulfite reductase [NADPH] flavoprotein component, putative', 208, NULL, NULL, 133928),
(133929, '2.130.10.10-FF-001487', NULL, 'WD repeat-containing protein 48 isoform X1', 147, NULL, NULL, 133929),
(133930, '1.10.10.10-FF-001383', NULL, 'Forkhead box O4', 78, NULL, NULL, 133930),
(133931, '1.20.1560.10-FF-000483', NULL, 'ABC transporter (ATP-binding protein) homolog ygaD', 348, NULL, NULL, 133931),
(133932, '2.40.10.380-FF-000001', NULL, 'Tail sheath monomer', 91, NULL, NULL, 133932),
(133933, '1.50.40.10-FF-000337', NULL, 'Uncharacterized protein', 201, NULL, NULL, 133933),
(133934, '3.30.70.330-FF-001334', NULL, 'Protein CBR-UNC-26', 82, NULL, NULL, 133934),
(133935, '2.60.40.10-FF-002324', NULL, 'Lachesin', 90, NULL, NULL, 133935),
(133936, '3.40.930.10-FF-000051', NULL, NULL, 113, NULL, NULL, 133936),
(133937, '1.25.40.950-FF-000004', NULL, 'Uncharacterized protein', 73, NULL, NULL, 133937),
(133938, '3.40.50.150-FF-001678', NULL, NULL, 147, NULL, NULL, 133938),
(133939, '2.130.10.10-FF-003286', NULL, 'phospholipase A-2-activating protein', 324, NULL, NULL, 133939),
(133940, '3.40.50.300-FF-007491', NULL, 'Uncharacterized protein', 227, NULL, NULL, 133940),
(133941, '3.90.25.10-FF-000077', NULL, 'GDP-mannose 4,6 dehydratase', 22, NULL, NULL, 133941),
(133942, '1.10.287.130-FF-000235', NULL, 'Regulatory components of sensory transduction system', 68, NULL, NULL, 133942),
(133943, '2.60.120.920-FF-000151', NULL, 'Si:dkey-269o24.1', 182, NULL, NULL, 133943),
(133944, '3.40.50.300-FF-007827', NULL, 'ABC transporter G family member 34', 271, NULL, NULL, 133944),
(133945, '3.40.50.10140-FF-000093', NULL, 'Uncharacterized protein', 67, NULL, NULL, 133945),
(133946, '3.40.50.300-FF-002510', NULL, 'DNA mismatch repair protein MutS', 220, NULL, NULL, 133946),
(133947, '3.20.20.120-FF-000021', NULL, 'Dipeptide epimerase', 223, NULL, NULL, 133947),
(133948, '3.40.50.1700-FF-000046', NULL, 'Glucan 1,4-beta-glucosidase', 124, NULL, NULL, 133948),
(133949, '1.10.10.10-FF-001922', NULL, 'Predicted protein', 95, NULL, NULL, 133949),
(133950, '3.40.800.20-FF-000050', NULL, 'Histone deacetylase', 375, NULL, NULL, 133950),
(133951, '2.60.40.10-FF-005326', NULL, NULL, 77, NULL, NULL, 133951),
(133952, '3.30.160.60-FF-002105', NULL, 'zinc finger protein 62 homolog', 35, NULL, NULL, 133952),
(133953, '3.10.260.10-FF-000012', NULL, NULL, 179, NULL, NULL, 133953),
(133954, '3.50.30.30-FF-000158', NULL, 'Glutamate carboxypeptidase, putative', 216, NULL, NULL, 133954),
(133955, '2.130.10.10-FF-002111', NULL, 'Lethal (3) 72Dn, isoform B', 248, NULL, NULL, 133955),
(133956, '2.40.30.10-FF-000071', NULL, 'Elongation factor Tu', 103, NULL, NULL, 133956),
(133957, '3.40.50.150-FF-001785', NULL, NULL, 177, NULL, NULL, 133957),
(133958, '2.60.220.30-FF-000002', NULL, 'Ankyrin-3 isoform 2', 159, NULL, NULL, 133958),
(133959, '3.30.70.1230-FF-000104', NULL, 'Adenylate cyclase', 195, NULL, NULL, 133959),
(133960, '1.20.58.60-FF-000456', NULL, 'Dystrophin', 114, NULL, NULL, 133960),
(133961, '3.90.79.20-FF-000018', NULL, 'NADH diphosphatase (Pyrophosphatase), putative', 131, NULL, NULL, 133961);
INSERT INTO "PUBLIC"."MODEL" VALUES
(133962, '1.20.5.170-FF-000252', NULL, 'Uncharacterized protein', 134, NULL, NULL, 133962),
(133963, '3.40.50.10330-FF-000026', NULL, 'NAD+ kinase, putative', 25, NULL, NULL, 133963),
(133964, '3.30.559.30-FF-000100', NULL, 'Hydroxamate-type ferrichrome siderophore peptide synthetase', 228, NULL, NULL, 133964),
(133965, '1.25.40.1030-FF-000008', NULL, 'Protein transport protein sec16', 431, NULL, NULL, 133965),
(133966, '3.40.50.10310-FF-000020', NULL, 'Creatininase', 240, NULL, NULL, 133966),
(133967, '3.30.70.330-FF-003133', NULL, NULL, 43, NULL, NULL, 133967),
(133968, '2.130.10.10-FF-005293', NULL, 'Uncharacterized protein', 222, NULL, NULL, 133968),
(133969, '3.30.420.10-FF-000503', NULL, NULL, 50, NULL, NULL, 133969),
(133970, '3.30.390.30-FF-000045', NULL, 'Glutathione reductase', 115, NULL, NULL, 133970),
(133971, '1.10.510.10-FF-003428', NULL, NULL, 288, NULL, NULL, 133971),
(133972, '3.30.160.60-FF-004011', NULL, NULL, 29, NULL, NULL, 133972),
(133973, '2.10.70.10-FF-000120', NULL, 'Coagulation factor XIII B chain', 57, NULL, NULL, 133973),
(133974, '1.10.8.720-FF-000003', NULL, 'Cytoplasmic dynein heavy chain 2', 177, NULL, NULL, 133974),
(133975, '3.40.50.10610-FF-000003', NULL, 'Curli production assembly/transport component CsgG', 153, NULL, NULL, 133975),
(133976, '3.40.50.150-FF-001605', NULL, NULL, 349, NULL, NULL, 133976),
(133977, '2.60.220.50-FF-000008', NULL, 'Adhesion G-protein coupled receptor D1', 185, NULL, NULL, 133977),
(133978, '2.60.40.10-FF-003319', NULL, 'Immunoglobulin superfamily member 3', 109, NULL, NULL, 133978),
(133979, '3.40.50.300-FF-001982', NULL, 'Serine protease/ABC transporter B family protein tagC', 239, NULL, NULL, 133979),
(133980, '2.40.50.140-FF-000959', NULL, NULL, 139, NULL, NULL, 133980),
(133981, '1.10.390.10-FF-000085', NULL, 'Predicted protein', 203, NULL, NULL, 133981),
(133982, '3.30.310.10-FF-000040', NULL, 'TATA box binding protein (TBP)-associated factor', 63, NULL, NULL, 133982),
(133983, '3.40.50.1820-FF-000099', NULL, 'Homoserine O-acetyltransferase', 371, NULL, NULL, 133983),
(133984, '1.20.1070.10-FF-000631', NULL, 'Dopamine receptor 4', 157, NULL, NULL, 133984),
(133985, '1.20.920.10-FF-000214', NULL, 'Uncharacterized protein', 99, NULL, NULL, 133985),
(133986, '3.90.45.10-FF-000005', NULL, 'Peptide deformylase', 170, NULL, NULL, 133986),
(133987, '2.40.128.110-FF-000002', NULL, 'Polyisoprenoid-binding protein', 176, NULL, NULL, 133987),
(133988, '3.20.20.140-FF-000027', NULL, 'putative deoxyribonuclease TATDN2', 268, NULL, NULL, 133988),
(133989, '3.10.400.10-FF-000001', NULL, 'bifunctional 3''-phosphoadenosine 5''-phosphosulfate synthase 1', 157, NULL, NULL, 133989),
(133990, '1.10.8.10-FF-000235', NULL, 'Plant UBX domain-containing protein 10', 50, NULL, NULL, 133990),
(133991, '3.30.70.330-FF-001244', NULL, 'Peptidyl-prolyl cis-trans isomerase', 136, NULL, NULL, 133991),
(133992, '3.40.50.300-FF-002162', NULL, 'Thymidine kinase', 140, NULL, NULL, 133992),
(133993, '1.50.10.10-FF-000167', NULL, 'alpha-1,2-Mannosidase', 449, NULL, NULL, 133993),
(133994, '2.60.120.10-FF-000045', NULL, 'Cysteine dioxygenase 1', 201, NULL, NULL, 133994),
(133995, '3.30.160.20-FF-000087', NULL, 'Staufen, isoform C', 72, NULL, NULL, 133995),
(133996, '1.10.540.10-FF-000041', NULL, 'Acyl-CoA dehydrogenase', 114, NULL, NULL, 133996),
(133997, '3.40.50.300-FF-005692', NULL, 'RNA guanylyltransferase', 180, NULL, NULL, 133997),
(133998, '1.10.287.70-FF-000672', NULL, 'Predicted protein', 112, NULL, NULL, 133998),
(133999, '1.10.390.10-FF-000113', NULL, 'Uncharacterized protein', 145, NULL, NULL, 133999),
(134000, '1.25.40.660-FF-000024', NULL, 'Vacuolar protein sorting35 putative', 163, NULL, NULL, 134000),
(134001, '3.40.50.360-FF-000134', NULL, 'Putative reductase', 192, NULL, NULL, 134001),
(134002, '4.10.640.10-FF-000003', NULL, '30S ribosomal protein S18', 76, NULL, NULL, 134002),
(134003, '1.10.565.10-FF-000121', NULL, 'Nuclear receptor', 246, NULL, NULL, 134003),
(134004, '1.10.3080.10-FF-000044', NULL, 'Predicted protein', 420, NULL, NULL, 134004);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(134005, '3.30.365.10-FF-000054', NULL, 'xanthine dehydrogenase/oxidase-like', 171, NULL, NULL, 134005),
(134006, '3.10.20.90-FF-000222', NULL, 'Polyubiquitin 5', 76, NULL, NULL, 134006),
(134007, '2.10.25.10-FF-000605', NULL, 'Crumbs cell polarity complex component 2', 37, NULL, NULL, 134007),
(134008, '3.40.1190.20-FF-000114', NULL, 'ADP-dependent (S)-NAD(P)H-hydrate dehydratase', 279, NULL, NULL, 134008),
(134009, '3.90.105.20-FF-000013', NULL, 'Ribosome assembly factor mrt4', 74, NULL, NULL, 134009),
(134010, '3.60.40.10-FF-000383', NULL, 'Uncharacterized protein', 146, NULL, NULL, 134010),
(134011, '3.30.70.940-FF-000011', NULL, 'Transcription elongation factor SPT5', 106, NULL, NULL, 134011),
(134012, '3.30.1330.40-FF-000050', NULL, 'Diphthine--ammonia ligase', 107, NULL, NULL, 134012),
(134013, '1.20.140.10-FF-000115', NULL, 'Uncharacterized protein', 93, NULL, NULL, 134013),
(134014, '1.20.58.390-FF-000300', NULL, 'Uncharacterized protein', 79, NULL, NULL, 134014),
(134015, '3.60.21.10-FF-000221', NULL, 'Sphingomyelin phosphodiesterase', 287, NULL, NULL, 134015),
(134016, '3.40.50.790-FF-000004', NULL, 'Ribosomal L1 domain-containing 1-like 1', 106, NULL, NULL, 134016),
(134017, '3.40.720.10-FF-000018', NULL, 'Putative GPI ethanolamine phosphate transferase 2', 279, NULL, NULL, 134017),
(134018, '3.30.160.60-FF-004230', NULL, NULL, 32, NULL, NULL, 134018),
(134019, '1.10.238.20-FF-000044', NULL, 'General odorant-binding protein 57c', 119, NULL, NULL, 134019),
(134020, '2.130.10.10-FF-005854', NULL, 'Sortilin', 325, NULL, NULL, 134020),
(134021, '2.30.30.380-FF-000035', NULL, 'Protein transport protein SEC23', 50, NULL, NULL, 134021),
(134022, '1.10.287.70-FF-000801', NULL, 'Uncharacterized protein', 101, NULL, NULL, 134022),
(134023, '3.40.710.10-FF-000063', NULL, 'D-alanyl-D-alanine carboxypeptidase', 262, NULL, NULL, 134023),
(134024, '1.10.10.60-FF-000987', NULL, NULL, 83, NULL, NULL, 134024),
(134025, '3.10.440.10-FF-000003', NULL, '60S ribosomal subunit protein L31, putative', 118, NULL, NULL, 134025),
(134026, '1.20.920.10-FF-000181', NULL, 'Bromodomain containing protein', 166, NULL, NULL, 134026),
(134027, '3.80.10.10-FF-000931', NULL, 'MDIS1-interacting receptor like kinase 2', 92, NULL, NULL, 134027),
(134028, '3.30.310.10-FF-000023', NULL, 'TATA-box-binding protein 2', 83, NULL, NULL, 134028),
(134029, '3.40.50.150-FF-001459', NULL, NULL, 138, NULL, NULL, 134029),
(134030, '1.10.510.10-FF-003647', NULL, NULL, 186, NULL, NULL, 134030),
(134031, '3.30.1330.20-FF-000015', NULL, 'Cell division protein FtsZ', 107, NULL, NULL, 134031),
(134032, '3.30.9.10-FF-000194', NULL, 'FAD dependent oxidoreductase', 181, NULL, NULL, 134032),
(134033, '2.20.25.10-FF-000060', NULL, 'DNA-directed RNA polymerase subunit', 55, NULL, NULL, 134033),
(134034, '3.30.1330.30-FF-000018', NULL, 'growth arrest and DNA damage-inducible protein GADD45 gamma', 159, NULL, NULL, 134034),
(134035, '1.20.1050.10-FF-000068', NULL, 'Putative GST6 protein', 134, NULL, NULL, 134035),
(134036, '2.40.50.140-FF-001106', NULL, NULL, 51, NULL, NULL, 134036),
(134037, '3.30.559.10-FF-000246', NULL, 'Uncharacterized protein', 77, NULL, NULL, 134037),
(134038, '3.30.1370.210-FF-000037', NULL, 'Uncharacterized protein', 59, NULL, NULL, 134038),
(134039, '3.30.70.330-FF-001008', NULL, 'Unplaced genomic scaffold supercont2.9, whole genome shotgun sequence', 150, NULL, NULL, 134039),
(134040, '1.20.1270.60-FF-000150', NULL, 'Arp2/3 complex-activating protein ricka, putative', 205, NULL, NULL, 134040),
(134041, '2.60.40.10-FF-003409', NULL, NULL, 98, NULL, NULL, 134041),
(134042, '4.10.1000.10-FF-000065', NULL, 'Cysteine three histidine 1', 31, NULL, NULL, 134042),
(134043, '3.30.160.60-FF-001739', NULL, 'zinc finger protein 133 isoform X2', 27, NULL, NULL, 134043),
(134044, '3.30.70.330-FF-001227', NULL, 'glycine-rich RNA-binding protein 4, mitochondrial', 114, NULL, NULL, 134044),
(134045, '3.80.10.10-FF-001201', NULL, 'mRNA_export_factor_MEX67', 152, NULL, NULL, 134045),
(134046, '3.40.50.10190-FF-000203', NULL, 'Replication factor C subunit 1', 108, NULL, NULL, 134046);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(134047, '2.40.50.700-FF-000015', NULL, NULL, 87, NULL, NULL, 134047),
(134048, '3.40.630.30-FF-000253', NULL, 'GD19407', 223, NULL, NULL, 134048),
(134049, '2.110.10.10-FF-000021', NULL, 'Matrix metallopeptidase 19', 64, NULL, NULL, 134049),
(134050, '3.80.10.10-FF-004309', NULL, 'Uncharacterized protein', 213, NULL, NULL, 134050),
(134051, '2.60.40.10-FF-005545', NULL, NULL, 119, NULL, NULL, 134051),
(134052, '2.40.40.20-FF-000024', NULL, 'AAA family ATPase, CDC48 subfamily', 106, NULL, NULL, 134052),
(134053, '3.40.50.150-FF-001824', NULL, NULL, 81, NULL, NULL, 134053),
(134054, '1.10.472.80-FF-000206', NULL, NULL, 148, NULL, NULL, 134054),
(134055, '2.40.40.10-FF-000021', NULL, NULL, 110, NULL, NULL, 134055),
(134056, '3.30.70.1320-FF-000013', NULL, 'Efflux pump membrane transporter', 102, NULL, NULL, 134056),
(134057, '1.10.287.110-FF-000313', NULL, 'YALI0C05819p', 111, NULL, NULL, 134057),
(134058, '1.10.238.10-FF-000041', NULL, 'DCN1-like protein', 89, NULL, NULL, 134058),
(134059, '3.30.559.30-FF-000010', NULL, 'Nonribosomal peptide synthase Pes1', 215, NULL, NULL, 134059),
(134060, '2.60.40.10-FF-006034', NULL, NULL, 63, NULL, NULL, 134060),
(134061, '3.30.420.10-FF-000161', NULL, 'Protein RISC-INTERACTING CLEARING 3''-5'' EXORIBONUCLEASE 2', 205, NULL, NULL, 134061),
(134062, '3.10.580.10-FF-000075', NULL, 'CBS domain-containing protein', 164, NULL, NULL, 134062),
(134063, '1.20.120.1080-FF-000053', NULL, 'ATP-dependent helicase hrpA', 87, NULL, NULL, 134063),
(134064, '2.30.30.140-FF-000121', NULL, 'Pre-mRNA-splicing factor 38B, putative', 62, NULL, NULL, 134064),
(134065, '1.25.10.10-FF-003339', NULL, 'Uncharacterized protein', 456, NULL, NULL, 134065),
(134066, '2.130.10.10-FF-003741', NULL, 'KIN14B-interacting protein At4g14310', 332, NULL, NULL, 134066),
(134067, '2.40.50.40-FF-000098', NULL, 'Histone-lysine N-methyltransferase', 67, NULL, NULL, 134067),
(134068, '2.30.29.30-FF-000658', NULL, 'SHC-transforming protein homolog 1', 152, NULL, NULL, 134068),
(134069, '1.10.510.10-FF-003956', NULL, NULL, 53, NULL, NULL, 134069),
(134070, '1.10.240.10-FF-000001', NULL, 'Tyrosine--tRNA ligase', 103, NULL, NULL, 134070),
(134071, '3.30.70.140-FF-000001', NULL, 'Aspartate carbamoyltransferase regulatory chain', 99, NULL, NULL, 134071),
(134072, '3.90.180.10-FF-000156', NULL, 'Uncharacterized protein', 149, NULL, NULL, 134072),
(134073, '3.30.70.150-FF-000004', NULL, 'Ribulose bisphosphate carboxylase', 132, NULL, NULL, 134073),
(134074, '1.20.1250.20-FF-002295', NULL, 'Uncharacterized protein', 65, NULL, NULL, 134074),
(134075, '3.40.50.800-FF-000081', NULL, 'Prolyl-tRNA synthetase', 113, NULL, NULL, 134075),
(134076, '1.10.238.10-FF-000260', NULL, 'Protein S100-A13', 98, NULL, NULL, 134076),
(134077, '3.40.30.10-FF-000613', NULL, 'Uncharacterized protein', 81, NULL, NULL, 134077),
(134078, '3.30.429.10-FF-000006', NULL, '5-carboxymethyl-2-hydroxymuconate delta isomerase', 116, NULL, NULL, 134078),
(134079, '4.10.240.10-FF-000029', NULL, 'Transcription factor', 87, NULL, NULL, 134079),
(134080, '3.40.50.300-FF-003556', NULL, 'NRAS proto-oncogene, GTPase', 120, NULL, NULL, 134080),
(134081, '1.10.510.10-FF-000213', NULL, 'STE20-related kinase adapter protein alpha isoform X2', 223, NULL, NULL, 134081),
(134082, '3.10.20.90-FF-000531', NULL, 'Autophagy-related protein', 127, NULL, NULL, 134082),
(134083, '3.40.50.620-FF-000555', NULL, 'YALI0D25564p', 245, NULL, NULL, 134083),
(134084, '1.20.1070.10-FF-001103', NULL, 'Encephalopsin', 313, NULL, NULL, 134084),
(134085, '3.40.50.300-FF-007518', NULL, 'ATP-dependent DNA helicase', 212, NULL, NULL, 134085),
(134086, '1.25.40.10-FF-004010', NULL, 'Coatomer protein complex, subunit epsilon', 203, NULL, NULL, 134086),
(134087, '3.20.20.190-FF-000121', NULL, 'FI16509p1', 341, NULL, NULL, 134087),
(134088, '1.10.150.850-FF-000002', NULL, 'Transcription elongation factor spt6', 92, NULL, NULL, 134088),
(134089, '1.10.510.10-FF-003086', NULL, NULL, 199, NULL, NULL, 134089),
(134090, '2.30.42.10-FF-000649', NULL, NULL, 97, NULL, NULL, 134090),
(134091, '3.80.10.10-FF-001420', NULL, 'Hypothetical_protein_-_conserved', 276, NULL, NULL, 134091);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(134092, '1.20.58.60-FF-000782', NULL, 'Dystonin', 311, NULL, NULL, 134092),
(134093, '3.40.630.30-FF-000562', NULL, 'Gll0241 protein', 122, NULL, NULL, 134093),
(134094, '3.40.30.10-FF-000265', NULL, 'Glutathione S-transferase family protein', 155, NULL, NULL, 134094),
(134095, '3.40.50.300-FF-003247', NULL, 'ATP-dependent Clp protease ATP-binding subunit clpX-like, mitochondrial', 82, NULL, NULL, 134095),
(134096, '3.40.630.30-FF-000601', NULL, 'Glucosamine-phosphate N-acetyltransferase 1', 68, NULL, NULL, 134096),
(134097, '3.30.505.10-FF-000043', NULL, 'SH3 domain binding protein 2', 99, NULL, NULL, 134097),
(134098, '1.10.1280.10-FF-000025', NULL, 'Uncharacterized protein', 79, NULL, NULL, 134098),
(134099, '3.40.5.50-FF-000006', NULL, 'AGAP010018-PA', 23, NULL, NULL, 134099),
(134100, '3.30.40.10-FF-001008', NULL, 'Chromatin modification-related protein', 91, NULL, NULL, 134100),
(134101, '3.20.20.140-FF-000246', NULL, 'Cytosine deaminase', 182, NULL, NULL, 134101),
(134102, '3.30.420.10-FF-000470', NULL, NULL, 205, NULL, NULL, 134102),
(134103, '3.40.50.1390-FF-000003', NULL, 'DNA resolvase', 163, NULL, NULL, 134103),
(134104, '3.90.105.10-FF-000010', NULL, 'Molybdopterin molybdenumtransferase', 57, NULL, NULL, 134104),
(134105, '1.10.510.10-FF-003395', NULL, NULL, 307, NULL, NULL, 134105),
(134106, '2.60.40.10-FF-001493', NULL, 'KETtiN (Drosophila actin-binding) homolog', 103, NULL, NULL, 134106),
(134107, '3.40.50.1820-FF-000560', NULL, 'Glutactin', 532, NULL, NULL, 134107),
(134108, '1.20.58.150-FF-000009', NULL, 'Putative clathrin assembly protein', 133, NULL, NULL, 134108),
(134109, '3.80.10.10-FF-000622', NULL, 'NLR family, pyrin domain containing 1B, PWK/PhJ specific, allele 1', 187, NULL, NULL, 134109),
(134110, '1.10.238.10-FF-000602', NULL, 'Calcium-binding protein CML24', 63, NULL, NULL, 134110),
(134111, '3.80.10.10-FF-001111', NULL, 'Leucine rich repeat and phosphatase domain containing protein', 89, NULL, NULL, 134111),
(134112, '1.20.1560.10-FF-000713', NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 8', 287, NULL, NULL, 134112),
(134113, '1.20.1070.10-FF-001210', NULL, 'Olfactory receptor 51J1', 102, NULL, NULL, 134113),
(134114, '1.20.1070.10-FF-002194', NULL, 'Uncharacterized protein', 314, NULL, NULL, 134114),
(134115, '1.20.58.2140-FF-000009', NULL, 'DNA-binding protein translin homolog', 200, NULL, NULL, 134115),
(134116, '3.20.20.80-FF-000825', NULL, 'Uncharacterized protein', 55, NULL, NULL, 134116),
(134117, '1.20.120.1760-FF-000026', NULL, 'ethanolaminephosphotransferase 1 isoform X1', 206, NULL, NULL, 134117),
(134118, '1.25.40.20-FF-000067', NULL, 'ankyrin repeat domain-containing protein 17 isoform X3', 69, NULL, NULL, 134118),
(134119, '3.40.50.360-FF-000117', NULL, 'Rubredoxin:oxygen/nitric oxide oxidoreductase', 153, NULL, NULL, 134119),
(134120, '1.20.1070.10-FF-000592', NULL, 'Platelet-activating factor receptor', 302, NULL, NULL, 134120),
(134121, '2.10.25.10-FF-000521', NULL, 'Neurogenic locus notch protein 1', 38, NULL, NULL, 134121),
(134122, '3.30.450.20-FF-000660', NULL, 'Diguanylate cyclase with PAS/PAC sensor', 113, NULL, NULL, 134122),
(134123, '2.170.210.10-FF-000003', NULL, 'DNA repair protein XRCC4', 101, NULL, NULL, 134123),
(134124, '3.30.160.60-FF-000323', NULL, 'zinc finger protein AEBP2', 30, NULL, NULL, 134124),
(134125, '3.30.160.60-FF-005646', NULL, NULL, 24, NULL, NULL, 134125),
(134126, '2.30.29.30-FF-001153', NULL, 'Ras association (RalGDS/AF-6) and pleckstrin homology domains 1', 110, NULL, NULL, 134126),
(134127, '1.25.40.10-FF-002695', NULL, 'Uncharacterized protein', 134, NULL, NULL, 134127),
(134128, '3.30.420.10-FF-000722', NULL, NULL, 73, NULL, NULL, 134128),
(134129, '2.60.120.200-FF-000733', NULL, 'Uncharacterized protein', 206, NULL, NULL, 134129),
(134130, '1.20.1410.10-FF-000040', NULL, 'Predicted protein', 186, NULL, NULL, 134130),
(134131, '3.60.40.10-FF-000361', NULL, 'Predicted protein', 290, NULL, NULL, 134131),
(134132, '4.10.410.10-FF-000065', NULL, 'Hedgehog interacting protein-like protein', 60, NULL, NULL, 134132);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(134133, '3.30.160.380-FF-000008', NULL, 'DsRNA-specific nuclease dicer and related ribonuclease', 102, NULL, NULL, 134133),
(134134, '2.40.50.150-FF-000024', NULL, 'DNA-directed RNA polymerase subunit 2', 127, NULL, NULL, 134134),
(134135, '3.40.50.300-FF-007597', NULL, 'Predicted protein', 165, NULL, NULL, 134135),
(134136, '2.30.42.10-FF-000088', NULL, 'MAGUK p55 subfamily member 5', 88, NULL, NULL, 134136),
(134137, '3.40.50.12160-FF-000030', NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase', 133, NULL, NULL, 134137),
(134138, '1.25.10.70-FF-000007', NULL, 'Nup188p', 304, NULL, NULL, 134138),
(134139, '1.10.10.10-FF-001613', NULL, 'Uncharacterized protein', 97, NULL, NULL, 134139),
(134140, '1.10.3730.10-FF-000010', NULL, 'Pyrroline-5-carboxylate reductase', 104, NULL, NULL, 134140),
(134141, '2.60.40.10-FF-003544', NULL, NULL, 111, NULL, NULL, 134141),
(134142, '3.40.50.300-FF-001667', NULL, 'Rab family gtpase', 194, NULL, NULL, 134142),
(134143, '2.130.10.10-FF-005068', NULL, 'Uncharacterized protein', 271, NULL, NULL, 134143),
(134144, '3.30.1490.20-FF-000066', NULL, 'Uncharacterized protein', 49, NULL, NULL, 134144),
(134145, '3.20.20.70-FF-000345', NULL, 'Orotidine 5''-phosphate decarboxylase', 226, NULL, NULL, 134145),
(134146, '3.40.50.2300-FF-001305', NULL, NULL, 124, NULL, NULL, 134146),
(134147, '2.40.160.210-FF-000001', NULL, 'Acyl-CoA thioesterase II', 286, NULL, NULL, 134147),
(134148, '3.90.640.90-FF-000024', NULL, 'Uncharacterized protein', 109, NULL, NULL, 134148),
(134149, '3.30.70.940-FF-000027', NULL, 'KOW motif family protein', 98, NULL, NULL, 134149),
(134150, '3.40.50.150-FF-001369', NULL, NULL, 179, NULL, NULL, 134150),
(134151, '1.25.40.10-FF-003313', NULL, 'Pentatricopeptide repeat-containing protein At4g37170', 140, NULL, NULL, 134151),
(134152, '1.25.40.270-FF-000008', NULL, 'Uncharacterized protein', 156, NULL, NULL, 134152),
(134153, '3.40.50.2300-FF-001092', NULL, NULL, 157, NULL, NULL, 134153),
(134154, '1.25.10.50-FF-000001', NULL, 'DNA mismatch repair protein HSM3', 304, NULL, NULL, 134154),
(134155, '2.60.120.10-FF-000062', NULL, 'Lysophospholipase NTE1', 119, NULL, NULL, 134155),
(134156, '3.40.50.300-FF-007608', NULL, 'ABC Transporter family', 159, NULL, NULL, 134156),
(134157, '2.60.40.1390-FF-000016', NULL, 'Uncharacterized protein', 83, NULL, NULL, 134157),
(134158, '2.130.10.10-FF-001268', NULL, 'Protein ROOT INITIATION DEFECTIVE 3', 74, NULL, NULL, 134158),
(134159, '1.20.120.20-FF-000027', NULL, 'Elastin microfibril interfacer 1', 192, NULL, NULL, 134159),
(134160, '1.25.40.10-FF-001711', NULL, 'Pentatricopeptide repeat-containing protein At2g31400, chloroplastic', 133, NULL, NULL, 134160),
(134161, '3.40.50.720-FF-002384', NULL, 'Probable oxidoreductase', 148, NULL, NULL, 134161),
(134162, '2.60.40.10-FF-002015', NULL, 'Jitterbug, isoform F', 97, NULL, NULL, 134162),
(134163, '3.40.710.10-FF-000085', NULL, 'Penicillin-binding protein 1A', 356, NULL, NULL, 134163),
(134164, '3.90.1420.10-FF-000011', NULL, 'Plastid transcriptionally active 14', 121, NULL, NULL, 134164),
(134165, '3.20.20.105-FF-000010', NULL, 'Queuine tRNA-ribosyltransferase accessory subunit 2', 374, NULL, NULL, 134165),
(134166, '1.25.10.10-FF-001563', NULL, 'Uncharacterized protein', 141, NULL, NULL, 134166),
(134167, '1.25.40.250-FF-000002', NULL, 'Eukaryotic translation initiation factor 3 subunit K', 117, NULL, NULL, 134167),
(134168, '1.20.1250.20-FF-000693', NULL, 'AmpG permease', 212, NULL, NULL, 134168),
(134169, '1.20.58.2220-FF-000050', NULL, 'Uncharacterized protein', 208, NULL, NULL, 134169),
(134170, '1.20.1070.10-FF-000737', NULL, 'Uncharacterized protein', 318, NULL, NULL, 134170),
(134171, '1.20.1070.10-FF-000485', NULL, 'alpha-2A adrenergic receptor', 153, NULL, NULL, 134171),
(134172, '3.40.50.720-FF-002529', NULL, 'Methylenetetrahydrofolate dehydrogenase (NADP+ dependent) 1 like', 94, NULL, NULL, 134172),
(134173, '1.10.510.10-FF-001938', NULL, NULL, 77, NULL, NULL, 134173),
(134174, '1.10.10.200-FF-000008', NULL, 'Probable transcriptional regulatory protein HP_0162', 63, NULL, NULL, 134174);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(134175, '3.30.60.30-FF-000150', NULL, 'Uncharacterized protein', 62, NULL, NULL, 134175),
(134176, '3.90.190.10-FF-000095', NULL, 'Unplaced genomic scaffold supercont1.9, whole genome shotgun sequence', 188, NULL, NULL, 134176),
(134177, '1.25.40.10-FF-003728', NULL, 'Uncharacterized protein', 320, NULL, NULL, 134177),
(134178, '3.30.342.10-FF-000029', NULL, 'DNA polymerase', 142, NULL, NULL, 134178),
(134179, '3.40.50.300-FF-007182', NULL, 'Shikimate kinase', 171, NULL, NULL, 134179),
(134180, '3.80.10.10-FF-002494', NULL, 'GPR insulin like receptor 1', 120, NULL, NULL, 134180),
(134181, '1.20.140.10-FF-000132', NULL, 'Acyl-CoA dehydrogenase short chain', 112, NULL, NULL, 134181),
(134182, '1.10.630.10-FF-000469', NULL, 'Putative cytochrome P450 superfamily protein', 244, NULL, NULL, 134182),
(134183, '3.40.50.150-FF-001476', NULL, NULL, 129, NULL, NULL, 134183),
(134184, '3.30.365.10-FF-000071', NULL, 'Uncharacterized protein', 142, NULL, NULL, 134184),
(134185, '1.10.3380.10-FF-000011', NULL, 'Translocation protein SEC63', 158, NULL, NULL, 134185),
(134186, '2.40.50.140-FF-001022', NULL, NULL, 48, NULL, NULL, 134186),
(134187, '2.60.40.10-FF-005197', NULL, NULL, 92, NULL, NULL, 134187),
(134188, '1.20.120.450-FF-000003', NULL, 'TIGR03084 family protein', 144, NULL, NULL, 134188),
(134189, '1.10.10.10-FF-000995', NULL, 'Ribosomal protein', 41, NULL, NULL, 134189),
(134190, '2.130.10.30-FF-000083', NULL, NULL, 94, NULL, NULL, 134190),
(134191, '2.120.10.80-FF-000120', NULL, 'kelch domain-containing protein 8B', 92, NULL, NULL, 134191),
(134192, '2.60.40.420-FF-000239', NULL, 'Uncharacterized protein', 114, NULL, NULL, 134192),
(134193, '1.10.287.70-FF-000565', NULL, 'Voltage-gated Ca2+ channel, alpha subunit', 126, NULL, NULL, 134193),
(134194, '2.60.40.60-FF-000063', NULL, 'protocadherin-15 isoform X1', 101, NULL, NULL, 134194),
(134195, '3.30.200.20-FF-001125', NULL, 'Serine/threonine receptor-like kinase NFP', 100, NULL, NULL, 134195),
(134196, '1.10.287.70-FF-000256', NULL, 'TWiK family of potassium channels', 309, NULL, NULL, 134196),
(134197, '2.130.10.10-FF-003415', NULL, 'eukaryotic translation initiation factor 2-alpha kinase 3', 185, NULL, NULL, 134197),
(134198, '2.60.40.10-FF-001829', NULL, 'Interleukin-21 receptor', 99, NULL, NULL, 134198),
(134199, '3.90.640.10-FF-000057', NULL, 'Actin-related protein 6', 71, NULL, NULL, 134199),
(134200, '3.90.1200.10-FF-000006', NULL, 'Protein-ribulosamine 3-kinase, chloroplastic', 199, NULL, NULL, 134200),
(134201, '3.30.70.330-FF-002099', NULL, NULL, 122, NULL, NULL, 134201),
(134202, '3.40.50.300-FF-003921', NULL, 'GD15936', 203, NULL, NULL, 134202),
(134203, '3.40.720.10-FF-000125', NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase', 73, NULL, NULL, 134203),
(134204, '1.10.10.1940-FF-000007', NULL, 'PHAryngeal gland Toxin-related', 44, NULL, NULL, 134204),
(134205, '3.10.20.30-FF-000103', NULL, NULL, 39, NULL, NULL, 134205),
(134206, '1.10.10.10-FF-000888', NULL, 'Anaphase-promoting complex subunit 2', 73, NULL, NULL, 134206),
(134207, '3.40.50.620-FF-000471', NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', 193, NULL, NULL, 134207),
(134208, '2.60.120.620-FF-000140', NULL, 'Uncharacterized protein', 223, NULL, NULL, 134208),
(134209, '3.30.710.10-FF-000368', NULL, 'Uncharacterized protein', 90, NULL, NULL, 134209),
(134210, '1.10.287.470-FF-000062', NULL, 'RND family efflux transporter, MFP subunit', 60, NULL, NULL, 134210),
(134211, '2.40.290.10-FF-000016', NULL, 'Protein Ku', 182, NULL, NULL, 134211),
(134212, '2.130.10.10-FF-003522', NULL, 'Elongator complex protein 2', 181, NULL, NULL, 134212),
(134213, '3.90.520.10-FF-000003', NULL, 'Mothers against decapentaplegic homolog', 117, NULL, NULL, 134213),
(134214, '1.50.40.10-FF-000028', NULL, 'Solute carrier family 25 member 33', 124, NULL, NULL, 134214),
(134215, '1.25.40.10-FF-004729', NULL, 'Crooked neck protein-related protein', 84, NULL, NULL, 134215),
(134216, '4.10.280.10-FF-000048', NULL, 'DNA-binding protein inhibitor ID-4', 63, NULL, NULL, 134216),
(134217, '2.60.40.10-FF-000110', NULL, 'Ephrin type-B receptor 2', 88, NULL, NULL, 134217);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(134218, '3.90.550.10-FF-000302', NULL, 'YALI0B09669p', 199, NULL, NULL, 134218),
(134219, '3.40.50.620-FF-000780', NULL, 'Choline-phosphate cytidylyltransferase 2', 92, NULL, NULL, 134219),
(134220, '1.25.40.10-FF-005191', NULL, 'Uncharacterized protein', 226, NULL, NULL, 134220),
(134221, '1.10.10.540-FF-000003', NULL, 'UV excision repair protein RAD23', 51, NULL, NULL, 134221),
(134222, '3.40.50.300-FF-005719', NULL, 'Dicer Related Helicase', 163, NULL, NULL, 134222),
(134223, '3.90.1290.10-FF-000051', NULL, 'Uncharacterized protein', 127, NULL, NULL, 134223),
(134224, '1.25.40.120-FF-000093', NULL, 'Rab geranylgeranyl transferase like protein', 202, NULL, NULL, 134224),
(134225, '1.10.10.60-FF-001257', NULL, NULL, 62, NULL, NULL, 134225),
(134226, '2.102.10.10-FF-000022', NULL, 'Rieske Fe-S domain containing', 59, NULL, NULL, 134226),
(134227, '3.10.20.360-FF-000011', NULL, NULL, 119, NULL, NULL, 134227),
(134228, '1.20.58.60-FF-000675', NULL, 'Nesprin-1', 182, NULL, NULL, 134228),
(134229, '2.130.10.10-FF-003724', NULL, 'Actin-related protein 2/3 complex subunit', 339, NULL, NULL, 134229),
(134230, '1.20.58.1440-FF-000001', NULL, 'Dsl1p', 98, NULL, NULL, 134230),
(134231, '1.10.510.10-FF-001523', NULL, 'MAP kinase-activated protein kinase mak-1', 198, NULL, NULL, 134231),
(134232, '3.30.530.20-FF-000115', NULL, 'StAR-related lipid transfer protein 7, mitochondrial', 208, NULL, NULL, 134232),
(134233, '3.40.50.10190-FF-000170', NULL, 'Protein CBG13622', 87, NULL, NULL, 134233),
(134234, '3.30.200.20-FF-000130', NULL, 'STE20-related kinase adapter protein alpha', 89, NULL, NULL, 134234),
(134235, '3.80.10.10-FF-000728', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 228, NULL, NULL, 134235),
(134236, '1.20.1270.50-FF-000012', NULL, 'Uncharacterized protein', 74, NULL, NULL, 134236),
(134237, '3.30.2290.10-FF-000008', NULL, 'Peptidase U62 modulator of DNA gyrase', 188, NULL, NULL, 134237),
(134238, '3.30.1330.30-FF-000153', NULL, 'Protein pelota homolog', 55, NULL, NULL, 134238),
(134239, '3.30.70.330-FF-003026', NULL, NULL, 58, NULL, NULL, 134239),
(134240, '3.30.450.20-FF-000328', NULL, 'Accessory colonization factor AcfB', 102, NULL, NULL, 134240),
(134241, '2.130.10.10-FF-001577', NULL, 'WGS project CABT00000000 data, contig 2.26', 289, NULL, NULL, 134241),
(134242, '3.40.30.10-FF-000720', NULL, 'Predicted protein', 78, NULL, NULL, 134242),
(134243, '1.25.10.10-FF-003474', NULL, 'Uncharacterized protein', 197, NULL, NULL, 134243),
(134244, '4.10.240.10-FF-000164', NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', 68, NULL, NULL, 134244),
(134245, '1.10.510.10-FF-003069', NULL, NULL, 204, NULL, NULL, 134245),
(134246, '2.60.120.920-FF-000016', NULL, 'neuralized-like protein 4 isoform X2', 165, NULL, NULL, 134246),
(134247, '3.40.50.1820-FF-001032', NULL, 'Acetyl xylan esterase-related protein', 159, NULL, NULL, 134247),
(134248, '1.10.510.10-FF-002091', NULL, NULL, 108, NULL, NULL, 134248),
(134249, '2.60.40.10-FF-003292', NULL, 'Netrin receptor unc-5', 91, NULL, NULL, 134249),
(134250, '3.30.930.10-FF-000109', NULL, 'Seryl-tRNA synthetase, cytoplasmic', 340, NULL, NULL, 134250),
(134251, '3.40.50.300-FF-001976', NULL, 'Replication factor c protein, putative', 182, NULL, NULL, 134251),
(134252, '1.25.40.10-FF-003509', NULL, 'Serine/threonine-protein kinase TOR', 350, NULL, NULL, 134252),
(134253, '3.30.40.10-FF-001452', NULL, 'Predicted protein', 118, NULL, NULL, 134253),
(134254, '3.40.1360.10-FF-000017', NULL, 'Meiotic recombination protein SPO11, variant 2', 217, NULL, NULL, 134254),
(134255, '1.10.630.10-FF-000576', NULL, 'Uncharacterized protein', 307, NULL, NULL, 134255),
(134256, '1.50.10.10-FF-000173', NULL, 'Predicted protein', 407, NULL, NULL, 134256),
(134257, '1.25.40.10-FF-001604', NULL, 'Coatomer subunit epsilon', 318, NULL, NULL, 134257),
(134258, '2.60.120.970-FF-000025', NULL, 'Transforming growth factor beta', 275, NULL, NULL, 134258),
(134259, '3.30.160.60-FF-005450', NULL, NULL, 36, NULL, NULL, 134259),
(134260, '3.30.70.100-FF-000124', NULL, NULL, 84, NULL, NULL, 134260);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(134261, '3.40.50.10490-FF-000153', NULL, NULL, 122, NULL, NULL, 134261),
(134262, '3.30.160.60-FF-003757', NULL, NULL, 19, NULL, NULL, 134262),
(134263, '1.20.120.350-FF-000052', NULL, 'polycystic kidney disease 2-like 1 protein isoform X1', 87, NULL, NULL, 134263),
(134264, '3.40.20.10-FF-000113', NULL, 'Si:dkey-40c11.2', 133, NULL, NULL, 134264),
(134265, '3.30.980.10-FF-000045', NULL, 'Uncharacterized protein', 119, NULL, NULL, 134265),
(134266, '1.20.1610.10-FF-000021', NULL, 'Putative alpha-1,2-mannosidase', 156, NULL, NULL, 134266),
(134267, '3.80.10.10-FF-004528', NULL, 'Uncharacterized protein', 248, NULL, NULL, 134267),
(134268, '3.40.50.300-FF-001448', NULL, 'Glutamine ABC transporter ATP-binding protein', 223, NULL, NULL, 134268),
(134269, '1.20.140.160-FF-000004', NULL, 'RNA polymerase sigma factor SigB', 148, NULL, NULL, 134269),
(134270, '3.80.10.10-FF-002746', NULL, 'F-box protein At5g07670', 218, NULL, NULL, 134270),
(134271, '1.20.58.150-FF-000026', NULL, NULL, 147, NULL, NULL, 134271),
(134272, '1.25.10.10-FF-002867', NULL, 'Predicted protein', 157, NULL, NULL, 134272),
(134273, '3.60.10.10-FF-000224', NULL, 'Putative inositol-1,4,5-trisphosphate (IP3) 5-phosphatase', 420, NULL, NULL, 134273),
(134274, '1.50.40.10-FF-000141', NULL, 'Mitochondrial carrier protein MTM1', 330, NULL, NULL, 134274),
(134275, '2.60.40.10-FF-001599', NULL, 'Uncharacterized protein, isoform C', 94, NULL, NULL, 134275),
(134276, '3.10.580.10-FF-000159', NULL, 'AMP-activated protein kinase, gamma regulatory subunit', 193, NULL, NULL, 134276),
(134277, '1.25.40.1030-FF-000014', NULL, 'Protein transport protein SEC31', 201, NULL, NULL, 134277),
(134278, '3.30.160.60-FF-000104', NULL, 'Transcriptional repressor protein YY1', 32, NULL, NULL, 134278),
(134279, '3.40.630.30-FF-000146', NULL, 'GNAT transcription factor', 118, NULL, NULL, 134279),
(134280, '3.40.50.1010-FF-000159', NULL, NULL, 183, NULL, NULL, 134280),
(134281, '2.60.40.10-FF-005904', NULL, NULL, 67, NULL, NULL, 134281),
(134282, '1.25.40.470-FF-000085', NULL, 'Intraflagellar transport protein 122 homolog', 176, NULL, NULL, 134282),
(134283, '2.60.120.10-FF-000371', NULL, 'Crp/Fnr family transcriptional regulator', 132, NULL, NULL, 134283),
(134284, '1.25.40.1040-FF-000017', NULL, 'Unplaced genomic scaffold supercont1.217, whole genome shotgun sequence', 374, NULL, NULL, 134284),
(134285, '2.60.40.150-FF-000214', NULL, 'Toll-interacting protein', 125, NULL, NULL, 134285),
(134286, '1.20.1250.20-FF-001311', NULL, 'Uncharacterized protein', 192, NULL, NULL, 134286),
(134287, '2.60.120.330-FF-000160', NULL, 'Uncharacterized protein', 351, NULL, NULL, 134287),
(134288, '2.30.30.380-FF-000052', NULL, 'Novel protein containing Zn-finger in Ran binding protein and others domain and 2 GRF zinc finger domains', 52, NULL, NULL, 134288),
(134289, '2.60.20.10-FF-000002', NULL, 'Crystallin, beta B2', 92, NULL, NULL, 134289),
(134290, '3.60.40.10-FF-000248', NULL, 'Stage II sporulation E family protein', 243, NULL, NULL, 134290),
(134291, '1.10.630.10-FF-000267', NULL, 'Cytochrome P450 family 39 subfamily A member 1', 452, NULL, NULL, 134291),
(134292, '3.20.20.80-FF-000680', NULL, 'Predicted protein', 327, NULL, NULL, 134292),
(134293, '3.10.129.10-FF-000286', NULL, 'Polyketide synthase', 142, NULL, NULL, 134293),
(134294, '3.20.20.140-FF-000353', NULL, 'Dihydropyrimidinase, putative', 306, NULL, NULL, 134294),
(134295, '3.40.1170.10-FF-000003', NULL, 'DNA mismatch repair protein', 119, NULL, NULL, 134295),
(134296, '2.130.10.10-FF-002797', NULL, 'Uncharacterized protein', 197, NULL, NULL, 134296),
(134297, '3.30.70.890-FF-000063', NULL, 'Mevalonate kinase', 136, NULL, NULL, 134297),
(134298, '3.30.9.10-FF-000121', NULL, 'FAD dependent oxidoreductase', 176, NULL, NULL, 134298),
(134299, '3.30.505.10-FF-000060', NULL, 'Tyrosine-protein kinase', 121, NULL, NULL, 134299),
(134300, '2.40.50.120-FF-000066', NULL, 'Uncharacterized protein', 90, NULL, NULL, 134300),
(134301, '1.10.472.140-FF-000003', NULL, 'Retinoblastoma-related protein 1', 159, NULL, NULL, 134301);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(134302, '4.10.1000.10-FF-000082', NULL, 'Uncharacterized protein', 73, NULL, NULL, 134302),
(134303, '3.65.10.20-FF-000025', NULL, 'Uncharacterized protein', 217, NULL, NULL, 134303),
(134304, '2.40.50.140-FF-001241', NULL, NULL, 133, NULL, NULL, 134304),
(134305, '1.10.510.10-FF-003872', NULL, NULL, 93, NULL, NULL, 134305),
(134306, '3.10.20.90-FF-000115', NULL, 'tubulin-specific chaperone cofactor E-like protein', 84, NULL, NULL, 134306),
(134307, '3.20.20.60-FF-000033', NULL, 'CoA ester lyase', 271, NULL, NULL, 134307),
(134308, '3.20.20.80-FF-000348', NULL, 'Beta-(1-3)-glucosyl transferase', 103, NULL, NULL, 134308),
(134309, '3.10.450.350-FF-000003', NULL, 'Cell envelope opacity-associated proteinA', 92, NULL, NULL, 134309),
(134310, '3.30.930.10-FF-000098', NULL, 'Phenylalanine--tRNA ligase', 280, NULL, NULL, 134310),
(134311, '2.40.128.20-FF-000053', NULL, 'Alpha-1-microglobulin/bikunin, like', 68, NULL, NULL, 134311),
(134312, '3.20.20.80-FF-000039', NULL, 'Glucosidase, alpha neutral C', 172, NULL, NULL, 134312),
(134313, '3.30.160.60-FF-003196', NULL, 'Zinc finger protein 561', 29, NULL, NULL, 134313),
(134314, '2.70.160.11-FF-000018', NULL, 'Protein arginine N-methyltransferase', 210, NULL, NULL, 134314),
(134315, '1.20.1560.10-FF-000477', NULL, 'Iron ABC transporter', 315, NULL, NULL, 134315),
(134316, '1.20.1280.50-FF-000080', NULL, 'F-box protein SKIP1', 43, NULL, NULL, 134316),
(134317, '1.20.1270.10-FF-000051', NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', 106, NULL, NULL, 134317),
(134318, '3.40.50.1010-FF-000070', NULL, 'Ribonuclease VapC', 124, NULL, NULL, 134318),
(134319, '3.90.320.10-FF-000038', NULL, 'RecBCD enzyme subunit RecB', 303, NULL, NULL, 134319),
(134320, '1.25.40.800-FF-000010', NULL, 'Uncharacterized protein', 180, NULL, NULL, 134320),
(134321, '1.10.1370.30-FF-000010', NULL, 'Angiotensin-converting enzyme', 277, NULL, NULL, 134321),
(134322, '3.30.470.20-FF-000184', NULL, 'Biotin carboxylase', 315, NULL, NULL, 134322),
(134323, '1.25.40.10-FF-000986', NULL, 'Os07g0203900 protein', 158, NULL, NULL, 134323),
(134324, '3.20.20.70-FF-000036', NULL, 'Lipoyl synthase, mitochondrial', 210, NULL, NULL, 134324),
(134325, '2.30.30.490-FF-000085', NULL, 'Origin recognition complex subunit 1', 160, NULL, NULL, 134325),
(134326, '3.90.640.10-FF-000276', NULL, 'Uncharacterized protein', 96, NULL, NULL, 134326),
(134327, '1.20.5.4980-FF-000001', NULL, 'Centromere protein X', 39, NULL, NULL, 134327),
(134328, '3.80.10.10-FF-000476', NULL, 'Si:dkey-279j5.1', 126, NULL, NULL, 134328),
(134329, '3.40.50.2300-FF-000001', NULL, 'DNA-binding response regulator PhoB', 80, NULL, NULL, 134329),
(134330, '2.10.25.10-FF-000740', NULL, 'Low-density lipoprotein receptor domain class A', 39, NULL, NULL, 134330),
(134331, '3.40.250.10-FF-000061', NULL, 'Rhodanese-like protein', 126, NULL, NULL, 134331),
(134332, '1.10.287.70-FF-000037', NULL, 'Glutamate receptor', 131, NULL, NULL, 134332),
(134333, '3.40.50.720-FF-000731', NULL, 'N-acetyl-gamma-glutamyl-phosphate reductase', 163, NULL, NULL, 134333),
(134334, '1.20.1250.20-FF-001530', NULL, 'Membrane-associated transporter protein', 450, NULL, NULL, 134334),
(134335, '1.25.10.10-FF-001782', NULL, 'Predicted protein', 640, NULL, NULL, 134335),
(134336, '4.10.970.10-FF-000011', NULL, 'Cku-70', 104, NULL, NULL, 134336),
(134337, '3.30.160.60-FF-001740', NULL, 'zinc finger protein 596 isoform X1', 25, NULL, NULL, 134337),
(134338, '1.20.120.1910-FF-000015', NULL, 'Cysteine--tRNA ligase', 157, NULL, NULL, 134338),
(134339, '2.10.109.10-FF-000069', NULL, 'Signal peptidase I', 134, NULL, NULL, 134339),
(134340, '2.60.40.10-FF-000200', NULL, 'cell adhesion molecule 1 isoform X1', 92, NULL, NULL, 134340),
(134341, '3.20.20.80-FF-000371', NULL, 'Glucosylceramidase', 257, NULL, NULL, 134341),
(134342, '4.10.270.10-FF-000003', NULL, 'IQ motif containing GTPase activating protein 1', 51, NULL, NULL, 134342),
(134343, '3.40.718.10-FF-000075', NULL, 'Isopropylmalate dehydrogenase1', 84, NULL, NULL, 134343),
(134344, '1.20.1560.10-FF-000819', NULL, 'Uncharacterized protein', 81, NULL, NULL, 134344);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(134345, '3.40.50.300-FF-001903', NULL, 'Obg-like ATPase 1', 34, NULL, NULL, 134345),
(134346, '3.30.70.3270-FF-000014', NULL, 'NADH dehydrogenase subunit I (NuoI)', 123, NULL, NULL, 134346),
(134347, '3.40.720.10-FF-000344', NULL, 'Uncharacterized protein', 79, NULL, NULL, 134347),
(134348, '3.40.50.300-FF-003691', NULL, 'Dynein heavy chain', 168, NULL, NULL, 134348),
(134349, '3.40.50.10190-FF-000057', NULL, 'Transcription coactivator', 98, NULL, NULL, 134349),
(134350, '4.10.280.10-FF-000032', NULL, 'Transcription factor bHLH123 family', 63, NULL, NULL, 134350),
(134351, '2.60.120.970-FF-000115', NULL, 'transforming growth factor beta superfamily signaling ligand isoform X1', 74, NULL, NULL, 134351),
(134352, '2.130.10.10-FF-001504', NULL, 'Polyadenylation factor subunit, putative', 242, NULL, NULL, 134352),
(134353, '1.10.510.10-FF-001377', NULL, 'Serine/threonine protein kinase', 168, NULL, NULL, 134353),
(134354, '3.20.20.70-FF-000126', NULL, 'Nicotinate phosphoribosyltransferase', 66, NULL, NULL, 134354),
(134355, '2.130.10.30-FF-000173', NULL, NULL, 302, NULL, NULL, 134355),
(134356, '3.40.50.300-FF-003449', NULL, 'Uncharacterized protein', 256, NULL, NULL, 134356),
(134357, '3.10.50.40-FF-000153', NULL, 'Uncharacterized protein', 90, NULL, NULL, 134357),
(134358, '1.10.630.10-FF-000503', NULL, 'Pentalenene oxygenase', 439, NULL, NULL, 134358),
(134359, '3.80.10.10-FF-002275', NULL, 'Centrosomal protein of 97 kDa', 90, NULL, NULL, 134359),
(134360, '3.50.50.60-FF-001219', NULL, 'Flavin-containing monooxygenase', 272, NULL, NULL, 134360),
(134361, '3.40.1110.10-FF-000336', NULL, NULL, 115, NULL, NULL, 134361),
(134362, '3.30.200.20-FF-001434', NULL, 'Homoserine kinase', 101, NULL, NULL, 134362),
(134363, '1.10.150.120-FF-000019', NULL, NULL, 82, NULL, NULL, 134363),
(134364, '3.20.20.60-FF-000123', NULL, 'Malate synthase', 167, NULL, NULL, 134364),
(134365, '1.20.1110.10-FF-000073', NULL, 'Calcium-transporting ATPase', 408, NULL, NULL, 134365),
(134366, '1.20.1250.10-FF-000139', NULL, NULL, 62, NULL, NULL, 134366),
(134367, '2.10.25.10-FF-000627', NULL, 'Brevican core protein', 37, NULL, NULL, 134367),
(134368, '3.30.160.20-FF-000008', NULL, 'interleukin enhancer-binding factor 3 isoform X2', 98, NULL, NULL, 134368),
(134369, '1.10.150.50-FF-000118', NULL, 'Protein CBR-TAG-97', 74, NULL, NULL, 134369),
(134370, '2.60.200.40-FF-000004', NULL, 'Diacylglycerol kinase', 166, NULL, NULL, 134370),
(134371, '1.20.1250.20-FF-000384', NULL, 'Solute carrier organic anion transporter family member', 112, NULL, NULL, 134371),
(134372, '2.60.40.1730-FF-000017', NULL, 'aminopeptidase RNPEPL1 isoform X2', 191, NULL, NULL, 134372),
(134373, '3.50.50.60-FF-001461', NULL, 'Uncharacterized protein', 74, NULL, NULL, 134373),
(134374, '3.30.450.20-FF-000637', NULL, 'Sensor histidine kinase response regulator, PAS and PAS domain-containing', 107, NULL, NULL, 134374),
(134375, '2.60.120.10-FF-000713', NULL, 'Uncharacterized protein', 149, NULL, NULL, 134375),
(134376, '1.10.510.10-FF-004125', NULL, NULL, 95, NULL, NULL, 134376),
(134377, '1.10.437.10-FF-000059', NULL, 'BH3 interacting domain death agonist', 185, NULL, NULL, 134377),
(134378, '2.30.29.30-FF-000765', NULL, 'Uncharacterized protein', 102, NULL, NULL, 134378),
(134379, '3.40.50.300-FF-007288', NULL, 'Predicted protein', 153, NULL, NULL, 134379),
(134380, '3.40.50.1820-FF-001251', NULL, 'Predicted protein', 315, NULL, NULL, 134380),
(134381, '2.30.30.140-FF-000323', NULL, 'Uncharacterized protein', 39, NULL, NULL, 134381),
(134382, '2.60.40.10-FF-005652', NULL, NULL, 90, NULL, NULL, 134382),
(134383, '1.25.40.10-FF-003622', NULL, 'Pentatricopeptide repeat-containing protein At1g74600, chloroplastic', 103, NULL, NULL, 134383),
(134384, '3.30.450.60-FF-000059', NULL, 'AP complex subunit sigma', 140, NULL, NULL, 134384),
(134385, '4.10.400.10-FF-000261', NULL, 'LDL receptor protein 1, isoform F', 47, NULL, NULL, 134385),
(134386, '3.40.50.300-FF-005490', NULL, 'Type III restriction enzyme, res subunit', 193, NULL, NULL, 134386),
(134387, '3.30.70.360-FF-000062', NULL, 'N-carbamyl-L-amino acid amidohydrolase, putative', 114, NULL, NULL, 134387);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(134388, '3.40.190.10-FF-000797', NULL, 'Prephenate dehydratase', 85, NULL, NULL, 134388),
(134389, '1.20.120.850-FF-000016', NULL, 'Putative helicase swr1 protein', 74, NULL, NULL, 134389),
(134390, '3.90.660.10-FF-000075', NULL, NULL, 216, NULL, NULL, 134390),
(134391, '2.30.29.170-FF-000009', NULL, 'EF-hand domain (C-terminal)-containing 1', 120, NULL, NULL, 134391),
(134392, '1.10.510.10-FF-001832', NULL, 'CSNK1A1 isoform 9', 96, NULL, NULL, 134392),
(134393, '2.10.90.10-FF-000025', NULL, 'vascular endothelial growth factor C', 166, NULL, NULL, 134393),
(134394, '2.40.100.10-FF-000020', NULL, 'E3 SUMO-protein ligase RanBP2', 171, NULL, NULL, 134394),
(134395, '3.40.1110.10-FF-000426', NULL, NULL, 203, NULL, NULL, 134395),
(134396, '1.10.150.110-FF-000016', NULL, 'DNA-directed DNA/RNA polymerase mu', 94, NULL, NULL, 134396),
(134397, '2.40.50.140-FF-001128', NULL, NULL, 90, NULL, NULL, 134397),
(134398, '3.40.50.300-FF-005248', NULL, 'Gluconokinase', 190, NULL, NULL, 134398),
(134399, '3.40.50.2000-FF-000479', NULL, 'UDP-glycosyltransferase 76F2', 248, NULL, NULL, 134399),
(134400, '3.30.160.60-FF-005865', NULL, NULL, 56, NULL, NULL, 134400),
(134401, '1.10.260.30-FF-000008', NULL, 'Signal recognition particle 54 kDa protein', 130, NULL, NULL, 134401),
(134402, '1.20.1270.60-FF-000256', NULL, 'Rho-GTPase-activating protein 8', 196, NULL, NULL, 134402),
(134403, '3.30.160.60-FF-002431', NULL, 'Zinc finger protein 787', 25, NULL, NULL, 134403),
(134404, '1.20.1560.10-FF-000348', NULL, 'ABC transporter, putative', 328, NULL, NULL, 134404),
(134405, '1.20.1250.10-FF-000049', NULL, 'Interferon gamma', 146, NULL, NULL, 134405),
(134406, '3.40.50.12710-FF-000015', NULL, 'ORF416', 384, NULL, NULL, 134406),
(134407, '2.120.10.30-FF-000021', NULL, 'Sortilin-related receptor isoform A', 286, NULL, NULL, 134407),
(134408, '2.30.29.150-FF-000003', NULL, 'FACT complex subunit SPT16', 155, NULL, NULL, 134408),
(134409, '1.10.510.10-FF-001629', NULL, 'Putative serine/threonine-protein kinase', 199, NULL, NULL, 134409),
(134410, '3.90.1170.40-FF-000006', NULL, 'Molybdenum cofactor biosynthesis protein MoaE', 140, NULL, NULL, 134410),
(134411, '1.10.640.10-FF-000077', NULL, 'Uncharacterized protein', 365, NULL, NULL, 134411),
(134412, '3.30.160.60-FF-001594', NULL, 'ras-responsive element-binding protein 1 isoform X1', 27, NULL, NULL, 134412),
(134413, '1.10.390.10-FF-000006', NULL, 'Puromycin-sensitive aminopeptidase', 249, NULL, NULL, 134413),
(134414, '3.90.1170.30-FF-000003', NULL, 'Thymidine phosphorylase', 85, NULL, NULL, 134414),
(134415, '3.10.280.10-FF-000013', NULL, 'Uncharacterized protein', 204, NULL, NULL, 134415),
(134416, '1.10.520.10-FF-000023', NULL, 'Peroxidase', 157, NULL, NULL, 134416),
(134417, '3.10.129.10-FF-000196', NULL, 'Acyl-CoA thioester hydrolase', 146, NULL, NULL, 134417),
(134418, '2.30.30.280-FF-000005', NULL, 'tRNA-specific 2-thiouridylase MnmA', 61, NULL, NULL, 134418),
(134419, '1.25.10.10-FF-001872', NULL, 'Pumilio domain-containing protein', 141, NULL, NULL, 134419),
(134420, '2.60.40.10-FF-003853', NULL, NULL, 94, NULL, NULL, 134420),
(134421, '3.30.70.3170-FF-000006', NULL, 'Uncharacterized protein', 37, NULL, NULL, 134421),
(134422, '4.10.400.10-FF-000019', NULL, 'Low density lipoprotein receptor-related protein 1', 34, NULL, NULL, 134422),
(134423, '3.30.70.3160-FF-000003', NULL, 'Probable tRNA pseudouridine synthase D', 83, NULL, NULL, 134423),
(134424, '3.80.10.10-FF-002185', NULL, 'Uncharacterized protein', 110, NULL, NULL, 134424),
(134425, '3.30.450.50-FF-000056', NULL, 'Uncharacterized protein', 105, NULL, NULL, 134425),
(134426, '3.30.300.30-FF-000096', NULL, 'Nonribosomal peptide synthase GliP2', 98, NULL, NULL, 134426),
(134427, '3.40.50.720-FF-001080', NULL, 'Thiamine biosynthesis protein ThiF', 265, NULL, NULL, 134427),
(134428, '2.60.120.10-FF-000152', NULL, 'BnaA05g35160D protein', 99, NULL, NULL, 134428),
(134429, '3.30.160.60-FF-005556', NULL, NULL, 32, NULL, NULL, 134429),
(134430, '1.10.3090.10-FF-000016', NULL, 'Putative tRNA nucleotidyltransferase', 330, NULL, NULL, 134430);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(134431, '3.40.50.720-FF-000276', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', 198, NULL, NULL, 134431),
(134432, '2.60.120.200-FF-000587', NULL, 'EGF-like-domain, multiple 6', 163, NULL, NULL, 134432),
(134433, '2.40.50.90-FF-000091', NULL, 'Uncharacterized protein', 151, NULL, NULL, 134433),
(134434, '1.10.20.120-FF-000014', NULL, 'Predicted protein', 149, NULL, NULL, 134434),
(134435, '1.10.287.1060-FF-000009', NULL, 'ESAT-6-like protein', 94, NULL, NULL, 134435),
(134436, '2.60.40.10-FF-003398', NULL, NULL, 122, NULL, NULL, 134436),
(134437, '2.10.25.10-FF-000375', NULL, 'Slit guidance ligand 3', 37, NULL, NULL, 134437),
(134438, '1.25.40.180-FF-000116', NULL, 'Putative eukaryotic initiation factor 4a', 265, NULL, NULL, 134438),
(134439, '3.30.70.330-FF-000862', NULL, 'RNA-binding protein 1', 120, NULL, NULL, 134439),
(134440, '1.25.40.10-FF-001368', NULL, 'Pentatricopeptide repeat-containing protein At2g37320 family', 96, NULL, NULL, 134440),
(134441, '2.60.40.2300-FF-000008', NULL, 'Uncharacterized protein', 130, NULL, NULL, 134441),
(134442, '1.10.287.40-FF-000005', NULL, 'Seryl-tRNA synthetase 2, mitochondrial', 114, NULL, NULL, 134442),
(134443, '3.30.930.10-FF-000132', NULL, 'Phenylalanine--tRNA ligase beta subunit', 190, NULL, NULL, 134443),
(134444, '1.10.150.50-FF-000085', NULL, 'Liprin-beta', 98, NULL, NULL, 134444),
(134445, '3.30.160.60-FF-001285', NULL, 'zinc finger protein 574', 75, NULL, NULL, 134445),
(134446, '1.10.8.60-FF-000328', NULL, 'AAA family cell division control-like protein', 73, NULL, NULL, 134446),
(134447, '1.20.120.350-FF-000271', NULL, NULL, 93, NULL, NULL, 134447),
(134448, '2.60.40.10-FF-004016', NULL, NULL, 99, NULL, NULL, 134448),
(134449, '1.10.555.10-FF-000165', NULL, NULL, 211, NULL, NULL, 134449),
(134450, '3.90.810.10-FF-000014', NULL, 'Non-specific serine/threonine protein kinase', 41, NULL, NULL, 134450),
(134451, '1.20.930.10-FF-000018', NULL, 'Protein iws1 homolog', 144, NULL, NULL, 134451),
(134452, '3.40.50.10190-FF-000276', NULL, 'Uncharacterized protein', 63, NULL, NULL, 134452),
(134453, '2.30.29.30-FF-000911', NULL, 'Phosphoinositide phospholipase C', 122, NULL, NULL, 134453),
(134454, '3.40.50.620-FF-000577', NULL, 'Uncharacterized protein', 139, NULL, NULL, 134454),
(134455, '3.30.200.20-FF-000849', NULL, 'Os06g0692600 protein', 109, NULL, NULL, 134455),
(134456, '1.25.40.10-FF-001391', NULL, 'Tetratricopeptide repeat protein 21B', 119, NULL, NULL, 134456),
(134457, '1.25.40.20-FF-001394', NULL, 'Predicted protein', 55, NULL, NULL, 134457),
(134458, '3.30.160.60-FF-002212', NULL, 'Zinc finger protein 672', 34, NULL, NULL, 134458),
(134459, '1.10.60.10-FF-000003', NULL, 'HTH-type transcriptional regulator MntR', 69, NULL, NULL, 134459),
(134460, '4.10.1060.10-FF-000057', NULL, 'Ubiquitin thioesterase zranb1-B', 42, NULL, NULL, 134460),
(134461, '1.25.40.90-FF-000083', NULL, 'ENTH/VHS family protein', 72, NULL, NULL, 134461),
(134462, '3.80.10.10-FF-002527', NULL, 'Leucine rich repeats and immunoglobulin like domains 2', 160, NULL, NULL, 134462),
(134463, '2.130.10.10-FF-001471', NULL, 'Zinc finger protein 106', 146, NULL, NULL, 134463),
(134464, '2.30.310.10-FF-000004', NULL, 'Fibronectin-binding protein A', 166, NULL, NULL, 134464),
(134465, '3.40.50.2300-FF-000939', NULL, NULL, 175, NULL, NULL, 134465),
(134466, '3.30.390.80-FF-000009', NULL, 'Uncharacterized protein', 48, NULL, NULL, 134466),
(134467, '1.10.287.1040-FF-000003', NULL, 'Exodeoxyribonuclease 7 small subunit', 70, NULL, NULL, 134467),
(134468, '3.80.10.10-FF-001190', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 155, NULL, NULL, 134468),
(134469, '3.10.450.40-FF-000058', NULL, NULL, 69, NULL, NULL, 134469),
(134470, '3.30.390.60-FF-000003', NULL, 'Heat-inducible transcription repressor HrcA', 104, NULL, NULL, 134470),
(134471, '1.20.5.110-FF-000239', NULL, 'Uncharacterized protein', 62, NULL, NULL, 134471),
(134472, '3.90.380.10-FF-000014', NULL, 'Possible dioxygenase', 77, NULL, NULL, 134472),
(134473, '3.30.1330.80-FF-000011', NULL, 'Alpha-acetolactate decarboxylase', 123, NULL, NULL, 134473);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(134474, '2.60.40.60-FF-001058', NULL, 'Uncharacterized protein', 72, NULL, NULL, 134474),
(134475, '3.10.20.30-FF-000013', NULL, 'Adrenodoxin, mitochondrial', 120, NULL, NULL, 134475),
(134476, '2.60.120.590-FF-000018', NULL, 'ALKylated DNA repair protein AlkB homolog', 211, NULL, NULL, 134476),
(134477, '3.40.50.620-FF-000886', NULL, 'Valyl-tRNA synthetase', 100, NULL, NULL, 134477),
(134478, '3.40.50.410-FF-000155', NULL, 'Collagen, type VI, alpha 1', 203, NULL, NULL, 134478),
(134479, '1.25.40.10-FF-001149', NULL, 'Blast:Protein crooked neck', 182, NULL, NULL, 134479),
(134480, '1.20.1730.10-FF-000075', NULL, 'Uncharacterized protein', 335, NULL, NULL, 134480),
(134481, '2.60.40.10-FF-003763', NULL, NULL, 101, NULL, NULL, 134481),
(134482, '3.70.10.10-FF-000105', NULL, 'Checkpoint protein', 265, NULL, NULL, 134482),
(134483, '1.20.1560.10-FF-000039', NULL, 'Cysteine/glutathione ABC transporter permease/ATP-binding protein CydD', 331, NULL, NULL, 134483),
(134484, '2.130.10.10-FF-005214', NULL, 'Uncharacterized protein', 85, NULL, NULL, 134484),
(134485, '3.10.420.10-FF-000002', NULL, 'Protein-export protein SecB', 157, NULL, NULL, 134485),
(134486, '3.40.50.720-FF-000618', NULL, 'SUMO-activating enzyme subunit 2', 180, NULL, NULL, 134486),
(134487, '3.30.160.60-FF-001408', NULL, 'Zinc finger protein 260', 29, NULL, NULL, 134487),
(134488, '3.70.10.10-FF-000015', NULL, 'DNA polymerase sliding clamp', 245, NULL, NULL, 134488),
(134489, '3.60.40.10-FF-000052', NULL, 'Probable protein phosphatase 2C 34', 322, NULL, NULL, 134489),
(134490, '2.10.70.10-FF-000226', NULL, 'Uncharacterized protein', 68, NULL, NULL, 134490),
(134491, '2.10.220.10-FF-000221', NULL, 'Predicted protein', 109, NULL, NULL, 134491),
(134492, '1.25.40.10-FF-001059', NULL, 'Putative pentatricopeptide repeat-containing protein', 110, NULL, NULL, 134492),
(134493, '1.10.287.1490-FF-000115', NULL, 'Uncharacterized protein', 127, NULL, NULL, 134493),
(134494, '2.10.25.10-FF-000936', NULL, 'Zonadhesin', 39, NULL, NULL, 134494),
(134495, '2.60.200.30-FF-000001', NULL, 'NAD kinase', 137, NULL, NULL, 134495),
(134496, '2.40.40.20-FF-000046', NULL, 'AAA family ATPase', 89, NULL, NULL, 134496),
(134497, '3.30.70.330-FF-002879', NULL, NULL, 65, NULL, NULL, 134497),
(134498, '2.30.170.20-FF-000018', NULL, '60S ribosomal protein L24, putative', 37, NULL, NULL, 134498),
(134499, '1.10.287.130-FF-000089', NULL, 'Sensor histidine kinase', 84, NULL, NULL, 134499),
(134500, '3.40.50.720-FF-000837', NULL, 'Putative hydroxyacid dehydrogenase', 146, NULL, NULL, 134500),
(134501, '3.30.160.60-FF-005337', NULL, NULL, 69, NULL, NULL, 134501),
(134502, '3.40.50.720-FF-000585', NULL, 'Alanine dehydrogenase 1', 180, NULL, NULL, 134502),
(134503, '3.40.50.12160-FF-000007', NULL, 'Ribosomal protein S12 methylthiotransferase RimO', 130, NULL, NULL, 134503),
(134504, '2.10.25.10-FF-000594', NULL, 'cadherin-related tumor suppressor', 39, NULL, NULL, 134504),
(134505, '3.40.630.70-FF-000001', NULL, 'Leucyl/phenylalanyl-tRNA--protein transferase', 173, NULL, NULL, 134505),
(134506, '1.10.8.60-FF-000109', NULL, 'Cell division control protein 48 homolog C', 109, NULL, NULL, 134506),
(134507, '2.10.25.10-FF-001212', NULL, 'AGAP003873-PA', 40, NULL, NULL, 134507),
(134508, '3.40.250.10-FF-000167', NULL, 'Molybdopterin biosynthesis protein', 101, NULL, NULL, 134508),
(134509, '3.40.50.720-FF-000927', NULL, 'DeHydrogenases, Short chain', 265, NULL, NULL, 134509),
(134510, '1.25.50.20-FF-000040', NULL, 'Aminopeptidase', 329, NULL, NULL, 134510),
(134511, '3.30.70.330-FF-002969', NULL, NULL, 99, NULL, NULL, 134511),
(134512, '2.10.70.10-FF-000136', NULL, 'Predicted protein', 63, NULL, NULL, 134512),
(134513, '3.40.1160.10-FF-000053', NULL, 'Glutamate 5-kinase', 208, NULL, NULL, 134513),
(134514, '1.10.630.10-FF-000470', NULL, 'Cytochrome P450 family 87 subfamily A polypeptide 2', 164, NULL, NULL, 134514),
(134515, '2.130.10.10-FF-005523', NULL, 'Uncharacterized protein', 50, NULL, NULL, 134515),
(134516, '3.40.50.2000-FF-001120', NULL, 'Trehalose-phosphatase', 305, NULL, NULL, 134516);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(134517, '2.60.120.290-FF-000142', NULL, 'C-type LECtin', 114, NULL, NULL, 134517),
(134518, '1.20.5.100-FF-000017', NULL, 'Ubiquinol:cytochrome c oxidoreductase cytochrome c1', 44, NULL, NULL, 134518),
(134519, '1.20.120.1510-FF-000002', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 112, NULL, NULL, 134519),
(134520, '1.10.3730.20-FF-000013', NULL, 'EamA family transporter', 105, NULL, NULL, 134520),
(134521, '3.40.50.2300-FF-000378', NULL, 'Uncharacterized protein', 293, NULL, NULL, 134521),
(134522, '2.10.25.10-FF-000285', NULL, 'cadherin EGF LAG seven-pass G-type receptor 2', 39, NULL, NULL, 134522),
(134523, '3.40.1110.10-FF-000207', NULL, 'Phospholipid-transporting ATPase', 128, NULL, NULL, 134523),
(134524, '3.40.50.2300-FF-000687', NULL, 'Vomeronasal 2, receptor 76', 134, NULL, NULL, 134524),
(134525, '2.20.28.10-FF-000004', NULL, 'DNA replication licensing factor MCM7', 55, NULL, NULL, 134525),
(134526, '3.40.50.300-FF-004163', NULL, 'Uncharacterized protein', 282, NULL, NULL, 134526),
(134527, '2.40.50.140-FF-001095', NULL, NULL, 61, NULL, NULL, 134527),
(134528, '3.40.50.300-FF-004995', NULL, 'Uncharacterized protein', 259, NULL, NULL, 134528),
(134529, '3.30.60.90-FF-000033', NULL, 'Discontinuous actin hexagon', 59, NULL, NULL, 134529),
(134530, '1.20.1050.20-FF-000020', NULL, NULL, 83, NULL, NULL, 134530),
(134531, '1.10.8.60-FF-000418', NULL, 'Replication factor C subunit', 97, NULL, NULL, 134531),
(134532, '1.10.630.10-FF-000812', NULL, 'Uncharacterized protein', 289, NULL, NULL, 134532),
(134533, '3.90.190.10-FF-000331', NULL, 'Endostyle specific protein 11', 286, NULL, NULL, 134533),
(134534, '3.10.580.10-FF-000053', NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', 142, NULL, NULL, 134534),
(134535, '3.50.50.60-FF-000747', NULL, 'Rab proteins geranylgeranyltransferase', 60, NULL, NULL, 134535),
(134536, '1.20.58.2130-FF-000006', NULL, 'DNA replication regulator sld3', 250, NULL, NULL, 134536),
(134537, '1.10.630.10-FF-000161', NULL, 'Cytochrome P450, putative', 385, NULL, NULL, 134537),
(134538, '2.60.120.200-FF-000497', NULL, 'Laminin subunit alpha', 190, NULL, NULL, 134538),
(134539, '3.40.430.10-FF-000024', NULL, 'Dihydrofolate reductase', 192, NULL, NULL, 134539),
(134540, '2.130.10.10-FF-001813', NULL, 'WD domain, G-beta repeat-containing protein', 116, NULL, NULL, 134540),
(134541, '3.10.20.310-FF-000007', NULL, 'Outer membrane protein, OMP85 family', 81, NULL, NULL, 134541),
(134542, '1.25.40.180-FF-000088', NULL, 'Eukaryotic translation initiation factor 4G2, isoform A', 143, NULL, NULL, 134542),
(134543, '1.25.40.10-FF-005213', NULL, 'Clustered mitochondria protein homolog', 199, NULL, NULL, 134543),
(134544, '3.40.50.1950-FF-000008', NULL, 'Indolepyruvate oxidoreductase subunit IorA', 173, NULL, NULL, 134544),
(134545, '3.40.50.10330-FF-000037', NULL, 'Diacylglycerol kinase', 136, NULL, NULL, 134545),
(134546, '2.60.120.10-FF-000404', NULL, 'Predicted protein', 153, NULL, NULL, 134546),
(134547, '3.40.1190.20-FF-000092', NULL, 'Fructokinase', 306, NULL, NULL, 134547),
(134548, '2.130.10.10-FF-004798', NULL, 'Uncharacterized protein', 147, NULL, NULL, 134548),
(134549, '3.40.50.620-FF-000914', NULL, 'Glutaminyl-tRNA synthetase', 25, NULL, NULL, 134549),
(134550, '3.30.420.10-FF-000374', NULL, NULL, 202, NULL, NULL, 134550),
(134551, '1.20.920.10-FF-000085', NULL, 'GD21428', 116, NULL, NULL, 134551),
(134552, '3.40.50.2000-FF-000951', NULL, 'Os07g0489950 protein', 113, NULL, NULL, 134552),
(134553, '3.30.40.10-FF-000862', NULL, 'RUN and FYVE domain containing 3', 73, NULL, NULL, 134553),
(134554, '1.25.40.470-FF-000068', NULL, 'Uncharacterized protein', 167, NULL, NULL, 134554),
(134555, '1.25.40.1040-FF-000034', NULL, 'Uncharacterized protein, isoform B', 318, NULL, NULL, 134555),
(134556, '1.20.1730.10-FF-000070', NULL, 'Uncharacterized protein', 146, NULL, NULL, 134556),
(134557, '2.40.20.10-FF-000025', NULL, 'Plasminogen', 91, NULL, NULL, 134557),
(134558, '1.20.1270.90-FF-000001', NULL, 'Gram-positive signal peptide protein, YSIRK family', 67, NULL, NULL, 134558);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(134559, '1.20.900.10-FF-000090', NULL, 'YALI0F13673p', 233, NULL, NULL, 134559),
(134560, '2.10.25.10-FF-001797', NULL, 'Uncharacterized protein', 27, NULL, NULL, 134560),
(134561, '1.20.120.550-FF-000016', NULL, 'Microsomal glutathione S-transferase 2', 98, NULL, NULL, 134561),
(134562, '2.130.10.10-FF-003180', NULL, 'Protein CBG03683', 118, NULL, NULL, 134562),
(134563, '3.80.10.10-FF-002735', NULL, 'Pollen receptor-like kinase 1', 110, NULL, NULL, 134563),
(134564, '3.40.50.150-FF-001572', NULL, NULL, 67, NULL, NULL, 134564),
(134565, '3.30.559.30-FF-000111', NULL, 'Uncharacterized protein', 225, NULL, NULL, 134565),
(134566, '3.40.20.10-FF-000080', NULL, 'Kinase c and casein kinase substrate in neurons protein', 133, NULL, NULL, 134566),
(134567, '3.80.10.10-FF-001212', NULL, 'Protein toll', 387, NULL, NULL, 134567),
(134568, '1.25.40.20-FF-000415', NULL, 'KiDINs220 (Vertebrate scaffold protein) homolog', 79, NULL, NULL, 134568),
(134569, '3.40.190.10-FF-000792', NULL, 'ABC-type dipeptide/oligopeptide transport system, periplasmic component', 121, NULL, NULL, 134569),
(134570, '1.20.1560.10-FF-000365', NULL, 'Predicted protein', 344, NULL, NULL, 134570),
(134571, '3.40.50.2300-FF-000934', NULL, NULL, 185, NULL, NULL, 134571),
(134572, '3.30.160.60-FF-003746', NULL, 'Zinc finger protein 208-like Protein', 87, NULL, NULL, 134572),
(134573, '2.60.15.10-FF-000018', NULL, 'ATP synthase epsilon chain', 106, NULL, NULL, 134573),
(134574, '3.30.70.1230-FF-000071', NULL, 'Adenylate cyclase (ATP pyrophosphate-lyase), putative', 231, NULL, NULL, 134574),
(134575, '3.30.160.60-FF-002223', NULL, 'zinc finger protein 516 isoform X3', 64, NULL, NULL, 134575),
(134576, '3.60.10.10-FF-000084', NULL, 'Inositol-phosphate phosphatase', 126, NULL, NULL, 134576),
(134577, '3.40.50.10190-FF-000169', NULL, 'Protein CBG13622', 102, NULL, NULL, 134577),
(134578, '1.25.40.1030-FF-000031', NULL, 'Uncharacterized protein', 425, NULL, NULL, 134578),
(134579, '2.150.10.10-FF-000025', NULL, NULL, 120, NULL, NULL, 134579),
(134580, '1.10.287.3240-FF-000034', NULL, 'V-type ATPase, D subunit family protein', 212, NULL, NULL, 134580),
(134581, '1.20.1070.10-FF-001007', NULL, 'Olfactory receptor 1349', 160, NULL, NULL, 134581),
(134582, '3.90.320.10-FF-000027', NULL, 'ATP-dependent DNA helicase', 174, NULL, NULL, 134582),
(134583, '3.40.30.10-FF-000147', NULL, 'Thioredoxin domain-containing protein 5', 111, NULL, NULL, 134583),
(134584, '1.25.40.20-FF-000320', NULL, 'Leucine-rich repeat kinase, isoform C', 200, NULL, NULL, 134584),
(134585, '2.60.40.10-FF-005337', NULL, NULL, 74, NULL, NULL, 134585),
(134586, '3.30.70.330-FF-001019', NULL, 'Eukaryotic translation initiation factor 3 subunit G', 115, NULL, NULL, 134586),
(134587, '2.60.40.10-FF-002111', NULL, 'Titin', 92, NULL, NULL, 134587),
(134588, '3.40.1830.10-FF-000003', NULL, 'Aminopeptidase protein', 168, NULL, NULL, 134588),
(134589, '3.40.50.300-FF-002044', NULL, 'Heat shock protein 101', 202, NULL, NULL, 134589),
(134590, '2.60.40.60-FF-000996', NULL, 'Uncharacterized protein', 76, NULL, NULL, 134590),
(134591, '1.10.8.10-FF-000117', NULL, 'UBX domain-containing protein 5', 42, NULL, NULL, 134591),
(134592, '1.25.40.10-FF-001935', NULL, 'Tetratricopeptide repeat (TPR)-containing protein', 138, NULL, NULL, 134592),
(134593, '4.10.280.10-FF-000037', NULL, 'max-like protein X isoform X2', 90, NULL, NULL, 134593),
(134594, '3.20.20.10-FF-000029', NULL, 'Alanine racemase', 212, NULL, NULL, 134594),
(134595, '3.90.550.10-FF-000162', NULL, 'Cellulose synthase-like B6', 168, NULL, NULL, 134595),
(134596, '3.40.50.300-FF-007850', NULL, 'Predicted protein', 223, NULL, NULL, 134596),
(134597, '2.70.150.10-FF-000050', NULL, 'Phospholipid-transporting ATPase', 135, NULL, NULL, 134597),
(134598, '3.40.50.10490-FF-000057', NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', 149, NULL, NULL, 134598),
(134599, '3.40.50.300-FF-005821', NULL, 'ATP-dependent DNA helicase RecQ family protein', 246, NULL, NULL, 134599),
(134600, '2.30.29.30-FF-000776', NULL, 'Uncharacterized protein', 98, NULL, NULL, 134600);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(134601, '2.130.10.10-FF-005315', NULL, 'Uncharacterized protein', 203, NULL, NULL, 134601),
(134602, '1.50.40.10-FF-000124', NULL, 'Solute carrier family 25 member 36', 196, NULL, NULL, 134602),
(134603, '2.60.40.60-FF-000411', NULL, 'Uncharacterized protein', 116, NULL, NULL, 134603),
(134604, '1.25.40.20-FF-001843', NULL, 'Predicted protein', 143, NULL, NULL, 134604),
(134605, '3.40.50.720-FF-000377', NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', 134, NULL, NULL, 134605),
(134606, '2.40.50.140-FF-000853', NULL, NULL, 35, NULL, NULL, 134606),
(134607, '3.40.470.10-FF-000026', NULL, NULL, 150, NULL, NULL, 134607),
(134608, '2.60.120.200-FF-000492', NULL, 'Growth arrest-specific 6', 194, NULL, NULL, 134608),
(134609, '3.30.200.20-FF-001097', NULL, 'Dual specificity protein kinase FUZ7', 109, NULL, NULL, 134609),
(134610, '1.20.58.60-FF-000338', NULL, 'Spectrin beta chain', 209, NULL, NULL, 134610),
(134611, '2.70.130.10-FF-000150', NULL, NULL, 138, NULL, NULL, 134611),
(134612, '3.40.30.10-FF-000473', NULL, 'Glutathione S-transferase Mu 1', 69, NULL, NULL, 134612),
(134613, '1.10.533.10-FF-000007', NULL, 'death domain-containing protein CRADD isoform X1', 97, NULL, NULL, 134613),
(134614, '1.20.1110.10-FF-000106', NULL, 'E1-E2 ATPase, putative', 113, NULL, NULL, 134614),
(134615, '1.20.58.150-FF-000015', NULL, NULL, 148, NULL, NULL, 134615),
(134616, '1.10.238.10-FF-000052', NULL, 'Guanylate cyclase activator 1A', 174, NULL, NULL, 134616),
(134617, '1.10.238.20-FF-000055', NULL, 'General odorant-binding protein 69', 129, NULL, NULL, 134617),
(134618, '3.50.50.60-FF-001242', NULL, 'Uncharacterized protein', 171, NULL, NULL, 134618),
(134619, '1.20.990.10-FF-000033', NULL, 'NADPH oxidoreductase A', 126, NULL, NULL, 134619),
(134620, '3.40.91.10-FF-000001', NULL, 'SgraIR restriction enzyme', 338, NULL, NULL, 134620),
(134621, '1.20.5.110-FF-000245', NULL, 'Syntaxin 5-1', 116, NULL, NULL, 134621),
(134622, '1.25.40.10-FF-001609', NULL, 'Hypothetical_protein_-_conserved', 261, NULL, NULL, 134622),
(134623, '3.30.70.1170-FF-000024', NULL, 'Uncharacterized protein', 89, NULL, NULL, 134623),
(134624, '3.90.870.10-FF-000006', NULL, 'Putative threonylcarbamoyl-AMP synthase', 210, NULL, NULL, 134624),
(134625, '3.40.50.10470-FF-000051', NULL, 'Uncharacterized protein', 65, NULL, NULL, 134625),
(134626, '3.40.50.720-FF-000591', NULL, 'Glucose-6-phosphate dehydrogenase', 87, NULL, NULL, 134626),
(134627, '3.30.1460.50-FF-000011', NULL, 'Autophagocytosis associated protein, c-terminal domain containing protein', 183, NULL, NULL, 134627),
(134628, '3.60.20.40-FF-000020', NULL, 'Si:ch73-59p9.2', 140, NULL, NULL, 134628),
(134629, '3.80.10.10-FF-002409', NULL, 'SLIT 2 protein', 162, NULL, NULL, 134629),
(134630, '3.40.50.410-FF-000065', NULL, 'Complement C2', 218, NULL, NULL, 134630),
(134631, '3.50.50.60-FF-001337', NULL, 'Uncharacterized protein', 219, NULL, NULL, 134631),
(134632, '3.40.50.10190-FF-000074', NULL, 'DNA repair protein Rtt107', 120, NULL, NULL, 134632),
(134633, '3.30.479.20-FF-000057', NULL, 'Elongation factor Ts 2, mitochondrial', 50, NULL, NULL, 134633),
(134634, '3.80.10.10-FF-000695', NULL, 'leucine-rich melanocyte differentiation-associated protein', 162, NULL, NULL, 134634),
(134635, '3.40.50.1820-FF-000537', NULL, 'Ves G 1 allergen, putative', 309, NULL, NULL, 134635),
(134636, '3.65.10.20-FF-000020', NULL, 'RNA cyclase, putative', 224, NULL, NULL, 134636),
(134637, '2.60.120.330-FF-000058', NULL, 'Oxidoreductase, putative', 329, NULL, NULL, 134637),
(134638, '1.10.8.10-FF-000331', NULL, 'Ubiquitin-specific peptidase 28', 43, NULL, NULL, 134638),
(134639, '3.40.1110.10-FF-000319', NULL, NULL, 146, NULL, NULL, 134639),
(134640, '1.20.1610.10-FF-000004', NULL, 'Alpha-1,2-mannosidase, putative', 144, NULL, NULL, 134640),
(134641, '1.20.140.10-FF-000121', NULL, 'Ribosomal protein L15', 143, NULL, NULL, 134641),
(134642, '3.40.140.100-FF-000020', NULL, 'ThiF family protein', 93, NULL, NULL, 134642),
(134643, '3.20.20.80-FF-000578', NULL, 'Uncharacterized protein', 164, NULL, NULL, 134643);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(134644, '1.25.40.10-FF-001840', NULL, 'Uncharacterized protein', 124, NULL, NULL, 134644),
(134645, '2.30.29.30-FF-000990', NULL, 'Uncharacterized protein', 138, NULL, NULL, 134645),
(134646, '1.10.510.10-FF-000073', NULL, 'Non-specific serine/threonine protein kinase', 193, NULL, NULL, 134646),
(134647, '3.40.50.300-FF-005596', NULL, 'DNA mismatch repair protein', 279, NULL, NULL, 134647),
(134648, '3.40.50.10140-FF-000071', NULL, 'Uncharacterized protein', 96, NULL, NULL, 134648),
(134649, '3.30.160.60-FF-002009', NULL, 'FEZ family zinc finger 2', 27, NULL, NULL, 134649),
(134650, '1.20.1250.20-FF-000816', NULL, 'Solute carrier organic anion transporter family member', 215, NULL, NULL, 134650),
(134651, '3.40.50.300-FF-005607', NULL, 'Si:dkey-11m19.5', 213, NULL, NULL, 134651),
(134652, '3.30.160.60-FF-000183', NULL, 'E3 ubiquitin-protein ligase ZFP91', 78, NULL, NULL, 134652),
(134653, '2.10.70.10-FF-000007', NULL, 'Fibronectin 1', 41, NULL, NULL, 134653),
(134654, '3.30.40.10-FF-001800', NULL, 'Putative peroxisomal biogenesis factor 10', 102, NULL, NULL, 134654),
(134655, '3.40.50.300-FF-003781', NULL, 'GTPase, IMAP family member 7', 83, NULL, NULL, 134655),
(134656, '1.10.510.10-FF-003541', NULL, NULL, 234, NULL, NULL, 134656),
(134657, '1.10.238.10-FF-001249', NULL, 'Uncharacterized protein', 83, NULL, NULL, 134657),
(134658, '3.30.420.270-FF-000007', NULL, 'Biopolymer transport protein ExbD', 69, NULL, NULL, 134658),
(134659, '1.20.1560.10-FF-000691', NULL, 'Protein CBG17574', 491, NULL, NULL, 134659),
(134660, '3.60.20.10-FF-000270', NULL, NULL, 72, NULL, NULL, 134660),
(134661, '3.30.70.330-FF-002868', NULL, NULL, 134, NULL, NULL, 134661),
(134662, '3.40.50.300-FF-007619', NULL, 'Uncharacterized protein', 148, NULL, NULL, 134662),
(134663, '1.10.1670.10-FF-000078', NULL, NULL, 117, NULL, NULL, 134663),
(134664, '1.10.3730.20-FF-000018', NULL, 'NIPA protein 2', 114, NULL, NULL, 134664),
(134665, '2.60.120.920-FF-000140', NULL, 'Uncharacterized protein', 136, NULL, NULL, 134665),
(134666, '2.30.39.10-FF-000046', NULL, 'Serine protease inhibitor 28Dc', 154, NULL, NULL, 134666),
(134667, '3.20.20.70-FF-000249', NULL, 'Lipoyl synthase, apicoplast', 212, NULL, NULL, 134667),
(134668, '3.30.160.60-FF-005096', NULL, NULL, 30, NULL, NULL, 134668),
(134669, '1.10.720.30-FF-000016', NULL, 'MEF2-activating motif and SAP domain-containing transcriptional regulator isoform X2', 63, NULL, NULL, 134669),
(134670, '2.10.70.10-FF-000119', NULL, 'Uncharacterized protein, isoform A', 60, NULL, NULL, 134670),
(134671, '3.30.780.10-FF-000069', NULL, 'Uncharacterized protein', 125, NULL, NULL, 134671),
(134672, '2.30.40.10-FF-000128', NULL, 'Guanine deaminase', 122, NULL, NULL, 134672),
(134673, '3.40.720.10-FF-000248', NULL, 'Uncharacterized protein', 137, NULL, NULL, 134673),
(134674, '2.70.70.10-FF-000078', NULL, 'Predicted protein', 157, NULL, NULL, 134674),
(134675, '2.10.25.10-FF-000953', NULL, 'High Incidence of Males (Increased X chromosome loss)', 35, NULL, NULL, 134675),
(134676, '3.80.10.10-FF-002398', NULL, 'Putative leucine-rich repeat domain, L domain-containing protein', 76, NULL, NULL, 134676),
(134677, '3.40.720.10-FF-000136', NULL, 'Phosphoglycerol transferase', 285, NULL, NULL, 134677),
(134678, '2.60.40.2440-FF-000011', NULL, 'Protein phosphatase 1 regulatory subunit 3G', 158, NULL, NULL, 134678),
(134679, '1.10.287.950-FF-000003', NULL, 'Methyl-accepting chemotaxis protein', 305, NULL, NULL, 134679),
(134680, '1.25.40.10-FF-003285', NULL, 'Putative pentatricopeptide repeat-containing protein', 131, NULL, NULL, 134680),
(134681, '1.20.1270.60-FF-000251', NULL, 'Chromosome 1, whole genome shotgun sequence', 234, NULL, NULL, 134681),
(134682, '1.10.510.10-FF-001175', NULL, 'Uncharacterized protein', 239, NULL, NULL, 134682),
(134683, '3.30.390.30-FF-000039', NULL, 'Bis-gamma-glutamylcystine reductase', 108, NULL, NULL, 134683),
(134684, '2.20.25.10-FF-000071', NULL, 'Peptide-N4-(N-acetyl-beta-glucosaminyl)asparagine amidase', 51, NULL, NULL, 134684),
(134685, '3.30.420.10-FF-000711', NULL, NULL, 93, NULL, NULL, 134685);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(134686, '1.20.58.830-FF-000022', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 157, NULL, NULL, 134686),
(134687, '3.30.1520.10-FF-000196', NULL, 'Uncharacterized protein', 143, NULL, NULL, 134687),
(134688, '1.10.510.10-FF-001287', NULL, 'Os10g0200000 protein', 208, NULL, NULL, 134688),
(134689, '3.30.1370.70-FF-000010', NULL, NULL, 56, NULL, NULL, 134689),
(134690, '3.10.620.30-FF-000001', NULL, 'peptide-N(4)-(N-acetyl-beta- glucosaminyl)asparagine amidase', 207, NULL, NULL, 134690),
(134691, '2.130.10.10-FF-001942', NULL, 'Retinoblastoma-binding protein homolog 5', 313, NULL, NULL, 134691),
(134692, '2.40.10.10-FF-000311', NULL, NULL, 104, NULL, NULL, 134692),
(134693, '3.30.60.90-FF-000050', NULL, 'Uncharacterized protein', 55, NULL, NULL, 134693),
(134694, '1.10.287.370-FF-000043', NULL, 'Prefoldin subunit 3', 146, NULL, NULL, 134694),
(134695, '2.40.50.90-FF-000079', NULL, 'ID821', 117, NULL, NULL, 134695),
(134696, '3.30.1330.30-FF-000029', NULL, 'tRNA/rRNA methyltransferase', 78, NULL, NULL, 134696),
(134697, '2.130.10.10-FF-001830', NULL, 'GM15299', 218, NULL, NULL, 134697),
(134698, '3.30.40.10-FF-000536', NULL, 'CCR4-NOT transcription complex subunit 4', 74, NULL, NULL, 134698),
(134699, '2.30.30.140-FF-000227', NULL, 'Tapas, isoform A', 86, NULL, NULL, 134699),
(134700, '3.30.1370.210-FF-000026', NULL, 'ziinc finger protein Ci-ZF(C3H)-7 isoform X1', 67, NULL, NULL, 134700),
(134701, '3.30.2270.10-FF-000002', NULL, 'Sarcosine oxidase subunit delta', 98, NULL, NULL, 134701),
(134702, '1.20.5.110-FF-000133', NULL, 'Putative synaptobrevin-type transport protein', 106, NULL, NULL, 134702),
(134703, '2.60.200.20-FF-000200', NULL, 'Serine/threonine-protein kinase Chk2', 109, NULL, NULL, 134703),
(134704, '1.10.510.10-FF-003636', NULL, NULL, 189, NULL, NULL, 134704),
(134705, '3.40.50.300-FF-000015', NULL, 'chromodomain-helicase-DNA-binding protein 9 isoform X1', 228, NULL, NULL, 134705),
(134706, '3.10.290.10-FF-000064', NULL, 'Uncharacterized protein', 60, NULL, NULL, 134706),
(134707, '3.30.1120.10-FF-000002', NULL, 'Arylsulfatase family member J', 111, NULL, NULL, 134707),
(134708, '3.30.710.10-FF-000458', NULL, 'Uncharacterized protein', 127, NULL, NULL, 134708),
(134709, '1.10.510.10-FF-004030', NULL, NULL, 104, NULL, NULL, 134709),
(134710, '1.20.120.980-FF-000010', NULL, 'Eukaryotic translation initiation factor 3 subunit D', 143, NULL, NULL, 134710),
(134711, '1.25.40.10-FF-004696', NULL, 'Uncharacterized protein', 100, NULL, NULL, 134711),
(134712, '1.20.1310.20-FF-000063', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 226, NULL, NULL, 134712),
(134713, '3.50.50.60-FF-001130', NULL, 'FAD-dependent pyridine nucleotide-disulfide oxidoreductase family protein', 120, NULL, NULL, 134713),
(134714, '3.30.40.10-FF-000957', NULL, 'TNF-receptor-associated factor 2', 61, NULL, NULL, 134714),
(134715, '3.40.1110.10-FF-000224', NULL, 'Phospholipid-transporting ATPase', 136, NULL, NULL, 134715),
(134716, '2.60.120.290-FF-000248', NULL, 'Predicted protein', 103, NULL, NULL, 134716),
(134717, '1.25.40.10-FF-003190', NULL, 'Pentatricopeptide repeat-containing protein At4g19191, mitochondrial', 95, NULL, NULL, 134717),
(134718, '3.40.50.2020-FF-000035', NULL, 'Hypoxanthine phosphoribosyltransferase', 175, NULL, NULL, 134718),
(134719, '3.30.1120.30-FF-000008', NULL, 'Serine/threonine-protein kinase PLK', 89, NULL, NULL, 134719),
(134720, '3.60.21.10-FF-000108', NULL, 'Calcineurin-like metallo-phosphoesterase superfamily protein', 309, NULL, NULL, 134720),
(134721, '3.90.70.80-FF-000056', NULL, 'OTU domain-containing protein 4 isoform X1', 138, NULL, NULL, 134721),
(134722, '3.40.50.150-FF-000402', NULL, 'Ribosomal RNA-processing protein 8', 163, NULL, NULL, 134722),
(134723, '3.30.70.940-FF-000022', NULL, 'Transcription antitermination protein RfaH', 166, NULL, NULL, 134723),
(134724, '3.30.420.40-FF-000012', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', 147, NULL, NULL, 134724),
(134725, '3.90.660.10-FF-000069', NULL, NULL, 231, NULL, NULL, 134725),
(134726, '3.40.50.790-FF-000015', NULL, 'Related to 50S ribosomal protein L1', 115, NULL, NULL, 134726);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(134727, '3.40.50.12710-FF-000010', NULL, 'Class I SAM-dependent methyltransferase', 388, NULL, NULL, 134727),
(134728, '2.60.40.10-FF-001852', NULL, 'B-cell antigen receptor complex-associated protein alpha chain', 94, NULL, NULL, 134728),
(134729, '3.40.50.300-FF-002370', NULL, 'Torsin family 3, member A', 218, NULL, NULL, 134729),
(134730, '3.40.50.12780-FF-000087', NULL, 'Acetyl-CoA synthase', 498, NULL, NULL, 134730),
(134731, '1.10.1420.10-FF-000031', NULL, 'DNA mismatch repair protein MSH2', 229, NULL, NULL, 134731),
(134732, '3.30.470.20-FF-000088', NULL, 'D-alanine--D-alanine ligase', 135, NULL, NULL, 134732),
(134733, '3.40.50.720-FF-002417', NULL, 'Delta-1-pyrroline-5-carboxylate synthase B', 43, NULL, NULL, 134733),
(134734, '2.10.25.10-FF-000274', NULL, 'Crumbs cell polarity complex component 1', 43, NULL, NULL, 134734),
(134735, '2.60.40.10-FF-003634', NULL, NULL, 110, NULL, NULL, 134735),
(134736, '3.90.1260.10-FF-000004', NULL, 'Argininosuccinate synthase', 224, NULL, NULL, 134736),
(134737, '3.40.50.450-FF-000032', NULL, 'Uncharacterized protein', 168, NULL, NULL, 134737),
(134738, '3.90.850.10-FF-000011', NULL, 'Fumarylacetoacetase', 297, NULL, NULL, 134738),
(134739, '3.40.50.720-FF-001220', NULL, 'D-beta-hydroxybutyrate dehydrogenase, mitochondrial', 133, NULL, NULL, 134739),
(134740, '3.40.50.300-FF-003567', NULL, 'Pre-mRNA cleavage complex II Clp1-like protein', 242, NULL, NULL, 134740),
(134741, '1.10.580.10-FF-000021', NULL, 'Citryl-CoA lyase', 91, NULL, NULL, 134741),
(134742, '3.30.420.60-FF-000018', NULL, 'Protein pelota homolog', 126, NULL, NULL, 134742),
(134743, '3.30.30.30-FF-000002', NULL, 'Heat shock 70 kDa protein 4', 76, NULL, NULL, 134743),
(134744, '1.10.10.10-FF-001265', NULL, 'Rap guanine nucleotide exchange factor 5', 148, NULL, NULL, 134744),
(134745, '1.10.287.2720-FF-000007', NULL, 'Oxysterol binding protein, putative', 64, NULL, NULL, 134745),
(134746, '1.25.40.120-FF-000014', NULL, 'Geranylgeranyl transferase type-2 subunit alpha 1', 258, NULL, NULL, 134746),
(134747, '3.30.160.60-FF-005758', NULL, NULL, 68, NULL, NULL, 134747),
(134748, '3.30.450.20-FF-000542', NULL, 'Sensory histidine protein kinase', 124, NULL, NULL, 134748),
(134749, '1.10.8.60-FF-000188', NULL, 'Unplaced genomic scaffold supercont1.133, whole genome shotgun sequence', 96, NULL, NULL, 134749),
(134750, '1.25.40.10-FF-005325', NULL, 'Uncharacterized protein', 106, NULL, NULL, 134750),
(134751, '3.70.10.10-FF-000004', NULL, 'Cell cycle checkpoint protein RAD1', 263, NULL, NULL, 134751),
(134752, '2.130.10.10-FF-005192', NULL, 'WD repeat-containing protein 38', 112, NULL, NULL, 134752),
(134753, '3.30.2130.30-FF-000048', NULL, 'Probable tRNA sulfurtransferase', 90, NULL, NULL, 134753),
(134754, '3.40.50.300-FF-000032', NULL, 'Export ABC transporter ATP-binding protein', 226, NULL, NULL, 134754),
(134755, '1.20.1250.20-FF-002278', NULL, 'Uncharacterized protein', 91, NULL, NULL, 134755),
(134756, '3.30.160.60-FF-000211', NULL, 'PR domain zinc finger protein 1', 28, NULL, NULL, 134756),
(134757, '1.20.5.170-FF-000139', NULL, 'Arr1p', 71, NULL, NULL, 134757),
(134758, '3.40.50.150-FF-000161', NULL, 'Methyltransferase', 252, NULL, NULL, 134758),
(134759, '3.30.160.60-FF-004140', NULL, NULL, 29, NULL, NULL, 134759),
(134760, '3.50.30.30-FF-000164', NULL, 'Uncharacterized protein', 146, NULL, NULL, 134760),
(134761, '3.30.40.10-FF-000974', NULL, 'Tnf receptor-associated factor 5', 54, NULL, NULL, 134761),
(134762, '3.50.20.20-FF-000003', NULL, 'sex-regulated protein janus-B', 114, NULL, NULL, 134762),
(134763, '3.30.160.60-FF-006034', NULL, NULL, 24, NULL, NULL, 134763),
(134764, '1.10.630.10-FF-000262', NULL, 'Isotrichodermin C-15 hydroxylase', 498, NULL, NULL, 134764),
(134765, '1.20.120.160-FF-000006', NULL, 'Chemotaxis protein CheA', 143, NULL, NULL, 134765),
(134766, '3.50.50.60-FF-001225', NULL, 'Flavin-containing monooxygenase', 242, NULL, NULL, 134766),
(134767, '1.20.120.350-FF-000063', NULL, 'Calcium channel subunit Cch1', 131, NULL, NULL, 134767),
(134768, '3.40.50.1260-FF-000015', NULL, 'Phosphoglycerate kinase', 164, NULL, NULL, 134768);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(134769, '1.10.238.110-FF-000023', NULL, 'Diacylglycerol kinase', 43, NULL, NULL, 134769),
(134770, '1.20.990.10-FF-000016', NULL, 'NADPH-dependent diflavin oxidoreductase 1', 130, NULL, NULL, 134770),
(134771, '3.40.50.1700-FF-000052', NULL, 'Predicted protein', 261, NULL, NULL, 134771),
(134772, '3.30.160.60-FF-003634', NULL, NULL, 27, NULL, NULL, 134772),
(134773, '3.40.50.11040-FF-000014', NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', 222, NULL, NULL, 134773),
(134774, '2.60.40.10-FF-005449', NULL, NULL, 76, NULL, NULL, 134774),
(134775, '1.20.120.150-FF-000003', NULL, 'Serine/threonine-protein kinase TOR', 99, NULL, NULL, 134775),
(134776, '2.130.10.10-FF-001263', NULL, 'U4/U6 small nuclear ribonucleoprotein Prp4, putative', 95, NULL, NULL, 134776),
(134777, '1.25.10.10-FF-001900', NULL, 'ARM repeat superfamily protein', 240, NULL, NULL, 134777),
(134778, '3.40.720.10-FF-000350', NULL, 'Sulfatase', 273, NULL, NULL, 134778),
(134779, '3.80.10.10-FF-000818', NULL, 'NLR family CARD domain containing 5', 336, NULL, NULL, 134779),
(134780, '1.10.10.60-FF-000976', NULL, NULL, 33, NULL, NULL, 134780),
(134781, '3.90.25.10-FF-000083', NULL, 'Predicted protein', 88, NULL, NULL, 134781),
(134782, '1.10.45.10-FF-000007', NULL, 'Cholesterol oxidase', 50, NULL, NULL, 134782),
(134783, '2.130.10.10-FF-003628', NULL, 'Chromosome 19, whole genome shotgun sequence', 130, NULL, NULL, 134783),
(134784, '3.40.30.10-FF-000035', NULL, 'hematopoietic prostaglandin D synthase', 85, NULL, NULL, 134784),
(134785, '3.40.50.1820-FF-000554', NULL, 'Alpha/beta hydrolase', 297, NULL, NULL, 134785),
(134786, '1.20.1300.10-FF-000020', NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit, mitochondrial', 129, NULL, NULL, 134786),
(134787, '1.10.20.10-FF-000023', NULL, 'transcription initiation protein SPT3 homolog', 43, NULL, NULL, 134787),
(134788, '3.40.50.970-FF-000098', NULL, 'Sulfite reductase alpha subunit', 214, NULL, NULL, 134788),
(134789, '3.60.20.10-FF-000039', NULL, 'Asparagine synthetase [glutamine-hydrolyzing]', 174, NULL, NULL, 134789),
(134790, '1.10.8.10-FF-000229', NULL, 'UBA/TS-N domain containing protein', 61, NULL, NULL, 134790),
(134791, '1.20.1070.10-FF-000283', NULL, 'Purinergic receptor P2Y11', 309, NULL, NULL, 134791),
(134792, '3.90.640.10-FF-000074', NULL, 'Stress-seventy subfamily Q protein', 88, NULL, NULL, 134792),
(134793, '3.40.50.300-FF-005579', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 96, NULL, NULL, 134793),
(134794, '2.130.10.10-FF-000987', NULL, 'Unplaced genomic scaffold supercont1.16, whole genome shotgun sequence', 127, NULL, NULL, 134794),
(134795, '3.30.420.10-FF-000357', NULL, NULL, 125, NULL, NULL, 134795),
(134796, '1.10.510.10-FF-000090', NULL, 'Dual specificity mitogen-activated protein kinase kinase 4', 208, NULL, NULL, 134796),
(134797, '3.40.50.300-FF-005933', NULL, 'Atp/GTP-binding protein', 221, NULL, NULL, 134797),
(134798, '3.20.20.140-FF-000123', NULL, 'Probable N-acetylglucosamine-6-phosphate deacetylase', 288, NULL, NULL, 134798),
(134799, '2.170.270.10-FF-000001', NULL, 'Putative histone-lysine N-methyltransferase EZH2', 210, NULL, NULL, 134799),
(134800, '2.10.70.10-FF-000024', NULL, 'Sushi repeat-containing protein SRPX', 60, NULL, NULL, 134800),
(134801, '1.20.920.10-FF-000208', NULL, 'Uncharacterized protein', 113, NULL, NULL, 134801),
(134802, '3.40.20.10-FF-000107', NULL, 'Villin-like 1', 113, NULL, NULL, 134802),
(134803, '1.10.8.10-FF-000089', NULL, 'Tyrosyl-DNA phosphodiesterase 2', 85, NULL, NULL, 134803),
(134804, '2.40.20.10-FF-000042', NULL, 'Uncharacterized protein', 79, NULL, NULL, 134804),
(134805, '3.40.50.720-FF-001315', NULL, 'Fatty acyl-CoA reductase', 150, NULL, NULL, 134805),
(134806, '1.25.10.10-FF-001445', NULL, 'UVSB', 382, NULL, NULL, 134806),
(134807, '2.30.29.30-FF-001170', NULL, 'uncharacterized protein LOC100187308 isoform X1', 95, NULL, NULL, 134807),
(134808, '1.20.58.60-FF-000776', NULL, 'Uncharacterized protein', 230, NULL, NULL, 134808),
(134809, '3.30.70.660-FF-000045', NULL, 'tRNA pseudouridine synthase', 169, NULL, NULL, 134809);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(134810, '1.20.900.10-FF-000073', NULL, 'Putative RhoGEF group protein', 232, NULL, NULL, 134810),
(134811, '1.20.920.10-FF-000068', NULL, 'Histone acetyltransferase GCN5', 116, NULL, NULL, 134811),
(134812, '3.40.1690.10-FF-000014', NULL, 'Type III secretion protein', 81, NULL, NULL, 134812),
(134813, '1.10.510.10-FF-003524', NULL, NULL, 244, NULL, NULL, 134813),
(134814, '3.10.580.10-FF-000165', NULL, 'Predicted protein', 70, NULL, NULL, 134814),
(134815, '3.20.20.80-FF-000792', NULL, 'Uncharacterized protein', 173, NULL, NULL, 134815),
(134816, '3.30.930.10-FF-000227', NULL, 'Pyrrolysyl-tRNA synthetase', 219, NULL, NULL, 134816),
(134817, '3.30.420.40-FF-000124', NULL, 'Carbamoyltransferase HypF', 250, NULL, NULL, 134817),
(134818, '3.50.50.60-FF-000848', NULL, 'Uncharacterized protein', 252, NULL, NULL, 134818),
(134819, '3.30.60.30-FF-000060', NULL, 'Protein CBG17314', 49, NULL, NULL, 134819),
(134820, '3.40.50.2300-FF-001423', NULL, NULL, 38, NULL, NULL, 134820),
(134821, '1.10.10.60-FF-001252', NULL, NULL, 70, NULL, NULL, 134821),
(134822, '3.40.1690.20-FF-000017', NULL, 'Uncharacterized protein', 105, NULL, NULL, 134822),
(134823, '2.60.300.12-FF-000033', NULL, NULL, 61, NULL, NULL, 134823),
(134824, '3.30.160.60-FF-001829', NULL, 'Zinc finger protein 296', 29, NULL, NULL, 134824),
(134825, '1.25.10.10-FF-003345', NULL, 'Uncharacterized protein', 445, NULL, NULL, 134825),
(134826, '3.10.20.600-FF-000004', NULL, 'Putative oxidoreductase', 90, NULL, NULL, 134826),
(134827, '3.30.160.60-FF-002111', NULL, 'Zinc finger protein 260', 21, NULL, NULL, 134827),
(134828, '2.130.10.10-FF-003387', NULL, 'Uncharacterized protein', 136, NULL, NULL, 134828),
(134829, '2.130.10.10-FF-002201', NULL, 'Sortilin', 187, NULL, NULL, 134829),
(134830, '3.40.50.300-FF-007833', NULL, 'Chromosome 12, whole genome shotgun sequence', 188, NULL, NULL, 134830),
(134831, '2.40.40.20-FF-000030', NULL, 'AAA family ATPase', 81, NULL, NULL, 134831),
(134832, '2.60.40.4280-FF-000001', NULL, 'Hydralysin-1', 99, NULL, NULL, 134832),
(134833, '1.10.533.10-FF-000221', NULL, 'E3 ubiquitin-protein ligase HERC2', 95, NULL, NULL, 134833),
(134834, '2.10.25.10-FF-000386', NULL, 'matrilin-4 isoform X1', 37, NULL, NULL, 134834),
(134835, '2.170.210.10-FF-000008', NULL, 'Uncharacterized protein', 142, NULL, NULL, 134835),
(134836, '3.40.630.30-FF-000023', NULL, 'protein O-GlcNAcase', 205, NULL, NULL, 134836),
(134837, '1.20.1260.10-FF-000078', NULL, 'Ferritin', 103, NULL, NULL, 134837),
(134838, '1.10.10.10-FF-001832', NULL, 'AGAP009060-PA', 94, NULL, NULL, 134838),
(134839, '3.30.200.110-FF-000006', NULL, NULL, 91, NULL, NULL, 134839),
(134840, '3.30.559.10-FF-000229', NULL, 'Hydroxamate-type ferrichrome siderophore peptide synthetase', 175, NULL, NULL, 134840),
(134841, '1.10.287.130-FF-000229', NULL, 'Sensor histidine kinase', 82, NULL, NULL, 134841),
(134842, '1.10.10.440-FF-000052', NULL, 'TransCription Elongation Regulator homolog', 77, NULL, NULL, 134842),
(134843, '1.10.510.10-FF-003962', NULL, NULL, 45, NULL, NULL, 134843),
(134844, '2.10.220.10-FF-000013', NULL, 'Receptor protein-tyrosine kinase', 58, NULL, NULL, 134844),
(134845, '3.40.50.720-FF-002294', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 183, NULL, NULL, 134845),
(134846, '2.60.120.970-FF-000008', NULL, 'Bone morphogenetic protein 7', 268, NULL, NULL, 134846),
(134847, '3.30.70.330-FF-001233', NULL, 'RNA recognition motif domain containing protein', 163, NULL, NULL, 134847),
(134848, '2.60.40.1180-FF-000150', NULL, 'Alpha-glucosidase II, catalytic subunit, putative', 73, NULL, NULL, 134848),
(134849, '3.80.10.10-FF-004326', NULL, 'Protein TORNADO 1', 202, NULL, NULL, 134849),
(134850, '3.40.50.800-FF-000075', NULL, 'Proline--tRNA ligase', 113, NULL, NULL, 134850),
(134851, '3.30.70.270-FF-000248', NULL, NULL, 193, NULL, NULL, 134851),
(134852, '3.30.200.100-FF-000003', NULL, 'RNA polymerase subunit sigma', 105, NULL, NULL, 134852),
(134853, '3.40.50.300-FF-004410', NULL, 'Adp-ribosylation factor-like protein 6-like isoform x3', 184, NULL, NULL, 134853);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(134854, '2.130.10.10-FF-001925', NULL, 'WD domain, G-beta repeat/BING4CT (NUC141) domain containing protein, putative', 196, NULL, NULL, 134854),
(134855, '3.40.50.620-FF-000791', NULL, 'Cryptochrome circadian regulator 2', 53, NULL, NULL, 134855),
(134856, '3.40.50.300-FF-003679', NULL, 'F-box DNA helicase 1', 199, NULL, NULL, 134856),
(134857, '3.40.630.20-FF-000020', NULL, 'Uncharacterized protein', 145, NULL, NULL, 134857),
(134858, '1.10.10.10-FF-001377', NULL, 'Acetylserotonin O-methyltransferase 3', 101, NULL, NULL, 134858),
(134859, '1.20.1250.20-FF-000479', NULL, 'MFS transporter', 388, NULL, NULL, 134859),
(134860, '2.60.40.10-FF-005551', NULL, NULL, 116, NULL, NULL, 134860),
(134861, '6.10.30.50-FF-000002', NULL, 'BNR1p Formin', 58, NULL, NULL, 134861),
(134862, '1.10.357.30-FF-000014', NULL, NULL, 65, NULL, NULL, 134862),
(134863, '1.20.5.110-FF-000150', NULL, 'EhSyntaxin I, putative', 63, NULL, NULL, 134863),
(134864, '3.30.70.330-FF-003150', NULL, NULL, 128, NULL, NULL, 134864),
(134865, '1.10.357.20-FF-000011', NULL, 'Solute carrier family 41 member 3', 105, NULL, NULL, 134865),
(134866, '1.20.5.170-FF-000235', NULL, 'Tropomyosin', 147, NULL, NULL, 134866),
(134867, '3.40.50.300-FF-008013', NULL, 'Uncharacterized protein', 142, NULL, NULL, 134867),
(134868, '3.90.830.10-FF-000009', NULL, 'Vacuolar sorting protein', 114, NULL, NULL, 134868),
(134869, '3.90.190.10-FF-000078', NULL, 'Protein tyrosine phosphatase, putative', 159, NULL, NULL, 134869),
(134870, '3.80.10.10-FF-000274', NULL, 'NLR family CARD domain containing 3', 162, NULL, NULL, 134870),
(134871, '1.25.10.10-FF-003362', NULL, 'Predicted protein', 183, NULL, NULL, 134871),
(134872, '2.30.29.30-FF-000097', NULL, 'Putative mRNA-decapping enzyme 1A', 126, NULL, NULL, 134872),
(134873, '3.30.2230.10-FF-000005', NULL, 'Ubiquitin carboxyl-terminal hydrolase 26', 100, NULL, NULL, 134873),
(134874, '3.20.20.70-FF-000019', NULL, 'Delta-aminolevulinic acid dehydratase', 325, NULL, NULL, 134874),
(134875, '3.90.105.20-FF-000007', NULL, 'Ribosome assembly factor mrt4', 74, NULL, NULL, 134875),
(134876, '3.20.20.60-FF-000016', NULL, 'Isocitrate lyase', 461, NULL, NULL, 134876),
(134877, '1.20.80.10-FF-000055', NULL, 'FERM, ARHGEF and pleckstrin domain-containing protein 1', 112, NULL, NULL, 134877),
(134878, '3.30.342.10-FF-000046', NULL, 'DNA polymerase', 153, NULL, NULL, 134878),
(134879, '2.10.25.10-FF-000841', NULL, 'GM15007', 62, NULL, NULL, 134879),
(134880, '3.40.720.10-FF-000024', NULL, 'Sulfatase YdeN', 421, NULL, NULL, 134880),
(134881, '1.10.287.950-FF-000020', NULL, 'Heme-based aerotactic transducer HemAT', 207, NULL, NULL, 134881),
(134882, '3.30.160.60-FF-003297', NULL, 'Si:ch211-266d19.4', 28, NULL, NULL, 134882),
(134883, '1.25.40.20-FF-001276', NULL, 'Uncharacterized protein', 180, NULL, NULL, 134883),
(134884, '2.60.40.10-FF-004140', NULL, NULL, 90, NULL, NULL, 134884),
(134885, '3.90.380.10-FF-000019', NULL, 'Neverland', 200, NULL, NULL, 134885),
(134886, '3.90.80.10-FF-000002', NULL, 'Soluble inorganic pyrophosphatase 4', 179, NULL, NULL, 134886),
(134887, '1.25.40.10-FF-003173', NULL, 'Putative pentatricopeptide repeat-containing protein At3g15200', 109, NULL, NULL, 134887),
(134888, '3.40.50.1820-FF-001043', NULL, 'Serine carboxypeptidase-like 45', 94, NULL, NULL, 134888),
(134889, '3.30.70.250-FF-000012', NULL, 'Malonyl CoA-acyl carrier protein transacylase', 67, NULL, NULL, 134889),
(134890, '3.30.70.100-FF-000012', NULL, 'Acylphosphatase', 91, NULL, NULL, 134890),
(134891, '1.10.390.10-FF-000107', NULL, 'Uncharacterized protein', 228, NULL, NULL, 134891),
(134892, '3.30.230.130-FF-000012', NULL, 'Cullin-1, putative', 150, NULL, NULL, 134892),
(134893, '3.80.10.10-FF-004197', NULL, 'Toll-like receptor', 266, NULL, NULL, 134893),
(134894, '2.130.10.10-FF-005641', NULL, 'Protein GFS12', 175, NULL, NULL, 134894),
(134895, '2.60.40.10-FF-003651', NULL, NULL, 89, NULL, NULL, 134895),
(134896, '2.60.40.10-FF-003297', NULL, NULL, 90, NULL, NULL, 134896),
(134897, '3.30.160.60-FF-003960', NULL, 'GM16127', 62, NULL, NULL, 134897);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(134898, '1.10.565.10-FF-000008', NULL, 'Nuclear receptor subfamily 4 group A member 1', 245, NULL, NULL, 134898),
(134899, '1.10.540.10-FF-000024', NULL, 'Acyl-CoA dehydrogenase FadE1', 132, NULL, NULL, 134899),
(134900, '1.20.1720.10-FF-000125', NULL, NULL, 235, NULL, NULL, 134900),
(134901, '3.40.50.300-FF-003808', NULL, 'ATP-dependent Zn protease', 177, NULL, NULL, 134901),
(134902, '1.20.120.1080-FF-000047', NULL, 'Pre-mRNA splicing factor ATP-dependent RNA helicase', 158, NULL, NULL, 134902),
(134903, '3.40.50.300-FF-003904', NULL, 'ABC transporter, ATP-binding protein', 232, NULL, NULL, 134903),
(134904, '2.40.50.140-FF-000836', NULL, NULL, 80, NULL, NULL, 134904),
(134905, '1.10.10.1800-FF-000005', NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', 99, NULL, NULL, 134905),
(134906, '2.30.30.140-FF-000115', NULL, 'Tudor/PWWP/MBT superfamily protein', 118, NULL, NULL, 134906),
(134907, '3.10.400.20-FF-000021', NULL, 'Translation initiation factor SUI1, putative', 212, NULL, NULL, 134907),
(134908, '1.20.120.1910-FF-000004', NULL, 'Cysteinyl-tRNA synthetase 2, mitochondrial', 190, NULL, NULL, 134908),
(134909, '1.20.1070.10-FF-000827', NULL, 'Odorant receptor, family H, subfamily 130, member 1', 312, NULL, NULL, 134909),
(134910, '2.60.40.10-FF-001397', NULL, 'Sidestep, isoform B', 104, NULL, NULL, 134910),
(134911, '1.20.1250.20-FF-000833', NULL, 'GM21103', 383, NULL, NULL, 134911),
(134912, '3.40.50.40-FF-000011', NULL, NULL, 115, NULL, NULL, 134912),
(134913, '3.40.30.10-FF-000361', NULL, 'Selenium binding protein', 84, NULL, NULL, 134913),
(134914, '2.60.120.200-FF-000166', NULL, 'neurexin-1 isoform X4', 190, NULL, NULL, 134914),
(134915, '3.90.520.10-FF-000008', NULL, 'Dwarfin sma', 120, NULL, NULL, 134915),
(134916, '2.30.29.30-FF-000664', NULL, 'Predicted protein', 133, NULL, NULL, 134916),
(134917, '1.25.10.10-FF-001771', NULL, 'Uncharacterized protein', 904, NULL, NULL, 134917),
(134918, '1.10.472.80-FF-000190', NULL, NULL, 128, NULL, NULL, 134918),
(134919, '2.20.100.10-FF-000255', NULL, 'Uncharacterized protein', 33, NULL, NULL, 134919),
(134920, '3.30.160.60-FF-005551', NULL, NULL, 33, NULL, NULL, 134920),
(134921, '1.10.510.10-FF-001624', NULL, 'Uncharacterized protein', 340, NULL, NULL, 134921),
(134922, '6.10.250.3260-FF-000005', NULL, 'Component of cytosolic 80S ribosome and 60S large subunit', 59, NULL, NULL, 134922),
(134923, '3.40.50.620-FF-000465', NULL, 'Nicotinic acid mononucleotide adenylyltransferase', 257, NULL, NULL, 134923),
(134924, '2.60.220.50-FF-000098', NULL, 'Adhesion G protein-coupled receptor D2', 193, NULL, NULL, 134924),
(134925, '1.25.40.10-FF-001273', NULL, 'GM26429', 378, NULL, NULL, 134925),
(134926, '1.10.720.30-FF-000033', NULL, 'Uncharacterized protein, isoform B', 50, NULL, NULL, 134926),
(134927, '1.10.486.10-FF-000049', NULL, 'DNA helicase', 164, NULL, NULL, 134927),
(134928, '1.20.120.1920-FF-000007', NULL, 'Ubiquitin associated protein 1', 37, NULL, NULL, 134928),
(134929, '2.40.50.140-FF-001016', NULL, NULL, 60, NULL, NULL, 134929),
(134930, '3.30.70.2190-FF-000004', NULL, 'FAD-binding oxidoreductase', 111, NULL, NULL, 134930),
(134931, '2.170.120.30-FF-000007', NULL, 'YbbR-like domain-containing protein', 104, NULL, NULL, 134931),
(134932, '2.60.120.10-FF-000051', NULL, 'dTDP-4-dehydrorhamnose 3,5-epimerase', 182, NULL, NULL, 134932),
(134933, '1.50.10.10-FF-000190', NULL, 'Predicted protein', 272, NULL, NULL, 134933),
(134934, '1.10.287.820-FF-000009', NULL, NULL, 82, NULL, NULL, 134934),
(134935, '3.90.580.10-FF-000001', NULL, 'DNA primase', 100, NULL, NULL, 134935),
(134936, '3.40.1110.10-FF-000196', NULL, 'Copper-(Or silver)-translocating P-type ATPase', 123, NULL, NULL, 134936),
(134937, '1.10.510.10-FF-003299', NULL, NULL, 85, NULL, NULL, 134937),
(134938, '3.30.1490.20-FF-000072', NULL, 'Tubulin tyrosine ligase protein, putative', 48, NULL, NULL, 134938),
(134939, '3.80.10.10-FF-003224', NULL, 'Uncharacterized protein', 364, NULL, NULL, 134939),
(134940, '3.30.450.20-FF-000188', NULL, 'Heme-regulated cyclic AMP phosphodiesterase (Direct oxygen sensor protein)', 124, NULL, NULL, 134940);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(134941, '3.30.9.10-FF-000227', NULL, 'Uncharacterized protein', 111, NULL, NULL, 134941),
(134942, '4.10.410.10-FF-000071', NULL, 'Uncharacterized protein', 53, NULL, NULL, 134942),
(134943, '3.90.1530.10-FF-000014', NULL, 'ParB domain protein nuclease', 88, NULL, NULL, 134943),
(134944, '1.25.40.20-FF-000303', NULL, 'Ankyrin repeat and SOCS box containing 8', 72, NULL, NULL, 134944),
(134945, '1.25.40.10-FF-000997', NULL, 'Related to peroxisomal targeting signal receptor', 335, NULL, NULL, 134945),
(134946, '2.60.40.10-FF-006040', NULL, NULL, 85, NULL, NULL, 134946),
(134947, '1.10.600.10-FF-000097', NULL, 'Ent-kaurene synthase B, chloroplast, putative', 81, NULL, NULL, 134947),
(134948, '1.10.510.10-FF-002113', NULL, 'BUB protein kinase', 317, NULL, NULL, 134948),
(134949, '1.10.150.170-FF-000006', NULL, 'Ribosomal RNA small subunit methyltransferase H', 106, NULL, NULL, 134949),
(134950, '1.25.40.20-FF-001489', NULL, 'Uncharacterized protein', 84, NULL, NULL, 134950),
(134951, '1.20.1250.20-FF-001322', NULL, 'Predicted protein', 190, NULL, NULL, 134951),
(134952, '2.30.30.380-FF-000041', NULL, 'Uncharacterized protein', 51, NULL, NULL, 134952),
(134953, '1.10.510.10-FF-001837', NULL, 'Protein kinase, putative', 118, NULL, NULL, 134953),
(134954, '1.20.58.830-FF-000005', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 143, NULL, NULL, 134954),
(134955, '1.25.40.10-FF-000300', NULL, 'Tetratricopeptide repeat domain 8', 335, NULL, NULL, 134955),
(134956, '1.10.1520.10-FF-000078', NULL, 'Predicted protein', 150, NULL, NULL, 134956),
(134957, '1.10.287.810-FF-000006', NULL, 'mitochondrial import inner membrane translocase subunit Tim10 B', 88, NULL, NULL, 134957),
(134958, '1.20.120.1900-FF-000001', NULL, 'Gamma-tubulin complex component', 304, NULL, NULL, 134958),
(134959, '1.25.40.10-FF-001486', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 90, NULL, NULL, 134959),
(134960, '2.60.40.10-FF-000312', NULL, 'Alpha-2-macroglobulin like 1', 118, NULL, NULL, 134960),
(134961, '1.10.12.10-FF-000033', NULL, 'Enoyl CoA hydratase (PaaF-3)', 57, NULL, NULL, 134961),
(134962, '3.30.70.1070-FF-000011', NULL, 'D-alanyl-D-alanine carboxypeptidase', 78, NULL, NULL, 134962),
(134963, '2.30.130.10-FF-000024', NULL, 'RNA-guided pseudouridylation complex pseudouridine synthase subunit Cbf5', 96, NULL, NULL, 134963),
(134964, '3.30.450.60-FF-000076', NULL, 'AP complex subunit sigma', 134, NULL, NULL, 134964),
(134965, '3.15.10.20-FF-000005', NULL, 'Hch1p', 151, NULL, NULL, 134965),
(134966, '3.30.390.30-FF-000040', NULL, 'NADH-rubredoxin oxidoreductase', 83, NULL, NULL, 134966),
(134967, '3.50.30.30-FF-000052', NULL, 'Aminopeptidase', 111, NULL, NULL, 134967),
(134968, '3.40.50.12160-FF-000024', NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase', 120, NULL, NULL, 134968),
(134969, '3.30.450.20-FF-000654', NULL, 'Sensory box sensor histidine kinase', 116, NULL, NULL, 134969),
(134970, '3.30.710.10-FF-000475', NULL, 'Predicted protein', 101, NULL, NULL, 134970),
(134971, '1.20.5.170-FF-000027', NULL, 'Tripartite motif-containing 46, isoform CRA_c', 56, NULL, NULL, 134971),
(134972, '1.25.10.10-FF-001658', NULL, 'Uncharacterized protein', 361, NULL, NULL, 134972),
(134973, '2.60.120.200-FF-000727', NULL, 'Uncharacterized protein P4H10.19c', 233, NULL, NULL, 134973),
(134974, '3.90.190.10-FF-000533', NULL, 'Uncharacterized protein', 187, NULL, NULL, 134974),
(134975, '2.130.10.10-FF-002898', NULL, 'Uncharacterized WD repeat-containing protein C26H5.03', 270, NULL, NULL, 134975),
(134976, '2.130.10.10-FF-003516', NULL, 'WD repeat domain 90', 240, NULL, NULL, 134976),
(134977, '3.60.21.10-FF-000125', NULL, 'Serine/threonine protein phosphatase type 5', 339, NULL, NULL, 134977),
(134978, '3.40.630.70-FF-000006', NULL, 'Hypothetical_protein_-_conserved', 192, NULL, NULL, 134978),
(134979, '1.20.140.10-FF-000019', NULL, 'Acyl-CoA dehydrogenase', 148, NULL, NULL, 134979),
(134980, '2.130.10.10-FF-001375', NULL, 'Neurobeachin-like protein 2', 226, NULL, NULL, 134980),
(134981, '2.60.40.10-FF-001408', NULL, 'titin isoform X1', 99, NULL, NULL, 134981);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(134982, '2.40.128.20-FF-000047', NULL, 'Lipocalin-type prostaglandin D synthase-like protein', 165, NULL, NULL, 134982),
(134983, '1.50.10.100-FF-000008', NULL, 'Heparin-sulfate lyase', 364, NULL, NULL, 134983),
(134984, '1.20.1250.20-FF-000266', NULL, 'MFS multidrug transporter, putative', 431, NULL, NULL, 134984),
(134985, '1.10.287.70-FF-000458', NULL, 'Uncharacterized protein', 148, NULL, NULL, 134985),
(134986, '2.60.40.3510-FF-000017', NULL, 'Delta-like protein', 159, NULL, NULL, 134986),
(134987, '1.20.1270.280-FF-000071', NULL, 'Uncharacterized protein', 110, NULL, NULL, 134987),
(134988, '2.130.10.10-FF-005074', NULL, 'Coronin', 268, NULL, NULL, 134988),
(134989, '3.30.420.10-FF-000144', NULL, 'Ribonuclease H', 146, NULL, NULL, 134989),
(134990, '3.90.70.80-FF-000039', NULL, 'Extracellular OTU-like cysteine protease, putative (AFU_orthologue AFUA_5G11300)', 143, NULL, NULL, 134990),
(134991, '1.10.630.10-FF-000374', NULL, '9-divinyl ether synthase', 414, NULL, NULL, 134991),
(134992, '3.30.1330.80-FF-000016', NULL, 'Uncharacterized protein', 140, NULL, NULL, 134992),
(134993, '1.20.1510.10-FF-000087', NULL, NULL, 90, NULL, NULL, 134993),
(134994, '3.30.70.2850-FF-000017', NULL, 'Uncharacterized protein', 170, NULL, NULL, 134994),
(134995, '3.30.200.20-FF-001546', NULL, 'Uncharacterized protein', 73, NULL, NULL, 134995),
(134996, '1.10.287.70-FF-000363', NULL, 'Ionotropic receptor 48c', 132, NULL, NULL, 134996),
(134997, '2.60.40.10-FF-001835', NULL, 'Cytokine receptor common subunit beta', 92, NULL, NULL, 134997),
(134998, '3.30.70.1390-FF-000006', NULL, 'Cyclic GMP-binding protein C', 74, NULL, NULL, 134998),
(134999, '3.30.420.40-FF-001086', NULL, 'Uncharacterized protein', 113, NULL, NULL, 134999),
(135000, '1.25.40.10-FF-002211', NULL, 'F20D22.10 protein', 154, NULL, NULL, 135000),
(135001, '1.20.1050.80-FF-000015', NULL, 'Vacuolar sorting protein', 169, NULL, NULL, 135001),
(135002, '1.10.260.30-FF-000003', NULL, 'Signal recognition particle 54 kDa protein', 138, NULL, NULL, 135002),
(135003, '1.25.10.10-FF-000034', NULL, 'AT-rich interactive domain-containing protein 1B', 285, NULL, NULL, 135003),
(135004, '3.30.1330.90-FF-000019', NULL, 'Probable L-serine dehydratase, alpha chain', 126, NULL, NULL, 135004),
(135005, '2.40.50.150-FF-000030', NULL, 'DNA-directed RNA polymerase subunit beta', 47, NULL, NULL, 135005),
(135006, '2.130.10.130-FF-000022', NULL, 'integrin alpha-PS1 isoform X1', 450, NULL, NULL, 135006),
(135007, '3.40.50.200-FF-000002', NULL, 'Proprotein convertase subtilisin/kexin type 5', 328, NULL, NULL, 135007),
(135008, '2.170.16.10-FF-000021', NULL, 'Replication factor C small subunit', 97, NULL, NULL, 135008),
(135009, '3.40.50.12470-FF-000016', NULL, NULL, 142, NULL, NULL, 135009),
(135010, '3.40.50.1820-FF-000088', NULL, 'SERAC1 isoform 1', 259, NULL, NULL, 135010),
(135011, '2.10.25.10-FF-000515', NULL, 'latent-transforming growth factor beta-binding protein 1 isoform X6', 39, NULL, NULL, 135011),
(135012, '1.10.1420.10-FF-000014', NULL, 'DNA mismatch repair protein', 170, NULL, NULL, 135012),
(135013, '3.40.920.10-FF-000005', NULL, '2-oxoglutarate ferredoxin oxidoreductase subunit alpha', 186, NULL, NULL, 135013),
(135014, '1.20.1070.10-FF-000491', NULL, 'Protein CBR-CFZ-2', 343, NULL, NULL, 135014),
(135015, '1.25.40.10-FF-003740', NULL, 'Uncharacterized protein', 112, NULL, NULL, 135015),
(135016, '3.40.50.300-FF-001089', NULL, 'RNA helicase', 250, NULL, NULL, 135016),
(135017, '3.20.20.80-FF-000354', NULL, 'Alpha-amylase', 345, NULL, NULL, 135017),
(135018, '3.40.50.620-FF-000673', NULL, 'Isoleucine--tRNA ligase', 324, NULL, NULL, 135018),
(135019, '3.40.50.1820-FF-000992', NULL, 'Thioesterase PikA5', 246, NULL, NULL, 135019),
(135020, '1.20.1740.10-FF-000008', NULL, 'large neutral amino acids transporter small subunit 2', 451, NULL, NULL, 135020),
(135021, '3.30.300.20-FF-000076', NULL, 'Uncharacterized protein', 64, NULL, NULL, 135021),
(135022, '4.10.400.10-FF-000143', NULL, 'low-density lipoprotein receptor-related protein 1-like', 39, NULL, NULL, 135022); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(135023, '3.40.50.2300-FF-000693', NULL, 'Glutamate receptor 1.2', 93, NULL, NULL, 135023),
(135024, '1.10.510.10-FF-001736', NULL, 'Serine/threonine-protein kinase', 174, NULL, NULL, 135024),
(135025, '1.10.40.30-FF-000025', NULL, 'Aspartate ammonia-lyase', 57, NULL, NULL, 135025),
(135026, '1.20.1560.10-FF-000820', NULL, 'Uncharacterized protein', 81, NULL, NULL, 135026),
(135027, '2.40.50.140-FF-000398', NULL, 'Ribosomal protein S1-like1', 66, NULL, NULL, 135027),
(135028, '1.25.40.800-FF-000004', NULL, 'NOT family protein, putative', 139, NULL, NULL, 135028),
(135029, '1.10.150.50-FF-000091', NULL, 'polycomb protein Sfmbt isoform X1', 86, NULL, NULL, 135029),
(135030, '3.40.250.10-FF-000162', NULL, 'Protein-tyrosine-phosphatase, putative', 123, NULL, NULL, 135030),
(135031, '3.40.50.720-FF-000832', NULL, 'Similar to D-3-phosphoglycerate dehydrogenase', 108, NULL, NULL, 135031),
(135032, '1.20.1110.10-FF-000202', NULL, NULL, 105, NULL, NULL, 135032),
(135033, '2.60.40.150-FF-000799', NULL, 'Uncharacterized protein', 61, NULL, NULL, 135033),
(135034, '1.25.40.10-FF-003408', NULL, 'Pentatricopeptide repeat-containing protein', 123, NULL, NULL, 135034),
(135035, '2.60.40.10-FF-001740', NULL, 'NPHS1, nephrin', 93, NULL, NULL, 135035),
(135036, '3.90.215.10-FF-000013', NULL, 'Fibrinogen-like protein 1', 163, NULL, NULL, 135036),
(135037, '3.40.50.300-FF-006889', NULL, 'Uncharacterized protein', 244, NULL, NULL, 135037),
(135038, '3.40.630.60-FF-000003', NULL, 'Ornithine decarboxylase antizyme 1', 133, NULL, NULL, 135038),
(135039, '1.10.10.350-FF-000031', NULL, NULL, 107, NULL, NULL, 135039),
(135040, '3.40.50.150-FF-001807', NULL, NULL, 116, NULL, NULL, 135040),
(135041, '3.20.20.70-FF-000351', NULL, 'IMPDH2 isoform 4', 300, NULL, NULL, 135041),
(135042, '1.20.58.60-FF-000097', NULL, 'microtubule-actin cross-linking factor 1 isoform X2', 111, NULL, NULL, 135042),
(135043, '3.40.50.2300-FF-001210', NULL, NULL, 46, NULL, NULL, 135043),
(135044, '3.10.20.90-FF-000216', NULL, 'Regulator of G-protein signaling 14', 72, NULL, NULL, 135044),
(135045, '1.10.3210.10-FF-000004', NULL, 'Guanosine-5''-triphosphate,3''-diphosphate pyrophosphatase', 190, NULL, NULL, 135045),
(135046, '3.40.50.2000-FF-000597', NULL, 'Uncharacterized protein', 88, NULL, NULL, 135046),
(135047, '2.60.120.260-FF-000594', NULL, 'Uncharacterized protein', 152, NULL, NULL, 135047),
(135048, '2.60.40.10-FF-001509', NULL, 'Uncharacterized protein, isoform D', 105, NULL, NULL, 135048),
(135049, '2.40.50.790-FF-000002', NULL, 'Tudor, isoform B', 46, NULL, NULL, 135049),
(135050, '4.10.240.10-FF-000158', NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', 69, NULL, NULL, 135050),
(135051, '3.20.20.60-FF-000128', NULL, 'Pyruvate kinase', 74, NULL, NULL, 135051),
(135052, '1.10.238.10-FF-000501', NULL, 'Calcium-binding protein 4a', 81, NULL, NULL, 135052),
(135053, '3.40.850.10-FF-000466', NULL, 'Kinesin motor domain containing protein', 366, NULL, NULL, 135053),
(135054, '3.40.630.30-FF-000247', NULL, 'RNA cytidine acetyltransferase', 219, NULL, NULL, 135054),
(135055, '4.10.240.10-FF-000046', NULL, 'Transcription factor', 43, NULL, NULL, 135055),
(135056, '3.40.50.300-FF-007283', NULL, 'Uncharacterized protein', 154, NULL, NULL, 135056),
(135057, '3.40.50.300-FF-007395', NULL, 'mRNA cleavage and polyadenylation factor clp1', 247, NULL, NULL, 135057),
(135058, '1.20.1560.10-FF-000915', NULL, 'ATP-binding cassette transporter, subfamily B, member 6, group TAP protein PpABCB6', 131, NULL, NULL, 135058),
(135059, '2.30.29.30-FF-000905', NULL, 'Insulin receptor substrate 1', 105, NULL, NULL, 135059),
(135060, '3.40.430.10-FF-000029', NULL, 'Bifunctional dihydrofolate reductase-thymidylate synthase', 196, NULL, NULL, 135060),
(135061, '1.10.8.60-FF-000216', NULL, 'Spermatogenesis associated 5', 41, NULL, NULL, 135061),
(135062, '3.30.70.330-FF-002986', NULL, NULL, 87, NULL, NULL, 135062),
(135063, '2.60.40.150-FF-000001', NULL, 'Regulating synaptic membrane exocytosis 3, isoform CRA_a', 150, NULL, NULL, 135063),
(135064, '1.10.8.60-FF-000104', NULL, 'DNA polymerase epsilon subunit', 70, NULL, NULL, 135064);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(135065, '2.30.30.810-FF-000001', NULL, 'DNA repair protein crb2', 72, NULL, NULL, 135065),
(135066, '3.40.50.150-FF-000610', NULL, 'Nucleolar protein NOP2', 212, NULL, NULL, 135066),
(135067, '2.60.120.10-FF-000500', NULL, 'Uncharacterized protein', 132, NULL, NULL, 135067),
(135068, '1.10.3380.20-FF-000008', NULL, 'DNA polymerase theta', 170, NULL, NULL, 135068),
(135069, '3.30.160.20-FF-000115', NULL, 'Peptide chain release factor 1', 60, NULL, NULL, 135069),
(135070, '3.90.640.10-FF-000282', NULL, 'Uncharacterized protein', 109, NULL, NULL, 135070),
(135071, '3.30.530.20-FF-000121', NULL, 'Uncharacterized protein', 145, NULL, NULL, 135071),
(135072, '4.10.860.120-FF-000020', NULL, 'DNA-directed RNA polymerase subunit', 115, NULL, NULL, 135072),
(135073, '1.25.40.20-FF-001388', NULL, 'Predicted protein', 58, NULL, NULL, 135073),
(135074, '3.40.33.10-FF-000058', NULL, 'peptidase inhibitor 16 isoform X1', 203, NULL, NULL, 135074),
(135075, '3.90.1170.40-FF-000023', NULL, 'Molybdenum cofactor biosynthesis protein D/E', 140, NULL, NULL, 135075),
(135076, '3.40.50.410-FF-000048', NULL, 'von Willebrand factor A domain-related protein', 200, NULL, NULL, 135076),
(135077, '1.10.3380.10-FF-000005', NULL, 'Pre-mRNA splicing helicase, putative', 134, NULL, NULL, 135077),
(135078, '1.10.640.10-FF-000094', NULL, 'Uncharacterized protein', 307, NULL, NULL, 135078),
(135079, '3.80.10.10-FF-002168', NULL, 'Leucine rich repeat containing 41', 208, NULL, NULL, 135079),
(135080, '1.10.10.200-FF-000014', NULL, 'Putative transcriptional regulatory protein', 46, NULL, NULL, 135080),
(135081, '3.40.50.300-FF-007507', NULL, 'Uncharacterized protein', 220, NULL, NULL, 135081),
(135082, '3.40.50.1460-FF-000058', NULL, 'Uncharacterized protein', 237, NULL, NULL, 135082),
(135083, '1.10.3080.10-FF-000061', NULL, 'Chloride channel protein EriC', 397, NULL, NULL, 135083),
(135084, '3.10.580.10-FF-000070', NULL, 'Cyclin and CBS domain divalent metal cation transport mediator 4', 45, NULL, NULL, 135084),
(135085, '1.10.630.10-FF-000475', NULL, 'Uncharacterized protein', 298, NULL, NULL, 135085),
(135086, '1.20.1250.20-FF-001081', NULL, 'Inositol transporter 4', 148, NULL, NULL, 135086),
(135087, '1.10.10.10-FF-001826', NULL, 'Predicted protein', 99, NULL, NULL, 135087),
(135088, '2.130.10.10-FF-001476', NULL, 'Dynein intermediate chain 3, ciliary', 168, NULL, NULL, 135088),
(135089, '3.40.50.300-FF-006310', NULL, 'Elongation factor like GTPase 1', 171, NULL, NULL, 135089),
(135090, '3.30.300.30-FF-000079', NULL, 'Peptide synthetase Nrp', 98, NULL, NULL, 135090),
(135091, '3.30.40.10-FF-001025', NULL, 'Predicted protein', 101, NULL, NULL, 135091),
(135092, '3.90.1150.10-FF-000468', NULL, 'Predicted protein', 124, NULL, NULL, 135092),
(135093, '1.10.510.10-FF-000899', NULL, 'Serine/threonine protein kinase', 224, NULL, NULL, 135093),
(135094, '3.80.10.10-FF-004534', NULL, 'F-box/leucine rich repeat protein, putative', 187, NULL, NULL, 135094),
(135095, '3.50.50.60-FF-000854', NULL, 'Flavin-containing monooxygenase', 17, NULL, NULL, 135095),
(135096, '3.40.1380.10-FF-000030', NULL, 'Uncharacterized protein', 213, NULL, NULL, 135096),
(135097, '3.40.50.1820-FF-000880', NULL, 'Uncharacterized protein', 293, NULL, NULL, 135097),
(135098, '1.50.40.10-FF-000354', NULL, 'Solute carrier family 25 member 33', 190, NULL, NULL, 135098),
(135099, '1.25.10.10-FF-001451', NULL, 'Protein CELLULOSE SYNTHASE INTERACTIVE 3', 264, NULL, NULL, 135099),
(135100, '1.10.510.10-FF-003754', NULL, NULL, 142, NULL, NULL, 135100),
(135101, '3.30.365.10-FF-000065', NULL, 'Uncharacterized protein', 30, NULL, NULL, 135101),
(135102, '1.20.970.40-FF-000001', NULL, 'Mesothelin', 62, NULL, NULL, 135102),
(135103, '3.40.1380.20-FF-000033', NULL, 'GD12403', 148, NULL, NULL, 135103),
(135104, '1.10.287.110-FF-000111', NULL, 'Heat shock protein DnaJ homologue Pfj2', 115, NULL, NULL, 135104),
(135105, '3.20.20.105-FF-000004', NULL, 'Queuine tRNA-ribosyltransferase', 360, NULL, NULL, 135105),
(135106, '3.40.50.200-FF-000103', NULL, 'Alkaline serine protease AorO, putative (AFU_orthologue AFUA_6G10250)', 357, NULL, NULL, 135106);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(135107, '1.25.40.10-FF-002003', NULL, 'Os02g0555100 protein', 130, NULL, NULL, 135107),
(135108, '2.60.120.10-FF-000275', NULL, 'Mannose-6-phosphate isomerase', 90, NULL, NULL, 135108),
(135109, '1.10.8.480-FF-000015', NULL, 'rRNA adenine N(6)-methyltransferase', 98, NULL, NULL, 135109),
(135110, '3.30.930.10-FF-000115', NULL, 'Phenylalanine-tRNA ligase, beta subunit', 229, NULL, NULL, 135110),
(135111, '3.90.70.10-FF-000400', NULL, 'SPbeta prophage-derived sublancin-168-processing and transport ATP-binding protein SunT', 149, NULL, NULL, 135111),
(135112, '1.20.1070.10-FF-000277', NULL, 'Muscarinic acetylcholine receptor A-type', 111, NULL, NULL, 135112),
(135113, '1.10.520.10-FF-000028', NULL, 'Peroxidase', 113, NULL, NULL, 135113),
(135114, '3.40.50.2300-FF-000485', NULL, 'Chemotaxis protein CheC--inhibitor of MCP methylation', 119, NULL, NULL, 135114),
(135115, '3.30.160.60-FF-001268', NULL, 'Uncharacterized protein, isoform C', 73, NULL, NULL, 135115),
(135116, '3.20.20.190-FF-000008', NULL, 'Phosphoinositide phospholipase C', 303, NULL, NULL, 135116),
(135117, '2.60.40.10-FF-005096', NULL, NULL, 99, NULL, NULL, 135117),
(135118, '3.40.50.2000-FF-000485', NULL, 'Alpha-1,3/1,6-mannosyltransferase alg-2', 207, NULL, NULL, 135118),
(135119, '1.10.275.60-FF-000006', NULL, 'Uncharacterized protein', 13, NULL, NULL, 135119),
(135120, '3.80.10.10-FF-001100', NULL, 'relaxin receptor 1 isoform X2', 125, NULL, NULL, 135120),
(135121, '3.30.160.60-FF-005871', NULL, NULL, 48, NULL, NULL, 135121),
(135122, '3.30.200.20-FF-001451', NULL, 'Myosin heavy chain kinase C', 53, NULL, NULL, 135122),
(135123, '1.10.287.130-FF-000117', NULL, 'Sensor histidine kinase', 63, NULL, NULL, 135123),
(135124, '1.10.10.10-FF-000989', NULL, 'Histone acetyltransferase', 36, NULL, NULL, 135124),
(135125, '2.170.180.11-FF-000006', NULL, 'Methuselah-like 8, isoform B', 122, NULL, NULL, 135125),
(135126, '3.30.460.10-FF-000039', NULL, 'Ribosomal silencing factor RsfS', 106, NULL, NULL, 135126),
(135127, '3.40.50.1010-FF-000283', NULL, NULL, 90, NULL, NULL, 135127),
(135128, '1.20.1270.60-FF-000133', NULL, 'SLIT-ROBO Rho GTPase-activating protein 2', 62, NULL, NULL, 135128),
(135129, '3.20.20.80-FF-000466', NULL, 'Beta-1,3-exoglucosidase (Eurofung)', 372, NULL, NULL, 135129),
(135130, '3.40.220.10-FF-000008', NULL, 'Orf1a polyprotein', 179, NULL, NULL, 135130),
(135131, '1.10.10.1150-FF-000001', NULL, NULL, 88, NULL, NULL, 135131),
(135132, '3.10.280.10-FF-000018', NULL, 'Hypothetical_protein_-_conserved', 92, NULL, NULL, 135132),
(135133, '2.60.40.10-FF-003538', NULL, NULL, 91, NULL, NULL, 135133),
(135134, '3.60.10.10-FF-000319', NULL, 'Predicted protein', 278, NULL, NULL, 135134),
(135135, '1.50.40.10-FF-000236', NULL, 'Uncharacterized protein', 195, NULL, NULL, 135135),
(135136, '3.20.20.70-FF-000463', NULL, 'Pentafunctional AROM polypeptide, putative', 235, NULL, NULL, 135136),
(135137, '2.60.120.1300-FF-000001', NULL, 'Uncharacterized protein', 86, NULL, NULL, 135137),
(135138, '3.30.310.130-FF-000031', NULL, 'FI06413p', 140, NULL, NULL, 135138),
(135139, '2.130.10.10-FF-003730', NULL, 'Uncharacterized protein', 336, NULL, NULL, 135139),
(135140, '3.70.10.10-FF-000122', NULL, 'Checkpoint protein', 161, NULL, NULL, 135140),
(135141, '3.40.50.10240-FF-000016', NULL, 'Thiamin pyrophosphokinase 1', 220, NULL, NULL, 135141),
(135142, '3.30.420.10-FF-000262', NULL, 'Gag-Pol polyprotein', 145, NULL, NULL, 135142),
(135143, '3.30.70.1230-FF-000183', NULL, 'Predicted protein', 176, NULL, NULL, 135143),
(135144, '3.90.1460.10-FF-000002', NULL, 'General transcription factor II-I isoform 1', 111, NULL, NULL, 135144),
(135145, '3.40.50.1820-FF-000981', NULL, 'Protein ABHD8', 256, NULL, NULL, 135145),
(135146, '1.20.1740.10-FF-000019', NULL, 'Tryptophan permease TnaB', 404, NULL, NULL, 135146),
(135147, '2.60.40.3120-FF-000007', NULL, 'Zinc carboxypeptidase, putative', 144, NULL, NULL, 135147),
(135148, '1.10.10.10-FF-001147', NULL, 'Predicted protein', 103, NULL, NULL, 135148),
(135149, '1.20.930.40-FF-000004', NULL, 'N-acetylated alpha-linked acidic dipeptidase like 2', 133, NULL, NULL, 135149);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(135150, '3.90.640.10-FF-000169', NULL, 'Heat shock protein family A (Hsp70) member 13', 35, NULL, NULL, 135150),
(135151, '2.60.120.200-FF-000615', NULL, 'Uncharacterized protein', 148, NULL, NULL, 135151),
(135152, '3.80.10.10-FF-002853', NULL, 'Uncharacterized protein', 192, NULL, NULL, 135152),
(135153, '3.60.21.10-FF-000013', NULL, 'Bis(5''-nucleosyl)-tetraphosphatase, symmetrical', 280, NULL, NULL, 135153),
(135154, '3.20.20.80-FF-000707', NULL, 'Beta-mannosidase, putative', 317, NULL, NULL, 135154),
(135155, '3.20.20.80-FF-000365', NULL, 'Putative glucosylceramidase/O-glycosyl hydrolase', 345, NULL, NULL, 135155),
(135156, '3.30.710.10-FF-000363', NULL, 'BTB/POZ domain-containing protein At3g09030', 94, NULL, NULL, 135156),
(135157, '3.90.1750.10-FF-000103', NULL, 'Predicted protein', 79, NULL, NULL, 135157),
(135158, '3.10.20.90-FF-000430', NULL, 'Ubiquitin family protein', 103, NULL, NULL, 135158),
(135159, '3.30.460.10-FF-000028', NULL, 'DNA nucleotidylexotransferase', 139, NULL, NULL, 135159),
(135160, '3.40.50.720-FF-000944', NULL, 'Sterol-4alpha-carboxylate 3-dehydrogenase (Decarboxylating)', 278, NULL, NULL, 135160),
(135161, '3.30.160.60-FF-001734', NULL, 'Zinc finger protein, putative', 27, NULL, NULL, 135161),
(135162, '3.40.50.150-FF-001684', NULL, NULL, 121, NULL, NULL, 135162),
(135163, '3.80.10.10-FF-002623', NULL, 'Disease resistance protein (TIR-NBS-LRR class)', 378, NULL, NULL, 135163),
(135164, '1.20.58.60-FF-000877', NULL, 'Kalirin RhoGEF kinase a', 183, NULL, NULL, 135164),
(135165, '3.60.10.10-FF-000196', NULL, 'Endonuclease/exonuclease/phosphatase, putative', 281, NULL, NULL, 135165),
(135166, '1.10.418.20-FF-000035', NULL, 'Uncharacterized protein', 16, NULL, NULL, 135166),
(135167, '3.80.10.10-FF-000482', NULL, 'Transforming growth factor beta activator LRRC32', 132, NULL, NULL, 135167),
(135168, '3.40.630.30-FF-000461', NULL, 'Uncharacterized protein', 223, NULL, NULL, 135168),
(135169, '3.40.50.300-FF-001555', NULL, 'Putative ATP-dependent RNA helicase', 141, NULL, NULL, 135169),
(135170, '1.20.1300.10-FF-000014', NULL, 'Succinate dehydrogenase subunit 3-1, mitochondrial', 102, NULL, NULL, 135170),
(135171, '3.90.470.40-FF-000007', NULL, 'Uncharacterized protein', 98, NULL, NULL, 135171),
(135172, '3.10.590.10-FF-000008', NULL, 'Ubiquinol-cytochrome C reductase', 137, NULL, NULL, 135172),
(135173, '3.30.40.10-FF-002099', NULL, 'Uncharacterized protein', 76, NULL, NULL, 135173),
(135174, '1.20.5.100-FF-000034', NULL, 'Integrin beta', 43, NULL, NULL, 135174),
(135175, '3.80.10.10-FF-000824', NULL, 'Receptor-like protein kinase HSL1 isoform A', 152, NULL, NULL, 135175),
(135176, '1.20.1300.20-FF-000017', NULL, 'Os02g0521500 protein', 106, NULL, NULL, 135176),
(135177, '1.10.510.10-FF-001383', NULL, 'Serine/threonine protein kinase', 168, NULL, NULL, 135177),
(135178, '1.20.58.530-FF-000022', NULL, 'Myosin heavy chain, muscle', 57, NULL, NULL, 135178),
(135179, '1.20.1050.10-FF-000169', NULL, 'Glutathione S-transferase epsilon class 6', 139, NULL, NULL, 135179),
(135180, '2.130.10.10-FF-000402', NULL, 'Cleavage and polyadenylation specificity factor subunit 1', 395, NULL, NULL, 135180),
(135181, '3.20.20.70-FF-000704', NULL, NULL, 146, NULL, NULL, 135181),
(135182, '3.30.190.20-FF-000038', NULL, 'Predicted protein', 87, NULL, NULL, 135182),
(135183, '1.20.1070.10-FF-000619', NULL, 'Uncharacterized protein', 300, NULL, NULL, 135183),
(135184, '3.40.50.300-FF-007384', NULL, 'Predicted protein', 311, NULL, NULL, 135184),
(135185, '1.25.10.10-FF-001119', NULL, 'Cilia- and flagella-associated protein 69', 472, NULL, NULL, 135185),
(135186, '2.60.40.10-FF-002223', NULL, 'KETtiN (Drosophila actin-binding) homolog', 98, NULL, NULL, 135186),
(135187, '1.20.1270.50-FF-000017', NULL, 'Uncharacterized protein', 26, NULL, NULL, 135187),
(135188, '1.10.510.10-FF-000202', NULL, 'Dual specificity testis-specific protein kinase 2', 196, NULL, NULL, 135188),
(135189, '1.10.510.10-FF-002231', NULL, NULL, 174, NULL, NULL, 135189),
(135190, '1.20.140.10-FF-000008', NULL, 'acyl-CoA dehydrogenase family member 9, mitochondrial', 147, NULL, NULL, 135190);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(135191, '3.40.50.12160-FF-000013', NULL, 'Radical SAM protein, putative', 77, NULL, NULL, 135191),
(135192, '3.40.50.12710-FF-000009', NULL, 'Protein arginine methyltransferase NDUFAF7', 394, NULL, NULL, 135192),
(135193, '1.25.40.120-FF-000008', NULL, 'Protein farnesyltransferase subunit alpha', 138, NULL, NULL, 135193),
(135194, '3.30.160.60-FF-003533', NULL, NULL, 28, NULL, NULL, 135194),
(135195, '2.60.120.200-FF-000374', NULL, 'Peptide-N4-(N-acetyl-beta-glucosaminyl)asparagine amidase', 224, NULL, NULL, 135195),
(135196, '3.40.30.90-FF-000002', NULL, 'Eukaryotic translation elongation factor 1 epsilon-1', 42, NULL, NULL, 135196),
(135197, '1.10.1040.10-FF-000047', NULL, '2-dehydropantoate 2-reductase', 151, NULL, NULL, 135197),
(135198, '3.40.605.10-FF-000048', NULL, 'Probable aldehyde dehydrogenase', 263, NULL, NULL, 135198),
(135199, '3.40.50.300-FF-000127', NULL, 'Ribose import ATP-binding protein RbsA', 240, NULL, NULL, 135199),
(135200, '3.40.50.10380-FF-000030', NULL, 'Malic enzyme', 244, NULL, NULL, 135200),
(135201, '3.40.1110.10-FF-000432', NULL, NULL, 183, NULL, NULL, 135201),
(135202, '3.40.50.720-FF-000259', NULL, 'Sepiapterin reductase', 255, NULL, NULL, 135202),
(135203, '4.10.280.10-FF-000155', NULL, 'Upstream stimulatory factor 2', 50, NULL, NULL, 135203),
(135204, '1.20.1070.10-FF-002177', NULL, 'Uncharacterized protein', 323, NULL, NULL, 135204),
(135205, '3.20.20.140-FF-000347', NULL, 'Uncharacterized protein', 329, NULL, NULL, 135205),
(135206, '2.80.10.50-FF-000203', NULL, 'Predicted protein', 155, NULL, NULL, 135206),
(135207, '3.40.50.300-FF-007406', NULL, 'ABC transporter, putative', 156, NULL, NULL, 135207),
(135208, '1.25.40.10-FF-005084', NULL, 'Uncharacterized protein', 187, NULL, NULL, 135208),
(135209, '1.25.40.10-FF-001385', NULL, 'Os01g0299150 protein', 96, NULL, NULL, 135209),
(135210, '2.10.90.10-FF-000121', NULL, 'Protein trunk', 130, NULL, NULL, 135210),
(135211, '2.60.120.200-FF-000716', NULL, 'Predicted protein', 177, NULL, NULL, 135211),
(135212, '1.20.1070.10-FF-001215', NULL, 'Uncharacterized protein', 256, NULL, NULL, 135212),
(135213, '3.40.50.10090-FF-000044', NULL, 'Putative uroporphyrinogen III synthase', 109, NULL, NULL, 135213),
(135214, '3.30.160.60-FF-005663', NULL, NULL, 29, NULL, NULL, 135214),
(135215, '1.25.40.10-FF-003526', NULL, 'Uncharacterized protein', 139, NULL, NULL, 135215),
(135216, '1.20.1410.10-FF-000023', NULL, 'YALI0F30195p', 170, NULL, NULL, 135216),
(135217, '2.60.120.290-FF-000136', NULL, 'GD12774', 120, NULL, NULL, 135217),
(135218, '1.10.510.10-FF-000101', NULL, 'Protein kinase C', 205, NULL, NULL, 135218),
(135219, '2.60.40.10-FF-001947', NULL, NULL, 99, NULL, NULL, 135219),
(135220, '6.10.140.2220-FF-000014', NULL, 'Programmed cell death 2', 54, NULL, NULL, 135220),
(135221, '2.40.160.20-FF-000032', NULL, 'Putative outer membrane protein', 203, NULL, NULL, 135221),
(135222, '3.40.50.1360-FF-000028', NULL, 'Glucosamine-6-phosphate deaminase', 242, NULL, NULL, 135222),
(135223, '3.40.710.10-FF-000068', NULL, 'D-alanyl-D-alanine carboxypeptidase', 266, NULL, NULL, 135223),
(135224, '1.10.555.10-FF-000171', NULL, NULL, 198, NULL, NULL, 135224),
(135225, '2.40.33.10-FF-000004', NULL, 'Pyruvate kinase', 107, NULL, NULL, 135225),
(135226, '3.90.360.10-FF-000018', NULL, 'Uncharacterized protein', 114, NULL, NULL, 135226),
(135227, '3.30.420.510-FF-000001', NULL, 'pantothenate kinase 2, mitochondrial', 167, NULL, NULL, 135227),
(135228, '2.60.120.380-FF-000051', NULL, 'Serine/threonine-protein kinase 4 homolog B', 149, NULL, NULL, 135228),
(135229, '3.80.10.10-FF-004298', NULL, 'Leucine rich repeat containing G protein-coupled receptor 4', 227, NULL, NULL, 135229),
(135230, '2.60.40.10-FF-003746', NULL, NULL, 87, NULL, NULL, 135230),
(135231, '2.30.42.10-FF-000296', NULL, 'Rho GTPase activating protein at 19D, isoform D', 167, NULL, NULL, 135231),
(135232, '2.60.40.10-FF-004022', NULL, NULL, 125, NULL, NULL, 135232),
(135233, '1.10.510.10-FF-002001', NULL, 'Protein CBG00206', 188, NULL, NULL, 135233),
(135234, '1.10.10.350-FF-000042', NULL, NULL, 112, NULL, NULL, 135234);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(135235, '3.20.20.70-FF-000362', NULL, 'Phosphoribosylanthranilate isomerase 1', 149, NULL, NULL, 135235),
(135236, '3.80.10.10-FF-000723', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 72, NULL, NULL, 135236),
(135237, '3.40.50.12780-FF-000199', NULL, 'Uncharacterized protein', 390, NULL, NULL, 135237),
(135238, '1.20.1730.10-FF-000069', NULL, 'Uncharacterized protein', 541, NULL, NULL, 135238),
(135239, '3.30.9.10-FF-000115', NULL, 'Oxidoreductase, FAD dependent', 125, NULL, NULL, 135239),
(135240, '1.25.40.20-FF-001377', NULL, 'Uncharacterized protein', 82, NULL, NULL, 135240),
(135241, '3.20.20.80-FF-000820', NULL, 'Predicted protein', 71, NULL, NULL, 135241),
(135242, '3.40.50.300-FF-001993', NULL, 'DNA helicase, putative', 270, NULL, NULL, 135242),
(135243, '3.40.50.300-FF-003455', NULL, 'Nuclear vcp-like-like protein', 189, NULL, NULL, 135243),
(135244, '3.30.710.10-FF-000464', NULL, 'Uncharacterized protein', 120, NULL, NULL, 135244),
(135245, '1.10.287.70-FF-000469', NULL, 'Predicted protein', 264, NULL, NULL, 135245),
(135246, '3.90.470.20-FF-000001', NULL, 'Holo-[acyl-carrier-protein] synthase', 126, NULL, NULL, 135246),
(135247, '1.25.50.20-FF-000034', NULL, 'Aminopeptidase', 166, NULL, NULL, 135247),
(135248, '1.10.8.60-FF-000093', NULL, 'Fidgetin like 2', 73, NULL, NULL, 135248),
(135249, '3.30.420.10-FF-000582', NULL, NULL, 216, NULL, NULL, 135249),
(135250, '2.60.40.10-FF-000323', NULL, 'Immunoglobulin superfamily member 9B', 94, NULL, NULL, 135250),
(135251, '1.25.40.10-FF-001374', NULL, 'Pentatricopeptide repeat-containing protein', 93, NULL, NULL, 135251),
(135252, '1.10.510.10-FF-001725', NULL, 'Kinase like protein', 174, NULL, NULL, 135252),
(135253, '2.60.40.2440-FF-000005', NULL, 'Protein phosphatase 1 regulatory subunit', 135, NULL, NULL, 135253),
(135254, '2.60.40.10-FF-001285', NULL, 'Usherin', 99, NULL, NULL, 135254),
(135255, '1.20.1070.10-FF-000378', NULL, 'CG18208-like amine receptor', 118, NULL, NULL, 135255),
(135256, '3.30.70.330-FF-000856', NULL, '60S ribosomal protein L23', 121, NULL, NULL, 135256),
(135257, '1.10.10.2910-FF-000001', NULL, 'Metallopeptidase ImmA', 110, NULL, NULL, 135257),
(135258, '4.10.400.10-FF-000244', NULL, 'Serine protease nudel', 45, NULL, NULL, 135258),
(135259, '3.30.70.330-FF-003032', NULL, NULL, 46, NULL, NULL, 135259),
(135260, '2.10.25.10-FF-000723', NULL, 'neurogenic locus notch homolog protein 4 isoform X1', 36, NULL, NULL, 135260),
(135261, '3.60.40.10-FF-000265', NULL, 'Uncharacterized protein', 293, NULL, NULL, 135261),
(135262, '3.40.50.300-FF-003893', NULL, 'ABC transporter ATP-binding protein', 251, NULL, NULL, 135262),
(135263, '2.60.40.3850-FF-000001', NULL, 'Interleukin-3 receptor subunit alpha', 82, NULL, NULL, 135263),
(135264, '3.40.50.300-FF-004511', NULL, 'ATP-dependent DNA helicase', 216, NULL, NULL, 135264),
(135265, '2.30.29.30-FF-000563', NULL, 'Phosphatidylinositol3,4-bisphosphate 4-phosphatase', 119, NULL, NULL, 135265),
(135266, '3.30.160.20-FF-000098', NULL, '30S small subunit ribosomal protein S5', 68, NULL, NULL, 135266),
(135267, '3.10.20.90-FF-000110', NULL, 'GA-binding protein alpha chain isoform X1', 89, NULL, NULL, 135267),
(135268, '3.30.70.330-FF-001132', NULL, 'Uncharacterized protein', 104, NULL, NULL, 135268),
(135269, '2.130.10.10-FF-003836', NULL, 'ADR108Cp', 295, NULL, NULL, 135269),
(135270, '2.60.40.150-FF-000231', NULL, 'Predicted protein', 129, NULL, NULL, 135270),
(135271, '2.10.50.10-FF-000124', NULL, 'Death receptor 6', 89, NULL, NULL, 135271),
(135272, '3.30.70.360-FF-000045', NULL, 'Novel protein aminoacylase 1 family 2 ACY1L2 (Homo sapiens), putative', 50, NULL, NULL, 135272),
(135273, '1.10.287.40-FF-000011', NULL, 'Serine--tRNA ligase, mitochondrial', 116, NULL, NULL, 135273),
(135274, '1.10.3290.20-FF-000001', NULL, 'Avirulence protein', 181, NULL, NULL, 135274),
(135275, '2.40.50.120-FF-000049', NULL, 'TIMP metallopeptidase inhibitor 2b', 94, NULL, NULL, 135275),
(135276, '3.30.200.20-FF-001338', NULL, 'Heme regulated eukaryotic translation initiation factor-like protein', 111, NULL, NULL, 135276);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(135277, '1.10.287.70-FF-000571', NULL, 'Inward rectifier potassium channel 2-like Protein', 127, NULL, NULL, 135277),
(135278, '1.10.1200.10-FF-000144', NULL, 'Novobiocin biosynthesis protein H', 82, NULL, NULL, 135278),
(135279, '3.30.200.20-FF-001108', NULL, 'Kinase, AGC MAST', 87, NULL, NULL, 135279),
(135280, '1.20.1250.20-FF-001204', NULL, 'Uncharacterized protein', 182, NULL, NULL, 135280),
(135281, '3.40.50.2000-FF-000496', NULL, 'Glycosyltransferase 9 family protein', 174, NULL, NULL, 135281),
(135282, '3.40.50.150-FF-001364', NULL, NULL, 285, NULL, NULL, 135282),
(135283, '3.40.50.2000-FF-001114', NULL, 'UDP-glycosyltransferase 90A1', 207, NULL, NULL, 135283),
(135284, '1.25.40.70-FF-000071', NULL, 'Uncharacterized protein', 115, NULL, NULL, 135284),
(135285, '2.40.30.10-FF-000211', NULL, 'Elongation factor 1-alpha, putative', 103, NULL, NULL, 135285),
(135286, '2.30.29.110-FF-000003', NULL, 'Inositol polyphosphate-5-phosphatase B', 150, NULL, NULL, 135286),
(135287, '3.40.50.10190-FF-000282', NULL, 'Uncharacterized protein', 91, NULL, NULL, 135287),
(135288, '1.25.40.10-FF-000879', NULL, 'Pentatricopeptide repeat-containing protein', 180, NULL, NULL, 135288),
(135289, '1.10.20.10-FF-000231', NULL, NULL, 133, NULL, NULL, 135289),
(135290, '3.40.50.2000-FF-000838', NULL, 'Protein CBR-SPR-1', 64, NULL, NULL, 135290),
(135291, '3.40.250.10-FF-000263', NULL, 'Uncharacterized protein', 136, NULL, NULL, 135291),
(135292, '3.50.50.60-FF-000399', NULL, 'FAD-dependent oxidoreductase', 208, NULL, NULL, 135292),
(135293, '2.60.40.840-FF-000011', NULL, 'Uncharacterized protein', 172, NULL, NULL, 135293),
(135294, '1.10.10.10-FF-001927', NULL, 'Uncharacterized protein', 93, NULL, NULL, 135294),
(135295, '2.40.50.140-FF-001224', NULL, NULL, 61, NULL, NULL, 135295),
(135296, '3.30.450.20-FF-000093', NULL, 'Histidine kinase A two component receptor', 124, NULL, NULL, 135296),
(135297, '1.20.140.50-FF-000003', NULL, 'GH16790', 178, NULL, NULL, 135297),
(135298, '2.60.40.10-FF-003185', NULL, NULL, 84, NULL, NULL, 135298),
(135299, '1.10.150.50-FF-000214', NULL, 'B cell linker', 33, NULL, NULL, 135299),
(135300, '3.30.160.60-FF-003179', NULL, 'Zinc finger protein 404', 36, NULL, NULL, 135300),
(135301, '3.40.50.720-FF-001107', NULL, 'D-3-phosphoglycerate dehydrogenase', 58, NULL, NULL, 135301),
(135302, '2.40.50.140-FF-000948', NULL, NULL, 70, NULL, NULL, 135302),
(135303, '3.30.70.330-FF-002756', NULL, NULL, 129, NULL, NULL, 135303),
(135304, '3.10.129.10-FF-000179', NULL, '1,4-dihydroxy-2-naphthoyl-CoA hydrolase', 138, NULL, NULL, 135304),
(135305, '3.30.950.10-FF-000015', NULL, 'Ribosomal RNA small subunit methyltransferase I', 116, NULL, NULL, 135305),
(135306, '2.80.10.50-FF-000080', NULL, 'Dolichyl-phosphate-mannose-protein mannosyltransferase 6', 220, NULL, NULL, 135306),
(135307, '3.40.50.2300-FF-001209', NULL, NULL, 75, NULL, NULL, 135307),
(135308, '3.40.710.10-FF-000181', NULL, 'Penicillin-binding protein 1A', 199, NULL, NULL, 135308),
(135309, '3.40.630.30-FF-000141', NULL, 'Acetyltransferase, GNAT family family', 184, NULL, NULL, 135309),
(135310, '1.20.1250.20-FF-000928', NULL, 'Major facilitator superfamily MFS_1', 216, NULL, NULL, 135310),
(135311, '1.20.1070.10-FF-000939', NULL, 'Predicted protein', 332, NULL, NULL, 135311),
(135312, '3.30.70.260-FF-000127', NULL, 'Tyrosine hydroxylase', 55, NULL, NULL, 135312),
(135313, '1.10.101.10-FF-000027', NULL, 'Carboxy-terminal processing protease', 76, NULL, NULL, 135313),
(135314, '3.50.50.100-FF-000020', NULL, 'NADH dehydrogenase', 384, NULL, NULL, 135314),
(135315, '1.20.1560.10-FF-000926', NULL, 'Uncharacterized protein', 79, NULL, NULL, 135315),
(135316, '1.25.40.180-FF-000329', NULL, NULL, 283, NULL, NULL, 135316),
(135317, '3.40.850.10-FF-000365', NULL, 'Myosin IHb', 178, NULL, NULL, 135317),
(135318, '3.40.1160.10-FF-000047', NULL, 'Acetylglutamate kinase', 239, NULL, NULL, 135318),
(135319, '3.40.50.720-FF-002389', NULL, 'S or R-dihydroxypropanesulfonate-2-dehydrogenase', 127, NULL, NULL, 135319),
(135320, '4.10.1060.10-FF-000063', NULL, 'Zinc finger Ran-binding domain-containing protein 2', 40, NULL, NULL, 135320);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(135321, '2.20.100.10-FF-000137', NULL, 'SPONdin (Extracellular matrix glycoprotein) family', 58, NULL, NULL, 135321),
(135322, '3.30.300.110-FF-000006', NULL, 'Met-10+ like-protein/Methyltransferase small domain/Methyltransferase domain containing protein, putative', 70, NULL, NULL, 135322),
(135323, '3.30.1360.120-FF-000042', NULL, 'Sarcosine oxidase, alpha subunit family protein', 381, NULL, NULL, 135323),
(135324, '1.10.287.500-FF-000003', NULL, 'Protein phosphatase CheZ', 135, NULL, NULL, 135324),
(135325, '3.90.190.10-FF-000544', NULL, 'Uncharacterized protein', 145, NULL, NULL, 135325),
(135326, '1.25.10.10-FF-001557', NULL, 'Uncharacterized protein', 220, NULL, NULL, 135326),
(135327, '1.20.58.390-FF-000053', NULL, 'Neuronal acetylcholine receptor subunit alpha-9', 67, NULL, NULL, 135327),
(135328, '3.30.160.60-FF-000306', NULL, 'Zinc finger and AT-hook domain containing', 28, NULL, NULL, 135328),
(135329, '3.80.10.10-FF-000369', NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', 244, NULL, NULL, 135329),
(135330, '2.130.10.10-FF-005427', NULL, 'Predicted protein', 231, NULL, NULL, 135330),
(135331, '1.25.10.20-FF-000026', NULL, 'Uncharacterized protein', 115, NULL, NULL, 135331),
(135332, '1.10.560.10-FF-000025', NULL, 'T-complex protein 1 subunit zeta isoform X3', 44, NULL, NULL, 135332),
(135333, '3.40.50.2300-FF-001311', NULL, NULL, 116, NULL, NULL, 135333),
(135334, '1.10.220.20-FF-000003', NULL, 'Cytohesin 1', 79, NULL, NULL, 135334),
(135335, '1.25.10.10-FF-003457', NULL, 'Uncharacterized protein', 201, NULL, NULL, 135335),
(135336, '1.25.10.10-FF-000023', NULL, 'AP-3 complex subunit beta', 561, NULL, NULL, 135336),
(135337, '2.40.50.100-FF-000043', NULL, 'Multidrug resistance protein MdtN', 35, NULL, NULL, 135337),
(135338, '3.40.50.300-FF-007945', NULL, 'Uncharacterized protein', 171, NULL, NULL, 135338),
(135339, '3.40.50.1820-FF-000649', NULL, 'Lipase A, lysosomal acid, cholesterol esterase, putative', 166, NULL, NULL, 135339),
(135340, '3.40.190.80-FF-000076', NULL, 'Fructose-1,6-bisphosphatase class 1', 142, NULL, NULL, 135340),
(135341, '1.10.287.660-FF-000023', NULL, 'Tail-anchored protein insertion receptor WRB', 77, NULL, NULL, 135341),
(135342, '1.10.8.60-FF-000205', NULL, 'Origin recognition complex subunit 1', 124, NULL, NULL, 135342),
(135343, '1.10.10.10-FF-001720', NULL, 'Chromosome 7, whole genome shotgun sequence', 115, NULL, NULL, 135343),
(135344, '3.30.160.380-FF-000003', NULL, 'Endoribonuclease dcr-1', 103, NULL, NULL, 135344),
(135345, '3.30.930.10-FF-000126', NULL, 'Phenylalanine-tRNA ligase, beta subunit', 204, NULL, NULL, 135345),
(135346, '2.130.10.10-FF-003275', NULL, 'Wdr1p', 162, NULL, NULL, 135346),
(135347, '2.10.220.10-FF-000125', NULL, 'R-spondin 1', 74, NULL, NULL, 135347),
(135348, '2.60.40.1730-FF-000034', NULL, 'Chromosome 9 open reading frame 3', 194, NULL, NULL, 135348),
(135349, '3.40.50.1110-FF-000083', NULL, 'Phospholipase B1', 202, NULL, NULL, 135349),
(135350, '1.10.220.30-FF-000006', NULL, 'Flagellar motor switch protein FliG', 89, NULL, NULL, 135350),
(135351, '3.40.50.300-FF-008221', NULL, 'ATP-dependent DNA helicase', 65, NULL, NULL, 135351),
(135352, '2.60.120.10-FF-000730', NULL, 'Uncharacterized protein', 130, NULL, NULL, 135352),
(135353, '2.30.310.10-FF-000010', NULL, NULL, 156, NULL, NULL, 135353),
(135354, '3.30.200.20-FF-001440', NULL, 'STK38L isoform 10', 103, NULL, NULL, 135354),
(135355, '3.40.50.11090-FF-000001', NULL, 'Sll5048 protein', 168, NULL, NULL, 135355),
(135356, '2.10.90.10-FF-000019', NULL, 'Sclerostin domain-containing protein 1', 100, NULL, NULL, 135356),
(135357, '1.20.1070.10-FF-000732', NULL, 'Adhesion G protein-coupled receptor L3', 306, NULL, NULL, 135357),
(135358, '2.60.40.640-FF-000041', NULL, 'SPO23p protein', 148, NULL, NULL, 135358),
(135359, '3.30.70.100-FF-000107', NULL, 'Acylphosphatase', 91, NULL, NULL, 135359),
(135360, '2.90.10.30-FF-000006', NULL, 'Serine/threonine-protein kinase', 148, NULL, NULL, 135360),
(135361, '2.130.10.10-FF-002999', NULL, 'Uncharacterized protein', 341, NULL, NULL, 135361);
INSERT INTO "PUBLIC"."MODEL" VALUES
(135362, '3.15.10.10-FF-000002', NULL, 'Cholesteryl ester transfer protein', 190, NULL, NULL, 135362),
(135363, '3.40.50.720-FF-000489', NULL, 'N(5)-(Carboxyethyl)ornithine synthase', 95, NULL, NULL, 135363),
(135364, '3.30.160.60-FF-001279', NULL, 'zinc finger and BTB domain-containing protein 32', 26, NULL, NULL, 135364),
(135365, '2.60.40.3110-FF-000004', NULL, 'Protein CsuD', 90, NULL, NULL, 135365),
(135366, '1.25.40.90-FF-000077', NULL, 'Uncharacterized protein', 144, NULL, NULL, 135366),
(135367, '2.30.29.30-FF-000782', NULL, 'Rho guanine nucleotide exchange factor (GEF) 10', 230, NULL, NULL, 135367),
(135368, '3.40.50.300-FF-005484', NULL, 'Putative ABC transport ATP-binding subunit', 203, NULL, NULL, 135368),
(135369, '3.30.160.390-FF-000006', NULL, 'Site-specific recombinase, phage integrase family domain protein', 56, NULL, NULL, 135369),
(135370, '3.40.50.1100-FF-000080', NULL, 'Diaminopropionate ammonia-lyase', 118, NULL, NULL, 135370),
(135371, '1.20.1250.20-FF-000367', NULL, 'Major facilitator superfamily domain containing 4B', 250, NULL, NULL, 135371),
(135372, '2.60.220.50-FF-000109', NULL, 'Uncharacterized protein', 117, NULL, NULL, 135372),
(135373, '1.25.40.1040-FF-000028', NULL, 'Uncharacterized protein', 505, NULL, NULL, 135373),
(135374, '3.40.50.300-FF-002038', NULL, 'tRNA modification GTPase MnmE', 162, NULL, NULL, 135374),
(135375, '3.40.190.10-FF-000786', NULL, 'Dipeptide ABC superfamily ATP binding cassette transporter, binding protein', 91, NULL, NULL, 135375),
(135376, '1.10.10.10-FF-001259', NULL, 'Manganese transport system membrane protein', 138, NULL, NULL, 135376),
(135377, '1.20.120.850-FF-000005', NULL, 'Helicase arip4 isoform 2', 58, NULL, NULL, 135377),
(135378, '1.20.120.550-FF-000022', NULL, 'Uncharacterized protein', 113, NULL, NULL, 135378),
(135379, '3.40.50.300-FF-006321', NULL, 'Predicted protein', 99, NULL, NULL, 135379),
(135380, '1.20.900.10-FF-000084', NULL, 'Kalirin RhoGEF kinase a', 88, NULL, NULL, 135380),
(135381, '3.65.10.10-FF-000011', NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', 226, NULL, NULL, 135381),
(135382, '3.30.160.60-FF-003752', NULL, NULL, 25, NULL, NULL, 135382),
(135383, '3.40.50.620-FF-000908', NULL, 'Uncharacterized protein', 56, NULL, NULL, 135383),
(135384, '1.20.120.1080-FF-000148', NULL, 'Uncharacterized protein', 125, NULL, NULL, 135384),
(135385, '1.25.40.1030-FF-000025', NULL, 'SEC16 homolog B, endoplasmic reticulum export factor', 214, NULL, NULL, 135385),
(135386, '1.10.8.720-FF-000020', NULL, 'Glutathione S-transferase class-mu 26 kDa isozyme', 165, NULL, NULL, 135386),
(135387, '1.25.40.10-FF-001941', NULL, 'RNA polymerase-associated protein CTR9', 113, NULL, NULL, 135387),
(135388, '3.80.10.10-FF-002741', NULL, 'Uncharacterized protein', 193, NULL, NULL, 135388),
(135389, '3.40.50.300-FF-003573', NULL, 'Zinc transport system ATP-binding protein', 228, NULL, NULL, 135389),
(135390, '1.20.1610.10-FF-000010', NULL, 'Putative conserved exported protein', 160, NULL, NULL, 135390),
(135391, '3.40.50.720-FF-001102', NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', 265, NULL, NULL, 135391),
(135392, '2.60.120.200-FF-000379', NULL, 'Terribly reduced optic lobes, isoform B', 184, NULL, NULL, 135392),
(135393, '1.20.1730.10-FF-000064', NULL, 'Uncharacterized protein', 465, NULL, NULL, 135393),
(135394, '3.40.50.2000-FF-000945', NULL, 'Sterol 3beta-glucosyltransferase', 124, NULL, NULL, 135394),
(135395, '3.30.420.10-FF-000368', NULL, NULL, 170, NULL, NULL, 135395),
(135396, '1.20.920.10-FF-000079', NULL, 'Unplaced genomic scaffold supercont1.199, whole genome shotgun sequence', 107, NULL, NULL, 135396),
(135397, '3.30.70.890-FF-000080', NULL, 'Uncharacterized protein', 73, NULL, NULL, 135397),
(135398, '1.20.1630.10-FF-000005', NULL, 'Putative dimethyl sulfoxide reductase membrane subunit C', 303, NULL, NULL, 135398),
(135399, '2.30.30.140-FF-000328', NULL, 'Histone-lysine N-methyltransferase', 112, NULL, NULL, 135399),
(135400, '2.60.120.920-FF-000027', NULL, 'E3 ubiquitin-protein ligase TRIM50', 189, NULL, NULL, 135400);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(135401, '3.90.1110.10-FF-000010', NULL, 'DNA-directed RNA polymerase subunit beta', 155, NULL, NULL, 135401),
(135402, '2.130.10.10-FF-005298', NULL, 'Uncharacterized protein', 218, NULL, NULL, 135402),
(135403, '3.80.10.10-FF-000594', NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', 130, NULL, NULL, 135403),
(135404, '3.90.640.10-FF-000287', NULL, 'Chromosome 10, whole genome shotgun sequence', 46, NULL, NULL, 135404),
(135405, '3.40.50.10930-FF-000009', NULL, NULL, 131, NULL, NULL, 135405),
(135406, '1.25.40.20-FF-000421', NULL, 'Glycerophosphocholine phosphodiesterase GDE1', 169, NULL, NULL, 135406),
(135407, '3.40.50.10190-FF-000175', NULL, 'DNA ligase 4', 98, NULL, NULL, 135407),
(135408, '3.40.50.10490-FF-000158', NULL, NULL, 202, NULL, NULL, 135408),
(135409, '3.90.850.10-FF-000005', NULL, 'FAA hydrolase family protein', 233, NULL, NULL, 135409),
(135410, '1.20.1560.10-FF-000359', NULL, 'Uncharacterized protein', 507, NULL, NULL, 135410),
(135411, '1.20.58.150-FF-000021', NULL, NULL, 147, NULL, NULL, 135411),
(135412, '3.40.1110.10-FF-000218', NULL, 'Heavy metal translocating P-type ATPase', 106, NULL, NULL, 135412),
(135413, '2.130.10.10-FF-003174', NULL, 'Predicted protein', 95, NULL, NULL, 135413),
(135414, '1.10.150.50-FF-000113', NULL, 'DNA-binding protein D-ETS-6', 83, NULL, NULL, 135414),
(135415, '3.10.105.10-FF-000062', NULL, 'Peptide transport periplasmic protein', 215, NULL, NULL, 135415),
(135416, '2.60.40.10-FF-005438', NULL, NULL, 123, NULL, NULL, 135416),
(135417, '1.25.40.20-FF-000314', NULL, 'Ankyrin-like protein', 139, NULL, NULL, 135417),
(135418, '1.20.1560.10-FF-000466', NULL, 'ABC transporter ATP-binding protein', 323, NULL, NULL, 135418),
(135419, '1.10.8.10-FF-000218', NULL, 'Uncharacterized protein', 44, NULL, NULL, 135419),
(135420, '1.10.510.10-FF-001495', NULL, 'Serine/threonine protein kinase Chk2,putative', 285, NULL, NULL, 135420),
(135421, '1.10.472.140-FF-000008', NULL, 'Retinoblastoma-related protein2', 131, NULL, NULL, 135421),
(135422, '3.10.20.770-FF-000016', NULL, 'Uncharacterized protein', 289, NULL, NULL, 135422),
(135423, '2.40.50.360-FF-000003', NULL, 'RuvB-like helicase', 79, NULL, NULL, 135423),
(135424, '2.130.10.10-FF-003281', NULL, 'WD domain, G-beta repeat, putative', 152, NULL, NULL, 135424),
(135425, '3.40.50.10190-FF-000068', NULL, 'Replication factor C subunit 1', 119, NULL, NULL, 135425),
(135426, '3.40.50.2300-FF-000928', NULL, NULL, 110, NULL, NULL, 135426),
(135427, '3.30.40.10-FF-000856', NULL, 'RBR-type E3 ubiquitin transferase', 86, NULL, NULL, 135427),
(135428, '3.65.10.20-FF-000014', NULL, 'RNA terminal phosphate cyclase like 1', 229, NULL, NULL, 135428),
(135429, '3.30.160.60-FF-002217', NULL, 'RB-associated KRAB zinc finger protein', 26, NULL, NULL, 135429),
(135430, '3.30.479.20-FF-000063', NULL, 'Elongation factor Ts, mitochondrial', 37, NULL, NULL, 135430),
(135431, '1.25.10.10-FF-003463', NULL, 'GCN (Yeast General Control Nondrepressible) homolog', 201, NULL, NULL, 135431),
(135432, '1.10.287.70-FF-000806', NULL, 'Uncharacterized protein', 236, NULL, NULL, 135432),
(135433, '1.25.40.180-FF-000094', NULL, 'Nonsense-mediated mRNA decay protein 2', 242, NULL, NULL, 135433),
(135434, '1.50.10.10-FF-000184', NULL, 'alpha-1,2-Mannosidase', 320, NULL, NULL, 135434),
(135435, '1.20.1250.20-FF-000608', NULL, 'EmrB/QacA family drug resistance transporter', 169, NULL, NULL, 135435),
(135436, '3.30.160.60-FF-001616', NULL, 'zinc finger protein 408 isoform X2', 31, NULL, NULL, 135436),
(135437, '1.10.472.130-FF-000005', NULL, 'Dynein axonemal heavy chain 7', 175, NULL, NULL, 135437),
(135438, '1.10.10.250-FF-000012', NULL, 'Ribosomal protein', 55, NULL, NULL, 135438),
(135439, '3.90.1530.10-FF-000008', NULL, '12-oxophytodienoate reductase 3', 95, NULL, NULL, 135439),
(135440, '3.10.20.310-FF-000013', NULL, 'Outer envelope protein 80 chloroplastic', 81, NULL, NULL, 135440),
(135441, '1.25.40.10-FF-005207', NULL, 'Tetratricopeptide repeat protein 21B-like Protein', 204, NULL, NULL, 135441),
(135442, '1.10.3090.10-FF-000011', NULL, 'tRNA nucleotidyltransferase', 240, NULL, NULL, 135442);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(135443, '1.10.1200.10-FF-000037', NULL, 'CurA', 85, NULL, NULL, 135443),
(135444, '3.40.50.410-FF-000059', NULL, 'Calcium-activated chloride channel regulator 2', 176, NULL, NULL, 135444),
(135445, '3.30.200.20-FF-001900', NULL, 'Uncharacterized protein', 92, NULL, NULL, 135445),
(135446, '2.130.10.10-FF-004697', NULL, 'Uncharacterized protein', 175, NULL, NULL, 135446),
(135447, '2.60.40.1770-FF-000012', NULL, 'Predicted protein', 58, NULL, NULL, 135447),
(135448, '2.60.40.10-FF-001167', NULL, 'Roundabout 2, isoform B', 110, NULL, NULL, 135448),
(135449, '2.10.109.10-FF-000058', NULL, 'Mitochondrial inner membrane signal peptidase', 114, NULL, NULL, 135449),
(135450, '1.20.58.60-FF-000658', NULL, 'Uncharacterized protein', 109, NULL, NULL, 135450),
(135451, '3.40.50.720-FF-001091', NULL, 'Short chain dehydrogenase', 240, NULL, NULL, 135451),
(135452, '3.40.470.10-FF-000032', NULL, NULL, 212, NULL, NULL, 135452),
(135453, '1.25.40.10-FF-004488', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 98, NULL, NULL, 135453),
(135454, '3.40.1810.10-FF-000002', NULL, 'Serum response factor b', 71, NULL, NULL, 135454),
(135455, '1.20.1070.10-FF-000833', NULL, 'RYamide receptor, isoform C', 353, NULL, NULL, 135455),
(135456, '2.170.120.30-FF-000013', NULL, 'Diadenylate cyclase', 93, NULL, NULL, 135456),
(135457, '3.30.420.10-FF-000475', NULL, NULL, 119, NULL, NULL, 135457),
(135458, '3.20.20.80-FF-000702', NULL, 'Glucosylceramidase, putative', 105, NULL, NULL, 135458),
(135459, '3.40.50.1820-FF-001037', NULL, 'Triacylglycerol lipase 1', 115, NULL, NULL, 135459),
(135460, '3.30.390.130-FF-000002', NULL, 'Uncharacterized protein', 57, NULL, NULL, 135460),
(135461, '1.10.2000.10-FF-000056', NULL, NULL, 139, NULL, NULL, 135461),
(135462, '3.20.20.10-FF-000035', NULL, 'Pyridoxal phosphate homeostasis protein', 223, NULL, NULL, 135462),
(135463, '1.10.10.10-FF-001366', NULL, 'Vacuolar protein sorting protein, putative', 84, NULL, NULL, 135463),
(135464, '3.30.860.10-FF-000002', NULL, '40S ribosomal protein S15', 144, NULL, NULL, 135464),
(135465, '2.60.40.10-FF-003640', NULL, NULL, 112, NULL, NULL, 135465),
(135466, '3.40.50.300-FF-007951', NULL, 'AFR371Wp', 168, NULL, NULL, 135466),
(135467, '3.30.70.330-FF-001351', NULL, 'FOG-1 protein', 88, NULL, NULL, 135467),
(135468, '2.102.10.10-FF-000005', NULL, '3-phenylpropionate/cinnamic acid dioxygenase ferredoxin subunit', 105, NULL, NULL, 135468),
(135469, '3.40.50.1100-FF-000203', NULL, 'Cbs-1', 158, NULL, NULL, 135469),
(135470, '2.10.25.10-FF-000280', NULL, 'Laminin subunit beta 4', 46, NULL, NULL, 135470),
(135471, '1.20.58.60-FF-000670', NULL, 'Uncharacterized protein', 100, NULL, NULL, 135471),
(135472, '3.30.70.3270-FF-000019', NULL, 'Proton-translocating NADH-quinone oxidoreductase, I subunit', 137, NULL, NULL, 135472),
(135473, '1.10.10.2660-FF-000004', NULL, 'Ubiquitin activating enzyme 1', 256, NULL, NULL, 135473),
(135474, '3.90.25.10-FF-000094', NULL, 'Uncharacterized protein', 59, NULL, NULL, 135474),
(135475, '2.60.120.620-FF-000151', NULL, 'Uncharacterized protein', 139, NULL, NULL, 135475),
(135476, '1.10.275.10-FF-000025', NULL, NULL, 117, NULL, NULL, 135476),
(135477, '3.40.50.1700-FF-000063', NULL, 'Probable beta-glucosidase O', 81, NULL, NULL, 135477),
(135478, '3.20.20.20-FF-000038', NULL, 'Predicted protein', 50, NULL, NULL, 135478),
(135479, '1.10.1300.10-FF-000096', NULL, 'Predicted protein', 58, NULL, NULL, 135479),
(135480, '3.40.50.300-FF-007844', NULL, 'Si:dkey-118k5.3', 230, NULL, NULL, 135480),
(135481, '3.90.190.10-FF-000084', NULL, 'Tyrosine phospatase-like protein', 148, NULL, NULL, 135481),
(135482, '2.40.40.20-FF-000041', NULL, 'Peroxisome biosynthesis protein (PAS1/Peroxin-1), putative', 132, NULL, NULL, 135482),
(135483, '2.60.120.10-FF-000831', NULL, 'Transcriptional regulator, putative', 138, NULL, NULL, 135483),
(135484, '3.30.70.330-FF-002981', NULL, NULL, 89, NULL, NULL, 135484),
(135485, '3.30.160.60-FF-001498', NULL, 'Zinc finger protein 404', 36, NULL, NULL, 135485),
(135486, '3.50.80.20-FF-000001', NULL, 'D-alanyl-D-alanine carboxypeptidase dacB', 95, NULL, NULL, 135486);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(135487, '3.20.20.120-FF-000004', NULL, 'D-galactonate dehydratase family protein', 263, NULL, NULL, 135487),
(135488, '3.40.30.10-FF-000153', NULL, 'Glutathione peroxidase', 194, NULL, NULL, 135488),
(135489, '2.30.30.490-FF-000080', NULL, 'Uncharacterized protein', 198, NULL, NULL, 135489),
(135490, '1.10.510.10-FF-003642', NULL, NULL, 188, NULL, NULL, 135490),
(135491, '3.40.50.300-FF-000021', NULL, 'Lon protease homolog', 179, NULL, NULL, 135491),
(135492, '3.40.50.720-FF-002518', NULL, 'Uncharacterized protein', 116, NULL, NULL, 135492),
(135493, '2.60.120.620-FF-000044', NULL, 'Predicted protein', 198, NULL, NULL, 135493),
(135494, '1.20.1270.60-FF-000138', NULL, 'Chromosome 9, whole genome shotgun sequence', 220, NULL, NULL, 135494),
(135495, '3.90.320.10-FF-000033', NULL, 'RecBCD enzyme subunit RecB', 296, NULL, NULL, 135495),
(135496, '1.20.920.10-FF-000186', NULL, 'Uncharacterized protein', 88, NULL, NULL, 135496),
(135497, '2.40.20.10-FF-000031', NULL, 'Plasminogen', 87, NULL, NULL, 135497),
(135498, '2.170.120.20-FF-000010', NULL, '50S ribosomal protein L25', 89, NULL, NULL, 135498),
(135499, '3.30.930.10-FF-000345', NULL, 'Uncharacterized protein', 71, NULL, NULL, 135499),
(135500, '1.10.10.2670-FF-000007', NULL, 'E3 ubiquitin-protein ligase UBR1', 102, NULL, NULL, 135500),
(135501, '1.10.720.30-FF-000022', NULL, 'DNA-(apurinic or apyrimidinic site) lyase', 69, NULL, NULL, 135501),
(135502, '2.10.70.10-FF-000125', NULL, 'Gamma-aminobutyric acid (GABA) B receptor, 1a', 62, NULL, NULL, 135502),
(135503, '1.20.5.2440-FF-000003', NULL, 'Nuclear fallout, isoform D', 61, NULL, NULL, 135503),
(135504, '1.20.58.60-FF-000439', NULL, 'AGAP009554-PA', 134, NULL, NULL, 135504),
(135505, '1.50.40.10-FF-000023', NULL, 'peroxisomal membrane protein PMP34 isoform X1', 200, NULL, NULL, 135505),
(135506, '1.20.5.110-FF-000032', NULL, 'Ras association domain family member 5', 55, NULL, NULL, 135506),
(135507, '3.10.250.10-FF-000073', NULL, NULL, 73, NULL, NULL, 135507),
(135508, '1.10.510.10-FF-002799', NULL, 'Kinase, NEK', 301, NULL, NULL, 135508),
(135509, '1.10.510.10-FF-003535', NULL, NULL, 238, NULL, NULL, 135509),
(135510, '3.40.50.720-FF-002288', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 197, NULL, NULL, 135510),
(135511, '1.25.10.10-FF-003356', NULL, 'Uncharacterized protein', 196, NULL, NULL, 135511),
(135512, '1.25.40.550-FF-000002', NULL, 'AAR2 protein family', 211, NULL, NULL, 135512),
(135513, '3.40.30.10-FF-000260', NULL, 'Mitochondrial ribosomal protein L44', 97, NULL, NULL, 135513),
(135514, '1.20.1250.20-FF-000822', NULL, 'Probable plastidic glucose transporter 3', 439, NULL, NULL, 135514),
(135515, '1.20.1250.20-FF-000934', NULL, 'Allantoate permease', 188, NULL, NULL, 135515),
(135516, '1.20.1560.10-FF-000685', NULL, 'Uncharacterized protein', 564, NULL, NULL, 135516),
(135517, '2.60.40.10-FF-002010', NULL, 'Cilia and flagella associated protein 65', 98, NULL, NULL, 135517),
(135518, '3.30.413.10-FF-000009', NULL, 'Sulfite reductase [ferredoxin]', 180, NULL, NULL, 135518),
(135519, '1.20.1070.10-FF-000496', NULL, 'Predicted protein', 289, NULL, NULL, 135519),
(135520, '1.25.40.570-FF-000008', NULL, 'COP9 signalosome complex subunit 3', 200, NULL, NULL, 135520),
(135521, '2.130.10.10-FF-001824', NULL, 'Coatomer subunit beta''', 243, NULL, NULL, 135521),
(135522, '3.40.50.300-FF-007165', NULL, 'Uncharacterized protein', 288, NULL, NULL, 135522),
(135523, '3.30.60.90-FF-000044', NULL, 'E3 ubiquitin-protein ligase KCMF1, putative', 82, NULL, NULL, 135523),
(135524, '1.10.630.10-FF-000823', NULL, 'Uncharacterized protein', 239, NULL, NULL, 135524),
(135525, '1.10.3370.10-FF-000044', NULL, 'Uncharacterized protein', 162, NULL, NULL, 135525),
(135526, '3.30.450.20-FF-000199', NULL, 'Sensor histidine kinase', 92, NULL, NULL, 135526),
(135527, '2.60.40.10-FF-001386', NULL, 'Receptor-type tyrosine-protein phosphatase gamma', 104, NULL, NULL, 135527),
(135528, '3.30.420.270-FF-000013', NULL, 'Biopolymer transporter ExbD', 70, NULL, NULL, 135528),
(135529, '3.30.450.20-FF-000087', NULL, 'White collar 1 protein', 109, NULL, NULL, 135529);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(135530, '2.60.40.60-FF-000310', NULL, 'Protocadherin alpha 11', 109, NULL, NULL, 135530),
(135531, '2.30.42.10-FF-000537', NULL, NULL, 106, NULL, NULL, 135531),
(135532, '3.40.50.410-FF-000166', NULL, 'Collagen, type VI, alpha 3', 79, NULL, NULL, 135532),
(135533, '3.90.1260.10-FF-000010', NULL, 'Argininosuccinate synthase', 207, NULL, NULL, 135533),
(135534, '1.20.1070.10-FF-001108', NULL, 'G-protein coupled receptor-like protein Q2/3L', 379, NULL, NULL, 135534),
(135535, '3.30.40.10-FF-000749', NULL, 'Ubiquitinyl hydrolase 1', 96, NULL, NULL, 135535),
(135536, '3.40.50.410-FF-000278', NULL, 'Uncharacterized protein', 54, NULL, NULL, 135536),
(135537, '3.30.420.10-FF-000149', NULL, 'Polynucleotidyl transferase, ribonuclease H-like superfamily protein', 205, NULL, NULL, 135537),
(135538, '2.60.220.50-FF-000087', NULL, 'Adhesion G protein-coupled receptor B3', 181, NULL, NULL, 135538),
(135539, '3.30.70.330-FF-002655', NULL, NULL, 120, NULL, NULL, 135539),
(135540, '2.10.25.10-FF-001111', NULL, 'Coagulation factor VII', 45, NULL, NULL, 135540),
(135541, '2.60.40.10-FF-005657', NULL, NULL, 89, NULL, NULL, 135541),
(135542, '1.25.40.560-FF-000005', NULL, 'Ubiquitin thioesterase zranb1-B', 97, NULL, NULL, 135542),
(135543, '3.40.50.12710-FF-000004', NULL, 'Protein arginine methyltransferase NDUFAF7', 420, NULL, NULL, 135543),
(135544, '3.20.20.140-FF-000229', NULL, 'TatD_related_DNase_-_putative', 187, NULL, NULL, 135544),
(135545, '3.40.50.12700-FF-000001', NULL, 'Uncharacterized protein', 98, NULL, NULL, 135545),
(135546, '1.10.510.10-FF-001388', NULL, 'Tyrosine-protein kinase', 186, NULL, NULL, 135546),
(135547, '3.40.1110.10-FF-000437', NULL, NULL, 11, NULL, NULL, 135547),
(135548, '1.10.10.10-FF-000062', NULL, 'IclR family transcriptional regulator', 74, NULL, NULL, 135548),
(135549, '2.60.40.10-FF-001846', NULL, 'Uncharacterized protein, isoform E', 105, NULL, NULL, 135549),
(135550, '3.60.40.10-FF-000366', NULL, 'Putative integral membrane protein', 275, NULL, NULL, 135550),
(135551, '2.60.120.10-FF-000505', NULL, 'Glr1099 protein', 128, NULL, NULL, 135551),
(135552, '3.20.20.70-FF-000811', NULL, NULL, 104, NULL, NULL, 135552),
(135553, '3.30.160.60-FF-005657', NULL, NULL, 23, NULL, NULL, 135553),
(135554, '2.10.50.10-FF-000023', NULL, 'Ectodysplasin A receptor', 88, NULL, NULL, 135554),
(135555, '3.40.50.300-FF-000133', NULL, 'Spermidine/putrescine import ATP-binding protein PotA', 221, NULL, NULL, 135555),
(135556, '1.10.10.10-FF-001478', NULL, 'DNA-directed RNA polymerase III subunit RPC3', 90, NULL, NULL, 135556),
(135557, '2.60.120.200-FF-000486', NULL, 'Thrombospondin A', 215, NULL, NULL, 135557),
(135558, '1.25.10.10-FF-003137', NULL, 'Telomere repeats-binding bouquet formation protein 1', 109, NULL, NULL, 135558),
(135559, '3.40.50.1820-FF-000762', NULL, 'Vegetative-specific protein H5', 303, NULL, NULL, 135559),
(135560, '4.10.1290.10-FF-000001', NULL, 'Tumor necrosis factor receptor superfamily member 13B', 35, NULL, NULL, 135560),
(135561, '1.20.1070.10-FF-000507', NULL, 'Adrenoceptor beta 3a', 299, NULL, NULL, 135561),
(135562, '3.30.2290.10-FF-000003', NULL, 'Zinc-dependent protease, TldD/PmbA family', 225, NULL, NULL, 135562),
(135563, '1.10.287.470-FF-000067', NULL, 'Heterocyst specific ABC-transporter, membrane fusion protein', 82, NULL, NULL, 135563),
(135564, '3.20.20.80-FF-000584', NULL, 'Alpha-L-fucosidase, putative', 251, NULL, NULL, 135564),
(135565, '3.60.21.10-FF-000114', NULL, 'Sia1p', 234, NULL, NULL, 135565),
(135566, '3.40.710.10-FF-000080', NULL, 'Conserved protein', 271, NULL, NULL, 135566),
(135567, '3.30.1370.210-FF-000032', NULL, 'Muscleblind like splicing regulator 1', 80, NULL, NULL, 135567),
(135568, '1.20.5.110-FF-000251', NULL, 'Uncharacterized protein', 108, NULL, NULL, 135568),
(135569, '3.30.40.10-FF-000963', NULL, 'Uncharacterized protein, isoform A', 68, NULL, NULL, 135569),
(135570, '4.10.990.10-FF-000001', NULL, '50S ribosomal protein L15', 50, NULL, NULL, 135570),
(135571, '1.10.533.10-FF-000013', NULL, 'Apoptosis-associated speck-like protein containing a CARD', 85, NULL, NULL, 135571);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(135572, '2.40.50.140-FF-000847', NULL, NULL, 86, NULL, NULL, 135572),
(135573, '1.10.10.10-FF-002102', NULL, 'RNA polymerase III subunit RPC82 family protein', 88, NULL, NULL, 135573),
(135574, '3.40.190.10-FF-000679', NULL, 'Glutamate receptor 1.1', 56, NULL, NULL, 135574),
(135575, '1.10.510.10-FF-001169', NULL, 'Lectin-domain containing receptor kinase A4.2', 179, NULL, NULL, 135575),
(135576, '3.40.50.300-FF-004404', NULL, 'DNA helicase', 188, NULL, NULL, 135576),
(135577, '3.40.50.2300-FF-000709', NULL, 'Uncharacterized protein', 141, NULL, NULL, 135577),
(135578, '1.20.1740.10-FF-000238', NULL, 'Uncharacterized protein', 386, NULL, NULL, 135578),
(135579, '3.90.1480.20-FF-000001', NULL, 'ST8 alpha-N-acetyl-neuraminide alpha-2,8-sialyltransferase 2', 289, NULL, NULL, 135579),
(135580, '3.20.20.80-FF-000814', NULL, 'SD02860p', 108, NULL, NULL, 135580),
(135581, '3.30.160.60-FF-003971', NULL, 'Zinc finger E-box-binding homeobox 2a', 88, NULL, NULL, 135581),
(135582, '1.10.10.930-FF-000002', NULL, 'Genome polyprotein', 80, NULL, NULL, 135582),
(135583, '3.30.420.10-FF-000705', NULL, NULL, 106, NULL, NULL, 135583),
(135584, '3.30.1330.20-FF-000032', NULL, 'Tubulin alpha chain', 117, NULL, NULL, 135584),
(135585, '2.150.10.10-FF-000019', NULL, NULL, 118, NULL, NULL, 135585),
(135586, '4.10.280.10-FF-000150', NULL, 'Mesoderm posterior protein 1', 61, NULL, NULL, 135586),
(135587, '1.20.990.10-FF-000027', NULL, '5-methyltetrahydrofolate-homocysteine methyltransferase reductase', 40, NULL, NULL, 135587),
(135588, '3.40.50.2300-FF-000698', NULL, 'GLutamate Receptor family (AMPA)', 169, NULL, NULL, 135588),
(135589, '3.30.420.40-FF-000130', NULL, 'Chromatin remodeling complex subunit (Arp9)', 132, NULL, NULL, 135589),
(135590, '1.10.287.3240-FF-000028', NULL, 'V-type ATP synthase subunit D', 199, NULL, NULL, 135590),
(135591, '3.30.160.60-FF-000200', NULL, 'zinc finger protein 510 isoform X2', 28, NULL, NULL, 135591),
(135592, '3.30.1490.20-FF-000083', NULL, 'ATP domain protein', 80, NULL, NULL, 135592),
(135593, '3.30.450.60-FF-000071', NULL, 'AP complex subunit sigma', 89, NULL, NULL, 135593),
(135594, '2.30.40.10-FF-000134', NULL, 'Guanine deaminase', 117, NULL, NULL, 135594),
(135595, '3.30.160.60-FF-001386', NULL, 'Zinc finger protein 212', 28, NULL, NULL, 135595),
(135596, '1.25.40.10-FF-003072', NULL, 'Pentatricopeptide repeat-containing protein', 196, NULL, NULL, 135596),
(135597, '3.30.1330.30-FF-000035', NULL, 'TrmH family RNA methyltransferase', 90, NULL, NULL, 135597),
(135598, '3.30.9.10-FF-000003', NULL, 'Glycine oxidase ThiO', 152, NULL, NULL, 135598),
(135599, '2.60.120.920-FF-000134', NULL, 'SPRY domain containing protein, putative', 154, NULL, NULL, 135599),
(135600, '1.25.40.10-FF-005089', NULL, 'Predicted protein', 77, NULL, NULL, 135600),
(135601, '3.50.50.60-FF-001343', NULL, 'Ubiquinone biosynthesis monooxgenase', 164, NULL, NULL, 135601),
(135602, '3.40.50.1820-FF-000329', NULL, 'Haloalkane dehalogenase', 279, NULL, NULL, 135602),
(135603, '2.10.260.10-FF-000004', NULL, 'Antitoxin ChpS', 83, NULL, NULL, 135603),
(135604, '3.40.50.150-FF-001471', NULL, NULL, 131, NULL, NULL, 135604),
(135605, '3.40.30.10-FF-000372', NULL, 'Thiol:disulfide interchange protein dsbD', 145, NULL, NULL, 135605),
(135606, '1.10.720.60-FF-000002', NULL, 'Enolase-phosphatase E1', 98, NULL, NULL, 135606),
(135607, '1.10.390.10-FF-000001', NULL, 'Aminopeptidase', 248, NULL, NULL, 135607),
(135608, '3.30.930.10-FF-000233', NULL, 'Phenylalanine--tRNA ligase alpha subunit', 311, NULL, NULL, 135608),
(135609, '3.40.50.300-FF-007625', NULL, 'Uncharacterized protein', 147, NULL, NULL, 135609),
(135610, '3.30.1330.40-FF-000038', NULL, 'Uncharacterized protein', 128, NULL, NULL, 135610),
(135611, '1.20.1110.10-FF-000207', NULL, NULL, 87, NULL, NULL, 135611),
(135612, '1.10.3730.20-FF-000024', NULL, 'Unplaced genomic scaffold supercont2.15, whole genome shotgun sequence', 124, NULL, NULL, 135612),
(135613, '3.50.30.30-FF-000170', NULL, 'Predicted protein', 131, NULL, NULL, 135613),
(135614, '3.90.76.10-FF-000003', NULL, 'Glutathione ABC transporter substrate-binding protein GsiB', 149, NULL, NULL, 135614);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(135615, '3.40.50.300-FF-005585', NULL, 'Predicted protein', 159, NULL, NULL, 135615),
(135616, '1.20.120.1080-FF-000036', NULL, 'ATP-dependent RNA helicase', 122, NULL, NULL, 135616),
(135617, '3.30.160.60-FF-006040', NULL, NULL, 17, NULL, NULL, 135617),
(135618, '3.30.30.170-FF-000002', NULL, 'Eukaryotic translation initiation factor 5', 103, NULL, NULL, 135618),
(135619, '3.30.1240.10-FF-000045', NULL, 'HAD family hydrolase', 109, NULL, NULL, 135619),
(135620, '2.60.40.10-FF-000430', NULL, 'Sallimus, isoform P', 102, NULL, NULL, 135620),
(135621, '4.10.910.10-FF-000002', NULL, '40S ribosomal protein S18', 52, NULL, NULL, 135621),
(135622, '2.60.40.10-FF-004949', NULL, NULL, 88, NULL, NULL, 135622),
(135623, '2.130.10.10-FF-005528', NULL, 'Uncharacterized protein', 13, NULL, NULL, 135623),
(135624, '3.40.50.300-FF-005927', NULL, 'Uncharacterized protein', 251, NULL, NULL, 135624),
(135625, '1.10.238.110-FF-000017', NULL, 'Diacylglycerol kinase', 82, NULL, NULL, 135625),
(135626, '1.20.1070.10-FF-002076', NULL, 'Uncharacterized protein', 54, NULL, NULL, 135626),
(135627, '3.30.930.10-FF-000340', NULL, 'Uncharacterized protein', 95, NULL, NULL, 135627),
(135628, '3.30.70.2000-FF-000004', NULL, 'Insomniac, isoform B', 55, NULL, NULL, 135628),
(135629, '3.40.50.720-FF-001214', NULL, 'Conserved hypothetical mitochondrial protein', 234, NULL, NULL, 135629),
(135630, '3.50.50.60-FF-001231', NULL, 'Uncharacterized protein', 225, NULL, NULL, 135630),
(135631, '2.40.30.330-FF-000001', NULL, 'Protein CLP1 homolog', 112, NULL, NULL, 135631),
(135632, '1.10.8.60-FF-000194', NULL, 'PTS-dependent dihydroxyacetone kinase operon regulatory protein', 70, NULL, NULL, 135632),
(135633, '3.90.1440.10-FF-000001', NULL, 'Preprotein translocase subunit SecA', 134, NULL, NULL, 135633),
(135634, '2.130.10.10-FF-001257', NULL, 'WD repeat-containing protein PAC11', 284, NULL, NULL, 135634),
(135635, '2.130.10.10-FF-005186', NULL, 'Ribosome biogenesis protein WDR12 homolog', 119, NULL, NULL, 135635),
(135636, '1.25.40.20-FF-000191', NULL, 'E3 ubiquitin-protein ligase MIB1 isoform X1', 178, NULL, NULL, 135636),
(135637, '3.40.1180.10-FF-000043', NULL, 'Alkyl transferase', 249, NULL, NULL, 135637),
(135638, '3.50.50.60-FF-000961', NULL, 'Uncharacterized protein', 170, NULL, NULL, 135638),
(135639, '3.40.1190.20-FF-000198', NULL, NULL, 207, NULL, NULL, 135639),
(135640, '3.40.50.11340-FF-000003', NULL, 'Galactoside 2-alpha-L-fucosyltransferase', 45, NULL, NULL, 135640),
(135641, '1.25.40.10-FF-001048', NULL, 'Putative intraflagellar transport protein IFT88', 79, NULL, NULL, 135641),
(135642, '3.40.50.300-FF-000026', NULL, 'ATP synthase subunit beta', 275, NULL, NULL, 135642),
(135643, '3.40.50.2000-FF-000833', NULL, 'Uncharacterized protein', 128, NULL, NULL, 135643),
(135644, '2.60.40.10-FF-005219', NULL, NULL, 90, NULL, NULL, 135644),
(135645, '3.30.450.20-FF-000536', NULL, 'Uncharacterized protein', 119, NULL, NULL, 135645),
(135646, '3.40.50.11350-FF-000006', NULL, 'Calcium ion binding', 148, NULL, NULL, 135646),
(135647, '3.40.50.300-FF-001656', NULL, 'Rab11B GTPase, putative', 187, NULL, NULL, 135647),
(135648, '1.20.58.830-FF-000011', NULL, 'Erythrocyte-binding antigen 175', 120, NULL, NULL, 135648),
(135649, '1.10.8.60-FF-000542', NULL, 'N-ethylmaleimide-sensitive factor-like protein', 37, NULL, NULL, 135649),
(135650, '3.40.50.1820-FF-000548', NULL, 'Lipase', 365, NULL, NULL, 135650),
(135651, '3.40.1810.10-FF-000007', NULL, 'Transcription factor, MADS-box', 71, NULL, NULL, 135651),
(135652, '3.40.50.300-FF-004062', NULL, 'Peroxin-1', 182, NULL, NULL, 135652),
(135653, '3.30.160.60-FF-001728', NULL, 'Zinc finger protein 560', 28, NULL, NULL, 135653),
(135654, '2.60.40.2300-FF-000003', NULL, 'Neutral ceramidase', 132, NULL, NULL, 135654),
(135655, '2.10.25.10-FF-001004', NULL, 'Delta/notch like EGF repeat containing', 42, NULL, NULL, 135655),
(135656, '3.40.50.800-FF-000069', NULL, 'Histidine--tRNA ligase', 93, NULL, NULL, 135656),
(135657, '2.60.120.970-FF-000014', NULL, 'growth/differentiation factor 2', 220, NULL, NULL, 135657);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(135658, '2.60.40.2310-FF-000006', NULL, 'Subtilisin-like protease SBT1.2', 139, NULL, NULL, 135658),
(135659, '3.40.50.150-FF-000503', NULL, 'Spermidine synthase', 226, NULL, NULL, 135659),
(135660, '3.30.40.10-FF-001020', NULL, 'RBR-type E3 ubiquitin transferase', 91, NULL, NULL, 135660),
(135661, '3.40.1690.20-FF-000023', NULL, 'Uncharacterized protein', 98, NULL, NULL, 135661),
(135662, '3.80.10.10-FF-003230', NULL, 'NLR family, pyrin domain-containing 2', 199, NULL, NULL, 135662),
(135663, '3.30.450.20-FF-000194', NULL, 'Cell wall metabolism sensor histidine kinase WalK', 155, NULL, NULL, 135663),
(135664, '1.25.10.10-FF-003351', NULL, 'Uncharacterized protein', 429, NULL, NULL, 135664),
(135665, '3.40.50.1260-FF-000009', NULL, 'Phosphoglycerate kinase', 162, NULL, NULL, 135665),
(135666, '3.40.50.2300-FF-001081', NULL, NULL, 39, NULL, NULL, 135666),
(135667, '2.60.40.10-FF-003084', NULL, 'leukocyte immune-type receptor 2 isoform X2', 98, NULL, NULL, 135667),
(135668, '1.10.3860.10-FF-000019', NULL, 'Proton/glutamate symporter', 402, NULL, NULL, 135668),
(135669, '3.30.160.60-FF-004134', NULL, NULL, 32, NULL, NULL, 135669),
(135670, '2.130.10.10-FF-004005', NULL, 'Uncharacterized protein', 227, NULL, NULL, 135670),
(135671, '2.40.50.140-FF-001229', NULL, NULL, 54, NULL, NULL, 135671),
(135672, '3.40.1690.10-FF-000020', NULL, 'FlhB domain protein', 78, NULL, NULL, 135672),
(135673, '3.30.70.330-FF-003037', NULL, NULL, 130, NULL, NULL, 135673),
(135674, '3.20.20.300-FF-000087', NULL, NULL, 18, NULL, NULL, 135674),
(135675, '3.30.160.60-FF-001835', NULL, 'Ras responsive element binding protein 1', 28, NULL, NULL, 135675),
(135676, '1.25.40.10-FF-005319', NULL, 'Uncharacterized protein', 114, NULL, NULL, 135676),
(135677, '2.60.40.10-FF-000082', NULL, 'receptor-type tyrosine-protein phosphatase delta isoform X2', 95, NULL, NULL, 135677),
(135678, '1.10.150.810-FF-000007', NULL, 'DNA polymerase kappa', 91, NULL, NULL, 135678),
(135679, '1.10.630.10-FF-000256', NULL, 'Os03g0249600 protein', 154, NULL, NULL, 135679),
(135680, '2.130.10.10-FF-003393', NULL, 'Tbc-19', 219, NULL, NULL, 135680),
(135681, '2.130.10.10-FF-003729', NULL, 'Uncharacterized protein', 336, NULL, NULL, 135681),
(135682, '3.40.50.720-FF-000938', NULL, 'Conserved protein', 227, NULL, NULL, 135682),
(135683, '1.20.1560.10-FF-000247', NULL, 'Predicted protein', 205, NULL, NULL, 135683),
(135684, '3.30.40.10-FF-000968', NULL, 'E3 ubiquitin-protein ligase RMA2', 76, NULL, NULL, 135684),
(135685, '2.60.120.290-FF-000237', NULL, 'CUB domaincontaining protein', 71, NULL, NULL, 135685),
(135686, '3.30.40.10-FF-000744', NULL, 'Ubiquitinyl hydrolase 1', 102, NULL, NULL, 135686),
(135687, '3.40.50.620-FF-000678', NULL, 'Uncharacterized protein', 202, NULL, NULL, 135687),
(135688, '2.40.270.10-FF-000026', NULL, NULL, 104, NULL, NULL, 135688),
(135689, '3.40.50.300-FF-003792', NULL, 'Rho-related GTP-binding protein Rho6', 85, NULL, NULL, 135689),
(135690, '1.20.1280.170-FF-000006', NULL, 'Exocyst complex component EXO70', 127, NULL, NULL, 135690),
(135691, '2.60.40.1090-FF-000022', NULL, 'Fimbrial protein StiA', 152, NULL, NULL, 135691),
(135692, '3.30.1370.50-FF-000038', NULL, 'Uncharacterized protein', 51, NULL, NULL, 135692),
(135693, '1.10.10.60-FF-001246', NULL, NULL, 37, NULL, NULL, 135693),
(135694, '3.90.640.10-FF-000068', NULL, 'Chaperone protein HscA homolog', 74, NULL, NULL, 135694),
(135695, '3.10.290.10-FF-000070', NULL, 'cDNA clone:002-120-H01, full insert sequence', 45, NULL, NULL, 135695),
(135696, '1.10.540.10-FF-000030', NULL, 'Acyl-CoA dehydrogenase FadE29', 116, NULL, NULL, 135696),
(135697, '2.10.70.10-FF-000018', NULL, 'Fibronectin 1', 50, NULL, NULL, 135697),
(135698, '3.40.50.80-FF-000248', NULL, 'Uncharacterized protein', 54, NULL, NULL, 135698),
(135699, '1.10.565.10-FF-000014', NULL, 'Oxysterols receptor LXR-alpha isoform 1', 243, NULL, NULL, 135699),
(135700, '1.25.40.180-FF-000217', NULL, NULL, 181, NULL, NULL, 135700),
(135701, '1.20.58.180-FF-000001', NULL, 'Glycine--tRNA ligase alpha subunit', 82, NULL, NULL, 135701);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(135702, '2.60.120.200-FF-000598', NULL, 'Laminin, alpha 3', 156, NULL, NULL, 135702),
(135703, '3.30.70.1230-FF-000200', NULL, 'Guanylate cyclase', 135, NULL, NULL, 135703),
(135704, '3.40.1110.10-FF-000106', NULL, 'P-type cation-transporting ATPase', 112, NULL, NULL, 135704),
(135705, '3.40.50.720-FF-001321', NULL, 'Uncharacterized protein', 75, NULL, NULL, 135705),
(135706, '1.20.1250.20-FF-000827', NULL, 'MFS transporter', 401, NULL, NULL, 135706),
(135707, '1.20.120.1220-FF-000011', NULL, 'Type 4 prepilin-like proteins leader peptide-processing enzyme', 126, NULL, NULL, 135707),
(135708, '2.10.25.10-FF-000728', NULL, 'Laminin subunit gamma 1', 46, NULL, NULL, 135708),
(135709, '3.80.10.10-FF-002960', NULL, 'CLL4B clavata1-like receptor S/T protein kinase protein', 81, NULL, NULL, 135709),
(135710, '3.40.140.10-FF-000041', NULL, 'Cytidine deaminase', 150, NULL, NULL, 135710),
(135711, '3.30.70.330-FF-000957', NULL, 'RNA-binding protein rnp-1', 66, NULL, NULL, 135711),
(135712, '1.20.58.190-FF-000004', NULL, 'Recombination hotspot-binding protein (Translin)', 143, NULL, NULL, 135712),
(135713, '1.10.287.70-FF-000576', NULL, 'Uncharacterized protein', 131, NULL, NULL, 135713),
(135714, '2.60.40.10-FF-003426', NULL, NULL, 106, NULL, NULL, 135714),
(135715, '3.40.50.300-FF-000700', NULL, 'ATP-dependent DNA helicase DinG', 261, NULL, NULL, 135715),
(135716, '1.25.40.180-FF-000324', NULL, NULL, 238, NULL, NULL, 135716),
(135717, '2.20.100.10-FF-000249', NULL, 'Predicted protein', 53, NULL, NULL, 135717),
(135718, '3.10.400.20-FF-000015', NULL, 'Translation machinery-associated protein 20', 174, NULL, NULL, 135718),
(135719, '1.10.510.10-FF-001618', NULL, 'CAMK family protein kinase', 301, NULL, NULL, 135719),
(135720, '2.30.30.140-FF-000109', NULL, 'Histone-lysine N-methyltransferase', 54, NULL, NULL, 135720),
(135721, '1.25.10.10-FF-001097', NULL, 'Serine/threonine-protein kinase TOR', 298, NULL, NULL, 135721),
(135722, '3.40.50.1240-FF-000003', NULL, '2,3-bisphosphoglycerate-dependent phosphoglycerate mutase', 249, NULL, NULL, 135722),
(135723, '1.10.630.10-FF-000604', NULL, 'Cytochrome P450, family 2, subfamily AA, polypeptide 7', 270, NULL, NULL, 135723),
(135724, '2.60.40.420-FF-000228', NULL, 'Laccase-1', 182, NULL, NULL, 135724),
(135725, '1.20.990.10-FF-000022', NULL, 'Sulfite reductase subunit alpha', 104, NULL, NULL, 135725),
(135726, '3.10.400.10-FF-000012', NULL, NULL, 176, NULL, NULL, 135726),
(135727, '2.40.50.90-FF-000192', NULL, 'Uncharacterized protein', 60, NULL, NULL, 135727),
(135728, '3.30.800.10-FF-000010', NULL, 'Putative 1-phosphatidylinositol-3-phosphate 5-kinase FAB1C', 174, NULL, NULL, 135728),
(135729, '2.130.10.10-FF-001605', NULL, 'Ribosome biogenesis protein BOP1 homolog', 349, NULL, NULL, 135729),
(135730, '3.30.1330.30-FF-000030', NULL, 'Growth arrest and DNA damage-inducible protein GADD45 alpha', 54, NULL, NULL, 135730),
(135731, '1.10.640.10-FF-000088', NULL, 'Uncharacterized protein', 47, NULL, NULL, 135731),
(135732, '3.30.160.60-FF-000205', NULL, 'Putative Krueppel-like factor 10', 31, NULL, NULL, 135732),
(135733, '3.80.10.10-FF-000268', NULL, 'Tubulin-specific chaperone E', 153, NULL, NULL, 135733),
(135734, '3.50.50.60-FF-001124', NULL, 'Uncharacterized protein', 364, NULL, NULL, 135734),
(135735, '2.30.29.30-FF-000670', NULL, 'Histone chaperone Rttp106-like, putative', 108, NULL, NULL, 135735),
(135736, '3.70.10.10-FF-000010', NULL, 'Checkpoint protein', 299, NULL, NULL, 135736),
(135737, '1.25.40.10-FF-003521', NULL, 'Protein TONSOKU', 183, NULL, NULL, 135737),
(135738, '3.60.20.10-FF-000264', NULL, NULL, 100, NULL, NULL, 135738),
(135739, '3.60.40.10-FF-000147', NULL, 'Protein phosphatase 2C, putative', 314, NULL, NULL, 135739),
(135740, '3.30.70.330-FF-000738', NULL, 'RNA-binding motif protein 19', 100, NULL, NULL, 135740),
(135741, '3.40.630.10-FF-000489', NULL, 'Amidohydrolase', 110, NULL, NULL, 135741),
(135742, '1.25.10.10-FF-001990', NULL, 'Putative pumilio/PUF RNA binding protein 7', 235, NULL, NULL, 135742),
(135743, '3.40.50.10140-FF-000082', NULL, 'Uncharacterized protein', 141, NULL, NULL, 135743);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(135744, '2.130.10.10-FF-000301', NULL, 'WD40 repeat-containing protein SMU1', 118, NULL, NULL, 135744),
(135745, '2.40.240.130-FF-000007', NULL, 'Axin-like protein 1', 83, NULL, NULL, 135745),
(135746, '1.25.40.20-FF-001618', NULL, 'Predicted protein', 100, NULL, NULL, 135746),
(135747, '2.60.40.150-FF-000113', NULL, 'activating signal cointegrator 1 complex subunit 3', 115, NULL, NULL, 135747),
(135748, '2.30.39.10-FF-000052', NULL, 'Serpin peptidase inhibitor, clade F (alpha-2 antiplasmin, pigment epithelium-derived factor), member 1', 155, NULL, NULL, 135748),
(135749, '3.30.1950.10-FF-000003', NULL, NULL, 62, NULL, NULL, 135749),
(135750, '3.30.70.330-FF-002874', NULL, NULL, 71, NULL, NULL, 135750),
(135751, '3.40.50.12780-FF-000098', NULL, 'Long-chain-fatty-acid--CoA ligase', 392, NULL, NULL, 135751),
(135752, '2.60.120.10-FF-000612', NULL, 'Predicted protein', 175, NULL, NULL, 135752),
(135753, '3.80.10.10-FF-004539', NULL, 'RE49158p', 135, NULL, NULL, 135753),
(135754, '3.40.50.2000-FF-001002', NULL, 'Alpha-1,4 glucan phosphorylase', 461, NULL, NULL, 135754),
(135755, '3.40.50.620-FF-000459', NULL, 'Cytoplasmic tRNA 2-thiolation protein 2-A', 335, NULL, NULL, 135755),
(135756, '3.90.190.10-FF-000207', NULL, 'Leucine rich repeat and phosphatase domain containing protein', 152, NULL, NULL, 135756),
(135757, '3.30.780.10-FF-000075', NULL, 'Cleavage stimulating factor 64', 42, NULL, NULL, 135757),
(135758, '2.10.10.40-FF-000001', NULL, 'Capsid vertex protein', 80, NULL, NULL, 135758),
(135759, '1.10.510.10-FF-001276', NULL, 'NEK4 isoform 4', 205, NULL, NULL, 135759),
(135760, '1.10.555.10-FF-000070', NULL, 'Phosphatidylinositol 3-kinase regulatory subunit alpha-like Protein', 221, NULL, NULL, 135760),
(135761, '3.30.160.60-FF-001509', NULL, 'Zinc finger protein 616', 28, NULL, NULL, 135761),
(135762, '2.10.220.10-FF-000007', NULL, 'Tyrosine-protein kinase receptor', 71, NULL, NULL, 135762),
(135763, '3.20.20.70-FF-000025', NULL, 'Triosephosphate isomerase', 247, NULL, NULL, 135763),
(135764, '3.40.140.100-FF-000014', NULL, 'Ubiquitin-like modifier-activating enzyme ATG7', 106, NULL, NULL, 135764),
(135765, '1.25.40.10-FF-001615', NULL, 'Os05g0457700 protein', 195, NULL, NULL, 135765),
(135766, '3.40.50.2000-FF-000726', NULL, 'UDP-Glycosyltransferase superfamily protein', 121, NULL, NULL, 135766),
(135767, '3.30.200.20-FF-001226', NULL, 'Protein kinase-like (PK-like)', 12, NULL, NULL, 135767),
(135768, '3.40.50.1820-FF-000767', NULL, 'Alpha/Beta hydrolase protein', 291, NULL, NULL, 135768),
(135769, '3.40.50.410-FF-000054', NULL, 'von Willebrand factor A domain containing 2', 187, NULL, NULL, 135769),
(135770, '2.30.330.10-FF-000011', NULL, 'Flagellar motor switch protein FliN', 83, NULL, NULL, 135770),
(135771, '1.20.1740.10-FF-000233', NULL, 'Uncharacterized protein', 409, NULL, NULL, 135771),
(135772, '1.20.120.1920-FF-000013', NULL, 'Uncharacterized protein', 41, NULL, NULL, 135772),
(135773, '1.25.40.10-FF-001492', NULL, 'Tetratricopeptide repeat domain 21B', 71, NULL, NULL, 135773),
(135774, '3.30.160.20-FF-000109', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 2', 68, NULL, NULL, 135774),
(135775, '3.40.1110.10-FF-000325', NULL, 'Phospholipid-transporting ATPase', 279, NULL, NULL, 135775),
(135776, '2.60.120.330-FF-000171', NULL, 'Os02g0630300 protein', 267, NULL, NULL, 135776),
(135777, '2.40.10.10-FF-000210', NULL, 'trypsin alpha-3', 237, NULL, NULL, 135777),
(135778, '2.10.90.10-FF-000020', NULL, 'bone morphogenetic protein 8B', 112, NULL, NULL, 135778),
(135779, '3.80.10.10-FF-001898', NULL, 'Nuclear pore complex protein NUP107', 147, NULL, NULL, 135779),
(135780, '1.25.10.10-FF-001439', NULL, 'Unc-45 homolog A (C. elegans)', 89, NULL, NULL, 135780),
(135781, '3.30.530.20-FF-000014', NULL, 'stAR-related lipid transfer protein 3 isoform X2', 229, NULL, NULL, 135781),
(135782, '3.20.20.60-FF-000022', NULL, 'CoA ester lyase', 60, NULL, NULL, 135782),
(135783, '1.20.80.10-FF-000049', NULL, 'Predicted protein', 119, NULL, NULL, 135783),
(135784, '1.25.40.20-FF-001495', NULL, 'Uncharacterized protein', 74, NULL, NULL, 135784);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(135785, '1.20.120.1910-FF-000010', NULL, 'Cysteinyl-tRNA synthetase 2, mitochondrial', 182, NULL, NULL, 135785),
(135786, '3.30.1680.10-FF-000010', NULL, 'semaphorin-4F isoform X1', 64, NULL, NULL, 135786),
(135787, '3.30.200.20-FF-001007', NULL, 'Protein kinase domain containing protein', 92, NULL, NULL, 135787),
(135788, '3.30.160.60-FF-000082', NULL, 'Putative zinc finger E-box-binding homeobox 2', 30, NULL, NULL, 135788),
(135789, '1.20.1080.10-FF-000098', NULL, 'Predicted protein', 228, NULL, NULL, 135789),
(135790, '2.60.40.10-FF-000211', NULL, 'Obscurin-like protein 1', 89, NULL, NULL, 135790),
(135791, '1.10.486.10-FF-000055', NULL, 'AaceriAFR093Wp', 138, NULL, NULL, 135791),
(135792, '2.130.10.10-FF-001931', NULL, 'Uncharacterized protein', 356, NULL, NULL, 135792),
(135793, '3.40.50.300-FF-005366', NULL, 'DNA helicase', 153, NULL, NULL, 135793),
(135794, '3.60.20.10-FF-000045', NULL, 'Glutamine amidotransferase DUG3', 316, NULL, NULL, 135794),
(135795, '3.40.50.450-FF-000043', NULL, 'ATP-dependent 6-phosphofructokinase, platelet type', 222, NULL, NULL, 135795),
(135796, '3.80.10.10-FF-000487', NULL, 'F-box and leucine-rich repeat protein 6', 349, NULL, NULL, 135796),
(135797, '1.25.40.20-FF-001837', NULL, 'Kinase, NEK', 145, NULL, NULL, 135797),
(135798, '2.170.210.10-FF-000014', NULL, 'Uncharacterized protein', 60, NULL, NULL, 135798),
(135799, '2.60.120.290-FF-000018', NULL, 'cubilin', 113, NULL, NULL, 135799),
(135800, '1.10.580.10-FF-000032', NULL, 'Citrate synthase', 93, NULL, NULL, 135800),
(135801, '1.20.1250.20-FF-000485', NULL, 'Solute carrier organic anion transporter family member', 220, NULL, NULL, 135801),
(135802, '3.40.50.410-FF-000273', NULL, 'Uncharacterized protein', 77, NULL, NULL, 135802),
(135803, '1.50.40.10-FF-000130', NULL, 'Putative ADP/ATP carrier protein', 327, NULL, NULL, 135803),
(135804, '3.30.40.10-FF-002329', NULL, 'Uncharacterized protein', 97, NULL, NULL, 135804),
(135805, '1.10.630.10-FF-000037', NULL, 'Cytochrome P450 9', 488, NULL, NULL, 135805),
(135806, '3.90.550.10-FF-000061', NULL, 'Cellulose synthase catalytic subunit [UDP-forming]', 222, NULL, NULL, 135806),
(135807, '3.40.50.460-FF-000046', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit alpha 2', 28, NULL, NULL, 135807),
(135808, '3.50.50.60-FF-001450', NULL, 'Predicted protein', 86, NULL, NULL, 135808),
(135809, '1.25.40.10-FF-001834', NULL, 'Pentatricopeptide repeat-containing protein At4g39952, mitochondrial', 100, NULL, NULL, 135809),
(135810, '3.30.160.60-FF-001493', NULL, 'zinc finger protein 664', 26, NULL, NULL, 135810),
(135811, '3.90.1260.10-FF-000015', NULL, 'Uncharacterized protein', 184, NULL, NULL, 135811),
(135812, '3.10.580.10-FF-000171', NULL, 'Chloride channel protein', 162, NULL, NULL, 135812),
(135813, '1.25.40.10-FF-005196', NULL, 'Uncharacterized protein', 218, NULL, NULL, 135813),
(135814, '3.90.1170.30-FF-000008', NULL, 'Pyrimidine-nucleoside phosphorylase family protein', 89, NULL, NULL, 135814),
(135815, '2.20.25.350-FF-000007', NULL, NULL, 22, NULL, NULL, 135815),
(135816, '1.10.357.70-FF-000003', NULL, 'exocyst complex component 3-like protein 2', 179, NULL, NULL, 135816),
(135817, '3.30.300.30-FF-000091', NULL, 'Probable acyl-activating enzyme 18, peroxisomal', 115, NULL, NULL, 135817),
(135818, '2.60.40.10-FF-003645', NULL, 'Cytokine receptor', 99, NULL, NULL, 135818),
(135819, '2.10.25.10-FF-000509', NULL, 'Latent transforming growth factor beta binding protein 2', 41, NULL, NULL, 135819),
(135820, '1.10.3370.10-FF-000049', NULL, 'Uncharacterized protein', 94, NULL, NULL, 135820),
(135821, '3.40.50.2000-FF-000378', NULL, 'Glycogen phosphorylase', 197, NULL, NULL, 135821),
(135822, '4.10.950.10-FF-000004', NULL, '60S ribosomal protein L2, mitochondrial', 67, NULL, NULL, 135822),
(135823, '4.10.280.10-FF-000043', NULL, 'Helix-loop-helix DNA binding protein', 64, NULL, NULL, 135823),
(135824, '2.60.300.12-FF-000027', NULL, NULL, 106, NULL, NULL, 135824),
(135825, '3.40.50.720-FF-001540', NULL, 'Uncharacterized protein', 262, NULL, NULL, 135825);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(135826, '3.30.460.10-FF-000146', NULL, 'Terminal uridylyl transferase 4', 64, NULL, NULL, 135826),
(135827, '2.130.10.10-FF-005309', NULL, 'Uncharacterized protein', 209, NULL, NULL, 135827),
(135828, '3.40.33.10-FF-000171', NULL, 'Uncharacterized protein', 93, NULL, NULL, 135828),
(135829, '1.10.357.30-FF-000020', NULL, NULL, 49, NULL, NULL, 135829),
(135830, '1.20.5.110-FF-000144', NULL, 'CRE-SYX-17 protein', 85, NULL, NULL, 135830),
(135831, '1.10.287.70-FF-000357', NULL, 'Calcium channel protein, putative', 168, NULL, NULL, 135831),
(135832, '3.40.1410.10-FF-000039', NULL, 'Transcriptional regulator, GntR family', 161, NULL, NULL, 135832),
(135833, '3.10.310.40-FF-000014', NULL, 'Alanine--tRNA ligase, cytoplasmic-like Protein', 159, NULL, NULL, 135833),
(135834, '1.20.1560.10-FF-000808', NULL, 'Uncharacterized protein', 159, NULL, NULL, 135834),
(135835, '3.40.20.10-FF-000091', NULL, 'Map kinase phosphatase', 95, NULL, NULL, 135835),
(135836, '2.60.120.1000-FF-000012', NULL, 'Si:dkey-61l1.4', 216, NULL, NULL, 135836),
(135837, '3.30.70.660-FF-000039', NULL, 'Pseudouridine synthase', 205, NULL, NULL, 135837),
(135838, '3.40.50.300-FF-005708', NULL, 'Bifunctional shikimate kinase/3-dehydroquinate synthase', 170, NULL, NULL, 135838),
(135839, '1.25.40.470-FF-000074', NULL, 'Intraflagellar transport protein 122 homolog-like Protein', 198, NULL, NULL, 135839),
(135840, '3.30.160.60-FF-005764', NULL, NULL, 34, NULL, NULL, 135840),
(135841, '2.60.120.260-FF-000588', NULL, 'Uncharacterized protein', 157, NULL, NULL, 135841),
(135842, '3.30.710.10-FF-000469', NULL, 'Uncharacterized protein', 110, NULL, NULL, 135842),
(135843, '1.10.472.80-FF-000201', NULL, NULL, 146, NULL, NULL, 135843),
(135844, '1.10.287.1490-FF-000014', NULL, 'AGAP008095-PA', 173, NULL, NULL, 135844),
(135845, '1.25.10.10-FF-001664', NULL, 'Calcium-binding protein 39-like', 330, NULL, NULL, 135845),
(135846, '3.20.20.100-FF-000139', NULL, 'Uncharacterized protein', 298, NULL, NULL, 135846),
(135847, '1.10.510.10-FF-001843', NULL, 'Protein kinase, putative', 118, NULL, NULL, 135847),
(135848, '3.30.390.30-FF-000034', NULL, 'Pyridine nucleotide-disulfide oxidoreductase', 110, NULL, NULL, 135848),
(135849, '2.130.10.10-FF-001369', NULL, 'Uncharacterized protein', 320, NULL, NULL, 135849),
(135850, '2.60.40.10-FF-003971', NULL, NULL, 104, NULL, NULL, 135850),
(135851, '2.30.130.10-FF-000030', NULL, 'Glutamate 5-kinase', 95, NULL, NULL, 135851),
(135852, '1.10.630.10-FF-000368', NULL, 'Cytochrome P450 monooxygenase', 446, NULL, NULL, 135852),
(135853, '1.20.1410.10-FF-000028', NULL, 'Uncharacterized protein', 189, NULL, NULL, 135853),
(135854, '1.10.357.90-FF-000009', NULL, NULL, 107, NULL, NULL, 135854),
(135855, '3.30.70.240-FF-000014', NULL, 'Elongation factor Tu, putative', 134, NULL, NULL, 135855),
(135856, '3.40.50.300-FF-003909', NULL, 'GD17397', 218, NULL, NULL, 135856),
(135857, '3.30.70.330-FF-001800', NULL, NULL, 92, NULL, NULL, 135857),
(135858, '1.25.40.10-FF-004937', NULL, 'Uncharacterized protein', 201, NULL, NULL, 135858),
(135859, '3.20.20.70-FF-000250', NULL, 'GTP 3'',8-cyclase', 333, NULL, NULL, 135859),
(135860, '1.20.5.460-FF-000007', NULL, 'Peptidylprolyl isomerase like 2', 18, NULL, NULL, 135860),
(135861, '1.10.12.10-FF-000027', NULL, 'Chromodomain protein, Y-like', 56, NULL, NULL, 135861),
(135862, '3.10.450.490-FF-000005', NULL, 'Metalloendopeptidase', 86, NULL, NULL, 135862),
(135863, '3.30.70.250-FF-000017', NULL, NULL, 70, NULL, NULL, 135863),
(135864, '3.90.550.10-FF-000510', NULL, 'LARGE xylosyl- and glucuronyltransferase 1-like', 258, NULL, NULL, 135864),
(135865, '3.30.450.20-FF-000648', NULL, 'Sensory histidine protein kinase', 123, NULL, NULL, 135865),
(135866, '3.40.50.2300-FF-001204', NULL, NULL, 100, NULL, NULL, 135866),
(135867, '3.30.40.10-FF-001132', NULL, 'Multicopy suppressor of chk1 protein 1', 76, NULL, NULL, 135867),
(135868, '3.80.10.10-FF-000936', NULL, 'Platelet glycoprotein V', 192, NULL, NULL, 135868),
(135869, '3.10.280.10-FF-000024', NULL, 'Uncharacterized protein', 201, NULL, NULL, 135869);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(135870, '3.80.10.10-FF-003011', NULL, 'Predicted protein', 191, NULL, NULL, 135870),
(135871, '3.40.710.10-FF-000186', NULL, 'Golvesin', 174, NULL, NULL, 135871),
(135872, '6.10.250.3250-FF-000002', NULL, 'Component of cytosolic 80S ribosome and 60S large subunit', 38, NULL, NULL, 135872),
(135873, '3.60.10.10-FF-000325', NULL, 'Predicted protein', 260, NULL, NULL, 135873),
(135874, '1.10.40.30-FF-000019', NULL, 'Fumarate hydratase class II', 57, NULL, NULL, 135874),
(135875, '3.40.50.300-FF-001768', NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 10, mitochondrial', 227, NULL, NULL, 135875),
(135876, '3.30.160.60-FF-004022', NULL, NULL, 29, NULL, NULL, 135876),
(135877, '1.20.5.2700-FF-000003', NULL, 'NAD(P)H-quinone oxidoreductase subunit 5, chloroplastic', 76, NULL, NULL, 135877),
(135878, '3.30.160.60-FF-001947', NULL, 'Zinc finger protein 605', 30, NULL, NULL, 135878),
(135879, '1.10.8.60-FF-000430', NULL, 'AAA family ATPase peroxin 1', 120, NULL, NULL, 135879),
(135880, '3.40.50.2300-FF-001193', NULL, NULL, 252, NULL, NULL, 135880),
(135881, '3.30.310.80-FF-000027', NULL, 'Non-specific serine/threonine protein kinase', 95, NULL, NULL, 135881),
(135882, '3.40.50.720-FF-000826', NULL, 'Probable dehydrogenase/reductase', 301, NULL, NULL, 135882),
(135883, '3.30.505.10-FF-000161', NULL, 'Tyrosine-protein phosphatase non-receptor type', 121, NULL, NULL, 135883),
(135884, '2.130.10.30-FF-000178', NULL, NULL, 245, NULL, NULL, 135884),
(135885, '1.20.58.340-FF-000072', NULL, 'Cation transporter, putative', 114, NULL, NULL, 135885),
(135886, '3.30.160.60-FF-005219', NULL, NULL, 57, NULL, NULL, 135886),
(135887, '2.60.40.3510-FF-000023', NULL, 'Delta-like protein', 159, NULL, NULL, 135887),
(135888, '3.40.250.10-FF-000156', NULL, 'Rhodanese domain protein / beta-lactamase domain protein', 105, NULL, NULL, 135888),
(135889, '2.10.10.100-FF-000008', NULL, NULL, 74, NULL, NULL, 135889),
(135890, '1.50.40.10-FF-000461', NULL, 'Solute carrier family 25 member 32a', 91, NULL, NULL, 135890),
(135891, '2.40.50.140-FF-001117', NULL, NULL, 104, NULL, NULL, 135891),
(135892, '1.20.58.1310-FF-000002', NULL, 'Rop guanine nucleotide exchange factor 2', 116, NULL, NULL, 135892),
(135893, '3.40.50.620-FF-000566', NULL, 'Uncharacterized protein', 184, NULL, NULL, 135893),
(135894, '1.10.510.10-FF-000314', NULL, 'Serine threonine-protein kinase mak', 252, NULL, NULL, 135894),
(135895, '3.90.1260.10-FF-000009', NULL, 'Putative carbamoyl-phosphate synthase', 155, NULL, NULL, 135895),
(135896, '3.30.60.300-FF-000002', NULL, '60S ribosomal protein L10', 47, NULL, NULL, 135896),
(135897, '1.20.1560.10-FF-000814', NULL, 'Predicted protein', 136, NULL, NULL, 135897),
(135898, '1.20.1260.140-FF-000010', NULL, NULL, 118, NULL, NULL, 135898),
(135899, '3.40.50.720-FF-000719', NULL, 'Alanine dehydrogenase, truncation', 91, NULL, NULL, 135899),
(135900, '3.40.50.300-FF-000245', NULL, 'C-1-tetrahydrofolate synthase, cytoplasmic', 159, NULL, NULL, 135900),
(135901, '3.40.30.10-FF-000821', NULL, 'Protein disulfide isomerase-like 1-2', 48, NULL, NULL, 135901),
(135902, '3.30.342.10-FF-000041', NULL, 'DNA polymerase', 147, NULL, NULL, 135902),
(135903, '3.30.160.60-FF-005545', NULL, NULL, 35, NULL, NULL, 135903),
(135904, '1.20.1250.20-FF-000373', NULL, 'Vacuolar basic amino acid transporter', 277, NULL, NULL, 135904),
(135905, '3.40.50.300-FF-007496', NULL, 'Helicase, putative', 224, NULL, NULL, 135905),
(135906, '3.30.428.10-FF-000049', NULL, 'Aprataxin', 95, NULL, NULL, 135906),
(135907, '1.25.40.10-FF-001267', NULL, 'Tetratricopeptide repeat protein 30 homolog', 141, NULL, NULL, 135907),
(135908, '3.30.70.2190-FF-000010', NULL, 'FAD dependent oxidoreductase', 122, NULL, NULL, 135908),
(135909, '3.40.50.360-FF-000016', NULL, 'Sulfite reductase subunit beta', 161, NULL, NULL, 135909),
(135910, '2.60.40.840-FF-000005', NULL, 'Arrestin domain-containing protein', 177, NULL, NULL, 135910),
(135911, '3.60.40.10-FF-000260', NULL, 'Tap-1', 327, NULL, NULL, 135911),
(135912, '3.30.300.30-FF-000085', NULL, 'AMP-binding_enzyme/AMP-binding_enzyme_C-terminal_ domain/Ankyrin_repeats_(3_copies)/Ankyrin_repeat/Ankyrin_re peats_(Many_copies)_-_putative', 132, NULL, NULL, 135912);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(135913, '4.10.400.10-FF-000137', NULL, 'Uncharacterized protein, isoform AA', 42, NULL, NULL, 135913),
(135914, '2.60.40.10-FF-000205', NULL, 'Cell adhesion associated, oncogene regulated', 101, NULL, NULL, 135914),
(135915, '3.90.190.10-FF-000432', NULL, 'Uncharacterized protein', 72, NULL, NULL, 135915),
(135916, '2.30.29.30-FF-001052', NULL, 'Uncharacterized protein', 134, NULL, NULL, 135916),
(135917, '2.60.40.10-FF-003639', NULL, NULL, 53, NULL, NULL, 135917),
(135918, '2.60.120.10-FF-000163', NULL, 'Putative cupin-like protein', 222, NULL, NULL, 135918),
(135919, '3.40.250.10-FF-000049', NULL, 'Phage shock protein E', 99, NULL, NULL, 135919),
(135920, '3.30.300.20-FF-000082', NULL, 'Uncharacterized protein', 68, NULL, NULL, 135920),
(135921, '1.20.930.10-FF-000029', NULL, 'Uncharacterized protein', 144, NULL, NULL, 135921),
(135922, '3.80.10.10-FF-004540', NULL, 'Os08g0193500 protein', 134, NULL, NULL, 135922),
(135923, '2.60.40.10-FF-003864', NULL, NULL, 148, NULL, NULL, 135923),
(135924, '3.20.20.190-FF-000109', NULL, NULL, 139, NULL, NULL, 135924),
(135925, '3.30.200.20-FF-001445', NULL, 'Protein kinase, putative', 103, NULL, NULL, 135925),
(135926, '1.10.150.120-FF-000008', NULL, 'Probable aldehyde oxidase gad-3', 124, NULL, NULL, 135926),
(135927, '3.40.50.2300-FF-000586', NULL, 'Gluconate utilization system gnt-I transcriptional repressor', 132, NULL, NULL, 135927),
(135928, '1.10.150.110-FF-000005', NULL, 'DNA polymerase POL4', 97, NULL, NULL, 135928),
(135929, '3.40.50.2300-FF-000479', NULL, 'Two-component system response regulator', 167, NULL, NULL, 135929),
(135930, '1.10.472.80-FF-000077', NULL, 'TBC1 domain family member', 141, NULL, NULL, 135930),
(135931, '2.30.42.10-FF-000189', NULL, 'Big bang, isoform F', 113, NULL, NULL, 135931),
(135932, '1.10.8.60-FF-000317', NULL, 'AAA-domain-containing protein', 64, NULL, NULL, 135932),
(135933, '3.90.660.10-FF-000064', NULL, NULL, 60, NULL, NULL, 135933),
(135934, '3.30.200.20-FF-001552', NULL, 'Predicted protein', 103, NULL, NULL, 135934),
(135935, '3.30.1640.10-FF-000013', NULL, 'DNA replication licensing factor MCM7', 93, NULL, NULL, 135935),
(135936, '3.40.50.2020-FF-000030', NULL, 'Ribose-phosphate pyrophosphokinase II', 148, NULL, NULL, 135936),
(135937, '1.10.472.80-FF-000184', NULL, NULL, 138, NULL, NULL, 135937),
(135938, '3.40.50.300-FF-005372', NULL, 'mRNA cleavage and polyadenylation factor CLP1', 244, NULL, NULL, 135938),
(135939, '1.20.1050.80-FF-000021', NULL, 'Vacuolar sorting protein 9 (VPS9) domain containing protein, putative', 170, NULL, NULL, 135939),
(135940, '1.20.5.440-FF-000001', NULL, 'ATP synthase epsilon chain', 44, NULL, NULL, 135940),
(135941, '3.40.50.300-FF-007513', NULL, 'Uncharacterized protein', 214, NULL, NULL, 135941),
(135942, '1.10.287.660-FF-000028', NULL, 'Uncharacterized protein', 36, NULL, NULL, 135942),
(135943, '2.130.10.10-FF-003842', NULL, 'Uncharacterized protein', 293, NULL, NULL, 135943),
(135944, '3.30.160.60-FF-005326', NULL, NULL, 75, NULL, NULL, 135944),
(135945, '3.40.50.300-FF-007277', NULL, 'Si:ch211-197g15.6', 154, NULL, NULL, 135945),
(135946, '3.60.40.10-FF-000153', NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', 256, NULL, NULL, 135946),
(135947, '2.10.25.10-FF-000835', NULL, 'Delta-like protein', 62, NULL, NULL, 135947),
(135948, '2.60.40.10-FF-001498', NULL, 'immunoglobulin superfamily member 22', 102, NULL, NULL, 135948),
(135949, '3.40.430.10-FF-000035', NULL, 'RibD domain-containing protein', 257, NULL, NULL, 135949),
(135950, '3.40.50.800-FF-000070', NULL, 'Polymerase (DNA directed), gamma 2, accessory subunit', 106, NULL, NULL, 135950),
(135951, '3.30.70.330-FF-003144', NULL, NULL, 74, NULL, NULL, 135951),
(135952, '3.40.30.10-FF-000602', NULL, 'Sulfhydryl oxidase', 78, NULL, NULL, 135952),
(135953, '3.40.50.2000-FF-001108', NULL, 'Soluble starch synthase', 13, NULL, NULL, 135953),
(135954, '3.30.40.10-FF-001019', NULL, 'RBR-type E3 ubiquitin transferase', 84, NULL, NULL, 135954),
(135955, '3.10.580.10-FF-000064', NULL, 'Chloride channel protein', 118, NULL, NULL, 135955);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(135956, '3.40.50.300-FF-000352', NULL, 'ATP-dependent zinc metalloprotease FTSH 7, chloroplastic', 189, NULL, NULL, 135956),
(135957, '1.25.40.10-FF-003633', NULL, 'Pentatricopeptide repeat-containing protein At5g62370', 127, NULL, NULL, 135957),
(135958, '1.10.268.10-FF-000003', NULL, 'DNA topoisomerase 2', 171, NULL, NULL, 135958),
(135959, '1.10.630.10-FF-000711', NULL, 'Uncharacterized protein', 116, NULL, NULL, 135959),
(135960, '3.30.590.20-FF-000012', NULL, 'Putative glutamate--cysteine ligase 2', 364, NULL, NULL, 135960),
(135961, '2.130.10.10-FF-001712', NULL, 'Sema domain, immunoglobulin domain (Ig), short basic domain, secreted, (semaphorin) 3H', 491, NULL, NULL, 135961),
(135962, '3.30.160.60-FF-005438', NULL, NULL, 53, NULL, NULL, 135962),
(135963, '3.90.380.10-FF-000025', NULL, NULL, 286, NULL, NULL, 135963),
(135964, '3.30.160.60-FF-000531', NULL, 'Zinc finger protein 827', 24, NULL, NULL, 135964),
(135965, '4.10.400.10-FF-000250', NULL, 'Lipophorin receptor 2, isoform B', 37, NULL, NULL, 135965),
(135966, '3.40.850.10-FF-000472', NULL, 'Kinesin-like protein', 402, NULL, NULL, 135966),
(135967, '1.10.10.60-FF-001139', NULL, NULL, 59, NULL, NULL, 135967),
(135968, '3.40.50.1460-FF-000064', NULL, 'Uncharacterized protein', 286, NULL, NULL, 135968),
(135969, '3.30.1640.30-FF-000019', NULL, NULL, 54, NULL, NULL, 135969),
(135970, '3.80.10.10-FF-002286', NULL, 'Fgr38p', 241, NULL, NULL, 135970),
(135971, '1.10.287.70-FF-000683', NULL, 'Uncharacterized protein', 86, NULL, NULL, 135971),
(135972, '2.130.10.10-FF-002100', NULL, 'Unplaced genomic scaffold supercont1.23, whole genome shotgun sequence', 134, NULL, NULL, 135972),
(135973, '3.30.160.20-FF-000216', NULL, 'Uncharacterized protein', 81, NULL, NULL, 135973),
(135974, '3.90.190.10-FF-000319', NULL, 'Predicted protein', 99, NULL, NULL, 135974),
(135975, '1.10.268.20-FF-000006', NULL, NULL, 128, NULL, NULL, 135975),
(135976, '2.60.40.10-FF-001515', NULL, 'Colony stimulating factor 2 receptor alpha subunit', 98, NULL, NULL, 135976),
(135977, '3.30.450.20-FF-000429', NULL, 'Sensor histidine kinase, PAS, PAS and PAS domain-containing', 118, NULL, NULL, 135977),
(135978, '1.25.40.10-FF-001380', NULL, 'TPR repeat-containing protein ZIP4', 114, NULL, NULL, 135978),
(135979, '3.80.10.10-FF-002067', NULL, 'Uncharacterized protein', 71, NULL, NULL, 135979),
(135980, '1.20.1560.10-FF-000921', NULL, 'Uncharacterized protein', 94, NULL, NULL, 135980),
(135981, '1.20.1250.10-FF-000038', NULL, 'Interleukin 24', 156, NULL, NULL, 135981),
(135982, '1.20.1600.10-FF-000060', NULL, 'Outer membrane efflux protein', 402, NULL, NULL, 135982),
(135983, '3.40.50.1820-FF-000874', NULL, 'Putative esterase KAI2', 136, NULL, NULL, 135983),
(135984, '1.10.287.110-FF-000105', NULL, 'Chaperone DnaJ-domain superfamily protein', 102, NULL, NULL, 135984),
(135985, '1.10.510.10-FF-001950', NULL, 'Receptor protein serine/threonine kinase', 216, NULL, NULL, 135985),
(135986, '2.60.40.10-FF-001734', NULL, 'Nonclassical MHC class I molecule, alpha chain', 104, NULL, NULL, 135986),
(135987, '3.40.1380.20-FF-000027', NULL, 'Pyruvate kinase', 141, NULL, NULL, 135987),
(135988, '3.40.50.300-FF-005259', NULL, 'Ras-related protein Rab-39B', 186, NULL, NULL, 135988),
(135989, '3.30.200.20-FF-000838', NULL, 'Non-specific serine/threonine protein kinase', 104, NULL, NULL, 135989),
(135990, '1.25.40.20-FF-001383', NULL, 'ANKYRIN', 70, NULL, NULL, 135990),
(135991, '1.20.1250.20-FF-000592', NULL, 'Phosphate transporter', 221, NULL, NULL, 135991),
(135992, '3.40.50.10380-FF-000024', NULL, 'Malic enzyme', 250, NULL, NULL, 135992),
(135993, '3.40.50.150-FF-000054', NULL, 'Catechol O-methyltransferase', 213, NULL, NULL, 135993),
(135994, '1.10.8.60-FF-000087', NULL, '26S protease regulatory subunit 7', 71, NULL, NULL, 135994),
(135995, '3.40.190.10-FF-000909', NULL, 'Uncharacterized protein', 99, NULL, NULL, 135995),
(135996, '3.40.50.300-FF-008114', NULL, 'Uncharacterized protein', 107, NULL, NULL, 135996),
(135997, '2.130.10.10-FF-005753', NULL, 'F-box/WD repeat-containing protein A', 119, NULL, NULL, 135997);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(135998, '2.30.29.30-FF-000338', NULL, 'Uncharacterized protein, isoform D', 125, NULL, NULL, 135998),
(135999, '3.30.70.330-FF-000963', NULL, 'NMD pathway component', 113, NULL, NULL, 135999),
(136000, '1.25.40.10-FF-001379', NULL, 'Selenium-binding protein-like', 193, NULL, NULL, 136000),
(136001, '3.40.50.620-FF-000785', NULL, 'Uncharacterized protein', 79, NULL, NULL, 136001),
(136002, '3.40.1380.10-FF-000024', NULL, 'ATP synthase gamma chain', 220, NULL, NULL, 136002),
(136003, '1.10.3210.10-FF-000105', NULL, 'Uncharacterized protein', 137, NULL, NULL, 136003),
(136004, '2.60.40.10-FF-003752', NULL, NULL, 99, NULL, NULL, 136004),
(136005, '1.25.40.10-FF-003414', NULL, 'PPR repeat family, putative', 118, NULL, NULL, 136005),
(136006, '1.25.40.10-FF-002796', NULL, 'Putative pentatricopeptide repeat-containing protein', 264, NULL, NULL, 136006),
(136007, '1.20.120.1630-FF-000027', NULL, 'Uncharacterized protein', 160, NULL, NULL, 136007),
(136008, '3.40.50.720-FF-000607', NULL, 'Inositol-3-phosphate synthase', 107, NULL, NULL, 136008),
(136009, '2.10.25.10-FF-000616', NULL, 'neurexin-1 isoform X3', 39, NULL, NULL, 136009),
(136010, '1.10.10.10-FF-000410', NULL, 'ADA regulatory protein, putative', 87, NULL, NULL, 136010),
(136011, '3.40.33.10-FF-000064', NULL, 'Uncharacterized protein', 223, NULL, NULL, 136011),
(136012, '3.10.20.30-FF-000002', NULL, 'GTP pyrophosphokinase (RelA/SpoT)', 74, NULL, NULL, 136012),
(136013, '3.30.1370.110-FF-000002', NULL, 'CCCH zinc finger and SMR domain protein', 106, NULL, NULL, 136013),
(136014, '3.40.50.150-FF-001813', NULL, NULL, 357, NULL, NULL, 136014),
(136015, '2.120.10.90-FF-000022', NULL, 'Predicted protein', 87, NULL, NULL, 136015),
(136016, '2.130.10.10-FF-001482', NULL, 'Coronin', 340, NULL, NULL, 136016),
(136017, '1.10.630.10-FF-000481', NULL, 'Cytochrome P450, putative', 475, NULL, NULL, 136017),
(136018, '3.30.200.20-FF-001333', NULL, 'Protein kinase, putative (AFU_orthologue AFUA_7G00740)', 104, NULL, NULL, 136018),
(136019, '1.10.287.70-FF-000464', NULL, 'Potassium voltage-gated channel subfamily H member 8', 244, NULL, NULL, 136019),
(136020, '2.40.270.10-FF-000032', NULL, NULL, 226, NULL, NULL, 136020),
(136021, '3.40.50.200-FF-000092', NULL, 'Uncharacterized protein', 210, NULL, NULL, 136021),
(136022, '3.40.50.1360-FF-000034', NULL, '6-phosphogluconolactonase', 140, NULL, NULL, 136022),
(136023, '2.40.33.10-FF-000010', NULL, 'Pyruvate kinase family protein', 107, NULL, NULL, 136023),
(136024, '1.20.910.10-FF-000028', NULL, 'Rop guanine nucleotide exchange factor 7', 140, NULL, NULL, 136024),
(136025, '3.40.50.1910-FF-000019', NULL, 'Carnation, isoform C', 205, NULL, NULL, 136025),
(136026, '3.40.50.300-FF-001881', NULL, 'Structural maintenance of chromosomes protein', 215, NULL, NULL, 136026),
(136027, '3.30.2140.20-FF-000001', NULL, 'Arylamine N-acetyltransferase 1', 290, NULL, NULL, 136027),
(136028, '3.40.30.10-FF-000041', NULL, 'Maleylacetoacetate isomerase isoform 1', 78, NULL, NULL, 136028),
(136029, '1.20.120.350-FF-000170', NULL, NULL, 164, NULL, NULL, 136029),
(136030, '3.20.80.10-FF-000033', NULL, 'Uncharacterized protein', 136, NULL, NULL, 136030),
(136031, '2.40.50.140-FF-000499', NULL, 'Glycerol-3-phosphate ABC transporter ATP-binding protein', 45, NULL, NULL, 136031),
(136032, '2.60.120.200-FF-000609', NULL, 'Protein crumbs-like Protein', 152, NULL, NULL, 136032),
(136033, '1.10.510.10-FF-001731', NULL, NULL, 94, NULL, NULL, 136033),
(136034, '1.20.1250.20-FF-002284', NULL, 'Os01g0311300 protein', 85, NULL, NULL, 136034),
(136035, '2.30.30.140-FF-000222', NULL, 'Histone-lysine N-methyltransferase', 100, NULL, NULL, 136035),
(136036, '3.20.20.140-FF-000454', NULL, 'Guanine deaminase', 314, NULL, NULL, 136036),
(136037, '3.40.1280.10-FF-000096', NULL, 'Uncharacterized protein', 300, NULL, NULL, 136037),
(136038, '3.30.710.10-FF-000357', NULL, 'BTB and CNC homology 1, basic leucine zipper transcription factor 1 b', 130, NULL, NULL, 136038),
(136039, '3.30.460.10-FF-000034', NULL, 'CCA tRNA nucleotidyltransferase', 140, NULL, NULL, 136039);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(136040, '2.60.120.200-FF-000267', NULL, 'Cadherin EGF LAG seven-pass G-type receptor', 171, NULL, NULL, 136040),
(136041, '3.90.1200.10-FF-000017', NULL, 'Aminoglycoside phosphotransferase', 234, NULL, NULL, 136041),
(136042, '3.50.40.10-FF-000001', NULL, 'Phenylalanine--tRNA ligase beta subunit', 201, NULL, NULL, 136042),
(136043, '3.90.230.10-FF-000020', NULL, 'FACT complex subunit SPT16', 272, NULL, NULL, 136043),
(136044, '3.30.900.10-FF-000063', NULL, 'Uncharacterized protein', 58, NULL, NULL, 136044),
(136045, '2.40.50.40-FF-000093', NULL, 'C-C motif chemokine', 79, NULL, NULL, 136045),
(136046, '1.10.287.1090-FF-000001', NULL, 'major centromere autoantigen B', 58, NULL, NULL, 136046),
(136047, '1.20.120.1080-FF-000042', NULL, 'probable ATP-dependent RNA helicase kurz', 112, NULL, NULL, 136047),
(136048, '3.30.420.10-FF-000256', NULL, 'Conserved protein of uncharacterized function, possible transposase remnant', 150, NULL, NULL, 136048),
(136049, '1.20.930.40-FF-000010', NULL, 'VPS70p protein', 161, NULL, NULL, 136049),
(136050, '3.40.50.300-FF-003803', NULL, 'Uncharacterized protein', 59, NULL, NULL, 136050),
(136051, '1.10.3860.10-FF-000025', NULL, 'Amino acid transporter', 277, NULL, NULL, 136051),
(136052, '3.80.10.10-FF-002847', NULL, 'Leucine rich repeat containing 15', 123, NULL, NULL, 136052),
(136053, '3.90.640.10-FF-000175', NULL, 'Uncharacterized protein', 137, NULL, NULL, 136053),
(136054, '2.60.40.10-FF-001953', NULL, 'V-set and transmembrane domain containing 4b', 138, NULL, NULL, 136054),
(136055, '1.25.50.20-FF-000028', NULL, 'Aminopeptidase', 311, NULL, NULL, 136055),
(136056, '1.10.1620.20-FF-000010', NULL, 'ATP synthase subunit epsilon, mitochondrial', 57, NULL, NULL, 136056),
(136057, '1.50.10.20-FF-000075', NULL, 'Protein farnesyltransferase subunit beta', 401, NULL, NULL, 136057),
(136058, '3.80.10.10-FF-003123', NULL, 'Distal membrane arm assembly complex 2', 86, NULL, NULL, 136058),
(136059, '1.10.287.90-FF-000003', NULL, 'Cytochrome C oxidase subunit II', 86, NULL, NULL, 136059),
(136060, '1.50.10.10-FF-000072', NULL, 'Lanthionine synthetase C family protein, putative', 481, NULL, NULL, 136060),
(136061, '3.40.50.20-FF-000039', NULL, 'D-alanine--D-alanine ligase', 121, NULL, NULL, 136061),
(136062, '1.20.1560.10-FF-000578', NULL, 'Uncharacterized protein', 202, NULL, NULL, 136062),
(136063, '1.20.58.400-FF-000017', NULL, 'Vesicle transport through interaction with t-SNAREs homolog 1A', 97, NULL, NULL, 136063),
(136064, '6.10.140.2220-FF-000008', NULL, 'Deformed epidermal autoregulatory factor 1', 51, NULL, NULL, 136064),
(136065, '1.25.40.20-FF-000202', NULL, 'Protein fem-1 homolog B', 142, NULL, NULL, 136065),
(136066, '1.20.1050.10-FF-000276', NULL, 'ARM repeat superfamily protein', 88, NULL, NULL, 136066),
(136067, '3.30.160.60-FF-004241', NULL, NULL, 32, NULL, NULL, 136067),
(136068, '1.50.10.160-FF-000004', NULL, 'Type B diterpene cyclase', 218, NULL, NULL, 136068),
(136069, '3.40.605.10-FF-000054', NULL, 'Aldehyde dehydrogenase family 1 member A3', 294, NULL, NULL, 136069),
(136070, '1.10.357.30-FF-000019', NULL, NULL, 123, NULL, NULL, 136070),
(136071, '3.30.70.940-FF-000016', NULL, 'Uncharacterized protein', 97, NULL, NULL, 136071),
(136072, '4.10.240.10-FF-000153', NULL, 'Lys144p', 71, NULL, NULL, 136072),
(136073, '1.20.930.60-FF-000016', NULL, 'Uncharacterized protein', 102, NULL, NULL, 136073),
(136074, '3.40.190.10-FF-000898', NULL, 'Predicted protein', 115, NULL, NULL, 136074),
(136075, '3.80.10.10-FF-000717', NULL, 'Os02g0136900 protein', 169, NULL, NULL, 136075),
(136076, '1.25.40.10-FF-003178', NULL, 'Pentatricopeptide repeat-containing protein', 106, NULL, NULL, 136076),
(136077, '3.60.21.10-FF-000007', NULL, 'Serine/threonine-protein phosphatase', 308, NULL, NULL, 136077),
(136078, '2.60.40.1390-FF-000005', NULL, 'Meiosis-specific transcription factor NDT80', 305, NULL, NULL, 136078),
(136079, '1.10.630.10-FF-000149', NULL, 'Uncharacterized protein', 461, NULL, NULL, 136079),
(136080, '3.10.20.90-FF-000323', NULL, 'Nuclear protein localization protein 4 homolog', 79, NULL, NULL, 136080);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(136081, '3.40.50.740-FF-000023', NULL, 'Dimethyl sulfoxide reductase subunit A', 301, NULL, NULL, 136081),
(136082, '3.20.20.80-FF-000472', NULL, 'Glycoside hydrolase, family 35', 345, NULL, NULL, 136082),
(136083, '3.30.190.20-FF-000044', NULL, '39S ribosomal protein L1, mitochondrial', 72, NULL, NULL, 136083),
(136084, '1.10.287.470-FF-000073', NULL, 'Efflux pump, RND family, membrane fusion lipoprotein', 88, NULL, NULL, 136084),
(136085, '1.50.40.10-FF-000242', NULL, 'Putative mitochondrial carrier protein', 115, NULL, NULL, 136085),
(136086, '1.50.10.150-FF-000001', NULL, 'S-type anion channel SLAH3', 318, NULL, NULL, 136086),
(136087, '3.60.10.10-FF-000089', NULL, 'Exodeoxyribonuclease III, putative', 102, NULL, NULL, 136087),
(136088, '1.25.40.20-FF-001725', NULL, 'Uncharacterized protein', 227, NULL, NULL, 136088),
(136089, '1.10.510.10-FF-003748', NULL, NULL, 145, NULL, NULL, 136089),
(136090, '1.10.8.480-FF-000021', NULL, 'rRNA adenine N(6)-methyltransferase', 91, NULL, NULL, 136090),
(136091, '2.60.40.150-FF-000006', NULL, 'Synaptotagmin-like 5, isoform CRA_a', 141, NULL, NULL, 136091),
(136092, '3.90.70.10-FF-000052', NULL, 'Ubiquitinyl hydrolase 1', 233, NULL, NULL, 136092),
(136093, '1.25.40.10-FF-005090', NULL, 'Putative pentatricopeptide repeat-containing protein At1g12700, mitochondrial', 72, NULL, NULL, 136093),
(136094, '3.40.1190.20-FF-000215', NULL, NULL, 278, NULL, NULL, 136094),
(136095, '1.20.140.10-FF-000014', NULL, 'Cytochrome c-552', 143, NULL, NULL, 136095),
(136096, '3.40.50.300-FF-007058', NULL, 'Uncharacterized protein', 196, NULL, NULL, 136096),
(136097, '1.20.1740.10-FF-000126', NULL, 'Amino acid transporter (Eurofung)', 473, NULL, NULL, 136097),
(136098, '1.10.1750.10-FF-000011', NULL, NULL, 101, NULL, NULL, 136098),
(136099, '3.40.50.300-FF-005478', NULL, 'Uncharacterized protein', 365, NULL, NULL, 136099),
(136100, '3.30.160.60-FF-000312', NULL, 'Zinc finger and BTB domain-containing 47', 31, NULL, NULL, 136100),
(136101, '1.25.40.10-FF-001722', NULL, 'pentatricopeptide repeat-containing protein At4g01030, mitochondrial', 149, NULL, NULL, 136101),
(136102, '1.20.920.10-FF-000080', NULL, 'Histone-lysine N-methyltransferase trithorax', 95, NULL, NULL, 136102),
(136103, '2.10.50.10-FF-000017', NULL, 'Tumor necrosis factor receptor superfamily member 10B', 41, NULL, NULL, 136103),
(136104, '3.40.50.1820-FF-001150', NULL, 'Lipoxygenase-like protein', 130, NULL, NULL, 136104),
(136105, '3.40.50.1240-FF-000110', NULL, 'Uncharacterized protein', 221, NULL, NULL, 136105),
(136106, '3.30.40.10-FF-001351', NULL, 'Pre-mRNA-splicing factor CWC24', 58, NULL, NULL, 136106),
(136107, '1.10.1040.10-FF-000053', NULL, '3-hydroxyacyl-CoA dehydrogenase', 105, NULL, NULL, 136107),
(136108, '2.30.110.10-FF-000028', NULL, 'PPOX class F420-dependent oxidoreductase', 107, NULL, NULL, 136108),
(136109, '3.40.50.300-FF-001549', NULL, 'SUV3p ATP-dependent RNA helicase', 156, NULL, NULL, 136109),
(136110, '3.90.180.10-FF-000038', NULL, 'Ast1p', 113, NULL, NULL, 136110),
(136111, '1.20.1280.50-FF-000181', NULL, 'Uncharacterized protein', 54, NULL, NULL, 136111),
(136112, '3.40.630.30-FF-000354', NULL, 'AGAP003264-PA', 143, NULL, NULL, 136112),
(136113, '1.10.510.10-FF-004024', NULL, NULL, 114, NULL, NULL, 136113),
(136114, '3.40.1110.10-FF-000095', NULL, 'Calcium-transporting ATPase, putative', 190, NULL, NULL, 136114),
(136115, '1.10.287.70-FF-000245', NULL, 'Voltage-gated sodium channel Nav2.1', 124, NULL, NULL, 136115),
(136116, '3.30.720.190-FF-000001', NULL, 'PlyCB', 72, NULL, NULL, 136116),
(136117, '2.40.290.10-FF-000027', NULL, 'ATP-dependent DNA helicase II subunit 2', 199, NULL, NULL, 136117),
(136118, '2.60.220.50-FF-000093', NULL, 'Starry night', 110, NULL, NULL, 136118),
(136119, '1.20.58.1120-FF-000046', NULL, NULL, 144, NULL, NULL, 136119),
(136120, '1.10.510.10-FF-003187', NULL, NULL, 152, NULL, NULL, 136120),
(136121, '1.10.520.10-FF-000034', NULL, 'Peroxidase', 50, NULL, NULL, 136121),
(136122, '6.10.140.2200-FF-000002', NULL, 'cbp/p300-interacting transactivator 1 isoform X2', 52, NULL, NULL, 136122);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(136123, '1.20.58.2170-FF-000001', NULL, 'Death domain-associated protein 6', 210, NULL, NULL, 136123),
(136124, '3.10.50.40-FF-000052', NULL, 'Peptidylprolyl isomerase', 143, NULL, NULL, 136124),
(136125, '3.40.50.1010-FF-000171', NULL, NULL, 103, NULL, NULL, 136125),
(136126, '3.40.50.1000-FF-000510', NULL, 'Phospholipid-transporting ATPase', 177, NULL, NULL, 136126),
(136127, '3.80.10.10-FF-000375', NULL, 'Piriformospora indica-insensitive protein 2', 104, NULL, NULL, 136127),
(136128, '1.20.1270.60-FF-000245', NULL, 'Uncharacterized protein', 78, NULL, NULL, 136128),
(136129, '2.60.40.10-FF-003533', NULL, 'Titin, tandem duplicate 1', 111, NULL, NULL, 136129),
(136130, '3.40.50.300-FF-003348', NULL, 'Uncharacterized protein', 286, NULL, NULL, 136130),
(136131, '2.30.42.10-FF-000644', NULL, NULL, 45, NULL, NULL, 136131),
(136132, '1.20.58.60-FF-000883', NULL, 'Spectrin alpha, non-erythrocytic 1', 64, NULL, NULL, 136132),
(136133, '1.20.1250.20-FF-001210', NULL, 'Sodium-dependent phosphate transport protein 4', 158, NULL, NULL, 136133),
(136134, '3.40.390.10-FF-000099', NULL, 'GM23611', 301, NULL, NULL, 136134),
(136135, '3.40.50.150-FF-001690', NULL, NULL, 109, NULL, NULL, 136135),
(136136, '3.80.10.10-FF-000830', NULL, 'Predicted protein', 219, NULL, NULL, 136136),
(136137, '1.25.40.10-FF-003291', NULL, 'Vacuolar protein sorting-associated protein 11 homolog', 214, NULL, NULL, 136137),
(136138, '3.60.21.10-FF-000120', NULL, '3'',5''-cyclic adenosine monophosphate phosphodiesterase CpdA', 298, NULL, NULL, 136138),
(136139, '3.30.9.10-FF-000222', NULL, 'NAD dehydrogenase, putative', 34, NULL, NULL, 136139),
(136140, '1.20.1070.10-FF-000726', NULL, 'Protein CBG03354', 155, NULL, NULL, 136140),
(136141, '3.10.20.90-FF-000104', NULL, 'Tyrosine-protein phosphatase non-receptor type', 87, NULL, NULL, 136141),
(136142, '2.60.40.10-FF-002116', NULL, 'Titin homolog', 109, NULL, NULL, 136142),
(136143, '1.10.340.70-FF-000038', NULL, 'Uncharacterized protein', 90, NULL, NULL, 136143),
(136144, '3.20.20.80-FF-000691', NULL, 'Predicted protein', 288, NULL, NULL, 136144),
(136145, '1.20.58.2190-FF-000007', NULL, 'Ubiquitin-associated (UBA)/TS-N domain-containing protein', 98, NULL, NULL, 136145),
(136146, '2.60.40.10-FF-005663', NULL, NULL, 88, NULL, NULL, 136146),
(136147, '3.40.50.720-FF-002176', NULL, 'Uncharacterized protein', 62, NULL, NULL, 136147),
(136148, '1.20.1070.10-FF-000384', NULL, 'Prostaglandin E receptor 1a (subtype EP1)', 312, NULL, NULL, 136148),
(136149, '3.30.70.260-FF-000133', NULL, 'Lysine-sensitive aspartokinase III', 70, NULL, NULL, 136149),
(136150, '1.25.40.250-FF-000013', NULL, 'Eukaryotic translation initiation factor 3 subunit K', 128, NULL, NULL, 136150),
(136151, '2.40.50.140-FF-000954', NULL, NULL, 62, NULL, NULL, 136151),
(136152, '3.40.50.1010-FF-000058', NULL, 'Flap endonuclease 1', 222, NULL, NULL, 136152),
(136153, '1.10.3370.10-FF-000050', NULL, 'Sec61 alpha subunit putative', 48, NULL, NULL, 136153),
(136154, '3.40.630.30-FF-000135', NULL, 'RNA cytidine acetyltransferase', 202, NULL, NULL, 136154),
(136155, '1.25.40.70-FF-000065', NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', 148, NULL, NULL, 136155),
(136156, '2.60.120.10-FF-000382', NULL, '(S)-2-hydroxypropylphosphonic acid epoxidase', 129, NULL, NULL, 136156),
(136157, '1.20.1070.10-FF-001002', NULL, 'Uncharacterized protein', 343, NULL, NULL, 136157),
(136158, '2.10.50.10-FF-000130', NULL, 'Tumor necrosis factor receptor superfamily, member 1a', 37, NULL, NULL, 136158),
(136159, '1.10.150.50-FF-000220', NULL, 'Uncharacterized protein', 44, NULL, NULL, 136159),
(136160, '3.60.40.10-FF-000259', NULL, 'Uncharacterized protein', 330, NULL, NULL, 136160),
(136161, '1.50.40.10-FF-000129', NULL, 'Peroxisomal membrane protein', 292, NULL, NULL, 136161),
(136162, '2.30.30.40-FF-000052', NULL, 'Ubiquitin-associated and SH3 domain-containing protein B', 64, NULL, NULL, 136162),
(136163, '3.30.70.330-FF-001126', NULL, 'Nucleolin', 100, NULL, NULL, 136163),
(136164, '1.25.10.10-FF-002968', NULL, 'Importin 4', 418, NULL, NULL, 136164);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(136165, '2.60.40.1730-FF-000028', NULL, 'Aminopeptidase', 210, NULL, NULL, 136165),
(136166, '3.80.10.10-FF-004427', NULL, 'Uncharacterized protein', 243, NULL, NULL, 136166),
(136167, '1.10.10.10-FF-001714', NULL, 'ATP-dependent DNA helicase', 126, NULL, NULL, 136167),
(136168, '3.90.1410.10-FF-000050', NULL, 'SET domain-containing protein 4', 245, NULL, NULL, 136168),
(136169, '2.130.10.10-FF-005079', NULL, 'WD repeat protein iqw1', 266, NULL, NULL, 136169),
(136170, '3.40.50.150-FF-001577', NULL, NULL, 57, NULL, NULL, 136170),
(136171, '3.90.190.10-FF-000538', NULL, 'Uncharacterized protein', 170, NULL, NULL, 136171),
(136172, '1.10.10.10-FF-001591', NULL, '6-hydroxytryprostatin B O-methyltransferase', 86, NULL, NULL, 136172),
(136173, '3.40.50.1700-FF-000057', NULL, 'Uncharacterized protein', 116, NULL, NULL, 136173),
(136174, '1.10.455.10-FF-000011', NULL, '30S ribosomal protein S7', 198, NULL, NULL, 136174),
(136175, '3.40.50.150-FF-001358', NULL, NULL, 187, NULL, NULL, 136175),
(136176, '3.30.70.100-FF-000113', NULL, NULL, 104, NULL, NULL, 136176),
(136177, '3.30.40.10-FF-000637', NULL, 'NOSIP domain-containing protein', 132, NULL, NULL, 136177),
(136178, '1.25.40.10-FF-001503', NULL, 'Pentatricopeptide repeat-containing protein At4g33170', 184, NULL, NULL, 136178),
(136179, '1.10.10.10-FF-001933', NULL, 'Uncharacterized protein', 89, NULL, NULL, 136179),
(136180, '3.20.20.70-FF-000137', NULL, 'Tagatose 1,6-diphosphate aldolase 2', 326, NULL, NULL, 136180),
(136181, '3.40.50.620-FF-000347', NULL, 'FMN adenylyltransferase', 245, NULL, NULL, 136181),
(136182, '3.30.930.10-FF-000339', NULL, 'Uncharacterized protein', 101, NULL, NULL, 136182),
(136183, '4.10.800.30-FF-000005', NULL, 'AGAP002302-PA', 95, NULL, NULL, 136183),
(136184, '3.80.10.10-FF-004085', NULL, 'Predicted protein', 125, NULL, NULL, 136184),
(136185, '1.10.533.10-FF-000120', NULL, 'B-cell lymphoma/leukemia 10-like', 110, NULL, NULL, 136185),
(136186, '3.30.420.10-FF-000037', NULL, 'epithelial splicing regulatory protein 2 isoform X1', 190, NULL, NULL, 136186),
(136187, '3.40.50.970-FF-000199', NULL, '2-hydroxyphytanoyl-CoA lyase, putative', 112, NULL, NULL, 136187),
(136188, '3.20.20.60-FF-000134', NULL, 'Pyruvate kinase', 40, NULL, NULL, 136188),
(136189, '3.40.50.1820-FF-000655', NULL, 'Carboxypeptidase', 437, NULL, NULL, 136189),
(136190, '3.40.190.80-FF-000082', NULL, 'Fructose-1,6-bisphosphatase/inositol-1-monophosphatase', 115, NULL, NULL, 136190),
(136191, '1.10.510.10-FF-003529', NULL, NULL, 242, NULL, NULL, 136191),
(136192, '1.10.560.10-FF-000031', NULL, '60 kDa heat shock protein, mitochondrial', 131, NULL, NULL, 136192),
(136193, '4.10.1250.10-FF-000004', NULL, 'Aminomethyltransferase', 26, NULL, NULL, 136193),
(136194, '2.60.120.200-FF-000722', NULL, 'Predicted protein', 242, NULL, NULL, 136194),
(136195, '1.25.10.10-FF-003244', NULL, 'Serine/threonine-protein kinase ATR-like Protein', 235, NULL, NULL, 136195),
(136196, '1.25.40.10-FF-003852', NULL, 'Predicted protein', 113, NULL, NULL, 136196),
(136197, '2.40.50.120-FF-000055', NULL, 'Uncharacterized protein', 110, NULL, NULL, 136197),
(136198, '3.30.9.10-FF-000109', NULL, 'Pyridine nucleotide-disulfide oxidoreductase/Thi4 family/FAD dependent oxidoreductase/NAD(P)-binding Rossmann-like domain containing protein, putative', 88, NULL, NULL, 136198),
(136199, '2.60.120.260-FF-000369', NULL, 'Predicted protein', 156, NULL, NULL, 136199),
(136200, '4.10.800.20-FF-000002', NULL, 'AMP deaminase', 93, NULL, NULL, 136200),
(136201, '1.20.1250.20-FF-000715', NULL, 'MFS transporter', 488, NULL, NULL, 136201),
(136202, '3.40.50.300-FF-003680', NULL, 'DEAD/DEAH box helicase', 193, NULL, NULL, 136202),
(136203, '3.30.10.30-FF-000006', NULL, 'Dual-specificity tyrosine phosphorylation-regulated kinase 3', 70, NULL, NULL, 136203),
(136204, '3.40.50.10090-FF-000038', NULL, 'Uroporphyrinogen-III synthase HemD', 146, NULL, NULL, 136204),
(136205, '3.40.920.10-FF-000011', NULL, '2-oxoacid ferredoxin oxidoreductase alpha subunit', 219, NULL, NULL, 136205),
(136206, '2.130.10.10-FF-003623', NULL, 'Predicted protein', 297, NULL, NULL, 136206);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(136207, '1.20.1070.10-FF-000945', NULL, 'Olr1366 protein', 91, NULL, NULL, 136207),
(136208, '1.10.565.10-FF-000126', NULL, 'Protein CBG26996', 216, NULL, NULL, 136208),
(136209, '2.60.40.10-FF-001279', NULL, 'OX-2 membrane glycoprotein', 113, NULL, NULL, 136209),
(136210, '4.10.400.10-FF-000031', NULL, 'Low-density lipoprotein receptor-related protein 1', 44, NULL, NULL, 136210),
(136211, '1.25.10.20-FF-000032', NULL, 'Hemolymph clottable protein', 331, NULL, NULL, 136211),
(136212, '1.10.101.10-FF-000033', NULL, 'Gamma-D-glutamyl-L-diamino acid endopeptidase 1', 70, NULL, NULL, 136212),
(136213, '2.102.10.10-FF-000011', NULL, 'Carnitine monooxygenase oxygenase subunit', 121, NULL, NULL, 136213),
(136214, '3.40.50.720-FF-002395', NULL, 'Uncharacterized protein', 86, NULL, NULL, 136214),
(136215, '2.30.30.490-FF-000074', NULL, 'DNA (cytosine-5)-methyltransferase', 172, NULL, NULL, 136215),
(136216, '3.60.130.10-FF-000019', NULL, 'TauD/TfdA family dioxygenase', 288, NULL, NULL, 136216),
(136217, '3.40.50.1820-FF-000436', NULL, 'Extracelular serine carboxypeptidase, putative', 212, NULL, NULL, 136217),
(136218, '3.90.215.10-FF-000007', NULL, 'Fibrinogen-like 2', 237, NULL, NULL, 136218),
(136219, '3.40.50.300-FF-007390', NULL, 'Uncharacterized protein', 102, NULL, NULL, 136219),
(136220, '3.30.160.60-FF-003185', NULL, 'Lame duck, isoform C', 23, NULL, NULL, 136220),
(136221, '3.40.850.10-FF-000359', NULL, 'Kinesin-like protein', 338, NULL, NULL, 136221),
(136222, '1.10.45.10-FF-000002', NULL, 'Alkylglycerone-phosphate synthase', 41, NULL, NULL, 136222),
(136223, '3.30.40.10-FF-000295', NULL, 'Zinc finger, FYVE domain-containing 26', 82, NULL, NULL, 136223),
(136224, '3.20.20.70-FF-000356', NULL, 'Ribonucleotide reductase of class III (Anaerobic), activating protein', 226, NULL, NULL, 136224),
(136225, '3.30.950.10-FF-000009', NULL, 'Tetrapyrrole methylase, putative', 119, NULL, NULL, 136225),
(136226, '3.20.20.80-FF-000359', NULL, 'Glucosidase, beta, acid 3 (Cytosolic) (Predicted)', 287, NULL, NULL, 136226),
(136227, '3.30.470.20-FF-000195', NULL, 'Uncharacterized protein', 36, NULL, NULL, 136227),
(136228, '2.60.120.380-FF-000045', NULL, 'Serine protease halolysin', 102, NULL, NULL, 136228),
(136229, '1.10.10.10-FF-001372', NULL, 'Ferric uptake regulation protein', 86, NULL, NULL, 136229),
(136230, '3.90.190.10-FF-000196', NULL, 'Dual specificity protein phosphatase putative', 166, NULL, NULL, 136230),
(136231, '3.30.760.10-FF-000074', NULL, 'Uncharacterized protein', 187, NULL, NULL, 136231),
(136232, '3.40.50.300-FF-007732', NULL, 'Uncharacterized protein', 86, NULL, NULL, 136232),
(136233, '1.10.20.70-FF-000007', NULL, NULL, 40, NULL, NULL, 136233),
(136234, '3.10.590.10-FF-000014', NULL, 'Thymocyte nuclear protein 1', 77, NULL, NULL, 136234),
(136235, '3.30.1330.30-FF-000142', NULL, 'Uncharacterized protein', 60, NULL, NULL, 136235),
(136236, '1.10.540.10-FF-000142', NULL, 'Bll6377 protein', 142, NULL, NULL, 136236),
(136237, '3.30.160.60-FF-003527', NULL, 'Uncharacterized protein, isoform A', 62, NULL, NULL, 136237),
(136238, '1.10.10.750-FF-000049', NULL, 'Uncharacterized protein', 60, NULL, NULL, 136238),
(136239, '3.30.70.330-FF-001345', NULL, 'Protein CBG14639', 131, NULL, NULL, 136239),
(136240, '2.40.50.140-FF-001230', NULL, NULL, 52, NULL, NULL, 136240),
(136241, '1.20.58.60-FF-000664', NULL, 'Uncharacterized protein', 135, NULL, NULL, 136241),
(136242, '1.10.510.10-FF-003861', NULL, NULL, 99, NULL, NULL, 136242),
(136243, '2.120.10.30-FF-000499', NULL, 'Hemomucin, putative', 222, NULL, NULL, 136243),
(136244, '3.30.10.20-FF-000003', NULL, 'Serine/threonine protein kinase PrkC', 63, NULL, NULL, 136244),
(136245, '1.20.1070.10-FF-001221', NULL, 'Uncharacterized protein', 125, NULL, NULL, 136245),
(136246, '3.30.70.1730-FF-000024', NULL, '60S acidic ribosomal protein P0', 114, NULL, NULL, 136246),
(136247, '2.40.128.20-FF-000042', NULL, 'Predicted protein', 160, NULL, NULL, 136247),
(136248, '3.30.420.40-FF-001092', NULL, 'Uncharacterized protein', 86, NULL, NULL, 136248),
(136249, '1.20.1270.60-FF-000026', NULL, 'FCH and double SH3 domains protein 2', 279, NULL, NULL, 136249);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(136250, '1.10.1200.10-FF-000150', NULL, 'Acyl carrier protein', 82, NULL, NULL, 136250),
(136251, '1.20.5.170-FF-000263', NULL, 'Uncharacterized protein', 87, NULL, NULL, 136251),
(136252, '3.40.50.720-FF-001568', NULL, 'Predicted protein', 243, NULL, NULL, 136252),
(136253, '3.30.70.1880-FF-000001', NULL, 'Membrane associated protein', 159, NULL, NULL, 136253),
(136254, '1.20.1070.10-FF-001440', NULL, 'Olfactory receptor E6', 223, NULL, NULL, 136254),
(136255, '2.60.120.650-FF-000008', NULL, 'Probable JmjC domain-containing histone demethylation protein 2C', 350, NULL, NULL, 136255),
(136256, '2.60.40.10-FF-000498', NULL, 'Down syndrome cell adhesion molecule, isoform J', 103, NULL, NULL, 136256),
(136257, '2.40.30.170-FF-000015', NULL, 'Efflux transporter periplasmic adaptor subunit', 96, NULL, NULL, 136257),
(136258, '1.20.5.110-FF-000352', NULL, 'Uncharacterized protein', 54, NULL, NULL, 136258),
(136259, '3.30.300.160-FF-000021', NULL, 'T2aSS secretion system assembly ATPase GspE', 87, NULL, NULL, 136259),
(136260, '3.40.50.300-FF-006849', NULL, 'Cytosolic Fe-S cluster assembly factor NUBP1 homolog', 261, NULL, NULL, 136260),
(136261, '3.40.50.261-FF-000021', NULL, 'Acetyl-CoA synthetase, putative', 156, NULL, NULL, 136261),
(136262, '3.30.450.150-FF-000011', NULL, 'Uncharacterized protein', 175, NULL, NULL, 136262),
(136263, '1.10.287.70-FF-000705', NULL, 'Uncharacterized protein', 188, NULL, NULL, 136263),
(136264, '3.30.160.60-FF-001083', NULL, 'Zinc finger protein 236', 26, NULL, NULL, 136264),
(136265, '4.10.280.10-FF-000144', NULL, 'Uncharacterized protein', 97, NULL, NULL, 136265),
(136266, '2.40.70.10-FF-000489', NULL, NULL, 137, NULL, NULL, 136266),
(136267, '3.30.200.20-FF-002255', NULL, 'Uncharacterized protein', 11, NULL, NULL, 136267),
(136268, '1.50.10.10-FF-000178', NULL, 'Uncharacterized protein', 383, NULL, NULL, 136268),
(136269, '3.10.490.10-FF-000017', NULL, 'Gamma-glutamylcyclotransferase', 187, NULL, NULL, 136269),
(136270, '2.120.10.30-FF-000190', NULL, 'Nhl repeat-containing protein, putative', 95, NULL, NULL, 136270),
(136271, '3.80.10.10-FF-002679', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 104, NULL, NULL, 136271),
(136272, '1.20.1250.20-FF-001654', NULL, 'Major facilitator superfamily MFS_1', 189, NULL, NULL, 136272),
(136273, '3.90.1290.10-FF-000085', NULL, 'Uncharacterized protein', 46, NULL, NULL, 136273),
(136274, '1.10.150.20-FF-000048', NULL, 'Fanconi anemia, complementation group M', 80, NULL, NULL, 136274),
(136275, '2.70.98.10-FF-000097', NULL, 'Uncharacterized protein', 218, NULL, NULL, 136275),
(136276, '1.20.120.850-FF-000011', NULL, 'DNA repair and recombination protein RAD54', 84, NULL, NULL, 136276),
(136277, '3.40.50.150-FF-001139', NULL, NULL, 270, NULL, NULL, 136277),
(136278, '2.60.40.10-FF-000059', NULL, 'Ephrin type-A receptor 6', 110, NULL, NULL, 136278),
(136279, '1.10.580.10-FF-000009', NULL, 'ATP-citrate synthase', 57, NULL, NULL, 136279),
(136280, '3.30.1520.10-FF-000038', NULL, 'sorting nexin-24', 107, NULL, NULL, 136280),
(136281, '2.60.40.60-FF-001069', NULL, 'Uncharacterized protein', 51, NULL, NULL, 136281),
(136282, '1.25.40.10-FF-001407', NULL, 'Pentatricopeptide (PPR) repeat protein', 190, NULL, NULL, 136282),
(136283, '1.20.120.230-FF-000033', NULL, 'CRE-DEB-1 protein', 117, NULL, NULL, 136283),
(136284, '3.80.10.10-FF-002207', NULL, 'MHC class II transactivator', 236, NULL, NULL, 136284),
(136285, '2.40.70.10-FF-000017', NULL, 'Uncharacterized protein', 235, NULL, NULL, 136285),
(136286, '3.30.70.330-FF-001547', NULL, NULL, 90, NULL, NULL, 136286),
(136287, '1.20.272.10-FF-000016', NULL, 'Replication factor C subunit 4', 90, NULL, NULL, 136287),
(136288, '2.130.10.10-FF-006023', NULL, 'Probable elongator complex protein 2', 165, NULL, NULL, 136288),
(136289, '3.40.47.10-FF-000101', NULL, 'Beta-ketoacyl synthase', 543, NULL, NULL, 136289),
(136290, '3.30.70.3000-FF-000006', NULL, 'Predicted protein', 246, NULL, NULL, 136290),
(136291, '3.30.70.330-FF-001986', NULL, NULL, 100, NULL, NULL, 136291);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(136292, '1.25.40.10-FF-000418', NULL, 'Tetratricopeptide repeat protein 30A', 207, NULL, NULL, 136292),
(136293, '1.25.40.180-FF-000144', NULL, NULL, 94, NULL, NULL, 136293),
(136294, '1.20.920.10-FF-000203', NULL, 'Uncharacterized protein', 126, NULL, NULL, 136294),
(136295, '3.30.160.60-FF-004842', NULL, NULL, 61, NULL, NULL, 136295),
(136296, '3.30.70.330-FF-002975', NULL, NULL, 208, NULL, NULL, 136296),
(136297, '3.100.10.10-FF-000035', NULL, NULL, 77, NULL, NULL, 136297),
(136298, '3.30.1600.10-FF-000039', NULL, 'Uncharacterized protein', 108, NULL, NULL, 136298),
(136299, '3.90.79.20-FF-000007', NULL, 'NADH pyrophosphatase', 141, NULL, NULL, 136299),
(136300, '3.40.50.300-FF-003623', NULL, 'Helicase, putative', 280, NULL, NULL, 136300),
(136301, '3.30.300.130-FF-000006', NULL, 'NifU-like protein 3, chloroplastic', 71, NULL, NULL, 136301),
(136302, '1.10.3500.10-FF-000004', NULL, 'Transcription elongation factor spt6', 291, NULL, NULL, 136302),
(136303, '1.50.40.10-FF-000326', NULL, 'Mitochondrial folate transporter/carrier', 293, NULL, NULL, 136303),
(136304, '3.40.140.10-FF-000165', NULL, 'Uncharacterized protein', 167, NULL, NULL, 136304),
(136305, '1.10.10.10-FF-000270', NULL, 'Non-structural maintenance of chromosomes element 1 homolog', 96, NULL, NULL, 136305),
(136306, '2.60.40.10-FF-001015', NULL, 'tyrosine-protein phosphatase Lar isoform X4', 96, NULL, NULL, 136306),
(136307, '3.40.50.720-FF-000579', NULL, 'NADP oxidoreductase', 197, NULL, NULL, 136307),
(136308, '2.130.10.10-FF-003909', NULL, 'Putative suppressive immunomodulating factor', 384, NULL, NULL, 136308),
(136309, '1.20.120.1960-FF-000002', NULL, 'Sulfhydryl oxidase', 138, NULL, NULL, 136309),
(136310, '3.30.160.60-FF-000508', NULL, 'Myeloid zinc finger 1', 30, NULL, NULL, 136310),
(136311, '2.30.29.30-FF-000506', NULL, 'OPY1p protein', 121, NULL, NULL, 136311),
(136312, '3.40.50.300-FF-004612', NULL, 'V-type proton ATPase catalytic subunit A', 84, NULL, NULL, 136312),
(136313, '3.30.160.60-FF-006287', NULL, NULL, 85, NULL, NULL, 136313),
(136314, '1.20.58.2220-FF-000022', NULL, 'Uncharacterized protein', 382, NULL, NULL, 136314),
(136315, '1.10.100.10-FF-000008', NULL, 'probable insulin-like peptide 7', 80, NULL, NULL, 136315),
(136316, '2.60.40.10-FF-001487', NULL, 'Signaling lymphocytic activation molecule', 86, NULL, NULL, 136316),
(136317, '1.10.238.10-FF-001210', NULL, 'Putative centrin', 162, NULL, NULL, 136317),
(136318, '3.40.30.10-FF-000737', NULL, 'Uncharacterized protein', 125, NULL, NULL, 136318),
(136319, '3.40.50.720-FF-000107', NULL, 'inositol-3-phosphate synthase', 129, NULL, NULL, 136319),
(136320, '3.30.160.60-FF-003853', NULL, NULL, 26, NULL, NULL, 136320),
(136321, '3.20.70.20-FF-000030', NULL, 'Formate acetyltransferase 2', 655, NULL, NULL, 136321),
(136322, '1.10.560.10-FF-000065', NULL, 'Predicted protein', 134, NULL, NULL, 136322),
(136323, '2.30.29.240-FF-000002', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 216, NULL, NULL, 136323),
(136324, '3.40.50.1010-FF-000047', NULL, 'Blast:Telomerase-binding protein EST1A', 179, NULL, NULL, 136324),
(136325, '3.30.200.20-FF-001299', NULL, 'Myosin heavy chain kinase A', 162, NULL, NULL, 136325),
(136326, '1.10.510.10-FF-003108', NULL, NULL, 194, NULL, NULL, 136326),
(136327, '2.60.40.4100-FF-000015', NULL, 'Uncharacterized protein', 159, NULL, NULL, 136327),
(136328, '3.30.200.20-FF-000810', NULL, 'L-type lectin-domain containing receptor kinase S.6', 112, NULL, NULL, 136328),
(136329, '4.10.400.10-FF-000233', NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein-like Protein', 37, NULL, NULL, 136329),
(136330, '3.30.70.3030-FF-000021', NULL, 'Nucleolar protein 6', 120, NULL, NULL, 136330),
(136331, '4.10.1240.30-FF-000009', NULL, NULL, 86, NULL, NULL, 136331),
(136332, '1.25.40.10-FF-001879', NULL, 'Tetratricopeptide repeat protein 36 homolog', 164, NULL, NULL, 136332),
(136333, '1.10.472.80-FF-000049', NULL, 'Uncharacterized protein, isoform B', 161, NULL, NULL, 136333),
(136334, '3.40.50.300-FF-004079', NULL, 'DNA mismatch repair protein', 119, NULL, NULL, 136334);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(136335, '3.30.160.60-FF-002072', NULL, 'Zinc finger protein 134', 27, NULL, NULL, 136335),
(136336, '3.40.50.620-FF-000375', NULL, 'Putative tyrosyl-tRNA synthetase', 263, NULL, NULL, 136336),
(136337, '1.50.10.20-FF-000035', NULL, 'Protein farnesyltransferase subunit beta', 436, NULL, NULL, 136337),
(136338, '3.90.1170.10-FF-000019', NULL, 'Uncharacterized protein', 70, NULL, NULL, 136338),
(136339, '1.10.1740.10-FF-000050', NULL, 'Uncharacterized protein', 82, NULL, NULL, 136339),
(136340, '1.10.510.10-FF-002271', NULL, NULL, 200, NULL, NULL, 136340),
(136341, '1.10.8.60-FF-000132', NULL, 'AAA family ATPase', 92, NULL, NULL, 136341),
(136342, '3.10.350.10-FF-000007', NULL, 'Probable L,D-transpeptidase YcfS', 60, NULL, NULL, 136342),
(136343, '2.60.120.10-FF-000511', NULL, 'Uncharacterized protein', 134, NULL, NULL, 136343),
(136344, '3.10.20.410-FF-000009', NULL, 'Probable fimbrial usher protein', 121, NULL, NULL, 136344),
(136345, '1.25.40.20-FF-000308', NULL, 'Oxysterol-binding family protein', 137, NULL, NULL, 136345),
(136346, '3.40.50.10190-FF-000181', NULL, 'LIGase', 97, NULL, NULL, 136346),
(136347, '1.10.510.10-FF-000354', NULL, 'Serine/threonine-protein kinase Chk2', 207, NULL, NULL, 136347),
(136348, '1.20.1230.10-FF-000014', NULL, 'Uncharacterized protein', 215, NULL, NULL, 136348),
(136349, '3.90.190.10-FF-000443', NULL, 'Protein CBG22503', 273, NULL, NULL, 136349),
(136350, '2.60.34.10-FF-000085', NULL, 'Uncharacterized protein', 180, NULL, NULL, 136350),
(136351, '2.20.100.10-FF-000036', NULL, 'Connective tissue growth factor (Predicted)', 69, NULL, NULL, 136351),
(136352, '1.10.240.10-FF-000018', NULL, 'Tryptophan--tRNA ligase', 110, NULL, NULL, 136352),
(136353, '1.25.10.10-FF-001698', NULL, 'Sister chromatid cohesion protein', 265, NULL, NULL, 136353),
(136354, '1.10.274.30-FF-000029', NULL, 'Uncharacterized protein', 131, NULL, NULL, 136354),
(136355, '3.30.1360.10-FF-000003', NULL, 'DNA-directed RNA polymerase II subunit RPB11', 117, NULL, NULL, 136355),
(136356, '2.60.40.10-FF-002004', NULL, 'Transmembrane and immunoglobulin domain containing 3', 105, NULL, NULL, 136356),
(136357, '2.40.50.120-FF-000061', NULL, 'Uncharacterized protein', 98, NULL, NULL, 136357),
(136358, '3.30.40.10-FF-001632', NULL, 'Structure-specific endonuclease subunit SLX1', 81, NULL, NULL, 136358),
(136359, '3.40.50.300-FF-001206', NULL, 'DNA repair helicase rad15', 136, NULL, NULL, 136359),
(136360, '3.40.50.1820-FF-001745', NULL, 'Predicted protein', 58, NULL, NULL, 136360),
(136361, '3.30.450.40-FF-000216', NULL, 'Pca regulon regulatory protein', 73, NULL, NULL, 136361),
(136362, '3.30.710.10-FF-000391', NULL, 'Uncharacterized protein', 172, NULL, NULL, 136362),
(136363, '1.20.120.1750-FF-000057', NULL, 'RBR-type E3 ubiquitin transferase', 75, NULL, NULL, 136363),
(136364, '2.60.40.150-FF-000175', NULL, 'C2 calcium dependent domain containing 3', 132, NULL, NULL, 136364),
(136365, '3.40.630.30-FF-000079', NULL, 'glycine N-acyltransferase-like protein 3', 115, NULL, NULL, 136365),
(136366, '1.25.40.10-FF-002835', NULL, 'Anaphase-promoting complex subunit 3 protein', 137, NULL, NULL, 136366),
(136367, '3.40.50.150-FF-000363', NULL, 'Methyltransferase domain containing protein', 221, NULL, NULL, 136367),
(136368, '3.30.70.1730-FF-000035', NULL, '50S ribosomal protein L10', 130, NULL, NULL, 136368),
(136369, '3.30.1490.20-FF-000077', NULL, 'Synapsin2', 14, NULL, NULL, 136369),
(136370, '3.30.70.1320-FF-000002', NULL, 'Multidrug resistance protein MdtB', 98, NULL, NULL, 136370),
(136371, '2.10.25.10-FF-000425', NULL, 'Eyes shut homolog', 37, NULL, NULL, 136371),
(136372, '3.30.1330.30-FF-000041', NULL, '60S ribosomal protein L7-3, putative', 183, NULL, NULL, 136372),
(136373, '3.80.10.10-FF-000442', NULL, 'tropomodulin-2 isoform X3', 109, NULL, NULL, 136373),
(136374, '1.10.150.240-FF-000033', NULL, 'Haloacid dehalogenase/epoxide hydrolase family protein', 68, NULL, NULL, 136374),
(136375, '1.20.58.340-FF-000044', NULL, 'Magnesium and cobalt transport protein CorA, putative', 102, NULL, NULL, 136375);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(136376, '2.40.110.10-FF-000083', NULL, 'Blr0120 protein', 69, NULL, NULL, 136376),
(136377, '3.40.50.1860-FF-000009', NULL, 'Glutamate racemase', 111, NULL, NULL, 136377),
(136378, '1.10.840.10-FF-000047', NULL, 'Phosphoinositide phospholipase C', 166, NULL, NULL, 136378),
(136379, '3.90.1750.20-FF-000022', NULL, NULL, 92, NULL, NULL, 136379),
(136380, '2.130.10.10-FF-003117', NULL, 'Uncharacterized protein', 269, NULL, NULL, 136380),
(136381, '2.40.50.140-FF-000600', NULL, 'Os05g0110950 protein', 106, NULL, NULL, 136381),
(136382, '2.30.29.30-FF-000153', NULL, 'amyloid beta A4 precursor protein-binding family B member 3 isoform X1', 142, NULL, NULL, 136382),
(136383, '3.40.640.10-FF-000158', NULL, 'Glycine dehydrogenase (decarboxylating)', 123, NULL, NULL, 136383),
(136384, '3.40.50.300-FF-006057', NULL, 'Uncharacterized protein', 131, NULL, NULL, 136384),
(136385, '1.20.1480.20-FF-000002', NULL, 'Microtubule-associated serine/threonine-protein kinase 3', 92, NULL, NULL, 136385),
(136386, '3.30.160.60-FF-002864', NULL, NULL, 28, NULL, NULL, 136386),
(136387, '3.30.750.44-FF-000002', NULL, 'carboxyl-terminal-processing peptidase 2, chloroplastic', 88, NULL, NULL, 136387),
(136388, '1.10.533.10-FF-000070', NULL, 'Caspase 10', 120, NULL, NULL, 136388),
(136389, '2.60.40.420-FF-000099', NULL, 'Cytochrome c oxidase subunit 2', 132, NULL, NULL, 136389),
(136390, '1.10.630.10-FF-000301', NULL, 'Uncharacterized protein', 223, NULL, NULL, 136390),
(136391, '2.130.10.10-FF-003589', NULL, 'Uncharacterized protein', 279, NULL, NULL, 136391),
(136392, '1.10.1420.10-FF-000003', NULL, 'DNA mismatch repair protein', 216, NULL, NULL, 136392),
(136393, '2.60.40.10-FF-004393', NULL, NULL, 93, NULL, NULL, 136393),
(136394, '3.30.200.20-FF-000490', NULL, 'AGC family protein kinase', 97, NULL, NULL, 136394),
(136395, '3.10.20.70-FF-000042', NULL, 'ATP:guanido phosphotransferase, Nterminal domain-containing protein', 44, NULL, NULL, 136395),
(136396, '1.20.1250.20-FF-000226', NULL, 'Vesicular GLUtamate transporter', 206, NULL, NULL, 136396),
(136397, '4.10.280.20-FF-000001', NULL, 'stannin', 87, NULL, NULL, 136397),
(136398, '2.130.10.10-FF-002280', NULL, 'Thoc6, isoform B', 233, NULL, NULL, 136398),
(136399, '3.40.50.10140-FF-000008', NULL, 'Toll-like receptor 3', 148, NULL, NULL, 136399),
(136400, '3.40.50.1100-FF-000102', NULL, 'Si:ch73-263o4.4', 97, NULL, NULL, 136400),
(136401, '1.20.1560.10-FF-000146', NULL, 'p-GlycoProtein related', 22, NULL, NULL, 136401),
(136402, '1.25.40.10-FF-003324', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 102, NULL, NULL, 136402),
(136403, '1.20.1270.420-FF-000012', NULL, 'Inhibitor of nuclear factor kappa B kinase subunit epsilon', 145, NULL, NULL, 136403),
(136404, '3.30.780.10-FF-000013', NULL, 'Translation machinery-associated protein 22', 91, NULL, NULL, 136404),
(136405, '3.30.559.10-FF-000257', NULL, 'Uncharacterized protein', 212, NULL, NULL, 136405),
(136406, '2.130.10.10-FF-001291', NULL, 'Periodic tryptophan protein 2-like protein', 193, NULL, NULL, 136406),
(136407, '3.40.50.1000-FF-000370', NULL, 'Haloacid dehalogenase-like hydrolase/HAD-hyrolase-like, putative', 130, NULL, NULL, 136407),
(136408, '3.40.50.300-FF-000717', NULL, 'Genome polyprotein', 158, NULL, NULL, 136408),
(136409, '3.30.450.20-FF-000210', NULL, 'Sensory box/GGDEF family protein', 139, NULL, NULL, 136409),
(136410, '3.30.70.330-FF-000558', NULL, 'Serine/arginine-rich SC35-like splicing factor SCL30', 116, NULL, NULL, 136410),
(136411, '3.10.100.10-FF-000287', NULL, NULL, 153, NULL, NULL, 136411),
(136412, '3.80.10.10-FF-001370', NULL, 'Kinase family with leucine-rich repeat domain-containing protein', 174, NULL, NULL, 136412),
(136413, '3.40.630.10-FF-000073', NULL, 'Zinc metallopeptidase', 231, NULL, NULL, 136413),
(136414, '3.10.20.90-FF-000048', NULL, 'Ras association domain family member 1', 162, NULL, NULL, 136414),
(136415, '2.40.10.10-FF-000160', NULL, 'Protease Do-like 7', 112, NULL, NULL, 136415),
(136416, '2.30.40.10-FF-000010', NULL, 'Imidazolonepropionase', 83, NULL, NULL, 136416);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(136417, '1.20.1740.10-FF-000244', NULL, 'Uncharacterized protein', 337, NULL, NULL, 136417),
(136418, '3.60.21.10-FF-000480', NULL, 'Serine/threonine-protein phosphatase', 230, NULL, NULL, 136418),
(136419, '2.30.42.10-FF-000172', NULL, 'Caspase recruitment domain family member 14', 84, NULL, NULL, 136419),
(136420, '3.90.190.10-FF-000090', NULL, 'Dual specificity phosphatase catalytic domain protein', 201, NULL, NULL, 136420),
(136421, '1.10.10.60-FF-001280', NULL, NULL, 64, NULL, NULL, 136421),
(136422, '3.30.420.10-FF-000172', NULL, 'DNA polymerase I-like protein B', 200, NULL, NULL, 136422),
(136423, '1.10.420.10-FF-000055', NULL, 'Uncharacterized protein', 80, NULL, NULL, 136423),
(136424, '2.60.120.290-FF-000029', NULL, 'seizure 6-like protein 2 isoform X1', 114, NULL, NULL, 136424),
(136425, '3.30.300.10-FF-000045', NULL, 'GMP synthase [glutamine-hydrolyzing] subunit B', 75, NULL, NULL, 136425),
(136426, '3.30.70.1620-FF-000002', NULL, 'Structural maintenance of chromosomes 3', 65, NULL, NULL, 136426),
(136427, '1.10.472.10-FF-000309', NULL, 'Transcription factor IIIB 90 kDa subunit', 104, NULL, NULL, 136427),
(136428, '3.30.1360.120-FF-000031', NULL, 'Protein CBG22093', 168, NULL, NULL, 136428),
(136429, '3.40.225.10-FF-000042', NULL, NULL, 189, NULL, NULL, 136429),
(136430, '2.60.40.60-FF-000613', NULL, 'Cadherin 26, tandem duplicate 1', 106, NULL, NULL, 136430),
(136431, '3.10.450.580-FF-000015', NULL, 'Mediator of RNA polymerase II transcription subunit 6', 136, NULL, NULL, 136431),
(136432, '3.10.290.10-FF-000036', NULL, 'Pseudouridine synthase', 54, NULL, NULL, 136432),
(136433, '1.10.1060.10-FF-000020', NULL, 'Pyridine nucleotide-disulfide oxidoreductase', 146, NULL, NULL, 136433),
(136434, '3.70.10.10-FF-000083', NULL, 'Predicted protein', 236, NULL, NULL, 136434),
(136435, '2.60.40.1170-FF-000102', NULL, NULL, 102, NULL, NULL, 136435),
(136436, '1.20.1280.290-FF-000048', NULL, 'Seven transmembrane protein 1', 103, NULL, NULL, 136436),
(136437, '1.25.10.10-FF-003143', NULL, 'Protein aardvark', 96, NULL, NULL, 136437),
(136438, '1.10.510.10-FF-003260', NULL, NULL, 111, NULL, NULL, 136438),
(136439, '3.60.40.10-FF-000372', NULL, 'Uncharacterized protein', 252, NULL, NULL, 136439),
(136440, '3.40.50.360-FF-000128', NULL, 'NAD(P)H:quinone oxidoreductase, type IV', 198, NULL, NULL, 136440),
(136441, '3.30.70.330-FF-002503', NULL, NULL, 72, NULL, NULL, 136441),
(136442, '2.160.20.10-FF-000177', NULL, 'Uncharacterized protein', 167, NULL, NULL, 136442),
(136443, '3.30.70.330-FF-002183', NULL, NULL, 74, NULL, NULL, 136443),
(136444, '3.40.50.300-FF-007838', NULL, 'Os11g0649100 protein', 234, NULL, NULL, 136444),
(136445, '3.40.50.1240-FF-000150', NULL, NULL, 201, NULL, NULL, 136445),
(136446, '3.50.50.60-FF-000360', NULL, 'FAD-dependent oxidoreductase family protein', 98, NULL, NULL, 136446),
(136447, '2.130.10.10-FF-002128', NULL, 'Transducin family protein / WD-40 repeat family protein', 129, NULL, NULL, 136447),
(136448, '3.40.50.1820-FF-000756', NULL, 'Uncharacterized protein', 322, NULL, NULL, 136448),
(136449, '3.40.50.10790-FF-000001', NULL, 'Adenosyl-chloride synthase', 163, NULL, NULL, 136449),
(136450, '3.40.710.10-FF-000074', NULL, 'Probable esterase/lipase lipP', 386, NULL, NULL, 136450),
(136451, '3.40.50.200-FF-000013', NULL, 'Tripeptidyl-peptidase 2 homolog', 334, NULL, NULL, 136451),
(136452, '3.40.50.2000-FF-000361', NULL, 'Glycosyl transferase, group 1 family', 180, NULL, NULL, 136452),
(136453, '3.40.190.290-FF-000036', NULL, 'LysR family transcriptional regulator', 207, NULL, NULL, 136453),
(136454, '2.30.29.30-FF-000978', NULL, 'Dynamin-2A', 87, NULL, NULL, 136454),
(136455, '1.20.1730.10-FF-000007', NULL, 'Sodium-coupled monocarboxylate transporter 2', 481, NULL, NULL, 136455),
(136456, '3.60.10.10-FF-000252', NULL, 'Putative transmembrane endonuclease/exonuclease', 260, NULL, NULL, 136456),
(136457, '3.40.605.10-FF-000060', NULL, 'Geranial dehydrogenase GeoB', 262, NULL, NULL, 136457),
(136458, '1.25.10.10-FF-001198', NULL, 'ARM repeat superfamily protein', 145, NULL, NULL, 136458);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(136459, '3.80.10.10-FF-001431', NULL, 'Toll-like receptor 22', 177, NULL, NULL, 136459),
(136460, '3.40.50.300-FF-005068', NULL, 'RAB38, member RAS oncogene family', 119, NULL, NULL, 136460),
(136461, '3.40.50.1820-FF-001245', NULL, 'Uncharacterized protein', 321, NULL, NULL, 136461),
(136462, '1.20.58.60-FF-000006', NULL, 'Spectrin alpha chain, non-erythrocytic 1', 102, NULL, NULL, 136462),
(136463, '1.25.40.20-FF-001236', NULL, 'Uncharacterized protein', 382, NULL, NULL, 136463),
(136464, '3.40.50.1240-FF-000211', NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', 539, NULL, NULL, 136464),
(136465, '2.40.10.120-FF-000013', NULL, 'Pro-apoptotic serine protease NMA111', 219, NULL, NULL, 136465),
(136466, '1.20.1090.10-FF-000042', NULL, '3-dehydroquinate synthase', 190, NULL, NULL, 136466),
(136467, '1.20.1270.60-FF-000161', NULL, 'Hypothetical_protein_-_conserved', 206, NULL, NULL, 136467),
(136468, '1.25.40.20-FF-000747', NULL, 'Notch receptor protein', 142, NULL, NULL, 136468),
(136469, '3.40.50.80-FF-000068', NULL, 'Iron ABC transporter ATP-binding protein/permease IrtA', 138, NULL, NULL, 136469),
(136470, '2.40.37.10-FF-000081', NULL, NULL, 97, NULL, NULL, 136470),
(136471, '3.40.50.10490-FF-000001', NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', 216, NULL, NULL, 136471),
(136472, '3.80.10.10-FF-003668', NULL, 'Uncharacterized protein', 226, NULL, NULL, 136472),
(136473, '1.10.472.10-FF-000461', NULL, 'Origin recognition complex subunit 6', 98, NULL, NULL, 136473),
(136474, '3.40.630.30-FF-000551', NULL, 'Uncharacterized protein', 132, NULL, NULL, 136474),
(136475, '3.10.20.90-FF-000520', NULL, 'Polycomb complex protein BMI-1-like protein', 109, NULL, NULL, 136475),
(136476, '2.10.25.10-FF-000925', NULL, 'Delta like non-canonical Notch ligand 1', 41, NULL, NULL, 136476),
(136477, '2.170.190.11-FF-000024', NULL, 'Molybdopterin molybdenumtransferase', 106, NULL, NULL, 136477),
(136478, '2.10.25.10-FF-001414', NULL, 'Uncharacterized protein', 46, NULL, NULL, 136478),
(136479, '1.20.1560.10-FF-000207', NULL, 'ABC transporter B family member 15-like', 344, NULL, NULL, 136479),
(136480, '1.10.10.10-FF-002035', NULL, 'Uncharacterized protein', 76, NULL, NULL, 136480),
(136481, '6.10.140.2150-FF-000004', NULL, 'Sphinganine-1-phosphate aldolase, putative', 47, NULL, NULL, 136481),
(136482, '3.40.50.300-FF-007013', NULL, 'Predicted protein', 208, NULL, NULL, 136482),
(136483, '3.50.80.10-FF-000015', NULL, 'Uncharacterized protein', 161, NULL, NULL, 136483),
(136484, '2.60.40.10-FF-004713', NULL, NULL, 86, NULL, NULL, 136484),
(136485, '2.130.10.10-FF-005534', NULL, 'Uncharacterized protein', 274, NULL, NULL, 136485),
(136486, '2.40.10.10-FF-000660', NULL, NULL, 80, NULL, NULL, 136486),
(136487, '1.10.510.10-FF-002771', NULL, NULL, 226, NULL, NULL, 136487),
(136488, '2.60.40.10-FF-004893', NULL, NULL, 116, NULL, NULL, 136488),
(136489, '3.30.160.60-FF-000155', NULL, 'zinc finger protein 133 isoform X1', 28, NULL, NULL, 136489),
(136490, '3.40.50.720-FF-002024', NULL, 'Predicted protein', 204, NULL, NULL, 136490),
(136491, '3.30.2350.10-FF-000031', NULL, 'Pseudouridine synthase', 217, NULL, NULL, 136491),
(136492, '1.20.210.10-FF-000025', NULL, 'Cytochrome c oxidase subunit CcoN', 507, NULL, NULL, 136492),
(136493, '3.10.100.10-FF-000315', NULL, NULL, 155, NULL, NULL, 136493),
(136494, '1.25.40.20-FF-000247', NULL, 'E3 ubiquitin-protein ligase mind-bomb', 172, NULL, NULL, 136494),
(136495, '1.25.10.10-FF-000450', NULL, 'ARM repeat superfamily protein', 958, NULL, NULL, 136495),
(136496, '3.40.50.300-FF-007485', NULL, 'Probable ATP-dependent helicase MJ0942', 231, NULL, NULL, 136496),
(136497, '3.40.350.10-FF-000091', NULL, 'Uncharacterized protein', 88, NULL, NULL, 136497),
(136498, '1.25.40.10-FF-005269', NULL, 'UTX (Ubiquitously transcribed TPR on X) homolog', 152, NULL, NULL, 136498),
(136499, '3.30.200.20-FF-000338', NULL, 'Serine/threonine protein kinase', 86, NULL, NULL, 136499),
(136500, '1.10.220.60-FF-000009', NULL, 'AGAP003540-PA', 54, NULL, NULL, 136500);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(136501, '1.10.10.430-FF-000004', NULL, 'Alphabet, isoform A', 73, NULL, NULL, 136501),
(136502, '3.30.310.80-FF-000050', NULL, 'Non-specific serine/threonine protein kinase', 109, NULL, NULL, 136502),
(136503, '2.130.10.10-FF-002780', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit TRM82', 218, NULL, NULL, 136503),
(136504, '3.80.10.10-FF-003168', NULL, 'Uncharacterized protein', 272, NULL, NULL, 136504),
(136505, '2.120.10.80-FF-000272', NULL, 'Kelch like family member 17', 75, NULL, NULL, 136505),
(136506, '2.40.50.140-FF-000100', NULL, 'Cell wall biogenesis protein phosphatase', 74, NULL, NULL, 136506),
(136507, '3.40.50.1980-FF-000079', NULL, 'Iron(III) dicitrate-binding protein', 186, NULL, NULL, 136507),
(136508, '3.40.50.300-FF-001706', NULL, 'tRNA dimethylallyltransferase isoform X2', 38, NULL, NULL, 136508),
(136509, '3.50.50.60-FF-001169', NULL, 'Uncharacterized protein', 184, NULL, NULL, 136509),
(136510, '3.40.850.10-FF-000084', NULL, 'Kinesin-like protein', 357, NULL, NULL, 136510),
(136511, '3.30.200.20-FF-001619', NULL, 'Mitogen-activated protein kinase kinase kinase 14', 98, NULL, NULL, 136511),
(136512, '3.30.1490.20-FF-000105', NULL, 'Uncharacterized protein', 26, NULL, NULL, 136512),
(136513, '1.10.418.10-FF-000139', NULL, 'Leucine-rich Repeats (LRR) and Calponin Homology (CH) domain homolog', 121, NULL, NULL, 136513),
(136514, '3.50.50.60-FF-000421', NULL, 'Flavin-containing monooxygenase', 305, NULL, NULL, 136514),
(136515, '3.30.40.10-FF-002149', NULL, 'Uncharacterized protein', 52, NULL, NULL, 136515),
(136516, '3.10.50.40-FF-000147', NULL, 'Trigger factor', 91, NULL, NULL, 136516),
(136517, '3.30.160.60-FF-005770', NULL, NULL, 24, NULL, NULL, 136517),
(136518, '1.10.10.10-FF-000770', NULL, 'LysR family transcriptional regulator', 92, NULL, NULL, 136518),
(136519, '3.40.50.720-FF-002496', NULL, 'Potassium channel protein', 155, NULL, NULL, 136519),
(136520, '2.130.10.10-FF-001611', NULL, 'WD repeat protein (AFU_orthologue AFUA_3G06910)', 139, NULL, NULL, 136520),
(136521, '3.30.70.860-FF-000009', NULL, 'Uncharacterized protein', 91, NULL, NULL, 136521),
(136522, '3.40.1030.10-FF-000004', NULL, 'Glycosyl transferase family protein', 248, NULL, NULL, 136522),
(136523, '3.30.70.3290-FF-000020', NULL, 'Probable polyketide synthase 2', 150, NULL, NULL, 136523),
(136524, '3.30.160.60-FF-002925', NULL, 'Zinc finger protein YGR067C', 32, NULL, NULL, 136524),
(136525, '2.60.120.10-FF-000039', NULL, 'cAMP-dependent protein kinase regulatory subunit', 143, NULL, NULL, 136525),
(136526, '2.130.10.10-FF-002600', NULL, 'Semaphorin-5A', 455, NULL, NULL, 136526),
(136527, '1.20.58.90-FF-000021', NULL, 'Centrosomal protein 57, like 1', 77, NULL, NULL, 136527),
(136528, '3.10.250.10-FF-000062', NULL, 'RIKEN cDNA 5830411N06 gene', 107, NULL, NULL, 136528),
(136529, '1.25.10.10-FF-000742', NULL, 'Uncharacterized protein, isoform A', 232, NULL, NULL, 136529),
(136530, '1.10.3720.10-FF-000015', NULL, 'Sulfate ABC transporter, permease CysW', 258, NULL, NULL, 136530),
(136531, '3.30.1370.10-FF-000240', NULL, 'Heterogeneous nuclear RibonucleoProtein (HnRNP) K homolog', 45, NULL, NULL, 136531),
(136532, '3.40.1110.10-FF-000005', NULL, 'Plasma membrane ATPase', 146, NULL, NULL, 136532),
(136533, '3.30.560.10-FF-000002', NULL, 'Versicolorin B synthase', 320, NULL, NULL, 136533),
(136534, '2.80.10.70-FF-000007', NULL, 'Predicted gene 28079', 129, NULL, NULL, 136534),
(136535, '2.60.120.200-FF-000222', NULL, 'Laminin-like protein epi-1', 176, NULL, NULL, 136535),
(136536, '1.20.58.60-FF-000506', NULL, 'Uncharacterized protein', 107, NULL, NULL, 136536),
(136537, '1.25.40.10-FF-003824', NULL, 'Uncharacterized protein', 130, NULL, NULL, 136537),
(136538, '2.60.40.1120-FF-000048', NULL, 'Transporter, outer membrane receptor (OMR) family', 81, NULL, NULL, 136538),
(136539, '3.90.226.10-FF-000100', NULL, 'Peptidase S49', 160, NULL, NULL, 136539),
(136540, '3.30.428.10-FF-000021', NULL, 'CWF19-like protein 2 homolog', 164, NULL, NULL, 136540),
(136541, '1.25.10.10-FF-002507', NULL, 'Uncharacterized protein', 200, NULL, NULL, 136541);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(136542, '1.20.1250.20-FF-001715', NULL, 'Uncharacterized protein', 194, NULL, NULL, 136542),
(136543, '3.80.10.10-FF-001870', NULL, 'Tubulin folding cofactor E', 99, NULL, NULL, 136543),
(136544, '3.40.50.150-FF-001611', NULL, NULL, 254, NULL, NULL, 136544),
(136545, '2.120.10.10-FF-000032', NULL, 'Uncharacterized protein', 146, NULL, NULL, 136545),
(136546, '1.10.287.1490-FF-000003', NULL, 'Epidermal growth factor receptor pathway substrate 15', 210, NULL, NULL, 136546),
(136547, '2.60.40.10-FF-005410', NULL, NULL, 111, NULL, NULL, 136547),
(136548, '2.60.40.1120-FF-000020', NULL, 'Silver, isoform N', 94, NULL, NULL, 136548),
(136549, '3.40.50.300-FF-000689', NULL, 'ATP binding cassette subfamily A member 12', 261, NULL, NULL, 136549),
(136550, '2.40.110.20-FF-000001', NULL, 'Acyl-CoA dehydrogenase AidB', 164, NULL, NULL, 136550),
(136551, '2.30.30.760-FF-000003', NULL, 'Flagella basal body P-ring formation protein FlgA', 59, NULL, NULL, 136551),
(136552, '3.90.226.10-FF-000128', NULL, 'Putative enoyl-CoA hydratase', 202, NULL, NULL, 136552),
(136553, '3.20.20.80-FF-000230', NULL, 'Galactosidase beta 1', 89, NULL, NULL, 136553),
(136554, '2.80.10.50-FF-000001', NULL, 'Fibroblast growth factor', 160, NULL, NULL, 136554),
(136555, '1.10.510.10-FF-003760', NULL, NULL, 141, NULL, NULL, 136555),
(136556, '3.40.50.1820-FF-001392', NULL, 'Uncharacterized protein', 217, NULL, NULL, 136556),
(136557, '3.80.20.20-FF-000064', NULL, 'Cell surface GPI-anchored protein ECM33', 170, NULL, NULL, 136557),
(136558, '1.10.3450.20-FF-000008', NULL, 'Nuclear pore complex protein', 159, NULL, NULL, 136558),
(136559, '1.10.510.10-FF-002332', NULL, NULL, 205, NULL, NULL, 136559),
(136560, '2.60.120.200-FF-000694', NULL, 'Uncharacterized protein', 197, NULL, NULL, 136560),
(136561, '2.60.120.590-FF-000029', NULL, 'Methyltransferase, putative', 200, NULL, NULL, 136561),
(136562, '1.10.260.40-FF-000096', NULL, 'Uncharacterized protein', 49, NULL, NULL, 136562),
(136563, '2.40.50.140-FF-000280', NULL, 'rRNA biogenesis protein RRP5', 99, NULL, NULL, 136563),
(136564, '2.120.10.30-FF-000038', NULL, 'Tyrosine-protein kinase receptor', 225, NULL, NULL, 136564),
(136565, '2.40.160.20-FF-000004', NULL, 'Outer membrane protein H1', 178, NULL, NULL, 136565),
(136566, '1.10.760.10-FF-000046', NULL, 'Cytochrome c peroxidase', 177, NULL, NULL, 136566),
(136567, '2.60.40.10-FF-000970', NULL, 'Plexin B3', 151, NULL, NULL, 136567),
(136568, '3.40.50.460-FF-000012', NULL, 'Diphosphate-fructose-6-phosphate 1-phosphotransferase', 122, NULL, NULL, 136568),
(136569, '1.10.10.390-FF-000003', NULL, 'Histone acetyltransferase type B catalytic subunit', 54, NULL, NULL, 136569),
(136570, '1.25.40.90-FF-000015', NULL, 'Pre-mRNA cleavage complex 2 protein Pcf11', 131, NULL, NULL, 136570),
(136571, '3.40.50.300-FF-003270', NULL, 'GTP-binding protein, putative', 177, NULL, NULL, 136571),
(136572, '3.30.70.330-FF-001194', NULL, 'Enhancer binding protein-1, putative', 91, NULL, NULL, 136572),
(136573, '3.90.650.10-FF-000018', NULL, 'Phosphoribosylformylglycinamidine synthase', 183, NULL, NULL, 136573),
(136574, '1.25.40.10-FF-001054', NULL, 'BnaA07g00700D protein', 155, NULL, NULL, 136574),
(136575, '1.50.10.10-FF-000206', NULL, 'alpha-1,2-Mannosidase', 196, NULL, NULL, 136575),
(136576, '1.10.560.10-FF-000126', NULL, 'Uncharacterized protein', 76, NULL, NULL, 136576),
(136577, '2.20.70.10-FF-000119', NULL, 'WW_domain_containing_protein_-_putative', 37, NULL, NULL, 136577),
(136578, '2.40.240.20-FF-000005', NULL, 'Ribosomal RNA small subunit methyltransferase E', 70, NULL, NULL, 136578),
(136579, '3.30.1490.80-FF-000016', NULL, 'Glutathione synthetase large chain', 93, NULL, NULL, 136579),
(136580, '1.20.120.790-FF-000032', NULL, 'Uncharacterized protein', 105, NULL, NULL, 136580),
(136581, '3.40.50.12230-FF-000017', NULL, 'Formyl transferase domain protein', 293, NULL, NULL, 136581),
(136582, '1.20.930.10-FF-000001', NULL, 'IWS1, SUPT6H interacting protein', 142, NULL, NULL, 136582),
(136583, '3.30.450.50-FF-000045', NULL, 'Uncharacterized protein', 124, NULL, NULL, 136583);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(136584, '1.20.920.10-FF-000175', NULL, 'Bromodomain-containing 2b', 70, NULL, NULL, 136584),
(136585, '1.25.40.10-FF-005241', NULL, 'Protein TONSOKU', 169, NULL, NULL, 136585),
(136586, '1.10.10.60-FF-000291', NULL, 'ALX homeobox protein 1', 66, NULL, NULL, 136586),
(136587, '3.30.420.10-FF-000464', NULL, NULL, 212, NULL, NULL, 136587),
(136588, '1.10.10.10-FF-001107', NULL, 'Multidrug resistance operon repressor MexR', 134, NULL, NULL, 136588),
(136589, '1.20.58.2050-FF-000010', NULL, 'Probable DNA replication complex GINS protein PSF3', 167, NULL, NULL, 136589),
(136590, '1.20.1310.10-FF-000015', NULL, 'Cullin 5', 127, NULL, NULL, 136590),
(136591, '1.20.140.10-FF-000109', NULL, 'Short/branched chain specific acyl-CoA dehydrogenase, mitochondrial', 154, NULL, NULL, 136591),
(136592, '3.10.150.10-FF-000026', NULL, 'Beta sliding clamp', 186, NULL, NULL, 136592),
(136593, '2.60.40.60-FF-000260', NULL, 'Cadherin related family member 4', 104, NULL, NULL, 136593),
(136594, '3.90.1640.10-FF-000011', NULL, 'Exopolyphosphatase', 252, NULL, NULL, 136594),
(136595, '3.30.450.20-FF-000502', NULL, 'GAF domain protein', 119, NULL, NULL, 136595),
(136596, '3.30.160.60-FF-005798', NULL, NULL, 77, NULL, NULL, 136596),
(136597, '3.40.630.10-FF-000365', NULL, 'Glutamate carboxypeptidase, putative', 127, NULL, NULL, 136597),
(136598, '1.10.238.10-FF-000693', NULL, 'EF-hand domain-containing family member B', 105, NULL, NULL, 136598),
(136599, '1.10.8.590-FF-000003', NULL, 'tRNA (cytidine/uridine-2''-O-)-methyltransferase TrmJ', 58, NULL, NULL, 136599),
(136600, '1.25.40.10-FF-004313', NULL, 'Uncharacterized protein', 179, NULL, NULL, 136600),
(136601, '3.40.30.10-FF-001226', NULL, 'Uncharacterized protein', 139, NULL, NULL, 136601),
(136602, '1.20.58.1480-FF-000030', NULL, 'Lon protease homolog', 82, NULL, NULL, 136602),
(136603, '1.25.10.10-FF-001226', NULL, 'RING-type E3 ubiquitin transferase', 182, NULL, NULL, 136603),
(136604, '2.30.30.40-FF-000108', NULL, 'Vav guanine nucleotide exchange factor 3', 78, NULL, NULL, 136604),
(136605, '3.40.50.1000-FF-000662', NULL, NULL, 119, NULL, NULL, 136605),
(136606, '3.30.200.20-FF-000310', NULL, 'serine/threonine-protein kinase Nek2', 51, NULL, NULL, 136606),
(136607, '1.10.472.130-FF-000096', NULL, 'Dynein heavy chain family protein', 145, NULL, NULL, 136607),
(136608, '3.40.50.300-FF-003123', NULL, 'ATP-dependent DNA helicase homolog RECG, chloroplastic', 254, NULL, NULL, 136608),
(136609, '3.30.60.20-FF-000124', NULL, 'Serine/threonine-protein kinase pakD', 68, NULL, NULL, 136609),
(136610, '3.30.420.40-FF-000540', NULL, 'Actin-like protein C08B11.6', 151, NULL, NULL, 136610),
(136611, '1.20.1560.10-FF-000679', NULL, 'Serine protease/ABC transporter B family protein tagC', 16, NULL, NULL, 136611),
(136612, '2.10.25.10-FF-000133', NULL, 'Fibrillin 3', 42, NULL, NULL, 136612),
(136613, '1.10.1300.10-FF-000056', NULL, 'Uncharacterized protein', 251, NULL, NULL, 136613),
(136614, '3.30.70.260-FF-000189', NULL, 'ACT domain protein', 84, NULL, NULL, 136614),
(136615, '1.25.40.10-FF-003032', NULL, 'Crooked neck protein, putative / cell cycle protein', 103, NULL, NULL, 136615),
(136616, '3.40.190.10-FF-000729', NULL, 'Ionotropic receptor IR68a', 122, NULL, NULL, 136616),
(136617, '2.40.50.140-FF-000128', NULL, '50S ribosomal protein L2', 114, NULL, NULL, 136617),
(136618, '3.10.310.10-FF-000033', NULL, 'Diaminopimelate epimerase', 118, NULL, NULL, 136618),
(136619, '3.30.40.10-FF-001340', NULL, 'PHD and RING finger domain-containing protein 1 isoform A', 80, NULL, NULL, 136619),
(136620, '1.25.40.10-FF-004752', NULL, 'Uncharacterized protein', 211, NULL, NULL, 136620),
(136621, '2.10.25.10-FF-001061', NULL, 'Uncharacterized protein', 36, NULL, NULL, 136621),
(136622, '3.30.750.140-FF-000003', NULL, 'Type III secretion system needle length determinant', 105, NULL, NULL, 136622),
(136623, '2.60.120.650-FF-000160', NULL, 'Uncharacterized protein', 253, NULL, NULL, 136623),
(136624, '2.130.10.10-FF-003409', NULL, 'Beta-alanine-activating enzyme', 190, NULL, NULL, 136624);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(136625, '2.60.120.620-FF-000084', NULL, 'RE09701p', 193, NULL, NULL, 136625),
(136626, '1.20.5.420-FF-000029', NULL, 'Type III export protein PscE', 67, NULL, NULL, 136626),
(136627, '3.90.1150.10-FF-000075', NULL, 'Cystathionine gamma-synthase/O-acetylhomoserine thiolyase', 32, NULL, NULL, 136627),
(136628, '3.20.20.150-FF-000036', NULL, 'Xylose isomerase-type TIM barrel domain protein', 252, NULL, NULL, 136628),
(136629, '3.30.70.330-FF-002475', NULL, NULL, 80, NULL, NULL, 136629),
(136630, '3.20.20.80-FF-000522', NULL, 'Endoglucanase H', 282, NULL, NULL, 136630),
(136631, '3.10.110.10-FF-000113', NULL, 'Protein ELC', 154, NULL, NULL, 136631),
(136632, '1.20.90.10-FF-000016', NULL, 'Phospholipase A(2)', 115, NULL, NULL, 136632),
(136633, '3.30.160.60-FF-006107', NULL, NULL, 58, NULL, NULL, 136633),
(136634, '1.50.40.10-FF-000034', NULL, 'Mitochondrial 2-oxodicarboxylate carrier', 290, NULL, NULL, 136634),
(136635, '1.10.3080.10-FF-000050', NULL, 'Os01g0704700 protein', 228, NULL, NULL, 136635),
(136636, '3.40.50.150-FF-001791', NULL, NULL, 164, NULL, NULL, 136636),
(136637, '2.170.130.10-FF-000070', NULL, NULL, 135, NULL, NULL, 136637),
(136638, '3.60.40.10-FF-000080', NULL, 'Protein phosphatase', 255, NULL, NULL, 136638),
(136639, '3.30.54.20-FF-000003', NULL, 'Threonine--tRNA ligase', 74, NULL, NULL, 136639),
(136640, '1.25.40.570-FF-000019', NULL, 'Proteasome regulatory non-ATPase subunit 6', 362, NULL, NULL, 136640),
(136641, '3.90.1030.10-FF-000009', NULL, '39S ribosomal protein L17, mitochondrial', 108, NULL, NULL, 136641),
(136642, '1.10.287.110-FF-000307', NULL, 'Chaperone protein DNAJ, putative', 111, NULL, NULL, 136642),
(136643, '1.10.287.10-FF-000002', NULL, '30S ribosomal protein S15', 53, NULL, NULL, 136643),
(136644, '2.60.40.820-FF-000011', NULL, 'T-box transcription factor TBX21', 198, NULL, NULL, 136644),
(136645, '3.40.50.300-FF-002634', NULL, 'Small GTP-binding protein', 158, NULL, NULL, 136645),
(136646, '3.30.70.270-FF-000107', NULL, 'GGDEF domain-containing protein', 172, NULL, NULL, 136646),
(136647, '1.10.238.10-FF-000254', NULL, 'Phosphoinositide phospholipase C', 85, NULL, NULL, 136647),
(136648, '1.20.5.420-FF-000001', NULL, 'Vacuolar protein sorting-associated protein VTA1 homolog', 40, NULL, NULL, 136648),
(136649, '2.60.40.10-FF-003432', NULL, NULL, 104, NULL, NULL, 136649),
(136650, '1.10.510.10-FF-001282', NULL, 'PEK protein kinase', 134, NULL, NULL, 136650),
(136651, '3.30.160.60-FF-000947', NULL, 'zinc finger protein 2 isoform X2', 28, NULL, NULL, 136651),
(136652, '3.40.220.10-FF-000019', NULL, 'Replicase polyprotein 1a', 167, NULL, NULL, 136652),
(136653, '2.40.40.20-FF-000018', NULL, 'DNA-directed RNA polymerase subunit', 114, NULL, NULL, 136653),
(136654, '3.30.160.60-FF-001436', NULL, 'zinc finger protein 777', 25, NULL, NULL, 136654),
(136655, '3.90.226.10-FF-000280', NULL, 'Im:7138837 protein', 221, NULL, NULL, 136655),
(136656, '2.60.120.260-FF-000133', NULL, 'SUN domain protein5', 141, NULL, NULL, 136656),
(136657, '1.25.10.10-FF-002687', NULL, 'Uncharacterized protein', 74, NULL, NULL, 136657),
(136658, '1.25.40.490-FF-000001', NULL, 'Fanconi anemia, complementation group F', 201, NULL, NULL, 136658),
(136659, '2.40.50.100-FF-000228', NULL, 'Sll0180 protein', 35, NULL, NULL, 136659),
(136660, '3.30.70.330-FF-000266', NULL, 'Ras GTPase-activating protein-binding protein 1', 136, NULL, NULL, 136660),
(136661, '3.80.10.10-FF-001723', NULL, 'Predicted protein', 236, NULL, NULL, 136661),
(136662, '1.20.1250.20-FF-000698', NULL, 'Sorbitol transporter', 459, NULL, NULL, 136662),
(136663, '2.30.30.40-FF-000260', NULL, 'neutrophil cytosol factor 2 isoform X1', 88, NULL, NULL, 136663),
(136664, '3.40.50.2300-FF-001642', NULL, NULL, 252, NULL, NULL, 136664),
(136665, '2.130.10.10-FF-004045', NULL, 'Uncharacterized WD repeat-containing protein C63.06', 217, NULL, NULL, 136665),
(136666, '2.30.30.140-FF-000025', NULL, 'Lethal(3)malignant brain tumor-like protein 1', 98, NULL, NULL, 136666),
(136667, '1.25.40.10-FF-000570', NULL, 'Hsp70/Hsp90 organizing protein', 118, NULL, NULL, 136667);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(136668, '3.30.200.20-FF-001799', NULL, 'Kinase suppressor of Ras 2', 90, NULL, NULL, 136668),
(136669, '3.40.50.300-FF-007305', NULL, 'Uncharacterized protein', 148, NULL, NULL, 136669),
(136670, '3.30.200.20-FF-001771', NULL, 'Rol-3', 124, NULL, NULL, 136670),
(136671, '2.60.40.150-FF-000203', NULL, 'Calcium-dependent lipid-binding (CaLB domain) family protein', 150, NULL, NULL, 136671),
(136672, '2.40.10.10-FF-000513', NULL, NULL, 60, NULL, NULL, 136672),
(136673, '1.10.150.20-FF-000109', NULL, 'tRNA-specific adenosine deaminase', 80, NULL, NULL, 136673),
(136674, '3.90.70.10-FF-000602', NULL, 'Ubiquitinyl hydrolase 1', 186, NULL, NULL, 136674),
(136675, '1.20.58.930-FF-000007', NULL, 'Arginine decarboxylase', 93, NULL, NULL, 136675),
(136676, '1.10.286.10-FF-000011', NULL, NULL, 51, NULL, NULL, 136676),
(136677, '3.50.30.50-FF-000001', NULL, 'Kynurenine formamidase', 208, NULL, NULL, 136677),
(136678, '1.20.1070.10-FF-000451', NULL, 'SERotonin/octopamine receptor family', 98, NULL, NULL, 136678),
(136679, '1.20.870.10-FF-000030', NULL, 'Ras guanine nucleotide exchange factor A', 164, NULL, NULL, 136679),
(136680, '1.10.472.140-FF-000014', NULL, 'Retinoblastoma-like 2 (p130)', 97, NULL, NULL, 136680),
(136681, '3.30.40.10-FF-000704', NULL, 'Zinc finger family protein', 71, NULL, NULL, 136681),
(136682, '1.20.190.50-FF-000017', NULL, 'Nucleoporin nup107', 241, NULL, NULL, 136682),
(136683, '3.40.50.300-FF-003915', NULL, '6-phosphofructo-2-kinase', 212, NULL, NULL, 136683),
(136684, '3.10.20.90-FF-000020', NULL, 'ubiquitin carboxyl-terminal hydrolase 15 isoform X2', 92, NULL, NULL, 136684),
(136685, '1.25.40.70-FF-000037', NULL, 'Phosphatidylinositol 3-kinase VPS34', 259, NULL, NULL, 136685),
(136686, '3.40.630.10-FF-000101', NULL, 'N-acetylated alpha-linked acidic dipeptidase like 1', 324, NULL, NULL, 136686),
(136687, '1.25.40.10-FF-000070', NULL, 'zinc finger CCCH domain-containing protein 7B', 143, NULL, NULL, 136687),
(136688, '2.30.40.10-FF-000038', NULL, 'Formylmethanofuran dehydrogenase, subunit A', 75, NULL, NULL, 136688),
(136689, '1.20.5.110-FF-000060', NULL, 'SNARE complex subunit (Syn8)', 63, NULL, NULL, 136689),
(136690, '4.10.60.10-FF-000210', NULL, 'Uncharacterized protein', 82, NULL, NULL, 136690),
(136691, '1.20.1070.10-FF-001732', NULL, 'Predicted protein', 92, NULL, NULL, 136691),
(136692, '3.30.70.330-FF-001694', NULL, NULL, 119, NULL, NULL, 136692),
(136693, '3.30.30.30-FF-000064', NULL, 'Heat shock protein, putative', 85, NULL, NULL, 136693),
(136694, '3.55.40.20-FF-000011', NULL, 'Superoxide dismutase [Fe]', 113, NULL, NULL, 136694),
(136695, '2.10.25.10-FF-001561', NULL, 'Uncharacterized protein', 38, NULL, NULL, 136695),
(136696, '3.90.1860.10-FF-000022', NULL, 'Uncharacterized protein', 26, NULL, NULL, 136696),
(136697, '3.30.420.10-FF-000672', NULL, NULL, 171, NULL, NULL, 136697),
(136698, '3.30.200.20-FF-002108', NULL, 'Protein-serine/threonine kinase', 79, NULL, NULL, 136698),
(136699, '3.40.630.30-FF-000051', NULL, 'N-alpha-acetyltransferase MAK3 isoform A', 149, NULL, NULL, 136699),
(136700, '1.20.1560.10-FF-000707', NULL, 'Uncharacterized protein', 320, NULL, NULL, 136700),
(136701, '1.20.1070.10-FF-002188', NULL, 'Uncharacterized protein', 83, NULL, NULL, 136701),
(136702, '1.25.10.10-FF-001670', NULL, 'Transport and golgi organization 6 homolog', 321, NULL, NULL, 136702),
(136703, '3.10.20.90-FF-000492', NULL, 'AFaDin (Actin filament binding protein) homolog', 108, NULL, NULL, 136703),
(136704, '3.40.50.300-FF-003331', NULL, 'Rap GTPase', 181, NULL, NULL, 136704),
(136705, '2.30.180.10-FF-000055', NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', 155, NULL, NULL, 136705),
(136706, '3.30.730.10-FF-000010', NULL, 'AP2-EREBP transcription factor', 62, NULL, NULL, 136706),
(136707, '3.90.70.10-FF-000069', NULL, 'Calpain 7', 138, NULL, NULL, 136707),
(136708, '3.90.550.10-FF-000398', NULL, 'Killer toxin-resistance protein, putative', 253, NULL, NULL, 136708),
(136709, '1.25.40.10-FF-000126', NULL, 'Anaphase promoting complex subunit 7', 122, NULL, NULL, 136709);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(136710, '1.10.8.60-FF-000424', NULL, 'Replication factor C subunit 1', 67, NULL, NULL, 136710),
(136711, '2.70.150.10-FF-000286', NULL, 'Phospholipid-transporting ATPase', 178, NULL, NULL, 136711),
(136712, '2.60.120.650-FF-000188', NULL, 'Uncharacterized protein', 82, NULL, NULL, 136712),
(136713, '1.10.510.10-FF-002299', NULL, NULL, 227, NULL, NULL, 136713),
(136714, '2.40.70.10-FF-000197', NULL, 'Uncharacterized protein', 152, NULL, NULL, 136714),
(136715, '3.30.450.30-FF-000067', NULL, 'Uncharacterized protein', 123, NULL, NULL, 136715),
(136716, '1.10.555.10-FF-000204', NULL, NULL, 96, NULL, NULL, 136716),
(136717, '1.20.1370.30-FF-000002', NULL, 'Malic enzyme 2, NAD(+)-dependent, mitochondrial', 89, NULL, NULL, 136717),
(136718, '1.10.287.70-FF-000413', NULL, 'Putative ion channel protein', 118, NULL, NULL, 136718),
(136719, '3.80.10.10-FF-002387', NULL, 'Uncharacterized protein', 110, NULL, NULL, 136719),
(136720, '2.60.40.10-FF-005202', NULL, NULL, 91, NULL, NULL, 136720),
(136721, '3.80.10.10-FF-001398', NULL, 'Os08g0446200 protein', 56, NULL, NULL, 136721),
(136722, '3.60.21.10-FF-000069', NULL, 'Serine/threonine-protein phosphatase', 344, NULL, NULL, 136722),
(136723, '3.30.2410.10-FF-000002', NULL, 'E3 ubiquitin-protein ligase HECW2', 118, NULL, NULL, 136723),
(136724, '1.10.10.10-FF-001607', NULL, 'Predicted protein', 101, NULL, NULL, 136724),
(136725, '2.40.70.10-FF-000309', NULL, NULL, 99, NULL, NULL, 136725),
(136726, '2.120.10.30-FF-000482', NULL, 'Uncharacterized protein', 299, NULL, NULL, 136726),
(136727, '2.60.120.200-FF-000194', NULL, 'Crumbs cell polarity complex component 2', 136, NULL, NULL, 136727),
(136728, '3.40.50.1000-FF-000870', NULL, NULL, 156, NULL, NULL, 136728),
(136729, '2.130.10.10-FF-003617', NULL, 'WD-repeat protein, putative', 88, NULL, NULL, 136729),
(136730, '3.40.50.2300-FF-000592', NULL, 'Sensor histidine kinase RcsC', 134, NULL, NULL, 136730),
(136731, '3.30.2330.10-FF-000001', NULL, 'Arginine biosynthesis bifunctional protein ArgJ, mitochondrial', 85, NULL, NULL, 136731),
(136732, '3.20.20.140-FF-000151', NULL, 'TatD related DNase, putative', 377, NULL, NULL, 136732),
(136733, '3.20.20.80-FF-000730', NULL, 'Uncharacterized protein', 96, NULL, NULL, 136733),
(136734, '4.10.410.10-FF-000059', NULL, 'Collagen, type VI, alpha 3', 63, NULL, NULL, 136734),
(136735, '3.40.640.10-FF-000130', NULL, '8-amino-7-oxononanoate synthase', 231, NULL, NULL, 136735),
(136736, '3.30.200.20-FF-002547', NULL, 'Uncharacterized protein', 67, NULL, NULL, 136736),
(136737, '3.30.40.10-FF-000143', NULL, 'Regulator of gluconeogenesis Rmd5', 65, NULL, NULL, 136737),
(136738, '1.20.1250.20-FF-001362', NULL, 'Uncharacterized protein', 198, NULL, NULL, 136738),
(136739, '3.40.190.10-FF-000701', NULL, '4-amino-5-hydroxymethyl-2-methylpyrimidine phosphate synthase', 180, NULL, NULL, 136739),
(136740, '3.50.50.60-FF-000652', NULL, 'FAD-binding oxidoreductase', 140, NULL, NULL, 136740),
(136741, '3.30.465.10-FF-000022', NULL, 'Glycolate oxidase, subunit GlcD', 121, NULL, NULL, 136741),
(136742, '2.60.40.10-FF-001307', NULL, 'Stretchin-Mlck, isoform V', 78, NULL, NULL, 136742),
(136743, '3.40.50.300-FF-002926', NULL, 'ATP-dependent RNA helicase, putative', 258, NULL, NULL, 136743),
(136744, '3.30.160.60-FF-006315', NULL, NULL, 28, NULL, NULL, 136744),
(136745, '3.40.50.300-FF-008266', NULL, 'Uncharacterized protein', 46, NULL, NULL, 136745),
(136746, '2.20.28.20-FF-000002', NULL, 'Methionyl-tRNA synthetase', 51, NULL, NULL, 136746),
(136747, '3.40.250.10-FF-000055', NULL, 'Ubiquitin C-terminal hydrolase, putative', 146, NULL, NULL, 136747),
(136748, '3.40.33.10-FF-000070', NULL, 'GM10906', 142, NULL, NULL, 136748),
(136749, '1.10.10.10-FF-000618', NULL, 'IclR family transcriptional regulator', 75, NULL, NULL, 136749),
(136750, '3.40.50.1480-FF-000019', NULL, 'Adenosylhomocysteinase', 91, NULL, NULL, 136750),
(136751, '3.30.70.330-FF-000058', NULL, 'RNA-binding motif protein 4', 73, NULL, NULL, 136751),
(136752, '1.50.40.10-FF-000298', NULL, 'Predicted protein', 285, NULL, NULL, 136752);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(136753, '1.10.10.60-FF-001100', NULL, NULL, 70, NULL, NULL, 136753),
(136754, '3.30.40.10-FF-002121', NULL, 'Uncharacterized protein', 98, NULL, NULL, 136754),
(136755, '1.10.510.10-FF-000646', NULL, 'SRSF protein kinase 2 isoform X4', 118, NULL, NULL, 136755),
(136756, '4.10.1000.10-FF-000076', NULL, 'Zinc finger CCCH domain-containing protein 62', 43, NULL, NULL, 136756),
(136757, '3.90.70.10-FF-000810', NULL, 'Uncharacterized protein', 310, NULL, NULL, 136757),
(136758, '3.60.15.10-FF-000095', NULL, 'Metallo-hydrolase/oxidoreductase superfamily protein', 257, NULL, NULL, 136758),
(136759, '3.80.10.10-FF-000734', NULL, 'Receptor-like protein 44', 79, NULL, NULL, 136759),
(136760, '3.30.160.60-FF-002364', NULL, 'zinc finger protein ZIC 3', 30, NULL, NULL, 136760),
(136761, '1.20.58.530-FF-000011', NULL, 'unconventional myosin-XVIIIa isoform X2', 180, NULL, NULL, 136761),
(136762, '2.130.10.120-FF-000025', NULL, 'Prolyl endopeptidase', 314, NULL, NULL, 136762),
(136763, '2.60.40.10-FF-002976', NULL, 'Inositol/phosphatidylinositol phosphatase,putative', 134, NULL, NULL, 136763),
(136764, '3.30.1740.10-FF-000021', NULL, 'Poly [ADP-ribose] polymerase', 104, NULL, NULL, 136764),
(136765, '3.40.50.1460-FF-000013', NULL, 'CASP8 and FADD like apoptosis regulator', 212, NULL, NULL, 136765),
(136766, '1.10.3630.10-FF-000008', NULL, 'Golgi phosphoprotein 3 (coat-protein)', 129, NULL, NULL, 136766),
(136767, '3.40.50.300-FF-004051', NULL, 'Transmembrane GTPase Marf', 222, NULL, NULL, 136767),
(136768, '3.30.497.10-FF-000096', NULL, 'Serine protease inhibitor-like protein', 171, NULL, NULL, 136768),
(136769, '4.10.240.10-FF-000170', NULL, 'Zcf27p', 62, NULL, NULL, 136769),
(136770, '3.40.50.620-FF-000083', NULL, 'Methionine--tRNA ligase', 346, NULL, NULL, 136770),
(136771, '3.30.160.20-FF-000222', NULL, 'Uncharacterized protein', 94, NULL, NULL, 136771),
(136772, '3.40.50.2300-FF-000209', NULL, 'Phosphodiesterase', 119, NULL, NULL, 136772),
(136773, '1.10.630.10-FF-000273', NULL, 'Erythromycin C-12 hydroxylase', 395, NULL, NULL, 136773),
(136774, '1.20.1250.20-FF-001946', NULL, 'Xylose transporter', 448, NULL, NULL, 136774),
(136775, '1.20.200.10-FF-000019', NULL, 'Argininosuccinate lyase chloroplastic', 147, NULL, NULL, 136775),
(136776, '3.30.230.10-FF-000281', NULL, 'Uncharacterized protein', 134, NULL, NULL, 136776),
(136777, '1.20.1250.20-FF-000518', NULL, 'MFS transporter', 198, NULL, NULL, 136777),
(136778, '2.60.40.200-FF-000033', NULL, 'Uncharacterized protein', 92, NULL, NULL, 136778),
(136779, '2.40.70.10-FF-000461', NULL, NULL, 177, NULL, NULL, 136779),
(136780, '3.40.50.150-FF-000863', NULL, 'tRNA (adenine(58)-N(1))-methyltransferase', 248, NULL, NULL, 136780),
(136781, '2.60.120.590-FF-000001', NULL, 'FTO, alpha-ketoglutarate dependent dioxygenase', 301, NULL, NULL, 136781),
(136782, '2.70.170.10-FF-000085', NULL, 'Probable ligand-gated ion channel 46', 212, NULL, NULL, 136782),
(136783, '1.20.58.60-FF-000153', NULL, 'Spectrin beta chain', 110, NULL, NULL, 136783),
(136784, '3.30.40.10-FF-001924', NULL, 'Uncharacterized protein', 71, NULL, NULL, 136784),
(136785, '2.10.25.10-FF-001353', NULL, 'Integrin, beta-like 1', 48, NULL, NULL, 136785),
(136786, '3.90.550.10-FF-000134', NULL, 'Glycosyl transferase family 2', 211, NULL, NULL, 136786),
(136787, '1.20.5.340-FF-000044', NULL, 'MIA SH3 domain ER export factor 2', 92, NULL, NULL, 136787),
(136788, '1.10.510.10-FF-002563', NULL, 'Uncharacterized protein', 262, NULL, NULL, 136788),
(136789, '2.60.40.10-FF-004921', NULL, NULL, 130, NULL, NULL, 136789),
(136790, '3.40.140.10-FF-000226', NULL, 'Uncharacterized protein', 173, NULL, NULL, 136790),
(136791, '3.30.420.40-FF-000832', NULL, 'Uncharacterized protein', 113, NULL, NULL, 136791),
(136792, '3.40.50.300-FF-004579', NULL, 'Dynein heavy chain', 191, NULL, NULL, 136792),
(136793, '3.30.200.20-FF-001827', NULL, 'Serine/threonine protein kinase', 46, NULL, NULL, 136793),
(136794, '1.10.20.10-FF-000208', NULL, NULL, 128, NULL, NULL, 136794),
(136795, '2.60.200.10-FF-000012', NULL, 'Interferon regulatory factor 3', 102, NULL, NULL, 136795);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(136796, '2.60.40.10-FF-000470', NULL, 'SLAM family member 7', 88, NULL, NULL, 136796),
(136797, '2.130.10.10-FF-000655', NULL, 'Protein transport protein SEC13', 292, NULL, NULL, 136797),
(136798, '1.25.40.10-FF-001907', NULL, 'U1 small nuclear ribonucleoprotein component, putative', 193, NULL, NULL, 136798),
(136799, '3.30.710.10-FF-000211', NULL, 'S-phase kinase-associated protein 1A, putative', 159, NULL, NULL, 136799),
(136800, '2.30.36.70-FF-000018', NULL, 'Uncharacterized protein', 41, NULL, NULL, 136800),
(136801, '3.40.850.10-FF-000112', NULL, 'Kinesin-8, putative', 354, NULL, NULL, 136801),
(136802, '2.70.150.10-FF-000022', NULL, 'Phospholipid-transporting ATPase', 177, NULL, NULL, 136802),
(136803, '3.30.70.330-FF-001486', NULL, 'POU domain, class 4, transcription factor', 124, NULL, NULL, 136803),
(136804, '3.30.2350.10-FF-000059', NULL, 'Pseudouridine synthase', 235, NULL, NULL, 136804),
(136805, '3.40.50.150-FF-001111', NULL, 'Uncharacterized protein B11B23.180', 250, NULL, NULL, 136805),
(136806, '2.30.29.30-FF-000006', NULL, 'Pleckstrin homology like domain family B member 1', 106, NULL, NULL, 136806),
(136807, '1.10.472.10-FF-000489', NULL, 'Uncharacterized protein', 145, NULL, NULL, 136807),
(136808, '3.40.50.1360-FF-000040', NULL, '6-phosphogluconolactonase', 242, NULL, NULL, 136808),
(136809, '1.10.1420.10-FF-000183', NULL, 'DNA mismatch repair protein', 190, NULL, NULL, 136809),
(136810, '2.10.220.10-FF-000069', NULL, 'Fraser extracellular matrix complex subunit 1', 82, NULL, NULL, 136810),
(136811, '3.30.530.20-FF-000003', NULL, 'Collagen type IV alpha-3-binding protein-like protein', 234, NULL, NULL, 136811),
(136812, '1.10.510.10-FF-001635', NULL, 'Protein CBR-IKKE-1', 279, NULL, NULL, 136812),
(136813, '1.10.150.340-FF-000006', NULL, '5''-nucleotidase', 56, NULL, NULL, 136813),
(136814, '3.40.50.720-FF-000079', NULL, 'Glucose-6-phosphate 1-dehydrogenase', 188, NULL, NULL, 136814),
(136815, '2.130.10.30-FF-000077', NULL, 'Highwire, isoform B', 190, NULL, NULL, 136815),
(136816, '3.40.50.2000-FF-000861', NULL, 'Alpha-1,3/1,6-mannosyltransferase ALG2-like Protein', 203, NULL, NULL, 136816),
(136817, '3.40.640.10-FF-000219', NULL, 'Aminotransferase PigE', 301, NULL, NULL, 136817),
(136818, '3.40.50.1980-FF-000107', NULL, 'Histidinol dehydrogenase', 93, NULL, NULL, 136818),
(136819, '3.40.50.10470-FF-000023', NULL, 'Translation initiation factor EIF-2b alpha subunit', 196, NULL, NULL, 136819),
(136820, '3.30.230.10-FF-000337', NULL, 'Predicted protein', 61, NULL, NULL, 136820),
(136821, '3.30.540.10-FF-000091', NULL, 'Os05g0438600 protein', 77, NULL, NULL, 136821),
(136822, '1.10.10.820-FF-000031', NULL, 'Chitin synthase', 64, NULL, NULL, 136822),
(136823, '1.10.10.60-FF-000583', NULL, 'Uncharacterized protein', 73, NULL, NULL, 136823),
(136824, '2.60.40.180-FF-000010', NULL, 'Hydroxyisourate hydrolase', 111, NULL, NULL, 136824),
(136825, '1.10.238.10-FF-000546', NULL, 'Calcium-binding protein CBP', 132, NULL, NULL, 136825),
(136826, '2.130.10.10-FF-005326', NULL, 'Uncharacterized protein', 196, NULL, NULL, 136826),
(136827, '3.90.980.20-FF-000012', NULL, 'Uncharacterized protein', 133, NULL, NULL, 136827),
(136828, '3.30.200.20-FF-001119', NULL, 'Myosin light chain kinase', 103, NULL, NULL, 136828),
(136829, '2.60.40.10-FF-004213', NULL, NULL, 74, NULL, NULL, 136829),
(136830, '2.40.30.130-FF-000031', NULL, 'Alanyl-tRNA synthetase', 101, NULL, NULL, 136830),
(136831, '3.40.50.2300-FF-000361', NULL, 'Two-component system response regulator', 130, NULL, NULL, 136831),
(136832, '1.20.1250.20-FF-002351', NULL, 'Uncharacterized protein', 410, NULL, NULL, 136832),
(136833, '1.20.1280.290-FF-000020', NULL, 'Bidirectional sugar transporter SWEET', 92, NULL, NULL, 136833),
(136834, '2.20.110.10-FF-000042', NULL, NULL, 43, NULL, NULL, 136834),
(136835, '1.20.1420.30-FF-000063', NULL, 'Sodium/potassium/calcium exchanger 4', 124, NULL, NULL, 136835),
(136836, '1.10.3130.10-FF-000015', NULL, 'Serine acetyltransferase, plasmid', 160, NULL, NULL, 136836),
(136837, '2.60.40.10-FF-001195', NULL, 'PKHD1 like 1', 86, NULL, NULL, 136837);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(136838, '1.10.10.60-FF-000644', NULL, 'MYB transcription factor', 64, NULL, NULL, 136838),
(136839, '2.30.30.140-FF-000317', NULL, 'Uncharacterized protein', 59, NULL, NULL, 136839),
(136840, '1.20.58.190-FF-000010', NULL, NULL, 128, NULL, NULL, 136840),
(136841, '2.130.10.10-FF-004337', NULL, 'SEC12-like protein 1', 99, NULL, NULL, 136841),
(136842, '4.10.110.10-FF-000014', NULL, 'Predicted protein', 59, NULL, NULL, 136842),
(136843, '2.60.120.200-FF-000430', NULL, 'Si:ch211-274f20.2', 211, NULL, NULL, 136843),
(136844, '2.60.40.10-FF-005910', NULL, NULL, 53, NULL, NULL, 136844),
(136845, '3.40.50.300-FF-005040', NULL, 'DEAH (Asp-Glu-Ala-His) box helicase 15', 103, NULL, NULL, 136845),
(136846, '2.40.50.140-FF-000072', NULL, 'SOSS complex subunit B2', 109, NULL, NULL, 136846),
(136847, '2.60.40.60-FF-001041', NULL, 'Uncharacterized protein', 97, NULL, NULL, 136847),
(136848, '3.40.50.300-FF-006788', NULL, 'Uncharacterized protein', 58, NULL, NULL, 136848),
(136849, '3.10.400.20-FF-000009', NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', 220, NULL, NULL, 136849),
(136850, '3.30.160.60-FF-003353', NULL, 'zinc finger protein 180 isoform X2', 22, NULL, NULL, 136850),
(136851, '3.30.190.20-FF-000050', NULL, 'Predicted protein', 108, NULL, NULL, 136851),
(136852, '3.40.190.10-FF-000437', NULL, 'Transferrin', 104, NULL, NULL, 136852),
(136853, '2.40.100.10-FF-000138', NULL, 'Uncharacterized protein', 46, NULL, NULL, 136853),
(136854, '1.20.1070.10-FF-000743', NULL, 'Predicted protein', 288, NULL, NULL, 136854),
(136855, '2.170.150.10-FF-000009', NULL, 'Translationally-controlled tumor protein homolog', 179, NULL, NULL, 136855),
(136856, '3.30.500.10-FF-000026', NULL, NULL, 95, NULL, NULL, 136856),
(136857, '3.40.30.10-FF-001081', NULL, 'Uncharacterized protein', 113, NULL, NULL, 136857),
(136858, '2.60.120.10-FF-000011', NULL, 'Potassium channel, voltage-gated eag-related subfamily H, member 7', 163, NULL, NULL, 136858),
(136859, '1.10.287.70-FF-000677', NULL, 'Uncharacterized protein', 98, NULL, NULL, 136859),
(136860, '2.60.40.10-FF-003140', NULL, NULL, 100, NULL, NULL, 136860),
(136861, '3.30.1330.20-FF-000004', NULL, 'Cell division protein FtsZ', 118, NULL, NULL, 136861),
(136862, '3.40.50.12780-FF-000126', NULL, 'Nonribosomal peptide synthetase 8', 403, NULL, NULL, 136862),
(136863, '1.20.1250.10-FF-000044', NULL, 'Interferon kappa', 181, NULL, NULL, 136863),
(136864, '1.10.1670.40-FF-000002', NULL, 'Base excision DNA repair protein, HhH-GPD family', 72, NULL, NULL, 136864),
(136865, '1.10.510.10-FF-001051', NULL, 'Guanylate cyclase', 276, NULL, NULL, 136865),
(136866, '3.40.50.1000-FF-000718', NULL, NULL, 95, NULL, NULL, 136866),
(136867, '3.40.50.300-FF-001145', NULL, 'Putative dynein heavy chain', 173, NULL, NULL, 136867),
(136868, '3.40.190.10-FF-000376', NULL, 'Alkaline phosphatase L', 136, NULL, NULL, 136868),
(136869, '3.20.110.10-FF-000027', NULL, 'Alpha-mannosidase', 220, NULL, NULL, 136869),
(136870, '2.60.40.10-FF-003965', NULL, NULL, 103, NULL, NULL, 136870),
(136871, '2.40.50.150-FF-000018', NULL, 'DNA-directed RNA polymerase subunit beta', 118, NULL, NULL, 136871),
(136872, '3.30.70.1020-FF-000002', NULL, 'Trehalose-6-phosphate synthase 2', 80, NULL, NULL, 136872),
(136873, '1.25.10.10-FF-002395', NULL, 'Uncharacterized protein', 259, NULL, NULL, 136873),
(136874, '1.10.1450.10-FF-000123', NULL, 'Tetraspanin', 84, NULL, NULL, 136874),
(136875, '2.60.40.10-FF-000531', NULL, 'Immunoglobulin superfamily member 9B', 95, NULL, NULL, 136875),
(136876, '3.40.50.880-FF-000110', NULL, 'Catalase', 153, NULL, NULL, 136876),
(136877, '3.40.47.10-FF-000068', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 3', 146, NULL, NULL, 136877),
(136878, '3.80.10.10-FF-000942', NULL, 'Disease resistance protein Pik-2', 279, NULL, NULL, 136878),
(136879, '2.40.50.140-FF-000780', NULL, 'Uncharacterized protein', 182, NULL, NULL, 136879),
(136880, '1.20.1280.290-FF-000109', NULL, 'Predicted protein', 91, NULL, NULL, 136880),
(136881, '3.30.160.60-FF-001144', NULL, 'zinc finger protein 646', 76, NULL, NULL, 136881);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(136882, '3.30.70.1230-FF-000239', NULL, 'Soluble adenylyl cyclase', 133, NULL, NULL, 136882),
(136883, '3.30.565.10-FF-000350', NULL, 'Phytochrome', 165, NULL, NULL, 136883),
(136884, '2.170.270.10-FF-000136', NULL, 'Uncharacterized protein', 191, NULL, NULL, 136884),
(136885, '1.25.10.10-FF-003204', NULL, 'Uncharacterized protein', 281, NULL, NULL, 136885),
(136886, '2.10.25.10-FF-000633', NULL, 'cubilin', 44, NULL, NULL, 136886),
(136887, '1.20.120.140-FF-000039', NULL, 'Signal recognition particle receptor FtsY', 80, NULL, NULL, 136887),
(136888, '1.25.40.10-FF-004521', NULL, 'Uncharacterized protein', 77, NULL, NULL, 136888),
(136889, '3.40.390.10-FF-000149', NULL, 'Carbohydrate-binding protein', 192, NULL, NULL, 136889),
(136890, '3.30.70.330-FF-000766', NULL, 'CUGBP Elav family member 6', 95, NULL, NULL, 136890),
(136891, '1.10.274.30-FF-000001', NULL, 'Mortality factor 4-like protein 1', 173, NULL, NULL, 136891),
(136892, '2.170.270.10-FF-000080', NULL, 'SET (Trithorax/polycomb) domain containing', 95, NULL, NULL, 136892),
(136893, '3.40.50.1440-FF-000119', NULL, 'Tubulin beta chain', 185, NULL, NULL, 136893),
(136894, '1.25.40.720-FF-000025', NULL, 'Uncharacterized protein', 192, NULL, NULL, 136894),
(136895, '3.10.590.10-FF-000020', NULL, 'ATP-dependent RNA helicase, putative', 151, NULL, NULL, 136895),
(136896, '2.130.10.10-FF-005826', NULL, 'Uncharacterized protein', 42, NULL, NULL, 136896),
(136897, '3.30.450.40-FF-000008', NULL, 'GAF domain-containing proteins', 158, NULL, NULL, 136897),
(136898, '2.60.40.420-FF-000127', NULL, 'Extracellular dihydrogeodin oxidase/laccase, putative', 200, NULL, NULL, 136898),
(136899, '3.40.850.10-FF-000376', NULL, 'Unconventional myosin class XV', 102, NULL, NULL, 136899),
(136900, '3.90.1150.10-FF-000136', NULL, 'Serine hydroxymethyltransferase', 153, NULL, NULL, 136900),
(136901, '1.20.920.20-FF-000032', NULL, 'Dynein heavy chain 9, axonemal', 167, NULL, NULL, 136901),
(136902, '2.40.220.10-FF-000001', NULL, 'Sialidase A', 80, NULL, NULL, 136902),
(136903, '1.20.1250.20-FF-002290', NULL, 'Uncharacterized protein', 71, NULL, NULL, 136903),
(136904, '3.40.190.10-FF-000229', NULL, 'Phosphate ABC transporter, phosphate-binding protein', 133, NULL, NULL, 136904),
(136905, '3.60.60.30-FF-000002', NULL, 'Phospholipase B-like', 514, NULL, NULL, 136905),
(136906, '1.20.1060.10-FF-000006', NULL, 'DNA polymerase I', 124, NULL, NULL, 136906),
(136907, '1.25.10.10-FF-001018', NULL, 'Protein CBG14894', 482, NULL, NULL, 136907),
(136908, '1.20.1110.10-FF-000067', NULL, 'Probable cation-transporting ATPase exp7', 294, NULL, NULL, 136908),
(136909, '3.30.160.60-FF-003089', NULL, NULL, 29, NULL, NULL, 136909),
(136910, '3.10.110.10-FF-000052', NULL, 'Putative e3 ubiquitin-protein ligase rnf25', 118, NULL, NULL, 136910),
(136911, '2.60.120.290-FF-000001', NULL, 'CUB and sushi domain-containing protein 3 isoform X1', 109, NULL, NULL, 136911),
(136912, '2.70.98.110-FF-000018', NULL, NULL, 202, NULL, NULL, 136912),
(136913, '3.30.160.60-FF-000739', NULL, 'Zgc:171418 protein', 28, NULL, NULL, 136913),
(136914, '3.30.450.20-FF-000002', NULL, 'LOV domain-containing protein', 165, NULL, NULL, 136914),
(136915, '3.30.530.20-FF-000211', NULL, 'F-box/WD repeat-containing protein A-like protein', 182, NULL, NULL, 136915),
(136916, '2.60.40.150-FF-000675', NULL, 'Uncharacterized protein', 44, NULL, NULL, 136916),
(136917, '1.25.40.10-FF-002335', NULL, 'Glutamine-rich protein23', 188, NULL, NULL, 136917),
(136918, '1.10.287.2620-FF-000022', NULL, 'Dynein heavy chain 6, axonemal', 64, NULL, NULL, 136918),
(136919, '3.40.50.300-FF-008474', NULL, 'Multidrug resistance-associated protein, putative', 227, NULL, NULL, 136919),
(136920, '3.90.640.10-FF-000225', NULL, 'Predicted protein', 67, NULL, NULL, 136920),
(136921, '1.10.150.110-FF-000022', NULL, 'DNA polymerase', 89, NULL, NULL, 136921),
(136922, '2.60.40.10-FF-004421', NULL, NULL, 96, NULL, NULL, 136922),
(136923, '1.50.40.10-FF-000534', NULL, 'Uncharacterized protein', 154, NULL, NULL, 136923),
(136924, '1.20.120.1240-FF-000051', NULL, 'Dynamin GTPase, putative', 224, NULL, NULL, 136924);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(136925, '4.10.900.10-FF-000018', NULL, 'Uncharacterized protein', 90, NULL, NULL, 136925),
(136926, '2.40.50.140-FF-000628', NULL, 'Tyrosine--tRNA ligase', 162, NULL, NULL, 136926),
(136927, '3.90.1150.10-FF-000283', NULL, 'Aminotransferase', 134, NULL, NULL, 136927),
(136928, '3.30.200.20-FF-001327', NULL, 'Leucine-rich repeat protein kinase family protein', 112, NULL, NULL, 136928),
(136929, '3.40.50.300-FF-005540', NULL, 'Meiotic recombination protein DMC1', 50, NULL, NULL, 136929),
(136930, '2.130.10.10-FF-000594', NULL, 'Small nucleolar ribonucleoprotein complex subunit, putative', 417, NULL, NULL, 136930),
(136931, '3.80.10.10-FF-000381', NULL, 'Ubiquitin ligase complex F-box protein GRR1', 262, NULL, NULL, 136931),
(136932, '3.30.230.10-FF-000129', NULL, 'Mlh2p', 126, NULL, NULL, 136932),
(136933, '1.10.730.10-FF-000218', NULL, 'Uncharacterized protein', 141, NULL, NULL, 136933),
(136934, '1.10.10.60-FF-000791', NULL, NULL, 35, NULL, NULL, 136934),
(136935, '2.60.40.10-FF-005702', NULL, NULL, 58, NULL, NULL, 136935),
(136936, '3.30.160.60-FF-005859', NULL, NULL, 104, NULL, NULL, 136936),
(136937, '3.40.50.300-FF-000217', NULL, 'DNA helicase', 341, NULL, NULL, 136937),
(136938, '2.130.10.10-FF-004545', NULL, 'AGR367Cp', 220, NULL, NULL, 136938),
(136939, '3.30.70.660-FF-000073', NULL, 'tRNA pseudouridine synthase', 135, NULL, NULL, 136939),
(136940, '3.30.70.890-FF-000057', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 117, NULL, NULL, 136940),
(136941, '3.40.532.10-FF-000019', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 211, NULL, NULL, 136941),
(136942, '3.40.50.1000-FF-000162', NULL, 'HAD-like protein', 14, NULL, NULL, 136942),
(136943, '3.30.830.10-FF-000074', NULL, 'Axl1p', 253, NULL, NULL, 136943),
(136944, '1.20.120.350-FF-000164', NULL, NULL, 136, NULL, NULL, 136944),
(136945, '1.10.135.10-FF-000004', NULL, 'Creatine kinase, flagellar', 96, NULL, NULL, 136945),
(136946, '3.40.50.2000-FF-000209', NULL, 'UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase GtfA subunit', 162, NULL, NULL, 136946),
(136947, '1.10.10.10-FF-001046', NULL, 'DNA topoisomerase, putative', 115, NULL, NULL, 136947),
(136948, '1.20.58.60-FF-000214', NULL, 'Spectrin beta chain', 104, NULL, NULL, 136948),
(136949, '1.10.8.1220-FF-000011', NULL, 'Axonemal dynein heavy chain', 90, NULL, NULL, 136949),
(136950, '3.80.10.10-FF-004124', NULL, 'Uncharacterized protein', 286, NULL, NULL, 136950),
(136951, '1.20.1070.10-FF-000951', NULL, 'Mitochondrial pyruvate carrier', 313, NULL, NULL, 136951),
(136952, '3.30.1140.32-FF-000017', NULL, '30S ribosomal protein S3', 122, NULL, NULL, 136952),
(136953, '3.90.226.10-FF-000072', NULL, 'Enoyl-CoA hydratase domain-containing protein 2, mitochondrial', 78, NULL, NULL, 136953),
(136954, '2.60.120.40-FF-000054', NULL, 'Uncharacterized protein', 162, NULL, NULL, 136954),
(136955, '2.10.250.10-FF-000009', NULL, 'Calreticulin family protein', 98, NULL, NULL, 136955),
(136956, '3.40.50.2000-FF-000153', NULL, 'Alpha-1,4 glucan phosphorylase', 505, NULL, NULL, 136956),
(136957, '1.20.1250.20-FF-001423', NULL, 'MFS transporter of unkown specificity (AFU_orthologue AFUA_1G11350)', 170, NULL, NULL, 136957),
(136958, '3.30.56.10-FF-000044', NULL, 'Predicted protein', 53, NULL, NULL, 136958),
(136959, '1.20.1250.20-FF-002143', NULL, 'Uncharacterized protein', 201, NULL, NULL, 136959),
(136960, '2.60.120.260-FF-000341', NULL, 'Sperm-associated antigen 4', 179, NULL, NULL, 136960),
(136961, '1.25.40.990-FF-000061', NULL, 'Si:zfos-452g4.1', 139, NULL, NULL, 136961),
(136962, '2.10.90.10-FF-000031', NULL, 'placenta growth factor isoform X2', 112, NULL, NULL, 136962),
(136963, '3.30.210.10-FF-000015', NULL, 'Uncharacterized protein', 55, NULL, NULL, 136963),
(136964, '3.30.420.40-FF-000068', NULL, 'Ectonucleoside triphosphate diphosphohydrolase 1', 134, NULL, NULL, 136964),
(136965, '2.60.40.790-FF-000159', NULL, NULL, 110, NULL, NULL, 136965),
(136966, '1.20.58.390-FF-000098', NULL, 'Predicted protein', 87, NULL, NULL, 136966),
(136967, '3.30.160.60-FF-001644', NULL, 'Zinc finger protein 574', 25, NULL, NULL, 136967); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(136968, '1.25.40.20-FF-000539', NULL, 'Suppressor of ty', 123, NULL, NULL, 136968),
(136969, '3.40.50.1820-FF-001453', NULL, 'Esterase/lipase/thioesterase family protein', 183, NULL, NULL, 136969),
(136970, '1.10.8.10-FF-000050', NULL, 'Related to AMFR protein', 48, NULL, NULL, 136970),
(136971, '3.40.50.150-FF-001583', NULL, NULL, 47, NULL, NULL, 136971),
(136972, '3.40.800.20-FF-000022', NULL, 'Histone deacetylase 2', 135, NULL, NULL, 136972),
(136973, '3.90.290.10-FF-000035', NULL, 'Uncharacterized protein', 81, NULL, NULL, 136973),
(136974, '3.90.950.10-FF-000035', NULL, 'Probable inosine/xanthosine triphosphatase', 209, NULL, NULL, 136974),
(136975, '3.40.50.2300-FF-000945', NULL, NULL, 163, NULL, NULL, 136975),
(136976, '1.20.1070.10-FF-001468', NULL, 'Predicted protein', 214, NULL, NULL, 136976),
(136977, '1.20.120.1900-FF-000063', NULL, 'Gamma-tubulin complex component', 314, NULL, NULL, 136977),
(136978, '1.10.460.10-FF-000029', NULL, 'DNA topoisomerase', 157, NULL, NULL, 136978),
(136979, '3.30.70.330-FF-002003', NULL, NULL, 85, NULL, NULL, 136979),
(136980, '3.40.50.1000-FF-000218', NULL, 'Copper-transporting ATPase', 155, NULL, NULL, 136980),
(136981, '1.20.120.330-FF-000006', NULL, 'Programmed cell death protein 10', 144, NULL, NULL, 136981),
(136982, '3.40.50.300-FF-008002', NULL, 'Uncharacterized protein', 149, NULL, NULL, 136982),
(136983, '1.20.1070.10-FF-001671', NULL, 'Uncharacterized protein', 124, NULL, NULL, 136983),
(136984, '1.25.10.10-FF-002187', NULL, 'Uncharacterized protein', 455, NULL, NULL, 136984),
(136985, '2.40.50.140-FF-000572', NULL, 'Exosome complex exonuclease RRP40, putative', 75, NULL, NULL, 136985),
(136986, '1.10.287.130-FF-000140', NULL, 'Sensor histidine kinase, PAS and GAF domain-containing', 79, NULL, NULL, 136986),
(136987, '1.10.10.1180-FF-000004', NULL, 'Inner nuclear membrane protein Man1', 90, NULL, NULL, 136987),
(136988, '3.30.70.870-FF-000046', NULL, 'Elongation factor G, mitochondrial', 95, NULL, NULL, 136988),
(136989, '3.60.21.10-FF-000333', NULL, 'Uncharacterized protein', 346, NULL, NULL, 136989),
(136990, '3.40.366.10-FF-000043', NULL, 'Uncharacterized protein', 210, NULL, NULL, 136990),
(136991, '1.10.287.110-FF-000246', NULL, 'DNaJ domain (Prokaryotic heat shock protein)', 110, NULL, NULL, 136991),
(136992, '1.20.1070.10-FF-000390', NULL, 'Novopsin-1', 318, NULL, NULL, 136992),
(136993, '3.30.160.60-FF-004634', NULL, NULL, 50, NULL, NULL, 136993),
(136994, '2.60.120.310-FF-000024', NULL, 'Uncharacterized protein', 132, NULL, NULL, 136994),
(136995, '3.40.190.10-FF-000640', NULL, 'Predicted protein', 272, NULL, NULL, 136995),
(136996, '4.10.320.10-FF-000024', NULL, 'Acetyltransferase component of pyruvate dehydrogenase complex', 52, NULL, NULL, 136996),
(136997, '3.90.550.10-FF-000718', NULL, 'Glycosyltransferase involved in cell wall biogenesis', 262, NULL, NULL, 136997),
(136998, '2.10.110.10-FF-000179', NULL, 'Calponin homology and LIM domain-containing protein', 66, NULL, NULL, 136998),
(136999, '3.10.450.10-FF-000043', NULL, 'Uncharacterized protein', 128, NULL, NULL, 136999),
(137000, '2.40.50.140-FF-001089', NULL, NULL, 162, NULL, NULL, 137000),
(137001, '2.10.25.10-FF-000897', NULL, 'Faulty attraction, isoform F', 50, NULL, NULL, 137001),
(137002, '2.130.10.10-FF-001111', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 163, NULL, NULL, 137002),
(137003, '3.30.260.10-FF-000018', NULL, 'Heat shock protein 60', 55, NULL, NULL, 137003),
(137004, '3.30.60.30-FF-000245', NULL, 'Uncharacterized protein', 45, NULL, NULL, 137004),
(137005, '3.80.10.10-FF-002887', NULL, 'Uncharacterized protein', 92, NULL, NULL, 137005),
(137006, '1.20.120.1100-FF-000003', NULL, 'Fatty Acid/Retinol binding protein', 138, NULL, NULL, 137006),
(137007, '2.60.40.10-FF-002476', NULL, 'Protein tyrosine phosphatase, receptor type C', 98, NULL, NULL, 137007),
(137008, '3.90.1150.10-FF-000400', NULL, 'Uncharacterized protein', 46, NULL, NULL, 137008),
(137009, '3.30.2130.10-FF-000020', NULL, 'Uncharacterized protein', 141, NULL, NULL, 137009);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(137010, '3.40.50.300-FF-002426', NULL, 'ADP-ribosylation factor-like 3', 78, NULL, NULL, 137010),
(137011, '3.10.20.90-FF-000992', NULL, 'Uncharacterized protein', 138, NULL, NULL, 137011),
(137012, '1.10.510.10-FF-000707', NULL, 'CAMK/CAMKL/CHK1 protein kinase', 312, NULL, NULL, 137012),
(137013, '3.40.50.720-FF-002524', NULL, 'Uncharacterized protein', 101, NULL, NULL, 137013),
(137014, '1.25.10.10-FF-000242', NULL, 'Cullin-associated NEDD8-dissociated protein 1', 1179, NULL, NULL, 137014),
(137015, '1.25.40.190-FF-000001', NULL, 'Actin-related protein 2/3 complex subunit 5', 150, NULL, NULL, 137015),
(137016, '3.30.70.330-FF-001339', NULL, 'Cellular nucleic acid binding protein, putative', 155, NULL, NULL, 137016),
(137017, '3.30.200.20-FF-002047', NULL, NULL, 89, NULL, NULL, 137017),
(137018, '1.20.1540.10-FF-000032', NULL, 'inactive rhomboid protein 1', 160, NULL, NULL, 137018),
(137019, '1.25.40.20-FF-000691', NULL, 'Uncharacterized protein', 130, NULL, NULL, 137019),
(137020, '1.10.20.10-FF-000355', NULL, NULL, 91, NULL, NULL, 137020),
(137021, '3.30.565.10-FF-000086', NULL, 'Type IV pilus sensor protein PilS', 154, NULL, NULL, 137021),
(137022, '3.20.20.220-FF-000085', NULL, 'Proline dehydrogenase', 80, NULL, NULL, 137022),
(137023, '3.30.450.90-FF-000006', NULL, 'P-type DNA transfer ATPase VirB11', 105, NULL, NULL, 137023),
(137024, '2.40.50.100-FF-000167', NULL, 'Cytochrome f', 58, NULL, NULL, 137024),
(137025, '3.30.160.60-FF-002425', NULL, 'Zinc finger protein STAMENLESS 1', 73, NULL, NULL, 137025),
(137026, '3.30.420.580-FF-000005', NULL, 'Probable actin-related protein 8', 17, NULL, NULL, 137026),
(137027, '1.20.1050.20-FF-000014', NULL, NULL, 206, NULL, NULL, 137027),
(137028, '1.10.3470.10-FF-000006', NULL, 'Metal ABC transporter permease', 257, NULL, NULL, 137028),
(137029, '3.20.20.80-FF-000022', NULL, 'Beta-glucosidase 11', 491, NULL, NULL, 137029),
(137030, '3.90.70.10-FF-000569', NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', 449, NULL, NULL, 137030),
(137031, '3.30.70.100-FF-000074', NULL, 'P-type cation-transporting ATPase', 76, NULL, NULL, 137031),
(137032, '2.60.40.10-FF-000267', NULL, 'Sidekick cell adhesion molecule 2', 103, NULL, NULL, 137032),
(137033, '3.80.10.10-FF-002179', NULL, 'ROP-interactive CRIB motif-containing protein 7', 339, NULL, NULL, 137033),
(137034, '1.20.140.150-FF-000108', NULL, 'Uncharacterized protein', 163, NULL, NULL, 137034),
(137035, '3.30.160.880-FF-000001', NULL, 'Cell division protein ZapA', 47, NULL, NULL, 137035),
(137036, '1.10.418.40-FF-000007', NULL, 'Beclin-1-like protein', 190, NULL, NULL, 137036),
(137037, '3.30.710.10-FF-000008', NULL, 'Speckle-type POZ protein-like a', 117, NULL, NULL, 137037),
(137038, '1.25.10.10-FF-000950', NULL, 'Tubulin-folding cofactor D', 441, NULL, NULL, 137038),
(137039, '3.90.660.10-FF-000024', NULL, 'Amine oxidase', 181, NULL, NULL, 137039),
(137040, '1.25.40.180-FF-000352', NULL, NULL, 61, NULL, NULL, 137040),
(137041, '1.20.58.610-FF-000001', NULL, 'Hsp90 co-chaperone Cdc37-like 1', 129, NULL, NULL, 137041),
(137042, '1.10.238.10-FF-000754', NULL, 'Phosphoinositide phospholipase C', 77, NULL, NULL, 137042),
(137043, '3.30.160.60-FF-005034', NULL, NULL, 31, NULL, NULL, 137043),
(137044, '1.10.287.70-FF-000205', NULL, 'Voltage-dependent L-type calcium channel subunit alpha-1S', 157, NULL, NULL, 137044),
(137045, '1.20.5.100-FF-000023', NULL, 'Integrin beta', 76, NULL, NULL, 137045),
(137046, '3.40.50.720-FF-000315', NULL, '(+)-neomenthol dehydrogenase', 283, NULL, NULL, 137046),
(137047, '3.30.1060.10-FF-000019', NULL, NULL, 129, NULL, NULL, 137047),
(137048, '2.30.30.100-FF-000064', NULL, 'U6 snRNA-associated Sm-like protein LSm4', 93, NULL, NULL, 137048),
(137049, '3.90.930.12-FF-000019', NULL, NULL, 89, NULL, NULL, 137049),
(137050, '1.10.510.10-FF-003316', NULL, NULL, 71, NULL, NULL, 137050),
(137051, '3.90.740.10-FF-000025', NULL, 'Valine--tRNA ligase, chloroplastic/mitochondrial 2 isoform X2', 42, NULL, NULL, 137051),
(137052, '3.40.50.300-FF-004820', NULL, 'TBP-associated factor A', 226, NULL, NULL, 137052);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(137053, '3.40.950.10-FF-000029', NULL, NULL, 218, NULL, NULL, 137053),
(137054, '3.30.310.50-FF-000035', NULL, 'Phosphohexomutase (Phosphoglucomutase / phosphomannomutase)', 86, NULL, NULL, 137054),
(137055, '3.30.160.60-FF-004781', NULL, NULL, 33, NULL, NULL, 137055),
(137056, '3.80.10.10-FF-001662', NULL, 'Immunoglobulin superfamily, member 10', 109, NULL, NULL, 137056),
(137057, '1.20.140.10-FF-000020', NULL, 'Long-chain specific acyl-CoA dehydrogenase, mitochondrial', 144, NULL, NULL, 137057),
(137058, '3.30.40.10-FF-000643', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 120, NULL, NULL, 137058),
(137059, '3.70.10.10-FF-000111', NULL, 'DNA repair protein rad9', 257, NULL, NULL, 137059),
(137060, '2.10.25.10-FF-000072', NULL, 'Low-density lipoprotein receptor-related protein 1B', 45, NULL, NULL, 137060),
(137061, '2.10.70.10-FF-000232', NULL, 'Uncharacterized protein', 64, NULL, NULL, 137061),
(137062, '1.10.510.10-FF-000854', NULL, 'Protein CBG12201', 308, NULL, NULL, 137062),
(137063, '1.25.40.10-FF-003616', NULL, 'Uncharacterized protein', 198, NULL, NULL, 137063),
(137064, '4.10.400.10-FF-000025', NULL, 'Very low density lipoprotein receptor', 36, NULL, NULL, 137064),
(137065, '2.40.170.20-FF-000038', NULL, 'SusC/RagA family TonB-linked outer membrane protein', 544, NULL, NULL, 137065),
(137066, '3.40.120.10-FF-000074', NULL, 'Phosphoglucosamine mutase', 92, NULL, NULL, 137066),
(137067, '1.10.150.50-FF-000124', NULL, 'AGAP009560-PA-like protein', 69, NULL, NULL, 137067),
(137068, '3.30.870.10-FF-000104', NULL, 'Phosphatidylcholine-hydrolyzing phospholipase D (PLD) family', 152, NULL, NULL, 137068),
(137069, '1.10.510.10-FF-002916', NULL, NULL, 137, NULL, NULL, 137069),
(137070, '1.25.40.20-FF-001091', NULL, 'Serine/threonine-protein kinase NEK', 92, NULL, NULL, 137070),
(137071, '3.90.230.10-FF-000059', NULL, NULL, 189, NULL, NULL, 137071),
(137072, '3.30.1010.10-FF-000016', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', 149, NULL, NULL, 137072),
(137073, '3.90.190.10-FF-000235', NULL, 'Protein-tyrosine-phosphatase', 320, NULL, NULL, 137073),
(137074, '3.40.50.150-FF-000655', NULL, 'Protein CBG03740', 199, NULL, NULL, 137074),
(137075, '3.40.50.300-FF-002050', NULL, 'ABC transporter, class F', 240, NULL, NULL, 137075),
(137076, '2.60.120.620-FF-000145', NULL, 'Uncharacterized protein', 134, NULL, NULL, 137076),
(137077, '1.10.630.10-FF-000773', NULL, 'Uncharacterized protein', 169, NULL, NULL, 137077),
(137078, '1.20.120.610-FF-000023', NULL, 'AGAP010692-PA', 44, NULL, NULL, 137078),
(137079, '1.10.287.3700-FF-000003', NULL, 'Pab1p-dependent poly(A) ribonuclease subunit, putative', 88, NULL, NULL, 137079),
(137080, '3.40.50.620-FF-000583', NULL, 'Uncharacterized protein', 124, NULL, NULL, 137080),
(137081, '2.40.30.10-FF-000335', NULL, 'Uncharacterized protein', 67, NULL, NULL, 137081),
(137082, '3.30.160.60-FF-005298', NULL, NULL, 32, NULL, NULL, 137082),
(137083, '1.10.510.10-FF-000146', NULL, 'LRR receptor-like serine/threonine-protein kinase IOS1', 209, NULL, NULL, 137083),
(137084, '2.60.40.10-FF-004685', NULL, NULL, 85, NULL, NULL, 137084),
(137085, '2.60.40.60-FF-000844', NULL, 'Uncharacterized protein', 71, NULL, NULL, 137085),
(137086, '3.40.1110.10-FF-000477', NULL, NULL, 11, NULL, NULL, 137086),
(137087, '1.20.58.400-FF-000023', NULL, 'Uncharacterized protein', 109, NULL, NULL, 137087),
(137088, '1.10.10.10-FF-000118', NULL, '40S ribosomal protein S19', 142, NULL, NULL, 137088),
(137089, '1.10.238.10-FF-000193', NULL, 'EF-hand calcium-binding domain-containing protein 7', 146, NULL, NULL, 137089),
(137090, '1.10.150.20-FF-000020', NULL, 'DNA-directed RNA polymerase subunit alpha', 78, NULL, NULL, 137090),
(137091, '3.30.110.20-FF-000011', NULL, 'RNase MRP subunit', 138, NULL, NULL, 137091),
(137092, '3.30.160.60-FF-002572', NULL, 'Tripartite motif-containing protein 49', 69, NULL, NULL, 137092),
(137093, '2.120.10.30-FF-000538', NULL, 'Flagellum-adhesion glycoprotein', 105, NULL, NULL, 137093),
(137094, '2.30.30.380-FF-000069', NULL, 'Uncharacterized protein', 62, NULL, NULL, 137094);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(137095, '3.40.630.10-FF-000281', NULL, 'Uncharacterized protein', 317, NULL, NULL, 137095),
(137096, '3.10.20.90-FF-000256', NULL, 'Small ubiquitin-related modifier', 97, NULL, NULL, 137096),
(137097, '2.60.120.260-FF-000402', NULL, 'Uncharacterized protein', 158, NULL, NULL, 137097),
(137098, '1.20.58.60-FF-000237', NULL, 'Spectrin repeat containing nuclear envelope family member 3', 184, NULL, NULL, 137098),
(137099, '1.10.510.10-FF-004305', NULL, NULL, 157, NULL, NULL, 137099),
(137100, '1.10.8.270-FF-000172', NULL, 'Small GTPase', 56, NULL, NULL, 137100),
(137101, '1.20.58.390-FF-000334', NULL, 'Uncharacterized protein', 62, NULL, NULL, 137101),
(137102, '2.40.160.110-FF-000033', NULL, 'Uncharacterized protein', 80, NULL, NULL, 137102),
(137103, '3.30.420.10-FF-000380', NULL, NULL, 183, NULL, NULL, 137103),
(137104, '1.10.530.10-FF-000029', NULL, 'Resuscitation-promoting factor RpfA', 97, NULL, NULL, 137104),
(137105, '1.20.1070.10-FF-002008', NULL, 'Uncharacterized protein', 140, NULL, NULL, 137105),
(137106, '1.10.10.60-FF-000083', NULL, 'BEL1-like homeodomain protein 4', 63, NULL, NULL, 137106),
(137107, '1.20.1070.10-FF-001968', NULL, 'Zgc:85942 protein', 183, NULL, NULL, 137107),
(137108, '1.20.120.1530-FF-000014', NULL, NULL, 97, NULL, NULL, 137108),
(137109, '3.60.20.10-FF-000106', NULL, 'Asparagine synthetase', 188, NULL, NULL, 137109),
(137110, '3.40.50.150-FF-001083', NULL, NULL, 234, NULL, NULL, 137110),
(137111, '1.10.1420.10-FF-000211', NULL, 'Uncharacterized protein', 156, NULL, NULL, 137111),
(137112, '1.20.1600.10-FF-000026', NULL, 'Multidrug resistance protein, putative', 328, NULL, NULL, 137112),
(137113, '2.20.70.10-FF-000035', NULL, 'Salvador homolog 1 (Drosophila)', 34, NULL, NULL, 137113),
(137114, '1.20.5.340-FF-000128', NULL, 'Myosin-2 heavy chain', 124, NULL, NULL, 137114),
(137115, '1.25.40.1040-FF-000040', NULL, 'Uncharacterized protein', 426, NULL, NULL, 137115),
(137116, '3.30.1510.10-FF-000009', NULL, 'Formate--tetrahydrofolate ligase', 125, NULL, NULL, 137116),
(137117, '2.40.30.30-FF-000021', NULL, 'Riboflavin kinase', 146, NULL, NULL, 137117),
(137118, '3.30.930.10-FF-000019', NULL, 'Threonine--tRNA ligase', 307, NULL, NULL, 137118),
(137119, '3.50.50.60-FF-001438', NULL, 'Uncharacterized protein', 106, NULL, NULL, 137119),
(137120, '3.40.50.300-FF-006760', NULL, 'Iron (II) transporter (FeoB-2) part 1, conjectural, authentic frameshift', 64, NULL, NULL, 137120),
(137121, '1.10.238.10-FF-000046', NULL, 'intersectin-1 isoform X2', 103, NULL, NULL, 137121),
(137122, '3.90.550.50-FF-000123', NULL, 'Hexosyltransferase', 186, NULL, NULL, 137122),
(137123, '1.10.150.60-FF-000009', NULL, 'AT-rich interactive domain-containing protein 3', 100, NULL, NULL, 137123),
(137124, '1.10.8.720-FF-000059', NULL, 'Dynein heavy chain family protein', 165, NULL, NULL, 137124),
(137125, '2.60.40.10-FF-003201', NULL, 'Uncharacterized protein', 112, NULL, NULL, 137125),
(137126, '3.40.50.300-FF-000925', NULL, 'DNA mismatch repair protein MSH2', 317, NULL, NULL, 137126),
(137127, '1.10.20.10-FF-000147', NULL, 'Histone H3, putative', 77, NULL, NULL, 137127),
(137128, '1.25.40.10-FF-003116', NULL, 'Uncharacterized protein', 134, NULL, NULL, 137128),
(137129, '3.10.450.50-FF-000027', NULL, 'Nuclear transport factor 2 family protein', 138, NULL, NULL, 137129),
(137130, '3.80.10.10-FF-003404', NULL, 'Dynein assembly factor 1, axonemal', 91, NULL, NULL, 137130),
(137131, '3.40.630.30-FF-000287', NULL, 'N(alpha)-acetyltransferase 60, NatF catalytic subunit', 122, NULL, NULL, 137131),
(137132, '2.60.40.10-FF-003196', NULL, 'Immunoglobulin-like domain-containing receptor 2', 119, NULL, NULL, 137132),
(137133, '3.90.1640.10-FF-000039', NULL, 'Mutant prune', 83, NULL, NULL, 137133),
(137134, '3.40.1080.10-FF-000007', NULL, 'Acetate CoA-transferase YdiF', 276, NULL, NULL, 137134),
(137135, '2.130.10.10-FF-002072', NULL, 'WD domain containing protein', 121, NULL, NULL, 137135),
(137136, '1.10.472.10-FF-000517', NULL, 'Predicted protein', 98, NULL, NULL, 137136),
(137137, '3.40.50.2300-FF-001378', NULL, NULL, 131, NULL, NULL, 137137);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(137138, '3.30.70.260-FF-000161', NULL, 'Prephenate dehydratase', 85, NULL, NULL, 137138),
(137139, '3.10.20.90-FF-000784', NULL, 'Predicted protein', 112, NULL, NULL, 137139),
(137140, '2.40.30.130-FF-000054', NULL, 'AGAP006997-PA', 111, NULL, NULL, 137140),
(137141, '1.25.10.10-FF-001962', NULL, 'Serine/threonine-protein kinase TOR', 219, NULL, NULL, 137141),
(137142, '1.20.920.10-FF-000091', NULL, 'DNA-binding bromodomain-containing protein', 122, NULL, NULL, 137142),
(137143, '2.30.31.10-FF-000028', NULL, 'Putative RNA polymerase II transcriptional coactivator', 107, NULL, NULL, 137143),
(137144, '3.60.21.10-FF-000272', NULL, 'Cytochrome c-554', 277, NULL, NULL, 137144),
(137145, '3.10.330.20-FF-000009', NULL, 'tRNA (adenine(58)-N(1))-methyltransferase catalytic subunit TRM61', 71, NULL, NULL, 137145),
(137146, '3.30.200.20-FF-000107', NULL, 'Putative activated CDC42 kinase 1', 94, NULL, NULL, 137146),
(137147, '3.30.70.330-FF-002391', NULL, NULL, 97, NULL, NULL, 137147),
(137148, '3.30.420.390-FF-000015', NULL, NULL, 161, NULL, NULL, 137148),
(137149, '3.40.190.10-FF-000937', NULL, 'Os02g0478525 protein', 34, NULL, NULL, 137149),
(137150, '3.30.420.40-FF-000771', NULL, 'Actin-related protein 7', 118, NULL, NULL, 137150),
(137151, '3.10.580.10-FF-000047', NULL, 'Chloride channel protein', 92, NULL, NULL, 137151),
(137152, '3.40.50.12280-FF-000010', NULL, 'NAD(P)H-quinone oxidoreductase subunit K, chloroplastic', 67, NULL, NULL, 137152),
(137153, '3.80.10.10-FF-003876', NULL, 'Insulin like growth factor binding protein acid labile subunit', 187, NULL, NULL, 137153),
(137154, '3.60.40.10-FF-000164', NULL, 'Response regulator', 171, NULL, NULL, 137154),
(137155, '1.25.40.20-FF-001028', NULL, 'Uncharacterized protein', 67, NULL, NULL, 137155),
(137156, '2.30.30.140-FF-000233', NULL, 'Qin', 76, NULL, NULL, 137156),
(137157, '1.25.40.20-FF-000955', NULL, 'Uncharacterized protein', 116, NULL, NULL, 137157),
(137158, '3.90.228.10-FF-000054', NULL, 'Poly [ADP-ribose] polymerase', 250, NULL, NULL, 137158),
(137159, '2.60.40.60-FF-000405', NULL, 'Si:ch211-186j3.6', 101, NULL, NULL, 137159),
(137160, '2.30.30.30-FF-000162', NULL, 'Predicted protein', 86, NULL, NULL, 137160),
(137161, '1.10.150.40-FF-000003', NULL, 'Barrier-to-autointegration factor B', 88, NULL, NULL, 137161),
(137162, '3.90.70.10-FF-000838', NULL, 'Uncharacterized protein', 136, NULL, NULL, 137162),
(137163, '1.10.8.270-FF-000109', NULL, 'Uncharacterized protein', 127, NULL, NULL, 137163),
(137164, '2.170.150.80-FF-000013', NULL, 'BnaC01g09890D protein', 156, NULL, NULL, 137164),
(137165, '3.30.1150.10-FF-000026', NULL, NULL, 96, NULL, NULL, 137165),
(137166, '3.30.160.60-FF-001228', NULL, 'Zinc finger protein 236', 27, NULL, NULL, 137166),
(137167, '3.30.110.170-FF-000003', NULL, 'Interleukin-1 receptor-associated kinase 1-binding protein 1 homolog', 56, NULL, NULL, 137167),
(137168, '3.90.550.50-FF-000067', NULL, 'Hexosyltransferase', 249, NULL, NULL, 137168),
(137169, '3.30.160.60-FF-000891', NULL, 'Zinc finger protein 142', 30, NULL, NULL, 137169),
(137170, '3.20.20.140-FF-000443', NULL, 'Predicted protein', 82, NULL, NULL, 137170),
(137171, '3.30.1490.150-FF-000001', NULL, 'AMME syndrome candidate gene 1 protein', 76, NULL, NULL, 137171),
(137172, '3.20.20.140-FF-000387', NULL, 'Uncharacterized protein', 172, NULL, NULL, 137172),
(137173, '2.60.40.10-FF-004185', NULL, NULL, 84, NULL, NULL, 137173),
(137174, '2.60.40.150-FF-000411', NULL, 'Putative ca2+-dependent phospholipid-binding protein synaptotagmin', 156, NULL, NULL, 137174),
(137175, '1.10.437.10-FF-000003', NULL, 'Bcl-2-like protein 1', 203, NULL, NULL, 137175),
(137176, '3.40.50.150-FF-000571', NULL, 'Methyltransferase, putative', 207, NULL, NULL, 137176),
(137177, '3.40.850.10-FF-000168', NULL, 'Kinesin-like protein', 356, NULL, NULL, 137177),
(137178, '3.40.630.30-FF-000343', NULL, 'Uncharacterized protein', 151, NULL, NULL, 137178),
(137179, '1.10.510.10-FF-003052', NULL, NULL, 210, NULL, NULL, 137179),
(137180, '3.30.9.10-FF-000087', NULL, 'FAD dependent oxidoreductase', 145, NULL, NULL, 137180);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(137181, '1.10.510.10-FF-001074', NULL, 'Putative serine/threonine-protein kinase Nek3', 182, NULL, NULL, 137181),
(137182, '1.10.357.10-FF-000002', NULL, 'Nucleoid occlusion factor SlmA', 190, NULL, NULL, 137182),
(137183, '3.30.420.10-FF-000756', NULL, NULL, 191, NULL, NULL, 137183),
(137184, '1.25.40.10-FF-001790', NULL, 'Putative pentatricopeptide repeat-containing protein At2g01510', 133, NULL, NULL, 137184),
(137185, '3.30.160.60-FF-003589', NULL, NULL, 31, NULL, NULL, 137185),
(137186, '3.30.70.590-FF-000001', NULL, 'Putative poly(A) polymerase gamma', 123, NULL, NULL, 137186),
(137187, '3.40.50.11040-FF-000003', NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', 191, NULL, NULL, 137187),
(137188, '3.10.20.90-FF-000312', NULL, 'E3 ubiquitin-protein ligase UPL5', 87, NULL, NULL, 137188),
(137189, '2.10.25.10-FF-001206', NULL, 'Uncharacterized protein', 45, NULL, NULL, 137189),
(137190, '1.20.1270.280-FF-000043', NULL, 'Dynein heavy chain', 207, NULL, NULL, 137190),
(137191, '1.25.10.10-FF-000181', NULL, 'Nipped-B protein', 157, NULL, NULL, 137191),
(137192, '1.10.150.50-FF-000208', NULL, 'Fli-1 proto-oncogene, ETS transcription factor a', 54, NULL, NULL, 137192),
(137193, '1.10.1370.30-FF-000044', NULL, 'Angiotensin-converting enzyme', 140, NULL, NULL, 137193),
(137194, '1.10.10.10-FF-000326', NULL, 'DEP domain-containing protein 7', 109, NULL, NULL, 137194),
(137195, '3.10.50.10-FF-000043', NULL, 'Di-N-acetylchitobiase', 77, NULL, NULL, 137195),
(137196, '2.10.25.10-FF-001589', NULL, 'Uncharacterized protein', 28, NULL, NULL, 137196),
(137197, '3.80.10.10-FF-002943', NULL, 'Receptor protein-tyrosine kinase CEPR2', 65, NULL, NULL, 137197),
(137198, '1.20.1070.10-FF-002160', NULL, 'Uncharacterized protein', 144, NULL, NULL, 137198),
(137199, '3.30.450.40-FF-000160', NULL, 'Sensory transduction histidine kinase', 208, NULL, NULL, 137199),
(137200, '3.40.960.10-FF-000002', NULL, 'DNA helicase related protein', 106, NULL, NULL, 137200),
(137201, '3.40.50.1820-FF-000048', NULL, 'Protein phosphatase methylesterase 1', 316, NULL, NULL, 137201),
(137202, '3.30.160.60-FF-005562', NULL, NULL, 63, NULL, NULL, 137202),
(137203, '3.40.1110.10-FF-000393', NULL, NULL, 108, NULL, NULL, 137203),
(137204, '2.60.40.10-FF-004977', NULL, NULL, 109, NULL, NULL, 137204),
(137205, '2.60.40.60-FF-000788', NULL, 'Uncharacterized protein', 104, NULL, NULL, 137205),
(137206, '1.10.357.30-FF-000008', NULL, 'Exocyst complex component SEC15', 183, NULL, NULL, 137206),
(137207, '3.40.50.300-FF-004343', NULL, 'ABC transporter releated protein', 248, NULL, NULL, 137207),
(137208, '3.40.190.10-FF-000584', NULL, 'ABC transporter substrate-binding protein', 91, NULL, NULL, 137208),
(137209, '3.30.420.80-FF-000024', NULL, 'Uncharacterized protein', 124, NULL, NULL, 137209),
(137210, '3.40.50.300-FF-002903', NULL, 'ABC transporter, ATP-binding protein', 241, NULL, NULL, 137210),
(137211, '1.25.10.10-FF-001170', NULL, 'Protein SWEETIE', 188, NULL, NULL, 137211),
(137212, '1.20.5.170-FF-000055', NULL, 'CCAAT/enhancer-binding protein gamma', 75, NULL, NULL, 137212),
(137213, '1.25.40.10-FF-005005', NULL, 'Tetratricopeptide repeat domain 28', 123, NULL, NULL, 137213),
(137214, '1.10.3710.10-FF-000014', NULL, 'ATPase WRNIP1', 113, NULL, NULL, 137214),
(137215, '2.40.340.10-FF-000009', NULL, 'Molybdopterin molybdenumtransferase', 59, NULL, NULL, 137215),
(137216, '1.20.144.10-FF-000141', NULL, 'Probable diacylglycerol pyrophosphate phosphatase 1', 252, NULL, NULL, 137216),
(137217, '2.60.40.10-FF-005141', NULL, NULL, 96, NULL, NULL, 137217),
(137218, '2.70.10.10-FF-000001', NULL, 'Hirudin variant-1', 65, NULL, NULL, 137218),
(137219, '3.80.10.10-FF-002415', NULL, 'Si:ch211-236p5.2', 242, NULL, NULL, 137219),
(137220, '3.30.70.20-FF-000097', NULL, NULL, 60, NULL, NULL, 137220),
(137221, '1.20.1530.20-FF-000063', NULL, 'Sodium/hydrogen exchanger family-domain-containing protein', 251, NULL, NULL, 137221),
(137222, '3.90.1150.10-FF-000344', NULL, 'Uncharacterized protein', 111, NULL, NULL, 137222),
(137223, '1.10.287.110-FF-000190', NULL, 'DnaJ domain containing protein, putative', 85, NULL, NULL, 137223);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(137224, '3.90.1420.10-FF-000028', NULL, 'Uncharacterized protein', 153, NULL, NULL, 137224),
(137225, '2.40.50.100-FF-000144', NULL, 'ABC transporter ATP-binding protein', 50, NULL, NULL, 137225),
(137226, '3.40.50.10130-FF-000062', NULL, 'Uncharacterized protein', 126, NULL, NULL, 137226),
(137227, '3.30.160.60-FF-003117', NULL, 'Si:ch73-120g24.4', 30, NULL, NULL, 137227),
(137228, '2.120.10.80-FF-000356', NULL, 'Peptidase S8 and S53 subtilisin kexin sedolisin', 298, NULL, NULL, 137228),
(137229, '3.40.50.2020-FF-000159', NULL, 'Uncharacterized protein', 89, NULL, NULL, 137229),
(137230, '2.60.40.150-FF-000759', NULL, 'Uncharacterized protein', 135, NULL, NULL, 137230),
(137231, '3.90.25.10-FF-000026', NULL, 'GDP-mannose 4,6-dehydratase', 81, NULL, NULL, 137231),
(137232, '2.40.10.10-FF-000249', NULL, 'Zgc:100868', 222, NULL, NULL, 137232),
(137233, '3.30.470.30-FF-000097', NULL, 'Uncharacterized protein', 55, NULL, NULL, 137233),
(137234, '3.40.50.720-FF-001799', NULL, 'Uncharacterized protein', 74, NULL, NULL, 137234),
(137235, '3.30.160.60-FF-000716', NULL, 'MDS1 and EVI1 complex locus protein isoform X1', 26, NULL, NULL, 137235),
(137236, '3.30.160.60-FF-001291', NULL, 'Zinc finger protein 354C', 30, NULL, NULL, 137236),
(137237, '2.40.50.1000-FF-000005', NULL, '30S ribosomal protein S17', 111, NULL, NULL, 137237),
(137238, '3.50.50.60-FF-000152', NULL, 'Oxidative stress-induced growth inhibitor 1', 348, NULL, NULL, 137238),
(137239, '2.10.22.10-FF-000008', NULL, NULL, 42, NULL, NULL, 137239),
(137240, '3.20.20.80-FF-000314', NULL, 'Alpha amylase catalytic region', 368, NULL, NULL, 137240),
(137241, '3.30.830.10-FF-000135', NULL, 'Metallo-peptidase, Clan ME, Family M16', 209, NULL, NULL, 137241),
(137242, '3.30.870.10-FF-000076', NULL, 'Phospholipase D, putative', 147, NULL, NULL, 137242),
(137243, '3.30.70.2750-FF-000004', NULL, 'V-type ATP synthase subunit I', 76, NULL, NULL, 137243),
(137244, '1.10.10.10-FF-000798', NULL, 'Protein nirG', 53, NULL, NULL, 137244),
(137245, '1.10.510.10-FF-000938', NULL, 'eIF-2-alpha kinase GCN2', 246, NULL, NULL, 137245),
(137246, '3.15.20.10-FF-000008', NULL, 'Cholesteryl ester transfer protein', 184, NULL, NULL, 137246),
(137247, '2.10.90.10-FF-000059', NULL, 'CRE-TIG-2 protein', 113, NULL, NULL, 137247),
(137248, '3.40.50.300-FF-003415', NULL, 'Dynein heavy chain', 147, NULL, NULL, 137248),
(137249, '3.40.50.880-FF-000166', NULL, 'Predicted protein', 128, NULL, NULL, 137249),
(137250, '1.10.287.130-FF-000196', NULL, 'Histidine kinase', 68, NULL, NULL, 137250),
(137251, '3.40.190.10-FF-000201', NULL, 'HTH-type transcriptional regulator xapR', 103, NULL, NULL, 137251),
(137252, '3.30.70.330-FF-001755', NULL, NULL, 87, NULL, NULL, 137252),
(137253, '1.25.40.10-FF-002127', NULL, 'Pentatricopeptide repeat-containing protein At4g21705, mitochondrial', 107, NULL, NULL, 137253),
(137254, '1.10.390.10-FF-000057', NULL, 'Transcription initiation factor TFIID subunit 2', 274, NULL, NULL, 137254),
(137255, '3.30.750.24-FF-000047', NULL, 'Prestin-like Protein', 157, NULL, NULL, 137255),
(137256, '3.90.226.10-FF-000336', NULL, 'Predicted protein', 57, NULL, NULL, 137256),
(137257, '1.25.40.10-FF-003908', NULL, 'Uncharacterized protein', 55, NULL, NULL, 137257),
(137258, '3.40.50.620-FF-000611', NULL, 'Arginyl-tRNA synthetase', 237, NULL, NULL, 137258),
(137259, '2.130.10.10-FF-000094', NULL, 'WD repeat-containing protein 61', 301, NULL, NULL, 137259),
(137260, '2.10.70.10-FF-000176', NULL, 'C-type LECtin', 55, NULL, NULL, 137260),
(137261, '2.10.50.10-FF-000169', NULL, 'Neurotrophin receptor-associated death domain', 35, NULL, NULL, 137261),
(137262, '3.40.50.360-FF-000100', NULL, 'NADPH-dependent diflavin oxidoreductase 1', 161, NULL, NULL, 137262),
(137263, '3.30.559.10-FF-000049', NULL, 'Choline O-acetyltransferase, putative', 265, NULL, NULL, 137263),
(137264, '2.130.10.130-FF-000062', NULL, NULL, 374, NULL, NULL, 137264),
(137265, '1.10.533.10-FF-000159', NULL, 'Predicted protein', 23, NULL, NULL, 137265),
(137266, '2.30.29.30-FF-001350', NULL, 'Predicted protein', 138, NULL, NULL, 137266);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(137267, '3.10.129.10-FF-000162', NULL, 'PaaI family thioesterase', 138, NULL, NULL, 137267),
(137268, '1.50.40.10-FF-000118', NULL, 'Mitochondrial glycine transporter', 146, NULL, NULL, 137268),
(137269, '3.80.10.10-FF-002095', NULL, 'Uncharacterized protein', 174, NULL, NULL, 137269),
(137270, '3.30.1370.70-FF-000004', NULL, 'HIRA-interacting protein 5, putative', 109, NULL, NULL, 137270),
(137271, '3.40.50.1440-FF-000030', NULL, 'tubulin beta chain isoform X5', 117, NULL, NULL, 137271),
(137272, '1.20.1580.10-FF-000001', NULL, 'UvrABC system protein A', 170, NULL, NULL, 137272),
(137273, '3.40.50.150-FF-000947', NULL, 'Trans-aconitate 3-methyltransferase, putative', 351, NULL, NULL, 137273),
(137274, '2.30.29.30-FF-000714', NULL, 'Growth factor receptor-bound protein 14', 162, NULL, NULL, 137274),
(137275, '1.10.287.370-FF-000037', NULL, 'Prefoldin subunit 2', 106, NULL, NULL, 137275),
(137276, '3.40.50.300-FF-000009', NULL, 'CTP synthase', 287, NULL, NULL, 137276),
(137277, '2.130.10.10-FF-003325', NULL, 'Uncharacterized protein', 107, NULL, NULL, 137277),
(137278, '3.80.10.10-FF-001459', NULL, 'Leucine-rich repeat protein (LRRP), putative', 100, NULL, NULL, 137278),
(137279, '1.10.150.670-FF-000021', NULL, 'crossover junction endonuclease MUS81', 81, NULL, NULL, 137279),
(137280, '1.20.1250.20-FF-000018', NULL, 'MFS transporter permease', 207, NULL, NULL, 137280),
(137281, '2.40.50.690-FF-000034', NULL, 'Predicted protein', 97, NULL, NULL, 137281),
(137282, '3.30.1370.110-FF-000030', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', 52, NULL, NULL, 137282),
(137283, '3.30.390.150-FF-000002', NULL, 'BRICHOS domain containing 5', 104, NULL, NULL, 137283),
(137284, '1.10.287.4070-FF-000002', NULL, 'Nucleolar protein 56', 159, NULL, NULL, 137284),
(137285, '1.25.40.10-FF-003588', NULL, 'Transcriptional regulator', 160, NULL, NULL, 137285),
(137286, '3.30.450.20-FF-000238', NULL, 'Uncharacterized protein', 115, NULL, NULL, 137286),
(137287, '2.60.40.1910-FF-000043', NULL, NULL, 72, NULL, NULL, 137287),
(137288, '3.30.160.60-FF-004578', NULL, NULL, 81, NULL, NULL, 137288),
(137289, '3.40.30.10-FF-001142', NULL, 'Uncharacterized protein', 57, NULL, NULL, 137289),
(137290, '3.40.1280.10-FF-000051', NULL, 'RNA methyltransferase trmh family putative', 164, NULL, NULL, 137290),
(137291, '2.60.260.20-FF-000086', NULL, 'Chaperone protein DnaJ', 105, NULL, NULL, 137291),
(137292, '3.10.450.240-FF-000026', NULL, 'Uncharacterized protein', 167, NULL, NULL, 137292),
(137293, '1.10.510.10-FF-000562', NULL, 'Serine/threonine-protein kinase bur1', 246, NULL, NULL, 137293),
(137294, '4.10.60.10-FF-000182', NULL, 'Ribosomal L28e protein family', 26, NULL, NULL, 137294),
(137295, '3.30.565.10-FF-000142', NULL, 'Pkp1p', 176, NULL, NULL, 137295),
(137296, '3.80.10.10-FF-004040', NULL, 'Uncharacterized protein', 143, NULL, NULL, 137296),
(137297, '1.20.1050.10-FF-000124', NULL, 'Uncharacterized protein', 108, NULL, NULL, 137297),
(137298, '2.40.100.10-FF-000110', NULL, 'Cyclophilin-type peptidyl-prolyl cis-trans isomerase, putative', 199, NULL, NULL, 137298),
(137299, '2.40.10.480-FF-000008', NULL, 'Cell surface protein', 81, NULL, NULL, 137299),
(137300, '1.10.340.30-FF-000032', NULL, 'Adenine DNA glycosylase', 95, NULL, NULL, 137300),
(137301, '3.30.300.30-FF-000023', NULL, 'Uncharacterized protein, isoform B', 138, NULL, NULL, 137301),
(137302, '1.20.1250.20-FF-001923', NULL, 'AGAP000046-PA', 220, NULL, NULL, 137302),
(137303, '3.30.160.60-FF-002780', NULL, 'Protein CBR-EOR-1', 29, NULL, NULL, 137303),
(137304, '1.20.142.10-FF-000007', NULL, 'Poly [ADP-ribose] polymerase', 142, NULL, NULL, 137304),
(137305, '2.60.260.20-FF-000114', NULL, 'DNAJB1 isoform 4', 41, NULL, NULL, 137305),
(137306, '2.60.40.10-FF-002268', NULL, 'Myotactin form A', 94, NULL, NULL, 137306),
(137307, '1.10.730.10-FF-000073', NULL, 'Isoleucine--tRNA ligase, cytoplasmic', 192, NULL, NULL, 137307),
(137308, '3.40.50.150-FF-000099', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', 165, NULL, NULL, 137308);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(137309, '1.10.287.690-FF-000015', NULL, 'DNA polymerase', 59, NULL, NULL, 137309),
(137310, '1.10.8.870-FF-000020', NULL, 'Aerobic glycerol-3-phosphate dehydrogenase', 112, NULL, NULL, 137310),
(137311, '1.10.287.110-FF-000038', NULL, 'DnaJ protein ERDJ2A', 83, NULL, NULL, 137311),
(137312, '2.60.40.150-FF-000091', NULL, 'Extended synaptotagmin 2', 150, NULL, NULL, 137312),
(137313, '3.40.50.150-FF-000155', NULL, 'Probable methyltransferase-like protein 15', 207, NULL, NULL, 137313),
(137314, '3.50.50.60-FF-000949', NULL, 'Uncharacterized protein', 213, NULL, NULL, 137314),
(137315, '2.30.42.10-FF-000256', NULL, 'Protease Do-like 9', 109, NULL, NULL, 137315),
(137316, '1.20.1250.20-FF-000434', NULL, 'Blast:Monocarboxylate transporter 4', 205, NULL, NULL, 137316),
(137317, '3.40.30.10-FF-000029', NULL, 'protein disulfide-isomerase A5 isoform X2', 124, NULL, NULL, 137317),
(137318, '3.30.70.330-FF-001278', NULL, 'RNA recognition motif domain containing protein', 85, NULL, NULL, 137318),
(137319, '3.30.160.60-FF-002633', NULL, 'Zinc finger protein 57', 27, NULL, NULL, 137319),
(137320, '1.10.8.10-FF-000286', NULL, 'Vacuolar protein sorting-associated protein 13D', 76, NULL, NULL, 137320),
(137321, '3.20.20.70-FF-000457', NULL, 'Uncharacterized protein', 158, NULL, NULL, 137321),
(137322, '3.40.50.10420-FF-000025', NULL, '5-formyltetrahydrofolate cyclo-ligase', 199, NULL, NULL, 137322),
(137323, '2.10.80.10-FF-000002', NULL, 'prokineticin-2 isoform X2', 99, NULL, NULL, 137323),
(137324, '3.30.2130.30-FF-000003', NULL, 'Probable tRNA sulfurtransferase', 175, NULL, NULL, 137324),
(137325, '1.20.1250.20-FF-002379', NULL, 'Solute carrier organic anion transporter family member', 211, NULL, NULL, 137325),
(137326, '1.10.287.4280-FF-000003', NULL, 'Transcription factor COE2', 43, NULL, NULL, 137326),
(137327, '3.90.940.10-FF-000006', NULL, 'DNA-directed RNA polymerase subunit I, putative', 146, NULL, NULL, 137327),
(137328, '3.30.465.10-FF-000106', NULL, 'Uncharacterized protein', 221, NULL, NULL, 137328),
(137329, '2.60.120.200-FF-000514', NULL, 'Beta-glycan assembly-like protein', 291, NULL, NULL, 137329),
(137330, '1.50.10.20-FF-000119', NULL, 'Uncharacterized protein', 106, NULL, NULL, 137330),
(137331, '3.40.50.720-FF-000787', NULL, 'L-2-aminoadipate reductase', 415, NULL, NULL, 137331),
(137332, '1.25.40.10-FF-004044', NULL, 'Uncharacterized protein', 175, NULL, NULL, 137332),
(137333, '3.40.50.12780-FF-000070', NULL, 'YOR093C-like protein', 169, NULL, NULL, 137333),
(137334, '3.10.170.20-FF-000007', NULL, 'Leishmanolysin-like peptidase', 192, NULL, NULL, 137334),
(137335, '3.90.1100.10-FF-000009', NULL, 'DNA-directed RNA polymerase subunit beta', 160, NULL, NULL, 137335),
(137336, '3.40.1810.10-FF-000070', NULL, NULL, 103, NULL, NULL, 137336),
(137337, '3.40.1000.50-FF-000020', NULL, 'Transcription regulator', 77, NULL, NULL, 137337),
(137338, '3.30.70.330-FF-002767', NULL, NULL, 77, NULL, NULL, 137338),
(137339, '3.40.50.150-FF-001875', NULL, NULL, 228, NULL, NULL, 137339),
(137340, '3.30.830.10-FF-000130', NULL, 'Protease, insulinase family/protease, insulinase family', 197, NULL, NULL, 137340),
(137341, '2.60.40.60-FF-000821', NULL, 'Uncharacterized protein', 63, NULL, NULL, 137341),
(137342, '3.40.50.300-FF-006288', NULL, 'Elongation factor G, mitochondrial', 243, NULL, NULL, 137342),
(137343, '3.30.160.60-FF-004573', NULL, NULL, 28, NULL, NULL, 137343),
(137344, '3.30.70.2130-FF-000003', NULL, 'Phosphoglycerate mutase, 2,3-bisphosphoglycerate-independent, putative', 99, NULL, NULL, 137344),
(137345, '1.10.472.10-FF-000253', NULL, 'Uncharacterized protein', 108, NULL, NULL, 137345),
(137346, '1.10.287.70-FF-000060', NULL, 'Sodium leak channel non-selective protein', 131, NULL, NULL, 137346),
(137347, '2.60.120.200-FF-000019', NULL, 'MAM domain containing glycosylphosphatidylinositol anchor 2', 183, NULL, NULL, 137347),
(137348, '1.25.40.20-FF-001444', NULL, 'Uncharacterized protein', 141, NULL, NULL, 137348),
(137349, '3.30.420.40-FF-000299', NULL, 'Actin-related protein 3C', 12, NULL, NULL, 137349);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(137350, '3.10.100.10-FF-000023', NULL, 'Macrophage mannose receptor 1', 129, NULL, NULL, 137350),
(137351, '3.30.2260.10-FF-000001', NULL, 'Enhancer of rudimentary homolog', 104, NULL, NULL, 137351),
(137352, '3.20.20.80-FF-000258', NULL, 'Endo-1,4-beta-xylanase A', 315, NULL, NULL, 137352),
(137353, '2.60.40.150-FF-000383', NULL, 'Helicase', 114, NULL, NULL, 137353),
(137354, '2.30.30.10-FF-000004', NULL, 'Pol polyprotein', 58, NULL, NULL, 137354),
(137355, '3.30.420.80-FF-000029', NULL, 'Uncharacterized protein', 97, NULL, NULL, 137355),
(137356, '3.40.367.20-FF-000008', NULL, 'Phosphotransferase', 228, NULL, NULL, 137356),
(137357, '2.40.30.30-FF-000026', NULL, 'Riboflavin biosynthesis protein', 134, NULL, NULL, 137357),
(137358, '3.30.2340.10-FF-000002', NULL, 'tRNA pseudouridine synthase D', 50, NULL, NULL, 137358),
(137359, '1.10.565.10-FF-000025', NULL, 'Nuclear receptor subfamily 1 group I member 3', 241, NULL, NULL, 137359),
(137360, '2.60.200.20-FF-000138', NULL, 'Adenylyl cyclase class-3/4/guanylyl cyclase', 103, NULL, NULL, 137360),
(137361, '2.160.10.10-FF-000087', NULL, 'Uncharacterized protein', 73, NULL, NULL, 137361),
(137362, '2.60.40.10-FF-006074', NULL, NULL, 88, NULL, NULL, 137362),
(137363, '3.40.50.2000-FF-001086', NULL, 'Soluble starch synthase', 108, NULL, NULL, 137363),
(137364, '3.40.50.300-FF-003831', NULL, 'DNA helicase INO80', 137, NULL, NULL, 137364),
(137365, '1.10.30.10-FF-000092', NULL, 'High mobility group B protein 13', 95, NULL, NULL, 137365),
(137366, '3.40.630.20-FF-000014', NULL, 'Pyroglutamyl-peptidase I', 194, NULL, NULL, 137366),
(137367, '1.10.287.110-FF-000010', NULL, 'Molecular chaperone DnaJ', 110, NULL, NULL, 137367),
(137368, '3.90.70.10-FF-000041', NULL, 'Inactive ubiquitin carboxyl-terminal hydrolase 53', 325, NULL, NULL, 137368),
(137369, '3.90.640.10-FF-000017', NULL, 'Actin-related protein 10 homolog', 112, NULL, NULL, 137369),
(137370, '3.30.70.270-FF-000254', NULL, NULL, 57, NULL, NULL, 137370),
(137371, '1.10.1450.10-FF-000095', NULL, 'Tetraspanin', 99, NULL, NULL, 137371),
(137372, '2.40.10.10-FF-000688', NULL, NULL, 38, NULL, NULL, 137372),
(137373, '1.25.40.180-FF-000228', NULL, NULL, 112, NULL, NULL, 137373),
(137374, '3.80.10.10-FF-000150', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 185, NULL, NULL, 137374),
(137375, '1.25.40.530-FF-000002', NULL, 'Unconventional myosin-VIIa', 232, NULL, NULL, 137375),
(137376, '2.60.40.150-FF-000467', NULL, 'Phosphatidylserine decarboxylase proenzyme 2', 131, NULL, NULL, 137376),
(137377, '1.25.40.10-FF-000334', NULL, 'Pentatricopeptide repeat-containing protein', 211, NULL, NULL, 137377),
(137378, '1.25.40.20-FF-001500', NULL, 'Uncharacterized protein', 56, NULL, NULL, 137378),
(137379, '2.40.70.10-FF-000225', NULL, 'Predicted protein', 189, NULL, NULL, 137379),
(137380, '1.10.510.10-FF-002068', NULL, 'Protein kinase, putative', 215, NULL, NULL, 137380),
(137381, '1.10.287.130-FF-000016', NULL, 'Aerobic respiration control sensor protein', 79, NULL, NULL, 137381),
(137382, '3.30.505.10-FF-000133', NULL, 'Tyrosine-protein kinase', 80, NULL, NULL, 137382),
(137383, '3.30.505.10-FF-000077', NULL, 'Tyrosine-protein kinase Lck', 104, NULL, NULL, 137383),
(137384, '3.30.1600.10-FF-000011', NULL, 'NAD-dependent protein deacylase', 99, NULL, NULL, 137384),
(137385, '1.10.10.10-FF-001815', NULL, 'Catabolite gene activator', 72, NULL, NULL, 137385),
(137386, '1.20.1280.50-FF-000097', NULL, 'Mitochondria-associated F-box protein', 106, NULL, NULL, 137386),
(137387, '1.10.510.10-FF-002416', NULL, NULL, 175, NULL, NULL, 137387),
(137388, '1.10.287.130-FF-000201', NULL, 'Phosphate regulon sensor protein PhoR (SphS)', 78, NULL, NULL, 137388),
(137389, '2.10.110.10-FF-000090', NULL, 'LIM domain kinase 2', 64, NULL, NULL, 137389),
(137390, '3.30.230.10-FF-000106', NULL, 'Ribonuclease P protein component', 111, NULL, NULL, 137390),
(137391, '2.30.30.140-FF-000289', NULL, 'Uncharacterized protein', 87, NULL, NULL, 137391),
(137392, '3.20.20.210-FF-000020', NULL, 'Uroporphyrinogen decarboxylase 1, chloroplastic', 188, NULL, NULL, 137392);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(137393, '3.80.10.10-FF-003399', NULL, 'Predicted protein', 95, NULL, NULL, 137393),
(137394, '2.170.140.10-FF-000008', NULL, 'Gasp, isoform B', 65, NULL, NULL, 137394),
(137395, '1.10.238.10-FF-000018', NULL, 'Actinin, alpha 1', 78, NULL, NULL, 137395),
(137396, '2.130.10.10-FF-001583', NULL, 'Autophagy-related protein 18a', 106, NULL, NULL, 137396),
(137397, '3.30.60.30-FF-000184', NULL, 'Follistatin-like 3 (secreted glycoprotein)', 37, NULL, NULL, 137397),
(137398, '3.40.50.10130-FF-000067', NULL, 'Uncharacterized protein', 86, NULL, NULL, 137398),
(137399, '2.60.120.330-FF-000210', NULL, 'Uncharacterized protein', 117, NULL, NULL, 137399),
(137400, '3.30.160.60-FF-003645', NULL, 'LD40944p', 61, NULL, NULL, 137400),
(137401, '1.10.472.10-FF-000197', NULL, 'Transcription initiation factor IIB', 112, NULL, NULL, 137401),
(137402, '1.10.10.10-FF-001490', NULL, 'Uncharacterized protein', 93, NULL, NULL, 137402),
(137403, '3.60.10.10-FF-000336', NULL, 'Uncharacterized protein', 227, NULL, NULL, 137403),
(137404, '1.10.287.3510-FF-000008', NULL, 'NADH dehydrogenase subunit 4L', 76, NULL, NULL, 137404),
(137405, '2.60.40.820-FF-000039', NULL, 'Protein CBR-WHT-8', 180, NULL, NULL, 137405),
(137406, '2.60.40.1180-FF-000195', NULL, 'Alpha-amylase SusG', 92, NULL, NULL, 137406),
(137407, '3.30.40.10-FF-001901', NULL, 'Uncharacterized protein', 73, NULL, NULL, 137407),
(137408, '3.80.10.10-FF-004332', NULL, 'Uncharacterized protein', 195, NULL, NULL, 137408),
(137409, '3.40.50.360-FF-000044', NULL, 'Protein NrdI', 130, NULL, NULL, 137409),
(137410, '1.10.238.10-FF-001002', NULL, 'Phosphoinositide phospholipase C', 49, NULL, NULL, 137410),
(137411, '3.90.180.10-FF-000122', NULL, 'Lovastatin nonaketide synthase, enoyl reductase component', 137, NULL, NULL, 137411),
(137412, '3.40.710.10-FF-000102', NULL, 'Membrane carboxypeptidase/penicillin-binding protein', 80, NULL, NULL, 137412),
(137413, '3.30.2380.10-FF-000004', NULL, 'EKC/KEOPS complex subunit CGI121', 181, NULL, NULL, 137413),
(137414, '1.25.40.420-FF-000025', NULL, 'Leucine-zipper-like transcription regulator 1', 67, NULL, NULL, 137414),
(137415, '3.80.10.10-FF-003932', NULL, 'Predicted protein', 93, NULL, NULL, 137415),
(137416, '3.30.70.330-FF-002211', NULL, NULL, 103, NULL, NULL, 137416),
(137417, '1.10.533.10-FF-000215', NULL, 'Uncharacterized protein', 102, NULL, NULL, 137417),
(137418, '1.20.1070.10-FF-000479', NULL, 'Uncharacterized protein, isoform A', 353, NULL, NULL, 137418),
(137419, '3.30.70.330-FF-002239', NULL, NULL, 108, NULL, NULL, 137419),
(137420, '3.30.1520.10-FF-000010', NULL, 'PX domain-containing protein kinase-like protein isoform X6', 122, NULL, NULL, 137420),
(137421, '1.25.40.10-FF-002099', NULL, 'Uncharacterized protein', 121, NULL, NULL, 137421),
(137422, '2.60.120.260-FF-000397', NULL, 'E3 ubiquitin-protein ligase HERC2', 160, NULL, NULL, 137422),
(137423, '3.30.70.980-FF-000051', NULL, 'Mitochondrion protein, putative', 84, NULL, NULL, 137423),
(137424, '1.20.1740.10-FF-000160', NULL, 'Amino acid permease family protein', 438, NULL, NULL, 137424),
(137425, '3.30.710.10-FF-000508', NULL, 'Predicted protein', 104, NULL, NULL, 137425),
(137426, '3.30.70.330-FF-001839', NULL, NULL, 117, NULL, NULL, 137426),
(137427, '3.30.420.110-FF-000033', NULL, 'DNA mismatch repair protein MutS', 122, NULL, NULL, 137427),
(137428, '3.30.230.10-FF-000073', NULL, 'DNA gyrase subunit B', 173, NULL, NULL, 137428),
(137429, '1.10.287.70-FF-000144', NULL, 'Calcium-activated potassium channel slo-1', 119, NULL, NULL, 137429),
(137430, '2.60.40.4060-FF-000014', NULL, 'Uncharacterized protein', 137, NULL, NULL, 137430),
(137431, '2.60.40.10-FF-005146', NULL, NULL, 95, NULL, NULL, 137431),
(137432, '3.90.640.10-FF-000080', NULL, 'Actin-like protein, putative', 47, NULL, NULL, 137432),
(137433, '2.40.50.140-FF-000364', NULL, 'Putative Aspartyl-tRNA synthetase', 136, NULL, NULL, 137433),
(137434, '3.30.60.30-FF-000037', NULL, 'Ovomucoid', 56, NULL, NULL, 137434),
(137435, '1.10.3080.10-FF-000078', NULL, 'Predicted protein', 133, NULL, NULL, 137435);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(137436, '3.40.50.1000-FF-000426', NULL, 'GD13364', 145, NULL, NULL, 137436),
(137437, '1.10.10.10-FF-000854', NULL, 'MarR family transcriptional regulator', 145, NULL, NULL, 137437),
(137438, '3.40.250.10-FF-000111', NULL, 'Si:dkey-175m17.7', 145, NULL, NULL, 137438),
(137439, '3.40.50.300-FF-008502', NULL, 'Uncharacterized protein', 282, NULL, NULL, 137439),
(137440, '3.30.70.240-FF-000003', NULL, 'Translation elongation factor 2', 121, NULL, NULL, 137440),
(137441, '3.80.10.10-FF-000526', NULL, 'Thyroid stimulating hormone receptor', 227, NULL, NULL, 137441),
(137442, '3.40.630.10-FF-000129', NULL, 'Putative aminoacyl-histidine dipeptidase', 229, NULL, NULL, 137442),
(137443, '3.80.10.10-FF-002948', NULL, 'Uncharacterized protein', 135, NULL, NULL, 137443),
(137444, '3.20.20.80-FF-000786', NULL, 'Glycosyl hydrolase-like protein', 193, NULL, NULL, 137444),
(137445, '2.30.30.30-FF-000015', NULL, 'E3 ubiquitin-protein ligase HERC2', 82, NULL, NULL, 137445),
(137446, '1.25.70.10-FF-000015', NULL, 'Mitochondrial transcription termination factor family protein', 214, NULL, NULL, 137446),
(137447, '2.130.10.10-FF-003033', NULL, 'Protein NEDD1', 156, NULL, NULL, 137447),
(137448, '1.25.40.20-FF-000516', NULL, 'Ankyrin repeat-containing protein C6C3.08', 109, NULL, NULL, 137448),
(137449, '2.30.39.10-FF-000001', NULL, 'Serpin family B member 2', 143, NULL, NULL, 137449),
(137450, '3.40.50.1820-FF-000464', NULL, 'Alpha/beta hydrolase', 266, NULL, NULL, 137450),
(137451, '3.40.50.300-FF-006557', NULL, 'Thymidine kinase 2', 104, NULL, NULL, 137451),
(137452, '3.30.710.10-FF-000003', NULL, 'BTB/POZ domain-containing protein KCTD6 isoform X2', 106, NULL, NULL, 137452),
(137453, '1.25.40.10-FF-002751', NULL, 'Est1p', 200, NULL, NULL, 137453),
(137454, '2.10.70.80-FF-000005', NULL, 'Sortilin', 52, NULL, NULL, 137454),
(137455, '2.20.70.10-FF-000271', NULL, 'Histone-lysine N-methyltransferase', 37, NULL, NULL, 137455),
(137456, '1.20.140.10-FF-000025', NULL, 'Acyl-coenzyme A oxidase', 131, NULL, NULL, 137456),
(137457, '3.30.40.10-FF-001716', NULL, 'Kinesin-like protein', 57, NULL, NULL, 137457),
(137458, '1.20.1440.100-FF-000017', NULL, 'Gll3211 protein', 73, NULL, NULL, 137458),
(137459, '2.60.40.1180-FF-000228', NULL, 'Alpha-galactosidase mel1', 69, NULL, NULL, 137459),
(137460, '3.30.70.80-FF-000036', NULL, 'Peptidase S8/S53 domain-containing protein', 95, NULL, NULL, 137460),
(137461, '1.20.120.330-FF-000001', NULL, 'focal adhesion kinase 1 isoform X1', 142, NULL, NULL, 137461),
(137462, '3.80.10.10-FF-001931', NULL, 'Uncharacterized protein', 79, NULL, NULL, 137462),
(137463, '3.40.50.300-FF-006613', NULL, 'Os11g0303400 protein', 95, NULL, NULL, 137463),
(137464, '1.10.1520.10-FF-000067', NULL, 'Ribonuclease 3 1', 137, NULL, NULL, 137464),
(137465, '2.60.120.260-FF-000110', NULL, 'Peptide-N(4)-(N-acetyl-beta-glucosaminyl)asparagine amidase', 141, NULL, NULL, 137465),
(137466, '3.10.660.10-FF-000020', NULL, 'DnaJ homolog subfamily C member 24-like Protein', 52, NULL, NULL, 137466),
(137467, '3.55.50.60-FF-000001', NULL, 'DotD', 123, NULL, NULL, 137467),
(137468, '3.40.50.300-FF-007069', NULL, 'AFR389Cp', 194, NULL, NULL, 137468),
(137469, '3.90.660.10-FF-000108', NULL, NULL, 222, NULL, NULL, 137469),
(137470, '3.40.50.2020-FF-000131', NULL, 'Hypoxanthine phosphoribosyltransferase', 171, NULL, NULL, 137470),
(137471, '2.60.120.650-FF-000244', NULL, 'Uncharacterized protein', 63, NULL, NULL, 137471),
(137472, '2.60.40.1930-FF-000021', NULL, 'Thioester-containing protein 4, isoform C', 124, NULL, NULL, 137472),
(137473, '3.90.190.10-FF-000527', NULL, 'Receptor tyrosine phosphatase type r2b, putative', 258, NULL, NULL, 137473),
(137474, '3.30.9.10-FF-000290', NULL, 'Uncharacterized protein', 84, NULL, NULL, 137474),
(137475, '2.70.170.10-FF-000293', NULL, 'Uncharacterized protein', 165, NULL, NULL, 137475),
(137476, '2.40.30.10-FF-000251', NULL, 'Ferric reduction oxidase 2', 100, NULL, NULL, 137476),
(137477, '3.40.50.11660-FF-000009', NULL, 'Uncharacterized protein', 220, NULL, NULL, 137477),
(137478, '3.10.20.90-FF-000604', NULL, 'Polyubiquitin 8', 74, NULL, NULL, 137478); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(137479, '3.40.50.10860-FF-000050', NULL, 'Bifunctional protein FolD 2', 90, NULL, NULL, 137479),
(137480, '3.10.20.90-FF-000548', NULL, 'protein DDI1 homolog 2', 77, NULL, NULL, 137480),
(137481, '3.30.160.60-FF-005118', NULL, NULL, 36, NULL, NULL, 137481),
(137482, '1.10.1520.10-FF-000123', NULL, 'Uncharacterized protein', 78, NULL, NULL, 137482),
(137483, '1.25.40.20-FF-001175', NULL, 'LOW QUALITY PROTEIN: kinase D-interacting substrate of 220 kDa B-like', 131, NULL, NULL, 137483),
(137484, '2.60.120.970-FF-000082', NULL, 'Predicted protein', 227, NULL, NULL, 137484),
(137485, '2.30.30.40-FF-000552', NULL, 'Uncharacterized protein', 107, NULL, NULL, 137485),
(137486, '2.10.110.10-FF-000207', NULL, 'GM16078', 61, NULL, NULL, 137486),
(137487, '3.40.50.2020-FF-000075', NULL, 'Adenine phosphoribosyltransferase', 81, NULL, NULL, 137487),
(137488, '3.40.50.1000-FF-000393', NULL, 'WGS project CABT00000000 data, contig 2.7', 167, NULL, NULL, 137488),
(137489, '3.30.420.40-FF-000568', NULL, 'Glycerol kinase', 245, NULL, NULL, 137489),
(137490, '1.20.1050.80-FF-000009', NULL, 'VPS9 domain protein, putative', 172, NULL, NULL, 137490),
(137491, '3.40.630.30-FF-000635', NULL, 'Acetyltransferase, putative', 175, NULL, NULL, 137491),
(137492, '3.80.10.10-FF-004096', NULL, 'Uncharacterized protein', 295, NULL, NULL, 137492),
(137493, '2.60.34.20-FF-000003', NULL, 'AAR2 family protein', 156, NULL, NULL, 137493),
(137494, '2.130.10.10-FF-000919', NULL, 'Actin-related protein 2/3 complex subunit 1', 374, NULL, NULL, 137494),
(137495, '3.10.28.10-FF-000008', NULL, 'Homothallism endonuclease', 118, NULL, NULL, 137495),
(137496, '1.20.1050.10-FF-000208', NULL, 'Uncharacterized protein', 35, NULL, NULL, 137496),
(137497, '3.40.50.620-FF-000139', NULL, 'Multidrug MFS transporter', 138, NULL, NULL, 137497),
(137498, '2.10.50.30-FF-000040', NULL, 'Uncharacterized protein', 77, NULL, NULL, 137498),
(137499, '1.10.10.60-FF-000908', NULL, NULL, 59, NULL, NULL, 137499),
(137500, '1.25.40.20-FF-000663', NULL, 'Ankyrin repeat, SAM and basic leucine zipper domain-containing 1', 212, NULL, NULL, 137500),
(137501, '3.30.1390.20-FF-000013', NULL, 'Rlp7p', 160, NULL, NULL, 137501),
(137502, '2.80.10.50-FF-000265', NULL, 'Predicted protein', 123, NULL, NULL, 137502),
(137503, '3.30.430.20-FF-000063', NULL, 'Uncharacterized protein', 56, NULL, NULL, 137503),
(137504, '3.50.30.30-FF-000046', NULL, 'Subtilisin-like protease SBT2.5', 166, NULL, NULL, 137504),
(137505, '6.10.140.2220-FF-000076', NULL, 'SET and MYND domain containing 1a', 32, NULL, NULL, 137505),
(137506, '3.30.70.270-FF-000023', NULL, 'Pol', 84, NULL, NULL, 137506),
(137507, '1.10.8.270-FF-000025', NULL, 'TBC1 domain family member 15-like', 99, NULL, NULL, 137507),
(137508, '2.60.40.10-FF-003016', NULL, 'AGAP009947-PA', 105, NULL, NULL, 137508),
(137509, '1.25.10.10-FF-001759', NULL, 'Protein Mo25', 62, NULL, NULL, 137509),
(137510, '1.10.510.10-FF-004013', NULL, NULL, 128, NULL, NULL, 137510),
(137511, '3.40.50.720-FF-001276', NULL, 'Predicted protein', 316, NULL, NULL, 137511),
(137512, '2.60.40.10-FF-002504', NULL, 'Unc-40 protein', 97, NULL, NULL, 137512),
(137513, '2.30.30.40-FF-000024', NULL, 'Intersectin 1', 68, NULL, NULL, 137513),
(137514, '3.30.870.10-FF-000020', NULL, 'Tyrosyl-DNA phosphodiesterase 1', 257, NULL, NULL, 137514),
(137515, '3.30.160.60-FF-003937', NULL, NULL, 31, NULL, NULL, 137515),
(137516, '3.40.30.10-FF-000501', NULL, 'Glutathione S-transferase', 79, NULL, NULL, 137516),
(137517, '2.10.50.10-FF-000085', NULL, 'Nerve growth factor receptor b', 36, NULL, NULL, 137517),
(137518, '2.60.120.10-FF-000483', NULL, 'Uncharacterized protein', 136, NULL, NULL, 137518),
(137519, '3.30.160.60-FF-003561', NULL, 'Zinc finger protein 529', 52, NULL, NULL, 137519),
(137520, '1.20.58.70-FF-000043', NULL, 'Syntaxin, Qa-SNARE family', 241, NULL, NULL, 137520),
(137521, '3.40.50.300-FF-004848', NULL, 'Elongation factor G, mitochondrial', 291, NULL, NULL, 137521),
(137522, '1.25.40.10-FF-001115', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 85, NULL, NULL, 137522);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(137523, '3.40.30.10-FF-000445', NULL, 'Glutathione S-transferase', 78, NULL, NULL, 137523),
(137524, '3.30.470.20-FF-000240', NULL, 'Glutathione synthetase', 68, NULL, NULL, 137524),
(137525, '3.40.50.300-FF-004904', NULL, 'Uncharacterized protein', 101, NULL, NULL, 137525),
(137526, '1.10.150.250-FF-000007', NULL, 'Succinate dehydrogenase assembly factor 2, mitochondrial', 89, NULL, NULL, 137526),
(137527, '1.25.40.10-FF-004460', NULL, 'Uncharacterized protein', 111, NULL, NULL, 137527),
(137528, '1.25.40.10-FF-004836', NULL, 'Uncharacterized protein', 143, NULL, NULL, 137528),
(137529, '3.20.20.100-FF-000038', NULL, 'Aldo/keto reductase', 326, NULL, NULL, 137529),
(137530, '1.10.510.10-FF-003344', NULL, NULL, 27, NULL, NULL, 137530),
(137531, '3.80.10.10-FF-003584', NULL, 'Uncharacterized protein', 138, NULL, NULL, 137531),
(137532, '3.20.20.100-FF-000190', NULL, 'Uncharacterized protein', 106, NULL, NULL, 137532),
(137533, '3.30.70.330-FF-002683', NULL, NULL, 224, NULL, NULL, 137533),
(137534, '1.10.225.10-FF-000011', NULL, 'Pulmonary surfactant-associated protein B', 73, NULL, NULL, 137534),
(137535, '3.40.50.620-FF-000667', NULL, 'RE41093p', 269, NULL, NULL, 137535),
(137536, '1.20.140.40-FF-000040', NULL, 'Uncharacterized protein', 157, NULL, NULL, 137536),
(137537, '1.20.58.90-FF-000049', NULL, NULL, 95, NULL, NULL, 137537),
(137538, '2.60.40.10-FF-001779', NULL, 'Cell adhesion molecule L1-like b', 91, NULL, NULL, 137538),
(137539, '1.25.40.10-FF-001587', NULL, 'Pentatricopeptide repeat-containing protein At2g04860', 97, NULL, NULL, 137539),
(137540, '1.20.58.830-FF-000039', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 120, NULL, NULL, 137540),
(137541, '1.10.510.10-FF-000415', NULL, 'CMGC/CDK/CRK7 protein kinase, variant', 241, NULL, NULL, 137541),
(137542, '1.25.10.10-FF-000473', NULL, 'Uncharacterized protein', 268, NULL, NULL, 137542),
(137543, '1.20.1540.10-FF-000116', NULL, 'Uncharacterized protein', 202, NULL, NULL, 137543),
(137544, '1.10.10.10-FF-000034', NULL, 'GTP-sensing transcriptional pleiotropic repressor CodY', 100, NULL, NULL, 137544),
(137545, '3.60.140.10-FF-000003', NULL, 'Polyphenol oxidase', 240, NULL, NULL, 137545),
(137546, '3.40.50.150-FF-000386', NULL, 'DNA (Cytosine-5)-methyltransferase', 43, NULL, NULL, 137546),
(137547, '1.20.1070.10-FF-000535', NULL, 'Olfactory receptor 1290', 80, NULL, NULL, 137547),
(137548, '1.20.1080.10-FF-000036', NULL, 'Probable nitrite transporter', 262, NULL, NULL, 137548),
(137549, '3.90.320.10-FF-000061', NULL, 'Uncharacterized protein', 218, NULL, NULL, 137549),
(137550, '3.80.10.10-FF-003112', NULL, 'Uncharacterized protein', 505, NULL, NULL, 137550),
(137551, '3.50.50.60-FF-000005', NULL, 'Rab GDP dissociation inhibitor', 170, NULL, NULL, 137551),
(137552, '1.50.40.10-FF-000562', NULL, 'Mitochondrial carrier protein, putative (AFU_orthologue AFUA_1G09980)', 216, NULL, NULL, 137552),
(137553, '3.40.33.10-FF-000159', NULL, 'Predicted extracellular protein', 125, NULL, NULL, 137553),
(137554, '1.25.10.10-FF-002923', NULL, 'Uncharacterized protein', 101, NULL, NULL, 137554),
(137555, '1.10.287.2250-FF-000006', NULL, 'Cysteine protease, putative', 69, NULL, NULL, 137555),
(137556, '3.40.50.720-FF-002440', NULL, '3-hydroxyisobutyrate dehydrogenase', 156, NULL, NULL, 137556),
(137557, '1.20.120.160-FF-000017', NULL, 'Aerobic respiration control sensor protein', 120, NULL, NULL, 137557),
(137558, '1.10.8.100-FF-000020', NULL, 'Probable ribosomal RNA small subunit methyltransferase A', 73, NULL, NULL, 137558),
(137559, '3.90.190.10-FF-000151', NULL, 'Receptor-type tyrosine-protein phosphatase S', 293, NULL, NULL, 137559),
(137560, '3.40.50.12780-FF-000103', NULL, '2-succinylbenzoate--CoA ligase', 367, NULL, NULL, 137560),
(137561, '3.30.60.20-FF-000040', NULL, 'Actin polymerization protein Bzz1', 77, NULL, NULL, 137561),
(137562, '3.40.1620.10-FF-000004', NULL, 'Antitoxin', 49, NULL, NULL, 137562),
(137563, '2.30.42.10-FF-000200', NULL, 'Uncharacterized protein, isoform E', 92, NULL, NULL, 137563),
(137564, '2.130.10.10-FF-002364', NULL, 'Transcriptional corepressor LEUNIG_HOMOLOG', 153, NULL, NULL, 137564);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(137565, '3.40.390.10-FF-000273', NULL, NULL, 143, NULL, NULL, 137565),
(137566, '3.40.1700.10-FF-000005', NULL, 'Diadenylate cyclase', 153, NULL, NULL, 137566),
(137567, '3.30.160.60-FF-003084', NULL, 'Zinc finger protein 1009', 28, NULL, NULL, 137567),
(137568, '2.60.120.10-FF-000803', NULL, 'Uncharacterized protein', 125, NULL, NULL, 137568),
(137569, '2.30.30.40-FF-000496', NULL, 'Uncharacterized protein', 83, NULL, NULL, 137569),
(137570, '3.40.50.300-FF-000633', NULL, 'ABC transporter A family member 7', 277, NULL, NULL, 137570),
(137571, '1.10.20.10-FF-000063', NULL, 'Centromere protein S', 117, NULL, NULL, 137571),
(137572, '3.30.70.60-FF-000030', NULL, 'Uncharacterized protein', 121, NULL, NULL, 137572),
(137573, '1.10.555.10-FF-000199', NULL, NULL, 123, NULL, NULL, 137573),
(137574, '3.30.40.10-FF-000087', NULL, 'General transcription factor IIE subunit 1', 62, NULL, NULL, 137574),
(137575, '1.20.1050.130-FF-000005', NULL, 'Glutamate--tRNA ligase cytoplasmic', 169, NULL, NULL, 137575),
(137576, '3.20.20.70-FF-000401', NULL, 'Deoxyribose-phosphate aldolase (putative)', 248, NULL, NULL, 137576),
(137577, '2.30.110.10-FF-000017', NULL, 'Flavin-dependent monooxygenase, reductase subunit', 185, NULL, NULL, 137577),
(137578, '3.40.50.1980-FF-000051', NULL, 'Iron-hydroxamate ABC transporter substrate-binding protein', 110, NULL, NULL, 137578),
(137579, '1.10.287.1490-FF-000059', NULL, 'Myocilin', 127, NULL, NULL, 137579),
(137580, '2.60.40.150-FF-000703', NULL, 'Serine/threonine-protein kinase gad8', 145, NULL, NULL, 137580),
(137581, '3.30.870.10-FF-000109', NULL, 'Phospholipase D', 246, NULL, NULL, 137581),
(137582, '3.30.200.20-FF-000782', NULL, 'Insulin receptor a', 48, NULL, NULL, 137582),
(137583, '1.20.1090.10-FF-000065', NULL, 'Uncharacterized protein', 124, NULL, NULL, 137583),
(137584, '1.25.40.10-FF-004605', NULL, 'Uncharacterized protein', 164, NULL, NULL, 137584),
(137585, '3.40.50.300-FF-002870', NULL, 'SNF2 family helicase/ATPase, putative', 248, NULL, NULL, 137585),
(137586, '2.130.10.10-FF-005798', NULL, 'Type II inositol polyphosphate 5-phosphatase 15', 93, NULL, NULL, 137586),
(137587, '3.90.70.10-FF-000277', NULL, 'Ubiquitin carboxyl-terminal hydrolase 9', 206, NULL, NULL, 137587),
(137588, '2.10.25.10-FF-000717', NULL, 'Merozoite surface protein 8', 41, NULL, NULL, 137588),
(137589, '3.40.1190.20-FF-000226', NULL, NULL, 209, NULL, NULL, 137589),
(137590, '2.40.70.10-FF-000517', NULL, NULL, 64, NULL, NULL, 137590),
(137591, '1.10.730.10-FF-000157', NULL, 'Leucine--tRNA ligase, mitochondrial', 301, NULL, NULL, 137591),
(137592, '3.30.160.60-FF-000071', NULL, 'Putative zinc finger protein 143', 31, NULL, NULL, 137592),
(137593, '2.60.40.60-FF-000552', NULL, 'Cadherin-related hmr-1', 114, NULL, NULL, 137593),
(137594, '3.40.50.720-FF-002108', NULL, 'Fatty acyl-CoA reductase', 121, NULL, NULL, 137594),
(137595, '3.10.300.10-FF-000004', NULL, 'Putative 3-methyladenine DNA glycosylase', 198, NULL, NULL, 137595),
(137596, '2.170.270.10-FF-000164', NULL, 'Histone-lysine N-methyltransferase', 275, NULL, NULL, 137596),
(137597, '3.30.1010.10-FF-000011', NULL, 'serine/threonine-protein kinase ATR', 174, NULL, NULL, 137597),
(137598, '3.30.950.10-FF-000021', NULL, 'Uroporphyrin-III C-methyltransferase', 124, NULL, NULL, 137598),
(137599, '2.40.10.10-FF-000396', NULL, NULL, 120, NULL, NULL, 137599),
(137600, '3.30.160.60-FF-004342', NULL, NULL, 61, NULL, NULL, 137600),
(137601, '3.60.10.10-FF-000044', NULL, 'Type IV inositol polyphosphate 5-phosphatase 11', 307, NULL, NULL, 137601),
(137602, '3.30.70.270-FF-000310', NULL, NULL, 36, NULL, NULL, 137602),
(137603, '3.90.70.10-FF-000333', NULL, 'Protein CBG02822', 335, NULL, NULL, 137603),
(137604, '3.40.50.1370-FF-000014', NULL, 'N-acetylornithine carbamoyltransferase', 147, NULL, NULL, 137604),
(137605, '2.120.10.80-FF-000300', NULL, 'Multiple epidermal growth factor-like domains protein 8', 196, NULL, NULL, 137605),
(137606, '2.130.10.10-FF-002628', NULL, 'Excision repair cross-complementation group 8', 178, NULL, NULL, 137606);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(137607, '3.90.1600.10-FF-000065', NULL, 'Uncharacterized protein', 73, NULL, NULL, 137607),
(137608, '3.30.565.10-FF-000378', NULL, 'Uncharacterized protein', 61, NULL, NULL, 137608),
(137609, '1.10.10.10-FF-001782', NULL, 'Protein CBR-EFL-2', 44, NULL, NULL, 137609),
(137610, '3.40.1170.60-FF-000012', NULL, 'Putative DNA-directed polymerase kappa', 54, NULL, NULL, 137610),
(137611, '3.30.1120.30-FF-000031', NULL, 'Serine/threonine-protein kinase PLK', 95, NULL, NULL, 137611),
(137612, '2.40.50.140-FF-000656', NULL, 'Transcription termination/antitermination protein NusA', 70, NULL, NULL, 137612),
(137613, '3.30.200.20-FF-002339', NULL, 'Receptor protein serine/threonine kinase', 64, NULL, NULL, 137613),
(137614, '1.10.10.990-FF-000003', NULL, 'RecBCD enzyme subunit RecC', 78, NULL, NULL, 137614),
(137615, '3.40.50.1110-FF-000167', NULL, 'Phospholipase B1', 212, NULL, NULL, 137615),
(137616, '1.20.1250.20-FF-000165', NULL, 'Solute carrier family 22 member 3', 408, NULL, NULL, 137616),
(137617, '3.30.160.60-FF-002717', NULL, 'Zinc finger protein 217', 66, NULL, NULL, 137617),
(137618, '1.20.1070.10-FF-001940', NULL, 'Predicted protein', 307, NULL, NULL, 137618),
(137619, '1.20.1070.10-FF-000007', NULL, 'Olfactory receptor', 289, NULL, NULL, 137619),
(137620, '1.10.238.10-FF-000985', NULL, 'Mitochondrial Rho GTPase 1', 223, NULL, NULL, 137620),
(137621, '3.40.50.300-FF-002718', NULL, 'Unplaced genomic scaffold supercont1.38, whole genome shotgun sequence', 200, NULL, NULL, 137621),
(137622, '1.10.287.70-FF-000621', NULL, 'Protein CBR-KQT-2', 236, NULL, NULL, 137622),
(137623, '3.40.50.1820-FF-000520', NULL, 'Thioesterase', 254, NULL, NULL, 137623),
(137624, '1.25.40.10-FF-004549', NULL, 'Uncharacterized protein', 222, NULL, NULL, 137624),
(137625, '1.25.10.10-FF-002979', NULL, 'Uncharacterized protein', 896, NULL, NULL, 137625),
(137626, '3.40.50.1440-FF-000058', NULL, 'Cell division protein FtsZ', 406, NULL, NULL, 137626),
(137627, '3.40.50.20-FF-000073', NULL, 'Lysine biosynthesis enzyme LysX', 105, NULL, NULL, 137627),
(137628, '2.120.10.30-FF-000274', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 239, NULL, NULL, 137628),
(137629, '2.60.40.10-FF-002184', NULL, 'Titin homolog', 104, NULL, NULL, 137629),
(137630, '3.40.50.300-FF-000397', NULL, 'Probable ATP-dependent RNA helicase DDX4', 254, NULL, NULL, 137630),
(137631, '1.10.510.10-FF-002832', NULL, NULL, 103, NULL, NULL, 137631),
(137632, '2.60.40.10-FF-005938', NULL, NULL, 98, NULL, NULL, 137632),
(137633, '1.10.510.10-FF-004272', NULL, NULL, 183, NULL, NULL, 137633),
(137634, '2.10.50.10-FF-000141', NULL, 'CD27 molecule', 73, NULL, NULL, 137634),
(137635, '3.80.10.10-FF-003640', NULL, 'Os08g0203400 protein', 134, NULL, NULL, 137635),
(137636, '3.40.50.720-FF-000023', NULL, 'Ketol-acid reductoisomerase (NADP(+))', 182, NULL, NULL, 137636),
(137637, '2.60.120.10-FF-000747', NULL, 'Uncharacterized protein', 103, NULL, NULL, 137637),
(137638, '3.40.50.1000-FF-000134', NULL, 'Glycerol-3-phosphate 2-O-acyltransferase 6', 118, NULL, NULL, 137638),
(137639, '1.10.10.10-FF-000562', NULL, 'Unplaced genomic scaffold supercont1.16, whole genome shotgun sequence', 99, NULL, NULL, 137639),
(137640, '3.40.50.300-FF-005776', NULL, 'Adenylyl cyclase class-3/4/guanylyl cyclase', 103, NULL, NULL, 137640),
(137641, '2.60.40.10-FF-000559', NULL, 'Uncharacterized protein, isoform J', 99, NULL, NULL, 137641),
(137642, '3.40.395.10-FF-000025', NULL, 'Uncharacterized protein', 98, NULL, NULL, 137642),
(137643, '1.20.1250.10-FF-000105', NULL, 'Leptin', 146, NULL, NULL, 137643),
(137644, '3.40.50.10190-FF-000001', NULL, 'Replication factor C subunit 1', 106, NULL, NULL, 137644),
(137645, '3.30.70.1660-FF-000019', NULL, 'Mitochondrial translation release factor', 85, NULL, NULL, 137645),
(137646, '3.30.40.10-FF-000412', NULL, 'Putative lysine-specific demethylase 5b', 43, NULL, NULL, 137646),
(137647, '3.30.470.30-FF-000006', NULL, 'Cap methyltransferase 1', 185, NULL, NULL, 137647),
(137648, '1.25.40.20-FF-000808', NULL, 'Uncharacterized protein', 174, NULL, NULL, 137648);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(137649, '3.30.420.40-FF-001024', NULL, 'Phosphotransferase', 42, NULL, NULL, 137649),
(137650, '2.120.10.30-FF-000307', NULL, 'Peptidylglycine alpha-amidating monooxygenase', 330, NULL, NULL, 137650),
(137651, '3.10.100.10-FF-000107', NULL, 'Uncharacterized protein', 118, NULL, NULL, 137651),
(137652, '3.40.50.620-FF-000291', NULL, 'Probable nicotinate-nucleotide adenylyltransferase', 213, NULL, NULL, 137652),
(137653, '1.10.110.10-FF-000014', NULL, 'Protein ARABIDOPSIS THALIANA ANTHER 7', 101, NULL, NULL, 137653),
(137654, '3.30.230.130-FF-000080', NULL, 'Anaphase-promoting complex subunit 2', 141, NULL, NULL, 137654),
(137655, '3.40.630.30-FF-000579', NULL, 'Protein GTLF3B, putative', 97, NULL, NULL, 137655),
(137656, '1.10.510.10-FF-003288', NULL, NULL, 95, NULL, NULL, 137656),
(137657, '1.20.120.290-FF-000005', NULL, 'ECA1 (ER-TYPE CA2+-ATPASE 1)', 114, NULL, NULL, 137657),
(137658, '3.30.420.40-FF-000624', NULL, 'Nucleoside triphosphate diphosphohydrolase', 149, NULL, NULL, 137658),
(137659, '3.30.160.60-FF-002156', NULL, 'REgulator of Fusion', 30, NULL, NULL, 137659),
(137660, '1.25.40.10-FF-000862', NULL, 'Tetratricopeptide repeat protein', 98, NULL, NULL, 137660),
(137661, '3.40.50.300-FF-002342', NULL, 'ATP-dependent DNA helicase UvrD', 90, NULL, NULL, 137661),
(137662, '3.30.200.20-FF-002491', NULL, 'Non-specific serine/threonine protein kinase', 23, NULL, NULL, 137662),
(137663, '1.10.3430.10-FF-000004', NULL, 'Ammonium transporter', 412, NULL, NULL, 137663),
(137664, '1.10.3480.10-FF-000007', NULL, 'Nitrate reductase delta subunit (NarJ)', 176, NULL, NULL, 137664),
(137665, '1.20.1270.460-FF-000001', NULL, 'protein lin-7 homolog B', 71, NULL, NULL, 137665),
(137666, '3.40.50.11850-FF-000004', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase', 114, NULL, NULL, 137666),
(137667, '1.10.1900.40-FF-000009', NULL, NULL, 109, NULL, NULL, 137667),
(137668, '3.40.50.2000-FF-000389', NULL, 'Glycosyltransferase', 246, NULL, NULL, 137668),
(137669, '1.10.274.30-FF-000006', NULL, 'Eaf3p', 181, NULL, NULL, 137669),
(137670, '3.30.200.20-FF-000254', NULL, 'Serine/threonine-protein kinase cot-1', 11, NULL, NULL, 137670),
(137671, '3.30.70.1230-FF-000155', NULL, 'Guanylate cyclase', 230, NULL, NULL, 137671),
(137672, '3.90.1150.10-FF-000428', NULL, 'Aspartate aminotransferase', 54, NULL, NULL, 137672),
(137673, '3.90.550.10-FF-000050', NULL, 'hyaluronan synthase 2', 253, NULL, NULL, 137673),
(137674, '3.30.310.210-FF-000004', NULL, 'RNA-binding protein, putative', 155, NULL, NULL, 137674),
(137675, '2.60.210.10-FF-000069', NULL, NULL, 130, NULL, NULL, 137675),
(137676, '1.20.1020.10-FF-000004', NULL, 'BTB/POZ and TAZ domain-containing protein 2', 125, NULL, NULL, 137676),
(137677, '3.20.20.300-FF-000042', NULL, NULL, 117, NULL, NULL, 137677),
(137678, '3.40.140.10-FF-000142', NULL, 'Sulfur carrier protein FdhD', 156, NULL, NULL, 137678),
(137679, '1.20.1250.20-FF-000726', NULL, 'DUF895 domain membrane protein', 186, NULL, NULL, 137679),
(137680, '3.30.420.210-FF-000006', NULL, 'UBX domain protein 2A', 65, NULL, NULL, 137680),
(137681, '1.10.510.10-FF-003849', NULL, NULL, 104, NULL, NULL, 137681),
(137682, '3.30.420.40-FF-000804', NULL, 'Uncharacterized protein', 80, NULL, NULL, 137682),
(137683, '1.20.1440.230-FF-000005', NULL, '[Fe] hydrogenase, HymB subunit', 96, NULL, NULL, 137683),
(137684, '4.10.240.10-FF-000198', NULL, 'Uncharacterized transcriptional regulatory protein C139.03', 91, NULL, NULL, 137684),
(137685, '3.50.50.60-FF-000713', NULL, 'FAD-dependent urate hydroxylase', 248, NULL, NULL, 137685),
(137686, '3.40.50.300-FF-002398', NULL, 'Trehalose 2-sulfotransferase', 262, NULL, NULL, 137686),
(137687, '3.40.50.300-FF-001414', NULL, 'Terminase DNA packaging enzyme large subunit', 254, NULL, NULL, 137687),
(137688, '3.30.1180.20-FF-000003', NULL, 'triokinase/FMN cyclase isoform X1', 154, NULL, NULL, 137688),
(137689, '3.40.50.720-FF-001512', NULL, '3-oxoacyl-reductase', 278, NULL, NULL, 137689),
(137690, '1.25.10.10-FF-000506', NULL, 'armadillo repeat-containing protein 4 isoform X2', 92, NULL, NULL, 137690);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(137691, '2.130.10.10-FF-000886', NULL, 'lipopolysaccharide-responsive and beige-like anchor protein isoform X1', 240, NULL, NULL, 137691),
(137692, '1.20.950.20-FF-000005', NULL, 'Putative cytochrome b561', 101, NULL, NULL, 137692),
(137693, '3.30.70.1450-FF-000018', NULL, 'Potassium transporter TrkA', 73, NULL, NULL, 137693),
(137694, '3.30.830.10-FF-000219', NULL, 'Os01g0711100 protein', 118, NULL, NULL, 137694),
(137695, '1.25.10.10-FF-000978', NULL, 'Serine/threonine-protein kinase TOR', 215, NULL, NULL, 137695),
(137696, '1.10.472.130-FF-000073', NULL, 'Dynein heavy chain', 155, NULL, NULL, 137696),
(137697, '3.90.190.20-FF-000064', NULL, 'Folylpolyglutamate synthase', 129, NULL, NULL, 137697),
(137698, '1.10.132.70-FF-000026', NULL, 'Telomerase reverse transcriptase', 114, NULL, NULL, 137698),
(137699, '1.20.1560.10-FF-000062', NULL, 'ABC transporter B family member 6', 89, NULL, NULL, 137699),
(137700, '3.50.50.60-FF-000657', NULL, 'Worm AIF (Apoptosis inducing factor) Homolog', 177, NULL, NULL, 137700),
(137701, '2.130.10.10-FF-003292', NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', 308, NULL, NULL, 137701),
(137702, '1.10.640.10-FF-000043', NULL, 'Protein CBG06977', 174, NULL, NULL, 137702),
(137703, '3.40.50.1820-FF-001537', NULL, 'Uncharacterized protein', 137, NULL, NULL, 137703),
(137704, '3.40.50.1100-FF-000074', NULL, 'Pyridoxal-phosphate dependent protein', 104, NULL, NULL, 137704),
(137705, '1.25.10.10-FF-002890', NULL, 'Uncharacterized protein', 144, NULL, NULL, 137705),
(137706, '1.10.275.10-FF-000014', NULL, 'Os03g0824900 protein', 107, NULL, NULL, 137706),
(137707, '3.40.50.410-FF-000374', NULL, 'Uncharacterized protein', 185, NULL, NULL, 137707),
(137708, '1.10.510.10-FF-001719', NULL, 'MAP kinase-activated protein kinase 5', 86, NULL, NULL, 137708),
(137709, '2.60.40.2030-FF-000017', NULL, 'Adhesion G protein-coupled receptor V1', 118, NULL, NULL, 137709),
(137710, '2.10.25.10-FF-000341', NULL, 'Fibulin 2', 49, NULL, NULL, 137710),
(137711, '3.30.160.60-FF-004865', NULL, NULL, 31, NULL, NULL, 137711),
(137712, '1.25.40.10-FF-001823', NULL, 'Pentatricopeptide repeat-containing protein At3g58590', 119, NULL, NULL, 137712),
(137713, '2.30.29.30-FF-000237', NULL, 'pleckstrin homology domain-containing family O member 1', 128, NULL, NULL, 137713),
(137714, '3.30.200.20-FF-002524', NULL, NULL, 87, NULL, NULL, 137714),
(137715, '3.30.572.10-FF-000018', NULL, 'Bifunctional dihydrofolate reductase-thymidylate synthase', 222, NULL, NULL, 137715),
(137716, '3.40.50.300-FF-007777', NULL, 'Uncharacterized protein', 56, NULL, NULL, 137716),
(137717, '3.50.50.60-FF-000860', NULL, 'Uncharacterized protein', 420, NULL, NULL, 137717),
(137718, '1.25.40.10-FF-003532', NULL, 'Pre-rRNA processing protein RRP5, putative', 226, NULL, NULL, 137718),
(137719, '2.40.50.580-FF-000001', NULL, 'Sugar fermentation stimulation protein A', 80, NULL, NULL, 137719),
(137720, '2.40.160.50-FF-000047', NULL, 'Uncharacterized protein', 130, NULL, NULL, 137720),
(137721, '3.80.10.10-FF-001167', NULL, 'Chaoptin', 233, NULL, NULL, 137721),
(137722, '3.40.50.1820-FF-001009', NULL, 'Uncharacterized protein', 524, NULL, NULL, 137722),
(137723, '3.40.50.1820-FF-000700', NULL, 'Putative phospholipase', 404, NULL, NULL, 137723),
(137724, '3.40.50.300-FF-005304', NULL, 'Uncharacterized protein', 383, NULL, NULL, 137724),
(137725, '3.40.50.720-FF-000495', NULL, '3 hydroxysteroid dehydrogenase, putative', 360, NULL, NULL, 137725),
(137726, '1.20.1560.10-FF-000590', NULL, 'Uncharacterized protein', 171, NULL, NULL, 137726),
(137727, '3.40.50.1820-FF-001684', NULL, 'Uncharacterized protein', 222, NULL, NULL, 137727),
(137728, '1.25.10.10-FF-002215', NULL, 'Uncharacterized protein', 414, NULL, NULL, 137728),
(137729, '2.130.10.10-FF-004629', NULL, 'Uncharacterized protein', 197, NULL, NULL, 137729),
(137730, '2.40.50.710-FF-000001', NULL, 'Major envelope glycoprotein', 54, NULL, NULL, 137730),
(137731, '3.20.19.10-FF-000009', NULL, 'Aconitate hydratase', 183, NULL, NULL, 137731),
(137732, '1.25.10.10-FF-003199', NULL, 'Uncharacterized protein', 294, NULL, NULL, 137732);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(137733, '1.10.472.10-FF-000484', NULL, 'Retinoblastoma-like protein 1', 62, NULL, NULL, 137733),
(137734, '3.40.1670.10-FF-000007', NULL, 'UbiD-like decarboxylase', 129, NULL, NULL, 137734),
(137735, '1.20.1070.10-FF-001699', NULL, 'Uncharacterized protein', 109, NULL, NULL, 137735),
(137736, '1.10.10.60-FF-000728', NULL, 'Transcription factor protein', 84, NULL, NULL, 137736),
(137737, '2.40.50.730-FF-000007', NULL, 'DNA polymerase', 84, NULL, NULL, 137737),
(137738, '3.40.50.10810-FF-000260', NULL, 'Chromosome 10, whole genome shotgun sequence', 275, NULL, NULL, 137738),
(137739, '3.30.70.100-FF-000158', NULL, NULL, 68, NULL, NULL, 137739),
(137740, '2.30.30.1020-FF-000053', NULL, NULL, 167, NULL, NULL, 137740),
(137741, '3.40.50.300-FF-001229', NULL, 'MAGUK p55 subfamily member 4', 218, NULL, NULL, 137741),
(137742, '3.40.50.720-FF-000551', NULL, 'D-aspartate oxidase', 83, NULL, NULL, 137742),
(137743, '3.40.50.2300-FF-000653', NULL, 'Two-component response regulator', 85, NULL, NULL, 137743),
(137744, '3.40.50.2300-FF-000092', NULL, 'Fructose-like phosphotransferase enzyme IIB component 1', 108, NULL, NULL, 137744),
(137745, '1.10.238.10-FF-000462', NULL, 'reticulocalbin-2', 86, NULL, NULL, 137745),
(137746, '1.10.238.10-FF-000838', NULL, 'Calmodulin, putative', 78, NULL, NULL, 137746),
(137747, '3.30.1640.10-FF-000081', NULL, 'DNA replication licensing factor Mcm2-like Protein', 90, NULL, NULL, 137747),
(137748, '2.60.40.10-FF-000615', NULL, 'collagen alpha-1(XIV) chain isoform X2', 93, NULL, NULL, 137748),
(137749, '2.40.10.10-FF-000305', NULL, 'Glandular kallikrein', 80, NULL, NULL, 137749),
(137750, '1.10.8.10-FF-000342', NULL, 'Uncharacterized protein', 23, NULL, NULL, 137750),
(137751, '3.40.50.300-FF-003359', NULL, 'Rad50, isoform E', 305, NULL, NULL, 137751),
(137752, '1.10.418.10-FF-000083', NULL, 'kinesin-like protein KIN-14J isoform X2', 112, NULL, NULL, 137752),
(137753, '3.40.50.200-FF-000193', NULL, 'Prohormone convertase, putative', 251, NULL, NULL, 137753),
(137754, '3.30.230.120-FF-000015', NULL, 'Blr5970 protein', 410, NULL, NULL, 137754),
(137755, '1.25.40.10-FF-002571', NULL, 'Pentatricopeptide repeat-containing protein At4g08210', 121, NULL, NULL, 137755),
(137756, '3.40.50.10800-FF-000015', NULL, NULL, 115, NULL, NULL, 137756),
(137757, '3.30.160.20-FF-000194', NULL, 'Uncharacterized protein', 74, NULL, NULL, 137757),
(137758, '2.30.33.40-FF-000025', NULL, 'Uncharacterized protein', 103, NULL, NULL, 137758),
(137759, '3.30.160.60-FF-000447', NULL, 'Zinc finger and AT-hook domain containing', 25, NULL, NULL, 137759),
(137760, '2.130.10.10-FF-000739', NULL, 'Putative U5 snrnp-specific protein', 299, NULL, NULL, 137760),
(137761, '2.60.40.420-FF-000043', NULL, 'Blue copper oxidase CueO', 146, NULL, NULL, 137761),
(137762, '1.25.40.20-FF-001736', NULL, 'Predicted protein', 219, NULL, NULL, 137762),
(137763, '2.10.25.10-FF-000009', NULL, 'Low-density lipoprotein receptor isoform 1', 82, NULL, NULL, 137763),
(137764, '3.10.180.10-FF-000090', NULL, '4-hydroxyphenylpyruvic acid dioxgenase', 133, NULL, NULL, 137764),
(137765, '2.130.10.10-FF-004253', NULL, 'Uncharacterized protein', 138, NULL, NULL, 137765),
(137766, '2.60.120.260-FF-000633', NULL, 'Glycoside hydrolase family 3 domain protein', 115, NULL, NULL, 137766),
(137767, '3.90.550.10-FF-000426', NULL, 'Predicted protein', 402, NULL, NULL, 137767),
(137768, '1.10.418.20-FF-000029', NULL, 'Uncharacterized protein', 34, NULL, NULL, 137768),
(137769, '2.60.60.20-FF-000002', NULL, 'Arachidonate 5-lipoxygenase a', 114, NULL, NULL, 137769),
(137770, '3.30.420.510-FF-000029', NULL, 'Type II pantothenate kinase', 97, NULL, NULL, 137770),
(137771, '2.120.10.30-FF-000510', NULL, 'Uncharacterized protein', 197, NULL, NULL, 137771),
(137772, '1.10.460.10-FF-000001', NULL, 'DNA topoisomerase 1', 147, NULL, NULL, 137772),
(137773, '3.30.565.10-FF-000434', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', 160, NULL, NULL, 137773),
(137774, '3.40.850.10-FF-000404', NULL, 'Kinesin-like protein', 263, NULL, NULL, 137774);
INSERT INTO "PUBLIC"."MODEL" VALUES
(137775, '3.30.160.60-FF-005270', NULL, NULL, 22, NULL, NULL, 137775),
(137776, '3.30.200.20-FF-000074', NULL, 'cyclin-dependent kinase 12 isoform X2', 105, NULL, NULL, 137776),
(137777, '2.130.10.10-FF-004814', NULL, 'Transducin family protein / WD-40 repeat family protein', 139, NULL, NULL, 137777),
(137778, '2.40.10.10-FF-000452', NULL, NULL, 33, NULL, NULL, 137778),
(137779, '3.40.50.300-FF-005271', NULL, 'Uncharacterized protein', 182, NULL, NULL, 137779),
(137780, '2.10.25.10-FF-001645', NULL, 'Uncharacterized protein', 75, NULL, NULL, 137780),
(137781, '2.130.10.10-FF-000363', NULL, 'DDB1- and CUL4-associated factor 5 isoform X1', 135, NULL, NULL, 137781),
(137782, '3.20.20.150-FF-000013', NULL, 'Fructoselysine 3-epimerase', 270, NULL, NULL, 137782),
(137783, '3.30.70.1020-FF-000007', NULL, 'Trehalose 6-phosphate phosphatase', 76, NULL, NULL, 137783),
(137784, '1.20.1560.10-FF-000623', NULL, 'Predicted protein', 321, NULL, NULL, 137784),
(137785, '2.60.40.60-FF-000496', NULL, 'Cadherin 3', 91, NULL, NULL, 137785),
(137786, '1.10.10.10-FF-001579', NULL, 'MurR/RpiR family transcriptional regulator', 102, NULL, NULL, 137786),
(137787, '3.40.190.10-FF-000292', NULL, 'GLutamate Receptor family (AMPA)', 130, NULL, NULL, 137787),
(137788, '3.50.7.10-FF-000072', NULL, NULL, 93, NULL, NULL, 137788),
(137789, '1.20.5.930-FF-000007', NULL, 'Integrin alpha L', 30, NULL, NULL, 137789),
(137790, '3.30.40.10-FF-001429', NULL, 'Tnf receptor-associated factor 5', 117, NULL, NULL, 137790),
(137791, '1.10.10.60-FF-000875', NULL, NULL, 70, NULL, NULL, 137791),
(137792, '3.30.70.141-FF-000008', NULL, 'nucleoside diphosphate kinase homolog 5', 144, NULL, NULL, 137792),
(137793, '1.20.1070.10-FF-001176', NULL, 'G-protein coupled receptor GRL101-like protein', 336, NULL, NULL, 137793),
(137794, '3.40.50.2000-FF-000625', NULL, 'Glycogen [starch] synthase', 71, NULL, NULL, 137794),
(137795, '3.40.50.2300-FF-000597', NULL, 'Response regulator', 134, NULL, NULL, 137795),
(137796, '2.60.40.10-FF-004505', NULL, NULL, 98, NULL, NULL, 137796),
(137797, '2.130.10.10-FF-005034', NULL, 'Uncharacterized protein', 300, NULL, NULL, 137797),
(137798, '2.60.40.10-FF-004449', NULL, NULL, 112, NULL, NULL, 137798),
(137799, '1.25.40.10-FF-002419', NULL, 'Pentatricopeptide repeat-containing protein', 217, NULL, NULL, 137799),
(137800, '3.30.1330.30-FF-000097', NULL, 'RNA methyltransferase, TrmH family, group 3', 78, NULL, NULL, 137800),
(137801, '3.30.70.330-FF-000030', NULL, 'Heterogeneous nuclear ribonucleoprotein d0 isoform', 83, NULL, NULL, 137801),
(137802, '2.130.10.10-FF-004106', NULL, 'Uncharacterized protein', 192, NULL, NULL, 137802),
(137803, '1.10.3120.10-FF-000014', NULL, 'Trigger factor', 207, NULL, NULL, 137803),
(137804, '1.10.287.600-FF-000005', NULL, 'Tubulin alpha chain', 66, NULL, NULL, 137804),
(137805, '1.10.220.150-FF-000056', NULL, 'YALI0D07524p', 117, NULL, NULL, 137805),
(137806, '2.30.40.10-FF-000033', NULL, 'Related to guanine deaminase', 62, NULL, NULL, 137806),
(137807, '1.25.50.20-FF-000017', NULL, 'Aminopeptidase', 328, NULL, NULL, 137807),
(137808, '1.20.140.100-FF-000026', NULL, 'Dynein heavy chain', 152, NULL, NULL, 137808),
(137809, '3.40.50.150-FF-000419', NULL, 'S-adenosyl-L-methionine-dependent methyltransferases superfamily protein', 148, NULL, NULL, 137809),
(137810, '2.130.10.10-FF-005742', NULL, 'Uncharacterized protein', 124, NULL, NULL, 137810),
(137811, '2.120.10.80-FF-000064', NULL, 'Kelch-like family member 31', 327, NULL, NULL, 137811),
(137812, '2.160.20.10-FF-000205', NULL, 'Predicted protein', 385, NULL, NULL, 137812),
(137813, '2.40.100.10-FF-000054', NULL, 'Peptidyl-prolyl cis-trans isomerase D', 179, NULL, NULL, 137813),
(137814, '3.30.160.60-FF-001936', NULL, 'Zinc finger protein 565', 27, NULL, NULL, 137814),
(137815, '3.10.110.10-FF-000321', NULL, 'ubiquitin-conjugating enzyme E2 G1', 162, NULL, NULL, 137815),
(137816, '3.40.50.300-FF-005124', NULL, 'Predicted protein', 248, NULL, NULL, 137816),
(137817, '3.40.50.2300-FF-001581', NULL, NULL, 142, NULL, NULL, 137817);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(137818, '3.40.50.2000-FF-000445', NULL, 'UDP-glucoronosyl and UDP-glucosyl transferase family protein', 274, NULL, NULL, 137818),
(137819, '3.30.470.110-FF-000003', NULL, 'ATP-citrate synthase subunit 2', 253, NULL, NULL, 137819),
(137820, '3.10.110.10-FF-000136', NULL, 'Predicted protein', 252, NULL, NULL, 137820),
(137821, '1.10.8.60-FF-000508', NULL, 'Uncharacterized protein', 62, NULL, NULL, 137821),
(137822, '3.40.50.11350-FF-000040', NULL, 'L-Fucosyltransferase', 177, NULL, NULL, 137822),
(137823, '3.30.40.10-FF-002357', NULL, 'RBR-type E3 ubiquitin transferase', 86, NULL, NULL, 137823),
(137824, '3.90.1150.10-FF-000052', NULL, 'Aspartate aminotransferase', 101, NULL, NULL, 137824),
(137825, '3.30.1240.10-FF-000056', NULL, 'Cof-type HAD-IIB family hydrolase', 116, NULL, NULL, 137825),
(137826, '1.25.40.10-FF-000098', NULL, 'Squamous cell carcinoma antigen recognized by T-cells 3', 193, NULL, NULL, 137826),
(137827, '1.10.418.10-FF-000116', NULL, 'Sperm flagellar protein 2', 110, NULL, NULL, 137827),
(137828, '3.30.70.1230-FF-000211', NULL, 'Uncharacterized protein', 126, NULL, NULL, 137828),
(137829, '1.10.287.110-FF-000482', NULL, 'Uncharacterized protein', 76, NULL, NULL, 137829),
(137830, '1.10.1070.11-FF-000027', NULL, 'Putative Phosphatidylinositol 4-kinase', 189, NULL, NULL, 137830),
(137831, '1.10.400.10-FF-000025', NULL, 'Guanine nucleotide-binding protein alpha-11 subunit', 122, NULL, NULL, 137831),
(137832, '3.30.450.20-FF-000441', NULL, 'Signal-transducing histidine kinase homolog', 110, NULL, NULL, 137832),
(137833, '3.90.79.10-FF-000089', NULL, 'CoA pyrophosphatase', 190, NULL, NULL, 137833),
(137834, '6.10.140.2220-FF-000020', NULL, 'Uncharacterized protein, isoform A', 56, NULL, NULL, 137834),
(137835, '2.30.29.30-FF-000422', NULL, 'Phosphoinositide phospholipase C', 118, NULL, NULL, 137835),
(137836, '3.30.160.60-FF-006231', NULL, NULL, 83, NULL, NULL, 137836),
(137837, '3.40.50.300-FF-008182', NULL, 'RecBCD enzyme subunit RecB', 81, NULL, NULL, 137837),
(137838, '1.10.10.60-FF-000352', NULL, 'Site-specific DNA recombinase', 47, NULL, NULL, 137838),
(137839, '3.30.2310.20-FF-000003', NULL, 'Type II toxin-antitoxin system YafQ family toxin', 88, NULL, NULL, 137839),
(137840, '3.70.10.10-FF-000139', NULL, 'Uncharacterized protein', 110, NULL, NULL, 137840),
(137841, '3.60.20.10-FF-000073', NULL, 'Proteasome subunit beta', 217, NULL, NULL, 137841),
(137842, '1.20.120.350-FF-000248', NULL, NULL, 70, NULL, NULL, 137842),
(137843, '3.30.450.70-FF-000028', NULL, NULL, 157, NULL, NULL, 137843),
(137844, '3.40.309.10-FF-000012', NULL, 'Betaine aldehyde dehydrogenase', 191, NULL, NULL, 137844),
(137845, '3.40.50.300-FF-000453', NULL, 'Probable helicase with zinc finger domain', 280, NULL, NULL, 137845),
(137846, '1.20.120.720-FF-000028', NULL, 'Myosin IE heavy chain', 109, NULL, NULL, 137846),
(137847, '3.40.50.300-FF-008558', NULL, 'Predicted protein', 95, NULL, NULL, 137847),
(137848, '2.130.10.10-FF-003797', NULL, 'WD40-repeat protein', 395, NULL, NULL, 137848),
(137849, '3.30.200.20-FF-001035', NULL, 'Myosin light chain kinase, putative', 112, NULL, NULL, 137849),
(137850, '3.40.50.300-FF-005832', NULL, 'Type I secretion system ATPase subunit HlyB family', 231, NULL, NULL, 137850),
(137851, '3.40.50.150-FF-001403', NULL, NULL, 165, NULL, NULL, 137851),
(137852, '3.30.30.30-FF-000069', NULL, 'Uncharacterized protein', 51, NULL, NULL, 137852),
(137853, '1.25.40.10-FF-002043', NULL, 'Tetratricopeptide repeat domain 21B', 230, NULL, NULL, 137853),
(137854, '2.60.40.60-FF-000349', NULL, 'Cadherin 5', 114, NULL, NULL, 137854),
(137855, '3.40.50.880-FF-000082', NULL, 'Biotin:apoprotein ligase', 234, NULL, NULL, 137855),
(137856, '3.30.160.20-FF-000227', NULL, 'Uncharacterized protein', 66, NULL, NULL, 137856),
(137857, '1.25.40.10-FF-002604', NULL, 'Pentatricopeptide repeat-containing protein At1g71420', 102, NULL, NULL, 137857),
(137858, '3.20.80.10-FF-000022', NULL, 'Heme-binding protein 2', 181, NULL, NULL, 137858),
(137859, '1.20.1260.60-FF-000008', NULL, 'Regulator of Vps4 activity in the MVB pathway protein', 180, NULL, NULL, 137859);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(137860, '1.10.510.10-FF-004069', NULL, NULL, 191, NULL, NULL, 137860),
(137861, '3.40.640.10-FF-000214', NULL, 'CAI-1 autoinducer synthase', 232, NULL, NULL, 137861),
(137862, '3.80.10.10-FF-002151', NULL, 'Leucine-rich repeat protein (LRRP), putative', 315, NULL, NULL, 137862),
(137863, '1.10.472.80-FF-000285', NULL, NULL, 75, NULL, NULL, 137863),
(137864, '2.60.40.10-FF-003488', NULL, 'Outer capsid protein lambda-2', 95, NULL, NULL, 137864),
(137865, '3.50.50.60-FF-000096', NULL, 'Glycerol-3-phosphate dehydrogenase', 81, NULL, NULL, 137865),
(137866, '3.30.230.70-FF-000012', NULL, 'exosome complex component RRP46', 211, NULL, NULL, 137866),
(137867, '3.40.50.10810-FF-000108', NULL, 'Helicase superfamily, c-terminal domain protein', 279, NULL, NULL, 137867),
(137868, '3.30.40.10-FF-001396', NULL, 'Putative histone-lysine n-methyltransferase 2c-like isoform x6', 43, NULL, NULL, 137868),
(137869, '3.30.160.60-FF-004286', NULL, NULL, 57, NULL, NULL, 137869),
(137870, '2.60.40.10-FF-000762', NULL, 'transcription factor collier isoform X4', 99, NULL, NULL, 137870),
(137871, '3.40.50.300-FF-004287', NULL, 'AGAP009547-PA', 239, NULL, NULL, 137871),
(137872, '1.10.510.10-FF-001343', NULL, 'L-type lectin-domain containing receptor kinase I.3', 252, NULL, NULL, 137872),
(137873, '2.20.28.10-FF-000061', NULL, 'Minichromosome maintenance protein 3', 55, NULL, NULL, 137873),
(137874, '1.10.418.10-FF-000263', NULL, 'Uncharacterized protein', 55, NULL, NULL, 137874),
(137875, '4.10.280.10-FF-000228', NULL, 'Transcription factor bHLH95', 73, NULL, NULL, 137875),
(137876, '1.20.1250.20-FF-001507', NULL, 'Uncharacterized protein', 147, NULL, NULL, 137876),
(137877, '2.30.18.10-FF-000003', NULL, 'Transcription initiation factor IIA subunit 2', 54, NULL, NULL, 137877),
(137878, '3.30.450.60-FF-000082', NULL, 'AP complex subunit sigma', 158, NULL, NULL, 137878),
(137879, '3.30.1490.190-FF-000018', NULL, 'Fur family transcriptional regulator', 56, NULL, NULL, 137879),
(137880, '2.10.25.10-FF-001830', NULL, 'Uncharacterized protein', 18, NULL, NULL, 137880),
(137881, '3.40.50.300-FF-003887', NULL, 'Signal recognition particle receptor subunit beta', 259, NULL, NULL, 137881),
(137882, '3.40.50.300-FF-001561', NULL, 'ras-related protein Rab-6B isoform X2', 80, NULL, NULL, 137882),
(137883, '2.70.150.10-FF-000106', NULL, 'Sodium/potassium-transporting ATPase subunit alpha', 166, NULL, NULL, 137883),
(137884, '2.130.10.10-FF-004781', NULL, 'Uncharacterized protein', 152, NULL, NULL, 137884),
(137885, '2.10.90.10-FF-000115', NULL, 'Uncharacterized protein', 109, NULL, NULL, 137885),
(137886, '3.40.190.10-FF-000145', NULL, 'Peptide/nickel ABC transporter substrate-binding protein', 141, NULL, NULL, 137886),
(137887, '3.40.800.20-FF-000027', NULL, 'HDA14', 366, NULL, NULL, 137887),
(137888, '3.40.630.10-FF-000337', NULL, 'Uncharacterized protein', 83, NULL, NULL, 137888),
(137889, '3.30.160.60-FF-004786', NULL, NULL, 58, NULL, NULL, 137889),
(137890, '3.30.70.100-FF-000079', NULL, 'Probable decarboxylase tpcK', 119, NULL, NULL, 137890),
(137891, '1.10.30.10-FF-000176', NULL, 'Predicted protein', 85, NULL, NULL, 137891),
(137892, '3.30.160.60-FF-005354', NULL, NULL, 61, NULL, NULL, 137892),
(137893, '1.10.150.80-FF-000015', NULL, 'Putative ribonuclease D', 99, NULL, NULL, 137893),
(137894, '1.20.1270.60-FF-000037', NULL, 'Proline-serine-threonine phosphatase interacting protein 1', 272, NULL, NULL, 137894),
(137895, '2.110.10.10-FF-000049', NULL, 'Predicted protein', 109, NULL, NULL, 137895),
(137896, '1.20.5.110-FF-000296', NULL, 'Uncharacterized protein', 87, NULL, NULL, 137896),
(137897, '2.40.160.20-FF-000009', NULL, 'Major outer membrane protein OMP-1S', 186, NULL, NULL, 137897),
(137898, '1.20.120.1900-FF-000086', NULL, 'Gamma-tubulin complex component', 145, NULL, NULL, 137898),
(137899, '3.60.21.10-FF-000417', NULL, 'Serine/threonine phosphatase type 1, putative', 276, NULL, NULL, 137899),
(137900, '1.25.40.340-FF-000012', NULL, NULL, 44, NULL, NULL, 137900),
(137901, '3.40.20.10-FF-000124', NULL, 'Uncharacterized protein', 120, NULL, NULL, 137901);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(137902, '3.30.200.20-FF-001743', NULL, 'Uncharacterized protein sll1119', 107, NULL, NULL, 137902),
(137903, '3.30.1490.190-FF-000013', NULL, 'Fur family nickel uptake regulator', 61, NULL, NULL, 137903),
(137904, '3.40.1090.10-FF-000036', NULL, 'Patatin-like phospholipase domain-containing protein', 171, NULL, NULL, 137904),
(137905, '1.10.1300.10-FF-000051', NULL, 'cAMP-specific phosphodiesterase, putative', 321, NULL, NULL, 137905),
(137906, '3.40.50.720-FF-001624', NULL, 'Uncharacterized protein', 64, NULL, NULL, 137906),
(137907, '2.60.120.380-FF-000028', NULL, 'Microbial collagenase', 101, NULL, NULL, 137907),
(137908, '3.40.50.1360-FF-000045', NULL, 'Predicted protein', 93, NULL, NULL, 137908),
(137909, '1.10.10.60-FF-000667', NULL, 'AraC family transcriptional regulator', 53, NULL, NULL, 137909),
(137910, '3.40.47.10-FF-000096', NULL, 'Acetyl-CoA C-acetyltransferase', 384, NULL, NULL, 137910),
(137911, '2.60.40.1120-FF-000025', NULL, 'Uncharacterized protein', 97, NULL, NULL, 137911),
(137912, '3.80.20.20-FF-000041', NULL, 'AGAP009262-PA', 170, NULL, NULL, 137912),
(137913, '1.20.1250.20-FF-001598', NULL, 'Uncharacterized protein', 256, NULL, NULL, 137913),
(137914, '3.30.1140.60-FF-000018', NULL, 'F-actin-capping protein subunit alpha', 109, NULL, NULL, 137914),
(137915, '1.20.58.60-FF-000181', NULL, 'Spectrin repeat containing, nuclear envelope 1a', 294, NULL, NULL, 137915),
(137916, '3.30.200.20-FF-002311', NULL, 'Uncharacterized protein', 51, NULL, NULL, 137916),
(137917, '1.20.1110.10-FF-000011', NULL, 'Calcium-transporting ATPase', 166, NULL, NULL, 137917),
(137918, '2.70.98.10-FF-000102', NULL, 'Uncharacterized protein', 358, NULL, NULL, 137918),
(137919, '1.10.167.10-FF-000050', NULL, 'Regulator of G protein signaling domain protein (AFU_orthologue AFUA_6G06860)', 152, NULL, NULL, 137919),
(137920, '3.20.20.80-FF-000106', NULL, 'Glycosyl hydrolase, putative', 214, NULL, NULL, 137920),
(137921, '3.40.50.300-FF-003146', NULL, 'Predicted protein', 225, NULL, NULL, 137921),
(137922, '1.25.10.10-FF-000326', NULL, 'V-type proton ATPase subunit H', 363, NULL, NULL, 137922),
(137923, '3.10.450.40-FF-000030', NULL, 'Amine oxidase', 99, NULL, NULL, 137923),
(137924, '2.130.10.10-FF-005950', NULL, 'Gll1931 protein', 251, NULL, NULL, 137924),
(137925, '4.10.530.10-FF-000001', NULL, 'angiopoietin-2 isoform X1', 74, NULL, NULL, 137925),
(137926, '3.30.560.10-FF-000007', NULL, 'Glucose-methanol-choline oxidoreductase', 320, NULL, NULL, 137926),
(137927, '3.40.1030.10-FF-000009', NULL, 'Anthranilate phosphoribosyltransferase', 263, NULL, NULL, 137927),
(137928, '3.30.70.330-FF-002059', NULL, NULL, 90, NULL, NULL, 137928),
(137929, '3.30.500.10-FF-000049', NULL, NULL, 75, NULL, NULL, 137929),
(137930, '1.20.5.1890-FF-000001', NULL, 'Envelope glycoprotein B', 89, NULL, NULL, 137930),
(137931, '3.30.1560.10-FF-000007', NULL, 'Uncharacterized protein', 47, NULL, NULL, 137931),
(137932, '3.30.1370.10-FF-000245', NULL, 'Predicted protein', 173, NULL, NULL, 137932),
(137933, '3.40.50.1010-FF-000103', NULL, 'PilT protein domain protein', 121, NULL, NULL, 137933),
(137934, '1.10.510.10-FF-002208', NULL, NULL, 65, NULL, NULL, 137934),
(137935, '3.30.230.70-FF-000164', NULL, 'Uncharacterized protein', 283, NULL, NULL, 137935),
(137936, '3.40.50.12650-FF-000031', NULL, 'DNA cross-link repair protein pso2/snm1, putative', 62, NULL, NULL, 137936),
(137937, '2.60.40.10-FF-003729', NULL, NULL, 83, NULL, NULL, 137937),
(137938, '1.10.287.950-FF-000054', NULL, 'Methyl-accepting chemotaxis protein CtpH', 285, NULL, NULL, 137938),
(137939, '3.30.260.10-FF-000081', NULL, NULL, 75, NULL, NULL, 137939),
(137940, '3.60.10.10-FF-000128', NULL, 'Inositol/phosphatidylinositol phosphatase, putative', 381, NULL, NULL, 137940),
(137941, '1.20.1070.10-FF-000395', NULL, 'G-protein coupled receptor 1', 278, NULL, NULL, 137941),
(137942, '3.30.160.60-FF-003325', NULL, 'Uncharacterized protein', 32, NULL, NULL, 137942),
(137943, '3.90.226.10-FF-000156', NULL, 'Putative enoyl-CoA hydratase', 205, NULL, NULL, 137943),
(137944, '1.10.10.10-FF-001170', NULL, 'HTH-type transcriptional repressor glcR', 55, NULL, NULL, 137944);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(137945, '3.40.50.620-FF-000431', NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', 333, NULL, NULL, 137945),
(137946, '3.30.1480.10-FF-000006', NULL, 'Transcription termination/antitermination protein NusA', 133, NULL, NULL, 137946),
(137947, '3.40.50.300-FF-000392', NULL, 'Zinc import ATP-binding protein ZnuC', 232, NULL, NULL, 137947),
(137948, '1.10.1450.10-FF-000179', NULL, 'Tetraspanin', 74, NULL, NULL, 137948),
(137949, '1.10.8.60-FF-000076', NULL, 'Stage V sporulation protein K', 90, NULL, NULL, 137949),
(137950, '3.40.50.150-FF-001616', NULL, NULL, 250, NULL, NULL, 137950),
(137951, '3.30.750.190-FF-000001', NULL, '3-hydroxyadipyl-CoA dehydrogenase', 94, NULL, NULL, 137951),
(137952, '2.10.25.10-FF-001358', NULL, 'Neuregulin 1 type IIIa isoform', 63, NULL, NULL, 137952),
(137953, '2.60.200.10-FF-000017', NULL, 'Interferon regulatory factor 3', 155, NULL, NULL, 137953),
(137954, '3.30.1140.40-FF-000012', NULL, 'Dynein light chain Tctex-type, putative', 101, NULL, NULL, 137954),
(137955, '3.30.160.60-FF-006343', NULL, NULL, 61, NULL, NULL, 137955),
(137956, '1.10.238.10-FF-001154', NULL, 'GTPase-activating protein gyp2', 199, NULL, NULL, 137956),
(137957, '3.40.50.1000-FF-000246', NULL, 'Bifunctional polynucleotide phosphatase/kinase', 215, NULL, NULL, 137957),
(137958, '3.30.60.190-FF-000020', NULL, 'Uncharacterized protein', 44, NULL, NULL, 137958),
(137959, '2.170.130.10-FF-000042', NULL, 'Transferrin-binding protein 1 Tbp1', 125, NULL, NULL, 137959),
(137960, '2.60.40.1120-FF-000076', NULL, 'Carboxypeptidase Z', 85, NULL, NULL, 137960),
(137961, '1.20.120.1900-FF-000035', NULL, 'Gamma-tubulin complex component', 310, NULL, NULL, 137961),
(137962, '3.80.10.10-FF-003724', NULL, 'Uncharacterized protein', 140, NULL, NULL, 137962),
(137963, '1.10.3520.10-FF-000011', NULL, 'Glycolipid transfer protein', 62, NULL, NULL, 137963),
(137964, '1.25.40.20-FF-000803', NULL, 'Transient receptor potential cation channel protein painless', 191, NULL, NULL, 137964),
(137965, '2.160.20.10-FF-000233', NULL, 'Pectinesterase', 227, NULL, NULL, 137965),
(137966, '1.20.58.1180-FF-000002', NULL, 'Mrpl35p', 130, NULL, NULL, 137966),
(137967, '1.20.1560.10-FF-000270', NULL, 'HlyB/MsbA family ABC transporter', 345, NULL, NULL, 137967),
(137968, '3.30.70.330-FF-002447', NULL, NULL, 86, NULL, NULL, 137968),
(137969, '3.40.50.1980-FF-000023', NULL, 'Iron ABC transporter substrate-binding protein', 101, NULL, NULL, 137969),
(137970, '3.30.540.10-FF-000063', NULL, 'Sedoheptulose-1,7-bisphosphatase', 174, NULL, NULL, 137970),
(137971, '3.40.50.300-FF-004556', NULL, 'Dynein heavy chain family protein', 272, NULL, NULL, 137971),
(137972, '2.60.120.200-FF-000278', NULL, 'Kon-tiki, isoform B', 173, NULL, NULL, 137972),
(137973, '3.30.200.20-FF-000754', NULL, 'Tyrosine kinase', 115, NULL, NULL, 137973),
(137974, '2.60.40.1760-FF-000009', NULL, 'Sugar hydrolase', 257, NULL, NULL, 137974),
(137975, '1.20.58.400-FF-000028', NULL, 'Snare region anchored in the vesicle membrane C-terminus-domain-containing protein', 90, NULL, NULL, 137975),
(137976, '3.30.230.10-FF-000253', NULL, 'Lon protease homolog 2, peroxisomal', 222, NULL, NULL, 137976),
(137977, '3.30.428.10-FF-000077', NULL, 'Putative galactose-1-phosphate uridylyltransferase-like Protein', 120, NULL, NULL, 137977),
(137978, '1.10.540.10-FF-000058', NULL, 'Acyl-CoA dehydrogenase', 112, NULL, NULL, 137978),
(137979, '3.30.70.330-FF-000261', NULL, 'RNA-binding motif protein 7', 86, NULL, NULL, 137979),
(137980, '2.60.40.60-FF-000557', NULL, 'Cadherin-related hmr-1', 124, NULL, NULL, 137980),
(137981, '3.40.20.10-FF-000175', NULL, 'Uncharacterized protein C4.03c', 136, NULL, NULL, 137981),
(137982, '3.40.50.1820-FF-000380', NULL, 'Alpha/beta fold hydrolase', 258, NULL, NULL, 137982),
(137983, '3.90.230.10-FF-000003', NULL, 'Methionine aminopeptidase 2', 289, NULL, NULL, 137983),
(137984, '2.130.10.10-FF-000678', NULL, 'Putative UV-damaged DNA binding protein', 321, NULL, NULL, 137984),
(137985, '2.60.120.260-FF-000509', NULL, 'Uncharacterized protein', 36, NULL, NULL, 137985); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(137986, '3.30.160.60-FF-000571', NULL, 'Uncharacterized protein', 28, NULL, NULL, 137986),
(137987, '2.130.10.10-FF-001616', NULL, 'Transducin family protein / WD-40 repeat family protein', 193, NULL, NULL, 137987),
(137988, '3.30.420.40-FF-000484', NULL, 'Actin related protein T3', 101, NULL, NULL, 137988),
(137989, '2.20.20.20-FF-000001', NULL, 'Baseplate wedge subunit and tail pin', 42, NULL, NULL, 137989),
(137990, '1.10.20.10-FF-000091', NULL, 'Histone H2A', 99, NULL, NULL, 137990),
(137991, '3.30.1680.10-FF-000055', NULL, 'Integrin beta', 59, NULL, NULL, 137991),
(137992, '3.40.50.850-FF-000011', NULL, 'Pyrazinamidase/nicotinamidase PncA', 186, NULL, NULL, 137992),
(137993, '3.10.100.10-FF-000343', NULL, NULL, 138, NULL, NULL, 137993),
(137994, '1.10.8.10-FF-000022', NULL, '50S ribosomal protein L3 glutamine methyltransferase', 91, NULL, NULL, 137994),
(137995, '3.30.420.40-FF-001001', NULL, 'Uncharacterized protein', 73, NULL, NULL, 137995),
(137996, '3.80.10.10-FF-001746', NULL, 'Expressed protein', 368, NULL, NULL, 137996),
(137997, '3.40.50.300-FF-002578', NULL, 'Amino acid ABC transporter ATP-binding protein', 239, NULL, NULL, 137997),
(137998, '3.40.50.300-FF-005916', NULL, 'ABC transporter (Eurofung)', 241, NULL, NULL, 137998),
(137999, '2.60.40.60-FF-001125', NULL, 'Uncharacterized protein', 133, NULL, NULL, 137999),
(138000, '3.40.50.300-FF-000341', NULL, 'High-affinity branched-chain amino acid transport ATP-binding protein', 237, NULL, NULL, 138000),
(138001, '3.30.2130.10-FF-000025', NULL, 'GATS isoform 1', 138, NULL, NULL, 138001),
(138002, '3.50.4.10-FF-000026', NULL, 'Merozoite adhesive erythrocytic binding protein', 121, NULL, NULL, 138002),
(138003, '1.25.40.10-FF-005297', NULL, 'Uncharacterized protein', 133, NULL, NULL, 138003),
(138004, '2.40.10.10-FF-000536', NULL, NULL, 94, NULL, NULL, 138004),
(138005, '3.40.50.2300-FF-001114', NULL, 'Predicted protein', 294, NULL, NULL, 138005),
(138006, '3.40.190.10-FF-000353', NULL, 'LysR family transcriptional regulator', 99, NULL, NULL, 138006),
(138007, '3.40.47.10-FF-000045', NULL, 'Hydroxymethylglutaryl-CoA synthase', 147, NULL, NULL, 138007),
(138008, '2.60.120.380-FF-000079', NULL, 'Calcium-dependent cysteine protease, putative', 74, NULL, NULL, 138008),
(138009, '3.30.420.210-FF-000001', NULL, 'NSFL1 (P97) cofactor (P47)', 65, NULL, NULL, 138009),
(138010, '3.40.1370.10-FF-000018', NULL, 'Mitochondrial 54S ribosomal protein YmL6', 241, NULL, NULL, 138010),
(138011, '3.40.50.11260-FF-000013', NULL, 'Chaperone protein HtpG', 89, NULL, NULL, 138011),
(138012, '2.40.50.40-FF-000025', NULL, 'C-C motif chemokine', 66, NULL, NULL, 138012),
(138013, '2.170.270.10-FF-000052', NULL, 'SET and MYND domain-containing protein 4', 125, NULL, NULL, 138013),
(138014, '3.40.50.1820-FF-001801', NULL, 'Uncharacterized protein', 145, NULL, NULL, 138014),
(138015, '1.25.40.10-FF-000154', NULL, 'Aspartyl/asparaginyl beta-hydroxylase', 98, NULL, NULL, 138015),
(138016, '2.30.30.140-FF-000020', NULL, 'RNA polymerase-associated protein RapA', 53, NULL, NULL, 138016),
(138017, '3.30.1380.10-FF-000010', NULL, 'D-alanyl-D-alanine dipeptidase', 178, NULL, NULL, 138017),
(138018, '1.25.10.10-FF-001754', NULL, 'Protein VAC14-like protein', 103, NULL, NULL, 138018),
(138019, '1.10.418.30-FF-000010', NULL, 'Uncharacterized protein', 89, NULL, NULL, 138019),
(138020, '1.20.1070.10-FF-001816', NULL, 'Uncharacterized protein', 356, NULL, NULL, 138020),
(138021, '1.50.10.160-FF-000015', NULL, 'Uncharacterized protein', 141, NULL, NULL, 138021),
(138022, '3.40.50.1980-FF-000074', NULL, 'Adhesion protein', 138, NULL, NULL, 138022),
(138023, '1.20.1070.10-FF-001704', NULL, 'Uncharacterized protein', 106, NULL, NULL, 138023),
(138024, '1.20.58.60-FF-000029', NULL, 'utrophin isoform X1', 108, NULL, NULL, 138024),
(138025, '1.10.472.80-FF-000173', NULL, 'GTPase-activating protein, putative', 163, NULL, NULL, 138025),
(138026, '1.10.287.110-FF-000302', NULL, 'Zgc:163044 protein', 76, NULL, NULL, 138026),
(138027, '2.40.50.140-FF-000544', NULL, 'Breast cancer 2, early onset', 146, NULL, NULL, 138027);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(138028, '3.80.10.10-FF-000386', NULL, 'Disease resistance protein RPS4', 197, NULL, NULL, 138028),
(138029, '3.10.20.230-FF-000023', NULL, 'Predicted protein', 91, NULL, NULL, 138029),
(138030, '2.30.29.30-FF-000681', NULL, 'GTP exchange factor for ARFs 1', 125, NULL, NULL, 138030),
(138031, '3.40.50.300-FF-001701', NULL, 'Uncharacterized protein, isoform D', 184, NULL, NULL, 138031),
(138032, '3.30.420.10-FF-000048', NULL, 'CCR4-associated factor 1, putative', 260, NULL, NULL, 138032),
(138033, '3.40.50.300-FF-006001', NULL, 'Peroxisomal biogenesis factor 6', 174, NULL, NULL, 138033),
(138034, '3.30.40.10-FF-000227', NULL, 'RING finger protein 214 isoform X1', 47, NULL, NULL, 138034),
(138035, '2.40.50.140-FF-001033', NULL, NULL, 141, NULL, NULL, 138035),
(138036, '3.30.50.10-FF-000025', NULL, 'GATA transcription factor', 51, NULL, NULL, 138036),
(138037, '1.10.220.20-FF-000020', NULL, 'Uncharacterized protein', 53, NULL, NULL, 138037),
(138038, '2.60.120.290-FF-000153', NULL, 'Uncharacterized protein', 112, NULL, NULL, 138038),
(138039, '3.40.50.200-FF-000069', NULL, 'Clan SB, family S8, subtilisin-like serine peptidase', 174, NULL, NULL, 138039),
(138040, '3.30.460.10-FF-000062', NULL, 'DNA polymerase', 146, NULL, NULL, 138040),
(138041, '1.20.1250.20-FF-001390', NULL, 'Uncharacterized protein', 190, NULL, NULL, 138041),
(138042, '2.60.40.10-FF-002532', NULL, 'Basigin, isoform J', 93, NULL, NULL, 138042),
(138043, '2.30.42.10-FF-000048', NULL, 'disks large homolog 1 isoform X1', 100, NULL, NULL, 138043),
(138044, '3.30.760.10-FF-000006', NULL, 'Eukaryotic translation initiation factor 4E family member 1c', 188, NULL, NULL, 138044),
(138045, '3.30.40.10-FF-000648', NULL, 'RING finger domain protein, putative', 70, NULL, NULL, 138045),
(138046, '1.20.210.10-FF-000020', NULL, 'Cytochrome c oxidase subunit 1', 269, NULL, NULL, 138046),
(138047, '3.30.413.10-FF-000032', NULL, 'Anaerobic sulfite reductase subunit c', 136, NULL, NULL, 138047),
(138048, '3.30.420.40-FF-001052', NULL, 'Phosphotransferase', 162, NULL, NULL, 138048),
(138049, '2.30.29.30-FF-000029', NULL, 'Insulin receptor substrate 1', 105, NULL, NULL, 138049),
(138050, '3.40.390.10-FF-000301', NULL, NULL, 53, NULL, NULL, 138050),
(138051, '3.30.420.40-FF-000063', NULL, 'N-acetylmannosamine kinase', 152, NULL, NULL, 138051),
(138052, '2.10.25.10-FF-000369', NULL, 'Multiple epidermal growth factor-like domains protein 11', 31, NULL, NULL, 138052),
(138053, '3.40.50.2300-FF-001165', NULL, NULL, 167, NULL, NULL, 138053),
(138054, '4.10.410.10-FF-000054', NULL, 'Protein CBR-MEC-1', 69, NULL, NULL, 138054),
(138055, '2.130.10.10-FF-004101', NULL, 'Coronin', 196, NULL, NULL, 138055),
(138056, '2.60.40.150-FF-000670', NULL, 'Uncharacterized protein', 76, NULL, NULL, 138056),
(138057, '3.90.230.10-FF-000054', NULL, NULL, 99, NULL, NULL, 138057),
(138058, '4.10.400.10-FF-000109', NULL, 'Transmembrane serine protease 7', 36, NULL, NULL, 138058),
(138059, '3.40.50.670-FF-000013', NULL, 'DNA gyrase subunit B', 111, NULL, NULL, 138059),
(138060, '1.25.10.10-FF-002243', NULL, 'Uncharacterized protein', 378, NULL, NULL, 138060),
(138061, '3.40.50.300-FF-005012', NULL, 'Adenylate dimethylallyltransferase', 141, NULL, NULL, 138061),
(138062, '2.160.20.80-FF-000001', NULL, 'Synaptic vesicle glycoprotein 2A', 101, NULL, NULL, 138062),
(138063, '1.10.246.90-FF-000010', NULL, 'U4/U6 small nuclear ribonucleoprotein Prp31', 69, NULL, NULL, 138063),
(138064, '1.10.510.10-FF-000410', NULL, 'Probable PHO85-cyclin-dependent protein kinase', 231, NULL, NULL, 138064),
(138065, '3.10.20.90-FF-000576', NULL, 'RB1-inducible coiled-coil protein 1', 80, NULL, NULL, 138065),
(138066, '2.30.130.30-FF-000002', NULL, 'Activating signal cointegrator 1', 122, NULL, NULL, 138066),
(138067, '1.10.1040.10-FF-000013', NULL, 'Ketol-acid reductoisomerase, mitochondrial', 61, NULL, NULL, 138067),
(138068, '3.80.10.10-FF-003612', NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', 92, NULL, NULL, 138068),
(138069, '3.40.630.10-FF-000388', NULL, 'Zn-dependent exopeptidase superfamily protein', 54, NULL, NULL, 138069);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(138070, '3.40.50.11380-FF-000015', NULL, NULL, 221, NULL, NULL, 138070),
(138071, '1.20.58.60-FF-000130', NULL, 'Spectrin beta chain', 107, NULL, NULL, 138071),
(138072, '1.10.10.750-FF-000038', NULL, 'TBC domain containing protein', 44, NULL, NULL, 138072),
(138073, '1.10.10.60-FF-000616', NULL, 'BAP', 99, NULL, NULL, 138073),
(138074, '1.25.10.10-FF-001703', NULL, 'Coatomer subunit beta, putative', 258, NULL, NULL, 138074),
(138075, '3.10.110.10-FF-000057', NULL, 'eukaryotic translation initiation factor 2-alpha kinase 4', 134, NULL, NULL, 138075),
(138076, '1.20.1070.10-FF-001755', NULL, 'Uncharacterized protein', 76, NULL, NULL, 138076),
(138077, '2.60.40.10-FF-000183', NULL, 'Myelin-oligodendrocyte glycoprotein', 125, NULL, NULL, 138077),
(138078, '1.50.40.10-FF-000450', NULL, 'Uncharacterized protein', 122, NULL, NULL, 138078),
(138079, '1.10.630.10-FF-000357', NULL, 'Cyp2c37-prov protein', 470, NULL, NULL, 138079),
(138080, '1.25.40.10-FF-004336', NULL, 'Pentatricopeptide repeat-containing protein', 165, NULL, NULL, 138080),
(138081, '2.130.10.10-FF-004489', NULL, 'Uncharacterized protein', 167, NULL, NULL, 138081),
(138082, '3.30.200.20-FF-000866', NULL, 'Death-associated protein kinase dapk-1', 88, NULL, NULL, 138082),
(138083, '3.10.590.10-FF-000025', NULL, 'Uncharacterized protein', 67, NULL, NULL, 138083),
(138084, '1.10.10.10-FF-001574', NULL, 'Ferric uptake regulation protein', 82, NULL, NULL, 138084),
(138085, '3.40.50.1980-FF-000135', NULL, 'Histidinol dehydrogenase', 69, NULL, NULL, 138085),
(138086, '3.40.50.300-FF-005512', NULL, 'IcmO', 153, NULL, NULL, 138086),
(138087, '3.40.366.10-FF-000020', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 84, NULL, NULL, 138087),
(138088, '3.80.10.10-FF-001307', NULL, 'EIN3-binding F-box domain containing protein', 87, NULL, NULL, 138088),
(138089, '1.10.1520.10-FF-000011', NULL, 'Ribonuclease III domain-containing protein RNC1, chloroplastic', 137, NULL, NULL, 138089),
(138090, '3.40.50.2000-FF-000737', NULL, '2-hydroxyacylsphingosine 1-beta-galactosyltransferase', 257, NULL, NULL, 138090),
(138091, '3.30.310.80-FF-000055', NULL, 'Non-specific serine/threonine protein kinase', 126, NULL, NULL, 138091),
(138092, '2.130.10.120-FF-000002', NULL, 'prolyl endopeptidase-like isoform X1', 325, NULL, NULL, 138092),
(138093, '3.30.9.10-FF-000295', NULL, 'Uncharacterized protein', 58, NULL, NULL, 138093),
(138094, '3.40.50.410-FF-000014', NULL, 'von Willebrand and RING finger domain protein', 175, NULL, NULL, 138094),
(138095, '3.30.70.1410-FF-000001', NULL, 'Hydrolase (HAD superfamily)', 87, NULL, NULL, 138095),
(138096, '2.10.110.10-FF-000174', NULL, 'Calpain family cysteine protease', 69, NULL, NULL, 138096),
(138097, '1.20.58.1070-FF-000020', NULL, 'Gem nuclear organelle associated protein 2', 38, NULL, NULL, 138097),
(138098, '2.40.50.140-FF-001084', NULL, NULL, 79, NULL, NULL, 138098),
(138099, '2.130.10.10-FF-000627', NULL, 'Bromodomain and WD repeat domain-containing protein', 139, NULL, NULL, 138099),
(138100, '3.40.525.10-FF-000031', NULL, 'Protein CBR-CGR-1', 265, NULL, NULL, 138100),
(138101, '2.160.20.10-FF-000121', NULL, 'Pectinesterase', 202, NULL, NULL, 138101),
(138102, '1.10.460.10-FF-000006', NULL, 'DNA topoisomerase', 102, NULL, NULL, 138102),
(138103, '1.25.40.20-FF-000011', NULL, 'Poly [ADP-ribose] polymerase', 163, NULL, NULL, 138103),
(138104, '3.30.160.60-FF-002369', NULL, 'C2H2 type zinc finger domain protein', 24, NULL, NULL, 138104),
(138105, '3.40.50.10050-FF-000009', NULL, 'Probable translation initiation factor IF-2', 110, NULL, NULL, 138105),
(138106, '1.10.510.10-FF-003996', NULL, NULL, 86, NULL, NULL, 138106),
(138107, '2.60.40.10-FF-001543', NULL, 'Interleukin 18 receptor 1', 97, NULL, NULL, 138107),
(138108, '2.170.150.10-FF-000037', NULL, 'Uncharacterized protein', 117, NULL, NULL, 138108),
(138109, '1.10.540.10-FF-000007', NULL, 'Isovaleryl-CoA dehydrogenase, mitochondrial', 124, NULL, NULL, 138109),
(138110, '4.10.410.10-FF-000003', NULL, 'amyloid-like protein 2 isoform X1', 67, NULL, NULL, 138110);
INSERT INTO "PUBLIC"."MODEL" VALUES
(138111, '3.40.50.720-FF-000635', NULL, 'NADP-dependent malic enzyme', 289, NULL, NULL, 138111),
(138112, '3.40.50.300-FF-001330', NULL, 'Mitochondrial Rho GTPase 1', 180, NULL, NULL, 138112),
(138113, '1.20.58.1100-FF-000017', NULL, 'Uncharacterized protein', 51, NULL, NULL, 138113),
(138114, '3.40.50.12100-FF-000001', NULL, 'Stimulator of interferon genes protein', 147, NULL, NULL, 138114),
(138115, '1.10.238.10-FF-000698', NULL, 'EF-hand domain pair, putative', 96, NULL, NULL, 138115),
(138116, '2.60.120.260-FF-000610', NULL, 'Putative secreted protein', 141, NULL, NULL, 138116),
(138117, '2.30.29.30-FF-000181', NULL, 'Arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 1', 105, NULL, NULL, 138117),
(138118, '3.30.70.1230-FF-000003', NULL, 'Adenylate cyclase', 211, NULL, NULL, 138118),
(138119, '3.10.20.440-FF-000001', NULL, 'Sarcosine oxidase, alpha subunit', 94, NULL, NULL, 138119),
(138120, '1.10.8.60-FF-000008', NULL, '26S protease regulatory subunit 10B', 72, NULL, NULL, 138120),
(138121, '3.60.21.10-FF-000485', NULL, 'Serine/threonine-protein phosphatase', 191, NULL, NULL, 138121),
(138122, '3.80.10.10-FF-003663', NULL, 'Uncharacterized protein', 85, NULL, NULL, 138122),
(138123, '2.10.25.10-FF-000869', NULL, 'Delta-like protein', 46, NULL, NULL, 138123),
(138124, '2.10.25.10-FF-001437', NULL, 'Heparan sulfate proteoglycan 2', 48, NULL, NULL, 138124),
(138125, '3.30.160.60-FF-005242', NULL, NULL, 29, NULL, NULL, 138125),
(138126, '3.90.980.20-FF-000017', NULL, 'Uncharacterized protein', 122, NULL, NULL, 138126),
(138127, '3.40.630.10-FF-000449', NULL, 'Uncharacterized protein', 174, NULL, NULL, 138127),
(138128, '3.40.190.10-FF-000432', NULL, 'ABC transporter substrate-binding protein', 208, NULL, NULL, 138128),
(138129, '1.10.10.60-FF-001105', NULL, NULL, 67, NULL, NULL, 138129),
(138130, '2.60.40.150-FF-000147', NULL, 'Phosphoinositide phospholipase C', 133, NULL, NULL, 138130),
(138131, '1.25.40.10-FF-002863', NULL, 'Pentatricopeptide repeat-containing protein At4g01990, mitochondrial', 86, NULL, NULL, 138131),
(138132, '3.40.366.10-FF-000071', NULL, 'Uncharacterized protein', 75, NULL, NULL, 138132),
(138133, '3.40.50.300-FF-004495', NULL, 'Chromosome 9, whole genome shotgun sequence', 241, NULL, NULL, 138133),
(138134, '2.60.40.60-FF-000636', NULL, 'AGAP002828-PA', 121, NULL, NULL, 138134),
(138135, '3.80.10.10-FF-003371', NULL, 'Uncharacterized protein', 108, NULL, NULL, 138135),
(138136, '2.60.40.10-FF-004218', NULL, NULL, 72, NULL, NULL, 138136),
(138137, '3.40.1190.10-FF-000021', NULL, 'UDP-N-acetylmuramoyl-L-alanyl-D-glutamate--2,6-diaminopimelate ligase', 234, NULL, NULL, 138137),
(138138, '3.40.50.720-FF-002260', NULL, 'Uncharacterized protein', 53, NULL, NULL, 138138),
(138139, '3.10.20.90-FF-000076', NULL, 'Krev interaction trapped protein 1', 100, NULL, NULL, 138139),
(138140, '3.40.1110.10-FF-000241', NULL, NULL, 69, NULL, NULL, 138140),
(138141, '1.20.58.2220-FF-000027', NULL, 'Uncharacterized protein', 360, NULL, NULL, 138141),
(138142, '1.10.238.10-FF-001215', NULL, 'Uncharacterized protein', 154, NULL, NULL, 138142),
(138143, '3.40.50.300-FF-007541', NULL, 'Uncharacterized protein', 200, NULL, NULL, 138143),
(138144, '1.20.5.110-FF-000228', NULL, 'Uncharacterized protein', 64, NULL, NULL, 138144),
(138145, '1.25.10.10-FF-000394', NULL, 'general vesicular transport factor p115', 613, NULL, NULL, 138145),
(138146, '3.40.50.300-FF-005063', NULL, 'Dynamin-related protein 4C', 135, NULL, NULL, 138146),
(138147, '3.40.850.10-FF-000432', NULL, 'Kinesin family member 13B', 151, NULL, NULL, 138147),
(138148, '2.40.10.10-FF-000165', NULL, 'Trypsin-like serine protease', 246, NULL, NULL, 138148),
(138149, '1.25.40.10-FF-001531', NULL, 'Pentatricopeptide repeat-containing protein At4g16835, mitochondrial', 149, NULL, NULL, 138149),
(138150, '3.80.10.10-FF-001807', NULL, 'Uncharacterized protein', 80, NULL, NULL, 138150),
(138151, '3.30.160.60-FF-000503', NULL, 'Zinc finger protein 276', 32, NULL, NULL, 138151),
(138152, '4.10.60.10-FF-000266', NULL, 'Uncharacterized protein', 57, NULL, NULL, 138152);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(138153, '3.40.50.300-FF-003207', NULL, 'ATLastiN (Endoplasmic reticulum GTPase) related', 213, NULL, NULL, 138153),
(138154, '1.20.58.390-FF-000154', NULL, 'CBN-LEV-8 protein', 71, NULL, NULL, 138154),
(138155, '3.40.120.10-FF-000079', NULL, 'Phosphoglucomutase-1', 207, NULL, NULL, 138155),
(138156, '3.30.470.20-FF-000116', NULL, 'Tubulin polyglutamylase ttll-4', 202, NULL, NULL, 138156),
(138157, '3.40.50.720-FF-001984', NULL, 'Uncharacterized protein', 246, NULL, NULL, 138157),
(138158, '3.30.200.20-FF-001855', NULL, 'Uncharacterized protein', 101, NULL, NULL, 138158),
(138159, '1.10.760.10-FF-000102', NULL, 'Cytochrome c-1', 72, NULL, NULL, 138159),
(138160, '1.25.40.660-FF-000018', NULL, 'Vacuolar protein sorting-associated protein 35', 313, NULL, NULL, 138160),
(138161, '2.60.40.10-FF-001190', NULL, 'Titin b', 100, NULL, NULL, 138161),
(138162, '1.10.287.210-FF-000006', NULL, 'SAGA-associated factor 11', 42, NULL, NULL, 138162),
(138163, '2.60.40.10-FF-000907', NULL, 'Platelet-derived growth factor receptor-like protein', 103, NULL, NULL, 138163),
(138164, '1.20.1070.10-FF-001316', NULL, 'Calcitonin receptor-like b', 93, NULL, NULL, 138164),
(138165, '3.40.33.10-FF-000154', NULL, 'Uncharacterized protein', 126, NULL, NULL, 138165),
(138166, '2.130.10.10-FF-005006', NULL, 'TNF receptor-associated factor 7', 54, NULL, NULL, 138166),
(138167, '2.70.170.10-FF-000080', NULL, 'Acetylcholine receptor subunit alpha-type unc-63', 247, NULL, NULL, 138167),
(138168, '1.10.1540.10-FF-000006', NULL, '40S ribosomal protein S4-3', 116, NULL, NULL, 138168),
(138169, '3.30.565.10-FF-000294', NULL, 'pyruvate dehydrogenase (Acetyl-transferring) kinase isozyme 1, mitochondrial', 99, NULL, NULL, 138169),
(138170, '2.40.10.10-FF-000457', NULL, NULL, 118, NULL, NULL, 138170),
(138171, '3.40.50.1820-FF-001740', NULL, 'Uncharacterized protein', 75, NULL, NULL, 138171),
(138172, '3.20.20.220-FF-000080', NULL, 'Proline dehydrogenase', 113, NULL, NULL, 138172),
(138173, '3.40.50.2300-FF-000176', NULL, 'metabotropic glutamate receptor 7', 136, NULL, NULL, 138173),
(138174, '3.30.710.10-FF-000216', NULL, 'Conserved protein', 107, NULL, NULL, 138174),
(138175, '3.30.300.180-FF-000004', NULL, 'Chromosomal replication initiator protein DnaA', 84, NULL, NULL, 138175),
(138176, '2.60.40.10-FF-003960', NULL, NULL, 104, NULL, NULL, 138176),
(138177, '2.60.40.1180-FF-000015', NULL, 'Alpha-mannosidase', 126, NULL, NULL, 138177),
(138178, '3.10.20.90-FF-000525', NULL, 'Ubiquitin-like protein 1-40S ribosomal protein S27a', 65, NULL, NULL, 138178),
(138179, '3.40.50.2000-FF-000237', NULL, 'Glycosyltransferase', 183, NULL, NULL, 138179),
(138180, '2.60.40.150-FF-000198', NULL, 'Phosphatidylserine decarboxylase proenzyme 2', 146, NULL, NULL, 138180),
(138181, '3.20.20.80-FF-000606', NULL, 'Os08g0518800 protein', 180, NULL, NULL, 138181),
(138182, '3.20.20.60-FF-000067', NULL, 'GG21066', 71, NULL, NULL, 138182),
(138183, '2.40.420.20-FF-000047', NULL, 'Acriflavin resistance protein AcrE', 92, NULL, NULL, 138183),
(138184, '1.10.510.10-FF-002708', NULL, NULL, 190, NULL, NULL, 138184),
(138185, '1.10.150.20-FF-000025', NULL, 'DNA repair protein REV1', 54, NULL, NULL, 138185),
(138186, '3.40.50.11500-FF-000006', NULL, 'SET binding factor 2', 179, NULL, NULL, 138186),
(138187, '3.30.160.60-FF-001060', NULL, 'Zinc finger protein OZF', 28, NULL, NULL, 138187),
(138188, '2.130.10.10-FF-002595', NULL, 'F-box and WD repeat domain-containing 4', 300, NULL, NULL, 138188),
(138189, '2.60.120.260-FF-000661', NULL, 'Predicted protein', 153, NULL, NULL, 138189),
(138190, '3.30.63.10-FF-000004', NULL, 'peripheral plasma membrane protein CASK isoform X2', 63, NULL, NULL, 138190),
(138191, '1.25.10.10-FF-002159', NULL, 'Uncharacterized protein', 514, NULL, NULL, 138191),
(138192, '3.40.5.90-FF-000001', NULL, 'CDGSH iron-sulfur domain-containing protein 1', 49, NULL, NULL, 138192),
(138193, '1.25.40.10-FF-002812', NULL, 'Uncharacterized protein', 221, NULL, NULL, 138193),
(138194, '1.10.150.390-FF-000004', NULL, 'DNA-directed RNA polymerase subunit', 58, NULL, NULL, 138194);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(138195, '2.100.10.50-FF-000011', NULL, 'Multivesicular body subunit 12B', 64, NULL, NULL, 138195),
(138196, '1.10.10.60-FF-001156', NULL, NULL, 52, NULL, NULL, 138196),
(138197, '1.25.40.10-FF-003768', NULL, 'RNA polymerase I-specific transcription initiation factor rrn11', 162, NULL, NULL, 138197),
(138198, '2.30.29.30-FF-000922', NULL, 'Uncharacterized protein', 69, NULL, NULL, 138198),
(138199, '2.60.40.690-FF-000011', NULL, 'Uncharacterized protein', 145, NULL, NULL, 138199),
(138200, '1.20.58.1030-FF-000036', NULL, 'Uncharacterized protein', 124, NULL, NULL, 138200),
(138201, '3.40.390.10-FF-000060', NULL, 'Mitochondrial intermediate peptidase, putative', 172, NULL, NULL, 138201),
(138202, '2.40.50.150-FF-000013', NULL, 'DNA-directed RNA polymerase subunit beta', 16, NULL, NULL, 138202),
(138203, '3.30.450.20-FF-000154', NULL, 'Probable diguanylate cyclase DgcE', 132, NULL, NULL, 138203),
(138204, '2.40.30.10-FF-000127', NULL, 'tRNA-specific 2-thiouridylase MnmA', 82, NULL, NULL, 138204),
(138205, '3.30.200.20-FF-001243', NULL, 'Probable inactive L-type lectin-domain containing receptor kinase III.1', 103, NULL, NULL, 138205),
(138206, '1.10.238.10-FF-000198', NULL, 'Polcalcin Phl p 7', 78, NULL, NULL, 138206),
(138207, '3.40.50.10260-FF-000022', NULL, 'Bifunctional NAD(P)H-hydrate repair enzyme', 187, NULL, NULL, 138207),
(138208, '3.30.530.20-FF-000155', NULL, 'Coenzyme Q-binding protein COQ10, mitochondrial-like Protein', 148, NULL, NULL, 138208),
(138209, '3.40.50.150-FF-001263', NULL, NULL, 256, NULL, NULL, 138209),
(138210, '3.30.559.10-FF-000201', NULL, 'Uncharacterized protein', 136, NULL, NULL, 138210),
(138211, '3.30.110.20-FF-000016', NULL, 'Rpp20, isoform B', 124, NULL, NULL, 138211),
(138212, '1.10.10.10-FF-001523', NULL, 'Predicted protein', 104, NULL, NULL, 138212),
(138213, '1.10.287.70-FF-000380', NULL, 'TOK potassium channel', 142, NULL, NULL, 138213),
(138214, '2.60.40.1460-FF-000009', NULL, 'Integrin alpha 4', 159, NULL, NULL, 138214),
(138215, '3.40.630.30-FF-000556', NULL, 'Uncharacterized protein', 130, NULL, NULL, 138215),
(138216, '3.90.350.10-FF-000001', NULL, 'IS4 family transposase', 207, NULL, NULL, 138216),
(138217, '3.30.70.330-FF-000182', NULL, 'RNA-binding motif protein 28', 93, NULL, NULL, 138217),
(138218, '3.30.450.20-FF-000446', NULL, 'Two-component sensor histidine kinase', 141, NULL, NULL, 138218),
(138219, '1.10.510.10-FF-001579', NULL, 'Cell division cycle 7 homolog (S. cerevisiae)', 234, NULL, NULL, 138219),
(138220, '3.10.20.90-FF-000817', NULL, 'Uncharacterized protein', 42, NULL, NULL, 138220),
(138221, '3.40.850.10-FF-000140', NULL, 'Kinesin-like protein', 345, NULL, NULL, 138221),
(138222, '2.120.10.30-FF-000515', NULL, 'Predicted protein', 193, NULL, NULL, 138222),
(138223, '3.40.50.720-FF-000523', NULL, 'Cinnamoyl-CoA reductase-like SNL6 isoform A', 298, NULL, NULL, 138223),
(138224, '3.30.1490.20-FF-000049', NULL, 'D-alanine--D-alanine ligase', 67, NULL, NULL, 138224),
(138225, '3.30.60.30-FF-000217', NULL, 'Uncharacterized protein', 59, NULL, NULL, 138225),
(138226, '1.10.630.10-FF-000778', NULL, 'Uncharacterized protein', 157, NULL, NULL, 138226),
(138227, '3.30.1370.10-FF-000184', NULL, 'KH homology domain-containing protein 4-like', 102, NULL, NULL, 138227),
(138228, '3.40.50.2300-FF-000625', NULL, 'Uncharacterized protein', 164, NULL, NULL, 138228),
(138229, '2.70.20.10-FF-000030', NULL, 'DNA topoisomerase III', 20, NULL, NULL, 138229),
(138230, '1.20.120.1750-FF-000113', NULL, 'RBR-type E3 ubiquitin transferase', 198, NULL, NULL, 138230),
(138231, '1.25.40.20-FF-001860', NULL, 'NAD-dependent deacetylase sir2B', 134, NULL, NULL, 138231),
(138232, '3.30.565.10-FF-000322', NULL, 'Two-component hybrid sensor and regulator', 140, NULL, NULL, 138232),
(138233, '3.30.70.330-FF-000974', NULL, 'Rim4p', 153, NULL, NULL, 138233),
(138234, '3.30.70.330-FF-002508', NULL, NULL, 71, NULL, NULL, 138234),
(138235, '1.20.1250.20-FF-001682', NULL, 'Uncharacterized protein', 205, NULL, NULL, 138235),
(138236, '3.30.360.10-FF-000077', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like protein', 171, NULL, NULL, 138236); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(138237, '1.20.1070.10-FF-001412', NULL, 'Uncharacterized protein', 332, NULL, NULL, 138237),
(138238, '2.130.10.10-FF-000599', NULL, 'Eukaryotic translation initiation factor 2A', 223, NULL, NULL, 138238),
(138239, '2.60.120.720-FF-000001', NULL, 'Spike protein P1', 155, NULL, NULL, 138239),
(138240, '3.30.530.20-FF-000059', NULL, 'SRPBCC family protein', 126, NULL, NULL, 138240),
(138241, '3.40.50.300-FF-006181', NULL, 'Uncharacterized protein', 114, NULL, NULL, 138241),
(138242, '3.30.1330.20-FF-000009', NULL, 'Tubulin beta chain', 111, NULL, NULL, 138242),
(138243, '3.10.20.90-FF-000868', NULL, 'Uncharacterized protein', 70, NULL, NULL, 138243),
(138244, '3.90.150.10-FF-000002', NULL, 'Variant surface glycoprotein 1125.4239', 198, NULL, NULL, 138244),
(138245, '2.120.10.30-FF-000566', NULL, 'Uncharacterized protein', 52, NULL, NULL, 138245),
(138246, '1.10.3470.10-FF-000029', NULL, 'Fe(3+)-hydroxamate ABC transporter permease FhuB', 324, NULL, NULL, 138246),
(138247, '3.40.395.10-FF-000048', NULL, 'Predicted protein', 91, NULL, NULL, 138247),
(138248, '2.60.120.740-FF-000007', NULL, 'Beta-galactosidase', 88, NULL, NULL, 138248),
(138249, '3.90.550.10-FF-000550', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 393, NULL, NULL, 138249),
(138250, '3.40.1230.10-FF-000008', NULL, 'Uncharacterized protein', 117, NULL, NULL, 138250),
(138251, '2.60.40.1170-FF-000097', NULL, NULL, 127, NULL, NULL, 138251),
(138252, '3.40.190.290-FF-000013', NULL, 'HTH-type transcriptional regulator SinR', 207, NULL, NULL, 138252),
(138253, '2.120.10.90-FF-000005', NULL, 'DNA topoisomerase 4 subunit A', 309, NULL, NULL, 138253),
(138254, '1.10.510.10-FF-002147', NULL, 'AGAP006960-PA', 188, NULL, NULL, 138254),
(138255, '3.90.550.50-FF-000207', NULL, 'Uncharacterized protein', 167, NULL, NULL, 138255),
(138256, '3.90.190.10-FF-000387', NULL, 'Uncharacterized protein', 68, NULL, NULL, 138256),
(138257, '1.20.1110.10-FF-000062', NULL, 'Calcium-transporting ATPase', 423, NULL, NULL, 138257),
(138258, '3.40.50.1820-FF-000228', NULL, 'Alpha/beta-Hydrolases superfamily protein', 319, NULL, NULL, 138258),
(138259, '2.30.29.30-FF-000973', NULL, 'Myotubularin-related protein 6', 97, NULL, NULL, 138259),
(138260, '1.20.120.140-FF-000034', NULL, 'Signal recognition particle receptor FtsY', 96, NULL, NULL, 138260),
(138261, '3.30.160.60-FF-005854', NULL, NULL, 67, NULL, NULL, 138261),
(138262, '3.20.20.70-FF-000688', NULL, NULL, 183, NULL, NULL, 138262),
(138263, '2.130.10.10-FF-000386', NULL, 'Plexin D1', 501, NULL, NULL, 138263),
(138264, '3.40.50.10810-FF-000232', NULL, 'Type III restriction enzyme, res subunit family protein', 252, NULL, NULL, 138264),
(138265, '1.10.1000.11-FF-000017', NULL, 'Arf guanine nucleotide exchange factor SYT1', 123, NULL, NULL, 138265),
(138266, '3.30.70.330-FF-001250', NULL, 'RNA-binding protein, putative', 125, NULL, NULL, 138266),
(138267, '2.30.29.30-FF-000630', NULL, 'GD20635', 110, NULL, NULL, 138267),
(138268, '3.40.30.10-FF-000001', NULL, 'Thioredoxin', 108, NULL, NULL, 138268),
(138269, '2.70.150.10-FF-000258', NULL, 'Uncharacterized protein', 18, NULL, NULL, 138269),
(138270, '1.10.3260.10-FF-000024', NULL, 'Predicted protein', 288, NULL, NULL, 138270),
(138271, '1.10.287.110-FF-000370', NULL, 'Putative chaperone protein DNAj', 99, NULL, NULL, 138271),
(138272, '1.10.510.10-FF-000298', NULL, 'Adenine nucleotide alpha hydrolase-like domain kinase', 204, NULL, NULL, 138272),
(138273, '1.10.1040.10-FF-000081', NULL, '2-dehydropantoate 2-reductase', 132, NULL, NULL, 138273),
(138274, '1.10.150.20-FF-000076', NULL, 'DNA repair endonuclease, putative', 68, NULL, NULL, 138274),
(138275, '3.30.70.330-FF-000761', NULL, 'Uncharacterized protein', 66, NULL, NULL, 138275),
(138276, '1.20.1250.20-FF-001631', NULL, 'YALI0E00616p', 102, NULL, NULL, 138276),
(138277, '3.90.70.10-FF-000254', NULL, 'Ubiquitin carboxyl-terminal hydrolase domain containing protein', 129, NULL, NULL, 138277),
(138278, '2.30.30.100-FF-000036', NULL, 'U6 snRNA-associated Sm-like protein LSm3', 85, NULL, NULL, 138278);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(138279, '3.20.20.450-FF-000013', NULL, 'Membrane-anchored cyclic-di-GMP phosphodiesterase', 251, NULL, NULL, 138279),
(138280, '3.40.50.720-FF-000343', NULL, 'Altronate oxidoreductase', 268, NULL, NULL, 138280),
(138281, '3.40.1350.60-FF-000009', NULL, 'Sugar fermentation stimulation protein homolog', 156, NULL, NULL, 138281),
(138282, '1.20.920.20-FF-000037', NULL, 'Flagellar outer dynein arm heavy chain gamma', 355, NULL, NULL, 138282),
(138283, '1.10.10.60-FF-000588', NULL, 'Transcription factor MYB36', 48, NULL, NULL, 138283),
(138284, '3.30.260.10-FF-000013', NULL, 'T-complex protein 1 subunit theta', 103, NULL, NULL, 138284),
(138285, '1.10.238.10-FF-001266', NULL, 'Uncharacterized protein', 54, NULL, NULL, 138285),
(138286, '1.20.1250.20-FF-000221', NULL, 'solute carrier family 2, facilitated glucose transporter member 6', 468, NULL, NULL, 138286),
(138287, '1.10.10.10-FF-000146', NULL, 'PCI domain-containing protein 2 homolog', 72, NULL, NULL, 138287),
(138288, '2.60.40.10-FF-005758', NULL, NULL, 91, NULL, NULL, 138288),
(138289, '3.30.450.20-FF-000497', NULL, 'Sensor histidine kinase, PAS, PAS, PAS and PAS domain-containing', 121, NULL, NULL, 138289),
(138290, '2.30.39.10-FF-000029', NULL, 'SeRPin', 124, NULL, NULL, 138290),
(138291, '3.80.10.10-FF-003320', NULL, 'Uncharacterized protein', 130, NULL, NULL, 138291),
(138292, '4.10.400.10-FF-000177', NULL, 'Terribly reduced optic lobes, isoform AH', 35, NULL, NULL, 138292),
(138293, '3.40.50.1240-FF-000094', NULL, 'Acid phosphatase 1, isoform B', 349, NULL, NULL, 138293),
(138294, '2.40.70.10-FF-000192', NULL, 'Pol polyprotein', 104, NULL, NULL, 138294),
(138295, '3.30.160.60-FF-003033', NULL, 'Draculin-like 3', 29, NULL, NULL, 138295),
(138296, '2.60.120.200-FF-000750', NULL, 'Uncharacterized protein', 133, NULL, NULL, 138296),
(138297, '3.40.50.300-FF-001622', NULL, 'Dynein, axonemal, heavy chain 14', 247, NULL, NULL, 138297),
(138298, '3.30.559.10-FF-000252', NULL, 'Nonribosomal peptide synthetase asqK', 45, NULL, NULL, 138298),
(138299, '3.20.100.30-FF-000004', NULL, 'Vacuolar transporter chaperone, putative', 304, NULL, NULL, 138299),
(138300, '1.10.8.680-FF-000002', NULL, 'AGAP002392-PA-like protein', 78, NULL, NULL, 138300),
(138301, '1.10.135.10-FF-000009', NULL, 'Arginine kinase, putative', 57, NULL, NULL, 138301),
(138302, '2.60.40.10-FF-002420', NULL, 'Obscurin-like 1b', 91, NULL, NULL, 138302),
(138303, '3.30.200.20-FF-002199', NULL, 'Predicted protein', 50, NULL, NULL, 138303),
(138304, '2.30.42.10-FF-000436', NULL, NULL, 94, NULL, NULL, 138304),
(138305, '3.40.50.1820-FF-001689', NULL, 'Predicted protein', 217, NULL, NULL, 138305),
(138306, '3.20.20.300-FF-000047', NULL, 'Beta-hexosaminidase', 309, NULL, NULL, 138306),
(138307, '3.40.50.300-FF-006905', NULL, 'Predicted protein', 238, NULL, NULL, 138307),
(138308, '2.60.40.10-FF-002448', NULL, 'MPL proto-oncogene, thrombopoietin receptor', 104, NULL, NULL, 138308),
(138309, '3.30.160.60-FF-005803', NULL, NULL, 92, NULL, NULL, 138309),
(138310, '1.10.150.240-FF-000117', NULL, 'Hydrolase, CbbY/CbbZ/GpH/YieH family', 68, NULL, NULL, 138310),
(138311, '3.40.30.10-FF-000973', NULL, 'Uncharacterized protein', 95, NULL, NULL, 138311),
(138312, '1.25.40.10-FF-002071', NULL, 'Tola protein homolog1', 195, NULL, NULL, 138312),
(138313, '3.10.580.10-FF-000199', NULL, 'Uncharacterized protein', 37, NULL, NULL, 138313),
(138314, '2.60.98.20-FF-000004', NULL, 'Flagellar hook protein FlgE', 177, NULL, NULL, 138314),
(138315, '1.25.40.10-FF-001582', NULL, 'Pentatricopeptide repeat-containing protein At3g16010', 70, NULL, NULL, 138315),
(138316, '3.30.565.10-FF-000373', NULL, 'Hybrid sensory kinase', 159, NULL, NULL, 138316),
(138317, '3.40.50.300-FF-002139', NULL, 'GTP-binding protein YPT10', 193, NULL, NULL, 138317),
(138318, '3.40.850.10-FF-000320', NULL, 'Kinesin-like protein', 378, NULL, NULL, 138318),
(138319, '2.60.120.40-FF-000059', NULL, 'Multimerin 2', 136, NULL, NULL, 138319),
(138320, '2.60.40.420-FF-000251', NULL, 'Uncharacterized protein', 148, NULL, NULL, 138320),
(138321, '1.10.510.10-FF-002939', NULL, NULL, 169, NULL, NULL, 138321);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(138322, '3.40.50.300-FF-004899', NULL, 'Ras-related protein, putative', 82, NULL, NULL, 138322),
(138323, '1.20.1250.20-FF-000850', NULL, 'Uncharacterized protein', 199, NULL, NULL, 138323),
(138324, '1.20.120.1750-FF-000029', NULL, 'RBR-type E3 ubiquitin transferase', 107, NULL, NULL, 138324),
(138325, '1.25.10.10-FF-001142', NULL, 'Uncharacterized protein', 137, NULL, NULL, 138325),
(138326, '2.40.50.430-FF-000007', NULL, 'Putative DNA polymerase delta subunit 2', 125, NULL, NULL, 138326),
(138327, '3.30.1360.60-FF-000001', NULL, 'PTS system glucose-specific IIBC component PtsG', 79, NULL, NULL, 138327),
(138328, '3.40.50.2000-FF-000176', NULL, 'UDP glucuronosyltransferase 1 family, polypeptide A7', 254, NULL, NULL, 138328),
(138329, '3.30.160.60-FF-001852', NULL, 'Zinc finger protein 136', 27, NULL, NULL, 138329),
(138330, '1.10.472.10-FF-000697', NULL, 'Uncharacterized protein', 68, NULL, NULL, 138330),
(138331, '4.10.60.10-FF-000154', NULL, 'Replication protein A subunit', 32, NULL, NULL, 138331),
(138332, '1.25.10.10-FF-000618', NULL, 'Sister chromatid cohesion protein PDS5 B', 178, NULL, NULL, 138332),
(138333, '1.20.5.190-FF-000033', NULL, 'IQ motif containing GTPase activating protein 3', 48, NULL, NULL, 138333),
(138334, '3.40.190.10-FF-000061', NULL, 'Glutamate receptor, ionotropic kainate', 100, NULL, NULL, 138334),
(138335, '3.30.60.20-FF-000147', NULL, 'Diacylglycerol kinase', 66, NULL, NULL, 138335),
(138336, '3.30.60.20-FF-000091', NULL, 'Diacylglycerol kinase', 49, NULL, NULL, 138336),
(138337, '1.10.510.10-FF-001315', NULL, 'Putative calcium/calmodulin-dependent protein kinase', 188, NULL, NULL, 138337),
(138338, '3.40.50.720-FF-001916', NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', 57, NULL, NULL, 138338),
(138339, '3.30.200.20-FF-001030', NULL, 'Kinase, AGC AKT', 85, NULL, NULL, 138339),
(138340, '3.80.10.10-FF-004101', NULL, 'Tyrosine-protein kinase receptor', 119, NULL, NULL, 138340),
(138341, '3.30.780.10-FF-000041', NULL, 'Translation initiation factor SUI1 family protein', 102, NULL, NULL, 138341),
(138342, '1.20.58.390-FF-000042', NULL, '5-hydroxytryptamine receptor 3C', 110, NULL, NULL, 138342),
(138343, '1.20.1270.60-FF-000329', NULL, 'Sorting nexin-41', 179, NULL, NULL, 138343),
(138344, '1.25.40.990-FF-000033', NULL, 'protein xmas-2', 295, NULL, NULL, 138344),
(138345, '1.20.5.1930-FF-000002', NULL, 'Sensor protein', 87, NULL, NULL, 138345),
(138346, '1.10.238.10-FF-000777', NULL, 'Uncharacterized protein', 46, NULL, NULL, 138346),
(138347, '2.130.10.10-FF-005118', NULL, 'Uncharacterized protein', 123, NULL, NULL, 138347),
(138348, '2.60.40.60-FF-000265', NULL, 'Cadherin 12', 118, NULL, NULL, 138348),
(138349, '2.130.10.10-FF-001908', NULL, 'WD repeat protein (AFU_orthologue AFUA_6G12600)', 375, NULL, NULL, 138349),
(138350, '2.30.30.490-FF-000102', NULL, 'Uncharacterized protein', 176, NULL, NULL, 138350),
(138351, '3.90.70.10-FF-000546', NULL, 'Ubiquitinyl hydrolase 1', 429, NULL, NULL, 138351),
(138352, '2.60.120.260-FF-000161', NULL, 'Probable allantoicase', 147, NULL, NULL, 138352),
(138353, '1.25.40.10-FF-002312', NULL, 'Pentatricopeptide repeat-containing protein At5g10690', 107, NULL, NULL, 138353),
(138354, '1.20.1070.10-FF-001204', NULL, 'Uncharacterized protein', 128, NULL, NULL, 138354),
(138355, '3.40.570.10-FF-000006', NULL, 'ectonucleotide pyrophosphatase/phosphodiesterase family member 1', 325, NULL, NULL, 138355),
(138356, '3.30.160.60-FF-002948', NULL, NULL, 28, NULL, NULL, 138356),
(138357, '2.60.120.200-FF-000306', NULL, 'Laminin-like protein epi-1', 156, NULL, NULL, 138357),
(138358, '2.60.40.150-FF-000208', NULL, 'Protein BONZAI 2', 134, NULL, NULL, 138358),
(138359, '3.20.20.80-FF-000674', NULL, 'Predicted protein', 348, NULL, NULL, 138359),
(138360, '1.10.730.10-FF-000050', NULL, 'Isoleucine-tRNA ligase, putative', 199, NULL, NULL, 138360),
(138361, '3.40.80.10-FF-000004', NULL, 'Peptidoglycan recognition protein 4', 158, NULL, NULL, 138361),
(138362, '2.60.40.1260-FF-000005', NULL, 'CRE-LMN-1 protein', 154, NULL, NULL, 138362);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(138363, '2.60.260.20-FF-000081', NULL, 'Chaperone protein dnaJ', 81, NULL, NULL, 138363),
(138364, '3.30.160.60-FF-006259', NULL, NULL, 77, NULL, NULL, 138364),
(138365, '3.40.50.300-FF-007018', NULL, 'Uncharacterized protein MG268', 207, NULL, NULL, 138365),
(138366, '1.10.510.10-FF-000798', NULL, 'caM kinase-like vesicle-associated protein isoform X2', 86, NULL, NULL, 138366),
(138367, '2.60.40.10-FF-002499', NULL, 'ImpL2, isoform B', 120, NULL, NULL, 138367),
(138368, '1.20.58.1120-FF-000063', NULL, NULL, 111, NULL, NULL, 138368),
(138369, '2.60.40.1180-FF-000083', NULL, 'Putative calpain-like cysteine peptidase', 104, NULL, NULL, 138369),
(138370, '1.20.1070.10-FF-000687', NULL, 'Si:ch73-379f7.4', 312, NULL, NULL, 138370),
(138371, '1.20.5.120-FF-000006', NULL, 'Protein CBG13260', 58, NULL, NULL, 138371),
(138372, '1.10.510.10-FF-004064', NULL, NULL, 101, NULL, NULL, 138372),
(138373, '1.10.630.10-FF-000806', NULL, 'Uncharacterized protein', 399, NULL, NULL, 138373),
(138374, '3.30.2350.20-FF-000005', NULL, 'pseudouridylate synthase 7 homolog-like protein', 199, NULL, NULL, 138374),
(138375, '2.30.30.790-FF-000023', NULL, 'Mitochondrial ribosomal protein, putative (AFU_orthologue AFUA_5G09490)', 50, NULL, NULL, 138375),
(138376, '3.40.640.10-FF-000394', NULL, 'Uncharacterized protein', 107, NULL, NULL, 138376),
(138377, '3.40.50.1400-FF-000046', NULL, 'Ferrochelatase', 77, NULL, NULL, 138377),
(138378, '3.30.930.10-FF-000199', NULL, 'Octanoyltransferase LipM', 273, NULL, NULL, 138378),
(138379, '3.40.50.300-FF-001673', NULL, 'Probable helicase MAGATAMA 3', 248, NULL, NULL, 138379),
(138380, '2.60.40.640-FF-000018', NULL, 'HECT-type ubiquitin ligase-interacting protein creD', 154, NULL, NULL, 138380),
(138381, '2.40.330.10-FF-000003', NULL, 'B3 domain-containing transcription factor FUS3', 116, NULL, NULL, 138381),
(138382, '3.80.10.10-FF-000414', NULL, 'Nuclear RNA export factor 3', 66, NULL, NULL, 138382),
(138383, '1.25.40.90-FF-000043', NULL, 'Protein NRD1', 156, NULL, NULL, 138383),
(138384, '2.60.40.10-FF-003437', NULL, NULL, 104, NULL, NULL, 138384),
(138385, '1.10.533.10-FF-000103', NULL, 'MALT1 paracaspase', 31, NULL, NULL, 138385),
(138386, '3.30.40.10-FF-001284', NULL, 'Uncharacterized protein', 69, NULL, NULL, 138386),
(138387, '1.25.70.10-FF-000010', NULL, 'Transcription termination factor MTEF1, chloroplastic', 169, NULL, NULL, 138387),
(138388, '1.20.5.1030-FF-000002', NULL, 'Protein translocase subunit SecE', 57, NULL, NULL, 138388),
(138389, '3.20.70.20-FF-000002', NULL, 'Autonomous glycyl radical cofactor', 63, NULL, NULL, 138389),
(138390, '3.40.50.1000-FF-000538', NULL, NULL, 177, NULL, NULL, 138390),
(138391, '3.40.50.300-FF-008322', NULL, 'ABC transporter AbcH.3', 245, NULL, NULL, 138391),
(138392, '3.40.50.1820-FF-000672', NULL, 'Alpha/beta_hydrolase_family/alpha /beta_hydrolase_fold_-_putative', 304, NULL, NULL, 138392),
(138393, '6.10.140.2220-FF-000025', NULL, 'Uncharacterized protein, isoform A', 61, NULL, NULL, 138393),
(138394, '3.20.20.140-FF-000095', NULL, 'DNA polymerase III subunit epsilon', 36, NULL, NULL, 138394),
(138395, '2.60.120.330-FF-000154', NULL, 'Uncharacterized protein', 86, NULL, NULL, 138395),
(138396, '2.30.29.30-FF-001198', NULL, 'Arf-GAP with dual PH domain-containing protein 1', 67, NULL, NULL, 138396),
(138397, '2.60.120.260-FF-000217', NULL, 'Netrin 5', 217, NULL, NULL, 138397),
(138398, '3.30.160.60-FF-000863', NULL, 'fez family zinc finger protein 2', 40, NULL, NULL, 138398),
(138399, '1.20.1280.50-FF-000153', NULL, 'F-box/LRR-repeat protein 4', 38, NULL, NULL, 138399),
(138400, '2.20.100.10-FF-000221', NULL, 'Metalloendopeptidase', 58, NULL, NULL, 138400),
(138401, '3.90.1410.10-FF-000090', NULL, 'Uncharacterized protein', 317, NULL, NULL, 138401),
(138402, '2.60.120.920-FF-000168', NULL, 'Mediterranean fever', 111, NULL, NULL, 138402),
(138403, '1.20.1250.20-FF-002019', NULL, 'Predicted protein', 362, NULL, NULL, 138403),
(138404, '1.10.510.10-FF-004221', NULL, NULL, 209, NULL, NULL, 138404),
(138405, '3.10.350.10-FF-000002', NULL, 'Oxidation resistance protein 1 isoform X1', 66, NULL, NULL, 138405);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(138406, '2.60.40.10-FF-004865', NULL, NULL, 116, NULL, NULL, 138406),
(138407, '1.25.10.10-FF-000894', NULL, 'RING-type E3 ubiquitin transferase', 294, NULL, NULL, 138407),
(138408, '3.30.70.580-FF-000060', NULL, 'tRNA pseudouridine synthase', 118, NULL, NULL, 138408),
(138409, '2.60.40.3330-FF-000003', NULL, 'Transthyretin-like protein 52', 110, NULL, NULL, 138409),
(138410, '1.10.1450.10-FF-000151', NULL, 'Tetraspanin', 121, NULL, NULL, 138410),
(138411, '3.30.565.10-FF-000030', NULL, 'Ethylene receptor 1', 183, NULL, NULL, 138411),
(138412, '3.30.710.10-FF-000155', NULL, 'Longitudinals lacking protein, isoforms F/I/K/T', 119, NULL, NULL, 138412),
(138413, '3.30.70.330-FF-001542', NULL, 'RH03791p', 152, NULL, NULL, 138413),
(138414, '2.130.10.10-FF-005450', NULL, 'Uncharacterized protein', 199, NULL, NULL, 138414),
(138415, '2.60.40.10-FF-004741', NULL, NULL, 97, NULL, NULL, 138415),
(138416, '3.90.180.10-FF-000173', NULL, 'Uncharacterized protein', 45, NULL, NULL, 138416),
(138417, '1.10.10.10-FF-001231', NULL, 'RNA polymerase III subunit C3', 89, NULL, NULL, 138417),
(138418, '2.130.10.10-FF-001055', NULL, 'Ribosome assembly protein 4, putative', 190, NULL, NULL, 138418),
(138419, '3.30.160.60-FF-001700', NULL, 'Zinc finger protein 677', 29, NULL, NULL, 138419),
(138420, '3.90.550.10-FF-000662', NULL, 'Predicted protein', 121, NULL, NULL, 138420),
(138421, '1.20.1560.10-FF-000331', NULL, 'Uncharacterized protein', 303, NULL, NULL, 138421),
(138422, '4.10.1240.10-FF-000026', NULL, 'Blast:Peroxidasin homolog', 58, NULL, NULL, 138422),
(138423, '3.20.20.80-FF-000045', NULL, 'Glucosidase II alpha subunit', 320, NULL, NULL, 138423),
(138424, '2.20.25.10-FF-000048', NULL, 'DNA-directed RNA polymerase subunit', 46, NULL, NULL, 138424),
(138425, '3.20.20.70-FF-000396', NULL, 'Probable oxidoreductase', 380, NULL, NULL, 138425),
(138426, '2.130.10.10-FF-001167', NULL, 'Uncharacterized protein', 343, NULL, NULL, 138426),
(138427, '2.70.150.10-FF-000078', NULL, 'Phospholipid-transporting ATPase', 149, NULL, NULL, 138427),
(138428, '3.30.9.10-FF-000082', NULL, 'D-amino acid dehydrogenase', 142, NULL, NULL, 138428),
(138429, '2.60.40.60-FF-001064', NULL, 'Uncharacterized protein', 62, NULL, NULL, 138429),
(138430, '1.10.20.10-FF-000332', NULL, NULL, 114, NULL, NULL, 138430),
(138431, '3.40.50.1820-FF-001397', NULL, 'Putative esterase/lipase 1', 212, NULL, NULL, 138431),
(138432, '2.60.40.180-FF-000015', NULL, '5-hydroxyisourate hydrolase', 126, NULL, NULL, 138432),
(138433, '3.30.40.10-FF-002065', NULL, 'Uncharacterized protein', 127, NULL, NULL, 138433),
(138434, '2.80.10.50-FF-000057', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 137, NULL, NULL, 138434),
(138435, '3.40.50.10190-FF-000214', NULL, 'Breast cancer type 1 susceptibility protein homolog', 95, NULL, NULL, 138435),
(138436, '3.90.1150.210-FF-000027', NULL, 'F-actin-capping protein subunit beta', 47, NULL, NULL, 138436),
(138437, '3.40.50.150-FF-000711', NULL, 'Yersiniabactin polyketide/non-ribosomal peptide synthetase', 252, NULL, NULL, 138437),
(138438, '3.40.50.300-FF-008446', NULL, 'Uncharacterized protein', 68, NULL, NULL, 138438),
(138439, '3.90.1150.10-FF-000491', NULL, 'Putative cystathionine gamma-synthase', 167, NULL, NULL, 138439),
(138440, '1.20.1090.10-FF-000014', NULL, 'Alcohol dehydrogenase, iron-dependent', 195, NULL, NULL, 138440),
(138441, '3.30.1120.90-FF-000003', NULL, 'Nucleosome assembly protein', 180, NULL, NULL, 138441),
(138442, '1.10.442.10-FF-000009', NULL, NULL, 55, NULL, NULL, 138442),
(138443, '2.10.22.10-FF-000003', NULL, 'Cysteine rich transmembrane BMP regulator 1', 35, NULL, NULL, 138443),
(138444, '2.120.10.80-FF-000295', NULL, 'Uncharacterized protein', 328, NULL, NULL, 138444),
(138445, '3.30.420.40-FF-000776', NULL, 'Hydantoin utilization protein A', 88, NULL, NULL, 138445),
(138446, '1.10.2000.10-FF-000073', NULL, NULL, 97, NULL, NULL, 138446),
(138447, '3.40.50.150-FF-000599', NULL, 'Protein arginine N-methyltransferase 7', 147, NULL, NULL, 138447),
(138448, '4.10.640.10-FF-000043', NULL, '28S ribosomal protein S18b, mitochondrial-like', 65, NULL, NULL, 138448);
INSERT INTO "PUBLIC"."MODEL" VALUES
(138449, '2.60.320.20-FF-000001', NULL, 'Envelope glycoprotein E2', 89, NULL, NULL, 138449),
(138450, '3.30.160.60-FF-005011', NULL, NULL, 79, NULL, NULL, 138450),
(138451, '3.40.190.290-FF-000064', NULL, 'Transcriptional regulator LysR family', 199, NULL, NULL, 138451),
(138452, '1.25.40.10-FF-002520', NULL, 'DNA-binding SARP family transcriptional activator', 163, NULL, NULL, 138452),
(138453, '1.20.58.60-FF-000681', NULL, 'Microtubule-actin crosslinking factor 1', 115, NULL, NULL, 138453),
(138454, '3.40.350.10-FF-000063', NULL, 'xaa-Pro aminopeptidase 1', 164, NULL, NULL, 138454),
(138455, '2.60.40.10-FF-002712', NULL, 'Predicted protein', 92, NULL, NULL, 138455),
(138456, '3.10.100.10-FF-000282', NULL, NULL, 98, NULL, NULL, 138456),
(138457, '1.10.8.720-FF-000054', NULL, 'Dynein heavy chain', 173, NULL, NULL, 138457),
(138458, '2.40.50.690-FF-000006', NULL, 'Exosome complex exonuclease RRP44 homolog A', 108, NULL, NULL, 138458),
(138459, '3.40.50.2300-FF-000889', NULL, NULL, 141, NULL, NULL, 138459),
(138460, '1.20.1560.10-FF-000882', NULL, 'Uncharacterized protein', 207, NULL, NULL, 138460),
(138461, '2.60.40.60-FF-000057', NULL, 'protocadherin-15 isoform X1', 111, NULL, NULL, 138461),
(138462, '3.90.470.20-FF-000046', NULL, 'Uncharacterized protein', 129, NULL, NULL, 138462),
(138463, '3.40.140.10-FF-000249', NULL, 'Uncharacterized protein', 147, NULL, NULL, 138463),
(138464, '1.10.10.60-FF-001044', NULL, NULL, 68, NULL, NULL, 138464),
(138465, '1.10.510.10-FF-000910', NULL, 'Wall-associated receptor kinase 3', 209, NULL, NULL, 138465),
(138466, '3.40.50.720-FF-001063', NULL, 'NADH:ubiquinone oxidoreductase subunit A9', 192, NULL, NULL, 138466),
(138467, '1.25.10.10-FF-002131', NULL, 'Serine/threonine-protein kinase TOR', 167, NULL, NULL, 138467),
(138468, '2.30.29.30-FF-001378', NULL, 'Uncharacterized protein', 123, NULL, NULL, 138468),
(138469, '3.10.270.10-FF-000001', NULL, 'Uricase', 304, NULL, NULL, 138469),
(138470, '1.10.10.820-FF-000003', NULL, 'unconventional myosin-IXa isoform X1', 77, NULL, NULL, 138470),
(138471, '3.40.50.1820-FF-001768', NULL, 'Lipase', 216, NULL, NULL, 138471),
(138472, '2.130.10.10-FF-003937', NULL, 'Uncharacterized protein', 252, NULL, NULL, 138472),
(138473, '1.10.10.750-FF-000010', NULL, 'EVI5-like protein isoform X1', 53, NULL, NULL, 138473),
(138474, '1.25.10.10-FF-001967', NULL, 'Serine/threonine-protein kinase VPS15', 206, NULL, NULL, 138474),
(138475, '1.25.40.10-FF-001874', NULL, 'Uncharacterized protein yjr088c homologue, putative', 181, NULL, NULL, 138475),
(138476, '1.10.555.10-FF-000148', NULL, NULL, 74, NULL, NULL, 138476),
(138477, '1.10.1420.10-FF-000059', NULL, 'MutS homolog 3 (E. coli)', 128, NULL, NULL, 138477),
(138478, '3.30.479.30-FF-000026', NULL, 'Uncharacterized protein', 132, NULL, NULL, 138478),
(138479, '1.10.150.90-FF-000001', NULL, 'Gag polyprotein', 132, NULL, NULL, 138479),
(138480, '3.30.160.60-FF-003729', NULL, NULL, 32, NULL, NULL, 138480),
(138481, '1.20.58.1220-FF-000003', NULL, 'Exocyst 84, isoform B', 97, NULL, NULL, 138481),
(138482, '2.60.40.10-FF-003229', NULL, 'T-cell surface antigen CD2', 100, NULL, NULL, 138482),
(138483, '3.30.40.10-FF-002273', NULL, 'Kinesin-like protein', 53, NULL, NULL, 138483),
(138484, '2.10.90.10-FF-000087', NULL, 'Bone morphogenetic protein 5', 76, NULL, NULL, 138484),
(138485, '1.10.150.50-FF-000068', NULL, 'Ephrin type-B receptor 6', 78, NULL, NULL, 138485),
(138486, '3.90.1150.10-FF-000159', NULL, 'Glycine dehydrogenase (decarboxylating)', 64, NULL, NULL, 138486),
(138487, '3.30.200.20-FF-001294', NULL, 'Uncharacterized protein', 96, NULL, NULL, 138487),
(138488, '3.40.50.300-FF-000684', NULL, 'Elongation factor 2', 216, NULL, NULL, 138488),
(138489, '3.40.50.150-FF-001375', NULL, NULL, 176, NULL, NULL, 138489),
(138490, '1.10.10.10-FF-001731', NULL, 'Two component transcriptional regulator, winged helix family', 105, NULL, NULL, 138490),
(138491, '3.40.50.1110-FF-000015', NULL, 'GDSL family lipase', 195, NULL, NULL, 138491),
(138492, '3.90.79.10-FF-000302', NULL, 'Uncharacterized protein', 58, NULL, NULL, 138492);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(138493, '3.90.70.10-FF-000833', NULL, 'Uncharacterized protein', 151, NULL, NULL, 138493),
(138494, '1.10.1170.10-FF-000017', NULL, 'Death-associated inhibitor of apoptosis 1', 121, NULL, NULL, 138494),
(138495, '3.30.559.30-FF-000027', NULL, 'Nonribosomal peptide synthase 2', 237, NULL, NULL, 138495),
(138496, '3.30.559.10-FF-000021', NULL, 'O-acyltransferase WSD1', 192, NULL, NULL, 138496),
(138497, '3.40.1810.10-FF-000075', NULL, NULL, 69, NULL, NULL, 138497),
(138498, '2.40.110.10-FF-000060', NULL, 'Acyl-CoA dehydrogenase', 105, NULL, NULL, 138498),
(138499, '1.25.40.10-FF-005185', NULL, 'Clathrin and VPS domain-containing protein', 242, NULL, NULL, 138499),
(138500, '3.40.50.2300-FF-000737', NULL, 'Histidine kinase', 123, NULL, NULL, 138500),
(138501, '3.40.640.10-FF-000506', NULL, 'Putative diaminobutyrate-pyruvate aminotransferase', 68, NULL, NULL, 138501),
(138502, '2.60.120.10-FF-000808', NULL, 'Uncharacterized protein', 114, NULL, NULL, 138502),
(138503, '2.40.50.90-FF-000051', NULL, 'Unplaced genomic scaffold supercont1.17, whole genome shotgun sequence', 131, NULL, NULL, 138503),
(138504, '3.40.50.1220-FF-000048', NULL, 'Electron-transfer-flavoprotein, alpha polypeptide, putative', 132, NULL, NULL, 138504),
(138505, '1.20.120.1150-FF-000001', NULL, 'Serine/threonine-protein phosphatase 2A activator', 111, NULL, NULL, 138505),
(138506, '1.10.1450.10-FF-000067', NULL, 'Tetraspanin', 99, NULL, NULL, 138506),
(138507, '2.40.170.20-FF-000117', NULL, 'SusC homolog', 568, NULL, NULL, 138507),
(138508, '2.40.50.90-FF-000107', NULL, 'Transcription factor (Snd1/p100), putative', 116, NULL, NULL, 138508),
(138509, '3.30.70.330-FF-000822', NULL, 'Ribosome biogenesis (Nop4), putative', 133, NULL, NULL, 138509),
(138510, '2.20.100.10-FF-000160', NULL, 'spondin-1', 50, NULL, NULL, 138510),
(138511, '3.40.50.300-FF-001122', NULL, 'AAA-ATPase ASD, mitochondrial', 185, NULL, NULL, 138511),
(138512, '2.10.25.10-FF-001729', NULL, 'Uncharacterized protein', 39, NULL, NULL, 138512),
(138513, '2.130.10.10-FF-000447', NULL, 'Denticleless protein homolog B', 127, NULL, NULL, 138513),
(138514, '3.90.70.10-FF-000193', NULL, 'Ubiquitinyl hydrolase 1', 248, NULL, NULL, 138514),
(138515, '2.130.10.10-FF-003584', NULL, 'Coronin', 244, NULL, NULL, 138515),
(138516, '1.20.1310.10-FF-000043', NULL, 'Cullin-1, putative', 128, NULL, NULL, 138516),
(138517, '1.20.1640.10-FF-000096', NULL, NULL, 196, NULL, NULL, 138517),
(138518, '3.40.1550.10-FF-000004', NULL, 'CheC-like family protein', 151, NULL, NULL, 138518),
(138519, '1.10.565.10-FF-000109', NULL, 'Nuclear receptor, putative', 84, NULL, NULL, 138519),
(138520, '3.40.630.10-FF-000157', NULL, 'Dipeptidase B, isoform A', 350, NULL, NULL, 138520),
(138521, '1.20.5.590-FF-000001', NULL, 'Protein phosphatase CheZ', 34, NULL, NULL, 138521),
(138522, '2.10.25.10-FF-000577', NULL, 'Dumpy, isoform P', 41, NULL, NULL, 138522),
(138523, '1.20.1250.20-FF-001238', NULL, 'Solute carrier organic anion transporter family member', 391, NULL, NULL, 138523),
(138524, '1.20.1250.20-FF-001182', NULL, 'Jen2p', 202, NULL, NULL, 138524),
(138525, '3.10.105.10-FF-000039', NULL, 'Probable glycine betaine-binding protein', 89, NULL, NULL, 138525),
(138526, '2.60.120.650-FF-000132', NULL, 'Uncharacterized protein', 62, NULL, NULL, 138526),
(138527, '3.40.33.10-FF-000103', NULL, 'Uncharacterized protein', 143, NULL, NULL, 138527),
(138528, '3.30.160.60-FF-003145', NULL, 'CG14655', 22, NULL, NULL, 138528),
(138529, '2.30.29.30-FF-000473', NULL, 'Mitogen-activated protein kinase', 108, NULL, NULL, 138529),
(138530, '3.30.160.60-FF-000683', NULL, 'Zinc finger protein 252', 28, NULL, NULL, 138530),
(138531, '2.60.40.10-FF-005989', NULL, NULL, 88, NULL, NULL, 138531),
(138532, '3.10.280.10-FF-000007', NULL, 'Regulatory protein SUAPRGA1', 220, NULL, NULL, 138532),
(138533, '3.60.70.12-FF-000011', NULL, 'Arginine biosynthesis bifunctional protein ArgJ 1, mitochondrial', 132, NULL, NULL, 138533),
(138534, '3.30.70.1710-FF-000001', NULL, 'Ethanolamine utilization protein EutM', 102, NULL, NULL, 138534);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(138535, '3.40.50.720-FF-001804', NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', 116, NULL, NULL, 138535),
(138536, '1.20.120.230-FF-000010', NULL, 'Vinculin a', 188, NULL, NULL, 138536),
(138537, '1.10.510.10-FF-001427', NULL, 'Serine/threonine-protein kinase', 202, NULL, NULL, 138537),
(138538, '3.40.50.1970-FF-000037', NULL, 'Probable iron-containing alcohol dehydrogenase', 194, NULL, NULL, 138538),
(138539, '3.40.50.300-FF-006973', NULL, 'Polynucleotide 5''-hydroxyl-kinase NOL9-like Protein', 219, NULL, NULL, 138539),
(138540, '3.30.497.10-FF-000040', NULL, 'Serpin, putative', 201, NULL, NULL, 138540),
(138541, '3.40.50.970-FF-000160', NULL, 'Sulfite reductase (NADPH) subunit beta', 145, NULL, NULL, 138541),
(138542, '3.40.50.410-FF-000082', NULL, 'Collagen type VI alpha 5 chain', 193, NULL, NULL, 138542),
(138543, '2.60.40.640-FF-000086', NULL, 'Putative arrestin-related trafficking adapter SPBC839.02', 166, NULL, NULL, 138543),
(138544, '3.40.50.720-FF-001692', NULL, 'Os06g0299200 protein', 56, NULL, NULL, 138544),
(138545, '3.30.70.1400-FF-000015', NULL, 'sarcosine dehydrogenase, mitochondrial-like isoform X1', 115, NULL, NULL, 138545),
(138546, '3.40.50.880-FF-000189', NULL, 'Carbamoyl-phosphate synthase small chain', 207, NULL, NULL, 138546),
(138547, '3.30.450.30-FF-000062', NULL, 'AGAP013030-PA', 97, NULL, NULL, 138547),
(138548, '2.30.30.40-FF-000136', NULL, 'Rho GTPase activating protein 4', 69, NULL, NULL, 138548),
(138549, '2.40.50.1070-FF-000009', NULL, '23S rRNA m(5)U-1939 methyltransferase', 123, NULL, NULL, 138549),
(138550, '1.20.58.60-FF-000361', NULL, 'Spectrin, beta, non-erythrocytic 5', 99, NULL, NULL, 138550),
(138551, '3.30.1330.30-FF-000125', NULL, 'Chromosome 8, whole genome shotgun sequence', 126, NULL, NULL, 138551),
(138552, '1.25.10.10-FF-003148', NULL, 'Uncharacterized protein', 71, NULL, NULL, 138552),
(138553, '3.30.70.330-FF-001042', NULL, 'RNA-binding protein, putative', 78, NULL, NULL, 138553),
(138554, '1.10.580.10-FF-000004', NULL, 'Citrate synthase', 227, NULL, NULL, 138554),
(138555, '2.60.120.260-FF-000285', NULL, 'Uncharacterized protein', 149, NULL, NULL, 138555),
(138556, '1.10.150.20-FF-000317', NULL, 'Predicted protein', 144, NULL, NULL, 138556),
(138557, '3.80.10.10-FF-003904', NULL, 'Uncharacterized protein', 132, NULL, NULL, 138557),
(138558, '1.20.1560.10-FF-000674', NULL, 'ABC transporter', 27, NULL, NULL, 138558),
(138559, '2.60.120.420-FF-000001', NULL, 'Outer capsid protein mu-1', 207, NULL, NULL, 138559),
(138560, '2.60.40.10-FF-005646', NULL, NULL, 122, NULL, NULL, 138560),
(138561, '3.40.1050.10-FF-000011', NULL, 'Beta-carbonic anhydrase 1', 164, NULL, NULL, 138561),
(138562, '1.10.10.60-FF-000436', NULL, 'Intermediate neuroblasts defective', 99, NULL, NULL, 138562),
(138563, '1.20.5.340-FF-000067', NULL, 'Kinesin family member C1', 94, NULL, NULL, 138563),
(138564, '2.30.29.30-FF-000130', NULL, 'neural Wiskott-Aldrich syndrome protein', 145, NULL, NULL, 138564),
(138565, '3.40.50.1820-FF-001189', NULL, 'Prolylcarboxypeptidase, putative', 52, NULL, NULL, 138565),
(138566, '1.10.10.60-FF-000700', NULL, 'Transcriptional regulator, AraC/XylS family', 55, NULL, NULL, 138566),
(138567, '3.90.810.10-FF-000020', NULL, 'WASP (Actin cytoskeleton modulator) homolog', 62, NULL, NULL, 138567),
(138568, '3.40.50.150-FF-000835', NULL, 'tRNA (guanine-N(7)-)-methyltransferase', 202, NULL, NULL, 138568),
(138569, '2.20.70.10-FF-000012', NULL, 'transcriptional coactivator YAP1 isoform X2', 47, NULL, NULL, 138569),
(138570, '3.40.50.2000-FF-000529', NULL, 'Glycosyltransferase', 181, NULL, NULL, 138570),
(138571, '2.130.10.10-FF-004601', NULL, 'Uncharacterized protein', 203, NULL, NULL, 138571),
(138572, '2.60.450.20-FF-000005', NULL, 'Lyst-interacting protein, putative', 154, NULL, NULL, 138572),
(138573, '1.20.1250.20-FF-002087', NULL, 'Uncharacterized protein', 266, NULL, NULL, 138573),
(138574, '2.60.40.2660-FF-000004', NULL, 'Ankyrin', 162, NULL, NULL, 138574),
(138575, '1.20.1720.10-FF-000097', NULL, NULL, 226, NULL, NULL, 138575),
(138576, '3.80.10.10-FF-001515', NULL, 'Adenylate cyclase', 258, NULL, NULL, 138576);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(138577, '3.40.50.300-FF-000892', NULL, 'probable ATP-dependent RNA helicase DDX49', 205, NULL, NULL, 138577),
(138578, '3.40.140.10-FF-000193', NULL, 'CysO-cysteine peptidase protein', 127, NULL, NULL, 138578),
(138579, '4.10.400.10-FF-000289', NULL, 'GM17661', 44, NULL, NULL, 138579),
(138580, '3.30.870.10-FF-000048', NULL, 'Phospholipase', 76, NULL, NULL, 138580),
(138581, '3.40.50.980-FF-000050', NULL, 'Predicted protein', 161, NULL, NULL, 138581),
(138582, '3.30.1360.120-FF-000087', NULL, 'Uncharacterized protein', 287, NULL, NULL, 138582),
(138583, '2.120.10.30-FF-000358', NULL, 'Uncharacterized protein', 85, NULL, NULL, 138583),
(138584, '2.40.50.140-FF-000252', NULL, 'DNA-directed RNA polymerase III subunit RPC8', 111, NULL, NULL, 138584),
(138585, '3.30.40.10-FF-001216', NULL, 'RBR-type E3 ubiquitin transferase', 91, NULL, NULL, 138585),
(138586, '3.30.70.100-FF-000130', NULL, NULL, 71, NULL, NULL, 138586),
(138587, '3.50.50.60-FF-000365', NULL, 'L-lysine N6-monooxygenase MbtG', 421, NULL, NULL, 138587),
(138588, '1.10.510.10-FF-000674', NULL, 'Serine/threonine protein kinase, putative', 196, NULL, NULL, 138588),
(138589, '2.60.40.1660-FF-000013', NULL, 'GD20124', 258, NULL, NULL, 138589),
(138590, '2.30.42.10-FF-000548', NULL, NULL, 84, NULL, NULL, 138590),
(138591, '1.25.40.20-FF-000724', NULL, 'Rel', 244, NULL, NULL, 138591),
(138592, '3.40.1000.30-FF-000014', NULL, 'Uncharacterized protein', 181, NULL, NULL, 138592),
(138593, '2.60.40.10-FF-001431', NULL, 'phosphatidylinositol phosphatase PTPRQ isoform X1', 95, NULL, NULL, 138593),
(138594, '1.25.40.20-FF-001000', NULL, 'Uncharacterized protein', 117, NULL, NULL, 138594),
(138595, '3.20.180.20-FF-000006', NULL, 'Dynein heavy chain family protein', 104, NULL, NULL, 138595),
(138596, '3.90.660.10-FF-000103', NULL, NULL, 262, NULL, NULL, 138596),
(138597, '1.10.1270.10-FF-000002', NULL, 'Trp operon repressor homolog', 99, NULL, NULL, 138597),
(138598, '1.10.238.10-FF-000810', NULL, 'Uncharacterized protein', 76, NULL, NULL, 138598),
(138599, '3.30.420.40-FF-000512', NULL, 'Actin related protein 10 homolog', 27, NULL, NULL, 138599),
(138600, '1.25.40.180-FF-000296', NULL, NULL, 105, NULL, NULL, 138600),
(138601, '3.40.50.300-FF-002347', NULL, 'DNA replication and repair protein RecF', 151, NULL, NULL, 138601),
(138602, '2.10.109.10-FF-000018', NULL, 'Mitochondrial inner membrane protease subunit', 136, NULL, NULL, 138602),
(138603, '2.60.40.10-FF-000003', NULL, 'Titin isoform E', 97, NULL, NULL, 138603),
(138604, '3.40.30.10-FF-000861', NULL, 'Uncharacterized protein', 110, NULL, NULL, 138604),
(138605, '3.30.160.60-FF-002869', NULL, 'Comb gap splice variant cg14', 25, NULL, NULL, 138605),
(138606, '1.10.8.240-FF-000005', NULL, '2-phospho-L-lactate transferase', 41, NULL, NULL, 138606),
(138607, '2.130.10.10-FF-000835', NULL, 'RNA polymerase II Elongator subunit', 236, NULL, NULL, 138607),
(138608, '2.130.10.10-FF-003241', NULL, 'LD47550p', 231, NULL, NULL, 138608),
(138609, '3.40.50.720-FF-000843', NULL, 'D-arabinitol dehydrogenase 1', 140, NULL, NULL, 138609),
(138610, '1.10.3450.40-FF-000014', NULL, NULL, 214, NULL, NULL, 138610),
(138611, '1.25.10.10-FF-000686', NULL, 'Serine/threonine-protein kinase TOR', 184, NULL, NULL, 138611),
(138612, '1.10.287.70-FF-000149', NULL, 'Cyclic nucleotide-gated cation channel beta-1', 227, NULL, NULL, 138612),
(138613, '2.170.150.80-FF-000018', NULL, 'Os02g0286000 protein', 173, NULL, NULL, 138613),
(138614, '3.40.50.720-FF-001416', NULL, 'Shikimate dehydrogenase (NADP(+))', 130, NULL, NULL, 138614),
(138615, '1.10.20.120-FF-000008', NULL, 'Uncharacterized protein', 149, NULL, NULL, 138615),
(138616, '1.10.220.10-FF-000079', NULL, 'Uncharacterized protein', 59, NULL, NULL, 138616),
(138617, '1.20.1070.10-FF-001524', NULL, 'Uncharacterized protein', 188, NULL, NULL, 138617),
(138618, '1.25.40.770-FF-000023', NULL, 'Uncharacterized protein', 127, NULL, NULL, 138618),
(138619, '2.130.10.10-FF-003320', NULL, 'Elongator subunit', 147, NULL, NULL, 138619),
(138620, '1.25.10.10-FF-001350', NULL, 'ER chaperone/ER translocation nucleotide exchange factor, putative', 281, NULL, NULL, 138620);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(138621, '3.40.50.300-FF-003707', NULL, 'ATP-dependent DNA helicase CHL1', 81, NULL, NULL, 138621),
(138622, '3.90.70.80-FF-000073', NULL, 'Predicted protein', 143, NULL, NULL, 138622),
(138623, '2.60.120.200-FF-000227', NULL, 'Concanavalin-A', 237, NULL, NULL, 138623),
(138624, '1.25.40.10-FF-000446', NULL, 'Pre-mRNA-splicing factor syf1', 127, NULL, NULL, 138624),
(138625, '2.70.170.10-FF-000141', NULL, 'gamma-aminobutyric acid receptor subunit beta-3-like', 215, NULL, NULL, 138625),
(138626, '3.30.1360.10-FF-000059', NULL, 'Uncharacterized protein', 111, NULL, NULL, 138626),
(138627, '3.10.20.90-FF-000284', NULL, 'Ubiquitin family protein', 77, NULL, NULL, 138627),
(138628, '3.30.505.10-FF-000189', NULL, NULL, 63, NULL, NULL, 138628),
(138629, '2.40.128.80-FF-000003', NULL, 'Cathepsin C', 118, NULL, NULL, 138629),
(138630, '3.30.200.20-FF-001647', NULL, NULL, 118, NULL, NULL, 138630),
(138631, '1.10.10.10-FF-000793', NULL, 'ArsR family transcriptional regulator', 107, NULL, NULL, 138631),
(138632, '2.130.10.10-FF-000711', NULL, 'Zinc finger protein 106', 155, NULL, NULL, 138632),
(138633, '3.10.28.10-FF-000036', NULL, 'Uncharacterized cox1 intron-2 37.2 kDa protein', 152, NULL, NULL, 138633),
(138634, '3.60.15.10-FF-000212', NULL, 'Uncharacterized protein', 29, NULL, NULL, 138634),
(138635, '3.30.60.30-FF-000189', NULL, 'Predicted protein', 35, NULL, NULL, 138635),
(138636, '3.40.630.30-FF-000495', NULL, 'UDP-N-acetylmuramoylpentapeptide-lysine N(6)-alanyltransferase', 167, NULL, NULL, 138636),
(138637, '3.40.50.2300-FF-000384', NULL, 'Ionotropic receptor 25a', 188, NULL, NULL, 138637),
(138638, '1.10.287.1880-FF-000002', NULL, 'Blast:Protein zwilch', 59, NULL, NULL, 138638),
(138639, '3.40.50.170-FF-000021', NULL, 'Phosphoribosylglycinamide formyltransferase', 192, NULL, NULL, 138639),
(138640, '1.10.2020.20-FF-000021', NULL, NULL, 85, NULL, NULL, 138640),
(138641, '3.40.710.10-FF-000158', NULL, 'Uncharacterized protein', 102, NULL, NULL, 138641),
(138642, '1.10.472.10-FF-000192', NULL, 'Predicted protein', 96, NULL, NULL, 138642),
(138643, '1.10.472.80-FF-000105', NULL, 'GTPase-activating protein GYP6', 144, NULL, NULL, 138643),
(138644, '3.90.70.10-FF-000754', NULL, 'Predicted protein', 114, NULL, NULL, 138644),
(138645, '3.30.160.60-FF-004106', NULL, NULL, 33, NULL, NULL, 138645),
(138646, '1.20.140.40-FF-000091', NULL, NULL, 54, NULL, NULL, 138646),
(138647, '3.90.79.10-FF-000061', NULL, '7,8-dihydro-8-oxoguanine-triphosphatase', 148, NULL, NULL, 138647),
(138648, '3.30.70.330-FF-002267', NULL, NULL, 108, NULL, NULL, 138648),
(138649, '3.30.50.10-FF-000093', NULL, 'Uncharacterized protein', 76, NULL, NULL, 138649),
(138650, '3.80.10.10-FF-000678', NULL, 'Predicted protein', 102, NULL, NULL, 138650),
(138651, '1.10.530.10-FF-000001', NULL, 'Lysozyme C', 130, NULL, NULL, 138651),
(138652, '3.40.50.150-FF-000094', NULL, 'Carnosine N-methyltransferase 1', 226, NULL, NULL, 138652),
(138653, '3.90.190.10-FF-000499', NULL, 'Uncharacterized protein', 147, NULL, NULL, 138653),
(138654, '1.10.4160.10-FF-000045', NULL, NULL, 235, NULL, NULL, 138654),
(138655, '1.20.1250.20-FF-001570', NULL, 'Transport protein', 385, NULL, NULL, 138655),
(138656, '3.90.1110.10-FF-000038', NULL, NULL, 37, NULL, NULL, 138656),
(138657, '3.40.50.720-FF-000282', NULL, 'Glyoxylate reductase protein', 187, NULL, NULL, 138657),
(138658, '3.10.20.90-FF-000464', NULL, 'Os10g0200000 protein', 90, NULL, NULL, 138658),
(138659, '3.10.150.10-FF-000003', NULL, 'Beta sliding clamp', 119, NULL, NULL, 138659),
(138660, '3.40.50.300-FF-005220', NULL, 'Rab_B05 protein', 206, NULL, NULL, 138660),
(138661, '3.30.420.110-FF-000061', NULL, 'DNA mismatch repair protein MSH3', 165, NULL, NULL, 138661),
(138662, '1.20.1070.10-FF-000423', NULL, 'NeuroPeptide Receptor family', 306, NULL, NULL, 138662),
(138663, '3.10.110.10-FF-000349', NULL, 'Uncharacterized protein', 130, NULL, NULL, 138663),
(138664, '3.30.420.40-FF-000855', NULL, 'Xylulokinase homolog (H. influenzae)', 142, NULL, NULL, 138664),
(138665, '2.60.40.10-FF-001251', NULL, 'usherin', 94, NULL, NULL, 138665);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(138666, '3.30.160.60-FF-006135', NULL, NULL, 72, NULL, NULL, 138666),
(138667, '1.20.900.10-FF-000117', NULL, 'Rac guanine nucleotide exchange factor B', 236, NULL, NULL, 138667),
(138668, '3.30.930.10-FF-000435', NULL, 'Uncharacterized protein', 74, NULL, NULL, 138668),
(138669, '1.10.3720.10-FF-000043', NULL, 'Putrescine ABC transporter permease PotH', 284, NULL, NULL, 138669),
(138670, '2.130.10.10-FF-001408', NULL, 'FI01301p', 239, NULL, NULL, 138670),
(138671, '2.60.40.10-FF-000975', NULL, 'Uncharacterized protein, isoform D', 103, NULL, NULL, 138671),
(138672, '3.80.10.10-FF-004388', NULL, 'Si:ch211-11p18.6', 168, NULL, NULL, 138672),
(138673, '3.40.30.10-FF-001249', NULL, 'NADH-ubiquinone oxidoreductase 24 kDa subunit homolog C11E3.12, mitochondrial', 81, NULL, NULL, 138673),
(138674, '3.30.519.10-FF-000047', NULL, NULL, 54, NULL, NULL, 138674),
(138675, '3.30.160.60-FF-001588', NULL, 'Zinc finger protein 82 homolog', 28, NULL, NULL, 138675),
(138676, '3.10.310.10-FF-000005', NULL, 'Proline racemase', 166, NULL, NULL, 138676),
(138677, '1.20.1530.20-FF-000040', NULL, 'Solute carrier family 10, member 4', 306, NULL, NULL, 138677),
(138678, '3.30.160.190-FF-000002', NULL, 'NADH dehydrogenase [ubiquinone] iron-sulfur protein 4', 76, NULL, NULL, 138678),
(138679, '3.40.1390.30-FF-000008', NULL, 'NGG1 interacting factor Nif3', 125, NULL, NULL, 138679),
(138680, '1.10.510.10-FF-002540', NULL, 'Mitogen-activated protein kinase kinase kinase kinase', 303, NULL, NULL, 138680),
(138681, '3.90.176.10-FF-000011', NULL, 'C3 family ADP-ribosyltransferase', 207, NULL, NULL, 138681),
(138682, '3.40.50.300-FF-008530', NULL, 'Uncharacterized protein', 171, NULL, NULL, 138682),
(138683, '1.10.760.10-FF-000069', NULL, 'Cytochrome C', 109, NULL, NULL, 138683),
(138684, '3.40.50.300-FF-007693', NULL, 'Predicted protein', 107, NULL, NULL, 138684),
(138685, '3.40.50.2300-FF-001518', NULL, NULL, 90, NULL, NULL, 138685),
(138686, '3.30.160.20-FF-000014', NULL, 'double-stranded RNA-binding protein Staufen homolog 1 isoform X1', 74, NULL, NULL, 138686),
(138687, '2.60.120.590-FF-000024', NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', 226, NULL, NULL, 138687),
(138688, '1.25.50.20-FF-000068', NULL, 'Predicted protein', 293, NULL, NULL, 138688),
(138689, '3.40.850.10-FF-000056', NULL, 'Kinesin-like protein', 349, NULL, NULL, 138689),
(138690, '3.40.50.2000-FF-001081', NULL, 'Glycosyltransferase', 131, NULL, NULL, 138690),
(138691, '3.80.10.10-FF-003163', NULL, 'Uncharacterized protein', 280, NULL, NULL, 138691),
(138692, '2.120.10.30-FF-000015', NULL, 'Low-density lipoprotein receptor-related protein 1', 322, NULL, NULL, 138692),
(138693, '1.25.40.10-FF-005117', NULL, 'DnaJ homolog subfamily C member 7 homolog', 113, NULL, NULL, 138693),
(138694, '3.90.226.10-FF-000105', NULL, 'Possible enoyl-CoA hydratase echA9', 345, NULL, NULL, 138694),
(138695, '3.30.2410.10-FF-000058', NULL, 'Uncharacterized protein', 141, NULL, NULL, 138695),
(138696, '3.30.70.370-FF-000014', NULL, 'DNA polymerase I', 95, NULL, NULL, 138696),
(138697, '2.80.10.50-FF-000237', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 112, NULL, NULL, 138697),
(138698, '1.25.50.10-FF-000008', NULL, 'Aminopeptidase N', 326, NULL, NULL, 138698),
(138699, '2.130.10.10-FF-005793', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', 95, NULL, NULL, 138699),
(138700, '2.60.120.260-FF-000009', NULL, 'SUN domain-containing protein 1 isoform X1', 196, NULL, NULL, 138700),
(138701, '3.40.1500.10-FF-000001', NULL, 'Oxygen-dependent coproporphyrinogen-III oxidase', 301, NULL, NULL, 138701),
(138702, '3.40.50.10090-FF-000010', NULL, 'Uroporphyrinogen-III synthase', 100, NULL, NULL, 138702),
(138703, '2.40.30.10-FF-000520', NULL, 'Uncharacterized protein', 104, NULL, NULL, 138703),
(138704, '3.40.50.150-FF-001055', NULL, 'Uncharacterized protein', 272, NULL, NULL, 138704),
(138705, '3.30.40.10-FF-000199', NULL, 'Bromodomain adjacent to zinc finger domain 2B', 110, NULL, NULL, 138705); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(138706, '1.10.630.10-FF-000065', NULL, 'Cytochrome P450 family 7 subfamily B member 1', 475, NULL, NULL, 138706),
(138707, '3.30.40.10-FF-001952', NULL, 'Uncharacterized protein', 66, NULL, NULL, 138707),
(138708, '3.40.50.740-FF-000006', NULL, 'NADH-quinone oxidoreductase', 184, NULL, NULL, 138708),
(138709, '2.20.70.70-FF-000002', NULL, 'Penicillin-binding protein', 23, NULL, NULL, 138709),
(138710, '1.10.238.10-FF-000485', NULL, 'Probable calcium-binding protein CML44', 94, NULL, NULL, 138710),
(138711, '3.90.550.10-FF-000218', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 379, NULL, NULL, 138711),
(138712, '1.20.1260.10-FF-000050', NULL, 'Diguanylate cyclase', 178, NULL, NULL, 138712),
(138713, '3.40.1480.10-FF-000004', NULL, 'MOFRL family protein', 159, NULL, NULL, 138713),
(138714, '1.10.510.10-FF-002591', NULL, NULL, 199, NULL, NULL, 138714),
(138715, '2.130.10.10-FF-000043', NULL, 'pre-mRNA-processing factor 19', 310, NULL, NULL, 138715),
(138716, '1.20.1310.10-FF-000167', NULL, NULL, 102, NULL, NULL, 138716),
(138717, '1.20.1560.10-FF-000887', NULL, 'Uncharacterized protein', 126, NULL, NULL, 138717),
(138718, '3.30.160.60-FF-002656', NULL, NULL, 33, NULL, NULL, 138718),
(138719, '2.40.10.250-FF-000001', NULL, 'Orf1a polyprotein', 115, NULL, NULL, 138719),
(138720, '1.20.1250.20-FF-001070', NULL, 'Yin, isoform D', 173, NULL, NULL, 138720),
(138721, '2.60.40.10-FF-002212', NULL, 'Interference hedgehog', 82, NULL, NULL, 138721),
(138722, '3.80.10.10-FF-000122', NULL, 'F-box/LRR-repeat protein 7 isoform X1', 138, NULL, NULL, 138722),
(138723, '3.40.1000.70-FF-000003', NULL, 'Possible lipoprotein LpqQ', 179, NULL, NULL, 138723),
(138724, '3.40.50.2300-FF-000389', NULL, 'Two-component response regulator ORR9', 187, NULL, NULL, 138724),
(138725, '3.90.79.10-FF-000010', NULL, 'GDP-mannose pyrophosphatase NudK', 191, NULL, NULL, 138725),
(138726, '3.40.50.300-FF-001965', NULL, 'ATP-dependent DNA helicase UvrD', 103, NULL, NULL, 138726),
(138727, '1.20.80.10-FF-000015', NULL, 'FERM domain-containing protein 6 isoform X2', 111, NULL, NULL, 138727),
(138728, '1.10.238.10-FF-000541', NULL, 'CRE-STA-2 protein', 140, NULL, NULL, 138728),
(138729, '3.30.40.10-FF-001896', NULL, 'RING/U-box superfamily protein', 74, NULL, NULL, 138729),
(138730, '1.10.1240.40-FF-000009', NULL, 'Emsy N Terminus (ENT)/ plant Tudor-like domains-containing protein', 138, NULL, NULL, 138730),
(138731, '2.10.25.10-FF-000689', NULL, 'Netrin G2', 84, NULL, NULL, 138731),
(138732, '3.30.590.10-FF-000043', NULL, 'Creatine kinase, brain b', 186, NULL, NULL, 138732),
(138733, '2.30.30.40-FF-000316', NULL, 'Myosin tail region-interacting protein MTI1', 68, NULL, NULL, 138733),
(138734, '2.120.10.30-FF-000246', NULL, 'Predicted protein', 157, NULL, NULL, 138734),
(138735, '3.40.50.2300-FF-000445', NULL, 'Glutamate receptor, ionotropic, N-methyl D-aspartate 2D, b', 165, NULL, NULL, 138735),
(138736, '3.30.200.20-FF-000170', NULL, 'Non-specific serine/threonine protein kinase', 112, NULL, NULL, 138736),
(138737, '2.60.40.10-FF-002156', NULL, 'Beta-glucosidase', 130, NULL, NULL, 138737),
(138738, '2.40.240.10-FF-000064', NULL, 'Glutamine--tRNA ligase', 130, NULL, NULL, 138738),
(138739, '3.60.40.10-FF-000113', NULL, 'Serine/threonine phosphoprotein phosphatase Stp1', 242, NULL, NULL, 138739),
(138740, '3.40.50.1970-FF-000014', NULL, 'Ethanolamine utilization protein EutG', 192, NULL, NULL, 138740),
(138741, '2.30.29.30-FF-000361', NULL, 'TBC1 domain family member 1 isoform B', 226, NULL, NULL, 138741),
(138742, '2.40.50.140-FF-000752', NULL, NULL, 87, NULL, NULL, 138742),
(138743, '1.20.140.150-FF-000136', NULL, 'Transmembrane protein 114', 61, NULL, NULL, 138743),
(138744, '3.30.160.60-FF-002712', NULL, NULL, 29, NULL, NULL, 138744),
(138745, '3.30.565.10-FF-000530', NULL, 'Uncharacterized protein', 96, NULL, NULL, 138745),
(138746, '2.120.10.30-FF-000302', NULL, 'Uncharacterized protein', 164, NULL, NULL, 138746),
(138747, '4.10.1240.50-FF-000015', NULL, 'ELM2 domaincontaining protein', 80, NULL, NULL, 138747),
(138748, '2.30.42.10-FF-000380', NULL, NULL, 82, NULL, NULL, 138748);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(138749, '2.130.10.30-FF-000105', NULL, NULL, 204, NULL, NULL, 138749),
(138750, '3.30.420.40-FF-000332', NULL, 'Unplaced genomic scaffold supercont2.11, whole genome shotgun sequence', 149, NULL, NULL, 138750),
(138751, '1.25.40.650-FF-000004', NULL, 'Penicillin-binding protein activator LpoA', 110, NULL, NULL, 138751),
(138752, '1.10.510.10-FF-001130', NULL, 'Serine/threonine-protein kinase KDX1', 232, NULL, NULL, 138752),
(138753, '3.20.20.70-FF-000053', NULL, 'Glutamate synthase large subunit', 432, NULL, NULL, 138753),
(138754, '3.80.10.10-FF-001690', NULL, 'Leucine-rich repeat receptor-like protein kinase PXC2', 215, NULL, NULL, 138754),
(138755, '1.10.630.10-FF-000621', NULL, 'Cytochrome P450, putative', 241, NULL, NULL, 138755),
(138756, '1.20.1640.10-FF-000040', NULL, 'Export membrane protein', 181, NULL, NULL, 138756),
(138757, '2.60.40.10-FF-001700', NULL, 'Immunoglobulin lambda variable 8-61', 103, NULL, NULL, 138757),
(138758, '2.130.10.10-FF-004314', NULL, 'Uncharacterized protein', 110, NULL, NULL, 138758),
(138759, '2.40.50.100-FF-000195', NULL, 'Predicted protein', 57, NULL, NULL, 138759),
(138760, '3.40.50.720-FF-000051', NULL, 'STEAP2 metalloreductase', 183, NULL, NULL, 138760),
(138761, '3.30.559.70-FF-000016', NULL, 'Protein CBG16408', 315, NULL, NULL, 138761),
(138762, '3.90.190.10-FF-000179', NULL, 'Phosphatase, putative', 159, NULL, NULL, 138762),
(138763, '2.120.10.30-FF-000297', NULL, 'Uncharacterized protein', 231, NULL, NULL, 138763),
(138764, '1.10.10.10-FF-001787', NULL, 'Transcriptional regulatory protein', 57, NULL, NULL, 138764),
(138765, '3.40.50.300-FF-005332', NULL, 'Uncharacterized protein', 148, NULL, NULL, 138765),
(138766, '3.40.50.720-FF-000899', NULL, 'Shikimate dehydrogenase (NADP(+))', 139, NULL, NULL, 138766),
(138767, '1.10.510.10-FF-003788', NULL, NULL, 130, NULL, NULL, 138767),
(138768, '2.60.40.10-FF-000391', NULL, 'TEK receptor tyrosine kinase', 100, NULL, NULL, 138768),
(138769, '2.30.30.380-FF-000018', NULL, 'Protein transport protein SEC23', 60, NULL, NULL, 138769),
(138770, '2.60.40.10-FF-004680', NULL, NULL, 88, NULL, NULL, 138770),
(138771, '3.30.342.10-FF-000001', NULL, 'DNA polymerase epsilon catalytic subunit', 159, NULL, NULL, 138771),
(138772, '3.40.50.1820-FF-000964', NULL, 'Phospholipase ABHD3', 279, NULL, NULL, 138772),
(138773, '2.60.40.10-FF-005966', NULL, NULL, 108, NULL, NULL, 138773),
(138774, '1.10.3720.10-FF-000223', NULL, 'Sugar ABC transporter, permease protein', 236, NULL, NULL, 138774),
(138775, '3.30.70.600-FF-000010', NULL, '39S ribosomal protein L48, mitochondrial', 100, NULL, NULL, 138775),
(138776, '1.20.1740.10-FF-000036', NULL, 'Solute carrier family 7 member 13', 440, NULL, NULL, 138776),
(138777, '1.20.1070.10-FF-001547', NULL, 'Uncharacterized protein', 176, NULL, NULL, 138777),
(138778, '3.30.160.60-FF-006023', NULL, NULL, 29, NULL, NULL, 138778),
(138779, '3.30.70.270-FF-000315', NULL, NULL, 28, NULL, NULL, 138779),
(138780, '1.10.472.10-FF-000129', NULL, 'Tryptophan synthase', 146, NULL, NULL, 138780),
(138781, '3.30.1130.10-FF-000019', NULL, 'Predicted protein', 138, NULL, NULL, 138781),
(138782, '3.40.50.1010-FF-000199', NULL, NULL, 157, NULL, NULL, 138782),
(138783, '3.20.20.80-FF-000382', NULL, 'AGAP001200-PA', 127, NULL, NULL, 138783),
(138784, '3.10.180.10-FF-000062', NULL, '4-hydroxyphenylpyruvate dioxygenase', 139, NULL, NULL, 138784),
(138785, '3.30.160.710-FF-000001', NULL, 'Hemagglutination activity domain protein', 91, NULL, NULL, 138785),
(138786, '3.30.160.20-FF-000019', NULL, 'RISC-loading complex subunit TARBP2', 74, NULL, NULL, 138786),
(138787, '3.90.640.10-FF-000192', NULL, 'Actin-related protein 4', 81, NULL, NULL, 138787),
(138788, '3.40.50.1440-FF-000086', NULL, 'Tubulin gamma chain', 273, NULL, NULL, 138788),
(138789, '3.30.40.10-FF-000435', NULL, 'Tripartite motif containing 71, E3 ubiquitin protein ligase', 112, NULL, NULL, 138789),
(138790, '3.80.10.10-FF-004444', NULL, 'Uncharacterized protein', 119, NULL, NULL, 138790),
(138791, '1.20.1720.10-FF-000041', NULL, 'Multidrug resistance protein D', 375, NULL, NULL, 138791);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(138792, '1.10.287.410-FF-000010', NULL, 'Carboxypeptidase', 67, NULL, NULL, 138792),
(138793, '3.40.50.970-FF-000221', NULL, 'Uncharacterized protein', 62, NULL, NULL, 138793),
(138794, '1.25.40.20-FF-001523', NULL, 'Protein 21.1', 132, NULL, NULL, 138794),
(138795, '3.40.50.300-FF-001061', NULL, 'Glutathione import ATP-binding protein GsiA', 296, NULL, NULL, 138795),
(138796, '1.10.510.10-FF-002484', NULL, NULL, 218, NULL, NULL, 138796),
(138797, '3.40.50.970-FF-000165', NULL, '2-oxoglutarate:ferredoxin oxidoreductase, thiamin diphosphate-binding subunit', 163, NULL, NULL, 138797),
(138798, '3.40.50.2300-FF-000501', NULL, 'DNA-binding response regulator', 80, NULL, NULL, 138798),
(138799, '1.25.40.10-FF-002599', NULL, 'Pentatricopeptide repeat-containing protein', 210, NULL, NULL, 138799),
(138800, '2.60.40.760-FF-000004', NULL, 'Swollenin like protein', 94, NULL, NULL, 138800),
(138801, '2.60.40.10-FF-001751', NULL, 'HMCN2 isoform 3', 94, NULL, NULL, 138801),
(138802, '1.10.630.10-FF-000565', NULL, 'Uncharacterized protein', 325, NULL, NULL, 138802),
(138803, '1.20.1050.10-FF-000236', NULL, 'Uncharacterized protein', 83, NULL, NULL, 138803),
(138804, '1.25.40.20-FF-001416', NULL, 'Uncharacterized protein', 273, NULL, NULL, 138804),
(138805, '3.40.710.10-FF-000107', NULL, 'Penicillin-binding protein, putative', 98, NULL, NULL, 138805),
(138806, '3.60.15.10-FF-000156', NULL, 'Ribonuclease Z, putative', 353, NULL, NULL, 138806),
(138807, '3.80.10.10-FF-004337', NULL, 'Uncharacterized protein', 191, NULL, NULL, 138807),
(138808, '1.20.58.120-FF-000006', NULL, 'BAG family molecular chaperone regulator 3', 106, NULL, NULL, 138808),
(138809, '3.30.70.20-FF-000029', NULL, 'Formate dehydrogenase iron-sulfur subunit', 114, NULL, NULL, 138809),
(138810, '3.30.70.330-FF-001834', NULL, NULL, 151, NULL, NULL, 138810),
(138811, '3.40.50.150-FF-001032', NULL, NULL, 166, NULL, NULL, 138811),
(138812, '3.40.50.300-FF-005276', NULL, 'Interferon induced protein 44', 179, NULL, NULL, 138812),
(138813, '2.130.10.10-FF-001459', NULL, 'Nuclear pore complex subunit', 425, NULL, NULL, 138813),
(138814, '1.20.1070.10-FF-000243', NULL, 'G protein-coupled receptor 20', 284, NULL, NULL, 138814),
(138815, '1.20.1070.10-FF-000979', NULL, 'Uncharacterized protein', 289, NULL, NULL, 138815),
(138816, '2.30.42.10-FF-000228', NULL, 'Rab3 interacting molecule, isoform R', 116, NULL, NULL, 138816),
(138817, '1.20.120.980-FF-000055', NULL, 'Uncharacterized protein', 71, NULL, NULL, 138817),
(138818, '3.40.50.300-FF-001858', NULL, 'DExH-box ATP-dependent RNA helicase DExH17', 221, NULL, NULL, 138818),
(138819, '3.40.50.360-FF-000095', NULL, 'NADPH-dependent FMN reductase Lot6, putative', 164, NULL, NULL, 138819),
(138820, '3.30.465.10-FF-000045', NULL, '2-hydroxy-acid oxidase', 232, NULL, NULL, 138820),
(138821, '3.30.70.1660-FF-000014', NULL, 'Peptide chain release factor 1', 80, NULL, NULL, 138821),
(138822, '3.10.20.870-FF-000012', NULL, NULL, 75, NULL, NULL, 138822),
(138823, '3.30.1380.20-FF-000007', NULL, 'Trafficking protein particle complex subunit', 191, NULL, NULL, 138823),
(138824, '3.40.1280.10-FF-000112', NULL, 'Methyltransferase', 70, NULL, NULL, 138824),
(138825, '1.20.120.1760-FF-000066', NULL, NULL, 173, NULL, NULL, 138825),
(138826, '1.20.940.10-FF-000002', NULL, 'Pre-mRNA processing factor 18', 182, NULL, NULL, 138826),
(138827, '3.10.20.30-FF-000081', NULL, NULL, 100, NULL, NULL, 138827),
(138828, '3.90.640.10-FF-000085', NULL, 'Actin-like protein, putative', 26, NULL, NULL, 138828),
(138829, '2.60.200.20-FF-000133', NULL, 'Probable E3 ubiquitin-protein ligase dma1', 105, NULL, NULL, 138829),
(138830, '2.130.10.10-FF-002460', NULL, 'Protein CBG01041', 222, NULL, NULL, 138830),
(138831, '3.30.70.330-FF-002216', NULL, NULL, 102, NULL, NULL, 138831),
(138832, '1.10.150.20-FF-000312', NULL, 'DNA polymerase iota', 44, NULL, NULL, 138832),
(138833, '1.20.1250.20-FF-001862', NULL, 'Uncharacterized protein', 120, NULL, NULL, 138833),
(138834, '3.90.215.10-FF-000024', NULL, 'Predicted protein', 167, NULL, NULL, 138834);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(138835, '3.30.870.10-FF-000025', NULL, 'Phospholipase D delta', 241, NULL, NULL, 138835),
(138836, '1.20.1250.20-FF-001974', NULL, 'Uncharacterized protein', 400, NULL, NULL, 138836),
(138837, '3.50.50.60-FF-000028', NULL, 'Thioredoxin reductase 1, mitochondrial', 220, NULL, NULL, 138837),
(138838, '4.10.470.20-FF-000004', NULL, NULL, 74, NULL, NULL, 138838),
(138839, '3.40.50.1820-FF-000172', NULL, 'Epoxide hydrolase', 408, NULL, NULL, 138839),
(138840, '2.40.33.10-FF-000044', NULL, 'Pyruvate kinase', 36, NULL, NULL, 138840),
(138841, '3.10.10.10-FF-000041', NULL, NULL, 73, NULL, NULL, 138841),
(138842, '3.50.50.60-FF-001489', NULL, 'Glutathione reductase', 44, NULL, NULL, 138842),
(138843, '3.40.50.720-FF-001248', NULL, 'NADPH-adrenodoxin reductase', 88, NULL, NULL, 138843),
(138844, '1.20.1070.10-FF-000187', NULL, 'G-protein coupled receptor 15', 305, NULL, NULL, 138844),
(138845, '3.90.1800.10-FF-000018', NULL, 'DNA-directed RNA polymerase subunit beta', 102, NULL, NULL, 138845),
(138846, '4.10.860.10-FF-000031', NULL, NULL, 36, NULL, NULL, 138846),
(138847, '2.130.10.10-FF-001403', NULL, 'Unplaced genomic scaffold supercont1.17, whole genome shotgun sequence', 325, NULL, NULL, 138847),
(138848, '2.60.40.60-FF-000900', NULL, 'Uncharacterized protein', 122, NULL, NULL, 138848),
(138849, '1.25.40.10-FF-000626', NULL, 'Serine/threonine protein phosphatase 5', 124, NULL, NULL, 138849),
(138850, '3.20.20.70-FF-000160', NULL, 'Probable galactinol--sucrose galactosyltransferase 2', 287, NULL, NULL, 138850),
(138851, '3.40.50.300-FF-008261', NULL, 'Uncharacterized protein', 48, NULL, NULL, 138851),
(138852, '3.30.1140.32-FF-000012', NULL, '30S ribosomal protein S3', 136, NULL, NULL, 138852),
(138853, '3.40.50.10810-FF-000052', NULL, 'DNA helicase', 215, NULL, NULL, 138853),
(138854, '3.40.440.10-FF-000002', NULL, 'Adenylosuccinate synthetase, chloroplastic', 164, NULL, NULL, 138854),
(138855, '2.60.200.20-FF-000189', NULL, 'Aprataxin and PNK-like factor', 49, NULL, NULL, 138855),
(138856, '1.25.10.10-FF-000006', NULL, 'CLIP-associating protein 1 isoform 2', 241, NULL, NULL, 138856),
(138857, '3.80.10.10-FF-000173', NULL, 'PH domain and leucine rich repeat protein phosphatase 1', 159, NULL, NULL, 138857),
(138858, '2.60.120.1540-FF-000016', NULL, 'Thiolester containing protein I', 110, NULL, NULL, 138858),
(138859, '3.30.160.60-FF-001296', NULL, 'Zinc finger protein 582', 26, NULL, NULL, 138859),
(138860, '1.25.40.20-FF-000163', NULL, 'Fem-1 homolog c (C.elegans)', 147, NULL, NULL, 138860),
(138861, '1.10.510.10-FF-003844', NULL, NULL, 106, NULL, NULL, 138861),
(138862, '3.40.30.10-FF-000529', NULL, 'Peroxiredoxin 1', 175, NULL, NULL, 138862),
(138863, '2.60.40.10-FF-001695', NULL, 'Erythroblast membrane associated protein (Scianna blood group)', 115, NULL, NULL, 138863),
(138864, '1.25.40.10-FF-000738', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 138, NULL, NULL, 138864),
(138865, '3.90.228.10-FF-000003', NULL, 'TCDD-inducible poly [ADP-ribose] polymerase', 188, NULL, NULL, 138865),
(138866, '3.30.70.1450-FF-000013', NULL, 'Trk system potassium transporter TrkA', 93, NULL, NULL, 138866),
(138867, '3.80.10.10-FF-003084', NULL, 'Uncharacterized protein', 125, NULL, NULL, 138867),
(138868, '3.90.148.10-FF-000002', NULL, 'DNA-binding protein', 153, NULL, NULL, 138868),
(138869, '3.40.50.300-FF-001914', NULL, 'YML133C-like protein', 178, NULL, NULL, 138869),
(138870, '1.10.8.60-FF-000396', NULL, 'DnaA regulatory inactivator Hda', 66, NULL, NULL, 138870),
(138871, '1.10.630.10-FF-000514', NULL, 'Uncharacterized protein', 414, NULL, NULL, 138871),
(138872, '2.60.120.10-FF-000247', NULL, 'Putative transcriptional regulator', 72, NULL, NULL, 138872),
(138873, '1.10.510.10-FF-002439', NULL, NULL, 185, NULL, NULL, 138873),
(138874, '3.40.30.10-FF-000681', NULL, 'Uncharacterized protein', 78, NULL, NULL, 138874),
(138875, '1.10.238.10-FF-000434', NULL, 'GD13508', 65, NULL, NULL, 138875),
(138876, '1.20.1250.20-FF-000513', NULL, 'Probable MFS transporter', 185, NULL, NULL, 138876);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(138877, '1.20.5.190-FF-000038', NULL, 'calmodulin-binding transcription activator 1 isoform X2', 54, NULL, NULL, 138877),
(138878, '3.30.365.10-FF-000037', NULL, 'Uncharacterized protein', 51, NULL, NULL, 138878),
(138879, '3.40.50.720-FF-001299', NULL, 'Sepiapterin reductase', 167, NULL, NULL, 138879),
(138880, '1.25.10.10-FF-002367', NULL, 'Uncharacterized protein', 278, NULL, NULL, 138880),
(138881, '3.90.780.10-FF-000027', NULL, 'Alkaline phosphatase', 267, NULL, NULL, 138881),
(138882, '3.40.50.1820-FF-001532', NULL, 'Oleoyl-ACP hydrolase', 142, NULL, NULL, 138882),
(138883, '1.10.10.440-FF-000092', NULL, 'Uncharacterized protein', 57, NULL, NULL, 138883),
(138884, '3.40.50.740-FF-000057', NULL, 'NADH-quinone oxidoreductase', 97, NULL, NULL, 138884),
(138885, '2.60.470.10-FF-000003', NULL, 'Amiloride-sensitive sodium channel subunit beta', 180, NULL, NULL, 138885),
(138886, '1.10.12.10-FF-000044', NULL, 'Enoyl-CoA hydratase/carnithine racemase', 55, NULL, NULL, 138886),
(138887, '3.30.70.20-FF-000092', NULL, NULL, 72, NULL, NULL, 138887),
(138888, '1.20.5.1160-FF-000018', NULL, 'nestin', 114, NULL, NULL, 138888),
(138889, '1.20.58.70-FF-000127', NULL, 'Uncharacterized protein', 132, NULL, NULL, 138889),
(138890, '3.30.300.30-FF-000051', NULL, 'O-succinylbenzoic acid--CoA ligase', 106, NULL, NULL, 138890),
(138891, '3.30.420.40-FF-000276', NULL, 'Cell division protein FtsA', 162, NULL, NULL, 138891),
(138892, '2.60.34.20-FF-000008', NULL, NULL, 137, NULL, NULL, 138892),
(138893, '2.40.160.10-FF-000063', NULL, 'Uncharacterized protein', 224, NULL, NULL, 138893),
(138894, '1.10.10.60-FF-000032', NULL, 'Zinc finger and SCAN domain-containing 20', 64, NULL, NULL, 138894),
(138895, '2.60.40.2610-FF-000006', NULL, 'Fimbrial biogenesis outer membrane usher protein', 92, NULL, NULL, 138895),
(138896, '3.40.50.1000-FF-000038', NULL, 'Fructose-1-phosphate/6-phosphogluconate phosphatase', 106, NULL, NULL, 138896),
(138897, '1.10.340.30-FF-000060', NULL, 'Endonuclease III homolog', 107, NULL, NULL, 138897),
(138898, '1.25.40.10-FF-004049', NULL, 'Uncharacterized protein', 328, NULL, NULL, 138898),
(138899, '3.30.160.60-FF-005511', NULL, NULL, 73, NULL, NULL, 138899),
(138900, '3.30.950.10-FF-000026', NULL, 'Precorrin-6Y C5,15-methyltransferase, putative', 114, NULL, NULL, 138900),
(138901, '3.30.457.60-FF-000024', NULL, 'Mitotic arrest deficient 1-like 1', 29, NULL, NULL, 138901),
(138902, '3.40.50.300-FF-001173', NULL, 'signal recognition particle receptor subunit beta', 214, NULL, NULL, 138902),
(138903, '1.10.8.60-FF-000340', NULL, 'Replication factor C small subunit', 60, NULL, NULL, 138903),
(138904, '3.30.200.20-FF-001479', NULL, 'Protein roller-3', 115, NULL, NULL, 138904),
(138905, '3.30.160.60-FF-000840', NULL, 'PR domain zinc finger protein 4', 27, NULL, NULL, 138905),
(138906, '3.10.129.10-FF-000038', NULL, 'Acyl-CoA thioester hydrolase', 163, NULL, NULL, 138906),
(138907, '1.10.510.10-FF-001023', NULL, 'Os07g0541700 protein', 90, NULL, NULL, 138907),
(138908, '3.40.50.300-FF-008210', NULL, 'Predicted protein', 70, NULL, NULL, 138908),
(138909, '1.20.120.680-FF-000004', NULL, NULL, 123, NULL, NULL, 138909),
(138910, '3.90.1140.10-FF-000046', NULL, 'Uncharacterized protein', 113, NULL, NULL, 138910),
(138911, '3.30.160.60-FF-006079', NULL, NULL, 84, NULL, NULL, 138911),
(138912, '1.20.1310.10-FF-000223', NULL, NULL, 41, NULL, NULL, 138912),
(138913, '2.60.40.150-FF-000708', NULL, 'Phosphatidylinositol 3-kinase class, putative', 140, NULL, NULL, 138913),
(138914, '3.30.230.130-FF-000052', NULL, 'Cullin family protein', 156, NULL, NULL, 138914),
(138915, '1.10.600.10-FF-000001', NULL, 'Geranylgeranyl diphosphate synthase', 295, NULL, NULL, 138915),
(138916, '2.30.180.10-FF-000050', NULL, 'YLR001C-like protein', 142, NULL, NULL, 138916),
(138917, '3.40.50.1010-FF-000255', NULL, NULL, 110, NULL, NULL, 138917),
(138918, '3.90.70.10-FF-000485', NULL, 'Cysteine protease, putative', 257, NULL, NULL, 138918),
(138919, '1.20.1540.10-FF-000111', NULL, 'Predicted protein', 119, NULL, NULL, 138919);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(138920, '2.30.42.10-FF-000205', NULL, 'SpoIVB peptidase 42 kDa isoform', 81, NULL, NULL, 138920),
(138921, '3.40.50.150-FF-000886', NULL, 'Protein-L-isoaspartate O-methyltransferase', 210, NULL, NULL, 138921),
(138922, '2.10.220.10-FF-000193', NULL, 'Predicted protein', 63, NULL, NULL, 138922),
(138923, '3.60.21.10-FF-000193', NULL, 'Double-strand break repair protein', 316, NULL, NULL, 138923),
(138924, '2.30.30.40-FF-000491', NULL, 'Tyrosine-protein kinase', 61, NULL, NULL, 138924),
(138925, '1.10.20.120-FF-000003', NULL, 'Ribonuclease H2 subunit B', 129, NULL, NULL, 138925),
(138926, '3.30.930.10-FF-000194', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase gcn-2', 349, NULL, NULL, 138926),
(138927, '1.20.1070.10-FF-000131', NULL, 'alpha-2A adrenergic receptor', 314, NULL, NULL, 138927),
(138928, '1.10.1240.20-FF-000003', NULL, 'Lytic murein transglycosylase', 69, NULL, NULL, 138928),
(138929, '1.10.10.10-FF-000438', NULL, 'DNA-binding response regulator', 110, NULL, NULL, 138929),
(138930, '1.20.120.1320-FF-000018', NULL, NULL, 82, NULL, NULL, 138930),
(138931, '2.130.10.10-FF-002864', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', 147, NULL, NULL, 138931),
(138932, '1.10.1670.10-FF-000050', NULL, NULL, 98, NULL, NULL, 138932),
(138933, '1.10.8.270-FF-000104', NULL, 'Rab-GTPase-TBC_domain_containing_protein_-_putative', 113, NULL, NULL, 138933),
(138934, '3.60.20.10-FF-000230', NULL, NULL, 104, NULL, NULL, 138934),
(138935, '1.20.1080.10-FF-000013', NULL, 'Aquaporin NIP2-1', 233, NULL, NULL, 138935),
(138936, '1.20.58.70-FF-000066', NULL, 't-SNARE family protein', 239, NULL, NULL, 138936),
(138937, '1.10.400.10-FF-000020', NULL, 'Guanine nucleotide-binding protein G(o) subunit alpha', 94, NULL, NULL, 138937),
(138938, '1.20.120.420-FF-000028', NULL, 'Uncharacterized protein', 55, NULL, NULL, 138938),
(138939, '1.10.472.10-FF-000641', NULL, 'Cyclin A', 115, NULL, NULL, 138939),
(138940, '1.20.120.720-FF-000005', NULL, 'unconventional myosin-VI isoform X1', 125, NULL, NULL, 138940),
(138941, '1.10.220.150-FF-000051', NULL, 'ADP-ribosylation factor GTPase activating protein, putative', 125, NULL, NULL, 138941),
(138942, '2.40.100.10-FF-000115', NULL, 'Probable peptidyl-prolyl cis-trans isomerase sll0227', 190, NULL, NULL, 138942),
(138943, '3.40.50.300-FF-004787', NULL, 'ATP-binding cassette sub-family A member 3-like Protein', 99, NULL, NULL, 138943),
(138944, '3.30.40.10-FF-002352', NULL, 'Histone acetyltransferase', 87, NULL, NULL, 138944),
(138945, '2.40.100.10-FF-000059', NULL, 'Peptidyl-prolyl cis-trans isomerase', 179, NULL, NULL, 138945),
(138946, '3.40.1390.30-FF-000003', NULL, 'Nif3-like dinuclear metal center protein', 107, NULL, NULL, 138946),
(138947, '3.30.750.24-FF-000024', NULL, 'Sulfate permease 2', 145, NULL, NULL, 138947),
(138948, '1.10.8.50-FF-000011', NULL, 'Ribosomal protein S13', 71, NULL, NULL, 138948),
(138949, '2.60.40.60-FF-000344', NULL, 'Cadherin 2', 105, NULL, NULL, 138949),
(138950, '3.80.10.10-FF-000234', NULL, 'Probable inactive receptor kinase RLK902', 159, NULL, NULL, 138950),
(138951, '3.30.70.330-FF-000530', NULL, 'Polyadenylate-binding protein-interacting protein 11', 113, NULL, NULL, 138951),
(138952, '3.40.50.10470-FF-000028', NULL, 'Methylthioribose-1-phosphate isomerase', 158, NULL, NULL, 138952),
(138953, '3.30.519.10-FF-000024', NULL, NULL, 82, NULL, NULL, 138953),
(138954, '3.80.10.10-FF-000178', NULL, 'protein AMN1 homolog isoform X1', 248, NULL, NULL, 138954),
(138955, '1.20.1560.10-FF-000831', NULL, 'Protein CBG12969', 640, NULL, NULL, 138955),
(138956, '1.10.3370.10-FF-000010', NULL, 'Protein transport protein SEC61 subunit alpha', 466, NULL, NULL, 138956),
(138957, '3.90.132.10-FF-000005', NULL, 'Leishmanolysin metalloprotease M8', 119, NULL, NULL, 138957),
(138958, '3.80.30.20-FF-000002', NULL, 'threonylcarbamoyladenosine tRNA methylthiotransferase isoform X2', 229, NULL, NULL, 138958),
(138959, '2.130.10.10-FF-000155', NULL, 'Autophagy-related protein 16-1 isoform 1', 74, NULL, NULL, 138959); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(138960, '2.10.25.10-FF-001145', NULL, 'Hemicentin 1', 39, NULL, NULL, 138960),
(138961, '3.30.70.850-FF-000012', NULL, 'Subtilisin-related protease SPC2', 88, NULL, NULL, 138961),
(138962, '3.40.50.720-FF-002316', NULL, 'Uncharacterized protein', 128, NULL, NULL, 138962),
(138963, '3.20.20.10-FF-000018', NULL, 'Pyridoxal phosphate homeostasis protein', 224, NULL, NULL, 138963),
(138964, '3.40.50.150-FF-000650', NULL, 'Polyketide synthase RzxC', 250, NULL, NULL, 138964),
(138965, '3.40.190.10-FF-000140', NULL, 'Transcriptional regulator, LysR family', 106, NULL, NULL, 138965),
(138966, '3.40.640.10-FF-000006', NULL, '5-aminolevulinate synthase, mitochondrial', 237, NULL, NULL, 138966),
(138967, '3.90.280.10-FF-000006', NULL, 'protein D3', 186, NULL, NULL, 138967),
(138968, '3.90.79.10-FF-000122', NULL, 'Nudix hydrolase 21', 127, NULL, NULL, 138968),
(138969, '1.10.10.2330-FF-000001', NULL, 'phenylalanine--tRNA ligase alpha subunit', 46, NULL, NULL, 138969),
(138970, '3.40.50.1760-FF-000013', NULL, NULL, 131, NULL, NULL, 138970),
(138971, '3.40.50.150-FF-000594', NULL, 'Ribosomal RNA small subunit methyltransferase A', 206, NULL, NULL, 138971),
(138972, '1.20.1070.10-FF-000182', NULL, 'gastrin/cholecystokinin type B receptor', 313, NULL, NULL, 138972),
(138973, '2.10.25.10-FF-001089', NULL, 'AGAP007849-PA', 49, NULL, NULL, 138973),
(138974, '3.90.79.10-FF-000066', NULL, 'DDP1p Polyphosphate phosphatase', 155, NULL, NULL, 138974),
(138975, '3.30.200.20-FF-000282', NULL, 'LRR receptor-like serine/threonine-protein kinase FEI 1', 102, NULL, NULL, 138975),
(138976, '3.30.2310.20-FF-000008', NULL, 'Toxin', 96, NULL, NULL, 138976),
(138977, '1.25.40.10-FF-001290', NULL, 'Os12g0233200 protein', 90, NULL, NULL, 138977),
(138978, '1.10.720.30-FF-000050', NULL, 'SAP domain-containing ribonucleoprotein isoform X1', 65, NULL, NULL, 138978),
(138979, '3.10.450.50-FF-000095', NULL, 'NTF2-related export protein 1', 102, NULL, NULL, 138979),
(138980, '1.20.1540.10-FF-000055', NULL, 'Rhomboid family intramembrane serine protease', 195, NULL, NULL, 138980),
(138981, '3.40.190.10-FF-000084', NULL, 'glutamate receptor ionotropic, NMDA 1 isoform X1', 28, NULL, NULL, 138981),
(138982, '3.30.420.40-FF-000220', NULL, 'D-ribulose kinase', 230, NULL, NULL, 138982),
(138983, '3.90.930.12-FF-000014', NULL, 'Uncharacterized protein', 42, NULL, NULL, 138983),
(138984, '3.40.630.150-FF-000011', NULL, 'Uncharacterized protein', 66, NULL, NULL, 138984),
(138985, '3.40.1190.20-FF-000018', NULL, 'Ketohexokinase', 296, NULL, NULL, 138985),
(138986, '2.60.40.420-FF-000071', NULL, 'Conidial pigment biosynthesis oxidase Abr1/brown 1', 189, NULL, NULL, 138986),
(138987, '3.30.420.40-FF-000271', NULL, 'actin-related protein 3B isoform X6', 81, NULL, NULL, 138987),
(138988, '3.90.70.10-FF-000777', NULL, 'Ubiquitin-specific peptidase 1', 43, NULL, NULL, 138988),
(138989, '3.30.1150.10-FF-000021', NULL, NULL, 88, NULL, NULL, 138989),
(138990, '1.20.1050.80-FF-000004', NULL, 'ankyrin repeat domain-containing protein 27', 149, NULL, NULL, 138990),
(138991, '2.60.40.60-FF-000288', NULL, 'cadherin-12 isoform X2', 54, NULL, NULL, 138991),
(138992, '3.30.160.60-FF-000391', NULL, 'zinc finger protein 652 isoform X1', 28, NULL, NULL, 138992),
(138993, '3.40.50.300-FF-000509', NULL, 'ADP-ribosylation factor-related protein 1', 192, NULL, NULL, 138993),
(138994, '3.40.50.300-FF-004843', NULL, 'DNA polymerase III subunit delta', 131, NULL, NULL, 138994),
(138995, '3.40.50.1780-FF-000019', NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', 125, NULL, NULL, 138995),
(138996, '1.20.58.70-FF-000122', NULL, 'Probable syntaxin-7B', 106, NULL, NULL, 138996),
(138997, '3.40.50.150-FF-000942', NULL, NULL, 63, NULL, NULL, 138997),
(138998, '3.10.110.10-FF-000344', NULL, 'Uncharacterized protein', 221, NULL, NULL, 138998),
(138999, '3.90.550.50-FF-000191', NULL, 'Uncharacterized protein', 207, NULL, NULL, 138999),
(139000, '3.30.200.20-FF-000630', NULL, 'Uncharacterized protein', 76, NULL, NULL, 139000),
(139001, '3.80.10.10-FF-002090', NULL, 'Predicted protein', 137, NULL, NULL, 139001);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(139002, '1.10.510.10-FF-000915', NULL, 'Serine/threonine-protein kinase ATG1', 240, NULL, NULL, 139002),
(139003, '3.30.750.24-FF-000075', NULL, 'GD11313', 113, NULL, NULL, 139003),
(139004, '1.10.8.270-FF-000048', NULL, 'Rab GTPase activating protein, putative', 96, NULL, NULL, 139004),
(139005, '1.10.220.100-FF-000002', NULL, 'Yeast Enhancer of DeCapping homolog', 90, NULL, NULL, 139005),
(139006, '2.130.10.10-FF-003825', NULL, 'Uncharacterized protein', 301, NULL, NULL, 139006),
(139007, '1.20.1310.10-FF-000228', NULL, NULL, 130, NULL, NULL, 139007),
(139008, '1.10.510.10-FF-003440', NULL, NULL, 361, NULL, NULL, 139008),
(139009, '3.40.50.300-FF-003882', NULL, 'Tyrosine-protein kinase ptk', 74, NULL, NULL, 139009),
(139010, '3.75.10.10-FF-000016', NULL, 'Amidinotransferase, putative', 281, NULL, NULL, 139010),
(139011, '3.90.190.10-FF-000230', NULL, 'Dual specificity protein phosphatase 12', 159, NULL, NULL, 139011),
(139012, '3.40.50.300-FF-006636', NULL, 'Uncharacterized protein', 90, NULL, NULL, 139012),
(139013, '1.10.510.10-FF-000966', NULL, 'Serine/threonine-protein kinase 3, putative', 261, NULL, NULL, 139013),
(139014, '1.10.10.60-FF-000144', NULL, 'homeobox-leucine zipper protein ATHB-6-like', 47, NULL, NULL, 139014),
(139015, '1.10.510.10-FF-001135', NULL, 'Protein CBG16501', 361, NULL, NULL, 139015),
(139016, '1.10.510.10-FF-000567', NULL, 'cGMP-dependent protein kinase', 194, NULL, NULL, 139016),
(139017, '1.10.230.10-FF-000017', NULL, 'Uncharacterized protein', 97, NULL, NULL, 139017),
(139018, '3.30.160.60-FF-003201', NULL, 'Zinc finger protein 212', 26, NULL, NULL, 139018),
(139019, '2.40.40.10-FF-000009', NULL, 'Allergenic cerato-platanin Asp F13 (AFU_orthologue AFUA_2G12630)', 119, NULL, NULL, 139019),
(139020, '3.60.21.50-FF-000025', NULL, 'DNA polymerase delta small subunit, putative', 97, NULL, NULL, 139020),
(139021, '1.20.58.310-FF-000001', NULL, 'Polyphosphate kinase', 101, NULL, NULL, 139021),
(139022, '2.60.40.10-FF-005062', NULL, 'Gelation factor', 101, NULL, NULL, 139022),
(139023, '1.10.510.10-FF-000859', NULL, 'ARM repeat superfamily protein', 199, NULL, NULL, 139023),
(139024, '3.50.50.60-FF-001085', NULL, 'Predicted protein', 105, NULL, NULL, 139024),
(139025, '3.50.50.60-FF-000180', NULL, 'Glutamate synthase 1 [NADH] chloroplastic', 102, NULL, NULL, 139025),
(139026, '3.30.1010.10-FF-000039', NULL, 'Related to PIK1-phosphatidylinositol 4-kinase', 144, NULL, NULL, 139026),
(139027, '1.25.40.10-FF-002251', NULL, 'Intraflagellar transport particle protein IFT88', 304, NULL, NULL, 139027),
(139028, '3.40.50.150-FF-000543', NULL, 'Class I SAM-dependent methyltransferase', 189, NULL, NULL, 139028),
(139029, '3.40.47.10-FF-000276', NULL, NULL, 70, NULL, NULL, 139029),
(139030, '3.40.50.300-FF-000953', NULL, 'GTPase Der', 166, NULL, NULL, 139030),
(139031, '3.90.190.10-FF-000123', NULL, 'Similar to protein tyrosine/serine phosphatase', 257, NULL, NULL, 139031),
(139032, '3.40.50.300-FF-000661', NULL, 'calmodulin-interacting protein 111 isoform X1', 176, NULL, NULL, 139032),
(139033, '3.60.21.10-FF-000209', NULL, '2'',3''-cyclic-nucleotide 2''-phosphodiesterase / 3''-nucleotidase', 310, NULL, NULL, 139033),
(139034, '1.25.40.440-FF-000003', NULL, 'Nuclear pore complex protein Nup155', 78, NULL, NULL, 139034),
(139035, '3.30.200.20-FF-000231', NULL, 'Cyclin-dependent kinase B2,2', 90, NULL, NULL, 139035),
(139036, '1.10.510.10-FF-004277', NULL, NULL, 176, NULL, NULL, 139036),
(139037, '3.20.110.10-FF-000004', NULL, 'Alpha-mannosidase', 335, NULL, NULL, 139037),
(139038, '3.20.20.140-FF-000319', NULL, 'Metal-dependent phosphoesterase, PHP family protein', 185, NULL, NULL, 139038),
(139039, '3.50.50.60-FF-000073', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 153, NULL, NULL, 139039),
(139040, '2.60.40.10-FF-004573', NULL, NULL, 98, NULL, NULL, 139040),
(139041, '3.30.160.60-FF-004281', NULL, NULL, 29, NULL, NULL, 139041),
(139042, '3.30.160.60-FF-001352', NULL, 'ras-responsive element-binding protein 1', 26, NULL, NULL, 139042),
(139043, '1.20.1260.60-FF-000003', NULL, 'IST1-like protein isoform A', 187, NULL, NULL, 139043);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(139044, '1.20.144.10-FF-000146', NULL, 'Uncharacterized protein', 75, NULL, NULL, 139044),
(139045, '3.30.1330.30-FF-000069', NULL, 'Pelota protein, putative', 120, NULL, NULL, 139045),
(139046, '3.40.50.300-FF-007193', NULL, 'Gluconokinase', 169, NULL, NULL, 139046),
(139047, '2.130.10.10-FF-005618', NULL, 'Uncharacterized protein', 185, NULL, NULL, 139047),
(139048, '1.10.530.10-FF-000057', NULL, 'Endolysin', 163, NULL, NULL, 139048),
(139049, '3.90.70.110-FF-000001', NULL, 'Non-structural polyprotein P1234', 150, NULL, NULL, 139049),
(139050, '3.30.160.60-FF-006074', NULL, NULL, 69, NULL, NULL, 139050),
(139051, '3.30.930.10-FF-000250', NULL, 'Uncharacterized protein', 208, NULL, NULL, 139051),
(139052, '1.10.510.10-FF-001927', NULL, 'Receptor protein-tyrosine kinase', 125, NULL, NULL, 139052),
(139053, '3.50.50.60-FF-000865', NULL, 'Uncharacterized protein', 94, NULL, NULL, 139053),
(139054, '1.20.1250.20-FF-002082', NULL, 'Os03g0197200 protein', 268, NULL, NULL, 139054),
(139055, '3.40.190.10-FF-000696', NULL, 'Bicarbonate-binding protein CmpA', 126, NULL, NULL, 139055),
(139056, '1.25.10.10-FF-001462', NULL, 'Telomere repeat binding bouquet formation protein 1', 163, NULL, NULL, 139056),
(139057, '3.30.160.60-FF-000239', NULL, 'C2H2 type zinc finger protein', 33, NULL, NULL, 139057),
(139058, '1.10.3720.10-FF-000228', NULL, 'Arginine transport system permease protein', 220, NULL, NULL, 139058),
(139059, '1.10.1370.30-FF-000049', NULL, 'Angiotensin-converting enzyme', 334, NULL, NULL, 139059),
(139060, '2.60.40.10-FF-000638', NULL, 'von Willebrand factor A domain-containing 1', 94, NULL, NULL, 139060),
(139061, '2.60.260.20-FF-000018', NULL, 'Mitochondrial protein import protein MAS5', 69, NULL, NULL, 139061),
(139062, '1.10.150.20-FF-000256', NULL, 'GEN1 Holliday junction resolvase homolog', 62, NULL, NULL, 139062),
(139063, '3.40.50.720-FF-001304', NULL, 'Pyrroline-5-carboxylate reductase', 178, NULL, NULL, 139063),
(139064, '2.70.150.10-FF-000134', NULL, 'Calcium-transporting ATPase', 98, NULL, NULL, 139064),
(139065, '1.10.510.10-FF-000174', NULL, 'Serine/threonine-protein kinase PDIK1L', 228, NULL, NULL, 139065),
(139066, '3.40.50.300-FF-003483', NULL, 'WHiTe (Drosophila) related ABC transporter', 246, NULL, NULL, 139066),
(139067, '3.55.50.30-FF-000014', NULL, 'Putative anti-sigma factor', 83, NULL, NULL, 139067),
(139068, '3.40.50.300-FF-008497', NULL, 'Uncharacterized protein', 22, NULL, NULL, 139068),
(139069, '1.25.40.10-FF-002195', NULL, 'Conserved Edge Expressed protein', 300, NULL, NULL, 139069),
(139070, '2.130.10.10-FF-003084', NULL, 'Predicted protein', 97, NULL, NULL, 139070),
(139071, '1.25.40.20-FF-000567', NULL, 'Uncharacterized protein', 133, NULL, NULL, 139071),
(139072, '1.20.1280.50-FF-000102', NULL, 'Putative a receptor for ubiquitination targets', 52, NULL, NULL, 139072),
(139073, '1.10.1070.11-FF-000022', NULL, 'Phosphatidylinositol 4-kinase stt4', 193, NULL, NULL, 139073),
(139074, '3.60.15.10-FF-000100', NULL, 'Possible bifunctional enzyme: 2-hydroxyhepta-2,4-diene-1,7-dioate isomerase + cyclase/dehydrase', 249, NULL, NULL, 139074),
(139075, '1.10.10.440-FF-000097', NULL, 'Uncharacterized protein', 81, NULL, NULL, 139075),
(139076, '3.30.200.20-FF-001535', NULL, 'Serine/threonine-protein kinase receptor', 94, NULL, NULL, 139076),
(139077, '3.30.200.20-FF-002024', NULL, 'Uncharacterized protein', 92, NULL, NULL, 139077),
(139078, '1.25.10.10-FF-000118', NULL, 'Integrator complex subunit 4', 147, NULL, NULL, 139078),
(139079, '1.25.40.10-FF-002543', NULL, 'Pentatricopeptide repeat-containing protein At1g62670, mitochondrial', 100, NULL, NULL, 139079),
(139080, '1.25.10.10-FF-000973', NULL, 'WD domain, G-beta repeat-containing protein', 277, NULL, NULL, 139080),
(139081, '4.10.1000.10-FF-000104', NULL, 'Uncharacterized protein', 68, NULL, NULL, 139081),
(139082, '3.40.50.300-FF-008154', NULL, 'Nuclear calmodulin-binding protein', 92, NULL, NULL, 139082),
(139083, '3.30.70.420-FF-000001', NULL, '3-hydroxy-3-methylglutaryl coenzyme A reductase', 117, NULL, NULL, 139083);
INSERT INTO "PUBLIC"."MODEL" VALUES
(139084, '3.50.50.60-FF-001141', NULL, 'Glutathione reductase', 90, NULL, NULL, 139084),
(139085, '1.25.40.1030-FF-000059', NULL, 'Uncharacterized protein', 54, NULL, NULL, 139085),
(139086, '1.10.8.60-FF-000284', NULL, 'AAA family ATPase', 94, NULL, NULL, 139086),
(139087, '3.90.550.10-FF-000370', NULL, 'Predicted protein', 117, NULL, NULL, 139087),
(139088, '3.30.420.10-FF-000677', NULL, NULL, 165, NULL, NULL, 139088),
(139089, '1.25.40.20-FF-000168', NULL, 'Myosin XVI', 119, NULL, NULL, 139089),
(139090, '1.20.120.980-FF-000050', NULL, 'Uncharacterized protein', 140, NULL, NULL, 139090),
(139091, '1.10.472.10-FF-000692', NULL, 'Uncharacterized protein', 175, NULL, NULL, 139091),
(139092, '2.60.120.10-FF-000303', NULL, 'Homogentisate 1,2-dioxygenase', 136, NULL, NULL, 139092),
(139093, '1.20.120.720-FF-000056', NULL, 'Myosin-4', 48, NULL, NULL, 139093),
(139094, '1.10.10.60-FF-000324', NULL, 'Transcription factor MYB3R-2', 63, NULL, NULL, 139094),
(139095, '2.10.25.10-FF-001706', NULL, 'Multiple EGF-like-domains 8', 62, NULL, NULL, 139095),
(139096, '3.30.830.10-FF-000214', NULL, 'Mitochondrial presequence protease', 255, NULL, NULL, 139096),
(139097, '1.20.1080.10-FF-000064', NULL, 'Uncharacterized protein', 145, NULL, NULL, 139097),
(139098, '1.20.1250.20-FF-002031', NULL, 'Uncharacterized protein', 344, NULL, NULL, 139098),
(139099, '2.40.20.10-FF-000126', NULL, 'Uncharacterized protein', 48, NULL, NULL, 139099),
(139100, '1.25.10.10-FF-001411', NULL, 'Unplaced genomic scaffold supercont2.21, whole genome shotgun sequence', 683, NULL, NULL, 139100),
(139101, '2.60.40.60-FF-000905', NULL, 'Uncharacterized protein', 107, NULL, NULL, 139101),
(139102, '3.20.10.10-FF-000012', NULL, '4-amino-4-deoxychorismate lyase', 156, NULL, NULL, 139102),
(139103, '3.40.309.10-FF-000040', NULL, 'Probable aldehyde dehydrogenase', 194, NULL, NULL, 139103),
(139104, '2.60.60.20-FF-000007', NULL, 'Lipoxygenase homology domain-containing protein 1', 121, NULL, NULL, 139104),
(139105, '3.40.50.720-FF-001355', NULL, 'Uncharacterized protein CaJ7.0123', 334, NULL, NULL, 139105),
(139106, '3.80.10.10-FF-002027', NULL, 'NEPN protein', 113, NULL, NULL, 139106),
(139107, '2.60.40.1490-FF-000001', NULL, 'Histone chaperone ASF1', 157, NULL, NULL, 139107),
(139108, '2.60.40.10-FF-000239', NULL, 'BDNF/NT-3 growth factors receptor', 101, NULL, NULL, 139108),
(139109, '3.60.15.10-FF-000151', NULL, 'Unplaced genomic scaffold supercont2.13, whole genome shotgun sequence', 338, NULL, NULL, 139109),
(139110, '1.10.472.10-FF-000017', NULL, 'Putative cyclin-c', 112, NULL, NULL, 139110),
(139111, '1.25.10.10-FF-002423', NULL, 'Cytosolic regulator of adenylyl cyclase', 247, NULL, NULL, 139111),
(139112, '3.20.20.190-FF-000025', NULL, 'Glycerophosphoryl diester phosphodiesterase', 286, NULL, NULL, 139112),
(139113, '3.40.140.10-FF-000081', NULL, 'Eukaryotic translation initiation factor 3 subunit F', 188, NULL, NULL, 139113),
(139114, '1.20.5.500-FF-000019', NULL, NULL, 46, NULL, NULL, 139114),
(139115, '1.25.40.10-FF-001795', NULL, 'Pentatricopeptide repeat-containing protein At1g25360', 155, NULL, NULL, 139115),
(139116, '3.80.10.10-FF-001538', NULL, 'Uncharacterized protein', 116, NULL, NULL, 139116),
(139117, '1.20.1640.10-FF-000091', NULL, 'Acyltrehalose exporter MmpL10', 175, NULL, NULL, 139117),
(139118, '2.130.10.10-FF-000947', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 215, NULL, NULL, 139118),
(139119, '2.130.10.10-FF-004258', NULL, 'Actin-interacting protein 1-2', 137, NULL, NULL, 139119),
(139120, '3.40.50.2000-FF-000417', NULL, 'Putative UDP-glucuronosyltransferase ugt-56', 174, NULL, NULL, 139120),
(139121, '1.25.40.20-FF-001528', NULL, 'Kinase, NEK', 68, NULL, NULL, 139121),
(139122, '1.10.418.20-FF-000024', NULL, 'Ubiquitin-like-specific protease, putative', 79, NULL, NULL, 139122),
(139123, '3.30.200.20-FF-001586', NULL, 'Uncharacterized protein', 96, NULL, NULL, 139123),
(139124, '3.40.50.12280-FF-000015', NULL, 'Photosystem II CP47 reaction center protein', 94, NULL, NULL, 139124),
(139125, '1.20.58.760-FF-000018', NULL, 'Putative mitochondrial Mitochondrial ATP-dependent zinc metallopeptidase', 192, NULL, NULL, 139125);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(139126, '3.40.50.2300-FF-001457', NULL, NULL, 110, NULL, NULL, 139126),
(139127, '3.30.230.70-FF-000040', NULL, 'EXOSome (Multiexonuclease complex) component', 278, NULL, NULL, 139127),
(139128, '1.20.1560.10-FF-000090', NULL, 'p-GlycoProtein related', 344, NULL, NULL, 139128),
(139129, '1.10.8.100-FF-000025', NULL, 'Ribosomal RNA small subunit methyltransferase A', 69, NULL, NULL, 139129),
(139130, '3.40.250.10-FF-000139', NULL, 'Related to CYS4-Cystathionine beta-synthase', 103, NULL, NULL, 139130),
(139131, '3.40.50.1820-FF-001476', NULL, 'Uncharacterized protein', 171, NULL, NULL, 139131),
(139132, '1.10.10.60-FF-000936', NULL, NULL, 116, NULL, NULL, 139132),
(139133, '2.130.10.10-FF-003769', NULL, 'COP-II coat subunit, nucleoporin', 318, NULL, NULL, 139133),
(139134, '1.25.40.10-FF-002594', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 89, NULL, NULL, 139134),
(139135, '3.50.7.10-FF-000044', NULL, NULL, 74, NULL, NULL, 139135),
(139136, '3.30.70.890-FF-000052', NULL, 'Phosphomevalonate kinase', 129, NULL, NULL, 139136),
(139137, '2.10.70.10-FF-000108', NULL, 'Coagulation factor XIII B chain', 61, NULL, NULL, 139137),
(139138, '3.30.200.20-FF-000574', NULL, 'Uncharacterized protein', 102, NULL, NULL, 139138),
(139139, '3.10.110.10-FF-000288', NULL, 'Uncharacterized protein', 113, NULL, NULL, 139139),
(139140, '2.70.70.10-FF-000038', NULL, 'Murein DD-endopeptidase MepM/ murein hydrolase activator NlpD', 164, NULL, NULL, 139140),
(139141, '2.60.40.150-FF-000259', NULL, 'Phosphatidyl inositol kinase (PIK-A)', 130, NULL, NULL, 139141),
(139142, '1.10.730.10-FF-000005', NULL, 'Methionine--tRNA ligase', 138, NULL, NULL, 139142),
(139143, '1.10.10.60-FF-000375', NULL, 'Ventral anterior homeobox 1', 116, NULL, NULL, 139143),
(139144, '1.20.120.790-FF-000037', NULL, 'TNF receptor associated protein 1', 59, NULL, NULL, 139144),
(139145, '3.30.160.60-FF-004550', NULL, NULL, 33, NULL, NULL, 139145),
(139146, '3.40.120.10-FF-000023', NULL, 'Phosphoacetylglucosamine mutase', 135, NULL, NULL, 139146),
(139147, '3.40.50.2300-FF-000097', NULL, 'Branched-chain amino acid ABC transporter substrate-binding protein', 159, NULL, NULL, 139147),
(139148, '3.30.70.330-FF-000710', NULL, 'Glycine-rich RNA-binding protein RZ1A', 97, NULL, NULL, 139148),
(139149, '1.20.58.1070-FF-000025', NULL, 'Gem-associated protein 2', 168, NULL, NULL, 139149),
(139150, '2.130.10.10-FF-004606', NULL, 'Uncharacterized protein', 202, NULL, NULL, 139150),
(139151, '2.130.10.10-FF-000335', NULL, 'F-box/WD repeat-containing protein 5 isoform X1', 163, NULL, NULL, 139151),
(139152, '2.60.40.150-FF-000315', NULL, 'Phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit beta', 162, NULL, NULL, 139152),
(139153, '3.90.70.10-FF-000597', NULL, 'Protein CBG24565', 195, NULL, NULL, 139153),
(139154, '3.30.160.60-FF-005062', NULL, NULL, 30, NULL, NULL, 139154),
(139155, '1.25.40.530-FF-000030', NULL, NULL, 117, NULL, NULL, 139155),
(139156, '3.30.160.60-FF-004494', NULL, NULL, 25, NULL, NULL, 139156),
(139157, '3.20.20.80-FF-000781', NULL, 'Alpha-L-fucosidase 1', 210, NULL, NULL, 139157),
(139158, '1.20.58.520-FF-000002', NULL, 'Uncharacterized protein', 100, NULL, NULL, 139158),
(139159, '2.40.10.10-FF-000244', NULL, 'GM24079', 256, NULL, NULL, 139159),
(139160, '1.10.10.10-FF-002063', NULL, 'Uncharacterized protein', 178, NULL, NULL, 139160),
(139161, '2.40.10.10-FF-000188', NULL, 'Si:dkeyp-93a5.2', 240, NULL, NULL, 139161),
(139162, '3.30.1370.10-FF-000060', NULL, 'Far upstream element binding protein 3', 92, NULL, NULL, 139162),
(139163, '1.20.5.4770-FF-000005', NULL, 'tumor necrosis factor alpha-induced protein 3', 57, NULL, NULL, 139163),
(139164, '3.40.50.410-FF-000306', NULL, 'Uncharacterized protein', 244, NULL, NULL, 139164),
(139165, '2.170.120.12-FF-000032', NULL, 'RNA polymerase Rpb3/Rpb11 dimerisation domain containing protein', 150, NULL, NULL, 139165),
(139166, '3.90.1310.10-FF-000031', NULL, 'Peptidoglycan glycosyltransferase', 170, NULL, NULL, 139166),
(139167, '1.25.40.10-FF-003829', NULL, 'Uncharacterized protein', 126, NULL, NULL, 139167);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(139168, '3.90.1410.10-FF-000027', NULL, 'SET domain containing protein, putative', 274, NULL, NULL, 139168),
(139169, '3.40.140.10-FF-000018', NULL, 'histone H2A deubiquitinase MYSM1 isoform X2', 150, NULL, NULL, 139169),
(139170, '3.40.50.2300-FF-000153', NULL, 'Guanylate cyclase', 58, NULL, NULL, 139170),
(139171, '3.40.50.2000-FF-000125', NULL, 'Putative alpha-glucosyl-transferase', 186, NULL, NULL, 139171),
(139172, '3.30.160.60-FF-002420', NULL, 'Zinc finger and BTB domain-containing protein 2', 35, NULL, NULL, 139172),
(139173, '3.40.718.10-FF-000007', NULL, 'Isocitrate dehydrogenase [NADP]', 411, NULL, NULL, 139173),
(139174, '2.60.40.1180-FF-000190', NULL, 'Alpha-galactosidase A', 99, NULL, NULL, 139174),
(139175, '2.60.40.10-FF-004005', NULL, NULL, 99, NULL, NULL, 139175),
(139176, '3.30.40.10-FF-001660', NULL, 'MIB (MIndBomb) ubiquitin ligase homolog', 62, NULL, NULL, 139176),
(139177, '3.30.830.10-FF-000158', NULL, 'A-factor-processing enzyme, putative', 186, NULL, NULL, 139177),
(139178, '3.40.50.80-FF-000220', NULL, 'Uncharacterized FAD-binding protein C17H9.12c', 118, NULL, NULL, 139178),
(139179, '3.30.210.10-FF-000010', NULL, 'Repair DNA polymerase X', 69, NULL, NULL, 139179),
(139180, '1.10.510.10-FF-001422', NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 205', 87, NULL, NULL, 139180),
(139181, '1.25.10.10-FF-002659', NULL, 'Uncharacterized protein', 101, NULL, NULL, 139181),
(139182, '2.60.40.10-FF-000683', NULL, 'ADAMTS like 1', 97, NULL, NULL, 139182),
(139183, '1.10.533.10-FF-000154', NULL, 'Uncharacterized protein', 86, NULL, NULL, 139183),
(139184, '2.60.40.640-FF-000081', NULL, 'Uncharacterized protein', 147, NULL, NULL, 139184),
(139185, '3.90.1150.10-FF-000260', NULL, 'Aminotransferase, class V family', 124, NULL, NULL, 139185),
(139186, '3.10.50.40-FF-000142', NULL, 'Peptidylprolyl isomerase', 61, NULL, NULL, 139186),
(139187, '2.10.110.10-FF-000095', NULL, 'four and a half LIM domains protein 3', 64, NULL, NULL, 139187),
(139188, '2.160.10.10-FF-000120', NULL, 'Uncharacterized protein', 140, NULL, NULL, 139188),
(139189, '2.60.120.10-FF-000539', NULL, 'Uncharacterized protein', 87, NULL, NULL, 139189),
(139190, '2.60.40.60-FF-000849', NULL, 'Uncharacterized protein', 90, NULL, NULL, 139190),
(139191, '3.30.70.370-FF-000019', NULL, 'Polymerase (DNA directed), theta', 121, NULL, NULL, 139191),
(139192, '2.10.70.10-FF-000092', NULL, 'Hig-anchoring scaffold protein, isoform A', 61, NULL, NULL, 139192),
(139193, '1.20.120.1750-FF-000136', NULL, 'RBR-type E3 ubiquitin transferase', 66, NULL, NULL, 139193),
(139194, '1.10.486.10-FF-000015', NULL, 'DNA helicase', 167, NULL, NULL, 139194),
(139195, '1.25.40.10-FF-000177', NULL, 'Amyloid beta precursor protein binding protein 2', 165, NULL, NULL, 139195),
(139196, '1.10.510.10-FF-003496', NULL, NULL, 257, NULL, NULL, 139196),
(139197, '1.20.1070.10-FF-001255', NULL, 'Uncharacterized protein', 127, NULL, NULL, 139197),
(139198, '3.30.450.20-FF-000233', NULL, 'PAS domain S-box protein', 113, NULL, NULL, 139198),
(139199, '1.20.58.60-FF-000630', NULL, 'Spectrin repeat-containing, nuclear envelope 1b', 222, NULL, NULL, 139199),
(139200, '3.40.50.12100-FF-000006', NULL, 'Stimulator of interferon genes protein-like Protein', 152, NULL, NULL, 139200),
(139201, '3.90.79.10-FF-000297', NULL, 'DNA repair glycosylase', 123, NULL, NULL, 139201),
(139202, '3.40.50.1820-FF-001240', NULL, 'Esterase', 325, NULL, NULL, 139202),
(139203, '1.10.238.10-FF-000142', NULL, 'Secretagogin', 97, NULL, NULL, 139203),
(139204, '3.80.10.10-FF-001291', NULL, 'RNI-like superfamily protein', 292, NULL, NULL, 139204),
(139205, '2.60.40.10-FF-004972', NULL, NULL, 110, NULL, NULL, 139205),
(139206, '1.25.40.10-FF-004780', NULL, 'Uncharacterized protein', 187, NULL, NULL, 139206),
(139207, '3.80.10.10-FF-003432', NULL, 'Leucine-rich repeat-containing 8 VRAC subunit B', 65, NULL, NULL, 139207),
(139208, '3.40.190.10-FF-000645', NULL, 'Peptide ABC transporter substrate-binding protein', 282, NULL, NULL, 139208),
(139209, '3.30.70.890-FF-000001', NULL, 'Galactokinase', 174, NULL, NULL, 139209);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(139210, '2.60.120.20-FF-000020', NULL, 'Genome polyprotein', 281, NULL, NULL, 139210),
(139211, '3.40.50.300-FF-005624', NULL, 'Dynein heavy chain family protein', 215, NULL, NULL, 139211),
(139212, '2.40.50.880-FF-000001', NULL, '3''-5'' exoribonuclease CSL4', 113, NULL, NULL, 139212),
(139213, '3.40.50.150-FF-001324', NULL, NULL, 203, NULL, NULL, 139213),
(139214, '3.40.50.300-FF-005568', NULL, 'Uncharacterized protein', 198, NULL, NULL, 139214),
(139215, '3.40.50.720-FF-001809', NULL, 'Narbonolide/10-deoxymethynolide synthase PikA1, modules 1 and 2', 484, NULL, NULL, 139215),
(139216, '2.40.270.10-FF-000009', NULL, 'DNA-directed RNA polymerase subunit beta', 137, NULL, NULL, 139216),
(139217, '4.10.240.30-FF-000001', NULL, 'Tumor necrosis factor alpha-induced protein 3', 31, NULL, NULL, 139217),
(139218, '3.40.605.10-FF-000144', NULL, 'Aldehyde dehydrogenase', 60, NULL, NULL, 139218),
(139219, '4.10.320.30-FF-000002', NULL, 'Histone acetyltransferase', 32, NULL, NULL, 139219),
(139220, '3.40.50.2300-FF-001406', NULL, NULL, 108, NULL, NULL, 139220),
(139221, '3.40.50.300-FF-004264', NULL, 'Glr1927 protein', 363, NULL, NULL, 139221),
(139222, '2.10.25.10-FF-000077', NULL, 'Latent-transforming growth factor beta-binding protein 3 isoform 1', 45, NULL, NULL, 139222),
(139223, '1.25.40.20-FF-000511', NULL, 'Ankyrin repeat domain-containing protein 54', 140, NULL, NULL, 139223),
(139224, '3.40.225.10-FF-000047', NULL, NULL, 213, NULL, NULL, 139224),
(139225, '1.25.50.10-FF-000003', NULL, 'M1 family aminopeptidase', 339, NULL, NULL, 139225),
(139226, '3.10.450.580-FF-000010', NULL, 'Mediator of RNA polymerase II transcription subunit 6', 130, NULL, NULL, 139226),
(139227, '3.40.50.300-FF-004371', NULL, 'YALI0D21494p', 218, NULL, NULL, 139227),
(139228, '2.120.10.30-FF-000010', NULL, 'Low density lipoprotein receptor-related protein 1B', 305, NULL, NULL, 139228),
(139229, '1.20.1530.20-FF-000091', NULL, 'Uncharacterized protein', 287, NULL, NULL, 139229),
(139230, '3.40.50.300-FF-007698', NULL, 'Predicted protein', 104, NULL, NULL, 139230),
(139231, '3.90.1030.10-FF-000004', NULL, '50S ribosomal protein L17', 113, NULL, NULL, 139231),
(139232, '3.40.50.1860-FF-000004', NULL, 'Aspartate racemase', 112, NULL, NULL, 139232),
(139233, '2.70.130.10-FF-000083', NULL, NULL, 146, NULL, NULL, 139233),
(139234, '3.30.200.20-FF-000462', NULL, 'Calcium-dependent protein kinase 24', 86, NULL, NULL, 139234),
(139235, '2.60.120.820-FF-000020', NULL, 'Uncharacterized protein', 106, NULL, NULL, 139235),
(139236, '2.10.110.10-FF-000151', NULL, 'Uncharacterized protein, isoform G', 74, NULL, NULL, 139236),
(139237, '3.40.50.300-FF-001353', NULL, 'Nuclear GTPase, germinal center associated', 219, NULL, NULL, 139237),
(139238, '3.40.50.720-FF-001012', NULL, 'Glycerate dehydrogenase', 93, NULL, NULL, 139238),
(139239, '3.80.10.10-FF-002651', NULL, 'Uncharacterized protein', 168, NULL, NULL, 139239),
(139240, '1.10.533.10-FF-000210', NULL, 'Uncharacterized protein', 82, NULL, NULL, 139240),
(139241, '3.50.50.60-FF-000921', NULL, 'IP11909p', 180, NULL, NULL, 139241),
(139242, '3.30.710.10-FF-000267', NULL, 'Regulator of chromosome condensation (RCC1) repeat, putative', 55, NULL, NULL, 139242),
(139243, '2.60.120.200-FF-000519', NULL, 'Vesicular integral-membrane protein VIP36', 228, NULL, NULL, 139243),
(139244, '3.90.1150.10-FF-000108', NULL, 'Aspartate aminotransferase', 111, NULL, NULL, 139244),
(139245, '3.50.4.10-FF-000003', NULL, 'Hepatocyte growth factor', 69, NULL, NULL, 139245),
(139246, '3.10.100.10-FF-000231', NULL, NULL, 139, NULL, NULL, 139246),
(139247, '1.10.167.10-FF-000055', NULL, 'Probable inactive serine/threonine-protein kinase roco10', 131, NULL, NULL, 139247),
(139248, '2.60.120.260-FF-000392', NULL, 'Beta-xylanase', 167, NULL, NULL, 139248),
(139249, '1.10.510.10-FF-000062', NULL, 'peripheral plasma membrane protein CASK isoform X2', 192, NULL, NULL, 139249),
(139250, '1.20.900.10-FF-000112', NULL, 'RH56938p', 76, NULL, NULL, 139250),
(139251, '1.20.1070.10-FF-002036', NULL, 'Olfactory receptor', 117, NULL, NULL, 139251);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(139252, '1.25.40.20-FF-000399', NULL, 'ankyrin repeat domain-containing protein 50', 49, NULL, NULL, 139252),
(139253, '3.40.50.300-FF-002134', NULL, 'ABC transporter ATP-binding protein/permease wht-1', 231, NULL, NULL, 139253),
(139254, '1.25.40.180-FF-000060', NULL, 'Putative CCR4-NOT transcription complex subunit 1', 259, NULL, NULL, 139254),
(139255, '3.50.50.60-FF-001377', NULL, 'Choline dehydrogenase, putative', 175, NULL, NULL, 139255),
(139256, '3.10.20.90-FF-000756', NULL, 'Uncharacterized protein', 94, NULL, NULL, 139256),
(139257, '3.50.50.60-FF-001433', NULL, 'GDP dissociation inhibitor family protein', 111, NULL, NULL, 139257),
(139258, '3.90.730.10-FF-000024', NULL, 'Uncharacterized protein', 138, NULL, NULL, 139258),
(139259, '3.80.10.10-FF-000521', NULL, 'Os03g0724300 protein', 257, NULL, NULL, 139259),
(139260, '3.30.540.10-FF-000040', NULL, 'Inositol-1-monophosphatase', 149, NULL, NULL, 139260),
(139261, '3.30.160.60-FF-004218', NULL, NULL, 32, NULL, NULL, 139261),
(139262, '3.30.200.20-FF-002316', NULL, 'Predicted protein', 105, NULL, NULL, 139262),
(139263, '1.10.8.60-FF-000576', NULL, 'Uncharacterized protein', 56, NULL, NULL, 139263),
(139264, '3.40.50.300-FF-004219', NULL, 'ATP-dependent RNA helicase', 184, NULL, NULL, 139264),
(139265, '3.90.810.10-FF-000025', NULL, NULL, 39, NULL, NULL, 139265),
(139266, '3.40.50.300-FF-000897', NULL, 'NLR family pyrin domain containing 1', 213, NULL, NULL, 139266),
(139267, '2.40.10.500-FF-000003', NULL, NULL, 87, NULL, NULL, 139267),
(139268, '3.40.50.300-FF-007985', NULL, 'Uncharacterized protein', 157, NULL, NULL, 139268),
(139269, '3.40.50.1100-FF-000282', NULL, 'Uncharacterized protein', 41, NULL, NULL, 139269),
(139270, '1.10.600.10-FF-000125', NULL, 'Farnesyl pyrophosphate synthase-like Protein', 93, NULL, NULL, 139270),
(139271, '3.40.390.10-FF-000121', NULL, 'Matrix metalloproteinase-B', 281, NULL, NULL, 139271),
(139272, '3.30.160.60-FF-002313', NULL, 'Tripartite motif containing 31', 77, NULL, NULL, 139272),
(139273, '4.10.280.10-FF-000060', NULL, 'Scute protein', 67, NULL, NULL, 139273),
(139274, '1.25.40.20-FF-000275', NULL, 'Uncharacterized protein, isoform B', 157, NULL, NULL, 139274),
(139275, '3.40.190.10-FF-000932', NULL, 'Glutamate receptor, putative', 53, NULL, NULL, 139275),
(139276, '3.30.300.130-FF-000029', NULL, NULL, 73, NULL, NULL, 139276),
(139277, '3.40.605.10-FF-000088', NULL, 'Aldehyde dehydrogenase X, mitochondrial', 106, NULL, NULL, 139277),
(139278, '3.30.160.60-FF-006366', NULL, NULL, 32, NULL, NULL, 139278),
(139279, '1.25.10.10-FF-000349', NULL, 'Armadillo-domain containing rhoptry protein, putative', 252, NULL, NULL, 139279),
(139280, '2.130.10.10-FF-004837', NULL, 'Ribosomal large subunit assembly and maintenance-related protein, putative', 132, NULL, NULL, 139280),
(139281, '3.80.10.10-FF-002595', NULL, 'Adhesion G protein-coupled receptor A2', 79, NULL, NULL, 139281),
(139282, '1.10.510.10-FF-004333', NULL, NULL, 135, NULL, NULL, 139282),
(139283, '3.30.1430.10-FF-000003', NULL, 'Ribosomal protein', 42, NULL, NULL, 139283),
(139284, '2.20.50.20-FF-000014', NULL, 'Vitellogenin', 129, NULL, NULL, 139284),
(139285, '1.25.40.10-FF-000339', NULL, 'Proteinaceous RNase P 1, chloroplastic/mitochondrial', 295, NULL, NULL, 139285),
(139286, '3.30.9.90-FF-000004', NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase, mitochondrial', 34, NULL, NULL, 139286),
(139287, '1.25.40.1040-FF-000045', NULL, 'Uncharacterized protein', 260, NULL, NULL, 139287),
(139288, '2.130.10.10-FF-001116', NULL, 'GM10830', 134, NULL, NULL, 139288),
(139289, '1.25.10.10-FF-000681', NULL, 'Serine/threonine-protein kinase TOR', 452, NULL, NULL, 139289),
(139290, '2.40.50.40-FF-000002', NULL, 'C-C motif chemokine', 71, NULL, NULL, 139290),
(139291, '3.40.50.80-FF-000040', NULL, 'Respiratory burst oxidase protein D', 196, NULL, NULL, 139291),
(139292, '3.30.1510.10-FF-000004', NULL, 'C1-tetrahydrofolate synthase', 101, NULL, NULL, 139292),
(139293, '2.60.40.60-FF-001013', NULL, 'Pcdh1 protein', 68, NULL, NULL, 139293);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(139294, '1.25.40.190-FF-000006', NULL, 'Actin-related protein 2/3 complex subunit 5', 101, NULL, NULL, 139294),
(139295, '3.40.50.2000-FF-000001', NULL, 'UDP-glucuronosyltransferase', 169, NULL, NULL, 139295),
(139296, '3.30.70.330-FF-002559', NULL, NULL, 148, NULL, NULL, 139296),
(139297, '2.70.150.10-FF-000027', NULL, 'Cation-transporting ATPase', 163, NULL, NULL, 139297),
(139298, '1.10.1390.10-FF-000005', NULL, 'Glucose-6-phosphate isomerase', 43, NULL, NULL, 139298),
(139299, '3.40.50.720-FF-000287', NULL, 'Pyrroline-5-carboxylate reductase', 160, NULL, NULL, 139299),
(139300, '1.10.30.10-FF-000097', NULL, 'Similar to transcription factor HMG', 86, NULL, NULL, 139300),
(139301, '2.10.110.10-FF-000331', NULL, 'Uncharacterized protein', 102, NULL, NULL, 139301),
(139302, '1.20.1560.10-FF-000382', NULL, 'Beta-(1-->2)glucan export ATP-binding/permease protein NdvA', 325, NULL, NULL, 139302),
(139303, '3.30.200.20-FF-001878', NULL, 'Predicted protein', 102, NULL, NULL, 139303),
(139304, '1.20.1070.10-FF-001199', NULL, 'Uncharacterized protein', 95, NULL, NULL, 139304),
(139305, '1.20.1250.20-FF-001575', NULL, 'Probable major facilitator superfamily (MFS) transporter', 376, NULL, NULL, 139305),
(139306, '1.10.510.10-FF-001079', NULL, 'Unplaced genomic scaffold supercont2.2, whole genome shotgun sequence', 221, NULL, NULL, 139306),
(139307, '1.10.150.170-FF-000017', NULL, NULL, 98, NULL, NULL, 139307),
(139308, '2.40.37.10-FF-000053', NULL, NULL, 11, NULL, NULL, 139308),
(139309, '3.40.50.880-FF-000138', NULL, 'Catalase', 135, NULL, NULL, 139309),
(139310, '3.40.190.10-FF-000589', NULL, 'Prephenate dehydratase', 81, NULL, NULL, 139310),
(139311, '1.20.1270.10-FF-000112', NULL, 'Uncharacterized protein', 33, NULL, NULL, 139311),
(139312, '3.30.70.330-FF-002891', NULL, NULL, 58, NULL, NULL, 139312),
(139313, '2.60.40.10-FF-000407', NULL, 'angiopoietin-1 receptor isoform X1', 96, NULL, NULL, 139313),
(139314, '3.40.50.10190-FF-000265', NULL, 'Putative dna topoisomerase 2-binding protein 1 isoform x1', 87, NULL, NULL, 139314),
(139315, '3.30.565.10-FF-000081', NULL, 'Sensor histidine kinase', 132, NULL, NULL, 139315),
(139316, '1.20.58.390-FF-000093', NULL, 'Uncharacterized protein', 115, NULL, NULL, 139316),
(139317, '1.20.1070.10-FF-000799', NULL, 'Uncharacterized protein', 303, NULL, NULL, 139317),
(139318, '3.40.50.620-FF-000875', NULL, 'Uncharacterized protein', 124, NULL, NULL, 139318),
(139319, '2.160.10.10-FF-000064', NULL, 'UTP--glucose-1-phosphate uridylyltransferase', 91, NULL, NULL, 139319),
(139320, '3.90.228.10-FF-000059', NULL, 'Poly [ADP-ribose] polymerase', 153, NULL, NULL, 139320),
(139321, '1.25.40.10-FF-002363', NULL, 'Os06g0611200 protein', 110, NULL, NULL, 139321),
(139322, '3.30.160.60-FF-005910', NULL, NULL, 44, NULL, NULL, 139322),
(139323, '3.40.50.11210-FF-000015', NULL, NULL, 110, NULL, NULL, 139323),
(139324, '3.30.70.330-FF-001199', NULL, 'RNA-binding protein TIA-1, putative', 122, NULL, NULL, 139324),
(139325, '3.10.170.20-FF-000002', NULL, 'Leishmanolysin like peptidase', 201, NULL, NULL, 139325),
(139326, '2.60.40.10-FF-006079', NULL, NULL, 65, NULL, NULL, 139326),
(139327, '3.40.50.2020-FF-000007', NULL, 'Ribose-phosphate pyrophosphokinase', 155, NULL, NULL, 139327),
(139328, '3.30.160.60-FF-001695', NULL, 'Transcriptional activator/repressor GIS1', 23, NULL, NULL, 139328),
(139329, '1.25.40.10-FF-002487', NULL, 'Pentatricopeptide repeat-containing protein At2g18940, chloroplastic', 110, NULL, NULL, 139329),
(139330, '1.10.8.10-FF-000134', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 36, NULL, NULL, 139330),
(139331, '2.60.40.1910-FF-000015', NULL, 'Aminopeptidase-like protein AC3.5', 88, NULL, NULL, 139331),
(139332, '3.40.50.1820-FF-001184', NULL, 'Uncharacterized protein', 134, NULL, NULL, 139332),
(139333, '3.40.50.720-FF-001647', NULL, 'GalE family epimerase/dehydratase', 305, NULL, NULL, 139333),
(139334, '3.20.20.10-FF-000069', NULL, 'Putative serine dehydratase domain-domain-containing protein', 244, NULL, NULL, 139334),
(139335, '1.10.533.10-FF-000098', NULL, 'Hematopoietic death receptor', 91, NULL, NULL, 139335);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(139336, '2.60.34.10-FF-000062', NULL, 'Heat shock 70 kDa protein 14', 47, NULL, NULL, 139336),
(139337, '2.40.160.200-FF-000004', NULL, NULL, 179, NULL, NULL, 139337),
(139338, '3.40.50.300-FF-000841', NULL, 'Magnesium protoporphyrin chelatase', 209, NULL, NULL, 139338),
(139339, '1.10.20.10-FF-000271', NULL, NULL, 80, NULL, NULL, 139339),
(139340, '1.10.10.60-FF-000431', NULL, 'Set3C deacetylase complex subunit', 76, NULL, NULL, 139340),
(139341, '2.60.40.420-FF-000020', NULL, 'Ephrin-B2', 149, NULL, NULL, 139341),
(139342, '3.80.10.10-FF-001246', NULL, 'Receptor-like protein 11', 155, NULL, NULL, 139342),
(139343, '2.60.40.10-FF-002768', NULL, 'GM22869', 84, NULL, NULL, 139343),
(139344, '3.40.640.10-FF-000282', NULL, 'Predicted protein', 88, NULL, NULL, 139344),
(139345, '1.10.287.440-FF-000002', NULL, 'Phosphoribosylaminoimidazolecarboxamide formyltransferase/IMP cyclohydrolase', 42, NULL, NULL, 139345),
(139346, '3.30.1680.10-FF-000050', NULL, 'Uncharacterized protein', 25, NULL, NULL, 139346),
(139347, '3.40.850.10-FF-000163', NULL, 'Kinesin-like protein vab-8', 302, NULL, NULL, 139347),
(139348, '2.130.10.10-FF-000442', NULL, 'striatin isoform X2', 172, NULL, NULL, 139348),
(139349, '3.10.50.40-FF-000086', NULL, 'Peptidylprolyl isomerase', 155, NULL, NULL, 139349),
(139350, '1.25.10.10-FF-002715', NULL, 'AGR166Wp', 975, NULL, NULL, 139350),
(139351, '1.20.5.190-FF-000089', NULL, 'Unconventional myosin-XIX', 48, NULL, NULL, 139351),
(139352, '3.30.70.270-FF-000102', NULL, 'Putative DNA polymerase eta', 178, NULL, NULL, 139352),
(139353, '2.30.30.30-FF-000083', NULL, 'Transcription elongation factor SPT5', 71, NULL, NULL, 139353),
(139354, '2.130.10.10-FF-003876', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit wuho', 279, NULL, NULL, 139354),
(139355, '3.30.40.10-FF-001784', NULL, 'RING/U-box superfamily protein', 96, NULL, NULL, 139355),
(139356, '3.40.50.300-FF-004551', NULL, 'Probable serine/threonine-protein kinase qkgA', 101, NULL, NULL, 139356),
(139357, '2.10.25.10-FF-001201', NULL, 'Netrin g1a', 31, NULL, NULL, 139357),
(139358, '3.30.70.270-FF-000046', NULL, 'Genome polyprotein', 136, NULL, NULL, 139358),
(139359, '3.40.50.1000-FF-000269', NULL, 'Related to alpha,alpha-trehalose-phosphate synthase, 115 KD subunit', 64, NULL, NULL, 139359),
(139360, '3.40.630.10-FF-000505', NULL, 'Tfr2 protein', 138, NULL, NULL, 139360),
(139361, '2.130.10.10-FF-000099', NULL, 'syntaxin-binding protein 5 isoform X1', 138, NULL, NULL, 139361),
(139362, '2.30.30.40-FF-000428', NULL, 'Ras family guanine nucleotide exchange factor', 70, NULL, NULL, 139362),
(139363, '1.20.140.150-FF-000024', NULL, 'Transmembrane protein 178A', 233, NULL, NULL, 139363),
(139364, '1.20.1060.20-FF-000015', NULL, 'Structural maintenance of chromosomes protein', 138, NULL, NULL, 139364),
(139365, '2.60.40.60-FF-000052', NULL, 'FAT atypical cadherin 1', 102, NULL, NULL, 139365),
(139366, '2.40.30.10-FF-000419', NULL, 'Uncharacterized GTP-binding protein P8A3.05', 80, NULL, NULL, 139366),
(139367, '3.30.70.100-FF-000023', NULL, 'N-terminal EF-hand calcium binding protein 3', 90, NULL, NULL, 139367),
(139368, '2.10.109.10-FF-000081', NULL, 'Uncharacterized protein', 59, NULL, NULL, 139368),
(139369, '3.80.10.10-FF-003955', NULL, 'LRR receptor-like serine/threonine-protein kinase RCH1', 63, NULL, NULL, 139369),
(139370, '3.30.200.60-FF-000007', NULL, 'Uncharacterized protein', 70, NULL, NULL, 139370),
(139371, '3.40.1110.10-FF-000185', NULL, 'Phospholipid-transporting ATPase', 156, NULL, NULL, 139371),
(139372, '1.10.10.2830-FF-000005', NULL, 'DNA-binding protein', 121, NULL, NULL, 139372),
(139373, '3.40.47.10-FF-000040', NULL, 'Type III polyketide synthase', 203, NULL, NULL, 139373),
(139374, '3.30.40.10-FF-001840', NULL, 'Predicted protein', 122, NULL, NULL, 139374),
(139375, '2.40.50.140-FF-000920', NULL, NULL, 85, NULL, NULL, 139375),
(139376, '2.40.50.140-FF-000864', NULL, NULL, 71, NULL, NULL, 139376),
(139377, '1.10.510.10-FF-000623', NULL, 'Dual specificity mitogen-activated protein kinase kinase hemipterous', 201, NULL, NULL, 139377);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(139378, '3.40.30.10-FF-001018', NULL, 'Calsequestrin-1', 56, NULL, NULL, 139378),
(139379, '3.30.200.40-FF-000001', NULL, 'm7GpppX diphosphatase', 105, NULL, NULL, 139379),
(139380, '3.30.505.10-FF-000138', NULL, 'Dual specificity protein kinase shkE', 121, NULL, NULL, 139380),
(139381, '1.25.40.10-FF-004960', NULL, 'Pentatricopeptide repeat-containing protein At2g15630, mitochondrial', 162, NULL, NULL, 139381),
(139382, '2.40.50.100-FF-000083', NULL, 'DNA-directed RNA polymerase subunit beta', 68, NULL, NULL, 139382),
(139383, '3.90.70.10-FF-000541', NULL, 'Ubiquitinyl hydrolase 1', 322, NULL, NULL, 139383),
(139384, '2.60.40.150-FF-000439', NULL, 'Phosphatidylinositol 3-kinase piki-1', 156, NULL, NULL, 139384),
(139385, '3.90.1720.10-FF-000017', NULL, 'BnaA03g55340D protein', 161, NULL, NULL, 139385),
(139386, '1.10.10.60-FF-001049', NULL, NULL, 109, NULL, NULL, 139386),
(139387, '2.130.10.10-FF-001791', NULL, 'LLGL scribble cell polarity complex component 1', 127, NULL, NULL, 139387),
(139388, '3.30.420.40-FF-000563', NULL, 'Heat shock protein 70F', 196, NULL, NULL, 139388),
(139389, '3.30.930.10-FF-000143', NULL, 'Chromosome 9, whole genome shotgun sequence', 360, NULL, NULL, 139389),
(139390, '2.80.10.50-FF-000288', NULL, 'Aldos-2-ulose dehydratase', 165, NULL, NULL, 139390),
(139391, '3.30.160.60-FF-004730', NULL, NULL, 62, NULL, NULL, 139391),
(139392, '3.30.40.10-FF-002060', NULL, 'MIZ type Zn finger-containing protein', 129, NULL, NULL, 139392),
(139393, '3.90.960.10-FF-000013', NULL, 'Aminoacyl-tRNA editing domain containing protein, putative', 158, NULL, NULL, 139393),
(139394, '3.60.10.10-FF-000016', NULL, 'Carbon catabolite repressor protein 4 1', 383, NULL, NULL, 139394),
(139395, '1.10.10.10-FF-001282', NULL, 'HTH-type transcriptional repressor AseR', 102, NULL, NULL, 139395),
(139396, '3.30.160.60-FF-003437', NULL, NULL, 28, NULL, NULL, 139396),
(139397, '3.90.1640.10-FF-000016', NULL, 'Acidocalcisomal exopolyphosphatase', 225, NULL, NULL, 139397),
(139398, '2.120.10.30-FF-000066', NULL, 'ABC transporter permease protein', 311, NULL, NULL, 139398),
(139399, '1.20.272.10-FF-000039', NULL, 'DNA polymerase III subunit delta', 105, NULL, NULL, 139399),
(139400, '3.30.70.330-FF-001435', NULL, 'RNA binding protein, putative', 203, NULL, NULL, 139400),
(139401, '1.20.58.340-FF-000049', NULL, 'Uncharacterized protein', 184, NULL, NULL, 139401),
(139402, '3.40.1800.20-FF-000038', NULL, NULL, 73, NULL, NULL, 139402),
(139403, '1.25.10.10-FF-002535', NULL, 'Uncharacterized protein', 184, NULL, NULL, 139403),
(139404, '2.40.340.10-FF-000004', NULL, 'Molybdopterin molybdenumtransferase', 82, NULL, NULL, 139404),
(139405, '2.30.29.30-FF-001142', NULL, 'Meiotic expression up-regulated protein 6', 113, NULL, NULL, 139405),
(139406, '3.20.20.70-FF-000845', NULL, NULL, 86, NULL, NULL, 139406),
(139407, '2.30.30.100-FF-000148', NULL, 'Small nuclear ribonucleoprotein B, putative', 70, NULL, NULL, 139407),
(139408, '2.40.20.10-FF-000014', NULL, 'Plasminogen', 105, NULL, NULL, 139408),
(139409, '3.40.50.720-FF-000231', NULL, 'Estradiol 17-beta-dehydrogenase 8', 251, NULL, NULL, 139409),
(139410, '3.40.50.300-FF-003590', NULL, 'Dephospho-CoA kinase', 195, NULL, NULL, 139410),
(139411, '3.30.40.10-FF-000148', NULL, 'Kinesin-like protein KIN-7D, mitochondrial', 72, NULL, NULL, 139411),
(139412, '3.10.110.10-FF-000001', NULL, 'Ubiquitin-conjugating enzyme 28, E2', 148, NULL, NULL, 139412),
(139413, '3.30.70.330-FF-002615', NULL, NULL, 129, NULL, NULL, 139413),
(139414, '3.30.1300.30-FF-000005', NULL, 'Type II secretion system protein I', 94, NULL, NULL, 139414),
(139415, '3.30.360.10-FF-000054', NULL, 'Aspartate-semialdehyde dehydrogenase 2', 184, NULL, NULL, 139415),
(139416, '1.20.58.70-FF-000015', NULL, 'Syntaxin 11', 126, NULL, NULL, 139416),
(139417, '3.50.50.100-FF-000048', NULL, 'Uncharacterized protein', 354, NULL, NULL, 139417),
(139418, '3.40.50.10140-FF-000003', NULL, 'Toll-like receptor 7', 145, NULL, NULL, 139418),
(139419, '2.130.10.10-FF-003533', NULL, 'Os04g0619700 protein', 186, NULL, NULL, 139419);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(139420, '2.60.40.10-FF-002948', NULL, 'Uncharacterized protein', 105, NULL, NULL, 139420),
(139421, '3.30.40.10-FF-000204', NULL, 'E3 ubiquitin-protein ligase RNF146', 94, NULL, NULL, 139421),
(139422, '3.90.550.50-FF-000146', NULL, 'Beta1,3-galactosyltransferase, putative', 167, NULL, NULL, 139422),
(139423, '3.30.1520.10-FF-000162', NULL, 'Uncharacterized protein', 132, NULL, NULL, 139423),
(139424, '2.30.29.30-FF-000866', NULL, 'YALI0B07623p', 133, NULL, NULL, 139424),
(139425, '1.25.10.10-FF-002479', NULL, 'Uncharacterized protein', 212, NULL, NULL, 139425),
(139426, '3.40.50.2300-FF-000333', NULL, 'Guanylate cyclase', 119, NULL, NULL, 139426),
(139427, '1.20.120.230-FF-000061', NULL, 'Vinculin-b', 89, NULL, NULL, 139427),
(139428, '3.30.70.120-FF-000029', NULL, NULL, 111, NULL, NULL, 139428),
(139429, '1.10.540.10-FF-000119', NULL, 'Acyl-coenzyme A oxidase', 65, NULL, NULL, 139429),
(139430, '1.10.10.60-FF-000088', NULL, 'DNA-binding transcriptional regulator NtrC', 84, NULL, NULL, 139430),
(139431, '3.40.50.300-FF-006928', NULL, 'Molybdenum ABC transporter, ATP-binding protein', 231, NULL, NULL, 139431),
(139432, '3.40.33.10-FF-000098', NULL, 'Golgi-associated plant pathogenesis-related protein 1', 149, NULL, NULL, 139432),
(139433, '3.40.50.300-FF-002639', NULL, 'ABC transporter G family protein', 241, NULL, NULL, 139433),
(139434, '1.20.1050.10-FF-000129', NULL, 'Hematopoietic prostaglandin D synthase', 103, NULL, NULL, 139434),
(139435, '3.30.710.10-FF-000503', NULL, 'Uncharacterized protein', 70, NULL, NULL, 139435),
(139436, '3.30.40.10-FF-001508', NULL, 'RING/FYVE/PHD zinc finger superfamily protein', 74, NULL, NULL, 139436),
(139437, '2.10.220.10-FF-000209', NULL, 'Proprotein convertase subtilisin/kexin type 5', 52, NULL, NULL, 139437),
(139438, '3.40.390.10-FF-000245', NULL, NULL, 32, NULL, NULL, 139438),
(139439, '3.30.70.330-FF-000474', NULL, 'Organelle RRM domain-containing protein 1, chloroplastic', 126, NULL, NULL, 139439),
(139440, '3.40.850.10-FF-000325', NULL, 'Kinesin-like protein', 370, NULL, NULL, 139440),
(139441, '2.60.40.10-FF-005354', NULL, NULL, 66, NULL, NULL, 139441),
(139442, '3.80.10.10-FF-003556', NULL, 'ELRR (Extracellular Leucine-Rich Repeat) ONly', 151, NULL, NULL, 139442),
(139443, '3.20.20.100-FF-000162', NULL, 'MIP04347p', 211, NULL, NULL, 139443),
(139444, '2.60.40.3980-FF-000001', NULL, 'EFF-1A', 104, NULL, NULL, 139444),
(139445, '3.40.630.10-FF-000106', NULL, 'Carboxypeptidase A', 309, NULL, NULL, 139445),
(139446, '3.30.60.30-FF-000032', NULL, 'Agrin', 72, NULL, NULL, 139446),
(139447, '2.130.10.10-FF-002752', NULL, 'Glycosyl hydrolase', 261, NULL, NULL, 139447),
(139448, '3.30.70.330-FF-001778', NULL, NULL, 125, NULL, NULL, 139448),
(139449, '3.40.50.300-FF-006529', NULL, 'Uncharacterized protein', 109, NULL, NULL, 139449),
(139450, '3.40.228.10-FF-000020', NULL, 'NADH dehydrogenase I, G subunit', 196, NULL, NULL, 139450),
(139451, '3.40.50.300-FF-006405', NULL, 'Uncharacterized protein', 132, NULL, NULL, 139451),
(139452, '2.170.300.10-FF-000038', NULL, 'Multiple epidermal growth factor-like domains protein 6', 117, NULL, NULL, 139452),
(139453, '3.30.460.20-FF-000003', NULL, 'Magnesium transporter ALR1', 127, NULL, NULL, 139453),
(139454, '3.30.310.130-FF-000014', NULL, 'Ubiquitin-like protease 2', 153, NULL, NULL, 139454),
(139455, '1.25.40.120-FF-000025', NULL, 'Prenyltransferase alpha subunit, putative', 288, NULL, NULL, 139455),
(139456, '3.10.310.10-FF-000056', NULL, 'Diaminopimelate epimerase', 141, NULL, NULL, 139456),
(139457, '1.10.10.440-FF-000041', NULL, 'TransCription Elongation Regulator homolog', 76, NULL, NULL, 139457),
(139458, '3.30.160.60-FF-002077', NULL, 'LP19870p', 31, NULL, NULL, 139458),
(139459, '3.40.50.2300-FF-000732', NULL, NULL, 25, NULL, NULL, 139459),
(139460, '3.30.1310.10-FF-000005', NULL, 'Nucleoid-associated protein SPAR113_1167', 99, NULL, NULL, 139460),
(139461, '1.10.8.10-FF-000078', NULL, 'Ubiquitin-conjugating enzyme E2 27', 37, NULL, NULL, 139461),
(139462, '3.40.50.1440-FF-000035', NULL, 'Tubulin alpha chain', 66, NULL, NULL, 139462);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(139463, '3.40.390.10-FF-000065', NULL, 'Metalloendopeptidase', 195, NULL, NULL, 139463),
(139464, '3.30.160.60-FF-000003', NULL, 'Zinc finger protein 3 homolog', 28, NULL, NULL, 139464),
(139465, '3.90.180.10-FF-000061', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 181, NULL, NULL, 139465),
(139466, '2.60.200.20-FF-000077', NULL, 'Forkhead box K, isoform G', 144, NULL, NULL, 139466),
(139467, '3.40.50.300-FF-002078', NULL, 'Ras-related protein RabQ', 182, NULL, NULL, 139467),
(139468, '2.130.10.10-FF-002572', NULL, 'Uncharacterized protein', 99, NULL, NULL, 139468),
(139469, '1.10.565.10-FF-000093', NULL, 'Nuclear Hormone Receptor family', 187, NULL, NULL, 139469),
(139470, '3.40.50.620-FF-000370', NULL, 'Tryptophanyl-tRNA synthetase', 267, NULL, NULL, 139470),
(139471, '2.20.70.10-FF-000243', NULL, 'Uncharacterized protein', 74, NULL, NULL, 139471),
(139472, '2.20.70.10-FF-000187', NULL, 'Uncharacterized protein', 56, NULL, NULL, 139472),
(139473, '3.40.50.10090-FF-000061', NULL, 'Uncharacterized protein', 24, NULL, NULL, 139473),
(139474, '3.30.70.1350-FF-000022', NULL, 'Cation efflux family protein', 93, NULL, NULL, 139474),
(139475, '1.10.510.10-FF-004513', NULL, NULL, 195, NULL, NULL, 139475),
(139476, '3.30.230.10-FF-000230', NULL, 'DNA mismatch repair protein MutL', 113, NULL, NULL, 139476),
(139477, '3.80.10.10-FF-003376', NULL, 'Uncharacterized protein', 106, NULL, NULL, 139477),
(139478, '2.60.120.920-FF-000117', NULL, 'Si:ch73-236c18.7', 63, NULL, NULL, 139478),
(139479, '1.25.40.20-FF-000455', NULL, 'Ankyrin repeat domain 28, isoform CRA_c', 50, NULL, NULL, 139479),
(139480, '1.10.510.10-FF-002192', NULL, 'Guanylate cyclase', 221, NULL, NULL, 139480),
(139481, '2.60.40.10-FF-002824', NULL, 'Myosin, light chain kinase 5', 94, NULL, NULL, 139481),
(139482, '1.25.10.10-FF-002136', NULL, 'Uncharacterized protein', 1213, NULL, NULL, 139482),
(139483, '3.10.100.10-FF-000175', NULL, 'Killer cell lectin-like receptor subfamily I member 1', 129, NULL, NULL, 139483),
(139484, '2.40.50.140-FF-000521', NULL, 'DNA helicase', 74, NULL, NULL, 139484),
(139485, '1.25.40.10-FF-000918', NULL, 'Bardet-Biedl syndrome 4, isoform B', 217, NULL, NULL, 139485),
(139486, '2.60.40.10-FF-003224', NULL, '2 (Zwei) IG domain protein', 97, NULL, NULL, 139486),
(139487, '3.10.100.10-FF-000051', NULL, 'Lymphocyte antigen 75 variant', 134, NULL, NULL, 139487),
(139488, '2.40.180.10-FF-000002', NULL, 'Catalase', 479, NULL, NULL, 139488),
(139489, '2.60.120.650-FF-000183', NULL, 'Os12g0169500 protein', 100, NULL, NULL, 139489),
(139490, '3.90.470.20-FF-000041', NULL, 'L-aminoadipate-semialdehyde dehydrogenase-phosphopantetheinyl transferase-like Protein', 146, NULL, NULL, 139490),
(139491, '3.40.50.11690-FF-000001', NULL, 'Cell division protein FtsQ', 133, NULL, NULL, 139491),
(139492, '3.30.870.10-FF-000099', NULL, 'Phospholipase D1-like protein (PLD1)', 181, NULL, NULL, 139492),
(139493, '3.10.129.10-FF-000218', NULL, 'Uncharacterized protein', 92, NULL, NULL, 139493),
(139494, '3.20.20.70-FF-000665', NULL, NULL, 223, NULL, NULL, 139494),
(139495, '3.40.50.300-FF-006349', NULL, 'Uncharacterized protein', 142, NULL, NULL, 139495),
(139496, '3.10.330.10-FF-000040', NULL, 'Uncharacterized protein', 107, NULL, NULL, 139496),
(139497, '3.40.50.720-FF-001068', NULL, 'Divinyl chlorophyllide a 8-vinyl-reductase, chloroplastic', 295, NULL, NULL, 139497),
(139498, '2.20.70.10-FF-000063', NULL, 'E3 ubiquitin-protein ligase NEDD4', 44, NULL, NULL, 139498),
(139499, '2.60.120.10-FF-000359', NULL, 'Uncharacterized protein', 150, NULL, NULL, 139499),
(139500, '2.60.120.260-FF-000554', NULL, 'Uncharacterized protein', 52, NULL, NULL, 139500),
(139501, '1.10.510.10-FF-003552', NULL, NULL, 228, NULL, NULL, 139501),
(139502, '3.20.190.10-FF-000015', NULL, 'Formamidopyrimidine-DNA glycosylase N-terminal domain-domain-containing protein', 144, NULL, NULL, 139502),
(139503, '1.25.40.10-FF-004628', NULL, 'GH21465p', 127, NULL, NULL, 139503),
(139504, '1.10.560.10-FF-000121', NULL, 'T-complex protein 1 subunit gamma', 135, NULL, NULL, 139504);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(139505, '3.30.70.3490-FF-000052', NULL, NULL, 64, NULL, NULL, 139505),
(139506, '1.50.40.10-FF-000438', NULL, 'Uncharacterized protein', 165, NULL, NULL, 139506),
(139507, '3.40.1120.10-FF-000011', NULL, NULL, 160, NULL, NULL, 139507),
(139508, '3.30.260.10-FF-000069', NULL, NULL, 85, NULL, NULL, 139508),
(139509, '2.30.29.170-FF-000021', NULL, NULL, 95, NULL, NULL, 139509),
(139510, '1.10.8.1310-FF-000010', NULL, 'Uncharacterized protein', 104, NULL, NULL, 139510),
(139511, '2.60.120.10-FF-000691', NULL, 'Uncharacterized protein', 66, NULL, NULL, 139511),
(139512, '2.60.120.200-FF-000014', NULL, 'neurexin-1 isoform X1', 168, NULL, NULL, 139512),
(139513, '3.40.50.10190-FF-000321', NULL, 'AGAP002605-PA', 90, NULL, NULL, 139513),
(139514, '2.60.40.1170-FF-000074', NULL, NULL, 104, NULL, NULL, 139514),
(139515, '1.10.30.10-FF-000153', NULL, 'HMG transcription factor SoxC', 79, NULL, NULL, 139515),
(139516, '3.40.30.10-FF-000237', NULL, 'NADH dehydrogenase subunit E', 84, NULL, NULL, 139516),
(139517, '3.40.50.20-FF-000005', NULL, 'acetyl-CoA carboxylase isoform X2', 157, NULL, NULL, 139517),
(139518, '2.60.40.10-FF-001987', NULL, 'Gelation factor', 104, NULL, NULL, 139518),
(139519, '1.25.40.10-FF-004105', NULL, 'Uncharacterized protein', 143, NULL, NULL, 139519),
(139520, '1.25.40.10-FF-003268', NULL, 'Uncharacterized protein', 144, NULL, NULL, 139520),
(139521, '2.60.40.150-FF-000591', NULL, 'Predicted protein', 137, NULL, NULL, 139521),
(139522, '3.10.20.90-FF-000812', NULL, 'Uncharacterized protein', 37, NULL, NULL, 139522),
(139523, '3.30.1440.10-FF-000009', NULL, '50S ribosomal protein L5, chloroplastic', 192, NULL, NULL, 139523),
(139524, '2.30.30.40-FF-000608', NULL, 'Tyrosine-protein kinase', 55, NULL, NULL, 139524),
(139525, '3.40.1170.10-FF-000014', NULL, 'Mismatch repair protein MSH8, putative', 149, NULL, NULL, 139525),
(139526, '1.20.1310.20-FF-000052', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 202, NULL, NULL, 139526),
(139527, '1.20.1280.50-FF-000158', NULL, 'Uncharacterized protein', 115, NULL, NULL, 139527),
(139528, '3.40.50.150-FF-001667', NULL, NULL, 180, NULL, NULL, 139528),
(139529, '3.90.640.10-FF-000141', NULL, 'Heat shock protein 70 homolog LHS1, putative', 85, NULL, NULL, 139529),
(139530, '3.40.50.300-FF-006681', NULL, 'Uncharacterized protein', 82, NULL, NULL, 139530),
(139531, '3.55.40.20-FF-000016', NULL, 'Mitochondrial 37S ribosomal protein RSM26', 112, NULL, NULL, 139531),
(139532, '3.30.420.390-FF-000010', NULL, NULL, 196, NULL, NULL, 139532),
(139533, '1.20.1250.20-FF-000406', NULL, 'Monocarboxylate transporter 2', 188, NULL, NULL, 139533),
(139534, '3.40.1090.10-FF-000013', NULL, 'Lysophospholipase NTE1', 88, NULL, NULL, 139534),
(139535, '2.30.29.30-FF-001086', NULL, 'Uncharacterized protein', 59, NULL, NULL, 139535),
(139536, '1.20.5.120-FF-000001', NULL, 'Proteasome activator complex subunit 3', 60, NULL, NULL, 139536),
(139537, '2.60.40.10-FF-002263', NULL, 'CD166 antigen homolog A', 99, NULL, NULL, 139537),
(139538, '3.40.50.720-FF-002029', NULL, 'Molybdopterin synthase sulphurylase-like', 194, NULL, NULL, 139538),
(139539, '2.60.40.10-FF-005697', NULL, NULL, 67, NULL, NULL, 139539),
(139540, '2.70.160.11-FF-000029', NULL, 'Arginine N-methyltransferase, putative', 183, NULL, NULL, 139540),
(139541, '3.30.1360.10-FF-000008', NULL, 'RNA polymerase II core subunit', 149, NULL, NULL, 139541),
(139542, '3.50.50.60-FF-001197', NULL, 'L-amino-acid oxidase', 501, NULL, NULL, 139542),
(139543, '2.10.25.10-FF-000420', NULL, 'Coagulation factor VII', 40, NULL, NULL, 139543),
(139544, '3.30.497.10-FF-000091', NULL, 'Neuroserpin', 208, NULL, NULL, 139544),
(139545, '3.30.70.330-FF-003060', NULL, NULL, 106, NULL, NULL, 139545),
(139546, '2.60.40.10-FF-004781', NULL, NULL, 81, NULL, NULL, 139546),
(139547, '3.30.160.60-FF-003802', NULL, NULL, 42, NULL, NULL, 139547),
(139548, '3.30.479.30-FF-000021', NULL, 'NPHS2 stomatin family member, podocin', 110, NULL, NULL, 139548),
(139549, '3.40.50.720-FF-002136', NULL, 'Fatty acyl-CoA reductase', 100, NULL, NULL, 139549);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(139550, '3.40.50.300-FF-004663', NULL, 'ATP-binding cassette transporter (ABC transporter) family C member 11', 231, NULL, NULL, 139550),
(139551, '2.10.109.10-FF-000013', NULL, 'Signal peptidase I', 141, NULL, NULL, 139551),
(139552, '3.50.50.60-FF-000781', NULL, 'Uncharacterized protein', 210, NULL, NULL, 139552),
(139553, '3.40.350.10-FF-000023', NULL, 'Xaa-pro aminopeptidase', 170, NULL, NULL, 139553),
(139554, '3.10.450.40-FF-000018', NULL, 'Amine oxidase', 116, NULL, NULL, 139554),
(139555, '2.130.10.10-FF-005938', NULL, 'Vacuolar protein sorting-associated protein 11 homolog', 259, NULL, NULL, 139555),
(139556, '1.20.1250.20-FF-002222', NULL, 'Solute carrier organic anion transporter, putative', 131, NULL, NULL, 139556),
(139557, '3.40.50.720-FF-000528', NULL, 'Nucleoside-diphosphate-sugar epimerase family protein', 205, NULL, NULL, 139557),
(139558, '3.90.70.10-FF-000361', NULL, 'Cathepsin F', 327, NULL, NULL, 139558),
(139559, '3.30.70.270-FF-000158', NULL, 'DNA damage repair protein, putative', 163, NULL, NULL, 139559),
(139560, '2.40.30.20-FF-000012', NULL, 'Riboflavin synthase alpha chain', 101, NULL, NULL, 139560),
(139561, '3.40.50.1010-FF-000098', NULL, 'Ribonuclease VapC', 127, NULL, NULL, 139561),
(139562, '3.40.50.720-FF-002092', NULL, 'Os04g0496000 protein', 135, NULL, NULL, 139562),
(139563, '3.40.47.10-FF-000152', NULL, '3-ketoacyl-CoA-synthase', 279, NULL, NULL, 139563),
(139564, '1.25.40.20-FF-000359', NULL, 'Uncharacterized protein, isoform C', 51, NULL, NULL, 139564),
(139565, '2.130.10.10-FF-002179', NULL, 'Intraflagellar transport protein 122 homolog-like Protein', 212, NULL, NULL, 139565),
(139566, '1.20.5.510-FF-000005', NULL, 'Ubiquinol-cytochrome c reductase iron-sulfur subunit', 40, NULL, NULL, 139566),
(139567, '1.10.246.110-FF-000001', NULL, 'ATP synthase-coupling factor 6, mitochondrial', 64, NULL, NULL, 139567),
(139568, '3.40.190.10-FF-000308', NULL, 'ABC transporter substrate-binding protein', 168, NULL, NULL, 139568),
(139569, '1.25.40.10-FF-001458', NULL, 'Pentatricopeptide repeat protein', 152, NULL, NULL, 139569),
(139570, '3.40.50.10190-FF-000130', NULL, 'DNA repair protein REV1', 96, NULL, NULL, 139570),
(139571, '2.60.60.20-FF-000030', NULL, 'Lipoxygenase', 157, NULL, NULL, 139571),
(139572, '3.90.1150.10-FF-000496', NULL, 'Uncharacterized protein', 26, NULL, NULL, 139572),
(139573, '3.30.40.10-FF-002037', NULL, 'ERAD-associated E3 ubiquitin-protein ligase hrd1', 97, NULL, NULL, 139573),
(139574, '3.10.100.10-FF-000236', NULL, NULL, 87, NULL, NULL, 139574),
(139575, '2.60.40.420-FF-000048', NULL, 'Early nodulin-like protein 18', 123, NULL, NULL, 139575),
(139576, '3.40.190.10-FF-000297', NULL, 'Glutamate receptor IIC', 97, NULL, NULL, 139576),
(139577, '1.20.890.10-FF-000025', NULL, 'ADP-ribosylation factor, putative', 50, NULL, NULL, 139577),
(139578, '1.10.20.10-FF-000304', NULL, NULL, 54, NULL, NULL, 139578),
(139579, '2.60.40.10-FF-000610', NULL, 'Tenascin C', 91, NULL, NULL, 139579),
(139580, '2.40.50.140-FF-000212', NULL, 'Ribosomal protein S1-like1', 92, NULL, NULL, 139580),
(139581, '3.40.50.1000-FF-000578', NULL, NULL, 122, NULL, NULL, 139581),
(139582, '1.10.3900.10-FF-000001', NULL, 'Cell division protein ZapD', 163, NULL, NULL, 139582),
(139583, '2.130.10.10-FF-002712', NULL, 'Predicted protein', 314, NULL, NULL, 139583),
(139584, '2.60.40.10-FF-003836', NULL, NULL, 102, NULL, NULL, 139584),
(139585, '1.10.238.200-FF-000005', NULL, 'Defective in cullin neddylation protein', 106, NULL, NULL, 139585),
(139586, '1.10.10.10-FF-000702', NULL, 'Regulatory protein RecX', 48, NULL, NULL, 139586),
(139587, '3.40.50.300-FF-007889', NULL, 'Uncharacterized protein', 306, NULL, NULL, 139587),
(139588, '1.10.246.130-FF-000007', NULL, 'Uncharacterized protein, isoform B', 112, NULL, NULL, 139588),
(139589, '3.40.50.1000-FF-000139', NULL, 'Mitochondrial import inner membrane translocase subunit TIM50', 180, NULL, NULL, 139589),
(139590, '2.10.160.10-FF-000002', NULL, 'vascular endothelial growth factor B', 50, NULL, NULL, 139590),
(139591, '1.10.287.110-FF-000297', NULL, 'Uncharacterized protein', 63, NULL, NULL, 139591);
INSERT INTO "PUBLIC"."MODEL" VALUES
(139592, '3.30.1640.10-FF-000053', NULL, 'DNA helicase', 119, NULL, NULL, 139592),
(139593, '1.10.10.60-FF-000240', NULL, 'Zinc fingers and homeoboxes protein 1', 64, NULL, NULL, 139593),
(139594, '3.30.200.20-FF-001850', NULL, NULL, 111, NULL, NULL, 139594),
(139595, '3.30.450.40-FF-000267', NULL, 'AGAP012811-PA', 151, NULL, NULL, 139595),
(139596, '3.40.50.720-FF-001517', NULL, 'UDP-glucose 4-epimerase, putative', 116, NULL, NULL, 139596),
(139597, '3.40.50.720-FF-001147', NULL, 'Uncharacterized protein', 184, NULL, NULL, 139597),
(139598, '3.90.1010.10-FF-000014', NULL, 'NifU-like N-terminal domain protein', 128, NULL, NULL, 139598),
(139599, '1.20.1280.20-FF-000003', NULL, 'Chaperone protein TorD', 79, NULL, NULL, 139599),
(139600, '1.10.220.10-FF-000056', NULL, 'Annexin', 75, NULL, NULL, 139600),
(139601, '3.20.20.60-FF-000095', NULL, 'Isocitrate lyase', 244, NULL, NULL, 139601),
(139602, '3.40.50.300-FF-000285', NULL, 'Sporulation initiation inhibitor Soj', 252, NULL, NULL, 139602),
(139603, '3.30.470.30-FF-000001', NULL, 'DNA ligase', 251, NULL, NULL, 139603),
(139604, '1.25.40.10-FF-000469', NULL, 'Pentatricopeptide repeat-containing protein', 119, NULL, NULL, 139604),
(139605, '3.30.160.60-FF-005247', NULL, NULL, 29, NULL, NULL, 139605),
(139606, '3.30.160.60-FF-004893', NULL, NULL, 79, NULL, NULL, 139606),
(139607, '2.30.180.10-FF-000151', NULL, NULL, 158, NULL, NULL, 139607),
(139608, '1.10.132.60-FF-000001', NULL, 'DNA polymerase', 158, NULL, NULL, 139608),
(139609, '3.40.1550.10-FF-000009', NULL, 'Flagellar motor switch protein FliM', 175, NULL, NULL, 139609),
(139610, '1.25.40.10-FF-000839', NULL, 'Serine/threonine-protein phosphatase', 168, NULL, NULL, 139610),
(139611, '3.90.70.10-FF-000198', NULL, 'Cysteine proteinase 3', 308, NULL, NULL, 139611),
(139612, '3.40.50.300-FF-003202', NULL, 'RecBCD enzyme subunit RecD', 104, NULL, NULL, 139612),
(139613, '3.60.10.10-FF-000140', NULL, 'Protein CBR-OCRL-1', 372, NULL, NULL, 139613),
(139614, '1.25.10.10-FF-002575', NULL, 'Uncharacterized protein', 163, NULL, NULL, 139614),
(139615, '3.90.1490.10-FF-000015', NULL, 'Predicted protein', 67, NULL, NULL, 139615),
(139616, '3.40.630.30-FF-000663', NULL, 'Predicted protein', 152, NULL, NULL, 139616),
(139617, '2.130.10.10-FF-004157', NULL, 'Predicted protein', 174, NULL, NULL, 139617),
(139618, '3.80.10.10-FF-001639', NULL, 'Toll-like receptor 12', 280, NULL, NULL, 139618),
(139619, '1.10.260.40-FF-000028', NULL, 'Secretion protein EspR', 92, NULL, NULL, 139619),
(139620, '2.40.30.10-FF-000155', NULL, 'NADPH--cytochrome P450 reductase', 129, NULL, NULL, 139620),
(139621, '3.40.50.300-FF-000768', NULL, 'Probable mitochondrial chaperone bcs1', 175, NULL, NULL, 139621),
(139622, '1.10.510.10-FF-001231', NULL, 'SAPK/ERK kinase', 199, NULL, NULL, 139622),
(139623, '1.10.472.10-FF-000040', NULL, 'D6-type cyclin', 98, NULL, NULL, 139623),
(139624, '1.25.40.450-FF-000017', NULL, 'Uncharacterized protein', 153, NULL, NULL, 139624),
(139625, '3.30.230.80-FF-000009', NULL, 'Molecular chaperone HtpG', 115, NULL, NULL, 139625),
(139626, '3.40.50.1100-FF-000153', NULL, 'Cysteine synthase B', 101, NULL, NULL, 139626),
(139627, '2.60.40.1830-FF-000002', NULL, NULL, 104, NULL, NULL, 139627),
(139628, '3.30.70.330-FF-002924', NULL, NULL, 124, NULL, NULL, 139628),
(139629, '2.60.40.150-FF-000607', NULL, 'Phosphoinositide phospholipase C', 117, NULL, NULL, 139629),
(139630, '3.40.50.300-FF-002685', NULL, 'RAB33A, member RAS oncogene family', 192, NULL, NULL, 139630),
(139631, '3.10.20.90-FF-000632', NULL, 'UBA/TS-N domain containing protein', 97, NULL, NULL, 139631),
(139632, '1.10.2020.20-FF-000009', NULL, 'Predicted protein', 100, NULL, NULL, 139632),
(139633, '2.30.31.30-FF-000001', NULL, 'Replicase polyprotein 1ab', 77, NULL, NULL, 139633),
(139634, '3.30.450.20-FF-000261', NULL, 'Diguanylate cyclase', 142, NULL, NULL, 139634),
(139635, '3.40.630.10-FF-000444', NULL, 'Uncharacterized protein', 193, NULL, NULL, 139635),
(139636, '1.25.40.430-FF-000011', NULL, 'Mitotic checkpoint serine/threonine-protein kinase bub-1', 141, NULL, NULL, 139636); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(139637, '3.90.1290.10-FF-000034', NULL, 'Microtubule-actin cross-linking factor 1', 118, NULL, NULL, 139637),
(139638, '3.40.50.10490-FF-000113', NULL, NULL, 54, NULL, NULL, 139638),
(139639, '3.30.70.1440-FF-000004', NULL, 'Efflux pump membrane transporter', 103, NULL, NULL, 139639),
(139640, '2.60.40.10-FF-002055', NULL, 'Immunoglobulin superfamily member 6', 125, NULL, NULL, 139640),
(139641, '3.60.120.10-FF-000024', NULL, 'Salicylate biosynthesis isochorismate synthase', 450, NULL, NULL, 139641),
(139642, '3.30.420.140-FF-000025', NULL, 'Uncharacterized protein', 80, NULL, NULL, 139642),
(139643, '1.10.510.10-FF-004457', NULL, NULL, 287, NULL, NULL, 139643),
(139644, '3.30.420.10-FF-000060', NULL, 'Ribonuclease D', 194, NULL, NULL, 139644),
(139645, '1.10.238.10-FF-000333', NULL, 'Myosin A tail domain interacting protein', 81, NULL, NULL, 139645),
(139646, '3.60.40.10-FF-000321', NULL, 'Uncharacterized protein', 204, NULL, NULL, 139646),
(139647, '2.40.50.90-FF-000135', NULL, 'Uncharacterized protein', 100, NULL, NULL, 139647),
(139648, '3.30.360.10-FF-000133', NULL, 'Bifunctional aspartate kinase/homoserine dehydrogenase', 26, NULL, NULL, 139648),
(139649, '3.30.450.20-FF-000570', NULL, 'Predicted protein', 44, NULL, NULL, 139649),
(139650, '2.60.120.200-FF-000643', NULL, 'Uncharacterized protein', 110, NULL, NULL, 139650),
(139651, '2.60.40.1510-FF-000007', NULL, 'Integrin beta', 111, NULL, NULL, 139651),
(139652, '4.10.1000.30-FF-000003', NULL, 'zinc finger CCCH domain-containing protein 14 isoform X6', 55, NULL, NULL, 139652),
(139653, '2.60.120.10-FF-000562', NULL, 'Uncharacterized protein', 141, NULL, NULL, 139653),
(139654, '1.10.340.30-FF-000009', NULL, 'DNA-3-methyladenine glycosylase I', 186, NULL, NULL, 139654),
(139655, '2.60.40.10-FF-003044', NULL, 'Probable beta-mannosidase', 111, NULL, NULL, 139655),
(139656, '3.40.190.290-FF-000087', NULL, 'Transcriptional regulatory protein', 203, NULL, NULL, 139656),
(139657, '1.10.486.10-FF-000010', NULL, 'ATP-dependent DNA helicase Rep', 156, NULL, NULL, 139657),
(139658, '3.10.350.10-FF-000058', NULL, 'Predicted protein', 43, NULL, NULL, 139658),
(139659, '2.20.28.10-FF-000049', NULL, 'Putative dna replication licensing factor mcm4 component', 59, NULL, NULL, 139659),
(139660, '3.30.160.60-FF-002504', NULL, 'zinc finger protein 821 isoform X2', 50, NULL, NULL, 139660),
(139661, '3.30.1240.10-FF-000005', NULL, 'Cof family hydrolase', 113, NULL, NULL, 139661),
(139662, '3.40.1810.10-FF-000047', NULL, NULL, 57, NULL, NULL, 139662),
(139663, '2.90.10.10-FF-000039', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase SD2-5', 98, NULL, NULL, 139663),
(139664, '1.25.10.10-FF-000658', NULL, 'Protein VAC14-like protein', 162, NULL, NULL, 139664),
(139665, '3.40.570.10-FF-000034', NULL, 'Uncharacterized protein', 214, NULL, NULL, 139665),
(139666, '3.80.10.10-FF-003617', NULL, 'Uncharacterized protein', 126, NULL, NULL, 139666),
(139667, '3.40.930.10-FF-000017', NULL, 'Solute carrier family 4, sodium borate transporter, member 11', 170, NULL, NULL, 139667),
(139668, '3.40.50.300-FF-004028', NULL, 'ATP-dependent RNA helicase DRS1', 270, NULL, NULL, 139668),
(139669, '1.10.287.740-FF-000002', NULL, 'Photosystem II reaction center protein Z', 62, NULL, NULL, 139669),
(139670, '3.40.50.300-FF-003191', NULL, 'ATP-binding cassette (ABC) transporter, putative', 256, NULL, NULL, 139670),
(139671, '3.30.160.60-FF-002493', NULL, 'Zinc finger protein', 30, NULL, NULL, 139671),
(139672, '3.10.20.90-FF-000941', NULL, 'Uncharacterized protein', 74, NULL, NULL, 139672),
(139673, '2.60.40.10-FF-001919', NULL, 'Platelet endothelial cell adhesion molecule', 102, NULL, NULL, 139673),
(139674, '1.10.287.70-FF-000273', NULL, 'potassium voltage-gated channel subfamily KQT member 2-like isoform X2', 145, NULL, NULL, 139674),
(139675, '2.40.30.270-FF-000011', NULL, 'DNA replication helicase Dna2', 118, NULL, NULL, 139675),
(139676, '1.10.620.20-FF-000005', NULL, 'Ribonucleoside-diphosphate reductase subunit beta', 292, NULL, NULL, 139676),
(139677, '3.40.50.2000-FF-000310', NULL, 'Glycosyl transferase CpoA', 188, NULL, NULL, 139677);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(139678, '3.40.630.30-FF-000500', NULL, 'Acetyltransferase', 129, NULL, NULL, 139678),
(139679, '3.80.10.10-FF-001482', NULL, 'F box and leucine-rich-repeat gene 4', 79, NULL, NULL, 139679),
(139680, '3.30.70.330-FF-000137', NULL, 'pre-mRNA-splicing factor RBM22', 71, NULL, NULL, 139680),
(139681, '2.130.10.10-FF-000251', NULL, 'Dynein axonemal intermediate chain 1', 187, NULL, NULL, 139681),
(139682, '3.40.50.1820-FF-000705', NULL, 'CDA peptide synthetase III', 347, NULL, NULL, 139682),
(139683, '3.30.160.60-FF-006236', NULL, NULL, 24, NULL, NULL, 139683),
(139684, '1.25.10.10-FF-000219', NULL, 'Importin subunit beta-2', 570, NULL, NULL, 139684),
(139685, '1.20.5.190-FF-000061', NULL, 'Myosin C', 51, NULL, NULL, 139685),
(139686, '2.40.10.10-FF-000272', NULL, 'GG11998', 229, NULL, NULL, 139686),
(139687, '1.10.1200.240-FF-000004', NULL, 'LSU ribosomal protein L19E', 139, NULL, NULL, 139687),
(139688, '1.20.1250.20-FF-001266', NULL, 'MFS general substrate transporter', 342, NULL, NULL, 139688),
(139689, '2.60.40.10-FF-002408', NULL, 'Blast:Protein amalgam', 105, NULL, NULL, 139689),
(139690, '2.120.10.30-FF-000089', NULL, 'Calcium-dependent phosphotriesterase superfamily protein', 276, NULL, NULL, 139690),
(139691, '2.60.120.970-FF-000087', NULL, 'Uncharacterized protein', 210, NULL, NULL, 139691),
(139692, '2.130.10.10-FF-004949', NULL, 'DDB1- and CUL4-associated factor 11 homolog', 98, NULL, NULL, 139692),
(139693, '3.40.50.880-FF-000014', NULL, 'Phosphoribosylformylglycinamidine synthase, putative', 326, NULL, NULL, 139693),
(139694, '1.20.120.340-FF-000015', NULL, 'Flagellar secretion chaperone FliS', 122, NULL, NULL, 139694),
(139695, '1.20.1560.10-FF-000730', NULL, 'Uncharacterized protein', 210, NULL, NULL, 139695),
(139696, '2.60.120.200-FF-000334', NULL, 'LAMinin related. See also lmb', 175, NULL, NULL, 139696),
(139697, '2.30.30.40-FF-000029', NULL, 'myc box-dependent-interacting protein 1 isoform X2', 83, NULL, NULL, 139697),
(139698, '2.40.50.120-FF-000010', NULL, 'secreted frizzled-related protein 3', 123, NULL, NULL, 139698),
(139699, '1.20.59.10-FF-000011', NULL, 'Chorismate mutase', 156, NULL, NULL, 139699),
(139700, '3.40.1440.60-FF-000011', NULL, 'Primosomal protein N''', 100, NULL, NULL, 139700),
(139701, '3.30.1360.10-FF-000054', NULL, 'Uncharacterized protein', 68, NULL, NULL, 139701),
(139702, '1.10.238.10-FF-001322', NULL, 'Ras homolog family member T1', 69, NULL, NULL, 139702),
(139703, '3.40.1090.10-FF-000081', NULL, 'Bll5745 protein', 255, NULL, NULL, 139703),
(139704, '2.40.110.10-FF-000032', NULL, 'Acyl-CoA dehydrogenase FADE21', 114, NULL, NULL, 139704),
(139705, '3.40.50.150-FF-001723', NULL, NULL, 134, NULL, NULL, 139705),
(139706, '1.25.40.20-FF-001787', NULL, 'Predicted protein', 177, NULL, NULL, 139706),
(139707, '3.40.50.720-FF-002445', NULL, 'Uncharacterized protein', 127, NULL, NULL, 139707),
(139708, '3.30.1370.10-FF-000189', NULL, 'Putative UPF0469 protein', 97, NULL, NULL, 139708),
(139709, '3.90.190.10-FF-000494', NULL, 'Uncharacterized protein', 154, NULL, NULL, 139709),
(139710, '3.30.450.380-FF-000013', NULL, NULL, 199, NULL, NULL, 139710),
(139711, '3.90.550.10-FF-000477', NULL, 'CMP-KDO synthetase-related protein', 209, NULL, NULL, 139711),
(139712, '2.120.10.80-FF-000204', NULL, 'Serine/threonine-protein phosphatase', 156, NULL, NULL, 139712),
(139713, '3.10.20.30-FF-000058', NULL, 'Threonine--tRNA ligase, cytoplasmic', 41, NULL, NULL, 139713),
(139714, '1.10.1020.10-FF-000006', NULL, 'Mu phage DNA adenine methylase Dam family', 94, NULL, NULL, 139714),
(139715, '1.10.10.1730-FF-000001', NULL, 'Folliculin', 90, NULL, NULL, 139715),
(139716, '2.40.10.10-FF-000581', NULL, NULL, 47, NULL, NULL, 139716),
(139717, '2.130.10.10-FF-003477', NULL, 'Uncharacterized protein', 314, NULL, NULL, 139717),
(139718, '3.30.420.40-FF-000439', NULL, 'Actin', 71, NULL, NULL, 139718),
(139719, '1.20.920.30-FF-000001', NULL, 'Cytoplasmic dynein heavy chain 1', 189, NULL, NULL, 139719),
(139720, '3.40.50.720-FF-001956', NULL, 'Uncharacterized protein', 259, NULL, NULL, 139720);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(139721, '2.60.40.60-FF-000029', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', 102, NULL, NULL, 139721),
(139722, '3.30.559.30-FF-000055', NULL, 'Peptide synthetase', 229, NULL, NULL, 139722),
(139723, '3.90.1410.10-FF-000106', NULL, 'Predicted protein', 247, NULL, NULL, 139723),
(139724, '3.80.10.10-FF-000330', NULL, 'Receptor protein-tyrosine kinase CEPR1', 287, NULL, NULL, 139724),
(139725, '2.60.40.10-FF-003353', NULL, NULL, 111, NULL, NULL, 139725),
(139726, '3.90.70.10-FF-000670', NULL, 'Putative ubiquitin hydrolase', 381, NULL, NULL, 139726),
(139727, '3.40.50.12650-FF-000019', NULL, 'Os01g0783400 protein', 12, NULL, NULL, 139727),
(139728, '2.10.25.10-FF-000004', NULL, 'Neurogenic locus notch 1', 38, NULL, NULL, 139728),
(139729, '3.90.1410.10-FF-000095', NULL, 'Lysine N-methylase', 263, NULL, NULL, 139729),
(139730, '3.30.1330.30-FF-000092', NULL, 'Uncharacterized protein', 58, NULL, NULL, 139730),
(139731, '2.60.40.10-FF-002864', NULL, 'LOC100127716 protein', 107, NULL, NULL, 139731),
(139732, '1.10.640.10-FF-000015', NULL, 'DUal OXidase', 570, NULL, NULL, 139732),
(139733, '2.110.10.10-FF-000061', NULL, 'Uncharacterized protein', 183, NULL, NULL, 139733),
(139734, '3.30.2020.30-FF-000017', NULL, 'Uncharacterized protein CaJ7.0511', 89, NULL, NULL, 139734),
(139735, '3.90.1200.10-FF-000040', NULL, 'Possible macrolide 2-phosphotransferase', 191, NULL, NULL, 139735),
(139736, '3.40.50.1820-FF-001796', NULL, 'Uncharacterized protein', 150, NULL, NULL, 139736),
(139737, '1.10.357.140-FF-000002', NULL, '4-hydroxybenzoate octaprenyltransferase', 146, NULL, NULL, 139737),
(139738, '3.90.226.10-FF-000212', NULL, 'ATP-dependent Clp protease proteolytic subunit', 134, NULL, NULL, 139738),
(139739, '3.20.20.80-FF-000281', NULL, 'Alpha-L-fucosidase', 336, NULL, NULL, 139739),
(139740, '3.20.20.70-FF-000744', NULL, NULL, 70, NULL, NULL, 139740),
(139741, '2.30.30.30-FF-000139', NULL, 'Ribosomal protein L14', 86, NULL, NULL, 139741),
(139742, '2.130.10.10-FF-002049', NULL, 'Transducin family protein / WD-40 repeat family protein', 185, NULL, NULL, 139742),
(139743, '3.30.70.330-FF-001626', NULL, NULL, 53, NULL, NULL, 139743),
(139744, '1.20.144.10-FF-000045', NULL, 'RE35738p', 270, NULL, NULL, 139744),
(139745, '2.60.120.260-FF-000184', NULL, 'Membrane protein', 143, NULL, NULL, 139745),
(139746, '2.130.10.10-FF-004966', NULL, 'Uncharacterized protein', 87, NULL, NULL, 139746),
(139747, '3.30.450.60-FF-000014', NULL, 'Coatomer subunit zeta-2', 147, NULL, NULL, 139747),
(139748, '2.170.150.10-FF-000032', NULL, 'Uncharacterized protein', 151, NULL, NULL, 139748),
(139749, '3.30.70.2510-FF-000011', NULL, NULL, 133, NULL, NULL, 139749),
(139750, '1.10.287.70-FF-000773', NULL, 'Uncharacterized protein', 118, NULL, NULL, 139750),
(139751, '3.30.530.20-FF-000099', NULL, 'Homeobox-leucine zipper protein HDG8', 204, NULL, NULL, 139751),
(139752, '2.80.10.50-FF-000052', NULL, 'Interleukin 33', 159, NULL, NULL, 139752),
(139753, '1.10.238.10-FF-001159', NULL, 'Uncharacterized protein', 112, NULL, NULL, 139753),
(139754, '3.30.420.40-FF-000748', NULL, 'Uncharacterized protein', 62, NULL, NULL, 139754),
(139755, '3.90.1750.10-FF-000053', NULL, 'Ubiquitin protein ligase, putative', 149, NULL, NULL, 139755),
(139756, '3.40.50.150-FF-001740', NULL, NULL, 250, NULL, NULL, 139756),
(139757, '3.40.190.10-FF-000960', NULL, 'Uncharacterized protein', 77, NULL, NULL, 139757),
(139758, '2.130.10.10-FF-004096', NULL, 'Uncharacterized protein', 197, NULL, NULL, 139758),
(139759, '1.20.272.10-FF-000084', NULL, NULL, 66, NULL, NULL, 139759),
(139760, '1.25.40.10-FF-003375', NULL, 'TPR repeat, putative', 175, NULL, NULL, 139760),
(139761, '3.30.200.20-FF-002367', NULL, 'Kinase family protein', 90, NULL, NULL, 139761),
(139762, '2.130.10.10-FF-002488', NULL, 'Uncharacterized protein', 186, NULL, NULL, 139762),
(139763, '1.10.760.10-FF-000097', NULL, 'Lupanine 17-hydroxylase [cytochrome c]', 110, NULL, NULL, 139763),
(139764, '2.60.40.1530-FF-000002', NULL, 'integrin alpha-V isoform X2', 220, NULL, NULL, 139764);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(139765, '3.30.9.10-FF-000267', NULL, 'Uncharacterized protein', 137, NULL, NULL, 139765),
(139766, '3.40.710.10-FF-000023', NULL, 'D-alanyl-D-alanine carboxypeptidase DacF', 270, NULL, NULL, 139766),
(139767, '3.40.50.10580-FF-000005', NULL, 'V-type proton ATPase subunit F', 68, NULL, NULL, 139767),
(139768, '2.30.42.10-FF-000604', NULL, NULL, 98, NULL, NULL, 139768),
(139769, '3.80.10.10-FF-002319', NULL, 'F-box domain-containing protein', 149, NULL, NULL, 139769),
(139770, '3.40.190.80-FF-000048', NULL, 'Putative fructose-1,6-bisphosphatase', 123, NULL, NULL, 139770),
(139771, '3.40.50.200-FF-000064', NULL, 'Extracellular serine protease', 421, NULL, NULL, 139771),
(139772, '3.40.50.300-FF-006737', NULL, 'Predicted protein', 69, NULL, NULL, 139772),
(139773, '4.10.1000.10-FF-000008', NULL, 'zinc finger CCCH domain-containing protein 3', 52, NULL, NULL, 139773),
(139774, '2.40.70.10-FF-000129', NULL, 'Aspartic proteinase A1', 213, NULL, NULL, 139774),
(139775, '1.25.40.10-FF-001003', NULL, 'AGAP000499-PA', 153, NULL, NULL, 139775),
(139776, '3.30.70.330-FF-002132', NULL, NULL, 102, NULL, NULL, 139776),
(139777, '3.40.50.300-FF-007434', NULL, 'Uncharacterized protein', 256, NULL, NULL, 139777),
(139778, '2.70.98.10-FF-000029', NULL, 'Aldose 1-epimerase', 350, NULL, NULL, 139778),
(139779, '1.20.1070.10-FF-000530', NULL, 'Putative olfactory receptor', 159, NULL, NULL, 139779),
(139780, '1.20.58.60-FF-000057', NULL, 'Short stop, isoform N', 112, NULL, NULL, 139780),
(139781, '2.30.230.10-FF-000015', NULL, 'Apolipophorin, isoform B', 238, NULL, NULL, 139781),
(139782, '1.10.150.240-FF-000084', NULL, 'Putative phosphatase', 63, NULL, NULL, 139782),
(139783, '3.40.640.10-FF-000242', NULL, 'Perosamine synthetase', 377, NULL, NULL, 139783),
(139784, '3.40.50.300-FF-003511', NULL, 'RNA helicase, superfamily II', 259, NULL, NULL, 139784),
(139785, '1.20.1070.10-FF-001709', NULL, 'Uncharacterized protein', 106, NULL, NULL, 139785),
(139786, '3.30.300.20-FF-000014', NULL, 'probable ribosome-binding factor A, chloroplastic', 117, NULL, NULL, 139786),
(139787, '3.40.50.300-FF-004680', NULL, 'MutS homolog 3', 96, NULL, NULL, 139787),
(139788, '3.40.50.300-FF-002994', NULL, 'ATPase, AAA family protein', 191, NULL, NULL, 139788),
(139789, '3.30.1960.10-FF-000009', NULL, 'DUF207 domain protein', 229, NULL, NULL, 139789),
(139790, '1.20.1250.20-FF-000777', NULL, 'MFS transporter', 179, NULL, NULL, 139790),
(139791, '2.40.30.110-FF-000025', NULL, NULL, 79, NULL, NULL, 139791),
(139792, '3.10.20.90-FF-000469', NULL, 'Polyubiquitin-C', 34, NULL, NULL, 139792),
(139793, '2.160.20.10-FF-000065', NULL, 'GM01353p', 191, NULL, NULL, 139793),
(139794, '1.10.510.10-FF-004518', NULL, NULL, 113, NULL, NULL, 139794),
(139795, '1.20.1050.130-FF-000033', NULL, 'Predicted protein', 64, NULL, NULL, 139795),
(139796, '2.130.10.10-FF-005585', NULL, 'Roco6, ROCO family protein', 203, NULL, NULL, 139796),
(139797, '3.30.50.10-FF-000048', NULL, 'GATA zinc finger domain-containing protein 1', 32, NULL, NULL, 139797),
(139798, '3.30.40.10-FF-001391', NULL, 'TRAF6', 56, NULL, NULL, 139798),
(139799, '1.20.1250.20-FF-000305', NULL, 'Drug resistance transporter, EmrB/QacA family', 237, NULL, NULL, 139799),
(139800, '3.30.70.330-FF-002907', NULL, NULL, 39, NULL, NULL, 139800),
(139801, '3.40.50.300-FF-006580', NULL, 'Uncharacterized protein', 100, NULL, NULL, 139801),
(139802, '1.25.40.10-FF-002756', NULL, 'Uncharacterized protein', 191, NULL, NULL, 139802),
(139803, '1.10.1900.10-FF-000017', NULL, 'YALI0B00616p', 90, NULL, NULL, 139803),
(139804, '3.40.50.2000-FF-000440', NULL, 'ADP-heptose--lipooligosaccharide heptosyltransferase II', 145, NULL, NULL, 139804),
(139805, '2.60.40.10-FF-002717', NULL, 'Type II inositol-1,4,5-trisphosphate 5-phosphatase, putative', 131, NULL, NULL, 139805),
(139806, '1.50.40.10-FF-000394', NULL, 'Mitochondrial amino acid carrier', 125, NULL, NULL, 139806),
(139807, '3.40.50.10190-FF-000113', NULL, 'DNA repair protein Rtt107', 94, NULL, NULL, 139807),
(139808, '3.10.350.10-FF-000075', NULL, 'LysM peptidoglycan-binding domain-containing protein', 63, NULL, NULL, 139808);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(139809, '1.25.10.10-FF-001147', NULL, 'Exportin 6', 329, NULL, NULL, 139809),
(139810, '3.30.200.20-FF-001748', NULL, 'Serine/threonine protein kinase, putative', 171, NULL, NULL, 139810),
(139811, '2.60.40.150-FF-000546', NULL, 'Phosphoinositide phospholipase C', 167, NULL, NULL, 139811),
(139812, '3.30.740.10-FF-000016', NULL, 'Dynein light chain', 97, NULL, NULL, 139812),
(139813, '1.20.58.1100-FF-000012', NULL, 'Uncharacterized protein', 151, NULL, NULL, 139813),
(139814, '2.30.30.40-FF-000468', NULL, 'Uncharacterized protein', 71, NULL, NULL, 139814),
(139815, '3.50.50.60-FF-001298', NULL, 'Thioredoxin reductase 1, mitochondrial-like Protein', 199, NULL, NULL, 139815),
(139816, '3.40.50.150-FF-000251', NULL, 'Putative RNA methylase', 178, NULL, NULL, 139816),
(139817, '2.30.180.10-FF-000134', NULL, NULL, 118, NULL, NULL, 139817),
(139818, '2.20.25.10-FF-000043', NULL, 'DNA-directed RNA polymerase subunit', 66, NULL, NULL, 139818),
(139819, '3.40.50.1820-FF-001296', NULL, 'Carboxypeptidase', 278, NULL, NULL, 139819),
(139820, '2.130.10.10-FF-000604', NULL, 'U3 snoRNA-associated small subunit rRNA processing protein, putative', 208, NULL, NULL, 139820),
(139821, '3.60.90.10-FF-000032', NULL, 'Uncharacterized protein', 164, NULL, NULL, 139821),
(139822, '1.25.40.20-FF-000831', NULL, 'Poly [ADP-ribose] polymerase', 353, NULL, NULL, 139822),
(139823, '3.40.30.10-FF-000658', NULL, 'Thiol-disulfide oxidoreductase ResA', 173, NULL, NULL, 139823),
(139824, '2.30.40.10-FF-000061', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 72, NULL, NULL, 139824),
(139825, '3.90.79.10-FF-000229', NULL, 'Predicted protein', 93, NULL, NULL, 139825),
(139826, '3.30.70.141-FF-000036', NULL, NULL, 192, NULL, NULL, 139826),
(139827, '3.90.1480.20-FF-000046', NULL, 'Alpha-2,8-sialyltransferase', 200, NULL, NULL, 139827),
(139828, '3.40.50.300-FF-001257', NULL, 'RAB20, member RAS oncogene family', 228, NULL, NULL, 139828),
(139829, '1.10.238.200-FF-000022', NULL, 'Defective in cullin neddylation protein 1', 82, NULL, NULL, 139829),
(139830, '1.10.472.130-FF-000045', NULL, 'Dynein heavy chain, putative', 200, NULL, NULL, 139830),
(139831, '1.10.10.1340-FF-000007', NULL, 'Mediator of RNA polymerase II transcription subunit 31', 96, NULL, NULL, 139831),
(139832, '2.10.25.10-FF-000785', NULL, 'Integrin beta', 50, NULL, NULL, 139832),
(139833, '3.40.140.10-FF-000114', NULL, 'Cytidine deaminase', 161, NULL, NULL, 139833),
(139834, '3.40.30.10-FF-000788', NULL, 'NADH dehydrogenase I, F subunit', 95, NULL, NULL, 139834),
(139835, '2.60.40.10-FF-001436', NULL, 'Muscle M-line assembly protein unc-89', 96, NULL, NULL, 139835),
(139836, '3.10.250.10-FF-000011', NULL, 'Scavenger receptor class A member 5', 107, NULL, NULL, 139836),
(139837, '1.10.287.1490-FF-000054', NULL, 'Centrosomal protein of 72 kDa', 193, NULL, NULL, 139837),
(139838, '2.70.170.10-FF-000017', NULL, '5-hydroxytryptamine receptor 3A', 208, NULL, NULL, 139838),
(139839, '1.10.150.80-FF-000043', NULL, 'Uncharacterized protein', 95, NULL, NULL, 139839),
(139840, '3.80.10.10-FF-003747', NULL, 'Leucine-rich repeat neuronal protein 1-like Protein', 127, NULL, NULL, 139840),
(139841, '1.10.506.10-FF-000035', NULL, 'Plexin b2a', 243, NULL, NULL, 139841),
(139842, '2.30.29.30-FF-000265', NULL, 'BAG-associated GRAM protein 1 isoform X2', 120, NULL, NULL, 139842),
(139843, '1.10.630.10-FF-000222', NULL, 'Os08g0152400 protein', 129, NULL, NULL, 139843),
(139844, '2.130.10.10-FF-001223', NULL, 'WD repeat-containing protein 90', 252, NULL, NULL, 139844),
(139845, '3.30.160.60-FF-001532', NULL, 'Zinc finger protein 483', 36, NULL, NULL, 139845),
(139846, '3.40.50.10800-FF-000010', NULL, 'Quinolinate synthase A', 85, NULL, NULL, 139846),
(139847, '3.40.50.10990-FF-000010', NULL, 'Monofunctional riboflavin biosynthesis protein RIBA 2, chloroplastic', 164, NULL, NULL, 139847),
(139848, '2.10.110.10-FF-000067', NULL, 'Uncharacterized protein, isoform Z', 59, NULL, NULL, 139848),
(139849, '3.30.160.60-FF-002976', NULL, NULL, 28, NULL, NULL, 139849),
(139850, '1.10.472.10-FF-000377', NULL, 'Cyclin t, putative', 73, NULL, NULL, 139850);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(139851, '1.10.533.10-FF-000182', NULL, 'Si:dkeyp-97b10.3', 99, NULL, NULL, 139851),
(139852, '3.30.40.10-FF-001992', NULL, 'Uncharacterized protein C16C9.05', 103, NULL, NULL, 139852),
(139853, '3.30.420.10-FF-000104', NULL, 'Werner Syndrome-like exonuclease', 206, NULL, NULL, 139853),
(139854, '1.10.510.10-FF-002203', NULL, 'Uncharacterized protein', 229, NULL, NULL, 139854),
(139855, '3.30.1370.10-FF-000217', NULL, 'Uncharacterized protein', 89, NULL, NULL, 139855),
(139856, '1.20.120.1780-FF-000004', NULL, '4-hydroxybenzoate octaprenyltransferase', 120, NULL, NULL, 139856),
(139857, '2.60.120.920-FF-000196', NULL, 'LOC567531 protein', 196, NULL, NULL, 139857),
(139858, '3.40.50.300-FF-000785', NULL, 'DEAD/DEAH box helicase', 187, NULL, NULL, 139858),
(139859, '3.90.420.10-FF-000001', NULL, 'Protein-methionine-sulfoxide reductase catalytic subunit MsrP', 271, NULL, NULL, 139859),
(139860, '3.30.530.20-FF-000071', NULL, 'START domain containing protein', 211, NULL, NULL, 139860),
(139861, '3.30.160.20-FF-000042', NULL, 'SON DNA binding protein', 51, NULL, NULL, 139861),
(139862, '2.60.40.10-FF-002847', NULL, 'Protein CBG01857', 113, NULL, NULL, 139862),
(139863, '2.60.40.10-FF-003336', NULL, 'Uncharacterized protein', 137, NULL, NULL, 139863),
(139864, '2.60.40.10-FF-006107', NULL, NULL, 62, NULL, NULL, 139864),
(139865, '1.10.1320.10-FF-000018', NULL, 'DNA-directed RNA polymerase', 348, NULL, NULL, 139865),
(139866, '1.10.260.40-FF-000045', NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin, putative', 62, NULL, NULL, 139866),
(139867, '3.40.50.300-FF-005309', NULL, 'ATP-dependent DNA helicase PIF1', 169, NULL, NULL, 139867),
(139868, '1.10.150.60-FF-000032', NULL, 'ARID/BRIGHT DNA-binding domain-containing protein', 120, NULL, NULL, 139868),
(139869, '2.30.30.140-FF-000076', NULL, 'RING finger protein 17', 72, NULL, NULL, 139869),
(139870, '3.40.50.300-FF-001274', NULL, 'Cell division protein ZapE', 153, NULL, NULL, 139870),
(139871, '3.90.70.10-FF-000018', NULL, 'Ubiquitin carboxyl-terminal hydrolase 32', 227, NULL, NULL, 139871),
(139872, '3.40.47.10-FF-000309', NULL, 'Polyketide synthase/nonribosomal peptide synthetase hybrid RzxB', 473, NULL, NULL, 139872),
(139873, '3.30.70.100-FF-000186', NULL, NULL, 76, NULL, NULL, 139873),
(139874, '2.130.10.80-FF-000002', NULL, 'Uncharacterized protein', 351, NULL, NULL, 139874),
(139875, '2.60.40.10-FF-002072', NULL, 'Plexin A1a', 134, NULL, NULL, 139875),
(139876, '1.10.1420.10-FF-000071', NULL, 'Mismatch repair protein', 132, NULL, NULL, 139876),
(139877, '3.40.850.10-FF-000516', NULL, 'Uncharacterized protein', 116, NULL, NULL, 139877),
(139878, '3.40.50.2300-FF-001058', NULL, NULL, 127, NULL, NULL, 139878),
(139879, '2.20.70.10-FF-000220', NULL, 'WW domain-containing protein WWM1', 66, NULL, NULL, 139879),
(139880, '2.40.50.90-FF-000152', NULL, 'Thermonuclease', 145, NULL, NULL, 139880),
(139881, '3.30.420.10-FF-000413', NULL, NULL, 177, NULL, NULL, 139881),
(139882, '3.40.50.300-FF-000329', NULL, 'GTP-binding protein rhoA', 191, NULL, NULL, 139882),
(139883, '2.60.40.10-FF-001127', NULL, 'Myosin, light chain kinase a', 103, NULL, NULL, 139883),
(139884, '3.30.160.40-FF-000020', NULL, 'Hydroxymethylbilane synthase, b', 40, NULL, NULL, 139884),
(139885, '1.20.1070.10-FF-001839', NULL, 'Predicted protein', 303, NULL, NULL, 139885),
(139886, '1.20.920.10-FF-000124', NULL, 'YALI0D20702p', 115, NULL, NULL, 139886),
(139887, '2.40.10.170-FF-000016', NULL, 'ATP synthase subunit beta', 77, NULL, NULL, 139887),
(139888, '1.10.287.70-FF-000756', NULL, 'Uncharacterized protein', 55, NULL, NULL, 139888),
(139889, '2.60.40.640-FF-000013', NULL, 'Putative arrestin domain-containing protein 1', 142, NULL, NULL, 139889),
(139890, '3.30.200.20-FF-001187', NULL, 'OSJNBa0042I15.25 protein', 111, NULL, NULL, 139890),
(139891, '3.40.50.300-FF-008406', NULL, 'Uncharacterized protein', 167, NULL, NULL, 139891),
(139892, '1.10.540.10-FF-000114', NULL, 'Acyl-coenzyme A oxidase', 112, NULL, NULL, 139892),
(139893, '3.80.10.10-FF-004236', NULL, 'Uncharacterized protein', 78, NULL, NULL, 139893);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(139894, '3.30.70.330-FF-002571', NULL, NULL, 144, NULL, NULL, 139894),
(139895, '1.25.10.10-FF-002327', NULL, 'Uncharacterized protein', 302, NULL, NULL, 139895),
(139896, '3.10.100.10-FF-000366', NULL, NULL, 144, NULL, NULL, 139896),
(139897, '3.80.10.10-FF-000313', NULL, 'Leucine rich repeat containing 14B', 257, NULL, NULL, 139897),
(139898, '1.25.40.20-FF-001315', NULL, 'Uncharacterized protein', 140, NULL, NULL, 139898),
(139899, '2.60.40.1510-FF-000024', NULL, 'Integrin beta', 111, NULL, NULL, 139899),
(139900, '1.10.510.10-FF-003029', NULL, NULL, 224, NULL, NULL, 139900),
(139901, '3.80.10.10-FF-001139', NULL, 'Os08g0194350 protein', 185, NULL, NULL, 139901),
(139902, '2.130.10.10-FF-004657', NULL, 'Uncharacterized protein', 188, NULL, NULL, 139902),
(139903, '3.40.50.2300-FF-000541', NULL, 'Ornithine decarboxylase', 131, NULL, NULL, 139903),
(139904, '1.10.10.60-FF-001212', NULL, NULL, 80, NULL, NULL, 139904),
(139905, '1.10.238.10-FF-000350', NULL, 'Calcium-binding EF hand family protein', 114, NULL, NULL, 139905),
(139906, '3.40.50.300-FF-007917', NULL, 'Uncharacterized protein', 182, NULL, NULL, 139906),
(139907, '3.30.430.20-FF-000035', NULL, 'Cysteine-rich receptor-like protein kinase 25 isoform A', 104, NULL, NULL, 139907),
(139908, '3.40.50.1980-FF-000028', NULL, 'High-affinity zinc uptake system protein znuA', 172, NULL, NULL, 139908),
(139909, '1.10.1300.10-FF-000005', NULL, 'Phosphodiesterase', 337, NULL, NULL, 139909),
(139910, '3.20.20.70-FF-000289', NULL, '2-dehydro-3-deoxy-phosphogluconate/2-dehydro-3-deoxy-6-phosphogalactonate aldolase', 289, NULL, NULL, 139910),
(139911, '1.10.510.10-FF-000697', NULL, 'G2-specific protein kinase nimA', 289, NULL, NULL, 139911),
(139912, '3.40.710.10-FF-000006', NULL, 'Penicillin-binding protein 1B', 371, NULL, NULL, 139912),
(139913, '1.20.58.390-FF-000238', NULL, 'Gamma-aminobutyric acid type A receptor alpha6 subunit', 187, NULL, NULL, 139913),
(139914, '1.10.10.10-FF-000950', NULL, 'Toxin co-regulated pilus biosynthesis protein P', 98, NULL, NULL, 139914),
(139915, '2.70.98.10-FF-000046', NULL, 'Alpha-1,2-mannosidase, putative', 271, NULL, NULL, 139915),
(139916, '3.40.30.10-FF-001277', NULL, 'Uncharacterized protein', 128, NULL, NULL, 139916),
(139917, '3.30.70.330-FF-002115', NULL, NULL, 112, NULL, NULL, 139917),
(139918, '2.40.50.140-FF-000460', NULL, 'ATP-dependent DNA helicase RecG', 91, NULL, NULL, 139918),
(139919, '2.30.29.90-FF-000013', NULL, 'Uncharacterized protein', 97, NULL, NULL, 139919),
(139920, '1.20.1250.20-FF-001283', NULL, 'Uncharacterized MFS-type transporter YwoD', 194, NULL, NULL, 139920),
(139921, '1.10.357.110-FF-000004', NULL, 'Vacuolar-sorting protein 53 long isoform', 155, NULL, NULL, 139921),
(139922, '1.25.10.10-FF-001810', NULL, 'Regulatory associated protein of MTOR, complex 1', 204, NULL, NULL, 139922),
(139923, '1.10.8.60-FF-000020', NULL, '26S protease regulatory subunit 6B', 82, NULL, NULL, 139923),
(139924, '2.60.40.10-FF-000947', NULL, 'Carcinoembryonic antigen related cell adhesion molecule 16', 75, NULL, NULL, 139924),
(139925, '3.40.50.300-FF-000638', NULL, 'Transmembrane GTPase Fzo1, putative', 223, NULL, NULL, 139925),
(139926, '3.40.630.10-FF-000314', NULL, 'Carboxypeptidase T, putative', 159, NULL, NULL, 139926),
(139927, '1.10.510.10-FF-002383', NULL, NULL, 105, NULL, NULL, 139927),
(139928, '3.30.428.10-FF-000072', NULL, 'Bis(5''-adenosyl)-triphosphatase, putative', 141, NULL, NULL, 139928),
(139929, '1.10.510.10-FF-001894', NULL, 'CAMK family protein kinase', 298, NULL, NULL, 139929),
(139930, '1.20.58.60-FF-000849', NULL, 'Uncharacterized protein', 140, NULL, NULL, 139930),
(139931, '2.130.10.10-FF-005130', NULL, 'Intraflagellar transport protein 122 homolog', 187, NULL, NULL, 139931),
(139932, '3.30.300.20-FF-000031', NULL, 'GTPase Era', 113, NULL, NULL, 139932),
(139933, '3.30.1380.20-FF-000035', NULL, 'Uncharacterized protein', 96, NULL, NULL, 139933),
(139934, '3.40.50.300-FF-005517', NULL, 'Meiotic recombination protein DMC1', 131, NULL, NULL, 139934),
(139935, '3.40.50.1440-FF-000007', NULL, 'Tubulin alpha chain', 268, NULL, NULL, 139935);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(139936, '2.160.20.10-FF-000048', NULL, 'tRNA nuclease CdiA', 294, NULL, NULL, 139936),
(139937, '3.30.200.20-FF-001979', NULL, 'Uncharacterized protein', 124, NULL, NULL, 139937),
(139938, '3.10.250.10-FF-000039', NULL, 'Multidomain scavenger receptor', 129, NULL, NULL, 139938),
(139939, '3.30.43.10-FF-000014', NULL, 'L-gulonolactone oxidase', 69, NULL, NULL, 139939),
(139940, '3.40.1110.10-FF-000409', NULL, NULL, 60, NULL, NULL, 139940),
(139941, '1.20.1250.20-FF-000322', NULL, 'Uncharacterized protein, isoform A', 124, NULL, NULL, 139941),
(139942, '3.90.25.10-FF-000021', NULL, 'GDP-mannose 4,6-dehydratase', 99, NULL, NULL, 139942),
(139943, '3.40.50.10880-FF-000005', NULL, 'DUF89-domain-containing protein', 174, NULL, NULL, 139943),
(139944, '1.10.510.10-FF-002411', NULL, NULL, 174, NULL, NULL, 139944),
(139945, '2.60.40.150-FF-000754', NULL, 'Uncharacterized protein', 51, NULL, NULL, 139945),
(139946, '1.25.40.570-FF-000042', NULL, 'Uncharacterized protein', 381, NULL, NULL, 139946),
(139947, '1.10.630.10-FF-000430', NULL, 'Uncharacterized protein', 177, NULL, NULL, 139947),
(139948, '3.90.20.20-FF-000035', NULL, 'Protein GrpE', 102, NULL, NULL, 139948),
(139949, '3.30.40.10-FF-000564', NULL, 'ERAD-associated E3 ubiquitin-protein ligase HRD1', 82, NULL, NULL, 139949),
(139950, '3.30.830.10-FF-000107', NULL, 'Insulin-degrading enzyme homolog', 227, NULL, NULL, 139950),
(139951, '3.40.50.2000-FF-000232', NULL, 'UDP-glycosyltransferase 76C1', 241, NULL, NULL, 139951),
(139952, '3.30.200.20-FF-001395', NULL, 'Mitogen-activated protein kinase', 104, NULL, NULL, 139952),
(139953, '3.40.50.1240-FF-000071', NULL, 'Probable phosphoglycerate mutase', 197, NULL, NULL, 139953),
(139954, '3.30.40.10-FF-001183', NULL, 'Ring finger domain/Zinc finger, C3HC4 type (RING finger) containing protein, putative', 82, NULL, NULL, 139954),
(139955, '1.20.1110.10-FF-000146', NULL, 'Cation-transporting P-type ATPase', 357, NULL, NULL, 139955),
(139956, '2.20.200.10-FF-000004', NULL, 'Multidrug resistance outer membrane protein MdtQ', 92, NULL, NULL, 139956),
(139957, '3.40.50.11990-FF-000001', NULL, 'Cell division cycle 73', 180, NULL, NULL, 139957),
(139958, '3.90.640.10-FF-000113', NULL, 'Actin-like ATPase domain-containing protein', 23, NULL, NULL, 139958),
(139959, '3.90.70.10-FF-000653', NULL, 'Predicted protein', 84, NULL, NULL, 139959),
(139960, '3.40.50.150-FF-001431', NULL, NULL, 149, NULL, NULL, 139960),
(139961, '3.30.160.60-FF-001796', NULL, 'Fanconi-associated nuclease', 27, NULL, NULL, 139961),
(139962, '3.90.660.20-FF-000016', NULL, 'Protoporphyrinogen oxidase', 199, NULL, NULL, 139962),
(139963, '3.30.450.20-FF-000598', NULL, 'C4-dicarboxylate transport sensor protein DctB, putative', 97, NULL, NULL, 139963),
(139964, '1.25.40.10-FF-000710', NULL, 'Pentatricopeptide repeat-containing protein', 101, NULL, NULL, 139964),
(139965, '3.40.50.620-FF-000616', NULL, 'Glutamate--tRNA ligase', 354, NULL, NULL, 139965),
(139966, '3.30.760.10-FF-000034', NULL, 'Eukaryotic translation initiation factor 4E, putative', 180, NULL, NULL, 139966),
(139967, '3.10.20.90-FF-000969', NULL, 'Chromosome 12, whole genome shotgun sequence', 111, NULL, NULL, 139967),
(139968, '3.80.10.10-FF-003539', NULL, 'Uncharacterized protein', 161, NULL, NULL, 139968),
(139969, '3.40.50.10140-FF-000031', NULL, 'putative ST2L protein isoform X4', 176, NULL, NULL, 139969),
(139970, '1.10.287.130-FF-000061', NULL, 'Histidine kinase', 74, NULL, NULL, 139970),
(139971, '1.10.800.10-FF-000022', NULL, 'Tyrosine hydroxylase', 55, NULL, NULL, 139971),
(139972, '3.40.850.10-FF-000308', NULL, 'Uncharacterized protein', 126, NULL, NULL, 139972),
(139973, '3.30.413.10-FF-000037', NULL, 'Anaerobic sulfite reductase subunit C', 136, NULL, NULL, 139973),
(139974, '1.10.1450.10-FF-000044', NULL, 'Tetraspanin', 86, NULL, NULL, 139974),
(139975, '4.10.400.10-FF-000093', NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein', 36, NULL, NULL, 139975),
(139976, '1.20.1110.10-FF-000247', NULL, NULL, 207, NULL, NULL, 139976),
(139977, '1.10.750.20-FF-000009', NULL, 'Suppressor of cytokine signaling 1', 33, NULL, NULL, 139977);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(139978, '3.30.70.330-FF-000215', NULL, 'ELAV-like protein', 97, NULL, NULL, 139978),
(139979, '1.10.30.50-FF-000002', NULL, 'DNA annealing helicase and endonuclease ZRANB3', 92, NULL, NULL, 139979),
(139980, '3.40.1110.10-FF-000398', NULL, NULL, 96, NULL, NULL, 139980),
(139981, '1.25.10.10-FF-000630', NULL, 'DnaJ heat shock protein family (Hsp40) member C13', 190, NULL, NULL, 139981),
(139982, '3.10.350.10-FF-000103', NULL, 'Membrane-bound lytic peptidoglycan transglycosylase D', 71, NULL, NULL, 139982),
(139983, '2.60.40.420-FF-000150', NULL, 'Coagulation factor V', 159, NULL, NULL, 139983),
(139984, '2.60.120.260-FF-000537', NULL, 'Uncharacterized protein', 83, NULL, NULL, 139984),
(139985, '3.40.190.290-FF-000120', NULL, 'Uncharacterized HTH-type transcriptional regulator HI_0775', 203, NULL, NULL, 139985),
(139986, '1.10.30.10-FF-000041', NULL, 'HMG box family protein', 83, NULL, NULL, 139986),
(139987, '3.20.20.80-FF-000410', NULL, 'Klotho beta', 108, NULL, NULL, 139987),
(139988, '1.10.287.1150-FF-000019', NULL, 'Alpha-ketoglutarate dehydrogenase E1', 79, NULL, NULL, 139988),
(139989, '3.30.450.60-FF-000031', NULL, 'Signal recognition particle receptor subunit alpha', 117, NULL, NULL, 139989),
(139990, '1.10.533.10-FF-000047', NULL, 'Nucleotide-binding oligomerization domain-containing protein 1', 98, NULL, NULL, 139990),
(139991, '3.40.50.80-FF-000208', NULL, 'Predicted protein', 121, NULL, NULL, 139991),
(139992, '3.40.50.300-FF-008070', NULL, 'Uncharacterized protein', 122, NULL, NULL, 139992),
(139993, '3.40.1370.10-FF-000046', NULL, 'Uncharacterized protein', 90, NULL, NULL, 139993),
(139994, '3.30.1370.10-FF-000009', NULL, 'RNA-binding protein PNO1', 97, NULL, NULL, 139994),
(139995, '1.25.40.10-FF-002155', NULL, 'Transcription factor EMB1444', 107, NULL, NULL, 139995),
(139996, '1.10.287.380-FF-000006', NULL, 'ABC transporter ATP-binding protein', 82, NULL, NULL, 139996),
(139997, '2.170.270.10-FF-000057', NULL, 'Histone-lysine N-methyltransferase', 231, NULL, NULL, 139997),
(139998, '3.30.420.100-FF-000024', NULL, 'Predicted protein', 73, NULL, NULL, 139998),
(139999, '2.90.10.10-FF-000056', NULL, 'Uncharacterized protein', 186, NULL, NULL, 139999),
(140000, '2.40.50.140-FF-001168', NULL, NULL, 61, NULL, NULL, 140000),
(140001, '3.40.50.300-FF-000740', NULL, 'Putative GTP-binding protein 1', 139, NULL, NULL, 140001),
(140002, '1.10.238.10-FF-000934', NULL, 'Uncharacterized protein', 104, NULL, NULL, 140002),
(140003, '3.90.1150.10-FF-000215', NULL, 'Glycine dehydrogenase subunit 2', 51, NULL, NULL, 140003),
(140004, '3.40.50.1820-FF-000043', NULL, 'acylamino-acid-releasing enzyme', 260, NULL, NULL, 140004),
(140005, '4.10.260.10-FF-000002', NULL, 'Regulator of G-protein signaling 6', 51, NULL, NULL, 140005),
(140006, '1.20.1560.10-FF-000067', NULL, 'Multidrug resistance protein 1', 332, NULL, NULL, 140006),
(140007, '3.30.160.60-FF-001324', NULL, 'Zinc finger protein 664', 29, NULL, NULL, 140007),
(140008, '3.80.10.10-FF-004045', NULL, 'Nischarin', 140, NULL, NULL, 140008),
(140009, '1.20.5.1160-FF-000013', NULL, 'Tropomyosin 1 (alpha)', 44, NULL, NULL, 140009),
(140010, '2.160.10.10-FF-000019', NULL, 'YRDA protein yrdA', 184, NULL, NULL, 140010),
(140011, '1.25.40.20-FF-001124', NULL, 'Serine/threonine protein kinase', 192, NULL, NULL, 140011),
(140012, '2.130.10.10-FF-001431', NULL, 'Predicted protein', 131, NULL, NULL, 140012),
(140013, '3.30.450.20-FF-000126', NULL, 'Putative diguanylate cyclase YegE', 130, NULL, NULL, 140013),
(140014, '3.30.565.10-FF-000119', NULL, 'DNA topoisomerase 2', 209, NULL, NULL, 140014),
(140015, '3.40.930.10-FF-000034', NULL, 'Anion/Bicarbonate TranSporter family', 324, NULL, NULL, 140015),
(140016, '3.10.20.90-FF-000924', NULL, 'Uncharacterized protein', 82, NULL, NULL, 140016),
(140017, '3.40.630.30-FF-000528', NULL, 'Tetratricopeptide repeat protein 21B-like Protein', 88, NULL, NULL, 140017),
(140018, '1.10.510.10-FF-004209', NULL, NULL, 217, NULL, NULL, 140018),
(140019, '2.30.42.10-FF-000043', NULL, 'Syntenin-1 isoform X1', 85, NULL, NULL, 140019);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(140020, '1.10.20.10-FF-000276', NULL, NULL, 76, NULL, NULL, 140020),
(140021, '3.30.470.30-FF-000029', NULL, 'Mrna capping enzyme family protein', 232, NULL, NULL, 140021),
(140022, '4.10.60.10-FF-000098', NULL, 'Cellular nucleic acid-binding protein', 51, NULL, NULL, 140022),
(140023, '3.40.50.920-FF-000015', NULL, 'Pyruvate dehydrogenase E1 component subunit beta', 130, NULL, NULL, 140023),
(140024, '1.25.10.10-FF-002119', NULL, 'RING-type E3 ubiquitin transferase', 107, NULL, NULL, 140024),
(140025, '3.90.180.10-FF-000066', NULL, 'Putative quinone oxidoreductase', 136, NULL, NULL, 140025),
(140026, '2.70.150.10-FF-000090', NULL, 'Cadmium-translocating P-type ATPase', 117, NULL, NULL, 140026),
(140027, '3.30.300.30-FF-000135', NULL, 'Nonribosomal peptide synthetase 6', 133, NULL, NULL, 140027),
(140028, '1.10.1520.10-FF-000016', NULL, 'Endoribonuclease Dcr-1', 152, NULL, NULL, 140028),
(140029, '3.90.79.10-FF-000190', NULL, 'NUDIX family hydrolase', 176, NULL, NULL, 140029),
(140030, '3.30.470.10-FF-000023', NULL, 'Branched-chain-amino-acid transaminase', 132, NULL, NULL, 140030),
(140031, '3.30.830.10-FF-000006', NULL, 'Putative insulin-degrading enzyme', 230, NULL, NULL, 140031),
(140032, '3.10.290.20-FF-000005', NULL, 'Ubiquitin-activating enzyme E1-like', 120, NULL, NULL, 140032),
(140033, '2.40.10.10-FF-000401', NULL, NULL, 108, NULL, NULL, 140033),
(140034, '1.10.472.10-FF-000068', NULL, 'Cyclin-L1-1 isoform A', 142, NULL, NULL, 140034),
(140035, '3.90.226.10-FF-000196', NULL, 'Enoyl-CoA hydratase/isomerase', 252, NULL, NULL, 140035),
(140036, '1.25.40.10-FF-003892', NULL, 'Uncharacterized protein', 78, NULL, NULL, 140036),
(140037, '2.30.230.10-FF-000032', NULL, 'von Willebrand factor type D domaincontaining protein', 218, NULL, NULL, 140037),
(140038, '3.40.50.300-FF-003174', NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', 138, NULL, NULL, 140038),
(140039, '3.40.50.2300-FF-001619', NULL, NULL, 294, NULL, NULL, 140039),
(140040, '3.40.525.10-FF-000036', NULL, 'Uncharacterized protein, isoform D', 245, NULL, NULL, 140040),
(140041, '1.20.1070.10-FF-001148', NULL, '5-hydroxytryptamine receptor 4', 347, NULL, NULL, 140041),
(140042, '3.30.70.330-FF-001418', NULL, 'Uncharacterized protein', 141, NULL, NULL, 140042),
(140043, '1.10.10.10-FF-001175', NULL, 'Uncharacterized protein', 105, NULL, NULL, 140043),
(140044, '3.30.260.10-FF-000086', NULL, NULL, 105, NULL, NULL, 140044),
(140045, '3.40.50.10320-FF-000006', NULL, '4-oxalmesaconate hydratase', 240, NULL, NULL, 140045),
(140046, '1.10.246.10-FF-000014', NULL, 'Serum albumin', 89, NULL, NULL, 140046),
(140047, '3.40.50.620-FF-000824', NULL, 'Transcriptional regulator, putative', 92, NULL, NULL, 140047),
(140048, '2.10.25.10-FF-000313', NULL, 'Usherin', 105, NULL, NULL, 140048),
(140049, '2.60.40.10-FF-000508', NULL, 'ephrin type-B receptor 6', 88, NULL, NULL, 140049),
(140050, '1.25.10.10-FF-002428', NULL, 'Uncharacterized protein', 243, NULL, NULL, 140050),
(140051, '3.90.1070.10-FF-000006', NULL, NULL, 68, NULL, NULL, 140051),
(140052, '1.10.10.60-FF-000801', NULL, NULL, 53, NULL, NULL, 140052),
(140053, '3.30.40.10-FF-000772', NULL, 'E3 ubiquitin-protein ligase rnf146', 73, NULL, NULL, 140053),
(140054, '3.40.50.170-FF-000009', NULL, 'Phosphoribosylglycinamide formyltransferase (Eurofung)', 214, NULL, NULL, 140054),
(140055, '1.25.40.10-FF-003111', NULL, 'Uncharacterized protein', 185, NULL, NULL, 140055),
(140056, '3.20.20.80-FF-000101', NULL, 'Lysozyme, putative', 202, NULL, NULL, 140056),
(140057, '1.25.40.10-FF-000502', NULL, 'Os03g0185200 protein', 136, NULL, NULL, 140057),
(140058, '1.25.40.20-FF-001332', NULL, 'Uncharacterized protein', 127, NULL, NULL, 140058),
(140059, '2.20.90.10-FF-000002', NULL, 'Vitellogenin-2', 172, NULL, NULL, 140059),
(140060, '2.30.29.30-FF-001355', NULL, 'Serine/threonine-protein kinase ksg1', 133, NULL, NULL, 140060),
(140061, '3.90.1520.10-FF-000013', NULL, 'Soluble guanylate cyclase gcy-37', 195, NULL, NULL, 140061),
(140062, '1.20.1250.20-FF-000114', NULL, 'Inner membrane metabolite transporter yhjE', 195, NULL, NULL, 140062);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(140063, '1.10.510.10-FF-003237', NULL, NULL, 121, NULL, NULL, 140063),
(140064, '3.30.900.10-FF-000023', NULL, 'Mitotic spindle assembly checkpoint protein MAD2B', 220, NULL, NULL, 140064),
(140065, '1.10.1740.140-FF-000005', NULL, NULL, 105, NULL, NULL, 140065),
(140066, '2.10.70.100-FF-000003', NULL, 'Sensory transduction histidine kinase', 32, NULL, NULL, 140066),
(140067, '2.40.50.40-FF-000053', NULL, 'CX chemokine ligand 34b, duplicate 11', 80, NULL, NULL, 140067),
(140068, '3.10.28.10-FF-000059', NULL, 'Vitamin B12-dependent ribonucleotide reductase', 165, NULL, NULL, 140068),
(140069, '2.60.120.330-FF-000098', NULL, 'Predicted protein', 324, NULL, NULL, 140069),
(140070, '3.40.1800.20-FF-000010', NULL, 'Transcription factor grauzone', 80, NULL, NULL, 140070),
(140071, '1.10.418.10-FF-000223', NULL, 'PH domain-containing protein DDB_G0287875', 117, NULL, NULL, 140071),
(140072, '3.40.50.300-FF-006945', NULL, 'Predicted protein', 315, NULL, NULL, 140072),
(140073, '2.60.120.620-FF-000016', NULL, 'Ectoine hydroxylase', 299, NULL, NULL, 140073),
(140074, '2.30.42.10-FF-000352', NULL, 'Periplasmic protease', 107, NULL, NULL, 140074),
(140075, '3.30.40.10-FF-000463', NULL, 'E3 ubiquitin-protein ligase RNF185 isoform X2', 71, NULL, NULL, 140075),
(140076, '1.25.40.10-FF-000811', NULL, 'Pentatricopeptide repeat-containing protein', 132, NULL, NULL, 140076),
(140077, '3.90.1100.10-FF-000004', NULL, 'DNA-directed RNA polymerase subunit beta', 209, NULL, NULL, 140077),
(140078, '3.20.20.80-FF-000090', NULL, 'Alpha-L-arabinofuranosidase A', 325, NULL, NULL, 140078),
(140079, '3.90.550.10-FF-000685', NULL, 'Uncharacterized protein', 78, NULL, NULL, 140079),
(140080, '3.60.90.10-FF-000015', NULL, 'S-adenosylmethionine decarboxylase proenzyme', 119, NULL, NULL, 140080),
(140081, '2.40.50.140-FF-000196', NULL, 'rRNA biogenesis protein RRP5', 67, NULL, NULL, 140081),
(140082, '3.30.430.20-FF-000018', NULL, 'Cysteine-rich receptor-like protein kinase 10', 111, NULL, NULL, 140082),
(140083, '3.30.160.60-FF-000604', NULL, 'Histone H4 transcription factor-like Protein', 28, NULL, NULL, 140083),
(140084, '1.10.10.850-FF-000006', NULL, NULL, 17, NULL, NULL, 140084),
(140085, '3.30.565.10-FF-000018', NULL, 'Two-component sensor kinase EnvZ', 156, NULL, NULL, 140085),
(140086, '3.30.9.10-FF-000059', NULL, 'Oxidoreductase, DadA family', 151, NULL, NULL, 140086),
(140087, '3.30.1540.20-FF-000037', NULL, NULL, 102, NULL, NULL, 140087),
(140088, '3.30.1120.30-FF-000036', NULL, 'Uncharacterized protein', 90, NULL, NULL, 140088),
(140089, '3.20.20.70-FF-000553', NULL, NULL, 159, NULL, NULL, 140089),
(140090, '3.30.70.330-FF-000446', NULL, 'Cyclic AMP-dependent transcription factor ATF-1-like protein', 87, NULL, NULL, 140090),
(140091, '3.80.10.10-FF-002819', NULL, 'Uncharacterized protein', 216, NULL, NULL, 140091),
(140092, '3.10.20.90-FF-000599', NULL, 'TuBulin folding Cofactor E homolog', 89, NULL, NULL, 140092),
(140093, '1.10.10.10-FF-000247', NULL, 'HTH-type transcriptional regulator MetR', 90, NULL, NULL, 140093),
(140094, '3.40.50.970-FF-000137', NULL, 'Sulfite reductase [NADPH] flavoprotein component, putative', 229, NULL, NULL, 140094),
(140095, '1.20.1070.10-FF-000322', NULL, 'latrophilin Cirl isoform X2', 292, NULL, NULL, 140095),
(140096, '1.10.287.110-FF-000375', NULL, 'Heat shock protein DnaJ domain protein', 84, NULL, NULL, 140096),
(140097, '2.60.40.2690-FF-000007', NULL, 'Zinc-finger of C2H2 type', 131, NULL, NULL, 140097),
(140098, '3.40.50.300-FF-007226', NULL, 'Predicted protein', 163, NULL, NULL, 140098),
(140099, '3.40.50.280-FF-000014', NULL, 'Methylmalonyl-CoA mutase C-terminal domain-containing protein', 157, NULL, NULL, 140099),
(140100, '1.10.510.10-FF-002984', NULL, NULL, 115, NULL, NULL, 140100),
(140101, '3.30.2350.10-FF-000082', NULL, 'tRNA pseudouridine synthase B', 231, NULL, NULL, 140101),
(140102, '2.60.40.1110-FF-000011', NULL, 'Phosphatidylinositol 3,4,5-trisphosphate 3-phosphatase and dual-specificity protein phosphatase PTEN', 131, NULL, NULL, 140102),
(140103, '1.10.287.1130-FF-000013', NULL, 'Uncharacterized protein', 49, NULL, NULL, 140103);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(140104, '2.60.40.10-FF-004764', NULL, NULL, 97, NULL, NULL, 140104),
(140105, '3.40.350.10-FF-000040', NULL, 'Cytoplasmic protein', 167, NULL, NULL, 140105),
(140106, '3.30.930.10-FF-000379', NULL, 'Uncharacterized protein', 108, NULL, NULL, 140106),
(140107, '3.30.565.10-FF-000327', NULL, 'Sensor histidine kinase', 168, NULL, NULL, 140107),
(140108, '2.20.25.20-FF-000001', NULL, 'Casein kinase II subunit beta', 72, NULL, NULL, 140108),
(140109, '1.25.10.10-FF-003047', NULL, 'Transportin MOS14', 285, NULL, NULL, 140109),
(140110, '3.30.479.20-FF-000001', NULL, 'Elongation factor Ts', 86, NULL, NULL, 140110),
(140111, '3.40.50.620-FF-000515', NULL, 'Valine--tRNA ligase', 272, NULL, NULL, 140111),
(140112, '3.30.160.60-FF-002184', NULL, 'Zinc finger protein 668', 25, NULL, NULL, 140112),
(140113, '1.10.1870.10-FF-000003', NULL, 'Lysine-ketoglutarate reductase/saccharopine dehydrogenase1', 110, NULL, NULL, 140113),
(140114, '3.90.1200.10-FF-000068', NULL, 'Fructosamine-3-kinase', 196, NULL, NULL, 140114),
(140115, '2.30.110.10-FF-000068', NULL, 'Blr4240 protein', 137, NULL, NULL, 140115),
(140116, '4.10.1130.10-FF-000001', NULL, NULL, 67, NULL, NULL, 140116),
(140117, '3.10.110.10-FF-000181', NULL, 'Uncharacterized protein', 149, NULL, NULL, 140117),
(140118, '1.20.1730.10-FF-000103', NULL, 'Uncharacterized protein', 219, NULL, NULL, 140118),
(140119, '2.10.25.10-FF-000768', NULL, 'Cadherin-related tumor suppressor', 64, NULL, NULL, 140119),
(140120, '1.25.10.10-FF-000321', NULL, 'Condensin complex subunit 1', 248, NULL, NULL, 140120),
(140121, '1.25.40.10-FF-003936', NULL, 'Predicted protein', 378, NULL, NULL, 140121),
(140122, '3.30.160.60-FF-000498', NULL, 'Putative zinc finger protein 131', 29, NULL, NULL, 140122),
(140123, '2.130.10.10-FF-000812', NULL, 'Plexin B2a', 477, NULL, NULL, 140123),
(140124, '3.40.50.300-FF-002555', NULL, 'Membrane-associated sulfotransferase kil1', 307, NULL, NULL, 140124),
(140125, '3.40.50.1820-FF-000144', NULL, 'Ndr family protein', 286, NULL, NULL, 140125),
(140126, '3.40.50.620-FF-000263', NULL, 'Asparagine synthetase', 294, NULL, NULL, 140126),
(140127, '1.10.20.10-FF-000175', NULL, 'Uncharacterized protein', 68, NULL, NULL, 140127),
(140128, '2.60.40.10-FF-004180', NULL, NULL, 85, NULL, NULL, 140128),
(140129, '3.30.420.40-FF-000411', NULL, 'RNA polymerase II transcription factor', 195, NULL, NULL, 140129),
(140130, '3.80.10.10-FF-004253', NULL, 'Relaxin family peptide receptor 1', 70, NULL, NULL, 140130),
(140131, '3.30.420.40-FF-000091', NULL, 'Anhydro-N-acetylmuramic acid kinase', 173, NULL, NULL, 140131),
(140132, '3.80.20.20-FF-000013', NULL, 'Erb-b2 receptor tyrosine kinase 3a', 197, NULL, NULL, 140132),
(140133, '3.40.50.300-FF-006400', NULL, 'Uncharacterized protein', 133, NULL, NULL, 140133),
(140134, '3.30.40.10-FF-001289', NULL, 'Uncharacterized protein', 60, NULL, NULL, 140134),
(140135, '1.10.510.10-FF-000011', NULL, 'Non-specific serine/threonine protein kinase', 199, NULL, NULL, 140135),
(140136, '3.90.70.10-FF-000698', NULL, 'Uncharacterized protein', 222, NULL, NULL, 140136),
(140137, '2.30.29.70-FF-000018', NULL, 'Uncharacterized protein C342.04', 115, NULL, NULL, 140137),
(140138, '2.60.40.2130-FF-000008', NULL, 'Uncharacterized protein', 198, NULL, NULL, 140138),
(140139, '1.25.40.10-FF-003684', NULL, 'Uncharacterized protein', 214, NULL, NULL, 140139),
(140140, '3.90.1150.10-FF-000316', NULL, 'Neamine transaminase BtrB', 105, NULL, NULL, 140140),
(140141, '2.60.40.60-FF-000001', NULL, 'Protocadherin alpha 2', 109, NULL, NULL, 140141),
(140142, '1.10.510.10-FF-000466', NULL, 'MAP kinase kinase kinase18', 305, NULL, NULL, 140142),
(140143, '2.40.50.140-FF-001269', NULL, NULL, 99, NULL, NULL, 140143),
(140144, '3.40.50.300-FF-005989', NULL, 'Katanin p60 ATPase-containing subunit A-like 2', 181, NULL, NULL, 140144),
(140145, '3.30.160.60-FF-004393', NULL, NULL, 70, NULL, NULL, 140145),
(140146, '1.10.246.60-FF-000018', NULL, NULL, 77, NULL, NULL, 140146),
(140147, '2.10.70.10-FF-000209', NULL, 'Complement regulatory membrane protein', 61, NULL, NULL, 140147);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(140148, '1.10.1000.11-FF-000012', NULL, 'BRag/Iqsec/Schizo related Arf GEF family member', 132, NULL, NULL, 140148),
(140149, '3.40.50.300-FF-003983', NULL, 'Putative replicative DNA helicase', 285, NULL, NULL, 140149),
(140150, '3.40.50.12610-FF-000002', NULL, 'dolichyl-diphosphooligosaccharide--protein glycosyltransferase subunit STT3A', 151, NULL, NULL, 140150),
(140151, '3.40.630.10-FF-000213', NULL, 'Succinyl-diaminopimelate desuccinylase', 240, NULL, NULL, 140151),
(140152, '1.20.120.430-FF-000025', NULL, 'tRNA modification GTPase MnmE', 160, NULL, NULL, 140152),
(140153, '1.25.10.10-FF-001602', NULL, 'Kinesin associated protein kap-1', 541, NULL, NULL, 140153),
(140154, '3.40.630.30-FF-000219', NULL, 'Nat4p', 190, NULL, NULL, 140154),
(140155, '3.80.10.10-FF-001274', NULL, 'Uncharacterized protein', 119, NULL, NULL, 140155),
(140156, '1.25.10.10-FF-002928', NULL, 'TORTIFOLIA1-like protein 5', 98, NULL, NULL, 140156),
(140157, '3.30.420.40-FF-000309', NULL, 'Mitochondrial type HSP70, putative', 50, NULL, NULL, 140157),
(140158, '2.40.70.10-FF-000377', NULL, NULL, 198, NULL, NULL, 140158),
(140159, '2.120.10.30-FF-000414', NULL, 'Uncharacterized protein', 184, NULL, NULL, 140159),
(140160, '3.30.70.2520-FF-000002', NULL, 'FAD-linked oxidoreductase', 92, NULL, NULL, 140160),
(140161, '2.60.120.650-FF-000076', NULL, 'Lysine-specific demethylase 6A isoform 1', 43, NULL, NULL, 140161),
(140162, '1.10.10.10-FF-001630', NULL, 'Protein CBG20282', 94, NULL, NULL, 140162),
(140163, '1.10.8.60-FF-000391', NULL, 'YALI0C00671p', 76, NULL, NULL, 140163),
(140164, '1.10.8.60-FF-000492', NULL, 'ATPase, AAA superfamily', 90, NULL, NULL, 140164),
(140165, '2.120.10.30-FF-000459', NULL, 'Predicted protein', 87, NULL, NULL, 140165),
(140166, '3.40.50.2300-FF-001266', NULL, NULL, 208, NULL, NULL, 140166),
(140167, '3.40.50.1220-FF-000060', NULL, '2-succinyl-5-enolpyruvyl-6-hydroxy-3-cyclohexene-1-carboxylate synthase', 121, NULL, NULL, 140167),
(140168, '3.40.50.1000-FF-000802', NULL, NULL, 146, NULL, NULL, 140168),
(140169, '4.10.60.10-FF-000131', NULL, 'ATP-dependent DNA helicase PIF1', 35, NULL, NULL, 140169),
(140170, '3.40.970.10-FF-000008', NULL, NULL, 48, NULL, NULL, 140170),
(140171, '1.10.10.10-FF-001675', NULL, 'Uncharacterized protein', 133, NULL, NULL, 140171),
(140172, '1.20.1310.20-FF-000001', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 196, NULL, NULL, 140172),
(140173, '3.40.50.300-FF-005883', NULL, 'DNA helicase', 143, NULL, NULL, 140173),
(140174, '3.30.1130.10-FF-000014', NULL, 'Folic acid synthesis protein fol1', 129, NULL, NULL, 140174),
(140175, '1.10.10.10-FF-000039', NULL, 'Friend leukemia integration 1 transcription factor', 127, NULL, NULL, 140175),
(140176, '3.40.50.720-FF-001939', NULL, 'Uncharacterized protein', 277, NULL, NULL, 140176),
(140177, '3.10.129.10-FF-000010', NULL, 'Cytosolic acyl coenzyme A thioester hydrolase', 159, NULL, NULL, 140177),
(140178, '2.20.25.90-FF-000010', NULL, 'NADH-ubiquinone oxidoreductase-G iron-sulfur binding region', 54, NULL, NULL, 140178),
(140179, '2.130.10.10-FF-004202', NULL, 'Uncharacterized protein', 157, NULL, NULL, 140179),
(140180, '3.40.1350.10-FF-000028', NULL, 'tRNA-splicing endonuclease subunit Sen34', 89, NULL, NULL, 140180),
(140181, '2.40.30.10-FF-000464', NULL, 'Elongation factor SelB', 92, NULL, NULL, 140181),
(140182, '3.30.160.60-FF-001015', NULL, 'Zinc finger protein 142', 26, NULL, NULL, 140182),
(140183, '1.10.10.480-FF-000007', NULL, 'Diphosphate-fructose-6-phosphate 1-phosphotransferase', 73, NULL, NULL, 140183),
(140184, '3.50.50.60-FF-000764', NULL, 'D-amino acid dehydrogenase', 80, NULL, NULL, 140184),
(140185, '1.10.510.10-FF-000730', NULL, 'Protein serine/threonine kinase-1', 243, NULL, NULL, 140185),
(140186, '1.25.40.180-FF-000032', NULL, 'Nucleolar MIF4G domain-containing protein 1', 272, NULL, NULL, 140186),
(140187, '1.20.120.1750-FF-000006', NULL, 'RBR-type E3 ubiquitin transferase', 68, NULL, NULL, 140187),
(140188, '1.10.510.10-FF-000275', NULL, 'SRSF protein kinase 2 isoform X3', 280, NULL, NULL, 140188);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(140189, '1.20.1050.50-FF-000001', NULL, 'Ammonia monooxygenase/methane monooxygenase, subunit C family protein', 245, NULL, NULL, 140189),
(140190, '3.30.160.20-FF-000143', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 2', 87, NULL, NULL, 140190),
(140191, '3.40.50.10810-FF-000159', NULL, 'Predicted protein', 142, NULL, NULL, 140191),
(140192, '1.20.5.170-FF-000050', NULL, 'E3 ubiquitin-protein ligase RNF8', 53, NULL, NULL, 140192),
(140193, '1.20.140.40-FF-000045', NULL, 'Pectinesterase', 155, NULL, NULL, 140193),
(140194, '1.20.1280.50-FF-000001', NULL, 'F-box/WD repeat-containing protein 11 isoform X2', 106, NULL, NULL, 140194),
(140195, '1.10.510.10-FF-002720', NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', 296, NULL, NULL, 140195),
(140196, '2.60.40.770-FF-000024', NULL, 'Predicted protein', 98, NULL, NULL, 140196),
(140197, '3.30.40.10-FF-000255', NULL, 'Bromodomain adjacent to zinc finger domain protein 2A', 84, NULL, NULL, 140197),
(140198, '3.40.50.720-FF-001164', NULL, 'Shikimate biosynthesis protein AroDE', 123, NULL, NULL, 140198),
(140199, '3.40.50.2000-FF-000541', NULL, 'Uncharacterized protein', 254, NULL, NULL, 140199),
(140200, '3.30.1370.20-FF-000001', NULL, 'Quinone-dependent D-lactate dehydrogenase', 85, NULL, NULL, 140200),
(140201, '2.60.120.1540-FF-000011', NULL, 'Thioester-containing protein 2, isoform G', 94, NULL, NULL, 140201),
(140202, '3.80.10.10-FF-003848', NULL, 'Uncharacterized protein', 136, NULL, NULL, 140202),
(140203, '3.10.20.230-FF-000028', NULL, 'Predicted protein', 88, NULL, NULL, 140203),
(140204, '2.30.30.30-FF-000038', NULL, 'Translation initiation factor 5A', 69, NULL, NULL, 140204),
(140205, '3.20.20.100-FF-000066', NULL, 'Aldo/keto reductase', 307, NULL, NULL, 140205),
(140206, '2.30.42.10-FF-000149', NULL, 'Periaxin', 87, NULL, NULL, 140206),
(140207, '2.60.40.60-FF-000501', NULL, 'Desmocollin 2-like', 77, NULL, NULL, 140207),
(140208, '1.25.40.10-FF-004864', NULL, 'Predicted protein', 139, NULL, NULL, 140208),
(140209, '1.20.5.340-FF-000123', NULL, 'Stromal interaction molecule 1', 71, NULL, NULL, 140209),
(140210, '2.70.170.10-FF-000118', NULL, 'AGAP010057-PA', 223, NULL, NULL, 140210),
(140211, '3.90.1420.10-FF-000051', NULL, 'Os01g0976450 protein', 111, NULL, NULL, 140211),
(140212, '2.120.10.30-FF-000561', NULL, 'Uncharacterized protein', 69, NULL, NULL, 140212),
(140213, '2.60.210.10-FF-000018', NULL, 'MATH_domain_containing_protein', 137, NULL, NULL, 140213),
(140214, '1.10.287.110-FF-000167', NULL, 'TPR-repeat-containing chaperone protein DNAJ', 105, NULL, NULL, 140214),
(140215, '3.30.1490.180-FF-000021', NULL, 'DNA-directed RNA polymerase subunit', 60, NULL, NULL, 140215),
(140216, '2.60.34.10-FF-000017', NULL, 'Heat shock 70 kDa protein 17', 147, NULL, NULL, 140216),
(140217, '3.90.190.10-FF-000600', NULL, 'Predicted protein', 276, NULL, NULL, 140217),
(140218, '3.40.50.300-FF-005208', NULL, 'RAD57 protein, putative', 306, NULL, NULL, 140218),
(140219, '3.40.50.10130-FF-000039', NULL, 'DNA excision repair protein ERCC-1-like Protein', 62, NULL, NULL, 140219),
(140220, '2.60.40.420-FF-000256', NULL, 'Uncharacterized protein', 99, NULL, NULL, 140220),
(140221, '1.10.10.10-FF-000450', NULL, 'Heat-inducible transcription repressor HrcA', 88, NULL, NULL, 140221),
(140222, '3.30.497.10-FF-000175', NULL, 'Uncharacterized protein', 190, NULL, NULL, 140222),
(140223, '2.30.30.60-FF-000007', NULL, 'Mechanosensitive ion channel domain-containing protein', 49, NULL, NULL, 140223),
(140224, '3.40.390.10-FF-000014', NULL, 'disintegrin and metalloproteinase domain-containing protein 11', 206, NULL, NULL, 140224),
(140225, '3.40.140.70-FF-000008', NULL, 'ubiquitin-like modifier-activating enzyme ATG7', 163, NULL, NULL, 140225),
(140226, '3.60.21.10-FF-000412', NULL, 'Uncharacterized protein', 286, NULL, NULL, 140226),
(140227, '1.10.132.10-FF-000008', NULL, 'DNA topoisomerase I', 139, NULL, NULL, 140227),
(140228, '3.30.70.330-FF-001727', NULL, NULL, 105, NULL, NULL, 140228),
(140229, '3.30.750.24-FF-000159', NULL, 'Uncharacterized protein', 110, NULL, NULL, 140229);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(140230, '2.115.10.20-FF-000014', NULL, 'Sucrose-6-phosphate hydrolase', 349, NULL, NULL, 140230),
(140231, '2.60.40.10-FF-002656', NULL, 'Uncharacterized protein, isoform A', 98, NULL, NULL, 140231),
(140232, '3.30.559.10-FF-000044', NULL, 'Phenolpthiocerol synthesis type-I polyketide synthase ppsE', 175, NULL, NULL, 140232),
(140233, '3.40.50.10050-FF-000004', NULL, 'Translation initiation factor if-2', 109, NULL, NULL, 140233),
(140234, '1.10.1670.10-FF-000038', NULL, NULL, 91, NULL, NULL, 140234),
(140235, '3.10.100.10-FF-000158', NULL, 'Uncharacterized protein', 134, NULL, NULL, 140235),
(140236, '3.40.50.300-FF-000846', NULL, 'ATPase family AAA domain-containing protein 5', 163, NULL, NULL, 140236),
(140237, '3.10.20.90-FF-000863', NULL, 'Uncharacterized protein', 73, NULL, NULL, 140237),
(140238, '3.40.50.620-FF-000307', NULL, 'FAD synthetase 1, chloroplastic', 191, NULL, NULL, 140238),
(140239, '3.40.47.10-FF-000091', NULL, 'Probable polyketide synthase 32', 508, NULL, NULL, 140239),
(140240, '2.60.40.10-FF-000138', NULL, 'filamin-B isoform X1', 74, NULL, NULL, 140240),
(140241, '3.40.30.10-FF-000996', NULL, 'Os06g0659500 protein', 76, NULL, NULL, 140241),
(140242, '4.10.240.10-FF-000102', NULL, 'C6 transcription factor, putative', 62, NULL, NULL, 140242),
(140243, '2.130.10.10-FF-001740', NULL, 'Anaphase-promoting complex subunit 4', 215, NULL, NULL, 140243),
(140244, '3.40.33.10-FF-000002', NULL, 'Golgi-associated plant pathogenesis-related protein 1', 148, NULL, NULL, 140244),
(140245, '3.40.50.2300-FF-000440', NULL, 'Response regulator receiver domain protein', 130, NULL, NULL, 140245),
(140246, '3.40.50.720-FF-002344', NULL, 'Oxidoreductase domain protein', 123, NULL, NULL, 140246),
(140247, '3.40.50.960-FF-000016', NULL, '6,7-dimethyl-8-ribityllumazine synthase', 149, NULL, NULL, 140247),
(140248, '2.60.40.10-FF-001228', NULL, 'Fibronectin type III domain containing 1', 96, NULL, NULL, 140248),
(140249, '3.40.1110.10-FF-000134', NULL, 'Cation transporting ATPase', 245, NULL, NULL, 140249),
(140250, '1.10.510.10-FF-002175', NULL, 'Guanylate cyclase', 265, NULL, NULL, 140250),
(140251, '3.90.1150.10-FF-000524', NULL, 'Uncharacterized protein', 51, NULL, NULL, 140251),
(140252, '3.40.50.1470-FF-000005', NULL, 'Peptidyl-tRNA hydrolase', 195, NULL, NULL, 140252),
(140253, '3.40.50.1820-FF-000352', NULL, 'Conserved hypothetical membrane protein', 277, NULL, NULL, 140253),
(140254, '3.30.230.10-FF-000360', NULL, 'Ribonuclease P protein component', 116, NULL, NULL, 140254),
(140255, '1.10.10.10-FF-000141', NULL, 'vacuolar protein-sorting-associated protein 25', 78, NULL, NULL, 140255),
(140256, '3.30.160.60-FF-004758', NULL, NULL, 42, NULL, NULL, 140256),
(140257, '3.40.1280.10-FF-000056', NULL, 'Ribosomal RNA small subunit methyltransferase E', 154, NULL, NULL, 140257),
(140258, '1.20.1070.10-FF-001648', NULL, 'Uncharacterized protein', 134, NULL, NULL, 140258),
(140259, '3.40.367.20-FF-000003', NULL, 'Phosphotransferase', 257, NULL, NULL, 140259),
(140260, '1.20.5.540-FF-000003', NULL, 'Acetyltransferase Atu2258', 31, NULL, NULL, 140260),
(140261, '2.60.200.20-FF-000245', NULL, 'Uncharacterized protein', 129, NULL, NULL, 140261),
(140262, '3.30.420.380-FF-000001', NULL, 'DNA utilization protein HofM', 187, NULL, NULL, 140262),
(140263, '2.130.10.30-FF-000009', NULL, 'Regulator of chromosome condensation 2', 195, NULL, NULL, 140263),
(140264, '3.40.718.10-FF-000035', NULL, 'Isocitrate dehydrogenase 3 (NAD+) alpha', 109, NULL, NULL, 140264),
(140265, '2.130.10.10-FF-002257', NULL, 'Uncharacterized protein', 323, NULL, NULL, 140265),
(140266, '1.10.287.2900-FF-000016', NULL, 'Uncharacterized protein', 50, NULL, NULL, 140266),
(140267, '3.40.50.1580-FF-000032', NULL, 'Purine nucleoside phosphorylase lateral transfer candidate', 122, NULL, NULL, 140267),
(140268, '3.30.40.10-FF-001744', NULL, 'Uncharacterized protein', 139, NULL, NULL, 140268),
(140269, '1.10.287.4070-FF-000007', NULL, 'Putative trans-splicing factor', 141, NULL, NULL, 140269),
(140270, '1.25.40.10-FF-003583', NULL, 'Heat shock 70kD protein binding protein', 168, NULL, NULL, 140270);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(140271, '2.30.29.30-FF-000849', NULL, 'Uncharacterized protein', 73, NULL, NULL, 140271),
(140272, '2.60.40.60-FF-001120', NULL, 'Predicted protein', 87, NULL, NULL, 140272),
(140273, '1.25.40.10-FF-004201', NULL, 'Predicted protein', 71, NULL, NULL, 140273),
(140274, '2.30.42.10-FF-000104', NULL, 'harmonin isoform X2', 125, NULL, NULL, 140274),
(140275, '3.40.50.2000-FF-001058', NULL, 'Predicted protein', 109, NULL, NULL, 140275),
(140276, '2.40.10.10-FF-000137', NULL, 'GD22965', 241, NULL, NULL, 140276),
(140277, '3.30.60.20-FF-000012', NULL, 'Protein kinase C', 68, NULL, NULL, 140277),
(140278, '3.50.50.60-FF-000101', NULL, 'lycopene epsilon cyclase, chloroplastic', 342, NULL, NULL, 140278),
(140279, '3.90.70.10-FF-000592', NULL, 'Uncharacterized protein', 211, NULL, NULL, 140279),
(140280, '3.30.160.60-FF-003010', NULL, NULL, 29, NULL, NULL, 140280),
(140281, '4.10.1000.10-FF-000109', NULL, 'Zinc finger C-x8-C-x5-C-x3-H type family protein', 61, NULL, NULL, 140281),
(140282, '3.60.15.10-FF-000027', NULL, 'DNA ligase 6', 163, NULL, NULL, 140282),
(140283, '3.90.1410.10-FF-000123', NULL, 'Uncharacterized protein', 119, NULL, NULL, 140283),
(140284, '3.40.50.1000-FF-000550', NULL, NULL, 188, NULL, NULL, 140284),
(140285, '3.40.50.1820-FF-001324', NULL, 'Predicted protein', 258, NULL, NULL, 140285),
(140286, '1.10.287.70-FF-000548', NULL, 'Uncharacterized protein', 120, NULL, NULL, 140286),
(140287, '3.40.50.1100-FF-000170', NULL, 'Uncharacterized protein', 111, NULL, NULL, 140287),
(140288, '3.30.470.20-FF-000144', NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', 137, NULL, NULL, 140288),
(140289, '1.50.10.20-FF-000114', NULL, 'Geranylgeranyl transferase type-2 subunit beta', 167, NULL, NULL, 140289),
(140290, '3.30.160.60-FF-002605', NULL, 'Zinc finger protein 45', 24, NULL, NULL, 140290),
(140291, '3.30.1360.70-FF-000026', NULL, NULL, 118, NULL, NULL, 140291),
(140292, '3.30.160.60-FF-004449', NULL, NULL, 51, NULL, NULL, 140292),
(140293, '2.70.98.10-FF-000107', NULL, 'Aldose 1-epimerase', 336, NULL, NULL, 140293),
(140294, '3.40.640.10-FF-000450', NULL, 'Uncharacterized protein', 34, NULL, NULL, 140294),
(140295, '2.10.25.10-FF-001173', NULL, 'Usherin', 49, NULL, NULL, 140295),
(140296, '3.40.190.10-FF-000617', NULL, 'Hydroxymethylbilane synthase', 105, NULL, NULL, 140296),
(140297, '2.40.50.140-FF-000651', NULL, 'Related to 30S ribosomal protein S17', 111, NULL, NULL, 140297),
(140298, '3.30.40.10-FF-001891', NULL, 'Predicted protein', 112, NULL, NULL, 140298),
(140299, '2.60.40.10-FF-000402', NULL, 'Protein tyrosine kinase 7 (inactive)', 88, NULL, NULL, 140299),
(140300, '3.30.565.10-FF-000221', NULL, 'Histidine kinase', 132, NULL, NULL, 140300),
(140301, '2.130.10.10-FF-002920', NULL, 'Uncharacterized WD repeat-containing protein C4F8.11', 243, NULL, NULL, 140301),
(140302, '3.40.50.12240-FF-000003', NULL, 'V-type proton ATPase subunit B', 455, NULL, NULL, 140302),
(140303, '3.30.200.20-FF-000422', NULL, 'Receptor protein-tyrosine kinase', 130, NULL, NULL, 140303),
(140304, '3.30.720.50-FF-000021', NULL, NULL, 82, NULL, NULL, 140304),
(140305, '3.90.70.10-FF-000226', NULL, 'Aminopeptidase', 377, NULL, NULL, 140305),
(140306, '1.25.40.10-FF-001430', NULL, 'Os01g0800400 protein', 140, NULL, NULL, 140306),
(140307, '1.20.1070.10-FF-001491', NULL, 'Uncharacterized protein', 201, NULL, NULL, 140307),
(140308, '3.90.228.20-FF-000023', NULL, NULL, 82, NULL, NULL, 140308),
(140309, '3.20.20.70-FF-000761', NULL, NULL, 55, NULL, NULL, 140309),
(140310, '1.20.1250.20-FF-001603', NULL, 'Sucrose transporter 1', 229, NULL, NULL, 140310),
(140311, '2.10.25.10-FF-001482', NULL, 'slit homolog 2 protein isoform X1', 38, NULL, NULL, 140311),
(140312, '2.40.160.120-FF-000047', NULL, 'Oxysterol-binding protein-related protein 3C', 59, NULL, NULL, 140312),
(140313, '1.25.40.10-FF-002964', NULL, 'Uncharacterized protein', 348, NULL, NULL, 140313),
(140314, '3.40.50.300-FF-006136', NULL, 'Citrate synthase', 85, NULL, NULL, 140314),
(140315, '3.40.50.12670-FF-000014', NULL, 'Carboxypeptidase', 129, NULL, NULL, 140315);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(140316, '3.40.50.11260-FF-000018', NULL, 'Molecular chaperone/ Grp94/Hsp90', 131, NULL, NULL, 140316),
(140317, '2.60.40.150-FF-000046', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', 166, NULL, NULL, 140317),
(140318, '1.20.920.20-FF-000009', NULL, 'Putative dynein heavy chain', 363, NULL, NULL, 140318),
(140319, '3.40.50.10260-FF-000027', NULL, 'Multifunctional fusion protein', 218, NULL, NULL, 140319),
(140320, '2.30.42.10-FF-000560', NULL, NULL, 52, NULL, NULL, 140320),
(140321, '2.130.10.10-FF-000150', NULL, 'Dmx-like 2, isoform CRA_c', 279, NULL, NULL, 140321),
(140322, '1.10.600.10-FF-000041', NULL, 'Geranylgeranyl pyrophosphate synthase, putative', 375, NULL, NULL, 140322),
(140323, '2.70.130.10-FF-000088', NULL, NULL, 144, NULL, NULL, 140323),
(140324, '3.30.450.40-FF-000137', NULL, 'Sensory transduction histidine kinase', 153, NULL, NULL, 140324),
(140325, '1.25.40.10-FF-000047', NULL, 'SMG5, nonsense mediated mRNA decay factor', 205, NULL, NULL, 140325),
(140326, '2.120.10.60-FF-000002', NULL, 'Tricorn protease homolog', 271, NULL, NULL, 140326),
(140327, '3.40.50.300-FF-003410', NULL, 'Uncharacterized protein', 171, NULL, NULL, 140327),
(140328, '1.20.5.110-FF-000301', NULL, 'Uncharacterized protein', 65, NULL, NULL, 140328),
(140329, '1.10.472.10-FF-000169', NULL, 'CTD kinase subunit beta', 95, NULL, NULL, 140329),
(140330, '3.30.230.10-FF-000258', NULL, 'Uncharacterized protein', 209, NULL, NULL, 140330),
(140331, '2.40.70.10-FF-000068', NULL, 'Aspartic-type endopeptidase (OpsB)', 187, NULL, NULL, 140331),
(140332, '1.20.1560.10-FF-000275', NULL, 'ATP-binding cassette, subfamily B', 324, NULL, NULL, 140332),
(140333, '3.40.50.150-FF-000779', NULL, 'Methyltransferase, putative', 301, NULL, NULL, 140333),
(140334, '2.40.50.140-FF-000549', NULL, '26S protease regulatory subunit 6B', 116, NULL, NULL, 140334),
(140335, '3.40.50.1000-FF-000241', NULL, 'alpha,alpha-trehalose-phosphate synthase [UDP-forming] 1 isoform X3', 141, NULL, NULL, 140335),
(140336, '2.30.42.10-FF-000251', NULL, 'Shroom family member 2', 54, NULL, NULL, 140336),
(140337, '3.90.950.20-FF-000004', NULL, 'CinA-like protein', 159, NULL, NULL, 140337),
(140338, '1.25.40.820-FF-000033', NULL, 'Uncharacterized protein', 138, NULL, NULL, 140338),
(140339, '2.60.40.340-FF-000013', NULL, NULL, 115, NULL, NULL, 140339),
(140340, '2.60.40.10-FF-005270', NULL, NULL, 86, NULL, NULL, 140340),
(140341, '1.10.287.70-FF-000172', NULL, 'Glutamate receptor', 139, NULL, NULL, 140341),
(140342, '3.40.50.980-FF-000027', NULL, 'Peptide synthetase', 175, NULL, NULL, 140342),
(140343, '3.30.160.60-FF-001987', NULL, 'Transcription factor SFP1', 62, NULL, NULL, 140343),
(140344, '3.40.720.10-FF-000052', NULL, 'Phosphatidylglycerol specific phospholipase, putative', 228, NULL, NULL, 140344),
(140345, '2.60.200.20-FF-000026', NULL, 'Aprataxin and PNKP like factor', 102, NULL, NULL, 140345),
(140346, '1.10.220.100-FF-000007', NULL, 'WD40, G-beta domain containing family protein, family', 50, NULL, NULL, 140346),
(140347, '1.10.8.10-FF-000027', NULL, 'Trinucleotide repeat-containing gene 6C protein', 66, NULL, NULL, 140347),
(140348, '1.20.120.350-FF-000035', NULL, 'Calcium-activated potassium channel slowpoke', 118, NULL, NULL, 140348),
(140349, '1.20.140.150-FF-000075', NULL, 'STarGazin (Mammalian calcium channel) homolog', 226, NULL, NULL, 140349),
(140350, '2.160.20.10-FF-000256', NULL, 'Uncharacterized protein', 76, NULL, NULL, 140350),
(140351, '3.30.559.70-FF-000056', NULL, 'Zgc:154046', 107, NULL, NULL, 140351),
(140352, '3.40.50.300-FF-001465', NULL, 'ABC multidrug transporter (Eurofung)', 242, NULL, NULL, 140352),
(140353, '3.30.720.210-FF-000007', NULL, 'ATP-dependent zinc metalloprotease FtsH', 79, NULL, NULL, 140353),
(140354, '1.10.510.10-FF-003900', NULL, NULL, 84, NULL, NULL, 140354),
(140355, '1.10.3720.10-FF-000167', NULL, 'Maltose/maltodextrin ABC transporter, permease protein MalG', 76, NULL, NULL, 140355),
(140356, '3.40.50.720-FF-001725', NULL, 'Aspartate-semialdehyde dehydrogenase', 167, NULL, NULL, 140356);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(140357, '2.60.120.560-FF-000037', NULL, 'Uncharacterized protein', 119, NULL, NULL, 140357),
(140358, '1.25.40.10-FF-002256', NULL, 'protein SLOW GREEN 1, chloroplastic', 134, NULL, NULL, 140358),
(140359, '2.60.120.10-FF-000354', NULL, 'Sodium/hydrogen exchanger 10-like Protein', 139, NULL, NULL, 140359),
(140360, '1.10.1200.20-FF-000001', NULL, 'Colicin-E9 immunity protein', 87, NULL, NULL, 140360),
(140361, '3.40.309.10-FF-000063', NULL, 'Aldehyde dehydrogenase family protein', 189, NULL, NULL, 140361),
(140362, '1.20.1640.10-FF-000028', NULL, 'PaTched Related family', 214, NULL, NULL, 140362),
(140363, '3.40.50.880-FF-000115', NULL, 'AraC family transcriptional regulator', 198, NULL, NULL, 140363),
(140364, '1.10.442.10-FF-000004', NULL, 'COX4I1 isoform 13', 61, NULL, NULL, 140364),
(140365, '3.90.470.20-FF-000069', NULL, 'L-aminoadipate-semialdehyde dehydrogenase-phosphopantetheinyl transferase', 121, NULL, NULL, 140365),
(140366, '3.40.50.300-FF-004719', NULL, 'Uncharacterized protein', 244, NULL, NULL, 140366),
(140367, '3.40.800.10-FF-000036', NULL, 'Agmatinase, putative', 310, NULL, NULL, 140367),
(140368, '2.60.40.60-FF-000456', NULL, 'Cadherin 3', 107, NULL, NULL, 140368),
(140369, '1.25.40.620-FF-000001', NULL, 'Tetrapyrrole-binding protein, chloroplastic', 132, NULL, NULL, 140369),
(140370, '2.40.30.160-FF-000006', NULL, 'Protein CBG14872', 108, NULL, NULL, 140370),
(140371, '2.10.70.10-FF-000283', NULL, 'Uncharacterized protein', 60, NULL, NULL, 140371),
(140372, '3.40.390.10-FF-000037', NULL, 'Metalloendopeptidase', 232, NULL, NULL, 140372),
(140373, '2.60.40.2970-FF-000001', NULL, 'Neutral protease 2', 139, NULL, NULL, 140373),
(140374, '2.40.100.10-FF-000003', NULL, 'Peptidylprolyl isomerase domain and WD repeat-containing 1', 172, NULL, NULL, 140374),
(140375, '3.90.1200.10-FF-000085', NULL, 'Putative choline kinase', 280, NULL, NULL, 140375),
(140376, '3.30.565.10-FF-000474', NULL, 'Uncharacterized protein', 115, NULL, NULL, 140376),
(140377, '1.25.10.10-FF-000866', NULL, 'Uncharacterized protein', 435, NULL, NULL, 140377),
(140378, '3.40.47.10-FF-000208', NULL, NULL, 196, NULL, NULL, 140378),
(140379, '3.40.30.10-FF-000102', NULL, 'Glutathione S-transferase DHAR3 chloroplastic', 89, NULL, NULL, 140379),
(140380, '3.10.490.20-FF-000026', NULL, 'Putative dynein heavy chain, cytosolic', 162, NULL, NULL, 140380),
(140381, '1.25.40.20-FF-000270', NULL, 'Transient receptor potential cation channel subfamily V member 6', 214, NULL, NULL, 140381),
(140382, '3.80.10.10-FF-001583', NULL, 'Leucine-rich repeat family protein isoform 1', 75, NULL, NULL, 140382),
(140383, '2.60.40.770-FF-000001', NULL, 'NPC intracellular cholesterol transporter 2', 130, NULL, NULL, 140383),
(140384, '2.40.50.140-FF-000313', NULL, 'ATP-dependent DNA helicase RecG', 94, NULL, NULL, 140384),
(140385, '1.10.1420.10-FF-000099', NULL, 'DNA mismatch repair protein', 216, NULL, NULL, 140385),
(140386, '1.20.1250.20-FF-001058', NULL, 'MFS transporter', 196, NULL, NULL, 140386),
(140387, '1.10.20.10-FF-000192', NULL, NULL, 124, NULL, NULL, 140387),
(140388, '2.120.10.100-FF-000004', NULL, 'ATP diphosphohydrolase apyrase, putative', 224, NULL, NULL, 140388),
(140389, '2.40.128.330-FF-000006', NULL, 'Metal ion channel-Mg2+, Co2+ and Ni2', 93, NULL, NULL, 140389),
(140390, '3.90.70.10-FF-000889', NULL, 'Uncharacterized protein', 217, NULL, NULL, 140390),
(140391, '3.80.10.10-FF-003191', NULL, 'Uncharacterized protein', 232, NULL, NULL, 140391),
(140392, '2.60.40.1190-FF-000001', NULL, 'Heme binding protein', 201, NULL, NULL, 140392),
(140393, '3.30.200.20-FF-000653', NULL, 'L-type lectin-domain containing receptor kinase S.4', 105, NULL, NULL, 140393),
(140394, '2.60.40.1400-FF-000014', NULL, NULL, 62, NULL, NULL, 140394),
(140395, '1.20.1250.20-FF-000069', NULL, 'Solute carrier family 45 member 4', 239, NULL, NULL, 140395),
(140396, '3.30.200.20-FF-000214', NULL, 'WAK1-OsWAK receptor-like cytoplasmic kinase (OsWAK-RLCK)', 105, NULL, NULL, 140396),
(140397, '3.40.50.1820-FF-001425', NULL, 'Uncharacterized protein', 197, NULL, NULL, 140397);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(140398, '3.60.15.10-FF-000105', NULL, 'Ribonuclease Z', 292, NULL, NULL, 140398),
(140399, '1.20.5.290-FF-000001', NULL, 'Cardiac phospholamban', 52, NULL, NULL, 140399),
(140400, '3.30.9.90-FF-000009', NULL, 'Uncharacterized protein', 33, NULL, NULL, 140400),
(140401, '3.80.10.10-FF-001055', NULL, 'OSJNBb0076A22.12 protein', 124, NULL, NULL, 140401),
(140402, '2.30.30.140-FF-000284', NULL, 'Non-specific serine/threonine protein kinase', 92, NULL, NULL, 140402),
(140403, '1.25.10.10-FF-002474', NULL, 'Plakophilin 1a', 214, NULL, NULL, 140403),
(140404, '2.130.10.10-FF-004421', NULL, 'Uncharacterized protein', 362, NULL, NULL, 140404),
(140405, '3.30.1490.100-FF-000031', NULL, 'DNA polymerase eta', 122, NULL, NULL, 140405),
(140406, '3.40.50.2000-FF-001030', NULL, 'UDP-N-acetylglucosamine transferase subunit ALG14', 170, NULL, NULL, 140406),
(140407, '1.20.1250.20-FF-000985', NULL, 'OSJNBb0008G24.13-like protein', 121, NULL, NULL, 140407),
(140408, '1.10.3080.10-FF-000027', NULL, 'Chloride channel protein', 417, NULL, NULL, 140408),
(140409, '3.20.20.10-FF-000086', NULL, 'Pyridoxal-dependent decarboxylase, C-terminal sheet domain containing protein', 71, NULL, NULL, 140409),
(140410, '3.40.190.10-FF-000409', NULL, 'Amino acid ABC transporter amino acid-binding protein', 92, NULL, NULL, 140410),
(140411, '1.10.8.270-FF-000121', NULL, 'Uncharacterized protein', 97, NULL, NULL, 140411),
(140412, '3.40.50.720-FF-002237', NULL, 'Uncharacterized protein', 90, NULL, NULL, 140412),
(140413, '3.20.20.370-FF-000023', NULL, 'Carbohydrate deacetylase', 295, NULL, NULL, 140413),
(140414, '3.40.50.11840-FF-000018', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 2', 60, NULL, NULL, 140414),
(140415, '1.10.287.1490-FF-000099', NULL, 'Uncharacterized protein', 209, NULL, NULL, 140415),
(140416, '3.60.130.10-FF-000053', NULL, 'Uncharacterized protein', 232, NULL, NULL, 140416),
(140417, '4.10.520.10-FF-000023', NULL, 'HNS-type DNA binding protein', 91, NULL, NULL, 140417),
(140418, '2.40.240.10-FF-000013', NULL, '50S ribosomal protein L25', 94, NULL, NULL, 140418),
(140419, '3.40.50.300-FF-000537', NULL, 'Bloom syndrome RecQ-like helicase', 219, NULL, NULL, 140419),
(140420, '1.25.10.10-FF-001855', NULL, 'Condensin complex subunit 1', 191, NULL, NULL, 140420),
(140421, '3.30.1610.10-FF-000017', NULL, 'Nucleoporin 98', 46, NULL, NULL, 140421),
(140422, '1.20.120.350-FF-000136', NULL, 'Potassium voltage-gated channel, subfamily G, member 4b', 166, NULL, NULL, 140422),
(140423, '1.20.5.4820-FF-000015', NULL, 'myosin-IB isoform X3', 118, NULL, NULL, 140423),
(140424, '1.20.900.10-FF-000033', NULL, 'Muscle M-line assembly protein unc-89-like Protein', 184, NULL, NULL, 140424),
(140425, '1.20.1070.10-FF-001283', NULL, 'Olfactory receptor', 181, NULL, NULL, 140425),
(140426, '3.30.40.10-FF-001845', NULL, 'Uncharacterized protein', 83, NULL, NULL, 140426),
(140427, '1.25.40.790-FF-000006', NULL, 'NOT family protein, putative', 290, NULL, NULL, 140427),
(140428, '2.40.30.10-FF-000380', NULL, 'Elongation factor G', 115, NULL, NULL, 140428),
(140429, '2.130.10.10-FF-002813', NULL, 'Eukaryotic translation initiation factor 2A', 158, NULL, NULL, 140429),
(140430, '2.20.110.10-FF-000014', NULL, 'MORN repeat-containing protein 4', 51, NULL, NULL, 140430),
(140431, '3.90.70.10-FF-000462', NULL, 'Protein CBG06540', 174, NULL, NULL, 140431),
(140432, '3.50.50.60-FF-001192', NULL, 'Uncharacterized protein', 32, NULL, NULL, 140432),
(140433, '3.30.160.60-FF-004213', NULL, NULL, 29, NULL, NULL, 140433),
(140434, '2.60.40.10-FF-000711', NULL, 'Nectin cell adhesion molecule 2', 99, NULL, NULL, 140434),
(140435, '3.40.50.300-FF-004236', NULL, 'Switch 2', 333, NULL, NULL, 140435),
(140436, '3.30.710.10-FF-000076', NULL, 'rho-related BTB domain-containing protein 3', 160, NULL, NULL, 140436),
(140437, '2.60.40.2030-FF-000040', NULL, 'Fras1-related extracellular matrix protein 2', 124, NULL, NULL, 140437),
(140438, '3.30.70.330-FF-000901', NULL, 'Unplaced genomic scaffold supercont2.15, whole genome shotgun sequence', 103, NULL, NULL, 140438);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(140439, '3.40.50.410-FF-000115', NULL, 'Retroelement pol polyprotein-like', 181, NULL, NULL, 140439),
(140440, '2.70.98.10-FF-000001', NULL, 'Glucans biosynthesis protein G', 374, NULL, NULL, 140440),
(140441, '2.40.128.680-FF-000004', NULL, 'Uncharacterized protein', 78, NULL, NULL, 140441),
(140442, '1.10.1200.10-FF-000088', NULL, 'Nonribosomal peptide synthase GliP2', 75, NULL, NULL, 140442),
(140443, '2.60.40.10-FF-003252', NULL, NULL, 61, NULL, NULL, 140443),
(140444, '1.10.287.370-FF-000088', NULL, 'Uncharacterized protein', 168, NULL, NULL, 140444),
(140445, '3.80.10.10-FF-002100', NULL, 'Leucine Rich Repeat family protein', 118, NULL, NULL, 140445),
(140446, '2.120.10.80-FF-000412', NULL, 'Uncharacterized protein', 155, NULL, NULL, 140446),
(140447, '1.10.10.60-FF-000824', NULL, NULL, 45, NULL, NULL, 140447),
(140448, '3.30.420.340-FF-000012', NULL, 'UvrABC system protein C', 178, NULL, NULL, 140448),
(140449, '3.40.50.300-FF-008614', NULL, 'Uncharacterized protein', 50, NULL, NULL, 140449),
(140450, '2.40.70.10-FF-000169', NULL, 'Uncharacterized protein', 175, NULL, NULL, 140450),
(140451, '1.10.510.10-FF-004092', NULL, NULL, 150, NULL, NULL, 140451),
(140452, '3.30.160.60-FF-002268', NULL, 'Zinc finger protein YPR022C', 35, NULL, NULL, 140452),
(140453, '2.80.10.50-FF-000136', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 147, NULL, NULL, 140453),
(140454, '3.40.50.880-FF-000222', NULL, 'Uncharacterized protein', 92, NULL, NULL, 140454),
(140455, '3.40.50.300-FF-008507', NULL, 'Uncharacterized protein', 75, NULL, NULL, 140455),
(140456, '2.60.40.10-FF-003145', NULL, NULL, 108, NULL, NULL, 140456),
(140457, '1.10.510.10-FF-004412', NULL, NULL, 77, NULL, NULL, 140457),
(140458, '2.60.40.10-FF-005489', NULL, NULL, 97, NULL, NULL, 140458),
(140459, '3.40.50.150-FF-001768', NULL, NULL, 328, NULL, NULL, 140459),
(140460, '1.20.1250.20-FF-001491', NULL, 'Uncharacterized protein', 386, NULL, NULL, 140460),
(140461, '3.30.70.1230-FF-000267', NULL, 'Predicted protein', 138, NULL, NULL, 140461),
(140462, '1.10.8.960-FF-000007', NULL, 'Glutamate--cysteine ligase', 63, NULL, NULL, 140462),
(140463, '1.20.1070.10-FF-001592', NULL, 'G protein-coupled receptor 141', 154, NULL, NULL, 140463),
(140464, '1.10.1040.10-FF-000114', NULL, 'Uncharacterized protein', 87, NULL, NULL, 140464),
(140465, '3.30.70.330-FF-002340', NULL, NULL, 110, NULL, NULL, 140465),
(140466, '1.10.3210.10-FF-000044', NULL, 'Response regulator', 251, NULL, NULL, 140466),
(140467, '3.30.70.20-FF-000041', NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase', 103, NULL, NULL, 140467),
(140468, '1.10.10.10-FF-000377', NULL, 'LysR family transcriptional regulator', 83, NULL, NULL, 140468),
(140469, '3.30.160.60-FF-004522', NULL, NULL, 79, NULL, NULL, 140469),
(140470, '2.10.220.10-FF-000204', NULL, 'Uncharacterized protein', 56, NULL, NULL, 140470),
(140471, '3.60.21.10-FF-000165', NULL, 'Serine/threonine-protein phosphatase', 348, NULL, NULL, 140471),
(140472, '1.20.120.790-FF-000009', NULL, 'Endoplasmin', 154, NULL, NULL, 140472),
(140473, '1.25.40.80-FF-000006', NULL, 'Cryptochrome 2', 127, NULL, NULL, 140473),
(140474, '3.40.50.300-FF-000184', NULL, 'Peptide chain release factor 3', 166, NULL, NULL, 140474),
(140475, '2.130.10.10-FF-005686', NULL, 'Uncharacterized protein', 157, NULL, NULL, 140475),
(140476, '3.30.450.200-FF-000004', NULL, 'SET binding factor 2', 164, NULL, NULL, 140476),
(140477, '1.20.120.770-FF-000003', NULL, 'Amyloid-beta-like protein', 209, NULL, NULL, 140477),
(140478, '1.20.1000.10-FF-000025', NULL, NULL, 207, NULL, NULL, 140478),
(140479, '1.20.1250.20-FF-002014', NULL, 'Solute carrier organic anion transporter family member', 370, NULL, NULL, 140479),
(140480, '1.25.40.10-FF-002711', NULL, 'Transcriptional activator domain-containing protein', 66, NULL, NULL, 140480),
(140481, '2.60.40.1180-FF-000088', NULL, 'Alpha,alpha-phosphotrehalase', 74, NULL, NULL, 140481),
(140482, '1.10.10.60-FF-000459', NULL, 'Transcriptional regulator, TetR family', 49, NULL, NULL, 140482),
(140483, '1.50.40.10-FF-000539', NULL, 'Predicted protein', 150, NULL, NULL, 140483); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(140484, '3.90.660.10-FF-000092', NULL, NULL, 209, NULL, NULL, 140484),
(140485, '3.40.225.10-FF-000019', NULL, '3-hydroxy-2-methylpyridine-4,5-dicarboxylic acid decarboxylase', 241, NULL, NULL, 140485),
(140486, '2.60.40.10-FF-003937', NULL, NULL, 148, NULL, NULL, 140486),
(140487, '1.20.1440.90-FF-000014', NULL, NULL, 133, NULL, NULL, 140487),
(140488, '2.60.40.10-FF-001330', NULL, 'Fibronectin type III domain containing 1', 90, NULL, NULL, 140488),
(140489, '2.40.50.100-FF-000088', NULL, 'ABC sugar transporter, ATP-binding protein', 62, NULL, NULL, 140489),
(140490, '1.25.40.10-FF-001683', NULL, 'Selenium-binding protein-like', 210, NULL, NULL, 140490),
(140491, '3.30.200.160-FF-000015', NULL, 'Transcription factor tau subunit sfc1', 110, NULL, NULL, 140491),
(140492, '1.25.40.10-FF-002172', NULL, 'Pentatricopeptide repeat-containing protein At1g32415, mitochondrial', 76, NULL, NULL, 140492),
(140493, '1.10.10.60-FF-000329', NULL, 'Mix paired-like homeobox', 72, NULL, NULL, 140493),
(140494, '3.40.50.1970-FF-000065', NULL, NULL, 37, NULL, NULL, 140494),
(140495, '1.10.340.30-FF-000083', NULL, 'Uncharacterized protein', 126, NULL, NULL, 140495),
(140496, '3.40.50.920-FF-000055', NULL, 'Uncharacterized protein', 58, NULL, NULL, 140496),
(140497, '2.40.50.140-FF-000420', NULL, 'Putative DNA replication factor', 62, NULL, NULL, 140497),
(140498, '1.25.40.420-FF-000020', NULL, 'Kelch-like 6 (Drosophila) (Predicted)', 103, NULL, NULL, 140498),
(140499, '2.130.10.10-FF-002504', NULL, 'Beta-alanine-activating enzyme', 88, NULL, NULL, 140499),
(140500, '3.30.2160.10-FF-000061', NULL, 'Predicted protein', 62, NULL, NULL, 140500),
(140501, '3.40.390.10-FF-000144', NULL, 'Metalloendopeptidase', 187, NULL, NULL, 140501),
(140502, '1.20.1250.20-FF-001367', NULL, 'Major facilitator superfamily MFS_1', 197, NULL, NULL, 140502),
(140503, '3.30.200.20-FF-002092', NULL, 'Uncharacterized protein', 81, NULL, NULL, 140503),
(140504, '3.30.70.260-FF-000054', NULL, 'D-3-phosphoglycerate dehydrogenase', 75, NULL, NULL, 140504),
(140505, '3.90.190.20-FF-000013', NULL, 'Bifunctional folylpolyglutamate synthase/dihydrofolate synthase', 133, NULL, NULL, 140505),
(140506, '3.40.50.300-FF-004455', NULL, 'DNA repair ATPase', 159, NULL, NULL, 140506),
(140507, '2.30.30.40-FF-000367', NULL, 'Variant sh3 domain containing protein', 67, NULL, NULL, 140507),
(140508, '3.30.450.40-FF-000036', NULL, 'IclR family transcriptional regulator', 177, NULL, NULL, 140508),
(140509, '1.10.10.10-FF-000910', NULL, 'LexA repressor', 65, NULL, NULL, 140509),
(140510, '3.30.200.20-FF-001939', NULL, NULL, 220, NULL, NULL, 140510),
(140511, '2.60.40.1670-FF-000033', NULL, NULL, 108, NULL, NULL, 140511),
(140512, '3.10.180.10-FF-000011', NULL, 'Lactoylglutathione lyase', 184, NULL, NULL, 140512),
(140513, '3.40.640.10-FF-000473', NULL, 'Uncharacterized protein', 103, NULL, NULL, 140513),
(140514, '3.30.40.10-FF-002245', NULL, 'Predicted protein', 61, NULL, NULL, 140514),
(140515, '2.60.40.10-FF-004556', NULL, NULL, 107, NULL, NULL, 140515),
(140516, '3.40.640.10-FF-000034', NULL, 'Probable glycine dehydrogenase (decarboxylating) subunit 2', 257, NULL, NULL, 140516),
(140517, '3.50.7.10-FF-000027', NULL, 'T-complex protein 1 subunit delta', 160, NULL, NULL, 140517),
(140518, '4.10.80.100-FF-000003', NULL, 'Nucleoside diphosphate-linked moiety X motif 6', 18, NULL, NULL, 140518),
(140519, '3.40.50.300-FF-003303', NULL, 'ABC transporter ATP-binding protein', 215, NULL, NULL, 140519),
(140520, '3.30.20.10-FF-000001', NULL, 'Endochitinase (Chitinase)', 59, NULL, NULL, 140520),
(140521, '3.10.10.10-FF-000029', NULL, NULL, 31, NULL, NULL, 140521),
(140522, '1.10.287.110-FF-000066', NULL, 'DNAJ heat shock family protein', 117, NULL, NULL, 140522),
(140523, '3.40.50.720-FF-001372', NULL, 'Putative NAD-dependent 2-hydroxyacid dehydrogenase', 92, NULL, NULL, 140523),
(140524, '1.25.40.20-FF-001079', NULL, 'Predicted protein', 119, NULL, NULL, 140524),
(140525, '1.10.418.10-FF-000004', NULL, 'Spectrin beta chain', 120, NULL, NULL, 140525),
(140526, '3.30.160.60-FF-003701', NULL, NULL, 25, NULL, NULL, 140526);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(140527, '2.40.50.180-FF-000005', NULL, 'Chemotaxis protein CheW', 68, NULL, NULL, 140527),
(140528, '3.40.140.10-FF-000013', NULL, '26S proteasome non-ATPase regulatory subunit 7', 186, NULL, NULL, 140528),
(140529, '2.160.20.10-FF-000025', NULL, 'Probable rhamnogalacturonase B', 423, NULL, NULL, 140529),
(140530, '3.90.1150.10-FF-000395', NULL, 'Uncharacterized protein', 27, NULL, NULL, 140530),
(140531, '3.80.10.10-FF-000419', NULL, 'Slit homolog 2 (Drosophila)', 138, NULL, NULL, 140531),
(140532, '1.20.1250.20-FF-002323', NULL, 'Protein NRT1/ PTR FAMILY 7.1', 66, NULL, NULL, 140532),
(140533, '3.30.60.30-FF-000240', NULL, 'Predicted protein', 46, NULL, NULL, 140533),
(140534, '1.20.1420.30-FF-000035', NULL, 'ECM27p protein', 145, NULL, NULL, 140534),
(140535, '3.40.50.300-FF-001049', NULL, 'ATP-dependent RNA helicase DQX1 isoform X1', 218, NULL, NULL, 140535),
(140536, '2.40.20.10-FF-000082', NULL, 'Neurotrypsin', 128, NULL, NULL, 140536),
(140537, '2.10.220.10-FF-000165', NULL, 'Receptor protein-tyrosine kinase', 94, NULL, NULL, 140537),
(140538, '3.60.40.10-FF-000220', NULL, 'Probable protein phosphatase 2C 62', 106, NULL, NULL, 140538),
(140539, '1.10.472.10-FF-000624', NULL, 'Uncharacterized protein', 124, NULL, NULL, 140539),
(140540, '3.90.640.70-FF-000001', NULL, NULL, 74, NULL, NULL, 140540),
(140541, '3.60.20.10-FF-000213', NULL, NULL, 172, NULL, NULL, 140541),
(140542, '1.20.140.150-FF-000029', NULL, 'lens fiber membrane intrinsic protein-like', 119, NULL, NULL, 140542),
(140543, '3.30.160.60-FF-005141', NULL, NULL, 87, NULL, NULL, 140543),
(140544, '3.10.20.90-FF-000733', NULL, 'Putative rho guanine nucleotide exchange factor cdep', 63, NULL, NULL, 140544),
(140545, '3.30.43.10-FF-000037', NULL, 'Cholesterol oxidase', 77, NULL, NULL, 140545),
(140546, '2.40.440.10-FF-000017', NULL, 'L,D-transpeptidase catalytic domain protein', 122, NULL, NULL, 140546),
(140547, '1.10.287.130-FF-000145', NULL, 'Sensory transduction histidine kinase', 79, NULL, NULL, 140547),
(140548, '3.90.78.10-FF-000002', NULL, 'UDP-N-acetylenolpyruvoylglucosamine reductase', 124, NULL, NULL, 140548),
(140549, '1.10.3200.20-FF-000001', NULL, 'DNA polymerase', 180, NULL, NULL, 140549),
(140550, '3.40.20.10-FF-000023', NULL, 'protein transport protein Sec24C isoform X1', 121, NULL, NULL, 140550),
(140551, '3.10.120.10-FF-000018', NULL, 'Heme/steroid binding domain protein, putative', 134, NULL, NULL, 140551),
(140552, '1.20.1280.50-FF-000237', NULL, 'Uncharacterized protein', 53, NULL, NULL, 140552),
(140553, '2.10.25.10-FF-001538', NULL, 'Delta-like protein', 22, NULL, NULL, 140553),
(140554, '1.10.3590.10-FF-000004', NULL, 'Acid-sensing ion channel 3', 70, NULL, NULL, 140554),
(140555, '2.70.50.30-FF-000026', NULL, NULL, 93, NULL, NULL, 140555),
(140556, '3.30.160.60-FF-000470', NULL, 'zinc finger protein 276', 25, NULL, NULL, 140556),
(140557, '1.10.10.440-FF-000029', NULL, 'Uncharacterized protein, isoform B', 60, NULL, NULL, 140557),
(140558, '3.90.640.90-FF-000007', NULL, 'BTG anti-proliferation factor 1', 90, NULL, NULL, 140558),
(140559, '3.30.200.20-FF-002103', NULL, 'AGC family protein kinase', 79, NULL, NULL, 140559),
(140560, '2.70.170.10-FF-000220', NULL, 'Uncharacterized protein', 113, NULL, NULL, 140560),
(140561, '2.60.120.340-FF-000016', NULL, 'nucleophosmin isoform X2', 66, NULL, NULL, 140561),
(140562, '3.40.50.1100-FF-000254', NULL, 'Predicted protein', 174, NULL, NULL, 140562),
(140563, '3.40.50.2300-FF-001013', NULL, NULL, 20, NULL, NULL, 140563),
(140564, '3.40.190.10-FF-000252', NULL, 'ABC transporter substrate-binding protein component', 88, NULL, NULL, 140564),
(140565, '1.20.1440.130-FF-000009', NULL, 'Vitamin K epoxide reductase complex, subunit 1', 104, NULL, NULL, 140565),
(140566, '2.170.300.10-FF-000050', NULL, 'Uncharacterized protein', 126, NULL, NULL, 140566),
(140567, '3.40.50.300-FF-000869', NULL, 'DNA helicase', 347, NULL, NULL, 140567),
(140568, '3.30.160.60-FF-005938', NULL, NULL, 39, NULL, NULL, 140568),
(140569, '3.50.50.60-FF-000573', NULL, 'Steroid monooxygenase, putative', 155, NULL, NULL, 140569);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(140570, '2.30.42.10-FF-000020', NULL, 'partitioning defective 3 homolog isoform X1', 103, NULL, NULL, 140570),
(140571, '3.90.190.10-FF-000128', NULL, 'Uncharacterized protein', 161, NULL, NULL, 140571),
(140572, '3.40.50.1820-FF-001088', NULL, 'Serine peptidase, family S28, putative (AFU_orthologue AFUA_4G03790)', 83, NULL, NULL, 140572),
(140573, '3.10.580.10-FF-000103', NULL, 'Chloride channel protein', 80, NULL, NULL, 140573),
(140574, '3.50.50.100-FF-000060', NULL, 'Uncharacterized protein', 88, NULL, NULL, 140574),
(140575, '2.170.260.10-FF-000006', NULL, 'Dicer-like 103', 103, NULL, NULL, 140575),
(140576, '2.60.40.10-FF-004550', NULL, NULL, 115, NULL, NULL, 140576),
(140577, '3.20.20.70-FF-000660', NULL, NULL, 229, NULL, NULL, 140577),
(140578, '1.10.10.2840-FF-000002', NULL, 'Transcriptional activator protein', 125, NULL, NULL, 140578),
(140579, '2.70.150.10-FF-000218', NULL, 'Uncharacterized protein', 132, NULL, NULL, 140579),
(140580, '1.20.900.10-FF-000016', NULL, 'Rho guanine nucleotide exchange factor 6', 193, NULL, NULL, 140580),
(140581, '3.80.10.10-FF-004461', NULL, 'Phytosulfokine receptor 1', 88, NULL, NULL, 140581),
(140582, '3.40.1190.20-FF-000030', NULL, 'Kinase, PfkB family', 260, NULL, NULL, 140582),
(140583, '3.40.30.10-FF-001030', NULL, 'Uncharacterized protein', 49, NULL, NULL, 140583),
(140584, '2.10.25.10-FF-001381', NULL, 'CD248 molecule, endosialin a', 39, NULL, NULL, 140584),
(140585, '3.40.50.2000-FF-000338', NULL, 'Glycosyltransferase', 266, NULL, NULL, 140585),
(140586, '1.25.10.10-FF-002344', NULL, 'Uncharacterized protein', 288, NULL, NULL, 140586),
(140587, '3.30.70.330-FF-001862', NULL, NULL, 107, NULL, NULL, 140587),
(140588, '3.10.430.100-FF-000020', NULL, 'Uncharacterized protein', 85, NULL, NULL, 140588),
(140589, '3.40.30.10-FF-000760', NULL, 'YALI0C03201p', 87, NULL, NULL, 140589),
(140590, '3.40.720.10-FF-000288', NULL, 'Uncharacterized protein', 271, NULL, NULL, 140590),
(140591, '3.40.50.300-FF-001358', NULL, 'RAD51 paralog B', 197, NULL, NULL, 140591),
(140592, '3.40.50.2300-FF-000524', NULL, 'AGAP002797-PB', 214, NULL, NULL, 140592),
(140593, '3.90.550.50-FF-000011', NULL, 'Hexosyltransferase', 219, NULL, NULL, 140593),
(140594, '3.40.50.620-FF-000162', NULL, 'Deoxyribodipyrimidine photo-lyase', 130, NULL, NULL, 140594),
(140595, '1.25.40.20-FF-001540', NULL, 'Uncharacterized protein', 219, NULL, NULL, 140595),
(140596, '3.30.160.60-FF-001301', NULL, 'Blast:Protein hunchback', 65, NULL, NULL, 140596),
(140597, '3.40.50.720-FF-000422', NULL, 'UDP-galactopyranose mutase', 125, NULL, NULL, 140597),
(140598, '2.40.30.10-FF-000363', NULL, 'Uncharacterized protein', 132, NULL, NULL, 140598),
(140599, '1.25.40.10-FF-000238', NULL, 'Anaphase promoting complex subunit 7', 153, NULL, NULL, 140599),
(140600, '1.20.1250.20-FF-002328', NULL, 'Uncharacterized protein', 181, NULL, NULL, 140600),
(140601, '2.60.260.20-FF-000058', NULL, 'Apj1p', 81, NULL, NULL, 140601),
(140602, '3.30.200.20-FF-002131', NULL, 'Non-specific serine/threonine protein kinase', 72, NULL, NULL, 140602),
(140603, '3.90.70.40-FF-000016', NULL, 'Uncharacterized protein', 151, NULL, NULL, 140603),
(140604, '3.30.230.10-FF-000022', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 163, NULL, NULL, 140604),
(140605, '3.40.50.1820-FF-001116', NULL, 'Uncharacterized protein', 545, NULL, NULL, 140605),
(140606, '3.30.200.20-FF-000523', NULL, 'Protein kinase superfamily protein', 108, NULL, NULL, 140606),
(140607, '2.30.30.40-FF-000440', NULL, 'Variant sh3 domain containing protein', 85, NULL, NULL, 140607),
(140608, '3.90.660.10-FF-000131', NULL, NULL, 63, NULL, NULL, 140608),
(140609, '3.90.550.10-FF-000139', NULL, 'Chitin synthase 8', 150, NULL, NULL, 140609),
(140610, '3.30.9.10-FF-000031', NULL, 'FAD dependent oxidoreductase superfamily', 167, NULL, NULL, 140610),
(140611, '2.40.50.230-FF-000003', NULL, 'Type IV secretion protein Rhs', 85, NULL, NULL, 140611),
(140612, '1.25.40.10-FF-000733', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 156, NULL, NULL, 140612); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(140613, '3.10.450.50-FF-000100', NULL, 'Uncharacterized protein', 66, NULL, NULL, 140613),
(140614, '2.60.34.10-FF-000118', NULL, 'Uncharacterized protein', 126, NULL, NULL, 140614),
(140615, '3.30.160.60-FF-002285', NULL, 'Zinc finger protein 597', 27, NULL, NULL, 140615),
(140616, '3.30.1110.10-FF-000007', NULL, 'Adenosine kinase 2-like protein', 60, NULL, NULL, 140616),
(140617, '3.30.200.20-FF-001142', NULL, 'Putative L-type lectin-domain containing receptor kinase S.7 isoform A', 118, NULL, NULL, 140617),
(140618, '3.40.50.720-FF-001591', NULL, 'Anthocyanidin reductase', 215, NULL, NULL, 140618),
(140619, '1.10.167.10-FF-000027', NULL, 'G protein-coupled receptor kinase', 81, NULL, NULL, 140619),
(140620, '3.30.70.20-FF-000046', NULL, 'Periplasmic [Fe] hydrogenase large subunit', 52, NULL, NULL, 140620),
(140621, '2.60.120.10-FF-000663', NULL, 'Cyclic nucleotidebinding domain-containing protein', 123, NULL, NULL, 140621),
(140622, '3.30.2350.20-FF-000073', NULL, NULL, 84, NULL, NULL, 140622),
(140623, '1.10.472.10-FF-000629', NULL, 'Uncharacterized protein', 121, NULL, NULL, 140623),
(140624, '3.60.15.10-FF-000235', NULL, 'Uncharacterized protein', 318, NULL, NULL, 140624),
(140625, '3.40.50.720-FF-000074', NULL, 'Retinol dehydrogenase type 1', 266, NULL, NULL, 140625),
(140626, '2.10.110.10-FF-000319', NULL, 'LIM and senescent cell antigen-like-containing domain protein 2', 80, NULL, NULL, 140626),
(140627, '2.60.40.10-FF-002616', NULL, 'Calmodulin-binding transcription activator 2', 78, NULL, NULL, 140627),
(140628, '1.25.10.10-FF-000557', NULL, 'AP complex subunit beta', 607, NULL, NULL, 140628),
(140629, '3.30.160.60-FF-006091', NULL, NULL, 24, NULL, NULL, 140629),
(140630, '3.30.1380.20-FF-000058', NULL, 'Predicted protein', 56, NULL, NULL, 140630),
(140631, '1.20.1310.10-FF-000144', NULL, NULL, 148, NULL, NULL, 140631),
(140632, '3.90.820.10-FF-000003', NULL, 'Antibiotic synthesis protein MbtH', 72, NULL, NULL, 140632),
(140633, '2.60.120.200-FF-000082', NULL, 'Contactin associated protein 1', 168, NULL, NULL, 140633),
(140634, '3.30.540.30-FF-000001', NULL, 'Dipeptidyl peptidase 3', 67, NULL, NULL, 140634),
(140635, '1.10.418.40-FF-000002', NULL, 'Beclin 1 protein', 203, NULL, NULL, 140635),
(140636, '2.10.25.10-FF-001196', NULL, 'GM15024', 48, NULL, NULL, 140636),
(140637, '3.40.50.11660-FF-000032', NULL, NULL, 201, NULL, NULL, 140637),
(140638, '1.10.620.20-FF-000045', NULL, 'Ribonucleoside-diphosphate reductase small subunit', 313, NULL, NULL, 140638),
(140639, '3.30.70.330-FF-002031', NULL, NULL, 124, NULL, NULL, 140639),
(140640, '2.40.30.180-FF-000001', NULL, 'ubiquitin-like modifier-activating enzyme 1', 81, NULL, NULL, 140640),
(140641, '2.130.10.10-FF-003685', NULL, 'F-box/WD repeat-containing protein 4-like Protein', 294, NULL, NULL, 140641),
(140642, '1.10.150.780-FF-000009', NULL, 'Probable vacuolar protein sorting-associated protein 16 homolog', 96, NULL, NULL, 140642),
(140643, '3.90.1140.10-FF-000023', NULL, 'U6 snRNA phosphodiesterase', 226, NULL, NULL, 140643),
(140644, '1.10.286.20-FF-000008', NULL, 'Regulator of nucleoside diphosphate kinase', 39, NULL, NULL, 140644),
(140645, '2.30.29.30-FF-000282', NULL, 'Connector enhancer of kinase suppressor of Ras 1 variant', 107, NULL, NULL, 140645),
(140646, '3.40.50.2020-FF-000187', NULL, 'Uncharacterized protein', 130, NULL, NULL, 140646),
(140647, '2.30.30.40-FF-000237', NULL, 'SH3 and cysteine rich domain 3', 67, NULL, NULL, 140647),
(140648, '3.40.50.300-FF-002319', NULL, 'Cancer-related nucleoside-triphosphatase', 189, NULL, NULL, 140648),
(140649, '2.60.40.150-FF-000490', NULL, 'Phosphatidylserine decarboxylase proenzyme 2', 148, NULL, NULL, 140649),
(140650, '2.60.40.60-FF-000237', NULL, 'Cadherin related family member 3', 120, NULL, NULL, 140650),
(140651, '2.130.10.10-FF-003213', NULL, 'Uncharacterized protein', 54, NULL, NULL, 140651),
(140652, '2.40.37.10-FF-000058', NULL, NULL, 126, NULL, NULL, 140652),
(140653, '3.90.1410.10-FF-000022', NULL, '[Cytochrome c]-lysine N-methyltransferase', 283, NULL, NULL, 140653);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(140654, '2.120.10.30-FF-000223', NULL, 'AkeP', 305, NULL, NULL, 140654),
(140655, '3.30.200.20-FF-002468', NULL, 'Predicted protein', 125, NULL, NULL, 140655),
(140656, '3.40.50.1820-FF-000121', NULL, 'Carboxypeptidase D', 427, NULL, NULL, 140656),
(140657, '2.60.40.10-FF-003561', NULL, NULL, 98, NULL, NULL, 140657),
(140658, '3.40.50.300-FF-002454', NULL, 'Chromosome 10, whole genome shotgun sequence', 303, NULL, NULL, 140658),
(140659, '3.30.40.10-FF-001536', NULL, 'E3 ubiquitin-protein ligase LRSAM1-like Protein', 64, NULL, NULL, 140659),
(140660, '1.20.1070.10-FF-000428', NULL, 'Uncharacterized protein', 281, NULL, NULL, 140660),
(140661, '3.30.70.1590-FF-000010', NULL, NULL, 43, NULL, NULL, 140661),
(140662, '3.30.230.70-FF-000124', NULL, 'Uncharacterized protein', 221, NULL, NULL, 140662),
(140663, '2.60.40.10-FF-002763', NULL, '2 (Zwei) IG domain protein', 94, NULL, NULL, 140663),
(140664, '1.10.3720.10-FF-000144', NULL, 'Probable permease of ABC transporter', 222, NULL, NULL, 140664),
(140665, '1.25.40.10-FF-004100', NULL, 'tetratricopeptide repeat protein 19, mitochondrial-like isoform X2', 145, NULL, NULL, 140665),
(140666, '2.10.25.10-FF-000212', NULL, 'Integrin beta', 35, NULL, NULL, 140666),
(140667, '1.20.58.60-FF-000602', NULL, 'Nesprin-1', 137, NULL, NULL, 140667),
(140668, '3.40.50.300-FF-005411', NULL, 'Helicase, putative', 239, NULL, NULL, 140668),
(140669, '2.70.70.10-FF-000033', NULL, 'Periplasmic septal ring factor with murein hydrolase activity EnvCYibP CDS', 147, NULL, NULL, 140669),
(140670, '3.40.50.720-FF-001748', NULL, 'Putative formaldehyde dehydrogenase AdhA', 155, NULL, NULL, 140670),
(140671, '3.30.230.130-FF-000057', NULL, 'Cullin 4B, putative', 188, NULL, NULL, 140671),
(140672, '1.25.40.10-FF-003476', NULL, 'Pentatricopeptide repeat-containing protein At5g12100, mitochondrial', 95, NULL, NULL, 140672),
(140673, '3.90.1300.10-FF-000025', NULL, 'Glutamyl-tRNA (Gln) amidotransferase subunit A', 418, NULL, NULL, 140673),
(140674, '3.80.10.10-FF-003983', NULL, 'Uncharacterized protein', 158, NULL, NULL, 140674),
(140675, '3.40.190.10-FF-000033', NULL, 'Maltodextrin-binding protein', 160, NULL, NULL, 140675),
(140676, '1.10.800.10-FF-000005', NULL, 'Tryptophan 5-hydroxylase 1', 160, NULL, NULL, 140676),
(140677, '3.20.20.100-FF-000167', NULL, 'Putative glutamate--cysteine ligase regulatory subunit', 184, NULL, NULL, 140677),
(140678, '2.10.25.10-FF-001757', NULL, 'Uncharacterized protein', 36, NULL, NULL, 140678),
(140679, '1.20.1250.20-FF-000530', NULL, 'MFS multidrug transporter, putative', 187, NULL, NULL, 140679),
(140680, '3.80.10.10-FF-000094', NULL, 'protein C21orf2 isoform X1', 133, NULL, NULL, 140680),
(140681, '2.120.10.10-FF-000009', NULL, 'Sialidase A', 391, NULL, NULL, 140681),
(140682, '3.40.50.300-FF-007209', NULL, 'Predicted protein', 166, NULL, NULL, 140682),
(140683, '1.20.1560.10-FF-000859', NULL, 'Uncharacterized protein', 211, NULL, NULL, 140683),
(140684, '1.25.40.10-FF-004965', NULL, 'Uncharacterized protein', 156, NULL, NULL, 140684),
(140685, '1.20.5.1500-FF-000014', NULL, 'Suppressor of presenilin-2', 75, NULL, NULL, 140685),
(140686, '3.60.130.10-FF-000070', NULL, 'Uncharacterized protein', 175, NULL, NULL, 140686),
(140687, '3.40.50.10240-FF-000044', NULL, 'Thiamine pyrophosphokinase', 149, NULL, NULL, 140687),
(140688, '1.20.272.40-FF-000008', NULL, 'ATP-dependent RNA helicase SUV3 homolog, mitochondrial', 79, NULL, NULL, 140688),
(140689, '1.10.10.2750-FF-000003', NULL, 'TBC1 domain family member', 79, NULL, NULL, 140689),
(140690, '3.30.60.30-FF-000133', NULL, 'GD15911', 60, NULL, NULL, 140690),
(140691, '3.40.50.12370-FF-000014', NULL, 'Uncharacterized protein', 204, NULL, NULL, 140691),
(140692, '3.40.20.10-FF-000040', NULL, 'macrophage-capping protein-like isoform X1', 106, NULL, NULL, 140692),
(140693, '3.30.470.30-FF-000046', NULL, 'DNA ligase', 253, NULL, NULL, 140693),
(140694, '3.90.1150.10-FF-000288', NULL, 'dTDP-4-dehydro-6-deoxy-D-glucose 4-aminotransferase', 125, NULL, NULL, 140694),
(140695, '3.40.50.1820-FF-000251', NULL, 'Extracelular serine carboxypeptidase, putative', 275, NULL, NULL, 140695);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(140696, '2.60.40.680-FF-000002', NULL, 'Uncharacterized protein', 128, NULL, NULL, 140696),
(140697, '3.80.10.10-FF-002999', NULL, 'Uncharacterized protein', 96, NULL, NULL, 140697),
(140698, '1.20.1070.10-FF-001064', NULL, 'Olfactory receptor 702', 109, NULL, NULL, 140698),
(140699, '3.10.120.10-FF-000035', NULL, 'Cytochrome b5, putative', 87, NULL, NULL, 140699),
(140700, '1.10.3380.10-FF-000067', NULL, 'Uncharacterized protein', 63, NULL, NULL, 140700),
(140701, '3.30.420.40-FF-000517', NULL, 'ROK family protein', 170, NULL, NULL, 140701),
(140702, '1.10.238.10-FF-000911', NULL, 'Phosphoinositide phospholipase C', 84, NULL, NULL, 140702),
(140703, '3.30.2080.10-FF-000015', NULL, 'Uncharacterized protein', 27, NULL, NULL, 140703),
(140704, '2.60.220.50-FF-000160', NULL, 'Uncharacterized protein', 162, NULL, NULL, 140704),
(140705, '3.40.50.620-FF-000408', NULL, 'Bll5861 protein', 136, NULL, NULL, 140705),
(140706, '3.30.40.10-FF-001317', NULL, 'BCL9 transcription coactivator', 66, NULL, NULL, 140706),
(140707, '3.40.50.150-FF-001515', NULL, NULL, 110, NULL, NULL, 140707),
(140708, '2.170.260.10-FF-000023', NULL, 'Minimal dicer', 112, NULL, NULL, 140708),
(140709, '3.20.20.80-FF-000207', NULL, 'Glycoside hydrolase family 128 protein', 238, NULL, NULL, 140709),
(140710, '3.10.100.10-FF-000152', NULL, 'C-type LECtin', 139, NULL, NULL, 140710),
(140711, '3.40.50.1000-FF-000786', NULL, NULL, 58, NULL, NULL, 140711),
(140712, '3.40.50.300-FF-002538', NULL, 'ABC multidrug transporter, putative', 238, NULL, NULL, 140712),
(140713, '3.40.50.1000-FF-000477', NULL, NULL, 116, NULL, NULL, 140713),
(140714, '1.10.220.30-FF-000034', NULL, 'Flagellar motor switch protein FliG', 85, NULL, NULL, 140714),
(140715, '3.40.50.12780-FF-000047', NULL, 'Acetyl-CoA synthetase, putative', 234, NULL, NULL, 140715),
(140716, '1.25.40.10-FF-000694', NULL, 'Pentatricopeptide repeat-containing protein At3g50420', 101, NULL, NULL, 140716),
(140717, '1.25.70.10-FF-000066', NULL, NULL, 249, NULL, NULL, 140717),
(140718, '1.20.1070.10-FF-000119', NULL, 'Prolactin releasing hormone receptor', 317, NULL, NULL, 140718),
(140719, '2.130.10.10-FF-003432', NULL, 'Sortilin', 160, NULL, NULL, 140719),
(140720, '3.30.420.40-FF-000664', NULL, 'Luminal-binding protein 2', 64, NULL, NULL, 140720),
(140721, '1.20.58.80-FF-000052', NULL, 'Katanin p60 ATPase-containing subunit A1', 77, NULL, NULL, 140721),
(140722, '3.30.1520.10-FF-000134', NULL, 'Phospholipase', 144, NULL, NULL, 140722),
(140723, '3.40.190.80-FF-000020', NULL, 'Fructose-1,6-bisphosphatase/inositol-1-monophosphatase', 116, NULL, NULL, 140723),
(140724, '2.60.60.20-FF-000058', NULL, NULL, 81, NULL, NULL, 140724),
(140725, '3.30.70.141-FF-000053', NULL, NULL, 113, NULL, NULL, 140725),
(140726, '3.40.47.10-FF-000197', NULL, NULL, 97, NULL, NULL, 140726),
(140727, '3.30.470.10-FF-000040', NULL, 'Class IV aminotransferase', 106, NULL, NULL, 140727),
(140728, '3.30.420.40-FF-000883', NULL, 'Actin-related protein 6', 33, NULL, NULL, 140728),
(140729, '1.10.510.10-FF-003001', NULL, NULL, 235, NULL, NULL, 140729),
(140730, '1.20.58.220-FF-000002', NULL, 'Phosphate-specific transport system accessory protein PhoU', 119, NULL, NULL, 140730),
(140731, '1.25.40.10-FF-004437', NULL, 'Pentatricopeptide repeat protein PPR868-14 isoform 1', 120, NULL, NULL, 140731),
(140732, '3.40.50.300-FF-006506', NULL, 'Uncharacterized protein', 113, NULL, NULL, 140732),
(140733, '2.130.10.10-FF-002943', NULL, 'Protein HIRA', 279, NULL, NULL, 140733),
(140734, '2.20.70.10-FF-000086', NULL, 'NEDD4-like E3 ubiquitin-protein ligase WWP1', 31, NULL, NULL, 140734),
(140735, '2.60.40.10-FF-005854', NULL, NULL, 99, NULL, NULL, 140735),
(140736, '3.30.160.60-FF-006467', NULL, NULL, 27, NULL, NULL, 140736),
(140737, '2.60.120.200-FF-000418', NULL, 'Growth arrest-specific 6', 205, NULL, NULL, 140737),
(140738, '2.40.50.140-FF-000004', NULL, 'Elongation factor P', 59, NULL, NULL, 140738),
(140739, '3.30.450.200-FF-000021', NULL, NULL, 72, NULL, NULL, 140739),
(140740, '3.30.70.270-FF-000203', NULL, NULL, 62, NULL, NULL, 140740);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(140741, '1.25.40.10-FF-004280', NULL, 'Predicted protein', 207, NULL, NULL, 140741),
(140742, '1.25.40.10-FF-004656', NULL, 'Uncharacterized protein', 119, NULL, NULL, 140742),
(140743, '3.30.890.10-FF-000015', NULL, 'Methyl-CpG-binding domain-containing protein 5', 126, NULL, NULL, 140743),
(140744, '2.60.40.10-FF-002291', NULL, NULL, 101, NULL, NULL, 140744),
(140745, '3.40.50.1000-FF-000825', NULL, NULL, 95, NULL, NULL, 140745),
(140746, '3.30.1010.10-FF-000140', NULL, 'Protein kinase rad3', 205, NULL, NULL, 140746),
(140747, '1.20.142.10-FF-000030', NULL, 'Poly [ADP-ribose] polymerase', 54, NULL, NULL, 140747),
(140748, '3.40.50.620-FF-000032', NULL, 'Valine--tRNA ligase', 198, NULL, NULL, 140748),
(140749, '3.30.40.10-FF-000356', NULL, 'TNF receptor-associated factor', 60, NULL, NULL, 140749),
(140750, '2.60.200.20-FF-000054', NULL, 'Putative coiled-coil proteincoiled-coil protein', 135, NULL, NULL, 140750),
(140751, '1.10.405.10-FF-000008', NULL, 'Rab proteins geranylgeranyltransferase component', 115, NULL, NULL, 140751),
(140752, '2.60.40.150-FF-000416', NULL, 'C2 domain containing protein', 148, NULL, NULL, 140752),
(140753, '1.25.10.10-FF-002783', NULL, 'Uncharacterized protein', 142, NULL, NULL, 140753),
(140754, '2.170.140.10-FF-000059', NULL, 'Uncharacterized protein', 64, NULL, NULL, 140754),
(140755, '1.10.287.110-FF-000061', NULL, 'DnaJ (Hsp40) homolog, subfamily C, member 11b', 41, NULL, NULL, 140755),
(140756, '3.10.490.20-FF-000009', NULL, 'Dynein heavy chain 4', 143, NULL, NULL, 140756),
(140757, '1.20.58.240-FF-000008', NULL, 'Uncharacterized protein', 177, NULL, NULL, 140757),
(140758, '2.60.40.790-FF-000007', NULL, '17.4 kDa class I heat shock protein', 152, NULL, NULL, 140758),
(140759, '3.40.50.1580-FF-000055', NULL, 'Probable S-methyl-5''-thioinosine phosphorylase', 265, NULL, NULL, 140759),
(140760, '1.20.140.10-FF-000076', NULL, 'Short-chain-specific acyl-CoA dehydrogenase, mitochondrial', 51, NULL, NULL, 140760),
(140761, '3.30.920.10-FF-000013', NULL, 'YALI0E15268p', 116, NULL, NULL, 140761),
(140762, '3.40.50.10860-FF-000005', NULL, 'C-1-tetrahydrofolate synthase, cytoplasmic, putative', 153, NULL, NULL, 140762),
(140763, '1.10.287.130-FF-000252', NULL, 'ATP-binding region ATPase domain protein', 77, NULL, NULL, 140763),
(140764, '2.40.50.100-FF-000015', NULL, 'Dihydrolipoyllysine-residue succinyltransferase component of 2-oxoglutarate dehydrogenase complex', 80, NULL, NULL, 140764),
(140765, '3.40.50.920-FF-000038', NULL, 'Transketolase', 126, NULL, NULL, 140765),
(140766, '1.25.50.20-FF-000096', NULL, 'Aminopeptidase', 229, NULL, NULL, 140766),
(140767, '1.20.1460.10-FF-000003', NULL, 'V-type proton ATPase subunit C', 183, NULL, NULL, 140767),
(140768, '1.10.533.10-FF-000311', NULL, 'Uncharacterized protein', 40, NULL, NULL, 140768),
(140769, '3.10.50.40-FF-000018', NULL, 'Aryl-hydrocarbon-interacting protein-like 1', 162, NULL, NULL, 140769),
(140770, '3.60.10.10-FF-000387', NULL, 'Extracellular endonuclease ExeM', 367, NULL, NULL, 140770),
(140771, '3.10.20.90-FF-000840', NULL, 'Uncharacterized protein', 90, NULL, NULL, 140771),
(140772, '1.20.58.60-FF-000821', NULL, 'Spectrin, beta, non-erythrocytic 5', 183, NULL, NULL, 140772),
(140773, '1.20.1270.280-FF-000048', NULL, 'Dynein heavy chain', 177, NULL, NULL, 140773),
(140774, '1.10.30.10-FF-000029', NULL, 'nucleolar transcription factor 1 isoform X2', 79, NULL, NULL, 140774),
(140775, '3.40.309.10-FF-000068', NULL, 'Aldehyde dehydrogenase, putative', 182, NULL, NULL, 140775),
(140776, '1.25.40.20-FF-001101', NULL, 'Wide awake', 76, NULL, NULL, 140776),
(140777, '1.10.472.10-FF-000596', NULL, 'Uncharacterized protein', 24, NULL, NULL, 140777),
(140778, '1.10.20.10-FF-000203', NULL, NULL, 96, NULL, NULL, 140778),
(140779, '1.20.58.670-FF-000019', NULL, NULL, 136, NULL, NULL, 140779),
(140780, '2.20.25.10-FF-000127', NULL, 'tRNA methyltransferase subunit 11-2', 91, NULL, NULL, 140780),
(140781, '1.25.40.10-FF-004095', NULL, 'Uncharacterized protein', 150, NULL, NULL, 140781),
(140782, '1.25.40.10-FF-000385', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 212, NULL, NULL, 140782);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(140783, '1.10.287.110-FF-000403', NULL, 'Uncharacterized protein', 112, NULL, NULL, 140783),
(140784, '2.60.110.10-FF-000033', NULL, 'Uncharacterized protein', 64, NULL, NULL, 140784),
(140785, '3.30.200.20-FF-000670', NULL, 'Serine/threonine protein kinase (Kin28)', 101, NULL, NULL, 140785),
(140786, '3.30.70.330-FF-002823', NULL, NULL, 143, NULL, NULL, 140786),
(140787, '3.30.160.60-FF-002049', NULL, 'Zinc finger protein 181 isoform X2', 28, NULL, NULL, 140787),
(140788, '2.60.40.10-FF-002633', NULL, 'Protein-tyrosine-phosphatase', 93, NULL, NULL, 140788),
(140789, '3.30.870.10-FF-000132', NULL, 'Phospholipase D family, member 6', 181, NULL, NULL, 140789),
(140790, '3.30.420.40-FF-000208', NULL, 'Actin-related protein 8', 91, NULL, NULL, 140790),
(140791, '2.30.30.30-FF-000111', NULL, '50S ribosomal protein L2 (AFU_orthologue AFUA_4G12170)', 112, NULL, NULL, 140791),
(140792, '1.10.10.10-FF-001866', NULL, 'Probable serine/threonine-protein kinase roco11', 67, NULL, NULL, 140792),
(140793, '1.10.10.10-FF-000455', NULL, 'LysR family transcriptional regulator', 88, NULL, NULL, 140793),
(140794, '3.40.50.300-FF-007125', NULL, 'ATP-dependent DNA helicase PIF6', 183, NULL, NULL, 140794),
(140795, '3.40.30.10-FF-000866', NULL, 'Uncharacterized protein', 110, NULL, NULL, 140795),
(140796, '3.30.160.60-FF-000267', NULL, 'Zinc finger and BTB domain-containing 49', 27, NULL, NULL, 140796),
(140797, '3.40.1280.10-FF-000028', NULL, 'Putative tRNA (cytidine(34)-2''-O)-methyltransferase', 152, NULL, NULL, 140797),
(140798, '3.30.70.330-FF-002262', NULL, NULL, 79, NULL, NULL, 140798),
(140799, '1.25.10.10-FF-003272', NULL, 'Predicted protein', 202, NULL, NULL, 140799),
(140800, '3.30.465.10-FF-000073', NULL, 'Predicted protein', 101, NULL, NULL, 140800),
(140801, '3.50.30.30-FF-000102', NULL, 'Probable secreted peptidase', 116, NULL, NULL, 140801),
(140802, '3.10.129.10-FF-000033', NULL, 'acyl-coenzyme A thioesterase 13', 139, NULL, NULL, 140802),
(140803, '2.60.200.20-FF-000161', NULL, 'Uncharacterized protein', 113, NULL, NULL, 140803),
(140804, '3.10.100.10-FF-000383', NULL, NULL, 131, NULL, NULL, 140804),
(140805, '1.25.40.10-FF-004881', NULL, 'Putative pentatricopeptide repeat-containing protein At1g69350, mitochondrial', 102, NULL, NULL, 140805),
(140806, '3.20.20.100-FF-000083', NULL, 'Aryl-alcohol dehydrogenase', 160, NULL, NULL, 140806),
(140807, '3.55.40.10-FF-000002', NULL, 'Type II secretion system protein H', 133, NULL, NULL, 140807),
(140808, '3.30.160.60-FF-005702', NULL, NULL, 58, NULL, NULL, 140808),
(140809, '3.90.110.10-FF-000028', NULL, NULL, 184, NULL, NULL, 140809),
(140810, '2.60.120.260-FF-000054', NULL, 'Proprotein convertase subtilisin/kexin type 1', 136, NULL, NULL, 140810),
(140811, '3.30.160.60-FF-000812', NULL, 'zinc finger protein 23 isoform X2', 28, NULL, NULL, 140811),
(140812, '1.25.40.860-FF-000022', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 131, NULL, NULL, 140812),
(140813, '3.40.50.150-FF-000818', NULL, '8-demethylnovobiocic acid C(8)-methyltransferase', 205, NULL, NULL, 140813),
(140814, '3.75.10.10-FF-000011', NULL, 'Translation initiation factor 6', 224, NULL, NULL, 140814),
(140815, '2.30.42.10-FF-000144', NULL, 'Membrane associated guanylate kinase, WW and PDZ domain containing 2', 107, NULL, NULL, 140815),
(140816, '2.10.25.10-FF-000993', NULL, 'Heparan sulfate proteoglycan 2', 30, NULL, NULL, 140816),
(140817, '3.40.50.300-FF-008159', NULL, 'Uncharacterized protein', 90, NULL, NULL, 140817),
(140818, '3.80.10.10-FF-003056', NULL, 'Uncharacterized protein', 149, NULL, NULL, 140818),
(140819, '3.80.10.10-FF-000785', NULL, 'F-box/LRR-repeat protein 4 isoform X2', 97, NULL, NULL, 140819),
(140820, '3.30.497.10-FF-000152', NULL, 'Serine (or cysteine) peptidase inhibitor, clade B, member 6e', 56, NULL, NULL, 140820),
(140821, '1.10.555.10-FF-000255', NULL, NULL, 124, NULL, NULL, 140821),
(140822, '3.80.10.10-FF-002022', NULL, 'Uncharacterized protein', 155, NULL, NULL, 140822),
(140823, '2.10.25.10-FF-001066', NULL, 'Matrilin 1', 30, NULL, NULL, 140823); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(140824, '1.50.10.20-FF-000007', NULL, 'Protein farnesyltransferase subunit beta', 414, NULL, NULL, 140824),
(140825, '2.30.29.30-FF-000057', NULL, 'Fermitin family homolog 2 (Drosophila)', 136, NULL, NULL, 140825),
(140826, '3.60.21.60-FF-000039', NULL, 'DNA polymerase alpha 70 kD subunit, putative', 126, NULL, NULL, 140826),
(140827, '2.60.40.10-FF-004106', NULL, NULL, 93, NULL, NULL, 140827),
(140828, '3.20.20.140-FF-000044', NULL, 'Polymerase/histidinol phosphatase-like protein', 173, NULL, NULL, 140828),
(140829, '3.30.160.60-FF-001431', NULL, 'Putative zinc finger E-box-binding homeobox 2', 36, NULL, NULL, 140829),
(140830, '3.80.10.10-FF-001510', NULL, 'Uncharacterized protein', 238, NULL, NULL, 140830),
(140831, '1.10.150.240-FF-000061', NULL, 'Glycerol-1-phosphatase, putative', 71, NULL, NULL, 140831),
(140832, '3.30.40.10-FF-000671', NULL, 'Unplaced genomic scaffold supercont2.18, whole genome shotgun sequence', 79, NULL, NULL, 140832),
(140833, '3.40.50.11610-FF-000039', NULL, NULL, 51, NULL, NULL, 140833),
(140834, '1.10.230.10-FF-000012', NULL, 'Citrate synthase', 92, NULL, NULL, 140834),
(140835, '3.40.50.1470-FF-000022', NULL, 'Peptidyl-tRNA hydrolase mitochondrial', 72, NULL, NULL, 140835),
(140836, '1.20.940.10-FF-000007', NULL, 'Protein transport protein (SEC31), putative', 105, NULL, NULL, 140836),
(140837, '1.25.40.10-FF-000603', NULL, 'Uncharacterized protein, isoform A', 163, NULL, NULL, 140837),
(140838, '1.10.510.10-FF-000691', NULL, 'Mitogen-activated protein kinase', 92, NULL, NULL, 140838),
(140839, '3.40.50.300-FF-004000', NULL, 'ATP-dependent helicase', 245, NULL, NULL, 140839),
(140840, '3.30.2350.10-FF-000008', NULL, 'tRNA pseudouridine synthase C', 224, NULL, NULL, 140840),
(140841, '3.30.710.10-FF-000424', NULL, 'Protein CBG11420', 109, NULL, NULL, 140841),
(140842, '3.40.50.300-FF-006029', NULL, 'Dynamin 2', 185, NULL, NULL, 140842),
(140843, '3.30.70.330-FF-001643', NULL, NULL, 110, NULL, NULL, 140843),
(140844, '1.20.58.60-FF-000473', NULL, 'Spectrin beta chain', 91, NULL, NULL, 140844),
(140845, '3.90.1300.10-FF-000008', NULL, 'Amidase AmiC', 474, NULL, NULL, 140845),
(140846, '1.10.3720.10-FF-000127', NULL, 'Amino acid ABC transporter permease', 216, NULL, NULL, 140846),
(140847, '1.25.40.180-FF-000279', NULL, NULL, 162, NULL, NULL, 140847),
(140848, '1.10.10.10-FF-001074', NULL, 'MurR/RpiR family transcriptional regulator', 74, NULL, NULL, 140848),
(140849, '3.40.50.300-FF-005888', NULL, 'ABC transporter E family member 2', 97, NULL, NULL, 140849),
(140850, '1.10.10.60-FF-000476', NULL, 'MYB-related transcription factor', 61, NULL, NULL, 140850),
(140851, '1.10.287.470-FF-000005', NULL, 'Multidrug resistance protein MdtA', 74, NULL, NULL, 140851),
(140852, '1.10.510.10-FF-004434', NULL, NULL, 57, NULL, NULL, 140852),
(140853, '2.70.150.10-FF-000235', NULL, 'Predicted protein', 124, NULL, NULL, 140853),
(140854, '3.30.70.240-FF-000059', NULL, 'Uncharacterized protein', 39, NULL, NULL, 140854),
(140855, '3.30.40.10-FF-001761', NULL, 'E3 ubiquitin-protein ligase', 52, NULL, NULL, 140855),
(140856, '1.10.506.10-FF-000052', NULL, 'GTPase activating protein involved in bud site selection, putative', 214, NULL, NULL, 140856),
(140857, '2.30.40.10-FF-000089', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 80, NULL, NULL, 140857),
(140858, '1.10.220.160-FF-000025', NULL, NULL, 26, NULL, NULL, 140858),
(140859, '3.30.160.60-FF-002521', NULL, 'Uncharacterized protein', 29, NULL, NULL, 140859),
(140860, '2.60.40.10-FF-003600', NULL, 'AGAP001769-PA', 143, NULL, NULL, 140860),
(140861, '2.70.160.11-FF-000041', NULL, 'GM18100', 174, NULL, NULL, 140861),
(140862, '1.10.10.10-FF-000938', NULL, 'Transcriptional regulator, IclR family', 69, NULL, NULL, 140862),
(140863, '2.30.29.30-FF-000602', NULL, 'Syntrophin, alpha 1', 52, NULL, NULL, 140863),
(140864, '3.40.50.1820-FF-001560', NULL, 'Uncharacterized protein', 118, NULL, NULL, 140864),
(140865, '1.10.510.10-FF-000702', NULL, 'Serine/threonine-protein kinase Nek6', 200, NULL, NULL, 140865),
(140866, '3.90.1750.10-FF-000036', NULL, 'E3 ubiquitin-protein ligase HECW2', 33, NULL, NULL, 140866);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(140867, '3.40.50.620-FF-000723', NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', 374, NULL, NULL, 140867),
(140868, '3.40.910.10-FF-000027', NULL, 'Uncharacterized protein', 65, NULL, NULL, 140868),
(140869, '3.30.60.60-FF-000001', NULL, 'Histone acetyltransferase', 58, NULL, NULL, 140869),
(140870, '2.60.40.10-FF-004634', NULL, NULL, 102, NULL, NULL, 140870),
(140871, '3.50.50.60-FF-001309', NULL, 'Glycerol-3-phosphate dehydrogenase, truncation', 173, NULL, NULL, 140871),
(140872, '3.30.1370.10-FF-000116', NULL, 'RNA-binding KH domain-containing protein', 83, NULL, NULL, 140872),
(140873, '3.40.190.10-FF-000488', NULL, 'Transcriptional regulator', 92, NULL, NULL, 140873),
(140874, '3.90.79.10-FF-000201', NULL, 'Uncharacterized protein', 144, NULL, NULL, 140874),
(140875, '3.60.15.10-FF-000252', NULL, 'Uncharacterized protein', 241, NULL, NULL, 140875),
(140876, '3.40.50.2300-FF-001249', NULL, NULL, 11, NULL, NULL, 140876),
(140877, '3.40.50.300-FF-002763', NULL, 'Putative transcriptional regulatory protein NadR', 159, NULL, NULL, 140877),
(140878, '3.40.50.300-FF-005091', NULL, 'Septin 6', 40, NULL, NULL, 140878),
(140879, '3.40.50.150-FF-001167', NULL, NULL, 208, NULL, NULL, 140879),
(140880, '1.10.510.10-FF-001686', NULL, 'Uncharacterized protein', 299, NULL, NULL, 140880),
(140881, '3.30.420.40-FF-000192', NULL, 'Glucokinase', 109, NULL, NULL, 140881),
(140882, '4.10.1060.10-FF-000001', NULL, 'Nuclear pore complex protein Nup153', 45, NULL, NULL, 140882),
(140883, '2.130.10.10-FF-000234', NULL, 'WD repeat-containing protein LWD1', 329, NULL, NULL, 140883),
(140884, '3.80.10.10-FF-004152', NULL, 'Leucine Rich Repeat family protein', 105, NULL, NULL, 140884),
(140885, '3.40.50.1440-FF-000114', NULL, 'Uncharacterized protein', 237, NULL, NULL, 140885),
(140886, '3.40.50.10190-FF-000366', NULL, 'Uncharacterized protein', 54, NULL, NULL, 140886),
(140887, '1.50.40.10-FF-000085', NULL, 'Tricarboxylate carrier, putative', 130, NULL, NULL, 140887),
(140888, '3.90.660.20-FF-000010', NULL, 'Dehydrogenase', 95, NULL, NULL, 140888),
(140889, '3.30.2410.10-FF-000053', NULL, 'Uncharacterized protein', 39, NULL, NULL, 140889),
(140890, '1.10.340.40-FF-000001', NULL, 'Nuclear polyadenylated RNA-binding protein nab2', 109, NULL, NULL, 140890),
(140891, '1.25.40.20-FF-001231', NULL, 'Uncharacterized protein', 275, NULL, NULL, 140891),
(140892, '2.130.10.10-FF-001324', NULL, 'Coatomer subunit alpha-1', 181, NULL, NULL, 140892),
(140893, '2.60.40.10-FF-000739', NULL, 'Hemicentin 1', 95, NULL, NULL, 140893),
(140894, '1.20.120.1750-FF-000080', NULL, 'RBR-type E3 ubiquitin transferase', 75, NULL, NULL, 140894),
(140895, '1.20.120.1150-FF-000006', NULL, 'Serine/threonine-protein phosphatase 2A activator', 124, NULL, NULL, 140895),
(140896, '2.115.10.20-FF-000019', NULL, 'Uncharacterized protein', 193, NULL, NULL, 140896),
(140897, '2.60.260.20-FF-000030', NULL, 'DNAJ heat shock family protein', 96, NULL, NULL, 140897),
(140898, '3.10.20.90-FF-000172', NULL, 'Gamma-aminobutyric acid receptor-associated protein-like 1', 116, NULL, NULL, 140898),
(140899, '1.20.1310.10-FF-000127', NULL, NULL, 128, NULL, NULL, 140899),
(140900, '1.10.510.10-FF-000961', NULL, 'Putative serine/threonine-protein kinase haspin homolog', 221, NULL, NULL, 140900),
(140901, '2.40.40.10-FF-000004', NULL, 'Expansin B3', 139, NULL, NULL, 140901),
(140902, '1.20.58.390-FF-000250', NULL, 'Uncharacterized protein', 112, NULL, NULL, 140902),
(140903, '1.10.510.10-FF-001995', NULL, 'Kinase', 201, NULL, NULL, 140903),
(140904, '2.60.40.10-FF-000582', NULL, 'T-lymphocyte activation antigen CD86', 109, NULL, NULL, 140904),
(140905, '3.30.930.10-FF-000418', NULL, 'Lysine--tRNA ligase', 347, NULL, NULL, 140905),
(140906, '2.40.150.20-FF-000026', NULL, 'Uncharacterized protein', 90, NULL, NULL, 140906),
(140907, '3.40.50.300-FF-006361', NULL, 'Uncharacterized protein', 140, NULL, NULL, 140907),
(140908, '1.20.1070.10-FF-000794', NULL, 'CG1056-like serotonin receptor', 343, NULL, NULL, 140908),
(140909, '1.20.1720.10-FF-000046', NULL, 'Uncharacterized protein', 247, NULL, NULL, 140909);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(140910, '1.25.40.10-FF-002947', NULL, 'Uncharacterized protein', 132, NULL, NULL, 140910),
(140911, '1.10.10.60-FF-000223', NULL, 'Goosecoid homeobox 2', 74, NULL, NULL, 140911),
(140912, '3.40.50.1820-FF-001341', NULL, 'Uncharacterized protein', 249, NULL, NULL, 140912),
(140913, '3.30.750.24-FF-000070', NULL, 'SulP family sulfate permease', 126, NULL, NULL, 140913),
(140914, '2.130.10.10-FF-003668', NULL, 'Related to yeast Vacuolar Protein Sorting factor', 175, NULL, NULL, 140914),
(140915, '3.30.420.10-FF-000520', NULL, NULL, 118, NULL, NULL, 140915),
(140916, '1.20.920.10-FF-000231', NULL, 'Uncharacterized protein', 161, NULL, NULL, 140916),
(140917, '3.30.497.10-FF-000045', NULL, 'Leukocyte elastase inhibitor, putative', 195, NULL, NULL, 140917),
(140918, '2.60.40.10-FF-005253', NULL, NULL, 114, NULL, NULL, 140918),
(140919, '2.40.30.70-FF-000010', NULL, 'Uncharacterized protein', 142, NULL, NULL, 140919),
(140920, '1.10.600.10-FF-000024', NULL, 'Ent-copalyl diphosphate synthase', 276, NULL, NULL, 140920),
(140921, '3.40.1440.10-FF-000018', NULL, NULL, 103, NULL, NULL, 140921),
(140922, '1.25.40.10-FF-000278', NULL, 'Vacuolar protein sorting-associated protein 11 homolog', 289, NULL, NULL, 140922),
(140923, '1.25.10.10-FF-002558', NULL, 'AER377Cp', 171, NULL, NULL, 140923),
(140924, '3.40.50.150-FF-001532', NULL, NULL, 97, NULL, NULL, 140924),
(140925, '3.30.40.10-FF-000339', NULL, 'Cellulose synthase', 92, NULL, NULL, 140925),
(140926, '3.40.50.10810-FF-000237', NULL, 'Uncharacterized protein', 198, NULL, NULL, 140926),
(140927, '1.20.58.1250-FF-000006', NULL, 'Uncharacterized protein', 96, NULL, NULL, 140927),
(140928, '2.40.50.140-FF-000235', NULL, 'Ribonuclease G', 91, NULL, NULL, 140928),
(140929, '3.40.640.10-FF-000343', NULL, '8-amino-3,8-dideoxy-alpha-D-manno-octulosonate transaminase', 250, NULL, NULL, 140929),
(140930, '2.60.40.150-FF-000647', NULL, 'Copine VIII', 124, NULL, NULL, 140930),
(140931, '3.90.640.10-FF-000220', NULL, 'Actin-related protein 8', 75, NULL, NULL, 140931),
(140932, '1.20.80.10-FF-000010', NULL, 'Acyl-CoA-binding domain-containing protein 5', 96, NULL, NULL, 140932),
(140933, '1.10.287.70-FF-000200', NULL, 'Glutamate receptor 2.8', 140, NULL, NULL, 140933),
(140934, '2.30.30.40-FF-000131', NULL, 'Guanine nucleotide exchange factor VAV2 isoform 2', 71, NULL, NULL, 140934),
(140935, '3.90.550.50-FF-000090', NULL, 'Protein CBG18324', 205, NULL, NULL, 140935),
(140936, '3.30.230.70-FF-000141', NULL, 'Uncharacterized protein', 145, NULL, NULL, 140936),
(140937, '1.20.58.480-FF-000029', NULL, 'Uncharacterized protein', 117, NULL, NULL, 140937),
(140938, '1.10.510.10-FF-001214', NULL, 'Guanylate cyclase', 258, NULL, NULL, 140938),
(140939, '2.60.40.10-FF-005961', NULL, NULL, 73, NULL, NULL, 140939),
(140940, '3.30.70.330-FF-000007', NULL, 'CUGBP Elav-like family member 4 isoform 3', 92, NULL, NULL, 140940),
(140941, '2.60.120.20-FF-000008', NULL, 'Capsid protein VP1', 228, NULL, NULL, 140941),
(140942, '3.30.160.60-FF-003140', NULL, 'Predicted protein', 51, NULL, NULL, 140942),
(140943, '2.60.40.1170-FF-000006', NULL, 'Putative AP-3 complex subunit mu-2-like', 142, NULL, NULL, 140943),
(140944, '4.10.1240.50-FF-000010', NULL, 'REST corepressor 3', 92, NULL, NULL, 140944),
(140945, '1.20.1070.10-FF-000900', NULL, 'Uncharacterized protein', 146, NULL, NULL, 140945),
(140946, '1.10.10.10-FF-000686', NULL, 'Cell division control protein', 91, NULL, NULL, 140946),
(140947, '3.40.309.10-FF-000085', NULL, 'Gamma-glutamyl phosphate reductase 2', 150, NULL, NULL, 140947),
(140948, '3.40.50.300-FF-003758', NULL, 'Zgc:171695', 234, NULL, NULL, 140948),
(140949, '3.30.559.10-FF-000072', NULL, 'Nonribosomal peptide synthase GliP2', 189, NULL, NULL, 140949),
(140950, '3.40.50.720-FF-001708', NULL, 'Uncharacterized protein', 152, NULL, NULL, 140950),
(140951, '3.30.160.60-FF-002740', NULL, 'Zinc finger and SCAN domain containing 4', 30, NULL, NULL, 140951),
(140952, '1.10.10.60-FF-000695', NULL, 'MYB transcription factor MYB48', 101, NULL, NULL, 140952),
(140953, '3.30.559.70-FF-000039', NULL, 'Uncharacterized protein', 302, NULL, NULL, 140953); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(140954, '3.30.160.60-FF-003229', NULL, 'PR/SET domain 15', 33, NULL, NULL, 140954),
(140955, '3.80.10.10-FF-003308', NULL, 'Toll-like receptor 20, tandem duplicate 2', 204, NULL, NULL, 140955),
(140956, '3.80.10.10-FF-003764', NULL, 'Uncharacterized protein', 114, NULL, NULL, 140956),
(140957, '1.10.1410.10-FF-000042', NULL, 'Poly(A) polymerase/terminal uridylyl transferase, nucleotidyltransferase domain protein', 73, NULL, NULL, 140957),
(140958, '2.170.130.10-FF-000002', NULL, 'Vitamin B12 transporter BtuB', 124, NULL, NULL, 140958),
(140959, '2.40.70.10-FF-000484', NULL, NULL, 150, NULL, NULL, 140959),
(140960, '3.30.160.60-FF-006427', NULL, NULL, 44, NULL, NULL, 140960),
(140961, '1.10.10.580-FF-000021', NULL, 'Rec8 like protein-domain-containing protein', 74, NULL, NULL, 140961),
(140962, '3.40.850.10-FF-000533', NULL, 'Kinesin, putative', 359, NULL, NULL, 140962),
(140963, '3.80.10.10-FF-000077', NULL, 'LRR receptor-like serine/threonine-protein kinase ERL1', 164, NULL, NULL, 140963),
(140964, '2.130.10.10-FF-005377', NULL, 'Uncharacterized protein', 159, NULL, NULL, 140964),
(140965, '3.30.70.330-FF-002155', NULL, NULL, 115, NULL, NULL, 140965),
(140966, '1.20.58.60-FF-000366', NULL, 'SMAll', 108, NULL, NULL, 140966),
(140967, '2.160.20.10-FF-000149', NULL, 'Uncharacterized protein', 182, NULL, NULL, 140967),
(140968, '2.30.30.620-FF-000006', NULL, 'Uncharacterized protein', 72, NULL, NULL, 140968),
(140969, '1.10.510.10-FF-003232', NULL, NULL, 125, NULL, NULL, 140969),
(140970, '3.40.30.10-FF-000557', NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 2', 93, NULL, NULL, 140970),
(140971, '4.10.60.10-FF-000103', NULL, 'RNA binding motif protein 4.1', 47, NULL, NULL, 140971),
(140972, '1.20.1070.10-FF-001047', NULL, 'Protein CBG13756', 231, NULL, NULL, 140972),
(140973, '1.25.10.10-FF-000905', NULL, 'Ste ste11 cdc15 protein kinase', 176, NULL, NULL, 140973),
(140974, '1.10.150.20-FF-000177', NULL, 'ATP-dependent DNA helicase', 53, NULL, NULL, 140974),
(140975, '3.30.40.10-FF-001975', NULL, 'At1g70910', 62, NULL, NULL, 140975),
(140976, '3.90.76.10-FF-000048', NULL, 'Oligopeptide-binding protein oppA', 120, NULL, NULL, 140976),
(140977, '3.40.50.1580-FF-000015', NULL, 'MTN2', 246, NULL, NULL, 140977),
(140978, '1.10.1740.10-FF-000027', NULL, 'RNA polymerase sigma factor', 84, NULL, NULL, 140978),
(140979, '2.130.10.10-FF-002252', NULL, 'U3 small nucleolar RNA-associated protein 18 homolog', 328, NULL, NULL, 140979),
(140980, '4.10.1000.10-FF-000025', NULL, 'Zinc finger matrin-type protein 5', 67, NULL, NULL, 140980),
(140981, '3.80.10.10-FF-001403', NULL, 'Predicted protein', 130, NULL, NULL, 140981),
(140982, '3.40.525.10-FF-000059', NULL, 'Uncharacterized protein', 85, NULL, NULL, 140982),
(140983, '2.60.40.150-FF-000523', NULL, 'C2 domain containing protein', 145, NULL, NULL, 140983),
(140984, '3.90.70.10-FF-000709', NULL, 'Uncharacterized protein', 207, NULL, NULL, 140984),
(140985, '2.30.30.40-FF-000676', NULL, 'Predicted protein', 84, NULL, NULL, 140985),
(140986, '3.40.50.2300-FF-000310', NULL, 'Glutamate receptor', 100, NULL, NULL, 140986),
(140987, '2.60.40.150-FF-000271', NULL, 'Misfire, isoform B', 128, NULL, NULL, 140987),
(140988, '1.10.10.10-FF-001759', NULL, 'Uncharacterized protein', 64, NULL, NULL, 140988),
(140989, '2.30.40.10-FF-000162', NULL, 'N-acetylgalactosamine-6-phosphate deacetylase', 81, NULL, NULL, 140989),
(140990, '2.30.29.30-FF-000366', NULL, 'Uncharacterized protein, isoform B', 164, NULL, NULL, 140990),
(140991, '3.30.1490.480-FF-000004', NULL, 'Endolytic murein transglycosylase', 73, NULL, NULL, 140991),
(140992, '3.40.50.150-FF-000548', NULL, 'tRNA/tmRNA (uracil-C(5))-methyltransferase', 202, NULL, NULL, 140992),
(140993, '3.40.250.10-FF-000004', NULL, 'M-phase inducer phosphatase 1 isoform X1', 183, NULL, NULL, 140993),
(140994, '3.40.50.300-FF-003382', NULL, 'Regulator of nonsense transcripts putative', 178, NULL, NULL, 140994),
(140995, '1.20.1730.10-FF-000131', NULL, 'Uncharacterized protein', 278, NULL, NULL, 140995),
(140996, '3.90.550.50-FF-000247', NULL, 'Predicted protein', 194, NULL, NULL, 140996);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(140997, '1.25.40.10-FF-004173', NULL, 'Uncharacterized protein', 97, NULL, NULL, 140997),
(140998, '2.130.10.10-FF-002960', NULL, 'WD40 repeat protein', 242, NULL, NULL, 140998),
(140999, '2.70.170.10-FF-000248', NULL, 'Uncharacterized protein', 119, NULL, NULL, 140999),
(141000, '3.30.499.10-FF-000027', NULL, 'Aconitate hydratase, cytoplasmic', 74, NULL, NULL, 141000),
(141001, '3.30.505.10-FF-000217', NULL, NULL, 107, NULL, NULL, 141001),
(141002, '1.20.5.340-FF-000016', NULL, 'Rho-associated protein kinase 2', 168, NULL, NULL, 141002),
(141003, '3.40.50.2000-FF-000102', NULL, 'Trehalose-6-phosphate synthase', 209, NULL, NULL, 141003),
(141004, '3.40.50.10330-FF-000099', NULL, 'Diacylglycerol kinase', 141, NULL, NULL, 141004),
(141005, '3.30.70.580-FF-000032', NULL, 'tRNA pseudouridine synthase', 115, NULL, NULL, 141005),
(141006, '1.20.120.350-FF-000119', NULL, 'Calcium channel, voltage-dependent, T type, alpha 1H subunit a', 115, NULL, NULL, 141006),
(141007, '3.40.630.30-FF-000399', NULL, 'Uncharacterized protein', 115, NULL, NULL, 141007),
(141008, '3.30.70.330-FF-002716', NULL, NULL, 102, NULL, NULL, 141008),
(141009, '3.40.50.300-FF-008053', NULL, 'Uncharacterized protein', 127, NULL, NULL, 141009),
(141010, '3.40.190.10-FF-000724', NULL, 'Glutamate receptor 1.4', 37, NULL, NULL, 141010),
(141011, '1.10.220.10-FF-000039', NULL, 'Annexin', 88, NULL, NULL, 141011),
(141012, '3.30.70.1660-FF-000042', NULL, 'Peptide chain release factor 1, putative', 166, NULL, NULL, 141012),
(141013, '3.40.50.2300-FF-000996', NULL, NULL, 140, NULL, NULL, 141013),
(141014, '3.30.70.360-FF-000005', NULL, 'Putative Aminoacylase-1', 111, NULL, NULL, 141014),
(141015, '2.60.40.1510-FF-000047', NULL, 'Integrin beta', 123, NULL, NULL, 141015),
(141016, '3.40.50.2300-FF-001614', NULL, NULL, 36, NULL, NULL, 141016),
(141017, '1.50.10.20-FF-000030', NULL, 'Geranylgeranyl transferase type-2 subunit beta', 322, NULL, NULL, 141017),
(141018, '3.30.710.10-FF-000059', NULL, 'Zinc finger and BTB domain-containing protein 16', 152, NULL, NULL, 141018),
(141019, '2.70.98.10-FF-000023', NULL, 'Glucose-6-phosphate 1-epimerase', 297, NULL, NULL, 141019),
(141020, '3.50.30.10-FF-000017', NULL, NULL, 111, NULL, NULL, 141020),
(141021, '2.60.40.60-FF-000928', NULL, 'Uncharacterized protein', 45, NULL, NULL, 141021),
(141022, '1.20.58.900-FF-000015', NULL, 'RUN and FYVE domain containing 4', 167, NULL, NULL, 141022),
(141023, '3.30.160.60-FF-001195', NULL, 'Zinc finger protein 239', 28, NULL, NULL, 141023),
(141024, '2.130.10.10-FF-000942', NULL, 'Topless-related protein 4', 142, NULL, NULL, 141024),
(141025, '3.30.260.10-FF-000114', NULL, NULL, 15, NULL, NULL, 141025),
(141026, '1.20.1050.10-FF-000231', NULL, 'Predicted protein', 90, NULL, NULL, 141026),
(141027, '1.10.510.10-FF-000382', NULL, 'Mitogen-activated protein kinase kinase kinase 2', 293, NULL, NULL, 141027),
(141028, '1.20.1070.10-FF-001608', NULL, 'Predicted protein', 149, NULL, NULL, 141028),
(141029, '2.160.20.10-FF-000172', NULL, 'Cell surface protein', 89, NULL, NULL, 141029),
(141030, '2.40.50.140-FF-001185', NULL, NULL, 150, NULL, NULL, 141030),
(141031, '1.10.510.10-FF-001000', NULL, 'Serine/threonine protein kinase', 334, NULL, NULL, 141031),
(141032, '1.20.1530.20-FF-000023', NULL, 'Cation/H(+) antiporter 14', 408, NULL, NULL, 141032),
(141033, '2.70.98.30-FF-000029', NULL, 'Lysosomal alpha-mannosidase, putative', 122, NULL, NULL, 141033),
(141034, '1.10.1070.11-FF-000050', NULL, 'Phosphatidylinositol 3-kinase age-1', 229, NULL, NULL, 141034),
(141035, '1.10.150.50-FF-000175', NULL, 'Receptor protein-tyrosine kinase', 51, NULL, NULL, 141035),
(141036, '1.20.58.760-FF-000046', NULL, 'Uncharacterized protein', 86, NULL, NULL, 141036),
(141037, '2.60.120.10-FF-000770', NULL, 'Uncharacterized protein', 52, NULL, NULL, 141037),
(141038, '2.130.10.10-FF-004197', NULL, 'Uncharacterized protein', 158, NULL, NULL, 141038),
(141039, '3.40.50.720-FF-000894', NULL, 'UDP-glucose 4-epimerase, truncation', 88, NULL, NULL, 141039),
(141040, '3.30.160.20-FF-000250', NULL, 'Predicted protein', 66, NULL, NULL, 141040);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(141041, '1.10.4190.10-FF-000002', NULL, 'Urease accessory protein UreF', 209, NULL, NULL, 141041),
(141042, '1.25.40.10-FF-003004', NULL, 'Pre-mRNA-splicing factor clf1', 124, NULL, NULL, 141042),
(141043, '1.25.40.10-FF-005134', NULL, 'Adenylyl cyclase class-3/4/guanylyl cyclase', 102, NULL, NULL, 141043),
(141044, '1.25.10.10-FF-001254', NULL, 'eIF-2-alpha kinase activator GCN1', 237, NULL, NULL, 141044),
(141045, '3.40.140.10-FF-000086', NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', 205, NULL, NULL, 141045),
(141046, '1.20.5.320-FF-000010', NULL, 'Collagen type VI alpha 6 chain', 47, NULL, NULL, 141046),
(141047, '2.130.10.10-FF-004382', NULL, 'Anaphase-promoting complex subunit 4', 76, NULL, NULL, 141047),
(141048, '3.30.930.10-FF-000042', NULL, 'probable proline--tRNA ligase, mitochondrial', 300, NULL, NULL, 141048),
(141049, '3.30.160.60-FF-005955', NULL, NULL, 51, NULL, NULL, 141049),
(141050, '1.20.58.1220-FF-000008', NULL, 'Exocyst complex component', 105, NULL, NULL, 141050),
(141051, '1.20.1280.290-FF-000071', NULL, 'Lysosomal L-cystine transporter (Eurofung)', 72, NULL, NULL, 141051),
(141052, '2.40.30.270-FF-000039', NULL, 'Uncharacterized protein', 112, NULL, NULL, 141052),
(141053, '3.30.1490.40-FF-000004', NULL, 'Zinc finger CCCH domain-containing protein 19', 58, NULL, NULL, 141053),
(141054, '3.10.20.90-FF-000368', NULL, 'Ubiquitin thioesterase OTU1', 73, NULL, NULL, 141054),
(141055, '2.170.150.20-FF-000023', NULL, 'Uncharacterized protein', 145, NULL, NULL, 141055),
(141056, '2.60.120.330-FF-000137', NULL, 'Uncharacterized protein', 135, NULL, NULL, 141056),
(141057, '3.50.50.60-FF-000129', NULL, 'Kynurenine 3-monooxygenase', 386, NULL, NULL, 141057),
(141058, '1.20.80.10-FF-000083', NULL, 'Myosin-G heavy chain', 112, NULL, NULL, 141058),
(141059, '1.20.1250.20-FF-001474', NULL, 'Transporter', 444, NULL, NULL, 141059),
(141060, '1.20.1250.20-FF-001289', NULL, 'Uncharacterized protein', 447, NULL, NULL, 141060),
(141061, '2.130.10.10-FF-005719', NULL, 'Uncharacterized protein', 139, NULL, NULL, 141061),
(141062, '3.30.300.30-FF-000152', NULL, 'Uncharacterized protein', 113, NULL, NULL, 141062),
(141063, '2.60.120.40-FF-000003', NULL, 'caprin-2 isoform X1', 134, NULL, NULL, 141063),
(141064, '1.20.91.20-FF-000004', NULL, 'Complement C5', 81, NULL, NULL, 141064),
(141065, '3.60.21.10-FF-000384', NULL, 'Uncharacterized protein', 75, NULL, NULL, 141065),
(141066, '1.20.5.260-FF-000003', NULL, 'Uncharacterized protein', 77, NULL, NULL, 141066),
(141067, '1.10.533.10-FF-000075', NULL, 'Baculoviral IAP repeat containing 7', 23, NULL, NULL, 141067),
(141068, '1.10.150.20-FF-000071', NULL, 'Flap endonuclease 1', 65, NULL, NULL, 141068),
(141069, '1.25.10.10-FF-001939', NULL, 'YALI0E27049p', 350, NULL, NULL, 141069),
(141070, '2.80.10.50-FF-000153', NULL, 'Uncharacterized protein', 101, NULL, NULL, 141070),
(141071, '1.25.40.20-FF-000376', NULL, 'Expressed protein', 172, NULL, NULL, 141071),
(141072, '1.25.40.80-FF-000023', NULL, 'Uncharacterized protein', 115, NULL, NULL, 141072),
(141073, '3.30.720.10-FF-000009', NULL, 'Signal recognition particle subunit SRP9', 80, NULL, NULL, 141073),
(141074, '2.120.10.80-FF-000188', NULL, 'AGAP008185-PA', 91, NULL, NULL, 141074),
(141075, '3.90.650.10-FF-000046', NULL, 'Phosphoribosylformylglycinamidine synthase', 172, NULL, NULL, 141075),
(141076, '1.10.8.270-FF-000149', NULL, 'Uncharacterized protein', 126, NULL, NULL, 141076),
(141077, '1.10.470.10-FF-000007', NULL, 'Variant surface glycoprotein (VSG, atypical), putative', 150, NULL, NULL, 141077),
(141078, '1.10.530.10-FF-000052', NULL, 'Endochitinase PR4', 87, NULL, NULL, 141078),
(141079, '1.10.10.60-FF-000931', NULL, NULL, 84, NULL, NULL, 141079),
(141080, '3.40.50.720-FF-001855', NULL, 'Galactose epimerase, putative', 116, NULL, NULL, 141080),
(141081, '1.25.10.10-FF-000074', NULL, 'importin-5 isoform X1', 1058, NULL, NULL, 141081),
(141082, '1.10.1300.10-FF-000028', NULL, 'Phosphodiesterase', 385, NULL, NULL, 141082),
(141083, '1.20.1110.10-FF-000163', NULL, NULL, 39, NULL, NULL, 141083);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(141084, '3.40.50.10130-FF-000011', NULL, 'Crossover junction endonuclease MUS81', 146, NULL, NULL, 141084),
(141085, '2.60.40.10-FF-005034', NULL, NULL, 146, NULL, NULL, 141085),
(141086, '1.20.1560.10-FF-000191', NULL, 'Uncharacterized protein', 213, NULL, NULL, 141086),
(141087, '1.20.1250.20-FF-000294', NULL, 'MFS transporter of unkown specificity', 207, NULL, NULL, 141087),
(141088, '4.10.830.40-FF-000010', NULL, NULL, 76, NULL, NULL, 141088),
(141089, '1.10.287.1970-FF-000001', NULL, 'Alanine aminotransferase 2', 51, NULL, NULL, 141089),
(141090, '3.40.50.300-FF-008429', NULL, 'Uncharacterized protein', 96, NULL, NULL, 141090),
(141091, '1.25.40.10-FF-002386', NULL, 'Predicted protein', 64, NULL, NULL, 141091),
(141092, '3.40.50.2020-FF-000108', NULL, 'Phosphoribosyl transferase domain protein', 190, NULL, NULL, 141092),
(141093, '1.20.870.10-FF-000035', NULL, 'RAS, guanyl releasing protein 3', 69, NULL, NULL, 141093),
(141094, '3.30.200.20-FF-001378', NULL, 'Uncharacterized protein', 74, NULL, NULL, 141094),
(141095, '4.10.410.60-FF-000001', NULL, '50S ribosomal protein L35', 64, NULL, NULL, 141095),
(141096, '3.30.450.30-FF-000011', NULL, 'Dynein light chain roadblock', 95, NULL, NULL, 141096),
(141097, '2.130.10.30-FF-000026', NULL, 'RCC1-like G exchanging factor-like protein', 129, NULL, NULL, 141097),
(141098, '2.120.10.30-FF-000330', NULL, 'Uncharacterized protein', 132, NULL, NULL, 141098),
(141099, '3.80.10.10-FF-002128', NULL, 'NLR family CARD domain-containing 9', 72, NULL, NULL, 141099),
(141100, '3.40.640.10-FF-000490', NULL, 'Aminotransferase tdiD', 429, NULL, NULL, 141100),
(141101, '3.80.10.10-FF-002331', NULL, 'Uncharacterized protein', 74, NULL, NULL, 141101),
(141102, '3.30.1120.10-FF-000058', NULL, 'N-acetylgalactosamine-6-sulfatase', 64, NULL, NULL, 141102),
(141103, '3.10.100.10-FF-000130', NULL, 'C-type lectin receptor-like tyrosine-protein kinase isoform B', 159, NULL, NULL, 141103),
(141104, '2.50.20.10-FF-000008', NULL, 'Outer-membrane lipoprotein carrier protein', 183, NULL, NULL, 141104),
(141105, '3.90.740.10-FF-000076', NULL, 'ATP binding / aminoacyl-tRNA ligase/ nucleotide binding protein', 60, NULL, NULL, 141105),
(141106, '4.10.400.10-FF-000076', NULL, 'Low-density lipoprotein receptor-related protein', 39, NULL, NULL, 141106),
(141107, '3.10.129.10-FF-000139', NULL, 'HotDog domain-containing protein', 136, NULL, NULL, 141107),
(141108, '3.80.10.10-FF-001038', NULL, 'Leucine-rich receptor-like kinase family protein', 132, NULL, NULL, 141108),
(141109, '2.10.25.10-FF-001302', NULL, 'AGAP003506-PA', 38, NULL, NULL, 141109),
(141110, '3.30.750.24-FF-000176', NULL, 'Chloride anion exchanger', 75, NULL, NULL, 141110),
(141111, '3.40.50.80-FF-000063', NULL, 'Ferredoxin--NADP reductase', 158, NULL, NULL, 141111),
(141112, '2.60.40.10-FF-001200', NULL, 'Titin a', 100, NULL, NULL, 141112),
(141113, '3.30.565.10-FF-000558', NULL, 'Putative heat shock protein HSP 90-alpha A4', 197, NULL, NULL, 141113),
(141114, '3.40.50.300-FF-005433', NULL, 'Uncharacterized protein', 115, NULL, NULL, 141114),
(141115, '2.130.10.10-FF-004758', NULL, 'Uncharacterized protein', 158, NULL, NULL, 141115),
(141116, '3.40.50.2300-FF-000069', NULL, 'Two-component system response regulator BasR', 80, NULL, NULL, 141116),
(141117, '2.10.90.10-FF-000082', NULL, 'Cerberus', 109, NULL, NULL, 141117),
(141118, '3.30.40.10-FF-002380', NULL, 'E3 ubiquitin-protein ligase', 70, NULL, NULL, 141118),
(141119, '1.20.144.10-FF-000085', NULL, 'Phosphatidate phosphatase PPAPDC1A', 236, NULL, NULL, 141119),
(141120, '3.80.10.10-FF-003511', NULL, 'Predicted protein', 180, NULL, NULL, 141120),
(141121, '2.60.40.60-FF-000372', NULL, 'Uncharacterized protein, isoform B', 105, NULL, NULL, 141121),
(141122, '1.20.1260.10-FF-000022', NULL, 'Ferritin', 161, NULL, NULL, 141122),
(141123, '2.160.20.70-FF-000037', NULL, 'Tubulin specific chaperone D', 164, NULL, NULL, 141123),
(141124, '2.130.10.10-FF-000487', NULL, 'Transducin beta like 2', 89, NULL, NULL, 141124),
(141125, '1.20.120.160-FF-000040', NULL, 'Two component system histidine kinase', 112, NULL, NULL, 141125);
INSERT INTO "PUBLIC"."MODEL" VALUES
(141126, '3.30.70.330-FF-000210', NULL, 'RNA-binding protein with serine-rich domain 1', 124, NULL, NULL, 141126),
(141127, '1.20.120.720-FF-000051', NULL, 'Uncharacterized protein', 113, NULL, NULL, 141127),
(141128, '1.25.40.10-FF-001082', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 125, NULL, NULL, 141128),
(141129, '4.10.40.50-FF-000001', NULL, 'liver-expressed antimicrobial peptide 2', 40, NULL, NULL, 141129),
(141130, '3.40.50.300-FF-001813', NULL, 'ATP-dependent DNA helicase', 228, NULL, NULL, 141130),
(141131, '3.90.550.10-FF-000246', NULL, 'Chitooligosaccharide synthase NodC', 243, NULL, NULL, 141131),
(141132, '2.60.40.3210-FF-000006', NULL, 'Zona pellucida sperm-binding protein 2', 114, NULL, NULL, 141132),
(141133, '1.20.5.370-FF-000014', NULL, 'Myosin-7', 30, NULL, NULL, 141133),
(141134, '1.10.286.70-FF-000001', NULL, 'Uncharacterized protein B2O8.280', 45, NULL, NULL, 141134),
(141135, '2.20.100.10-FF-000064', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 10 preproprotein', 59, NULL, NULL, 141135),
(141136, '2.60.40.10-FF-000054', NULL, 'Contactin 1', 92, NULL, NULL, 141136),
(141137, '3.30.70.2630-FF-000007', NULL, 'Telomerase reverse transcriptase', 62, NULL, NULL, 141137),
(141138, '3.30.110.30-FF-000008', NULL, 'Proline--tRNA ligase', 73, NULL, NULL, 141138),
(141139, '1.10.3380.30-FF-000022', NULL, 'ATP-dependent DNA helicase Hel308', 221, NULL, NULL, 141139),
(141140, '2.70.130.10-FF-000127', NULL, NULL, 149, NULL, NULL, 141140),
(141141, '3.40.50.10810-FF-000131', NULL, 'AGAP010699-PA', 278, NULL, NULL, 141141),
(141142, '3.40.50.150-FF-000442', NULL, 'tRNA (Adenine22-N1)-methyltransferase TrmK', 173, NULL, NULL, 141142),
(141143, '3.30.160.60-FF-004319', NULL, NULL, 26, NULL, NULL, 141143),
(141144, '3.30.1010.10-FF-000067', NULL, 'Phosphatidylinositol4,5-bisphosphate 3-kinase catalytic subunit, putative', 163, NULL, NULL, 141144),
(141145, '3.40.1660.10-FF-000001', NULL, 'Erythromycin esterase', 175, NULL, NULL, 141145),
(141146, '3.10.450.100-FF-000001', NULL, 'Penicillin-binding protein 3', 116, NULL, NULL, 141146),
(141147, '3.30.1490.70-FF-000002', NULL, 'DNA ligase', 71, NULL, NULL, 141147),
(141148, '4.10.280.10-FF-000195', NULL, 'cDNA FLJ52911, highly similar to Max-like protein X', 64, NULL, NULL, 141148),
(141149, '1.20.190.50-FF-000012', NULL, 'Nuclear pore complex protein', 231, NULL, NULL, 141149),
(141150, '2.30.30.140-FF-000177', NULL, 'Histone acetyltransferase', 80, NULL, NULL, 141150),
(141151, '3.40.50.1240-FF-000155', NULL, NULL, 193, NULL, NULL, 141151),
(141152, '1.10.238.10-FF-000439', NULL, 'Troponin C type IIIb1', 84, NULL, NULL, 141152),
(141153, '3.30.40.10-FF-002014', NULL, 'Predicted protein', 48, NULL, NULL, 141153),
(141154, '3.30.200.20-FF-000198', NULL, 'Myosin light chain kinase, smooth muscle', 123, NULL, NULL, 141154),
(141155, '1.10.510.10-FF-002304', NULL, 'Kinase-like domain-containing protein', 265, NULL, NULL, 141155),
(141156, '1.10.238.10-FF-001058', NULL, 'Uncharacterized protein', 85, NULL, NULL, 141156),
(141157, '2.60.120.290-FF-000052', NULL, 'Metalloendopeptidase', 114, NULL, NULL, 141157),
(141158, '3.30.110.10-FF-000002', NULL, 'Translation initiation factor IF-3', 96, NULL, NULL, 141158),
(141159, '1.10.472.10-FF-000702', NULL, 'Uncharacterized protein', 251, NULL, NULL, 141159),
(141160, '2.90.10.10-FF-000051', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase SD2-5', 110, NULL, NULL, 141160),
(141161, '3.30.830.10-FF-000023', NULL, 'Mitochondrial processing peptidase alpha subunit', 234, NULL, NULL, 141161),
(141162, '3.40.1390.20-FF-000011', NULL, 'Manganese-dependent inorganic pyrophosphatase', 114, NULL, NULL, 141162),
(141163, '2.60.40.10-FF-000363', NULL, 'neurofascin isoform X1', 114, NULL, NULL, 141163),
(141164, '2.60.40.10-FF-004325', NULL, NULL, 88, NULL, NULL, 141164),
(141165, '3.30.70.2610-FF-000001', NULL, 'General transcription factor IIH subunit 4', 78, NULL, NULL, 141165),
(141166, '3.40.190.10-FF-000853', NULL, 'Uncharacterized protein', 67, NULL, NULL, 141166);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(141167, '3.60.40.10-FF-000304', NULL, 'Predicted protein', 296, NULL, NULL, 141167),
(141168, '3.40.50.300-FF-004686', NULL, 'Recombination-defective, isoform B', 327, NULL, NULL, 141168),
(141169, '2.60.40.60-FF-001081', NULL, 'Uncharacterized protein', 133, NULL, NULL, 141169),
(141170, '3.30.70.330-FF-000553', NULL, 'Splicing factor SRp54', 85, NULL, NULL, 141170),
(141171, '2.10.25.10-FF-000684', NULL, 'EGF, latrophilin seven transmembrane domain-containing protein 1', 45, NULL, NULL, 141171),
(141172, '1.10.1450.10-FF-000016', NULL, 'Tetraspanin', 89, NULL, NULL, 141172),
(141173, '3.90.550.10-FF-000555', NULL, 'Uncharacterized protein', 201, NULL, NULL, 141173),
(141174, '2.30.29.30-FF-000260', NULL, 'Rho GTPase activating protein 15', 120, NULL, NULL, 141174),
(141175, '1.10.510.10-FF-000359', NULL, 'Mitogen-activated protein kinase 1, putative, expressed', 269, NULL, NULL, 141175),
(141176, '3.30.160.60-FF-000576', NULL, 'C2H2 transcription factor (AmdX)', 45, NULL, NULL, 141176),
(141177, '3.30.830.10-FF-000242', NULL, 'Clan ME, family M16, insulinase-like metallopeptidase', 208, NULL, NULL, 141177),
(141178, '2.60.40.60-FF-000681', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1', 105, NULL, NULL, 141178),
(141179, '1.25.10.10-FF-000635', NULL, 'Importin beta-2 subunit, putative', 349, NULL, NULL, 141179),
(141180, '1.20.1070.10-FF-002137', NULL, 'Uncharacterized protein', 242, NULL, NULL, 141180),
(141181, '2.30.22.10-FF-000002', NULL, 'GrpE protein homolog', 57, NULL, NULL, 141181),
(141182, '3.40.50.10860-FF-000027', NULL, 'Shikimate dehydrogenase (NADP(+))', 111, NULL, NULL, 141182),
(141183, '3.20.20.300-FF-000019', NULL, 'Thermostable beta-glucosidase B, putative', 307, NULL, NULL, 141183),
(141184, '3.40.50.2000-FF-000193', NULL, 'Protein RfbU', 117, NULL, NULL, 141184),
(141185, '3.40.1110.10-FF-000050', NULL, 'Phospholipid-transporting ATPase', 132, NULL, NULL, 141185),
(141186, '1.10.630.10-FF-000413', NULL, 'Os07g0451300 protein', 478, NULL, NULL, 141186),
(141187, '3.30.565.10-FF-000249', NULL, 'Signal-transducing protein, histidine kinase', 146, NULL, NULL, 141187),
(141188, '3.50.50.60-FF-000680', NULL, 'Uncharacterized protein', 132, NULL, NULL, 141188),
(141189, '2.60.40.10-FF-004073', NULL, NULL, 120, NULL, NULL, 141189),
(141190, '3.90.190.10-FF-000022', NULL, 'Receptor-type tyrosine-protein phosphatase epsilon', 295, NULL, NULL, 141190),
(141191, '2.130.10.10-FF-004073', NULL, 'Uncharacterized protein', 205, NULL, NULL, 141191),
(141192, '3.30.1370.10-FF-000083', NULL, 'DEAD (Asp-Glu-Ala-Asp) box polypeptide 43', 96, NULL, NULL, 141192),
(141193, '1.10.8.60-FF-000475', NULL, 'AAA ATPase, cell division control protein, putative', 68, NULL, NULL, 141193),
(141194, '1.25.40.10-FF-001767', NULL, 'Pentatricopeptide repeat-containing protein At5g15340, mitochondrial', 190, NULL, NULL, 141194),
(141195, '3.30.200.20-FF-000759', NULL, 'Non-specific serine/threonine protein kinase', 143, NULL, NULL, 141195),
(141196, '3.40.47.10-FF-000175', NULL, NULL, 88, NULL, NULL, 141196),
(141197, '1.20.1560.10-FF-000314', NULL, 'Heavy metal tolerance factor 1', 344, NULL, NULL, 141197),
(141198, '2.30.30.640-FF-000001', NULL, 'Glycoprotein', 82, NULL, NULL, 141198),
(141199, '3.30.160.60-FF-001560', NULL, 'zinc finger protein 853', 31, NULL, NULL, 141199),
(141200, '3.30.450.20-FF-000042', NULL, 'hypoxia-inducible factor 3-alpha isoform X1', 132, NULL, NULL, 141200),
(141201, '2.30.30.100-FF-000160', NULL, 'Protein CBR-LSM-3', 59, NULL, NULL, 141201),
(141202, '1.20.1540.10-FF-000083', NULL, 'Rhomboid-like protein', 182, NULL, NULL, 141202),
(141203, '3.40.50.720-FF-000219', NULL, 'Cinnamoyl-CoA reductase 1', 329, NULL, NULL, 141203),
(141204, '3.40.50.300-FF-004472', NULL, 'Uncharacterized protein', 290, NULL, NULL, 141204),
(141205, '2.30.29.30-FF-000821', NULL, 'Predicted protein', 103, NULL, NULL, 141205),
(141206, '3.90.70.10-FF-000097', NULL, 'Ubiquitin specific peptidase 32', 196, NULL, NULL, 141206),
(141207, '3.40.50.300-FF-000976', NULL, 'Translocase subunit secA chloroplastic-like', 236, NULL, NULL, 141207);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(141208, '1.25.10.10-FF-000293', NULL, 'Lyase containing HEAT-repeat', 280, NULL, NULL, 141208),
(141209, '1.20.5.110-FF-000329', NULL, 'Syntaxin-22', 100, NULL, NULL, 141209),
(141210, '1.10.472.10-FF-000141', NULL, 'Transcription initiation factor IIB', 114, NULL, NULL, 141210),
(141211, '1.10.3470.10-FF-000057', NULL, 'Probable ABC transporter, putative', 237, NULL, NULL, 141211),
(141212, '3.30.1050.10-FF-000030', NULL, 'Non-specific lipid-transfer protein', 123, NULL, NULL, 141212),
(141213, '1.10.238.10-FF-000097', NULL, 'Alpha-actinin, sarcomeric (F-actin cross linking protein)', 75, NULL, NULL, 141213),
(141214, '3.30.160.60-FF-004994', NULL, NULL, 57, NULL, NULL, 141214),
(141215, '1.10.510.10-FF-003687', NULL, NULL, 169, NULL, NULL, 141215),
(141216, '3.30.420.40-FF-000872', NULL, 'Uncharacterized protein', 67, NULL, NULL, 141216),
(141217, '1.25.40.10-FF-004645', NULL, 'Os05g0307200 protein', 123, NULL, NULL, 141217),
(141218, '1.10.10.60-FF-001173', NULL, NULL, 40, NULL, NULL, 141218),
(141219, '2.10.230.10-FF-000019', NULL, 'DnaJ domain containing protein', 61, NULL, NULL, 141219),
(141220, '1.10.10.10-FF-000697', NULL, 'G protein-coupled receptor 155', 116, NULL, NULL, 141220),
(141221, '3.30.160.60-FF-004314', NULL, NULL, 59, NULL, NULL, 141221),
(141222, '3.40.190.10-FF-000836', NULL, 'Sugar ABC transporter, periplasmic sugar-binding protein', 225, NULL, NULL, 141222),
(141223, '3.30.960.10-FF-000004', NULL, 'Eukaryotic peptide chain release factor subunit 1', 135, NULL, NULL, 141223),
(141224, '1.10.238.20-FF-000004', NULL, 'Pheromone-binding protein Gp-9', 121, NULL, NULL, 141224),
(141225, '1.20.1250.20-FF-001710', NULL, 'Organic cation/carnitine transporter 7', 127, NULL, NULL, 141225),
(141226, '1.10.510.10-FF-004193', NULL, NULL, 106, NULL, NULL, 141226),
(141227, '2.40.160.120-FF-000042', NULL, 'Oxysterol-binding protein 4', 192, NULL, NULL, 141227),
(141228, '3.80.10.10-FF-003303', NULL, 'Toll-9, isoform B', 84, NULL, NULL, 141228),
(141229, '1.20.1070.10-FF-001384', NULL, 'LOC567796 protein', 250, NULL, NULL, 141229),
(141230, '2.60.40.10-FF-001122', NULL, 'NPHS1, nephrin', 98, NULL, NULL, 141230),
(141231, '4.10.280.10-FF-000088', NULL, 'HLH DNA binding protein', 94, NULL, NULL, 141231),
(141232, '2.60.40.10-FF-004769', NULL, NULL, 94, NULL, NULL, 141232),
(141233, '3.10.105.10-FF-000118', NULL, 'Oligopeptide ABC transporter, periplasmic oligopeptide-binding protein', 228, NULL, NULL, 141233),
(141234, '1.25.40.10-FF-001891', NULL, 'Pentatricopeptide repeat-containing protein At4g36680, mitochondrial', 214, NULL, NULL, 141234),
(141235, '3.30.1120.10-FF-000053', NULL, 'Arylsulfatase A', 69, NULL, NULL, 141235),
(141236, '3.30.479.20-FF-000006', NULL, 'Elongation factor Ts', 70, NULL, NULL, 141236),
(141237, '1.25.40.20-FF-000371', NULL, 'G9a, isoform B', 132, NULL, NULL, 141237),
(141238, '1.10.238.220-FF-000005', NULL, 'Protein CBG16342', 87, NULL, NULL, 141238),
(141239, '1.20.870.10-FF-000018', NULL, 'Blast:Ral guanine nucleotide dissociation stimulator-like 1', 198, NULL, NULL, 141239),
(141240, '2.10.25.10-FF-000318', NULL, 'Eyes shut homolog', 37, NULL, NULL, 141240),
(141241, '2.40.10.10-FF-000053', NULL, 'Neurotrypsin', 250, NULL, NULL, 141241),
(141242, '2.130.10.10-FF-003224', NULL, 'Uncharacterized protein', 300, NULL, NULL, 141242),
(141243, '3.80.10.10-FF-003292', NULL, 'Toll-like receptor 2', 78, NULL, NULL, 141243),
(141244, '3.40.640.10-FF-000265', NULL, 'Serine hydroxymethyltransferase, mitochondrial', 159, NULL, NULL, 141244),
(141245, '1.20.1250.10-FF-000072', NULL, 'Prolactin family 3, subfamily a, member 1', 200, NULL, NULL, 141245),
(141246, '3.40.50.300-FF-004135', NULL, 'Thymidine kinase', 142, NULL, NULL, 141246),
(141247, '3.60.15.10-FF-000004', NULL, 'Probable L-ascorbate-6-phosphate lactonase UlaG', 352, NULL, NULL, 141247),
(141248, '3.50.50.60-FF-000348', NULL, '2-polyprenyl-6-methoxyphenol hydroxylase-like oxidoreductase', 373, NULL, NULL, 141248),
(141249, '1.20.1250.20-FF-001159', NULL, 'Monocarboxylate transporter, putative', 234, NULL, NULL, 141249);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(141250, '2.40.30.10-FF-000048', NULL, 'Ferredoxin--NADP reductase, chloroplastic', 139, NULL, NULL, 141250),
(141251, '3.40.50.300-FF-002999', NULL, 'Branched-chain amino acid ABC transporter ATP-binding protein', 259, NULL, NULL, 141251),
(141252, '1.25.40.10-FF-000946', NULL, 'Transcription factor tau 131 kDa subunit', 179, NULL, NULL, 141252),
(141253, '2.120.10.80-FF-000199', NULL, 'F-box/kelch-repeat protein SKIP20', 301, NULL, NULL, 141253),
(141254, '1.20.1730.10-FF-000114', NULL, 'Uncharacterized protein', 140, NULL, NULL, 141254),
(141255, '3.30.200.20-FF-002362', NULL, 'Uncharacterized protein', 108, NULL, NULL, 141255),
(141256, '4.10.1200.10-FF-000001', NULL, 'Respiratory nitrate reductase subunit alpha', 42, NULL, NULL, 141256),
(141257, '3.20.20.140-FF-000286', NULL, 'Putative histidinol-phosphatase', 261, NULL, NULL, 141257),
(141258, '1.10.510.10-FF-002647', NULL, NULL, 174, NULL, NULL, 141258),
(141259, '1.10.418.10-FF-000212', NULL, 'Uncharacterized protein', 86, NULL, NULL, 141259),
(141260, '3.40.50.1000-FF-000685', NULL, NULL, 149, NULL, NULL, 141260),
(141261, '3.40.140.10-FF-000221', NULL, 'Uncharacterized protein', 183, NULL, NULL, 141261),
(141262, '2.40.30.10-FF-000487', NULL, 'Eukaryotic initiation factor', 38, NULL, NULL, 141262),
(141263, '2.60.120.10-FF-000455', NULL, 'Potassium voltage-gated channel subfamily H member 8', 161, NULL, NULL, 141263),
(141264, '3.10.20.90-FF-000155', NULL, 'Ubiquitin-like protein SMT3', 93, NULL, NULL, 141264),
(141265, '1.25.40.180-FF-000037', NULL, 'Nonsense-mediated mRNA decay factor (Upf2)', 239, NULL, NULL, 141265),
(141266, '3.40.630.10-FF-000180', NULL, 'Cytosolic carboxypeptidase-like protein 5', 239, NULL, NULL, 141266),
(141267, '3.40.50.80-FF-000080', NULL, 'NADPH oxidoreductase', 125, NULL, NULL, 141267),
(141268, '1.25.10.10-FF-000765', NULL, 'Transportin 2', 325, NULL, NULL, 141268),
(141269, '3.40.190.10-FF-000741', NULL, 'Uncharacterized protein', 63, NULL, NULL, 141269),
(141270, '1.10.10.10-FF-001214', NULL, 'Response regulator receiver', 104, NULL, NULL, 141270),
(141271, '3.30.70.890-FF-000029', NULL, 'Phosphomevalonate kinase', 140, NULL, NULL, 141271),
(141272, '1.20.5.930-FF-000002', NULL, 'Integrin, alpha 9', 50, NULL, NULL, 141272),
(141273, '1.20.1280.290-FF-000104', NULL, 'Uncharacterized protein', 62, NULL, NULL, 141273),
(141274, '3.40.720.10-FF-000299', NULL, 'Sulfatase and phosphatidylinositolglycan class N domain-containing protein', 239, NULL, NULL, 141274),
(141275, '3.30.70.870-FF-000023', NULL, 'Tetracycline resistance protein, GTP-binding elongation family', 75, NULL, NULL, 141275),
(141276, '1.20.1270.60-FF-000088', NULL, 'Ivy1p', 214, NULL, NULL, 141276),
(141277, '1.10.8.60-FF-000025', NULL, 'Katanin p60 ATPase-containing subunit A1', 86, NULL, NULL, 141277),
(141278, '3.30.930.10-FF-000295', NULL, 'Lysine--tRNA ligase', 362, NULL, NULL, 141278),
(141279, '3.40.30.10-FF-001041', NULL, 'Peroxiredoxin, thioredoxin peroxidase', 193, NULL, NULL, 141279),
(141280, '2.40.50.90-FF-000028', NULL, 'staphylococcal-like nuclease CAN2', 127, NULL, NULL, 141280),
(141281, '3.40.630.30-FF-000186', NULL, 'N-acetyltransferase', 175, NULL, NULL, 141281),
(141282, '3.30.40.10-FF-001525', NULL, 'abscission/NoCut checkpoint regulator', 70, NULL, NULL, 141282),
(141283, '2.40.10.10-FF-000148', NULL, 'CLIP-domain serine protease', 107, NULL, NULL, 141283),
(141284, '2.130.10.10-FF-004961', NULL, 'Uncharacterized protein', 89, NULL, NULL, 141284),
(141285, '3.40.50.300-FF-001381', NULL, 'Putative lipoprotein ABC transporter, ATP-binding protein', 223, NULL, NULL, 141285),
(141286, '3.40.50.300-FF-005080', NULL, 'ADP-ribosylation factor family, putative', 85, NULL, NULL, 141286),
(141287, '2.60.120.260-FF-000189', NULL, 'Teneurin-m-like Protein', 153, NULL, NULL, 141287),
(141288, '2.10.25.10-FF-001746', NULL, 'Agrin', 37, NULL, NULL, 141288),
(141289, '1.10.1450.10-FF-000128', NULL, 'Tetraspanin', 101, NULL, NULL, 141289),
(141290, '3.30.470.20-FF-000037', NULL, 'Phosphoribosylaminoimidazole carboxylase, chloroplastic', 195, NULL, NULL, 141290);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(141291, '3.40.50.300-FF-006956', NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 10, mitochondrial', 223, NULL, NULL, 141291),
(141292, '2.70.170.10-FF-000012', NULL, 'Nicotinic acetylcholine receptor subunit gamma', 227, NULL, NULL, 141292),
(141293, '1.20.58.760-FF-000041', NULL, 'ATP-dependent zinc metalloprotease FtsH', 192, NULL, NULL, 141293),
(141294, '3.90.70.10-FF-000693', NULL, 'Uncharacterized protein', 226, NULL, NULL, 141294),
(141295, '3.40.50.150-FF-000678', NULL, 'Methyltransferase', 223, NULL, NULL, 141295),
(141296, '2.10.110.10-FF-000286', NULL, 'Uncharacterized protein', 72, NULL, NULL, 141296),
(141297, '3.30.160.40-FF-000025', NULL, 'Porphobilinogen deaminase-like Protein', 88, NULL, NULL, 141297),
(141298, '1.10.510.10-FF-002164', NULL, NULL, 30, NULL, NULL, 141298),
(141299, '3.40.50.170-FF-000004', NULL, 'Methionyl-tRNA formyltransferase', 206, NULL, NULL, 141299),
(141300, '3.30.2350.10-FF-000087', NULL, 'Pseudouridine synthase', 225, NULL, NULL, 141300),
(141301, '2.170.150.40-FF-000001', NULL, 'DUF427 domain-containing protein', 115, NULL, NULL, 141301),
(141302, '3.90.550.50-FF-000224', NULL, 'Hexosyltransferase', 127, NULL, NULL, 141302),
(141303, '3.30.40.10-FF-000699', NULL, 'E3 ubiquitin-protein ligase TRIM31', 80, NULL, NULL, 141303),
(141304, '3.40.50.10490-FF-000006', NULL, 'DnaA initiator-associating protein DiaA', 196, NULL, NULL, 141304),
(141305, '3.90.950.10-FF-000007', NULL, 'dTTP/UTP pyrophosphatase', 188, NULL, NULL, 141305),
(141306, '3.40.50.620-FF-000268', NULL, 'Isoleucine--tRNA ligase, mitochondrial', 228, NULL, NULL, 141306),
(141307, '4.10.40.20-FF-000009', NULL, 'Insulin like growth factor binding protein like 1', 77, NULL, NULL, 141307),
(141308, '1.25.40.10-FF-002503', NULL, 'hsp70-Hsp90 organizing protein 2-like', 58, NULL, NULL, 141308),
(141309, '1.20.960.30-FF-000003', NULL, 'Related to Nuclear receptor co-repressor/HDAC3 complex subunit TBLR1', 82, NULL, NULL, 141309),
(141310, '4.10.1060.10-FF-000012', NULL, 'ubiquitin thioesterase ZRANB1 isoform X1', 36, NULL, NULL, 141310),
(141311, '3.20.20.330-FF-000011', NULL, 'Methionine synthase', 314, NULL, NULL, 141311),
(141312, '1.25.40.10-FF-003689', NULL, 'Putative pentatricopeptide repeat-containing protein', 128, NULL, NULL, 141312),
(141313, '2.60.40.60-FF-000945', NULL, 'Uncharacterized protein', 37, NULL, NULL, 141313),
(141314, '3.30.497.10-FF-000068', NULL, 'Serpin-2 precursor, putative', 163, NULL, NULL, 141314),
(141315, '1.10.1670.10-FF-000027', NULL, 'Endonuclease III homolog', 81, NULL, NULL, 141315),
(141316, '3.10.450.10-FF-000015', NULL, 'Histidine-rich glycoprotein', 116, NULL, NULL, 141316),
(141317, '1.25.40.10-FF-003931', NULL, 'Coatomer subunit epsilon', 288, NULL, NULL, 141317),
(141318, '3.30.1060.10-FF-000014', NULL, NULL, 167, NULL, NULL, 141318),
(141319, '3.80.10.10-FF-002786', NULL, 'Uncharacterized protein', 170, NULL, NULL, 141319),
(141320, '1.25.10.10-FF-001271', NULL, 'Sorting Of Apical Proteins', 382, NULL, NULL, 141320),
(141321, '1.20.1250.20-FF-002115', NULL, 'Uncharacterized protein', 228, NULL, NULL, 141321),
(141322, '3.40.50.2000-FF-000316', NULL, 'Probable glycosyl transferase', 104, NULL, NULL, 141322),
(141323, '2.60.40.10-FF-002841', NULL, 'Uncharacterized protein, isoform A', 95, NULL, NULL, 141323),
(141324, '3.30.70.270-FF-000170', NULL, 'Diguanylate cyclase/phosphodiesterase (GGDEF & EAL domain) with PAS/PAC sensor(S)', 171, NULL, NULL, 141324),
(141325, '1.20.58.900-FF-000004', NULL, 'pleckstrin homology domain-containing family M member 2 isoform X2', 162, NULL, NULL, 141325),
(141326, '1.20.58.390-FF-000233', NULL, 'Protein CBR-LGC-39', 252, NULL, NULL, 141326),
(141327, '2.60.120.430-FF-000021', NULL, 'MRLK2', 189, NULL, NULL, 141327),
(141328, '3.40.50.150-FF-000239', NULL, 'Ribosomal RNA small subunit methyltransferase H', 219, NULL, NULL, 141328),
(141329, '2.30.30.100-FF-000165', NULL, 'U6 snRNA-associated Sm-like protein LSm2, putative', 94, NULL, NULL, 141329),
(141330, '3.30.70.330-FF-000570', NULL, 'ALKylated DNA repair protein AlkB homolog', 95, NULL, NULL, 141330);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(141331, '3.40.50.720-FF-000214', NULL, 'L-xylulose reductase', 243, NULL, NULL, 141331),
(141332, '3.30.70.330-FF-000682', NULL, 'Ras GTPase-activating protein-binding protein 2', 161, NULL, NULL, 141332),
(141333, '1.10.730.10-FF-000033', NULL, 'Valine--tRNA ligase', 227, NULL, NULL, 141333),
(141334, '1.10.150.240-FF-000089', NULL, 'Chromosome 7, whole genome shotgun sequence', 72, NULL, NULL, 141334),
(141335, '1.20.120.1750-FF-000001', NULL, 'RBR-type E3 ubiquitin transferase', 81, NULL, NULL, 141335),
(141336, '2.130.10.10-FF-004522', NULL, 'Uncharacterized protein', 231, NULL, NULL, 141336),
(141337, '3.90.1150.10-FF-000182', NULL, 'Cystathionine gamma-synthase', 117, NULL, NULL, 141337),
(141338, '3.40.50.300-FF-004927', NULL, 'Uncharacterized protein ABCG26', 304, NULL, NULL, 141338),
(141339, '2.30.30.790-FF-000006', NULL, '50S ribosomal protein L19', 115, NULL, NULL, 141339),
(141340, '2.120.10.30-FF-000454', NULL, 'Uncharacterized protein', 97, NULL, NULL, 141340),
(141341, '1.20.58.60-FF-000501', NULL, 'Dystrophin, isoform K', 304, NULL, NULL, 141341),
(141342, '3.30.1520.10-FF-000145', NULL, 'Autophagy-related protein 20', 120, NULL, NULL, 141342),
(141343, '3.40.50.1820-FF-001217', NULL, 'Lipase', 366, NULL, NULL, 141343),
(141344, '3.50.30.20-FF-000009', NULL, 'CAD protein', 161, NULL, NULL, 141344),
(141345, '1.10.10.10-FF-001995', NULL, 'Uncharacterized protein', 32, NULL, NULL, 141345),
(141346, '3.30.160.60-FF-003016', NULL, NULL, 29, NULL, NULL, 141346),
(141347, '3.30.200.20-FF-000445', NULL, 'Receptor-like cytosolic serine/threonine-protein kinase RBK2', 105, NULL, NULL, 141347),
(141348, '2.60.120.590-FF-000041', NULL, 'Chromosome 1, whole genome shotgun sequence', 211, NULL, NULL, 141348),
(141349, '3.40.950.10-FF-000024', NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', 163, NULL, NULL, 141349),
(141350, '3.40.50.2300-FF-001586', NULL, NULL, 134, NULL, NULL, 141350),
(141351, '3.10.50.40-FF-000119', NULL, 'Peptidylprolyl isomerase', 119, NULL, NULL, 141351),
(141352, '1.10.555.10-FF-000120', NULL, 'Rho GTPase-activating protein gacN', 229, NULL, NULL, 141352),
(141353, '3.40.50.2000-FF-000788', NULL, 'Uncharacterized protein', 238, NULL, NULL, 141353),
(141354, '4.10.60.10-FF-000215', NULL, 'Uncharacterized protein', 53, NULL, NULL, 141354),
(141355, '3.40.50.300-FF-003516', NULL, 'Putative DNA polymerase III, delta prime subunit', 149, NULL, NULL, 141355),
(141356, '1.25.10.10-FF-002682', NULL, 'Uncharacterized protein', 81, NULL, NULL, 141356),
(141357, '1.25.50.20-FF-000085', NULL, 'Aminopeptidase', 330, NULL, NULL, 141357),
(141358, '1.25.10.10-FF-002794', NULL, 'LOC443698 protein, putative', 237, NULL, NULL, 141358),
(141359, '1.20.1050.10-FF-000091', NULL, 'Chloride intracellular channel exl-1', 151, NULL, NULL, 141359),
(141360, '1.10.400.10-FF-000048', NULL, 'guanine nucleotide-binding protein G(K) subunit alpha-like', 119, NULL, NULL, 141360),
(141361, '1.10.1200.270-FF-000007', NULL, 'Salicylate carboxymethyltransferase', 131, NULL, NULL, 141361),
(141362, '3.80.10.10-FF-004489', NULL, 'Leucine-rich repeat receptor-like tyrosine-protein kinase PXC3', 108, NULL, NULL, 141362),
(141363, '1.20.920.50-FF-000001', NULL, 'Androgen-binding protein', 84, NULL, NULL, 141363),
(141364, '3.90.1030.10-FF-000021', NULL, '50S ribosomal protein L17', 122, NULL, NULL, 141364),
(141365, '2.40.50.140-FF-000105', NULL, 'Myeloid cell nuclear differentiation antigen', 97, NULL, NULL, 141365),
(141366, '6.10.140.2150-FF-000009', NULL, 'Uncharacterized protein', 45, NULL, NULL, 141366),
(141367, '3.30.360.110-FF-000001', NULL, 'S-adenosylmethionine decarboxylase proenzyme', 62, NULL, NULL, 141367),
(141368, '1.10.260.40-FF-000040', NULL, 'POU domain, class 6, transcription factor 2', 90, NULL, NULL, 141368),
(141369, '1.20.140.40-FF-000068', NULL, NULL, 165, NULL, NULL, 141369),
(141370, '3.40.50.150-FF-001184', NULL, 'CurJ', 300, NULL, NULL, 141370),
(141371, '3.40.1190.20-FF-000041', NULL, 'Putative phosphomethylpyrimidine kinase', 253, NULL, NULL, 141371),
(141372, '3.40.50.300-FF-003730', NULL, 'DEAH-box helicase 16', 123, NULL, NULL, 141372);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(141373, '2.60.120.260-FF-000301', NULL, 'AGAP008739-PA', 117, NULL, NULL, 141373),
(141374, '2.60.40.1860-FF-000005', NULL, 'Peptidyl arginine deiminase, type II', 114, NULL, NULL, 141374),
(141375, '3.40.50.300-FF-007092', NULL, 'Small GTP-binding protein, putative', 190, NULL, NULL, 141375),
(141376, '3.40.50.80-FF-000192', NULL, 'Uncharacterized protein', 153, NULL, NULL, 141376),
(141377, '3.30.530.20-FF-000076', NULL, 'START domain containing protein', 208, NULL, NULL, 141377),
(141378, '3.30.40.10-FF-000811', NULL, 'RAD5p DNA helicase/Ubiquitin ligase', 80, NULL, NULL, 141378),
(141379, '3.30.200.20-FF-000315', NULL, 'Calcium-dependent protein kinase 3', 92, NULL, NULL, 141379),
(141380, '2.60.120.920-FF-000191', NULL, 'Predicted protein', 68, NULL, NULL, 141380),
(141381, '3.40.50.300-FF-006052', NULL, 'Uncharacterized protein', 154, NULL, NULL, 141381),
(141382, '3.40.50.970-FF-000013', NULL, 'Pyruvate dehydrogenase E1 component subunit alpha', 360, NULL, NULL, 141382),
(141383, '2.60.120.260-FF-000077', NULL, 'Probable allantoicase', 185, NULL, NULL, 141383),
(141384, '3.40.850.10-FF-000191', NULL, 'Bipolar kinesin, putative', 345, NULL, NULL, 141384),
(141385, '1.25.40.10-FF-000463', NULL, 'Pentatricopeptide repeat-containing protein', 102, NULL, NULL, 141385),
(141386, '1.10.510.10-FF-001450', NULL, 'Protein kinase domain containing protein', 208, NULL, NULL, 141386),
(141387, '2.60.120.620-FF-000089', NULL, 'Multifunctional dioxygenase ausE', 291, NULL, NULL, 141387),
(141388, '1.10.3470.10-FF-000046', NULL, 'Manganese/zinc/iron transport system permease protein', 291, NULL, NULL, 141388),
(141389, '1.10.472.80-FF-000122', NULL, 'TBC1 domain family member 25', 128, NULL, NULL, 141389),
(141390, '3.70.10.10-FF-000055', NULL, 'Cell cycle checkpoint control protein', 45, NULL, NULL, 141390),
(141391, '3.30.230.10-FF-000365', NULL, 'Uncharacterized protein', 97, NULL, NULL, 141391),
(141392, '1.10.510.10-FF-000814', NULL, 'PTI1-like tyrosine-protein kinase 3', 219, NULL, NULL, 141392),
(141393, '2.60.120.650-FF-000115', NULL, 'Predicted protein', 349, NULL, NULL, 141393),
(141394, '1.25.40.180-FF-000251', NULL, NULL, 75, NULL, NULL, 141394),
(141395, '2.30.29.30-FF-001018', NULL, 'Uncharacterized protein', 134, NULL, NULL, 141395),
(141396, '2.130.10.10-FF-000470', NULL, 'Periodic tryptophan protein 2 homolog', 135, NULL, NULL, 141396),
(141397, '3.30.1360.70-FF-000021', NULL, NULL, 116, NULL, NULL, 141397),
(141398, '2.20.100.10-FF-000081', NULL, 'Spondin-1', 56, NULL, NULL, 141398),
(141399, '2.60.40.10-FF-000503', NULL, 'Hemicentin 1', 95, NULL, NULL, 141399),
(141400, '3.30.70.330-FF-003099', NULL, NULL, 96, NULL, NULL, 141400),
(141401, '2.130.10.10-FF-001667', NULL, 'Related to SOF1-involved in 18S pre-rRNA production', 124, NULL, NULL, 141401),
(141402, '3.30.70.330-FF-002008', NULL, NULL, 81, NULL, NULL, 141402),
(141403, '3.10.20.90-FF-000947', NULL, 'Predicted protein', 70, NULL, NULL, 141403),
(141404, '1.10.510.10-FF-002276', NULL, NULL, 133, NULL, NULL, 141404),
(141405, '3.80.10.10-FF-004129', NULL, 'Tyrosine-sulfated glycopeptide receptor 1', 112, NULL, NULL, 141405),
(141406, '2.120.10.30-FF-000083', NULL, 'Peptidyl-glycine alpha-amidating monooxygenase B', 320, NULL, NULL, 141406),
(141407, '1.10.287.70-FF-000649', NULL, 'Potassium channel, putative', 166, NULL, NULL, 141407),
(141408, '1.10.2020.20-FF-000004', NULL, 'WGS project CABT00000000 data, contig 2.6', 160, NULL, NULL, 141408),
(141409, '3.40.50.300-FF-000745', NULL, 'Dynein cytoplasmic 2 heavy chain 1', 333, NULL, NULL, 141409),
(141410, '1.10.20.10-FF-000299', NULL, NULL, 62, NULL, NULL, 141410),
(141411, '3.30.70.1990-FF-000006', NULL, NULL, 103, NULL, NULL, 141411),
(141412, '1.25.40.20-FF-001208', NULL, 'Uncharacterized protein', 104, NULL, NULL, 141412),
(141413, '2.30.39.10-FF-000097', NULL, 'AGAP006909-PA', 132, NULL, NULL, 141413),
(141414, '3.30.540.10-FF-000012', NULL, 'Blast:Putative inositol monophosphatase 3', 166, NULL, NULL, 141414),
(141415, '3.40.720.10-FF-000187', NULL, 'Uncharacterized protein', 330, NULL, NULL, 141415);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(141416, '3.30.160.60-FF-001329', NULL, 'INSM transcriptional repressor 1', 58, NULL, NULL, 141416),
(141417, '3.40.50.410-FF-000323', NULL, 'Protein transport protein SEC23', 204, NULL, NULL, 141417),
(141418, '1.20.58.60-FF-000490', NULL, 'Spectrin beta, non-erythrocytic 5', 136, NULL, NULL, 141418),
(141419, '3.40.50.80-FF-000203', NULL, 'Ferric-chelate reductase/ oxidoreductase', 171, NULL, NULL, 141419),
(141420, '2.30.180.10-FF-000139', NULL, NULL, 135, NULL, NULL, 141420),
(141421, '3.10.290.70-FF-000003', NULL, '40S ribosomal protein S8', 130, NULL, NULL, 141421),
(141422, '1.10.630.10-FF-000666', NULL, 'Os02g0502300 protein', 182, NULL, NULL, 141422),
(141423, '3.90.370.10-FF-000013', NULL, 'Tissue inhibitor of metalloproteinase, putative', 60, NULL, NULL, 141423),
(141424, '3.90.79.10-FF-000206', NULL, '39S mitochondrial ribosomal protein L46-domain-containing protein', 119, NULL, NULL, 141424),
(141425, '1.10.287.110-FF-000274', NULL, 'DnaJ domain containing protein', 109, NULL, NULL, 141425),
(141426, '3.60.21.10-FF-000305', NULL, 'Sphingomyelinase phosphodiesterase', 299, NULL, NULL, 141426),
(141427, '3.30.420.10-FF-000548', NULL, NULL, 70, NULL, NULL, 141427),
(141428, '3.40.50.620-FF-000510', NULL, 'Uncharacterized protein', 311, NULL, NULL, 141428),
(141429, '2.40.20.10-FF-000093', NULL, 'Putative macrophage stimulating 1-like protein', 103, NULL, NULL, 141429),
(141430, '3.10.10.10-FF-000001', NULL, 'Gag-Pol polyprotein', 128, NULL, NULL, 141430),
(141431, '2.60.120.20-FF-000003', NULL, 'Genome polyprotein', 320, NULL, NULL, 141431),
(141432, '3.40.50.300-FF-006389', NULL, 'Uncharacterized protein (Fragment)', 135, NULL, NULL, 141432),
(141433, '3.90.70.10-FF-000237', NULL, 'Dipeptidyl aminopeptidase 3', 179, NULL, NULL, 141433),
(141434, '3.30.830.10-FF-000231', NULL, 'Protease of the insulinase family', 189, NULL, NULL, 141434),
(141435, '3.40.50.620-FF-000740', NULL, 'Universal stress protein A family protein C25B2.10', 155, NULL, NULL, 141435),
(141436, '1.20.1730.10-FF-000002', NULL, 'Sodium/proline symporter', 472, NULL, NULL, 141436),
(141437, '3.30.450.40-FF-000244', NULL, 'Phosphodiesterase', 53, NULL, NULL, 141437),
(141438, '3.40.50.2300-FF-000760', NULL, 'Glutamate receptor 2', 164, NULL, NULL, 141438),
(141439, '3.90.180.10-FF-000201', NULL, 'Uncharacterized protein', 85, NULL, NULL, 141439),
(141440, '1.10.10.10-FF-001091', NULL, 'Biofilm growth-associated repressor', 102, NULL, NULL, 141440),
(141441, '3.30.930.10-FF-000278', NULL, 'Si:ch211-256m1.8', 339, NULL, NULL, 141441),
(141442, '2.60.40.10-FF-004657', NULL, NULL, 108, NULL, NULL, 141442),
(141443, '3.40.50.1820-FF-000020', NULL, 'Lysophospholipase L2', 310, NULL, NULL, 141443),
(141444, '1.25.10.10-FF-002108', NULL, 'Uncharacterized protein', 163, NULL, NULL, 141444),
(141445, '3.30.70.330-FF-002368', NULL, NULL, 103, NULL, NULL, 141445),
(141446, '3.40.50.1820-FF-001791', NULL, 'Uncharacterized protein', 158, NULL, NULL, 141446),
(141447, '2.40.50.140-FF-000095', NULL, 'DNA helicase', 85, NULL, NULL, 141447),
(141448, '2.60.120.260-FF-000526', NULL, 'Uncharacterized protein', 61, NULL, NULL, 141448),
(141449, '3.30.870.30-FF-000003', NULL, 'Uncharacterized protein', 97, NULL, NULL, 141449),
(141450, '1.10.1580.10-FF-000020', NULL, 'GTP-binding protein, putative', 106, NULL, NULL, 141450),
(141451, '3.50.50.60-FF-000236', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 113, NULL, NULL, 141451),
(141452, '1.20.58.390-FF-000019', NULL, 'Gamma-aminobutyric acid (GABA) A receptor, pi', 135, NULL, NULL, 141452),
(141453, '1.20.1250.20-FF-001047', NULL, 'Riboflavin transporter RibJ', 194, NULL, NULL, 141453),
(141454, '2.130.10.10-FF-000695', NULL, 'Lactonase, 7-bladed beta-propeller domain protein', 323, NULL, NULL, 141454),
(141455, '1.10.1410.40-FF-000017', NULL, 'Uncharacterized protein', 72, NULL, NULL, 141455),
(141456, '3.10.20.90-FF-000964', NULL, 'Uncharacterized protein', 38, NULL, NULL, 141456),
(141457, '1.25.40.10-FF-002380', NULL, 'Protein O-mannosyl-transferase TMTC2', 75, NULL, NULL, 141457);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(141458, '3.10.180.10-FF-000039', NULL, 'Trihydroxytoluene oxygenase (AFU_orthologue AFUA_8G02470)', 130, NULL, NULL, 141458),
(141459, '1.25.10.10-FF-000214', NULL, 'MAP3K epsilon protein kinase 1', 190, NULL, NULL, 141459),
(141460, '3.30.40.10-FF-001637', NULL, 'Uncharacterized protein', 56, NULL, NULL, 141460),
(141461, '2.120.10.80-FF-000087', NULL, 'Kelch repeat-containing protein', 126, NULL, NULL, 141461),
(141462, '3.30.160.60-FF-004426', NULL, 'CTCF', 81, NULL, NULL, 141462),
(141463, '1.25.40.20-FF-000483', NULL, 'Ankyrin repeats (3 copies), putative', 169, NULL, NULL, 141463),
(141464, '1.10.10.10-FF-000585', NULL, 'Response regulator receiver domain protein', 102, NULL, NULL, 141464),
(141465, '2.60.40.420-FF-000172', NULL, 'Uncharacterized protein', 191, NULL, NULL, 141465),
(141466, '2.160.20.70-FF-000032', NULL, 'Probable septum site-determining protein MinC', 113, NULL, NULL, 141466),
(141467, '3.30.710.10-FF-000312', NULL, 'BTB and MATH domain-containing protein 42', 127, NULL, NULL, 141467),
(141468, '2.20.100.10-FF-000204', NULL, 'Complement factor properdin', 66, NULL, NULL, 141468),
(141469, '2.130.10.10-FF-001307', NULL, 'elongator complex protein 2 isoform X6', 121, NULL, NULL, 141469),
(141470, '3.40.50.1000-FF-000555', NULL, NULL, 150, NULL, NULL, 141470),
(141471, '3.90.780.10-FF-000050', NULL, 'Uncharacterized protein', 94, NULL, NULL, 141471),
(141472, '1.10.630.10-FF-000306', NULL, 'CYtochrome P450 family', 136, NULL, NULL, 141472),
(141473, '3.40.50.720-FF-000652', NULL, 'Chromosome 12, whole genome shotgun sequence', 116, NULL, NULL, 141473),
(141474, '1.20.1260.10-FF-000027', NULL, 'Ring oxydation complex/ phenylacetic acid degradation', 236, NULL, NULL, 141474),
(141475, '2.130.10.10-FF-003112', NULL, 'Flagellar/basal body protein', 275, NULL, NULL, 141475),
(141476, '2.60.120.920-FF-000089', NULL, 'Dual specificity protein kinase splA', 174, NULL, NULL, 141476),
(141477, '2.10.220.10-FF-000064', NULL, 'Proprotein convertase subtilisin/kexin type 5', 54, NULL, NULL, 141477),
(141478, '3.40.50.300-FF-002218', NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', 167, NULL, NULL, 141478),
(141479, '3.40.1370.10-FF-000035', NULL, '50S ribosomal protein L4', 206, NULL, NULL, 141479),
(141480, '3.10.490.10-FF-000012', NULL, 'AIG2-like (Avirulence induced gene) family protein', 144, NULL, NULL, 141480),
(141481, '1.10.150.20-FF-000172', NULL, 'Meiotic recombination protein (Dmc1), putative (AFU_orthologue AFUA_7G02200)', 76, NULL, NULL, 141481),
(141482, '3.90.110.10-FF-000039', NULL, NULL, 193, NULL, NULL, 141482),
(141483, '2.60.40.10-FF-000475', NULL, 'myelin-associated glycoprotein isoform X1', 94, NULL, NULL, 141483),
(141484, '3.20.20.80-FF-000657', NULL, 'Beta-mannosidase, putative', 61, NULL, NULL, 141484),
(141485, '3.30.160.60-FF-001088', NULL, 'Zinc finger protein 628', 26, NULL, NULL, 141485),
(141486, '3.30.160.60-FF-005371', NULL, NULL, 52, NULL, NULL, 141486),
(141487, '3.40.50.12240-FF-000009', NULL, 'Uncharacterized protein', 123, NULL, NULL, 141487),
(141488, '3.40.718.10-FF-000030', NULL, 'Isocitrate dehydrogenase [NADP]', 228, NULL, NULL, 141488),
(141489, '3.30.360.10-FF-000026', NULL, 'Putative aspartate-semialdehyde dehydrogenase', 183, NULL, NULL, 141489),
(141490, '3.40.50.1820-FF-000149', NULL, 'Alpha/beta hydrolase fold', 276, NULL, NULL, 141490),
(141491, '2.110.10.10-FF-000066', NULL, 'Uncharacterized protein', 74, NULL, NULL, 141491),
(141492, '3.40.50.720-FF-001271', NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase, putative', 195, NULL, NULL, 141492),
(141493, '1.20.1560.10-FF-000202', NULL, 'ABC transporter ATP-binding protein', 347, NULL, NULL, 141493),
(141494, '3.40.50.300-FF-003067', NULL, 'Dephospho-CoA kinase, putative', 203, NULL, NULL, 141494),
(141495, '3.10.129.10-FF-000246', NULL, 'Uncharacterized protein', 133, NULL, NULL, 141495),
(141496, '4.10.1000.10-FF-000020', NULL, 'Translation machinery-associated protein 46', 76, NULL, NULL, 141496),
(141497, '2.130.10.10-FF-004281', NULL, 'Zgc:162420 protein', 128, NULL, NULL, 141497);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(141498, '3.30.1380.20-FF-000030', NULL, 'Trafficking protein particle complex subunit', 188, NULL, NULL, 141498),
(141499, '3.30.40.10-FF-001188', NULL, 'RING finger protein', 74, NULL, NULL, 141499),
(141500, '1.10.1410.20-FF-000011', NULL, 'Predicted protein', 117, NULL, NULL, 141500),
(141501, '3.40.50.300-FF-005984', NULL, 'Predicted protein', 45, NULL, NULL, 141501),
(141502, '1.20.1390.10-FF-000014', NULL, 'Putative cyclin-dependent protein kinase family protein', 59, NULL, NULL, 141502),
(141503, '1.10.3730.20-FF-000069', NULL, 'Uncharacterized protein', 79, NULL, NULL, 141503),
(141504, '1.20.58.60-FF-000260', NULL, 'Kakapo', 108, NULL, NULL, 141504),
(141505, '2.10.25.10-FF-001049', NULL, 'Uncharacterized protein', 48, NULL, NULL, 141505),
(141506, '1.20.1070.10-FF-000086', NULL, 'Dopamine D2 receptor 2', 239, NULL, NULL, 141506),
(141507, '1.10.1900.40-FF-000004', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 55, NULL, NULL, 141507),
(141508, '2.30.30.190-FF-000023', NULL, 'Nip100p', 95, NULL, NULL, 141508),
(141509, '2.60.40.60-FF-000248', NULL, 'Protocadherin 10', 104, NULL, NULL, 141509),
(141510, '3.40.50.300-FF-003163', NULL, 'Miro family protein', 197, NULL, NULL, 141510),
(141511, '2.60.40.150-FF-000731', NULL, 'Calpain-5', 112, NULL, NULL, 141511),
(141512, '2.60.40.340-FF-000018', NULL, NULL, 111, NULL, NULL, 141512),
(141513, '3.40.190.10-FF-000044', NULL, 'Chorismate mutase/prephenate dehydratase', 88, NULL, NULL, 141513),
(141514, '3.40.50.720-FF-001933', NULL, 'Nadh-ubiquinone oxidoreductase', 287, NULL, NULL, 141514),
(141515, '2.130.10.10-FF-005933', NULL, 'Predicted protein', 264, NULL, NULL, 141515),
(141516, '3.40.50.1100-FF-000046', NULL, 'THR4p Threonine synthase', 252, NULL, NULL, 141516),
(141517, '3.40.50.12650-FF-000014', NULL, 'DNA repair protein', 63, NULL, NULL, 141517),
(141518, '3.40.50.300-FF-008390', NULL, 'DNA helicase', 195, NULL, NULL, 141518),
(141519, '2.40.70.10-FF-000045', NULL, 'Basic 7S globulin', 194, NULL, NULL, 141519),
(141520, '3.40.350.10-FF-000046', NULL, 'Xaa-pro aminopeptidase, putative', 138, NULL, NULL, 141520),
(141521, '3.90.76.10-FF-000060', NULL, 'Putative bifunctional protein [include methyl-accepting chemotaxis protein and an extracellular solute-binding protein]', 149, NULL, NULL, 141521),
(141522, '3.90.190.10-FF-000027', NULL, 'Protein tyrosine phosphatase domain containing 1', 162, NULL, NULL, 141522),
(141523, '3.40.50.10440-FF-000003', NULL, 'Homodimeric dihydroxyacetone kinase', 171, NULL, NULL, 141523),
(141524, '3.40.80.10-FF-000021', NULL, 'Putative N-acetylmuramoyl-L-alanine amidase', 174, NULL, NULL, 141524),
(141525, '2.40.70.10-FF-000141', NULL, 'Uncharacterized protein', 153, NULL, NULL, 141525),
(141526, '3.90.550.10-FF-000241', NULL, 'Uncharacterized glycosyltransferase MT1564', 212, NULL, NULL, 141526),
(141527, '1.25.40.10-FF-002279', NULL, 'Uncharacterized protein', 161, NULL, NULL, 141527),
(141528, '1.25.40.10-FF-000042', NULL, 'C-myc promoter-binding protein isoform X1', 101, NULL, NULL, 141528),
(141529, '3.30.559.30-FF-000050', NULL, 'Nonribosomal peptide synthase 2', 265, NULL, NULL, 141529),
(141530, '1.20.140.150-FF-000052', NULL, 'Sur7p', 219, NULL, NULL, 141530),
(141531, '2.40.110.10-FF-000037', NULL, 'Acyl-CoA dehydrogenase FadE28', 92, NULL, NULL, 141531),
(141532, '2.30.29.30-FF-000613', NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', 104, NULL, NULL, 141532),
(141533, '3.30.160.60-FF-000262', NULL, 'PR domain zinc finger protein 1', 30, NULL, NULL, 141533),
(141534, '4.10.365.10-FF-000009', NULL, 'Cyclin-dependent kinase inhibitor 1A', 81, NULL, NULL, 141534),
(141535, '2.20.25.90-FF-000016', NULL, 'Acetylene hydratase', 57, NULL, NULL, 141535),
(141536, '3.10.20.90-FF-000508', NULL, 'GM11836', 118, NULL, NULL, 141536),
(141537, '2.10.70.10-FF-000075', NULL, 'Complement component C7', 62, NULL, NULL, 141537),
(141538, '1.10.510.10-FF-002731', NULL, NULL, 146, NULL, NULL, 141538),
(141539, '4.10.40.30-FF-000001', NULL, 'Cocaine-and amphetamine-regulated transcript protein', 41, NULL, NULL, 141539);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(141540, '1.20.120.1910-FF-000055', NULL, 'Uncharacterized protein', 73, NULL, NULL, 141540),
(141541, '1.10.8.270-FF-000020', NULL, 'Putative TBC1 domain family member 25', 112, NULL, NULL, 141541),
(141542, '1.10.287.770-FF-000005', NULL, 'Amiloride-sensitive sodium channel subunit gamma', 62, NULL, NULL, 141542),
(141543, '2.60.40.10-FF-001094', NULL, 'Cell surface glycoprotein MUC18', 108, NULL, NULL, 141543),
(141544, '3.40.50.800-FF-000120', NULL, 'Glycyl tRNA synthetase', 99, NULL, NULL, 141544),
(141545, '2.130.10.10-FF-000239', NULL, 'DNA damage-binding protein 1a', 343, NULL, NULL, 141545),
(141546, '3.30.2020.30-FF-000012', NULL, 'Gamma-butyrobetaine hydroxylase subfamily, putative', 88, NULL, NULL, 141546),
(141547, '1.20.1280.20-FF-000026', NULL, 'Uncharacterized protein', 76, NULL, NULL, 141547),
(141548, '3.40.50.300-FF-006473', NULL, 'Uncharacterized protein', 118, NULL, NULL, 141548),
(141549, '3.40.50.300-FF-001038', NULL, 'ABC transporter B family member 25', 255, NULL, NULL, 141549),
(141550, '3.40.50.1460-FF-000120', NULL, 'Caspase, apoptotic cysteine protease, putative', 268, NULL, NULL, 141550),
(141551, '2.160.20.10-FF-000250', NULL, 'Predicted protein', 95, NULL, NULL, 141551),
(141552, '3.40.630.30-FF-000539', NULL, 'Glycylpeptide N-tetradecanoyltransferase 1', 34, NULL, NULL, 141552),
(141553, '1.10.510.10-FF-000831', NULL, 'cyclin-dependent kinase 4', 204, NULL, NULL, 141553),
(141554, '3.90.1140.10-FF-000006', NULL, 'U6 snRNA phosphodiesterase', 193, NULL, NULL, 141554),
(141555, '3.40.50.140-FF-000006', NULL, 'DNA topoisomerase I', 153, NULL, NULL, 141555),
(141556, '3.30.40.10-FF-002256', NULL, 'Nuclear receptor binding SET domain protein 1a', 56, NULL, NULL, 141556),
(141557, '3.40.30.10-FF-000310', NULL, 'Predicted protein', 80, NULL, NULL, 141557),
(141558, '3.40.50.80-FF-000175', NULL, 'NADPH-dependent diflavin oxidoreductase', 66, NULL, NULL, 141558),
(141559, '3.90.226.10-FF-000095', NULL, 'Enoyl-CoA hydratase', 216, NULL, NULL, 141559),
(141560, '3.20.20.390-FF-000001', NULL, 'Heptaprenylglyceryl phosphate synthase', 240, NULL, NULL, 141560),
(141561, '2.120.10.30-FF-000206', NULL, 'Predicted protein', 199, NULL, NULL, 141561),
(141562, '2.40.30.270-FF-000034', NULL, 'DNA replication ATP-dependent helicase/nuclease dna2', 112, NULL, NULL, 141562),
(141563, '3.30.1490.20-FF-000021', NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', 62, NULL, NULL, 141563),
(141564, '3.90.1180.10-FF-000020', NULL, NULL, 64, NULL, NULL, 141564),
(141565, '2.60.40.770-FF-000029', NULL, 'Predicted protein', 129, NULL, NULL, 141565),
(141566, '3.30.1360.40-FF-000023', NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', 78, NULL, NULL, 141566),
(141567, '3.30.160.110-FF-000001', NULL, 'Siroheme synthase', 36, NULL, NULL, 141567),
(141568, '3.30.450.20-FF-000137', NULL, 'Two-component sensor histidine kinase', 101, NULL, NULL, 141568),
(141569, '3.40.50.11500-FF-000023', NULL, NULL, 100, NULL, NULL, 141569),
(141570, '3.40.1190.10-FF-000049', NULL, NULL, 44, NULL, NULL, 141570),
(141571, '1.10.10.480-FF-000002', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit beta', 67, NULL, NULL, 141571),
(141572, '1.10.620.20-FF-000028', NULL, 'Acyl-[acyl-carrier-protein] desaturase', 223, NULL, NULL, 141572),
(141573, '3.30.420.40-FF-000175', NULL, 'Chromatin remodeling and histone acetyltransferase complexes subunit', 31, NULL, NULL, 141573),
(141574, '1.10.150.340-FF-000001', NULL, 'Cytosolic 5-nucleotidase 3-like', 82, NULL, NULL, 141574),
(141575, '3.80.10.10-FF-001375', NULL, 'Uncharacterized protein', 160, NULL, NULL, 141575),
(141576, '1.10.510.10-FF-001219', NULL, 'serine/threonine-protein kinase greatwall isoform X1', 204, NULL, NULL, 141576),
(141577, '3.30.420.10-FF-000099', NULL, 'ERI1 exoribonuclease 3 isoform X3', 155, NULL, NULL, 141577),
(141578, '1.20.59.10-FF-000016', NULL, 'Prephenate dehydratase / chorismate mutase', 108, NULL, NULL, 141578),
(141579, '1.25.40.10-FF-003459', NULL, 'Os07g0635800 protein', 108, NULL, NULL, 141579);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(141580, '3.40.50.1820-FF-001329', NULL, 'Carboxylic ester hydrolase', 257, NULL, NULL, 141580),
(141581, '1.10.1020.10-FF-000001', NULL, 'Site-specific DNA-methyltransferase (adenine-specific)', 100, NULL, NULL, 141581),
(141582, '1.10.630.10-FF-000649', NULL, 'Uncharacterized protein', 206, NULL, NULL, 141582),
(141583, '3.30.565.10-FF-000013', NULL, 'Two-component sensor histidine kinase', 154, NULL, NULL, 141583),
(141584, '3.30.70.330-FF-000665', NULL, 'Polyadenylate-binding protein-interacting protein 10', 79, NULL, NULL, 141584),
(141585, '1.10.420.10-FF-000032', NULL, 'Predicted protein', 147, NULL, NULL, 141585),
(141586, '2.20.25.20-FF-000006', NULL, 'F-box only protein 5', 57, NULL, NULL, 141586),
(141587, '3.30.780.10-FF-000018', NULL, 'Translation machinery-associated protein 22', 119, NULL, NULL, 141587),
(141588, '1.10.730.20-FF-000019', NULL, 'Predicted protein', 272, NULL, NULL, 141588),
(141589, '1.25.10.10-FF-000877', NULL, 'Serine/threonine-protein kinase TOR', 345, NULL, NULL, 141589),
(141590, '1.10.30.10-FF-000125', NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily E member 1', 104, NULL, NULL, 141590),
(141591, '2.60.120.10-FF-000567', NULL, 'Predicted protein', 98, NULL, NULL, 141591),
(141592, '3.40.50.720-FF-000091', NULL, 'Sorbitol-6-phosphate dehydrogenase', 257, NULL, NULL, 141592),
(141593, '3.30.70.1230-FF-000020', NULL, 'Adenylate cyclase', 239, NULL, NULL, 141593),
(141594, '2.60.200.40-FF-000032', NULL, 'Diacylglycerol kinase', 161, NULL, NULL, 141594),
(141595, '1.10.10.60-FF-000684', NULL, 'Homeodomain-like superfamily protein', 63, NULL, NULL, 141595),
(141596, '3.20.20.70-FF-000637', NULL, NULL, 260, NULL, NULL, 141596),
(141597, '2.30.42.10-FF-000127', NULL, 'Pro-interleukin-16', 111, NULL, NULL, 141597),
(141598, '3.80.20.20-FF-000024', NULL, 'Erb-b2 receptor tyrosine kinase 3b', 182, NULL, NULL, 141598),
(141599, '3.40.50.1820-FF-000812', NULL, 'Non-ribosomal peptide synthetase', 249, NULL, NULL, 141599),
(141600, '3.30.420.150-FF-000022', NULL, 'Ppx/GppA phosphatase family-domain-containing protein', 61, NULL, NULL, 141600),
(141601, '1.10.10.10-FF-000242', NULL, 'E3 ubiquitin-protein ligase SHPRH isoform X1', 80, NULL, NULL, 141601),
(141602, '3.100.10.10-FF-000063', NULL, NULL, 178, NULL, NULL, 141602),
(141603, '2.130.10.10-FF-001184', NULL, 'Unplaced genomic scaffold supercont2.6, whole genome shotgun sequence', 317, NULL, NULL, 141603),
(141604, '2.60.120.620-FF-000117', NULL, 'Uncharacterized protein', 152, NULL, NULL, 141604),
(141605, '3.30.160.60-FF-003246', NULL, 'paternally-expressed gene 3 protein isoform X1', 34, NULL, NULL, 141605),
(141606, '3.20.20.80-FF-000174', NULL, 'YIR007W-like protein', 207, NULL, NULL, 141606),
(141607, '2.60.40.420-FF-000155', NULL, 'Protein CBG16448', 147, NULL, NULL, 141607),
(141608, '2.30.29.30-FF-000046', NULL, 'FERM, RhoGEF and pleckstrin domain-containing protein 1', 103, NULL, NULL, 141608),
(141609, '1.20.1740.10-FF-000188', NULL, 'Amino acid transporter, putative', 263, NULL, NULL, 141609),
(141610, '2.40.30.10-FF-000150', NULL, 'NADH-cytochrome b5 reductase, putative', 122, NULL, NULL, 141610),
(141611, '3.40.50.1700-FF-000001', NULL, 'probable beta-D-xylosidase 2', 248, NULL, NULL, 141611),
(141612, '3.40.50.2300-FF-000193', NULL, 'Glutamate receptor ionotropic, NMDA 2B', 156, NULL, NULL, 141612),
(141613, '1.10.10.60-FF-000228', NULL, 'Myb-related protein 308', 48, NULL, NULL, 141613),
(141614, '2.60.40.150-FF-000068', NULL, 'multiple C2 and transmembrane domain-containing protein 1 isoform X2', 135, NULL, NULL, 141614),
(141615, '2.60.120.200-FF-000778', NULL, 'Galectin', 150, NULL, NULL, 141615),
(141616, '3.40.50.720-FF-002552', NULL, 'Uncharacterized protein', 65, NULL, NULL, 141616),
(141617, '2.60.120.260-FF-000638', NULL, 'Uncharacterized protein', 105, NULL, NULL, 141617),
(141618, '1.10.150.20-FF-000284', NULL, 'Meiotic recombination protein DMC1-like protein', 31, NULL, NULL, 141618),
(141619, '2.70.50.60-FF-000001', NULL, 'Sugar ABC transporter ATP-binding protein', 136, NULL, NULL, 141619);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(141620, '1.10.1900.10-FF-000012', NULL, 'Uncharacterized protein', 85, NULL, NULL, 141620),
(141621, '1.10.238.10-FF-001283', NULL, 'Uncharacterized protein', 59, NULL, NULL, 141621),
(141622, '3.30.460.10-FF-000202', NULL, 'Poly(A) RNA polymerase, mitochondrial', 86, NULL, NULL, 141622),
(141623, '3.30.160.60-FF-006214', NULL, NULL, 90, NULL, NULL, 141623),
(141624, '1.25.40.10-FF-003791', NULL, 'Uncharacterized protein', 146, NULL, NULL, 141624),
(141625, '3.90.70.10-FF-000125', NULL, 'Ubiquitin C-terminal hydrolase, putative', 377, NULL, NULL, 141625),
(141626, '2.160.20.10-FF-000042', NULL, 'Glycoside hydrolase family 28 protein', 399, NULL, NULL, 141626),
(141627, '3.10.20.30-FF-000053', NULL, 'Molybdopterin synthase sulfur carrier subunit', 87, NULL, NULL, 141627),
(141628, '3.40.50.1820-FF-001661', NULL, 'Carboxypeptidase', 300, NULL, NULL, 141628),
(141629, '1.20.1420.30-FF-000018', NULL, 'Sodium/potassium/calcium exchanger 2', 128, NULL, NULL, 141629),
(141630, '3.40.50.10890-FF-000020', NULL, 'Uncharacterized protein', 166, NULL, NULL, 141630),
(141631, '1.50.40.10-FF-000399', NULL, 'Uncharacterized protein', 126, NULL, NULL, 141631),
(141632, '3.30.70.330-FF-001750', NULL, NULL, 109, NULL, NULL, 141632),
(141633, '1.10.8.60-FF-000368', NULL, 'Uncharacterized protein', 79, NULL, NULL, 141633),
(141634, '3.30.230.10-FF-000382', NULL, 'Mevalonate 3-kinase', 176, NULL, NULL, 141634),
(141635, '2.60.40.790-FF-000136', NULL, NULL, 51, NULL, NULL, 141635),
(141636, '2.30.42.10-FF-000571', NULL, NULL, 95, NULL, NULL, 141636),
(141637, '3.30.470.20-FF-000133', NULL, 'Probable tubulin--tyrosine ligase C12B10.04', 257, NULL, NULL, 141637),
(141638, '1.20.1280.50-FF-000254', NULL, 'Predicted protein', 85, NULL, NULL, 141638),
(141639, '3.40.50.300-FF-003859', NULL, 'Predicted protein', 175, NULL, NULL, 141639),
(141640, '1.25.40.20-FF-001652', NULL, 'Uncharacterized protein', 88, NULL, NULL, 141640),
(141641, '3.40.50.1240-FF-000077', NULL, 'Glucosyl-3-phosphoglycerate phosphatase', 223, NULL, NULL, 141641),
(141642, '3.40.50.10810-FF-000136', NULL, 'SNF2 family N-terminal domain-domain-containing protein', 164, NULL, NULL, 141642),
(141643, '3.30.9.10-FF-000278', NULL, 'Uncharacterized protein', 62, NULL, NULL, 141643),
(141644, '1.20.1560.10-FF-000174', NULL, 'multidrug resistance protein 1A', 23, NULL, NULL, 141644),
(141645, '1.50.10.10-FF-000010', NULL, 'alpha-1,2-Mannosidase', 454, NULL, NULL, 141645),
(141646, '1.10.510.10-FF-000270', NULL, 'Guanylate cyclase', 269, NULL, NULL, 141646),
(141647, '2.20.28.10-FF-000044', NULL, 'DNA helicase', 61, NULL, NULL, 141647),
(141648, '3.30.70.330-FF-000114', NULL, 'RNA-binding protein 10 isoform X1', 132, NULL, NULL, 141648),
(141649, '1.20.1420.10-FF-000012', NULL, 'Rhea, isoform B', 170, NULL, NULL, 141649),
(141650, '2.60.40.10-FF-002403', NULL, 'Uncharacterized protein', 120, NULL, NULL, 141650),
(141651, '2.40.50.140-FF-000448', NULL, 'rRNA biogenesis protein RRP5', 82, NULL, NULL, 141651),
(141652, '3.20.20.70-FF-000188', NULL, 'Mycofactocin radical SAM maturase MftC', 296, NULL, NULL, 141652),
(141653, '3.40.50.1000-FF-000342', NULL, 'Putative hydrolase', 125, NULL, NULL, 141653),
(141654, '3.40.850.10-FF-000409', NULL, 'Kinesin-like protein', 254, NULL, NULL, 141654),
(141655, '3.60.21.10-FF-000176', NULL, 'Serine/threonine-protein phosphatase', 344, NULL, NULL, 141655),
(141656, '3.40.50.1220-FF-000071', NULL, 'Putative pyruvate/indole-pyruvate carboxylase', 159, NULL, NULL, 141656),
(141657, '1.20.1070.10-FF-000114', NULL, 'Growth hormone releasing hormone receptor', 284, NULL, NULL, 141657),
(141658, '2.60.120.10-FF-000112', NULL, 'Mannose-6-phosphate isomerase, class I', 86, NULL, NULL, 141658),
(141659, '3.30.160.60-FF-004977', NULL, NULL, 33, NULL, NULL, 141659),
(141660, '1.25.40.10-FF-001222', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 93, NULL, NULL, 141660),
(141661, '1.10.565.10-FF-000177', NULL, 'Nuclear receptor subfamily 5, group A, member 1a', 167, NULL, NULL, 141661),
(141662, '2.20.25.530-FF-000016', NULL, 'Uncharacterized protein', 70, NULL, NULL, 141662);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(141663, '3.80.10.10-FF-000886', NULL, 'Leucine-rich Repeats (LRR) and Calponin Homology (CH) domain homolog', 241, NULL, NULL, 141663),
(141664, '3.30.50.10-FF-000172', NULL, 'Protein CBG01321', 60, NULL, NULL, 141664),
(141665, '1.10.3210.10-FF-000061', NULL, 'Metal dependent phosphohydrolase', 172, NULL, NULL, 141665),
(141666, '3.30.160.60-FF-004657', NULL, NULL, 26, NULL, NULL, 141666),
(141667, '3.30.450.40-FF-000031', NULL, 'Phosphodiesterase', 187, NULL, NULL, 141667),
(141668, '2.20.70.10-FF-000226', NULL, 'WW domain-containing protein A', 49, NULL, NULL, 141668),
(141669, '2.170.150.20-FF-000006', NULL, 'Peptide-methionine (R)-S-oxide reductase', 137, NULL, NULL, 141669),
(141670, '3.40.630.10-FF-000096', NULL, 'M18 aspartyl aminopeptidase', 80, NULL, NULL, 141670),
(141671, '1.20.1280.290-FF-000076', NULL, 'Sugar transporter SWEET', 93, NULL, NULL, 141671),
(141672, '1.25.10.10-FF-003171', NULL, 'Uncharacterized protein', 334, NULL, NULL, 141672),
(141673, '1.20.920.30-FF-000006', NULL, 'Cytoplasmic dynein 2 heavy chain 1', 199, NULL, NULL, 141673),
(141674, '2.120.10.10-FF-000004', NULL, 'Hemagglutinin-neuraminidase', 446, NULL, NULL, 141674),
(141675, '1.20.144.10-FF-000068', NULL, 'Predicted protein', 209, NULL, NULL, 141675),
(141676, '1.20.1070.10-FF-000215', NULL, 'G protein-coupled receptor 151', 317, NULL, NULL, 141676),
(141677, '3.80.10.10-FF-003972', NULL, 'Si:dkey-286j17.4', 162, NULL, NULL, 141677),
(141678, '3.30.200.20-FF-002440', NULL, 'Tyrosine-protein kinase', 68, NULL, NULL, 141678),
(141679, '3.40.50.300-FF-001830', NULL, 'Cytidylate kinase', 225, NULL, NULL, 141679),
(141680, '3.40.50.2000-FF-000760', NULL, 'Glycosyltransferase (Type 1)', 178, NULL, NULL, 141680),
(141681, '2.120.10.30-FF-000437', NULL, 'Uncharacterized protein', 126, NULL, NULL, 141681),
(141682, '3.30.40.10-FF-001767', NULL, 'Uncharacterized protein', 72, NULL, NULL, 141682),
(141683, '3.40.1350.10-FF-000039', NULL, 'Gut-2', 81, NULL, NULL, 141683),
(141684, '2.60.40.150-FF-000170', NULL, 'Protein CELLULOSE SYNTHASE INTERACTIVE 1', 122, NULL, NULL, 141684),
(141685, '3.40.50.2300-FF-000316', NULL, 'Two-component response regulator-like APRR1', 240, NULL, NULL, 141685),
(141686, '1.20.1070.10-FF-001625', NULL, 'Uncharacterized protein', 143, NULL, NULL, 141686),
(141687, '3.30.420.40-FF-000203', NULL, 'Actin-related protein 4', 180, NULL, NULL, 141687),
(141688, '2.130.10.30-FF-000133', NULL, 'ABR238Wp', 399, NULL, NULL, 141688),
(141689, '3.30.420.140-FF-000036', NULL, 'Uncharacterized protein', 172, NULL, NULL, 141689),
(141690, '2.60.40.10-FF-000846', NULL, 'Hyaluronan and proteoglycan link protein 2', 107, NULL, NULL, 141690),
(141691, '1.20.1050.10-FF-000101', NULL, 'Glutathione S-transferase Mu 4', 105, NULL, NULL, 141691),
(141692, '2.70.50.80-FF-000007', NULL, 'Uncharacterized protein', 144, NULL, NULL, 141692),
(141693, '3.40.30.10-FF-001058', NULL, 'Peroxiredoxin', 171, NULL, NULL, 141693),
(141694, '1.25.40.20-FF-001551', NULL, 'Uncharacterized protein', 109, NULL, NULL, 141694),
(141695, '3.30.70.270-FF-000074', NULL, 'Diguanylate cyclase DosC', 165, NULL, NULL, 141695),
(141696, '2.40.10.120-FF-000018', NULL, 'Genome polyprotein', 180, NULL, NULL, 141696),
(141697, '3.30.430.20-FF-000012', NULL, 'Cysteine-rich receptor-like protein kinase 25', 105, NULL, NULL, 141697),
(141698, '3.10.20.90-FF-000593', NULL, 'Zgc:158659', 142, NULL, NULL, 141698),
(141699, '3.80.10.10-FF-001824', NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g53440', 102, NULL, NULL, 141699),
(141700, '3.30.230.70-FF-000017', NULL, 'Exosome complex component Rrp42', 271, NULL, NULL, 141700),
(141701, '3.30.160.60-FF-004882', NULL, NULL, 41, NULL, NULL, 141701),
(141702, '3.30.160.60-FF-003454', NULL, 'zinc finger protein 473 isoform X2', 35, NULL, NULL, 141702),
(141703, '2.130.10.10-FF-000127', NULL, 'Eukaryotic translation initiation factor 3 subunit I', 326, NULL, NULL, 141703),
(141704, '2.60.40.10-FF-005837', NULL, NULL, 127, NULL, NULL, 141704),
(141705, '2.130.10.10-FF-004410', NULL, 'Uncharacterized protein', 371, NULL, NULL, 141705);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(141706, '3.40.50.720-FF-001484', NULL, 'uncharacterized protein LOC100179743', 139, NULL, NULL, 141706),
(141707, '1.25.10.10-FF-002552', NULL, 'Os11g0638900 protein', 176, NULL, NULL, 141707),
(141708, '1.10.8.270-FF-000132', NULL, 'Uncharacterized protein', 98, NULL, NULL, 141708),
(141709, '3.60.20.10-FF-000090', NULL, 'Proteasome subunit beta', 215, NULL, NULL, 141709),
(141710, '3.40.630.10-FF-000421', NULL, 'Carboxypeptidase A', 294, NULL, NULL, 141710),
(141711, '3.40.50.150-FF-000127', NULL, 'mRNA cap guanine-N7 methyltransferase', 285, NULL, NULL, 141711),
(141712, '2.60.40.2030-FF-000057', NULL, 'Extracellular nuclease', 112, NULL, NULL, 141712),
(141713, '3.80.10.10-FF-000206', NULL, 'leucine-rich repeat-containing protein 40', 144, NULL, NULL, 141713),
(141714, '2.40.50.100-FF-000223', NULL, 'Uncharacterized protein', 71, NULL, NULL, 141714),
(141715, '2.60.120.10-FF-000798', NULL, 'Uncharacterized protein', 132, NULL, NULL, 141715),
(141716, '1.20.1250.20-FF-001614', NULL, 'Uncharacterized protein', 170, NULL, NULL, 141716),
(141717, '3.40.1110.10-FF-000033', NULL, 'Phospholipid-transporting ATPase', 144, NULL, NULL, 141717),
(141718, '3.30.230.10-FF-000157', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 154, NULL, NULL, 141718),
(141719, '2.70.130.10-FF-000015', NULL, 'Insulin-like growth factor 2 receptor', 141, NULL, NULL, 141719),
(141720, '3.30.70.100-FF-000175', NULL, NULL, 68, NULL, NULL, 141720),
(141721, '3.90.480.20-FF-000007', NULL, 'Ferredoxin--nitrite reductase', 185, NULL, NULL, 141721),
(141722, '3.40.50.2000-FF-000333', NULL, 'GM14531', 204, NULL, NULL, 141722),
(141723, '3.40.47.10-FF-000192', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase II', 436, NULL, NULL, 141723),
(141724, '1.20.810.10-FF-000026', NULL, 'Cytochrome b/b6', 394, NULL, NULL, 141724),
(141725, '1.10.10.10-FF-001310', NULL, 'RNA polymerase sigma factor', 75, NULL, NULL, 141725),
(141726, '3.30.1640.10-FF-000064', NULL, 'DNA helicase', 108, NULL, NULL, 141726),
(141727, '1.25.40.730-FF-000017', NULL, 'Clathrin heavy chain', 61, NULL, NULL, 141727),
(141728, '1.20.272.10-FF-000011', NULL, 'Replication factor C subunit 2', 91, NULL, NULL, 141728),
(141729, '3.40.630.30-FF-000427', NULL, 'Acetyltransferase, putative', 136, NULL, NULL, 141729),
(141730, '3.40.50.2300-FF-001474', NULL, NULL, 144, NULL, NULL, 141730),
(141731, '3.30.200.20-FF-000203', NULL, 'Calcium/calmodulin-dependent protein kinase type 1', 98, NULL, NULL, 141731),
(141732, '3.30.70.330-FF-000322', NULL, 'CUGBP Elav-like family member 2', 95, NULL, NULL, 141732),
(141733, '2.170.130.20-FF-000011', NULL, NULL, 99, NULL, NULL, 141733),
(141734, '3.30.450.20-FF-000025', NULL, 'Neuronal PAS domain protein 3 isoform 1', 171, NULL, NULL, 141734),
(141735, '2.30.42.10-FF-000357', NULL, 'Lnx2 protein', 97, NULL, NULL, 141735),
(141736, '3.20.20.60-FF-000084', NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', 273, NULL, NULL, 141736),
(141737, '2.60.40.10-FF-003701', NULL, NULL, 97, NULL, NULL, 141737),
(141738, '3.90.1490.10-FF-000010', NULL, 'DPH6 isoform 5', 58, NULL, NULL, 141738),
(141739, '3.90.260.10-FF-000022', NULL, 'DNA repair protein complementing XP-C cells homolog', 208, NULL, NULL, 141739),
(141740, '1.10.560.10-FF-000093', NULL, '60 kDa chaperonin 4', 241, NULL, NULL, 141740),
(141741, '3.30.70.330-FF-001851', NULL, NULL, 112, NULL, NULL, 141741),
(141742, '2.30.30.40-FF-000344', NULL, 'Chemotaxis protein CheW', 54, NULL, NULL, 141742),
(141743, '3.30.2130.10-FF-000008', NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase, putative', 155, NULL, NULL, 141743),
(141744, '1.10.10.10-FF-001883', NULL, 'Lysine (K)-specific demethylase 1a', 33, NULL, NULL, 141744),
(141745, '3.30.70.330-FF-002470', NULL, NULL, 154, NULL, NULL, 141745),
(141746, '2.20.110.10-FF-000019', NULL, 'MORN repeat-containing protein 4', 40, NULL, NULL, 141746),
(141747, '2.40.30.110-FF-000020', NULL, NULL, 90, NULL, NULL, 141747),
(141748, '3.30.565.10-FF-000451', NULL, 'Sensor histidine kinase, PAS and GAF domain-containing', 197, NULL, NULL, 141748);
INSERT INTO "PUBLIC"."MODEL" VALUES
(141749, '3.10.250.10-FF-000146', NULL, NULL, 101, NULL, NULL, 141749),
(141750, '1.10.3110.10-FF-000008', NULL, 'Dehydrogenase', 83, NULL, NULL, 141750),
(141751, '3.10.20.90-FF-000385', NULL, 'Sorting nexin-17 homolog', 118, NULL, NULL, 141751),
(141752, '3.30.200.20-FF-000091', NULL, 'Serine/threonine-protein kinase PLK', 89, NULL, NULL, 141752),
(141753, '1.25.40.710-FF-000011', NULL, 'Tripeptidyl-peptidase 2-like protein', 249, NULL, NULL, 141753),
(141754, '1.20.1250.20-FF-000541', NULL, 'Putative hexuronate transporter', 202, NULL, NULL, 141754),
(141755, '1.20.1280.70-FF-000001', NULL, 'Exodeoxyribonuclease I', 61, NULL, NULL, 141755),
(141756, '3.10.129.10-FF-000134', NULL, 'Phenylacetic acid degradation protein', 136, NULL, NULL, 141756),
(141757, '3.40.30.10-FF-000653', NULL, 'Thiol:disulfide interchange protein DsbA', 184, NULL, NULL, 141757),
(141758, '2.130.10.10-FF-002156', NULL, 'Type I inositol polyphosphate 5-phosphatase 12', 222, NULL, NULL, 141758),
(141759, '3.20.20.80-FF-000202', NULL, 'CHItinase-Like', 262, NULL, NULL, 141759),
(141760, '1.20.120.1450-FF-000001', NULL, 'Heptaprenyl diphosphate synthase component I', 117, NULL, NULL, 141760),
(141761, '2.70.98.10-FF-000006', NULL, 'Beta-galactosidase', 293, NULL, NULL, 141761),
(141762, '3.30.160.60-FF-001116', NULL, 'Zinc finger protein 562', 28, NULL, NULL, 141762),
(141763, '3.30.70.330-FF-001519', NULL, 'U2 snRNP auxiliary factor large subunit', 104, NULL, NULL, 141763),
(141764, '3.30.1010.10-FF-000062', NULL, 'Phosphatidylinositol 4-kinase PIK1alpha', 177, NULL, NULL, 141764),
(141765, '4.10.240.10-FF-000203', NULL, 'Stb5p', 72, NULL, NULL, 141765),
(141766, '3.40.50.300-FF-001021', NULL, 'Probable ATP-dependent RNA helicase DDX20', 166, NULL, NULL, 141766),
(141767, '1.20.1070.10-FF-000895', NULL, 'Uncharacterized protein', 89, NULL, NULL, 141767),
(141768, '3.40.50.300-FF-005416', NULL, 'Chromosome 10, whole genome shotgun sequence', 273, NULL, NULL, 141768),
(141769, '1.10.10.1340-FF-000002', NULL, 'Mediator of RNA polymerase II transcription subunit 31', 101, NULL, NULL, 141769),
(141770, '1.10.565.10-FF-000076', NULL, 'Nuclear hormone receptor family member nhr-67', 167, NULL, NULL, 141770),
(141771, '2.120.10.80-FF-000328', NULL, 'Attractin-like 1', 140, NULL, NULL, 141771),
(141772, '3.90.400.10-FF-000011', NULL, 'CD98 heavy chain, isoform A', 66, NULL, NULL, 141772),
(141773, '3.40.50.12780-FF-000154', NULL, 'Nonribosomal peptide synthase, putative (JCVI)', 245, NULL, NULL, 141773),
(141774, '2.130.10.30-FF-000021', NULL, 'serine/threonine-protein kinase Nek9 isoform X2', 263, NULL, NULL, 141774),
(141775, '2.60.220.50-FF-000031', NULL, 'Starry night, isoform F', 121, NULL, NULL, 141775),
(141776, '2.60.40.640-FF-000119', NULL, 'Arrestin, putative', 199, NULL, NULL, 141776),
(141777, '2.40.10.10-FF-000036', NULL, 'Trypsin beta', 123, NULL, NULL, 141777),
(141778, '1.20.1640.10-FF-000023', NULL, 'Protein-export membrane protein SecF', 213, NULL, NULL, 141778),
(141779, '1.25.10.10-FF-000186', NULL, 'Importin 4', 1033, NULL, NULL, 141779),
(141780, '2.60.200.20-FF-000037', NULL, 'FHA domain containing protein', 111, NULL, NULL, 141780),
(141781, '3.40.50.150-FF-000335', NULL, 'Ribosomal RNA large subunit methyltransferase J', 201, NULL, NULL, 141781),
(141782, '1.25.40.20-FF-000932', NULL, 'Ankyrin repeats (Many copies), putative', 163, NULL, NULL, 141782),
(141783, '3.40.1000.50-FF-000025', NULL, 'Predicted protein', 74, NULL, NULL, 141783),
(141784, '3.40.50.1100-FF-000158', NULL, 'Cysteine synthase B protein', 102, NULL, NULL, 141784),
(141785, '1.25.40.10-FF-000250', NULL, 'RNA polymerase II transcription elongation factor', 39, NULL, NULL, 141785),
(141786, '1.20.58.1520-FF-000003', NULL, 'Coiled-coil domain-containing protein 87', 128, NULL, NULL, 141786),
(141787, '1.20.1510.10-FF-000019', NULL, 'Metal tolerance protein C2', 202, NULL, NULL, 141787),
(141788, '1.10.10.60-FF-001201', NULL, NULL, 84, NULL, NULL, 141788),
(141789, '3.80.10.10-FF-001616', NULL, 'Os08g0195000 protein', 187, NULL, NULL, 141789);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(141790, '4.10.780.10-FF-000002', NULL, 'Pyruvate:ferredoxin (Flavodoxin) oxidoreductase', 43, NULL, NULL, 141790),
(141791, '3.80.10.10-FF-002443', NULL, 'leucine-rich repeat-containing protein 40 isoform X1', 119, NULL, NULL, 141791),
(141792, '1.20.1250.20-FF-001738', NULL, 'Uncharacterized protein', 200, NULL, NULL, 141792),
(141793, '2.130.10.10-FF-001212', NULL, 'Protein kinase (VPS15), putative', 164, NULL, NULL, 141793),
(141794, '3.40.50.300-FF-000318', NULL, 'ATP-dependent RNA helicase DDX19B', 176, NULL, NULL, 141794),
(141795, '3.30.70.270-FF-000282', NULL, NULL, 174, NULL, NULL, 141795),
(141796, '2.30.30.370-FF-000004', NULL, NULL, 39, NULL, NULL, 141796),
(141797, '1.20.120.1750-FF-000097', NULL, 'RBR-type E3 ubiquitin transferase', 107, NULL, NULL, 141797),
(141798, '6.20.250.70-FF-000004', NULL, 'Uncharacterized protein', 114, NULL, NULL, 141798),
(141799, '3.30.710.10-FF-000407', NULL, 'Rho-related BTB domain-containing protein 1-like Protein', 114, NULL, NULL, 141799),
(141800, '3.40.30.10-FF-001272', NULL, 'Predicted protein', 63, NULL, NULL, 141800),
(141801, '2.130.10.10-FF-004730', NULL, 'Uncharacterized protein', 165, NULL, NULL, 141801),
(141802, '1.20.1070.10-FF-001272', NULL, 'Growth hormone releasing hormone receptor', 153, NULL, NULL, 141802),
(141803, '2.60.40.10-FF-003128', NULL, 'Uncharacterized protein', 97, NULL, NULL, 141803),
(141804, '3.30.70.3490-FF-000035', NULL, NULL, 101, NULL, NULL, 141804),
(141805, '3.30.420.40-FF-000984', NULL, 'Proton-dependent oligopeptide transport (POT) family protein', 107, NULL, NULL, 141805),
(141806, '2.60.40.1180-FF-000116', NULL, 'Alpha-mannosidase C', 113, NULL, NULL, 141806),
(141807, '3.30.70.330-FF-002138', NULL, NULL, 99, NULL, NULL, 141807),
(141808, '3.40.50.300-FF-008289', NULL, 'Predicted protein', 31, NULL, NULL, 141808),
(141809, '3.90.1230.10-FF-000002', NULL, NULL, 89, NULL, NULL, 141809),
(141810, '3.90.420.10-FF-000006', NULL, 'Sulfur dehydrogenase subunit SoxC', 258, NULL, NULL, 141810),
(141811, '1.10.3430.10-FF-000055', NULL, 'Blr0608 protein', 223, NULL, NULL, 141811),
(141812, '1.20.1250.20-FF-001822', NULL, 'Uncharacterized protein', 249, NULL, NULL, 141812),
(141813, '3.90.550.10-FF-000342', NULL, 'Poly-beta-1,6-N-acetyl-D-glucosamine synthase', 258, NULL, NULL, 141813),
(141814, '2.170.130.10-FF-000019', NULL, 'Fe(III)-pyochelin outer membrane receptor', 100, NULL, NULL, 141814),
(141815, '3.40.50.150-FF-001307', NULL, NULL, 212, NULL, NULL, 141815),
(141816, '1.10.510.10-FF-004417', NULL, NULL, 73, NULL, NULL, 141816),
(141817, '3.20.20.370-FF-000006', NULL, 'YdjC chitooligosaccharide deacetylase homolog', 297, NULL, NULL, 141817),
(141818, '3.10.20.90-FF-000716', NULL, 'Ubiquitin domain-containing protein', 101, NULL, NULL, 141818),
(141819, '1.25.40.90-FF-000122', NULL, 'Uncharacterized protein', 152, NULL, NULL, 141819),
(141820, '3.40.50.300-FF-004247', NULL, '3''-5'' exonuclease DinG', 257, NULL, NULL, 141820),
(141821, '3.30.200.20-FF-002232', NULL, 'Cyclin-dependent kinase 14', 37, NULL, NULL, 141821),
(141822, '1.10.1420.10-FF-000082', NULL, 'Msh2-like protein', 134, NULL, NULL, 141822),
(141823, '3.30.70.330-FF-000238', NULL, 'SAFB-like transcription modulator isoform X2', 183, NULL, NULL, 141823),
(141824, '3.60.10.10-FF-000151', NULL, 'Inositol phosphosphingolipid phospholipase C-Like', 309, NULL, NULL, 141824),
(141825, '1.25.40.10-FF-001110', NULL, 'LuxR family transcriptional regulator', 255, NULL, NULL, 141825),
(141826, '3.40.50.300-FF-008401', NULL, 'Regulator of nonsense transcripts putative', 176, NULL, NULL, 141826),
(141827, '1.10.30.50-FF-000013', NULL, '5-methylcytosine-specific restriction enzyme A', 100, NULL, NULL, 141827),
(141828, '1.50.10.10-FF-000122', NULL, 'Six-hairpin glycosidase-like protein', 79, NULL, NULL, 141828),
(141829, '3.30.160.60-FF-000924', NULL, 'IKAROS family zinc finger 5', 29, NULL, NULL, 141829),
(141830, '1.10.600.10-FF-000029', NULL, 'Octaprenyl pyrophosphate synthase', 356, NULL, NULL, 141830),
(141831, '3.40.50.1440-FF-000131', NULL, 'Uncharacterized protein', 153, NULL, NULL, 141831);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(141832, '1.10.510.10-FF-002517', NULL, NULL, 96, NULL, NULL, 141832),
(141833, '1.10.510.10-FF-003136', NULL, NULL, 183, NULL, NULL, 141833),
(141834, '3.40.50.10810-FF-000024', NULL, 'DNA annealing helicase and endonuclease ZRANB3', 264, NULL, NULL, 141834),
(141835, '3.10.100.10-FF-000259', NULL, NULL, 164, NULL, NULL, 141835),
(141836, '3.40.50.10190-FF-000006', NULL, 'Breast cancer type 1 susceptibility protein homolog', 108, NULL, NULL, 141836),
(141837, '1.10.1200.10-FF-000099', NULL, 'CurA', 83, NULL, NULL, 141837),
(141838, '1.25.40.10-FF-000834', NULL, 'Pentatricopeptide repeat-containing protein', 96, NULL, NULL, 141838),
(141839, '3.30.160.60-FF-001543', NULL, 'Zinc finger protein 334', 28, NULL, NULL, 141839),
(141840, '1.20.1110.10-FF-000270', NULL, NULL, 18, NULL, NULL, 141840),
(141841, '1.10.3020.10-FF-000001', NULL, 'Possible hydrolase', 88, NULL, NULL, 141841),
(141842, '3.90.1010.10-FF-000019', NULL, 'Iron-sulfur cluster assembly enzyme b', 82, NULL, NULL, 141842),
(141843, '3.40.50.300-FF-000993', NULL, 'probable ATP-dependent RNA helicase DDX49', 178, NULL, NULL, 141843),
(141844, '2.40.50.40-FF-000042', NULL, 'Chromodomain-helicase-DNA-binding protein Mi-2 homolog', 68, NULL, NULL, 141844),
(141845, '1.10.238.10-FF-000226', NULL, 'Serine/threonine-protein phosphatase with EF-hands', 164, NULL, NULL, 141845),
(141846, '3.30.200.20-FF-000102', NULL, 'Non-specific serine/threonine protein kinase', 113, NULL, NULL, 141846),
(141847, '1.10.287.1490-FF-000076', NULL, 'Outer dense fiber of sperm tails 2-like', 164, NULL, NULL, 141847),
(141848, '1.20.890.10-FF-000020', NULL, 'CBN-KIN-2 protein', 50, NULL, NULL, 141848),
(141849, '3.30.160.60-FF-001200', NULL, 'zinc finger protein 639', 73, NULL, NULL, 141849),
(141850, '2.60.40.10-FF-002280', NULL, 'Myosin binding protein C, slow type', 47, NULL, NULL, 141850),
(141851, '3.40.50.10190-FF-000349', NULL, 'BRCT-containing protein 1', 113, NULL, NULL, 141851),
(141852, '2.60.120.380-FF-000096', NULL, 'Putative calpain-like cysteine protease A', 140, NULL, NULL, 141852),
(141853, '3.30.160.60-FF-004769', NULL, NULL, 32, NULL, NULL, 141853),
(141854, '1.10.20.10-FF-000309', NULL, NULL, 41, NULL, NULL, 141854),
(141855, '3.80.10.10-FF-000998', NULL, 'Os06g0692100 protein', 100, NULL, NULL, 141855),
(141856, '1.10.150.80-FF-000032', NULL, 'Exosome complex exonuclease RRP6, putative', 87, NULL, NULL, 141856),
(141857, '2.60.120.340-FF-000011', NULL, 'Nucleophosmin/nucleoplasmin 3', 125, NULL, NULL, 141857),
(141858, '1.25.40.10-FF-002734', NULL, 'Sll0314 protein', 264, NULL, NULL, 141858),
(141859, '1.10.150.310-FF-000003', NULL, 'LD12377p', 144, NULL, NULL, 141859),
(141860, '2.60.40.150-FF-000276', NULL, 'Blast:Dedicator of cytokinesis protein 6', 178, NULL, NULL, 141860),
(141861, '2.60.40.60-FF-000479', NULL, 'Uncharacterized protein', 111, NULL, NULL, 141861),
(141862, '3.30.160.60-FF-000020', NULL, 'Zinc finger protein 14 homolog', 29, NULL, NULL, 141862),
(141863, '2.130.10.10-FF-005141', NULL, 'Uncharacterized protein', 74, NULL, NULL, 141863),
(141864, '2.30.30.90-FF-000005', NULL, 'DtxR family transcriptional regulator', 79, NULL, NULL, 141864),
(141865, '1.25.40.10-FF-004420', NULL, 'Uncharacterized protein', 129, NULL, NULL, 141865),
(141866, '1.10.357.140-FF-000007', NULL, '1,4-dihydroxy-2-naphthoate octaprenyltransferase', 160, NULL, NULL, 141866),
(141867, '1.10.246.130-FF-000018', NULL, NULL, 111, NULL, NULL, 141867),
(141868, '3.30.200.20-FF-001726', NULL, NULL, 110, NULL, NULL, 141868),
(141869, '3.90.1150.10-FF-000535', NULL, 'Putative acetylornithine/succinylornithine aminotransferase family protein', 106, NULL, NULL, 141869),
(141870, '2.40.50.110-FF-000001', NULL, 'Cholera enterotoxin subunit B', 103, NULL, NULL, 141870),
(141871, '3.80.10.10-FF-000105', NULL, 'S-phase kinase-associated protein 2', 329, NULL, NULL, 141871),
(141872, '2.170.300.10-FF-000055', NULL, 'Uncharacterized protein', 69, NULL, NULL, 141872),
(141873, '1.10.357.110-FF-000009', NULL, 'Vps53p', 184, NULL, NULL, 141873),
(141874, '2.130.10.10-FF-004865', NULL, 'Chromosome 15, whole genome shotgun sequence', 123, NULL, NULL, 141874);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(141875, '1.10.150.60-FF-000037', NULL, NULL, 89, NULL, NULL, 141875),
(141876, '1.10.575.10-FF-000003', NULL, 'Single strand-specific nuclease, putative', 271, NULL, NULL, 141876),
(141877, '3.30.420.10-FF-000649', NULL, NULL, 277, NULL, NULL, 141877),
(141878, '3.40.50.1820-FF-000604', NULL, 'Esterase/lipase', 326, NULL, NULL, 141878),
(141879, '3.30.160.60-FF-002392', NULL, 'Zinc finger protein 251', 32, NULL, NULL, 141879),
(141880, '1.25.40.10-FF-000593', NULL, 'Protein KINESIN LIGHT CHAIN-RELATED 1', 178, NULL, NULL, 141880),
(141881, '1.10.472.10-FF-000388', NULL, 'Uncharacterized protein', 30, NULL, NULL, 141881),
(141882, '1.10.510.10-FF-000489', NULL, 'cyclin-dependent kinase 19 isoform X2', 139, NULL, NULL, 141882),
(141883, '1.10.533.10-FF-000171', NULL, 'Uncharacterized protein', 34, NULL, NULL, 141883),
(141884, '3.80.10.10-FF-001959', NULL, 'Protein STRUBBELIG-RECEPTOR FAMILY 6 isoform A', 98, NULL, NULL, 141884),
(141885, '3.40.50.1820-FF-000363', NULL, 'Alpha/beta hydrolase', 201, NULL, NULL, 141885),
(141886, '3.30.760.10-FF-000023', NULL, 'Unplaced genomic scaffold supercont1.138, whole genome shotgun sequence', 188, NULL, NULL, 141886),
(141887, '3.20.20.70-FF-000749', NULL, NULL, 67, NULL, NULL, 141887),
(141888, '2.10.25.10-FF-000105', NULL, 'laminin subunit gamma-1', 53, NULL, NULL, 141888),
(141889, '3.80.10.10-FF-002235', NULL, 'Uncharacterized protein', 68, NULL, NULL, 141889),
(141890, '1.10.510.10-FF-001899', NULL, 'Discoidin domain receptor, putative', 108, NULL, NULL, 141890),
(141891, '1.50.10.10-FF-000021', NULL, 'N-acylglucosamine 2-epimerase', 392, NULL, NULL, 141891),
(141892, '3.30.700.10-FF-000002', NULL, 'Type 4 fimbrial biogenesis protein PilE', 128, NULL, NULL, 141892),
(141893, '3.40.50.620-FF-000055', NULL, 'Asparagine synthetase [glutamine-hydrolyzing]', 320, NULL, NULL, 141893),
(141894, '1.10.10.580-FF-000026', NULL, 'Uncharacterized protein', 96, NULL, NULL, 141894),
(141895, '3.30.1740.20-FF-000013', NULL, 'Uncharacterized protein', 63, NULL, NULL, 141895),
(141896, '1.10.238.10-FF-001075', NULL, 'Uncharacterized protein', 73, NULL, NULL, 141896),
(141897, '1.10.10.60-FF-000116', NULL, 'Cut-like homeobox 2b', 85, NULL, NULL, 141897),
(141898, '3.40.50.300-FF-006501', NULL, 'Uncharacterized protein', 114, NULL, NULL, 141898),
(141899, '3.40.190.10-FF-000275', NULL, 'Prephenate dehydratase', 81, NULL, NULL, 141899),
(141900, '3.30.70.1290-FF-000010', NULL, NULL, 166, NULL, NULL, 141900),
(141901, '3.30.420.110-FF-000038', NULL, 'DNA mismatch repair protein mutS, putative', 142, NULL, NULL, 141901),
(141902, '3.30.420.10-FF-000205', NULL, 'DNA polymerase III epsilon subunit', 184, NULL, NULL, 141902),
(141903, '3.90.230.10-FF-000071', NULL, NULL, 264, NULL, NULL, 141903),
(141904, '2.30.30.490-FF-000023', NULL, 'Egg-laying defective protein 27', 152, NULL, NULL, 141904),
(141905, '2.40.10.170-FF-000011', NULL, 'ATP synthase subunit beta', 79, NULL, NULL, 141905),
(141906, '1.10.220.150-FF-000005', NULL, 'Arf-GAP domain and FG repeat-containing protein 1', 137, NULL, NULL, 141906),
(141907, '1.25.50.20-FF-000091', NULL, 'Uncharacterized protein', 263, NULL, NULL, 141907),
(141908, '2.30.180.10-FF-000027', NULL, 'Uncharacterized protein, isoform C', 136, NULL, NULL, 141908),
(141909, '1.10.238.10-FF-000569', NULL, 'Centrin 3', 73, NULL, NULL, 141909),
(141910, '2.80.10.50-FF-000260', NULL, 'Beta-agarase AgaB34', 140, NULL, NULL, 141910),
(141911, '1.10.1410.10-FF-000025', NULL, 'Putative Poly(A) polymerase', 177, NULL, NULL, 141911),
(141912, '3.30.70.330-FF-002576', NULL, NULL, 142, NULL, NULL, 141912),
(141913, '1.10.300.10-FF-000001', NULL, 'Adenylosuccinate synthetase', 100, NULL, NULL, 141913),
(141914, '1.10.533.10-FF-000058', NULL, 'death domain-containing protein CRADD isoform X1', 102, NULL, NULL, 141914),
(141915, '3.60.20.10-FF-000202', NULL, NULL, 212, NULL, NULL, 141915),
(141916, '3.30.40.10-FF-001868', NULL, 'Uncharacterized protein', 78, NULL, NULL, 141916),
(141917, '3.40.30.10-FF-000552', NULL, 'Uncharacterized protein', 156, NULL, NULL, 141917);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(141918, '3.90.70.10-FF-000445', NULL, 'Putative ubiquitin-hydrolase domain protein', 138, NULL, NULL, 141918),
(141919, '3.40.120.10-FF-000107', NULL, 'Uncharacterized protein', 39, NULL, NULL, 141919),
(141920, '2.60.120.260-FF-000318', NULL, 'Putative lipoprotein', 132, NULL, NULL, 141920),
(141921, '3.10.350.10-FF-000070', NULL, 'Gamma-D-glutamyl-L-diamino acid endopeptidase 1', 47, NULL, NULL, 141921),
(141922, '3.40.50.10140-FF-000020', NULL, 'Blast:Protein toll', 153, NULL, NULL, 141922),
(141923, '1.20.1250.20-FF-000642', NULL, 'Multi-drug resistance efflux pump', 213, NULL, NULL, 141923),
(141924, '2.40.30.130-FF-000008', NULL, 'Alanine--tRNA ligase', 92, NULL, NULL, 141924),
(141925, '3.60.21.10-FF-000277', NULL, 'Uncharacterized protein F44B9.9', 108, NULL, NULL, 141925),
(141926, '3.30.420.40-FF-001029', NULL, 'Uncharacterized protein', 34, NULL, NULL, 141926),
(141927, '3.90.650.10-FF-000063', NULL, 'Predicted protein', 161, NULL, NULL, 141927),
(141928, '2.10.25.10-FF-001515', NULL, 'Uncharacterized protein', 50, NULL, NULL, 141928),
(141929, '2.10.25.10-FF-001297', NULL, 'Uncharacterized protein', 39, NULL, NULL, 141929),
(141930, '2.10.110.10-FF-000314', NULL, 'Uncharacterized protein', 51, NULL, NULL, 141930),
(141931, '3.30.160.60-FF-000363', NULL, 'Zinc finger protein 239', 27, NULL, NULL, 141931),
(141932, '3.30.40.10-FF-002144', NULL, 'RBR-type E3 ubiquitin transferase', 110, NULL, NULL, 141932),
(141933, '1.20.58.60-FF-000613', NULL, 'Nesprin-2', 207, NULL, NULL, 141933),
(141934, '1.10.760.10-FF-000092', NULL, 'Putative SCO1/SenC family protein/methylamine utilization protein MauG', 195, NULL, NULL, 141934),
(141935, '3.30.200.20-FF-000546', NULL, 'MAP kinase-activated protein kinase 2', 50, NULL, NULL, 141935),
(141936, '3.30.450.30-FF-000039', NULL, 'Predicted protein', 128, NULL, NULL, 141936),
(141937, '3.30.40.10-FF-000244', NULL, 'TNF receptor-associated factor', 62, NULL, NULL, 141937),
(141938, '1.20.1250.10-FF-000100', NULL, NULL, 162, NULL, NULL, 141938),
(141939, '3.10.580.20-FF-000005', NULL, 'Chloride channel protein', 86, NULL, NULL, 141939),
(141940, '2.60.40.10-FF-001560', NULL, 'palladin isoform X1', 107, NULL, NULL, 141940),
(141941, '2.70.98.30-FF-000001', NULL, 'alpha-mannosidase 2C1 isoform X2', 247, NULL, NULL, 141941),
(141942, '3.50.50.60-FF-000444', NULL, 'Putative GMC-type oxidoreductase', 185, NULL, NULL, 141942),
(141943, '1.10.10.430-FF-000009', NULL, 'Uncharacterized protein', 69, NULL, NULL, 141943),
(141944, '3.30.40.10-FF-000120', NULL, 'ligand of Numb protein X 2', 129, NULL, NULL, 141944),
(141945, '3.30.1540.20-FF-000014', NULL, 'DNA mismatch repair protein MutL', 89, NULL, NULL, 141945),
(141946, '3.30.420.40-FF-000641', NULL, 'Heat shock 70 kDa protein', 98, NULL, NULL, 141946),
(141947, '1.10.510.10-FF-001107', NULL, 'Non-specific serine/threonine protein kinase', 151, NULL, NULL, 141947),
(141948, '2.60.260.20-FF-000142', NULL, 'DnAJ-like protein slr0093', 64, NULL, NULL, 141948),
(141949, '3.30.505.10-FF-000234', NULL, NULL, 86, NULL, NULL, 141949),
(141950, '1.25.10.10-FF-000422', NULL, 'Stambha A, isoform D', 285, NULL, NULL, 141950),
(141951, '2.130.10.10-FF-002735', NULL, 'Ribosome biogenesis protein WDR12 homolog', 286, NULL, NULL, 141951),
(141952, '2.10.110.10-FF-000191', NULL, 'LIM domain kinase 2', 60, NULL, NULL, 141952),
(141953, '3.80.10.10-FF-001263', NULL, 'Insulin-like growth factor-binding protein complex acid labile subunit', 141, NULL, NULL, 141953),
(141954, '1.10.10.2030-FF-000001', NULL, 'DNA/RNA-binding protein KIN17, putative', 100, NULL, NULL, 141954),
(141955, '1.25.10.10-FF-002451', NULL, 'AFL147Cp', 227, NULL, NULL, 141955),
(141956, '1.10.287.470-FF-000022', NULL, 'Membrane fusion protein', 74, NULL, NULL, 141956),
(141957, '3.40.50.2000-FF-000097', NULL, 'alpha-1,3/1,6-mannosyltransferase ALG2', 185, NULL, NULL, 141957),
(141958, '3.40.50.720-FF-002001', NULL, 'NADH:ubiquinone oxidoreductase 39 kDa subunit', 232, NULL, NULL, 141958),
(141959, '1.20.190.40-FF-000003', NULL, 'Major DNA-binding protein', 138, NULL, NULL, 141959);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(141960, '1.25.40.320-FF-000001', NULL, 'Leukotriene A(4) hydrolase', 148, NULL, NULL, 141960),
(141961, '3.30.710.10-FF-000284', NULL, 'Predicted protein', 104, NULL, NULL, 141961),
(141962, '2.60.120.650-FF-000087', NULL, 'Uncharacterized protein', 270, NULL, NULL, 141962),
(141963, '1.20.1000.10-FF-000042', NULL, NULL, 75, NULL, NULL, 141963),
(141964, '1.20.1250.20-FF-001261', NULL, 'Tetracycline resistance determinant tetV', 386, NULL, NULL, 141964),
(141965, '2.60.40.10-FF-002509', NULL, 'Unc-5, isoform B', 92, NULL, NULL, 141965),
(141966, '3.30.160.60-FF-003797', NULL, NULL, 26, NULL, NULL, 141966),
(141967, '1.25.10.10-FF-001041', NULL, 'Protein phosphatase PP2A regulatory subunit A', 632, NULL, NULL, 141967),
(141968, '3.40.50.720-FF-002125', NULL, 'Uncharacterized protein', 109, NULL, NULL, 141968),
(141969, '1.20.1560.10-FF-000410', NULL, 'Uncharacterized protein', 332, NULL, NULL, 141969),
(141970, '3.30.160.60-FF-002971', NULL, 'Zinc finger protein', 28, NULL, NULL, 141970),
(141971, '3.30.360.10-FF-000138', NULL, 'Glucose-6-phosphate 1-dehydrogenase 4 chloroplastic', 104, NULL, NULL, 141971),
(141972, '2.130.10.10-FF-003893', NULL, 'Uncharacterized protein', 273, NULL, NULL, 141972),
(141973, '3.40.50.720-FF-001383', NULL, 'C-terminal-binding protein 2', 194, NULL, NULL, 141973),
(141974, '3.40.50.450-FF-000099', NULL, 'Uncharacterized protein', 75, NULL, NULL, 141974),
(141975, '3.30.200.20-FF-001956', NULL, 'Mitogen-activated protein kinase kinase kinase kinase 4', 106, NULL, NULL, 141975),
(141976, '3.10.450.40-FF-000007', NULL, 'Amine oxidase', 116, NULL, NULL, 141976),
(141977, '1.10.10.10-FF-001102', NULL, 'Transcriptional regulator, MarR family', 142, NULL, NULL, 141977),
(141978, '3.30.70.1230-FF-000262', NULL, 'Uncharacterized protein', 151, NULL, NULL, 141978),
(141979, '1.20.1270.60-FF-000296', NULL, 'Uncharacterized protein', 142, NULL, NULL, 141979),
(141980, '1.10.10.1050-FF-000016', NULL, 'Uncharacterized protein', 94, NULL, NULL, 141980),
(141981, '4.10.1000.10-FF-000132', NULL, 'Uncharacterized protein', 62, NULL, NULL, 141981),
(141982, '1.20.1070.10-FF-001833', NULL, 'Uncharacterized protein', 305, NULL, NULL, 141982),
(141983, '1.25.40.10-FF-003240', NULL, 'Pentatricopeptide repeat-containing protein', 181, NULL, NULL, 141983),
(141984, '2.30.30.40-FF-000445', NULL, 'Tyrosine-protein kinase', 74, NULL, NULL, 141984),
(141985, '3.30.470.30-FF-000023', NULL, 'DNA ligase', 236, NULL, NULL, 141985),
(141986, '1.20.58.60-FF-000052', NULL, 'dystonin isoform X2', 234, NULL, NULL, 141986),
(141987, '4.10.1060.10-FF-000006', NULL, 'ubiquitin thioesterase ZRANB1 isoform X1', 34, NULL, NULL, 141987),
(141988, '3.40.50.300-FF-003275', NULL, 'ras-related C3 botulinum toxin substrate 1 isoform X2', 94, NULL, NULL, 141988),
(141989, '3.40.50.300-FF-006844', NULL, 'DNA repair protein rhp55', 262, NULL, NULL, 141989),
(141990, '3.40.390.10-FF-000161', NULL, 'Metalloendopeptidase', 171, NULL, NULL, 141990),
(141991, '1.10.10.10-FF-000826', NULL, 'LuxR family transcriptional regulator', 70, NULL, NULL, 141991),
(141992, '4.10.280.10-FF-000200', NULL, 'Hms1p', 67, NULL, NULL, 141992),
(141993, '3.40.50.2300-FF-000417', NULL, 'DNA-binding response regulator', 80, NULL, NULL, 141993),
(141994, '3.40.50.1010-FF-000120', NULL, 'NYN domain-containing protein', 170, NULL, NULL, 141994),
(141995, '3.30.420.40-FF-000080', NULL, 'Actin, alpha skeletal muscle', 113, NULL, NULL, 141995),
(141996, '3.30.200.20-FF-002356', NULL, 'Mitogen-activated protein kinase 11', 38, NULL, NULL, 141996),
(141997, '3.30.2160.10-FF-000044', NULL, 'YALI0A20372p', 83, NULL, NULL, 141997),
(141998, '3.50.50.60-FF-000320', NULL, 'Amine oxidase', 166, NULL, NULL, 141998),
(141999, '3.30.479.20-FF-000012', NULL, 'Elongation factor Ts, mitochondrial', 108, NULL, NULL, 141999),
(142000, '1.10.640.10-FF-000026', NULL, 'Protein CBG17660', 589, NULL, NULL, 142000),
(142001, '3.30.1490.80-FF-000011', NULL, 'Glutathione synthetase', 12, NULL, NULL, 142001),
(142002, '2.40.50.90-FF-000130', NULL, 'Transcription factor, Tudor domain, putative', 146, NULL, NULL, 142002);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(142003, '1.20.20.10-FF-000006', NULL, 'ATP synthase subunit 9, mitochondrial', 75, NULL, NULL, 142003),
(142004, '3.40.50.300-FF-007120', NULL, 'Uncharacterized protein', 184, NULL, NULL, 142004),
(142005, '2.60.40.60-FF-000136', NULL, 'Neural-cadherin', 115, NULL, NULL, 142005),
(142006, '3.80.10.10-FF-003871', NULL, 'Uncharacterized protein', 206, NULL, NULL, 142006),
(142007, '1.10.10.2740-FF-000006', NULL, 'Uncharacterized protein', 90, NULL, NULL, 142007),
(142008, '2.40.70.10-FF-000253', NULL, NULL, 99, NULL, NULL, 142008),
(142009, '3.30.160.60-FF-004073', NULL, NULL, 29, NULL, NULL, 142009),
(142010, '3.20.20.150-FF-000064', NULL, 'Protein CBG19664', 138, NULL, NULL, 142010),
(142011, '2.60.40.10-FF-003460', NULL, NULL, 101, NULL, NULL, 142011),
(142012, '3.50.50.60-FF-001293', NULL, 'Uncharacterized protein', 163, NULL, NULL, 142012),
(142013, '2.70.70.10-FF-000010', NULL, 'M23 family peptidase', 139, NULL, NULL, 142013),
(142014, '3.80.10.10-FF-002578', NULL, 'NLR family CARD domain containing 3', 113, NULL, NULL, 142014),
(142015, '1.10.472.10-FF-000045', NULL, 'Transcription initiation factor IIB', 98, NULL, NULL, 142015),
(142016, '3.30.710.10-FF-000183', NULL, 'Ankyrin repeat and BTB/POZ domain protein', 145, NULL, NULL, 142016),
(142017, '2.60.40.10-FF-001116', NULL, 'Titin novex-3', 88, NULL, NULL, 142017),
(142018, '3.90.470.20-FF-000063', NULL, 'Uncharacterized protein', 66, NULL, NULL, 142018),
(142019, '3.40.1190.20-FF-000142', NULL, 'Uncharacterized sugar kinase', 351, NULL, NULL, 142019),
(142020, '1.10.10.10-FF-001315', NULL, 'Transcriptional activator domain protein', 92, NULL, NULL, 142020),
(142021, '2.40.10.10-FF-000480', NULL, NULL, 103, NULL, NULL, 142021),
(142022, '3.30.160.60-FF-003696', NULL, 'Zinc finger protein 527', 27, NULL, NULL, 142022),
(142023, '2.60.120.200-FF-000435', NULL, 'AGAP004456-PA', 310, NULL, NULL, 142023),
(142024, '3.30.160.60-FF-006444', NULL, NULL, 32, NULL, NULL, 142024),
(142025, '1.25.40.10-FF-004651', NULL, 'Uncharacterized protein', 122, NULL, NULL, 142025),
(142026, '3.40.50.300-FF-006265', NULL, 'SNF2 superfamily protein', 302, NULL, NULL, 142026),
(142027, '3.80.10.10-FF-001162', NULL, 'Leucine rich repeat containing 15', 80, NULL, NULL, 142027),
(142028, '2.60.40.2500-FF-000001', NULL, 'Protein virB9', 128, NULL, NULL, 142028),
(142029, '4.10.60.10-FF-000007', NULL, 'Protein lin-28 homolog A', 66, NULL, NULL, 142029),
(142030, '1.10.287.110-FF-000398', NULL, 'Uncharacterized protein', 29, NULL, NULL, 142030),
(142031, '1.10.510.10-FF-000606', NULL, 'Wall-associated receptor kinase 3', 202, NULL, NULL, 142031),
(142032, '1.10.10.10-FF-000803', NULL, 'Putative cation uptake regulator', 86, NULL, NULL, 142032),
(142033, '2.60.40.1170-FF-000001', NULL, 'AP-1 complex subunit mu-1 isoform 1', 147, NULL, NULL, 142033),
(142034, '3.40.50.2000-FF-000889', NULL, 'Uncharacterized protein', 178, NULL, NULL, 142034),
(142035, '3.40.50.2300-FF-001485', NULL, NULL, 133, NULL, NULL, 142035),
(142036, '3.30.559.10-FF-000061', NULL, 'Diacylglycerol O-acyltransferase', 170, NULL, NULL, 142036),
(142037, '3.40.30.10-FF-000097', NULL, 'NADH dehydrogenase [ubiquinone] flavoprotein 2', 110, NULL, NULL, 142037),
(142038, '3.40.50.620-FF-000274', NULL, 'Universal stress protein MT3220', 146, NULL, NULL, 142038),
(142039, '3.40.395.10-FF-000020', NULL, 'Peptidase', 117, NULL, NULL, 142039),
(142040, '2.60.40.10-FF-002639', NULL, 'Neuronal immunoglobulin domain-containing protein rig-3', 98, NULL, NULL, 142040),
(142041, '2.130.10.10-FF-004860', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit', 125, NULL, NULL, 142041),
(142042, '3.30.70.330-FF-000457', NULL, 'RNA binding protein MSSP-2', 115, NULL, NULL, 142042),
(142043, '3.40.50.300-FF-000970', NULL, 'Ras-related protein Rab-6', 193, NULL, NULL, 142043),
(142044, '1.20.58.760-FF-000035', NULL, 'ATP-dependent zinc metalloprotease FTSH 6 chloroplastic', 173, NULL, NULL, 142044),
(142045, '3.80.10.10-FF-000543', NULL, 'Transforming growth factor beta activator LRRC33', 136, NULL, NULL, 142045);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(142046, '1.25.10.10-FF-000427', NULL, 'Ataxin-10 isoform 1', 182, NULL, NULL, 142046),
(142047, '3.30.160.60-FF-002173', NULL, 'GM13856', 58, NULL, NULL, 142047),
(142048, '3.40.50.2000-FF-000996', NULL, 'Uncharacterized protein', 43, NULL, NULL, 142048),
(142049, '3.30.70.3490-FF-000012', NULL, 'Oxysterol-binding protein homolog 4', 127, NULL, NULL, 142049),
(142050, '3.30.230.10-FF-000152', NULL, '114 kDa U5 small nuclear ribonucleoprotein component', 149, NULL, NULL, 142050),
(142051, '1.25.40.10-FF-003009', NULL, 'YALI0C19426p', 120, NULL, NULL, 142051),
(142052, '2.130.10.10-FF-001083', NULL, 'Autophagy-related protein 18a isoform A', 331, NULL, NULL, 142052),
(142053, '2.70.98.60-FF-000004', NULL, 'Alpha-galactosidase', 274, NULL, NULL, 142053),
(142054, '2.130.10.10-FF-000571', NULL, 'Regulatory-associated protein of TOR 2', 318, NULL, NULL, 142054),
(142055, '1.10.630.10-FF-000082', NULL, 'Cytochrome P450 family 20 subfamily A member 1', 438, NULL, NULL, 142055),
(142056, '3.40.50.300-FF-001482', NULL, 'Phosphonates import ATP-binding protein PhnC', 254, NULL, NULL, 142056),
(142057, '1.25.40.20-FF-001888', NULL, 'Ankyrin 2, isoform X', 50, NULL, NULL, 142057),
(142058, '1.25.40.10-FF-000255', NULL, 'Pentatricopeptide repeat-containing protein 1, mitochondrial', 178, NULL, NULL, 142058),
(142059, '1.25.40.470-FF-000023', NULL, 'WD repeat-containing protein 19', 156, NULL, NULL, 142059),
(142060, '1.20.120.1880-FF-000012', NULL, 'Nuclear pore complex protein Nup155', 227, NULL, NULL, 142060),
(142061, '2.60.120.650-FF-000109', NULL, 'Lysine-specific demethylase rbr-2', 166, NULL, NULL, 142061),
(142062, '1.10.3470.10-FF-000052', NULL, 'Iron ABC transporter, permease protein', 322, NULL, NULL, 142062),
(142063, '3.40.50.720-FF-000427', NULL, 'Shikimate dehydrogenase', 127, NULL, NULL, 142063),
(142064, '1.20.1560.10-FF-000522', NULL, 'Chromosome 10, whole genome shotgun sequence', 298, NULL, NULL, 142064),
(142065, '1.10.10.60-FF-000560', NULL, 'Probable transposase', 47, NULL, NULL, 142065),
(142066, '2.60.120.10-FF-000775', NULL, 'Uncharacterized protein', 40, NULL, NULL, 142066),
(142067, '2.20.25.100-FF-000005', NULL, '40S ribosomal protein S27', 86, NULL, NULL, 142067),
(142068, '1.25.40.10-FF-004544', NULL, 'Uncharacterized protein', 230, NULL, NULL, 142068),
(142069, '1.20.5.110-FF-000195', NULL, 'Qb-SNARE_protein_-_putative', 80, NULL, NULL, 142069),
(142070, '1.25.10.10-FF-002895', NULL, 'Predicted protein', 141, NULL, NULL, 142070),
(142071, '1.20.5.190-FF-000162', NULL, NULL, 49, NULL, NULL, 142071),
(142072, '3.30.40.10-FF-000805', NULL, 'Bassoon presynaptic cytomatrix protein', 99, NULL, NULL, 142072),
(142073, '3.10.20.90-FF-000739', NULL, 'Diacylglycerol kinase', 111, NULL, NULL, 142073),
(142074, '2.60.260.20-FF-000035', NULL, 'Heat shock protein DNAJ, putative', 71, NULL, NULL, 142074),
(142075, '3.90.400.10-FF-000016', NULL, 'Maltase A2', 75, NULL, NULL, 142075),
(142076, '3.40.50.300-FF-002898', NULL, 'Protein CBG21524', 180, NULL, NULL, 142076),
(142077, '2.40.30.10-FF-000386', NULL, 'GTPase', 159, NULL, NULL, 142077),
(142078, '3.40.50.12780-FF-000042', NULL, 'Possible fatty-acid-CoA ligase fadD1', 399, NULL, NULL, 142078),
(142079, '1.20.58.1520-FF-000008', NULL, 'SPD-1', 122, NULL, NULL, 142079),
(142080, '2.40.10.10-FF-000373', NULL, NULL, 86, NULL, NULL, 142080),
(142081, '2.60.40.10-FF-006006', NULL, NULL, 118, NULL, NULL, 142081),
(142082, '2.60.120.200-FF-000542', NULL, 'Predicted protein', 266, NULL, NULL, 142082),
(142083, '3.40.640.10-FF-000366', NULL, 'Aspartate aminotransferase', 123, NULL, NULL, 142083),
(142084, '1.10.1760.20-FF-000003', NULL, 'Riboflavin transporter', 186, NULL, NULL, 142084),
(142085, '1.10.510.10-FF-002748', NULL, 'Chromosome 15, whole genome shotgun sequence', 302, NULL, NULL, 142085),
(142086, '2.80.10.50-FF-000029', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 131, NULL, NULL, 142086),
(142087, '3.20.20.70-FF-000429', NULL, 'Hydroxyacid oxidase 2 (long chain)', 180, NULL, NULL, 142087),
(142088, '1.10.20.10-FF-000198', NULL, NULL, 69, NULL, NULL, 142088);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(142089, '3.30.70.330-FF-002711', NULL, NULL, 105, NULL, NULL, 142089),
(142090, '1.10.510.10-FF-001444', NULL, 'Uncharacterized protein', 227, NULL, NULL, 142090),
(142091, '3.40.640.10-FF-000259', NULL, 'UDP-4-amino-4,6-dideoxy-N-acetyl-beta-L-altrosamine transaminase', 245, NULL, NULL, 142091),
(142092, '2.70.160.11-FF-000052', NULL, 'Protein arginine N-methyltransferase 2', 204, NULL, NULL, 142092),
(142093, '1.25.40.10-FF-001559', NULL, 'Pentatricopeptide repeat-containing protein At1g56690, mitochondrial', 64, NULL, NULL, 142093),
(142094, '3.30.2160.10-FF-000067', NULL, 'Predicted protein', 38, NULL, NULL, 142094),
(142095, '3.40.50.410-FF-000222', NULL, 'Midasin', 163, NULL, NULL, 142095),
(142096, '1.20.1250.20-FF-000081', NULL, 'Lactose permease', 212, NULL, NULL, 142096),
(142097, '2.60.220.50-FF-000036', NULL, 'Adhesion G protein-coupled receptor L4', 192, NULL, NULL, 142097),
(142098, '3.20.20.70-FF-000536', NULL, NULL, 240, NULL, NULL, 142098),
(142099, '3.30.1370.10-FF-000088', NULL, 'Uncharacterized protein, isoform A', 106, NULL, NULL, 142099),
(142100, '1.10.510.10-FF-001551', NULL, 'TANK-binding kinase 1 transcript variant X1', 130, NULL, NULL, 142100),
(142101, '3.40.50.10330-FF-000094', NULL, 'Uncharacterized protein', 132, NULL, NULL, 142101),
(142102, '3.30.70.580-FF-000037', NULL, 'tRNA pseudouridine synthase A', 109, NULL, NULL, 142102),
(142103, '1.25.40.10-FF-000362', NULL, 'Nephrocystin-3', 158, NULL, NULL, 142103),
(142104, '1.25.10.10-FF-003412', NULL, 'Uncharacterized protein', 342, NULL, NULL, 142104),
(142105, '1.20.1560.10-FF-000415', NULL, 'Uncharacterized protein', 327, NULL, NULL, 142105),
(142106, '3.30.710.10-FF-000290', NULL, 'Predicted protein', 128, NULL, NULL, 142106),
(142107, '2.20.70.10-FF-000080', NULL, 'E3 ubiquitin-protein ligase', 30, NULL, NULL, 142107),
(142108, '3.30.70.330-FF-000890', NULL, 'Uncharacterized protein', 86, NULL, NULL, 142108),
(142109, '3.30.40.10-FF-000912', NULL, 'RING-variant_domain_containing_protein_-_putative', 81, NULL, NULL, 142109),
(142110, '1.20.120.350-FF-000243', NULL, NULL, 128, NULL, NULL, 142110),
(142111, '1.20.58.80-FF-000035', NULL, 'MIT domain containing protein', 69, NULL, NULL, 142111),
(142112, '1.10.8.720-FF-000071', NULL, 'Dynein heavy chain family protein', 148, NULL, NULL, 142112),
(142113, '3.40.1110.10-FF-000269', NULL, NULL, 51, NULL, NULL, 142113),
(142114, '3.30.56.10-FF-000016', NULL, 'Phenylalanine-tRNA ligase, beta subunit', 78, NULL, NULL, 142114),
(142115, '2.120.10.80-FF-000305', NULL, 'Uncharacterized protein', 185, NULL, NULL, 142115),
(142116, '1.25.40.320-FF-000006', NULL, 'Leukotriene A(4) hydrolase', 149, NULL, NULL, 142116),
(142117, '3.30.200.20-FF-001951', NULL, 'AGR334Wp', 107, NULL, NULL, 142117),
(142118, '1.20.1070.10-FF-000552', NULL, 'Olfactory receptor family 4 subfamily C member 3', 196, NULL, NULL, 142118),
(142119, '1.10.10.60-FF-000453', NULL, 'Unplaced genomic scaffold supercont1.84, whole genome shotgun sequence', 60, NULL, NULL, 142119),
(142120, '1.20.5.110-FF-000200', NULL, 'Syntaxin 11-1', 102, NULL, NULL, 142120),
(142121, '1.10.441.10-FF-000013', NULL, 'Uncharacterized protein', 69, NULL, NULL, 142121),
(142122, '1.20.1270.60-FF-000189', NULL, 'Dip13 beta, putative', 88, NULL, NULL, 142122),
(142123, '3.50.7.10-FF-000004', NULL, 'T-complex protein 1 subunit zeta', 163, NULL, NULL, 142123),
(142124, '1.10.405.10-FF-000025', NULL, 'Putative bifunctional amine oxidase DDB_G0291301', 91, NULL, NULL, 142124),
(142125, '2.60.40.10-FF-004078', NULL, NULL, 95, NULL, NULL, 142125),
(142126, '2.60.40.150-FF-000299', NULL, 'RNA helicase, putative', 110, NULL, NULL, 142126),
(142127, '1.20.1250.20-FF-000878', NULL, 'Drug resistance transporter, EmrB/QacA subfamily', 204, NULL, NULL, 142127),
(142128, '3.40.50.1580-FF-000038', NULL, 'Purine nucleoside phosphorylase', 310, NULL, NULL, 142128),
(142129, '3.10.129.10-FF-000111', NULL, 'Fatty acid synthase beta subunit aflB', 271, NULL, NULL, 142129),
(142130, '2.30.30.100-FF-000171', NULL, 'U6 snRNA-associated Sm-like protein LSm3', 89, NULL, NULL, 142130);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(142131, '3.40.220.10-FF-000042', NULL, 'Uncharacterized protein', 134, NULL, NULL, 142131),
(142132, '1.10.510.10-FF-003479', NULL, NULL, 267, NULL, NULL, 142132),
(142133, '1.10.220.160-FF-000020', NULL, NULL, 84, NULL, NULL, 142133),
(142134, '3.20.20.190-FF-000042', NULL, 'Glycerophosphodiester phosphodiesterase', 229, NULL, NULL, 142134),
(142135, '3.30.160.60-FF-002280', NULL, 'Zinc finger protein 669', 30, NULL, NULL, 142135),
(142136, '1.25.40.20-FF-000039', NULL, 'Ankyrin repeat domain-containing protein 11', 134, NULL, NULL, 142136),
(142137, '1.10.30.10-FF-000024', NULL, 'Histone-lysine N-methyltransferase NSD2', 50, NULL, NULL, 142137),
(142138, '3.40.50.980-FF-000022', NULL, 'Nonribosomal peptide synthetase 8', 153, NULL, NULL, 142138),
(142139, '1.25.40.10-FF-001778', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 236, NULL, NULL, 142139),
(142140, '3.30.200.20-FF-002463', NULL, 'Tubulin gamma-2 chain', 54, NULL, NULL, 142140),
(142141, '3.40.50.300-FF-007221', NULL, 'Uncharacterized protein', 163, NULL, NULL, 142141),
(142142, '1.20.1250.20-FF-001502', NULL, 'Xylose/H+ symporter, putative', 100, NULL, NULL, 142142),
(142143, '3.90.45.10-FF-000033', NULL, 'Peptide deformylase', 164, NULL, NULL, 142143),
(142144, '1.20.58.900-FF-000010', NULL, 'FYVE and coiled-coil domain containing 1', 173, NULL, NULL, 142144),
(142145, '2.40.30.10-FF-000256', NULL, 'Siderophore-interacting protein', 129, NULL, NULL, 142145),
(142146, '3.40.50.10860-FF-000022', NULL, 'Methylenetetrahydrofolate dehydrogenase (NAD+), putative', 140, NULL, NULL, 142146),
(142147, '1.25.70.10-FF-000089', NULL, NULL, 130, NULL, NULL, 142147),
(142148, '1.25.40.10-FF-001211', NULL, 'Pentatricopeptide repeat-containing protein', 207, NULL, NULL, 142148),
(142149, '1.10.4200.10-FF-000009', NULL, 'CITG protein', 118, NULL, NULL, 142149),
(142150, '3.30.710.10-FF-000520', NULL, 'Uncharacterized protein', 157, NULL, NULL, 142150),
(142151, '3.30.70.3040-FF-000012', NULL, 'Cell division ATP-binding protein FtsE', 105, NULL, NULL, 142151),
(142152, '1.25.10.10-FF-001046', NULL, 'WGS project CABT00000000 data, contig 2.4', 304, NULL, NULL, 142152),
(142153, '3.50.50.60-FF-000449', NULL, 'Glycerol-3-phosphate dehydrogenase, mitochondrial', 72, NULL, NULL, 142153),
(142154, '3.90.190.20-FF-000036', NULL, 'Putative folylpolyglutamate synthase', 131, NULL, NULL, 142154),
(142155, '3.30.1520.10-FF-000139', NULL, 'Predicted protein', 159, NULL, NULL, 142155),
(142156, '1.20.5.110-FF-000088', NULL, 'AGAP005543-PA-like protein', 107, NULL, NULL, 142156),
(142157, '1.25.10.10-FF-000534', NULL, 'HEAT repeat containing 1', 554, NULL, NULL, 142157),
(142158, '3.40.50.11660-FF-000037', NULL, NULL, 226, NULL, NULL, 142158),
(142159, '3.40.50.1000-FF-000347', NULL, 'HAD hydrolase', 127, NULL, NULL, 142159),
(142160, '2.40.30.10-FF-000279', NULL, 'Protein CBG08008', 110, NULL, NULL, 142160),
(142161, '3.40.50.150-FF-001408', NULL, NULL, 164, NULL, NULL, 142161),
(142162, '1.20.120.620-FF-000009', NULL, 'Two-component sensor KdpD', 105, NULL, NULL, 142162),
(142163, '1.10.10.60-FF-001072', NULL, NULL, 71, NULL, NULL, 142163),
(142164, '3.50.50.60-FF-001068', NULL, 'Flavin-containing monooxygenase', 222, NULL, NULL, 142164),
(142165, '1.10.225.10-FF-000039', NULL, 'Uncharacterized protein', 30, NULL, NULL, 142165),
(142166, '2.70.170.10-FF-000006', NULL, 'Cholinergic receptor nicotinic beta 2 subunit', 218, NULL, NULL, 142166),
(142167, '3.10.20.90-FF-000609', NULL, 'Neutrophil cytosolic factor 4', 106, NULL, NULL, 142167),
(142168, '1.25.40.770-FF-000006', NULL, 'Unplaced genomic scaffold supercont1.10, whole genome shotgun sequence', 217, NULL, NULL, 142168),
(142169, '2.60.40.60-FF-000361', NULL, 'Protocadherin Fat', 104, NULL, NULL, 142169),
(142170, '3.80.10.10-FF-001954', NULL, 'Leucine-rich repeat receptor-like protein kinase', 290, NULL, NULL, 142170),
(142171, '3.30.160.60-FF-000256', NULL, 'PLAG1 like zinc finger 2', 32, NULL, NULL, 142171),
(142172, '2.130.10.10-FF-000464', NULL, 'Ribosome assembly protein 4', 374, NULL, NULL, 142172);
INSERT INTO "PUBLIC"."MODEL" VALUES
(142173, '1.20.1070.10-FF-001171', NULL, 'Adhesion G protein-coupled receptor L3', 289, NULL, NULL, 142173),
(142174, '3.40.50.11980-FF-000015', NULL, 'Uncharacterized protein', 137, NULL, NULL, 142174),
(142175, '3.40.1190.20-FF-000035', NULL, 'Pyridoxal kinase', 290, NULL, NULL, 142175),
(142176, '1.10.8.60-FF-000031', NULL, 'vesicle-fusing ATPase isoform X1', 67, NULL, NULL, 142176),
(142177, '3.30.70.330-FF-001295', NULL, 'Glycine-rich RNA-binding protein RZ1B', 119, NULL, NULL, 142177),
(142178, '1.10.3810.10-FF-000022', NULL, 'Glycosyl transferase', 233, NULL, NULL, 142178),
(142179, '1.10.10.10-FF-001422', NULL, 'ATP-dependent DNA helicase RecQ', 112, NULL, NULL, 142179),
(142180, '2.40.30.130-FF-000003', NULL, 'alanyl-tRNA editing protein Aarsd1', 95, NULL, NULL, 142180),
(142181, '2.30.30.20-FF-000001', NULL, 'Aspartate carbamoyltransferase regulatory chain', 53, NULL, NULL, 142181),
(142182, '3.90.980.20-FF-000040', NULL, NULL, 96, NULL, NULL, 142182),
(142183, '1.10.287.70-FF-000065', NULL, 'sodium leak channel non-selective protein', 143, NULL, NULL, 142183),
(142184, '1.10.3430.10-FF-000032', NULL, 'Ammonium transporter, putative', 210, NULL, NULL, 142184),
(142185, '3.30.60.30-FF-000116', NULL, 'Serine protease inhibitor, Kazal-type family protein', 44, NULL, NULL, 142185),
(142186, '2.10.25.10-FF-000217', NULL, 'SCO-spondin', 58, NULL, NULL, 142186),
(142187, '1.25.70.10-FF-000083', NULL, NULL, 147, NULL, NULL, 142187),
(142188, '1.10.286.20-FF-000003', NULL, 'Elongation factor Ts', 39, NULL, NULL, 142188),
(142189, '3.10.100.10-FF-000135', NULL, 'GM16651', 178, NULL, NULL, 142189),
(142190, '3.40.50.1240-FF-000054', NULL, 'Putative phosphomutase', 235, NULL, NULL, 142190),
(142191, '3.30.470.20-FF-000245', NULL, 'Uncharacterized protein', 54, NULL, NULL, 142191),
(142192, '2.60.40.10-FF-002740', NULL, 'Chitin binding protein', 83, NULL, NULL, 142192),
(142193, '3.40.50.1820-FF-000599', NULL, 'Chromosome 23, whole genome shotgun sequence', 283, NULL, NULL, 142193),
(142194, '1.25.40.20-FF-000584', NULL, 'Uncharacterized protein', 68, NULL, NULL, 142194),
(142195, '3.40.50.720-FF-001832', NULL, 'Calcium-activated potassium channel slowpoke-like Protein', 132, NULL, NULL, 142195),
(142196, '1.25.40.10-FF-002178', NULL, 'Tetratricopeptide repeat domain 21A', 132, NULL, NULL, 142196),
(142197, '2.30.140.10-FF-000036', NULL, 'Uncharacterized protein', 38, NULL, NULL, 142197),
(142198, '3.30.40.10-FF-001424', NULL, 'RING finger protein 37', 79, NULL, NULL, 142198),
(142199, '1.20.1250.20-FF-000193', NULL, 'Solute carrier family 45 member 3', 213, NULL, NULL, 142199),
(142200, '3.40.50.620-FF-000167', NULL, 'Choline-phosphate cytidylyltransferase B', 240, NULL, NULL, 142200),
(142201, '3.30.450.20-FF-000362', NULL, 'Two-component sensor histidine kinase', 109, NULL, NULL, 142201),
(142202, '3.30.200.20-FF-000439', NULL, 'Tribbles pseudokinase 3', 81, NULL, NULL, 142202),
(142203, '1.10.730.10-FF-000027', NULL, 'Valine--tRNA ligase', 174, NULL, NULL, 142203),
(142204, '2.60.40.1180-FF-000223', NULL, 'Uncharacterized protein', 18, NULL, NULL, 142204),
(142205, '1.20.1560.10-FF-000303', NULL, 'ABC transporter PGP-2', 23, NULL, NULL, 142205),
(142206, '1.10.238.10-FF-000794', NULL, 'Reticulocalbin 1', 76, NULL, NULL, 142206),
(142207, '1.20.58.60-FF-000714', NULL, 'Uncharacterized protein', 109, NULL, NULL, 142207),
(142208, '2.10.110.10-FF-000078', NULL, 'Protein DA1-related 1', 60, NULL, NULL, 142208),
(142209, '2.130.10.10-FF-005135', NULL, 'WD-repeat containing protein', 144, NULL, NULL, 142209),
(142210, '1.25.10.10-FF-003300', NULL, 'Predicted protein', 175, NULL, NULL, 142210),
(142211, '1.25.10.10-FF-000990', NULL, 'AGAP006942-PA', 1046, NULL, NULL, 142211),
(142212, '1.10.533.10-FF-000283', NULL, 'Uncharacterized protein', 118, NULL, NULL, 142212),
(142213, '3.40.50.720-FF-000208', NULL, 'Prephenate dehydrogenase', 175, NULL, NULL, 142213),
(142214, '2.30.22.10-FF-000013', NULL, 'Protein GrpE', 56, NULL, NULL, 142214),
(142215, '2.30.30.40-FF-000007', NULL, 'nebulin isoform X1', 61, NULL, NULL, 142215);
INSERT INTO "PUBLIC"."MODEL" VALUES
(142216, '1.25.10.10-FF-002900', NULL, 'Protein CBG21459', 134, NULL, NULL, 142216),
(142217, '1.10.10.10-FF-001208', NULL, 'LysR family transcriptional regulator', 86, NULL, NULL, 142217),
(142218, '1.10.1450.10-FF-000027', NULL, 'Tetraspanin', 99, NULL, NULL, 142218),
(142219, '3.40.50.300-FF-002893', NULL, 'Rab_B04 protein', 211, NULL, NULL, 142219),
(142220, '1.50.40.10-FF-000293', NULL, 'Uncharacterized protein', 108, NULL, NULL, 142220),
(142221, '3.30.1370.10-FF-000200', NULL, 'Vigilin 1', 86, NULL, NULL, 142221),
(142222, '1.10.510.10-FF-002063', NULL, 'Protein kinase, putative', 282, NULL, NULL, 142222),
(142223, '1.10.287.1970-FF-000006', NULL, 'Alanine aminotransferase, putative', 22, NULL, NULL, 142223),
(142224, '3.90.780.10-FF-000044', NULL, 'YALI0D13640p', 82, NULL, NULL, 142224),
(142225, '3.40.50.1820-FF-001785', NULL, 'Predicted protein', 171, NULL, NULL, 142225),
(142226, '2.170.130.20-FF-000016', NULL, NULL, 100, NULL, NULL, 142226),
(142227, '3.30.40.10-FF-000800', NULL, 'Slx8p', 98, NULL, NULL, 142227),
(142228, '1.20.1070.10-FF-002132', NULL, 'Smoothend-like protein protein', 265, NULL, NULL, 142228),
(142229, '2.60.40.10-FF-000716', NULL, 'T-cell-specific surface glycoprotein CD28', 128, NULL, NULL, 142229),
(142230, '2.60.40.60-FF-000580', NULL, 'Cadherin 1, type 1', 87, NULL, NULL, 142230),
(142231, '2.60.40.790-FF-000024', NULL, 'heat shock protein beta-1', 126, NULL, NULL, 142231),
(142232, '3.30.890.10-FF-000004', NULL, 'Methyl-CpG-binding protein 2', 132, NULL, NULL, 142232),
(142233, '2.170.150.20-FF-000029', NULL, 'Uncharacterized protein', 124, NULL, NULL, 142233),
(142234, '1.25.10.10-FF-001838', NULL, 'Dynein, axonemal, assembly factor 5', 403, NULL, NULL, 142234),
(142235, '3.30.450.20-FF-000250', NULL, 'Methyl-accepting chemotaxis protein', 115, NULL, NULL, 142235),
(142236, '3.40.50.150-FF-000447', NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', 148, NULL, NULL, 142236),
(142237, '1.10.10.10-FF-001203', NULL, 'GntR family transcriptional regulator', 73, NULL, NULL, 142237),
(142238, '1.20.1070.10-FF-001856', NULL, 'Uncharacterized protein', 297, NULL, NULL, 142238),
(142239, '1.25.40.10-FF-002627', NULL, 'Intraflagellar transport protein 88 homolog', 155, NULL, NULL, 142239),
(142240, '3.40.50.450-FF-000094', NULL, 'ATP-dependent 6-phosphofructokinase 3', 107, NULL, NULL, 142240),
(142241, '1.10.10.60-FF-000015', NULL, 'Transcription factor RAX3', 62, NULL, NULL, 142241),
(142242, '1.10.472.10-FF-000146', NULL, 'Bur2p', 149, NULL, NULL, 142242),
(142243, '2.130.10.10-FF-005242', NULL, 'Predicted protein', 302, NULL, NULL, 142243),
(142244, '3.40.50.300-FF-005641', NULL, 'Uncharacterized protein', 232, NULL, NULL, 142244),
(142245, '2.70.150.10-FF-000230', NULL, 'Calcium-transporting ATPase', 226, NULL, NULL, 142245),
(142246, '2.130.10.10-FF-002836', NULL, 'Protein TSSC1', 363, NULL, NULL, 142246),
(142247, '2.20.70.10-FF-000203', NULL, 'Uncharacterized protein', 42, NULL, NULL, 142247),
(142248, '1.10.238.10-FF-000125', NULL, 'Reticulocalbin 2', 78, NULL, NULL, 142248),
(142249, '3.40.50.300-FF-001605', NULL, 'Bacitracin ABC transporter, ATP-binding protein', 241, NULL, NULL, 142249),
(142250, '3.30.450.70-FF-000023', NULL, 'Synbindin, putative', 137, NULL, NULL, 142250),
(142251, '3.30.160.60-FF-005039', NULL, NULL, 27, NULL, NULL, 142251),
(142252, '1.10.10.60-FF-000690', NULL, 'Transcriptional regulator, AraC/XylS family', 111, NULL, NULL, 142252),
(142253, '3.40.50.2300-FF-001030', NULL, NULL, 175, NULL, NULL, 142253),
(142254, '3.30.70.330-FF-000002', NULL, '50S ribosomal protein L23, chloroplastic', 86, NULL, NULL, 142254),
(142255, '2.60.120.330-FF-000238', NULL, 'Uncharacterized protein', 65, NULL, NULL, 142255),
(142256, '1.20.5.370-FF-000019', NULL, NULL, 46, NULL, NULL, 142256),
(142257, '1.10.510.10-FF-001006', NULL, 'Serine/threonine protein kinase', 364, NULL, NULL, 142257),
(142258, '1.10.10.10-FF-000933', NULL, 'Blast:AT-rich interactive domain-containing protein 2', 83, NULL, NULL, 142258),
(142259, '3.60.15.10-FF-000128', NULL, 'Unplaced genomic scaffold supercont2.2, whole genome shotgun sequence', 113, NULL, NULL, 142259);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(142260, '3.30.559.10-FF-000173', NULL, 'Nonribosomal peptide synthase 2', 165, NULL, NULL, 142260),
(142261, '3.40.50.2300-FF-001373', NULL, NULL, 76, NULL, NULL, 142261),
(142262, '1.10.246.20-FF-000006', NULL, 'Mediator of RNA polymerase II transcription subunit 15', 79, NULL, NULL, 142262),
(142263, '1.20.120.1880-FF-000017', NULL, 'Nucleoporin 155', 87, NULL, NULL, 142263),
(142264, '1.20.58.60-FF-000158', NULL, 'Spectrin beta chain', 217, NULL, NULL, 142264),
(142265, '3.40.1810.10-FF-000058', NULL, NULL, 92, NULL, NULL, 142265),
(142266, '3.30.70.330-FF-000345', NULL, 'Serine/arginine-rich splicing factor 9', 97, NULL, NULL, 142266),
(142267, '3.30.750.24-FF-000171', NULL, 'Uncharacterized protein', 81, NULL, NULL, 142267),
(142268, '3.40.30.10-FF-000990', NULL, 'Uncharacterized protein', 85, NULL, NULL, 142268),
(142269, '3.30.160.60-FF-004527', NULL, NULL, 43, NULL, NULL, 142269),
(142270, '2.50.20.10-FF-000002', NULL, 'Outer-membrane lipoprotein LolB', 178, NULL, NULL, 142270),
(142271, '3.80.10.10-FF-003516', NULL, 'Uncharacterized protein', 176, NULL, NULL, 142271),
(142272, '3.90.550.10-FF-000578', NULL, 'UDP-N-acetylglucosamine-pyrophosphorylase', 258, NULL, NULL, 142272),
(142273, '3.40.50.300-FF-000077', NULL, 'Probable DNA repair helicase RAD25', 192, NULL, NULL, 142273),
(142274, '2.60.40.60-FF-001092', NULL, 'Uncharacterized protein', 118, NULL, NULL, 142274),
(142275, '2.30.29.30-FF-000052', NULL, 'Sprouty-related, EVH1 domain containing 2', 126, NULL, NULL, 142275),
(142276, '3.40.120.10-FF-000006', NULL, 'Phosphoglucomutase PgmA', 99, NULL, NULL, 142276),
(142277, '3.40.50.2300-FF-000754', NULL, 'Chromosome-Segregation and RNAi deficient', 164, NULL, NULL, 142277),
(142278, '2.40.20.10-FF-000087', NULL, 'Muscle, skeletal, receptor tyrosine kinase', 70, NULL, NULL, 142278),
(142279, '3.90.70.10-FF-000338', NULL, 'Cathepsin 7', 313, NULL, NULL, 142279),
(142280, '2.40.50.140-FF-000443', NULL, 'Ribosomal protein', 109, NULL, NULL, 142280),
(142281, '3.40.309.10-FF-000080', NULL, 'Succinate-semialdehyde dehydrogenase', 228, NULL, NULL, 142281),
(142282, '2.30.29.30-FF-001226', NULL, 'Uncharacterized protein', 117, NULL, NULL, 142282),
(142283, '2.10.25.10-FF-001622', NULL, 'Non-specific serine/threonine protein kinase', 52, NULL, NULL, 142283),
(142284, '1.10.8.810-FF-000002', NULL, 'Daxx-like protein, isoform A', 83, NULL, NULL, 142284),
(142285, '2.10.70.10-FF-000288', NULL, 'Mannan binding lectin serine peptidase 2', 56, NULL, NULL, 142285),
(142286, '3.40.50.300-FF-006260', NULL, 'Swi/snf family helicase_2', 101, NULL, NULL, 142286),
(142287, '2.10.25.10-FF-000998', NULL, 'Latent-transforming growth factor beta-binding protein 4', 40, NULL, NULL, 142287),
(142288, '2.60.40.60-FF-000473', NULL, 'cadherin EGF LAG seven-pass G-type receptor 2 isoform X2', 105, NULL, NULL, 142288),
(142289, '3.60.20.10-FF-000101', NULL, 'Proteasome subunit alpha type', 244, NULL, NULL, 142289),
(142290, '1.10.3520.10-FF-000039', NULL, 'Uncharacterized protein', 52, NULL, NULL, 142290),
(142291, '2.60.40.10-FF-004320', NULL, NULL, 94, NULL, NULL, 142291),
(142292, '2.160.20.80-FF-000029', NULL, NULL, 80, NULL, NULL, 142292),
(142293, '3.40.50.10710-FF-000005', NULL, 'Ribonuclease J', 160, NULL, NULL, 142293),
(142294, '1.20.1110.10-FF-000258', NULL, NULL, 96, NULL, NULL, 142294),
(142295, '3.30.720.50-FF-000010', NULL, 'Zinc finger protein', 89, NULL, NULL, 142295),
(142296, '3.40.50.200-FF-000165', NULL, 'Uncharacterized protein', 131, NULL, NULL, 142296),
(142297, '2.60.40.10-FF-003696', NULL, NULL, 112, NULL, NULL, 142297),
(142298, '1.25.40.10-FF-001666', NULL, 'Crooked neck protein, putative', 174, NULL, NULL, 142298),
(142299, '2.10.25.10-FF-001274', NULL, 'slit homolog 2 protein isoform X1', 45, NULL, NULL, 142299),
(142300, '3.30.565.10-FF-000457', NULL, 'Uncharacterized protein', 73, NULL, NULL, 142300),
(142301, '3.90.1480.20-FF-000057', NULL, 'ST3 beta-galactoside alpha-2,3-sialyltransferase 3b', 136, NULL, NULL, 142301),
(142302, '3.40.850.10-FF-000303', NULL, 'Predicted protein', 289, NULL, NULL, 142302);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(142303, '1.10.730.10-FF-000022', NULL, 'Methionyl-tRNA synthetase 2, mitochondrial', 200, NULL, NULL, 142303),
(142304, '1.10.630.10-FF-000205', NULL, 'Cyp6w1, isoform B', 370, NULL, NULL, 142304),
(142305, '2.130.10.10-FF-002151', NULL, 'Sortilin-related VPS10 domain-containing receptor 3b', 320, NULL, NULL, 142305),
(142306, '1.10.168.20-FF-000004', NULL, '40S ribosomal protein S8', 22, NULL, NULL, 142306),
(142307, '3.30.160.60-FF-004185', NULL, NULL, 28, NULL, NULL, 142307),
(142308, '2.60.220.50-FF-000143', NULL, 'Uncharacterized protein', 140, NULL, NULL, 142308),
(142309, '3.40.50.300-FF-006821', NULL, 'Uncharacterized protein', 36, NULL, NULL, 142309),
(142310, '3.30.160.60-FF-004078', NULL, NULL, 34, NULL, NULL, 142310),
(142311, '4.10.60.10-FF-000002', NULL, 'cellular nucleic acid-binding protein-like isoform X1', 42, NULL, NULL, 142311),
(142312, '2.60.40.630-FF-000004', NULL, 'Signal transducer and activator of transcription', 142, NULL, NULL, 142312),
(142313, '2.130.10.10-FF-001875', NULL, 'Transducin/WD40 repeat-like superfamily protein', 207, NULL, NULL, 142313),
(142314, '3.30.420.40-FF-000647', NULL, 'Actin-related protein 5', 27, NULL, NULL, 142314),
(142315, '3.30.160.60-FF-001779', NULL, 'Zinc finger and SCAN domain containing 4', 29, NULL, NULL, 142315),
(142316, '3.40.50.300-FF-002550', NULL, 'Hypothetical_protein_-_conserved', 221, NULL, NULL, 142316),
(142317, '3.30.500.10-FF-000021', NULL, NULL, 54, NULL, NULL, 142317),
(142318, '2.40.70.10-FF-000276', NULL, 'Putative aspartic endopeptidase', 199, NULL, NULL, 142318),
(142319, '1.25.40.20-FF-001096', NULL, 'E3 ubiquitin-protein ligase MIB2-like isoform X2', 86, NULL, NULL, 142319),
(142320, '3.30.559.70-FF-000033', NULL, 'Carnitine O-palmitoyltransferase 2, mitochondrial', 239, NULL, NULL, 142320),
(142321, '3.30.1050.10-FF-000053', NULL, 'Sterol carrier protein 2', 85, NULL, NULL, 142321),
(142322, '3.10.110.10-FF-000080', NULL, 'Ubiquitin-conjugating enzyme E2 R1', 127, NULL, NULL, 142322),
(142323, '3.30.300.130-FF-000046', NULL, NULL, 83, NULL, NULL, 142323),
(142324, '3.40.50.2000-FF-000092', NULL, 'UDP-glucuronosyltransferase', 177, NULL, NULL, 142324),
(142325, '2.130.10.10-FF-003792', NULL, 'Uncharacterized protein', 313, NULL, NULL, 142325),
(142326, '3.40.50.300-FF-000296', NULL, 'ATP-dependent DNA helicase RecQ', 216, NULL, NULL, 142326),
(142327, '1.20.59.10-FF-000022', NULL, 'Uncharacterized protein', 98, NULL, NULL, 142327),
(142328, '1.25.40.10-FF-002048', NULL, 'Predicted protein', 99, NULL, NULL, 142328),
(142329, '3.90.226.10-FF-000313', NULL, 'EnoylCoA hydratase, putative', 81, NULL, NULL, 142329),
(142330, '1.10.510.10-FF-003131', NULL, NULL, 185, NULL, NULL, 142330),
(142331, '1.10.510.10-FF-002855', NULL, 'Serine/threonine-protein kinase', 230, NULL, NULL, 142331),
(142332, '3.40.190.10-FF-000516', NULL, 'Predicted protein', 146, NULL, NULL, 142332),
(142333, '3.10.290.20-FF-000022', NULL, 'Ubiquitin-activating enzyme E1, putative', 98, NULL, NULL, 142333),
(142334, '2.30.29.30-FF-000607', NULL, 'RTT106p Histone chaperone', 97, NULL, NULL, 142334),
(142335, '3.30.2020.30-FF-000006', NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', 98, NULL, NULL, 142335),
(142336, '3.40.50.300-FF-001044', NULL, 'Extra-large guanine nucleotide-binding protein 3', 197, NULL, NULL, 142336),
(142337, '2.40.30.110-FF-000008', NULL, 'Sarcosine dehydrogenase', 83, NULL, NULL, 142337),
(142338, '3.30.160.60-FF-000475', NULL, 'zinc finger protein 32 isoform X1', 29, NULL, NULL, 142338),
(142339, '1.10.2000.10-FF-000005', NULL, 'secreted frizzled-related protein 4', 126, NULL, NULL, 142339),
(142340, '1.10.472.10-FF-000601', NULL, 'Cyclin-B1-4', 19, NULL, NULL, 142340),
(142341, '2.70.50.30-FF-000009', NULL, 'RHO protein GDP dissociation inhibitor', 132, NULL, NULL, 142341),
(142342, '3.40.50.2300-FF-001480', NULL, NULL, 137, NULL, NULL, 142342),
(142343, '3.40.50.1100-FF-000259', NULL, 'Predicted protein', 140, NULL, NULL, 142343),
(142344, '3.30.450.30-FF-000016', NULL, 'Profilin', 171, NULL, NULL, 142344);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(142345, '2.130.10.10-FF-002499', NULL, 'Intraflagellar transport protein 122 homolog', 120, NULL, NULL, 142345),
(142346, '3.90.260.10-FF-000027', NULL, 'Uncharacterized protein', 275, NULL, NULL, 142346),
(142347, '1.20.120.310-FF-000023', NULL, NULL, 56, NULL, NULL, 142347),
(142348, '1.10.579.10-FF-000012', NULL, 'Predicted protein', 48, NULL, NULL, 142348),
(142349, '3.30.160.60-FF-001223', NULL, 'Zinc finger protein 14', 28, NULL, NULL, 142349),
(142350, '1.10.418.10-FF-000111', NULL, 'Fimbrin, putative', 111, NULL, NULL, 142350),
(142351, '2.130.10.10-FF-001190', NULL, 'DDB1 and CUL4 associated factor 12', 206, NULL, NULL, 142351),
(142352, '3.50.50.60-FF-000556', NULL, 'Pyridine nucleotide-disulfide oxidoreductase/Thi4 family/FAD dependent oxidoreductase/NAD(P)-binding Rossmann-like domain containing protein, putative', 183, NULL, NULL, 142352),
(142353, '1.10.8.10-FF-000151', NULL, 'UBA/TS-N domain containing protein', 43, NULL, NULL, 142353),
(142354, '3.30.1360.120-FF-000008', NULL, 'Aminomethyltransferase', 144, NULL, NULL, 142354),
(142355, '1.10.3170.10-FF-000012', NULL, 'RecBCD enzyme subunit RecB', 223, NULL, NULL, 142355),
(142356, '1.10.950.10-FF-000010', NULL, 'Coronin', 67, NULL, NULL, 142356),
(142357, '3.30.1360.100-FF-000002', NULL, 'Type II secretion system protein M', 80, NULL, NULL, 142357),
(142358, '3.30.160.60-FF-005146', NULL, NULL, 72, NULL, NULL, 142358),
(142359, '3.30.810.10-FF-000016', NULL, 'Phosphatidylinositol phosphate kinase alpha', 152, NULL, NULL, 142359),
(142360, '1.20.1110.10-FF-000039', NULL, 'Calcium-transporting ATPase', 250, NULL, NULL, 142360),
(142361, '3.90.70.10-FF-000468', NULL, 'Uncharacterized protein', 415, NULL, NULL, 142361),
(142362, '2.130.10.10-FF-005927', NULL, 'Predicted protein', 269, NULL, NULL, 142362),
(142363, '3.30.160.60-FF-000599', NULL, 'ras-responsive element-binding protein 1 isoform X1', 92, NULL, NULL, 142363),
(142364, '3.10.450.50-FF-000004', NULL, 'Nuclear RNA export factor 1', 186, NULL, NULL, 142364),
(142365, '1.20.1530.20-FF-000012', NULL, 'sodium/hydrogen exchanger 9B2 isoform X1', 404, NULL, NULL, 142365),
(142366, '3.10.580.10-FF-000120', NULL, 'Chloride channel protein', 155, NULL, NULL, 142366),
(142367, '3.40.850.10-FF-000180', NULL, 'Kinesin-like protein', 347, NULL, NULL, 142367),
(142368, '3.40.50.300-FF-008058', NULL, 'Uncharacterized protein', 125, NULL, NULL, 142368),
(142369, '1.10.510.10-FF-000483', NULL, 'Cell division cycle 7-related protein kinase', 97, NULL, NULL, 142369),
(142370, '3.40.50.300-FF-007569', NULL, 'RAD3-like DNA-binding helicase protein', 183, NULL, NULL, 142370),
(142371, '3.30.160.60-FF-000823', NULL, 'replication initiator 1 isoform X1', 30, NULL, NULL, 142371),
(142372, '3.50.30.10-FF-000012', NULL, NULL, 104, NULL, NULL, 142372),
(142373, '2.60.260.20-FF-000165', NULL, 'DnaJ homolog 1, mitochondrial', 63, NULL, NULL, 142373),
(142374, '2.130.10.10-FF-000026', NULL, 'cytoplasmic dynein 1 intermediate chain 2 isoform X2', 310, NULL, NULL, 142374),
(142375, '2.60.200.20-FF-000150', NULL, 'Uncharacterized protein', 97, NULL, NULL, 142375),
(142376, '1.20.144.10-FF-000062', NULL, 'Phosphatase PAP2 family protein', 115, NULL, NULL, 142376),
(142377, '3.90.740.10-FF-000053', NULL, 'Valine--tRNA ligase', 178, NULL, NULL, 142377),
(142378, '3.30.70.1660-FF-000031', NULL, 'Uncharacterized protein', 84, NULL, NULL, 142378),
(142379, '1.20.1250.20-FF-001497', NULL, 'Uncharacterized protein', 173, NULL, NULL, 142379),
(142380, '2.30.38.10-FF-000010', NULL, 'Long-chain fatty acid--CoA ligase', 74, NULL, NULL, 142380),
(142381, '3.30.60.270-FF-000010', NULL, 'Sortilin', 76, NULL, NULL, 142381),
(142382, '2.60.40.10-FF-001223', NULL, 'Sidekick cell adhesion molecule 1', 97, NULL, NULL, 142382),
(142383, '1.10.287.2250-FF-000001', NULL, 'Cathepsin F', 77, NULL, NULL, 142383),
(142384, '2.40.10.10-FF-000261', NULL, 'Transmembrane serine protease 5', 97, NULL, NULL, 142384),
(142385, '1.20.1250.20-FF-001845', NULL, 'Uncharacterized protein', 134, NULL, NULL, 142385),
(142386, '2.60.40.10-FF-000823', NULL, 'Tyrosine-protein phosphatase 10D', 98, NULL, NULL, 142386);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(142387, '2.110.10.10-FF-000072', NULL, 'Uncharacterized protein', 106, NULL, NULL, 142387),
(142388, '3.40.50.300-FF-000425', NULL, 'Probable ABC transporter, ATP-binding subunit', 237, NULL, NULL, 142388),
(142389, '1.10.510.10-FF-002170', NULL, 'Probable serine/threonine-protein kinase MARK-A', 273, NULL, NULL, 142389),
(142390, '2.40.100.10-FF-000082', NULL, 'Peptidyl-prolyl cis-trans isomerase', 171, NULL, NULL, 142390),
(142391, '3.30.565.10-FF-000007', NULL, 'Mitochondrial pyruvate dehydrogenase kinase isoform 2', 184, NULL, NULL, 142391),
(142392, '3.90.1150.10-FF-000423', NULL, 'Cobalamin biosynthetic protein CobC', 96, NULL, NULL, 142392),
(142393, '3.80.10.10-FF-001499', NULL, 'Leucine-rich repeat-containing protein 70', 147, NULL, NULL, 142393),
(142394, '3.30.540.10-FF-000023', NULL, 'Protein CBR-TAG-231', 171, NULL, NULL, 142394),
(142395, '2.40.30.270-FF-000028', NULL, 'DNA replication helicase DNA2, putative', 108, NULL, NULL, 142395),
(142396, '2.130.10.10-FF-004753', NULL, 'Ribosome biogenesis protein nsa1', 159, NULL, NULL, 142396),
(142397, '2.130.10.10-FF-001532', NULL, 'Small nucleolar ribonucleoprotein complex subunit (Pwp2), putative', 124, NULL, NULL, 142397),
(142398, '3.30.420.40-FF-000304', NULL, 'Type 4 fimbrial biogenesis protein PilM', 150, NULL, NULL, 142398),
(142399, '3.40.50.300-FF-004348', NULL, 'Hypothetical_protein_-_conserved', 244, NULL, NULL, 142399),
(142400, '3.80.10.10-FF-002123', NULL, 'Predicted protein', 202, NULL, NULL, 142400),
(142401, '3.80.10.10-FF-002336', NULL, 'Putative leucine-rich repeat receptor-like serine/threonine-protein kinase', 117, NULL, NULL, 142401),
(142402, '1.10.260.100-FF-000004', NULL, 'Putative stress-induced-phosphoprotein 1', 69, NULL, NULL, 142402),
(142403, '2.20.25.20-FF-000012', NULL, 'Casein kinase II subunit beta', 72, NULL, NULL, 142403),
(142404, '3.90.1100.10-FF-000021', NULL, 'DNA-directed RNA polymerase subunit beta', 202, NULL, NULL, 142404),
(142405, '3.40.50.1460-FF-000114', NULL, 'Uncharacterized protein', 85, NULL, NULL, 142405),
(142406, '1.10.472.80-FF-000257', NULL, NULL, 62, NULL, NULL, 142406),
(142407, '2.40.128.630-FF-000006', NULL, 'Protein kinase', 78, NULL, NULL, 142407),
(142408, '2.60.120.260-FF-000532', NULL, 'Putative secreted beta-galactosidase', 88, NULL, NULL, 142408),
(142409, '3.60.140.10-FF-000008', NULL, 'Polyphenol oxidase', 239, NULL, NULL, 142409),
(142410, '1.20.120.330-FF-000029', NULL, 'Aminoglycoside 6-adenylyltransferase', 146, NULL, NULL, 142410),
(142411, '3.50.50.60-FF-001517', NULL, 'Uncharacterized protein', 81, NULL, NULL, 142411),
(142412, '2.30.30.60-FF-000002', NULL, 'Mechanosensitive ion channel family protein', 51, NULL, NULL, 142412),
(142413, '3.80.10.10-FF-001847', NULL, 'Leucine-rich repeat protein (LRRP), putative', 77, NULL, NULL, 142413),
(142414, '1.10.220.150-FF-000028', NULL, 'ADP-ribosylation factor GTPase activating protein 1, putative', 131, NULL, NULL, 142414),
(142415, '2.70.170.10-FF-000113', NULL, 'Gamma-aminobutyric acid type A receptor pi subunit', 64, NULL, NULL, 142415),
(142416, '1.20.140.100-FF-000054', NULL, 'Uncharacterized protein', 57, NULL, NULL, 142416),
(142417, '3.30.70.330-FF-003088', NULL, NULL, 105, NULL, NULL, 142417),
(142418, '3.30.830.10-FF-000118', NULL, 'Uncharacterized protein', 206, NULL, NULL, 142418),
(142419, '3.40.50.2000-FF-000108', NULL, 'UDP-glycosyltransferase 83A1', 253, NULL, NULL, 142419),
(142420, '1.25.10.10-FF-002114', NULL, 'Formin-like 3', 240, NULL, NULL, 142420),
(142421, '1.10.20.10-FF-000068', NULL, 'Nuclear factor Y transcription factor', 112, NULL, NULL, 142421),
(142422, '2.10.70.10-FF-000069', NULL, 'Complement component receptor type 1', 62, NULL, NULL, 142422),
(142423, '1.20.1250.20-FF-000086', NULL, 'ascorbate transporter, chloroplastic isoform X2', 190, NULL, NULL, 142423),
(142424, '3.30.870.10-FF-000121', NULL, 'Cardiolipin synthetase', 148, NULL, NULL, 142424),
(142425, '2.60.40.10-FF-000262', NULL, 'MAM domain containing glycosylphosphatidylinositol anchor 1', 95, NULL, NULL, 142425),
(142426, '3.40.50.10890-FF-000014', NULL, 'Integrator complex subunit 11', 45, NULL, NULL, 142426);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(142427, '3.30.450.40-FF-000132', NULL, 'Transcriptional regulatory protein', 170, NULL, NULL, 142427),
(142428, '3.30.300.30-FF-000028', NULL, 'AMP-dependent synthetase', 113, NULL, NULL, 142428),
(142429, '2.70.50.50-FF-000004', NULL, 'Chitin binding protein', 141, NULL, NULL, 142429),
(142430, '3.90.1300.10-FF-000002', NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit A, mitochondrial', 499, NULL, NULL, 142430),
(142431, '3.30.1360.10-FF-000031', NULL, 'DNA-directed RNA polymerase RPB3', 46, NULL, NULL, 142431),
(142432, '3.30.160.60-FF-003460', NULL, 'Early growth response protein 1', 22, NULL, NULL, 142432),
(142433, '1.10.1900.10-FF-000006', NULL, 'Polyadenylate-binding protein', 75, NULL, NULL, 142433),
(142434, '1.10.510.10-FF-001787', NULL, 'Kitb', 181, NULL, NULL, 142434),
(142435, '2.130.10.10-FF-002948', NULL, 'Uncharacterized protein', 282, NULL, NULL, 142435),
(142436, '3.30.565.10-FF-000226', NULL, 'Sensor histidine kinase', 135, NULL, NULL, 142436),
(142437, '3.30.160.60-FF-006096', NULL, NULL, 22, NULL, NULL, 142437),
(142438, '3.20.20.70-FF-000300', NULL, 'GTP 3'',8-cyclase 2', 334, NULL, NULL, 142438),
(142439, '1.25.40.10-FF-000598', NULL, 'pentatricopeptide repeat-containing protein At1g20230 isoform X2', 134, NULL, NULL, 142439),
(142440, '3.30.50.10-FF-000065', NULL, 'GATA transcription factor LreA', 44, NULL, NULL, 142440),
(142441, '1.10.10.10-FF-001990', NULL, 'Uncharacterized protein', 43, NULL, NULL, 142441),
(142442, '3.40.50.970-FF-000036', NULL, '2-oxoglutarate dehydrogenase E1 component', 378, NULL, NULL, 142442),
(142443, '3.30.420.10-FF-000200', NULL, 'Protein CBG10739', 218, NULL, NULL, 142443),
(142444, '3.40.50.1980-FF-000152', NULL, 'Iron ABC transporter, periplasmic substrate-binding protein', 146, NULL, NULL, 142444),
(142445, '3.90.550.10-FF-000454', NULL, 'Slr1537 protein', 239, NULL, NULL, 142445),
(142446, '3.30.200.20-FF-000883', NULL, 'OSJNBb0096E05.1 protein', 108, NULL, NULL, 142446),
(142447, '2.30.30.40-FF-000451', NULL, 'Tyrosine-protein kinase', 53, NULL, NULL, 142447),
(142448, '3.90.660.10-FF-000120', NULL, NULL, 125, NULL, NULL, 142448),
(142449, '1.25.40.20-FF-000707', NULL, 'Kinase, NEK', 93, NULL, NULL, 142449),
(142450, '1.20.1050.10-FF-000096', NULL, 'TCHQD class glutathione S-transferase', 111, NULL, NULL, 142450),
(142451, '2.60.120.200-FF-000087', NULL, 'Laminin subunit alpha 4', 177, NULL, NULL, 142451),
(142452, '1.10.260.100-FF-000010', NULL, 'Hsp70/Hsp90 organizing protein', 67, NULL, NULL, 142452),
(142453, '3.30.450.200-FF-000009', NULL, 'Receptor Mediated Endocytosis', 141, NULL, NULL, 142453),
(142454, '3.40.50.1240-FF-000178', NULL, NULL, 189, NULL, NULL, 142454),
(142455, '3.90.640.10-FF-000012', NULL, 'Hypoxia up-regulated protein 1', 85, NULL, NULL, 142455),
(142456, '3.30.200.20-FF-002120', NULL, 'Uncharacterized protein', 75, NULL, NULL, 142456),
(142457, '2.60.120.590-FF-000052', NULL, 'Uncharacterized protein', 205, NULL, NULL, 142457),
(142458, '1.10.3210.10-FF-000049', NULL, 'Inositol oxygenase 2', 152, NULL, NULL, 142458),
(142459, '3.30.160.60-FF-002509', NULL, 'Uncharacterized protein', 29, NULL, NULL, 142459),
(142460, '2.70.240.10-FF-000001', NULL, 'Alpha-hemolysin', 294, NULL, NULL, 142460),
(142461, '1.25.40.10-FF-002739', NULL, 'Peptidase family C50-domain-containing protein', 231, NULL, NULL, 142461),
(142462, '1.20.1050.140-FF-000002', NULL, 'H(2):CoB-CoM heterodisulfide,ferredoxin reductase subunit B', 128, NULL, NULL, 142462),
(142463, '3.40.640.10-FF-000023', NULL, 'Transcriptional regulator, GntR family', 220, NULL, NULL, 142463),
(142464, '2.60.40.10-FF-005045', NULL, NULL, 102, NULL, NULL, 142464),
(142465, '3.30.1120.130-FF-000003', NULL, 'Probable serine/threonine-protein kinase zyg-1', 100, NULL, NULL, 142465),
(142466, '3.40.1280.30-FF-000034', NULL, 'Uncharacterized protein', 159, NULL, NULL, 142466),
(142467, '3.90.600.20-FF-000001', NULL, NULL, 95, NULL, NULL, 142467),
(142468, '3.50.50.60-FF-000106', NULL, 'Glycerol-3-phosphate dehydrogenase', 117, NULL, NULL, 142468),
(142469, '2.60.40.10-FF-002392', NULL, 'Muscle M-line assembly protein unc-89', 93, NULL, NULL, 142469);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(142470, '1.10.287.70-FF-000520', NULL, 'Phosphomevalonate kinase', 132, NULL, NULL, 142470),
(142471, '2.10.25.10-FF-000892', NULL, 'Putative wall-associated kinase', 39, NULL, NULL, 142471),
(142472, '2.10.220.10-FF-000176', NULL, 'Uncharacterized protein', 76, NULL, NULL, 142472),
(142473, '1.10.238.10-FF-000338', NULL, 'Probable calcium-binding protein CML35', 87, NULL, NULL, 142473),
(142474, '1.10.510.10-FF-003024', NULL, NULL, 228, NULL, NULL, 142474),
(142475, '3.40.50.300-FF-000189', NULL, 'Member of ras oncogene family', 173, NULL, NULL, 142475),
(142476, '3.40.50.150-FF-000919', NULL, NULL, 153, NULL, NULL, 142476),
(142477, '2.60.40.380-FF-000002', NULL, 'Alkaline phosphatase D', 108, NULL, NULL, 142477),
(142478, '3.40.50.10810-FF-000029', NULL, 'ERCC excision repair 6-like, spindle assembly checkpoint helicase', 265, NULL, NULL, 142478),
(142479, '3.30.70.20-FF-000069', NULL, 'DNA-directed RNA polymerase II subunit, putative', 73, NULL, NULL, 142479),
(142480, '1.20.1050.10-FF-000107', NULL, 'Glutathione S-transferase family protein', 112, NULL, NULL, 142480),
(142481, '2.60.40.10-FF-004533', NULL, NULL, 93, NULL, NULL, 142481),
(142482, '1.10.510.10-FF-002512', NULL, NULL, 114, NULL, NULL, 142482),
(142483, '1.10.287.110-FF-000162', NULL, 'Chaperone protein dnaJ C76, chloroplastic', 89, NULL, NULL, 142483),
(142484, '1.20.1420.30-FF-000012', NULL, 'Vacuolar cation/proton exchanger', 140, NULL, NULL, 142484),
(142485, '2.130.10.10-FF-000818', NULL, 'WD domain', 294, NULL, NULL, 142485),
(142486, '3.40.50.2000-FF-000653', NULL, 'Glycosyltransferase', 243, NULL, NULL, 142486),
(142487, '3.30.160.60-FF-000368', NULL, 'Krueppel-like factor 15', 30, NULL, NULL, 142487),
(142488, '1.10.10.10-FF-000354', NULL, 'COP9 signalosome complex subunit 3', 73, NULL, NULL, 142488),
(142489, '3.30.70.1230-FF-000256', NULL, 'Adenylyl cyclase class-3/4/guanylyl cyclase', 184, NULL, NULL, 142489),
(142490, '3.40.50.1220-FF-000065', NULL, 'Sir2 family transcriptional regulator putative', 143, NULL, NULL, 142490),
(142491, '1.20.1250.20-FF-001839', NULL, 'Uncharacterized protein', 139, NULL, NULL, 142491),
(142492, '2.60.200.20-FF-000262', NULL, 'Uncharacterized protein', 65, NULL, NULL, 142492),
(142493, '3.90.660.10-FF-000007', NULL, 'Lysine-specific histone demethylase 1B', 222, NULL, NULL, 142493),
(142494, '1.20.120.730-FF-000025', NULL, 'Protein transport protein Sec24A, putative', 136, NULL, NULL, 142494),
(142495, '2.30.30.30-FF-000116', NULL, '5''-3'' exoribonuclease 1', 49, NULL, NULL, 142495),
(142496, '1.10.10.60-FF-000796', NULL, 'Homeobox and leucine zipper encoding a', 85, NULL, NULL, 142496),
(142497, '1.10.196.10-FF-000004', NULL, 'regulator of G-protein signaling 12 isoform X1', 54, NULL, NULL, 142497),
(142498, '1.10.238.10-FF-001182', NULL, 'Uncharacterized protein', 87, NULL, NULL, 142498),
(142499, '3.90.550.10-FF-000347', NULL, 'Minor teichoic acid biosynthesis protein GgaA', 250, NULL, NULL, 142499),
(142500, '3.40.30.10-FF-000765', NULL, 'Thiol-disulfide isomerase or thioredoxin', 174, NULL, NULL, 142500),
(142501, '3.30.70.330-FF-002363', NULL, NULL, 164, NULL, NULL, 142501),
(142502, '3.90.70.80-FF-000090', NULL, 'Uncharacterized protein', 77, NULL, NULL, 142502),
(142503, '3.40.50.300-FF-004478', NULL, 'ABC transporter family protein', 237, NULL, NULL, 142503),
(142504, '2.60.40.1730-FF-000085', NULL, NULL, 285, NULL, NULL, 142504),
(142505, '3.30.450.40-FF-000025', NULL, 'Stage V sporulation protein T', 123, NULL, NULL, 142505),
(142506, '3.40.50.300-FF-006714', NULL, 'Predicted protein', 76, NULL, NULL, 142506),
(142507, '3.40.50.150-FF-000234', NULL, 'Probable RNA methyltransferase At5g51130', 217, NULL, NULL, 142507),
(142508, '3.10.180.10-FF-000022', NULL, '4-hydroxyphenylpyruvate dioxygenase', 210, NULL, NULL, 142508),
(142509, '1.20.1310.20-FF-000029', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 187, NULL, NULL, 142509),
(142510, '3.30.460.10-FF-000197', NULL, 'ATPase synthesis protein 25, mitochondrial', 139, NULL, NULL, 142510),
(142511, '3.30.160.60-FF-002841', NULL, 'Zinc finger protein', 36, NULL, NULL, 142511); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(142512, '3.50.30.40-FF-000004', NULL, 'D-arabino-3-hexulose 6-phosphate formaldehyde lyase', 199, NULL, NULL, 142512),
(142513, '1.20.5.900-FF-000004', NULL, 'T-cell surface glycoprotein CD4', 35, NULL, NULL, 142513),
(142514, '2.70.98.20-FF-000015', NULL, 'Amine oxidase', 469, NULL, NULL, 142514),
(142515, '3.40.50.720-FF-001720', NULL, 'D-glycerate dehydrogenase', 120, NULL, NULL, 142515),
(142516, '3.40.190.10-FF-000168', NULL, 'ABC transporter, substrate-binding protein, family 3', 125, NULL, NULL, 142516),
(142517, '3.40.50.300-FF-002443', NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', 118, NULL, NULL, 142517),
(142518, '3.40.250.10-FF-000212', NULL, 'Predicted protein', 97, NULL, NULL, 142518),
(142519, '3.90.70.80-FF-000101', NULL, 'Cysteine proteinases superfamily protein', 75, NULL, NULL, 142519),
(142520, '3.55.50.30-FF-000031', NULL, 'Fec operon regulator FecR', 77, NULL, NULL, 142520),
(142521, '1.20.1070.10-FF-000108', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', 271, NULL, NULL, 142521),
(142522, '1.25.40.730-FF-000011', NULL, 'Clathrin heavy chain', 94, NULL, NULL, 142522),
(142523, '2.130.10.10-FF-002044', NULL, 'Pre-mRNA cleavage and polyadenylation factor (CPF) complex subunit', 195, NULL, NULL, 142523),
(142524, '2.30.29.30-FF-000158', NULL, 'FYVE, RhoGEF and PH domain containing 6', 102, NULL, NULL, 142524),
(142525, '1.10.8.60-FF-000267', NULL, 'AAA family ATPase, putative', 74, NULL, NULL, 142525),
(142526, '1.20.1250.20-FF-001608', NULL, 'Uncharacterized protein', 202, NULL, NULL, 142526),
(142527, '1.25.40.10-FF-004196', NULL, 'Uncharacterized protein', 74, NULL, NULL, 142527),
(142528, '1.10.510.10-FF-000258', NULL, 'Probable serine/threonine-protein kinase PBL8', 214, NULL, NULL, 142528),
(142529, '1.25.10.10-FF-000085', NULL, 'Wings apart-like protein homolog', 514, NULL, NULL, 142529),
(142530, '1.10.10.10-FF-001658', NULL, 'Protein CSN12 homolog', 71, NULL, NULL, 142530),
(142531, '3.40.50.2300-FF-000529', NULL, 'Gamma-aminobutyric acid type B receptor subunit 2', 175, NULL, NULL, 142531),
(142532, '2.40.50.100-FF-000116', NULL, 'sn-glycerol-3-phosphate import ATP-binding protein UgpC', 47, NULL, NULL, 142532),
(142533, '2.40.170.20-FF-000033', NULL, 'TonB-dependent siderophore receptor', 526, NULL, NULL, 142533),
(142534, '3.30.70.330-FF-000906', NULL, 'Nuclear cap-binding protein subunit 2', 132, NULL, NULL, 142534),
(142535, '1.20.120.1240-FF-000056', NULL, 'Dynamin-related protein,putative', 207, NULL, NULL, 142535),
(142536, '2.40.50.90-FF-000023', NULL, 'Tudor domain containing 6', 103, NULL, NULL, 142536),
(142537, '3.40.50.300-FF-004803', NULL, '6-phosphofructo-2-kinase/fructose-2, 6-bisphosphatase 2', 210, NULL, NULL, 142537),
(142538, '3.40.630.10-FF-000197', NULL, 'Uncharacterized protein', 304, NULL, NULL, 142538),
(142539, '2.60.40.150-FF-000063', NULL, 'Copine 4', 131, NULL, NULL, 142539),
(142540, '1.20.5.390-FF-000014', NULL, NULL, 69, NULL, NULL, 142540),
(142541, '1.10.8.270-FF-000126', NULL, 'Uncharacterized protein', 111, NULL, NULL, 142541),
(142542, '3.40.50.410-FF-000110', NULL, 'Protein CBR-DIG-1', 195, NULL, NULL, 142542),
(142543, '3.80.10.10-FF-000993', NULL, 'Dia2p', 179, NULL, NULL, 142543),
(142544, '2.40.30.10-FF-000043', NULL, 'dual oxidase 1', 101, NULL, NULL, 142544),
(142545, '3.90.480.10-FF-000010', NULL, 'Sulfite reductase', 91, NULL, NULL, 142545),
(142546, '3.30.200.20-FF-000658', NULL, 'Ethanolamine kinase', 102, NULL, NULL, 142546),
(142547, '3.90.190.10-FF-000252', NULL, 'Uncharacterized protein', 45, NULL, NULL, 142547),
(142548, '3.10.450.50-FF-000111', NULL, 'Uncharacterized protein', 57, NULL, NULL, 142548),
(142549, '2.10.110.10-FF-000308', NULL, 'Uncharacterized protein', 100, NULL, NULL, 142549),
(142550, '1.10.150.50-FF-000040', NULL, 'Phosphatidylcholine:ceramide cholinephosphotransferase 1', 73, NULL, NULL, 142550),
(142551, '2.60.40.10-FF-004426', NULL, NULL, 93, NULL, NULL, 142551),
(142552, '3.40.50.261-FF-000026', NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta, mitochondrial', 147, NULL, NULL, 142552);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(142553, '1.10.510.10-FF-000590', NULL, 'PR5-like receptor kinase', 206, NULL, NULL, 142553),
(142554, '3.50.50.60-FF-000337', NULL, 'GDP dissociation inhibitor, putative', 74, NULL, NULL, 142554),
(142555, '1.20.1280.50-FF-000029', NULL, 'F-box only protein 30', 50, NULL, NULL, 142555),
(142556, '3.50.50.60-FF-000213', NULL, 'FAD-containing monooxygenase EthA', 177, NULL, NULL, 142556),
(142557, '2.60.40.10-FF-004314', NULL, NULL, 98, NULL, NULL, 142557),
(142558, '3.40.50.300-FF-000532', NULL, 'ABC transporter G family member 34', 306, NULL, NULL, 142558),
(142559, '1.10.540.10-FF-000086', NULL, 'Flavin-dependent monooxygenase', 114, NULL, NULL, 142559),
(142560, '3.40.50.2000-FF-000546', NULL, 'Uncharacterized protein', 168, NULL, NULL, 142560),
(142561, '2.160.20.10-FF-000273', NULL, 'Uncharacterized protein', 265, NULL, NULL, 142561),
(142562, '1.25.40.10-FF-001323', NULL, 'Pentatricopeptide repeat-containing protein At2g33680', 121, NULL, NULL, 142562),
(142563, '3.40.50.1820-FF-001436', NULL, 'Phospholipase A2, group VII (platelet-activating factor acetylhydrolase, plasma)', 192, NULL, NULL, 142563),
(142564, '1.25.40.20-FF-001545', NULL, 'Uncharacterized protein', 120, NULL, NULL, 142564),
(142565, '2.130.10.10-FF-004174', NULL, 'Uncharacterized protein', 166, NULL, NULL, 142565),
(142566, '2.60.40.10-FF-003589', NULL, NULL, 98, NULL, NULL, 142566),
(142567, '3.30.470.20-FF-000032', NULL, 'tubulin monoglycylase TTLL3 isoform X2', 225, NULL, NULL, 142567),
(142568, '1.10.760.10-FF-000086', NULL, 'Cytochrome c551 peroxidase', 160, NULL, NULL, 142568),
(142569, '1.20.1250.20-FF-001154', NULL, 'Putative inorganic phosphate cotransporter-like Protein', 432, NULL, NULL, 142569),
(142570, '1.10.720.30-FF-000078', NULL, 'Uncharacterized protein', 37, NULL, NULL, 142570),
(142571, '3.30.2080.10-FF-000010', NULL, 'Glycoside hydrolase family 92 protein', 142, NULL, NULL, 142571),
(142572, '2.60.40.10-FF-000155', NULL, 'complement C3 isoform X1', 111, NULL, NULL, 142572),
(142573, '3.30.230.80-FF-000026', NULL, 'Heat shock protein 90C', 172, NULL, NULL, 142573),
(142574, '1.10.10.60-FF-000807', NULL, 'Telomeric repeat-binding factor 2-interacting protein 1', 55, NULL, NULL, 142574),
(142575, '3.30.1010.10-FF-000056', NULL, 'Phosphatidylinositol 4-kinase alpha, putative', 180, NULL, NULL, 142575),
(142576, '3.30.40.10-FF-000351', NULL, 'Mitochondrial ubiquitin ligase activator of NFKB 1', 80, NULL, NULL, 142576),
(142577, '3.40.50.720-FF-000995', NULL, 'GM19262', 248, NULL, NULL, 142577),
(142578, '1.20.1640.10-FF-000017', NULL, 'Patched domain-containing protein 1', 206, NULL, NULL, 142578),
(142579, '3.30.70.330-FF-002582', NULL, NULL, 137, NULL, NULL, 142579),
(142580, '3.40.50.300-FF-003966', NULL, 'ABC transporter ATP-binding protein', 272, NULL, NULL, 142580),
(142581, '2.30.29.30-FF-000490', NULL, 'Pleckstrin homology domain containing O2', 114, NULL, NULL, 142581),
(142582, '3.90.1150.10-FF-000529', NULL, 'Uncharacterized protein', 113, NULL, NULL, 142582),
(142583, '3.40.50.12230-FF-000012', NULL, 'Uncharacterized protein', 352, NULL, NULL, 142583),
(142584, '2.70.130.10-FF-000116', NULL, NULL, 87, NULL, NULL, 142584),
(142585, '3.30.200.20-FF-000990', NULL, 'Mitogen-activated protein kinase', 114, NULL, NULL, 142585),
(142586, '4.10.240.10-FF-000097', NULL, 'C6 zinc finger domain protein', 80, NULL, NULL, 142586),
(142587, '1.20.1560.10-FF-000758', NULL, 'HlyB/MsbA family ABC transporter', 341, NULL, NULL, 142587),
(142588, '1.10.238.10-FF-001070', NULL, 'Uncharacterized protein', 124, NULL, NULL, 142588),
(142589, '3.90.550.10-FF-000235', NULL, 'Beta-1,4-galactosyltransferase 1', 105, NULL, NULL, 142589),
(142590, '3.40.367.20-FF-000020', NULL, 'Hexokinase-1', 254, NULL, NULL, 142590),
(142591, '1.10.510.10-FF-000039', NULL, 'Focal adhesion kinase, isoform D', 207, NULL, NULL, 142591),
(142592, '1.10.8.100-FF-000008', NULL, 'Ribosomal RNA small subunit methyltransferase A', 71, NULL, NULL, 142592),
(142593, '3.30.70.270-FF-000175', NULL, NULL, 107, NULL, NULL, 142593),
(142594, '1.10.287.1490-FF-000071', NULL, 'Uncharacterized protein', 174, NULL, NULL, 142594);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(142595, '3.30.200.20-FF-002007', NULL, 'Eukaryotic translation initiation factor 2 alpha kinase 3', 95, NULL, NULL, 142595),
(142596, '3.80.10.10-FF-001830', NULL, 'Uncharacterized protein', 138, NULL, NULL, 142596),
(142597, '3.40.50.800-FF-000013', NULL, 'Histidine--tRNA ligase', 95, NULL, NULL, 142597),
(142598, '2.120.10.30-FF-000431', NULL, 'Uncharacterized protein', 137, NULL, NULL, 142598),
(142599, '3.40.50.2300-FF-000861', NULL, NULL, 109, NULL, NULL, 142599),
(142600, '1.20.1260.10-FF-000033', NULL, 'Ferritin', 126, NULL, NULL, 142600),
(142601, '3.30.60.60-FF-000007', NULL, 'Histone acetyltransferase', 62, NULL, NULL, 142601),
(142602, '1.10.238.10-FF-000670', NULL, 'N-terminal EF-hand calcium binding protein 3', 112, NULL, NULL, 142602),
(142603, '3.80.10.10-FF-002230', NULL, 'Uncharacterized protein', 120, NULL, NULL, 142603),
(142604, '4.10.1240.30-FF-000004', NULL, 'Integrin beta', 83, NULL, NULL, 142604),
(142605, '3.40.50.300-FF-005192', NULL, 'Uncharacterized protein', 213, NULL, NULL, 142605),
(142606, '3.30.200.20-FF-000097', NULL, 'Probable serine/threonine-protein kinase nek1', 83, NULL, NULL, 142606),
(142607, '2.40.70.10-FF-000146', NULL, 'Aspartic protease', 211, NULL, NULL, 142607),
(142608, '2.10.60.10-FF-000012', NULL, 'Anti-Muellerian hormone type-2 receptor', 80, NULL, NULL, 142608),
(142609, '1.20.1540.10-FF-000072', NULL, 'RHOMBOID-like protein', 175, NULL, NULL, 142609),
(142610, '1.25.40.720-FF-000020', NULL, 'Uncharacterized protein', 113, NULL, NULL, 142610),
(142611, '3.30.230.70-FF-000147', NULL, 'Uncharacterized protein', 105, NULL, NULL, 142611),
(142612, '3.30.70.1110-FF-000001', NULL, 'Chemotaxis protein CheA', 86, NULL, NULL, 142612),
(142613, '3.30.160.100-FF-000015', NULL, 'Ribosomal associated cold shock response protein YfiA', 100, NULL, NULL, 142613),
(142614, '3.30.40.10-FF-001076', NULL, 'E3 ubiquitin-protein ligase MSL2 isoform X2', 70, NULL, NULL, 142614),
(142615, '1.10.472.10-FF-000276', NULL, 'CYCLIN B15', 14, NULL, NULL, 142615),
(142616, '1.25.10.10-FF-002007', NULL, 'Uncharacterized protein B24H17.130', 219, NULL, NULL, 142616),
(142617, '1.20.1250.20-FF-002227', NULL, 'Monocarboxylate transporter, putative', 127, NULL, NULL, 142617),
(142618, '1.10.132.10-FF-000003', NULL, 'DNA topoisomerase I', 147, NULL, NULL, 142618),
(142619, '3.40.50.720-FF-002232', NULL, '2-hydroxyacid dehydrogenase, putative', 94, NULL, NULL, 142619),
(142620, '2.60.40.60-FF-000922', NULL, 'Protocadherin 18', 63, NULL, NULL, 142620),
(142621, '3.40.366.10-FF-000048', NULL, 'Fatty acid synthase beta subunit aflB', 158, NULL, NULL, 142621),
(142622, '2.10.25.10-FF-001510', NULL, 'Uncharacterized protein', 42, NULL, NULL, 142622),
(142623, '2.60.120.260-FF-000425', NULL, 'Reelin', 109, NULL, NULL, 142623),
(142624, '3.90.1420.10-FF-000056', NULL, 'Lysine N-methylase', 87, NULL, NULL, 142624),
(142625, '2.30.29.30-FF-000501', NULL, 'EG:23E12.2, isoform A', 134, NULL, NULL, 142625),
(142626, '3.40.50.300-FF-005203', NULL, 'Predicted protein', 211, NULL, NULL, 142626),
(142627, '3.10.20.90-FF-001009', NULL, 'Uncharacterized protein', 103, NULL, NULL, 142627),
(142628, '1.10.10.160-FF-000024', NULL, 'Exodeoxyribonuclease V, gamma subunit', 107, NULL, NULL, 142628),
(142629, '3.30.420.10-FF-000312', NULL, NULL, 166, NULL, NULL, 142629),
(142630, '1.20.920.10-FF-000023', NULL, 'Bromodomain adjacent to zinc finger domain protein 2B', 121, NULL, NULL, 142630),
(142631, '2.60.120.200-FF-000323', NULL, 'cadherin EGF LAG seven-pass G-type receptor 3 isoform X2', 195, NULL, NULL, 142631),
(142632, '3.30.20.10-FF-000006', NULL, NULL, 30, NULL, NULL, 142632),
(142633, '3.40.50.300-FF-006153', NULL, 'ATP-binding cassette, sub-family B (MDR/TAP), member 11b', 16, NULL, NULL, 142633),
(142634, '1.25.40.10-FF-004757', NULL, 'Uncharacterized protein', 61, NULL, NULL, 142634),
(142635, '3.30.710.10-FF-000071', NULL, 'Kelch-like family member 24', 126, NULL, NULL, 142635),
(142636, '2.60.40.10-FF-000374', NULL, 'Protein tyrosine phosphatase, receptor type, H', 86, NULL, NULL, 142636);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(142637, '3.30.890.10-FF-000010', NULL, 'Methyl-CpG-binding-domain-like, isoform C', 84, NULL, NULL, 142637),
(142638, '3.30.565.10-FF-000114', NULL, 'Two-component system sensor molecule', 152, NULL, NULL, 142638),
(142639, '2.170.130.10-FF-000025', NULL, 'TonB-dependent siderophore receptor', 121, NULL, NULL, 142639),
(142640, '3.10.50.10-FF-000015', NULL, 'Chitotriosidase-1', 67, NULL, NULL, 142640),
(142641, '3.10.20.90-FF-000380', NULL, 'Plant UBX domain-containing protein 10', 77, NULL, NULL, 142641),
(142642, '3.30.50.10-FF-000177', NULL, 'Uncharacterized protein', 65, NULL, NULL, 142642),
(142643, '1.25.40.10-FF-000486', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 114, NULL, NULL, 142643),
(142644, '3.30.40.10-FF-000019', NULL, 'RBR-type E3 ubiquitin transferase', 90, NULL, NULL, 142644),
(142645, '1.10.220.10-FF-000051', NULL, 'Annexin', 56, NULL, NULL, 142645),
(142646, '1.10.510.10-FF-004081', NULL, NULL, 165, NULL, NULL, 142646),
(142647, '2.30.110.10-FF-000085', NULL, 'Flavin reductase domain protein FMN-binding', 160, NULL, NULL, 142647),
(142648, '3.40.640.10-FF-000478', NULL, 'Uncharacterized protein', 81, NULL, NULL, 142648),
(142649, '3.90.1010.10-FF-000025', NULL, 'Nitrogen-fixing NifU domain protein', 148, NULL, NULL, 142649),
(142650, '3.40.50.1000-FF-000797', NULL, NULL, 160, NULL, NULL, 142650),
(142651, '2.40.50.140-FF-000336', NULL, 'Membrane-bound serine protease', 64, NULL, NULL, 142651),
(142652, '3.80.10.10-FF-003409', NULL, 'EIN3-binding F-box protein 1', 87, NULL, NULL, 142652),
(142653, '1.25.40.20-FF-001107', NULL, 'Putative ubiquitin ligase protein mib2', 52, NULL, NULL, 142653),
(142654, '3.40.50.300-FF-007676', NULL, 'Os01g0691600 protein', 116, NULL, NULL, 142654),
(142655, '2.60.40.150-FF-000624', NULL, 'Predicted protein', 145, NULL, NULL, 142655),
(142656, '3.90.70.200-FF-000023', NULL, 'Uncharacterized protein', 128, NULL, NULL, 142656),
(142657, '1.20.1070.10-FF-000327', NULL, 'Vasopressin V1a receptor', 185, NULL, NULL, 142657),
(142658, '2.60.200.10-FF-000040', NULL, 'Mothers against decapentaplegic homolog', 146, NULL, NULL, 142658),
(142659, '1.10.30.50-FF-000007', NULL, 'HNH endonuclease', 84, NULL, NULL, 142659),
(142660, '1.10.357.150-FF-000016', NULL, 'Predicted protein', 194, NULL, NULL, 142660),
(142661, '2.60.120.330-FF-000002', NULL, '1-aminocyclopropane-1-carboxylate oxidase 1', 318, NULL, NULL, 142661),
(142662, '2.30.30.40-FF-000575', NULL, 'Predicted protein', 76, NULL, NULL, 142662),
(142663, '1.10.472.80-FF-000021', NULL, 'GTPase activating protein (Gyp2)', 140, NULL, NULL, 142663),
(142664, '3.80.10.10-FF-004028', NULL, 'Predicted protein', 145, NULL, NULL, 142664),
(142665, '1.10.1420.10-FF-000076', NULL, 'DNA mismatch repair protein MutS', 138, NULL, NULL, 142665),
(142666, '3.40.50.1000-FF-000454', NULL, 'Phospholipid-transporting ATPase', 138, NULL, NULL, 142666),
(142667, '4.10.80.40-FF-000001', NULL, 'Succinate dehydrogenase flavoprotein subunit', 41, NULL, NULL, 142667),
(142668, '3.10.100.10-FF-000360', NULL, NULL, 109, NULL, NULL, 142668),
(142669, '1.20.1070.10-FF-001620', NULL, 'Uncharacterized protein', 144, NULL, NULL, 142669),
(142670, '3.90.1290.10-FF-000017', NULL, 'Microtubule-actin crosslinking factor 1', 168, NULL, NULL, 142670),
(142671, '1.20.1250.20-FF-000535', NULL, 'Sucrose transport protein SUT5', 211, NULL, NULL, 142671),
(142672, '1.50.10.10-FF-000015', NULL, 'alpha-1,2-Mannosidase', 461, NULL, NULL, 142672),
(142673, '1.25.40.10-FF-005033', NULL, 'Uncharacterized protein', 142, NULL, NULL, 142673),
(142674, '2.60.40.1170-FF-000107', NULL, NULL, 68, NULL, NULL, 142674),
(142675, '3.20.20.80-FF-000415', NULL, 'Uncharacterized protein', 399, NULL, NULL, 142675),
(142676, '1.10.287.70-FF-000301', NULL, 'Uncharacterized protein', 148, NULL, NULL, 142676),
(142677, '3.80.10.10-FF-003180', NULL, 'Uncharacterized protein', 249, NULL, NULL, 142677),
(142678, '1.20.920.30-FF-000029', NULL, 'Dynein heavy chain', 216, NULL, NULL, 142678),
(142679, '3.30.70.980-FF-000056', NULL, 'Uncharacterized protein', 48, NULL, NULL, 142679);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(142680, '4.10.520.10-FF-000028', NULL, NULL, 94, NULL, NULL, 142680),
(142681, '3.30.559.10-FF-000280', NULL, 'Carnitine O-palmitoyltransferase, putative', 248, NULL, NULL, 142681),
(142682, '1.10.10.10-FF-000478', NULL, 'SET domain and mariner transposase fusion gene', 39, NULL, NULL, 142682),
(142683, '3.90.1150.10-FF-000187', NULL, 'Probable L-tyrosine/L-aspartate decarboxylase', 116, NULL, NULL, 142683),
(142684, '3.60.21.10-FF-000064', NULL, 'Serine/threonine-protein phosphatase', 373, NULL, NULL, 142684),
(142685, '3.30.9.10-FF-000166', NULL, 'Predicted protein', 11, NULL, NULL, 142685),
(142686, '3.90.190.10-FF-000595', NULL, 'Phosphatase and tensin homolog A', 73, NULL, NULL, 142686),
(142687, '1.10.510.10-FF-002624', NULL, NULL, 92, NULL, NULL, 142687),
(142688, '3.90.180.10-FF-000190', NULL, 'Alcohol dehydrogenase-like 3', 55, NULL, NULL, 142688),
(142689, '4.10.400.10-FF-000317', NULL, 'Sortilin-related receptor, L(DLR class) A repeats-containing', 36, NULL, NULL, 142689),
(142690, '3.30.160.60-FF-002965', NULL, 'AGAP007915-PA', 28, NULL, NULL, 142690),
(142691, '3.40.800.10-FF-000013', NULL, 'Agmatinase, putative', 314, NULL, NULL, 142691),
(142692, '3.30.1490.190-FF-000030', NULL, 'Fe2+/Zn2+ uptake regulation protein', 51, NULL, NULL, 142692),
(142693, '1.20.272.40-FF-000003', NULL, 'ATP-dependent RNA helicase SUV3L, mitochondrial', 79, NULL, NULL, 142693),
(142694, '3.40.50.300-FF-007114', NULL, 'Uncharacterized protein', 185, NULL, NULL, 142694),
(142695, '3.40.1280.10-FF-000039', NULL, '23S rRNA methyltransferase TsnR', 162, NULL, NULL, 142695),
(142696, '2.60.40.10-FF-001335', NULL, 'Sallimus, isoform Q', 102, NULL, NULL, 142696),
(142697, '3.40.30.10-FF-000889', NULL, 'Uncharacterized protein', 59, NULL, NULL, 142697),
(142698, '3.40.640.10-FF-000135', NULL, 'Transcriptional regulator PtsJ', 340, NULL, NULL, 142698),
(142699, '2.30.42.10-FF-000121', NULL, 'Tax1-binding protein 3', 113, NULL, NULL, 142699),
(142700, '3.40.50.620-FF-000403', NULL, 'Probable nicotinate-nucleotide adenylyltransferase', 190, NULL, NULL, 142700),
(142701, '3.30.160.60-FF-003241', NULL, 'Topi', 29, NULL, NULL, 142701),
(142702, '1.50.10.20-FF-000131', NULL, 'Protein farnesyltransferase subunit beta', 402, NULL, NULL, 142702),
(142703, '1.25.10.10-FF-001389', NULL, 'Importin 8', 821, NULL, NULL, 142703),
(142704, '2.60.40.1120-FF-000008', NULL, 'Carboxypeptidase D', 110, NULL, NULL, 142704),
(142705, '2.30.30.30-FF-000010', NULL, 'Elongation factor P', 63, NULL, NULL, 142705),
(142706, '1.10.150.780-FF-000003', NULL, 'Vacuolar protein sorting-associated protein 16, putative', 108, NULL, NULL, 142706),
(142707, '3.90.640.10-FF-000118', NULL, 'Actin, gamma 2, smooth muscle, enteric', 22, NULL, NULL, 142707),
(142708, '3.30.505.10-FF-000009', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', 107, NULL, NULL, 142708),
(142709, '1.25.40.10-FF-004072', NULL, 'Protein high chlorophyll fluorescent 107', 159, NULL, NULL, 142709),
(142710, '3.20.20.80-FF-000073', NULL, 'Alpha-1,3-glucan synthase Ags2', 425, NULL, NULL, 142710),
(142711, '3.60.120.10-FF-000013', NULL, 'Anthranilate synthase component I', 388, NULL, NULL, 142711),
(142712, '3.10.450.40-FF-000013', NULL, 'Bacillolysin', 83, NULL, NULL, 142712),
(142713, '1.10.1870.10-FF-000008', NULL, 'Probable saccharopine dehydrogenase [NADP(+), L-glutamate-forming]', 124, NULL, NULL, 142713),
(142714, '3.90.1600.10-FF-000042', NULL, 'DNA polymerase epsilon catalytic subunit', 127, NULL, NULL, 142714),
(142715, '1.20.58.390-FF-000126', NULL, 'Ligand-Gated ion Channel', 152, NULL, NULL, 142715),
(142716, '3.30.160.60-FF-006219', NULL, NULL, 20, NULL, NULL, 142716),
(142717, '1.10.287.130-FF-000044', NULL, 'LAO/AO transport system ATPase', 69, NULL, NULL, 142717),
(142718, '3.10.120.10-FF-000030', NULL, 'Fatty acid 2-hydroxylase', 82, NULL, NULL, 142718),
(142719, '3.30.70.3490-FF-000029', NULL, NULL, 107, NULL, NULL, 142719),
(142720, '3.40.30.10-FF-001165', NULL, 'Uncharacterized protein', 96, NULL, NULL, 142720),
(142721, '2.130.10.10-FF-005478', NULL, 'Uncharacterized protein', 143, NULL, NULL, 142721);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(142722, '3.30.420.40-FF-000416', NULL, 'Acetate kinase', 198, NULL, NULL, 142722),
(142723, '3.40.50.1820-FF-000256', NULL, 'Poly(ethylene terephthalate) hydrolase', 266, NULL, NULL, 142723),
(142724, '2.70.170.10-FF-000225', NULL, 'Uncharacterized protein', 100, NULL, NULL, 142724),
(142725, '3.40.50.11820-FF-000001', NULL, 'Glycosyl transferase', 175, NULL, NULL, 142725),
(142726, '1.25.40.10-FF-003796', NULL, 'Uncharacterized protein', 317, NULL, NULL, 142726),
(142727, '2.60.120.650-FF-000216', NULL, 'Uncharacterized protein', 257, NULL, NULL, 142727),
(142728, '1.20.58.60-FF-000607', NULL, 'Spectrin beta chain', 117, NULL, NULL, 142728),
(142729, '3.90.226.10-FF-000201', NULL, 'Carboxyl-terminal-processing peptidase 1 chloroplastic', 24, NULL, NULL, 142729),
(142730, '1.10.510.10-FF-002967', NULL, NULL, 119, NULL, NULL, 142730),
(142731, '3.10.129.10-FF-000241', NULL, 'Uncharacterized protein', 139, NULL, NULL, 142731),
(142732, '1.25.10.10-FF-002788', NULL, 'Uncharacterized protein', 240, NULL, NULL, 142732),
(142733, '3.80.10.10-FF-003741', NULL, 'Uncharacterized protein', 130, NULL, NULL, 142733),
(142734, '1.25.40.20-FF-000820', NULL, 'Ankyrin repeat family protein', 64, NULL, NULL, 142734),
(142735, '2.60.40.10-FF-002971', NULL, NULL, 88, NULL, NULL, 142735),
(142736, '2.20.110.10-FF-000025', NULL, 'MORN repeat, putative', 55, NULL, NULL, 142736),
(142737, '1.10.1670.10-FF-000010', NULL, 'DNA-3-methyladenine glycosylase II', 51, NULL, NULL, 142737),
(142738, '3.80.10.10-FF-000318', NULL, 'transforming growth factor beta activator LRRC32', 122, NULL, NULL, 142738),
(142739, '1.10.10.1320-FF-000013', NULL, 'Transcriptional activator, putative', 99, NULL, NULL, 142739),
(142740, '2.60.40.640-FF-000114', NULL, 'Uncharacterized protein', 61, NULL, NULL, 142740),
(142741, '3.30.310.260-FF-000002', NULL, 'Zgc:158858', 79, NULL, NULL, 142741),
(142742, '3.90.1150.170-FF-000003', NULL, 'Glutamate decarboxylase 1', 171, NULL, NULL, 142742),
(142743, '3.60.110.10-FF-000063', NULL, 'N-carbamoylputrescine amidase', 292, NULL, NULL, 142743),
(142744, '1.20.58.1970-FF-000008', NULL, 'Predicted protein', 164, NULL, NULL, 142744),
(142745, '3.80.10.10-FF-001611', NULL, 'Uncharacterized protein', 100, NULL, NULL, 142745),
(142746, '1.10.620.20-FF-000022', NULL, 'Phenol hydroxylase component', 331, NULL, NULL, 142746),
(142747, '1.10.238.10-FF-000917', NULL, 'Uncharacterized protein', 184, NULL, NULL, 142747),
(142748, '2.60.120.920-FF-000084', NULL, 'SPRY_domain/HECT-domain_(Ubiquitin-transferase)_-_putative', 170, NULL, NULL, 142748),
(142749, '1.25.10.10-FF-003064', NULL, 'Condensin complex subunit 1', 265, NULL, NULL, 142749),
(142750, '3.30.1520.10-FF-000033', NULL, 'Sorting nexin 25', 129, NULL, NULL, 142750),
(142751, '2.60.120.10-FF-000668', NULL, 'Auxin-binding protein 5', 109, NULL, NULL, 142751),
(142752, '3.10.100.10-FF-000028', NULL, 'integral membrane protein DGCR2/IDD isoform X2', 180, NULL, NULL, 142752),
(142753, '3.40.50.300-FF-007333', NULL, 'Ras-related protein RabK3', 143, NULL, NULL, 142753),
(142754, '2.130.10.10-FF-001768', NULL, 'Gid7p', 366, NULL, NULL, 142754),
(142755, '2.130.10.10-FF-003005', NULL, 'Transducin', 185, NULL, NULL, 142755),
(142756, '2.30.42.10-FF-000464', NULL, NULL, 125, NULL, NULL, 142756),
(142757, '3.40.50.150-FF-001291', NULL, NULL, 217, NULL, NULL, 142757),
(142758, '1.20.1070.10-FF-001963', NULL, 'Uncharacterized protein', 188, NULL, NULL, 142758),
(142759, '2.30.30.40-FF-000232', NULL, 'RIMS-binding protein 3A-like', 72, NULL, NULL, 142759),
(142760, '3.40.50.920-FF-000032', NULL, 'Pyruvate flavodoxin/ferredoxin oxidoreductase domain protein', 114, NULL, NULL, 142760),
(142761, '3.90.1140.10-FF-000029', NULL, 'A-kinase anchor protein 7 isoform gamma', 211, NULL, NULL, 142761),
(142762, '2.60.40.1140-FF-000003', NULL, 'Collagen adhesin', 104, NULL, NULL, 142762),
(142763, '3.40.50.1010-FF-000238', NULL, NULL, 59, NULL, NULL, 142763),
(142764, '3.30.420.40-FF-000198', NULL, 'Actin like 8', 109, NULL, NULL, 142764),
(142765, '1.10.357.10-FF-000070', NULL, 'TetR family transcriptional regulator', 141, NULL, NULL, 142765);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(142766, '4.10.60.10-FF-000238', NULL, 'Uncharacterized protein', 47, NULL, NULL, 142766),
(142767, '1.20.1270.60-FF-000301', NULL, 'Uncharacterized protein', 126, NULL, NULL, 142767),
(142768, '3.40.50.1400-FF-000029', NULL, 'Protein CBG20458', 228, NULL, NULL, 142768),
(142769, '2.130.10.10-FF-002605', NULL, 'Uncharacterized protein', 467, NULL, NULL, 142769),
(142770, '1.25.40.10-FF-004414', NULL, 'Uncharacterized protein', 131, NULL, NULL, 142770),
(142771, '2.30.29.30-FF-001119', NULL, 'Uncharacterized protein', 132, NULL, NULL, 142771),
(142772, '3.30.70.330-FF-001963', NULL, NULL, 92, NULL, NULL, 142772),
(142773, '3.40.50.1110-FF-000032', NULL, 'GDSL-like protein', 170, NULL, NULL, 142773),
(142774, '3.30.160.60-FF-000711', NULL, 'zinc finger protein 697', 27, NULL, NULL, 142774),
(142775, '3.30.530.20-FF-000183', NULL, 'Uncharacterized protein', 95, NULL, NULL, 142775),
(142776, '1.25.40.10-FF-000941', NULL, 'Pentatricopeptide repeat-containing protein At5g15300', 106, NULL, NULL, 142776),
(142777, '2.60.40.790-FF-000131', NULL, NULL, 109, NULL, NULL, 142777),
(142778, '1.20.58.60-FF-000265', NULL, 'Microtubule-actin cross-linking factor 1', 111, NULL, NULL, 142778),
(142779, '3.40.850.10-FF-000292', NULL, 'Uncharacterized protein', 376, NULL, NULL, 142779),
(142780, '3.30.70.580-FF-000043', NULL, 'Pseudouridine synthase', 82, NULL, NULL, 142780),
(142781, '2.170.270.10-FF-000187', NULL, 'Histone-lysine N-methyltransferase', 220, NULL, NULL, 142781),
(142782, '3.30.160.60-FF-004421', NULL, NULL, 28, NULL, NULL, 142782),
(142783, '1.20.120.630-FF-000001', NULL, 'ATP-dependent DNA helicase RecG', 101, NULL, NULL, 142783),
(142784, '3.40.50.300-FF-006372', NULL, 'Uncharacterized protein', 138, NULL, NULL, 142784),
(142785, '2.130.10.10-FF-005697', NULL, 'Predicted protein', 150, NULL, NULL, 142785),
(142786, '3.20.20.80-FF-000758', NULL, 'Iduronidase alpha-L-', 293, NULL, NULL, 142786),
(142787, '4.10.1170.10-FF-000003', NULL, 'MAP kinase-activated protein kinase mak-1', 60, NULL, NULL, 142787),
(142788, '3.40.50.300-FF-006496', NULL, 'Uncharacterized protein', 114, NULL, NULL, 142788),
(142789, '1.50.40.10-FF-000186', NULL, 'YPR011Cp-like protein', 306, NULL, NULL, 142789),
(142790, '1.10.510.10-FF-003928', NULL, NULL, 73, NULL, NULL, 142790),
(142791, '3.30.60.10-FF-000003', NULL, 'Class IV chitinase', 49, NULL, NULL, 142791),
(142792, '3.30.420.10-FF-000655', NULL, NULL, 198, NULL, NULL, 142792),
(142793, '3.30.465.10-FF-000062', NULL, 'POSSIBLE OXIDOREDUCTASE', 118, NULL, NULL, 142793),
(142794, '1.20.58.60-FF-000046', NULL, 'Spectrin alpha chain, non-erythrocytic 1', 71, NULL, NULL, 142794),
(142795, '2.40.30.160-FF-000001', NULL, 'tRNA-modifying protein YgfZ', 122, NULL, NULL, 142795),
(142796, '3.10.10.10-FF-000018', NULL, NULL, 69, NULL, NULL, 142796),
(142797, '1.20.90.10-FF-000044', NULL, NULL, 37, NULL, NULL, 142797),
(142798, '2.40.70.10-FF-000040', NULL, 'aspartyl protease AED3', 186, NULL, NULL, 142798),
(142799, '3.40.50.300-FF-002786', NULL, 'Uncharacterized conserved protein', 202, NULL, NULL, 142799),
(142800, '2.60.40.150-FF-000282', NULL, 'Rho GTPase-activating protein syd-1', 138, NULL, NULL, 142800),
(142801, '3.20.20.140-FF-000179', NULL, 'WGS project CABT00000000 data, contig 2.98', 294, NULL, NULL, 142801),
(142802, '2.30.29.30-FF-001338', NULL, 'G protein-coupled receptor kinase', 44, NULL, NULL, 142802),
(142803, '3.30.870.10-FF-000008', NULL, 'CDP-diacylglycerol--serine O-phosphatidyltransferase', 209, NULL, NULL, 142803),
(142804, '3.30.2060.10-FF-000008', NULL, 'Penicillin-binding protein 1B', 90, NULL, NULL, 142804),
(142805, '3.40.710.10-FF-000130', NULL, 'D-alanyl-D-alanine carboxypeptidase', 139, NULL, NULL, 142805),
(142806, '3.40.50.1970-FF-000054', NULL, NULL, 179, NULL, NULL, 142806),
(142807, '3.40.50.720-FF-001377', NULL, 'Putative NAD-dependent 2-hydroxyacid dehydrogenase', 189, NULL, NULL, 142807),
(142808, '3.30.900.10-FF-000006', NULL, 'HORMA domain-containing protein 1', 275, NULL, NULL, 142808),
(142809, '3.30.230.10-FF-000045', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase, chloroplastic', 173, NULL, NULL, 142809); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(142810, '1.10.730.10-FF-000134', NULL, 'Uncharacterized protein', 116, NULL, NULL, 142810),
(142811, '3.80.10.10-FF-000650', NULL, 'Protein kinase A regulatory subunit', 161, NULL, NULL, 142811),
(142812, '2.130.10.10-FF-002387', NULL, 'WD-40 repeat protein', 251, NULL, NULL, 142812),
(142813, '3.30.60.30-FF-000009', NULL, 'Follistatin a', 76, NULL, NULL, 142813),
(142814, '3.90.1430.10-FF-000006', NULL, '114 kDa U5 small nuclear ribonucleoprotein component', 103, NULL, NULL, 142814),
(142815, '3.40.1620.60-FF-000002', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 10', 92, NULL, NULL, 142815),
(142816, '1.25.40.10-FF-000609', NULL, 'Small glutamine-rich tetratricopeptide repeat protein', 145, NULL, NULL, 142816),
(142817, '3.40.50.300-FF-002662', NULL, 'tRNA dimethylallyltransferase 9', 284, NULL, NULL, 142817),
(142818, '2.130.10.10-FF-001987', NULL, 'WD repeat domain 60', 349, NULL, NULL, 142818),
(142819, '3.30.420.40-FF-000759', NULL, 'Uncharacterized protein', 144, NULL, NULL, 142819),
(142820, '4.10.60.10-FF-000114', NULL, 'Zinc knuckle domain containing protein', 65, NULL, NULL, 142820),
(142821, '2.130.10.10-FF-002729', NULL, 'Protein ROOT INITIATION DEFECTIVE 3', 300, NULL, NULL, 142821),
(142822, '1.25.40.20-FF-000146', NULL, 'Ankyrin repeat and SOCS box containing 7', 77, NULL, NULL, 142822),
(142823, '2.60.40.10-FF-001678', NULL, 'filamin-A isoform X8', 91, NULL, NULL, 142823),
(142824, '3.60.10.10-FF-000145', NULL, 'Endonuclease/Exonuclease/phosphatase family prote in', 309, NULL, NULL, 142824),
(142825, '2.170.300.10-FF-000061', NULL, 'Predicted protein', 62, NULL, NULL, 142825),
(142826, '3.80.10.10-FF-003067', NULL, 'Uncharacterized protein', 138, NULL, NULL, 142826),
(142827, '3.40.30.10-FF-000546', NULL, 'thioredoxin domain-containing protein 5', 113, NULL, NULL, 142827),
(142828, '3.30.40.10-FF-001531', NULL, 'Uncharacterized protein', 107, NULL, NULL, 142828),
(142829, '1.10.10.440-FF-000018', NULL, 'pre-mRNA-processing factor 40 homolog A', 50, NULL, NULL, 142829),
(142830, '1.10.645.10-FF-000003', NULL, 'NAD(P)H-quinone oxidoreductase subunit H, chloroplastic', 384, NULL, NULL, 142830),
(142831, '3.40.50.10470-FF-000006', NULL, 'Methylthioribose-1-phosphate isomerase', 198, NULL, NULL, 142831),
(142832, '3.40.50.300-FF-003062', NULL, 'Conserved protein', 212, NULL, NULL, 142832),
(142833, '1.10.510.10-FF-004204', NULL, NULL, 220, NULL, NULL, 142833),
(142834, '3.80.10.10-FF-004360', NULL, 'Uncharacterized protein', 176, NULL, NULL, 142834),
(142835, '1.25.40.790-FF-000001', NULL, 'Ccr4-not transcription complex subunit 1 isoform', 303, NULL, NULL, 142835),
(142836, '1.25.40.20-FF-000910', NULL, 'Calmodulin-binding transcription activator 2', 132, NULL, NULL, 142836),
(142837, '1.10.730.10-FF-000235', NULL, 'Methionine--tRNA ligase', 152, NULL, NULL, 142837),
(142838, '3.80.10.10-FF-003831', NULL, 'Uncharacterized protein', 67, NULL, NULL, 142838),
(142839, '3.40.50.880-FF-000065', NULL, 'Carbamoyl-phosphate synthase small chain', 213, NULL, NULL, 142839),
(142840, '1.10.10.60-FF-000661', NULL, 'Transcription repressor MYB5', 85, NULL, NULL, 142840),
(142841, '1.25.10.10-FF-002524', NULL, 'Si:dkey-21e13.3', 191, NULL, NULL, 142841),
(142842, '1.25.40.320-FF-000012', NULL, 'Predicted protein', 54, NULL, NULL, 142842),
(142843, '3.30.70.330-FF-002492', NULL, NULL, 75, NULL, NULL, 142843),
(142844, '1.10.10.820-FF-000014', NULL, 'unconventional myosin-XIX isoform X1', 52, NULL, NULL, 142844),
(142845, '3.40.50.300-FF-008457', NULL, 'Uncharacterized protein', 250, NULL, NULL, 142845),
(142846, '3.10.196.10-FF-000002', NULL, 'Methionine synthase', 195, NULL, NULL, 142846),
(142847, '3.40.50.1820-FF-001375', NULL, 'Uncharacterized protein', 223, NULL, NULL, 142847),
(142848, '3.80.20.20-FF-000047', NULL, 'Receptor protein-tyrosine kinase', 198, NULL, NULL, 142848),
(142849, '1.25.40.10-FF-002026', NULL, 'Pentatricopeptide repeat-containing protein', 167, NULL, NULL, 142849),
(142850, '3.20.200.10-FF-000017', NULL, 'Alpha-protein kinase vwkA', 116, NULL, NULL, 142850);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(142851, '3.40.50.300-FF-005231', NULL, 'Bifunctional heparan sulfate N-deacetylase/N-sulfotransferase', 302, NULL, NULL, 142851),
(142852, '2.160.20.10-FF-000340', NULL, 'Uncharacterized protein', 285, NULL, NULL, 142852),
(142853, '2.40.50.140-FF-000263', NULL, 'Ribosomal protein S1-like1', 96, NULL, NULL, 142853),
(142854, '1.20.1250.20-FF-002160', NULL, 'Uncharacterized protein', 193, NULL, NULL, 142854),
(142855, '2.60.40.10-FF-003302', NULL, 'Leukemia inhibitory factor receptor alpha b', 90, NULL, NULL, 142855),
(142856, '2.60.120.340-FF-000022', NULL, 'DNA-binding protein, putative', 95, NULL, NULL, 142856),
(142857, '1.10.555.10-FF-000013', NULL, 'SLIT-ROBO Rho GTPase activating protein 3', 252, NULL, NULL, 142857),
(142858, '2.60.40.150-FF-000512', NULL, 'Calpain 6', 117, NULL, NULL, 142858),
(142859, '3.30.230.70-FF-000057', NULL, '3''exoribonuclease, putative', 247, NULL, NULL, 142859),
(142860, '3.40.50.1910-FF-000002', NULL, 'Sec1 family domain-containing protein 1', 213, NULL, NULL, 142860),
(142861, '1.20.920.30-FF-000052', NULL, 'Uncharacterized protein', 201, NULL, NULL, 142861),
(142862, '1.20.1270.70-FF-000001', NULL, 'Uncharacterized protein', 67, NULL, NULL, 142862),
(142863, '3.90.550.50-FF-000168', NULL, 'Uncharacterized protein', 82, NULL, NULL, 142863),
(142864, '2.120.10.30-FF-000347', NULL, 'Tol-Pal system protein TolB', 260, NULL, NULL, 142864),
(142865, '3.40.50.410-FF-000121', NULL, 'Midasin, putative', 174, NULL, NULL, 142865),
(142866, '3.40.50.1820-FF-000273', NULL, 'Dual specificity phosphatase catalytic domain protein', 293, NULL, NULL, 142866),
(142867, '2.10.110.10-FF-000342', NULL, 'Uncharacterized protein', 87, NULL, NULL, 142867),
(142868, '3.30.160.60-FF-000464', NULL, 'Zinc finger and SCAN domain containing 25', 28, NULL, NULL, 142868),
(142869, '3.10.20.90-FF-000683', NULL, 'NFATC2-interacting protein', 95, NULL, NULL, 142869),
(142870, '3.30.980.10-FF-000011', NULL, 'Alanyl-tRNA synthetase domain protein', 150, NULL, NULL, 142870),
(142871, '3.90.950.10-FF-000052', NULL, 'Guanine nucleotide exchange factor SPIKE 1', 72, NULL, NULL, 142871),
(142872, '3.40.50.300-FF-004242', NULL, 'Replication factor C small subunit', 184, NULL, NULL, 142872),
(142873, '3.30.160.60-FF-001127', NULL, 'Zinc finger protein 142', 59, NULL, NULL, 142873),
(142874, '3.80.30.20-FF-000019', NULL, 'tRNA methylthiotransferase YqeV', 227, NULL, NULL, 142874),
(142875, '3.40.1090.10-FF-000143', NULL, 'Uncharacterized protein', 77, NULL, NULL, 142875),
(142876, '2.10.25.10-FF-001370', NULL, 'Uncharacterized protein', 39, NULL, NULL, 142876),
(142877, '3.90.550.10-FF-000589', NULL, 'Glycosyltransferase-like protein', 235, NULL, NULL, 142877),
(142878, '1.10.238.10-FF-000384', NULL, 'Signal transducer and activator of transcription', 116, NULL, NULL, 142878),
(142879, '2.60.40.10-FF-004730', NULL, NULL, 119, NULL, NULL, 142879),
(142880, '2.30.30.40-FF-000097', NULL, 'Putative src kinase-associated phosphoprotein 2', 60, NULL, NULL, 142880),
(142881, '2.70.130.10-FF-000094', NULL, NULL, 158, NULL, NULL, 142881),
(142882, '2.20.70.10-FF-000136', NULL, 'Pre-mRNA-processing protein 40A', 57, NULL, NULL, 142882),
(142883, '2.60.200.20-FF-000032', NULL, 'FHA domain-containing protein', 106, NULL, NULL, 142883),
(142884, '3.30.160.60-FF-000138', NULL, 'Zinc finger and BTB domain containing 7C', 26, NULL, NULL, 142884),
(142885, '3.30.2350.20-FF-000051', NULL, NULL, 235, NULL, NULL, 142885),
(142886, '3.90.1150.10-FF-000445', NULL, 'Aminotransferase', 151, NULL, NULL, 142886),
(142887, '1.10.1140.10-FF-000004', NULL, 'V-type ATP synthase alpha chain', 144, NULL, NULL, 142887),
(142888, '2.60.40.1510-FF-000058', NULL, 'Integrin beta', 52, NULL, NULL, 142888),
(142889, '1.20.210.10-FF-000008', NULL, 'Nitric oxide reductase large subunit', 533, NULL, NULL, 142889),
(142890, '3.10.20.740-FF-000007', NULL, 'NADH-ubiquinone oxidoreductase 75 kDa subunit, mitochondrial isoform X3', 37, NULL, NULL, 142890),
(142891, '2.40.10.10-FF-000643', NULL, NULL, 142, NULL, NULL, 142891),
(142892, '3.10.20.720-FF-000001', NULL, 'Inner kinetochore subunit CHL4', 85, NULL, NULL, 142892);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(142893, '1.10.510.10-FF-002754', NULL, 'Predicted protein', 252, NULL, NULL, 142893),
(142894, '3.40.50.720-FF-002041', NULL, 'BC089597 protein', 181, NULL, NULL, 142894),
(142895, '1.20.930.40-FF-000027', NULL, 'AER157Cp', 161, NULL, NULL, 142895),
(142896, '3.40.30.10-FF-001243', NULL, 'Uncharacterized protein', 79, NULL, NULL, 142896),
(142897, '1.20.930.20-FF-000021', NULL, 'Uncharacterized protein', 147, NULL, NULL, 142897),
(142898, '3.30.60.190-FF-000008', NULL, 'Zinc finger protein', 54, NULL, NULL, 142898),
(142899, '3.90.1150.10-FF-000119', NULL, 'Ddc, isoform C', 99, NULL, NULL, 142899),
(142900, '2.70.170.10-FF-000214', NULL, 'Uncharacterized protein', 144, NULL, NULL, 142900),
(142901, '1.20.5.110-FF-000189', NULL, 'AT4G17730 protein', 64, NULL, NULL, 142901),
(142902, '2.130.10.10-FF-002763', NULL, 'WD repeat domain phosphoinositide interacting protein, putative', 243, NULL, NULL, 142902),
(142903, '1.10.1780.10-FF-000007', NULL, 'Chaperone protein ClpB', 142, NULL, NULL, 142903),
(142904, '1.20.1070.10-FF-001923', NULL, 'Uncharacterized protein', 281, NULL, NULL, 142904),
(142905, '3.90.550.10-FF-000117', NULL, 'Glycosyltransferase family 34 protein', 199, NULL, NULL, 142905),
(142906, '3.20.180.20-FF-000028', NULL, 'Dynein heavy chain, cytosolic, putative', 95, NULL, NULL, 142906),
(142907, '1.20.120.350-FF-000086', NULL, 'Potassium voltage-gated channel subfamily KQT member 1', 85, NULL, NULL, 142907),
(142908, '2.70.150.10-FF-000005', NULL, 'Calcium-transporting ATPase', 161, NULL, NULL, 142908),
(142909, '3.40.350.10-FF-000074', NULL, 'Aminopeptidase P1, putative', 155, NULL, NULL, 142909),
(142910, '3.30.1010.10-FF-000117', NULL, 'Uncharacterized protein', 80, NULL, NULL, 142910),
(142911, '2.10.25.10-FF-000116', NULL, 'pro-neuregulin-2, membrane-bound isoform', 47, NULL, NULL, 142911),
(142912, '1.10.3430.10-FF-000077', NULL, 'Uncharacterized protein', 108, NULL, NULL, 142912),
(142913, '2.30.42.10-FF-000481', NULL, NULL, 94, NULL, NULL, 142913),
(142914, '3.20.20.10-FF-000092', NULL, 'Uncharacterized protein', 97, NULL, NULL, 142914),
(142915, '2.30.29.30-FF-000023', NULL, 'Kinesin family member 1B', 112, NULL, NULL, 142915),
(142916, '3.40.190.10-FF-000246', NULL, '4-amino-5-hydroxymethyl-2-methylpyrimidine phosphate synthase THI13', 87, NULL, NULL, 142916),
(142917, '3.30.1560.10-FF-000001', NULL, 'Protein mago nashi homolog', 144, NULL, NULL, 142917),
(142918, '3.30.40.10-FF-001469', NULL, 'Uncharacterized protein', 77, NULL, NULL, 142918),
(142919, '3.90.1140.10-FF-000001', NULL, 'Ubiquitin-associated and SH3 domain-containing protein B', 162, NULL, NULL, 142919),
(142920, '2.60.40.10-FF-000661', NULL, 'receptor-type tyrosine-protein kinase FLT3', 94, NULL, NULL, 142920),
(142921, '1.10.1300.10-FF-000039', NULL, 'Phosphodiesterase', 201, NULL, NULL, 142921),
(142922, '1.10.10.10-FF-000753', NULL, 'Vacuolar sorting protein', 69, NULL, NULL, 142922),
(142923, '3.40.50.720-FF-000096', NULL, 'tRNA cyclic N6-threonylcarbamoyladenosine(37) synthase TcdA', 268, NULL, NULL, 142923),
(142924, '2.10.110.10-FF-000016', NULL, 'LIM domain only 3', 72, NULL, NULL, 142924),
(142925, '3.50.50.60-FF-000404', NULL, 'Glucose-methanol-choline (Gmc) oxidoreductase', 241, NULL, NULL, 142925),
(142926, '2.120.10.80-FF-000255', NULL, 'Uncharacterized protein', 207, NULL, NULL, 142926),
(142927, '3.30.160.60-FF-002908', NULL, 'Zinc finger protein 304', 56, NULL, NULL, 142927),
(142928, '3.60.20.10-FF-000207', NULL, NULL, 187, NULL, NULL, 142928),
(142929, '3.30.160.60-FF-004679', NULL, NULL, 66, NULL, NULL, 142929),
(142930, '3.90.640.10-FF-000242', NULL, 'Uncharacterized protein', 29, NULL, NULL, 142930),
(142931, '3.40.50.1970-FF-000059', NULL, NULL, 191, NULL, NULL, 142931),
(142932, '3.40.50.2300-FF-000344', NULL, 'Glutamate ionotropic receptor NMDA type subunit 2A', 67, NULL, NULL, 142932),
(142933, '2.170.120.12-FF-000010', NULL, 'Related to RPB3-DNA-directed RNA polymerase II chain', 134, NULL, NULL, 142933),
(142934, '3.40.5.10-FF-000011', NULL, '50S ribosomal protein L9', 60, NULL, NULL, 142934);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(142935, '3.40.50.300-FF-006366', NULL, 'Uncharacterized protein', 139, NULL, NULL, 142935),
(142936, '3.30.519.10-FF-000002', NULL, 'Guanosine nucleotide diphosphate dissociation inhibitor', 152, NULL, NULL, 142936),
(142937, '3.10.310.10-FF-000050', NULL, 'Proline racemase', 168, NULL, NULL, 142937),
(142938, '3.80.10.10-FF-002050', NULL, 'Leucine-rich repeat receptor-like protein kinase', 122, NULL, NULL, 142938),
(142939, '3.30.420.40-FF-000377', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', 158, NULL, NULL, 142939),
(142940, '2.10.70.10-FF-000277', NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing 1', 61, NULL, NULL, 142940),
(142941, '2.60.40.1180-FF-000094', NULL, 'Alpha-mannosidase D', 130, NULL, NULL, 142941),
(142942, '2.60.120.260-FF-000150', NULL, 'Anaphase-promoting complex subunit 10', 161, NULL, NULL, 142942),
(142943, '3.60.21.10-FF-000171', NULL, 'Hypothetical_protein_-_conserved', 411, NULL, NULL, 142943),
(142944, '3.30.930.10-FF-000300', NULL, 'Phenylalanine--tRNA ligase beta subunit', 225, NULL, NULL, 142944),
(142945, '3.80.10.10-FF-003977', NULL, 'Protein DIA2', 160, NULL, NULL, 142945),
(142946, '1.10.220.160-FF-000014', NULL, 'GM24661', 99, NULL, NULL, 142946),
(142947, '1.10.238.10-FF-000737', NULL, 'Uncharacterized protein', 172, NULL, NULL, 142947),
(142948, '1.25.40.990-FF-000044', NULL, 'Uncharacterized protein', 297, NULL, NULL, 142948),
(142949, '1.10.10.60-FF-000335', NULL, 'DNA-directed RNA polymerase subunit N, putative', 65, NULL, NULL, 142949),
(142950, '2.60.40.1170-FF-000091', NULL, NULL, 165, NULL, NULL, 142950),
(142951, '1.10.150.530-FF-000013', NULL, 'Ribosomal RNA large subunit methyltransferase Cfr', 54, NULL, NULL, 142951),
(142952, '3.30.40.10-FF-002312', NULL, 'Uncharacterized protein', 109, NULL, NULL, 142952),
(142953, '2.30.30.30-FF-000061', NULL, 'Transcription elongation factor SPT5', 51, NULL, NULL, 142953),
(142954, '3.30.60.30-FF-000083', NULL, 'Uncharacterized protein', 48, NULL, NULL, 142954),
(142955, '3.30.1370.10-FF-000138', NULL, 'KH type 1 domain protein', 73, NULL, NULL, 142955),
(142956, '1.10.220.150-FF-000011', NULL, 'Arf-GAP with dual PH domain-containing protein 1', 127, NULL, NULL, 142956),
(142957, '3.30.420.230-FF-000001', NULL, 'Pre-mRNA-processing-splicing factor 8', 161, NULL, NULL, 142957),
(142958, '1.20.1250.20-FF-002008', NULL, 'Uncharacterized protein', 373, NULL, NULL, 142958),
(142959, '3.90.930.12-FF-000036', NULL, NULL, 79, NULL, NULL, 142959),
(142960, '3.40.50.1000-FF-000527', NULL, NULL, 21, NULL, NULL, 142960),
(142961, '3.90.226.10-FF-000263', NULL, 'Uncharacterized protein', 384, NULL, NULL, 142961),
(142962, '3.30.60.20-FF-000107', NULL, 'Non-specific serine/threonine protein kinase', 79, NULL, NULL, 142962),
(142963, '1.10.472.10-FF-000298', NULL, 'Uncharacterized protein', 343, NULL, NULL, 142963),
(142964, '3.40.50.2300-FF-000670', NULL, 'Uncharacterized protein', 306, NULL, NULL, 142964),
(142965, '3.40.50.80-FF-000231', NULL, 'Uncharacterized protein', 115, NULL, NULL, 142965),
(142966, '3.30.160.60-FF-001453', NULL, 'POZ-, AT hook-, and zinc finger-containing protein 1 isoform X4', 38, NULL, NULL, 142966),
(142967, '2.60.120.700-FF-000001', NULL, 'Putative aspergillopepsin', 208, NULL, NULL, 142967),
(142968, '1.20.1080.10-FF-000053', NULL, 'Aquaporin, glycerol transport activity', 215, NULL, NULL, 142968),
(142969, '3.30.70.240-FF-000048', NULL, 'Elongation factor 2-like Protein', 131, NULL, NULL, 142969),
(142970, '1.25.40.90-FF-000032', NULL, 'CTD kinase subunit gamma', 138, NULL, NULL, 142970),
(142971, '2.70.20.10-FF-000018', NULL, 'DNA topoisomerase 1', 63, NULL, NULL, 142971),
(142972, '3.50.50.60-FF-000051', NULL, 'Glutathione reductase', 120, NULL, NULL, 142972),
(142973, '3.40.50.10810-FF-000125', NULL, 'Helicase, Snf2 family protein', 238, NULL, NULL, 142973),
(142974, '2.130.10.10-FF-004062', NULL, 'Eukaryotic translation initiation factor 2A', 208, NULL, NULL, 142974),
(142975, '3.30.40.10-FF-000221', NULL, 'E3 ubiquitin-protein ligase FANCL isoform X2', 84, NULL, NULL, 142975);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(142976, '3.30.70.330-FF-000249', NULL, 'Pre-mRNA-splicing factor CWC2, variant', 91, NULL, NULL, 142976),
(142977, '2.130.10.120-FF-000008', NULL, 'Prolyl oligopeptidase family protein', 367, NULL, NULL, 142977),
(142978, '1.10.1200.10-FF-000094', NULL, 'Nonribosomal peptide synthase, putative', 71, NULL, NULL, 142978),
(142979, '3.40.630.30-FF-000388', NULL, 'Predicted protein', 61, NULL, NULL, 142979),
(142980, '3.30.160.60-FF-002555', NULL, 'B-cell CLL/lymphoma 6 member B protein', 29, NULL, NULL, 142980),
(142981, '3.30.870.10-FF-000149', NULL, 'Phospholipase D superfamily protein', 192, NULL, NULL, 142981),
(142982, '1.20.120.790-FF-000015', NULL, '90 kDa heat shock protein, putative', 137, NULL, NULL, 142982),
(142983, '3.80.10.10-FF-002988', NULL, 'Uncharacterized protein', 149, NULL, NULL, 142983),
(142984, '3.90.550.10-FF-000443', NULL, 'Glycosyl transferase family 2', 236, NULL, NULL, 142984),
(142985, '3.30.70.330-FF-001177', NULL, 'Putative RNA binding protein', 109, NULL, NULL, 142985),
(142986, '3.90.1310.10-FF-000008', NULL, 'Penicillin-binding protein, transpeptidase domain protein', 141, NULL, NULL, 142986),
(142987, '1.25.40.10-FF-002705', NULL, 'TPR-repeat protein, putative', 116, NULL, NULL, 142987),
(142988, '1.10.357.10-FF-000047', NULL, 'Transcriptional regulator, TetR family', 192, NULL, NULL, 142988),
(142989, '3.30.60.20-FF-000080', NULL, 'Serine/threonine-protein kinase dkf-1', 66, NULL, NULL, 142989),
(142990, '2.60.120.400-FF-000001', NULL, 'Fucose-binding lectin PA-IIL', 114, NULL, NULL, 142990),
(142991, '2.60.40.10-FF-000868', NULL, 'Plexin D1', 138, NULL, NULL, 142991),
(142992, '3.90.290.10-FF-000018', NULL, 'latent-transforming growth factor beta-binding protein 3 isoform X2', 67, NULL, NULL, 142992),
(142993, '3.10.20.90-FF-000357', NULL, 'STE20/SPS1-related proline-alanine-rich protein kinase', 51, NULL, NULL, 142993),
(142994, '1.10.287.110-FF-000229', NULL, 'Uncharacterized protein', 116, NULL, NULL, 142994),
(142995, '3.30.70.330-FF-000721', NULL, 'Nuclear polyadenylated RNA-binding protein 4', 116, NULL, NULL, 142995),
(142996, '3.90.79.10-FF-000167', NULL, 'Uncharacterized protein', 74, NULL, NULL, 142996),
(142997, '1.10.510.10-FF-004406', NULL, NULL, 82, NULL, NULL, 142997),
(142998, '3.40.630.10-FF-000382', NULL, 'Uncharacterized protein', 79, NULL, NULL, 142998),
(142999, '2.10.220.10-FF-000171', NULL, 'Uncharacterized protein', 85, NULL, NULL, 142999),
(143000, '2.130.10.10-FF-000346', NULL, 'Sema-1a, isoform D', 465, NULL, NULL, 143000),
(143001, '1.20.5.170-FF-000100', NULL, 'ATP-dependent helicase BRM', 75, NULL, NULL, 143001),
(143002, '3.90.15.10-FF-000014', NULL, 'DNA topoisomerase I', 149, NULL, NULL, 143002),
(143003, '2.60.40.60-FF-000243', NULL, 'Cadherin 16, KSP-cadherin', 101, NULL, NULL, 143003),
(143004, '2.130.10.10-FF-005989', NULL, 'JNK-interacting protein 3-like Protein', 227, NULL, NULL, 143004),
(143005, '3.50.50.60-FF-000730', NULL, 'FAD dependent oxidoreductase', 79, NULL, NULL, 143005),
(143006, '2.10.10.20-FF-000012', NULL, 'Chitinase ChiA', 43, NULL, NULL, 143006),
(143007, '2.60.120.310-FF-000007', NULL, 'MOXD1 homolog 2', 170, NULL, NULL, 143007),
(143008, '3.30.710.10-FF-000082', NULL, 'zinc finger and BTB domain-containing protein 24 isoform X1', 140, NULL, NULL, 143008),
(143009, '2.160.10.10-FF-000042', NULL, 'Translation initiation factor eIF2B subunit', 146, NULL, NULL, 143009),
(143010, '1.10.472.10-FF-000618', NULL, 'Uncharacterized protein', 204, NULL, NULL, 143010),
(143011, '2.60.34.10-FF-000129', NULL, 'Uncharacterized protein', 111, NULL, NULL, 143011),
(143012, '4.10.365.10-FF-000004', NULL, 'Cyclin-dependent kinase inhibitor 4', 60, NULL, NULL, 143012),
(143013, '3.40.50.12390-FF-000003', NULL, '5''-3'' exoribonuclease', 136, NULL, NULL, 143013),
(143014, '1.10.287.630-FF-000003', NULL, 'Cyclic nucleotide-gated ion channel 1', 65, NULL, NULL, 143014),
(143015, '3.10.380.20-FF-000001', NULL, '16S rRNA endonuclease CdiA', 76, NULL, NULL, 143015),
(143016, '2.60.40.10-FF-000189', NULL, 'Neogenin isoform 3', 96, NULL, NULL, 143016);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(143017, '2.60.40.10-FF-002459', NULL, 'Phosphatase family protein (AFU_orthologue AFUA_5G07860)', 142, NULL, NULL, 143017),
(143018, '3.90.70.10-FF-000086', NULL, 'Cysteine proteinase falcipain 2a', 241, NULL, NULL, 143018),
(143019, '2.130.10.10-FF-002437', NULL, 'Pre-mRNA-splicing factor RSE1', 367, NULL, NULL, 143019),
(143020, '3.60.15.10-FF-000111', NULL, 'MBL fold metallo-hydrolase', 260, NULL, NULL, 143020),
(143021, '3.40.50.300-FF-003140', NULL, 'Polynucleotide kinase 3-phosphatase putative', 166, NULL, NULL, 143021),
(143022, '3.30.40.10-FF-000160', NULL, 'Ring finger protein 141', 46, NULL, NULL, 143022),
(143023, '1.10.418.10-FF-000156', NULL, 'Fimbrin, putative', 114, NULL, NULL, 143023),
(143024, '1.20.120.530-FF-000016', NULL, 'GntR family transcriptional regulator', 133, NULL, NULL, 143024),
(143025, '1.25.40.10-FF-003015', NULL, 'Bardet-Biedl syndrome 4', 115, NULL, NULL, 143025),
(143026, '1.20.120.520-FF-000013', NULL, 'Predicted protein', 167, NULL, NULL, 143026),
(143027, '1.10.472.10-FF-000091', NULL, 'putative cyclin-B3-1 isoform X3', 130, NULL, NULL, 143027),
(143028, '3.30.497.10-FF-000141', NULL, 'Uncharacterized protein', 71, NULL, NULL, 143028),
(143029, '3.60.15.10-FF-000257', NULL, 'Uncharacterized protein', 129, NULL, NULL, 143029),
(143030, '3.30.70.3490-FF-000006', NULL, 'Oxysterol-binding protein-related protein 1C', 63, NULL, NULL, 143030),
(143031, '3.30.565.10-FF-000480', NULL, 'Uncharacterized protein', 79, NULL, NULL, 143031),
(143032, '1.10.30.10-FF-000018', NULL, 'High mobility group protein B2', 95, NULL, NULL, 143032),
(143033, '3.40.640.10-FF-000321', NULL, 'Serine hydroxymethyltransferase', 244, NULL, NULL, 143033),
(143034, '2.60.40.2030-FF-000034', NULL, 'Adhesion G-protein-coupled receptor V1', 118, NULL, NULL, 143034),
(143035, '2.10.25.10-FF-001044', NULL, 'Protein lin-12', 39, NULL, NULL, 143035),
(143036, '2.60.40.10-FF-004404', NULL, NULL, 103, NULL, NULL, 143036),
(143037, '3.30.505.10-FF-000178', NULL, NULL, 130, NULL, NULL, 143037),
(143038, '3.40.50.300-FF-002797', NULL, 'Uridine kinase', 207, NULL, NULL, 143038),
(143039, '1.10.287.70-FF-000222', NULL, 'Voltage-gated Ion Channel (VIC) Superfamily', 107, NULL, NULL, 143039),
(143040, '3.40.50.2000-FF-000670', NULL, 'Alpha-1,3/1,6-mannosyltransferase ALG2', 208, NULL, NULL, 143040),
(143041, '3.30.70.920-FF-000038', NULL, 'Uncharacterized HTH-type transcriptional regulator PH0140', 88, NULL, NULL, 143041),
(143042, '1.10.8.270-FF-000008', NULL, 'Putative TBC1 domain family member 14', 116, NULL, NULL, 143042),
(143043, '3.40.50.150-FF-001009', NULL, 'tRNA wybutosine-synthesizing protein 2', 291, NULL, NULL, 143043),
(143044, '3.40.140.10-FF-000148', NULL, 'Eukaryotic translation initiation factor 3 subunit H', 205, NULL, NULL, 143044),
(143045, '2.40.50.90-FF-000101', NULL, 'Probable staphylococcal-like nuclease CAN4', 178, NULL, NULL, 143045),
(143046, '3.30.870.10-FF-000003', NULL, 'Cardiolipin synthase A', 143, NULL, NULL, 143046),
(143047, '1.10.510.10-FF-002815', NULL, NULL, 148, NULL, NULL, 143047),
(143048, '3.40.30.10-FF-000754', NULL, 'Putative 28S ribosomal protein S25, mitochondrial', 103, NULL, NULL, 143048),
(143049, '3.40.50.12090-FF-000003', NULL, 'Precursor of the S-layer proteins', 99, NULL, NULL, 143049),
(143050, '2.130.10.10-FF-004680', NULL, 'Uncharacterized protein', 181, NULL, NULL, 143050),
(143051, '3.40.50.720-FF-000124', NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase', 177, NULL, NULL, 143051),
(143052, '3.90.1030.10-FF-000026', NULL, '50S ribosomal protein L17', 118, NULL, NULL, 143052),
(143053, '2.30.29.30-FF-000523', NULL, 'Protostome-specific GEF, isoform E', 179, NULL, NULL, 143053),
(143054, '3.40.50.300-FF-002943', NULL, 'DNA polymerase III subunit epsilon protein', 181, NULL, NULL, 143054),
(143055, '2.30.22.10-FF-000007', NULL, 'Protein GrpE', 59, NULL, NULL, 143055),
(143056, '1.10.8.80-FF-000008', NULL, 'Putative moxR protein', 103, NULL, NULL, 143056),
(143057, '3.40.50.80-FF-000085', NULL, 'Iron-uptake factor', 145, NULL, NULL, 143057);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(143058, '2.60.40.10-FF-000368', NULL, 'kalirin isoform X1', 102, NULL, NULL, 143058),
(143059, '3.40.50.12120-FF-000001', NULL, 'Proteasome biogenesis-associated', 173, NULL, NULL, 143059),
(143060, '3.30.160.60-FF-004179', NULL, NULL, 24, NULL, NULL, 143060),
(143061, '3.40.50.790-FF-000038', NULL, 'Uncharacterized protein', 96, NULL, NULL, 143061),
(143062, '3.30.160.60-FF-002055', NULL, 'INSM transcriptional repressor 1', 46, NULL, NULL, 143062),
(143063, '3.40.50.2000-FF-000344', NULL, 'Glycosyl transferase group 1', 177, NULL, NULL, 143063),
(143064, '3.40.190.290-FF-000053', NULL, 'LysR family transcriptional regulator', 204, NULL, NULL, 143064),
(143065, '2.60.40.10-FF-002813', NULL, 'Neural cell adhesion molecule L1', 94, NULL, NULL, 143065),
(143066, '2.10.25.10-FF-001723', NULL, 'Uncharacterized protein', 59, NULL, NULL, 143066),
(143067, '3.30.450.20-FF-000047', NULL, 'SIM bHLH transcription factor 2', 153, NULL, NULL, 143067),
(143068, '2.20.25.10-FF-000094', NULL, 'Uncharacterized protein', 57, NULL, NULL, 143068),
(143069, '3.30.1490.100-FF-000020', NULL, 'DNA polymerase IV', 110, NULL, NULL, 143069),
(143070, '3.30.40.10-FF-001295', NULL, 'Uncharacterized protein', 116, NULL, NULL, 143070),
(143071, '2.120.10.30-FF-000173', NULL, 'NHL (Ring finger b-box coiled coil) domain containing', 289, NULL, NULL, 143071),
(143072, '3.40.50.10810-FF-000097', NULL, 'Uncharacterized protein, isoform A', 212, NULL, NULL, 143072),
(143073, '3.40.50.620-FF-000392', NULL, 'Sensor histidine kinase KdpD', 137, NULL, NULL, 143073),
(143074, '3.40.50.620-FF-000212', NULL, 'Leucine--tRNA ligase', 215, NULL, NULL, 143074),
(143075, '3.40.640.10-FF-000528', NULL, 'Uncharacterized protein', 96, NULL, NULL, 143075),
(143076, '3.30.710.10-FF-000109', NULL, 'zinc finger and BTB domain-containing protein 1', 146, NULL, NULL, 143076),
(143077, '3.40.50.720-FF-001877', NULL, 'Damino acid oxidase, putative', 65, NULL, NULL, 143077),
(143078, '3.10.350.10-FF-000024', NULL, 'Hypothetical exported protein', 56, NULL, NULL, 143078),
(143079, '1.10.300.10-FF-000006', NULL, 'Adenylosuccinate synthetase', 99, NULL, NULL, 143079),
(143080, '3.30.56.30-FF-000005', NULL, 'signal recognition particle 19 kDa protein-like isoform X2', 63, NULL, NULL, 143080),
(143081, '3.30.565.10-FF-000541', NULL, 'Glr1767 protein', 137, NULL, NULL, 143081),
(143082, '3.90.550.10-FF-000089', NULL, 'Cellulose synthase-like protein D4', 146, NULL, NULL, 143082),
(143083, '1.10.510.10-FF-000337', NULL, 'Serine/threonine-protein kinase SBK1', 295, NULL, NULL, 143083),
(143084, '3.30.930.10-FF-000385', NULL, 'Biotin--protein ligase', 214, NULL, NULL, 143084),
(143085, '1.25.40.10-FF-004622', NULL, 'General transcription factor 3C polypeptide 3-like Protein', 157, NULL, NULL, 143085),
(143086, '1.20.1070.10-FF-001862', NULL, 'Uncharacterized protein', 348, NULL, NULL, 143086),
(143087, '3.90.1600.10-FF-000020', NULL, 'DNA polymerase', 177, NULL, NULL, 143087),
(143088, '1.20.870.10-FF-000013', NULL, 'rap guanine nucleotide exchange factor 5', 152, NULL, NULL, 143088),
(143089, '3.30.160.60-FF-000638', NULL, 'Zinc finger protein 184', 30, NULL, NULL, 143089),
(143090, '3.40.830.10-FF-000004', NULL, 'YJR008W-like protein', 337, NULL, NULL, 143090),
(143091, '1.25.40.10-FF-000109', NULL, 'Cell division coordinator CpoB', 122, NULL, NULL, 143091),
(143092, '1.20.144.10-FF-000096', NULL, 'phospholipid phosphatase 1 isoform X1', 283, NULL, NULL, 143092),
(143093, '3.10.150.10-FF-000009', NULL, 'Beta sliding clamp', 179, NULL, NULL, 143093),
(143094, '2.40.30.10-FF-000526', NULL, 'Eukaryotic translation initiation factor 5B, isoform E', 110, NULL, NULL, 143094),
(143095, '1.20.1310.10-FF-000178', NULL, NULL, 121, NULL, NULL, 143095),
(143096, '3.30.40.10-FF-001941', NULL, 'Uncharacterized protein', 108, NULL, NULL, 143096),
(143097, '2.10.25.10-FF-001544', NULL, 'Chymotrypsin inhibitor Ani s 6', 57, NULL, NULL, 143097),
(143098, '1.25.10.10-FF-000607', NULL, 'Protein CLASP-2', 235, NULL, NULL, 143098),
(143099, '1.20.140.80-FF-000012', NULL, 'Uncharacterized protein', 80, NULL, NULL, 143099);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(143100, '3.30.70.330-FF-001677', NULL, NULL, 146, NULL, NULL, 143100),
(143101, '2.130.10.10-FF-004915', NULL, 'Predicted protein', 318, NULL, NULL, 143101),
(143102, '2.40.30.10-FF-000234', NULL, 'U5 small nuclear ribonucleoprotein component, putative', 137, NULL, NULL, 143102),
(143103, '2.60.40.60-FF-000743', NULL, 'Predicted protein', 109, NULL, NULL, 143103),
(143104, '3.90.1110.10-FF-000027', NULL, NULL, 82, NULL, NULL, 143104),
(143105, '3.30.530.20-FF-000048', NULL, 'Sreptomyces cyclase/dehydrase family protein', 168, NULL, NULL, 143105),
(143106, '3.40.50.620-FF-000066', NULL, 'valine--tRNA ligase, mitochondrial', 206, NULL, NULL, 143106),
(143107, '3.10.110.10-FF-000243', NULL, 'UBiquitin Conjugating enzyme', 133, NULL, NULL, 143107),
(143108, '3.30.1370.50-FF-000010', NULL, 'Shuttle craft, isoform D', 99, NULL, NULL, 143108),
(143109, '1.20.58.390-FF-000109', NULL, 'AcetylCholine Receptor', 111, NULL, NULL, 143109),
(143110, '3.40.50.300-FF-004388', NULL, 'DNA packaging ATPase', 205, NULL, NULL, 143110),
(143111, '1.10.238.270-FF-000003', NULL, 'Odorant-binding protein 47b', 173, NULL, NULL, 143111),
(143112, '2.30.30.40-FF-000390', NULL, 'ITSN (Intersectin) family', 68, NULL, NULL, 143112),
(143113, '3.80.10.10-FF-003770', NULL, 'Uncharacterized protein', 109, NULL, NULL, 143113),
(143114, '3.90.660.10-FF-000125', NULL, NULL, 103, NULL, NULL, 143114),
(143115, '3.40.50.720-FF-001585', NULL, 'Short-chain dehydrogenase/reductase family protein, putative', 229, NULL, NULL, 143115),
(143116, '2.70.170.10-FF-000068', NULL, 'LOW QUALITY PROTEIN: 5-hydroxytryptamine receptor 3C-like', 198, NULL, NULL, 143116),
(143117, '1.25.40.10-FF-004089', NULL, 'Pentatricopeptide repeat-containing protein At2g20710, mitochondrial', 153, NULL, NULL, 143117),
(143118, '3.90.70.10-FF-000440', NULL, 'Calpain-like cysteine peptidase, putative', 159, NULL, NULL, 143118),
(143119, '3.10.20.70-FF-000025', NULL, 'Glutamine synthetase catalytic region', 105, NULL, NULL, 143119),
(143120, '1.10.10.60-FF-000009', NULL, 'transcription factor MYB1R1', 52, NULL, NULL, 143120),
(143121, '1.20.120.230-FF-000050', NULL, 'Breast cancer anti-estrogen resistance protein 1', 131, NULL, NULL, 143121),
(143122, '3.30.160.60-FF-000817', NULL, 'zinc finger protein 22', 28, NULL, NULL, 143122),
(143123, '1.10.8.60-FF-000587', NULL, 'Uncharacterized protein', 11, NULL, NULL, 143123),
(143124, '3.30.540.10-FF-000017', NULL, 'Inositol-1-monophosphatase', 141, NULL, NULL, 143124),
(143125, '2.60.40.1670-FF-000027', NULL, NULL, 158, NULL, NULL, 143125),
(143126, '3.30.1520.10-FF-000055', NULL, 'Phospholipase', 115, NULL, NULL, 143126),
(143127, '3.40.630.10-FF-000056', NULL, 'Zinc carboxypeptidase', 311, NULL, NULL, 143127),
(143128, '3.40.50.300-FF-007968', NULL, 'Predicted protein', 163, NULL, NULL, 143128),
(143129, '3.30.200.20-FF-000181', NULL, 'Mitogen-activated protein kinase', 91, NULL, NULL, 143129),
(143130, '1.25.40.180-FF-000161', NULL, 'Predicted protein', 249, NULL, NULL, 143130),
(143131, '3.80.10.10-FF-000133', NULL, 'prolargin', 168, NULL, NULL, 143131),
(143132, '3.90.70.10-FF-000732', NULL, 'Uncharacterized protein', 169, NULL, NULL, 143132),
(143133, '6.10.300.40-FF-000002', NULL, 'Proteasome 26S subunit, non-ATPase 4a', 41, NULL, NULL, 143133),
(143134, '3.20.20.70-FF-000856', NULL, NULL, 52, NULL, NULL, 143134),
(143135, '3.30.160.60-FF-004825', NULL, NULL, 31, NULL, NULL, 143135),
(143136, '1.25.40.60-FF-000017', NULL, NULL, 122, NULL, NULL, 143136),
(143137, '3.90.1100.10-FF-000055', NULL, 'DNA-directed RNA polymerase subunit beta', 214, NULL, NULL, 143137),
(143138, '2.60.40.640-FF-000064', NULL, 'Uncharacterized protein', 147, NULL, NULL, 143138),
(143139, '2.60.40.1660-FF-000024', NULL, 'Uncharacterized protein', 297, NULL, NULL, 143139),
(143140, '1.10.1060.10-FF-000003', NULL, 'Succinate dehydrogenase iron-sulfur subunit', 130, NULL, NULL, 143140),
(143141, '1.25.40.10-FF-004443', NULL, 'Pentatricopeptide repeat-containing protein At5g08305', 117, NULL, NULL, 143141),
(143142, '1.25.40.10-FF-001981', NULL, 'EMB2261 putative', 119, NULL, NULL, 143142);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(143143, '4.10.80.40-FF-000006', NULL, 'Succinate dehydrogenase [ubiquinone] flavoprotein subunit, mitochondrial', 64, NULL, NULL, 143143),
(143144, '2.120.10.10-FF-000015', NULL, 'Hemagglutinin-neuraminidase', 433, NULL, NULL, 143144),
(143145, '1.20.58.80-FF-000029', NULL, 'GM15315', 77, NULL, NULL, 143145),
(143146, '3.40.50.2000-FF-000018', NULL, 'UDP-N-acetylglucosamine--N-acetylmuramyl-(pentapeptide) pyrophosphoryl-undecaprenol N-acetylglucosamine transferase', 175, NULL, NULL, 143146),
(143147, '2.160.20.10-FF-000194', NULL, 'Preneck appendage protein', 468, NULL, NULL, 143147),
(143148, '2.130.10.10-FF-004354', NULL, 'Autophagy-related protein 16-1-like Protein', 93, NULL, NULL, 143148),
(143149, '3.40.30.10-FF-000428', NULL, 'Protein disulfide-isomerase A4', 130, NULL, NULL, 143149),
(143150, '1.20.272.40-FF-000014', NULL, 'ATP-dependent RNA helicase SUPV3L1, mitochondrial', 79, NULL, NULL, 143150),
(143151, '3.30.70.330-FF-002520', NULL, NULL, 60, NULL, NULL, 143151),
(143152, '2.40.100.10-FF-000155', NULL, 'Peptidyl-prolyl cis-trans isomerase', 137, NULL, NULL, 143152),
(143153, '2.40.320.10-FF-000020', NULL, 'Mediator of RNA polymerase II transcription subunit 18', 200, NULL, NULL, 143153),
(143154, '2.130.10.10-FF-002145', NULL, 'Predicted protein', 235, NULL, NULL, 143154),
(143155, '3.20.20.80-FF-000213', NULL, 'Arabinogalactan endo-beta-1,4-galactanase', 311, NULL, NULL, 143155),
(143156, '3.50.50.60-FF-000343', NULL, 'FAD/NAD(P)-binding oxidoreductase family protein', 97, NULL, NULL, 143156),
(143157, '3.30.780.10-FF-000030', NULL, 'Mitochondrial large ribosomal subunit L49, putative', 145, NULL, NULL, 143157),
(143158, '3.80.10.10-FF-001853', NULL, 'YALI0B18759p', 226, NULL, NULL, 143158),
(143159, '1.10.510.10-FF-001152', NULL, 'Uncharacterized protein', 197, NULL, NULL, 143159),
(143160, '3.40.30.10-FF-001064', NULL, 'Glutathione peroxidase', 164, NULL, NULL, 143160),
(143161, '1.20.120.1630-FF-000004', NULL, '7-dehydrocholesterol reductase', 215, NULL, NULL, 143161),
(143162, '3.30.420.40-FF-000670', NULL, 'Uncharacterized protein', 62, NULL, NULL, 143162),
(143163, '1.25.40.10-FF-003807', NULL, 'Uncharacterized protein', 139, NULL, NULL, 143163),
(143164, '1.25.40.20-FF-000882', NULL, 'Predicted protein', 187, NULL, NULL, 143164),
(143165, '1.20.1070.10-FF-000142', NULL, 'G protein-coupled receptor 55', 295, NULL, NULL, 143165),
(143166, '1.10.510.10-FF-000663', NULL, 'Mixed lineage kinase domain-like pseudokinase', 183, NULL, NULL, 143166),
(143167, '2.40.10.350-FF-000014', NULL, 'Cell shape-determining protein MreC', 88, NULL, NULL, 143167),
(143168, '3.40.50.300-FF-004096', NULL, 'Multidrug resistance protein (SpaB)', 256, NULL, NULL, 143168),
(143169, '1.20.1090.10-FF-000025', NULL, '3-dehydroquinate synthase', 180, NULL, NULL, 143169),
(143170, '3.40.50.300-FF-002325', NULL, 'Hydrogenase maturation GTPase HydF', 178, NULL, NULL, 143170),
(143171, '3.20.20.70-FF-000210', NULL, '2-nitropropane dioxygenase', 312, NULL, NULL, 143171),
(143172, '1.10.760.10-FF-000063', NULL, 'PQQ-dependent dehydrogenase, methanol/ethanol family', 111, NULL, NULL, 143172),
(143173, '2.130.10.10-FF-001010', NULL, 'Chromatin assembly factor 1 subunit B', 280, NULL, NULL, 143173),
(143174, '3.30.160.60-FF-002381', NULL, 'Putative spalt protein', 33, NULL, NULL, 143174),
(143175, '1.10.150.240-FF-000050', NULL, 'Phosphoglycolate phosphatase', 68, NULL, NULL, 143175),
(143176, '3.40.50.300-FF-000998', NULL, 'Thymidine kinase 2, mitochondrial', 208, NULL, NULL, 143176),
(143177, '3.30.565.10-FF-000187', NULL, 'Mlh1, isoform A', 214, NULL, NULL, 143177),
(143178, '3.10.20.690-FF-000003', NULL, 'DNA gyrase subunit B', 91, NULL, NULL, 143178),
(143179, '3.30.70.330-FF-002166', NULL, NULL, 89, NULL, NULL, 143179),
(143180, '3.90.550.10-FF-000617', NULL, 'Uncharacterized protein', 212, NULL, NULL, 143180),
(143181, '1.10.150.20-FF-000211', NULL, 'Rad10p', 93, NULL, NULL, 143181),
(143182, '1.20.58.480-FF-000018', NULL, 'Uncharacterized protein', 203, NULL, NULL, 143182),
(143183, '1.20.58.70-FF-000026', NULL, 'Syntaxin-132', 128, NULL, NULL, 143183);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(143184, '2.60.200.20-FF-000178', NULL, 'Uncharacterized protein', 126, NULL, NULL, 143184),
(143185, '3.30.200.20-FF-001928', NULL, 'Uncharacterized protein', 107, NULL, NULL, 143185),
(143186, '1.20.58.60-FF-000023', NULL, 'Kalirin RhoGEF kinase b', 281, NULL, NULL, 143186),
(143187, '3.40.1390.10-FF-000008', NULL, 'UDP-3-O-acylglucosamine N-acyltransferase', 99, NULL, NULL, 143187),
(143188, '1.20.58.390-FF-000289', NULL, 'Cholinergic receptor, nicotinic, alpha polypeptide 9', 25, NULL, NULL, 143188),
(143189, '2.30.30.40-FF-000417', NULL, 'Neutrophil cytosolic factor 4', 72, NULL, NULL, 143189),
(143190, '3.20.110.10-FF-000044', NULL, 'Uncharacterized protein', 48, NULL, NULL, 143190),
(143191, '2.60.120.260-FF-000442', NULL, 'Uncharacterized protein', 111, NULL, NULL, 143191),
(143192, '1.10.1040.10-FF-000120', NULL, 'Uncharacterized protein', 96, NULL, NULL, 143192),
(143193, '3.40.50.150-FF-000846', NULL, 'tRNA (Guanine-N-7) methyltransferase', 161, NULL, NULL, 143193),
(143194, '1.25.10.10-FF-002378', NULL, 'Uncharacterized protein', 274, NULL, NULL, 143194),
(143195, '1.20.120.1760-FF-000077', NULL, NULL, 175, NULL, NULL, 143195),
(143196, '1.20.1000.10-FF-000014', NULL, NULL, 131, NULL, NULL, 143196),
(143197, '3.30.70.1230-FF-000138', NULL, 'Guanylate cyclase', 110, NULL, NULL, 143197),
(143198, '3.50.50.60-FF-000904', NULL, 'Oxidoreductase PigB', 94, NULL, NULL, 143198),
(143199, '3.30.200.20-FF-000029', NULL, 'Serine/threonine-protein kinase TAO2, putative', 96, NULL, NULL, 143199),
(143200, '1.20.120.1750-FF-000074', NULL, 'E3 ubiquitin-protein ligase parkin', 73, NULL, NULL, 143200),
(143201, '3.40.850.10-FF-000213', NULL, 'Probable Chs8-Chitin Synthase 8', 36, NULL, NULL, 143201),
(143202, '3.30.70.20-FF-000052', NULL, 'NADH-ubiquinone oxidoreductase-G iron-sulfur binding region', 79, NULL, NULL, 143202),
(143203, '3.40.1260.10-FF-000004', NULL, 'Sulfurtransferase TusC', 119, NULL, NULL, 143203),
(143204, '2.10.25.10-FF-000442', NULL, 'Integrin beta', 57, NULL, NULL, 143204),
(143205, '3.40.50.300-FF-001223', NULL, 'X-ray repair cross complementing 3', 264, NULL, NULL, 143205),
(143206, '3.40.50.1820-FF-001728', NULL, 'Uncharacterized protein', 96, NULL, NULL, 143206),
(143207, '3.40.50.300-FF-006866', NULL, 'Uncharacterized protein', 253, NULL, NULL, 143207),
(143208, '3.30.420.40-FF-000877', NULL, 'Uncharacterized protein', 45, NULL, NULL, 143208),
(143209, '3.40.1260.20-FF-000007', NULL, 'Ribonuclease G', 88, NULL, NULL, 143209),
(143210, '2.40.30.170-FF-000032', NULL, 'GntR family transcriptional regulator', 83, NULL, NULL, 143210),
(143211, '2.30.30.40-FF-000597', NULL, 'Uncharacterized protein', 59, NULL, NULL, 143211),
(143212, '3.30.70.3400-FF-000019', NULL, 'Protein translocase subunit SecD', 77, NULL, NULL, 143212),
(143213, '1.25.40.10-FF-000727', NULL, 'Chromosome 1, whole genome shotgun sequence', 224, NULL, NULL, 143213),
(143214, '2.40.390.10-FF-000001', NULL, 'Hydantoinase, putative', 124, NULL, NULL, 143214),
(143215, '3.40.640.10-FF-000293', NULL, 'Pyridoxal dependent decarboxylase domain containing 1', 116, NULL, NULL, 143215),
(143216, '3.40.50.300-FF-000734', NULL, 'ATPase family, AAA domain containing 2', 174, NULL, NULL, 143216),
(143217, '1.10.472.10-FF-000326', NULL, 'Uncharacterized protein', 116, NULL, NULL, 143217),
(143218, '3.40.720.10-FF-000294', NULL, 'Uncharacterized protein', 256, NULL, NULL, 143218),
(143219, '4.10.60.10-FF-000047', NULL, 'Glycine-rich RNA-binding protein RZ1C', 29, NULL, NULL, 143219),
(143220, '2.60.40.10-FF-004258', NULL, NULL, 120, NULL, NULL, 143220),
(143221, '1.10.490.10-FF-000020', NULL, 'Globin-coupled sensor protein', 159, NULL, NULL, 143221),
(143222, '2.30.180.10-FF-000185', NULL, NULL, 133, NULL, NULL, 143222),
(143223, '2.170.150.20-FF-000001', NULL, 'Peptide methionine sulfoxide reductase MsrB', 134, NULL, NULL, 143223),
(143224, '3.30.160.60-FF-000790', NULL, 'flt3-interacting zinc finger protein 1', 27, NULL, NULL, 143224),
(143225, '3.40.630.10-FF-000410', NULL, 'Uncharacterized protein', 118, NULL, NULL, 143225);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(143226, '3.30.70.330-FF-000575', NULL, 'Heterogeneous nuclear ribonucleoprotein H3', 53, NULL, NULL, 143226),
(143227, '1.10.506.10-FF-000086', NULL, 'Predicted protein', 114, NULL, NULL, 143227),
(143228, '1.10.132.60-FF-000035', NULL, 'DNA polymerase epsilon, catalytic subunit A', 121, NULL, NULL, 143228),
(143229, '3.50.50.60-FF-001478', NULL, 'Amine oxidase', 59, NULL, NULL, 143229),
(143230, '1.10.555.10-FF-000098', NULL, 'Related to BEM2-GTPase-activating protein', 212, NULL, NULL, 143230),
(143231, '3.40.50.720-FF-001259', NULL, 'UDP-galactose 4-epimerase', 246, NULL, NULL, 143231),
(143232, '3.30.2300.10-FF-000011', NULL, 'THUMP domain-containing 1', 86, NULL, NULL, 143232),
(143233, '3.30.830.10-FF-000175', NULL, 'Axl1p', 234, NULL, NULL, 143233),
(143234, '3.30.465.10-FF-000123', NULL, 'Hemolysin protein', 80, NULL, NULL, 143234),
(143235, '3.30.470.30-FF-000052', NULL, 'ATP-dependent DNA ligase', 125, NULL, NULL, 143235),
(143236, '2.160.20.10-FF-000014', NULL, 'Pectinesterase', 313, NULL, NULL, 143236),
(143237, '1.10.10.60-FF-000189', NULL, 'Homeobox protein engrailed-like', 91, NULL, NULL, 143237),
(143238, '3.10.129.10-FF-000027', NULL, 'Uncharacterized acyl-CoA thioester hydrolase', 170, NULL, NULL, 143238),
(143239, '3.15.10.30-FF-000002', NULL, 'GL26314', 223, NULL, NULL, 143239),
(143240, '2.10.25.10-FF-001605', NULL, 'Uncharacterized protein', 45, NULL, NULL, 143240),
(143241, '3.30.50.10-FF-000071', NULL, 'GATA transcription factor 28', 61, NULL, NULL, 143241),
(143242, '3.30.70.330-FF-001738', NULL, NULL, 107, NULL, NULL, 143242),
(143243, '3.30.70.330-FF-002312', NULL, NULL, 116, NULL, NULL, 143243),
(143244, '3.30.160.60-FF-002942', NULL, 'Protein teashirt', 71, NULL, NULL, 143244),
(143245, '1.20.58.60-FF-000523', NULL, 'Uncharacterized protein', 278, NULL, NULL, 143245),
(143246, '1.25.10.10-FF-000580', NULL, 'Protein peg1', 247, NULL, NULL, 143246),
(143247, '3.40.50.300-FF-008165', NULL, 'Predicted protein', 86, NULL, NULL, 143247),
(143248, '1.10.10.10-FF-000461', NULL, 'Eukaryotic translation initiation factor 3 subunit C', 79, NULL, NULL, 143248),
(143249, '2.60.120.200-FF-000093', NULL, 'Laminin subunit alpha 3', 159, NULL, NULL, 143249),
(143250, '2.130.10.10-FF-000285', NULL, 'WD repeat and FYVE domain-containing protein 1', 143, NULL, NULL, 143250),
(143251, '3.40.30.10-FF-000928', NULL, 'Thioredoxin', 121, NULL, NULL, 143251),
(143252, '3.90.100.10-FF-000005', NULL, 'Ornithine decarboxylase', 130, NULL, NULL, 143252),
(143253, '1.25.10.10-FF-000079', NULL, 'transportin-3 isoform X1', 921, NULL, NULL, 143253),
(143254, '1.25.40.10-FF-001216', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 113, NULL, NULL, 143254),
(143255, '1.25.40.20-FF-001219', NULL, 'SI:dZ87I4.2 (Novel glutaminase)', 74, NULL, NULL, 143255),
(143256, '1.25.10.10-FF-002816', NULL, 'Uncharacterized protein', 195, NULL, NULL, 143256),
(143257, '3.40.50.300-FF-002825', NULL, 'ATP-dependent DNA helicase', 221, NULL, NULL, 143257),
(143258, '3.40.50.12440-FF-000007', NULL, 'Nitrate reductase alpha subunit (NarG)', 741, NULL, NULL, 143258),
(143259, '3.30.1330.10-FF-000046', NULL, 'Uncharacterized protein', 95, NULL, NULL, 143259),
(143260, '2.30.30.1020-FF-000036', NULL, NULL, 88, NULL, NULL, 143260),
(143261, '3.40.30.10-FF-000872', NULL, 'Glutaredoxin-3', 128, NULL, NULL, 143261),
(143262, '1.10.340.70-FF-000010', NULL, 'YALI0E13376p', 84, NULL, NULL, 143262),
(143263, '1.20.1280.50-FF-000198', NULL, 'F-box/WD repeat-containing protein A-like protein', 91, NULL, NULL, 143263),
(143264, '2.40.70.10-FF-000298', NULL, NULL, 111, NULL, NULL, 143264),
(143265, '3.30.60.20-FF-000046', NULL, 'Rho GTPase-activating protein 29', 56, NULL, NULL, 143265),
(143266, '1.10.510.10-FF-001360', NULL, 'Heptose kinase', 103, NULL, NULL, 143266),
(143267, '2.130.10.10-FF-004028', NULL, 'Nucleolar protein, putative', 221, NULL, NULL, 143267),
(143268, '1.25.70.10-FF-000055', NULL, 'Transcription termination factor 5, mitochondrial', 139, NULL, NULL, 143268),
(143269, '3.90.1800.10-FF-000001', NULL, 'DNA-directed RNA polymerase subunit beta', 54, NULL, NULL, 143269);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(143270, '3.30.1330.20-FF-000049', NULL, 'Beta-tubulin 2', 87, NULL, NULL, 143270),
(143271, '3.10.180.10-FF-000016', NULL, 'Methylmalonyl-CoA epimerase', 134, NULL, NULL, 143271),
(143272, '1.10.8.960-FF-000002', NULL, 'Glutamate-cysteine ligase Gcs1', 53, NULL, NULL, 143272),
(143273, '3.10.100.10-FF-000006', NULL, 'Layilin b', 155, NULL, NULL, 143273),
(143274, '1.10.10.60-FF-000953', NULL, NULL, 120, NULL, NULL, 143274),
(143275, '1.25.40.10-FF-003779', NULL, 'Uncharacterized protein', 155, NULL, NULL, 143275),
(143276, '2.60.40.10-FF-002931', NULL, 'GH04611p', 101, NULL, NULL, 143276),
(143277, '3.40.50.1580-FF-000066', NULL, 'Uncharacterized protein', 169, NULL, NULL, 143277),
(143278, '1.25.40.10-FF-004830', NULL, 'Crooked neck protein-related protein', 146, NULL, NULL, 143278),
(143279, '1.10.443.10-FF-000023', NULL, 'Uncharacterized protein', 170, NULL, NULL, 143279),
(143280, '3.30.300.30-FF-000040', NULL, 'GG11281', 135, NULL, NULL, 143280),
(143281, '4.10.1000.10-FF-000031', NULL, 'Cleavage and polyadenylation specific factor 4', 48, NULL, NULL, 143281),
(143282, '1.10.10.10-FF-002018', NULL, 'Putative MarR-family regulatory protein', 167, NULL, NULL, 143282),
(143283, '2.70.40.10-FF-000020', NULL, 'Uncharacterized protein', 82, NULL, NULL, 143283),
(143284, '2.60.120.260-FF-000650', NULL, 'Uncharacterized protein', 95, NULL, NULL, 143284),
(143285, '1.10.3730.20-FF-000064', NULL, 'solute carrier family 35 member G1', 101, NULL, NULL, 143285),
(143286, '3.30.750.210-FF-000002', NULL, 'Uncharacterized protein', 106, NULL, NULL, 143286),
(143287, '3.90.550.10-FF-000409', NULL, 'SPbeta prophage-derived glycosyltransferase SunS', 159, NULL, NULL, 143287),
(143288, '1.20.1070.10-FF-001777', NULL, 'Uncharacterized protein', 330, NULL, NULL, 143288),
(143289, '3.40.50.300-FF-004534', NULL, 'DEAD-box ATP-dependent RNA helicase 5', 279, NULL, NULL, 143289),
(143290, '3.40.50.11070-FF-000001', NULL, 'Protein STE5', 196, NULL, NULL, 143290),
(143291, '2.70.170.10-FF-000186', NULL, 'Predicted protein', 217, NULL, NULL, 143291),
(143292, '1.10.150.220-FF-000010', NULL, NULL, 86, NULL, NULL, 143292),
(143293, '1.25.40.10-FF-000227', NULL, 'Pentatricopeptide repeat-containing protein At3g13880', 100, NULL, NULL, 143293),
(143294, '3.40.850.10-FF-000421', NULL, 'Uncharacterized protein', 195, NULL, NULL, 143294),
(143295, '3.40.50.300-FF-007030', NULL, 'Uncharacterized protein', 204, NULL, NULL, 143295),
(143296, '1.10.238.10-FF-000092', NULL, 'Phosphoinositide phospholipase C', 72, NULL, NULL, 143296),
(143297, '3.40.50.1820-FF-001762', NULL, 'Uncharacterized protein', 229, NULL, NULL, 143297),
(143298, '1.10.472.10-FF-000652', NULL, 'Uncharacterized protein', 299, NULL, NULL, 143298),
(143299, '1.20.144.10-FF-000124', NULL, 'Phosphatidate phosphatase, putative', 187, NULL, NULL, 143299),
(143300, '3.40.50.720-FF-001759', NULL, 'Uncharacterized protein', 58, NULL, NULL, 143300),
(143301, '3.30.160.60-FF-005489', NULL, NULL, 23, NULL, NULL, 143301),
(143302, '3.30.200.20-FF-002390', NULL, 'Uncharacterized protein', 100, NULL, NULL, 143302),
(143303, '4.10.60.10-FF-000255', NULL, 'Uncharacterized protein', 42, NULL, NULL, 143303),
(143304, '1.10.150.240-FF-000016', NULL, 'Phosphoenolpyruvate and 6-phosphogluconate phosphatase', 68, NULL, NULL, 143304),
(143305, '2.40.110.10-FF-000066', NULL, 'Uncharacterized protein', 116, NULL, NULL, 143305),
(143306, '3.10.100.10-FF-000332', NULL, NULL, 92, NULL, NULL, 143306),
(143307, '1.20.140.40-FF-000079', NULL, NULL, 107, NULL, NULL, 143307),
(143308, '3.30.70.20-FF-000018', NULL, 'Cytochrome c nitrite reductase, Fe-S protein', 122, NULL, NULL, 143308),
(143309, '3.30.40.10-FF-001615', NULL, 'Uncharacterized protein', 96, NULL, NULL, 143309),
(143310, '3.30.750.24-FF-000007', NULL, 'Prestin', 143, NULL, NULL, 143310),
(143311, '1.20.1160.11-FF-000004', NULL, 'Paired amphipathic helix protein Sin3a', 89, NULL, NULL, 143311),
(143312, '1.10.10.60-FF-000482', NULL, 'Homeobox protein TOS8', 83, NULL, NULL, 143312),
(143313, '3.40.50.2300-FF-000052', NULL, 'DNA-binding response regulator YycF', 84, NULL, NULL, 143313);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(143314, '1.20.120.730-FF-000019', NULL, 'SEC24 homolog B, COPII coat complex component', 43, NULL, NULL, 143314),
(143315, '2.30.30.40-FF-000389', NULL, 'RAS p21 protein activator (GTPase activating protein) 1a', 36, NULL, NULL, 143315),
(143316, '3.40.50.12430-FF-000004', NULL, 'Birt-Hogg-Dube', 111, NULL, NULL, 143316),
(143317, '1.20.5.190-FF-000140', NULL, NULL, 44, NULL, NULL, 143317),
(143318, '1.20.1250.20-FF-000209', NULL, 'Transporter, MFS superfamily protein', 435, NULL, NULL, 143318),
(143319, '3.30.497.10-FF-000107', NULL, 'Serpin-2, putative', 233, NULL, NULL, 143319),
(143320, '3.40.50.1820-FF-001083', NULL, 'Uncharacterized protein', 199, NULL, NULL, 143320),
(143321, '3.20.20.20-FF-000010', NULL, 'Dihydropteroate synthase', 269, NULL, NULL, 143321),
(143322, '3.30.70.610-FF-000002', NULL, 'Quinone-dependent D-lactate dehydrogenase', 80, NULL, NULL, 143322),
(143323, '1.20.5.1700-FF-000006', NULL, 'Bone marrow stromal antigen 2', 112, NULL, NULL, 143323),
(143324, '2.40.50.100-FF-000066', NULL, 'Glycine cleavage system H protein', 124, NULL, NULL, 143324),
(143325, '3.30.420.40-FF-000523', NULL, 'Actin-related protein 2', 140, NULL, NULL, 143325),
(143326, '1.10.274.10-FF-000006', NULL, 'Phosphotransferase system, fructose-specific EI/HPr/EIIA components', 122, NULL, NULL, 143326),
(143327, '3.30.200.20-FF-000355', NULL, 'Nik related kinase', 125, NULL, NULL, 143327),
(143328, '1.20.1070.10-FF-001098', NULL, 'G-protein coupled receptor GRL101-like protein', 357, NULL, NULL, 143328),
(143329, '2.60.40.10-FF-004584', NULL, NULL, 120, NULL, NULL, 143329),
(143330, '3.40.50.300-FF-000526', NULL, 'DExH-box ATP-dependent RNA helicase DExH3', 226, NULL, NULL, 143330),
(143331, '3.40.718.10-FF-000001', NULL, 'Isocitrate dehydrogenase [NAD] subunit, mitochondrial', 349, NULL, NULL, 143331),
(143332, '3.40.1360.10-FF-000068', NULL, 'Topoisomerase-like enzyme2', 131, NULL, NULL, 143332),
(143333, '2.120.10.80-FF-000401', NULL, 'Uncharacterized protein', 128, NULL, NULL, 143333),
(143334, '3.90.550.10-FF-000561', NULL, 'Uncharacterized protein', 146, NULL, NULL, 143334),
(143335, '3.30.70.3290-FF-000003', NULL, 'Fatty acid synthase', 102, NULL, NULL, 143335),
(143336, '3.80.10.10-FF-001561', NULL, 'Tubulin folding cofactor E', 118, NULL, NULL, 143336),
(143337, '2.40.100.10-FF-000037', NULL, 'Peptidyl-prolyl cis-trans isomerase', 235, NULL, NULL, 143337),
(143338, '3.30.1370.10-FF-000223', NULL, 'KRR1 small subunit processome component', 104, NULL, NULL, 143338),
(143339, '3.10.110.10-FF-000361', NULL, 'Protein IMPACT homolog', 161, NULL, NULL, 143339),
(143340, '2.60.40.10-FF-001150', NULL, 'Intercellular adhesion molecule 5', 95, NULL, NULL, 143340),
(143341, '1.10.510.10-FF-000955', NULL, 'YDL025C-like protein', 326, NULL, NULL, 143341),
(143342, '3.40.190.10-FF-000538', NULL, 'Glutamate receptor', 45, NULL, NULL, 143342),
(143343, '3.30.70.330-FF-001795', NULL, NULL, 117, NULL, NULL, 143343),
(143344, '3.10.110.10-FF-000304', NULL, 'Uncharacterized protein', 89, NULL, NULL, 143344),
(143345, '3.90.1720.30-FF-000006', NULL, 'Glycosyl hydrolase-like protein', 164, NULL, NULL, 143345),
(143346, '3.30.530.20-FF-000166', NULL, 'Polyketide cyclase/dehydrase and lipid transport superfamily protein', 126, NULL, NULL, 143346),
(143347, '3.40.50.11660-FF-000054', NULL, NULL, 76, NULL, NULL, 143347),
(143348, '2.170.130.10-FF-000053', NULL, NULL, 92, NULL, NULL, 143348),
(143349, '3.40.50.720-FF-002102', NULL, 'Predicted protein', 127, NULL, NULL, 143349),
(143350, '3.30.160.60-FF-006478', NULL, NULL, 22, NULL, NULL, 143350),
(143351, '1.20.1070.10-FF-001362', NULL, 'Neuropeptide FF receptor, putative', 263, NULL, NULL, 143351),
(143352, '3.40.140.10-FF-000182', NULL, 'YALI0D26884p', 175, NULL, NULL, 143352),
(143353, '3.40.50.80-FF-000113', NULL, 'NADPH-dependent FMN/FAD containing oxidoreductase', 177, NULL, NULL, 143353),
(143354, '2.60.210.10-FF-000029', NULL, 'Metalloendopeptidase', 159, NULL, NULL, 143354),
(143355, '1.20.58.60-FF-000315', NULL, 'Spectrin beta chain, non-erythrocytic', 180, NULL, NULL, 143355);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(143356, '3.40.50.620-FF-000420', NULL, 'Leucine--tRNA ligase', 205, NULL, NULL, 143356),
(143357, '3.40.50.300-FF-000408', NULL, 'Shikimate kinase 2', 170, NULL, NULL, 143357),
(143358, '3.30.70.270-FF-000124', NULL, 'DNA repair protein REV1', 125, NULL, NULL, 143358),
(143359, '1.10.10.60-FF-000217', NULL, 'Transcriptional regulator, AraC family', 58, NULL, NULL, 143359),
(143360, '1.10.150.20-FF-000126', NULL, 'DNA repair protein RAD51 homolog', 94, NULL, NULL, 143360),
(143361, '1.10.560.10-FF-000048', NULL, '60 kDa chaperonin 1', 245, NULL, NULL, 143361),
(143362, '1.10.3720.10-FF-000178', NULL, '2-aminoethylphosphonate transport system permease protein phnU', 263, NULL, NULL, 143362),
(143363, '2.40.50.140-FF-000229', NULL, 'Woronin body major protein', 75, NULL, NULL, 143363),
(143364, '3.40.50.300-FF-002617', NULL, 'Elongator complex protein 6', 273, NULL, NULL, 143364),
(143365, '3.30.1590.10-FF-000003', NULL, 'Maltooligosyl trehalose synthase', 119, NULL, NULL, 143365),
(143366, '3.30.160.60-FF-002616', NULL, 'Deformed wings', 28, NULL, NULL, 143366),
(143367, '3.40.50.10810-FF-000243', NULL, 'ERCC excision repair 6, chromatin-remodeling factor', 175, NULL, NULL, 143367),
(143368, '2.40.110.10-FF-000009', NULL, 'Acyl-CoA dehydrogenase', 112, NULL, NULL, 143368),
(143369, '3.40.50.170-FF-000032', NULL, 'Methionyl-tRNA formyltransferase', 205, NULL, NULL, 143369),
(143370, '3.80.10.10-FF-001706', NULL, 'Chaoptin', 164, NULL, NULL, 143370),
(143371, '3.40.50.150-FF-001010', NULL, NULL, 199, NULL, NULL, 143371),
(143372, '2.130.10.10-FF-000493', NULL, 'Nucleoporin SEH1', 315, NULL, NULL, 143372),
(143373, '1.10.533.10-FF-000261', NULL, 'Uncharacterized protein', 59, NULL, NULL, 143373),
(143374, '3.40.50.2000-FF-000552', NULL, 'Asparagine Linked Glycosylation (ALG) homolog, Nematode', 198, NULL, NULL, 143374),
(143375, '2.130.10.10-FF-000964', NULL, 'WD repeat domain phosphoinositide-interacting protein', 282, NULL, NULL, 143375),
(143376, '3.40.250.10-FF-000010', NULL, 'Phage shock protein PspE', 85, NULL, NULL, 143376),
(143377, '3.30.590.10-FF-000021', NULL, 'Uncharacterized protein', 325, NULL, NULL, 143377),
(143378, '2.30.30.40-FF-000182', NULL, 'Tyrosine-protein kinase Fyn', 64, NULL, NULL, 143378),
(143379, '2.60.40.2240-FF-000007', NULL, 'Uncharacterized protein', 132, NULL, NULL, 143379),
(143380, '2.60.40.2220-FF-000001', NULL, 'Alpha-mannosidase 2C1', 84, NULL, NULL, 143380),
(143381, '3.30.70.120-FF-000012', NULL, 'DUF190 domain-containing protein', 117, NULL, NULL, 143381),
(143382, '2.30.29.30-FF-000315', NULL, 'pleckstrin homology domain-containing family M member 1 isoform X1', 107, NULL, NULL, 143382),
(143383, '2.10.25.10-FF-001662', NULL, 'Uncharacterized protein', 46, NULL, NULL, 143383),
(143384, '1.10.238.10-FF-001108', NULL, 'Uncharacterized protein', 60, NULL, NULL, 143384),
(143385, '2.60.40.150-FF-000366', NULL, 'Putative U5 small nuclear ribonucleoprotein 200 kDa helicase', 109, NULL, NULL, 143385),
(143386, '1.10.510.10-FF-002254', NULL, NULL, 214, NULL, NULL, 143386),
(143387, '3.60.15.10-FF-000050', NULL, 'Metallo-beta-lactamase type 2', 232, NULL, NULL, 143387),
(143388, '3.30.70.870-FF-000001', NULL, 'Elongation factor G', 77, NULL, NULL, 143388),
(143389, '1.10.530.40-FF-000004', NULL, 'Lysozyme', 150, NULL, NULL, 143389),
(143390, '3.80.10.10-FF-001768', NULL, 'NACHT, LRR and PYD domains-containing protein 16', 164, NULL, NULL, 143390),
(143391, '2.170.270.10-FF-000237', NULL, 'Uncharacterized protein', 56, NULL, NULL, 143391),
(143392, '3.20.20.100-FF-000032', NULL, 'Hyperkinetic, isoform I', 336, NULL, NULL, 143392),
(143393, '2.130.10.10-FF-000228', NULL, 'COMPASS-like H3K4 histone methylase component WDR5A', 312, NULL, NULL, 143393),
(143394, '2.20.70.10-FF-000170', NULL, 'Rho GTPase-activating protein 27', 62, NULL, NULL, 143394),
(143395, '1.10.10.60-FF-000274', NULL, 'Homeobox-leucine zipper protein HOX24', 65, NULL, NULL, 143395),
(143396, '1.10.150.20-FF-000183', NULL, 'Transcription termination/antitermination protein NusA', 67, NULL, NULL, 143396); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(143397, '2.60.120.650-FF-000143', NULL, 'Uncharacterized protein', 86, NULL, NULL, 143397),
(143398, '3.30.70.330-FF-000603', NULL, 'Polyadenylate-binding protein', 67, NULL, NULL, 143398),
(143399, '3.30.70.330-FF-001385', NULL, 'Multiple RNA-binding domain-containing protein 1', 174, NULL, NULL, 143399),
(143400, '2.130.10.10-FF-004707', NULL, 'Uncharacterized protein', 171, NULL, NULL, 143400),
(143401, '3.40.390.10-FF-000048', NULL, 'Zinc metalloproteinase', 247, NULL, NULL, 143401),
(143402, '3.80.10.10-FF-001089', NULL, 'Protein NLRC5', 106, NULL, NULL, 143402),
(143403, '1.20.140.140-FF-000004', NULL, 'Predicted protein', 197, NULL, NULL, 143403),
(143404, '1.10.730.10-FF-000056', NULL, 'Leucine--tRNA ligase', 26, NULL, NULL, 143404),
(143405, '3.60.21.10-FF-000378', NULL, 'Uncharacterized protein', 91, NULL, NULL, 143405),
(143406, '2.60.40.60-FF-000389', NULL, 'Protocadherin Fat', 107, NULL, NULL, 143406),
(143407, '1.25.40.10-FF-002644', NULL, 'Signal recognition particle subunit srp72', 164, NULL, NULL, 143407),
(143408, '3.30.450.20-FF-000401', NULL, 'Aryl hydrocarbon receptor nuclear translocator type 1b', 72, NULL, NULL, 143408),
(143409, '2.40.30.10-FF-000498', NULL, 'Uncharacterized protein', 103, NULL, NULL, 143409),
(143410, '3.20.20.120-FF-000038', NULL, 'Hydrophobic dipeptide epimerase', 247, NULL, NULL, 143410),
(143411, '2.20.70.10-FF-000018', NULL, 'DGCR8 microprocessor complex subunit', 56, NULL, NULL, 143411),
(143412, '1.20.140.150-FF-000007', NULL, 'transmembrane protein 178B', 227, NULL, NULL, 143412),
(143413, '1.20.1250.20-FF-001671', NULL, 'Solute carrier organic anion transporter family member', 222, NULL, NULL, 143413),
(143414, '1.20.1070.10-FF-001569', NULL, 'Uncharacterized protein', 165, NULL, NULL, 143414),
(143415, '3.30.40.10-FF-001823', NULL, 'SWI/SNF family DNA-dependent ATPase, putative', 81, NULL, NULL, 143415),
(143416, '3.40.190.10-FF-000067', NULL, 'Cystine ABC transporter substrate-binding protein', 96, NULL, NULL, 143416),
(143417, '1.10.1300.10-FF-000073', NULL, 'Uncharacterized protein', 70, NULL, NULL, 143417),
(143418, '3.10.450.10-FF-000088', NULL, 'Uncharacterized protein', 60, NULL, NULL, 143418),
(143419, '1.20.120.230-FF-000016', NULL, 'Catenin alpha like 1', 137, NULL, NULL, 143419),
(143420, '3.40.50.1000-FF-000561', NULL, NULL, 120, NULL, NULL, 143420),
(143421, '3.80.10.10-FF-003359', NULL, 'Uncharacterized protein', 113, NULL, NULL, 143421),
(143422, '2.60.120.920-FF-000067', NULL, 'ATP-dependent RNA helicase DDX1, putative', 178, NULL, NULL, 143422),
(143423, '1.10.10.2660-FF-000027', NULL, 'Uncharacterized protein', 119, NULL, NULL, 143423),
(143424, '1.10.472.170-FF-000012', NULL, 'Transcription initiation factor IIB-2', 223, NULL, NULL, 143424),
(143425, '3.30.230.10-FF-000180', NULL, 'Uncharacterized protein', 181, NULL, NULL, 143425),
(143426, '1.25.40.10-FF-002526', NULL, 'Putative peptidyl-prolyl cis-trans isomerase', 144, NULL, NULL, 143426),
(143427, '1.20.140.100-FF-000043', NULL, 'Dynein heavy chain 4', 153, NULL, NULL, 143427),
(143428, '1.25.40.20-FF-000438', NULL, 'Ankyrin repeat domain 31', 218, NULL, NULL, 143428),
(143429, '1.20.210.10-FF-000042', NULL, 'Putative COX1/OXI3 intron 2 protein', 144, NULL, NULL, 143429),
(143430, '2.60.40.150-FF-000484', NULL, 'Copine, putative', 123, NULL, NULL, 143430),
(143431, '3.40.50.2300-FF-001564', NULL, NULL, 172, NULL, NULL, 143431),
(143432, '4.10.400.10-FF-000188', NULL, 'Low-density lipoprotein receptor-related protein 2', 40, NULL, NULL, 143432),
(143433, '3.10.310.10-FF-000016', NULL, 'Diaminopimelate epimerase', 134, NULL, NULL, 143433),
(143434, '3.20.190.20-FF-000001', NULL, 'Serine protease DegP', 139, NULL, NULL, 143434),
(143435, '3.80.10.10-FF-002016', NULL, 'Leucine-rich repeat-containing 15', 122, NULL, NULL, 143435),
(143436, '3.10.310.20-FF-000019', NULL, NULL, 154, NULL, NULL, 143436),
(143437, '3.40.190.10-FF-000746', NULL, 'Uncharacterized protein', 121, NULL, NULL, 143437),
(143438, '1.25.40.10-FF-000435', NULL, 'Pentatricopeptide repeat-containing protein MRL1, chloroplastic isoform X1', 198, NULL, NULL, 143438);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(143439, '1.20.58.900-FF-000009', NULL, 'Small G protein signaling modulator 3', 211, NULL, NULL, 143439),
(143440, '3.90.1150.10-FF-000092', NULL, 'Capsular polysaccharide biosynthesis protein', 127, NULL, NULL, 143440),
(143441, '1.20.5.190-FF-000139', NULL, NULL, 47, NULL, NULL, 143441),
(143442, '2.130.10.10-FF-001009', NULL, 'Small nucleolar ribonucleoprotein complex subunit, putative', 160, NULL, NULL, 143442),
(143443, '2.60.120.200-FF-000031', NULL, 'NtA agrin', 186, NULL, NULL, 143443),
(143444, '3.90.226.10-FF-000229', NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', 368, NULL, NULL, 143444),
(143445, '1.25.40.10-FF-004235', NULL, 'Uncharacterized protein', 249, NULL, NULL, 143445),
(143446, '2.60.40.1170-FF-000057', NULL, 'Clathrin adaptor complexes medium subunit family protein', 139, NULL, NULL, 143446),
(143447, '1.20.1070.10-FF-001570', NULL, 'Predicted protein', 165, NULL, NULL, 143447),
(143448, '3.10.180.10-FF-000045', NULL, 'ATP-dependent 6-phosphofructokinase', 149, NULL, NULL, 143448),
(143449, '1.10.10.60-FF-000835', NULL, NULL, 107, NULL, NULL, 143449),
(143450, '3.40.50.970-FF-000148', NULL, 'Pyruvate dehydrogenase E1 component subunit beta', 99, NULL, NULL, 143450),
(143451, '3.90.70.30-FF-000007', NULL, 'Uncharacterized protein', 60, NULL, NULL, 143451),
(143452, '3.30.160.60-FF-001245', NULL, 'zinc finger protein 48', 26, NULL, NULL, 143452),
(143453, '3.40.50.300-FF-008575', NULL, 'Uncharacterized protein', 28, NULL, NULL, 143453),
(143454, '1.20.120.220-FF-000013', NULL, 'ATP synthase F0 subunit 6', 197, NULL, NULL, 143454),
(143455, '1.10.730.10-FF-000117', NULL, 'Mitochondrial probable methionyl-tRNA synthetase', 189, NULL, NULL, 143455),
(143456, '3.40.50.11530-FF-000009', NULL, 'Uncharacterized protein', 163, NULL, NULL, 143456),
(143457, '3.90.1410.10-FF-000157', NULL, 'N-lysine methyltransferase', 59, NULL, NULL, 143457),
(143458, '1.10.560.10-FF-000082', NULL, 'McKusick-Kaufman syndrome', 177, NULL, NULL, 143458),
(143459, '1.10.1370.10-FF-000021', NULL, 'Thimet oligopeptidase 1', 65, NULL, NULL, 143459),
(143460, '3.20.20.80-FF-000421', NULL, 'Glucosylceramidase', 138, NULL, NULL, 143460),
(143461, '3.40.50.1000-FF-000319', NULL, 'Haloacid dehalogenase family hydrolase domain containing protein', 153, NULL, NULL, 143461),
(143462, '3.40.50.2020-FF-000058', NULL, 'Orotidine-5-phosphate decarboxylase/orotate phosphoribosyltransferase', 198, NULL, NULL, 143462),
(143463, '1.10.437.10-FF-000020', NULL, 'BCL2 like 10', 155, NULL, NULL, 143463),
(143464, '1.10.1370.30-FF-000027', NULL, 'Angiotensin-converting enzyme', 414, NULL, NULL, 143464),
(143465, '3.30.160.60-FF-003044', NULL, NULL, 28, NULL, NULL, 143465),
(143466, '3.30.420.40-FF-000170', NULL, 'D-xylulose kinase', 209, NULL, NULL, 143466),
(143467, '3.40.850.10-FF-000185', NULL, 'Kinesin, putative', 312, NULL, NULL, 143467),
(143468, '1.10.472.10-FF-000444', NULL, 'Uncharacterized protein', 120, NULL, NULL, 143468),
(143469, '1.10.418.10-FF-000038', NULL, 'LIM and calponin homology domains-containing protein 1', 130, NULL, NULL, 143469),
(143470, '2.60.120.200-FF-000800', NULL, 'Putative L-type lectin-domain containing receptor kinase V.2', 222, NULL, NULL, 143470),
(143471, '3.40.50.1240-FF-000048', NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', 367, NULL, NULL, 143471),
(143472, '3.90.640.10-FF-000124', NULL, 'Heat shock protein 70 putative', 101, NULL, NULL, 143472),
(143473, '3.40.30.10-FF-001125', NULL, 'Uncharacterized protein', 80, NULL, NULL, 143473),
(143474, '3.80.10.10-FF-001914', NULL, 'Polycystin-1', 88, NULL, NULL, 143474),
(143475, '1.25.10.10-FF-001304', NULL, 'Uncharacterized protein', 135, NULL, NULL, 143475),
(143476, '1.25.10.10-FF-003013', NULL, 'Uncharacterized protein', 333, NULL, NULL, 143476),
(143477, '1.10.4200.10-FF-000004', NULL, 'Probable 2-(5''''-triphosphoribosyl)-3''-dephosphocoenzyme-A synthase', 95, NULL, NULL, 143477),
(143478, '1.10.520.10-FF-000074', NULL, 'L-ascorbate peroxidase 2 cytosolic', 12, NULL, NULL, 143478);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(143479, '3.40.50.2000-FF-000052', NULL, 'Alpha-1,3-glucan synthase Ags2', 198, NULL, NULL, 143479),
(143480, '2.120.10.80-FF-000137', NULL, 'Kelch protein, putative', 357, NULL, NULL, 143480),
(143481, '2.30.30.40-FF-000625', NULL, 'Src like adaptor 2', 29, NULL, NULL, 143481),
(143482, '3.40.190.10-FF-000128', NULL, 'Taurine ABC transporter substrate-binding protein', 105, NULL, NULL, 143482),
(143483, '3.30.70.330-FF-000103', NULL, 'Polyadenylate-binding protein RBP47B', 81, NULL, NULL, 143483),
(143484, '3.40.190.10-FF-000185', NULL, 'Iron ABC transporter substrate-binding protein', 164, NULL, NULL, 143484),
(143485, '3.40.50.300-FF-003022', NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily A containing DEAD/H box 1 homolog', 219, NULL, NULL, 143485),
(143486, '1.10.1870.10-FF-000014', NULL, 'Lysine-ketoglutarate reductase/saccharopine dehydrogenase bifunctional enzyme', 49, NULL, NULL, 143486),
(143487, '3.10.450.80-FF-000002', NULL, 'Uncharacterized protein', 61, NULL, NULL, 143487),
(143488, '3.10.110.10-FF-000097', NULL, 'Gir2p', 128, NULL, NULL, 143488),
(143489, '1.20.1080.10-FF-000114', NULL, 'Uncharacterized protein', 113, NULL, NULL, 143489),
(143490, '1.10.940.10-FF-000009', NULL, 'Antitermination NusB domain-containing protein', 140, NULL, NULL, 143490),
(143491, '3.20.20.70-FF-000795', NULL, NULL, 40, NULL, NULL, 143491),
(143492, '1.10.150.20-FF-000065', NULL, 'DNA-directed RNA polymerase', 231, NULL, NULL, 143492),
(143493, '1.20.1250.20-FF-001637', NULL, 'Monocarboxylate transporter, putative', 83, NULL, NULL, 143493),
(143494, '2.70.70.10-FF-000055', NULL, 'Peptidase M23', 143, NULL, NULL, 143494),
(143495, '3.40.190.10-FF-000331', NULL, 'Extracellular solute-binding protein family 5', 94, NULL, NULL, 143495),
(143496, '1.10.1450.10-FF-000022', NULL, 'Tetraspanin 32', 80, NULL, NULL, 143496),
(143497, '2.10.25.10-FF-001252', NULL, 'Uncharacterized protein', 42, NULL, NULL, 143497),
(143498, '1.10.8.270-FF-000155', NULL, 'Uncharacterized protein', 107, NULL, NULL, 143498),
(143499, '3.30.565.10-FF-000507', NULL, 'Sensor histidine kinase, GAF domain-containing', 132, NULL, NULL, 143499),
(143500, '2.60.260.20-FF-000187', NULL, 'Predicted protein', 33, NULL, NULL, 143500),
(143501, '2.130.10.10-FF-005051', NULL, 'General transcription factor IIIC subunit 2', 280, NULL, NULL, 143501),
(143502, '3.60.10.10-FF-000061', NULL, 'Type I inositol polyphosphate 5-phosphatase 2', 113, NULL, NULL, 143502),
(143503, '1.20.80.10-FF-000032', NULL, 'FERM domain-containing protein', 106, NULL, NULL, 143503),
(143504, '1.10.730.10-FF-000174', NULL, 'Uncharacterized protein', 56, NULL, NULL, 143504),
(143505, '3.30.70.330-FF-000367', NULL, 'glycine-rich RNA-binding protein RZ1C', 115, NULL, NULL, 143505),
(143506, '2.130.10.10-FF-000846', NULL, 'Katanin p80 WD40 repeat-containing subunit B1 homolog', 299, NULL, NULL, 143506),
(143507, '3.40.50.720-FF-001905', NULL, 'Predicted protein', 127, NULL, NULL, 143507),
(143508, '2.40.70.10-FF-000034', NULL, 'Aspartyl protease family protein', 185, NULL, NULL, 143508),
(143509, '3.40.50.150-FF-000493', NULL, 'tRNA (uracil(54)-C(5))-methyltransferase homolog', 238, NULL, NULL, 143509),
(143510, '1.20.1070.10-FF-001159', NULL, 'Apelin receptor', 343, NULL, NULL, 143510),
(143511, '3.30.1360.120-FF-000076', NULL, 'tRNA modification GTPase TrmE', 137, NULL, NULL, 143511),
(143512, '3.40.50.1240-FF-000195', NULL, NULL, 205, NULL, NULL, 143512),
(143513, '1.20.1050.10-FF-000225', NULL, 'Glutathione S-transferase 1, isoform A', 103, NULL, NULL, 143513),
(143514, '2.130.10.10-FF-002645', NULL, 'VID27-like protein', 267, NULL, NULL, 143514),
(143515, '2.30.30.40-FF-000535', NULL, 'YALI0F19778p', 58, NULL, NULL, 143515),
(143516, '3.40.50.2300-FF-000170', NULL, 'Response regulator receiver domain protein', 84, NULL, NULL, 143516),
(143517, '3.40.50.1440-FF-000075', NULL, 'Protein misato', 316, NULL, NULL, 143517),
(143518, '2.160.20.10-FF-000222', NULL, 'Uncharacterized protein', 285, NULL, NULL, 143518),
(143519, '1.20.120.20-FF-000010', NULL, 'Apolipoprotein E', 164, NULL, NULL, 143519);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(143520, '2.40.70.10-FF-000091', NULL, 'GG22202', 216, NULL, NULL, 143520),
(143521, '3.30.200.20-FF-000501', NULL, 'Obscurin isoform B', 82, NULL, NULL, 143521),
(143522, '3.30.160.60-FF-000582', NULL, 'zinc finger protein 821 isoform X1', 84, NULL, NULL, 143522),
(143523, '1.10.418.10-FF-000190', NULL, 'Uncharacterized protein', 109, NULL, NULL, 143523),
(143524, '3.40.50.300-FF-003640', NULL, 'GTPase, IMAP family member 1', 233, NULL, NULL, 143524),
(143525, '1.10.400.10-FF-000008', NULL, 'Guanine nucleotide-binding protein alpha-1 subunit', 126, NULL, NULL, 143525),
(143526, '1.20.1530.20-FF-000107', NULL, 'Uncharacterized protein', 405, NULL, NULL, 143526),
(143527, '2.60.40.10-FF-001032', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', 88, NULL, NULL, 143527),
(143528, '2.60.40.10-FF-000576', NULL, 'Myosin-binding protein C, cardiac-type', 95, NULL, NULL, 143528),
(143529, '1.10.10.10-FF-000427', NULL, 'RNA polymerase sigma factor', 90, NULL, NULL, 143529),
(143530, '2.60.120.260-FF-000032', NULL, 'Sperm associated antigen 4 (Predicted)', 191, NULL, NULL, 143530),
(143531, '3.30.160.60-FF-004472', NULL, NULL, 28, NULL, NULL, 143531),
(143532, '3.30.710.10-FF-000317', NULL, 'Uncharacterized protein', 152, NULL, NULL, 143532),
(143533, '4.10.60.30-FF-000002', NULL, NULL, 70, NULL, NULL, 143533),
(143534, '1.10.10.60-FF-000689', NULL, 'AraC family transcriptional regulator', 111, NULL, NULL, 143534),
(143535, '3.40.30.10-FF-001182', NULL, 'Uncharacterized protein', 81, NULL, NULL, 143535),
(143536, '1.25.10.10-FF-002496', NULL, 'Uncharacterized protein', 203, NULL, NULL, 143536),
(143537, '3.40.50.970-FF-000058', NULL, 'Putative pyruvate decarboxylase', 83, NULL, NULL, 143537),
(143538, '3.40.50.720-FF-001198', NULL, 'GM21301', 263, NULL, NULL, 143538),
(143539, '3.80.10.10-FF-001971', NULL, 'Leucine rich repeat containing 30', 110, NULL, NULL, 143539),
(143540, '1.10.1040.10-FF-000002', NULL, '6-phosphogluconate dehydrogenase, decarboxylating', 255, NULL, NULL, 143540),
(143541, '3.40.50.150-FF-001217', NULL, NULL, 141, NULL, NULL, 143541),
(143542, '3.20.20.80-FF-000331', NULL, 'Alpha-L-fucosidase', 362, NULL, NULL, 143542),
(143543, '2.10.50.10-FF-000068', NULL, 'Cysteine repeat modular protein 4 PbCRM4', 59, NULL, NULL, 143543),
(143544, '1.10.510.10-FF-003889', NULL, NULL, 88, NULL, NULL, 143544),
(143545, '3.20.20.30-FF-000013', NULL, 'Putative F420-dependent oxidoreductase', 149, NULL, NULL, 143545),
(143546, '3.80.10.10-FF-003505', NULL, 'Uncharacterized protein', 186, NULL, NULL, 143546),
(143547, '2.160.20.10-FF-000132', NULL, 'Uncharacterized protein', 103, NULL, NULL, 143547),
(143548, '1.25.10.10-FF-000080', NULL, 'lisH domain and HEAT repeat-containing protein KIAA1468 homolog', 269, NULL, NULL, 143548),
(143549, '2.10.25.10-FF-001459', NULL, 'Laminin subunit alpha-1', 62, NULL, NULL, 143549),
(143550, '1.10.238.10-FF-000445', NULL, 'Phosphatidylserine decarboxylase proenzyme 2', 132, NULL, NULL, 143550),
(143551, '3.10.450.50-FF-000105', NULL, 'Uncharacterized protein', 111, NULL, NULL, 143551),
(143552, '1.10.630.10-FF-000110', NULL, 'Uncharacterized protein', 469, NULL, NULL, 143552),
(143553, '1.20.1730.10-FF-000024', NULL, 'Blast:Sodium-coupled monocarboxylate transporter 2', 466, NULL, NULL, 143553),
(143554, '3.40.50.880-FF-000211', NULL, 'Uncharacterized protein', 195, NULL, NULL, 143554),
(143555, '1.50.40.10-FF-000489', NULL, 'Mitochondrial glycine transporter', 275, NULL, NULL, 143555),
(143556, '1.10.40.30-FF-000002', NULL, 'Fumarate hydratase class II', 57, NULL, NULL, 143556),
(143557, '3.30.70.330-FF-002048', NULL, NULL, 96, NULL, NULL, 143557),
(143558, '2.10.25.10-FF-000234', NULL, 'tomoregulin-2 isoform X1', 49, NULL, NULL, 143558),
(143559, '3.30.160.60-FF-000672', NULL, 'Zinc finger protein 430', 27, NULL, NULL, 143559),
(143560, '3.30.230.130-FF-000035', NULL, 'Cullin_family /Cullin_protein_neddylation_domain_containing_protein_-_putative', 179, NULL, NULL, 143560),
(143561, '3.40.50.620-FF-000184', NULL, 'Putative isoleucyl-tRNA synthetase', 248, NULL, NULL, 143561);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(143562, '3.30.200.20-FF-000708', NULL, 'Protein kinase superfamily protein', 101, NULL, NULL, 143562),
(143563, '1.10.20.10-FF-000046', NULL, 'transcription initiation factor TFIID subunit 6', 66, NULL, NULL, 143563),
(143564, '1.10.510.10-FF-000545', NULL, 'Guanylate cyclase', 274, NULL, NULL, 143564),
(143565, '2.120.10.30-FF-000139', NULL, 'SMP-30/Gluconolaconase/LRE domain protein', 281, NULL, NULL, 143565),
(143566, '3.30.420.40-FF-001041', NULL, 'Heat shock protein family A (Hsp70) member 9', 19, NULL, NULL, 143566),
(143567, '2.60.40.150-FF-000720', NULL, 'Serine/threonine-protein kinase sck1', 126, NULL, NULL, 143567),
(143568, '3.40.50.300-FF-005085', NULL, 'Uncharacterized protein', 67, NULL, NULL, 143568),
(143569, '1.25.40.20-FF-001253', NULL, 'Uncharacterized protein', 349, NULL, NULL, 143569),
(143570, '1.25.10.10-FF-000287', NULL, 'Exportin-4 protein', 432, NULL, NULL, 143570),
(143571, '3.40.50.1970-FF-000060', NULL, NULL, 117, NULL, NULL, 143571),
(143572, '2.130.10.10-FF-004236', NULL, 'Uncharacterized protein', 144, NULL, NULL, 143572),
(143573, '1.10.490.10-FF-000019', NULL, 'YNL234W-like protein', 128, NULL, NULL, 143573),
(143574, '1.10.8.60-FF-000469', NULL, 'Uncharacterized protein', 116, NULL, NULL, 143574),
(143575, '2.40.50.90-FF-000040', NULL, 'Tudor domain containing 6', 123, NULL, NULL, 143575),
(143576, '2.10.110.10-FF-000134', NULL, 'Lrg1p', 57, NULL, NULL, 143576),
(143577, '3.30.1680.10-FF-000033', NULL, 'Integrin beta', 57, NULL, NULL, 143577),
(143578, '4.10.60.10-FF-000108', NULL, 'Similar to zinc knuckle domain-containing protein', 26, NULL, NULL, 143578),
(143579, '3.90.550.10-FF-000297', NULL, 'Predicted protein', 376, NULL, NULL, 143579),
(143580, '1.20.58.1780-FF-000013', NULL, 'Nuclear pore complex protein (NUP155), putative', 259, NULL, NULL, 143580),
(143581, '2.60.40.10-FF-002785', NULL, 'Myotactin form A', 83, NULL, NULL, 143581),
(143582, '2.60.120.260-FF-000503', NULL, 'Uncharacterized protein', 78, NULL, NULL, 143582),
(143583, '3.30.160.60-FF-002881', NULL, 'Reduced expression 2', 26, NULL, NULL, 143583),
(143584, '2.60.40.10-FF-002167', NULL, 'Transglutaminase, isoform B', 176, NULL, NULL, 143584),
(143585, '2.60.40.10-FF-004994', NULL, NULL, 107, NULL, NULL, 143585),
(143586, '2.60.40.60-FF-000535', NULL, 'Cadherin-89D', 110, NULL, NULL, 143586),
(143587, '1.25.10.10-FF-000641', NULL, 'RING zinc finger protein-like protein', 231, NULL, NULL, 143587),
(143588, '3.40.50.2300-FF-000018', NULL, 'DNA-binding transcriptional regulator NtrC', 129, NULL, NULL, 143588),
(143589, '3.30.1370.100-FF-000038', NULL, 'DNA mismatch repair protein MutL', 95, NULL, NULL, 143589),
(143590, '3.30.565.10-FF-000395', NULL, 'Two-component system sensor protein', 142, NULL, NULL, 143590),
(143591, '3.30.750.24-FF-000125', NULL, 'Uncharacterized protein', 126, NULL, NULL, 143591),
(143592, '3.30.710.10-FF-000110', NULL, 'Regulatory protein NPR3', 185, NULL, NULL, 143592),
(143593, '1.10.150.360-FF-000001', NULL, 'Protein her-1', 68, NULL, NULL, 143593),
(143594, '3.30.200.20-FF-000147', NULL, 'probable serine/threonine protein kinase IREH1', 97, NULL, NULL, 143594),
(143595, '1.25.40.10-FF-005050', NULL, 'Predicted protein', 226, NULL, NULL, 143595),
(143596, '2.100.10.30-FF-000011', NULL, 'Cysteine-rich receptor-like protein kinase 40', 146, NULL, NULL, 143596),
(143597, '3.30.300.30-FF-000101', NULL, 'Uncharacterized protein', 120, NULL, NULL, 143597),
(143598, '2.120.10.30-FF-000381', NULL, 'Uncharacterized protein', 315, NULL, NULL, 143598),
(143599, '1.10.10.520-FF-000014', NULL, 'Ubiquitin-activating enzyme E1-like', 195, NULL, NULL, 143599),
(143600, '1.10.238.10-FF-000592', NULL, 'Defective in cullin neddylation protein', 110, NULL, NULL, 143600),
(143601, '2.40.320.10-FF-000019', NULL, 'Mediator of RNA polymerase II transcription subunit 18', 231, NULL, NULL, 143601),
(143602, '3.90.1290.10-FF-000068', NULL, 'Dspa protein', 168, NULL, NULL, 143602),
(143603, '2.130.10.30-FF-000032', NULL, 'Serine/threonine-protein kinase Nek8', 245, NULL, NULL, 143603);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(143604, '3.10.10.10-FF-000024', NULL, 'Transposon Ty3-G Gag-Pol polyprotein', 113, NULL, NULL, 143604),
(143605, '3.10.100.10-FF-000124', NULL, 'Lectin-46Ca', 153, NULL, NULL, 143605),
(143606, '3.30.160.60-FF-002263', NULL, 'Nrg1p', 32, NULL, NULL, 143606),
(143607, '3.30.470.20-FF-000110', NULL, 'Carbamoyl-phosphate synthase large chain', 195, NULL, NULL, 143607),
(143608, '2.120.10.30-FF-000229', NULL, 'Uncharacterized protein', 137, NULL, NULL, 143608),
(143609, '2.40.30.10-FF-000026', NULL, 'Eukaryotic translation initiation factor 5B', 137, NULL, NULL, 143609),
(143610, '1.20.1250.20-FF-000243', NULL, 'Probable L-galactonate transporter', 202, NULL, NULL, 143610),
(143611, '2.130.10.10-FF-003983', NULL, 'Vacuolar protein sorting-associated protein 11 homolog', 233, NULL, NULL, 143611),
(143612, '3.80.10.10-FF-001353', NULL, 'Receptor-like protein kinase 2 isoform A', 114, NULL, NULL, 143612),
(143613, '3.40.30.10-FF-001035', NULL, 'Uncharacterized protein', 41, NULL, NULL, 143613),
(143614, '2.60.40.10-FF-004376', NULL, NULL, 77, NULL, NULL, 143614),
(143615, '1.10.510.10-FF-000455', NULL, 'protein spire homolog 1 isoform X1', 194, NULL, NULL, 143615),
(143616, '2.10.110.10-FF-000224', NULL, 'transcription factor protein', 65, NULL, NULL, 143616),
(143617, '3.40.640.10-FF-000175', NULL, 'YLL058W-like protein', 239, NULL, NULL, 143617),
(143618, '3.40.50.150-FF-000964', NULL, NULL, 183, NULL, NULL, 143618),
(143619, '1.20.1070.10-FF-000024', NULL, 'Olfactory receptor', 294, NULL, NULL, 143619),
(143620, '1.25.10.10-FF-002850', NULL, 'Uncharacterized protein', 170, NULL, NULL, 143620),
(143621, '1.20.120.80-FF-000011', NULL, 'Cytochrome c oxidase subunit III', 172, NULL, NULL, 143621),
(143622, '1.10.510.10-FF-002607', NULL, NULL, 164, NULL, NULL, 143622),
(143623, '3.30.420.40-FF-000731', NULL, 'Actin-related protein 10', 118, NULL, NULL, 143623),
(143624, '1.20.5.4820-FF-000021', NULL, NULL, 113, NULL, NULL, 143624),
(143625, '4.10.280.10-FF-000189', NULL, 'Uncharacterized protein', 85, NULL, NULL, 143625),
(143626, '2.40.50.180-FF-000016', NULL, 'Chemotaxis protein CheW', 74, NULL, NULL, 143626),
(143627, '3.30.40.10-FF-002020', NULL, 'Uncharacterized protein', 39, NULL, NULL, 143627),
(143628, '3.30.43.10-FF-000048', NULL, 'D-lactate dehydrogenase', 67, NULL, NULL, 143628),
(143629, '1.20.58.160-FF-000012', NULL, NULL, 91, NULL, NULL, 143629),
(143630, '1.10.1670.10-FF-000004', NULL, 'DNA glycosylase/AP lyase ROS1', 109, NULL, NULL, 143630),
(143631, '1.20.58.1880-FF-000009', NULL, 'Nuclear receptor corepressor 1', 49, NULL, NULL, 143631),
(143632, '3.40.350.10-FF-000017', NULL, 'FACT complex subunit SPT16', 162, NULL, NULL, 143632),
(143633, '3.40.1000.50-FF-000003', NULL, 'Repressor of RNA polymerase III transcription MAF1', 158, NULL, NULL, 143633),
(143634, '1.10.238.20-FF-000010', NULL, 'Odorant-binding protein 56e', 108, NULL, NULL, 143634),
(143635, '3.40.50.300-FF-005759', NULL, 'UvrD/REP helicase N-terminal domain protein', 123, NULL, NULL, 143635),
(143636, '3.30.830.10-FF-000293', NULL, 'Uncharacterized protein', 139, NULL, NULL, 143636),
(143637, '3.40.140.10-FF-000266', NULL, 'Cytidine/deoxycytidylate deaminase family protein', 114, NULL, NULL, 143637),
(143638, '4.10.400.10-FF-000278', NULL, 'LDL receptor protein 1, isoform G', 32, NULL, NULL, 143638),
(143639, '3.30.530.50-FF-000001', NULL, 'Outer membrane protein assembly factor BamC', 112, NULL, NULL, 143639),
(143640, '2.160.20.10-FF-000278', NULL, 'Uncharacterized protein', 240, NULL, NULL, 143640),
(143641, '3.10.110.10-FF-000158', NULL, 'Ubiquitin-conjugating enzyme E2 C', 152, NULL, NULL, 143641),
(143642, '2.130.10.10-FF-004270', NULL, 'Predicted protein', 131, NULL, NULL, 143642),
(143643, '3.90.1150.10-FF-000030', NULL, 'UDP-4-amino-4-deoxy-L-arabinose--oxoglutarate aminotransferase', 130, NULL, NULL, 143643),
(143644, '2.60.40.60-FF-001024', NULL, 'Uncharacterized protein', 108, NULL, NULL, 143644),
(143645, '1.10.510.10-FF-001118', NULL, 'Tyrosine-protein kinase PR2', 234, NULL, NULL, 143645),
(143646, '3.40.50.80-FF-000023', NULL, 'Putative ferric-chelate reductase', 158, NULL, NULL, 143646);
INSERT INTO "PUBLIC"."MODEL" VALUES
(143647, '1.20.1250.10-FF-000122', NULL, NULL, 144, NULL, NULL, 143647),
(143648, '3.40.395.10-FF-000008', NULL, 'Ulp1 protease family protein', 215, NULL, NULL, 143648),
(143649, '3.30.200.20-FF-001693', NULL, 'Protein kinase, putative', 66, NULL, NULL, 143649),
(143650, '3.30.559.10-FF-000212', NULL, 'Carnitine palmitoyltransferase-like protein', 195, NULL, NULL, 143650),
(143651, '3.10.100.10-FF-000186', NULL, 'Mannose receptor, C type 1b', 151, NULL, NULL, 143651),
(143652, '1.10.940.10-FF-000010', NULL, 'Transcription antitermination protein NusB', 137, NULL, NULL, 143652),
(143653, '1.10.238.220-FF-000011', NULL, NULL, 130, NULL, NULL, 143653),
(143654, '3.40.50.1000-FF-000735', NULL, NULL, 67, NULL, NULL, 143654),
(143655, '1.10.1200.80-FF-000007', NULL, 'tRNA-dihydrouridine synthase', 71, NULL, NULL, 143655),
(143656, '2.60.40.10-FF-002577', NULL, 'High Incidence of Males (Increased X chromosome loss)', 91, NULL, NULL, 143656),
(143657, '3.30.457.50-FF-000009', NULL, NULL, 43, NULL, NULL, 143657),
(143658, '1.10.510.10-FF-004294', NULL, NULL, 163, NULL, NULL, 143658),
(143659, '2.102.10.10-FF-000056', NULL, 'Cytochrome b/b6 complex, iron-sulfur cluster-binding subunit', 89, NULL, NULL, 143659),
(143660, '3.40.367.20-FF-000025', NULL, 'Phosphotransferase', 271, NULL, NULL, 143660),
(143661, '1.10.730.10-FF-000090', NULL, 'Methionine--tRNA ligase', 187, NULL, NULL, 143661),
(143662, '3.90.550.10-FF-000651', NULL, 'Glycosyltransferases', 134, NULL, NULL, 143662),
(143663, '1.20.1070.10-FF-001485', NULL, 'Predicted protein', 206, NULL, NULL, 143663),
(143664, '3.30.160.60-FF-004264', NULL, NULL, 94, NULL, NULL, 143664),
(143665, '1.10.1410.10-FF-000076', NULL, 'U Six snRNA Interacting Protein', 179, NULL, NULL, 143665),
(143666, '2.60.40.10-FF-000397', NULL, 'angiopoietin-1 receptor isoform X1', 90, NULL, NULL, 143666),
(143667, '1.10.10.60-FF-000190', NULL, 'Melibiose operon regulatory protein', 56, NULL, NULL, 143667),
(143668, '3.40.50.1780-FF-000036', NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', 20, NULL, NULL, 143668),
(143669, '3.60.110.10-FF-000102', NULL, NULL, 111, NULL, NULL, 143669),
(143670, '3.30.160.60-FF-004943', NULL, NULL, 30, NULL, NULL, 143670),
(143671, '1.20.1640.10-FF-000079', NULL, 'Putative multidrug resistance protein', 220, NULL, NULL, 143671),
(143672, '1.10.287.110-FF-000347', NULL, 'Uncharacterized protein', 63, NULL, NULL, 143672),
(143673, '3.10.20.90-FF-000149', NULL, 'microtubule-associated proteins 1A/1B light chain 3C', 124, NULL, NULL, 143673),
(143674, '3.40.630.10-FF-000174', NULL, 'Arginine utilization protein RocB', 217, NULL, NULL, 143674),
(143675, '1.10.472.10-FF-000562', NULL, 'Predicted protein', 65, NULL, NULL, 143675),
(143676, '2.60.120.780-FF-000013', NULL, 'YALI0E23342p', 159, NULL, NULL, 143676),
(143677, '3.40.50.300-FF-003522', NULL, 'RAD51-like protein 2', 290, NULL, NULL, 143677),
(143678, '3.40.50.1760-FF-000030', NULL, NULL, 25, NULL, NULL, 143678),
(143679, '3.30.450.20-FF-000311', NULL, 'Nitrogen fixation regulatory protein, NifL', 131, NULL, NULL, 143679),
(143680, '1.20.950.20-FF-000022', NULL, 'Periplasmically oriented, membrane-bound [NiFe]-hydrogenase b-type cytochrome subunit', 198, NULL, NULL, 143680),
(143681, '3.20.20.70-FF-000002', NULL, 'Transaldolase', 319, NULL, NULL, 143681),
(143682, '3.40.50.720-FF-001962', NULL, 'Uncharacterized oxidoreductase C16H5.14c', 256, NULL, NULL, 143682),
(143683, '1.25.40.180-FF-000043', NULL, 'MIF4G domain-containing protein / MA3 domain-containing protein', 285, NULL, NULL, 143683),
(143684, '3.40.50.300-FF-000291', NULL, 'ATP-dependent RNA helicase SrmB', 213, NULL, NULL, 143684),
(143685, '3.90.1680.10-FF-000002', NULL, 'YMR114C-like protein', 234, NULL, NULL, 143685),
(143686, '1.10.260.170-FF-000008', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', 134, NULL, NULL, 143686),
(143687, '2.60.40.10-FF-004292', NULL, NULL, 100, NULL, NULL, 143687),
(143688, '3.20.20.80-FF-000005', NULL, 'Glucan endo-1,3-beta-glucosidase 14', 326, NULL, NULL, 143688),
(143689, '3.40.50.150-FF-000728', NULL, 'Predicted protein', 217, NULL, NULL, 143689);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(143690, '3.30.160.60-FF-003162', NULL, NULL, 29, NULL, NULL, 143690),
(143691, '1.10.150.60-FF-000054', NULL, NULL, 105, NULL, NULL, 143691),
(143692, '1.10.20.140-FF-000003', NULL, 'tRNA dimethylallyltransferase', 83, NULL, NULL, 143692),
(143693, '2.130.10.10-FF-002706', NULL, 'YALI0E06633p', 320, NULL, NULL, 143693),
(143694, '1.20.1560.10-FF-000308', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 366, NULL, NULL, 143694),
(143695, '1.10.472.130-FF-000056', NULL, 'Dynein heavy chain 6', 179, NULL, NULL, 143695),
(143696, '3.40.50.300-FF-001431', NULL, 'Dephospho-CoA kinase', 203, NULL, NULL, 143696),
(143697, '3.40.50.2000-FF-000462', NULL, 'Os02g0467700 protein', 120, NULL, NULL, 143697),
(143698, '1.10.472.10-FF-000360', NULL, 'Transcription factor TFIIB cyclin-related', 91, NULL, NULL, 143698),
(143699, '2.60.120.200-FF-000328', NULL, 'Protein CBG09099', 133, NULL, NULL, 143699),
(143700, '3.30.70.330-FF-002604', NULL, NULL, 132, NULL, NULL, 143700),
(143701, '3.30.70.330-FF-000513', NULL, 'Splicing factor, proline-and glutamine-rich', 87, NULL, NULL, 143701),
(143702, '3.40.980.10-FF-000048', NULL, 'Uncharacterized protein', 173, NULL, NULL, 143702),
(143703, '2.130.10.10-FF-002229', NULL, 'NACHT and WD domain protein', 150, NULL, NULL, 143703),
(143704, '3.60.15.10-FF-000049', NULL, 'tRNase Z TRZ1', 259, NULL, NULL, 143704),
(143705, '3.30.200.20-FF-002507', NULL, 'Protein kinase N1', 115, NULL, NULL, 143705),
(143706, '3.40.50.300-FF-004826', NULL, 'SWF/SNF family helicase', 187, NULL, NULL, 143706),
(143707, '1.10.238.10-FF-000529', NULL, 'Solute carrier family 25 member 13', 71, NULL, NULL, 143707),
(143708, '3.40.1160.10-FF-000002', NULL, 'Aspartokinase', 251, NULL, NULL, 143708),
(143709, '1.25.40.10-FF-004061', NULL, 'Uncharacterized protein (Fragment)', 354, NULL, NULL, 143709),
(143710, '3.30.200.60-FF-000018', NULL, 'OTU deubiquitinase, ubiquitin aldehyde-binding 1b', 49, NULL, NULL, 143710),
(143711, '3.40.140.10-FF-000064', NULL, 'Nuclear protein localization protein 4, putative', 191, NULL, NULL, 143711),
(143712, '1.10.10.10-FF-000489', NULL, 'Putative peroxisomal membrane anchor protein', 55, NULL, NULL, 143712),
(143713, '2.130.10.10-FF-004646', NULL, 'Uncharacterized protein', 192, NULL, NULL, 143713),
(143714, '2.60.40.10-FF-003038', NULL, 'AGAP006350-PA', 111, NULL, NULL, 143714),
(143715, '3.30.420.110-FF-000016', NULL, 'DNA mismatch repair protein MSH2', 160, NULL, NULL, 143715),
(143716, '3.30.1330.60-FF-000038', NULL, 'Flagellar motor protein MotB', 103, NULL, NULL, 143716),
(143717, '1.10.1080.10-FF-000004', NULL, 'Glutathione synthetase', 83, NULL, NULL, 143717),
(143718, '1.20.58.2220-FF-000067', NULL, 'Uncharacterized protein', 246, NULL, NULL, 143718),
(143719, '3.30.565.10-FF-000272', NULL, 'Mlh2-like protein', 232, NULL, NULL, 143719),
(143720, '3.30.420.100-FF-000013', NULL, '60S ribosomal protein L5 isoform X2', 181, NULL, NULL, 143720),
(143721, '3.75.10.10-FF-000033', NULL, NULL, 251, NULL, NULL, 143721),
(143722, '3.90.180.10-FF-000105', NULL, '6-hydroxycylohex-1-en-1-carbonyl-CoA dehydrogenase', 179, NULL, NULL, 143722),
(143723, '3.30.70.330-FF-001300', NULL, 'RNA-binding motif protein 7', 120, NULL, NULL, 143723),
(143724, '3.30.70.3490-FF-000063', NULL, NULL, 106, NULL, NULL, 143724),
(143725, '3.50.50.60-FF-000461', NULL, 'Flavin-containing monooxygenase', 166, NULL, NULL, 143725),
(143726, '1.10.486.10-FF-000004', NULL, 'PCNA-interacting partner isoform X3', 141, NULL, NULL, 143726),
(143727, '3.40.50.720-FF-000332', NULL, 'Galactitol-1-phosphate 5-dehydrogenase', 138, NULL, NULL, 143727),
(143728, '3.40.190.10-FF-000628', NULL, 'Glutamate receptor U1, putative', 104, NULL, NULL, 143728),
(143729, '2.120.10.30-FF-000616', NULL, 'Uncharacterized protein', 80, NULL, NULL, 143729),
(143730, '3.40.50.150-FF-001420', NULL, NULL, 156, NULL, NULL, 143730),
(143731, '3.30.200.20-FF-000416', NULL, 'AGC/AKT protein kinase', 95, NULL, NULL, 143731),
(143732, '3.60.120.10-FF-000018', NULL, 'Para-aminobenzoate synthase, component I, putative', 359, NULL, NULL, 143732);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(143733, '1.10.238.10-FF-000855', NULL, 'Defective in cullin neddylation protein 1', 132, NULL, NULL, 143733),
(143734, '3.40.109.10-FF-000047', NULL, 'Probable NAD(P)H nitroreductase PigM', 233, NULL, NULL, 143734),
(143735, '3.30.160.60-FF-003898', NULL, NULL, 28, NULL, NULL, 143735),
(143736, '1.10.10.10-FF-000017', NULL, 'transcription factor RFX3 isoform X1', 75, NULL, NULL, 143736),
(143737, '3.30.200.20-FF-001052', NULL, 'BnaA09g28440D protein', 71, NULL, NULL, 143737),
(143738, '2.30.29.30-FF-001187', NULL, 'Uncharacterized protein', 103, NULL, NULL, 143738),
(143739, '1.25.10.10-FF-000490', NULL, 'CRM1p Major karyopherin', 367, NULL, NULL, 143739),
(143740, '1.20.1250.20-FF-000327', NULL, 'Transporter, MFS superfamily', 185, NULL, NULL, 143740),
(143741, '3.40.50.1820-FF-001318', NULL, 'Uncharacterized protein', 260, NULL, NULL, 143741),
(143742, '1.10.510.10-FF-000808', NULL, 'Serine/threonine kinase 31', 200, NULL, NULL, 143742),
(143743, '2.60.40.10-FF-004668', NULL, NULL, 116, NULL, NULL, 143743),
(143744, '1.25.10.10-FF-002581', NULL, 'Uncharacterized protein', 159, NULL, NULL, 143744),
(143745, '2.60.40.10-FF-000930', NULL, 'immunoglobulin superfamily DCC subclass member 3', 96, NULL, NULL, 143745),
(143746, '3.20.20.300-FF-000002', NULL, 'Probable beta-glucosidase', 330, NULL, NULL, 143746),
(143747, '2.40.30.10-FF-000318', NULL, 'Probable mitochondrial tRNA-specific 2-thiouridylase 1', 88, NULL, NULL, 143747),
(143748, '1.10.10.10-FF-001001', NULL, 'Predicted protein', 107, NULL, NULL, 143748),
(143749, '3.30.160.60-FF-005989', NULL, NULL, 48, NULL, NULL, 143749),
(143750, '1.20.1050.130-FF-000022', NULL, 'Glutathione S-transferase, putative', 114, NULL, NULL, 143750),
(143751, '3.40.50.10810-FF-000182', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 60, NULL, NULL, 143751),
(143752, '3.30.160.60-FF-001335', NULL, 'zinc finger protein 592 isoform X1', 76, NULL, NULL, 143752),
(143753, '3.20.140.10-FF-000017', NULL, 'Nicotinate phosphoribosyltransferase', 446, NULL, NULL, 143753),
(143754, '3.30.160.60-FF-000846', NULL, 'Zinc finger protein 624', 29, NULL, NULL, 143754),
(143755, '2.130.10.10-FF-003016', NULL, 'U3 small nucleolar RNA-associated protein 15-like protein', 171, NULL, NULL, 143755),
(143756, '2.60.120.920-FF-000185', NULL, 'Uncharacterized protein', 111, NULL, NULL, 143756),
(143757, '3.40.1810.10-FF-000053', NULL, NULL, 72, NULL, NULL, 143757),
(143758, '3.90.1410.10-FF-000073', NULL, 'Predicted protein', 240, NULL, NULL, 143758),
(143759, '3.30.70.330-FF-000160', NULL, 'Transformer-2 protein homolog beta', 202, NULL, NULL, 143759),
(143760, '1.25.40.450-FF-000023', NULL, 'Uncharacterized protein', 50, NULL, NULL, 143760),
(143761, '2.10.220.10-FF-000199', NULL, 'Proprotein convertase subtilisin/kexin type 5a', 60, NULL, NULL, 143761),
(143762, '3.30.70.270-FF-000001', NULL, 'Diguanylate cyclase domain protein', 167, NULL, NULL, 143762),
(143763, '1.25.40.540-FF-000022', NULL, 'Uncharacterized protein', 258, NULL, NULL, 143763),
(143764, '2.70.150.10-FF-000269', NULL, 'Calcium-transporting ATPase', 43, NULL, NULL, 143764),
(143765, '1.10.3210.10-FF-000095', NULL, 'Uncharacterized protein', 289, NULL, NULL, 143765),
(143766, '3.30.160.60-FF-004887', NULL, NULL, 28, NULL, NULL, 143766),
(143767, '1.25.10.10-FF-001597', NULL, 'Karyopherin (Importin) alpha, putative', 170, NULL, NULL, 143767),
(143768, '3.90.79.10-FF-000049', NULL, 'Peroxisomal coenzyme A diphosphatase NUDT7', 187, NULL, NULL, 143768),
(143769, '1.25.10.10-FF-000815', NULL, 'RING-type E3 ubiquitin transferase', 195, NULL, NULL, 143769),
(143770, '1.10.510.10-FF-004524', NULL, NULL, 209, NULL, NULL, 143770),
(143771, '3.30.1360.70-FF-000015', NULL, 'Arginine--tRNA ligase', 104, NULL, NULL, 143771),
(143772, '2.40.10.10-FF-000435', NULL, NULL, 60, NULL, NULL, 143772),
(143773, '1.20.5.780-FF-000013', NULL, 'FXYD domain-containing ion transport regulator', 53, NULL, NULL, 143773),
(143774, '3.40.50.300-FF-002089', NULL, 'Adenylate kinase isoenzyme 6 homolog', 185, NULL, NULL, 143774);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(143775, '1.20.1070.10-FF-001659', NULL, 'Uncharacterized protein', 127, NULL, NULL, 143775),
(143776, '1.10.10.60-FF-000392', NULL, 'sigma-54-dependent Fis family transcriptional regulator', 69, NULL, NULL, 143776),
(143777, '2.80.10.50-FF-000187', NULL, 'Mannose receptor C type 2', 131, NULL, NULL, 143777),
(143778, '2.60.40.10-FF-004522', NULL, NULL, 107, NULL, NULL, 143778),
(143779, '3.40.190.10-FF-000038', NULL, 'Putative glutamate receptor ionotropic NMDA 2B', 129, NULL, NULL, 143779),
(143780, '1.20.58.390-FF-000227', NULL, 'Glycine receptor alpha chain, putative', 143, NULL, NULL, 143780),
(143781, '3.90.110.10-FF-000011', NULL, 'L-lactate dehydrogenase', 167, NULL, NULL, 143781),
(143782, '2.70.150.10-FF-000213', NULL, 'Uncharacterized protein', 92, NULL, NULL, 143782),
(143783, '1.10.510.10-FF-000399', NULL, 'Tyrosine-protein kinase', 186, NULL, NULL, 143783),
(143784, '3.30.160.60-FF-004741', NULL, NULL, 27, NULL, NULL, 143784),
(143785, '1.20.1250.20-FF-001429', NULL, 'Uncharacterized protein', 146, NULL, NULL, 143785),
(143786, '3.50.7.10-FF-000055', NULL, NULL, 180, NULL, NULL, 143786),
(143787, '2.10.25.10-FF-001162', NULL, 'Delta-like protein', 40, NULL, NULL, 143787),
(143788, '2.60.40.60-FF-000951', NULL, 'Cad74A isoform A family protein', 105, NULL, NULL, 143788),
(143789, '1.10.10.10-FF-000961', NULL, 'Two-component response regulator', 102, NULL, NULL, 143789),
(143790, '2.60.40.10-FF-003510', NULL, NULL, 88, NULL, NULL, 143790),
(143791, '3.30.497.10-FF-000023', NULL, 'Serpin B6', 211, NULL, NULL, 143791),
(143792, '1.10.472.10-FF-000034', NULL, 'D2/4-type cyclin', 118, NULL, NULL, 143792),
(143793, '2.40.70.10-FF-000118', NULL, 'Eukaryotic aspartyl protease family protein', 203, NULL, NULL, 143793),
(143794, '3.30.450.30-FF-000084', NULL, 'Uncharacterized protein', 79, NULL, NULL, 143794),
(143795, '1.10.510.10-FF-000253', NULL, 'MAP kinase kinase Ste7', 214, NULL, NULL, 143795),
(143796, '3.30.430.20-FF-000046', NULL, 'Cysteine-rich repeat secretory protein 55', 107, NULL, NULL, 143796),
(143797, '3.40.50.300-FF-002409', NULL, 'Probable GTP-binding protein EngB', 193, NULL, NULL, 143797),
(143798, '1.10.220.150-FF-000039', NULL, 'ADP-ribosylation factor GTPase activating protein, putative', 140, NULL, NULL, 143798),
(143799, '3.40.50.150-FF-001190', NULL, NULL, 188, NULL, NULL, 143799),
(143800, '3.30.710.10-FF-000025', NULL, 'B-cell lymphoma 6 protein-like', 128, NULL, NULL, 143800),
(143801, '3.30.40.10-FF-000103', NULL, 'Inhibitor of growth protein', 57, NULL, NULL, 143801),
(143802, '3.90.660.10-FF-000041', NULL, 'Putative polyamine oxidase 5 isoform A', 28, NULL, NULL, 143802),
(143803, '3.30.450.40-FF-000087', NULL, 'Phosphoserine phosphatase RsbP', 194, NULL, NULL, 143803),
(143804, '2.10.25.10-FF-001752', NULL, 'Adhesion G protein-coupled receptor L4', 36, NULL, NULL, 143804),
(143805, '2.120.10.80-FF-000047', NULL, 'V(D)J recombination-activating protein 2', 320, NULL, NULL, 143805),
(143806, '3.10.100.10-FF-000416', NULL, NULL, 99, NULL, NULL, 143806),
(143807, '2.30.29.30-FF-000405', NULL, 'RHO1 GDP-GTP exchange protein 2', 150, NULL, NULL, 143807),
(143808, '1.10.8.270-FF-000065', NULL, 'GTPase activating protein', 108, NULL, NULL, 143808),
(143809, '2.60.40.420-FF-000205', NULL, 'Uncharacterized protein', 54, NULL, NULL, 143809),
(143810, '3.10.180.10-FF-000106', NULL, '4-hydroxyphenylpyruvate dioxygenase', 168, NULL, NULL, 143810),
(143811, '2.40.100.10-FF-000071', NULL, 'Putative cyclophilin 13', 175, NULL, NULL, 143811),
(143812, '2.170.40.20-FF-000001', NULL, 'Envelope glycoprotein gp160', 101, NULL, NULL, 143812),
(143813, '2.40.70.10-FF-000388', NULL, NULL, 187, NULL, NULL, 143813),
(143814, '3.40.50.300-FF-008047', NULL, 'Uncharacterized protein', 128, NULL, NULL, 143814),
(143815, '3.60.21.10-FF-000255', NULL, 'Serine/threonine-protein phosphatase', 317, NULL, NULL, 143815),
(143816, '3.80.10.10-FF-003713', NULL, 'Uncharacterized protein', 151, NULL, NULL, 143816),
(143817, '3.30.70.270-FF-000332', NULL, NULL, 76, NULL, NULL, 143817),
(143818, '3.40.140.10-FF-000092', NULL, 'Cytidine deaminase family enzyme', 135, NULL, NULL, 143818);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(143819, '3.80.10.10-FF-003893', NULL, 'Os05g0170300 protein', 289, NULL, NULL, 143819),
(143820, '3.30.40.10-FF-000249', NULL, 'E3 ubiquitin-protein ligase RNF216 isoform X1', 87, NULL, NULL, 143820),
(143821, '3.10.180.10-FF-000101', NULL, 'Uncharacterized protein', 129, NULL, NULL, 143821),
(143822, '1.10.540.10-FF-000081', NULL, 'Acyl-CoA dehydrogenase short/branched chain', 71, NULL, NULL, 143822),
(143823, '2.60.40.10-FF-005511', NULL, NULL, 79, NULL, NULL, 143823),
(143824, '2.30.29.30-FF-001333', NULL, 'Uncharacterized protein', 57, NULL, NULL, 143824),
(143825, '1.20.1250.20-FF-002042', NULL, 'Solute carrier organic anion transporter family member', 319, NULL, NULL, 143825),
(143826, '3.30.870.10-FF-000183', NULL, 'Uncharacterized protein', 195, NULL, NULL, 143826),
(143827, '1.25.40.20-FF-000972', NULL, 'Uncharacterized protein', 80, NULL, NULL, 143827),
(143828, '2.30.30.30-FF-000145', NULL, 'Eukaryotic translation initiation factor 5A', 70, NULL, NULL, 143828),
(143829, '3.40.640.10-FF-000236', NULL, 'Alanine aminotransferase 2', 247, NULL, NULL, 143829),
(143830, '3.30.420.40-FF-000259', NULL, 'Actin-like protein arp-6', 123, NULL, NULL, 143830),
(143831, '2.60.40.10-FF-001240', NULL, 'Sialic acid binding Ig-like lectin E', 89, NULL, NULL, 143831),
(143832, '3.30.70.330-FF-002082', NULL, NULL, 77, NULL, NULL, 143832),
(143833, '2.130.10.10-FF-003342', NULL, 'Myosin heavy chain kinase A', 105, NULL, NULL, 143833),
(143834, '3.40.640.10-FF-000383', NULL, 'Aspartate aminotransferase, putative', 211, NULL, NULL, 143834),
(143835, '3.40.50.300-FF-006395', NULL, 'Uncharacterized protein', 134, NULL, NULL, 143835),
(143836, '1.20.58.60-FF-000107', NULL, 'Short stop, isoform K', 112, NULL, NULL, 143836),
(143837, '1.20.1420.30-FF-000080', NULL, 'Ca(2+)/H(+) antiporter', 148, NULL, NULL, 143837),
(143838, '3.40.50.620-FF-000009', NULL, 'Cysteine--tRNA ligase', 302, NULL, NULL, 143838),
(143839, '1.10.10.10-FF-000635', NULL, 'Frv operon regulatory protein', 62, NULL, NULL, 143839),
(143840, '2.10.25.160-FF-000003', NULL, 'Progranulin', 61, NULL, NULL, 143840),
(143841, '3.30.200.20-FF-002417', NULL, 'Uncharacterized protein', 86, NULL, NULL, 143841),
(143842, '3.40.50.12650-FF-000008', NULL, 'DNA cross-link repair protein pso2/snm1', 126, NULL, NULL, 143842),
(143843, '3.40.630.30-FF-000596', NULL, 'Uncharacterized protein', 80, NULL, NULL, 143843),
(143844, '3.40.50.1820-FF-000211', NULL, 'Carboxypeptidase', 261, NULL, NULL, 143844),
(143845, '3.40.50.1970-FF-000031', NULL, '3-dehydroquinate synthase', 171, NULL, NULL, 143845),
(143846, '3.40.50.920-FF-000004', NULL, '2-oxoisovalerate dehydrogenase subunit beta 1, mitochondrial', 133, NULL, NULL, 143846),
(143847, '3.30.70.330-FF-000283', NULL, 'U2 snRNP auxiliary factor large subunit', 57, NULL, NULL, 143847),
(143848, '1.10.10.10-FF-000871', NULL, 'ATP-dependent DNA helicase', 129, NULL, NULL, 143848),
(143849, '1.25.10.10-FF-000495', NULL, 'Uncharacterized protein', 412, NULL, NULL, 143849),
(143850, '1.20.930.80-FF-000016', NULL, 'Uncharacterized protein', 154, NULL, NULL, 143850),
(143851, '3.40.50.1980-FF-000034', NULL, 'Ferric enterobactin transporter binding protein', 147, NULL, NULL, 143851),
(143852, '3.30.40.10-FF-001407', NULL, 'Uncharacterized protein', 86, NULL, NULL, 143852),
(143853, '3.30.559.30-FF-000044', NULL, 'Nonribosomal peptide synthetase 7', 231, NULL, NULL, 143853),
(143854, '2.40.37.10-FF-000007', NULL, 'Diaminopimelate decarboxylase', 148, NULL, NULL, 143854),
(143855, '1.10.510.10-FF-003035', NULL, NULL, 219, NULL, NULL, 143855),
(143856, '1.10.238.10-FF-000299', NULL, 'Uncharacterized protein', 86, NULL, NULL, 143856),
(143857, '1.20.5.190-FF-000050', NULL, 'Myosin VIIb', 49, NULL, NULL, 143857),
(143858, '2.20.20.110-FF-000011', NULL, 'DNA repair protein rhp41', 53, NULL, NULL, 143858),
(143859, '1.10.455.10-FF-000034', NULL, 'Uncharacterized protein', 129, NULL, NULL, 143859),
(143860, '3.30.40.10-FF-000305', NULL, 'RING finger protein 112', 74, NULL, NULL, 143860),
(143861, '3.30.160.60-FF-004915', NULL, NULL, 45, NULL, NULL, 143861);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(143862, '1.20.1070.10-FF-001805', NULL, 'Uncharacterized protein', 315, NULL, NULL, 143862),
(143863, '1.25.40.20-FF-001045', NULL, 'Protein ACCELERATED CELL DEATH 6', 171, NULL, NULL, 143863),
(143864, '2.130.10.130-FF-000045', NULL, NULL, 76, NULL, NULL, 143864),
(143865, '1.20.120.980-FF-000038', NULL, 'AGAP003641-PA', 95, NULL, NULL, 143865),
(143866, '3.40.50.1820-FF-001644', NULL, 'Carboxylic ester hydrolase', 396, NULL, NULL, 143866),
(143867, '1.20.1070.10-FF-000226', NULL, 'Probable G-protein coupled receptor 152', 292, NULL, NULL, 143867),
(143868, '3.30.160.60-FF-006181', NULL, NULL, 61, NULL, NULL, 143868),
(143869, '3.40.50.2060-FF-000019', NULL, 'Putative syntaxin binding protein 1', 131, NULL, NULL, 143869),
(143870, '2.30.30.550-FF-000013', NULL, NULL, 81, NULL, NULL, 143870),
(143871, '1.20.120.1080-FF-000087', NULL, 'Nucleic acid helicase, putative', 125, NULL, NULL, 143871),
(143872, '1.25.10.10-FF-003305', NULL, 'Serine/threonine-protein kinase TOR', 169, NULL, NULL, 143872),
(143873, '1.20.1050.130-FF-000027', NULL, 'Uncharacterized protein', 115, NULL, NULL, 143873),
(143874, '1.20.120.560-FF-000002', NULL, 'programmed cell death 6-interacting protein-like isoform X2', 146, NULL, NULL, 143874),
(143875, '3.20.20.100-FF-000116', NULL, 'Aldehyde reductase, putative', 230, NULL, NULL, 143875),
(143876, '3.10.350.10-FF-000081', NULL, 'Cell wall hydrolase', 64, NULL, NULL, 143876),
(143877, '2.20.70.10-FF-000254', NULL, 'Uncharacterized protein', 48, NULL, NULL, 143877),
(143878, '1.20.1390.10-FF-000008', NULL, 'RNA Binding Motif protein homolog', 116, NULL, NULL, 143878),
(143879, '2.20.70.10-FF-000052', NULL, 'pre-mRNA-processing factor 40 homolog B isoform X1', 54, NULL, NULL, 143879),
(143880, '3.10.20.90-FF-000475', NULL, 'Midnolin homolog', 103, NULL, NULL, 143880),
(143881, '3.30.470.140-FF-000001', NULL, 'mRNA-capping enzyme catalytic subunit', 177, NULL, NULL, 143881),
(143882, '3.30.30.30-FF-000047', NULL, 'Uncharacterized protein', 52, NULL, NULL, 143882),
(143883, '3.40.50.300-FF-001307', NULL, 'Primosomal protein N''', 187, NULL, NULL, 143883),
(143884, '3.40.630.10-FF-000348', NULL, 'Glutamate carboxypeptidase, putative', 220, NULL, NULL, 143884),
(143885, '1.10.10.60-FF-001206', NULL, NULL, 82, NULL, NULL, 143885),
(143886, '1.20.1070.10-FF-002025', NULL, 'Uncharacterized protein', 125, NULL, NULL, 143886),
(143887, '1.25.40.10-FF-004712', NULL, 'AGAP012369-PA', 91, NULL, NULL, 143887),
(143888, '2.60.40.10-FF-004612', NULL, NULL, 123, NULL, NULL, 143888),
(143889, '3.40.1110.10-FF-000376', NULL, NULL, 155, NULL, NULL, 143889),
(143890, '3.30.70.20-FF-000136', NULL, NULL, 96, NULL, NULL, 143890),
(143891, '2.30.40.10-FF-000111', NULL, 'Uncharacterized protein', 24, NULL, NULL, 143891),
(143892, '3.40.50.300-FF-006248', NULL, 'Uncharacterized protein', 202, NULL, NULL, 143892),
(143893, '3.30.505.10-FF-000094', NULL, 'Cytokine-inducible SH2-containing protein', 169, NULL, NULL, 143893),
(143894, '1.10.287.110-FF-000437', NULL, 'Chaperone protein DNAJ, putative', 74, NULL, NULL, 143894),
(143895, '3.10.20.90-FF-000565', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 106, NULL, NULL, 143895),
(143896, '2.30.29.30-FF-000400', NULL, 'docking protein 1 isoform X1', 116, NULL, NULL, 143896),
(143897, '4.10.60.10-FF-000137', NULL, 'Zinc knuckle domain containing protein', 42, NULL, NULL, 143897),
(143898, '2.60.40.150-FF-000248', NULL, 'U5 small nuclear ribonucleoprotein helicase', 135, NULL, NULL, 143898),
(143899, '2.60.40.10-FF-002870', NULL, 'Mast/stem cell growth factor receptor', 106, NULL, NULL, 143899),
(143900, '3.90.70.10-FF-000294', NULL, 'Expressed protein', 284, NULL, NULL, 143900),
(143901, '3.10.450.40-FF-000041', NULL, NULL, 107, NULL, NULL, 143901),
(143902, '1.10.357.110-FF-000010', NULL, 'Vps53-like protein', 175, NULL, NULL, 143902),
(143903, '2.60.40.10-FF-005596', NULL, NULL, 84, NULL, NULL, 143903),
(143904, '1.25.40.10-FF-004914', NULL, 'Uncharacterized protein', 71, NULL, NULL, 143904),
(143905, '3.40.50.150-FF-000554', NULL, 'Cation-transporting ATPase', 278, NULL, NULL, 143905);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(143906, '2.30.30.40-FF-000333', NULL, 'Predicted protein', 69, NULL, NULL, 143906),
(143907, '1.25.40.10-FF-000643', NULL, 'Pentatricopeptide repeat-containing protein', 97, NULL, NULL, 143907),
(143908, '1.20.272.10-FF-000090', NULL, NULL, 47, NULL, NULL, 143908),
(143909, '3.40.50.1380-FF-000034', NULL, 'Uncharacterized protein', 151, NULL, NULL, 143909),
(143910, '3.40.390.10-FF-000312', NULL, NULL, 212, NULL, NULL, 143910),
(143911, '3.10.450.50-FF-000044', NULL, 'UBA/TS-N domain containing protein', 155, NULL, NULL, 143911),
(143912, '3.40.50.1000-FF-000645', NULL, NULL, 127, NULL, NULL, 143912),
(143913, '3.30.60.20-FF-000164', NULL, 'Uncharacterized protein', 73, NULL, NULL, 143913),
(143914, '3.40.50.1370-FF-000031', NULL, 'Aspartate carbamoyltransferase', 134, NULL, NULL, 143914),
(143915, '1.25.40.20-FF-000646', NULL, 'SH3 and multiple ankyrin repeat domains 2', 182, NULL, NULL, 143915),
(143916, '1.10.510.10-FF-002669', NULL, NULL, 92, NULL, NULL, 143916),
(143917, '3.60.140.10-FF-000020', NULL, 'Polyphenol oxidase', 210, NULL, NULL, 143917),
(143918, '2.20.100.10-FF-000114', NULL, 'Unc-5, isoform B', 52, NULL, NULL, 143918),
(143919, '1.20.140.40-FF-000023', NULL, 'Pectinesterase inhibitor 9', 173, NULL, NULL, 143919),
(143920, '2.60.40.10-FF-002667', NULL, 'Protein-tyrosine-phosphatase', 123, NULL, NULL, 143920),
(143921, '2.60.120.970-FF-000065', NULL, 'Southpaw', 150, NULL, NULL, 143921),
(143922, '2.30.42.10-FF-000363', NULL, 'Periplasmic serine endoprotease DegP-like', 88, NULL, NULL, 143922),
(143923, '3.80.20.20-FF-000018', NULL, 'Insulin-like receptor', 225, NULL, NULL, 143923),
(143924, '3.80.10.10-FF-001145', NULL, 'Leucine-rich repeat and sterile alpha motif-containing 1', 177, NULL, NULL, 143924),
(143925, '2.10.50.30-FF-000023', NULL, 'Uncharacterized protein', 78, NULL, NULL, 143925),
(143926, '3.80.10.10-FF-003567', NULL, 'Uncharacterized protein', 146, NULL, NULL, 143926),
(143927, '1.10.238.10-FF-000945', NULL, 'Uncharacterized protein', 99, NULL, NULL, 143927),
(143928, '3.30.470.160-FF-000007', NULL, 'Histone deacetylase 2', 345, NULL, NULL, 143928),
(143929, '3.30.60.30-FF-000167', NULL, 'Agrin', 71, NULL, NULL, 143929),
(143930, '2.40.50.140-FF-000145', NULL, '30S ribosomal protein S28e', 67, NULL, NULL, 143930),
(143931, '1.25.40.10-FF-001132', NULL, 'Os03g0168550 protein', 136, NULL, NULL, 143931),
(143932, '1.10.510.10-FF-002872', NULL, NULL, 195, NULL, NULL, 143932),
(143933, '3.30.160.60-FF-000902', NULL, 'Zinc finger protein 445', 31, NULL, NULL, 143933),
(143934, '2.70.40.10-FF-000019', NULL, 'Deoxyuridine 5''-triphosphate nucleotidohydrolase, mitochondrial', 112, NULL, NULL, 143934),
(143935, '3.30.70.330-FF-002430', NULL, NULL, 88, NULL, NULL, 143935),
(143936, '1.25.40.20-FF-001135', NULL, 'Ankyrin_repeats_(Many_copies)/Ankyrin_repeats_(3_ copies)/Zinc_finger_-_C3HC4_type_(RING_finger )_containing_protein_-_putativ', 159, NULL, NULL, 143936),
(143937, '3.40.50.300-FF-006743', NULL, 'Uncharacterized protein', 68, NULL, NULL, 143937),
(143938, '2.130.10.10-FF-001982', NULL, 'RBBP4 isoform 19', 150, NULL, NULL, 143938),
(143939, '2.170.270.10-FF-000029', NULL, 'Histone-lysine N-methyltransferase SETDB2', 282, NULL, NULL, 143939),
(143940, '2.60.450.20-FF-000016', NULL, 'Predicted protein', 160, NULL, NULL, 143940),
(143941, '3.30.750.24-FF-000064', NULL, 'Sulfate permease family protein', 130, NULL, NULL, 143941),
(143942, '3.30.420.40-FF-000169', NULL, 'Actin 3', 109, NULL, NULL, 143942),
(143943, '2.60.450.10-FF-000013', NULL, 'LPS-assembly protein LptD', 151, NULL, NULL, 143943),
(143944, '3.40.50.1000-FF-000117', NULL, 'Cytosolic purine 5-nucleotidase', 220, NULL, NULL, 143944),
(143945, '1.10.10.10-FF-000545', NULL, 'RNA polymerase sigma factor', 70, NULL, NULL, 143945),
(143946, '2.130.10.10-FF-001217', NULL, 'Peptidyl-prolyl cis-trans isomerase', 218, NULL, NULL, 143946),
(143947, '1.10.510.10-FF-003361', NULL, NULL, 181, NULL, NULL, 143947),
(143948, '2.60.40.1120-FF-000003', NULL, 'Outer membrane protein Omp121', 71, NULL, NULL, 143948),
(143949, '1.10.238.10-FF-000327', NULL, 'Calmodulin-like protein 11', 71, NULL, NULL, 143949);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(143950, '2.40.50.40-FF-000103', NULL, 'Chemokine (C-X-C motif) ligand 18b', 75, NULL, NULL, 143950),
(143951, '1.10.287.380-FF-000001', NULL, 'Valine--tRNA ligase', 72, NULL, NULL, 143951),
(143952, '3.90.1750.10-FF-000087', NULL, 'Uncharacterized protein', 98, NULL, NULL, 143952),
(143953, '3.80.10.10-FF-003623', NULL, 'Leucine rich repeat containing G protein-coupled receptor 4', 340, NULL, NULL, 143953),
(143954, '2.40.50.40-FF-000047', NULL, 'Chromator, isoform A', 70, NULL, NULL, 143954),
(143955, '3.10.490.10-FF-000057', NULL, 'Glutathione-specific gamma-glutamylcyclotransferase', 163, NULL, NULL, 143955),
(143956, '3.30.479.30-FF-000043', NULL, 'Uncharacterized protein', 120, NULL, NULL, 143956),
(143957, '1.10.260.40-FF-000051', NULL, 'Probable transcriptional regulator', 84, NULL, NULL, 143957),
(143958, '1.10.1650.10-FF-000003', NULL, '50S ribosomal protein L19e', 55, NULL, NULL, 143958),
(143959, '2.40.50.140-FF-000055', NULL, 'Cold shock domain containing E1, RNA-binding', 70, NULL, NULL, 143959),
(143960, '3.30.559.10-FF-000066', NULL, 'Nonribosomal peptide synthetase 7', 172, NULL, NULL, 143960),
(143961, '1.10.238.10-FF-001311', NULL, 'Uncharacterized protein', 107, NULL, NULL, 143961),
(143962, '1.20.1250.20-FF-000035', NULL, 'Dipeptide permease D', 493, NULL, NULL, 143962),
(143963, '3.30.250.20-FF-000004', NULL, 'L1 transposable element', 81, NULL, NULL, 143963),
(143964, '1.10.510.10-FF-002725', NULL, NULL, 265, NULL, NULL, 143964),
(143965, '3.40.309.10-FF-000091', NULL, 'Aldehyde dehydrogenase 4 family member A1', 120, NULL, NULL, 143965),
(143966, '2.40.160.10-FF-000046', NULL, 'Probable porin', 446, NULL, NULL, 143966),
(143967, '3.30.500.10-FF-000009', NULL, 'Uncharacterized protein', 168, NULL, NULL, 143967),
(143968, '1.10.287.70-FF-000306', NULL, 'potassium channel subfamily K member 5 isoform X2', 192, NULL, NULL, 143968),
(143969, '1.10.1300.10-FF-000011', NULL, 'Phosphodiesterase', 387, NULL, NULL, 143969),
(143970, '3.40.33.10-FF-000199', NULL, 'Uncharacterized protein', 62, NULL, NULL, 143970),
(143971, '3.40.50.10810-FF-000187', NULL, 'Predicted protein', 185, NULL, NULL, 143971),
(143972, '3.30.430.20-FF-000041', NULL, 'Putative cysteine-rich receptor-like protein kinase 9', 100, NULL, NULL, 143972),
(143973, '3.40.525.10-FF-000042', NULL, 'Predicted protein', 161, NULL, NULL, 143973),
(143974, '2.60.40.10-FF-002723', NULL, 'Protein CBR-UNC-22', 95, NULL, NULL, 143974),
(143975, '1.10.510.10-FF-002377', NULL, NULL, 137, NULL, NULL, 143975),
(143976, '3.30.420.40-FF-001102', NULL, 'Protein CBG00489', 63, NULL, NULL, 143976),
(143977, '2.40.50.140-FF-000706', NULL, NULL, 50, NULL, NULL, 143977),
(143978, '3.30.160.60-FF-003252', NULL, 'Si:dkeyp-82b4.6', 28, NULL, NULL, 143978),
(143979, '3.30.250.10-FF-000001', NULL, 'Protein RecA', 80, NULL, NULL, 143979),
(143980, '1.10.1420.10-FF-000048', NULL, 'DNA mismatch repair protein MutS', 138, NULL, NULL, 143980),
(143981, '2.40.30.10-FF-000144', NULL, 'Eukaryotic release factor 3, putative', 108, NULL, NULL, 143981),
(143982, '3.10.105.10-FF-000085', NULL, 'Oligopeptide transport system binding protein', 211, NULL, NULL, 143982),
(143983, '1.20.58.60-FF-000731', NULL, 'Uncharacterized protein', 105, NULL, NULL, 143983),
(143984, '2.130.10.10-FF-002847', NULL, 'Ribosome assembly protein RRB1, putative', 426, NULL, NULL, 143984),
(143985, '3.40.50.1000-FF-000084', NULL, 'Phospholipid-transporting ATPase', 187, NULL, NULL, 143985),
(143986, '1.25.40.20-FF-000702', NULL, 'Putative ankyrin repeat family protein', 149, NULL, NULL, 143986),
(143987, '1.25.10.10-FF-001889', NULL, 'Uncharacterized protein', 327, NULL, NULL, 143987),
(143988, '2.60.120.260-FF-000088', NULL, 'Beta-galactosidase A', 167, NULL, NULL, 143988),
(143989, '3.40.50.10330-FF-000077', NULL, 'Diacylglycerol kinase', 79, NULL, NULL, 143989),
(143990, '1.20.5.780-FF-000018', NULL, 'FXYD domain-containing ion transport regulator', 50, NULL, NULL, 143990),
(143991, '1.20.58.60-FF-000080', NULL, 'Spectrin alpha chain, non-erythrocytic 1', 108, NULL, NULL, 143991); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(143992, '2.30.30.40-FF-000474', NULL, 'SLIT-ROBO Rho GTPase-activating protein 3', 55, NULL, NULL, 143992),
(143993, '3.30.230.70-FF-000091', NULL, 'Exosome complex component RRP45B', 135, NULL, NULL, 143993),
(143994, '2.40.70.10-FF-000444', NULL, NULL, 75, NULL, NULL, 143994),
(143995, '2.60.40.10-FF-004494', NULL, NULL, 98, NULL, NULL, 143995),
(143996, '3.10.450.240-FF-000009', NULL, 'Protein MBA1, mitochondrial', 138, NULL, NULL, 143996),
(143997, '3.30.1380.20-FF-000024', NULL, 'Trafficking protein particle complex 5', 100, NULL, NULL, 143997),
(143998, '3.10.450.220-FF-000003', NULL, '60S ribosome subunit biogenesis protein NIP7 homolog', 46, NULL, NULL, 143998),
(143999, '3.40.50.300-FF-004450', NULL, 'Helicase, putative', 156, NULL, NULL, 143999),
(144000, '3.40.630.10-FF-000438', NULL, 'Uncharacterized protein', 240, NULL, NULL, 144000),
(144001, '2.40.70.10-FF-000534', NULL, NULL, 195, NULL, NULL, 144001),
(144002, '1.25.10.10-FF-001799', NULL, 'Protein kinase, putative', 247, NULL, NULL, 144002),
(144003, '2.70.150.10-FF-000185', NULL, 'Cation transporting ATPase', 178, NULL, NULL, 144003),
(144004, '1.10.1670.10-FF-000033', NULL, 'Endonuclease III homolog', 92, NULL, NULL, 144004),
(144005, '1.20.58.70-FF-000083', NULL, 't-SNARE', 122, NULL, NULL, 144005),
(144006, '1.20.58.60-FF-000170', NULL, 'Dystrophin', 110, NULL, NULL, 144006),
(144007, '2.70.150.10-FF-000095', NULL, 'Phospholipid-transporting ATPase', 78, NULL, NULL, 144007),
(144008, '3.80.10.10-FF-000217', NULL, 'fibromodulin', 68, NULL, NULL, 144008),
(144009, '1.20.5.190-FF-000078', NULL, 'Abnormal spindle microtubule assembly', 44, NULL, NULL, 144009),
(144010, '3.40.50.11670-FF-000001', NULL, 'DNA replication regulator family protein', 180, NULL, NULL, 144010),
(144011, '1.20.1070.10-FF-001715', NULL, 'Uncharacterized protein', 102, NULL, NULL, 144011),
(144012, '1.20.5.170-FF-000072', NULL, 'Putative chromatin structure-remodeling complex subunit snf21', 76, NULL, NULL, 144012),
(144013, '3.20.20.100-FF-000206', NULL, 'Os05g0456200 protein', 54, NULL, NULL, 144013),
(144014, '1.25.40.10-FF-000019', NULL, 'UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase 110 kDa subunit', 387, NULL, NULL, 144014),
(144015, '3.40.50.1820-FF-000065', NULL, 'Phospholipase A1-II 3', 391, NULL, NULL, 144015),
(144016, '2.60.40.10-FF-002049', NULL, 'Mesocentin', 118, NULL, NULL, 144016),
(144017, '3.30.2350.10-FF-000014', NULL, 'PUS4p Pseudouridine synthase', 263, NULL, NULL, 144017),
(144018, '3.30.450.40-FF-000289', NULL, 'Phosphodiesterase', 54, NULL, NULL, 144018),
(144019, '3.30.230.10-FF-000415', NULL, 'DNA mismatch repair protein pms1', 119, NULL, NULL, 144019),
(144020, '1.20.58.80-FF-000086', NULL, 'Protein CBR-XPC-1', 153, NULL, NULL, 144020),
(144021, '3.40.30.10-FF-001007', NULL, 'Glutaredoxin NrdH', 68, NULL, NULL, 144021),
(144022, '2.30.42.10-FF-000273', NULL, 'Par-3 family cell polarity regulator', 72, NULL, NULL, 144022),
(144023, '3.40.50.1820-FF-000155', NULL, 'Carboxylic ester hydrolase', 549, NULL, NULL, 144023),
(144024, '2.40.160.210-FF-000018', NULL, 'Acyl-CoA thioesterase (AFU_orthologue AFUA_1G12060)', 318, NULL, NULL, 144024),
(144025, '2.130.10.10-FF-005579', NULL, 'Mitogen-activated protein kinase kinase kinase A', 207, NULL, NULL, 144025),
(144026, '1.20.5.340-FF-000089', NULL, 'Myosin-2 heavy chain', 99, NULL, NULL, 144026),
(144027, '1.20.1250.20-FF-000125', NULL, 'Sugar efflux transporter SetB', 187, NULL, NULL, 144027),
(144028, '2.30.180.10-FF-000128', NULL, NULL, 134, NULL, NULL, 144028),
(144029, '3.90.25.10-FF-000043', NULL, 'Tissue-specific transplantation antigen P35B', 41, NULL, NULL, 144029),
(144030, '2.30.130.40-FF-000016', NULL, 'ATP-dependent protease La (LON) domain-containing protein-like', 114, NULL, NULL, 144030),
(144031, '3.90.79.10-FF-000252', NULL, 'Uncharacterized protein', 144, NULL, NULL, 144031),
(144032, '3.40.50.150-FF-001425', NULL, NULL, 154, NULL, NULL, 144032),
(144033, '2.40.10.10-FF-000289', NULL, NULL, 56, NULL, NULL, 144033),
(144034, '2.40.50.140-FF-000673', NULL, 'Replication protein A, subunit RPA32', 137, NULL, NULL, 144034);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(144035, '3.40.50.720-FF-001967', NULL, 'Uncharacterized protein', 255, NULL, NULL, 144035),
(144036, '3.40.50.300-FF-003432', NULL, 'ATP-dependent DNA helicase RecQ', 140, NULL, NULL, 144036),
(144037, '2.60.40.150-FF-000776', NULL, 'Uncharacterized protein', 105, NULL, NULL, 144037),
(144038, '1.25.10.10-FF-002288', NULL, 'Uncharacterized protein', 327, NULL, NULL, 144038),
(144039, '3.40.449.10-FF-000005', NULL, 'Phosphoenolpyruvate carboxykinase [GTP]', 206, NULL, NULL, 144039),
(144040, '3.40.50.1980-FF-000124', NULL, 'Iron(III) dicitrate-binding periplasmic protein', 185, NULL, NULL, 144040),
(144041, '4.10.410.10-FF-000099', NULL, 'Collagen type XXVIII alpha 1 chain', 94, NULL, NULL, 144041),
(144042, '3.30.70.2510-FF-000005', NULL, NULL, 126, NULL, NULL, 144042),
(144043, '3.10.100.10-FF-000242', NULL, NULL, 141, NULL, NULL, 144043),
(144044, '2.60.40.10-FF-003033', NULL, 'Carcinoembryonic antigen-related cell adhesion molecule', 102, NULL, NULL, 144044),
(144045, '1.10.8.10-FF-000269', NULL, 'Unc-23', 52, NULL, NULL, 144045),
(144046, '1.10.506.10-FF-000029', NULL, 'probable Ras GTPase-activating protein isoform X2', 122, NULL, NULL, 144046),
(144047, '3.30.70.330-FF-001587', NULL, NULL, 159, NULL, NULL, 144047),
(144048, '3.30.870.10-FF-000093', NULL, 'Phospholipase D C', 191, NULL, NULL, 144048),
(144049, '1.50.10.20-FF-000136', NULL, 'Dammarenediol II synthase', 162, NULL, NULL, 144049),
(144050, '3.30.160.60-FF-004556', NULL, NULL, 27, NULL, NULL, 144050),
(144051, '3.30.428.10-FF-000004', NULL, 'aprataxin isoform X2', 178, NULL, NULL, 144051),
(144052, '1.10.1040.10-FF-000030', NULL, 'Ketol-acid reductoisomerase (NADP(+))', 60, NULL, NULL, 144052),
(144053, '2.130.10.10-FF-004562', NULL, 'Uncharacterized protein', 215, NULL, NULL, 144053),
(144054, '2.60.40.1180-FF-000178', NULL, 'O-GlcNAcase BT_4395', 124, NULL, NULL, 144054),
(144055, '3.30.830.10-FF-000113', NULL, 'Peptidase, insulinase family', 178, NULL, NULL, 144055),
(144056, '3.50.50.100-FF-000037', NULL, 'Uncharacterized protein', 402, NULL, NULL, 144056),
(144057, '3.30.310.50-FF-000018', NULL, 'Phosphoglucomutase/phosphomannomutase family protein', 78, NULL, NULL, 144057),
(144058, '1.10.287.1770-FF-000003', NULL, 'Ferrous iron transport protein B', 101, NULL, NULL, 144058),
(144059, '2.60.40.60-FF-000804', NULL, 'Si:ch211-186j3.6', 116, NULL, NULL, 144059),
(144060, '1.20.1070.10-FF-001154', NULL, 'C-X-C chemokine receptor type 1', 344, NULL, NULL, 144060),
(144061, '3.30.390.50-FF-000034', NULL, 'AGAP006221-PA', 42, NULL, NULL, 144061),
(144062, '3.30.830.10-FF-000057', NULL, 'Pitrilysin-like metalloprotease', 260, NULL, NULL, 144062),
(144063, '3.40.190.10-FF-000600', NULL, 'Uncharacterized protein', 38, NULL, NULL, 144063),
(144064, '1.10.10.60-FF-000419', NULL, 'Homeobox protein Hox-D4', 70, NULL, NULL, 144064),
(144065, '3.90.180.10-FF-000015', NULL, 'Fatty acid synthase', 359, NULL, NULL, 144065),
(144066, '1.20.58.1040-FF-000022', NULL, '1,3-beta-glucanosyltransferase', 116, NULL, NULL, 144066),
(144067, '1.20.81.30-FF-000001', NULL, 'Type II secretion system protein F', 116, NULL, NULL, 144067),
(144068, '2.60.40.790-FF-000086', NULL, 'CG9617', 92, NULL, NULL, 144068),
(144069, '2.30.29.30-FF-000113', NULL, 'FYVE, RhoGEF and PH domain-containing protein 4', 135, NULL, NULL, 144069),
(144070, '3.40.366.10-FF-000003', NULL, 'Fatty acid synthase subunit beta dehydratase', 53, NULL, NULL, 144070),
(144071, '1.25.40.10-FF-004353', NULL, 'Peptidylprolyl isomerase', 41, NULL, NULL, 144071),
(144072, '3.30.160.60-FF-006208', NULL, NULL, 30, NULL, NULL, 144072),
(144073, '3.30.43.10-FF-000020', NULL, 'FAD-binding oxidoreductase', 92, NULL, NULL, 144073),
(144074, '3.40.50.1240-FF-000133', NULL, NULL, 209, NULL, NULL, 144074),
(144075, '1.25.40.20-FF-000556', NULL, 'Protein fem-1 homolog CG6966', 219, NULL, NULL, 144075),
(144076, '1.20.1560.10-FF-000224', NULL, 'ABC transporter ABCC.6, putative', 334, NULL, NULL, 144076),
(144077, '1.20.1070.10-FF-000052', NULL, 'Adhesion G-protein coupled receptor G6', 298, NULL, NULL, 144077);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(144078, '2.120.10.30-FF-000055', NULL, 'Protein STRICTOSIDINE SYNTHASE-LIKE 11', 314, NULL, NULL, 144078),
(144079, '1.20.120.910-FF-000006', NULL, 'Conjugal transfer protein TraR', 63, NULL, NULL, 144079),
(144080, '3.40.50.1000-FF-000443', NULL, 'Trehalose 6-phosphate phosphatase RA3', 138, NULL, NULL, 144080),
(144081, '1.50.10.130-FF-000017', NULL, NULL, 12, NULL, NULL, 144081),
(144082, '1.10.357.50-FF-000003', NULL, 'Exocyst complex component SEC6', 170, NULL, NULL, 144082),
(144083, '1.25.40.10-FF-000553', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 188, NULL, NULL, 144083),
(144084, '3.30.310.10-FF-000057', NULL, 'Uncharacterized protein', 48, NULL, NULL, 144084),
(144085, '3.40.50.670-FF-000002', NULL, 'DNA gyrase subunit B', 251, NULL, NULL, 144085),
(144086, '3.30.740.10-FF-000027', NULL, NULL, 70, NULL, NULL, 144086),
(144087, '1.20.1110.10-FF-000197', NULL, NULL, 130, NULL, NULL, 144087),
(144088, '1.25.40.10-FF-002262', NULL, 'TPR repeat-containing protein ZIP4', 283, NULL, NULL, 144088),
(144089, '3.90.1150.10-FF-000322', NULL, 'Serine hydroxymethyltransferase', 164, NULL, NULL, 144089),
(144090, '3.30.70.370-FF-000031', NULL, NULL, 16, NULL, NULL, 144090),
(144091, '3.90.105.10-FF-000027', NULL, 'Molybdenum cofactor biosynthesis protein MoeA2', 56, NULL, NULL, 144091),
(144092, '3.40.50.2000-FF-000226', NULL, 'Glycosyltransferase', 259, NULL, NULL, 144092),
(144093, '3.40.50.150-FF-001858', NULL, NULL, 349, NULL, NULL, 144093),
(144094, '3.30.40.10-FF-000721', NULL, 'Os12g0527800 protein', 48, NULL, NULL, 144094),
(144095, '1.25.10.10-FF-000669', NULL, 'Armadillo repeat-containing protein 6', 167, NULL, NULL, 144095),
(144096, '2.60.40.10-FF-006091', NULL, NULL, 129, NULL, NULL, 144096),
(144097, '2.30.42.10-FF-000037', NULL, 'Periplasmic serine endoprotease DegP-like', 102, NULL, NULL, 144097),
(144098, '3.10.290.70-FF-000020', NULL, NULL, 55, NULL, NULL, 144098),
(144099, '1.20.5.30-FF-000004', NULL, 'Matrilin 3', 42, NULL, NULL, 144099),
(144100, '1.20.120.900-FF-000003', NULL, 'Peroxisomal membrane protein import receptor PEX19', 113, NULL, NULL, 144100),
(144101, '2.70.170.10-FF-000304', NULL, 'Uncharacterized protein', 94, NULL, NULL, 144101),
(144102, '3.40.50.300-FF-002179', NULL, 'ATP-dependent DNA helicase Q1', 212, NULL, NULL, 144102),
(144103, '1.10.1030.10-FF-000001', NULL, 'Carbamoyl-phosphate synthase large chain', 145, NULL, NULL, 144103),
(144104, '3.20.20.70-FF-000295', NULL, 'Deoxyribose-phosphate aldolase', 222, NULL, NULL, 144104),
(144105, '3.80.10.10-FF-003477', NULL, 'Chromosome 7, whole genome shotgun sequence', 207, NULL, NULL, 144105),
(144106, '1.25.10.10-FF-003221', NULL, 'Protein zyg-11 homolog A', 263, NULL, NULL, 144106),
(144107, '3.30.420.80-FF-000007', NULL, '30S ribosomal protein S11', 132, NULL, NULL, 144107),
(144108, '2.60.40.150-FF-000158', NULL, 'extended synaptotagmin-2 isoform X4', 144, NULL, NULL, 144108),
(144109, '3.30.70.330-FF-000805', NULL, 'Flowering time control protein FPA', 102, NULL, NULL, 144109),
(144110, '1.10.10.10-FF-001124', NULL, 'Two-component response regulator', 110, NULL, NULL, 144110),
(144111, '3.40.366.10-FF-000060', NULL, 'Predicted protein', 104, NULL, NULL, 144111),
(144112, '3.50.4.10-FF-000048', NULL, NULL, 86, NULL, NULL, 144112),
(144113, '3.10.50.10-FF-000026', NULL, 'AGAP005337-PA', 77, NULL, NULL, 144113),
(144114, '1.20.1060.10-FF-000023', NULL, 'Predicted protein', 45, NULL, NULL, 144114),
(144115, '2.60.120.200-FF-000300', NULL, 'Terribly reduced optic lobes, isoform B', 178, NULL, NULL, 144115),
(144116, '1.25.40.10-FF-000025', NULL, 'Unc-45 myosin chaperone B', 127, NULL, NULL, 144116),
(144117, '1.20.120.1380-FF-000002', NULL, 'Flagellar biosynthesis regulator FlhF', 15, NULL, NULL, 144117),
(144118, '1.10.287.110-FF-000263', NULL, 'Chaperone DnaJ-domain superfamily protein', 97, NULL, NULL, 144118),
(144119, '3.30.450.20-FF-000603', NULL, 'voltage-dependent calcium channel subunit alpha-2/delta-1', 138, NULL, NULL, 144119),
(144120, '1.20.1060.20-FF-000026', NULL, NULL, 72, NULL, NULL, 144120);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(144121, '3.40.50.2300-FF-000198', NULL, 'D-allose-binding periplasmic protein (ALBP)', 139, NULL, NULL, 144121),
(144122, '1.25.40.10-FF-000497', NULL, 'Tetratricopeptide repeat domain 37', 279, NULL, NULL, 144122),
(144123, '3.30.70.330-FF-001593', NULL, NULL, 130, NULL, NULL, 144123),
(144124, '2.130.10.10-FF-005809', NULL, 'Intraflagellar transport protein 140 homolog-like Protein', 398, NULL, NULL, 144124),
(144125, '2.60.40.10-FF-002493', NULL, 'T cell receptor alpha variable 29/delta variable 5 (gene/pseudogene)', 104, NULL, NULL, 144125),
(144126, '1.20.5.20-FF-000001', NULL, 'apolipoprotein A-I', 45, NULL, NULL, 144126),
(144127, '1.10.533.10-FF-000199', NULL, 'Uncharacterized protein', 87, NULL, NULL, 144127),
(144128, '1.10.274.100-FF-000014', NULL, 'DNA-directed RNA polymerase subunit', 167, NULL, NULL, 144128),
(144129, '2.130.10.10-FF-004505', NULL, 'Uncharacterized protein', 238, NULL, NULL, 144129),
(144130, '2.40.70.10-FF-000208', NULL, 'Plasmepsin VI', 165, NULL, NULL, 144130),
(144131, '3.80.10.10-FF-004202', NULL, 'Uncharacterized protein', 89, NULL, NULL, 144131),
(144132, '3.40.390.10-FF-000166', NULL, NULL, 63, NULL, NULL, 144132),
(144133, '1.10.533.10-FF-000053', NULL, 'Apoptosis-associated speck-like protein containing a CARD', 90, NULL, NULL, 144133),
(144134, '1.10.275.40-FF-000012', NULL, 'Helicase, putative', 50, NULL, NULL, 144134),
(144135, '2.60.40.10-FF-002869', NULL, 'Platelet-derived growth factor receptor, beta polypeptide', 96, NULL, NULL, 144135),
(144136, '3.30.70.580-FF-000009', NULL, 'Pseudouridine synthase', 83, NULL, NULL, 144136),
(144137, '3.90.1150.10-FF-000361', NULL, 'DegT/DnrJ/EryC1/StrS family aminotransferase', 119, NULL, NULL, 144137),
(144138, '2.40.170.20-FF-000078', NULL, 'TonB-dependent siderophore receptor', 543, NULL, NULL, 144138),
(144139, '3.30.460.10-FF-000101', NULL, 'DUF455 domain-containing protein', 148, NULL, NULL, 144139),
(144140, '2.120.10.30-FF-000583', NULL, 'Predicted protein', 138, NULL, NULL, 144140),
(144141, '3.40.50.10260-FF-000033', NULL, 'Uncharacterized protein', 257, NULL, NULL, 144141),
(144142, '3.40.50.12780-FF-000053', NULL, 'Fatty-acid--CoA ligase', 430, NULL, NULL, 144142),
(144143, '3.30.200.20-FF-002215', NULL, NULL, 42, NULL, NULL, 144143),
(144144, '2.60.40.150-FF-000692', NULL, 'Predicted protein', 159, NULL, NULL, 144144),
(144145, '2.60.40.10-FF-001886', NULL, 'FiLamiN (Actin binding protein) homolog', 100, NULL, NULL, 144145),
(144146, '3.30.160.60-FF-000756', NULL, 'C2H2 transcription factor RfeC', 27, NULL, NULL, 144146),
(144147, '3.30.565.10-FF-000069', NULL, 'Probable histidine kinase 1', 183, NULL, NULL, 144147),
(144148, '3.40.50.300-FF-001723', NULL, 'Guanine nucleotide-binding protein G(f) subunit alpha', 226, NULL, NULL, 144148),
(144149, '3.40.50.1000-FF-000819', NULL, NULL, 103, NULL, NULL, 144149),
(144150, '1.10.472.10-FF-000118', NULL, 'Cyclin g', 107, NULL, NULL, 144150),
(144151, '2.170.140.10-FF-000025', NULL, 'peritrophin-1', 65, NULL, NULL, 144151),
(144152, '1.20.1250.20-FF-001199', NULL, 'Predicted protein', 182, NULL, NULL, 144152),
(144153, '2.40.30.10-FF-000088', NULL, 'Translation elongation factor EF-1, subunit alpha', 109, NULL, NULL, 144153),
(144154, '1.10.472.10-FF-000175', NULL, 'Uncharacterized protein', 136, NULL, NULL, 144154),
(144155, '2.30.30.40-FF-000507', NULL, 'Predicted protein', 54, NULL, NULL, 144155),
(144156, '3.30.70.1040-FF-000002', NULL, 'Dystroglycan, isoform B', 143, NULL, NULL, 144156),
(144157, '3.40.50.10420-FF-000008', NULL, 'Uncharacterized protein', 147, NULL, NULL, 144157),
(144158, '2.160.10.10-FF-000126', NULL, 'Serine acetyltransferase', 107, NULL, NULL, 144158),
(144159, '3.40.50.300-FF-007232', NULL, 'RAS-related protein, putative', 161, NULL, NULL, 144159),
(144160, '3.40.50.150-FF-000077', NULL, 'HemK methyltransferase family member 2', 200, NULL, NULL, 144160),
(144161, '1.25.10.10-FF-000725', NULL, 'Tubulin folding cofactor D', 335, NULL, NULL, 144161),
(144162, '1.20.1050.10-FF-000051', NULL, 'Glutathione S-transferase', 123, NULL, NULL, 144162);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(144163, '2.130.10.10-FF-002471', NULL, 'WD-40 protein, putative', 295, NULL, NULL, 144163),
(144164, '3.30.70.2170-FF-000004', NULL, 'V-type ATP synthase subunit I', 60, NULL, NULL, 144164),
(144165, '3.30.70.560-FF-000003', NULL, 'Folate synthesis bifunctional protein', 150, NULL, NULL, 144165),
(144166, '3.30.40.10-FF-001177', NULL, 'RING-H2 finger protein ATL60', 86, NULL, NULL, 144166),
(144167, '1.10.418.40-FF-000024', NULL, 'Uncharacterized protein', 211, NULL, NULL, 144167),
(144168, '2.20.28.10-FF-000038', NULL, 'DNA helicase', 60, NULL, NULL, 144168),
(144169, '1.10.10.10-FF-001978', NULL, 'Interferon regulatory factor 9', 59, NULL, NULL, 144169),
(144170, '3.40.50.720-FF-000242', NULL, 'Glutamate dehydrogenase', 154, NULL, NULL, 144170),
(144171, '1.10.238.10-FF-000771', NULL, 'Uncharacterized protein', 101, NULL, NULL, 144171),
(144172, '3.30.70.1050-FF-000005', NULL, 'Trigger factor', 110, NULL, NULL, 144172),
(144173, '3.40.30.10-FF-001120', NULL, 'CEBPA: CCAAT/enhancer-binding protein alpha, putative', 136, NULL, NULL, 144173),
(144174, '1.10.238.10-FF-000619', NULL, 'Uncharacterized protein', 89, NULL, NULL, 144174),
(144175, '1.25.10.10-FF-002434', NULL, 'Uncharacterized protein', 240, NULL, NULL, 144175),
(144176, '1.25.40.10-FF-003987', NULL, 'AimR transcriptional regulator', 216, NULL, NULL, 144176),
(144177, '2.60.120.10-FF-000438', NULL, 'Predicted protein', 70, NULL, NULL, 144177),
(144178, '3.30.540.10-FF-000102', NULL, 'Uncharacterized protein', 62, NULL, NULL, 144178),
(144179, '1.25.40.10-FF-004151', NULL, 'Uncharacterized protein', 111, NULL, NULL, 144179),
(144180, '1.10.357.140-FF-000024', NULL, 'Uncharacterized protein B19A17.050', 95, NULL, NULL, 144180),
(144181, '3.30.540.10-FF-000046', NULL, 'Inositol monophosphatase family protein', 181, NULL, NULL, 144181),
(144182, '1.20.120.1900-FF-000046', NULL, 'Chromosome 15, whole genome shotgun sequence', 421, NULL, NULL, 144182),
(144183, '3.30.1640.10-FF-000058', NULL, 'DNA helicase', 95, NULL, NULL, 144183),
(144184, '3.30.56.10-FF-000027', NULL, 'Phenylalanine--tRNA ligase beta subunit', 76, NULL, NULL, 144184),
(144185, '2.70.98.10-FF-000057', NULL, 'Aldose 1-epimerase', 261, NULL, NULL, 144185),
(144186, '1.10.1630.10-FF-000002', NULL, 'Uncharacterized protein, isoform C', 49, NULL, NULL, 144186),
(144187, '3.30.160.60-FF-004180', NULL, NULL, 24, NULL, NULL, 144187),
(144188, '3.30.70.580-FF-000066', NULL, 'tRNA pseudouridine synthase', 80, NULL, NULL, 144188),
(144189, '3.30.230.70-FF-000118', NULL, 'Predicted protein', 240, NULL, NULL, 144189),
(144190, '3.40.50.300-FF-003106', NULL, 'AAA family ATPase', 171, NULL, NULL, 144190),
(144191, '3.90.1030.20-FF-000001', NULL, 'DNA polymerase delta 3, accessory subunit', 144, NULL, NULL, 144191),
(144192, '3.40.1090.10-FF-000058', NULL, 'Uncharacterized protein', 111, NULL, NULL, 144192),
(144193, '3.40.50.2300-FF-000434', NULL, 'CELF35-1', 255, NULL, NULL, 144193),
(144194, '3.10.20.90-FF-000711', NULL, 'Uncharacterized protein', 111, NULL, NULL, 144194),
(144195, '6.10.250.3320-FF-000001', NULL, 'neuroendocrine convertase 1', 45, NULL, NULL, 144195),
(144196, '2.40.10.10-FF-000087', NULL, 'Kallikrein 8 (Neuropsin/ovasin)', 101, NULL, NULL, 144196),
(144197, '1.50.10.20-FF-000052', NULL, 'Ent-kaurene synthase', 295, NULL, NULL, 144197),
(144198, '3.30.230.10-FF-000056', NULL, 'GAL1p Galactokinase', 242, NULL, NULL, 144198),
(144199, '2.130.10.10-FF-002319', NULL, 'WD repeat-containing protein 63', 283, NULL, NULL, 144199),
(144200, '2.40.10.10-FF-000558', NULL, NULL, 72, NULL, NULL, 144200),
(144201, '3.30.40.10-FF-000250', NULL, 'E3 ubiquitin-protein ligase MIB2 isoform X2', 56, NULL, NULL, 144201),
(144202, '3.90.1150.10-FF-000029', NULL, '5-aminolevulinate synthase', 108, NULL, NULL, 144202),
(144203, '3.40.50.1820-FF-000301', NULL, 'Related to triacylglycerol lipase', 351, NULL, NULL, 144203),
(144204, '2.130.10.10-FF-002673', NULL, 'Nuclear Pore complex Protein', 329, NULL, NULL, 144204),
(144205, '1.10.630.10-FF-000756', NULL, 'Cytochrome P450, family 2, subfamily j, polypeptide 12', 46, NULL, NULL, 144205);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(144206, '3.40.720.10-FF-000378', NULL, 'Acid phosphatase', 179, NULL, NULL, 144206),
(144207, '2.60.40.60-FF-000861', NULL, 'Uncharacterized protein', 109, NULL, NULL, 144207),
(144208, '2.40.50.140-FF-001275', NULL, NULL, 154, NULL, NULL, 144208),
(144209, '1.10.287.70-FF-000312', NULL, 'Channel voltage-gated Shaker protein Potassium', 55, NULL, NULL, 144209),
(144210, '2.60.260.20-FF-000007', NULL, 'dnaJ homolog subfamily B member 5', 97, NULL, NULL, 144210),
(144211, '3.60.15.10-FF-000139', NULL, 'Ribonuclease Z', 299, NULL, NULL, 144211),
(144212, '3.40.390.10-FF-000020', NULL, 'Stromelysin-3 preproprotein', 196, NULL, NULL, 144212),
(144213, '3.40.50.1000-FF-000589', NULL, NULL, 67, NULL, NULL, 144213),
(144214, '2.40.50.140-FF-000347', NULL, 'Proteasome regulatory ATPase subunit 5', 84, NULL, NULL, 144214),
(144215, '1.20.120.1910-FF-000049', NULL, 'Uncharacterized protein', 197, NULL, NULL, 144215),
(144216, '3.30.200.20-FF-001400', NULL, 'Uncharacterized protein', 101, NULL, NULL, 144216),
(144217, '2.60.120.650-FF-000025', NULL, 'Lysine-specific demethylase 8', 228, NULL, NULL, 144217),
(144218, '3.80.10.10-FF-000043', NULL, 'Leucine-rich repeat transmembrane protein FLRT3', 331, NULL, NULL, 144218),
(144219, '3.40.630.10-FF-000264', NULL, 'Peptide hydrolase', 379, NULL, NULL, 144219),
(144220, '1.20.1260.80-FF-000003', NULL, 'Uncharacterized protein', 179, NULL, NULL, 144220),
(144221, '3.90.550.10-FF-000499', NULL, 'Putative alpha-1,3-mannosyltransferase MNN14', 274, NULL, NULL, 144221),
(144222, '2.40.30.10-FF-000470', NULL, 'Uncharacterized protein', 73, NULL, NULL, 144222),
(144223, '1.25.40.10-FF-002149', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 93, NULL, NULL, 144223),
(144224, '2.170.270.10-FF-000119', NULL, 'Histone-lysine N-methyltransferase', 55, NULL, NULL, 144224),
(144225, '3.40.50.280-FF-000008', NULL, 'Methionine synthase (MetH)', 153, NULL, NULL, 144225),
(144226, '3.30.420.40-FF-000933', NULL, 'Heat shock protein, Hsp70 family', 94, NULL, NULL, 144226),
(144227, '2.10.110.10-FF-000196', NULL, 'Paxillin', 57, NULL, NULL, 144227),
(144228, '1.20.1600.10-FF-000009', NULL, 'Multidrug resistance outer membrane protein MdtQ', 326, NULL, NULL, 144228),
(144229, '3.40.30.10-FF-001209', NULL, 'Uncharacterized protein', 46, NULL, NULL, 144229),
(144230, '1.20.1440.340-FF-000016', NULL, 'Uncharacterized protein', 13, NULL, NULL, 144230),
(144231, '3.90.260.10-FF-000016', NULL, 'DNA repair protein RAD4', 251, NULL, NULL, 144231),
(144232, '2.40.70.10-FF-000360', NULL, NULL, 129, NULL, NULL, 144232),
(144233, '1.20.58.390-FF-000317', NULL, 'Uncharacterized protein', 77, NULL, NULL, 144233),
(144234, '3.40.50.300-FF-004742', NULL, 'ABC transporter, putative', 233, NULL, NULL, 144234),
(144235, '2.60.40.3440-FF-000002', NULL, 'Probable exported protein', 92, NULL, NULL, 144235),
(144236, '1.25.40.10-FF-003133', NULL, 'Uncharacterized protein', 91, NULL, NULL, 144236),
(144237, '2.60.120.620-FF-000067', NULL, 'Uncharacterized PKHD-type hydroxylase At1g22950', 181, NULL, NULL, 144237),
(144238, '3.30.230.70-FF-000175', NULL, 'Uncharacterized protein', 64, NULL, NULL, 144238),
(144239, '3.30.200.20-FF-000563', NULL, 'Protein kinase C', 27, NULL, NULL, 144239),
(144240, '3.30.200.20-FF-002182', NULL, 'Uncharacterized protein', 57, NULL, NULL, 144240),
(144241, '3.10.28.10-FF-000053', NULL, 'DNA topoisomerase 1', 220, NULL, NULL, 144241),
(144242, '2.10.25.10-FF-000032', NULL, 'signal peptide, CUB and EGF-like domain-containing protein 2 isoform X1', 42, NULL, NULL, 144242),
(144243, '2.10.110.10-FF-000050', NULL, 'Four and a half LIM domains protein 1', 61, NULL, NULL, 144243),
(144244, '3.30.160.60-FF-002465', NULL, 'paternally-expressed gene 3 protein isoform X1', 32, NULL, NULL, 144244),
(144245, '1.25.40.370-FF-000004', NULL, 'Apaf-1 related killer DARK', 149, NULL, NULL, 144245),
(144246, '2.20.130.20-FF-000001', NULL, 'Complement C3', 79, NULL, NULL, 144246),
(144247, '2.30.29.30-FF-001097', NULL, 'Os08g0404400 protein', 35, NULL, NULL, 144247),
(144248, '3.30.160.270-FF-000009', NULL, '2-isopropylmalate synthase, putative', 159, NULL, NULL, 144248);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(144249, '3.90.226.10-FF-000027', NULL, 'Probable 3-hydroxyisobutyryl-CoA hydrolase 2', 365, NULL, NULL, 144249),
(144250, '3.30.760.10-FF-000028', NULL, 'Eukaryotic translation initiation factor 4E type', 211, NULL, NULL, 144250),
(144251, '1.20.1520.10-FF-000008', NULL, 'Predicted protein', 55, NULL, NULL, 144251),
(144252, '3.40.50.620-FF-000302', NULL, 'tRNA-specific 2-thiouridylase MnmA', 214, NULL, NULL, 144252),
(144253, '3.40.50.300-FF-002651', NULL, 'RNA helicase', 279, NULL, NULL, 144253),
(144254, '1.10.10.10-FF-000719', NULL, 'RNA polymerase sigma factor SigX', 88, NULL, NULL, 144254),
(144255, '1.10.10.10-FF-000399', NULL, 'AsnC family transcriptional regulator', 51, NULL, NULL, 144255),
(144256, '1.25.40.420-FF-000042', NULL, 'Protein CBR-BATH-43', 82, NULL, NULL, 144256),
(144257, '1.20.140.150-FF-000125', NULL, 'Uncharacterized protein', 103, NULL, NULL, 144257),
(144258, '3.30.160.60-FF-005899', NULL, NULL, 25, NULL, NULL, 144258),
(144259, '3.40.309.10-FF-000118', NULL, 'Uncharacterized protein', 222, NULL, NULL, 144259),
(144260, '3.10.100.10-FF-000096', NULL, 'C-type lectin domain family 2 member B', 129, NULL, NULL, 144260),
(144261, '3.30.310.40-FF-000015', NULL, 'Uncharacterized protein', 74, NULL, NULL, 144261),
(144262, '3.30.300.130-FF-000023', NULL, 'Fe-S cluster assembly protein NifU, putative', 93, NULL, NULL, 144262),
(144263, '1.50.40.10-FF-000517', NULL, 'Mitochondrial carrier protein', 187, NULL, NULL, 144263),
(144264, '3.10.20.90-FF-000239', NULL, 'Small ubiquitin-related modifier 1', 99, NULL, NULL, 144264),
(144265, '3.30.450.270-FF-000002', NULL, 'Sensor histidine kinase/response regulator, putative', 184, NULL, NULL, 144265),
(144266, '3.40.120.10-FF-000091', NULL, 'Phosphoglucomutase/phosphomannomutase family protein', 172, NULL, NULL, 144266),
(144267, '1.20.1250.20-FF-001816', NULL, 'Glr0912 protein', 155, NULL, NULL, 144267),
(144268, '2.60.260.20-FF-000064', NULL, 'DNAJ domain-containing protein Mas5', 98, NULL, NULL, 144268),
(144269, '2.60.120.260-FF-000234', NULL, 'Proprotein convertase subtilisin/kexin type 2', 105, NULL, NULL, 144269),
(144270, '3.30.70.330-FF-002374', NULL, NULL, 102, NULL, NULL, 144270),
(144271, '2.60.40.10-FF-001234', NULL, 'Colony stimulating factor 3 receptor', 95, NULL, NULL, 144271),
(144272, '2.40.10.10-FF-000704', NULL, NULL, 78, NULL, NULL, 144272),
(144273, '3.90.70.10-FF-000529', NULL, 'Putative ubiquitin hydrolase', 301, NULL, NULL, 144273),
(144274, '2.40.50.770-FF-000013', NULL, 'Uncharacterized protein', 140, NULL, NULL, 144274),
(144275, '3.90.740.10-FF-000042', NULL, 'Valine--tRNA ligase', 83, NULL, NULL, 144275),
(144276, '1.10.3720.10-FF-000094', NULL, 'Ectoine/hydroxyectoine ABC transporter permease subunit EhuC', 211, NULL, NULL, 144276),
(144277, '3.30.160.60-FF-001009', NULL, 'Zinc finger protein 26', 28, NULL, NULL, 144277),
(144278, '2.60.40.10-FF-000958', NULL, 'Interleukin-13 receptor subunit alpha-2', 94, NULL, NULL, 144278),
(144279, '3.30.420.40-FF-000462', NULL, 'Uncharacterized protein', 135, NULL, NULL, 144279),
(144280, '3.10.450.10-FF-000083', NULL, 'Kininogen 2', 90, NULL, NULL, 144280),
(144281, '3.30.360.10-FF-000099', NULL, 'Predicted protein', 143, NULL, NULL, 144281),
(144282, '1.25.40.10-FF-003897', NULL, 'Os12g0256900 protein', 74, NULL, NULL, 144282),
(144283, '3.30.497.10-FF-000079', NULL, 'Serine protease inhibitor (serpin) 4', 98, NULL, NULL, 144283),
(144284, '1.10.510.10-FF-000871', NULL, 'Protein kinase', 196, NULL, NULL, 144284),
(144285, '3.40.50.300-FF-000796', NULL, 'Cytosolic Fe-S cluster assembly factor NUBP2', 258, NULL, NULL, 144285),
(144286, '3.30.70.60-FF-000007', NULL, '37S ribosomal protein Mrp17', 115, NULL, NULL, 144286),
(144287, '1.20.120.730-FF-000020', NULL, 'Protein transport protein SEC23', 125, NULL, NULL, 144287),
(144288, '3.40.50.300-FF-006451', NULL, 'Uncharacterized protein', 123, NULL, NULL, 144288),
(144289, '3.30.40.10-FF-002104', NULL, 'Mst2 complex subunit nto1', 119, NULL, NULL, 144289),
(144290, '1.10.472.10-FF-000208', NULL, 'Cyclin', 125, NULL, NULL, 144290);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(144291, '2.40.50.140-FF-000201', NULL, 'TRM2p tRNA methyltransferase', 82, NULL, NULL, 144291),
(144292, '1.10.510.10-FF-000629', NULL, 'Protein kinase domain containing protein', 303, NULL, NULL, 144292),
(144293, '3.40.640.10-FF-000091', NULL, 'Diaminobutyrate--2-oxoglutarate aminotransferase', 270, NULL, NULL, 144293),
(144294, '3.40.50.150-FF-000695', NULL, 'Methyltransferase', 232, NULL, NULL, 144294),
(144295, '3.40.50.970-FF-000210', NULL, 'Uncharacterized protein', 184, NULL, NULL, 144295),
(144296, '1.25.40.20-FF-001337', NULL, 'Uncharacterized protein', 122, NULL, NULL, 144296),
(144297, '3.30.559.70-FF-000005', NULL, 'Carnitine O-palmitoyltransferase 2, mitochondrial', 270, NULL, NULL, 144297),
(144298, '2.60.40.10-FF-003797', NULL, NULL, 83, NULL, NULL, 144298),
(144299, '3.40.50.300-FF-004539', NULL, 'AAA family ATPase peroxin 1', 172, NULL, NULL, 144299),
(144300, '3.40.47.10-FF-000231', NULL, NULL, 83, NULL, NULL, 144300),
(144301, '3.30.1010.10-FF-000090', NULL, 'Uncharacterized protein', 158, NULL, NULL, 144301),
(144302, '1.25.40.10-FF-002442', NULL, 'Pentatricopeptide repeat-containing protein At3g49740', 105, NULL, NULL, 144302),
(144303, '3.40.50.150-FF-000880', NULL, NULL, 68, NULL, NULL, 144303),
(144304, '3.40.50.11320-FF-000003', NULL, 'Carboxypeptidase', 95, NULL, NULL, 144304),
(144305, '3.50.50.60-FF-001276', NULL, 'Predicted protein', 64, NULL, NULL, 144305),
(144306, '3.10.20.90-FF-000857', NULL, 'Uncharacterized protein', 77, NULL, NULL, 144306),
(144307, '1.10.510.10-FF-004468', NULL, NULL, 272, NULL, NULL, 144307),
(144308, '1.25.10.10-FF-000164', NULL, 'Testis-expressed sequence 10 protein', 194, NULL, NULL, 144308),
(144309, '1.25.40.10-FF-002913', NULL, 'Os02g0680500 protein', 186, NULL, NULL, 144309),
(144310, '3.30.2090.10-FF-000010', NULL, 'Transporter, AcrB/D/F family', 91, NULL, NULL, 144310),
(144311, '3.60.21.10-FF-000199', NULL, 'Protein CBG20631', 283, NULL, NULL, 144311),
(144312, '1.10.10.10-FF-000343', NULL, 'Ets at 65A, isoform C', 129, NULL, NULL, 144312),
(144313, '3.40.50.150-FF-000638', NULL, 'tRNA (Cytosine-5-)-methyltransferase, putative', 324, NULL, NULL, 144313),
(144314, '2.60.40.10-FF-004814', NULL, NULL, 94, NULL, NULL, 144314),
(144315, '3.40.50.300-FF-008339', NULL, 'Predicted protein', 246, NULL, NULL, 144315),
(144316, '1.20.1250.20-FF-001963', NULL, 'Uncharacterized protein', 422, NULL, NULL, 144316),
(144317, '3.40.47.10-FF-000028', NULL, '3-ketoacyl-CoA synthase', 370, NULL, NULL, 144317),
(144318, '3.30.1010.10-FF-000033', NULL, 'Putative phosphatidylinositol 3-kinase', 146, NULL, NULL, 144318),
(144319, '3.30.1360.10-FF-000020', NULL, 'RH25219p', 37, NULL, NULL, 144319),
(144320, '1.10.510.10-FF-002580', NULL, NULL, 231, NULL, NULL, 144320),
(144321, '3.40.50.300-FF-001015', NULL, 'ADP-ribosylation factor-like protein 8B', 180, NULL, NULL, 144321),
(144322, '2.30.30.40-FF-000187', NULL, 'Neutrophil cytosolic factor 2', 62, NULL, NULL, 144322),
(144323, '1.10.510.10-FF-002670', NULL, NULL, 82, NULL, NULL, 144323),
(144324, '3.30.565.10-FF-000215', NULL, 'Sensor protein', 137, NULL, NULL, 144324),
(144325, '3.40.1160.10-FF-000087', NULL, 'Amino-acid acetyltransferase, mitochondrial', 234, NULL, NULL, 144325),
(144326, '1.20.140.150-FF-000069', NULL, 'Uncharacterized protein', 171, NULL, NULL, 144326),
(144327, '2.60.40.10-FF-004904', NULL, NULL, 108, NULL, NULL, 144327),
(144328, '3.30.40.10-FF-001885', NULL, 'Uncharacterized protein', 75, NULL, NULL, 144328),
(144329, '2.110.10.10-FF-000038', NULL, 'Uncharacterized protein', 74, NULL, NULL, 144329),
(144330, '3.40.50.300-FF-004652', NULL, 'DNA helicase', 176, NULL, NULL, 144330),
(144331, '1.20.1530.20-FF-000080', NULL, 'Arsenic oxyanion-translocation pump', 338, NULL, NULL, 144331),
(144332, '2.60.40.790-FF-000119', NULL, 'Sgt1p', 112, NULL, NULL, 144332),
(144333, '3.30.40.10-FF-002161', NULL, 'Structure-specific endonuclease subunit SLX1 homolog', 71, NULL, NULL, 144333),
(144334, '2.30.29.30-FF-000080', NULL, 'Arf-GAP with dual PH domain-containing protein 1', 111, NULL, NULL, 144334);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(144335, '1.20.890.10-FF-000014', NULL, 'Protein dpy-30', 33, NULL, NULL, 144335),
(144336, '3.40.720.10-FF-000001', NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase', 268, NULL, NULL, 144336),
(144337, '3.90.550.10-FF-000735', NULL, 'Os01g0264100 protein', 249, NULL, NULL, 144337),
(144338, '2.40.50.140-FF-000999', NULL, NULL, 115, NULL, NULL, 144338),
(144339, '2.40.50.100-FF-000184', NULL, 'RND family efflux transporter MFP subunit', 34, NULL, NULL, 144339),
(144340, '1.10.510.10-FF-002338', NULL, NULL, 202, NULL, NULL, 144340),
(144341, '3.90.1150.220-FF-000013', NULL, 'Non-structural maintenance of chromosomes element 1 homolog-like Protein', 76, NULL, NULL, 144341),
(144342, '3.30.200.20-FF-002272', NULL, 'Uncharacterized protein', 111, NULL, NULL, 144342),
(144343, '3.90.1180.10-FF-000037', NULL, NULL, 140, NULL, NULL, 144343),
(144344, '3.30.720.200-FF-000010', NULL, 'Glycyl-tRNA synthetase family protein', 46, NULL, NULL, 144344),
(144345, '1.20.1310.10-FF-000094', NULL, 'Cullin-1, putative', 112, NULL, NULL, 144345),
(144346, '1.10.150.280-FF-000005', NULL, 'Kinesin-like protein', 74, NULL, NULL, 144346),
(144347, '1.10.20.10-FF-000169', NULL, 'Histone H4', 98, NULL, NULL, 144347),
(144348, '3.40.50.720-FF-002131', NULL, 'mRNA clone with similarity to L-glycerol-3-phosphate:NAD oxidoreductase and albumin gene sequences', 104, NULL, NULL, 144348),
(144349, '3.30.420.40-FF-000405', NULL, 'ARP1 actin related protein 1 homolog B', 72, NULL, NULL, 144349),
(144350, '3.30.1050.10-FF-000007', NULL, 'SCP-2 family sterol carrier protein', 103, NULL, NULL, 144350),
(144351, '2.120.10.80-FF-000373', NULL, 'Uncharacterized protein', 166, NULL, NULL, 144351),
(144352, '3.30.200.20-FF-000473', NULL, 'Calcium-dependent protein kinase 4', 100, NULL, NULL, 144352),
(144353, '3.40.390.10-FF-000110', NULL, 'Metalloendopeptidase', 251, NULL, NULL, 144353),
(144354, '3.90.1150.210-FF-000010', NULL, 'F-actin-capping protein subunit beta', 180, NULL, NULL, 144354),
(144355, '3.55.50.30-FF-000003', NULL, 'Fe(3+) dicitrate transport protein FecA', 92, NULL, NULL, 144355),
(144356, '1.10.3470.10-FF-000023', NULL, 'Iron ABC transporter permease', 314, NULL, NULL, 144356),
(144357, '2.30.30.940-FF-000006', NULL, 'ATP-dependent RecD-like DNA helicase', 89, NULL, NULL, 144357),
(144358, '2.30.30.210-FF-000024', NULL, 'Ribonuclease P protein subunit', 128, NULL, NULL, 144358),
(144359, '3.40.850.10-FF-000005', NULL, 'Myosin heavy chain', 261, NULL, NULL, 144359),
(144360, '2.70.170.10-FF-000271', NULL, 'Uncharacterized protein', 119, NULL, NULL, 144360),
(144361, '1.25.10.10-FF-000579', NULL, 'Serine/threonine kinase like domain containing 1', 344, NULL, NULL, 144361),
(144362, '3.40.50.300-FF-000942', NULL, 'Ras-related and estrogen-regulated growth inhibitor', 170, NULL, NULL, 144362),
(144363, '3.30.50.10-FF-000076', NULL, 'Similar to transcription factor Zn, GATA', 62, NULL, NULL, 144363),
(144364, '1.10.20.10-FF-000372', NULL, NULL, 62, NULL, NULL, 144364),
(144365, '3.50.50.60-FF-000258', NULL, 'Flavin-binding monooxygenase-like protein (AFU_orthologue AFUA_6G01900)', 247, NULL, NULL, 144365),
(144366, '3.10.20.420-FF-000001', NULL, 'Bypass-of-forespore protein C', 53, NULL, NULL, 144366),
(144367, '1.10.30.10-FF-000198', NULL, 'PHDfinger domain-containing protein', 52, NULL, NULL, 144367),
(144368, '3.10.20.90-FF-000767', NULL, 'Uncharacterized protein', 132, NULL, NULL, 144368),
(144369, '1.10.510.10-FF-000781', NULL, 'Protein kinase dsk1', 91, NULL, NULL, 144369),
(144370, '3.30.70.330-FF-002284', NULL, NULL, 89, NULL, NULL, 144370),
(144371, '3.40.50.300-FF-001072', NULL, 'Rab family GTPase', 196, NULL, NULL, 144371),
(144372, '3.90.70.10-FF-000586', NULL, 'PAN2-like protein', 246, NULL, NULL, 144372),
(144373, '1.20.1250.20-FF-001345', NULL, 'Sialin', 206, NULL, NULL, 144373),
(144374, '3.30.160.60-FF-005051', NULL, NULL, 51, NULL, NULL, 144374),
(144375, '3.40.50.1000-FF-000499', NULL, 'Cleavage and polyadenylation factor 6-related protein', 223, NULL, NULL, 144375),
(144376, '1.25.10.10-FF-000782', NULL, 'ARM repeat superfamily protein', 329, NULL, NULL, 144376);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(144377, '3.40.50.1100-FF-000288', NULL, 'Uncharacterized protein', 135, NULL, NULL, 144377),
(144378, '3.40.50.300-FF-004449', NULL, 'ORC1-type DNA replication protein 2', 183, NULL, NULL, 144378),
(144379, '3.40.47.10-FF-000141', NULL, 'Putative 3-oxoacyl-(Acyl-carrier-protein) synthase III', 336, NULL, NULL, 144379),
(144380, '2.10.25.10-FF-001807', NULL, 'Uncharacterized protein', 81, NULL, NULL, 144380),
(144381, '3.40.50.880-FF-000149', NULL, 'Imidazole glycerol phosphate synthase subunit HisH', 197, NULL, NULL, 144381),
(144382, '2.60.40.790-FF-000176', NULL, NULL, 125, NULL, NULL, 144382),
(144383, '3.30.720.50-FF-000015', NULL, NULL, 84, NULL, NULL, 144383),
(144384, '2.60.120.20-FF-000031', NULL, NULL, 194, NULL, NULL, 144384),
(144385, '3.10.290.10-FF-000019', NULL, '40S ribosomal protein S4', 117, NULL, NULL, 144385),
(144386, '1.10.238.10-FF-001081', NULL, 'DCN1-like protein', 89, NULL, NULL, 144386),
(144387, '2.60.120.260-FF-000324', NULL, 'Glycoside hydrolase family 3 domain protein', 150, NULL, NULL, 144387),
(144388, '3.90.70.10-FF-000439', NULL, 'Uncharacterized protein', 164, NULL, NULL, 144388),
(144389, '1.20.5.1140-FF-000001', NULL, '6-deoxyerythronolide-B synthase EryA2, modules 3 and 4', 41, NULL, NULL, 144389),
(144390, '3.30.70.660-FF-000090', NULL, 'Predicted protein', 157, NULL, NULL, 144390),
(144391, '2.60.40.60-FF-001114', NULL, 'Uncharacterized protein', 47, NULL, NULL, 144391),
(144392, '3.40.190.290-FF-000019', NULL, 'Transcriptional regulator, LysR family', 200, NULL, NULL, 144392),
(144393, '3.90.470.20-FF-000029', NULL, '4phosphopantetheinyl transferase EC 278 CDS', 91, NULL, NULL, 144393),
(144394, '3.40.50.300-FF-008249', NULL, 'Dynein, axonemal, heavy chain 11', 52, NULL, NULL, 144394),
(144395, '3.40.800.20-FF-000005', NULL, 'histone deacetylase 6', 370, NULL, NULL, 144395),
(144396, '1.20.1250.20-FF-002126', NULL, 'AGAP007755-PA', 215, NULL, NULL, 144396),
(144397, '2.60.40.10-FF-003887', NULL, NULL, 127, NULL, NULL, 144397),
(144398, '3.80.10.10-FF-001476', NULL, 'Toll-like receptor 2', 567, NULL, NULL, 144398),
(144399, '2.60.120.40-FF-000037', NULL, 'Uncharacterized protein, isoform B', 146, NULL, NULL, 144399),
(144400, '1.25.10.10-FF-002614', NULL, 'Uncharacterized protein', 137, NULL, NULL, 144400),
(144401, '2.40.30.270-FF-000005', NULL, 'Probable RNA helicase SDE3', 50, NULL, NULL, 144401),
(144402, '1.20.5.1160-FF-000007', NULL, 'Lamin B1', 106, NULL, NULL, 144402),
(144403, '3.30.450.40-FF-000290', NULL, 'Phosphodiesterase', 50, NULL, NULL, 144403),
(144404, '2.30.29.30-FF-000731', NULL, 'Pleckstrin homology domain containing A2', 64, NULL, NULL, 144404),
(144405, '2.70.98.10-FF-000113', NULL, 'Beta-galactosidase', 247, NULL, NULL, 144405),
(144406, '2.130.10.10-FF-004472', NULL, 'Uncharacterized protein', 62, NULL, NULL, 144406),
(144407, '2.40.20.10-FF-000059', NULL, 'HCG2029799, isoform CRA_b', 36, NULL, NULL, 144407),
(144408, '3.40.190.10-FF-000454', NULL, 'Transcriptional regulatory protein', 91, NULL, NULL, 144408),
(144409, '3.40.800.10-FF-000002', NULL, 'Agmatinase', 315, NULL, NULL, 144409),
(144410, '3.40.50.2000-FF-000136', NULL, 'Glycosyl transferase, group 1', 167, NULL, NULL, 144410),
(144411, '3.90.470.10-FF-000026', NULL, 'Mitochondrial Ribosomal Protein, Large', 171, NULL, NULL, 144411),
(144412, '2.60.40.340-FF-000007', NULL, 'Signal transducer and activator of transcription', 133, NULL, NULL, 144412),
(144413, '3.40.50.410-FF-000031', NULL, 'X-ray repair cross-complementing protein 6 isoform X1', 216, NULL, NULL, 144413),
(144414, '1.20.58.760-FF-000012', NULL, 'probable inactive ATP-dependent zinc metalloprotease FTSHI 2, chloroplastic', 186, NULL, NULL, 144414),
(144415, '2.40.50.100-FF-000094', NULL, 'sn-glycerol-3-phosphate ABC transporter ATP-binding protein UgpC', 75, NULL, NULL, 144415),
(144416, '2.60.40.1910-FF-000026', NULL, NULL, 88, NULL, NULL, 144416),
(144417, '3.40.50.1820-FF-001285', NULL, 'Uncharacterized protein', 286, NULL, NULL, 144417),
(144418, '2.60.15.10-FF-000001', NULL, 'ATP synthase epsilon chain', 88, NULL, NULL, 144418);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(144419, '3.80.10.10-FF-002460', NULL, 'Leucine rich repeats and death domain containing 1', 104, NULL, NULL, 144419),
(144420, '2.130.10.10-FF-000672', NULL, 'Os05g0519500 protein', 143, NULL, NULL, 144420),
(144421, '3.30.559.70-FF-000062', NULL, 'Uncharacterized protein', 89, NULL, NULL, 144421),
(144422, '3.30.420.60-FF-000001', NULL, 'Eukaryotic peptide chain release factor subunit 1', 140, NULL, NULL, 144422),
(144423, '3.30.720.210-FF-000013', NULL, 'ATP-dependent zinc metalloprotease FtsH', 79, NULL, NULL, 144423),
(144424, '2.20.80.10-FF-000024', NULL, 'Uncharacterized protein', 167, NULL, NULL, 144424),
(144425, '1.10.510.10-FF-001034', NULL, 'Uncharacterized protein', 345, NULL, NULL, 144425),
(144426, '3.40.47.10-FF-000085', NULL, '2-heptyl-4(1H)-quinolone synthase subunit PqsC', 158, NULL, NULL, 144426),
(144427, '2.60.40.60-FF-000187', NULL, 'Cadherin 16', 112, NULL, NULL, 144427),
(144428, '2.90.10.10-FF-000028', NULL, 'Serine/threonine-protein kinase', 140, NULL, NULL, 144428),
(144429, '3.40.50.11610-FF-000005', NULL, 'Probable 2-oxoglutarate dehydrogenase E1 component DHKTD1, mitochondrial', 161, NULL, NULL, 144429),
(144430, '3.30.160.60-FF-001161', NULL, 'zinc finger protein 397 isoform X2', 28, NULL, NULL, 144430),
(144431, '1.20.1050.10-FF-000141', NULL, 'Os01g0370600 protein', 82, NULL, NULL, 144431),
(144432, '2.120.10.30-FF-000201', NULL, 'Low-density lipoprotein receptor-related protein', 328, NULL, NULL, 144432),
(144433, '3.30.200.20-FF-000383', NULL, 'Slowpoke binding protein, isoform E', 23, NULL, NULL, 144433),
(144434, '1.20.58.60-FF-000400', NULL, 'SPeCtrin', 209, NULL, NULL, 144434),
(144435, '3.40.50.300-FF-001162', NULL, 'ATP-dependent RNA helicase DQX1', 167, NULL, NULL, 144435),
(144436, '3.30.2160.10-FF-000038', NULL, 'E3 ubiquitin-protein ligase UPL1', 22, NULL, NULL, 144436),
(144437, '2.10.109.10-FF-000035', NULL, 'Signal peptidase I', 157, NULL, NULL, 144437),
(144438, '3.30.160.60-FF-005612', NULL, NULL, 68, NULL, NULL, 144438),
(144439, '1.20.1270.280-FF-000026', NULL, 'Dynein alpha chain, flagellar outer arm', 172, NULL, NULL, 144439),
(144440, '3.40.50.300-FF-001105', NULL, 'Orf1ab polyprotein', 159, NULL, NULL, 144440),
(144441, '3.30.40.10-FF-001738', NULL, 'Lysine-specific demethylase rbr-2', 102, NULL, NULL, 144441),
(144442, '1.20.1250.20-FF-001906', NULL, 'Uncharacterized protein', 241, NULL, NULL, 144442),
(144443, '2.60.40.60-FF-000658', NULL, 'Cadherin 16', 113, NULL, NULL, 144443),
(144444, '3.30.40.10-FF-001795', NULL, 'Uncharacterized protein', 87, NULL, NULL, 144444),
(144445, '3.90.780.10-FF-000016', NULL, 'Sulfur oxidation protein SoxB', 184, NULL, NULL, 144445),
(144446, '3.50.50.60-FF-000314', NULL, 'Baeyer-Villiger monooxygenase', 206, NULL, NULL, 144446),
(144447, '1.25.40.10-FF-002970', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 135, NULL, NULL, 144447),
(144448, '2.170.190.11-FF-000007', NULL, 'Molybdopterin molybdenumtransferase', 101, NULL, NULL, 144448),
(144449, '3.90.1420.10-FF-000045', NULL, 'Uncharacterized protein', 137, NULL, NULL, 144449),
(144450, '3.30.450.40-FF-000233', NULL, 'Heat-inducible transcription repressor HrcA', 134, NULL, NULL, 144450),
(144451, '2.30.29.30-FF-000170', NULL, 'Arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 1', 109, NULL, NULL, 144451),
(144452, '1.20.50.20-FF-000005', NULL, 'DNA primase', 63, NULL, NULL, 144452),
(144453, '3.40.50.300-FF-004596', NULL, 'Large T antigen', 153, NULL, NULL, 144453),
(144454, '1.20.1510.10-FF-000036', NULL, 'Cation diffusion facilitator family transporter', 196, NULL, NULL, 144454),
(144455, '2.180.10.10-FF-000029', NULL, 'Uncharacterized protein', 625, NULL, NULL, 144455),
(144456, '3.30.50.10-FF-000132', NULL, 'C2C2-GATA transcription factor', 90, NULL, NULL, 144456),
(144457, '1.10.1450.10-FF-000106', NULL, 'Tetraspanin', 106, NULL, NULL, 144457),
(144458, '3.30.160.60-FF-004595', NULL, NULL, 28, NULL, NULL, 144458),
(144459, '1.20.1250.20-FF-001873', NULL, 'Uncharacterized protein', 108, NULL, NULL, 144459);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(144460, '2.170.8.10-FF-000002', NULL, 'phosphoenolpyruvate carboxykinase, cytosolic [GTP]', 108, NULL, NULL, 144460),
(144461, '1.20.120.1240-FF-000011', NULL, 'Dynamin-2A', 214, NULL, NULL, 144461),
(144462, '2.10.25.10-FF-001336', NULL, 'Uncharacterized protein', 50, NULL, NULL, 144462),
(144463, '3.90.1150.10-FF-000209', NULL, 'CAI-1 autoinducer synthase', 128, NULL, NULL, 144463),
(144464, '2.60.40.10-FF-000453', NULL, 'Chitin biosynthesis protein CHS5', 89, NULL, NULL, 144464),
(144465, '1.10.238.10-FF-001024', NULL, 'Uncharacterized protein', 64, NULL, NULL, 144465),
(144466, '3.40.50.2300-FF-000254', NULL, 'Chemotaxis protein CheV', 139, NULL, NULL, 144466),
(144467, '1.20.1250.20-FF-001255', NULL, 'Sugar (Glycoside-Pentoside-Hexuronide) transporter', 406, NULL, NULL, 144467),
(144468, '1.10.510.10-FF-004378', NULL, NULL, 98, NULL, NULL, 144468),
(144469, '3.90.550.10-FF-000645', NULL, 'Cellulose synthase A catalytic subunit 8 [UDP-forming]', 152, NULL, NULL, 144469),
(144470, '3.40.140.10-FF-000209', NULL, 'Predicted protein', 143, NULL, NULL, 144470),
(144471, '3.40.50.1820-FF-001846', NULL, 'Carboxylic ester hydrolase', 72, NULL, NULL, 144471),
(144472, '3.90.70.10-FF-000496', NULL, 'Uncharacterized protein', 358, NULL, NULL, 144472),
(144473, '3.90.480.20-FF-000002', NULL, 'Sulfite reductase', 197, NULL, NULL, 144473),
(144474, '3.30.40.10-FF-002048', NULL, 'Uncharacterized protein', 131, NULL, NULL, 144474),
(144475, '2.70.50.40-FF-000012', NULL, 'Uncharacterized protein', 143, NULL, NULL, 144475),
(144476, '3.30.50.10-FF-000042', NULL, 'Nuclear hormone receptor HR96', 109, NULL, NULL, 144476),
(144477, '3.40.50.300-FF-000852', NULL, 'Heparan-sulfate 6-O-sulfotransferase', 210, NULL, NULL, 144477),
(144478, '1.10.20.10-FF-000282', NULL, NULL, 73, NULL, NULL, 144478),
(144479, '2.130.10.10-FF-000762', NULL, 'Splicing factor 3B subunit 3', 85, NULL, NULL, 144479),
(144480, '3.40.50.720-FF-001821', NULL, 'Uncharacterized protein', 176, NULL, NULL, 144480),
(144481, '3.40.50.970-FF-000120', NULL, 'Pyruvate dehydrogenase (Ferredoxin/flavodoxin-dependent)', 384, NULL, NULL, 144481),
(144482, '1.10.287.70-FF-000599', NULL, 'Potassium voltage-gated channel, subfamily H (eag-related), member 3', 259, NULL, NULL, 144482),
(144483, '1.10.1320.10-FF-000012', NULL, 'DNA-directed RNA polymerase 3 chloroplastic', 151, NULL, NULL, 144483),
(144484, '2.120.10.80-FF-000406', NULL, 'Uncharacterized protein', 287, NULL, NULL, 144484),
(144485, '2.30.230.10-FF-000037', NULL, 'Vitellogenin 1', 168, NULL, NULL, 144485),
(144486, '3.40.50.300-FF-008491', NULL, 'ATP binding cassette subfamily B member 4', 126, NULL, NULL, 144486),
(144487, '1.20.1110.10-FF-000253', NULL, NULL, 143, NULL, NULL, 144487),
(144488, '1.10.10.60-FF-000751', NULL, 'Two-component system sensor histidine kinase/response regulator', 53, NULL, NULL, 144488),
(144489, '2.40.10.10-FF-000143', NULL, 'Serine protease PepA', 98, NULL, NULL, 144489),
(144490, '3.30.160.60-FF-002611', NULL, 'Ras-responsive element-binding protein 1', 46, NULL, NULL, 144490),
(144491, '1.25.40.10-FF-002352', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 198, NULL, NULL, 144491),
(144492, '1.10.10.60-FF-000509', NULL, 'TetR family transcriptional regulator', 42, NULL, NULL, 144492),
(144493, '2.60.40.60-FF-000097', NULL, 'cadherin-12 isoform X1', 108, NULL, NULL, 144493),
(144494, '3.30.300.10-FF-000028', NULL, 'S-adenosylmethionine synthetase 2', 27, NULL, NULL, 144494),
(144495, '1.10.238.10-FF-000535', NULL, 'Calcium uptake protein 1 homolog, mitochondrial', 158, NULL, NULL, 144495),
(144496, '2.60.40.1400-FF-000020', NULL, NULL, 55, NULL, NULL, 144496),
(144497, '1.10.238.10-FF-001103', NULL, 'Phosphoinositide phospholipase C', 62, NULL, NULL, 144497),
(144498, '3.40.367.20-FF-000031', NULL, 'Phosphotransferase', 80, NULL, NULL, 144498),
(144499, '2.60.40.10-FF-001060', NULL, 'Sallimus, isoform Q', 111, NULL, NULL, 144499),
(144500, '1.10.472.170-FF-000017', NULL, 'BRF1 homolog, subunit of RNA polymerase III transcription initiation factor IIIB (S. cerevisiae) (Predicted), isoform CRA_a', 88, NULL, NULL, 144500);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(144501, '3.30.70.270-FF-000214', NULL, NULL, 116, NULL, NULL, 144501),
(144502, '1.10.10.10-FF-000225', NULL, 'Positive transcription regulator EvgA', 73, NULL, NULL, 144502),
(144503, '3.40.309.10-FF-000113', NULL, 'Aldehyde dehydrogenase, putative', 85, NULL, NULL, 144503),
(144504, '1.20.1070.10-FF-000878', NULL, 'Predicted protein', 125, NULL, NULL, 144504),
(144505, '3.80.10.10-FF-003775', NULL, 'Uncharacterized protein', 106, NULL, NULL, 144505),
(144506, '3.90.226.10-FF-000061', NULL, 'Methylglutaconyl-CoA hydratase, mitochondrial', 207, NULL, NULL, 144506),
(144507, '1.20.58.1880-FF-000015', NULL, 'AGAP001029-PA', 90, NULL, NULL, 144507),
(144508, '1.25.10.10-FF-000282', NULL, 'Spindle pole body component', 255, NULL, NULL, 144508),
(144509, '2.160.20.10-FF-000284', NULL, 'Uncharacterized protein', 177, NULL, NULL, 144509),
(144510, '1.10.1420.10-FF-000161', NULL, 'Uncharacterized protein', 178, NULL, NULL, 144510),
(144511, '3.10.129.10-FF-000263', NULL, 'Acyl-CoA thioesterase 11a', 62, NULL, NULL, 144511),
(144512, '2.40.180.10-FF-000019', NULL, 'Catalase', 499, NULL, NULL, 144512),
(144513, '1.10.575.10-FF-000020', NULL, 'Uncharacterized protein', 273, NULL, NULL, 144513),
(144514, '1.10.640.10-FF-000060', NULL, 'Uncharacterized protein', 211, NULL, NULL, 144514),
(144515, '3.60.21.10-FF-000373', NULL, 'Serine/threonine protein phosphatase, putative', 109, NULL, NULL, 144515),
(144516, '3.30.1520.20-FF-000002', NULL, 'Exodeoxyribonuclease I', 141, NULL, NULL, 144516),
(144517, '1.20.1310.10-FF-000173', NULL, NULL, 128, NULL, NULL, 144517),
(144518, '3.30.70.330-FF-002610', NULL, NULL, 130, NULL, NULL, 144518),
(144519, '2.130.10.10-FF-004264', NULL, 'Uncharacterized protein', 135, NULL, NULL, 144519),
(144520, '3.40.50.300-FF-006810', NULL, 'Uncharacterized protein', 47, NULL, NULL, 144520),
(144521, '2.130.10.10-FF-002235', NULL, 'Uncharacterized protein', 326, NULL, NULL, 144521),
(144522, '2.60.40.10-FF-004348', NULL, NULL, 113, NULL, NULL, 144522),
(144523, '3.40.50.300-FF-006861', NULL, 'ABC transporter, ATP-binding/permease protein', 256, NULL, NULL, 144523),
(144524, '3.40.50.1000-FF-000729', NULL, NULL, 77, NULL, NULL, 144524),
(144525, '3.40.30.10-FF-001187', NULL, 'Uncharacterized protein', 109, NULL, NULL, 144525),
(144526, '2.20.100.10-FF-000030', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 3', 56, NULL, NULL, 144526),
(144527, '3.40.50.720-FF-001580', NULL, 'WbnF', 348, NULL, NULL, 144527),
(144528, '2.30.30.40-FF-000266', NULL, 'SLIT-ROBO Rho GTPase-activating protein 2', 91, NULL, NULL, 144528),
(144529, '3.90.1600.10-FF-000025', NULL, 'DNA polymerase', 149, NULL, NULL, 144529),
(144530, '1.50.10.20-FF-000142', NULL, 'Squalene cyclase family protein', 349, NULL, NULL, 144530),
(144531, '3.80.10.10-FF-002252', NULL, 'Expressed protein', 115, NULL, NULL, 144531),
(144532, '3.40.50.300-FF-003084', NULL, 'Cell cycle-associated GTPase, putative', 184, NULL, NULL, 144532),
(144533, '2.70.98.10-FF-000091', NULL, 'AGAP008154-PA', 267, NULL, NULL, 144533),
(144534, '2.40.70.10-FF-000124', NULL, 'Transposon Tf2-8 polyprotein', 137, NULL, NULL, 144534),
(144535, '3.30.160.60-FF-002706', NULL, 'Zinc finger protein 682', 51, NULL, NULL, 144535),
(144536, '1.10.472.10-FF-000028', NULL, 'Cyclin-T1-5 like', 105, NULL, NULL, 144536),
(144537, '2.60.40.10-FF-004286', NULL, NULL, 88, NULL, NULL, 144537),
(144538, '3.30.40.10-FF-001946', NULL, 'Uncharacterized protein', 67, NULL, NULL, 144538),
(144539, '3.30.200.20-FF-000703', NULL, 'Tyrosine-protein kinase', 99, NULL, NULL, 144539),
(144540, '1.10.268.10-FF-000037', NULL, NULL, 137, NULL, NULL, 144540),
(144541, '1.20.1250.20-FF-000119', NULL, 'MFS monosaccharide transporter, putative', 454, NULL, NULL, 144541),
(144542, '1.10.510.10-FF-002585', NULL, NULL, 213, NULL, NULL, 144542),
(144543, '2.40.70.10-FF-000450', NULL, NULL, 40, NULL, NULL, 144543),
(144544, '3.30.200.20-FF-000057', NULL, 'Serine/threonine-protein kinase DCLK1 isoform 2', 93, NULL, NULL, 144544),
(144545, '1.20.120.1240-FF-000073', NULL, 'Uncharacterized protein', 83, NULL, NULL, 144545);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(144546, '2.60.120.650-FF-000053', NULL, '2-oxoglutarate (2OG) and Fe(II)-dependent oxygenase superfamily protein', 286, NULL, NULL, 144546),
(144547, '1.20.120.220-FF-000018', NULL, 'ATPase protein', 117, NULL, NULL, 144547),
(144548, '2.40.30.170-FF-000060', NULL, NULL, 91, NULL, NULL, 144548),
(144549, '1.10.3720.10-FF-000173', NULL, 'Putative ABC transporter, permease protein', 196, NULL, NULL, 144549),
(144550, '1.20.1070.10-FF-001867', NULL, 'Uncharacterized protein', 294, NULL, NULL, 144550),
(144551, '3.80.10.10-FF-000009', NULL, 'F-actin-uncapping protein LRRC16A isoform X1', 506, NULL, NULL, 144551),
(144552, '2.170.270.10-FF-000147', NULL, 'Uncharacterized protein', 168, NULL, NULL, 144552),
(144553, '2.70.150.10-FF-000207', NULL, 'Phospholipid-transporting ATPase', 124, NULL, NULL, 144553),
(144554, '2.60.40.10-FF-002257', NULL, 'CLUMA_CG019509, isoform A', 95, NULL, NULL, 144554),
(144555, '3.40.50.2000-FF-000900', NULL, 'Putative colanic acid biosynthesis glycosyl transferase', 169, NULL, NULL, 144555),
(144556, '2.70.170.10-FF-000158', NULL, 'Predicted protein', 131, NULL, NULL, 144556),
(144557, '3.90.70.10-FF-000316', NULL, 'Putative cysteine peptidase, Clan CA, family C19', 341, NULL, NULL, 144557),
(144558, '1.10.238.10-FF-000440', NULL, 'Probable calcium-binding protein CML31', 85, NULL, NULL, 144558),
(144559, '1.10.10.10-FF-000276', NULL, 'heterochromatin protein 1-binding protein 3 isoform X1', 87, NULL, NULL, 144559),
(144560, '3.90.550.10-FF-000319', NULL, 'Hexosyltransferase', 254, NULL, NULL, 144560),
(144561, '1.25.40.10-FF-002880', NULL, 'U3 small nucleolar RNA-associated protein 6 homolog', 237, NULL, NULL, 144561),
(144562, '1.10.3210.10-FF-000089', NULL, 'HD superfamily hydrolase', 185, NULL, NULL, 144562),
(144563, '1.10.472.10-FF-000416', NULL, 'Predicted protein', 89, NULL, NULL, 144563),
(144564, '1.20.144.10-FF-000040', NULL, 'Probable diacylglycerol pyrophosphate phosphatase 1', 269, NULL, NULL, 144564),
(144565, '1.25.40.10-FF-001986', NULL, 'Pentatricopeptide repeat protein', 111, NULL, NULL, 144565),
(144566, '2.130.10.10-FF-005787', NULL, 'Predicted protein', 98, NULL, NULL, 144566),
(144567, '1.10.510.10-FF-003102', NULL, NULL, 196, NULL, NULL, 144567),
(144568, '3.40.50.1820-FF-000003', NULL, 'Dipeptidyl peptidase 4', 258, NULL, NULL, 144568),
(144569, '3.30.565.10-FF-000417', NULL, 'GAF domain-containing protein', 162, NULL, NULL, 144569),
(144570, '3.40.850.10-FF-000218', NULL, 'Kinesin-like protein costa', 148, NULL, NULL, 144570),
(144571, '1.25.40.10-FF-002649', NULL, 'Coatomer subunit epsilon', 297, NULL, NULL, 144571),
(144572, '2.60.40.10-FF-001801', NULL, 'Sidestep, isoform A', 56, NULL, NULL, 144572),
(144573, '1.10.600.10-FF-000046', NULL, 'Squalene synthase HpnC', 265, NULL, NULL, 144573),
(144574, '3.40.50.261-FF-000009', NULL, 'Protein lysine acetyltransferase', 157, NULL, NULL, 144574),
(144575, '1.25.40.20-FF-000792', NULL, 'Ankyrin repeats (3 copies), putative', 105, NULL, NULL, 144575),
(144576, '1.10.510.10-FF-000461', NULL, 'Interleukin 1 receptor associated kinase 3', 209, NULL, NULL, 144576),
(144577, '1.10.3460.10-FF-000023', NULL, 'Chlorophyll a-b binding protein, chloroplastic', 184, NULL, NULL, 144577),
(144578, '2.30.30.40-FF-000215', NULL, 'MAGUK p55 subfamily member 3', 107, NULL, NULL, 144578),
(144579, '2.60.40.10-FF-002162', NULL, 'filamin-A isoform X10', 100, NULL, NULL, 144579),
(144580, '2.30.30.40-FF-000592', NULL, 'Uncharacterized protein', 62, NULL, NULL, 144580),
(144581, '1.20.1250.20-FF-001761', NULL, 'Sodium:galactoside symporter family protein', 190, NULL, NULL, 144581),
(144582, '3.30.200.20-FF-002148', NULL, 'MOK protein kinase', 69, NULL, NULL, 144582),
(144583, '3.40.50.1820-FF-001577', NULL, 'Os07g0665801 protein', 104, NULL, NULL, 144583),
(144584, '1.10.238.10-FF-000209', NULL, 'Ninein like', 159, NULL, NULL, 144584),
(144585, '1.20.120.1760-FF-000072', NULL, NULL, 194, NULL, NULL, 144585),
(144586, '1.20.1310.10-FF-000122', NULL, NULL, 152, NULL, NULL, 144586),
(144587, '3.30.230.70-FF-000113', NULL, 'Exosome complex component mtr3', 252, NULL, NULL, 144587);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(144588, '3.40.190.290-FF-000081', NULL, 'LysR family transcriptional regulator', 201, NULL, NULL, 144588),
(144589, '3.20.20.220-FF-000063', NULL, 'Proline dehydrogenase', 222, NULL, NULL, 144589),
(144590, '1.25.10.10-FF-002322', NULL, 'Uncharacterized protein', 308, NULL, NULL, 144590),
(144591, '2.120.10.30-FF-000145', NULL, 'Low-density lipoprotein receptor-related protein', 340, NULL, NULL, 144591),
(144592, '1.10.510.10-FF-001124', NULL, 'Receptor-like serine/threonine-protein kinase SD1-6', 211, NULL, NULL, 144592),
(144593, '3.10.110.10-FF-000119', NULL, 'Uncharacterized protein', 160, NULL, NULL, 144593),
(144594, '2.60.40.10-FF-000924', NULL, 'TAP binding protein', 132, NULL, NULL, 144594),
(144595, '1.10.238.10-FF-000586', NULL, 'Uncharacterized protein', 85, NULL, NULL, 144595),
(144596, '1.10.3720.10-FF-000122', NULL, 'Oligopeptide ABC transporter, permease protein', 217, NULL, NULL, 144596),
(144597, '3.20.20.150-FF-000081', NULL, 'Protein arginine N-methyltransferase', 152, NULL, NULL, 144597),
(144598, '3.10.260.30-FF-000001', NULL, 'Regulatory protein SWI6', 108, NULL, NULL, 144598),
(144599, '3.30.70.330-FF-002222', NULL, NULL, 107, NULL, NULL, 144599),
(144600, '1.20.1280.290-FF-000093', NULL, 'Uncharacterized protein', 91, NULL, NULL, 144600),
(144601, '3.30.70.330-FF-001828', NULL, NULL, 113, NULL, NULL, 144601),
(144602, '3.40.50.720-FF-001254', NULL, 'Alcohol dehydrogenase', 128, NULL, NULL, 144602),
(144603, '3.90.70.80-FF-000005', NULL, 'OTU domain-containing protein 3', 141, NULL, NULL, 144603),
(144604, '3.30.1330.60-FF-000044', NULL, 'Sortase system OmpA family protein PdsO', 163, NULL, NULL, 144604),
(144605, '1.20.1420.30-FF-000102', NULL, 'Potassium-dependent sodium-calcium exchanger, putative', 187, NULL, NULL, 144605),
(144606, '3.30.360.10-FF-000009', NULL, '4-hydroxy-tetrahydrodipicolinate reductase', 106, NULL, NULL, 144606),
(144607, '2.60.40.10-FF-002903', NULL, 'Fc receptor like 3', 87, NULL, NULL, 144607),
(144608, '3.40.1140.10-FF-000001', NULL, 'Chromosome partition protein MukB', 87, NULL, NULL, 144608),
(144609, '2.40.70.10-FF-000175', NULL, 'Eukaryotic aspartyl protease family protein', 178, NULL, NULL, 144609),
(144610, '1.10.3210.10-FF-000038', NULL, 'Cyanamide hydratase, putative', 182, NULL, NULL, 144610),
(144611, '2.60.410.10-FF-000005', NULL, 'Penicillin-binding protein 3/D-alanyl-D-alanine carboxypeptidase', 101, NULL, NULL, 144611),
(144612, '1.20.1000.10-FF-000019', NULL, 'Uncharacterized protein', 283, NULL, NULL, 144612),
(144613, '3.30.200.20-FF-001485', NULL, 'AGC/NDR protein kinase', 11, NULL, NULL, 144613),
(144614, '2.130.10.10-FF-000902', NULL, 'Nuclear distribution protein PAC1', 356, NULL, NULL, 144614),
(144615, '1.10.10.10-FF-000955', NULL, 'Heat Shock Factor', 112, NULL, NULL, 144615),
(144616, '2.120.10.80-FF-000053', NULL, 'Kelch domain-containing protein 8B', 116, NULL, NULL, 144616),
(144617, '3.80.10.10-FF-003449', NULL, 'Uncharacterized protein', 247, NULL, NULL, 144617),
(144618, '2.60.40.150-FF-000714', NULL, 'Phosphoinositide phospholipase C', 170, NULL, NULL, 144618),
(144619, '3.40.630.30-FF-000618', NULL, 'Aminoglycoside N6''-acetyltransferase', 187, NULL, NULL, 144619),
(144620, '3.40.50.150-FF-000369', NULL, 'Leucine carboxyl methyltransferase 1', 334, NULL, NULL, 144620),
(144621, '3.30.40.10-FF-001267', NULL, 'RING-type E3 ubiquitin transferase', 119, NULL, NULL, 144621),
(144622, '3.90.70.10-FF-000642', NULL, 'Putative calpain-like cysteine peptidase', 106, NULL, NULL, 144622),
(144623, '3.40.50.2300-FF-000546', NULL, 'DNA-binding response regulator', 120, NULL, NULL, 144623),
(144624, '1.10.10.60-FF-000830', NULL, NULL, 52, NULL, NULL, 144624),
(144625, '1.10.1070.11-FF-000016', NULL, 'PIK1p Phosphatidylinositol 4-kinase', 197, NULL, NULL, 144625),
(144626, '2.70.40.10-FF-000025', NULL, 'Deoxyuridine 5''-triphosphate nucleotidohydrolase', 207, NULL, NULL, 144626),
(144627, '3.40.50.300-FF-005967', NULL, 'Guanine nucleotide-binding protein (G protein), alpha-activating activity polypeptide, olfactory type', 175, NULL, NULL, 144627);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(144628, '1.25.40.10-FF-000525', NULL, 'Pentatricopeptide (PPR) repeat-containing protein-like', 223, NULL, NULL, 144628),
(144629, '1.10.238.10-FF-000861', NULL, 'Uncharacterized protein', 131, NULL, NULL, 144629),
(144630, '3.30.70.330-FF-002317', NULL, NULL, 88, NULL, NULL, 144630),
(144631, '3.10.110.10-FF-000271', NULL, 'Ubiquitin-conjugating enzyme family protein', 141, NULL, NULL, 144631),
(144632, '2.130.10.10-FF-000841', NULL, 'Putative CPSF (Cleavage and polyadenylation specific factor), subunit A', 37, NULL, NULL, 144632),
(144633, '3.60.20.10-FF-000005', NULL, 'Proteasome subunit beta type-2', 232, NULL, NULL, 144633),
(144634, '2.60.120.290-FF-000102', NULL, 'Suppressor of lurcher protein 1', 110, NULL, NULL, 144634),
(144635, '3.90.920.10-FF-000022', NULL, 'DNA primase', 408, NULL, NULL, 144635),
(144636, '2.10.25.10-FF-001600', NULL, 'Uncharacterized protein', 60, NULL, NULL, 144636),
(144637, '3.40.50.970-FF-000064', NULL, '1-deoxy-D-xylulose 5-phosphate synthase', 170, NULL, NULL, 144637),
(144638, '2.130.10.10-FF-004652', NULL, 'Uncharacterized protein', 189, NULL, NULL, 144638),
(144639, '3.30.160.60-FF-004056', NULL, NULL, 27, NULL, NULL, 144639),
(144640, '3.40.30.10-FF-000956', NULL, 'Uncharacterized protein', 106, NULL, NULL, 144640),
(144641, '3.40.50.300-FF-004770', NULL, 'Ras family protein', 101, NULL, NULL, 144641),
(144642, '3.40.50.1240-FF-000217', NULL, NULL, 198, NULL, NULL, 144642),
(144643, '3.40.50.300-FF-001167', NULL, 'DNA replication protein', 183, NULL, NULL, 144643),
(144644, '2.60.40.10-FF-002369', NULL, 'Coiled-coil domain-containing 141', 105, NULL, NULL, 144644),
(144645, '2.60.40.60-FF-000619', NULL, 'Uncharacterized protein', 122, NULL, NULL, 144645),
(144646, '3.30.565.10-FF-000305', NULL, 'Sensor histidine kinase', 155, NULL, NULL, 144646),
(144647, '3.40.50.300-FF-004618', NULL, 'ABC transporter B family member 9', 42, NULL, NULL, 144647),
(144648, '1.20.120.420-FF-000011', NULL, 'Ribose 1,5-bisphosphate isomerase', 108, NULL, NULL, 144648),
(144649, '3.30.70.600-FF-000004', NULL, '30S ribosomal protein S10', 114, NULL, NULL, 144649),
(144650, '4.10.320.10-FF-000013', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 52, NULL, NULL, 144650),
(144651, '1.10.287.110-FF-000139', NULL, 'Chaperone protein dnaJ 20', 105, NULL, NULL, 144651),
(144652, '1.25.10.10-FF-002373', NULL, 'HD protein homolog', 275, NULL, NULL, 144652),
(144653, '2.60.120.260-FF-000447', NULL, 'F-box protein 6', 156, NULL, NULL, 144653),
(144654, '3.40.190.10-FF-000415', NULL, 'HTH-type transcriptional regulator ClcR', 92, NULL, NULL, 144654),
(144655, '1.10.510.10-FF-002490', NULL, 'CAMK family protein kinase', 322, NULL, NULL, 144655),
(144656, '3.30.40.10-FF-001997', NULL, 'Uncharacterized protein', 53, NULL, NULL, 144656),
(144657, '3.90.110.10-FF-000005', NULL, 'L-lactate dehydrogenase', 167, NULL, NULL, 144657),
(144658, '3.30.160.60-FF-004735', NULL, NULL, 30, NULL, NULL, 144658),
(144659, '1.10.340.30-FF-000054', NULL, 'Uncharacterized protein', 166, NULL, NULL, 144659),
(144660, '3.30.300.30-FF-000045', NULL, 'Propionate--CoA ligase', 133, NULL, NULL, 144660),
(144661, '3.30.70.330-FF-001733', NULL, NULL, 78, NULL, NULL, 144661),
(144662, '3.30.1520.10-FF-000050', NULL, 'Related to Protein scd2/ral3', 151, NULL, NULL, 144662),
(144663, '3.40.50.300-FF-008608', NULL, 'Uncharacterized protein', 147, NULL, NULL, 144663),
(144664, '3.40.50.1820-FF-001526', NULL, 'S-formylglutathione hydrolase', 145, NULL, NULL, 144664),
(144665, '1.10.10.440-FF-000086', NULL, 'Uncharacterized protein', 83, NULL, NULL, 144665),
(144666, '1.20.120.430-FF-000014', NULL, 'tRNA modification GTPase trmE', 68, NULL, NULL, 144666),
(144667, '2.60.120.560-FF-000026', NULL, 'galactocerebrosidase', 207, NULL, NULL, 144667),
(144668, '3.30.1490.100-FF-000025', NULL, 'Related to DNA polymerase kappa', 110, NULL, NULL, 144668),
(144669, '2.130.10.10-FF-006029', NULL, 'Uncharacterized protein', 121, NULL, NULL, 144669),
(144670, '3.40.50.1000-FF-000376', NULL, 'Putative glycosyl hydrolase', 98, NULL, NULL, 144670);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(144671, '1.20.1280.290-FF-000042', NULL, 'Sugar transporter SemiSWEET', 93, NULL, NULL, 144671),
(144672, '3.20.100.10-FF-000009', NULL, 'mRNA triphosphatase CET1', 338, NULL, NULL, 144672),
(144673, '2.40.50.140-FF-000414', NULL, 'Single-stranded DNA-binding protein 1', 116, NULL, NULL, 144673),
(144674, '1.20.1420.30-FF-000041', NULL, 'Na/Ca eXchangers', 127, NULL, NULL, 144674),
(144675, '1.25.10.10-FF-000809', NULL, '89B helicase', 227, NULL, NULL, 144675),
(144676, '1.25.40.690-FF-000016', NULL, 'Uncharacterized protein', 86, NULL, NULL, 144676),
(144677, '2.60.40.10-FF-004674', NULL, NULL, 93, NULL, NULL, 144677),
(144678, '3.30.70.330-FF-001879', NULL, NULL, 98, NULL, NULL, 144678),
(144679, '1.20.1560.10-FF-000140', NULL, 'Uncharacterized protein', 325, NULL, NULL, 144679),
(144680, '3.40.50.300-FF-002527', NULL, 'DNA-directed DNA polymerase theta, putative', 197, NULL, NULL, 144680),
(144681, '2.40.33.10-FF-000038', NULL, 'Pyruvate kinase', 114, NULL, NULL, 144681),
(144682, '3.30.420.140-FF-000002', NULL, 'Putative pre-16S rRNA nuclease', 138, NULL, NULL, 144682),
(144683, '3.30.420.150-FF-000005', NULL, 'NTPase, isoform C', 240, NULL, NULL, 144683),
(144684, '3.80.10.10-FF-002201', NULL, 'Toll-like receptor 21', 293, NULL, NULL, 144684),
(144685, '2.60.40.10-FF-002583', NULL, 'CRE-UNC-22 protein', 103, NULL, NULL, 144685),
(144686, '3.80.10.10-FF-001858', NULL, 'Uncharacterized protein', 71, NULL, NULL, 144686),
(144687, '1.20.1070.10-FF-000344', NULL, 'Serpentine Receptor, class V', 316, NULL, NULL, 144687),
(144688, '3.40.50.10190-FF-000023', NULL, 'DNA topoisomerase II binding protein 1', 107, NULL, NULL, 144688),
(144689, '1.10.287.110-FF-000353', NULL, 'Chaperone protein DnaJ', 129, NULL, NULL, 144689),
(144690, '3.90.1150.10-FF-000501', NULL, 'Glycine cleavage system P protein', 110, NULL, NULL, 144690),
(144691, '2.10.220.10-FF-000047', NULL, 'Proprotein convertase subtilisin/kexin type 6', 54, NULL, NULL, 144691),
(144692, '2.120.10.30-FF-000403', NULL, 'Uncharacterized protein', 206, NULL, NULL, 144692),
(144693, '1.10.940.10-FF-000004', NULL, 'Transcription antitermination protein NusB', 137, NULL, NULL, 144693),
(144694, '3.40.47.10-FF-000107', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 3', 362, NULL, NULL, 144694),
(144695, '1.10.1660.10-FF-000004', NULL, 'Zn(II)-responsive transcriptional regulator', 128, NULL, NULL, 144695),
(144696, '2.60.40.10-FF-000812', NULL, 'Terribly reduced optic lobes, isoform AN', 87, NULL, NULL, 144696),
(144697, '3.40.50.300-FF-005107', NULL, 'Predicted protein', 264, NULL, NULL, 144697),
(144698, '1.10.10.10-FF-000904', NULL, 'RrF2 family protein', 142, NULL, NULL, 144698),
(144699, '3.60.21.10-FF-000047', NULL, 'Serine/threonine-protein phosphatase', 296, NULL, NULL, 144699),
(144700, '3.90.930.12-FF-000008', NULL, '50S ribosomal protein L6', 97, NULL, NULL, 144700),
(144701, '1.10.1070.11-FF-000067', NULL, 'AGAP003967-PA', 171, NULL, NULL, 144701),
(144702, '1.10.510.10-FF-001236', NULL, 'Uncharacterized protein', 316, NULL, NULL, 144702),
(144703, '3.90.740.10-FF-000036', NULL, 'Isoleucyl-tRNA synthetase', 152, NULL, NULL, 144703),
(144704, '1.20.58.70-FF-000116', NULL, 'Syntaxin', 125, NULL, NULL, 144704),
(144705, '1.10.238.10-FF-000939', NULL, 'Calcium-binding EF-hand family protein', 136, NULL, NULL, 144705),
(144706, '2.40.160.50-FF-000041', NULL, 'Uncharacterized protein', 295, NULL, NULL, 144706),
(144707, '1.10.238.10-FF-000647', NULL, 'Calcium-binding protein CML38', 91, NULL, NULL, 144707),
(144708, '3.40.30.10-FF-000698', NULL, 'Glutathione peroxidase', 63, NULL, NULL, 144708),
(144709, '3.30.40.10-FF-001790', NULL, 'Uncharacterized protein', 80, NULL, NULL, 144709),
(144710, '3.40.50.80-FF-000141', NULL, 'Ferric reduction oxidase 8, mitochondrial isoform A', 102, NULL, NULL, 144710),
(144711, '2.40.50.140-FF-000139', NULL, 'DNA ligase B', 83, NULL, NULL, 144711),
(144712, '2.40.100.10-FF-000065', NULL, 'Peptidyl-prolyl cis-trans isomerase 4', 185, NULL, NULL, 144712),
(144713, '1.10.10.10-FF-000629', NULL, 'Transcription factor E2F/dimerization partner', 86, NULL, NULL, 144713);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(144714, '3.60.60.10-FF-000002', NULL, 'N-acylsphingosine amidohydrolase 1', 261, NULL, NULL, 144714),
(144715, '1.20.1070.10-FF-000232', NULL, 'Uncharacterized protein', 329, NULL, NULL, 144715),
(144716, '2.130.10.10-FF-004438', NULL, 'Uncharacterized protein', 354, NULL, NULL, 144716),
(144717, '2.60.120.970-FF-000059', NULL, 'Univin', 246, NULL, NULL, 144717),
(144718, '1.10.540.10-FF-000075', NULL, 'Acyl-CoA dehydrogenase MmgC', 119, NULL, NULL, 144718),
(144719, '2.130.10.10-FF-001976', NULL, 'Ribosome biogenesis protein ENP2', 202, NULL, NULL, 144719),
(144720, '3.40.50.300-FF-003016', NULL, 'DEAH-box helicase 9', 48, NULL, NULL, 144720),
(144721, '3.80.10.10-FF-001763', NULL, 'Protein toll', 201, NULL, NULL, 144721),
(144722, '2.40.50.90-FF-000045', NULL, 'Putative nuclease', 140, NULL, NULL, 144722),
(144723, '3.30.1680.10-FF-000038', NULL, 'Uncharacterized protein', 63, NULL, NULL, 144723),
(144724, '2.30.30.40-FF-000092', NULL, 'Uncharacterized protein, isoform B', 62, NULL, NULL, 144724),
(144725, '1.10.238.10-FF-000709', NULL, 'calumenin-B', 84, NULL, NULL, 144725),
(144726, '1.10.10.60-FF-000537', NULL, 'AraC family transcriptional regulator', 106, NULL, NULL, 144726),
(144727, '3.10.20.10-FF-000024', NULL, '60S ribosomal protein L18a', 80, NULL, NULL, 144727),
(144728, '1.10.8.100-FF-000031', NULL, 'Mitochondrial transcription factor 1', 74, NULL, NULL, 144728),
(144729, '3.30.1370.10-FF-000228', NULL, 'KRR1 small subunit processome component', 102, NULL, NULL, 144729),
(144730, '3.90.1150.10-FF-000440', NULL, 'Taurine--pyruvate aminotransferase', 159, NULL, NULL, 144730),
(144731, '3.30.519.10-FF-000030', NULL, NULL, 74, NULL, NULL, 144731),
(144732, '1.25.10.10-FF-002294', NULL, 'Uncharacterized protein', 325, NULL, NULL, 144732),
(144733, '1.20.120.720-FF-000011', NULL, 'Myosin 2', 145, NULL, NULL, 144733),
(144734, '2.60.40.420-FF-000121', NULL, 'At4g39830', 135, NULL, NULL, 144734),
(144735, '3.30.450.20-FF-000103', NULL, 'Methyl-accepting chemotaxis protein', 115, NULL, NULL, 144735),
(144736, '3.30.200.20-FF-002423', NULL, NULL, 80, NULL, NULL, 144736),
(144737, '3.50.50.60-FF-000174', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 110, NULL, NULL, 144737),
(144738, '3.30.1370.10-FF-000133', NULL, 'Uncharacterized protein, isoform A', 81, NULL, NULL, 144738),
(144739, '3.30.160.40-FF-000008', NULL, 'Porphobilinogen deaminase, variant', 92, NULL, NULL, 144739),
(144740, '3.40.50.150-FF-001212', NULL, NULL, 193, NULL, NULL, 144740),
(144741, '2.40.30.10-FF-000357', NULL, 'Translation elongation factor EF-1 alpha/Tu, putative', 106, NULL, NULL, 144741),
(144742, '3.40.50.720-FF-001754', NULL, 'Geraniol dehydrogenase GeoA', 138, NULL, NULL, 144742),
(144743, '3.30.505.10-FF-000088', NULL, 'Tyrosine-protein kinase', 110, NULL, NULL, 144743),
(144744, '2.60.40.10-FF-000863', NULL, 'immunoglobulin superfamily member 8', 121, NULL, NULL, 144744),
(144745, '2.60.40.10-FF-004174', NULL, NULL, 87, NULL, NULL, 144745),
(144746, '3.30.40.230-FF-000005', NULL, 'Glycine--tRNA ligase', 64, NULL, NULL, 144746),
(144747, '3.40.50.300-FF-006922', NULL, 'Uncharacterized protein', 232, NULL, NULL, 144747),
(144748, '3.40.50.300-FF-002595', NULL, 'BMA-SPAS-1, isoform d', 188, NULL, NULL, 144748),
(144749, '3.90.1300.10-FF-000031', NULL, 'Uncharacterized protein', 464, NULL, NULL, 144749),
(144750, '1.25.40.10-FF-002150', NULL, 'Predicted protein', 145, NULL, NULL, 144750),
(144751, '3.40.50.720-FF-001703', NULL, 'Phosphoglycerate dehydrogenase', 183, NULL, NULL, 144751),
(144752, '1.10.510.10-FF-000865', NULL, 'ESAT-6 secretion machinery protein EssB', 176, NULL, NULL, 144752),
(144753, '3.80.10.10-FF-002140', NULL, 'tropomodulin-2 isoform X1', 133, NULL, NULL, 144753),
(144754, '1.10.420.10-FF-000009', NULL, 'Ascorbate peroxidase', 121, NULL, NULL, 144754),
(144755, '3.30.420.40-FF-000607', NULL, 'Chaperone protein DnaK', 123, NULL, NULL, 144755),
(144756, '2.60.40.10-FF-000571', NULL, 'Neurocan core protein', 120, NULL, NULL, 144756),
(144757, '1.20.120.730-FF-000014', NULL, 'Protein transport protein SEC23', 129, NULL, NULL, 144757); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(144758, '3.30.450.40-FF-000109', NULL, 'Stage II sporulation protein E', 164, NULL, NULL, 144758),
(144759, '2.70.210.12-FF-000001', NULL, 'GTPase Obg', 158, NULL, NULL, 144759),
(144760, '3.30.200.20-FF-002474', NULL, 'Protein kinase, putative', 48, NULL, NULL, 144760),
(144761, '1.10.510.10-FF-002759', NULL, NULL, 117, NULL, NULL, 144761),
(144762, '1.10.472.10-FF-000293', NULL, 'Cyclin', 141, NULL, NULL, 144762),
(144763, '3.70.10.10-FF-000089', NULL, 'Mitotic and DNA damage checkpoint protein hus1, putative', 282, NULL, NULL, 144763),
(144764, '1.10.30.10-FF-000108', NULL, 'High mobility group protein-like tdp-1, putative', 96, NULL, NULL, 144764),
(144765, '3.30.70.20-FF-000142', NULL, NULL, 61, NULL, NULL, 144765),
(144766, '2.30.29.30-FF-001327', NULL, 'Uncharacterized protein', 61, NULL, NULL, 144766),
(144767, '1.20.1070.10-FF-002031', NULL, 'Predicted protein', 118, NULL, NULL, 144767),
(144768, '1.10.10.10-FF-001040', NULL, 'Glycine cleavage operon activator', 85, NULL, NULL, 144768),
(144769, '2.130.10.10-FF-003775', NULL, 'Uncharacterized protein', 398, NULL, NULL, 144769),
(144770, '2.60.40.10-FF-000245', NULL, 'protein turtle homolog B isoform X2', 113, NULL, NULL, 144770),
(144771, '1.10.8.270-FF-000003', NULL, 'Ecotropic viral integration site 5', 93, NULL, NULL, 144771),
(144772, '3.50.50.60-FF-000820', NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', 135, NULL, NULL, 144772),
(144773, '3.40.50.720-FF-001349', NULL, 'tRNA threonylcarbamoyladenosine dehydratase', 208, NULL, NULL, 144773),
(144774, '2.60.200.20-FF-000234', NULL, 'Uncharacterized protein', 52, NULL, NULL, 144774),
(144775, '3.30.1120.10-FF-000036', NULL, 'Arylsulfatase', 89, NULL, NULL, 144775),
(144776, '2.60.120.650-FF-000227', NULL, 'Bifunctional lysine-specific demethylase and histidyl-hydroxylase NO66', 169, NULL, NULL, 144776),
(144777, '1.20.1070.10-FF-001693', NULL, 'Predicted protein', 111, NULL, NULL, 144777),
(144778, '1.10.30.10-FF-000159', NULL, 'Uncharacterized protein', 66, NULL, NULL, 144778),
(144779, '3.30.70.330-FF-000631', NULL, 'Glycine-rich RNA-binding protein 3, mitochondrial', 127, NULL, NULL, 144779),
(144780, '3.30.70.270-FF-000091', NULL, 'DNA repair protein REV1', 103, NULL, NULL, 144780),
(144781, '1.20.1080.10-FF-000058', NULL, 'Probable aquaporin SIP2-1', 232, NULL, NULL, 144781),
(144782, '3.30.50.10-FF-000104', NULL, 'Predicted protein', 56, NULL, NULL, 144782),
(144783, '3.30.160.60-FF-004623', NULL, NULL, 34, NULL, NULL, 144783),
(144784, '1.20.1250.40-FF-000047', NULL, 'Uncharacterized protein', 80, NULL, NULL, 144784),
(144785, '3.40.1090.10-FF-000019', NULL, 'Patatin-like phospholipase domain-containing 2', 95, NULL, NULL, 144785),
(144786, '1.10.510.10-FF-000247', NULL, 'Myosin IIIA', 307, NULL, NULL, 144786),
(144787, '3.90.70.10-FF-000384', NULL, 'Cathepsin La', 185, NULL, NULL, 144787),
(144788, '1.20.120.980-FF-000044', NULL, 'Prolylcarboxypeptidase, putative', 14, NULL, NULL, 144788),
(144789, '2.40.50.180-FF-000011', NULL, 'Putative chemotaxis protein CheV', 70, NULL, NULL, 144789),
(144790, '3.90.640.10-FF-000040', NULL, 'Actin-like protein ARP6', 107, NULL, NULL, 144790),
(144791, '1.10.472.10-FF-000242', NULL, 'Uncharacterized protein', 127, NULL, NULL, 144791),
(144792, '1.10.20.10-FF-000170', NULL, 'Histone H2A', 74, NULL, NULL, 144792),
(144793, '1.10.287.770-FF-000022', NULL, 'CD3 antigen delta polypeptide', 32, NULL, NULL, 144793),
(144794, '1.25.40.10-FF-004274', NULL, 'Uncharacterized protein', 212, NULL, NULL, 144794),
(144795, '3.40.50.1820-FF-001638', NULL, 'Uncharacterized protein', 415, NULL, NULL, 144795),
(144796, '2.60.40.10-FF-004786', NULL, NULL, 134, NULL, NULL, 144796),
(144797, '3.40.50.10110-FF-000005', NULL, 'DNA polymerase III chi subunit', 143, NULL, NULL, 144797),
(144798, '1.25.40.10-FF-000351', NULL, 'Pentatricopeptide repeat-containing protein', 104, NULL, NULL, 144798),
(144799, '2.40.70.10-FF-000528', NULL, NULL, 209, NULL, NULL, 144799),
(144800, '3.40.309.10-FF-000034', NULL, 'Aldehyde dehydrogenase, dimeric NADP-preferring', 75, NULL, NULL, 144800);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(144801, '3.30.559.30-FF-000078', NULL, 'MFS transporter/NRPS-like enzyme, putative (JCVI)', 229, NULL, NULL, 144801),
(144802, '3.80.10.10-FF-003275', NULL, 'Toll-like receptor 2', 164, NULL, NULL, 144802),
(144803, '2.60.34.10-FF-000124', NULL, 'Uncharacterized protein', 152, NULL, NULL, 144803),
(144804, '1.25.40.20-FF-000354', NULL, 'Leucine-rich repeat kinase, isoform C', 148, NULL, NULL, 144804),
(144805, '3.80.10.10-FF-000869', NULL, 'Leucine-rich repeat containing protein', 103, NULL, NULL, 144805),
(144806, '3.30.40.10-FF-000311', NULL, 'E3 ubiquitin-protein ligase SINAT5-like', 95, NULL, NULL, 144806),
(144807, '3.40.50.460-FF-000001', NULL, 'ATP-dependent 6-phosphofructokinase', 139, NULL, NULL, 144807),
(144808, '3.40.50.1580-FF-000010', NULL, 'Purine nucleoside phosphorylase', 271, NULL, NULL, 144808),
(144809, '1.25.40.1050-FF-000003', NULL, '5''-3'' exoribonuclease', 99, NULL, NULL, 144809),
(144810, '1.25.40.10-FF-000963', NULL, 'Programmed cell death protein pre-rrna processing protein rrp5', 131, NULL, NULL, 144810),
(144811, '3.30.1550.10-FF-000001', NULL, '50S ribosomal protein L11', 68, NULL, NULL, 144811),
(144812, '3.40.50.300-FF-004118', NULL, 'ABC transporter ATP-binding protein', 72, NULL, NULL, 144812),
(144813, '1.10.510.10-FF-003041', NULL, NULL, 216, NULL, NULL, 144813),
(144814, '3.40.50.300-FF-006782', NULL, 'Uncharacterized protein', 59, NULL, NULL, 144814),
(144815, '1.25.40.20-FF-000966', NULL, 'Putative calmodulin-binding transcription activator', 130, NULL, NULL, 144815),
(144816, '3.80.10.10-FF-001358', NULL, 'Receptor like protein 29', 73, NULL, NULL, 144816),
(144817, '3.40.50.880-FF-000037', NULL, 'DJ-1 family protein', 196, NULL, NULL, 144817),
(144818, '3.40.140.10-FF-000204', NULL, 'Uncharacterized protein', 185, NULL, NULL, 144818),
(144819, '3.40.50.620-FF-000414', NULL, 'Isoleucine--tRNA ligase, cytoplasmic-like', 202, NULL, NULL, 144819),
(144820, '1.25.40.10-FF-004566', NULL, 'Uncharacterized protein', 196, NULL, NULL, 144820),
(144821, '3.30.160.60-FF-006422', NULL, NULL, 24, NULL, NULL, 144821),
(144822, '3.10.20.90-FF-000913', NULL, 'Serine/threonine-protein kinase phg2', 95, NULL, NULL, 144822),
(144823, '1.20.20.10-FF-000028', NULL, 'ATP synthase subunit c', 73, NULL, NULL, 144823),
(144824, '1.20.1250.20-FF-001968', NULL, 'Uncharacterized protein', 410, NULL, NULL, 144824),
(144825, '3.10.250.10-FF-000129', NULL, NULL, 70, NULL, NULL, 144825),
(144826, '3.90.76.10-FF-000037', NULL, 'ABC transporter substrate-binding protein-oligopeptide transport', 132, NULL, NULL, 144826),
(144827, '3.30.160.60-FF-003600', NULL, NULL, 28, NULL, NULL, 144827),
(144828, '4.10.410.40-FF-000001', NULL, 'Phage major tail protein', 153, NULL, NULL, 144828),
(144829, '2.130.10.10-FF-004590', NULL, 'Uncharacterized protein', 206, NULL, NULL, 144829),
(144830, '3.90.1150.10-FF-000114', NULL, 'Serine hydroxymethyltransferase', 142, NULL, NULL, 144830),
(144831, '3.40.50.150-FF-000195', NULL, 'Methyltransferase domain containing protein', 180, NULL, NULL, 144831),
(144832, '1.10.3720.10-FF-000234', NULL, 'Phosphonate ABC transporter, permease protein', 198, NULL, NULL, 144832),
(144833, '3.40.50.280-FF-000003', NULL, 'Dimethylamine methyltransferase corrinoid protein', 134, NULL, NULL, 144833),
(144834, '3.30.830.10-FF-000085', NULL, 'Uncharacterized protein', 218, NULL, NULL, 144834),
(144835, '2.60.120.200-FF-000115', NULL, 'Galectin', 152, NULL, NULL, 144835),
(144836, '2.60.120.260-FF-000094', NULL, 'Cyclic di-GMP-binding protein', 160, NULL, NULL, 144836),
(144837, '1.25.40.20-FF-001129', NULL, 'Uncharacterized protein', 180, NULL, NULL, 144837),
(144838, '2.60.40.150-FF-000602', NULL, 'Si:rp71-17i16.5', 73, NULL, NULL, 144838),
(144839, '3.70.10.10-FF-000038', NULL, 'DNA polymerase sliding clamp 1', 249, NULL, NULL, 144839),
(144840, '3.40.50.300-FF-008367', NULL, 'GTPase Era', 167, NULL, NULL, 144840),
(144841, '3.40.640.10-FF-000326', NULL, 'Uncharacterized protein', 170, NULL, NULL, 144841),
(144842, '1.20.1050.10-FF-000023', NULL, 'Probable glutathione S-transferase GSTU6', 143, NULL, NULL, 144842);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(144843, '3.30.160.60-FF-004348', NULL, NULL, 73, NULL, NULL, 144843),
(144844, '3.30.40.10-FF-000362', NULL, 'E3 ubiquitin-protein ligase TRIM56', 83, NULL, NULL, 144844),
(144845, '3.40.50.1580-FF-000061', NULL, 'Purine nucleoside phosphorylase-like Protein', 232, NULL, NULL, 144845),
(144846, '3.40.50.11710-FF-000002', NULL, 'Cyclo(L-tyrosyl-L-tyrosyl) synthase', 241, NULL, NULL, 144846),
(144847, '3.40.50.200-FF-000199', NULL, 'Peptidase S8 and S53 subtilisin kexin sedolisin', 311, NULL, NULL, 144847),
(144848, '3.40.50.300-FF-007884', NULL, 'Uncharacterized protein ABCC16', 195, NULL, NULL, 144848),
(144849, '3.90.550.50-FF-000045', NULL, 'Glycoprotein-N-acetylgalactosamine 3-beta-galactosyltransferase 1', 209, NULL, NULL, 144849),
(144850, '2.40.50.140-FF-000061', NULL, 'ATP-dependent RNA helicase DHX8', 87, NULL, NULL, 144850),
(144851, '3.40.50.200-FF-000148', NULL, 'Tripeptidyl peptidase I', 43, NULL, NULL, 144851),
(144852, '3.40.50.1100-FF-000029', NULL, 'Cysteine synthase', 164, NULL, NULL, 144852),
(144853, '3.40.50.1240-FF-000043', NULL, 'Phosphoglycerate mutase', 211, NULL, NULL, 144853),
(144854, '1.25.40.10-FF-000637', NULL, 'Pentatricopeptide repeat-containing protein', 214, NULL, NULL, 144854),
(144855, '3.30.428.10-FF-000009', NULL, 'Galactose-1-phosphate uridylyltransferase', 171, NULL, NULL, 144855),
(144856, '1.25.40.20-FF-000915', NULL, 'Uncharacterized protein', 105, NULL, NULL, 144856),
(144857, '3.40.50.150-FF-000318', NULL, 'tRNA (adenine(58)-N(1))-methyltransferase', 236, NULL, NULL, 144857),
(144858, '3.30.160.60-FF-002139', NULL, 'Zinc finger protein 655', 35, NULL, NULL, 144858),
(144859, '2.60.120.10-FF-000697', NULL, 'Acireductone dioxygenase, putative', 52, NULL, NULL, 144859),
(144860, '3.30.70.1660-FF-000008', NULL, 'Peptide chain release factor 1', 135, NULL, NULL, 144860),
(144861, '3.40.225.10-FF-000002', NULL, 'alpha-adducin isoform X2', 257, NULL, NULL, 144861),
(144862, '3.40.630.10-FF-000500', NULL, 'Predicted protein', 296, NULL, NULL, 144862),
(144863, '2.120.10.80-FF-000345', NULL, 'Uncharacterized protein', 95, NULL, NULL, 144863),
(144864, '1.20.5.190-FF-000084', NULL, 'Abnormal spindle microtubule assembly', 43, NULL, NULL, 144864),
(144865, '1.10.10.10-FF-000551', NULL, 'MarR family transcriptional regulator', 144, NULL, NULL, 144865),
(144866, '1.20.5.170-FF-000105', NULL, 'AP-1-like transcription factor YAP4', 66, NULL, NULL, 144866),
(144867, '1.10.287.630-FF-000008', NULL, 'Cyclic nucleotide-gated ion channel 11', 65, NULL, NULL, 144867),
(144868, '3.50.50.60-FF-000202', NULL, 'Sarcosine dehydrogenase, mitochondrial', 160, NULL, NULL, 144868),
(144869, '2.170.140.10-FF-000031', NULL, 'Chitinase 4', 60, NULL, NULL, 144869),
(144870, '3.40.50.300-FF-002853', NULL, 'Protein-tyrosine sulfotransferase', 275, NULL, NULL, 144870),
(144871, '2.40.160.110-FF-000022', NULL, 'Uncharacterized protein', 127, NULL, NULL, 144871),
(144872, '2.170.270.10-FF-000035', NULL, 'Histone-lysine N-methyltransferase', 257, NULL, NULL, 144872),
(144873, '1.10.620.20-FF-000051', NULL, 'Uncharacterized protein', 73, NULL, NULL, 144873),
(144874, '2.130.10.10-FF-002853', NULL, 'Nuclear pore protein seh1, putative', 344, NULL, NULL, 144874),
(144875, '2.130.10.10-FF-000548', NULL, 'Protein TRANSPARENT TESTA GLABRA 1', 221, NULL, NULL, 144875),
(144876, '1.25.10.10-FF-003311', NULL, 'Serine/threonine-protein kinase TOR', 156, NULL, NULL, 144876),
(144877, '2.40.170.20-FF-000016', NULL, 'Iron-regulated outer membrane virulence protein', 485, NULL, NULL, 144877),
(144878, '3.30.1360.200-FF-000010', NULL, 'Protein translocase subunit SecD', 144, NULL, NULL, 144878),
(144879, '1.10.730.10-FF-000112', NULL, 'Valine--tRNA ligase', 262, NULL, NULL, 144879),
(144880, '3.30.70.330-FF-000923', NULL, 'RNA-binding protein 1', 126, NULL, NULL, 144880),
(144881, '1.20.1070.10-FF-001367', NULL, 'Uncharacterized protein', 261, NULL, NULL, 144881),
(144882, '3.90.1140.10-FF-000057', NULL, '2'',3''-cyclic-nucleotide 3''-phosphodiesterase', 188, NULL, NULL, 144882),
(144883, '3.80.10.10-FF-000223', NULL, 'Leucine-rich repeat-containing 8 VRAC subunit A', 231, NULL, NULL, 144883);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(144884, '3.30.160.60-FF-006473', NULL, NULL, 46, NULL, NULL, 144884),
(144885, '3.40.50.300-FF-004444', NULL, 'Cytoplasmic dynein 1b light intermediate chain, D1bLIC', 153, NULL, NULL, 144885),
(144886, '2.40.160.120-FF-000025', NULL, 'Oxysterol-binding protein/PH domain-containing protein', 155, NULL, NULL, 144886),
(144887, '3.40.50.1820-FF-001077', NULL, 'Acylamino-acid-releasing enzyme', 252, NULL, NULL, 144887),
(144888, '3.40.50.300-FF-008160', NULL, 'Uncharacterized protein', 90, NULL, NULL, 144888),
(144889, '2.40.30.10-FF-000178', NULL, 'Elongation factor Tu homologue', 101, NULL, NULL, 144889),
(144890, '3.40.50.720-FF-002243', NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase NAD-binding', 86, NULL, NULL, 144890),
(144891, '1.25.40.10-FF-000912', NULL, 'Pentatricopeptide repeat protein PPR986-12', 169, NULL, NULL, 144891),
(144892, '2.10.110.10-FF-000106', NULL, 'F-actin-monooxygenase MICAL1 isoform 1', 78, NULL, NULL, 144892),
(144893, '3.30.1360.210-FF-000013', NULL, 'Uncharacterized protein', 105, NULL, NULL, 144893),
(144894, '3.30.160.60-FF-004909', NULL, NULL, 57, NULL, NULL, 144894),
(144895, '2.30.29.220-FF-000002', NULL, 'FACT complex subunit SSRP1', 84, NULL, NULL, 144895),
(144896, '3.80.10.10-FF-001684', NULL, 'Predicted protein', 293, NULL, NULL, 144896),
(144897, '1.25.10.10-FF-002822', NULL, 'Protein HEATR9', 191, NULL, NULL, 144897),
(144898, '3.50.50.60-FF-000253', NULL, 'NAD(P)H-dependent glutamate synthase, putative', 117, NULL, NULL, 144898),
(144899, '2.10.110.10-FF-000252', NULL, 'Ci-Fhl1/2/3 protein', 63, NULL, NULL, 144899),
(144900, '1.10.510.10-FF-002198', NULL, NULL, 142, NULL, NULL, 144900),
(144901, '1.20.1160.11-FF-000009', NULL, 'F3I6.18 protein', 64, NULL, NULL, 144901),
(144902, '3.40.1410.10-FF-000011', NULL, 'Phosphonate metabolism transcriptional regulator PhnF', 165, NULL, NULL, 144902),
(144903, '3.40.390.10-FF-000222', NULL, NULL, 150, NULL, NULL, 144903),
(144904, '3.30.70.330-FF-000305', NULL, 'speckle targeted PIP5K1A-regulated poly(A) polymerase', 73, NULL, NULL, 144904),
(144905, '3.10.20.90-FF-000655', NULL, 'Uncharacterized protein', 95, NULL, NULL, 144905),
(144906, '3.10.450.10-FF-000049', NULL, 'Uncharacterized protein', 121, NULL, NULL, 144906),
(144907, '1.10.510.10-FF-000573', NULL, 'Uncharacterized protein, isoform D', 307, NULL, NULL, 144907),
(144908, '1.20.1070.10-FF-001772', NULL, 'Uncharacterized protein', 54, NULL, NULL, 144908),
(144909, '2.30.30.40-FF-000327', NULL, 'CIN85 and CD2AP related, isoform D', 81, NULL, NULL, 144909),
(144910, '3.30.160.60-FF-002757', NULL, 'Zinc finger protein, putative', 25, NULL, NULL, 144910),
(144911, '3.30.160.60-FF-006068', NULL, NULL, 41, NULL, NULL, 144911),
(144912, '3.40.50.150-FF-000936', NULL, 'Uncharacterized protein', 249, NULL, NULL, 144912),
(144913, '1.20.1310.10-FF-000234', NULL, NULL, 104, NULL, NULL, 144913),
(144914, '3.30.70.270-FF-000040', NULL, 'DNA repair protein REV1', 127, NULL, NULL, 144914),
(144915, '3.55.50.30-FF-000008', NULL, 'Putative anti-sigma factor', 76, NULL, NULL, 144915),
(144916, '1.20.58.60-FF-000113', NULL, 'A-kinase anchor protein 6', 113, NULL, NULL, 144916),
(144917, '2.30.29.240-FF-000008', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 33, NULL, NULL, 144917),
(144918, '3.40.50.1820-FF-000503', NULL, 'Alpha/beta fold hydrolase', 286, NULL, NULL, 144918),
(144919, '2.30.29.230-FF-000005', NULL, 'RabGAP/TBC domain-containing protein', 129, NULL, NULL, 144919),
(144920, '3.40.50.920-FF-000010', NULL, 'Pyruvate ferredoxin oxidoreductase, alpha subunit', 139, NULL, NULL, 144920),
(144921, '1.25.10.10-FF-000574', NULL, 'Kinesin-like protein', 85, NULL, NULL, 144921),
(144922, '2.40.50.100-FF-000189', NULL, 'Probable cation efflux system (CzcB-like)', 66, NULL, NULL, 144922),
(144923, '3.40.630.30-FF-000686', NULL, 'Putative acyl-CoA N-acyltransferase (NAT) family protein', 74, NULL, NULL, 144923),
(144924, '3.10.129.10-FF-000212', NULL, 'Acyl-CoA thioesterase', 129, NULL, NULL, 144924),
(144925, '1.20.5.470-FF-000010', NULL, 'Uncharacterized protein', 35, NULL, NULL, 144925);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(144926, '2.60.40.790-FF-000092', NULL, 'SHQ1 isoform 5', 82, NULL, NULL, 144926),
(144927, '3.40.630.10-FF-000051', NULL, 'Peptidase M28', 239, NULL, NULL, 144927),
(144928, '1.10.10.60-FF-000425', NULL, 'Homeobox and leucine zipper encoding a', 55, NULL, NULL, 144928),
(144929, '1.10.150.240-FF-000055', NULL, 'HAD hydrolase, family IA', 59, NULL, NULL, 144929),
(144930, '3.90.226.10-FF-000353', NULL, 'Uncharacterized protein', 265, NULL, NULL, 144930),
(144931, '3.90.120.10-FF-000012', NULL, 'Probable BsuMI modification methylase subunit YdiO', 134, NULL, NULL, 144931),
(144932, '2.60.40.10-FF-001352', NULL, 'MAM domain containing glycosylphosphatidylinositol anchor 1', 96, NULL, NULL, 144932),
(144933, '1.25.40.840-FF-000016', NULL, 'Uncharacterized protein', 90, NULL, NULL, 144933),
(144934, '3.60.40.10-FF-000299', NULL, 'Uncharacterized protein', 111, NULL, NULL, 144934),
(144935, '2.60.40.1180-FF-000184', NULL, 'Alpha-amylase', 99, NULL, NULL, 144935),
(144936, '1.10.510.10-FF-000753', NULL, 'CAMK/CAMKL protein kinase', 291, NULL, NULL, 144936),
(144937, '2.60.120.40-FF-000065', NULL, 'Myeloid-specific peroxidase', 65, NULL, NULL, 144937),
(144938, '2.160.20.60-FF-000012', NULL, 'Ferredoxin-glutamate synthase, putative', 181, NULL, NULL, 144938),
(144939, '2.60.120.10-FF-000646', NULL, 'Uncharacterized protein', 154, NULL, NULL, 144939),
(144940, '1.25.10.10-FF-002760', NULL, 'Uncharacterized protein', 610, NULL, NULL, 144940),
(144941, '3.30.1330.40-FF-000004', NULL, 'Translation initiation inhibitor', 116, NULL, NULL, 144941),
(144942, '3.40.640.10-FF-000118', NULL, 'Acetylornithine aminotransferase', 249, NULL, NULL, 144942),
(144943, '4.10.800.10-FF-000027', NULL, 'Thyroglobulin', 69, NULL, NULL, 144943),
(144944, '2.120.10.80-FF-000019', NULL, 'Kelch-like family member 17', 169, NULL, NULL, 144944),
(144945, '1.25.40.20-FF-000562', NULL, 'Uncharacterized protein, isoform C', 238, NULL, NULL, 144945),
(144946, '3.40.225.10-FF-000053', NULL, NULL, 188, NULL, NULL, 144946),
(144947, '3.10.20.90-FF-000981', NULL, 'Uncharacterized protein', 98, NULL, NULL, 144947),
(144948, '2.130.10.10-FF-000341', NULL, 'WD repeat-containing protein 81 isoform X1', 157, NULL, NULL, 144948),
(144949, '2.60.40.10-FF-004056', NULL, NULL, 96, NULL, NULL, 144949),
(144950, '3.30.1300.10-FF-000016', NULL, NULL, 116, NULL, NULL, 144950),
(144951, '2.60.40.10-FF-000784', NULL, 'Striated muscle preferentially expressed protein kinase', 103, NULL, NULL, 144951),
(144952, '3.30.230.10-FF-000005', NULL, 'DNA gyrase subunit B', 174, NULL, NULL, 144952),
(144953, '3.90.190.20-FF-000047', NULL, 'Folyl-polyglutamate synthetase', 144, NULL, NULL, 144953),
(144954, '3.40.50.10860-FF-000056', NULL, 'Bifunctional protein FolD', 148, NULL, NULL, 144954),
(144955, '3.40.50.12780-FF-000002', NULL, 'Disco interacting protein 2 homolog B', 482, NULL, NULL, 144955),
(144956, '2.130.10.10-FF-001330', NULL, 'Protein CYPRO4', 190, NULL, NULL, 144956),
(144957, '3.50.7.10-FF-000050', NULL, 'Bardet-Biedl syndrome 12', 152, NULL, NULL, 144957),
(144958, '3.30.200.20-FF-000411', NULL, 'Pti1 kinase-like protein', 101, NULL, NULL, 144958),
(144959, '1.10.274.100-FF-000020', NULL, 'DNA-directed RNA polymerase subunit beta''', 90, NULL, NULL, 144959),
(144960, '3.40.5.60-FF-000003', NULL, 'DNA replication complex GINS protein SLD5', 58, NULL, NULL, 144960),
(144961, '3.30.420.40-FF-000675', NULL, 'Predicted protein', 95, NULL, NULL, 144961),
(144962, '1.20.58.1380-FF-000011', NULL, 'Npp-15', 80, NULL, NULL, 144962),
(144963, '3.40.50.720-FF-001815', NULL, 'Lovastatin diketide synthase LovF', 243, NULL, NULL, 144963),
(144964, '2.60.40.10-FF-000745', NULL, 'Myomesin 3', 98, NULL, NULL, 144964),
(144965, '3.30.70.330-FF-002840', NULL, NULL, 85, NULL, NULL, 144965),
(144966, '2.160.10.10-FF-000070', NULL, 'UDP-N-acetylbacillosamine N-acetyltransferase', 119, NULL, NULL, 144966),
(144967, '3.80.10.10-FF-001297', NULL, 'Uncharacterized protein AT4g34280', 73, NULL, NULL, 144967),
(144968, '3.40.50.150-FF-001330', NULL, NULL, 291, NULL, NULL, 144968); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(144969, '3.10.120.10-FF-000013', NULL, 'Neudesin', 101, NULL, NULL, 144969),
(144970, '3.90.190.10-FF-000044', NULL, 'Dual specificity protein phosphatase 8', 151, NULL, NULL, 144970),
(144971, '3.30.60.20-FF-000085', NULL, 'Rap Guanine nucleotide Exchange Factor homolog', 66, NULL, NULL, 144971),
(144972, '2.130.10.10-FF-002465', NULL, 'Os03g0735100 protein', 122, NULL, NULL, 144972),
(144973, '3.40.50.720-FF-001872', NULL, 'Uncharacterized protein', 69, NULL, NULL, 144973),
(144974, '2.40.10.10-FF-000345', NULL, NULL, 128, NULL, NULL, 144974),
(144975, '1.10.455.10-FF-000039', NULL, 'Uncharacterized protein', 170, NULL, NULL, 144975),
(144976, '2.40.10.10-FF-000295', NULL, 'Inactive serine protease PAMR1', 269, NULL, NULL, 144976),
(144977, '1.10.10.10-FF-000517', NULL, 'Uncharacterized protein', 70, NULL, NULL, 144977),
(144978, '3.40.50.2020-FF-000182', NULL, 'Ribose-phosphate pyrophosphokinase 2 chloroplastic', 98, NULL, NULL, 144978),
(144979, '2.130.10.10-FF-002527', NULL, 'Putative SecA-type chloroplast protein transport factor', 232, NULL, NULL, 144979),
(144980, '3.40.50.1820-FF-001818', NULL, 'Uncharacterized protein', 321, NULL, NULL, 144980),
(144981, '2.130.10.10-FF-004556', NULL, 'Uncharacterized protein', 347, NULL, NULL, 144981),
(144982, '2.10.25.10-FF-000026', NULL, 'Teneurin transmembrane protein 2', 31, NULL, NULL, 144982),
(144983, '1.20.5.490-FF-000016', NULL, 'Uncharacterized protein', 34, NULL, NULL, 144983),
(144984, '3.30.60.30-FF-000088', NULL, 'Protein CBG17314', 52, NULL, NULL, 144984),
(144985, '1.10.10.160-FF-000041', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 97, NULL, NULL, 144985),
(144986, '2.60.260.20-FF-000131', NULL, 'Chaperone protein DnaJ', 107, NULL, NULL, 144986),
(144987, '3.30.160.60-FF-004505', NULL, NULL, 24, NULL, NULL, 144987),
(144988, '2.60.120.10-FF-000489', NULL, 'Uncharacterized protein', 99, NULL, NULL, 144988),
(144989, '1.20.1510.10-FF-000042', NULL, 'Metal tolerance protein B', 201, NULL, NULL, 144989),
(144990, '1.25.10.10-FF-002081', NULL, 'Uncharacterized protein', 108, NULL, NULL, 144990),
(144991, '1.10.510.10-FF-004384', NULL, NULL, 92, NULL, NULL, 144991),
(144992, '3.50.50.60-FF-001484', NULL, 'Uncharacterized protein', 50, NULL, NULL, 144992),
(144993, '1.25.10.10-FF-000523', NULL, 'Protein phosphatase PP2A regulatory subunit A', 208, NULL, NULL, 144993),
(144994, '3.50.30.30-FF-000097', NULL, 'Vacuolar sorting receptor', 189, NULL, NULL, 144994),
(144995, '3.30.70.330-FF-000811', NULL, 'Os07g0663300 protein', 110, NULL, NULL, 144995),
(144996, '2.10.110.10-FF-000044', NULL, 'Rho GTPase activator Rga', 57, NULL, NULL, 144996),
(144997, '3.30.160.60-FF-002471', NULL, 'Zinc finger protein 311', 28, NULL, NULL, 144997),
(144998, '2.130.10.10-FF-000436', NULL, 'Regulator of MON1-CCZ1 complex', 136, NULL, NULL, 144998),
(144999, '3.30.450.40-FF-000227', NULL, 'PAS domain-containing protein', 179, NULL, NULL, 144999),
(145000, '3.30.505.10-FF-000268', NULL, NULL, 111, NULL, NULL, 145000),
(145001, '1.25.40.10-FF-002357', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 159, NULL, NULL, 145001),
(145002, '1.10.220.10-FF-000034', NULL, 'Annexin', 79, NULL, NULL, 145002),
(145003, '3.90.950.10-FF-000024', NULL, 'dITP/XTP pyrophosphatase', 196, NULL, NULL, 145003),
(145004, '1.10.10.60-FF-000330', NULL, 'LIM homeobox transcription factor 1 alpha', 65, NULL, NULL, 145004),
(145005, '2.60.40.10-FF-006085', NULL, NULL, 46, NULL, NULL, 145005),
(145006, '3.40.50.2300-FF-001356', NULL, NULL, 28, NULL, NULL, 145006),
(145007, '2.30.30.40-FF-000653', NULL, 'Uncharacterized protein', 69, NULL, NULL, 145007),
(145008, '3.30.1360.40-FF-000040', NULL, 'DNA topoisomerase 2', 114, NULL, NULL, 145008),
(145009, '2.30.42.10-FF-000150', NULL, 'Membrane associated guanylate kinase, WW and PDZ domain containing 2', 111, NULL, NULL, 145009),
(145010, '3.30.1320.10-FF-000017', NULL, '30S ribosomal protein S16-1, chloroplastic isoform A', 91, NULL, NULL, 145010),
(145011, '3.40.50.12350-FF-000014', NULL, 'Predicted protein', 95, NULL, NULL, 145011);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(145012, '1.25.40.820-FF-000010', NULL, 'Uncharacterized protein', 141, NULL, NULL, 145012),
(145013, '1.20.58.390-FF-000087', NULL, 'GABA-gated ion channel', 141, NULL, NULL, 145013),
(145014, '1.50.10.130-FF-000023', NULL, NULL, 75, NULL, NULL, 145014),
(145015, '2.40.70.10-FF-000354', NULL, NULL, 145, NULL, NULL, 145015),
(145016, '3.40.50.150-FF-000756', NULL, 'Uncharacterized protein', 199, NULL, NULL, 145016),
(145017, '3.30.420.40-FF-000046', NULL, 'Chaperone protein HscA', 187, NULL, NULL, 145017),
(145018, '3.30.160.60-FF-004174', NULL, NULL, 28, NULL, NULL, 145018),
(145019, '3.40.50.620-FF-000240', NULL, 'Methionine--tRNA ligase, putative', 132, NULL, NULL, 145019),
(145020, '3.30.70.980-FF-000039', NULL, 'Uncharacterized protein', 86, NULL, NULL, 145020),
(145021, '3.30.2130.30-FF-000020', NULL, 'RNA-binding protein, containing THUMP domain', 151, NULL, NULL, 145021),
(145022, '3.40.50.150-FF-000436', NULL, 'Thiopurine S-methyltransferase, putative', 194, NULL, NULL, 145022),
(145023, '2.60.40.150-FF-000653', NULL, 'Predicted protein', 111, NULL, NULL, 145023),
(145024, '2.60.40.10-FF-000458', NULL, 'Molecular chaperone FimC', 118, NULL, NULL, 145024),
(145025, '3.90.190.10-FF-000578', NULL, 'Predicted protein', 169, NULL, NULL, 145025),
(145026, '3.30.497.10-FF-000146', NULL, 'Uncharacterized protein', 152, NULL, NULL, 145026),
(145027, '3.30.1330.50-FF-000007', NULL, '2-C-methyl-D-erythritol 2,4-cyclodiphosphate synthase', 161, NULL, NULL, 145027),
(145028, '2.160.20.70-FF-000015', NULL, 'BnaA04g27540D protein', 159, NULL, NULL, 145028),
(145029, '2.40.50.120-FF-000015', NULL, 'Procollagen C-endopeptidase enhancer 2', 125, NULL, NULL, 145029),
(145030, '3.40.190.10-FF-000870', NULL, 'Glutamine-binding periplasmic protein/glutamine transport system permease protein', 95, NULL, NULL, 145030),
(145031, '2.130.10.10-FF-004764', NULL, 'Uncharacterized protein', 157, NULL, NULL, 145031),
(145032, '1.20.1070.10-FF-001480', NULL, 'AGAP008237-PA', 208, NULL, NULL, 145032),
(145033, '2.40.37.20-FF-000005', NULL, 'Uncharacterized protein MT1457', 132, NULL, NULL, 145033),
(145034, '1.20.1250.20-FF-001676', NULL, 'Deoxyribose-phosphate aldolase, putative (AFU_orthologue AFUA_3G06590)', 282, NULL, NULL, 145034),
(145035, '3.30.70.330-FF-001946', NULL, NULL, 174, NULL, NULL, 145035),
(145036, '2.10.25.10-FF-001813', NULL, 'Uncharacterized protein', 30, NULL, NULL, 145036),
(145037, '3.40.50.720-FF-000444', NULL, 'L-idonate 5-dehydrogenase', 134, NULL, NULL, 145037),
(145038, '3.40.50.2300-FF-000900', NULL, NULL, 136, NULL, NULL, 145038),
(145039, '1.10.357.140-FF-000030', NULL, 'Digeranylgeranylglyceryl phosphate synthase', 147, NULL, NULL, 145039),
(145040, '3.40.50.2000-FF-000024', NULL, 'Trehalose-6-phosphate synthase', 209, NULL, NULL, 145040),
(145041, '1.10.472.130-FF-000051', NULL, 'Dynein heavy chain 5, axonemal', 139, NULL, NULL, 145041),
(145042, '3.30.230.10-FF-000062', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 166, NULL, NULL, 145042),
(145043, '3.30.70.330-FF-002104', NULL, NULL, 118, NULL, NULL, 145043),
(145044, '3.30.830.10-FF-000259', NULL, 'Uncharacterized protein', 89, NULL, NULL, 145044),
(145045, '1.25.10.10-FF-000248', NULL, 'MAP3K epsilon protein kinase 1', 216, NULL, NULL, 145045),
(145046, '3.40.50.300-FF-001521', NULL, 'Iron-sulfur cluster carrier protein', 225, NULL, NULL, 145046),
(145047, '3.30.160.60-FF-000958', NULL, 'Odd skipped', 29, NULL, NULL, 145047),
(145048, '2.160.20.10-FF-000312', NULL, 'Uncharacterized protein', 222, NULL, NULL, 145048),
(145049, '3.40.50.10490-FF-000023', NULL, 'Glucose-6-phosphate isomerase', 184, NULL, NULL, 145049),
(145050, '1.10.1070.11-FF-000134', NULL, 'Uncharacterized protein', 205, NULL, NULL, 145050),
(145051, '3.40.640.10-FF-000231', NULL, 'Aminotransferase', 210, NULL, NULL, 145051),
(145052, '1.20.140.150-FF-000131', NULL, 'Transmembrane protein 114', 108, NULL, NULL, 145052),
(145053, '3.30.160.60-FF-004269', NULL, NULL, 26, NULL, NULL, 145053),
(145054, '3.90.550.50-FF-000084', NULL, 'Predicted protein', 198, NULL, NULL, 145054);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(145055, '1.10.472.10-FF-000124', NULL, 'Cyclin homologue', 153, NULL, NULL, 145055),
(145056, '1.10.418.10-FF-000246', NULL, 'Uncharacterized protein', 109, NULL, NULL, 145056),
(145057, '3.40.50.1000-FF-000651', NULL, NULL, 155, NULL, NULL, 145057),
(145058, '1.20.1270.20-FF-000003', NULL, 'Hydroxylamine reductase', 158, NULL, NULL, 145058),
(145059, '1.10.10.570-FF-000012', NULL, 'AaceriAGL318Wp', 104, NULL, NULL, 145059),
(145060, '3.30.40.10-FF-001379', NULL, 'GM26809', 75, NULL, NULL, 145060),
(145061, '1.10.418.10-FF-000066', NULL, 'plastin-1 isoform X2', 117, NULL, NULL, 145061),
(145062, '3.60.15.10-FF-000201', NULL, 'CPSF3L protein', 132, NULL, NULL, 145062),
(145063, '1.10.10.10-FF-000837', NULL, 'Histone acetyltransferase', 106, NULL, NULL, 145063),
(145064, '2.120.10.80-FF-000171', NULL, 'F-box/kelch-repeat protein At1g51550', 143, NULL, NULL, 145064),
(145065, '1.10.10.10-FF-000725', NULL, 'DNA repair protein Nse1, putative', 119, NULL, NULL, 145065),
(145066, '2.40.37.10-FF-000002', NULL, 'Alanine racemase', 147, NULL, NULL, 145066),
(145067, '2.30.33.40-FF-000008', NULL, '10 kDa chaperonin', 92, NULL, NULL, 145067),
(145068, '3.80.10.10-FF-003269', NULL, 'Toll, putative', 222, NULL, NULL, 145068),
(145069, '2.60.40.1170-FF-000029', NULL, 'AP-1 complex subunit mu-2', 113, NULL, NULL, 145069),
(145070, '1.25.10.10-FF-002529', NULL, 'Uncharacterized protein', 189, NULL, NULL, 145070),
(145071, '1.10.287.230-FF-000001', NULL, 'Nuclear export protein', 57, NULL, NULL, 145071),
(145072, '3.50.4.10-FF-000009', NULL, 'GG11699', 93, NULL, NULL, 145072),
(145073, '1.25.10.10-FF-001512', NULL, 'Armadillo repeat protein (AFU_orthologue AFUA_1G07050)', 202, NULL, NULL, 145073),
(145074, '1.25.40.20-FF-000348', NULL, 'Uncharacterized protein, isoform A', 136, NULL, NULL, 145074),
(145075, '1.20.1250.20-FF-002132', NULL, 'Organic anion transporter, putative', 208, NULL, NULL, 145075),
(145076, '1.10.510.10-FF-003602', NULL, NULL, 201, NULL, NULL, 145076),
(145077, '2.130.10.10-FF-005899', NULL, 'Uncharacterized protein', 287, NULL, NULL, 145077),
(145078, '3.40.50.300-FF-004736', NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase PRP16', 174, NULL, NULL, 145078),
(145079, '1.20.1250.20-FF-001581', NULL, 'Solute carrier organic anion transporter family member', 345, NULL, NULL, 145079),
(145080, '3.40.50.1580-FF-000009', NULL, 'Uridine phosphorylase 2', 307, NULL, NULL, 145080),
(145081, '3.60.110.10-FF-000080', NULL, NULL, 262, NULL, NULL, 145081),
(145082, '3.40.50.300-FF-006456', NULL, 'Uncharacterized protein', 121, NULL, NULL, 145082),
(145083, '3.30.200.20-FF-002502', NULL, 'Uncharacterized protein', 118, NULL, NULL, 145083),
(145084, '3.90.79.10-FF-000139', NULL, 'Putative nudix hydrolase 2', 207, NULL, NULL, 145084),
(145085, '1.20.5.110-FF-000279', NULL, 'Ubiquitin-conjugating enzyme', 52, NULL, NULL, 145085),
(145086, '2.130.10.10-FF-004831', NULL, 'U3 small nucleolar RNA-associated protein 15', 134, NULL, NULL, 145086),
(145087, '3.30.750.24-FF-000069', NULL, 'Sodium-independent anion transporter', 137, NULL, NULL, 145087),
(145088, '3.90.79.10-FF-000291', NULL, 'Adenine DNA glycosylase', 143, NULL, NULL, 145088),
(145089, '3.30.40.10-FF-000036', NULL, 'nucleosome-remodeling factor subunit BPTF isoform X1', 54, NULL, NULL, 145089),
(145090, '3.90.1640.10-FF-000022', NULL, 'Inorganic pyrophosphatase, manganese-dependent', 188, NULL, NULL, 145090),
(145091, '1.10.10.10-FF-001332', NULL, 'IclR family transcriptional regulator', 74, NULL, NULL, 145091),
(145092, '3.30.160.60-FF-002583', NULL, 'Zinc finger protein, putative', 59, NULL, NULL, 145092),
(145093, '3.30.710.10-FF-000430', NULL, 'Uncharacterized protein', 85, NULL, NULL, 145093),
(145094, '3.40.47.10-FF-000225', NULL, NULL, 113, NULL, NULL, 145094),
(145095, '3.60.20.10-FF-000123', NULL, 'Proteasome subunit beta', 202, NULL, NULL, 145095),
(145096, '1.25.40.190-FF-000012', NULL, NULL, 70, NULL, NULL, 145096),
(145097, '2.60.120.650-FF-000019', NULL, 'Bifunctional peptidase and arginyl-hydroxylase JMJD5', 235, NULL, NULL, 145097);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(145098, '1.10.510.10-FF-004176', NULL, NULL, 187, NULL, NULL, 145098),
(145099, '3.30.70.330-FF-002161', NULL, NULL, 119, NULL, NULL, 145099),
(145100, '3.40.640.10-FF-000495', NULL, 'Predicted protein', 267, NULL, NULL, 145100),
(145101, '3.30.230.10-FF-000123', NULL, 'Galactokinase', 186, NULL, NULL, 145101),
(145102, '3.30.70.330-FF-000070', NULL, 'Epithelial splicing regulatory protein 1', 97, NULL, NULL, 145102),
(145103, '3.40.50.1000-FF-000494', NULL, 'bifunctional polynucleotide phosphatase/kinase', 192, NULL, NULL, 145103),
(145104, '3.80.10.10-FF-003483', NULL, 'Uncharacterized protein', 203, NULL, NULL, 145104),
(145105, '2.40.50.140-FF-000353', NULL, 'Mitochondrial ribosomal protein', 107, NULL, NULL, 145105),
(145106, '3.40.50.150-FF-000644', NULL, 'FBL isoform 7', 128, NULL, NULL, 145106),
(145107, '3.90.226.10-FF-000173', NULL, 'Enoyl-CoA hydratase', 247, NULL, NULL, 145107),
(145108, '2.60.120.260-FF-000329', NULL, 'Uncharacterized protein', 199, NULL, NULL, 145108),
(145109, '3.40.50.1000-FF-000437', NULL, NULL, 68, NULL, NULL, 145109),
(145110, '3.10.20.70-FF-000020', NULL, 'Glutamine synthetase protein', 105, NULL, NULL, 145110),
(145111, '3.40.50.720-FF-001462', NULL, 'UDP-glucose/GDP-mannose dehydrogenase, putative', 199, NULL, NULL, 145111),
(145112, '3.10.20.90-FF-000705', NULL, 'Uncharacterized protein', 89, NULL, NULL, 145112),
(145113, '1.10.8.60-FF-000582', NULL, 'ORC1-type DNA replication protein 2', 32, NULL, NULL, 145113),
(145114, '2.40.50.860-FF-000001', NULL, 'Cell division control protein 13', 131, NULL, NULL, 145114),
(145115, '1.10.1610.10-FF-000001', NULL, 'Nicotinate-nucleotide--dimethylbenzimidazole phosphoribosyltransferase', 58, NULL, NULL, 145115),
(145116, '3.40.390.10-FF-000172', NULL, NULL, 27, NULL, NULL, 145116),
(145117, '3.90.1150.10-FF-000035', NULL, 'Adenosylmethionine-8-amino-7-oxononanoate aminotransferase', 136, NULL, NULL, 145117),
(145118, '1.10.287.110-FF-000257', NULL, 'Chaperone DnaJ-domain superfamily protein', 108, NULL, NULL, 145118),
(145119, '3.30.160.60-FF-005163', NULL, NULL, 79, NULL, NULL, 145119),
(145120, '1.25.40.10-FF-003959', NULL, 'Uncharacterized protein', 252, NULL, NULL, 145120),
(145121, '3.60.40.10-FF-000001', NULL, 'protein phosphatase 1B isoform X1', 297, NULL, NULL, 145121),
(145122, '3.30.160.60-FF-004382', NULL, NULL, 25, NULL, NULL, 145122),
(145123, '1.25.10.10-FF-002586', NULL, 'Uncharacterized protein', 157, NULL, NULL, 145123),
(145124, '1.10.10.10-FF-000337', NULL, 'Methylated-DNA--protein-cysteine methyltransferase', 84, NULL, NULL, 145124),
(145125, '2.10.90.10-FF-000166', NULL, 'Uncharacterized protein', 137, NULL, NULL, 145125),
(145126, '2.40.50.140-FF-000914', NULL, NULL, 105, NULL, NULL, 145126),
(145127, '3.90.79.10-FF-000128', NULL, 'WGS project CABT00000000 data, contig 2.8', 177, NULL, NULL, 145127),
(145128, '1.25.40.20-FF-000680', NULL, 'Uncharacterized protein', 212, NULL, NULL, 145128),
(145129, '2.60.40.1730-FF-000068', NULL, NULL, 80, NULL, NULL, 145129),
(145130, '2.60.120.10-FF-000764', NULL, 'Uncharacterized protein', 63, NULL, NULL, 145130),
(145131, '3.10.129.10-FF-000145', NULL, 'Peroxisomal hydratase-dehydrogenase-epimerase', 152, NULL, NULL, 145131),
(145132, '1.25.10.10-FF-000456', NULL, 'Importin-7, putative', 659, NULL, NULL, 145132),
(145133, '4.10.240.10-FF-000012', NULL, 'C6 transcription factor', 67, NULL, NULL, 145133),
(145134, '2.40.10.10-FF-000356', NULL, 'Mannose-binding lectin associated serine protease', 260, NULL, NULL, 145134),
(145135, '2.130.10.10-FF-002347', NULL, 'Cleavage and polyadenylation specificity factor subunit, putative', 345, NULL, NULL, 145135),
(145136, '3.80.10.10-FF-002134', NULL, 'Leucine-rich repeat protein (LRRP), putative', 149, NULL, NULL, 145136),
(145137, '3.10.100.10-FF-000068', NULL, 'CG4115', 182, NULL, NULL, 145137),
(145138, '3.40.30.120-FF-000002', NULL, '2-polyprenyl-6-methoxyphenol hydroxylase and related FAD-dependent oxidoreductases', 136, NULL, NULL, 145138),
(145139, '3.30.470.20-FF-000054', NULL, 'Glutathione synthetase', 111, NULL, NULL, 145139);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(145140, '3.30.70.330-FF-002722', NULL, NULL, 145, NULL, NULL, 145140),
(145141, '3.30.160.60-FF-002824', NULL, NULL, 23, NULL, NULL, 145141),
(145142, '3.30.1230.20-FF-000013', NULL, '40S ribosomal protein S21', 78, NULL, NULL, 145142),
(145143, '3.40.50.1000-FF-000617', NULL, NULL, 111, NULL, NULL, 145143),
(145144, '3.30.70.420-FF-000006', NULL, 'Uncharacterized protein', 81, NULL, NULL, 145144),
(145145, '3.30.497.10-FF-000085', NULL, 'Serine protease inhibitor 28Dc', 247, NULL, NULL, 145145),
(145146, '1.10.510.10-FF-002046', NULL, 'piRNA biogenesis factor prde-1', 297, NULL, NULL, 145146),
(145147, '3.30.559.70-FF-000011', NULL, 'Choline O-acetyltransferase', 341, NULL, NULL, 145147),
(145148, '3.40.50.300-FF-000616', NULL, 'GPN-loop GTPase 3', 263, NULL, NULL, 145148),
(145149, '3.40.50.300-FF-003308', NULL, 'Integral membrane protein', 216, NULL, NULL, 145149),
(145150, '3.30.160.60-FF-000969', NULL, 'Zinc finger protein 407', 29, NULL, NULL, 145150),
(145151, '1.20.1060.20-FF-000021', NULL, NULL, 118, NULL, NULL, 145151),
(145152, '3.30.1520.10-FF-000111', NULL, 'Uncharacterized protein', 118, NULL, NULL, 145152),
(145153, '3.30.70.60-FF-000013', NULL, 'Mitochondrial ribosomal protein S6-2', 101, NULL, NULL, 145153),
(145154, '2.30.42.10-FF-000503', NULL, NULL, 99, NULL, NULL, 145154),
(145155, '3.40.50.1100-FF-000237', NULL, 'Uncharacterized protein', 55, NULL, NULL, 145155),
(145156, '3.40.50.12780-FF-000120', NULL, 'Uncharacterized protein', 433, NULL, NULL, 145156),
(145157, '3.40.390.10-FF-000290', NULL, NULL, 88, NULL, NULL, 145157),
(145158, '1.20.1440.160-FF-000001', NULL, 'Tumor necrosis factor alpha-induced protein 8-like 1', 187, NULL, NULL, 145158),
(145159, '3.30.40.10-FF-002110', NULL, 'Uncharacterized protein', 50, NULL, NULL, 145159),
(145160, '3.10.25.10-FF-000013', NULL, 'Methionyl-tRNA formyltransferase', 107, NULL, NULL, 145160),
(145161, '3.90.1420.10-FF-000039', NULL, 'Uncharacterized protein', 158, NULL, NULL, 145161),
(145162, '1.10.1140.10-FF-000009', NULL, 'Vacuolar ATP synthase catalytic subunit A', 153, NULL, NULL, 145162),
(145163, '1.10.238.10-FF-001316', NULL, 'Uncharacterized protein', 92, NULL, NULL, 145163),
(145164, '2.40.50.100-FF-000190', NULL, 'Putative RND efflux membrane fusion protein', 54, NULL, NULL, 145164),
(145165, '3.40.50.300-FF-002645', NULL, 'RNA helicase', 186, NULL, NULL, 145165),
(145166, '3.30.200.20-FF-000237', NULL, 'Serine/threonine-protein kinase SAPK2', 79, NULL, NULL, 145166),
(145167, '2.60.40.1510-FF-000053', NULL, 'Integrin beta', 78, NULL, NULL, 145167),
(145168, '1.25.10.10-FF-002940', NULL, 'Uncharacterized protein', 82, NULL, NULL, 145168),
(145169, '3.30.565.10-FF-000485', NULL, 'Os09g0551900 protein', 205, NULL, NULL, 145169),
(145170, '3.90.180.10-FF-000010', NULL, 'Enoyl-[acyl-carrier-protein] reductase, mitochondrial', 137, NULL, NULL, 145170),
(145171, '1.25.10.10-FF-003103', NULL, 'Uncharacterized protein', 220, NULL, NULL, 145171),
(145172, '3.30.70.20-FF-000108', NULL, NULL, 56, NULL, NULL, 145172),
(145173, '3.90.550.10-FF-000387', NULL, 'Putative cellulose synthase A catalytic subunit 11 [UDP-forming]', 167, NULL, NULL, 145173),
(145174, '2.60.260.20-FF-000013', NULL, 'DnaJ subfamily B member 11', 98, NULL, NULL, 145174),
(145175, '2.30.29.30-FF-001092', NULL, 'Si:dkey-172j4.3', 51, NULL, NULL, 145175),
(145176, '1.20.5.420-FF-000023', NULL, 'Putative conserved secreted 15 kDa protein', 71, NULL, NULL, 145176),
(145177, '2.90.10.10-FF-000034', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase CES101 isoform A', 133, NULL, NULL, 145177),
(145178, '3.80.10.10-FF-000335', NULL, 'mimecan', 117, NULL, NULL, 145178),
(145179, '3.30.830.10-FF-000326', NULL, 'Uncharacterized protein', 76, NULL, NULL, 145179),
(145180, '2.60.40.10-FF-000537', NULL, 'immunoglobulin superfamily member 10', 98, NULL, NULL, 145180),
(145181, '3.20.20.150-FF-000030', NULL, 'putative hydroxypyruvate isomerase', 195, NULL, NULL, 145181),
(145182, '3.30.420.10-FF-000739', NULL, NULL, 171, NULL, NULL, 145182),
(145183, '3.30.1360.10-FF-000014', NULL, 'DNA-directed RNA polymerase II subunit RPB3', 158, NULL, NULL, 145183);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(145184, '1.20.1280.290-FF-000008', NULL, 'PQ-loop repeat-containing protein 1', 97, NULL, NULL, 145184),
(145185, '3.40.50.300-FF-004944', NULL, 'Polynucleotide 5''-hydroxyl-kinase nol9', 270, NULL, NULL, 145185),
(145186, '3.40.50.300-FF-007350', NULL, 'Uncharacterized protein', 109, NULL, NULL, 145186),
(145187, '1.25.40.620-FF-000006', NULL, 'Sll1380 protein', 98, NULL, NULL, 145187),
(145188, '2.160.20.10-FF-000019', NULL, 'polygalacturonase At1g48100', 389, NULL, NULL, 145188),
(145189, '2.130.10.10-FF-002965', NULL, 'Putative WD-repeat family protein', 349, NULL, NULL, 145189),
(145190, '1.20.58.1080-FF-000011', NULL, 'Predicted protein', 103, NULL, NULL, 145190),
(145191, '1.10.10.580-FF-000015', NULL, 'Uncharacterized protein', 66, NULL, NULL, 145191),
(145192, '1.20.58.70-FF-000021', NULL, 'SNARE complex subunit (Tlg2)', 228, NULL, NULL, 145192),
(145193, '2.60.40.10-FF-004409', NULL, NULL, 100, NULL, NULL, 145193),
(145194, '3.40.50.300-FF-001510', NULL, 'ABC transporter G family member 2', 246, NULL, NULL, 145194),
(145195, '1.20.1440.170-FF-000004', NULL, 'Protein_of_uncharacterized_function_(DUF2962)_-_p utative', 118, NULL, NULL, 145195),
(145196, '1.10.10.10-FF-000394', NULL, 'Homologous-pairing protein 2 homolog', 82, NULL, NULL, 145196),
(145197, '2.60.40.10-FF-004466', NULL, NULL, 100, NULL, NULL, 145197),
(145198, '1.25.40.10-FF-002436', NULL, 'Pentatricopeptide repeat-containing protein', 108, NULL, NULL, 145198),
(145199, '2.30.42.10-FF-000161', NULL, 'Synaptojanin-2-binding protein', 112, NULL, NULL, 145199),
(145200, '3.30.200.20-FF-000675', NULL, 'Choline kinase', 93, NULL, NULL, 145200),
(145201, '2.120.10.80-FF-000227', NULL, 'Kelch like family member 18, isoform A', 177, NULL, NULL, 145201),
(145202, '3.40.50.10900-FF-000028', NULL, 'Uncharacterized protein', 211, NULL, NULL, 145202),
(145203, '1.20.1440.180-FF-000007', NULL, 'Predicted protein', 121, NULL, NULL, 145203),
(145204, '3.40.30.10-FF-001069', NULL, 'Uncharacterized protein', 158, NULL, NULL, 145204),
(145205, '3.40.50.1240-FF-000138', NULL, NULL, 96, NULL, NULL, 145205),
(145206, '2.130.10.10-FF-004146', NULL, 'Actin-related protein 2/3 complex subunit 1', 377, NULL, NULL, 145206),
(145207, '3.20.20.70-FF-000497', NULL, NULL, 100, NULL, NULL, 145207),
(145208, '1.20.1250.20-FF-000333', NULL, 'Folate transporter 2', 190, NULL, NULL, 145208),
(145209, '3.30.470.30-FF-000057', NULL, 'DNA ligase', 233, NULL, NULL, 145209),
(145210, '3.30.420.40-FF-000057', NULL, 'Ectonucleoside triphosphate diphosphohydrolase 4', 142, NULL, NULL, 145210),
(145211, '1.10.150.870-FF-000002', NULL, 'Error-prone DNA polymerase', 97, NULL, NULL, 145211),
(145212, '1.10.287.110-FF-000465', NULL, 'Uncharacterized protein', 79, NULL, NULL, 145212),
(145213, '1.25.40.10-FF-000284', NULL, 'Pentatricopeptide repeat-containing protein', 104, NULL, NULL, 145213),
(145214, '3.40.50.720-FF-000978', NULL, 'Protein CBG20301', 234, NULL, NULL, 145214),
(145215, '1.10.510.10-FF-001028', NULL, 'Serine/threonine-protein kinase RIO1', 147, NULL, NULL, 145215),
(145216, '1.10.400.10-FF-000065', NULL, 'Uncharacterized protein', 36, NULL, NULL, 145216),
(145217, '1.10.472.10-FF-000534', NULL, 'Uncharacterized protein', 86, NULL, NULL, 145217),
(145218, '3.40.190.10-FF-000802', NULL, 'Uncharacterized protein', 99, NULL, NULL, 145218),
(145219, '3.90.470.10-FF-000032', NULL, 'Mitochondrial large ribosomal subunit', 132, NULL, NULL, 145219),
(145220, '3.40.109.10-FF-000053', NULL, 'Nitroreductase', 171, NULL, NULL, 145220),
(145221, '1.25.10.10-FF-002608', NULL, 'ARM repeat superfamily protein', 140, NULL, NULL, 145221),
(145222, '2.130.10.10-FF-002027', NULL, 'Uncharacterized protein', 218, NULL, NULL, 145222),
(145223, '2.40.50.140-FF-000173', NULL, 'DNA ligase', 162, NULL, NULL, 145223),
(145224, '2.60.120.260-FF-000560', NULL, 'Uncharacterized protein', 46, NULL, NULL, 145224),
(145225, '3.40.50.300-FF-008255', NULL, 'Heterogeneous nuclear ribonucleoprotein U-like protein 1', 50, NULL, NULL, 145225),
(145226, '1.20.1560.10-FF-000101', NULL, 'ABC transporter ATP-binding protein', 314, NULL, NULL, 145226);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(145227, '3.40.462.20-FF-000005', NULL, 'Putative FAD-dependent oxygenase EncM', 210, NULL, NULL, 145227),
(145228, '3.30.70.330-FF-002402', NULL, NULL, 95, NULL, NULL, 145228),
(145229, '2.30.230.10-FF-000043', NULL, 'Uncharacterized protein', 83, NULL, NULL, 145229),
(145230, '3.30.70.2760-FF-000001', NULL, 'Metal-dependent phosphohydrolase HD domain-containing protein', 121, NULL, NULL, 145230),
(145231, '3.40.462.10-FF-000002', NULL, 'Conserved protein', 47, NULL, NULL, 145231),
(145232, '2.20.80.10-FF-000018', NULL, 'Vitellogenin-1', 174, NULL, NULL, 145232),
(145233, '3.30.70.3490-FF-000001', NULL, 'Oxysterol-binding protein', 70, NULL, NULL, 145233),
(145234, '3.90.470.20-FF-000035', NULL, 'L-aminoadipate-semialdehyde dehydrogenase-phosphopantetheinyl transferase', 77, NULL, NULL, 145234),
(145235, '1.20.5.1000-FF-000004', NULL, 'Uncharacterized protein', 47, NULL, NULL, 145235),
(145236, '3.30.450.20-FF-000688', NULL, 'Predicted protein', 25, NULL, NULL, 145236),
(145237, '3.40.50.1440-FF-000165', NULL, 'Uncharacterized protein', 94, NULL, NULL, 145237),
(145238, '1.10.1080.10-FF-000010', NULL, 'Glutathione synthetase', 80, NULL, NULL, 145238),
(145239, '2.30.29.30-FF-001299', NULL, 'Uncharacterized protein', 82, NULL, NULL, 145239),
(145240, '3.10.100.10-FF-000181', NULL, 'C-type LECtin', 131, NULL, NULL, 145240),
(145241, '1.25.40.10-FF-001008', NULL, 'Coatomer subunit epsilon', 296, NULL, NULL, 145241),
(145242, '1.20.1050.10-FF-000135', NULL, 'Glutathione S-transferase', 131, NULL, NULL, 145242),
(145243, '3.30.200.20-FF-002266', NULL, 'CDK inhibitory kinase', 113, NULL, NULL, 145243),
(145244, '2.60.40.1400-FF-000019', NULL, NULL, 176, NULL, NULL, 145244),
(145245, '2.30.30.210-FF-000018', NULL, 'Predicted protein', 74, NULL, NULL, 145245),
(145246, '3.40.50.2300-FF-000260', NULL, 'Uncharacterized protein', 153, NULL, NULL, 145246),
(145247, '2.60.40.10-FF-002611', NULL, 'Papain family cysteine protease', 89, NULL, NULL, 145247),
(145248, '3.80.10.10-FF-004000', NULL, 'Predicted protein', 151, NULL, NULL, 145248),
(145249, '2.30.30.40-FF-000479', NULL, 'Scaffold protein CheW associated with MCPs of class 44H', 34, NULL, NULL, 145249),
(145250, '3.40.50.970-FF-000114', NULL, 'Indolepyruvate ferredoxin oxidoreductase alpha subunit', 193, NULL, NULL, 145250),
(145251, '1.10.3430.10-FF-000021', NULL, 'RH (Rhesus) antigen Related', 432, NULL, NULL, 145251),
(145252, '3.30.200.20-FF-002209', NULL, 'GH15507p', 46, NULL, NULL, 145252),
(145253, '3.30.70.330-FF-000423', NULL, 'Ribonucleoprotein A, chloroplastic', 124, NULL, NULL, 145253),
(145254, '3.30.190.20-FF-000004', NULL, '39S ribosomal protein L1, mitochondrial', 116, NULL, NULL, 145254),
(145255, '2.60.40.10-FF-005303', NULL, NULL, 81, NULL, NULL, 145255),
(145256, '3.40.850.10-FF-000331', NULL, 'Uncharacterized protein', 348, NULL, NULL, 145256),
(145257, '1.10.340.30-FF-000015', NULL, '3-methyladenine DNA glycosylase/8-oxoguanine DNA glycosylase', 114, NULL, NULL, 145257),
(145258, '2.130.10.10-FF-001341', NULL, 'Regulator of ribosome biogenesis', 451, NULL, NULL, 145258),
(145259, '3.90.79.10-FF-000280', NULL, 'Uncharacterized protein', 68, NULL, NULL, 145259),
(145260, '1.20.1070.10-FF-002143', NULL, 'Cadherin, EGF LAG seven-pass G-type receptor 3', 198, NULL, NULL, 145260),
(145261, '2.60.40.1180-FF-000206', NULL, 'Alpha-L-fucosidase, putative', 93, NULL, NULL, 145261),
(145262, '3.40.50.1820-FF-001852', NULL, 'Uncharacterized protein', 62, NULL, NULL, 145262),
(145263, '3.80.10.10-FF-003562', NULL, 'Predicted protein', 147, NULL, NULL, 145263),
(145264, '1.25.40.10-FF-004774', NULL, 'Uncharacterized protein', 196, NULL, NULL, 145264),
(145265, '1.25.40.10-FF-002700', NULL, 'TPR repeat protein', 127, NULL, NULL, 145265),
(145266, '1.25.10.10-FF-000731', NULL, 'Suppressor of tub2', 278, NULL, NULL, 145266),
(145267, '1.10.10.370-FF-000003', NULL, 'Siroheme-sulfite reductase gamma subunit homolog', 64, NULL, NULL, 145267),
(145268, '2.60.40.60-FF-000445', NULL, 'GG17179', 110, NULL, NULL, 145268),
(145269, '2.130.10.10-FF-002701', NULL, 'Pre-rRNA-processing protein IPI3', 322, NULL, NULL, 145269); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(145270, '3.20.20.70-FF-000851', NULL, NULL, 72, NULL, NULL, 145270),
(145271, '3.10.50.10-FF-000032', NULL, 'Chitinase 4', 66, NULL, NULL, 145271),
(145272, '3.30.160.60-FF-005697', NULL, NULL, 63, NULL, NULL, 145272),
(145273, '2.40.70.10-FF-000562', NULL, NULL, 115, NULL, NULL, 145273),
(145274, '3.30.70.80-FF-000019', NULL, 'Subtilisin-like protease SBT3.3', 92, NULL, NULL, 145274),
(145275, '2.40.290.30-FF-000005', NULL, 'GM26574', 153, NULL, NULL, 145275),
(145276, '3.40.1280.10-FF-000011', NULL, 'putative methyltransferase C9orf114 homolog', 206, NULL, NULL, 145276),
(145277, '1.10.420.10-FF-000010', NULL, 'Peroxidase', 144, NULL, NULL, 145277),
(145278, '3.10.20.30-FF-000098', NULL, NULL, 66, NULL, NULL, 145278),
(145279, '3.40.50.300-FF-004326', NULL, 'Os10g0163220 protein', 63, NULL, NULL, 145279),
(145280, '1.10.730.10-FF-000230', NULL, 'Uncharacterized protein', 166, NULL, NULL, 145280),
(145281, '3.40.50.2300-FF-000108', NULL, 'DNA-binding response OmpR family regulator', 80, NULL, NULL, 145281),
(145282, '1.20.1070.10-FF-001249', NULL, 'Olfactory receptor', 190, NULL, NULL, 145282),
(145283, '3.40.50.1440-FF-000108', NULL, 'Tubulin alpha chain', 247, NULL, NULL, 145283),
(145284, '3.30.40.10-FF-001559', NULL, 'Vacuolar membrane protein pep18, putative', 100, NULL, NULL, 145284),
(145285, '6.10.250.3370-FF-000004', NULL, 'NTP-dependent putrebactin synthetase PubC', 48, NULL, NULL, 145285),
(145286, '2.120.10.30-FF-000471', NULL, 'Predicted protein', 62, NULL, NULL, 145286),
(145287, '2.60.40.10-FF-003151', NULL, 'AGAP011650-PA', 104, NULL, NULL, 145287),
(145288, '3.30.559.10-FF-000100', NULL, 'Nonribosomal peptide synthase 2', 178, NULL, NULL, 145288),
(145289, '1.20.120.230-FF-000055', NULL, 'Uncharacterized protein', 108, NULL, NULL, 145289),
(145290, '3.30.70.330-FF-002609', NULL, NULL, 181, NULL, NULL, 145290),
(145291, '3.50.50.60-FF-000135', NULL, 'L-lysine 6-monooxygenase IucD', 419, NULL, NULL, 145291),
(145292, '3.30.70.330-FF-000081', NULL, 'Cleavage and polyadenylation specificity factor subunit 6', 92, NULL, NULL, 145292),
(145293, '1.10.472.10-FF-000354', NULL, 'G2/mitotic-specific cyclin 1/2', 148, NULL, NULL, 145293),
(145294, '4.10.60.10-FF-000075', NULL, 'CCHC-type zinc finger protein CG3800', 30, NULL, NULL, 145294),
(145295, '3.40.50.10810-FF-000069', NULL, 'DNA helicase', 237, NULL, NULL, 145295),
(145296, '3.10.100.10-FF-000388', NULL, NULL, 165, NULL, NULL, 145296),
(145297, '1.20.1250.20-FF-001468', NULL, 'Nitrate/nitrite transporter NrtP', 220, NULL, NULL, 145297),
(145298, '1.10.287.890-FF-000007', NULL, 'Os07g0190150 protein', 61, NULL, NULL, 145298),
(145299, '3.40.1280.30-FF-000017', NULL, 'Uncharacterized protein', 194, NULL, NULL, 145299),
(145300, '3.30.160.60-FF-003100', NULL, 'zinc finger protein 444 isoform X2', 25, NULL, NULL, 145300),
(145301, '2.60.40.10-FF-002818', NULL, 'Uncharacterized protein', 101, NULL, NULL, 145301),
(145302, '2.60.40.10-FF-002875', NULL, 'MPL proto-oncogene, thrombopoietin receptor', 100, NULL, NULL, 145302),
(145303, '2.40.160.40-FF-000004', NULL, 'Putative outer membrane protein', 205, NULL, NULL, 145303),
(145304, '1.25.40.10-FF-001340', NULL, 'rRNA biogenesis protein RRP5, putative', 182, NULL, NULL, 145304),
(145305, '3.40.50.300-FF-006535', NULL, 'Predicted protein', 108, NULL, NULL, 145305),
(145306, '3.30.200.20-FF-002541', NULL, 'Non-specific serine/threonine protein kinase', 18, NULL, NULL, 145306),
(145307, '3.40.50.1820-FF-001291', NULL, 'Putative steryl acetyl hydrolase mug81', 281, NULL, NULL, 145307),
(145308, '1.20.144.10-FF-000091', NULL, 'RfiA', 100, NULL, NULL, 145308),
(145309, '3.40.50.720-FF-002310', NULL, 'Uncharacterized protein', 133, NULL, NULL, 145309),
(145310, '3.40.190.10-FF-000241', NULL, 'Glutamate receptor 2', 123, NULL, NULL, 145310),
(145311, '2.10.25.10-FF-001549', NULL, 'Putative per-hexamer repeat protein 5', 48, NULL, NULL, 145311),
(145312, '3.40.50.300-FF-003101', NULL, 'Guanylate binding protein, putative', 281, NULL, NULL, 145312),
(145313, '3.30.60.20-FF-000102', NULL, 'Protein kinase C', 56, NULL, NULL, 145313); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(145314, '1.20.144.10-FF-000034', NULL, 'Dihydrosphingosine-1-phosphate phosphatase', 102, NULL, NULL, 145314),
(145315, '1.10.510.10-FF-002664', NULL, NULL, 109, NULL, NULL, 145315),
(145316, '2.40.160.50-FF-000007', NULL, 'Outer envelope protein 80, chloroplastic', 320, NULL, NULL, 145316),
(145317, '1.25.40.20-FF-001343', NULL, 'Uncharacterized protein', 113, NULL, NULL, 145317),
(145318, '3.40.30.10-FF-000636', NULL, 'Peroxiredoxin-like 2C', 176, NULL, NULL, 145318),
(145319, '3.40.30.10-FF-001204', NULL, 'Glutathione peroxidase', 61, NULL, NULL, 145319),
(145320, '3.30.160.60-FF-005404', NULL, NULL, 45, NULL, NULL, 145320),
(145321, '1.20.58.60-FF-000231', NULL, 'Spectrin repeat containing, nuclear envelope 1a', 291, NULL, NULL, 145321),
(145322, '3.40.47.10-FF-000146', NULL, 'Orsellinic acid synthase', 442, NULL, NULL, 145322),
(145323, '1.10.10.10-FF-000219', NULL, 'DNA-binding response regulator', 104, NULL, NULL, 145323),
(145324, '3.30.70.330-FF-000362', NULL, 'GBP2p Poly(A+) RNA-binding protein', 82, NULL, NULL, 145324),
(145325, '1.20.1280.290-FF-000003', NULL, 'Bidirectional sugar transporter SWEET', 93, NULL, NULL, 145325),
(145326, '3.40.50.1000-FF-000089', NULL, 'NIF domain protein', 200, NULL, NULL, 145326),
(145327, '3.30.1540.20-FF-000003', NULL, 'DNA mismatch repair protein MutL', 89, NULL, NULL, 145327),
(145328, '3.30.559.70-FF-000067', NULL, 'Carnitine acyltransferase, putative', 45, NULL, NULL, 145328),
(145329, '1.10.150.80-FF-000009', NULL, '3''-5'' exonuclease', 79, NULL, NULL, 145329),
(145330, '3.40.50.720-FF-000006', NULL, 'Bifunctional protein FolD', 128, NULL, NULL, 145330),
(145331, '3.30.720.210-FF-000018', NULL, 'ATP-dependent zinc metalloprotease FtsH', 77, NULL, NULL, 145331),
(145332, '3.80.10.10-FF-001701', NULL, 'LRR receptor kinase SERK2', 185, NULL, NULL, 145332),
(145333, '1.25.40.20-FF-000904', NULL, 'Uncharacterized protein', 95, NULL, NULL, 145333),
(145334, '1.50.40.10-FF-000169', NULL, 'Mitochondrial carrier protein (Pet8), putative', 329, NULL, NULL, 145334),
(145335, '3.80.10.10-FF-001645', NULL, 'Uncharacterized protein', 271, NULL, NULL, 145335),
(145336, '3.40.1410.10-FF-000005', NULL, 'HTH-type transcriptional regulator frlR', 162, NULL, NULL, 145336),
(145337, '1.25.40.20-FF-000848', NULL, 'Kinase, NEK-frag', 200, NULL, NULL, 145337),
(145338, '3.30.160.60-FF-001133', NULL, 'Zinc finger and BTB domain containing 41', 68, NULL, NULL, 145338),
(145339, '3.40.50.300-FF-000386', NULL, 'Regulator of nonsense transcripts 1', 214, NULL, NULL, 145339),
(145340, '1.20.1070.10-FF-000350', NULL, 'Frizzled', 357, NULL, NULL, 145340),
(145341, '2.10.25.10-FF-001257', NULL, 'Protein CBG11506', 64, NULL, NULL, 145341),
(145342, '3.40.50.1380-FF-000006', NULL, 'Methylglyoxal synthase', 131, NULL, NULL, 145342),
(145343, '3.80.10.10-FF-003825', NULL, 'Uncharacterized protein', 72, NULL, NULL, 145343),
(145344, '3.10.580.10-FF-000098', NULL, 'KpsF/GutQ family sugar-phosphate isomerase', 123, NULL, NULL, 145344),
(145345, '3.80.10.10-FF-003769', NULL, 'Leucine Rich Repeat family protein', 111, NULL, NULL, 145345),
(145346, '2.60.40.10-FF-003679', NULL, NULL, 99, NULL, NULL, 145346),
(145347, '3.90.226.10-FF-000055', NULL, 'ATP-dependent Clp protease proteolytic subunit', 193, NULL, NULL, 145347),
(145348, '3.40.630.10-FF-000343', NULL, 'Si:ch1073-459j12.1', 341, NULL, NULL, 145348),
(145349, '2.70.98.10-FF-000052', NULL, 'Glucose-6-phosphate 1-epimerase', 287, NULL, NULL, 145349),
(145350, '3.30.420.40-FF-000383', NULL, 'tRNA (Adenosine(37)-N6)-threonylcarbamoyltransferase complex dimerization subunit type 1 TsaB', 95, NULL, NULL, 145350),
(145351, '1.10.439.10-FF-000002', NULL, 'Putative penicillin acylase (Penicillin amidase) (Penicillin amidohydrolase)', 164, NULL, NULL, 145351),
(145352, '1.25.40.10-FF-000845', NULL, 'pentatricopeptide repeat-containing protein At1g20230 isoform X1', 93, NULL, NULL, 145352),
(145353, '3.30.70.330-FF-002109', NULL, NULL, 162, NULL, NULL, 145353),
(145354, '1.25.40.10-FF-004156', NULL, 'Pentatricopeptide repeat-containing protein', 108, NULL, NULL, 145354);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(145355, '1.25.40.20-FF-001461', NULL, 'Palmitoyltransferase', 120, NULL, NULL, 145355),
(145356, '1.10.1070.11-FF-000073', NULL, 'Dual specificity protein phosphatase PHS1', 165, NULL, NULL, 145356),
(145357, '3.30.500.10-FF-000004', NULL, 'Retinoic acid early-inducible protein 1-beta', 175, NULL, NULL, 145357),
(145358, '3.40.50.300-FF-005225', NULL, 'Minichromosome maintenance domain containing 2', 204, NULL, NULL, 145358),
(145359, '3.50.50.60-FF-000410', NULL, 'Flavocytochrome C sulfide dehydrogenase', 176, NULL, NULL, 145359),
(145360, '1.20.120.520-FF-000007', NULL, 'Hemerythrin domain-containing protein', 179, NULL, NULL, 145360),
(145361, '3.30.70.330-FF-001885', NULL, NULL, 91, NULL, NULL, 145361),
(145362, '3.30.160.90-FF-000001', NULL, 'Vitamin B12-dependent ribonucleotide reductase', 76, NULL, NULL, 145362),
(145363, '3.30.70.270-FF-000208', NULL, NULL, 165, NULL, NULL, 145363),
(145364, '3.40.50.300-FF-002533', NULL, 'Large subunit GTPase 1', 135, NULL, NULL, 145364),
(145365, '2.40.160.10-FF-000018', NULL, 'Mitochondrial import receptor subunit tom40', 135, NULL, NULL, 145365),
(145366, '3.30.420.10-FF-000003', NULL, 'Oligoribonuclease', 187, NULL, NULL, 145366),
(145367, '2.30.30.40-FF-000209', NULL, 'Abl interactor 2', 48, NULL, NULL, 145367),
(145368, '1.10.460.10-FF-000012', NULL, 'DNA topoisomerase', 101, NULL, NULL, 145368),
(145369, '1.10.10.820-FF-000008', NULL, 'Zipper, isoform D', 56, NULL, NULL, 145369),
(145370, '1.10.600.10-FF-000052', NULL, 'Farnesyl pyrophosphate synthase', 345, NULL, NULL, 145370),
(145371, '3.30.1460.20-FF-000002', NULL, 'Arp2/3 complex 34 kDa subunit', 151, NULL, NULL, 145371),
(145372, '1.10.3460.10-FF-000017', NULL, 'Fucoxanthin chl a/c light-harvesting protein', 198, NULL, NULL, 145372),
(145373, '3.40.350.10-FF-000068', NULL, 'FACT complex subunit SPT16', 171, NULL, NULL, 145373),
(145374, '1.20.1260.20-FF-000002', NULL, 'Hypothetical alanine and glycine rich protein', 161, NULL, NULL, 145374),
(145375, '3.40.50.720-FF-001467', NULL, 'Pyrroline-5-carboxylate reductase', 153, NULL, NULL, 145375),
(145376, '3.80.10.10-FF-000015', NULL, 'Leucine rich repeat containing 38', 218, NULL, NULL, 145376),
(145377, '1.20.120.1900-FF-000041', NULL, 'Spindle pole body component', 332, NULL, NULL, 145377),
(145378, '3.40.50.720-FF-002035', NULL, 'Uncharacterized protein', 190, NULL, NULL, 145378),
(145379, '3.30.160.60-FF-002763', NULL, 'Zinc finger protein 646', 26, NULL, NULL, 145379),
(145380, '2.170.270.10-FF-000153', NULL, 'PR domain-containing 11', 163, NULL, NULL, 145380),
(145381, '1.20.58.60-FF-000282', NULL, 'Spectrin beta, non-erythrocytic 5', 303, NULL, NULL, 145381),
(145382, '3.30.200.20-FF-000063', NULL, 'Non-specific serine/threonine protein kinase', 11, NULL, NULL, 145382),
(145383, '1.20.920.10-FF-000040', NULL, 'Histone-lysine N-methyltransferase', 121, NULL, NULL, 145383),
(145384, '1.20.1070.10-FF-001603', NULL, 'Vomeronasal type-1 receptor', 152, NULL, NULL, 145384),
(145385, '1.10.510.10-FF-002602', NULL, 'Uncharacterized protein', 352, NULL, NULL, 145385),
(145386, '3.30.565.10-FF-000367', NULL, 'PAS domain-containing hybrid sensor histidine kinase/response regulator', 163, NULL, NULL, 145386),
(145387, '3.30.50.10-FF-000194', NULL, 'Uncharacterized protein', 33, NULL, NULL, 145387),
(145388, '1.25.40.10-FF-000519', NULL, 'pre-mRNA-splicing factor SYF1', 170, NULL, NULL, 145388),
(145389, '1.20.1250.20-FF-000451', NULL, 'MFS sugar transporter, putative', 232, NULL, NULL, 145389),
(145390, '2.30.29.230-FF-000011', NULL, 'GTPase-activating protein GYP7', 136, NULL, NULL, 145390),
(145391, '3.40.50.300-FF-006804', NULL, 'Uncharacterized protein', 50, NULL, NULL, 145391),
(145392, '2.170.270.10-FF-000097', NULL, 'Histone-lysine N-methyltransferase', 140, NULL, NULL, 145392),
(145393, '3.30.160.60-FF-000458', NULL, 'pH-response transcription factor pacC/RIM101', 28, NULL, NULL, 145393),
(145394, '1.20.1090.10-FF-000019', NULL, '3-dehydroquinate synthase', 186, NULL, NULL, 145394),
(145395, '3.80.10.10-FF-004500', NULL, 'Leucine-rich repeat receptor-like tyrosine-protein kinase PXC3', 235, NULL, NULL, 145395);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(145396, '3.90.550.10-FF-000269', NULL, '2-C-methyl-D-erythritol 4-phosphate cytidylyltransferase', 214, NULL, NULL, 145396),
(145397, '3.20.20.300-FF-000053', NULL, NULL, 105, NULL, NULL, 145397),
(145398, '3.40.30.10-FF-000687', NULL, 'Glutathione S-transferase', 134, NULL, NULL, 145398),
(145399, '3.40.50.450-FF-000077', NULL, 'ATP-dependent 6-phosphofructokinase 2', 199, NULL, NULL, 145399),
(145400, '1.20.1070.10-FF-001980', NULL, 'Predicted protein', 167, NULL, NULL, 145400),
(145401, '3.40.50.620-FF-000425', NULL, 'Tyrosine--tRNA ligase', 258, NULL, NULL, 145401),
(145402, '3.30.420.40-FF-000338', NULL, 'Acetate kinase', 193, NULL, NULL, 145402),
(145403, '3.30.70.330-FF-000036', NULL, 'polypyrimidine tract-binding protein 1 isoform X2', 89, NULL, NULL, 145403),
(145404, '3.40.50.10800-FF-000004', NULL, 'Quinolinate synthase A', 101, NULL, NULL, 145404),
(145405, '3.30.70.330-FF-001941', NULL, NULL, 134, NULL, NULL, 145405),
(145406, '3.40.50.10810-FF-000007', NULL, 'Chromodomain-helicase-DNA-binding protein 2 isoform 1', 230, NULL, NULL, 145406),
(145407, '3.40.190.10-FF-000207', NULL, 'Glutamine ABC transporter substrate-binding protein GlnH', 91, NULL, NULL, 145407),
(145408, '2.130.10.10-FF-000728', NULL, 'WD repeat and HMG-box DNA-binding protein 1', 88, NULL, NULL, 145408),
(145409, '2.60.34.10-FF-000135', NULL, 'Uncharacterized protein', 71, NULL, NULL, 145409),
(145410, '1.20.920.30-FF-000046', NULL, 'Si:dkey-11m19.5', 145, NULL, NULL, 145410),
(145411, '3.20.100.10-FF-000015', NULL, 'mRNA-capping enzyme subunit beta', 264, NULL, NULL, 145411),
(145412, '3.40.50.1370-FF-000003', NULL, 'Ornithine carbamoyltransferase', 160, NULL, NULL, 145412),
(145413, '1.10.246.90-FF-000004', NULL, 'Nucleolar protein 58', 122, NULL, NULL, 145413),
(145414, '2.60.40.150-FF-000664', NULL, 'Copine, putative', 87, NULL, NULL, 145414),
(145415, '3.30.160.60-FF-002549', NULL, 'Si:ch73-92e7.4', 28, NULL, NULL, 145415),
(145416, '1.20.58.60-FF-000175', NULL, 'dystrophin, isoforms A/C/F/G/H isoform X5', 109, NULL, NULL, 145416),
(145417, '1.10.10.60-FF-000717', NULL, 'Putative acetoin operon transcriptional activator', 59, NULL, NULL, 145417),
(145418, '2.40.10.10-FF-000682', NULL, NULL, 63, NULL, NULL, 145418),
(145419, '3.30.230.70-FF-000170', NULL, 'Uncharacterized protein', 102, NULL, NULL, 145419),
(145420, '2.120.10.30-FF-000291', NULL, 'AGAP007095-PA', 64, NULL, NULL, 145420),
(145421, '1.20.920.20-FF-000043', NULL, 'Uncharacterized protein', 111, NULL, NULL, 145421),
(145422, '1.20.1250.20-FF-001811', NULL, 'Solute carrier family 45 member 1', 162, NULL, NULL, 145422),
(145423, '2.60.410.10-FF-000011', NULL, NULL, 90, NULL, NULL, 145423),
(145424, '3.40.50.670-FF-000007', NULL, 'DNA gyrase subunit B', 191, NULL, NULL, 145424),
(145425, '3.30.1240.10-FF-000011', NULL, 'HAD family hydrolase', 111, NULL, NULL, 145425),
(145426, '2.160.20.10-FF-000076', NULL, 'F-box domain containing protein', 197, NULL, NULL, 145426),
(145427, '2.60.120.200-FF-000121', NULL, 'Terribly reduced optic lobes, isoform AF', 185, NULL, NULL, 145427),
(145428, '2.60.40.790-FF-000114', NULL, 'Protein CBG09701', 101, NULL, NULL, 145428),
(145429, '3.30.310.50-FF-000046', NULL, 'Phosphoglucosamine mutase', 77, NULL, NULL, 145429),
(145430, '1.20.120.80-FF-000016', NULL, 'Cytochrome c oxidase subunit 3', 126, NULL, NULL, 145430),
(145431, '1.10.287.110-FF-000196', NULL, 'DnaJ heat shock protein family (Hsp40) member B12b', 110, NULL, NULL, 145431),
(145432, '3.30.360.10-FF-000127', NULL, 'Glucose-6-phosphate 1-dehydrogenase', 60, NULL, NULL, 145432),
(145433, '1.25.40.990-FF-000038', NULL, 'GM16907', 144, NULL, NULL, 145433),
(145434, '3.30.830.10-FF-000091', NULL, 'Probable zinc protease PqqL', 204, NULL, NULL, 145434),
(145435, '1.10.510.10-FF-004463', NULL, NULL, 278, NULL, NULL, 145435),
(145436, '1.25.10.10-FF-002316', NULL, 'ARM repeat superfamily protein', 314, NULL, NULL, 145436),
(145437, '3.20.20.70-FF-000738', NULL, NULL, 78, NULL, NULL, 145437),
(145438, '3.30.750.200-FF-000004', NULL, NULL, 120, NULL, NULL, 145438);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(145439, '2.60.40.10-FF-000806', NULL, 'Matrix remodeling associated 8', 128, NULL, NULL, 145439),
(145440, '2.180.10.10-FF-000024', NULL, 'Uncharacterized protein', 448, NULL, NULL, 145440),
(145441, '3.40.50.1820-FF-001583', NULL, 'Uncharacterized protein', 96, NULL, NULL, 145441),
(145442, '1.25.10.10-FF-002086', NULL, 'Protein VAC14 homolog', 140, NULL, NULL, 145442),
(145443, '3.60.15.10-FF-000263', NULL, 'ElaC ribonuclease Z 2', 166, NULL, NULL, 145443),
(145444, '2.10.25.10-FF-001038', NULL, 'Protein cueball', 31, NULL, NULL, 145444),
(145445, '3.30.70.920-FF-000044', NULL, 'Transcription regulator, Lrp/AsnC family', 96, NULL, NULL, 145445),
(145446, '1.20.120.950-FF-000001', NULL, 'Archaeal structural protein', 98, NULL, NULL, 145446),
(145447, '3.10.20.70-FF-000019', NULL, 'Glutamine synthetase', 103, NULL, NULL, 145447),
(145448, '2.120.10.10-FF-000021', NULL, 'Neuraminidase', 372, NULL, NULL, 145448),
(145449, '2.60.120.650-FF-000233', NULL, 'Uncharacterized protein', 129, NULL, NULL, 145449),
(145450, '3.90.1300.10-FF-000042', NULL, 'Uncharacterized protein', 79, NULL, NULL, 145450),
(145451, '2.40.70.10-FF-000293', NULL, NULL, 121, NULL, NULL, 145451),
(145452, '1.20.120.430-FF-000020', NULL, 'Uncharacterized protein', 171, NULL, NULL, 145452),
(145453, '3.30.565.10-FF-000148', NULL, 'Stage II sporulation protein E', 143, NULL, NULL, 145453),
(145454, '1.25.40.10-FF-002762', NULL, 'YALI0A07821p', 182, NULL, NULL, 145454),
(145455, '3.30.200.20-FF-002154', NULL, 'TrkA', 67, NULL, NULL, 145455),
(145456, '3.30.230.10-FF-000410', NULL, 'DNA repair protein RadA', 166, NULL, NULL, 145456),
(145457, '3.30.420.40-FF-000490', NULL, 'Actin-like ATPase domain-containing protein', 40, NULL, NULL, 145457),
(145458, '3.30.200.20-FF-000911', NULL, 'Protein CBR-KSR-1', 92, NULL, NULL, 145458),
(145459, '1.10.510.10-FF-000129', NULL, 'cysteine-rich receptor-like protein kinase 10', 203, NULL, NULL, 145459),
(145460, '3.80.10.10-FF-002994', NULL, 'Uncharacterized protein', 264, NULL, NULL, 145460),
(145461, '1.10.400.10-FF-000071', NULL, 'Guanine nucleotide-binding protein alpha-2 subunit', 52, NULL, NULL, 145461),
(145462, '3.40.630.10-FF-000236', NULL, 'Probable aspartoacylase', 229, NULL, NULL, 145462),
(145463, '3.30.1320.10-FF-000012', NULL, '37S ribosomal protein S16', 101, NULL, NULL, 145463),
(145464, '2.60.40.60-FF-000737', NULL, 'Uncharacterized protein', 122, NULL, NULL, 145464),
(145465, '3.40.190.10-FF-000533', NULL, 'Hydroxymethylbilane synthase', 99, NULL, NULL, 145465),
(145466, '3.40.50.300-FF-006574', NULL, 'ATP-dependent DNA helicase-like PIF8', 101, NULL, NULL, 145466),
(145467, '2.40.50.140-FF-000701', NULL, NULL, 71, NULL, NULL, 145467),
(145468, '2.120.10.30-FF-000521', NULL, 'Uncharacterized protein', 175, NULL, NULL, 145468),
(145469, '3.30.565.10-FF-000423', NULL, 'Histidine kinase', 153, NULL, NULL, 145469),
(145470, '3.30.40.10-FF-001733', NULL, 'Uncharacterized protein', 108, NULL, NULL, 145470),
(145471, '2.40.70.10-FF-000242', NULL, 'Acid protease', 184, NULL, NULL, 145471),
(145472, '3.30.160.60-FF-000346', NULL, 'zinc finger and BTB domain-containing protein 17 isoform X2', 27, NULL, NULL, 145472),
(145473, '1.10.10.10-FF-001973', NULL, 'Putative HTH-type transcriptional regulator aq_268', 140, NULL, NULL, 145473),
(145474, '3.30.450.40-FF-000059', NULL, 'IclR family transcriptional regulator', 178, NULL, NULL, 145474),
(145475, '1.10.510.10-FF-002372', NULL, NULL, 166, NULL, NULL, 145475),
(145476, '3.10.100.10-FF-000444', NULL, NULL, 52, NULL, NULL, 145476),
(145477, '3.40.50.300-FF-002584', NULL, 'Helicase in mitochondria', 178, NULL, NULL, 145477),
(145478, '3.40.50.720-FF-001793', NULL, 'Shikimate dehydrogenase (NADP(+))', 142, NULL, NULL, 145478),
(145479, '3.10.20.90-FF-000363', NULL, 'Ubiquitin regulatory X', 88, NULL, NULL, 145479),
(145480, '2.40.50.140-FF-000471', NULL, 'Lysine--tRNA ligase', 135, NULL, NULL, 145480),
(145481, '3.30.450.30-FF-000056', NULL, 'MglB protein', 130, NULL, NULL, 145481),
(145482, '3.40.630.30-FF-000394', NULL, 'Putative N-acetyltransferase YjaB', 144, NULL, NULL, 145482);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(145483, '3.30.420.40-FF-000557', NULL, 'Actin-related protein 8', 176, NULL, NULL, 145483),
(145484, '1.10.300.10-FF-000012', NULL, 'Adenylosuccinate synthetase', 102, NULL, NULL, 145484),
(145485, '3.90.550.10-FF-000325', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 281, NULL, NULL, 145485),
(145486, '3.30.160.60-FF-001240', NULL, 'zinc finger and BTB domain-containing protein 7A', 26, NULL, NULL, 145486),
(145487, '2.60.40.10-FF-005011', NULL, NULL, 134, NULL, NULL, 145487),
(145488, '3.30.450.20-FF-000053', NULL, 'Sensor histidine kinase/response regulator', 122, NULL, NULL, 145488),
(145489, '2.60.40.10-FF-002370', NULL, 'Collagen alpha-3(VI) chain', 81, NULL, NULL, 145489),
(145490, '3.40.50.620-FF-000206', NULL, 'Universal stress protein family protein', 161, NULL, NULL, 145490),
(145491, '1.10.357.10-FF-000053', NULL, 'TetR family transcriptional regulator', 142, NULL, NULL, 145491),
(145492, '3.40.50.10810-FF-000119', NULL, 'CSB (Cockayne Syndrome B) homolog', 273, NULL, NULL, 145492),
(145493, '3.40.50.2300-FF-000552', NULL, 'Avr9/Cf-9 rapidly elicited protein-like', 165, NULL, NULL, 145493),
(145494, '3.30.70.980-FF-000034', NULL, 'Probable transcriptional regulatory protein Tnap_0248', 80, NULL, NULL, 145494),
(145495, '3.30.40.10-FF-000373', NULL, 'Tripartite motif-containing protein 35', 89, NULL, NULL, 145495),
(145496, '3.90.920.10-FF-000016', NULL, 'DNA primase', 424, NULL, NULL, 145496),
(145497, '3.40.30.10-FF-000962', NULL, 'Iodothyronine deiodinase', 100, NULL, NULL, 145497),
(145498, '3.40.50.880-FF-000071', NULL, 'Peptidase E', 191, NULL, NULL, 145498),
(145499, '1.25.40.10-FF-000901', NULL, 'DnaJ homolog subfamily C member 7', 113, NULL, NULL, 145499),
(145500, '1.20.1080.10-FF-000120', NULL, 'Uncharacterized protein', 83, NULL, NULL, 145500),
(145501, '3.30.470.30-FF-000091', NULL, 'DNA ligase', 251, NULL, NULL, 145501),
(145502, '3.60.40.10-FF-000006', NULL, 'Pyruvate dehyrogenase phosphatase catalytic subunit 1', 428, NULL, NULL, 145502),
(145503, '3.90.640.10-FF-000034', NULL, 'Actin-related protein 5', 55, NULL, NULL, 145503),
(145504, '2.130.10.10-FF-004500', NULL, 'Uncharacterized protein', 240, NULL, NULL, 145504),
(145505, '3.30.160.60-FF-004617', NULL, NULL, 45, NULL, NULL, 145505),
(145506, '3.30.70.330-FF-000255', NULL, 'Regulator of nonsense transcripts UPF3', 96, NULL, NULL, 145506),
(145507, '3.30.9.10-FF-000149', NULL, 'D-amino acid oxidase', 172, NULL, NULL, 145507),
(145508, '2.10.70.10-FF-000159', NULL, 'Furrowed, isoform A', 52, NULL, NULL, 145508),
(145509, '1.20.58.60-FF-000405', NULL, 'Spectrin repeat containing nuclear envelope protein 1', 264, NULL, NULL, 145509),
(145510, '3.40.30.10-FF-000748', NULL, 'All0195 protein', 111, NULL, NULL, 145510),
(145511, '1.10.238.10-FF-000597', NULL, 'Putative mitochondrial carrier isoform A', 140, NULL, NULL, 145511),
(145512, '1.10.10.60-FF-000543', NULL, 'Homeobox and leucine zipper encoding a', 47, NULL, NULL, 145512),
(145513, '2.10.25.10-FF-000875', NULL, 'Vacuolar-sorting receptor 6', 49, NULL, NULL, 145513),
(145514, '3.40.980.10-FF-000043', NULL, 'Uncharacterized protein', 185, NULL, NULL, 145514),
(145515, '1.10.238.10-FF-000653', NULL, 'EF hand family protein', 74, NULL, NULL, 145515),
(145516, '3.40.50.300-FF-005113', NULL, 'Translocase of chloroplast', 256, NULL, NULL, 145516),
(145517, '1.20.1270.10-FF-000005', NULL, 'heat shock cognate 70 kDa protein-like', 75, NULL, NULL, 145517),
(145518, '2.60.210.10-FF-000063', NULL, NULL, 192, NULL, NULL, 145518),
(145519, '2.60.40.10-FF-004168', NULL, NULL, 88, NULL, NULL, 145519),
(145520, '1.20.144.10-FF-000039', NULL, 'PhosphoLipid PhosPhatase homolog', 246, NULL, NULL, 145520),
(145521, '3.20.20.220-FF-000074', NULL, 'Methylenetetrahydrofolate reductase', 311, NULL, NULL, 145521),
(145522, '2.30.29.30-FF-000231', NULL, 'Oxysterol-binding protein', 104, NULL, NULL, 145522),
(145523, '1.10.10.60-FF-000195', NULL, 'AraC family transcriptional regulator', 53, NULL, NULL, 145523),
(145524, '1.10.287.70-FF-000104', NULL, 'Two pore calcium channel protein 2', 125, NULL, NULL, 145524);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(145525, '1.20.1230.10-FF-000003', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 258, NULL, NULL, 145525),
(145526, '3.40.50.800-FF-000030', NULL, 'Histidine-tRNA ligase', 103, NULL, NULL, 145526),
(145527, '3.40.50.720-FF-000118', NULL, 'Glutamate synthase small subunit', 107, NULL, NULL, 145527),
(145528, '1.10.510.10-FF-002821', NULL, NULL, 130, NULL, NULL, 145528),
(145529, '1.10.532.10-FF-000005', NULL, 'Signal transducer and activator of transcription', 129, NULL, NULL, 145529),
(145530, '1.20.1270.20-FF-000008', NULL, 'Hybrid-cluster protein', 84, NULL, NULL, 145530),
(145531, '1.10.510.10-FF-001242', NULL, 'Leucine-rich repeat serine/threonine-protein kinase 1', 191, NULL, NULL, 145531),
(145532, '2.30.180.10-FF-000179', NULL, NULL, 133, NULL, NULL, 145532),
(145533, '1.10.132.60-FF-000029', NULL, 'DNA polymerase', 189, NULL, NULL, 145533),
(145534, '3.30.2160.10-FF-000033', NULL, 'Ubiquitin protein ligase, putative', 78, NULL, NULL, 145534),
(145535, '3.80.10.10-FF-001471', NULL, 'Pollen-specific leucine-rich repeat extensin-like protein 2', 144, NULL, NULL, 145535),
(145536, '1.25.10.10-FF-001012', NULL, 'Pre-rRNA-processing protein ipi1', 120, NULL, NULL, 145536),
(145537, '2.130.10.10-FF-000880', NULL, 'U3 small nucleolar RNA-associated protein 12', 235, NULL, NULL, 145537),
(145538, '2.40.70.10-FF-000186', NULL, 'Os06g0119600 protein', 187, NULL, NULL, 145538),
(145539, '2.30.29.30-FF-000175', NULL, 'switch-associated protein 70 isoform X2', 104, NULL, NULL, 145539),
(145540, '3.40.50.1460-FF-000030', NULL, 'GM15423', 274, NULL, NULL, 145540),
(145541, '3.30.200.20-FF-000916', NULL, 'Putative Serine/threonine-protein kinase pim-3', 99, NULL, NULL, 145541),
(145542, '2.60.120.200-FF-000126', NULL, 'usherin', 169, NULL, NULL, 145542),
(145543, '3.40.50.980-FF-000056', NULL, 'Predicted protein', 72, NULL, NULL, 145543),
(145544, '3.30.40.10-FF-001059', NULL, 'RING-H2 finger protein ATL22', 82, NULL, NULL, 145544),
(145545, '3.40.50.2300-FF-000226', NULL, 'Sigma-54-dependent Fis family transcriptional regulator', 129, NULL, NULL, 145545),
(145546, '2.60.120.1560-FF-000011', NULL, 'Predicted protein', 135, NULL, NULL, 145546),
(145547, '3.90.70.10-FF-000434', NULL, 'Uncharacterized protein', 378, NULL, NULL, 145547),
(145548, '3.90.550.10-FF-000763', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 382, NULL, NULL, 145548),
(145549, '3.30.160.60-FF-004680', NULL, NULL, 101, NULL, NULL, 145549),
(145550, '2.60.220.50-FF-000053', NULL, 'Adhesion G protein-coupled receptor G3', 163, NULL, NULL, 145550),
(145551, '3.30.160.60-FF-000677', NULL, 'zinc finger protein 76 isoform X2', 28, NULL, NULL, 145551),
(145552, '3.40.366.10-FF-000065', NULL, 'Uncharacterized protein', 140, NULL, NULL, 145552),
(145553, '3.40.50.1580-FF-000004', NULL, 'Purine nucleoside phosphorylase', 283, NULL, NULL, 145553),
(145554, '4.10.80.160-FF-000004', NULL, 'Unplaced genomic scaffold supercont2.8, whole genome shotgun sequence', 30, NULL, NULL, 145554),
(145555, '2.60.40.10-FF-002993', NULL, 'AGAP003656-PB', 95, NULL, NULL, 145555),
(145556, '3.50.50.60-FF-000522', NULL, 'Oleate hydratase', 132, NULL, NULL, 145556),
(145557, '1.10.287.110-FF-000089', NULL, 'Related to DnaJ homolog subfamily C member 3', 84, NULL, NULL, 145557),
(145558, '2.130.10.10-FF-004444', NULL, 'Uncharacterized protein', 426, NULL, NULL, 145558),
(145559, '3.40.109.10-FF-000019', NULL, '5,6-dimethylbenzimidazole synthase', 181, NULL, NULL, 145559),
(145560, '1.10.533.10-FF-000266', NULL, 'Baculoviral IAP repeat containing 7', 128, NULL, NULL, 145560),
(145561, '1.10.1450.10-FF-000168', NULL, 'Tetraspanin', 58, NULL, NULL, 145561),
(145562, '3.90.550.10-FF-000437', NULL, 'Galactosylgalactosylxylosylprotein 3-beta-glucuronosyltransferase', 174, NULL, NULL, 145562),
(145563, '3.30.565.10-FF-000535', NULL, 'Histidine kinase', 158, NULL, NULL, 145563),
(145564, '2.60.120.560-FF-000032', NULL, 'Putative invertase', 109, NULL, NULL, 145564),
(145565, '2.60.200.20-FF-000184', NULL, 'FHA domain containing protein', 119, NULL, NULL, 145565);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(145566, '1.25.10.10-FF-000843', NULL, 'Vacuole morphology and inheritance protein 14', 277, NULL, NULL, 145566),
(145567, '3.30.1370.50-FF-000004', NULL, 'NFKB repressing factor', 76, NULL, NULL, 145567),
(145568, '3.40.50.300-FF-000167', NULL, 'Cell division control protein 42 homolog', 182, NULL, NULL, 145568),
(145569, '3.40.50.300-FF-008098', NULL, 'ABC transporter', 111, NULL, NULL, 145569),
(145570, '3.10.110.10-FF-000237', NULL, 'Ubiquitin-conjugating enzyme E2-21.2 kDa', 150, NULL, NULL, 145570),
(145571, '1.25.40.10-FF-000345', NULL, 'Pentatricopeptide repeat-containing protein', 209, NULL, NULL, 145571),
(145572, '3.10.20.30-FF-000036', NULL, 'Naphthalene 1,2-dioxygenase reductase component', 97, NULL, NULL, 145572),
(145573, '1.10.790.10-FF-000003', NULL, 'Prion protein 2', 134, NULL, NULL, 145573),
(145574, '3.90.70.10-FF-000092', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 376, NULL, NULL, 145574),
(145575, '2.40.160.50-FF-000002', NULL, 'sorting and assembly machinery component 50 homolog', 335, NULL, NULL, 145575),
(145576, '3.90.550.10-FF-000095', NULL, 'Glycosyltransferase family protein 64 protein C5', 243, NULL, NULL, 145576),
(145577, '3.90.79.10-FF-000173', NULL, 'Macaca fascicularis brain cDNA clone: QtrA-18315, similar to human fibroblast growth factor 2 (basic) (FGF2), mRNA, RefSeq: NM_002006.3', 60, NULL, NULL, 145577),
(145578, '1.25.40.10-FF-003774', NULL, 'Uncharacterized protein', 155, NULL, NULL, 145578),
(145579, '3.40.50.170-FF-000026', NULL, 'Phosphoribosylglycinamide formyltransferase protein', 191, NULL, NULL, 145579),
(145580, '1.20.5.730-FF-000015', NULL, 'Uncharacterized protein', 39, NULL, NULL, 145580),
(145581, '1.20.58.1880-FF-000004', NULL, 'nuclear receptor corepressor 1 isoform X4', 117, NULL, NULL, 145581),
(145582, '3.30.70.330-FF-000581', NULL, 'Heterogeneous nuclear ribonucleoprotein A0', 123, NULL, NULL, 145582),
(145583, '3.30.160.40-FF-000014', NULL, 'Probable porphobilinogen deaminase', 87, NULL, NULL, 145583),
(145584, '3.30.565.10-FF-000193', NULL, 'Sensor histidine kinase', 155, NULL, NULL, 145584),
(145585, '1.10.490.10-FF-000014', NULL, 'Hemoglobin subunit delta', 115, NULL, NULL, 145585),
(145586, '3.40.640.10-FF-000113', NULL, 'Probable glycine dehydrogenase (decarboxylating) subunit 1', 266, NULL, NULL, 145586),
(145587, '3.40.50.300-FF-002589', NULL, 'Putative AAA family ATPase', 196, NULL, NULL, 145587),
(145588, '1.20.1560.10-FF-000106', NULL, 'Yersiniabactin ABC transporter ATP-binding/permease protein YbtP', 315, NULL, NULL, 145588),
(145589, '1.25.40.10-FF-001868', NULL, 'Adenylyl cyclase', 229, NULL, NULL, 145589),
(145590, '1.20.1640.10-FF-000107', NULL, NULL, 125, NULL, NULL, 145590),
(145591, '1.20.870.10-FF-000007', NULL, 'Ras-GEF domain-containing family member 1B', 153, NULL, NULL, 145591),
(145592, '3.10.20.10-FF-000030', NULL, '60S ribosomal protein L18a', 64, NULL, NULL, 145592),
(145593, '2.70.150.10-FF-000264', NULL, 'Calcium-transporting ATPase', 161, NULL, NULL, 145593),
(145594, '1.10.420.10-FF-000015', NULL, 'Cytochrome c peroxidase, mitochondrial', 121, NULL, NULL, 145594),
(145595, '2.60.40.10-FF-002375', NULL, 'Sushi, nidogen and EGF-like domains 1', 94, NULL, NULL, 145595),
(145596, '1.25.10.10-FF-002642', NULL, 'Uncharacterized protein', 118, NULL, NULL, 145596),
(145597, '2.40.30.130-FF-000037', NULL, 'Alanine--tRNA ligase', 91, NULL, NULL, 145597),
(145598, '2.60.40.60-FF-000956', NULL, 'Uncharacterized protein', 99, NULL, NULL, 145598),
(145599, '3.40.50.880-FF-000183', NULL, 'Glutamine amidotransferase class-I, putative', 189, NULL, NULL, 145599),
(145600, '3.40.1260.10-FF-000010', NULL, 'DsrE family protein', 114, NULL, NULL, 145600),
(145601, '1.25.40.10-FF-002144', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 94, NULL, NULL, 145601),
(145602, '3.40.1380.20-FF-000067', NULL, 'Pyruvate kinase', 78, NULL, NULL, 145602),
(145603, '3.40.50.80-FF-000091', NULL, 'NADPH oxidase 4', 175, NULL, NULL, 145603),
(145604, '1.25.40.20-FF-000909', NULL, 'Uncharacterized protein', 206, NULL, NULL, 145604);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(145605, '1.25.40.10-FF-001975', NULL, 'Tetratricopeptide-like helical', 204, NULL, NULL, 145605),
(145606, '2.130.10.10-FF-000554', NULL, 'Vacuolar protein sorting-associated protein 41 homolog', 274, NULL, NULL, 145606),
(145607, '2.10.25.10-FF-001583', NULL, 'Thrombospondin 4', 37, NULL, NULL, 145607),
(145608, '1.10.287.110-FF-000145', NULL, 'Chaperone protein dnaJ 20, chloroplastic', 111, NULL, NULL, 145608),
(145609, '3.30.830.10-FF-000265', NULL, 'Uncharacterized protein', 241, NULL, NULL, 145609),
(145610, '1.20.1250.20-FF-002300', NULL, 'AFR602Wp', 474, NULL, NULL, 145610),
(145611, '1.20.120.1080-FF-000002', NULL, 'Putative ATP-dependent RNA helicase DHX36', 105, NULL, NULL, 145611),
(145612, '2.60.40.60-FF-000782', NULL, 'Cadherin 24, type 2a', 82, NULL, NULL, 145612),
(145613, '1.10.1200.80-FF-000002', NULL, 'tRNA-dihydrouridine synthase', 67, NULL, NULL, 145613),
(145614, '1.25.40.680-FF-000002', NULL, 'Uncharacterized protein', 159, NULL, NULL, 145614),
(145615, '3.30.160.60-FF-006416', NULL, NULL, 53, NULL, NULL, 145615),
(145616, '1.25.40.470-FF-000040', NULL, 'Intraflagellar transport protein osm-1', 131, NULL, NULL, 145616),
(145617, '3.90.76.10-FF-000043', NULL, 'Peptide ABC transporter, periplasmic peptide-binding protein', 108, NULL, NULL, 145617),
(145618, '2.60.40.1450-FF-000012', NULL, 'Transcription factor cbf12', 195, NULL, NULL, 145618),
(145619, '2.70.170.10-FF-000147', NULL, '5-hydroxytryptamine receptor 3D', 124, NULL, NULL, 145619),
(145620, '2.160.20.10-FF-000020', NULL, 'SHC SH2 domain-binding protein 1', 206, NULL, NULL, 145620),
(145621, '3.40.640.10-FF-000405', NULL, 'Uncharacterized protein', 260, NULL, NULL, 145621),
(145622, '1.10.150.670-FF-000004', NULL, 'Crossover junction endonuclease EME1', 94, NULL, NULL, 145622),
(145623, '1.25.10.10-FF-000169', NULL, 'protein VAC14 homolog isoform X1', 163, NULL, NULL, 145623),
(145624, '3.30.70.141-FF-000002', NULL, 'Nucleoside diphosphate kinase', 152, NULL, NULL, 145624),
(145625, '2.40.10.10-FF-000019', NULL, 'Anionic trypsin', 97, NULL, NULL, 145625),
(145626, '1.10.287.1490-FF-000048', NULL, 'Uncharacterized protein', 233, NULL, NULL, 145626),
(145627, '3.40.50.1820-FF-001695', NULL, 'Carboxypeptidase', 191, NULL, NULL, 145627),
(145628, '3.30.450.20-FF-000160', NULL, 'PAS domain containing repressor 1', 140, NULL, NULL, 145628),
(145629, '3.40.50.980-FF-000005', NULL, 'Acyl-CoA synthetase family member 2', 152, NULL, NULL, 145629),
(145630, '1.10.418.10-FF-000072', NULL, 'microtubule-associated protein RP/EB family member 2 isoform X2', 131, NULL, NULL, 145630),
(145631, '2.130.10.30-FF-000150', NULL, NULL, 180, NULL, NULL, 145631),
(145632, '1.10.472.10-FF-000236', NULL, 'Cyclin, N-terminal domain protein', 101, NULL, NULL, 145632),
(145633, '3.30.160.60-FF-000784', NULL, 'Zinc finger protein 180', 26, NULL, NULL, 145633),
(145634, '3.40.50.970-FF-000002', NULL, '2-oxoglutarate dehydrogenase, E1 component', 366, NULL, NULL, 145634),
(145635, '3.30.70.240-FF-000054', NULL, 'Uncharacterized protein', 76, NULL, NULL, 145635),
(145636, '2.60.40.720-FF-000003', NULL, 'Cellular tumor antigen p53', 201, NULL, NULL, 145636),
(145637, '3.40.1000.50-FF-000008', NULL, 'Maf1 regulator', 156, NULL, NULL, 145637),
(145638, '3.40.50.2000-FF-000911', NULL, 'Uncharacterized protein', 164, NULL, NULL, 145638),
(145639, '3.30.70.330-FF-000311', NULL, 'polyadenylate-binding protein 2', 175, NULL, NULL, 145639),
(145640, '3.40.50.300-FF-008373', NULL, 'Predicted protein', 195, NULL, NULL, 145640),
(145641, '3.10.20.90-FF-000649', NULL, 'Uncharacterized protein', 100, NULL, NULL, 145641),
(145642, '2.60.260.20-FF-000069', NULL, 'Molecular chaperone DnaJ', 67, NULL, NULL, 145642),
(145643, '2.60.40.790-FF-000058', NULL, 'CS domain protein, putative', 85, NULL, NULL, 145643),
(145644, '3.40.640.10-FF-000057', NULL, 'Phosphoserine aminotransferase', 244, NULL, NULL, 145644),
(145645, '2.60.40.1460-FF-000015', NULL, 'Integrin alpha 3 protein', 148, NULL, NULL, 145645),
(145646, '1.20.1250.20-FF-001755', NULL, 'Uncharacterized protein', 193, NULL, NULL, 145646);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(145647, '1.20.1250.20-FF-002244', NULL, 'Uncharacterized protein', 114, NULL, NULL, 145647),
(145648, '3.30.450.40-FF-000166', NULL, 'GGDEF family protein', 158, NULL, NULL, 145648),
(145649, '1.20.1560.10-FF-000432', NULL, 'Predicted protein', 23, NULL, NULL, 145649),
(145650, '3.40.190.290-FF-000137', NULL, 'Transcriptional regulator lysR family', 226, NULL, NULL, 145650),
(145651, '3.30.200.20-FF-001934', NULL, 'Uncharacterized protein', 67, NULL, NULL, 145651),
(145652, '2.60.40.60-FF-000563', NULL, 'Cadherin 5', 112, NULL, NULL, 145652),
(145653, '2.40.160.120-FF-000019', NULL, 'Oxysterol binding protein, putative', 167, NULL, NULL, 145653),
(145654, '3.90.1150.10-FF-000327', NULL, 'Aminotransferase class I and II', 140, NULL, NULL, 145654),
(145655, '1.25.40.10-FF-000289', NULL, 'RNA polymerase-associated protein CTR9 homolog', 271, NULL, NULL, 145655),
(145656, '1.10.150.20-FF-000205', NULL, 'GH27547p', 130, NULL, NULL, 145656),
(145657, '3.30.450.40-FF-000115', NULL, 'Transcriptional regulator, IclR family', 166, NULL, NULL, 145657),
(145658, '1.20.58.480-FF-000024', NULL, 'Uncharacterized protein', 258, NULL, NULL, 145658),
(145659, '1.10.510.10-FF-002546', NULL, 'Protein kinase, putative', 291, NULL, NULL, 145659),
(145660, '1.10.240.10-FF-000029', NULL, 'Uncharacterized protein', 75, NULL, NULL, 145660),
(145661, '2.40.160.110-FF-000016', NULL, 'FI04419p', 188, NULL, NULL, 145661),
(145662, '2.10.25.10-FF-001364', NULL, 'Wall-associated receptor kinase-like 8', 56, NULL, NULL, 145662),
(145663, '3.30.200.20-FF-000175', NULL, 'Serine/threonine-protein kinase 17B', 84, NULL, NULL, 145663),
(145664, '3.30.1360.210-FF-000007', NULL, 'Uncharacterized protein', 46, NULL, NULL, 145664),
(145665, '3.30.1330.50-FF-000002', NULL, '2-C-methyl-D-erythritol 2,4-cyclodiphosphate synthase', 160, NULL, NULL, 145665),
(145666, '2.40.30.170-FF-000026', NULL, 'HlyD family secretion protein', 61, NULL, NULL, 145666),
(145667, '2.60.40.1660-FF-000018', NULL, 'Sodium/potassium-transporting ATPase subunit beta-1', 250, NULL, NULL, 145667),
(145668, '3.30.40.10-FF-001677', NULL, 'Hrdl-1', 74, NULL, NULL, 145668),
(145669, '3.90.1100.10-FF-000049', NULL, 'DNA-directed RNA polymerase subunit beta', 156, NULL, NULL, 145669),
(145670, '3.30.420.40-FF-000613', NULL, 'Actin-related protein 7', 62, NULL, NULL, 145670),
(145671, '3.50.50.60-FF-000814', NULL, 'FAD-dependent pyridine nucleotide-disulfide oxidoreductase family protein', 173, NULL, NULL, 145671),
(145672, '1.20.1070.10-FF-001985', NULL, 'Predicted protein', 160, NULL, NULL, 145672),
(145673, '1.25.40.10-FF-002470', NULL, 'Pentatricopeptide repeat-containing protein', 101, NULL, NULL, 145673),
(145674, '1.25.10.10-FF-000787', NULL, 'TATA-binding protein-associated factor BTAF1', 212, NULL, NULL, 145674),
(145675, '2.60.200.20-FF-000240', NULL, 'Uncharacterized protein', 121, NULL, NULL, 145675),
(145676, '1.10.20.10-FF-000377', NULL, NULL, 67, NULL, NULL, 145676),
(145677, '2.40.10.10-FF-000637', NULL, NULL, 218, NULL, NULL, 145677),
(145678, '3.30.1360.200-FF-000004', NULL, 'Protein translocase subunit SecD', 155, NULL, NULL, 145678),
(145679, '3.30.200.20-FF-002480', NULL, NULL, 38, NULL, NULL, 145679),
(145680, '1.20.1530.20-FF-000046', NULL, 'Cation/H(+) antiporter 28', 426, NULL, NULL, 145680),
(145681, '2.60.40.60-FF-001119', NULL, 'Predicted protein', 102, NULL, NULL, 145681),
(145682, '3.40.50.11020-FF-000003', NULL, 'Replicase polyprotein 1a', 119, NULL, NULL, 145682),
(145683, '1.10.10.60-FF-000594', NULL, 'Pre-mRNA-splicing factor CEF1', 41, NULL, NULL, 145683),
(145684, '3.40.50.970-FF-000053', NULL, 'Acetolactate synthase, mitochondrial', 226, NULL, NULL, 145684),
(145685, '3.40.50.300-FF-007878', NULL, 'Si:dkey-11m19.5', 201, NULL, NULL, 145685),
(145686, '3.40.50.2000-FF-000350', NULL, 'UDP-GlcNAc:PI a1-6 GlcNAc-transferase', 162, NULL, NULL, 145686),
(145687, '3.90.190.10-FF-000050', NULL, 'Dual specificity phosphatase 16 (Predicted)', 157, NULL, NULL, 145687),
(145688, '1.10.20.10-FF-000164', NULL, 'Uncharacterized protein', 91, NULL, NULL, 145688);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(145689, '3.50.50.60-FF-000466', NULL, 'L-ornithine N(5)-monooxygenase', 431, NULL, NULL, 145689),
(145690, '1.20.1050.10-FF-000017', NULL, 'Maleylacetoacetate isomerase', 127, NULL, NULL, 145690),
(145691, '1.20.58.390-FF-000199', NULL, 'Ligand-gated ion channel', 138, NULL, NULL, 145691),
(145692, '3.40.50.300-FF-001280', NULL, 'Related to 6-phosphofructo-2-kinase', 212, NULL, NULL, 145692),
(145693, '2.120.10.80-FF-000339', NULL, 'Uncharacterized protein', 118, NULL, NULL, 145693),
(145694, '3.30.530.20-FF-000161', NULL, 'Predicted protein', 139, NULL, NULL, 145694),
(145695, '3.90.190.20-FF-000053', NULL, 'Folylpolyglutamate synthase', 187, NULL, NULL, 145695),
(145696, '3.30.40.10-FF-002166', NULL, 'Uncharacterized protein', 86, NULL, NULL, 145696),
(145697, '3.40.50.300-FF-001010', NULL, 'ABC multidrug transporter (Eurofung)', 239, NULL, NULL, 145697),
(145698, '2.60.40.10-FF-004909', NULL, NULL, 89, NULL, NULL, 145698),
(145699, '3.30.200.20-FF-002210', NULL, 'Tribbles pseudokinase 1', 46, NULL, NULL, 145699),
(145700, '3.40.190.10-FF-000426', NULL, 'HTH-type transcriptional regulator IlvY', 102, NULL, NULL, 145700),
(145701, '3.40.50.300-FF-004657', NULL, 'Protein transport protein HofB homolog', 234, NULL, NULL, 145701),
(145702, '3.30.1370.10-FF-000054', NULL, 'Fragile X mental retardation protein 1', 82, NULL, NULL, 145702),
(145703, '2.120.10.30-FF-000353', NULL, 'Uncharacterized protein', 162, NULL, NULL, 145703),
(145704, '3.40.50.300-FF-000791', NULL, 'Cytosolic Fe-S cluster assembly factor NBP35', 259, NULL, NULL, 145704),
(145705, '3.90.70.10-FF-000378', NULL, 'Uncharacterized protein', 290, NULL, NULL, 145705),
(145706, '1.25.10.10-FF-001063', NULL, 'Uncharacterized protein', 130, NULL, NULL, 145706),
(145707, '1.10.238.10-FF-000378', NULL, 'Protein S100-A9', 115, NULL, NULL, 145707),
(145708, '3.90.226.10-FF-000347', NULL, 'Propionyl-CoA carboxylase, putative', 250, NULL, NULL, 145708),
(145709, '1.10.287.950-FF-000048', NULL, 'Heme-based aerotactic transducer HemAT', 294, NULL, NULL, 145709),
(145710, '3.30.60.190-FF-000014', NULL, 'Uncharacterized protein', 51, NULL, NULL, 145710),
(145711, '2.160.20.10-FF-000071', NULL, 'Uncharacterized protein', 344, NULL, NULL, 145711),
(145712, '1.20.1250.20-FF-001137', NULL, 'Solute carrier organic anion transporter family member', 275, NULL, NULL, 145712),
(145713, '1.25.10.10-FF-000517', NULL, 'Condensin-2 complex subunit', 182, NULL, NULL, 145713),
(145714, '3.30.200.20-FF-001985', NULL, 'Os04g0563600 protein', 122, NULL, NULL, 145714),
(145715, '1.10.510.10-FF-002933', NULL, NULL, 121, NULL, NULL, 145715),
(145716, '2.40.50.120-FF-000021', NULL, 'ADAMTS like 5', 124, NULL, NULL, 145716),
(145717, '1.10.340.70-FF-000004', NULL, 'Retrovirus-related Pol polyprotein from transposon 297-like Protein', 84, NULL, NULL, 145717),
(145718, '2.160.20.70-FF-000009', NULL, 'Tubulin-folding cofactor C', 173, NULL, NULL, 145718),
(145719, '3.40.50.300-FF-004949', NULL, 'LIP1/RABL3-like protein, Ras superfamily GTPase', 167, NULL, NULL, 145719),
(145720, '2.30.30.100-FF-000081', NULL, 'U6 snRNA-associated Sm-like protein LSm8p', 95, NULL, NULL, 145720),
(145721, '2.60.260.20-FF-000182', NULL, 'Chaperone protein dnaJ A6 chloroplastic', 61, NULL, NULL, 145721),
(145722, '2.130.10.10-FF-003988', NULL, 'Uncharacterized protein', 231, NULL, NULL, 145722),
(145723, '2.30.29.30-FF-001209', NULL, 'Uncharacterized protein', 164, NULL, NULL, 145723),
(145724, '2.130.10.10-FF-000279', NULL, 'POC1 centriolar protein homolog B', 94, NULL, NULL, 145724),
(145725, '3.30.160.60-FF-005112', NULL, NULL, 61, NULL, NULL, 145725),
(145726, '3.40.50.2000-FF-000170', NULL, 'Probable glycosyltransferase', 226, NULL, NULL, 145726),
(145727, '1.25.70.10-FF-000061', NULL, NULL, 150, NULL, NULL, 145727),
(145728, '3.40.50.1820-FF-000621', NULL, 'Alpha/beta hydrolase', 261, NULL, NULL, 145728),
(145729, '2.130.10.10-FF-001858', NULL, 'Blast:Phosphoinositide 3-kinase regulatory subunit 4', 204, NULL, NULL, 145729),
(145730, '1.10.3630.10-FF-000002', NULL, 'Vacuolar sorting-associated 74 protein', 282, NULL, NULL, 145730);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(145731, '1.25.40.20-FF-001130', NULL, 'Potassium channel AKT2/3', 179, NULL, NULL, 145731),
(145732, '1.10.510.10-FF-002877', NULL, NULL, 174, NULL, NULL, 145732),
(145733, '2.60.120.260-FF-000116', NULL, 'Beta-galactosidase 17', 188, NULL, NULL, 145733),
(145734, '3.40.50.150-FF-000762', NULL, 'S-adenosyl-L-methionine-dependent methyltransferase', 251, NULL, NULL, 145734),
(145735, '3.30.420.40-FF-000669', NULL, 'Uncharacterized protein', 64, NULL, NULL, 145735),
(145736, '3.90.70.10-FF-000647', NULL, 'Uncharacterized protein', 92, NULL, NULL, 145736),
(145737, '3.80.10.10-FF-004051', NULL, 'Leucine-rich repeats and immunoglobulin-like domains 2', 136, NULL, NULL, 145737),
(145738, '1.25.40.10-FF-001649', NULL, 'Pentatricopeptide repeat-containing protein', 241, NULL, NULL, 145738),
(145739, '2.60.120.330-FF-000199', NULL, 'Uncharacterized protein', 146, NULL, NULL, 145739),
(145740, '3.30.250.20-FF-000009', NULL, 'Uncharacterized protein', 77, NULL, NULL, 145740),
(145741, '3.30.40.10-FF-000042', NULL, 'protein AF-10 isoform X1', 123, NULL, NULL, 145741),
(145742, '3.30.420.100-FF-000018', NULL, 'Structural constituent of ribosome', 48, NULL, NULL, 145742),
(145743, '3.40.50.11660-FF-000003', NULL, 'Alpha-(1,4)-fucosyltransferase', 207, NULL, NULL, 145743),
(145744, '3.90.70.10-FF-000608', NULL, 'Uncharacterized protein', 173, NULL, NULL, 145744),
(145745, '3.30.40.10-FF-002222', NULL, 'Histone-lysine N-methyltransferase', 68, NULL, NULL, 145745),
(145746, '3.40.50.720-FF-000337', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 275, NULL, NULL, 145746),
(145747, '2.40.50.140-FF-000027', NULL, '26S protease regulatory subunit 10B', 105, NULL, NULL, 145747),
(145748, '3.30.40.10-FF-000081', NULL, 'Zinc finger MYND domain-containing protein 11', 63, NULL, NULL, 145748),
(145749, '1.20.1050.60-FF-000009', NULL, 'Alpha-1,2-mannosidase, putative', 99, NULL, NULL, 145749),
(145750, '3.30.830.10-FF-000208', NULL, 'Insulin degrading enzyme-like zinc peptidase, putative', 219, NULL, NULL, 145750),
(145751, '3.40.50.300-FF-002819', NULL, 'BRCA1 interacting protein C-terminal helicase 1', 97, NULL, NULL, 145751),
(145752, '1.10.238.10-FF-000827', NULL, 'Calcium-binding EF hand family protein', 95, NULL, NULL, 145752),
(145753, '2.40.30.10-FF-000352', NULL, 'Putative tRNA-methyl transferase', 131, NULL, NULL, 145753),
(145754, '3.40.50.300-FF-000728', NULL, 'ADP-ribosylation factor-like protein 5', 177, NULL, NULL, 145754),
(145755, '2.70.170.10-FF-000192', NULL, 'Predicted protein', 203, NULL, NULL, 145755),
(145756, '3.40.50.300-FF-000678', NULL, 'Rho GTPase Rho4', 200, NULL, NULL, 145756),
(145757, '2.30.30.490-FF-000040', NULL, 'DNA methyltransferase Dim-2', 167, NULL, NULL, 145757),
(145758, '3.30.40.10-FF-002172', NULL, 'Predicted protein', 83, NULL, NULL, 145758),
(145759, '3.80.10.10-FF-001976', NULL, 'Uncharacterized protein', 151, NULL, NULL, 145759),
(145760, '4.10.800.10-FF-000033', NULL, 'Uncharacterized protein', 55, NULL, NULL, 145760),
(145761, '2.160.20.60-FF-000006', NULL, 'Ferredoxin-dependent glutamate synthase, chloroplastic', 87, NULL, NULL, 145761),
(145762, '3.30.200.20-FF-000349', NULL, 'Anti-Muellerian hormone type-2 receptor', 93, NULL, NULL, 145762),
(145763, '1.25.40.90-FF-000037', NULL, 'Enhancer of ag-4 2', 144, NULL, NULL, 145763),
(145764, '3.40.50.920-FF-000009', NULL, '2-oxoglutarate ferredoxin oxidoreductase subunit alpha', 115, NULL, NULL, 145764),
(145765, '1.20.1390.10-FF-000003', NULL, 'U4/U6 small nuclear ribonucleoprotein Prp3', 71, NULL, NULL, 145765),
(145766, '2.40.50.430-FF-000013', NULL, 'Uncharacterized protein', 167, NULL, NULL, 145766),
(145767, '3.30.1490.80-FF-000033', NULL, 'Uncharacterized protein', 27, NULL, NULL, 145767),
(145768, '1.10.510.10-FF-000803', NULL, 'Muscle M-line assembly protein unc-89', 219, NULL, NULL, 145768),
(145769, '4.10.60.10-FF-000261', NULL, 'Uncharacterized protein', 85, NULL, NULL, 145769),
(145770, '3.40.570.10-FF-000051', NULL, 'Uncharacterized protein', 147, NULL, NULL, 145770),
(145771, '3.30.710.10-FF-000104', NULL, 'zinc finger and BTB domain-containing protein 39', 139, NULL, NULL, 145771);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(145772, '3.40.50.2300-FF-000046', NULL, 'Galactose ABC transporter substrate-binding protein', 128, NULL, NULL, 145772),
(145773, '2.10.25.160-FF-000008', NULL, 'Granulin b', 66, NULL, NULL, 145773),
(145774, '3.30.2300.10-FF-000016', NULL, 'Uncharacterized protein', 89, NULL, NULL, 145774),
(145775, '1.20.1250.20-FF-001463', NULL, 'Proton-dependent oligopeptide transport family protein', 224, NULL, NULL, 145775),
(145776, '1.10.220.10-FF-000028', NULL, 'Annexin D4', 70, NULL, NULL, 145776),
(145777, '2.60.40.420-FF-000200', NULL, 'AGAP008732-PA', 97, NULL, NULL, 145777),
(145778, '3.50.50.60-FF-000702', NULL, 'OSJNBa0084K11.8-like protein', 321, NULL, NULL, 145778),
(145779, '1.20.1160.11-FF-000010', NULL, 'Os05g0588700 protein', 71, NULL, NULL, 145779),
(145780, '1.10.287.680-FF-000001', NULL, 'UPF0304 protein YfbU', 50, NULL, NULL, 145780),
(145781, '3.20.20.140-FF-000201', NULL, 'Dihydroorotase', 312, NULL, NULL, 145781),
(145782, '2.40.10.10-FF-000351', NULL, NULL, 107, NULL, NULL, 145782),
(145783, '1.25.10.30-FF-000001', NULL, 'Inositol 1,4,5-trisphosphate receptor, type 2', 166, NULL, NULL, 145783),
(145784, '3.90.950.10-FF-000018', NULL, 'dTTP/UTP pyrophosphatase', 189, NULL, NULL, 145784),
(145785, '3.90.1150.10-FF-000097', NULL, 'Glycine cleavage system P protein', 136, NULL, NULL, 145785),
(145786, '1.10.510.10-FF-002990', NULL, NULL, 198, NULL, NULL, 145786),
(145787, '1.25.40.10-FF-004448', NULL, 'Pentatricopeptide repeat-containing protein At1g66345, mitochondrial', 114, NULL, NULL, 145787),
(145788, '2.60.40.10-FF-002549', NULL, 'Myotactin form A', 93, NULL, NULL, 145788),
(145789, '1.20.1000.10-FF-000020', NULL, NULL, 230, NULL, NULL, 145789),
(145790, '1.20.1530.20-FF-000102', NULL, 'Uncharacterized protein', 133, NULL, NULL, 145790),
(145791, '3.30.420.40-FF-000725', NULL, 'AaceriACR184Cp', 147, NULL, NULL, 145791),
(145792, '3.10.25.10-FF-000018', NULL, 'Methionyl-tRNA formyltransferase', 105, NULL, NULL, 145792),
(145793, '3.40.50.2020-FF-000176', NULL, 'Uncharacterized protein', 54, NULL, NULL, 145793),
(145794, '3.30.1390.20-FF-000019', NULL, '50S ribosomal protein L30', 59, NULL, NULL, 145794),
(145795, '3.30.450.70-FF-000040', NULL, NULL, 80, NULL, NULL, 145795),
(145796, '3.40.50.2300-FF-001569', NULL, NULL, 158, NULL, NULL, 145796),
(145797, '3.30.40.10-FF-001497', NULL, 'FI16849p1', 77, NULL, NULL, 145797),
(145798, '3.40.640.10-FF-000444', NULL, 'Uncharacterized protein', 144, NULL, NULL, 145798),
(145799, '1.25.40.10-FF-002318', NULL, 'Os07g0662700 protein', 97, NULL, NULL, 145799),
(145800, '3.40.50.300-FF-008603', NULL, 'Uncharacterized protein', 195, NULL, NULL, 145800),
(145801, '2.130.10.10-FF-003134', NULL, 'Ubiquitin-binding SDF ubiquitin ligase complex subunit', 126, NULL, NULL, 145801),
(145802, '2.60.40.150-FF-000372', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', 154, NULL, NULL, 145802),
(145803, '3.30.160.60-FF-002257', NULL, 'Zinc finger protein 540', 25, NULL, NULL, 145803),
(145804, '3.40.50.300-FF-001403', NULL, 'Polyprotein P1234', 137, NULL, NULL, 145804),
(145805, '3.30.559.10-FF-000190', NULL, 'Uncharacterized protein', 174, NULL, NULL, 145805),
(145806, '1.10.3610.10-FF-000001', NULL, 'Nucleoprotein', 200, NULL, NULL, 145806),
(145807, '1.10.3730.20-FF-000058', NULL, 'EamA-like transporter family protein', 118, NULL, NULL, 145807),
(145808, '3.90.120.10-FF-000006', NULL, 'DNA (Cytosine-5)-methyltransferase', 133, NULL, NULL, 145808),
(145809, '3.40.630.30-FF-000101', NULL, 'N-alpha-acetyltransferase 10', 179, NULL, NULL, 145809),
(145810, '2.130.10.10-FF-001004', NULL, 'Transducin family protein / WD-40 repeat family protein', 260, NULL, NULL, 145810),
(145811, '3.40.50.620-FF-000133', NULL, 'Isoleucyl-tRNA synthetase, cytoplasmic', 274, NULL, NULL, 145811),
(145812, '3.40.50.620-FF-000190', NULL, 'Arginine--tRNA ligase', 379, NULL, NULL, 145812),
(145813, '3.40.190.10-FF-000752', NULL, 'Bifunctional periplasmic substrate binding protein/cytoplasmic diguanylate cyclase', 95, NULL, NULL, 145813),
(145814, '1.20.1250.20-FF-002250', NULL, 'Battenin', 111, NULL, NULL, 145814);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(145815, '3.30.70.330-FF-002110', NULL, NULL, 113, NULL, NULL, 145815),
(145816, '3.40.50.300-FF-006243', NULL, 'SNF2 superfamily protein', 222, NULL, NULL, 145816),
(145817, '1.10.287.890-FF-000002', NULL, 'Adenylate isopentenyltransferase 5, chloroplastic', 101, NULL, NULL, 145817),
(145818, '1.25.40.10-FF-001014', NULL, 'Pentatricopeptide repeat-containing protein', 164, NULL, NULL, 145818),
(145819, '3.30.420.110-FF-000078', NULL, 'Predicted protein', 165, NULL, NULL, 145819),
(145820, '2.60.40.10-FF-001026', NULL, 'Uncharacterized protein, isoform B', 100, NULL, NULL, 145820),
(145821, '1.10.8.1130-FF-000001', NULL, NULL, 67, NULL, NULL, 145821),
(145822, '3.90.550.10-FF-000656', NULL, 'Uncharacterized protein', 126, NULL, NULL, 145822),
(145823, '3.80.10.10-FF-002701', NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', 58, NULL, NULL, 145823),
(145824, '3.10.20.310-FF-000047', NULL, 'Translocation and assembly module subunit TamA', 75, NULL, NULL, 145824),
(145825, '1.25.40.20-FF-001017', NULL, 'Os05g0427600 protein', 204, NULL, NULL, 145825),
(145826, '2.130.10.10-FF-004770', NULL, 'AGAP000479-PA', 155, NULL, NULL, 145826),
(145827, '3.10.20.90-FF-000918', NULL, 'Uncharacterized protein', 62, NULL, NULL, 145827),
(145828, '3.30.160.60-FF-000964', NULL, 'zinc finger protein 507', 80, NULL, NULL, 145828),
(145829, '2.160.20.10-FF-000306', NULL, 'Protein CBR-DRE-1', 130, NULL, NULL, 145829),
(145830, '1.10.1070.11-FF-000128', NULL, 'Uncharacterized protein', 95, NULL, NULL, 145830),
(145831, '2.130.10.10-FF-004882', NULL, 'Uncharacterized protein', 118, NULL, NULL, 145831),
(145832, '2.120.10.80-FF-000165', NULL, 'Epithiospecifier protein', 128, NULL, NULL, 145832),
(145833, '3.90.70.10-FF-000760', NULL, 'Ubiquitin-specific peptidase 2a', 91, NULL, NULL, 145833),
(145834, '1.10.10.10-FF-000843', NULL, 'NAD kinase', 88, NULL, NULL, 145834),
(145835, '1.10.418.10-FF-000184', NULL, 'Uncharacterized protein', 126, NULL, NULL, 145835),
(145836, '3.30.60.30-FF-000195', NULL, 'GEO13384p1', 49, NULL, NULL, 145836),
(145837, '2.60.40.60-FF-000119', NULL, 'neural-cadherin isoform X1', 110, NULL, NULL, 145837),
(145838, '3.30.160.60-FF-004387', NULL, NULL, 84, NULL, NULL, 145838),
(145839, '3.40.50.150-FF-000487', NULL, 'tRNA wybutosine-synthesizing protein 4', 364, NULL, NULL, 145839),
(145840, '1.10.472.10-FF-000528', NULL, 'Uncharacterized protein', 90, NULL, NULL, 145840),
(145841, '3.10.450.10-FF-000094', NULL, 'Uncharacterized protein', 60, NULL, NULL, 145841),
(145842, '1.20.140.100-FF-000037', NULL, 'Dynein heavy chain', 128, NULL, NULL, 145842),
(145843, '3.30.160.60-FF-001801', NULL, 'Zinc finger protein 574', 77, NULL, NULL, 145843),
(145844, '1.10.10.60-FF-000268', NULL, 'Transcription factor MYB86', 69, NULL, NULL, 145844),
(145845, '2.130.10.10-FF-000498', NULL, 'Striatin 3', 230, NULL, NULL, 145845),
(145846, '3.40.50.300-FF-008547', NULL, 'Mitochondrial GTPase 1', 156, NULL, NULL, 145846),
(145847, '2.10.25.10-FF-001656', NULL, 'Uncharacterized protein', 47, NULL, NULL, 145847),
(145848, '1.20.5.340-FF-000117', NULL, 'Transcriptional repressor tup11', 87, NULL, NULL, 145848),
(145849, '2.130.10.10-FF-004713', NULL, 'Uncharacterized protein', 169, NULL, NULL, 145849),
(145850, '1.25.40.10-FF-002650', NULL, 'Uncharacterized protein', 271, NULL, NULL, 145850),
(145851, '3.30.420.40-FF-000905', NULL, 'Chromosome 10, whole genome shotgun sequence', 169, NULL, NULL, 145851),
(145852, '2.60.40.60-FF-000395', NULL, 'Dachsous, isoform B', 105, NULL, NULL, 145852),
(145853, '2.60.40.10-FF-004792', NULL, NULL, 89, NULL, NULL, 145853),
(145854, '3.90.1150.10-FF-000153', NULL, 'Glycine dehydrogenase (decarboxylating)', 140, NULL, NULL, 145854),
(145855, '1.10.150.910-FF-000003', NULL, 'DNA damage-binding protein 1a', 87, NULL, NULL, 145855),
(145856, '2.60.260.20-FF-000125', NULL, 'Chaperone protein DNAJ, putative', 68, NULL, NULL, 145856),
(145857, '3.40.50.11660-FF-000060', NULL, NULL, 155, NULL, NULL, 145857),
(145858, '3.30.565.10-FF-000479', NULL, 'Uncharacterized protein', 82, NULL, NULL, 145858);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(145859, '2.40.10.10-FF-000463', NULL, NULL, 130, NULL, NULL, 145859),
(145860, '1.10.630.10-FF-000115', NULL, 'Cytochrome P450 monooxygenase, putative', 492, NULL, NULL, 145860),
(145861, '2.20.25.10-FF-000099', NULL, 'Uncharacterized protein', 127, NULL, NULL, 145861),
(145862, '3.40.190.10-FF-000191', NULL, 'Lipoprotein', 117, NULL, NULL, 145862),
(145863, '1.10.2000.10-FF-000022', NULL, 'Smoothened, frizzled class receptor', 61, NULL, NULL, 145863),
(145864, '1.10.150.220-FF-000004', NULL, 'Uncharacterized protein, isoform A', 88, NULL, NULL, 145864),
(145865, '3.40.50.261-FF-000004', NULL, 'ATP-citrate synthase subunit', 188, NULL, NULL, 145865),
(145866, '1.10.287.110-FF-000471', NULL, 'Uncharacterized protein', 54, NULL, NULL, 145866),
(145867, '1.10.238.10-FF-000086', NULL, 'calcium-dependent protein kinase SK5', 73, NULL, NULL, 145867),
(145868, '3.40.718.10-FF-000052', NULL, 'Isocitrate dehydrogenase 3 (NAD+) gamma', 79, NULL, NULL, 145868),
(145869, '1.10.8.270-FF-000093', NULL, 'Rab GTPase activating protein, putative', 127, NULL, NULL, 145869),
(145870, '1.20.1090.10-FF-000020', NULL, '3-dehydroquinate synthase', 188, NULL, NULL, 145870),
(145871, '3.30.70.3190-FF-000006', NULL, NULL, 37, NULL, NULL, 145871),
(145872, '3.40.50.2000-FF-000400', NULL, 'GDP-mannose-dependent alpha-(1-6)-phosphatidylinositol dimannoside mannosyltransferase', 200, NULL, NULL, 145872),
(145873, '3.30.160.60-FF-000907', NULL, 'Zinc finger protein 1 homolog', 27, NULL, NULL, 145873),
(145874, '3.40.50.300-FF-000908', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', 160, NULL, NULL, 145874),
(145875, '1.10.20.10-FF-000338', NULL, NULL, 106, NULL, NULL, 145875),
(145876, '3.30.40.10-FF-001385', NULL, 'Histone-lysine N-methyltransferase', 63, NULL, NULL, 145876),
(145877, '1.25.40.1010-FF-000008', NULL, 'Chromosome 1, whole genome shotgun sequence', 213, NULL, NULL, 145877),
(145878, '3.20.20.220-FF-000068', NULL, 'Proline dehydrogenase', 368, NULL, NULL, 145878),
(145879, '1.20.1290.10-FF-000001', NULL, 'Sestrin 1', 161, NULL, NULL, 145879),
(145880, '1.10.510.10-FF-004058', NULL, NULL, 289, NULL, NULL, 145880),
(145881, '3.30.200.20-FF-000681', NULL, 'Non-specific serine/threonine protein kinase', 104, NULL, NULL, 145881),
(145882, '1.20.1370.10-FF-000002', NULL, 'Hemocyanin subunit B', 106, NULL, NULL, 145882),
(145883, '3.60.15.10-FF-000044', NULL, 'Hydroxyacylglutathione hydrolase', 237, NULL, NULL, 145883),
(145884, '3.30.200.20-FF-000624', NULL, 'Mitogen-activated protein kinase kinase 2', 54, NULL, NULL, 145884),
(145885, '3.10.20.90-FF-000975', NULL, 'Uncharacterized protein', 101, NULL, NULL, 145885),
(145886, '3.40.50.300-FF-001515', NULL, 'ATP-dependent RNA helicase, putative', 204, NULL, NULL, 145886),
(145887, '1.10.8.720-FF-000048', NULL, 'Uncharacterized protein', 147, NULL, NULL, 145887),
(145888, '3.40.350.10-FF-000012', NULL, 'Xaa-Pro aminopeptidase', 173, NULL, NULL, 145888),
(145889, '2.40.380.10-FF-000001', NULL, 'Probable ribonuclease FAU-1', 110, NULL, NULL, 145889),
(145890, '3.30.830.10-FF-000321', NULL, 'Uncharacterized protein', 60, NULL, NULL, 145890),
(145891, '3.40.50.80-FF-000107', NULL, 'AGAP003772-PA', 172, NULL, NULL, 145891),
(145892, '2.60.40.10-FF-004735', NULL, NULL, 94, NULL, NULL, 145892),
(145893, '3.80.10.10-FF-003270', NULL, 'Toll-like receptor 2', 221, NULL, NULL, 145893),
(145894, '3.40.50.720-FF-000450', NULL, 'mRNA, clone: RTFL01-03-A18', 74, NULL, NULL, 145894),
(145895, '1.10.510.10-FF-000747', NULL, 'Serine/threonine-protein kinase GRIK2', 303, NULL, NULL, 145895),
(145896, '3.30.530.20-FF-000054', NULL, 'StAR-related lipid transfer protein 4', 201, NULL, NULL, 145896),
(145897, '2.60.40.10-FF-001301', NULL, 'Coagulation factor XIII A chain', 101, NULL, NULL, 145897),
(145898, '3.30.780.10-FF-000035', NULL, 'Eukaryotic Initiation Factor', 86, NULL, NULL, 145898),
(145899, '3.30.1370.10-FF-000015', NULL, 'Far upstream element-binding protein 1 isoform X1', 72, NULL, NULL, 145899),
(145900, '1.20.1250.20-FF-000968', NULL, 'GM19873', 228, NULL, NULL, 145900);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(145901, '3.40.50.300-FF-000498', NULL, 'Eukaryotic initiation factor 4A-III', 222, NULL, NULL, 145901),
(145902, '3.30.160.60-FF-004674', NULL, NULL, 39, NULL, NULL, 145902),
(145903, '3.10.129.10-FF-000151', NULL, 'Acyl-[acyl-carrier-protein] hydrolase', 84, NULL, NULL, 145903),
(145904, '1.10.10.60-FF-000829', NULL, NULL, 64, NULL, NULL, 145904),
(145905, '1.10.10.60-FF-000487', NULL, 'TetR family transcriptional regulator', 59, NULL, NULL, 145905),
(145906, '2.60.120.10-FF-000758', NULL, 'Uncharacterized protein', 81, NULL, NULL, 145906),
(145907, '3.40.50.300-FF-007243', NULL, 'Predicted protein', 283, NULL, NULL, 145907),
(145908, '3.30.70.870-FF-000006', NULL, 'Elongation factor G', 77, NULL, NULL, 145908),
(145909, '1.20.1440.180-FF-000013', NULL, 'Probable serine/threonine-protein kinase irlE', 143, NULL, NULL, 145909),
(145910, '3.30.70.860-FF-000003', NULL, 'UPF0234 protein YBT020_06460', 65, NULL, NULL, 145910),
(145911, '1.20.5.190-FF-000145', NULL, NULL, 52, NULL, NULL, 145911),
(145912, '1.10.400.10-FF-000014', NULL, 'G-protein alpha subunit 1', 115, NULL, NULL, 145912),
(145913, '2.60.40.150-FF-000097', NULL, 'copine-1 isoform X2', 130, NULL, NULL, 145913),
(145914, '1.10.520.10-FF-000068', NULL, 'Catalase/peroxidase', 36, NULL, NULL, 145914),
(145915, '2.130.10.10-FF-004152', NULL, 'AER035Wp', 176, NULL, NULL, 145915),
(145916, '2.60.40.150-FF-000153', NULL, 'Synaptotagmin 16', 135, NULL, NULL, 145916),
(145917, '1.20.5.1700-FF-000001', NULL, 'Transforming acidic coiled-coil-containing protein 1 isoform 2', 48, NULL, NULL, 145917),
(145918, '1.20.1540.10-FF-000105', NULL, 'Uncharacterized protein', 183, NULL, NULL, 145918),
(145919, '1.10.3080.10-FF-000089', NULL, 'Predicted protein', 121, NULL, NULL, 145919),
(145920, '3.30.2350.10-FF-000019', NULL, 'Mitochondrial mRNA pseudouridine synthase RPUSD3', 221, NULL, NULL, 145920),
(145921, '1.20.1250.20-FF-000007', NULL, 'Glycerol-3-phosphate transporter', 209, NULL, NULL, 145921),
(145922, '1.25.40.10-FF-000671', NULL, 'rRNA biogenesis protein RRP5', 199, NULL, NULL, 145922),
(145923, '3.30.160.60-FF-002818', NULL, 'Potential zinc finger protein', 55, NULL, NULL, 145923),
(145924, '3.10.100.10-FF-000118', NULL, 'C-type lectin domain family 4 member E', 140, NULL, NULL, 145924),
(145925, '2.60.450.20-FF-000011', NULL, 'Uncharacterized protein', 163, NULL, NULL, 145925),
(145926, '2.30.42.10-FF-000211', NULL, 'Na(+)/H(+) exchange regulatory cofactor NHE-RF3', 88, NULL, NULL, 145926),
(145927, '2.130.10.10-FF-002353', NULL, 'PSF2m', 180, NULL, NULL, 145927),
(145928, '3.30.420.150-FF-000011', NULL, 'Exopolyphosphatase 2', 183, NULL, NULL, 145928),
(145929, '1.20.1250.10-FF-000004', NULL, 'Kit ligand', 144, NULL, NULL, 145929),
(145930, '3.40.140.10-FF-000187', NULL, 'Cytosine deaminase, putative', 152, NULL, NULL, 145930),
(145931, '1.25.40.10-FF-002088', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 164, NULL, NULL, 145931),
(145932, '2.60.210.10-FF-000024', NULL, 'BTB and MATH domain-containing protein 42', 133, NULL, NULL, 145932),
(145933, '3.30.160.60-FF-002875', NULL, 'Zinc finger protein, putative', 28, NULL, NULL, 145933),
(145934, '1.25.40.10-FF-004229', NULL, 'Uncharacterized protein', 257, NULL, NULL, 145934),
(145935, '2.30.130.40-FF-000044', NULL, 'Uncharacterized protein', 121, NULL, NULL, 145935),
(145936, '3.30.70.330-FF-000816', NULL, 'Heterogeneous nuclear ribonucleoprotein Q', 151, NULL, NULL, 145936),
(145937, '2.40.70.10-FF-000236', NULL, 'FI01813p', 149, NULL, NULL, 145937),
(145938, '3.90.70.10-FF-000827', NULL, 'Uncharacterized protein', 167, NULL, NULL, 145938),
(145939, '1.20.20.10-FF-000023', NULL, 'Uncharacterized protein', 72, NULL, NULL, 145939),
(145940, '1.25.40.10-FF-003667', NULL, 'Uncharacterized protein', 123, NULL, NULL, 145940),
(145941, '2.130.10.10-FF-002639', NULL, 'Uncharacterized protein', 275, NULL, NULL, 145941),
(145942, '2.60.120.200-FF-000452', NULL, 'BEACH domain-containing protein lvsE', 188, NULL, NULL, 145942),
(145943, '1.10.3660.10-FF-000004', NULL, 'Prephenate dehydrogenase [NADP(+)]', 119, NULL, NULL, 145943);
INSERT INTO "PUBLIC"."MODEL" VALUES
(145944, '3.80.10.10-FF-001920', NULL, 'Disease resistance protein (TIR-NBS-LRR class)', 213, NULL, NULL, 145944),
(145945, '4.10.320.10-FF-000007', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 61, NULL, NULL, 145945),
(145946, '3.30.70.330-FF-001997', NULL, NULL, 88, NULL, NULL, 145946),
(145947, '1.20.1330.10-FF-000005', NULL, 'Flagellin', 158, NULL, NULL, 145947),
(145948, '1.10.1410.10-FF-000008', NULL, 'speckle targeted PIP5K1A-regulated poly(A) polymerase', 196, NULL, NULL, 145948),
(145949, '1.10.730.10-FF-000168', NULL, 'Leucine--tRNA ligase', 24, NULL, NULL, 145949),
(145950, '2.10.25.10-FF-000240', NULL, 'Vitamin K-dependent protein S', 41, NULL, NULL, 145950),
(145951, '3.40.50.300-FF-002297', NULL, 'ATP-dependent helicase ULS1', 197, NULL, NULL, 145951),
(145952, '2.60.40.150-FF-000771', NULL, 'Uncharacterized protein', 109, NULL, NULL, 145952),
(145953, '1.10.510.40-FF-000003', NULL, 'Siderophore biosynthesis protein, IucA/IucC family', 196, NULL, NULL, 145953),
(145954, '3.20.20.70-FF-000789', NULL, NULL, 61, NULL, NULL, 145954),
(145955, '3.30.40.10-FF-000603', NULL, 'RBR-type E3 ubiquitin transferase', 91, NULL, NULL, 145955),
(145956, '3.90.550.50-FF-000202', NULL, 'Hexosyltransferase', 179, NULL, NULL, 145956),
(145957, '3.30.420.40-FF-000164', NULL, 'Actin cytoplasmic 1', 48, NULL, NULL, 145957),
(145958, '2.130.10.110-FF-000005', NULL, 'Clathrin heavy chain 1', 112, NULL, NULL, 145958),
(145959, '3.40.50.300-FF-004950', NULL, 'Bifunctional heparan sulfate N-deacetylase/N-sulfotransferase 1', 303, NULL, NULL, 145959),
(145960, '4.10.60.10-FF-000081', NULL, 'Protein lin-28', 60, NULL, NULL, 145960),
(145961, '2.10.110.10-FF-000218', NULL, 'Four and a half LIM domains protein 5', 65, NULL, NULL, 145961),
(145962, '2.120.10.30-FF-000408', NULL, 'Uncharacterized protein', 194, NULL, NULL, 145962),
(145963, '3.30.230.10-FF-000174', NULL, 'DNA repair protein RadA', 155, NULL, NULL, 145963),
(145964, '3.40.50.1980-FF-000129', NULL, 'Histidinol dehydrogenase', 120, NULL, NULL, 145964),
(145965, '3.40.50.1820-FF-000060', NULL, 'Carboxypeptidase', 419, NULL, NULL, 145965),
(145966, '1.25.40.20-FF-000674', NULL, 'Uncharacterized protein', 349, NULL, NULL, 145966),
(145967, '1.10.10.10-FF-001967', NULL, 'Transcription regulator, ArsR family', 70, NULL, NULL, 145967),
(145968, '3.30.200.20-FF-001698', NULL, 'Uncharacterized protein', 61, NULL, NULL, 145968),
(145969, '2.130.10.10-FF-002297', NULL, 'Uncharacterized protein', 156, NULL, NULL, 145969),
(145970, '1.25.10.10-FF-002934', NULL, 'Uncharacterized protein', 91, NULL, NULL, 145970),
(145971, '3.40.50.1000-FF-000325', NULL, 'p-nitrophenylphosphatase, putative', 152, NULL, NULL, 145971),
(145972, '3.30.470.20-FF-000161', NULL, 'Eukaryotic glutathione synthase', 101, NULL, NULL, 145972),
(145973, '2.40.50.140-FF-000465', NULL, 'Exosome complex exonuclease RRP4, putative', 90, NULL, NULL, 145973),
(145974, '3.30.160.60-FF-003038', NULL, 'Zinc finger protein 711-like Protein', 59, NULL, NULL, 145974),
(145975, '2.120.10.30-FF-000465', NULL, 'Uncharacterized protein', 73, NULL, NULL, 145975),
(145976, '3.30.70.330-FF-001379', NULL, 'RNA recognition motif-containing protein', 121, NULL, NULL, 145976),
(145977, '1.20.1250.20-FF-000120', NULL, 'Solute carrier family 45, member 1', 229, NULL, NULL, 145977),
(145978, '1.25.40.10-FF-004381', NULL, 'Predicted protein', 144, NULL, NULL, 145978),
(145979, '1.20.1070.10-FF-001710', NULL, 'CCAP', 104, NULL, NULL, 145979),
(145980, '1.20.120.430-FF-000019', NULL, 'tRNA modification GTPase TrmE', 198, NULL, NULL, 145980),
(145981, '2.60.40.60-FF-000451', NULL, 'Predicted protein', 100, NULL, NULL, 145981),
(145982, '1.10.287.70-FF-000430', NULL, 'Two-pore potassium channel 4', 106, NULL, NULL, 145982),
(145983, '3.30.750.24-FF-000131', NULL, 'Anti-sigma factor antagonist', 111, NULL, NULL, 145983),
(145984, '3.90.226.10-FF-000235', NULL, '3-hydroxyisobutyryl-CoA hydrolase', 350, NULL, NULL, 145984),
(145985, '1.25.10.10-FF-000405', NULL, 'Pumilio homolog 24', 225, NULL, NULL, 145985);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(145986, '2.160.20.10-FF-000126', NULL, 'Uncharacterized protein', 156, NULL, NULL, 145986),
(145987, '3.90.1300.10-FF-000036', NULL, 'Uncharacterized protein', 267, NULL, NULL, 145987),
(145988, '1.10.510.10-FF-004171', NULL, NULL, 186, NULL, NULL, 145988),
(145989, '3.40.462.20-FF-000011', NULL, 'Uncharacterized protein', 83, NULL, NULL, 145989),
(145990, '3.30.870.10-FF-000155', NULL, 'Uncharacterized protein', 129, NULL, NULL, 145990),
(145991, '1.25.40.10-FF-004561', NULL, 'Uncharacterized protein', 305, NULL, NULL, 145991),
(145992, '3.40.50.300-FF-006187', NULL, 'Protein CBG01006', 101, NULL, NULL, 145992),
(145993, '3.20.20.140-FF-000488', NULL, 'Gll3395 protein', 183, NULL, NULL, 145993),
(145994, '3.40.50.300-FF-002971', NULL, 'Os03g0282700 protein', 89, NULL, NULL, 145994),
(145995, '3.30.710.10-FF-000323', NULL, 'YALI0D10087p', 116, NULL, NULL, 145995),
(145996, '3.30.70.330-FF-002054', NULL, NULL, 93, NULL, NULL, 145996),
(145997, '3.30.420.10-FF-000222', NULL, 'Polynucleotidyl transferase, ribonuclease H-like superfamily protein', 249, NULL, NULL, 145997),
(145998, '1.50.40.10-FF-000495', NULL, 'Mitochondrial carrier', 273, NULL, NULL, 145998),
(145999, '3.40.50.1440-FF-000159', NULL, 'Uncharacterized protein', 194, NULL, NULL, 145999),
(146000, '2.130.10.10-FF-002914', NULL, 'Uncharacterized protein', 213, NULL, NULL, 146000),
(146001, '1.20.1730.10-FF-000030', NULL, 'Hybrid sensor histidine kinase/response regulator', 456, NULL, NULL, 146001),
(146002, '1.20.1420.30-FF-000046', NULL, 'Vacuolar calcium ion transporter', 256, NULL, NULL, 146002),
(146003, '3.40.50.620-FF-000532', NULL, 'GTP binding', 80, NULL, NULL, 146003),
(146004, '3.30.160.60-FF-003370', NULL, 'Zinc finger protein 169', 27, NULL, NULL, 146004),
(146005, '1.10.510.10-FF-003895', NULL, NULL, 86, NULL, NULL, 146005),
(146006, '1.10.3720.10-FF-000116', NULL, 'Oligopeptide transport system permease protein OppC', 217, NULL, NULL, 146006),
(146007, '2.60.200.20-FF-000239', NULL, 'Uncharacterized protein', 123, NULL, NULL, 146007),
(146008, '2.30.30.40-FF-000541', NULL, 'Uncharacterized protein', 84, NULL, NULL, 146008),
(146009, '3.30.160.60-FF-006186', NULL, NULL, 58, NULL, NULL, 146009),
(146010, '3.40.1280.10-FF-000062', NULL, '23S rRNA methyltransferase', 163, NULL, NULL, 146010),
(146011, '1.10.3430.10-FF-000015', NULL, 'Ammonium transporter', 417, NULL, NULL, 146011),
(146012, '3.30.70.330-FF-000075', NULL, 'Heterogeneous nuclear ribonucleoprotein H1 (H)', 97, NULL, NULL, 146012),
(146013, '3.30.420.40-FF-000782', NULL, 'Arp9p', 163, NULL, NULL, 146013),
(146014, '1.10.10.570-FF-000006', NULL, 'Uncharacterized protein', 96, NULL, NULL, 146014),
(146015, '3.40.50.1000-FF-000763', NULL, NULL, 131, NULL, NULL, 146015),
(146016, '3.10.100.10-FF-000337', NULL, NULL, 71, NULL, NULL, 146016),
(146017, '3.20.140.10-FF-000012', NULL, 'Nicotinate phosphoribosyltransferase', 201, NULL, NULL, 146017),
(146018, '3.40.50.12780-FF-000171', NULL, 'Putative long-chain fatty-acid-CoA ligase', 403, NULL, NULL, 146018),
(146019, '2.60.40.10-FF-002605', NULL, 'Terribly reduced optic lobes, isoform B', 91, NULL, NULL, 146019),
(146020, '1.10.357.10-FF-000008', NULL, 'Transcriptional regulator, TetR family', 161, NULL, NULL, 146020),
(146021, '1.20.1070.10-FF-000018', NULL, 'Rhodopsin', 354, NULL, NULL, 146021),
(146022, '3.80.10.10-FF-003157', NULL, 'Uncharacterized protein', 286, NULL, NULL, 146022),
(146023, '1.10.8.80-FF-000003', NULL, 'Transcriptional regulator moxR1', 117, NULL, NULL, 146023),
(146024, '1.10.10.580-FF-000009', NULL, 'Sister chromatid cohesion protein 1', 82, NULL, NULL, 146024),
(146025, '2.60.40.1400-FF-000025', NULL, NULL, 192, NULL, NULL, 146025),
(146026, '3.40.640.10-FF-000388', NULL, 'Aspartate aminotransferase', 220, NULL, NULL, 146026),
(146027, '2.60.40.10-FF-003100', NULL, 'Immunoglobulin heavy chain precursor', 106, NULL, NULL, 146027),
(146028, '2.40.110.10-FF-000015', NULL, 'Acyl-CoA dehydrogenase', 123, NULL, NULL, 146028),
(146029, '2.10.25.10-FF-000021', NULL, 'Teneurin transmembrane protein 2', 32, NULL, NULL, 146029);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(146030, '3.40.50.720-FF-002361', NULL, 'Uncharacterized protein', 187, NULL, NULL, 146030),
(146031, '1.25.40.10-FF-000233', NULL, 'Tetratricopeptide repeat domain 26', 195, NULL, NULL, 146031),
(146032, '1.20.1200.10-FF-000001', NULL, 'Cob(I)yrinic acid a,c-diamide adenosyltransferase', 178, NULL, NULL, 146032),
(146033, '3.30.1330.10-FF-000018', NULL, 'selenide, water dikinase 2', 131, NULL, NULL, 146033),
(146034, '2.40.50.100-FF-000206', NULL, 'Uncharacterized protein', 60, NULL, NULL, 146034),
(146035, '3.40.640.10-FF-000169', NULL, 'L-lysine 6-aminotransferase', 271, NULL, NULL, 146035),
(146036, '3.10.100.10-FF-000394', NULL, NULL, 122, NULL, NULL, 146036),
(146037, '1.20.1070.10-FF-001654', NULL, 'Uncharacterized protein', 130, NULL, NULL, 146037),
(146038, '3.90.176.10-FF-000005', NULL, 'ADP-ribosyltransferase', 209, NULL, NULL, 146038),
(146039, '2.60.120.200-FF-000233', NULL, 'Hemagglutinin A', 176, NULL, NULL, 146039),
(146040, '1.20.90.10-FF-000010', NULL, 'Protein interacting with cyclin A1', 115, NULL, NULL, 146040),
(146041, '1.10.10.10-FF-000663', NULL, 'Ferric uptake regulator family protein', 80, NULL, NULL, 146041),
(146042, '3.40.50.12350-FF-000008', NULL, 'Predicted protein', 270, NULL, NULL, 146042),
(146043, '1.20.200.10-FF-000036', NULL, 'Uncharacterized protein', 95, NULL, NULL, 146043),
(146044, '3.40.50.10490-FF-000130', NULL, NULL, 125, NULL, NULL, 146044),
(146045, '2.60.40.10-FF-001245', NULL, 'vascular endothelial growth factor receptor 1', 131, NULL, NULL, 146045),
(146046, '3.30.40.10-FF-001907', NULL, 'Uncharacterized protein', 73, NULL, NULL, 146046),
(146047, '3.40.1360.10-FF-000063', NULL, 'Uncharacterized protein', 200, NULL, NULL, 146047),
(146048, '2.60.40.820-FF-000033', NULL, 'T, brachyury homolog, gene 2', 194, NULL, NULL, 146048),
(146049, '3.30.190.20-FF-000010', NULL, '50S ribosomal protein L1, mitochondrial,putative', 69, NULL, NULL, 146049),
(146050, '2.130.10.10-FF-002971', NULL, 'Protein HIR2', 221, NULL, NULL, 146050),
(146051, '1.50.40.10-FF-000276', NULL, 'Uncharacterized protein', 312, NULL, NULL, 146051),
(146052, '1.25.40.10-FF-004504', NULL, 'Pentatricopeptide repeat-containing protein At1g66345, mitochondrial', 90, NULL, NULL, 146052),
(146053, '3.40.30.10-FF-001131', NULL, 'Predicted protein', 75, NULL, NULL, 146053),
(146054, '2.60.120.10-FF-000197', NULL, 'Transcriptional regulator AraC family', 89, NULL, NULL, 146054),
(146055, '1.10.10.10-FF-001006', NULL, 'Uncharacterized protein', 82, NULL, NULL, 146055),
(146056, '3.30.70.2820-FF-000008', NULL, 'DNA polymerase', 115, NULL, NULL, 146056),
(146057, '1.10.287.160-FF-000019', NULL, 'Tyrosine-protein kinase', 84, NULL, NULL, 146057),
(146058, '3.40.1090.10-FF-000137', NULL, 'Patatin', 89, NULL, NULL, 146058),
(146059, '3.40.50.300-FF-006748', NULL, 'Predicted protein', 68, NULL, NULL, 146059),
(146060, '2.60.40.10-FF-002662', NULL, 'Titin homolog', 100, NULL, NULL, 146060),
(146061, '3.20.20.210-FF-000026', NULL, 'Uncharacterized protein', 100, NULL, NULL, 146061),
(146062, '3.40.1280.10-FF-000005', NULL, '23S rRNA (guanosine-2''-O-)-methyltransferase RlmB', 167, NULL, NULL, 146062),
(146063, '2.40.70.10-FF-000416', NULL, NULL, 51, NULL, NULL, 146063),
(146064, '1.20.1310.10-FF-000116', NULL, NULL, 137, NULL, NULL, 146064),
(146065, '1.10.510.10-FF-002259', NULL, NULL, 98, NULL, NULL, 146065),
(146066, '2.60.40.150-FF-000658', NULL, 'Copine 8', 96, NULL, NULL, 146066),
(146067, '1.10.3430.10-FF-000072', NULL, 'Uncharacterized protein', 148, NULL, NULL, 146067),
(146068, '3.40.50.300-FF-003314', NULL, 'Uncharacterized protein', 201, NULL, NULL, 146068),
(146069, '1.20.140.40-FF-000085', NULL, NULL, 169, NULL, NULL, 146069),
(146070, '1.20.810.10-FF-000009', NULL, 'Cytochrome b', 410, NULL, NULL, 146070),
(146071, '3.90.1600.10-FF-000019', NULL, 'DNA polymerase', 101, NULL, NULL, 146071),
(146072, '3.30.160.60-FF-002476', NULL, 'Ras responsive element binding protein 1a', 29, NULL, NULL, 146072),
(146073, '3.10.120.10-FF-000007', NULL, 'Sulfite oxidase, mitochondrial', 86, NULL, NULL, 146073);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(146074, '3.20.20.20-FF-000004', NULL, 'Dihydropteroate synthase', 278, NULL, NULL, 146074),
(146075, '1.20.1440.170-FF-000010', NULL, NULL, 110, NULL, NULL, 146075),
(146076, '1.10.238.10-FF-000940', NULL, 'Uncharacterized protein', 131, NULL, NULL, 146076),
(146077, '2.40.30.10-FF-000239', NULL, 'Elongation factor 1-alpha, putative (TuF-2)', 74, NULL, NULL, 146077),
(146078, '3.20.20.30-FF-000007', NULL, 'Monooxygenase, mmyo', 345, NULL, NULL, 146078),
(146079, '3.40.50.300-FF-002477', NULL, 'Putative replication factor C, subunit 4', 195, NULL, NULL, 146079),
(146080, '3.10.20.90-FF-000470', NULL, 'Protein CBG12265', 90, NULL, NULL, 146080),
(146081, '2.60.40.1510-FF-000002', NULL, 'integrin alpha-6 isoform X2', 165, NULL, NULL, 146081),
(146082, '3.30.70.2800-FF-000002', NULL, 'Diedel 3, isoform A', 92, NULL, NULL, 146082),
(146083, '1.10.287.4070-FF-000013', NULL, 'NOSIC domain protein', 135, NULL, NULL, 146083),
(146084, '2.60.120.260-FF-000155', NULL, 'Probable beta-glucosidase H', 162, NULL, NULL, 146084),
(146085, '1.10.287.130-FF-000010', NULL, 'Two-component sensor histidine kinase', 76, NULL, NULL, 146085),
(146086, '2.30.42.10-FF-000155', NULL, 'membrane-associated guanylate kinase, WW and PDZ domain-containing protein 2 isoform X4', 104, NULL, NULL, 146086),
(146087, '1.25.40.10-FF-000851', NULL, 'Pentatricopeptide repeat-containing protein103', 101, NULL, NULL, 146087),
(146088, '2.40.30.10-FF-000296', NULL, 'NADPH-cytochrome P450 reductase', 105, NULL, NULL, 146088),
(146089, '3.80.10.10-FF-003718', NULL, 'Uncharacterized protein', 148, NULL, NULL, 146089),
(146090, '1.20.58.1120-FF-000012', NULL, 'Dynein, axonemal, heavy chain 2', 145, NULL, NULL, 146090),
(146091, '1.10.510.10-FF-003153', NULL, NULL, 174, NULL, NULL, 146091),
(146092, '1.25.40.20-FF-000854', NULL, 'Kinase, NEK', 154, NULL, NULL, 146092),
(146093, '1.20.1270.60-FF-000211', NULL, 'Bridging integrator 1b', 194, NULL, NULL, 146093),
(146094, '3.40.50.300-FF-007024', NULL, 'Uncharacterized protein', 206, NULL, NULL, 146094),
(146095, '3.30.40.10-FF-000480', NULL, 'Peroxisome biogenesis factor 2', 71, NULL, NULL, 146095),
(146096, '2.130.10.10-FF-002078', NULL, 'WD domain, G-beta repeat, putative', 86, NULL, NULL, 146096),
(146097, '1.20.140.40-FF-000028', NULL, 'Os02g0688200 protein', 151, NULL, NULL, 146097),
(146098, '3.90.1600.10-FF-000076', NULL, 'Uncharacterized protein', 158, NULL, NULL, 146098),
(146099, '3.80.10.10-FF-000341', NULL, 'volume-regulated anion channel subunit LRRC8D', 87, NULL, NULL, 146099),
(146100, '1.10.1420.10-FF-000166', NULL, 'MutS protein homolog 5-like Protein', 222, NULL, NULL, 146100),
(146101, '3.30.1510.10-FF-000015', NULL, 'Uncharacterized protein', 101, NULL, NULL, 146101),
(146102, '3.90.1150.10-FF-000024', NULL, 'Aspartate aminotransferase', 111, NULL, NULL, 146102),
(146103, '3.90.550.10-FF-000168', NULL, '8-amino-3,8-dideoxy-manno-octulosonate cytidylyltransferase', 245, NULL, NULL, 146103),
(146104, '1.20.5.340-FF-000078', NULL, 'Rho kinase', 163, NULL, NULL, 146104),
(146105, '1.10.510.10-FF-002703', NULL, NULL, 99, NULL, NULL, 146105),
(146106, '4.10.400.10-FF-000284', NULL, 'Uncharacterized protein', 43, NULL, NULL, 146106),
(146107, '3.30.160.60-FF-005410', NULL, NULL, 44, NULL, NULL, 146107),
(146108, '1.20.1070.10-FF-000400', NULL, 'Melanopsin-B', 299, NULL, NULL, 146108),
(146109, '2.70.150.10-FF-000056', NULL, 'Cation-transporting ATPase', 156, NULL, NULL, 146109),
(146110, '3.10.20.90-FF-000778', NULL, 'Uncharacterized protein', 101, NULL, NULL, 146110),
(146111, '2.120.10.30-FF-000252', NULL, 'Uncharacterized protein', 340, NULL, NULL, 146111),
(146112, '2.20.70.10-FF-000041', NULL, 'WW and C2 domain containing 1', 40, NULL, NULL, 146112),
(146113, '2.40.30.130-FF-000048', NULL, 'Uncharacterized protein', 104, NULL, NULL, 146113),
(146114, '2.60.15.10-FF-000012', NULL, 'ATP synthase epsilon chain', 135, NULL, NULL, 146114),
(146115, '1.10.510.10-FF-001601', NULL, 'Cell division protein kinase 2, putative', 203, NULL, NULL, 146115),
(146116, '1.10.1370.30-FF-000050', NULL, 'Angiotensin-converting enzyme', 294, NULL, NULL, 146116);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(146117, '2.60.40.10-FF-004825', NULL, NULL, 111, NULL, NULL, 146117),
(146118, '1.10.10.60-FF-000723', NULL, 'Vent homeobox 2', 94, NULL, NULL, 146118),
(146119, '3.40.50.300-FF-000931', NULL, 'DExH-box ATP-dependent RNA helicase DExH1', 163, NULL, NULL, 146119),
(146120, '1.10.10.10-FF-000169', NULL, 'Transcriptional regulator, Fur family', 83, NULL, NULL, 146120),
(146121, '2.40.37.10-FF-000030', NULL, 'Biosynthetic arginine decarboxylase', 176, NULL, NULL, 146121),
(146122, '3.10.110.10-FF-000164', NULL, 'Ubiquitin-conjugating enzyme family protein', 291, NULL, NULL, 146122),
(146123, '3.30.40.10-FF-001374', NULL, 'RBR-type E3 ubiquitin transferase', 84, NULL, NULL, 146123),
(146124, '3.90.226.10-FF-000049', NULL, 'Enoyl-CoA delta isomerase 3', 225, NULL, NULL, 146124),
(146125, '3.40.50.620-FF-000324', NULL, 'Valine--tRNA ligase', 232, NULL, NULL, 146125),
(146126, '3.40.50.970-FF-000171', NULL, '2-oxoisovalerate dehydrogenase subunit alpha', 204, NULL, NULL, 146126),
(146127, '3.40.850.10-FF-000016', NULL, 'Kinesin-like protein', 361, NULL, NULL, 146127),
(146128, '1.25.40.10-FF-002447', NULL, 'Pentatricopeptide repeat-containing protein DOT4, chloroplastic', 92, NULL, NULL, 146128),
(146129, '2.120.10.80-FF-000160', NULL, 'Kelch domain-containing protein', 176, NULL, NULL, 146129),
(146130, '2.60.40.150-FF-000563', NULL, 'Esyt-2', 138, NULL, NULL, 146130),
(146131, '3.30.720.210-FF-000024', NULL, 'ATP-dependent zinc metalloprotease FtsH', 93, NULL, NULL, 146131),
(146132, '2.20.80.10-FF-000013', NULL, 'Uncharacterized protein', 218, NULL, NULL, 146132),
(146133, '1.10.600.10-FF-000102', NULL, 'copal-8-ol diphosphate hydratase, chloroplastic', 266, NULL, NULL, 146133),
(146134, '3.40.50.970-FF-000215', NULL, 'Uncharacterized protein', 106, NULL, NULL, 146134),
(146135, '1.20.120.980-FF-000049', NULL, 'Uncharacterized protein', 148, NULL, NULL, 146135),
(146136, '3.40.50.300-FF-008362', NULL, 'Signal recognition particle alpha', 220, NULL, NULL, 146136),
(146137, '3.40.640.10-FF-000416', NULL, 'Predicted protein', 76, NULL, NULL, 146137),
(146138, '3.40.50.1970-FF-000008', NULL, 'Alcohol dehydrogenase YqhD', 175, NULL, NULL, 146138),
(146139, '1.10.10.570-FF-000001', NULL, 'vacuolar protein-sorting-associated protein 25', 98, NULL, NULL, 146139),
(146140, '3.80.10.10-FF-002145', NULL, 'Uncharacterized protein', 94, NULL, NULL, 146140),
(146141, '2.30.30.40-FF-000159', NULL, 'MAGUK p55 subfamily member 7', 136, NULL, NULL, 146141),
(146142, '3.30.590.50-FF-000004', NULL, 'Glutamate-cysteine ligase Gcs1', 292, NULL, NULL, 146142),
(146143, '1.10.510.10-FF-000449', NULL, 'Calcium/calmodulin-dependent protein kinase', 212, NULL, NULL, 146143),
(146144, '1.20.1310.10-FF-000066', NULL, 'Cullin-like protein-like protein', 101, NULL, NULL, 146144),
(146145, '3.40.50.80-FF-000017', NULL, 'Dihydroorotate dehydrogenase B (NAD(+)), electron transfer subunit', 113, NULL, NULL, 146145),
(146146, '1.10.1070.11-FF-000123', NULL, 'Uncharacterized protein', 144, NULL, NULL, 146146),
(146147, '3.90.1140.10-FF-000052', NULL, 'U6 snRNA phosphodiesterase', 205, NULL, NULL, 146147),
(146148, '1.10.3080.10-FF-000084', NULL, 'Chloride channel protein', 283, NULL, NULL, 146148),
(146149, '1.10.10.580-FF-000004', NULL, 'Double-strand-break repair protein rad21', 87, NULL, NULL, 146149),
(146150, '2.60.40.10-FF-000447', NULL, 'fibronectin isoform X1', 94, NULL, NULL, 146150),
(146151, '1.10.287.690-FF-000026', NULL, 'DNA polymerase', 42, NULL, NULL, 146151),
(146152, '1.20.5.170-FF-000212', NULL, 'GTPase activator protein', 56, NULL, NULL, 146152),
(146153, '3.90.79.10-FF-000055', NULL, 'U8 snoRNA-decapping enzyme', 194, NULL, NULL, 146153),
(146154, '1.25.40.10-FF-004690', NULL, 'Pentatricopeptide repeat-containing protein', 102, NULL, NULL, 146154),
(146155, '2.30.30.30-FF-000156', NULL, 'Uncharacterized protein', 108, NULL, NULL, 146155),
(146156, '1.20.144.10-FF-000028', NULL, 'Glucose-6-phosphatase', 205, NULL, NULL, 146156),
(146157, '3.30.457.60-FF-000018', NULL, 'Mitotic spindle assembly checkpoint protein MAD1', 78, NULL, NULL, 146157);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(146158, '3.80.10.10-FF-001802', NULL, 'Mimecan', 108, NULL, NULL, 146158),
(146159, '3.60.40.10-FF-000012', NULL, 'Regulator of RpoS', 182, NULL, NULL, 146159),
(146160, '3.30.70.330-FF-002071', NULL, NULL, 84, NULL, NULL, 146160),
(146161, '3.30.200.20-FF-000259', NULL, 'Mitogen-activated protein kinase kinase kinase kinase 4', 101, NULL, NULL, 146161),
(146162, '1.25.10.10-FF-002945', NULL, 'Uncharacterized protein', 60, NULL, NULL, 146162),
(146163, '3.10.180.10-FF-000112', NULL, 'Uncharacterized protein', 41, NULL, NULL, 146163),
(146164, '3.90.70.10-FF-000518', NULL, 'Ubiquitin carboxyl-terminal hydrolase 4', 205, NULL, NULL, 146164),
(146165, '3.40.50.10470-FF-000057', NULL, 'Eukaryotic Initiation Factor', 168, NULL, NULL, 146165),
(146166, '2.40.50.140-FF-000358', NULL, 'RNA-binding protein, putative', 86, NULL, NULL, 146166),
(146167, '3.40.50.300-FF-006754', NULL, 'Predicted protein', 66, NULL, NULL, 146167),
(146168, '1.10.8.270-FF-000059', NULL, 'Unplaced genomic scaffold supercont2.12, whole genome shotgun sequence', 103, NULL, NULL, 146168),
(146169, '3.30.710.10-FF-000340', NULL, 'Zinc finger protein ZNF-U69274', 79, NULL, NULL, 146169),
(146170, '3.30.1010.10-FF-000022', NULL, 'Serine/threonine-protein kinase TOR', 140, NULL, NULL, 146170),
(146171, '3.30.900.10-FF-000040', NULL, 'Mitotic spindle assembly checkpoint protein MAD2B', 205, NULL, NULL, 146171),
(146172, '1.20.1640.10-FF-000085', NULL, 'Transmembrane transport protein mmpL13a', 150, NULL, NULL, 146172),
(146173, '2.40.10.10-FF-000429', NULL, 'Male accessory gland protein', 230, NULL, NULL, 146173),
(146174, '1.10.420.10-FF-000004', NULL, 'Catalase-peroxidase', 124, NULL, NULL, 146174),
(146175, '2.60.120.260-FF-000245', NULL, 'Glycoside hydrolase family 2 protein', 207, NULL, NULL, 146175),
(146176, '1.20.1250.20-FF-000131', NULL, 'Probable anion transporter 3, chloroplastic', 194, NULL, NULL, 146176),
(146177, '3.10.20.90-FF-000099', NULL, 'Polycomb group RING finger protein 1', 111, NULL, NULL, 146177),
(146178, '3.40.50.1100-FF-000299', NULL, 'Uncharacterized protein', 90, NULL, NULL, 146178),
(146179, '3.80.10.10-FF-003247', NULL, 'Uncharacterized protein', 176, NULL, NULL, 146179),
(146180, '2.60.40.60-FF-001018', NULL, 'Uncharacterized protein', 145, NULL, NULL, 146180),
(146181, '2.130.10.10-FF-002549', NULL, 'Bromodomain and WD repeat domain-containing 3', 258, NULL, NULL, 146181),
(146182, '2.130.10.10-FF-005894', NULL, 'Probable inactive protein kinase DDB_G0270444', 293, NULL, NULL, 146182),
(146183, '1.25.10.10-FF-001001', NULL, 'RING-type E3 ubiquitin transferase', 97, NULL, NULL, 146183),
(146184, '3.30.60.30-FF-000178', NULL, 'Agrin', 58, NULL, NULL, 146184),
(146185, '2.130.10.10-FF-004466', NULL, 'Uncharacterized protein', 138, NULL, NULL, 146185),
(146186, '3.30.200.20-FF-001687', NULL, 'Uncharacterized protein', 115, NULL, NULL, 146186),
(146187, '1.20.1440.170-FF-000015', NULL, NULL, 74, NULL, NULL, 146187),
(146188, '3.40.50.300-FF-001111', NULL, 'neuron navigator 2 isoform X3', 177, NULL, NULL, 146188),
(146189, '3.40.50.1000-FF-000741', NULL, NULL, 78, NULL, NULL, 146189),
(146190, '3.30.830.10-FF-000287', NULL, 'Uncharacterized protein', 162, NULL, NULL, 146190),
(146191, '3.90.1150.10-FF-000350', NULL, 'dTDP-3-amino-3,4,6-trideoxy-alpha-D-glucose transaminase', 127, NULL, NULL, 146191),
(146192, '3.40.309.10-FF-000006', NULL, 'Gamma-glutamyl phosphate reductase', 153, NULL, NULL, 146192),
(146193, '1.25.40.10-FF-004701', NULL, 'Uncharacterized protein', 99, NULL, NULL, 146193),
(146194, '1.25.10.10-FF-000821', NULL, 'Heatr1 protein', 163, NULL, NULL, 146194),
(146195, '2.40.290.30-FF-000011', NULL, 'Uncharacterized protein', 86, NULL, NULL, 146195),
(146196, '3.30.40.10-FF-000272', NULL, 'transcription intermediary factor 1-beta', 68, NULL, NULL, 146196),
(146197, '3.80.10.10-FF-003926', NULL, 'Uncharacterized protein', 96, NULL, NULL, 146197),
(146198, '2.130.10.10-FF-000088', NULL, 'Hepatocyte growth factor receptor', 491, NULL, NULL, 146198),
(146199, '1.10.150.190-FF-000006', NULL, 'Translation initiation factor 2 subunit alpha', 89, NULL, NULL, 146199);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(146200, '1.10.10.60-FF-000077', NULL, 'MYB transcription factor', 57, NULL, NULL, 146200),
(146201, '1.10.220.150-FF-000062', NULL, 'Uncharacterized protein', 73, NULL, NULL, 146201),
(146202, '2.60.40.2070-FF-000001', NULL, 'Fimbrial outer membrane usher protein', 85, NULL, NULL, 146202),
(146203, '1.20.1440.180-FF-000018', NULL, 'Serine/threonine-protein kinase/endoribonuclease IRE1a', 58, NULL, NULL, 146203),
(146204, '3.30.160.60-FF-001032', NULL, 'zinc finger and BTB domain-containing protein 17 isoform X1', 30, NULL, NULL, 146204),
(146205, '1.10.1420.10-FF-000054', NULL, 'DNA mismatch repair protein Msh2, putative', 160, NULL, NULL, 146205),
(146206, '1.10.287.3510-FF-000014', NULL, 'NADH-ubiquinone oxidoreductase chain 4L', 98, NULL, NULL, 146206),
(146207, '2.60.40.60-FF-000664', NULL, 'protocadherin-11 X-linked', 101, NULL, NULL, 146207),
(146208, '3.10.290.10-FF-000087', NULL, 'Tyrosine--tRNA ligase', 73, NULL, NULL, 146208),
(146209, '2.30.29.30-FF-001193', NULL, 'Uncharacterized protein', 82, NULL, NULL, 146209),
(146210, '3.90.70.10-FF-000209', NULL, 'Protein CBR-TRA-3', 159, NULL, NULL, 146210),
(146211, '3.90.550.10-FF-000538', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 393, NULL, NULL, 146211),
(146212, '2.70.170.10-FF-000309', NULL, 'Uncharacterized protein', 78, NULL, NULL, 146212),
(146213, '3.30.160.60-FF-004584', NULL, NULL, 31, NULL, NULL, 146213),
(146214, '2.60.260.20-FF-000092', NULL, 'DNaJ domain (Prokaryotic heat shock protein)', 68, NULL, NULL, 146214),
(146215, '3.30.70.960-FF-000005', NULL, 'transmembrane protease serine 7', 107, NULL, NULL, 146215),
(146216, '3.30.565.10-FF-000266', NULL, 'Nitrogen regulation protein/Sensor Histidine Kinase NtrY', 156, NULL, NULL, 146216),
(146217, '1.25.40.10-FF-003875', NULL, 'Pentatricopeptide repeat-containing protein', 91, NULL, NULL, 146217),
(146218, '3.30.710.10-FF-000031', NULL, 'BTB/POZ domain-containing protein KCTD16', 113, NULL, NULL, 146218),
(146219, '2.60.40.790-FF-000108', NULL, 'Heat shock protein 22A', 149, NULL, NULL, 146219),
(146220, '3.40.640.10-FF-000096', NULL, 'Molybdenum cofactor sulfurase', 273, NULL, NULL, 146220),
(146221, '2.10.25.10-FF-000959', NULL, 'Dumpy, isoform R', 40, NULL, NULL, 146221),
(146222, '3.30.505.10-FF-000083', NULL, 'Ras GTPase-activating protein 1', 121, NULL, NULL, 146222),
(146223, '2.10.25.10-FF-001465', NULL, 'Mannan-binding lectin serine peptidase 2', 40, NULL, NULL, 146223),
(146224, '3.90.1420.10-FF-000034', NULL, 'Predicted protein', 197, NULL, NULL, 146224),
(146225, '1.10.3720.10-FF-000066', NULL, 'Glycine betaine/carnitine/choline/L-proline ABC transporter permease ProZ', 189, NULL, NULL, 146225),
(146226, '2.40.340.10-FF-000015', NULL, NULL, 70, NULL, NULL, 146226),
(146227, '2.60.40.420-FF-000211', NULL, 'L-ascorbate oxidase-like Protein', 192, NULL, NULL, 146227),
(146228, '3.40.50.300-FF-006119', NULL, 'Uncharacterized protein', 85, NULL, NULL, 146228),
(146229, '3.30.2010.10-FF-000022', NULL, 'Peptidase, M48 family', 83, NULL, NULL, 146229),
(146230, '3.30.70.660-FF-000022', NULL, 'tRNA pseudouridine synthase', 189, NULL, NULL, 146230),
(146231, '2.60.200.20-FF-000127', NULL, 'Uncharacterized protein C3H7.13', 124, NULL, NULL, 146231),
(146232, '1.10.1670.10-FF-000072', NULL, NULL, 58, NULL, NULL, 146232),
(146233, '3.40.850.10-FF-000342', NULL, 'Putative kinesin', 234, NULL, NULL, 146233),
(146234, '1.20.1510.10-FF-000047', NULL, 'Cation efflux family protein-like', 126, NULL, NULL, 146234),
(146235, '3.40.228.10-FF-000014', NULL, 'NADH-quinone oxidoreductase', 60, NULL, NULL, 146235),
(146236, '1.20.1070.10-FF-002154', NULL, 'Uncharacterized protein', 155, NULL, NULL, 146236),
(146237, '2.160.20.10-FF-000082', NULL, 'Pectinesterase', 298, NULL, NULL, 146237),
(146238, '3.40.50.300-FF-000594', NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase', 220, NULL, NULL, 146238),
(146239, '3.30.70.330-FF-001598', NULL, NULL, 140, NULL, NULL, 146239),
(146240, '2.120.10.30-FF-000622', NULL, 'NHL repeat-containing protein 2', 56, NULL, NULL, 146240);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(146241, '2.60.40.10-FF-003999', NULL, NULL, 100, NULL, NULL, 146241),
(146242, '3.30.70.3490-FF-000057', NULL, NULL, 64, NULL, NULL, 146242),
(146243, '3.30.420.80-FF-000018', NULL, '40S ribosomal protein S14', 151, NULL, NULL, 146243),
(146244, '3.30.40.10-FF-002200', NULL, 'Meiosis-specific protein hop1', 74, NULL, NULL, 146244),
(146245, '2.60.40.10-FF-002364', NULL, 'Protein CBG19196', 98, NULL, NULL, 146245),
(146246, '1.10.510.10-FF-000775', NULL, 'CMGC/CDK protein kinase', 215, NULL, NULL, 146246),
(146247, '3.40.50.150-FF-000425', NULL, 'Ribosomal RNA small subunit methyltransferase H', 175, NULL, NULL, 146247),
(146248, '3.40.50.300-FF-005017', NULL, 'tRNA delta(2)-isopentenylpyrophosphate transferase, putative', 149, NULL, NULL, 146248),
(146249, '3.60.15.10-FF-000162', NULL, 'DNA repair protein, putative (AFU_orthologue AFUA_1G04570)', 60, NULL, NULL, 146249),
(146250, '3.40.50.300-FF-002376', NULL, '6-phosphofructo-2-kinase/fructose-2', 219, NULL, NULL, 146250),
(146251, '1.25.40.20-FF-001141', NULL, 'Uncharacterized protein', 154, NULL, NULL, 146251),
(146252, '4.10.60.10-FF-000176', NULL, 'Uncharacterized protein', 30, NULL, NULL, 146252),
(146253, '3.30.420.60-FF-000012', NULL, 'Protein pelota homolog', 122, NULL, NULL, 146253),
(146254, '1.10.472.10-FF-000186', NULL, 'Cyclin D', 119, NULL, NULL, 146254),
(146255, '3.80.10.10-FF-004062', NULL, 'Leucine-rich repeats and IQ motif containing 1', 133, NULL, NULL, 146255),
(146256, '2.60.34.10-FF-000034', NULL, 'Heat shock 70 kDa protein 16 isoform A', 158, NULL, NULL, 146256),
(146257, '2.30.29.30-FF-000091', NULL, 'kalirin isoform X1', 137, NULL, NULL, 146257),
(146258, '1.10.510.10-FF-002366', NULL, NULL, 179, NULL, NULL, 146258),
(146259, '3.40.640.10-FF-000107', NULL, 'Kynureninase', 258, NULL, NULL, 146259),
(146260, '3.80.10.10-FF-001791', NULL, 'F-box/LRR-repeat protein 20 isoform X1', 259, NULL, NULL, 146260),
(146261, '1.25.40.10-FF-004364', NULL, 'Predicted protein', 153, NULL, NULL, 146261),
(146262, '1.10.238.10-FF-000642', NULL, 'Uncharacterized protein', 148, NULL, NULL, 146262),
(146263, '1.10.357.50-FF-000014', NULL, 'Protein unc-13 homolog', 185, NULL, NULL, 146263),
(146264, '3.30.70.60-FF-000002', NULL, '30S ribosomal protein S6', 96, NULL, NULL, 146264),
(146265, '2.130.10.10-FF-002342', NULL, 'Os01g0551900 protein', 232, NULL, NULL, 146265),
(146266, '1.10.30.10-FF-000069', NULL, 'CBL-interacting protein kinase 33', 85, NULL, NULL, 146266),
(146267, '3.40.390.10-FF-000306', NULL, 'NEPrilysin metallopeptidase family', 334, NULL, NULL, 146267),
(146268, '1.10.418.10-FF-000061', NULL, 'Spermatogenesis associated 4', 111, NULL, NULL, 146268),
(146269, '3.80.10.10-FF-003573', NULL, 'RE59904p', 143, NULL, NULL, 146269),
(146270, '3.30.420.40-FF-000602', NULL, 'Actin-related protein 6', 29, NULL, NULL, 146270),
(146271, '3.10.129.10-FF-000156', NULL, 'YALI0E28853p', 133, NULL, NULL, 146271),
(146272, '3.40.50.150-FF-000734', NULL, 'NOP2 nucleolar protein homolog (yeast)', 316, NULL, NULL, 146272),
(146273, '2.30.30.40-FF-000529', NULL, 'Epidermal growth factor receptor kinase substrate 8', 64, NULL, NULL, 146273),
(146274, '1.10.510.10-FF-004148', NULL, NULL, 42, NULL, NULL, 146274),
(146275, '3.30.160.60-FF-006175', NULL, NULL, 64, NULL, NULL, 146275),
(146276, '1.25.10.10-FF-002619', NULL, 'Uncharacterized protein', 133, NULL, NULL, 146276),
(146277, '3.30.870.10-FF-000054', NULL, 'Phospholipase', 163, NULL, NULL, 146277),
(146278, '3.40.50.2000-FF-000147', NULL, 'UDP-N-acetylglucosamine transferase subunit ALG13-like protein', 151, NULL, NULL, 146278),
(146279, '3.30.70.330-FF-001609', NULL, NULL, 103, NULL, NULL, 146279),
(146280, '1.20.120.20-FF-000004', NULL, 'Apolipoprotein A-IV', 165, NULL, NULL, 146280),
(146281, '2.60.40.1210-FF-000007', NULL, 'Uncharacterized protein', 110, NULL, NULL, 146281),
(146282, '3.30.160.60-FF-002813', NULL, 'Transcription factor IIIA', 65, NULL, NULL, 146282),
(146283, '3.30.200.20-FF-002530', NULL, NULL, 50, NULL, NULL, 146283),
(146284, '1.20.1080.10-FF-000002', NULL, 'Probable aquaporin TIP1-1', 248, NULL, NULL, 146284);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(146285, '2.60.40.10-FF-006080', NULL, NULL, 118, NULL, NULL, 146285),
(146286, '3.90.470.10-FF-000021', NULL, 'Related to 50S ribosomal protein L22', 152, NULL, NULL, 146286),
(146287, '1.20.58.120-FF-000012', NULL, 'SNL1p Ribosome-associated protein', 119, NULL, NULL, 146287),
(146288, '2.30.29.30-FF-000102', NULL, 'FYVE, RhoGEF and PH domain-containing protein 4', 96, NULL, NULL, 146288),
(146289, '3.40.5.70-FF-000001', NULL, 'DNA-packaging protein FI', 61, NULL, NULL, 146289),
(146290, '2.130.10.10-FF-004803', NULL, 'Uncharacterized protein', 145, NULL, NULL, 146290),
(146291, '3.40.50.300-FF-006428', NULL, 'Uncharacterized protein', 128, NULL, NULL, 146291),
(146292, '3.30.40.10-FF-001727', NULL, 'Regulator Ustilago maydis 1 protein (Rum1)', 115, NULL, NULL, 146292),
(146293, '1.10.506.10-FF-000018', NULL, 'Plexin B2', 427, NULL, NULL, 146293),
(146294, '3.30.1360.120-FF-000082', NULL, 'Aminomethyltransferase', 149, NULL, NULL, 146294),
(146295, '1.20.272.10-FF-000067', NULL, NULL, 122, NULL, NULL, 146295),
(146296, '2.60.210.10-FF-000052', NULL, NULL, 187, NULL, NULL, 146296),
(146297, '1.20.120.30-FF-000007', NULL, 'Methyl-accepting chemotaxis protein', 164, NULL, NULL, 146297),
(146298, '1.10.287.380-FF-000040', NULL, 'Uncharacterized protein', 72, NULL, NULL, 146298),
(146299, '2.130.10.10-FF-000751', NULL, '40S ribosomal processing protein, putative', 274, NULL, NULL, 146299),
(146300, '3.30.70.330-FF-000507', NULL, 'serine/arginine-rich splicing factor 1B', 113, NULL, NULL, 146300),
(146301, '3.40.50.720-FF-001810', NULL, 'CurJ', 502, NULL, NULL, 146301),
(146302, '3.30.420.10-FF-000121', NULL, 'DNA polymerase I', 222, NULL, NULL, 146302),
(146303, '1.20.1070.10-FF-001665', NULL, 'Uncharacterized protein', 125, NULL, NULL, 146303),
(146304, '3.30.1370.10-FF-000043', NULL, 'KH domain-containing protein', 202, NULL, NULL, 146304),
(146305, '3.40.50.720-FF-000045', NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', 150, NULL, NULL, 146305),
(146306, '2.130.10.10-FF-001240', NULL, 'Transducin family protein / WD-40 repeat family protein', 271, NULL, NULL, 146306),
(146307, '1.10.150.240-FF-000128', NULL, 'HAD-superfamily hydrolase, subfamily IA, variant 3', 70, NULL, NULL, 146307),
(146308, '3.30.910.20-FF-000015', NULL, 'Outer membrane protein 26', 98, NULL, NULL, 146308),
(146309, '3.80.10.10-FF-000700', NULL, 'Leucine-rich repeat protein', 158, NULL, NULL, 146309),
(146310, '1.25.10.10-FF-000158', NULL, 'ARM repeat superfamily protein', 216, NULL, NULL, 146310),
(146311, '1.10.510.10-FF-003046', NULL, NULL, 256, NULL, NULL, 146311),
(146312, '3.30.30.10-FF-000018', NULL, 'Defensin NsD7', 48, NULL, NULL, 146312),
(146313, '3.40.190.10-FF-000134', NULL, 'Nickel-binding periplasmic protein NikA', 274, NULL, NULL, 146313),
(146314, '3.30.160.60-FF-000868', NULL, 'putative histone-lysine N-methyltransferase PRDM6', 24, NULL, NULL, 146314),
(146315, '1.20.1050.10-FF-000028', NULL, 'Prostaglandin E synthase 2', 153, NULL, NULL, 146315),
(146316, '1.10.510.10-FF-000096', NULL, 'cGMP-dependent protein kinase', 195, NULL, NULL, 146316),
(146317, '3.90.470.20-FF-000024', NULL, 'Siderophore biosynthesis protein', 118, NULL, NULL, 146317),
(146318, '2.60.40.3530-FF-000001', NULL, 'Early E3 18.5 kDa glycoprotein', 108, NULL, NULL, 146318),
(146319, '2.180.10.10-FF-000018', NULL, 'Protein rhsD', 287, NULL, NULL, 146319),
(146320, '3.80.10.10-FF-000021', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 183, NULL, NULL, 146320),
(146321, '3.30.559.10-FF-000206', NULL, 'Uncharacterized protein', 200, NULL, NULL, 146321),
(146322, '3.10.100.10-FF-000192', NULL, 'Uncharacterized protein', 144, NULL, NULL, 146322),
(146323, '2.60.40.10-FF-000773', NULL, 'obscurin isoform X4', 98, NULL, NULL, 146323),
(146324, '3.40.50.10810-FF-000176', NULL, 'SNF2 superfamily protein', 133, NULL, NULL, 146324),
(146325, '3.30.160.60-FF-000559', NULL, 'zinc finger protein 462 isoform X1', 81, NULL, NULL, 146325),
(146326, '3.50.50.60-FF-000146', NULL, 'Mitochondrial translation optimization protein (Mto1)', 231, NULL, NULL, 146326);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(146327, '2.60.120.260-FF-000571', NULL, 'Predicted protein', 215, NULL, NULL, 146327),
(146328, '2.60.120.10-FF-000399', NULL, 'Si:ch211-161h7.4', 88, NULL, NULL, 146328),
(146329, '3.30.160.60-FF-000189', NULL, 'zinc finger protein 133 isoform X1', 28, NULL, NULL, 146329),
(146330, '3.30.420.40-FF-000809', NULL, 'SWI/SNF and RSC complexes subunit arp9', 145, NULL, NULL, 146330),
(146331, '3.30.70.1230-FF-000189', NULL, 'Predicted protein', 153, NULL, NULL, 146331),
(146332, '1.25.10.10-FF-002636', NULL, 'Predicted protein', 121, NULL, NULL, 146332),
(146333, '1.20.1250.20-FF-001766', NULL, 'Putative nitrate transporter', 188, NULL, NULL, 146333),
(146334, '3.30.70.330-FF-002424', NULL, NULL, 91, NULL, NULL, 146334),
(146335, '1.10.287.690-FF-000009', NULL, 'DNA polymerase epsilon catalytic subunit A', 64, NULL, NULL, 146335),
(146336, '3.90.1460.10-FF-000008', NULL, 'General transcription factor II-I repeat domain-containing protein 1', 87, NULL, NULL, 146336),
(146337, '1.10.3210.10-FF-000128', NULL, 'Exopolyphosphatase Ppx', 192, NULL, NULL, 146337),
(146338, '3.90.940.10-FF-000012', NULL, NULL, 90, NULL, NULL, 146338),
(146339, '2.60.260.20-FF-000120', NULL, 'dnaJ homolog subfamily A member 2', 84, NULL, NULL, 146339),
(146340, '3.60.21.10-FF-000249', NULL, 'Serine/threonine-protein phosphatase', 339, NULL, NULL, 146340),
(146341, '3.90.470.10-FF-000004', NULL, '50S ribosomal protein L22, chloroplastic', 119, NULL, NULL, 146341),
(146342, '3.40.50.1220-FF-000104', NULL, 'Putative 2-hydroxyacyl-CoA lyase', 149, NULL, NULL, 146342),
(146343, '3.40.50.1780-FF-000025', NULL, 'Uncharacterized protein (Fragment)', 106, NULL, NULL, 146343),
(146344, '1.20.1020.10-FF-000010', NULL, NULL, 104, NULL, NULL, 146344),
(146345, '3.30.70.330-FF-001918', NULL, NULL, 50, NULL, NULL, 146345),
(146346, '2.20.20.100-FF-000002', NULL, 'Autoinducer 2 sensor kinase/phosphatase LuxQ', 64, NULL, NULL, 146346),
(146347, '1.25.40.10-FF-002138', NULL, 'Predicted protein', 131, NULL, NULL, 146347),
(146348, '1.10.455.10-FF-000028', NULL, 'Ribosomal protein S7 domain-containing protein', 154, NULL, NULL, 146348),
(146349, '3.30.70.330-FF-000524', NULL, 'RNA-binding motif protein 38', 108, NULL, NULL, 146349),
(146350, '1.10.238.10-FF-000951', NULL, 'Calcineurin subunit B type 2', 183, NULL, NULL, 146350),
(146351, '3.40.980.10-FF-000037', NULL, 'CinA-like protein', 170, NULL, NULL, 146351),
(146352, '2.60.40.60-FF-000294', NULL, 'Protocadherin alpha subfamily C, 2', 108, NULL, NULL, 146352),
(146353, '2.40.50.140-FF-000151', NULL, 'Asparagine--tRNA ligase, cytoplasmic', 117, NULL, NULL, 146353),
(146354, '3.90.70.10-FF-000491', NULL, 'Senescence-specific cysteine protease SAG39', 117, NULL, NULL, 146354),
(146355, '3.30.540.10-FF-000068', NULL, 'Fructose-1,6-bisphosphatase', 149, NULL, NULL, 146355),
(146356, '2.20.20.110-FF-000005', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 49, NULL, NULL, 146356),
(146357, '3.90.550.10-FF-000640', NULL, 'Asparagine Linked Glycosylation (ALG) homolog, Nematode', 168, NULL, NULL, 146357),
(146358, '2.40.160.210-FF-000024', NULL, 'ACL122Wp', 315, NULL, NULL, 146358),
(146359, '3.10.20.90-FF-000571', NULL, 'ELongin B', 102, NULL, NULL, 146359),
(146360, '3.50.7.10-FF-000061', NULL, NULL, 145, NULL, NULL, 146360),
(146361, '2.130.10.10-FF-002196', NULL, 'Protein will die slowly-like protein', 152, NULL, NULL, 146361),
(146362, '2.10.25.10-FF-001139', NULL, 'Dumpy, isoform AA', 71, NULL, NULL, 146362),
(146363, '3.30.230.10-FF-000067', NULL, 'Serine/threonine protein kinase', 140, NULL, NULL, 146363),
(146364, '1.10.287.1080-FF-000004', NULL, 'dCTP pyrophosphatase 1', 110, NULL, NULL, 146364),
(146365, '3.40.50.620-FF-000015', NULL, 'NH(3)-dependent NAD(+) synthetase', 274, NULL, NULL, 146365),
(146366, '3.40.630.10-FF-000461', NULL, 'Uncharacterized protein', 115, NULL, NULL, 146366),
(146367, '2.70.130.10-FF-000173', NULL, NULL, 35, NULL, NULL, 146367),
(146368, '2.10.25.10-FF-001095', NULL, 'Stabilin 2', 43, NULL, NULL, 146368),
(146369, '2.60.40.60-FF-000338', NULL, 'Protocadherin-15', 90, NULL, NULL, 146369);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(146370, '3.30.200.20-FF-000052', NULL, 'Serine/threonine-protein kinase RIO2', 100, NULL, NULL, 146370),
(146371, '3.90.1150.10-FF-000333', NULL, 'Uncharacterized protein', 129, NULL, NULL, 146371),
(146372, '3.10.450.40-FF-000035', NULL, 'Hemagglutinin/proteinase', 85, NULL, NULL, 146372),
(146373, '3.10.28.10-FF-000031', NULL, 'Intron-encoded endonuclease I-SceI', 122, NULL, NULL, 146373),
(146374, '2.20.70.10-FF-000248', NULL, 'Uncharacterized protein', 51, NULL, NULL, 146374),
(146375, '2.60.120.200-FF-000025', NULL, 'Xyloglucan endotransglucosylase/hydrolase', 268, NULL, NULL, 146375),
(146376, '3.10.450.50-FF-000038', NULL, 'Nuclear RNA export factor 2', 196, NULL, NULL, 146376),
(146377, '3.30.60.20-FF-000158', NULL, 'Diacylglycerol kinase', 51, NULL, NULL, 146377),
(146378, '1.20.1270.10-FF-000011', NULL, 'stress-70 protein, mitochondrial isoform X1', 104, NULL, NULL, 146378),
(146379, '1.20.1560.10-FF-000112', NULL, 'ATP binding cassette subfamily C member 5', 96, NULL, NULL, 146379),
(146380, '3.10.110.10-FF-000147', NULL, 'Putative ubiquitin-conjugating enzyme E2 25', 183, NULL, NULL, 146380),
(146381, '1.25.10.10-FF-000793', NULL, 'Protein CBR-DAF-15', 202, NULL, NULL, 146381),
(146382, '3.90.1150.10-FF-000041', NULL, 'Low-specificity L-threonine aldolase', 97, NULL, NULL, 146382),
(146383, '1.10.287.1490-FF-000037', NULL, 'Elastin microfibril interfacer 3', 146, NULL, NULL, 146383),
(146384, '1.10.1660.10-FF-000009', NULL, 'HTH-type transcriptional regulator ycgE', 115, NULL, NULL, 146384),
(146385, '3.30.160.60-FF-005101', NULL, NULL, 31, NULL, NULL, 146385),
(146386, '2.60.40.790-FF-000081', NULL, 'Phosphatase-like protein, putative', 104, NULL, NULL, 146386),
(146387, '3.40.50.300-FF-004972', NULL, 'Gluconokinase', 195, NULL, NULL, 146387),
(146388, '3.30.70.960-FF-000022', NULL, 'Mucin 16', 36, NULL, NULL, 146388),
(146389, '2.30.30.550-FF-000007', NULL, 'Major vault protein', 54, NULL, NULL, 146389),
(146390, '2.30.30.100-FF-000204', NULL, 'Probable U6 snRNA-associated Sm-like protein LSm3', 93, NULL, NULL, 146390),
(146391, '3.30.450.40-FF-000093', NULL, 'IclR family transcriptional regulator', 165, NULL, NULL, 146391),
(146392, '1.20.5.340-FF-000095', NULL, 'Rabaptin, RAB GTPase-binding effector protein 2', 90, NULL, NULL, 146392),
(146393, '1.10.3430.10-FF-000010', NULL, 'Ammonium transporter', 424, NULL, NULL, 146393),
(146394, '1.10.1450.10-FF-000174', NULL, 'Tetraspanin', 49, NULL, NULL, 146394),
(146395, '1.10.400.10-FF-000093', NULL, 'Uncharacterized protein', 44, NULL, NULL, 146395),
(146396, '1.10.340.30-FF-000026', NULL, 'Uncharacterized protein', 112, NULL, NULL, 146396),
(146397, '3.30.450.30-FF-000090', NULL, 'Uncharacterized protein', 58, NULL, NULL, 146397),
(146398, '3.30.390.50-FF-000023', NULL, 'Carbon monoxide dehydrogenase, medium subunit, putative', 94, NULL, NULL, 146398),
(146399, '1.10.10.10-FF-002086', NULL, 'Interferon regulatory factor 3', 56, NULL, NULL, 146399),
(146400, '1.20.1510.10-FF-000064', NULL, NULL, 63, NULL, NULL, 146400),
(146401, '3.90.780.10-FF-000005', NULL, 'Putative 5''-nucleotidase', 186, NULL, NULL, 146401),
(146402, '3.40.50.300-FF-000459', NULL, 'ras-related protein Rab-37 isoform X1', 194, NULL, NULL, 146402),
(146403, '3.50.50.60-FF-000472', NULL, 'Putative glycine oxidase ThiO', 183, NULL, NULL, 146403),
(146404, '3.30.420.40-FF-000591', NULL, 'Uncharacterized protein', 27, NULL, NULL, 146404),
(146405, '1.20.1270.60-FF-000110', NULL, 'Sorting nexin', 192, NULL, NULL, 146405),
(146406, '3.80.10.10-FF-003264', NULL, 'Disease resistance protein RPS2', 222, NULL, NULL, 146406),
(146407, '2.60.40.180-FF-000004', NULL, '5-hydroxyisourate hydrolase', 116, NULL, NULL, 146407),
(146408, '1.25.40.10-FF-000295', NULL, 'serine/threonine-protein phosphatase 5', 115, NULL, NULL, 146408),
(146409, '1.10.287.70-FF-000110', NULL, 'Potassium channel subfamily K member', 279, NULL, NULL, 146409),
(146410, '3.30.760.10-FF-000051', NULL, 'Eukaryotic translation initiation factor 4E type 1B', 186, NULL, NULL, 146410),
(146411, '1.25.40.10-FF-002464', NULL, 'Pentatricopeptide repeat-containing protein At1g71420', 111, NULL, NULL, 146411);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(146412, '3.10.100.10-FF-000219', NULL, NULL, 137, NULL, NULL, 146412),
(146413, '3.40.50.12780-FF-000064', NULL, 'Probable medium chain fatty-acid-CoA ligase fadD14', 431, NULL, NULL, 146413),
(146414, '3.30.160.60-FF-001402', NULL, 'Zinc finger protein 473', 30, NULL, NULL, 146414),
(146415, '3.30.70.980-FF-000028', NULL, 'Probable transcriptional regulatory protein ERS082928_00922', 74, NULL, NULL, 146415),
(146416, '3.80.10.10-FF-001465', NULL, 'Leucine-rich repeat containing protein', 334, NULL, NULL, 146416),
(146417, '2.70.20.50-FF-000002', NULL, 'Matrix protein', 191, NULL, NULL, 146417),
(146418, '3.40.50.880-FF-000144', NULL, 'DJ-1 family protein', 187, NULL, NULL, 146418),
(146419, '3.40.850.10-FF-000033', NULL, 'Kinesin-like protein KIN-12E', 355, NULL, NULL, 146419),
(146420, '1.25.40.20-FF-000859', NULL, 'LOW QUALITY PROTEIN: kinase D-interacting substrate of 220 kDa B-like', 90, NULL, NULL, 146420),
(146421, '2.60.40.150-FF-000237', NULL, 'Synaptotagmin 15', 132, NULL, NULL, 146421),
(146422, '3.40.190.10-FF-000090', NULL, 'Glycine betaine transporter periplasmic subunit', 161, NULL, NULL, 146422),
(146423, '3.30.70.1730-FF-000001', NULL, '50S ribosomal protein L10', 130, NULL, NULL, 146423),
(146424, '1.10.357.50-FF-000031', NULL, 'Uncharacterized protein', 162, NULL, NULL, 146424),
(146425, '1.10.418.10-FF-000268', NULL, 'Protein hook homolog', 145, NULL, NULL, 146425),
(146426, '3.30.590.50-FF-000021', NULL, 'Predicted protein', 38, NULL, NULL, 146426),
(146427, '1.20.1070.10-FF-001991', NULL, 'Uncharacterized protein', 155, NULL, NULL, 146427),
(146428, '3.30.160.60-FF-004921', NULL, NULL, 79, NULL, NULL, 146428),
(146429, '3.40.50.80-FF-000034', NULL, 'Respiratory burst oxidase homolog protein B', 196, NULL, NULL, 146429),
(146430, '3.50.50.100-FF-000026', NULL, 'Uncharacterized protein', 384, NULL, NULL, 146430),
(146431, '1.10.150.20-FF-000132', NULL, 'Exonuclease-1, H3TH domain protein', 78, NULL, NULL, 146431),
(146432, '2.40.50.140-FF-000049', NULL, '26S protease regulatory subunit 6B', 110, NULL, NULL, 146432),
(146433, '3.40.630.10-FF-000135', NULL, 'Aminopeptidase', 71, NULL, NULL, 146433),
(146434, '1.10.287.110-FF-000358', NULL, 'Chloroplast DnaJ-like protein', 88, NULL, NULL, 146434),
(146435, '1.10.10.10-FF-000539', NULL, '40S ribosomal protein S10, putative', 99, NULL, NULL, 146435),
(146436, '2.40.70.10-FF-000231', NULL, 'Sap98p', 160, NULL, NULL, 146436),
(146437, '2.40.40.20-FF-000069', NULL, 'NADPH-Fe(3+) oxidoreductase subunit alpha', 114, NULL, NULL, 146437),
(146438, '1.10.30.10-FF-000086', NULL, 'Protein CBG16280', 79, NULL, NULL, 146438),
(146439, '1.10.1180.10-FF-000001', NULL, 'DNA transposition protein (GpB)', 91, NULL, NULL, 146439),
(146440, '3.30.200.20-FF-002513', NULL, 'Uncharacterized protein', 112, NULL, NULL, 146440),
(146441, '2.60.120.200-FF-000351', NULL, 'Galectin', 142, NULL, NULL, 146441),
(146442, '3.40.50.1980-FF-000130', NULL, 'Putative histidinol dehydrogenase 2', 163, NULL, NULL, 146442),
(146443, '2.40.50.140-FF-000712', NULL, NULL, 103, NULL, NULL, 146443),
(146444, '3.40.50.1000-FF-000639', NULL, NULL, 151, NULL, NULL, 146444),
(146445, '1.25.40.10-FF-002773', NULL, 'Uncharacterized protein', 95, NULL, NULL, 146445),
(146446, '1.50.10.130-FF-000012', NULL, 'Tricyclene synthase 1e20, chloroplastic', 195, NULL, NULL, 146446),
(146447, '1.10.1450.10-FF-000089', NULL, 'TetraSPanin family', 112, NULL, NULL, 146447),
(146448, '1.20.1640.10-FF-000068', NULL, 'RND multidrug efflux transporter', 210, NULL, NULL, 146448),
(146449, '2.30.30.40-FF-000294', NULL, 'Chemotaxis protein CheW', 59, NULL, NULL, 146449),
(146450, '2.30.30.940-FF-000001', NULL, 'ATP-dependent RecD-like DNA helicase', 78, NULL, NULL, 146450),
(146451, '2.40.10.10-FF-000564', NULL, NULL, 68, NULL, NULL, 146451),
(146452, '3.30.70.370-FF-000042', NULL, NULL, 31, NULL, NULL, 146452),
(146453, '3.30.390.50-FF-000006', NULL, 'FAD binding domain in molybdopterin dehydrogenase', 96, NULL, NULL, 146453),
(146454, '2.60.40.10-FF-004281', NULL, NULL, 95, NULL, NULL, 146454);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(146455, '3.40.1080.10-FF-000018', NULL, 'CoA transferase CarA2', 250, NULL, NULL, 146455),
(146456, '3.90.550.10-FF-000494', NULL, 'Glycosyltransferases', 90, NULL, NULL, 146456),
(146457, '2.130.10.10-FF-000734', NULL, 'Protein RAE1', 279, NULL, NULL, 146457),
(146458, '3.10.50.10-FF-000037', NULL, 'Chitinase, putative', 27, NULL, NULL, 146458),
(146459, '3.40.50.1000-FF-000432', NULL, 'Polynucleotide kinase 3''-phosphatase', 187, NULL, NULL, 146459),
(146460, '3.30.420.100-FF-000007', NULL, 'Ribosomal L18p/L5e family protein', 115, NULL, NULL, 146460),
(146461, '1.50.40.10-FF-000377', NULL, 'Uncharacterized protein', 109, NULL, NULL, 146461),
(146462, '3.40.50.720-FF-000028', NULL, 'NAD(P) transhydrogenase subunit alpha', 181, NULL, NULL, 146462),
(146463, '2.30.42.10-FF-000060', NULL, 'Connector enhancer of kinase suppressor of Ras 2', 102, NULL, NULL, 146463),
(146464, '2.30.29.150-FF-000009', NULL, 'Nucleosome binding factor SPN, SPT16 subunit', 160, NULL, NULL, 146464),
(146465, '3.50.50.60-FF-000163', NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase, mitochondrial', 240, NULL, NULL, 146465),
(146466, '3.40.50.1380-FF-000028', NULL, 'Carbamoyl-phosphate synthase large chain', 137, NULL, NULL, 146466),
(146467, '3.30.200.20-FF-002204', NULL, 'Uncharacterized protein', 47, NULL, NULL, 146467),
(146468, '2.60.40.1300-FF-000001', NULL, 'Putative DD-carboxypeptidase TP_0574', 128, NULL, NULL, 146468),
(146469, '2.40.160.10-FF-000052', NULL, 'Uncharacterized protein', 213, NULL, NULL, 146469),
(146470, '3.40.50.10810-FF-000193', NULL, 'Uncharacterized protein', 233, NULL, NULL, 146470),
(146471, '1.25.40.20-FF-000298', NULL, 'ArfGAP with GTPase domain, ankyrin repeat and PH domain 2', 114, NULL, NULL, 146471),
(146472, '1.25.10.10-FF-000484', NULL, 'RING-type E3 ubiquitin transferase', 264, NULL, NULL, 146472),
(146473, '1.25.40.10-FF-001958', NULL, 'Pentatricopeptide repeat-containing protein', 134, NULL, NULL, 146473),
(146474, '1.10.10.10-FF-000848', NULL, 'Regulatory protein RecX', 43, NULL, NULL, 146474),
(146475, '1.25.40.180-FF-000110', NULL, 'Uncharacterized protein', 249, NULL, NULL, 146475),
(146476, '1.10.8.270-FF-000194', NULL, 'Predicted protein', 76, NULL, NULL, 146476),
(146477, '3.40.525.10-FF-000019', NULL, 'RhoGAP GTPase, putative', 142, NULL, NULL, 146477),
(146478, '1.10.20.10-FF-000158', NULL, 'Histone-like_transcription_factor_(CBF/NF-Y)_and_ archaeal_histone/Core_histone_H2A/H2B/H3/H4_-_putative', 111, NULL, NULL, 146478),
(146479, '2.30.30.100-FF-000221', NULL, 'U6 snRNA-associated Sm-like protein LSm8', 67, NULL, NULL, 146479),
(146480, '2.60.40.150-FF-000254', NULL, 'protein unc-13 homolog D isoform X1', 169, NULL, NULL, 146480),
(146481, '3.20.20.70-FF-000727', NULL, NULL, 373, NULL, NULL, 146481),
(146482, '3.30.160.60-FF-002667', NULL, 'Si:dkey-1b17.7 protein', 25, NULL, NULL, 146482),
(146483, '3.30.420.40-FF-000826', NULL, 'Actin-related protein 5-like protein', 30, NULL, NULL, 146483),
(146484, '2.40.70.10-FF-000540', NULL, NULL, 188, NULL, NULL, 146484),
(146485, '2.130.10.10-FF-000425', NULL, 'Cytoplasmic dynein 1 intermediate chain 2', 224, NULL, NULL, 146485),
(146486, '1.10.10.60-FF-000414', NULL, 'Transcription factor RAX3', 67, NULL, NULL, 146486),
(146487, '1.20.120.1200-FF-000027', NULL, 'Uncharacterized protein', 88, NULL, NULL, 146487),
(146488, '2.170.130.10-FF-000047', NULL, 'SusC/RagA family TonB-linked outer membrane protein', 131, NULL, NULL, 146488),
(146489, '3.80.10.10-FF-003909', NULL, 'Uncharacterized protein', 124, NULL, NULL, 146489),
(146490, '3.90.550.10-FF-000185', NULL, 'Glycosyl transferase, group 2', 240, NULL, NULL, 146490),
(146491, '3.30.40.10-FF-001683', NULL, 'RUN and FYVE domain-containing 4', 73, NULL, NULL, 146491),
(146492, '1.25.40.10-FF-003858', NULL, 'Uncharacterized protein', 107, NULL, NULL, 146492),
(146493, '3.40.50.1820-FF-001824', NULL, 'Alpha/beta hydrolase', 96, NULL, NULL, 146493),
(146494, '3.40.50.1000-FF-000078', NULL, 'Bifunctional polynucleotide phosphatase/kinase', 194, NULL, NULL, 146494);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(146495, '3.30.420.80-FF-000035', NULL, 'Mitochondrial ribosomal protein L18, putative', 81, NULL, NULL, 146495),
(146496, '3.30.160.60-FF-004567', NULL, NULL, 23, NULL, NULL, 146496),
(146497, '2.120.10.30-FF-000605', NULL, 'Dipeptidyl aminopeptidase BIII', 186, NULL, NULL, 146497),
(146498, '3.10.330.20-FF-000015', NULL, 'tRNA (adenine(58)-N(1))-methyltransferase catalytic subunit TRMT61A', 72, NULL, NULL, 146498),
(146499, '2.30.130.30-FF-000007', NULL, NULL, 110, NULL, NULL, 146499),
(146500, '4.10.400.10-FF-000267', NULL, 'LDL receptor protein 1, isoform F', 40, NULL, NULL, 146500),
(146501, '3.40.50.720-FF-002153', NULL, 'Uncharacterized protein', 82, NULL, NULL, 146501),
(146502, '1.10.8.210-FF-000002', NULL, 'Siroheme synthase', 59, NULL, NULL, 146502),
(146503, '2.40.37.20-FF-000016', NULL, NULL, 63, NULL, NULL, 146503),
(146504, '1.10.10.10-FF-000332', NULL, 'DEP domain-containing mTOR-interacting protein isoform X1', 142, NULL, NULL, 146504),
(146505, '2.70.150.10-FF-000191', NULL, 'Uncharacterized protein, isoform A', 40, NULL, NULL, 146505),
(146506, '3.30.70.330-FF-001935', NULL, NULL, 140, NULL, NULL, 146506),
(146507, '2.10.25.10-FF-001802', NULL, 'Low density lipoprotein receptor-related protein 1Aa', 22, NULL, NULL, 146507),
(146508, '3.40.30.10-FF-000479', NULL, 'Thioredoxin domain containing 5', 125, NULL, NULL, 146508),
(146509, '3.30.200.20-FF-000922', NULL, 'Serine/threonine-protein kinase-like protein At1g28390', 111, NULL, NULL, 146509),
(146510, '2.60.40.1900-FF-000001', NULL, 'Beta-microseminoprotein', 85, NULL, NULL, 146510),
(146511, '1.10.510.10-FF-002692', NULL, NULL, 174, NULL, NULL, 146511),
(146512, '2.40.37.10-FF-000013', NULL, 'Carboxynorspermidine decarboxylase', 135, NULL, NULL, 146512),
(146513, '1.10.3090.10-FF-000039', NULL, 'Bifunctional uridylyltransferase/uridylyl-removing enzyme', 228, NULL, NULL, 146513),
(146514, '2.40.50.40-FF-000070', NULL, 'Uncharacterized protein', 59, NULL, NULL, 146514),
(146515, '1.20.58.70-FF-000077', NULL, 'YALI0E33165p', 209, NULL, NULL, 146515),
(146516, '2.60.260.20-FF-000075', NULL, 'Chaperone protein DNAj, putative', 62, NULL, NULL, 146516),
(146517, '2.60.40.10-FF-004842', NULL, NULL, 102, NULL, NULL, 146517),
(146518, '3.40.50.300-FF-000947', NULL, 'DNA repair protein RAD50', 165, NULL, NULL, 146518),
(146519, '3.10.330.10-FF-000012', NULL, 'AAA family ATPase, CDC48 subfamily', 103, NULL, NULL, 146519),
(146520, '3.30.360.10-FF-000116', NULL, 'Uncharacterized protein', 75, NULL, NULL, 146520),
(146521, '2.40.50.730-FF-000029', NULL, 'DNA polymerase', 42, NULL, NULL, 146521),
(146522, '3.40.50.2000-FF-000602', NULL, 'Glycosyltransferase family protein 1', 206, NULL, NULL, 146522),
(146523, '1.25.40.10-FF-004038', NULL, 'Uncharacterized protein', 180, NULL, NULL, 146523),
(146524, '3.40.50.2300-FF-000232', NULL, 'Response regulator GraR', 123, NULL, NULL, 146524),
(146525, '1.10.472.10-FF-000539', NULL, 'Cyclin-B1-4', 81, NULL, NULL, 146525),
(146526, '3.40.50.620-FF-000341', NULL, 'Deoxyribodipyrimidine photolyase single-strand-specific', 129, NULL, NULL, 146526),
(146527, '3.30.200.20-FF-000613', NULL, 'Fibrillarin-like rRNA/tRNA 2''-O-methyltransferase', 55, NULL, NULL, 146527),
(146528, '1.20.1070.10-FF-001811', NULL, 'Predicted protein', 313, NULL, NULL, 146528),
(146529, '3.30.200.20-FF-000361', NULL, 'Dual specificity testis-specific protein kinase 1', 76, NULL, NULL, 146529),
(146530, '3.20.20.70-FF-000598', NULL, NULL, 244, NULL, NULL, 146530),
(146531, '2.40.70.10-FF-000438', NULL, NULL, 110, NULL, NULL, 146531),
(146532, '3.60.21.50-FF-000019', NULL, 'Polymerase (DNA directed), delta 2, accessory subunit', 114, NULL, NULL, 146532),
(146533, '3.30.230.10-FF-000112', NULL, 'Eukaryotic translation elongation factor 2', 154, NULL, NULL, 146533),
(146534, '1.20.1110.10-FF-000129', NULL, NULL, 208, NULL, NULL, 146534),
(146535, '2.60.34.10-FF-000051', NULL, 'Heat shock protein70', 164, NULL, NULL, 146535),
(146536, '1.25.40.10-FF-004347', NULL, 'Uncharacterized protein', 162, NULL, NULL, 146536),
(146537, '1.20.58.60-FF-000074', NULL, 'dystonin isoform X1', 109, NULL, NULL, 146537);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(146538, '1.10.287.110-FF-000460', NULL, 'Uncharacterized protein', 88, NULL, NULL, 146538),
(146539, '1.10.10.10-FF-000641', NULL, 'DNA-binding response regulator', 106, NULL, NULL, 146539),
(146540, '3.30.160.60-FF-004258', NULL, NULL, 73, NULL, NULL, 146540),
(146541, '1.10.532.10-FF-000011', NULL, 'Signal transducer and activator of transcription', 122, NULL, NULL, 146541),
(146542, '3.30.565.10-FF-000412', NULL, 'HAMP domain-containing protein', 161, NULL, NULL, 146542),
(146543, '1.10.150.670-FF-000010', NULL, 'GD16537', 79, NULL, NULL, 146543),
(146544, '1.25.10.10-FF-002075', NULL, 'Uncharacterized protein', 333, NULL, NULL, 146544),
(146545, '3.30.420.40-FF-000265', NULL, 'Actin-related protein, putative', 40, NULL, NULL, 146545),
(146546, '2.60.40.10-FF-002690', NULL, 'AGAP003610-PA', 101, NULL, NULL, 146546),
(146547, '3.40.1490.10-FF-000010', NULL, 'Uncharacterized protein', 35, NULL, NULL, 146547),
(146548, '3.80.10.10-FF-003590', NULL, 'Flagellar associated protein', 133, NULL, NULL, 146548),
(146549, '4.10.320.10-FF-000002', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 50, NULL, NULL, 146549),
(146550, '3.40.50.220-FF-000002', NULL, 'Ornithine decarboxylase, constitutive', 100, NULL, NULL, 146550),
(146551, '1.10.510.10-FF-003501', NULL, NULL, 255, NULL, NULL, 146551),
(146552, '3.10.660.10-FF-000014', NULL, 'GG10921', 61, NULL, NULL, 146552),
(146553, '1.20.5.110-FF-000110', NULL, 'Sulfate permease family', 64, NULL, NULL, 146553),
(146554, '3.40.50.2300-FF-000147', NULL, 'Atrial natriuretic peptide receptor 3', 179, NULL, NULL, 146554),
(146555, '3.30.160.60-FF-006158', NULL, NULL, 96, NULL, NULL, 146555),
(146556, '1.20.1510.10-FF-000081', NULL, NULL, 163, NULL, NULL, 146556),
(146557, '2.20.70.10-FF-000265', NULL, 'Uncharacterized protein', 40, NULL, NULL, 146557),
(146558, '3.30.450.40-FF-000076', NULL, 'IclR family transcriptional regulator', 177, NULL, NULL, 146558),
(146559, '1.20.1530.20-FF-000085', NULL, 'Sodium/bile acid cotransporter 7-like Protein', 322, NULL, NULL, 146559),
(146560, '1.20.120.20-FF-000021', NULL, 'Apolipoprotein E', 77, NULL, NULL, 146560),
(146561, '3.40.50.150-FF-000279', NULL, 'Methyltransferase-like protein', 253, NULL, NULL, 146561),
(146562, '3.30.870.10-FF-000071', NULL, 'Tyrosyl-DNA phosphodiesterase', 215, NULL, NULL, 146562),
(146563, '3.50.50.60-FF-000601', NULL, '2-octaprenyl-3-methyl-6-methoxy-1,4-benzoquinol hydroxylase', 129, NULL, NULL, 146563),
(146564, '1.10.510.10-FF-002883', NULL, 'CAMK family protein kinase', 284, NULL, NULL, 146564),
(146565, '2.60.120.650-FF-000238', NULL, 'Uncharacterized protein', 104, NULL, NULL, 146565),
(146566, '1.20.1270.280-FF-000077', NULL, 'Predicted protein', 59, NULL, NULL, 146566),
(146567, '1.20.1050.130-FF-000050', NULL, 'Uncharacterized protein', 80, NULL, NULL, 146567),
(146568, '2.10.110.10-FF-000145', NULL, 'Cysteine and glycine-rich protein', 72, NULL, NULL, 146568),
(146569, '2.10.70.80-FF-000011', NULL, 'Sortilin', 56, NULL, NULL, 146569),
(146570, '3.30.1360.120-FF-000065', NULL, 'Dimethylglycine dehydrogenase, mitochondrial', 177, NULL, NULL, 146570),
(146571, '3.30.70.20-FF-000131', NULL, NULL, 42, NULL, NULL, 146571),
(146572, '3.30.70.1050-FF-000011', NULL, 'Trigger factor', 123, NULL, NULL, 146572),
(146573, '3.40.50.720-FF-000236', NULL, 'Bifunctional dTDP-4-dehydrorhamnose 3,5-epimerase/dTDP-4-dehydrorhamnose reductase', 297, NULL, NULL, 146573),
(146574, '3.90.1410.10-FF-000078', NULL, 'SET domain containing protein, putative', 178, NULL, NULL, 146574),
(146575, '1.20.58.340-FF-000078', NULL, 'Uncharacterized protein', 127, NULL, NULL, 146575),
(146576, '1.10.340.30-FF-000043', NULL, 'N-glycosylase/DNA lyase, putative', 65, NULL, NULL, 146576),
(146577, '3.30.420.40-FF-000147', NULL, 'Cell division protein FtsA', 86, NULL, NULL, 146577),
(146578, '1.10.400.10-FF-000076', NULL, 'Uncharacterized protein', 126, NULL, NULL, 146578),
(146579, '1.10.533.10-FF-000148', NULL, 'CASP2 and RIPK1 domain containing adaptor with death domain', 103, NULL, NULL, 146579);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(146580, '1.20.1070.10-FF-001682', NULL, 'Predicted protein', 115, NULL, NULL, 146580),
(146581, '3.30.450.30-FF-000073', NULL, 'Uncharacterized protein', 125, NULL, NULL, 146581),
(146582, '2.40.10.10-FF-000238', NULL, 'Kallikrein related peptidase 13', 90, NULL, NULL, 146582),
(146583, '1.25.10.10-FF-002721', NULL, 'Uncharacterized protein', 942, NULL, NULL, 146583),
(146584, '3.30.40.10-FF-001598', NULL, 'Zinc finger protein', 83, NULL, NULL, 146584),
(146585, '3.40.190.10-FF-000117', NULL, 'Glutamate receptor, ionotropic kainate', 131, NULL, NULL, 146585),
(146586, '3.40.50.300-FF-001302', NULL, 'DNA replication ATP-dependent helicase/nuclease DNA2', 102, NULL, NULL, 146586),
(146587, '1.20.1050.10-FF-000146', NULL, 'Uncharacterized protein', 100, NULL, NULL, 146587),
(146588, '2.30.180.10-FF-000117', NULL, NULL, 128, NULL, NULL, 146588),
(146589, '1.20.58.1040-FF-000016', NULL, '1,3-beta-glucanosyltransferase GAS2', 120, NULL, NULL, 146589),
(146590, '2.60.40.10-FF-000790', NULL, 'HLA class II histocompatibility antigen, DM alpha chain', 109, NULL, NULL, 146590),
(146591, '3.30.200.20-FF-002485', NULL, NULL, 29, NULL, NULL, 146591),
(146592, '3.30.310.40-FF-000009', NULL, 'Putative 8-oxoguanine DNA glycosylase', 80, NULL, NULL, 146592),
(146593, '1.25.10.10-FF-000719', NULL, 'Karyopherin/importin that interacts with the nuclear pore complex', 870, NULL, NULL, 146593),
(146594, '2.60.40.10-FF-000902', NULL, 'MER proto-oncogene, tyrosine kinase', 100, NULL, NULL, 146594),
(146595, '3.30.450.20-FF-000070', NULL, 'Two-component system sensor histidine kinase CreC', 114, NULL, NULL, 146595),
(146596, '1.20.1050.10-FF-000045', NULL, 'Glutathione S-transferase family protein', 160, NULL, NULL, 146596),
(146597, '2.40.10.10-FF-000194', NULL, 'Uncharacterized protein', 97, NULL, NULL, 146597),
(146598, '3.90.79.10-FF-000246', NULL, 'Uncharacterized protein', 161, NULL, NULL, 146598),
(146599, '3.30.70.330-FF-002733', NULL, NULL, 96, NULL, NULL, 146599),
(146600, '3.50.50.100-FF-000043', NULL, 'Uncharacterized protein', 368, NULL, NULL, 146600),
(146601, '3.40.50.1820-FF-001178', NULL, 'Uncharacterized protein', 209, NULL, NULL, 146601),
(146602, '3.40.50.300-FF-004955', NULL, 'GPN-loop GTPase', 161, NULL, NULL, 146602),
(146603, '3.30.160.60-FF-003510', NULL, 'GM10229', 26, NULL, NULL, 146603),
(146604, '1.25.40.10-FF-002801', NULL, 'Predicted protein', 100, NULL, NULL, 146604),
(146605, '3.90.1480.20-FF-000029', NULL, 'ST3 beta-galactoside alpha-2,3-sialyltransferase 1,-like', 124, NULL, NULL, 146605),
(146606, '3.30.160.60-FF-002459', NULL, 'myeloid zinc finger 1 isoform X5', 28, NULL, NULL, 146606),
(146607, '3.30.200.20-FF-002058', NULL, 'Predicted protein', 117, NULL, NULL, 146607),
(146608, '1.10.730.10-FF-000106', NULL, 'Methionine--tRNA ligase', 139, NULL, NULL, 146608),
(146609, '3.30.160.60-FF-003887', NULL, NULL, 31, NULL, NULL, 146609),
(146610, '1.10.510.10-FF-003400', NULL, NULL, 304, NULL, NULL, 146610),
(146611, '3.40.190.10-FF-000651', NULL, 'ABC transporter substrate-binding protein-oligopeptide transport', 131, NULL, NULL, 146611),
(146612, '3.30.70.660-FF-000005', NULL, 'tRNA pseudouridine synthase', 183, NULL, NULL, 146612),
(146613, '2.40.340.10-FF-000032', NULL, NULL, 47, NULL, NULL, 146613),
(146614, '3.40.50.720-FF-001439', NULL, 'CD38 molecule', 125, NULL, NULL, 146614),
(146615, '3.30.70.580-FF-000015', NULL, 'tRNA pseudouridine synthase A', 104, NULL, NULL, 146615),
(146616, '3.50.50.60-FF-000500', NULL, 'D-amino acid oxidase', 182, NULL, NULL, 146616),
(146617, '1.10.287.80-FF-000028', NULL, 'Probable lysine-specific histone demethylase 1', 80, NULL, NULL, 146617),
(146618, '3.30.50.10-FF-000020', NULL, 'Zinc finger transcription factor Trps1', 65, NULL, NULL, 146618),
(146619, '1.10.275.40-FF-000006', NULL, 'Excision repair cross-complementation group 2', 72, NULL, NULL, 146619),
(146620, '3.100.10.10-FF-000001', NULL, '60S ribosomal protein L18', 188, NULL, NULL, 146620),
(146621, '2.10.25.10-FF-001448', NULL, 'Uncharacterized protein', 65, NULL, NULL, 146621);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(146622, '3.90.105.10-FF-000033', NULL, 'Molybdenum cofactor biosynthesis protein', 33, NULL, NULL, 146622),
(146623, '1.20.1000.10-FF-000008', NULL, 'Guanylate-binding protein 4', 133, NULL, NULL, 146623),
(146624, '1.20.58.900-FF-000032', NULL, 'FYVE and coiled-coil domain-containing 1a', 90, NULL, NULL, 146624),
(146625, '2.60.40.10-FF-002347', NULL, 'Protein sidekick homolog', 93, NULL, NULL, 146625),
(146626, '2.30.30.40-FF-000614', NULL, 'SH3 and multiple ankyrin repeat domains 3', 53, NULL, NULL, 146626),
(146627, '1.20.1020.10-FF-000009', NULL, NULL, 114, NULL, NULL, 146627),
(146628, '2.120.10.80-FF-000351', NULL, 'Attractin-like 1a', 58, NULL, NULL, 146628),
(146629, '3.40.50.1220-FF-000121', NULL, 'Uncharacterized protein', 176, NULL, NULL, 146629),
(146630, '3.40.50.1000-FF-000286', NULL, 'NLI_interacting_factor-like_phosphatase', 121, NULL, NULL, 146630),
(146631, '1.50.40.10-FF-000568', NULL, 'Mitochondrial energy transfer protein', 99, NULL, NULL, 146631),
(146632, '3.30.70.330-FF-000171', NULL, 'Meiosis regulator and mRNA stability factor 1', 80, NULL, NULL, 146632),
(146633, '3.50.4.10-FF-000054', NULL, NULL, 80, NULL, NULL, 146633),
(146634, '3.40.50.1010-FF-000289', NULL, NULL, 137, NULL, NULL, 146634),
(146635, '1.25.40.20-FF-000977', NULL, 'Ankyrin repeat domain 55', 138, NULL, NULL, 146635),
(146636, '1.10.275.30-FF-000003', NULL, 'ATP-dependent DNA helicase Saci_0192', 108, NULL, NULL, 146636),
(146637, '2.160.20.10-FF-000211', NULL, 'Uncharacterized protein', 336, NULL, NULL, 146637),
(146638, '3.40.50.300-FF-004854', NULL, 'DNA helicase', 198, NULL, NULL, 146638),
(146639, '1.20.1540.10-FF-000021', NULL, 'UBA domain containing 2', 187, NULL, NULL, 146639),
(146640, '2.60.200.20-FF-000099', NULL, 'Serine/threonine protein kinase', 122, NULL, NULL, 146640),
(146641, '3.40.50.1240-FF-000127', NULL, 'Uncharacterized protein, isoform J', 129, NULL, NULL, 146641),
(146642, '3.90.190.10-FF-000201', NULL, 'Tyrosine-protein phosphatase cdc-14', 163, NULL, NULL, 146642),
(146643, '3.30.210.10-FF-000004', NULL, 'DNA-directed DNA/RNA polymerase mu', 70, NULL, NULL, 146643),
(146644, '3.40.50.300-FF-008553', NULL, 'ATP-dependent DNA helicase', 227, NULL, NULL, 146644),
(146645, '3.40.50.300-FF-002393', NULL, 'Uncharacterized protein, isoform C', 87, NULL, NULL, 146645),
(146646, '2.40.50.140-FF-000504', NULL, 'RNA m5u methyltransferase', 85, NULL, NULL, 146646),
(146647, '3.40.50.2000-FF-000131', NULL, 'Trehalose-6-phosphate phosphatase', 301, NULL, NULL, 146647),
(146648, '3.90.550.50-FF-000039', NULL, 'WGS project CABT00000000 data, contig 2.9', 276, NULL, NULL, 146648),
(146649, '3.40.630.30-FF-000585', NULL, 'Uncharacterized protein', 92, NULL, NULL, 146649),
(146650, '1.25.40.540-FF-000027', NULL, 'Uncharacterized protein C63.05', 192, NULL, NULL, 146650),
(146651, '3.10.20.90-FF-000554', NULL, 'NADPH oxidase activator 1', 85, NULL, NULL, 146651),
(146652, '3.90.260.10-FF-000067', NULL, 'Uncharacterized protein', 171, NULL, NULL, 146652),
(146653, '3.40.30.10-FF-000288', NULL, 'Tryparedoxin 1a', 144, NULL, NULL, 146653),
(146654, '1.20.1560.10-FF-000230', NULL, 'AGAP008437-PA', 70, NULL, NULL, 146654),
(146655, '2.60.40.2170-FF-000014', NULL, 'Uncharacterized protein', 124, NULL, NULL, 146655),
(146656, '3.40.140.10-FF-000069', NULL, 'Cytidine deaminase', 136, NULL, NULL, 146656),
(146657, '1.10.1370.10-FF-000010', NULL, 'Protein CBG00366', 346, NULL, NULL, 146657),
(146658, '1.10.238.10-FF-000625', NULL, 'Putative calmodulin-related protein', 83, NULL, NULL, 146658),
(146659, '1.25.40.10-FF-004246', NULL, 'Uncharacterized protein', 235, NULL, NULL, 146659),
(146660, '2.60.120.10-FF-000753', NULL, 'Uncharacterized protein', 88, NULL, NULL, 146660),
(146661, '1.25.40.530-FF-000024', NULL, 'Myosin XVB', 169, NULL, NULL, 146661),
(146662, '1.10.1600.10-FF-000017', NULL, 'Uncharacterized protein', 94, NULL, NULL, 146662),
(146663, '3.40.50.2300-FF-001676', NULL, NULL, 153, NULL, NULL, 146663),
(146664, '1.25.40.10-FF-000547', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 78, NULL, NULL, 146664);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(146665, '3.90.226.10-FF-000151', NULL, 'Probable enoyl-CoA hydratase/isomerase', 355, NULL, NULL, 146665),
(146666, '3.30.830.10-FF-000315', NULL, 'Mitochondrial Processing Peptidase Alpha', 148, NULL, NULL, 146666),
(146667, '3.90.70.10-FF-000389', NULL, 'Cysteine proteinases superfamily protein', 341, NULL, NULL, 146667),
(146668, '1.25.40.10-FF-004673', NULL, 'Pentatricopeptide repeat-containing protein', 225, NULL, NULL, 146668),
(146669, '3.30.565.10-FF-000384', NULL, 'Sensor histidine kinase', 146, NULL, NULL, 146669),
(146670, '1.10.4180.10-FF-000001', NULL, 'Transcription factor floricaula/leafy', 170, NULL, NULL, 146670),
(146671, '3.30.450.190-FF-000006', NULL, 'GTR1p Cytoplasmic GTPase', 119, NULL, NULL, 146671),
(146672, '3.80.10.10-FF-003691', NULL, 'SYM-1 protein', 300, NULL, NULL, 146672),
(146673, '1.10.238.10-FF-001131', NULL, 'Uncharacterized protein', 158, NULL, NULL, 146673),
(146674, '3.30.160.60-FF-000970', NULL, 'zinc finger protein 333 isoform X2', 27, NULL, NULL, 146674),
(146675, '3.40.30.10-FF-000496', NULL, 'Uncharacterized protein', 124, NULL, NULL, 146675),
(146676, '3.40.30.10-FF-001114', NULL, 'Uncharacterized protein', 16, NULL, NULL, 146676),
(146677, '2.60.40.10-FF-005899', NULL, NULL, 69, NULL, NULL, 146677),
(146678, '3.40.190.10-FF-000342', NULL, 'ABC transporter substrate-binding protein', 102, NULL, NULL, 146678),
(146679, '3.90.780.10-FF-000022', NULL, 'Chromosome 1, whole genome shotgun sequence', 175, NULL, NULL, 146679),
(146680, '4.10.280.10-FF-000178', NULL, 'Uncharacterized protein', 88, NULL, NULL, 146680),
(146681, '1.20.58.60-FF-000091', NULL, 'dystrophin isoform X2', 114, NULL, NULL, 146681),
(146682, '1.10.940.10-FF-000032', NULL, 'Transcription antitermination protein NusB', 148, NULL, NULL, 146682),
(146683, '1.10.3930.10-FF-000003', NULL, 'Arginine deiminase', 87, NULL, NULL, 146683),
(146684, '1.10.510.10-FF-002675', NULL, NULL, 209, NULL, NULL, 146684),
(146685, '3.40.50.300-FF-006299', NULL, 'Predicted protein', 142, NULL, NULL, 146685),
(146686, '3.40.50.300-FF-006900', NULL, 'Uncharacterized protein', 239, NULL, NULL, 146686),
(146687, '1.25.40.20-FF-000770', NULL, 'Ankyrin repeat-containing protein ITN1', 174, NULL, NULL, 146687),
(146688, '3.90.1150.210-FF-000004', NULL, 'F-actin-capping protein subunit beta', 167, NULL, NULL, 146688),
(146689, '3.30.1010.10-FF-000005', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit beta', 152, NULL, NULL, 146689),
(146690, '2.60.120.260-FF-000262', NULL, 'Beta-galactosidase', 93, NULL, NULL, 146690),
(146691, '1.25.40.10-FF-003993', NULL, 'Uncharacterized protein', 213, NULL, NULL, 146691),
(146692, '1.25.40.10-FF-000856', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 151, NULL, NULL, 146692),
(146693, '1.20.58.70-FF-000094', NULL, 'AGAP008756-PA', 182, NULL, NULL, 146693),
(146694, '1.20.58.830-FF-000045', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 121, NULL, NULL, 146694),
(146695, '1.10.472.130-FF-000028', NULL, 'GM14172', 153, NULL, NULL, 146695),
(146696, '1.25.40.10-FF-000340', NULL, 'Cyclic nucleotide-binding domain protein', 127, NULL, NULL, 146696),
(146697, '3.40.50.1820-FF-001279', NULL, 'Uncharacterized protein', 297, NULL, NULL, 146697),
(146698, '2.70.98.10-FF-000063', NULL, 'Beta-galactosidase', 269, NULL, NULL, 146698),
(146699, '3.40.50.300-FF-002494', NULL, 'AFG1 family ATPase', 192, NULL, NULL, 146699),
(146700, '3.50.50.60-FF-000264', NULL, 'Ferrodoxin reductase-like protein', 183, NULL, NULL, 146700),
(146701, '3.30.160.60-FF-000661', NULL, 'paternally-expressed gene 3 protein-like', 27, NULL, NULL, 146701),
(146702, '3.30.200.20-FF-000260', NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', 112, NULL, NULL, 146702),
(146703, '3.30.565.10-FF-000075', NULL, 'MORC family CW-type zinc finger protein 4', 200, NULL, NULL, 146703),
(146704, '2.130.10.10-FF-001122', NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', 368, NULL, NULL, 146704),
(146705, '2.40.50.140-FF-000813', NULL, NULL, 126, NULL, NULL, 146705);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(146706, '1.10.630.10-FF-000121', NULL, 'Cytochrome P450, putative', 523, NULL, NULL, 146706),
(146707, '2.60.40.60-FF-000973', NULL, 'Uncharacterized protein', 127, NULL, NULL, 146707),
(146708, '2.130.10.10-FF-006057', NULL, 'LOC100145488 protein', 114, NULL, NULL, 146708),
(146709, '2.60.40.10-FF-003162', NULL, NULL, 98, NULL, NULL, 146709),
(146710, '2.60.40.10-FF-002246', NULL, 'Muscle M-line assembly protein unc-89', 101, NULL, NULL, 146710),
(146711, '2.60.260.20-FF-000119', NULL, 'Chaperone protein DNAj, putative', 99, NULL, NULL, 146711),
(146712, '2.40.30.10-FF-000094', NULL, 'Ribosomal protein', 18, NULL, NULL, 146712),
(146713, '3.90.550.10-FF-000729', NULL, 'Ceramide glucosyltransferase, putative', 252, NULL, NULL, 146713),
(146714, '3.40.50.300-FF-006237', NULL, 'Helicase swr1', 311, NULL, NULL, 146714),
(146715, '3.30.1050.10-FF-000013', NULL, 'Metallo-beta-lactamase superfamily', 130, NULL, NULL, 146715),
(146716, '3.40.350.10-FF-000006', NULL, 'FACT complex subunit SPT16', 171, NULL, NULL, 146716),
(146717, '3.30.420.40-FF-000248', NULL, 'Actin-related protein 5', 31, NULL, NULL, 146717),
(146718, '2.60.40.60-FF-000546', NULL, 'Cadherin 17, LI cadherin (liver-intestine)', 116, NULL, NULL, 146718),
(146719, '1.20.970.30-FF-000004', NULL, 'Uncharacterized protein', 47, NULL, NULL, 146719),
(146720, '3.80.20.20-FF-000070', NULL, 'Predicted protein', 154, NULL, NULL, 146720),
(146721, '3.30.70.360-FF-000022', NULL, 'Hippurate hydrolase', 115, NULL, NULL, 146721),
(146722, '3.30.870.10-FF-000172', NULL, 'Uncharacterized protein', 185, NULL, NULL, 146722),
(146723, '1.10.238.10-FF-000524', NULL, 'Mitochondrial Rho GTPase', 198, NULL, NULL, 146723),
(146724, '1.20.970.20-FF-000001', NULL, 'Surface composition regulator', 66, NULL, NULL, 146724),
(146725, '3.40.109.10-FF-000042', NULL, 'Nitroreductase family protein', 97, NULL, NULL, 146725),
(146726, '3.10.110.10-FF-000029', NULL, 'Ubiquitin conjugating enzyme E2 D3', 142, NULL, NULL, 146726),
(146727, '2.10.109.10-FF-000030', NULL, 'Signal peptidase I', 139, NULL, NULL, 146727),
(146728, '1.10.1410.10-FF-000098', NULL, 'Uncharacterized protein', 31, NULL, NULL, 146728),
(146729, '3.80.10.10-FF-002600', NULL, 'Leucine rich repeats and calponin homology domain containing 1', 69, NULL, NULL, 146729),
(146730, '3.40.47.10-FF-000135', NULL, 'Beta-ketoacyl synthase', 267, NULL, NULL, 146730),
(146731, '3.80.10.10-FF-001982', NULL, 'AT5g40470/K21I16_20', 202, NULL, NULL, 146731),
(146732, '3.30.110.20-FF-000022', NULL, 'AGR216Wp', 120, NULL, NULL, 146732),
(146733, '2.120.10.30-FF-000061', NULL, 'teneurin-2 isoform X1', 142, NULL, NULL, 146733),
(146734, '3.30.70.370-FF-000025', NULL, NULL, 125, NULL, NULL, 146734),
(146735, '3.90.1150.10-FF-000007', NULL, 'Glycine dehydrogenase (decarboxylating), mitochondrial', 139, NULL, NULL, 146735),
(146736, '2.40.30.10-FF-000346', NULL, 'U5 snRNP GTPase', 131, NULL, NULL, 146736),
(146737, '1.20.120.350-FF-000198', NULL, NULL, 145, NULL, NULL, 146737),
(146738, '1.10.3380.30-FF-000005', NULL, 'Ski2 like RNA helicase', 69, NULL, NULL, 146738),
(146739, '3.40.50.300-FF-004646', NULL, 'Methyl coenzyme M reductase system, component A2 homolog', 196, NULL, NULL, 146739),
(146740, '2.60.40.60-FF-000855', NULL, 'Uncharacterized protein', 58, NULL, NULL, 146740),
(146741, '3.30.230.120-FF-000021', NULL, NULL, 257, NULL, NULL, 146741),
(146742, '3.60.40.10-FF-000130', NULL, 'Related to PTC7-type 2C protein phosphatase', 176, NULL, NULL, 146742),
(146743, '1.10.10.10-FF-000186', NULL, 'AsnC family transcriptional regulator', 52, NULL, NULL, 146743),
(146744, '3.90.1150.220-FF-000007', NULL, 'Uncharacterized protein', 49, NULL, NULL, 146744),
(146745, '2.60.40.10-FF-002555', NULL, 'Titin homolog', 86, NULL, NULL, 146745),
(146746, '1.10.3380.20-FF-000002', NULL, 'helicase POLQ-like isoform X1', 178, NULL, NULL, 146746),
(146747, '3.30.1640.10-FF-000036', NULL, 'DNA helicase', 105, NULL, NULL, 146747),
(146748, '2.40.50.100-FF-000178', NULL, 'Acetoin dehydrogenase complex, E2 component, dihydrolipoamide acetyltransferase', 78, NULL, NULL, 146748);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(146749, '3.30.1370.10-FF-000161', NULL, 'RNA-binding protein rnc1', 80, NULL, NULL, 146749),
(146750, '1.25.40.20-FF-001023', NULL, 'Kinase, NEK', 171, NULL, NULL, 146750),
(146751, '2.40.160.20-FF-000038', NULL, 'Outer membrane protein P5', 194, NULL, NULL, 146751),
(146752, '3.10.20.90-FF-000762', NULL, 'Ras-interacting protein 1', 137, NULL, NULL, 146752),
(146753, '1.10.238.10-FF-000833', NULL, 'YALI0A20518p', 83, NULL, NULL, 146753),
(146754, '2.120.10.30-FF-000268', NULL, 'Lipoprotein receptor', 313, NULL, NULL, 146754),
(146755, '2.130.10.10-FF-003140', NULL, 'Intraflagellar transport 140', 246, NULL, NULL, 146755),
(146756, '3.40.50.300-FF-002185', NULL, 'DNA mismatch repair protein, putative', 304, NULL, NULL, 146756),
(146757, '1.25.40.280-FF-000005', NULL, 'pH-response regulator protein palC', 442, NULL, NULL, 146757),
(146758, '1.25.10.10-FF-000467', NULL, 'Beta-catenin-like protein 1', 376, NULL, NULL, 146758),
(146759, '2.20.100.10-FF-000002', NULL, 'Unc-5 netrin receptor C', 56, NULL, NULL, 146759),
(146760, '3.90.190.10-FF-000100', NULL, 'Phosphatase domain-containing paladin 1b', 242, NULL, NULL, 146760),
(146761, '1.20.89.10-FF-000001', NULL, 'Nitrogenase molybdenum-iron protein beta chain', 67, NULL, NULL, 146761),
(146762, '3.40.50.1820-FF-000514', NULL, 'Alpha/beta hydrolase', 284, NULL, NULL, 146762),
(146763, '2.40.160.10-FF-000035', NULL, 'OpdB proline porin', 415, NULL, NULL, 146763),
(146764, '1.20.1250.20-FF-001457', NULL, 'Major facilitator superfamily MFS_1', 228, NULL, NULL, 146764),
(146765, '1.25.40.10-FF-001020', NULL, 'Protein HLB1', 122, NULL, NULL, 146765),
(146766, '2.60.40.1120-FF-000071', NULL, 'Putative ferric aerobactin receptor', 75, NULL, NULL, 146766),
(146767, '3.30.460.80-FF-000009', NULL, 'NADH-quinone oxidoreductase subunit C', 131, NULL, NULL, 146767),
(146768, '2.30.29.30-FF-000220', NULL, 'methylosome subunit pICln isoform X1', 118, NULL, NULL, 146768),
(146769, '3.40.390.10-FF-000115', NULL, 'Matrix metallopeptidase 30', 257, NULL, NULL, 146769),
(146770, '3.40.50.1370-FF-000008', NULL, 'Ornithine carbamoyltransferase', 160, NULL, NULL, 146770),
(146771, '3.80.10.10-FF-001673', NULL, 'LRR receptor-like serine/threonine-protein kinase EFR', 72, NULL, NULL, 146771),
(146772, '3.30.160.60-FF-004713', NULL, NULL, 21, NULL, NULL, 146772),
(146773, '2.30.130.40-FF-000027', NULL, 'Lon protease', 113, NULL, NULL, 146773),
(146774, '3.30.465.10-FF-000011', NULL, 'Alkylglycerone-phosphate synthase', 120, NULL, NULL, 146774),
(146775, '3.30.70.1450-FF-000024', NULL, 'Chloride transporter, ClC family', 77, NULL, NULL, 146775),
(146776, '1.10.10.60-FF-001111', NULL, NULL, 65, NULL, NULL, 146776),
(146777, '3.90.550.10-FF-000286', NULL, 'PGL/p-HBAD biosynthesis glycosyltransferase BCG_2978', 219, NULL, NULL, 146777),
(146778, '3.40.50.300-FF-001066', NULL, 'DNA helicase INO80-like protein', 253, NULL, NULL, 146778),
(146779, '3.30.200.60-FF-000013', NULL, 'Ubiquitin thioesterase', 93, NULL, NULL, 146779),
(146780, '1.25.10.10-FF-000512', NULL, 'Pumilio homology domain family member 6', 256, NULL, NULL, 146780),
(146781, '3.40.50.720-FF-002254', NULL, 'Predicted protein', 67, NULL, NULL, 146781),
(146782, '3.30.70.2010-FF-000001', NULL, '2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-succinyltransferase', 131, NULL, NULL, 146782),
(146783, '2.60.40.10-FF-002038', NULL, 'Basement membrane proteoglycan', 88, NULL, NULL, 146783),
(146784, '3.10.129.10-FF-000201', NULL, 'Fluoroacetyl-CoA thioesterase', 139, NULL, NULL, 146784),
(146785, '1.20.58.2010-FF-000009', NULL, 'Rop guanine nucleotide exchange factor 7', 54, NULL, NULL, 146785),
(146786, '3.30.200.20-FF-000276', NULL, 'Receptor tyrosine-protein kinase erbB-3', 95, NULL, NULL, 146786),
(146787, '3.40.50.300-FF-006445', NULL, 'Uncharacterized protein', 124, NULL, NULL, 146787),
(146788, '3.40.1350.100-FF-000002', NULL, 'Protein TIC 22-like, chloroplastic', 75, NULL, NULL, 146788),
(146789, '2.60.120.260-FF-000228', NULL, 'E3 ubiquitin-protein ligase rpm-1', 153, NULL, NULL, 146789),
(146790, '3.90.70.10-FF-000535', NULL, 'Uncharacterized protein', 282, NULL, NULL, 146790);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(146791, '3.40.47.10-FF-000034', NULL, 'Acetyl-CoA acetyltransferase, cytosolic', 206, NULL, NULL, 146791),
(146792, '2.60.40.10-FF-004707', NULL, NULL, 97, NULL, NULL, 146792),
(146793, '3.30.2350.20-FF-000028', NULL, 'tRNA pseudouridine synthase, putative', 191, NULL, NULL, 146793),
(146794, '3.20.20.100-FF-000021', NULL, 'Hypothetical oxidoreductase YdbC', 280, NULL, NULL, 146794),
(146795, '3.30.160.60-FF-002768', NULL, 'Zinc finger protein 408', 28, NULL, NULL, 146795),
(146796, '2.170.140.10-FF-000003', NULL, 'Tequila, isoform D', 62, NULL, NULL, 146796),
(146797, '3.40.50.1820-FF-001487', NULL, 'LIPaSe related', 167, NULL, NULL, 146797),
(146798, '3.90.920.10-FF-000011', NULL, 'DNA primase small subunit PriS', 329, NULL, NULL, 146798),
(146799, '2.60.40.10-FF-002908', NULL, 'Uncharacterized protein', 108, NULL, NULL, 146799),
(146800, '3.40.50.300-FF-001420', NULL, 'ADP-ribosylation factor 4a', 71, NULL, NULL, 146800),
(146801, '1.10.10.10-FF-000540', NULL, 'DNA-binding transcriptional activator BglJ', 91, NULL, NULL, 146801),
(146802, '3.10.180.10-FF-000084', NULL, '4-hydroxyphenylpyruvate dioxygenase', 162, NULL, NULL, 146802),
(146803, '3.40.30.10-FF-000951', NULL, 'Uncharacterized protein', 107, NULL, NULL, 146803),
(146804, '3.30.420.40-FF-000456', NULL, 'Actin related protein', 40, NULL, NULL, 146804),
(146805, '3.40.50.300-FF-002746', NULL, 'ABC transporter ATP-binding protein', 243, NULL, NULL, 146805),
(146806, '3.40.50.1820-FF-000205', NULL, 'Non-haem bromoperoxidase BPO-A2', 273, NULL, NULL, 146806),
(146807, '2.170.300.10-FF-000010', NULL, 'Scavenger receptor class F member 2', 124, NULL, NULL, 146807),
(146808, '1.10.110.10-FF-000020', NULL, 'Trypsin inhibitor CMe', 125, NULL, NULL, 146808),
(146809, '3.40.50.2300-FF-000041', NULL, 'Low molecular weight protein-tyrosine-phosphatase', 145, NULL, NULL, 146809),
(146810, '1.25.40.20-FF-000197', NULL, 'protein fem-1 homolog B', 81, NULL, NULL, 146810),
(146811, '3.30.70.330-FF-000480', NULL, 'Fne, isoform A', 97, NULL, NULL, 146811),
(146812, '1.20.120.180-FF-000006', NULL, 'Proteasome activator complex subunit 3', 42, NULL, NULL, 146812),
(146813, '2.130.10.10-FF-000217', NULL, 'Lysosomal trafficking regulator', 98, NULL, NULL, 146813),
(146814, '3.30.230.70-FF-000169', NULL, 'Uncharacterized protein', 126, NULL, NULL, 146814),
(146815, '1.25.40.20-FF-000668', NULL, 'Uncharacterized protein', 163, NULL, NULL, 146815),
(146816, '1.25.40.10-FF-000194', NULL, 'Tetratricopeptide repeat domain 5', 279, NULL, NULL, 146816),
(146817, '3.50.50.60-FF-000707', NULL, 'Tryptophan halogenase', 431, NULL, NULL, 146817),
(146818, '3.30.420.40-FF-000810', NULL, 'SWI/SNF and RSC complexes subunit arp9', 70, NULL, NULL, 146818),
(146819, '1.20.1250.20-FF-001867', NULL, 'Siderophore iron transporter mirA', 247, NULL, NULL, 146819),
(146820, '1.10.238.10-FF-000316', NULL, 'Calcium-binding EF hand family protein', 150, NULL, NULL, 146820),
(146821, '3.55.40.20-FF-000022', NULL, 'Superoxide dismutase', 117, NULL, NULL, 146821),
(146822, '2.160.20.10-FF-000109', NULL, 'Hemagglutination activity domain protein', 396, NULL, NULL, 146822),
(146823, '3.30.420.40-FF-000911', NULL, 'Uncharacterized protein', 66, NULL, NULL, 146823),
(146824, '3.40.1360.10-FF-000057', NULL, 'DNA primase', 122, NULL, NULL, 146824),
(146825, '3.40.630.10-FF-000270', NULL, 'Peptide hydrolase', 258, NULL, NULL, 146825),
(146826, '3.40.30.10-FF-000597', NULL, 'Thioredoxin-like protein CXXS1', 115, NULL, NULL, 146826),
(146827, '3.30.70.330-FF-001817', NULL, NULL, 120, NULL, NULL, 146827),
(146828, '2.130.10.10-FF-004775', NULL, 'Uncharacterized protein', 154, NULL, NULL, 146828),
(146829, '3.30.70.330-FF-002323', NULL, NULL, 116, NULL, NULL, 146829),
(146830, '1.10.510.10-FF-002574', NULL, NULL, 242, NULL, NULL, 146830),
(146831, '2.60.40.10-FF-004808', NULL, NULL, 84, NULL, NULL, 146831),
(146832, '3.30.1320.10-FF-000006', NULL, '30S ribosomal protein S16', 180, NULL, NULL, 146832),
(146833, '3.30.497.10-FF-000028', NULL, 'Serine proteinase inhibitor 2', 107, NULL, NULL, 146833);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(146834, '3.60.21.10-FF-000148', NULL, 'Serine/threonine-protein phosphatase', 466, NULL, NULL, 146834),
(146835, '2.160.20.60-FF-000001', NULL, 'Glutamate synthase, large subunit', 272, NULL, NULL, 146835),
(146836, '3.30.40.10-FF-000154', NULL, 'PHD finger protein 12', 85, NULL, NULL, 146836),
(146837, '3.30.230.10-FF-000213', NULL, 'Mevalonate kinase', 199, NULL, NULL, 146837),
(146838, '2.10.25.10-FF-000976', NULL, 'Low-density lipoprotein RecePtor related', 52, NULL, NULL, 146838),
(146839, '2.40.50.730-FF-000013', NULL, 'DNA polymerase', 68, NULL, NULL, 146839),
(146840, '3.40.50.12780-FF-000210', NULL, 'Folliculin-interacting protein 1', 216, NULL, NULL, 146840),
(146841, '3.40.50.2300-FF-000131', NULL, 'Piwi-like RNA-mediated gene silencing 1', 128, NULL, NULL, 146841),
(146842, '3.30.1330.20-FF-000038', NULL, 'Tubulin alpha chain', 115, NULL, NULL, 146842),
(146843, '1.20.1250.10-FF-000010', NULL, 'Macrophage colony-stimulating factor 1', 154, NULL, NULL, 146843),
(146844, '2.40.160.90-FF-000002', NULL, 'Transferrin-binding protein 2', 208, NULL, NULL, 146844),
(146845, '1.20.1250.20-FF-000013', NULL, 'MFS general substrate transporter', 189, NULL, NULL, 146845),
(146846, '1.20.1520.10-FF-000003', NULL, 'GM24123', 136, NULL, NULL, 146846),
(146847, '3.40.50.10860-FF-000067', NULL, 'Bifunctional protein FolD', 149, NULL, NULL, 146847),
(146848, '3.40.50.1820-FF-001588', NULL, 'Uncharacterized protein', 91, NULL, NULL, 146848),
(146849, '3.10.20.90-FF-000806', NULL, 'Uncharacterized protein', 89, NULL, NULL, 146849),
(146850, '3.30.200.20-FF-002176', NULL, 'Predicted protein', 60, NULL, NULL, 146850),
(146851, '1.25.40.10-FF-002094', NULL, 'Pentatricopeptide repeat-containing protein', 123, NULL, NULL, 146851),
(146852, '1.10.3430.10-FF-000009', NULL, 'Blood group Rh(D) polypeptide', 414, NULL, NULL, 146852),
(146853, '3.90.1310.10-FF-000014', NULL, 'Penicillin-binding protein 2', 186, NULL, NULL, 146853),
(146854, '3.40.50.300-FF-003320', NULL, 'Rho family GTPase', 196, NULL, NULL, 146854),
(146855, '3.30.1330.10-FF-000035', NULL, 'Phosphoribosylformylglycinamidine synthase', 211, NULL, NULL, 146855),
(146856, '3.70.10.10-FF-000145', NULL, 'Uncharacterized protein', 154, NULL, NULL, 146856),
(146857, '3.90.190.20-FF-000058', NULL, 'Bifunctional folylpolyglutamate synthase/dihydrofolate synthase', 134, NULL, NULL, 146857),
(146858, '1.25.10.10-FF-000366', NULL, 'DnaJ homolog subfamily C GRV2', 246, NULL, NULL, 146858),
(146859, '3.40.50.300-FF-004545', NULL, 'ATP synthase subunit alpha', 212, NULL, NULL, 146859),
(146860, '2.60.40.1400-FF-000031', NULL, NULL, 195, NULL, NULL, 146860),
(146861, '2.30.42.10-FF-000413', NULL, NULL, 61, NULL, NULL, 146861),
(146862, '3.40.1410.10-FF-000016', NULL, 'Probable transcriptional regulator', 160, NULL, NULL, 146862),
(146863, '3.30.50.10-FF-000126', NULL, 'Steroid hormone receptor 3', 148, NULL, NULL, 146863),
(146864, '1.25.10.10-FF-002827', NULL, 'Uncharacterized protein', 188, NULL, NULL, 146864),
(146865, '1.20.1280.290-FF-000031', NULL, 'Mannose-P-dolichol utilization defect 1', 88, NULL, NULL, 146865),
(146866, '1.20.900.10-FF-000050', NULL, 'Guanine nucleotide exchange factor', 224, NULL, NULL, 146866),
(146867, '3.30.450.40-FF-000284', NULL, 'Phosphodiesterase', 73, NULL, NULL, 146867),
(146868, '1.20.1420.30-FF-000052', NULL, 'Potassium-dependent sodium-calcium exchanger, putative', 151, NULL, NULL, 146868),
(146869, '3.30.40.10-FF-001582', NULL, 'E3 ubiquitin-protein ligase RMA3', 123, NULL, NULL, 146869),
(146870, '3.60.21.10-FF-000457', NULL, 'Serine/threonine-protein phosphatase', 319, NULL, NULL, 146870),
(146871, '1.10.10.60-FF-000515', NULL, 'Transcription factor MYB7', 92, NULL, NULL, 146871),
(146872, '1.10.10.60-FF-001021', NULL, NULL, 67, NULL, NULL, 146872),
(146873, '3.30.465.10-FF-000101', NULL, 'Uncharacterized protein', 256, NULL, NULL, 146873),
(146874, '2.60.40.790-FF-000182', NULL, NULL, 121, NULL, NULL, 146874),
(146875, '3.40.50.720-FF-000500', NULL, 'Blast:Retinol dehydrogenase 14', 285, NULL, NULL, 146875),
(146876, '1.10.150.20-FF-000194', NULL, 'DNA polymerase IV', 51, NULL, NULL, 146876);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(146877, '2.40.20.10-FF-000065', NULL, 'Hepatocyte growth factor-like protein', 45, NULL, NULL, 146877),
(146878, '2.120.10.30-FF-000504', NULL, 'Uncharacterized protein', 214, NULL, NULL, 146878),
(146879, '3.40.190.10-FF-000460', NULL, 'Glutamate receptor 2.8', 62, NULL, NULL, 146879),
(146880, '3.30.70.330-FF-002632', NULL, NULL, 125, NULL, NULL, 146880),
(146881, '3.40.50.1820-FF-001633', NULL, 'Carboxylic ester hydrolase', 447, NULL, NULL, 146881),
(146882, '2.60.120.1190-FF-000018', NULL, 'Discoidin domain receptor tyrosine kinase 1', 97, NULL, NULL, 146882),
(146883, '1.10.8.270-FF-000076', NULL, 'Rab GTPase activating protein, putative', 123, NULL, NULL, 146883),
(146884, '2.40.10.10-FF-000446', NULL, NULL, 79, NULL, NULL, 146884),
(146885, '2.30.240.10-FF-000004', NULL, 'At1g55265', 125, NULL, NULL, 146885),
(146886, '1.10.1070.11-FF-000078', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit, putative', 171, NULL, NULL, 146886),
(146887, '1.10.730.10-FF-000095', NULL, 'Leucine--tRNA ligase', 24, NULL, NULL, 146887),
(146888, '1.20.1250.20-FF-001912', NULL, 'Uncharacterized protein', 406, NULL, NULL, 146888),
(146889, '3.30.200.20-FF-000731', NULL, 'Glycogen synthase kinase 3', 88, NULL, NULL, 146889),
(146890, '3.90.1170.50-FF-000020', NULL, 'Uncharacterized protein', 74, NULL, NULL, 146890),
(146891, '3.40.390.10-FF-000071', NULL, 'Zinc metalloproteinase', 216, NULL, NULL, 146891),
(146892, '3.30.40.10-FF-000300', NULL, 'Bromodomain adjacent to zinc finger domain protein 1A', 94, NULL, NULL, 146892),
(146893, '3.40.50.300-FF-004293', NULL, 'Dephospho-CoA kinase', 201, NULL, NULL, 146893),
(146894, '1.20.1250.20-FF-001558', NULL, 'MFS transporter, putative', 398, NULL, NULL, 146894),
(146895, '4.10.1000.10-FF-000042', NULL, 'Gar2 protein', 51, NULL, NULL, 146895),
(146896, '1.10.510.10-FF-001040', NULL, 'Related to SSK2-MAP kinase kinase kinase of the high osmolarity signal transduction pathway', 315, NULL, NULL, 146896),
(146897, '2.130.10.10-FF-002566', NULL, 'Transcriptional corepressor (Eurofung)', 176, NULL, NULL, 146897),
(146898, '1.25.10.10-FF-000057', NULL, 'Exportin-2 isoform 1', 959, NULL, NULL, 146898),
(146899, '3.40.50.300-FF-003011', NULL, 'DNA repair helicase', 191, NULL, NULL, 146899),
(146900, '1.25.40.10-FF-002655', NULL, 'Cleavage stimulation factor subunit 3', 308, NULL, NULL, 146900),
(146901, '3.40.640.10-FF-000208', NULL, 'Decarboxylase, group II', 293, NULL, NULL, 146901),
(146902, '3.30.60.20-FF-000057', NULL, 'Ras association domain family member 5', 41, NULL, NULL, 146902),
(146903, '2.130.10.110-FF-000011', NULL, 'Clathrin heavy chain', 366, NULL, NULL, 146903),
(146904, '2.60.40.150-FF-000355', NULL, 'Protein CBR-SNT-7', 126, NULL, NULL, 146904),
(146905, '2.70.170.10-FF-000265', NULL, 'Uncharacterized protein', 138, NULL, NULL, 146905),
(146906, '3.90.70.10-FF-000283', NULL, 'Ubiquitinyl hydrolase 1', 234, NULL, NULL, 146906),
(146907, '3.20.20.100-FF-000111', NULL, 'Oxidoreductase', 279, NULL, NULL, 146907),
(146908, '2.60.40.10-FF-000756', NULL, 'Interleukin 1 receptor accessory protein', 115, NULL, NULL, 146908),
(146909, '3.40.1090.10-FF-000064', NULL, 'Patatin', 379, NULL, NULL, 146909),
(146910, '1.20.58.390-FF-000177', NULL, 'Uncharacterized protein', 146, NULL, NULL, 146910),
(146911, '1.20.1070.10-FF-001339', NULL, 'Predicted protein', 273, NULL, NULL, 146911),
(146912, '2.60.120.200-FF-000160', NULL, 'Laminin subunit alpha-3', 202, NULL, NULL, 146912),
(146913, '2.60.40.1170-FF-000068', NULL, 'Adaptor complex subunit medium chain 3', 142, NULL, NULL, 146913),
(146914, '2.110.10.10-FF-000044', NULL, 'LOC100127856 protein', 211, NULL, NULL, 146914),
(146915, '1.10.287.3990-FF-000011', NULL, 'Uncharacterized protein', 85, NULL, NULL, 146915),
(146916, '1.25.10.10-FF-002266', NULL, 'Uncharacterized protein', 343, NULL, NULL, 146916),
(146917, '3.90.79.10-FF-000038', NULL, 'Tudor-interacting repair regulator protein', 207, NULL, NULL, 146917),
(146918, '2.30.30.40-FF-000193', NULL, 'Rho guanine nucleotide exchange factor 38', 88, NULL, NULL, 146918); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(146919, '1.10.443.10-FF-000012', NULL, 'Phage integrase family', 192, NULL, NULL, 146919),
(146920, '3.30.1550.10-FF-000006', NULL, '50S ribosomal protein L11', 68, NULL, NULL, 146920),
(146921, '1.10.510.10-FF-004474', NULL, NULL, 263, NULL, NULL, 146921),
(146922, '1.25.40.1050-FF-000008', NULL, '5''-3'' exoribonuclease 1', 62, NULL, NULL, 146922),
(146923, '3.40.800.10-FF-000053', NULL, NULL, 320, NULL, NULL, 146923),
(146924, '3.40.50.300-FF-008036', NULL, 'Lon protease homolog', 135, NULL, NULL, 146924),
(146925, '1.10.10.60-FF-000206', NULL, 'transcription termination factor 1 isoform X1', 49, NULL, NULL, 146925),
(146926, '3.30.260.10-FF-000041', NULL, 'CG8258', 107, NULL, NULL, 146926),
(146927, '2.40.150.20-FF-000009', NULL, '50S ribosomal protein L14', 129, NULL, NULL, 146927),
(146928, '1.10.238.10-FF-001030', NULL, 'Uncharacterized protein', 61, NULL, NULL, 146928),
(146929, '3.40.30.10-FF-000849', NULL, 'Protein disulfide-isomerase', 105, NULL, NULL, 146929),
(146930, '2.60.40.10-FF-003061', NULL, 'Uncharacterized protein, isoform A', 99, NULL, NULL, 146930),
(146931, '3.40.50.2300-FF-000911', NULL, NULL, 134, NULL, NULL, 146931),
(146932, '1.10.10.10-FF-001012', NULL, 'PCI domain containing protein', 68, NULL, NULL, 146932),
(146933, '3.40.1280.10-FF-000101', NULL, 'Uncharacterized protein', 161, NULL, NULL, 146933),
(146934, '1.20.58.1030-FF-000013', NULL, 'DNA replication complex GINS protein PSF1, putative', 111, NULL, NULL, 146934),
(146935, '3.90.70.10-FF-000844', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 122, NULL, NULL, 146935),
(146936, '1.25.40.10-FF-002565', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 148, NULL, NULL, 146936),
(146937, '2.60.40.10-FF-000801', NULL, 'Tenascin-X', 86, NULL, NULL, 146937),
(146938, '3.40.50.300-FF-005118', NULL, 'Conserved component of ABC transporter for natural amino acids', 253, NULL, NULL, 146938),
(146939, '1.10.150.60-FF-000003', NULL, 'AT-rich interactive domain-containing protein 4B', 119, NULL, NULL, 146939),
(146940, '3.40.50.2300-FF-000602', NULL, 'C4-dicarboxylate transport transcriptional regulatory protein', 138, NULL, NULL, 146940),
(146941, '2.40.100.10-FF-000060', NULL, 'Probable peptidyl-prolyl cis-trans isomerase B', 180, NULL, NULL, 146941),
(146942, '3.40.630.40-FF-000020', NULL, 'Cell wall hydrolase/autolysin', 188, NULL, NULL, 146942),
(146943, '2.20.70.10-FF-000057', NULL, 'FERM and PDZ domain-containing protein 4', 33, NULL, NULL, 146943),
(146944, '3.10.450.10-FF-000077', NULL, 'Kininogen 2', 42, NULL, NULL, 146944),
(146945, '2.30.29.30-FF-000074', NULL, 'Oxysterol-binding protein', 99, NULL, NULL, 146945),
(146946, '3.40.50.300-FF-008345', NULL, 'Dynein heavy chain family protein', 182, NULL, NULL, 146946),
(146947, '3.90.550.50-FF-000073', NULL, 'Hexosyltransferase', 211, NULL, NULL, 146947),
(146948, '2.60.40.1180-FF-000173', NULL, 'Alpha-mannosidase', 98, NULL, NULL, 146948),
(146949, '3.30.40.10-FF-001492', NULL, 'Uncharacterized protein', 79, NULL, NULL, 146949),
(146950, '1.10.3120.10-FF-000008', NULL, 'Trigger factor', 208, NULL, NULL, 146950),
(146951, '2.130.10.10-FF-004820', NULL, 'Uncharacterized protein', 138, NULL, NULL, 146951),
(146952, '3.30.1330.60-FF-000033', NULL, 'DUF3868 domain-containing protein', 147, NULL, NULL, 146952),
(146953, '2.60.120.20-FF-000025', NULL, 'Genome polyprotein', 272, NULL, NULL, 146953),
(146954, '1.10.510.10-FF-004165', NULL, NULL, 189, NULL, NULL, 146954),
(146955, '2.10.25.10-FF-001791', NULL, 'Uncharacterized protein', 30, NULL, NULL, 146955),
(146956, '1.10.3210.10-FF-000027', NULL, 'Urea hydro-lyase/cyanamide hydratase', 163, NULL, NULL, 146956),
(146957, '2.60.200.20-FF-000083', NULL, 'AFaDin (Actin filament binding protein) homolog', 113, NULL, NULL, 146957),
(146958, '3.40.50.150-FF-001240', NULL, NULL, 91, NULL, NULL, 146958),
(146959, '2.60.40.150-FF-000445', NULL, 'GTPase activating protein involved in bud site selection, putative', 129, NULL, NULL, 146959),
(146960, '3.40.800.20-FF-000056', NULL, 'Mannose-6-phosphate isomerase 1', 158, NULL, NULL, 146960);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(146961, '3.20.20.120-FF-000027', NULL, 'Mandelate racemase/muconate lactonizing protein', 242, NULL, NULL, 146961),
(146962, '3.40.50.720-FF-001782', NULL, 'Acetohydroxy acid isomeroreductase', 227, NULL, NULL, 146962),
(146963, '1.10.287.550-FF-000018', NULL, 'Uncharacterized protein', 59, NULL, NULL, 146963),
(146964, '3.30.750.24-FF-000092', NULL, 'Putative anti-sigma factor antagonist TM_1081', 110, NULL, NULL, 146964),
(146965, '1.20.1560.10-FF-000949', NULL, 'Uncharacterized protein', 165, NULL, NULL, 146965),
(146966, '1.20.1440.370-FF-000002', NULL, 'Multifunctional virulence effector protein DrrA', 53, NULL, NULL, 146966),
(146967, '3.30.200.20-FF-000158', NULL, 'Serine/threonine-protein kinase 32A', 95, NULL, NULL, 146967),
(146968, '2.60.40.150-FF-000029', NULL, 'Intersectin 1', 125, NULL, NULL, 146968),
(146969, '3.60.21.10-FF-000367', NULL, 'Serine/threonine-protein phosphatase', 126, NULL, NULL, 146969),
(146970, '1.10.8.1190-FF-000002', NULL, 'ORF1ab polyprotein', 127, NULL, NULL, 146970),
(146971, '3.30.565.10-FF-000518', NULL, 'Uncharacterized protein', 131, NULL, NULL, 146971),
(146972, '3.40.50.880-FF-000059', NULL, '4-methyl-5(B-hydroxyethyl)-thiazole monophosphate biosynthesis enzyme', 174, NULL, NULL, 146972),
(146973, '3.90.1110.10-FF-000016', NULL, 'DNA-directed RNA polymerase subunit beta', 173, NULL, NULL, 146973),
(146974, '3.30.160.60-FF-004792', NULL, NULL, 65, NULL, NULL, 146974),
(146975, '3.30.70.270-FF-000220', NULL, NULL, 91, NULL, NULL, 146975),
(146976, '1.20.1250.20-FF-001648', NULL, 'MFS peptide transporter, putative', 473, NULL, NULL, 146976),
(146977, '3.40.50.1000-FF-000640', NULL, NULL, 161, NULL, NULL, 146977),
(146978, '1.20.58.390-FF-000278', NULL, 'Uncharacterized protein', 63, NULL, NULL, 146978),
(146979, '1.10.510.10-FF-000983', NULL, 'Fibroblast growth factor receptor homolog 2', 213, NULL, NULL, 146979),
(146980, '1.25.10.10-FF-000922', NULL, 'HEAT repeat domain containing protein', 1073, NULL, NULL, 146980),
(146981, '2.60.120.10-FF-000298', NULL, 'Cyclic Nucleotide Gated channel', 138, NULL, NULL, 146981),
(146982, '3.40.50.10900-FF-000006', NULL, 'Proteasome assembly chaperone 2', 139, NULL, NULL, 146982),
(146983, '1.10.510.10-FF-004249', NULL, NULL, 194, NULL, NULL, 146983),
(146984, '2.130.10.10-FF-004904', NULL, 'Uncharacterized protein', 111, NULL, NULL, 146984),
(146985, '3.30.230.70-FF-000063', NULL, 'Exosome complex component RRP45B', 196, NULL, NULL, 146985),
(146986, '3.40.50.300-FF-004085', NULL, 'F-box only protein 9', 35, NULL, NULL, 146986),
(146987, '1.20.58.1880-FF-000021', NULL, 'Chromatin complexes subunit BAP18', 64, NULL, NULL, 146987),
(146988, '1.20.58.480-FF-000007', NULL, 'Tryptophan 2,3-dioxygenase', 251, NULL, NULL, 146988),
(146989, '1.25.40.10-FF-002548', NULL, 'Pentatricopeptide repeat-containing protein At2g46050, mitochondrial', 213, NULL, NULL, 146989),
(146990, '1.10.10.10-FF-001849', NULL, 'Uncharacterized protein', 81, NULL, NULL, 146990),
(146991, '2.60.40.10-FF-004247', NULL, NULL, 106, NULL, NULL, 146991),
(146992, '3.40.50.1100-FF-000198', NULL, 'Predicted protein', 62, NULL, NULL, 146992),
(146993, '3.40.50.150-FF-000526', NULL, 'FtsJ-like methyltransferase family protein', 184, NULL, NULL, 146993),
(146994, '3.40.50.300-FF-003090', NULL, 'GTP-binding protein, Ras family protein', 177, NULL, NULL, 146994),
(146995, '2.130.10.10-FF-000633', NULL, 'Small nucleolar ribonucleoprotein complex subunit Utp15, putative', 175, NULL, NULL, 146995),
(146996, '3.40.190.10-FF-000196', NULL, 'Amino acid ABC transporter', 93, NULL, NULL, 146996),
(146997, '1.25.10.10-FF-000276', NULL, 'Regulatory-associated protein of mTOR isoform 1', 250, NULL, NULL, 146997),
(146998, '3.90.1530.30-FF-000008', NULL, 'Probable plasmid partitioning protein, ParB1', 75, NULL, NULL, 146998),
(146999, '1.10.560.10-FF-000059', NULL, 'Uncharacterized protein', 215, NULL, NULL, 146999),
(147000, '3.40.30.10-FF-001086', NULL, 'Glutaredoxin/malate transporter fusion protein', 111, NULL, NULL, 147000),
(147001, '3.30.200.20-FF-002305', NULL, 'Uncharacterized protein', 185, NULL, NULL, 147001);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(147002, '2.60.40.420-FF-000003', NULL, 'Blue copper', 106, NULL, NULL, 147002),
(147003, '3.20.20.220-FF-000057', NULL, 'Methylenetetrahydrofolate reductase', 278, NULL, NULL, 147003),
(147004, '3.90.1290.10-FF-000079', NULL, 'Uncharacterized protein', 98, NULL, NULL, 147004),
(147005, '2.130.10.30-FF-000043', NULL, 'Guanidine nucleotide exchange factor', 268, NULL, NULL, 147005),
(147006, '1.25.10.10-FF-000383', NULL, 'armadillo repeat-containing protein 4', 159, NULL, NULL, 147006),
(147007, '2.40.180.10-FF-000025', NULL, 'Catalase-related peroxidase', 209, NULL, NULL, 147007),
(147008, '2.60.120.260-FF-000346', NULL, 'Alpha-1,3-mannosyl-glycoprotein 4-beta-N-acetylglucosaminyltransferase C', 133, NULL, NULL, 147008),
(147009, '3.90.70.10-FF-000299', NULL, 'Os03g0192800 protein', 218, NULL, NULL, 147009),
(147010, '3.30.200.20-FF-002412', NULL, 'Cullin-associated NEDD8-dissociated protein 1', 88, NULL, NULL, 147010),
(147011, '1.20.1070.10-FF-001917', NULL, 'Uncharacterized protein', 282, NULL, NULL, 147011),
(147012, '1.10.3470.10-FF-000001', NULL, 'Vitamin B12 ABC transporter permease BtuC', 330, NULL, NULL, 147012),
(147013, '3.30.530.20-FF-000037', NULL, 'Coenzyme Q-binding protein COQ10, mitochondrial', 147, NULL, NULL, 147013),
(147014, '1.20.140.150-FF-000092', NULL, 'Claudin domain containing 2', 100, NULL, NULL, 147014),
(147015, '3.90.1170.10-FF-000025', NULL, 'Uncharacterized protein', 69, NULL, NULL, 147015),
(147016, '1.10.10.60-FF-000622', NULL, 'DNA-binding transcriptional regulator', 53, NULL, NULL, 147016),
(147017, '2.60.40.10-FF-004926', NULL, NULL, 103, NULL, NULL, 147017),
(147018, '3.90.550.10-FF-000639', NULL, 'Predicted protein', 176, NULL, NULL, 147018),
(147019, '3.10.310.10-FF-000011', NULL, 'Diaminopimelate epimerase, chloroplastic', 150, NULL, NULL, 147019),
(147020, '1.20.120.430-FF-000008', NULL, 'tRNA modification GTPase MnmE', 164, NULL, NULL, 147020),
(147021, '2.130.10.10-FF-004691', NULL, 'Ribosome biogenesis protein BOP1 homolog', 176, NULL, NULL, 147021),
(147022, '2.30.29.30-FF-001294', NULL, 'Predicted protein', 88, NULL, NULL, 147022),
(147023, '1.10.510.10-FF-004356', NULL, NULL, 114, NULL, NULL, 147023),
(147024, '3.40.190.290-FF-000042', NULL, 'ArgP/LysG family DNA-binding transcriptional regulator', 223, NULL, NULL, 147024),
(147025, '3.10.110.10-FF-000265', NULL, 'Ubiquitin-conjugating enzyme, putative', 252, NULL, NULL, 147025),
(147026, '2.30.29.30-FF-000310', NULL, 'FACT complex subunit POB3', 91, NULL, NULL, 147026),
(147027, '2.60.40.1760-FF-000015', NULL, 'Glucosidase, putative', 227, NULL, NULL, 147027),
(147028, '1.10.287.1490-FF-000155', NULL, 'Uncharacterized protein', 160, NULL, NULL, 147028),
(147029, '2.10.25.10-FF-001690', NULL, 'Uncharacterized protein', 43, NULL, NULL, 147029),
(147030, '3.90.1150.10-FF-000125', NULL, 'Putative serine hydroxymethyltransferase', 147, NULL, NULL, 147030),
(147031, '1.10.630.10-FF-000031', NULL, 'cholesterol 24-hydroxylase isoform X2', 445, NULL, NULL, 147031),
(147032, '3.30.460.20-FF-000008', NULL, 'Cobalt/magnesium transport protein CorA', 165, NULL, NULL, 147032),
(147033, '2.40.160.50-FF-000030', NULL, 'Slr1661 protein', 368, NULL, NULL, 147033),
(147034, '1.20.1070.10-FF-002053', NULL, 'Olfactory receptor', 98, NULL, NULL, 147034),
(147035, '3.80.30.20-FF-000025', NULL, 'Radical SAM domain protein', 220, NULL, NULL, 147035),
(147036, '1.10.1450.10-FF-000090', NULL, 'Tetraspanin', 127, NULL, NULL, 147036),
(147037, '2.70.170.10-FF-000164', NULL, 'Neurotransmitter gated ion channel, putative', 103, NULL, NULL, 147037),
(147038, '2.130.10.10-FF-001032', NULL, 'SNRNP40 isoform 5', 101, NULL, NULL, 147038),
(147039, '2.40.10.350-FF-000003', NULL, 'Cell shape-determining protein MreC', 79, NULL, NULL, 147039),
(147040, '2.70.150.10-FF-000157', NULL, 'Os01g0869100 protein', 75, NULL, NULL, 147040),
(147041, '1.20.120.420-FF-000005', NULL, 'Methylthioribose-1-phosphate isomerase', 148, NULL, NULL, 147041),
(147042, '3.40.50.720-FF-001681', NULL, 'Oxidoreductase, putative', 95, NULL, NULL, 147042);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(147043, '2.130.10.10-FF-000526', NULL, 'Protein transport protein SEC31', 336, NULL, NULL, 147043),
(147044, '3.80.10.10-FF-003674', NULL, 'Uncharacterized protein', 214, NULL, NULL, 147044),
(147045, '3.30.750.24-FF-000103', NULL, 'Sulfate transporter', 130, NULL, NULL, 147045),
(147046, '3.30.379.10-FF-000007', NULL, 'Alpha-glucuronidase A', 119, NULL, NULL, 147046),
(147047, '1.25.40.20-FF-000753', NULL, 'Uncharacterized protein', 77, NULL, NULL, 147047),
(147048, '1.10.510.10-FF-001978', NULL, 'Kinase, CMGC CDK', 263, NULL, NULL, 147048),
(147049, '3.40.30.10-FF-001193', NULL, 'Iodothyronine deiodinase', 88, NULL, NULL, 147049),
(147050, '3.30.50.10-FF-000019', NULL, 'Nuclear receptor subfamily 2 group E member', 105, NULL, NULL, 147050),
(147051, '2.60.40.10-FF-000981', NULL, 'Titin a', 90, NULL, NULL, 147051),
(147052, '2.10.110.10-FF-000336', NULL, 'Metalloprotease', 46, NULL, NULL, 147052),
(147053, '3.90.550.50-FF-000174', NULL, 'Hexosyltransferase', 257, NULL, NULL, 147053),
(147054, '3.30.40.10-FF-001789', NULL, 'PHD and RING finger domain-containing protein C126.07c', 86, NULL, NULL, 147054),
(147055, '3.30.70.330-FF-000406', NULL, 'Related to Nucleolar protein NOP4', 133, NULL, NULL, 147055),
(147056, '3.30.559.10-FF-000105', NULL, 'Transferase family protein', 215, NULL, NULL, 147056),
(147057, '1.25.40.10-FF-000750', NULL, 'Fanconi anemia group G protein', 410, NULL, NULL, 147057),
(147058, '3.40.50.1820-FF-000430', NULL, 'Carboxylic ester hydrolase', 538, NULL, NULL, 147058),
(147059, '2.60.40.10-FF-000874', NULL, 'Inducible T-cell costimulator', 126, NULL, NULL, 147059),
(147060, '3.30.70.260-FF-000110', NULL, 'Acetolactate synthase, small subunit', 76, NULL, NULL, 147060),
(147061, '4.10.60.10-FF-000070', NULL, 'Splicing factor, arginine/serine-rich 7', 77, NULL, NULL, 147061),
(147062, '2.10.110.10-FF-000229', NULL, 'LIM-domain containing phosphatase', 63, NULL, NULL, 147062),
(147063, '3.40.50.2000-FF-000355', NULL, 'Glycosyltransferase', 233, NULL, NULL, 147063),
(147064, '1.20.1060.10-FF-000001', NULL, 'DNA polymerase I', 116, NULL, NULL, 147064),
(147065, '2.40.70.10-FF-000539', NULL, NULL, 190, NULL, NULL, 147065),
(147066, '3.30.160.60-FF-004359', NULL, NULL, 31, NULL, NULL, 147066),
(147067, '3.30.70.270-FF-000113', NULL, 'DNA polymerase eta', 188, NULL, NULL, 147067),
(147068, '3.40.50.300-FF-002628', NULL, 'Cytoplasmic dynein 2 light intermediate chain 1', 187, NULL, NULL, 147068),
(147069, '1.10.150.530-FF-000007', NULL, '23S rRNA methyltransferase', 61, NULL, NULL, 147069),
(147070, '1.10.390.30-FF-000001', NULL, 'TRPM8 channel-associated factor 1', 153, NULL, NULL, 147070),
(147071, '3.30.2340.10-FF-000007', NULL, 'tRNA pseudouridine synthase D', 147, NULL, NULL, 147071),
(147072, '2.60.40.10-FF-000346', NULL, 'Tenascin C', 91, NULL, NULL, 147072),
(147073, '3.30.260.10-FF-000024', NULL, 'Chaperonin 60 subunit alpha 2 chloroplastic', 35, NULL, NULL, 147073),
(147074, '3.90.230.10-FF-000048', NULL, NULL, 105, NULL, NULL, 147074),
(147075, '3.40.50.80-FF-000225', NULL, 'Uncharacterized protein', 245, NULL, NULL, 147075),
(147076, '1.10.390.40-FF-000004', NULL, NULL, 69, NULL, NULL, 147076),
(147077, '2.30.42.10-FF-000166', NULL, 'Na(+)/H(+) exchange regulatory cofactor NHE-RF3 isoform X1', 107, NULL, NULL, 147077),
(147078, '3.30.160.60-FF-004466', NULL, NULL, 29, NULL, NULL, 147078),
(147079, '3.80.10.10-FF-003455', NULL, 'Uncharacterized protein', 241, NULL, NULL, 147079),
(147080, '3.40.50.300-FF-008137', NULL, 'Uncharacterized protein', 101, NULL, NULL, 147080),
(147081, '3.20.20.450-FF-000002', NULL, 'Cyclic di-GMP phosphodiesterase YhjH', 233, NULL, NULL, 147081),
(147082, '2.30.30.40-FF-000058', NULL, 'Disks large homolog 1 isoform X1', 101, NULL, NULL, 147082),
(147083, '3.30.420.40-FF-000720', NULL, 'Endoplasmic reticulum chaperone BiP', 215, NULL, NULL, 147083),
(147084, '3.10.110.10-FF-000372', NULL, 'Putative ATP-dependent RNA helicase ucp12', 118, NULL, NULL, 147084),
(147085, '3.40.5.10-FF-000005', NULL, '39S ribosomal protein L9, mitochondrial', 58, NULL, NULL, 147085);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(147086, '2.40.30.230-FF-000005', NULL, 'Regulator of nonsense transcripts 1 homolog', 91, NULL, NULL, 147086),
(147087, '3.80.10.10-FF-002044', NULL, 'Insulin-like growth factor-binding protein acid labile subunit', 76, NULL, NULL, 147087),
(147088, '3.40.850.10-FF-000224', NULL, 'Kinesin-like protein', 148, NULL, NULL, 147088),
(147089, '3.40.50.300-FF-007035', NULL, 'Predicted protein', 202, NULL, NULL, 147089),
(147090, '3.40.50.300-FF-001212', NULL, 'ATP-dependent dethiobiotin synthetase BioD', 222, NULL, NULL, 147090),
(147091, '3.40.50.1000-FF-000842', NULL, NULL, 69, NULL, NULL, 147091),
(147092, '3.30.70.3250-FF-000019', NULL, NULL, 116, NULL, NULL, 147092),
(147093, '3.30.1330.90-FF-000002', NULL, 'D-3-phosphoglycerate dehydrogenase', 138, NULL, NULL, 147093),
(147094, '2.60.40.10-FF-004617', NULL, NULL, 39, NULL, NULL, 147094),
(147095, '3.40.50.300-FF-000723', NULL, 'Guanylate-binding family protein', 279, NULL, NULL, 147095),
(147096, '3.40.50.11610-FF-000011', NULL, 'Oxoglutarate dehydrogenase (Succinyl-transferring), E1 component', 179, NULL, NULL, 147096),
(147097, '2.160.10.10-FF-000036', NULL, 'Acetyltransferase, CYSE/LACA/LPXA/NODL', 183, NULL, NULL, 147097),
(147098, '2.40.30.220-FF-000002', NULL, NULL, 112, NULL, NULL, 147098),
(147099, '2.30.170.40-FF-000013', NULL, '39S ribosomal protein L28, mitochondrial', 67, NULL, NULL, 147099),
(147100, '3.30.60.30-FF-000077', NULL, 'AGAP006282-PA', 58, NULL, NULL, 147100),
(147101, '2.70.20.10-FF-000024', NULL, 'DNA topoisomerase', 136, NULL, NULL, 147101),
(147102, '2.40.70.10-FF-000337', NULL, NULL, 165, NULL, NULL, 147102),
(147103, '3.30.160.60-FF-004157', NULL, NULL, 59, NULL, NULL, 147103),
(147104, '3.40.50.300-FF-000493', NULL, 'Guanine nucleotide-binding protein-like 3-like protein', 187, NULL, NULL, 147104),
(147105, '3.10.450.50-FF-000072', NULL, 'Nuclear transport factor 2, putative', 128, NULL, NULL, 147105),
(147106, '1.10.8.60-FF-000458', NULL, 'Peroxisome biogenesis protein peroxin 1 (Eurofung)', 132, NULL, NULL, 147106),
(147107, '2.40.100.10-FF-000161', NULL, 'Peptidyl-prolyl cis-trans isomerase', 101, NULL, NULL, 147107),
(147108, '2.10.25.10-FF-001701', NULL, 'Uncharacterized protein', 62, NULL, NULL, 147108),
(147109, '3.80.10.10-FF-003146', NULL, 'Preferentially expressed antigen in melanoma', 307, NULL, NULL, 147109),
(147110, '3.40.190.10-FF-000089', NULL, 'Thiamine ABC transporter substrate binding subunit', 146, NULL, NULL, 147110),
(147111, '2.60.200.20-FF-000228', NULL, 'Protein CBG04097', 81, NULL, NULL, 147111),
(147112, '1.25.40.10-FF-002239', NULL, 'Uncharacterized protein', 196, NULL, NULL, 147112),
(147113, '3.90.70.10-FF-000619', NULL, 'Uncharacterized protein', 145, NULL, NULL, 147113),
(147114, '1.25.40.10-FF-004263', NULL, 'Uncharacterized protein', 220, NULL, NULL, 147114),
(147115, '2.170.120.20-FF-000016', NULL, '50S ribosomal protein L25', 99, NULL, NULL, 147115),
(147116, '1.10.1600.10-FF-000034', NULL, 'ATP dependent DNA ligase 1', 97, NULL, NULL, 147116),
(147117, '3.30.70.1350-FF-000011', NULL, 'Unplaced genomic scaffold supercont1.174, whole genome shotgun sequence', 82, NULL, NULL, 147117),
(147118, '1.10.760.10-FF-000024', NULL, 'Di-heme cytochrome C peroxidase', 75, NULL, NULL, 147118),
(147119, '1.20.58.1480-FF-000024', NULL, 'Lon protease homolog, mitochondrial', 133, NULL, NULL, 147119),
(147120, '2.40.100.10-FF-000166', NULL, 'Uncharacterized protein', 52, NULL, NULL, 147120),
(147121, '1.10.472.10-FF-000085', NULL, 'Pho80p cyclin', 230, NULL, NULL, 147121),
(147122, '2.30.30.30-FF-000055', NULL, '50S ribosomal protein L2', 80, NULL, NULL, 147122),
(147123, '2.60.40.60-FF-000765', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1', 106, NULL, NULL, 147123),
(147124, '2.60.120.260-FF-000453', NULL, 'Uncharacterized protein', 68, NULL, NULL, 147124),
(147125, '1.10.12.70-FF-000011', NULL, NULL, 63, NULL, NULL, 147125),
(147126, '2.20.70.10-FF-000142', NULL, 'TransCription Elongation Regulator homolog', 70, NULL, NULL, 147126),
(147127, '1.10.60.40-FF-000001', NULL, 'Alkaline phosphatase', 86, NULL, NULL, 147127);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(147128, '2.60.490.10-FF-000010', NULL, 'Uncharacterized protein', 206, NULL, NULL, 147128),
(147129, '3.40.532.10-FF-000025', NULL, NULL, 236, NULL, NULL, 147129),
(147130, '3.40.50.11380-FF-000009', NULL, NULL, 144, NULL, NULL, 147130),
(147131, '1.20.1070.10-FF-000501', NULL, 'Olfactory receptor', 295, NULL, NULL, 147131),
(147132, '3.40.140.10-FF-000159', NULL, 'Histone H2A deubiquitinase MYSM1', 210, NULL, NULL, 147132),
(147133, '3.40.190.10-FF-000561', NULL, 'HTH-type transcriptional regulator PhcA', 105, NULL, NULL, 147133),
(147134, '3.60.21.10-FF-000474', NULL, 'Meiotic recombination 11', 298, NULL, NULL, 147134),
(147135, '1.10.10.10-FF-000068', NULL, 'RNA polymerase sigma factor', 69, NULL, NULL, 147135),
(147136, '1.10.340.70-FF-000015', NULL, 'Pro-Pol polyprotein', 93, NULL, NULL, 147136),
(147137, '3.40.50.300-FF-004764', NULL, 'tRNA modification GTPase TrmE', 173, NULL, NULL, 147137),
(147138, '3.40.50.2300-FF-000338', NULL, 'Branched-chain amino acid ABC transporter substrate-binding protein', 170, NULL, NULL, 147138),
(147139, '2.30.30.100-FF-000120', NULL, 'U7 snRNA-associated Sm protein LSm11', 104, NULL, NULL, 147139),
(147140, '3.40.50.2000-FF-000029', NULL, 'Sterol 3-beta-glucosyltransferase', 226, NULL, NULL, 147140),
(147141, '3.30.830.10-FF-000186', NULL, 'Mitochondrial-processing peptidase subunit alpha', 229, NULL, NULL, 147141),
(147142, '3.30.200.20-FF-000467', NULL, 'Leucine-rich repeat receptor-like protein kinase', 93, NULL, NULL, 147142),
(147143, '2.60.40.150-FF-000338', NULL, 'U5 small nuclear ribonucleoprotein helicase, putative', 110, NULL, NULL, 147143),
(147144, '1.25.10.10-FF-000585', NULL, '26S proteasome regulatory non-ATPase subunit', 436, NULL, NULL, 147144),
(147145, '3.30.470.30-FF-000063', NULL, 'DNA ligase', 215, NULL, NULL, 147145),
(147146, '1.25.40.10-FF-004802', NULL, 'Predicted protein', 165, NULL, NULL, 147146),
(147147, '3.40.50.11370-FF-000006', NULL, 'Inositol 1,3,4-trisphosphate 5/6-kinase 4', 126, NULL, NULL, 147147),
(147148, '2.130.10.10-FF-005995', NULL, 'Uncharacterized protein', 225, NULL, NULL, 147148),
(147149, '2.60.120.10-FF-000837', NULL, 'Cyclic nucleotide-gated cation channel subunit A-like Protein', 89, NULL, NULL, 147149),
(147150, '1.20.210.10-FF-000014', NULL, 'Probable intron-encoded endonuclease aI4', 269, NULL, NULL, 147150),
(147151, '3.40.50.150-FF-000296', NULL, 'Putative methyltransferase DDB_G0268948', 254, NULL, NULL, 147151),
(147152, '2.120.10.80-FF-000261', NULL, 'Predicted protein', 176, NULL, NULL, 147152),
(147153, '1.25.40.10-FF-004482', NULL, 'Uncharacterized protein', 102, NULL, NULL, 147153),
(147154, '3.20.20.100-FF-000004', NULL, 'Oxidoreductase, aldo/keto reductase', 322, NULL, NULL, 147154),
(147155, '2.60.40.10-FF-000655', NULL, 'brother of CDO isoform X1', 92, NULL, NULL, 147155),
(147156, '3.40.50.1000-FF-000533', NULL, NULL, 182, NULL, NULL, 147156),
(147157, '3.30.1010.10-FF-000084', NULL, 'Uncharacterized protein', 111, NULL, NULL, 147157),
(147158, '3.40.50.970-FF-000070', NULL, '2-oxoglutarate dehydrogenase E1 component', 370, NULL, NULL, 147158),
(147159, '3.30.160.60-FF-001610', NULL, 'transcription factor IIIA', 31, NULL, NULL, 147159),
(147160, '1.20.58.460-FF-000001', NULL, 'O-GlcNAcase NagJ', 129, NULL, NULL, 147160),
(147161, '3.30.60.20-FF-000074', NULL, 'Thymidine kinase', 45, NULL, NULL, 147161),
(147162, '3.40.50.1820-FF-001369', NULL, 'Uncharacterized protein', 226, NULL, NULL, 147162),
(147163, '1.10.1420.10-FF-000155', NULL, 'Protein CBR-MSH-2', 93, NULL, NULL, 147163),
(147164, '2.40.30.10-FF-000228', NULL, 'NADPH-dependent diflavin oxidoreductase 1', 51, NULL, NULL, 147164),
(147165, '3.30.470.20-FF-000060', NULL, 'Putative alpha-L-glutamate ligase homolog', 104, NULL, NULL, 147165),
(147166, '1.10.472.10-FF-000315', NULL, 'RNA polymerase II holoenzyme cyclin-like subunit', 102, NULL, NULL, 147166),
(147167, '3.40.50.11060-FF-000003', NULL, 'GTP-binding protein chloroplastic', 114, NULL, NULL, 147167),
(147168, '3.30.1010.10-FF-000123', NULL, 'Frap1 protein', 60, NULL, NULL, 147168);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(147169, '2.30.30.40-FF-000530', NULL, 'BAR domaincontaining protein', 64, NULL, NULL, 147169),
(147170, '2.160.20.10-FF-000334', NULL, 'Uncharacterized protein', 327, NULL, NULL, 147170),
(147171, '2.40.50.140-FF-000257', NULL, 'Replication protein A subunit', 112, NULL, NULL, 147171),
(147172, '2.60.40.150-FF-000669', NULL, 'Predicted protein', 77, NULL, NULL, 147172),
(147173, '2.130.10.10-FF-004365', NULL, 'Gbp protein', 87, NULL, NULL, 147173),
(147174, '1.25.10.10-FF-002530', NULL, 'Uncharacterized protein', 189, NULL, NULL, 147174),
(147175, '3.30.1300.10-FF-000005', NULL, 'Pantothenate synthetase', 115, NULL, NULL, 147175),
(147176, '3.60.60.10-FF-000013', NULL, 'Choloylglycine hydrolase', 317, NULL, NULL, 147176),
(147177, '2.60.120.260-FF-000144', NULL, 'Probable beta-galactosidase C', 141, NULL, NULL, 147177),
(147178, '3.40.50.1820-FF-001739', NULL, 'Uncharacterized protein', 76, NULL, NULL, 147178),
(147179, '3.40.50.300-FF-004394', NULL, 'bifunctional heparan sulfate N-deacetylase/N-sulfotransferase 4', 300, NULL, NULL, 147179),
(147180, '3.20.20.80-FF-000224', NULL, 'Chitinase A', 333, NULL, NULL, 147180),
(147181, '3.40.47.10-FF-000253', NULL, 'Uncharacterized protein', 378, NULL, NULL, 147181),
(147182, '3.40.50.720-FF-000130', NULL, 'SDR family NAD(P)-dependent oxidoreductase', 268, NULL, NULL, 147182),
(147183, '1.20.210.10-FF-000019', NULL, 'Nitric oxide reductase large subunit-like protein', 525, NULL, NULL, 147183),
(147184, '1.10.238.10-FF-001221', NULL, 'Uncharacterized protein', 130, NULL, NULL, 147184),
(147185, '2.40.10.10-FF-000654', NULL, NULL, 104, NULL, NULL, 147185),
(147186, '1.10.10.10-FF-000287', NULL, 'Phosphonate utilization transcriptional regulator PhnR', 71, NULL, NULL, 147186),
(147187, '3.30.420.10-FF-000498', NULL, NULL, 145, NULL, NULL, 147187),
(147188, '2.130.10.10-FF-004674', NULL, 'Uncharacterized protein', 184, NULL, NULL, 147188),
(147189, '2.30.29.30-FF-001277', NULL, 'Uncharacterized protein', 96, NULL, NULL, 147189),
(147190, '2.30.30.1150-FF-000018', NULL, 'RING/FYVE/PHD zinc finger superfamily protein', 206, NULL, NULL, 147190),
(147191, '3.40.50.300-FF-002937', NULL, 'ATP-dependent RNA helicase', 217, NULL, NULL, 147191),
(147192, '2.60.40.2320-FF-000003', NULL, 'Type I pullulanase', 95, NULL, NULL, 147192),
(147193, '2.30.29.30-FF-000001', NULL, 'Erythrocyte membrane protein band 4.1', 95, NULL, NULL, 147193),
(147194, '2.10.110.10-FF-000027', NULL, 'lipoma-preferred partner isoform X1', 59, NULL, NULL, 147194),
(147195, '2.20.25.10-FF-000088', NULL, 'DNA-directed RNA polymerase subunit', 66, NULL, NULL, 147195),
(147196, '3.30.710.10-FF-000115', NULL, 'Kelch protein K13', 90, NULL, NULL, 147196),
(147197, '3.10.100.10-FF-000309', NULL, NULL, 166, NULL, NULL, 147197),
(147198, '1.10.510.10-FF-002467', NULL, NULL, 149, NULL, NULL, 147198),
(147199, '3.30.160.60-FF-003050', NULL, 'Potential zinc finger protein', 31, NULL, NULL, 147199),
(147200, '1.25.40.20-FF-000769', NULL, 'Ankyrin repeat domain 11', 176, NULL, NULL, 147200),
(147201, '1.20.1070.10-FF-000029', NULL, 'Frizzled class receptor 2', 359, NULL, NULL, 147201),
(147202, '1.10.1420.10-FF-000138', NULL, 'MutS domain III protein', 59, NULL, NULL, 147202),
(147203, '3.40.50.1000-FF-000516', NULL, 'ATPase 2, plasma membrane-type', 152, NULL, NULL, 147203),
(147204, '1.25.40.10-FF-000441', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 131, NULL, NULL, 147204),
(147205, '1.20.1540.10-FF-000004', NULL, 'Transmembrane protein 115', 200, NULL, NULL, 147205),
(147206, '3.90.70.10-FF-000726', NULL, 'Uncharacterized protein', 185, NULL, NULL, 147206),
(147207, '3.40.850.10-FF-000134', NULL, 'Kinesin-like protein', 401, NULL, NULL, 147207),
(147208, '3.10.100.10-FF-000074', NULL, 'C-type lectin domain family 1 member A', 187, NULL, NULL, 147208),
(147209, '2.120.10.30-FF-000167', NULL, 'Uncharacterized protein', 92, NULL, NULL, 147209),
(147210, '3.10.20.90-FF-000907', NULL, 'Uncharacterized protein', 43, NULL, NULL, 147210),
(147211, '3.60.10.10-FF-000302', NULL, 'Predicted protein', 320, NULL, NULL, 147211);
INSERT INTO "PUBLIC"."MODEL" VALUES
(147212, '3.30.830.10-FF-000169', NULL, 'Uncharacterized protein', 53, NULL, NULL, 147212),
(147213, '1.10.510.10-FF-002809', NULL, 'Serine/threonine-protein kinase PLK', 298, NULL, NULL, 147213),
(147214, '2.40.50.140-FF-000274', NULL, 'Mitochondrial RNA binding protein', 78, NULL, NULL, 147214),
(147215, '2.60.40.10-FF-001037', NULL, 'Usherin', 91, NULL, NULL, 147215),
(147216, '1.10.720.60-FF-000008', NULL, 'Enolase-phosphatase E1', 84, NULL, NULL, 147216),
(147217, '1.20.1280.140-FF-000003', NULL, 'Uncharacterized protein', 84, NULL, NULL, 147217),
(147218, '3.30.1520.10-FF-000061', NULL, 'Sorting nexin 1', 136, NULL, NULL, 147218),
(147219, '1.20.930.20-FF-000010', NULL, 'RING-type E3 ubiquitin transferase', 121, NULL, NULL, 147219),
(147220, '2.120.10.30-FF-000370', NULL, 'Uncharacterized protein', 259, NULL, NULL, 147220),
(147221, '3.80.10.10-FF-003365', NULL, 'GH16156p', 111, NULL, NULL, 147221),
(147222, '2.60.40.1120-FF-000054', NULL, 'nodal modulator 1', 80, NULL, NULL, 147222),
(147223, '3.40.50.300-FF-006872', NULL, 'Probable replicative DNA helicase', 250, NULL, NULL, 147223),
(147224, '1.20.140.80-FF-000006', NULL, 'Transcription factor Dp-1, a', 36, NULL, NULL, 147224),
(147225, '3.90.226.10-FF-000050', NULL, 'ATP-dependent Clp protease proteolytic subunit', 194, NULL, NULL, 147225),
(147226, '3.40.50.1820-FF-001734', NULL, 'Predicted protein', 91, NULL, NULL, 147226),
(147227, '3.90.1110.10-FF-000033', NULL, NULL, 123, NULL, NULL, 147227),
(147228, '3.40.1000.10-FF-000019', NULL, 'Hemochromatosis type 2', 154, NULL, NULL, 147228),
(147229, '1.10.720.40-FF-000002', NULL, 'Thymopoietin isoform alpha', 57, NULL, NULL, 147229),
(147230, '1.25.10.10-FF-002165', NULL, 'Utp20p', 504, NULL, NULL, 147230),
(147231, '2.60.120.260-FF-000363', NULL, 'Predicted protein', 197, NULL, NULL, 147231),
(147232, '2.60.40.10-FF-005798', NULL, NULL, 81, NULL, NULL, 147232),
(147233, '3.40.50.300-FF-006344', NULL, 'Uncharacterized protein', 41, NULL, NULL, 147233),
(147234, '1.10.510.10-FF-004266', NULL, NULL, 187, NULL, NULL, 147234),
(147235, '3.30.505.10-FF-000184', NULL, NULL, 84, NULL, NULL, 147235),
(147236, '2.60.40.10-FF-000565', NULL, 'Matrix metalloproteinase-23', 85, NULL, NULL, 147236),
(147237, '3.30.465.10-FF-000090', NULL, 'FAD binding oxidoreductase CpoX1', 223, NULL, NULL, 147237),
(147238, '3.30.710.10-FF-000222', NULL, 'Lola-like protein', 148, NULL, NULL, 147238),
(147239, '3.10.129.10-FF-000050', NULL, 'Acyl-CoA thioester hydrolase', 132, NULL, NULL, 147239),
(147240, '1.20.140.90-FF-000009', NULL, 'Uncharacterized protein', 82, NULL, NULL, 147240),
(147241, '3.30.160.60-FF-004483', NULL, NULL, 23, NULL, NULL, 147241),
(147242, '3.40.309.10-FF-000124', NULL, 'Aldehyde dehydrogenase, putative', 62, NULL, NULL, 147242),
(147243, '3.90.1600.10-FF-000014', NULL, 'DNA polymerase epsilon catalytic subunit', 166, NULL, NULL, 147243),
(147244, '1.10.10.10-FF-000764', NULL, 'MarR family transcriptional regulator', 130, NULL, NULL, 147244),
(147245, '2.130.10.10-FF-004921', NULL, 'Uncharacterized protein', 107, NULL, NULL, 147245),
(147246, '3.40.50.1000-FF-000168', NULL, 'D,D-heptose 1,7-bisphosphate phosphatase', 179, NULL, NULL, 147246),
(147247, '3.40.640.10-FF-000287', NULL, 'Uncharacterized protein', 68, NULL, NULL, 147247),
(147248, '3.30.160.60-FF-002919', NULL, 'Zinc finger protein 45', 26, NULL, NULL, 147248),
(147249, '1.20.140.150-FF-000119', NULL, 'uncharacterized protein LOC100181662', 117, NULL, NULL, 147249),
(147250, '1.25.40.10-FF-004128', NULL, 'Uncharacterized protein', 122, NULL, NULL, 147250),
(147251, '3.30.40.10-FF-001935', NULL, 'Uncharacterized protein', 70, NULL, NULL, 147251),
(147252, '2.120.10.10-FF-000026', NULL, 'VPS10 domain-containing receptor SorCS1', 145, NULL, NULL, 147252),
(147253, '2.120.10.80-FF-000042', NULL, 'Serine/threonine-protein phosphatase', 185, NULL, NULL, 147253),
(147254, '2.170.120.12-FF-000021', NULL, 'DNA-directed RNA polymerase subunit alpha', 124, NULL, NULL, 147254),
(147255, '3.30.497.10-FF-000135', NULL, 'Secreted salivary gland peptide, putative', 34, NULL, NULL, 147255);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(147256, '3.30.160.60-FF-002577', NULL, NULL, 28, NULL, NULL, 147256),
(147257, '1.20.1070.10-FF-000136', NULL, 'Adhesion G protein-coupled receptor E5', 277, NULL, NULL, 147257),
(147258, '4.10.800.10-FF-000005', NULL, 'Putative insulin-like growth factor-binding protein 5', 73, NULL, NULL, 147258),
(147259, '3.30.559.30-FF-000128', NULL, 'Uncharacterized protein', 255, NULL, NULL, 147259),
(147260, '1.20.5.2020-FF-000001', NULL, 'Flagellar motor switch protein FliG', 41, NULL, NULL, 147260),
(147261, '2.80.10.50-FF-000097', NULL, 'Uncharacterized protein', 42, NULL, NULL, 147261),
(147262, '2.40.50.140-FF-000622', NULL, 'Uncharacterized protein', 146, NULL, NULL, 147262),
(147263, '3.40.50.2300-FF-000703', NULL, 'Two-component response regulator', 141, NULL, NULL, 147263),
(147264, '3.10.129.110-FF-000020', NULL, 'Probable polyketide synthase 37', 328, NULL, NULL, 147264),
(147265, '1.10.1070.11-FF-000005', NULL, 'Phosphatidylinositol 4-kinase, catalytic, alpha', 192, NULL, NULL, 147265),
(147266, '3.40.50.300-FF-004399', NULL, 'Ras-related protein Rab-34', 186, NULL, NULL, 147266),
(147267, '2.60.120.650-FF-000031', NULL, 'lysine-specific demethylase 5C isoform X10', 148, NULL, NULL, 147267),
(147268, '3.30.70.3190-FF-000001', NULL, 'tRNA pseudouridine synthase Pus10', 109, NULL, NULL, 147268),
(147269, '3.90.70.10-FF-000636', NULL, 'Cathepsin F', 117, NULL, NULL, 147269),
(147270, '2.120.10.80-FF-000266', NULL, 'F-box/Kelch repeat-containing F-box family protein', 229, NULL, NULL, 147270),
(147271, '3.30.1370.130-FF-000002', NULL, 'DNA transporter HofQ', 59, NULL, NULL, 147271),
(147272, '3.30.70.240-FF-000037', NULL, 'Shwachman-Bodian-Diamond syndrome protein', 93, NULL, NULL, 147272),
(147273, '3.40.50.720-FF-001990', NULL, 'Short-chain dehydrogenase/reductase SDR', 242, NULL, NULL, 147273),
(147274, '2.130.10.10-FF-000650', NULL, 'WD repeat-containing protein WRAP73', 151, NULL, NULL, 147274),
(147275, '1.10.150.240-FF-000044', NULL, 'Phosphoglycolate phosphatase', 74, NULL, NULL, 147275),
(147276, '3.30.160.60-FF-002684', NULL, 'ZFP28 zinc finger protein', 30, NULL, NULL, 147276),
(147277, '2.40.320.10-FF-000014', NULL, 'Adenylate cyclase', 200, NULL, NULL, 147277),
(147278, '1.25.10.10-FF-002384', NULL, 'Uncharacterized protein', 268, NULL, NULL, 147278),
(147279, '3.40.50.150-FF-000189', NULL, 'tRNA (adenine(58)-N(1))-methyltransferase catalytic subunit TRM61', 243, NULL, NULL, 147279),
(147280, '3.60.21.10-FF-000339', NULL, 'Purple acid phosphatase 3', 70, NULL, NULL, 147280),
(147281, '2.130.10.10-FF-004360', NULL, 'Uncharacterized protein', 91, NULL, NULL, 147281),
(147282, '3.30.70.270-FF-000130', NULL, 'Diguanylate cyclase/phosphodiesterase', 181, NULL, NULL, 147282),
(147283, '3.30.70.330-FF-002514', NULL, NULL, 67, NULL, NULL, 147283),
(147284, '1.20.58.60-FF-000203', NULL, 'Uncharacterized protein, isoform F', 251, NULL, NULL, 147284),
(147285, '3.30.70.330-FF-002172', NULL, NULL, 139, NULL, NULL, 147285),
(147286, '3.10.20.90-FF-000346', NULL, 'BolA family transcriptional regulator', 85, NULL, NULL, 147286),
(147287, '2.130.10.10-FF-004702', NULL, 'cDNA FLJ57184, highly similar to Bromodomain and WD repeat domain-containing protein 2', 173, NULL, NULL, 147287),
(147288, '3.90.1640.20-FF-000008', NULL, 'Predicted protein', 318, NULL, NULL, 147288),
(147289, '3.30.2300.10-FF-000005', NULL, 'Protein CBG06641', 87, NULL, NULL, 147289),
(147290, '2.160.20.10-FF-000008', NULL, 'Pectinesterase', 303, NULL, NULL, 147290),
(147291, '2.60.120.650-FF-000154', NULL, 'Lid2 complex component jmj3', 289, NULL, NULL, 147291),
(147292, '1.20.5.170-FF-000111', NULL, 'CCAAT/enhancer-binding protein', 78, NULL, NULL, 147292),
(147293, '2.10.220.10-FF-000148', NULL, 'Proprotein convertase subtilisin/kexin type 5', 114, NULL, NULL, 147293),
(147294, '3.90.1640.10-FF-000005', NULL, 'Cyclic-di-AMP phosphodiesterase', 217, NULL, NULL, 147294),
(147295, '1.10.510.10-FF-004047', NULL, NULL, 55, NULL, NULL, 147295),
(147296, '2.130.10.10-FF-005978', NULL, 'Protein CBG20406', 235, NULL, NULL, 147296);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(147297, '3.30.559.30-FF-000095', NULL, 'HC-toxin synthetase', 250, NULL, NULL, 147297),
(147298, '3.10.100.10-FF-000293', NULL, NULL, 141, NULL, NULL, 147298),
(147299, '3.30.750.24-FF-000120', NULL, 'Uncharacterized protein', 137, NULL, NULL, 147299),
(147300, '1.20.20.10-FF-000034', NULL, 'Uncharacterized protein', 69, NULL, NULL, 147300),
(147301, '2.20.20.160-FF-000003', NULL, 'Protein giant-lens', 83, NULL, NULL, 147301),
(147302, '3.40.630.30-FF-000377', NULL, 'N-terminal acetyltransferase complex ARD1 subunit, putative', 161, NULL, NULL, 147302),
(147303, '4.10.800.10-FF-000022', NULL, 'Insulin-like growth factor-binding protein 1', 41, NULL, NULL, 147303),
(147304, '3.40.50.1820-FF-000413', NULL, 'carboxylesterase 1E', 550, NULL, NULL, 147304),
(147305, '2.170.120.12-FF-000004', NULL, 'RNA polymerase I subunit 43', 149, NULL, NULL, 147305),
(147306, '1.25.40.280-FF-000022', NULL, 'Signal recognition particle subunit SRP68', 216, NULL, NULL, 147306),
(147307, '3.30.230.70-FF-000068', NULL, 'Polyribonucleotide nucleotidyltransferase', 312, NULL, NULL, 147307),
(147308, '1.20.1050.10-FF-000253', NULL, 'Uncharacterized protein', 25, NULL, NULL, 147308),
(147309, '3.30.559.10-FF-000122', NULL, 'PKS-NRPS hybrid synthetase psoA', 197, NULL, NULL, 147309),
(147310, '3.40.50.300-FF-006653', NULL, 'Uncharacterized protein', 87, NULL, NULL, 147310),
(147311, '1.20.920.30-FF-000063', NULL, 'Predicted protein', 122, NULL, NULL, 147311),
(147312, '3.30.420.40-FF-000355', NULL, 'tRNA (Adenosine(37)-N6)-threonylcarbamoyltransferase complex dimerization subunit type 1 TsaB', 105, NULL, NULL, 147312),
(147313, '1.20.920.20-FF-000060', NULL, 'Dynein heavy chain family protein', 338, NULL, NULL, 147313),
(147314, '4.10.60.10-FF-000053', NULL, 'RNA recognition motif domain containing protein', 29, NULL, NULL, 147314),
(147315, '2.60.120.260-FF-000127', NULL, 'Allantoicase', 151, NULL, NULL, 147315),
(147316, '2.60.120.340-FF-000033', NULL, 'Predicted protein', 130, NULL, NULL, 147316),
(147317, '1.20.1160.11-FF-000015', NULL, NULL, 69, NULL, NULL, 147317),
(147318, '1.25.10.30-FF-000006', NULL, NULL, 146, NULL, NULL, 147318),
(147319, '3.40.50.1820-FF-000104', NULL, 'Alpha/beta hydrolase, putative', 248, NULL, NULL, 147319),
(147320, '3.30.70.1230-FF-000099', NULL, 'Adenylate cyclase EC 4611', 207, NULL, NULL, 147320),
(147321, '3.30.70.330-FF-000608', NULL, 'RNA binding motif protein 19', 142, NULL, NULL, 147321),
(147322, '3.30.40.10-FF-000047', NULL, 'Roquin-2 isoform 1', 81, NULL, NULL, 147322),
(147323, '2.40.110.10-FF-000077', NULL, 'Uncharacterized protein', 112, NULL, NULL, 147323),
(147324, '2.60.40.820-FF-000005', NULL, 'T-box transcription factor TBX5', 196, NULL, NULL, 147324),
(147325, '3.40.250.10-FF-000021', NULL, 'M-phase inducer phosphatase cdc-25.2', 180, NULL, NULL, 147325),
(147326, '1.25.10.10-FF-000613', NULL, 'Condensin-2 complex subunit D3', 160, NULL, NULL, 147326),
(147327, '2.160.20.10-FF-000227', NULL, 'Cell surface protein', 261, NULL, NULL, 147327),
(147328, '3.40.50.300-FF-007142', NULL, 'Uncharacterized protein', 177, NULL, NULL, 147328),
(147329, '3.90.226.10-FF-000134', NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', 350, NULL, NULL, 147329),
(147330, '3.80.10.10-FF-000127', NULL, 'protein phosphatase 1 regulatory subunit 7 isoform X2', 193, NULL, NULL, 147330),
(147331, '3.10.10.10-FF-000046', NULL, NULL, 28, NULL, NULL, 147331),
(147332, '2.70.170.10-FF-000074', NULL, 'Uncharacterized protein', 78, NULL, NULL, 147332),
(147333, '1.20.120.1750-FF-000170', NULL, 'RBR-type E3 ubiquitin transferase', 84, NULL, NULL, 147333),
(147334, '2.160.20.10-FF-000317', NULL, 'Uncharacterized protein', 188, NULL, NULL, 147334),
(147335, '3.10.250.10-FF-000096', NULL, NULL, 63, NULL, NULL, 147335),
(147336, '2.130.10.10-FF-005669', NULL, 'F-box/WD repeat-containing protein A', 163, NULL, NULL, 147336),
(147337, '1.10.400.10-FF-000003', NULL, 'Guanine nucleotide-binding protein G(S) subunit alpha', 115, NULL, NULL, 147337),
(147338, '1.10.1170.10-FF-000028', NULL, 'Uncharacterized protein', 115, NULL, NULL, 147338);
INSERT INTO "PUBLIC"."MODEL" VALUES
(147339, '2.30.30.40-FF-000075', NULL, 'phosphatidylinositol 3-kinase regulatory subunit alpha', 83, NULL, NULL, 147339),
(147340, '3.40.50.150-FF-000498', NULL, 'Methyltransferase domain containing protein', 235, NULL, NULL, 147340),
(147341, '3.30.1140.40-FF-000001', NULL, 'Dynein light chain Tctex-type 1', 100, NULL, NULL, 147341),
(147342, '3.30.160.60-FF-002358', NULL, 'RB associated KRAB zinc finger', 28, NULL, NULL, 147342),
(147343, '2.60.120.260-FF-000037', NULL, 'Beta-galactosidase', 90, NULL, NULL, 147343),
(147344, '3.80.10.10-FF-003039', NULL, 'Leucine-rich repeat protein kinase family protein', 163, NULL, NULL, 147344),
(147345, '3.30.710.10-FF-000132', NULL, 'BTB/POZ domain and ankyrin repeat-containing protein NH5.2', 195, NULL, NULL, 147345),
(147346, '1.10.510.10-FF-003310', NULL, NULL, 75, NULL, NULL, 147346),
(147347, '3.40.50.80-FF-000118', NULL, 'Ferric-chelate reductase, putative', 205, NULL, NULL, 147347),
(147348, '1.20.120.140-FF-000028', NULL, 'Signal recognition particle receptor FtsY', 100, NULL, NULL, 147348),
(147349, '2.60.40.10-FF-002139', NULL, 'Gamma interferon receptor', 83, NULL, NULL, 147349),
(147350, '1.10.238.10-FF-000726', NULL, 'Reticulocalbin-2', 58, NULL, NULL, 147350),
(147351, '3.40.850.10-FF-000117', NULL, 'Kinesin-like protein', 337, NULL, NULL, 147351),
(147352, '2.40.50.140-FF-000403', NULL, 'Translation initiation factor 2 subunit beta', 61, NULL, NULL, 147352),
(147353, '3.30.200.20-FF-002384', NULL, 'Predicted protein', 104, NULL, NULL, 147353),
(147354, '3.90.950.10-FF-000030', NULL, 'Bifunctional phosphopantetheine adenylyltransferase/NTP phosphatase', 178, NULL, NULL, 147354),
(147355, '2.30.30.40-FF-000384', NULL, 'Alpha-(1,6)-fucosyltransferase', 75, NULL, NULL, 147355),
(147356, '1.25.40.10-FF-000424', NULL, 'Type VII secretion AAA-ATPase EccA', 272, NULL, NULL, 147356),
(147357, '2.60.40.150-FF-000815', NULL, 'Misfire, isoform F', 124, NULL, NULL, 147357),
(147358, '2.30.42.10-FF-000312', NULL, 'Glutamate receptor interacting protein 1', 98, NULL, NULL, 147358),
(147359, '3.30.2160.10-FF-000016', NULL, 'E3 ubiquitin-protein ligase HACE1', 15, NULL, NULL, 147359),
(147360, '2.130.10.10-FF-002448', NULL, 'Uncharacterized protein', 171, NULL, NULL, 147360),
(147361, '3.40.50.300-FF-002847', NULL, 'Predicted protein', 201, NULL, NULL, 147361),
(147362, '2.160.10.10-FF-000053', NULL, 'Probable translation initiation factor eIF-2B subunit epsilon', 129, NULL, NULL, 147362),
(147363, '3.10.310.10-FF-000027', NULL, 'Probable phenazine biosynthesis protein', 113, NULL, NULL, 147363),
(147364, '2.130.10.10-FF-002757', NULL, 'Transcriptional regulator STERILE APETALA', 255, NULL, NULL, 147364),
(147365, '3.10.450.320-FF-000005', NULL, 'Mitochondrial import inner membrane translocase subunit Tim21', 112, NULL, NULL, 147365),
(147366, '2.70.20.10-FF-000007', NULL, 'DNA topoisomerase', 116, NULL, NULL, 147366),
(147367, '2.30.30.40-FF-000423', NULL, 'Protein kinase C and casein kinase substrate in neurons 2', 68, NULL, NULL, 147367),
(147368, '2.130.10.10-FF-001959', NULL, 'Os11g0187100 protein', 288, NULL, NULL, 147368),
(147369, '3.40.50.1000-FF-000387', NULL, 'Predicted protein', 156, NULL, NULL, 147369),
(147370, '2.60.120.200-FF-000042', NULL, 'Neuropilin', 191, NULL, NULL, 147370),
(147371, '3.10.28.10-FF-000014', NULL, 'V-type proton ATPase catalytic subunit A', 95, NULL, NULL, 147371),
(147372, '1.20.5.190-FF-000117', NULL, NULL, 53, NULL, NULL, 147372),
(147373, '3.90.70.10-FF-000417', NULL, 'Predicted protein', 197, NULL, NULL, 147373),
(147374, '1.20.1090.10-FF-000031', NULL, 'Iron alcohol dehydrogenase', 195, NULL, NULL, 147374),
(147375, '3.40.50.1980-FF-000085', NULL, 'ABC transporter substrate-binding protein', 163, NULL, NULL, 147375),
(147376, '1.10.10.10-FF-001130', NULL, 'LysR family transcriptional regulator', 84, NULL, NULL, 147376),
(147377, '3.30.40.10-FF-002301', NULL, 'Protein CBG05712', 116, NULL, NULL, 147377),
(147378, '1.20.120.230-FF-000027', NULL, 'Talin 2b', 28, NULL, NULL, 147378),
(147379, '2.30.42.10-FF-000621', NULL, NULL, 84, NULL, NULL, 147379);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(147380, '2.30.30.30-FF-000072', NULL, 'KOW motif domain protein', 102, NULL, NULL, 147380),
(147381, '3.30.200.20-FF-002075', NULL, 'Serine/threonine-protein kinase PknB', 83, NULL, NULL, 147381),
(147382, '3.40.50.1820-FF-001515', NULL, 'Uncharacterized protein', 151, NULL, NULL, 147382),
(147383, '3.40.630.10-FF-000371', NULL, 'Uncharacterized protein', 119, NULL, NULL, 147383),
(147384, '3.40.50.300-FF-002292', NULL, 'Helicase SWR1', 236, NULL, NULL, 147384),
(147385, '3.30.830.10-FF-000079', NULL, 'Coenzyme PQQ synthesis protein F', 236, NULL, NULL, 147385),
(147386, '1.10.238.10-FF-000417', NULL, 'Calcium-binding EF hand family protein', 64, NULL, NULL, 147386),
(147387, '3.80.10.10-FF-003348', NULL, 'Predicted protein', 117, NULL, NULL, 147387),
(147388, '3.30.710.10-FF-000441', NULL, 'Uncharacterized protein', 221, NULL, NULL, 147388),
(147389, '3.30.1490.100-FF-000014', NULL, 'DNA polymerase IV', 107, NULL, NULL, 147389),
(147390, '1.25.10.10-FF-002182', NULL, 'Uncharacterized protein', 465, NULL, NULL, 147390),
(147391, '2.10.25.10-FF-001555', NULL, 'Wall-associated receptor kinase-like 17', 29, NULL, NULL, 147391),
(147392, '3.30.565.10-FF-000182', NULL, 'Sensor histidine kinase KinD', 148, NULL, NULL, 147392),
(147393, '3.30.1330.40-FF-000010', NULL, 'Diphthine--ammonia ligase', 138, NULL, NULL, 147393),
(147394, '4.10.60.10-FF-000160', NULL, 'Replication protein A subunit', 23, NULL, NULL, 147394),
(147395, '1.20.58.60-FF-000001', NULL, 'Microtubule-actin cross-linking factor 1', 110, NULL, NULL, 147395),
(147396, '3.40.50.1820-FF-001717', NULL, 'Predicted protein', 136, NULL, NULL, 147396),
(147397, '3.20.20.140-FF-000100', NULL, '2-pyrone-4,6-dicarboxylate hydrolase', 293, NULL, NULL, 147397),
(147398, '1.10.510.10-FF-004491', NULL, NULL, 233, NULL, NULL, 147398),
(147399, '1.25.40.10-FF-000076', NULL, 'calcineurin-binding protein cabin-1 isoform X1', 255, NULL, NULL, 147399),
(147400, '2.60.40.60-FF-000748', NULL, 'Cdh-4', 108, NULL, NULL, 147400),
(147401, '3.40.190.10-FF-000544', NULL, 'Ionotropic receptor 93a', 135, NULL, NULL, 147401),
(147402, '3.30.730.10-FF-000004', NULL, 'AP2-like ethylene-responsive transcription factor', 60, NULL, NULL, 147402),
(147403, '3.30.505.10-FF-000167', NULL, NULL, 111, NULL, NULL, 147403),
(147404, '3.40.630.10-FF-000045', NULL, 'Transferrin receptor protein 1', 260, NULL, NULL, 147404),
(147405, '3.30.160.60-FF-004612', NULL, NULL, 48, NULL, NULL, 147405),
(147406, '3.30.420.40-FF-000574', NULL, 'Cell division protein FtsA', 161, NULL, NULL, 147406),
(147407, '2.40.30.10-FF-000195', NULL, 'DUal OXidase', 100, NULL, NULL, 147407),
(147408, '3.40.50.1580-FF-000072', NULL, 'Inosine guanosine and xanthosine phosphorylase family protein', 274, NULL, NULL, 147408),
(147409, '3.30.200.20-FF-000506', NULL, 'SH3 domain binding kinase family member 3', 91, NULL, NULL, 147409),
(147410, '1.20.120.1750-FF-000035', NULL, 'RBR-type E3 ubiquitin transferase', 223, NULL, NULL, 147410),
(147411, '1.20.5.170-FF-000021', NULL, 'Cyclic AMP-dependent transcription factor ATF-4', 63, NULL, NULL, 147411),
(147412, '3.30.160.360-FF-000014', NULL, 'Histone-lysine N-methyltransferase', 145, NULL, NULL, 147412),
(147413, '3.50.50.60-FF-000062', NULL, 'FAD-dependent 2-octaprenylphenol hydroxylase', 145, NULL, NULL, 147413),
(147414, '2.60.40.10-FF-002925', NULL, 'HERV-H LTR-associating 2a, tandem duplicate 2', 126, NULL, NULL, 147414),
(147415, '3.40.50.300-FF-006563', NULL, 'Uncharacterized protein', 102, NULL, NULL, 147415),
(147416, '1.10.357.10-FF-000036', NULL, 'TetR/AcrR family transcriptional regulator', 111, NULL, NULL, 147416),
(147417, '3.30.1330.20-FF-000055', NULL, 'Tubulin gamma-2 chain', 106, NULL, NULL, 147417),
(147418, '3.40.190.10-FF-000016', NULL, 'Lipoprotein', 107, NULL, NULL, 147418),
(147419, '3.40.50.150-FF-000857', NULL, 'Modification methylase', 249, NULL, NULL, 147419),
(147420, '3.30.70.330-FF-000064', NULL, 'Differentiation 1 negative regulator', 89, NULL, NULL, 147420),
(147421, '3.30.390.10-FF-000028', NULL, 'Enolase', 43, NULL, NULL, 147421); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(147422, '2.130.10.120-FF-000019', NULL, 'Prolyl oligopeptidase family protein', 240, NULL, NULL, 147422),
(147423, '3.30.450.20-FF-000171', NULL, 'Protein CBR-AHA-1', 128, NULL, NULL, 147423),
(147424, '3.80.10.10-FF-001875', NULL, 'Uncharacterized protein LGR3', 129, NULL, NULL, 147424),
(147425, '3.40.50.300-FF-002286', NULL, 'ATP-dependent DNA helicase RecQ', 199, NULL, NULL, 147425),
(147426, '3.30.40.10-FF-002323', NULL, 'Uncharacterized protein', 100, NULL, NULL, 147426),
(147427, '3.10.20.70-FF-000014', NULL, 'Glutamine synthetase type I', 106, NULL, NULL, 147427),
(147428, '1.10.357.10-FF-000042', NULL, 'TetR family HTH-type transcriptional regulator', 194, NULL, NULL, 147428),
(147429, '1.10.238.10-FF-000187', NULL, 'Programmed cell death protein 6', 172, NULL, NULL, 147429),
(147430, '2.60.40.10-FF-002454', NULL, 'KETtiN (Drosophila actin-binding) homolog', 115, NULL, NULL, 147430),
(147431, '3.30.160.60-FF-002886', NULL, 'Zinc finger protein 197', 32, NULL, NULL, 147431),
(147432, '3.40.50.300-FF-000577', NULL, 'lymphoid-specific helicase isoform X1', 289, NULL, NULL, 147432),
(147433, '3.90.930.12-FF-000025', NULL, NULL, 94, NULL, NULL, 147433),
(147434, '1.10.472.10-FF-000231', NULL, 'Cyclin, N-terminal domain containing protein', 115, NULL, NULL, 147434),
(147435, '2.70.150.10-FF-000292', NULL, 'Putative phospholipid-transporting ATPase C24B11.12c', 195, NULL, NULL, 147435),
(147436, '2.130.10.110-FF-000016', NULL, 'Clathrin heavy chain', 365, NULL, NULL, 147436),
(147437, '3.40.120.10-FF-000068', NULL, 'Phosphomannomutase/phosphoglucomutase', 160, NULL, NULL, 147437),
(147438, '3.30.1330.60-FF-000016', NULL, 'Outer membrane protein OmpA', 129, NULL, NULL, 147438),
(147439, '3.40.30.10-FF-001013', NULL, 'Uncharacterized protein', 58, NULL, NULL, 147439),
(147440, '3.40.630.60-FF-000009', NULL, NULL, 128, NULL, NULL, 147440),
(147441, '1.20.5.190-FF-000027', NULL, 'Myosin IXA', 42, NULL, NULL, 147441),
(147442, '2.70.70.10-FF-000050', NULL, 'Peptidase, M23 family', 181, NULL, NULL, 147442),
(147443, '3.40.50.720-FF-001765', NULL, 'Uncharacterized protein', 180, NULL, NULL, 147443),
(147444, '3.30.50.10-FF-000109', NULL, 'NURR1', 41, NULL, NULL, 147444),
(147445, '1.10.3260.10-FF-000047', NULL, 'Uncharacterized protein', 116, NULL, NULL, 147445),
(147446, '2.40.10.10-FF-000671', NULL, NULL, 40, NULL, NULL, 147446),
(147447, '3.40.50.360-FF-000010', NULL, 'FMN-dependent NADH-azoreductase', 201, NULL, NULL, 147447),
(147448, '3.90.980.20-FF-000006', NULL, 'Uncharacterized protein', 123, NULL, NULL, 147448),
(147449, '1.25.40.70-FF-000088', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', 200, NULL, NULL, 147449),
(147450, '3.40.630.10-FF-000152', NULL, 'aspartyl aminopeptidase isoform X2', 87, NULL, NULL, 147450),
(147451, '1.20.144.10-FF-000118', NULL, 'Glucose-6-phosphatase', 198, NULL, NULL, 147451),
(147452, '1.20.1070.10-FF-001575', NULL, 'Uncharacterized protein', 162, NULL, NULL, 147452),
(147453, '1.10.260.60-FF-000006', NULL, 'DOT1-like, histone H3 methyltransferase (S. cerevisiae)', 56, NULL, NULL, 147453),
(147454, '2.70.150.10-FF-000179', NULL, 'Calcium-transporting ATPase', 141, NULL, NULL, 147454),
(147455, '2.60.120.650-FF-000137', NULL, 'Lysine-specific demethylase 7 homolog', 299, NULL, NULL, 147455),
(147456, '1.10.287.920-FF-000005', NULL, 'Alpha-factor pheromone receptor', 53, NULL, NULL, 147456),
(147457, '2.10.90.10-FF-000149', NULL, 'Uncharacterized protein', 162, NULL, NULL, 147457),
(147458, '3.30.750.24-FF-000013', NULL, 'Solute carrier family 26 member 11', 117, NULL, NULL, 147458),
(147459, '1.10.10.60-FF-000532', NULL, 'C. Elegans Homeobox', 76, NULL, NULL, 147459),
(147460, '1.10.150.130-FF-000011', NULL, 'Tyrosine recombinase XerS', 109, NULL, NULL, 147460),
(147461, '3.90.132.10-FF-000028', NULL, 'GP63-like', 125, NULL, NULL, 147461),
(147462, '3.40.50.2000-FF-000810', NULL, 'Uncharacterized protein', 147, NULL, NULL, 147462),
(147463, '2.60.40.10-FF-002780', NULL, 'Wrapper protein', 105, NULL, NULL, 147463),
(147464, '1.10.1670.10-FF-000055', NULL, NULL, 62, NULL, NULL, 147464); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(147465, '3.30.450.40-FF-000177', NULL, 'Probable HTH-type transcriptional regulator ArcR', 180, NULL, NULL, 147465),
(147466, '1.10.260.50-FF-000003', NULL, 'Probable cysteine desulfurase iscS', 89, NULL, NULL, 147466),
(147467, '3.80.10.10-FF-002061', NULL, 'Predicted protein', 206, NULL, NULL, 147467),
(147468, '1.20.1420.30-FF-000057', NULL, 'Uncharacterized protein', 201, NULL, NULL, 147468),
(147469, '2.60.11.10-FF-000009', NULL, 'Cytochrome c oxidase subunit 5', 86, NULL, NULL, 147469),
(147470, '3.40.50.150-FF-001004', NULL, NULL, 206, NULL, NULL, 147470),
(147471, '3.30.200.20-FF-002159', NULL, 'C-ros-like receptor', 66, NULL, NULL, 147471),
(147472, '3.30.160.60-FF-006265', NULL, NULL, 26, NULL, NULL, 147472),
(147473, '3.30.160.60-FF-003611', NULL, 'Zinc finger protein 644a', 74, NULL, NULL, 147473),
(147474, '3.80.10.10-FF-001347', NULL, 'LRR receptor-like serine/threonine-protein kinase GSO2', 97, NULL, NULL, 147474),
(147475, '3.30.160.60-FF-002993', NULL, 'Blast:Transcription factor grauzone', 32, NULL, NULL, 147475),
(147476, '3.10.129.10-FF-000072', NULL, 'PaaI family thioesterase', 139, NULL, NULL, 147476),
(147477, '1.20.1250.20-FF-001783', NULL, 'Uncharacterized protein', 182, NULL, NULL, 147477),
(147478, '3.30.540.10-FF-000085', NULL, 'Inositol-1-monophosphatase', 86, NULL, NULL, 147478),
(147479, '1.20.5.870-FF-000001', NULL, 'Calcium-gated potassium channel MthK', 30, NULL, NULL, 147479),
(147480, '3.40.50.300-FF-005034', NULL, 'Uncharacterized protein', 193, NULL, NULL, 147480),
(147481, '2.120.10.30-FF-000476', NULL, 'NHL repeat-containing protein 2-like Protein', 54, NULL, NULL, 147481),
(147482, '3.40.640.10-FF-000181', NULL, 'cystathionine gamma-lyase', 246, NULL, NULL, 147482),
(147483, '1.10.238.10-FF-000732', NULL, 'GEO12020p1', 79, NULL, NULL, 147483),
(147484, '2.40.100.10-FF-000144', NULL, 'Peptidyl-prolyl cis-trans isomerase', 180, NULL, NULL, 147484),
(147485, '1.25.70.10-FF-000049', NULL, NULL, 112, NULL, NULL, 147485),
(147486, '2.60.410.10-FF-000016', NULL, NULL, 92, NULL, NULL, 147486),
(147487, '1.20.140.140-FF-000010', NULL, 'Uncharacterized protein', 52, NULL, NULL, 147487),
(147488, '3.30.230.10-FF-000331', NULL, 'Uncharacterized protein', 84, NULL, NULL, 147488),
(147489, '1.10.490.10-FF-000025', NULL, 'Predicted protein', 121, NULL, NULL, 147489),
(147490, '1.20.58.390-FF-000194', NULL, 'Uncharacterized protein', 81, NULL, NULL, 147490),
(147491, '3.40.30.10-FF-000395', NULL, 'Glutathione S-transferase, C-terminal domain containing protein, expressed', 66, NULL, NULL, 147491),
(147492, '2.40.70.10-FF-000315', NULL, NULL, 165, NULL, NULL, 147492),
(147493, '3.90.980.10-FF-000003', NULL, 'DNA primase', 134, NULL, NULL, 147493),
(147494, '2.30.29.180-FF-000001', NULL, 'Ubiquitin carboxyl-terminal hydrolase 37', 104, NULL, NULL, 147494),
(147495, '1.10.510.10-FF-002776', NULL, NULL, 216, NULL, NULL, 147495),
(147496, '2.40.30.10-FF-000447', NULL, 'Predicted protein', 74, NULL, NULL, 147496),
(147497, '1.20.920.20-FF-000054', NULL, 'Dynein heavy chain, cytoplasmic', 182, NULL, NULL, 147497),
(147498, '2.60.40.10-FF-001144', NULL, 'lachesin isoform X1', 112, NULL, NULL, 147498),
(147499, '3.40.30.10-FF-001232', NULL, 'Uncharacterized protein', 107, NULL, NULL, 147499),
(147500, '2.60.120.1320-FF-000001', NULL, 'Uncharacterized protein', 151, NULL, NULL, 147500),
(147501, '3.40.50.720-FF-002170', NULL, 'Uncharacterized protein', 70, NULL, NULL, 147501),
(147502, '1.10.287.2480-FF-000002', NULL, 'Fusion glycoprotein F0', 125, NULL, NULL, 147502),
(147503, '3.30.160.60-FF-006484', NULL, NULL, 78, NULL, NULL, 147503),
(147504, '1.20.1250.60-FF-000002', NULL, 'Interferon lambda-4', 155, NULL, NULL, 147504),
(147505, '2.30.36.70-FF-000012', NULL, 'Actin-related protein 3, putative arp3', 31, NULL, NULL, 147505),
(147506, '1.10.510.10-FF-002557', NULL, 'Protein kinase, putative', 358, NULL, NULL, 147506),
(147507, '2.20.100.10-FF-000120', NULL, 'Thrombospondin, type I, domain-containing 7Ab', 50, NULL, NULL, 147507),
(147508, '3.40.50.10470-FF-000074', NULL, 'Uncharacterized protein', 196, NULL, NULL, 147508);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(147509, '3.40.50.1220-FF-000020', NULL, 'Nad-dependent histone deacetylase sir2-like protein', 139, NULL, NULL, 147509),
(147510, '1.20.920.30-FF-000057', NULL, 'AGAP010790-PA', 181, NULL, NULL, 147510),
(147511, '1.25.10.10-FF-001996', NULL, 'Uncharacterized protein', 258, NULL, NULL, 147511),
(147512, '1.10.730.10-FF-000213', NULL, 'Protein CBR-LARS-2', 155, NULL, NULL, 147512),
(147513, '2.130.10.10-FF-002089', NULL, 'WD repeat-containing protein 11 isoform X2', 224, NULL, NULL, 147513),
(147514, '2.20.28.120-FF-000007', NULL, '50S ribosomal protein L33', 56, NULL, NULL, 147514),
(147515, '3.30.40.10-FF-001918', NULL, 'Predicted protein', 71, NULL, NULL, 147515),
(147516, '3.30.2350.10-FF-000053', NULL, 'Os02g0274650 protein', 88, NULL, NULL, 147516),
(147517, '3.30.420.40-FF-000349', NULL, 'Heat shock protein 70 putative', 17, NULL, NULL, 147517),
(147518, '3.40.800.10-FF-000058', NULL, NULL, 83, NULL, NULL, 147518),
(147519, '3.60.10.10-FF-000100', NULL, 'Unplaced genomic scaffold supercont2.12, whole genome shotgun sequence', 203, NULL, NULL, 147519),
(147520, '3.90.550.50-FF-000157', NULL, 'Beta-1,3-galactosyltransferase brn-like Protein', 231, NULL, NULL, 147520),
(147521, '3.10.105.10-FF-000079', NULL, 'Putative ABC transporter, substrate-binding protein', 204, NULL, NULL, 147521),
(147522, '1.20.1250.20-FF-000041', NULL, 'Uncharacterized MFS-type transporter YcaD', 178, NULL, NULL, 147522),
(147523, '3.80.20.20-FF-000069', NULL, 'ErbB-3 R1', 66, NULL, NULL, 147523),
(147524, '1.10.533.10-FF-000255', NULL, 'Uncharacterized protein', 90, NULL, NULL, 147524),
(147525, '2.60.200.10-FF-000006', NULL, 'Expansion, isoform A', 212, NULL, NULL, 147525),
(147526, '3.90.70.10-FF-000861', NULL, 'Predicted protein', 95, NULL, NULL, 147526),
(147527, '3.10.20.10-FF-000002', NULL, '60S ribosomal protein L18a', 69, NULL, NULL, 147527),
(147528, '3.10.100.10-FF-000326', NULL, NULL, 132, NULL, NULL, 147528),
(147529, '2.60.40.10-FF-000891', NULL, 'Titin a', 103, NULL, NULL, 147529),
(147530, '3.10.20.90-FF-000880', NULL, 'Carbohydrate sulfotransferase', 61, NULL, NULL, 147530),
(147531, '1.20.5.190-FF-000134', NULL, NULL, 81, NULL, NULL, 147531),
(147532, '1.20.1270.350-FF-000002', NULL, 'Myoblast city, isoform B', 94, NULL, NULL, 147532),
(147533, '3.30.160.40-FF-000003', NULL, 'porphobilinogen deaminase isoform X1', 122, NULL, NULL, 147533),
(147534, '1.10.510.10-FF-000652', NULL, 'Serine/threonine-protein kinase', 187, NULL, NULL, 147534),
(147535, '2.60.200.20-FF-000009', NULL, 'bifunctional polynucleotide phosphatase/kinase', 108, NULL, NULL, 147535),
(147536, '2.130.10.10-FF-000649', NULL, 'Compass component swd1', 244, NULL, NULL, 147536),
(147537, '2.30.29.30-FF-001384', NULL, 'Predicted protein', 121, NULL, NULL, 147537),
(147538, '3.30.160.60-FF-003302', NULL, 'Zgc:171673', 37, NULL, NULL, 147538),
(147539, '3.40.50.150-FF-001223', NULL, NULL, 196, NULL, NULL, 147539),
(147540, '2.40.160.110-FF-000011', NULL, 'Lysosome-associated membrane glycoprotein 2', 168, NULL, NULL, 147540),
(147541, '1.20.1250.70-FF-000005', NULL, 'Interleukin', 121, NULL, NULL, 147541),
(147542, '2.60.40.10-FF-002673', NULL, 'Uncharacterized protein', 91, NULL, NULL, 147542),
(147543, '3.30.559.10-FF-000015', NULL, 'Spermidine hydroxycinnamoyl transferase', 205, NULL, NULL, 147543),
(147544, '1.10.3720.10-FF-000184', NULL, 'Nitrate ABC transporter permease protein', 210, NULL, NULL, 147544),
(147545, '2.20.28.40-FF-000002', NULL, 'H/ACA ribonucleoprotein complex subunit 3', 50, NULL, NULL, 147545),
(147546, '1.20.58.60-FF-000220', NULL, 'Alpha spectrin, isoform B', 247, NULL, NULL, 147546),
(147547, '3.40.1280.10-FF-000073', NULL, 'tRNA/rRNA methyltransferase (SpoU)', 175, NULL, NULL, 147547),
(147548, '2.130.10.10-FF-004343', NULL, 'Uncharacterized protein', 98, NULL, NULL, 147548),
(147549, '2.10.25.10-FF-001774', NULL, 'Uncharacterized protein', 34, NULL, NULL, 147549),
(147550, '3.30.70.1450-FF-000041', NULL, 'Uncharacterized protein', 79, NULL, NULL, 147550),
(147551, '2.130.10.10-FF-002903', NULL, 'Katanin p80 WD40 repeat-containing subunit B1', 130, NULL, NULL, 147551);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(147552, '1.10.3460.10-FF-000028', NULL, 'Fucoxanthin chl a/c light-harvesting protein', 167, NULL, NULL, 147552),
(147553, '3.40.630.10-FF-000354', NULL, 'Uncharacterized protein', 184, NULL, NULL, 147553),
(147554, '3.30.70.330-FF-002407', NULL, NULL, 157, NULL, NULL, 147554),
(147555, '3.90.960.10-FF-000002', NULL, 'Cys-tRNA(Pro)/Cys-tRNA(Cys) deacylase', 159, NULL, NULL, 147555),
(147556, '3.30.70.330-FF-001789', NULL, NULL, 63, NULL, NULL, 147556),
(147557, '3.40.50.10900-FF-000023', NULL, 'Uncharacterized protein', 135, NULL, NULL, 147557),
(147558, '1.25.40.10-FF-004572', NULL, 'Tetratricopeptide repeat protein 17-like Protein', 190, NULL, NULL, 147558),
(147559, '3.20.20.140-FF-000477', NULL, 'Predicted protein', 140, NULL, NULL, 147559),
(147560, '2.60.120.200-FF-000244', NULL, 'Galectin', 141, NULL, NULL, 147560),
(147561, '3.30.160.60-FF-004831', NULL, NULL, 44, NULL, NULL, 147561),
(147562, '2.30.30.40-FF-000277', NULL, 'Actin-binding protein', 59, NULL, NULL, 147562),
(147563, '3.90.79.10-FF-000145', NULL, 'Uncharacterized protein', 65, NULL, NULL, 147563),
(147564, '1.10.287.4070-FF-000024', NULL, 'GM14238p', 47, NULL, NULL, 147564),
(147565, '3.30.70.330-FF-000373', NULL, 'RNA-binding protein 39 isoform X4', 156, NULL, NULL, 147565),
(147566, '1.10.510.10-FF-000904', NULL, 'Serine/threonine-protein kinase', 219, NULL, NULL, 147566),
(147567, '3.30.465.10-FF-000016', NULL, 'probable D-lactate dehydrogenase, mitochondrial', 121, NULL, NULL, 147567),
(147568, '2.20.70.10-FF-000164', NULL, 'WW_domain_containing_protein_-_putative', 64, NULL, NULL, 147568),
(147569, '2.130.10.10-FF-002651', NULL, 'ER membrane protein complex subunit 1-like Protein', 267, NULL, NULL, 147569),
(147570, '3.40.630.40-FF-000003', NULL, 'N-acetylmuramoyl-L-alanine amidase AmiB', 240, NULL, NULL, 147570),
(147571, '3.10.129.110-FF-000014', NULL, 'Polyketide synthase, putative (JCVI)', 299, NULL, NULL, 147571),
(147572, '3.40.50.1240-FF-000026', NULL, 'Putative fructose-2,6-bisphosphatase TIGAR', 270, NULL, NULL, 147572),
(147573, '2.30.29.230-FF-000016', NULL, 'Uncharacterized protein', 175, NULL, NULL, 147573),
(147574, '1.10.510.10-FF-002248', NULL, NULL, 115, NULL, NULL, 147574),
(147575, '3.10.180.10-FF-000067', NULL, 'Anthracycline biosynthesis protein DauV', 133, NULL, NULL, 147575),
(147576, '1.10.287.950-FF-000037', NULL, 'Methyl-accepting chemotaxis protein', 304, NULL, NULL, 147576),
(147577, '2.60.40.10-FF-004578', NULL, NULL, 104, NULL, NULL, 147577),
(147578, '2.60.40.1400-FF-000036', NULL, NULL, 186, NULL, NULL, 147578),
(147579, '1.10.287.140-FF-000002', NULL, 'Glutamate dehydrogenase, mitochondrial', 55, NULL, NULL, 147579),
(147580, '3.40.50.300-FF-003325', NULL, 'Thymidylate kinase', 189, NULL, NULL, 147580),
(147581, '2.40.10.10-FF-000339', NULL, 'Complement component 1, r subcomponent', 245, NULL, NULL, 147581),
(147582, '3.40.50.1000-FF-000864', NULL, NULL, 30, NULL, NULL, 147582),
(147583, '3.30.70.120-FF-000006', NULL, 'GTP cyclohydrolase 1 type 2 homolog', 109, NULL, NULL, 147583),
(147584, '3.40.50.300-FF-006670', NULL, 'Os01g0540300 protein', 85, NULL, NULL, 147584),
(147585, '3.40.190.290-FF-000058', NULL, 'Oxidative stress response regulatory protein OxyS', 209, NULL, NULL, 147585),
(147586, '3.30.420.40-FF-000372', NULL, 'Putative fimbrial assembly protein PilM', 147, NULL, NULL, 147586),
(147587, '3.30.46.10-FF-000004', NULL, 'Uncharacterized protein', 67, NULL, NULL, 147587),
(147588, '3.60.15.10-FF-000072', NULL, 'Cleavage and polyadenylation specificity factor subunit 2', 222, NULL, NULL, 147588),
(147589, '3.40.1090.10-FF-000148', NULL, 'Uncharacterized protein', 84, NULL, NULL, 147589),
(147590, '2.60.40.150-FF-000580', NULL, 'Synaptotagmin 1c', 98, NULL, NULL, 147590),
(147591, '3.20.20.30-FF-000018', NULL, 'POSSIBLE OXIDOREDUCTASE', 254, NULL, NULL, 147591),
(147592, '3.40.50.1820-FF-001408', NULL, 'Monoglyceride lipase', 207, NULL, NULL, 147592),
(147593, '1.20.85.10-FF-000015', NULL, 'Uncharacterized protein', 68, NULL, NULL, 147593),
(147594, '1.20.1050.10-FF-000270', NULL, 'Predicted gene 20441', 113, NULL, NULL, 147594);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(147595, '3.40.50.300-FF-001291', NULL, 'Probable ATP-dependent RNA helicase DDX58', 221, NULL, NULL, 147595),
(147596, '2.60.40.10-FF-004269', NULL, NULL, 106, NULL, NULL, 147596),
(147597, '2.40.10.10-FF-000648', NULL, NULL, 130, NULL, NULL, 147597),
(147598, '1.25.40.20-FF-001702', NULL, 'Uncharacterized protein', 58, NULL, NULL, 147598),
(147599, '1.20.1310.10-FF-000184', NULL, NULL, 113, NULL, NULL, 147599),
(147600, '3.30.2350.20-FF-000056', NULL, NULL, 245, NULL, NULL, 147600),
(147601, '3.30.590.10-FF-000015', NULL, 'Glutamine synthetase, type I', 375, NULL, NULL, 147601),
(147602, '3.30.420.40-FF-000681', NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', 147, NULL, NULL, 147602),
(147603, '1.20.5.470-FF-000004', NULL, 'Argininosuccinate synthase, chloroplastic', 26, NULL, NULL, 147603),
(147604, '1.10.730.10-FF-000180', NULL, 'Uncharacterized protein', 23, NULL, NULL, 147604),
(147605, '3.30.40.10-FF-001609', NULL, 'PHD finger family protein', 143, NULL, NULL, 147605),
(147606, '1.20.1070.10-FF-001356', NULL, 'Uncharacterized protein', 266, NULL, NULL, 147606),
(147607, '2.60.40.820-FF-000022', NULL, 'T-box transcription factor TBX2', 45, NULL, NULL, 147607),
(147608, '3.40.50.300-FF-008452', NULL, 'Uncharacterized protein', 56, NULL, NULL, 147608),
(147609, '1.10.472.10-FF-000646', NULL, 'Cyclin H', 124, NULL, NULL, 147609),
(147610, '1.25.10.10-FF-002491', NULL, 'Uncharacterized protein', 207, NULL, NULL, 147610),
(147611, '3.90.1150.10-FF-000142', NULL, 'Histidinol-phosphate aminotransferase', 136, NULL, NULL, 147611),
(147612, '1.10.630.10-FF-000014', NULL, 'Abscisic acid 8', 441, NULL, NULL, 147612),
(147613, '3.40.50.2000-FF-000046', NULL, 'alpha,alpha-trehalose-phosphate synthase [UDP-forming] 1', 255, NULL, NULL, 147613),
(147614, '3.10.110.10-FF-000046', NULL, 'Ubiquitin-conjugating enzyme E2 Z', 256, NULL, NULL, 147614),
(147615, '3.10.350.10-FF-000030', NULL, 'Peptidoglycan-binding LysM domain-containing protein', 62, NULL, NULL, 147615),
(147616, '1.20.58.860-FF-000020', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 61, NULL, NULL, 147616),
(147617, '3.40.50.11030-FF-000017', NULL, NULL, 172, NULL, NULL, 147617),
(147618, '1.10.1410.10-FF-000109', NULL, 'Protein CBG04590', 123, NULL, NULL, 147618),
(147619, '3.30.160.60-FF-004718', NULL, NULL, 29, NULL, NULL, 147619),
(147620, '1.20.58.1480-FF-000002', NULL, 'Lon protease homolog, mitochondrial', 127, NULL, NULL, 147620),
(147621, '3.30.460.80-FF-000004', NULL, 'NAD(P)H-quinone oxidoreductase subunit J, chloroplastic', 115, NULL, NULL, 147621),
(147622, '3.30.50.10-FF-000003', NULL, 'Nuclear orphan receptor ROR-beta', 110, NULL, NULL, 147622),
(147623, '3.30.200.210-FF-000002', NULL, 'NADH-ubiquinone oxidoreductase 75 kDa subunit', 115, NULL, NULL, 147623),
(147624, '1.20.1070.10-FF-002070', NULL, 'Uncharacterized protein', 69, NULL, NULL, 147624),
(147625, '1.25.10.10-FF-000692', NULL, 'Arm repeat containing protein homolog-like', 90, NULL, NULL, 147625),
(147626, '1.10.1370.10-FF-000015', NULL, 'Protein CBG01792', 313, NULL, NULL, 147626),
(147627, '1.25.10.10-FF-001310', NULL, 'WAPL (Wings apart-like protein regulation of heterochromatin) protein', 93, NULL, NULL, 147627),
(147628, '3.40.50.300-FF-000268', NULL, 'ATP-dependent Clp protease, ATP-binding subunit ClpA', 214, NULL, NULL, 147628),
(147629, '2.60.40.10-FF-000672', NULL, 'Titin a', 103, NULL, NULL, 147629),
(147630, '3.30.40.10-FF-002290', NULL, 'Uncharacterized protein', 40, NULL, NULL, 147630),
(147631, '1.10.1450.10-FF-000073', NULL, 'Tetraspanin', 84, NULL, NULL, 147631),
(147632, '3.40.50.720-FF-001456', NULL, 'Ornithine cyclodeaminase', 177, NULL, NULL, 147632),
(147633, '1.25.40.20-FF-001051', NULL, 'Ankyrin repeat domain-containing protein 27-like Protein', 158, NULL, NULL, 147633),
(147634, '2.130.10.10-FF-000397', NULL, 'Autophagy-related protein 18', 272, NULL, NULL, 147634),
(147635, '2.130.10.10-FF-001015', NULL, 'DIP2p Nucleolar protein', 121, NULL, NULL, 147635),
(147636, '1.10.287.380-FF-000023', NULL, 'ABC transporter ATP-binding protein', 69, NULL, NULL, 147636);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(147637, '2.30.29.240-FF-000019', NULL, 'Phosphoinositide phospholipase C', 146, NULL, NULL, 147637),
(147638, '3.30.70.330-FF-000300', NULL, 'Interferon-induced protein 35', 81, NULL, NULL, 147638),
(147639, '2.70.170.10-FF-000181', NULL, 'Neuronal acetylcholine receptor subunit alpha-3, putative', 164, NULL, NULL, 147639),
(147640, '1.10.8.20-FF-000002', NULL, 'tyrosine-protein phosphatase non-receptor type 9', 73, NULL, NULL, 147640),
(147641, '3.40.50.300-FF-008581', NULL, 'Uncharacterized protein', 114, NULL, NULL, 147641),
(147642, '2.30.180.10-FF-000078', NULL, 'BIGH3, putative', 127, NULL, NULL, 147642),
(147643, '3.40.50.1440-FF-000081', NULL, 'Beta tubulin,putative', 254, NULL, NULL, 147643),
(147644, '3.40.1740.10-FF-000002', NULL, 'UPF0301 protein A5636_14805', 184, NULL, NULL, 147644),
(147645, '1.10.10.520-FF-000008', NULL, 'SUMO-activating enzyme subunit', 121, NULL, NULL, 147645),
(147646, '3.30.40.10-FF-000502', NULL, 'RING-type E3 ubiquitin transferase', 81, NULL, NULL, 147646),
(147647, '3.40.50.2300-FF-001558', NULL, NULL, 19, NULL, NULL, 147647),
(147648, '1.20.1740.10-FF-000210', NULL, 'Uncharacterized protein', 138, NULL, NULL, 147648),
(147649, '2.40.70.10-FF-000085', NULL, 'Aspartic-type endopeptidase (CtsD), putative', 203, NULL, NULL, 147649),
(147650, '1.10.510.10-FF-000668', NULL, 'Phosphoenolpyruvate carboxylase kinase', 188, NULL, NULL, 147650),
(147651, '3.40.190.10-FF-000235', NULL, 'Phosphate-binding protein PstS', 186, NULL, NULL, 147651),
(147652, '3.30.70.920-FF-000016', NULL, 'AsnC family transcriptional regulator', 85, NULL, NULL, 147652),
(147653, '1.25.40.20-FF-000775', NULL, 'Cell-cycle-regulation transcription factor, putative', 284, NULL, NULL, 147653),
(147654, '1.10.10.60-FF-000841', NULL, NULL, 70, NULL, NULL, 147654),
(147655, '3.90.650.10-FF-000012', NULL, 'Thiamine-monophosphate kinase', 179, NULL, NULL, 147655),
(147656, '1.20.1560.10-FF-000005', NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 9', 345, NULL, NULL, 147656),
(147657, '1.10.20.10-FF-000259', NULL, NULL, 173, NULL, NULL, 147657),
(147658, '2.100.10.30-FF-000005', NULL, 'Demilune cell and parotid protein 1', 145, NULL, NULL, 147658),
(147659, '2.10.25.10-FF-001246', NULL, 'Uncharacterized protein', 78, NULL, NULL, 147659),
(147660, '1.20.140.140-FF-000009', NULL, 'Uncharacterized protein', 76, NULL, NULL, 147660),
(147661, '3.30.160.60-FF-004376', NULL, NULL, 29, NULL, NULL, 147661),
(147662, '2.130.10.10-FF-005776', NULL, 'Bromodomain and WD repeat-containing DDB_G0285837', 105, NULL, NULL, 147662),
(147663, '2.10.110.10-FF-000230', NULL, 'Uncharacterized protein', 78, NULL, NULL, 147663),
(147664, '3.30.160.60-FF-005180', NULL, NULL, 51, NULL, NULL, 147664),
(147665, '2.70.150.10-FF-000073', NULL, 'P-type ATPase, putative', 47, NULL, NULL, 147665),
(147666, '3.50.50.60-FF-000371', NULL, 'FAD-dependent monooxygenase', 158, NULL, NULL, 147666),
(147667, '1.10.10.60-FF-000638', NULL, 'Sigma-54-dependent Fis family transcriptional regulator', 43, NULL, NULL, 147667),
(147668, '3.90.950.10-FF-000029', NULL, 'Maf-like protein yhdE', 209, NULL, NULL, 147668),
(147669, '3.30.200.20-FF-000815', NULL, 'Mitogen-activated protein kinase', 96, NULL, NULL, 147669),
(147670, '1.20.1250.20-FF-002036', NULL, 'Os04g0679000 protein', 330, NULL, NULL, 147670),
(147671, '4.10.1240.10-FF-000077', NULL, 'Uncharacterized protein', 65, NULL, NULL, 147671),
(147672, '1.25.40.10-FF-000772', NULL, 'Tetratricopeptide repeat/TPR repeat, putative', 130, NULL, NULL, 147672),
(147673, '2.30.30.100-FF-000013', NULL, 'Small nuclear ribonucleoprotein E', 89, NULL, NULL, 147673),
(147674, '2.170.270.10-FF-000142', NULL, 'SET domain containing protein, putative', 99, NULL, NULL, 147674),
(147675, '3.30.830.10-FF-000080', NULL, 'Pitrilysin-like metalloprotease', 232, NULL, NULL, 147675),
(147676, '2.130.10.10-FF-003977', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit', 236, NULL, NULL, 147676),
(147677, '3.30.160.60-FF-001138', NULL, 'zinc finger protein 407 isoform X1', 72, NULL, NULL, 147677);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(147678, '3.50.7.10-FF-000049', NULL, NULL, 169, NULL, NULL, 147678),
(147679, '1.20.1280.290-FF-000014', NULL, 'Bidirectional sugar transporter SWEET', 91, NULL, NULL, 147679),
(147680, '3.40.50.150-FF-000841', NULL, 'Cephalosporin hydroxylase', 186, NULL, NULL, 147680),
(147681, '3.30.200.20-FF-001996', NULL, 'Probable serine/threonine-protein kinase ndrA', 97, NULL, NULL, 147681),
(147682, '1.10.510.10-FF-002922', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 4-like Protein', 273, NULL, NULL, 147682),
(147683, '2.60.40.790-FF-000209', NULL, NULL, 151, NULL, NULL, 147683),
(147684, '3.30.70.330-FF-000715', NULL, 'Eukaryotic translation initiation factor 4Bb', 76, NULL, NULL, 147684),
(147685, '1.10.238.10-FF-001114', NULL, 'Uncharacterized protein', 47, NULL, NULL, 147685),
(147686, '1.20.120.80-FF-000005', NULL, 'Cytochrome C oxidase subunit III', 197, NULL, NULL, 147686),
(147687, '3.90.70.80-FF-000022', NULL, 'OTU2p protein', 165, NULL, NULL, 147687),
(147688, '3.80.10.10-FF-003820', NULL, 'Uncharacterized protein', 75, NULL, NULL, 147688),
(147689, '1.10.510.10-FF-000197', NULL, 'LIM domain kinase 2 isoform X1', 203, NULL, NULL, 147689),
(147690, '3.60.20.40-FF-000048', NULL, 'Uncharacterized protein', 121, NULL, NULL, 147690),
(147691, '1.10.10.60-FF-001004', NULL, NULL, 73, NULL, NULL, 147691),
(147692, '1.20.58.60-FF-000310', NULL, 'Spectrin beta chain, non-erythrocytic', 100, NULL, NULL, 147692),
(147693, '1.10.10.60-FF-000386', NULL, 'AraC family transcriptional regulator', 107, NULL, NULL, 147693),
(147694, '3.40.190.10-FF-000325', NULL, 'Membrane-bound lytic murein transglycosylase F', 95, NULL, NULL, 147694),
(147695, '3.40.50.2000-FF-000501', NULL, 'UDP-N-acetylglucosamine 2-epimerase', 165, NULL, NULL, 147695),
(147696, '3.10.25.10-FF-000007', NULL, 'Methionyl-tRNA formyltransferase', 100, NULL, NULL, 147696),
(147697, '3.30.450.20-FF-000204', NULL, 'Protein FimX', 121, NULL, NULL, 147697),
(147698, '1.10.10.10-FF-000742', NULL, 'MarR family transcriptional regulator', 132, NULL, NULL, 147698),
(147699, '1.10.8.750-FF-000001', NULL, 'Putative phosphoribosylformylglycinamidine synthase', 61, NULL, NULL, 147699),
(147700, '2.70.98.10-FF-000080', NULL, 'Beta-galactosidase', 158, NULL, NULL, 147700),
(147701, '2.10.110.10-FF-000140', NULL, 'Cysteine and glycine-rich protein 1', 44, NULL, NULL, 147701),
(147702, '3.90.360.10-FF-000001', NULL, 'Histone acetyltransferase type B catalytic subunit', 126, NULL, NULL, 147702),
(147703, '1.10.760.10-FF-000018', NULL, 'Cytochrome c1, heme protein, mitochondrial', 207, NULL, NULL, 147703),
(147704, '3.40.30.10-FF-001119', NULL, 'Glutathione s-transferase', 143, NULL, NULL, 147704),
(147705, '2.130.10.10-FF-000543', NULL, 'WD repeat-containing protein 48 homolog', 145, NULL, NULL, 147705),
(147706, '1.10.510.10-FF-000539', NULL, 'eIF-2-alpha kinase GCN2', 194, NULL, NULL, 147706),
(147707, '4.10.60.10-FF-000159', NULL, 'Terminal uridylyl transferase 4', 85, NULL, NULL, 147707),
(147708, '3.90.120.10-FF-000017', NULL, 'Predicted protein', 97, NULL, NULL, 147708),
(147709, '3.40.50.2020-FF-000165', NULL, 'Uncharacterized protein', 142, NULL, NULL, 147709),
(147710, '3.30.60.190-FF-000019', NULL, 'Uncharacterized protein', 54, NULL, NULL, 147710),
(147711, '3.30.70.330-FF-000154', NULL, 'Polyadenylate-binding protein', 96, NULL, NULL, 147711),
(147712, '3.40.640.10-FF-000433', NULL, 'Glutamine--scyllo-inositol transaminase', 250, NULL, NULL, 147712),
(147713, '1.25.40.10-FF-002329', NULL, 'Bardet-Biedl syndrome 4', 45, NULL, NULL, 147713),
(147714, '3.40.50.1240-FF-000099', NULL, 'Uncharacterized protein At3g52155, chloroplastic', 178, NULL, NULL, 147714),
(147715, '3.30.40.10-FF-001828', NULL, 'Predicted protein', 70, NULL, NULL, 147715),
(147716, '3.30.200.20-FF-001001', NULL, 'Muscle M-line assembly protein unc-89', 76, NULL, NULL, 147716),
(147717, '3.30.310.50-FF-000041', NULL, 'Uncharacterized protein', 92, NULL, NULL, 147717),
(147718, '3.90.1170.10-FF-000008', NULL, '50S ribosomal protein L10e', 172, NULL, NULL, 147718);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(147719, '2.60.40.60-FF-000529', NULL, 'Dachsous cadherin-related 1a', 111, NULL, NULL, 147719),
(147720, '2.60.40.10-FF-004943', NULL, NULL, 55, NULL, NULL, 147720),
(147721, '3.40.50.300-FF-008468', NULL, 'Predicted protein', 242, NULL, NULL, 147721),
(147722, '2.60.40.60-FF-000771', NULL, 'Uncharacterized protein', 111, NULL, NULL, 147722),
(147723, '3.30.70.330-FF-001699', NULL, NULL, 86, NULL, NULL, 147723),
(147724, '1.25.10.10-FF-000944', NULL, 'Adaptin-related protein-like protein', 602, NULL, NULL, 147724),
(147725, '2.40.160.50-FF-000013', NULL, 'Putative Tob55', 360, NULL, NULL, 147725),
(147726, '3.90.550.10-FF-000084', NULL, 'Glycosyltransferases', 254, NULL, NULL, 147726),
(147727, '1.10.150.20-FF-000014', NULL, 'Polymerase (DNA directed), eta', 57, NULL, NULL, 147727),
(147728, '1.20.5.340-FF-000106', NULL, 'Uncharacterized protein', 103, NULL, NULL, 147728),
(147729, '2.30.29.30-FF-000203', NULL, 'PH domain-containing protein', 123, NULL, NULL, 147729),
(147730, '2.30.30.100-FF-000103', NULL, 'Bifunctional protein BirA: biotin operon repressor + biotin--[acetyl-CoA-carboxylase] synthetase', 48, NULL, NULL, 147730),
(147731, '2.60.210.10-FF-000035', NULL, 'TNF receptor-associated factor 2', 187, NULL, NULL, 147731),
(147732, '1.20.1070.10-FF-001884', NULL, 'Uncharacterized protein', 341, NULL, NULL, 147732),
(147733, '2.40.30.10-FF-000341', NULL, 'Elongation factor-like protein', 86, NULL, NULL, 147733),
(147734, '1.10.10.60-FF-000167', NULL, 'Homeobox protein engrailed-like', 92, NULL, NULL, 147734),
(147735, '3.40.47.10-FF-000118', NULL, '3-hydroxy-3-methylglutaryl coenzyme A synthase', 138, NULL, NULL, 147735),
(147736, '1.10.10.10-FF-000433', NULL, 'DNA-binding protein RFX8-like isoform X4', 76, NULL, NULL, 147736),
(147737, '3.40.50.720-FF-001546', NULL, 'Uncharacterized protein', 259, NULL, NULL, 147737),
(147738, '1.25.10.10-FF-001220', NULL, 'SEC7-like guanine nucleotide exchange family protein', 593, NULL, NULL, 147738),
(147739, '1.20.1070.10-FF-000030', NULL, 'trace amine-associated receptor 1', 312, NULL, NULL, 147739),
(147740, '1.25.40.10-FF-001857', NULL, 'Coatomer subunit epsilon', 321, NULL, NULL, 147740),
(147741, '3.40.50.2300-FF-001648', NULL, NULL, 231, NULL, NULL, 147741),
(147742, '3.30.1370.10-FF-000026', NULL, 'Insulin-like growth factor 2 mRNA-binding protein 3', 77, NULL, NULL, 147742),
(147743, '3.40.35.10-FF-000001', NULL, 'PTS system mannose-specific EIIAB component', 165, NULL, NULL, 147743),
(147744, '3.40.50.150-FF-000970', NULL, NULL, 231, NULL, NULL, 147744),
(147745, '3.90.79.10-FF-000274', NULL, 'Uncharacterized protein', 95, NULL, NULL, 147745),
(147746, '3.30.160.60-FF-002920', NULL, 'Hunchback-like protein', 68, NULL, NULL, 147746),
(147747, '3.40.50.300-FF-004871', NULL, 'YALI0E32857p', 123, NULL, NULL, 147747),
(147748, '3.40.50.10810-FF-000075', NULL, 'Protein CHROMATIN REMODELING 5', 240, NULL, NULL, 147748),
(147749, '3.90.1150.10-FF-000232', NULL, 'Aminotransferase class III-fold pyridoxal phosphate-dependent enzyme', 115, NULL, NULL, 147749),
(147750, '3.40.140.10-FF-000176', NULL, 'COP9 signalosome subunit 6', 192, NULL, NULL, 147750),
(147751, '3.40.390.10-FF-000200', NULL, NULL, 197, NULL, NULL, 147751),
(147752, '2.60.40.10-FF-004691', NULL, NULL, 93, NULL, NULL, 147752),
(147753, '3.40.50.300-FF-004629', NULL, 'ABC transporter ATP-binding protein', 222, NULL, NULL, 147753),
(147754, '2.40.50.730-FF-000030', NULL, 'Uncharacterized protein', 41, NULL, NULL, 147754),
(147755, '2.60.120.40-FF-000060', NULL, 'Multimerin 2', 131, NULL, NULL, 147755),
(147756, '2.120.10.80-FF-000244', NULL, 'Acyl-CoA-binding domain-containing protein 4', 106, NULL, NULL, 147756),
(147757, '3.30.1640.10-FF-000019', NULL, 'DNA helicase', 79, NULL, NULL, 147757),
(147758, '1.20.5.1700-FF-000012', NULL, 'Zgc:111960 protein', 68, NULL, NULL, 147758),
(147759, '1.20.5.1160-FF-000030', NULL, 'Keratin, type I cytoskeletal 20', 52, NULL, NULL, 147759),
(147760, '2.130.10.10-FF-004449', NULL, 'Uncharacterized protein', 348, NULL, NULL, 147760),
(147761, '2.130.10.10-FF-000852', NULL, 'Chromatin assembly factor 1 subunit B', 262, NULL, NULL, 147761);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(147762, '3.30.200.20-FF-002053', NULL, 'Uncharacterized protein', 88, NULL, NULL, 147762),
(147763, '3.30.40.10-FF-002071', NULL, 'Uncharacterized protein', 87, NULL, NULL, 147763),
(147764, '3.30.160.60-FF-000885', NULL, 'Zinc finger protein 691', 24, NULL, NULL, 147764),
(147765, '3.20.180.20-FF-000023', NULL, 'Dynein gamma chain, flagellar outer arm', 98, NULL, NULL, 147765),
(147766, '3.40.50.300-FF-000829', NULL, 'Dynein heavy chain, cytoplasmic', 124, NULL, NULL, 147766),
(147767, '2.60.40.10-FF-004163', NULL, NULL, 89, NULL, NULL, 147767),
(147768, '3.40.640.10-FF-000523', NULL, 'Uncharacterized protein', 121, NULL, NULL, 147768),
(147769, '3.40.50.720-FF-000152', NULL, 'Aspartate-semialdehyde dehydrogenase', 137, NULL, NULL, 147769),
(147770, '1.20.1720.10-FF-000102', NULL, NULL, 203, NULL, NULL, 147770),
(147771, '2.60.40.1360-FF-000018', NULL, 'Lysosomal alpha-mannosidase, putative', 126, NULL, NULL, 147771),
(147772, '3.40.50.720-FF-001911', NULL, 'UDP galactopyranose mutase', 110, NULL, NULL, 147772),
(147773, '3.90.550.10-FF-000393', NULL, 'Glycoside transferase family 2', 261, NULL, NULL, 147773),
(147774, '2.60.40.10-FF-004382', NULL, NULL, 100, NULL, NULL, 147774),
(147775, '4.10.860.10-FF-000020', NULL, 'GM12568', 42, NULL, NULL, 147775),
(147776, '3.10.390.10-FF-000004', NULL, 'Deformed epidermal autoregulatory factor 1', 93, NULL, NULL, 147776),
(147777, '3.80.10.10-FF-001656', NULL, 'Predicted protein', 252, NULL, NULL, 147777),
(147778, '3.40.50.720-FF-000129', NULL, 'D-mannonate oxidoreductase', 284, NULL, NULL, 147778),
(147779, '3.30.200.20-FF-001777', NULL, 'Uncharacterized protein', 85, NULL, NULL, 147779),
(147780, '3.40.50.720-FF-000461', NULL, 'Putative Dehydrogenase', 119, NULL, NULL, 147780),
(147781, '1.10.472.100-FF-000002', NULL, 'Presenilin', 102, NULL, NULL, 147781),
(147782, '3.30.70.20-FF-000024', NULL, 'Ferredoxin-type protein NapF', 52, NULL, NULL, 147782),
(147783, '3.30.450.190-FF-000023', NULL, 'Uncharacterized protein', 122, NULL, NULL, 147783),
(147784, '1.10.150.20-FF-000233', NULL, 'DNA polymerase', 51, NULL, NULL, 147784),
(147785, '1.10.472.10-FF-000540', NULL, 'Cdk activating kinase, putative', 81, NULL, NULL, 147785),
(147786, '1.10.287.110-FF-000459', NULL, 'Chaperone protein DnaJ 1', 101, NULL, NULL, 147786),
(147787, '1.10.150.530-FF-000024', NULL, 'Probable dual-specificity RNA methyltransferase RlmN', 45, NULL, NULL, 147787),
(147788, '2.130.10.10-FF-000178', NULL, 'WD repeat domain 3', 71, NULL, NULL, 147788),
(147789, '3.30.1240.10-FF-000022', NULL, 'Haloacid dehalogenase-like hydrolase', 103, NULL, NULL, 147789),
(147790, '1.25.40.980-FF-000002', NULL, NULL, 73, NULL, NULL, 147790),
(147791, '1.10.150.20-FF-000323', NULL, 'Uncharacterized protein', 43, NULL, NULL, 147791),
(147792, '2.60.40.10-FF-004472', NULL, NULL, 93, NULL, NULL, 147792),
(147793, '1.10.238.10-FF-000496', NULL, 'Light chain for Myo1p', 148, NULL, NULL, 147793),
(147794, '2.60.40.10-FF-004724', NULL, NULL, 87, NULL, NULL, 147794),
(147795, '3.50.50.60-FF-000039', NULL, 'Sulfide:quinone oxidoreductase, mitochondrial', 176, NULL, NULL, 147795),
(147796, '1.10.238.10-FF-000748', NULL, 'Glycerol-3-phosphate dehydrogenase', 131, NULL, NULL, 147796),
(147797, '3.30.565.10-FF-000159', NULL, 'Two-component system sensor protein', 157, NULL, NULL, 147797),
(147798, '3.10.110.10-FF-000355', NULL, 'Ubiquitin protein ligase, putative', 56, NULL, NULL, 147798),
(147799, '3.50.50.60-FF-000590', NULL, 'Flavocytochrome c', 299, NULL, NULL, 147799),
(147800, '2.60.40.60-FF-000439', NULL, 'Dachsous, isoform B', 117, NULL, NULL, 147800),
(147801, '3.30.428.10-FF-000043', NULL, 'Predicted protein', 103, NULL, NULL, 147801),
(147802, '3.30.565.10-FF-000491', NULL, 'Uncharacterized protein', 148, NULL, NULL, 147802),
(147803, '3.30.160.60-FF-000666', NULL, 'RB-associated KRAB zinc finger protein-like', 30, NULL, NULL, 147803),
(147804, '3.10.20.90-FF-000677', NULL, 'UBX domain-containing protein 11-like', 122, NULL, NULL, 147804),
(147805, '3.30.160.60-FF-004685', NULL, NULL, 29, NULL, NULL, 147805);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(147806, '1.10.472.10-FF-000450', NULL, 'Cyclin-H', 115, NULL, NULL, 147806),
(147807, '3.80.10.10-FF-001908', NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', 107, NULL, NULL, 147807),
(147808, '3.50.50.60-FF-000281', NULL, 'Glutathione reductase', 181, NULL, NULL, 147808),
(147809, '1.10.510.10-FF-000758', NULL, 'Probable serine/threonine-protein kinase DDB_G0292350', 259, NULL, NULL, 147809),
(147810, '2.60.40.640-FF-000069', NULL, 'Arrestin domain-containing protein B', 146, NULL, NULL, 147810),
(147811, '3.10.260.20-FF-000003', NULL, 'SKI family transcriptional corepressor 1 homolog-B-like', 101, NULL, NULL, 147811),
(147812, '3.30.160.60-FF-001251', NULL, 'zinc finger and BTB domain-containing protein 38', 52, NULL, NULL, 147812),
(147813, '1.20.58.1780-FF-000007', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 262, NULL, NULL, 147813),
(147814, '3.80.10.10-FF-001566', NULL, 'NACHT, LRR and PYD domains-containing protein 7', 93, NULL, NULL, 147814),
(147815, '1.25.40.180-FF-000301', NULL, NULL, 86, NULL, NULL, 147815),
(147816, '3.40.350.10-FF-000080', NULL, 'Creatinase', 153, NULL, NULL, 147816),
(147817, '2.60.40.60-FF-000990', NULL, 'Uncharacterized protein', 110, NULL, NULL, 147817),
(147818, '1.20.1290.10-FF-000012', NULL, 'Sestrin homolog', 121, NULL, NULL, 147818),
(147819, '3.90.1150.10-FF-000451', NULL, 'Aspartate aminotransferase, putative', 139, NULL, NULL, 147819),
(147820, '1.20.1540.10-FF-000026', NULL, 'Rhomboid-like protein 14, mitochondrial', 196, NULL, NULL, 147820),
(147821, '2.10.10.20-FF-000001', NULL, 'Secreted chitinase', 52, NULL, NULL, 147821),
(147822, '3.40.50.150-FF-000751', NULL, 'Ribosomal RNA small subunit methyltransferase G', 215, NULL, NULL, 147822),
(147823, '1.10.1070.20-FF-000001', NULL, 'Serine/threonine-protein kinase toxin HipA', 176, NULL, NULL, 147823),
(147824, '3.10.20.90-FF-000986', NULL, 'Uncharacterized protein', 93, NULL, NULL, 147824),
(147825, '1.10.760.10-FF-000041', NULL, 'Cytochrome c peroxidase', 179, NULL, NULL, 147825),
(147826, '1.10.3970.10-FF-000005', NULL, 'BSD domain-containing protein C22A12.14c', 101, NULL, NULL, 147826),
(147827, '3.80.10.10-FF-003910', NULL, 'Uncharacterized protein', 124, NULL, NULL, 147827),
(147828, '1.10.20.10-FF-000349', NULL, NULL, 94, NULL, NULL, 147828),
(147829, '3.30.160.60-FF-000975', NULL, 'PLAG1 like zinc finger 2', 27, NULL, NULL, 147829),
(147830, '3.40.50.150-FF-000509', NULL, 'Probable dna methylase', 192, NULL, NULL, 147830),
(147831, '2.60.120.260-FF-000352', NULL, 'Uncharacterized protein', 225, NULL, NULL, 147831),
(147832, '2.30.29.30-FF-001395', NULL, 'FERM domain-containing protein B', 108, NULL, NULL, 147832),
(147833, '1.20.1070.10-FF-001446', NULL, 'Uncharacterized protein', 221, NULL, NULL, 147833),
(147834, '1.10.150.20-FF-000104', NULL, 'Unplaced genomic scaffold supercont1.24, whole genome shotgun sequence', 89, NULL, NULL, 147834),
(147835, '1.10.510.10-FF-004255', NULL, NULL, 191, NULL, NULL, 147835),
(147836, '1.20.58.390-FF-000284', NULL, 'Uncharacterized protein', 52, NULL, NULL, 147836),
(147837, '3.30.710.10-FF-000233', NULL, 'Bric-a-brac', 132, NULL, NULL, 147837),
(147838, '1.10.8.490-FF-000001', NULL, 'Cell death protein 4', 80, NULL, NULL, 147838),
(147839, '3.90.1170.10-FF-000031', NULL, 'Uncharacterized protein', 88, NULL, NULL, 147839),
(147840, '2.130.10.10-FF-001133', NULL, 'WD40 domain-containing protein', 81, NULL, NULL, 147840),
(147841, '3.80.20.20-FF-000103', NULL, 'Uncharacterized protein', 183, NULL, NULL, 147841),
(147842, '1.10.287.110-FF-000448', NULL, 'Uncharacterized protein', 65, NULL, NULL, 147842),
(147843, '3.30.70.330-FF-000940', NULL, 'Putative polypyrimidine tract binding protein', 86, NULL, NULL, 147843),
(147844, '2.60.40.60-FF-001030', NULL, 'Predicted protein', 104, NULL, NULL, 147844),
(147845, '3.30.420.40-FF-000916', NULL, 'Uncharacterized protein', 27, NULL, NULL, 147845),
(147846, '3.40.50.150-FF-001133', NULL, NULL, 65, NULL, NULL, 147846),
(147847, '1.20.5.340-FF-000090', NULL, 'Viral A-type inclusion protein, putative', 121, NULL, NULL, 147847);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(147848, '3.40.140.10-FF-000272', NULL, 'Predicted protein', 89, NULL, NULL, 147848),
(147849, '2.60.40.10-FF-002678', NULL, 'Putative Defective proboscis extension response', 87, NULL, NULL, 147849),
(147850, '3.60.15.10-FF-000055', NULL, 'Cleavage and polyadenylation specificity factor protein', 66, NULL, NULL, 147850),
(147851, '3.20.20.80-FF-000011', NULL, 'Cytosolic beta-glucosidase', 472, NULL, NULL, 147851),
(147852, '2.40.70.10-FF-000545', NULL, NULL, 227, NULL, NULL, 147852),
(147853, '1.10.8.710-FF-000017', NULL, NULL, 115, NULL, NULL, 147853),
(147854, '3.30.160.60-FF-005888', NULL, NULL, 83, NULL, NULL, 147854),
(147855, '3.30.160.60-FF-006394', NULL, NULL, 93, NULL, NULL, 147855),
(147856, '2.130.10.10-FF-004359', NULL, 'Uncharacterized protein', 92, NULL, NULL, 147856),
(147857, '3.30.200.20-FF-000692', NULL, 'CAMK/CAMK1 protein kinase', 82, NULL, NULL, 147857),
(147858, '1.10.510.10-FF-000556', NULL, 'Lymphokine-activated killer T-cell-originated protein kinase', 310, NULL, NULL, 147858),
(147859, '3.40.50.150-FF-000627', NULL, 'Amine N-MethylTransferase', 250, NULL, NULL, 147859),
(147860, '1.20.120.1200-FF-000022', NULL, 'NADH-ubiquinone oxidoreductase chain 6', 176, NULL, NULL, 147860),
(147861, '2.30.30.560-FF-000005', NULL, 'Major vault protein-like protein', 81, NULL, NULL, 147861),
(147862, '3.30.230.10-FF-000191', NULL, 'DNA repair protein RadA', 135, NULL, NULL, 147862),
(147863, '2.30.30.550-FF-000002', NULL, 'Major vault protein', 58, NULL, NULL, 147863),
(147864, '3.40.830.10-FF-000009', NULL, '4,5-DOPA dioxygenase extradiol-like protein', 279, NULL, NULL, 147864),
(147865, '2.60.120.1000-FF-000029', NULL, 'Uncharacterized protein', 80, NULL, NULL, 147865),
(147866, '1.25.40.10-FF-002554', NULL, 'Tetratricopeptide repeat protein 21B', 121, NULL, NULL, 147866),
(147867, '1.10.1370.30-FF-000038', NULL, 'Angiotensin-converting enzyme', 229, NULL, NULL, 147867),
(147868, '3.30.230.10-FF-000202', NULL, 'Type 2 DNA topoisomerase 6 subunit B', 209, NULL, NULL, 147868),
(147869, '3.80.20.20-FF-000092', NULL, 'Meiotic expression up-regulated protein 10', 92, NULL, NULL, 147869),
(147870, '3.30.160.60-FF-006405', NULL, NULL, 29, NULL, NULL, 147870),
(147871, '1.25.40.10-FF-003982', NULL, 'Tetratricopeptide repeat protein 10, tpr10, putative', 219, NULL, NULL, 147871),
(147872, '3.90.1510.10-FF-000001', NULL, 'Glycerate kinase 2', 235, NULL, NULL, 147872),
(147873, '1.10.730.10-FF-000179', NULL, 'Uncharacterized protein', 27, NULL, NULL, 147873),
(147874, '3.30.160.60-FF-000992', NULL, 'Zinc finger protein 320', 29, NULL, NULL, 147874),
(147875, '3.30.497.10-FF-000017', NULL, 'Uncharacterized protein, isoform B', 202, NULL, NULL, 147875),
(147876, '2.130.10.10-FF-004910', NULL, 'Uncharacterized protein', 110, NULL, NULL, 147876),
(147877, '2.40.160.50-FF-000024', NULL, 'ShlB family hemolysin secretion/activation protein', 385, NULL, NULL, 147877),
(147878, '1.25.40.20-FF-001360', NULL, 'DNA-binding protein rfxank, putative', 97, NULL, NULL, 147878),
(147879, '3.40.850.10-FF-000123', NULL, 'Putative kinesin', 379, NULL, NULL, 147879),
(147880, '2.60.40.10-FF-004932', NULL, NULL, 127, NULL, NULL, 147880),
(147881, '3.30.420.40-FF-000821', NULL, 'Phosphotransferase', 128, NULL, NULL, 147881),
(147882, '2.30.30.100-FF-000002', NULL, 'Small nuclear ribonucleoprotein Sm D3', 84, NULL, NULL, 147882),
(147883, '1.10.1370.10-FF-000032', NULL, 'Metalloprotease', 364, NULL, NULL, 147883),
(147884, '1.20.1250.20-FF-001547', NULL, 'Major facilitator superfamily domain-containing protein', 418, NULL, NULL, 147884),
(147885, '1.10.1600.10-FF-000028', NULL, 'Uncharacterized protein', 80, NULL, NULL, 147885),
(147886, '1.10.238.10-FF-000956', NULL, 'Uncharacterized protein', 181, NULL, NULL, 147886),
(147887, '1.10.10.60-FF-000184', NULL, 'Chromodomain helicase DNA binding protein 6', 136, NULL, NULL, 147887),
(147888, '1.10.8.270-FF-000071', NULL, 'Uncharacterized protein', 102, NULL, NULL, 147888),
(147889, '2.40.50.140-FF-000156', NULL, 'DNA-directed RNA polymerase II subunit', 90, NULL, NULL, 147889);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(147890, '3.30.450.190-FF-000017', NULL, 'Uncharacterized protein', 124, NULL, NULL, 147890),
(147891, '2.40.100.10-FF-000048', NULL, 'Peptidyl-prolyl cis-trans isomerase', 182, NULL, NULL, 147891),
(147892, '2.40.33.40-FF-000002', NULL, 'Hypothetical PTS enzyme III glucitol', 121, NULL, NULL, 147892),
(147893, '3.80.10.10-FF-003680', NULL, 'Uncharacterized protein', 199, NULL, NULL, 147893),
(147894, '3.90.470.10-FF-000009', NULL, '39S ribosomal protein L22, mitochondrial', 165, NULL, NULL, 147894),
(147895, '3.80.10.10-FF-003354', NULL, 'Uncharacterized protein', 114, NULL, NULL, 147895),
(147896, '2.120.10.80-FF-000148', NULL, 'Muskelin, isoform C', 82, NULL, NULL, 147896),
(147897, '1.20.120.180-FF-000001', NULL, 'Proteasome activator complex subunit 3', 140, NULL, NULL, 147897),
(147898, '2.40.30.10-FF-000099', NULL, 'NADPH-dependent diflavin oxidoreductase 1', 89, NULL, NULL, 147898),
(147899, '2.40.30.10-FF-000436', NULL, 'Predicted protein', 86, NULL, NULL, 147899),
(147900, '2.60.40.420-FF-000104', NULL, 'Predicted protein', 113, NULL, NULL, 147900),
(147901, '3.30.160.60-FF-006489', NULL, NULL, 68, NULL, NULL, 147901),
(147902, '3.40.640.10-FF-000309', NULL, 'Histidinol-phosphate aminotransferase', 211, NULL, NULL, 147902),
(147903, '3.30.530.20-FF-000138', NULL, 'Phosphatidylinositol transfer protein', 276, NULL, NULL, 147903),
(147904, '3.10.20.90-FF-000885', NULL, 'LOC563577 protein', 57, NULL, NULL, 147904),
(147905, '1.25.10.10-FF-002631', NULL, 'Uncharacterized protein', 127, NULL, NULL, 147905),
(147906, '3.30.160.60-FF-005303', NULL, NULL, 30, NULL, NULL, 147906),
(147907, '3.20.20.70-FF-000379', NULL, 'Related to tRNA dihydrouridine synthase', 229, NULL, NULL, 147907),
(147908, '3.60.21.10-FF-000468', NULL, 'Serine/threonine-protein phosphatase', 120, NULL, NULL, 147908),
(147909, '1.25.10.10-FF-000377', NULL, 'Polyubiquitin binding protein (Doa1/Ufd3)', 283, NULL, NULL, 147909),
(147910, '2.30.180.10-FF-000095', NULL, NULL, 164, NULL, NULL, 147910),
(147911, '3.20.80.10-FF-000056', NULL, 'Uncharacterized protein', 144, NULL, NULL, 147911),
(147912, '2.170.140.10-FF-000014', NULL, 'Uncharacterized protein, isoform B', 69, NULL, NULL, 147912),
(147913, '3.30.40.10-FF-002082', NULL, 'Uncharacterized protein', 85, NULL, NULL, 147913),
(147914, '2.130.10.10-FF-002656', NULL, 'Uncharacterized protein', 268, NULL, NULL, 147914),
(147915, '1.10.20.10-FF-000248', NULL, NULL, 89, NULL, NULL, 147915),
(147916, '1.10.8.60-FF-000559', NULL, 'AFR371Wp', 135, NULL, NULL, 147916),
(147917, '3.40.50.300-FF-004186', NULL, 'RAS-related protein, putative', 150, NULL, NULL, 147917),
(147918, '1.20.120.350-FF-000193', NULL, NULL, 110, NULL, NULL, 147918),
(147919, '3.40.50.1000-FF-000634', NULL, NULL, 32, NULL, NULL, 147919),
(147920, '1.20.1250.20-FF-000024', NULL, 'Nitrite extrusion protein NarK', 461, NULL, NULL, 147920),
(147921, '3.40.50.1820-FF-001268', NULL, 'Carboxylic ester hydrolase', 542, NULL, NULL, 147921),
(147922, '2.40.50.730-FF-000024', NULL, 'DNA polymerase', 82, NULL, NULL, 147922),
(147923, '2.60.40.10-FF-000554', NULL, 'collagen alpha-1(XII) chain isoform X1', 101, NULL, NULL, 147923),
(147924, '1.25.40.180-FF-000200', NULL, NULL, 149, NULL, NULL, 147924),
(147925, '1.10.10.10-FF-000646', NULL, 'Transcriptional regulator, AsnC family', 51, NULL, NULL, 147925),
(147926, '3.40.50.300-FF-000487', NULL, 'Formate--tetrahydrofolate ligase', 304, NULL, NULL, 147926),
(147927, '3.40.50.300-FF-002948', NULL, 'DNA replication ATP-dependent helicase/nuclease DNA2', 150, NULL, NULL, 147927),
(147928, '1.10.150.20-FF-000093', NULL, 'Holliday junction ATP-dependent DNA helicase RuvA', 70, NULL, NULL, 147928),
(147929, '3.30.200.20-FF-001794', NULL, 'MRLK6', 103, NULL, NULL, 147929),
(147930, '2.120.10.80-FF-000362', NULL, 'Acyl-CoA binding protein', 258, NULL, NULL, 147930),
(147931, '2.40.70.10-FF-000219', NULL, NULL, 12, NULL, NULL, 147931),
(147932, '1.20.1250.10-FF-000021', NULL, 'Granulocyte colony-stimulating factor', 174, NULL, NULL, 147932),
(147933, '3.40.50.300-FF-008564', NULL, 'Mating factor M secretion protein mam1', 235, NULL, NULL, 147933);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(147934, '2.70.160.11-FF-000102', NULL, 'Uncharacterized protein', 201, NULL, NULL, 147934),
(147935, '1.20.5.420-FF-000006', NULL, 'Minichromosome maintenance 10 replication initiation factor', 29, NULL, NULL, 147935),
(147936, '3.40.50.300-FF-007041', NULL, 'Predicted protein', 200, NULL, NULL, 147936),
(147937, '1.25.10.10-FF-000714', NULL, 'Nipped-B protein', 430, NULL, NULL, 147937),
(147938, '1.20.144.10-FF-000135', NULL, 'Uncharacterized protein', 84, NULL, NULL, 147938),
(147939, '2.40.160.210-FF-000029', NULL, 'Uncharacterized protein', 101, NULL, NULL, 147939),
(147940, '1.10.510.10-FF-002905', NULL, NULL, 173, NULL, NULL, 147940),
(147941, '3.30.750.70-FF-000006', NULL, '4-hydroxybutyrate CoA transferase', 97, NULL, NULL, 147941),
(147942, '3.10.110.10-FF-000366', NULL, 'Uncharacterized protein', 131, NULL, NULL, 147942),
(147943, '2.130.10.10-FF-002982', NULL, 'Uncharacterized protein', 345, NULL, NULL, 147943),
(147944, '3.40.140.10-FF-000058', NULL, 'Phage tail protein', 106, NULL, NULL, 147944),
(147945, '1.25.40.10-FF-000216', NULL, 'MAU2 chromatid cohesion factor homolog', 213, NULL, NULL, 147945),
(147946, '2.130.10.10-FF-000195', NULL, 'Zinc finger protein 106', 161, NULL, NULL, 147946),
(147947, '2.70.98.110-FF-000013', NULL, 'Uncharacterized protein', 281, NULL, NULL, 147947),
(147948, '3.30.428.10-FF-000026', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 132, NULL, NULL, 147948),
(147949, '3.30.40.10-FF-001576', NULL, 'Ubiquitin conjugating enzyme interacting protein, putative (Fragment)', 91, NULL, NULL, 147949),
(147950, '3.40.50.2300-FF-000125', NULL, 'Vomeronasal 2, receptor 88', 137, NULL, NULL, 147950),
(147951, '3.40.50.2300-FF-000237', NULL, 'Arsenate reductase', 131, NULL, NULL, 147951),
(147952, '1.10.238.10-FF-000277', NULL, 'Mitochondrial Rho GTPase 1', 193, NULL, NULL, 147952),
(147953, '2.10.110.10-FF-000235', NULL, 'Uncharacterized protein', 82, NULL, NULL, 147953),
(147954, '2.60.40.150-FF-000361', NULL, 'C2 domain-containing protein', 130, NULL, NULL, 147954),
(147955, '2.10.110.10-FF-000123', NULL, 'Rho GTPase-activating protein', 92, NULL, NULL, 147955),
(147956, '3.30.310.80-FF-000004', NULL, 'Non-specific serine/threonine protein kinase', 117, NULL, NULL, 147956),
(147957, '2.30.30.40-FF-000524', NULL, 'Si:ch211-25d12.7', 69, NULL, NULL, 147957),
(147958, '2.60.40.10-FF-002892', NULL, 'Alpha-1-B glycoprotein', 88, NULL, NULL, 147958),
(147959, '3.30.40.10-FF-001688', NULL, 'Uncharacterized protein', 71, NULL, NULL, 147959),
(147960, '3.30.40.10-FF-000070', NULL, 'Histone-lysine N-methyltransferase', 44, NULL, NULL, 147960),
(147961, '2.60.40.60-FF-000299', NULL, 'Predicted protein', 98, NULL, NULL, 147961),
(147962, '2.60.120.260-FF-000138', NULL, 'Probable beta-galactosidase B', 144, NULL, NULL, 147962),
(147963, '3.80.10.10-FF-001437', NULL, 'Toll-4', 164, NULL, NULL, 147963),
(147964, '3.40.50.1100-FF-000097', NULL, 'L-serine ammonia-lyase, putative', 146, NULL, NULL, 147964),
(147965, '2.130.10.10-FF-002561', NULL, 'RIC1 homolog, RAB6A GEF complex partner 1', 252, NULL, NULL, 147965),
(147966, '3.20.20.100-FF-000010', NULL, 'NADPH-dependent aldo-keto reductase, chloroplastic', 310, NULL, NULL, 147966),
(147967, '1.10.287.1080-FF-000009', NULL, 'Nucleotide pyrophosphohydrolase', 99, NULL, NULL, 147967),
(147968, '2.60.120.260-FF-000026', NULL, 'proprotein convertase subtilisin/kexin type 7', 139, NULL, NULL, 147968),
(147969, '2.30.30.110-FF-000005', NULL, 'Endoribonuclease toxin ChpB', 109, NULL, NULL, 147969),
(147970, '2.30.29.30-FF-001069', NULL, 'Uncharacterized protein', 74, NULL, NULL, 147970),
(147971, '3.40.30.10-FF-000844', NULL, 'Predicted protein', 120, NULL, NULL, 147971),
(147972, '1.20.1250.20-FF-000350', NULL, 'Putative MFS superfamily transporter', 414, NULL, NULL, 147972),
(147973, '3.40.33.10-FF-000188', NULL, 'Uncharacterized protein', 156, NULL, NULL, 147973),
(147974, '3.40.50.300-FF-006552', NULL, 'Uncharacterized protein', 105, NULL, NULL, 147974),
(147975, '3.40.50.300-FF-002741', NULL, 'Cms1 ribosomal small subunit homolog', 94, NULL, NULL, 147975);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(147976, '3.30.465.10-FF-000112', NULL, 'Isoamyl alcohol oxidase, putative (AFU_orthologue AFUA_1G01180)', 231, NULL, NULL, 147976),
(147977, '1.10.150.240-FF-000038', NULL, 'HAD family hydrolase', 69, NULL, NULL, 147977),
(147978, '2.30.30.100-FF-000114', NULL, 'Small nuclear ribonucleoprotein G', 65, NULL, NULL, 147978),
(147979, '3.90.1660.10-FF-000001', NULL, 'Coenzyme F420:L-glutamate ligase', 56, NULL, NULL, 147979),
(147980, '1.25.10.10-FF-000591', NULL, 'Importin alpha re-exporter', 857, NULL, NULL, 147980),
(147981, '3.30.70.1600-FF-000002', NULL, NULL, 79, NULL, NULL, 147981),
(147982, '1.25.40.10-FF-000093', NULL, 'cell division cycle protein 23 homolog', 211, NULL, NULL, 147982),
(147983, '1.20.140.20-FF-000011', NULL, '[Pyruvate dehydrogenase (acetyl-transferring)] kinase isozyme 1, mitochondrial', 76, NULL, NULL, 147983),
(147984, '3.30.460.10-FF-000011', NULL, 'interleukin enhancer-binding factor 3 isoform X1', 139, NULL, NULL, 147984),
(147985, '2.60.40.10-FF-003994', NULL, NULL, 100, NULL, NULL, 147985),
(147986, '1.10.730.10-FF-000084', NULL, 'Leucyl-tRNA synthetase b', 116, NULL, NULL, 147986),
(147987, '3.10.450.10-FF-000066', NULL, 'Cystatin domain-containing 5', 61, NULL, NULL, 147987),
(147988, '3.40.50.150-FF-000953', NULL, NULL, 74, NULL, NULL, 147988),
(147989, '3.40.50.720-FF-001675', NULL, 'Erythronate-4-phosphate dehydrogenase', 111, NULL, NULL, 147989),
(147990, '1.25.10.10-FF-002743', NULL, 'Uncharacterized protein', 767, NULL, NULL, 147990),
(147991, '1.10.10.60-FF-000296', NULL, 'Scarecrow, isoform A', 81, NULL, NULL, 147991),
(147992, '3.30.830.10-FF-000068', NULL, 'Cytochrome b-c1 complex subunit 1, mitochondrial', 202, NULL, NULL, 147992),
(147993, '1.20.58.1040-FF-000005', NULL, '1,3-beta-glucanosyltransferase', 111, NULL, NULL, 147993),
(147994, '2.60.40.150-FF-000456', NULL, 'SYTF', 126, NULL, NULL, 147994),
(147995, '2.130.10.10-FF-000318', NULL, 'WD repeat-containing protein pop3', 71, NULL, NULL, 147995),
(147996, '3.40.50.300-FF-008238', NULL, 'Small nuclear ribonucleoprotein, U5 200kDa subunit', 56, NULL, NULL, 147996),
(147997, '3.30.200.20-FF-002406', NULL, 'Inactive serine/threonine-protein kinase/endoribonuclease IRE1-like', 89, NULL, NULL, 147997),
(147998, '2.60.120.330-FF-000188', NULL, 'Uncharacterized protein', 179, NULL, NULL, 147998),
(147999, '4.10.410.10-FF-000088', NULL, 'Predicted protein', 58, NULL, NULL, 147999),
(148000, '3.30.160.60-FF-004365', NULL, NULL, 70, NULL, NULL, 148000),
(148001, '3.20.140.10-FF-000023', NULL, 'Nicotinate phosphoribosyltransferase', 160, NULL, NULL, 148001),
(148002, '1.10.3290.10-FF-000009', NULL, 'Protein adenylyltransferase', 236, NULL, NULL, 148002),
(148003, '3.30.460.20-FF-000014', NULL, 'Magnesium and cobalt transporter CorA', 155, NULL, NULL, 148003),
(148004, '1.10.472.10-FF-000337', NULL, 'Uncharacterized protein', 97, NULL, NULL, 148004),
(148005, '2.20.70.10-FF-000260', NULL, 'Predicted protein', 44, NULL, NULL, 148005),
(148006, '1.20.1070.10-FF-000035', NULL, 'C-C chemokine receptor type 6', 309, NULL, NULL, 148006),
(148007, '2.40.30.130-FF-000060', NULL, 'Uncharacterized protein', 62, NULL, NULL, 148007),
(148008, '3.40.50.300-FF-004298', NULL, 'ATPase, putative', 148, NULL, NULL, 148008),
(148009, '1.20.140.40-FF-000017', NULL, 'Pectinesterase', 143, NULL, NULL, 148009),
(148010, '1.20.58.1030-FF-000002', NULL, 'DNA replication complex GINS protein SLD5', 153, NULL, NULL, 148010),
(148011, '2.40.50.140-FF-000044', NULL, '26S protease regulatory subunit 8', 105, NULL, NULL, 148011),
(148012, '3.90.1410.10-FF-000067', NULL, 'Uncharacterized protein', 334, NULL, NULL, 148012),
(148013, '3.40.190.10-FF-000095', NULL, 'Lactotransferrin', 164, NULL, NULL, 148013),
(148014, '2.30.30.40-FF-000619', NULL, 'Rho GTPase-activating protein 9', 46, NULL, NULL, 148014),
(148015, '3.90.70.10-FF-000737', NULL, 'Uncharacterized protein', 154, NULL, NULL, 148015),
(148016, '3.40.50.300-FF-002836', NULL, 'ATP-dependent Clp protease ATP-binding subunit ClpX', 273, NULL, NULL, 148016),
(148017, '1.10.510.10-FF-002810', NULL, NULL, 183, NULL, NULL, 148017);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(148018, '3.40.50.10810-FF-000215', NULL, 'Protein CBG05712', 90, NULL, NULL, 148018),
(148019, '1.10.10.10-FF-000534', NULL, 'Metallo-hydrolase/oxidoreductase superfamily protein', 74, NULL, NULL, 148019),
(148020, '3.20.180.20-FF-000040', NULL, 'Dynein heavy chain 4', 95, NULL, NULL, 148020),
(148021, '3.30.260.10-FF-000030', NULL, 'Probable CCT6-component of chaperonin-containing T-complex (Zeta subunit)', 112, NULL, NULL, 148021),
(148022, '2.70.170.10-FF-000063', NULL, 'Ligand-Gated ion Channel', 197, NULL, NULL, 148022),
(148023, '1.25.40.990-FF-000016', NULL, 'Si:zfos-452g4.1', 271, NULL, NULL, 148023),
(148024, '1.25.40.10-FF-004920', NULL, 'Uncharacterized protein', 64, NULL, NULL, 148024),
(148025, '3.90.1150.10-FF-000131', NULL, 'Glycine dehydrogenase [decarboxylating], mitochondrial', 11, NULL, NULL, 148025),
(148026, '1.10.287.830-FF-000001', NULL, NULL, 41, NULL, NULL, 148026),
(148027, '3.40.50.1820-FF-001835', NULL, 'Predicted protein', 83, NULL, NULL, 148027),
(148028, '1.10.533.10-FF-000137', NULL, 'Uncharacterized protein', 92, NULL, NULL, 148028),
(148029, '2.140.10.10-FF-000003', NULL, 'Methanol dehydrogenase, large subunit', 562, NULL, NULL, 148029),
(148030, '1.10.1450.10-FF-000084', NULL, 'Tetraspanin', 91, NULL, NULL, 148030),
(148031, '3.30.460.20-FF-000031', NULL, 'Putative metal ion transporter C27B12.12c', 175, NULL, NULL, 148031),
(148032, '3.30.2070.10-FF-000003', NULL, 'Formate dehydrogenase', 24, NULL, NULL, 148032),
(148033, '3.30.710.10-FF-000121', NULL, 'BTB/POZ domain-containing protein KCTD11', 81, NULL, NULL, 148033),
(148034, '1.10.275.40-FF-000017', NULL, 'Nucleotide excision repair protein ERCC2', 88, NULL, NULL, 148034),
(148035, '3.100.10.10-FF-000012', NULL, 'Mitochondrial ribosomal protein L15', 87, NULL, NULL, 148035),
(148036, '2.60.40.60-FF-000866', NULL, 'Uncharacterized protein', 103, NULL, NULL, 148036),
(148037, '1.10.10.10-FF-000293', NULL, 'Tigger transposable element-derived protein 5', 63, NULL, NULL, 148037),
(148038, '2.60.120.260-FF-000240', NULL, 'Probable E3 ubiquitin-protein ligase HERC2', 152, NULL, NULL, 148038),
(148039, '3.30.1490.100-FF-000008', NULL, 'DNA polymerase V subunit', 111, NULL, NULL, 148039),
(148040, '1.10.510.10-FF-004367', NULL, NULL, 106, NULL, NULL, 148040),
(148041, '2.60.40.1170-FF-000063', NULL, 'AdaPtin, Mu/medium chain (Clathrin associated complex)', 106, NULL, NULL, 148041),
(148042, '2.60.40.60-FF-001142', NULL, 'Uncharacterized protein', 88, NULL, NULL, 148042),
(148043, '3.90.550.10-FF-000292', NULL, 'Family 2 glycosyl transferase', 190, NULL, NULL, 148043),
(148044, '2.60.260.20-FF-000108', NULL, 'Cobalamin ABC transporter permease', 75, NULL, NULL, 148044),
(148045, '1.10.10.60-FF-000307', NULL, 'Eyegone, isoform A', 64, NULL, NULL, 148045),
(148046, '3.80.10.10-FF-003707', NULL, 'Putative leucine-rich repeat-containing protein DDB_G0281931', 158, NULL, NULL, 148046),
(148047, '2.30.42.10-FF-000306', NULL, 'GRASP65 homolog protein 1', 132, NULL, NULL, 148047),
(148048, '3.30.870.10-FF-000177', NULL, 'Mitochondrial cardiolipin hydrolase-like Protein', 166, NULL, NULL, 148048),
(148049, '1.10.287.980-FF-000001', NULL, 'Cytochrome b6-f complex subunit 4', 93, NULL, NULL, 148049),
(148050, '2.10.25.10-FF-001667', NULL, 'Eosinophil peroxidase', 68, NULL, NULL, 148050),
(148051, '3.30.70.3290-FF-000008', NULL, 'Yersiniabactin polyketide/non-ribosomal peptide synthetase', 127, NULL, NULL, 148051),
(148052, '3.30.565.10-FF-000064', NULL, 'Phytochrome', 161, NULL, NULL, 148052),
(148053, '1.10.110.10-FF-000008', NULL, 'BnaCnng36210D protein', 82, NULL, NULL, 148053),
(148054, '2.170.120.12-FF-000015', NULL, 'DNA-directed RNA polymerase subunit alpha', 128, NULL, NULL, 148054),
(148055, '2.130.10.130-FF-000039', NULL, NULL, 180, NULL, NULL, 148055),
(148056, '3.40.190.10-FF-000662', NULL, 'Bacterial extracellular solute-binding protein, family 5', 119, NULL, NULL, 148056),
(148057, '1.10.287.690-FF-000021', NULL, 'Predicted protein', 60, NULL, NULL, 148057),
(148058, '2.60.40.1180-FF-000066', NULL, 'Alpha,alpha-phosphotrehalase', 63, NULL, NULL, 148058);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(148059, '3.30.540.10-FF-000080', NULL, 'Ammonium transport protein', 150, NULL, NULL, 148059),
(148060, '1.10.357.10-FF-000019', NULL, 'LuxR family transcriptional regulator', 203, NULL, NULL, 148060),
(148061, '1.20.120.1750-FF-000147', NULL, 'RBR-type E3 ubiquitin transferase', 99, NULL, NULL, 148061),
(148062, '3.10.450.50-FF-000050', NULL, 'Benzoate 1,2-dioxygenase small subunit', 161, NULL, NULL, 148062),
(148063, '3.30.200.20-FF-001917', NULL, 'Ribosomal protein S6 kinase', 68, NULL, NULL, 148063),
(148064, '1.20.5.1160-FF-000041', NULL, 'Neurofilament heavy polypeptide', 82, NULL, NULL, 148064),
(148065, '2.60.40.10-FF-006068', NULL, NULL, 124, NULL, NULL, 148065),
(148066, '2.30.30.850-FF-000002', NULL, 'Uncharacterized protein', 83, NULL, NULL, 148066),
(148067, '2.40.110.10-FF-000088', NULL, 'Predicted protein', 97, NULL, NULL, 148067),
(148068, '1.20.82.10-FF-000003', NULL, 'Uncharacterized protein', 61, NULL, NULL, 148068),
(148069, '2.130.10.10-FF-003050', NULL, 'WD-40 repeat protein', 146, NULL, NULL, 148069),
(148070, '3.20.140.10-FF-000040', NULL, 'NAPRTase', 150, NULL, NULL, 148070),
(148071, '3.40.50.720-FF-002501', NULL, 'Uncharacterized protein', 146, NULL, NULL, 148071),
(148072, '1.10.3720.10-FF-000189', NULL, 'ABC transporter permease', 195, NULL, NULL, 148072),
(148073, '2.130.10.10-FF-000644', NULL, 'Rrp9p', 420, NULL, NULL, 148073),
(148074, '1.25.40.90-FF-000060', NULL, 'Uncharacterized protein', 128, NULL, NULL, 148074),
(148075, '3.40.50.10190-FF-000299', NULL, 'DNA ligase', 107, NULL, NULL, 148075),
(148076, '1.10.510.10-FF-000444', NULL, 'probable L-type lectin-domain containing receptor kinase S.5', 201, NULL, NULL, 148076),
(148077, '3.30.420.10-FF-000014', NULL, 'Piwi-like RNA-mediated gene silencing 1', 237, NULL, NULL, 148077),
(148078, '1.10.3460.10-FF-000040', NULL, 'Pt17531-like protein', 189, NULL, NULL, 148078),
(148079, '3.90.190.20-FF-000070', NULL, 'Folylpolyglutamate synthase', 171, NULL, NULL, 148079),
(148080, '1.20.1310.10-FF-000105', NULL, 'Protein CBG17039', 149, NULL, NULL, 148080),
(148081, '3.40.630.10-FF-000258', NULL, 'Uncharacterized protein', 323, NULL, NULL, 148081),
(148082, '3.30.160.60-FF-000880', NULL, 'Zinc finger protein', 32, NULL, NULL, 148082),
(148083, '1.50.40.10-FF-000484', NULL, 'mitochondrial dicarboxylate carrier-like', 277, NULL, NULL, 148083),
(148084, '3.30.497.10-FF-000129', NULL, 'Serpin peptidase inhibitor, clade E (nexin, plasminogen activator inhibitor type 1), member 2', 140, NULL, NULL, 148084),
(148085, '3.90.226.10-FF-000044', NULL, 'Retinol-binding protein 3', 207, NULL, NULL, 148085),
(148086, '3.40.50.300-FF-006198', NULL, 'Predicted protein', 126, NULL, NULL, 148086),
(148087, '3.40.50.300-FF-001313', NULL, 'Helicase with zinc finger domain 2', 220, NULL, NULL, 148087),
(148088, '1.10.1660.10-FF-000021', NULL, 'Transcriptional regulator, MerR family', 72, NULL, NULL, 148088),
(148089, '3.90.1150.10-FF-000243', NULL, 'Transcriptional regulator, GntR family', 149, NULL, NULL, 148089),
(148090, '3.10.10.10-FF-000052', NULL, NULL, 93, NULL, NULL, 148090),
(148091, '3.10.100.10-FF-000422', NULL, NULL, 84, NULL, NULL, 148091),
(148092, '3.40.309.10-FF-000130', NULL, 'Uncharacterized protein', 100, NULL, NULL, 148092),
(148093, '2.70.130.10-FF-000066', NULL, NULL, 124, NULL, NULL, 148093),
(148094, '1.10.150.20-FF-000121', NULL, 'DNA-directed RNA polymerase subunit alpha', 78, NULL, NULL, 148094),
(148095, '2.60.40.10-FF-005888', NULL, NULL, 83, NULL, NULL, 148095),
(148096, '3.40.50.720-FF-000601', NULL, 'Fatty acyl-CoA reductase', 270, NULL, NULL, 148096),
(148097, '2.60.40.10-FF-001043', NULL, 'TAP binding protein', 138, NULL, NULL, 148097),
(148098, '3.20.20.100-FF-000122', NULL, 'L-galactose dehydrogenase isoform A', 132, NULL, NULL, 148098),
(148099, '3.40.50.1980-FF-000091', NULL, 'Periplasmic solute binding family protein', 160, NULL, NULL, 148099),
(148100, '3.90.70.10-FF-000288', NULL, 'Gamete and mating-type specific protein A', 241, NULL, NULL, 148100),
(148101, '1.10.3720.10-FF-000105', NULL, 'Lactose transport system permease protein LacF', 257, NULL, NULL, 148101);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(148102, '3.30.40.10-FF-001593', NULL, 'PHd Finger family', 56, NULL, NULL, 148102),
(148103, '1.10.12.70-FF-000005', NULL, 'Germinal center kinase 1', 66, NULL, NULL, 148103),
(148104, '1.25.40.20-FF-001146', NULL, 'Putative E3 ubiquitin-protein ligase XBAT35', 144, NULL, NULL, 148104),
(148105, '1.20.1050.10-FF-000040', NULL, 'chloride intracellular channel exc-4', 146, NULL, NULL, 148105),
(148106, '3.30.60.20-FF-000068', NULL, 'Serine/threonine-protein kinase D2', 64, NULL, NULL, 148106),
(148107, '3.30.160.60-FF-004477', NULL, NULL, 42, NULL, NULL, 148107),
(148108, '3.30.200.20-FF-002069', NULL, 'Protein kinase, putative', 85, NULL, NULL, 148108),
(148109, '3.90.550.10-FF-000533', NULL, 'Glycosyl transferase, group 2 family', 244, NULL, NULL, 148109),
(148110, '2.60.40.10-FF-004039', NULL, NULL, 97, NULL, NULL, 148110),
(148111, '3.10.100.10-FF-000197', NULL, 'Adhesion G-protein coupled receptor D1', 138, NULL, NULL, 148111),
(148112, '3.90.870.30-FF-000001', NULL, 'Carbamoyltransferase HypF', 202, NULL, NULL, 148112),
(148113, '3.30.160.60-FF-000554', NULL, 'protein indeterminate-domain 12-like', 69, NULL, NULL, 148113),
(148114, '2.130.10.10-FF-002218', NULL, 'AT18160p', 154, NULL, NULL, 148114),
(148115, '3.40.50.300-FF-006338', NULL, 'Uncharacterized protein', 264, NULL, NULL, 148115),
(148116, '1.10.472.10-FF-000107', NULL, 'Cyclin-D5-1', 96, NULL, NULL, 148116),
(148117, '2.60.40.10-FF-002471', NULL, 'Os10g0200000 protein', 124, NULL, NULL, 148117),
(148118, '3.40.50.620-FF-000122', NULL, 'Glutamate--tRNA ligase', 122, NULL, NULL, 148118),
(148119, '1.10.1170.10-FF-000051', NULL, 'Uncharacterized protein', 98, NULL, NULL, 148119),
(148120, '2.30.42.10-FF-000402', NULL, NULL, 111, NULL, NULL, 148120),
(148121, '3.20.20.80-FF-000123', NULL, 'Beta-galactosidase', 283, NULL, NULL, 148121),
(148122, '3.30.230.70-FF-000085', NULL, 'Polyribonucleotide nucleotidyltransferase', 316, NULL, NULL, 148122),
(148123, '2.60.200.20-FF-000088', NULL, 'PROBABLE CONSERVED TRANSMEMBRANE ATP-BINDING PROTEIN ABC TRANSPORTER', 100, NULL, NULL, 148123),
(148124, '2.30.130.40-FF-000022', NULL, 'Lon protease', 115, NULL, NULL, 148124),
(148125, '3.40.50.300-FF-002269', NULL, 'ABC transporter B family member 7', 125, NULL, NULL, 148125),
(148126, '1.10.287.90-FF-000009', NULL, 'Cytochrome c oxidase subunit 2', 77, NULL, NULL, 148126),
(148127, '3.80.20.20-FF-000075', NULL, 'Uncharacterized protein', 166, NULL, NULL, 148127),
(148128, '1.10.287.70-FF-000003', NULL, 'Sodium channel protein', 143, NULL, NULL, 148128),
(148129, '2.70.150.10-FF-000275', NULL, 'Cation-transporting ATPase 5', 154, NULL, NULL, 148129),
(148130, '3.30.420.40-FF-000793', NULL, 'Uncharacterized protein', 76, NULL, NULL, 148130),
(148131, '1.20.1540.10-FF-000010', NULL, 'Rhomboid-like protein 15', 198, NULL, NULL, 148131),
(148132, '4.10.640.40-FF-000001', NULL, 'Cytoplasmic polyadenylation element-binding 2 isoform X2', 65, NULL, NULL, 148132),
(148133, '2.130.10.10-FF-004573', NULL, 'Uncharacterized protein', 211, NULL, NULL, 148133),
(148134, '3.30.450.40-FF-000295', NULL, 'Acetoin catabolism regulatory protein', 193, NULL, NULL, 148134),
(148135, '1.20.1270.60-FF-000003', NULL, 'arfaptin-2 isoform X1', 201, NULL, NULL, 148135),
(148136, '3.40.50.1820-FF-000071', NULL, 'Embryogenesis-associated protein EMB8', 272, NULL, NULL, 148136),
(148137, '1.10.4100.10-FF-000002', NULL, 'Aconitate decarboxylase 1', 264, NULL, NULL, 148137),
(148138, '1.10.287.80-FF-000006', NULL, 'ATP synthase gamma chain', 57, NULL, NULL, 148138),
(148139, '1.20.5.1300-FF-000004', NULL, 'Histidinol dehydrogenase', 54, NULL, NULL, 148139),
(148140, '3.30.70.330-FF-000047', NULL, 'Differentiation 1 negative regulator', 96, NULL, NULL, 148140),
(148141, '3.30.160.60-FF-001037', NULL, 'zinc finger protein 566 isoform X2', 28, NULL, NULL, 148141),
(148142, '3.40.50.300-FF-004753', NULL, 'Predicted protein', 234, NULL, NULL, 148142),
(148143, '3.40.50.720-FF-000040', NULL, 'UDP-glucose 4-epimerase', 219, NULL, NULL, 148143),
(148144, '1.25.40.10-FF-000328', NULL, 'protein CTR9 homolog', 328, NULL, NULL, 148144);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(148145, '3.40.50.1000-FF-000297', NULL, 'BnaAnng05460D protein', 55, NULL, NULL, 148145),
(148146, '1.20.1250.20-FF-001452', NULL, 'Amino acid/peptide transporter', 232, NULL, NULL, 148146),
(148147, '3.30.70.330-FF-000614', NULL, 'Mrp20p', 134, NULL, NULL, 148147),
(148148, '3.10.110.10-FF-000254', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 116, NULL, NULL, 148148),
(148149, '1.25.10.10-FF-003002', NULL, 'Tubulin-specific chaperone d', 594, NULL, NULL, 148149),
(148150, '3.40.50.2000-FF-000254', NULL, 'Trehalose 6-P phosphatase', 340, NULL, NULL, 148150),
(148151, '3.50.50.60-FF-000511', NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase, mitochondrial', 128, NULL, NULL, 148151),
(148152, '2.60.120.560-FF-000009', NULL, 'Beta-fructofuranosidase, putative', 157, NULL, NULL, 148152),
(148153, '1.25.10.10-FF-002390', NULL, 'Nipped-B-like protein pqn-85', 263, NULL, NULL, 148153),
(148154, '1.10.10.60-FF-000633', NULL, 'TCP pilus virulence regulatory protein ToxT', 65, NULL, NULL, 148154),
(148155, '3.90.79.10-FF-000162', NULL, 'Adenine DNA glycosylase', 126, NULL, NULL, 148155),
(148156, '3.40.50.720-FF-001658', NULL, 'Os06g0299200 protein', 166, NULL, NULL, 148156),
(148157, '1.25.10.10-FF-002726', NULL, 'Uncharacterized protein', 917, NULL, NULL, 148157),
(148158, '1.10.418.10-FF-000049', NULL, 'Rho guanine nucleotide exchange factor 7 isoform X1', 116, NULL, NULL, 148158),
(148159, '3.40.50.1820-FF-001509', NULL, 'Uncharacterized protein', 153, NULL, NULL, 148159),
(148160, '1.25.40.10-FF-002228', NULL, 'Uncharacterized protein', 334, NULL, NULL, 148160),
(148161, '2.60.40.150-FF-000809', NULL, 'Uncharacterized protein', 133, NULL, NULL, 148161),
(148162, '1.25.10.10-FF-000826', NULL, 'Uncharacterized protein', 428, NULL, NULL, 148162),
(148163, '2.30.29.30-FF-000321', NULL, 'Oxysterol-binding protein-related protein 1C', 99, NULL, NULL, 148163),
(148164, '3.40.50.620-FF-000105', NULL, 'Isoleucine--tRNA ligase cytoplasmic', 279, NULL, NULL, 148164),
(148165, '1.10.10.10-FF-000860', NULL, 'MarR family transcriptional regulator', 136, NULL, NULL, 148165),
(148166, '1.25.40.10-FF-004257', NULL, 'Uncharacterized protein', 227, NULL, NULL, 148166),
(148167, '1.20.1310.10-FF-000189', NULL, NULL, 107, NULL, NULL, 148167),
(148168, '1.10.287.80-FF-000023', NULL, 'ATP synthase gamma chain, chloroplastic', 99, NULL, NULL, 148168),
(148169, '2.30.30.40-FF-000636', NULL, 'Si:dkey-40c11.2', 84, NULL, NULL, 148169),
(148170, '3.30.200.20-FF-002165', NULL, 'Os11g0664100 protein', 64, NULL, NULL, 148170),
(148171, '3.30.1390.20-FF-000036', NULL, 'Uncharacterized protein', 102, NULL, NULL, 148171),
(148172, '3.40.190.10-FF-000336', NULL, 'Unplaced genomic scaffold supercont1.18, whole genome shotgun sequence', 105, NULL, NULL, 148172),
(148173, '3.30.200.20-FF-000271', NULL, 'MAPK/MAK/MRK overlapping kinase', 81, NULL, NULL, 148173),
(148174, '2.40.10.10-FF-000199', NULL, 'Trypsin, putative', 249, NULL, NULL, 148174),
(148175, '3.30.160.60-FF-002448', NULL, 'Zinc finger protein 430', 37, NULL, NULL, 148175),
(148176, '1.10.1170.10-FF-000034', NULL, 'X-linked inhibitor of apoptosis', 74, NULL, NULL, 148176),
(148177, '1.10.287.90-FF-000026', NULL, 'Cytochrome c oxidase subunit 2', 93, NULL, NULL, 148177),
(148178, '2.40.50.140-FF-000370', NULL, 'Eukaryotic translation initiation factor 1A', 149, NULL, NULL, 148178),
(148179, '3.40.50.1980-FF-000118', NULL, 'Iron(III) dicitrate-binding periplasmic protein', 106, NULL, NULL, 148179),
(148180, '3.40.50.2300-FF-000142', NULL, 'Two-component system response regulator RstA', 119, NULL, NULL, 148180),
(148181, '3.30.50.10-FF-000008', NULL, 'estrogen-related receptor gamma isoform X1', 102, NULL, NULL, 148181),
(148182, '1.10.287.70-FF-000020', NULL, 'Potassium channel, voltage-gated eag-related subfamily H, member 7', 260, NULL, NULL, 148182),
(148183, '1.10.10.60-FF-000279', NULL, 'Sugar-binding transcriptional regulator', 50, NULL, NULL, 148183),
(148184, '1.20.1070.10-FF-000361', NULL, 'Dopamine receptor D4', 217, NULL, NULL, 148184);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(148185, '2.60.40.10-FF-004606', NULL, NULL, 90, NULL, NULL, 148185),
(148186, '3.40.50.300-FF-002499', NULL, 'Deoxynucleotide monophosphate kinase', 112, NULL, NULL, 148186),
(148187, '1.20.1250.20-FF-001659', NULL, 'Uncharacterized protein', 161, NULL, NULL, 148187),
(148188, '1.10.10.10-FF-000197', NULL, 'RNA polymerase sigma factor', 82, NULL, NULL, 148188),
(148189, '1.10.1410.10-FF-000087', NULL, 'Nucleolar protein 6', 128, NULL, NULL, 148189),
(148190, '3.40.50.300-FF-000824', NULL, 'Iron ABC transporter ATP-binding protein', 244, NULL, NULL, 148190),
(148191, '3.40.50.10260-FF-000005', NULL, 'NAD(P)H-hydrate epimerase', 230, NULL, NULL, 148191),
(148192, '3.30.70.330-FF-002205', NULL, NULL, 157, NULL, NULL, 148192),
(148193, '2.60.40.150-FF-000782', NULL, 'Uncharacterized protein', 96, NULL, NULL, 148193),
(148194, '2.10.50.30-FF-000017', NULL, 'Vomeronasal 2 receptor, 31', 71, NULL, NULL, 148194),
(148195, '3.30.200.20-FF-001889', NULL, 'Proline-rich receptor-like protein kinase PERK1', 80, NULL, NULL, 148195),
(148196, '2.160.10.10-FF-000047', NULL, 'Glucose-1-phosphate adenylyltransferase', 122, NULL, NULL, 148196),
(148197, '2.130.10.10-FF-005984', NULL, 'Uncharacterized protein', 230, NULL, NULL, 148197),
(148198, '3.30.590.10-FF-000032', NULL, 'Glutamine synthetase', 327, NULL, NULL, 148198),
(148199, '3.30.70.330-FF-002301', NULL, NULL, 150, NULL, NULL, 148199),
(148200, '3.30.160.60-FF-006377', NULL, NULL, 29, NULL, NULL, 148200),
(148201, '1.20.120.1750-FF-000164', NULL, 'RBR-type E3 ubiquitin transferase', 193, NULL, NULL, 148201),
(148202, '1.10.510.10-FF-002782', NULL, 'Kinase, NEK', 311, NULL, NULL, 148202),
(148203, '2.60.40.1180-FF-000049', NULL, 'Alpha-galactosidase', 109, NULL, NULL, 148203),
(148204, '4.10.70.10-FF-000008', NULL, NULL, 50, NULL, NULL, 148204),
(148205, '3.10.20.90-FF-000559', NULL, 'Uncharacterized protein', 77, NULL, NULL, 148205),
(148206, '1.20.58.60-FF-000422', NULL, 'AGAP007562-PA', 283, NULL, NULL, 148206),
(148207, '2.60.40.1170-FF-000046', NULL, 'AP-1 complex subunit mu-2', 109, NULL, NULL, 148207),
(148208, '1.10.10.60-FF-001122', NULL, NULL, 64, NULL, NULL, 148208),
(148209, '1.20.1070.10-FF-001463', NULL, 'Predicted protein', 215, NULL, NULL, 148209),
(148210, '3.40.50.80-FF-000124', NULL, 'Ferric-chelate reductase', 169, NULL, NULL, 148210),
(148211, '3.90.230.10-FF-000037', NULL, NULL, 44, NULL, NULL, 148211),
(148212, '3.40.30.10-FF-000389', NULL, 'Possible conserved membrane or secreted protein', 198, NULL, NULL, 148212),
(148213, '3.40.50.150-FF-001116', NULL, NULL, 96, NULL, NULL, 148213),
(148214, '2.10.25.10-FF-001460', NULL, 'Laminin subunit alpha-1-like Protein', 41, NULL, NULL, 148214),
(148215, '3.10.20.10-FF-000007', NULL, 'DNA fragmentation factor subunit alpha', 100, NULL, NULL, 148215),
(148216, '2.120.10.80-FF-000036', NULL, 'Attractin like 1', 162, NULL, NULL, 148216),
(148217, '1.25.10.10-FF-000265', NULL, 'Serine/threonine-protein kinase TOR', 169, NULL, NULL, 148217),
(148218, '2.120.10.30-FF-000257', NULL, 'Sortilin-related receptor, L(DLR class) A repeats containing', 136, NULL, NULL, 148218),
(148219, '2.60.40.10-FF-000880', NULL, 'Vascular endothelial growth factor receptor 2', 121, NULL, NULL, 148219),
(148220, '2.40.70.10-FF-000096', NULL, 'Basic 7S globulin', 199, NULL, NULL, 148220),
(148221, '3.30.40.10-FF-002205', NULL, 'E3 ubiquitin-protein ligase mind-bomb-like Protein', 72, NULL, NULL, 148221),
(148222, '3.40.47.10-FF-000242', NULL, NULL, 32, NULL, NULL, 148222),
(148223, '1.20.1250.20-FF-001098', NULL, 'Transport protein', 442, NULL, NULL, 148223),
(148224, '1.20.1280.50-FF-000187', NULL, 'F-box/WD repeat-containing protein 4-like isoform X1', 74, NULL, NULL, 148224),
(148225, '1.10.8.710-FF-000034', NULL, NULL, 40, NULL, NULL, 148225),
(148226, '3.40.50.880-FF-000060', NULL, 'Peptidase E', 218, NULL, NULL, 148226),
(148227, '3.30.1370.10-FF-000150', NULL, 'Drosophila dodeca-satellite protein 1', 79, NULL, NULL, 148227),
(148228, '3.30.40.10-FF-000053', NULL, 'protein AF-10 isoform X2', 60, NULL, NULL, 148228);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(148229, '1.10.510.10-FF-000882', NULL, 'Mitogen-activated protein kinase kinase kinase 17', 295, NULL, NULL, 148229),
(148230, '3.30.40.10-FF-001929', NULL, 'MARCH (Membrane-Associated Ring finger (C3HC4)) homolog', 70, NULL, NULL, 148230),
(148231, '2.130.10.10-FF-002544', NULL, 'Hybrid sensor histidine kinase/response regulator', 304, NULL, NULL, 148231),
(148232, '1.10.8.720-FF-000037', NULL, 'Dynein heavy chain', 178, NULL, NULL, 148232),
(148233, '3.30.70.330-FF-002076', NULL, NULL, 83, NULL, NULL, 148233),
(148234, '3.30.450.20-FF-000412', NULL, 'Hybrid signal transduction histidine kinase B', 120, NULL, NULL, 148234),
(148235, '3.40.30.10-FF-000827', NULL, 'Protein disulfide isomerase 2', 141, NULL, NULL, 148235),
(148236, '2.70.170.10-FF-000287', NULL, 'Uncharacterized protein', 56, NULL, NULL, 148236),
(148237, '3.40.190.10-FF-000550', NULL, 'LysR family transcriptional regulator', 95, NULL, NULL, 148237),
(148238, '1.10.10.10-FF-001023', NULL, 'LysR family transcriptional regulator', 83, NULL, NULL, 148238),
(148239, '3.30.160.60-FF-004606', NULL, NULL, 53, NULL, NULL, 148239),
(148240, '3.10.620.10-FF-000006', NULL, 'Uncharacterized protein', 95, NULL, NULL, 148240),
(148241, '3.30.310.40-FF-000021', NULL, '8-oxoguanine DNA glycosylase', 74, NULL, NULL, 148241),
(148242, '2.170.270.10-FF-000018', NULL, 'PR domain zinc finger protein 12', 174, NULL, NULL, 148242),
(148243, '3.30.160.60-FF-003988', NULL, NULL, 50, NULL, NULL, 148243),
(148244, '3.90.70.10-FF-000075', NULL, 'Ubiquitin carboxyl-terminal hydrolase creB', 368, NULL, NULL, 148244),
(148245, '3.30.390.50-FF-000028', NULL, 'Putative lipoate-protein ligase A', 54, NULL, NULL, 148245),
(148246, '2.60.200.20-FF-000217', NULL, 'Predicted protein', 118, NULL, NULL, 148246),
(148247, '3.90.180.10-FF-000021', NULL, 'Galactitol-1-phosphate 5-dehydrogenase', 172, NULL, NULL, 148247),
(148248, '3.30.70.20-FF-000119', NULL, NULL, 103, NULL, NULL, 148248),
(148249, '3.80.10.10-FF-002977', NULL, 'Uncharacterized protein', 100, NULL, NULL, 148249),
(148250, '3.40.50.300-FF-004427', NULL, 'Small GTPase superfamily', 172, NULL, NULL, 148250),
(148251, '3.30.1370.50-FF-000015', NULL, 'Uncharacterized protein', 140, NULL, NULL, 148251),
(148252, '3.30.160.360-FF-000008', NULL, 'Histone-lysine N-methyltransferase', 138, NULL, NULL, 148252),
(148253, '1.25.10.10-FF-002176', NULL, 'Predicted protein', 475, NULL, NULL, 148253),
(148254, '3.30.420.40-FF-000580', NULL, 'Actin, putative', 147, NULL, NULL, 148254),
(148255, '3.30.565.10-FF-000176', NULL, 'PAS domain-containing sensor histidine kinase', 154, NULL, NULL, 148255),
(148256, '1.10.510.10-FF-002355', NULL, NULL, 191, NULL, NULL, 148256),
(148257, '3.40.50.300-FF-001190', NULL, 'GTP-binding protein ERG', 192, NULL, NULL, 148257),
(148258, '1.10.150.570-FF-000002', NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme GidA', 54, NULL, NULL, 148258),
(148259, '3.30.160.60-FF-000762', NULL, 'Zinc finger and BTB domain-containing 14', 28, NULL, NULL, 148259),
(148260, '1.10.10.440-FF-000069', NULL, 'WW domain-containing protein ZK1098.1', 78, NULL, NULL, 148260),
(148261, '3.40.50.2300-FF-001199', NULL, NULL, 119, NULL, NULL, 148261),
(148262, '3.20.20.70-FF-000828', NULL, NULL, 140, NULL, NULL, 148262),
(148263, '2.60.40.150-FF-000810', NULL, 'Uncharacterized protein', 133, NULL, NULL, 148263),
(148264, '1.10.10.10-FF-002119', NULL, 'Uncharacterized HTH-type transcriptional regulator HI_0224', 51, NULL, NULL, 148264),
(148265, '1.10.472.10-FF-000225', NULL, 'CyCliN K', 139, NULL, NULL, 148265),
(148266, '3.30.40.10-FF-000620', NULL, 'Tripartite motif-containing 38, isoform CRA_a', 90, NULL, NULL, 148266),
(148267, '3.30.470.30-FF-000080', NULL, 'mRNA-capping enzyme', 68, NULL, NULL, 148267),
(148268, '2.60.40.1360-FF-000013', NULL, 'Alpha-mannosidase C', 94, NULL, NULL, 148268),
(148269, '1.10.760.10-FF-000035', NULL, 'Cytochrome C Snr1', 122, NULL, NULL, 148269),
(148270, '1.25.40.20-FF-000657', NULL, 'Ankyrin repeat and SOCS box-containing 2b', 93, NULL, NULL, 148270),
(148271, '2.30.29.30-FF-000107', NULL, 'Tyrosine-protein phosphatase non-receptor type 13', 102, NULL, NULL, 148271);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(148272, '1.20.1110.10-FF-000096', NULL, 'Na+/K+ ATPase alpha subunit isoform 1', 151, NULL, NULL, 148272),
(148273, '1.20.140.90-FF-000004', NULL, 'Malonyl-CoA decarboxylase', 142, NULL, NULL, 148273),
(148274, '1.20.1070.10-FF-000153', NULL, 'Neuropeptide FF receptor 1', 350, NULL, NULL, 148274),
(148275, '3.80.10.10-FF-003578', NULL, 'Uncharacterized protein', 141, NULL, NULL, 148275),
(148276, '2.130.10.10-FF-000857', NULL, 'WD-40 repeat-containing protein MSI4', 455, NULL, NULL, 148276),
(148277, '2.60.40.1210-FF-000002', NULL, 'MOXD1 homolog 2', 132, NULL, NULL, 148277),
(148278, '2.130.10.10-FF-000756', NULL, 'striatin-4 isoform X2', 132, NULL, NULL, 148278),
(148279, '3.40.50.2000-FF-000703', NULL, 'Phosphatidylinositol N-acetylglucosaminyltransferase subunit A', 178, NULL, NULL, 148279),
(148280, '3.40.190.10-FF-000123', NULL, 'HIS1p ATP phosphoribosyltransferase', 97, NULL, NULL, 148280),
(148281, '1.20.1250.20-FF-001901', NULL, 'Protein NRT1/ PTR FAMILY 8.3', 53, NULL, NULL, 148281),
(148282, '2.40.50.140-FF-000605', NULL, 'Ribosomal protein S12 methylthiotransferase RimO', 61, NULL, NULL, 148282),
(148283, '1.20.1560.10-FF-000117', NULL, 'ABC transporter ATP-binding protein', 319, NULL, NULL, 148283),
(148284, '2.70.20.10-FF-000013', NULL, 'DNA topoisomerase', 128, NULL, NULL, 148284),
(148285, '6.20.10.30-FF-000005', NULL, 'DNA ligase', 31, NULL, NULL, 148285),
(148286, '3.50.50.60-FF-000056', NULL, 'Dihydropyrimidine dehydrogenase [NADP(+)]', 135, NULL, NULL, 148286),
(148287, '1.20.1250.20-FF-001890', NULL, 'Uncharacterized protein', 83, NULL, NULL, 148287),
(148288, '1.20.140.80-FF-000001', NULL, 'Transcription factor', 151, NULL, NULL, 148288),
(148289, '1.10.238.180-FF-000004', NULL, 'Predicted protein', 78, NULL, NULL, 148289),
(148290, '2.60.40.60-FF-000754', NULL, 'Hedgehog protein', 107, NULL, NULL, 148290),
(148291, '1.25.10.10-FF-001080', NULL, 'Armadillo repeat only 4', 182, NULL, NULL, 148291),
(148292, '3.40.630.10-FF-000146', NULL, 'Peptidase M28', 273, NULL, NULL, 148292),
(148293, '1.10.10.60-FF-000846', NULL, NULL, 99, NULL, NULL, 148293),
(148294, '3.40.50.1820-FF-000200', NULL, 'Serine protease 16', 131, NULL, NULL, 148294),
(148295, '3.40.50.300-FF-001201', NULL, 'ATP-dependent DNA helicase UvrD2', 104, NULL, NULL, 148295),
(148296, '1.10.510.10-FF-003979', NULL, NULL, 330, NULL, NULL, 148296),
(148297, '3.90.226.10-FF-000252', NULL, 'Methylcrotonoyl-CoA carboxylase beta chain, mitochondrial', 75, NULL, NULL, 148297),
(148298, '3.30.360.10-FF-000094', NULL, 'Uncharacterized protein', 165, NULL, NULL, 148298),
(148299, '2.60.120.200-FF-000250', NULL, 'Fat-like cadherin-related tumor suppressor homolog', 185, NULL, NULL, 148299),
(148300, '1.20.58.1780-FF-000002', NULL, 'Nuclear pore complex protein NUP155', 307, NULL, NULL, 148300),
(148301, '3.40.630.10-FF-000466', NULL, 'Uncharacterized protein', 92, NULL, NULL, 148301),
(148302, '2.30.30.30-FF-000066', NULL, '60S ribosomal protein L14, putative', 88, NULL, NULL, 148302),
(148303, '1.10.1820.10-FF-000011', NULL, 'Casein kinase II subunit beta', 105, NULL, NULL, 148303),
(148304, '2.30.30.40-FF-000069', NULL, 'MAGUK p55 subfamily member 6', 122, NULL, NULL, 148304),
(148305, '2.60.40.60-FF-000653', NULL, 'Cadherin-89D', 87, NULL, NULL, 148305),
(148306, '2.60.200.20-FF-000116', NULL, 'Forkhead-associated (FHA) domain-containing protein', 143, NULL, NULL, 148306),
(148307, '3.30.160.60-FF-002791', NULL, 'zinc finger protein 672', 27, NULL, NULL, 148307),
(148308, '3.30.70.1450-FF-000035', NULL, 'Glutathione-regulated potassium-efflux system protein', 70, NULL, NULL, 148308),
(148309, '2.60.40.60-FF-000327', NULL, 'Protocadherin beta-17', 109, NULL, NULL, 148309),
(148310, '3.30.70.330-FF-000491', NULL, 'protein alan shepard isoform X6', 119, NULL, NULL, 148310),
(148311, '3.40.50.720-FF-000135', NULL, 'UDP-glucuronic acid decarboxylase 1', 189, NULL, NULL, 148311),
(148312, '2.130.10.10-FF-004135', NULL, 'LLGL scribble cell polarity complex component 2', 182, NULL, NULL, 148312),
(148313, '1.20.58.2010-FF-000004', NULL, 'Rop guanine nucleotide exchange factor 1', 241, NULL, NULL, 148313);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(148314, '1.10.3720.10-FF-000077', NULL, 'Sugar ABC transporter, permease protein, putative', 241, NULL, NULL, 148314),
(148315, '3.30.519.10-FF-000013', NULL, 'GDP dissociation inhibitor, putative', 66, NULL, NULL, 148315),
(148316, '3.40.50.11320-FF-000008', NULL, 'Uncharacterized protein', 100, NULL, NULL, 148316),
(148317, '3.40.50.10810-FF-000092', NULL, 'Protein CHROMATIN REMODELING 4', 243, NULL, NULL, 148317),
(148318, '2.130.10.10-FF-004455', NULL, 'Uncharacterized protein', 345, NULL, NULL, 148318),
(148319, '1.10.238.10-FF-000294', NULL, 'Calcyphosin', 87, NULL, NULL, 148319),
(148320, '3.30.200.20-FF-002070', NULL, 'Uncharacterized protein', 117, NULL, NULL, 148320),
(148321, '2.30.29.30-FF-000208', NULL, 'Pleckstrin 2', 117, NULL, NULL, 148321),
(148322, '2.60.120.200-FF-000036', NULL, 'Calsyntenin 1', 191, NULL, NULL, 148322),
(148323, '2.70.40.10-FF-000008', NULL, 'Deoxyuridine 5''-triphosphate nucleotidohydrolase', 145, NULL, NULL, 148323),
(148324, '3.30.70.920-FF-000033', NULL, 'Transcriptional regulatory protein', 82, NULL, NULL, 148324),
(148325, '3.80.10.10-FF-001454', NULL, 'Leucine-rich repeat protein (LRRP), putative', 108, NULL, NULL, 148325),
(148326, '3.40.190.10-FF-000218', NULL, 'Uncharacterized protein', 124, NULL, NULL, 148326),
(148327, '2.60.40.10-FF-004477', NULL, NULL, 121, NULL, NULL, 148327),
(148328, '3.30.70.270-FF-000017', NULL, 'Predicted diguanylate cyclase', 170, NULL, NULL, 148328),
(148329, '1.25.40.10-FF-000654', NULL, 'Calcineurin-binding protein 1', 253, NULL, NULL, 148329),
(148330, '3.30.200.20-FF-000832', NULL, 'Tyrosine-protein kinase', 94, NULL, NULL, 148330),
(148331, '3.40.50.1440-FF-000064', NULL, 'Delta tubulin', 333, NULL, NULL, 148331),
(148332, '1.20.58.410-FF-000003', NULL, 'High chlorophyll fluorescent 109', 117, NULL, NULL, 148332),
(148333, '3.90.930.12-FF-000031', NULL, NULL, 57, NULL, NULL, 148333),
(148334, '3.40.50.300-FF-005141', NULL, 'ATP-binding cassette transporter, subfamily G, member 28, group WBC protein PpABCG28', 236, NULL, NULL, 148334),
(148335, '1.10.533.10-FF-000249', NULL, 'Uncharacterized protein', 115, NULL, NULL, 148335),
(148336, '1.10.510.10-FF-002456', NULL, 'Probable serine/threonine-protein kinase fnkB', 295, NULL, NULL, 148336),
(148337, '3.60.20.10-FF-000022', NULL, 'Proteasome subunit alpha type', 261, NULL, NULL, 148337),
(148338, '3.30.870.10-FF-000059', NULL, 'Cardiolipin synthetase, putative', 167, NULL, NULL, 148338),
(148339, '2.60.40.10-FF-004157', NULL, NULL, 89, NULL, NULL, 148339),
(148340, '2.160.20.10-FF-000087', NULL, 'GG17321', 252, NULL, NULL, 148340),
(148341, '3.40.640.10-FF-000074', NULL, 'Aromatic amino acid aminotransferase', 481, NULL, NULL, 148341),
(148342, '3.40.50.300-FF-002724', NULL, 'HAlF transporter (PGP related)', 64, NULL, NULL, 148342),
(148343, '3.40.50.1820-FF-001723', NULL, 'Uncharacterized protein', 120, NULL, NULL, 148343),
(148344, '3.40.50.300-FF-000583', NULL, 'Adenylate kinase isoenzyme 5', 195, NULL, NULL, 148344),
(148345, '2.120.10.30-FF-000049', NULL, 'LDL receptor related protein 2', 311, NULL, NULL, 148345),
(148346, '3.80.10.10-FF-001881', NULL, 'AGAP009688-PA', 83, NULL, NULL, 148346),
(148347, '3.80.10.10-FF-003915', NULL, 'LRR receptor-like serine/threonine-protein kinase GSO1', 266, NULL, NULL, 148347),
(148348, '3.10.110.10-FF-000248', NULL, 'RBR-type E3 ubiquitin transferase', 135, NULL, NULL, 148348),
(148349, '2.40.160.110-FF-000005', NULL, 'Lysosome-associated membrane glycoprotein 1', 170, NULL, NULL, 148349),
(148350, '3.80.10.10-FF-000144', NULL, 'F-box and leucine-rich repeat protein 16', 93, NULL, NULL, 148350),
(148351, '3.30.910.20-FF-000010', NULL, 'Outer membrane protein', 137, NULL, NULL, 148351),
(148352, '3.30.750.24-FF-000114', NULL, 'Uncharacterized protein', 116, NULL, NULL, 148352),
(148353, '3.30.160.60-FF-005320', NULL, NULL, 31, NULL, NULL, 148353),
(148354, '3.40.50.10470-FF-000068', NULL, 'Initiation factor 2 subunit, putative', 193, NULL, NULL, 148354),
(148355, '1.25.10.10-FF-003114', NULL, 'Predicted protein', 214, NULL, NULL, 148355);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(148356, '3.40.350.10-FF-000107', NULL, 'Uncharacterized protein', 83, NULL, NULL, 148356),
(148357, '3.80.10.10-FF-003803', NULL, 'Uncharacterized protein', 89, NULL, NULL, 148357),
(148358, '3.30.70.330-FF-000502', NULL, 'Pre-mRNA-splicing factor cwc2, putative', 92, NULL, NULL, 148358),
(148359, '3.40.50.300-FF-006765', NULL, 'Uncharacterized protein', 62, NULL, NULL, 148359),
(148360, '3.10.390.10-FF-000010', NULL, 'CBN-TAG-347 protein', 95, NULL, NULL, 148360),
(148361, '1.10.1410.10-FF-000093', NULL, 'Uncharacterized protein', 63, NULL, NULL, 148361),
(148362, '1.20.930.80-FF-000005', NULL, 'DNA primase large subunit', 275, NULL, NULL, 148362),
(148363, '3.90.550.10-FF-000078', NULL, 'glycosyltransferase 8 domain-containing protein 2', 285, NULL, NULL, 148363),
(148364, '3.40.50.20-FF-000022', NULL, 'Formate-dependent phosphoribosylglycinamide formyltransferase', 112, NULL, NULL, 148364),
(148365, '3.30.160.60-FF-004932', NULL, NULL, 37, NULL, NULL, 148365),
(148366, '1.10.238.10-FF-000389', NULL, 'Flagellar pocket-related cytoskeletal protein', 89, NULL, NULL, 148366),
(148367, '3.40.50.1000-FF-000185', NULL, 'Phospholipid-transporting ATPase', 197, NULL, NULL, 148367),
(148368, '1.20.144.10-FF-000023', NULL, 'Lipid phosphate phosphatase gamma', 103, NULL, NULL, 148368),
(148369, '1.10.220.150-FF-000073', NULL, 'Uncharacterized protein', 84, NULL, NULL, 148369),
(148370, '1.10.150.20-FF-000008', NULL, 'DNA repair protein RAD51 homolog', 73, NULL, NULL, 148370),
(148371, '1.10.472.10-FF-000433', NULL, 'YALI0C13926p', 134, NULL, NULL, 148371),
(148372, '3.90.1100.10-FF-000066', NULL, 'DNA polymerase epsilon catalytic subunit', 59, NULL, NULL, 148372),
(148373, '1.20.120.810-FF-000004', NULL, 'Vinculin, isoform B', 221, NULL, NULL, 148373),
(148374, '3.30.160.60-FF-000649', NULL, 'Zinc finger protein 710', 28, NULL, NULL, 148374),
(148375, '3.90.70.10-FF-000855', NULL, 'Uncharacterized protein', 106, NULL, NULL, 148375),
(148376, '3.30.160.60-FF-006490', NULL, NULL, 29, NULL, NULL, 148376),
(148377, '3.40.50.1910-FF-000013', NULL, 'Vacuolar sorting protein', 173, NULL, NULL, 148377),
(148378, '3.40.50.970-FF-000182', NULL, '2-oxoglutarate dehydrogenase, E1 protein', 357, NULL, NULL, 148378),
(148379, '2.130.10.10-FF-004808', NULL, 'WD repeat-containing protein 41', 144, NULL, NULL, 148379),
(148380, '2.40.160.120-FF-000008', NULL, 'Oxysterol binding protein (Osh1)', 171, NULL, NULL, 148380),
(148381, '1.20.58.390-FF-000188', NULL, 'Uncharacterized protein', 118, NULL, NULL, 148381),
(148382, '3.10.20.340-FF-000005', NULL, 'Arginine biosynthesis bifunctional protein ArgJ', 126, NULL, NULL, 148382),
(148383, '1.25.40.10-FF-004145', NULL, 'Uncharacterized protein', 114, NULL, NULL, 148383),
(148384, '1.10.238.10-FF-001007', NULL, 'Solute carrier family 25 (mitochondrial carrier; phosphate carrier), member 23a', 131, NULL, NULL, 148384),
(148385, '3.10.450.50-FF-000049', NULL, 'Calcium/calmodulin dependent protein kinase II delta', 77, NULL, NULL, 148385),
(148386, '3.30.160.60-FF-002678', NULL, 'Zinc finger protein 687', 69, NULL, NULL, 148386),
(148387, '2.30.30.40-FF-000406', NULL, 'Tyrosine-protein kinase', 62, NULL, NULL, 148387),
(148388, '1.10.490.10-FF-000031', NULL, 'Two-on-two hemoglobin-3', 151, NULL, NULL, 148388),
(148389, '2.10.110.10-FF-000353', NULL, 'AGAP008979-PA', 34, NULL, NULL, 148389),
(148390, '3.40.50.300-FF-000936', NULL, 'Arsenical pump-driving ATPase', 339, NULL, NULL, 148390),
(148391, '1.20.120.230-FF-000044', NULL, 'Talin', 141, NULL, NULL, 148391),
(148392, '1.10.630.10-FF-000599', NULL, 'Uncharacterized protein', 275, NULL, NULL, 148392),
(148393, '3.30.200.20-FF-002277', NULL, 'Uncharacterized protein', 136, NULL, NULL, 148393),
(148394, '1.20.1280.290-FF-000019', NULL, 'PQ-loop repeat family protein / transmembrane family protein', 97, NULL, NULL, 148394),
(148395, '3.80.10.10-FF-001549', NULL, 'Si:ch211-76m11.5', 132, NULL, NULL, 148395),
(148396, '3.10.180.10-FF-000073', NULL, '4-hydroxyphenylpyruvate dioxygenase, putative', 227, NULL, NULL, 148396),
(148397, '3.30.420.40-FF-000467', NULL, 'Actin-related protein 2', 30, NULL, NULL, 148397);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(148398, '3.30.70.3400-FF-000008', NULL, 'Protein translocase subunit SecD', 76, NULL, NULL, 148398),
(148399, '3.40.50.300-FF-006664', NULL, 'Uncharacterized protein', 85, NULL, NULL, 148399),
(148400, '3.30.40.10-FF-000406', NULL, 'Transcription intermediary factor 1-beta', 66, NULL, NULL, 148400),
(148401, '2.60.120.1030-FF-000009', NULL, 'mRNA cleavage and polyadenylation factor CLP1', 81, NULL, NULL, 148401),
(148402, '3.20.20.300-FF-000064', NULL, NULL, 330, NULL, NULL, 148402),
(148403, '2.40.30.170-FF-000037', NULL, 'Efflux transporter periplasmic adaptor subunit', 69, NULL, NULL, 148403),
(148404, '1.20.1540.10-FF-000009', NULL, 'Rhomboid domain containing 1', 183, NULL, NULL, 148404),
(148405, '3.30.390.110-FF-000013', NULL, 'Ribosomal L28e protein family', 120, NULL, NULL, 148405),
(148406, '2.130.10.10-FF-002095', NULL, 'WGS project CAEQ00000000 data, annotated contig 84', 213, NULL, NULL, 148406),
(148407, '3.90.1530.30-FF-000003', NULL, 'Putative ParB-like nuclease domain', 64, NULL, NULL, 148407),
(148408, '3.40.50.720-FF-002046', NULL, 'Predicted protein', 179, NULL, NULL, 148408),
(148409, '1.10.10.520-FF-000003', NULL, 'Ubiquitin-activating enzyme E1-like', 208, NULL, NULL, 148409),
(148410, '3.40.50.300-FF-003230', NULL, 'Mismatch repair protein MSH3, putative', 257, NULL, NULL, 148410),
(148411, '2.40.320.10-FF-000031', NULL, 'Uncharacterized protein', 206, NULL, NULL, 148411),
(148412, '3.30.70.330-FF-002413', NULL, NULL, 92, NULL, NULL, 148412),
(148413, '1.10.510.10-FF-003170', NULL, NULL, 164, NULL, NULL, 148413),
(148414, '3.40.50.1220-FF-000014', NULL, 'Acetolactate synthase', 170, NULL, NULL, 148414),
(148415, '3.40.190.10-FF-000903', NULL, 'Periplasmic substrate-binding histidine kinase', 132, NULL, NULL, 148415),
(148416, '3.90.940.10-FF-000001', NULL, 'DNA-directed RNA polymerase subunit omega', 90, NULL, NULL, 148416),
(148417, '3.30.450.40-FF-000183', NULL, 'IclR family transcriptional regulator', 168, NULL, NULL, 148417),
(148418, '1.20.58.860-FF-000003', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 86, NULL, NULL, 148418),
(148419, '2.60.40.2030-FF-000012', NULL, 'Adhesion G-protein coupled receptor V1', 116, NULL, NULL, 148419),
(148420, '1.10.287.540-FF-000004', NULL, 'Calreticulin 3', 37, NULL, NULL, 148420),
(148421, '3.90.1170.10-FF-000014', NULL, 'Apicoplast ribosomal protein L16', 128, NULL, NULL, 148421),
(148422, '3.30.160.60-FF-002903', NULL, 'Protein CBR-SMA-9', 32, NULL, NULL, 148422),
(148423, '2.40.170.20-FF-000084', NULL, 'Putative TonB-dependent outer membrane receptor protein', 635, NULL, NULL, 148423),
(148424, '1.25.40.20-FF-000871', NULL, 'Ankyrin repeat and KH domain-containing 1', 420, NULL, NULL, 148424),
(148425, '1.20.1310.10-FF-000088', NULL, 'Uncharacterized protein', 140, NULL, NULL, 148425),
(148426, '2.60.120.1030-FF-000010', NULL, 'mRNA cleavage and polyadenylation factor CLP1', 59, NULL, NULL, 148426),
(148427, '3.80.10.10-FF-004410', NULL, 'Leucine-rich repeat family protein', 75, NULL, NULL, 148427),
(148428, '3.30.70.330-FF-002531', NULL, NULL, 55, NULL, NULL, 148428),
(148429, '3.40.1090.10-FF-000053', NULL, 'Lysophospholipase NTE1', 78, NULL, NULL, 148429),
(148430, '3.80.10.10-FF-003792', NULL, 'Uncharacterized protein', 97, NULL, NULL, 148430),
(148431, '1.10.10.10-FF-000416', NULL, 'Vacuolar protein-sorting-associated protein 36', 79, NULL, NULL, 148431),
(148432, '3.30.830.10-FF-000282', NULL, 'Uncharacterized protein', 214, NULL, NULL, 148432),
(148433, '2.10.25.10-FF-001780', NULL, 'Uncharacterized protein', 33, NULL, NULL, 148433),
(148434, '3.40.630.10-FF-000360', NULL, 'Predicted protein', 145, NULL, NULL, 148434),
(148435, '2.160.20.10-FF-000003', NULL, 'Pectin lyase F', 356, NULL, NULL, 148435),
(148436, '1.25.10.10-FF-002277', NULL, 'Uncharacterized protein', 335, NULL, NULL, 148436),
(148437, '1.10.510.10-FF-003878', NULL, NULL, 92, NULL, NULL, 148437),
(148438, '1.20.58.870-FF-000006', NULL, 'DNA helicase', 115, NULL, NULL, 148438),
(148439, '2.130.10.10-FF-004247', NULL, 'Uncharacterized protein', 140, NULL, NULL, 148439);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(148440, '1.20.5.190-FF-000128', NULL, NULL, 84, NULL, NULL, 148440),
(148441, '2.30.30.1190-FF-000002', NULL, 'probable E3 ubiquitin-protein ligase makorin-2 isoform X2', 61, NULL, NULL, 148441),
(148442, '1.25.40.10-FF-004706', NULL, 'Uncharacterized protein', 96, NULL, NULL, 148442),
(148443, '3.60.21.10-FF-000356', NULL, 'Uncharacterized protein', 165, NULL, NULL, 148443),
(148444, '1.10.30.10-FF-000193', NULL, 'FACT complex subunit SSRP1', 72, NULL, NULL, 148444),
(148445, '3.40.50.1000-FF-000746', NULL, NULL, 120, NULL, NULL, 148445),
(148446, '1.20.1560.10-FF-000022', NULL, 'ATP-binding cassette sub-family B member 6, mitochondrial', 347, NULL, NULL, 148446),
(148447, '2.60.40.10-FF-002807', NULL, 'Sensory AXon guidance', 92, NULL, NULL, 148447),
(148448, '2.30.42.10-FF-000514', NULL, NULL, 79, NULL, NULL, 148448),
(148449, '3.90.320.10-FF-000010', NULL, 'Exodeoxyribonuclease VIII', 231, NULL, NULL, 148449),
(148450, '1.10.150.130-FF-000005', NULL, 'Prophage integrase IntS', 111, NULL, NULL, 148450),
(148451, '1.20.58.160-FF-000001', NULL, 'TOM1-like protein 2 isoform X1', 102, NULL, NULL, 148451),
(148452, '3.40.50.720-FF-001771', NULL, 'Uncharacterized protein', 54, NULL, NULL, 148452),
(148453, '4.10.860.10-FF-000003', NULL, 'YibL family ribosome-associated protein', 60, NULL, NULL, 148453),
(148454, '2.40.180.10-FF-000042', NULL, 'Uncharacterized protein', 55, NULL, NULL, 148454),
(148455, '1.25.40.10-FF-004027', NULL, 'Uncharacterized serine-rich protein C2F12.03c', 187, NULL, NULL, 148455),
(148456, '1.10.260.40-FF-000101', NULL, 'Repressor protein cI', 89, NULL, NULL, 148456),
(148457, '3.40.50.150-FF-000392', NULL, 'Protein-lysine N-methyltransferase Dere_GG24471', 192, NULL, NULL, 148457),
(148458, '3.40.50.300-FF-003112', NULL, 'DNA helicase', 207, NULL, NULL, 148458),
(148459, '3.40.50.300-FF-000375', NULL, 'Putative ATP-dependent RNA helicase DHX30', 170, NULL, NULL, 148459),
(148460, '3.30.200.20-FF-000720', NULL, 'Protein kinase OspG', 77, NULL, NULL, 148460),
(148461, '2.20.70.10-FF-000046', NULL, 'Peptidyl-prolyl cis-trans isomerase', 42, NULL, NULL, 148461),
(148462, '3.10.110.10-FF-000153', NULL, 'eIF-2-alpha kinase GCN2', 134, NULL, NULL, 148462),
(148463, '4.10.860.20-FF-000006', NULL, 'RABenoSyn (Trafficking protein) homolog', 74, NULL, NULL, 148463),
(148464, '2.40.160.100-FF-000002', NULL, 'Outer membrane channel OmpJ', 387, NULL, NULL, 148464),
(148465, '3.10.330.10-FF-000023', NULL, 'Vesicle-fusing ATPase', 108, NULL, NULL, 148465),
(148466, '3.90.550.50-FF-000062', NULL, 'Hexosyltransferase', 252, NULL, NULL, 148466),
(148467, '3.30.160.60-FF-002892', NULL, 'PR domain zinc finger protein 15', 31, NULL, NULL, 148467),
(148468, '1.20.1080.10-FF-000081', NULL, 'AQuaPorin or aquaglyceroporin related', 257, NULL, NULL, 148468),
(148469, '1.20.930.70-FF-000002', NULL, 'Fatty acid synthase', 128, NULL, NULL, 148469),
(148470, '1.10.510.10-FF-004485', NULL, NULL, 243, NULL, NULL, 148470),
(148471, '2.60.40.10-FF-004365', NULL, NULL, 92, NULL, NULL, 148471),
(148472, '2.10.25.10-FF-001229', NULL, 'GM15452', 53, NULL, NULL, 148472),
(148473, '3.40.640.10-FF-000186', NULL, 'Aminotransferase, class III', 260, NULL, NULL, 148473),
(148474, '3.30.70.330-FF-000159', NULL, 'tRNA selenocysteine 1-associated protein 1', 84, NULL, NULL, 148474),
(148475, '3.40.50.2300-FF-000029', NULL, 'Metabotropic glutamate receptor 3', 144, NULL, NULL, 148475),
(148476, '3.30.70.20-FF-000007', NULL, 'Dimethyl sulfoxide reductase subunit B', 124, NULL, NULL, 148476),
(148477, '3.10.330.20-FF-000026', NULL, 'tRNA (adenine(58)-N(1))-methyltransferase TrmI', 59, NULL, NULL, 148477),
(148478, '1.10.486.10-FF-000032', NULL, 'DNA helicase', 163, NULL, NULL, 148478),
(148479, '2.40.70.10-FF-000433', NULL, NULL, 185, NULL, NULL, 148479),
(148480, '2.60.40.10-FF-000666', NULL, 'basement membrane-specific heparan sulfate proteoglycan core protein-like', 88, NULL, NULL, 148480),
(148481, '3.30.70.330-FF-001576', NULL, NULL, 99, NULL, NULL, 148481),
(148482, '2.60.40.820-FF-000016', NULL, 'T-box transcription factor TBX2-A', 193, NULL, NULL, 148482);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(148483, '1.20.1070.10-FF-001558', NULL, 'Uncharacterized protein', 171, NULL, NULL, 148483),
(148484, '1.25.40.10-FF-004807', NULL, 'Uncharacterized protein', 162, NULL, NULL, 148484),
(148485, '3.90.550.10-FF-000628', NULL, 'Uncharacterized protein', 192, NULL, NULL, 148485),
(148486, '1.20.58.860-FF-000014', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 85, NULL, NULL, 148486),
(148487, '2.130.10.10-FF-006046', NULL, 'Uncharacterized protein', 227, NULL, NULL, 148487),
(148488, '2.70.170.10-FF-000175', NULL, 'Si:ch211-256e16.10', 122, NULL, NULL, 148488),
(148489, '1.50.40.10-FF-000579', NULL, 'Uncharacterized protein', 68, NULL, NULL, 148489),
(148490, '3.30.160.60-FF-000099', NULL, 'Zinc finger protein 79', 29, NULL, NULL, 148490),
(148491, '1.20.950.20-FF-000011', NULL, 'Nickel-dependent hydrogenase b-type cytochrome subunit', 167, NULL, NULL, 148491),
(148492, '1.25.40.10-FF-004465', NULL, 'Uncharacterized protein', 109, NULL, NULL, 148492),
(148493, '3.40.50.1820-FF-001829', NULL, 'Uncharacterized protein', 86, NULL, NULL, 148493),
(148494, '1.10.418.10-FF-000280', NULL, 'Fimbrin, putative', 77, NULL, NULL, 148494),
(148495, '3.40.50.1820-FF-000306', NULL, 'Alpha/beta hydrolase', 275, NULL, NULL, 148495),
(148496, '1.10.630.10-FF-000020', NULL, 'Cytochrome P450 family protein', 448, NULL, NULL, 148496),
(148497, '3.40.1090.10-FF-000154', NULL, 'Phospholipase A2', 219, NULL, NULL, 148497),
(148498, '3.30.379.10-FF-000024', NULL, NULL, 135, NULL, NULL, 148498),
(148499, '3.30.450.40-FF-000194', NULL, 'Uncharacterized protein', 163, NULL, NULL, 148499),
(148500, '1.20.1560.10-FF-000011', NULL, 'Multidrug ABC transporter ATP-binding protein', 326, NULL, NULL, 148500),
(148501, '1.20.1000.10-FF-000003', NULL, 'Guanylate-binding family protein', 281, NULL, NULL, 148501),
(148502, '2.70.130.10-FF-000167', NULL, NULL, 79, NULL, NULL, 148502),
(148503, '2.60.120.260-FF-000470', NULL, 'Uncharacterized protein', 191, NULL, NULL, 148503),
(148504, '3.30.450.40-FF-000306', NULL, 'Phosphodiesterase', 158, NULL, NULL, 148504),
(148505, '2.20.70.10-FF-000147', NULL, 'Chromosome 19, whole genome shotgun sequence', 40, NULL, NULL, 148505),
(148506, '2.60.40.2860-FF-000013', NULL, 'Transmission-blocking target antigen S230', 145, NULL, NULL, 148506),
(148507, '3.30.160.60-FF-006282', NULL, NULL, 50, NULL, NULL, 148507),
(148508, '3.30.1680.40-FF-000002', NULL, 'Variant surface glycoprotein (VSG), putative', 52, NULL, NULL, 148508),
(148509, '1.10.150.20-FF-000216', NULL, 'DNA repair protein RAD51 homolog', 80, NULL, NULL, 148509),
(148510, '3.20.20.20-FF-000021', NULL, 'Dihydropteroate synthase-related protein', 230, NULL, NULL, 148510),
(148511, '1.10.20.10-FF-000366', NULL, NULL, 85, NULL, NULL, 148511),
(148512, '3.40.50.1000-FF-000847', NULL, NULL, 63, NULL, NULL, 148512),
(148513, '3.40.50.150-FF-000745', NULL, 'Protein CBG16658', 246, NULL, NULL, 148513),
(148514, '2.130.10.10-FF-000745', NULL, 'Dynein, putative', 171, NULL, NULL, 148514),
(148515, '3.40.50.1240-FF-000009', NULL, 'serine/threonine-protein phosphatase PGAM5, mitochondrial isoform X1', 202, NULL, NULL, 148515),
(148516, '3.40.50.10810-FF-000198', NULL, 'DNA repair protein, putative', 203, NULL, NULL, 148516),
(148517, '2.60.40.10-FF-004595', NULL, NULL, 94, NULL, NULL, 148517),
(148518, '3.40.640.10-FF-000427', NULL, 'Predicted protein', 242, NULL, NULL, 148518),
(148519, '2.60.40.10-FF-002566', NULL, 'Titin homolog', 95, NULL, NULL, 148519),
(148520, '3.30.2320.10-FF-000001', NULL, 'Bacteriocin CFP29', 91, NULL, NULL, 148520),
(148521, '1.10.940.10-FF-000021', NULL, 'Transcription antitermination protein NusB', 142, NULL, NULL, 148521),
(148522, '3.30.300.130-FF-000001', NULL, 'NFU1 iron-sulfur cluster scaffold', 75, NULL, NULL, 148522),
(148523, '2.70.150.10-FF-000180', NULL, 'Uncharacterized protein', 168, NULL, NULL, 148523),
(148524, '1.20.1250.20-FF-001339', NULL, 'Monocarboxylate transporter-like protein', 209, NULL, NULL, 148524),
(148525, '1.20.1070.10-FF-001912', NULL, 'Predicted protein', 285, NULL, NULL, 148525),
(148526, '2.130.10.10-FF-001021', NULL, 'Elongator acetyltransferase complex subunit 2', 249, NULL, NULL, 148526);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(148527, '3.50.4.10-FF-000043', NULL, NULL, 80, NULL, NULL, 148527),
(148528, '1.10.287.110-FF-000336', NULL, 'Uncharacterized protein', 79, NULL, NULL, 148528),
(148529, '3.20.20.30-FF-000024', NULL, 'F420-dependent glucose-6-phosphate dehydrogenase', 326, NULL, NULL, 148529),
(148530, '3.30.230.10-FF-000314', NULL, 'Uncharacterized protein', 27, NULL, NULL, 148530),
(148531, '1.10.3720.10-FF-000088', NULL, 'Iron(III) ABC transporter, permease protein', 254, NULL, NULL, 148531),
(148532, '2.30.30.940-FF-000012', NULL, 'Rcorf28', 85, NULL, NULL, 148532),
(148533, '1.10.10.60-FF-000734', NULL, 'Homeobox protein Rhox5', 63, NULL, NULL, 148533),
(148534, '2.60.40.150-FF-000574', NULL, 'YALI0F20724p', 109, NULL, NULL, 148534),
(148535, '3.40.850.10-FF-000011', NULL, 'Kinesin family member 21A', 381, NULL, NULL, 148535),
(148536, '1.25.40.840-FF-000005', NULL, 'CCR4-not transcription complex, putative', 172, NULL, NULL, 148536),
(148537, '1.10.10.60-FF-001010', NULL, NULL, 47, NULL, NULL, 148537),
(148538, '1.25.40.550-FF-000019', NULL, 'Uncharacterized protein', 154, NULL, NULL, 148538),
(148539, '1.10.10.10-FF-000208', NULL, 'LysR family transcriptional regulator', 87, NULL, NULL, 148539),
(148540, '1.20.1530.20-FF-000074', NULL, 'Predicted protein', 108, NULL, NULL, 148540),
(148541, '1.10.8.790-FF-000001', NULL, 'RNA-dependent RNA polymerase', 80, NULL, NULL, 148541),
(148542, '1.10.340.70-FF-000021', NULL, 'Uncharacterized protein', 89, NULL, NULL, 148542),
(148543, '2.10.25.10-FF-001572', NULL, 'Uncharacterized protein', 43, NULL, NULL, 148543),
(148544, '1.25.10.10-FF-000927', NULL, 'Importin alpha, putative', 431, NULL, NULL, 148544),
(148545, '2.60.40.10-FF-002920', NULL, 'Usher syndrome 2A (autosomal recessive, mild)', 108, NULL, NULL, 148545),
(148546, '3.40.30.10-FF-001215', NULL, 'Uncharacterized protein', 134, NULL, NULL, 148546),
(148547, '3.90.79.10-FF-000257', NULL, 'Uncharacterized protein', 134, NULL, NULL, 148547),
(148548, '3.40.50.80-FF-000012', NULL, 'NADPH oxidase, isoform B', 195, NULL, NULL, 148548),
(148549, '3.10.660.10-FF-000003', NULL, 'DNAJ heat shock N-terminal domain-containing protein-like', 88, NULL, NULL, 148549),
(148550, '3.40.50.1390-FF-000026', NULL, 'Partial ORF from ISC1904', 44, NULL, NULL, 148550),
(148551, '1.10.3410.10-FF-000003', NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase-like protein', 106, NULL, NULL, 148551),
(148552, '2.60.40.790-FF-000069', NULL, 'Protein lethal(2)essential for life', 133, NULL, NULL, 148552),
(148553, '3.40.640.10-FF-000085', NULL, 'Cystathionine gamma-lyase', 244, NULL, NULL, 148553),
(148554, '3.40.630.10-FF-000028', NULL, 'Peptidase, M20/M25/M40 family', 238, NULL, NULL, 148554),
(148555, '1.25.10.10-FF-001203', NULL, 'AP-3 complex subunit delta', 399, NULL, NULL, 148555),
(148556, '1.25.40.530-FF-000013', NULL, 'Motor AXon guidance', 187, NULL, NULL, 148556),
(148557, '1.20.920.30-FF-000074', NULL, 'Uncharacterized protein', 50, NULL, NULL, 148557),
(148558, '3.40.50.2300-FF-001665', NULL, NULL, 172, NULL, NULL, 148558),
(148559, '1.20.140.100-FF-000009', NULL, 'Dynein heavy chain, putative', 153, NULL, NULL, 148559),
(148560, '3.90.1310.10-FF-000003', NULL, 'Peptidoglycan D,D-transpeptidase FtsI', 176, NULL, NULL, 148560),
(148561, '3.80.10.10-FF-001892', NULL, 'Tubulin folding cofactor E', 144, NULL, NULL, 148561),
(148562, '3.30.70.330-FF-002177', NULL, NULL, 81, NULL, NULL, 148562),
(148563, '1.20.120.1750-FF-000052', NULL, 'RBR-type E3 ubiquitin transferase', 121, NULL, NULL, 148563),
(148564, '2.40.10.10-FF-000227', NULL, 'CG9649 protein', 252, NULL, NULL, 148564),
(148565, '3.40.50.1380-FF-000023', NULL, 'Bifunctional purine biosynthesis protein PurH', 156, NULL, NULL, 148565),
(148566, '3.30.70.1350-FF-000005', NULL, 'Metal tolerance protein 4', 91, NULL, NULL, 148566),
(148567, '3.50.50.60-FF-000606', NULL, 'O-methyltransferase', 416, NULL, NULL, 148567),
(148568, '3.50.50.60-FF-000045', NULL, '3-phenylpropionate/cinnamic acid dioxygenase ferredoxin--NAD(+) reductase component', 181, NULL, NULL, 148568);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(148569, '3.40.525.10-FF-000008', NULL, 'Phosphatidylinositol transfer protein 3', 272, NULL, NULL, 148569),
(148570, '1.20.120.1240-FF-000005', NULL, 'Dynamin-2 isoform 2', 200, NULL, NULL, 148570),
(148571, '1.20.1310.10-FF-000190', NULL, NULL, 106, NULL, NULL, 148571),
(148572, '3.30.710.10-FF-000020', NULL, 'Potassium voltage-gated channel protein Shaw', 115, NULL, NULL, 148572),
(148573, '3.30.200.20-FF-002518', NULL, 'Uncharacterized protein', 107, NULL, NULL, 148573),
(148574, '1.20.120.30-FF-000002', NULL, 'Methyl-accepting chemotaxis protein I', 172, NULL, NULL, 148574),
(148575, '3.30.420.40-FF-000708', NULL, 'N-acetylmuramic acid/N-acetylglucosamine kinase', 176, NULL, NULL, 148575),
(148576, '3.40.50.970-FF-000204', NULL, 'Pyruvate dehydrogenase E1 component subunit beta, mitochondrial', 91, NULL, NULL, 148576),
(148577, '3.30.420.40-FF-000366', NULL, 'Putative actin-like protein', 42, NULL, NULL, 148577),
(148578, '3.40.50.150-FF-001021', NULL, NULL, 186, NULL, NULL, 148578),
(148579, '2.30.30.40-FF-000283', NULL, 'NAP1-binding protein 2', 59, NULL, NULL, 148579),
(148580, '3.40.50.720-FF-001563', NULL, '3-oxoacyl-(Acyl carrier protein) reductase', 246, NULL, NULL, 148580),
(148581, '3.30.70.270-FF-000006', NULL, 'Gag-Pol polyprotein', 109, NULL, NULL, 148581),
(148582, '3.30.40.10-FF-002306', NULL, 'Titin, putative', 115, NULL, NULL, 148582),
(148583, '3.30.470.20-FF-000200', NULL, 'Uncharacterized protein', 84, NULL, NULL, 148583),
(148584, '3.40.1780.10-FF-000004', NULL, 'S-adenosylmethionine:tRNA ribosyltransferase-isomerase', 212, NULL, NULL, 148584),
(148585, '1.10.357.50-FF-000020', NULL, 'SNARE-binding exocyst subunit', 250, NULL, NULL, 148585),
(148586, '3.90.70.10-FF-000625', NULL, 'Uncharacterized protein', 132, NULL, NULL, 148586),
(148587, '3.40.50.2000-FF-000142', NULL, 'L-arabinokinase', 153, NULL, NULL, 148587),
(148588, '1.10.1070.11-FF-000090', NULL, 'Uncharacterized protein', 68, NULL, NULL, 148588),
(148589, '3.20.20.100-FF-000009', NULL, 'Aldo-keto reductase family 1 member B1', 315, NULL, NULL, 148589),
(148590, '3.30.200.20-FF-000821', NULL, 'Cdc2-related kinase 6, putative', 101, NULL, NULL, 148590),
(148591, '1.20.1270.220-FF-000008', NULL, 'Bromodomain-containing transcription factor, putative', 79, NULL, NULL, 148591),
(148592, '1.20.58.1880-FF-000032', NULL, 'Uncharacterized protein', 116, NULL, NULL, 148592),
(148593, '3.30.200.20-FF-000366', NULL, 'receptor-type tyrosine-protein kinase FLT3', 132, NULL, NULL, 148593),
(148594, '3.30.1070.10-FF-000003', NULL, 'Cell division topological specificity factor', 82, NULL, NULL, 148594),
(148595, '1.25.40.540-FF-000016', NULL, 'Uncharacterized protein', 237, NULL, NULL, 148595),
(148596, '3.90.1150.50-FF-000002', NULL, 'CarD-like transcriptional regulator family protein, expressed', 148, NULL, NULL, 148596),
(148597, '3.90.226.10-FF-000139', NULL, 'Enoyl-CoA hydratase', 253, NULL, NULL, 148597),
(148598, '3.40.228.10-FF-000003', NULL, 'Biotin sulfoxide reductase 2', 248, NULL, NULL, 148598),
(148599, '3.30.565.10-FF-000165', NULL, 'Phosphate regulon sensor histidine kinase PhoR', 157, NULL, NULL, 148599),
(148600, '3.40.30.10-FF-000939', NULL, 'Putative redox protein fmp46, mitochondrial', 112, NULL, NULL, 148600),
(148601, '3.30.450.20-FF-000300', NULL, 'Methyl-accepting chemotaxis protein', 152, NULL, NULL, 148601),
(148602, '3.30.70.330-FF-002290', NULL, NULL, 96, NULL, NULL, 148602),
(148603, '1.10.238.10-FF-000283', NULL, 'Solute carrier family 25 (Mitochondrial aspartate/glutamate transporter), member 12/13', 136, NULL, NULL, 148603),
(148604, '2.60.470.10-FF-000020', NULL, 'pickpocket protein 28', 166, NULL, NULL, 148604),
(148605, '3.40.50.300-FF-004635', NULL, 'Translation factor GUF1, mitochondrial', 202, NULL, NULL, 148605),
(148606, '3.40.50.300-FF-004865', NULL, 'CTP synthase', 304, NULL, NULL, 148606),
(148607, '1.10.10.60-FF-000745', NULL, 'Uncharacterized protein, isoform A', 54, NULL, NULL, 148607),
(148608, '1.10.730.10-FF-000207', NULL, 'Uncharacterized protein', 238, NULL, NULL, 148608);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(148609, '1.10.10.10-FF-000085', NULL, 'Vacuolar-sorting protein SNF8', 81, NULL, NULL, 148609),
(148610, '3.50.7.10-FF-000066', NULL, NULL, 37, NULL, NULL, 148610),
(148611, '2.10.109.10-FF-000041', NULL, 'Signal peptidase I', 109, NULL, NULL, 148611),
(148612, '4.10.400.10-FF-000368', NULL, 'Uncharacterized protein', 41, NULL, NULL, 148612),
(148613, '3.80.10.10-FF-000026', NULL, 'U2 small nuclear ribonucleoprotein A', 176, NULL, NULL, 148613),
(148614, '2.60.40.1120-FF-000059', NULL, 'Uncharacterized protein', 77, NULL, NULL, 148614),
(148615, '1.10.3720.10-FF-000190', NULL, 'Sulfate ABC transporter permease protein CysW', 258, NULL, NULL, 148615),
(148616, '3.30.160.60-FF-002914', NULL, NULL, 27, NULL, NULL, 148616),
(148617, '1.10.8.600-FF-000001', NULL, 'DNA replication protein 16.7', 67, NULL, NULL, 148617),
(148618, '3.30.40.10-FF-000165', NULL, 'E3 ubiquitin-protein ligase Arkadia isoform X1', 67, NULL, NULL, 148618),
(148619, '3.40.50.300-FF-002735', NULL, 'ras-related protein Rap-2b isoform X3', 129, NULL, NULL, 148619),
(148620, '3.30.70.330-FF-000390', NULL, 'dead end protein homolog 1', 78, NULL, NULL, 148620),
(148621, '3.40.50.880-FF-000155', NULL, 'Carbamoyl-phosphate synthase small chain', 228, NULL, NULL, 148621),
(148622, '3.40.50.1980-FF-000006', NULL, 'Zinc ABC transporter substrate-binding protein ZnuA', 113, NULL, NULL, 148622),
(148623, '3.30.160.60-FF-004814', NULL, NULL, 38, NULL, NULL, 148623),
(148624, '1.20.1070.10-FF-001890', NULL, 'Uncharacterized protein', 290, NULL, NULL, 148624),
(148625, '3.30.70.330-FF-000732', NULL, 'RNA recognition water-stress protein1', 113, NULL, NULL, 148625),
(148626, '3.10.129.10-FF-000055', NULL, 'ATP-binding Cassette (ABC) superfamily', 165, NULL, NULL, 148626),
(148627, '1.10.533.10-FF-000238', NULL, 'Uncharacterized protein', 92, NULL, NULL, 148627),
(148628, '3.40.50.620-FF-000217', NULL, 'Leucine--tRNA ligase, putative', 155, NULL, NULL, 148628),
(148629, '3.30.70.260-FF-000003', NULL, 'GTP pyrophosphokinase RelA', 81, NULL, NULL, 148629),
(148630, '1.20.1310.10-FF-000077', NULL, 'CRE-CUL-5 protein', 110, NULL, NULL, 148630),
(148631, '3.90.550.50-FF-000163', NULL, 'Tripeptidyl peptidase SED3 (AFU_orthologue AFUA_3G08930)', 158, NULL, NULL, 148631),
(148632, '1.20.910.10-FF-000011', NULL, 'Aminopyrimidine aminohydrolase', 222, NULL, NULL, 148632),
(148633, '3.40.50.1370-FF-000020', NULL, 'Acetylornithine carbamoyltransferase', 164, NULL, NULL, 148633),
(148634, '3.30.559.10-FF-000010', NULL, 'carnitine O-palmitoyltransferase 2, mitochondrial', 212, NULL, NULL, 148634),
(148635, '2.40.50.140-FF-000482', NULL, 'Replication factor-A protein 2', 146, NULL, NULL, 148635),
(148636, '3.40.50.1820-FF-001498', NULL, 'Putative serine carboxypeptidase-like 53', 161, NULL, NULL, 148636),
(148637, '3.30.1370.10-FF-000032', NULL, 'synaptic functional regulator FMR1 isoform X2', 59, NULL, NULL, 148637),
(148638, '3.40.50.1970-FF-000003', NULL, 'Alcohol dehydrogenase, iron-containing', 183, NULL, NULL, 148638),
(148639, '3.30.1010.10-FF-000106', NULL, 'Uncharacterized protein', 164, NULL, NULL, 148639),
(148640, '3.30.160.60-FF-003055', NULL, 'Tripartite motif containing 4', 49, NULL, NULL, 148640),
(148641, '3.30.2350.20-FF-000039', NULL, NULL, 67, NULL, NULL, 148641),
(148642, '1.10.132.110-FF-000002', NULL, 'Amyloid protein A', 70, NULL, NULL, 148642),
(148643, '1.25.40.10-FF-002346', NULL, 'Pre-mRNA-splicing factor SYF1', 131, NULL, NULL, 148643),
(148644, '1.10.472.10-FF-000663', NULL, 'Cyclin J-like', 81, NULL, NULL, 148644),
(148645, '1.10.510.10-FF-000764', NULL, 'AGC/PDK1 protein kinase, variant 1', 210, NULL, NULL, 148645),
(148646, '3.40.50.1000-FF-000308', NULL, 'Related to FCP1-TFIIF interacting component of CTD phosphatase', 157, NULL, NULL, 148646),
(148647, '1.10.490.10-FF-000042', NULL, 'Heme-based aerotactic transducer HemAT', 163, NULL, NULL, 148647),
(148648, '3.40.47.10-FF-000124', NULL, 'Possible lipid transfer protein or keto acyl-CoA thiolase Ltp4', 350, NULL, NULL, 148648),
(148649, '4.10.60.10-FF-000165', NULL, 'Uncharacterized protein', 40, NULL, NULL, 148649);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(148650, '2.60.40.10-FF-004718', NULL, NULL, 99, NULL, NULL, 148650),
(148651, '3.40.50.720-FF-002400', NULL, 'Uncharacterized protein', 43, NULL, NULL, 148651),
(148652, '2.40.10.10-FF-000665', NULL, NULL, 59, NULL, NULL, 148652),
(148653, '2.120.10.30-FF-000162', NULL, 'LDL receptor related protein 5 like', 269, NULL, NULL, 148653),
(148654, '2.30.30.30-FF-000167', NULL, 'Uncharacterized protein', 39, NULL, NULL, 148654),
(148655, '1.10.287.920-FF-000011', NULL, 'AFR522Cp', 79, NULL, NULL, 148655),
(148656, '2.70.150.10-FF-000067', NULL, 'Cation-transporting ATPase', 145, NULL, NULL, 148656),
(148657, '2.70.130.10-FF-000178', NULL, NULL, 150, NULL, NULL, 148657),
(148658, '3.30.2010.10-FF-000011', NULL, 'Putative beta-barrel assembly-enhancing protease', 85, NULL, NULL, 148658),
(148659, '3.40.50.80-FF-000242', NULL, 'Sulfite reductase', 162, NULL, NULL, 148659),
(148660, '1.10.4160.10-FF-000011', NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', 477, NULL, NULL, 148660),
(148661, '3.30.160.60-FF-004691', NULL, NULL, 41, NULL, NULL, 148661),
(148662, '3.10.350.10-FF-000013', NULL, 'Peptidase, M23 family', 64, NULL, NULL, 148662),
(148663, '2.60.40.10-FF-004820', NULL, NULL, 73, NULL, NULL, 148663),
(148664, '1.25.40.10-FF-001031', NULL, 'Pre-mRNA-splicing factor SYF1', 172, NULL, NULL, 148664),
(148665, '1.25.40.10-FF-004600', NULL, 'Uncharacterized protein', 167, NULL, NULL, 148665),
(148666, '1.10.287.70-FF-000115', NULL, 'Cation channel sperm-associated protein 2', 157, NULL, NULL, 148666),
(148667, '3.40.850.10-FF-000241', NULL, 'Kinesin-like protein', 345, NULL, NULL, 148667),
(148668, '3.10.100.10-FF-000214', NULL, NULL, 132, NULL, NULL, 148668),
(148669, '2.70.98.10-FF-000074', NULL, 'Aldose 1-epimerase', 358, NULL, NULL, 148669),
(148670, '2.60.220.10-FF-000002', NULL, 'Chondroitin sulfate ABC lyase', 128, NULL, NULL, 148670),
(148671, '3.40.390.10-FF-000104', NULL, 'Metalloendopeptidase', 235, NULL, NULL, 148671),
(148672, '1.10.580.10-FF-000038', NULL, 'Citrate synthase', 240, NULL, NULL, 148672),
(148673, '3.80.10.10-FF-003472', NULL, 'Plekhe1 protein, putative', 211, NULL, NULL, 148673),
(148674, '1.10.287.940-FF-000017', NULL, 'Expressed protein', 67, NULL, NULL, 148674),
(148675, '3.40.50.1220-FF-000003', NULL, 'NAD-dependent protein deacylase 1', 129, NULL, NULL, 148675),
(148676, '1.10.150.530-FF-000018', NULL, 'Predicted protein', 57, NULL, NULL, 148676),
(148677, '3.60.110.10-FF-000012', NULL, 'N-carbamoylputrescine amidohydrolase, putative', 301, NULL, NULL, 148677),
(148678, '1.25.40.20-FF-001034', NULL, 'Espin like', 107, NULL, NULL, 148678),
(148679, '3.30.2350.10-FF-000036', NULL, 'Pseudouridine synthase', 250, NULL, NULL, 148679),
(148680, '3.10.20.90-FF-000773', NULL, 'Partitioning defective 3-like protein', 84, NULL, NULL, 148680),
(148681, '1.25.70.10-FF-000044', NULL, 'uncharacterized protein LOC108087286', 218, NULL, NULL, 148681),
(148682, '1.10.238.10-FF-001120', NULL, 'Uncharacterized protein', 40, NULL, NULL, 148682),
(148683, '3.90.550.10-FF-000741', NULL, 'Gll2192 protein', 244, NULL, NULL, 148683),
(148684, '3.10.450.700-FF-000001', NULL, 'Purine-rich element binding protein A', 76, NULL, NULL, 148684),
(148685, '2.70.160.11-FF-000001', NULL, 'Blast:Protein arginine N-methyltransferase 1', 177, NULL, NULL, 148685),
(148686, '2.20.100.10-FF-000013', NULL, 'Spondin 1a', 51, NULL, NULL, 148686),
(148687, '3.40.50.620-FF-000010', NULL, 'Glutamine--tRNA ligase', 110, NULL, NULL, 148687),
(148688, '1.25.40.20-FF-000758', NULL, 'Uncharacterized protein', 241, NULL, NULL, 148688),
(148689, '1.10.418.10-FF-000167', NULL, 'Dixin', 121, NULL, NULL, 148689),
(148690, '3.10.110.10-FF-000142', NULL, 'Ubiquitin-conjugating enzyme E2', 157, NULL, NULL, 148690),
(148691, '4.10.860.10-FF-000014', NULL, 'ATP-dependent Clp protease ATP-binding subunit', 67, NULL, NULL, 148691),
(148692, '1.10.238.10-FF-000844', NULL, 'EF-hand domain pair/EF-hand domain/EF hand, putative', 75, NULL, NULL, 148692),
(148693, '3.30.497.10-FF-000130', NULL, 'Uncharacterized protein', 135, NULL, NULL, 148693);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(148694, '2.120.10.80-FF-000250', NULL, 'Kelch domain-containing protein 8B', 135, NULL, NULL, 148694),
(148695, '1.10.560.10-FF-000149', NULL, '60 kDa heat shock protein, mitochondrial', 12, NULL, NULL, 148695),
(148696, '3.40.190.170-FF-000011', NULL, 'TRAP-type C4-dicarboxylate transport system, substrate-binding protein', 249, NULL, NULL, 148696),
(148697, '1.20.1250.20-FF-001660', NULL, 'YALI0F03751p', 74, NULL, NULL, 148697),
(148698, '3.40.30.10-FF-001092', NULL, '40S ribosomal protein S8-1', 86, NULL, NULL, 148698),
(148699, '1.20.1250.20-FF-002053', NULL, 'Uncharacterized protein', 308, NULL, NULL, 148699),
(148700, '1.10.1670.10-FF-000061', NULL, NULL, 92, NULL, NULL, 148700),
(148701, '2.60.40.10-FF-003403', NULL, NULL, 82, NULL, NULL, 148701),
(148702, '1.25.40.10-FF-000755', NULL, 'Pentatricopeptide repeat-containing protein', 169, NULL, NULL, 148702),
(148703, '2.30.280.10-FF-000012', NULL, NULL, 78, NULL, NULL, 148703),
(148704, '3.20.20.150-FF-000007', NULL, 'Hydroxypyruvate isomerase', 258, NULL, NULL, 148704),
(148705, '1.20.5.2480-FF-000004', NULL, 'Reticulon', 55, NULL, NULL, 148705),
(148706, '1.20.210.10-FF-000003', NULL, 'Cytochrome c oxidase subunit 1', 527, NULL, NULL, 148706),
(148707, '3.40.50.970-FF-000081', NULL, 'Transketolase', 322, NULL, NULL, 148707),
(148708, '1.20.272.10-FF-000056', NULL, NULL, 88, NULL, NULL, 148708),
(148709, '2.60.210.10-FF-000041', NULL, NULL, 150, NULL, NULL, 148709),
(148710, '3.30.30.10-FF-000007', NULL, 'Defensin-like protein 195', 68, NULL, NULL, 148710),
(148711, '2.60.40.10-FF-000548', NULL, 'vascular endothelial growth factor receptor 3', 90, NULL, NULL, 148711),
(148712, '3.30.590.50-FF-000010', NULL, 'Gamma-glutamylcysteine synthetase, putative', 296, NULL, NULL, 148712),
(148713, '2.40.70.10-FF-000551', NULL, NULL, 180, NULL, NULL, 148713),
(148714, '1.10.730.10-FF-000185', NULL, 'Uncharacterized protein', 13, NULL, NULL, 148714),
(148715, '1.20.5.340-FF-000084', NULL, 'Uncharacterized protein', 96, NULL, NULL, 148715),
(148716, '3.40.50.300-FF-006327', NULL, 'ATPase family AAA domain-containing 2B', 134, NULL, NULL, 148716),
(148717, '2.70.170.10-FF-000057', NULL, 'Ligand-Gated ion Channel', 238, NULL, NULL, 148717),
(148718, '3.30.160.60-FF-006388', NULL, NULL, 33, NULL, NULL, 148718),
(148719, '2.30.29.30-FF-001389', NULL, 'Uncharacterized protein', 119, NULL, NULL, 148719),
(148720, '1.10.150.20-FF-000110', NULL, 'Protein CBG20918', 19, NULL, NULL, 148720),
(148721, '1.10.8.710-FF-000023', NULL, NULL, 115, NULL, NULL, 148721),
(148722, '1.10.418.10-FF-000162', NULL, 'Serine/threonine-protein kinase pakD', 139, NULL, NULL, 148722),
(148723, '3.40.50.170-FF-000043', NULL, 'Uncharacterized protein', 101, NULL, NULL, 148723),
(148724, '3.50.50.60-FF-000831', NULL, 'Uncharacterized protein', 111, NULL, NULL, 148724),
(148725, '3.10.20.770-FF-000010', NULL, 'Phosphatidylinositol-4,5-bisphosphate 3-kinase, catalytic subunit gamma', 297, NULL, NULL, 148725),
(148726, '1.25.40.10-FF-002453', NULL, 'Pentatricopeptide repeat-containing protein', 68, NULL, NULL, 148726),
(148727, '3.40.50.620-FF-000330', NULL, 'Glutamate--tRNA ligase', 329, NULL, NULL, 148727),
(148728, '1.25.10.10-FF-002518', NULL, 'Serine/threonine-protein phosphatase 2A 65 kDa regulatory subunit A, putative', 193, NULL, NULL, 148728),
(148729, '1.10.287.110-FF-000454', NULL, 'FLJ00095 protein', 50, NULL, NULL, 148729),
(148730, '3.30.1550.10-FF-000023', NULL, 'Uncharacterized protein', 46, NULL, NULL, 148730),
(148731, '1.10.10.10-FF-000747', NULL, 'Transcriptional regulator', 87, NULL, NULL, 148731),
(148732, '3.30.200.20-FF-000591', NULL, 'Serine/threonine-protein kinase', 106, NULL, NULL, 148732),
(148733, '2.60.40.150-FF-000462', NULL, 'ATP-dependent RNA helicase', 109, NULL, NULL, 148733),
(148734, '3.30.40.10-FF-001368', NULL, 'Jumonji domain containing 2B', 49, NULL, NULL, 148734),
(148735, '3.60.15.10-FF-000061', NULL, 'Interstrand crosslink repair protein', 171, NULL, NULL, 148735),
(148736, '2.60.40.10-FF-002684', NULL, 'High Incidence of Males (Increased X chromosome loss)', 94, NULL, NULL, 148736);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(148737, '3.40.640.10-FF-000315', NULL, 'Mitochondrial aspartate aminotransferase', 268, NULL, NULL, 148737),
(148738, '3.40.50.2300-FF-000350', NULL, 'Diguanylate cyclase response regulator', 155, NULL, NULL, 148738),
(148739, '1.25.10.10-FF-002951', NULL, 'Uncharacterized protein', 27, NULL, NULL, 148739),
(148740, '2.60.40.10-FF-004819', NULL, NULL, 68, NULL, NULL, 148740),
(148741, '3.90.70.10-FF-000850', NULL, 'AGAP000884-PA', 317, NULL, NULL, 148741),
(148742, '3.90.1150.10-FF-000018', NULL, 'Histidine decarboxylase', 100, NULL, NULL, 148742),
(148743, '2.130.10.10-FF-002662', NULL, 'Uncharacterized protein', 112, NULL, NULL, 148743),
(148744, '3.30.40.10-FF-001475', NULL, 'Uncharacterized protein', 105, NULL, NULL, 148744),
(148745, '1.20.120.350-FF-000187', NULL, NULL, 121, NULL, NULL, 148745),
(148746, '2.120.10.80-FF-000249', NULL, 'Galactose oxidase/kelch repeat superfamily protein', 141, NULL, NULL, 148746),
(148747, '2.60.40.420-FF-000110', NULL, 'VAB-2', 152, NULL, NULL, 148747),
(148748, '1.10.238.10-FF-000962', NULL, 'Calmodulin 2', 79, NULL, NULL, 148748),
(148749, '3.10.100.10-FF-000079', NULL, 'Oxidized low-density lipoprotein receptor 1', 135, NULL, NULL, 148749),
(148750, '2.40.50.140-FF-000162', NULL, '30S ribosomal protein S1, chloroplastic', 78, NULL, NULL, 148750),
(148751, '1.20.1250.20-FF-000030', NULL, 'monocarboxylate transporter 1 isoform X1', 401, NULL, NULL, 148751),
(148752, '3.40.50.1000-FF-000628', NULL, NULL, 135, NULL, NULL, 148752),
(148753, '1.10.20.10-FF-000254', NULL, NULL, 66, NULL, NULL, 148753),
(148754, '3.30.420.40-FF-000922', NULL, 'Actin-related protein', 137, NULL, NULL, 148754),
(148755, '3.30.230.10-FF-000090', NULL, 'glucuronokinase 1-like isoform X1', 187, NULL, NULL, 148755),
(148756, '3.40.50.80-FF-000130', NULL, 'Rieske_[2Fe-2S]_domain/Rieske-like_[2Fe-2S ]_domain_containing_protein_-_putative', 140, NULL, NULL, 148756),
(148757, '2.60.40.10-FF-001161', NULL, 'Usherin', 108, NULL, NULL, 148757),
(148758, '2.60.210.10-FF-000046', NULL, NULL, 145, NULL, NULL, 148758),
(148759, '2.60.40.1170-FF-000052', NULL, 'APM2p protein', 106, NULL, NULL, 148759),
(148760, '3.90.470.10-FF-000015', NULL, '50S ribosomal protein L22', 152, NULL, NULL, 148760),
(148761, '3.90.470.20-FF-000018', NULL, 'Holo-[acyl-carrier-protein] synthase', 161, NULL, NULL, 148761),
(148762, '2.130.10.10-FF-003859', NULL, 'Uncharacterized protein', 283, NULL, NULL, 148762),
(148763, '1.25.10.10-FF-002625', NULL, 'Predicted protein', 130, NULL, NULL, 148763),
(148764, '1.10.1450.10-FF-000078', NULL, 'GD10451', 82, NULL, NULL, 148764),
(148765, '3.30.420.40-FF-000815', NULL, 'nebramycin 5'' synthase', 228, NULL, NULL, 148765),
(148766, '3.30.70.120-FF-000001', NULL, 'Nitrogen regulatory protein P-II', 112, NULL, NULL, 148766),
(148767, '3.40.640.10-FF-000422', NULL, 'Uncharacterized protein', 35, NULL, NULL, 148767),
(148768, '1.20.120.1200-FF-000016', NULL, 'NADH-quinone oxidoreductase subunit J', 163, NULL, NULL, 148768),
(148769, '3.10.20.90-FF-000902', NULL, 'Uncharacterized protein', 82, NULL, NULL, 148769),
(148770, '1.10.287.70-FF-000121', NULL, 'Sodium channel protein', 148, NULL, NULL, 148770),
(148771, '1.25.40.10-FF-000199', NULL, 'Penicillin-binding protein activator LpoA', 124, NULL, NULL, 148771),
(148772, '1.20.1300.10-FF-000037', NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', 101, NULL, NULL, 148772),
(148773, '1.10.510.10-FF-002804', NULL, NULL, 187, NULL, NULL, 148773),
(148774, '1.10.730.10-FF-000078', NULL, 'Methionine--tRNA ligase, cytoplasmic', 158, NULL, NULL, 148774),
(148775, '3.30.497.10-FF-000118', NULL, 'Uncharacterized protein', 215, NULL, NULL, 148775),
(148776, '1.10.418.10-FF-000055', NULL, 'MICAL-like protein 2', 108, NULL, NULL, 148776),
(148777, '2.130.10.10-FF-002336', NULL, 'Intraflagellar transport protein 80', 136, NULL, NULL, 148777),
(148778, '3.90.70.10-FF-000743', NULL, 'Uncharacterized protein', 143, NULL, NULL, 148778),
(148779, '1.10.287.1080-FF-000015', NULL, 'Nucleoside triphosphate pyrophosphohydrolase MazG', 126, NULL, NULL, 148779);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(148780, '3.80.20.20-FF-000086', NULL, 'Tyrosine-protein kinase receptor', 105, NULL, NULL, 148780),
(148781, '3.40.50.300-FF-000818', NULL, 'pre-mRNA-splicing factor ATP-dependent RNA helicase DHX16', 225, NULL, NULL, 148781),
(148782, '2.60.40.10-FF-002791', NULL, 'Uncharacterized protein', 97, NULL, NULL, 148782),
(148783, '3.30.70.890-FF-000086', NULL, 'Predicted protein', 144, NULL, NULL, 148783),
(148784, '3.10.100.10-FF-000091', NULL, 'C-type LECtin', 143, NULL, NULL, 148784),
(148785, '1.20.58.530-FF-000039', NULL, NULL, 126, NULL, NULL, 148785),
(148786, '3.40.50.2300-FF-000024', NULL, 'Vomeronasal 2, receptor 73', 161, NULL, NULL, 148786),
(148787, '2.40.170.20-FF-000089', NULL, 'Vitamin B12 transporter BtuB', 455, NULL, NULL, 148787),
(148788, '1.25.40.10-FF-002560', NULL, 'Uncharacterized protein', 213, NULL, NULL, 148788),
(148789, '1.20.120.1750-FF-000158', NULL, 'RBR-type E3 ubiquitin transferase', 70, NULL, NULL, 148789),
(148790, '2.60.40.10-FF-002802', NULL, 'Immunoglobulin heavy constant delta', 103, NULL, NULL, 148790),
(148791, '1.10.287.70-FF-000014', NULL, 'Voltage-dependent T-type calcium channel subunit alpha', 145, NULL, NULL, 148791),
(148792, '1.10.720.60-FF-000025', NULL, 'Uncharacterized protein', 19, NULL, NULL, 148792),
(148793, '1.10.1840.10-FF-000001', NULL, 'Replicase polyprotein 1a', 109, NULL, NULL, 148793),
(148794, '1.10.1170.10-FF-000040', NULL, 'Apoptosis 2 inhibitor-like Protein', 93, NULL, NULL, 148794),
(148795, '2.40.340.10-FF-000021', NULL, NULL, 75, NULL, NULL, 148795),
(148796, '3.10.450.10-FF-000072', NULL, 'Uncharacterized protein', 76, NULL, NULL, 148796),
(148797, '3.90.550.10-FF-000746', NULL, 'Uncharacterized protein', 73, NULL, NULL, 148797),
(148798, '3.90.1150.220-FF-000002', NULL, 'Non-structural maintenance of chromosomes element 1', 77, NULL, NULL, 148798),
(148799, '3.60.130.10-FF-000002', NULL, 'Alpha-ketoglutarate-dependent taurine dioxygenase', 290, NULL, NULL, 148799),
(148800, '2.40.50.730-FF-000018', NULL, 'DNA polymerase', 80, NULL, NULL, 148800),
(148801, '3.40.30.10-FF-000838', NULL, 'Protein disulfide-isomerase 2', 139, NULL, NULL, 148801),
(148802, '1.10.357.50-FF-000008', NULL, 'Exocyst complex component 3-like 1', 187, NULL, NULL, 148802),
(148803, '1.20.5.2440-FF-000009', NULL, 'Rab11 family-interacting protein', 62, NULL, NULL, 148803),
(148804, '3.80.10.10-FF-001903', NULL, 'NLR family pyrin domain containing 11', 120, NULL, NULL, 148804),
(148805, '1.25.40.10-FF-003869', NULL, 'Uncharacterized protein', 99, NULL, NULL, 148805),
(148806, '1.20.1070.10-FF-001238', NULL, 'Putative cysteine-rich domain of the smoothened receptor', 370, NULL, NULL, 148806),
(148807, '1.25.10.10-FF-000720', NULL, 'APL6p Beta3-like subunit', 634, NULL, NULL, 148807),
(148808, '1.20.5.420-FF-000012', NULL, 'Small glutamine-rich tetratricopeptide repeat-containing protein alpha', 75, NULL, NULL, 148808),
(148809, '2.130.10.10-FF-000419', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 325, NULL, NULL, 148809),
(148810, '3.40.50.150-FF-000852', NULL, 'Uncharacterized protein', 280, NULL, NULL, 148810),
(148811, '1.10.238.10-FF-000743', NULL, 'Uncharacterized protein', 68, NULL, NULL, 148811),
(148812, '2.10.50.30-FF-000006', NULL, 'Uncharacterized protein', 79, NULL, NULL, 148812),
(148813, '1.10.287.80-FF-000017', NULL, 'Transcription initiation factor TFIID subunit 3', 60, NULL, NULL, 148813),
(148814, '2.60.40.60-FF-000086', NULL, 'Protocadherin 9', 99, NULL, NULL, 148814),
(148815, '3.40.50.300-FF-000588', NULL, 'Endoribonuclease Dicer isoform 1', 215, NULL, NULL, 148815),
(148816, '3.30.40.10-FF-001694', NULL, 'YALI0E30547p', 69, NULL, NULL, 148816),
(148817, '1.10.20.10-FF-000361', NULL, NULL, 88, NULL, NULL, 148817),
(148818, '3.40.120.10-FF-000057', NULL, 'Phosphomannomutase', 111, NULL, NULL, 148818),
(148819, '2.60.40.60-FF-000198', NULL, 'Protocadherin Fat 2', 103, NULL, NULL, 148819),
(148820, '3.60.130.20-FF-000005', NULL, 'Uncharacterized protein', 228, NULL, NULL, 148820),
(148821, '2.70.98.110-FF-000007', NULL, 'Mannosyl-oligosaccharide glucosidase', 257, NULL, NULL, 148821);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(148822, '2.130.10.10-FF-000189', NULL, 'Protein phosphatase PP2A regulatory subunit B', 126, NULL, NULL, 148822),
(148823, '2.10.110.10-FF-000022', NULL, 'prickle-like protein 2 isoform X1', 61, NULL, NULL, 148823),
(148824, '3.60.21.50-FF-000008', NULL, 'DNA polymerase delta 2, accessory subunit', 90, NULL, NULL, 148824),
(148825, '1.10.510.10-FF-000657', NULL, 'Putative inactive leucine-rich repeat receptor-like protein kinase', 201, NULL, NULL, 148825),
(148826, '2.60.34.10-FF-000040', NULL, 'Heat shock protein 70, putative', 147, NULL, NULL, 148826),
(148827, '1.20.930.20-FF-000015', NULL, 'Mixed lineage kinase domain-like protein', 62, NULL, NULL, 148827),
(148828, '3.20.180.20-FF-000034', NULL, 'Predicted protein', 120, NULL, NULL, 148828),
(148829, '2.60.120.260-FF-000239', NULL, 'Netrin 5', 43, NULL, NULL, 148829),
(148830, '3.40.50.300-FF-008570', NULL, 'Multidrug resistance protein ABC transporter family', 105, NULL, NULL, 148830),
(148831, '3.40.50.620-FF-000111', NULL, 'Mitochondrial isoleucyl-tRNA synthetase', 195, NULL, NULL, 148831),
(148832, '1.10.287.1770-FF-000008', NULL, 'Ferrous iron transport protein B', 100, NULL, NULL, 148832),
(148833, '2.60.40.640-FF-000058', NULL, 'Vacuolar sorting protein 26, putative', 151, NULL, NULL, 148833),
(148834, '3.40.50.1000-FF-000409', NULL, 'Uncharacterized protein', 200, NULL, NULL, 148834),
(148835, '2.10.110.10-FF-000241', NULL, 'YALI0A18381p', 68, NULL, NULL, 148835),
(148836, '2.30.42.10-FF-000071', NULL, 'harmonin isoform X1', 92, NULL, NULL, 148836),
(148837, '4.10.60.10-FF-000058', NULL, 'Cellular nucleic acid-binding protein homolog', 21, NULL, NULL, 148837),
(148838, '3.30.200.20-FF-000372', NULL, 'L-type lectin-domain containing receptor kinase VIII.1', 112, NULL, NULL, 148838),
(148839, '1.50.10.130-FF-000006', NULL, 'Terpene synthase 7', 163, NULL, NULL, 148839),
(148840, '3.40.390.10-FF-000082', NULL, 'Neutral protease 2', 177, NULL, NULL, 148840),
(148841, '3.90.650.10-FF-000001', NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase', 175, NULL, NULL, 148841),
(148842, '3.40.50.620-FF-000116', NULL, 'Arginine--tRNA ligase', 338, NULL, NULL, 148842),
(148843, '2.60.40.10-FF-006057', NULL, NULL, 107, NULL, NULL, 148843),
(148844, '1.10.510.10-FF-002793', NULL, NULL, 194, NULL, NULL, 148844),
(148845, '2.10.25.10-FF-001566', NULL, 'Uncharacterized protein', 77, NULL, NULL, 148845),
(148846, '2.40.70.10-FF-000332', NULL, NULL, 170, NULL, NULL, 148846),
(148847, '3.30.428.10-FF-000032', NULL, 'ADP-glucose phosphorylase', 186, NULL, NULL, 148847),
(148848, '3.40.50.1820-FF-001274', NULL, 'Predicted protein', 299, NULL, NULL, 148848),
(148849, '3.40.50.720-FF-001669', NULL, 'Predicted protein', 93, NULL, NULL, 148849),
(148850, '1.10.540.10-FF-000159', NULL, 'Putative medium-chain specific acyl-CoA dehydrogenase, mitochondrial-like Protein', 38, NULL, NULL, 148850),
(148851, '1.10.150.20-FF-000003', NULL, 'DNA polymerase I', 90, NULL, NULL, 148851),
(148852, '2.40.30.10-FF-000442', NULL, 'Elongation factor Tu', 52, NULL, NULL, 148852),
(148853, '1.10.30.10-FF-000075', NULL, 'Capicua transcriptional repressor a', 83, NULL, NULL, 148853),
(148854, '1.50.40.10-FF-000478', NULL, 'Predicted protein', 286, NULL, NULL, 148854),
(148855, '1.25.40.10-FF-000087', NULL, 'Nuclear autoantigenic sperm protein (Histone-binding)', 274, NULL, NULL, 148855),
(148856, '1.20.1250.20-FF-001553', NULL, 'MFS transporter', 408, NULL, NULL, 148856),
(148857, '3.40.50.1000-FF-000398', NULL, 'Phosphotransferase', 133, NULL, NULL, 148857),
(148858, '3.30.460.20-FF-000020', NULL, 'Chromosome 1, whole genome shotgun sequence', 144, NULL, NULL, 148858),
(148859, '2.60.120.40-FF-000048', NULL, 'Adipolin', 151, NULL, NULL, 148859),
(148860, '1.20.140.30-FF-000008', NULL, 'Putative MOB kinase activator-like 2B', 120, NULL, NULL, 148860),
(148861, '3.30.1370.10-FF-000037', NULL, 'KH domain protein', 98, NULL, NULL, 148861),
(148862, '2.20.28.120-FF-000002', NULL, '50S ribosomal protein L33', 54, NULL, NULL, 148862),
(148863, '3.30.160.60-FF-004371', NULL, NULL, 84, NULL, NULL, 148863);
INSERT INTO "PUBLIC"."MODEL" VALUES
(148864, '1.25.10.10-FF-002737', NULL, 'Uncharacterized protein', 820, NULL, NULL, 148864),
(148865, '3.20.20.70-FF-000587', NULL, NULL, 119, NULL, NULL, 148865),
(148866, '1.20.5.170-FF-000004', NULL, 'Keratin, type II cytoskeletal 5', 80, NULL, NULL, 148866),
(148867, '1.25.40.10-FF-000317', NULL, 'Tetratricopeptide repeat protein 30A', 130, NULL, NULL, 148867),
(148868, '3.30.230.10-FF-000101', NULL, 'Phosphomevalonate kinase', 268, NULL, NULL, 148868),
(148869, '2.60.200.20-FF-000094', NULL, 'NAD-dependent protein deacylase sirtuin-5, mitochondrial', 72, NULL, NULL, 148869),
(148870, '3.40.50.300-FF-002954', NULL, 'Protein kinase domain containing protein', 170, NULL, NULL, 148870),
(148871, '1.10.10.60-FF-000178', NULL, 'hematopoietically-expressed homeobox protein HHEX', 81, NULL, NULL, 148871),
(148872, '2.170.140.10-FF-000020', NULL, 'peritrophin-1 isoform X1', 64, NULL, NULL, 148872),
(148873, '3.30.200.20-FF-001788', NULL, 'Eukaryotic translation initiation factor 2 alpha kinase 2', 107, NULL, NULL, 148873),
(148874, '2.40.160.50-FF-000018', NULL, 'Outer membrane protein', 318, NULL, NULL, 148874),
(148875, '3.40.640.10-FF-000534', NULL, 'Uncharacterized protein', 73, NULL, NULL, 148875),
(148876, '3.40.50.300-FF-006546', NULL, 'Uncharacterized protein', 106, NULL, NULL, 148876),
(148877, '2.70.170.10-FF-000276', NULL, 'Uncharacterized protein', 101, NULL, NULL, 148877),
(148878, '2.30.30.1150-FF-000013', NULL, 'Uncharacterized protein', 168, NULL, NULL, 148878),
(148879, '3.30.200.20-FF-000602', NULL, 'Non-specific serine/threonine protein kinase', 84, NULL, NULL, 148879),
(148880, '2.130.10.10-FF-002555', NULL, 'WD repeat domain 19', 99, NULL, NULL, 148880),
(148881, '3.30.420.40-FF-000585', NULL, 'Actin, putative', 111, NULL, NULL, 148881),
(148882, '1.20.81.30-FF-000006', NULL, 'Protein transport protein HofC homolog', 118, NULL, NULL, 148882),
(148883, '2.30.180.10-FF-000196', NULL, NULL, 91, NULL, NULL, 148883),
(148884, '1.25.40.10-FF-004358', NULL, 'Uncharacterized protein', 155, NULL, NULL, 148884),
(148885, '3.40.50.10860-FF-000073', NULL, 'Bifunctional protein FolD 1 mitochondrial', 59, NULL, NULL, 148885),
(148886, '1.10.357.10-FF-000025', NULL, 'TetR family transcriptional regulator', 151, NULL, NULL, 148886),
(148887, '3.90.70.10-FF-000524', NULL, 'Unplaced genomic scaffold supercont1.10, whole genome shotgun sequence', 126, NULL, NULL, 148887),
(148888, '3.40.50.2300-FF-000243', NULL, 'Metabotropic glutamate receptor 5', 199, NULL, NULL, 148888),
(148889, '3.10.28.10-FF-000025', NULL, 'Probable intron-encoded endonuclease aI8', 122, NULL, NULL, 148889),
(148890, '1.10.132.60-FF-000046', NULL, 'Uncharacterized protein', 54, NULL, NULL, 148890),
(148891, '3.90.20.20-FF-000001', NULL, 'Protein GrpE', 104, NULL, NULL, 148891),
(148892, '1.10.1170.10-FF-000045', NULL, 'Predicted protein', 103, NULL, NULL, 148892),
(148893, '1.25.40.10-FF-002672', NULL, 'Erythrocyte binding protein, putative', 247, NULL, NULL, 148893),
(148894, '3.50.50.60-FF-000612', NULL, 'Amine oxidase', 410, NULL, NULL, 148894),
(148895, '3.30.40.10-FF-000064', NULL, 'Histone-lysine N-methyltransferase 2C', 54, NULL, NULL, 148895),
(148896, '3.30.160.60-FF-005202', NULL, NULL, 28, NULL, NULL, 148896),
(148897, '2.60.40.790-FF-000075', NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', 129, NULL, NULL, 148897),
(148898, '3.90.79.10-FF-000263', NULL, 'Nudix (nucleoside diphosphate linked moiety X)-type motif 15', 118, NULL, NULL, 148898),
(148899, '3.40.50.720-FF-000360', NULL, 'Short chain dehydrogenase', 251, NULL, NULL, 148899),
(148900, '3.30.830.10-FF-000181', NULL, 'Protease', 198, NULL, NULL, 148900),
(148901, '3.100.10.10-FF-000006', NULL, '39S ribosomal protein L15, mitochondrial', 92, NULL, NULL, 148901),
(148902, '3.30.565.10-FF-000406', NULL, 'Probable two-component sensor histidine kinase VicK', 146, NULL, NULL, 148902),
(148903, '3.40.350.10-FF-000085', NULL, 'Uncharacterized protein', 151, NULL, NULL, 148903),
(148904, '2.130.10.10-FF-002550', NULL, 'transducin beta-like protein 3', 254, NULL, NULL, 148904);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(148905, '3.40.50.1820-FF-001841', NULL, 'Uncharacterized protein', 78, NULL, NULL, 148905),
(148906, '3.30.200.20-FF-000046', NULL, 'Mitogen-activated protein kinase', 109, NULL, NULL, 148906),
(148907, '1.20.120.1750-FF-000153', NULL, 'RBR-type E3 ubiquitin transferase', 79, NULL, NULL, 148907),
(148908, '1.10.150.20-FF-000222', NULL, 'RNA helicase, activating signal cointegrator 1', 60, NULL, NULL, 148908),
(148909, '3.50.80.10-FF-000009', NULL, 'D-aminoacyl-tRNA deacylase', 155, NULL, NULL, 148909),
(148910, '2.10.25.10-FF-001673', NULL, 'Uncharacterized protein', 45, NULL, NULL, 148910),
(148911, '3.30.70.3290-FF-000014', NULL, 'Polyketide synthase type I', 124, NULL, NULL, 148911),
(148912, '1.10.287.1490-FF-000138', NULL, 'Viral A-type inclusion protein, putative', 190, NULL, NULL, 148912),
(148913, '3.40.50.1820-FF-001493', NULL, 'Uncharacterized protein', 163, NULL, NULL, 148913),
(148914, '2.60.40.10-FF-004371', NULL, NULL, 102, NULL, NULL, 148914),
(148915, '1.25.40.10-FF-002341', NULL, 'Uncharacterized protein', 135, NULL, NULL, 148915),
(148916, '2.60.40.60-FF-000872', NULL, 'Uncharacterized protein', 117, NULL, NULL, 148916),
(148917, '1.10.238.10-FF-000069', NULL, 'calcium-binding protein 1 isoform X1', 84, NULL, NULL, 148917),
(148918, '2.70.150.10-FF-000174', NULL, 'ATP2C2 isoform 14', 33, NULL, NULL, 148918),
(148919, '1.25.10.10-FF-002406', NULL, 'Uncharacterized protein', 255, NULL, NULL, 148919),
(148920, '2.40.50.140-FF-000381', NULL, 'DNA ligase', 178, NULL, NULL, 148920),
(148921, '3.40.50.2300-FF-000462', NULL, 'Signal transduction histidine kinase CheA', 119, NULL, NULL, 148921),
(148922, '3.40.50.10810-FF-000209', NULL, 'DNA repair protein, putative', 128, NULL, NULL, 148922),
(148923, '3.30.200.20-FF-001569', NULL, 'Uncharacterized protein', 31, NULL, NULL, 148923),
(148924, '3.10.20.90-FF-000672', NULL, 'Uncharacterized protein', 66, NULL, NULL, 148924),
(148925, '1.20.1250.20-FF-000142', NULL, 'probable anion transporter 3, chloroplastic', 199, NULL, NULL, 148925),
(148926, '1.10.418.10-FF-000274', NULL, 'Utrophin', 52, NULL, NULL, 148926),
(148927, '1.10.287.80-FF-000012', NULL, 'ATP synthase gamma chain', 96, NULL, NULL, 148927),
(148928, '3.30.160.60-FF-001150', NULL, 'zinc finger protein 324A isoform X1', 28, NULL, NULL, 148928),
(148929, '1.25.40.970-FF-000004', NULL, 'histone-lysine N-methyltransferase SMYD3', 79, NULL, NULL, 148929),
(148930, '3.30.70.330-FF-000053', NULL, 'Serine/arginine-rich splicing factor 1', 77, NULL, NULL, 148930),
(148931, '2.130.10.10-FF-002774', NULL, 'Uncharacterized protein', 228, NULL, NULL, 148931),
(148932, '3.40.390.10-FF-000205', NULL, NULL, 155, NULL, NULL, 148932),
(148933, '1.20.5.1160-FF-000035', NULL, 'Uncharacterized protein', 84, NULL, NULL, 148933),
(148934, '1.10.287.3550-FF-000003', NULL, 'Stromal interaction molecule 1', 136, NULL, NULL, 148934),
(148935, '1.25.10.10-FF-002058', NULL, 'Ipo7 protein', 217, NULL, NULL, 148935),
(148936, '3.80.10.10-FF-001229', NULL, 'Leucine-rich repeat protein, putative', 57, NULL, NULL, 148936),
(148937, '2.60.40.10-FF-002465', NULL, 'Uncharacterized protein', 99, NULL, NULL, 148937),
(148938, '3.30.460.20-FF-000025', NULL, 'Magnesium transport protein CorA', 118, NULL, NULL, 148938),
(148939, '3.30.40.10-FF-001587', NULL, 'Remodeling and spacing factor 1', 85, NULL, NULL, 148939),
(148940, '1.20.58.1040-FF-000011', NULL, '1,3-beta-glucanosyltransferase', 112, NULL, NULL, 148940),
(148941, '3.10.100.10-FF-000321', NULL, NULL, 146, NULL, NULL, 148941),
(148942, '1.20.1510.10-FF-000070', NULL, NULL, 198, NULL, NULL, 148942),
(148943, '2.120.10.30-FF-000611', NULL, 'DPP6 N-terminal domain-like protein', 131, NULL, NULL, 148943),
(148944, '1.20.1250.20-FF-001665', NULL, 'Monocarboxylate transporter, putative', 186, NULL, NULL, 148944),
(148945, '3.40.50.300-FF-000369', NULL, 'GTP-binding nuclear protein', 215, NULL, NULL, 148945),
(148946, '1.10.12.10-FF-000010', NULL, 'Enoyl-CoA hydratase EchA12', 61, NULL, NULL, 148946),
(148947, '1.10.10.60-FF-000408', NULL, 'Sigma-54 dependent transcriptional regulator', 55, NULL, NULL, 148947);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(148948, '1.10.10.10-FF-000528', NULL, 'Transcriptional regulatory protein EmbR', 101, NULL, NULL, 148948),
(148949, '2.40.10.10-FF-000547', NULL, NULL, 80, NULL, NULL, 148949),
(148950, '3.40.630.90-FF-000001', NULL, 'Uncharacterized protein', 159, NULL, NULL, 148950),
(148951, '1.10.10.60-FF-000066', NULL, 'Paired mesoderm homeobox protein 1', 71, NULL, NULL, 148951),
(148952, '2.120.10.30-FF-000263', NULL, 'Predicted protein', 235, NULL, NULL, 148952),
(148953, '3.40.50.720-FF-000253', NULL, 'Uncharacterized protein At5g02240', 251, NULL, NULL, 148953),
(148954, '3.30.160.60-FF-002673', NULL, 'Zinc finger protein 407', 67, NULL, NULL, 148954),
(148955, '1.20.1070.10-FF-001457', NULL, 'Vomeronasal type-1 receptor', 218, NULL, NULL, 148955),
(148956, '2.60.40.10-FF-000767', NULL, 'Vascular endothelial growth factor receptor 2', 86, NULL, NULL, 148956),
(148957, '2.10.10.20-FF-000006', NULL, 'Chitinase A1', 46, NULL, NULL, 148957),
(148958, '1.25.10.10-FF-000259', NULL, 'interferon-related developmental regulator 1', 263, NULL, NULL, 148958),
(148959, '3.30.160.60-FF-000874', NULL, 'zinc finger protein 235 isoform X1', 30, NULL, NULL, 148959),
(148960, '2.60.40.10-FF-004264', NULL, NULL, 98, NULL, NULL, 148960),
(148961, '3.60.15.10-FF-000280', NULL, 'Uncharacterized protein', 136, NULL, NULL, 148961),
(148962, '3.40.50.150-FF-001341', NULL, NULL, 194, NULL, NULL, 148962),
(148963, '2.170.8.10-FF-000007', NULL, 'Phosphoenolpyruvate carboxykinase [GTP]', 109, NULL, NULL, 148963),
(148964, '3.30.70.1050-FF-000016', NULL, 'Trigger factor', 113, NULL, NULL, 148964),
(148965, '3.30.70.2470-FF-000004', NULL, 'Uncharacterized protein', 58, NULL, NULL, 148965),
(148966, '3.40.50.720-FF-001883', NULL, 'NADPH-dependent pterin aldehyde reductase', 112, NULL, NULL, 148966),
(148967, '3.30.540.10-FF-000074', NULL, 'Uncharacterized protein', 111, NULL, NULL, 148967),
(148968, '3.30.565.10-FF-000058', NULL, 'Sensor protein', 136, NULL, NULL, 148968),
(148969, '1.10.3120.10-FF-000003', NULL, 'Trigger factor', 215, NULL, NULL, 148969),
(148970, '1.10.275.40-FF-000023', NULL, 'ERCC2/XPD/Rad3-related DNA repair helicase', 138, NULL, NULL, 148970),
(148971, '1.10.510.10-FF-002911', NULL, NULL, 100, NULL, NULL, 148971),
(148972, '2.60.40.10-FF-003988', NULL, NULL, 103, NULL, NULL, 148972),
(148973, '3.40.50.300-FF-003117', NULL, 'Putative ATP-dependent RNA helicase', 236, NULL, NULL, 148973),
(148974, '3.30.70.2460-FF-000001', NULL, 'DNA repair protein Rad4 family', 73, NULL, NULL, 148974),
(148975, '1.20.1250.20-FF-001772', NULL, 'Uncharacterized protein', 258, NULL, NULL, 148975),
(148976, '3.30.160.60-FF-006383', NULL, NULL, 68, NULL, NULL, 148976),
(148977, '1.10.8.10-FF-000100', NULL, 'Elongation factor Ts, mitochondrial', 46, NULL, NULL, 148977),
(148978, '2.170.130.10-FF-000064', NULL, NULL, 117, NULL, NULL, 148978),
(148979, '3.40.50.300-FF-008244', NULL, 'Elongation factor G, mitochondrial', 54, NULL, NULL, 148979),
(148980, '3.30.160.60-FF-000767', NULL, 'WW domain-binding protein 4', 60, NULL, NULL, 148980),
(148981, '3.30.420.10-FF-000020', NULL, 'Exodeoxyribonuclease X', 173, NULL, NULL, 148981),
(148982, '3.40.50.2300-FF-000810', NULL, NULL, 121, NULL, NULL, 148982),
(148983, '1.10.8.270-FF-000177', NULL, 'TBC1 domain family member 5 homolog A', 129, NULL, NULL, 148983),
(148984, '3.30.46.10-FF-000009', NULL, 'Glycine N-methyltransferase, putative', 82, NULL, NULL, 148984),
(148985, '1.10.510.10-FF-004373', NULL, NULL, 101, NULL, NULL, 148985),
(148986, '3.30.70.370-FF-000036', NULL, NULL, 91, NULL, NULL, 148986),
(148987, '1.10.10.10-FF-000309', NULL, 'Transcriptional activatory protein CaiF', 83, NULL, NULL, 148987),
(148988, '3.30.70.330-FF-000620', NULL, 'Interferon induced protein 35', 52, NULL, NULL, 148988),
(148989, '2.130.10.10-FF-000077', NULL, 'WD repeat domain 33', 97, NULL, NULL, 148989),
(148990, '1.10.10.60-FF-000627', NULL, 'Transcriptional regulator AraC/XylS family', 41, NULL, NULL, 148990),
(148991, '2.170.40.20-FF-000006', NULL, 'Envelope glycoprotein', 94, NULL, NULL, 148991);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(148992, '3.30.457.40-FF-000001', NULL, 'AT07283p', 96, NULL, NULL, 148992),
(148993, '2.40.100.10-FF-000149', NULL, 'Peptidyl-prolyl cis-trans isomerase', 173, NULL, NULL, 148993),
(148994, '2.30.40.10-FF-000004', NULL, 'Allantoinase', 121, NULL, NULL, 148994),
(148995, '3.90.550.10-FF-000308', NULL, 'Glycosyltransferase', 214, NULL, NULL, 148995),
(148996, '3.40.50.300-FF-004747', NULL, 'Adenylate kinase isoenzyme 6-like isoform A', 124, NULL, NULL, 148996),
(148997, '3.30.457.50-FF-000004', NULL, 'Spc25p', 54, NULL, NULL, 148997),
(148998, '1.20.1080.10-FF-000103', NULL, 'Uncharacterized protein', 167, NULL, NULL, 148998),
(148999, '3.90.79.10-FF-000156', NULL, 'ADP-ribose pyrophosphatase', 173, NULL, NULL, 148999),
(149000, '1.20.1310.10-FF-000195', NULL, NULL, 87, NULL, NULL, 149000),
(149001, '3.30.200.20-FF-001895', NULL, 'Protein kinase family protein', 112, NULL, NULL, 149001),
(149002, '1.10.10.10-FF-002097', NULL, 'Uncharacterized protein', 47, NULL, NULL, 149002),
(149003, '2.60.120.560-FF-000015', NULL, 'Glycosyl hydrolases family 32 superfamily', 159, NULL, NULL, 149003),
(149004, '3.40.50.2300-FF-000355', NULL, 'Transcription factor SKN7', 226, NULL, NULL, 149004),
(149005, '3.40.50.300-FF-000476', NULL, 'RNA helicase aquarius', 301, NULL, NULL, 149005),
(149006, '3.30.457.60-FF-000007', NULL, 'Mitotic spindle assembly checkpoint protein MAD1', 82, NULL, NULL, 149006),
(149007, '2.30.130.110-FF-000001', NULL, 'Galactarate dehydratase (L-threo-forming)', 78, NULL, NULL, 149007),
(149008, '3.30.160.60-FF-002454', NULL, 'PR domain containing 10', 59, NULL, NULL, 149008),
(149009, '1.20.58.390-FF-000076', NULL, 'Glutamate-gated chloride channel, putative', 136, NULL, NULL, 149009),
(149010, '3.10.150.10-FF-000032', NULL, 'Putative DNA polymerase III beta chain', 115, NULL, NULL, 149010),
(149011, '3.30.160.60-FF-001043', NULL, 'Zinc finger protein 462', 89, NULL, NULL, 149011),
(149012, '3.10.20.30-FF-000019', NULL, 'NADH oxidoreductase hcr', 93, NULL, NULL, 149012),
(149013, '1.10.472.10-FF-000545', NULL, 'Uncharacterized protein', 77, NULL, NULL, 149013),
(149014, '3.10.110.10-FF-000260', NULL, 'UEV domain/Zinc finger, C3HC4 type (RING finger), putative', 148, NULL, NULL, 149014),
(149015, '1.20.1250.20-FF-001446', NULL, 'Uncharacterized protein', 78, NULL, NULL, 149015),
(149016, '3.40.50.300-FF-001100', NULL, 'intraflagellar transport protein 22 homolog', 166, NULL, NULL, 149016),
(149017, '3.80.20.20-FF-000081', NULL, 'Uncharacterized protein', 129, NULL, NULL, 149017),
(149018, '3.20.20.300-FF-000070', NULL, NULL, 151, NULL, NULL, 149018),
(149019, '3.40.309.10-FF-000017', NULL, 'Aldehyde dehydrogenase B', 203, NULL, NULL, 149019),
(149020, '3.30.160.60-FF-004590', NULL, NULL, 73, NULL, NULL, 149020),
(149021, '1.20.58.420-FF-000006', NULL, NULL, 36, NULL, NULL, 149021),
(149022, '3.40.50.10950-FF-000004', NULL, 'NADP-dependent malic enzyme', 148, NULL, NULL, 149022),
(149023, '1.20.120.980-FF-000027', NULL, 'Serine peptidase, putative', 124, NULL, NULL, 149023),
(149024, '3.30.310.80-FF-000010', NULL, 'Non-specific serine/threonine protein kinase', 100, NULL, NULL, 149024),
(149025, '3.40.50.300-FF-005023', NULL, 'RAD51 paralog B', 83, NULL, NULL, 149025),
(149026, '3.10.20.10-FF-000013', NULL, '60S ribosomal protein L18a', 76, NULL, NULL, 149026),
(149027, '3.40.50.1820-FF-001167', NULL, '1-alkyl-2-acetylglycerophosphocholine esterase', 247, NULL, NULL, 149027),
(149028, '1.10.8.710-FF-000028', NULL, NULL, 102, NULL, NULL, 149028),
(149029, '3.10.50.40-FF-000069', NULL, 'Peptidylprolyl isomerase', 142, NULL, NULL, 149029),
(149030, '3.10.20.90-FF-000891', NULL, 'Uncharacterized protein', 52, NULL, NULL, 149030),
(149031, '1.10.510.10-FF-000876', NULL, 'Receptor-like protein kinase FERONIA', 217, NULL, NULL, 149031),
(149032, '3.40.50.150-FF-001122', NULL, NULL, 184, NULL, NULL, 149032),
(149033, '3.30.40.10-FF-000401', NULL, 'lysine-specific demethylase 5C isoform X4', 44, NULL, NULL, 149033),
(149034, '2.70.150.10-FF-000281', NULL, 'Cation-transporting ATPase', 145, NULL, NULL, 149034);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(149035, '3.30.200.20-FF-000607', NULL, 'Nuclear receptor-binding protein 2a', 99, NULL, NULL, 149035),
(149036, '1.25.40.20-FF-001152', NULL, 'Kinase, NEK', 141, NULL, NULL, 149036),
(149037, '3.40.50.720-FF-001664', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 184, NULL, NULL, 149037),
(149038, '3.40.47.10-FF-000023', NULL, 'Acetyl-CoA acetyltransferase', 182, NULL, NULL, 149038),
(149039, '1.25.40.20-FF-000876', NULL, 'Protein phosphatase 1 regulatory subunit 12A', 162, NULL, NULL, 149039),
(149040, '3.30.200.20-FF-000484', NULL, 'Serine/threonine protein kinase, putative', 85, NULL, NULL, 149040),
(149041, '3.90.226.10-FF-000257', NULL, 'Peptidase S41', 158, NULL, NULL, 149041),
(149042, '1.25.40.10-FF-002234', NULL, 'Uncharacterized protein', 326, NULL, NULL, 149042),
(149043, '1.20.140.40-FF-000006', NULL, 'Pectinesterase inhibitor 3', 165, NULL, NULL, 149043),
(149044, '3.40.50.10940-FF-000001', NULL, 'L-arabinose isomerase', 175, NULL, NULL, 149044),
(149045, '3.40.47.10-FF-000236', NULL, NULL, 64, NULL, NULL, 149045),
(149046, '2.60.34.10-FF-000045', NULL, 'Heat shock protein 70, putative', 129, NULL, NULL, 149046),
(149047, '1.25.10.10-FF-002513', NULL, 'Uncharacterized protein', 196, NULL, NULL, 149047),
(149048, '1.10.510.10-FF-001500', NULL, 'CK1/CK1 protein kinase', 168, NULL, NULL, 149048),
(149049, '3.30.910.10-FF-000001', NULL, 'DNA damage-inducible protein I', 81, NULL, NULL, 149049),
(149050, '3.30.910.20-FF-000004', NULL, 'Outer membrane chaperone Skp (OmpH)', 148, NULL, NULL, 149050),
(149051, '2.130.10.10-FF-004348', NULL, 'Uncharacterized protein', 96, NULL, NULL, 149051),
(149052, '3.30.1370.10-FF-000144', NULL, 'Drosophila dodeca-satellite protein 1', 77, NULL, NULL, 149052),
(149053, '1.20.144.10-FF-000129', NULL, 'Uncharacterized protein', 143, NULL, NULL, 149053),
(149054, '1.10.150.20-FF-000115', NULL, 'DNA repair protein REV1', 88, NULL, NULL, 149054),
(149055, '1.10.150.240-FF-000027', NULL, 'HAD superfamily hydrolase (TIGR01509 family)', 70, NULL, NULL, 149055),
(149056, '1.25.10.10-FF-002732', NULL, 'Uncharacterized protein', 866, NULL, NULL, 149056),
(149057, '3.40.50.1820-FF-001386', NULL, 'Esterase alnB', 220, NULL, NULL, 149057),
(149058, '3.40.50.2000-FF-000260', NULL, 'Starch synthase, chloroplastic/amyloplastic', 266, NULL, NULL, 149058),
(149059, '1.20.140.30-FF-000003', NULL, 'MOB kinase activator 2', 205, NULL, NULL, 149059),
(149060, '3.30.70.330-FF-000272', NULL, 'Serine/arginine-rich splicing factor RS2Z32', 84, NULL, NULL, 149060),
(149061, '3.40.50.880-FF-000054', NULL, 'Folate gamma-glutamyl hydrolase', 295, NULL, NULL, 149061),
(149062, '2.10.25.10-FF-001454', NULL, 'Uncharacterized protein', 42, NULL, NULL, 149062),
(149063, '3.30.70.330-FF-000401', NULL, '30S ribosomal protein 2, chloroplastic', 90, NULL, NULL, 149063),
(149064, '1.20.140.150-FF-000097', NULL, 'Uncharacterized protein', 94, NULL, NULL, 149064),
(149065, '2.60.40.10-FF-000329', NULL, 'Plexin A4', 138, NULL, NULL, 149065),
(149066, '3.30.420.40-FF-000703', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', 204, NULL, NULL, 149066),
(149067, '1.20.5.1300-FF-000010', NULL, 'Histidinol dehydrogenase', 54, NULL, NULL, 149067),
(149068, '3.30.160.60-FF-004819', NULL, NULL, 23, NULL, NULL, 149068),
(149069, '3.90.1150.10-FF-000237', NULL, 'DegT/DnrJ/EryC1/StrS family aminotransferase', 117, NULL, NULL, 149069),
(149070, '2.130.10.10-FF-000296', NULL, 'WD repeat domain 11', 196, NULL, NULL, 149070),
(149071, '3.90.550.10-FF-000527', NULL, '3-deoxy-manno-octulosonate cytidylyltransferase', 244, NULL, NULL, 149071),
(149072, '3.30.590.10-FF-000026', NULL, 'Creatine kinase B-type', 276, NULL, NULL, 149072),
(149073, '3.10.50.10-FF-000060', NULL, 'Uncharacterized protein', 72, NULL, NULL, 149073),
(149074, '1.20.58.390-FF-000295', NULL, 'Cholinergic receptor nicotinic gamma subunit', 105, NULL, NULL, 149074),
(149075, '3.40.140.10-FF-000171', NULL, 'Uncharacterized protein', 162, NULL, NULL, 149075),
(149076, '3.90.550.10-FF-000179', NULL, 'Phosphoglucomutase, cytoplasmic', 366, NULL, NULL, 149076);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(149077, '3.50.50.60-FF-000157', NULL, 'NAD-dependent dihydropyrimidine dehydrogenase subunit PreT', 160, NULL, NULL, 149077),
(149078, '1.10.1660.10-FF-000015', NULL, 'Transcriptional regulator, MerR family', 125, NULL, NULL, 149078),
(149079, '2.130.10.10-FF-000638', NULL, 'U3 small nucleolar RNA-associated protein 4 homolog', 226, NULL, NULL, 149079),
(149080, '1.20.1250.20-FF-001991', NULL, 'MFS polyamine transporter, putative', 387, NULL, NULL, 149080),
(149081, '3.40.50.2000-FF-000041', NULL, 'Glycogen [starch] synthase', 199, NULL, NULL, 149081),
(149082, '3.30.1050.10-FF-000002', NULL, 'SCP2 domain-containing protein YhbT', 95, NULL, NULL, 149082),
(149083, '2.130.10.10-FF-004567', NULL, 'Uncharacterized protein', 214, NULL, NULL, 149083),
(149084, '3.30.200.20-FF-000265', NULL, 'Mitogen-activated protein kinase kinase 6', 110, NULL, NULL, 149084),
(149085, '2.40.340.10-FF-000026', NULL, NULL, 62, NULL, NULL, 149085),
(149086, '3.30.70.920-FF-000027', NULL, 'Transcriptional regulator, AsnC family', 85, NULL, NULL, 149086),
(149087, '3.80.10.10-FF-001780', NULL, 'Uncharacterized protein', 137, NULL, NULL, 149087),
(149088, '3.40.50.150-FF-000633', NULL, '3-demethylubiquinone-9 3-methyltransferase', 176, NULL, NULL, 149088),
(149089, '1.10.3720.10-FF-000195', NULL, 'ABC transporter permease protein', 231, NULL, NULL, 149089),
(149090, '3.90.226.10-FF-000038', NULL, 'Retinol-binding protein 3', 202, NULL, NULL, 149090),
(149091, '2.40.33.10-FF-000027', NULL, 'Pyruvate kinase', 123, NULL, NULL, 149091),
(149092, '3.40.50.300-FF-008463', NULL, 'DNA replication and repair protein RecF', 144, NULL, NULL, 149092),
(149093, '1.25.10.10-FF-000478', NULL, 'ARM-repeat/Tetratricopeptide repeat (TPR)-like protein', 154, NULL, NULL, 149093),
(149094, '1.20.58.1480-FF-000007', NULL, 'Lon protease homolog', 65, NULL, NULL, 149094),
(149095, '3.50.50.60-FF-000505', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 172, NULL, NULL, 149095),
(149096, '6.20.10.30-FF-000011', NULL, 'DNA ligase', 39, NULL, NULL, 149096),
(149097, '2.120.10.30-FF-000044', NULL, 'Tyrosine-protein kinase receptor', 292, NULL, NULL, 149097),
(149098, '1.20.120.1630-FF-000010', NULL, 'Steroid alpha reductase family protein', 180, NULL, NULL, 149098),
(149099, '2.30.180.10-FF-000089', NULL, 'Transforming growth factor-beta-induced protein Ig-H3', 139, NULL, NULL, 149099),
(149100, '3.30.160.60-FF-000548', NULL, 'Zinc finger protein 423', 23, NULL, NULL, 149100),
(149101, '3.40.50.300-FF-005242', NULL, 'Septin AspA, putative', 195, NULL, NULL, 149101),
(149102, '3.40.190.290-FF-000047', NULL, 'LysR family transcriptional regulator', 204, NULL, NULL, 149102),
(149103, '3.30.50.10-FF-000014', NULL, 'Estrogen receptor beta', 108, NULL, NULL, 149103),
(149104, '3.20.140.10-FF-000034', NULL, 'Nicotinate phosphoribosyltransferase', 296, NULL, NULL, 149104),
(149105, '3.40.50.720-FF-000034', NULL, 'Potassium channel subfamily T member 1', 142, NULL, NULL, 149105),
(149106, '1.25.10.10-FF-001102', NULL, 'Tubulin-folding cofactor D', 308, NULL, NULL, 149106),
(149107, '2.30.30.40-FF-000288', NULL, 'Calcium channel, voltage-dependent, beta 3b', 137, NULL, NULL, 149107),
(149108, '3.40.50.300-FF-000695', NULL, 'Flagellar biosynthesis regulator FlhF', 186, NULL, NULL, 149108),
(149109, '1.10.10.60-FF-000285', NULL, 'Homeobox protein', 77, NULL, NULL, 149109),
(149110, '1.20.120.430-FF-000003', NULL, 'Related to GTPase MSS1, mitochondrial', 188, NULL, NULL, 149110),
(149111, '3.40.50.150-FF-000285', NULL, 'tRNA (cytosine(38)-C(5))-methyltransferase', 191, NULL, NULL, 149111),
(149112, '2.40.10.10-FF-000328', NULL, NULL, 99, NULL, NULL, 149112),
(149113, '3.40.50.2300-FF-000136', NULL, 'PTS sugar transporter subunit IIB', 101, NULL, NULL, 149113),
(149114, '3.30.565.10-FF-000277', NULL, 'Nitrogen fixation regulatory protein, NifL', 158, NULL, NULL, 149114),
(149115, '3.30.200.20-FF-002171', NULL, 'Uncharacterized protein', 63, NULL, NULL, 149115),
(149116, '2.10.25.10-FF-000043', NULL, 'Integrin beta', 73, NULL, NULL, 149116),
(149117, '3.30.50.10-FF-000121', NULL, 'Coup-like 1 transcription factor', 103, NULL, NULL, 149117);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(149118, '1.20.1070.10-FF-001676', NULL, 'Uncharacterized protein', 121, NULL, NULL, 149118),
(149119, '1.10.150.20-FF-000334', NULL, 'UvrABC system protein C', 59, NULL, NULL, 149119),
(149120, '3.30.450.40-FF-000082', NULL, 'Sensor histidine kinase', 165, NULL, NULL, 149120),
(149121, '1.20.1250.20-FF-001884', NULL, 'Uncharacterized protein', 93, NULL, NULL, 149121),
(149122, '3.30.70.20-FF-000125', NULL, NULL, 53, NULL, NULL, 149122),
(149123, '3.30.70.330-FF-001688', NULL, NULL, 79, NULL, NULL, 149123),
(149124, '3.30.70.330-FF-002306', NULL, NULL, 170, NULL, NULL, 149124),
(149125, '1.10.340.30-FF-000037', NULL, 'Putative 8-oxoguanine DNA glycosylase', 120, NULL, NULL, 149125),
(149126, '2.90.10.10-FF-000017', NULL, 'Putative receptor protein kinase ZmPK1', 130, NULL, NULL, 149126),
(149127, '3.40.50.720-FF-001338', NULL, 'Insect-type dehydrogenase', 249, NULL, NULL, 149127),
(149128, '3.40.532.10-FF-000036', NULL, NULL, 86, NULL, NULL, 149128),
(149129, '1.10.510.10-FF-004479', NULL, NULL, 255, NULL, NULL, 149129),
(149130, '2.60.40.60-FF-000760', NULL, 'Predicted protein', 106, NULL, NULL, 149130),
(149131, '1.25.40.10-FF-000648', NULL, 'Signal recognition particle subunit SRP72', 196, NULL, NULL, 149131),
(149132, '2.60.40.10-FF-004483', NULL, NULL, 139, NULL, NULL, 149132),
(149133, '3.30.870.10-FF-000065', NULL, 'Phospholipase D, putative', 199, NULL, NULL, 149133),
(149134, '2.60.200.20-FF-000223', NULL, 'Uncharacterized protein', 104, NULL, NULL, 149134),
(149135, '3.40.50.1980-FF-000096', NULL, 'Heme ABC superfamily ATP binding cassette transporter, binding protein', 123, NULL, NULL, 149135),
(149136, '1.20.58.2140-FF-000003', NULL, 'Translin', 199, NULL, NULL, 149136),
(149137, '3.40.50.10810-FF-000086', NULL, 'CHD3-type chromatin-remodeling factor PICKLE', 246, NULL, NULL, 149137),
(149138, '3.30.70.330-FF-000165', NULL, 'nuclear RNA export factor 1', 106, NULL, NULL, 149138),
(149139, '1.20.1560.10-FF-000123', NULL, 'Mini-chromosome maintenance complex-binding protein', 338, NULL, NULL, 149139),
(149140, '3.30.1360.120-FF-000059', NULL, 'GTP-binding protein TrmE N-terminus-domain-containing protein', 133, NULL, NULL, 149140),
(149141, '3.30.470.30-FF-000074', NULL, 'Uncharacterized protein', 148, NULL, NULL, 149141),
(149142, '1.10.760.10-FF-000029', NULL, 'Cytochrome c5', 78, NULL, NULL, 149142),
(149143, '3.40.640.10-FF-000080', NULL, 'Aminotransferase, putative', 261, NULL, NULL, 149143),
(149144, '2.130.10.10-FF-004129', NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', 184, NULL, NULL, 149144),
(149145, '2.160.20.10-FF-000104', NULL, 'Uncharacterized protein', 193, NULL, NULL, 149145),
(149146, '1.10.472.10-FF-000332', NULL, 'Putative ortholog of g2/mitotic-specific cyclin B3, 13 of 14', 107, NULL, NULL, 149146),
(149147, '2.30.29.30-FF-000214', NULL, 'FACT complex subunit SSRP1', 110, NULL, NULL, 149147),
(149148, '3.80.10.10-FF-001448', NULL, 'F-box/LRR protein', 178, NULL, NULL, 149148),
(149149, '1.10.238.10-FF-000288', NULL, 'Glycerol-3-phosphate dehydrogenase', 112, NULL, NULL, 149149),
(149150, '3.40.50.300-FF-004528', NULL, 'ATP-dependent DEAD/H RNA helicase, putative', 163, NULL, NULL, 149150),
(149151, '2.60.40.10-FF-004590', NULL, NULL, 100, NULL, NULL, 149151),
(149152, '1.20.58.2220-FF-000056', NULL, 'Uncharacterized protein', 134, NULL, NULL, 149152),
(149153, '3.40.50.1000-FF-000292', NULL, 'HAD family hydrolase', 100, NULL, NULL, 149153),
(149154, '1.25.40.280-FF-000011', NULL, 'pH-response regulator protein palA', 363, NULL, NULL, 149154),
(149155, '3.90.640.10-FF-000051', NULL, 'Actin-related protein, putative', 53, NULL, NULL, 149155),
(149156, '3.40.109.10-FF-000036', NULL, 'Oxygen-insensitive NAD(P)H nitroreductase', 171, NULL, NULL, 149156),
(149157, '3.30.160.60-FF-004707', NULL, NULL, 74, NULL, NULL, 149157),
(149158, '3.40.50.300-FF-006658', NULL, 'Uncharacterized protein', 86, NULL, NULL, 149158),
(149159, '3.30.460.80-FF-000015', NULL, 'NADH-quinone oxidoreductase subunit B/C/D', 134, NULL, NULL, 149159),
(149160, '3.30.565.10-FF-000283', NULL, 'Two-component system sensor histidine kinase', 155, NULL, NULL, 149160);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(149161, '1.25.40.10-FF-002902', NULL, 'Uncharacterized protein', 204, NULL, NULL, 149161),
(149162, '3.20.20.150-FF-000002', NULL, 'Xylose isomerase', 437, NULL, NULL, 149162),
(149163, '1.25.10.10-FF-002283', NULL, 'Uncharacterized protein', 331, NULL, NULL, 149163),
(149164, '2.60.40.60-FF-000647', NULL, 'Uncharacterized protein', 109, NULL, NULL, 149164),
(149165, '2.60.34.10-FF-000039', NULL, 'Heat shock protein 70, putative', 144, NULL, NULL, 149165),
(149166, '1.10.3720.10-FF-000083', NULL, 'Amino acid ABC transporter permease', 220, NULL, NULL, 149166),
(149167, '1.10.560.10-FF-000155', NULL, 'Uncharacterized protein', 214, NULL, NULL, 149167),
(149168, '3.30.40.10-FF-001817', NULL, 'Uncharacterized protein', 89, NULL, NULL, 149168),
(149169, '2.40.320.10-FF-000025', NULL, 'Mediator of RNA polymerase II transcription subunit 18', 270, NULL, NULL, 149169),
(149170, '3.30.30.10-FF-000013', NULL, NULL, 40, NULL, NULL, 149170),
(149171, '3.40.50.1820-FF-001616', NULL, 'Uncharacterized protein', 63, NULL, NULL, 149171),
(149172, '3.40.50.970-FF-000075', NULL, 'Oxoglutarate dehydrogenase (Succinyl-transferring), E1 component', 361, NULL, NULL, 149172),
(149173, '3.80.10.10-FF-000251', NULL, 'Ubiquitin ligase complex F-box protein GRR1', 132, NULL, NULL, 149173),
(149174, '3.40.50.300-FF-001083', NULL, 'Chromosome transmission fidelity factor 18', 211, NULL, NULL, 149174),
(149175, '1.20.58.1480-FF-000013', NULL, 'Lon protease homolog, mitochondrial', 73, NULL, NULL, 149175),
(149176, '2.10.25.10-FF-001128', NULL, 'von Willebrand factor D and EGF domains', 41, NULL, NULL, 149176),
(149177, '1.20.1720.10-FF-000001', NULL, 'Putative multidrug resistance protein MdtD', 210, NULL, NULL, 149177),
(149178, '1.10.10.60-FF-000852', NULL, NULL, 57, NULL, NULL, 149178),
(149179, '3.40.47.10-FF-000017', NULL, 'Acetyl-CoA acetyltransferase', 170, NULL, NULL, 149179),
(149180, '3.40.630.10-FF-000472', NULL, 'Predicted protein', 65, NULL, NULL, 149180),
(149181, '1.10.1820.10-FF-000005', NULL, 'Casein kinase II subunit beta', 103, NULL, NULL, 149181),
(149182, '1.10.238.10-FF-001232', NULL, 'Uncharacterized protein', 104, NULL, NULL, 149182),
(149183, '2.60.40.1360-FF-000007', NULL, 'Alpha-mannosidase', 142, NULL, NULL, 149183),
(149184, '1.10.10.10-FF-000298', NULL, 'Response regulator (OmpR)', 110, NULL, NULL, 149184),
(149185, '3.30.260.10-FF-000035', NULL, 'T-complex protein 1 subunit gamma', 73, NULL, NULL, 149185),
(149186, '2.130.10.10-FF-000863', NULL, 'U4/U6 small nuclear ribonucleoprotein PRP4', 224, NULL, NULL, 149186),
(149187, '3.40.50.720-FF-001670', NULL, 'Predicted protein', 123, NULL, NULL, 149187),
(149188, '2.120.10.30-FF-000156', NULL, 'GM17661', 311, NULL, NULL, 149188),
(149189, '2.30.42.10-FF-000520', NULL, NULL, 70, NULL, NULL, 149189),
(149190, '2.60.40.10-FF-005101', NULL, NULL, 99, NULL, NULL, 149190),
(149191, '2.40.50.320-FF-000002', NULL, 'Type 4 fimbrial biogenesis protein', 81, NULL, NULL, 149191),
(149192, '3.80.10.10-FF-001774', NULL, 'F-box/LRR-repeat protein 10', 177, NULL, NULL, 149192),
(149193, '3.10.450.50-FF-000055', NULL, 'Hypothetical_protein_-_conserved', 199, NULL, NULL, 149193),
(149194, '3.40.50.300-FF-003224', NULL, 'Uncharacterized protein', 191, NULL, NULL, 149194),
(149195, '1.10.443.10-FF-000017', NULL, 'NifD element site-specific recombinase XisA', 197, NULL, NULL, 149195),
(149196, '3.30.1680.10-FF-000027', NULL, 'Sema domain, immunoglobulin domain (Ig), transmembrane domain (TM) and short cytoplasmic domain, (semaphorin) 4Ga', 60, NULL, NULL, 149196),
(149197, '1.10.510.10-FF-002349', NULL, 'Uncharacterized protein', 280, NULL, NULL, 149197),
(149198, '1.25.40.20-FF-001601', NULL, 'Poly [ADP-ribose] polymerase', 112, NULL, NULL, 149198),
(149199, '2.130.10.10-FF-000970', NULL, 'Nuclear pore complex component (Sc Seh1)', 327, NULL, NULL, 149199),
(149200, '3.10.450.40-FF-000052', NULL, NULL, 62, NULL, NULL, 149200),
(149201, '2.40.50.140-FF-000611', NULL, 'Replication protein A 32 kDa subunit', 128, NULL, NULL, 149201),
(149202, '2.60.120.200-FF-000143', NULL, 'Crumbs, isoform D', 168, NULL, NULL, 149202); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(149203, '2.60.40.10-FF-000099', NULL, 'Fibronectin 1', 88, NULL, NULL, 149203),
(149204, '3.10.20.90-FF-000447', NULL, 'Large proline-rich protein bag6-A', 86, NULL, NULL, 149204),
(149205, '2.60.40.790-FF-000187', NULL, NULL, 109, NULL, NULL, 149205),
(149206, '3.80.10.10-FF-003702', NULL, 'Leucine-rich repeat protein (LRRP), putative', 166, NULL, NULL, 149206),
(149207, '3.30.420.40-FF-000473', NULL, 'EryA, erythritol kinase', 254, NULL, NULL, 149207),
(149208, '3.30.1370.50-FF-000021', NULL, 'Zinc finger protein', 71, NULL, NULL, 149208),
(149209, '3.40.630.30-FF-000478', NULL, 'GCN5-related N-acetyltransferase', 155, NULL, NULL, 149209),
(149210, '1.20.58.60-FF-000321', NULL, 'SMAll', 105, NULL, NULL, 149210),
(149211, '2.40.50.100-FF-000173', NULL, 'ABC transporter, ATP binding protein (Glucose)', 42, NULL, NULL, 149211),
(149212, '3.40.30.10-FF-001108', NULL, 'Uncharacterized protein', 31, NULL, NULL, 149212),
(149213, '3.40.50.1000-FF-000179', NULL, 'Hydrolase family protein / HAD-superfamily protein', 158, NULL, NULL, 149213),
(149214, '1.10.510.10-FF-002681', NULL, NULL, 178, NULL, NULL, 149214),
(149215, '1.20.144.10-FF-000017', NULL, 'Diacylglycerol pyrophosphate phosphatase 1', 242, NULL, NULL, 149215),
(149216, '2.60.40.1120-FF-000065', NULL, 'Putative cell surface-anchored phosphoesterase', 105, NULL, NULL, 149216),
(149217, '2.40.30.170-FF-000043', NULL, 'RND transporter MFP subunit', 80, NULL, NULL, 149217),
(149218, '3.90.740.10-FF-000008', NULL, 'Valine--tRNA ligase, mitochondrial', 41, NULL, NULL, 149218),
(149219, '3.30.750.24-FF-000108', NULL, 'Anti-sigma factor antagonist', 109, NULL, NULL, 149219),
(149220, '2.10.25.10-FF-001235', NULL, 'Uncharacterized protein', 48, NULL, NULL, 149220),
(149221, '1.10.238.10-FF-000395', NULL, 'Calcium-dependent protein kinase 23', 67, NULL, NULL, 149221),
(149222, '1.10.238.10-FF-001013', NULL, 'UBA domain-containing protein 8', 101, NULL, NULL, 149222),
(149223, '2.60.40.60-FF-000428', NULL, 'Protocadherin 20', 104, NULL, NULL, 149223),
(149224, '1.25.10.10-FF-000372', NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit', 377, NULL, NULL, 149224),
(149225, '3.90.226.10-FF-000145', NULL, 'Carboxy-terminal processing protease', 167, NULL, NULL, 149225),
(149226, '3.90.79.10-FF-000044', NULL, 'protein syndesmos isoform X1', 137, NULL, NULL, 149226),
(149227, '1.20.120.980-FF-000033', NULL, 'Uncharacterized protein', 138, NULL, NULL, 149227),
(149228, '3.40.630.10-FF-000359', NULL, 'Peptidase M20 domain-containing protein 2', 156, NULL, NULL, 149228),
(149229, '1.20.120.230-FF-000038', NULL, 'Cas scaffold protein family member 4', 120, NULL, NULL, 149229),
(149230, '3.80.10.10-FF-003921', NULL, 'AGAP011649-PA', 100, NULL, NULL, 149230),
(149231, '2.10.25.10-FF-001347', NULL, 'Laminin, gamma 3', 48, NULL, NULL, 149231),
(149232, '3.30.160.60-FF-004926', NULL, NULL, 50, NULL, NULL, 149232),
(149233, '2.60.40.10-FF-000992', NULL, 'Phosphoglucan phosphatase DSP4, chloroplastic', 91, NULL, NULL, 149233),
(149234, '1.10.506.10-FF-000097', NULL, 'Uncharacterized protein', 79, NULL, NULL, 149234),
(149235, '3.50.50.60-FF-000382', NULL, 'L-aspartate oxidase', 266, NULL, NULL, 149235),
(149236, '3.80.10.10-FF-001555', NULL, 'Ubiquitin-like_domain_containing_protein_-_putative', 136, NULL, NULL, 149236),
(149237, '3.80.10.10-FF-001667', NULL, 'F-box/LRR-repeat protein 20 isoform X1', 145, NULL, NULL, 149237),
(149238, '3.40.50.880-FF-000161', NULL, 'Biotin--[acetyl-CoA-carboxylase] ligase', 142, NULL, NULL, 149238),
(149239, '3.40.190.10-FF-000443', NULL, 'Phosphate ABC transporter, phosphate-binding component', 149, NULL, NULL, 149239),
(149240, '1.20.58.70-FF-000088', NULL, 'AFL232Wp', 95, NULL, NULL, 149240),
(149241, '3.40.190.10-FF-000224', NULL, 'Glutamate receptor', 46, NULL, NULL, 149241),
(149242, '2.170.8.10-FF-000013', NULL, 'Phosphoenolpyruvate carboxykinase', 23, NULL, NULL, 149242),
(149243, '1.25.40.10-FF-000980', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 71, NULL, NULL, 149243),
(149244, '3.40.309.10-FF-000023', NULL, 'Aldehyde dehydrogenase 12', 189, NULL, NULL, 149244);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(149245, '1.20.1560.10-FF-000016', NULL, 'ATP-binding cassette sub-family B member 8, mitochondrial', 269, NULL, NULL, 149245),
(149246, '1.25.40.20-FF-000983', NULL, 'Uncharacterized protein', 44, NULL, NULL, 149246),
(149247, '1.10.510.10-FF-001045', NULL, 'Serine/threonine-protein kinase SKY1', 109, NULL, NULL, 149247),
(149248, '2.60.40.60-FF-001035', NULL, 'Predicted protein', 101, NULL, NULL, 149248),
(149249, '1.20.1740.10-FF-000002', NULL, 'Putative solute carrier family 12 member 4', 441, NULL, NULL, 149249),
(149250, '3.90.70.10-FF-000395', NULL, 'Ubiquitin carboxyl-terminal hydrolase 2', 299, NULL, NULL, 149250),
(149251, '3.40.50.720-FF-001557', NULL, '3-ketodihydrosphingosine reductase TSC10', 251, NULL, NULL, 149251),
(149252, '1.10.472.10-FF-000551', NULL, 'Cyclin, N-terminal domain containing protein', 73, NULL, NULL, 149252),
(149253, '3.30.565.10-FF-000390', NULL, 'Histidine kinase', 139, NULL, NULL, 149253),
(149254, '1.20.1640.10-FF-000074', NULL, 'PaTched Related family', 207, NULL, NULL, 149254),
(149255, '2.40.10.10-FF-000553', NULL, NULL, 76, NULL, NULL, 149255),
(149256, '1.20.930.80-FF-000011', NULL, 'Uncharacterized protein', 94, NULL, NULL, 149256),
(149257, '2.130.10.10-FF-004461', NULL, 'Chromosome 1, whole genome shotgun sequence', 335, NULL, NULL, 149257),
(149258, '2.40.50.770-FF-000002', NULL, 'recQ-mediated genome instability protein 1', 154, NULL, NULL, 149258),
(149259, '3.90.1750.10-FF-000098', NULL, 'Predicted protein', 103, NULL, NULL, 149259),
(149260, '3.40.50.1820-FF-000998', NULL, 'GPI inositol-deacylase', 235, NULL, NULL, 149260),
(149261, '3.40.47.10-FF-000129', NULL, '3-hydroxy-3-methylglutaryl coenzyme A synthase', 456, NULL, NULL, 149261),
(149262, '1.20.58.1880-FF-000026', NULL, 'Uncharacterized protein', 127, NULL, NULL, 149262),
(149263, '3.30.519.10-FF-000007', NULL, 'Rab proteins geranylgeranyltransferase component A', 18, NULL, NULL, 149263),
(149264, '3.40.50.150-FF-000178', NULL, 'Anamorsin homolog', 126, NULL, NULL, 149264),
(149265, '3.40.50.1980-FF-000113', NULL, 'Periplasmic divalent manganese/zinc-binding lipoprotein', 113, NULL, NULL, 149265),
(149266, '3.30.950.30-FF-000004', NULL, 'Divergent AAA domain containing protein, putative', 181, NULL, NULL, 149266),
(149267, '1.25.10.10-FF-000933', NULL, 'Symplekin', 338, NULL, NULL, 149267),
(149268, '1.10.10.10-FF-000192', NULL, 'AsnC family transcriptional regulator', 49, NULL, NULL, 149268),
(149269, '3.90.70.10-FF-000176', NULL, 'Ubiquitin-specific protease', 429, NULL, NULL, 149269),
(149270, '1.20.58.60-FF-000102', NULL, 'utrophin isoform X2', 301, NULL, NULL, 149270),
(149271, '1.10.8.270-FF-000183', NULL, 'RabGAP/TBC domain-containing protein', 129, NULL, NULL, 149271),
(149272, '1.10.510.10-FF-002462', NULL, NULL, 200, NULL, NULL, 149272),
(149273, '3.90.1170.10-FF-000020', NULL, '39S ribosomal protein L16, mitochondrial-like', 181, NULL, NULL, 149273),
(149274, '3.30.160.60-FF-001262', NULL, 'zinc finger protein 18', 30, NULL, NULL, 149274),
(149275, '2.130.10.120-FF-000031', NULL, 'Uncharacterized protein', 81, NULL, NULL, 149275),
(149276, '3.40.1410.10-FF-000022', NULL, 'Transcriptional regulator, GntR family', 158, NULL, NULL, 149276),
(149277, '1.10.287.40-FF-000028', NULL, 'Uncharacterized protein', 74, NULL, NULL, 149277),
(149278, '3.30.230.70-FF-000080', NULL, 'Exosome complex component RRP42', 286, NULL, NULL, 149278),
(149279, '2.60.40.2030-FF-000006', NULL, 'Fraser extracellular matrix complex subunit 1', 122, NULL, NULL, 149279),
(149280, '3.50.50.60-FF-000270', NULL, 'FAD/NAD(P)-binding domain-containing protein', 399, NULL, NULL, 149280),
(149281, '1.10.1070.11-FF-000095', NULL, 'Phosphatidylinositol 3-kinase piki-1', 211, NULL, NULL, 149281),
(149282, '3.40.50.720-FF-000141', NULL, 'tRNA threonylcarbamoyladenosine dehydratase', 245, NULL, NULL, 149282),
(149283, '3.30.160.60-FF-006057', NULL, NULL, 46, NULL, NULL, 149283),
(149284, '1.20.1050.10-FF-000152', NULL, 'Uncharacterized protein', 131, NULL, NULL, 149284),
(149285, '3.10.110.10-FF-000035', NULL, 'SUMO-conjugating enzyme ubc9', 157, NULL, NULL, 149285);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(149286, '3.10.129.10-FF-000280', NULL, 'Acyl-CoA thioesterase 9, tandem duplicate 1', 59, NULL, NULL, 149286),
(149287, '3.90.1170.50-FF-000003', NULL, 'Aldehyde oxidase', 141, NULL, NULL, 149287),
(149288, '3.30.420.40-FF-000254', NULL, 'Heat shock protein 17', 105, NULL, NULL, 149288),
(149289, '3.30.200.20-FF-002064', NULL, 'Uncharacterized protein', 86, NULL, NULL, 149289),
(149290, '3.30.160.60-FF-000655', NULL, 'Zinc finger protein 462', 75, NULL, NULL, 149290),
(149291, '3.40.630.30-FF-000697', NULL, 'RNA cytidine acetyltransferase', 215, NULL, NULL, 149291),
(149292, '3.30.1490.100-FF-000003', NULL, 'Polymerase (DNA directed) iota', 121, NULL, NULL, 149292),
(149293, '1.10.1070.11-FF-000106', NULL, 'Uncharacterized protein', 136, NULL, NULL, 149293),
(149294, '1.10.472.10-FF-000219', NULL, 'Cyclin-D5-1', 89, NULL, NULL, 149294),
(149295, '1.10.10.60-FF-000740', NULL, NULL, 62, NULL, NULL, 149295),
(149296, '1.20.1250.20-FF-000136', NULL, 'Major facilitator superfamily domain-containing protein 6', 96, NULL, NULL, 149296),
(149297, '1.20.1540.10-FF-000015', NULL, 'RHOMBOID-like protein 10 chloroplastic', 183, NULL, NULL, 149297),
(149298, '2.10.25.10-FF-000150', NULL, 'Fibulin-1', 41, NULL, NULL, 149298),
(149299, '2.30.30.40-FF-000395', NULL, 'Chemotaxis protein CheA', 64, NULL, NULL, 149299),
(149300, '2.120.10.80-FF-000143', NULL, 'Multistep regulator of cAMP-PKA signaling', 215, NULL, NULL, 149300),
(149301, '2.60.40.150-FF-000804', NULL, 'Uncharacterized protein', 171, NULL, NULL, 149301),
(149302, '3.40.50.300-FF-004860', NULL, 'MutS domain V domaincontaining protein', 121, NULL, NULL, 149302),
(149303, '3.10.20.90-FF-000666', NULL, 'NEDD8 protein', 80, NULL, NULL, 149303),
(149304, '2.60.40.2020-FF-000003', NULL, 'Cysteine peptidase inhibitor', 113, NULL, NULL, 149304),
(149305, '1.20.120.140-FF-000017', NULL, 'Predicted protein', 115, NULL, NULL, 149305),
(149306, '1.20.1070.10-FF-001783', NULL, 'Uncharacterized protein', 326, NULL, NULL, 149306),
(149307, '3.30.450.190-FF-000012', NULL, 'Unplaced genomic scaffold supercont1.38, whole genome shotgun sequence', 165, NULL, NULL, 149307),
(149308, '1.20.120.810-FF-000010', NULL, NULL, 237, NULL, NULL, 149308),
(149309, '3.10.660.10-FF-000008', NULL, 'CSL zinc finger', 74, NULL, NULL, 149309),
(149310, '3.90.550.10-FF-000634', NULL, 'Glycosyl transferase, group 2 family protein', 182, NULL, NULL, 149310),
(149311, '2.60.40.10-FF-005320', NULL, NULL, 77, NULL, NULL, 149311),
(149312, '1.20.58.70-FF-000105', NULL, 'Diablo, IAP-binding mitochondrial protein b', 80, NULL, NULL, 149312),
(149313, '3.40.140.10-FF-000277', NULL, 'Uncharacterized protein', 67, NULL, NULL, 149313),
(149314, '2.30.42.10-FF-000301', NULL, 'PDZ and LIM domain protein 3', 69, NULL, NULL, 149314),
(149315, '3.30.360.10-FF-000088', NULL, 'Dehydrogenase, putative', 162, NULL, NULL, 149315),
(149316, '1.10.3720.10-FF-000206', NULL, 'Peptide ABC transporter permease protein', 219, NULL, NULL, 149316),
(149317, '3.30.160.60-FF-006276', NULL, NULL, 53, NULL, NULL, 149317),
(149318, '2.70.170.10-FF-000169', NULL, 'Nicotinic acetylcholine receptor alpha 9 subunit', 71, NULL, NULL, 149318),
(149319, '1.25.40.10-FF-004471', NULL, 'Uncharacterized protein', 107, NULL, NULL, 149319),
(149320, '3.20.20.100-FF-000015', NULL, 'Oxidoreductase, aldo/keto reductase family', 275, NULL, NULL, 149320),
(149321, '3.90.290.10-FF-000029', NULL, 'Fibrillin-1', 70, NULL, NULL, 149321),
(149322, '3.40.50.300-FF-006439', NULL, 'Uncharacterized protein', 125, NULL, NULL, 149322),
(149323, '2.160.20.10-FF-000216', NULL, 'Uncharacterized protein', 314, NULL, NULL, 149323),
(149324, '1.20.1070.10-FF-001564', NULL, 'Uncharacterized protein', 169, NULL, NULL, 149324),
(149325, '2.10.310.10-FF-000003', NULL, 'Serpin peptidase inhibitor 28', 29, NULL, NULL, 149325),
(149326, '1.25.40.10-FF-004813', NULL, 'Uncharacterized protein', 158, NULL, NULL, 149326),
(149327, '2.40.128.130-FF-000002', NULL, 'Putative outer membrane autotransporter', 306, NULL, NULL, 149327),
(149328, '3.30.465.10-FF-000005', NULL, 'Integral membrane protein TerC', 79, NULL, NULL, 149328);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(149329, '3.30.230.10-FF-000320', NULL, 'Predicted protein', 136, NULL, NULL, 149329),
(149330, '2.20.70.10-FF-000153', NULL, 'Pre-mRNA-processing factor 40 homolog A-like Protein', 42, NULL, NULL, 149330),
(149331, '3.50.50.60-FF-001467', NULL, 'Uncharacterized protein', 222, NULL, NULL, 149331),
(149332, '3.10.310.20-FF-000025', NULL, NULL, 159, NULL, NULL, 149332),
(149333, '1.20.120.1900-FF-000018', NULL, 'Gamma-tubulin complex component 6 isoform A', 314, NULL, NULL, 149333),
(149334, '1.20.1070.10-FF-001906', NULL, 'G protein-coupled receptor 85', 287, NULL, NULL, 149334),
(149335, '1.50.40.10-FF-000585', NULL, 'Solute carrier family 25 member 47', 51, NULL, NULL, 149335),
(149336, '3.40.50.300-FF-006097', NULL, 'Uncharacterized protein', 160, NULL, NULL, 149336),
(149337, '3.40.50.300-FF-002168', NULL, 'Dephospho-CoA kinase', 206, NULL, NULL, 149337),
(149338, '1.10.472.10-FF-000096', NULL, 'G1/S-specific cyclin-D3 isoform X2', 113, NULL, NULL, 149338),
(149339, '2.30.30.40-FF-000631', NULL, 'Uncharacterized protein', 85, NULL, NULL, 149339),
(149340, '3.10.310.10-FF-000022', NULL, 'Diaminopimelate epimerase', 143, NULL, NULL, 149340),
(149341, '1.20.1090.10-FF-000036', NULL, 'Glycerol-1-phosphate dehydrogenase [NAD(P)+]', 212, NULL, NULL, 149341),
(149342, '1.25.10.10-FF-001788', NULL, 'AP complex subunit beta', 597, NULL, NULL, 149342),
(149343, '3.50.4.10-FF-000037', NULL, NULL, 70, NULL, NULL, 149343),
(149344, '3.90.950.10-FF-000041', NULL, 'dTTP/UTP pyrophosphatase', 215, NULL, NULL, 149344),
(149345, '1.10.510.10-FF-000438', NULL, 'Tau tubulin kinase 2b', 48, NULL, NULL, 149345),
(149346, '3.40.50.1440-FF-000069', NULL, 'Tubulin alpha chain', 197, NULL, NULL, 149346),
(149347, '3.40.50.1820-FF-000312', NULL, 'Lipase H', 159, NULL, NULL, 149347),
(149348, '1.25.40.530-FF-000007', NULL, 'Rho GTPase-activating protein 39', 197, NULL, NULL, 149348),
(149349, '2.60.40.10-FF-002572', NULL, 'Tyrosine-protein kinase receptor', 120, NULL, NULL, 149349),
(149350, '3.30.160.60-FF-002347', NULL, 'Potential zinc finger protein', 22, NULL, NULL, 149350),
(149351, '3.40.640.10-FF-000192', NULL, 'Perosamine synthase', 241, NULL, NULL, 149351),
(149352, '3.90.550.50-FF-000056', NULL, 'Beta 3-glucosyltransferase b', 211, NULL, NULL, 149352),
(149353, '1.10.1420.10-FF-000037', NULL, 'DNA mismatch repair protein', 171, NULL, NULL, 149353),
(149354, '2.40.50.140-FF-000050', NULL, 'Lysine--tRNA ligase', 143, NULL, NULL, 149354),
(149355, '3.60.10.10-FF-000201', NULL, 'DNA-(Apurinic or apyrimidinic site) lyase,putative', 182, NULL, NULL, 149355),
(149356, '2.40.160.10-FF-000041', NULL, 'Outer membrane protein U porin OmpU', 300, NULL, NULL, 149356),
(149357, '3.30.379.10-FF-000018', NULL, NULL, 113, NULL, NULL, 149357),
(149358, '1.10.238.10-FF-000850', NULL, 'Calcium-binding protein CML37', 113, NULL, NULL, 149358),
(149359, '3.60.15.10-FF-000173', NULL, 'ElaC ribonuclease Z 2', 159, NULL, NULL, 149359),
(149360, '3.40.50.150-FF-000739', NULL, 'Guanidinoacetate N-methyltransferase', 176, NULL, NULL, 149360),
(149361, '3.10.330.10-FF-000017', NULL, 'Peroxisome biosynthesis protein-like protein', 87, NULL, NULL, 149361),
(149362, '3.30.1460.50-FF-000028', NULL, 'ATG10 autophagy related 10 homolog (S. cerevisiae)', 96, NULL, NULL, 149362),
(149363, '2.60.40.150-FF-000681', NULL, 'Phosphoinositide phospholipase C', 169, NULL, NULL, 149363),
(149364, '3.40.525.10-FF-000014', NULL, 'Ganglioside-induced differentiation-associated protein 2', 153, NULL, NULL, 149364),
(149365, '1.10.357.10-FF-000031', NULL, 'TetR family transcriptional regulator', 198, NULL, NULL, 149365),
(149366, '1.10.238.10-FF-000176', NULL, 'reticulocalbin-2 isoform X2', 92, NULL, NULL, 149366),
(149367, '2.170.120.12-FF-000009', NULL, 'DNA-directed RNA polymerase II 36 kDa polypeptide A', 132, NULL, NULL, 149367),
(149368, '1.10.1170.10-FF-000039', NULL, 'SBP (S-ribonuclease binding protein) family protein', 28, NULL, NULL, 149368),
(149369, '3.30.559.10-FF-000223', NULL, 'Uncharacterized protein', 180, NULL, NULL, 149369),
(149370, '1.20.1070.10-FF-000041', NULL, 'Muscarinic acetylcholine receptor', 115, NULL, NULL, 149370);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(149371, '2.130.10.10-FF-002881', NULL, 'Katanin p80 WD40 repeat-containing subunit B1 homolog', 170, NULL, NULL, 149371),
(149372, '3.40.50.2300-FF-001659', NULL, NULL, 187, NULL, NULL, 149372),
(149373, '1.10.287.130-FF-000100', NULL, 'Sensor histidine kinase/response regulator', 87, NULL, NULL, 149373),
(149374, '3.30.70.330-FF-002525', NULL, NULL, 59, NULL, NULL, 149374),
(149375, '1.20.58.60-FF-000208', NULL, 'Uncharacterized protein, isoform B', 205, NULL, NULL, 149375),
(149376, '3.40.350.10-FF-000102', NULL, 'Uncharacterized protein', 161, NULL, NULL, 149376),
(149377, '3.40.30.10-FF-001221', NULL, 'Protein disulfide-isomerase', 126, NULL, NULL, 149377),
(149378, '3.40.50.150-FF-001015', NULL, NULL, 196, NULL, NULL, 149378),
(149379, '3.65.10.10-FF-000028', NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', 215, NULL, NULL, 149379),
(149380, '2.40.20.10-FF-000048', NULL, 'Uncharacterized protein', 151, NULL, NULL, 149380),
(149381, '3.30.70.270-FF-000231', NULL, NULL, 122, NULL, NULL, 149381),
(149382, '1.10.238.10-FF-000518', NULL, 'EF-hand superfamily Ca2+-modulated protein', 163, NULL, NULL, 149382),
(149383, '1.20.5.170-FF-000010', NULL, 'Cyclic AMP-dependent transcription factor ATF-2', 61, NULL, NULL, 149383),
(149384, '2.40.30.130-FF-000059', NULL, 'Uncharacterized protein', 69, NULL, NULL, 149384),
(149385, '1.25.40.1040-FF-000011', NULL, 'Related to RNA14-component of pre-mRNA 3`-end processing factor CF I', 218, NULL, NULL, 149385),
(149386, '2.30.29.30-FF-001176', NULL, 'Uncharacterized protein', 128, NULL, NULL, 149386),
(149387, '3.40.50.300-FF-002842', NULL, 'DNA mismatch repair protein MutS', 248, NULL, NULL, 149387),
(149388, '2.60.120.1040-FF-000007', NULL, 'Protein CBG06449', 140, NULL, NULL, 149388),
(149389, '1.25.40.10-FF-000429', NULL, 'Pre-mRNA-processing factor 6, putative', 75, NULL, NULL, 149389),
(149390, '1.10.30.10-FF-000187', NULL, 'HMG', 95, NULL, NULL, 149390),
(149391, '2.60.120.10-FF-000629', NULL, 'Uncharacterized protein', 120, NULL, NULL, 149391),
(149392, '1.10.510.10-FF-000770', NULL, 'SRSF protein kinase 2', 53, NULL, NULL, 149392),
(149393, '3.30.1330.60-FF-000027', NULL, 'OmpA family protein', 142, NULL, NULL, 149393),
(149394, '2.60.120.1020-FF-000001', NULL, 'Peptide-N(4)-(N-acetyl-beta-glucosaminyl)asparagine amidase', 181, NULL, NULL, 149394),
(149395, '3.30.420.10-FF-000599', NULL, NULL, 193, NULL, NULL, 149395),
(149396, '2.130.10.10-FF-005877', NULL, 'Uncharacterized protein', 303, NULL, NULL, 149396),
(149397, '2.40.70.10-FF-000326', NULL, NULL, 174, NULL, NULL, 149397),
(149398, '2.60.40.150-FF-000568', NULL, 'Uncharacterized protein', 152, NULL, NULL, 149398),
(149399, '1.20.5.190-FF-000016', NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', 44, NULL, NULL, 149399),
(149400, '2.70.70.10-FF-000061', NULL, 'Uncharacterized protein', 129, NULL, NULL, 149400),
(149401, '3.30.565.10-FF-000513', NULL, 'Histidine kinase sensor protein', 151, NULL, NULL, 149401),
(149402, '1.10.510.10-FF-004480', NULL, NULL, 253, NULL, NULL, 149402),
(149403, '3.80.10.10-FF-003808', NULL, 'F-box/LRR-repeat protein 16-like Protein', 85, NULL, NULL, 149403),
(149404, '3.20.20.30-FF-000030', NULL, 'LLM class flavin-dependent oxidoreductase', 345, NULL, NULL, 149404),
(149405, '1.25.10.10-FF-002389', NULL, 'Uncharacterized protein', 263, NULL, NULL, 149405),
(149406, '2.170.270.10-FF-000243', NULL, 'Eukaryotic translation initiation factor 2 subunit 3-like Protein', 244, NULL, NULL, 149406),
(149407, '3.30.230.130-FF-000029', NULL, 'Cullin family protein', 146, NULL, NULL, 149407),
(149408, '3.20.20.70-FF-000699', NULL, NULL, 161, NULL, NULL, 149408),
(149409, '2.30.42.10-FF-000065', NULL, 'syntenin-1 isoform X1', 96, NULL, NULL, 149409),
(149410, '2.40.180.10-FF-000036', NULL, 'Catalase', 413, NULL, NULL, 149410),
(149411, '3.30.200.20-FF-000714', NULL, 'Nitrogen permease regulator', 91, NULL, NULL, 149411),
(149412, '2.60.120.1030-FF-000004', NULL, 'mRNA cleavage and polyadenylation factor CLP1', 84, NULL, NULL, 149412),
(149413, '3.30.200.20-FF-000153', NULL, 'Calcium/calmodulin-dependent protein kinase type I', 92, NULL, NULL, 149413); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(149414, '1.10.472.170-FF-000006', NULL, 'Os07g0504500 protein', 215, NULL, NULL, 149414),
(149415, '2.130.10.10-FF-002443', NULL, 'WD-40 repeat protein', 156, NULL, NULL, 149415),
(149416, '3.10.28.10-FF-000019', NULL, 'Vitamin B12-dependent ribonucleotide reductase', 113, NULL, NULL, 149416),
(149417, '1.10.472.10-FF-000438', NULL, 'D-type cyclin', 125, NULL, NULL, 149417),
(149418, '1.25.40.10-FF-004139', NULL, 'MSHA biogenesis protein MshN', 116, NULL, NULL, 149418),
(149419, '1.25.70.10-FF-000038', NULL, 'GM18334', 252, NULL, NULL, 149419),
(149420, '3.40.47.10-FF-000130', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 2', 434, NULL, NULL, 149420),
(149421, '1.10.274.100-FF-000003', NULL, 'DNA-directed RNA polymerase subunit', 171, NULL, NULL, 149421),
(149422, '3.30.450.40-FF-000188', NULL, 'GAF domain-containing protein', 160, NULL, NULL, 149422),
(149423, '2.30.30.40-FF-000176', NULL, 'Tyrosine-protein kinase', 76, NULL, NULL, 149423),
(149424, '1.10.10.60-FF-000397', NULL, 'Blast:Homeobox protein Hmx', 75, NULL, NULL, 149424),
(149425, '1.20.1310.10-FF-000083', NULL, 'Protein CBR-CUL-2', 125, NULL, NULL, 149425),
(149426, '3.40.50.150-FF-000397', NULL, 'Cytotoxin|haemolysin homologue TLYA', 212, NULL, NULL, 149426),
(149427, '2.70.170.10-FF-000282', NULL, 'Uncharacterized protein', 73, NULL, NULL, 149427),
(149428, '3.10.129.10-FF-000061', NULL, 'Probable dehydrogenase', 283, NULL, NULL, 149428),
(149429, '2.110.10.10-FF-000027', NULL, 'Protein CBG23191', 198, NULL, NULL, 149429),
(149430, '3.40.50.300-FF-004641', NULL, 'Putative RNA helicase armi-like Protein', 206, NULL, NULL, 149430),
(149431, '3.40.1090.10-FF-000047', NULL, 'Patatin-like protein, PlpD', 137, NULL, NULL, 149431),
(149432, '3.20.20.80-FF-000016', NULL, 'Maltase-glucoamylase, intestinal', 349, NULL, NULL, 149432),
(149433, '3.10.100.10-FF-000208', NULL, 'Mannose-binding protein C', 115, NULL, NULL, 149433),
(149434, '1.20.58.860-FF-000008', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 60, NULL, NULL, 149434),
(149435, '3.30.200.20-FF-002283', NULL, 'Uncharacterized protein', 165, NULL, NULL, 149435),
(149436, '3.40.50.720-FF-002052', NULL, 'Uncharacterized protein', 173, NULL, NULL, 149436),
(149437, '1.25.10.10-FF-003120', NULL, 'Uncharacterized protein', 209, NULL, NULL, 149437),
(149438, '3.90.105.10-FF-000016', NULL, 'Molybdopterin molybdenumtransferase', 56, NULL, NULL, 149438),
(149439, '3.60.150.10-FF-000003', NULL, 'Chorismate synthase', 355, NULL, NULL, 149439),
(149440, '2.40.50.140-FF-000830', NULL, NULL, 100, NULL, NULL, 149440),
(149441, '1.10.720.60-FF-000019', NULL, 'Enolase-phosphatase E1', 77, NULL, NULL, 149441),
(149442, '3.40.50.11370-FF-000001', NULL, 'Inositol-tetrakisphosphate 1-kinase', 126, NULL, NULL, 149442),
(149443, '3.40.630.10-FF-000253', NULL, 'Uncharacterized protein', 378, NULL, NULL, 149443),
(149444, '1.20.5.430-FF-000009', NULL, 'Uncharacterized protein', 61, NULL, NULL, 149444),
(149445, '4.10.860.10-FF-000008', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 42, NULL, NULL, 149445),
(149446, '3.40.50.720-FF-001776', NULL, '2-dehydropantoate 2-reductase', 183, NULL, NULL, 149446),
(149447, '3.30.390.110-FF-000007', NULL, '60S ribosomal protein L28', 121, NULL, NULL, 149447),
(149448, '3.30.559.10-FF-000004', NULL, 'Acetyltransferase component of pyruvate dehydrogenase complex', 246, NULL, NULL, 149448),
(149449, '2.60.120.650-FF-000036', NULL, 'Lysine-specific demethylase rbr-2', 275, NULL, NULL, 149449),
(149450, '3.30.70.270-FF-000012', NULL, 'DNA polymerase V subunit', 87, NULL, NULL, 149450),
(149451, '3.40.50.300-FF-006771', NULL, 'Uncharacterized protein', 61, NULL, NULL, 149451),
(149452, '3.30.40.10-FF-000171', NULL, 'E3 ubiquitin-protein ligase TRIM39', 92, NULL, NULL, 149452),
(149453, '3.80.10.10-FF-000032', NULL, 'Slit homolog 2 (Drosophila)', 114, NULL, NULL, 149453),
(149454, '1.20.1280.290-FF-000025', NULL, 'MtN3-like protein', 85, NULL, NULL, 149454),
(149455, '3.30.1330.10-FF-000041', NULL, 'Selenide, water dikinase', 100, NULL, NULL, 149455);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(149456, '1.25.40.20-FF-001040', NULL, 'Ankyrin repeat family protein', 94, NULL, NULL, 149456),
(149457, '3.30.40.10-FF-000513', NULL, 'Transcriptional regulator (Cti6), putative', 70, NULL, NULL, 149457),
(149458, '3.40.50.620-FF-000223', NULL, 'Sulfate adenylyltransferase', 251, NULL, NULL, 149458),
(149459, '1.25.40.10-FF-000761', NULL, 'pentatricopeptide repeat-containing protein 1, mitochondrial', 195, NULL, NULL, 149459),
(149460, '2.120.10.30-FF-000375', NULL, 'Uncharacterized protein', 53, NULL, NULL, 149460),
(149461, '1.10.287.940-FF-000023', NULL, 'p2X purinoceptor,putative', 42, NULL, NULL, 149461),
(149462, '2.30.30.40-FF-000518', NULL, 'Tyrosine-protein kinase', 84, NULL, NULL, 149462),
(149463, '3.40.50.620-FF-000004', NULL, 'tRNA-specific 2-thiouridylase MnmA', 212, NULL, NULL, 149463),
(149464, '2.10.50.30-FF-000012', NULL, 'Uncharacterized protein', 79, NULL, NULL, 149464),
(149465, '2.40.10.10-FF-000098', NULL, 'Coagulation factor XII', 117, NULL, NULL, 149465),
(149466, '3.30.160.60-FF-003403', NULL, 'CRE-ZTF-12 protein', 79, NULL, NULL, 149466),
(149467, '1.10.287.280-FF-000004', NULL, 'DNA-dependent RNA polymerase', 78, NULL, NULL, 149467),
(149468, '2.40.30.10-FF-000329', NULL, 'Dihydroorotate dehydrogenase electron transfer subunit', 96, NULL, NULL, 149468),
(149469, '3.30.497.10-FF-000124', NULL, 'Uncharacterized serpin-like protein PAE0049', 186, NULL, NULL, 149469),
(149470, '3.30.160.60-FF-002566', NULL, NULL, 28, NULL, NULL, 149470),
(149471, '3.30.230.10-FF-000207', NULL, 'Ribonuclease P protein component', 117, NULL, NULL, 149471),
(149472, '1.20.272.10-FF-000062', NULL, NULL, 91, NULL, NULL, 149472),
(149473, '1.10.1600.10-FF-000023', NULL, 'Cku-70', 95, NULL, NULL, 149473),
(149474, '3.30.40.10-FF-001930', NULL, 'Uncharacterized protein', 70, NULL, NULL, 149474),
(149475, '3.30.70.960-FF-000011', NULL, 'Transmembrane protease serine', 106, NULL, NULL, 149475),
(149476, '3.40.630.40-FF-000014', NULL, 'N-formylglutamate amidohydrolase', 259, NULL, NULL, 149476),
(149477, '3.30.2350.10-FF-000042', NULL, 'RNA pseudouridine synthase', 250, NULL, NULL, 149477),
(149478, '1.25.10.10-FF-002844', NULL, 'HEAT repeat-containing protein 1', 173, NULL, NULL, 149478),
(149479, '1.20.1070.10-FF-000260', NULL, 'Dopamine receptor 1', 328, NULL, NULL, 149479),
(149480, '3.80.10.10-FF-003685', NULL, 'Protein CBG20033', 187, NULL, NULL, 149480),
(149481, '1.25.40.20-FF-000764', NULL, 'Uncharacterized protein', 187, NULL, NULL, 149481),
(149482, '3.30.750.24-FF-000002', NULL, 'Sulfate transporter 31', 147, NULL, NULL, 149482),
(149483, '3.40.50.300-FF-002387', NULL, 'Small GTP-binding protein domain containing protein', 198, NULL, NULL, 149483),
(149484, '2.60.40.1180-FF-000167', NULL, 'Alpha-mannosidase', 122, NULL, NULL, 149484),
(149485, '1.20.920.30-FF-000068', NULL, 'Dynein heavy chain domain 1', 97, NULL, NULL, 149485),
(149486, '3.30.70.330-FF-000384', NULL, 'Polyadenylate-binding protein', 98, NULL, NULL, 149486),
(149487, '1.10.10.970-FF-000003', NULL, 'Phosphotransferase, putative', 70, NULL, NULL, 149487),
(149488, '2.70.98.10-FF-000068', NULL, 'Putative alpha-1,2-mannosidase', 97, NULL, NULL, 149488),
(149489, '1.10.287.990-FF-000009', NULL, 'Putative superoxide dismutase', 65, NULL, NULL, 149489),
(149490, '2.40.30.330-FF-000018', NULL, 'mRNA cleavage and polyadenylation factor clp1', 133, NULL, NULL, 149490),
(149491, '3.30.420.100-FF-000002', NULL, '60S ribosomal protein L5', 292, NULL, NULL, 149491),
(149492, '3.30.160.60-FF-006495', NULL, NULL, 28, NULL, NULL, 149492),
(149493, '1.20.120.1750-FF-000046', NULL, 'RBR-type E3 ubiquitin transferase', 72, NULL, NULL, 149493),
(149494, '1.20.120.1760-FF-000049', NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', 163, NULL, NULL, 149494),
(149495, '2.30.36.70-FF-000001', NULL, 'Actin, alpha skeletal muscle', 38, NULL, NULL, 149495),
(149496, '3.30.710.10-FF-000014', NULL, 'Rho-related BTB domain-containing protein 2 isoform 1', 161, NULL, NULL, 149496),
(149497, '1.20.1530.20-FF-000068', NULL, 'Cation/H(+) antiporter 14', 403, NULL, NULL, 149497);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(149498, '3.30.2010.10-FF-000005', NULL, 'CAAX prenyl protease', 84, NULL, NULL, 149498),
(149499, '3.40.640.10-FF-000079', NULL, 'LPS biosynthesis protein', 304, NULL, NULL, 149499),
(149500, '3.30.1030.10-FF-000001', NULL, 'Methenyltetrahydromethanopterin cyclohydrolase', 199, NULL, NULL, 149500),
(149501, '1.25.40.10-FF-004252', NULL, 'Uncharacterized protein', 233, NULL, NULL, 149501),
(149502, '2.160.20.10-FF-000093', NULL, 'Cell surface protein', 249, NULL, NULL, 149502),
(149503, '2.10.110.10-FF-000128', NULL, 'Pxl1p', 74, NULL, NULL, 149503),
(149504, '4.10.60.10-FF-000171', NULL, 'WGS project CABT00000000 data, contig 2.31', 28, NULL, NULL, 149504),
(149505, '3.40.30.10-FF-000945', NULL, 'Uncharacterized protein', 109, NULL, NULL, 149505),
(149506, '3.30.160.60-FF-002785', NULL, 'DNA polymerase kappa subunit', 29, NULL, NULL, 149506),
(149507, '3.30.70.330-FF-001469', NULL, 'RNA-binding protein 4', 99, NULL, NULL, 149507),
(149508, '3.80.10.10-FF-003466', NULL, 'Uncharacterized protein', 330, NULL, NULL, 149508),
(149509, '1.20.1310.10-FF-000206', NULL, NULL, 41, NULL, NULL, 149509),
(149510, '1.25.40.20-FF-000545', NULL, 'Serine/threonine-protein phosphatase 6 regulatory ankyrin repeat subunit A', 136, NULL, NULL, 149510),
(149511, '3.90.70.10-FF-000631', NULL, 'Calpain-like protease palB', 121, NULL, NULL, 149511),
(149512, '3.30.2350.20-FF-000045', NULL, NULL, 234, NULL, NULL, 149512),
(149513, '1.25.40.10-FF-003976', NULL, 'Uncharacterized protein', 224, NULL, NULL, 149513),
(149514, '1.10.10.10-FF-000972', NULL, 'ORC1-type DNA replication protein', 88, NULL, NULL, 149514),
(149515, '3.30.310.50-FF-000029', NULL, 'Phosphoacetylglucosamine mutase', 80, NULL, NULL, 149515),
(149516, '1.10.3180.10-FF-000001', NULL, 'Ethylene insensitive 3-like 1', 138, NULL, NULL, 149516),
(149517, '1.10.940.10-FF-000015', NULL, '16S rRNA methyltransferase B', 132, NULL, NULL, 149517),
(149518, '3.40.50.12780-FF-000204', NULL, 'Long-chain-fatty-acid--luciferin-component ligase', 320, NULL, NULL, 149518),
(149519, '3.10.100.10-FF-000085', NULL, 'Uncharacterized protein, isoform B', 158, NULL, NULL, 149519),
(149520, '3.40.50.300-FF-006990', NULL, 'Uncharacterized protein', 213, NULL, NULL, 149520),
(149521, '1.25.40.10-FF-000542', NULL, 'Pentatricopeptide repeat-containing protein MRL1, chloroplastic isoform X1', 92, NULL, NULL, 149521),
(149522, '3.30.160.60-FF-003061', NULL, 'GD25683', 101, NULL, NULL, 149522),
(149523, '3.40.50.300-FF-002729', NULL, '50S ribosome-binding GTPase/Dynamin family, putative', 255, NULL, NULL, 149523),
(149524, '3.30.160.60-FF-004820', NULL, NULL, 30, NULL, NULL, 149524),
(149525, '2.40.10.10-FF-000659', NULL, NULL, 85, NULL, NULL, 149525),
(149526, '3.30.420.40-FF-000692', NULL, 'Xylulokinase', 302, NULL, NULL, 149526),
(149527, '1.10.110.10-FF-000003', NULL, 'pEARLI1-like lipid transfer protein 1', 85, NULL, NULL, 149527),
(149528, '1.20.140.150-FF-000114', NULL, 'Uncharacterized protein', 131, NULL, NULL, 149528),
(149529, '1.10.533.10-FF-000244', NULL, 'Si:dkey-265e15.2', 55, NULL, NULL, 149529),
(149530, '3.10.100.10-FF-000427', NULL, NULL, 82, NULL, NULL, 149530),
(149531, '2.70.40.10-FF-000014', NULL, 'dUTP pyrophosphatase', 152, NULL, NULL, 149531),
(149532, '4.10.640.10-FF-000026', NULL, '28S ribosomal protein S18a, mitochondrial', 64, NULL, NULL, 149532),
(149533, '3.60.21.10-FF-000463', NULL, 'Serine/threonine-protein phosphatase', 134, NULL, NULL, 149533),
(149534, '1.10.10.10-FF-000079', NULL, 'GntR family transcriptional regulator', 77, NULL, NULL, 149534),
(149535, '2.60.40.10-FF-002914', NULL, 'Protein sidekick homolog', 94, NULL, NULL, 149535),
(149536, '3.30.1010.10-FF-000112', NULL, 'Serine/threonine-protein kinase tel1', 111, NULL, NULL, 149536),
(149537, '2.80.10.50-FF-000198', NULL, 'Ryanodine receptor 3', 156, NULL, NULL, 149537),
(149538, '1.10.510.10-FF-002568', NULL, 'Uncharacterized protein', 258, NULL, NULL, 149538),
(149539, '2.60.40.150-FF-000349', NULL, 'Copine family protein', 141, NULL, NULL, 149539),
(149540, '3.40.50.300-FF-003005', NULL, '26S protease regulatory subunit 7', 181, NULL, NULL, 149540);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(149541, '1.10.10.440-FF-000075', NULL, 'Uncharacterized protein', 58, NULL, NULL, 149541),
(149542, '2.170.300.10-FF-000004', NULL, 'Laminin subunit beta 1', 104, NULL, NULL, 149542),
(149543, '3.80.10.10-FF-004303', NULL, 'Uncharacterized protein', 218, NULL, NULL, 149543),
(149544, '3.30.70.1450-FF-000030', NULL, 'Trk system potassium uptake protein CeoB', 70, NULL, NULL, 149544),
(149545, '3.40.50.1000-FF-000853', NULL, NULL, 57, NULL, NULL, 149545),
(149546, '3.30.60.20-FF-000063', NULL, 'Protein kinase C', 82, NULL, NULL, 149546),
(149547, '2.40.70.10-FF-000107', NULL, 'Pepsin-like aspartic protease A1', 156, NULL, NULL, 149547),
(149548, '3.40.50.1820-FF-000869', NULL, 'Predicted protein', 427, NULL, NULL, 149548),
(149549, '3.90.340.10-FF-000001', NULL, 'Nitric oxide synthase, endothelial', 170, NULL, NULL, 149549),
(149550, '3.90.1170.50-FF-000004', NULL, 'Selenate reductase subunit YgfN', 98, NULL, NULL, 149550),
(149551, '3.20.20.220-FF-000018', NULL, 'Methylenetetrahydrofolate reductase', 292, NULL, NULL, 149551),
(149552, '3.90.1580.10-FF-000006', NULL, 'Generic methyltransferase, putative', 271, NULL, NULL, 149552),
(149553, '2.10.25.10-FF-000185', NULL, 'basement membrane-specific heparan sulfate proteoglycan core protein-like', 41, NULL, NULL, 149553),
(149554, '3.90.70.10-FF-000862', NULL, 'Protein CBG17827', 94, NULL, NULL, 149554),
(149555, '3.30.559.30-FF-000117', NULL, 'Nonribosomal peptide synthetase easA', 180, NULL, NULL, 149555),
(149556, '3.10.110.10-FF-000226', NULL, 'Uncharacterized protein', 107, NULL, NULL, 149556),
(149557, '3.30.160.20-FF-000043', NULL, '60S ribosomal protein L3', 92, NULL, NULL, 149557),
(149558, '1.20.5.340-FF-000096', NULL, 'Uncharacterized protein', 86, NULL, NULL, 149558),
(149559, '3.30.160.60-FF-005911', NULL, NULL, 37, NULL, NULL, 149559),
(149560, '1.10.630.10-FF-000094', NULL, 'cytochrome P450 2J6-like', 471, NULL, NULL, 149560),
(149561, '1.25.10.10-FF-002480', NULL, 'Predicted protein', 212, NULL, NULL, 149561),
(149562, '3.90.470.20-FF-000075', NULL, 'Glr2851 protein', 110, NULL, NULL, 149562),
(149563, '4.10.400.10-FF-000346', NULL, 'Uncharacterized protein', 35, NULL, NULL, 149563),
(149564, '3.40.50.300-FF-004725', NULL, 'Uncharacterized protein', 71, NULL, NULL, 149564),
(149565, '1.20.5.500-FF-000020', NULL, NULL, 43, NULL, NULL, 149565),
(149566, '1.10.3460.10-FF-000029', NULL, 'Chlorophyll a-b binding protein, chloroplastic', 160, NULL, NULL, 149566),
(149567, '2.30.30.210-FF-000007', NULL, 'Uncharacterized protein', 99, NULL, NULL, 149567),
(149568, '3.40.367.20-FF-000037', NULL, 'Phosphotransferase', 28, NULL, NULL, 149568),
(149569, '3.90.550.50-FF-000091', NULL, 'Hexosyltransferase', 262, NULL, NULL, 149569),
(149570, '2.60.40.10-FF-001128', NULL, 'Sallimus, isoform P', 102, NULL, NULL, 149570),
(149571, '1.50.10.20-FF-000148', NULL, 'Ent-copalyl diphosphate synthase', 232, NULL, NULL, 149571),
(149572, '1.25.40.10-FF-004073', NULL, 'Uncharacterized protein', 159, NULL, NULL, 149572),
(149573, '1.20.272.50-FF-000001', NULL, 'DNA polymerase clamp loader subunit', 74, NULL, NULL, 149573),
(149574, '3.60.20.40-FF-000026', NULL, 'Gamma-glutamyltransferase 5', 105, NULL, NULL, 149574),
(149575, '3.40.50.2000-FF-000002', NULL, 'Alpha-1,4 glucan phosphorylase', 465, NULL, NULL, 149575),
(149576, '3.40.50.150-FF-000476', NULL, 'Polyamine aminopropyltransferase', 229, NULL, NULL, 149576),
(149577, '3.30.70.3400-FF-000003', NULL, 'Preprotein translocase subunit SecD', 61, NULL, NULL, 149577),
(149578, '2.60.40.10-FF-002589', NULL, 'FI06716p', 102, NULL, NULL, 149578),
(149579, '1.10.490.10-FF-000003', NULL, 'Flavohemoprotein', 145, NULL, NULL, 149579),
(149580, '3.30.70.330-FF-002616', NULL, NULL, 129, NULL, NULL, 149580),
(149581, '3.30.160.60-FF-002185', NULL, 'Histone H4 transcription factor', 24, NULL, NULL, 149581),
(149582, '1.25.40.10-FF-002509', NULL, 'Uncharacterized protein', 87, NULL, NULL, 149582),
(149583, '3.60.20.10-FF-000130', NULL, 'Proteasome subunit beta type 9', 195, NULL, NULL, 149583),
(149584, '3.80.10.10-FF-000555', NULL, 'Leucine-rich repeat family protein', 69, NULL, NULL, 149584);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(149585, '1.10.287.110-FF-000359', NULL, 'Chaperone protein DnaJ 2', 127, NULL, NULL, 149585),
(149586, '3.30.379.10-FF-000013', NULL, 'Beta-hexosaminidase', 164, NULL, NULL, 149586),
(149587, '3.40.140.10-FF-000278', NULL, 'Uncharacterized protein', 66, NULL, NULL, 149587),
(149588, '3.40.30.10-FF-000058', NULL, 'Glutathione S-transferase, omega', 169, NULL, NULL, 149588),
(149589, '1.20.1070.10-FF-001992', NULL, 'Uncharacterized protein', 291, NULL, NULL, 149589),
(149590, '3.30.160.60-FF-003174', NULL, 'Zinc finger protein 490', 60, NULL, NULL, 149590),
(149591, '1.10.510.10-FF-000467', NULL, 'Liguleless narrow1', 204, NULL, NULL, 149591),
(149592, '1.20.1310.10-FF-000128', NULL, NULL, 128, NULL, NULL, 149592),
(149593, '1.20.1640.10-FF-000001', NULL, 'Efflux pump membrane transporter', 208, NULL, NULL, 149593),
(149594, '3.90.1100.10-FF-000038', NULL, 'DNA-directed RNA polymerase subunit beta', 137, NULL, NULL, 149594),
(149595, '3.20.20.70-FF-000014', NULL, 'Probable dual-specificity RNA methyltransferase RlmN', 285, NULL, NULL, 149595),
(149596, '1.10.472.10-FF-000574', NULL, 'Cyclin putative cyclin', 53, NULL, NULL, 149596),
(149597, '1.25.40.10-FF-005062', NULL, 'Uncharacterized protein', 105, NULL, NULL, 149597),
(149598, '3.40.1190.20-FF-000047', NULL, 'Hydroxyethylthiazole kinase', 284, NULL, NULL, 149598),
(149599, '4.10.60.10-FF-000031', NULL, 'splicing factor 1', 54, NULL, NULL, 149599),
(149600, '3.30.1330.30-FF-000154', NULL, 'Eukaryotic peptide chain release factor subunit 1-2', 43, NULL, NULL, 149600),
(149601, '3.30.110.10-FF-000003', NULL, 'Translation initiation factor IF-3', 98, NULL, NULL, 149601),
(149602, '1.25.40.20-FF-001849', NULL, 'Protein CBR-MIB-1', 139, NULL, NULL, 149602),
(149603, '3.30.1010.10-FF-000040', NULL, 'Phosphatidylinositol 3-kinase', 181, NULL, NULL, 149603),
(149604, '3.40.50.1820-FF-001858', NULL, 'Uncharacterized protein', 53, NULL, NULL, 149604),
(149605, '3.40.50.300-FF-003736', NULL, 'MutS homolog 3 (E. coli)', 277, NULL, NULL, 149605),
(149606, '3.90.920.10-FF-000028', NULL, 'DNA polymerase alpha subunit IV, putative', 192, NULL, NULL, 149606),
(149607, '3.30.930.10-FF-000043', NULL, 'Proline--tRNA ligase', 285, NULL, NULL, 149607),
(149608, '3.30.200.20-FF-002368', NULL, 'AGC family protein kinase', 63, NULL, NULL, 149608),
(149609, '3.40.50.300-FF-000982', NULL, 'Inactive ATP-dependent zinc metalloprotease FTSHI 2 like', 193, NULL, NULL, 149609),
(149610, '1.10.287.700-FF-000002', NULL, 'Gamma-synuclein', 126, NULL, NULL, 149610),
(149611, '1.10.565.10-FF-000054', NULL, 'Nuclear Hormone Receptor family', 226, NULL, NULL, 149611),
(149612, '1.20.1070.10-FF-001553', NULL, 'Uncharacterized protein', 173, NULL, NULL, 149612),
(149613, '2.70.170.10-FF-000018', NULL, 'Gamma-aminobutyric acid (GABA-A) receptor, subunit delta', 203, NULL, NULL, 149613),
(149614, '1.25.10.10-FF-001491', NULL, 'C11.1, isoform A', 271, NULL, NULL, 149614),
(149615, '2.60.40.60-FF-000373', NULL, 'Ventral neural cadherin', 117, NULL, NULL, 149615),
(149616, '3.40.30.10-FF-001047', NULL, 'Glutathione S-transferase kappa', 220, NULL, NULL, 149616),
(149617, '1.25.40.10-FF-002948', NULL, 'TPR Domain containing protein', 235, NULL, NULL, 149617),
(149618, '1.10.510.10-FF-004362', NULL, NULL, 110, NULL, NULL, 149618),
(149619, '3.40.50.10240-FF-000005', NULL, 'Thiamine pyrophosphokinase', 187, NULL, NULL, 149619),
(149620, '3.40.50.720-FF-000872', NULL, '3-oxoacyl-ACP reductase, putative', 250, NULL, NULL, 149620),
(149621, '1.10.8.270-FF-000077', NULL, 'Rab GTPase activating protein, putative', 141, NULL, NULL, 149621),
(149622, '1.10.1200.10-FF-000105', NULL, 'HC-toxin synthetase', 72, NULL, NULL, 149622),
(149623, '1.20.144.10-FF-000046', NULL, 'PhosphoLipid Phosphatase Related homolog', 229, NULL, NULL, 149623),
(149624, '3.20.140.10-FF-000029', NULL, 'Nicotinate phosphoribosyltransferase', 145, NULL, NULL, 149624),
(149625, '2.170.270.10-FF-000221', NULL, 'Uncharacterized protein', 108, NULL, NULL, 149625),
(149626, '2.130.10.10-FF-000476', NULL, 'Activating molecule in BECN1-regulated autophagy protein', 181, NULL, NULL, 149626);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(149627, '3.40.50.10420-FF-000054', NULL, 'Chromosome 8, whole genome shotgun sequence', 239, NULL, NULL, 149627),
(149628, '1.20.1270.370-FF-000003', NULL, 'Subunit of oxygen-sensitive 2-hydroxyisocaproyl-CoA dehydratase', 87, NULL, NULL, 149628),
(149629, '3.30.70.330-FF-000851', NULL, 'RNA-binding protein 29', 116, NULL, NULL, 149629),
(149630, '3.40.190.10-FF-000961', NULL, 'Uncharacterized protein', 53, NULL, NULL, 149630),
(149631, '3.30.200.20-FF-000131', NULL, 'Dual specificity protein kinase TTK', 90, NULL, NULL, 149631),
(149632, '1.25.40.180-FF-000257', NULL, NULL, 276, NULL, NULL, 149632),
(149633, '3.40.850.10-FF-000517', NULL, 'Uncharacterized protein', 115, NULL, NULL, 149633),
(149634, '1.10.220.150-FF-000080', NULL, 'Uncharacterized protein', 133, NULL, NULL, 149634),
(149635, '2.80.10.50-FF-000086', NULL, 'Calcium up-regulated protein A', 138, NULL, NULL, 149635),
(149636, '2.60.40.10-FF-003106', NULL, 'Ig-like and fibronectin type-III domain-containing protein 1', 97, NULL, NULL, 149636),
(149637, '1.10.238.10-FF-000867', NULL, 'Uncharacterized protein', 126, NULL, NULL, 149637),
(149638, '3.50.50.60-FF-001462', NULL, 'Uncharacterized protein', 73, NULL, NULL, 149638),
(149639, '2.60.40.10-FF-005023', NULL, NULL, 104, NULL, NULL, 149639),
(149640, '2.30.42.10-FF-000605', NULL, NULL, 125, NULL, NULL, 149640),
(149641, '3.30.40.10-FF-002381', NULL, 'E3 ubiquitin-protein ligase', 69, NULL, NULL, 149641),
(149642, '2.30.29.30-FF-001255', NULL, 'Uncharacterized protein', 106, NULL, NULL, 149642),
(149643, '1.10.287.1490-FF-000116', NULL, 'Uncharacterized protein', 116, NULL, NULL, 149643),
(149644, '2.30.42.10-FF-000285', NULL, 'Caspase recruitment domain family, member 11', 103, NULL, NULL, 149644),
(149645, '2.10.25.10-FF-001174', NULL, 'NIDogen (Basement membrane protein)', 50, NULL, NULL, 149645),
(149646, '3.20.20.80-FF-000343', NULL, 'Protein CBG22612', 33, NULL, NULL, 149646),
(149647, '3.30.2020.30-FF-000018', NULL, 'ADR024Wp', 102, NULL, NULL, 149647),
(149648, '3.40.50.300-FF-003383', NULL, 'UMP-CMP kinase, putative', 173, NULL, NULL, 149648),
(149649, '1.20.1280.50-FF-000182', NULL, 'Fbox domain-containing protein', 38, NULL, NULL, 149649),
(149650, '1.10.3720.10-FF-000128', NULL, 'Molybdenum transport system permease', 246, NULL, NULL, 149650),
(149651, '3.40.50.300-FF-002747', NULL, 'Hypothetical_protein_-_conserved', 243, NULL, NULL, 149651),
(149652, '3.75.10.10-FF-000045', NULL, NULL, 295, NULL, NULL, 149652),
(149653, '2.40.400.10-FF-000004', NULL, 'Acetoacetate decarboxylase', 232, NULL, NULL, 149653),
(149654, '1.25.40.20-FF-000540', NULL, 'GD22794', 111, NULL, NULL, 149654),
(149655, '2.30.29.30-FF-000619', NULL, 'Phosphatidylinositol-3-phosphatase myotubularin-2', 99, NULL, NULL, 149655),
(149656, '1.20.1070.10-FF-000564', NULL, 'GD11847', 377, NULL, NULL, 149656),
(149657, '2.30.230.10-FF-000049', NULL, 'Vitellogenin, putative', 252, NULL, NULL, 149657),
(149658, '3.20.20.70-FF-000806', NULL, NULL, 115, NULL, NULL, 149658),
(149659, '3.40.970.20-FF-000001', NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit beta', 90, NULL, NULL, 149659),
(149660, '1.10.10.1620-FF-000002', NULL, 'Putative bifunctional amine oxidase DDB_G0291301', 48, NULL, NULL, 149660),
(149661, '3.40.50.10810-FF-000081', NULL, 'DNA repair protein, putative', 114, NULL, NULL, 149661),
(149662, '3.30.420.100-FF-000025', NULL, 'Uncharacterized protein', 61, NULL, NULL, 149662),
(149663, '1.20.1480.30-FF-000005', NULL, 'Uncharacterized protein', 98, NULL, NULL, 149663),
(149664, '2.60.220.50-FF-000060', NULL, 'Adhesion G protein-coupled receptor G1', 148, NULL, NULL, 149664),
(149665, '3.80.10.10-FF-001983', NULL, 'Leucine-rich repeat protein lrrA', 98, NULL, NULL, 149665),
(149666, '1.25.40.10-FF-003937', NULL, 'Uncharacterized protein', 278, NULL, NULL, 149666),
(149667, '1.20.58.60-FF-000619', NULL, 'Uncharacterized protein', 115, NULL, NULL, 149667),
(149668, '4.10.1000.10-FF-000009', NULL, 'probable helicase with zinc finger domain', 30, NULL, NULL, 149668),
(149669, '3.20.20.100-FF-000067', NULL, 'Related to GCY1-galactose-induced protein of aldo/keto reductase family / uncharacterized protein', 301, NULL, NULL, 149669);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(149670, '1.20.1050.10-FF-000029', NULL, 'Glutathione S-transferase DHAR3, chloroplastic', 123, NULL, NULL, 149670),
(149671, '1.10.10.60-FF-000465', NULL, 'Sequence-specific DNA binding transcription factor', 71, NULL, NULL, 149671),
(149672, '2.60.40.10-FF-002909', NULL, 'Basigin', 93, NULL, NULL, 149672),
(149673, '2.130.10.10-FF-001432', NULL, 'SVP1-like protein 2, variant', 293, NULL, NULL, 149673),
(149674, '2.30.30.40-FF-000373', NULL, 'Putative purine-binding chemotaxis protein Chew', 58, NULL, NULL, 149674),
(149675, '1.10.8.60-FF-000245', NULL, 'Sigma-54 dependent response regulator', 64, NULL, NULL, 149675),
(149676, '1.10.1580.10-FF-000009', NULL, 'Mitochondrial GTPase 1', 88, NULL, NULL, 149676),
(149677, '2.60.40.150-FF-000316', NULL, 'Protein CBG05923', 146, NULL, NULL, 149677),
(149678, '1.10.3380.10-FF-000028', NULL, 'DnaJ domain containing protein', 139, NULL, NULL, 149678),
(149679, '1.10.10.1940-FF-000008', NULL, 'Metalloendopeptidase', 43, NULL, NULL, 149679),
(149680, '3.30.450.60-FF-000015', NULL, 'Signal recognition particle receptor subunit alpha', 124, NULL, NULL, 149680),
(149681, '3.30.160.60-FF-005591', NULL, NULL, 31, NULL, NULL, 149681),
(149682, '1.10.238.10-FF-001323', NULL, 'Uncharacterized protein', 96, NULL, NULL, 149682),
(149683, '2.30.130.40-FF-000028', NULL, 'Lon protease homolog', 153, NULL, NULL, 149683),
(149684, '3.40.390.10-FF-000150', NULL, NULL, 135, NULL, NULL, 149684),
(149685, '1.20.1720.10-FF-000002', NULL, 'Multidrug resistance protein B', 206, NULL, NULL, 149685),
(149686, '3.40.50.1820-FF-000077', NULL, 'Abhydrolase domain containing 14B', 211, NULL, NULL, 149686),
(149687, '3.80.10.10-FF-002972', NULL, 'Uncharacterized protein', 103, NULL, NULL, 149687),
(149688, '3.30.465.10-FF-000074', NULL, 'D-lactate dehydrogenase [cytochrome] mitochondrial', 153, NULL, NULL, 149688),
(149689, '3.50.30.30-FF-000103', NULL, 'Peptidase S8 and S53 subtilisin kexin sedolisin', 115, NULL, NULL, 149689),
(149690, '4.10.1060.10-FF-000018', NULL, 'E3 SUMO-protein ligase RanBP2', 39, NULL, NULL, 149690),
(149691, '2.60.200.20-FF-000162', NULL, 'Uncharacterized protein', 112, NULL, NULL, 149691),
(149692, '3.40.50.720-FF-001861', NULL, 'Peroxisomal trans-2-enoyl-CoA reductase', 224, NULL, NULL, 149692),
(149693, '2.30.30.140-FF-000138', NULL, 'Chromosome 1, whole genome shotgun sequence', 81, NULL, NULL, 149693),
(149694, '3.40.50.10190-FF-000294', NULL, 'Pol lambda-related class X DNA repair polymerase', 116, NULL, NULL, 149694),
(149695, '1.25.40.10-FF-004926', NULL, 'Uncharacterized protein', 58, NULL, NULL, 149695),
(149696, '3.80.10.10-FF-003461', NULL, 'Uncharacterized protein', 232, NULL, NULL, 149696),
(149697, '1.20.960.30-FF-000009', NULL, 'WD40 repeat-containing protein HOS15', 96, NULL, NULL, 149697),
(149698, '3.40.50.1000-FF-000011', NULL, 'Calcium-transporting ATPase', 153, NULL, NULL, 149698),
(149699, '2.60.120.10-FF-000624', NULL, 'Uncharacterized protein', 47, NULL, NULL, 149699),
(149700, '2.60.120.260-FF-000307', NULL, 'Netrin precursor', 280, NULL, NULL, 149700),
(149701, '1.25.10.10-FF-000563', NULL, 'Vacuolar import and degradation protein', 341, NULL, NULL, 149701),
(149702, '1.25.40.10-FF-001700', NULL, 'putative pentatricopeptide repeat-containing protein At5g08490 isoform X1', 230, NULL, NULL, 149702),
(149703, '2.40.128.90-FF-000001', NULL, 'Outer membrane protease', 297, NULL, NULL, 149703),
(149704, '1.25.40.10-FF-004426', NULL, 'Uncharacterized protein', 126, NULL, NULL, 149704),
(149705, '2.130.10.10-FF-002893', NULL, 'Uncharacterized protein', 152, NULL, NULL, 149705),
(149706, '3.30.40.10-FF-000817', NULL, 'Blast:Histone-lysine N-methyltransferase 2C', 53, NULL, NULL, 149706),
(149707, '3.40.50.2020-FF-000160', NULL, 'Uncharacterized protein', 77, NULL, NULL, 149707),
(149708, '3.90.20.20-FF-000036', NULL, 'Protein GrpE', 122, NULL, NULL, 149708),
(149709, '3.90.480.10-FF-000011', NULL, 'Sulfite reductase, putative', 88, NULL, NULL, 149709),
(149710, '3.80.10.10-FF-002472', NULL, 'RabGAP/TBC domain-containing protein', 142, NULL, NULL, 149710);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(149711, '3.40.50.300-FF-004372', NULL, 'ABC transporter ATP-binding protein', 217, NULL, NULL, 149711),
(149712, '2.20.90.10-FF-000003', NULL, 'Uncharacterized protein', 169, NULL, NULL, 149712),
(149713, '3.90.1150.10-FF-000249', NULL, 'Ornithine aminotransferase, putative', 136, NULL, NULL, 149713),
(149714, '2.40.70.10-FF-000310', NULL, NULL, 181, NULL, NULL, 149714),
(149715, '3.40.50.300-FF-007098', NULL, 'Dephospho-CoA kinase', 188, NULL, NULL, 149715),
(149716, '3.30.565.10-FF-000171', NULL, 'Two-component sensor histidine kinase', 150, NULL, NULL, 149716),
(149717, '1.10.8.430-FF-000001', NULL, 'Apoptotic protease-activating factor 1', 91, NULL, NULL, 149717),
(149718, '3.40.50.1260-FF-000010', NULL, 'Phosphoglycerate kinase', 67, NULL, NULL, 149718),
(149719, '1.20.58.70-FF-000095', NULL, 'Syntaxin-22', 43, NULL, NULL, 149719),
(149720, '2.120.10.30-FF-000623', NULL, 'Uncharacterized protein', 159, NULL, NULL, 149720),
(149721, '3.30.1380.20-FF-000036', NULL, 'Uncharacterized protein', 134, NULL, NULL, 149721),
(149722, '1.10.510.10-FF-001456', NULL, 'Protein kinase domain-containing protein', 243, NULL, NULL, 149722),
(149723, '3.40.570.10-FF-000035', NULL, 'Uncharacterized protein', 193, NULL, NULL, 149723),
(149724, '2.40.170.20-FF-000062', NULL, 'TonB dependent receptor', 565, NULL, NULL, 149724),
(149725, '3.30.420.40-FF-000653', NULL, 'Actin-related protein 4', 69, NULL, NULL, 149725),
(149726, '3.55.40.10-FF-000003', NULL, 'General secretion pathway protein H', 162, NULL, NULL, 149726),
(149727, '1.20.1250.20-FF-001767', NULL, 'Uncharacterized protein', 422, NULL, NULL, 149727),
(149728, '3.40.50.1110-FF-000044', NULL, 'Blast:Phospholipase B1, membrane-associated', 240, NULL, NULL, 149728),
(149729, '1.25.40.10-FF-002156', NULL, 'Putative pentatricopeptide repeat-containing protein At1g56570', 107, NULL, NULL, 149729),
(149730, '3.40.50.300-FF-002808', NULL, 'Selenocysteine-specific elongation factor selB', 144, NULL, NULL, 149730),
(149731, '3.40.50.300-FF-006642', NULL, 'Uncharacterized protein', 89, NULL, NULL, 149731),
(149732, '3.30.160.60-FF-004955', NULL, NULL, 52, NULL, NULL, 149732),
(149733, '2.60.40.10-FF-004034', NULL, NULL, 97, NULL, NULL, 149733),
(149734, '3.40.50.720-FF-000400', NULL, 'UDP-glucose 6-dehydrogenase', 197, NULL, NULL, 149734),
(149735, '3.10.170.20-FF-000031', NULL, NULL, 80, NULL, NULL, 149735),
(149736, '2.120.10.80-FF-000385', NULL, 'Uncharacterized protein', 232, NULL, NULL, 149736),
(149737, '3.90.1150.10-FF-000188', NULL, 'Dubious cystathionine gamma-lyase', 125, NULL, NULL, 149737),
(149738, '3.80.10.10-FF-003309', NULL, 'Uncharacterized protein', 201, NULL, NULL, 149738),
(149739, '3.40.50.300-FF-000510', NULL, 'ADP-ribosylation factor 1', 176, NULL, NULL, 149739),
(149740, '1.10.472.10-FF-000102', NULL, 'cyclin-C isoform X1', 13, NULL, NULL, 149740),
(149741, '3.40.50.150-FF-000004', NULL, 'AdoMet-dependent rRNA methyltransferase SPB1', 187, NULL, NULL, 149741),
(149742, '1.25.40.20-FF-000068', NULL, 'ankyrin repeat domain-containing protein 17 isoform X5', 189, NULL, NULL, 149742),
(149743, '1.10.20.10-FF-000029', NULL, 'son of sevenless homolog 1 isoform X1', 155, NULL, NULL, 149743),
(149744, '3.20.20.100-FF-000128', NULL, 'NADP(+) coupled glycerol dehydrogenase (Eurofung)', 58, NULL, NULL, 149744),
(149745, '2.130.10.10-FF-004219', NULL, 'Mediator of RNA polymerase II transcription subunit 16', 150, NULL, NULL, 149745),
(149746, '3.30.710.10-FF-000032', NULL, 'hypermethylated in cancer 2 protein-like', 128, NULL, NULL, 149746),
(149747, '2.20.25.10-FF-000077', NULL, 'DNA-directed RNA polymerase subunit', 53, NULL, NULL, 149747),
(149748, '3.30.200.20-FF-001120', NULL, 'Putative DUF26-domain receptor-like protein kinase family protein', 79, NULL, NULL, 149748),
(149749, '3.80.10.10-FF-004237', NULL, 'Uncharacterized protein', 77, NULL, NULL, 149749),
(149750, '3.30.2350.20-FF-000034', NULL, 'Uncharacterized protein', 160, NULL, NULL, 149750),
(149751, '1.20.1530.20-FF-000029', NULL, 'K(+) efflux antiporter 6', 384, NULL, NULL, 149751);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(149752, '2.60.120.200-FF-000043', NULL, 'Neuropilin', 193, NULL, NULL, 149752),
(149753, '3.40.1360.10-FF-000018', NULL, 'Type II DNA topoisomerase VI subunit A', 222, NULL, NULL, 149753),
(149754, '2.60.40.2070-FF-000002', NULL, 'Fimbrial outer membrane usher protein', 77, NULL, NULL, 149754),
(149755, '3.30.890.10-FF-000016', NULL, 'Methyl-CpG-binding domain protein 2-like Protein', 49, NULL, NULL, 149755),
(149756, '1.20.1250.20-FF-001828', NULL, 'Solute carrier family 16 member 4', 151, NULL, NULL, 149756),
(149757, '3.10.450.50-FF-000056', NULL, 'WGS project CABT00000000 data, contig 2.12', 195, NULL, NULL, 149757),
(149758, '2.40.50.140-FF-001202', NULL, NULL, 93, NULL, NULL, 149758),
(149759, '1.10.533.10-FF-000183', NULL, 'Predicted protein', 100, NULL, NULL, 149759),
(149760, '3.40.50.880-FF-000195', NULL, 'Predicted protein', 205, NULL, NULL, 149760),
(149761, '1.10.287.1490-FF-000088', NULL, 'Uso1p', 174, NULL, NULL, 149761),
(149762, '2.60.120.780-FF-000020', NULL, 'Chromosome 10, whole genome shotgun sequence', 155, NULL, NULL, 149762),
(149763, '3.40.1800.20-FF-000011', NULL, 'transcription factor Sp2', 76, NULL, NULL, 149763),
(149764, '3.30.70.1450-FF-000042', NULL, 'SLC13 family permease', 77, NULL, NULL, 149764),
(149765, '3.30.1010.10-FF-000101', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', 166, NULL, NULL, 149765),
(149766, '1.20.20.10-FF-000035', NULL, 'Uncharacterized protein', 68, NULL, NULL, 149766),
(149767, '3.10.290.20-FF-000006', NULL, 'NEDD8-activating enzyme E1 catalytic subunit', 83, NULL, NULL, 149767),
(149768, '3.40.50.2300-FF-000002', NULL, 'DNA-binding response regulator PhoP', 81, NULL, NULL, 149768),
(149769, '3.90.930.12-FF-000020', NULL, NULL, 80, NULL, NULL, 149769),
(149770, '3.90.79.10-FF-000090', NULL, 'Hydrolase, NUDIX family protein', 143, NULL, NULL, 149770),
(149771, '3.30.160.60-FF-001257', NULL, 'Zinc finger and BTB domain-containing 48', 30, NULL, NULL, 149771),
(149772, '2.70.150.10-FF-000135', NULL, 'Calcium-transporting ATPase', 147, NULL, NULL, 149772),
(149773, '1.10.530.10-FF-000058', NULL, 'Lysozyme g', 150, NULL, NULL, 149773),
(149774, '1.10.150.910-FF-000015', NULL, 'DNA damage-binding protein 1', 90, NULL, NULL, 149774),
(149775, '1.25.10.10-FF-001811', NULL, 'AaceriADR331Cp', 297, NULL, NULL, 149775),
(149776, '1.25.40.20-FF-001349', NULL, 'Aberrant large forked product', 107, NULL, NULL, 149776),
(149777, '2.30.29.70-FF-000019', NULL, 'Predicted protein', 109, NULL, NULL, 149777),
(149778, '1.10.506.10-FF-000069', NULL, 'Uncharacterized protein', 147, NULL, NULL, 149778),
(149779, '3.30.390.10-FF-000023', NULL, 'L-Ala-D/L-Glu epimerase', 115, NULL, NULL, 149779),
(149780, '2.60.40.10-FF-005995', NULL, NULL, 83, NULL, NULL, 149780),
(149781, '1.20.200.10-FF-000020', NULL, 'Os03g0824900 protein', 32, NULL, NULL, 149781),
(149782, '3.90.1200.10-FF-000041', NULL, 'Homoserine kinase', 205, NULL, NULL, 149782),
(149783, '1.10.510.10-FF-003401', NULL, NULL, 303, NULL, NULL, 149783),
(149784, '1.10.260.40-FF-000029', NULL, 'XRE family transcriptional regulator', 74, NULL, NULL, 149784),
(149785, '2.60.120.820-FF-000021', NULL, 'Uncharacterized protein', 104, NULL, NULL, 149785),
(149786, '3.40.50.80-FF-000209', NULL, 'Uncharacterized protein', 121, NULL, NULL, 149786),
(149787, '2.70.160.11-FF-000030', NULL, 'Arginine N-methyltransferase, type I', 186, NULL, NULL, 149787),
(149788, '3.30.470.10-FF-000024', NULL, 'Branched-chain-amino-acid aminotransferase', 119, NULL, NULL, 149788),
(149789, '3.30.930.10-FF-000104', NULL, 'histidine--tRNA ligase, cytoplasmic isoform X6', 44, NULL, NULL, 149789),
(149790, '1.10.510.10-FF-002384', NULL, NULL, 98, NULL, NULL, 149790),
(149791, '2.60.40.10-FF-004534', NULL, NULL, 93, NULL, NULL, 149791),
(149792, '4.10.410.10-FF-000111', NULL, 'Boophilin, putative', 66, NULL, NULL, 149792),
(149793, '2.130.10.10-FF-005147', NULL, 'Vacuolar protein sorting-associated protein 11 homolog', 123, NULL, NULL, 149793),
(149794, '1.10.20.140-FF-000010', NULL, 'tRNA dimethylallyltransferase', 68, NULL, NULL, 149794);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(149795, '3.90.190.10-FF-000556', NULL, 'Chromosome 10, whole genome shotgun sequence', 101, NULL, NULL, 149795),
(149796, '2.130.10.10-FF-002713', NULL, 'Uncharacterized protein', 313, NULL, NULL, 149796),
(149797, '3.30.70.270-FF-000159', NULL, 'Putative diguanylate cyclase YcdT', 165, NULL, NULL, 149797),
(149798, '2.40.30.20-FF-000013', NULL, 'ATP synthase subunit alpha', 100, NULL, NULL, 149798),
(149799, '3.40.1440.10-FF-000019', NULL, NULL, 105, NULL, NULL, 149799),
(149800, '2.130.10.10-FF-002421', NULL, 'THO complex subunit 3', 82, NULL, NULL, 149800),
(149801, '2.30.110.10-FF-000102', NULL, 'Putative flavin reductase', 157, NULL, NULL, 149801),
(149802, '3.65.10.10-FF-000006', NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', 201, NULL, NULL, 149802),
(149803, '1.25.40.10-FF-002009', NULL, 'Pre-mRNA-processing factor 6-like Protein', 95, NULL, NULL, 149803),
(149804, '2.120.10.80-FF-000205', NULL, 'Uncharacterized protein', 224, NULL, NULL, 149804),
(149805, '1.10.150.50-FF-000237', NULL, 'Kinesin-related protein 6', 67, NULL, NULL, 149805),
(149806, '2.60.120.920-FF-000197', NULL, 'Uncharacterized protein', 192, NULL, NULL, 149806),
(149807, '1.25.10.70-FF-000002', NULL, 'Nucleoporin (Nup184), putative', 306, NULL, NULL, 149807),
(149808, '3.80.10.10-FF-000055', NULL, 'Protein phosphatase 1 regulatory subunit 7', 129, NULL, NULL, 149808),
(149809, '2.40.320.10-FF-000003', NULL, 'Uncharacterized protein, isoform C', 164, NULL, NULL, 149809),
(149810, '2.60.40.1510-FF-000008', NULL, 'Integrin beta', 119, NULL, NULL, 149810),
(149811, '1.10.472.10-FF-000602', NULL, 'Uncharacterized protein', 17, NULL, NULL, 149811),
(149812, '3.40.50.300-FF-008407', NULL, 'DNA helicase', 166, NULL, NULL, 149812),
(149813, '2.60.40.10-FF-004826', NULL, NULL, 123, NULL, NULL, 149813),
(149814, '3.50.30.30-FF-000075', NULL, 'RNF13 isoform 14', 91, NULL, NULL, 149814),
(149815, '3.30.365.10-FF-000010', NULL, 'Selenate reductase, molybdenum-binding subunit', 217, NULL, NULL, 149815),
(149816, '1.10.10.10-FF-000411', NULL, 'Ecdysone-induced protein 74EF isoform A', 127, NULL, NULL, 149816),
(149817, '2.160.20.10-FF-000318', NULL, 'F-box containing protein, putative', 171, NULL, NULL, 149817),
(149818, '1.10.510.10-FF-003873', NULL, NULL, 93, NULL, NULL, 149818),
(149819, '3.50.50.60-FF-000034', NULL, 'sulfide:quinone oxidoreductase, mitochondrial', 140, NULL, NULL, 149819),
(149820, '1.25.40.10-FF-000391', NULL, 'Tetratricopeptide repeat domain 12', 145, NULL, NULL, 149820),
(149821, '3.10.110.10-FF-000165', NULL, 'ubiquitin-conjugating enzyme E2 A isoform X2', 119, NULL, NULL, 149821),
(149822, '3.30.1370.100-FF-000022', NULL, 'MutL homolog 3 (E. coli)', 112, NULL, NULL, 149822),
(149823, '1.25.40.20-FF-001057', NULL, 'Calcium transporter 2', 71, NULL, NULL, 149823),
(149824, '1.20.1050.130-FF-000034', NULL, 'Probable glutamate--tRNA ligase, cytoplasmic', 166, NULL, NULL, 149824),
(149825, '1.10.287.10-FF-000054', NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase', 44, NULL, NULL, 149825),
(149826, '1.20.1740.10-FF-000065', NULL, 'Amino acid permease', 457, NULL, NULL, 149826),
(149827, '3.30.300.20-FF-000015', NULL, 'Ribosome-binding factor A', 110, NULL, NULL, 149827),
(149828, '3.10.580.10-FF-000076', NULL, 'Chloride channel protein', 177, NULL, NULL, 149828),
(149829, '1.10.530.10-FF-000030', NULL, 'Chitinase C', 148, NULL, NULL, 149829),
(149830, '2.60.120.200-FF-000335', NULL, 'Protein crumbs', 176, NULL, NULL, 149830),
(149831, '3.60.15.10-FF-000241', NULL, 'Uncharacterized protein', 85, NULL, NULL, 149831),
(149832, '1.10.10.10-FF-000383', NULL, 'Histone H1', 87, NULL, NULL, 149832),
(149833, '3.80.10.10-FF-002000', NULL, 'Nyctalopin', 168, NULL, NULL, 149833),
(149834, '3.40.50.300-FF-001819', NULL, 'Uncharacterized protein', 184, NULL, NULL, 149834),
(149835, '3.10.100.10-FF-000080', NULL, 'Killer cell lectin-like receptor subfamily F member 1', 125, NULL, NULL, 149835),
(149836, '1.25.40.10-FF-004573', NULL, 'Bardet-Biedl syndrome 4 protein homolog', 189, NULL, NULL, 149836);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(149837, '3.40.30.10-FF-000530', NULL, 'Peroxiredoxin family protein', 169, NULL, NULL, 149837),
(149838, '3.40.50.10540-FF-000005', NULL, 'succinate--hydroxymethylglutarate CoA-transferase isoform X1', 310, NULL, NULL, 149838),
(149839, '3.30.160.60-FF-002538', NULL, 'Mot3p', 58, NULL, NULL, 149839),
(149840, '3.20.20.140-FF-000472', NULL, 'Uncharacterized protein', 199, NULL, NULL, 149840),
(149841, '3.40.1280.10-FF-000017', NULL, 'rRNA methyltransferase 3, mitochondrial', 172, NULL, NULL, 149841),
(149842, '3.50.50.60-FF-000473', NULL, 'tRNA 5-methylaminomethyl-2-thiouridine biosynthesis bifunctional protein MnmC', 244, NULL, NULL, 149842),
(149843, '3.30.40.10-FF-001806', NULL, 'Sister chromatid cohesion protein', 104, NULL, NULL, 149843),
(149844, '3.20.20.70-FF-000514', NULL, 'Dihydroorotate dehydrogenase 2', 295, NULL, NULL, 149844),
(149845, '3.30.160.60-FF-003202', NULL, 'Zinc finger protein 217', 26, NULL, NULL, 149845),
(149846, '3.40.710.10-FF-000007', NULL, 'D-alanyl-D-alanine endopeptidase', 293, NULL, NULL, 149846),
(149847, '2.10.25.10-FF-001527', NULL, 'Delta-like protein', 46, NULL, NULL, 149847),
(149848, '2.60.120.430-FF-000027', NULL, 'Chondroitin sulfate ABC lyase', 164, NULL, NULL, 149848),
(149849, '3.30.230.70-FF-000041', NULL, 'WGS project CABT00000000 data, contig 2.3', 295, NULL, NULL, 149849),
(149850, '3.30.160.60-FF-000740', NULL, 'zinc finger protein 133 isoform X1', 26, NULL, NULL, 149850),
(149851, '3.30.70.330-FF-002296', NULL, NULL, 196, NULL, NULL, 149851),
(149852, '3.30.70.560-FF-000010', NULL, 'Folic acid synthesis protein fol1', 197, NULL, NULL, 149852),
(149853, '1.25.10.10-FF-002328', NULL, 'Uncharacterized protein', 301, NULL, NULL, 149853),
(149854, '2.130.10.10-FF-004658', NULL, 'Uncharacterized protein', 188, NULL, NULL, 149854),
(149855, '3.40.50.410-FF-000190', NULL, 'Circularly permutated Ras protein 1', 206, NULL, NULL, 149855),
(149856, '1.20.1070.10-FF-000272', NULL, 'G protein-coupled receptor 146', 295, NULL, NULL, 149856),
(149857, '3.40.710.10-FF-000187', NULL, 'Uncharacterized protein', 169, NULL, NULL, 149857),
(149858, '2.30.42.10-FF-000313', NULL, 'MAGI (Membrane Associated Guanylate kinase Inverted) homolog', 100, NULL, NULL, 149858),
(149859, '3.30.1370.10-FF-000061', NULL, 'High density lipoprotein binding protein', 60, NULL, NULL, 149859),
(149860, '3.40.309.10-FF-000041', NULL, 'Aldehyde dehydrogenase', 201, NULL, NULL, 149860),
(149861, '2.60.40.10-FF-000791', NULL, 'Two-component system sensor histidine kinase/response regulator', 130, NULL, NULL, 149861),
(149862, '1.10.132.20-FF-000001', NULL, 'Ribosome-recycling factor', 97, NULL, NULL, 149862),
(149863, '2.40.30.10-FF-000217', NULL, 'NADPH oxidase 1', 92, NULL, NULL, 149863),
(149864, '3.40.50.300-FF-002455', NULL, 'F-box DNA helicase 1', 176, NULL, NULL, 149864),
(149865, '1.10.1080.10-FF-000016', NULL, 'Glutathione synthetase', 87, NULL, NULL, 149865),
(149866, '3.40.50.620-FF-000016', NULL, 'Putative choline-phosphate cytidylyltransferase B', 234, NULL, NULL, 149866),
(149867, '3.40.47.10-FF-000153', NULL, NULL, 206, NULL, NULL, 149867),
(149868, '3.30.200.20-FF-000923', NULL, 'Uncharacterized protein', 88, NULL, NULL, 149868),
(149869, '2.10.109.10-FF-000047', NULL, 'Peptidase S26B, signal peptidase', 106, NULL, NULL, 149869),
(149870, '2.10.90.10-FF-000144', NULL, 'Uncharacterized protein', 108, NULL, NULL, 149870),
(149871, '1.20.58.180-FF-000002', NULL, 'Glycine--tRNA ligase, chloroplastic/mitochondrial 2', 80, NULL, NULL, 149871),
(149872, '2.60.40.60-FF-000726', NULL, 'Cadherin-4', 97, NULL, NULL, 149872),
(149873, '2.60.210.10-FF-000070', NULL, NULL, 125, NULL, NULL, 149873),
(149874, '1.10.472.10-FF-000074', NULL, 'D3-type cyclin', 108, NULL, NULL, 149874),
(149875, '1.20.1270.60-FF-000274', NULL, 'Uncharacterized protein', 66, NULL, NULL, 149875),
(149876, '2.40.50.100-FF-000049', NULL, 'Auxiliary transport protein, membrane fusion protein family', 35, NULL, NULL, 149876),
(149877, '3.40.50.1220-FF-000105', NULL, 'Putative indolepyruvate decarboxylase, isozyme 1', 163, NULL, NULL, 149877);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(149878, '1.20.5.190-FF-000123', NULL, NULL, 45, NULL, NULL, 149878),
(149879, '1.20.140.100-FF-000055', NULL, 'Uncharacterized protein', 154, NULL, NULL, 149879),
(149880, '2.10.250.10-FF-000010', NULL, 'Uncharacterized protein', 46, NULL, NULL, 149880),
(149881, '3.40.50.300-FF-007126', NULL, 'Uncharacterized protein', 183, NULL, NULL, 149881),
(149882, '2.60.40.60-FF-000873', NULL, 'Uncharacterized protein', 122, NULL, NULL, 149882),
(149883, '3.40.50.1820-FF-000369', NULL, 'LD47264p', 355, NULL, NULL, 149883),
(149884, '3.30.565.10-FF-000463', NULL, 'Two component signal transduction system controlling the osmosenstive K+ channel histidine kinase KdpD', 146, NULL, NULL, 149884),
(149885, '3.90.980.10-FF-000004', NULL, 'DNA primase', 126, NULL, NULL, 149885),
(149886, '2.60.40.640-FF-000047', NULL, 'pH-response regulator protein palF/RIM8', 171, NULL, NULL, 149886),
(149887, '1.10.287.660-FF-000029', NULL, 'Predicted protein', 77, NULL, NULL, 149887),
(149888, '1.10.10.60-FF-000757', NULL, 'Hybrid sensor histidine kinase/response regulator', 57, NULL, NULL, 149888),
(149889, '2.60.40.10-FF-000644', NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein', 92, NULL, NULL, 149889),
(149890, '1.10.245.10-FF-000007', NULL, 'SWIB complex BAF60b domain-containing protein', 86, NULL, NULL, 149890),
(149891, '3.80.10.10-FF-001544', NULL, 'Leucine-rich repeat-containing protein 29', 126, NULL, NULL, 149891),
(149892, '3.30.70.330-FF-002116', NULL, NULL, 112, NULL, NULL, 149892),
(149893, '3.30.160.60-FF-005411', NULL, NULL, 43, NULL, NULL, 149893),
(149894, '1.25.40.120-FF-000054', NULL, 'RAB geranylgeranyl transferase', 412, NULL, NULL, 149894),
(149895, '3.30.70.141-FF-000037', NULL, NULL, 191, NULL, NULL, 149895),
(149896, '2.60.260.20-FF-000019', NULL, 'DnaJ subfamily A member', 79, NULL, NULL, 149896),
(149897, '3.40.630.10-FF-000186', NULL, 'Protein CBG15123', 295, NULL, NULL, 149897),
(149898, '1.10.510.10-FF-001748', NULL, 'Predicted protein', 103, NULL, NULL, 149898),
(149899, '1.20.58.390-FF-000239', NULL, 'Uncharacterized protein', 129, NULL, NULL, 149899),
(149900, '2.40.30.10-FF-000364', NULL, 'NADPH-dependent diflavin oxidoreductase 1', 70, NULL, NULL, 149900),
(149901, '3.30.70.580-FF-000049', NULL, 'tRNA pseudouridine synthase', 108, NULL, NULL, 149901),
(149902, '2.40.50.140-FF-000713', NULL, NULL, 95, NULL, NULL, 149902),
(149903, '2.30.29.30-FF-000266', NULL, 'Capping protein, Arp2/3 and myosin-I linker protein 3', 112, NULL, NULL, 149903),
(149904, '3.40.50.720-FF-001209', NULL, '3-oxoacyl-[acyl-carrier-protein] reductase', 247, NULL, NULL, 149904),
(149905, '2.40.70.10-FF-000282', NULL, 'Secretory aspartyl protease, putative', 180, NULL, NULL, 149905),
(149906, '3.30.160.60-FF-004663', NULL, NULL, 73, NULL, NULL, 149906),
(149907, '3.30.470.20-FF-000206', NULL, 'Uncharacterized protein', 231, NULL, NULL, 149907),
(149908, '3.30.70.20-FF-000002', NULL, 'NADH-ubiquinone oxidoreductase 75 kDa subunit', 78, NULL, NULL, 149908),
(149909, '3.90.190.10-FF-000264', NULL, 'Protein tyrosine phosphatase type IVA, member 3', 71, NULL, NULL, 149909),
(149910, '2.60.40.10-FF-005462', NULL, NULL, 129, NULL, NULL, 149910),
(149911, '1.20.1250.20-FF-000339', NULL, 'MFS transporter', 191, NULL, NULL, 149911),
(149912, '1.20.120.1760-FF-000027', NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', 190, NULL, NULL, 149912),
(149913, '3.30.160.60-FF-002977', NULL, 'AGAP009066-PA-like protein', 73, NULL, NULL, 149913),
(149914, '3.30.60.90-FF-000005', NULL, 'Putative E3 ubiquitin-protein ligase mib1', 53, NULL, NULL, 149914),
(149915, '2.60.40.150-FF-000288', NULL, 'Copine-8', 126, NULL, NULL, 149915),
(149916, '1.25.40.10-FF-000239', NULL, 'Transmembrane and TPR repeat-containing protein 3', 170, NULL, NULL, 149916),
(149917, '2.20.70.10-FF-000092', NULL, 'WW domain-binding protein 4', 44, NULL, NULL, 149917),
(149918, '1.20.5.430-FF-000004', NULL, 'heat shock factor-binding protein 1-like protein 1', 43, NULL, NULL, 149918),
(149919, '3.30.200.20-FF-001412', NULL, 'Kinase, NEK', 86, NULL, NULL, 149919);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(149920, '2.60.260.20-FF-000171', NULL, 'Predicted protein', 79, NULL, NULL, 149920),
(149921, '1.25.40.10-FF-000211', NULL, 'tetratricopeptide repeat protein 30B', 340, NULL, NULL, 149921),
(149922, '2.40.180.10-FF-000031', NULL, 'Uncharacterized protein', 333, NULL, NULL, 149922),
(149923, '3.30.70.1230-FF-000240', NULL, 'Uncharacterized protein', 123, NULL, NULL, 149923),
(149924, '2.10.70.10-FF-000261', NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', 58, NULL, NULL, 149924),
(149925, '1.10.287.130-FF-000106', NULL, 'Hybrid sensor histidine kinase/response regulator', 78, NULL, NULL, 149925),
(149926, '3.40.50.1000-FF-000483', NULL, 'Uncharacterized protein', 173, NULL, NULL, 149926),
(149927, '1.10.418.60-FF-000014', NULL, 'Probable kinetochore protein NUF2', 166, NULL, NULL, 149927),
(149928, '2.10.25.10-FF-001674', NULL, 'Uncharacterized protein', 44, NULL, NULL, 149928),
(149929, '1.20.120.1200-FF-000028', NULL, 'ATP synthase subunit a', 81, NULL, NULL, 149929),
(149930, '3.40.50.300-FF-008587', NULL, 'Uncharacterized protein', 175, NULL, NULL, 149930),
(149931, '2.70.170.10-FF-000170', NULL, 'Uncharacterized protein', 78, NULL, NULL, 149931),
(149932, '1.25.10.10-FF-001991', NULL, 'Exportin 5', 288, NULL, NULL, 149932),
(149933, '2.60.40.10-FF-001280', NULL, 'V-set and immunoglobulin domain containing 2 (Predicted)', 121, NULL, NULL, 149933),
(149934, '3.40.50.2000-FF-000474', NULL, 'UDP-glucuronosyltransferase', 172, NULL, NULL, 149934),
(149935, '3.80.10.10-FF-002180', NULL, 'Tropomodulin-2', 169, NULL, NULL, 149935),
(149936, '1.10.30.50-FF-000019', NULL, 'Slr2080 protein', 89, NULL, NULL, 149936),
(149937, '3.30.390.30-FF-000001', NULL, 'Dihydrolipoyl dehydrogenase', 121, NULL, NULL, 149937),
(149938, '3.40.50.300-FF-004664', NULL, 'Uncharacterized protein', 295, NULL, NULL, 149938),
(149939, '3.30.420.40-FF-000361', NULL, 'MPA43p protein', 335, NULL, NULL, 149939),
(149940, '3.40.630.150-FF-000012', NULL, 'Uncharacterized protein', 45, NULL, NULL, 149940),
(149941, '1.10.510.10-FF-002945', NULL, NULL, 87, NULL, NULL, 149941),
(149942, '1.25.40.10-FF-004134', NULL, 'Predicted protein', 119, NULL, NULL, 149942),
(149943, '3.20.80.10-FF-000051', NULL, 'Uncharacterized protein', 168, NULL, NULL, 149943),
(149944, '3.30.420.10-FF-000285', NULL, '3''-5''_exonuclease_-_putative', 230, NULL, NULL, 149944),
(149945, '3.30.450.20-FF-000323', NULL, 'Sensory box histidine kinase', 119, NULL, NULL, 149945),
(149946, '1.20.5.350-FF-000014', NULL, NULL, 85, NULL, NULL, 149946),
(149947, '3.40.50.150-FF-001432', NULL, NULL, 149, NULL, NULL, 149947),
(149948, '3.40.50.1100-FF-000215', NULL, 'Uncharacterized protein', 71, NULL, NULL, 149948),
(149949, '3.40.190.10-FF-000522', NULL, 'Phosphate ABC transporter substrate-binding protein', 158, NULL, NULL, 149949),
(149950, '1.25.40.10-FF-002448', NULL, 'Pentatricopeptide repeat-containing protein At1g13040, mitochondrial', 80, NULL, NULL, 149950),
(149951, '3.40.33.10-FF-000183', NULL, 'Uncharacterized protein', 75, NULL, NULL, 149951),
(149952, '1.10.1900.10-FF-000018', NULL, 'Polyadenylate-binding protein 7', 82, NULL, NULL, 149952),
(149953, '3.90.120.10-FF-000018', NULL, 'Modification methylase AplI', 95, NULL, NULL, 149953),
(149954, '1.10.1040.50-FF-000003', NULL, 'Fatty acid oxidation complex subunit alpha', 207, NULL, NULL, 149954),
(149955, '2.30.30.140-FF-000110', NULL, 'Survival motor neuron-like protein', 58, NULL, NULL, 149955),
(149956, '3.30.40.10-FF-002234', NULL, 'Uncharacterized protein', 64, NULL, NULL, 149956),
(149957, '1.20.120.1780-FF-000005', NULL, 'Chlorophyll synthase, chloroplastic', 120, NULL, NULL, 149957),
(149958, '3.40.366.10-FF-000009', NULL, 'Fatty acid synthase Fas', 156, NULL, NULL, 149958),
(149959, '3.30.420.40-FF-000592', NULL, 'Hexokinase domain containing 1', 168, NULL, NULL, 149959),
(149960, '1.25.70.10-FF-000067', NULL, 'Uncharacterized protein', 271, NULL, NULL, 149960),
(149961, '1.20.1270.60-FF-000302', NULL, 'Uncharacterized protein', 112, NULL, NULL, 149961);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(149962, '1.25.40.820-FF-000022', NULL, 'Putative RNA polymerase II subunit B1 CTD phosphatase rtr1', 172, NULL, NULL, 149962),
(149963, '1.20.1540.10-FF-000084', NULL, 'Integral membrane protein', 182, NULL, NULL, 149963),
(149964, '3.10.129.10-FF-000039', NULL, 'Beta-hydroxyacyl-ACP dehydratase', 127, NULL, NULL, 149964),
(149965, '3.30.1330.60-FF-000022', NULL, 'Sodium-type flagellar protein MotY', 118, NULL, NULL, 149965),
(149966, '3.30.465.10-FF-000135', NULL, 'Glycolate oxidase subunits GlcE and GlcF', 122, NULL, NULL, 149966),
(149967, '1.10.510.10-FF-000759', NULL, 'CAMK/CAMKL/AMPK protein kinase', 354, NULL, NULL, 149967),
(149968, '3.40.50.1400-FF-000007', NULL, 'Ferrochelatase', 141, NULL, NULL, 149968),
(149969, '3.80.10.10-FF-002028', NULL, 'Si:ch211-11p18.6', 118, NULL, NULL, 149969),
(149970, '2.30.30.100-FF-000205', NULL, 'Small nuclear ribonucleoprotein E', 91, NULL, NULL, 149970),
(149971, '1.10.274.30-FF-000030', NULL, 'Protein CBG13706', 130, NULL, NULL, 149971),
(149972, '1.20.1110.10-FF-000208', NULL, NULL, 79, NULL, NULL, 149972),
(149973, '1.20.58.80-FF-000013', NULL, 'STAM-binding protein-like A', 146, NULL, NULL, 149973),
(149974, '2.60.11.10-FF-000015', NULL, 'Uncharacterized protein', 90, NULL, NULL, 149974),
(149975, '3.40.50.11350-FF-000029', NULL, 'Alpha-(1,6)-fucosyltransferase', 168, NULL, NULL, 149975),
(149976, '1.25.10.10-FF-002300', NULL, 'Uncharacterized protein', 1039, NULL, NULL, 149976),
(149977, '2.40.50.740-FF-000005', NULL, '30S ribosomal protein S4e', 55, NULL, NULL, 149977),
(149978, '3.40.50.150-FF-000768', NULL, NULL, 75, NULL, NULL, 149978),
(149979, '3.30.160.60-FF-000768', NULL, 'zinc finger homeobox protein 3 isoform X2', 67, NULL, NULL, 149979),
(149980, '3.80.10.10-FF-000847', NULL, 'NACHT, LRR and PYD domains-containing protein 12 isoform X3', 152, NULL, NULL, 149980),
(149981, '3.30.70.1230-FF-000268', NULL, 'Uncharacterized protein', 138, NULL, NULL, 149981),
(149982, '3.40.50.1820-FF-000577', NULL, 'Peptide hydrolase', 253, NULL, NULL, 149982),
(149983, '2.40.50.90-FF-000136', NULL, 'Tudor domain-containing protein 7A', 94, NULL, NULL, 149983),
(149984, '3.40.1110.10-FF-000270', NULL, NULL, 141, NULL, NULL, 149984),
(149985, '3.30.230.10-FF-000394', NULL, 'Uncharacterized protein', 71, NULL, NULL, 149985),
(149986, '3.90.70.110-FF-000002', NULL, 'Polyprotein P1234', 153, NULL, NULL, 149986),
(149987, '3.90.70.10-FF-000715', NULL, 'Predicted protein', 200, NULL, NULL, 149987),
(149988, '1.20.58.60-FF-000058', NULL, 'Short stop, isoform K', 110, NULL, NULL, 149988),
(149989, '3.40.630.10-FF-000006', NULL, 'N-acetyldiaminopimelate deacetylase', 243, NULL, NULL, 149989),
(149990, '3.90.550.10-FF-000039', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 390, NULL, NULL, 149990),
(149991, '1.20.5.170-FF-000084', NULL, 'Mitotic spindle assembly checkpoint protein MAD1', 32, NULL, NULL, 149991),
(149992, '3.30.200.20-FF-001620', NULL, 'Probable protein kinase yloP', 98, NULL, NULL, 149992),
(149993, '3.40.50.300-FF-003444', NULL, 'DNA helicase', 115, NULL, NULL, 149993),
(149994, '2.120.10.30-FF-000123', NULL, 'Chloroplast protein HCF243', 105, NULL, NULL, 149994),
(149995, '1.20.1070.10-FF-001109', NULL, 'Neuropeptide FF receptor 2', 356, NULL, NULL, 149995),
(149996, '3.30.2080.10-FF-000016', NULL, 'Alpha-1,2-mannosidase family protein', 157, NULL, NULL, 149996),
(149997, '3.30.160.60-FF-002477', NULL, 'Zinc finger protein 521', 88, NULL, NULL, 149997),
(149998, '1.25.40.10-FF-005354', NULL, 'Pentatricopeptide repeat-containing protein', 121, NULL, NULL, 149998),
(149999, '1.20.1250.20-FF-001267', NULL, 'Solute carrier family 15 member 3', 341, NULL, NULL, 149999),
(150000, '1.20.58.390-FF-000211', NULL, 'Uncharacterized protein', 103, NULL, NULL, 150000),
(150001, '3.40.850.10-FF-000225', NULL, 'Putative kinesin', 359, NULL, NULL, 150001),
(150002, '3.30.40.10-FF-000525', NULL, 'PHD finger protein 24', 87, NULL, NULL, 150002),
(150003, '1.25.40.20-FF-001821', NULL, 'Uncharacterized protein', 155, NULL, NULL, 150003),
(150004, '3.10.120.10-FF-000019', NULL, 'Chitin synthase ChsE', 73, NULL, NULL, 150004);
INSERT INTO "PUBLIC"."MODEL" VALUES
(150005, '3.40.50.1820-FF-001566', NULL, 'Uncharacterized protein', 115, NULL, NULL, 150005),
(150006, '3.30.70.330-FF-001599', NULL, NULL, 126, NULL, NULL, 150006),
(150007, '2.10.25.10-FF-000038', NULL, 'Fibrillin 2', 46, NULL, NULL, 150007),
(150008, '3.30.1010.10-FF-000068', NULL, 'YALI0F20636p', 162, NULL, NULL, 150008),
(150009, '1.20.1000.10-FF-000026', NULL, NULL, 180, NULL, NULL, 150009),
(150010, '2.10.25.10-FF-001466', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1', 40, NULL, NULL, 150010),
(150011, '1.10.472.10-FF-000282', NULL, 'Uncharacterized protein', 104, NULL, NULL, 150011),
(150012, '3.30.160.60-FF-001757', NULL, 'paternally-expressed gene 3 protein isoform X1', 29, NULL, NULL, 150012),
(150013, '2.20.28.30-FF-000005', NULL, 'CHY zinc finger-domain-containing protein', 51, NULL, NULL, 150013),
(150014, '1.20.120.1240-FF-000080', NULL, 'Uncharacterized protein', 166, NULL, NULL, 150014),
(150015, '3.30.70.100-FF-000187', NULL, NULL, 71, NULL, NULL, 150015),
(150016, '3.40.50.300-FF-004872', NULL, 'Dynein heavy chain', 335, NULL, NULL, 150016),
(150017, '2.60.120.290-FF-000030', NULL, 'Seizure related 6 homolog like', 111, NULL, NULL, 150017),
(150018, '3.40.50.720-FF-000580', NULL, 'Putative mitochondrial NADH-ubiquinone oxidoreductase complex I subunit,FT', 248, NULL, NULL, 150018),
(150019, '1.10.3260.10-FF-000053', NULL, 'Uncharacterized protein', 82, NULL, NULL, 150019),
(150020, '3.40.50.2300-FF-000266', NULL, 'Glutamate [NMDA] receptor subunit 1', 164, NULL, NULL, 150020),
(150021, '1.10.260.100-FF-000016', NULL, 'Stress-induced protein sti1', 68, NULL, NULL, 150021),
(150022, '1.25.10.10-FF-001783', NULL, 'serine/threonine-protein phosphatase 4 regulatory subunit 4-like isoform X1', 617, NULL, NULL, 150022),
(150023, '4.10.60.10-FF-000059', NULL, 'Gis2p', 41, NULL, NULL, 150023),
(150024, '2.130.10.130-FF-000028', NULL, NULL, 158, NULL, NULL, 150024),
(150025, '2.130.10.10-FF-000184', NULL, 'semaphorin-6C isoform X1', 497, NULL, NULL, 150025),
(150026, '2.130.10.10-FF-003202', NULL, 'Predicted protein', 94, NULL, NULL, 150026),
(150027, '2.60.40.10-FF-002617', NULL, 'Protein tyrosine phosphatase receptor type K', 54, NULL, NULL, 150027),
(150028, '1.25.10.10-FF-001047', NULL, 'Predicted protein', 182, NULL, NULL, 150028),
(150029, '3.40.50.720-FF-001389', NULL, 'UDP-N-acetyl-2-amino-2-deoxy-D-glucuronate oxidase', 133, NULL, NULL, 150029),
(150030, '3.80.10.10-FF-004006', NULL, 'Protein CBR-MRPS-18A', 321, NULL, NULL, 150030),
(150031, '3.40.50.11950-FF-000001', NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', 105, NULL, NULL, 150031),
(150032, '3.90.79.10-FF-000151', NULL, 'Adenine DNA glycosylase', 164, NULL, NULL, 150032),
(150033, '2.40.10.10-FF-000626', NULL, NULL, 257, NULL, NULL, 150033),
(150034, '3.30.230.10-FF-000130', NULL, 'Endopeptidase La', 112, NULL, NULL, 150034),
(150035, '1.25.10.10-FF-002036', NULL, 'Armadillo/beta-catenin-like repeat, putative', 135, NULL, NULL, 150035),
(150036, '1.10.10.10-FF-001900', NULL, 'O-methyltransferase family protein', 97, NULL, NULL, 150036),
(150037, '1.10.10.60-FF-000173', NULL, 'brain-specific homeobox protein homolog', 94, NULL, NULL, 150037),
(150038, '3.10.129.10-FF-000191', NULL, 'Long-chain acyl-CoA thioesterase, BFIT_BACH family', 156, NULL, NULL, 150038),
(150039, '3.90.1530.30-FF-000009', NULL, 'Partitioning protein', 64, NULL, NULL, 150039),
(150040, '3.20.20.140-FF-000264', NULL, 'Periplasmic amidohydrolase family protein', 300, NULL, NULL, 150040),
(150041, '1.20.1690.10-FF-000004', NULL, 'V-type proton ATPase subunit', 122, NULL, NULL, 150041),
(150042, '1.25.40.10-FF-000891', NULL, 'SGT1 and CS domain protein', 144, NULL, NULL, 150042),
(150043, '3.90.226.10-FF-000213', NULL, 'Enoyl-CoA hydratase, mitochondrial', 202, NULL, NULL, 150043),
(150044, '3.30.160.60-FF-001049', NULL, 'zinc finger protein 319', 29, NULL, NULL, 150044),
(150045, '3.20.20.80-FF-000635', NULL, 'Uncharacterized protein', 116, NULL, NULL, 150045),
(150046, '3.40.50.1460-FF-000126', NULL, 'Uncharacterized protein', 149, NULL, NULL, 150046);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(150047, '1.10.1320.10-FF-000024', NULL, 'DNA-directed RNA polymerase', 118, NULL, NULL, 150047),
(150048, '3.40.50.150-FF-000504', NULL, 'Integral membrane protein', 224, NULL, NULL, 150048),
(150049, '2.10.25.10-FF-001819', NULL, 'Protein CBG10218', 40, NULL, NULL, 150049),
(150050, '1.10.3390.10-FF-000001', NULL, 'UPF0352 protein YejL', 75, NULL, NULL, 150050),
(150051, '3.90.76.10-FF-000049', NULL, 'Putative substrate binding protein', 116, NULL, NULL, 150051),
(150052, '3.40.50.300-FF-001999', NULL, 'Rho-related BTB domain-containing protein 1', 87, NULL, NULL, 150052),
(150053, '3.50.50.60-FF-000181', NULL, 'Pyridine nucleotide-disulfide oxidoreductase domain-containing protein 1', 150, NULL, NULL, 150053),
(150054, '2.60.120.260-FF-000454', NULL, 'Beta-galactosidase', 48, NULL, NULL, 150054),
(150055, '3.40.50.150-FF-001724', NULL, NULL, 73, NULL, NULL, 150055),
(150056, '3.40.50.450-FF-000004', NULL, 'ATP-dependent 6-phosphofructokinase', 207, NULL, NULL, 150056),
(150057, '3.40.30.10-FF-000558', NULL, 'Major surface protein 5', 173, NULL, NULL, 150057),
(150058, '1.10.510.10-FF-000967', NULL, 'Protein CBG11274', 312, NULL, NULL, 150058),
(150059, '1.20.120.2010-FF-000001', NULL, 'NGFI-A-binding protein 1 isoform X1', 140, NULL, NULL, 150059),
(150060, '3.30.70.600-FF-000011', NULL, 'Uncharacterized protein', 119, NULL, NULL, 150060),
(150061, '3.80.10.10-FF-003809', NULL, 'Uncharacterized protein', 84, NULL, NULL, 150061),
(150062, '3.40.50.300-FF-000010', NULL, 'Chaperone clpB 1, putative', 194, NULL, NULL, 150062),
(150063, '1.20.1250.20-FF-002256', NULL, 'Uncharacterized protein', 517, NULL, NULL, 150063),
(150064, '2.60.60.20-FF-000031', NULL, 'Uncharacterized protein', 114, NULL, NULL, 150064),
(150065, '1.10.8.10-FF-000163', NULL, 'Ubiquitin-specific peptidase 28', 74, NULL, NULL, 150065),
(150066, '3.40.50.2000-FF-001019', NULL, 'Alphaalpha-trehalose-phosphate synthase [UDP-forming] 5', 181, NULL, NULL, 150066),
(150067, '3.90.1530.10-FF-000003', NULL, 'Sulfiredoxin chloroplastic/mitochondrial', 88, NULL, NULL, 150067),
(150068, '3.40.50.1370-FF-000043', NULL, 'Ornithine carbamoyltransferase chloroplastic', 126, NULL, NULL, 150068),
(150069, '2.60.40.1180-FF-000044', NULL, 'Alpha-glucosidase 1', 101, NULL, NULL, 150069),
(150070, '1.25.10.10-FF-001311', NULL, 'Uncharacterized protein', 76, NULL, NULL, 150070),
(150071, '3.40.50.410-FF-000043', NULL, 'Protein transport protein SEC23', 260, NULL, NULL, 150071),
(150072, '3.30.160.60-FF-006428', NULL, NULL, 22, NULL, NULL, 150072),
(150073, '3.90.550.50-FF-000152', NULL, 'Predicted protein', 111, NULL, NULL, 150073),
(150074, '1.10.287.370-FF-000066', NULL, 'Prefoldin subunit 5, putative', 96, NULL, NULL, 150074),
(150075, '1.10.510.10-FF-002592', NULL, NULL, 197, NULL, NULL, 150075),
(150076, '2.60.40.10-FF-004798', NULL, NULL, 109, NULL, NULL, 150076),
(150077, '4.10.1240.30-FF-000010', NULL, NULL, 84, NULL, NULL, 150077),
(150078, '3.40.50.1260-FF-000038', NULL, 'Phosphoglycerate kinase', 166, NULL, NULL, 150078),
(150079, '3.30.40.10-FF-001453', NULL, 'Uncharacterized protein', 112, NULL, NULL, 150079),
(150080, '3.30.200.20-FF-001884', NULL, 'Uncharacterized protein', 98, NULL, NULL, 150080),
(150081, '3.30.450.20-FF-000615', NULL, 'Neuronal PAS domain-containing protein 4B', 115, NULL, NULL, 150081),
(150082, '1.20.890.10-FF-000026', NULL, 'cAMP-dependent protein kinase type II-alpha regulatory subunit', 44, NULL, NULL, 150082),
(150083, '3.30.70.330-FF-000351', NULL, 'Heterogeneous nuclear ribonucleoprotein 27C', 80, NULL, NULL, 150083),
(150084, '1.10.1300.10-FF-000080', NULL, 'Phosphodiesterase', 368, NULL, NULL, 150084),
(150085, '3.30.160.60-FF-002685', NULL, 'Zinc finger protein 285', 39, NULL, NULL, 150085),
(150086, '2.60.40.1450-FF-000001', NULL, 'Recombining binding protein suppressor of hairless', 164, NULL, NULL, 150086),
(150087, '3.40.50.2000-FF-000502', NULL, 'N-acylglucosamine 2-epimerase', 160, NULL, NULL, 150087),
(150088, '1.20.1070.10-FF-002037', NULL, 'GM02327p', 116, NULL, NULL, 150088),
(150089, '1.20.1510.10-FF-000048', NULL, 'Cation-efflux pump FieF protein', 198, NULL, NULL, 150089); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(150090, '3.20.20.70-FF-000161', NULL, 'Dual-specificity RNA methyltransferase RlmN', 280, NULL, NULL, 150090),
(150091, '2.40.50.140-FF-000421', NULL, 'Replication protein A subunit', 115, NULL, NULL, 150091),
(150092, '3.60.21.10-FF-000446', NULL, 'Serine/threonine-protein phosphatase', 195, NULL, NULL, 150092),
(150093, '3.40.50.1000-FF-000775', NULL, NULL, 93, NULL, NULL, 150093),
(150094, '1.25.40.10-FF-000183', NULL, 'ARM-repeat/Tetratricopeptide repeat (TPR)-like protein', 125, NULL, NULL, 150094),
(150095, '2.60.40.10-FF-003606', NULL, NULL, 110, NULL, NULL, 150095),
(150096, '1.10.340.30-FF-000061', NULL, '8-oxoguanine DNA glycosylase', 120, NULL, NULL, 150096),
(150097, '3.40.50.10490-FF-000086', NULL, 'Glucose-6-phosphate isomerase', 199, NULL, NULL, 150097),
(150098, '3.40.50.1000-FF-000511', NULL, NULL, 146, NULL, NULL, 150098),
(150099, '2.120.10.100-FF-000005', NULL, 'Calcium-activated nucleotidase 1b', 221, NULL, NULL, 150099),
(150100, '1.10.510.10-FF-002092', NULL, NULL, 95, NULL, NULL, 150100),
(150101, '3.40.50.300-FF-008615', NULL, 'Uncharacterized protein', 298, NULL, NULL, 150101),
(150102, '3.40.50.1860-FF-000010', NULL, 'Glutamate racemase', 113, NULL, NULL, 150102),
(150103, '4.10.1240.50-FF-000016', NULL, 'Predicted protein', 70, NULL, NULL, 150103),
(150104, '1.50.10.130-FF-000029', NULL, NULL, 62, NULL, NULL, 150104),
(150105, '3.40.50.300-FF-001027', NULL, 'dynamin-related protein 3A', 299, NULL, NULL, 150105),
(150106, '2.130.10.10-FF-005355', NULL, 'Uncharacterized protein', 175, NULL, NULL, 150106),
(150107, '3.20.20.100-FF-000100', NULL, 'Hypothetical protein LOC594893', 343, NULL, NULL, 150107),
(150108, '3.30.160.60-FF-001549', NULL, 'Zinc finger protein 75a', 27, NULL, NULL, 150108),
(150109, '3.30.300.30-FF-000052', NULL, 'Ss-alanyl conjugating enzyme', 99, NULL, NULL, 150109),
(150110, '3.30.420.10-FF-000313', NULL, NULL, 125, NULL, NULL, 150110),
(150111, '1.25.40.710-FF-000017', NULL, 'Uncharacterized protein', 196, NULL, NULL, 150111),
(150112, '3.30.420.10-FF-000577', NULL, NULL, 231, NULL, NULL, 150112),
(150113, '3.30.160.60-FF-004894', NULL, NULL, 73, NULL, NULL, 150113),
(150114, '1.10.1420.10-FF-000088', NULL, 'Endonuclease MutS2', 110, NULL, NULL, 150114),
(150115, '1.25.40.10-FF-002217', NULL, 'ER membrane protein complex subunit 2', 96, NULL, NULL, 150115),
(150116, '2.130.10.10-FF-005939', NULL, 'Uncharacterized protein', 259, NULL, NULL, 150116),
(150117, '3.50.7.10-FF-000005', NULL, 'T-complex protein 1 subunit gamma', 154, NULL, NULL, 150117),
(150118, '1.20.1250.20-FF-000047', NULL, '3-phenylpropionic acid MFS transporter', 185, NULL, NULL, 150118),
(150119, '1.10.10.10-FF-001400', NULL, 'DNA-directed RNA polymerase III subunit RPC6', 81, NULL, NULL, 150119),
(150120, '1.10.287.70-FF-000318', NULL, 'Cyclic nucleotide-gated potassium channel', 250, NULL, NULL, 150120),
(150121, '3.40.720.10-FF-000013', NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase', 280, NULL, NULL, 150121),
(150122, '3.40.50.970-FF-000042', NULL, 'Oxalyl-CoA decarboxylase', 214, NULL, NULL, 150122),
(150123, '3.30.559.10-FF-000078', NULL, 'Nonribosomal peptide synthetase DhbF', 196, NULL, NULL, 150123),
(150124, '3.20.20.80-FF-000843', NULL, 'Predicted protein', 338, NULL, NULL, 150124),
(150125, '3.80.10.10-FF-000263', NULL, 'volume-regulated anion channel subunit LRRC8B', 87, NULL, NULL, 150125),
(150126, '4.10.1240.10-FF-000055', NULL, 'Uncharacterized protein', 101, NULL, NULL, 150126),
(150127, '1.20.920.10-FF-000024', NULL, 'Transcription intermediary factor 1-alpha', 121, NULL, NULL, 150127),
(150128, '3.40.50.300-FF-006581', NULL, 'RAS (RAD and GEM)-like GTP binding 2', 100, NULL, NULL, 150128),
(150129, '3.30.1490.100-FF-000032', NULL, 'DNA-directed DNA polymerase eta', 150, NULL, NULL, 150129),
(150130, '3.30.559.70-FF-000017', NULL, 'Choline/Carnitine o-acyltransferase-like protein', 372, NULL, NULL, 150130),
(150131, '1.10.357.50-FF-000015', NULL, 'Predicted protein', 167, NULL, NULL, 150131),
(150132, '3.40.50.300-FF-003236', NULL, 'Protein brown', 222, NULL, NULL, 150132);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(150133, '1.20.1250.20-FF-002195', NULL, 'Uncharacterized protein', 152, NULL, NULL, 150133),
(150134, '3.40.850.10-FF-000017', NULL, 'Kinesin-like protein', 352, NULL, NULL, 150134),
(150135, '3.40.50.2000-FF-000766', NULL, 'Glycosyltransferase family 1 protein', 230, NULL, NULL, 150135),
(150136, '3.30.750.24-FF-000076', NULL, 'Anti-sigma factor antagonist', 109, NULL, NULL, 150136),
(150137, '3.20.20.80-FF-000135', NULL, 'Beta-galactosidase, putative, bgl35A', 374, NULL, NULL, 150137),
(150138, '1.10.10.570-FF-000018', NULL, 'Uncharacterized protein', 72, NULL, NULL, 150138),
(150139, '3.40.800.10-FF-000014', NULL, 'Arginase family protein', 343, NULL, NULL, 150139),
(150140, '2.130.10.10-FF-003410', NULL, 'Sortilin', 188, NULL, NULL, 150140),
(150141, '1.10.1410.10-FF-000059', NULL, 'Uncharacterized protein', 151, NULL, NULL, 150141),
(150142, '3.40.50.20-FF-000006', NULL, 'Phosphoribosylamine--glycine ligase, chloroplastic', 94, NULL, NULL, 150142),
(150143, '3.40.220.10-FF-000020', NULL, 'Transcription factor bHLH140', 148, NULL, NULL, 150143),
(150144, '2.60.40.10-FF-005231', NULL, NULL, 89, NULL, NULL, 150144),
(150145, '3.10.105.10-FF-000012', NULL, 'Peptide/nickel transport system substrate-binding protein', 216, NULL, NULL, 150145),
(150146, '1.10.10.1020-FF-000002', NULL, 'RecBCD enzyme subunit RecD', 122, NULL, NULL, 150146),
(150147, '3.40.1580.10-FF-000001', NULL, 'Similar to 1,3-beta-glucan biosynthesis protein', 158, NULL, NULL, 150147),
(150148, '3.10.330.10-FF-000029', NULL, 'Cell division control protein 48 homolog D', 49, NULL, NULL, 150148),
(150149, '1.20.1050.10-FF-000181', NULL, 'Glutathione S-transferase', 119, NULL, NULL, 150149),
(150150, '1.10.238.10-FF-000659', NULL, 'Uncharacterized protein', 54, NULL, NULL, 150150),
(150151, '3.40.50.620-FF-000224', NULL, 'Leucine--tRNA ligase, putative', 114, NULL, NULL, 150151),
(150152, '3.40.630.30-FF-000664', NULL, 'Elongator complex protein 3', 150, NULL, NULL, 150152),
(150153, '2.60.120.20-FF-000009', NULL, 'Genome polyprotein', 261, NULL, NULL, 150153),
(150154, '3.40.50.720-FF-000372', NULL, 'Mycocerosic acid synthase-like polyketide synthase', 250, NULL, NULL, 150154),
(150155, '2.40.30.10-FF-000425', NULL, 'Uncharacterized protein', 123, NULL, NULL, 150155),
(150156, '3.30.450.20-FF-000262', NULL, 'Methyl-accepting chemotaxis sensory transducer', 116, NULL, NULL, 150156),
(150157, '3.10.450.100-FF-000002', NULL, 'Penicillin-binding protein 3', 114, NULL, NULL, 150157),
(150158, '3.50.50.60-FF-000681', NULL, '2-octaprenyl-6-methoxyphenyl hydroxylase', 251, NULL, NULL, 150158),
(150159, '3.30.40.10-FF-000172', NULL, 'E3 ubiquitin-protein ligase RAD18', 94, NULL, NULL, 150159),
(150160, '2.60.120.260-FF-000246', NULL, 'Cytosolic endo-beta-N-acetylglucosaminidase 1 isoform A', 184, NULL, NULL, 150160),
(150161, '3.60.40.10-FF-000193', NULL, 'Uncharacterized protein', 130, NULL, NULL, 150161),
(150162, '2.30.30.40-FF-000581', NULL, 'Uncharacterized protein', 68, NULL, NULL, 150162),
(150163, '3.30.200.160-FF-000016', NULL, 'Uncharacterized protein', 94, NULL, NULL, 150163),
(150164, '1.25.40.420-FF-000054', NULL, 'Uncharacterized protein', 72, NULL, NULL, 150164),
(150165, '3.60.40.10-FF-000305', NULL, 'Uncharacterized protein', 320, NULL, NULL, 150165),
(150166, '3.40.50.10190-FF-000322', NULL, 'Uncharacterized protein', 119, NULL, NULL, 150166),
(150167, '1.20.120.350-FF-000069', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 66, NULL, NULL, 150167),
(150168, '3.40.50.200-FF-000126', NULL, 'Uncharacterized protein', 173, NULL, NULL, 150168),
(150169, '3.30.830.10-FF-000187', NULL, 'Uncharacterized protein', 220, NULL, NULL, 150169),
(150170, '2.40.20.10-FF-000099', NULL, 'Predicted protein', 134, NULL, NULL, 150170),
(150171, '3.40.50.1580-FF-000016', NULL, 'Nucleoside phosphorylase, putative', 308, NULL, NULL, 150171),
(150172, '2.60.40.10-FF-003045', NULL, 'Poliovirus receptor', 123, NULL, NULL, 150172),
(150173, '3.40.50.720-FF-001653', NULL, 'NAD-dependent epimerase/dehydratase family protein', 299, NULL, NULL, 150173);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(150174, '2.10.50.10-FF-000170', NULL, 'Predicted protein', 75, NULL, NULL, 150174),
(150175, '1.20.1070.10-FF-001761', NULL, 'Uncharacterized protein', 70, NULL, NULL, 150175),
(150176, '2.60.40.60-FF-000934', NULL, 'Uncharacterized protein', 110, NULL, NULL, 150176),
(150177, '3.40.50.880-FF-000015', NULL, 'Protein DJ-1 homolog C', 190, NULL, NULL, 150177),
(150178, '3.70.10.10-FF-000016', NULL, 'Checkpoint protein', 301, NULL, NULL, 150178),
(150179, '3.80.10.10-FF-003961', NULL, 'Uncharacterized protein', 198, NULL, NULL, 150179),
(150180, '3.40.50.300-FF-006934', NULL, 'Uncharacterized protein', 229, NULL, NULL, 150180),
(150181, '2.110.10.10-FF-000078', NULL, 'Uncharacterized protein', 74, NULL, NULL, 150181),
(150182, '4.10.640.10-FF-000009', NULL, 'Ribosomal protein S18', 64, NULL, NULL, 150182),
(150183, '2.60.40.10-FF-005815', NULL, NULL, 63, NULL, NULL, 150183),
(150184, '3.60.120.10-FF-000025', NULL, 'Isochorismate synthase', 449, NULL, NULL, 150184),
(150185, '2.20.70.10-FF-000120', NULL, 'mRNA cap guanine-N7 methyltransferase', 36, NULL, NULL, 150185),
(150186, '2.20.25.240-FF-000014', NULL, 'Uncharacterized protein', 82, NULL, NULL, 150186),
(150187, '3.10.20.770-FF-000005', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', 310, NULL, NULL, 150187),
(150188, '1.25.40.10-FF-000683', NULL, 'Pentatricopeptide repeat-containing protein At3g49170, chloroplastic', 97, NULL, NULL, 150188),
(150189, '3.90.70.10-FF-000098', NULL, 'Calpain, putative (Pcalp)', 143, NULL, NULL, 150189),
(150190, '1.20.5.4010-FF-000003', NULL, 'protein quaking-B isoform X1', 57, NULL, NULL, 150190),
(150191, '3.30.160.60-FF-003702', NULL, NULL, 28, NULL, NULL, 150191),
(150192, '3.10.20.90-FF-000633', NULL, 'Ubiquitin family protein', 87, NULL, NULL, 150192),
(150193, '1.20.1270.60-FF-000066', NULL, 'Metastasis suppressor protein 1', 182, NULL, NULL, 150193),
(150194, '1.20.58.60-FF-000119', NULL, 'nesprin-1 isoform X2', 141, NULL, NULL, 150194),
(150195, '3.40.50.300-FF-008115', NULL, 'Uncharacterized protein', 107, NULL, NULL, 150195),
(150196, '3.30.160.60-FF-005091', NULL, NULL, 50, NULL, NULL, 150196),
(150197, '3.40.50.2000-FF-000974', NULL, 'Uncharacterized protein', 84, NULL, NULL, 150197),
(150198, '3.10.100.10-FF-000428', NULL, NULL, 82, NULL, NULL, 150198),
(150199, '3.40.190.10-FF-000489', NULL, 'LysR family transcriptional regulator', 92, NULL, NULL, 150199),
(150200, '3.30.70.330-FF-000407', NULL, 'Fusilli, isoform E', 121, NULL, NULL, 150200),
(150201, '2.40.10.10-FF-000273', NULL, 'Serine protease', 117, NULL, NULL, 150201),
(150202, '3.40.850.10-FF-000489', NULL, 'Kinesin-like protein', 66, NULL, NULL, 150202),
(150203, '3.40.50.410-FF-000251', NULL, 'Cutl-23', 188, NULL, NULL, 150203),
(150204, '3.80.10.10-FF-002680', NULL, 'Leucine-rich repeat transmembrane protein kinase', 104, NULL, NULL, 150204),
(150205, '3.30.420.10-FF-000077', NULL, 'Uncharacterized protein', 141, NULL, NULL, 150205),
(150206, '2.30.30.180-FF-000010', NULL, 'Ribosome maturation factor RimP', 66, NULL, NULL, 150206),
(150207, '3.30.70.940-FF-000028', NULL, 'Uncharacterized protein', 94, NULL, NULL, 150207),
(150208, '3.20.20.80-FF-000282', NULL, 'Alpha-glucosidase', 313, NULL, NULL, 150208),
(150209, '2.30.29.30-FF-000058', NULL, 'focal adhesion kinase 1 isoform X1', 119, NULL, NULL, 150209),
(150210, '3.30.70.260-FF-000010', NULL, 'GTP pyrophosphokinase RelA', 80, NULL, NULL, 150210),
(150211, '3.30.2410.10-FF-000031', NULL, 'Hectd1 protein', 68, NULL, NULL, 150211),
(150212, '2.40.50.140-FF-000685', NULL, 'rRNA biogenesis protein RRP5', 89, NULL, NULL, 150212),
(150213, '3.30.1330.40-FF-000011', NULL, 'Translation initiation inhibitor', 129, NULL, NULL, 150213),
(150214, '2.40.50.140-FF-000213', NULL, 'Ribonuclease R', 80, NULL, NULL, 150214),
(150215, '2.170.270.10-FF-000193', NULL, 'Uncharacterized protein', 180, NULL, NULL, 150215),
(150216, '2.60.220.50-FF-000121', NULL, 'Uncharacterized protein', 37, NULL, NULL, 150216),
(150217, '2.40.70.10-FF-000490', NULL, NULL, 137, NULL, NULL, 150217);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(150218, '1.10.1600.10-FF-000006', NULL, 'ATP-dependent DNA helicase 2 subunit 2', 124, NULL, NULL, 150218),
(150219, '3.40.50.300-FF-004164', NULL, 'Predicted protein', 137, NULL, NULL, 150219),
(150220, '1.20.1560.10-FF-000500', NULL, 'Uncharacterized protein', 28, NULL, NULL, 150220),
(150221, '1.20.58.1610-FF-000019', NULL, NULL, 123, NULL, NULL, 150221),
(150222, '1.10.357.10-FF-000059', NULL, 'Transcriptional regulator, TetR family', 188, NULL, NULL, 150222),
(150223, '1.20.1250.20-FF-000547', NULL, 'Folate transporter 1', 194, NULL, NULL, 150223),
(150224, '1.25.40.10-FF-004634', NULL, 'Serine/threonine-protein phosphatase', 77, NULL, NULL, 150224),
(150225, '3.40.50.720-FF-001709', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 143, NULL, NULL, 150225),
(150226, '3.90.70.10-FF-000362', NULL, 'Os12g0148301 protein', 249, NULL, NULL, 150226),
(150227, '3.30.160.100-FF-000021', NULL, 'Ribosome-associated factor Y', 101, NULL, NULL, 150227),
(150228, '3.40.50.720-FF-002429', NULL, 'Uncharacterized protein', 18, NULL, NULL, 150228),
(150229, '2.60.40.10-FF-000583', NULL, 'tyrosine-protein kinase receptor Tie-1 isoform X2', 95, NULL, NULL, 150229),
(150230, '3.40.30.10-FF-000822', NULL, 'Uncharacterized protein', 55, NULL, NULL, 150230),
(150231, '1.20.920.30-FF-000035', NULL, 'Inner dynein arm I1 heavy chain 1-ALPHA', 200, NULL, NULL, 150231),
(150232, '3.40.50.300-FF-007598', NULL, 'ABC transporter, putative', 164, NULL, NULL, 150232),
(150233, '3.30.200.20-FF-002137', NULL, 'Predicted protein', 71, NULL, NULL, 150233),
(150234, '3.90.550.10-FF-000511', NULL, 'Glycosyl transferase family 2', 258, NULL, NULL, 150234),
(150235, '1.25.40.10-FF-001200', NULL, 'Swa2p', 154, NULL, NULL, 150235),
(150236, '1.20.140.10-FF-000110', NULL, 'Acyl-coenzyme A oxidase', 127, NULL, NULL, 150236),
(150237, '3.30.530.20-FF-000116', NULL, 'Uncharacterized protein', 187, NULL, NULL, 150237),
(150238, '2.130.10.10-FF-002393', NULL, 'Two-component system sensor histidine kinase/response regulator', 314, NULL, NULL, 150238),
(150239, '1.10.10.60-FF-000696', NULL, 'Myb-related protein 306', 61, NULL, NULL, 150239),
(150240, '2.60.40.150-FF-000788', NULL, 'Regulating synaptic membrane exocytosis 1a', 87, NULL, NULL, 150240),
(150241, '3.30.160.60-FF-006372', NULL, NULL, 78, NULL, NULL, 150241),
(150242, '3.40.190.10-FF-000730', NULL, 'Glutamate receptor, putative', 121, NULL, NULL, 150242),
(150243, '3.30.2010.10-FF-000006', NULL, 'Beta-barrel assembly-enhancing protease', 78, NULL, NULL, 150243),
(150244, '3.40.50.150-FF-001224', NULL, NULL, 128, NULL, NULL, 150244),
(150245, '1.25.40.10-FF-003145', NULL, 'Pentatricopeptide repeat-containing protein', 123, NULL, NULL, 150245),
(150246, '3.30.160.60-FF-003966', NULL, NULL, 79, NULL, NULL, 150246),
(150247, '3.90.25.10-FF-000055', NULL, 'NmrA-like family protein', 98, NULL, NULL, 150247),
(150248, '2.30.180.10-FF-000084', NULL, 'Uncharacterized protein CaJ7.0034', 136, NULL, NULL, 150248),
(150249, '3.30.70.920-FF-000022', NULL, 'ArsR family transcriptional regulator', 85, NULL, NULL, 150249),
(150250, '3.40.50.300-FF-008379', NULL, 'Uncharacterized protein', 64, NULL, NULL, 150250),
(150251, '3.80.10.10-FF-001191', NULL, 'Receptor protein-tyrosine kinase CEPR2', 122, NULL, NULL, 150251),
(150252, '3.40.50.1100-FF-000007', NULL, 'L-threonine dehydratase catabolic TdcB', 201, NULL, NULL, 150252),
(150253, '3.40.50.1000-FF-000275', NULL, 'Unplaced genomic scaffold supercont1.16, whole genome shotgun sequence', 166, NULL, NULL, 150253),
(150254, '3.40.50.300-FF-005653', NULL, 'Type III restriction enzyme, res subunit family protein', 213, NULL, NULL, 150254),
(150255, '3.30.505.10-FF-000162', NULL, NULL, 106, NULL, NULL, 150255),
(150256, '1.10.540.10-FF-000087', NULL, 'Acyl-CoA dehydrogenase, short-chain specific', 114, NULL, NULL, 150256),
(150257, '3.30.450.20-FF-000115', NULL, 'potassium voltage-gated channel subfamily H member 3 isoform X2', 81, NULL, NULL, 150257),
(150258, '1.25.40.10-FF-000739', NULL, 'Testis expressed 11', 115, NULL, NULL, 150258);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(150259, '3.90.1150.10-FF-000396', NULL, 'Uncharacterized protein', 30, NULL, NULL, 150259),
(150260, '3.40.50.300-FF-005389', NULL, 'Replicative DNA helicase', 274, NULL, NULL, 150260),
(150261, '1.10.510.10-FF-003373', NULL, NULL, 52, NULL, NULL, 150261),
(150262, '1.10.418.10-FF-000140', NULL, 'Dystonin', 92, NULL, NULL, 150262),
(150263, '3.30.110.30-FF-000014', NULL, 'Proline--tRNA ligase', 74, NULL, NULL, 150263),
(150264, '1.10.510.10-FF-002445', NULL, NULL, 193, NULL, NULL, 150264),
(150265, '3.40.50.12780-FF-000239', NULL, 'Uncharacterized protein C162.02c', 416, NULL, NULL, 150265),
(150266, '3.40.50.620-FF-000488', NULL, 'Valine-tRNA ligase', 228, NULL, NULL, 150266),
(150267, '3.40.630.30-FF-000400', NULL, 'RNA cytidine acetyltransferase', 110, NULL, NULL, 150267),
(150268, '3.30.200.20-FF-002401', NULL, '3-phosphoinositide-dependent protein kinase B', 130, NULL, NULL, 150268),
(150269, '1.50.40.10-FF-000439', NULL, 'Mitochondrial substrate carrier family protein', 165, NULL, NULL, 150269),
(150270, '1.25.10.10-FF-001108', NULL, 'Chromosome 12, whole genome shotgun sequence', 213, NULL, NULL, 150270),
(150271, '3.30.450.190-FF-000024', NULL, 'Rag-type gtp-binding protein', 149, NULL, NULL, 150271),
(150272, '3.40.640.10-FF-000479', NULL, 'Ornithine aminotransferase', 69, NULL, NULL, 150272),
(150273, '3.60.10.10-FF-000365', NULL, 'Uncharacterized protein', 124, NULL, NULL, 150273),
(150274, '1.10.10.1580-FF-000001', NULL, 'interferon regulatory factor 2-binding protein 2', 59, NULL, NULL, 150274),
(150275, '1.20.1070.10-FF-000856', NULL, 'KISS1 receptor b', 112, NULL, NULL, 150275),
(150276, '1.10.10.10-FF-002120', NULL, 'Transcriptional regulator AsnC family', 51, NULL, NULL, 150276),
(150277, '2.30.30.40-FF-000429', NULL, 'Purine-binding chemotaxis protein (CheW)', 56, NULL, NULL, 150277),
(150278, '3.30.160.60-FF-001196', NULL, 'Zinc finger protein 770', 30, NULL, NULL, 150278),
(150279, '4.10.410.20-FF-000001', NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase family member 2', 50, NULL, NULL, 150279),
(150280, '3.10.310.10-FF-000062', NULL, 'Uncharacterized protein', 69, NULL, NULL, 150280),
(150281, '3.10.260.10-FF-000001', NULL, 'APSES transcription factor (MbpA)', 130, NULL, NULL, 150281),
(150282, '3.40.350.10-FF-000024', NULL, 'YFR006W-like protein', 166, NULL, NULL, 150282),
(150283, '1.10.555.10-FF-000109', NULL, 'Rho GTPase-activating protein 19', 250, NULL, NULL, 150283),
(150284, '1.10.150.50-FF-000029', NULL, 'Ephrin type-A receptor 1', 68, NULL, NULL, 150284),
(150285, '1.10.287.130-FF-000045', NULL, 'Two-component system sensor histidine kinase/response regulator', 81, NULL, NULL, 150285),
(150286, '1.20.140.40-FF-000029', NULL, 'Os03g0830800 protein', 150, NULL, NULL, 150286),
(150287, '3.90.1030.10-FF-000010', NULL, 'Mrpl8p', 134, NULL, NULL, 150287),
(150288, '1.25.10.10-FF-003317', NULL, 'Probable ubiquitin fusion degradation protein C12B10.01c', 453, NULL, NULL, 150288),
(150289, '1.20.1250.20-FF-001328', NULL, 'Chromosome 1, whole genome shotgun sequence', 280, NULL, NULL, 150289),
(150290, '3.30.160.60-FF-000268', NULL, 'zinc finger protein 484 isoform X2', 29, NULL, NULL, 150290),
(150291, '3.30.360.20-FF-000024', NULL, NULL, 94, NULL, NULL, 150291),
(150292, '3.30.70.1440-FF-000005', NULL, 'Cation efflux system protein CusA', 103, NULL, NULL, 150292),
(150293, '1.10.510.10-FF-001164', NULL, 'Protein kinase, putative', 286, NULL, NULL, 150293),
(150294, '3.30.160.20-FF-000104', NULL, 'GD20369', 96, NULL, NULL, 150294),
(150295, '6.10.250.3450-FF-000001', NULL, '60S ribosomal protein L35', 46, NULL, NULL, 150295),
(150296, '3.10.20.80-FF-000012', NULL, 'AGAP012309-PA', 74, NULL, NULL, 150296),
(150297, '2.120.10.30-FF-000595', NULL, 'Uncharacterized protein', 97, NULL, NULL, 150297),
(150298, '2.10.25.10-FF-000538', NULL, 'netrin-G1 isoform X1', 57, NULL, NULL, 150298),
(150299, '2.60.40.420-FF-000184', NULL, 'Uncharacterized protein', 124, NULL, NULL, 150299),
(150300, '3.30.420.40-FF-000945', NULL, 'Uncharacterized protein', 41, NULL, NULL, 150300);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(150301, '2.120.10.30-FF-000331', NULL, 'Predicted protein', 129, NULL, NULL, 150301),
(150302, '1.20.58.760-FF-000047', NULL, 'Uncharacterized protein', 200, NULL, NULL, 150302),
(150303, '1.25.40.20-FF-001557', NULL, 'Ankyrin repeat domain 6', 102, NULL, NULL, 150303),
(150304, '2.60.40.10-FF-001600', NULL, 'Neuromusculin, isoform E', 83, NULL, NULL, 150304),
(150305, '3.90.550.10-FF-000247', NULL, 'Gamma subunit', 250, NULL, NULL, 150305),
(150306, '1.10.630.10-FF-000414', NULL, 'Cholesterol side-chain cleavage enzyme, mitochondrial', 295, NULL, NULL, 150306),
(150307, '1.25.10.10-FF-002800', NULL, 'Predicted protein', 208, NULL, NULL, 150307),
(150308, '1.20.1250.20-FF-000811', NULL, 'MFS transporter, putative', 439, NULL, NULL, 150308),
(150309, '3.90.1110.10-FF-000011', NULL, 'DNA-directed RNA polymerase subunit beta', 177, NULL, NULL, 150309),
(150310, '3.30.1120.10-FF-000014', NULL, 'Arylsulfatase family member H', 111, NULL, NULL, 150310),
(150311, '1.20.1730.10-FF-000031', NULL, 'Uncharacterized protein', 522, NULL, NULL, 150311),
(150312, '1.10.10.10-FF-000883', NULL, 'Crp/Fnr family transcriptional regulator', 75, NULL, NULL, 150312),
(150313, '1.10.287.90-FF-000004', NULL, 'Cytochrome c oxidase subunit 2', 110, NULL, NULL, 150313),
(150314, '3.50.50.60-FF-000534', NULL, 'FAD/NAD(P)-binding domain-containing protein', 163, NULL, NULL, 150314),
(150315, '2.170.300.10-FF-000039', NULL, 'Uncharacterized protein', 63, NULL, NULL, 150315),
(150316, '3.30.710.10-FF-000324', NULL, 'Uncharacterized protein', 112, NULL, NULL, 150316),
(150317, '1.20.5.110-FF-000173', NULL, 'Putative syntaxin', 82, NULL, NULL, 150317),
(150318, '3.40.50.1820-FF-001358', NULL, 'Protein bem46', 236, NULL, NULL, 150318),
(150319, '3.40.47.10-FF-000214', NULL, NULL, 153, NULL, NULL, 150319),
(150320, '1.20.5.650-FF-000014', NULL, NULL, 57, NULL, NULL, 150320),
(150321, '3.40.250.10-FF-000168', NULL, 'Sulphate transporter', 98, NULL, NULL, 150321),
(150322, '3.30.160.60-FF-000829', NULL, 'zinc finger protein 510', 28, NULL, NULL, 150322),
(150323, '2.130.10.10-FF-001201', NULL, 'UTP7p Nucleolar protein', 153, NULL, NULL, 150323),
(150324, '3.40.630.10-FF-000506', NULL, 'Uncharacterized protein', 124, NULL, NULL, 150324),
(150325, '3.30.1370.10-FF-000122', NULL, 'Scp160p', 75, NULL, NULL, 150325),
(150326, '1.20.1420.10-FF-000018', NULL, 'Talin', 169, NULL, NULL, 150326),
(150327, '2.170.140.10-FF-000037', NULL, 'RE16222p', 70, NULL, NULL, 150327),
(150328, '3.30.40.10-FF-000025', NULL, 'Histone-lysine N-methyltransferase', 107, NULL, NULL, 150328),
(150329, '2.60.120.200-FF-000543', NULL, 'L-type lectin-domain containing receptor kinase IX.1', 124, NULL, NULL, 150329),
(150330, '1.10.150.530-FF-000025', NULL, 'Radical SAM superfamily protein', 68, NULL, NULL, 150330),
(150331, '2.60.40.10-FF-002117', NULL, 'Twitchin', 83, NULL, NULL, 150331),
(150332, '1.20.120.1750-FF-000142', NULL, 'RBR-type E3 ubiquitin transferase', 217, NULL, NULL, 150332),
(150333, '3.10.390.10-FF-000005', NULL, 'SP140 nuclear body protein', 95, NULL, NULL, 150333),
(150334, '1.20.58.60-FF-000266', NULL, 'Muscle-specific protein 300 kDa, isoform D', 215, NULL, NULL, 150334),
(150335, '1.25.10.10-FF-000855', NULL, 'Coatomer subunit beta', 588, NULL, NULL, 150335),
(150336, '2.60.40.10-FF-004326', NULL, NULL, 87, NULL, NULL, 150336),
(150337, '3.40.50.2300-FF-000474', NULL, 'Vomeronasal 2, receptor 82', 135, NULL, NULL, 150337),
(150338, '1.20.1250.20-FF-001475', NULL, 'Uncharacterized protein, isoform E', 257, NULL, NULL, 150338),
(150339, '3.20.20.190-FF-000054', NULL, 'Phosphoinositide phospholipase C', 179, NULL, NULL, 150339),
(150340, '2.40.50.140-FF-001141', NULL, NULL, 62, NULL, NULL, 150340),
(150341, '1.10.238.10-FF-001059', NULL, 'Uncharacterized protein', 155, NULL, NULL, 150341),
(150342, '3.40.50.1820-FF-000841', NULL, 'Palmitoyl-protein thioesterase-dolichyl pyrophosphate phosphatase fusion 1', 295, NULL, NULL, 150342),
(150343, '3.30.1600.10-FF-000040', NULL, 'Uncharacterized protein', 89, NULL, NULL, 150343),
(150344, '3.90.870.10-FF-000030', NULL, 'Predicted protein', 234, NULL, NULL, 150344); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(150345, '3.30.230.10-FF-000214', NULL, 'Mevalonate kinase', 173, NULL, NULL, 150345),
(150346, '3.20.10.10-FF-000069', NULL, 'Uncharacterized protein', 64, NULL, NULL, 150346),
(150347, '3.30.540.10-FF-000024', NULL, 'Inositol-1-monophosphatase', 142, NULL, NULL, 150347),
(150348, '3.40.1090.10-FF-000042', NULL, 'Patatin-like phospholipase domain-containing 3', 84, NULL, NULL, 150348),
(150349, '1.10.510.10-FF-002653', NULL, NULL, 81, NULL, NULL, 150349),
(150350, '2.60.40.1170-FF-000007', NULL, 'Coatomer subunit delta', 101, NULL, NULL, 150350),
(150351, '1.10.580.10-FF-000033', NULL, 'Citrate synthase', 205, NULL, NULL, 150351),
(150352, '3.40.50.12780-FF-000211', NULL, 'Uncharacterized protein', 196, NULL, NULL, 150352),
(150353, '2.40.10.10-FF-000542', NULL, NULL, 134, NULL, NULL, 150353),
(150354, '1.10.10.10-FF-000175', NULL, 'ATP-dependent DNA helicase RecQ', 182, NULL, NULL, 150354),
(150355, '2.60.120.330-FF-000031', NULL, '2-oxoglutarate (2OG) and Fe(II)-dependent oxygenase superfamily protein', 341, NULL, NULL, 150355),
(150356, '2.10.25.10-FF-001319', NULL, 'Uncharacterized protein', 26, NULL, NULL, 150356),
(150357, '3.40.50.12780-FF-000155', NULL, 'AMP-binding enzyme, putative', 239, NULL, NULL, 150357),
(150358, '1.20.1070.10-FF-000356', NULL, 'Predicted protein', 328, NULL, NULL, 150358),
(150359, '3.60.10.10-FF-000101', NULL, 'Endonuclease/exonuclease/phosphatase family protein', 297, NULL, NULL, 150359),
(150360, '1.25.40.10-FF-004657', NULL, 'Enhanced entry protein enhC, tetratricopeptide repeat family', 229, NULL, NULL, 150360),
(150361, '3.20.20.80-FF-000551', NULL, 'Beta-galactosidase', 224, NULL, NULL, 150361),
(150362, '3.40.50.720-FF-002581', NULL, 'ThiF family protein', 19, NULL, NULL, 150362),
(150363, '3.30.230.10-FF-000158', NULL, 'Galactokinase', 205, NULL, NULL, 150363),
(150364, '3.40.50.1820-FF-000341', NULL, 'Lipase/serine esterase, putative', 194, NULL, NULL, 150364),
(150365, '2.60.40.10-FF-001072', NULL, 'Immunoglobulin heavy variable V1-24', 117, NULL, NULL, 150365),
(150366, '1.10.418.10-FF-000224', NULL, 'Uncharacterized protein', 115, NULL, NULL, 150366),
(150367, '3.90.850.10-FF-000023', NULL, 'Possible bifunctional enzyme: 2-hydroxyhepta-2,4-diene-1,7-dioate isomerase + cyclase/dehydrase', 303, NULL, NULL, 150367),
(150368, '1.10.418.10-FF-000168', NULL, 'Guanine exchange factor for Rac 30', 121, NULL, NULL, 150368),
(150369, '1.10.10.60-FF-000201', NULL, 'MYB proto-oncogene like 2', 52, NULL, NULL, 150369),
(150370, '1.25.10.10-FF-003048', NULL, 'Condensin complex subunit 1', 285, NULL, NULL, 150370),
(150371, '3.10.490.10-FF-000041', NULL, 'AIG2 family protein', 134, NULL, NULL, 150371),
(150372, '1.10.1070.11-FF-000079', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', 140, NULL, NULL, 150372),
(150373, '1.10.286.20-FF-000009', NULL, 'Elongation factor Ts', 28, NULL, NULL, 150373),
(150374, '3.30.1060.10-FF-000020', NULL, NULL, 121, NULL, NULL, 150374),
(150375, '3.90.640.10-FF-000254', NULL, 'Actin-related protein 2', 95, NULL, NULL, 150375),
(150376, '1.10.3450.40-FF-000015', NULL, NULL, 205, NULL, NULL, 150376),
(150377, '2.130.10.10-FF-004922', NULL, 'Pre-rRNA-processing protein crb3/ipi3', 107, NULL, NULL, 150377),
(150378, '3.10.110.10-FF-000081', NULL, 'E3 ubiquitin-protein ligase FANCL', 88, NULL, NULL, 150378),
(150379, '1.10.1740.140-FF-000006', NULL, NULL, 82, NULL, NULL, 150379),
(150380, '1.10.238.10-FF-000603', NULL, 'Calcium-binding protein CP1', 63, NULL, NULL, 150380),
(150381, '3.40.50.300-FF-007334', NULL, 'Uncharacterized protein', 143, NULL, NULL, 150381),
(150382, '1.10.630.10-FF-000206', NULL, 'Uncharacterized protein', 144, NULL, NULL, 150382),
(150383, '3.40.50.720-FF-002053', NULL, 'Uncharacterized protein', 173, NULL, NULL, 150383),
(150384, '3.40.50.1820-FF-000285', NULL, 'Alpha/beta-Hydrolases superfamily protein', 268, NULL, NULL, 150384),
(150385, '3.30.70.330-FF-000907', NULL, 'U2 splicing auxiliary factor, putative', 103, NULL, NULL, 150385),
(150386, '3.40.50.1360-FF-000006', NULL, 'Glucitol operon repressor', 159, NULL, NULL, 150386);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(150387, '1.25.10.10-FF-002536', NULL, 'Armadillo repeat-containing protein 10', 184, NULL, NULL, 150387),
(150388, '3.90.190.10-FF-000348', NULL, 'Dual specificity protein phosphatase', 158, NULL, NULL, 150388),
(150389, '3.40.50.300-FF-004580', NULL, 'ATP-dependent 3''-5'' DNA helicase', 189, NULL, NULL, 150389),
(150390, '2.40.160.20-FF-000033', NULL, 'Outer membrane protein, putative', 185, NULL, NULL, 150390),
(150391, '2.40.50.40-FF-000031', NULL, 'Heterochromatin protein 1', 66, NULL, NULL, 150391),
(150392, '3.40.630.190-FF-000001', NULL, 'LytR family transcriptional regulator', 291, NULL, NULL, 150392),
(150393, '1.10.8.60-FF-000037', NULL, 'Sigma-54-dependent Fis family transcriptional regulator', 77, NULL, NULL, 150393),
(150394, '3.80.10.10-FF-003692', NULL, 'Uncharacterized protein', 176, NULL, NULL, 150394),
(150395, '2.60.40.150-FF-000524', NULL, 'Phosphoinositide phospholipase C', 164, NULL, NULL, 150395),
(150396, '1.25.40.20-FF-000332', NULL, 'Ankyrin repeat family A protein', 162, NULL, NULL, 150396),
(150397, '3.40.850.10-FF-000461', NULL, 'Uncharacterized protein', 373, NULL, NULL, 150397),
(150398, '2.60.120.10-FF-000416', NULL, 'Uncharacterized protein', 140, NULL, NULL, 150398),
(150399, '1.10.510.10-FF-002176', NULL, 'CAMK family protein kinase', 278, NULL, NULL, 150399),
(150400, '4.10.240.10-FF-000103', NULL, 'WGS project CABT00000000 data, contig 2.54', 28, NULL, NULL, 150400),
(150401, '1.20.5.110-FF-000257', NULL, 'Syntaxin 2', 76, NULL, NULL, 150401),
(150402, '1.20.1560.10-FF-000528', NULL, 'ABC transporter B family member 15', 25, NULL, NULL, 150402),
(150403, '3.40.50.300-FF-005092', NULL, 'Uncharacterized protein', 37, NULL, NULL, 150403),
(150404, '3.40.50.700-FF-000006', NULL, NULL, 182, NULL, NULL, 150404),
(150405, '2.60.40.10-FF-005254', NULL, NULL, 114, NULL, NULL, 150405),
(150406, '3.30.190.20-FF-000016', NULL, 'Ribosomal L1 domain-containing 1-like 1', 73, NULL, NULL, 150406),
(150407, '3.30.1520.10-FF-000062', NULL, 'Bud emergence protein', 155, NULL, NULL, 150407),
(150408, '3.30.160.60-FF-002769', NULL, 'GM23757', 52, NULL, NULL, 150408),
(150409, '1.10.510.10-FF-001664', NULL, 'CAMK protein kinase', 135, NULL, NULL, 150409),
(150410, '2.120.10.30-FF-000415', NULL, 'Low density lipoprotein receptor-related protein 1Aa', 184, NULL, NULL, 150410),
(150411, '3.30.40.10-FF-001537', NULL, 'RING-finger domain protein, putative (AFU_orthologue AFUA_5G14845)', 63, NULL, NULL, 150411),
(150412, '3.40.50.720-FF-001097', NULL, 'NADH dehydrogenase', 301, NULL, NULL, 150412),
(150413, '1.20.1250.20-FF-001559', NULL, 'Solute carrier organic anion transporter family member', 397, NULL, NULL, 150413),
(150414, '2.120.10.30-FF-000359', NULL, 'Predicted protein', 92, NULL, NULL, 150414),
(150415, '3.30.450.40-FF-000273', NULL, 'Sensory transduction histidine kinase', 165, NULL, NULL, 150415),
(150416, '3.30.450.20-FF-000531', NULL, 'Uncharacterized protein', 151, NULL, NULL, 150416),
(150417, '3.30.70.3490-FF-000018', NULL, 'Unplaced genomic scaffold supercont1.15, whole genome shotgun sequence', 84, NULL, NULL, 150417),
(150418, '3.30.460.10-FF-000023', NULL, 'CCA tRNA nucleotidyltransferase 1, mitochondrial', 152, NULL, NULL, 150418),
(150419, '1.25.40.10-FF-004218', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 42, NULL, NULL, 150419),
(150420, '1.20.910.10-FF-000023', NULL, 'TenA family transcriptional activator-like protein', 228, NULL, NULL, 150420),
(150421, '1.20.1280.150-FF-000001', NULL, 'Genome polyprotein', 73, NULL, NULL, 150421),
(150422, '3.40.50.300-FF-006434', NULL, 'Uncharacterized protein', 127, NULL, NULL, 150422),
(150423, '4.10.280.10-FF-000049', NULL, 'MAX isoform 16', 80, NULL, NULL, 150423),
(150424, '2.40.50.140-FF-000921', NULL, NULL, 86, NULL, NULL, 150424),
(150425, '2.30.29.30-FF-000474', NULL, 'AGC/RSK/RSKP90 protein kinase', 105, NULL, NULL, 150425),
(150426, '3.30.70.1230-FF-000032', NULL, 'Adenylyl cyclase 78C', 204, NULL, NULL, 150426),
(150427, '1.10.760.10-FF-000075', NULL, 'Probable Methylamine utilization protein mauG', 118, NULL, NULL, 150427); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(150428, '2.30.30.40-FF-000165', NULL, 'dynamin-binding protein isoform X1', 68, NULL, NULL, 150428),
(150429, '2.30.29.230-FF-000017', NULL, 'Predicted protein', 173, NULL, NULL, 150429),
(150430, '1.10.287.70-FF-000234', NULL, 'TWiK family of potassium channels', 295, NULL, NULL, 150430),
(150431, '2.130.10.10-FF-003141', NULL, 'Coatomer subunit alpha', 237, NULL, NULL, 150431),
(150432, '1.25.40.10-FF-002364', NULL, 'HCF152', 108, NULL, NULL, 150432),
(150433, '2.130.10.10-FF-003085', NULL, 'mRNA export factor', 96, NULL, NULL, 150433),
(150434, '3.30.420.40-FF-000445', NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', 191, NULL, NULL, 150434),
(150435, '1.10.630.10-FF-000678', NULL, 'Uncharacterized protein', 164, NULL, NULL, 150435),
(150436, '2.60.40.10-FF-002325', NULL, 'Semaphorin 4D', 73, NULL, NULL, 150436),
(150437, '3.90.132.10-FF-000006', NULL, 'GP63-like', 128, NULL, NULL, 150437),
(150438, '3.30.920.10-FF-000014', NULL, 'Frataxin, mitochondrial', 120, NULL, NULL, 150438),
(150439, '1.10.940.10-FF-000016', NULL, 'Ribosomal RNA small subunit methyltransferase B', 141, NULL, NULL, 150439),
(150440, '1.10.455.10-FF-000017', NULL, '40S ribosomal protein S5', 185, NULL, NULL, 150440),
(150441, '3.40.50.300-FF-000302', NULL, 'ATP-binding cassette subfamily B member 5', 248, NULL, NULL, 150441),
(150442, '3.30.1680.10-FF-000016', NULL, 'Putative Semaphorin-6B', 58, NULL, NULL, 150442),
(150443, '3.30.900.10-FF-000007', NULL, 'Autophagy-related protein 13a', 202, NULL, NULL, 150443),
(150444, '1.20.1250.60-FF-000003', NULL, 'Interferon lambda1', 153, NULL, NULL, 150444),
(150445, '1.20.120.430-FF-000026', NULL, 'Uncharacterized protein', 97, NULL, NULL, 150445),
(150446, '2.120.10.30-FF-000095', NULL, 'Uncharacterized protein', 131, NULL, NULL, 150446),
(150447, '1.10.860.10-FF-000015', NULL, 'Putative replicative DNA helicase', 173, NULL, NULL, 150447),
(150448, '1.20.1310.10-FF-000072', NULL, 'Cullin-like protein-like protein', 120, NULL, NULL, 150448),
(150449, '3.30.40.10-FF-000233', NULL, 'RING-H2 finger protein ATL54', 74, NULL, NULL, 150449),
(150450, '1.10.8.1080-FF-000003', NULL, 'N-acetylmuramic acid 6-phosphate etherase', 58, NULL, NULL, 150450),
(150451, '3.40.47.10-FF-000006', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase I', 254, NULL, NULL, 150451),
(150452, '3.90.1480.20-FF-000007', NULL, 'Type 2 lactosamine alpha-2,3-sialyltransferase', 242, NULL, NULL, 150452),
(150453, '3.40.50.2000-FF-000266', NULL, 'ALG2, alpha-1,3/1,6-mannosyltransferase', 214, NULL, NULL, 150453),
(150454, '3.30.70.270-FF-000131', NULL, 'Related to DNA repair protein MUS-42', 117, NULL, NULL, 150454),
(150455, '3.40.50.300-FF-002539', NULL, 'RNA helicase', 227, NULL, NULL, 150455),
(150456, '2.60.40.60-FF-001093', NULL, 'Predicted protein', 106, NULL, NULL, 150456),
(150457, '3.40.50.150-FF-001640', NULL, NULL, 233, NULL, NULL, 150457),
(150458, '1.10.10.60-FF-001185', NULL, NULL, 95, NULL, NULL, 150458),
(150459, '1.25.40.10-FF-000003', NULL, 'kinesin light chain isoform X1', 306, NULL, NULL, 150459),
(150460, '2.130.10.10-FF-001196', NULL, 'WD repeat protein (AFU_orthologue AFUA_1G12380)', 187, NULL, NULL, 150460),
(150461, '2.130.10.10-FF-004427', NULL, 'Uncharacterized protein', 436, NULL, NULL, 150461),
(150462, '3.30.200.20-FF-001648', NULL, 'Protein CBG05171', 88, NULL, NULL, 150462),
(150463, '3.30.2140.20-FF-000024', NULL, 'Uncharacterized protein', 177, NULL, NULL, 150463),
(150464, '3.30.70.330-FF-001571', NULL, NULL, 138, NULL, NULL, 150464),
(150465, '1.10.10.2840-FF-000003', NULL, 'PucR family transcriptional regulator', 132, NULL, NULL, 150465),
(150466, '3.40.640.10-FF-000535', NULL, 'Uncharacterized protein', 54, NULL, NULL, 150466),
(150467, '3.40.50.1820-FF-001589', NULL, 'Uncharacterized protein', 90, NULL, NULL, 150467),
(150468, '3.30.470.20-FF-000061', NULL, 'D-alanine-D-alanine ligase family', 184, NULL, NULL, 150468),
(150469, '3.40.50.11370-FF-000007', NULL, 'Inositol-tetrakisphosphate 1-kinase', 118, NULL, NULL, 150469),
(150470, '2.60.120.10-FF-000040', NULL, 'rap guanine nucleotide exchange factor 6 isoform X1', 119, NULL, NULL, 150470); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(150471, '2.60.120.200-FF-000127', NULL, 'Laminin subunit alpha 1', 164, NULL, NULL, 150471),
(150472, '2.60.40.10-FF-005607', NULL, NULL, 106, NULL, NULL, 150472),
(150473, '3.40.630.30-FF-000580', NULL, 'Uncharacterized protein', 96, NULL, NULL, 150473),
(150474, '1.20.58.60-FF-000035', NULL, 'Spectrin alpha chain, non-erythrocytic 1', 118, NULL, NULL, 150474),
(150475, '3.40.50.300-FF-005445', NULL, 'Uncharacterized protein', 250, NULL, NULL, 150475),
(150476, '1.25.10.10-FF-002272', NULL, 'Uncharacterized protein', 340, NULL, NULL, 150476),
(150477, '2.60.40.10-FF-000408', NULL, 'Fibroblast growth factor receptor', 91, NULL, NULL, 150477),
(150478, '3.30.160.60-FF-005208', NULL, NULL, 86, NULL, NULL, 150478),
(150479, '1.25.40.10-FF-003353', NULL, 'Putative pentatricopeptide repeat-containing protein At3g16890, mitochondrial', 75, NULL, NULL, 150479),
(150480, '1.25.40.90-FF-000100', NULL, '50S ribosome-binding GTPase', 138, NULL, NULL, 150480),
(150481, '3.80.10.10-FF-000763', NULL, 'cDNA clone:J023048C13, full insert sequence', 147, NULL, NULL, 150481),
(150482, '2.30.30.100-FF-000177', NULL, 'Small nuclear ribonucleoprotein E', 83, NULL, NULL, 150482),
(150483, '3.90.70.10-FF-000654', NULL, 'Uncharacterized protein', 83, NULL, NULL, 150483),
(150484, '3.30.450.20-FF-000054', NULL, 'Trachealess, isoform D', 129, NULL, NULL, 150484),
(150485, '3.30.70.2760-FF-000007', NULL, NULL, 130, NULL, NULL, 150485),
(150486, '2.160.20.10-FF-000026', NULL, 'Exo-beta-1,3-glucanase Exg0', 346, NULL, NULL, 150486),
(150487, '2.30.180.10-FF-000112', NULL, NULL, 138, NULL, NULL, 150487),
(150488, '3.40.190.290-FF-000093', NULL, 'LysR family transcriptional regulator', 197, NULL, NULL, 150488),
(150489, '3.90.245.10-FF-000021', NULL, 'Purine nucleosidase, putative (IunH-2)', 306, NULL, NULL, 150489),
(150490, '3.80.10.10-FF-001275', NULL, 'Protein CBG01587', 155, NULL, NULL, 150490),
(150491, '2.60.40.10-FF-002797', NULL, 'Interferon gamma receptor 2 (interferon gamma transducer 1), gene 2', 201, NULL, NULL, 150491),
(150492, '2.30.29.30-FF-000530', NULL, 'Spermitin, isoform B', 133, NULL, NULL, 150492),
(150493, '2.30.22.10-FF-000014', NULL, 'Protein GrpE', 58, NULL, NULL, 150493),
(150494, '3.40.50.300-FF-001174', NULL, 'ABC transporter family protein-like', 241, NULL, NULL, 150494),
(150495, '2.60.40.10-FF-001336', NULL, 'V-set pre-B cell surrogate light chain 3', 103, NULL, NULL, 150495),
(150496, '3.40.50.2300-FF-000558', NULL, 'Uncharacterized protein', 262, NULL, NULL, 150496),
(150497, '3.50.4.10-FF-000032', NULL, 'NOmpA Homolog (Drosophila nompA: no mechanoreceptor potential A)', 79, NULL, NULL, 150497),
(150498, '1.10.1900.40-FF-000010', NULL, NULL, 108, NULL, NULL, 150498),
(150499, '3.40.50.300-FF-001235', NULL, 'ATP binding cassette subfamily A member 7', 258, NULL, NULL, 150499),
(150500, '3.30.1370.10-FF-000206', NULL, 'Uncharacterized protein', 60, NULL, NULL, 150500),
(150501, '3.40.50.300-FF-000774', NULL, 'ATP-dependent RNA helicase', 260, NULL, NULL, 150501),
(150502, '2.70.170.10-FF-000226', NULL, 'Uncharacterized protein', 94, NULL, NULL, 150502),
(150503, '2.40.330.10-FF-000004', NULL, 'B3 domain-containing transcription factor vrn1', 121, NULL, NULL, 150503),
(150504, '1.20.1280.290-FF-000110', NULL, 'Cation-transporting ATPase', 91, NULL, NULL, 150504),
(150505, '3.30.710.10-FF-000296', NULL, 'Uncharacterized protein', 127, NULL, NULL, 150505),
(150506, '1.25.40.90-FF-000044', NULL, 'Putative clathrin assembly protein', 142, NULL, NULL, 150506),
(150507, '1.20.1510.10-FF-000020', NULL, 'zinc transporter 10', 214, NULL, NULL, 150507),
(150508, '2.90.10.10-FF-000012', NULL, 'Serine/threonine-protein kinase', 132, NULL, NULL, 150508),
(150509, '1.10.1170.10-FF-000046', NULL, 'Uncharacterized protein', 73, NULL, NULL, 150509),
(150510, '3.40.50.11350-FF-000001', NULL, 'Alpha-(1,6)-fucosyltransferase', 157, NULL, NULL, 150510),
(150511, '2.10.25.10-FF-000010', NULL, 'Pro-epidermal growth factor', 41, NULL, NULL, 150511),
(150512, '3.20.20.70-FF-000222', NULL, 'Raffinose synthase Sip1 protein', 308, NULL, NULL, 150512);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(150513, '2.40.250.10-FF-000003', NULL, 'BROther (Drosophila tx factor partner) homolog', 126, NULL, NULL, 150513),
(150514, '2.30.42.10-FF-000021', NULL, 'Glutamate receptor interacting protein 1', 99, NULL, NULL, 150514),
(150515, '1.20.58.60-FF-000530', NULL, 'Uncharacterized protein', 198, NULL, NULL, 150515),
(150516, '3.40.50.300-FF-002163', NULL, 'Replicative DNA helicase', 279, NULL, NULL, 150516),
(150517, '1.50.10.130-FF-000001', NULL, 'Isoprene synthase, chloroplastic', 164, NULL, NULL, 150517),
(150518, '1.10.40.30-FF-000014', NULL, 'Argininosuccinate lyase', 34, NULL, NULL, 150518),
(150519, '2.60.220.50-FF-000149', NULL, 'Uncharacterized protein', 185, NULL, NULL, 150519),
(150520, '3.30.1360.10-FF-000032', NULL, 'DNA-directed RNA polymerase II subunit RPB11', 119, NULL, NULL, 150520),
(150521, '3.50.50.60-FF-000618', NULL, 'FAD/NAD(P)-binding oxidoreductase family protein', 269, NULL, NULL, 150521),
(150522, '3.40.50.10490-FF-000030', NULL, '30S ribosomal protein S2', 198, NULL, NULL, 150522),
(150523, '2.60.200.10-FF-000041', NULL, 'BMP signal transducer Smad1', 50, NULL, NULL, 150523),
(150524, '1.20.1250.20-FF-001183', NULL, 'Xyloside transporter XynT', 201, NULL, NULL, 150524),
(150525, '2.40.30.10-FF-000448', NULL, 'Uncharacterized protein', 74, NULL, NULL, 150525),
(150526, '3.30.200.20-FF-001704', NULL, NULL, 53, NULL, NULL, 150526),
(150527, '2.20.28.120-FF-000008', NULL, 'Apicoplast ribosomal protein L33', 59, NULL, NULL, 150527),
(150528, '4.10.520.10-FF-000029', NULL, NULL, 92, NULL, NULL, 150528),
(150529, '3.80.10.10-FF-004506', NULL, 'Putative inactive leucine-rich repeat receptor-like protein kinase', 323, NULL, NULL, 150529),
(150530, '2.40.30.10-FF-000072', NULL, 'translation initiation factor IF-2, mitochondrial isoform X1', 93, NULL, NULL, 150530),
(150531, '3.50.50.60-FF-001254', NULL, 'Uncharacterized protein', 132, NULL, NULL, 150531),
(150532, '3.30.565.10-FF-000199', NULL, 'Signal transduction histidine kinase', 133, NULL, NULL, 150532),
(150533, '2.130.10.10-FF-002505', NULL, 'Nucleoporin, putative', 395, NULL, NULL, 150533),
(150534, '1.25.40.10-FF-002892', NULL, 'Leucine-rich PPR motif-containing protein, mitochondrial', 215, NULL, NULL, 150534),
(150535, '3.20.20.80-FF-000074', NULL, 'Hydrolase, hydrolyzing O-glycosyl compounds', 339, NULL, NULL, 150535),
(150536, '3.30.1330.20-FF-000033', NULL, 'Tubulin alpha chain', 116, NULL, NULL, 150536),
(150537, '1.25.40.10-FF-001728', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 159, NULL, NULL, 150537),
(150538, '2.40.30.170-FF-000072', NULL, NULL, 97, NULL, NULL, 150538),
(150539, '3.30.420.40-FF-001081', NULL, 'Pantothenate kinase 2', 124, NULL, NULL, 150539),
(150540, '3.30.1360.170-FF-000018', NULL, 'Flavin-dependent thymidylate synthase', 58, NULL, NULL, 150540),
(150541, '3.40.50.1440-FF-000148', NULL, 'Phage tubulin-like protein', 295, NULL, NULL, 150541),
(150542, '3.40.50.300-FF-007070', NULL, 'Putative arsenical pump-driving ATPase 2', 297, NULL, NULL, 150542),
(150543, '3.90.180.10-FF-000174', NULL, 'Uncharacterized protein', 31, NULL, NULL, 150543),
(150544, '1.10.10.10-FF-001428', NULL, 'Uncharacterized protein', 104, NULL, NULL, 150544),
(150545, '2.40.50.90-FF-000052', NULL, 'Nuclease domain-containing protein 1', 168, NULL, NULL, 150545),
(150546, '3.90.79.10-FF-000235', NULL, 'ADP-ribose pyrophosphatase, putative', 206, NULL, NULL, 150546),
(150547, '1.10.400.10-FF-000077', NULL, 'G-protein alpha subunit, putative', 116, NULL, NULL, 150547),
(150548, '1.10.10.10-FF-000939', NULL, 'ATP-dependent DNA helicase RecQ', 177, NULL, NULL, 150548),
(150549, '2.60.40.10-FF-000936', NULL, 'Uncharacterized protein, isoform C', 101, NULL, NULL, 150549),
(150550, '2.30.30.100-FF-000121', NULL, 'Small nuclear ribonucleoprotein F', 45, NULL, NULL, 150550),
(150551, '3.40.50.2300-FF-000182', NULL, 'RNA polymerase II subunit A', 124, NULL, NULL, 150551),
(150552, '3.40.50.720-FF-001889', NULL, 'Pyrroline-5-carboxylate reductase', 159, NULL, NULL, 150552),
(150553, '3.30.980.10-FF-000023', NULL, 'Threonyl-tRNA synthetase', 95, NULL, NULL, 150553);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(150554, '3.40.50.1450-FF-000005', NULL, 'Hydrogenase maturation protease HycI', 153, NULL, NULL, 150554),
(150555, '2.130.10.10-FF-004866', NULL, 'Ribosome biogenesis protein BOP1 homolog', 123, NULL, NULL, 150555),
(150556, '3.40.50.150-FF-001201', NULL, NULL, 223, NULL, NULL, 150556),
(150557, '1.25.40.20-FF-001265', NULL, 'Uncharacterized protein', 198, NULL, NULL, 150557),
(150558, '1.10.10.60-FF-000673', NULL, 'Two-component system sensor histidine kinase', 59, NULL, NULL, 150558),
(150559, '2.130.10.10-FF-000684', NULL, 'PRA1 family protein', 231, NULL, NULL, 150559),
(150560, '1.20.1740.10-FF-000149', NULL, 'Uncharacterized protein', 275, NULL, NULL, 150560),
(150561, '3.40.50.300-FF-004956', NULL, 'Multidrug resistance protein homolog, putative', 145, NULL, NULL, 150561),
(150562, '2.10.110.10-FF-000028', NULL, 'LIM domain-containing protein 1', 63, NULL, NULL, 150562),
(150563, '2.40.10.10-FF-000065', NULL, 'Urokinase-type plasminogen activator', 128, NULL, NULL, 150563),
(150564, '2.40.50.140-FF-000449', NULL, 'Unplaced genomic scaffold supercont1.202, whole genome shotgun sequence', 117, NULL, NULL, 150564),
(150565, '2.20.28.10-FF-000022', NULL, 'DNA helicase', 59, NULL, NULL, 150565),
(150566, '3.40.50.2300-FF-001194', NULL, NULL, 154, NULL, NULL, 150566),
(150567, '3.60.90.10-FF-000016', NULL, 'S-adenosylmethionine decarboxylase proenzyme', 294, NULL, NULL, 150567),
(150568, '2.30.29.30-FF-000035', NULL, 'Disabled homolog 2 isoform 1', 158, NULL, NULL, 150568),
(150569, '1.10.600.10-FF-000058', NULL, 'Protein CBG02872', 275, NULL, NULL, 150569),
(150570, '2.70.40.10-FF-000003', NULL, 'dCTP deaminase', 193, NULL, NULL, 150570),
(150571, '2.60.40.1260-FF-000006', NULL, 'Lamin, isoform B', 151, NULL, NULL, 150571),
(150572, '2.60.40.1150-FF-000001', NULL, 'AP complex subunit beta', 117, NULL, NULL, 150572),
(150573, '2.60.40.2860-FF-000025', NULL, 'Transmission-blocking target antigen Pfs230', 125, NULL, NULL, 150573),
(150574, '1.20.5.110-FF-000201', NULL, 'Uncharacterized protein', 64, NULL, NULL, 150574),
(150575, '3.30.780.10-FF-000042', NULL, 'Protein translation factor SUI1-like protein', 92, NULL, NULL, 150575),
(150576, '3.40.30.10-FF-000322', NULL, 'Probable glutathione S-transferase', 81, NULL, NULL, 150576),
(150577, '3.40.50.1390-FF-000021', NULL, 'Integrase', 141, NULL, NULL, 150577),
(150578, '1.10.10.10-FF-002092', NULL, 'Uncharacterized protein', 63, NULL, NULL, 150578),
(150579, '2.60.40.10-FF-004742', NULL, NULL, 126, NULL, NULL, 150579),
(150580, '3.40.50.200-FF-000042', NULL, 'Proprotein convertase subtilisin/kexin type 5', 157, NULL, NULL, 150580),
(150581, '3.30.160.60-FF-001521', NULL, 'zinc finger protein 90 homolog', 27, NULL, NULL, 150581),
(150582, '2.170.120.20-FF-000011', NULL, 'Ribosomal protein L25, Ctc-form', 87, NULL, NULL, 150582),
(150583, '3.90.226.10-FF-000005', NULL, 'Acetyl-CoA carboxylase 1', 262, NULL, NULL, 150583),
(150584, '3.50.40.10-FF-000007', NULL, 'YALI0E22979p', 212, NULL, NULL, 150584),
(150585, '2.20.70.10-FF-000209', NULL, 'WW domain containing protein, putative', 34, NULL, NULL, 150585),
(150586, '2.30.230.10-FF-000021', NULL, 'AGAP002032-PA', 212, NULL, NULL, 150586),
(150587, '1.10.600.10-FF-000002', NULL, 'Octaprenyl diphosphate synthase', 324, NULL, NULL, 150587),
(150588, '3.30.160.60-FF-004394', NULL, NULL, 38, NULL, NULL, 150588),
(150589, '2.60.40.60-FF-001098', NULL, 'Cadherin 22', 113, NULL, NULL, 150589),
(150590, '3.40.30.10-FF-001278', NULL, 'Uncharacterized protein', 129, NULL, NULL, 150590),
(150591, '3.40.50.150-FF-000712', NULL, 'Phosphoethanolamine MethylTransferase', 250, NULL, NULL, 150591),
(150592, '1.25.40.10-FF-003729', NULL, 'Pentatricopeptide repeat-containing protein At5g62370', 146, NULL, NULL, 150592),
(150593, '1.10.1370.10-FF-000027', NULL, 'Thimet oligopeptidase 1', 133, NULL, NULL, 150593),
(150594, '3.10.20.90-FF-000925', NULL, 'Uncharacterized protein', 82, NULL, NULL, 150594),
(150595, '2.10.110.10-FF-000180', NULL, 'GM16078', 60, NULL, NULL, 150595),
(150596, '3.90.470.10-FF-000010', NULL, '60S ribosomal protein L17', 181, NULL, NULL, 150596);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(150597, '3.30.160.60-FF-003882', NULL, 'GD15780', 60, NULL, NULL, 150597),
(150598, '3.30.420.140-FF-000014', NULL, 'Putative pre-16S rRNA nuclease', 138, NULL, NULL, 150598),
(150599, '2.10.25.10-FF-001443', NULL, 'Laminin subunit alpha-1-like Protein', 46, NULL, NULL, 150599),
(150600, '3.10.20.90-FF-000869', NULL, 'Uncharacterized protein', 69, NULL, NULL, 150600),
(150601, '3.30.2090.10-FF-000022', NULL, 'Multidrug resistance protein, putative', 89, NULL, NULL, 150601),
(150602, '3.90.1150.10-FF-000160', NULL, 'Similar to aspartate aminotransferase', 55, NULL, NULL, 150602),
(150603, '1.10.640.10-FF-000004', NULL, 'Dual oxidase 2', 557, NULL, NULL, 150603),
(150604, '1.20.1250.20-FF-001975', NULL, 'Chromosome 1, whole genome shotgun sequence', 398, NULL, NULL, 150604),
(150605, '1.10.2000.10-FF-000006', NULL, 'Frizzled-3 protein', 120, NULL, NULL, 150605),
(150606, '3.30.450.20-FF-000059', NULL, 'PAS domain containing serine/threonine kinase', 111, NULL, NULL, 150606),
(150607, '3.30.300.30-FF-000113', NULL, 'Nonribosomal peptide synthase, putative', 124, NULL, NULL, 150607),
(150608, '3.40.50.150-FF-001168', NULL, NULL, 208, NULL, NULL, 150608),
(150609, '1.20.58.2220-FF-000051', NULL, 'Formin-like 2b', 183, NULL, NULL, 150609),
(150610, '3.10.580.10-FF-000104', NULL, 'Chloride channel protein', 96, NULL, NULL, 150610),
(150611, '3.20.140.10-FF-000001', NULL, 'Nicotinate phosphoribosyltransferase', 400, NULL, NULL, 150611),
(150612, '3.30.40.10-FF-000609', NULL, 'RING-H2 finger protein ATL1', 88, NULL, NULL, 150612),
(150613, '1.20.5.170-FF-000292', NULL, 'JunB proto-oncogene, AP-1 transcription factor subunit a', 37, NULL, NULL, 150613),
(150614, '1.10.510.10-FF-003581', NULL, NULL, 213, NULL, NULL, 150614),
(150615, '2.60.40.60-FF-000642', NULL, 'AGAP004166-PA', 90, NULL, NULL, 150615),
(150616, '3.30.70.330-FF-001099', NULL, 'Putative RNA-binding protein', 152, NULL, NULL, 150616),
(150617, '1.10.472.80-FF-000078', NULL, 'Uncharacterized protein', 145, NULL, NULL, 150617),
(150618, '1.10.560.10-FF-000150', NULL, 'Uncharacterized protein', 160, NULL, NULL, 150618),
(150619, '1.10.8.60-FF-000453', NULL, 'Lon protease homolog 2, peroxisomal', 88, NULL, NULL, 150619),
(150620, '3.20.10.10-FF-000013', NULL, 'Branched-chain-amino-acid aminotransferase', 171, NULL, NULL, 150620),
(150621, '3.30.70.660-FF-000006', NULL, 'tRNA pseudouridine synthase', 158, NULL, NULL, 150621),
(150622, '1.10.287.130-FF-000253', NULL, 'Two component signal transduction system histidine kinase', 119, NULL, NULL, 150622),
(150623, '3.30.9.10-FF-000228', NULL, 'Predicted protein', 106, NULL, NULL, 150623),
(150624, '3.40.50.720-FF-001125', NULL, 'NAD-binding Rossmann fold oxidoreductase', 151, NULL, NULL, 150624),
(150625, '3.40.50.300-FF-003175', NULL, 'Dynein heavy chain, cytoplasmic', 128, NULL, NULL, 150625),
(150626, '1.10.1450.10-FF-000028', NULL, 'Tetraspanin', 111, NULL, NULL, 150626),
(150627, '3.20.20.80-FF-000079', NULL, 'Alpha-amylase', 214, NULL, NULL, 150627),
(150628, '1.25.10.10-FF-001608', NULL, 'Uncharacterized protein', 969, NULL, NULL, 150628),
(150629, '1.20.1070.10-FF-001284', NULL, 'Serpentine Receptor, class TX', 301, NULL, NULL, 150629),
(150630, '3.40.50.150-FF-001696', NULL, NULL, 85, NULL, NULL, 150630),
(150631, '3.40.1110.10-FF-000062', NULL, 'Phospholipid-transporting ATPase', 174, NULL, NULL, 150631),
(150632, '3.10.20.410-FF-000010', NULL, 'Outer membrane usher protein SfmD', 129, NULL, NULL, 150632),
(150633, '1.20.1250.20-FF-000311', NULL, 'Protein NRT1/ PTR FAMILY 5.8', 540, NULL, NULL, 150633),
(150634, '3.90.105.10-FF-000011', NULL, 'Molybdopterin molybdenumtransferase', 56, NULL, NULL, 150634),
(150635, '3.30.50.10-FF-000054', NULL, 'Transcription factor elt-1', 51, NULL, NULL, 150635),
(150636, '1.10.520.10-FF-000001', NULL, 'Peroxidase', 155, NULL, NULL, 150636),
(150637, '2.60.40.10-FF-003814', NULL, NULL, 104, NULL, NULL, 150637),
(150638, '2.40.70.10-FF-000102', NULL, 'YALI0C10923p', 166, NULL, NULL, 150638),
(150639, '1.25.10.10-FF-000647', NULL, 'Nucleolar protein 9', 213, NULL, NULL, 150639);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(150640, '3.40.190.10-FF-000253', NULL, 'Peptide ABC transporter substrate-binding protein', 131, NULL, NULL, 150640),
(150641, '3.50.50.80-FF-000012', NULL, NULL, 109, NULL, NULL, 150641),
(150642, '3.30.200.20-FF-002340', NULL, 'Mitochondrial ribosomal protein L27', 63, NULL, NULL, 150642),
(150643, '2.40.30.160-FF-000007', NULL, 'Putative transferase CAF17, mitochondrial', 81, NULL, NULL, 150643),
(150644, '3.30.420.10-FF-000369', NULL, NULL, 213, NULL, NULL, 150644),
(150645, '2.40.50.140-FF-000977', NULL, NULL, 79, NULL, NULL, 150645),
(150646, '1.10.472.80-FF-000134', NULL, 'Rab GTPase activating protein, putative', 143, NULL, NULL, 150646),
(150647, '1.10.1200.270-FF-000036', NULL, 'Uncharacterized protein', 40, NULL, NULL, 150647),
(150648, '2.40.70.10-FF-000574', NULL, NULL, 78, NULL, NULL, 150648),
(150649, '3.30.497.10-FF-000153', NULL, 'Uncharacterized protein', 54, NULL, NULL, 150649),
(150650, '2.130.10.10-FF-002685', NULL, 'WD-repeat protein, putative', 471, NULL, NULL, 150650),
(150651, '3.30.70.330-FF-000879', NULL, 'Splicing factor U2af large subunit A', 115, NULL, NULL, 150651),
(150652, '2.170.8.10-FF-000014', NULL, 'Phosphoenolpyruvate carboxykinase [GTP]', 107, NULL, NULL, 150652),
(150653, '3.40.720.10-FF-000160', NULL, 'Arylsulfatase A', 359, NULL, NULL, 150653),
(150654, '2.130.10.10-FF-002449', NULL, 'Uncharacterized protein, isoform B', 143, NULL, NULL, 150654),
(150655, '1.10.1750.10-FF-000017', NULL, 'Chromosomal replication initiator protein DnaA', 109, NULL, NULL, 150655),
(150656, '3.30.1360.10-FF-000060', NULL, 'RNA polymerase Rpb3/Rpb11 dimerisation domain containing protein', 109, NULL, NULL, 150656),
(150657, '1.20.1260.10-FF-000039', NULL, 'Ferritin', 175, NULL, NULL, 150657),
(150658, '3.40.50.1240-FF-000116', NULL, 'Fructose-2,6-bisphosphatase TIGAR B', 265, NULL, NULL, 150658),
(150659, '1.50.10.150-FF-000007', NULL, 'Sulfite efflux pump SSU1', 412, NULL, NULL, 150659),
(150660, '1.10.1240.30-FF-000001', NULL, 'Phosphoserine phosphatase RsbU', 84, NULL, NULL, 150660),
(150661, '2.130.10.10-FF-005411', NULL, 'BEACH domain-containing protein lvsB', 111, NULL, NULL, 150661),
(150662, '3.50.50.60-FF-000326', NULL, 'Squalene monooxygenase', 103, NULL, NULL, 150662),
(150663, '1.20.140.150-FF-000137', NULL, 'Uncharacterized protein', 54, NULL, NULL, 150663),
(150664, '3.100.10.10-FF-000064', NULL, NULL, 118, NULL, NULL, 150664),
(150665, '3.40.140.10-FF-000250', NULL, 'Eukaryotic translation initiation factor 3 subunit H', 228, NULL, NULL, 150665),
(150666, '3.40.50.300-FF-003028', NULL, 'ATP-dependent DNA helicase (Eurofung)', 109, NULL, NULL, 150666),
(150667, '3.40.50.1000-FF-000567', NULL, NULL, 55, NULL, NULL, 150667),
(150668, '3.30.60.20-FF-000029', NULL, 'Diacylglycerol kinase', 60, NULL, NULL, 150668),
(150669, '1.20.58.60-FF-000474', NULL, 'Spectrin beta chain', 213, NULL, NULL, 150669),
(150670, '3.30.559.10-FF-000286', NULL, 'Uncharacterized protein', 256, NULL, NULL, 150670),
(150671, '3.40.50.720-FF-002081', NULL, 'Os12g0534000 protein', 142, NULL, NULL, 150671),
(150672, '1.20.1250.20-FF-000255', NULL, 'Solute carrier family 29 member 4', 219, NULL, NULL, 150672),
(150673, '2.60.40.10-FF-003337', NULL, NULL, 71, NULL, NULL, 150673),
(150674, '3.90.1070.10-FF-000007', NULL, NULL, 70, NULL, NULL, 150674),
(150675, '2.40.30.140-FF-000001', NULL, 'Cytoplasmic alpha-amylase', 106, NULL, NULL, 150675),
(150676, '1.20.58.340-FF-000073', NULL, 'Cation transporter, putative', 79, NULL, NULL, 150676),
(150677, '3.30.390.50-FF-000012', NULL, 'Carbon monoxide dehydrogenase medium chain', 105, NULL, NULL, 150677),
(150678, '2.130.10.10-FF-003938', NULL, 'Uncharacterized protein', 252, NULL, NULL, 150678),
(150679, '4.10.280.10-FF-000173', NULL, 'helix-loop-helix protein delilah', 67, NULL, NULL, 150679),
(150680, '2.130.10.10-FF-001701', NULL, 'NACHT and WD repeat domain containing 1', 102, NULL, NULL, 150680),
(150681, '3.30.70.60-FF-000019', NULL, 'Fimbrial assembly protein PilO, putative', 105, NULL, NULL, 150681),
(150682, '2.130.10.10-FF-001516', NULL, 'Protein CFT1', 396, NULL, NULL, 150682);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(150683, '3.30.760.10-FF-000012', NULL, 'Eukaryotic translation initiation factor 4E', 214, NULL, NULL, 150683),
(150684, '1.10.560.10-FF-000094', NULL, '60 kDa chaperonin', 239, NULL, NULL, 150684),
(150685, '1.10.20.10-FF-000237', NULL, NULL, 111, NULL, NULL, 150685),
(150686, '3.80.10.10-FF-001691', NULL, 'Uncharacterized protein', 227, NULL, NULL, 150686),
(150687, '3.40.50.720-FF-000164', NULL, 'Carbonyl reductase [NADPH] 1', 273, NULL, NULL, 150687),
(150688, '2.60.120.10-FF-000388', NULL, 'Predicted protein', 104, NULL, NULL, 150688),
(150689, '1.20.58.60-FF-000327', NULL, 'Muscle-specific protein 300 kDa, isoform D', 306, NULL, NULL, 150689),
(150690, '3.30.360.10-FF-000083', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase GAPCP1 chloroplastic', 60, NULL, NULL, 150690),
(150691, '1.10.3470.10-FF-000035', NULL, 'Iron chelate uptake ABC transporter, FeCT family, permease protein', 322, NULL, NULL, 150691),
(150692, '3.20.20.70-FF-000694', NULL, NULL, 169, NULL, NULL, 150692),
(150693, '2.60.120.200-FF-000599', NULL, 'Predicted protein', 156, NULL, NULL, 150693),
(150694, '2.60.40.770-FF-000002', NULL, 'putative phosphatidylglycerol/phosphatidylinositol transfer protein DDB_G0282179', 122, NULL, NULL, 150694),
(150695, '3.40.50.10140-FF-000032', NULL, 'AGAP001590-PB', 143, NULL, NULL, 150695),
(150696, '3.30.2290.10-FF-000026', NULL, 'Peptide maturation', 211, NULL, NULL, 150696),
(150697, '3.40.50.300-FF-002691', NULL, 'ATPase, AAA family protein', 185, NULL, NULL, 150697),
(150698, '3.30.160.60-FF-003090', NULL, 'Az2', 65, NULL, NULL, 150698),
(150699, '2.60.120.590-FF-000053', NULL, 'Fat mass and obesity associated', 199, NULL, NULL, 150699),
(150700, '2.60.40.10-FF-003253', NULL, 'Si:ch211-141e20.2', 91, NULL, NULL, 150700),
(150701, '3.40.30.10-FF-001250', NULL, '5'' nucleotidase, putative', 52, NULL, NULL, 150701),
(150702, '3.30.60.20-FF-000092', NULL, 'Diacylglycerol kinase', 61, NULL, NULL, 150702),
(150703, '1.10.555.10-FF-000020', NULL, 'protein FAM13B isoform X1', 220, NULL, NULL, 150703),
(150704, '3.40.30.10-FF-001194', NULL, 'Uncharacterized protein', 87, NULL, NULL, 150704),
(150705, '1.10.532.10-FF-000012', NULL, 'Signal transducer and activator of transcription', 61, NULL, NULL, 150705),
(150706, '2.70.160.11-FF-000058', NULL, 'Arginine N-methyltransferase', 170, NULL, NULL, 150706),
(150707, '1.25.40.10-FF-004281', NULL, 'Uncharacterized protein', 206, NULL, NULL, 150707),
(150708, '3.40.50.300-FF-003091', NULL, 'Small GTPase EhRabX28, putative', 175, NULL, NULL, 150708),
(150709, '3.10.129.10-FF-000247', NULL, 'Uncharacterized protein', 131, NULL, NULL, 150709),
(150710, '2.60.40.10-FF-002853', NULL, 'IGLV2-33 isoform 1', 108, NULL, NULL, 150710),
(150711, '1.25.40.540-FF-000005', NULL, 'TOR signalling pathway regulator (TapA), putative', 214, NULL, NULL, 150711),
(150712, '1.25.10.10-FF-000794', NULL, 'She4p', 499, NULL, NULL, 150712),
(150713, '3.40.50.2300-FF-000974', NULL, NULL, 80, NULL, NULL, 150713),
(150714, '3.40.50.300-FF-004517', NULL, 'putative helicase MOV-10 isoform X1', 206, NULL, NULL, 150714),
(150715, '3.30.497.10-FF-000006', NULL, 'Plasminogen activator inhibitor 1', 207, NULL, NULL, 150715),
(150716, '3.30.200.20-FF-000395', NULL, 'Proline-rich receptor-like protein kinase PERK3', 96, NULL, NULL, 150716),
(150717, '2.40.50.140-FF-000185', NULL, 'DNA helicase', 77, NULL, NULL, 150717),
(150718, '3.40.630.30-FF-000164', NULL, 'Acetyltransferase GNAT family protein, putative', 183, NULL, NULL, 150718),
(150719, '2.130.10.10-FF-000212', NULL, 'Proteasomal ATPase associated factor 1', 167, NULL, NULL, 150719),
(150720, '3.60.15.10-FF-000269', NULL, 'Uncharacterized protein', 70, NULL, NULL, 150720),
(150721, '3.40.50.880-FF-000223', NULL, 'Uncharacterized protein', 89, NULL, NULL, 150721),
(150722, '3.90.70.10-FF-000598', NULL, 'Cathepsin C, putative', 194, NULL, NULL, 150722),
(150723, '3.90.550.10-FF-000747', NULL, 'Predicted protein', 61, NULL, NULL, 150723),
(150724, '3.30.450.40-FF-000301', NULL, 'PAS sensor protein', 175, NULL, NULL, 150724);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(150725, '3.30.40.10-FF-002026', NULL, 'Uncharacterized protein', 101, NULL, NULL, 150725),
(150726, '1.10.800.10-FF-000006', NULL, 'Phenylalanine 4-monooxygenase', 274, NULL, NULL, 150726),
(150727, '3.80.10.10-FF-000347', NULL, 'Platelet glycoprotein Ib alpha chain', 266, NULL, NULL, 150727),
(150728, '3.40.430.10-FF-000002', NULL, 'Dihydrofolate reductase', 185, NULL, NULL, 150728),
(150729, '3.30.70.330-FF-002824', NULL, NULL, 89, NULL, NULL, 150729),
(150730, '1.10.3500.10-FF-000033', NULL, 'Uncharacterized protein', 134, NULL, NULL, 150730),
(150731, '3.40.50.2000-FF-000210', NULL, 'Alpha-1,3/1,6-mannosyltransferase ALG2', 198, NULL, NULL, 150731),
(150732, '2.130.10.10-FF-000740', NULL, 'WD repeat-containing protein', 116, NULL, NULL, 150732),
(150733, '2.60.20.10-FF-000020', NULL, NULL, 84, NULL, NULL, 150733),
(150734, '3.10.28.10-FF-000065', NULL, 'tRNA-splicing ligase RtcB', 122, NULL, NULL, 150734),
(150735, '3.40.366.10-FF-000072', NULL, 'Uncharacterized protein', 71, NULL, NULL, 150735),
(150736, '3.40.30.10-FF-000794', NULL, 'Glutathione S-transferase', 35, NULL, NULL, 150736),
(150737, '2.60.40.790-FF-000188', NULL, NULL, 106, NULL, NULL, 150737),
(150738, '3.40.50.1820-FF-001297', NULL, 'Uncharacterized protein', 277, NULL, NULL, 150738),
(150739, '3.90.850.10-FF-000028', NULL, 'FAA hydrolase family protein', 206, NULL, NULL, 150739),
(150740, '3.90.70.10-FF-000507', NULL, 'pro-cathepsin H-like', 314, NULL, NULL, 150740),
(150741, '3.40.50.300-FF-008323', NULL, 'Uncharacterized protein', 245, NULL, NULL, 150741),
(150742, '1.25.40.10-FF-000475', NULL, 'Pentatricopeptide repeat-containing protein At5g40410, mitochondrial', 97, NULL, NULL, 150742),
(150743, '3.10.20.90-FF-000841', NULL, 'Uncharacterized protein', 89, NULL, NULL, 150743),
(150744, '3.90.470.10-FF-000038', NULL, 'Uncharacterized protein', 177, NULL, NULL, 150744),
(150745, '3.90.550.50-FF-000175', NULL, 'Hexosyltransferase', 255, NULL, NULL, 150745),
(150746, '1.10.3720.10-FF-000072', NULL, 'Amino acid ABC transporter permease', 215, NULL, NULL, 150746),
(150747, '3.40.30.10-FF-000266', NULL, 'Thioredoxin-related transmembrane protein 3', 103, NULL, NULL, 150747),
(150748, '3.40.50.300-FF-000246', NULL, 'Preprotein translocase subunit SecA', 48, NULL, NULL, 150748),
(150749, '2.130.10.10-FF-001140', NULL, 'Similar to WD repeat-containing protein', 170, NULL, NULL, 150749),
(150750, '4.10.60.10-FF-000267', NULL, 'Uncharacterized protein', 56, NULL, NULL, 150750),
(150751, '1.25.40.10-FF-005146', NULL, 'Uncharacterized protein', 96, NULL, NULL, 150751),
(150752, '2.60.40.60-FF-000165', NULL, 'FAT atypical cadherin 3', 106, NULL, NULL, 150752),
(150753, '1.10.472.80-FF-000050', NULL, 'GTPase activating protein (Gyp3)', 158, NULL, NULL, 150753),
(150754, '1.25.40.10-FF-002420', NULL, 'Pentatricopeptide repeat-containing protein', 96, NULL, NULL, 150754),
(150755, '3.30.40.10-FF-002173', NULL, 'Uncharacterized protein', 83, NULL, NULL, 150755),
(150756, '3.40.50.300-FF-003652', NULL, 'Uncharacterized protein LmxM_30_0480b_1', 155, NULL, NULL, 150756),
(150757, '2.40.50.140-FF-000893', NULL, NULL, 120, NULL, NULL, 150757),
(150758, '3.30.1490.80-FF-000040', NULL, 'Glutathione synthetase, putative (AFU_orthologue AFUA_5G06610)', 78, NULL, NULL, 150758),
(150759, '1.20.1070.10-FF-001317', NULL, 'Uncharacterized protein', 334, NULL, NULL, 150759),
(150760, '2.130.10.10-FF-002977', NULL, 'Uncharacterized protein', 211, NULL, NULL, 150760),
(150761, '1.10.510.10-FF-004446', NULL, NULL, 43, NULL, NULL, 150761),
(150762, '3.30.9.10-FF-000195', NULL, 'Uncharacterized protein', 177, NULL, NULL, 150762),
(150763, '1.10.510.10-FF-001720', NULL, 'MUT9-related serine/threonine protein kinase', 351, NULL, NULL, 150763),
(150764, '3.30.70.270-FF-000075', NULL, 'Biofilm formation regulator HmsP', 163, NULL, NULL, 150764),
(150765, '3.55.50.30-FF-000015', NULL, 'DUF4974 domain-containing protein', 76, NULL, NULL, 150765),
(150766, '1.10.287.100-FF-000002', NULL, 'Glucosidase YgjK', 39, NULL, NULL, 150766),
(150767, '1.25.10.20-FF-000004', NULL, 'Apolipoprotein B', 313, NULL, NULL, 150767); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(150768, '3.30.565.10-FF-000227', NULL, 'Probable two-component sensor', 145, NULL, NULL, 150768),
(150769, '3.90.550.50-FF-000208', NULL, 'Hexosyltransferase', 165, NULL, NULL, 150769),
(150770, '3.90.550.10-FF-000011', NULL, '3-deoxy-manno-octulosonate cytidylyltransferase', 251, NULL, NULL, 150770),
(150771, '3.40.1170.10-FF-000043', NULL, 'Predicted protein', 73, NULL, NULL, 150771),
(150772, '1.25.40.20-FF-001321', NULL, 'Uncharacterized protein', 138, NULL, NULL, 150772),
(150773, '1.10.510.10-FF-000736', NULL, 'Guanylate cyclase', 260, NULL, NULL, 150773),
(150774, '3.90.228.20-FF-000001', NULL, 'Phosphoenolpyruvate carboxykinase (ATP)', 240, NULL, NULL, 150774),
(150775, '2.70.170.10-FF-000198', NULL, 'Uncharacterized protein', 176, NULL, NULL, 150775),
(150776, '3.10.20.90-FF-000133', NULL, 'growth factor receptor-bound protein 14 isoform X2', 94, NULL, NULL, 150776),
(150777, '2.60.120.200-FF-000604', NULL, 'Uncharacterized protein', 154, NULL, NULL, 150777),
(150778, '3.40.50.300-FF-001230', NULL, 'Phosphoribulokinase/uridine kinase family protein', 266, NULL, NULL, 150778),
(150779, '2.40.70.10-FF-000046', NULL, 'Aspartic proteinase PCS1', 202, NULL, NULL, 150779),
(150780, '3.30.160.60-FF-000032', NULL, 'Krueppel-like factor 4', 89, NULL, NULL, 150780),
(150781, '1.25.10.10-FF-000119', NULL, 'Integrator complex subunit 4', 167, NULL, NULL, 150781),
(150782, '3.40.1810.10-FF-000008', NULL, 'MADS-box transcription factor 1', 73, NULL, NULL, 150782),
(150783, '1.10.287.660-FF-000001', NULL, 'pre-mRNA-splicing factor ISY1 homolog', 58, NULL, NULL, 150783),
(150784, '3.30.40.10-FF-001189', NULL, 'AGAP006749-PA', 71, NULL, NULL, 150784),
(150785, '3.40.50.300-FF-006378', NULL, 'Predicted protein', 137, NULL, NULL, 150785),
(150786, '3.40.50.1820-FF-001302', NULL, 'Predicted protein', 274, NULL, NULL, 150786),
(150787, '1.10.238.10-FF-000598', NULL, 'Calmodulin, putative', 69, NULL, NULL, 150787),
(150788, '3.30.420.40-FF-000389', NULL, 'Putative actin-like protein', 74, NULL, NULL, 150788),
(150789, '1.10.274.100-FF-000026', NULL, 'DNA-directed RNA polymerase subunit', 102, NULL, NULL, 150789),
(150790, '3.90.1410.10-FF-000056', NULL, 'CIA6', 236, NULL, NULL, 150790),
(150791, '3.40.50.300-FF-007362', NULL, 'Uncharacterized protein', 253, NULL, NULL, 150791),
(150792, '1.20.58.220-FF-000003', NULL, 'Inorganic phosphate transporter, sodium-dependent', 204, NULL, NULL, 150792),
(150793, '3.70.10.10-FF-000140', NULL, 'Uncharacterized protein', 105, NULL, NULL, 150793),
(150794, '1.25.40.10-FF-001436', NULL, 'Si:ch211-166a6.5', 97, NULL, NULL, 150794),
(150795, '1.10.287.110-FF-000275', NULL, 'Heat shock protein 40', 131, NULL, NULL, 150795),
(150796, '2.110.10.10-FF-000022', NULL, 'Hemopexin', 198, NULL, NULL, 150796),
(150797, '1.10.510.10-FF-003957', NULL, NULL, 51, NULL, NULL, 150797),
(150798, '3.30.200.20-FF-000215', NULL, 'Cyclin-dependent kinase 2 (CDK2L)', 84, NULL, NULL, 150798),
(150799, '2.30.42.10-FF-000493', NULL, NULL, 116, NULL, NULL, 150799),
(150800, '1.20.1270.10-FF-000012', NULL, 'Heat shock protein 105 kDa isoform 1', 86, NULL, NULL, 150800),
(150801, '1.10.150.80-FF-000044', NULL, 'Uncharacterized protein', 98, NULL, NULL, 150801),
(150802, '2.40.50.230-FF-000004', NULL, 'Baseplate assembly protein V', 87, NULL, NULL, 150802),
(150803, '3.90.70.10-FF-000570', NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit pan2', 382, NULL, NULL, 150803),
(150804, '3.10.310.70-FF-000001', NULL, 'Conserved protein', 109, NULL, NULL, 150804),
(150805, '2.60.120.650-FF-000065', NULL, 'Uncharacterized protein', 291, NULL, NULL, 150805),
(150806, '1.10.30.10-FF-000182', NULL, 'Uncharacterized protein', 64, NULL, NULL, 150806),
(150807, '2.70.70.10-FF-000067', NULL, 'Zinc metalloendopeptidase M23 domain protein', 135, NULL, NULL, 150807),
(150808, '3.30.40.10-FF-001161', NULL, 'Uncharacterized protein', 76, NULL, NULL, 150808),
(150809, '2.40.50.100-FF-000196', NULL, 'Predicted protein', 83, NULL, NULL, 150809),
(150810, '1.20.1160.11-FF-000016', NULL, NULL, 62, NULL, NULL, 150810);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(150811, '2.60.40.1670-FF-000011', NULL, 'Protein transport protein Sec24C, putative', 143, NULL, NULL, 150811),
(150812, '2.40.50.120-FF-000027', NULL, 'Secreted Frizzled-Related Protein', 127, NULL, NULL, 150812),
(150813, '1.10.287.70-FF-000381', NULL, 'Uncharacterized protein', 135, NULL, NULL, 150813),
(150814, '3.90.180.10-FF-000027', NULL, 'Zinc-type alcohol dehydrogenase AdhD', 218, NULL, NULL, 150814),
(150815, '3.30.160.60-FF-000824', NULL, 'Zinc finger protein 184', 31, NULL, NULL, 150815),
(150816, '4.10.400.10-FF-000054', NULL, 'Corin, serine peptidase', 40, NULL, NULL, 150816),
(150817, '2.120.10.30-FF-000600', NULL, 'Gll1703 protein', 142, NULL, NULL, 150817),
(150818, '3.60.21.10-FF-000093', NULL, 'Cell division cycle-related protein', 252, NULL, NULL, 150818),
(150819, '3.30.160.60-FF-002954', NULL, 'Zinc finger protein 408', 37, NULL, NULL, 150819),
(150820, '2.60.40.150-FF-000760', NULL, 'Uncharacterized protein', 193, NULL, NULL, 150820),
(150821, '3.30.70.330-FF-000082', NULL, '60S ribosomal protein L23a', 120, NULL, NULL, 150821),
(150822, '1.10.357.10-FF-000054', NULL, 'Transcriptional regulator, TetR family', 137, NULL, NULL, 150822),
(150823, '3.20.20.70-FF-000778', NULL, NULL, 84, NULL, NULL, 150823),
(150824, '3.20.20.70-FF-000306', NULL, 'Lipoyl synthase, mitochondrial', 217, NULL, NULL, 150824),
(150825, '3.80.10.10-FF-003489', NULL, 'Uncharacterized protein', 202, NULL, NULL, 150825),
(150826, '3.15.10.30-FF-000014', NULL, NULL, 84, NULL, NULL, 150826),
(150827, '2.30.29.170-FF-000010', NULL, 'Rib72_protein-like_protein', 130, NULL, NULL, 150827),
(150828, '1.25.40.20-FF-000568', NULL, 'HECT domain E3 ubiquitin protein ligase 1', 119, NULL, NULL, 150828),
(150829, '1.10.10.10-FF-000467', NULL, 'Cyclic nucleotide-binding domain protein', 82, NULL, NULL, 150829),
(150830, '3.90.550.10-FF-000516', NULL, 'Sll1995 protein', 252, NULL, NULL, 150830),
(150831, '1.10.238.10-FF-000311', NULL, 'Follistatin-like 4', 115, NULL, NULL, 150831),
(150832, '1.10.238.10-FF-001295', NULL, 'Uncharacterized protein', 131, NULL, NULL, 150832),
(150833, '1.10.12.70-FF-000012', NULL, NULL, 74, NULL, NULL, 150833),
(150834, '4.10.860.10-FF-000015', NULL, 'Calcyclin-binding protein', 47, NULL, NULL, 150834),
(150835, '1.10.510.10-FF-000231', NULL, 'Cyclin-dependent kinase 1', 211, NULL, NULL, 150835),
(150836, '2.60.120.10-FF-000708', NULL, 'Uncharacterized protein', 82, NULL, NULL, 150836),
(150837, '3.90.660.20-FF-000022', NULL, 'Pcyox1l protein', 102, NULL, NULL, 150837),
(150838, '3.10.110.10-FF-000373', NULL, 'Predicted protein', 117, NULL, NULL, 150838),
(150839, '2.60.40.790-FF-000160', NULL, NULL, 106, NULL, NULL, 150839),
(150840, '1.25.40.20-FF-000624', NULL, 'Uncharacterized protein, isoform B', 184, NULL, NULL, 150840),
(150841, '1.20.140.40-FF-000001', NULL, 'Pectinesterase', 158, NULL, NULL, 150841),
(150842, '1.20.1080.10-FF-000093', NULL, 'Uncharacterized protein', 249, NULL, NULL, 150842),
(150843, '2.30.42.10-FF-000577', NULL, NULL, 116, NULL, NULL, 150843),
(150844, '3.40.50.300-FF-002247', NULL, 'ATP-dependent RNA helicase DDX51', 215, NULL, NULL, 150844),
(150845, '1.10.1030.10-FF-000013', NULL, 'Predicted protein', 88, NULL, NULL, 150845),
(150846, '3.30.160.60-FF-003466', NULL, 'Zinc finger protein 709', 23, NULL, NULL, 150846),
(150847, '3.80.10.10-FF-003545', NULL, 'Uncharacterized protein', 159, NULL, NULL, 150847),
(150848, '1.10.10.60-FF-000965', NULL, NULL, 99, NULL, NULL, 150848),
(150849, '3.90.190.10-FF-000056', NULL, 'Dual specificity phosphatase 12', 160, NULL, NULL, 150849),
(150850, '3.40.1690.20-FF-000012', NULL, 'AAA ATPase domain-containing protein', 94, NULL, NULL, 150850),
(150851, '3.40.50.12780-FF-000008', NULL, 'Long-chain fatty acid transport protein 4', 442, NULL, NULL, 150851),
(150852, '1.20.58.670-FF-000025', NULL, NULL, 101, NULL, NULL, 150852),
(150853, '1.10.510.10-FF-000175', NULL, 'Myosin light chain kinase, smooth muscle', 221, NULL, NULL, 150853),
(150854, '3.40.390.10-FF-000178', NULL, NULL, 248, NULL, NULL, 150854),
(150855, '1.25.10.10-FF-002828', NULL, 'Uncharacterized protein', 187, NULL, NULL, 150855);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(150856, '1.20.120.350-FF-000013', NULL, 'Voltage-dependent N-type calcium channel subunit alpha', 123, NULL, NULL, 150856),
(150857, '3.40.50.11500-FF-000007', NULL, 'DENN domain and WD repeat-containing protein SCD1', 165, NULL, NULL, 150857),
(150858, '2.30.42.10-FF-000049', NULL, 'disks large homolog 1 isoform X1', 99, NULL, NULL, 150858),
(150859, '2.10.25.10-FF-000954', NULL, 'Predicted protein', 38, NULL, NULL, 150859),
(150860, '2.20.25.690-FF-000003', NULL, 'Tripeptidyl-peptidase II, isoform E', 63, NULL, NULL, 150860),
(150861, '3.60.120.10-FF-000002', NULL, 'Isochorismate synthase MenF', 431, NULL, NULL, 150861),
(150862, '1.20.1560.10-FF-000731', NULL, 'Uncharacterized protein', 209, NULL, NULL, 150862),
(150863, '3.30.70.370-FF-000043', NULL, NULL, 24, NULL, NULL, 150863),
(150864, '3.40.50.720-FF-002345', NULL, 'Chromosome 1, whole genome shotgun sequence', 120, NULL, NULL, 150864),
(150865, '2.40.50.150-FF-000042', NULL, 'DNA-directed RNA polymerase subunit beta', 133, NULL, NULL, 150865),
(150866, '3.40.630.40-FF-000021', NULL, 'N-acetylmuramoyl-L-alanine amidase', 221, NULL, NULL, 150866),
(150867, '3.20.20.150-FF-000065', NULL, 'Si:ch211-141o9.10', 111, NULL, NULL, 150867),
(150868, '3.60.10.10-FF-000281', NULL, 'Predicted protein', 360, NULL, NULL, 150868),
(150869, '1.20.1070.10-FF-000064', NULL, 'adhesion G protein-coupled receptor L4 isoform X1', 266, NULL, NULL, 150869),
(150870, '1.50.10.10-FF-000022', NULL, 'LanC like 2', 433, NULL, NULL, 150870),
(150871, '3.30.420.510-FF-000030', NULL, 'Pantothenate kinase 2', 71, NULL, NULL, 150871),
(150872, '1.10.1040.10-FF-000042', NULL, 'Mannitol-1-phosphate 5-dehydrogenase', 171, NULL, NULL, 150872),
(150873, '1.25.40.10-FF-002712', NULL, 'Uncharacterized protein', 66, NULL, NULL, 150873),
(150874, '3.40.50.300-FF-006086', NULL, 'Ras family protein', 187, NULL, NULL, 150874),
(150875, '3.30.460.10-FF-000170', NULL, 'Bifunctional uridylyltransferase/uridylyl-removing enzyme', 99, NULL, NULL, 150875),
(150876, '3.30.420.40-FF-000097', NULL, 'tRNA threonylcarbamoyladenosine biosynthesis protein TsaB', 108, NULL, NULL, 150876),
(150877, '3.40.50.1110-FF-000128', NULL, 'Uncharacterized protein', 248, NULL, NULL, 150877),
(150878, '1.25.10.10-FF-001103', NULL, 'armadillo repeat-containing protein 8 isoform X4', 244, NULL, NULL, 150878),
(150879, '2.60.40.10-FF-000852', NULL, 'brother of CDO isoform X1', 103, NULL, NULL, 150879),
(150880, '2.10.50.30-FF-000001', NULL, 'metabotropic glutamate receptor 1', 75, NULL, NULL, 150880),
(150881, '2.60.40.60-FF-000081', NULL, 'protocadherin Fat 4', 108, NULL, NULL, 150881),
(150882, '3.30.160.60-FF-005175', NULL, NULL, 53, NULL, NULL, 150882),
(150883, '1.25.40.10-FF-002656', NULL, 'Golgi to ER traffic protein 4 homolog', 279, NULL, NULL, 150883),
(150884, '1.20.58.390-FF-000155', NULL, 'Nicotinic acetylcholine receptor subunit', 120, NULL, NULL, 150884),
(150885, '1.10.246.90-FF-000011', NULL, 'Nucleolar protein NOP5/ snoRNA binding domain', 125, NULL, NULL, 150885),
(150886, '2.130.10.10-FF-004719', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit trm82', 168, NULL, NULL, 150886),
(150887, '2.20.70.10-FF-000176', NULL, 'Histone-lysine N-methyltransferase', 45, NULL, NULL, 150887),
(150888, '1.10.10.1320-FF-000002', NULL, 'Anti-sigma-L factor RslA', 64, NULL, NULL, 150888),
(150889, '3.10.100.10-FF-000344', NULL, NULL, 130, NULL, NULL, 150889),
(150890, '3.50.50.60-FF-001170', NULL, 'Monooxygenase, putative (AFU_orthologue AFUA_7G06960)', 181, NULL, NULL, 150890),
(150891, '2.60.120.260-FF-000015', NULL, 'Netrin 1', 282, NULL, NULL, 150891),
(150892, '2.40.30.10-FF-000156', NULL, 'Mitochondrial NADH-dependent fumarate reductase', 106, NULL, NULL, 150892),
(150893, '3.30.70.860-FF-000010', NULL, 'UPF0381 protein HI_0636', 72, NULL, NULL, 150893),
(150894, '1.10.510.10-FF-001956', NULL, 'Uncharacterized protein', 217, NULL, NULL, 150894),
(150895, '3.10.20.90-FF-000077', NULL, 'gamma-aminobutyric acid receptor-associated protein-like 2', 117, NULL, NULL, 150895),
(150896, '3.40.50.1820-FF-001830', NULL, 'Beta-hydroxypalmitic acid methyl ester hydrolase', 86, NULL, NULL, 150896);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(150897, '3.30.40.10-FF-001245', NULL, 'Chromatin modification-related protein', 57, NULL, NULL, 150897),
(150898, '1.10.540.10-FF-000148', NULL, 'Acyl-coa oxidase', 120, NULL, NULL, 150898),
(150899, '1.20.272.10-FF-000068', NULL, NULL, 97, NULL, NULL, 150899),
(150900, '3.30.30.10-FF-000019', NULL, NULL, 31, NULL, NULL, 150900),
(150901, '3.40.920.10-FF-000017', NULL, NULL, 189, NULL, NULL, 150901),
(150902, '2.60.120.970-FF-000043', NULL, 'Bone morphogenetic protein 16', 255, NULL, NULL, 150902),
(150903, '3.40.50.12610-FF-000003', NULL, 'Oligosaccharyl transferase-like protein', 174, NULL, NULL, 150903),
(150904, '3.30.70.340-FF-000028', NULL, NULL, 52, NULL, NULL, 150904),
(150905, '3.80.10.10-FF-001308', NULL, 'EIN3-binding F-box domain containing protein', 80, NULL, NULL, 150905),
(150906, '1.10.287.70-FF-000049', NULL, 'Voltage-dependent sodium channel 2', 141, NULL, NULL, 150906),
(150907, '3.40.390.10-FF-000234', NULL, NULL, 82, NULL, NULL, 150907),
(150908, '2.130.10.10-FF-004630', NULL, 'Uncharacterized protein', 196, NULL, NULL, 150908),
(150909, '1.10.533.10-FF-000267', NULL, 'Uncharacterized protein', 100, NULL, NULL, 150909),
(150910, '1.25.40.10-FF-000508', NULL, 'Zinc finger C3H1-type containing', 130, NULL, NULL, 150910),
(150911, '3.30.70.120-FF-000018', NULL, 'CutA1 divalent ion tolerance protein', 101, NULL, NULL, 150911),
(150912, '2.130.10.10-FF-000504', NULL, 'Nuclear pore protein (SEH1)', 329, NULL, NULL, 150912),
(150913, '1.10.10.1340-FF-000008', NULL, 'Mediator of RNA polymerase II transcription subunit 31', 100, NULL, NULL, 150913),
(150914, '3.40.50.300-FF-008290', NULL, 'CTP synthase', 30, NULL, NULL, 150914),
(150915, '3.40.50.300-FF-000690', NULL, 'GTPase HflX', 165, NULL, NULL, 150915),
(150916, '1.10.1410.10-FF-000054', NULL, 'Uncharacterized protein', 36, NULL, NULL, 150916),
(150917, '2.40.20.10-FF-000127', NULL, 'Uncharacterized protein', 45, NULL, NULL, 150917),
(150918, '3.30.200.20-FF-001143', NULL, 'Hypothetical_protein_-_conserved', 102, NULL, NULL, 150918),
(150919, '3.40.50.720-FF-002401', NULL, 'Uncharacterized protein', 22, NULL, NULL, 150919),
(150920, '3.10.100.10-FF-000400', NULL, NULL, 118, NULL, NULL, 150920),
(150921, '3.60.130.10-FF-000031', NULL, 'Alpha-ketoglutarate-dependent taurine dioxygenase', 295, NULL, NULL, 150921),
(150922, '1.20.58.860-FF-000015', NULL, 'Uncharacterized protein', 75, NULL, NULL, 150922),
(150923, '1.20.1200.10-FF-000007', NULL, 'Cob(I)yrinic acid a,c-diamide adenosyltransferase', 166, NULL, NULL, 150923),
(150924, '4.10.410.10-FF-000083', NULL, 'Putative serine protease inhibitor 3', 52, NULL, NULL, 150924),
(150925, '3.60.20.10-FF-000214', NULL, NULL, 169, NULL, NULL, 150925),
(150926, '1.20.1070.10-FF-001845', NULL, 'Uncharacterized protein', 376, NULL, NULL, 150926),
(150927, '2.60.40.380-FF-000008', NULL, 'Ca(2+)-dependent phospholipase D PhoD', 99, NULL, NULL, 150927),
(150928, '3.90.260.10-FF-000028', NULL, 'Predicted protein', 42, NULL, NULL, 150928),
(150929, '1.50.10.20-FF-000120', NULL, 'Uncharacterized protein', 106, NULL, NULL, 150929),
(150930, '1.10.510.10-FF-003137', NULL, NULL, 182, NULL, NULL, 150930),
(150931, '1.10.287.70-FF-000526', NULL, 'Uncharacterized protein', 131, NULL, NULL, 150931),
(150932, '2.30.30.40-FF-000457', NULL, 'Probable peroxisomal membrane protein PEX13', 89, NULL, NULL, 150932),
(150933, '1.10.506.10-FF-000013', NULL, 'Plexin b1a', 422, NULL, NULL, 150933),
(150934, '3.40.50.300-FF-005209', NULL, 'Rab_B19 protein', 209, NULL, NULL, 150934),
(150935, '3.30.200.20-FF-000631', NULL, 'Serine/threonine-protein kinase NEK', 82, NULL, NULL, 150935),
(150936, '3.40.50.2300-FF-000502', NULL, 'Protein FimX', 126, NULL, NULL, 150936),
(150937, '2.60.40.10-FF-003781', NULL, NULL, 95, NULL, NULL, 150937),
(150938, '2.40.50.40-FF-000059', NULL, 'Chromatin remodeling factor CHD3 (PICKLE)', 53, NULL, NULL, 150938),
(150939, '2.60.120.330-FF-000115', NULL, 'Predicted protein', 300, NULL, NULL, 150939),
(150940, '3.20.190.10-FF-000004', NULL, 'Putative Formamidopyrimidine-DNA glycosylase', 145, NULL, NULL, 150940);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(150941, '1.20.1280.50-FF-000002', NULL, 'F-box only protein 44', 63, NULL, NULL, 150941),
(150942, '3.50.50.60-FF-000765', NULL, 'Flavin-containing monooxygenase', 91, NULL, NULL, 150942),
(150943, '3.40.50.720-FF-000456', NULL, '3-ketodihydrosphingosine reductase tsc10', 281, NULL, NULL, 150943),
(150944, '1.20.1250.20-FF-001744', NULL, 'Sodium-dependent glucose transporter, putative', 281, NULL, NULL, 150944),
(150945, '1.10.357.140-FF-000036', NULL, 'Uncharacterized protein', 154, NULL, NULL, 150945),
(150946, '3.40.140.10-FF-000194', NULL, '26S proteasome non-ATPase regulatory subunit 14-like protein', 105, NULL, NULL, 150946),
(150947, '1.10.1670.10-FF-000016', NULL, 'Endonuclease III', 76, NULL, NULL, 150947),
(150948, '2.30.180.10-FF-000168', NULL, NULL, 153, NULL, NULL, 150948),
(150949, '1.25.40.10-FF-000767', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 121, NULL, NULL, 150949),
(150950, '3.40.50.300-FF-008031', NULL, 'Dynein heavy chain 9', 137, NULL, NULL, 150950),
(150951, '1.20.1250.20-FF-002200', NULL, 'Uncharacterized protein', 145, NULL, NULL, 150951),
(150952, '3.40.50.2300-FF-001014', NULL, NULL, 113, NULL, NULL, 150952),
(150953, '3.40.190.10-FF-000814', NULL, 'ABC transporter substrate-binding protein', 65, NULL, NULL, 150953),
(150954, '3.40.1410.10-FF-000051', NULL, 'GntR-family transcriptional regulator', 151, NULL, NULL, 150954),
(150955, '3.80.30.20-FF-000003', NULL, 'CDK5 regulatory subunit-associated protein 1', 259, NULL, NULL, 150955),
(150956, '3.40.1350.100-FF-000003', NULL, 'Protein TIC 22-like, chloroplastic', 85, NULL, NULL, 150956),
(150957, '1.10.287.110-FF-000331', NULL, 'Uncharacterized protein', 85, NULL, NULL, 150957),
(150958, '3.40.50.300-FF-000538', NULL, 'ATPase family AAA domain-containing protein 1', 178, NULL, NULL, 150958),
(150959, '3.30.70.330-FF-002532', NULL, NULL, 53, NULL, NULL, 150959),
(150960, '3.30.160.60-FF-000537', NULL, 'Zinc finger with KRAB and SCAN domains 7', 28, NULL, NULL, 150960),
(150961, '2.130.10.10-FF-002157', NULL, 'WD repeat-containing protein, putative', 199, NULL, NULL, 150961),
(150962, '3.30.200.20-FF-000159', NULL, 'muscle, skeletal receptor tyrosine-protein kinase', 97, NULL, NULL, 150962),
(150963, '3.40.20.10-FF-000001', NULL, 'Gelsolin', 93, NULL, NULL, 150963),
(150964, '3.30.40.10-FF-001953', NULL, 'Uncharacterized protein', 107, NULL, NULL, 150964),
(150965, '1.10.132.60-FF-000018', NULL, 'DNA polymerase', 182, NULL, NULL, 150965),
(150966, '3.40.50.620-FF-000196', NULL, 'YdcF family protein', 142, NULL, NULL, 150966),
(150967, '2.60.40.10-FF-002033', NULL, 'Mesocentin', 84, NULL, NULL, 150967),
(150968, '3.40.50.720-FF-000636', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase 2, cytosolic', 14, NULL, NULL, 150968),
(150969, '3.30.70.3450-FF-000001', NULL, 'Alkylglycerone-phosphate synthase', 125, NULL, NULL, 150969),
(150970, '1.20.1250.20-FF-000542', NULL, 'Sugar transporter family protein', 198, NULL, NULL, 150970),
(150971, '1.20.1070.10-FF-001789', NULL, 'Uncharacterized protein', 361, NULL, NULL, 150971),
(150972, '3.30.200.20-FF-000687', NULL, 'LRR receptor-like serine/threonine-protein kinase GSO1', 118, NULL, NULL, 150972),
(150973, '2.10.110.10-FF-000264', NULL, 'Ttx-3', 64, NULL, NULL, 150973),
(150974, '1.20.1730.10-FF-000036', NULL, 'Hybrid sensor histidine kinase/response regulator', 491, NULL, NULL, 150974),
(150975, '3.40.50.200-FF-000098', NULL, 'Peptidase S8/S53 domain-containing protein', 291, NULL, NULL, 150975),
(150976, '2.60.40.10-FF-002561', NULL, 'KETtiN (Drosophila actin-binding) homolog', 98, NULL, NULL, 150976),
(150977, '2.60.40.60-FF-000457', NULL, 'Cadherin-related hmr-1', 104, NULL, NULL, 150977),
(150978, '3.40.50.300-FF-004809', NULL, 'Translation initiation factor IF-2, putative', 164, NULL, NULL, 150978),
(150979, '3.40.1090.10-FF-000126', NULL, 'Os08g0376550 protein', 176, NULL, NULL, 150979),
(150980, '1.50.10.20-FF-000064', NULL, 'Uncharacterized protein', 230, NULL, NULL, 150980),
(150981, '3.10.450.40-FF-000019', NULL, 'Amine oxidase', 112, NULL, NULL, 150981);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(150982, '2.60.40.1110-FF-000012', NULL, 'TeNSin homolog', 121, NULL, NULL, 150982),
(150983, '1.20.1250.40-FF-000025', NULL, 'Uncharacterized protein', 142, NULL, NULL, 150983),
(150984, '4.10.470.20-FF-000005', NULL, NULL, 176, NULL, NULL, 150984),
(150985, '3.10.350.10-FF-000059', NULL, 'Uncharacterized protein', 48, NULL, NULL, 150985),
(150986, '3.40.50.1820-FF-001774', NULL, 'Predicted protein', 191, NULL, NULL, 150986),
(150987, '2.60.40.10-FF-002089', NULL, 'Uncharacterized protein YeeJ', 102, NULL, NULL, 150987),
(150988, '3.90.1150.10-FF-000013', NULL, 'Cystathionine beta-lyase', 132, NULL, NULL, 150988),
(150989, '3.30.750.24-FF-000137', NULL, 'Anti-sigma factor antagonist', 103, NULL, NULL, 150989),
(150990, '3.30.559.30-FF-000056', NULL, 'NonRibosomal Peptide Synthetase', 216, NULL, NULL, 150990),
(150991, '3.10.100.10-FF-000164', NULL, 'C-type LECtin', 131, NULL, NULL, 150991),
(150992, '1.25.10.10-FF-003233', NULL, 'PIKK family atypical protein kinase', 250, NULL, NULL, 150992),
(150993, '3.80.10.10-FF-002236', NULL, 'Uncharacterized protein', 140, NULL, NULL, 150993),
(150994, '4.10.520.10-FF-000001', NULL, 'DNA-binding protein HU', 90, NULL, NULL, 150994),
(150995, '2.10.25.10-FF-000246', NULL, 'EGF-like repeat and discoidin I-like domain-containing protein 3', 95, NULL, NULL, 150995),
(150996, '3.10.400.20-FF-000010', NULL, 'Tma64p', 183, NULL, NULL, 150996),
(150997, '3.40.630.10-FF-000478', NULL, 'Uncharacterized protein', 316, NULL, NULL, 150997),
(150998, '2.60.40.2970-FF-000002', NULL, 'Neutral protease 2', 141, NULL, NULL, 150998),
(150999, '3.30.430.20-FF-000024', NULL, 'L-type lectin-domain containing receptor kinase IX.1', 103, NULL, NULL, 150999),
(151000, '3.80.10.10-FF-001836', NULL, 'Os06g0557400 protein', 164, NULL, NULL, 151000),
(151001, '3.40.50.10470-FF-000052', NULL, 'Uncharacterized protein', 201, NULL, NULL, 151001),
(151002, '2.60.40.10-FF-002409', NULL, 'Malto-oligosyltrehalose trehalohydrolase', 75, NULL, NULL, 151002),
(151003, '2.115.10.20-FF-000020', NULL, 'Glycosyl hydrolases family 32 protein', 313, NULL, NULL, 151003),
(151004, '1.10.630.10-FF-000122', NULL, 'Cytochrome P450', 471, NULL, NULL, 151004),
(151005, '3.40.350.10-FF-000108', NULL, 'Transporter', 51, NULL, NULL, 151005),
(151006, '3.30.559.10-FF-000050', NULL, 'Nonribosomal peptide synthase SidD', 164, NULL, NULL, 151006),
(151007, '3.30.70.330-FF-002908', NULL, NULL, 39, NULL, NULL, 151007),
(151008, '3.30.565.10-FF-000519', NULL, 'Predicted protein', 106, NULL, NULL, 151008),
(151009, '1.10.510.10-FF-003665', NULL, NULL, 178, NULL, NULL, 151009),
(151010, '1.10.8.1120-FF-000004', NULL, 'Histone_RNA_hairpin-binding_protein_RNA-binding_domain_containing_protein', 73, NULL, NULL, 151010),
(151011, '3.40.50.1970-FF-000043', NULL, 'NAD-dependent methanol dehydrogenase', 183, NULL, NULL, 151011),
(151012, '3.30.70.330-FF-002588', NULL, NULL, 136, NULL, NULL, 151012),
(151013, '3.30.160.60-FF-004247', NULL, NULL, 26, NULL, NULL, 151013),
(151014, '4.10.400.10-FF-000110', NULL, 'Low-density lipoprotein receptor-related protein 1B', 40, NULL, NULL, 151014),
(151015, '2.60.120.200-FF-000312', NULL, 'Galectin', 154, NULL, NULL, 151015),
(151016, '1.25.40.10-FF-004365', NULL, 'Uncharacterized protein', 152, NULL, NULL, 151016),
(151017, '2.60.120.1020-FF-000007', NULL, 'Uncharacterized protein', 179, NULL, NULL, 151017),
(151018, '3.40.50.300-FF-001522', NULL, 'Probable MIS1-C1-tetrahydrofolate synthase, mitochondrial', 230, NULL, NULL, 151018),
(151019, '3.50.50.60-FF-000242', NULL, 'Amine oxidase', 120, NULL, NULL, 151019),
(151020, '3.60.40.10-FF-000013', NULL, 'probable protein phosphatase 2C 5', 268, NULL, NULL, 151020),
(151021, '3.30.160.60-FF-005355', NULL, NULL, 60, NULL, NULL, 151021),
(151022, '3.80.10.10-FF-004001', NULL, 'Leucine-rich repeat protein (LRRP), putative', 151, NULL, NULL, 151022),
(151023, '1.10.620.20-FF-000006', NULL, 'Acyl-ACP desaturase DesA', 312, NULL, NULL, 151023),
(151024, '3.40.640.10-FF-000451', NULL, 'Uncharacterized protein', 250, NULL, NULL, 151024),
(151025, '3.40.50.620-FF-000516', NULL, 'Valine--tRNA ligase', 200, NULL, NULL, 151025);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(151026, '2.80.10.50-FF-000114', NULL, 'CRE-EGL-17 protein', 134, NULL, NULL, 151026),
(151027, '1.20.1560.10-FF-000495', NULL, 'Export ABC transporter', 104, NULL, NULL, 151027),
(151028, '1.10.238.10-FF-000367', NULL, 'Putative p25-alpha family protein', 88, NULL, NULL, 151028),
(151029, '1.10.3430.10-FF-000061', NULL, 'Uncharacterized protein', 126, NULL, NULL, 151029),
(151030, '2.60.40.10-FF-005523', NULL, NULL, 64, NULL, NULL, 151030),
(151031, '3.40.50.80-FF-000097', NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', 211, NULL, NULL, 151031),
(151032, '3.10.10.10-FF-000007', NULL, 'Retrovirus-related Pol polyprotein from transposon 17.6-like Protein', 33, NULL, NULL, 151032),
(151033, '1.10.3210.10-FF-000078', NULL, 'dGTP triphosphohydrolase', 334, NULL, NULL, 151033),
(151034, '1.25.40.10-FF-003437', NULL, 'Pentatricopeptide repeat-containing protein', 148, NULL, NULL, 151034),
(151035, '3.40.50.80-FF-000153', NULL, '(methionine synthase) reductase', 162, NULL, NULL, 151035),
(151036, '1.20.1070.10-FF-000300', NULL, 'Vomeronasal type-1 receptor', 303, NULL, NULL, 151036),
(151037, '1.10.486.10-FF-000044', NULL, 'ATP-dependent DNA helicase', 103, NULL, NULL, 151037),
(151038, '2.60.40.10-FF-000088', NULL, 'Butyrophilin subfamily 1 member A1', 98, NULL, NULL, 151038),
(151039, '3.40.50.720-FF-000080', NULL, 'Thiazole biosynthesis adenylyltransferase ThiF', 246, NULL, NULL, 151039),
(151040, '3.40.50.10810-FF-000165', NULL, 'Excision repair cross-complementing rodent repair deficiency, complementation group 6 variant', 143, NULL, NULL, 151040),
(151041, '3.40.50.300-FF-002955', NULL, 'Apaf-1 related killer DARK', 166, NULL, NULL, 151041),
(151042, '3.40.50.1260-FF-000033', NULL, 'Phosphoglycerate kinase', 70, NULL, NULL, 151042),
(151043, '3.30.342.10-FF-000030', NULL, 'DNA polymerase epsilon catalytic subunit', 172, NULL, NULL, 151043),
(151044, '3.40.50.1000-FF-000039', NULL, 'Phosphoglycolate phosphatase', 136, NULL, NULL, 151044),
(151045, '3.30.200.20-FF-002429', NULL, 'Uncharacterized protein', 78, NULL, NULL, 151045),
(151046, '3.40.50.300-FF-005361', NULL, 'Uncharacterized protein', 201, NULL, NULL, 151046),
(151047, '2.130.10.10-FF-004158', NULL, 'WD-repeat protein, putative', 173, NULL, NULL, 151047),
(151048, '3.20.20.190-FF-000138', NULL, NULL, 28, NULL, NULL, 151048),
(151049, '3.30.70.2250-FF-000001', NULL, 'DNA polymerase', 63, NULL, NULL, 151049),
(151050, '3.40.50.720-FF-001945', NULL, 'Short-chain dehydrogenase, putative', 358, NULL, NULL, 151050),
(151051, '6.10.250.3360-FF-000002', NULL, NULL, 46, NULL, NULL, 151051),
(151052, '2.130.10.10-FF-003702', NULL, 'Semaphorin 3C', 255, NULL, NULL, 151052),
(151053, '3.50.20.20-FF-000009', NULL, 'Phosphohistidine phosphatase 1', 73, NULL, NULL, 151053),
(151054, '2.20.25.10-FF-000105', NULL, 'Uncharacterized protein', 50, NULL, NULL, 151054),
(151055, '3.30.160.60-FF-003410', NULL, 'Uncharacterized protein, isoform A', 26, NULL, NULL, 151055),
(151056, '1.10.10.60-FF-000257', NULL, 'Zinc-finger homeodomain protein 2', 75, NULL, NULL, 151056),
(151057, '1.10.10.10-FF-000647', NULL, 'Serine/threonine protein kinase', 88, NULL, NULL, 151057),
(151058, '1.20.80.10-FF-000044', NULL, 'Motor AXon guidance', 70, NULL, NULL, 151058),
(151059, '3.30.1390.10-FF-000005', NULL, 'E3 ubiquitin-protein ligase UBR1 isoform X2', 101, NULL, NULL, 151059),
(151060, '3.40.630.10-FF-000422', NULL, 'AGAP006210-PA', 291, NULL, NULL, 151060),
(151061, '3.40.720.10-FF-000305', NULL, 'Iduronate-2-sulfatase', 478, NULL, NULL, 151061),
(151062, '2.120.10.80-FF-000149', NULL, 'Multiple EGF like domains 8', 124, NULL, NULL, 151062),
(151063, '3.40.80.10-FF-000033', NULL, 'Peptidoglycan recognition protein 6', 74, NULL, NULL, 151063),
(151064, '1.10.8.10-FF-000247', NULL, 'Ubiquitinyl hydrolase 1', 64, NULL, NULL, 151064),
(151065, '1.50.40.10-FF-000411', NULL, 'Protein CBG20451', 215, NULL, NULL, 151065),
(151066, '3.40.640.10-FF-000304', NULL, 'Aspartate aminotransferase, mitochondrial', 242, NULL, NULL, 151066),
(151067, '3.30.40.10-FF-000317', NULL, 'transcription initiation factor TFIID subunit 3', 74, NULL, NULL, 151067);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(151068, '2.10.25.10-FF-001735', NULL, 'Predicted protein', 38, NULL, NULL, 151068),
(151069, '3.40.50.920-FF-000016', NULL, 'Sulfite reductase [NADPH] flavoprotein component, putative', 158, NULL, NULL, 151069),
(151070, '2.60.120.260-FF-000538', NULL, 'Uncharacterized protein', 77, NULL, NULL, 151070),
(151071, '3.40.50.10050-FF-000010', NULL, 'Translation initiation factor IF-2, putative', 104, NULL, NULL, 151071),
(151072, '1.20.120.1910-FF-000033', NULL, 'Cysteine--tRNA ligase', 168, NULL, NULL, 151072),
(151073, '3.40.50.360-FF-000005', NULL, 'Protein NrdI', 131, NULL, NULL, 151073),
(151074, '1.20.1420.30-FF-000092', NULL, 'Uncharacterized protein', 69, NULL, NULL, 151074),
(151075, '1.20.1070.10-FF-000772', NULL, 'Predicted protein', 307, NULL, NULL, 151075),
(151076, '3.10.20.10-FF-000036', NULL, '60S ribosomal protein L18a', 33, NULL, NULL, 151076),
(151077, '2.30.40.10-FF-000067', NULL, '5-methylthioadenosine/S-adenosylhomocysteine deaminase', 56, NULL, NULL, 151077),
(151078, '2.30.30.40-FF-000401', NULL, 'Calcium Channel, Beta subunit', 141, NULL, NULL, 151078),
(151079, '3.30.40.10-FF-000520', NULL, 'E3 ubiquitin-protein ligase PDZRN3 isoform X1', 54, NULL, NULL, 151079),
(151080, '2.60.120.560-FF-000038', NULL, 'Uncharacterized protein', 109, NULL, NULL, 151080),
(151081, '3.30.70.20-FF-000058', NULL, 'Probable ferredoxin/ferredoxin--NADP reductase', 106, NULL, NULL, 151081),
(151082, '3.40.50.300-FF-001994', NULL, 'Translation elongation factor G', 284, NULL, NULL, 151082),
(151083, '2.60.40.420-FF-000004', NULL, 'Cell division protein FtsP', 181, NULL, NULL, 151083),
(151084, '3.30.70.330-FF-000587', NULL, 'Hephaestus, isoform B', 107, NULL, NULL, 151084),
(151085, '3.40.140.10-FF-000047', NULL, 'Apolipoprotein B editing enzyme catalytic polypeptide-like 3H', 181, NULL, NULL, 151085),
(151086, '3.30.1360.70-FF-000027', NULL, NULL, 112, NULL, NULL, 151086),
(151087, '3.90.1310.10-FF-000015', NULL, 'Penicillin binding protein 2x', 14, NULL, NULL, 151087),
(151088, '3.40.50.410-FF-000335', NULL, 'Uncharacterized protein', 154, NULL, NULL, 151088),
(151089, '3.80.10.10-FF-002764', NULL, 'Uncharacterized protein', 224, NULL, NULL, 151089),
(151090, '1.25.10.10-FF-000939', NULL, 'Uncharacterized protein', 282, NULL, NULL, 151090),
(151091, '2.40.50.140-FF-000505', NULL, '26S protease regulatory subunit 6A, putative', 140, NULL, NULL, 151091),
(151092, '3.30.420.40-FF-000861', NULL, 'Putative glycoprotease family protein', 104, NULL, NULL, 151092),
(151093, '3.30.160.60-FF-002393', NULL, 'Blast:Transcription factor grauzone', 27, NULL, NULL, 151093),
(151094, '1.20.58.60-FF-000182', NULL, 'Spectrin repeat containing, nuclear envelope 1a', 191, NULL, NULL, 151094),
(151095, '1.20.1080.10-FF-000126', NULL, 'Uncharacterized protein', 164, NULL, NULL, 151095),
(151096, '2.60.40.10-FF-001780', NULL, 'Obscurin like 1', 96, NULL, NULL, 151096),
(151097, '3.40.50.410-FF-000279', NULL, 'Integrin beta', 50, NULL, NULL, 151097),
(151098, '1.20.1110.10-FF-000091', NULL, 'Sodium/potassium-transporting ATPase subunit alpha', 417, NULL, NULL, 151098),
(151099, '3.90.79.10-FF-000179', NULL, 'Predicted protein', 139, NULL, NULL, 151099),
(151100, '3.40.50.2000-FF-000682', NULL, 'UDP-glucuronosyltransferase', 194, NULL, NULL, 151100),
(151101, '3.40.50.720-FF-001417', NULL, 'UDP-2-acetamido-2,6-beta-L-arabino-hexul-4-ose reductase', 249, NULL, NULL, 151101),
(151102, '1.10.10.850-FF-000007', NULL, NULL, 64, NULL, NULL, 151102),
(151103, '3.40.1110.10-FF-000298', NULL, 'Calcium transporting ATPase', 261, NULL, NULL, 151103),
(151104, '3.40.718.10-FF-000036', NULL, '3-isopropylmalate dehydrogenase', 355, NULL, NULL, 151104),
(151105, '3.40.50.1820-FF-000572', NULL, 'Lipase', 374, NULL, NULL, 151105),
(151106, '1.10.510.10-FF-001248', NULL, 'Predicted protein', 192, NULL, NULL, 151106),
(151107, '1.20.5.340-FF-000073', NULL, 'AGAP000406-PA', 165, NULL, NULL, 151107),
(151108, '3.40.1110.10-FF-000354', NULL, NULL, 28, NULL, NULL, 151108),
(151109, '3.40.50.2300-FF-001519', NULL, NULL, 88, NULL, NULL, 151109);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(151110, '3.40.190.10-FF-000197', NULL, 'Glutamine ABC transporter substrate-binding protein GlnH', 133, NULL, NULL, 151110),
(151111, '3.30.70.330-FF-000115', NULL, 'eukaryotic translation initiation factor 4H', 98, NULL, NULL, 151111),
(151112, '3.40.1210.10-FF-000007', NULL, 'ADL312Cp', 300, NULL, NULL, 151112),
(151113, '3.40.640.10-FF-000248', NULL, 'Adenosylmethionine-8-amino-7-oxononanoate aminotransferase', 278, NULL, NULL, 151113),
(151114, '3.30.230.130-FF-000018', NULL, 'Cul3p', 155, NULL, NULL, 151114),
(151115, '3.40.50.360-FF-000152', NULL, 'NAD(P)H dehydrogenase (Quinone) FQR1', 44, NULL, NULL, 151115),
(151116, '3.30.710.10-FF-000240', NULL, 'BTB and MATH domain containing', 112, NULL, NULL, 151116),
(151117, '3.30.70.330-FF-000790', NULL, 'Serine/arginine-rich splicing factor SR45a', 127, NULL, NULL, 151117),
(151118, '3.90.1750.10-FF-000014', NULL, 'Putative Ubiquitin-protein ligase E3C', 159, NULL, NULL, 151118),
(151119, '3.40.720.10-FF-000249', NULL, 'Uncharacterized protein', 137, NULL, NULL, 151119),
(151120, '1.10.510.10-FF-002940', NULL, 'Predicted protein', 295, NULL, NULL, 151120),
(151121, '3.30.160.60-FF-005883', NULL, NULL, 34, NULL, NULL, 151121),
(151122, '3.60.10.10-FF-000129', NULL, 'Protein angel', 382, NULL, NULL, 151122),
(151123, '3.10.270.10-FF-000002', NULL, 'Uricase', 311, NULL, NULL, 151123),
(151124, '1.20.120.1200-FF-000005', NULL, 'NADH-quinone oxidoreductase subunit J', 162, NULL, NULL, 151124),
(151125, '1.20.5.190-FF-000062', NULL, 'IQ-domain 11', 52, NULL, NULL, 151125),
(151126, '3.90.640.90-FF-000019', NULL, 'Predicted protein', 129, NULL, NULL, 151126),
(151127, '3.40.50.300-FF-006850', NULL, 'Uncharacterized protein', 261, NULL, NULL, 151127),
(151128, '2.40.37.10-FF-000019', NULL, 'Diaminopimelate decarboxylase', 119, NULL, NULL, 151128),
(151129, '2.60.60.30-FF-000005', NULL, 'Tellurium resistance protein TerA', 146, NULL, NULL, 151129),
(151130, '1.50.40.10-FF-000355', NULL, 'Predicted protein', 169, NULL, NULL, 151130),
(151131, '1.10.1300.10-FF-000085', NULL, 'Uncharacterized protein', 249, NULL, NULL, 151131),
(151132, '3.90.550.10-FF-000483', NULL, 'Glycosyl transferase', 193, NULL, NULL, 151132),
(151133, '3.30.40.10-FF-000464', NULL, 'Histone-lysine N-methyltransferase', 120, NULL, NULL, 151133),
(151134, '1.10.630.10-FF-000650', NULL, 'Uncharacterized protein', 202, NULL, NULL, 151134),
(151135, '2.40.240.130-FF-000002', NULL, 'Axin 1', 84, NULL, NULL, 151135),
(151136, '3.10.129.10-FF-000011', NULL, 'Acyl-coenzyme A thioesterase 11', 147, NULL, NULL, 151136),
(151137, '1.10.10.830-FF-000001', NULL, 'Isoleucine--tRNA ligase', 56, NULL, NULL, 151137),
(151138, '1.25.10.10-FF-002980', NULL, 'Uncharacterized protein', 625, NULL, NULL, 151138),
(151139, '2.60.40.10-FF-000291', NULL, 'Neuroplastin b', 115, NULL, NULL, 151139),
(151140, '3.40.309.10-FF-000102', NULL, 'Putative succinate semialdehyde dehydrogenase', 191, NULL, NULL, 151140),
(151141, '1.10.10.10-FF-000703', NULL, 'Regulatory protein RecX', 41, NULL, NULL, 151141),
(151142, '3.30.450.20-FF-000346', NULL, 'Sensor histidine kinase', 135, NULL, NULL, 151142),
(151143, '1.10.150.20-FF-000138', NULL, 'DNA-dependent RNA polymerase', 195, NULL, NULL, 151143),
(151144, '3.40.50.800-FF-000126', NULL, 'Uncharacterized protein', 124, NULL, NULL, 151144),
(151145, '3.30.420.40-FF-000676', NULL, 'Predicted protein', 311, NULL, NULL, 151145),
(151146, '2.30.29.30-FF-000327', NULL, 'Rho guanyl nucleotide exchange factor', 143, NULL, NULL, 151146),
(151147, '3.60.15.10-FF-000180', NULL, 'Ribonuclease Z', 298, NULL, NULL, 151147),
(151148, '3.30.500.10-FF-000050', NULL, NULL, 104, NULL, NULL, 151148),
(151149, '2.130.10.130-FF-000023', NULL, 'integrin alpha-PS2 isoform X1', 472, NULL, NULL, 151149),
(151150, '3.40.50.1820-FF-000605', NULL, 'S-formylglutathione hydrolase FrmB', 317, NULL, NULL, 151150),
(151151, '1.10.510.10-FF-002737', NULL, 'Uncharacterized protein', 295, NULL, NULL, 151151),
(151152, '3.40.220.10-FF-000048', NULL, 'Uncharacterized protein', 83, NULL, NULL, 151152);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(151153, '1.20.1050.10-FF-000265', NULL, 'Putative glutathione S-transferase', 125, NULL, NULL, 151153),
(151154, '3.40.50.2300-FF-001486', NULL, NULL, 132, NULL, NULL, 151154),
(151155, '2.130.10.10-FF-001960', NULL, 'WD40 repeat-like protein', 292, NULL, NULL, 151155),
(151156, '2.60.120.10-FF-000332', NULL, 'Mannose-6-phosphate isomerase', 142, NULL, NULL, 151156),
(151157, '3.30.1340.30-FF-000008', NULL, 'Probable osmotically inducible protein Y', 69, NULL, NULL, 151157),
(151158, '2.130.10.10-FF-000976', NULL, 'Eukaryotic translation initiation factor 2A', 148, NULL, NULL, 151158),
(151159, '1.10.510.10-FF-002209', NULL, NULL, 94, NULL, NULL, 151159),
(151160, '1.25.40.10-FF-003061', NULL, 'Pre-mRNA splicing factor putative', 224, NULL, NULL, 151160),
(151161, '3.40.50.300-FF-005737', NULL, 'Uncharacterized protein', 151, NULL, NULL, 151161),
(151162, '2.60.40.150-FF-000608', NULL, 'Phosphoinositide phospholipase C', 65, NULL, NULL, 151162),
(151163, '3.30.1550.10-FF-000007', NULL, '50S ribosomal protein L11', 76, NULL, NULL, 151163),
(151164, '3.30.310.80-FF-000016', NULL, 'Non-specific serine/threonine protein kinase', 125, NULL, NULL, 151164),
(151165, '3.30.160.60-FF-006136', NULL, NULL, 29, NULL, NULL, 151165),
(151166, '3.40.50.720-FF-001384', NULL, 'Probable polysaccharide biosynthesis protein EpsC', 126, NULL, NULL, 151166),
(151167, '1.25.40.10-FF-000711', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 213, NULL, NULL, 151167),
(151168, '3.30.70.890-FF-000081', NULL, 'Uncharacterized protein', 70, NULL, NULL, 151168),
(151169, '2.20.25.20-FF-000018', NULL, 'Casein kinase II subunit beta', 76, NULL, NULL, 151169),
(151170, '3.40.30.10-FF-000030', NULL, 'Protein disulfide-isomerase', 129, NULL, NULL, 151170),
(151171, '3.40.50.300-FF-008087', NULL, 'Uncharacterized protein', 114, NULL, NULL, 151171),
(151172, '3.40.190.10-FF-000758', NULL, 'Glutamate receptor', 37, NULL, NULL, 151172),
(151173, '2.30.30.380-FF-000070', NULL, 'Uncharacterized protein', 60, NULL, NULL, 151173),
(151174, '2.160.20.10-FF-000262', NULL, 'Uncharacterized protein', 119, NULL, NULL, 151174),
(151175, '3.30.260.10-FF-000042', NULL, 'T-complex protein 1, epsilon subunit protein', 106, NULL, NULL, 151175),
(151176, '3.80.10.10-FF-002056', NULL, 'Leucine-rich repeat protein kinase family protein', 148, NULL, NULL, 151176),
(151177, '3.90.1380.10-FF-000002', NULL, 'Threonine synthase', 87, NULL, NULL, 151177),
(151178, '1.25.40.570-FF-000020', NULL, 'Eukaryotic translation initiation factor 3 subunit E', 206, NULL, NULL, 151178),
(151179, '3.90.1460.10-FF-000003', NULL, 'general transcription factor II-I isoform X1', 109, NULL, NULL, 151179),
(151180, '2.130.10.10-FF-001229', NULL, 'NACHT and WD repeat domain containing 1', 138, NULL, NULL, 151180),
(151181, '1.10.510.10-FF-003901', NULL, NULL, 84, NULL, NULL, 151181),
(151182, '2.40.50.40-FF-000115', NULL, 'Uncharacterized protein', 42, NULL, NULL, 151182),
(151183, '3.30.70.330-FF-001604', NULL, NULL, 115, NULL, NULL, 151183),
(151184, '3.40.50.1700-FF-000007', NULL, 'Exo-1,4-beta-xylosidase xlnD', 240, NULL, NULL, 151184),
(151185, '1.10.630.10-FF-000594', NULL, 'Os07g0293000 protein', 281, NULL, NULL, 151185),
(151186, '3.40.50.300-FF-001466', NULL, 'RNA helicase', 273, NULL, NULL, 151186),
(151187, '3.30.930.10-FF-000312', NULL, 'Phenylalanyl-tRNA synthetase, beta subunit', 231, NULL, NULL, 151187),
(151188, '3.30.160.60-FF-001465', NULL, 'Zinc finger protein 560', 31, NULL, NULL, 151188),
(151189, '2.30.29.30-FF-001311', NULL, 'Uncharacterized protein', 76, NULL, NULL, 151189),
(151190, '1.20.120.1630-FF-000016', NULL, 'Phosphatidylethanolamine N-methyltransferase', 178, NULL, NULL, 151190),
(151191, '3.40.850.10-FF-000309', NULL, 'Uncharacterized protein', 142, NULL, NULL, 151191),
(151192, '3.30.70.330-FF-001043', NULL, 'RNA-binding protein, putative', 79, NULL, NULL, 151192),
(151193, '3.40.50.150-FF-000999', NULL, NULL, 208, NULL, NULL, 151193),
(151194, '3.40.50.10490-FF-000114', NULL, NULL, 199, NULL, NULL, 151194),
(151195, '3.40.50.1000-FF-000803', NULL, NULL, 142, NULL, NULL, 151195);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(151196, '2.40.10.10-FF-000357', NULL, NULL, 98, NULL, NULL, 151196),
(151197, '1.10.10.60-FF-001218', NULL, NULL, 78, NULL, NULL, 151197),
(151198, '3.30.1420.10-FF-000003', NULL, 'Siroheme-sulfite reductase gamma subunit homolog', 47, NULL, NULL, 151198),
(151199, '1.10.10.10-FF-001631', NULL, 'Helix-turn-helix transcriptional regulator, ArsR family', 93, NULL, NULL, 151199),
(151200, '3.30.70.330-FF-000643', NULL, 'Splicing factor U2AF large subunit', 109, NULL, NULL, 151200),
(151201, '2.10.220.10-FF-000093', NULL, 'Proprotein convertase subtilisin/kexin type 5', 100, NULL, NULL, 151201),
(151202, '2.130.10.10-FF-000268', NULL, 'polycomb group protein FIE1', 350, NULL, NULL, 151202),
(151203, '2.60.200.20-FF-000246', NULL, 'Chromosome 1, whole genome shotgun sequence', 126, NULL, NULL, 151203),
(151204, '1.10.510.10-FF-002884', NULL, NULL, 107, NULL, NULL, 151204),
(151205, '2.60.40.10-FF-001105', NULL, 'T-cell surface glycoprotein CD4', 109, NULL, NULL, 151205),
(151206, '3.30.160.20-FF-000099', NULL, 'Unplaced genomic scaffold supercont1.38, whole genome shotgun sequence', 96, NULL, NULL, 151206),
(151207, '1.20.1690.10-FF-000009', NULL, 'V-type proton ATPase subunit', 122, NULL, NULL, 151207),
(151208, '3.30.420.40-FF-000709', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', 172, NULL, NULL, 151208),
(151209, '2.60.40.820-FF-000040', NULL, 'Putative T-box protein 36', 193, NULL, NULL, 151209),
(151210, '2.30.40.10-FF-000123', NULL, 'Imidazolonepropionase', 86, NULL, NULL, 151210),
(151211, '2.30.42.10-FF-000105', NULL, 'Tyrosine-protein phosphatase non-receptor type 13', 109, NULL, NULL, 151211),
(151212, '3.60.15.10-FF-000033', NULL, 'MBL fold metallo-hydrolase', 291, NULL, NULL, 151212),
(151213, '2.60.40.150-FF-000232', NULL, 'U5 small nuclear ribonucleoprotein-specific protein', 132, NULL, NULL, 151213),
(151214, '3.50.50.100-FF-000021', NULL, 'AMID-like mitochondrial oxidoreductase, putative', 372, NULL, NULL, 151214),
(151215, '1.25.10.10-FF-001867', NULL, 'Uncharacterized protein', 165, NULL, NULL, 151215),
(151216, '3.40.50.300-FF-001319', NULL, 'Site-determining protein', 239, NULL, NULL, 151216),
(151217, '3.80.10.10-FF-003017', NULL, 'AGAP010289-PA', 168, NULL, NULL, 151217),
(151218, '1.25.40.180-FF-000173', NULL, NULL, 186, NULL, NULL, 151218),
(151219, '3.90.70.80-FF-000074', NULL, 'OTU deubiquitinase 3', 140, NULL, NULL, 151219),
(151220, '3.10.180.10-FF-000028', NULL, 'Glyoxalase/fosfomycin resistance/dioxygenase domain containing protein', 129, NULL, NULL, 151220),
(151221, '4.10.1280.10-FF-000001', NULL, 'Botulinum neurotoxin type A', 65, NULL, NULL, 151221),
(151222, '1.10.1420.10-FF-000116', NULL, 'DNA mismatch repair protein Msh2', 115, NULL, NULL, 151222),
(151223, '2.130.10.10-FF-002213', NULL, 'BBS2, putative', 300, NULL, NULL, 151223),
(151224, '2.60.40.720-FF-000009', NULL, 'Transcription factor cep-1', 196, NULL, NULL, 151224),
(151225, '2.170.270.10-FF-000013', NULL, 'Histone-lysine N-methyltransferase SMYD1 isoform 1', 118, NULL, NULL, 151225),
(151226, '1.10.4160.10-FF-000046', NULL, NULL, 181, NULL, NULL, 151226),
(151227, '2.130.10.10-FF-002921', NULL, 'Predicted protein', 176, NULL, NULL, 151227),
(151228, '2.60.120.260-FF-000162', NULL, 'Probable alpha-galactosidase D', 151, NULL, NULL, 151228),
(151229, '3.30.470.20-FF-000145', NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', 148, NULL, NULL, 151229),
(151230, '2.170.300.10-FF-000011', NULL, 'cadherin EGF LAG seven-pass G-type receptor 1', 50, NULL, NULL, 151230),
(151231, '3.90.80.10-FF-000008', NULL, 'Pyrophosphatase (inorganic) 2', 157, NULL, NULL, 151231),
(151232, '3.80.10.10-FF-003725', NULL, 'Leucine-rich repeat-containing protein', 139, NULL, NULL, 151232),
(151233, '1.20.120.150-FF-000009', NULL, 'PIKK family atypical protein kinase', 83, NULL, NULL, 151233),
(151234, '2.130.10.10-FF-005647', NULL, 'Uncharacterized protein', 171, NULL, NULL, 151234),
(151235, '2.70.130.10-FF-000049', NULL, NULL, 156, NULL, NULL, 151235),
(151236, '3.30.1540.20-FF-000015', NULL, 'DNA mismatch repair protein PMS1', 34, NULL, NULL, 151236);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(151237, '3.40.50.300-FF-004669', NULL, 'ATP-dependent nuclease subunit A', 159, NULL, NULL, 151237),
(151238, '1.25.40.20-FF-000916', NULL, 'Predicted protein', 300, NULL, NULL, 151238),
(151239, '1.10.287.1260-FF-000008', NULL, 'Mechanosensitive ion channel protein 3, chloroplastic', 105, NULL, NULL, 151239),
(151240, '3.40.30.10-FF-000586', NULL, 'Thioredoxin', 109, NULL, NULL, 151240),
(151241, '1.25.40.10-FF-003561', NULL, 'Transcriptional regulator', 254, NULL, NULL, 151241),
(151242, '3.30.160.60-FF-005416', NULL, NULL, 39, NULL, NULL, 151242),
(151243, '3.90.380.10-FF-000003', NULL, 'Carnitine monooxygenase oxygenase subunit', 74, NULL, NULL, 151243),
(151244, '3.20.20.140-FF-000348', NULL, 'Phosphotriesterase, putative', 322, NULL, NULL, 151244),
(151245, '1.20.58.60-FF-000243', NULL, 'Spectrin beta chain', 101, NULL, NULL, 151245),
(151246, '3.40.50.300-FF-005237', NULL, 'Dephospho-CoA kinase', 197, NULL, NULL, 151246),
(151247, '2.130.10.10-FF-004282', NULL, 'Semaphorin 4A', 128, NULL, NULL, 151247),
(151248, '3.90.176.10-FF-000012', NULL, 'NAD(P)(+)--arginine ADP-ribosyltransferase', 218, NULL, NULL, 151248),
(151249, '3.30.70.330-FF-000374', NULL, 'Flowering time control protein FCA', 91, NULL, NULL, 151249),
(151250, '3.30.160.60-FF-002662', NULL, 'Uncharacterized protein', 27, NULL, NULL, 151250),
(151251, '3.40.800.10-FF-000042', NULL, NULL, 279, NULL, NULL, 151251),
(151252, '3.90.70.10-FF-000367', NULL, 'Ubiquitin carboxyl-terminal hydrolase 20', 166, NULL, NULL, 151252),
(151253, '1.10.510.10-FF-003749', NULL, NULL, 144, NULL, NULL, 151253),
(151254, '2.40.30.20-FF-000018', NULL, 'Tail spike protein', 87, NULL, NULL, 151254),
(151255, '3.60.20.10-FF-000074', NULL, 'Proteasome subunit beta', 219, NULL, NULL, 151255),
(151256, '3.30.230.130-FF-000013', NULL, 'Anaphase-promoting complex subunit ApcB, putative', 158, NULL, NULL, 151256),
(151257, '1.10.287.1240-FF-000002', NULL, 'Exodeoxyribonuclease I', 59, NULL, NULL, 151257),
(151258, '3.40.50.1820-FF-000925', NULL, 'Kynurenine formamidase', 256, NULL, NULL, 151258),
(151259, '1.10.10.60-FF-000729', NULL, 'Msx-type homeobox protein', 67, NULL, NULL, 151259),
(151260, '3.90.1140.10-FF-000007', NULL, 'Cyclic phosphodiesterase', 180, NULL, NULL, 151260),
(151261, '3.90.550.10-FF-000663', NULL, 'Polypeptide N-acetylgalactosaminyltransferase 17', 117, NULL, NULL, 151261),
(151262, '1.10.357.120-FF-000002', NULL, 'DNA-directed RNA polymerase subunit', 134, NULL, NULL, 151262),
(151263, '3.10.196.10-FF-000008', NULL, 'Methionine synthase', 223, NULL, NULL, 151263),
(151264, '2.60.40.10-FF-001656', NULL, 'Calmodulin-binding transcription activator 5', 97, NULL, NULL, 151264),
(151265, '3.40.50.300-FF-000454', NULL, 'Protein CLP1 homolog', 223, NULL, NULL, 151265),
(151266, '2.40.50.140-FF-000269', NULL, 'Single-stranded DNA-binding protein', 112, NULL, NULL, 151266),
(151267, '3.40.630.30-FF-000248', NULL, 'N-acetyltransferase 9-like protein', 170, NULL, NULL, 151267),
(151268, '1.25.40.1040-FF-000001', NULL, 'N-alpha-acetyltransferase 15, NatA auxiliary subunit', 497, NULL, NULL, 151268),
(151269, '1.20.1250.10-FF-000134', NULL, NULL, 95, NULL, NULL, 151269),
(151270, '3.30.470.10-FF-000001', NULL, 'Branched-chain-amino-acid aminotransferase', 118, NULL, NULL, 151270),
(151271, '2.20.110.10-FF-000071', NULL, NULL, 70, NULL, NULL, 151271),
(151272, '2.40.100.10-FF-000015', NULL, 'Peptidyl-prolyl cis-trans isomerase', 172, NULL, NULL, 151272),
(151273, '3.90.1200.10-FF-000046', NULL, 'Probable choline kinase 1', 248, NULL, NULL, 151273),
(151274, '3.40.47.10-FF-000158', NULL, NULL, 184, NULL, NULL, 151274),
(151275, '3.40.1350.150-FF-000001', NULL, 'tRNA splicing endonuclease subunit 54', 101, NULL, NULL, 151275),
(151276, '3.30.200.20-FF-000075', NULL, 'Probable serine/threonine-protein kinase WNK1', 97, NULL, NULL, 151276),
(151277, '1.20.920.10-FF-000052', NULL, 'Chromatin structure-remodeling complex subunit snf21', 164, NULL, NULL, 151277),
(151278, '3.80.10.10-FF-004361', NULL, 'Si:dkey-22a18.2', 176, NULL, NULL, 151278),
(151279, '3.80.10.10-FF-000027', NULL, 'PH domain and leucine rich repeat protein phosphatase 2', 163, NULL, NULL, 151279);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(151280, '2.170.270.10-FF-000165', NULL, 'Uncharacterized protein', 124, NULL, NULL, 151280),
(151281, '3.40.50.300-FF-002483', NULL, 'Uncharacterized protein', 260, NULL, NULL, 151281),
(151282, '1.10.238.10-FF-000491', NULL, 'Protein kinase, putative', 100, NULL, NULL, 151282),
(151283, '1.10.20.140-FF-000015', NULL, NULL, 69, NULL, NULL, 151283),
(151284, '3.40.50.1000-FF-000747', NULL, NULL, 76, NULL, NULL, 151284),
(151285, '3.40.50.1370-FF-000066', NULL, NULL, 47, NULL, NULL, 151285),
(151286, '3.40.630.10-FF-000242', NULL, 'Uncharacterized protein', 161, NULL, NULL, 151286),
(151287, '1.10.357.140-FF-000008', NULL, '4-hydroxybenzoate octaprenyltransferase', 155, NULL, NULL, 151287),
(151288, '3.30.565.10-FF-000486', NULL, 'Uncharacterized protein', 186, NULL, NULL, 151288),
(151289, '1.20.1250.20-FF-002228', NULL, 'Uncharacterized protein', 127, NULL, NULL, 151289),
(151290, '2.130.10.10-FF-000971', NULL, 'COMPASS component SWD3', 307, NULL, NULL, 151290),
(151291, '3.40.350.10-FF-000029', NULL, 'Aminopeptidase P', 143, NULL, NULL, 151291),
(151292, '1.20.1270.50-FF-000001', NULL, 'Alpha-mannosidase', 117, NULL, NULL, 151292),
(151293, '2.30.42.10-FF-000341', NULL, 'Zinc metalloprotease', 86, NULL, NULL, 151293),
(151294, '2.130.10.10-FF-005271', NULL, 'Uncharacterized protein', 252, NULL, NULL, 151294),
(151295, '3.30.420.10-FF-000341', NULL, 'Argonaute-like protein, putative', 283, NULL, NULL, 151295),
(151296, '3.60.40.10-FF-000069', NULL, 'Pyruvate dehydrogenase', 407, NULL, NULL, 151296),
(151297, '1.20.1260.10-FF-000011', NULL, 'Spore coat protein CotJC', 187, NULL, NULL, 151297),
(151298, '3.40.50.1820-FF-001482', NULL, 'Uncharacterized protein', 169, NULL, NULL, 151298),
(151299, '3.60.40.10-FF-000018', NULL, 'Integrin-linked kinase-associated serine/threonine phosphatase 2C', 285, NULL, NULL, 151299),
(151300, '1.25.40.20-FF-001473', NULL, 'Uncharacterized protein', 103, NULL, NULL, 151300),
(151301, '3.30.505.10-FF-000038', NULL, 'Tyrosine-protein kinase', 102, NULL, NULL, 151301),
(151302, '2.40.50.140-FF-000657', NULL, NULL, 100, NULL, NULL, 151302),
(151303, '3.30.160.60-FF-004899', NULL, NULL, 40, NULL, NULL, 151303),
(151304, '2.130.10.10-FF-002769', NULL, 'Predicted protein', 234, NULL, NULL, 151304),
(151305, '2.30.29.30-FF-000322', NULL, 'Uncharacterized protein, isoform B', 118, NULL, NULL, 151305),
(151306, '1.10.150.20-FF-000217', NULL, 'DNA repair and recombination protein RadA', 66, NULL, NULL, 151306),
(151307, '1.10.565.10-FF-000110', NULL, 'Nuclear Hormone Receptor family', 224, NULL, NULL, 151307),
(151308, '3.30.565.10-FF-000047', NULL, 'Phosphotransferase RcsD', 181, NULL, NULL, 151308),
(151309, '3.40.50.2000-FF-000530', NULL, 'Glycosyltransferase', 261, NULL, NULL, 151309),
(151310, '3.30.1460.20-FF-000014', NULL, 'Arp2/3 complex 34 kDa subunit', 169, NULL, NULL, 151310),
(151311, '3.30.470.30-FF-000007', NULL, 'DNA ligase B', 219, NULL, NULL, 151311),
(151312, '3.10.450.50-FF-000033', NULL, 'SEC-C motif-containing protein,tetratricopeptide repeat protein', 36, NULL, NULL, 151312),
(151313, '2.60.200.20-FF-000038', NULL, 'FHA domain-containing protein SNIP1', 132, NULL, NULL, 151313),
(151314, '3.30.1050.10-FF-000042', NULL, 'stomatin-like protein 1', 111, NULL, NULL, 151314),
(151315, '1.20.1070.10-FF-001497', NULL, 'Vomeronasal type-1 receptor', 199, NULL, NULL, 151315),
(151316, '3.60.15.10-FF-000117', NULL, 'DNA cross-link repair 1A protein, variant', 196, NULL, NULL, 151316),
(151317, '1.10.8.100-FF-000009', NULL, 'rRNA adenine N(6)-methyltransferase', 78, NULL, NULL, 151317),
(151318, '2.60.40.10-FF-001605', NULL, 'B-cell receptor CD22', 88, NULL, NULL, 151318),
(151319, '1.25.40.710-FF-000012', NULL, 'Uncharacterized protein', 242, NULL, NULL, 151319),
(151320, '3.40.50.300-FF-001022', NULL, 'RNA helicase', 229, NULL, NULL, 151320),
(151321, '1.20.920.30-FF-000007', NULL, 'Dynein axonemal heavy chain 10', 197, NULL, NULL, 151321),
(151322, '1.10.8.60-FF-000189', NULL, 'AAA family ATPase, CDC48 subfamily', 83, NULL, NULL, 151322),
(151323, '1.10.10.1710-FF-000001', NULL, '(6-4) photolyase', 76, NULL, NULL, 151323);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(151324, '3.30.565.10-FF-000435', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', 158, NULL, NULL, 151324),
(151325, '3.40.50.1820-FF-000021', NULL, 'Lipase', 377, NULL, NULL, 151325),
(151326, '3.40.50.800-FF-000121', NULL, 'Histidine--tRNA ligase', 89, NULL, NULL, 151326),
(151327, '3.90.550.50-FF-000028', NULL, 'Hexosyltransferase', 234, NULL, NULL, 151327),
(151328, '3.90.780.10-FF-000051', NULL, '5'' nucleotidase, putative', 144, NULL, NULL, 151328),
(151329, '3.40.50.300-FF-006665', NULL, 'Septin homolog spn5', 276, NULL, NULL, 151329),
(151330, '1.10.418.60-FF-000019', NULL, 'Kinetochore protein Nuf2 homolog', 165, NULL, NULL, 151330),
(151331, '3.30.70.3310-FF-000004', NULL, 'neurogenic locus notch homolog protein 4', 152, NULL, NULL, 151331),
(151332, '1.20.920.10-FF-000001', NULL, 'Histone acetyltransferase p300', 118, NULL, NULL, 151332),
(151333, '1.10.1370.30-FF-000005', NULL, 'Angiotensin-converting enzyme', 133, NULL, NULL, 151333),
(151334, '3.40.50.150-FF-001729', NULL, NULL, 88, NULL, NULL, 151334),
(151335, '1.10.287.130-FF-000101', NULL, 'Sensor histidine kinase', 85, NULL, NULL, 151335),
(151336, '3.40.50.880-FF-000190', NULL, 'Glutathione-independent glyoxalase DJ-1', 192, NULL, NULL, 151336),
(151337, '1.10.405.40-FF-000001', NULL, 'Amine oxidase', 135, NULL, NULL, 151337),
(151338, '3.30.160.60-FF-003230', NULL, 'Zinc finger protein ZIC 3', 30, NULL, NULL, 151338),
(151339, '3.80.10.10-FF-003837', NULL, 'Leucine-rich repeat family protein', 55, NULL, NULL, 151339),
(151340, '1.10.472.10-FF-000630', NULL, 'Uncharacterized protein', 121, NULL, NULL, 151340),
(151341, '1.10.10.440-FF-000002', NULL, 'pre-mRNA-processing factor 40 homolog A isoform X1', 80, NULL, NULL, 151341),
(151342, '1.25.10.10-FF-000878', NULL, 'Serine/threonine-protein kinase ATR', 400, NULL, NULL, 151342),
(151343, '3.30.160.60-FF-005467', NULL, NULL, 67, NULL, NULL, 151343),
(151344, '3.30.230.10-FF-000366', NULL, 'Equilibrative Nucleoside Transporter', 186, NULL, NULL, 151344),
(151345, '3.30.200.20-FF-000867', NULL, 'Possible serine/threonine kinase', 76, NULL, NULL, 151345),
(151346, '3.10.180.10-FF-000023', NULL, 'Glyoxalase/bleomycin resistance/dioxygenase family protein', 123, NULL, NULL, 151346),
(151347, '3.40.50.80-FF-000237', NULL, 'Uncharacterized protein', 92, NULL, NULL, 151347),
(151348, '3.40.50.2300-FF-000738', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One component system)', 116, NULL, NULL, 151348),
(151349, '1.10.443.10-FF-000001', NULL, 'Tyrosine recombinase XerD', 182, NULL, NULL, 151349),
(151350, '3.20.20.80-FF-000287', NULL, 'Maltooligosyl trehalose synthase', 161, NULL, NULL, 151350),
(151351, '3.40.50.10590-FF-000003', NULL, 'Leucine aminopeptidase 1', 155, NULL, NULL, 151351),
(151352, '3.60.21.10-FF-000177', NULL, 'Serine/threonine-protein phosphatase', 339, NULL, NULL, 151352),
(151353, '3.40.50.620-FF-000544', NULL, 'Uncharacterized protein', 288, NULL, NULL, 151353),
(151354, '3.30.390.30-FF-000006', NULL, 'Nitrite reductase large subunit', 82, NULL, NULL, 151354),
(151355, '3.40.50.300-FF-002871', NULL, 'Helicase SWR1', 285, NULL, NULL, 151355),
(151356, '1.20.1050.10-FF-000153', NULL, 'Protein CBR-GST-15', 76, NULL, NULL, 151356),
(151357, '1.10.238.10-FF-000339', NULL, 'Actin cytoskeleton-regulatory complex protein END3', 113, NULL, NULL, 151357),
(151358, '3.30.160.60-FF-000684', NULL, 'Zinc finger protein 710', 24, NULL, NULL, 151358),
(151359, '2.10.220.10-FF-000098', NULL, 'Tyrosine-protein kinase receptor', 79, NULL, NULL, 151359),
(151360, '2.30.30.30-FF-000067', NULL, '60S ribosomal protein L14 putative', 87, NULL, NULL, 151360),
(151361, '1.25.40.10-FF-000655', NULL, 'Sec72p', 145, NULL, NULL, 151361),
(151362, '3.40.50.300-FF-007542', NULL, 'Uncharacterized protein', 200, NULL, NULL, 151362),
(151363, '3.30.70.330-FF-001784', NULL, NULL, 112, NULL, NULL, 151363),
(151364, '1.20.1070.10-FF-000036', NULL, 'frizzled-3 isoform X1', 352, NULL, NULL, 151364),
(151365, '3.40.1160.10-FF-000014', NULL, 'Aspartokinase', 191, NULL, NULL, 151365);
INSERT INTO "PUBLIC"."MODEL" VALUES
(151366, '3.30.70.330-FF-002352', NULL, NULL, 106, NULL, NULL, 151366),
(151367, '1.20.1110.10-FF-000124', NULL, NULL, 93, NULL, NULL, 151367),
(151368, '3.40.50.300-FF-007654', NULL, 'Gll3851 protein', 129, NULL, NULL, 151368),
(151369, '3.60.10.10-FF-000421', NULL, 'Predicted protein', 124, NULL, NULL, 151369),
(151370, '3.30.40.10-FF-000492', NULL, 'Tripartite motif containing 65', 75, NULL, NULL, 151370),
(151371, '2.60.40.10-FF-005990', NULL, NULL, 85, NULL, NULL, 151371),
(151372, '1.10.472.10-FF-000097', NULL, 'Pho85 cyclin', 190, NULL, NULL, 151372),
(151373, '3.40.1280.10-FF-000080', NULL, 'Uncharacterized tRNA/rRNA methyltransferase slr0955', 178, NULL, NULL, 151373),
(151374, '3.30.519.10-FF-000008', NULL, 'Rab GDP dissociation inhibitor', 161, NULL, NULL, 151374),
(151375, '2.60.120.650-FF-000245', NULL, 'Bifunctional lysine-specific demethylase and histidyl-hydroxylase NO66', 52, NULL, NULL, 151375),
(151376, '3.40.630.30-FF-000669', NULL, 'Elongator complex protein 3', 148, NULL, NULL, 151376),
(151377, '3.10.20.810-FF-000001', NULL, 'Histidine biosynthesis bifunctional protein HisIE', 96, NULL, NULL, 151377),
(151378, '1.25.40.10-FF-001144', NULL, 'Pre-mRNA-splicing factor SYF1', 247, NULL, NULL, 151378),
(151379, '3.10.290.70-FF-000004', NULL, '40S ribosomal protein S8', 114, NULL, NULL, 151379),
(151380, '1.25.40.10-FF-004921', NULL, 'Uncharacterized protein', 63, NULL, NULL, 151380),
(151381, '3.10.450.50-FF-000084', NULL, 'Nuclear export factor 3, isoform B', 170, NULL, NULL, 151381),
(151382, '3.40.50.970-FF-000014', NULL, '2-oxoglutarate dehydrogenase E1 component', 367, NULL, NULL, 151382),
(151383, '3.40.50.720-FF-002261', NULL, 'Uncharacterized protein', 50, NULL, NULL, 151383),
(151384, '2.170.120.12-FF-000016', NULL, 'RH25219p', 50, NULL, NULL, 151384),
(151385, '1.25.40.180-FF-000313', NULL, NULL, 272, NULL, NULL, 151385),
(151386, '1.10.510.10-FF-001900', NULL, 'Uncharacterized protein', 158, NULL, NULL, 151386),
(151387, '2.30.130.40-FF-000005', NULL, 'LON peptidase N-terminal domain and ring finger 1', 100, NULL, NULL, 151387),
(151388, '3.10.20.90-FF-000638', NULL, 'Microtubule-associated proteins 1A/1B light chain 3C-like Protein', 136, NULL, NULL, 151388),
(151389, '3.40.1780.10-FF-000005', NULL, 'S-adenosylmethionine:tRNA ribosyltransferase-isomerase', 86, NULL, NULL, 151389),
(151390, '3.30.365.10-FF-000066', NULL, 'Uncharacterized protein', 21, NULL, NULL, 151390),
(151391, '3.40.50.300-FF-007103', NULL, 'Si:dkeyp-75b4.9', 187, NULL, NULL, 151391),
(151392, '3.90.1420.10-FF-000057', NULL, 'Uncharacterized protein', 81, NULL, NULL, 151392),
(151393, '1.10.10.60-FF-000960', NULL, NULL, 58, NULL, NULL, 151393),
(151394, '3.30.465.10-FF-000051', NULL, 'FAD-binding oxidoreductase', 214, NULL, NULL, 151394),
(151395, '1.25.40.10-FF-001695', NULL, 'Pentatricopeptide repeat-containing protein At4g37170', 82, NULL, NULL, 151395),
(151396, '2.40.10.10-FF-000649', NULL, NULL, 119, NULL, NULL, 151396),
(151397, '3.30.200.20-FF-002492', NULL, 'Uncharacterized protein', 20, NULL, NULL, 151397),
(151398, '1.25.40.20-FF-000012', NULL, 'ankyrin repeat domain-containing protein 17 isoform X1', 244, NULL, NULL, 151398),
(151399, '3.30.710.10-FF-000408', NULL, 'Uncharacterized protein', 113, NULL, NULL, 151399),
(151400, '1.20.1250.20-FF-002020', NULL, 'Uncharacterized protein', 359, NULL, NULL, 151400),
(151401, '2.60.40.60-FF-000249', NULL, 'Starry night', 106, NULL, NULL, 151401),
(151402, '3.80.10.10-FF-002848', NULL, 'Uncharacterized protein', 135, NULL, NULL, 151402),
(151403, '3.30.70.330-FF-000323', NULL, 'RNA binding protein MSSP-2', 77, NULL, NULL, 151403),
(151404, '1.10.390.10-FF-000030', NULL, 'AGAP000129-PA', 230, NULL, NULL, 151404),
(151405, '2.30.30.790-FF-000007', NULL, 'Mitochondrial ribosomal protein, putative', 127, NULL, NULL, 151405),
(151406, '3.30.450.40-FF-000065', NULL, 'Hydrogenase-4 transcriptional activator', 177, NULL, NULL, 151406),
(151407, '3.40.1090.10-FF-000149', NULL, 'Uncharacterized protein', 160, NULL, NULL, 151407),
(151408, '3.40.50.10890-FF-000003', NULL, 'Integrator complex subunit 9', 169, NULL, NULL, 151408);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(151409, '2.60.200.20-FF-000190', NULL, 'SMAD/FHA domain-containing protein', 143, NULL, NULL, 151409),
(151410, '3.30.1360.120-FF-000088', NULL, 'Uncharacterized protein', 285, NULL, NULL, 151410),
(151411, '3.40.50.1170-FF-000011', NULL, 'Asparaginase/glutaminase', 191, NULL, NULL, 151411),
(151412, '1.20.1250.20-FF-001031', NULL, 'AGL277Wp', 250, NULL, NULL, 151412),
(151413, '3.10.20.90-FF-000217', NULL, 'Tubulin folding cofactor B', 89, NULL, NULL, 151413),
(151414, '3.40.190.10-FF-000045', NULL, 'Putative glutamate receptor ionotropic NMDA 3A', 109, NULL, NULL, 151414),
(151415, '3.90.180.10-FF-000022', NULL, 'NADP-dependent alcohol dehydrogenase', 158, NULL, NULL, 151415),
(151416, '3.40.50.12660-FF-000001', NULL, 'Metacaspase-1', 322, NULL, NULL, 151416),
(151417, '3.40.50.12390-FF-000009', NULL, '5''-3'' exoribonuclease', 140, NULL, NULL, 151417),
(151418, '3.30.70.1230-FF-000184', NULL, 'Predicted protein', 170, NULL, NULL, 151418),
(151419, '1.10.150.910-FF-000010', NULL, 'DNA damage-binding protein 1', 99, NULL, NULL, 151419),
(151420, '3.40.50.1220-FF-000049', NULL, 'Electron transfer flavoprotein alpha subunit', 126, NULL, NULL, 151420),
(151421, '1.10.510.10-FF-001080', NULL, 'NIMA related kinase 2', 195, NULL, NULL, 151421),
(151422, '1.10.287.70-FF-000442', NULL, 'Ionotropic receptor 68a, isoform A', 181, NULL, NULL, 151422),
(151423, '3.90.640.10-FF-000102', NULL, 'Actin, putative', 78, NULL, NULL, 151423),
(151424, '3.80.10.10-FF-001488', NULL, 'Receptor-like protein EIX1', 176, NULL, NULL, 151424),
(151425, '1.20.1310.20-FF-000013', NULL, 'Erythrocyte binding ligand-1', 180, NULL, NULL, 151425),
(151426, '2.40.30.270-FF-000017', NULL, 'YALI0B06897p', 108, NULL, NULL, 151426),
(151427, '3.30.460.10-FF-000203', NULL, 'Gsl0787 protein', 86, NULL, NULL, 151427),
(151428, '1.20.920.30-FF-000058', NULL, 'Uncharacterized protein', 175, NULL, NULL, 151428),
(151429, '3.90.640.10-FF-000041', NULL, 'Actin-related protein 6', 62, NULL, NULL, 151429),
(151430, '3.80.10.10-FF-000078', NULL, 'Leiomodin 3', 184, NULL, NULL, 151430),
(151431, '3.40.50.1370-FF-000015', NULL, 'ornithine carbamoyltransferase, chloroplastic', 140, NULL, NULL, 151431),
(151432, '3.30.40.10-FF-001801', NULL, 'Uncharacterized protein', 85, NULL, NULL, 151432),
(151433, '3.50.7.10-FF-000033', NULL, 'T-complex protein 1 subunit delta', 162, NULL, NULL, 151433),
(151434, '1.20.120.1080-FF-000014', NULL, 'Probable ATP-dependent RNA helicase DHX37', 120, NULL, NULL, 151434),
(151435, '2.30.30.770-FF-000001', NULL, '60S ribosomal protein L27', 136, NULL, NULL, 151435),
(151436, '1.20.1740.10-FF-000060', NULL, 'S-methylmethionine permease', 469, NULL, NULL, 151436),
(151437, '3.40.50.410-FF-000195', NULL, 'Protein transport protein SEC23', 81, NULL, NULL, 151437),
(151438, '3.30.40.10-FF-000441', NULL, 'Neuralized, isoform B', 71, NULL, NULL, 151438),
(151439, '2.130.10.10-FF-002718', NULL, 'Uncharacterized protein', 311, NULL, NULL, 151439),
(151440, '2.60.40.10-FF-005046', NULL, NULL, 102, NULL, NULL, 151440),
(151441, '1.20.1250.20-FF-002380', NULL, 'Facilitated trehalose transporter Tret1-2 homolog-like Protein', 206, NULL, NULL, 151441),
(151442, '2.130.10.10-FF-001308', NULL, 'Mitotic checkpoint protein BUB3', 314, NULL, NULL, 151442),
(151443, '3.40.50.2300-FF-000890', NULL, NULL, 211, NULL, NULL, 151443),
(151444, '1.10.510.10-FF-002440', NULL, 'Uncharacterized protein', 378, NULL, NULL, 151444),
(151445, '1.10.8.270-FF-000054', NULL, 'GTPase-activating protein gyp3', 130, NULL, NULL, 151445),
(151446, '2.40.170.20-FF-000067', NULL, 'TonB-dependent receptor', 527, NULL, NULL, 151446),
(151447, '2.130.10.10-FF-004394', NULL, 'Uncharacterized protein', 60, NULL, NULL, 151447),
(151448, '2.170.120.30-FF-000008', NULL, 'YbbR-like domain-containing protein', 106, NULL, NULL, 151448),
(151449, '3.90.320.10-FF-000062', NULL, 'Bifunctional ATP-dependent DNA helicase/ssDNA endodeoxyribonuclease', 213, NULL, NULL, 151449),
(151450, '3.40.30.10-FF-000182', NULL, 'Thioredoxin reductase', 98, NULL, NULL, 151450),
(151451, '2.130.10.10-FF-004214', NULL, 'Predicted protein', 151, NULL, NULL, 151451);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(151452, '3.30.420.150-FF-000023', NULL, 'Bifunctional 3-dehydroquinate synthase/phosphatase', 186, NULL, NULL, 151452),
(151453, '3.80.10.10-FF-000971', NULL, 'Leucine-rich repeat serine/threonine-protein kinase 1', 92, NULL, NULL, 151453),
(151454, '3.60.20.10-FF-000186', NULL, 'Acyl-homoserine lactone acylase PvdQ', 277, NULL, NULL, 151454),
(151455, '2.60.40.10-FF-005759', NULL, NULL, 77, NULL, NULL, 151455),
(151456, '1.25.10.10-FF-001316', NULL, 'Uncharacterized protein', 327, NULL, NULL, 151456),
(151457, '1.10.472.10-FF-000597', NULL, 'Uncharacterized protein', 23, NULL, NULL, 151457),
(151458, '2.60.40.10-FF-006035', NULL, NULL, 50, NULL, NULL, 151458),
(151459, '3.80.10.10-FF-004473', NULL, 'Uncharacterized protein', 251, NULL, NULL, 151459),
(151460, '1.10.287.70-FF-000493', NULL, 'Predicted protein', 112, NULL, NULL, 151460),
(151461, '2.60.40.10-FF-003573', NULL, NULL, 94, NULL, NULL, 151461),
(151462, '3.40.50.1460-FF-000042', NULL, 'HEAT repeat domain containing protein', 197, NULL, NULL, 151462),
(151463, '1.20.1070.10-FF-000536', NULL, 'Predicted novel alpha-adrenergic-like G-protein coupled receptor', 300, NULL, NULL, 151463),
(151464, '2.10.110.10-FF-000236', NULL, 'Lim homeobox protein, putative', 79, NULL, NULL, 151464),
(151465, '3.30.1010.10-FF-000045', NULL, 'Ataxia telangiectasia mutated, putative', 141, NULL, NULL, 151465),
(151466, '3.40.50.1820-FF-000813', NULL, 'Pyoverdine synthetase D', 248, NULL, NULL, 151466),
(151467, '1.20.960.30-FF-000004', NULL, 'Nuclear distribution protein PAC1', 112, NULL, NULL, 151467),
(151468, '2.60.120.260-FF-000302', NULL, 'Beta-galactosidase', 184, NULL, NULL, 151468),
(151469, '1.10.1530.10-FF-000001', NULL, '2,3-diketo-L-gulonate reductase', 70, NULL, NULL, 151469),
(151470, '1.10.1380.10-FF-000005', NULL, 'Kell blood group, metallo-endopeptidase', 360, NULL, NULL, 151470),
(151471, '3.30.200.20-FF-000479', NULL, 'Putative inactive leucine-rich repeat receptor-like protein kinase', 120, NULL, NULL, 151471),
(151472, '2.120.10.30-FF-000128', NULL, 'Predicted protein', 86, NULL, NULL, 151472),
(151473, '3.40.50.300-FF-000858', NULL, 'Nickel import ATP-binding protein NikD', 247, NULL, NULL, 151473),
(151474, '3.40.50.720-FF-002322', NULL, 'Probable 2-hydroxyacid dehydrogenase', 121, NULL, NULL, 151474),
(151475, '3.40.50.300-FF-000566', NULL, 'Signal recognition particle receptor subunit alpha', 225, NULL, NULL, 151475),
(151476, '3.30.460.30-FF-000001', NULL, 'Glutamyl-tRNA reductase', 160, NULL, NULL, 151476),
(151477, '1.10.10.10-FF-001344', NULL, 'ESCRT-II subunit protein', 79, NULL, NULL, 151477),
(151478, '3.90.740.10-FF-000054', NULL, 'Isoleucine--tRNA ligase', 149, NULL, NULL, 151478),
(151479, '3.30.60.300-FF-000003', NULL, '60S ribosomal protein L10, putative', 43, NULL, NULL, 151479),
(151480, '1.10.10.10-FF-001687', NULL, 'Interferon regulatory factor like protein', 114, NULL, NULL, 151480),
(151481, '2.60.120.200-FF-000571', NULL, 'Putative L-type lectin-domain containing receptor kinase V.8', 82, NULL, NULL, 151481),
(151482, '1.10.10.10-FF-001636', NULL, 'Histone H1.2', 85, NULL, NULL, 151482),
(151483, '3.30.70.330-FF-002740', NULL, NULL, 94, NULL, NULL, 151483),
(151484, '3.30.60.30-FF-000038', NULL, 'Solute carrier organic anion transporter family member', 54, NULL, NULL, 151484),
(151485, '2.130.10.10-FF-001460', NULL, 'COMPASS-like H3K4 histone methylase component WDR5B', 93, NULL, NULL, 151485),
(151486, '2.130.10.10-FF-002365', NULL, 'GM25543', 152, NULL, NULL, 151486),
(151487, '2.60.40.10-FF-004478', NULL, NULL, 115, NULL, NULL, 151487),
(151488, '3.40.50.300-FF-002371', NULL, 'Predicted protein', 201, NULL, NULL, 151488),
(151489, '2.60.120.260-FF-000010', NULL, 'Laminin subunit beta 1', 254, NULL, NULL, 151489),
(151490, '3.40.1500.10-FF-000018', NULL, 'Uncharacterized protein', 287, NULL, NULL, 151490),
(151491, '2.20.110.10-FF-000003', NULL, 'Junctophilin', 48, NULL, NULL, 151491),
(151492, '1.25.40.20-FF-001552', NULL, 'Os09g0343200 protein', 108, NULL, NULL, 151492),
(151493, '3.40.50.300-FF-006294', NULL, 'Elongation factor G, mitochondrial', 293, NULL, NULL, 151493);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(151494, '1.20.1560.10-FF-000736', NULL, 'Uncharacterized protein', 177, NULL, NULL, 151494),
(151495, '1.10.510.10-FF-000883', NULL, 'Tau TuBulin Kinase', 330, NULL, NULL, 151495),
(151496, '1.25.40.10-FF-002504', NULL, 'SART-3/p110 homolog', 288, NULL, NULL, 151496),
(151497, '2.10.110.10-FF-000287', NULL, 'Predicted protein', 65, NULL, NULL, 151497),
(151498, '3.60.20.10-FF-000135', NULL, 'Acyl-homoserine lactone acylase QuiP', 324, NULL, NULL, 151498),
(151499, '3.20.70.20-FF-000019', NULL, 'Anaerobic ribonucleoside-triphosphate reductase', 556, NULL, NULL, 151499),
(151500, '3.60.10.10-FF-000360', NULL, 'Uncharacterized protein', 136, NULL, NULL, 151500),
(151501, '1.25.10.10-FF-001367', NULL, 'Nuclear transport factor, putative', 998, NULL, NULL, 151501),
(151502, '3.30.40.10-FF-002257', NULL, 'Origin recognition complex subunit 1', 56, NULL, NULL, 151502),
(151503, '1.20.1070.10-FF-000087', NULL, 'prostaglandin E2 receptor EP3 subtype', 326, NULL, NULL, 151503),
(151504, '3.50.50.60-FF-001338', NULL, 'Uncharacterized protein', 219, NULL, NULL, 151504),
(151505, '1.10.287.110-FF-000095', NULL, 'DnaJ domain containing protein', 94, NULL, NULL, 151505),
(151506, '3.30.160.60-FF-001605', NULL, 'Zinc finger protein 646', 28, NULL, NULL, 151506),
(151507, '1.20.1270.280-FF-000072', NULL, 'Dynein heavy chain 3', 105, NULL, NULL, 151507),
(151508, '3.40.50.300-FF-004748', NULL, 'Os02g0684150 protein', 190, NULL, NULL, 151508),
(151509, '3.30.930.10-FF-000099', NULL, 'Histidine--tRNA ligase', 336, NULL, NULL, 151509),
(151510, '4.10.60.10-FF-000087', NULL, 'Protein CBG24470', 67, NULL, NULL, 151510),
(151511, '2.40.30.60-FF-000002', NULL, '16S rRNA processing protein RimM family', 95, NULL, NULL, 151511),
(151512, '3.90.79.10-FF-000027', NULL, 'nucleoside diphosphate-linked moiety X motif 6', 140, NULL, NULL, 151512),
(151513, '3.30.420.40-FF-000917', NULL, 'Uncharacterized protein', 24, NULL, NULL, 151513),
(151514, '3.30.70.330-FF-000435', NULL, 'Polyadenylate-binding protein', 96, NULL, NULL, 151514),
(151515, '3.90.105.20-FF-000008', NULL, 'Ribosome assembly factor mrt4', 73, NULL, NULL, 151515),
(151516, '3.90.660.10-FF-000053', NULL, 'Amine oxidase family member 1', 235, NULL, NULL, 151516),
(151517, '3.30.160.60-FF-001701', NULL, 'zinc finger protein 777', 39, NULL, NULL, 151517),
(151518, '3.30.40.10-FF-000941', NULL, 'Ring finger protein, putative', 81, NULL, NULL, 151518),
(151519, '2.60.450.10-FF-000020', NULL, 'Lipopolysaccharide export system protein LptC', 128, NULL, NULL, 151519),
(151520, '1.20.1420.10-FF-000013', NULL, 'Rhea, isoform B', 170, NULL, NULL, 151520),
(151521, '2.40.100.10-FF-000083', NULL, 'Putative cyclophilin 8', 166, NULL, NULL, 151521),
(151522, '2.60.220.50-FF-000065', NULL, 'Predicted protein', 49, NULL, NULL, 151522),
(151523, '3.20.20.100-FF-000123', NULL, 'Aflatoxin B1 aldehyde reductase member 2', 129, NULL, NULL, 151523),
(151524, '2.60.120.1440-FF-000009', NULL, 'Regulatory protein, putative', 143, NULL, NULL, 151524),
(151525, '3.10.110.10-FF-000350', NULL, 'Predicted protein', 121, NULL, NULL, 151525),
(151526, '3.40.50.40-FF-000012', NULL, NULL, 125, NULL, NULL, 151526),
(151527, '3.10.20.310-FF-000042', NULL, 'Outer membrane protein assembly factor BamA', 80, NULL, NULL, 151527),
(151528, '3.30.160.60-FF-001313', NULL, 'Zinc finger protein 155', 35, NULL, NULL, 151528),
(151529, '2.70.150.10-FF-000051', NULL, 'Phospholipid-transporting ATPase, putative', 36, NULL, NULL, 151529),
(151530, '2.40.50.140-FF-001146', NULL, NULL, 74, NULL, NULL, 151530),
(151531, '3.90.550.50-FF-000096', NULL, 'GM18190', 196, NULL, NULL, 151531),
(151532, '2.60.120.200-FF-000520', NULL, 'Uncharacterized protein', 224, NULL, NULL, 151532),
(151533, '1.10.630.10-FF-000419', NULL, 'Cytochrome P450 monooxygenase, putative', 237, NULL, NULL, 151533),
(151534, '2.60.40.1930-FF-000022', NULL, 'Complement C4', 100, NULL, NULL, 151534),
(151535, '3.60.15.10-FF-000056', NULL, 'integrator complex subunit 9', 205, NULL, NULL, 151535),
(151536, '3.50.50.60-FF-001046', NULL, 'Succinate dehydrogenase [ubiquinone] flavoprotein subunit 1 mitochondrial', 26, NULL, NULL, 151536);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(151537, '3.90.190.10-FF-000180', NULL, 'Protein tyrosine phosphatase', 158, NULL, NULL, 151537),
(151538, '3.40.50.300-FF-008059', NULL, 'Arf-GAP with GTPase, ANK repeat and PH domain-containing protein 9', 125, NULL, NULL, 151538),
(151539, '1.20.1270.60-FF-000330', NULL, 'Uncharacterized protein', 273, NULL, NULL, 151539),
(151540, '3.40.50.11610-FF-000040', NULL, NULL, 13, NULL, NULL, 151540),
(151541, '1.20.1280.50-FF-000007', NULL, 'F-box/LRR-repeat protein 5 isoform X1', 101, NULL, NULL, 151541),
(151542, '2.160.10.10-FF-000048', NULL, 'Serine acetyltransferase-related protein', 109, NULL, NULL, 151542),
(151543, '2.60.40.10-FF-003522', NULL, NULL, 113, NULL, NULL, 151543),
(151544, '3.30.1010.10-FF-000096', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit, putative', 129, NULL, NULL, 151544),
(151545, '3.40.47.10-FF-000237', NULL, NULL, 60, NULL, NULL, 151545),
(151546, '3.90.470.20-FF-000047', NULL, 'Uncharacterized protein', 97, NULL, NULL, 151546),
(151547, '3.90.70.40-FF-000022', NULL, 'Uncharacterized protein', 71, NULL, NULL, 151547),
(151548, '3.40.50.300-FF-000807', NULL, 'galactosylceramide sulfotransferase isoform X1', 267, NULL, NULL, 151548),
(151549, '2.60.120.10-FF-000208', NULL, 'Catabolite gene activator', 201, NULL, NULL, 151549),
(151550, '2.60.40.10-FF-000296', NULL, 'Tyrosine-protein kinase receptor TYRO3', 83, NULL, NULL, 151550),
(151551, '1.10.10.60-FF-000229', NULL, 'Homeobox-leucine zipper protein HDG1', 87, NULL, NULL, 151551),
(151552, '4.10.640.10-FF-000004', NULL, '30S ribosomal protein S18', 69, NULL, NULL, 151552),
(151553, '2.130.10.10-FF-000920', NULL, 'WD repeat-containing protein 92', 356, NULL, NULL, 151553),
(151554, '3.30.710.10-FF-000329', NULL, 'Rho-related BTB domain-containing protein 1', 134, NULL, NULL, 151554),
(151555, '3.30.160.60-FF-004478', NULL, NULL, 27, NULL, NULL, 151555),
(151556, '2.60.40.150-FF-000732', NULL, 'Putative U5 small nuclear ribonucleoprotein 200 kDa helicase-like protein', 112, NULL, NULL, 151556),
(151557, '3.30.40.10-FF-002206', NULL, 'Uncharacterized protein', 72, NULL, NULL, 151557),
(151558, '1.10.10.60-FF-000049', NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily A member', 107, NULL, NULL, 151558),
(151559, '1.20.58.760-FF-000024', NULL, 'ATP-dependent zinc metalloprotease FtsH', 205, NULL, NULL, 151559),
(151560, '2.60.120.330-FF-000059', NULL, '1-aminocyclopropane-1-carboxylate oxidase 1', 311, NULL, NULL, 151560),
(151561, '3.40.50.80-FF-000125', NULL, 'Flavohemoglobin', 147, NULL, NULL, 151561),
(151562, '2.60.120.200-FF-000419', NULL, 'Laminin, alpha 5', 207, NULL, NULL, 151562),
(151563, '1.20.5.1160-FF-000042', NULL, 'Coiled-coil domain-containing 136b', 72, NULL, NULL, 151563),
(151564, '1.10.1520.10-FF-000124', NULL, 'Predicted protein', 67, NULL, NULL, 151564),
(151565, '3.20.20.70-FF-000458', NULL, 'Uncharacterized protein', 264, NULL, NULL, 151565),
(151566, '1.10.246.140-FF-000005', NULL, 'Transcription and mRNA export factor ENY2', 91, NULL, NULL, 151566),
(151567, '3.10.100.10-FF-000405', NULL, NULL, 111, NULL, NULL, 151567),
(151568, '3.40.190.190-FF-000001', NULL, 'High affinity transport system protein', 189, NULL, NULL, 151568),
(151569, '1.25.40.20-FF-000124', NULL, 'NF-kappa-B inhibitor alpha isoform X2', 235, NULL, NULL, 151569),
(151570, '3.40.30.10-FF-000974', NULL, 'Glutathione peroxidase', 95, NULL, NULL, 151570),
(151571, '3.30.590.10-FF-000027', NULL, 'Glutamine synthetase III', 340, NULL, NULL, 151571),
(151572, '3.40.50.970-FF-000126', NULL, 'Phosphonopyruvate decarboxylase-like protein', 174, NULL, NULL, 151572),
(151573, '3.40.50.720-FF-002373', NULL, 'Uncharacterized protein', 94, NULL, NULL, 151573),
(151574, '3.40.50.150-FF-000448', NULL, 'SAM-dependent methyltransferase', 245, NULL, NULL, 151574),
(151575, '3.30.160.60-FF-003910', NULL, NULL, 31, NULL, NULL, 151575),
(151576, '3.90.190.10-FF-000028', NULL, 'Dual specificity phosphatase 10', 153, NULL, NULL, 151576),
(151577, '3.40.50.300-FF-004169', NULL, 'Atlastin 3', 107, NULL, NULL, 151577);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(151578, '3.30.420.40-FF-000125', NULL, 'Chaperone protein DnaK 1', 13, NULL, NULL, 151578),
(151579, '3.80.10.10-FF-000527', NULL, 'Serine/threonine kinase 11 interacting protein', 150, NULL, NULL, 151579),
(151580, '2.40.20.10-FF-000094', NULL, 'Predicted protein', 103, NULL, NULL, 151580),
(151581, '3.40.50.150-FF-000499', NULL, 'rRNA methyltransferase', 225, NULL, NULL, 151581),
(151582, '3.10.10.10-FF-000002', NULL, 'Retrovirus-related Pol polyprotein from transposon 17.6-like protein', 111, NULL, NULL, 151582),
(151583, '1.25.40.180-FF-000021', NULL, 'Nuclear cap binding protein subunit 1', 289, NULL, NULL, 151583),
(151584, '1.10.1330.10-FF-000002', NULL, 'S8 family serine protease', 64, NULL, NULL, 151584),
(151585, '1.10.730.10-FF-000163', NULL, 'Methionine--tRNA ligase', 176, NULL, NULL, 151585),
(151586, '3.40.50.1820-FF-000072', NULL, 'Serine carboxypeptidase-like 19', 269, NULL, NULL, 151586),
(151587, '1.25.10.10-FF-000086', NULL, 'protein zyg-11 homolog B isoform X2', 390, NULL, NULL, 151587),
(151588, '3.90.1150.10-FF-000244', NULL, 'Probable transcriptional regulator', 147, NULL, NULL, 151588),
(151589, '3.30.230.10-FF-000074', NULL, 'DNA mismatch repair protein (Pms1)', 139, NULL, NULL, 151589),
(151590, '3.40.367.20-FF-000009', NULL, 'Phosphotransferase', 255, NULL, NULL, 151590),
(151591, '1.10.287.70-FF-000150', NULL, 'Two pore potassium channel c', 99, NULL, NULL, 151591),
(151592, '1.20.1070.10-FF-000980', NULL, 'Uncharacterized protein', 392, NULL, NULL, 151592),
(151593, '1.10.472.10-FF-000546', NULL, 'Cyclin T2', 77, NULL, NULL, 151593),
(151594, '2.60.40.420-FF-000156', NULL, 'Aspergillus niger contig An12c0160, genomic contig', 155, NULL, NULL, 151594),
(151595, '3.30.310.40-FF-000004', NULL, 'Ogg1p', 86, NULL, NULL, 151595),
(151596, '2.60.40.150-FF-000783', NULL, 'Predicted protein', 96, NULL, NULL, 151596),
(151597, '2.10.25.10-FF-000302', NULL, 'latent-transforming growth factor beta-binding protein 3 isoform X2', 45, NULL, NULL, 151597),
(151598, '1.20.58.60-FF-000294', NULL, 'Spectrin beta chain', 110, NULL, NULL, 151598),
(151599, '3.90.550.10-FF-000275', NULL, 'Uncharacterized protein', 246, NULL, NULL, 151599),
(151600, '2.30.42.10-FF-000280', NULL, 'Big bang, isoform C', 129, NULL, NULL, 151600),
(151601, '3.80.10.10-FF-002556', NULL, 'YALI0A17358p', 142, NULL, NULL, 151601),
(151602, '2.120.10.30-FF-000207', NULL, 'Uncharacterized protein', 129, NULL, NULL, 151602),
(151603, '3.40.50.1000-FF-000831', NULL, NULL, 81, NULL, NULL, 151603),
(151604, '1.25.10.10-FF-000827', NULL, 'Importin alpha subunit, putative', 424, NULL, NULL, 151604),
(151605, '3.30.160.60-FF-000296', NULL, 'Zinc fingers and homeoboxes protein 1', 88, NULL, NULL, 151605),
(151606, '3.30.450.190-FF-000001', NULL, 'Ras-related GTP-binding protein C', 138, NULL, NULL, 151606),
(151607, '3.30.70.260-FF-000066', NULL, 'Chorismate mutase/prephenate dehydratase', 91, NULL, NULL, 151607),
(151608, '3.60.15.10-FF-000005', NULL, 'Cleavage and polyadenylation specificity factor subunit 3', 226, NULL, NULL, 151608),
(151609, '1.25.40.10-FF-004842', NULL, 'Pentatricopeptide repeat-containing protein', 139, NULL, NULL, 151609),
(151610, '1.10.287.770-FF-000006', NULL, 'acid-sensing ion channel 2', 30, NULL, NULL, 151610),
(151611, '3.40.50.1010-FF-000216', NULL, NULL, 131, NULL, NULL, 151611),
(151612, '3.40.50.1460-FF-000121', NULL, 'Uncharacterized protein', 246, NULL, NULL, 151612),
(151613, '1.20.1540.10-FF-000061', NULL, 'Rhomboid-6, isoform B', 193, NULL, NULL, 151613),
(151614, '1.10.8.60-FF-000240', NULL, 'Uncharacterized protein', 90, NULL, NULL, 151614),
(151615, '3.30.420.10-FF-000633', NULL, NULL, 159, NULL, NULL, 151615),
(151616, '1.20.144.10-FF-000102', NULL, 'Putative phosphatidate phosphatase-like Protein', 241, NULL, NULL, 151616),
(151617, '1.50.40.10-FF-000563', NULL, 'Uncharacterized protein', 117, NULL, NULL, 151617),
(151618, '3.30.200.20-FF-000428', NULL, 'Inactive LRR receptor-like serine/threonine-protein kinase BIR2', 114, NULL, NULL, 151618),
(151619, '3.40.50.1910-FF-000008', NULL, 'vacuolar protein sorting-associated protein 33A isoform X2', 127, NULL, NULL, 151619);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(151620, '4.10.1000.40-FF-000001', NULL, 'zinc finger CCCH domain-containing protein 14 isoform X2', 58, NULL, NULL, 151620),
(151621, '3.40.50.620-FF-000252', NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', 352, NULL, NULL, 151621),
(151622, '2.10.25.10-FF-000662', NULL, 'Eyes shut, isoform E', 37, NULL, NULL, 151622),
(151623, '1.10.555.10-FF-000233', NULL, NULL, 182, NULL, NULL, 151623),
(151624, '3.30.70.330-FF-002791', NULL, NULL, 44, NULL, NULL, 151624),
(151625, '1.10.150.50-FF-000153', NULL, 'Uncharacterized protein', 64, NULL, NULL, 151625),
(151626, '3.30.450.20-FF-000138', NULL, 'VWFA and cache domain-containing protein CG16868', 107, NULL, NULL, 151626),
(151627, '1.10.510.10-FF-003345', NULL, NULL, 239, NULL, NULL, 151627),
(151628, '1.10.260.100-FF-000011', NULL, 'TPR Domain containing protein', 52, NULL, NULL, 151628),
(151629, '1.10.510.10-FF-000523', NULL, 'Serine/threonine-protein kinase PITSLRE', 211, NULL, NULL, 151629),
(151630, '2.170.200.10-FF-000003', NULL, 'Regulatory protein E2', 105, NULL, NULL, 151630),
(151631, '3.30.420.40-FF-000176', NULL, 'Chromatin remodeling complex subunit (Arp5)', 42, NULL, NULL, 151631),
(151632, '3.40.190.10-FF-000606', NULL, 'Sll0224 protein', 149, NULL, NULL, 151632),
(151633, '1.10.510.10-FF-000815', NULL, 'Protein kinase, putative', 236, NULL, NULL, 151633),
(151634, '3.30.160.60-FF-005124', NULL, NULL, 84, NULL, NULL, 151634),
(151635, '3.50.50.60-FF-000557', NULL, 'Pyridine nucleotide-disulfide oxidoreductase/Thi4 family/FAD dependent oxidoreductase/NAD(P)-binding Rossmann-like domain containing protein, putative', 41, NULL, NULL, 151635),
(151636, '3.90.650.10-FF-000047', NULL, 'Phosphoribosylformylglycinamidine synthase', 145, NULL, NULL, 151636),
(151637, '1.10.8.1210-FF-000003', NULL, 'Glutamate dehydrogenase', 31, NULL, NULL, 151637),
(151638, '3.40.50.1820-FF-000633', NULL, '2-oxoglutarate decarboxylase/hydro-lyase/magnesium ion-binding protein', 271, NULL, NULL, 151638),
(151639, '3.40.50.720-FF-000248', NULL, 'Glucose 1-dehydrogenase', 261, NULL, NULL, 151639),
(151640, '1.10.510.10-FF-002889', NULL, NULL, 196, NULL, NULL, 151640),
(151641, '2.30.30.490-FF-000007', NULL, 'bromo adjacent homology domain-containing 1 protein isoform X1', 138, NULL, NULL, 151641),
(151642, '1.20.1070.10-FF-000648', NULL, 'Predicted protein', 316, NULL, NULL, 151642),
(151643, '3.90.1410.10-FF-000051', NULL, 'SET (Trithorax/polycomb) domain containing', 246, NULL, NULL, 151643),
(151644, '3.50.30.30-FF-000108', NULL, 'AER157Cp', 258, NULL, NULL, 151644),
(151645, '3.40.50.150-FF-000824', NULL, 'Transferase', 227, NULL, NULL, 151645),
(151646, '2.40.10.10-FF-000306', NULL, 'IP19845p', 127, NULL, NULL, 151646),
(151647, '3.40.50.1700-FF-000002', NULL, 'Glycosyl hydrolase family protein', 227, NULL, NULL, 151647),
(151648, '3.20.20.140-FF-000056', NULL, 'Amidohydrolase', 368, NULL, NULL, 151648),
(151649, '1.10.10.60-FF-001005', NULL, NULL, 78, NULL, NULL, 151649),
(151650, '3.40.140.10-FF-000042', NULL, 'Mov34/MPN/PAD-1 family protein', 164, NULL, NULL, 151650),
(151651, '3.40.50.720-FF-001833', NULL, 'Bone marrow stromal cell antigen 1', 125, NULL, NULL, 151651),
(151652, '1.10.1410.10-FF-000003', NULL, 'non-canonical poly(A) RNA polymerase PAPD7', 171, NULL, NULL, 151652),
(151653, '3.90.25.10-FF-000027', NULL, 'dTDP-glucose 4,6-dehydratase', 71, NULL, NULL, 151653),
(151654, '2.130.10.10-FF-002426', NULL, 'Uncharacterized protein AT4g01860', 262, NULL, NULL, 151654),
(151655, '3.40.50.300-FF-007093', NULL, 'Uncharacterized protein', 190, NULL, NULL, 151655),
(151656, '1.10.238.10-FF-000783', NULL, 'Uncharacterized protein', 78, NULL, NULL, 151656),
(151657, '2.130.10.150-FF-000001', NULL, 'Acylamino-acid-releasing enzyme', 291, NULL, NULL, 151657),
(151658, '3.30.1370.10-FF-000066', NULL, 'KH domain containing 4, pre-mRNA splicing factor', 91, NULL, NULL, 151658),
(151659, '2.30.29.30-FF-000614', NULL, 'Guanine nucleotide exchange factor UNC-73A', 135, NULL, NULL, 151659),
(151660, '3.90.79.10-FF-000207', NULL, 'Uncharacterized protein', 221, NULL, NULL, 151660);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(151661, '3.30.70.330-FF-002801', NULL, NULL, 148, NULL, NULL, 151661),
(151662, '3.80.10.10-FF-000319', NULL, 'Tyrosine-protein kinase receptor', 116, NULL, NULL, 151662),
(151663, '1.10.238.10-FF-000839', NULL, 'Polcalcin Cup a 4', 77, NULL, NULL, 151663),
(151664, '2.70.170.10-FF-000254', NULL, 'Uncharacterized protein', 197, NULL, NULL, 151664),
(151665, '2.60.40.10-FF-001364', NULL, 'Interleukin 23 receptor', 94, NULL, NULL, 151665),
(151666, '1.10.533.10-FF-000216', NULL, 'Tumor necrosis factor receptor superfamily member 6', 101, NULL, NULL, 151666),
(151667, '1.20.1070.10-FF-002161', NULL, 'C1A receptor, putative', 143, NULL, NULL, 151667),
(151668, '1.25.40.10-FF-001083', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 122, NULL, NULL, 151668),
(151669, '3.40.50.300-FF-003388', NULL, 'Uncharacterized protein', 97, NULL, NULL, 151669),
(151670, '2.130.10.10-FF-004574', NULL, 'Uncharacterized protein, isoform A', 210, NULL, NULL, 151670),
(151671, '3.20.20.80-FF-000787', NULL, 'Membrane-bound maltase-glucoamylase', 193, NULL, NULL, 151671),
(151672, '3.30.160.60-FF-005708', NULL, NULL, 55, NULL, NULL, 151672),
(151673, '1.10.510.10-FF-001372', NULL, 'eIF-2 alpha kinase', 142, NULL, NULL, 151673),
(151674, '3.20.19.10-FF-000010', NULL, 'Aconitate hydratase', 110, NULL, NULL, 151674),
(151675, '3.30.70.330-FF-000615', NULL, 'Os09g0374500 protein', 119, NULL, NULL, 151675),
(151676, '3.40.720.10-FF-000300', NULL, 'Uncharacterized protein', 238, NULL, NULL, 151676),
(151677, '3.30.420.40-FF-000737', NULL, 'Actin-like protein 2', 110, NULL, NULL, 151677),
(151678, '2.170.210.10-FF-000009', NULL, 'Xrcc4-like factor 1', 130, NULL, NULL, 151678),
(151679, '1.25.40.20-FF-001765', NULL, 'Predicted protein', 192, NULL, NULL, 151679),
(151680, '2.60.40.4370-FF-000012', NULL, NULL, 94, NULL, NULL, 151680),
(151681, '2.60.40.10-FF-002792', NULL, 'Uncharacterized protein', 111, NULL, NULL, 151681),
(151682, '1.25.40.10-FF-005034', NULL, 'Putative pentatricopeptide repeat-containing protein At1g12700, mitochondrial', 140, NULL, NULL, 151682),
(151683, '2.70.160.11-FF-000053', NULL, 'Protein arginine N-methyltransferase 1', 44, NULL, NULL, 151683),
(151684, '3.40.850.10-FF-000169', NULL, 'Kinesin, putative', 323, NULL, NULL, 151684),
(151685, '1.10.238.10-FF-000098', NULL, 'calcium-binding mitochondrial carrier protein SCaMC-2 isoform X1', 78, NULL, NULL, 151685),
(151686, '3.20.180.20-FF-000035', NULL, 'Uncharacterized protein', 97, NULL, NULL, 151686),
(151687, '1.10.10.1230-FF-000003', NULL, 'Penicillin-binding protein H', 118, NULL, NULL, 151687),
(151688, '3.90.190.20-FF-000065', NULL, 'Uncharacterized protein', 109, NULL, NULL, 151688),
(151689, '2.40.50.140-FF-000365', NULL, 'Lysine-tRNA ligase', 154, NULL, NULL, 151689),
(151690, '3.40.50.620-FF-000201', NULL, 'Universal stress protein PHOS34', 180, NULL, NULL, 151690),
(151691, '3.30.710.10-FF-000116', NULL, 'SLX4 structure-specific endonuclease subunit', 129, NULL, NULL, 151691),
(151692, '3.20.20.100-FF-000044', NULL, 'Aldose reductase', 293, NULL, NULL, 151692),
(151693, '1.10.150.530-FF-000002', NULL, 'Probable dual-specificity RNA methyltransferase RlmN', 77, NULL, NULL, 151693),
(151694, '3.10.20.10-FF-000008', NULL, 'Cell death inducing DFFA like effector a', 112, NULL, NULL, 151694),
(151695, '2.60.120.200-FF-000751', NULL, 'Galectin', 124, NULL, NULL, 151695),
(151696, '2.60.40.290-FF-000009', NULL, 'Beta-N-acetylhexosaminidase HexB', 137, NULL, NULL, 151696),
(151697, '3.40.50.720-FF-000405', NULL, 'Uncharacterized protein, isoform A', 117, NULL, NULL, 151697),
(151698, '3.40.50.1100-FF-000131', NULL, 'Diaminopropionate ammonia-lyase', 118, NULL, NULL, 151698),
(151699, '2.130.10.10-FF-005563', NULL, 'Uncharacterized protein', 215, NULL, NULL, 151699),
(151700, '2.70.70.10-FF-000062', NULL, 'Membrane protein related to metalloendopeptidase', 133, NULL, NULL, 151700),
(151701, '2.60.40.10-FF-004978', NULL, NULL, 109, NULL, NULL, 151701),
(151702, '3.30.1490.70-FF-000003', NULL, 'Probable ATP-dependent DNA ligase', 58, NULL, NULL, 151702);
INSERT INTO "PUBLIC"."MODEL" VALUES
(151703, '1.10.472.10-FF-000658', NULL, 'Uncharacterized protein', 97, NULL, NULL, 151703),
(151704, '2.60.40.1180-FF-000100', NULL, 'Alpha-L-fucosidase', 109, NULL, NULL, 151704),
(151705, '1.20.5.190-FF-000090', NULL, 'Abnormal spindle microtubule assembly', 40, NULL, NULL, 151705),
(151706, '1.25.10.10-FF-003441', NULL, 'Uncharacterized protein', 256, NULL, NULL, 151706),
(151707, '2.10.110.10-FF-000005', NULL, 'Testin isoform 1', 59, NULL, NULL, 151707),
(151708, '3.40.50.620-FF-000044', NULL, 'GMP synthase [glutamine-hydrolyzing]', 221, NULL, NULL, 151708),
(151709, '2.60.40.1180-FF-000196', NULL, 'Alpha-mannosidase', 116, NULL, NULL, 151709),
(151710, '3.40.50.300-FF-006373', NULL, 'Replication factor C subunit 5', 137, NULL, NULL, 151710),
(151711, '3.80.10.10-FF-000471', NULL, 'Leucine rich repeat containing 29', 204, NULL, NULL, 151711),
(151712, '2.60.40.150-FF-000283', NULL, 'Non-specific serine/threonine protein kinase', 111, NULL, NULL, 151712),
(151713, '3.30.40.10-FF-000048', NULL, 'nucleosome-remodeling factor subunit BPTF isoform X1', 67, NULL, NULL, 151713),
(151714, '3.30.40.10-FF-002178', NULL, 'Ring finger protein 112, gene 2', 81, NULL, NULL, 151714),
(151715, '1.25.40.20-FF-001181', NULL, 'Uncharacterized protein', 171, NULL, NULL, 151715),
(151716, '3.30.450.40-FF-000245', NULL, 'Phosphodiesterase', 201, NULL, NULL, 151716),
(151717, '1.25.40.10-FF-002425', NULL, 'Pentatricopeptide repeat-containing protein At1g22830', 134, NULL, NULL, 151717),
(151718, '3.40.50.300-FF-001314', NULL, 'DNA replication licensing factor MCM8', 338, NULL, NULL, 151718),
(151719, '3.80.10.10-FF-002505', NULL, 'Uncharacterized protein', 147, NULL, NULL, 151719),
(151720, '1.25.10.10-FF-003284', NULL, 'Uncharacterized protein', 186, NULL, NULL, 151720),
(151721, '1.25.40.10-FF-003853', NULL, 'Uncharacterized protein', 113, NULL, NULL, 151721),
(151722, '2.10.90.10-FF-000060', NULL, 'Spatzle 6', 68, NULL, NULL, 151722),
(151723, '3.10.330.20-FF-000010', NULL, 'tRNA (adenine(58)-N(1))-methyltransferase catalytic subunit TRMT61A', 70, NULL, NULL, 151723),
(151724, '2.130.10.10-FF-003433', NULL, 'Predicted protein', 159, NULL, NULL, 151724),
(151725, '2.60.40.4240-FF-000001', NULL, 'Churchill domain containing 1', 106, NULL, NULL, 151725),
(151726, '3.30.70.141-FF-000014', NULL, 'Nucleoside diphosphate kinase', 153, NULL, NULL, 151726),
(151727, '3.30.70.330-FF-002060', NULL, NULL, 90, NULL, NULL, 151727),
(151728, '3.40.50.12780-FF-000071', NULL, 'Long-chain-fatty-acid--ACP ligase MbtM', 407, NULL, NULL, 151728),
(151729, '2.30.30.140-FF-000262', NULL, 'Histone acetyltransferase', 128, NULL, NULL, 151729),
(151730, '3.40.50.300-FF-002983', NULL, 'Mtg2p', 179, NULL, NULL, 151730),
(151731, '3.40.50.1820-FF-000313', NULL, '1-alkyl-2-acetylglycerophosphocholine esterase', 382, NULL, NULL, 151731),
(151732, '2.20.100.10-FF-000126', NULL, 'Lonely heart, isoform A', 54, NULL, NULL, 151732),
(151733, '3.90.70.10-FF-000890', NULL, 'Type I protein secretion system bifunctional ATPase and permease component AggC', 125, NULL, NULL, 151733),
(151734, '3.30.420.40-FF-000968', NULL, 'DnaK protein', 98, NULL, NULL, 151734),
(151735, '2.60.120.200-FF-000363', NULL, 'Agrin, putative', 76, NULL, NULL, 151735),
(151736, '3.40.50.620-FF-000432', NULL, 'Phosphoadenosine phosphosulfate reductase family protein', 218, NULL, NULL, 151736),
(151737, '1.10.437.10-FF-000004', NULL, 'apoptosis regulator BAX isoform X2', 167, NULL, NULL, 151737),
(151738, '3.30.160.60-FF-004186', NULL, NULL, 33, NULL, NULL, 151738),
(151739, '3.40.390.80-FF-000002', NULL, 'Metallprotease, enhancin', 128, NULL, NULL, 151739),
(151740, '2.60.40.1760-FF-000010', NULL, 'Glucosidase II catalytic subunit', 166, NULL, NULL, 151740),
(151741, '3.40.50.10810-FF-000249', NULL, 'Uncharacterized protein', 134, NULL, NULL, 151741),
(151742, '1.20.1560.10-FF-000523', NULL, 'AGAP004602-PA', 298, NULL, NULL, 151742),
(151743, '3.30.200.20-FF-000136', NULL, 'Non-specific serine/threonine protein kinase', 95, NULL, NULL, 151743),
(151744, '1.20.58.1120-FF-000024', NULL, 'Kl-2 1-beta dynein heavy chain', 144, NULL, NULL, 151744);
INSERT INTO "PUBLIC"."MODEL" VALUES
(151745, '3.30.540.30-FF-000002', NULL, 'Dipeptidyl peptidase 3', 124, NULL, NULL, 151745),
(151746, '1.20.1250.10-FF-000073', NULL, 'Growth hormone d24', 204, NULL, NULL, 151746),
(151747, '3.30.40.10-FF-000380', NULL, 'Uncharacterized protein, isoform B', 98, NULL, NULL, 151747),
(151748, '1.25.40.20-FF-001029', NULL, 'Uncharacterized protein', 104, NULL, NULL, 151748),
(151749, '1.10.490.60-FF-000001', NULL, NULL, 74, NULL, NULL, 151749),
(151750, '2.60.40.2500-FF-000002', NULL, 'Type IV secretion system protein VirB9', 113, NULL, NULL, 151750),
(151751, '3.80.10.10-FF-000639', NULL, 'Brassinosteroid LRR receptor kinase BRL3', 144, NULL, NULL, 151751),
(151752, '1.10.287.130-FF-000022', NULL, 'Two-component sensor CbrA', 72, NULL, NULL, 151752),
(151753, '2.10.25.10-FF-001730', NULL, 'Brevican', 39, NULL, NULL, 151753),
(151754, '2.130.10.10-FF-003146', NULL, 'Outer segment 1', 175, NULL, NULL, 151754),
(151755, '1.25.40.180-FF-000201', NULL, NULL, 87, NULL, NULL, 151755),
(151756, '1.20.1280.50-FF-000058', NULL, 'OSJNBa0058K23.14 protein', 95, NULL, NULL, 151756),
(151757, '3.20.140.10-FF-000024', NULL, 'Nicotinate phosphoribosyltransferase', 293, NULL, NULL, 151757),
(151758, '1.50.40.10-FF-000271', NULL, 'Mitochondrial dicarboxylate transporter, putative', 297, NULL, NULL, 151758),
(151759, '3.30.70.330-FF-000935', NULL, 'Hrb1p', 94, NULL, NULL, 151759),
(151760, '3.30.420.40-FF-000417', NULL, 'Conserved protein', 375, NULL, NULL, 151760),
(151761, '3.40.50.2300-FF-000007', NULL, 'Putative glutamate receptor ionotropic kainate 1', 188, NULL, NULL, 151761),
(151762, '3.20.20.10-FF-000070', NULL, 'Zgc:162816', 110, NULL, NULL, 151762),
(151763, '3.30.230.10-FF-000186', NULL, 'Phosphomevalonate kinase', 180, NULL, NULL, 151763),
(151764, '3.40.930.10-FF-000046', NULL, NULL, 247, NULL, NULL, 151764),
(151765, '1.20.1250.20-FF-001531', NULL, 'Facilitated trehalose transporter Tret1', 448, NULL, NULL, 151765),
(151766, '3.30.497.10-FF-000001', NULL, 'Serine protease inhibitor', 220, NULL, NULL, 151766),
(151767, '3.20.20.20-FF-000016', NULL, '4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase (flavodoxin)', 183, NULL, NULL, 151767),
(151768, '1.10.630.10-FF-000178', NULL, 'Cytochrome P450, family 2, subfamily N, polypeptide 13', 282, NULL, NULL, 151768),
(151769, '3.80.10.10-FF-003276', NULL, 'Uncharacterized protein', 163, NULL, NULL, 151769),
(151770, '1.25.10.10-FF-000911', NULL, 'MMS19 nucleotide excision repair protein isogeny', 249, NULL, NULL, 151770),
(151771, '2.60.40.2880-FF-000003', NULL, 'Conserved hypothetical threonine and proline rich protein', 87, NULL, NULL, 151771),
(151772, '3.30.830.10-FF-000164', NULL, 'Os01g0779100 protein', 77, NULL, NULL, 151772),
(151773, '1.25.40.10-FF-004578', NULL, 'Uncharacterized protein', 183, NULL, NULL, 151773),
(151774, '2.170.130.10-FF-000008', NULL, 'SusC/RagA family TonB-linked outer membrane protein', 129, NULL, NULL, 151774),
(151775, '2.60.40.10-FF-003730', NULL, 'Receptor protein-tyrosine kinase', 121, NULL, NULL, 151775),
(151776, '3.30.1330.40-FF-000067', NULL, 'Uncharacterized protein', 56, NULL, NULL, 151776),
(151777, '3.40.50.11060-FF-000010', NULL, 'GTPase HflX', 101, NULL, NULL, 151777),
(151778, '3.30.200.20-FF-002284', NULL, 'Uncharacterized protein', 91, NULL, NULL, 151778),
(151779, '3.40.50.300-FF-004220', NULL, 'ATP-dependent RNA helicase', 215, NULL, NULL, 151779),
(151780, '1.20.120.1750-FF-000086', NULL, 'RBR-type E3 ubiquitin transferase', 103, NULL, NULL, 151780),
(151781, '3.30.559.30-FF-000084', NULL, 'Nonribosomal peptide synthetase 8', 190, NULL, NULL, 151781),
(151782, '1.25.10.10-FF-000535', NULL, 'Sxm1p', 939, NULL, NULL, 151782),
(151783, '2.40.70.10-FF-000366', NULL, NULL, 77, NULL, NULL, 151783),
(151784, '1.10.510.10-FF-004126', NULL, NULL, 93, NULL, NULL, 151784),
(151785, '2.10.25.10-FF-000370', NULL, 'Integrin beta', 56, NULL, NULL, 151785),
(151786, '3.90.550.10-FF-000567', NULL, 'Uncharacterized protein', 75, NULL, NULL, 151786),
(151787, '1.20.120.1380-FF-000014', NULL, 'Flagellar biosynthesis protein FlhF', 50, NULL, NULL, 151787);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(151788, '2.60.40.10-FF-000375', NULL, 'Sodium channel beta 1 subunit', 128, NULL, NULL, 151788),
(151789, '3.40.850.10-FF-000045', NULL, 'Kinesin-like protein KIN-14I isoform A', 374, NULL, NULL, 151789),
(151790, '1.20.1560.10-FF-000236', NULL, 'p-GlycoProtein related', 346, NULL, NULL, 151790),
(151791, '3.40.33.10-FF-000008', NULL, 'GLI pathogenesis-related 1 (Glioma)', 202, NULL, NULL, 151791),
(151792, '1.20.1250.20-FF-000755', NULL, 'Vacuolar sorting protein', 467, NULL, NULL, 151792),
(151793, '2.60.40.150-FF-000491', NULL, 'Synaptotagmin 15', 146, NULL, NULL, 151793),
(151794, '1.10.357.10-FF-000003', NULL, 'HTH-type transcriptional regulator AcrR', 214, NULL, NULL, 151794),
(151795, '4.10.240.10-FF-000075', NULL, 'Transcriptional regulatory protein moc3', 71, NULL, NULL, 151795),
(151796, '1.20.1250.20-FF-000171', NULL, 'MFS general substrate transporter', 467, NULL, NULL, 151796),
(151797, '2.40.30.70-FF-000011', NULL, 'Uncharacterized protein', 122, NULL, NULL, 151797),
(151798, '3.40.220.10-FF-000043', NULL, 'Probable cytosol aminopeptidase', 155, NULL, NULL, 151798),
(151799, '3.40.50.10420-FF-000059', NULL, '5-formyltetrahydrofolate cyclo-ligase', 180, NULL, NULL, 151799),
(151800, '3.30.1510.10-FF-000010', NULL, 'C-1-tetrahydrofolate synthase, cytoplasmic', 106, NULL, NULL, 151800),
(151801, '2.130.10.10-FF-001084', NULL, 'Phosphatidylinositol 3,5-bisphosphate-binding protein', 221, NULL, NULL, 151801),
(151802, '3.40.50.1820-FF-001038', NULL, 'cDNA clone:J013114C10, full insert sequence', 114, NULL, NULL, 151802),
(151803, '3.40.50.150-FF-001016', NULL, NULL, 195, NULL, NULL, 151803),
(151804, '1.20.272.10-FF-000045', NULL, 'AGAP007477-PA-like protein', 93, NULL, NULL, 151804),
(151805, '3.30.70.1170-FF-000025', NULL, 'NOP2/Sun RNA methyltransferase family member 5', 83, NULL, NULL, 151805),
(151806, '3.40.630.30-FF-000220', NULL, 'Ribosomal-protein-serine acetyltransferase', 178, NULL, NULL, 151806),
(151807, '2.30.30.470-FF-000001', NULL, 'Putative DD-carboxypeptidase TP_0574', 112, NULL, NULL, 151807),
(151808, '3.40.50.10190-FF-000119', NULL, 'BRCA1 C Terminus (BRCT) domain containing protein, putative', 103, NULL, NULL, 151808),
(151809, '1.10.10.60-FF-001073', NULL, NULL, 63, NULL, NULL, 151809),
(151810, '3.40.50.720-FF-001092', NULL, 'Probable dehydrogenase', 229, NULL, NULL, 151810),
(151811, '1.20.58.60-FF-000586', NULL, 'Spectrin beta chain', 211, NULL, NULL, 151811),
(151812, '3.40.50.12780-FF-000183', NULL, 'Acetyl-CoA synthetase (Acetate-CoA ligase) carboxy-end (AcsA-4)', 164, NULL, NULL, 151812),
(151813, '3.40.50.1780-FF-000020', NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', 16, NULL, NULL, 151813),
(151814, '3.40.50.1460-FF-000093', NULL, 'Uncharacterized protein', 179, NULL, NULL, 151814),
(151815, '1.10.1450.10-FF-000180', NULL, 'Tetraspanin', 55, NULL, NULL, 151815),
(151816, '4.10.60.10-FF-000036', NULL, 'Gag polyprotein', 58, NULL, NULL, 151816),
(151817, '3.40.1110.10-FF-000303', NULL, NULL, 208, NULL, NULL, 151817),
(151818, '2.30.29.30-FF-000243', NULL, 'Pleckstrin 2', 108, NULL, NULL, 151818),
(151819, '3.40.50.300-FF-002663', NULL, 'ABC transporter ATP-binding protein/permease', 237, NULL, NULL, 151819),
(151820, '3.40.50.800-FF-000042', NULL, 'Unplaced genomic scaffold supercont1.23, whole genome shotgun sequence', 107, NULL, NULL, 151820),
(151821, '3.80.10.10-FF-004181', NULL, 'Os05g0105300 protein', 97, NULL, NULL, 151821),
(151822, '3.30.56.10-FF-000005', NULL, 'Phenylalanine--tRNA ligase beta subunit', 89, NULL, NULL, 151822),
(151823, '3.30.870.10-FF-000009', NULL, 'Phospholipase', 235, NULL, NULL, 151823),
(151824, '2.30.42.10-FF-000521', NULL, NULL, 68, NULL, NULL, 151824),
(151825, '2.30.18.10-FF-000004', NULL, 'General transcription factor IIA 1', 47, NULL, NULL, 151825),
(151826, '3.40.50.1820-FF-000521', NULL, 'Acetyl esterase (Acetylxylosidase)', 251, NULL, NULL, 151826),
(151827, '1.25.40.20-FF-001260', NULL, 'Uncharacterized protein', 210, NULL, NULL, 151827),
(151828, '2.130.10.10-FF-001988', NULL, 'Putative WD-repeat family protein', 344, NULL, NULL, 151828);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(151829, '3.40.50.150-FF-000892', NULL, NULL, 60, NULL, NULL, 151829),
(151830, '3.30.70.270-FF-000052', NULL, 'DNA repair protein REV1', 17, NULL, NULL, 151830),
(151831, '3.80.10.10-FF-001831', NULL, 'Leucine Rich Repeat family protein', 82, NULL, NULL, 151831),
(151832, '3.10.450.50-FF-000112', NULL, 'Predicted protein', 152, NULL, NULL, 151832),
(151833, '1.50.40.10-FF-000063', NULL, 'Mitochondrial nicotinamide adenine dinucleotide transporter 1', 197, NULL, NULL, 151833),
(151834, '1.25.40.20-FF-000984', NULL, 'Putative huntingtin interacting protein (HIP)', 117, NULL, NULL, 151834),
(151835, '3.90.226.10-FF-000241', NULL, 'Enoyl-CoA hydratase/isomerase family protein', 200, NULL, NULL, 151835),
(151836, '3.30.428.10-FF-000078', NULL, 'Predicted protein', 84, NULL, NULL, 151836),
(151837, '1.20.1560.10-FF-000787', NULL, 'Uncharacterized protein', 238, NULL, NULL, 151837),
(151838, '3.40.30.10-FF-001042', NULL, 'Glutathione peroxidase', 192, NULL, NULL, 151838),
(151839, '3.40.50.150-FF-000948', NULL, NULL, 103, NULL, NULL, 151839),
(151840, '2.130.10.10-FF-004506', NULL, 'Uncharacterized protein', 238, NULL, NULL, 151840),
(151841, '1.10.287.70-FF-000785', NULL, 'Uncharacterized protein', 63, NULL, NULL, 151841),
(151842, '3.40.50.300-FF-005125', NULL, 'Predicted protein', 247, NULL, NULL, 151842),
(151843, '2.40.30.10-FF-000369', NULL, 'Uncharacterized protein', 110, NULL, NULL, 151843),
(151844, '2.60.40.2030-FF-000041', NULL, 'Adhesion G-protein coupled receptor V1', 98, NULL, NULL, 151844),
(151845, '2.60.210.10-FF-000075', NULL, NULL, 141, NULL, NULL, 151845),
(151846, '3.80.30.20-FF-000008', NULL, 'CDK5 regulatory subunit-associated protein 1 isoform X4', 44, NULL, NULL, 151846),
(151847, '3.40.30.10-FF-000766', NULL, 'Glutathione peroxidase', 171, NULL, NULL, 151847),
(151848, '1.20.1250.20-FF-002048', NULL, 'Uncharacterized protein', 311, NULL, NULL, 151848),
(151849, '1.10.10.10-FF-000355', NULL, 'Putative transcriptional regulator', 99, NULL, NULL, 151849),
(151850, '1.20.120.350-FF-000272', NULL, NULL, 91, NULL, NULL, 151850),
(151851, '3.40.50.620-FF-000168', NULL, 'Isoleucine--tRNA ligase', 212, NULL, NULL, 151851),
(151852, '3.30.160.60-FF-004686', NULL, NULL, 26, NULL, NULL, 151852),
(151853, '1.20.1070.10-FF-000480', NULL, 'G protein-coupled receptor 37', 168, NULL, NULL, 151853),
(151854, '2.30.29.30-FF-001339', NULL, 'Protein tyrosine kinase 2 beta, a', 43, NULL, NULL, 151854),
(151855, '2.60.40.60-FF-000406', NULL, 'Protocadherin 12', 95, NULL, NULL, 151855),
(151856, '3.30.420.10-FF-000521', NULL, NULL, 117, NULL, NULL, 151856),
(151857, '1.10.510.10-FF-000591', NULL, 'Serine protein kinase Sky1', 267, NULL, NULL, 151857),
(151858, '3.40.630.10-FF-000473', NULL, 'Uncharacterized protein', 62, NULL, NULL, 151858),
(151859, '1.20.120.850-FF-000040', NULL, 'Helicase SWR1', 72, NULL, NULL, 151859),
(151860, '1.20.58.1440-FF-000002', NULL, 'AFR652Wp', 82, NULL, NULL, 151860),
(151861, '2.40.50.140-FF-000157', NULL, '39S ribosomal protein L2, mitochondrial', 107, NULL, NULL, 151861),
(151862, '2.60.40.10-FF-001544', NULL, 'titin isoform X1', 100, NULL, NULL, 151862),
(151863, '3.75.10.10-FF-000040', NULL, NULL, 112, NULL, NULL, 151863),
(151864, '1.20.58.60-FF-000322', NULL, 'SMAll', 107, NULL, NULL, 151864),
(151865, '2.60.120.430-FF-000022', NULL, 'Uncharacterized protein', 188, NULL, NULL, 151865),
(151866, '3.40.1350.60-FF-000010', NULL, 'Uncharacterized protein', 159, NULL, NULL, 151866),
(151867, '2.10.150.10-FF-000002', NULL, 'Urease', 119, NULL, NULL, 151867),
(151868, '3.30.160.60-FF-004927', NULL, NULL, 27, NULL, NULL, 151868),
(151869, '3.80.10.10-FF-002152', NULL, 'Receptor like protein 29', 311, NULL, NULL, 151869),
(151870, '3.40.630.10-FF-000130', NULL, 'Aminopeptidase', 249, NULL, NULL, 151870),
(151871, '3.30.160.60-FF-005203', NULL, NULL, 37, NULL, NULL, 151871),
(151872, '3.90.70.10-FF-000738', NULL, 'Uncharacterized protein', 151, NULL, NULL, 151872),
(151873, '1.10.238.10-FF-000715', NULL, 'Defective in cullin neddylation protein', 41, NULL, NULL, 151873);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(151874, '1.10.10.10-FF-001979', NULL, 'Uncharacterized protein', 59, NULL, NULL, 151874),
(151875, '2.10.25.10-FF-000218', NULL, 'latent-transforming growth factor beta-binding protein 4 isoform X1', 40, NULL, NULL, 151875),
(151876, '3.80.10.10-FF-000139', NULL, 'centriolin isoform X2', 85, NULL, NULL, 151876),
(151877, '1.10.532.10-FF-000017', NULL, 'Signal transducer and activator of transcription', 71, NULL, NULL, 151877),
(151878, '1.10.10.60-FF-000549', NULL, 'Myb like transcription factor', 73, NULL, NULL, 151878),
(151879, '3.40.50.300-FF-003888', NULL, 'ATP-dependent DNA helicase', 259, NULL, NULL, 151879),
(151880, '1.10.287.470-FF-000006', NULL, 'Multidrug resistance protein MdtE', 74, NULL, NULL, 151880),
(151881, '1.10.540.10-FF-000143', NULL, 'Acyl-coenzyme A oxidase', 112, NULL, NULL, 151881),
(151882, '1.10.490.10-FF-000026', NULL, 'Preprotein translocase subunit TatC', 117, NULL, NULL, 151882),
(151883, '2.40.30.170-FF-000044', NULL, 'Efflux transporter periplasmic adaptor subunit', 78, NULL, NULL, 151883),
(151884, '3.90.1150.10-FF-000452', NULL, 'Glycine/serine hydroxymethyltransferase, putative', 173, NULL, NULL, 151884),
(151885, '3.30.420.40-FF-000625', NULL, 'Ppx/GppA phosphatase', 107, NULL, NULL, 151885),
(151886, '3.30.2350.10-FF-000088', NULL, 'Uncharacterized RNA pseudouridine synthase MG209', 218, NULL, NULL, 151886),
(151887, '3.30.70.1730-FF-000064', NULL, 'Uncharacterized protein', 59, NULL, NULL, 151887),
(151888, '1.25.10.10-FF-000799', NULL, 'U2 snRNP component HSH155', 420, NULL, NULL, 151888),
(151889, '1.10.287.40-FF-000006', NULL, 'Seryl-tRNA synthetase', 102, NULL, NULL, 151889),
(151890, '1.20.1070.10-FF-001429', NULL, 'Uncharacterized protein', 225, NULL, NULL, 151890),
(151891, '3.30.70.330-FF-000727', NULL, 'UBP1-associated protein 2A', 85, NULL, NULL, 151891),
(151892, '3.90.190.10-FF-000472', NULL, 'Uncharacterized protein', 180, NULL, NULL, 151892),
(151893, '3.40.50.2000-FF-000710', NULL, 'Uncharacterized protein', 168, NULL, NULL, 151893),
(151894, '2.20.100.10-FF-000065', NULL, 'Cellular communication network factor 6', 66, NULL, NULL, 151894),
(151895, '3.30.420.10-FF-000133', NULL, 'DNA polymerase III PolC-type', 188, NULL, NULL, 151895),
(151896, '1.20.1250.20-FF-001295', NULL, 'Monocarboxylate transporter, putative', 165, NULL, NULL, 151896),
(151897, '2.40.70.10-FF-000546', NULL, NULL, 183, NULL, NULL, 151897),
(151898, '1.25.40.10-FF-001644', NULL, 'AGAP001559-PA', 361, NULL, NULL, 151898),
(151899, '1.20.140.10-FF-000054', NULL, 'Acyl-CoA dehydrogenase FadE33', 137, NULL, NULL, 151899),
(151900, '2.10.220.10-FF-000177', NULL, 'Proprotein convertase subtilisin/kexin type 5', 73, NULL, NULL, 151900),
(151901, '2.40.50.90-FF-000164', NULL, 'Tudor domain containing protein', 152, NULL, NULL, 151901),
(151902, '2.40.340.10-FF-000010', NULL, 'Molybdopterin molybdenumtransferase', 71, NULL, NULL, 151902),
(151903, '2.60.40.60-FF-000749', NULL, 'Cdh-4', 108, NULL, NULL, 151903),
(151904, '2.30.30.40-FF-000396', NULL, 'Alkylphosphonate uptake protein', 70, NULL, NULL, 151904),
(151905, '3.30.40.10-FF-001397', NULL, 'Histone acetyltransferase', 116, NULL, NULL, 151905),
(151906, '3.90.260.10-FF-000056', NULL, 'Xeroderma pigmentosum, complementation group C', 77, NULL, NULL, 151906),
(151907, '2.60.40.10-FF-003230', NULL, 'Uncharacterized protein', 120, NULL, NULL, 151907),
(151908, '1.20.58.570-FF-000001', NULL, 'F-actin-capping protein subunit beta', 88, NULL, NULL, 151908),
(151909, '1.10.238.10-FF-000991', NULL, 'Uncharacterized protein', 124, NULL, NULL, 151909),
(151910, '1.25.10.10-FF-001075', NULL, 'E3 ubiquitin-protein ligase UPL1', 548, NULL, NULL, 151910),
(151911, '1.20.1560.10-FF-000444', NULL, 'Uncharacterized protein', 128, NULL, NULL, 151911),
(151912, '3.40.50.1010-FF-000104', NULL, 'Uncharacterized protein', 155, NULL, NULL, 151912),
(151913, '3.50.50.60-FF-000478', NULL, 'RAB GDP-dissociation inhibitor, putative', 113, NULL, NULL, 151913),
(151914, '3.30.70.330-FF-002583', NULL, NULL, 137, NULL, NULL, 151914),
(151915, '1.10.287.110-FF-000483', NULL, 'Diphthamide biosynthesis protein 4', 75, NULL, NULL, 151915);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(151916, '3.40.50.300-FF-006878', NULL, 'Elongator complex protein 4', 328, NULL, NULL, 151916),
(151917, '1.10.150.250-FF-000008', NULL, 'Succinate dehydrogenase assembly factor 2 family protein', 91, NULL, NULL, 151917),
(151918, '1.10.510.10-FF-000315', NULL, 'membrane-associated tyrosine- and threonine-specific cdc2-inhibitory kinase', 175, NULL, NULL, 151918),
(151919, '3.30.70.580-FF-000044', NULL, 'Pseudouridine synthase', 73, NULL, NULL, 151919),
(151920, '1.20.91.20-FF-000005', NULL, 'Complement C4', 80, NULL, NULL, 151920),
(151921, '1.10.150.240-FF-000062', NULL, 'HAD family hydrolase', 70, NULL, NULL, 151921),
(151922, '1.10.10.60-FF-000881', NULL, NULL, 39, NULL, NULL, 151922),
(151923, '3.30.1330.10-FF-000024', NULL, 'Trifunctional purine biosynthetic protein adenosine-3', 138, NULL, NULL, 151923),
(151924, '1.20.920.10-FF-000232', NULL, 'Predicted protein', 140, NULL, NULL, 151924),
(151925, '3.30.200.20-FF-000636', NULL, 'Serine/threonine-protein kinase, putative', 86, NULL, NULL, 151925),
(151926, '1.20.1720.10-FF-000058', NULL, 'Uncharacterized protein', 202, NULL, NULL, 151926),
(151927, '3.40.50.960-FF-000005', NULL, '6,7-dimethyl-8-ribityllumazine synthase', 207, NULL, NULL, 151927),
(151928, '1.25.40.70-FF-000066', NULL, 'Uncharacterized protein', 142, NULL, NULL, 151928),
(151929, '3.40.50.300-FF-007154', NULL, 'Uncharacterized protein', 289, NULL, NULL, 151929),
(151930, '3.30.160.60-FF-003461', NULL, NULL, 27, NULL, NULL, 151930),
(151931, '2.130.10.10-FF-000892', NULL, 'Os03g0355200 protein', 131, NULL, NULL, 151931),
(151932, '3.40.50.970-FF-000065', NULL, 'Oxoglutarate dehydrogenase (Succinyl-transferring), E1 component', 370, NULL, NULL, 151932),
(151933, '3.40.720.10-FF-000221', NULL, 'Putative sulfatase yidJ', 365, NULL, NULL, 151933),
(151934, '3.40.1380.10-FF-000025', NULL, 'ATP synthase gamma chain 1 chloroplastic', 45, NULL, NULL, 151934),
(151935, '3.40.190.10-FF-000545', NULL, 'Sensory box sensor histidine kinase/response regulator VieS', 93, NULL, NULL, 151935),
(151936, '2.60.40.10-FF-004854', NULL, NULL, 96, NULL, NULL, 151936),
(151937, '1.10.510.10-FF-002968', NULL, NULL, 120, NULL, NULL, 151937),
(151938, '1.20.1640.10-FF-000057', NULL, 'MMPL domain-containing drug exporter', 196, NULL, NULL, 151938),
(151939, '3.30.740.10-FF-000005', NULL, 'Dynein light chain', 89, NULL, NULL, 151939),
(151940, '1.10.4000.10-FF-000001', NULL, 'Flagellar transcriptional regulator FlhD', 116, NULL, NULL, 151940),
(151941, '2.30.39.10-FF-000081', NULL, 'Antithrombin-III', 96, NULL, NULL, 151941),
(151942, '3.20.20.80-FF-000579', NULL, '14-alpha-glucan-branching enzyme 2-2 chloroplastic/amyloplastic', 274, NULL, NULL, 151942),
(151943, '1.25.40.10-FF-001987', NULL, 'Pentatricopeptide repeat-containing protein At1g79490, mitochondrial', 106, NULL, NULL, 151943),
(151944, '1.20.1070.10-FF-000328', NULL, 'Tachykinin-like peptides receptor 86C', 356, NULL, NULL, 151944),
(151945, '3.30.559.10-FF-000281', NULL, 'Carnitine palmitoyltransferase 1Cb', 185, NULL, NULL, 151945),
(151946, '1.20.1250.20-FF-000250', NULL, 'Protein NRT1/ PTR FAMILY 4.6', 532, NULL, NULL, 151946),
(151947, '3.30.160.60-FF-000976', NULL, 'B-cell CLL/lymphoma 6, member B', 27, NULL, NULL, 151947),
(151948, '3.40.50.1000-FF-000798', NULL, NULL, 157, NULL, NULL, 151948),
(151949, '1.10.287.70-FF-000521', NULL, 'Glutamate receptor 1.4', 123, NULL, NULL, 151949),
(151950, '3.40.710.10-FF-000131', NULL, 'Putative lipoprotein YbbD', 429, NULL, NULL, 151950),
(151951, '3.30.70.2850-FF-000001', NULL, 'DNA-directed RNA polymerase subunit', 211, NULL, NULL, 151951),
(151952, '3.30.160.60-FF-001252', NULL, 'Zinc finger and BTB domain-containing 48', 26, NULL, NULL, 151952),
(151953, '1.20.1390.20-FF-000001', NULL, 'Elongation factor 3', 90, NULL, NULL, 151953),
(151954, '3.40.50.300-FF-000797', NULL, 'Rac-like GTP-binding protein ARAC7', 183, NULL, NULL, 151954),
(151955, '2.40.320.10-FF-000026', NULL, 'Mediator of RNA polymerase II transcription subunit 18', 192, NULL, NULL, 151955),
(151956, '3.30.70.330-FF-002240', NULL, NULL, 72, NULL, NULL, 151956);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(151957, '1.20.1260.140-FF-000011', NULL, NULL, 178, NULL, NULL, 151957),
(151958, '3.30.300.130-FF-000035', NULL, NULL, 77, NULL, NULL, 151958),
(151959, '1.20.1070.10-FF-000148', NULL, '5-hydroxytryptamine receptor 6', 320, NULL, NULL, 151959),
(151960, '1.20.90.10-FF-000045', NULL, NULL, 30, NULL, NULL, 151960),
(151961, '2.40.50.140-FF-000718', NULL, NULL, 80, NULL, NULL, 151961),
(151962, '2.60.40.420-FF-000217', NULL, 'Laccase family multicopper oxidase', 157, NULL, NULL, 151962),
(151963, '2.170.270.10-FF-000226', NULL, 'SET domain-containing protein 5', 96, NULL, NULL, 151963),
(151964, '2.40.160.210-FF-000002', NULL, 'acyl-coenzyme A thioesterase 8', 286, NULL, NULL, 151964),
(151965, '3.30.200.20-FF-000979', NULL, 'Os06g0693900 protein', 99, NULL, NULL, 151965),
(151966, '2.40.290.10-FF-000028', NULL, 'AGAP009910-PA', 196, NULL, NULL, 151966),
(151967, '2.10.25.10-FF-001651', NULL, 'Epidermal growth factor', 74, NULL, NULL, 151967),
(151968, '1.20.1250.20-FF-002312', NULL, 'Uncharacterized protein', 231, NULL, NULL, 151968),
(151969, '2.60.40.1120-FF-000009', NULL, 'adipocyte enhancer-binding protein 1', 80, NULL, NULL, 151969),
(151970, '1.50.10.10-FF-000235', NULL, 'alpha-1,2-Mannosidase', 121, NULL, NULL, 151970),
(151971, '3.30.870.10-FF-000161', NULL, 'Uncharacterized protein', 107, NULL, NULL, 151971),
(151972, '3.40.50.300-FF-008435', NULL, 'ATP-dependent DEAD/H DNA helicase recQ family-like protein', 88, NULL, NULL, 151972),
(151973, '3.30.420.40-FF-000237', NULL, 'Actin-related protein 5', 156, NULL, NULL, 151973),
(151974, '1.10.2000.10-FF-000034', NULL, NULL, 68, NULL, NULL, 151974),
(151975, '3.30.1370.50-FF-000022', NULL, 'Uncharacterized protein', 71, NULL, NULL, 151975),
(151976, '2.130.10.10-FF-004782', NULL, 'Ribosomal RNA processing 9, U3 small nucleolar RNA binding protein', 152, NULL, NULL, 151976),
(151977, '1.20.1270.10-FF-000068', NULL, 'Heat shock cognate 70 kDa protein 2', 74, NULL, NULL, 151977),
(151978, '2.10.230.10-FF-000003', NULL, 'dnaJ homolog subfamily A member 3, mitochondrial', 61, NULL, NULL, 151978),
(151979, '3.40.640.10-FF-000299', NULL, 'L-seryl-tRNA(Sec) selenium transferase', 262, NULL, NULL, 151979),
(151980, '3.30.160.60-FF-000796', NULL, 'Zinc finger protein 335', 67, NULL, NULL, 151980),
(151981, '3.40.50.720-FF-000748', NULL, 'Adenylyltransferase and sulfurtransferase MOCS3', 134, NULL, NULL, 151981),
(151982, '1.10.510.10-FF-002389', NULL, NULL, 58, NULL, NULL, 151982),
(151983, '1.25.40.470-FF-000052', NULL, 'Cotamer alpha, putative', 106, NULL, NULL, 151983),
(151984, '1.10.418.10-FF-000084', NULL, 'Girdin, isoform C', 158, NULL, NULL, 151984),
(151985, '2.40.128.130-FF-000003', NULL, 'AIDA-I family autotransporter YfaL', 297, NULL, NULL, 151985),
(151986, '3.30.70.2740-FF-000024', NULL, 'Uncharacterized protein', 43, NULL, NULL, 151986),
(151987, '3.20.20.140-FF-000320', NULL, 'Uncharacterized protein', 277, NULL, NULL, 151987),
(151988, '2.30.29.30-FF-000822', NULL, 'Oxysterol-binding protein-like 9', 60, NULL, NULL, 151988),
(151989, '2.60.40.10-FF-001156', NULL, 'Interferon alpha/beta receptor 2', 97, NULL, NULL, 151989),
(151990, '1.10.533.10-FF-000008', NULL, 'Death associated protein kinase 1', 104, NULL, NULL, 151990),
(151991, '1.25.10.10-FF-001816', NULL, 'Predicted protein', 226, NULL, NULL, 151991),
(151992, '1.10.10.10-FF-001136', NULL, 'Transcription factor E2F7', 56, NULL, NULL, 151992),
(151993, '1.25.40.10-FF-000363', NULL, 'Pentatricopeptide repeat-containing protein', 147, NULL, NULL, 151993),
(151994, '1.25.40.10-FF-005298', NULL, 'Uncharacterized protein', 132, NULL, NULL, 151994),
(151995, '1.10.510.10-FF-003406', NULL, NULL, 300, NULL, NULL, 151995),
(151996, '2.60.120.200-FF-000020', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 2', 192, NULL, NULL, 151996),
(151997, '1.20.950.20-FF-000006', NULL, 'Cytochrome b561 2', 84, NULL, NULL, 151997),
(151998, '1.10.472.80-FF-000286', NULL, NULL, 70, NULL, NULL, 151998),
(151999, '3.30.160.60-FF-001813', NULL, 'Zinc finger protein 687 (Predicted)', 62, NULL, NULL, 151999);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(152000, '3.10.310.20-FF-000008', NULL, 'Uncharacterized protein', 163, NULL, NULL, 152000),
(152001, '1.20.58.390-FF-000003', NULL, 'Glycine receptor alpha 2 subunit', 142, NULL, NULL, 152001),
(152002, '2.130.10.10-FF-005299', NULL, 'Uncharacterized protein', 218, NULL, NULL, 152002),
(152003, '3.30.40.10-FF-000733', NULL, 'Pib1p', 89, NULL, NULL, 152003),
(152004, '3.40.50.300-FF-003500', NULL, 'ADP-ribosylation factor 1', 181, NULL, NULL, 152004),
(152005, '4.10.1060.10-FF-000013', NULL, 'Zinc finger, RanBP2-type protein', 35, NULL, NULL, 152005),
(152006, '1.10.472.80-FF-000022', NULL, 'TBC1 domain family, member 31', 119, NULL, NULL, 152006),
(152007, '4.10.60.10-FF-000115', NULL, 'Putative cleavage and polyadenylation specificity factor 30 kDa subunit', 53, NULL, NULL, 152007),
(152008, '3.40.50.1820-FF-001690', NULL, 'Uncharacterized protein', 214, NULL, NULL, 152008),
(152009, '1.20.58.390-FF-000267', NULL, 'Uncharacterized protein', 87, NULL, NULL, 152009),
(152010, '3.40.50.720-FF-000187', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 287, NULL, NULL, 152010),
(152011, '3.30.460.10-FF-000175', NULL, 'Uncharacterized protein', 73, NULL, NULL, 152011),
(152012, '1.20.1260.60-FF-000009', NULL, 'IST1-like protein', 177, NULL, NULL, 152012),
(152013, '2.130.10.10-FF-002949', NULL, 'EG:63B12.7 protein', 203, NULL, NULL, 152013),
(152014, '1.20.120.160-FF-000041', NULL, 'Diguanylate cyclase with response regulator receiver modulation', 108, NULL, NULL, 152014),
(152015, '3.10.20.90-FF-000189', NULL, 'Neutrophil cytosol factor 4', 108, NULL, NULL, 152015),
(152016, '1.10.510.10-FF-001872', NULL, 'Protein kinase, putative', 205, NULL, NULL, 152016),
(152017, '3.30.565.10-FF-000255', NULL, 'Sensor histidine kinase', 152, NULL, NULL, 152017),
(152018, '2.70.170.10-FF-000046', NULL, 'Cholinergic receptor nicotinic alpha 1 subunit', 60, NULL, NULL, 152018),
(152019, '2.60.40.10-FF-005310', NULL, NULL, 79, NULL, NULL, 152019),
(152020, '2.60.120.650-FF-000037', NULL, 'Transcription factor jumonji (JmjC) domain-containing protein', 249, NULL, NULL, 152020),
(152021, '2.40.240.10-FF-000025', NULL, 'Glutamine-tRNA ligase', 129, NULL, NULL, 152021),
(152022, '3.40.50.300-FF-008559', NULL, 'Uncharacterized protein', 77, NULL, NULL, 152022),
(152023, '3.40.50.1000-FF-000455', NULL, 'Predicted protein', 189, NULL, NULL, 152023),
(152024, '2.10.25.10-FF-001090', NULL, 'Vein, isoform C', 45, NULL, NULL, 152024),
(152025, '2.60.120.260-FF-000510', NULL, 'Uncharacterized protein', 195, NULL, NULL, 152025),
(152026, '3.40.50.300-FF-001814', NULL, 'DNA mismatch repair protein MutS type 2', 321, NULL, NULL, 152026),
(152027, '2.30.30.40-FF-000053', NULL, 'endophilin-A1 isoform X2', 71, NULL, NULL, 152027),
(152028, '1.25.40.570-FF-000048', NULL, '26S proteasome non-ATPase regulatory subunit 6', 291, NULL, NULL, 152028),
(152029, '3.40.50.2300-FF-000289', NULL, 'Osmosensing histidine protein kinase SLN1', 133, NULL, NULL, 152029),
(152030, '1.10.10.10-FF-000698', NULL, 'RNA polymerase sigma factor', 84, NULL, NULL, 152030),
(152031, '3.40.390.10-FF-000318', NULL, NULL, 95, NULL, NULL, 152031),
(152032, '1.20.1270.60-FF-000122', NULL, 'Protein CBG22463', 213, NULL, NULL, 152032),
(152033, '2.130.10.10-FF-001016', NULL, 'WD repeat-containing protein', 295, NULL, NULL, 152033),
(152034, '2.10.110.10-FF-000348', NULL, 'Uncharacterized protein', 64, NULL, NULL, 152034),
(152035, '2.40.160.10-FF-000024', NULL, 'Mitochondrial outer membrane protein porin 1 isoform A', 243, NULL, NULL, 152035),
(152036, '1.20.1070.10-FF-001840', NULL, 'NMUR (NeuroMedin U Receptor) homolog', 377, NULL, NULL, 152036),
(152037, '3.40.50.1820-FF-000133', NULL, 'esterase AGAP003155', 211, NULL, NULL, 152037),
(152038, '2.60.40.380-FF-000003', NULL, 'Metallo phosphoesterase', 96, NULL, NULL, 152038),
(152039, '1.10.1670.10-FF-000011', NULL, 'N-glycosylase/DNA lyase, putative', 67, NULL, NULL, 152039),
(152040, '3.30.160.20-FF-000071', NULL, 'Double-stranded RNA-binding protein 4', 76, NULL, NULL, 152040),
(152041, '3.80.10.10-FF-004029', NULL, 'Uncharacterized protein', 145, NULL, NULL, 152041);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(152042, '3.80.10.10-FF-003629', NULL, 'Uncharacterized protein', 223, NULL, NULL, 152042),
(152043, '3.90.70.10-FF-000659', NULL, 'Uncharacterized protein', 59, NULL, NULL, 152043),
(152044, '3.40.190.80-FF-000026', NULL, '3''-phosphoadenosine 5''-phosphate phosphatase', 102, NULL, NULL, 152044),
(152045, '1.25.40.20-FF-000708', NULL, 'Intracelllar PhosphoLipase A family', 351, NULL, NULL, 152045),
(152046, '1.25.10.10-FF-001255', NULL, 'Exportin 1', 1057, NULL, NULL, 152046),
(152047, '2.60.120.290-FF-000053', NULL, 'Cubilin', 115, NULL, NULL, 152047),
(152048, '3.30.70.330-FF-000031', NULL, 'Heterogeneous nuclear ribonucleoprotein h3 isoform', 88, NULL, NULL, 152048),
(152049, '2.130.10.10-FF-003225', NULL, 'Cilia- and flagella-associated protein 43', 294, NULL, NULL, 152049),
(152050, '3.40.50.720-FF-001597', NULL, 'Os07g0601900 protein', 175, NULL, NULL, 152050),
(152051, '2.60.40.60-FF-000518', NULL, 'Protein CBG11732', 100, NULL, NULL, 152051),
(152052, '1.10.560.10-FF-000026', NULL, 'Chaperonin 60 subunit alpha 2 chloroplastic', 112, NULL, NULL, 152052),
(152053, '3.40.309.10-FF-000069', NULL, 'Aldehyde-alcohol dehydrogenase', 195, NULL, NULL, 152053),
(152054, '1.25.10.10-FF-000294', NULL, 'Transformation/transcription domain associated protein', 804, NULL, NULL, 152054),
(152055, '1.25.40.10-FF-000863', NULL, 'Vacuolar protein sorting-associated protein 27', 51, NULL, NULL, 152055),
(152056, '3.50.50.60-FF-000321', NULL, 'D-amino acid dehydrogenase small subunit', 150, NULL, NULL, 152056),
(152057, '3.10.129.10-FF-000275', NULL, 'Uncharacterized protein', 90, NULL, NULL, 152057),
(152058, '1.10.510.10-FF-003221', NULL, NULL, 134, NULL, NULL, 152058),
(152059, '1.25.40.10-FF-001431', NULL, 'NRDE-2, necessary for RNA interference, domain-containing', 201, NULL, NULL, 152059),
(152060, '2.130.10.10-FF-001640', NULL, 'GM20238', 122, NULL, NULL, 152060),
(152061, '3.30.200.20-FF-000715', NULL, 'AGC protein kinase', 92, NULL, NULL, 152061),
(152062, '1.20.120.1900-FF-000092', NULL, 'Gamma-tubulin complex component', 206, NULL, NULL, 152062),
(152063, '3.30.40.10-FF-001958', NULL, 'Putative RING zinc finger domain superfamily protein', 65, NULL, NULL, 152063),
(152064, '2.60.120.650-FF-000014', NULL, 'PHD transcription factor (Rum1)', 286, NULL, NULL, 152064),
(152065, '3.30.1520.10-FF-000011', NULL, 'Putative sorting nexin-16', 127, NULL, NULL, 152065),
(152066, '3.90.226.10-FF-000073', NULL, 'Probable enoyl-CoA hydratase', 258, NULL, NULL, 152066),
(152067, '2.60.20.10-FF-000025', NULL, NULL, 62, NULL, NULL, 152067),
(152068, '1.25.40.20-FF-000860', NULL, 'Transient receptor potential cation channel subfamily A member 1', 68, NULL, NULL, 152068),
(152069, '3.30.200.20-FF-002261', NULL, 'Uncharacterized protein', 114, NULL, NULL, 152069),
(152070, '3.30.1640.10-FF-000065', NULL, 'DNA replication licensing factor MCM4 protein', 100, NULL, NULL, 152070),
(152071, '3.40.1050.10-FF-000028', NULL, 'Carbonic anhydrase', 233, NULL, NULL, 152071),
(152072, '3.30.200.20-FF-000659', NULL, 'SH2-protein kinase domain containing protein', 85, NULL, NULL, 152072),
(152073, '3.30.230.70-FF-000069', NULL, '3''-5''-exoribonuclease family protein', 121, NULL, NULL, 152073),
(152074, '3.30.1540.10-FF-000006', NULL, 'Succinyl-CoA--L-malate CoA-transferase beta subunit', 87, NULL, NULL, 152074),
(152075, '2.20.80.10-FF-000025', NULL, 'Uncharacterized protein', 164, NULL, NULL, 152075),
(152076, '2.60.120.1020-FF-000002', NULL, 'N-glycanase 1', 67, NULL, NULL, 152076),
(152077, '3.80.10.10-FF-002213', NULL, 'Uncharacterized protein', 150, NULL, NULL, 152077),
(152078, '1.10.510.10-FF-003165', NULL, NULL, 168, NULL, NULL, 152078),
(152079, '3.30.230.70-FF-000125', NULL, 'Predicted protein', 219, NULL, NULL, 152079),
(152080, '3.30.590.20-FF-000013', NULL, 'Glutamate--cysteine ligase', 364, NULL, NULL, 152080),
(152081, '2.10.70.10-FF-000289', NULL, 'Uncharacterized protein', 55, NULL, NULL, 152081),
(152082, '3.60.21.10-FF-000441', NULL, 'Protein phosphatase 2B, putative', 214, NULL, NULL, 152082),
(152083, '3.40.50.2300-FF-001019', NULL, NULL, 190, NULL, NULL, 152083);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(152084, '3.30.559.10-FF-000218', NULL, 'Ferrichrome siderophore peptide synthetase', 188, NULL, NULL, 152084),
(152085, '2.60.40.10-FF-004298', NULL, NULL, 108, NULL, NULL, 152085),
(152086, '2.60.120.1190-FF-000007', NULL, 'Discoidin domain receptor tyrosine kinase 1', 184, NULL, NULL, 152086),
(152087, '3.40.50.2300-FF-000507', NULL, 'Two-component response regulator NatK', 125, NULL, NULL, 152087),
(152088, '1.20.59.10-FF-000023', NULL, 'Shikimate 5-dehydrogenase', 84, NULL, NULL, 152088),
(152089, '1.20.58.60-FF-000827', NULL, 'Uncharacterized protein', 175, NULL, NULL, 152089),
(152090, '3.40.50.300-FF-003152', NULL, 'Elongation factor 1-alpha', 78, NULL, NULL, 152090),
(152091, '3.30.160.60-FF-004803', NULL, NULL, 38, NULL, NULL, 152091),
(152092, '3.80.10.10-FF-002264', NULL, 'GH06740p', 103, NULL, NULL, 152092),
(152093, '3.60.21.10-FF-000334', NULL, 'Uncharacterized protein', 344, NULL, NULL, 152093),
(152094, '3.30.160.60-FF-000476', NULL, 'Zinc finger protein', 28, NULL, NULL, 152094),
(152095, '1.20.1270.60-FF-000061', NULL, 'Rho guanine nucleotide exchange factor 38', 230, NULL, NULL, 152095),
(152096, '3.40.50.300-FF-006822', NULL, 'Adenylate kinase isoenzyme 1', 35, NULL, NULL, 152096),
(152097, '1.10.238.10-FF-001115', NULL, 'Uncharacterized protein', 45, NULL, NULL, 152097),
(152098, '2.40.70.10-FF-000074', NULL, 'Os05g0384300 protein', 184, NULL, NULL, 152098),
(152099, '2.40.30.170-FF-000021', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 82, NULL, NULL, 152099),
(152100, '3.10.100.10-FF-000248', NULL, NULL, 156, NULL, NULL, 152100),
(152101, '1.20.5.170-FF-000224', NULL, 'SNF2 family N-terminal domain-domain-containing protein', 75, NULL, NULL, 152101),
(152102, '3.40.190.10-FF-000258', NULL, 'ATP phosphoribosyltransferase', 95, NULL, NULL, 152102),
(152103, '2.130.10.10-FF-005911', NULL, 'Uncharacterized protein', 280, NULL, NULL, 152103),
(152104, '3.10.580.10-FF-000109', NULL, 'SNF1-related protein kinase regulatory subunit gamma-like PV42b', 154, NULL, NULL, 152104),
(152105, '2.130.10.10-FF-005799', NULL, 'Uncharacterized protein', 92, NULL, NULL, 152105),
(152106, '3.30.1490.480-FF-000005', NULL, 'Endolytic murein transglycosylase', 72, NULL, NULL, 152106),
(152107, '3.80.10.10-FF-001752', NULL, 'Putative disease resistance protein At3g14460', 403, NULL, NULL, 152107),
(152108, '3.40.50.720-FF-001541', NULL, 'Uncharacterized protein', 262, NULL, NULL, 152108),
(152109, '3.40.33.10-FF-000003', NULL, 'Peptidase inhibitor 15', 197, NULL, NULL, 152109),
(152110, '3.10.129.10-FF-000224', NULL, 'Cytosolic acyl coenzyme A thioester hydrolase', 147, NULL, NULL, 152110),
(152111, '3.40.1110.10-FF-000034', NULL, 'Zinc/cadmium/lead-transporting P-type ATPase', 117, NULL, NULL, 152111),
(152112, '3.40.50.200-FF-000093', NULL, 'Uncharacterized protein', 368, NULL, NULL, 152112),
(152113, '2.60.40.2030-FF-000046', NULL, 'Adhesion G protein-coupled receptor V1', 150, NULL, NULL, 152113),
(152114, '2.20.70.10-FF-000148', NULL, 'AFR317Cp', 40, NULL, NULL, 152114),
(152115, '3.40.50.10810-FF-000188', NULL, 'Uncharacterized protein', 75, NULL, NULL, 152115),
(152116, '3.40.190.80-FF-000077', NULL, 'Inositol-1-monophosphatase', 126, NULL, NULL, 152116),
(152117, '3.90.480.20-FF-000008', NULL, 'Ferredoxin--nitrite reductase, chloroplastic', 196, NULL, NULL, 152117),
(152118, '2.60.120.260-FF-000459', NULL, 'Uncharacterized protein', 123, NULL, NULL, 152118),
(152119, '1.20.58.60-FF-000086', NULL, 'Short stop, isoform K', 216, NULL, NULL, 152119),
(152120, '3.20.20.300-FF-000071', NULL, NULL, 139, NULL, NULL, 152120),
(152121, '3.80.10.10-FF-002320', NULL, 'Predicted protein', 142, NULL, NULL, 152121),
(152122, '3.30.160.60-FF-004747', NULL, NULL, 72, NULL, NULL, 152122),
(152123, '3.30.750.24-FF-000109', NULL, 'ABC transporter permease protein', 97, NULL, NULL, 152123),
(152124, '1.10.1670.40-FF-000003', NULL, 'DNA-3-methyladenine glycosylase II', 50, NULL, NULL, 152124),
(152125, '3.90.1150.10-FF-000457', NULL, 'Aminotransferase class-III', 130, NULL, NULL, 152125),
(152126, '2.20.70.10-FF-000204', NULL, 'Uncharacterized protein', 42, NULL, NULL, 152126);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(152127, '3.40.20.10-FF-000029', NULL, 'SEC24 homolog B, COPII coat complex component', 129, NULL, NULL, 152127),
(152128, '1.10.640.10-FF-000027', NULL, 'Protein CBG06977', 160, NULL, NULL, 152128),
(152129, '3.60.130.10-FF-000059', NULL, 'Predicted protein', 381, NULL, NULL, 152129),
(152130, '1.20.58.340-FF-000005', NULL, 'Inner membrane magnesium transporter MRS2', 173, NULL, NULL, 152130),
(152131, '2.130.10.10-FF-005855', NULL, 'Nucleoporin nup131', 324, NULL, NULL, 152131),
(152132, '1.10.840.10-FF-000008', NULL, 'Ras-GEF domain-containing family member 1B', 271, NULL, NULL, 152132),
(152133, '3.90.1150.10-FF-000513', NULL, 'Transcriptional regulator, GntR family', 141, NULL, NULL, 152133),
(152134, '3.40.1410.10-FF-000023', NULL, 'Phosphonate utilization transcriptional regulator PhnR', 157, NULL, NULL, 152134),
(152135, '2.10.25.10-FF-000870', NULL, 'Uncharacterized protein', 52, NULL, NULL, 152135),
(152136, '3.40.800.20-FF-000051', NULL, 'Histone deacetylase 1 HDAC Hda1p', 371, NULL, NULL, 152136),
(152137, '3.40.50.150-FF-000212', NULL, 'Ribosomal RNA large subunit methyltransferase E', 218, NULL, NULL, 152137),
(152138, '1.10.10.10-FF-001075', NULL, 'DNA-directed RNA polymerase III subunit RPC3', 74, NULL, NULL, 152138),
(152139, '1.20.920.20-FF-000061', NULL, 'Uncharacterized protein', 331, NULL, NULL, 152139),
(152140, '3.40.50.720-FF-001592', NULL, 'Uncharacterized protein', 207, NULL, NULL, 152140),
(152141, '3.30.160.60-FF-000532', NULL, 'GLIS family zinc finger 2', 31, NULL, NULL, 152141),
(152142, '3.40.50.300-FF-003096', NULL, 'Small GTPase EhRabX29, putative', 167, NULL, NULL, 152142),
(152143, '1.10.238.10-FF-000159', NULL, 'Calcium uptake protein 1, mitochondrial', 191, NULL, NULL, 152143),
(152144, '3.30.70.330-FF-003072', NULL, NULL, 103, NULL, NULL, 152144),
(152145, '3.10.20.90-FF-000369', NULL, 'Bud emergence protein', 84, NULL, NULL, 152145),
(152146, '3.40.630.10-FF-000394', NULL, 'Uncharacterized protein', 33, NULL, NULL, 152146),
(152147, '3.40.190.10-FF-000314', NULL, 'LysR family transcriptional regulator', 94, NULL, NULL, 152147),
(152148, '3.30.450.50-FF-000006', NULL, 'Vesicle-associated membrane protein 7', 123, NULL, NULL, 152148),
(152149, '3.50.50.60-FF-000265', NULL, 'Putative lysine-specific histone demethylase 1', 156, NULL, NULL, 152149),
(152150, '2.60.40.770-FF-000007', NULL, 'Uncharacterized protein', 126, NULL, NULL, 152150),
(152151, '2.40.50.140-FF-000426', NULL, 'Protection of telomeres protein 1', 164, NULL, NULL, 152151),
(152152, '1.20.1160.20-FF-000012', NULL, 'Regulator of telomere elongation helicase 1 homolog', 91, NULL, NULL, 152152),
(152153, '3.30.1490.100-FF-000037', NULL, 'DNA polymerase IV', 113, NULL, NULL, 152153),
(152154, '1.20.1270.60-FF-000010', NULL, 'Metastasis suppressor 1, isoform CRA_e', 246, NULL, NULL, 152154),
(152155, '1.20.272.10-FF-000040', NULL, 'Replication factor C large subunit, putative', 93, NULL, NULL, 152155),
(152156, '3.60.20.30-FF-000017', NULL, NULL, 139, NULL, NULL, 152156),
(152157, '3.40.50.1820-FF-001538', NULL, 'Neuroligin-3', 136, NULL, NULL, 152157),
(152158, '1.25.40.420-FF-000026', NULL, 'BTB/POZ domain-containing protein', 74, NULL, NULL, 152158),
(152159, '2.130.10.10-FF-002926', NULL, 'Predicted protein', 149, NULL, NULL, 152159),
(152160, '1.20.1460.20-FF-000001', NULL, 'V-type ATP synthase subunit I', 175, NULL, NULL, 152160),
(152161, '2.60.40.10-FF-005203', NULL, NULL, 91, NULL, NULL, 152161),
(152162, '3.40.50.1980-FF-000080', NULL, 'Nickel/cobalt efflux system', 145, NULL, NULL, 152162),
(152163, '3.30.160.20-FF-000251', NULL, 'RISC-loading complex subunit TARBP2', 59, NULL, NULL, 152163),
(152164, '1.20.1250.20-FF-000194', NULL, 'Inner membrane protein yhjX', 191, NULL, NULL, 152164),
(152165, '1.25.40.10-FF-004393', NULL, 'Uncharacterized protein', 140, NULL, NULL, 152165),
(152166, '2.10.25.10-FF-000033', NULL, 'Laminin subunit alpha 2', 57, NULL, NULL, 152166),
(152167, '2.60.40.1080-FF-000008', NULL, 'Ig-like repeat domain protein 3', 87, NULL, NULL, 152167),
(152168, '4.10.400.10-FF-000138', NULL, 'Low-density lipoprotein receptor-related protein 8', 41, NULL, NULL, 152168);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(152169, '3.40.50.1240-FF-000055', NULL, 'Phosphoglycerate mutase, putative', 211, NULL, NULL, 152169),
(152170, '3.40.50.280-FF-000015', NULL, 'Methionine synthase', 140, NULL, NULL, 152170),
(152171, '2.30.30.20-FF-000002', NULL, NULL, 55, NULL, NULL, 152171),
(152172, '3.30.70.330-FF-002408', NULL, NULL, 93, NULL, NULL, 152172),
(152173, '2.120.10.30-FF-000590', NULL, 'Uncharacterized protein', 113, NULL, NULL, 152173),
(152174, '3.40.50.300-FF-006081', NULL, 'ATP-binding cassette sub-family A member 3-like Protein', 131, NULL, NULL, 152174),
(152175, '1.25.40.570-FF-000043', NULL, 'Uncharacterized protein', 351, NULL, NULL, 152175),
(152176, '1.25.40.10-FF-003229', NULL, 'Interferon-induced protein with tetratricopeptide repeats 5-like', 57, NULL, NULL, 152176),
(152177, '2.130.10.10-FF-004006', NULL, 'Uncharacterized protein', 226, NULL, NULL, 152177),
(152178, '3.90.70.10-FF-000103', NULL, 'Hypothetical LOC496748', 320, NULL, NULL, 152178),
(152179, '3.30.160.60-FF-005703', NULL, NULL, 57, NULL, NULL, 152179),
(152180, '3.30.200.20-FF-002109', NULL, 'CMGC family protein kinase', 78, NULL, NULL, 152180),
(152181, '1.10.274.30-FF-000035', NULL, 'Protein CBG13704', 170, NULL, NULL, 152181),
(152182, '1.25.40.10-FF-002717', NULL, 'YALI0D14344p', 303, NULL, NULL, 152182),
(152183, '2.170.150.10-FF-000010', NULL, 'Translationally-controlled tumor protein homolog', 181, NULL, NULL, 152183),
(152184, '2.170.130.10-FF-000003', NULL, 'SusC/RagA family TonB-linked outer membrane protein', 129, NULL, NULL, 152184),
(152185, '3.40.50.300-FF-004405', NULL, 'Uncharacterized protein', 186, NULL, NULL, 152185),
(152186, '1.10.510.10-FF-000259', NULL, 'Serine/threonine-protein kinase TNNI3K', 275, NULL, NULL, 152186),
(152187, '3.90.660.10-FF-000109', NULL, NULL, 31, NULL, NULL, 152187),
(152188, '2.70.170.10-FF-000277', NULL, 'Uncharacterized protein', 97, NULL, NULL, 152188),
(152189, '1.25.40.20-FF-000629', NULL, 'Intracelllar PhosphoLipase A family', 174, NULL, NULL, 152189),
(152190, '3.90.550.10-FF-000455', NULL, 'Glycosyl transferase family 2', 239, NULL, NULL, 152190),
(152191, '3.40.630.10-FF-000450', NULL, 'Uncharacterized protein', 172, NULL, NULL, 152191),
(152192, '3.10.20.90-FF-000425', NULL, 'Polyubiquitin containing 7 ubiquitin monomers', 82, NULL, NULL, 152192),
(152193, '2.70.150.10-FF-000219', NULL, 'ATPase copper transporting beta', 125, NULL, NULL, 152193),
(152194, '2.60.120.200-FF-000251', NULL, 'Tyrosine-protein kinase receptor', 177, NULL, NULL, 152194),
(152195, '1.20.1410.10-FF-000012', NULL, 'YLR287C-like protein', 178, NULL, NULL, 152195),
(152196, '1.10.10.10-FF-001479', NULL, 'DNA-directed RNA polymerase III subunit RPC3', 86, NULL, NULL, 152196),
(152197, '2.40.50.140-FF-000477', NULL, 'Polyribonucleotide nucleotidyltransferase', 72, NULL, NULL, 152197),
(152198, '3.40.630.30-FF-000456', NULL, 'Similar to nourseothricin acetyltransferase', 316, NULL, NULL, 152198),
(152199, '1.20.1070.10-FF-001784', NULL, 'Uncharacterized protein', 326, NULL, NULL, 152199),
(152200, '3.30.1640.10-FF-000014', NULL, 'DNA helicase', 114, NULL, NULL, 152200),
(152201, '3.30.160.60-FF-002893', NULL, 'Zinc finger protein 971', 28, NULL, NULL, 152201),
(152202, '1.10.472.10-FF-000366', NULL, 'General transcription factor IIB', 104, NULL, NULL, 152202),
(152203, '2.60.120.260-FF-000515', NULL, 'Beta-galactosidase', 81, NULL, NULL, 152203),
(152204, '3.30.40.10-FF-000109', NULL, 'Zinc finger FYVE domain-containing protein 1', 78, NULL, NULL, 152204),
(152205, '3.40.50.150-FF-000268', NULL, 'Histidine protein methyltransferase 1 homolog', 215, NULL, NULL, 152205),
(152206, '1.10.3210.10-FF-000106', NULL, 'Uncharacterized protein', 316, NULL, NULL, 152206),
(152207, '1.10.287.70-FF-000285', NULL, 'TWiK family of potassium channels', 312, NULL, NULL, 152207),
(152208, '3.40.50.150-FF-000156', NULL, 'Methyltransferase like 22', 218, NULL, NULL, 152208),
(152209, '1.10.472.10-FF-000254', NULL, 'Cyclin-T1.2', 117, NULL, NULL, 152209),
(152210, '1.10.10.10-FF-000967', NULL, 'Transcriptional regulator, LysR family', 86, NULL, NULL, 152210);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(152211, '3.30.160.60-FF-003382', NULL, NULL, 28, NULL, NULL, 152211),
(152212, '2.40.270.10-FF-000010', NULL, 'DNA-directed RNA polymerase subunit beta', 167, NULL, NULL, 152212),
(152213, '1.25.40.20-FF-001760', NULL, 'Protein tirA', 193, NULL, NULL, 152213),
(152214, '2.120.10.80-FF-000121', NULL, 'acyl-CoA-binding domain-containing protein 4 isoform X1', 173, NULL, NULL, 152214),
(152215, '2.30.42.10-FF-000572', NULL, NULL, 121, NULL, NULL, 152215),
(152216, '3.40.50.11660-FF-000038', NULL, NULL, 202, NULL, NULL, 152216),
(152217, '2.60.40.1970-FF-000011', NULL, 'YEATS family', 260, NULL, NULL, 152217),
(152218, '3.40.30.10-FF-001199', NULL, 'Uncharacterized protein', 78, NULL, NULL, 152218),
(152219, '3.30.70.330-FF-003021', NULL, NULL, 68, NULL, NULL, 152219),
(152220, '1.20.1070.10-FF-001609', NULL, 'Predicted protein', 149, NULL, NULL, 152220),
(152221, '3.30.420.140-FF-000037', NULL, 'SUPT6H,-like protein to suppressor of ty 6', 165, NULL, NULL, 152221),
(152222, '3.50.50.60-FF-000214', NULL, 'PROBABLE MONOOXYGENASE', 153, NULL, NULL, 152222),
(152223, '1.20.1280.20-FF-000015', NULL, 'Fe-S protein assembly co-chaperone HscB', 83, NULL, NULL, 152223),
(152224, '3.10.28.10-FF-000060', NULL, 'DNA polymerase', 163, NULL, NULL, 152224),
(152225, '1.10.238.10-FF-001290', NULL, 'Protein kinase, putative', 80, NULL, NULL, 152225),
(152226, '3.40.50.1000-FF-000163', NULL, 'Pyridoxal phosphate phosphatase', 173, NULL, NULL, 152226),
(152227, '2.130.10.10-FF-002185', NULL, 'Transducin family protein, putative, expressed', 219, NULL, NULL, 152227),
(152228, '4.10.280.110-FF-000010', NULL, 'mRNA splicing factor (Prp18), putative', 69, NULL, NULL, 152228),
(152229, '1.25.10.10-FF-003172', NULL, 'Ras guanine nucleotide exchange factor V', 334, NULL, NULL, 152229),
(152230, '2.70.98.10-FF-000007', NULL, 'Putative alpha-1,2-mannosidase', 306, NULL, NULL, 152230),
(152231, '2.60.40.10-FF-002437', NULL, 'Cilia- and flagella-associated protein 74', 107, NULL, NULL, 152231),
(152232, '3.40.1380.20-FF-000062', NULL, 'Pyruvate kinase', 127, NULL, NULL, 152232),
(152233, '2.60.40.60-FF-000581', NULL, 'Uncharacterized protein', 87, NULL, NULL, 152233),
(152234, '1.20.1740.10-FF-000273', NULL, 'Uncharacterized protein', 193, NULL, NULL, 152234),
(152235, '3.30.70.330-FF-002560', NULL, NULL, 148, NULL, NULL, 152235),
(152236, '3.40.50.300-FF-003944', NULL, 'Shikimate kinase', 169, NULL, NULL, 152236),
(152237, '1.10.287.110-FF-000207', NULL, 'Uncharacterized J domain-containing protein C1071.09c', 97, NULL, NULL, 152237),
(152238, '3.40.50.360-FF-000157', NULL, 'Uncharacterized protein', 115, NULL, NULL, 152238),
(152239, '2.10.25.10-FF-001382', NULL, 'Uncharacterized protein', 74, NULL, NULL, 152239),
(152240, '3.60.21.10-FF-000385', NULL, 'Serine/threonine protein phosphatase, putative', 74, NULL, NULL, 152240),
(152241, '3.40.309.10-FF-000125', NULL, '10-formyltetrahydrofolate dehydrogenase', 59, NULL, NULL, 152241),
(152242, '3.40.630.30-FF-000405', NULL, 'Histone acetyltransferase', 71, NULL, NULL, 152242),
(152243, '1.10.640.10-FF-000072', NULL, 'Uncharacterized protein', 123, NULL, NULL, 152243),
(152244, '3.30.300.130-FF-000030', NULL, NULL, 82, NULL, NULL, 152244),
(152245, '1.10.510.10-FF-003114', NULL, NULL, 191, NULL, NULL, 152245),
(152246, '1.20.1560.10-FF-000175', NULL, 'ABC transporter family protein', 292, NULL, NULL, 152246),
(152247, '1.25.10.10-FF-000350', NULL, 'Kinesin-like protein', 360, NULL, NULL, 152247),
(152248, '3.90.70.10-FF-000154', NULL, 'Putative U4/U6.U5 tri-snRNP-associated protein 2', 349, NULL, NULL, 152248),
(152249, '3.20.20.300-FF-000008', NULL, 'Beta-N-acetylglucosaminidase, putative', 340, NULL, NULL, 152249),
(152250, '1.20.1280.290-FF-000077', NULL, 'Uncharacterized protein', 103, NULL, NULL, 152250),
(152251, '2.20.70.10-FF-000199', NULL, 'Uncharacterized protein', 49, NULL, NULL, 152251),
(152252, '3.90.226.10-FF-000180', NULL, 'Enoyl-CoA hydratase', 204, NULL, NULL, 152252),
(152253, '2.30.29.30-FF-000479', NULL, 'General transcription factor IIH subunit', 109, NULL, NULL, 152253);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(152254, '1.10.1200.10-FF-000072', NULL, 'Nonribosomal peptide synthase, putative', 73, NULL, NULL, 152254),
(152255, '3.40.50.12610-FF-000008', NULL, 'Uncharacterized protein', 66, NULL, NULL, 152255),
(152256, '2.30.29.30-FF-001047', NULL, 'Uncharacterized protein', 64, NULL, NULL, 152256),
(152257, '3.90.226.10-FF-000185', NULL, 'ClpP/crotonase', 215, NULL, NULL, 152257),
(152258, '2.130.10.10-FF-001752', NULL, 'Putative duf1620 domain-containing protein', 308, NULL, NULL, 152258),
(152259, '3.40.190.10-FF-000202', NULL, 'ABC transporter, substrate-binding protein, family 5', 263, NULL, NULL, 152259),
(152260, '3.80.10.10-FF-001775', NULL, 'F-box/LRR-repeat protein 17', 129, NULL, NULL, 152260),
(152261, '2.40.50.90-FF-000057', NULL, 'Nuclease domain containing protein', 110, NULL, NULL, 152261),
(152262, '3.30.70.330-FF-001104', NULL, 'Putative RNA-binding protein EEED8.10', 107, NULL, NULL, 152262),
(152263, '3.30.1680.10-FF-000011', NULL, 'Semaphorin 3B', 51, NULL, NULL, 152263),
(152264, '3.30.230.80-FF-000010', NULL, 'Heat shock protein 75 kDa', 163, NULL, NULL, 152264),
(152265, '1.20.58.80-FF-000069', NULL, 'Uncharacterized protein', 76, NULL, NULL, 152265),
(152266, '1.10.760.10-FF-000070', NULL, 'Cytochrome c peroxidase', 109, NULL, NULL, 152266),
(152267, '1.20.1250.20-FF-001536', NULL, 'Uncharacterized protein', 436, NULL, NULL, 152267),
(152268, '2.40.10.10-FF-000418', NULL, 'GH24985p', 248, NULL, NULL, 152268),
(152269, '2.30.29.30-FF-000535', NULL, 'Tyrosine-protein kinase', 164, NULL, NULL, 152269),
(152270, '3.40.50.11320-FF-000009', NULL, 'Os12g0581400 protein', 93, NULL, NULL, 152270),
(152271, '1.20.120.1630-FF-000011', NULL, 'Delta(14)-sterol reductase', 197, NULL, NULL, 152271),
(152272, '3.40.50.720-FF-000428', NULL, 'Leucoanthocyanidin reductase', 338, NULL, NULL, 152272),
(152273, '1.20.1250.20-FF-001188', NULL, 'WGS project CABT00000000 data, contig 2.10', 265, NULL, NULL, 152273),
(152274, '3.40.1350.100-FF-000008', NULL, NULL, 104, NULL, NULL, 152274),
(152275, '2.170.140.10-FF-000009', NULL, 'Chondroitin proteoglycan 1', 66, NULL, NULL, 152275),
(152276, '2.130.10.10-FF-001696', NULL, 'WD repeats protein kinase', 249, NULL, NULL, 152276),
(152277, '3.30.420.40-FF-000468', NULL, 'DnaK protein', 94, NULL, NULL, 152277),
(152278, '3.30.60.270-FF-000011', NULL, 'Sortilin', 78, NULL, NULL, 152278),
(152279, '2.130.10.10-FF-000509', NULL, 'U3 small nucleolar RNA-interacting protein', 335, NULL, NULL, 152279),
(152280, '2.60.120.10-FF-000540', NULL, 'AER145Wp', 161, NULL, NULL, 152280),
(152281, '3.40.50.150-FF-001516', NULL, NULL, 110, NULL, NULL, 152281),
(152282, '2.60.120.10-FF-000484', NULL, 'Homogentisate 1,2-dioxygenase', 136, NULL, NULL, 152282),
(152283, '3.90.70.10-FF-000210', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 363, NULL, NULL, 152283),
(152284, '3.30.160.60-FF-004742', NULL, NULL, 27, NULL, NULL, 152284),
(152285, '2.40.240.20-FF-000011', NULL, NULL, 71, NULL, NULL, 152285),
(152286, '1.25.40.10-FF-001487', NULL, 'Os12g0552300 protein', 158, NULL, NULL, 152286),
(152287, '1.20.1250.20-FF-000019', NULL, 'Multidrug resistance protein B', 199, NULL, NULL, 152287),
(152288, '3.30.260.10-FF-000070', NULL, NULL, 70, NULL, NULL, 152288),
(152289, '2.30.29.30-FF-000827', NULL, 'Uncharacterized protein', 111, NULL, NULL, 152289),
(152290, '3.30.1370.10-FF-000089', NULL, 'BnaC09g50550D protein', 77, NULL, NULL, 152290),
(152291, '1.20.1250.20-FF-000750', NULL, 'protein NRT1/ PTR FAMILY 5.4', 507, NULL, NULL, 152291),
(152292, '3.40.20.10-FF-000024', NULL, 'Glia maturation factor', 139, NULL, NULL, 152292),
(152293, '3.40.50.300-FF-007311', NULL, 'Uncharacterized protein', 147, NULL, NULL, 152293),
(152294, '1.20.5.170-FF-000112', NULL, 'testis-specific serine kinase substrate', 109, NULL, NULL, 152294),
(152295, '3.40.50.12760-FF-000025', NULL, 'Uncharacterized protein', 154, NULL, NULL, 152295),
(152296, '3.40.50.720-FF-002030', NULL, 'Fatty acyl-CoA reductase', 194, NULL, NULL, 152296),
(152297, '2.60.120.10-FF-000832', NULL, 'Transcriptional regulator (Crp/Fnr family)', 149, NULL, NULL, 152297);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(152298, '2.40.50.1060-FF-000024', NULL, 'Uncharacterized protein', 194, NULL, NULL, 152298),
(152299, '3.90.1210.10-FF-000007', NULL, NULL, 61, NULL, NULL, 152299),
(152300, '1.10.10.2660-FF-000005', NULL, 'Ubiquitin-activating enzyme E1, putative', 276, NULL, NULL, 152300),
(152301, '2.60.40.10-FF-000875', NULL, 'Interleukin 12 receptor subunit beta 2', 104, NULL, NULL, 152301),
(152302, '2.30.60.10-FF-000001', NULL, 'Cyanovirin-N', 101, NULL, NULL, 152302),
(152303, '3.10.129.10-FF-000163', NULL, 'Thioesterase', 136, NULL, NULL, 152303),
(152304, '2.30.29.30-FF-001103', NULL, 'Uncharacterized protein', 153, NULL, NULL, 152304),
(152305, '3.10.100.10-FF-000136', NULL, 'Mannose receptor, C type 2', 137, NULL, NULL, 152305),
(152306, '3.30.70.2850-FF-000006', NULL, 'DNA-directed RNA polymerase subunit', 229, NULL, NULL, 152306),
(152307, '2.60.40.150-FF-000108', NULL, 'Synaptotagmin like 1', 165, NULL, NULL, 152307),
(152308, '1.25.10.10-FF-003109', NULL, 'Uncharacterized protein', 216, NULL, NULL, 152308),
(152309, '3.30.310.80-FF-000011', NULL, 'Non-specific serine/threonine protein kinase', 105, NULL, NULL, 152309),
(152310, '1.20.1250.20-FF-001587', NULL, 'Monocarboxylate transporter 2, transcript variant X3', 326, NULL, NULL, 152310),
(152311, '3.30.70.330-FF-001447', NULL, 'RNA-binding protein', 128, NULL, NULL, 152311),
(152312, '3.30.160.60-FF-005147', NULL, NULL, 63, NULL, NULL, 152312),
(152313, '3.10.490.10-FF-000046', NULL, 'Putative gamma-glutamylcyclotransferase CG2811-like Protein', 145, NULL, NULL, 152313),
(152314, '3.40.50.2000-FF-000654', NULL, 'Glycosyltransferase', 238, NULL, NULL, 152314),
(152315, '3.30.200.20-FF-001772', NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', 102, NULL, NULL, 152315),
(152316, '2.40.50.140-FF-000533', NULL, 'Aspartate--tRNA ligase', 129, NULL, NULL, 152316),
(152317, '2.30.29.30-FF-000086', NULL, 'GRAM domain-containing protein 2B isoform 2', 109, NULL, NULL, 152317),
(152318, '3.20.20.70-FF-000301', NULL, '2-nitropropane dioxygenase family', 332, NULL, NULL, 152318),
(152319, '1.20.58.60-FF-000030', NULL, 'Short stop, isoform K', 94, NULL, NULL, 152319),
(152320, '3.40.190.80-FF-000021', NULL, 'Myo-inositol-1(Or 4)-monophosphatase', 132, NULL, NULL, 152320),
(152321, '1.25.10.10-FF-000355', NULL, 'Exportin-T', 1005, NULL, NULL, 152321),
(152322, '1.25.40.10-FF-002780', NULL, 'Uncharacterized protein', 143, NULL, NULL, 152322),
(152323, '2.60.120.1190-FF-000002', NULL, 'epithelial discoidin domain-containing receptor 1', 185, NULL, NULL, 152323),
(152324, '1.25.10.10-FF-001659', NULL, 'Subunit of TORC2 (Tor2p-Lst8p-Avo1-Avo2-Tsc11p-Bit61p), a membrane-associated complex that regulates actin cytoskeletal dynamics during polarized growth and cell wall integrity, putative', 355, NULL, NULL, 152324),
(152325, '2.60.40.10-FF-004186', NULL, NULL, 113, NULL, NULL, 152325),
(152326, '1.20.58.2130-FF-000001', NULL, 'Uncharacterized protein', 276, NULL, NULL, 152326),
(152327, '2.20.100.10-FF-000121', NULL, 'Lonely heart, isoform A', 61, NULL, NULL, 152327),
(152328, '3.40.50.10490-FF-000142', NULL, NULL, 198, NULL, NULL, 152328),
(152329, '1.10.10.10-FF-000731', NULL, 'Phenazine-specific methyltransferase', 88, NULL, NULL, 152329),
(152330, '2.60.40.10-FF-000824', NULL, 'Hemicentin 1', 91, NULL, NULL, 152330),
(152331, '2.60.120.10-FF-000091', NULL, 'cGMP-dependent protein kinase', 139, NULL, NULL, 152331),
(152332, '3.30.450.20-FF-000407', NULL, 'Sensor histidine kinase, PAS, PAS and PAS domain-containing', 120, NULL, NULL, 152332),
(152333, '1.10.10.10-FF-000170', NULL, 'Vacuolar protein-sorting-associated protein 36', 68, NULL, NULL, 152333),
(152334, '1.25.10.10-FF-002952', NULL, 'Uncharacterized protein', 467, NULL, NULL, 152334),
(152335, '3.60.130.10-FF-000003', NULL, 'Alpha-ketoglutarate-dependent taurine dioxygenase', 291, NULL, NULL, 152335),
(152336, '1.20.90.10-FF-000022', NULL, NULL, 50, NULL, NULL, 152336),
(152337, '1.10.510.10-FF-002676', NULL, NULL, 58, NULL, NULL, 152337),
(152338, '2.120.10.80-FF-000177', NULL, 'Putative protein tag-53', 183, NULL, NULL, 152338);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(152339, '1.20.5.570-FF-000001', NULL, '3-octaprenyl-4-hydroxybenzoate carboxy-lyase', 38, NULL, NULL, 152339),
(152340, '1.20.120.730-FF-000026', NULL, 'Protein transport protein SEC23', 111, NULL, NULL, 152340),
(152341, '3.40.50.11260-FF-000002', NULL, 'Molecular chaperone HtpG', 93, NULL, NULL, 152341),
(152342, '2.60.40.10-FF-001100', NULL, 'Usherin', 105, NULL, NULL, 152342),
(152343, '4.10.240.10-FF-000131', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 67, NULL, NULL, 152343),
(152344, '2.70.98.10-FF-000119', NULL, 'Alpha-1,2-mannosidase family protein', 304, NULL, NULL, 152344),
(152345, '2.60.120.290-FF-000058', NULL, 'CUB domaincontaining protein', 129, NULL, NULL, 152345),
(152346, '1.20.120.1750-FF-000030', NULL, 'RBR-type E3 ubiquitin transferase', 225, NULL, NULL, 152346),
(152347, '3.40.1230.10-FF-000014', NULL, 'Uncharacterized protein', 137, NULL, NULL, 152347),
(152348, '3.30.1370.70-FF-000005', NULL, 'Type Fe-S cluster assembly protein NFU', 96, NULL, NULL, 152348),
(152349, '3.40.532.10-FF-000020', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 227, NULL, NULL, 152349),
(152350, '2.130.10.10-FF-004843', NULL, 'Uncharacterized protein', 131, NULL, NULL, 152350),
(152351, '3.40.50.300-FF-001527', NULL, 'AAA family ATPase', 215, NULL, NULL, 152351),
(152352, '2.40.30.10-FF-000184', NULL, 'Ferredoxin--NADP reductase', 101, NULL, NULL, 152352),
(152353, '3.40.33.10-FF-000059', NULL, 'Uncharacterized protein', 127, NULL, NULL, 152353),
(152354, '1.10.630.10-FF-000127', NULL, 'Cytochrome P450 Cyp124', 428, NULL, NULL, 152354),
(152355, '3.30.70.330-FF-000143', NULL, 'msx2-interacting protein-like isoform X1', 76, NULL, NULL, 152355),
(152356, '3.30.70.330-FF-001048', NULL, 'Nucleolar protein 12', 88, NULL, NULL, 152356),
(152357, '1.10.472.130-FF-000006', NULL, 'Dynein axonemal heavy chain 1', 173, NULL, NULL, 152357),
(152358, '3.30.1370.10-FF-000145', NULL, 'KH domain-containing protein', 72, NULL, NULL, 152358),
(152359, '1.10.10.10-FF-000063', NULL, 'LysR family transcriptional regulator', 88, NULL, NULL, 152359),
(152360, '2.10.25.10-FF-001494', NULL, 'Scavenger receptor cysteine-rich protein variant 1', 35, NULL, NULL, 152360),
(152361, '3.40.50.2300-FF-000682', NULL, 'Vomeronasal 2 receptor, x4', 157, NULL, NULL, 152361),
(152362, '2.120.10.30-FF-000483', NULL, 'Predicted protein', 294, NULL, NULL, 152362),
(152363, '1.20.5.170-FF-000056', NULL, 'DNA repair protein SWI5 homolog', 64, NULL, NULL, 152363),
(152364, '2.30.30.40-FF-000553', NULL, 'SH3 domain protein, conserved', 100, NULL, NULL, 152364),
(152365, '1.25.10.10-FF-002660', NULL, 'ATPase H+-transporting V1 subunit H', 100, NULL, NULL, 152365),
(152366, '1.10.760.10-FF-000007', NULL, 'Cytochrome c peroxidase', 128, NULL, NULL, 152366),
(152367, '3.30.465.10-FF-000107', NULL, 'Uncharacterized protein', 234, NULL, NULL, 152367),
(152368, '3.30.160.60-FF-002218', NULL, 'Transcriptional regulator CRZ1', 26, NULL, NULL, 152368),
(152369, '3.30.40.10-FF-001458', NULL, 'Peroxisome assembly protein, putative', 79, NULL, NULL, 152369),
(152370, '3.30.230.10-FF-000242', NULL, 'Galactokinase', 200, NULL, NULL, 152370),
(152371, '3.30.470.20-FF-000122', NULL, 'Formate-dependent phosphoribosylglycinamide formyltransferase', 200, NULL, NULL, 152371),
(152372, '3.90.70.10-FF-000159', NULL, 'Ubiquitin-specific protease', 351, NULL, NULL, 152372),
(152373, '3.30.450.20-FF-000290', NULL, 'Development and carotenogenesis control-1 protein', 128, NULL, NULL, 152373),
(152374, '3.80.10.10-FF-003517', NULL, 'Uncharacterized protein', 176, NULL, NULL, 152374),
(152375, '2.40.37.10-FF-000014', NULL, 'Ornithine decarboxylase', 127, NULL, NULL, 152375),
(152376, '3.80.20.20-FF-000025', NULL, 'Tyrosine-protein kinase receptor', 137, NULL, NULL, 152376),
(152377, '3.10.110.10-FF-000018', NULL, 'Ubiquitin-conjugating enzyme E2 G1', 164, NULL, NULL, 152377),
(152378, '3.40.50.10190-FF-000114', NULL, 'DNA ligase', 111, NULL, NULL, 152378),
(152379, '3.40.1810.10-FF-000059', NULL, NULL, 70, NULL, NULL, 152379);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(152380, '3.10.100.10-FF-000187', NULL, 'Latrophilin-like protein LAT-2', 124, NULL, NULL, 152380),
(152381, '2.60.40.10-FF-004747', NULL, NULL, 110, NULL, NULL, 152381),
(152382, '3.30.565.10-FF-000278', NULL, 'Sporulation-specific ATP-dependent proteinhistidine kinase', 146, NULL, NULL, 152382),
(152383, '3.40.50.10810-FF-000137', NULL, 'Helicase-like protein', 255, NULL, NULL, 152383),
(152384, '3.30.9.10-FF-000144', NULL, 'FAD dependent oxidoreductase', 144, NULL, NULL, 152384),
(152385, '1.25.10.10-FF-002148', NULL, 'Os01g0235400 protein', 536, NULL, NULL, 152385),
(152386, '3.40.630.30-FF-000512', NULL, 'Uncharacterized protein', 125, NULL, NULL, 152386),
(152387, '3.30.9.10-FF-000200', NULL, 'Glycerol-3-phosphate dehydrogenase (FAD-dependent), putative', 120, NULL, NULL, 152387),
(152388, '3.90.1010.10-FF-000003', NULL, 'NifU family SUF system Fe-S assembly protein', 151, NULL, NULL, 152388),
(152389, '2.60.120.260-FF-000566', NULL, 'Predicted protein', 33, NULL, NULL, 152389),
(152390, '1.20.58.60-FF-000822', NULL, 'Uncharacterized protein', 181, NULL, NULL, 152390),
(152391, '3.40.50.620-FF-000724', NULL, 'Nicotinamide-nucleotide adenylyltransferase', 201, NULL, NULL, 152391),
(152392, '3.30.420.10-FF-000072', NULL, 'DNA-directed DNA polymerase', 232, NULL, NULL, 152392),
(152393, '2.160.20.10-FF-000138', NULL, 'Putative pectinesterase/pectinesterase inhibitor 54', 126, NULL, NULL, 152393),
(152394, '3.80.10.10-FF-003225', NULL, 'Uncharacterized protein', 201, NULL, NULL, 152394),
(152395, '3.80.10.10-FF-001196', NULL, 'F-box/LRR-repeat protein 4', 239, NULL, NULL, 152395),
(152396, '3.20.20.80-FF-000051', NULL, 'glycogen debranching enzyme isoform X2', 221, NULL, NULL, 152396),
(152397, '3.30.470.20-FF-000173', NULL, 'Uncharacterized protein', 136, NULL, NULL, 152397),
(152398, '3.80.10.10-FF-003169', NULL, 'Uncharacterized protein', 270, NULL, NULL, 152398),
(152399, '3.30.54.20-FF-000004', NULL, 'Alanine--tRNA ligase', 56, NULL, NULL, 152399),
(152400, '1.20.120.160-FF-000046', NULL, 'Diguanylate cyclase', 119, NULL, NULL, 152400),
(152401, '1.10.8.60-FF-000537', NULL, 'Peroxisome biogenesis factor, putative', 92, NULL, NULL, 152401),
(152402, '3.40.390.10-FF-000206', NULL, NULL, 97, NULL, NULL, 152402),
(152403, '2.60.40.10-FF-005315', NULL, NULL, 78, NULL, NULL, 152403),
(152404, '1.10.10.10-FF-000675', NULL, 'Cell division cycle-related protein', 87, NULL, NULL, 152404),
(152405, '1.10.10.10-FF-001131', NULL, 'Winged helix-turn-helix transcriptional regulator', 59, NULL, NULL, 152405),
(152406, '2.120.10.80-FF-000126', NULL, 'Calicin', 211, NULL, NULL, 152406),
(152407, '1.10.20.10-FF-000288', NULL, NULL, 70, NULL, NULL, 152407),
(152408, '1.20.120.1750-FF-000081', NULL, 'RBR-type E3 ubiquitin transferase', 77, NULL, NULL, 152408),
(152409, '2.60.120.290-FF-000114', NULL, 'AGAP004160-PA', 128, NULL, NULL, 152409),
(152410, '1.25.10.10-FF-000299', NULL, 'Protein phosphatase 4 regulatory subunit 1-like (pseudogene)', 329, NULL, NULL, 152410),
(152411, '3.30.160.60-FF-002269', NULL, NULL, 29, NULL, NULL, 152411),
(152412, '2.60.40.10-FF-001044', NULL, 'TAP binding protein', 111, NULL, NULL, 152412),
(152413, '3.30.450.20-FF-000470', NULL, 'Period', 176, NULL, NULL, 152413),
(152414, '3.30.450.40-FF-000296', NULL, 'Histidine kinase', 185, NULL, NULL, 152414),
(152415, '3.40.50.720-FF-002553', NULL, '17-beta-hydroxysteroid dehydrogenase type 4', 64, NULL, NULL, 152415),
(152416, '1.10.10.10-FF-000855', NULL, 'ArsR family transcriptional regulator', 92, NULL, NULL, 152416),
(152417, '3.30.420.10-FF-000021', NULL, 'RNA exonuclease 1 homolog', 165, NULL, NULL, 152417),
(152418, '1.10.460.10-FF-000030', NULL, 'DNA topoisomerase', 63, NULL, NULL, 152418),
(152419, '3.30.500.40-FF-000002', NULL, 'Zinc finger FYVE domain-containing protein 16', 150, NULL, NULL, 152419),
(152420, '1.10.510.10-FF-003906', NULL, NULL, 82, NULL, NULL, 152420),
(152421, '1.10.418.10-FF-000196', NULL, 'Uncharacterized protein', 155, NULL, NULL, 152421),
(152422, '2.60.120.380-FF-000080', NULL, 'AGAP012907-PA', 58, NULL, NULL, 152422); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(152423, '3.30.70.330-FF-000087', NULL, 'Nucleolysin TIAR isoform 1', 87, NULL, NULL, 152423),
(152424, '2.60.300.12-FF-000028', NULL, NULL, 95, NULL, NULL, 152424),
(152425, '3.80.10.10-FF-003568', NULL, 'Predicted protein', 146, NULL, NULL, 152425),
(152426, '3.40.1190.20-FF-000199', NULL, NULL, 201, NULL, NULL, 152426),
(152427, '3.30.1440.10-FF-000010', NULL, 'Uncharacterized protein', 197, NULL, NULL, 152427),
(152428, '2.60.40.4100-FF-000021', NULL, 'Uncharacterized protein', 149, NULL, NULL, 152428),
(152429, '3.40.630.60-FF-000004', NULL, 'Putative Ornithine decarboxylase antizyme', 139, NULL, NULL, 152429),
(152430, '1.50.10.10-FF-000230', NULL, 'alpha-1,2-Mannosidase', 153, NULL, NULL, 152430),
(152431, '2.130.10.10-FF-005063', NULL, 'Predicted protein', 273, NULL, NULL, 152431),
(152432, '3.40.718.10-FF-000064', NULL, 'Isocitrate dehydrogenase [NAD] subunit alpha, mitochondrial', 97, NULL, NULL, 152432),
(152433, '3.20.20.150-FF-000042', NULL, 'Xylose isomerase domain protein TIM barrel', 297, NULL, NULL, 152433),
(152434, '3.30.70.1050-FF-000006', NULL, 'Trigger factor', 117, NULL, NULL, 152434),
(152435, '1.10.275.20-FF-000012', NULL, NULL, 84, NULL, NULL, 152435),
(152436, '2.60.120.260-FF-000223', NULL, 'F5/8 type C domain protein', 114, NULL, NULL, 152436),
(152437, '3.40.850.10-FF-000337', NULL, 'Kinesin-like protein', 95, NULL, NULL, 152437),
(152438, '2.40.30.110-FF-000009', NULL, 'Glycine cleavage system T protein', 85, NULL, NULL, 152438),
(152439, '3.90.550.10-FF-000399', NULL, 'Glycosyltransferase, group 2 family protein', 252, NULL, NULL, 152439),
(152440, '3.30.420.60-FF-000007', NULL, 'Eukaryotic peptide chain release factor subunit 1', 145, NULL, NULL, 152440),
(152441, '1.20.5.340-FF-000129', NULL, 'Predicted protein', 119, NULL, NULL, 152441),
(152442, '2.60.40.10-FF-004354', NULL, NULL, 86, NULL, NULL, 152442),
(152443, '3.40.50.300-FF-000297', NULL, 'Uridine-cytidine kinase 2', 222, NULL, NULL, 152443),
(152444, '2.130.10.10-FF-001191', NULL, 'WD repeat-containing protein 48', 210, NULL, NULL, 152444),
(152445, '3.40.1110.10-FF-000146', NULL, 'Phospholipid-transporting ATPase', 119, NULL, NULL, 152445),
(152446, '3.30.559.10-FF-000106', NULL, 'Spermidine sinapoyl-CoA acyltransferase', 207, NULL, NULL, 152446),
(152447, '1.10.418.10-FF-000145', NULL, 'WGS project CABT00000000 data, contig 2.3', 145, NULL, NULL, 152447),
(152448, '1.10.510.10-FF-002732', NULL, NULL, 180, NULL, NULL, 152448),
(152449, '1.10.10.60-FF-001180', NULL, NULL, 36, NULL, NULL, 152449),
(152450, '3.40.50.300-FF-001590', NULL, 'DNA polymerase III, delta subunit', 176, NULL, NULL, 152450),
(152451, '1.20.120.520-FF-000002', NULL, 'F-box/LRR-repeat protein 5 isoform X2', 160, NULL, NULL, 152451),
(152452, '2.40.330.10-FF-000009', NULL, 'Transcriptional factor B3 family protein', 97, NULL, NULL, 152452),
(152453, '2.60.15.10-FF-000007', NULL, 'ATP synthase epsilon chain', 91, NULL, NULL, 152453),
(152454, '3.30.1490.70-FF-000008', NULL, 'DNA ligase', 57, NULL, NULL, 152454),
(152455, '1.20.120.350-FF-000277', NULL, NULL, 134, NULL, NULL, 152455),
(152456, '3.40.640.10-FF-000456', NULL, 'DegT/DnrJ/EryC1/StrS aminotransferase family protein', 228, NULL, NULL, 152456),
(152457, '3.20.20.80-FF-000523', NULL, 'Alpha-L-arabinofuranosidase A', 278, NULL, NULL, 152457),
(152458, '3.30.160.60-FF-006260', NULL, NULL, 91, NULL, NULL, 152458),
(152459, '2.60.40.10-FF-001095', NULL, 'Interleukin 22 receptor, alpha 2', 104, NULL, NULL, 152459),
(152460, '1.10.275.40-FF-000018', NULL, 'Helicase, putative', 34, NULL, NULL, 152460),
(152461, '2.130.10.10-FF-000392', NULL, 'WD repeat-containing protein 37', 131, NULL, NULL, 152461),
(152462, '3.40.390.10-FF-000257', NULL, NULL, 220, NULL, NULL, 152462),
(152463, '3.40.50.1000-FF-000270', NULL, 'Nuclear envelope-endoplasmic reticulum network protein', 194, NULL, NULL, 152463),
(152464, '3.40.50.300-FF-006873', NULL, 'Branched-chain amino acid ABC transporter, ATP-binding protein', 250, NULL, NULL, 152464),
(152465, '3.60.130.10-FF-000054', NULL, 'Uncharacterized protein', 273, NULL, NULL, 152465);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(152466, '2.30.31.10-FF-000029', NULL, 'Uncharacterized protein', 32, NULL, NULL, 152466),
(152467, '3.40.640.10-FF-000243', NULL, 'Cytochrome D ubiquinol oxidase subunit I', 275, NULL, NULL, 152467),
(152468, '1.10.10.60-FF-000381', NULL, 'Transcription factor MYB119', 65, NULL, NULL, 152468),
(152469, '2.30.29.30-FF-000878', NULL, 'Uncharacterized protein', 116, NULL, NULL, 152469),
(152470, '1.20.1070.10-FF-000305', NULL, 'Sphingosine 1-phosphate receptor 4', 282, NULL, NULL, 152470),
(152471, '2.60.40.10-FF-000083', NULL, 'Sortilin-related VPS10 domain containing receptor 2', 96, NULL, NULL, 152471),
(152472, '3.30.40.10-FF-000672', NULL, 'E3 ubiquitin-protein ligase ATL41', 92, NULL, NULL, 152472),
(152473, '2.130.10.110-FF-000017', NULL, 'Uncharacterized protein', 350, NULL, NULL, 152473),
(152474, '2.40.10.10-FF-000481', NULL, NULL, 100, NULL, NULL, 152474),
(152475, '3.40.50.300-FF-005861', NULL, 'Predicted protein', 229, NULL, NULL, 152475),
(152476, '1.10.1600.10-FF-000001', NULL, 'X-ray repair cross-complementing protein 6 isoform X2', 94, NULL, NULL, 152476),
(152477, '3.10.20.230-FF-000012', NULL, 'Doublecortin domain containing 2C', 85, NULL, NULL, 152477),
(152478, '1.10.472.10-FF-000422', NULL, 'Cyclin-T1-5', 72, NULL, NULL, 152478),
(152479, '3.40.718.10-FF-000013', NULL, 'Tartrate dehydrogenase', 360, NULL, NULL, 152479),
(152480, '3.30.200.20-FF-002553', NULL, NULL, 110, NULL, NULL, 152480),
(152481, '1.10.510.10-FF-003457', NULL, NULL, 274, NULL, NULL, 152481),
(152482, '1.20.58.60-FF-000479', NULL, 'Microtubule-actin crosslinking factor 1', 110, NULL, NULL, 152482),
(152483, '1.10.8.10-FF-000371', NULL, 'Nascent polypeptide-associated complex subunit alpha', 38, NULL, NULL, 152483),
(152484, '3.40.50.300-FF-005529', NULL, 'DNA helicase', 93, NULL, NULL, 152484),
(152485, '2.60.40.10-FF-003461', NULL, NULL, 98, NULL, NULL, 152485),
(152486, '1.10.30.10-FF-000002', NULL, 'transcription factor Sox-2', 78, NULL, NULL, 152486),
(152487, '3.40.570.10-FF-000012', NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase 2', 316, NULL, NULL, 152487),
(152488, '3.30.70.330-FF-000666', NULL, 'UBP1-associated protein 2A', 125, NULL, NULL, 152488),
(152489, '3.30.1330.40-FF-000016', NULL, 'Endoribonuclease', 123, NULL, NULL, 152489),
(152490, '2.60.40.640-FF-000042', NULL, 'Vacuolar sorting-associated protein-like,putative', 158, NULL, NULL, 152490),
(152491, '1.20.1070.10-FF-000704', NULL, 'NeuroPeptide Receptor family', 313, NULL, NULL, 152491),
(152492, '2.60.220.50-FF-000144', NULL, 'Uncharacterized protein', 138, NULL, NULL, 152492),
(152493, '1.10.3730.20-FF-000019', NULL, 'DMT family transporter', 133, NULL, NULL, 152493),
(152494, '1.25.10.10-FF-000586', NULL, 'Microtubule-associated protein TORTIFOLIA1', 355, NULL, NULL, 152494),
(152495, '3.30.497.10-FF-000158', NULL, 'Serpin, putative', 59, NULL, NULL, 152495),
(152496, '2.60.120.10-FF-000596', NULL, 'cGMP-dependent protein kinase, putative', 104, NULL, NULL, 152496),
(152497, '1.25.40.90-FF-000049', NULL, 'ZFP family member, putative', 133, NULL, NULL, 152497),
(152498, '1.25.10.10-FF-000642', NULL, 'TATA-binding protein-associated factor BTAF1', 96, NULL, NULL, 152498),
(152499, '1.20.1390.10-FF-000015', NULL, 'RNA-binding protein 26', 83, NULL, NULL, 152499),
(152500, '2.10.110.10-FF-000056', NULL, 'insulin gene enhancer protein ISL-1', 65, NULL, NULL, 152500),
(152501, '1.10.150.240-FF-000123', NULL, 'Phosphoglycolate phosphatase', 66, NULL, NULL, 152501),
(152502, '3.40.50.300-FF-001258', NULL, 'Sulfotransferase', 319, NULL, NULL, 152502),
(152503, '3.40.605.10-FF-000049', NULL, 'CRE-ALH-9 protein', 262, NULL, NULL, 152503),
(152504, '1.10.3710.10-FF-000015', NULL, 'ATP/GTP-binding domain protein', 68, NULL, NULL, 152504),
(152505, '2.30.40.10-FF-000062', NULL, 'Pyrimidine deaminase archaeal predicted', 68, NULL, NULL, 152505),
(152506, '1.10.720.60-FF-000003', NULL, 'Enolase-phosphatase E1', 83, NULL, NULL, 152506),
(152507, '3.30.70.960-FF-000006', NULL, 'Suppressor of tumorigenicity 14 protein homolog', 96, NULL, NULL, 152507);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(152508, '2.60.40.2130-FF-000014', NULL, 'Uncharacterized protein', 80, NULL, NULL, 152508),
(152509, '2.60.40.10-FF-005602', NULL, NULL, 56, NULL, NULL, 152509),
(152510, '3.30.70.330-FF-002852', NULL, NULL, 82, NULL, NULL, 152510),
(152511, '3.30.200.20-FF-000367', NULL, 'Protein kinase C', 51, NULL, NULL, 152511),
(152512, '3.40.50.2000-FF-000182', NULL, 'UDP-N-acetylglucosamine transferase subunit ALG14 isogeny', 181, NULL, NULL, 152512),
(152513, '3.40.1650.10-FF-000001', NULL, 'L-fucose mutarotase', 140, NULL, NULL, 152513),
(152514, '3.40.50.2300-FF-000114', NULL, 'Guanylate cyclase', 170, NULL, NULL, 152514),
(152515, '3.30.160.60-FF-000240', NULL, 'Zinc finger protein 250', 28, NULL, NULL, 152515),
(152516, '1.20.58.60-FF-000535', NULL, 'Nesprin-3', 172, NULL, NULL, 152516),
(152517, '2.130.10.10-FF-002477', NULL, 'Mitogen-activated protein kinase kinase kinase A', 72, NULL, NULL, 152517),
(152518, '3.30.43.10-FF-000026', NULL, 'Aldehyde oxidase 4', 87, NULL, NULL, 152518),
(152519, '3.30.60.20-FF-000153', NULL, 'Predicted protein', 59, NULL, NULL, 152519),
(152520, '3.30.70.660-FF-000074', NULL, 'tRNA pseudouridine synthase', 128, NULL, NULL, 152520),
(152521, '2.30.30.100-FF-000093', NULL, 'U6 snRNA-associated Sm-like protein LSm4', 79, NULL, NULL, 152521),
(152522, '3.90.1150.10-FF-000221', NULL, 'Lysine decarboxylase, constitutive', 166, NULL, NULL, 152522),
(152523, '3.10.290.10-FF-000065', NULL, 'Pseudouridine synthase', 65, NULL, NULL, 152523),
(152524, '1.10.510.10-FF-003513', NULL, NULL, 249, NULL, NULL, 152524),
(152525, '3.40.50.1820-FF-001089', NULL, 'Hydrolase, alpha/beta fold family protein, putative, expressed', 320, NULL, NULL, 152525),
(152526, '2.30.140.10-FF-000014', NULL, 'Polyamine aminopropyltransferase', 51, NULL, NULL, 152526),
(152527, '3.30.70.330-FF-000559', NULL, 'U11/U12 small nuclear ribonucleoprotein 65 kDa protein', 99, NULL, NULL, 152527),
(152528, '3.30.160.60-FF-004455', NULL, NULL, 30, NULL, NULL, 152528),
(152529, '2.60.120.470-FF-000011', NULL, 'Uncharacterized protein', 181, NULL, NULL, 152529),
(152530, '3.40.640.10-FF-000512', NULL, 'Serine--pyruvate aminotransferase', 51, NULL, NULL, 152530),
(152531, '2.30.29.30-FF-000030', NULL, 'Oxysterol-binding protein', 122, NULL, NULL, 152531),
(152532, '1.20.1300.10-FF-000015', NULL, 'Succinate dehydrogenase cytochrome B subunit', 125, NULL, NULL, 152532),
(152533, '3.90.1150.10-FF-000165', NULL, 'Probable L-lysine-epsilon aminotransferase', 168, NULL, NULL, 152533),
(152534, '3.20.20.140-FF-000213', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 160, NULL, NULL, 152534),
(152535, '3.30.40.10-FF-001565', NULL, 'YALI0B22088p', 97, NULL, NULL, 152535),
(152536, '3.40.50.720-FF-001884', NULL, 'Protein CBG22303', 252, NULL, NULL, 152536),
(152537, '1.10.357.40-FF-000006', NULL, 'Riboflavin biosynthesis protein VVA0006', 158, NULL, NULL, 152537),
(152538, '3.30.160.60-FF-002325', NULL, 'Si:cabz01021430.2', 28, NULL, NULL, 152538),
(152539, '3.40.50.80-FF-000176', NULL, 'FAD-binding domain-domain-containing protein', 239, NULL, NULL, 152539),
(152540, '2.40.10.10-FF-000149', NULL, 'Inactive serine protease 35', 19, NULL, NULL, 152540),
(152541, '3.40.50.300-FF-000746', NULL, 'Ribosome assembly protein 1', 253, NULL, NULL, 152541),
(152542, '3.90.1310.10-FF-000043', NULL, 'Penicillin binding protein 2', 190, NULL, NULL, 152542),
(152543, '3.40.50.10260-FF-000039', NULL, 'Uncharacterized protein', 154, NULL, NULL, 152543),
(152544, '1.10.8.10-FF-000039', NULL, 'HBS1-like translational GTPase', 56, NULL, NULL, 152544),
(152545, '3.30.160.60-FF-005759', NULL, NULL, 28, NULL, NULL, 152545),
(152546, '1.10.1410.40-FF-000006', NULL, 'Inositol 1,4,5-trisphosphate receptor-interacting protein', 116, NULL, NULL, 152546),
(152547, '3.80.10.10-FF-001988', NULL, 'Uncharacterized protein', 145, NULL, NULL, 152547),
(152548, '1.10.8.960-FF-000008', NULL, 'Uncharacterized protein', 59, NULL, NULL, 152548),
(152549, '2.60.40.10-FF-001313', NULL, 'Hemicentin 1', 93, NULL, NULL, 152549),
(152550, '1.20.1110.10-FF-000259', NULL, NULL, 88, NULL, NULL, 152550); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(152551, '1.25.40.10-FF-002268', NULL, 'Pentatricopeptide repeat protein', 219, NULL, NULL, 152551),
(152552, '3.50.7.10-FF-000056', NULL, NULL, 185, NULL, NULL, 152552),
(152553, '2.130.10.10-FF-004950', NULL, 'WD-repeat protein, putative', 316, NULL, NULL, 152553),
(152554, '3.30.60.20-FF-000097', NULL, 'CYtoKinesis defect', 56, NULL, NULL, 152554),
(152555, '3.90.79.10-FF-000258', NULL, 'Predicted protein', 133, NULL, NULL, 152555),
(152556, '3.10.20.90-FF-000717', NULL, 'Uncharacterized protein', 62, NULL, NULL, 152556),
(152557, '3.40.50.300-FF-006530', NULL, 'Uncharacterized protein', 109, NULL, NULL, 152557),
(152558, '3.40.1550.20-FF-000002', NULL, 'Transcriptional regulator MraZ', 141, NULL, NULL, 152558),
(152559, '3.30.160.60-FF-000184', NULL, 'Zinc finger protein 333', 29, NULL, NULL, 152559),
(152560, '2.10.110.10-FF-000112', NULL, 'Rho GTPase activator (Lrg11)', 76, NULL, NULL, 152560),
(152561, '1.10.10.10-FF-001423', NULL, 'BLM RecQ like helicase', 84, NULL, NULL, 152561),
(152562, '3.40.50.10490-FF-000035', NULL, '30S ribosomal protein S2', 186, NULL, NULL, 152562),
(152563, '3.30.70.330-FF-002796', NULL, NULL, 96, NULL, NULL, 152563),
(152564, '3.30.200.20-FF-000423', NULL, 'L-type lectin-domain containing receptor kinase S.1', 91, NULL, NULL, 152564),
(152565, '1.20.1560.10-FF-000287', NULL, 'ABC transporter ATP-binding protein', 315, NULL, NULL, 152565),
(152566, '2.10.70.10-FF-000053', NULL, 'CUB and Sushi multiple domains 3', 58, NULL, NULL, 152566),
(152567, '1.20.970.10-FF-000004', NULL, 'Thymidine phosphorylase', 67, NULL, NULL, 152567),
(152568, '3.30.1370.240-FF-000007', NULL, 'Phenylalanine--tRNA ligase subunit alpha', 85, NULL, NULL, 152568),
(152569, '3.40.50.150-FF-000717', NULL, 'Dihydroaeruginoic acid synthetase', 103, NULL, NULL, 152569),
(152570, '3.40.225.10-FF-000008', NULL, 'Sugar aldolase', 206, NULL, NULL, 152570),
(152571, '3.30.160.60-FF-001544', NULL, 'Zinc finger protein 69', 32, NULL, NULL, 152571),
(152572, '2.130.10.10-FF-006024', NULL, 'Centriole proteome protein 16', 163, NULL, NULL, 152572),
(152573, '3.10.310.20-FF-000003', NULL, 'Prune exopolyphosphatase 1', 139, NULL, NULL, 152573),
(152574, '2.60.40.1170-FF-000035', NULL, 'Coatomer subunit delta', 129, NULL, NULL, 152574),
(152575, '1.10.3430.10-FF-000033', NULL, 'Solute carrier family 14 member 2', 191, NULL, NULL, 152575),
(152576, '3.40.50.80-FF-000069', NULL, 'POSSIBLE OXYGENASE', 133, NULL, NULL, 152576),
(152577, '3.20.20.30-FF-000025', NULL, 'LLM class F420-dependent oxidoreductase', 120, NULL, NULL, 152577),
(152578, '2.60.40.10-FF-004803', NULL, NULL, 94, NULL, NULL, 152578),
(152579, '3.10.330.10-FF-000001', NULL, 'Cell division control 48', 97, NULL, NULL, 152579),
(152580, '1.20.990.10-FF-000062', NULL, 'Uncharacterized protein', 17, NULL, NULL, 152580),
(152581, '4.10.520.10-FF-000006', NULL, 'DNA-binding protein HU', 99, NULL, NULL, 152581),
(152582, '1.10.437.20-FF-000001', NULL, 'N1L', 117, NULL, NULL, 152582),
(152583, '2.60.40.60-FF-001070', NULL, 'Si:dkey-1m11.6', 46, NULL, NULL, 152583),
(152584, '3.40.50.1000-FF-000562', NULL, NULL, 215, NULL, NULL, 152584),
(152585, '2.60.40.1770-FF-000007', NULL, 'Ephrin receptor 1', 62, NULL, NULL, 152585),
(152586, '1.10.3020.10-FF-000002', NULL, NULL, 23, NULL, NULL, 152586),
(152587, '1.10.238.10-FF-000103', NULL, 'Troponin C Ib', 77, NULL, NULL, 152587),
(152588, '1.25.40.10-FF-003117', NULL, 'Uncharacterized protein', 116, NULL, NULL, 152588),
(152589, '1.10.472.130-FF-000057', NULL, 'Inner dynein arm I1 heavy chain 1-ALPHA', 142, NULL, NULL, 152589),
(152590, '2.60.40.150-FF-000440', NULL, 'Arrestin domain-containing protein B', 148, NULL, NULL, 152590),
(152591, '3.90.1030.20-FF-000007', NULL, NULL, 133, NULL, NULL, 152591),
(152592, '3.80.10.10-FF-003337', NULL, 'Uncharacterized protein', 122, NULL, NULL, 152592),
(152593, '3.40.50.2300-FF-000390', NULL, 'Branched-chain amino acid ABC transporter substrate-binding protein', 189, NULL, NULL, 152593),
(152594, '3.30.160.60-FF-003730', NULL, NULL, 28, NULL, NULL, 152594),
(152595, '1.25.40.10-FF-005141', NULL, 'Uncharacterized protein', 99, NULL, NULL, 152595);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(152596, '1.10.1300.10-FF-000017', NULL, 'Phosphodiesterase', 336, NULL, NULL, 152596),
(152597, '3.90.70.200-FF-000001', NULL, 'RNA polymerase-associated protein RTF1 homolog', 132, NULL, NULL, 152597),
(152598, '3.40.50.300-FF-003731', NULL, 'GM17994', 225, NULL, NULL, 152598),
(152599, '2.60.40.10-FF-005259', NULL, NULL, 87, NULL, NULL, 152599),
(152600, '2.60.200.30-FF-000024', NULL, 'Inorganic polyphosphate/ATP-NAD kinase, putative', 127, NULL, NULL, 152600),
(152601, '2.170.130.10-FF-000059', NULL, NULL, 133, NULL, NULL, 152601),
(152602, '1.25.40.20-FF-000416', NULL, 'E3 ubiquitin-protein ligase XB3', 63, NULL, NULL, 152602),
(152603, '2.60.40.10-FF-000532', NULL, 'Vascular endothelial growth factor receptor 2', 109, NULL, NULL, 152603),
(152604, '3.60.10.10-FF-000073', NULL, 'Inositol phosphosphingolipid phospholipase', 296, NULL, NULL, 152604),
(152605, '1.10.10.10-FF-000624', NULL, 'PCI domain-containing protein', 68, NULL, NULL, 152605),
(152606, '3.40.640.10-FF-000187', NULL, 'Biotin F', 248, NULL, NULL, 152606),
(152607, '3.90.550.10-FF-000724', NULL, 'Uncharacterized protein', 257, NULL, NULL, 152607),
(152608, '2.40.160.110-FF-000034', NULL, 'Lysosomal-associated membrane protein 2', 75, NULL, NULL, 152608),
(152609, '3.40.50.10380-FF-000002', NULL, 'Malic enzyme', 255, NULL, NULL, 152609),
(152610, '3.30.420.10-FF-000526', NULL, NULL, 107, NULL, NULL, 152610),
(152611, '3.40.50.1000-FF-000724', NULL, NULL, 86, NULL, NULL, 152611),
(152612, '3.30.750.44-FF-000031', NULL, NULL, 73, NULL, NULL, 152612),
(152613, '3.30.160.60-FF-004399', NULL, NULL, 35, NULL, NULL, 152613),
(152614, '1.20.1250.20-FF-002043', NULL, 'General alpha-glucoside permease', 318, NULL, NULL, 152614),
(152615, '2.130.10.10-FF-004894', NULL, 'Pre-rRNA-processing protein IPI3, putative', 115, NULL, NULL, 152615),
(152616, '1.10.287.70-FF-000678', NULL, 'Uncharacterized protein', 97, NULL, NULL, 152616),
(152617, '1.10.730.10-FF-000186', NULL, 'Valine--tRNA ligase', 214, NULL, NULL, 152617),
(152618, '1.10.1170.10-FF-000023', NULL, 'Baculoviral IAP repeat-containing protein 7', 95, NULL, NULL, 152618),
(152619, '2.120.10.80-FF-000233', NULL, 'Uncharacterized protein', 227, NULL, NULL, 152619),
(152620, '1.10.1530.10-FF-000006', NULL, 'Ureidoglycolate dehydrogenase', 84, NULL, NULL, 152620),
(152621, '3.30.1330.30-FF-000070', NULL, 'Ribosomal protein L7Ae, putative', 120, NULL, NULL, 152621),
(152622, '1.20.1250.20-FF-002205', NULL, 'Uncharacterized protein', 144, NULL, NULL, 152622),
(152623, '3.30.200.20-FF-002508', NULL, 'Uncharacterized protein', 115, NULL, NULL, 152623),
(152624, '3.50.30.30-FF-000159', NULL, 'Uncharacterized protein', 169, NULL, NULL, 152624),
(152625, '3.40.50.300-FF-002932', NULL, 'Putative AAA family ATPase', 193, NULL, NULL, 152625),
(152626, '3.50.50.60-FF-000826', NULL, 'Probable FAD-dependent oxidoreductase PA4991', 118, NULL, NULL, 152626),
(152627, '1.10.860.10-FF-000010', NULL, 'Replicative DNA helicase', 142, NULL, NULL, 152627),
(152628, '2.130.10.10-FF-002533', NULL, 'F-box/WD-40 repeat-containing protein At5g21040', 150, NULL, NULL, 152628),
(152629, '2.130.10.10-FF-002657', NULL, 'Uncharacterized protein', 116, NULL, NULL, 152629),
(152630, '3.30.565.10-FF-000547', NULL, 'DNA gyrase subunit B', 221, NULL, NULL, 152630),
(152631, '3.30.70.3270-FF-000003', NULL, 'NADH-quinone oxidoreductase subunit I', 127, NULL, NULL, 152631),
(152632, '3.40.140.10-FF-000255', NULL, 'Protein CBG16582', 130, NULL, NULL, 152632),
(152633, '3.40.50.150-FF-000555', NULL, 'Ribosomal RNA small subunit methyltransferase H', 180, NULL, NULL, 152633),
(152634, '3.40.50.2300-FF-000058', NULL, 'Two-component system response regulator', 118, NULL, NULL, 152634),
(152635, '3.40.50.11050-FF-000001', NULL, 'Toxin B', 254, NULL, NULL, 152635),
(152636, '1.25.40.10-FF-000470', NULL, 'Pentatricopeptide repeat-containing protein At5g66520', 161, NULL, NULL, 152636),
(152637, '3.40.50.2020-FF-000188', NULL, 'Dynein heavy chain 9', 120, NULL, NULL, 152637),
(152638, '2.40.30.10-FF-000420', NULL, 'Uncharacterized protein', 79, NULL, NULL, 152638);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(152639, '1.25.40.180-FF-000252', NULL, NULL, 74, NULL, NULL, 152639),
(152640, '1.10.390.10-FF-000086', NULL, 'Uncharacterized protein', 186, NULL, NULL, 152640),
(152641, '3.30.70.3290-FF-000009', NULL, 'Fatty acid synthase 2, isoform A', 100, NULL, NULL, 152641),
(152642, '3.30.70.330-FF-000379', NULL, 'la-related protein 7 isoform X2', 115, NULL, NULL, 152642),
(152643, '3.40.50.300-FF-008328', NULL, 'Uncharacterized protein', 243, NULL, NULL, 152643),
(152644, '2.60.120.330-FF-000110', NULL, 'Uncharacterized protein', 351, NULL, NULL, 152644),
(152645, '1.10.520.10-FF-000029', NULL, 'Peroxidase', 141, NULL, NULL, 152645),
(152646, '3.20.20.60-FF-000129', NULL, 'Uncharacterized protein', 67, NULL, NULL, 152646),
(152647, '3.40.50.1820-FF-000364', NULL, 'Carboxylic ester hydrolase', 552, NULL, NULL, 152647),
(152648, '3.10.450.40-FF-000047', NULL, NULL, 120, NULL, NULL, 152648),
(152649, '2.20.100.10-FF-000177', NULL, 'SCO-spondin', 57, NULL, NULL, 152649),
(152650, '1.25.40.90-FF-000105', NULL, 'Predicted protein', 100, NULL, NULL, 152650),
(152651, '3.40.50.1100-FF-000187', NULL, 'L-threonine dehydratase catabolic TdcB', 101, NULL, NULL, 152651),
(152652, '3.40.50.300-FF-002039', NULL, 'ABC multidrug transporter, putative', 250, NULL, NULL, 152652),
(152653, '2.120.10.80-FF-000357', NULL, 'Predicted protein', 289, NULL, NULL, 152653),
(152654, '1.25.10.10-FF-002772', NULL, 'Uncharacterized protein', 1087, NULL, NULL, 152654),
(152655, '2.60.120.10-FF-000776', NULL, 'Uncharacterized protein', 26, NULL, NULL, 152655),
(152656, '3.30.200.20-FF-001148', NULL, 'Si:ch211-171h4.3', 91, NULL, NULL, 152656),
(152657, '1.25.40.80-FF-000007', NULL, 'Cryptochrome 4', 136, NULL, NULL, 152657),
(152658, '3.40.50.170-FF-000038', NULL, 'Phosphoribosylglycinamide formyltransferase', 122, NULL, NULL, 152658),
(152659, '3.10.110.10-FF-000249', NULL, 'Protein kinase, putative', 135, NULL, NULL, 152659),
(152660, '3.40.50.300-FF-007042', NULL, 'Uncharacterized protein', 200, NULL, NULL, 152660),
(152661, '2.60.40.10-FF-001948', NULL, 'Titin homolog', 102, NULL, NULL, 152661),
(152662, '3.40.50.150-FF-001229', NULL, NULL, 98, NULL, NULL, 152662),
(152663, '1.20.58.90-FF-000022', NULL, 'Tubulin-specific chaperone A', 108, NULL, NULL, 152663),
(152664, '2.60.40.150-FF-000552', NULL, 'Paired amphipathic helix SIN3-like protein', 78, NULL, NULL, 152664),
(152665, '3.40.470.10-FF-000027', NULL, NULL, 143, NULL, NULL, 152665),
(152666, '1.20.900.10-FF-000017', NULL, 'pleckstrin homology domain-containing family G member 5 isoform X1', 231, NULL, NULL, 152666),
(152667, '1.10.8.730-FF-000001', NULL, 'PrgJ', 119, NULL, NULL, 152667),
(152668, '2.40.160.210-FF-000007', NULL, 'Probable peroxisomal acyl-coenzyme A thioester hydrolase 1', 324, NULL, NULL, 152668),
(152669, '1.20.870.10-FF-000019', NULL, 'Rap guanine nucleotide exchange factor 5', 162, NULL, NULL, 152669),
(152670, '1.10.10.790-FF-000028', NULL, 'Splicing factor putative', 58, NULL, NULL, 152670),
(152671, '1.25.10.10-FF-001024', NULL, 'Importin subunit alpha-3, putative', 324, NULL, NULL, 152671),
(152672, '2.60.40.420-FF-000212', NULL, 'cDNA FLJ37971 fis, clone CTONG2009958, highly similar to CERULOPLASMIN', 84, NULL, NULL, 152672),
(152673, '2.30.30.40-FF-000160', NULL, 'dynamin-binding protein isoform X1', 66, NULL, NULL, 152673),
(152674, '1.10.418.10-FF-000252', NULL, 'Uncharacterized protein', 93, NULL, NULL, 152674),
(152675, '1.10.150.240-FF-000067', NULL, 'Putative phosphatase YhcW', 70, NULL, NULL, 152675),
(152676, '2.60.40.10-FF-000588', NULL, 'Cell adhesion molecule 4', 103, NULL, NULL, 152676),
(152677, '3.90.640.10-FF-000226', NULL, 'Uncharacterized protein', 65, NULL, NULL, 152677),
(152678, '1.10.10.10-FF-000911', NULL, 'HTH-type transcriptional regulator NorG', 44, NULL, NULL, 152678),
(152679, '2.130.10.10-FF-005967', NULL, 'Uncharacterized protein', 241, NULL, NULL, 152679),
(152680, '1.10.340.70-FF-000022', NULL, 'Uncharacterized protein', 87, NULL, NULL, 152680),
(152681, '3.30.70.3490-FF-000013', NULL, 'Oxysterol-binding protein-related protein 2A', 72, NULL, NULL, 152681);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(152682, '1.20.5.1010-FF-000002', NULL, 'Transient receptor potential cation channel subfamily M member 7', 55, NULL, NULL, 152682),
(152683, '3.40.390.10-FF-000026', NULL, 'Pappalysin 1', 312, NULL, NULL, 152683),
(152684, '3.60.60.10-FF-000020', NULL, 'Acyl-coenzyme A:6-aminopenicillanic acid acyl-transferase domain protein', 313, NULL, NULL, 152684),
(152685, '1.25.40.60-FF-000001', NULL, 'syntaxin-binding protein 1 isoform X2', 120, NULL, NULL, 152685),
(152686, '3.30.930.10-FF-000048', NULL, 'Serine--tRNA ligase', 325, NULL, NULL, 152686),
(152687, '1.25.40.20-FF-000692', NULL, 'Uncharacterized protein', 129, NULL, NULL, 152687),
(152688, '3.40.50.10140-FF-000060', NULL, 'Toll-Interleukin receptor', 102, NULL, NULL, 152688),
(152689, '3.40.50.720-FF-000136', NULL, 'ATP-citrate synthase beta chain protein', 136, NULL, NULL, 152689),
(152690, '2.30.39.10-FF-000030', NULL, 'Serpin 2', 197, NULL, NULL, 152690),
(152691, '1.20.144.10-FF-000107', NULL, 'Uncharacterized protein', 232, NULL, NULL, 152691),
(152692, '3.30.1520.10-FF-000123', NULL, 'Phosphatidylinositol 3-kinase piki-1', 155, NULL, NULL, 152692),
(152693, '1.10.30.10-FF-000058', NULL, 'IXR1p Transcriptional repressor', 79, NULL, NULL, 152693),
(152694, '1.25.10.10-FF-000804', NULL, 'Phosphoinositide 3-kinase regulatory subunit 4', 218, NULL, NULL, 152694),
(152695, '1.20.58.70-FF-000072', NULL, 'Syntaxin-16', 104, NULL, NULL, 152695),
(152696, '2.40.30.270-FF-000012', NULL, 'ATP-dependent 5''-3'' DNA helicase', 118, NULL, NULL, 152696),
(152697, '3.40.50.300-FF-005417', NULL, 'P-loop nucleoside triphosphate hydrolase superfamily protein', 171, NULL, NULL, 152697),
(152698, '3.60.20.10-FF-000242', NULL, NULL, 67, NULL, NULL, 152698),
(152699, '1.25.40.10-FF-000975', NULL, 'Pentatricopeptide repeat-containing protein', 201, NULL, NULL, 152699),
(152700, '3.20.180.20-FF-000012', NULL, 'Dynein Heavy Chain', 84, NULL, NULL, 152700),
(152701, '3.80.10.10-FF-001483', NULL, 'Insulin like growth factor binding protein acid labile subunit', 235, NULL, NULL, 152701),
(152702, '3.90.70.10-FF-000502', NULL, 'Ubiquitin-specific protease, putative', 319, NULL, NULL, 152702),
(152703, '3.40.47.10-FF-000001', NULL, '3-ketoacyl-CoA thiolase', 206, NULL, NULL, 152703),
(152704, '2.20.130.20-FF-000007', NULL, 'Alpha-2-macroglobulin like 1', 109, NULL, NULL, 152704),
(152705, '1.20.1600.10-FF-000055', NULL, 'Outer membrane efflux protein', 411, NULL, NULL, 152705),
(152706, '3.20.20.80-FF-000630', NULL, 'Os05g0366200 protein', 122, NULL, NULL, 152706),
(152707, '1.20.1070.10-FF-001997', NULL, 'Protein CBR-GNRR-8', 149, NULL, NULL, 152707),
(152708, '3.10.110.10-FF-000305', NULL, 'Uncharacterized protein', 87, NULL, NULL, 152708),
(152709, '3.30.70.370-FF-000020', NULL, 'DNA polymerase family A', 80, NULL, NULL, 152709),
(152710, '3.40.50.300-FF-007603', NULL, 'ATP-binding cassette subfamily F member 2', 161, NULL, NULL, 152710),
(152711, '2.60.120.200-FF-000756', NULL, 'Uncharacterized protein', 100, NULL, NULL, 152711),
(152712, '3.30.160.60-FF-000745', NULL, 'zinc finger protein 181 isoform X1', 29, NULL, NULL, 152712),
(152713, '3.30.200.20-FF-000187', NULL, 'Cell division control protein 2', 84, NULL, NULL, 152713),
(152714, '1.25.40.10-FF-001195', NULL, 'GD10841', 97, NULL, NULL, 152714),
(152715, '2.60.40.10-FF-003281', NULL, NULL, 89, NULL, NULL, 152715),
(152716, '2.10.109.10-FF-000042', NULL, 'Signal peptidase I', 100, NULL, NULL, 152716),
(152717, '3.40.50.2300-FF-000238', NULL, 'Diguanylate cyclase (GGDEF) domain protein', 149, NULL, NULL, 152717),
(152718, '3.10.250.10-FF-000124', NULL, NULL, 103, NULL, NULL, 152718),
(152719, '3.40.50.12780-FF-000132', NULL, '8-demethylnovobiocic acid synthase', 410, NULL, NULL, 152719),
(152720, '3.40.50.300-FF-004512', NULL, 'DNA helicase RecQ', 216, NULL, NULL, 152720),
(152721, '2.40.30.300-FF-000004', NULL, 'ATP dependent RNA helicase', 158, NULL, NULL, 152721),
(152722, '2.40.50.90-FF-000113', NULL, 'Tudor domain-containing 12', 107, NULL, NULL, 152722),
(152723, '1.25.40.10-FF-004286', NULL, 'Uncharacterized protein', 204, NULL, NULL, 152723);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(152724, '3.30.470.20-FF-000066', NULL, 'Acetyl coenzyme A synthetase (ADP forming), alpha domain-containing protein', 135, NULL, NULL, 152724),
(152725, '3.40.30.10-FF-000474', NULL, 'Zeta class glutathione transferase GSTZ1', 80, NULL, NULL, 152725),
(152726, '3.30.2160.10-FF-000045', NULL, 'Predicted protein', 79, NULL, NULL, 152726),
(152727, '3.30.160.40-FF-000026', NULL, 'Uncharacterized protein', 54, NULL, NULL, 152727),
(152728, '3.40.50.1820-FF-001706', NULL, 'Uncharacterized protein', 168, NULL, NULL, 152728),
(152729, '1.10.10.580-FF-000027', NULL, 'Uncharacterized protein', 66, NULL, NULL, 152729),
(152730, '3.10.410.10-FF-000002', NULL, '10-formyltetrahydrofolate synthetase', 62, NULL, NULL, 152730),
(152731, '1.25.40.10-FF-004342', NULL, 'At2g37400', 162, NULL, NULL, 152731),
(152732, '2.40.70.10-FF-000254', NULL, NULL, 141, NULL, NULL, 152732),
(152733, '1.10.472.10-FF-000310', NULL, 'Uncharacterized protein', 95, NULL, NULL, 152733),
(152734, '3.30.40.10-FF-001689', NULL, 'YALI0C16390p', 71, NULL, NULL, 152734),
(152735, '1.10.1200.10-FF-000021', NULL, 'Isochorismatase', 74, NULL, NULL, 152735),
(152736, '2.40.50.140-FF-000825', NULL, NULL, 105, NULL, NULL, 152736),
(152737, '1.25.40.10-FF-001936', NULL, 'EMB2750', 131, NULL, NULL, 152737),
(152738, '2.40.30.10-FF-000476', NULL, 'Uncharacterized protein', 54, NULL, NULL, 152738),
(152739, '3.40.50.300-FF-004456', NULL, 'Dynein heavy chain 2', 281, NULL, NULL, 152739),
(152740, '3.30.40.10-FF-002021', NULL, 'Uncharacterized protein', 102, NULL, NULL, 152740),
(152741, '2.60.40.420-FF-000268', NULL, 'Uncharacterized protein', 142, NULL, NULL, 152741),
(152742, '3.30.70.270-FF-000007', NULL, 'Membrane-associated phosphodiesterase', 168, NULL, NULL, 152742),
(152743, '3.40.50.620-FF-000275', NULL, 'Probable cysteinyl-tRNA synthetase', 139, NULL, NULL, 152743),
(152744, '2.130.10.10-FF-004551', NULL, 'Uncharacterized protein', 219, NULL, NULL, 152744),
(152745, '2.60.40.790-FF-000165', NULL, NULL, 64, NULL, NULL, 152745),
(152746, '3.60.21.10-FF-000098', NULL, 'Serine/threonine-protein phosphatase', 332, NULL, NULL, 152746),
(152747, '1.10.238.10-FF-000608', NULL, 'mRNA, clone: RTFL01-44-H24', 66, NULL, NULL, 152747),
(152748, '3.80.10.10-FF-002444', NULL, 'Receptor like protein 1', 271, NULL, NULL, 152748),
(152749, '3.90.550.10-FF-000163', NULL, 'Van1p', 253, NULL, NULL, 152749),
(152750, '3.30.200.20-FF-000928', NULL, 'Protein kinase domain containing protein', 78, NULL, NULL, 152750),
(152751, '3.50.50.60-FF-001102', NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', 228, NULL, NULL, 152751),
(152752, '1.10.510.10-FF-004238', NULL, NULL, 202, NULL, NULL, 152752),
(152753, '3.30.70.250-FF-000001', NULL, 'Malonyl CoA-acyl carrier protein transacylase', 73, NULL, NULL, 152753),
(152754, '3.40.50.2000-FF-000362', NULL, 'soyasaponin III rhamnosyltransferase', 175, NULL, NULL, 152754),
(152755, '2.60.40.10-FF-004242', NULL, NULL, 111, NULL, NULL, 152755),
(152756, '1.10.20.10-FF-000176', NULL, 'Histone H2B', 125, NULL, NULL, 152756),
(152757, '3.40.190.10-FF-000837', NULL, 'Phosphonate ABC transporter, periplasmic phosphonate-binding protein', 113, NULL, NULL, 152757),
(152758, '3.40.50.300-FF-006586', NULL, 'Uncharacterized protein', 99, NULL, NULL, 152758),
(152759, '1.10.3470.10-FF-000030', NULL, 'Fe(3+)-hydroxamate ABC transporter permease FhuB', 320, NULL, NULL, 152759),
(152760, '3.30.160.20-FF-000020', NULL, 'Peptide chain release factor 1', 59, NULL, NULL, 152760),
(152761, '3.30.200.20-FF-001204', NULL, 'Probable inactive receptor kinase At5g67200', 91, NULL, NULL, 152761),
(152762, '1.25.40.10-FF-000071', NULL, 'Putative mitochondrial import receptor subunit TOM70', 386, NULL, NULL, 152762),
(152763, '1.25.40.10-FF-000632', NULL, 'Pre-mRNA splicing factor (Prp24), putative', 329, NULL, NULL, 152763),
(152764, '2.60.120.590-FF-000030', NULL, '2OG-Fe(II)_oxygenase_superfamily_-_putative', 223, NULL, NULL, 152764),
(152765, '3.90.640.10-FF-000046', NULL, 'Actin-like protein, putative', 96, NULL, NULL, 152765);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(152766, '1.25.40.10-FF-002212', NULL, 'Mitochondrial fission 1 protein', 151, NULL, NULL, 152766),
(152767, '2.60.40.60-FF-000013', NULL, 'Cadherin EGF LAG seven-pass G-type receptor', 105, NULL, NULL, 152767),
(152768, '1.10.510.10-FF-002097', NULL, NULL, 62, NULL, NULL, 152768),
(152769, '3.30.160.60-FF-004978', NULL, NULL, 48, NULL, NULL, 152769),
(152770, '1.10.510.10-FF-000023', NULL, 'Protein kinase C', 194, NULL, NULL, 152770),
(152771, '1.25.40.10-FF-004865', NULL, 'Vacuolar protein sorting-associated protein 41', 133, NULL, NULL, 152771),
(152772, '3.40.50.300-FF-008166', NULL, 'Eukaryotic translation initiation factor 2 subunit gamma', 86, NULL, NULL, 152772),
(152773, '2.60.40.3510-FF-000018', NULL, 'Delta-like protein', 158, NULL, NULL, 152773),
(152774, '2.40.30.10-FF-000077', NULL, 'Putative translation elongation/initiation factor family protein', 109, NULL, NULL, 152774),
(152775, '3.30.160.60-FF-001021', NULL, 'zinc finger and BTB domain-containing protein 17 isoform X1', 24, NULL, NULL, 152775),
(152776, '2.130.10.10-FF-005350', NULL, 'Damage-specific DNA binding protein, putative', 371, NULL, NULL, 152776),
(152777, '3.40.250.10-FF-000084', NULL, 'MercaptoPyruvate SulfurTransferase homolog', 126, NULL, NULL, 152777),
(152778, '3.30.70.330-FF-002291', NULL, NULL, 91, NULL, NULL, 152778),
(152779, '3.90.110.10-FF-000017', NULL, 'Malate dehydrogenase', 169, NULL, NULL, 152779),
(152780, '3.30.230.10-FF-000135', NULL, 'Ribonuclease P protein component', 113, NULL, NULL, 152780),
(152781, '3.30.70.1400-FF-000021', NULL, 'Aminomethyltransferase', 91, NULL, NULL, 152781),
(152782, '2.60.120.200-FF-000812', NULL, 'Uncharacterized protein', 131, NULL, NULL, 152782),
(152783, '3.40.630.10-FF-000181', NULL, 'Succinyl-diaminopimelate desuccinylase', 260, NULL, NULL, 152783),
(152784, '1.20.1270.10-FF-000017', NULL, 'Heat shock protein family A (Hsp70) member 4', 91, NULL, NULL, 152784),
(152785, '1.10.510.10-FF-000528', NULL, 'Tyrosine-protein kinase receptor', 212, NULL, NULL, 152785),
(152786, '2.60.120.650-FF-000088', NULL, 'Predicted protein', 206, NULL, NULL, 152786),
(152787, '1.10.10.10-FF-001928', NULL, 'Uncharacterized protein', 93, NULL, NULL, 152787),
(152788, '2.70.130.10-FF-000044', NULL, NULL, 72, NULL, NULL, 152788),
(152789, '2.60.40.10-FF-000931', NULL, 'V-set and immunoglobulin domain containing 1', 125, NULL, NULL, 152789),
(152790, '4.10.320.10-FF-000025', NULL, '2-oxo acid dehydrogenases acyltransferase, putative', 48, NULL, NULL, 152790),
(152791, '1.20.1730.10-FF-000115', NULL, 'Uncharacterized protein', 111, NULL, NULL, 152791),
(152792, '4.10.240.10-FF-000024', NULL, 'Proline utilization trans-activator', 31, NULL, NULL, 152792),
(152793, '2.60.120.200-FF-000071', NULL, 'Hydroxyproline O-galactosyltransferase GALT2', 85, NULL, NULL, 152793),
(152794, '3.30.40.10-FF-000784', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 99, NULL, NULL, 152794),
(152795, '1.20.1560.10-FF-000231', NULL, 'ABC transporter, ATP-binding/permease protein', 325, NULL, NULL, 152795),
(152796, '2.30.30.940-FF-000013', NULL, 'ATP-dependent RecD-like DNA helicase', 74, NULL, NULL, 152796),
(152797, '2.60.120.200-FF-000195', NULL, 'Lys-gingipain W83', 176, NULL, NULL, 152797),
(152798, '3.40.50.620-FF-000836', NULL, 'Uncharacterized protein', 132, NULL, NULL, 152798),
(152799, '1.10.238.10-FF-000047', NULL, 'Calcineurin subunit B type 1', 169, NULL, NULL, 152799),
(152800, '3.10.450.700-FF-000002', NULL, 'Transcription factor Pur-alpha 1', 64, NULL, NULL, 152800),
(152801, '2.10.25.10-FF-000325', NULL, 'Mutant fibrillin-1', 41, NULL, NULL, 152801),
(152802, '1.25.40.1040-FF-000006', NULL, 'CFIA complex component Rna14, putative', 613, NULL, NULL, 152802),
(152803, '1.10.10.10-FF-001187', NULL, 'MarR family transcriptional regulator', 143, NULL, NULL, 152803),
(152804, '2.130.10.10-FF-003438', NULL, 'GPI inositol-deacylase', 149, NULL, NULL, 152804),
(152805, '2.60.120.290-FF-000002', NULL, 'Signal peptide, CUB domain and EGF-like domain-containing 2', 115, NULL, NULL, 152805),
(152806, '3.30.360.10-FF-000139', NULL, 'Uncharacterized protein', 94, NULL, NULL, 152806);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(152807, '3.40.50.2000-FF-000761', NULL, 'Uncharacterized protein', 177, NULL, NULL, 152807),
(152808, '3.30.160.60-FF-003674', NULL, NULL, 31, NULL, NULL, 152808),
(152809, '3.40.525.10-FF-000048', NULL, 'Uncharacterized protein', 249, NULL, NULL, 152809),
(152810, '4.10.280.10-FF-000201', NULL, 'Hms1p', 63, NULL, NULL, 152810),
(152811, '4.10.280.10-FF-000021', NULL, 'Transcription factor bHLH130 family', 69, NULL, NULL, 152811),
(152812, '2.70.130.10-FF-000100', NULL, NULL, 150, NULL, NULL, 152812),
(152813, '1.20.140.150-FF-000081', NULL, 'Calcium channel, voltage-dependent, gamma subunit 8a', 177, NULL, NULL, 152813),
(152814, '2.60.40.150-FF-000496', NULL, 'Uncharacterized protein', 142, NULL, NULL, 152814),
(152815, '1.20.58.60-FF-000878', NULL, 'Uncharacterized protein', 178, NULL, NULL, 152815),
(152816, '1.25.10.10-FF-001603', NULL, 'Uncharacterized protein', 658, NULL, NULL, 152816),
(152817, '2.60.40.60-FF-000850', NULL, 'Uncharacterized protein', 84, NULL, NULL, 152817),
(152818, '3.30.300.30-FF-000136', NULL, 'Beta-alanine-activating enzyme', 98, NULL, NULL, 152818),
(152819, '1.20.120.350-FF-000221', NULL, NULL, 50, NULL, NULL, 152819),
(152820, '3.30.70.270-FF-000283', NULL, NULL, 97, NULL, NULL, 152820),
(152821, '1.20.1070.10-FF-001492', NULL, 'Predicted protein', 201, NULL, NULL, 152821),
(152822, '2.130.10.30-FF-000162', NULL, NULL, 116, NULL, NULL, 152822),
(152823, '1.10.287.130-FF-000258', NULL, 'Sensor histidine kinase', 82, NULL, NULL, 152823),
(152824, '1.10.287.70-FF-000173', NULL, 'glutamate receptor 2', 142, NULL, NULL, 152824),
(152825, '2.60.120.620-FF-000146', NULL, 'Zgc:174917', 116, NULL, NULL, 152825),
(152826, '3.40.250.10-FF-000140', NULL, 'Rhodanese-like domain containing protein', 114, NULL, NULL, 152826),
(152827, '3.90.870.10-FF-000035', NULL, 'Uncharacterized protein', 185, NULL, NULL, 152827),
(152828, '1.25.40.10-FF-005303', NULL, 'Uncharacterized protein', 129, NULL, NULL, 152828),
(152829, '2.40.420.20-FF-000008', NULL, 'RND family efflux transporter, MFP subunit', 92, NULL, NULL, 152829),
(152830, '3.90.950.10-FF-000036', NULL, 'Maf-like protein', 194, NULL, NULL, 152830),
(152831, '2.170.150.20-FF-000007', NULL, 'Protein cereblon', 141, NULL, NULL, 152831),
(152832, '1.25.40.240-FF-000005', NULL, 'ATP-dependent DNA helicase II subunit 2', 154, NULL, NULL, 152832),
(152833, '1.10.10.650-FF-000003', NULL, 'Transcription elongation factor spt6', 188, NULL, NULL, 152833),
(152834, '2.40.50.100-FF-000044', NULL, 'exosome complex component RRP40', 94, NULL, NULL, 152834),
(152835, '3.40.50.300-FF-003495', NULL, 'Ras homolog family member Q', 121, NULL, NULL, 152835),
(152836, '1.20.930.40-FF-000005', NULL, 'putative N-acetylated-alpha-linked acidic dipeptidase isoform X3', 61, NULL, NULL, 152836),
(152837, '3.40.50.300-FF-007946', NULL, 'Si:ch211-241b2.5', 170, NULL, NULL, 152837),
(152838, '1.10.510.10-FF-000860', NULL, 'Serine/threonine-protein kinase ENV7', 144, NULL, NULL, 152838),
(152839, '1.10.287.70-FF-000734', NULL, 'Uncharacterized protein', 115, NULL, NULL, 152839),
(152840, '3.40.30.10-FF-001255', NULL, 'Predicted protein', 116, NULL, NULL, 152840),
(152841, '1.20.1250.20-FF-000463', NULL, 'Nitrate transporter CrnA', 207, NULL, NULL, 152841),
(152842, '1.20.5.170-FF-000168', NULL, 'AP-1-like transcription factor YAP2', 96, NULL, NULL, 152842),
(152843, '3.30.540.30-FF-000007', NULL, 'Dipeptidyl peptidase 3', 125, NULL, NULL, 152843),
(152844, '3.30.40.10-FF-001745', NULL, 'YALI0B14443p', 94, NULL, NULL, 152844),
(152845, '3.40.50.300-FF-000802', NULL, 'Sulfate adenylyltransferase', 183, NULL, NULL, 152845),
(152846, '3.80.10.10-FF-002500', NULL, 'Leucine Rich Repeat family protein, expressed', 119, NULL, NULL, 152846),
(152847, '1.10.20.10-FF-000232', NULL, NULL, 129, NULL, NULL, 152847),
(152848, '2.40.50.140-FF-000769', NULL, NULL, 106, NULL, NULL, 152848),
(152849, '1.10.510.10-FF-004418', NULL, NULL, 69, NULL, NULL, 152849),
(152850, '1.10.510.10-FF-000708', NULL, 'serine/threonine-protein kinase par-1-like', 177, NULL, NULL, 152850);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(152851, '1.25.10.10-FF-000243', NULL, 'Putative Vacuolar protein 8', 298, NULL, NULL, 152851),
(152852, '3.30.160.60-FF-004635', NULL, NULL, 30, NULL, NULL, 152852),
(152853, '2.130.10.10-FF-000004', NULL, 'F-box/WD repeat-containing protein 11 isoform X2', 295, NULL, NULL, 152853),
(152854, '1.10.238.10-FF-000446', NULL, 'Signal transducer and activator of transcription', 88, NULL, NULL, 152854),
(152855, '3.30.700.10-FF-000003', NULL, 'Type IV pilin', 141, NULL, NULL, 152855),
(152856, '2.30.30.30-FF-000044', NULL, 'Elongation factor P', 61, NULL, NULL, 152856),
(152857, '1.10.150.60-FF-000038', NULL, NULL, 122, NULL, NULL, 152857),
(152858, '1.10.4040.10-FF-000003', NULL, 'Transcriptional regulator, putative', 46, NULL, NULL, 152858),
(152859, '3.40.50.12430-FF-000005', NULL, 'Uncharacterized protein', 126, NULL, NULL, 152859),
(152860, '3.30.590.10-FF-000004', NULL, 'Glutamine synthetase', 250, NULL, NULL, 152860),
(152861, '2.120.10.80-FF-000413', NULL, 'Uncharacterized protein', 106, NULL, NULL, 152861),
(152862, '2.30.34.10-FF-000002', NULL, 'Leishmanolysin-like peptidase', 107, NULL, NULL, 152862),
(152863, '2.60.34.10-FF-000023', NULL, '70 kDa heat shock cognate protein', 176, NULL, NULL, 152863),
(152864, '1.20.1250.20-FF-001823', NULL, 'Monocarboxylate transporter, putative', 153, NULL, NULL, 152864),
(152865, '3.30.2130.30-FF-000032', NULL, 'Uncharacterized protein', 144, NULL, NULL, 152865),
(152866, '3.30.200.20-FF-000243', NULL, 'serine/threonine-protein kinase Nek8', 82, NULL, NULL, 152866),
(152867, '2.60.40.10-FF-003129', NULL, 'Solute carrier family 35 member C2', 90, NULL, NULL, 152867),
(152868, '3.90.70.10-FF-000446', NULL, 'Ubiquitin carboxyl-terminal hydrolase 32', 134, NULL, NULL, 152868),
(152869, '2.60.40.10-FF-002729', NULL, 'Muscle M-line assembly protein unc-89-like Protein', 96, NULL, NULL, 152869),
(152870, '1.10.1370.10-FF-000022', NULL, 'Mitochondrial intermediate peptidase', 160, NULL, NULL, 152870),
(152871, '1.20.85.10-FF-000004', NULL, 'Photosynthetic reaction center subunit M', 160, NULL, NULL, 152871),
(152872, '3.90.1150.10-FF-000401', NULL, 'Protein CBG19479', 45, NULL, NULL, 152872),
(152873, '3.100.10.10-FF-000041', NULL, NULL, 89, NULL, NULL, 152873),
(152874, '3.90.420.10-FF-000007', NULL, 'Sulfite:cytochrome c oxidoreductase subunit A', 259, NULL, NULL, 152874),
(152875, '2.30.170.40-FF-000002', NULL, '50S ribosomal protein L28', 40, NULL, NULL, 152875),
(152876, '2.160.10.10-FF-000025', NULL, 'Hexapeptide-repeat containing-acetyltransferase', 184, NULL, NULL, 152876),
(152877, '3.30.1520.10-FF-000067', NULL, 'Unplaced genomic scaffold supercont1.259, whole genome shotgun sequence', 125, NULL, NULL, 152877),
(152878, '1.10.533.10-FF-000059', NULL, 'Fas-associated via death domain', 94, NULL, NULL, 152878),
(152879, '2.30.30.40-FF-000665', NULL, 'Uncharacterized protein', 65, NULL, NULL, 152879),
(152880, '2.60.260.20-FF-000143', NULL, 'Chaperone protein DnaJ 2', 60, NULL, NULL, 152880),
(152881, '3.40.50.620-FF-000437', NULL, 'Hypothetical_protein_-_conserved', 80, NULL, NULL, 152881),
(152882, '3.40.50.1820-FF-001145', NULL, 'Carboxypeptidase', 77, NULL, NULL, 152882),
(152883, '3.10.50.40-FF-000047', NULL, 'Peptidylprolyl isomerase', 114, NULL, NULL, 152883),
(152884, '3.30.160.60-FF-001201', NULL, 'Zinc finger protein 217', 40, NULL, NULL, 152884),
(152885, '3.90.340.10-FF-000006', NULL, 'Nitric oxide synthase', 162, NULL, NULL, 152885),
(152886, '1.20.58.610-FF-000002', NULL, 'Hsp90 co-chaperone Cdc37, putative', 117, NULL, NULL, 152886),
(152887, '1.25.40.10-FF-004685', NULL, 'Uncharacterized protein', 105, NULL, NULL, 152887),
(152888, '1.25.40.1030-FF-000060', NULL, 'Uncharacterized protein', 402, NULL, NULL, 152888),
(152889, '1.10.8.60-FF-000301', NULL, 'Uncharacterized protein', 102, NULL, NULL, 152889),
(152890, '3.40.50.300-FF-004113', NULL, 'Putative ABC Transporter, ATP-binding protein', 170, NULL, NULL, 152890),
(152891, '3.10.20.90-FF-000993', NULL, 'Sorting nexin, putative', 89, NULL, NULL, 152891),
(152892, '3.40.50.1820-FF-001437', NULL, 'Lysosomal acid lipase/cholesteryl ester hydrolase, putative', 191, NULL, NULL, 152892);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(152893, '3.40.50.720-FF-000012', NULL, 'C-terminal-binding protein 2 isoform 1', 194, NULL, NULL, 152893),
(152894, '1.20.58.60-FF-000187', NULL, 'SEC14 domain and spectrin repeat-containing protein 1 isoform X2', 143, NULL, NULL, 152894),
(152895, '2.60.40.1400-FF-000026', NULL, NULL, 186, NULL, NULL, 152895),
(152896, '1.10.472.10-FF-000523', NULL, 'Uncharacterized protein', 94, NULL, NULL, 152896),
(152897, '2.60.120.200-FF-000447', NULL, 'Predicted protein', 120, NULL, NULL, 152897),
(152898, '1.10.10.10-FF-001760', NULL, 'Regulatory protein RecX', 47, NULL, NULL, 152898),
(152899, '3.40.50.1100-FF-000266', NULL, 'Os06g0564400 protein', 105, NULL, NULL, 152899),
(152900, '3.50.50.60-FF-001411', NULL, 'Uncharacterized protein', 134, NULL, NULL, 152900),
(152901, '3.30.9.10-FF-000060', NULL, 'FAD dependent oxidoreductase superfamily', 165, NULL, NULL, 152901),
(152902, '3.30.450.20-FF-000374', NULL, 'Sensory transduction histidine kinase', 130, NULL, NULL, 152902),
(152903, '1.20.1250.20-FF-000570', NULL, 'Glucose transporter, lmgt1', 207, NULL, NULL, 152903),
(152904, '3.20.20.140-FF-000404', NULL, 'Uncharacterized protein', 115, NULL, NULL, 152904),
(152905, '1.20.120.290-FF-000006', NULL, 'Peptidyl-prolyl cis-trans isomerase CYP38, chloroplastic', 107, NULL, NULL, 152905),
(152906, '2.60.40.10-FF-005411', NULL, 'Beta-mannosidase', 110, NULL, NULL, 152906),
(152907, '3.30.200.20-FF-001171', NULL, 'Protein kinase, putative', 94, NULL, NULL, 152907),
(152908, '3.60.40.10-FF-000081', NULL, 'protein phosphatase 1G isoform X2', 110, NULL, NULL, 152908),
(152909, '3.80.10.10-FF-001595', NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3', 58, NULL, NULL, 152909),
(152910, '1.10.1300.10-FF-000057', NULL, 'Uncharacterized protein', 246, NULL, NULL, 152910),
(152911, '3.30.750.24-FF-000160', NULL, 'Sodium-independent sulfate anion transporter-like Protein', 110, NULL, NULL, 152911),
(152912, '2.30.29.30-FF-000850', NULL, 'SHC (Src homology 2 domain-containing)-transforming protein 2', 71, NULL, NULL, 152912),
(152913, '3.30.70.1840-FF-000001', NULL, 'Putative spike glycoprotein', 140, NULL, NULL, 152913),
(152914, '4.10.280.10-FF-000206', NULL, 'Uncharacterized protein', 56, NULL, NULL, 152914),
(152915, '3.40.50.720-FF-000451', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 284, NULL, NULL, 152915),
(152916, '1.25.40.790-FF-000018', NULL, 'Predicted protein', 287, NULL, NULL, 152916),
(152917, '3.40.50.300-FF-008519', NULL, 'Protein CBR-CDC-48.3', 47, NULL, NULL, 152917),
(152918, '3.10.20.90-FF-000745', NULL, 'Autophagy protein 5', 102, NULL, NULL, 152918),
(152919, '2.60.120.310-FF-000025', NULL, 'Dopamine beta-hydroxylase', 117, NULL, NULL, 152919),
(152920, '2.20.110.10-FF-000026', NULL, 'MORN repeat containing 3', 50, NULL, NULL, 152920),
(152921, '2.40.30.130-FF-000015', NULL, 'Alanine--tRNA ligase', 109, NULL, NULL, 152921),
(152922, '3.90.1180.10-FF-000009', NULL, '60S ribosomal protein L13a', 148, NULL, NULL, 152922),
(152923, '2.60.40.10-FF-003157', NULL, 'Chitinase', 128, NULL, NULL, 152923),
(152924, '3.30.160.60-FF-001145', NULL, 'Uncharacterized protein', 27, NULL, NULL, 152924),
(152925, '1.10.167.10-FF-000056', NULL, 'Uncharacterized protein', 125, NULL, NULL, 152925),
(152926, '1.10.510.10-FF-003805', NULL, NULL, 120, NULL, NULL, 152926),
(152927, '3.30.160.60-FF-004904', NULL, NULL, 75, NULL, NULL, 152927),
(152928, '3.80.10.10-FF-000134', NULL, 'F-box and leucine rich repeat protein 13', 256, NULL, NULL, 152928),
(152929, '1.20.1250.20-FF-001716', NULL, 'Uncharacterized protein', 243, NULL, NULL, 152929),
(152930, '1.20.120.350-FF-000148', NULL, 'Sodium/hydrogen exchanger 10-like Protein', 153, NULL, NULL, 152930),
(152931, '3.40.50.10330-FF-000111', NULL, 'Predicted protein', 44, NULL, NULL, 152931),
(152932, '3.40.640.10-FF-000372', NULL, 'Uncharacterized protein', 165, NULL, NULL, 152932),
(152933, '2.130.10.10-FF-003770', NULL, 'WD repeat-containing protein 34-like Protein', 318, NULL, NULL, 152933),
(152934, '2.130.10.10-FF-000055', NULL, 'DDB1 and CUL4-associated factor 1', 322, NULL, NULL, 152934);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(152935, '3.40.50.880-FF-000127', NULL, 'Catalase-3', 154, NULL, NULL, 152935),
(152936, '2.60.40.10-FF-002168', NULL, 'Protein roller-3', 112, NULL, NULL, 152936),
(152937, '2.40.50.140-FF-001270', NULL, NULL, 97, NULL, NULL, 152937),
(152938, '3.10.490.20-FF-000038', NULL, 'Dynein heavy chain family protein', 125, NULL, NULL, 152938),
(152939, '1.10.287.70-FF-000077', NULL, 'Potassium channel subfamily K member 5', 275, NULL, NULL, 152939),
(152940, '1.10.286.10-FF-000012', NULL, NULL, 45, NULL, NULL, 152940),
(152941, '3.90.79.10-FF-000022', NULL, 'Nudix hydrolase 17, mitochondrial', 152, NULL, NULL, 152941),
(152942, '2.60.40.10-FF-001549', NULL, 'Sidekick, isoform B', 98, NULL, NULL, 152942),
(152943, '3.40.50.200-FF-000194', NULL, 'Clan SB, family S8, subtilisin-like serine peptidase', 246, NULL, NULL, 152943),
(152944, '1.10.645.10-FF-000004', NULL, 'Hydrogenase 3, large subunit', 357, NULL, NULL, 152944),
(152945, '2.10.25.10-FF-000134', NULL, 'Transmembrane agrin', 46, NULL, NULL, 152945),
(152946, '3.40.50.2000-FF-000906', NULL, 'UDP-glycosyltransferase 71B1', 165, NULL, NULL, 152946),
(152947, '3.50.50.60-FF-000894', NULL, 'Probable malate:quinone oxidoreductase', 161, NULL, NULL, 152947),
(152948, '1.25.10.10-FF-000451', NULL, 'Coatomer subunit beta', 668, NULL, NULL, 152948),
(152949, '3.30.160.60-FF-002617', NULL, 'Kruppel like factor 18', 34, NULL, NULL, 152949),
(152950, '3.40.50.1820-FF-000818', NULL, 'Plipastatin synthase subunit C', 102, NULL, NULL, 152950),
(152951, '1.20.1070.10-FF-002121', NULL, 'Uncharacterized protein (Fragment)', 96, NULL, NULL, 152951),
(152952, '3.90.190.10-FF-000152', NULL, 'Tyrosine phosphatase, putative', 174, NULL, NULL, 152952),
(152953, '3.30.565.10-FF-000379', NULL, 'Uncharacterized protein', 101, NULL, NULL, 152953),
(152954, '3.30.40.10-FF-001857', NULL, 'Uncharacterized protein', 80, NULL, NULL, 152954),
(152955, '1.20.1280.50-FF-000131', NULL, 'F-box/LRR-repeat protein 6', 50, NULL, NULL, 152955),
(152956, '1.20.1250.20-FF-002335', NULL, 'Solute carrier family 2 member 10', 130, NULL, NULL, 152956),
(152957, '3.10.50.10-FF-000004', NULL, 'Chitinase 5', 72, NULL, NULL, 152957),
(152958, '2.130.10.30-FF-000111', NULL, NULL, 143, NULL, NULL, 152958),
(152959, '1.50.10.10-FF-000050', NULL, 'G-protein coupled receptor, putative', 418, NULL, NULL, 152959),
(152960, '3.80.10.10-FF-002904', NULL, 'Uncharacterized protein', 132, NULL, NULL, 152960),
(152961, '1.25.10.10-FF-002912', NULL, 'Uncharacterized protein', 120, NULL, NULL, 152961),
(152962, '3.30.70.330-FF-000267', NULL, 'Peptidyl-prolyl cis-trans isomerase', 146, NULL, NULL, 152962),
(152963, '1.10.3720.10-FF-000179', NULL, 'Amino acid ABC transporter permease', 217, NULL, NULL, 152963),
(152964, '1.20.58.1280-FF-000004', NULL, 'DNA repair protein REV1', 94, NULL, NULL, 152964),
(152965, '2.30.29.220-FF-000008', NULL, 'FACT complex subunit SSRP1', 64, NULL, NULL, 152965),
(152966, '3.30.1590.10-FF-000004', NULL, 'Malto-oligosyltrehalose synthase', 127, NULL, NULL, 152966),
(152967, '3.30.420.40-FF-001058', NULL, 'Uncharacterized protein', 77, NULL, NULL, 152967),
(152968, '1.20.5.50-FF-000005', NULL, 'Fibrinogen gamma chain', 144, NULL, NULL, 152968),
(152969, '1.20.1270.60-FF-000206', NULL, 'Uncharacterized protein', 223, NULL, NULL, 152969),
(152970, '1.10.533.10-FF-000295', NULL, 'Uncharacterized protein', 79, NULL, NULL, 152970),
(152971, '3.40.390.10-FF-000049', NULL, 'Kell blood group, metallo-endopeptidase', 284, NULL, NULL, 152971),
(152972, '3.40.50.2000-FF-000423', NULL, 'AGAP008401-PA', 160, NULL, NULL, 152972),
(152973, '1.20.1250.10-FF-000078', NULL, 'Kit ligand', 142, NULL, NULL, 152973),
(152974, '3.40.630.30-FF-000304', NULL, 'YghO protein', 290, NULL, NULL, 152974),
(152975, '3.10.450.80-FF-000003', NULL, '60S ribosomal protein L36a-like', 68, NULL, NULL, 152975),
(152976, '1.20.1560.10-FF-000860', NULL, 'ABC transporter AbcB-related protein', 193, NULL, NULL, 152976),
(152977, '2.60.40.10-FF-001712', NULL, 'Interleukin-27 receptor subunit alpha', 84, NULL, NULL, 152977);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(152978, '3.40.30.10-FF-000007', NULL, 'Thioredoxin-dependent thiol peroxidase', 153, NULL, NULL, 152978),
(152979, '3.30.160.60-FF-003123', NULL, 'Zinc finger protein 443', 27, NULL, NULL, 152979),
(152980, '1.20.1310.10-FF-000179', NULL, NULL, 121, NULL, NULL, 152980),
(152981, '3.50.50.60-FF-000905', NULL, 'Uncharacterized protein', 86, NULL, NULL, 152981),
(152982, '1.10.510.10-FF-001035', NULL, 'Serine/threonine-protein kinase CHK1', 351, NULL, NULL, 152982),
(152983, '1.25.10.10-FF-002379', NULL, 'ARM repeat superfamily protein', 272, NULL, NULL, 152983),
(152984, '3.60.40.10-FF-000125', NULL, 'IcfG protein', 249, NULL, NULL, 152984),
(152985, '3.30.559.70-FF-000040', NULL, 'Uncharacterized protein', 228, NULL, NULL, 152985),
(152986, '1.20.120.1750-FF-000119', NULL, 'RBR-type E3 ubiquitin transferase', 134, NULL, NULL, 152986),
(152987, '1.20.5.340-FF-000045', NULL, 'SCAR family protein', 90, NULL, NULL, 152987),
(152988, '2.60.40.640-FF-000126', NULL, 'Uncharacterized protein', 124, NULL, NULL, 152988),
(152989, '2.60.40.10-FF-004585', NULL, NULL, 116, NULL, NULL, 152989),
(152990, '3.40.50.1820-FF-001807', NULL, 'Gastric triacylglycerol lipase, putative', 128, NULL, NULL, 152990),
(152991, '3.30.160.60-FF-005040', NULL, NULL, 27, NULL, NULL, 152991),
(152992, '2.60.40.10-FF-003949', NULL, NULL, 105, NULL, NULL, 152992),
(152993, '3.30.60.30-FF-000145', NULL, 'Agrin, putative', 36, NULL, NULL, 152993),
(152994, '1.20.1070.10-FF-000204', NULL, 'platelet-activating factor receptor', 316, NULL, NULL, 152994),
(152995, '3.90.260.10-FF-000051', NULL, 'Uncharacterized protein', 113, NULL, NULL, 152995),
(152996, '3.30.1010.10-FF-000091', NULL, 'Phosphatidylinositol 4-kinase', 163, NULL, NULL, 152996),
(152997, '1.10.357.10-FF-000082', NULL, 'Uncharacterized protein', 118, NULL, NULL, 152997),
(152998, '3.90.190.10-FF-000505', NULL, 'Protein tyrosine phosphatase, putative', 144, NULL, NULL, 152998),
(152999, '3.20.20.80-FF-000231', NULL, 'Chitinase 9', 276, NULL, NULL, 152999),
(153000, '3.30.1330.30-FF-000103', NULL, '50S ribosomal protein L30e', 103, NULL, NULL, 153000),
(153001, '2.40.30.10-FF-000285', NULL, 'Elongation factor 2', 129, NULL, NULL, 153001),
(153002, '3.40.50.1460-FF-000014', NULL, 'Caspase 10, apoptosis-related cysteine peptidase', 248, NULL, NULL, 153002),
(153003, '1.20.1250.20-FF-001396', NULL, 'Uncharacterized protein', 189, NULL, NULL, 153003),
(153004, '3.30.160.60-FF-004534', NULL, NULL, 21, NULL, NULL, 153004),
(153005, '3.20.20.100-FF-000179', NULL, 'Predicted protein', 151, NULL, NULL, 153005),
(153006, '1.20.58.70-FF-000044', NULL, 'GM25395', 122, NULL, NULL, 153006),
(153007, '3.30.450.40-FF-000060', NULL, 'Stage II sporulation protein E', 172, NULL, NULL, 153007),
(153008, '3.60.10.10-FF-000253', NULL, 'Secreted protein containing Endonuclease/exonuclease/phosphatase domain', 254, NULL, NULL, 153008),
(153009, '3.40.50.10860-FF-000051', NULL, 'Uncharacterized protein', 85, NULL, NULL, 153009),
(153010, '3.40.50.800-FF-000014', NULL, 'Putative dna polymerase subunit gamma-2 mitochondrial', 106, NULL, NULL, 153010),
(153011, '1.10.472.10-FF-000153', NULL, 'Putative transcription factor', 93, NULL, NULL, 153011),
(153012, '3.40.50.10420-FF-000003', NULL, '5-formyltetrahydrofolate cyclo-ligase', 217, NULL, NULL, 153012),
(153013, '2.30.30.30-FF-000123', NULL, '39S ribosomal protein L24, mitochondrial', 106, NULL, NULL, 153013),
(153014, '3.90.70.30-FF-000008', NULL, 'Uncharacterized protein', 121, NULL, NULL, 153014),
(153015, '1.25.40.20-FF-001580', NULL, 'Uncharacterized protein', 253, NULL, NULL, 153015),
(153016, '2.30.42.10-FF-000234', NULL, 'Protein KINase', 97, NULL, NULL, 153016),
(153017, '2.40.50.150-FF-000019', NULL, 'DNA-directed RNA polymerase subunit beta', 126, NULL, NULL, 153017),
(153018, '1.10.287.1150-FF-000003', NULL, '2-oxoglutarate dehydrogenase, E1 subunit', 83, NULL, NULL, 153018),
(153019, '1.20.58.60-FF-000507', NULL, 'Nesprin-2', 173, NULL, NULL, 153019),
(153020, '3.30.70.380-FF-000012', NULL, NULL, 90, NULL, NULL, 153020),
(153021, '3.30.200.20-FF-001980', NULL, 'Receptor protein serine/threonine kinase', 100, NULL, NULL, 153021);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(153022, '3.40.50.300-FF-000561', NULL, 'rho-related GTP-binding protein RhoV', 181, NULL, NULL, 153022),
(153023, '3.10.580.10-FF-000008', NULL, 'Integral membrane protein TerC', 153, NULL, NULL, 153023),
(153024, '3.30.70.330-FF-001739', NULL, 'RNA-binding motif protein 28', 170, NULL, NULL, 153024),
(153025, '2.60.40.10-FF-004894', NULL, NULL, 74, NULL, NULL, 153025),
(153026, '3.90.70.10-FF-000002', NULL, 'Ubiquitin carboxyl-terminal hydrolase 13', 329, NULL, NULL, 153026),
(153027, '2.60.40.10-FF-004455', NULL, NULL, 107, NULL, NULL, 153027),
(153028, '3.30.200.20-FF-000991', NULL, 'Non-specific serine/threonine protein kinase', 92, NULL, NULL, 153028),
(153029, '3.40.50.620-FF-000084', NULL, 'arginine--tRNA ligase, cytoplasmic', 340, NULL, NULL, 153029),
(153030, '1.10.1900.20-FF-000004', NULL, 'MRPL20 isoform 5', 33, NULL, NULL, 153030),
(153031, '1.20.1560.10-FF-000208', NULL, 'Peptidase domain-containing ABC transporter', 310, NULL, NULL, 153031),
(153032, '3.90.70.10-FF-000811', NULL, 'Uncharacterized protein', 309, NULL, NULL, 153032),
(153033, '1.10.510.10-FF-002496', NULL, NULL, 180, NULL, NULL, 153033),
(153034, '1.25.10.10-FF-003205', NULL, 'Valyl-tRNA synthetase', 281, NULL, NULL, 153034),
(153035, '3.30.160.60-FF-003606', NULL, NULL, 28, NULL, NULL, 153035),
(153036, '2.40.50.100-FF-000100', NULL, 'Carbohydrate ABC transporter ATP-binding protein (CUT1 family)', 89, NULL, NULL, 153036),
(153037, '1.25.70.10-FF-000090', NULL, NULL, 125, NULL, NULL, 153037),
(153038, '1.10.1040.10-FF-000019', NULL, '3-hydroxybutyryl-CoA dehydrogenase FadB2', 97, NULL, NULL, 153038),
(153039, '3.40.50.300-FF-006058', NULL, 'ATP-binding cassette transporter, subfamily C, member 10, group MRP protein PpABCC10', 247, NULL, NULL, 153039),
(153040, '3.30.1010.10-FF-000152', NULL, 'Uncharacterized protein', 157, NULL, NULL, 153040),
(153041, '1.20.5.110-FF-000105', NULL, 'SNARE protein, putative', 84, NULL, NULL, 153041),
(153042, '3.30.420.10-FF-000217', NULL, 'DNA polymerase epsilon catalytic subunit', 113, NULL, NULL, 153042),
(153043, '1.25.40.20-FF-000961', NULL, 'Ankyrin repeat domain 33', 68, NULL, NULL, 153043),
(153044, '1.25.40.10-FF-002740', NULL, 'TPR domain protein (AFU_orthologue AFUA_4G13160)', 231, NULL, NULL, 153044),
(153045, '3.40.50.10190-FF-000243', NULL, 'DNA ligase', 83, NULL, NULL, 153045),
(153046, '1.20.900.10-FF-000045', NULL, 'Uncharacterized protein, isoform C', 216, NULL, NULL, 153046),
(153047, '1.25.40.20-FF-000591', NULL, 'Ankyrin repeat, PH and SEC7 domain containing protein secG', 72, NULL, NULL, 153047),
(153048, '1.20.1250.20-FF-001407', NULL, 'MFS sugar transporter, putative (AFU_orthologue AFUA_5G06720)', 186, NULL, NULL, 153048),
(153049, '2.30.30.140-FF-000189', NULL, 'maternal protein tudor', 70, NULL, NULL, 153049),
(153050, '3.30.160.60-FF-003915', NULL, NULL, 41, NULL, NULL, 153050),
(153051, '2.60.40.10-FF-005074', NULL, NULL, 145, NULL, NULL, 153051),
(153052, '2.130.10.10-FF-000847', NULL, 'F-box protein MET30', 81, NULL, NULL, 153052),
(153053, '3.40.50.720-FF-000760', NULL, 'Putative short-chain dehydrogenase', 266, NULL, NULL, 153053),
(153054, '2.60.40.150-FF-000737', NULL, 'Uncharacterized protein', 105, NULL, NULL, 153054),
(153055, '3.30.56.10-FF-000028', NULL, 'Phenylalanine--tRNA ligase beta subunit', 70, NULL, NULL, 153055),
(153056, '3.40.50.2000-FF-001042', NULL, 'Uncharacterized protein', 151, NULL, NULL, 153056),
(153057, '3.40.1110.10-FF-000410', NULL, NULL, 55, NULL, NULL, 153057),
(153058, '3.40.630.10-FF-000118', NULL, 'Metallo-peptidase, Clan MC, Family M14', 274, NULL, NULL, 153058),
(153059, '1.25.40.10-FF-001116', NULL, 'Uncharacterized protein', 251, NULL, NULL, 153059),
(153060, '1.10.357.150-FF-000005', NULL, 'Dsl1p', 195, NULL, NULL, 153060),
(153061, '3.40.1180.10-FF-000021', NULL, 'Undecaprenyl diphosphate synthase', 215, NULL, NULL, 153061),
(153062, '3.30.420.40-FF-000069', NULL, 'Heat shock protein 70', 143, NULL, NULL, 153062),
(153063, '3.40.50.1010-FF-000109', NULL, 'Ribonuclease VapC', 122, NULL, NULL, 153063),
(153064, '1.25.40.10-FF-004977', NULL, 'Pentatricopeptide repeat-containing protein', 148, NULL, NULL, 153064); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(153065, '3.30.200.20-FF-000535', NULL, 'Non-specific serine/threonine protein kinase', 161, NULL, NULL, 153065),
(153066, '3.20.20.70-FF-000065', NULL, 'Hyaluronidase', 420, NULL, NULL, 153066),
(153067, '3.80.10.10-FF-002112', NULL, 'Protein CBG01819', 396, NULL, NULL, 153067),
(153068, '2.40.50.140-FF-000325', NULL, 'Maltose ABC transporter, ATP-binding protein, putative', 43, NULL, NULL, 153068),
(153069, '3.40.50.300-FF-001387', NULL, 'ABC transporter ATP-binding protein', 243, NULL, NULL, 153069),
(153070, '1.10.246.90-FF-000016', NULL, 'U4/U6-U5 snRNP complex subunit', 122, NULL, NULL, 153070),
(153071, '2.130.10.10-FF-003118', NULL, 'WD-40 domain-containing protein', 268, NULL, NULL, 153071),
(153072, '3.40.50.2300-FF-000406', NULL, 'Two-component response regulator', 83, NULL, NULL, 153072),
(153073, '1.10.10.60-FF-000836', NULL, NULL, 67, NULL, NULL, 153073),
(153074, '1.10.510.10-FF-000416', NULL, 'Serine/threonine-protein kinase H1', 333, NULL, NULL, 153074),
(153075, '1.20.1640.10-FF-000052', NULL, 'Transmembrane transport protein MmpL11', 195, NULL, NULL, 153075),
(153076, '1.10.472.10-FF-000653', NULL, 'Uncharacterized protein', 102, NULL, NULL, 153076),
(153077, '3.20.20.370-FF-000035', NULL, 'Uncharacterized protein', 147, NULL, NULL, 153077),
(153078, '3.90.190.20-FF-000042', NULL, 'Folyl-polyglutamate synthetase', 127, NULL, NULL, 153078),
(153079, '3.40.140.10-FF-000227', NULL, 'Uncharacterized protein', 172, NULL, NULL, 153079),
(153080, '3.30.230.10-FF-000034', NULL, '30S ribosomal protein S9', 133, NULL, NULL, 153080),
(153081, '3.30.160.60-FF-005170', NULL, NULL, 68, NULL, NULL, 153081),
(153082, '3.40.50.720-FF-001277', NULL, 'Yersiniabactin polyketide/non-ribosomal peptide synthetase', 468, NULL, NULL, 153082),
(153083, '2.60.120.260-FF-000667', NULL, 'Uncharacterized protein', 184, NULL, NULL, 153083),
(153084, '3.90.550.20-FF-000025', NULL, 'Uncharacterized protein', 219, NULL, NULL, 153084),
(153085, '1.25.10.10-FF-002249', NULL, 'Uncharacterized protein', 373, NULL, NULL, 153085),
(153086, '1.10.287.70-FF-000414', NULL, 'Ion_channel_-_putative', 96, NULL, NULL, 153086),
(153087, '2.60.40.10-FF-000723', NULL, 'Collagen type VI alpha 3 chain', 98, NULL, NULL, 153087),
(153088, '3.30.70.20-FF-000070', NULL, 'Iron-sulfur cluster-binding protein', 90, NULL, NULL, 153088),
(153089, '1.10.10.10-FF-000815', NULL, 'MarR family transcriptional regulator', 145, NULL, NULL, 153089),
(153090, '1.10.10.820-FF-000032', NULL, 'Chitin synthase', 62, NULL, NULL, 153090),
(153091, '3.10.20.90-FF-000392', NULL, 'Ubiquitin carboxyl-terminal hydrolase 47', 89, NULL, NULL, 153091),
(153092, '1.10.1760.20-FF-000015', NULL, 'Riboflavin transporter', 195, NULL, NULL, 153092),
(153093, '3.10.120.10-FF-000042', NULL, 'Acyl-CoA desaturase', 94, NULL, NULL, 153093),
(153094, '3.30.70.270-FF-000288', NULL, NULL, 89, NULL, NULL, 153094),
(153095, '1.10.3370.10-FF-000022', NULL, 'Protein translocase subunit SecY', 465, NULL, NULL, 153095),
(153096, '2.10.25.10-FF-000117', NULL, 'Delta-like protein', 39, NULL, NULL, 153096),
(153097, '2.60.40.640-FF-000098', NULL, 'Arrestin domain-containing protein B', 144, NULL, NULL, 153097),
(153098, '3.80.10.10-FF-002921', NULL, 'Os05g0256500 protein', 184, NULL, NULL, 153098),
(153099, '3.40.50.300-FF-004613', NULL, 'Putative RNA helicase', 74, NULL, NULL, 153099),
(153100, '3.30.710.10-FF-000083', NULL, 'Kelch-like family member 22', 123, NULL, NULL, 153100),
(153101, '3.40.605.10-FF-000122', NULL, 'Uncharacterized protein', 230, NULL, NULL, 153101),
(153102, '2.160.10.10-FF-000093', NULL, 'Transferase hexapeptide repeat containing protein', 124, NULL, NULL, 153102),
(153103, '3.10.20.720-FF-000002', NULL, 'Inner kinetochore subunit mis15', 85, NULL, NULL, 153103),
(153104, '3.20.20.70-FF-000082', NULL, 'NADPH-dependent 2,4-dienoyl-CoA reductase', 368, NULL, NULL, 153104),
(153105, '3.40.50.1820-FF-000026', NULL, 'GPI inositol-deacylase', 217, NULL, NULL, 153105),
(153106, '3.40.50.2000-FF-000553', NULL, 'Glycosyl transferase', 244, NULL, NULL, 153106);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(153107, '1.10.8.590-FF-000004', NULL, 'tRNA (cytidine/uridine/adenosine-2''-O-)-methyltransferase TrmJ', 78, NULL, NULL, 153107),
(153108, '2.160.20.10-FF-000178', NULL, 'Uncharacterized protein', 142, NULL, NULL, 153108),
(153109, '2.60.120.290-FF-000210', NULL, 'Uncharacterized protein', 130, NULL, NULL, 153109),
(153110, '3.40.720.10-FF-000064', NULL, 'Probable acid phosphatase Pho610', 279, NULL, NULL, 153110),
(153111, '3.30.70.270-FF-000108', NULL, 'GGDEF family protein', 166, NULL, NULL, 153111),
(153112, '1.25.40.10-FF-004185', NULL, 'Predicted protein', 83, NULL, NULL, 153112),
(153113, '1.25.40.20-FF-001900', NULL, 'Uncharacterized protein', 106, NULL, NULL, 153113),
(153114, '3.30.70.3490-FF-000041', NULL, NULL, 73, NULL, NULL, 153114),
(153115, '1.20.142.10-FF-000013', NULL, 'Poly [ADP-ribose] polymerase', 153, NULL, NULL, 153115),
(153116, '1.10.150.670-FF-000005', NULL, 'ERCC4 domain-containing protein', 91, NULL, NULL, 153116),
(153117, '3.40.50.300-FF-008536', NULL, 'Uncharacterized protein', 86, NULL, NULL, 153117),
(153118, '3.40.50.300-FF-002359', NULL, 'SNF2 superfamily protein', 282, NULL, NULL, 153118),
(153119, '1.20.1230.10-FF-000015', NULL, 'Phosphoinositide phospholipase C', 170, NULL, NULL, 153119),
(153120, '3.40.47.10-FF-000282', NULL, NULL, 299, NULL, NULL, 153120),
(153121, '1.25.40.10-FF-000262', NULL, 'Histone-lysine N-methyltransferase SMYD3', 75, NULL, NULL, 153121),
(153122, '3.40.50.150-FF-000364', NULL, 'S-adenosylmethionine-dependent methyltransferase, putative', 208, NULL, NULL, 153122),
(153123, '3.30.70.330-FF-002728', NULL, NULL, 97, NULL, NULL, 153123),
(153124, '3.40.50.2000-FF-000114', NULL, 'GHMP kinase-like', 143, NULL, NULL, 153124),
(153125, '3.30.200.20-FF-002008', NULL, NULL, 95, NULL, NULL, 153125),
(153126, '3.10.110.10-FF-000294', NULL, 'Uncharacterized protein', 107, NULL, NULL, 153126),
(153127, '3.20.20.140-FF-000421', NULL, 'Os08g0165800 protein', 65, NULL, NULL, 153127),
(153128, '3.80.10.10-FF-000443', NULL, 'Leucine-rich repeat (LRR) family protein', 292, NULL, NULL, 153128),
(153129, '1.25.40.10-FF-003016', NULL, 'Pentatricopeptide repeat-containing protein MRL1, chloroplastic', 114, NULL, NULL, 153129),
(153130, '3.30.420.40-FF-000232', NULL, 'Actin-related protein 8', 181, NULL, NULL, 153130),
(153131, '3.40.50.300-FF-004793', NULL, 'Uncharacterized protein', 123, NULL, NULL, 153131),
(153132, '2.30.29.30-FF-000187', NULL, 'SH2B adapter protein 2', 133, NULL, NULL, 153132),
(153133, '3.80.10.10-FF-000004', NULL, 'Slit guidance ligand 2', 186, NULL, NULL, 153133),
(153134, '1.25.40.20-FF-001006', NULL, 'Uncharacterized protein', 78, NULL, NULL, 153134),
(153135, '2.60.40.10-FF-004085', NULL, NULL, 94, NULL, NULL, 153135),
(153136, '1.25.40.10-FF-004005', NULL, 'Gamma-soluble NSF attachment protein, putative', 205, NULL, NULL, 153136),
(153137, '2.60.40.10-FF-000740', NULL, '6-phosphofructo-2-kinase/fructose-2,6-bisphosphatase', 93, NULL, NULL, 153137),
(153138, '3.20.20.70-FF-000565', NULL, 'Uncharacterized protein', 331, NULL, NULL, 153138),
(153139, '3.30.40.10-FF-000705', NULL, 'E3 ubiquitin-protein ligase RHF2A isoform X1', 73, NULL, NULL, 153139),
(153140, '3.30.70.330-FF-002245', NULL, NULL, 100, NULL, NULL, 153140),
(153141, '1.20.1070.10-FF-000143', NULL, 'C-X-C chemokine receptor type 5', 304, NULL, NULL, 153141),
(153142, '3.40.50.1240-FF-000212', NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', 379, NULL, NULL, 153142),
(153143, '3.40.50.300-FF-002798', NULL, 'Cytoplasmic dynein 2 heavy chain 1', 169, NULL, NULL, 153143),
(153144, '3.80.10.10-FF-004366', NULL, 'Uncharacterized protein', 369, NULL, NULL, 153144),
(153145, '2.70.160.11-FF-000081', NULL, 'Protein arginine methyltransferase 3', 92, NULL, NULL, 153145),
(153146, '3.10.290.70-FF-000009', NULL, '40S ribosomal protein S8', 123, NULL, NULL, 153146),
(153147, '1.50.40.10-FF-000198', NULL, 'Protein CBG17210', 290, NULL, NULL, 153147),
(153148, '2.60.120.200-FF-000094', NULL, 'Collagen type XVI alpha 1 chain', 212, NULL, NULL, 153148);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(153149, '1.20.1050.10-FF-000130', NULL, 'Uncharacterized protein', 83, NULL, NULL, 153149),
(153150, '1.25.40.20-FF-001445', NULL, 'Uncharacterized protein', 141, NULL, NULL, 153150),
(153151, '3.40.309.10-FF-000092', NULL, 'AGAP009944-PA', 202, NULL, NULL, 153151),
(153152, '3.30.1370.10-FF-000010', NULL, 'far upstream element-binding protein 1 isoform X1', 90, NULL, NULL, 153152),
(153153, '1.50.40.10-FF-000170', NULL, 'Mitochondrial carrier protein, putative', 176, NULL, NULL, 153153),
(153154, '3.30.499.10-FF-000039', NULL, NULL, 216, NULL, NULL, 153154),
(153155, '3.40.710.10-FF-000136', NULL, 'Stage V sporulation protein D', 198, NULL, NULL, 153155),
(153156, '1.10.10.350-FF-000003', NULL, 'probable glutamate--tRNA ligase, mitochondrial isoform X2', 93, NULL, NULL, 153156),
(153157, '1.10.472.10-FF-000506', NULL, 'Protein CBG15501', 143, NULL, NULL, 153157),
(153158, '1.10.10.60-FF-000706', NULL, 'NK2b', 60, NULL, NULL, 153158),
(153159, '1.20.1270.60-FF-000223', NULL, 'F-BAR and double SH3 domains protein 2', 306, NULL, NULL, 153159),
(153160, '2.20.110.10-FF-000043', NULL, 'MORN repeat-containing protein 4 homolog', 77, NULL, NULL, 153160),
(153161, '3.30.40.140-FF-000007', NULL, 'Uncharacterized protein', 172, NULL, NULL, 153161),
(153162, '1.10.1040.10-FF-000121', NULL, 'Uncharacterized protein', 95, NULL, NULL, 153162),
(153163, '3.30.160.60-FF-001128', NULL, 'Uncharacterized protein', 28, NULL, NULL, 153163),
(153164, '2.120.10.10-FF-000033', NULL, 'Predicted protein', 178, NULL, NULL, 153164),
(153165, '1.10.167.10-FF-000039', NULL, 'A-kinase anchor protein 10', 133, NULL, NULL, 153165),
(153166, '1.20.1070.10-FF-001632', NULL, 'Diuretic hormone receptor, putative', 140, NULL, NULL, 153166),
(153167, '1.25.10.10-FF-002688', NULL, 'Uncharacterized protein', 74, NULL, NULL, 153167),
(153168, '1.20.1250.10-FF-000106', NULL, NULL, 79, NULL, NULL, 153168),
(153169, '3.30.160.60-FF-001206', NULL, 'Zinc finger protein 668', 27, NULL, NULL, 153169),
(153170, '3.30.1310.10-FF-000017', NULL, 'Nucleoid-associated protein FN1270', 88, NULL, NULL, 153170),
(153171, '1.25.10.10-FF-001940', NULL, 'Regulator of chromosome condensation repeat containing protein', 349, NULL, NULL, 153171),
(153172, '3.40.47.10-FF-000102', NULL, 'Keto acyl-CoA thiolase', 406, NULL, NULL, 153172),
(153173, '3.30.60.20-FF-000125', NULL, 'Diacylglycerol kinase A', 72, NULL, NULL, 153173),
(153174, '2.40.30.70-FF-000016', NULL, 'Uncharacterized protein', 75, NULL, NULL, 153174),
(153175, '1.25.40.320-FF-000013', NULL, 'Uncharacterized protein', 114, NULL, NULL, 153175),
(153176, '3.30.470.20-FF-000257', NULL, 'Cycloserine biosynthesis protein DcsG', 46, NULL, NULL, 153176),
(153177, '3.60.20.10-FF-000079', NULL, 'Proteasome subunit beta 2', 189, NULL, NULL, 153177),
(153178, '3.30.450.30-FF-000068', NULL, 'Profilin', 126, NULL, NULL, 153178),
(153179, '3.30.499.10-FF-000011', NULL, 'Iron-responsive element binding protein 2', 240, NULL, NULL, 153179),
(153180, '2.10.110.10-FF-000343', NULL, 'Protein DA1-related 2', 76, NULL, NULL, 153180),
(153181, '3.90.1150.10-FF-000300', NULL, 'Aspartate aminotransferase', 96, NULL, NULL, 153181),
(153182, '3.10.450.50-FF-000005', NULL, 'Nuclear transport factor 2', 124, NULL, NULL, 153182),
(153183, '3.30.420.40-FF-000569', NULL, 'Carbohydrate kinase', 240, NULL, NULL, 153183),
(153184, '2.60.40.60-FF-001002', NULL, 'Uncharacterized protein', 109, NULL, NULL, 153184),
(153185, '3.30.160.60-FF-002634', NULL, NULL, 28, NULL, NULL, 153185),
(153186, '3.50.30.30-FF-000024', NULL, 'E3 ubiquitin-protein ligase RNF43 isoform X2', 51, NULL, NULL, 153186),
(153187, '1.20.190.10-FF-000001', NULL, 'Uncharacterized protein', 218, NULL, NULL, 153187),
(153188, '3.10.129.10-FF-000123', NULL, 'Phenylacetic acid degradation protein PaaI', 139, NULL, NULL, 153188),
(153189, '1.25.10.10-FF-000434', NULL, 'Hsp70 nucleotide exchange factor fes1', 166, NULL, NULL, 153189),
(153190, '1.10.12.10-FF-000005', NULL, 'Carnitinyl-CoA dehydratase', 62, NULL, NULL, 153190),
(153191, '3.30.870.10-FF-000037', NULL, 'Superfamily I DNA helicase', 156, NULL, NULL, 153191);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(153192, '1.25.10.10-FF-001070', NULL, 'AGAP009004-PA', 241, NULL, NULL, 153192),
(153193, '1.20.120.850-FF-000045', NULL, 'SWI/SNF chromatin remodeling complex component', 33, NULL, NULL, 153193),
(153194, '3.30.420.10-FF-000234', NULL, 'DNA polymerase I', 214, NULL, NULL, 153194),
(153195, '1.25.40.10-FF-001088', NULL, 'Pentatricopeptide repeat-containing protein At4g33990', 145, NULL, NULL, 153195),
(153196, '3.40.50.10130-FF-000023', NULL, 'Fanconi anemia core complex-associated protein 24', 47, NULL, NULL, 153196),
(153197, '3.30.1520.10-FF-000039', NULL, 'PX domain containing serine/threonine kinase like', 81, NULL, NULL, 153197),
(153198, '1.20.1270.20-FF-000009', NULL, 'Hydroxylamine reductase', 85, NULL, NULL, 153198),
(153199, '1.25.40.10-FF-000823', NULL, 'Unplaced genomic scaffold supercont1.141, whole genome shotgun sequence', 180, NULL, NULL, 153199),
(153200, '1.10.287.110-FF-000308', NULL, 'DnaJ heat shock protein family (Hsp40) member B12a', 107, NULL, NULL, 153200),
(153201, '2.130.10.10-FF-002764', NULL, 'Nan1p', 243, NULL, NULL, 153201),
(153202, '3.40.1280.10-FF-000068', NULL, 'Mitochondrial rRNA methyltransferase 1 homolog (S. cerevisiae), isoform CRA_b', 128, NULL, NULL, 153202),
(153203, '3.30.2160.10-FF-000073', NULL, 'Uncharacterized protein', 29, NULL, NULL, 153203),
(153204, '2.60.120.10-FF-000220', NULL, 'Uncharacterized protein', 191, NULL, NULL, 153204),
(153205, '2.30.30.40-FF-000261', NULL, 'Chemotaxis protein CheV', 60, NULL, NULL, 153205),
(153206, '1.25.40.10-FF-000599', NULL, 'Protein CBG09283', 117, NULL, NULL, 153206),
(153207, '3.30.2260.10-FF-000002', NULL, 'LOW QUALITY PROTEIN: enhancer of rudimentary homolog', 32, NULL, NULL, 153207),
(153208, '3.40.50.300-FF-007710', NULL, 'Predicted protein', 98, NULL, NULL, 153208),
(153209, '1.10.287.130-FF-000157', NULL, 'Two-component system sensor protein', 74, NULL, NULL, 153209),
(153210, '3.30.70.330-FF-000930', NULL, 'Sbp1p', 171, NULL, NULL, 153210),
(153211, '2.10.70.10-FF-000210', NULL, 'Complement regulatory membrane protein', 60, NULL, NULL, 153211),
(153212, '4.10.240.30-FF-000007', NULL, 'Uncharacterized protein', 28, NULL, NULL, 153212),
(153213, '1.10.287.4070-FF-000019', NULL, 'Uncharacterized protein', 160, NULL, NULL, 153213),
(153214, '1.10.10.10-FF-000462', NULL, 'Two component transcriptional regulator', 113, NULL, NULL, 153214),
(153215, '1.10.287.10-FF-000003', NULL, '40S ribosomal protein S13', 69, NULL, NULL, 153215),
(153216, '1.10.238.10-FF-000816', NULL, 'Calcium-binding protein CML38', 87, NULL, NULL, 153216),
(153217, '3.40.30.10-FF-000581', NULL, 'Thioredoxin', 78, NULL, NULL, 153217),
(153218, '2.60.40.10-FF-002538', NULL, 'PLeXin', 163, NULL, NULL, 153218),
(153219, '3.50.50.60-FF-000113', NULL, 'NADPH-dependent 2,4-dienoyl-CoA reductase', 157, NULL, NULL, 153219),
(153220, '3.30.1490.80-FF-000017', NULL, 'Eukaryotic glutathione synthase', 44, NULL, NULL, 153220),
(153221, '1.20.1070.10-FF-000452', NULL, 'SERotonin/octopamine receptor family', 141, NULL, NULL, 153221),
(153222, '1.20.144.10-FF-000097', NULL, 'Phosphatidic acid phosphatase type 2/haloperoxidase', 255, NULL, NULL, 153222),
(153223, '3.40.50.10750-FF-000001', NULL, 'Phosphate acetyltransferase', 154, NULL, NULL, 153223),
(153224, '3.30.70.330-FF-000800', NULL, 'AAEL005515-PF', 84, NULL, NULL, 153224),
(153225, '3.30.70.20-FF-000053', NULL, 'Ferredoxin-type protein NapF', 63, NULL, NULL, 153225),
(153226, '2.60.40.10-FF-003466', NULL, 'FI18055p1', 123, NULL, NULL, 153226),
(153227, '1.10.238.10-FF-000946', NULL, 'Uncharacterized protein', 98, NULL, NULL, 153227),
(153228, '1.10.20.10-FF-000108', NULL, 'High mobility group protein B4, putative', 84, NULL, NULL, 153228),
(153229, '3.40.50.300-FF-002668', NULL, 'ATP binding cassette subfamily A member 8', 76, NULL, NULL, 153229),
(153230, '1.10.3200.20-FF-000013', NULL, NULL, 122, NULL, NULL, 153230),
(153231, '2.60.40.10-FF-002977', NULL, 'Tyrosine-protein kinase receptor', 102, NULL, NULL, 153231),
(153232, '4.10.260.10-FF-000014', NULL, 'Guanine nucleotide-binding protein subunit gamma', 52, NULL, NULL, 153232);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(153233, '3.30.160.60-FF-003253', NULL, 'Si:dkeyp-82b4.6', 28, NULL, NULL, 153233),
(153234, '1.10.3060.10-FF-000021', NULL, 'Uncharacterized protein', 89, NULL, NULL, 153234),
(153235, '1.10.560.10-FF-000127', NULL, 'Eukaryotic translation initiation factor 3 subunit E', 70, NULL, NULL, 153235),
(153236, '2.20.25.20-FF-000013', NULL, 'RBR-type E3 ubiquitin transferase', 49, NULL, NULL, 153236),
(153237, '2.60.40.10-FF-002640', NULL, 'AXL2p Integral plasma membrane protein', 101, NULL, NULL, 153237),
(153238, '4.10.1000.10-FF-000110', NULL, 'Expressed protein', 93, NULL, NULL, 153238),
(153239, '1.10.238.230-FF-000003', NULL, 'Uncharacterized protein, isoform B', 102, NULL, NULL, 153239),
(153240, '3.90.550.20-FF-000008', NULL, 'Mannosyltransferase OCH1 and related enzymes', 237, NULL, NULL, 153240),
(153241, '3.30.160.190-FF-000008', NULL, 'Uncharacterized protein', 79, NULL, NULL, 153241),
(153242, '4.10.60.10-FF-000143', NULL, 'Replication protein A subunit', 28, NULL, NULL, 153242),
(153243, '2.70.150.10-FF-000039', NULL, 'Cadmium-translocating P-type ATPase', 104, NULL, NULL, 153243),
(153244, '3.20.20.80-FF-000214', NULL, 'Class V chitinase Chi100', 270, NULL, NULL, 153244),
(153245, '3.40.850.10-FF-000085', NULL, 'Myosin heavy chain 7', 64, NULL, NULL, 153245),
(153246, '1.10.3720.10-FF-000049', NULL, 'Oligopeptide transport system permease oppC', 217, NULL, NULL, 153246),
(153247, '2.40.30.10-FF-000268', NULL, 'NADPH--cytochrome P450 reductase, putative', 96, NULL, NULL, 153247),
(153248, '3.10.580.10-FF-000025', NULL, 'Magnesium transporter MgtE', 128, NULL, NULL, 153248),
(153249, '3.90.70.10-FF-000783', NULL, 'Predicted protein', 353, NULL, NULL, 153249),
(153250, '3.40.1180.10-FF-000004', NULL, 'Isoprenyl transferase', 266, NULL, NULL, 153250),
(153251, '1.10.472.10-FF-000170', NULL, 'Putative mitotic cyclin', 20, NULL, NULL, 153251),
(153252, '2.60.120.290-FF-000081', NULL, 'Uncharacterized protein, isoform B', 127, NULL, NULL, 153252),
(153253, '2.60.40.10-FF-002668', NULL, 'Uncharacterized protein, isoform B', 104, NULL, NULL, 153253),
(153254, '4.10.1000.10-FF-000138', NULL, 'Uncharacterized protein', 54, NULL, NULL, 153254),
(153255, '3.30.70.1560-FF-000007', NULL, 'Pseudouridine synthase', 89, NULL, NULL, 153255),
(153256, '1.10.10.160-FF-000053', NULL, 'UVRD/Rep like helicase', 102, NULL, NULL, 153256),
(153257, '1.10.10.10-FF-001108', NULL, 'MarR family transcriptional regulator', 134, NULL, NULL, 153257),
(153258, '1.20.1250.20-FF-000435', NULL, 'Os11g0620400 protein', 293, NULL, NULL, 153258),
(153259, '1.25.40.180-FF-000145', NULL, 'Uncharacterized protein', 203, NULL, NULL, 153259),
(153260, '2.60.40.1510-FF-000059', NULL, 'Integrin beta', 41, NULL, NULL, 153260),
(153261, '3.10.100.10-FF-000057', NULL, 'Lymphatic vessel endothelial hyaluronic acid receptor 1', 92, NULL, NULL, 153261),
(153262, '3.90.70.10-FF-000474', NULL, 'Bleomycin hydrolase', 352, NULL, NULL, 153262),
(153263, '3.10.110.10-FF-000114', NULL, 'Yih1p', 113, NULL, NULL, 153263),
(153264, '1.20.5.190-FF-000174', NULL, NULL, 42, NULL, NULL, 153264),
(153265, '3.40.50.620-FF-000067', NULL, 'Protein FixB', 179, NULL, NULL, 153265),
(153266, '1.10.510.10-FF-000388', NULL, 'Leucine-rich repeat receptor-like tyrosine-protein kinase PXC3', 205, NULL, NULL, 153266),
(153267, '1.10.150.20-FF-000262', NULL, '50S ribosomal protein L32e', 55, NULL, NULL, 153267),
(153268, '3.80.10.10-FF-003540', NULL, 'Uncharacterized protein', 160, NULL, NULL, 153268),
(153269, '2.60.40.10-FF-004877', NULL, NULL, 70, NULL, NULL, 153269),
(153270, '1.25.40.10-FF-003033', NULL, 'Pentatricopeptide repeat-containing protein At3g04750, mitochondrial', 100, NULL, NULL, 153270),
(153271, '3.40.50.150-FF-001336', NULL, NULL, 196, NULL, NULL, 153271),
(153272, '2.40.10.10-FF-000385', NULL, NULL, 86, NULL, NULL, 153272),
(153273, '1.20.1310.10-FF-000049', NULL, 'Putative ubiquitin ligase subunit CulD', 102, NULL, NULL, 153273),
(153274, '2.30.29.30-FF-001367', NULL, 'Uncharacterized protein', 127, NULL, NULL, 153274),
(153275, '3.30.830.10-FF-000119', NULL, 'Uncharacterized protein', 235, NULL, NULL, 153275);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(153276, '3.30.460.10-FF-000208', NULL, 'tRNA nucleotidyltransferase, putative', 93, NULL, NULL, 153276),
(153277, '3.40.50.2300-FF-000654', NULL, 'Two-component response regulator', 84, NULL, NULL, 153277),
(153278, '3.30.930.10-FF-000172', NULL, 'Lipoate-protein ligase, putative', 231, NULL, NULL, 153278),
(153279, '2.60.120.260-FF-000066', NULL, 'Muskelin 1', 156, NULL, NULL, 153279),
(153280, '1.25.40.10-FF-003797', NULL, 'Mitochondrial fission 1 protein', 143, NULL, NULL, 153280),
(153281, '3.40.50.720-FF-000304', NULL, 'UDP-glucose 4,6-dehydratase', 246, NULL, NULL, 153281),
(153282, '3.40.120.10-FF-000035', NULL, 'Pgm3p', 174, NULL, NULL, 153282),
(153283, '3.30.1360.10-FF-000037', NULL, 'DNA-directed RNA polymerase II subunit RPB11', 123, NULL, NULL, 153283),
(153284, '2.40.128.20-FF-000020', NULL, 'Lipocalin 1', 153, NULL, NULL, 153284),
(153285, '3.30.160.60-FF-005068', NULL, NULL, 29, NULL, NULL, 153285),
(153286, '3.40.50.410-FF-000330', NULL, 'Chloride channel accessory 3, pseudogene', 175, NULL, NULL, 153286),
(153287, '1.10.10.10-FF-000962', NULL, 'DNA-binding response regulator', 108, NULL, NULL, 153287),
(153288, '3.40.225.10-FF-000059', NULL, NULL, 254, NULL, NULL, 153288),
(153289, '3.40.50.300-FF-005001', NULL, 'Uncharacterized protein', 163, NULL, NULL, 153289),
(153290, '3.90.1150.10-FF-000328', NULL, 'Kynureninase', 139, NULL, NULL, 153290),
(153291, '2.60.40.1930-FF-000027', NULL, 'Complement 4B (Chido blood group)', 116, NULL, NULL, 153291),
(153292, '1.10.510.10-FF-001905', NULL, 'nuclear receptor-binding protein-like', 117, NULL, NULL, 153292),
(153293, '3.90.45.10-FF-000034', NULL, 'Peptide deformylase', 159, NULL, NULL, 153293),
(153294, '2.130.10.10-FF-002972', NULL, 'Uncharacterized protein', 219, NULL, NULL, 153294),
(153295, '1.25.40.10-FF-000615', NULL, 'Golgi to ER traffic protein 4', 285, NULL, NULL, 153295),
(153296, '3.40.1210.10-FF-000002', NULL, 'Tubulin-tyrosine ligase', 286, NULL, NULL, 153296),
(153297, '3.40.50.150-FF-001292', NULL, NULL, 216, NULL, NULL, 153297),
(153298, '3.40.630.30-FF-000113', NULL, 'Elongator complex protein', 150, NULL, NULL, 153298),
(153299, '3.10.170.20-FF-000008', NULL, 'GP63', 203, NULL, NULL, 153299),
(153300, '4.10.410.10-FF-000032', NULL, 'CRE-MEC-1 protein', 67, NULL, NULL, 153300),
(153301, '3.30.2460.20-FF-000003', NULL, 'Protein Wnt', 68, NULL, NULL, 153301),
(153302, '3.40.50.300-FF-008183', NULL, 'Type III restriction enzyme, res subunit family protein', 81, NULL, NULL, 153302),
(153303, '1.10.10.60-FF-000914', NULL, NULL, 79, NULL, NULL, 153303),
(153304, '3.30.160.60-FF-000291', NULL, 'Spalt-like transcription factor 4', 32, NULL, NULL, 153304),
(153305, '1.20.1070.10-FF-000660', NULL, 'Predicted protein', 295, NULL, NULL, 153305),
(153306, '1.25.40.70-FF-000010', NULL, 'Phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit gamma', 192, NULL, NULL, 153306),
(153307, '3.40.50.1000-FF-000354', NULL, 'Putative P-type cation-transporting ATPase', 137, NULL, NULL, 153307),
(153308, '1.25.10.10-FF-001631', NULL, 'catenin delta-1 isoform X1', 475, NULL, NULL, 153308),
(153309, '1.10.1060.10-FF-000004', NULL, 'Glutamate synthase, small subunit', 137, NULL, NULL, 153309),
(153310, '3.70.10.10-FF-000084', NULL, 'Proliferating cell nuclear antigen', 234, NULL, NULL, 153310),
(153311, '3.40.30.10-FF-000890', NULL, 'Uncharacterized protein', 101, NULL, NULL, 153311),
(153312, '2.60.470.10-FF-000004', NULL, 'Degenerin unc-8', 170, NULL, NULL, 153312),
(153313, '3.30.160.60-FF-004079', NULL, NULL, 26, NULL, NULL, 153313),
(153314, '2.40.70.10-FF-000259', NULL, 'ASpartyl Protease', 177, NULL, NULL, 153314),
(153315, '3.40.50.11210-FF-000021', NULL, NULL, 125, NULL, NULL, 153315),
(153316, '3.80.10.10-FF-004158', NULL, 'Si:ch211-64i20.3', 103, NULL, NULL, 153316),
(153317, '1.25.40.20-FF-001237', NULL, 'KN motif and ankyrin repeat domain-containing protein 1-like isoform X1', 255, NULL, NULL, 153317),
(153318, '3.30.60.60-FF-000013', NULL, 'Histone acetyltransferase', 57, NULL, NULL, 153318),
(153319, '3.30.360.10-FF-000055', NULL, 'Putative myo-inositol-1-phosphate synthase', 41, NULL, NULL, 153319);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(153320, '2.10.25.10-FF-001623', NULL, 'Uncharacterized protein', 50, NULL, NULL, 153320),
(153321, '1.20.1440.80-FF-000001', NULL, 'Gap junction alpha-1', 230, NULL, NULL, 153321),
(153322, '3.80.10.10-FF-002449', NULL, 'MDIS1-interacting receptor like kinase 2', 94, NULL, NULL, 153322),
(153323, '3.80.10.10-FF-003068', NULL, 'Uncharacterized protein', 136, NULL, NULL, 153323),
(153324, '1.10.10.750-FF-000016', NULL, 'GTPase-activating protein, putative', 52, NULL, NULL, 153324),
(153325, '2.30.42.10-FF-000156', NULL, 'Ras-associating and dilute domain-containing protein', 104, NULL, NULL, 153325),
(153326, '1.20.1250.20-FF-001851', NULL, 'Uncharacterized protein', 130, NULL, NULL, 153326),
(153327, '2.10.50.10-FF-000102', NULL, 'Uncharacterized protein', 44, NULL, NULL, 153327),
(153328, '3.90.740.10-FF-000059', NULL, 'Valine--tRNA ligase', 36, NULL, NULL, 153328),
(153329, '3.40.50.1780-FF-000008', NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', 210, NULL, NULL, 153329),
(153330, '3.40.50.720-FF-000349', NULL, 'Uncharacterized protein At1g32220, chloroplastic', 243, NULL, NULL, 153330),
(153331, '3.40.50.300-FF-004484', NULL, 'Predicted protein', 204, NULL, NULL, 153331),
(153332, '1.10.132.10-FF-000015', NULL, NULL, 86, NULL, NULL, 153332),
(153333, '3.80.10.10-FF-002360', NULL, 'Platelet glycoprotein V', 162, NULL, NULL, 153333),
(153334, '1.20.1070.10-FF-002149', NULL, 'Uncharacterized protein', 180, NULL, NULL, 153334),
(153335, '3.40.50.300-FF-005102', NULL, 'ABC transporter family-like protein', 265, NULL, NULL, 153335),
(153336, '1.25.40.10-FF-004314', NULL, 'mRNA splicing protein', 178, NULL, NULL, 153336),
(153337, '3.40.50.10810-FF-000160', NULL, 'Helicase', 271, NULL, NULL, 153337),
(153338, '3.30.160.60-FF-005023', NULL, NULL, 31, NULL, NULL, 153338),
(153339, '2.30.30.490-FF-000052', NULL, 'Uncharacterized protein', 141, NULL, NULL, 153339),
(153340, '3.30.450.30-FF-000040', NULL, 'Late endosomal/lysosomal adaptor, Mapk (MAPK) and mToR (MTOR) activator homolog', 120, NULL, NULL, 153340),
(153341, '1.20.1090.10-FF-000026', NULL, 'Alcohol dehydrogenase, putative', 208, NULL, NULL, 153341),
(153342, '2.60.200.20-FF-000274', NULL, 'Uncharacterized protein', 137, NULL, NULL, 153342),
(153343, '3.40.1770.10-FF-000004', NULL, 'Urocanate hydratase', 202, NULL, NULL, 153343),
(153344, '3.40.50.720-FF-001940', NULL, 'C-3 sterol dehydrogenase/C-4 decarboxylase', 275, NULL, NULL, 153344),
(153345, '2.40.70.10-FF-000170', NULL, 'Eukaryotic aspartyl protease family protein', 206, NULL, NULL, 153345),
(153346, '2.70.150.10-FF-000247', NULL, 'Cation-transporting ATPase', 92, NULL, NULL, 153346),
(153347, '3.40.50.10130-FF-000040', NULL, 'Uncharacterized protein', 105, NULL, NULL, 153347),
(153348, '1.10.510.10-FF-002996', NULL, NULL, 209, NULL, NULL, 153348),
(153349, '1.10.1040.10-FF-000093', NULL, '2-dehydropantoate 2-reductase', 128, NULL, NULL, 153349),
(153350, '1.10.510.10-FF-003614', NULL, NULL, 198, NULL, NULL, 153350),
(153351, '1.20.120.720-FF-000034', NULL, 'Dachs, isoform D', 101, NULL, NULL, 153351),
(153352, '2.130.10.10-FF-005243', NULL, 'Uncharacterized protein', 302, NULL, NULL, 153352),
(153353, '3.30.160.60-FF-001437', NULL, 'Zinc finger protein 594', 29, NULL, NULL, 153353),
(153354, '3.30.40.10-FF-000677', NULL, 'E3 ubiquitin-protein ligase SDIR1', 83, NULL, NULL, 153354),
(153355, '3.40.50.1820-FF-000156', NULL, 'Neuroligin-4, Y-linked', 572, NULL, NULL, 153355),
(153356, '1.10.510.10-FF-003030', NULL, NULL, 224, NULL, NULL, 153356),
(153357, '1.10.510.10-FF-002524', NULL, NULL, 239, NULL, NULL, 153357),
(153358, '1.20.1250.20-FF-000227', NULL, 'MFS transporter, metabolite:H+ symporter family protein', 197, NULL, NULL, 153358),
(153359, '1.25.40.10-FF-003696', NULL, 'Tetratricopeptide repeat protein 30 homolog-like Protein', 241, NULL, NULL, 153359),
(153360, '1.20.940.10-FF-000019', NULL, 'Steroid receptor RNA activator 1', 81, NULL, NULL, 153360),
(153361, '2.40.50.140-FF-000134', NULL, 'ATP-dependent DNA helicase RecG', 94, NULL, NULL, 153361),
(153362, '3.40.50.1100-FF-000075', NULL, 'Threonine synthase ThrC', 140, NULL, NULL, 153362);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(153363, '2.60.40.10-FF-001257', NULL, 'Sallimus, isoform Q', 91, NULL, NULL, 153363),
(153364, '3.30.160.20-FF-000172', NULL, 'Uncharacterized protein', 72, NULL, NULL, 153364),
(153365, '3.30.780.10-FF-000047', NULL, 'Uncharacterized protein', 127, NULL, NULL, 153365),
(153366, '1.10.630.10-FF-000234', NULL, 'Cytochrome P450 71D7', 236, NULL, NULL, 153366),
(153367, '3.10.110.10-FF-000322', NULL, 'Uncharacterized protein', 161, NULL, NULL, 153367),
(153368, '3.30.530.20-FF-000184', NULL, 'Uncharacterized protein', 93, NULL, NULL, 153368),
(153369, '1.10.390.10-FF-000035', NULL, 'NPEPPS isoform 15', 159, NULL, NULL, 153369),
(153370, '3.30.70.330-FF-002700', NULL, NULL, 112, NULL, NULL, 153370),
(153371, '2.40.10.190-FF-000006', NULL, 'Ribosomal protein L35Ae, putative', 102, NULL, NULL, 153371),
(153372, '2.60.120.920-FF-000129', NULL, 'Uncharacterized protein', 99, NULL, NULL, 153372),
(153373, '3.40.950.10-FF-000002', NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', 15, NULL, NULL, 153373),
(153374, '3.40.50.1240-FF-000184', NULL, NULL, 132, NULL, NULL, 153374),
(153375, '3.30.70.330-FF-001756', NULL, NULL, 83, NULL, NULL, 153375),
(153376, '2.10.25.10-FF-001078', NULL, 'Uncharacterized protein', 40, NULL, NULL, 153376),
(153377, '3.30.70.330-FF-000328', NULL, 'Eukaryotic translation initiation factor 3 subunit G', 104, NULL, NULL, 153377),
(153378, '1.10.3720.10-FF-000151', NULL, 'Amino acid ABC transporter, permease protein', 217, NULL, NULL, 153378),
(153379, '3.40.190.10-FF-000410', NULL, 'LysR family transcriptional regulator', 92, NULL, NULL, 153379),
(153380, '1.10.8.870-FF-000009', NULL, 'Glycerol-3-phosphate dehydrogenase', 142, NULL, NULL, 153380),
(153381, '3.40.50.150-FF-001544', NULL, NULL, 90, NULL, NULL, 153381),
(153382, '1.20.120.1320-FF-000002', NULL, 'Aspartokinase', 93, NULL, NULL, 153382),
(153383, '3.90.550.50-FF-000231', NULL, 'Uncharacterized protein', 106, NULL, NULL, 153383),
(153384, '3.40.50.12660-FF-000006', NULL, 'Mca1p', 109, NULL, NULL, 153384),
(153385, '2.60.40.60-FF-000030', NULL, 'Protocadherin 9', 113, NULL, NULL, 153385),
(153386, '3.40.50.2300-FF-000906', NULL, NULL, 134, NULL, NULL, 153386),
(153387, '3.90.1600.10-FF-000071', NULL, 'Predicted protein', 49, NULL, NULL, 153387),
(153388, '3.30.420.40-FF-000440', NULL, 'Actin', 42, NULL, NULL, 153388),
(153389, '1.10.3060.10-FF-000004', NULL, 'Protein translocase subunit SecA 1', 178, NULL, NULL, 153389),
(153390, '2.60.40.10-FF-005383', NULL, NULL, 56, NULL, NULL, 153390),
(153391, '3.80.10.10-FF-001623', NULL, 'F-box domain-containing protein', 318, NULL, NULL, 153391),
(153392, '1.10.1450.10-FF-000157', NULL, 'Leukocyte surface antigen CD53-like Protein', 80, NULL, NULL, 153392),
(153393, '3.10.110.10-FF-000086', NULL, 'Ubiquitin-conjugating enzyme E2 J1', 182, NULL, NULL, 153393),
(153394, '1.10.510.10-FF-002625', NULL, NULL, 84, NULL, NULL, 153394),
(153395, '2.40.70.10-FF-000523', NULL, NULL, 45, NULL, NULL, 153395),
(153396, '3.30.70.1130-FF-000013', NULL, 'Predicted protein', 41, NULL, NULL, 153396),
(153397, '3.50.50.60-FF-001439', NULL, 'Uncharacterized protein', 103, NULL, NULL, 153397),
(153398, '1.20.1260.10-FF-000034', NULL, 'Ferritin', 108, NULL, NULL, 153398),
(153399, '3.30.40.10-FF-001296', NULL, 'E3 ubiquitin-protein ligase RNF167', 77, NULL, NULL, 153399),
(153400, '2.130.10.30-FF-000050', NULL, 'HECT and RLD domain containing E3 ubiquitin protein ligase family member 6', 166, NULL, NULL, 153400),
(153401, '3.10.350.10-FF-000008', NULL, 'Murein hydrolase activator NlpD', 58, NULL, NULL, 153401),
(153402, '2.130.10.10-FF-001544', NULL, 'Elongator complex protein 2', 90, NULL, NULL, 153402),
(153403, '1.10.630.10-FF-000543', NULL, 'Uncharacterized protein', 354, NULL, NULL, 153403),
(153404, '3.40.1190.20-FF-000070', NULL, 'Putative pyridoxal kinase C6F6.11c', 340, NULL, NULL, 153404),
(153405, '3.30.9.10-FF-000088', NULL, 'Hydrogen cyanide synthase HcnC', 145, NULL, NULL, 153405),
(153406, '1.10.238.10-FF-000463', NULL, 'Protein CBG14543', 71, NULL, NULL, 153406),
(153407, '3.40.50.2000-FF-000345', NULL, 'Sucrose synthase 3', 93, NULL, NULL, 153407);
INSERT INTO "PUBLIC"."MODEL" VALUES
(153408, '3.30.60.190-FF-000009', NULL, 'Uncharacterized zinc-finger protein C4F10.19c', 50, NULL, NULL, 153408),
(153409, '2.60.40.60-FF-000614', NULL, 'Uncharacterized protein', 80, NULL, NULL, 153409),
(153410, '1.20.1270.10-FF-000080', NULL, '105/110 kDa heat shock protein, nucleotide-binding domain', 110, NULL, NULL, 153410),
(153411, '2.60.220.30-FF-000031', NULL, 'Uncharacterized protein', 85, NULL, NULL, 153411),
(153412, '3.40.50.2300-FF-000862', NULL, 'Uncharacterized protein', 177, NULL, NULL, 153412),
(153413, '3.90.550.10-FF-000270', NULL, 'Rhamnosyltransferase 2', 203, NULL, NULL, 153413),
(153414, '3.30.200.20-FF-001199', NULL, 'Protein kinase, putative', 23, NULL, NULL, 153414),
(153415, '2.130.10.10-FF-000717', NULL, 'Cilia- and flagella-associated protein 43', 131, NULL, NULL, 153415),
(153416, '3.30.70.330-FF-000019', NULL, 'heterogeneous nuclear ribonucleoproteins C1/C2 isoform X1', 105, NULL, NULL, 153416),
(153417, '3.40.50.300-FF-001050', NULL, 'ATP-dependent DNA helicase DDX11', 249, NULL, NULL, 153417),
(153418, '3.40.1110.10-FF-000039', NULL, 'Sodium P-type ATPase', 240, NULL, NULL, 153418),
(153419, '1.10.238.260-FF-000001', NULL, '2-isopropylmalate synthase', 114, NULL, NULL, 153419),
(153420, '1.10.3810.10-FF-000023', NULL, 'Penicillin-binding protein 1A (PBP-1a)', 206, NULL, NULL, 153420),
(153421, '2.102.10.10-FF-000051', NULL, 'Gll1923 protein', 100, NULL, NULL, 153421),
(153422, '3.40.50.12780-FF-000059', NULL, 'Coronamic acid synthetase CmaA', 398, NULL, NULL, 153422),
(153423, '2.60.120.260-FF-000330', NULL, 'Endoprotease aex-5', 121, NULL, NULL, 153423),
(153424, '2.130.10.10-FF-001645', NULL, 'Katanin p80 WD40 repeat-containing subunit B1', 93, NULL, NULL, 153424),
(153425, '1.10.30.10-FF-000053', NULL, 'Protein CRABS CLAW', 70, NULL, NULL, 153425),
(153426, '3.30.40.10-FF-000913', NULL, 'Non-specific serine/threonine protein kinase', 71, NULL, NULL, 153426),
(153427, '3.30.230.70-FF-000153', NULL, 'Uncharacterized protein', 78, NULL, NULL, 153427),
(153428, '3.40.50.150-FF-001191', NULL, NULL, 156, NULL, NULL, 153428),
(153429, '3.30.160.60-FF-002089', NULL, 'Zinc finger protein 629', 27, NULL, NULL, 153429),
(153430, '3.30.160.540-FF-000001', NULL, 'Probable septum site-determining protein MinC', 81, NULL, NULL, 153430),
(153431, '2.30.42.10-FF-000364', NULL, 'Tail-specific protease', 106, NULL, NULL, 153431),
(153432, '2.60.120.290-FF-000182', NULL, 'Adhesion G protein-coupled receptor L3', 111, NULL, NULL, 153432),
(153433, '3.50.50.60-FF-000714', NULL, 'NAD(P)-binding Rossmann-like domain protein', 98, NULL, NULL, 153433),
(153434, '3.40.630.10-FF-000427', NULL, 'Nicalin', 281, NULL, NULL, 153434),
(153435, '3.40.50.11850-FF-000005', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', 50, NULL, NULL, 153435),
(153436, '2.60.220.50-FF-000037', NULL, 'Adhesion G protein-coupled receptor E15', 179, NULL, NULL, 153436),
(153437, '2.40.37.10-FF-000082', NULL, NULL, 86, NULL, NULL, 153437),
(153438, '3.40.50.2300-FF-000553', NULL, 'Response regulator', 162, NULL, NULL, 153438),
(153439, '1.10.1130.10-FF-000009', NULL, 'Nitrite reductase (cytochrome; ammonia-forming)', 322, NULL, NULL, 153439),
(153440, '3.30.160.60-FF-003270', NULL, NULL, 29, NULL, NULL, 153440),
(153441, '2.130.10.10-FF-004315', NULL, 'Uncharacterized protein', 109, NULL, NULL, 153441),
(153442, '3.90.180.10-FF-000078', NULL, 'Quinone oxidoreductase', 163, NULL, NULL, 153442),
(153443, '3.30.450.20-FF-000391', NULL, 'Two-component oxygen-sensor histidine kinase', 56, NULL, NULL, 153443),
(153444, '1.10.238.10-FF-000154', NULL, 'Reticulocalbin 3', 124, NULL, NULL, 153444),
(153445, '3.30.479.30-FF-000004', NULL, 'Putative membrane protease family, stomatin', 112, NULL, NULL, 153445),
(153446, '3.40.50.12230-FF-000018', NULL, 'Methionyl-tRNA formyltransferase', 327, NULL, NULL, 153446),
(153447, '3.40.50.1100-FF-000283', NULL, 'Uncharacterized protein', 39, NULL, NULL, 153447),
(153448, '1.10.510.10-FF-002316', NULL, NULL, 217, NULL, NULL, 153448),
(153449, '3.40.50.620-FF-000729', NULL, 'Uncharacterized protein', 188, NULL, NULL, 153449);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(153450, '3.30.160.60-FF-004343', NULL, NULL, 20, NULL, NULL, 153450),
(153451, '3.40.50.150-FF-000925', NULL, NULL, 227, NULL, NULL, 153451),
(153452, '1.10.510.10-FF-001552', NULL, 'Uncharacterized protein', 174, NULL, NULL, 153452),
(153453, '3.30.1370.210-FF-000004', NULL, 'Muscleblind like splicing regulator 1', 85, NULL, NULL, 153453),
(153454, '3.40.50.1760-FF-000014', NULL, NULL, 125, NULL, NULL, 153454),
(153455, '1.20.870.10-FF-000047', NULL, 'Uncharacterized protein', 141, NULL, NULL, 153455),
(153456, '3.30.1150.10-FF-000027', NULL, NULL, 93, NULL, NULL, 153456),
(153457, '1.20.1070.10-FF-000351', NULL, 'Octopamine receptor Oamb', 185, NULL, NULL, 153457),
(153458, '3.30.1370.10-FF-000190', NULL, 'KH domain-containing, RNA-binding, signal transduction-associated protein 3', 205, NULL, NULL, 153458),
(153459, '1.20.1070.10-FF-000013', NULL, 'Olfactory receptor', 290, NULL, NULL, 153459),
(153460, '3.10.430.100-FF-000003', NULL, '50S ribosomal protein L9', 92, NULL, NULL, 153460),
(153461, '3.40.50.300-FF-000898', NULL, 'ADP-ribosylation factor-like protein 11', 175, NULL, NULL, 153461),
(153462, '3.30.530.20-FF-000083', NULL, 'Uncharacterized protein MT0096', 147, NULL, NULL, 153462),
(153463, '2.20.25.30-FF-000004', NULL, 'Ribosomal protein L37', 83, NULL, NULL, 153463),
(153464, '1.10.1450.10-FF-000056', NULL, 'Tetraspanin', 88, NULL, NULL, 153464),
(153465, '1.10.472.10-FF-000714', NULL, 'Cyclin-A1-1', 20, NULL, NULL, 153465),
(153466, '3.30.200.20-FF-000474', NULL, 'Serine/threonine-protein kinase N2-like', 93, NULL, NULL, 153466),
(153467, '2.40.50.100-FF-000128', NULL, 'ABC transporter ATP-binding protein', 63, NULL, NULL, 153467),
(153468, '3.30.50.10-FF-000178', NULL, 'Nuclear receptor subfamily 2, group F, member 6b', 62, NULL, NULL, 153468),
(153469, '1.10.287.110-FF-000382', NULL, 'Predicted protein', 67, NULL, NULL, 153469),
(153470, '2.130.10.10-FF-001336', NULL, 'LisH protein', 294, NULL, NULL, 153470),
(153471, '3.30.160.60-FF-000509', NULL, 'zinc finger protein with KRAB and SCAN domains 5', 29, NULL, NULL, 153471),
(153472, '1.10.630.10-FF-000335', NULL, 'CYtochrome P450 family', 212, NULL, NULL, 153472),
(153473, '2.60.210.10-FF-000002', NULL, 'E3 ubiquitin-protein ligase', 133, NULL, NULL, 153473),
(153474, '1.10.238.10-FF-000890', NULL, 'ubiquitin carboxyl-terminal hydrolase 32', 162, NULL, NULL, 153474),
(153475, '2.60.120.310-FF-000008', NULL, 'Probable peptidyl-glycine alpha-amidating monooxygenase pamn-1', 147, NULL, NULL, 153475),
(153476, '2.60.40.10-FF-002185', NULL, 'Uncharacterized protein, isoform H', 104, NULL, NULL, 153476),
(153477, '3.40.20.10-FF-000052', NULL, 'Actin-binding protein', 141, NULL, NULL, 153477),
(153478, '3.40.50.970-FF-000166', NULL, 'Pyruvate dehydrogenase E1 component subunit alpha, somatic form, mitochondrial', 75, NULL, NULL, 153478),
(153479, '1.10.10.10-FF-001788', NULL, 'ATP-dependent DNA helicase', 108, NULL, NULL, 153479),
(153480, '1.20.272.10-FF-000017', NULL, 'DNA polymerase III subunit delta', 118, NULL, NULL, 153480),
(153481, '1.10.287.130-FF-000174', NULL, 'Sensory box histidine kinase', 84, NULL, NULL, 153481),
(153482, '3.30.70.330-FF-002375', NULL, NULL, 102, NULL, NULL, 153482),
(153483, '3.90.320.10-FF-000067', NULL, 'DNA replication helicase DNA2, putative', 165, NULL, NULL, 153483),
(153484, '2.10.110.10-FF-000213', NULL, 'Four and a half LIM domains protein 2', 44, NULL, NULL, 153484),
(153485, '3.40.50.300-FF-007255', NULL, 'ABC transporter, putative', 158, NULL, NULL, 153485),
(153486, '2.70.98.90-FF-000008', NULL, 'Membrane protein insertase YidC', 296, NULL, NULL, 153486),
(153487, '1.10.238.20-FF-000011', NULL, 'Odorant-binding protein 56c, isoform C', 95, NULL, NULL, 153487),
(153488, '3.90.70.10-FF-000339', NULL, 'Os09g0565000 protein', 273, NULL, NULL, 153488),
(153489, '1.25.40.20-FF-001080', NULL, 'Kinase, NEK', 117, NULL, NULL, 153489),
(153490, '2.60.40.10-FF-001212', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', 106, NULL, NULL, 153490),
(153491, '3.30.70.330-FF-002037', NULL, NULL, 131, NULL, NULL, 153491); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(153492, '1.25.40.10-FF-001543', NULL, 'Pentatricopeptide repeat-containing protein At1g32415, mitochondrial', 100, NULL, NULL, 153492),
(153493, '2.60.40.10-FF-004646', NULL, NULL, 101, NULL, NULL, 153493),
(153494, '3.30.200.20-FF-000108', NULL, 'Serine/threonine-protein kinase Nek2', 83, NULL, NULL, 153494),
(153495, '1.25.10.10-FF-003076', NULL, 'Uncharacterized protein', 242, NULL, NULL, 153495),
(153496, '3.40.50.2300-FF-001379', NULL, NULL, 175, NULL, NULL, 153496),
(153497, '2.10.25.10-FF-001286', NULL, 'Vasorin', 79, NULL, NULL, 153497),
(153498, '1.20.1560.10-FF-000079', NULL, 'ABC transporter ATP-binding protein', 336, NULL, NULL, 153498),
(153499, '3.20.20.70-FF-000666', NULL, NULL, 222, NULL, NULL, 153499),
(153500, '3.30.200.20-FF-000783', NULL, 'RGD1307355 protein', 91, NULL, NULL, 153500),
(153501, '3.40.140.10-FF-000098', NULL, 'Cytidine deaminase', 174, NULL, NULL, 153501),
(153502, '1.10.220.150-FF-000057', NULL, 'Uncharacterized protein', 131, NULL, NULL, 153502),
(153503, '2.10.25.10-FF-001387', NULL, 'von Willebrand factor D and EGF domains', 30, NULL, NULL, 153503),
(153504, '3.30.1370.10-FF-000201', NULL, 'Protein CBR-NUO-2', 83, NULL, NULL, 153504),
(153505, '3.30.1490.40-FF-000016', NULL, NULL, 65, NULL, NULL, 153505),
(153506, '1.20.1730.10-FF-000008', NULL, 'High affinity choline transporter 1', 475, NULL, NULL, 153506),
(153507, '3.40.50.12100-FF-000007', NULL, 'Uncharacterized protein', 144, NULL, NULL, 153507),
(153508, '2.60.40.1530-FF-000014', NULL, 'Integrin alpha 2b', 179, NULL, NULL, 153508),
(153509, '1.20.245.10-FF-000005', NULL, 'Arachidonate 12-lipoxygenase', 149, NULL, NULL, 153509),
(153510, '3.90.1720.10-FF-000029', NULL, 'ALdehyde deHydrogenase', 185, NULL, NULL, 153510),
(153511, '1.20.5.1190-FF-000011', NULL, 'Sodium channel protein', 27, NULL, NULL, 153511),
(153512, '3.10.50.10-FF-000021', NULL, 'Chitinase, putative', 49, NULL, NULL, 153512),
(153513, '2.40.50.140-FF-000342', NULL, 'RNA polymerase A', 82, NULL, NULL, 153513),
(153514, '1.25.40.10-FF-004769', NULL, 'Anaphase-promoting complex subunit 6', 305, NULL, NULL, 153514),
(153515, '3.90.640.10-FF-000142', NULL, 'Actin, putative', 127, NULL, NULL, 153515),
(153516, '1.10.730.10-FF-000135', NULL, 'Methionine--tRNA ligase', 182, NULL, NULL, 153516),
(153517, '1.10.196.10-FF-000005', NULL, 'Axin 1', 20, NULL, NULL, 153517),
(153518, '2.30.42.10-FF-000465', NULL, NULL, 91, NULL, NULL, 153518),
(153519, '1.20.5.320-FF-000022', NULL, 'Collagen, type XVII, alpha 1b', 46, NULL, NULL, 153519),
(153520, '1.25.40.10-FF-002869', NULL, 'Protein O-mannosyl-transferase TMTC1', 57, NULL, NULL, 153520),
(153521, '3.40.50.300-FF-006749', NULL, 'Uncharacterized protein', 67, NULL, NULL, 153521),
(153522, '1.20.1050.60-FF-000004', NULL, 'Putative alpha-1,2-mannosidase', 94, NULL, NULL, 153522),
(153523, '2.30.40.10-FF-000174', NULL, 'Deacetylase Oant_2987', 108, NULL, NULL, 153523),
(153524, '3.40.390.10-FF-000066', NULL, 'Metalloendopeptidase', 232, NULL, NULL, 153524),
(153525, '3.90.660.10-FF-000008', NULL, 'Spermine oxidase', 238, NULL, NULL, 153525),
(153526, '1.10.287.2230-FF-000001', NULL, 'Structural polyprotein', 68, NULL, NULL, 153526),
(153527, '3.40.50.720-FF-002558', NULL, 'Inositol-3-phosphate synthase isozyme 1', 49, NULL, NULL, 153527),
(153528, '3.40.50.300-FF-007210', NULL, 'Uncharacterized protein', 165, NULL, NULL, 153528),
(153529, '3.30.230.130-FF-000069', NULL, 'Cullin homolog 1-like Protein', 155, NULL, NULL, 153529),
(153530, '3.40.50.300-FF-004804', NULL, '6-phosphofructo-2-kinase/fructose-2, 6-bisphosphatase', 209, NULL, NULL, 153530),
(153531, '1.25.40.10-FF-001588', NULL, 'Cell division cycle 27, isoform A', 170, NULL, NULL, 153531),
(153532, '3.10.110.10-FF-000013', NULL, 'SUMO-conjugating enzyme UBC9', 157, NULL, NULL, 153532),
(153533, '1.25.40.770-FF-000007', NULL, 'Chromosome 10, whole genome shotgun sequence', 210, NULL, NULL, 153533),
(153534, '3.50.50.60-FF-000922', NULL, 'IP11909p', 127, NULL, NULL, 153534),
(153535, '3.40.50.1820-FF-000509', NULL, 'lipase member H', 296, NULL, NULL, 153535);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(153536, '3.30.190.20-FF-000011', NULL, '50S ribosomal protein L1', 111, NULL, NULL, 153536),
(153537, '1.20.58.1970-FF-000009', NULL, 'Exocyst complex component sec10', 163, NULL, NULL, 153537),
(153538, '3.30.160.60-FF-002297', NULL, 'Zinc finger protein 85', 26, NULL, NULL, 153538),
(153539, '2.60.40.10-FF-004910', NULL, NULL, 112, NULL, NULL, 153539),
(153540, '2.170.130.10-FF-000031', NULL, 'TonB-linked outer membrane protein SusC/RagA family', 153, NULL, NULL, 153540),
(153541, '2.130.10.10-FF-002264', NULL, 'Guanine nucleotide-binding protein beta subunit, putative', 310, NULL, NULL, 153541),
(153542, '2.60.40.10-FF-002769', NULL, 'Coagulation factor III, tissue factor', 78, NULL, NULL, 153542),
(153543, '3.40.50.2300-FF-000345', NULL, 'Guanylate cyclase', 102, NULL, NULL, 153543),
(153544, '1.20.5.340-FF-000028', NULL, 'rab GTPase-binding effector protein 2 isoform X1', 88, NULL, NULL, 153544),
(153545, '3.30.160.60-FF-002409', NULL, 'Crooked legs, isoform F', 30, NULL, NULL, 153545),
(153546, '2.60.120.200-FF-000464', NULL, 'Uncharacterized protein', 167, NULL, NULL, 153546),
(153547, '3.30.40.10-FF-001649', NULL, 'Uncharacterized protein', 79, NULL, NULL, 153547),
(153548, '3.40.50.1360-FF-000001', NULL, 'Ribose-5-phosphate isomerase A', 135, NULL, NULL, 153548),
(153549, '1.20.1460.10-FF-000015', NULL, 'V-type proton ATPase subunit C', 99, NULL, NULL, 153549),
(153550, '3.10.20.90-FF-000976', NULL, 'Uncharacterized protein', 100, NULL, NULL, 153550),
(153551, '1.10.287.2250-FF-000007', NULL, 'P34 probable thiol protease', 79, NULL, NULL, 153551),
(153552, '1.20.58.60-FF-000850', NULL, 'Uncharacterized protein', 304, NULL, NULL, 153552),
(153553, '1.10.10.10-FF-000254', NULL, 'Two-component system response regulator CreB', 100, NULL, NULL, 153553),
(153554, '3.90.1750.10-FF-000065', NULL, 'HECT-domain ubiquitin--protein ligase E3', 123, NULL, NULL, 153554),
(153555, '2.80.10.50-FF-000165', NULL, 'YALI0D10549p', 207, NULL, NULL, 153555),
(153556, '3.30.200.20-FF-000682', NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', 106, NULL, NULL, 153556),
(153557, '3.80.10.10-FF-003332', NULL, 'Uncharacterized protein', 124, NULL, NULL, 153557),
(153558, '2.30.29.30-FF-000378', NULL, 'Uncharacterized protein, isoform A', 130, NULL, NULL, 153558),
(153559, '3.40.50.720-FF-001069', NULL, 'Uncharacterized protein', 326, NULL, NULL, 153559),
(153560, '3.30.70.330-FF-001211', NULL, 'Heterogeneous nuclear ribonucleoprotein', 119, NULL, NULL, 153560),
(153561, '1.20.1070.10-FF-001177', NULL, 'Neuropeptide Y receptor type 1', 367, NULL, NULL, 153561),
(153562, '2.130.10.10-FF-006007', NULL, 'Predicted protein', 245, NULL, NULL, 153562),
(153563, '3.40.850.10-FF-000293', NULL, 'Kinesin-like protein', 363, NULL, NULL, 153563),
(153564, '1.10.220.150-FF-000012', NULL, 'ADP-ribosylation factor GTPase-activating protein AGD10', 137, NULL, NULL, 153564),
(153565, '1.10.510.10-FF-003244', NULL, NULL, 118, NULL, NULL, 153565),
(153566, '3.90.226.10-FF-000342', NULL, 'Enoyl-CoA hydratase', 207, NULL, NULL, 153566),
(153567, '3.40.850.10-FF-000101', NULL, 'Slow myosin heavy chain 2', 98, NULL, NULL, 153567),
(153568, '1.20.1540.10-FF-000117', NULL, 'Predicted protein', 200, NULL, NULL, 153568),
(153569, '3.40.50.10880-FF-000012', NULL, NULL, 116, NULL, NULL, 153569),
(153570, '3.10.20.870-FF-000013', NULL, NULL, 77, NULL, NULL, 153570),
(153571, '2.170.140.10-FF-000060', NULL, 'Major mite allergen Der p 23', 53, NULL, NULL, 153571),
(153572, '3.40.630.30-FF-000321', NULL, 'N-acetyltransferase', 90, NULL, NULL, 153572),
(153573, '3.40.50.970-FF-000019', NULL, 'Pyruvate decarboxylase isozyme', 186, NULL, NULL, 153573),
(153574, '1.10.510.10-FF-001344', NULL, 'Uncharacterized protein', 347, NULL, NULL, 153574),
(153575, '3.40.50.300-FF-000089', NULL, 'Eukaryotic initiation factor 4A-II', 220, NULL, NULL, 153575),
(153576, '3.40.630.10-FF-000326', NULL, 'Glutamate carboxypeptidase, putative', 127, NULL, NULL, 153576),
(153577, '1.20.1420.30-FF-000047', NULL, 'Probable sodium/calcium exchanger antiporter', 137, NULL, NULL, 153577);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(153578, '1.10.8.60-FF-000032', NULL, 'Replication factor C subunit 4', 65, NULL, NULL, 153578),
(153579, '2.30.29.30-FF-000642', NULL, 'Regulator of G-protein signaling loco', 155, NULL, NULL, 153579),
(153580, '3.60.20.10-FF-000107', NULL, 'Probable proteasome subunit beta type-5', 160, NULL, NULL, 153580),
(153581, '3.40.50.150-FF-001853', NULL, NULL, 26, NULL, NULL, 153581),
(153582, '3.40.50.80-FF-000102', NULL, 'Putative reductase', 126, NULL, NULL, 153582),
(153583, '1.10.3380.10-FF-000051', NULL, 'Uncharacterized protein', 151, NULL, NULL, 153583),
(153584, '3.30.200.20-FF-001300', NULL, 'Ephrin receptor like protein', 87, NULL, NULL, 153584),
(153585, '1.10.8.60-FF-000296', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 84, NULL, NULL, 153585),
(153586, '3.90.70.10-FF-000839', NULL, 'Uncharacterized protein', 131, NULL, NULL, 153586),
(153587, '3.60.10.10-FF-000022', NULL, 'type I inositol 1,4,5-trisphosphate 5-phosphatase', 363, NULL, NULL, 153587),
(153588, '3.40.50.720-FF-000804', NULL, 'UDP-galactopyranose mutase', 116, NULL, NULL, 153588),
(153589, '1.20.1600.10-FF-000004', NULL, 'Outer membrane efflux protein', 413, NULL, NULL, 153589),
(153590, '3.80.10.10-FF-001387', NULL, 'Similarity to receptor-like protein kinase', 261, NULL, NULL, 153590),
(153591, '3.30.40.10-FF-000368', NULL, 'Lysine demethylase 5A', 63, NULL, NULL, 153591),
(153592, '3.20.70.20-FF-000031', NULL, 'Vitamin B12-dependent ribonucleotide reductase', 644, NULL, NULL, 153592),
(153593, '3.40.50.1440-FF-000036', NULL, 'Tubulin alpha chain', 61, NULL, NULL, 153593),
(153594, '3.30.470.110-FF-000004', NULL, 'ATP-citrate synthase', 236, NULL, NULL, 153594),
(153595, '3.90.70.10-FF-000682', NULL, 'Uncharacterized protein', 254, NULL, NULL, 153595),
(153596, '3.90.199.10-FF-000008', NULL, 'DNA topoisomerase (ATP-hydrolyzing)', 182, NULL, NULL, 153596),
(153597, '1.10.287.1150-FF-000020', NULL, 'Probable 2-oxoglutarate dehydrogenase E1 component DHKTD1 homolog, mitochondrial', 81, NULL, NULL, 153597),
(153598, '3.40.20.10-FF-000153', NULL, 'Cofilin-4', 135, NULL, NULL, 153598),
(153599, '2.60.120.620-FF-000129', NULL, 'Predicted protein', 62, NULL, NULL, 153599),
(153600, '3.30.160.60-FF-004551', NULL, NULL, 35, NULL, NULL, 153600),
(153601, '1.10.238.10-FF-001082', NULL, 'Defective in cullin neddylation protein', 111, NULL, NULL, 153601),
(153602, '1.10.1520.10-FF-000023', NULL, 'Endoribonuclease dcr-1', 178, NULL, NULL, 153602),
(153603, '1.10.10.10-FF-001007', NULL, 'Uncharacterized protein', 74, NULL, NULL, 153603),
(153604, '1.25.40.570-FF-000071', NULL, 'Uncharacterized protein', 359, NULL, NULL, 153604),
(153605, '1.10.510.10-FF-004469', NULL, NULL, 271, NULL, NULL, 153605),
(153606, '3.40.640.10-FF-000355', NULL, 'Cystathionine synthase/lyase (Cystathionine gamma-synthase, cystathionine gamma-lyase, cystathionine beta-lyase)', 263, NULL, NULL, 153606),
(153607, '3.30.160.60-FF-000397', NULL, 'Metal regulatory transcription factor 1', 42, NULL, NULL, 153607),
(153608, '1.20.1560.10-FF-000888', NULL, 'Uncharacterized protein', 114, NULL, NULL, 153608),
(153609, '3.30.40.10-FF-001796', NULL, 'Protein CBG15934', 51, NULL, NULL, 153609),
(153610, '1.20.1250.20-FF-000070', NULL, 'Solute carrier family 22 member 5', 409, NULL, NULL, 153610),
(153611, '4.10.60.10-FF-000244', NULL, 'RNA-binding region RNP-1 domain-containing protein', 34, NULL, NULL, 153611),
(153612, '3.40.630.10-FF-000074', NULL, 'Peptide hydrolase', 338, NULL, NULL, 153612),
(153613, '1.20.1420.10-FF-000041', NULL, NULL, 108, NULL, NULL, 153613),
(153614, '2.130.10.10-FF-004107', NULL, 'Uncharacterized protein', 192, NULL, NULL, 153614),
(153615, '1.25.40.10-FF-000924', NULL, 'Pentatricopeptide repeat-containing protein At4g39620, chloroplastic', 175, NULL, NULL, 153615),
(153616, '3.40.50.410-FF-000122', NULL, 'Mesocentin', 193, NULL, NULL, 153616),
(153617, '2.160.10.10-FF-000121', NULL, 'Polysialic acid O-acetyltransferase', 215, NULL, NULL, 153617),
(153618, '3.80.10.10-FF-002713', NULL, 'PXY', 105, NULL, NULL, 153618);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(153619, '2.60.120.330-FF-000003', NULL, 'Gibberellin 20 oxidase 2', 331, NULL, NULL, 153619),
(153620, '3.30.1360.180-FF-000004', NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase family member 4', 100, NULL, NULL, 153620),
(153621, '3.40.50.300-FF-003315', NULL, 'Small GTPase EhRabX8, putative', 202, NULL, NULL, 153621),
(153622, '2.40.50.140-FF-000556', NULL, 'GEO08380p1', 110, NULL, NULL, 153622),
(153623, '3.80.10.10-FF-000651', NULL, 'F-box/LRR-repeat protein 4', 252, NULL, NULL, 153623),
(153624, '3.30.505.10-FF-000139', NULL, 'Tyrosine-protein kinase', 122, NULL, NULL, 153624),
(153625, '3.30.70.330-FF-000694', NULL, 'RNA-binding protein, putative', 180, NULL, NULL, 153625),
(153626, '1.20.120.1880-FF-000001', NULL, 'Nuclear pore complex protein Nup155', 221, NULL, NULL, 153626),
(153627, '3.40.50.10810-FF-000261', NULL, 'Uncharacterized protein', 273, NULL, NULL, 153627),
(153628, '1.20.1250.20-FF-001508', NULL, 'Solute carrier organic anion transporter family member', 220, NULL, NULL, 153628),
(153629, '1.20.5.110-FF-000206', NULL, 'Uncharacterized protein', 99, NULL, NULL, 153629),
(153630, '3.40.50.150-FF-000572', NULL, 'CLL-associated antigen KW-2, putative', 207, NULL, NULL, 153630),
(153631, '3.40.50.1480-FF-000008', NULL, 'Adenosylhomocysteinase', 243, NULL, NULL, 153631),
(153632, '1.10.8.270-FF-000026', NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', 106, NULL, NULL, 153632),
(153633, '3.30.160.60-FF-001780', NULL, 'zinc finger protein 420 isoform X1', 48, NULL, NULL, 153633),
(153634, '1.20.1050.10-FF-000097', NULL, 'Glutathione S-transferase U20', 59, NULL, NULL, 153634),
(153635, '2.170.270.10-FF-000064', NULL, 'SET_domain_containing_protein_-_putative', 109, NULL, NULL, 153635),
(153636, '1.10.10.60-FF-000353', NULL, 'Transcription factor WER', 72, NULL, NULL, 153636),
(153637, '3.60.130.10-FF-000082', NULL, 'Predicted protein', 142, NULL, NULL, 153637),
(153638, '1.10.30.10-FF-000154', NULL, 'Predicted protein', 77, NULL, NULL, 153638),
(153639, '3.30.160.60-FF-000852', NULL, 'zinc finger protein 629 isoform X2', 28, NULL, NULL, 153639),
(153640, '2.130.10.10-FF-005698', NULL, 'Predicted protein', 150, NULL, NULL, 153640),
(153641, '2.130.10.10-FF-003798', NULL, 'Uncharacterized protein', 311, NULL, NULL, 153641),
(153642, '2.60.120.10-FF-000692', NULL, 'Uncharacterized protein', 65, NULL, NULL, 153642),
(153643, '3.30.710.10-FF-000291', NULL, 'Ankyrin repeat and BTB/POZ domain-containing protein 1', 129, NULL, NULL, 153643),
(153644, '3.40.1120.10-FF-000012', NULL, NULL, 107, NULL, NULL, 153644),
(153645, '1.10.10.10-FF-001316', NULL, 'Uncharacterized protein', 88, NULL, NULL, 153645),
(153646, '2.30.30.30-FF-000140', NULL, '60S ribosomal protein L14', 88, NULL, NULL, 153646),
(153647, '3.30.420.210-FF-000007', NULL, 'UBX domain protein 2B', 53, NULL, NULL, 153647),
(153648, '3.30.160.60-FF-006451', NULL, NULL, 24, NULL, NULL, 153648),
(153649, '3.30.60.10-FF-000004', NULL, 'Endochitinase At2g43590', 39, NULL, NULL, 153649),
(153650, '2.60.40.10-FF-003365', NULL, 'Uncharacterized protein', 125, NULL, NULL, 153650),
(153651, '3.40.50.10490-FF-000018', NULL, 'Glucose-6-phosphate isomerase', 195, NULL, NULL, 153651),
(153652, '1.20.1720.10-FF-000070', NULL, 'MFS transporter', 416, NULL, NULL, 153652),
(153653, '1.10.3520.10-FF-000040', NULL, 'Uncharacterized protein', 49, NULL, NULL, 153653),
(153654, '2.70.70.10-FF-000039', NULL, 'Membrane-bound metalloendopeptidase', 148, NULL, NULL, 153654),
(153655, '3.90.1150.10-FF-000429', NULL, 'Uncharacterized protein', 53, NULL, NULL, 153655),
(153656, '2.60.120.650-FF-000222', NULL, 'Multicopy suppressor of chk1 protein 1', 197, NULL, NULL, 153656),
(153657, '3.40.50.1820-FF-000257', NULL, 'Uncharacterized protein, isoform A', 206, NULL, NULL, 153657),
(153658, '3.40.50.150-FF-000263', NULL, 'Putative methyltransferase', 210, NULL, NULL, 153658),
(153659, '2.170.300.10-FF-000062', NULL, 'Uncharacterized protein', 125, NULL, NULL, 153659),
(153660, '3.30.230.10-FF-000051', NULL, '30S ribosomal protein S9', 134, NULL, NULL, 153660);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(153661, '1.20.1280.50-FF-000159', NULL, 'F-box and leucine rich repeat protein 18', 76, NULL, NULL, 153661),
(153662, '3.80.10.10-FF-000342', NULL, 'Leucine rich repeat containing 47', 242, NULL, NULL, 153662),
(153663, '3.90.79.10-FF-000230', NULL, 'Uncharacterized protein', 87, NULL, NULL, 153663),
(153664, '3.40.50.140-FF-000018', NULL, 'DNA topoisomerase', 135, NULL, NULL, 153664),
(153665, '3.30.540.10-FF-000052', NULL, 'Inositol-1-monophosphatase', 145, NULL, NULL, 153665),
(153666, '2.130.10.10-FF-003489', NULL, 'Uncharacterized protein', 284, NULL, NULL, 153666),
(153667, '3.30.160.60-FF-005523', NULL, NULL, 24, NULL, NULL, 153667),
(153668, '3.40.1090.10-FF-000014', NULL, 'Patatin like phospholipase domain containing 1', 81, NULL, NULL, 153668),
(153669, '2.130.10.10-FF-005035', NULL, 'Uncharacterized protein', 299, NULL, NULL, 153669),
(153670, '1.10.10.60-FF-000044', NULL, 'chromodomain-helicase-DNA-binding protein 9 isoform X1', 123, NULL, NULL, 153670),
(153671, '2.130.10.10-FF-002825', NULL, 'Uncharacterized protein', 119, NULL, NULL, 153671),
(153672, '3.40.640.10-FF-000400', NULL, 'Ornithine aminotransferase', 22, NULL, NULL, 153672),
(153673, '3.40.30.10-FF-000081', NULL, 'phosducin-like protein 3', 134, NULL, NULL, 153673),
(153674, '1.25.40.10-FF-003488', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 79, NULL, NULL, 153674),
(153675, '2.60.40.2160-FF-000006', NULL, 'Interleukin cytokine receptor-related protein 1', 162, NULL, NULL, 153675),
(153676, '2.30.30.40-FF-000452', NULL, 'Tyrosine-protein kinase', 44, NULL, NULL, 153676),
(153677, '3.30.9.10-FF-000043', NULL, 'FAD-dependent oxidoreductase family protein', 155, NULL, NULL, 153677),
(153678, '1.20.58.60-FF-000142', NULL, 'Envoplakin like', 107, NULL, NULL, 153678),
(153679, '3.40.50.300-FF-005310', NULL, 'Uncharacterized protein', 168, NULL, NULL, 153679),
(153680, '3.90.530.10-FF-000004', NULL, 'DNA repair protein RAD14', 110, NULL, NULL, 153680),
(153681, '3.90.650.10-FF-000070', NULL, 'Uncharacterized protein', 173, NULL, NULL, 153681),
(153682, '2.60.40.150-FF-000659', NULL, 'Predicted protein', 95, NULL, NULL, 153682),
(153683, '2.130.10.10-FF-000925', NULL, 'Transcription factor SPT8', 210, NULL, NULL, 153683),
(153684, '3.40.50.720-FF-002249', NULL, 'Uncharacterized protein', 76, NULL, NULL, 153684),
(153685, '3.30.40.10-FF-002049', NULL, 'Uncharacterized protein', 131, NULL, NULL, 153685),
(153686, '2.120.10.80-FF-000317', NULL, 'Predicted protein', 317, NULL, NULL, 153686),
(153687, '3.90.1410.10-FF-000028', NULL, 'SET domain containing protein, putative', 256, NULL, NULL, 153687),
(153688, '1.20.5.930-FF-000008', NULL, 'Integrin subunit alpha 2', 50, NULL, NULL, 153688),
(153689, '1.20.1250.20-FF-002127', NULL, 'Os03g0286700 protein', 215, NULL, NULL, 153689),
(153690, '3.90.1300.10-FF-000037', NULL, 'Uncharacterized protein', 147, NULL, NULL, 153690),
(153691, '3.30.1370.240-FF-000002', NULL, 'phenylalanine--tRNA ligase alpha subunit', 77, NULL, NULL, 153691),
(153692, '3.30.160.60-FF-005832', NULL, NULL, 56, NULL, NULL, 153692),
(153693, '1.50.10.20-FF-000019', NULL, 'Alpha-2-macroglobulin', 268, NULL, NULL, 153693),
(153694, '3.40.50.11260-FF-000025', NULL, 'Chaperone protein HtpG', 114, NULL, NULL, 153694),
(153695, '2.130.10.10-FF-000616', NULL, 'Striatin-3 isoform B', 231, NULL, NULL, 153695),
(153696, '3.90.1140.10-FF-000035', NULL, '2'',3''-cyclic-nucleotide 3''-phosphodiesterase', 186, NULL, NULL, 153696),
(153697, '2.130.10.10-FF-000364', NULL, 'Autophagy-related protein 16-1 isoform 1', 295, NULL, NULL, 153697),
(153698, '1.25.40.10-FF-002971', NULL, 'OSM-5', 145, NULL, NULL, 153698),
(153699, '3.80.10.10-FF-001168', NULL, 'Leucine-rich repeat containing protein', 145, NULL, NULL, 153699),
(153700, '3.40.605.10-FF-000021', NULL, 'NADP-dependent glyceraldehyde-3-phosphate dehydrogenase', 242, NULL, NULL, 153700),
(153701, '3.90.70.200-FF-000006', NULL, 'Serine/threonine-protein phosphatase', 124, NULL, NULL, 153701),
(153702, '2.30.29.30-FF-000423', NULL, 'Phosphatidylinositol kinase (PIK-H1)', 100, NULL, NULL, 153702);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(153703, '4.10.1170.10-FF-000004', NULL, 'MAP kinase-activated protein kinase 3', 54, NULL, NULL, 153703),
(153704, '3.40.50.300-FF-001415', NULL, 'Polyprotein P1234', 128, NULL, NULL, 153704),
(153705, '3.30.200.20-FF-001963', NULL, 'Membrane-associated tyrosine-and threonine-specific cdc2-inhibitory kinase-like Protein', 103, NULL, NULL, 153705),
(153706, '2.120.10.70-FF-000005', NULL, 'Putative secreted neuraminidase', 155, NULL, NULL, 153706),
(153707, '1.10.10.60-FF-000605', NULL, 'Pyrroline-5-carboxylate reductase', 65, NULL, NULL, 153707),
(153708, '3.40.50.720-FF-001732', NULL, 'Putative myo-inositol phosphate synthase', 272, NULL, NULL, 153708),
(153709, '3.30.1390.20-FF-000014', NULL, '50S ribosomal protein L30', 58, NULL, NULL, 153709),
(153710, '1.20.1110.10-FF-000040', NULL, 'Na(+)-exporting P-type ATPase', 49, NULL, NULL, 153710),
(153711, '3.40.50.1000-FF-000707', NULL, NULL, 103, NULL, NULL, 153711),
(153712, '3.40.50.300-FF-003624', NULL, 'Uncharacterized ABC transporter ATP-binding protein MJ1662', 260, NULL, NULL, 153712),
(153713, '2.60.120.590-FF-000081', NULL, 'Uncharacterized protein', 206, NULL, NULL, 153713),
(153714, '2.60.120.20-FF-000032', NULL, NULL, 152, NULL, NULL, 153714),
(153715, '3.90.550.50-FF-000023', NULL, 'Hexosyltransferase', 196, NULL, NULL, 153715),
(153716, '3.30.160.60-FF-006349', NULL, NULL, 22, NULL, NULL, 153716),
(153717, '2.40.160.110-FF-000039', NULL, 'Predicted protein', 166, NULL, NULL, 153717),
(153718, '3.20.20.210-FF-000021', NULL, 'Uroporphyrinogen decarboxylase', 58, NULL, NULL, 153718),
(153719, '1.10.1220.10-FF-000011', NULL, 'Transcriptional repressor arc', 53, NULL, NULL, 153719),
(153720, '2.60.120.380-FF-000001', NULL, 'Calpain-1 catalytic subunit', 156, NULL, NULL, 153720),
(153721, '2.40.10.10-FF-000486', NULL, NULL, 218, NULL, NULL, 153721),
(153722, '3.90.226.10-FF-000117', NULL, 'Biotin carboxylase subunit of acetyl CoA carboxylase, putative', 450, NULL, NULL, 153722),
(153723, '2.60.40.10-FF-000032', NULL, 'palladin isoform X1', 100, NULL, NULL, 153723),
(153724, '3.40.50.300-FF-008430', NULL, 'Uncharacterized protein', 90, NULL, NULL, 153724),
(153725, '2.130.10.10-FF-001089', NULL, 'WD domain', 381, NULL, NULL, 153725),
(153726, '1.10.150.20-FF-000054', NULL, 'DNA repair protein RAD51 homolog', 71, NULL, NULL, 153726),
(153727, '3.40.50.12650-FF-000043', NULL, 'DNA repair metallo-beta-lactamase family protein', 119, NULL, NULL, 153727),
(153728, '3.30.200.20-FF-001755', NULL, 'Uncharacterized protein', 39, NULL, NULL, 153728),
(153729, '1.25.40.10-FF-000368', NULL, 'Sperm associated antigen 1', 170, NULL, NULL, 153729),
(153730, '3.30.40.10-FF-000340', NULL, 'RUN and FYVE domain containing 3', 74, NULL, NULL, 153730),
(153731, '3.40.630.10-FF-000349', NULL, 'Uncharacterized protein', 211, NULL, NULL, 153731),
(153732, '2.60.40.10-FF-004793', NULL, NULL, 82, NULL, NULL, 153732),
(153733, '3.40.640.10-FF-000271', NULL, 'Probable aminotransferase gliI', 252, NULL, NULL, 153733),
(153734, '3.30.70.270-FF-000182', NULL, NULL, 104, NULL, NULL, 153734),
(153735, '3.30.160.60-FF-001572', NULL, 'General transcription factor IIIA', 34, NULL, NULL, 153735),
(153736, '3.30.70.330-FF-001520', NULL, NULL, 103, NULL, NULL, 153736),
(153737, '3.30.420.10-FF-000442', NULL, NULL, 227, NULL, NULL, 153737),
(153738, '1.20.1280.290-FF-000009', NULL, 'PQ loop repeat family protein', 91, NULL, NULL, 153738),
(153739, '1.10.246.130-FF-000019', NULL, NULL, 107, NULL, NULL, 153739),
(153740, '1.10.540.10-FF-000019', NULL, 'Acyl-CoA dehydrogenase', 117, NULL, NULL, 153740),
(153741, '3.10.450.10-FF-000027', NULL, 'Cystatin cpi-2', 115, NULL, NULL, 153741),
(153742, '3.30.70.330-FF-001992', NULL, NULL, 137, NULL, NULL, 153742),
(153743, '1.25.10.10-FF-003104', NULL, 'Uncharacterized protein', 220, NULL, NULL, 153743),
(153744, '1.10.10.60-FF-000145', NULL, 'homeobox protein Hox-A2', 116, NULL, NULL, 153744),
(153745, '1.10.1200.30-FF-000004', NULL, 'Gag polyprotein', 87, NULL, NULL, 153745),
(153746, '3.30.160.60-FF-001100', NULL, 'Zinc finger protein 184', 34, NULL, NULL, 153746);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(153747, '2.40.30.10-FF-000499', NULL, 'Uncharacterized FAD-binding protein C17H9.12c', 98, NULL, NULL, 153747),
(153748, '1.20.1740.10-FF-000205', NULL, 'Uncharacterized protein', 150, NULL, NULL, 153748),
(153749, '3.30.260.10-FF-000093', NULL, NULL, 92, NULL, NULL, 153749),
(153750, '3.40.50.12240-FF-000010', NULL, 'Uncharacterized protein', 63, NULL, NULL, 153750),
(153751, '1.10.287.70-FF-000178', NULL, 'Ion transporter', 100, NULL, NULL, 153751),
(153752, '1.20.5.170-FF-000180', NULL, 'C-type lectin domain family 4 member F', 37, NULL, NULL, 153752),
(153753, '2.60.34.10-FF-000091', NULL, 'Luminal binding protein', 154, NULL, NULL, 153753),
(153754, '1.10.510.10-FF-002069', NULL, 'Protein_kinase_-_putative', 205, NULL, NULL, 153754),
(153755, '2.170.130.10-FF-000054', NULL, NULL, 131, NULL, NULL, 153755),
(153756, '1.10.150.900-FF-000001', NULL, 'Aminoacylase-1, putative', 81, NULL, NULL, 153756),
(153757, '3.10.450.40-FF-000042', NULL, NULL, 104, NULL, NULL, 153757),
(153758, '1.10.220.10-FF-000080', NULL, 'Uncharacterized protein', 50, NULL, NULL, 153758),
(153759, '1.10.20.120-FF-000009', NULL, 'YALI0E29535p', 132, NULL, NULL, 153759),
(153760, '1.20.920.20-FF-000049', NULL, 'Dynein-1-beta heavy chain, flagellar inner arm I1 complex', 336, NULL, NULL, 153760),
(153761, '3.40.800.20-FF-000039', NULL, 'Histone deacetylase', 381, NULL, NULL, 153761),
(153762, '3.30.200.20-FF-001272', NULL, 'Serine/threonine protein kinase 24', 88, NULL, NULL, 153762),
(153763, '1.20.920.10-FF-000153', NULL, 'Bromodomain-containing protein', 137, NULL, NULL, 153763),
(153764, '3.40.50.11000-FF-000003', NULL, 'Fe-S cluster assembly protein DRE2', 123, NULL, NULL, 153764),
(153765, '3.60.110.10-FF-000064', NULL, 'Beta-ureidopropionase', 385, NULL, NULL, 153765),
(153766, '2.60.40.10-FF-001021', NULL, 'Hemicentin 1', 94, NULL, NULL, 153766),
(153767, '3.40.50.1820-FF-000392', NULL, 'Beta-ketoadipate enol-lactone hydrolase', 257, NULL, NULL, 153767),
(153768, '2.60.40.10-FF-004686', NULL, NULL, 83, NULL, NULL, 153768),
(153769, '3.80.20.20-FF-000053', NULL, 'Predicted protein', 64, NULL, NULL, 153769),
(153770, '1.25.40.630-FF-000004', NULL, 'Rna15p', 108, NULL, NULL, 153770),
(153771, '3.30.420.110-FF-000067', NULL, 'Him-14', 160, NULL, NULL, 153771),
(153772, '3.40.1090.10-FF-000093', NULL, 'Uncharacterized protein', 149, NULL, NULL, 153772),
(153773, '2.40.110.10-FF-000044', NULL, 'Acyl-CoA dehydrogenase', 117, NULL, NULL, 153773),
(153774, '3.30.450.20-FF-000475', NULL, 'Sensor histidine kinase', 102, NULL, NULL, 153774),
(153775, '2.130.10.10-FF-004181', NULL, 'Diphthine methyltransferase', 163, NULL, NULL, 153775),
(153776, '1.10.10.60-FF-001078', NULL, NULL, 131, NULL, NULL, 153776),
(153777, '3.30.60.270-FF-000016', NULL, 'uncharacterized protein LOC100182944', 81, NULL, NULL, 153777),
(153778, '3.30.200.20-FF-000760', NULL, 'Casein kinase II subunit alpha', 125, NULL, NULL, 153778),
(153779, '2.60.40.150-FF-000631', NULL, 'Uncharacterized protein', 139, NULL, NULL, 153779),
(153780, '1.25.40.10-FF-000970', NULL, 'Pentatricopeptide repeat-containing protein At3g26630, chloroplastic', 155, NULL, NULL, 153780),
(153781, '3.20.20.30-FF-000002', NULL, 'LLM class flavin-dependent oxidoreductase', 332, NULL, NULL, 153781),
(153782, '3.90.190.10-FF-000404', NULL, 'Dual specificity protein phosphatase CDC14B-like Protein', 158, NULL, NULL, 153782),
(153783, '3.20.20.300-FF-000059', NULL, NULL, 192, NULL, NULL, 153783),
(153784, '3.20.20.70-FF-000649', NULL, NULL, 237, NULL, NULL, 153784),
(153785, '3.30.420.10-FF-000009', NULL, 'Ribonuclease T', 206, NULL, NULL, 153785),
(153786, '3.90.730.10-FF-000008', NULL, 'Drought-induced S-like ribonuclease', 213, NULL, NULL, 153786),
(153787, '3.90.1010.10-FF-000026', NULL, 'Uncharacterized protein', 98, NULL, NULL, 153787),
(153788, '1.10.150.20-FF-000161', NULL, 'ATP-dependent RNA helicase, putative', 75, NULL, NULL, 153788),
(153789, '3.40.50.300-FF-003540', NULL, 'DNA replication protein', 185, NULL, NULL, 153789),
(153790, '3.40.50.300-FF-001606', NULL, 'Rab family GTPase', 210, NULL, NULL, 153790);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(153791, '1.10.3430.10-FF-000038', NULL, 'Ammonium transporter', 416, NULL, NULL, 153791),
(153792, '1.10.472.130-FF-000074', NULL, 'Flagellar outer dynein arm heavy chain gamma', 146, NULL, NULL, 153792),
(153793, '2.130.10.10-FF-000156', NULL, 'protein TSSC1 isoform X1', 374, NULL, NULL, 153793),
(153794, '2.60.120.200-FF-000548', NULL, 'Calreticulin 2, calcium-binding protein', 237, NULL, NULL, 153794),
(153795, '1.10.30.10-FF-000137', NULL, 'Histone-lysine N-methyltransferase', 108, NULL, NULL, 153795),
(153796, '1.20.1250.20-FF-001615', NULL, 'Sucrose transporter, putative', 166, NULL, NULL, 153796),
(153797, '2.110.10.10-FF-000073', NULL, 'Uncharacterized protein', 101, NULL, NULL, 153797),
(153798, '3.30.70.100-FF-000052', NULL, 'V-type proton ATPase subunit C', 97, NULL, NULL, 153798),
(153799, '1.10.1740.10-FF-000011', NULL, 'RNA polymerase sigma factor rpoD', 78, NULL, NULL, 153799),
(153800, '1.10.1390.10-FF-000006', NULL, NULL, 44, NULL, NULL, 153800),
(153801, '1.10.10.10-FF-000916', NULL, 'Probable metalloprotease ARX1', 76, NULL, NULL, 153801),
(153802, '3.40.395.10-FF-000026', NULL, 'Uncharacterized protein', 194, NULL, NULL, 153802),
(153803, '2.120.10.80-FF-000109', NULL, 'Kelch-like protein 34', 306, NULL, NULL, 153803),
(153804, '2.60.200.40-FF-000044', NULL, 'Sphingosine kinase 1', 246, NULL, NULL, 153804),
(153805, '3.40.50.300-FF-001595', NULL, 'DNA helicase B', 52, NULL, NULL, 153805),
(153806, '3.40.50.10190-FF-000035', NULL, 'DNA-directed DNA/RNA polymerase mu', 104, NULL, NULL, 153806),
(153807, '1.10.150.920-FF-000001', NULL, 'Bifunctional hemolysin/adenylate cyclase', 56, NULL, NULL, 153807),
(153808, '2.60.120.740-FF-000013', NULL, 'Uncharacterized protein', 44, NULL, NULL, 153808),
(153809, '2.70.98.10-FF-000058', NULL, 'Aldose 1-epimerase', 338, NULL, NULL, 153809),
(153810, '1.25.40.180-FF-000061', NULL, 'Eukaryotic translation initiation factor 4 gamma 2', 240, NULL, NULL, 153810),
(153811, '2.130.10.10-FF-005962', NULL, 'Two component signal transduction system hybrid histidine kinase', 244, NULL, NULL, 153811),
(153812, '2.40.50.580-FF-000002', NULL, 'Sugar fermentation stimulation protein homolog', 78, NULL, NULL, 153812),
(153813, '3.90.180.10-FF-000123', NULL, 'Enoyl-[acyl-carrier-protein] reductase, mitochondrial', 136, NULL, NULL, 153813),
(153814, '1.20.1250.20-FF-000671', NULL, 'Major facilitator transporter', 232, NULL, NULL, 153814),
(153815, '2.40.30.10-FF-000504', NULL, 'Predicted protein', 93, NULL, NULL, 153815),
(153816, '1.10.10.10-FF-000607', NULL, 'Virulence genes transcriptional activator SpvR', 83, NULL, NULL, 153816),
(153817, '2.60.40.1120-FF-000037', NULL, 'SusC/RagA family TonB-linked outer membrane protein', 75, NULL, NULL, 153817),
(153818, '2.30.29.30-FF-000951', NULL, 'AAR091Wp', 116, NULL, NULL, 153818),
(153819, '1.25.40.10-FF-002841', NULL, 'Ubiquitin-protein ligase Sel1/Ubx2', 448, NULL, NULL, 153819),
(153820, '2.40.10.10-FF-000593', NULL, NULL, 31, NULL, NULL, 153820),
(153821, '1.20.5.110-FF-000313', NULL, 'WASH complex subunit CCDC53 homolog-like Protein', 53, NULL, NULL, 153821),
(153822, '3.30.40.10-FF-000604', NULL, 'Blast:E3 ubiquitin-protein ligase TRIM33', 83, NULL, NULL, 153822),
(153823, '2.120.10.30-FF-000460', NULL, 'Uncharacterized protein', 83, NULL, NULL, 153823),
(153824, '3.30.1240.10-FF-000017', NULL, 'Cof family hydrolase', 108, NULL, NULL, 153824),
(153825, '2.60.120.200-FF-000239', NULL, 'Laminin subunit alpha-3', 205, NULL, NULL, 153825),
(153826, '3.30.160.60-FF-006248', NULL, NULL, 28, NULL, NULL, 153826),
(153827, '3.30.160.60-FF-002870', NULL, NULL, 25, NULL, NULL, 153827),
(153828, '3.30.450.20-FF-000582', NULL, 'Uncharacterized protein', 51, NULL, NULL, 153828),
(153829, '3.50.50.60-FF-001203', NULL, 'Uncharacterized protein', 381, NULL, NULL, 153829),
(153830, '1.20.1560.10-FF-000635', NULL, 'Uncharacterized protein', 209, NULL, NULL, 153830),
(153831, '3.90.550.10-FF-000376', NULL, 'Putative UDP-N-acetylglucosamine pyrophosphorylase', 564, NULL, NULL, 153831),
(153832, '3.90.70.10-FF-000710', NULL, 'Uncharacterized protein', 205, NULL, NULL, 153832);
INSERT INTO "PUBLIC"."MODEL" VALUES
(153833, '2.60.260.20-FF-000148', NULL, 'Heat shock protein DnaJ, putative', 71, NULL, NULL, 153833),
(153834, '3.40.850.10-FF-000410', NULL, 'Kinesin-like protein', 253, NULL, NULL, 153834),
(153835, '1.10.565.10-FF-000211', NULL, 'Estrogen receptor', 121, NULL, NULL, 153835),
(153836, '3.90.1150.10-FF-000406', NULL, 'Uncharacterized protein', 103, NULL, NULL, 153836),
(153837, '3.40.50.2300-FF-001598', NULL, NULL, 99, NULL, NULL, 153837),
(153838, '3.90.1720.30-FF-000001', NULL, 'desumoylating isopeptidase 2', 167, NULL, NULL, 153838),
(153839, '3.90.190.10-FF-000399', NULL, 'Protein-tyrosine-phosphatase', 185, NULL, NULL, 153839),
(153840, '3.80.10.10-FF-003641', NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g29720', 169, NULL, NULL, 153840),
(153841, '2.60.40.10-FF-001448', NULL, 'Frazzled, isoform C', 101, NULL, NULL, 153841),
(153842, '2.30.180.10-FF-000056', NULL, 'Fasciclin-domain-containing protein', 128, NULL, NULL, 153842),
(153843, '1.10.238.10-FF-000710', NULL, 'Calbindin 2', 73, NULL, NULL, 153843),
(153844, '3.90.950.10-FF-000013', NULL, 'Nucleoside triphosphate pyrophosphatase', 185, NULL, NULL, 153844),
(153845, '3.30.720.10-FF-000015', NULL, 'Uncharacterized protein C17H9.07', 98, NULL, NULL, 153845),
(153846, '3.90.79.10-FF-000123', NULL, 'Membrane-associated phospholipid phosphatase', 97, NULL, NULL, 153846),
(153847, '3.40.50.360-FF-000101', NULL, '5-methyltetrahydrofolate-homocysteine methyltransferase reductase', 72, NULL, NULL, 153847),
(153848, '3.40.50.720-FF-001838', NULL, 'FAD dependent oxidoreductase superfamily (AFU_orthologue AFUA_6G10230)', 92, NULL, NULL, 153848),
(153849, '2.30.30.1020-FF-000031', NULL, NULL, 178, NULL, NULL, 153849),
(153850, '3.80.10.10-FF-000235', NULL, 'Leucine-rich repeat serine/threonine-protein kinase 1', 153, NULL, NULL, 153850),
(153851, '2.10.110.10-FF-000079', NULL, 'LIM and cysteine-rich domains protein 1', 70, NULL, NULL, 153851),
(153852, '3.30.1360.40-FF-000035', NULL, 'DNA topoisomerase 2', 82, NULL, NULL, 153852),
(153853, '2.60.40.150-FF-000092', NULL, 'E3 ubiquitin-protein ligase', 142, NULL, NULL, 153853),
(153854, '1.25.40.430-FF-000023', NULL, 'BUB1 mitotic checkpoint serine/threonine kinase Bb', 185, NULL, NULL, 153854),
(153855, '2.120.10.80-FF-000418', NULL, 'Predicted protein', 318, NULL, NULL, 153855),
(153856, '2.60.40.3210-FF-000018', NULL, 'Uncharacterized protein', 107, NULL, NULL, 153856),
(153857, '2.160.20.10-FF-000150', NULL, 'Os06g0280100 protein', 89, NULL, NULL, 153857),
(153858, '1.20.120.1750-FF-000013', NULL, 'RBR-type E3 ubiquitin transferase', 249, NULL, NULL, 153858),
(153859, '3.40.640.10-FF-000164', NULL, 'Cystathionine gamma-lyase, putative', 285, NULL, NULL, 153859),
(153860, '1.10.150.20-FF-000318', NULL, 'Predicted protein', 143, NULL, NULL, 153860),
(153861, '3.30.1740.10-FF-000022', NULL, 'Poly [ADP-ribose] polymerase', 100, NULL, NULL, 153861),
(153862, '3.10.250.10-FF-000023', NULL, 'lysyl oxidase homolog 4', 126, NULL, NULL, 153862),
(153863, '2.60.34.10-FF-000102', NULL, 'Heat shock 105/110 protein 1', 159, NULL, NULL, 153863),
(153864, '3.40.390.10-FF-000274', NULL, NULL, 136, NULL, NULL, 153864),
(153865, '4.10.60.10-FF-000227', NULL, 'Uncharacterized protein', 56, NULL, NULL, 153865),
(153866, '3.40.50.300-FF-007811', NULL, 'Uncharacterized protein', 28, NULL, NULL, 153866),
(153867, '3.40.50.410-FF-000228', NULL, 'Uncharacterized protein', 121, NULL, NULL, 153867),
(153868, '1.25.10.10-FF-001176', NULL, 'Karyopherin, putative', 977, NULL, NULL, 153868),
(153869, '2.60.120.650-FF-000121', NULL, 'Lysine-specific demethylase JMJ25', 253, NULL, NULL, 153869),
(153870, '3.30.40.10-FF-000593', NULL, 'Cti6p', 89, NULL, NULL, 153870),
(153871, '2.60.40.1180-FF-000229', NULL, 'Alpha-galactosidase', 68, NULL, NULL, 153871),
(153872, '3.40.710.10-FF-000030', NULL, 'Penicillin-binding protein 1', 404, NULL, NULL, 153872),
(153873, '2.60.40.630-FF-000005', NULL, 'Signal transducer and activator of transcription', 159, NULL, NULL, 153873),
(153874, '2.30.30.190-FF-000035', NULL, NULL, 47, NULL, NULL, 153874);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(153875, '3.40.50.150-FF-000791', NULL, 'Os12g0199500 protein', 130, NULL, NULL, 153875),
(153876, '1.10.3380.30-FF-000034', NULL, 'Uncharacterized protein', 158, NULL, NULL, 153876),
(153877, '2.120.10.30-FF-000466', NULL, 'Predicted protein', 68, NULL, NULL, 153877),
(153878, '3.30.700.10-FF-000008', NULL, 'ComG operon protein 3', 92, NULL, NULL, 153878),
(153879, '2.60.40.1910-FF-000044', NULL, NULL, 88, NULL, NULL, 153879),
(153880, '3.40.50.720-FF-000113', NULL, 'Glutamate synthase [NADH], amyloplastic', 108, NULL, NULL, 153880),
(153881, '3.30.160.60-FF-005259', NULL, NULL, 70, NULL, NULL, 153881),
(153882, '2.60.120.1540-FF-000017', NULL, 'Complement component 4', 109, NULL, NULL, 153882),
(153883, '2.60.40.10-FF-003702', NULL, NULL, 96, NULL, NULL, 153883),
(153884, '3.30.342.10-FF-000007', NULL, 'DNA polymerase', 176, NULL, NULL, 153884),
(153885, '3.60.21.60-FF-000040', NULL, 'Uncharacterized protein', 213, NULL, NULL, 153885),
(153886, '3.30.160.60-FF-001881', NULL, 'Protein tramtrack, beta isoform', 30, NULL, NULL, 153886),
(153887, '3.30.70.330-FF-000475', NULL, 'splicing factor-like protein 1', 103, NULL, NULL, 153887),
(153888, '2.60.40.10-FF-001920', NULL, 'Immunoglobulin lambda variable 6-57', 111, NULL, NULL, 153888),
(153889, '3.30.70.870-FF-000035', NULL, 'Elongation factor G, mitochondrial', 73, NULL, NULL, 153889),
(153890, '3.10.100.10-FF-000260', NULL, NULL, 152, NULL, NULL, 153890),
(153891, '3.30.360.10-FF-000038', NULL, 'Gfo/Idh/MocA family oxidoreductase', 143, NULL, NULL, 153891),
(153892, '3.30.230.70-FF-000176', NULL, 'Uncharacterized protein', 61, NULL, NULL, 153892),
(153893, '3.30.450.40-FF-000161', NULL, 'Sensor histidine kinase/response regulator, putative', 201, NULL, NULL, 153893),
(153894, '3.40.50.450-FF-000100', NULL, 'Uncharacterized protein C191.05c', 190, NULL, NULL, 153894),
(153895, '3.40.50.720-FF-001529', NULL, 'Fatty acyl-CoA reductase', 286, NULL, NULL, 153895),
(153896, '3.80.10.10-FF-004260', NULL, 'Uncharacterized protein', 65, NULL, NULL, 153896),
(153897, '2.60.40.10-FF-003382', NULL, NULL, 86, NULL, NULL, 153897),
(153898, '3.40.50.300-FF-002904', NULL, 'Type VII secretion system ESX-1 associated protein EspI', 239, NULL, NULL, 153898),
(153899, '3.40.190.10-FF-000629', NULL, 'Uncharacterized protein', 95, NULL, NULL, 153899),
(153900, '3.60.40.10-FF-000226', NULL, 'Sigma factor SibG regulation protein RsbU', 277, NULL, NULL, 153900),
(153901, '3.40.50.10810-FF-000058', NULL, 'RDH54p DNA-dependent ATPase', 303, NULL, NULL, 153901),
(153902, '3.30.70.20-FF-000098', NULL, NULL, 44, NULL, NULL, 153902),
(153903, '2.20.70.30-FF-000002', NULL, 'Nascent polypeptide-associated complex (NAC), alpha subunit', 53, NULL, NULL, 153903),
(153904, '3.40.50.720-FF-002474', NULL, 'Predicted protein', 258, NULL, NULL, 153904),
(153905, '1.20.1070.10-FF-001733', NULL, 'Uncharacterized protein', 92, NULL, NULL, 153905),
(153906, '2.60.120.10-FF-000591', NULL, 'Patatin like phospholipase domain containing 7', 83, NULL, NULL, 153906),
(153907, '2.40.420.20-FF-000020', NULL, 'Probable RND efflux membrane fusion protein', 90, NULL, NULL, 153907),
(153908, '3.90.1480.20-FF-000058', NULL, 'ST6 beta-galactosamide alpha-2,6-sialyltranferase 2b', 105, NULL, NULL, 153908),
(153909, '3.40.50.300-FF-005996', NULL, 'Katanin p60 ATPase-containing subunit', 94, NULL, NULL, 153909),
(153910, '1.20.120.1770-FF-000013', NULL, 'Uncharacterized protein', 252, NULL, NULL, 153910),
(153911, '1.10.8.60-FF-000397', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 63, NULL, NULL, 153911),
(153912, '1.20.140.40-FF-000074', NULL, NULL, 153, NULL, NULL, 153912),
(153913, '3.60.10.10-FF-000045', NULL, 'Endonuclease/exonuclease/phosphatase family protein', 253, NULL, NULL, 153913),
(153914, '3.30.559.10-FF-000174', NULL, 'Nonribosomal peptide synthetase 6', 162, NULL, NULL, 153914),
(153915, '3.30.160.60-FF-000936', NULL, 'Zinc finger protein 577', 28, NULL, NULL, 153915),
(153916, '2.40.50.1000-FF-000006', NULL, '40S ribosomal protein S11', 158, NULL, NULL, 153916);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(153917, '3.40.50.300-FF-006485', NULL, 'Predicted protein', 116, NULL, NULL, 153917),
(153918, '3.30.740.10-FF-000028', NULL, NULL, 59, NULL, NULL, 153918),
(153919, '1.25.40.10-FF-002313', NULL, 'Pentatricopeptide repeat (PPR) superfamily protein', 107, NULL, NULL, 153919),
(153920, '3.10.20.30-FF-000087', NULL, NULL, 95, NULL, NULL, 153920),
(153921, '1.25.40.180-FF-000280', NULL, NULL, 161, NULL, NULL, 153921),
(153922, '1.25.40.10-FF-002768', NULL, 'YALI0E15994p', 172, NULL, NULL, 153922),
(153923, '3.30.479.20-FF-000030', NULL, 'Elongation factor Ts', 53, NULL, NULL, 153923),
(153924, '1.50.10.10-FF-000151', NULL, 'Uncharacterized protein', 364, NULL, NULL, 153924),
(153925, '2.120.10.30-FF-000090', NULL, 'Putative Dipeptidyl aminopeptidases /acylaminoacyl-peptidase', 142, NULL, NULL, 153925),
(153926, '1.25.40.10-FF-005039', NULL, 'Uncharacterized protein', 129, NULL, NULL, 153926),
(153927, '3.40.50.300-FF-006030', NULL, 'Helicase, putative', 253, NULL, NULL, 153927),
(153928, '2.40.70.10-FF-000153', NULL, 'Basic 7S globulin', 188, NULL, NULL, 153928),
(153929, '2.40.50.140-FF-000926', NULL, NULL, 132, NULL, NULL, 153929),
(153930, '3.40.50.300-FF-002899', NULL, 'Unplaced genomic scaffold supercont1.83, whole genome shotgun sequence', 250, NULL, NULL, 153930),
(153931, '1.20.1250.20-FF-002104', NULL, 'Monocarboxylate transporter 1', 241, NULL, NULL, 153931),
(153932, '2.40.70.10-FF-000389', NULL, NULL, 186, NULL, NULL, 153932),
(153933, '3.30.450.30-FF-000023', NULL, 'Profilin', 102, NULL, NULL, 153933),
(153934, '3.40.50.2300-FF-001626', NULL, NULL, 327, NULL, NULL, 153934),
(153935, '1.10.510.10-FF-003053', NULL, NULL, 210, NULL, NULL, 153935),
(153936, '3.90.1470.20-FF-000001', NULL, 'Putative phosphoserine phosphatase protein', 109, NULL, NULL, 153936),
(153937, '1.20.58.340-FF-000022', NULL, 'Magnesium transporter MRS2-F', 214, NULL, NULL, 153937),
(153938, '3.80.10.10-FF-002343', NULL, 'EIN3-binding F-box protein 1', 102, NULL, NULL, 153938),
(153939, '3.40.50.150-FF-001752', NULL, NULL, 252, NULL, NULL, 153939),
(153940, '3.40.630.10-FF-000219', NULL, 'Uncharacterized protein', 292, NULL, NULL, 153940),
(153941, '1.50.40.10-FF-000299', NULL, 'Uncharacterized mitochondrial carrier C4G8.08', 289, NULL, NULL, 153941),
(153942, '3.50.50.60-FF-000669', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 115, NULL, NULL, 153942),
(153943, '1.20.5.120-FF-000007', NULL, NULL, 60, NULL, NULL, 153943),
(153944, '3.30.420.10-FF-000318', NULL, 'Polymerase (DNA directed) nu', 170, NULL, NULL, 153944),
(153945, '2.130.10.10-FF-005012', NULL, 'Neural precursor cell expressed, developmentally down-regulated 1', 35, NULL, NULL, 153945),
(153946, '1.20.5.100-FF-000001', NULL, 'UDP-glucose 6-dehydrogenase', 32, NULL, NULL, 153946),
(153947, '2.60.40.3360-FF-000001', NULL, 'Mucosa-associated lymphoid tissue lymphoma translocation protein 1', 148, NULL, NULL, 153947),
(153948, '1.10.472.80-FF-000027', NULL, 'GTPase activating protein (Evi5)', 151, NULL, NULL, 153948),
(153949, '2.60.200.10-FF-000046', NULL, 'Interferon regulatory factor 7', 218, NULL, NULL, 153949),
(153950, '3.30.40.10-FF-001902', NULL, 'Uncharacterized protein', 112, NULL, NULL, 153950),
(153951, '3.90.730.10-FF-000025', NULL, 'Uncharacterized protein', 155, NULL, NULL, 153951),
(153952, '3.30.420.40-FF-001030', NULL, 'Uncharacterized protein', 34, NULL, NULL, 153952),
(153953, '3.40.50.300-FF-003995', NULL, 'Ras-related protein Rab-37', 46, NULL, NULL, 153953),
(153954, '1.25.40.20-FF-000736', NULL, 'Ankyrin repeat protein', 82, NULL, NULL, 153954),
(153955, '1.25.40.10-FF-001779', NULL, 'Pentatricopeptide repeat-containing protein At4g08210', 120, NULL, NULL, 153955),
(153956, '1.10.238.10-FF-001183', NULL, 'Uncharacterized protein', 87, NULL, NULL, 153956),
(153957, '2.60.40.10-FF-003921', NULL, NULL, 108, NULL, NULL, 153957),
(153958, '3.40.50.300-FF-003523', NULL, 'Endosomal AAA ATPase-like protein', 181, NULL, NULL, 153958),
(153959, '2.40.50.100-FF-000145', NULL, 'Sugar ABC transporter, ATP-binding protein', 45, NULL, NULL, 153959);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(153960, '3.40.50.11500-FF-000030', NULL, NULL, 223, NULL, NULL, 153960),
(153961, '1.20.920.10-FF-000029', NULL, 'Bromodomain adjacent to zinc finger domain protein 1A', 115, NULL, NULL, 153961),
(153962, '1.10.274.10-FF-000007', NULL, 'Phosphoenolpyruvate-protein phosphotransferase', 125, NULL, NULL, 153962),
(153963, '3.30.300.30-FF-000164', NULL, 'Nonribosomal peptide synthetase asqK', 82, NULL, NULL, 153963),
(153964, '2.60.120.40-FF-000015', NULL, 'Collagen-like triple helix repeat-containing protein', 142, NULL, NULL, 153964),
(153965, '4.10.240.10-FF-000215', NULL, 'Zcf1p', 54, NULL, NULL, 153965),
(153966, '3.30.200.20-FF-000344', NULL, 'Serine/threonine-protein kinase WARTS homolog', 13, NULL, NULL, 153966),
(153967, '3.50.30.50-FF-000002', NULL, 'Kynurenine formamidase', 219, NULL, NULL, 153967),
(153968, '3.50.4.10-FF-000004', NULL, 'Hepatocyte growth factor-like 1', 92, NULL, NULL, 153968),
(153969, '1.20.140.40-FF-000057', NULL, NULL, 139, NULL, NULL, 153969),
(153970, '3.30.450.230-FF-000002', NULL, 'AGR054Cp', 148, NULL, NULL, 153970),
(153971, '3.40.50.300-FF-007446', NULL, 'ATP-dependent DEAD/H RNA helicase, putative', 248, NULL, NULL, 153971),
(153972, '1.25.40.10-FF-001352', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 144, NULL, NULL, 153972),
(153973, '1.20.1250.20-FF-002251', NULL, 'Uncharacterized protein', 110, NULL, NULL, 153973),
(153974, '3.40.50.10190-FF-000018', NULL, 'DNA topoisomerase 2-binding protein 1', 125, NULL, NULL, 153974),
(153975, '4.10.40.30-FF-000002', NULL, NULL, 23, NULL, NULL, 153975),
(153976, '3.30.70.330-FF-002392', NULL, NULL, 97, NULL, NULL, 153976),
(153977, '3.30.160.60-FF-006243', NULL, NULL, 29, NULL, NULL, 153977),
(153978, '3.40.50.720-FF-002457', NULL, 'Shikimate dehydrogenase (NADP(+))', 145, NULL, NULL, 153978),
(153979, '3.30.160.60-FF-000588', NULL, 'Zinc finger protein 568', 28, NULL, NULL, 153979),
(153980, '1.10.640.10-FF-000055', NULL, 'Putative peroxinectin', 376, NULL, NULL, 153980),
(153981, '3.30.497.10-FF-000097', NULL, 'Serpin 42Db, isoform D', 162, NULL, NULL, 153981),
(153982, '1.10.510.10-FF-002288', NULL, NULL, 177, NULL, NULL, 153982),
(153983, '1.50.10.10-FF-000134', NULL, 'Putative secreted protein', 417, NULL, NULL, 153983),
(153984, '1.10.1670.40-FF-000008', NULL, 'DNA-3-methyladenine glycosidase II', 74, NULL, NULL, 153984),
(153985, '3.90.70.10-FF-000603', NULL, 'Uncharacterized protein', 184, NULL, NULL, 153985),
(153986, '3.40.50.1980-FF-000052', NULL, 'Ferrichrome ABC transporter lipoprotein', 184, NULL, NULL, 153986),
(153987, '2.160.10.10-FF-000020', NULL, 'Glucose-1-phosphate adenylyltransferase', 117, NULL, NULL, 153987),
(153988, '1.25.40.10-FF-000059', NULL, 'Vacuolar protein sorting-associated protein 41 homolog', 182, NULL, NULL, 153988),
(153989, '1.10.238.10-FF-000238', NULL, 'CALmodulin related genes', 70, NULL, NULL, 153989),
(153990, '3.80.10.10-FF-001640', NULL, 'Transforming growth factor beta activator LRRC33', 84, NULL, NULL, 153990),
(153991, '4.10.1060.10-FF-000041', NULL, 'Uncharacterized protein, isoform A', 41, NULL, NULL, 153991),
(153992, '2.60.120.260-FF-000089', NULL, 'Eph receptor tyrosine kinase', 183, NULL, NULL, 153992),
(153993, '2.60.120.680-FF-000001', NULL, 'SEC14-like protein 2 isoform X1', 108, NULL, NULL, 153993),
(153994, '3.40.50.620-FF-000645', NULL, 'Os01g0120300 protein', 132, NULL, NULL, 153994),
(153995, '3.40.800.10-FF-000019', NULL, 'Agmatinase', 289, NULL, NULL, 153995),
(153996, '1.10.510.10-FF-000490', NULL, 'Proto-oncogene serine/threonine-protein kinase mos', 186, NULL, NULL, 153996),
(153997, '3.40.50.170-FF-000033', NULL, 'Trifunctional purine biosynthetic protein adenosine-3', 194, NULL, NULL, 153997),
(153998, '3.30.9.10-FF-000279', NULL, 'Uncharacterized protein', 59, NULL, NULL, 153998),
(153999, '2.60.40.790-FF-000137', NULL, NULL, 105, NULL, NULL, 153999),
(154000, '4.10.280.110-FF-000015', NULL, 'WD40-repeat-containing domain protein', 70, NULL, NULL, 154000),
(154001, '2.40.50.880-FF-000002', NULL, NULL, 125, NULL, NULL, 154001);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(154002, '1.10.418.50-FF-000005', NULL, 'Uncharacterized protein', 78, NULL, NULL, 154002),
(154003, '3.40.50.300-FF-001179', NULL, 'Rho family GTPase', 192, NULL, NULL, 154003),
(154004, '1.10.20.130-FF-000001', NULL, 'Poly [ADP-ribose] polymerase', 74, NULL, NULL, 154004),
(154005, '3.60.110.10-FF-000092', NULL, NULL, 102, NULL, NULL, 154005),
(154006, '3.40.50.1820-FF-001662', NULL, 'Narbonolide/10-deoxymethynolide synthase PikA4, module 6', 290, NULL, NULL, 154006),
(154007, '3.90.226.10-FF-000078', NULL, 'Enoyl-CoA hydratase EchA12', 208, NULL, NULL, 154007),
(154008, '3.10.20.30-FF-000082', NULL, NULL, 79, NULL, NULL, 154008),
(154009, '1.20.120.1020-FF-000002', NULL, 'Heterokaryon incompatibility protein s', 223, NULL, NULL, 154009),
(154010, '3.80.10.10-FF-001724', NULL, 'F-box and leucine-rich repeat protein 22', 204, NULL, NULL, 154010),
(154011, '3.40.50.720-FF-001524', NULL, '3-ketodihydrosphingosine reductase', 267, NULL, NULL, 154011),
(154012, '3.10.20.90-FF-000493', NULL, 'Ubiquitin', 76, NULL, NULL, 154012),
(154013, '3.30.160.60-FF-000408', NULL, 'Krueppel-like factor 15', 24, NULL, NULL, 154013),
(154014, '3.30.70.330-FF-003100', NULL, NULL, 96, NULL, NULL, 154014),
(154015, '2.40.50.140-FF-000241', NULL, 'DNA-directed RNA polymerases I, II, and III subunit RPABC3', 136, NULL, NULL, 154015),
(154016, '2.40.100.20-FF-000001', NULL, 'Flavodoxin', 118, NULL, NULL, 154016),
(154017, '1.10.287.110-FF-000191', NULL, 'Putative heat shock protein DNAJ', 134, NULL, NULL, 154017),
(154018, '2.60.120.200-FF-000655', NULL, 'Collagen type XXVII alpha 1 chain', 91, NULL, NULL, 154018),
(154019, '2.130.10.10-FF-002073', NULL, 'WD40 repeat-like protein', 119, NULL, NULL, 154019),
(154020, '3.40.50.1220-FF-000072', NULL, 'Hst3p', 102, NULL, NULL, 154020),
(154021, '2.70.98.60-FF-000005', NULL, 'Alpha-galactosidase', 274, NULL, NULL, 154021),
(154022, '1.10.8.60-FF-000402', NULL, 'Katanin p60 ATPase-containing subunit A-like 2', 36, NULL, NULL, 154022),
(154023, '2.30.30.100-FF-000172', NULL, 'U6 snRNA-associated Sm-like protein LSm3', 87, NULL, NULL, 154023),
(154024, '2.60.40.60-FF-000693', NULL, 'Predicted protein', 104, NULL, NULL, 154024),
(154025, '3.10.20.90-FF-000970', NULL, 'CHD gene family protein containing chromodomain, helicase domain, and DNA-binding domain', 110, NULL, NULL, 154025),
(154026, '3.10.20.90-FF-000184', NULL, 'UBX domain-containing protein 8 isoform X1', 80, NULL, NULL, 154026),
(154027, '2.40.180.10-FF-000008', NULL, 'lipoxygenase homology domain-containing protein 1', 136, NULL, NULL, 154027),
(154028, '3.40.190.10-FF-000865', NULL, 'Uncharacterized protein', 34, NULL, NULL, 154028),
(154029, '3.30.70.330-FF-002476', NULL, NULL, 80, NULL, NULL, 154029),
(154030, '1.10.20.10-FF-000333', NULL, NULL, 112, NULL, NULL, 154030),
(154031, '2.40.50.1070-FF-000010', NULL, '23S rRNA m(5)U-1939 methyltransferase', 173, NULL, NULL, 154031),
(154032, '3.30.160.60-FF-003831', NULL, NULL, 29, NULL, NULL, 154032),
(154033, '3.40.532.10-FF-000008', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 242, NULL, NULL, 154033),
(154034, '3.30.110.20-FF-000017', NULL, 'WGS project CABT00000000 data, contig 2.72', 119, NULL, NULL, 154034),
(154035, '3.40.50.1820-FF-001353', NULL, 'GH05794p', 239, NULL, NULL, 154035),
(154036, '3.40.33.10-FF-000031', NULL, 'Extracellular SCP domain-containing protein Pry1', 157, NULL, NULL, 154036),
(154037, '3.30.70.330-FF-000222', NULL, 'mRNA binding post-transcriptional regulator', 80, NULL, NULL, 154037),
(154038, '3.40.30.10-FF-001070', NULL, 'Thioredoxin SoxW', 157, NULL, NULL, 154038),
(154039, '3.40.50.1820-FF-000717', NULL, 'Acetylcholinesterase/butyrylcholinesterase, putative', 184, NULL, NULL, 154039),
(154040, '2.40.50.140-FF-000550', NULL, 'RNA-editing complex protein MP81', 144, NULL, NULL, 154040),
(154041, '3.40.50.1100-FF-000182', NULL, 'Cysteine synthase', 163, NULL, NULL, 154041),
(154042, '1.20.1250.20-FF-000654', NULL, 'Carcinine transporter', 412, NULL, NULL, 154042),
(154043, '3.40.50.2300-FF-001250', NULL, NULL, 178, NULL, NULL, 154043);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(154044, '1.10.840.10-FF-000020', NULL, 'Phosphoinositide phospholipase C', 271, NULL, NULL, 154044),
(154045, '3.40.120.10-FF-000119', NULL, 'Uncharacterized protein', 51, NULL, NULL, 154045),
(154046, '3.40.50.720-FF-000220', NULL, '3 beta-hydroxysteroid dehydrogenase/Delta 5-->4-isomerase type 1', 362, NULL, NULL, 154046),
(154047, '2.20.70.10-FF-000125', NULL, 'E3 ubiquitin-protein ligase Smurf1', 48, NULL, NULL, 154047),
(154048, '3.40.50.300-FF-007339', NULL, 'Midasin', 132, NULL, NULL, 154048),
(154049, '1.10.510.10-FF-004233', NULL, NULL, 307, NULL, NULL, 154049),
(154050, '3.40.50.2300-FF-000446', NULL, 'Guanylate cyclase', 196, NULL, NULL, 154050),
(154051, '3.10.350.10-FF-000082', NULL, 'Lipoprotein NlpD', 73, NULL, NULL, 154051),
(154052, '3.30.200.20-FF-000451', NULL, 'L-type lectin-domain containing receptor kinase I.9', 111, NULL, NULL, 154052),
(154053, '2.130.10.10-FF-002634', NULL, 'Pleiotropic regulator 1', 72, NULL, NULL, 154053),
(154054, '3.20.20.300-FF-000020', NULL, 'Sugar hydrolase', 347, NULL, NULL, 154054),
(154055, '3.30.260.10-FF-000098', NULL, NULL, 111, NULL, NULL, 154055),
(154056, '3.30.160.60-FF-005624', NULL, NULL, 81, NULL, NULL, 154056),
(154057, '2.90.10.10-FF-000063', NULL, 'Uncharacterized protein', 85, NULL, NULL, 154057),
(154058, '3.40.190.10-FF-000646', NULL, 'Peptide ABC transporter substrate-binding protein', 273, NULL, NULL, 154058),
(154059, '1.20.1560.10-FF-000107', NULL, 'ABC transporter C family member 13', 309, NULL, NULL, 154059),
(154060, '2.60.120.970-FF-000099', NULL, 'Bone morphogenetic protein, putative', 147, NULL, NULL, 154060),
(154061, '3.90.79.10-FF-000106', NULL, 'NUDIX domain-containing protein', 160, NULL, NULL, 154061),
(154062, '3.30.1120.30-FF-000048', NULL, 'CAMK family protein kinase', 92, NULL, NULL, 154062),
(154063, '3.40.50.2300-FF-000322', NULL, 'Autoinducer 2 sensor kinase/phosphatase luxQ', 126, NULL, NULL, 154063),
(154064, '1.20.1250.20-FF-001632', NULL, 'MFS multidrug transporter, putative', 101, NULL, NULL, 154064),
(154065, '3.50.50.60-FF-000821', NULL, 'AGR055Cp', 305, NULL, NULL, 154065),
(154066, '3.10.129.10-FF-000270', NULL, 'Acyl coenzyme A thioester hydrolase', 150, NULL, NULL, 154066),
(154067, '3.40.50.300-FF-003068', NULL, 'Rab family GTPase', 203, NULL, NULL, 154067),
(154068, '3.40.50.1820-FF-001701', NULL, 'Predicted protein', 180, NULL, NULL, 154068),
(154069, '3.40.50.1240-FF-000167', NULL, NULL, 350, NULL, NULL, 154069),
(154070, '2.130.10.10-FF-003034', NULL, 'Uncharacterized WD repeat-containing protein slr1409', 155, NULL, NULL, 154070),
(154071, '3.30.930.10-FF-000200', NULL, 'Lysyl-tRNA synthetase', 341, NULL, NULL, 154071),
(154072, '3.80.10.10-FF-003438', NULL, 'Predicted protein', 59, NULL, NULL, 154072),
(154073, '2.30.39.10-FF-000002', NULL, 'Serpin family D member 1', 145, NULL, NULL, 154073),
(154074, '3.30.160.60-FF-001353', NULL, 'zinc finger protein 133 isoform X1', 29, NULL, NULL, 154074),
(154075, '2.40.50.100-FF-000229', NULL, 'Protein CBR-LIN-7', 94, NULL, NULL, 154075),
(154076, '1.25.40.20-FF-000517', NULL, 'Phosphate metabolism-related protein', 182, NULL, NULL, 154076),
(154077, '3.90.850.10-FF-000051', NULL, NULL, 83, NULL, NULL, 154077),
(154078, '3.30.70.580-FF-000072', NULL, 'tRNA pseudouridine synthase', 93, NULL, NULL, 154078),
(154079, '3.40.50.2300-FF-000761', NULL, 'Gamma-aminobutyric acid type B receptor subunit 1-like Protein', 107, NULL, NULL, 154079),
(154080, '1.25.10.10-FF-003093', NULL, 'Condensin complex subunit 1', 224, NULL, NULL, 154080),
(154081, '3.30.900.10-FF-000035', NULL, 'Autophagy related 13', 51, NULL, NULL, 154081),
(154082, '1.20.5.110-FF-000330', NULL, 't-SNARE domain containing 1', 96, NULL, NULL, 154082),
(154083, '3.30.420.390-FF-000016', NULL, NULL, 82, NULL, NULL, 154083),
(154084, '2.130.10.10-FF-003562', NULL, 'Os02g0796700 protein', 162, NULL, NULL, 154084),
(154085, '1.20.1250.20-FF-000126', NULL, 'MFS transporter permease', 187, NULL, NULL, 154085),
(154086, '1.20.120.610-FF-000001', NULL, 'V-type proton ATPase proteolipid subunit', 150, NULL, NULL, 154086);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(154087, '1.20.1560.10-FF-000416', NULL, 'ATP-binding cassette sub-family C member 8', 175, NULL, NULL, 154087),
(154088, '3.40.50.410-FF-000223', NULL, 'Uncharacterized protein', 148, NULL, NULL, 154088),
(154089, '1.20.120.1750-FF-000018', NULL, 'RBR-type E3 ubiquitin transferase', 73, NULL, NULL, 154089),
(154090, '1.10.260.40-FF-000052', NULL, 'HTH-type transcriptional regulator DicA', 67, NULL, NULL, 154090),
(154091, '3.40.50.2000-FF-000570', NULL, 'Glycosyl transferase family 1', 177, NULL, NULL, 154091),
(154092, '1.25.40.20-FF-001681', NULL, 'Uncharacterized protein', 76, NULL, NULL, 154092),
(154093, '1.20.930.10-FF-000002', NULL, 'Transcription elongation factor A (SII), 1', 93, NULL, NULL, 154093),
(154094, '3.90.1290.10-FF-000046', NULL, 'Uncharacterized protein', 147, NULL, NULL, 154094),
(154095, '3.50.50.60-FF-001310', NULL, 'Uncharacterized protein', 118, NULL, NULL, 154095),
(154096, '3.40.50.850-FF-000023', NULL, 'Isochorismatase domain-containing protein 1', 197, NULL, NULL, 154096),
(154097, '3.40.50.2300-FF-000631', NULL, 'Guanylate cyclase', 125, NULL, NULL, 154097),
(154098, '4.10.400.10-FF-000003', NULL, 'Putative low-density lipoprotein receptor-related protein 12', 40, NULL, NULL, 154098),
(154099, '3.30.40.10-FF-001773', NULL, 'Uncharacterized protein', 88, NULL, NULL, 154099),
(154100, '3.30.40.10-FF-001897', NULL, 'Uncharacterized protein', 112, NULL, NULL, 154100),
(154101, '2.20.25.80-FF-000008', NULL, 'WRKY transcription factor 40', 78, NULL, NULL, 154101),
(154102, '3.30.160.60-FF-000953', NULL, 'Zinc finger protein 691', 34, NULL, NULL, 154102),
(154103, '3.30.720.10-FF-000010', NULL, 'Signal recognition particle (SRP) subunit', 142, NULL, NULL, 154103),
(154104, '3.30.200.20-FF-000890', NULL, 'Putative serine/threonine-protein kinase', 97, NULL, NULL, 154104),
(154105, '2.30.180.10-FF-000039', NULL, 'Fasciclin 1, isoform F', 137, NULL, NULL, 154105),
(154106, '2.130.10.10-FF-003253', NULL, 'WD domain, G-beta repeat, putative', 208, NULL, NULL, 154106),
(154107, '2.10.25.10-FF-001314', NULL, 'Delta/notch-like EGF-related receptor', 37, NULL, NULL, 154107),
(154108, '1.25.40.20-FF-000697', NULL, 'Transient receptor potential cation channel, subfamily A, member 1b', 201, NULL, NULL, 154108),
(154109, '1.10.510.10-FF-001136', NULL, 'MTK1/MEKK4 homolog', 291, NULL, NULL, 154109),
(154110, '1.20.1270.60-FF-000307', NULL, 'Uncharacterized protein', 70, NULL, NULL, 154110),
(154111, '3.40.50.720-FF-000905', NULL, 'Oxidoreductase, short chain dehydrogenase/reductase family, putative', 257, NULL, NULL, 154111),
(154112, '3.90.550.10-FF-000371', NULL, 'Hexosyltransferase', 272, NULL, NULL, 154112),
(154113, '2.130.10.30-FF-000010', NULL, 'RCC1 and BTB domain-containing protein 1 isoform X2', 315, NULL, NULL, 154113),
(154114, '1.10.533.10-FF-000087', NULL, 'Uncharacterized protein', 88, NULL, NULL, 154114),
(154115, '1.25.40.470-FF-000024', NULL, 'Reduced mechanoreceptor potential A', 164, NULL, NULL, 154115),
(154116, '3.30.2130.30-FF-000004', NULL, 'THUMP domain-containing protein 3 isoform X1', 145, NULL, NULL, 154116),
(154117, '2.60.40.1510-FF-000031', NULL, 'Integrin beta', 73, NULL, NULL, 154117),
(154118, '3.40.50.300-FF-000645', NULL, 'DNA mismatch repair protein', 264, NULL, NULL, 154118),
(154119, '3.30.40.10-FF-000576', NULL, 'RING finger protein ETP1', 88, NULL, NULL, 154119),
(154120, '1.10.101.10-FF-000005', NULL, 'General secretion pathway protein A', 65, NULL, NULL, 154120),
(154121, '1.10.8.140-FF-000015', NULL, 'DNA-binding protein VNG_2008H', 104, NULL, NULL, 154121),
(154122, '2.60.40.60-FF-000513', NULL, 'CaDHerin family', 106, NULL, NULL, 154122),
(154123, '3.30.160.60-FF-004450', NULL, NULL, 33, NULL, NULL, 154123),
(154124, '2.130.10.10-FF-004973', NULL, 'Uncharacterized protein', 85, NULL, NULL, 154124),
(154125, '2.60.450.20-FF-000017', NULL, 'Uncharacterized protein', 153, NULL, NULL, 154125),
(154126, '1.25.40.20-FF-000388', NULL, 'Os11g0251200 protein', 225, NULL, NULL, 154126),
(154127, '1.20.1250.20-FF-001290', NULL, 'Solute carrier organic anion transporter family member', 252, NULL, NULL, 154127);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(154128, '1.25.40.20-FF-001664', NULL, 'Predicted protein', 84, NULL, NULL, 154128),
(154129, '3.30.70.330-FF-001172', NULL, 'Uncharacterized protein, isoform A', 95, NULL, NULL, 154129),
(154130, '2.120.10.30-FF-000544', NULL, 'Uncharacterized protein', 69, NULL, NULL, 154130),
(154131, '1.10.565.10-FF-000189', NULL, 'RAR-related orphan receptor A', 66, NULL, NULL, 154131),
(154132, '2.40.50.140-FF-000472', NULL, 'Unplaced genomic scaffold supercont1.9, whole genome shotgun sequence', 130, NULL, NULL, 154132),
(154133, '1.10.10.10-FF-002069', NULL, 'Uncharacterized protein', 90, NULL, NULL, 154133),
(154134, '3.10.20.30-FF-000065', NULL, 'Carbazole 1,9a-dioxygenase ferredoxin component', 109, NULL, NULL, 154134),
(154135, '1.10.760.10-FF-000002', NULL, 'Cytochrome c1, heme protein', 196, NULL, NULL, 154135),
(154136, '3.40.50.300-FF-002775', NULL, 'Regulator of nonsense transcripts 1-like protein', 253, NULL, NULL, 154136),
(154137, '1.10.10.10-FF-001996', NULL, 'Transcriptional regulator, MarR family', 139, NULL, NULL, 154137),
(154138, '2.60.40.10-FF-000268', NULL, 'Nectin cell adhesion molecule 1', 91, NULL, NULL, 154138),
(154139, '1.10.238.10-FF-000255', NULL, 'Mitochondrial Rho GTPase', 196, NULL, NULL, 154139),
(154140, '1.20.1070.10-FF-000120', NULL, 'Vomeronasal type-1 receptor', 300, NULL, NULL, 154140),
(154141, '3.40.50.620-FF-000628', NULL, 'Argininosuccinate synthetase', 26, NULL, NULL, 154141),
(154142, '3.30.70.80-FF-000048', NULL, 'Uncharacterized protein', 66, NULL, NULL, 154142),
(154143, '1.10.287.310-FF-000003', NULL, '50S ribosomal protein L29', 64, NULL, NULL, 154143),
(154144, '3.80.10.10-FF-004057', NULL, 'CAP-Gly domain containing protein', 134, NULL, NULL, 154144),
(154145, '1.10.8.1220-FF-000012', NULL, 'Protein CBR-CHE-3', 88, NULL, NULL, 154145),
(154146, '3.40.30.10-FF-000878', NULL, 'Glutathione s-transferase', 16, NULL, NULL, 154146),
(154147, '3.30.565.10-FF-000250', NULL, 'Sensor histidine kinase', 153, NULL, NULL, 154147),
(154148, '2.30.30.40-FF-000036', NULL, 'Spectrin alpha chain, non-erythrocytic 1', 75, NULL, NULL, 154148),
(154149, '1.10.730.20-FF-000020', NULL, 'Uncharacterized protein', 52, NULL, NULL, 154149),
(154150, '2.60.120.260-FF-000561', NULL, 'Uncharacterized protein', 46, NULL, NULL, 154150),
(154151, '3.80.10.10-FF-000420', NULL, 'protein NLRC5 isoform X1', 97, NULL, NULL, 154151),
(154152, '2.60.40.60-FF-000822', NULL, 'Predicted protein', 52, NULL, NULL, 154152),
(154153, '2.70.70.10-FF-000011', NULL, 'Leukocyte cell-derived chemotaxin-2', 135, NULL, NULL, 154153),
(154154, '3.40.50.2300-FF-000215', NULL, 'LacI family DNA-binding transcriptional regulator', 130, NULL, NULL, 154154),
(154155, '1.10.287.130-FF-000073', NULL, 'Two-component sensor histidine kinase', 67, NULL, NULL, 154155),
(154156, '3.40.50.10700-FF-000003', NULL, 'D-aminoacyl-tRNA deacylase', 80, NULL, NULL, 154156),
(154157, '2.130.10.10-FF-004995', NULL, 'Uncharacterized protein', 66, NULL, NULL, 154157),
(154158, '3.40.50.1440-FF-000019', NULL, 'Tubulin alpha chain', 268, NULL, NULL, 154158),
(154159, '1.20.120.790-FF-000010', NULL, 'Endoplasmin, putative', 147, NULL, NULL, 154159),
(154160, '3.40.50.11990-FF-000013', NULL, NULL, 165, NULL, NULL, 154160),
(154161, '1.25.40.20-FF-001136', NULL, 'YALI0E32791p', 158, NULL, NULL, 154161),
(154162, '1.10.340.30-FF-000010', NULL, 'Adenine DNA glycosylase', 112, NULL, NULL, 154162),
(154163, '3.20.20.100-FF-000095', NULL, 'Uncharacterized protein', 250, NULL, NULL, 154163),
(154164, '1.25.40.10-FF-003802', NULL, 'Uncharacterized protein', 143, NULL, NULL, 154164),
(154165, '1.25.40.10-FF-004421', NULL, 'Uncharacterized protein', 128, NULL, NULL, 154165),
(154166, '2.20.70.10-FF-000232', NULL, 'Uncharacterized protein', 44, NULL, NULL, 154166),
(154167, '3.30.240.40-FF-000004', NULL, NULL, 54, NULL, NULL, 154167),
(154168, '3.40.50.300-FF-003287', NULL, 'U5 small nuclear ribonucleoprotein 200 kDa helicase', 228, NULL, NULL, 154168),
(154169, '2.120.10.30-FF-000016', NULL, 'peptidyl-glycine alpha-amidating monooxygenase isoform X1', 328, NULL, NULL, 154169);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(154170, '3.40.50.980-FF-000051', NULL, 'N-(5-amino-5-carboxypentanoyl)-L-cysteinyl-D-valine synthase', 157, NULL, NULL, 154170),
(154171, '3.10.150.10-FF-000004', NULL, 'Beta sliding clamp', 126, NULL, NULL, 154171),
(154172, '1.25.40.10-FF-002280', NULL, 'Peptidylprolyl isomerase', 151, NULL, NULL, 154172),
(154173, '2.70.50.40-FF-000007', NULL, 'Unc-119 homolog a (C. elegans)', 143, NULL, NULL, 154173),
(154174, '2.170.270.10-FF-000069', NULL, 'protein msta', 123, NULL, NULL, 154174),
(154175, '3.40.50.300-FF-006518', NULL, 'Uncharacterized protein', 111, NULL, NULL, 154175),
(154176, '3.40.190.10-FF-000073', NULL, 'Spermidine/putrescine ABC transporter substrate-binding protein', 149, NULL, NULL, 154176),
(154177, '3.40.50.300-FF-004377', NULL, 'AGAP006740-PA', 211, NULL, NULL, 154177),
(154178, '3.30.565.10-FF-000339', NULL, 'Two-component system sensor histidine kinase', 140, NULL, NULL, 154178),
(154179, '3.20.110.10-FF-000033', NULL, 'Uncharacterized protein', 88, NULL, NULL, 154179),
(154180, '3.40.50.1480-FF-000025', NULL, NULL, 118, NULL, NULL, 154180),
(154181, '3.50.30.30-FF-000007', NULL, 'Signal peptide peptidase-like 3', 140, NULL, NULL, 154181),
(154182, '1.20.1050.20-FF-000015', NULL, NULL, 104, NULL, NULL, 154182),
(154183, '3.30.40.10-FF-001301', NULL, 'Uncharacterized protein', 80, NULL, NULL, 154183),
(154184, '2.130.10.10-FF-002865', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', 272, NULL, NULL, 154184),
(154185, '3.30.565.10-FF-000143', NULL, 'Sensor histidine kinase', 133, NULL, NULL, 154185),
(154186, '1.10.1870.10-FF-000015', NULL, 'Uncharacterized protein', 135, NULL, NULL, 154186),
(154187, '3.30.70.330-FF-002167', NULL, NULL, 141, NULL, NULL, 154187),
(154188, '1.20.58.60-FF-000378', NULL, 'AGAP009554-PA', 285, NULL, NULL, 154188),
(154189, '3.90.70.10-FF-000238', NULL, 'Putative calpain-like cysteine peptidase', 150, NULL, NULL, 154189),
(154190, '3.20.20.80-FF-000422', NULL, 'Alpha-L-arabinofuranosidase 1', 121, NULL, NULL, 154190),
(154191, '1.20.1070.10-FF-000805', NULL, 'Uncharacterized protein', 260, NULL, NULL, 154191),
(154192, '1.25.40.10-FF-004786', NULL, 'Uncharacterized protein', 179, NULL, NULL, 154192),
(154193, '2.10.25.10-FF-000898', NULL, 'Crumbs family member 1, photoreceptor morphogenesis associated', 38, NULL, NULL, 154193),
(154194, '2.60.120.650-FF-000205', NULL, 'Predicted protein', 142, NULL, NULL, 154194),
(154195, '1.10.30.50-FF-000014', NULL, 'SNF2 domain-containing protein / helicase domain-containing protein / HNH endonuclease domain-containing protein', 137, NULL, NULL, 154195),
(154196, '2.60.40.150-FF-000176', NULL, 'Synaptotagmin 8', 133, NULL, NULL, 154196),
(154197, '3.40.50.300-FF-004012', NULL, 'ATP-dependent RNA helicase', 192, NULL, NULL, 154197),
(154198, '3.30.710.10-FF-000436', NULL, 'Uncharacterized protein', 51, NULL, NULL, 154198),
(154199, '2.60.40.60-FF-000277', NULL, 'DE-cadherin', 103, NULL, NULL, 154199),
(154200, '1.25.10.10-FF-003177', NULL, 'Predicted protein', 322, NULL, NULL, 154200),
(154201, '1.10.274.30-FF-000018', NULL, 'Protein CBG13694', 194, NULL, NULL, 154201),
(154202, '3.90.228.10-FF-000032', NULL, 'Poly [ADP-ribose] polymerase', 165, NULL, NULL, 154202),
(154203, '3.10.430.100-FF-000009', NULL, '50S ribosomal protein L9', 90, NULL, NULL, 154203),
(154204, '3.40.50.1820-FF-001246', NULL, 'Chromosome 7, whole genome shotgun sequence', 317, NULL, NULL, 154204),
(154205, '1.25.40.720-FF-000026', NULL, 'Uncharacterized protein', 133, NULL, NULL, 154205),
(154206, '3.20.100.10-FF-000004', NULL, 'Uncharacterized protein', 257, NULL, NULL, 154206),
(154207, '3.40.50.300-FF-007250', NULL, 'Uncharacterized protein', 159, NULL, NULL, 154207),
(154208, '2.60.40.3640-FF-000001', NULL, NULL, 120, NULL, NULL, 154208),
(154209, '3.30.497.10-FF-000057', NULL, 'GM20478', 218, NULL, NULL, 154209),
(154210, '1.10.510.10-FF-000596', NULL, 'CK1 family protein kinase', 324, NULL, NULL, 154210),
(154211, '3.40.50.150-FF-001437', NULL, NULL, 148, NULL, NULL, 154211);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(154212, '2.30.29.30-FF-000979', NULL, 'Class VII unconventional myosin', 87, NULL, NULL, 154212),
(154213, '3.90.640.10-FF-000125', NULL, 'Actin related protein 3, putative', 99, NULL, NULL, 154213),
(154214, '3.40.50.2300-FF-000070', NULL, 'Glutamate receptor, ionotropic, delta 1b', 232, NULL, NULL, 154214),
(154215, '3.30.70.330-FF-002953', NULL, NULL, 155, NULL, NULL, 154215),
(154216, '3.10.50.10-FF-000044', NULL, 'AGAP011033-PA', 72, NULL, NULL, 154216),
(154217, '1.10.10.60-FF-000600', NULL, 'Pyruvate carboxylase', 47, NULL, NULL, 154217),
(154218, '3.50.50.60-FF-000219', NULL, 'Ubiquinone biosynthesis hydroxylase', 138, NULL, NULL, 154218),
(154219, '1.25.40.10-FF-004893', NULL, 'Pentatricopeptide repeat protein PPR868-14', 94, NULL, NULL, 154219),
(154220, '3.40.50.150-FF-000347', NULL, 'Methyltransferase', 300, NULL, NULL, 154220),
(154221, '3.10.50.40-FF-000148', NULL, 'Trigger factor', 87, NULL, NULL, 154221),
(154222, '3.10.10.10-FF-000030', NULL, NULL, 106, NULL, NULL, 154222),
(154223, '2.130.10.10-FF-004523', NULL, 'Protein CBG19705', 349, NULL, NULL, 154223),
(154224, '2.70.220.10-FF-000006', NULL, 'GM24104', 143, NULL, NULL, 154224),
(154225, '3.40.850.10-FF-000332', NULL, 'Kifc1, putative', 340, NULL, NULL, 154225),
(154226, '2.60.40.10-FF-005158', NULL, NULL, 95, NULL, NULL, 154226),
(154227, '3.30.160.60-FF-000717', NULL, 'MDS1 and EVI1 complex locus protein EVI1-A', 26, NULL, NULL, 154227),
(154228, '3.30.40.10-FF-002285', NULL, 'Histone-lysine N-methyltransferase', 45, NULL, NULL, 154228),
(154229, '2.170.130.20-FF-000017', NULL, NULL, 68, NULL, NULL, 154229),
(154230, '1.20.120.230-FF-000011', NULL, 'Catenin alpha 1', 131, NULL, NULL, 154230),
(154231, '3.80.10.10-FF-001415', NULL, 'Uncharacterized protein', 149, NULL, NULL, 154231),
(154232, '3.40.30.10-FF-000210', NULL, 'nucleoredoxin', 143, NULL, NULL, 154232),
(154233, '3.30.160.60-FF-003045', NULL, NULL, 28, NULL, NULL, 154233),
(154234, '3.50.50.60-FF-000130', NULL, '3-oxosteroid 1-dehydrogenase', 84, NULL, NULL, 154234),
(154235, '3.60.21.10-FF-000289', NULL, 'Uncharacterized protein', 156, NULL, NULL, 154235),
(154236, '1.10.287.70-FF-000633', NULL, 'Predicted protein', 199, NULL, NULL, 154236),
(154237, '3.30.60.190-FF-000003', NULL, 'HIT-type Zinc finger family protein', 44, NULL, NULL, 154237),
(154238, '1.10.510.10-FF-004339', NULL, NULL, 131, NULL, NULL, 154238),
(154239, '3.20.20.70-FF-000110', NULL, '1-(5-phosphoribosyl)-5-[(5-phosphoribosylamino)methylideneamino] imidazole-4-carboxamide isomerase, chloroplastic', 255, NULL, NULL, 154239),
(154240, '3.40.525.10-FF-000060', NULL, 'Uncharacterized protein', 59, NULL, NULL, 154240),
(154241, '3.30.70.330-FF-001548', NULL, NULL, 115, NULL, NULL, 154241),
(154242, '2.40.50.90-FF-000029', NULL, 'Probable endonuclease lcl3', 172, NULL, NULL, 154242),
(154243, '1.25.40.660-FF-000002', NULL, 'Vacuolar protein sorting-associated protein 35', 311, NULL, NULL, 154243),
(154244, '3.30.450.20-FF-000402', NULL, 'Diguanylate cyclase', 132, NULL, NULL, 154244),
(154245, '1.20.1070.10-FF-001424', NULL, 'Uncharacterized protein', 228, NULL, NULL, 154245),
(154246, '2.130.10.10-FF-000139', NULL, 'WD repeat domain 36', 329, NULL, NULL, 154246),
(154247, '1.10.4020.10-FF-000013', NULL, 'Zinc finger protein 444', 84, NULL, NULL, 154247),
(154248, '2.60.260.20-FF-000042', NULL, 'Protein SIS1', 96, NULL, NULL, 154248),
(154249, '4.10.60.10-FF-000008', NULL, 'Cleavage and polyadenylation specificity factor subunit 4', 41, NULL, NULL, 154249),
(154250, '1.20.58.390-FF-000262', NULL, 'Uncharacterized protein', 93, NULL, NULL, 154250),
(154251, '1.10.510.10-FF-000607', NULL, 'Cyclin-dependent-like kinase 5', 151, NULL, NULL, 154251),
(154252, '3.10.450.580-FF-000016', NULL, 'Mediator of RNA polymerase II transcription subunit 6', 167, NULL, NULL, 154252),
(154253, '1.10.150.780-FF-000010', NULL, 'Uncharacterized protein', 125, NULL, NULL, 154253),
(154254, '1.10.510.10-FF-001119', NULL, 'Aurora kinase A', 138, NULL, NULL, 154254),
(154255, '1.10.10.2360-FF-000005', NULL, 'Putative nuclear pore outer ring', 40, NULL, NULL, 154255);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(154256, '2.30.29.240-FF-000003', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 139, NULL, NULL, 154256),
(154257, '1.20.1250.20-FF-002144', NULL, 'Acetyl-coenzyme A transporter, putative', 201, NULL, NULL, 154257),
(154258, '2.60.40.10-FF-002741', NULL, 'Receptor-type tyrosine-protein phosphatase beta', 82, NULL, NULL, 154258),
(154259, '3.40.50.300-FF-006827', NULL, 'Uncharacterized protein', 273, NULL, NULL, 154259),
(154260, '1.25.10.10-FF-001524', NULL, 'RING-type E3 ubiquitin transferase', 119, NULL, NULL, 154260),
(154261, '1.10.287.70-FF-000105', NULL, 'Eye-enriched kainate receptor, isoform A', 156, NULL, NULL, 154261),
(154262, '1.20.1070.10-FF-001969', NULL, 'Uncharacterized protein', 181, NULL, NULL, 154262),
(154263, '1.20.58.60-FF-000743', NULL, 'Dystonin', 80, NULL, NULL, 154263),
(154264, '3.40.1410.10-FF-000006', NULL, 'Transcriptional regulator, GntR family', 164, NULL, NULL, 154264),
(154265, '1.20.1290.10-FF-000007', NULL, 'YJR111C-like protein', 184, NULL, NULL, 154265),
(154266, '3.60.60.30-FF-000003', NULL, 'Phospholipase B-like', 565, NULL, NULL, 154266),
(154267, '1.10.150.320-FF-000001', NULL, 'Competence protein ComEA helix-hairpin-helix repeat region', 75, NULL, NULL, 154267),
(154268, '4.10.280.10-FF-000122', NULL, 'Retrograde regulation protein 1', 60, NULL, NULL, 154268),
(154269, '2.60.40.150-FF-000428', NULL, 'Phosphoinositide phospholipase C', 167, NULL, NULL, 154269),
(154270, '3.40.350.10-FF-000075', NULL, 'Uncharacterized protein', 84, NULL, NULL, 154270),
(154271, '3.30.1020.10-FF-000001', NULL, '1-Cys peroxiredoxin', 69, NULL, NULL, 154271),
(154272, '3.30.470.10-FF-000029', NULL, '4-amino-4-deoxychorismate lyase', 110, NULL, NULL, 154272),
(154273, '1.25.40.10-FF-004078', NULL, 'Uncharacterized protein', 157, NULL, NULL, 154273),
(154274, '3.30.70.330-FF-000823', NULL, 'Uncharacterized protein, isoform A', 115, NULL, NULL, 154274),
(154275, '3.40.30.10-FF-000682', NULL, 'Uncharacterized protein', 91, NULL, NULL, 154275),
(154276, '3.80.10.10-FF-000111', NULL, 'LRR receptor-like serine/threonine-protein kinase ERECTA', 125, NULL, NULL, 154276),
(154277, '3.40.50.300-FF-004720', NULL, 'Predicted protein', 242, NULL, NULL, 154277),
(154278, '3.30.160.60-FF-001122', NULL, 'Zinc finger protein 180', 31, NULL, NULL, 154278),
(154279, '3.30.70.270-FF-000215', NULL, NULL, 112, NULL, NULL, 154279),
(154280, '2.30.29.30-FF-000507', NULL, 'AGC protein kinase', 124, NULL, NULL, 154280),
(154281, '1.10.8.10-FF-000051', NULL, 'ubiquitin-associated and SH3 domain-containing protein B', 42, NULL, NULL, 154281),
(154282, '2.60.200.20-FF-000066', NULL, 'Kinesin protein', 101, NULL, NULL, 154282),
(154283, '3.30.420.40-FF-000529', NULL, 'Actin-like ATPase domain-containing protein', 94, NULL, NULL, 154283),
(154284, '1.10.575.10-FF-000015', NULL, 'S1/P1 Nuclease', 266, NULL, NULL, 154284),
(154285, '3.30.710.10-FF-000184', NULL, 'BTB/POZ domain and ankyrin repeat-containing protein NPR1', 196, NULL, NULL, 154285),
(154286, '1.10.8.60-FF-000060', NULL, 'peroxisome biogenesis factor 1', 60, NULL, NULL, 154286),
(154287, '3.10.129.10-FF-000140', NULL, 'Putative thioesterase', 134, NULL, NULL, 154287),
(154288, '3.40.50.1820-FF-000734', NULL, 'LIPaSe related', 226, NULL, NULL, 154288),
(154289, '3.30.1490.180-FF-000033', NULL, 'Uncharacterized protein', 31, NULL, NULL, 154289),
(154290, '1.10.10.60-FF-000128', NULL, 'Putative ZZ-type zinc finger-containing protein 3', 54, NULL, NULL, 154290),
(154291, '3.30.1520.10-FF-000146', NULL, 'Uncharacterized protein', 156, NULL, NULL, 154291),
(154292, '1.20.200.10-FF-000025', NULL, 'Argininosuccinate lyase chloroplastic', 169, NULL, NULL, 154292),
(154293, '2.60.40.10-FF-003360', NULL, 'Plexin-2', 88, NULL, NULL, 154293),
(154294, '2.170.150.10-FF-000015', NULL, 'Uncharacterized protein', 134, NULL, NULL, 154294),
(154295, '2.30.30.140-FF-000161', NULL, 'Polycomblike, isoform B', 68, NULL, NULL, 154295),
(154296, '1.25.10.10-FF-000687', NULL, 'Condensin complex subunit 1', 246, NULL, NULL, 154296),
(154297, '1.10.287.370-FF-000015', NULL, 'unconventional prefoldin RPB5 interactor 1', 79, NULL, NULL, 154297);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(154298, '1.10.10.2010-FF-000007', NULL, NULL, 75, NULL, NULL, 154298),
(154299, '3.40.50.300-FF-000870', NULL, 'MutS protein homolog 4', 294, NULL, NULL, 154299),
(154300, '3.30.2130.10-FF-000009', NULL, 'Aspartate kinase', 155, NULL, NULL, 154300),
(154301, '2.60.40.1460-FF-000010', NULL, 'Integrin alpha pat-2', 172, NULL, NULL, 154301),
(154302, '3.40.225.10-FF-000020', NULL, 'Methylthioribulose-1-phosphate dehydratase', 213, NULL, NULL, 154302),
(154303, '3.40.50.460-FF-000013', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase', 190, NULL, NULL, 154303),
(154304, '3.40.50.300-FF-005232', NULL, 'Gluconokinase', 201, NULL, NULL, 154304),
(154305, '2.130.10.10-FF-000471', NULL, 'Peptidylprolyl isomerase domain and WD repeat-containing protein', 185, NULL, NULL, 154305),
(154306, '3.30.500.10-FF-000027', NULL, NULL, 182, NULL, NULL, 154306),
(154307, '2.40.10.10-FF-000413', NULL, 'Serine protease H164', 234, NULL, NULL, 154307),
(154308, '3.30.710.10-FF-000060', NULL, 'Potassium voltage-gated channel modifier subfamily G member 3', 118, NULL, NULL, 154308),
(154309, '1.25.40.10-FF-000840', NULL, 'Pentatricopeptide repeat-containing protein At3g12770', 119, NULL, NULL, 154309),
(154310, '3.30.160.60-FF-005607', NULL, NULL, 35, NULL, NULL, 154310),
(154311, '3.40.50.300-FF-005541', NULL, 'ADP-ribosylation factor-like protein 5', 39, NULL, NULL, 154311),
(154312, '1.10.287.70-FF-000094', NULL, 'Two pore calcium channel protein 1', 112, NULL, NULL, 154312),
(154313, '3.30.200.20-FF-001305', NULL, 'Dual specificity protein phosphatase, putative', 103, NULL, NULL, 154313),
(154314, '2.40.30.130-FF-000032', NULL, 'Alanyl-tRNA editing protein AlaX-M', 88, NULL, NULL, 154314),
(154315, '1.20.120.350-FF-000120', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 128, NULL, NULL, 154315),
(154316, '3.30.450.60-FF-000043', NULL, 'AP complex subunit sigma', 158, NULL, NULL, 154316),
(154317, '3.30.710.10-FF-000217', NULL, 'Rho-related BTB domain-containing 1', 96, NULL, NULL, 154317),
(154318, '2.60.40.420-FF-000077', NULL, 'SKU5 similar 17', 122, NULL, NULL, 154318),
(154319, '2.60.40.60-FF-000058', NULL, 'FAT atypical cadherin 3', 106, NULL, NULL, 154319),
(154320, '2.130.10.10-FF-005142', NULL, 'AGAP006535-PA', 283, NULL, NULL, 154320),
(154321, '3.40.50.1240-FF-000083', NULL, 'Fructose-2,6-bisphosphatase, putative', 125, NULL, NULL, 154321),
(154322, '3.80.10.10-FF-002820', NULL, 'Uncharacterized protein', 114, NULL, NULL, 154322),
(154323, '4.10.280.10-FF-000100', NULL, 'Transcription factor BEE 3', 64, NULL, NULL, 154323),
(154324, '3.80.10.10-FF-000999', NULL, 'Receptor-like protein kinase HSL1', 58, NULL, NULL, 154324),
(154325, '3.40.1190.20-FF-000042', NULL, 'Probable thiamine biosynthetic bifunctional enzyme', 281, NULL, NULL, 154325),
(154326, '2.130.10.10-FF-004742', NULL, 'Uncharacterized protein', 162, NULL, NULL, 154326),
(154327, '3.30.40.10-FF-001666', NULL, 'Pentatricopeptide repeat-containing protein', 84, NULL, NULL, 154327),
(154328, '3.10.100.10-FF-000288', NULL, NULL, 149, NULL, NULL, 154328),
(154329, '3.30.160.60-FF-001336', NULL, 'Zinc finger protein 334', 28, NULL, NULL, 154329),
(154330, '2.30.30.40-FF-000345', NULL, 'serine-rich adhesin for platelets isoform X2', 74, NULL, NULL, 154330),
(154331, '2.10.25.10-FF-000589', NULL, 'Multiple epidermal growth factor-like domains 9', 54, NULL, NULL, 154331),
(154332, '3.30.160.60-FF-003354', NULL, 'Zinc finger protein 555 isoform 2', 27, NULL, NULL, 154332),
(154333, '1.10.460.10-FF-000035', NULL, 'DNA topoisomerase', 100, NULL, NULL, 154333),
(154334, '3.60.60.10-FF-000008', NULL, 'Mutant tan', 281, NULL, NULL, 154334),
(154335, '3.40.850.10-FF-000438', NULL, 'Uncharacterized protein', 136, NULL, NULL, 154335),
(154336, '2.40.110.10-FF-000061', NULL, 'Butyryl-CoA dehydrogenase', 117, NULL, NULL, 154336),
(154337, '1.20.1560.10-FF-000551', NULL, 'Uncharacterized protein', 162, NULL, NULL, 154337),
(154338, '2.20.160.10-FF-000001', NULL, 'Titin-cap (Telethonin)', 84, NULL, NULL, 154338),
(154339, '1.10.10.2330-FF-000007', NULL, 'Phenylalanine-tRNA ligase, alpha subunit', 57, NULL, NULL, 154339);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(154340, '2.10.25.10-FF-001207', NULL, 'signal peptide, CUB and EGF-like domain-containing protein 2 isoform X1', 34, NULL, NULL, 154340),
(154341, '3.30.505.10-FF-000111', NULL, 'Suppressor of cytokine signaling, invertebrate', 132, NULL, NULL, 154341),
(154342, '1.20.58.100-FF-000001', NULL, 'Succinate dehydrogenase flavoprotein subunit (SdhA)', 117, NULL, NULL, 154342),
(154343, '3.30.40.10-FF-002066', NULL, 'Uncharacterized protein', 89, NULL, NULL, 154343),
(154344, '1.20.1070.10-FF-000244', NULL, 'galanin receptor type 3', 322, NULL, NULL, 154344),
(154345, '1.10.8.10-FF-000303', NULL, 'Uncharacterized protein', 57, NULL, NULL, 154345),
(154346, '1.20.5.1700-FF-000007', NULL, 'Homer scaffold protein 3b', 76, NULL, NULL, 154346),
(154347, '3.30.70.330-FF-000244', NULL, 'serine/arginine-rich splicing factor SR34A-like', 111, NULL, NULL, 154347),
(154348, '3.40.50.1820-FF-000173', NULL, 'Alpha/beta hydrolase', 283, NULL, NULL, 154348),
(154349, '2.120.10.80-FF-000334', NULL, 'Uncharacterized protein', 128, NULL, NULL, 154349),
(154350, '3.30.470.20-FF-000021', NULL, 'Biotin carboxylase', 241, NULL, NULL, 154350),
(154351, '1.10.510.10-FF-002541', NULL, 'Mitogen-activated protein kinase kinase kinase 17', 302, NULL, NULL, 154351),
(154352, '2.40.290.30-FF-000006', NULL, 'Mediator of RNA polymerase II transcription subunit 25', 163, NULL, NULL, 154352),
(154353, '3.30.160.20-FF-000155', NULL, 'Os04g0529500 protein', 72, NULL, NULL, 154353),
(154354, '3.30.70.330-FF-002931', NULL, NULL, 120, NULL, NULL, 154354),
(154355, '3.40.190.10-FF-000382', NULL, 'Nitrate ABC transporter substrate-binding protein', 204, NULL, NULL, 154355),
(154356, '3.40.910.10-FF-000011', NULL, 'Deoxyhypusine synthase regulatory subunit', 342, NULL, NULL, 154356),
(154357, '2.80.10.50-FF-000058', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 138, NULL, NULL, 154357),
(154358, '3.30.43.10-FF-000049', NULL, 'UDP-N-acetylenolpyruvoylglucosamine reductase', 80, NULL, NULL, 154358),
(154359, '1.25.40.180-FF-000044', NULL, 'Eukaryotic translation initiation factor 4G1, isoform B', 261, NULL, NULL, 154359),
(154360, '2.20.25.10-FF-000049', NULL, 'DNA-directed RNA polymerase subunit', 55, NULL, NULL, 154360),
(154361, '2.70.170.10-FF-000142', NULL, 'Transmembrane ion channel', 212, NULL, NULL, 154361),
(154362, '2.60.40.10-FF-001252', NULL, 'Hemicentin 1', 89, NULL, NULL, 154362),
(154363, '4.10.1240.10-FF-000004', NULL, 'Adhesion G protein-coupled receptor L3', 59, NULL, NULL, 154363),
(154364, '1.10.510.10-FF-000287', NULL, 'probable LRR receptor-like serine/threonine-protein kinase RKF3', 203, NULL, NULL, 154364),
(154365, '1.10.630.10-FF-000318', NULL, 'Uncharacterized protein', 178, NULL, NULL, 154365),
(154366, '2.160.20.10-FF-000077', NULL, 'F-box protein 11', 179, NULL, NULL, 154366),
(154367, '3.60.110.10-FF-000103', NULL, NULL, 306, NULL, NULL, 154367),
(154368, '1.10.150.220-FF-000011', NULL, NULL, 62, NULL, NULL, 154368),
(154369, '1.10.10.10-FF-001451', NULL, 'ATP-dependent RNA helicase', 99, NULL, NULL, 154369),
(154370, '2.120.10.30-FF-000235', NULL, 'Putative Nhl ring finger b-box coiled coil domain containing family member nhl-3', 99, NULL, NULL, 154370),
(154371, '3.40.50.12780-FF-000031', NULL, 'Enterobactin synthase component E', 430, NULL, NULL, 154371),
(154372, '2.40.10.10-FF-000519', NULL, NULL, 40, NULL, NULL, 154372),
(154373, '2.40.50.140-FF-000781', NULL, NULL, 156, NULL, NULL, 154373),
(154374, '2.40.160.50-FF-000008', NULL, 'Mitochondrial outer membrane beta-barrel protein Tob55', 355, NULL, NULL, 154374),
(154375, '3.40.640.10-FF-000395', NULL, 'Uncharacterized protein', 74, NULL, NULL, 154375),
(154376, '3.10.110.10-FF-000193', NULL, 'Ubiquitin-conjugating enzyme/RWD-like protein', 159, NULL, NULL, 154376),
(154377, '1.10.10.10-FF-000832', NULL, 'E2F-like (Mammalian transcription factor)', 76, NULL, NULL, 154377),
(154378, '1.20.1250.20-FF-000199', NULL, 'Probable anion transporter 7', 202, NULL, NULL, 154378),
(154379, '3.80.10.10-FF-003669', NULL, 'Uncharacterized protein', 223, NULL, NULL, 154379);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(154380, '1.25.10.10-FF-003413', NULL, 'Uncharacterized protein', 342, NULL, NULL, 154380),
(154381, '6.10.140.2220-FF-000054', NULL, 'SD27884p', 53, NULL, NULL, 154381),
(154382, '1.10.510.10-FF-001580', NULL, 'Uncharacterized protein', 236, NULL, NULL, 154382),
(154383, '3.10.450.10-FF-000044', NULL, 'Uncharacterized protein', 103, NULL, NULL, 154383),
(154384, '2.160.10.10-FF-000104', NULL, 'Uncharacterized protein', 114, NULL, NULL, 154384),
(154385, '3.20.20.80-FF-000528', NULL, 'Glucan 13-beta-glucosidase', 177, NULL, NULL, 154385),
(154386, '3.80.10.10-FF-004130', NULL, 'Uncharacterized protein', 112, NULL, NULL, 154386),
(154387, '3.30.1330.30-FF-000002', NULL, 'NHP2-like protein 1 homolog', 128, NULL, NULL, 154387),
(154388, '3.30.70.3220-FF-000005', NULL, 'Multifunctional fusion protein', 126, NULL, NULL, 154388),
(154389, '2.130.10.10-FF-002741', NULL, 'notchless protein homolog 1 isoform X2', 276, NULL, NULL, 154389),
(154390, '3.30.230.10-FF-000181', NULL, 'DNA topoisomerase 2', 130, NULL, NULL, 154390),
(154391, '2.60.120.260-FF-000291', NULL, 'Os01g0531400 protein', 104, NULL, NULL, 154391),
(154392, '2.40.128.80-FF-000004', NULL, 'Dipeptidyl aminopeptidase 3', 129, NULL, NULL, 154392),
(154393, '3.40.1050.10-FF-000023', NULL, 'Carbonic anhydrase', 129, NULL, NULL, 154393),
(154394, '3.10.490.10-FF-000018', NULL, 'Uncharacterized protein, isoform B', 146, NULL, NULL, 154394),
(154395, '3.40.50.10810-FF-000036', NULL, 'Chromatin remodelling complex ATPase chain', 216, NULL, NULL, 154395),
(154396, '2.40.50.180-FF-000017', NULL, 'Chemotaxis protein CheV', 74, NULL, NULL, 154396),
(154397, '3.20.20.80-FF-000186', NULL, 'Alpha glucosidase-like protein', 355, NULL, NULL, 154397),
(154398, '2.10.80.10-FF-000014', NULL, 'Dickkopf-1', 87, NULL, NULL, 154398),
(154399, '3.30.420.10-FF-000425', NULL, NULL, 138, NULL, NULL, 154399),
(154400, '3.40.50.720-FF-001041', NULL, 'Shikimate dehydrogenase (NADP(+))', 144, NULL, NULL, 154400),
(154401, '1.25.40.10-FF-002532', NULL, 'Pentatricopeptide repeat-containing protein At1g74600, chloroplastic', 116, NULL, NULL, 154401),
(154402, '3.30.230.70-FF-000046', NULL, 'Exosome complex component MTR3', 250, NULL, NULL, 154402),
(154403, '1.10.238.10-FF-001328', NULL, 'Calpain 10-like', 168, NULL, NULL, 154403),
(154404, '3.40.50.2000-FF-000007', NULL, 'Trehalose-6-phosphate synthase', 202, NULL, NULL, 154404),
(154405, '2.60.40.10-FF-000487', NULL, 'ADAMTS-like 3 isoform 1', 79, NULL, NULL, 154405),
(154406, '3.40.50.2300-FF-001143', NULL, NULL, 95, NULL, NULL, 154406),
(154407, '3.40.50.300-FF-006266', NULL, 'Uncharacterized protein', 297, NULL, NULL, 154407),
(154408, '2.60.40.10-FF-004562', NULL, NULL, 103, NULL, NULL, 154408),
(154409, '3.90.1580.10-FF-000001', NULL, 'Sulfatase modifying factor 1', 300, NULL, NULL, 154409),
(154410, '2.40.50.140-FF-000106', NULL, 'DNA polymerase III subunit alpha', 94, NULL, NULL, 154410),
(154411, '1.10.3730.10-FF-000005', NULL, 'Pyrroline-5-carboxylate reductase', 108, NULL, NULL, 154411),
(154412, '2.60.120.10-FF-000675', NULL, 'Predicted protein', 269, NULL, NULL, 154412),
(154413, '3.70.10.10-FF-000067', NULL, 'YALI0F06204p', 301, NULL, NULL, 154413),
(154414, '4.10.1060.50-FF-000002', NULL, 'Predicted protein', 21, NULL, NULL, 154414),
(154415, '1.25.10.10-FF-003071', NULL, 'Predicted protein', 253, NULL, NULL, 154415),
(154416, '3.30.160.60-FF-006479', NULL, NULL, 22, NULL, NULL, 154416),
(154417, '3.30.300.30-FF-000057', NULL, 'Nonribosomal siderophore peptide synthase SidC', 121, NULL, NULL, 154417),
(154418, '1.10.1060.10-FF-000021', NULL, 'Glutamate synthase', 155, NULL, NULL, 154418),
(154419, '1.20.920.10-FF-000136', NULL, 'Predicted protein', 137, NULL, NULL, 154419),
(154420, '1.10.287.110-FF-000387', NULL, 'Chaperone protein DNAJ, putative', 88, NULL, NULL, 154420),
(154421, '3.40.50.1000-FF-000371', NULL, 'Uncharacterized protein', 134, NULL, NULL, 154421),
(154422, '2.40.10.10-FF-000177', NULL, 'Serine protease', 230, NULL, NULL, 154422),
(154423, '2.60.40.10-FF-005866', NULL, NULL, 97, NULL, NULL, 154423);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(154424, '1.25.10.10-FF-002795', NULL, 'Uncharacterized protein', 186, NULL, NULL, 154424),
(154425, '1.10.150.20-FF-000285', NULL, 'UvrABC system protein C', 68, NULL, NULL, 154425),
(154426, '1.20.1740.10-FF-000172', NULL, 'Amino acid transporter (Eurofung)', 241, NULL, NULL, 154426),
(154427, '2.30.42.10-FF-000381', NULL, NULL, 60, NULL, NULL, 154427),
(154428, '2.60.40.60-FF-000586', NULL, 'Fat-like cadherin-related tumor suppressor homolog', 106, NULL, NULL, 154428),
(154429, '3.30.50.10-FF-000094', NULL, 'Os07g0246901 protein', 63, NULL, NULL, 154429),
(154430, '2.60.40.10-FF-002432', NULL, 'Tyrosine-protein kinase receptor', 78, NULL, NULL, 154430),
(154431, '3.40.50.1580-FF-000067', NULL, 'Uncharacterized protein', 126, NULL, NULL, 154431),
(154432, '3.80.10.10-FF-003293', NULL, 'Toll-like receptor 12', 76, NULL, NULL, 154432),
(154433, '3.10.180.10-FF-000051', NULL, 'Putative enzyme related to lactoylglutathione lyase', 121, NULL, NULL, 154433),
(154434, '3.30.70.330-FF-000458', NULL, 'U2 snRNP auxiliary factor large subunit', 110, NULL, NULL, 154434),
(154435, '1.25.40.10-FF-003241', NULL, 'Pentatricopeptide repeat-containing protein At3g46790, chloroplastic', 181, NULL, NULL, 154435),
(154436, '4.10.1000.10-FF-000133', NULL, 'Uncharacterized protein', 80, NULL, NULL, 154436),
(154437, '1.10.420.10-FF-000061', NULL, 'Uncharacterized protein', 14, NULL, NULL, 154437),
(154438, '2.40.170.20-FF-000039', NULL, 'TonB-dependent siderophore receptor', 532, NULL, NULL, 154438),
(154439, '1.10.472.10-FF-000607', NULL, 'Predicted protein', 11, NULL, NULL, 154439),
(154440, '3.30.200.20-FF-002233', NULL, 'Predicted protein', 37, NULL, NULL, 154440),
(154441, '2.60.120.620-FF-000101', NULL, 'Uncharacterized protein', 189, NULL, NULL, 154441),
(154442, '3.30.70.870-FF-000052', NULL, 'Uncharacterized protein', 56, NULL, NULL, 154442),
(154443, '3.50.50.60-FF-000585', NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', 149, NULL, NULL, 154443),
(154444, '3.40.50.1700-FF-000030', NULL, 'Beta-glucosidase', 282, NULL, NULL, 154444),
(154445, '3.40.50.150-FF-000908', NULL, 'Modification methylase MjaII', 181, NULL, NULL, 154445),
(154446, '3.20.20.80-FF-000219', NULL, 'Acidic mammalian chitinase', 250, NULL, NULL, 154446),
(154447, '1.25.40.70-FF-000015', NULL, 'Related to PIK1-phosphatidylinositol 4-kinase', 116, NULL, NULL, 154447),
(154448, '3.30.450.20-FF-000166', NULL, 'CMGC/MAPK protein kinase', 125, NULL, NULL, 154448),
(154449, '3.40.850.10-FF-000062', NULL, 'Kinesin-like protein', 356, NULL, NULL, 154449),
(154450, '1.10.1420.10-FF-000083', NULL, 'DNA mismatch repair protein Msh4, putative', 188, NULL, NULL, 154450),
(154451, '1.10.10.2740-FF-000012', NULL, 'Uncharacterized protein', 21, NULL, NULL, 154451),
(154452, '3.40.50.150-FF-001308', NULL, NULL, 212, NULL, NULL, 154452),
(154453, '2.130.10.10-FF-002180', NULL, 'Small nucleolar ribonucleoprotein complex subunit, putative (AFU_orthologue AFUA_4G07540)', 251, NULL, NULL, 154453),
(154454, '3.80.10.10-FF-002365', NULL, 'F-box and leucine-rich repeat protein 13', 86, NULL, NULL, 154454),
(154455, '2.40.50.110-FF-000002', NULL, 'Enterotoxin type A', 85, NULL, NULL, 154455),
(154456, '2.70.98.90-FF-000003', NULL, 'Membrane protein insertase YidC', 282, NULL, NULL, 154456),
(154457, '3.30.56.10-FF-000045', NULL, 'Uncharacterized protein', 45, NULL, NULL, 154457),
(154458, '3.40.50.1010-FF-000008', NULL, 'Meiosis regulator and mRNA stability factor 1', 148, NULL, NULL, 154458),
(154459, '3.40.50.720-FF-002002', NULL, 'Uncharacterized protein', 230, NULL, NULL, 154459),
(154460, '1.20.190.40-FF-000004', NULL, 'Major DNA-binding protein', 132, NULL, NULL, 154460),
(154461, '2.30.30.100-FF-000065', NULL, 'Small nuclear ribonucleoprotein E', 88, NULL, NULL, 154461),
(154462, '3.40.50.970-FF-000149', NULL, 'Pyruvate-flavodoxin oxidoreductase', 66, NULL, NULL, 154462),
(154463, '3.10.490.20-FF-000010', NULL, 'Dynein heavy chain, putative', 144, NULL, NULL, 154463),
(154464, '3.30.470.10-FF-000052', NULL, 'Branched chain amino acid transaminase 1', 25, NULL, NULL, 154464);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(154465, '3.30.830.10-FF-000147', NULL, 'A-factor-processing enzyme, putative', 241, NULL, NULL, 154465),
(154466, '1.10.510.10-FF-003013', NULL, NULL, 215, NULL, NULL, 154466),
(154467, '3.60.40.10-FF-000209', NULL, 'Protein phosphatase 2C, putative', 206, NULL, NULL, 154467),
(154468, '3.40.50.150-FF-001061', NULL, 'Predicted protein', 259, NULL, NULL, 154468),
(154469, '3.40.50.300-FF-001286', NULL, 'ABC transporter, ATP-binding protein', 244, NULL, NULL, 154469),
(154470, '1.20.58.80-FF-000064', NULL, 'Uncharacterized protein', 114, NULL, NULL, 154470),
(154471, '1.25.10.10-FF-000198', NULL, 'GCN1, eIF2 alpha kinase activator homolog', 148, NULL, NULL, 154471),
(154472, '3.40.50.2000-FF-000098', NULL, 'UDP-N-acetylglucosamine transferase subunit ALG14 homolog', 179, NULL, NULL, 154472),
(154473, '1.25.40.10-FF-002077', NULL, 'Putative adenylate cyclase', 317, NULL, NULL, 154473),
(154474, '2.60.220.50-FF-000172', NULL, 'Uncharacterized protein', 206, NULL, NULL, 154474),
(154475, '2.60.40.10-FF-000829', NULL, 'Sialic acid-binding Ig-like lectin 8', 134, NULL, NULL, 154475),
(154476, '3.40.50.300-FF-006721', NULL, 'Uncharacterized protein', 72, NULL, NULL, 154476),
(154477, '2.60.40.290-FF-000004', NULL, 'Putative chitinase', 109, NULL, NULL, 154477),
(154478, '2.30.40.10-FF-000090', NULL, 'N-acyl-D-amino-acid deacylase family protein', 80, NULL, NULL, 154478),
(154479, '3.90.190.20-FF-000025', NULL, 'Folylpolyglutamate synthase/dihydrofolate synthase', 132, NULL, NULL, 154479),
(154480, '3.30.70.890-FF-000058', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 115, NULL, NULL, 154480),
(154481, '1.10.510.10-FF-003721', NULL, NULL, 154, NULL, NULL, 154481),
(154482, '3.30.1490.20-FF-000050', NULL, 'Succinate--CoA ligase (ADP-forming)', 61, NULL, NULL, 154482),
(154483, '3.30.1330.50-FF-000008', NULL, 'Bifunctional enzyme IspD/IspF', 163, NULL, NULL, 154483),
(154484, '2.40.30.10-FF-000521', NULL, 'Ribosome-releasing factor 2, mitochondrial-like Protein', 137, NULL, NULL, 154484),
(154485, '3.30.160.60-FF-002050', NULL, 'zinc finger protein 527 isoform X1', 35, NULL, NULL, 154485),
(154486, '3.30.70.600-FF-000016', NULL, 'Probable 28S ribosomal protein S10, mitochondrial', 106, NULL, NULL, 154486),
(154487, '1.25.50.10-FF-000009', NULL, 'Membrane alanine aminopeptidase', 323, NULL, NULL, 154487),
(154488, '1.20.120.1900-FF-000064', NULL, 'Spindle pole body component', 312, NULL, NULL, 154488),
(154489, '2.60.40.10-FF-004871', NULL, NULL, 95, NULL, NULL, 154489),
(154490, '3.30.470.30-FF-000058', NULL, 'mRNA capping enzyme alpha subunit', 274, NULL, NULL, 154490),
(154491, '1.20.1560.10-FF-000096', NULL, 'ABC transporter related', 313, NULL, NULL, 154491),
(154492, '1.10.472.10-FF-000389', NULL, 'Uncharacterized protein', 172, NULL, NULL, 154492),
(154493, '2.40.30.30-FF-000038', NULL, 'Uncharacterized protein', 135, NULL, NULL, 154493),
(154494, '2.30.30.490-FF-000024', NULL, 'Origin recognition complex subunit 1', 236, NULL, NULL, 154494),
(154495, '3.20.20.20-FF-000011', NULL, 'Dihydropteroate synthase', 285, NULL, NULL, 154495),
(154496, '1.20.5.2210-FF-000008', NULL, 'ATP synthase F(0) complex subunit B1, mitochondrial', 105, NULL, NULL, 154496),
(154497, '3.30.200.20-FF-002452', NULL, 'Uncharacterized protein', 58, NULL, NULL, 154497),
(154498, '3.40.50.300-FF-005338', NULL, 'Midasin', 107, NULL, NULL, 154498),
(154499, '2.30.29.30-FF-000294', NULL, 'WAS/WASL-interacting protein family member 1', 33, NULL, NULL, 154499),
(154500, '3.30.479.20-FF-000013', NULL, 'Elongation factor Ts', 91, NULL, NULL, 154500),
(154501, '2.60.40.10-FF-005490', NULL, NULL, 97, NULL, NULL, 154501),
(154502, '1.20.1250.20-FF-001379', NULL, 'Uncharacterized MFS-type transporter C1399.02', 193, NULL, NULL, 154502),
(154503, '2.40.100.10-FF-000088', NULL, 'Peptidyl-prolyl cis-trans isomerase CYP23', 181, NULL, NULL, 154503),
(154504, '1.10.510.10-FF-003160', NULL, NULL, 171, NULL, NULL, 154504),
(154505, '2.130.10.10-FF-004287', NULL, 'TATA box-binding protein-associated factor RNA polymerase I subunit C', 127, NULL, NULL, 154505);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(154506, '2.60.40.420-FF-000280', NULL, 'Uncharacterized protein', 48, NULL, NULL, 154506),
(154507, '3.30.260.10-FF-000019', NULL, '60 kDa heat shock mitochondrial', 92, NULL, NULL, 154507),
(154508, '3.60.15.10-FF-000157', NULL, 'Ribonuclease Z 2, mitochondrial', 101, NULL, NULL, 154508),
(154509, '1.25.10.10-FF-002143', NULL, 'Uncharacterized protein', 546, NULL, NULL, 154509),
(154510, '2.120.10.10-FF-000010', NULL, 'Sialidase B', 330, NULL, NULL, 154510),
(154511, '1.10.287.2620-FF-000023', NULL, 'Uncharacterized protein', 58, NULL, NULL, 154511),
(154512, '2.130.10.10-FF-001561', NULL, 'Small nucleolar ribonucleoprotein complex subunit (SOF1), putative', 107, NULL, NULL, 154512),
(154513, '2.60.40.10-FF-000976', NULL, 'V-set and immunoglobulin domain containing 8', 118, NULL, NULL, 154513),
(154514, '3.30.420.40-FF-000333', NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', 89, NULL, NULL, 154514),
(154515, '1.10.20.10-FF-000097', NULL, 'Histone H2A', 113, NULL, NULL, 154515),
(154516, '3.40.50.300-FF-000667', NULL, 'Dynein axonemal heavy chain 11', 182, NULL, NULL, 154516),
(154517, '1.20.1110.10-FF-000068', NULL, 'Calcium-transporting ATPase', 110, NULL, NULL, 154517),
(154518, '1.25.40.990-FF-000062', NULL, 'Uncharacterized protein', 134, NULL, NULL, 154518),
(154519, '4.10.830.30-FF-000002', NULL, '50S ribosomal protein L31 type B', 82, NULL, NULL, 154519),
(154520, '1.10.760.10-FF-000108', NULL, 'Uncharacterized protein', 136, NULL, NULL, 154520),
(154521, '1.25.10.10-FF-002704', NULL, 'Microtubule-associated protein 215 long isoform', 55, NULL, NULL, 154521),
(154522, '1.20.58.60-FF-000614', NULL, 'Spectrin repeat containing nuclear envelope protein 2', 138, NULL, NULL, 154522),
(154523, '1.25.10.10-FF-002452', NULL, 'Uncharacterized protein', 227, NULL, NULL, 154523),
(154524, '1.10.10.2030-FF-000002', NULL, 'KIN17 protein', 98, NULL, NULL, 154524),
(154525, '3.40.50.2000-FF-000659', NULL, 'Alpha-1,3/1,6-mannosyltransferase ALG2', 234, NULL, NULL, 154525),
(154526, '2.60.40.10-FF-004539', NULL, NULL, 90, NULL, NULL, 154526),
(154527, '3.40.50.720-FF-002221', NULL, 'Uncharacterized protein', 108, NULL, NULL, 154527),
(154528, '1.20.120.1080-FF-000121', NULL, 'Uncharacterized protein', 123, NULL, NULL, 154528),
(154529, '3.30.40.10-FF-000121', NULL, 'TNF receptor-associated factor', 56, NULL, NULL, 154529),
(154530, '1.10.510.10-FF-002760', NULL, NULL, 82, NULL, NULL, 154530),
(154531, '3.30.450.30-FF-000045', NULL, 'Profilin', 156, NULL, NULL, 154531),
(154532, '1.20.1050.130-FF-000039', NULL, 'Uncharacterized protein', 140, NULL, NULL, 154532),
(154533, '1.10.1200.10-FF-000100', NULL, 'Polyketide synthase type I', 82, NULL, NULL, 154533),
(154534, '2.60.40.10-FF-001813', NULL, 'Protein tyrosine phosphatase, receptor type B', 97, NULL, NULL, 154534),
(154535, '3.30.160.60-FF-002426', NULL, 'Unplaced genomic scaffold supercont1.20, whole genome shotgun sequence', 56, NULL, NULL, 154535),
(154536, '3.30.1360.40-FF-000052', NULL, 'Ribosome recycling factor, putative', 40, NULL, NULL, 154536),
(154537, '3.30.450.20-FF-000508', NULL, 'Histidine kinase', 113, NULL, NULL, 154537),
(154538, '1.10.10.10-FF-000271', NULL, 'HTH-type transcriptional regulator yhjB', 73, NULL, NULL, 154538),
(154539, '2.10.110.10-FF-000320', NULL, 'Uncharacterized protein', 79, NULL, NULL, 154539),
(154540, '1.25.40.10-FF-003460', NULL, 'Pentatricopeptide repeat-containing protein At5g12100, mitochondrial', 220, NULL, NULL, 154540),
(154541, '1.25.10.10-FF-001159', NULL, 'Uncharacterized protein', 280, NULL, NULL, 154541),
(154542, '3.60.10.10-FF-000152', NULL, 'DNase I-like protein', 360, NULL, NULL, 154542),
(154543, '1.25.40.10-FF-002521', NULL, 'Adenylate/guanylate cyclase domain-containing protein', 160, NULL, NULL, 154543),
(154544, '1.10.510.10-FF-001563', NULL, 'Protein kinase, putative', 281, NULL, NULL, 154544),
(154545, '1.10.472.10-FF-000529', NULL, 'Uncharacterized protein', 90, NULL, NULL, 154545),
(154546, '1.20.1070.10-FF-002014', NULL, 'Uncharacterized protein', 136, NULL, NULL, 154546); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(154547, '3.60.20.10-FF-000118', NULL, 'Proteasome endopeptidase complex', 244, NULL, NULL, 154547),
(154548, '2.130.10.10-FF-003242', NULL, 'Wdr1p', 229, NULL, NULL, 154548),
(154549, '3.40.50.300-FF-006277', NULL, 'Uncharacterized protein', 162, NULL, NULL, 154549),
(154550, '2.60.60.20-FF-000036', NULL, 'Lipase, endothelial', 128, NULL, NULL, 154550),
(154551, '3.40.50.300-FF-003629', NULL, 'Predicted protein', 314, NULL, NULL, 154551),
(154552, '2.60.120.340-FF-000028', NULL, 'Uncharacterized protein', 94, NULL, NULL, 154552),
(154553, '2.10.25.10-FF-000241', NULL, 'Fibulin-1', 44, NULL, NULL, 154553),
(154554, '3.30.160.60-FF-006456', NULL, NULL, 70, NULL, NULL, 154554),
(154555, '1.20.1120.10-FF-000001', NULL, 'Botulinum neurotoxin type A', 366, NULL, NULL, 154555),
(154556, '3.40.50.300-FF-000875', NULL, 'ABC transporter ATP-binding protein', 245, NULL, NULL, 154556),
(154557, '1.20.1560.10-FF-000427', NULL, 'p-GlycoProtein related', 683, NULL, NULL, 154557),
(154558, '1.10.3080.10-FF-000039', NULL, 'Chloride channel protein', 463, NULL, NULL, 154558),
(154559, '3.40.190.10-FF-000854', NULL, 'Uncharacterized protein', 66, NULL, NULL, 154559),
(154560, '2.60.40.10-FF-002645', NULL, 'Interleukin 4 receptor, tandem duplicate 1', 106, NULL, NULL, 154560),
(154561, '3.30.40.10-FF-000924', NULL, 'Putative RING zinc finger domain superfamily protein', 63, NULL, NULL, 154561),
(154562, '3.90.1180.10-FF-000021', NULL, NULL, 49, NULL, NULL, 154562),
(154563, '3.30.479.30-FF-000027', NULL, 'Putative transmembrane protein', 158, NULL, NULL, 154563),
(154564, '1.10.287.4070-FF-000014', NULL, 'Os02g0730200 protein', 40, NULL, NULL, 154564),
(154565, '1.10.510.10-FF-000040', NULL, 'Mitogen-activated protein kinase', 230, NULL, NULL, 154565),
(154566, '1.20.20.10-FF-000012', NULL, 'ATP synthase subunit c', 70, NULL, NULL, 154566),
(154567, '2.130.10.10-FF-000583', NULL, 'Katanin p80 WD40 repeat-containing subunit B1 homolog', 134, NULL, NULL, 154567),
(154568, '1.10.10.10-FF-001232', NULL, 'ORC1-type DNA replication protein', 109, NULL, NULL, 154568),
(154569, '1.20.140.150-FF-000053', NULL, 'EG:80H7.2 protein', 189, NULL, NULL, 154569),
(154570, '3.30.160.150-FF-000002', NULL, 'LPS-assembly lipoprotein LptE', 162, NULL, NULL, 154570),
(154571, '2.60.40.60-FF-000480', NULL, 'Protocadherin-23', 77, NULL, NULL, 154571),
(154572, '1.10.472.10-FF-000046', NULL, 'Transcription factor IIIB 50 kDa subunit', 108, NULL, NULL, 154572),
(154573, '1.10.10.60-FF-000572', NULL, 'Fis family transcriptional regulator', 51, NULL, NULL, 154573),
(154574, '3.40.50.10490-FF-000119', NULL, NULL, 168, NULL, NULL, 154574),
(154575, '3.30.70.580-FF-000061', NULL, 'tRNA pseudouridine synthase', 110, NULL, NULL, 154575),
(154576, '3.80.10.10-FF-000662', NULL, 'NACHT, LRR and PYD domains-containing protein 2', 421, NULL, NULL, 154576),
(154577, '3.30.70.330-FF-002509', NULL, NULL, 71, NULL, NULL, 154577),
(154578, '1.25.40.10-FF-000267', NULL, 'DAP3 binding cell death enhancer 1', 199, NULL, NULL, 154578),
(154579, '3.40.50.150-FF-000583', NULL, 'Uncharacterized protein', 254, NULL, NULL, 154579),
(154580, '3.40.50.300-FF-008531', NULL, 'Uncharacterized protein', 167, NULL, NULL, 154580),
(154581, '1.20.1730.10-FF-000132', NULL, 'Uncharacterized protein', 263, NULL, NULL, 154581),
(154582, '1.20.870.10-FF-000036', NULL, 'Kinase non-catalytic C-lobe domain containing 1', 234, NULL, NULL, 154582),
(154583, '1.10.510.10-FF-003266', NULL, NULL, 109, NULL, NULL, 154583),
(154584, '3.40.50.10330-FF-000004', NULL, 'NAD kinase', 129, NULL, NULL, 154584),
(154585, '3.30.160.60-FF-001673', NULL, 'Zinc finger protein 536', 27, NULL, NULL, 154585),
(154586, '4.10.60.10-FF-000019', NULL, 'Zinc finger CCHC domain-containing protein 2', 53, NULL, NULL, 154586),
(154587, '3.30.710.10-FF-000200', NULL, 'YLR108C-like protein', 106, NULL, NULL, 154587),
(154588, '3.40.390.10-FF-000043', NULL, 'Major allergen Asp F2', 184, NULL, NULL, 154588),
(154589, '2.10.109.10-FF-000019', NULL, 'Mitochondrial inner membrane protease subunit', 111, NULL, NULL, 154589);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(154590, '1.25.10.10-FF-001384', NULL, 'Uncharacterized protein', 223, NULL, NULL, 154590),
(154591, '3.40.50.1820-FF-000504', NULL, 'Carboxylic ester hydrolase', 521, NULL, NULL, 154591),
(154592, '1.10.510.10-FF-000944', NULL, 'Testis-specific serine/threonine-protein kinase 5', 291, NULL, NULL, 154592),
(154593, '3.30.160.60-FF-004427', NULL, NULL, 30, NULL, NULL, 154593),
(154594, '1.20.1070.10-FF-000457', NULL, 'Somatostatin receptor type 4', 328, NULL, NULL, 154594),
(154595, '3.30.300.320-FF-000002', NULL, 'N-acetylglucosamine-1-phosphotransferase subunits alpha/beta isoform X1', 122, NULL, NULL, 154595),
(154596, '3.90.226.10-FF-000218', NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', 115, NULL, NULL, 154596),
(154597, '1.10.287.3240-FF-000001', NULL, 'V-type proton ATPase subunit D', 211, NULL, NULL, 154597),
(154598, '2.60.40.10-FF-003590', NULL, NULL, 98, NULL, NULL, 154598),
(154599, '3.40.1380.10-FF-000008', NULL, 'ATP synthase gamma chain', 224, NULL, NULL, 154599),
(154600, '3.30.750.24-FF-000053', NULL, 'Anti-sigma F factor antagonist', 99, NULL, NULL, 154600),
(154601, '2.30.38.10-FF-000022', NULL, 'Uncharacterized protein', 113, NULL, NULL, 154601),
(154602, '2.40.37.10-FF-000087', NULL, NULL, 13, NULL, NULL, 154602),
(154603, '3.30.1330.30-FF-000098', NULL, 'Ribosomal protein L7Ae', 133, NULL, NULL, 154603),
(154604, '3.10.100.10-FF-000052', NULL, 'Lymphocyte antigen 75', 123, NULL, NULL, 154604),
(154605, '2.30.39.10-FF-000013', NULL, 'Serpin family I member 2', 162, NULL, NULL, 154605),
(154606, '3.80.10.10-FF-001067', NULL, 'Protein singed wings 2', 139, NULL, NULL, 154606),
(154607, '3.40.50.720-FF-001737', NULL, 'D-aspartate oxidase', 182, NULL, NULL, 154607),
(154608, '1.20.1270.10-FF-000085', NULL, 'Chaperone protein DnaK', 86, NULL, NULL, 154608),
(154609, '2.130.10.10-FF-002286', NULL, 'Transducin', 219, NULL, NULL, 154609),
(154610, '2.130.10.10-FF-001100', NULL, 'Blast:U4/U6 small nuclear ribonucleoprotein Prp4', 163, NULL, NULL, 154610),
(154611, '1.10.287.110-FF-000415', NULL, 'DnaJ domain containing protein, expressed', 98, NULL, NULL, 154611),
(154612, '1.20.58.60-FF-000726', NULL, 'Uncharacterized protein', 268, NULL, NULL, 154612),
(154613, '2.70.170.10-FF-000125', NULL, 'Uncharacterized protein', 185, NULL, NULL, 154613),
(154614, '2.30.29.30-FF-001362', NULL, 'Vps51/Vps67 protein, putative', 129, NULL, NULL, 154614),
(154615, '3.90.550.10-FF-000707', NULL, 'Dolichylphosphate beta-glucosyltransferase', 275, NULL, NULL, 154615),
(154616, '1.10.10.10-FF-001327', NULL, 'LysR family transcriptional regulator', 85, NULL, NULL, 154616),
(154617, '3.30.160.60-FF-000728', NULL, 'Zinc finger protein 521', 29, NULL, NULL, 154617),
(154618, '3.30.450.70-FF-000012', NULL, 'Trafficking protein particle complex subunit 1', 140, NULL, NULL, 154618),
(154619, '2.60.40.10-FF-001235', NULL, 'Interferon lambda receptor 1', 99, NULL, NULL, 154619),
(154620, '3.30.200.20-FF-000558', NULL, 'Receptor-like cytosolic serine/threonine-protein kinase RBK1', 104, NULL, NULL, 154620),
(154621, '3.40.50.300-FF-006974', NULL, 'Sulfotransferase', 310, NULL, NULL, 154621),
(154622, '2.10.70.10-FF-000188', NULL, 'Modular serine protease', 60, NULL, NULL, 154622),
(154623, '3.30.559.10-FF-000073', NULL, 'Nonribosomal peptide synthase SidE', 161, NULL, NULL, 154623),
(154624, '2.60.210.10-FF-000007', NULL, 'TNF receptor-associated factor', 185, NULL, NULL, 154624),
(154625, '3.40.1190.20-FF-000154', NULL, 'Fructokinase', 297, NULL, NULL, 154625),
(154626, '3.40.30.10-FF-000114', NULL, 'Prostaglandin E synthase 2', 91, NULL, NULL, 154626),
(154627, '1.20.120.1710-FF-000001', NULL, 'NAD-dependent histone deacetylase SIR2', 141, NULL, NULL, 154627),
(154628, '2.130.10.10-FF-000369', NULL, 'semaphorin-2A isoform X1', 483, NULL, NULL, 154628),
(154629, '2.130.10.10-FF-004765', NULL, 'Uncharacterized protein', 157, NULL, NULL, 154629),
(154630, '2.40.128.330-FF-000012', NULL, 'Predicted protein', 66, NULL, NULL, 154630),
(154631, '1.10.287.370-FF-000010', NULL, 'Protein UXT like', 140, NULL, NULL, 154631);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(154632, '3.30.230.10-FF-000057', NULL, 'DNA topoisomerase II large subunit', 120, NULL, NULL, 154632),
(154633, '1.10.730.10-FF-000146', NULL, 'Arginine--tRNA ligase', 121, NULL, NULL, 154633),
(154634, '3.40.50.1470-FF-000011', NULL, 'Uncharacterized protein', 224, NULL, NULL, 154634),
(154635, '3.30.40.10-FF-002274', NULL, 'Uncharacterized protein', 52, NULL, NULL, 154635),
(154636, '2.60.120.920-FF-000202', NULL, 'Uncharacterized protein', 90, NULL, NULL, 154636),
(154637, '3.30.2350.20-FF-000006', NULL, 'Multisubstrate pseudouridine synthase 7', 209, NULL, NULL, 154637),
(154638, '3.80.10.10-FF-001859', NULL, 'Uncharacterized protein, isoform B', 86, NULL, NULL, 154638),
(154639, '3.30.70.330-FF-001312', NULL, 'RNA-binding protein 44', 143, NULL, NULL, 154639),
(154640, '2.60.40.650-FF-000011', NULL, 'Oxidase', 114, NULL, NULL, 154640),
(154641, '2.10.25.10-FF-001067', NULL, 'Uncharacterized protein', 58, NULL, NULL, 154641),
(154642, '3.30.2400.10-FF-000002', NULL, 'HK97 family phage major capsid protein', 39, NULL, NULL, 154642),
(154643, '1.10.486.10-FF-000016', NULL, 'DNA helicase', 162, NULL, NULL, 154643),
(154644, '3.30.40.10-FF-000020', NULL, 'lysine-specific demethylase 2B isoform X1', 77, NULL, NULL, 154644),
(154645, '2.60.40.2160-FF-000001', NULL, 'Interleukin 17 receptor A', 166, NULL, NULL, 154645),
(154646, '3.90.190.20-FF-000048', NULL, 'Folylpolyglutamate synthase/dihydrofolate synthase', 137, NULL, NULL, 154646),
(154647, '2.10.90.10-FF-000088', NULL, 'Inhibin beta B chain', 113, NULL, NULL, 154647),
(154648, '3.40.630.10-FF-000079', NULL, 'Carboxypeptidase D', 137, NULL, NULL, 154648),
(154649, '3.30.2310.30-FF-000001', NULL, 'S-type pyocin protein', 102, NULL, NULL, 154649),
(154650, '3.40.50.300-FF-001831', NULL, 'DDX46 isoform 10', 196, NULL, NULL, 154650),
(154651, '4.10.1060.10-FF-000030', NULL, 'HECT E3 ubiquitin ligase', 38, NULL, NULL, 154651),
(154652, '3.80.10.10-FF-000448', NULL, 'Toll-like receptor 7', 146, NULL, NULL, 154652),
(154653, '3.40.850.10-FF-000192', NULL, 'Kinesin-like protein', 388, NULL, NULL, 154653),
(154654, '3.30.160.60-FF-005046', NULL, NULL, 26, NULL, NULL, 154654),
(154655, '1.10.220.150-FF-000017', NULL, 'ARF GTPase activator (Csx2), putative', 139, NULL, NULL, 154655),
(154656, '1.10.418.10-FF-000016', NULL, 'Probable fimbrin', 136, NULL, NULL, 154656),
(154657, '1.10.510.10-FF-002861', NULL, NULL, 220, NULL, NULL, 154657),
(154658, '3.40.50.300-FF-007233', NULL, 'Uncharacterized protein', 161, NULL, NULL, 154658),
(154659, '3.40.50.300-FF-006614', NULL, 'Muscle-specific beta 1 integrin-binding protein', 94, NULL, NULL, 154659),
(154660, '3.30.420.10-FF-000650', NULL, NULL, 199, NULL, NULL, 154660),
(154661, '1.10.238.10-FF-000923', NULL, 'Phosphoinositide phospholipase C', 77, NULL, NULL, 154661),
(154662, '1.10.1520.10-FF-000045', NULL, '39S ribosomal protein L44, mitochondrial', 144, NULL, NULL, 154662),
(154663, '1.10.533.10-FF-000076', NULL, 'Interferon-inducible protein AIM2', 95, NULL, NULL, 154663),
(154664, '3.40.30.10-FF-000906', NULL, 'Thioredoxin domain containing 15', 137, NULL, NULL, 154664),
(154665, '3.30.160.60-FF-000375', NULL, 'Zinc finger and BTB domain containing 5', 25, NULL, NULL, 154665),
(154666, '3.30.40.10-FF-000132', NULL, 'G2/M phase-specific E3 ubiquitin-protein ligase', 121, NULL, NULL, 154666),
(154667, '1.25.10.10-FF-003424', NULL, 'Uncharacterized protein', 302, NULL, NULL, 154667),
(154668, '3.10.580.10-FF-000020', NULL, 'Glycine betaine/L-proline ABC transporter, ATP-binding protein', 113, NULL, NULL, 154668),
(154669, '2.60.40.4060-FF-000003', NULL, 'Ferric chelate reductase 1', 136, NULL, NULL, 154669),
(154670, '1.10.533.10-FF-000188', NULL, 'Uncharacterized protein', 93, NULL, NULL, 154670),
(154671, '1.20.58.60-FF-000631', NULL, 'Spectrin repeat-containing, nuclear envelope 1b', 219, NULL, NULL, 154671),
(154672, '3.20.20.100-FF-000191', NULL, 'Uncharacterized protein', 105, NULL, NULL, 154672),
(154673, '2.160.10.10-FF-000109', NULL, 'Uncharacterized protein', 143, NULL, NULL, 154673),
(154674, '1.20.120.790-FF-000038', NULL, 'Uncharacterized protein', 50, NULL, NULL, 154674);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(154675, '3.10.20.90-FF-000526', NULL, 'Ubiquitin-like 7', 91, NULL, NULL, 154675),
(154676, '1.25.10.10-FF-002805', NULL, 'Predicted protein', 201, NULL, NULL, 154676),
(154677, '3.40.50.80-FF-000193', NULL, 'Ferric reductase-like transmembrane component', 133, NULL, NULL, 154677),
(154678, '3.30.40.10-FF-001329', NULL, 'AGAP000736-PA', 93, NULL, NULL, 154678),
(154679, '3.30.450.20-FF-000267', NULL, 'Voltage-dependent calcium channel subunit alpha-2/delta-1', 141, NULL, NULL, 154679),
(154680, '3.40.630.30-FF-000557', NULL, 'Uncharacterized protein', 127, NULL, NULL, 154680),
(154681, '1.10.238.10-FF-000699', NULL, 'EF-hand domain pair, putative', 86, NULL, NULL, 154681),
(154682, '3.10.120.10-FF-000047', NULL, 'Hect domain and RLD 2-like protein', 89, NULL, NULL, 154682),
(154683, '1.10.238.10-FF-000811', NULL, 'Uncharacterized protein', 72, NULL, NULL, 154683),
(154684, '3.30.450.20-FF-000155', NULL, 'Sensor histidine kinase TodS', 125, NULL, NULL, 154684),
(154685, '4.10.240.30-FF-000002', NULL, 'Tumor necrosis factor, alpha-induced protein 3', 36, NULL, NULL, 154685),
(154686, '1.20.1070.10-FF-001076', NULL, 'Histamine H2 receptor', 327, NULL, NULL, 154686),
(154687, '2.130.10.10-FF-005703', NULL, 'Uncharacterized protein', 417, NULL, NULL, 154687),
(154688, '3.40.50.1100-FF-000159', NULL, 'Cysteine synthase B protein', 21, NULL, NULL, 154688),
(154689, '3.30.420.40-FF-000193', NULL, 'Actin-like protein ARP6', 154, NULL, NULL, 154689),
(154690, '1.25.40.10-FF-002184', NULL, 'Pentatricopeptide repeat-containing protein At1g14470', 139, NULL, NULL, 154690),
(154691, '3.30.710.10-FF-000088', NULL, 'zinc finger and BTB domain-containing protein 41', 137, NULL, NULL, 154691),
(154692, '1.25.40.10-FF-003140', NULL, 'Uncharacterized protein', 134, NULL, NULL, 154692),
(154693, '2.60.40.10-FF-000279', NULL, 'Hemicentin 1', 93, NULL, NULL, 154693),
(154694, '3.30.200.20-FF-001856', NULL, 'Uncharacterized protein', 117, NULL, NULL, 154694),
(154695, '3.20.20.190-FF-000161', NULL, NULL, 162, NULL, NULL, 154695),
(154696, '2.50.20.10-FF-000014', NULL, 'RNA polymerase subunit sigma', 177, NULL, NULL, 154696),
(154697, '1.20.1050.10-FF-000102', NULL, 'Glutaredoxin/Glutathione_S-transferase_-_N-terminal_domain_containing_protein_-_putative', 148, NULL, NULL, 154697),
(154698, '3.30.56.10-FF-000022', NULL, 'Phenylalanine--tRNA ligase beta subunit', 58, NULL, NULL, 154698),
(154699, '3.80.10.10-FF-003888', NULL, 'Uncharacterized protein', 153, NULL, NULL, 154699),
(154700, '1.20.1440.130-FF-000010', NULL, 'Predicted protein', 158, NULL, NULL, 154700),
(154701, '1.25.40.20-FF-000967', NULL, 'YALI0A19778p', 212, NULL, NULL, 154701),
(154702, '2.70.98.30-FF-000013', NULL, 'Alpha-mannosidase', 281, NULL, NULL, 154702),
(154703, '2.10.25.10-FF-001634', NULL, 'Uncharacterized protein', 49, NULL, NULL, 154703),
(154704, '3.40.30.10-FF-000895', NULL, 'Uncharacterized protein', 87, NULL, NULL, 154704),
(154705, '3.40.50.150-FF-001325', NULL, NULL, 292, NULL, NULL, 154705),
(154706, '2.60.40.10-FF-005630', NULL, NULL, 96, NULL, NULL, 154706),
(154707, '3.40.50.2300-FF-000901', NULL, NULL, 132, NULL, NULL, 154707),
(154708, '1.25.10.10-FF-000439', NULL, 'Exportin-4 isoform X1', 535, NULL, NULL, 154708),
(154709, '3.40.50.300-FF-003208', NULL, 'Uncharacterized protein', 244, NULL, NULL, 154709),
(154710, '3.30.365.10-FF-000015', NULL, 'Xanthine dehydrogenase yagR molybdenum-binding subunit', 138, NULL, NULL, 154710),
(154711, '1.25.40.20-FF-001001', NULL, 'Predicted protein', 105, NULL, NULL, 154711),
(154712, '1.20.1440.80-FF-000006', NULL, 'gap junction epsilon-1 protein', 99, NULL, NULL, 154712),
(154713, '1.10.510.10-FF-003480', NULL, 'Serine/threonine-protein kinase ppk1', 357, NULL, NULL, 154713),
(154714, '3.10.129.10-FF-000016', NULL, 'Acyl-coenzyme A thioesterase 9, mitochondrial', 148, NULL, NULL, 154714),
(154715, '1.20.120.330-FF-000018', NULL, 'Focal adhesion kinase, isoform D', 161, NULL, NULL, 154715),
(154716, '2.170.270.10-FF-000209', NULL, 'SET and MYND domain-containing protein DDB_G0288495', 157, NULL, NULL, 154716);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(154717, '3.50.30.30-FF-000131', NULL, 'Uncharacterized protein', 131, NULL, NULL, 154717),
(154718, '1.10.8.270-FF-000133', NULL, 'Rab-GTPase-TBC domain containing protein, putative', 87, NULL, NULL, 154718),
(154719, '2.130.10.10-FF-002409', NULL, 'Polyadenylation factor subunit 2', 133, NULL, NULL, 154719),
(154720, '3.40.50.1580-FF-000044', NULL, 'Phosphorylase superfamily protein', 255, NULL, NULL, 154720),
(154721, '2.30.29.30-FF-000743', NULL, 'Histone-arginine methyltransferase CARM1', 110, NULL, NULL, 154721),
(154722, '3.30.70.330-FF-002723', NULL, NULL, 99, NULL, NULL, 154722),
(154723, '1.10.510.10-FF-002991', NULL, NULL, 189, NULL, NULL, 154723),
(154724, '2.60.40.60-FF-000833', NULL, 'Uncharacterized protein', 47, NULL, NULL, 154724),
(154725, '2.40.10.10-FF-000278', NULL, NULL, 19, NULL, NULL, 154725),
(154726, '1.10.150.390-FF-000005', NULL, 'DNA-directed RNA polymerase subunit', 44, NULL, NULL, 154726),
(154727, '1.20.5.190-FF-000067', NULL, 'Dilute class unconventional myosin', 53, NULL, NULL, 154727),
(154728, '3.40.50.1820-FF-001010', NULL, 'Serine hydrolase FSH', 219, NULL, NULL, 154728),
(154729, '3.40.50.1000-FF-000590', NULL, NULL, 145, NULL, NULL, 154729),
(154730, '1.25.40.470-FF-000035', NULL, 'WD repeat-containing protein', 152, NULL, NULL, 154730),
(154731, '3.50.50.60-FF-000580', NULL, 'Flavin-containing monooxygenase', 117, NULL, NULL, 154731),
(154732, '2.20.110.10-FF-000020', NULL, 'MORN repeat containing 3', 53, NULL, NULL, 154732),
(154733, '3.40.50.300-FF-004248', NULL, 'DNA helicase', 166, NULL, NULL, 154733),
(154734, '3.40.50.300-FF-002011', NULL, 'Shikimate kinase', 179, NULL, NULL, 154734),
(154735, '1.25.40.10-FF-004550', NULL, 'Os02g0191200 protein', 222, NULL, NULL, 154735),
(154736, '1.20.1110.10-FF-000175', NULL, NULL, 269, NULL, NULL, 154736),
(154737, '1.20.150.20-FF-000001', NULL, 'ATP synthase subunit alpha', 131, NULL, NULL, 154737),
(154738, '1.10.730.10-FF-000034', NULL, 'Arginine--tRNA ligase', 120, NULL, NULL, 154738),
(154739, '3.40.640.10-FF-000378', NULL, 'Uncharacterized protein', 40, NULL, NULL, 154739),
(154740, '3.20.20.70-FF-000430', NULL, 'Nicotinate phosphoribosyltransferase', 171, NULL, NULL, 154740),
(154741, '2.170.270.10-FF-000086', NULL, 'Histone-lysine N-methyltransferase', 236, NULL, NULL, 154741),
(154742, '2.10.25.10-FF-000353', NULL, 'Delta/notch like EGF repeat containing', 41, NULL, NULL, 154742),
(154743, '2.60.200.20-FF-000055', NULL, 'Transcriptional regulator EmbR', 100, NULL, NULL, 154743),
(154744, '3.20.20.300-FF-000048', NULL, 'Beta-glucosidase C', 394, NULL, NULL, 154744),
(154745, '3.40.30.10-FF-000002', NULL, 'Alkyl hydroperoxide reductase C', 196, NULL, NULL, 154745),
(154746, '1.10.3720.10-FF-000156', NULL, 'ABC transporter, permease protein', 249, NULL, NULL, 154746),
(154747, '3.30.565.10-FF-000356', NULL, 'Histidine protein kinase SLN1', 122, NULL, NULL, 154747),
(154748, '3.30.50.10-FF-000189', NULL, 'Uncharacterized protein', 94, NULL, NULL, 154748),
(154749, '2.20.100.10-FF-000222', NULL, 'SCO-spondin', 58, NULL, NULL, 154749),
(154750, '3.40.50.1110-FF-000151', NULL, 'Uncharacterized protein', 81, NULL, NULL, 154750),
(154751, '3.30.420.40-FF-000760', NULL, 'Hsp70 protein-domain-containing protein', 97, NULL, NULL, 154751),
(154752, '1.10.510.10-FF-001451', NULL, 'Serine/threonine protein kinase, STE20 family', 203, NULL, NULL, 154752),
(154753, '1.10.1000.11-FF-000018', NULL, 'Sec7_domain_containing_protein_-_putative', 126, NULL, NULL, 154753),
(154754, '3.40.190.10-FF-000966', NULL, 'Oligopeptide-binding protein oppA', 235, NULL, NULL, 154754),
(154755, '2.130.10.30-FF-000134', NULL, NULL, 342, NULL, NULL, 154755),
(154756, '3.90.70.10-FF-000255', NULL, 'Toxin secretion ATP-binding protein', 126, NULL, NULL, 154756),
(154757, '2.60.40.10-FF-000728', NULL, 'Plexin D1', 139, NULL, NULL, 154757),
(154758, '1.20.920.20-FF-000038', NULL, 'Dynein heavy chain', 297, NULL, NULL, 154758),
(154759, '3.40.50.2300-FF-001278', NULL, NULL, 171, NULL, NULL, 154759),
(154760, '1.20.200.10-FF-000008', NULL, 'Adenylosuccinate lyase', 256, NULL, NULL, 154760);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(154761, '1.10.8.10-FF-000056', NULL, 'Defective in cullin neddylation protein', 42, NULL, NULL, 154761),
(154762, '3.60.15.10-FF-000134', NULL, 'Metallo-beta-lactamase superfamily protein', 268, NULL, NULL, 154762),
(154763, '3.40.50.1010-FF-000233', NULL, NULL, 71, NULL, NULL, 154763),
(154764, '3.40.50.1000-FF-000808', NULL, NULL, 135, NULL, NULL, 154764),
(154765, '1.50.40.10-FF-000546', NULL, 'Uncharacterized protein', 137, NULL, NULL, 154765),
(154766, '1.10.472.10-FF-000158', NULL, 'RNA polymerase II holoenzyme cyclin-like subunit', 116, NULL, NULL, 154766),
(154767, '2.60.40.2140-FF-000006', NULL, 'GNBP A1', 106, NULL, NULL, 154767),
(154768, '1.10.10.60-FF-000460', NULL, 'Homebox and aldo/keto reductase', 63, NULL, NULL, 154768),
(154769, '3.40.390.10-FF-000173', NULL, NULL, 131, NULL, NULL, 154769),
(154770, '2.60.40.1180-FF-000128', NULL, '1,4-alpha-glucan branching enzyme', 117, NULL, NULL, 154770),
(154771, '3.40.50.10490-FF-000007', NULL, '30S ribosomal protein S2', 188, NULL, NULL, 154771),
(154772, '3.40.1190.20-FF-000171', NULL, 'Multifunctional fusion protein', 290, NULL, NULL, 154772),
(154773, '1.10.20.10-FF-000092', NULL, 'Protein MHF1-like isoform A', 119, NULL, NULL, 154773),
(154774, '1.25.40.10-FF-004533', NULL, 'Pre-mRNA-splicing factor CLF1', 60, NULL, NULL, 154774),
(154775, '2.40.50.140-FF-000578', NULL, '26S protease regulatory subunit 6A', 71, NULL, NULL, 154775),
(154776, '3.40.50.150-FF-000471', NULL, 'Methyltransferase', 186, NULL, NULL, 154776),
(154777, '2.30.30.210-FF-000002', NULL, 'Ribonuclease P protein subunit p29', 97, NULL, NULL, 154777),
(154778, '1.25.40.10-FF-000155', NULL, 'General transcription factor 3C polypeptide 3', 322, NULL, NULL, 154778),
(154779, '3.90.550.10-FF-000354', NULL, 'UDP-N-acetyl-alpha-D-galactosamine:polypeptide N-acetylgalactosaminyltransferase 14 (GalNAc-T14)', 227, NULL, NULL, 154779),
(154780, '3.80.10.10-FF-000550', NULL, 'peroxidasin homolog', 117, NULL, NULL, 154780),
(154781, '3.40.50.300-FF-004265', NULL, 'Uncharacterized protein', 211, NULL, NULL, 154781),
(154782, '2.40.50.140-FF-001197', NULL, NULL, 101, NULL, NULL, 154782),
(154783, '2.20.70.10-FF-000108', NULL, 'growth arrest-specific protein 7 isoform X2', 32, NULL, NULL, 154783),
(154784, '1.10.287.610-FF-000003', NULL, 'DNA ligase B', 61, NULL, NULL, 154784),
(154785, '3.80.10.10-FF-001960', NULL, 'Probable inactive receptor kinase At4g23740', 84, NULL, NULL, 154785),
(154786, '1.10.10.60-FF-000358', NULL, 'Myb-related protein 305', 72, NULL, NULL, 154786),
(154787, '3.30.200.20-FF-001968', NULL, NULL, 126, NULL, NULL, 154787),
(154788, '2.130.10.10-FF-003697', NULL, 'Uncharacterized protein', 326, NULL, NULL, 154788),
(154789, '3.40.225.10-FF-000048', NULL, NULL, 207, NULL, NULL, 154789),
(154790, '1.25.40.10-FF-003252', NULL, 'Pentatricopeptide repeat-containing protein isoform A', 167, NULL, NULL, 154790),
(154791, '1.25.40.10-FF-002976', NULL, 'Uncharacterized protein', 156, NULL, NULL, 154791),
(154792, '1.25.40.990-FF-000067', NULL, 'Predicted protein', 114, NULL, NULL, 154792),
(154793, '1.10.8.1220-FF-000023', NULL, 'Dynein heavy chain', 88, NULL, NULL, 154793),
(154794, '3.40.50.300-FF-005546', NULL, 'Senataxin', 351, NULL, NULL, 154794),
(154795, '1.10.238.270-FF-000010', NULL, NULL, 169, NULL, NULL, 154795),
(154796, '3.60.21.10-FF-000418', NULL, 'Serine/threonine-protein phosphatase', 395, NULL, NULL, 154796),
(154797, '3.40.50.720-FF-000327', NULL, 'Glycerol-3-phosphate dehydrogenase', 186, NULL, NULL, 154797),
(154798, '3.40.50.2300-FF-000429', NULL, 'GntR family transcriptional regulator', 141, NULL, NULL, 154798),
(154799, '3.40.50.1820-FF-000942', NULL, 'Protein phosphatase methylesterase 1', 311, NULL, NULL, 154799),
(154800, '3.40.250.10-FF-000112', NULL, 'Sulfurtransferase', 132, NULL, NULL, 154800),
(154801, '3.40.50.10810-FF-000266', NULL, 'Uncharacterized ATP-dependent helicase C17A2.12', 280, NULL, NULL, 154801),
(154802, '2.60.410.10-FF-000006', NULL, 'D-alanyl-D-alanine carboxypeptidase DacA', 100, NULL, NULL, 154802),
(154803, '2.60.40.1400-FF-000003', NULL, 'Potassium voltage-gated channel subfamily J member 16', 180, NULL, NULL, 154803);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(154804, '3.30.70.330-FF-001767', NULL, NULL, 128, NULL, NULL, 154804),
(154805, '1.25.40.790-FF-000013', NULL, 'Ccr4-Not transcription complex subunit', 286, NULL, NULL, 154805),
(154806, '1.20.1250.10-FF-000117', NULL, NULL, 152, NULL, NULL, 154806),
(154807, '3.30.710.10-FF-000425', NULL, 'Predicted protein', 106, NULL, NULL, 154807),
(154808, '2.30.29.30-FF-000631', NULL, 'PH-protein kinase domain containing protein', 127, NULL, NULL, 154808),
(154809, '3.40.50.10470-FF-000001', NULL, 'Translation initiation factor eIF-2B subunit alpha', 198, NULL, NULL, 154809),
(154810, '3.90.550.20-FF-000020', NULL, 'Predicted protein', 221, NULL, NULL, 154810),
(154811, '2.60.120.200-FF-000442', NULL, 'Putative L-type lectin-domain containing receptor kinase S.7', 238, NULL, NULL, 154811),
(154812, '3.30.43.10-FF-000043', NULL, 'Carbon monoxide dehydrogenase, medium subunit, putative', 52, NULL, NULL, 154812),
(154813, '2.60.40.10-FF-001673', NULL, 'titin isoform X1', 94, NULL, NULL, 154813),
(154814, '3.40.1140.10-FF-000002', NULL, 'Chromosome partition protein MukB', 227, NULL, NULL, 154814),
(154815, '3.30.160.60-FF-006344', NULL, NULL, 60, NULL, NULL, 154815),
(154816, '3.40.50.300-FF-008194', NULL, 'Uncharacterized protein', 76, NULL, NULL, 154816),
(154817, '3.40.50.920-FF-000044', NULL, '2-oxoacid:acceptor oxidoreductase subunit alpha', 112, NULL, NULL, 154817),
(154818, '3.40.50.10860-FF-000039', NULL, 'Bifunctional protein FolD', 142, NULL, NULL, 154818),
(154819, '1.10.3260.10-FF-000025', NULL, 'DNA ligase', 235, NULL, NULL, 154819),
(154820, '3.30.40.10-FF-000357', NULL, 'Peroxisome biogenesis protein 12', 65, NULL, NULL, 154820),
(154821, '2.40.50.140-FF-000348', NULL, 'DNA replication helicase protein MCM', 81, NULL, NULL, 154821),
(154822, '1.10.1040.10-FF-000014', NULL, '2-dehydropantoate 2-reductase', 123, NULL, NULL, 154822),
(154823, '3.40.30.10-FF-000665', NULL, 'Glutathione peroxidase', 142, NULL, NULL, 154823),
(154824, '2.60.120.10-FF-000568', NULL, 'Mannose-6-phosphate isomerase', 88, NULL, NULL, 154824),
(154825, '1.10.287.630-FF-000009', NULL, 'Tetrameric potassium-selective cyclic nucleotide gated channel', 64, NULL, NULL, 154825),
(154826, '1.25.40.10-FF-000604', NULL, 'MAU2 sister chromatid cohesion factor', 167, NULL, NULL, 154826),
(154827, '2.130.10.10-FF-000611', NULL, 'Dynein axonemal intermediate chain 1', 247, NULL, NULL, 154827),
(154828, '1.10.10.10-FF-000838', NULL, 'Histone acetyltransferase', 96, NULL, NULL, 154828),
(154829, '2.130.10.10-FF-002848', NULL, 'Uncharacterized protein', 349, NULL, NULL, 154829),
(154830, '2.40.30.10-FF-000280', NULL, 'Eukaryotic translation initiation factor 5B, isoform D', 36, NULL, NULL, 154830),
(154831, '3.30.200.20-FF-002475', NULL, 'Predicted protein', 43, NULL, NULL, 154831),
(154832, '2.60.120.330-FF-000008', NULL, 'Jasmonate-regulated gene 21', 338, NULL, NULL, 154832),
(154833, '2.70.98.30-FF-000030', NULL, 'Uncharacterized protein', 131, NULL, NULL, 154833),
(154834, '3.40.50.1820-FF-000381', NULL, 'YJR107W-like protein', 323, NULL, NULL, 154834),
(154835, '3.30.2130.10-FF-000026', NULL, 'ACT domain-domain-containing protein', 132, NULL, NULL, 154835),
(154836, '2.60.40.60-FF-001126', NULL, 'Uncharacterized protein', 118, NULL, NULL, 154836),
(154837, '3.40.50.300-FF-002803', NULL, 'Structural maintenance of chromosomes', 207, NULL, NULL, 154837),
(154838, '3.30.40.10-FF-002386', NULL, 'Uncharacterized protein', 70, NULL, NULL, 154838),
(154839, '2.30.29.220-FF-000003', NULL, 'FACT complex subunit POB3', 103, NULL, NULL, 154839),
(154840, '3.30.450.90-FF-000018', NULL, 'Twitching motility pilus retraction protein', 101, NULL, NULL, 154840),
(154841, '2.60.40.10-FF-003601', NULL, NULL, 84, NULL, NULL, 154841),
(154842, '3.30.70.330-FF-001200', NULL, 'AGAP013051-PA', 164, NULL, NULL, 154842),
(154843, '2.40.10.10-FF-000166', NULL, 'Trypsin', 133, NULL, NULL, 154843),
(154844, '3.60.110.10-FF-000075', NULL, NULL, 286, NULL, NULL, 154844),
(154845, '2.60.40.10-FF-002196', NULL, 'Probable beta-D-xylosidase 6', 105, NULL, NULL, 154845);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(154846, '2.10.25.10-FF-001179', NULL, 'Low-density lipoprotein receptor-related protein', 47, NULL, NULL, 154846),
(154847, '1.10.3130.10-FF-000004', NULL, 'Serine acetyltransferase 5', 149, NULL, NULL, 154847),
(154848, '1.10.8.270-FF-000150', NULL, 'TBC domain protein, putative', 119, NULL, NULL, 154848),
(154849, '1.10.1420.10-FF-000195', NULL, 'Uncharacterized protein', 98, NULL, NULL, 154849),
(154850, '3.40.190.10-FF-000174', NULL, 'Peptide ABC transporter substrate-binding protein', 147, NULL, NULL, 154850),
(154851, '1.20.5.110-FF-000100', NULL, 'Pep12p', 103, NULL, NULL, 154851),
(154852, '2.20.90.10-FF-000008', NULL, 'Vitellogenin 3, phosvitinless', 172, NULL, NULL, 154852),
(154853, '2.60.120.650-FF-000228', NULL, 'Predicted protein', 168, NULL, NULL, 154853),
(154854, '2.30.42.10-FF-000257', NULL, 'Uncharacterized protein, isoform B', 101, NULL, NULL, 154854),
(154855, '3.40.50.1000-FF-000247', NULL, 'HAD family phosphatase', 80, NULL, NULL, 154855),
(154856, '3.30.830.10-FF-000035', NULL, 'Protease 3', 184, NULL, NULL, 154856),
(154857, '1.20.120.330-FF-000035', NULL, 'Protein tyrosine kinase 2', 41, NULL, NULL, 154857),
(154858, '1.20.1270.280-FF-000055', NULL, 'Uncharacterized protein', 139, NULL, NULL, 154858),
(154859, '1.25.10.10-FF-001412', NULL, 'BRCA1 associated ATM activator 1', 119, NULL, NULL, 154859),
(154860, '3.30.200.20-FF-001064', NULL, 'Cysteine-rich receptor-like protein kinase 25 isoform A', 92, NULL, NULL, 154860),
(154861, '3.90.70.30-FF-000002', NULL, 'Uncharacterized protein', 215, NULL, NULL, 154861),
(154862, '3.40.250.10-FF-000016', NULL, 'Dual specificity phosphatase 16 (Predicted)', 134, NULL, NULL, 154862),
(154863, '3.10.110.10-FF-000333', NULL, 'Uncharacterized protein', 154, NULL, NULL, 154863),
(154864, '2.130.10.30-FF-000038', NULL, 'RCC1 and BTB domain-containing protein 2', 161, NULL, NULL, 154864),
(154865, '2.130.10.10-FF-002269', NULL, 'Putative WD-40 repeat protein', 460, NULL, NULL, 154865),
(154866, '2.60.220.50-FF-000048', NULL, 'Predicted protein', 179, NULL, NULL, 154866),
(154867, '3.90.70.10-FF-000816', NULL, 'Predicted protein', 199, NULL, NULL, 154867),
(154868, '1.10.10.2330-FF-000002', NULL, 'Phenylalanyl-tRNA synthetase alpha chain', 59, NULL, NULL, 154868),
(154869, '1.10.510.10-FF-001349', NULL, 'Serine/threonine protein kinase ULK3, putative', 299, NULL, NULL, 154869),
(154870, '1.25.10.10-FF-003312', NULL, 'Predicted protein', 156, NULL, NULL, 154870),
(154871, '1.10.1450.10-FF-000051', NULL, 'Tetraspanin', 94, NULL, NULL, 154871),
(154872, '3.40.50.300-FF-006726', NULL, 'Predicted protein', 72, NULL, NULL, 154872),
(154873, '3.30.160.60-FF-004787', NULL, NULL, 29, NULL, NULL, 154873),
(154874, '2.160.20.10-FF-000285', NULL, 'Periplasmic copper-binding', 167, NULL, NULL, 154874),
(154875, '2.60.40.150-FF-000423', NULL, 'Synaptotagmin 3', 58, NULL, NULL, 154875),
(154876, '3.30.200.20-FF-000788', NULL, 'Ribosomal protein S6 kinase', 112, NULL, NULL, 154876),
(154877, '2.130.10.10-FF-002056', NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', 159, NULL, NULL, 154877),
(154878, '3.40.50.720-FF-000344', NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', 131, NULL, NULL, 154878),
(154879, '3.40.367.20-FF-000032', NULL, 'Phosphotransferase', 315, NULL, NULL, 154879),
(154880, '1.50.40.10-FF-000203', NULL, 'Solute carrier family 25 member 39', 73, NULL, NULL, 154880),
(154881, '2.30.30.30-FF-000016', NULL, 'Transcription elongation factor SPT5', 51, NULL, NULL, 154881),
(154882, '1.10.630.10-FF-000779', NULL, 'Cytochrome P450 71D7', 157, NULL, NULL, 154882),
(154883, '3.90.180.10-FF-000090', NULL, 'Possible dehydrogenase', 141, NULL, NULL, 154883),
(154884, '3.90.226.10-FF-000348', NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', 187, NULL, NULL, 154884),
(154885, '3.30.200.20-FF-000575', NULL, 'Protein KINase', 140, NULL, NULL, 154885),
(154886, '3.40.50.12780-FF-000054', NULL, 'Bifunctional fatty acid transporter/acyl-CoA synthetase (FAT1), putative', 451, NULL, NULL, 154886),
(154887, '3.30.160.60-FF-002292', NULL, 'Zinc finger protein 816', 28, NULL, NULL, 154887);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(154888, '2.170.300.10-FF-000067', NULL, 'Laminin subunit gamma-1', 91, NULL, NULL, 154888),
(154889, '1.10.8.100-FF-000026', NULL, 'Ribosomal RNA small subunit methyltransferase A', 66, NULL, NULL, 154889),
(154890, '3.40.50.10310-FF-000009', NULL, 'Creatinine amidohydrolase', 243, NULL, NULL, 154890),
(154891, '1.20.1070.10-FF-001188', NULL, 'Uncharacterized protein', 126, NULL, NULL, 154891),
(154892, '1.25.40.10-FF-002072', NULL, 'Peptidylprolyl isomerase', 158, NULL, NULL, 154892),
(154893, '3.90.25.10-FF-000050', NULL, 'GDP-mannose 4,6 dehydratase', 65, NULL, NULL, 154893),
(154894, '2.30.31.10-FF-000001', NULL, 'Activated RNA polymerase II transcriptional coactivator p15', 66, NULL, NULL, 154894),
(154895, '3.90.190.10-FF-000612', NULL, 'Predicted protein', 106, NULL, NULL, 154895),
(154896, '2.20.100.10-FF-000205', NULL, 'Complement factor properdin', 64, NULL, NULL, 154896),
(154897, '2.120.10.30-FF-000567', NULL, 'Uncharacterized protein', 46, NULL, NULL, 154897),
(154898, '1.50.10.20-FF-000143', NULL, 'Squalene cyclase family protein', 286, NULL, NULL, 154898),
(154899, '1.10.510.10-FF-000832', NULL, 'Serine/threonine protein kinase, variant', 192, NULL, NULL, 154899),
(154900, '1.10.510.10-FF-003036', NULL, NULL, 218, NULL, NULL, 154900),
(154901, '1.20.1250.20-FF-000093', NULL, 'Solute carrier organic anion transporter family member', 395, NULL, NULL, 154901),
(154902, '3.30.70.330-FF-000795', NULL, 'RNA-binding protein CP33, chloroplastic', 105, NULL, NULL, 154902),
(154903, '3.30.230.10-FF-000287', NULL, 'DNA gyrase subunit B', 172, NULL, NULL, 154903),
(154904, '3.30.200.20-FF-000119', NULL, 'Protein kinase C', 115, NULL, NULL, 154904),
(154905, '1.10.238.10-FF-001216', NULL, 'EF hand family protein', 152, NULL, NULL, 154905),
(154906, '3.40.50.300-FF-007671', NULL, 'Uncharacterized protein', 120, NULL, NULL, 154906),
(154907, '3.80.10.10-FF-000095', NULL, 'LRR receptor-like serine/threonine-protein kinase GSO1', 295, NULL, NULL, 154907),
(154908, '3.30.160.60-FF-003601', NULL, NULL, 22, NULL, NULL, 154908),
(154909, '1.20.120.1750-FF-000114', NULL, 'RBR-type E3 ubiquitin transferase', 154, NULL, NULL, 154909),
(154910, '3.40.50.300-FF-001494', NULL, 'Pachytene checkpoint component Pch2', 212, NULL, NULL, 154910),
(154911, '1.20.1310.20-FF-000030', NULL, 'Duffy binding-like merozoite surface protein', 178, NULL, NULL, 154911),
(154912, '3.40.800.20-FF-000028', NULL, 'Histone deacetylase', 335, NULL, NULL, 154912),
(154913, '3.30.160.60-FF-005063', NULL, NULL, 30, NULL, NULL, 154913),
(154914, '3.40.50.410-FF-000127', NULL, '60 kDa SS-A/Ro ribonucleoprotein homolog', 159, NULL, NULL, 154914),
(154915, '3.40.50.620-FF-000409', NULL, 'Putative SanA protein', 129, NULL, NULL, 154915),
(154916, '2.60.40.10-FF-002292', NULL, 'Twitchin', 104, NULL, NULL, 154916),
(154917, '1.20.1070.10-FF-000671', NULL, 'Predicted protein', 296, NULL, NULL, 154917),
(154918, '2.60.40.10-FF-004450', NULL, NULL, 111, NULL, NULL, 154918),
(154919, '3.40.50.150-FF-001297', NULL, NULL, 215, NULL, NULL, 154919),
(154920, '1.10.238.10-FF-000570', NULL, 'Defective in cullin neddylation protein 1', 112, NULL, NULL, 154920),
(154921, '1.20.5.520-FF-000003', NULL, 'Thymosin beta', 38, NULL, NULL, 154921),
(154922, '3.90.660.10-FF-000002', NULL, 'Amine oxidase', 143, NULL, NULL, 154922),
(154923, '1.25.40.10-FF-001127', NULL, 'BnaUnng00170D protein', 117, NULL, NULL, 154923),
(154924, '3.60.40.10-FF-000120', NULL, 'Protein phosphatase PPM5', 146, NULL, NULL, 154924),
(154925, '3.40.50.2300-FF-000659', NULL, 'Guanylate cyclase', 119, NULL, NULL, 154925),
(154926, '2.40.50.1000-FF-000017', NULL, 'Os08g0207000 protein', 54, NULL, NULL, 154926),
(154927, '3.10.20.90-FF-000509', NULL, 'WGS project CABT00000000 data, contig 2.9', 81, NULL, NULL, 154927),
(154928, '3.90.470.20-FF-000070', NULL, 'Uncharacterized protein', 117, NULL, NULL, 154928),
(154929, '1.10.10.10-FF-000708', NULL, 'Transcription factor SFL2', 117, NULL, NULL, 154929),
(154930, '1.25.40.10-FF-001223', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 103, NULL, NULL, 154930);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(154931, '3.30.160.60-FF-000392', NULL, 'early growth response protein 3', 39, NULL, NULL, 154931),
(154932, '1.10.230.10-FF-000018', NULL, 'Citrate synthase', 106, NULL, NULL, 154932),
(154933, '1.10.1520.10-FF-000028', NULL, 'RNA editing complex protein MP90', 124, NULL, NULL, 154933),
(154934, '3.90.550.10-FF-000584', NULL, 'Uncharacterized protein', 240, NULL, NULL, 154934),
(154935, '3.40.630.10-FF-000321', NULL, 'Uncharacterized protein', 156, NULL, NULL, 154935),
(154936, '1.25.40.20-FF-000484', NULL, 'Ankyrin repeat-containing protein ITN1 isoform C', 215, NULL, NULL, 154936),
(154937, '3.20.70.20-FF-000036', NULL, 'Ribonucleoside-diphosphate reductase', 174, NULL, NULL, 154937),
(154938, '3.40.50.300-FF-006165', NULL, 'DExH-box ATP-dependent RNA helicase DExH18 mitochondrial', 51, NULL, NULL, 154938),
(154939, '3.30.1240.20-FF-000003', NULL, NULL, 47, NULL, NULL, 154939),
(154940, '3.30.110.10-FF-000008', NULL, 'Translation initiation factor IF3, putative', 87, NULL, NULL, 154940),
(154941, '2.60.40.60-FF-000378', NULL, 'Cadherin-87A', 110, NULL, NULL, 154941),
(154942, '1.25.40.10-FF-000947', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform A', 110, NULL, NULL, 154942),
(154943, '1.25.40.10-FF-002633', NULL, 'Uncharacterized protein', 137, NULL, NULL, 154943),
(154944, '3.30.530.20-FF-000189', NULL, 'Uncharacterized protein', 74, NULL, NULL, 154944),
(154945, '1.10.150.20-FF-000301', NULL, 'DNA repair protein rev1', 78, NULL, NULL, 154945),
(154946, '1.25.10.10-FF-000670', NULL, 'Vacuole-associated enzyme activator complex component (Vac14), putative', 172, NULL, NULL, 154946),
(154947, '1.10.510.10-FF-003249', NULL, NULL, 115, NULL, NULL, 154947),
(154948, '2.40.50.140-FF-000218', NULL, 'DNA ligase', 159, NULL, NULL, 154948),
(154949, '1.10.238.10-FF-000474', NULL, 'Mitochondrial Rho GTPase 1', 130, NULL, NULL, 154949),
(154950, '3.40.50.10190-FF-000350', NULL, 'BRCT-containing protein 1', 107, NULL, NULL, 154950),
(154951, '1.10.510.10-FF-001012', NULL, 'Protein kinase KNS1', 199, NULL, NULL, 154951),
(154952, '3.30.160.60-FF-001914', NULL, 'Zinc finger protein 713', 28, NULL, NULL, 154952),
(154953, '1.20.1420.10-FF-000030', NULL, NULL, 152, NULL, NULL, 154953),
(154954, '2.30.30.140-FF-000054', NULL, 'Histone-lysine N-methyltransferase', 60, NULL, NULL, 154954),
(154955, '3.20.20.80-FF-000315', NULL, 'Predicted protein', 188, NULL, NULL, 154955),
(154956, '2.60.40.790-FF-000148', NULL, NULL, 105, NULL, NULL, 154956),
(154957, '3.40.630.10-FF-000107', NULL, 'N-acetylated-alpha-linked acidic dipeptidase-like protein', 199, NULL, NULL, 154957),
(154958, '3.30.50.10-FF-000077', NULL, 'White collar 1 protein', 67, NULL, NULL, 154958),
(154959, '1.20.1560.10-FF-000091', NULL, 'ATP-dependent permease MDL2', 345, NULL, NULL, 154959),
(154960, '3.30.70.20-FF-000075', NULL, 'Dissimilatory sulfite reductase beta subunit', 72, NULL, NULL, 154960),
(154961, '2.60.120.200-FF-000211', NULL, 'Adhesion G protein-coupled receptor D2', 199, NULL, NULL, 154961),
(154962, '3.60.15.10-FF-000264', NULL, 'Uncharacterized protein', 163, NULL, NULL, 154962),
(154963, '3.80.10.10-FF-000903', NULL, 'F-box protein family-like', 166, NULL, NULL, 154963),
(154964, '3.40.50.10810-FF-000053', NULL, 'SNF2 family helicase/ATPase, putative', 292, NULL, NULL, 154964),
(154965, '1.25.40.10-FF-002763', NULL, 'Soluble NSF attachment protein, SNAP, putative', 331, NULL, NULL, 154965),
(154966, '2.10.25.20-FF-000002', NULL, 'Outer capsid protein sigma-1', 56, NULL, NULL, 154966),
(154967, '3.10.100.10-FF-000395', NULL, NULL, 122, NULL, NULL, 154967),
(154968, '2.170.260.40-FF-000004', NULL, '5''-3'' exoribonuclease 1', 171, NULL, NULL, 154968),
(154969, '3.30.450.40-FF-000144', NULL, 'Phytochrome', 183, NULL, NULL, 154969),
(154970, '3.30.9.10-FF-000296', NULL, 'D-aspartate oxidase 1', 57, NULL, NULL, 154970),
(154971, '3.10.20.90-FF-000498', NULL, 'Serine/threonine-protein kinase WNK8', 90, NULL, NULL, 154971),
(154972, '3.40.50.300-FF-001735', NULL, 'Mov10 like RISC complex RNA helicase 1', 141, NULL, NULL, 154972); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(154973, '3.90.1300.10-FF-000014', NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit A, chloroplastic/mitochondrial', 484, NULL, NULL, 154973),
(154974, '3.50.50.60-FF-001063', NULL, 'Glutathione reductase', 71, NULL, NULL, 154974),
(154975, '2.130.10.10-FF-000824', NULL, 'U4/U6 small nuclear ribonucleoprotein PRP4', 96, NULL, NULL, 154975),
(154976, '1.20.1070.10-FF-001738', NULL, 'Si:dkey-181m19.11', 89, NULL, NULL, 154976),
(154977, '1.10.287.110-FF-000174', NULL, 'DnaJ protein, putative', 86, NULL, NULL, 154977),
(154978, '2.60.120.200-FF-000099', NULL, 'Contactin associated protein 1', 187, NULL, NULL, 154978),
(154979, '3.75.10.10-FF-000017', NULL, 'NGNG-dimethylarginine dimethylaminohydrolase 1', 280, NULL, NULL, 154979),
(154980, '2.70.50.30-FF-000010', NULL, NULL, 146, NULL, NULL, 154980),
(154981, '3.40.50.720-FF-001288', NULL, 'Short chain alcohol dehydrogenase, putative', 136, NULL, NULL, 154981),
(154982, '3.30.465.10-FF-000079', NULL, 'Protein CBG02085', 139, NULL, NULL, 154982),
(154983, '2.60.40.10-FF-003022', NULL, 'CD79A isoform 1', 50, NULL, NULL, 154983),
(154984, '3.30.1310.10-FF-000006', NULL, 'Nucleoid-associated protein LEP1GSC116_0101', 107, NULL, NULL, 154984),
(154985, '3.40.50.1820-FF-000049', NULL, 'probable glutamyl endopeptidase, chloroplastic', 268, NULL, NULL, 154985),
(154986, '3.30.160.60-FF-004995', NULL, NULL, 56, NULL, NULL, 154986),
(154987, '2.60.40.1730-FF-000097', NULL, NULL, 66, NULL, NULL, 154987),
(154988, '3.40.390.10-FF-000285', NULL, NULL, 108, NULL, NULL, 154988),
(154989, '3.80.10.10-FF-003984', NULL, 'Uncharacterized protein', 158, NULL, NULL, 154989),
(154990, '1.10.3660.10-FF-000005', NULL, 'Prephenate dehydrogenase', 104, NULL, NULL, 154990),
(154991, '3.90.79.10-FF-000095', NULL, 'NADH pyrophosphatase', 156, NULL, NULL, 154991),
(154992, '2.60.120.970-FF-000094', NULL, 'Maverick', 183, NULL, NULL, 154992),
(154993, '3.40.50.800-FF-000019', NULL, 'Threonine--tRNA ligase mitochondrial 1', 104, NULL, NULL, 154993),
(154994, '3.55.40.20-FF-000017', NULL, 'Superoxide dismutase', 81, NULL, NULL, 154994),
(154995, '1.10.510.10-FF-000282', NULL, 'LIM domain kinase 1', 222, NULL, NULL, 154995),
(154996, '1.10.238.10-FF-001300', NULL, 'Uncharacterized protein', 71, NULL, NULL, 154996),
(154997, '1.10.420.10-FF-000044', NULL, 'Uncharacterized protein', 69, NULL, NULL, 154997),
(154998, '1.10.238.10-FF-001188', NULL, 'Uncharacterized protein', 187, NULL, NULL, 154998),
(154999, '1.20.1250.20-FF-002357', NULL, 'Uncharacterized protein', 409, NULL, NULL, 154999),
(155000, '3.30.2310.20-FF-000015', NULL, 'AAA family ATPase', 93, NULL, NULL, 155000),
(155001, '3.30.200.20-FF-000900', NULL, 'Os02g0136900 protein', 117, NULL, NULL, 155001),
(155002, '1.10.150.20-FF-000189', NULL, 'Dmc1b', 80, NULL, NULL, 155002),
(155003, '3.30.200.40-FF-000002', NULL, 'm7GpppX diphosphatase', 125, NULL, NULL, 155003),
(155004, '2.30.29.30-FF-000182', NULL, 'Rho GTPase activating protein 9', 124, NULL, NULL, 155004),
(155005, '2.60.120.10-FF-000017', NULL, 'cAMP-dependent protein kinase type II regulatory subunit', 144, NULL, NULL, 155005),
(155006, '3.10.20.90-FF-001015', NULL, 'Uncharacterized protein', 22, NULL, NULL, 155006),
(155007, '1.10.510.10-FF-001804', NULL, 'Protein CBG04913', 284, NULL, NULL, 155007),
(155008, '3.80.10.10-FF-004490', NULL, 'Leucine-rich repeat protein kinase family protein', 103, NULL, NULL, 155008),
(155009, '3.60.21.10-FF-000194', NULL, 'Serine/threonine-protein phosphatase', 326, NULL, NULL, 155009),
(155010, '3.30.70.1660-FF-000043', NULL, 'Uncharacterized protein', 99, NULL, NULL, 155010),
(155011, '1.20.1070.10-FF-000019', NULL, 'Lutropin-choriogonadotropic hormone receptor', 284, NULL, NULL, 155011),
(155012, '3.90.660.10-FF-000132', NULL, NULL, 45, NULL, NULL, 155012),
(155013, '3.40.50.300-FF-006957', NULL, 'Uncharacterized protein', 313, NULL, NULL, 155013),
(155014, '1.20.1050.10-FF-000214', NULL, 'Glutathione s-transferase', 161, NULL, NULL, 155014),
(155015, '1.10.10.60-FF-001106', NULL, NULL, 67, NULL, NULL, 155015),
(155016, '2.40.70.10-FF-000158', NULL, 'OSJNba0093F12.2 protein', 194, NULL, NULL, 155016);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(155017, '2.10.110.10-FF-000219', NULL, 'Uncharacterized protein', 57, NULL, NULL, 155017),
(155018, '1.50.10.20-FF-000013', NULL, 'Transcobalamin-2', 297, NULL, NULL, 155018),
(155019, '3.10.20.90-FF-000397', NULL, 'Splicing factor 3A subunit', 109, NULL, NULL, 155019),
(155020, '1.10.220.150-FF-000034', NULL, 'Sporulation protein SPS18', 162, NULL, NULL, 155020),
(155021, '2.60.34.20-FF-000009', NULL, NULL, 157, NULL, NULL, 155021),
(155022, '2.10.25.10-FF-001522', NULL, 'Uncharacterized protein', 45, NULL, NULL, 155022),
(155023, '2.160.20.10-FF-000155', NULL, 'Os01g0172900 protein', 112, NULL, NULL, 155023),
(155024, '3.90.226.10-FF-000320', NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', 360, NULL, NULL, 155024),
(155025, '3.30.70.330-FF-001863', NULL, NULL, 210, NULL, NULL, 155025),
(155026, '2.130.10.10-FF-005720', NULL, 'Uncharacterized protein', 139, NULL, NULL, 155026),
(155027, '3.40.50.300-FF-007463', NULL, 'Probable ATP-dependent RNA helicase ddx27', 242, NULL, NULL, 155027),
(155028, '3.40.50.2000-FF-000238', NULL, 'Glycosyltransferase', 239, NULL, NULL, 155028),
(155029, '1.10.10.60-FF-000813', NULL, NULL, 68, NULL, NULL, 155029),
(155030, '3.40.50.1010-FF-000025', NULL, 'DNA repair protein RAD2', 135, NULL, NULL, 155030),
(155031, '2.60.120.590-FF-000058', NULL, 'Alpha-ketoglutarate-dependent dioxygenase abh1', 188, NULL, NULL, 155031),
(155032, '1.25.40.20-FF-000141', NULL, 'E3 ubiquitin-protein ligase MIB1 isoform X3', 85, NULL, NULL, 155032),
(155033, '2.170.150.20-FF-000024', NULL, 'Peptide-methionine (R)-S-oxide reductase', 109, NULL, NULL, 155033),
(155034, '3.30.40.10-FF-001088', NULL, 'Uncharacterized protein', 88, NULL, NULL, 155034),
(155035, '3.40.640.10-FF-000035', NULL, 'O-succinylhomoserine sulfhydrylase', 282, NULL, NULL, 155035),
(155036, '1.10.287.70-FF-000419', NULL, 'Predicted protein', 234, NULL, NULL, 155036),
(155037, '2.60.40.10-FF-004118', NULL, NULL, 92, NULL, NULL, 155037),
(155038, '1.25.40.10-FF-001335', NULL, 'Os10g0558600 protein', 107, NULL, NULL, 155038),
(155039, '3.80.10.10-FF-000218', NULL, 'Probable E3 ubiquitin-protein ligase ipaH7.8', 263, NULL, NULL, 155039),
(155040, '3.40.50.300-FF-005333', NULL, 'DEAD (Asp-Glu-Ala-Asp) box polypeptide 41', 147, NULL, NULL, 155040),
(155041, '3.40.50.300-FF-002354', NULL, 'Cytosolic Fe-S cluster assembly factor NUBP1 homolog', 260, NULL, NULL, 155041),
(155042, '1.10.238.10-FF-000362', NULL, 'Centrin-4', 74, NULL, NULL, 155042),
(155043, '1.10.510.10-FF-001220', NULL, 'Serine/threonine-protein kinase', 215, NULL, NULL, 155043),
(155044, '4.10.1000.10-FF-000037', NULL, 'Zinc finger CCCH domain-containing protein 39', 33, NULL, NULL, 155044),
(155045, '1.25.10.10-FF-002564', NULL, '26S proteasome non-ATPase regulatory subunit 5-like Protein', 170, NULL, NULL, 155045),
(155046, '2.40.30.270-FF-000040', NULL, 'Predicted protein', 45, NULL, NULL, 155046),
(155047, '3.30.70.2280-FF-000009', NULL, 'RNA helicase', 80, NULL, NULL, 155047),
(155048, '1.10.1070.11-FF-000051', NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', 182, NULL, NULL, 155048),
(155049, '1.10.238.10-FF-000682', NULL, 'GM13096', 112, NULL, NULL, 155049),
(155050, '1.10.760.10-FF-000103', NULL, 'Cytochrome c, somatic a', 65, NULL, NULL, 155050),
(155051, '3.30.420.10-FF-000212', NULL, 'Pol polyprotein', 157, NULL, NULL, 155051),
(155052, '3.20.20.100-FF-000201', NULL, 'Uncharacterized protein', 255, NULL, NULL, 155052),
(155053, '3.90.640.10-FF-000018', NULL, 'Chromatin remodeling complex subunit', 31, NULL, NULL, 155053),
(155054, '3.40.50.300-FF-001943', NULL, 'DEAD (Asp-Glu-Ala-Asp) box polypeptide 60', 214, NULL, NULL, 155054),
(155055, '1.25.40.10-FF-001919', NULL, 'Putative pentatricopeptide repeat-containing protein At1g74400', 70, NULL, NULL, 155055),
(155056, '1.10.620.20-FF-000034', NULL, 'Stearoyl-[acyl-carrier-protein] 9-desaturase 7 chloroplastic', 40, NULL, NULL, 155056),
(155057, '1.10.3080.10-FF-000011', NULL, 'Chloride channel protein', 494, NULL, NULL, 155057),
(155058, '2.40.50.140-FF-000786', NULL, NULL, 71, NULL, NULL, 155058);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(155059, '2.40.50.690-FF-000035', NULL, 'Uncharacterized protein', 95, NULL, NULL, 155059),
(155060, '1.10.600.10-FF-000030', NULL, 'Geranylgeranyl pyrophosphate synthase', 330, NULL, NULL, 155060),
(155061, '1.25.40.10-FF-003589', NULL, 'DNA-directed RNA polymerase', 160, NULL, NULL, 155061),
(155062, '1.25.10.10-FF-002935', NULL, 'Predicted protein', 87, NULL, NULL, 155062),
(155063, '1.10.510.10-FF-000383', NULL, 'Mitogen-activated protein kinase kinase kinase 14', 206, NULL, NULL, 155063),
(155064, '1.10.150.50-FF-000052', NULL, 'Kinesin family member 24', 72, NULL, NULL, 155064),
(155065, '3.40.50.720-FF-002114', NULL, 'Uncharacterized protein', 116, NULL, NULL, 155065),
(155066, '3.30.420.40-FF-000316', NULL, 'Heat shock 70 kDa protein cognate', 86, NULL, NULL, 155066),
(155067, '2.20.25.160-FF-000001', NULL, 'Aspartoacylase', 48, NULL, NULL, 155067),
(155068, '3.30.160.60-FF-003258', NULL, 'Uncharacterized protein, isoform A', 56, NULL, NULL, 155068),
(155069, '4.10.240.10-FF-000108', NULL, 'NosA protein', 70, NULL, NULL, 155069),
(155070, '2.70.150.10-FF-000028', NULL, 'Calcium-transporting ATPase', 154, NULL, NULL, 155070),
(155071, '1.20.58.60-FF-000165', NULL, 'nesprin-1 isoform X1', 126, NULL, NULL, 155071),
(155072, '3.40.50.720-FF-001496', NULL, 'Uncharacterized protein', 172, NULL, NULL, 155072),
(155073, '3.30.70.260-FF-000083', NULL, 'Acetolactate synthase small subunit', 78, NULL, NULL, 155073),
(155074, '2.40.30.10-FF-000049', NULL, '39S ribosomal protein L3, mitochondrial', 83, NULL, NULL, 155074),
(155075, '3.20.20.80-FF-000107', NULL, 'Alpha-N-acetylglucosaminidase family', 340, NULL, NULL, 155075),
(155076, '2.60.40.10-FF-000959', NULL, 'Interleukin-12 subunit beta', 84, NULL, NULL, 155076),
(155077, '3.30.230.70-FF-000029', NULL, 'Polyribonucleotide nucleotidyltransferase', 310, NULL, NULL, 155077),
(155078, '1.10.640.10-FF-000044', NULL, 'Skpo-1', 162, NULL, NULL, 155078),
(155079, '1.10.418.10-FF-000128', NULL, 'CRE-PAT-6 protein', 126, NULL, NULL, 155079),
(155080, '3.40.47.10-FF-000097', NULL, 'Acetyl-CoA acetyltransferase 2', 67, NULL, NULL, 155080),
(155081, '2.60.34.10-FF-000107', NULL, 'Uncharacterized protein', 157, NULL, NULL, 155081),
(155082, '3.30.160.60-FF-005512', NULL, NULL, 29, NULL, NULL, 155082),
(155083, '1.20.1070.10-FF-000912', NULL, 'Uncharacterized protein', 260, NULL, NULL, 155083),
(155084, '3.40.50.300-FF-003079', NULL, 'Small GTPase EhRabX5, putative', 186, NULL, NULL, 155084),
(155085, '3.10.110.10-FF-000221', NULL, 'Ubiquitin-conjugating enzyme E2E 2', 116, NULL, NULL, 155085),
(155086, '1.20.5.1160-FF-000019', NULL, 'LamC, isoform B', 117, NULL, NULL, 155086),
(155087, '3.80.10.10-FF-002348', NULL, 'Uncharacterized protein', 178, NULL, NULL, 155087),
(155088, '3.40.50.880-FF-000116', NULL, 'AraC family transcriptional regulator', 198, NULL, NULL, 155088),
(155089, '2.10.25.10-FF-000903', NULL, 'C-type LECtin', 38, NULL, NULL, 155089),
(155090, '2.130.10.10-FF-001117', NULL, 'DDB1 and CUL4-associated factor 11', 144, NULL, NULL, 155090),
(155091, '3.30.160.60-FF-003359', NULL, 'Zinc finger protein', 31, NULL, NULL, 155091),
(155092, '1.20.920.20-FF-000021', NULL, 'Dynein heavy chain 5, axonemal', 161, NULL, NULL, 155092),
(155093, '1.20.58.1100-FF-000018', NULL, 'Uncharacterized protein', 41, NULL, NULL, 155093),
(155094, '1.10.132.30-FF-000015', NULL, 'DNA-directed RNA polymerase subunit', 158, NULL, NULL, 155094),
(155095, '3.40.50.1820-FF-001459', NULL, 'Uncharacterized protein', 180, NULL, NULL, 155095),
(155096, '3.90.190.10-FF-000163', NULL, 'Protein tyrosine phosphatase, receptor type D', 183, NULL, NULL, 155096),
(155097, '3.90.550.10-FF-000146', NULL, 'Tout-velu, isoform B', 276, NULL, NULL, 155097),
(155098, '3.40.50.10330-FF-000100', NULL, 'Diacylglycerol kinase', 137, NULL, NULL, 155098),
(155099, '1.25.40.20-FF-001456', NULL, 'Uncharacterized protein', 234, NULL, NULL, 155099),
(155100, '3.40.50.720-FF-002238', NULL, 'Uncharacterized protein', 90, NULL, NULL, 155100),
(155101, '1.10.10.10-FF-000046', NULL, 'RNA polymerase sigma factor RpoS', 77, NULL, NULL, 155101);
INSERT INTO "PUBLIC"."MODEL" VALUES
(155102, '2.20.25.10-FF-000021', NULL, 'Multifunctional methyltransferase subunit trm112', 127, NULL, NULL, 155102),
(155103, '3.30.450.30-FF-000028', NULL, 'Profilin', 129, NULL, NULL, 155103),
(155104, '3.30.460.10-FF-000107', NULL, 'Aminoglycoside 6-adenylyltransferase', 131, NULL, NULL, 155104),
(155105, '1.20.1070.10-FF-000227', NULL, 'Pyroglutamylated RFamide peptide receptor a', 339, NULL, NULL, 155105),
(155106, '1.10.472.10-FF-000490', NULL, 'Cyclin-D2-1', 111, NULL, NULL, 155106),
(155107, '3.40.50.300-FF-002562', NULL, 'ATP synthase subunit alpha, mitochondrial', 67, NULL, NULL, 155107),
(155108, '3.30.160.60-FF-002533', NULL, 'Zinc finger protein 770', 26, NULL, NULL, 155108),
(155109, '3.50.30.20-FF-000010', NULL, 'Carbamoyl-phosphate synthase small chain', 139, NULL, NULL, 155109),
(155110, '1.10.8.270-FF-000037', NULL, 'TBC1 domain family member 22A', 128, NULL, NULL, 155110),
(155111, '3.90.800.10-FF-000008', NULL, NULL, 75, NULL, NULL, 155111),
(155112, '3.40.190.290-FF-000126', NULL, 'Arginine/lysine-responsive transcriptional regulator ArgP', 230, NULL, NULL, 155112),
(155113, '2.90.10.10-FF-000068', NULL, 'Uncharacterized protein', 121, NULL, NULL, 155113),
(155114, '2.30.30.30-FF-000128', NULL, 'Ribosomal protein L24', 109, NULL, NULL, 155114),
(155115, '3.60.40.10-FF-000092', NULL, 'Protein phosphatase 2C', 151, NULL, NULL, 155115),
(155116, '2.60.120.10-FF-000225', NULL, 'Transcriptional regulator Crp/Fnr family', 200, NULL, NULL, 155116),
(155117, '3.40.30.10-FF-001171', NULL, 'Glutathione S-transferase Mu 5', 86, NULL, NULL, 155117),
(155118, '3.40.50.620-FF-000853', NULL, 'Uncharacterized protein', 238, NULL, NULL, 155118),
(155119, '1.20.1270.60-FF-000201', NULL, 'growth arrest-specific protein 7', 274, NULL, NULL, 155119),
(155120, '3.80.10.10-FF-001179', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 137, NULL, NULL, 155120),
(155121, '1.50.40.10-FF-000304', NULL, 'Mitochondrial carrier protein, putative', 314, NULL, NULL, 155121),
(155122, '3.30.870.10-FF-000032', NULL, 'Phospholipase', 153, NULL, NULL, 155122),
(155123, '1.10.3210.10-FF-000073', NULL, 'Predicted protein', 222, NULL, NULL, 155123),
(155124, '1.10.10.60-FF-000488', NULL, 'DnaJ-like protein subfamily C member 2', 59, NULL, NULL, 155124),
(155125, '1.20.120.1900-FF-000069', NULL, 'Spindle pole body component', 446, NULL, NULL, 155125),
(155126, '2.60.40.10-FF-002988', NULL, 'Two-component system sensor histidine kinase/response regulator', 126, NULL, NULL, 155126),
(155127, '3.30.470.20-FF-000038', NULL, 'Pyruvate, phosphate dikinase, chloroplastic', 98, NULL, NULL, 155127),
(155128, '3.40.250.10-FF-000224', NULL, 'Expressed protein', 118, NULL, NULL, 155128),
(155129, '1.20.1310.10-FF-000156', NULL, NULL, 46, NULL, NULL, 155129),
(155130, '3.90.1140.10-FF-000024', NULL, 'Uncharacterized protein', 195, NULL, NULL, 155130),
(155131, '3.30.70.330-FF-001975', NULL, NULL, 190, NULL, NULL, 155131),
(155132, '3.10.20.440-FF-000002', NULL, 'Sarcosine oxidase, alpha subunit', 95, NULL, NULL, 155132),
(155133, '1.20.1050.10-FF-000006', NULL, 'Elongation factor 1 gamma', 137, NULL, NULL, 155133),
(155134, '3.30.70.330-FF-000227', NULL, 'mRNA binding post-transcriptional regulator', 106, NULL, NULL, 155134),
(155135, '3.90.70.10-FF-000463', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 266, NULL, NULL, 155135),
(155136, '3.30.559.70-FF-000045', NULL, 'Uncharacterized protein', 254, NULL, NULL, 155136),
(155137, '3.30.420.40-FF-000108', NULL, 'Glycerol kinase, glycosomal', 252, NULL, NULL, 155137),
(155138, '1.20.1720.10-FF-000081', NULL, NULL, 137, NULL, NULL, 155138),
(155139, '3.40.50.300-FF-008082', NULL, 'Predicted protein', 117, NULL, NULL, 155139),
(155140, '1.10.10.10-FF-001215', NULL, 'Two-component transcriptional regulator, winged helix family', 110, NULL, NULL, 155140),
(155141, '2.130.10.10-FF-000499', NULL, 'PWP2, small subunit processome component', 210, NULL, NULL, 155141),
(155142, '3.30.160.60-FF-005967', NULL, NULL, 76, NULL, NULL, 155142);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(155143, '2.70.98.10-FF-000035', NULL, 'Aldose 1-epimerase', 336, NULL, NULL, 155143),
(155144, '1.25.40.10-FF-000716', NULL, 'Protein KINESIN LIGHT CHAIN-RELATED 2', 163, NULL, NULL, 155144),
(155145, '1.20.1270.60-FF-000190', NULL, 'Uncharacterized protein', 263, NULL, NULL, 155145),
(155146, '1.20.80.10-FF-000016', NULL, 'Krev interaction trapped protein 1', 119, NULL, NULL, 155146),
(155147, '3.80.10.10-FF-003860', NULL, 'Uncharacterized protein', 115, NULL, NULL, 155147),
(155148, '3.30.40.10-FF-000469', NULL, 'Anaphase-promoting complex subunit 11', 68, NULL, NULL, 155148),
(155149, '3.60.15.10-FF-000140', NULL, 'Ribonuclease J', 275, NULL, NULL, 155149),
(155150, '3.30.2160.10-FF-000062', NULL, 'Uncharacterized protein', 57, NULL, NULL, 155150),
(155151, '3.30.200.20-FF-002345', NULL, 'Uncharacterized protein', 56, NULL, NULL, 155151),
(155152, '3.40.50.2000-FF-000901', NULL, 'Gll0082 protein', 169, NULL, NULL, 155152),
(155153, '3.30.1490.20-FF-000033', NULL, 'alpha-glucan water dikinase, chloroplastic isoform X2', 47, NULL, NULL, 155153),
(155154, '2.30.30.40-FF-000249', NULL, 'Activated Cdc42 kinase-like', 56, NULL, NULL, 155154),
(155155, '2.30.110.10-FF-000097', NULL, 'Predicted protein', 148, NULL, NULL, 155155),
(155156, '3.30.160.60-FF-004770', NULL, NULL, 80, NULL, NULL, 155156),
(155157, '3.60.20.10-FF-000006', NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', 241, NULL, NULL, 155157),
(155158, '3.30.1640.10-FF-000093', NULL, 'DNA helicase', 102, NULL, NULL, 155158),
(155159, '3.20.20.60-FF-000101', NULL, 'Uncharacterized protein', 177, NULL, NULL, 155159),
(155160, '1.20.1070.10-FF-001637', NULL, 'Uncharacterized protein', 138, NULL, NULL, 155160),
(155161, '3.40.50.850-FF-000012', NULL, 'Isochorismatase family protein', 186, NULL, NULL, 155161),
(155162, '3.30.70.2800-FF-000003', NULL, 'Protein Diedel', 91, NULL, NULL, 155162),
(155163, '1.20.1560.10-FF-000315', NULL, 'ABC transporter ATP-binding protein', 326, NULL, NULL, 155163),
(155164, '2.60.40.10-FF-004669', NULL, NULL, 97, NULL, NULL, 155164),
(155165, '3.90.199.10-FF-000020', NULL, NULL, 14, NULL, NULL, 155165),
(155166, '2.60.40.10-FF-004899', NULL, NULL, 102, NULL, NULL, 155166),
(155167, '3.40.850.10-FF-000202', NULL, 'Kinesin-like protein', 373, NULL, NULL, 155167),
(155168, '1.20.1250.20-FF-000446', NULL, 'Nodulin family protein', 218, NULL, NULL, 155168),
(155169, '3.30.230.130-FF-000081', NULL, 'Uncharacterized protein', 141, NULL, NULL, 155169),
(155170, '3.30.470.30-FF-000030', NULL, 'DNA ligase', 248, NULL, NULL, 155170),
(155171, '3.90.930.40-FF-000004', NULL, NULL, 159, NULL, NULL, 155171),
(155172, '3.30.565.10-FF-000126', NULL, 'Histidine kinase', 139, NULL, NULL, 155172),
(155173, '1.25.10.10-FF-000226', NULL, 'GCN1, eIF2 alpha kinase activator homolog', 166, NULL, NULL, 155173),
(155174, '3.40.50.1820-FF-001561', NULL, 'Uncharacterized protein', 117, NULL, NULL, 155174),
(155175, '3.90.148.10-FF-000003', NULL, NULL, 33, NULL, NULL, 155175),
(155176, '1.25.10.10-FF-002356', NULL, 'Uncharacterized protein', 283, NULL, NULL, 155176),
(155177, '2.40.50.1020-FF-000012', NULL, 'Two-component response regulator NatK', 107, NULL, NULL, 155177),
(155178, '3.30.830.10-FF-000243', NULL, 'Uncharacterized protein', 206, NULL, NULL, 155178),
(155179, '1.20.1090.10-FF-000003', NULL, 'Probable hydroxyacid-oxoacid transhydrogenase, mitochondrial', 231, NULL, NULL, 155179),
(155180, '3.30.40.10-FF-000812', NULL, 'Bitesize, isoform G', 144, NULL, NULL, 155180),
(155181, '3.60.21.10-FF-000317', NULL, 'Serine/threonine-protein phosphatase', 205, NULL, NULL, 155181),
(155182, '2.130.10.10-FF-004978', NULL, 'Uncharacterized protein', 82, NULL, NULL, 155182),
(155183, '1.10.10.740-FF-000002', NULL, 'Cysteine-rich venom protein kaouthin-1', 61, NULL, NULL, 155183),
(155184, '3.30.900.10-FF-000030', NULL, 'Mitotic spindle assembly checkpoint protein MAD2B', 229, NULL, NULL, 155184),
(155185, '2.60.40.2580-FF-000003', NULL, 'Minor fimbrium tip subunit MfA4', 151, NULL, NULL, 155185),
(155186, '3.80.10.10-FF-003433', NULL, 'Uncharacterized protein', 65, NULL, NULL, 155186);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(155187, '3.30.450.70-FF-000029', NULL, NULL, 133, NULL, NULL, 155187),
(155188, '3.30.2130.30-FF-000015', NULL, 'RNA methylase family protein', 185, NULL, NULL, 155188),
(155189, '1.20.1250.20-FF-001840', NULL, 'Uncharacterized protein', 139, NULL, NULL, 155189),
(155190, '3.30.70.980-FF-000068', NULL, 'AGL053Cp', 90, NULL, NULL, 155190),
(155191, '3.50.50.60-FF-000006', NULL, 'Succinate dehydrogenase flavoprotein subunit', 303, NULL, NULL, 155191),
(155192, '1.25.40.10-FF-000498', NULL, 'lysine-specific demethylase 6A isoform X1', 112, NULL, NULL, 155192),
(155193, '1.10.840.10-FF-000025', NULL, 'uncharacterized protein LOC108092584 isoform X2', 265, NULL, NULL, 155193),
(155194, '3.30.70.890-FF-000030', NULL, 'glucuronokinase 1', 132, NULL, NULL, 155194),
(155195, '1.10.8.10-FF-000298', NULL, 'Uncharacterized protein', 71, NULL, NULL, 155195),
(155196, '2.130.10.10-FF-001325', NULL, 'Lethal(2) giant larvae protein homolog 1', 179, NULL, NULL, 155196),
(155197, '1.25.40.20-FF-001113', NULL, 'E3 ubiquitin-protein ligase KEG', 231, NULL, NULL, 155197),
(155198, '3.30.60.60-FF-000002', NULL, 'Histone acetyltransferase', 63, NULL, NULL, 155198),
(155199, '2.60.40.1860-FF-000006', NULL, 'protein-arginine deiminase type-1', 120, NULL, NULL, 155199),
(155200, '3.10.50.10-FF-000027', NULL, 'Protein CBG06565', 59, NULL, NULL, 155200),
(155201, '1.25.40.10-FF-002392', NULL, 'Pentatricopeptide repeat-containing protein At3g09650, chloroplastic', 177, NULL, NULL, 155201),
(155202, '3.30.450.50-FF-000023', NULL, 'Putative synaptobrevin-type transport protein', 149, NULL, NULL, 155202),
(155203, '2.60.40.10-FF-005175', NULL, NULL, 118, NULL, NULL, 155203),
(155204, '1.20.900.10-FF-000034', NULL, 'Uncharacterized protein, isoform B', 230, NULL, NULL, 155204),
(155205, '3.40.50.2300-FF-000530', NULL, 'Autoinducer 2-binding periplasmic protein LuxP', 150, NULL, NULL, 155205),
(155206, '3.40.50.1820-FF-001802', NULL, 'Uncharacterized protein', 142, NULL, NULL, 155206),
(155207, '3.30.160.60-FF-003590', NULL, 'Zinc finger protein 248', 85, NULL, NULL, 155207),
(155208, '3.40.50.300-FF-007025', NULL, 'RacS, RHO family GTPase', 205, NULL, NULL, 155208),
(155209, '2.130.10.10-FF-003354', NULL, 'Predicted protein', 91, NULL, NULL, 155209),
(155210, '2.30.29.30-FF-000390', NULL, 'AGC/PDK1 protein kinase, variant 1', 127, NULL, NULL, 155210),
(155211, '1.10.510.10-FF-004093', NULL, NULL, 326, NULL, NULL, 155211),
(155212, '3.40.47.10-FF-000181', NULL, 'Beta ketoacyl-acyl carrier protein synthase', 402, NULL, NULL, 155212),
(155213, '3.30.160.60-FF-001561', NULL, 'Zinc finger and SCAN domain containing 30', 29, NULL, NULL, 155213),
(155214, '1.10.472.130-FF-000085', NULL, 'Uncharacterized protein', 97, NULL, NULL, 155214),
(155215, '2.60.40.10-FF-003146', NULL, 'Predicted protein', 124, NULL, NULL, 155215),
(155216, '3.40.50.300-FF-006406', NULL, 'Uncharacterized protein', 132, NULL, NULL, 155216),
(155217, '3.40.50.1820-FF-000280', NULL, 'Possible conserved membrane protein', 227, NULL, NULL, 155217),
(155218, '3.90.190.10-FF-000371', NULL, 'Protein-tyrosine-phosphatase PTP1', 191, NULL, NULL, 155218),
(155219, '1.25.40.20-FF-000837', NULL, 'LOC100005699 protein', 105, NULL, NULL, 155219),
(155220, '3.40.50.300-FF-002792', NULL, 'bifunctional heparan sulfate N-deacetylase/N-sulfotransferase 4 isoform X2', 109, NULL, NULL, 155220),
(155221, '1.10.287.70-FF-000650', NULL, 'Uncharacterized protein', 166, NULL, NULL, 155221),
(155222, '3.80.10.10-FF-004052', NULL, 'Uncharacterized protein', 308, NULL, NULL, 155222),
(155223, '1.10.10.820-FF-000037', NULL, 'Myosin, heavy chain 9a, non-muscle', 18, NULL, NULL, 155223),
(155224, '2.60.40.200-FF-000011', NULL, 'Superoxide dismutase [Cu-Zn]', 157, NULL, NULL, 155224),
(155225, '1.25.10.10-FF-000327', NULL, 'Epoxyqueuosine reductase', 79, NULL, NULL, 155225),
(155226, '2.60.40.1110-FF-000017', NULL, 'Uncharacterized protein', 86, NULL, NULL, 155226),
(155227, '3.40.850.10-FF-000545', NULL, 'Uncharacterized protein', 239, NULL, NULL, 155227),
(155228, '1.20.58.670-FF-000020', NULL, NULL, 156, NULL, NULL, 155228);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(155229, '3.30.160.60-FF-000841', NULL, 'zinc finger and BTB domain-containing protein 41', 32, NULL, NULL, 155229),
(155230, '3.30.870.10-FF-000138', NULL, 'Uncharacterized protein', 182, NULL, NULL, 155230),
(155231, '3.30.70.270-FF-000187', NULL, 'Uncharacterized protein', 182, NULL, NULL, 155231),
(155232, '3.30.40.10-FF-001661', NULL, 'General Transcription Factor homolog', 62, NULL, NULL, 155232),
(155233, '2.60.120.380-FF-000012', NULL, 'Microbial collagenase', 116, NULL, NULL, 155233),
(155234, '2.60.120.260-FF-000431', NULL, 'Glycoside hydrolase family 29', 122, NULL, NULL, 155234),
(155235, '3.30.70.330-FF-000683', NULL, 'RNA binding protein rggm', 70, NULL, NULL, 155235),
(155236, '3.40.50.300-FF-001382', NULL, 'Protein Ycf2', 163, NULL, NULL, 155236),
(155237, '1.20.1270.10-FF-000113', NULL, 'Uncharacterized protein', 110, NULL, NULL, 155237),
(155238, '3.80.10.10-FF-003776', NULL, 'Uncharacterized protein', 252, NULL, NULL, 155238),
(155239, '3.30.200.20-FF-000007', NULL, 'Cyclin-dependent kinase 14, putative', 83, NULL, NULL, 155239),
(155240, '1.10.3460.10-FF-000006', NULL, 'Chlorophyll a-b binding protein, chloroplastic', 219, NULL, NULL, 155240),
(155241, '3.40.525.10-FF-000065', NULL, 'Uncharacterized protein', 175, NULL, NULL, 155241),
(155242, '3.30.1240.10-FF-000012', NULL, 'HAD family hydrolase', 107, NULL, NULL, 155242),
(155243, '1.10.238.210-FF-000003', NULL, 'GLutamiNAse', 84, NULL, NULL, 155243),
(155244, '1.25.40.10-FF-001015', NULL, 'Cartilage associated protein', 141, NULL, NULL, 155244),
(155245, '2.40.128.620-FF-000009', NULL, 'Uncharacterized protein', 63, NULL, NULL, 155245),
(155246, '3.30.160.60-FF-004871', NULL, NULL, 28, NULL, NULL, 155246),
(155247, '3.30.160.20-FF-000048', NULL, 'Double-stranded RNA-binding protein 1', 74, NULL, NULL, 155247),
(155248, '3.40.140.20-FF-000011', NULL, NULL, 119, NULL, NULL, 155248),
(155249, '3.30.60.20-FF-000136', NULL, 'Heavy chain, Unconventional Myosin', 74, NULL, NULL, 155249),
(155250, '2.10.25.10-FF-000802', NULL, 'Adhesion G protein-coupled receptor E5b, duplicate 3', 40, NULL, NULL, 155250),
(155251, '3.40.1280.10-FF-000063', NULL, 'Ribosomal RNA small subunit methyltransferase E', 171, NULL, NULL, 155251),
(155252, '1.10.1740.10-FF-000039', NULL, 'Response regulator', 65, NULL, NULL, 155252),
(155253, '2.30.140.10-FF-000031', NULL, 'Polyamine aminopropyltransferase', 51, NULL, NULL, 155253),
(155254, '1.10.510.10-FF-004334', NULL, NULL, 134, NULL, NULL, 155254),
(155255, '3.30.160.60-FF-002741', NULL, 'Zinc finger protein 786', 29, NULL, NULL, 155255),
(155256, '2.40.50.120-FF-000022', NULL, 'Netrin-B', 150, NULL, NULL, 155256),
(155257, '3.40.50.620-FF-000752', NULL, 'Cytidylyltransferase family protein', 145, NULL, NULL, 155257),
(155258, '3.30.40.10-FF-001981', NULL, 'Uncharacterized protein', 104, NULL, NULL, 155258),
(155259, '1.25.40.20-FF-000596', NULL, 'Uncharacterized protein', 208, NULL, NULL, 155259),
(155260, '3.30.420.40-FF-000889', NULL, 'Predicted protein', 237, NULL, NULL, 155260),
(155261, '3.40.50.300-FF-005788', NULL, 'Vesicular fusion ATPase, putative (AFU_orthologue AFUA_3G12510)', 78, NULL, NULL, 155261),
(155262, '2.130.10.10-FF-005254', NULL, 'Uncharacterized protein', 276, NULL, NULL, 155262),
(155263, '1.25.40.10-FF-003010', NULL, 'Uncharacterized protein', 119, NULL, NULL, 155263),
(155264, '1.10.238.230-FF-000009', NULL, 'Uncharacterized protein', 57, NULL, NULL, 155264),
(155265, '1.25.10.10-FF-002699', NULL, 'Uncharacterized protein', 62, NULL, NULL, 155265),
(155266, '2.80.10.50-FF-000030', NULL, 'Fascin', 107, NULL, NULL, 155266),
(155267, '3.40.50.300-FF-002915', NULL, 'Unplaced genomic scaffold supercont2.6, whole genome shotgun sequence', 170, NULL, NULL, 155267),
(155268, '2.60.34.30-FF-000001', NULL, 'Competence protein j', 124, NULL, NULL, 155268),
(155269, '3.30.1520.10-FF-000163', NULL, 'Uncharacterized protein', 130, NULL, NULL, 155269),
(155270, '2.20.100.10-FF-000194', NULL, 'Predicted protein', 49, NULL, NULL, 155270),
(155271, '3.40.309.10-FF-000097', NULL, 'Uncharacterized protein', 209, NULL, NULL, 155271);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(155272, '2.130.10.10-FF-004074', NULL, 'Uncharacterized protein', 204, NULL, NULL, 155272),
(155273, '1.20.5.370-FF-000020', NULL, NULL, 87, NULL, NULL, 155273),
(155274, '1.10.1040.10-FF-000126', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', 58, NULL, NULL, 155274),
(155275, '3.20.10.10-FF-000041', NULL, 'Branched-chain-amino-acid aminotransferase', 152, NULL, NULL, 155275),
(155276, '1.20.5.4770-FF-000006', NULL, 'Zinc finger A20 and AN1 domain-containing stress-associated protein 1', 66, NULL, NULL, 155276),
(155277, '3.50.50.60-FF-000349', NULL, '2-heptyl-3-hydroxy-4(1H)-quinolone synthase', 362, NULL, NULL, 155277),
(155278, '3.30.70.1230-FF-000167', NULL, 'Predicted protein', 200, NULL, NULL, 155278),
(155279, '2.70.98.20-FF-000027', NULL, 'Amine oxidase', 315, NULL, NULL, 155279),
(155280, '3.40.50.2300-FF-000075', NULL, 'L-arabinose-binding periplasmic protein', 136, NULL, NULL, 155280),
(155281, '2.60.40.10-FF-002084', NULL, 'Glucanase', 91, NULL, NULL, 155281),
(155282, '1.25.40.10-FF-004449', NULL, 'Uncharacterized protein', 114, NULL, NULL, 155282),
(155283, '1.20.120.910-FF-000001', NULL, 'RNA polymerase-binding transcription factor DksA', 151, NULL, NULL, 155283),
(155284, '1.25.40.10-FF-000054', NULL, 'Pre-mRNA processing factor 6', 72, NULL, NULL, 155284),
(155285, '2.40.30.180-FF-000013', NULL, 'Uncharacterized protein', 72, NULL, NULL, 155285),
(155286, '1.20.120.220-FF-000002', NULL, 'ATP synthase subunit a', 177, NULL, NULL, 155286),
(155287, '3.40.50.1000-FF-000146', NULL, 'Phosphoserine phosphatase SerB', 295, NULL, NULL, 155287),
(155288, '3.80.10.10-FF-001729', NULL, 'Leucine-rich repeat protein (LRRP), putative', 335, NULL, NULL, 155288),
(155289, '2.130.10.10-FF-003011', NULL, 'Uncharacterized protein', 176, NULL, NULL, 155289),
(155290, '1.20.1530.20-FF-000024', NULL, 'YMR034C-like protein', 342, NULL, NULL, 155290),
(155291, '3.40.50.2000-FF-000322', NULL, 'UDP glucuronosyltransferase family 2 member B4', 87, NULL, NULL, 155291),
(155292, '3.30.540.10-FF-000029', NULL, '3''-phosphoadenosine 5''-phosphate phosphatase', 135, NULL, NULL, 155292),
(155293, '1.10.287.1490-FF-000083', NULL, 'Maltose/maltodextrin ABC transporter, permease protein MalG', 156, NULL, NULL, 155293),
(155294, '3.30.565.10-FF-000564', NULL, 'Sensor histidine kinase/response regulator, putative', 110, NULL, NULL, 155294),
(155295, '1.20.1250.20-FF-000103', NULL, 'monosaccharide-sensing protein 2', 248, NULL, NULL, 155295),
(155296, '3.50.50.60-FF-001198', NULL, 'Putative flavin-containing monooxygenase 2', 395, NULL, NULL, 155296),
(155297, '3.40.50.2300-FF-000210', NULL, 'Vomeronasal 2, receptor 79', 267, NULL, NULL, 155297),
(155298, '2.160.10.30-FF-000003', NULL, NULL, 81, NULL, NULL, 155298),
(155299, '2.30.180.10-FF-000163', NULL, NULL, 66, NULL, NULL, 155299),
(155300, '4.10.830.40-FF-000011', NULL, NULL, 65, NULL, NULL, 155300),
(155301, '3.20.20.30-FF-000008', NULL, 'Xenobiotic compound monooxygenase A subunit', 457, NULL, NULL, 155301),
(155302, '1.10.340.70-FF-000005', NULL, 'Uncharacterized protein', 88, NULL, NULL, 155302),
(155303, '3.40.50.720-FF-000771', NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', 133, NULL, NULL, 155303),
(155304, '4.10.240.10-FF-000007', NULL, 'C6 transcription factor FacB', 84, NULL, NULL, 155304),
(155305, '2.40.30.10-FF-000392', NULL, 'tRNA-specific 2-thiouridylase', 81, NULL, NULL, 155305),
(155306, '3.40.30.10-FF-000457', NULL, 'Co-chaperone YbbN', 111, NULL, NULL, 155306),
(155307, '3.30.160.60-FF-004539', NULL, NULL, 21, NULL, NULL, 155307),
(155308, '1.10.506.10-FF-000064', NULL, 'Plexin A3', 193, NULL, NULL, 155308),
(155309, '3.40.50.2300-FF-000873', NULL, 'Uncharacterized protein', 265, NULL, NULL, 155309),
(155310, '3.40.50.620-FF-000191', NULL, 'Nicotinamide-nucleotide adenylyltransferase', 242, NULL, NULL, 155310),
(155311, '1.10.132.60-FF-000013', NULL, 'DNA polymerase Pol2', 165, NULL, NULL, 155311),
(155312, '2.60.260.20-FF-000047', NULL, 'Molecular chaperone DnaJ', 110, NULL, NULL, 155312),
(155313, '1.20.58.70-FF-000055', NULL, 'QA-SNARE protein putative', 215, NULL, NULL, 155313);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(155314, '2.130.10.10-FF-004635', NULL, 'Uncharacterized protein', 195, NULL, NULL, 155314),
(155315, '1.25.40.10-FF-004106', NULL, 'Uncharacterized protein', 298, NULL, NULL, 155315),
(155316, '3.40.50.300-FF-004692', NULL, 'DNA helicase', 194, NULL, NULL, 155316),
(155317, '3.40.50.300-FF-001600', NULL, 'RhoU, isoform B', 189, NULL, NULL, 155317),
(155318, '2.70.130.10-FF-000128', NULL, NULL, 143, NULL, NULL, 155318),
(155319, '3.90.1150.10-FF-000305', NULL, 'Sphingosine Phosphate Lyase', 121, NULL, NULL, 155319),
(155320, '1.20.58.60-FF-000518', NULL, 'Spectrin repeat containing, nuclear envelope 1a', 116, NULL, NULL, 155320),
(155321, '3.30.1640.10-FF-000082', NULL, 'DNA replication licensing factor MCM7', 90, NULL, NULL, 155321),
(155322, '1.20.1250.20-FF-001727', NULL, 'Uncharacterized protein', 204, NULL, NULL, 155322),
(155323, '1.10.10.10-FF-000484', NULL, 'ArsR family transcriptional regulator', 98, NULL, NULL, 155323),
(155324, '1.25.40.330-FF-000004', NULL, 'Adenylyl cyclase-associated protein', 170, NULL, NULL, 155324),
(155325, '2.60.40.10-FF-001465', NULL, 'Interleukin-22 receptor subunit alpha-1', 108, NULL, NULL, 155325),
(155326, '1.25.10.10-FF-001507', NULL, 'Uncharacterized protein', 199, NULL, NULL, 155326),
(155327, '3.30.160.60-FF-002639', NULL, 'Kruppel-Like Factor (Zinc finger protein)', 31, NULL, NULL, 155327),
(155328, '1.20.1050.130-FF-000011', NULL, 'Glutamyl-prolyl-tRNA synthetase', 170, NULL, NULL, 155328),
(155329, '3.30.160.60-FF-002078', NULL, NULL, 28, NULL, NULL, 155329),
(155330, '1.10.1300.10-FF-000034', NULL, 'Phosphodiesterase', 313, NULL, NULL, 155330),
(155331, '3.20.20.10-FF-000002', NULL, 'Alanine racemase', 211, NULL, NULL, 155331),
(155332, '3.80.10.10-FF-002005', NULL, 'Zgc:194906', 227, NULL, NULL, 155332),
(155333, '3.30.70.330-FF-001655', NULL, NULL, 66, NULL, NULL, 155333),
(155334, '1.25.40.10-FF-004781', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 186, NULL, NULL, 155334),
(155335, '1.20.5.220-FF-000003', NULL, 'Photosystem I reaction center subunit VI', 23, NULL, NULL, 155335),
(155336, '3.30.40.10-FF-000149', NULL, 'E3 ubiquitin-protein ligase AMFR', 80, NULL, NULL, 155336),
(155337, '3.30.160.60-FF-001229', NULL, 'Zinc finger protein 341', 32, NULL, NULL, 155337),
(155338, '2.40.180.10-FF-000003', NULL, 'Catalase', 451, NULL, NULL, 155338),
(155339, '2.60.40.10-FF-000616', NULL, 'PKHD1 like 1', 81, NULL, NULL, 155339),
(155340, '2.10.110.10-FF-000096', NULL, 'LIM domain kinase 2 isoform X2', 37, NULL, NULL, 155340),
(155341, '3.30.160.60-FF-001105', NULL, 'Zinc finger protein 677', 28, NULL, NULL, 155341),
(155342, '2.60.40.1190-FF-000002', NULL, 'Amidohydrolase 2', 212, NULL, NULL, 155342),
(155343, '2.40.160.120-FF-000054', NULL, 'Predicted protein', 95, NULL, NULL, 155343),
(155344, '3.40.50.2000-FF-000446', NULL, 'WbcN protein', 187, NULL, NULL, 155344),
(155345, '3.10.250.10-FF-000040', NULL, 'Multidomain scavenger receptor', 123, NULL, NULL, 155345),
(155346, '3.30.70.330-FF-000806', NULL, 'Heterogeneous nuclear ribonucleoprotein Q isoform A', 146, NULL, NULL, 155346),
(155347, '3.30.160.60-FF-005490', NULL, NULL, 37, NULL, NULL, 155347),
(155348, '3.30.420.40-FF-000546', NULL, 'YALI0B10538p', 153, NULL, NULL, 155348),
(155349, '3.90.180.10-FF-000100', NULL, 'Putative cinnamyl alcohol dehydrogenase 6', 30, NULL, NULL, 155349),
(155350, '1.20.1080.10-FF-000042', NULL, 'AQuaPorin or aquaglyceroporin related', 246, NULL, NULL, 155350),
(155351, '1.10.418.10-FF-000117', NULL, 'p-loop nucleoside triphosphate hydrolase superfamily protein with CH (Calponin Homology) domain', 81, NULL, NULL, 155351),
(155352, '3.30.110.60-FF-000001', NULL, 'RNA-binding protein YhbY', 97, NULL, NULL, 155352),
(155353, '1.20.1250.10-FF-000005', NULL, 'cardiotrophin-like cytokine factor 1', 178, NULL, NULL, 155353),
(155354, '3.30.470.20-FF-000049', NULL, 'tubulin--tyrosine ligase', 219, NULL, NULL, 155354),
(155355, '3.40.50.980-FF-000034', NULL, 'Nonribosomal peptide synthase, putative (JCVI)', 157, NULL, NULL, 155355),
(155356, '2.40.30.10-FF-000493', NULL, 'Nitric oxide synthase', 117, NULL, NULL, 155356);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(155357, '3.30.710.10-FF-000189', NULL, 'Predicted protein', 106, NULL, NULL, 155357),
(155358, '3.40.50.1000-FF-000702', NULL, NULL, 107, NULL, NULL, 155358),
(155359, '1.25.40.610-FF-000004', NULL, 'adhesion G protein-coupled receptor B1', 124, NULL, NULL, 155359),
(155360, '1.20.870.10-FF-000042', NULL, 'Ras guanine nucleotide exchange factor M', 153, NULL, NULL, 155360),
(155361, '1.20.1070.10-FF-001396', NULL, 'Uncharacterized protein', 241, NULL, NULL, 155361),
(155362, '1.25.40.10-FF-005163', NULL, 'Uncharacterized protein', 76, NULL, NULL, 155362),
(155363, '1.10.1200.10-FF-000004', NULL, 'D-alanyl carrier protein', 78, NULL, NULL, 155363),
(155364, '1.20.1280.50-FF-000030', NULL, 'F-box/kelch-repeat protein At3g61590', 48, NULL, NULL, 155364),
(155365, '3.50.50.60-FF-000793', NULL, 'FAD-dependent oxidoreductase domain containing 2', 215, NULL, NULL, 155365),
(155366, '3.30.420.40-FF-000884', NULL, 'Uncharacterized protein', 30, NULL, NULL, 155366),
(155367, '1.10.238.20-FF-000016', NULL, 'Odorant-binding protein 57e', 106, NULL, NULL, 155367),
(155368, '3.40.50.620-FF-000292', NULL, 'Pantetheine-phosphate adenylyltransferase, putative', 163, NULL, NULL, 155368),
(155369, '3.30.160.60-FF-004326', NULL, NULL, 28, NULL, NULL, 155369),
(155370, '3.40.50.170-FF-000010', NULL, 'Methionyl-tRNA formyltransferase', 219, NULL, NULL, 155370),
(155371, '1.25.10.10-FF-001390', NULL, 'Armadillo repeat protein, putative', 173, NULL, NULL, 155371),
(155372, '3.30.479.20-FF-000018', NULL, 'Elongation factor Ts', 39, NULL, NULL, 155372),
(155373, '1.10.20.10-FF-000209', NULL, NULL, 87, NULL, NULL, 155373),
(155374, '3.30.710.10-FF-000301', NULL, 'GDNF inducible zinc finger protein 1', 151, NULL, NULL, 155374),
(155375, '3.40.50.1000-FF-000584', NULL, NULL, 178, NULL, NULL, 155375),
(155376, '3.30.70.330-FF-002032', NULL, NULL, 97, NULL, NULL, 155376),
(155377, '1.20.5.270-FF-000001', NULL, 'Cytochrome b-c1 complex subunit Rieske, mitochondrial', 64, NULL, NULL, 155377),
(155378, '3.20.20.210-FF-000009', NULL, 'Putative uroporphyrinogen decarboxylase', 340, NULL, NULL, 155378),
(155379, '3.40.50.300-FF-003635', NULL, 'DNA repair protein RecN', 250, NULL, NULL, 155379),
(155380, '3.10.20.90-FF-000846', NULL, 'Ubiquitin family protein', 83, NULL, NULL, 155380),
(155381, '2.60.40.60-FF-000957', NULL, 'Uncharacterized protein', 99, NULL, NULL, 155381),
(155382, '3.30.70.2970-FF-000003', NULL, 'Putative lipoprotein LpqG', 111, NULL, NULL, 155382),
(155383, '3.30.1960.10-FF-000010', NULL, 'tRNA(Phe) 7-((3-amino-3-carboxypropyl)-4-demethylwyosine(37)-N(4))-methyltransferase 1', 192, NULL, NULL, 155383),
(155384, '3.40.50.720-FF-000552', NULL, 'NEDD8-activating enzyme E1 catalytic subunit', 213, NULL, NULL, 155384),
(155385, '3.90.550.50-FF-000129', NULL, 'Hexosyltransferase', 267, NULL, NULL, 155385),
(155386, '1.20.120.350-FF-000249', NULL, NULL, 56, NULL, NULL, 155386),
(155387, '2.60.40.10-FF-002746', NULL, 'Uncharacterized protein', 118, NULL, NULL, 155387),
(155388, '3.20.70.20-FF-000042', NULL, 'Hypothetical nucleotide reductase', 381, NULL, NULL, 155388),
(155389, '1.10.287.4070-FF-000008', NULL, 'PRP31p Splicing factor', 147, NULL, NULL, 155389),
(155390, '3.30.1020.10-FF-000006', NULL, 'Peroxiredoxin', 104, NULL, NULL, 155390),
(155391, '3.30.160.60-FF-003814', NULL, NULL, 41, NULL, NULL, 155391),
(155392, '1.10.20.10-FF-000316', NULL, NULL, 134, NULL, NULL, 155392),
(155393, '3.40.50.300-FF-000881', NULL, 'ABC multidrug transporter A-1', 240, NULL, NULL, 155393),
(155394, '1.20.1270.10-FF-000091', NULL, 'Heat shock cognate 71 kDa protein', 49, NULL, NULL, 155394),
(155395, '2.10.25.10-FF-001758', NULL, 'Notch 3', 55, NULL, NULL, 155395),
(155396, '3.40.50.12280-FF-000016', NULL, 'Uncharacterized protein', 48, NULL, NULL, 155396),
(155397, '2.60.40.10-FF-003258', NULL, 'Interleukin-6 receptor subunit alpha', 72, NULL, NULL, 155397),
(155398, '3.30.830.10-FF-000248', NULL, 'AGAP006099-PA', 196, NULL, NULL, 155398),
(155399, '1.10.3470.10-FF-000058', NULL, 'Probable metal transport system membrane protein TM_0125', 228, NULL, NULL, 155399); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(155400, '2.60.120.920-FF-000101', NULL, 'Neuralized E3 ubiquitin protein ligase 1Ab', 149, NULL, NULL, 155400),
(155401, '2.30.39.10-FF-000007', NULL, 'pigment epithelium-derived factor isoform X2', 161, NULL, NULL, 155401),
(155402, '2.60.40.420-FF-000072', NULL, 'Spore coat protein A', 161, NULL, NULL, 155402),
(155403, '3.30.160.60-FF-003707', NULL, 'Zinc finger protein 786', 93, NULL, NULL, 155403),
(155404, '1.10.510.10-FF-000624', NULL, 'Mitogen-activated protein kinase', 224, NULL, NULL, 155404),
(155405, '3.30.60.30-FF-000246', NULL, 'Agrin', 44, NULL, NULL, 155405),
(155406, '2.40.50.140-FF-000909', NULL, NULL, 145, NULL, NULL, 155406),
(155407, '3.40.50.1000-FF-000691', NULL, NULL, 139, NULL, NULL, 155407),
(155408, '2.130.10.10-FF-002617', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit wuho', 285, NULL, NULL, 155408),
(155409, '1.20.1560.10-FF-000540', NULL, 'ATP-binding cassette transporter, subfamily C, member 5, group MRP protein PpABCC5', 335, NULL, NULL, 155409),
(155410, '1.25.40.20-FF-000383', NULL, 'Ankyrin repeat and SOCS box protein 10', 97, NULL, NULL, 155410),
(155411, '3.80.10.10-FF-003208', NULL, 'Si:dkey-286j17.4', 223, NULL, NULL, 155411),
(155412, '1.10.3370.10-FF-000011', NULL, 'Protein translocase subunit SecY', 447, NULL, NULL, 155412),
(155413, '1.25.10.10-FF-000771', NULL, 'Unplaced genomic scaffold supercont1.234, whole genome shotgun sequence', 597, NULL, NULL, 155413),
(155414, '3.40.50.720-FF-001968', NULL, 'Uncharacterized protein', 392, NULL, NULL, 155414),
(155415, '2.20.25.80-FF-000002', NULL, 'probable WRKY transcription factor 31', 78, NULL, NULL, 155415),
(155416, '3.30.70.360-FF-000006', NULL, 'N-fatty-acyl-amino acid synthase/hydrolase PM20D1', 104, NULL, NULL, 155416),
(155417, '3.30.70.2520-FF-000003', NULL, 'L-gulonolactone oxidase 2', 101, NULL, NULL, 155417),
(155418, '1.10.150.390-FF-000011', NULL, NULL, 31, NULL, NULL, 155418),
(155419, '3.30.70.1990-FF-000012', NULL, NULL, 105, NULL, NULL, 155419),
(155420, '2.170.150.80-FF-000019', NULL, 'NAC domain containing protein 64', 157, NULL, NULL, 155420),
(155421, '3.30.160.60-FF-005271', NULL, NULL, 70, NULL, NULL, 155421),
(155422, '1.10.555.10-FF-000025', NULL, 'Rho GTPase-activating protein 20', 200, NULL, NULL, 155422),
(155423, '3.30.70.330-FF-001998', NULL, NULL, 88, NULL, NULL, 155423),
(155424, '3.40.50.2000-FF-000103', NULL, 'Glycosyltransferase', 267, NULL, NULL, 155424),
(155425, '4.10.280.10-FF-000105', NULL, 'Rtg3p', 73, NULL, NULL, 155425),
(155426, '3.80.10.10-FF-003197', NULL, 'Receptor-like kinase TMK2', 228, NULL, NULL, 155426),
(155427, '3.40.50.300-FF-002112', NULL, 'NLR family pyrin domain containing 10', 220, NULL, NULL, 155427),
(155428, '3.30.530.20-FF-000088', NULL, 'START domain containing protein', 202, NULL, NULL, 155428),
(155429, '3.40.1620.60-FF-000014', NULL, NULL, 82, NULL, NULL, 155429),
(155430, '1.20.58.60-FF-000406', NULL, 'Related to alpha-actinin', 107, NULL, NULL, 155430),
(155431, '3.40.50.150-FF-001089', NULL, NULL, 217, NULL, NULL, 155431),
(155432, '3.30.200.20-FF-000327', NULL, 'Cysteine-rich receptor-like protein kinase 10', 112, NULL, NULL, 155432),
(155433, '2.60.40.10-FF-005731', NULL, NULL, 113, NULL, NULL, 155433),
(155434, '3.40.50.11500-FF-000035', NULL, NULL, 126, NULL, NULL, 155434),
(155435, '1.20.1730.10-FF-000019', NULL, 'Solute carrier family 5 member 10', 381, NULL, NULL, 155435),
(155436, '3.40.140.10-FF-000126', NULL, '26S proteasome non-ATPase regulatory subunit 7', 182, NULL, NULL, 155436),
(155437, '3.10.490.10-FF-000029', NULL, 'Gamma-glutamylcyclotransferase', 173, NULL, NULL, 155437),
(155438, '3.30.40.10-FF-002043', NULL, 'PHd Finger family', 95, NULL, NULL, 155438),
(155439, '3.30.160.60-FF-000959', NULL, 'zinc finger protein 449', 29, NULL, NULL, 155439),
(155440, '2.20.100.10-FF-000093', NULL, 'SCO-spondin-like isoform 1', 60, NULL, NULL, 155440),
(155441, '2.60.40.10-FF-000515', NULL, 'Leptin receptor', 84, NULL, NULL, 155441),
(155442, '1.25.10.10-FF-001968', NULL, 'Rapamycin-insensitive companion of mTOR, N-term-domain-containing protein', 203, NULL, NULL, 155442);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(155443, '3.40.50.10190-FF-000142', NULL, 'BRCT domain-containing protein', 93, NULL, NULL, 155443),
(155444, '3.30.1120.10-FF-000065', NULL, 'Uncharacterized protein', 28, NULL, NULL, 155444),
(155445, '1.25.40.20-FF-000276', NULL, 'Asparaginase', 100, NULL, NULL, 155445),
(155446, '2.70.160.11-FF-000070', NULL, 'Uncharacterized protein', 158, NULL, NULL, 155446),
(155447, '2.60.120.260-FF-000206', NULL, 'Netrin-B, isoform G', 55, NULL, NULL, 155447),
(155448, '1.20.58.390-FF-000020', NULL, '5-hydroxytryptamine (serotonin) receptor 3A', 122, NULL, NULL, 155448),
(155449, '2.10.25.10-FF-001073', NULL, 'AGAP008185-PA', 26, NULL, NULL, 155449),
(155450, '3.30.2330.10-FF-000002', NULL, 'Arginine biosynthesis bifunctional protein ArgJ', 79, NULL, NULL, 155450),
(155451, '3.90.1720.10-FF-000001', NULL, 'Bifunctional murein DD-endopeptidase/murein LD-carboxypeptidase', 127, NULL, NULL, 155451),
(155452, '3.40.630.10-FF-000085', NULL, 'Gly-Xaa carboxypeptidase', 208, NULL, NULL, 155452),
(155453, '4.10.60.10-FF-000132', NULL, 'Uncharacterized protein', 27, NULL, NULL, 155453),
(155454, '1.10.630.10-FF-000785', NULL, 'Uncharacterized protein', 118, NULL, NULL, 155454),
(155455, '3.40.1110.10-FF-000399', NULL, NULL, 88, NULL, NULL, 155455),
(155456, '2.130.10.10-FF-004534', NULL, 'Uncharacterized protein', 226, NULL, NULL, 155456),
(155457, '1.10.510.10-FF-001243', NULL, 'Protein CBG14903', 343, NULL, NULL, 155457),
(155458, '2.30.39.10-FF-000114', NULL, 'Male accessory gland protein', 116, NULL, NULL, 155458),
(155459, '2.60.40.4070-FF-000012', NULL, 'Basal-body rod modification protein FlgD', 88, NULL, NULL, 155459),
(155460, '1.20.58.390-FF-000138', NULL, 'Predicted protein', 103, NULL, NULL, 155460),
(155461, '3.90.1410.10-FF-000135', NULL, 'Uncharacterized protein', 265, NULL, NULL, 155461),
(155462, '2.60.40.60-FF-000272', NULL, 'DE cadherin-like protein', 109, NULL, NULL, 155462),
(155463, '1.20.58.60-FF-000395', NULL, 'Utrophin', 135, NULL, NULL, 155463),
(155464, '1.25.10.10-FF-003418', NULL, 'Uncharacterized protein', 327, NULL, NULL, 155464),
(155465, '3.40.50.1820-FF-001229', NULL, 'Uncharacterized protein', 345, NULL, NULL, 155465),
(155466, '3.30.430.20-FF-000047', NULL, 'Os01g0366300 protein', 107, NULL, NULL, 155466),
(155467, '3.40.50.1480-FF-000020', NULL, 'Adenosylhomocysteinase', 147, NULL, NULL, 155467),
(155468, '2.10.25.10-FF-000561', NULL, 'Wing blister, isoform B', 54, NULL, NULL, 155468),
(155469, '1.10.555.10-FF-000132', NULL, 'Inositol polyphosphate-5-phosphatase B', 135, NULL, NULL, 155469),
(155470, '3.30.40.10-FF-002280', NULL, 'Lysine-specific demethylase rbr-2', 48, NULL, NULL, 155470),
(155471, '1.10.300.10-FF-000013', NULL, 'Adenylosuccinate synthetase', 99, NULL, NULL, 155471),
(155472, '2.40.50.140-FF-000117', NULL, 'Replication protein A subunit', 116, NULL, NULL, 155472),
(155473, '3.30.420.40-FF-000092', NULL, 'Phosphotransferase', 134, NULL, NULL, 155473),
(155474, '1.10.220.160-FF-000026', NULL, NULL, 102, NULL, NULL, 155474),
(155475, '2.30.30.490-FF-000035', NULL, 'BAH and TFIIS domain-containing protein', 227, NULL, NULL, 155475),
(155476, '2.60.40.650-FF-000005', NULL, 'Sulfite oxidase, putative', 122, NULL, NULL, 155476),
(155477, '3.90.70.10-FF-000575', NULL, 'Uncharacterized protein', 396, NULL, NULL, 155477),
(155478, '2.60.40.1910-FF-000049', NULL, NULL, 63, NULL, NULL, 155478),
(155479, '1.20.58.900-FF-000016', NULL, 'Small G protein signaling modulator 3', 221, NULL, NULL, 155479),
(155480, '3.40.50.150-FF-001196', NULL, NULL, 64, NULL, NULL, 155480),
(155481, '2.130.10.10-FF-000263', NULL, 'cytoplasmic dynein 1 intermediate chain 2 isoform X2', 200, NULL, NULL, 155481),
(155482, '3.30.70.330-FF-002717', NULL, NULL, 149, NULL, NULL, 155482),
(155483, '3.20.20.100-FF-000090', NULL, 'Aldehyde reductase protein', 337, NULL, NULL, 155483),
(155484, '1.10.10.10-FF-002064', NULL, 'ATP-dependent DNA helicase', 84, NULL, NULL, 155484),
(155485, '4.10.260.10-FF-000003', NULL, 'G-protein complex gamma subunit Ste18/GpgA', 76, NULL, NULL, 155485),
(155486, '3.40.50.300-FF-006390', NULL, 'Ras-related protein RabK2', 135, NULL, NULL, 155486);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(155487, '1.10.10.10-FF-001552', NULL, 'Adenosine deaminase, RNA-specific', 76, NULL, NULL, 155487),
(155488, '2.40.100.10-FF-000116', NULL, 'Protein CBG27914', 172, NULL, NULL, 155488),
(155489, '2.60.120.200-FF-000672', NULL, 'Uncharacterized protein', 58, NULL, NULL, 155489),
(155490, '3.40.50.880-FF-000228', NULL, 'Carbamoyl-phosphate synthase small chain', 214, NULL, NULL, 155490),
(155491, '1.10.132.30-FF-000010', NULL, 'DNA-directed RNA polymerase subunit', 133, NULL, NULL, 155491),
(155492, '3.30.70.330-FF-002936', NULL, NULL, 117, NULL, NULL, 155492),
(155493, '2.60.40.10-FF-001460', NULL, 'Receptor protein-tyrosine phosphatase 10d', 72, NULL, NULL, 155493),
(155494, '3.20.20.330-FF-000023', NULL, 'Methionine synthase', 338, NULL, NULL, 155494),
(155495, '3.90.1720.30-FF-000007', NULL, NULL, 174, NULL, NULL, 155495),
(155496, '3.40.50.300-FF-000662', NULL, 'Pachytene checkpoint protein 2 homolog', 226, NULL, NULL, 155496),
(155497, '1.10.10.60-FF-000252', NULL, 'Retinal homeobox protein Rx-B', 63, NULL, NULL, 155497),
(155498, '3.90.640.80-FF-000005', NULL, 'Poly [ADP-ribose] polymerase', 124, NULL, NULL, 155498),
(155499, '1.10.8.1290-FF-000004', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 116, NULL, NULL, 155499),
(155500, '2.40.50.140-FF-001062', NULL, NULL, 101, NULL, NULL, 155500),
(155501, '1.25.40.10-FF-002408', NULL, 'CBN-SEL-1 protein', 134, NULL, NULL, 155501),
(155502, '3.30.740.10-FF-000022', NULL, NULL, 83, NULL, NULL, 155502),
(155503, '1.10.510.10-FF-002985', NULL, 'Uncharacterized protein', 256, NULL, NULL, 155503),
(155504, '3.30.497.10-FF-000074', NULL, 'Angiotensinogen', 206, NULL, NULL, 155504),
(155505, '1.25.40.20-FF-001214', NULL, 'Uncharacterized protein', 160, NULL, NULL, 155505),
(155506, '2.60.120.920-FF-000096', NULL, 'Si:dkey-31n13.4', 79, NULL, NULL, 155506),
(155507, '3.40.720.10-FF-000204', NULL, 'GM26188', 311, NULL, NULL, 155507),
(155508, '3.10.20.90-FF-000953', NULL, 'Uncharacterized protein', 64, NULL, NULL, 155508),
(155509, '1.20.1290.10-FF-000002', NULL, '4-carboxymuconolactone decarboxylase', 121, NULL, NULL, 155509),
(155510, '3.30.420.40-FF-000777', NULL, 'Hydantoinase, putative', 88, NULL, NULL, 155510),
(155511, '3.60.20.10-FF-000219', NULL, NULL, 141, NULL, NULL, 155511),
(155512, '4.10.1000.10-FF-000032', NULL, 'Zinc finger CCCH-type containing 7A', 28, NULL, NULL, 155512),
(155513, '3.40.50.720-FF-000119', NULL, '3-hydroxyisobutyrate dehydrogenase', 167, NULL, NULL, 155513),
(155514, '3.10.350.10-FF-000087', NULL, 'Lytic transglycosylase, SLT, LysM and LysM domain-containing', 51, NULL, NULL, 155514),
(155515, '3.30.505.10-FF-000246', NULL, NULL, 59, NULL, NULL, 155515),
(155516, '3.30.830.10-FF-000136', NULL, 'Putative mitochondrial-processing peptidase subunit beta, mitochondrial', 195, NULL, NULL, 155516),
(155517, '2.10.25.10-FF-000342', NULL, 'Betacellulin preproprotein', 50, NULL, NULL, 155517),
(155518, '1.10.220.10-FF-000068', NULL, 'Annexin', 46, NULL, NULL, 155518),
(155519, '2.60.120.260-FF-000083', NULL, 'Cyclic di-GMP-binding protein', 129, NULL, NULL, 155519),
(155520, '2.60.120.10-FF-000467', NULL, 'Cysteine dioxygenase', 201, NULL, NULL, 155520),
(155521, '1.10.1580.10-FF-000032', NULL, 'Mitochondrial GTPase 1', 50, NULL, NULL, 155521),
(155522, '3.20.20.70-FF-000773', NULL, NULL, 100, NULL, NULL, 155522),
(155523, '2.30.29.30-FF-001356', NULL, 'Uncharacterized protein', 133, NULL, NULL, 155523),
(155524, '3.40.50.2000-FF-000215', NULL, 'Polysaccharide pyruvyl transferase', 134, NULL, NULL, 155524),
(155525, '3.30.160.60-FF-004219', NULL, NULL, 32, NULL, NULL, 155525),
(155526, '3.30.1490.80-FF-000028', NULL, 'Glutathione synthetase', 52, NULL, NULL, 155526),
(155527, '1.20.1070.10-FF-001289', NULL, 'Predicted protein', 169, NULL, NULL, 155527),
(155528, '1.10.1450.10-FF-000152', NULL, 'Tetraspanin', 86, NULL, NULL, 155528),
(155529, '3.40.50.150-FF-000577', NULL, 'Protein-lysine N-methyltransferase EHI_110190', 191, NULL, NULL, 155529),
(155530, '1.25.40.10-FF-000492', NULL, 'Tetratricopeptide repeat domain 21B', 196, NULL, NULL, 155530);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(155531, '1.20.5.270-FF-000007', NULL, 'Cytochrome b-c1 complex subunit Rieske, mitochondrial', 37, NULL, NULL, 155531),
(155532, '3.90.950.10-FF-000019', NULL, 'Inosine triphosphate pyrophosphatase', 190, NULL, NULL, 155532),
(155533, '3.40.50.300-FF-008306', NULL, 'Dynein heavy chain, cytoplasmic', 337, NULL, NULL, 155533),
(155534, '3.30.160.60-FF-002398', NULL, 'Zinc finger and SCAN domain-containing protein 2', 29, NULL, NULL, 155534),
(155535, '3.30.70.370-FF-000003', NULL, 'DNA polymerase I A, chloroplastic/mitochondrial', 121, NULL, NULL, 155535),
(155536, '3.40.190.10-FF-000753', NULL, 'Hydroxymethylbilane synthase (Porphobilinogen deaminase)', 95, NULL, NULL, 155536),
(155537, '1.10.15.30-FF-000001', NULL, '60S ribosomal protein L7', 63, NULL, NULL, 155537),
(155538, '3.40.50.1010-FF-000020', NULL, '20S-pre-rRNA D-site endonuclease NOB1', 121, NULL, NULL, 155538),
(155539, '3.30.60.20-FF-000024', NULL, 'Protein kinase C epsilon', 82, NULL, NULL, 155539),
(155540, '3.80.10.10-FF-003085', NULL, 'F-box protein SKIP14', 124, NULL, NULL, 155540),
(155541, '3.30.160.60-FF-003022', NULL, 'Transcription factor Sp7 isoform B', 28, NULL, NULL, 155541),
(155542, '2.130.10.10-FF-002494', NULL, 'YALI0D19778p', 157, NULL, NULL, 155542),
(155543, '3.30.760.10-FF-000035', NULL, 'Eukaryotic translation initiation factor 4E, putative', 172, NULL, NULL, 155543),
(155544, '1.25.40.990-FF-000073', NULL, 'Uncharacterized protein', 91, NULL, NULL, 155544),
(155545, '1.25.10.10-FF-002587', NULL, 'Uncharacterized protein', 156, NULL, NULL, 155545),
(155546, '1.10.510.10-FF-000843', NULL, 'Serine/threonine-protein kinase PLK', 184, NULL, NULL, 155546),
(155547, '3.90.660.10-FF-000137', NULL, NULL, 191, NULL, NULL, 155547),
(155548, '1.20.1510.10-FF-000025', NULL, 'Zinc transporter 35C, isoform B', 101, NULL, NULL, 155548),
(155549, '3.20.20.80-FF-000427', NULL, 'Uncharacterized protein', 195, NULL, NULL, 155549),
(155550, '3.20.20.80-FF-000091', NULL, 'Class V chitinase CHIT5', 246, NULL, NULL, 155550),
(155551, '2.60.40.10-FF-004663', NULL, NULL, 101, NULL, NULL, 155551),
(155552, '3.30.160.60-FF-001460', NULL, 'Uncharacterized protein', 28, NULL, NULL, 155552),
(155553, '3.40.50.10190-FF-000030', NULL, 'Poly [ADP-ribose] polymerase', 112, NULL, NULL, 155553),
(155554, '1.10.274.10-FF-000001', NULL, 'Phosphoenolpyruvate-protein phosphotransferase', 126, NULL, NULL, 155554),
(155555, '3.40.50.300-FF-001623', NULL, 'Adenylate cyclase type 10', 221, NULL, NULL, 155555),
(155556, '3.80.10.10-FF-002573', NULL, 'Leucine rich repeats and guanylate kinase domain containing', 118, NULL, NULL, 155556),
(155557, '2.60.200.20-FF-000061', NULL, 'Zgc:165656 protein', 98, NULL, NULL, 155557),
(155558, '1.10.510.10-FF-002529', NULL, 'Probable serine/threonine-protein kinase pknH', 323, NULL, NULL, 155558),
(155559, '2.130.10.10-FF-000948', NULL, 'Pre-mRNA-processing factor 19', 215, NULL, NULL, 155559),
(155560, '2.60.98.20-FF-000005', NULL, 'Flagellar hook protein FlgE', 195, NULL, NULL, 155560),
(155561, '1.20.1050.10-FF-000237', NULL, 'Uncharacterized protein', 77, NULL, NULL, 155561),
(155562, '1.10.10.160-FF-000036', NULL, 'DNA helicase', 77, NULL, NULL, 155562),
(155563, '1.20.1250.20-FF-000204', NULL, 'Peptide transporter PTR2', 519, NULL, NULL, 155563),
(155564, '2.60.40.10-FF-000392', NULL, 'CLUMA_CG000981, isoform A', 109, NULL, NULL, 155564),
(155565, '3.30.460.10-FF-000102', NULL, 'DNA polymerase', 124, NULL, NULL, 155565),
(155566, '3.20.20.140-FF-000180', NULL, 'YJL213W-like protein', 284, NULL, NULL, 155566),
(155567, '2.130.10.10-FF-001224', NULL, 'Protein CBR-SMU-1', 299, NULL, NULL, 155567),
(155568, '2.60.120.260-FF-000190', NULL, 'Odd Oz/ten-m (Odz2), mRNA protein', 63, NULL, NULL, 155568),
(155569, '3.40.50.300-FF-008295', NULL, 'Uncharacterized protein', 28, NULL, NULL, 155569),
(155570, '1.10.287.70-FF-000313', NULL, 'Small conductance calcium-activated potassium channel-like protein 3', 235, NULL, NULL, 155570),
(155571, '3.40.50.300-FF-005889', NULL, 'CHL1 helicase, putative', 71, NULL, NULL, 155571);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(155572, '3.40.50.720-FF-001176', NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 9, mitochondrial', 213, NULL, NULL, 155572),
(155573, '3.40.50.10490-FF-000013', NULL, 'Phosphoheptose isomerase', 192, NULL, NULL, 155573),
(155574, '1.25.40.10-FF-000503', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 149, NULL, NULL, 155574),
(155575, '3.40.50.300-FF-006513', NULL, 'Uncharacterized protein', 112, NULL, NULL, 155575),
(155576, '1.10.246.190-FF-000003', NULL, 'Autophagy protein 5', 69, NULL, NULL, 155576),
(155577, '3.30.900.10-FF-000024', NULL, 'Autophagy-related protein 13', 302, NULL, NULL, 155577),
(155578, '1.50.10.10-FF-000027', NULL, 'Probable mannosyl-oligosaccharide glucosidase', 475, NULL, NULL, 155578),
(155579, '2.40.50.40-FF-000054', NULL, 'Chromo-domain protein', 69, NULL, NULL, 155579),
(155580, '1.25.40.10-FF-002285', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 112, NULL, NULL, 155580),
(155581, '1.20.920.20-FF-000044', NULL, 'Uncharacterized protein', 260, NULL, NULL, 155581),
(155582, '2.130.10.10-FF-005838', NULL, 'Uncharacterized protein', 363, NULL, NULL, 155582),
(155583, '3.30.160.60-FF-005731', NULL, NULL, 31, NULL, NULL, 155583),
(155584, '1.10.8.60-FF-000161', NULL, 'Putative AAA family ATPase SEC18', 72, NULL, NULL, 155584),
(155585, '1.10.357.140-FF-000031', NULL, 'Probable protoheme IX farnesyltransferase, mitochondrial', 173, NULL, NULL, 155585),
(155586, '3.30.710.10-FF-000431', NULL, 'Uncharacterized protein', 75, NULL, NULL, 155586),
(155587, '2.20.70.10-FF-000221', NULL, 'Putative mitochondrial protein', 40, NULL, NULL, 155587),
(155588, '2.60.40.150-FF-000636', NULL, 'Uncharacterized protein', 133, NULL, NULL, 155588),
(155589, '3.40.50.1440-FF-000143', NULL, 'Tubulin/FtsZ family, GTPase domain containing protein', 378, NULL, NULL, 155589),
(155590, '3.10.20.90-FF-000734', NULL, 'Serine threonine protein kinase raf1', 57, NULL, NULL, 155590),
(155591, '1.10.8.10-FF-000062', NULL, 'NEDD8 ultimate buster 1 isoform X2', 44, NULL, NULL, 155591),
(155592, '3.30.160.60-FF-000167', NULL, 'Zinc finger protein 521', 59, NULL, NULL, 155592),
(155593, '3.40.350.10-FF-000052', NULL, 'X-Pro aminopeptidase, putative', 153, NULL, NULL, 155593),
(155594, '1.10.2020.20-FF-000010', NULL, NULL, 114, NULL, NULL, 155594),
(155595, '3.40.50.300-FF-001281', NULL, 'Dynamin-like protein ARC5', 369, NULL, NULL, 155595),
(155596, '1.10.274.30-FF-000007', NULL, 'Male-specific lethal 3', 210, NULL, NULL, 155596),
(155597, '3.40.50.300-FF-008188', NULL, 'Uncharacterized protein', 79, NULL, NULL, 155597),
(155598, '1.10.510.10-FF-003474', NULL, NULL, 269, NULL, NULL, 155598),
(155599, '3.90.180.10-FF-000106', NULL, 'Quinone oxidoreductase', 172, NULL, NULL, 155599),
(155600, '3.10.20.90-FF-001010', NULL, 'Uncharacterized protein', 101, NULL, NULL, 155600),
(155601, '2.130.10.10-FF-004990', NULL, 'Uncharacterized protein', 75, NULL, NULL, 155601),
(155602, '3.40.140.10-FF-000019', NULL, 'Eukaryotic translation initiation factor 3 subunit F', 188, NULL, NULL, 155602),
(155603, '3.30.450.20-FF-000161', NULL, 'Cyclic-di-AMP phosphodiesterase', 106, NULL, NULL, 155603),
(155604, '3.20.20.140-FF-000073', NULL, 'Parathion hydrolase', 333, NULL, NULL, 155604),
(155605, '3.10.100.10-FF-000372', NULL, NULL, 141, NULL, NULL, 155605),
(155606, '1.10.238.10-FF-000468', NULL, 'Dual oxidase 2', 152, NULL, NULL, 155606),
(155607, '1.25.50.20-FF-000102', NULL, 'Uncharacterized protein', 127, NULL, NULL, 155607),
(155608, '3.90.550.50-FF-000124', NULL, 'UDP-galactose:N-acetylgalactosamine-alpha-R beta 1,3-galactosyltransferase', 198, NULL, NULL, 155608),
(155609, '3.40.190.290-FF-000014', NULL, 'LysR family transcriptional regulator', 201, NULL, NULL, 155609),
(155610, '3.20.20.210-FF-000004', NULL, 'Uroporphyrinogen decarboxylase', 360, NULL, NULL, 155610),
(155611, '1.25.10.10-FF-002457', NULL, 'Uncharacterized protein', 224, NULL, NULL, 155611),
(155612, '1.20.120.1490-FF-000002', NULL, 'ATP-independent periplasmic protein-refolding chaperone', 111, NULL, NULL, 155612);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(155613, '3.40.50.300-FF-003416', NULL, 'Dynein heavy chain', 135, NULL, NULL, 155613),
(155614, '2.60.40.10-FF-005282', NULL, NULL, 83, NULL, NULL, 155614),
(155615, '3.40.1030.10-FF-000016', NULL, 'Thymidine phosphorylase', 205, NULL, NULL, 155615),
(155616, '1.10.600.10-FF-000053', NULL, 'Squalene synthase', 340, NULL, NULL, 155616),
(155617, '3.90.1140.10-FF-000030', NULL, 'A-kinase-anchoring protein 7', 210, NULL, NULL, 155617),
(155618, '3.10.50.40-FF-000120', NULL, 'Peptidylprolyl isomerase', 113, NULL, NULL, 155618),
(155619, '3.40.1090.10-FF-000121', NULL, 'Patatin', 211, NULL, NULL, 155619),
(155620, '3.60.40.10-FF-000114', NULL, 'PP2C-family Ser/Thr phosphatase', 239, NULL, NULL, 155620),
(155621, '3.10.290.10-FF-000048', NULL, 'Tyrosine--tRNA ligase', 93, NULL, NULL, 155621),
(155622, '2.60.220.50-FF-000161', NULL, 'Uncharacterized protein', 162, NULL, NULL, 155622),
(155623, '3.30.450.20-FF-000503', NULL, 'Histidine kinase', 156, NULL, NULL, 155623),
(155624, '3.40.50.620-FF-000297', NULL, 'Universal stress protein MT2087', 133, NULL, NULL, 155624),
(155625, '2.30.30.40-FF-000244', NULL, 'Peptidase, M23/M37 family', 53, NULL, NULL, 155625),
(155626, '1.10.10.2750-FF-000004', NULL, NULL, 76, NULL, NULL, 155626),
(155627, '3.80.10.10-FF-001628', NULL, 'Receptor like protein 41', 101, NULL, NULL, 155627),
(155628, '3.40.1370.10-FF-000047', NULL, 'Uncharacterized protein', 90, NULL, NULL, 155628),
(155629, '1.20.1640.10-FF-000029', NULL, 'Putative Patched sphingolipid transporter', 202, NULL, NULL, 155629),
(155630, '3.60.10.10-FF-000157', NULL, 'Pantothenate kinase subunit, putative', 317, NULL, NULL, 155630),
(155631, '3.40.630.30-FF-000080', NULL, 'Siderophore biosynthesis acetylase AceI, putative', 205, NULL, NULL, 155631),
(155632, '1.10.418.10-FF-000229', NULL, 'Uncharacterized protein', 100, NULL, NULL, 155632),
(155633, '3.30.720.210-FF-000019', NULL, 'ATP-dependent zinc metalloprotease FtsH', 76, NULL, NULL, 155633),
(155634, '1.10.150.620-FF-000001', NULL, 'Structural polyprotein', 79, NULL, NULL, 155634),
(155635, '1.10.150.240-FF-000090', NULL, 'Phosphoglycolate phosphatase', 72, NULL, NULL, 155635),
(155636, '1.10.220.10-FF-000063', NULL, 'Uncharacterized protein', 71, NULL, NULL, 155636),
(155637, '3.90.1520.10-FF-000020', NULL, 'Uncharacterized protein', 191, NULL, NULL, 155637),
(155638, '1.10.10.60-FF-001213', NULL, NULL, 80, NULL, NULL, 155638),
(155639, '3.40.50.300-FF-004933', NULL, 'Uncharacterized protein', 210, NULL, NULL, 155639),
(155640, '3.30.1780.10-FF-000024', NULL, 'Uncharacterized protein', 93, NULL, NULL, 155640),
(155641, '1.10.630.10-FF-000223', NULL, 'Sporulation-specific N-formyltyrosine oxidase Dit2, putative', 474, NULL, NULL, 155641),
(155642, '3.30.1060.10-FF-000003', NULL, 'Peptide methionine sulfoxide reductase MsrA', 167, NULL, NULL, 155642),
(155643, '2.10.110.10-FF-000073', NULL, 'Uncharacterized protein, isoform Z', 59, NULL, NULL, 155643),
(155644, '1.10.10.60-FF-000589', NULL, 'AEL176Cp', 71, NULL, NULL, 155644),
(155645, '3.30.200.20-FF-002244', NULL, NULL, 30, NULL, NULL, 155645),
(155646, '2.130.10.10-FF-003017', NULL, 'U3 small nucleolar RNA-associated protein 15 homolog', 171, NULL, NULL, 155646),
(155647, '3.40.1170.60-FF-000041', NULL, NULL, 28, NULL, NULL, 155647),
(155648, '1.10.287.1130-FF-000014', NULL, 'Cytochrome c oxidase copper chaperone', 56, NULL, NULL, 155648),
(155649, '3.30.40.10-FF-000126', NULL, 'metal-response element-binding transcription factor 2 isoform X1', 64, NULL, NULL, 155649),
(155650, '3.30.450.40-FF-000149', NULL, 'IclR family transcriptional regulator', 71, NULL, NULL, 155650),
(155651, '2.40.160.120-FF-000059', NULL, 'Uncharacterized protein', 79, NULL, NULL, 155651),
(155652, '3.40.50.1010-FF-000132', NULL, 'Flap endonuclease Xni', 162, NULL, NULL, 155652),
(155653, '1.20.1080.10-FF-000065', NULL, 'Uncharacterized protein', 190, NULL, NULL, 155653),
(155654, '2.60.40.10-FF-005624', NULL, NULL, 98, NULL, NULL, 155654),
(155655, '2.60.40.10-FF-001004', NULL, 'Usherin', 99, NULL, NULL, 155655),
(155656, '1.20.190.50-FF-000018', NULL, 'Nuclear pore complex protein', 270, NULL, NULL, 155656);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(155657, '2.10.25.10-FF-000347', NULL, 'delta-like protein 3', 41, NULL, NULL, 155657),
(155658, '3.30.160.60-FF-005276', NULL, NULL, 65, NULL, NULL, 155658),
(155659, '2.80.10.50-FF-000266', NULL, 'Predicted protein', 119, NULL, NULL, 155659),
(155660, '2.40.10.10-FF-000172', NULL, 'Prostate-specific antigen', 82, NULL, NULL, 155660),
(155661, '1.20.1270.280-FF-000049', NULL, 'Dynein heavy chain 6, axonemal', 201, NULL, NULL, 155661),
(155662, '1.10.238.10-FF-001087', NULL, 'Uncharacterized protein', 83, NULL, NULL, 155662),
(155663, '1.10.400.10-FF-000054', NULL, 'Os05g0341300 protein', 40, NULL, NULL, 155663),
(155664, '3.90.650.10-FF-000075', NULL, 'Uncharacterized protein', 123, NULL, NULL, 155664),
(155665, '1.20.120.910-FF-000007', NULL, 'Zinc finger transcriptional regulator, TraR/DksA family', 122, NULL, NULL, 155665),
(155666, '2.40.10.10-FF-000514', NULL, NULL, 59, NULL, NULL, 155666),
(155667, '1.10.10.10-FF-000147', NULL, 'Fur family transcriptional regulator', 87, NULL, NULL, 155667),
(155668, '1.25.40.20-FF-000832', NULL, 'Death-associated protein kinase 1', 388, NULL, NULL, 155668),
(155669, '3.40.140.10-FF-000238', NULL, 'Uncharacterized protein', 162, NULL, NULL, 155669),
(155670, '1.25.50.20-FF-000097', NULL, 'Uncharacterized protein', 224, NULL, NULL, 155670),
(155671, '1.25.10.10-FF-000664', NULL, 'Pta1p', 328, NULL, NULL, 155671),
(155672, '3.80.10.10-FF-004153', NULL, 'Uncharacterized protein', 104, NULL, NULL, 155672),
(155673, '1.10.760.10-FF-000098', NULL, 'Uvrd / recb / pcra DNA helicase, putative', 65, NULL, NULL, 155673),
(155674, '3.30.70.330-FF-000582', NULL, 'RNA-binding protein, putative', 95, NULL, NULL, 155674),
(155675, '1.10.287.470-FF-000034', NULL, 'Nodulation protein nolF', 60, NULL, NULL, 155675),
(155676, '1.20.120.720-FF-000057', NULL, 'Extraocular myosin heavy chain EO-MYHC', 25, NULL, NULL, 155676),
(155677, '1.20.1740.10-FF-000200', NULL, 'Solute carrier family 7 (Cationic amino acid transporter, y+ system), member 12, isoform CRA_b', 172, NULL, NULL, 155677),
(155678, '1.20.120.1240-FF-000068', NULL, 'Uncharacterized protein', 230, NULL, NULL, 155678),
(155679, '3.80.10.10-FF-003753', NULL, 'Predicted protein', 123, NULL, NULL, 155679),
(155680, '2.130.10.10-FF-003910', NULL, 'Uncharacterized protein', 266, NULL, NULL, 155680),
(155681, '3.40.50.150-FF-001084', NULL, NULL, 232, NULL, NULL, 155681),
(155682, '1.10.15.30-FF-000006', NULL, '50S ribosomal protein L30', 55, NULL, NULL, 155682),
(155683, '2.120.10.30-FF-000230', NULL, 'Haloacid dehalogenase-like hydrolase family', 74, NULL, NULL, 155683),
(155684, '3.40.50.11860-FF-000002', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', 99, NULL, NULL, 155684),
(155685, '3.30.70.330-FF-000452', NULL, 'Multiple RNA-binding domain-containing protein 1', 115, NULL, NULL, 155685),
(155686, '2.40.50.140-FF-000680', NULL, NULL, 84, NULL, NULL, 155686),
(155687, '2.30.42.10-FF-000133', NULL, 'PDZ domain containing ring finger 4', 104, NULL, NULL, 155687),
(155688, '1.20.1540.10-FF-000089', NULL, 'Os02g0326700 protein', 124, NULL, NULL, 155688),
(155689, '3.30.530.20-FF-000195', NULL, 'Uncharacterized protein', 255, NULL, NULL, 155689),
(155690, '2.60.40.10-FF-000953', NULL, 'Collagen, type XX, alpha 1', 93, NULL, NULL, 155690),
(155691, '2.60.40.10-FF-002308', NULL, 'Stretchin-Mlck, isoform T', 89, NULL, NULL, 155691),
(155692, '1.20.1070.10-FF-000800', NULL, 'Vomeronasal type-1 receptor', 295, NULL, NULL, 155692),
(155693, '3.80.10.10-FF-004501', NULL, 'Os03g0773700 protein', 214, NULL, NULL, 155693),
(155694, '1.10.10.60-FF-000937', NULL, NULL, 58, NULL, NULL, 155694),
(155695, '1.20.1310.10-FF-000151', NULL, NULL, 146, NULL, NULL, 155695),
(155696, '2.60.40.1730-FF-000102', NULL, NULL, 65, NULL, NULL, 155696),
(155697, '3.40.50.150-FF-000684', NULL, 'Nodulation protein', 195, NULL, NULL, 155697),
(155698, '3.40.800.20-FF-000034', NULL, 'Histone deacetylase 19', 118, NULL, NULL, 155698),
(155699, '3.40.50.2300-FF-000098', NULL, 'Two-component response regulator', 118, NULL, NULL, 155699);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(155700, '3.60.60.10-FF-000003', NULL, 'N-acylethanolamine-hydrolyzing acid amidase', 235, NULL, NULL, 155700),
(155701, '3.40.50.80-FF-000092', NULL, 'Similar to gi|11359636|pir||T49761 related to ferric reductase', 148, NULL, NULL, 155701),
(155702, '2.70.70.10-FF-000016', NULL, 'Peptidase, M23 family', 141, NULL, NULL, 155702),
(155703, '3.80.10.10-FF-003877', NULL, 'Uncharacterized protein', 333, NULL, NULL, 155703),
(155704, '1.10.10.10-FF-001440', NULL, 'Iron-dependent repressor IdeR/DtxR', 70, NULL, NULL, 155704),
(155705, '3.90.190.10-FF-000051', NULL, 'Dual specificity phosphatase domain protein', 148, NULL, NULL, 155705),
(155706, '2.40.30.10-FF-000055', NULL, 'Siderophore-interacting family protein', 129, NULL, NULL, 155706),
(155707, '3.30.70.3490-FF-000030', NULL, 'Oxysterol-binding protein', 90, NULL, NULL, 155707),
(155708, '1.25.40.90-FF-000021', NULL, 'Cytoskeleton assembly control protein Sla2', 133, NULL, NULL, 155708),
(155709, '3.30.342.10-FF-000002', NULL, 'DNA polymerase zeta catalytic subunit isoform X1', 166, NULL, NULL, 155709),
(155710, '1.10.8.1220-FF-000017', NULL, 'Putative dynein heavy chain, cytosolic', 94, NULL, NULL, 155710),
(155711, '3.40.50.620-FF-000415', NULL, 'Leucine--tRNA ligase', 185, NULL, NULL, 155711),
(155712, '1.10.510.10-FF-002636', NULL, 'Uncharacterized protein', 331, NULL, NULL, 155712),
(155713, '3.40.50.300-FF-001842', NULL, 'Pre-mRNA-splicing helicase BRR2, putative', 194, NULL, NULL, 155713),
(155714, '3.30.160.60-FF-002853', NULL, 'zinc finger protein 707 isoform X1', 31, NULL, NULL, 155714),
(155715, '3.30.300.10-FF-000057', NULL, 'Uncharacterized protein', 60, NULL, NULL, 155715),
(155716, '3.30.70.330-FF-001071', NULL, 'Tar DNA-binding protein homolog 1', 122, NULL, NULL, 155716),
(155717, '3.50.50.60-FF-000686', NULL, 'Uncharacterized protein', 128, NULL, NULL, 155717),
(155718, '1.25.10.10-FF-001283', NULL, 'V-type proton ATPase subunit H', 344, NULL, NULL, 155718),
(155719, '1.20.1250.20-FF-002121', NULL, 'Uncharacterized protein', 218, NULL, NULL, 155719),
(155720, '3.40.50.720-FF-002007', NULL, 'Dehydrogenase', 223, NULL, NULL, 155720),
(155721, '1.25.40.10-FF-000610', NULL, 'Pentatricopeptide repeat protein', 205, NULL, NULL, 155721),
(155722, '3.90.1150.10-FF-000081', NULL, 'serine palmitoyltransferase 1 isoform X1', 121, NULL, NULL, 155722),
(155723, '3.40.30.10-FF-000215', NULL, '39S ribosomal protein L53, mitochondrial', 112, NULL, NULL, 155723),
(155724, '1.10.150.20-FF-000077', NULL, 'DExH-box ATP-dependent RNA helicase DExH17', 48, NULL, NULL, 155724),
(155725, '2.30.29.30-FF-000518', NULL, 'Arf-GAP with ANK repeat and PH domain-containing protein cnt-2', 132, NULL, NULL, 155725),
(155726, '1.25.40.10-FF-001796', NULL, 'Genomes uncoupled1', 119, NULL, NULL, 155726),
(155727, '3.40.50.300-FF-007002', NULL, 'Uncharacterized protein', 209, NULL, NULL, 155727),
(155728, '3.40.50.1400-FF-000030', NULL, 'Sirohydrochlorin cobaltochelatase', 133, NULL, NULL, 155728),
(155729, '1.10.287.110-FF-000179', NULL, 'DNaJ domain (Prokaryotic heat shock protein)', 87, NULL, NULL, 155729),
(155730, '3.90.1600.10-FF-000054', NULL, 'DNA polymerase alpha subunit one', 47, NULL, NULL, 155730),
(155731, '1.10.510.10-FF-004098', NULL, NULL, 133, NULL, NULL, 155731),
(155732, '3.40.850.10-FF-000433', NULL, 'Uncharacterized protein', 150, NULL, NULL, 155732),
(155733, '1.25.40.10-FF-003246', NULL, 'Pentatricopeptide repeat-containing protein', 176, NULL, NULL, 155733),
(155734, '3.40.50.720-FF-000557', NULL, 'Pyrroline-5-carboxylate reductase', 178, NULL, NULL, 155734),
(155735, '1.25.40.180-FF-000049', NULL, 'Eukaryotic translation initation factor 4 gamma, putative', 234, NULL, NULL, 155735),
(155736, '3.40.50.1460-FF-000025', NULL, 'Cell death protein 3', 258, NULL, NULL, 155736),
(155737, '1.20.272.40-FF-000015', NULL, 'SUPV3L1 protein', 40, NULL, NULL, 155737),
(155738, '1.20.1560.10-FF-000652', NULL, 'Uncharacterized protein', 113, NULL, NULL, 155738),
(155739, '3.80.10.10-FF-003192', NULL, 'Uncharacterized protein', 231, NULL, NULL, 155739);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(155740, '3.40.50.300-FF-005552', NULL, 'Oligopeptide transport ATP-binding protein', 266, NULL, NULL, 155740),
(155741, '3.30.40.10-FF-000363', NULL, 'E3 ubiquitin-protein ligase ZNRF2', 60, NULL, NULL, 155741),
(155742, '3.40.50.150-FF-001645', NULL, NULL, 224, NULL, NULL, 155742),
(155743, '2.60.40.150-FF-000417', NULL, 'Phosphoinositide phospholipase C', 187, NULL, NULL, 155743),
(155744, '2.120.10.80-FF-000093', NULL, 'Rab9 effector protein with kelch motifs', 120, NULL, NULL, 155744),
(155745, '2.40.50.140-FF-000005', NULL, 'Cold shock protein CspE', 43, NULL, NULL, 155745),
(155746, '1.20.58.60-FF-000390', NULL, 'Trio, isoform A', 152, NULL, NULL, 155746),
(155747, '3.40.640.10-FF-000147', NULL, 'Aspartate aminotransferase', 242, NULL, NULL, 155747),
(155748, '1.10.1070.11-FF-000056', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', 201, NULL, NULL, 155748),
(155749, '2.40.10.170-FF-000023', NULL, 'ATP synthase subunit beta', 53, NULL, NULL, 155749),
(155750, '2.60.40.150-FF-000075', NULL, 'protein fantom isoform X1', 132, NULL, NULL, 155750),
(155751, '3.40.1280.10-FF-000040', NULL, 'YMR310C-like protein', 171, NULL, NULL, 155751),
(155752, '1.20.1260.10-FF-000051', NULL, 'Ferritin light chain', 104, NULL, NULL, 155752),
(155753, '1.10.1450.10-FF-000045', NULL, 'AGAP013391-PA', 73, NULL, NULL, 155753),
(155754, '3.40.50.150-FF-000139', NULL, 'probable 28S rRNA (Cytosine-C(5))-methyltransferase isoform X2', 221, NULL, NULL, 155754),
(155755, '2.30.30.70-FF-000005', NULL, 'Uncharacterized protein', 97, NULL, NULL, 155755),
(155756, '3.30.200.20-FF-002025', NULL, 'Predicted protein', 92, NULL, NULL, 155756),
(155757, '3.10.110.10-FF-000327', NULL, 'ubiquitin-conjugating enzyme E2 35-like isoform X2', 157, NULL, NULL, 155757),
(155758, '3.60.40.10-FF-000333', NULL, 'Predicted protein', 151, NULL, NULL, 155758),
(155759, '1.10.472.10-FF-000383', NULL, 'D7-type cyclin', 107, NULL, NULL, 155759),
(155760, '1.10.100.10-FF-000014', NULL, 'GD12890', 94, NULL, NULL, 155760),
(155761, '1.10.630.10-FF-000442', NULL, 'Putative cytochrome P450 superfamily protein', 367, NULL, NULL, 155761),
(155762, '1.25.40.10-FF-002757', NULL, 'AGAP003616-PA', 189, NULL, NULL, 155762),
(155763, '1.10.510.10-FF-001799', NULL, 'Kinase-like protein', 256, NULL, NULL, 155763),
(155764, '3.30.420.10-FF-000094', NULL, 'Gag-Pol polyprotein', 201, NULL, NULL, 155764),
(155765, '2.60.120.10-FF-000124', NULL, 'Glycinin G5', 280, NULL, NULL, 155765),
(155766, '1.20.1250.20-FF-000334', NULL, 'Drug resistance transporter, EmrB/QacA family', 194, NULL, NULL, 155766),
(155767, '1.20.1280.50-FF-000266', NULL, 'Uncharacterized protein', 52, NULL, NULL, 155767),
(155768, '2.10.220.10-FF-000194', NULL, 'Uncharacterized protein', 62, NULL, NULL, 155768),
(155769, '1.25.10.10-FF-002244', NULL, 'Nipped-B protein', 376, NULL, NULL, 155769),
(155770, '3.40.50.1820-FF-001673', NULL, 'Putative peptide synthase', 253, NULL, NULL, 155770),
(155771, '1.20.1050.10-FF-000113', NULL, 'Glutathione S-transferase', 140, NULL, NULL, 155771),
(155772, '1.10.510.10-FF-002417', NULL, NULL, 228, NULL, NULL, 155772),
(155773, '3.40.50.360-FF-000073', NULL, 'Protoporphyrinogen oxidase', 112, NULL, NULL, 155773),
(155774, '1.10.287.70-FF-000425', NULL, 'Voltage-gated Ca2+ channel, alpha subunit', 123, NULL, NULL, 155774),
(155775, '3.40.50.300-FF-006619', NULL, 'Uncharacterized protein', 93, NULL, NULL, 155775),
(155776, '2.10.60.10-FF-000024', NULL, 'Cytotoxin 1', 64, NULL, NULL, 155776),
(155777, '3.30.300.20-FF-000043', NULL, 'Uncharacterized GTP-binding protein E02H1.2', 103, NULL, NULL, 155777),
(155778, '1.25.10.10-FF-001732', NULL, 'Related to SLS1 protein', 195, NULL, NULL, 155778),
(155779, '1.10.3720.10-FF-000044', NULL, 'Thiamine/thiamine pyrophosphate ABC transporter permease ThiP', 256, NULL, NULL, 155779),
(155780, '1.20.1420.30-FF-000024', NULL, 'Calcium/proton exchanger, variant', 157, NULL, NULL, 155780),
(155781, '2.60.200.20-FF-000167', NULL, 'Bifunctional polynucleotide phosphatase/kinase', 105, NULL, NULL, 155781);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(155782, '3.40.390.10-FF-000279', NULL, NULL, 119, NULL, NULL, 155782),
(155783, '1.25.40.20-FF-000040', NULL, 'RBR-type E3 ubiquitin transferase', 202, NULL, NULL, 155783),
(155784, '3.40.720.10-FF-000081', NULL, 'Protein CBG02074', 420, NULL, NULL, 155784),
(155785, '1.10.1080.10-FF-000011', NULL, 'Glutathione synthetase', 40, NULL, NULL, 155785),
(155786, '3.40.250.10-FF-000117', NULL, 'Rodhanase family domain containing protein', 166, NULL, NULL, 155786),
(155787, '3.50.50.60-FF-000118', NULL, 'Glutathione reductase, mitochondrial', 129, NULL, NULL, 155787),
(155788, '3.90.70.80-FF-000006', NULL, 'Ubiquitin thioesterase OTU1', 182, NULL, NULL, 155788),
(155789, '3.20.20.100-FF-000207', NULL, 'Uncharacterized protein', 230, NULL, NULL, 155789),
(155790, '1.20.1250.20-FF-001952', NULL, 'Uncharacterized protein', 435, NULL, NULL, 155790),
(155791, '2.130.10.10-FF-001437', NULL, 'LLGL scribble cell polarity complex component 1', 310, NULL, NULL, 155791),
(155792, '3.30.420.40-FF-000209', NULL, 'Phosphotransferase', 163, NULL, NULL, 155792),
(155793, '3.40.50.1820-FF-000150', NULL, 'Alpha/beta fold hydrolase', 287, NULL, NULL, 155793),
(155794, '3.30.160.60-FF-001330', NULL, 'Zinc finger protein ZIC 4', 85, NULL, NULL, 155794),
(155795, '2.120.10.10-FF-000016', NULL, 'Trans-sialidase, putative', 401, NULL, NULL, 155795),
(155796, '3.30.30.30-FF-000076', NULL, 'Protein CBG19479', 21, NULL, NULL, 155796),
(155797, '3.30.1740.10-FF-000027', NULL, 'Predicted protein', 85, NULL, NULL, 155797),
(155798, '3.40.50.300-FF-001151', NULL, 'Large subunit GTPase 1', 210, NULL, NULL, 155798),
(155799, '2.160.20.10-FF-000054', NULL, 'Polygalacturonase', 381, NULL, NULL, 155799),
(155800, '1.20.144.10-FF-000074', NULL, 'Dolichyl pyrophosphate phosphatase, putative', 99, NULL, NULL, 155800),
(155801, '3.30.870.10-FF-000133', NULL, 'AGAP006233-PA', 177, NULL, NULL, 155801),
(155802, '1.10.1520.10-FF-000040', NULL, 'Uncharacterized protein', 134, NULL, NULL, 155802),
(155803, '3.30.2410.10-FF-000059', NULL, 'Uncharacterized protein', 128, NULL, NULL, 155803),
(155804, '2.60.40.10-FF-005063', NULL, NULL, 101, NULL, NULL, 155804),
(155805, '3.40.50.1460-FF-000019', NULL, 'caspase-14-like', 238, NULL, NULL, 155805),
(155806, '3.40.50.300-FF-002348', NULL, 'ATP-dependent RNA helicase', 171, NULL, NULL, 155806),
(155807, '3.30.200.20-FF-000895', NULL, 'Transmembrane ion channel', 95, NULL, NULL, 155807),
(155808, '1.25.40.20-FF-000725', NULL, 'Serine/threonine protein kinase', 62, NULL, NULL, 155808),
(155809, '1.20.58.70-FF-000049', NULL, 'EhSyntaxin 1B', 132, NULL, NULL, 155809),
(155810, '3.30.420.40-FF-000541', NULL, 'Luminal-binding protein 2', 195, NULL, NULL, 155810),
(155811, '3.30.930.10-FF-000071', NULL, 'histidine--tRNA ligase, cytoplasmic isoform X6', 233, NULL, NULL, 155811),
(155812, '1.20.120.680-FF-000005', NULL, NULL, 44, NULL, NULL, 155812),
(155813, '2.120.10.30-FF-000443', NULL, 'Uncharacterized protein', 114, NULL, NULL, 155813),
(155814, '3.40.50.300-FF-005108', NULL, 'Elongator complex protein 4', 336, NULL, NULL, 155814),
(155815, '3.40.50.800-FF-000025', NULL, 'PEK/GCN2 protein kinase, variant', 102, NULL, NULL, 155815),
(155816, '3.50.50.60-FF-000450', NULL, 'Amine oxidase', 65, NULL, NULL, 155816),
(155817, '3.10.180.10-FF-000040', NULL, 'Methylmalonyl-CoA epimerase', 145, NULL, NULL, 155817),
(155818, '2.60.40.10-FF-000167', NULL, 'Down syndrome cell adhesion molecule b', 99, NULL, NULL, 155818),
(155819, '1.20.1070.10-FF-000221', NULL, 'Muscarinic acetylcholine receptor gar-2', 226, NULL, NULL, 155819),
(155820, '3.30.470.20-FF-000044', NULL, 'tubulin polyglutamylase TTLL11 isoform X2', 244, NULL, NULL, 155820),
(155821, '3.30.420.10-FF-000105', NULL, 'Uncharacterized protein', 130, NULL, NULL, 155821),
(155822, '3.30.2310.20-FF-000009', NULL, 'HigB toxin protein', 92, NULL, NULL, 155822),
(155823, '1.10.287.110-FF-000067', NULL, 'Chaperone DnaJ domain protein', 110, NULL, NULL, 155823),
(155824, '3.10.129.10-FF-000146', NULL, 'Cytosolic acyl coenzyme A thioester hydrolase', 158, NULL, NULL, 155824);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(155825, '3.90.550.10-FF-000359', NULL, 'Similar to UTP--glucose-1-phosphate uridylyltransferase', 383, NULL, NULL, 155825),
(155826, '3.30.60.30-FF-000010', NULL, 'Solute carrier organic anion transporter family member', 49, NULL, NULL, 155826),
(155827, '3.50.30.50-FF-000007', NULL, 'Cyclase, putative', 68, NULL, NULL, 155827),
(155828, '3.20.20.300-FF-000031', NULL, 'Glycosyl hydrolase family protein', 37, NULL, NULL, 155828),
(155829, '3.80.10.10-FF-000898', NULL, 'Leucine Rich Repeat family protein, expressed', 104, NULL, NULL, 155829),
(155830, '1.20.1440.170-FF-000005', NULL, 'Putative translation machinery-associated protein 16 protein', 119, NULL, NULL, 155830),
(155831, '1.25.10.10-FF-002351', NULL, 'Predicted protein', 285, NULL, NULL, 155831),
(155832, '2.130.10.10-FF-004079', NULL, 'Uncharacterized protein', 202, NULL, NULL, 155832),
(155833, '2.60.120.260-FF-000662', NULL, 'Beta-Mannosidase, isoform F', 88, NULL, NULL, 155833),
(155834, '3.30.230.130-FF-000086', NULL, 'Uncharacterized protein', 144, NULL, NULL, 155834),
(155835, '3.40.50.300-FF-005440', NULL, 'ATP-dependent DEAD/H RNA helicase', 260, NULL, NULL, 155835),
(155836, '1.10.3110.10-FF-000014', NULL, 'NAD(P)/FAD-dependent oxidoreductase', 76, NULL, NULL, 155836),
(155837, '2.60.40.60-FF-000721', NULL, 'Cadherin-4', 98, NULL, NULL, 155837),
(155838, '3.40.50.980-FF-000039', NULL, 'Peptide synthetase', 134, NULL, NULL, 155838),
(155839, '2.30.30.40-FF-000137', NULL, 'Uncharacterized protein, isoform G', 113, NULL, NULL, 155839),
(155840, '3.20.20.60-FF-000096', NULL, 'Pyruvate kinase', 241, NULL, NULL, 155840),
(155841, '3.60.40.10-FF-000221', NULL, 'Sigma factor sigB regulation protein rsbU', 243, NULL, NULL, 155841),
(155842, '3.40.50.720-FF-002244', NULL, 'Uncharacterized protein', 82, NULL, NULL, 155842),
(155843, '1.20.1310.10-FF-000044', NULL, 'Ubiquitin ligase subunit CulD, putative', 120, NULL, NULL, 155843),
(155844, '4.10.400.10-FF-000211', NULL, 'Lipophorin receptor 2, isoform I', 39, NULL, NULL, 155844),
(155845, '3.40.50.2000-FF-000558', NULL, 'Glycosyltransferase', 236, NULL, NULL, 155845),
(155846, '1.10.510.10-FF-000276', NULL, 'LRR receptor-like serine/threonine-protein kinase RCH1', 215, NULL, NULL, 155846),
(155847, '3.40.1800.20-FF-000016', NULL, 'LD15650p', 77, NULL, NULL, 155847),
(155848, '3.40.50.970-FF-000143', NULL, '1-deoxy-D-xylulose-5-phosphate synthase', 206, NULL, NULL, 155848),
(155849, '2.60.40.10-FF-002297', NULL, 'CRE-TWK-32 protein', 98, NULL, NULL, 155849),
(155850, '2.70.98.10-FF-000030', NULL, 'Putative alpha-1,2-mannosidase', 326, NULL, NULL, 155850),
(155851, '3.40.50.720-FF-002013', NULL, 'Uncharacterized protein', 218, NULL, NULL, 155851),
(155852, '3.20.20.70-FF-000205', NULL, 'Fructose-bisphosphate aldolase', 179, NULL, NULL, 155852),
(155853, '2.30.29.30-FF-001120', NULL, 'TBC1 domain family member 1', 131, NULL, NULL, 155853),
(155854, '3.40.50.720-FF-000900', NULL, 'Phthiocerol synthesis polyketide synthase type I PpsB', 475, NULL, NULL, 155854),
(155855, '2.60.40.10-FF-004438', NULL, NULL, 80, NULL, NULL, 155855),
(155856, '3.90.190.10-FF-000500', NULL, 'mRNA capping enzyme', 147, NULL, NULL, 155856),
(155857, '2.60.40.1510-FF-000036', NULL, 'Integrin beta', 30, NULL, NULL, 155857),
(155858, '3.30.160.60-FF-003365', NULL, NULL, 30, NULL, NULL, 155858),
(155859, '1.25.40.10-FF-001228', NULL, 'Pentatricopeptide repeat-containing protein At4g20770', 103, NULL, NULL, 155859),
(155860, '3.30.200.20-FF-001513', NULL, 'Protein kinase, putative (AFU_orthologue AFUA_6G09240)', 11, NULL, NULL, 155860),
(155861, '2.60.120.200-FF-000104', NULL, 'adhesion G-protein coupled receptor D1', 167, NULL, NULL, 155861),
(155862, '3.90.660.10-FF-000025', NULL, 'Amine oxidase', 96, NULL, NULL, 155862),
(155863, '3.30.260.10-FF-000103', NULL, NULL, 65, NULL, NULL, 155863),
(155864, '3.40.50.300-FF-007570', NULL, 'Si:dkey-88j15.4', 183, NULL, NULL, 155864),
(155865, '3.40.50.300-FF-004585', NULL, 'NACHT and Ankyrin domain protein', 179, NULL, NULL, 155865),
(155866, '2.20.25.20-FF-000030', NULL, NULL, 51, NULL, NULL, 155866);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(155867, '1.10.10.10-FF-000259', NULL, 'Transcriptional regulator, DeoR family', 58, NULL, NULL, 155867),
(155868, '1.10.8.270-FF-000138', NULL, 'Uncharacterized protein', 63, NULL, NULL, 155868),
(155869, '3.30.40.10-FF-001874', NULL, 'Predicted protein', 77, NULL, NULL, 155869),
(155870, '4.10.40.20-FF-000010', NULL, 'Kazal-type serine protease inhibitor domain-containing protein 1', 76, NULL, NULL, 155870),
(155871, '1.10.150.80-FF-000049', NULL, 'ATP-dependent DNA helicase', 64, NULL, NULL, 155871),
(155872, '2.120.10.30-FF-000224', NULL, 'Regucalcin', 300, NULL, NULL, 155872),
(155873, '3.40.1110.10-FF-000163', NULL, 'Calcium-transporting ATPase', 240, NULL, NULL, 155873),
(155874, '2.40.30.10-FF-000509', NULL, 'NADPH oxidase 3', 78, NULL, NULL, 155874),
(155875, '1.10.640.10-FF-000050', NULL, 'Protein CBR-PXN-2', 350, NULL, NULL, 155875),
(155876, '3.30.160.60-FF-002746', NULL, 'Uncharacterized protein, isoform A', 70, NULL, NULL, 155876),
(155877, '3.40.50.300-FF-005097', NULL, 'X-ray repair-complementing defective repair in Chinese hamster cells 3', 268, NULL, NULL, 155877),
(155878, '2.30.29.30-FF-000395', NULL, 'Non-specific serine/threonine protein kinase', 61, NULL, NULL, 155878),
(155879, '3.80.10.10-FF-002135', NULL, 'CD180 molecule', 591, NULL, NULL, 155879),
(155880, '3.30.160.60-FF-004764', NULL, NULL, 34, NULL, NULL, 155880),
(155881, '1.10.510.10-FF-003261', NULL, NULL, 110, NULL, NULL, 155881),
(155882, '3.30.70.270-FF-000316', NULL, NULL, 28, NULL, NULL, 155882),
(155883, '3.30.160.60-FF-003146', NULL, 'Zinc finger 30C', 72, NULL, NULL, 155883),
(155884, '1.10.238.10-FF-000575', NULL, 'GM19870', 93, NULL, NULL, 155884),
(155885, '1.10.510.10-FF-000495', NULL, 'calcium/calmodulin-regulated receptor-like kinase 1', 209, NULL, NULL, 155885),
(155886, '3.30.559.70-FF-000068', NULL, 'Uncharacterized protein', 33, NULL, NULL, 155886),
(155887, '3.40.50.720-FF-001625', NULL, 'Fatty acyl-CoA reductase', 60, NULL, NULL, 155887),
(155888, '2.60.40.150-FF-000529', NULL, 'Phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit alpha-like protein', 162, NULL, NULL, 155888),
(155889, '3.30.1640.10-FF-000087', NULL, 'Uncharacterized protein', 58, NULL, NULL, 155889),
(155890, '3.90.1150.10-FF-000530', NULL, 'Uncharacterized protein', 80, NULL, NULL, 155890),
(155891, '3.10.580.10-FF-000132', NULL, 'Uncharacterized protein', 131, NULL, NULL, 155891),
(155892, '3.40.47.10-FF-000074', NULL, 'Fatty acid synthase', 574, NULL, NULL, 155892),
(155893, '2.60.120.10-FF-000809', NULL, 'Uncharacterized protein', 114, NULL, NULL, 155893),
(155894, '3.40.50.720-FF-002137', NULL, 'Uncharacterized protein', 98, NULL, NULL, 155894),
(155895, '1.20.1720.10-FF-000075', NULL, 'Transmembrane transport protein', 210, NULL, NULL, 155895),
(155896, '2.40.240.10-FF-000042', NULL, 'Glutaminyl-tRNA synthetase', 49, NULL, NULL, 155896),
(155897, '3.30.1370.10-FF-000229', NULL, 'KH domain containing protein', 120, NULL, NULL, 155897),
(155898, '2.60.40.10-FF-001572', NULL, 'Prolactin-inducible protein homolog', 118, NULL, NULL, 155898),
(155899, '3.90.1100.10-FF-000033', NULL, 'DNA-directed RNA polymerase subunit beta', 203, NULL, NULL, 155899),
(155900, '1.25.10.10-FF-002929', NULL, 'Uncharacterized protein', 98, NULL, NULL, 155900),
(155901, '2.130.10.10-FF-004186', NULL, 'Anaphase-promoting complex subunit 4', 161, NULL, NULL, 155901),
(155902, '1.25.40.10-FF-003701', NULL, 'Uncharacterized protein', 291, NULL, NULL, 155902),
(155903, '2.120.10.30-FF-000336', NULL, 'Predicted protein', 136, NULL, NULL, 155903),
(155904, '2.30.29.30-FF-000406', NULL, 'Putative RNA polymerase II transcription factor related protein', 108, NULL, NULL, 155904),
(155905, '1.20.140.150-FF-000058', NULL, 'Actin cortical patch protein Sur7', 173, NULL, NULL, 155905),
(155906, '2.60.120.10-FF-000231', NULL, '5-deoxy-glucuronate isomerase', 108, NULL, NULL, 155906),
(155907, '3.40.50.620-FF-000308', NULL, 'Cytidylyltransferase family protein', 258, NULL, NULL, 155907),
(155908, '2.10.25.10-FF-001415', NULL, 'Uncharacterized protein', 37, NULL, NULL, 155908);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(155909, '3.40.50.261-FF-000038', NULL, 'Succinate--CoA ligase [ADP-forming] subunit alpha-1 mitochondrial', 112, NULL, NULL, 155909),
(155910, '3.30.70.1880-FF-000002', NULL, 'UPF0749 protein Rv1825', 144, NULL, NULL, 155910),
(155911, '3.40.190.10-FF-000281', NULL, 'ABC transporter, periplasmic substrate-binding protein', 130, NULL, NULL, 155911),
(155912, '1.10.3460.10-FF-000001', NULL, 'Chlorophyll a-b binding protein, chloroplastic', 203, NULL, NULL, 155912),
(155913, '3.80.10.10-FF-000212', NULL, 'Podocan', 237, NULL, NULL, 155913),
(155914, '2.130.10.30-FF-000139', NULL, NULL, 178, NULL, NULL, 155914),
(155915, '1.25.40.10-FF-004213', NULL, 'Uncharacterized protein', 55, NULL, NULL, 155915),
(155916, '3.30.470.30-FF-000035', NULL, 'CRE-LIG-4 protein', 229, NULL, NULL, 155916),
(155917, '3.30.450.40-FF-000037', NULL, 'PAS sensor protein', 160, NULL, NULL, 155917),
(155918, '1.20.120.1900-FF-000075', NULL, 'Gamma-tubulin complex component gfh1', 286, NULL, NULL, 155918),
(155919, '1.10.238.220-FF-000012', NULL, NULL, 67, NULL, NULL, 155919),
(155920, '4.10.170.10-FF-000007', NULL, 'Serine/threonine-protein kinase cst-1', 54, NULL, NULL, 155920),
(155921, '2.40.50.140-FF-000573', NULL, 'Aspartyl-tRNA synthetase, putative', 100, NULL, NULL, 155921),
(155922, '3.40.33.10-FF-000132', NULL, 'AFR700Wp', 185, NULL, NULL, 155922),
(155923, '2.60.40.60-FF-000485', NULL, 'Uncharacterized protein', 133, NULL, NULL, 155923),
(155924, '3.80.10.10-FF-003646', NULL, 'Disease resistance protein SUMM2', 102, NULL, NULL, 155924),
(155925, '3.30.505.10-FF-000010', NULL, 'Tyrosine-protein kinase', 107, NULL, NULL, 155925),
(155926, '3.80.20.20-FF-000042', NULL, 'Meiotic expression up-regulated protein 10', 144, NULL, NULL, 155926),
(155927, '3.40.640.10-FF-000260', NULL, 'Aminotransferase', 228, NULL, NULL, 155927),
(155928, '3.30.200.20-FF-002132', NULL, 'Uncharacterized protein', 72, NULL, NULL, 155928),
(155929, '2.130.10.10-FF-002281', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit TRM82', 230, NULL, NULL, 155929),
(155930, '3.30.420.40-FF-001053', NULL, 'Probable actin-related protein 8', 159, NULL, NULL, 155930),
(155931, '1.10.238.10-FF-001194', NULL, 'Serine/threonine-protein phosphatase', 80, NULL, NULL, 155931),
(155932, '2.60.40.10-FF-005170', NULL, NULL, 94, NULL, NULL, 155932),
(155933, '3.30.870.10-FF-000026', NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', 214, NULL, NULL, 155933),
(155934, '1.20.1250.20-FF-001059', NULL, 'Major facilitator superfamily MFS_1', 198, NULL, NULL, 155934),
(155935, '1.10.560.10-FF-000099', NULL, '60 kDa chaperonin 2', 245, NULL, NULL, 155935),
(155936, '3.30.450.20-FF-000031', NULL, 'Nuclear receptor coactivator', 113, NULL, NULL, 155936),
(155937, '3.30.160.60-FF-005383', NULL, NULL, 87, NULL, NULL, 155937),
(155938, '3.40.630.10-FF-000214', NULL, 'Acetylornithine deacetylase', 136, NULL, NULL, 155938),
(155939, '2.60.120.340-FF-000023', NULL, 'Nucleoplasmin-like protein', 127, NULL, NULL, 155939),
(155940, '3.90.1490.10-FF-000016', NULL, 'Diphthine--ammonia ligase', 62, NULL, NULL, 155940),
(155941, '2.170.270.10-FF-000081', NULL, 'GD10068', 29, NULL, NULL, 155941),
(155942, '3.10.20.90-FF-000740', NULL, 'Uncharacterized protein', 106, NULL, NULL, 155942),
(155943, '2.60.40.10-FF-004770', NULL, NULL, 94, NULL, NULL, 155943),
(155944, '3.40.50.2000-FF-000890', NULL, 'N-acetylglucosaminyl-phosphatidylinositol biosynthetic protein', 177, NULL, NULL, 155944),
(155945, '3.30.160.60-FF-006001', NULL, NULL, 41, NULL, NULL, 155945),
(155946, '3.90.550.10-FF-000691', NULL, 'Uncharacterized protein', 60, NULL, NULL, 155946),
(155947, '1.10.472.130-FF-000079', NULL, 'Dynein heavy chain, putative', 114, NULL, NULL, 155947),
(155948, '1.10.10.10-FF-000591', NULL, 'Archaeal heat shock regulator, ArsR family', 93, NULL, NULL, 155948),
(155949, '1.10.510.10-FF-003822', NULL, NULL, 114, NULL, NULL, 155949),
(155950, '2.60.40.10-FF-004219', NULL, NULL, 72, NULL, NULL, 155950),
(155951, '2.60.120.380-FF-000006', NULL, 'Calpain 10', 153, NULL, NULL, 155951);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(155952, '2.30.30.380-FF-000002', NULL, 'Thioredoxin', 34, NULL, NULL, 155952),
(155953, '1.20.120.1080-FF-000110', NULL, 'Putative ATP-dependent RNA helicase DHX40', 103, NULL, NULL, 155953),
(155954, '3.90.190.10-FF-000157', NULL, 'Protein-tyrosine phosphatase', 160, NULL, NULL, 155954),
(155955, '6.10.250.3310-FF-000004', NULL, 'Signal transducer and activator of transcription', 41, NULL, NULL, 155955),
(155956, '2.60.120.970-FF-000088', NULL, 'Uncharacterized protein', 201, NULL, NULL, 155956),
(155957, '2.60.40.10-FF-005967', NULL, NULL, 108, NULL, NULL, 155957),
(155958, '3.40.250.10-FF-000011', NULL, 'Dual specificity phosphatase 7', 151, NULL, NULL, 155958),
(155959, '3.40.50.620-FF-000640', NULL, 'Uncharacterized protein', 210, NULL, NULL, 155959),
(155960, '2.40.30.110-FF-000026', NULL, NULL, 82, NULL, NULL, 155960),
(155961, '2.10.25.10-FF-000797', NULL, 'Thrombomodulin', 40, NULL, NULL, 155961),
(155962, '3.40.50.10140-FF-000037', NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', 132, NULL, NULL, 155962),
(155963, '1.25.40.10-FF-002864', NULL, 'Fanconi anemia group G protein', 83, NULL, NULL, 155963),
(155964, '1.20.920.30-FF-000030', NULL, 'Putative dynein heavy chain', 197, NULL, NULL, 155964),
(155965, '3.40.50.1220-FF-000077', NULL, 'NAD-dependent deacetylase, Sir2 family protein', 182, NULL, NULL, 155965),
(155966, '3.40.50.300-FF-006951', NULL, 'Uncharacterized protein', 224, NULL, NULL, 155966),
(155967, '3.30.40.10-FF-000256', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 107, NULL, NULL, 155967),
(155968, '3.90.110.10-FF-000040', NULL, NULL, 97, NULL, NULL, 155968),
(155969, '3.40.850.10-FF-000540', NULL, 'Uncharacterized protein', 313, NULL, NULL, 155969),
(155970, '3.30.70.330-FF-002144', NULL, NULL, 68, NULL, NULL, 155970),
(155971, '2.40.70.10-FF-000383', NULL, NULL, 191, NULL, NULL, 155971),
(155972, '1.20.1250.20-FF-000210', NULL, 'Solute carrier organic anion transporter family member', 407, NULL, NULL, 155972),
(155973, '3.40.710.10-FF-000035', NULL, 'Membrane peptidoglycan carboxypeptidase', 379, NULL, NULL, 155973),
(155974, '2.60.120.10-FF-000012', NULL, 'neuropathy target esterase isoform X2', 144, NULL, NULL, 155974),
(155975, '2.60.40.790-FF-000036', NULL, 'Heat Shock Protein', 92, NULL, NULL, 155975),
(155976, '3.30.420.40-FF-000996', NULL, 'Actin-related protein 8', 82, NULL, NULL, 155976),
(155977, '3.40.50.1820-FF-001797', NULL, 'Carboxylic ester hydrolase', 347, NULL, NULL, 155977),
(155978, '2.130.10.10-FF-000712', NULL, 'Transducin/WD40 repeat-like superfamily protein', 110, NULL, NULL, 155978),
(155979, '1.20.1050.10-FF-000001', NULL, 'Chloride intracellular channel 2', 144, NULL, NULL, 155979),
(155980, '2.130.10.10-FF-002842', NULL, 'FG-nucleoporin', 355, NULL, NULL, 155980),
(155981, '1.10.472.80-FF-000269', NULL, NULL, 97, NULL, NULL, 155981),
(155982, '1.50.10.20-FF-000036', NULL, 'Protein farnesyltransferase subunit beta', 414, NULL, NULL, 155982),
(155983, '2.60.40.10-FF-002533', NULL, 'Titin homolog', 102, NULL, NULL, 155983),
(155984, '1.10.437.10-FF-000032', NULL, 'Bcl-2-related ovarian killer protein homolog B', 171, NULL, NULL, 155984),
(155985, '1.10.10.10-FF-000602', NULL, 'MurR/RpiR family transcriptional regulator', 81, NULL, NULL, 155985),
(155986, '3.40.50.300-FF-007019', NULL, 'Iron (III) ABC transporter ATP-binding protein, putative', 206, NULL, NULL, 155986),
(155987, '3.40.50.2300-FF-000766', NULL, 'Argonaute 2, isoform E', 169, NULL, NULL, 155987),
(155988, '1.20.1250.20-FF-000098', NULL, 'D-xylose transporter XylE', 252, NULL, NULL, 155988),
(155989, '1.20.1250.20-FF-002352', NULL, 'Predicted protein', 147, NULL, NULL, 155989),
(155990, '2.40.110.10-FF-000049', NULL, 'GD25894', 114, NULL, NULL, 155990),
(155991, '2.10.25.10-FF-000111', NULL, 'Protein kinase C-binding protein NELL2', 49, NULL, NULL, 155991),
(155992, '1.10.510.10-FF-004441', NULL, NULL, 49, NULL, NULL, 155992),
(155993, '1.10.150.20-FF-000184', NULL, 'DNA excision repair protein ERCC-1', 44, NULL, NULL, 155993),
(155994, '3.90.180.10-FF-000095', NULL, 'Chlorophyll synthesis pathway protein BchC', 175, NULL, NULL, 155994);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(155995, '3.30.70.1170-FF-000008', NULL, 'Proliferating-cell nucleolar antigen p120', 105, NULL, NULL, 155995),
(155996, '1.10.10.750-FF-000011', NULL, 'TBC1 domain family member 2B-like', 31, NULL, NULL, 155996),
(155997, '2.160.20.70-FF-000044', NULL, 'Adenylyl cyclase-associated protein 1', 62, NULL, NULL, 155997),
(155998, '3.40.50.720-FF-000664', NULL, 'GDP-mannose 6-dehydrogenase', 202, NULL, NULL, 155998),
(155999, '3.30.450.20-FF-000610', NULL, 'Uncharacterized protein', 145, NULL, NULL, 155999),
(156000, '1.10.1130.10-FF-000004', NULL, 'Cytochrome c-552', 355, NULL, NULL, 156000),
(156001, '2.30.42.10-FF-000026', NULL, 'Golgi reassembly stacking protein 2', 98, NULL, NULL, 156001),
(156002, '3.40.1280.10-FF-000057', NULL, 'tRNA (cytidine(34)-2''-O)-methyltransferase', 150, NULL, NULL, 156002),
(156003, '2.60.40.60-FF-000827', NULL, 'Predicted protein', 68, NULL, NULL, 156003),
(156004, '1.20.120.330-FF-000030', NULL, 'Probable mannitol operon repressor', 144, NULL, NULL, 156004),
(156005, '2.170.150.10-FF-000038', NULL, 'Uncharacterized protein', 86, NULL, NULL, 156005),
(156006, '3.30.420.110-FF-000062', NULL, 'DNA mismatch repair protein', 181, NULL, NULL, 156006),
(156007, '3.30.70.330-FF-000014', NULL, 'RNA-binding motif, single-stranded-interacting protein 3 isoform 1', 84, NULL, NULL, 156007),
(156008, '3.40.50.720-FF-000321', NULL, 'Chloroplast stem-loop binding protein of 41 kDa a, chloroplastic', 293, NULL, NULL, 156008),
(156009, '3.40.50.2300-FF-001042', NULL, NULL, 154, NULL, NULL, 156009),
(156010, '3.30.9.100-FF-000004', NULL, 'Squalene monooxygenase', 51, NULL, NULL, 156010),
(156011, '3.80.10.10-FF-004046', NULL, 'Uncharacterized protein', 140, NULL, NULL, 156011),
(156012, '3.40.190.290-FF-000121', NULL, 'Probable nitrogen assimilation transcriptional activator', 213, NULL, NULL, 156012),
(156013, '1.25.10.10-FF-000895', NULL, 'RING-type E3 ubiquitin transferase', 294, NULL, NULL, 156013),
(156014, '3.50.30.80-FF-000005', NULL, 'Dihydroxy-acid dehydratase chloroplastic', 114, NULL, NULL, 156014),
(156015, '3.30.230.10-FF-000282', NULL, 'Translation elongation factor G', 133, NULL, NULL, 156015),
(156016, '3.40.1810.10-FF-000076', NULL, NULL, 90, NULL, NULL, 156016),
(156017, '2.70.150.10-FF-000242', NULL, 'ACR086Cp', 99, NULL, NULL, 156017),
(156018, '2.60.40.60-FF-001103', NULL, 'Uncharacterized protein', 107, NULL, NULL, 156018),
(156019, '3.50.50.60-FF-000574', NULL, 'Putative polyamine oxidase 5 isoform A', 117, NULL, NULL, 156019),
(156020, '2.10.25.10-FF-000454', NULL, 'Laminin subunit alpha 1', 50, NULL, NULL, 156020),
(156021, '3.40.190.10-FF-000623', NULL, 'Putative chorismate mutase/prephenate dehydratase', 86, NULL, NULL, 156021),
(156022, '2.130.10.10-FF-003461', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 92, NULL, NULL, 156022),
(156023, '2.60.40.10-FF-002876', NULL, 'Uncharacterized protein', 106, NULL, NULL, 156023),
(156024, '3.30.460.10-FF-000091', NULL, 'DNA polymerase lambda subunit', 121, NULL, NULL, 156024),
(156025, '1.25.40.10-FF-000846', NULL, 'Signal peptidase I', 118, NULL, NULL, 156025),
(156026, '1.20.58.220-FF-000008', NULL, 'Phosphate-specific transport system accessory protein PhoU homolog 2', 108, NULL, NULL, 156026),
(156027, '3.40.50.700-FF-000001', NULL, 'Hydrogenase 2 small subunit', 186, NULL, NULL, 156027),
(156028, '3.40.850.10-FF-000197', NULL, 'Predicted protein', 368, NULL, NULL, 156028),
(156029, '3.30.1240.10-FF-000006', NULL, 'HAD superfamily hydrolase', 104, NULL, NULL, 156029),
(156030, '3.30.70.330-FF-002487', NULL, NULL, 76, NULL, NULL, 156030),
(156031, '3.30.497.10-FF-000181', NULL, 'Uncharacterized protein', 121, NULL, NULL, 156031),
(156032, '3.40.525.10-FF-000071', NULL, 'Uncharacterized protein', 113, NULL, NULL, 156032),
(156033, '2.130.10.30-FF-000033', NULL, 'RCC1 and BTB domain-containing protein 2', 158, NULL, NULL, 156033),
(156034, '2.60.40.10-FF-003152', NULL, 'Tyrosine-protein phosphatase 69D', 104, NULL, NULL, 156034),
(156035, '2.60.40.1120-FF-000026', NULL, 'Carboxypeptidase D', 78, NULL, NULL, 156035);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(156036, '1.20.1250.20-FF-001391', NULL, 'monocarboxylate transporter 13-like', 190, NULL, NULL, 156036),
(156037, '3.30.420.380-FF-000002', NULL, 'Type II secretion system protein L', 156, NULL, NULL, 156037),
(156038, '1.25.10.10-FF-001171', NULL, 'Unplaced genomic scaffold supercont1.20, whole genome shotgun sequence', 179, NULL, NULL, 156038),
(156039, '2.40.10.10-FF-000621', NULL, NULL, 247, NULL, NULL, 156039),
(156040, '2.60.120.200-FF-000228', NULL, 'Beta-glucan synthesis-associated protein KRE6', 135, NULL, NULL, 156040),
(156041, '3.40.50.410-FF-000015', NULL, 'General transcription factor IIH subunit 2', 188, NULL, NULL, 156041),
(156042, '3.40.50.300-FF-003860', NULL, 'Si:rp71-7l19.2', 133, NULL, NULL, 156042),
(156043, '3.90.1180.10-FF-000026', NULL, NULL, 155, NULL, NULL, 156043),
(156044, '1.10.8.140-FF-000010', NULL, 'Uncharacterized protein D2005.3', 79, NULL, NULL, 156044),
(156045, '1.20.900.10-FF-000040', NULL, 'Trio, isoform D', 208, NULL, NULL, 156045),
(156046, '3.40.50.2300-FF-000081', NULL, 'Glutamate receptor', 170, NULL, NULL, 156046),
(156047, '1.10.510.10-FF-001113', NULL, 'Casein kinase 1 gamma 2', 315, NULL, NULL, 156047),
(156048, '3.40.50.300-FF-000437', NULL, 'ATP-dependent DNA helicase DinG', 188, NULL, NULL, 156048),
(156049, '1.25.40.20-FF-000489', NULL, 'Ankyrin 2', 155, NULL, NULL, 156049),
(156050, '3.10.450.50-FF-000016', NULL, 'Mitogen-activated protein kinase', 116, NULL, NULL, 156050),
(156051, '2.10.230.10-FF-000020', NULL, 'Uncharacterized protein', 86, NULL, NULL, 156051),
(156052, '2.60.40.150-FF-000187', NULL, 'Protein C2-DOMAIN ABA-RELATED 10', 124, NULL, NULL, 156052),
(156053, '3.30.2130.30-FF-000009', NULL, 'Probable tRNA sulfurtransferase', 174, NULL, NULL, 156053),
(156054, '1.20.5.2950-FF-000005', NULL, 'Vacuolar ATP synthase subunit G, putative', 110, NULL, NULL, 156054),
(156055, '1.10.287.70-FF-000206', NULL, 'Voltage-dependent T-type calcium channel subunit alpha', 184, NULL, NULL, 156055),
(156056, '3.40.50.300-FF-002909', NULL, 'GPN-loop GTPase', 198, NULL, NULL, 156056),
(156057, '2.130.10.10-FF-001331', NULL, 'Actin-related protein 2/3 complex subunit', 359, NULL, NULL, 156057),
(156058, '2.130.10.10-FF-003803', NULL, 'Meiotic fizzy-related protein 1', 310, NULL, NULL, 156058),
(156059, '1.25.70.10-FF-000095', NULL, NULL, 107, NULL, NULL, 156059),
(156060, '1.20.1440.120-FF-000001', NULL, 'DNA repair protein RecO', 164, NULL, NULL, 156060),
(156061, '3.80.10.10-FF-001735', NULL, 'Leucine_Rich_repeat/Leucine_Rich_Repeat/Leucine_R ich_repeats_(2_copies)_-_putative', 128, NULL, NULL, 156061),
(156062, '3.30.565.10-FF-000019', NULL, 'Virulence sensor histidine kinase PhoQ', 151, NULL, NULL, 156062),
(156063, '1.10.510.10-FF-000731', NULL, 'Serine/threonine-protein kinase RCK1', 363, NULL, NULL, 156063),
(156064, '3.40.50.300-FF-001730', NULL, 'Multidrug ABC transporter ATP-binding protein', 257, NULL, NULL, 156064),
(156065, '3.30.160.880-FF-000002', NULL, 'Cell division protein ZapA', 48, NULL, NULL, 156065),
(156066, '3.10.100.10-FF-000265', NULL, NULL, 147, NULL, NULL, 156066),
(156067, '1.20.1070.10-FF-001525', NULL, 'Uncharacterized protein', 188, NULL, NULL, 156067),
(156068, '1.10.533.10-FF-000082', NULL, 'Uncharacterized protein', 118, NULL, NULL, 156068),
(156069, '1.10.630.10-FF-000330', NULL, 'Uncharacterized protein', 389, NULL, NULL, 156069),
(156070, '1.10.510.10-FF-004109', NULL, NULL, 120, NULL, NULL, 156070),
(156071, '1.10.730.10-FF-000039', NULL, 'Arginine--tRNA ligase', 126, NULL, NULL, 156071),
(156072, '1.25.40.20-FF-000944', NULL, 'Predicted protein', 133, NULL, NULL, 156072),
(156073, '2.60.40.60-FF-000266', NULL, 'Cadherin 23', 109, NULL, NULL, 156073),
(156074, '1.25.40.20-FF-001344', NULL, 'Ankyrin repeat and MYND domain-containing 2b', 112, NULL, NULL, 156074),
(156075, '1.10.1060.10-FF-000009', NULL, 'Glutamate synthase 1 [NADH] chloroplastic', 166, NULL, NULL, 156075),
(156076, '3.40.225.10-FF-000031', NULL, 'Hu li tai shao-like protein', 273, NULL, NULL, 156076),
(156077, '3.30.40.10-FF-002150', NULL, 'Uncharacterized protein', 63, NULL, NULL, 156077);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(156078, '3.40.50.150-FF-000920', NULL, NULL, 150, NULL, NULL, 156078),
(156079, '1.25.40.10-FF-000048', NULL, 'Cell cycle control protein', 205, NULL, NULL, 156079),
(156080, '3.90.226.10-FF-000325', NULL, 'Retinol binding protein 3', 172, NULL, NULL, 156080),
(156081, '3.80.10.10-FF-004265', NULL, 'Predicted protein', 61, NULL, NULL, 156081),
(156082, '2.60.40.10-FF-003713', NULL, NULL, 90, NULL, NULL, 156082),
(156083, '2.130.10.10-FF-004422', NULL, 'Uncharacterized protein', 361, NULL, NULL, 156083),
(156084, '1.10.405.10-FF-000037', NULL, 'Uncharacterized protein', 66, NULL, NULL, 156084),
(156085, '1.20.5.170-FF-000191', NULL, 'FOS-like antigen 1b', 68, NULL, NULL, 156085),
(156086, '1.25.40.10-FF-004319', NULL, 'Uncharacterized protein', 175, NULL, NULL, 156086),
(156087, '1.10.260.40-FF-000057', NULL, 'XRE family transcriptional regulator', 68, NULL, NULL, 156087),
(156088, '3.40.190.10-FF-000062', NULL, 'Putrescine-binding periplasmic protein', 131, NULL, NULL, 156088),
(156089, '3.40.50.1820-FF-000493', NULL, 'Protein CBG12424', 258, NULL, NULL, 156089),
(156090, '3.30.160.190-FF-000003', NULL, 'NADH dehydrogenase [ubiquinone] iron-sulfur protein 4, mitochondrial', 47, NULL, NULL, 156090),
(156091, '1.25.40.20-FF-001220', NULL, 'No mechanoreceptor potential C, isoform H', 142, NULL, NULL, 156091),
(156092, '3.40.50.300-FF-002567', NULL, 'DNA helicase', 198, NULL, NULL, 156092),
(156093, '3.40.50.1100-FF-000058', NULL, 'Cysteine synthase B, putative', 124, NULL, NULL, 156093),
(156094, '1.10.287.380-FF-000007', NULL, 'Valine-tRNA ligase', 72, NULL, NULL, 156094),
(156095, '3.40.50.880-FF-000122', NULL, '4-methyl-5(B-hydroxyethyl)-thiazol monophosphate biosynthesis enzyme, putative', 183, NULL, NULL, 156095),
(156096, '2.40.50.140-FF-000792', NULL, NULL, 92, NULL, NULL, 156096),
(156097, '3.40.50.1000-FF-000359', NULL, 'Chromosome 9, whole genome shotgun sequence', 136, NULL, NULL, 156097),
(156098, '3.30.810.10-FF-000028', NULL, 'RpkA', 159, NULL, NULL, 156098),
(156099, '2.30.42.10-FF-000369', NULL, 'WD domain, G-beta repeat, putative', 83, NULL, NULL, 156099),
(156100, '1.20.5.510-FF-000006', NULL, 'Photosystem II psbX protein', 39, NULL, NULL, 156100),
(156101, '1.25.40.10-FF-004994', NULL, 'Uncharacterized protein', 131, NULL, NULL, 156101),
(156102, '2.170.150.20-FF-000030', NULL, 'Predicted protein', 104, NULL, NULL, 156102),
(156103, '3.40.50.2300-FF-000423', NULL, 'Predicted protein', 284, NULL, NULL, 156103),
(156104, '2.40.420.20-FF-000031', NULL, 'Efflux transporter periplasmic adaptor subunit', 93, NULL, NULL, 156104),
(156105, '3.30.565.10-FF-000351', NULL, 'Two-component sensor histidine kinase', 160, NULL, NULL, 156105),
(156106, '1.10.8.590-FF-000009', NULL, NULL, 71, NULL, NULL, 156106),
(156107, '3.30.200.20-FF-000552', NULL, 'Cell division protein kinase, putative', 85, NULL, NULL, 156107),
(156108, '3.40.140.20-FF-000005', NULL, 'Bifunctional purine biosynthesis protein PurH', 150, NULL, NULL, 156108),
(156109, '1.20.120.610-FF-000024', NULL, 'Uncharacterized protein', 40, NULL, NULL, 156109),
(156110, '3.80.10.10-FF-003989', NULL, 'Si:dkey-156k2.3', 157, NULL, NULL, 156110),
(156111, '3.30.1120.160-FF-000001', NULL, 'GTPase-activating Rap/Ran-GAP domain-like protein 3', 140, NULL, NULL, 156111),
(156112, '3.40.50.620-FF-000061', NULL, 'Tyrosine--tRNA ligase', 217, NULL, NULL, 156112),
(156113, '3.30.70.330-FF-002829', NULL, NULL, 88, NULL, NULL, 156113),
(156114, '3.40.50.1780-FF-000003', NULL, 'Periplasmic [Fe] hydrogenase large subunit', 165, NULL, NULL, 156114),
(156115, '2.160.20.110-FF-000001', NULL, 'CXC-rich protein', 277, NULL, NULL, 156115),
(156116, '3.30.500.10-FF-000038', NULL, NULL, 74, NULL, NULL, 156116),
(156117, '3.40.462.10-FF-000003', NULL, 'Cholesterol oxidase', 273, NULL, NULL, 156117),
(156118, '3.90.226.10-FF-000106', NULL, 'Possible enoyl-CoA hydratase echA4', 305, NULL, NULL, 156118),
(156119, '3.40.1190.10-FF-000050', NULL, NULL, 136, NULL, NULL, 156119),
(156120, '3.40.50.1820-FF-001454', NULL, 'Uncharacterized protein', 183, NULL, NULL, 156120);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(156121, '1.10.1670.10-FF-000039', NULL, 'Adenine DNA glycosylase', 94, NULL, NULL, 156121),
(156122, '1.10.1300.10-FF-000040', NULL, 'cGMP-specific 3'',5''-cyclic phosphodiesterase', 165, NULL, NULL, 156122),
(156123, '1.25.40.20-FF-001905', NULL, 'Molting protein MLT-4', 99, NULL, NULL, 156123),
(156124, '1.25.40.10-FF-001560', NULL, 'Tetratricopeptide repeat domain 21A', 134, NULL, NULL, 156124),
(156125, '3.40.50.1240-FF-000072', NULL, 'Histidine phosphatase family protein', 196, NULL, NULL, 156125),
(156126, '2.20.25.90-FF-000011', NULL, 'Dimethyl sulfoxide reductase subunit A', 70, NULL, NULL, 156126),
(156127, '3.30.70.260-FF-000190', NULL, 'Glycine cleavage system transcriptional repressor GcvR', 95, NULL, NULL, 156127),
(156128, '3.40.50.300-FF-007238', NULL, 'Uncharacterized protein', 161, NULL, NULL, 156128),
(156129, '3.40.50.300-FF-003528', NULL, 'CTP synthase', 179, NULL, NULL, 156129),
(156130, '2.40.70.10-FF-000506', NULL, NULL, 101, NULL, NULL, 156130),
(156131, '3.30.70.330-FF-003105', NULL, NULL, 87, NULL, NULL, 156131),
(156132, '3.40.50.10860-FF-000034', NULL, 'monofunctional C1-tetrahydrofolate synthase, mitochondrial isoform X1', 85, NULL, NULL, 156132),
(156133, '3.90.550.50-FF-000236', NULL, 'Uncharacterized protein', 85, NULL, NULL, 156133),
(156134, '3.10.20.90-FF-000285', NULL, 'Putative ubiquitin/ribosomal protein S27a', 75, NULL, NULL, 156134),
(156135, '1.25.40.10-FF-005270', NULL, 'Predicted protein', 152, NULL, NULL, 156135),
(156136, '3.80.10.10-FF-001516', NULL, 'Lap1, isoform B', 90, NULL, NULL, 156136),
(156137, '3.30.920.10-FF-000019', NULL, 'Uncharacterized protein', 143, NULL, NULL, 156137),
(156138, '3.40.50.1980-FF-000057', NULL, 'Similar to ferrichrome ABC transporter', 180, NULL, NULL, 156138),
(156139, '1.10.10.10-FF-001895', NULL, 'Predicted protein', 69, NULL, NULL, 156139),
(156140, '3.20.20.100-FF-000196', NULL, 'Uncharacterized protein', 80, NULL, NULL, 156140),
(156141, '1.10.418.20-FF-000002', NULL, 'sentrin-specific protease 6 isoform X1', 50, NULL, NULL, 156141),
(156142, '1.25.40.340-FF-000013', NULL, NULL, 198, NULL, NULL, 156142),
(156143, '2.60.40.640-FF-000019', NULL, 'Arrestin 3', 209, NULL, NULL, 156143),
(156144, '2.30.230.10-FF-000044', NULL, 'Zgc:136383 protein', 63, NULL, NULL, 156144),
(156145, '3.30.720.50-FF-000022', NULL, NULL, 78, NULL, NULL, 156145),
(156146, '1.20.1070.10-FF-001868', NULL, 'Uncharacterized protein', 346, NULL, NULL, 156146),
(156147, '2.130.10.10-FF-003129', NULL, 'Uncharacterized protein', 248, NULL, NULL, 156147),
(156148, '1.10.10.60-FF-000701', NULL, 'TetR family transcriptional regulator', 54, NULL, NULL, 156148),
(156149, '3.40.50.300-FF-004821', NULL, 'SNF2 family N-terminal domain containing protein', 267, NULL, NULL, 156149),
(156150, '3.40.190.10-FF-000860', NULL, 'Uncharacterized protein', 49, NULL, NULL, 156150),
(156151, '3.30.559.10-FF-000185', NULL, 'Brassinosteroid-related acyltransferase 1', 224, NULL, NULL, 156151),
(156152, '1.20.1070.10-FF-001744', NULL, 'Zg01', 85, NULL, NULL, 156152),
(156153, '1.10.132.50-FF-000004', NULL, 'V-type proton ATPase subunit d 1', 69, NULL, NULL, 156153),
(156154, '3.30.160.60-FF-000616', NULL, 'PR domain zinc finger protein 13', 29, NULL, NULL, 156154),
(156155, '1.25.40.770-FF-000024', NULL, 'Uncharacterized protein', 114, NULL, NULL, 156155),
(156156, '2.120.10.80-FF-000104', NULL, 'Multiple EGF like domains 8', 208, NULL, NULL, 156156),
(156157, '3.30.70.1150-FF-000002', NULL, 'Nickel-responsive regulator', 85, NULL, NULL, 156157),
(156158, '3.40.47.10-FF-000310', NULL, 'Polyketide synthase', 440, NULL, NULL, 156158),
(156159, '3.30.450.70-FF-000035', NULL, NULL, 144, NULL, NULL, 156159),
(156160, '3.30.70.330-FF-001868', NULL, NULL, 104, NULL, NULL, 156160),
(156161, '1.20.1070.10-FF-002144', NULL, 'Uncharacterized protein', 195, NULL, NULL, 156161),
(156162, '3.40.50.200-FF-000177', NULL, 'Putative subtilisin proteinase-like protein', 330, NULL, NULL, 156162),
(156163, '3.30.70.330-FF-002268', NULL, NULL, 87, NULL, NULL, 156163),
(156164, '1.10.418.40-FF-000008', NULL, 'Vacuolar sorting protein', 192, NULL, NULL, 156164);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(156165, '2.40.30.170-FF-000004', NULL, 'Auxiliary transport protein, membrane fusion protein family', 121, NULL, NULL, 156165),
(156166, '1.20.1270.60-FF-000083', NULL, 'Rho guanyl nucleotide exchange factor, putative', 228, NULL, NULL, 156166),
(156167, '2.120.10.30-FF-000314', NULL, 'NHL repeat domain lipoprotein', 237, NULL, NULL, 156167),
(156168, '3.40.50.10490-FF-000131', NULL, NULL, 88, NULL, NULL, 156168),
(156169, '3.30.160.60-FF-002668', NULL, 'Paternally expressed 3', 28, NULL, NULL, 156169),
(156170, '3.30.1120.10-FF-000059', NULL, 'Probable sulfatase atsG', 63, NULL, NULL, 156170),
(156171, '2.40.160.110-FF-000045', NULL, 'Lysosomal-associated membrane protein 1a', 130, NULL, NULL, 156171),
(156172, '1.10.357.100-FF-000002', NULL, 'ADL286Wp', 176, NULL, NULL, 156172),
(156173, '1.10.1220.10-FF-000005', NULL, 'Bifunctional antitoxin/transcriptional repressor RelB', 79, NULL, NULL, 156173),
(156174, '2.130.10.10-FF-002730', NULL, 'Bardet-Biedl syndrome 1 protein homolog', 299, NULL, NULL, 156174),
(156175, '1.10.287.1260-FF-000002', NULL, 'Potassium efflux system KefA', 102, NULL, NULL, 156175),
(156176, '1.10.10.60-FF-000095', NULL, 'LIM homeobox transcription factor 1 beta', 82, NULL, NULL, 156176),
(156177, '1.10.510.10-FF-002075', NULL, NULL, 84, NULL, NULL, 156177),
(156178, '2.40.160.120-FF-000048', NULL, 'Uncharacterized protein', 208, NULL, NULL, 156178),
(156179, '2.60.40.10-FF-004843', NULL, NULL, 61, NULL, NULL, 156179),
(156180, '3.40.50.300-FF-006772', NULL, 'Predicted protein', 61, NULL, NULL, 156180),
(156181, '3.80.10.10-FF-000072', NULL, 'protein scribble homolog isoform X1', 114, NULL, NULL, 156181),
(156182, '1.10.510.10-FF-004199', NULL, NULL, 371, NULL, NULL, 156182),
(156183, '3.30.70.330-FF-003122', NULL, NULL, 180, NULL, NULL, 156183),
(156184, '2.70.150.10-FF-000118', NULL, 'Copper-transporting ATPase', 109, NULL, NULL, 156184),
(156185, '3.40.50.720-FF-002154', NULL, 'Fatty acyl-CoA reductase', 82, NULL, NULL, 156185),
(156186, '3.90.70.200-FF-000012', NULL, 'GM16155', 126, NULL, NULL, 156186),
(156187, '2.30.30.550-FF-000008', NULL, NULL, 54, NULL, NULL, 156187),
(156188, '3.30.420.40-FF-001007', NULL, 'Actin-related protein 8', 64, NULL, NULL, 156188),
(156189, '3.10.110.10-FF-000182', NULL, 'UBiquitin Conjugating enzyme', 150, NULL, NULL, 156189),
(156190, '3.40.50.150-FF-001095', NULL, NULL, 194, NULL, NULL, 156190),
(156191, '1.20.20.10-FF-000018', NULL, 'H+transporting two-sector ATPase C subunit', 69, NULL, NULL, 156191),
(156192, '1.20.120.350-FF-000199', NULL, NULL, 132, NULL, NULL, 156192),
(156193, '3.80.10.10-FF-001174', NULL, 'Si:ch211-156p11.1', 149, NULL, NULL, 156193),
(156194, '3.40.1080.10-FF-000019', NULL, 'CoA transferase CarA2', 265, NULL, NULL, 156194),
(156195, '3.40.50.300-FF-005670', NULL, 'ATP-dependent nuclease subunit A', 193, NULL, NULL, 156195),
(156196, '1.25.40.10-FF-000374', NULL, 'Mitochondrial proteins import receptor', 385, NULL, NULL, 156196),
(156197, '3.80.10.10-FF-002163', NULL, 'Leucine Rich repeat, putative', 226, NULL, NULL, 156197),
(156198, '3.30.160.60-FF-001566', NULL, 'Zinc finger protein 263', 32, NULL, NULL, 156198),
(156199, '3.40.50.720-FF-001491', NULL, 'Ornithine cyclodeaminase', 177, NULL, NULL, 156199),
(156200, '1.20.1250.10-FF-000027', NULL, 'Cardiotrophin 1', 186, NULL, NULL, 156200),
(156201, '3.40.190.10-FF-000359', NULL, 'Putative molybdopterin biosynthesis protein', 100, NULL, NULL, 156201),
(156202, '3.60.40.10-FF-000030', NULL, 'Protein phosphatase, Mg2+/Mn2+-dependent 1D', 319, NULL, NULL, 156202),
(156203, '1.25.40.10-FF-004556', NULL, 'Protein NPGR1', 209, NULL, NULL, 156203),
(156204, '1.10.418.10-FF-000269', NULL, 'Predicted protein', 139, NULL, NULL, 156204),
(156205, '1.25.10.10-FF-000872', NULL, 'U3 small nucleolar RNA-associated protein 10', 241, NULL, NULL, 156205),
(156206, '3.50.50.60-FF-001299', NULL, 'Glr2871 protein', 190, NULL, NULL, 156206),
(156207, '3.40.1190.20-FF-000210', NULL, NULL, 66, NULL, NULL, 156207),
(156208, '3.40.50.300-FF-004681', NULL, 'Mitochondrial GTPase 1', 191, NULL, NULL, 156208);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(156209, '1.25.10.10-FF-002963', NULL, 'Uncharacterized protein', 432, NULL, NULL, 156209),
(156210, '2.60.120.200-FF-000352', NULL, 'Concanavalin A-like lectin family protein', 208, NULL, NULL, 156210),
(156211, '1.10.3430.10-FF-000044', NULL, 'Uncharacterized protein', 238, NULL, NULL, 156211),
(156212, '3.40.850.10-FF-000034', NULL, 'Kinesin family member 15', 359, NULL, NULL, 156212),
(156213, '1.25.40.10-FF-002465', NULL, 'Pentatricopeptide repeat-containing protein At1g13040, mitochondrial', 116, NULL, NULL, 156213),
(156214, '3.40.50.2300-FF-000457', NULL, 'Transcriptional regulator, LacI family', 131, NULL, NULL, 156214),
(156215, '2.130.10.10-FF-004821', NULL, 'Uncharacterized protein', 138, NULL, NULL, 156215),
(156216, '3.40.50.970-FF-000233', NULL, 'Putative 2-oxoglutarate dehydrogenase E1 component DHKTD1 homolog, mitochondrial-like Protein', 365, NULL, NULL, 156216),
(156217, '3.40.640.10-FF-000434', NULL, 'Uncharacterized protein', 247, NULL, NULL, 156217),
(156218, '3.40.50.1970-FF-000026', NULL, '3-dehydroquinate synthase', 170, NULL, NULL, 156218),
(156219, '2.60.40.10-FF-004197', NULL, NULL, 82, NULL, NULL, 156219),
(156220, '1.10.472.130-FF-000080', NULL, 'Uncharacterized protein', 177, NULL, NULL, 156220),
(156221, '2.60.120.200-FF-000026', NULL, 'contactin-associated protein-like 4 isoform X1', 167, NULL, NULL, 156221),
(156222, '3.40.220.10-FF-000003', NULL, 'O-acetyl-ADP-ribose deacetylase MACROD2', 234, NULL, NULL, 156222),
(156223, '3.10.129.10-FF-000174', NULL, 'Uncharacterized protein', 124, NULL, NULL, 156223),
(156224, '3.40.50.12780-FF-000110', NULL, 'Nonribosomal peptide synthase, putative', 389, NULL, NULL, 156224),
(156225, '3.30.60.30-FF-000196', NULL, 'Potamin-1', 47, NULL, NULL, 156225),
(156226, '3.40.50.1820-FF-001488', NULL, 'Hydrolase-like protein family', 167, NULL, NULL, 156226),
(156227, '3.40.30.10-FF-000221', NULL, 'Glutathione S-transferase rho', 84, NULL, NULL, 156227),
(156228, '2.60.120.330-FF-000132', NULL, 'Uncharacterized protein', 64, NULL, NULL, 156228),
(156229, '3.30.230.70-FF-000024', NULL, 'Similar to exosome complex exonuclease RRP41', 253, NULL, NULL, 156229),
(156230, '3.40.309.10-FF-000024', NULL, 'Betaine aldehyde dehydrogenase', 198, NULL, NULL, 156230),
(156231, '1.10.418.10-FF-000123', NULL, 'Protein CBR-UNC-53, isoform d', 123, NULL, NULL, 156231),
(156232, '2.30.18.10-FF-000015', NULL, 'Transcription initiation factor IIA subunit 2', 54, NULL, NULL, 156232),
(156233, '3.40.50.1980-FF-000029', NULL, 'Ferrichrome ABC transporter substrate-binding protein', 149, NULL, NULL, 156233),
(156234, '2.60.120.260-FF-000263', NULL, 'Cellulose synthase domain-containing protein', 137, NULL, NULL, 156234),
(156235, '2.60.40.150-FF-000625', NULL, 'Predicted protein', 143, NULL, NULL, 156235),
(156236, '3.20.20.80-FF-000652', NULL, 'RP120N2.5 family protein', 82, NULL, NULL, 156236),
(156237, '3.40.47.10-FF-000170', NULL, '3-hydroxy-3-methylglutaryl coenzyme A synthase', 443, NULL, NULL, 156237),
(156238, '3.30.420.40-FF-000783', NULL, 'YALI0B10934p', 161, NULL, NULL, 156238),
(156239, '2.130.10.10-FF-000959', NULL, 'F-box and WD repeat domain containing 9', 158, NULL, NULL, 156239),
(156240, '1.10.238.10-FF-001014', NULL, 'Uncharacterized protein', 59, NULL, NULL, 156240),
(156241, '2.130.10.10-FF-004175', NULL, 'Uncharacterized protein', 166, NULL, NULL, 156241),
(156242, '3.40.50.300-FF-005344', NULL, 'DNA replication ATP-dependent helicase/nuclease DNA2', 264, NULL, NULL, 156242),
(156243, '1.10.4160.10-FF-000001', NULL, 'Uracil permease, putative', 474, NULL, NULL, 156243),
(156244, '3.30.70.1450-FF-000025', NULL, 'Sulfur deprivation response regulator', 76, NULL, NULL, 156244),
(156245, '1.10.357.140-FF-000053', NULL, 'Uncharacterized protein', 71, NULL, NULL, 156245),
(156246, '1.10.8.140-FF-000021', NULL, 'Predicted protein', 103, NULL, NULL, 156246),
(156247, '2.10.109.10-FF-000064', NULL, 'Transcription regulator LexA', 127, NULL, NULL, 156247),
(156248, '3.60.21.10-FF-000284', NULL, 'Glr0056 protein', 288, NULL, NULL, 156248);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(156249, '3.30.930.10-FF-000413', NULL, 'Uncharacterized protein', 369, NULL, NULL, 156249),
(156250, '1.10.620.20-FF-000023', NULL, 'Heavy-metal transporting P-type ATPase', 89, NULL, NULL, 156250),
(156251, '2.60.40.60-FF-000856', NULL, 'Cadherin 26', 52, NULL, NULL, 156251),
(156252, '2.60.40.1510-FF-000025', NULL, 'integrin alpha-PS2 isoform X1', 141, NULL, NULL, 156252),
(156253, '3.10.20.90-FF-000796', NULL, 'Uncharacterized protein', 70, NULL, NULL, 156253),
(156254, '3.90.79.10-FF-000073', NULL, 'ADP-ribose pyrophosphatase NudF', 203, NULL, NULL, 156254),
(156255, '2.40.40.20-FF-000002', NULL, 'DNA-directed RNA polymerase subunit', 111, NULL, NULL, 156255),
(156256, '2.40.50.140-FF-000376', NULL, 'Putative exosome complex component CSL4', 131, NULL, NULL, 156256),
(156257, '1.10.20.10-FF-000159', NULL, 'CBF/NF-Y family transcription factor, putative', 163, NULL, NULL, 156257),
(156258, '2.40.50.40-FF-000132', NULL, 'Signal recognition particle 43 kDa protein, chloroplastic', 56, NULL, NULL, 156258),
(156259, '2.60.220.50-FF-000104', NULL, 'Predicted protein', 192, NULL, NULL, 156259),
(156260, '3.40.190.10-FF-000652', NULL, 'ABC transporter substrate-binding protein', 94, NULL, NULL, 156260),
(156261, '1.20.140.100-FF-000038', NULL, 'Dynein heavy chain', 52, NULL, NULL, 156261),
(156262, '3.80.10.10-FF-003944', NULL, 'Uncharacterized protein', 228, NULL, NULL, 156262),
(156263, '3.40.50.1370-FF-000060', NULL, NULL, 94, NULL, NULL, 156263),
(156264, '3.40.50.150-FF-001302', NULL, NULL, 213, NULL, NULL, 156264),
(156265, '2.30.30.140-FF-000301', NULL, 'Uncharacterized protein', 75, NULL, NULL, 156265),
(156266, '1.10.486.10-FF-000061', NULL, 'ATP-dependent DNA helicase srs2', 177, NULL, NULL, 156266),
(156267, '3.20.110.10-FF-000011', NULL, 'Lysosomal alpha-mannosidase, putative', 124, NULL, NULL, 156267),
(156268, '1.10.238.10-FF-000497', NULL, 'Uncharacterized protein', 66, NULL, NULL, 156268),
(156269, '3.30.70.330-FF-000481', NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', 121, NULL, NULL, 156269),
(156270, '3.40.1170.20-FF-000001', NULL, 'tRNA-splicing endonuclease', 75, NULL, NULL, 156270),
(156271, '3.40.50.150-FF-000959', NULL, 'RNA methyltransferase', 266, NULL, NULL, 156271),
(156272, '3.90.70.10-FF-000906', NULL, 'Ubiquitinyl hydrolase 1', 267, NULL, NULL, 156272),
(156273, '1.25.40.20-FF-001366', NULL, 'Uncharacterized protein', 91, NULL, NULL, 156273),
(156274, '2.70.160.11-FF-000013', NULL, 'Protein arginine N-methyltransferase 1.6', 163, NULL, NULL, 156274),
(156275, '2.60.15.10-FF-000030', NULL, 'ATP synthase H+ transporting, F1 complex, delta subunit precursor, putative', 69, NULL, NULL, 156275),
(156276, '3.30.160.60-FF-004000', NULL, 'GD24229', 80, NULL, NULL, 156276),
(156277, '3.10.20.770-FF-000022', NULL, 'Uncharacterized protein', 154, NULL, NULL, 156277),
(156278, '3.40.50.10810-FF-000238', NULL, 'Predicted protein', 198, NULL, NULL, 156278),
(156279, '1.10.10.60-FF-000774', NULL, 'Homeobox protein NANOG', 118, NULL, NULL, 156279),
(156280, '2.70.98.10-FF-000108', NULL, 'Putative alpha-1,2-mannosidase', 319, NULL, NULL, 156280),
(156281, '1.20.58.60-FF-000136', NULL, 'MCF.2 cell line derived transforming sequence like', 318, NULL, NULL, 156281),
(156282, '2.40.30.10-FF-000347', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 120, NULL, NULL, 156282),
(156283, '6.10.140.2220-FF-000003', NULL, 'MYND-type zinc finger protein', 54, NULL, NULL, 156283),
(156284, '2.130.10.10-FF-005164', NULL, 'Os02g0796700 protein', 134, NULL, NULL, 156284),
(156285, '2.170.270.10-FF-000058', NULL, 'Histone-lysine N-methyltransferase', 169, NULL, NULL, 156285),
(156286, '3.40.50.300-FF-006479', NULL, 'Predicted protein', 117, NULL, NULL, 156286),
(156287, '1.10.418.40-FF-000019', NULL, 'Uncharacterized protein', 183, NULL, NULL, 156287),
(156288, '1.25.40.10-FF-002791', NULL, 'Predicted protein', 195, NULL, NULL, 156288),
(156289, '3.30.160.60-FF-004646', NULL, NULL, 55, NULL, NULL, 156289),
(156290, '3.40.50.2000-FF-000811', NULL, 'Uncharacterized protein', 86, NULL, NULL, 156290);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(156291, '3.30.420.10-FF-000122', NULL, '3''-5'' exonuclease', 261, NULL, NULL, 156291),
(156292, '3.30.160.60-FF-002994', NULL, 'Zinc finger protein 473', 26, NULL, NULL, 156292),
(156293, '1.10.510.10-FF-000837', NULL, 'STE family protein kinase', 294, NULL, NULL, 156293),
(156294, '1.10.275.20-FF-000001', NULL, 'carnitine O-palmitoyltransferase 2, mitochondrial', 101, NULL, NULL, 156294),
(156295, '3.10.50.10-FF-000055', NULL, 'Uncharacterized protein', 40, NULL, NULL, 156295),
(156296, '3.40.50.300-FF-003427', NULL, 'DExD/H-box helicase 58', 68, NULL, NULL, 156296),
(156297, '3.30.470.20-FF-000223', NULL, 'D-alanine--D-alanine ligase', 155, NULL, NULL, 156297),
(156298, '3.50.50.60-FF-000517', NULL, 'Lysine-specific histone demethylase 1', 42, NULL, NULL, 156298),
(156299, '3.30.70.270-FF-000030', NULL, 'Genome polyprotein', 56, NULL, NULL, 156299),
(156300, '1.20.1250.20-FF-000356', NULL, 'Glycoside-Pentoside-Hexuronide (GPH):Cation Symporter Family', 151, NULL, NULL, 156300),
(156301, '3.90.190.10-FF-000101', NULL, 'phosphatidylinositol phosphatase PTPRQ', 287, NULL, NULL, 156301),
(156302, '2.60.260.20-FF-000154', NULL, 'Uncharacterized protein', 138, NULL, NULL, 156302),
(156303, '3.30.565.10-FF-000328', NULL, 'DNA topoisomerase 2', 97, NULL, NULL, 156303),
(156304, '1.20.1050.130-FF-000051', NULL, 'Uncharacterized protein', 76, NULL, NULL, 156304),
(156305, '2.60.40.10-FF-003415', NULL, NULL, 90, NULL, NULL, 156305),
(156306, '2.130.10.10-FF-004528', NULL, 'WD domain, Gbeta repeat-containing protein', 228, NULL, NULL, 156306),
(156307, '3.20.20.150-FF-000019', NULL, 'Probable endonuclease 4', 251, NULL, NULL, 156307),
(156308, '3.40.718.10-FF-000053', NULL, 'Isocitrate dehydrogenase [NAD] subunit alpha, mitochondrial', 77, NULL, NULL, 156308),
(156309, '1.20.120.30-FF-000008', NULL, NULL, 133, NULL, NULL, 156309),
(156310, '3.40.50.300-FF-001336', NULL, 'Dynein heavy chain domain-containing protein 1', 164, NULL, NULL, 156310),
(156311, '3.30.43.10-FF-000015', NULL, 'Carbon monoxide dehydrogenase medium chain', 54, NULL, NULL, 156311),
(156312, '2.60.40.10-FF-000774', NULL, 'Hepatitis A virus cellular receptor 1', 114, NULL, NULL, 156312),
(156313, '1.10.10.10-FF-000866', NULL, 'LysR family transcriptional regulator', 88, NULL, NULL, 156313),
(156314, '2.30.42.10-FF-000122', NULL, 'Pro-interleukin-16', 117, NULL, NULL, 156314),
(156315, '2.10.25.10-FF-001657', NULL, 'Agrin', 71, NULL, NULL, 156315),
(156316, '3.30.1370.10-FF-000105', NULL, 'Protein CBG12765', 171, NULL, NULL, 156316),
(156317, '3.30.40.10-FF-000008', NULL, 'Bromodomain containing 1, isoform CRA_a', 68, NULL, NULL, 156317),
(156318, '2.130.10.10-FF-001302', NULL, 'Protein kinase family protein / WD-40 repeat family protein', 284, NULL, NULL, 156318),
(156319, '2.60.120.260-FF-000616', NULL, 'Tail spike protein', 136, NULL, NULL, 156319),
(156320, '3.40.50.2300-FF-000311', NULL, 'Guanylate cyclase', 109, NULL, NULL, 156320),
(156321, '3.30.200.20-FF-002531', NULL, 'Predicted protein', 50, NULL, NULL, 156321),
(156322, '3.40.525.10-FF-000037', NULL, 'CRAL/TRIO, N-terminus family protein, expressed', 190, NULL, NULL, 156322),
(156323, '3.40.50.2300-FF-001300', NULL, NULL, 130, NULL, NULL, 156323),
(156324, '3.60.130.10-FF-000014', NULL, 'Gamma-butyrobetaine hydroxylase subfamily', 292, NULL, NULL, 156324),
(156325, '1.20.1250.20-FF-001458', NULL, 'Solute carrier organic anion transporter family member', 403, NULL, NULL, 156325),
(156326, '1.10.510.10-FF-002928', NULL, NULL, 89, NULL, NULL, 156326),
(156327, '3.30.70.330-FF-000688', NULL, 'RNA-binding protein 8A-like', 159, NULL, NULL, 156327),
(156328, '3.40.30.10-FF-000867', NULL, 'Thioredoxin domain-containing 5', 143, NULL, NULL, 156328),
(156329, '3.30.470.20-FF-000162', NULL, 'Blr0101 protein', 99, NULL, NULL, 156329),
(156330, '2.30.40.10-FF-000140', NULL, 'Amidohydrolase domain containing 1', 29, NULL, NULL, 156330),
(156331, '3.40.50.720-FF-002480', NULL, 'Asperfuranone polyketide synthase afoG', 218, NULL, NULL, 156331),
(156332, '3.80.10.10-FF-003618', NULL, 'Uncharacterized protein', 121, NULL, NULL, 156332);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(156333, '3.30.70.330-FF-002279', NULL, NULL, 98, NULL, NULL, 156333),
(156334, '1.20.5.1500-FF-000003', NULL, 'SET isoform 2', 79, NULL, NULL, 156334),
(156335, '1.10.510.10-FF-000776', NULL, 'Cdc2-related protein kinase 4', 232, NULL, NULL, 156335),
(156336, '1.20.1070.10-FF-000255', NULL, 'Allatostatin A receptor', 331, NULL, NULL, 156336),
(156337, '3.40.366.10-FF-000026', NULL, 'Fatty acid synthase', 110, NULL, NULL, 156337),
(156338, '3.30.40.10-FF-002251', NULL, 'Uncharacterized protein', 58, NULL, NULL, 156338),
(156339, '3.30.540.10-FF-000069', NULL, 'Predicted protein', 127, NULL, NULL, 156339),
(156340, '2.130.10.10-FF-001887', NULL, 'Chromatin assembly factor 1, subunit B', 101, NULL, NULL, 156340),
(156341, '1.20.120.160-FF-000001', NULL, 'Histidine-containing phosphotransfer protein 1', 148, NULL, NULL, 156341),
(156342, '3.60.10.10-FF-000202', NULL, 'DNA-(apurinic or apyrimidinic site) lyase', 148, NULL, NULL, 156342),
(156343, '1.25.10.10-FF-001209', NULL, 'Tubulin-specific chaperone D', 241, NULL, NULL, 156343),
(156344, '3.30.1370.10-FF-000044', NULL, 'Polyribonucleotide nucleotidyltransferase 1, mitochondrial', 68, NULL, NULL, 156344),
(156345, '3.40.50.300-FF-002438', NULL, 'tRNA dimethylallyltransferase', 223, NULL, NULL, 156345),
(156346, '3.30.200.20-FF-000940', NULL, 'Receptor protein-tyrosine kinase', 102, NULL, NULL, 156346),
(156347, '2.60.40.10-FF-000509', NULL, 'Immunoglobin superfamily member 21', 119, NULL, NULL, 156347),
(156348, '2.40.340.10-FF-000016', NULL, NULL, 82, NULL, NULL, 156348),
(156349, '1.10.287.70-FF-000009', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 136, NULL, NULL, 156349),
(156350, '2.60.40.790-FF-000143', NULL, NULL, 122, NULL, NULL, 156350),
(156351, '3.40.50.720-FF-000237', NULL, 'Malic enzyme', 311, NULL, NULL, 156351),
(156352, '3.30.70.870-FF-000029', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 77, NULL, NULL, 156352),
(156353, '1.20.1270.60-FF-000111', NULL, 'YPR148C-like protein', 223, NULL, NULL, 156353),
(156354, '1.25.10.10-FF-000193', NULL, 'HEAT repeat-containing protein 5A isoform X3', 252, NULL, NULL, 156354),
(156355, '1.10.10.10-FF-001030', NULL, 'Methionine aminopeptidase, putative', 63, NULL, NULL, 156355),
(156356, '1.10.510.10-FF-004492', NULL, NULL, 233, NULL, NULL, 156356),
(156357, '1.25.40.20-FF-000377', NULL, 'No mechanoreceptor potential C, isoform D', 172, NULL, NULL, 156357),
(156358, '3.30.920.20-FF-000005', NULL, NULL, 64, NULL, NULL, 156358),
(156359, '1.10.275.30-FF-000004', NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', 117, NULL, NULL, 156359),
(156360, '3.40.350.10-FF-000041', NULL, 'Intermediate cleaving peptidase 55, mitochondrial', 159, NULL, NULL, 156360),
(156361, '1.20.120.20-FF-000005', NULL, 'Apolipoprotein A-IV', 154, NULL, NULL, 156361),
(156362, '3.40.720.10-FF-000322', NULL, 'Phosphatidylinositol-glycan biosynthesis, class O protein', 164, NULL, NULL, 156362),
(156363, '3.40.50.1820-FF-000386', NULL, 'Probable lipase/esterase LipG', 294, NULL, NULL, 156363),
(156364, '3.80.10.10-FF-003298', NULL, 'Si:ch211-197f20.1', 394, NULL, NULL, 156364),
(156365, '3.30.710.10-FF-000402', NULL, 'Predicted protein', 154, NULL, NULL, 156365),
(156366, '3.30.720.10-FF-000021', NULL, 'Uncharacterized protein', 47, NULL, NULL, 156366),
(156367, '3.40.50.1820-FF-000240', NULL, 'Alpha/beta-Hydrolases superfamily protein', 240, NULL, NULL, 156367),
(156368, '1.20.120.180-FF-000007', NULL, 'Predicted protein', 90, NULL, NULL, 156368),
(156369, '3.30.40.10-FF-001762', NULL, 'E3 ubiquitin-protein ligase', 99, NULL, NULL, 156369),
(156370, '3.90.70.80-FF-000028', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 138, NULL, NULL, 156370),
(156371, '1.20.1250.20-FF-001930', NULL, 'Uncharacterized protein', 366, NULL, NULL, 156371),
(156372, '1.20.1420.30-FF-000013', NULL, 'Calcium permease family membrane transporter', 130, NULL, NULL, 156372),
(156373, '1.20.200.10-FF-000003', NULL, 'Histidine ammonia-lyase', 311, NULL, NULL, 156373);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(156374, '3.30.70.330-FF-002133', NULL, NULL, 153, NULL, NULL, 156374),
(156375, '3.40.50.300-FF-005018', NULL, 'Uncharacterized protein', 86, NULL, NULL, 156375),
(156376, '3.30.160.60-FF-004585', NULL, NULL, 77, NULL, NULL, 156376),
(156377, '3.40.390.10-FF-000307', NULL, NULL, 245, NULL, NULL, 156377),
(156378, '3.90.1150.10-FF-000412', NULL, 'Serine--pyruvate aminotransferase', 57, NULL, NULL, 156378),
(156379, '2.40.70.10-FF-000439', NULL, NULL, 101, NULL, NULL, 156379),
(156380, '1.10.150.210-FF-000002', NULL, 'Phosphoserine phosphatase', 54, NULL, NULL, 156380),
(156381, '1.10.1200.10-FF-000122', NULL, 'HC-toxin synthetase', 84, NULL, NULL, 156381),
(156382, '3.40.630.10-FF-000169', NULL, 'Peptidase M20 domain-containing protein 2', 232, NULL, NULL, 156382),
(156383, '1.20.5.1200-FF-000003', NULL, 'Alpha-tocopherol transfer protein', 42, NULL, NULL, 156383),
(156384, '1.20.58.60-FF-000075', NULL, 'utrophin isoform X1', 117, NULL, NULL, 156384),
(156385, '2.130.10.10-FF-001802', NULL, 'Uncharacterized protein', 185, NULL, NULL, 156385),
(156386, '2.40.50.140-FF-000404', NULL, 'Lysylphosphatidylglycerol biosynthesis bifunctional protein LysX', 131, NULL, NULL, 156386),
(156387, '3.30.160.60-FF-002494', NULL, NULL, 29, NULL, NULL, 156387),
(156388, '3.40.50.2000-FF-000783', NULL, 'Granule bound starch synthase', 49, NULL, NULL, 156388),
(156389, '3.30.70.330-FF-000542', NULL, 'Putative rnp domain protein', 143, NULL, NULL, 156389),
(156390, '3.30.450.20-FF-000306', NULL, 'GGDEF family protein', 118, NULL, NULL, 156390),
(156391, '2.60.40.420-FF-000083', NULL, 'Plastocyanin', 99, NULL, NULL, 156391),
(156392, '3.30.70.2280-FF-000004', NULL, 'DExD-box helicase 21', 49, NULL, NULL, 156392),
(156393, '3.30.200.20-FF-002385', NULL, 'AGAP006960-PA', 103, NULL, NULL, 156393),
(156394, '2.60.120.650-FF-000138', NULL, 'YALI0C16390p', 289, NULL, NULL, 156394),
(156395, '3.30.420.40-FF-000518', NULL, 'Heat shock protein 70 putative', 140, NULL, NULL, 156395),
(156396, '3.30.460.50-FF-000001', NULL, 'WGS project CAEQ00000000 data, annotated contig 1888', 117, NULL, NULL, 156396),
(156397, '1.10.220.10-FF-000057', NULL, 'Annexin', 62, NULL, NULL, 156397),
(156398, '1.10.287.2720-FF-000002', NULL, 'Oxysterol-binding protein', 64, NULL, NULL, 156398),
(156399, '3.40.50.300-FF-006507', NULL, 'Predicted protein', 113, NULL, NULL, 156399),
(156400, '3.40.50.720-FF-001698', NULL, 'GDP-mannose dehydrogenase', 195, NULL, NULL, 156400),
(156401, '3.30.450.30-FF-000017', NULL, 'Profilin', 136, NULL, NULL, 156401),
(156402, '3.40.50.1820-FF-001549', NULL, 'Predicted protein', 125, NULL, NULL, 156402),
(156403, '1.20.58.70-FF-000078', NULL, 'Syntaxin-7A', 115, NULL, NULL, 156403),
(156404, '3.90.70.10-FF-000199', NULL, 'Cysteine proteinases superfamily protein', 330, NULL, NULL, 156404),
(156405, '1.20.1000.10-FF-000009', NULL, 'Guanylate nucleotide binding protein, putative', 293, NULL, NULL, 156405),
(156406, '3.30.450.20-FF-000014', NULL, 'voltage-dependent calcium channel subunit alpha-2/delta-1 isoform X1', 138, NULL, NULL, 156406),
(156407, '1.20.58.1460-FF-000002', NULL, 'PaaX domain-containing protein, C-domain protein', 80, NULL, NULL, 156407),
(156408, '1.10.10.60-FF-000802', NULL, NULL, 65, NULL, NULL, 156408),
(156409, '1.20.144.10-FF-000063', NULL, 'PAP2-domain-containing protein', 78, NULL, NULL, 156409),
(156410, '1.10.150.220-FF-000005', NULL, 'Protein phosphatase 1 regulatory inhibitor subunit 14D', 40, NULL, NULL, 156410),
(156411, '3.40.50.1000-FF-000466', NULL, NULL, 148, NULL, NULL, 156411),
(156412, '3.40.50.2300-FF-000283', NULL, 'DNA-binding response regulator', 122, NULL, NULL, 156412),
(156413, '1.25.40.180-FF-000274', NULL, NULL, 177, NULL, NULL, 156413),
(156414, '2.30.42.10-FF-000268', NULL, 'DegP protease 7', 95, NULL, NULL, 156414),
(156415, '3.90.1150.10-FF-000351', NULL, 'Perosamine synthetase', 126, NULL, NULL, 156415),
(156416, '1.10.274.100-FF-000009', NULL, 'DNA-directed RNA polymerase subunit beta', 164, NULL, NULL, 156416),
(156417, '1.25.40.10-FF-000548', NULL, 'Tetratricopeptide repeat domain 21A', 356, NULL, NULL, 156417);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(156418, '1.10.287.690-FF-000027', NULL, 'DNA polymerase delta subunit 1', 40, NULL, NULL, 156418),
(156419, '2.130.10.10-FF-000459', NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', 317, NULL, NULL, 156419),
(156420, '1.25.40.270-FF-000003', NULL, 'Vacuolar protein sorting-associated protein VTA1 homolog', 104, NULL, NULL, 156420),
(156421, '3.90.70.10-FF-000553', NULL, 'Probable ubiquitin carboxyl-terminal hydrolase 8', 344, NULL, NULL, 156421),
(156422, '3.30.160.60-FF-004972', NULL, NULL, 33, NULL, NULL, 156422),
(156423, '3.40.50.2000-FF-000491', NULL, 'DNA beta-glucosyltransferase', 183, NULL, NULL, 156423),
(156424, '3.30.70.330-FF-000834', NULL, 'RNA binding protein, putative', 97, NULL, NULL, 156424),
(156425, '3.30.40.10-FF-000273', NULL, 'E3 ubiquitin-protein ligase RBX1', 99, NULL, NULL, 156425),
(156426, '1.20.5.110-FF-000010', NULL, 'Vesicle-associated membrane protein 726', 87, NULL, NULL, 156426),
(156427, '3.40.50.300-FF-002910', NULL, 'Dephospho-CoA kinase', 199, NULL, NULL, 156427),
(156428, '1.20.1250.20-FF-002301', NULL, 'Uncharacterized protein', 473, NULL, NULL, 156428),
(156429, '2.30.29.30-FF-001238', NULL, 'GTPase-activating protein BEM2', 113, NULL, NULL, 156429),
(156430, '2.20.100.10-FF-000019', NULL, 'Thrombospondin type 1 domain containing 7A', 55, NULL, NULL, 156430),
(156431, '1.20.1060.10-FF-000018', NULL, 'Polq-1', 116, NULL, NULL, 156431),
(156432, '1.20.950.20-FF-000017', NULL, 'Quinone-reactive Ni/Fe-hydrogenase B-type cytochrome subunit', 204, NULL, NULL, 156432),
(156433, '3.40.50.720-FF-000563', NULL, '3-oxoacyl-acyl carrier protein reductase', 262, NULL, NULL, 156433),
(156434, '3.30.200.20-FF-001103', NULL, 'Os08g0514000 protein', 112, NULL, NULL, 156434),
(156435, '1.20.58.1480-FF-000008', NULL, 'Lon protease', 125, NULL, NULL, 156435),
(156436, '2.30.42.10-FF-000622', NULL, NULL, 83, NULL, NULL, 156436),
(156437, '3.40.50.300-FF-002764', NULL, 'Sulfate adenylyltransferase', 122, NULL, NULL, 156437),
(156438, '3.30.70.270-FF-000237', NULL, NULL, 55, NULL, NULL, 156438),
(156439, '1.20.1560.10-FF-000130', NULL, 'ABC transporter B family member 5', 326, NULL, NULL, 156439),
(156440, '2.130.10.10-FF-004349', NULL, 'Uncharacterized protein', 96, NULL, NULL, 156440),
(156441, '3.80.10.10-FF-003798', NULL, 'Volume-regulated anion channel subunit LRRC8C', 92, NULL, NULL, 156441),
(156442, '3.30.465.10-FF-000118', NULL, 'Glr1833 protein', 83, NULL, NULL, 156442),
(156443, '3.50.50.60-FF-000490', NULL, 'Phytoene desaturase', 97, NULL, NULL, 156443),
(156444, '3.80.10.10-FF-004080', NULL, 'Uncharacterized protein', 127, NULL, NULL, 156444),
(156445, '3.30.160.60-FF-003483', NULL, 'Zinc finger and BTB domain-containing 41', 89, NULL, NULL, 156445),
(156446, '2.40.50.120-FF-000044', NULL, 'Uncharacterized protein', 86, NULL, NULL, 156446),
(156447, '2.60.40.60-FF-001053', NULL, 'Uncharacterized protein', 80, NULL, NULL, 156447),
(156448, '2.60.40.10-FF-002926', NULL, 'Receptor protein-tyrosine kinase', 114, NULL, NULL, 156448),
(156449, '1.10.290.10-FF-000005', NULL, 'DNA topoisomerase 1A', 138, NULL, NULL, 156449),
(156450, '2.60.450.10-FF-000008', NULL, 'Lipopolysaccharide export system protein LptA', 141, NULL, NULL, 156450),
(156451, '3.40.50.80-FF-000052', NULL, 'NADH-cytochrome b5 reductase', 113, NULL, NULL, 156451),
(156452, '2.130.10.10-FF-000813', NULL, 'F-box and WD repeat domain containing 10', 315, NULL, NULL, 156452),
(156453, '2.60.120.10-FF-000141', NULL, 'Sulfate transporter family protein', 168, NULL, NULL, 156453),
(156454, '3.40.50.2300-FF-001385', NULL, NULL, 82, NULL, NULL, 156454),
(156455, '3.30.950.10-FF-000004', NULL, 'Diphthine synthase putative', 159, NULL, NULL, 156455),
(156456, '3.80.10.10-FF-001674', NULL, 'Uncharacterized protein', 100, NULL, NULL, 156456),
(156457, '3.30.200.20-FF-000440', NULL, 'CMGC/DYRK/PRP4 protein kinase, variant', 87, NULL, NULL, 156457),
(156458, '1.25.40.10-FF-000874', NULL, 'Pentatricopeptide repeat-containing protein At1g60770', 106, NULL, NULL, 156458),
(156459, '1.20.1070.10-FF-000581', NULL, 'octopamine receptor Oamb isoform X1', 164, NULL, NULL, 156459);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(156460, '3.20.20.80-FF-000034', NULL, 'Solute carrier family 3 member 1', 383, NULL, NULL, 156460),
(156461, '3.40.50.300-FF-005170', NULL, 'Torsin-like protein', 222, NULL, NULL, 156461),
(156462, '3.90.1580.10-FF-000023', NULL, 'AGAP013122-PA', 290, NULL, NULL, 156462),
(156463, '1.25.10.10-FF-002019', NULL, 'Uncharacterized protein', 138, NULL, NULL, 156463),
(156464, '3.30.70.330-FF-001969', NULL, NULL, 95, NULL, NULL, 156464),
(156465, '1.25.40.280-FF-000006', NULL, 'GH16790', 367, NULL, NULL, 156465),
(156466, '3.90.470.20-FF-000058', NULL, 'Uncharacterized protein', 18, NULL, NULL, 156466),
(156467, '1.25.40.10-FF-003600', NULL, 'RNA-binding protein 4F, isoform D', 306, NULL, NULL, 156467),
(156468, '3.30.1520.10-FF-000168', NULL, 'Uncharacterized protein', 119, NULL, NULL, 156468),
(156469, '1.10.238.10-FF-000558', NULL, 'EH domain-containing and endocytosis protein 1', 105, NULL, NULL, 156469),
(156470, '3.40.50.1220-FF-000122', NULL, 'Uncharacterized protein', 153, NULL, NULL, 156470),
(156471, '1.10.600.10-FF-000103', NULL, 'Bifunctional protein CrtB/UppS', 259, NULL, NULL, 156471),
(156472, '3.40.50.620-FF-000033', NULL, 'tryptophan--tRNA ligase, cytoplasmic', 274, NULL, NULL, 156472),
(156473, '2.130.10.10-FF-004793', NULL, 'WD repeat-containing protein 48 homolog', 148, NULL, NULL, 156473),
(156474, '3.30.870.10-FF-000088', NULL, 'Phospholipase d active site domain-containing protein', 166, NULL, NULL, 156474),
(156475, '2.30.29.30-FF-000136', NULL, 'Ran-specific GTPase-activating protein-like', 146, NULL, NULL, 156475),
(156476, '2.60.40.10-FF-005332', NULL, NULL, 75, NULL, NULL, 156476),
(156477, '2.30.30.100-FF-000222', NULL, 'U6 snRNA-associated Sm-like protein LSm4', 64, NULL, NULL, 156477),
(156478, '1.10.10.10-FF-000692', NULL, 'Vacuolar-sorting protein SNF8', 75, NULL, NULL, 156478),
(156479, '3.90.215.10-FF-000002', NULL, 'Fibrinogen gamma chain', 150, NULL, NULL, 156479),
(156480, '3.30.70.960-FF-000023', NULL, 'Serine protease P146', 105, NULL, NULL, 156480),
(156481, '1.10.510.10-FF-000158', NULL, 'Dual specificity mitogen-activated protein kinase kinase 6', 202, NULL, NULL, 156481),
(156482, '2.30.130.30-FF-000008', NULL, NULL, 33, NULL, NULL, 156482),
(156483, '3.10.450.590-FF-000002', NULL, NULL, 100, NULL, NULL, 156483),
(156484, '3.40.50.720-FF-001844', NULL, 'Dhs-28', 54, NULL, NULL, 156484),
(156485, '1.10.579.10-FF-000007', NULL, '(6-4) photolyase', 121, NULL, NULL, 156485),
(156486, '3.30.200.20-FF-002059', NULL, 'Receptor protein serine/threonine kinase', 86, NULL, NULL, 156486),
(156487, '3.30.1120.90-FF-000009', NULL, 'Nucleosome assembly protein (NAP), putative', 196, NULL, NULL, 156487),
(156488, '1.10.640.10-FF-000049', NULL, 'Uncharacterized protein', 248, NULL, NULL, 156488),
(156489, '2.10.70.80-FF-000012', NULL, 'Sortilin', 55, NULL, NULL, 156489),
(156490, '2.130.10.10-FF-000785', NULL, 'Eukaryotic translation initiation factor 3 subunit I', 327, NULL, NULL, 156490),
(156491, '3.30.420.80-FF-000036', NULL, '40S ribosomal protein S14', 79, NULL, NULL, 156491),
(156492, '3.10.20.90-FF-000824', NULL, 'Uncharacterized protein', 105, NULL, NULL, 156492),
(156493, '2.30.30.100-FF-000076', NULL, 'small Nuclear ribonucleoprotein F, Putative', 82, NULL, NULL, 156493),
(156494, '3.30.160.60-FF-003511', NULL, 'Zinc finger protein 114', 24, NULL, NULL, 156494),
(156495, '3.40.50.220-FF-000003', NULL, 'Ornithine decarboxylase', 108, NULL, NULL, 156495),
(156496, '3.30.160.60-FF-005282', NULL, NULL, 64, NULL, NULL, 156496),
(156497, '2.60.40.10-FF-002898', NULL, 'Neural cell adhesion molecule 1a', 53, NULL, NULL, 156497),
(156498, '3.30.1360.100-FF-000003', NULL, 'Type II secretion system protein L', 86, NULL, NULL, 156498),
(156499, '3.30.200.210-FF-000008', NULL, NULL, 110, NULL, NULL, 156499),
(156500, '3.20.20.70-FF-000031', NULL, 'Glutamate synthase 1 [NADH]', 353, NULL, NULL, 156500),
(156501, '1.20.120.620-FF-000010', NULL, 'Nodulation protein V', 100, NULL, NULL, 156501),
(156502, '3.90.470.10-FF-000055', NULL, 'Gem (nuclear organelle)-associated protein 5', 163, NULL, NULL, 156502);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(156503, '2.40.50.90-FF-000153', NULL, 'Predicted protein', 141, NULL, NULL, 156503),
(156504, '3.40.50.620-FF-000325', NULL, 'Isoleucine--tRNA ligase', 221, NULL, NULL, 156504),
(156505, '3.30.870.10-FF-000116', NULL, 'Cardiolipin synthase', 175, NULL, NULL, 156505),
(156506, '1.25.40.20-FF-000877', NULL, 'Espin-like a', 51, NULL, NULL, 156506),
(156507, '2.90.10.10-FF-000057', NULL, 'Comitin', 61, NULL, NULL, 156507),
(156508, '3.30.40.10-FF-000834', NULL, 'RING-H2 finger protein ATL80', 92, NULL, NULL, 156508),
(156509, '2.130.10.10-FF-003040', NULL, 'Ribosome biogenesis protein ERB1', 150, NULL, NULL, 156509),
(156510, '2.20.70.10-FF-000249', NULL, 'Uncharacterized protein', 51, NULL, NULL, 156510),
(156511, '4.10.60.10-FF-000194', NULL, 'AGAP008075-PA', 36, NULL, NULL, 156511),
(156512, '2.60.40.10-FF-002691', NULL, 'High Incidence of Males (Increased X chromosome loss)', 95, NULL, NULL, 156512),
(156513, '1.25.10.10-FF-003126', NULL, 'Uncharacterized protein', 205, NULL, NULL, 156513),
(156514, '2.60.200.20-FF-000145', NULL, 'Hypothetical_protein_-_conserved', 92, NULL, NULL, 156514),
(156515, '3.40.50.300-FF-004355', NULL, 'MEI-218', 306, NULL, NULL, 156515),
(156516, '1.20.1510.10-FF-000065', NULL, 'Uncharacterized protein', 216, NULL, NULL, 156516),
(156517, '1.10.490.40-FF-000001', NULL, 'Diphtheria toxin', 179, NULL, NULL, 156517),
(156518, '3.40.630.10-FF-000495', NULL, 'Aspartyl aminopeptidase', 133, NULL, NULL, 156518),
(156519, '3.30.160.60-FF-005102', NULL, NULL, 37, NULL, NULL, 156519),
(156520, '1.10.510.10-FF-002693', NULL, NULL, 157, NULL, NULL, 156520),
(156521, '3.60.15.10-FF-000224', NULL, 'Uncharacterized protein', 102, NULL, NULL, 156521),
(156522, '3.30.1380.20-FF-000019', NULL, 'Trafficking protein particle complex subunit', 193, NULL, NULL, 156522),
(156523, '1.20.1070.10-FF-002172', NULL, 'Predicted protein', 119, NULL, NULL, 156523),
(156524, '1.10.510.10-FF-004519', NULL, NULL, 112, NULL, NULL, 156524),
(156525, '1.20.272.10-FF-000085', NULL, NULL, 56, NULL, NULL, 156525),
(156526, '3.30.70.1350-FF-000028', NULL, NULL, 80, NULL, NULL, 156526),
(156527, '3.30.50.10-FF-000099', NULL, 'Peroxisome proliferator-activated receptor gamma', 72, NULL, NULL, 156527),
(156528, '3.40.228.10-FF-000032', NULL, 'Molybdopterin oxidoreductase', 234, NULL, NULL, 156528),
(156529, '3.40.50.1000-FF-000792', NULL, NULL, 180, NULL, NULL, 156529),
(156530, '2.30.130.10-FF-000002', NULL, '60S ribosome subunit biogenesis protein NIP7 homolog', 87, NULL, NULL, 156530),
(156531, '3.30.40.10-FF-001936', NULL, 'Uncharacterized protein', 70, NULL, NULL, 156531),
(156532, '3.30.450.20-FF-000632', NULL, 'Two component system histidine kinase', 133, NULL, NULL, 156532),
(156533, '1.25.40.10-FF-002139', NULL, 'Pentatricopeptide repeat domain 3', 270, NULL, NULL, 156533),
(156534, '3.40.850.10-FF-000360', NULL, 'Kinesin-like protein Nod', 324, NULL, NULL, 156534),
(156535, '3.40.50.1110-FF-000061', NULL, 'Expressed protein', 243, NULL, NULL, 156535),
(156536, '1.10.340.30-FF-000044', NULL, 'Endonuclease III', 119, NULL, NULL, 156536),
(156537, '2.60.40.150-FF-000597', NULL, 'Probable Ras GTPase-activating-like protein ngap', 171, NULL, NULL, 156537),
(156538, '3.30.300.180-FF-000011', NULL, 'Chromosomal replication initiator protein DnaA', 91, NULL, NULL, 156538),
(156539, '2.160.20.10-FF-000161', NULL, 'Polygalacturonase', 98, NULL, NULL, 156539),
(156540, '3.80.10.10-FF-000100', NULL, 'Si:dkey-11n14.1', 179, NULL, NULL, 156540),
(156541, '2.60.40.10-FF-003123', NULL, NULL, 93, NULL, NULL, 156541),
(156542, '1.10.10.200-FF-000003', NULL, 'Probable transcriptional regulatory protein YeeN', 77, NULL, NULL, 156542),
(156543, '1.10.10.60-FF-000595', NULL, 'Transcriptional regulator AraC/XylS family', 57, NULL, NULL, 156543),
(156544, '2.60.40.10-FF-000482', NULL, 'Down syndrome cell adhesion molecule like 1', 86, NULL, NULL, 156544),
(156545, '1.20.1080.10-FF-000020', NULL, 'Entomoglyceroporin 4, isoform A', 240, NULL, NULL, 156545),
(156546, '3.40.50.970-FF-000087', NULL, 'Thi3p', 201, NULL, NULL, 156546);
INSERT INTO "PUBLIC"."MODEL" VALUES
(156547, '1.10.357.50-FF-000032', NULL, 'Uncharacterized protein', 87, NULL, NULL, 156547),
(156548, '3.30.1490.100-FF-000015', NULL, 'DNA repair protein', 107, NULL, NULL, 156548),
(156549, '2.130.10.10-FF-003247', NULL, 'WD-40 repeat protein', 220, NULL, NULL, 156549),
(156550, '3.60.10.10-FF-000174', NULL, 'Endonuclease/exonuclease/phosphatase-like protein', 124, NULL, NULL, 156550),
(156551, '3.80.10.10-FF-003591', NULL, 'Uncharacterized protein', 132, NULL, NULL, 156551),
(156552, '1.10.10.160-FF-000002', NULL, 'DNA helicase', 74, NULL, NULL, 156552),
(156553, '1.10.1300.10-FF-000006', NULL, 'Phosphodiesterase 9A', 326, NULL, NULL, 156553),
(156554, '3.40.50.300-FF-003253', NULL, 'Chromatin remodeling 38', 274, NULL, NULL, 156554),
(156555, '1.25.40.10-FF-001037', NULL, 'Pentatricopeptide', 243, NULL, NULL, 156555),
(156556, '3.90.780.10-FF-000039', NULL, 'NAD 5''-nucleotidase', 223, NULL, NULL, 156556),
(156557, '2.40.10.170-FF-000017', NULL, 'ATP synthase subunit beta 1', 77, NULL, NULL, 156557),
(156558, '3.40.50.150-FF-000021', NULL, 'Ribosomal protein L11 methyltransferase', 193, NULL, NULL, 156558),
(156559, '2.60.40.10-FF-005006', NULL, NULL, 106, NULL, NULL, 156559),
(156560, '2.70.20.50-FF-000003', NULL, 'Matrix protein', 168, NULL, NULL, 156560),
(156561, '3.40.50.850-FF-000017', NULL, 'Nicotinamidase 1', 190, NULL, NULL, 156561),
(156562, '2.60.40.10-FF-004517', NULL, NULL, 88, NULL, NULL, 156562),
(156563, '3.30.230.10-FF-000113', NULL, 'DNA topoisomerase 2', 124, NULL, NULL, 156563),
(156564, '3.30.200.20-FF-000614', NULL, 'Os06g0689600 protein', 109, NULL, NULL, 156564),
(156565, '3.40.50.180-FF-000002', NULL, 'Protein-glutamate methylesterase/protein-glutamine glutaminase', 192, NULL, NULL, 156565),
(156566, '3.30.420.100-FF-000008', NULL, '50S ribosomal protein L18', 185, NULL, NULL, 156566),
(156567, '3.20.20.80-FF-000360', NULL, 'Amylo-alpha-1,6-glucosidase family protein', 235, NULL, NULL, 156567),
(156568, '3.40.190.10-FF-000859', NULL, 'Uncharacterized protein', 53, NULL, NULL, 156568),
(156569, '1.10.10.60-FF-000448', NULL, 'LIM/homeobox protein Lhx4', 60, NULL, NULL, 156569),
(156570, '3.30.160.60-FF-005309', NULL, NULL, 29, NULL, NULL, 156570),
(156571, '3.40.50.1820-FF-000414', NULL, 'Lysophospholipase, putative', 219, NULL, NULL, 156571),
(156572, '1.10.3720.10-FF-000145', NULL, 'Phosphate transport system permease protein PstA', 276, NULL, NULL, 156572),
(156573, '3.50.50.60-FF-000164', NULL, 'Peroxisomal sarcosine oxidase', 201, NULL, NULL, 156573),
(156574, '3.90.1600.10-FF-000048', NULL, 'DNA-directed DNA polymerase', 165, NULL, NULL, 156574),
(156575, '3.40.190.10-FF-000831', NULL, 'Uncharacterized protein', 134, NULL, NULL, 156575),
(156576, '3.40.50.150-FF-001123', NULL, NULL, 178, NULL, NULL, 156576),
(156577, '1.25.40.730-FF-000012', NULL, 'Clathrin heavy chain', 98, NULL, NULL, 156577),
(156578, '3.40.50.300-FF-008278', NULL, 'AGAP012862-PA', 37, NULL, NULL, 156578),
(156579, '1.20.58.1880-FF-000038', NULL, 'Uncharacterized protein', 54, NULL, NULL, 156579),
(156580, '1.20.58.60-FF-000636', NULL, 'Uncharacterized protein', 294, NULL, NULL, 156580),
(156581, '3.40.50.620-FF-000651', NULL, 'Valyl-tRNA synthetase', 113, NULL, NULL, 156581),
(156582, '3.30.200.20-FF-002238', NULL, 'AGC protein kinase', 33, NULL, NULL, 156582),
(156583, '3.40.50.170-FF-000027', NULL, 'Putative methionyl-tRNA formyltransferase', 142, NULL, NULL, 156583),
(156584, '2.10.110.10-FF-000163', NULL, 'LIM domain-containing protein ajuba isoform 2', 39, NULL, NULL, 156584),
(156585, '3.40.50.880-FF-000178', NULL, 'Imidazole glycerol phosphate synthase subunit HisH', 201, NULL, NULL, 156585),
(156586, '3.10.450.40-FF-000036', NULL, 'Amine oxidase', 128, NULL, NULL, 156586),
(156587, '1.20.1070.10-FF-001683', NULL, 'Zg09', 114, NULL, NULL, 156587),
(156588, '2.40.128.80-FF-000009', NULL, 'Encystation-specific protease', 128, NULL, NULL, 156588),
(156589, '1.25.10.10-FF-002637', NULL, 'Uncharacterized protein', 121, NULL, NULL, 156589),
(156590, '3.40.50.2000-FF-000165', NULL, 'Starch synthase, chloroplastic/amyloplastic', 220, NULL, NULL, 156590);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(156591, '2.60.120.10-FF-000787', NULL, 'Uncharacterized protein', 145, NULL, NULL, 156591),
(156592, '2.30.30.40-FF-000238', NULL, 'NADPH oxidase organizer 1', 65, NULL, NULL, 156592),
(156593, '3.10.450.50-FF-000039', NULL, 'Nuclear transport factor 2, putative', 104, NULL, NULL, 156593),
(156594, '3.40.390.10-FF-000133', NULL, 'ADAM metallopeptidase domain 3A', 208, NULL, NULL, 156594),
(156595, '2.120.10.30-FF-000168', NULL, 'S9 family peptidase', 152, NULL, NULL, 156595),
(156596, '1.10.510.10-FF-000484', NULL, 'Serine/threonine-protein kinase greatwall, putative', 73, NULL, NULL, 156596),
(156597, '3.40.190.10-FF-000298', NULL, 'Blast:Glutamate receptor ionotropic, kainate 2', 68, NULL, NULL, 156597),
(156598, '3.30.465.10-FF-000091', NULL, 'FAD binding oxidoreductase CpoX1', 97, NULL, NULL, 156598),
(156599, '3.30.70.330-FF-000216', NULL, 'RNA-binding protein BRN1 isoform X1', 93, NULL, NULL, 156599),
(156600, '2.10.25.10-FF-000701', NULL, 'tenascin isoform X1', 35, NULL, NULL, 156600),
(156601, '1.20.1070.10-FF-000401', NULL, 'Predicted protein', 319, NULL, NULL, 156601),
(156602, '4.10.1060.10-FF-000035', NULL, 'RanBP2-type zinc finger protein At1g67325', 40, NULL, NULL, 156602),
(156603, '1.25.40.10-FF-004909', NULL, 'Uncharacterized protein', 73, NULL, NULL, 156603),
(156604, '2.170.130.10-FF-000048', NULL, 'Heme receptor HasR', 127, NULL, NULL, 156604),
(156605, '1.25.10.10-FF-000485', NULL, 'RING-type E3 ubiquitin transferase', 314, NULL, NULL, 156605),
(156606, '1.10.3820.10-FF-000001', NULL, 'Cytochrome c-type protein', 179, NULL, NULL, 156606),
(156607, '3.30.200.40-FF-000007', NULL, 'HIT-like domain-containing protein', 107, NULL, NULL, 156607),
(156608, '3.40.50.410-FF-000060', NULL, 'Collagen, type VI, alpha 1', 207, NULL, NULL, 156608),
(156609, '3.30.160.60-FF-003157', NULL, 'Uncharacterized protein', 27, NULL, NULL, 156609),
(156610, '1.20.1310.10-FF-000145', NULL, NULL, 120, NULL, NULL, 156610),
(156611, '1.25.40.20-FF-001720', NULL, 'CASK-interacting protein 1', 38, NULL, NULL, 156611),
(156612, '2.120.10.30-FF-000494', NULL, 'Uncharacterized protein', 238, NULL, NULL, 156612),
(156613, '1.10.472.80-FF-000151', NULL, 'Rab-GTPase-TBC_domain_containing_protein_-_putative', 129, NULL, NULL, 156613),
(156614, '2.40.50.140-FF-000522', NULL, 'DNA-directed RNA polymerase III subunit, putative', 157, NULL, NULL, 156614),
(156615, '3.10.20.30-FF-000059', NULL, 'Threonyl-tRNA synthetase cytoplasmic, putative', 65, NULL, NULL, 156615),
(156616, '3.40.850.10-FF-000326', NULL, 'Kinesin-like protein', 368, NULL, NULL, 156616),
(156617, '3.30.40.10-FF-002190', NULL, 'Uncharacterized protein', 77, NULL, NULL, 156617),
(156618, '1.20.120.330-FF-000013', NULL, 'DNA-binding transcriptional regulator', 169, NULL, NULL, 156618),
(156619, '3.30.40.10-FF-001728', NULL, 'Vacuolar protein sorting-associated protein 11 homolog', 115, NULL, NULL, 156619),
(156620, '2.20.70.10-FF-000283', NULL, 'Uncharacterized protein', 40, NULL, NULL, 156620),
(156621, '1.25.10.10-FF-001210', NULL, 'Uncharacterized protein B20D17.200', 241, NULL, NULL, 156621),
(156622, '1.10.10.60-FF-000387', NULL, 'Replication termination factor 1', 53, NULL, NULL, 156622),
(156623, '3.30.413.10-FF-000010', NULL, 'Nitrite reductase large subunit', 127, NULL, NULL, 156623),
(156624, '2.70.170.10-FF-000299', NULL, 'Cholinergic receptor nicotinic alpha 10 subunit', 134, NULL, NULL, 156624),
(156625, '3.30.420.40-FF-000636', NULL, 'Cell division protein FtsA', 163, NULL, NULL, 156625),
(156626, '3.30.70.330-FF-000660', NULL, 'Pre-mRNA-splicing factor', 102, NULL, NULL, 156626),
(156627, '3.30.160.60-FF-002376', NULL, 'Zinc finger protein 236', 26, NULL, NULL, 156627),
(156628, '1.25.40.10-FF-002173', NULL, 'Tetratricopeptide repeat protein 30A', 229, NULL, NULL, 156628),
(156629, '3.30.1360.40-FF-000001', NULL, 'Ribosome-recycling factor', 75, NULL, NULL, 156629),
(156630, '1.10.510.10-FF-001265', NULL, 'Casein kinase I, putative', 322, NULL, NULL, 156630),
(156631, '1.10.400.10-FF-000094', NULL, 'Uncharacterized protein', 41, NULL, NULL, 156631);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(156632, '2.120.10.30-FF-000606', NULL, 'Dipeptidyl Peptidase Four (IV) family', 169, NULL, NULL, 156632),
(156633, '3.30.70.330-FF-000716', NULL, 'Eukaryotic translation initiation factor 3 subunit G', 140, NULL, NULL, 156633),
(156634, '2.60.120.590-FF-000013', NULL, '2-oxoglutarate-dependent dioxygenase family protein', 225, NULL, NULL, 156634),
(156635, '2.60.40.10-FF-004489', NULL, NULL, 178, NULL, NULL, 156635),
(156636, '3.90.640.10-FF-000063', NULL, 'Chromatin remodeling and histone acetyltransferase complexes subunit putative', 131, NULL, NULL, 156636),
(156637, '1.20.5.190-FF-000045', NULL, 'Sperm surface protein Sp17', 94, NULL, NULL, 156637),
(156638, '3.40.50.300-FF-004973', NULL, 'Uncharacterized protein', 220, NULL, NULL, 156638),
(156639, '3.40.50.300-FF-000639', NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily A containing DEAD/H box 1 isoform X1', 192, NULL, NULL, 156639),
(156640, '3.40.50.2300-FF-000165', NULL, 'Glutamate receptor ionotropic, kainate', 184, NULL, NULL, 156640),
(156641, '2.30.30.100-FF-000104', NULL, 'Small nuclear ribonucleoprotein Sm D2', 92, NULL, NULL, 156641),
(156642, '1.20.1410.10-FF-000001', NULL, 'Talin 2', 188, NULL, NULL, 156642),
(156643, '2.30.40.10-FF-000106', NULL, 'Formylmethanofuran dehydrogenase subunit A', 24, NULL, NULL, 156643),
(156644, '3.90.110.10-FF-000034', NULL, NULL, 135, NULL, NULL, 156644),
(156645, '3.30.160.60-FF-003039', NULL, 'Putative endonuclease or glycosyl hydrolase with C2H2-type zinc finger domain-containing protein', 59, NULL, NULL, 156645),
(156646, '3.90.660.10-FF-000031', NULL, 'Protein anon-37Cs-like Protein', 231, NULL, NULL, 156646),
(156647, '3.40.50.300-FF-004916', NULL, 'Protein CBG03934', 198, NULL, NULL, 156647),
(156648, '2.60.40.10-FF-000274', NULL, 'Tenascin C', 90, NULL, NULL, 156648),
(156649, '3.20.20.100-FF-000145', NULL, 'Uncharacterized protein', 273, NULL, NULL, 156649),
(156650, '3.30.710.10-FF-000015', NULL, 'BTB/POZ domain-containing protein 3', 159, NULL, NULL, 156650),
(156651, '3.90.1410.10-FF-000096', NULL, 'Uncharacterized protein', 299, NULL, NULL, 156651),
(156652, '3.30.70.60-FF-000036', NULL, '30S ribosomal protein S6', 100, NULL, NULL, 156652),
(156653, '3.90.170.10-FF-000010', NULL, 'Uncharacterized protein', 56, NULL, NULL, 156653),
(156654, '1.20.120.770-FF-000004', NULL, 'Amyloid beta (A4) precursor protein b', 105, NULL, NULL, 156654),
(156655, '3.40.1280.10-FF-000034', NULL, 'Putative small subunit rRNA processing factor', 196, NULL, NULL, 156655),
(156656, '3.40.50.80-FF-000170', NULL, 'Ferric reductase transmembrane component, putative', 204, NULL, NULL, 156656),
(156657, '3.40.50.1820-FF-001667', NULL, 'Non-ribosomal peptide synthase', 268, NULL, NULL, 156657),
(156658, '3.20.20.300-FF-000025', NULL, '1,4-beta-D-glucan glucohydrolase', 357, NULL, NULL, 156658),
(156659, '3.30.300.90-FF-000007', NULL, 'YAL044W-A-like protein', 97, NULL, NULL, 156659),
(156660, '3.30.760.10-FF-000052', NULL, 'Eukaryotic translation initiation factor 4E type 6', 179, NULL, NULL, 156660),
(156661, '1.10.10.10-FF-000366', NULL, 'COP9 signalosome complex subunit', 70, NULL, NULL, 156661),
(156662, '3.30.565.10-FF-000093', NULL, 'Histidine protein kinase SaeS', 156, NULL, NULL, 156662),
(156663, '1.25.40.20-FF-000995', NULL, 'Uncharacterized protein', 135, NULL, NULL, 156663),
(156664, '1.20.58.1780-FF-000008', NULL, 'Nuclear pore complex protein Nup154', 286, NULL, NULL, 156664),
(156665, '3.30.40.10-FF-000481', NULL, 'U-box domain containing 5', 72, NULL, NULL, 156665),
(156666, '1.25.40.10-FF-004264', NULL, 'Predicted protein', 220, NULL, NULL, 156666),
(156667, '2.60.40.1170-FF-000086', NULL, NULL, 36, NULL, NULL, 156667),
(156668, '3.30.160.60-FF-002847', NULL, 'Uncharacterized protein', 30, NULL, NULL, 156668),
(156669, '1.10.287.370-FF-000021', NULL, 'Prefoldin, alpha subunit', 122, NULL, NULL, 156669),
(156670, '3.30.1520.10-FF-000140', NULL, 'Uncharacterized protein', 67, NULL, NULL, 156670),
(156671, '1.10.8.20-FF-000003', NULL, 'Alpha-tocopherol transfer protein', 77, NULL, NULL, 156671);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(156672, '1.20.58.1770-FF-000005', NULL, 'RILP-like protein homolog isoform X1', 84, NULL, NULL, 156672),
(156673, '3.40.50.300-FF-002938', NULL, 'ATP-dependent RNA helicase DBP7', 301, NULL, NULL, 156673),
(156674, '3.40.140.10-FF-000087', NULL, 'Eukaryotic translation initiation factor 3 subunit H', 220, NULL, NULL, 156674),
(156675, '3.40.50.300-FF-003192', NULL, 'AAA family ATPase, putative', 175, NULL, NULL, 156675),
(156676, '3.30.160.60-FF-006119', NULL, NULL, 39, NULL, NULL, 156676),
(156677, '2.60.40.10-FF-000689', NULL, 'Immunoglobulin superfamily member 3', 120, NULL, NULL, 156677),
(156678, '3.40.50.1820-FF-001196', NULL, 'Uncharacterized protein', 138, NULL, NULL, 156678),
(156679, '3.90.70.10-FF-000671', NULL, 'Uncharacterized protein', 292, NULL, NULL, 156679),
(156680, '3.10.50.40-FF-000098', NULL, 'Protein export protein', 105, NULL, NULL, 156680),
(156681, '3.10.20.90-FF-000942', NULL, 'Uncharacterized protein', 73, NULL, NULL, 156681),
(156682, '3.40.50.1820-FF-000740', NULL, 'Uncharacterized protein', 205, NULL, NULL, 156682),
(156683, '3.30.200.20-FF-002446', NULL, 'Protein kinase, putative', 62, NULL, NULL, 156683),
(156684, '2.60.40.1180-FF-000089', NULL, 'Alpha-glucosidase B', 113, NULL, NULL, 156684),
(156685, '1.10.287.380-FF-000024', NULL, 'Valyl-tRNA synthetase 2, mitochondrial (putative)', 72, NULL, NULL, 156685),
(156686, '1.25.40.10-FF-000992', NULL, 'Pentatricopeptide repeat-containing protein', 106, NULL, NULL, 156686),
(156687, '1.10.400.10-FF-000037', NULL, 'Guanine nucleotide-binding protein alpha-14 subunit', 121, NULL, NULL, 156687),
(156688, '1.20.58.60-FF-000428', NULL, 'Chromosome 14 open reading frame 49', 137, NULL, NULL, 156688),
(156689, '3.30.750.24-FF-000031', NULL, 'Sulfate permease', 107, NULL, NULL, 156689),
(156690, '3.30.160.60-FF-000931', NULL, 'zinc finger protein 697', 29, NULL, NULL, 156690),
(156691, '3.90.980.20-FF-000024', NULL, NULL, 160, NULL, NULL, 156691),
(156692, '1.10.150.240-FF-000129', NULL, 'Probable phosphatase', 69, NULL, NULL, 156692),
(156693, '2.60.120.1560-FF-000006', NULL, 'Putative cell agglutination protein SPAC1348.08c', 210, NULL, NULL, 156693),
(156694, '1.25.40.570-FF-000003', NULL, '26S proteasome non-ATPase regulatory subunit 11', 377, NULL, NULL, 156694),
(156695, '3.40.50.300-FF-007143', NULL, 'Chromosome 10, whole genome shotgun sequence', 177, NULL, NULL, 156695),
(156696, '3.40.30.10-FF-000985', NULL, '2-hydroxychromene-2-carboxylate isomerase', 196, NULL, NULL, 156696),
(156697, '4.10.80.160-FF-000005', NULL, 'Predicted protein', 29, NULL, NULL, 156697),
(156698, '2.60.120.260-FF-000555', NULL, 'Clan SB, family S8, subtilisin-like serine peptidase', 50, NULL, NULL, 156698),
(156699, '1.20.5.780-FF-000008', NULL, 'FXYD domain-containing ion transport regulator', 67, NULL, NULL, 156699),
(156700, '1.20.80.10-FF-000061', NULL, 'Acyl-CoA binding protein, putative', 91, NULL, NULL, 156700),
(156701, '3.40.250.10-FF-000123', NULL, 'Rhodanese-like domain containing protein, putative', 139, NULL, NULL, 156701),
(156702, '1.20.1250.20-FF-000710', NULL, 'YMR221C-like protein', 408, NULL, NULL, 156702),
(156703, '3.30.420.110-FF-000045', NULL, 'DNA mismatch repair protein', 176, NULL, NULL, 156703),
(156704, '2.10.25.10-FF-001718', NULL, 'Uncharacterized protein', 40, NULL, NULL, 156704),
(156705, '3.40.50.920-FF-000033', NULL, '2-oxoglutarate oxidoreductase, alpha subunit', 110, NULL, NULL, 156705),
(156706, '1.25.10.10-FF-000693', NULL, 'RING-type E3 ubiquitin transferase', 102, NULL, NULL, 156706),
(156707, '3.10.100.10-FF-000119', NULL, 'C-type lectin domain family 12 member B', 206, NULL, NULL, 156707),
(156708, '2.40.100.10-FF-000094', NULL, 'Peptidyl-prolyl cis-trans isomerase', 179, NULL, NULL, 156708),
(156709, '1.25.40.10-FF-004943', NULL, 'Uncharacterized protein', 183, NULL, NULL, 156709),
(156710, '3.30.70.660-FF-000023', NULL, 'tRNA pseudouridine synthase', 185, NULL, NULL, 156710),
(156711, '3.60.15.10-FF-000163', NULL, 'Uncharacterized protein', 47, NULL, NULL, 156711),
(156712, '3.40.50.80-FF-000226', NULL, 'Uncharacterized protein', 166, NULL, NULL, 156712);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(156713, '3.30.70.330-FF-000508', NULL, 'Protein HRB1', 101, NULL, NULL, 156713),
(156714, '3.30.160.60-FF-001712', NULL, 'Neurotrophin receptor-interacting factor homolog', 34, NULL, NULL, 156714),
(156715, '1.25.10.10-FF-001002', NULL, 'Related to septation (SepH) gene', 346, NULL, NULL, 156715),
(156716, '3.40.50.300-FF-003545', NULL, 'Predicted protein', 229, NULL, NULL, 156716),
(156717, '3.60.20.10-FF-000028', NULL, 'Proteasome subunit alpha type', 233, NULL, NULL, 156717),
(156718, '3.30.70.1820-FF-000012', NULL, NULL, 77, NULL, NULL, 156718),
(156719, '1.20.1250.20-FF-001576', NULL, 'Uncharacterized protein', 375, NULL, NULL, 156719),
(156720, '3.40.30.10-FF-001238', NULL, 'Calsequestrin', 89, NULL, NULL, 156720),
(156721, '1.10.150.780-FF-000004', NULL, 'Vacuolar protein sorting-associated protein 16', 107, NULL, NULL, 156721),
(156722, '1.10.472.10-FF-000439', NULL, 'Cyclin-related protein FAM58A', 125, NULL, NULL, 156722),
(156723, '4.10.60.10-FF-000014', NULL, 'RNA-binding motif protein 4', 30, NULL, NULL, 156723),
(156724, '2.40.50.140-FF-000730', NULL, NULL, 76, NULL, NULL, 156724),
(156725, '3.90.190.10-FF-000281', NULL, 'Serine/threonine/tyrosine-interacting protein', 170, NULL, NULL, 156725),
(156726, '2.60.260.20-FF-000036', NULL, 'Type I HSP40 co-chaperone', 82, NULL, NULL, 156726),
(156727, '3.40.630.170-FF-000006', NULL, 'Glycylpeptide N-tetradecanoyltransferase', 204, NULL, NULL, 156727),
(156728, '3.30.420.40-FF-000844', NULL, 'Cell division protein FtsA', 79, NULL, NULL, 156728),
(156729, '1.25.40.180-FF-000066', NULL, 'Eukaryotic translation initiation factor', 236, NULL, NULL, 156729),
(156730, '1.10.10.10-FF-001237', NULL, 'Anaphase-promoting complex subunit 2', 84, NULL, NULL, 156730),
(156731, '1.20.144.10-FF-000029', NULL, 'Phospholipid phosphatase 4', 205, NULL, NULL, 156731),
(156732, '1.25.40.20-FF-000938', NULL, 'Ankyrin repeat protein, putative', 144, NULL, NULL, 156732),
(156733, '2.40.10.10-FF-000582', NULL, NULL, 46, NULL, NULL, 156733),
(156734, '1.10.510.10-FF-001001', NULL, 'Putative serine/threonine-protein kinase K06H7.1', 342, NULL, NULL, 156734),
(156735, '1.10.8.270-FF-000094', NULL, 'TBC domain containing protein', 99, NULL, NULL, 156735),
(156736, '3.40.1090.10-FF-000082', NULL, 'Lysophospholipase', 402, NULL, NULL, 156736),
(156737, '1.20.58.60-FF-000221', NULL, 'nesprin-1 isoform X1', 113, NULL, NULL, 156737),
(156738, '3.10.100.10-FF-000237', NULL, NULL, 84, NULL, NULL, 156738),
(156739, '1.10.150.770-FF-000001', NULL, 'Peptidoglycan D,D-transpeptidase FtsI', 73, NULL, NULL, 156739),
(156740, '2.20.70.10-FF-000075', NULL, 'Pre-mRNA-processing protein 40A isoform A', 45, NULL, NULL, 156740),
(156741, '3.80.10.10-FF-004315', NULL, 'Uncharacterized protein', 207, NULL, NULL, 156741),
(156742, '1.10.1070.11-FF-000039', NULL, 'Serine/threonine-protein kinase TOR', 184, NULL, NULL, 156742),
(156743, '2.120.10.80-FF-000194', NULL, 'Kelch repeat-containing protein 2', 173, NULL, NULL, 156743),
(156744, '3.40.50.2000-FF-000457', NULL, 'Lipopolysaccharide heptosyltransferase II', 148, NULL, NULL, 156744),
(156745, '3.30.710.10-FF-000223', NULL, 'SD05384p', 155, NULL, NULL, 156745),
(156746, '3.40.50.150-FF-000398', NULL, '3-demethylubiquinone-9 3-O-methyltransferase', 293, NULL, NULL, 156746),
(156747, '3.40.50.300-FF-006833', NULL, 'Uncharacterized protein', 268, NULL, NULL, 156747),
(156748, '1.10.287.70-FF-000043', NULL, 'Potassium channel subfamily K member 10 isoform 2', 314, NULL, NULL, 156748),
(156749, '3.40.640.10-FF-000288', NULL, 'Uncharacterized protein', 262, NULL, NULL, 156749),
(156750, '3.30.40.10-FF-002133', NULL, 'Uncharacterized protein', 101, NULL, NULL, 156750),
(156751, '3.30.200.20-FF-001311', NULL, 'PH-protein kinase domain containing protein', 88, NULL, NULL, 156751),
(156752, '3.30.2060.10-FF-000003', NULL, 'Penicillin-binding protein 1B', 90, NULL, NULL, 156752),
(156753, '3.30.830.10-FF-000288', NULL, 'Predicted protein', 158, NULL, NULL, 156753),
(156754, '1.10.287.3240-FF-000006', NULL, 'V-type proton ATPase subunit D', 209, NULL, NULL, 156754); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(156755, '2.40.10.10-FF-000464', NULL, NULL, 116, NULL, NULL, 156755),
(156756, '2.130.10.10-FF-002584', NULL, 'Uncharacterized protein', 315, NULL, NULL, 156756),
(156757, '2.160.20.10-FF-000335', NULL, 'Uncharacterized protein', 315, NULL, NULL, 156757),
(156758, '2.40.50.140-FF-000258', NULL, 'Phenylalanine--tRNA ligase beta subunit', 123, NULL, NULL, 156758),
(156759, '1.20.900.10-FF-000011', NULL, 'Intersectin 1', 198, NULL, NULL, 156759),
(156760, '2.30.29.30-FF-000344', NULL, 'Uncharacterized protein, isoform C', 117, NULL, NULL, 156760),
(156761, '3.40.50.80-FF-000018', NULL, 'NADPH--cytochrome P450 reductase', 167, NULL, NULL, 156761),
(156762, '3.30.160.60-FF-003303', NULL, 'Transcription factor IIIA', 29, NULL, NULL, 156762),
(156763, '1.10.238.20-FF-000033', NULL, 'GD21452', 96, NULL, NULL, 156763),
(156764, '3.40.50.2300-FF-001593', NULL, NULL, 118, NULL, NULL, 156764),
(156765, '2.130.10.10-FF-000993', NULL, 'Sperm associated antigen 16', 84, NULL, NULL, 156765),
(156766, '3.30.420.40-FF-000283', NULL, 'Actin-related protein 6', 91, NULL, NULL, 156766),
(156767, '2.10.110.10-FF-000337', NULL, 'Uncharacterized protein', 41, NULL, NULL, 156767),
(156768, '2.60.120.620-FF-000096', NULL, 'Predicted protein', 208, NULL, NULL, 156768),
(156769, '2.60.40.10-FF-001145', NULL, 'Jitterbug, isoform I', 97, NULL, NULL, 156769),
(156770, '3.30.310.80-FF-000033', NULL, 'Non-specific serine/threonine protein kinase', 104, NULL, NULL, 156770),
(156771, '2.40.160.10-FF-000070', NULL, 'Uncharacterized protein', 56, NULL, NULL, 156771),
(156772, '1.10.1070.11-FF-000096', NULL, 'Phosphatidylinositol 3-kinase-related protein kinase', 159, NULL, NULL, 156772),
(156773, '3.80.10.10-FF-001466', NULL, 'Leucine-rich repeat protein (LRRP), putative', 186, NULL, NULL, 156773),
(156774, '3.30.40.10-FF-002279', NULL, 'Cbl proto-oncogene-like 1, E3 ubiquitin protein ligase', 48, NULL, NULL, 156774),
(156775, '1.25.40.1040-FF-000023', NULL, 'mRNA 3''-end-processing protein RNA14', 382, NULL, NULL, 156775),
(156776, '2.30.42.10-FF-000330', NULL, 'HtrA-like serine protease', 99, NULL, NULL, 156776),
(156777, '3.30.70.270-FF-000029', NULL, 'DNA polymerase eta', 144, NULL, NULL, 156777),
(156778, '2.60.40.10-FF-005540', NULL, NULL, 43, NULL, NULL, 156778),
(156779, '3.30.160.60-FF-000723', NULL, 'PR domain zinc finger protein 4', 28, NULL, NULL, 156779),
(156780, '1.10.533.10-FF-000166', NULL, 'Melanoma differentiation associated gene 5', 95, NULL, NULL, 156780),
(156781, '3.90.550.10-FF-000702', NULL, 'Uncharacterized protein', 289, NULL, NULL, 156781),
(156782, '3.30.160.20-FF-000060', NULL, 'DEA(D/H)-box RNA helicase family protein', 87, NULL, NULL, 156782),
(156783, '2.60.120.590-FF-000070', NULL, 'AlkB, alkylation repair homolog', 126, NULL, NULL, 156783),
(156784, '2.70.170.10-FF-000092', NULL, 'Gamma-aminobutyric acid type A receptor alpha6 subunit', 70, NULL, NULL, 156784),
(156785, '1.20.1070.10-FF-001918', NULL, 'G protein-coupled receptor 141', 282, NULL, NULL, 156785),
(156786, '2.120.10.80-FF-000076', NULL, 'F-box/kelch-repeat protein At3g61590 family', 300, NULL, NULL, 156786),
(156787, '2.60.120.680-FF-000006', NULL, 'Acyl-CoA binding domain containing 3', 64, NULL, NULL, 156787),
(156788, '2.130.10.30-FF-000145', NULL, NULL, 219, NULL, NULL, 156788),
(156789, '3.30.1550.10-FF-000024', NULL, 'Uncharacterized protein', 39, NULL, NULL, 156789),
(156790, '2.60.40.60-FF-000890', NULL, 'Uncharacterized protein', 103, NULL, NULL, 156790),
(156791, '3.80.10.10-FF-000572', NULL, 'Ran GTPase-activating protein 1', 351, NULL, NULL, 156791),
(156792, '3.40.50.300-FF-006272', NULL, 'Mitochondrial Rho GTPase 1', 169, NULL, NULL, 156792),
(156793, '3.40.50.150-FF-000459', NULL, 'Methionine S-methyltransferase', 216, NULL, NULL, 156793),
(156794, '2.60.260.20-FF-000093', NULL, 'DNaJ domain (Prokaryotic heat shock protein)', 71, NULL, NULL, 156794),
(156795, '1.10.460.10-FF-000013', NULL, 'DNA topoisomerase', 105, NULL, NULL, 156795),
(156796, '1.25.40.10-FF-004735', NULL, 'Uncharacterized protein', 80, NULL, NULL, 156796);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(156797, '1.25.10.10-FF-002345', NULL, 'Uncharacterized protein', 288, NULL, NULL, 156797),
(156798, '3.30.420.10-FF-000004', NULL, 'DNA polymerase', 219, NULL, NULL, 156798),
(156799, '1.10.472.10-FF-000557', NULL, 'Uncharacterized protein', 69, NULL, NULL, 156799),
(156800, '3.90.650.10-FF-000002', NULL, 'Phosphoribosylformylglycinamidine synthase', 186, NULL, NULL, 156800),
(156801, '3.40.350.10-FF-000069', NULL, 'FACT complex subunit SPT16', 163, NULL, NULL, 156801),
(156802, '1.10.510.10-FF-000658', NULL, 'Protein CBG12184', 270, NULL, NULL, 156802),
(156803, '1.10.510.10-FF-003210', NULL, NULL, 143, NULL, NULL, 156803),
(156804, '3.40.50.880-FF-000206', NULL, 'Uncharacterized protein', 222, NULL, NULL, 156804),
(156805, '2.40.128.270-FF-000005', NULL, 'Slr0841 protein', 120, NULL, NULL, 156805),
(156806, '1.10.472.10-FF-000591', NULL, 'Predicted protein', 31, NULL, NULL, 156806),
(156807, '2.10.220.10-FF-000076', NULL, 'Proprotein convertase subtilisin/kexin type 5', 59, NULL, NULL, 156807),
(156808, '2.10.25.10-FF-001157', NULL, 'Putative Fibrillin-1', 36, NULL, NULL, 156808),
(156809, '3.30.40.10-FF-002072', NULL, 'Uncharacterized protein', 87, NULL, NULL, 156809),
(156810, '2.40.50.1000-FF-000012', NULL, '30S ribosomal protein S17', 107, NULL, NULL, 156810),
(156811, '3.30.2350.10-FF-000043', NULL, 'RNA-guided pseudouridylation complex pseudouridine synthase subunit Cbf5', 154, NULL, NULL, 156811),
(156812, '1.20.120.1150-FF-000007', NULL, 'Serine/threonine-protein phosphatase 2A activator', 124, NULL, NULL, 156812),
(156813, '1.20.1080.10-FF-000019', NULL, 'AQuaPorin or aquaglyceroporin related', 241, NULL, NULL, 156813),
(156814, '3.40.190.10-FF-000444', NULL, 'Accessory colonization factor AcfC', 116, NULL, NULL, 156814),
(156815, '3.40.50.300-FF-003753', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 244, NULL, NULL, 156815),
(156816, '3.30.460.10-FF-000040', NULL, 'tRNA nucleotidyltransferase cca1', 165, NULL, NULL, 156816),
(156817, '1.20.1250.20-FF-000502', NULL, 'Membrane transporter, putative', 205, NULL, NULL, 156817),
(156818, '3.40.50.150-FF-001510', NULL, NULL, 110, NULL, NULL, 156818),
(156819, '1.25.40.10-FF-002583', NULL, 'Crooked neck protein, putative / cell cycle protein', 121, NULL, NULL, 156819),
(156820, '3.30.160.60-FF-002786', NULL, 'SAGA-associated factor', 29, NULL, NULL, 156820),
(156821, '3.30.200.20-FF-002093', NULL, 'Uncharacterized protein', 81, NULL, NULL, 156821),
(156822, '1.20.120.1130-FF-000001', NULL, 'Vacuolar protein sorting-associated protein 28 homolog', 100, NULL, NULL, 156822),
(156823, '3.40.1800.30-FF-000002', NULL, 'Histone deacetylase complex subunit SAP30', 75, NULL, NULL, 156823),
(156824, '3.80.10.10-FF-001819', NULL, 'Centrosomal protein of 78 kDa', 129, NULL, NULL, 156824),
(156825, '3.40.50.2000-FF-000311', NULL, 'Lipopolysaccharide core biosynthesis protein', 188, NULL, NULL, 156825),
(156826, '3.40.50.12780-FF-000025', NULL, 'luciferin 4-monooxygenase', 412, NULL, NULL, 156826),
(156827, '1.10.1670.10-FF-000056', NULL, NULL, 54, NULL, NULL, 156827),
(156828, '3.30.200.20-FF-000294', NULL, 'Map kinase kinase', 106, NULL, NULL, 156828),
(156829, '3.30.230.10-FF-000028', NULL, 'DNA mismatch repair protein Mlh3', 149, NULL, NULL, 156829),
(156830, '3.40.50.300-FF-006979', NULL, 'Uncharacterized protein', 216, NULL, NULL, 156830),
(156831, '3.40.50.720-FF-002272', NULL, 'Uncharacterized protein', 26, NULL, NULL, 156831),
(156832, '3.30.60.290-FF-000005', NULL, 'YALI0D08756p', 49, NULL, NULL, 156832),
(156833, '4.10.40.50-FF-000002', NULL, 'Leucine-rich colipase-like 1', 36, NULL, NULL, 156833),
(156834, '1.10.418.10-FF-000095', NULL, 'Fimbrin', 117, NULL, NULL, 156834),
(156835, '3.20.20.60-FF-000079', NULL, 'Putative aldolase', 257, NULL, NULL, 156835),
(156836, '3.50.50.60-FF-000079', NULL, 'Flavin-containing monooxygenase', 312, NULL, NULL, 156836),
(156837, '1.25.40.20-FF-001248', NULL, 'Uncharacterized protein', 237, NULL, NULL, 156837),
(156838, '2.40.50.140-FF-000112', NULL, 'Exosome complex component RRP40', 77, NULL, NULL, 156838);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(156839, '3.40.50.11840-FF-000013', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 2', 92, NULL, NULL, 156839),
(156840, '2.130.10.10-FF-001510', NULL, 'Protein NEDD1', 68, NULL, NULL, 156840),
(156841, '2.130.10.10-FF-002904', NULL, 'Uncharacterized protein', 140, NULL, NULL, 156841),
(156842, '3.40.50.720-FF-002215', NULL, 'Enoyl-CoA hydratase and 3-hydroxyacyl CoA dehydrogenase', 155, NULL, NULL, 156842),
(156843, '2.60.40.10-FF-005040', NULL, NULL, 103, NULL, NULL, 156843),
(156844, '2.130.10.10-FF-005310', NULL, 'Uncharacterized protein', 207, NULL, NULL, 156844),
(156845, '3.30.200.20-FF-000406', NULL, 'PTI1-like tyrosine-protein kinase At3g15890', 104, NULL, NULL, 156845),
(156846, '2.60.120.260-FF-000145', NULL, 'Nuclear receptor 2C2-associated protein', 66, NULL, NULL, 156846),
(156847, '2.60.40.10-FF-004725', NULL, NULL, 82, NULL, NULL, 156847),
(156848, '2.160.20.10-FF-000127', NULL, 'Right_handed_beta_helix_region /Periplasmic_copper-binding_protein_(NosD)_-_putative', 139, NULL, NULL, 156848),
(156849, '3.60.10.10-FF-000320', NULL, 'Uncharacterized protein', 276, NULL, NULL, 156849),
(156850, '1.25.40.10-FF-001245', NULL, 'Dsf2p', 191, NULL, NULL, 156850),
(156851, '1.10.10.2330-FF-000013', NULL, NULL, 56, NULL, NULL, 156851),
(156852, '2.30.30.40-FF-000682', NULL, 'Tyrosine-protein kinase', 53, NULL, NULL, 156852),
(156853, '2.40.70.10-FF-000147', NULL, 'GPI-anchored aspartic protease', 210, NULL, NULL, 156853),
(156854, '1.25.40.10-FF-004382', NULL, 'Uncharacterized protein', 144, NULL, NULL, 156854),
(156855, '1.25.40.430-FF-000012', NULL, 'Uncharacterized protein', 144, NULL, NULL, 156855),
(156856, '3.90.180.10-FF-000044', NULL, 'Glutathione-dependent formaldehyde dehydrogenase', 209, NULL, NULL, 156856),
(156857, '3.60.10.10-FF-000410', NULL, 'Predicted protein', 316, NULL, NULL, 156857),
(156858, '1.10.1420.10-FF-000190', NULL, 'DNA mismatch repair protein Msh2, putative', 104, NULL, NULL, 156858),
(156859, '1.25.10.10-FF-001417', NULL, 'Unplaced genomic scaffold supercont1.18, whole genome shotgun sequence', 343, NULL, NULL, 156859),
(156860, '3.20.20.450-FF-000019', NULL, 'EAL domain-containing protein', 254, NULL, NULL, 156860),
(156861, '3.30.230.10-FF-000231', NULL, 'MUTL protein homolog 3', 93, NULL, NULL, 156861),
(156862, '2.60.40.10-FF-003500', NULL, NULL, 91, NULL, NULL, 156862),
(156863, '3.30.1120.90-FF-000010', NULL, 'Probable nucleosome assembly protein', 169, NULL, NULL, 156863),
(156864, '3.20.20.80-FF-000326', NULL, 'Glycoside hydrolase family 1 protein', 480, NULL, NULL, 156864),
(156865, '2.30.30.790-FF-000001', NULL, '50S ribosomal protein L19', 115, NULL, NULL, 156865),
(156866, '4.10.400.10-FF-000329', NULL, 'Lipophorin receptor 2, isoform A', 44, NULL, NULL, 156866),
(156867, '2.30.42.10-FF-000594', NULL, NULL, 104, NULL, NULL, 156867),
(156868, '3.30.230.10-FF-000085', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase, putative', 139, NULL, NULL, 156868),
(156869, '2.30.30.230-FF-000002', NULL, 'Fumarylacetoacetase', 121, NULL, NULL, 156869),
(156870, '3.40.1450.10-FF-000008', NULL, 'Predicted protein', 85, NULL, NULL, 156870),
(156871, '1.10.10.10-FF-001501', NULL, 'Transcriptional regulator, Crp/Fnr family', 84, NULL, NULL, 156871),
(156872, '3.30.230.70-FF-000142', NULL, 'Exosome complex exonuclease RRP46-like protein', 130, NULL, NULL, 156872),
(156873, '3.20.20.70-FF-000323', NULL, 'Fructose-bisphosphate aldolase A', 143, NULL, NULL, 156873),
(156874, '3.40.630.30-FF-000001', NULL, 'Histone acetyltransferase', 132, NULL, NULL, 156874),
(156875, '1.20.58.160-FF-000007', NULL, 'Hepatocyte growth factor-regulated tyrosine kinase substrate', 98, NULL, NULL, 156875),
(156876, '3.40.50.12780-FF-000082', NULL, 'Fatty-acid-CoA ligase FadD2', 399, NULL, NULL, 156876),
(156877, '1.25.40.20-FF-000585', NULL, 'Ankyrin repeat-containing protein ITN1', 54, NULL, NULL, 156877),
(156878, '3.90.190.20-FF-000019', NULL, 'UDP-N-acetylmuramate--L-alanyl-gamma-D-glutamyl-meso-2,6-diaminoheptandioate ligase', 138, NULL, NULL, 156878),
(156879, '1.10.10.60-FF-000948', NULL, NULL, 70, NULL, NULL, 156879);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(156880, '2.60.40.10-FF-000835', NULL, 'Hibris, isoform B', 107, NULL, NULL, 156880),
(156881, '3.90.190.10-FF-000073', NULL, 'Tyrosine-protein phosphatase CDC14', 149, NULL, NULL, 156881),
(156882, '3.40.50.10860-FF-000028', NULL, 'Bifunctional protein FolD', 149, NULL, NULL, 156882),
(156883, '2.60.40.60-FF-000682', NULL, 'Hedgehog protein', 104, NULL, NULL, 156883),
(156884, '2.70.150.10-FF-000236', NULL, 'Predicted protein', 123, NULL, NULL, 156884),
(156885, '3.40.50.300-FF-003135', NULL, 'Putative DEAD box RNA helicase', 174, NULL, NULL, 156885),
(156886, '3.30.70.330-FF-000008', NULL, 'Cytoplasmic polyadenylation element-binding 2 isoform X2', 94, NULL, NULL, 156886),
(156887, '3.30.470.20-FF-000015', NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', 144, NULL, NULL, 156887),
(156888, '3.30.1510.10-FF-000016', NULL, 'C-1-tetrahydrofolate synthase, cytoplasmic-like Protein', 96, NULL, NULL, 156888),
(156889, '3.30.160.60-FF-002168', NULL, 'Zinc finger protein 484', 28, NULL, NULL, 156889),
(156890, '3.40.50.720-FF-002362', NULL, 'Uncharacterized protein', 173, NULL, NULL, 156890),
(156891, '3.40.1410.10-FF-000034', NULL, 'GntR family transcriptional regulator', 177, NULL, NULL, 156891),
(156892, '2.60.40.150-FF-000479', NULL, 'Phosphatidylinositol 3-kinase VPS34-like', 135, NULL, NULL, 156892),
(156893, '1.20.58.150-FF-000004', NULL, 'ENTH domain protein', 152, NULL, NULL, 156893),
(156894, '1.25.10.10-FF-002845', NULL, 'Tubulin-specific chaperone D-like Protein', 173, NULL, NULL, 156894),
(156895, '3.40.630.40-FF-000004', NULL, 'N-acetylmuramoyl-L-alanine amidase CwlD', 199, NULL, NULL, 156895),
(156896, '3.10.20.90-FF-000678', NULL, 'Uncharacterized protein', 120, NULL, NULL, 156896),
(156897, '1.20.1250.20-FF-000148', NULL, 'Solute carrier family 22 member 2', 408, NULL, NULL, 156897),
(156898, '1.20.1070.10-FF-001475', NULL, 'Predicted protein', 209, NULL, NULL, 156898),
(156899, '3.40.50.300-FF-004563', NULL, 'Dynein heavy chain family protein', 122, NULL, NULL, 156899),
(156900, '3.80.10.10-FF-002281', NULL, 'Uncharacterized protein', 77, NULL, NULL, 156900),
(156901, '3.30.470.30-FF-000018', NULL, 'DNA ligase', 194, NULL, NULL, 156901),
(156902, '3.30.460.10-FF-000130', NULL, 'Poly(A) polymerase', 119, NULL, NULL, 156902),
(156903, '3.90.190.20-FF-000076', NULL, 'Uncharacterized protein', 150, NULL, NULL, 156903),
(156904, '3.30.160.60-FF-003191', NULL, 'LOC100124727 protein', 29, NULL, NULL, 156904),
(156905, '1.10.472.150-FF-000001', NULL, 'Protein MtfA', 124, NULL, NULL, 156905),
(156906, '3.40.47.10-FF-000052', NULL, 'Beta-ketoacyl-acyl-carrier-protein synthase III', 318, NULL, NULL, 156906),
(156907, '3.60.15.10-FF-000106', NULL, 'MoRTal germline', 170, NULL, NULL, 156907),
(156908, '3.10.129.10-FF-000292', NULL, 'Putative sterigmatocystin biosynthesis fatty acid synthase subunit beta', 202, NULL, NULL, 156908),
(156909, '3.30.160.60-FF-002876', NULL, 'Zgc:172128', 29, NULL, NULL, 156909),
(156910, '2.60.120.200-FF-000705', NULL, 'Os08g0514000 protein', 184, NULL, NULL, 156910),
(156911, '3.40.390.10-FF-000195', NULL, NULL, 226, NULL, NULL, 156911),
(156912, '1.10.150.20-FF-000324', NULL, 'Uncharacterized protein', 43, NULL, NULL, 156912),
(156913, '3.40.50.1700-FF-000024', NULL, 'Beta-hexosaminidase', 223, NULL, NULL, 156913),
(156914, '2.10.25.10-FF-001775', NULL, 'Stabilin 2', 34, NULL, NULL, 156914),
(156915, '4.10.240.10-FF-000120', NULL, 'Zcf18p', 85, NULL, NULL, 156915),
(156916, '2.60.40.10-FF-004635', NULL, NULL, 102, NULL, NULL, 156916),
(156917, '1.25.10.10-FF-003008', NULL, 'tRNA exportin, putative', 339, NULL, NULL, 156917),
(156918, '1.10.3180.10-FF-000002', NULL, 'Ethylene insensitive 3-like 1', 79, NULL, NULL, 156918),
(156919, '3.30.1010.10-FF-000023', NULL, 'Serine/threonine-protein kinase ATM', 160, NULL, NULL, 156919),
(156920, '1.20.1250.20-FF-001166', NULL, 'Membrane associated transporter protein', 219, NULL, NULL, 156920),
(156921, '1.25.40.20-FF-001512', NULL, 'Ankyrin repeat domain 17', 170, NULL, NULL, 156921),
(156922, '1.25.10.10-FF-000546', NULL, 'Armadillo repeat containing 4', 177, NULL, NULL, 156922);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(156923, '3.80.10.10-FF-001909', NULL, 'NLR family pyrin domain containing 9', 103, NULL, NULL, 156923),
(156924, '3.30.1050.10-FF-000031', NULL, 'Uncharacterized protein', 137, NULL, NULL, 156924),
(156925, '3.40.1190.20-FF-000002', NULL, 'Bifunctional protein HldE', 308, NULL, NULL, 156925),
(156926, '1.10.10.520-FF-000009', NULL, 'Ubiquitin activating enzyme, putative', 98, NULL, NULL, 156926),
(156927, '3.30.1490.430-FF-000001', NULL, 'mRNA-capping enzyme', 69, NULL, NULL, 156927),
(156928, '3.30.450.20-FF-000514', NULL, 'Uncharacterized protein', 107, NULL, NULL, 156928),
(156929, '1.20.120.1190-FF-000002', NULL, 'GTP-binding protein', 179, NULL, NULL, 156929),
(156930, '3.30.1330.90-FF-000020', NULL, 'D-3-phosphoglycerate dehydrogenase', 133, NULL, NULL, 156930),
(156931, '1.10.20.10-FF-000193', NULL, NULL, 142, NULL, NULL, 156931),
(156932, '2.40.170.20-FF-000045', NULL, 'TonB-dependent outer membrane receptor', 456, NULL, NULL, 156932),
(156933, '3.40.50.1000-FF-000674', NULL, NULL, 177, NULL, NULL, 156933),
(156934, '1.20.1080.10-FF-000109', NULL, 'Formate/nitrite transporter family protein, putative', 150, NULL, NULL, 156934),
(156935, '3.90.640.10-FF-000029', NULL, 'Heat shock protein 110', 83, NULL, NULL, 156935),
(156936, '3.90.150.10-FF-000008', NULL, 'Variant surface glycoprotein (VSG), putative', 190, NULL, NULL, 156936),
(156937, '3.10.20.90-FF-000588', NULL, 'Ubiquitin fold modifier 1', 66, NULL, NULL, 156937),
(156938, '1.10.510.10-FF-001473', NULL, 'Casein kinase I isoform alpha', 133, NULL, NULL, 156938),
(156939, '2.120.10.30-FF-000286', NULL, 'E3 ubiquitin-protein ligase TRIM71', 98, NULL, NULL, 156939),
(156940, '3.40.50.12230-FF-000029', NULL, 'Non-ribosomal peptide synthetase', 290, NULL, NULL, 156940),
(156941, '3.90.226.10-FF-000319', NULL, 'Uncharacterized protein', 52, NULL, NULL, 156941),
(156942, '2.130.10.10-FF-000398', NULL, 'U3 small nucleolar RNA-associated protein 15 homolog', 133, NULL, NULL, 156942),
(156943, '1.10.8.100-FF-000003', NULL, 'Ribosomal RNA small subunit methyltransferase A', 63, NULL, NULL, 156943),
(156944, '2.10.110.10-FF-000129', NULL, 'LIM domain-containing protein', 63, NULL, NULL, 156944),
(156945, '3.30.70.270-FF-000322', NULL, NULL, 146, NULL, NULL, 156945),
(156946, '1.10.10.10-FF-000574', NULL, 'GntR family transcriptional regulator', 78, NULL, NULL, 156946),
(156947, '3.90.1300.10-FF-000003', NULL, 'Amidase signature enzyme', 554, NULL, NULL, 156947),
(156948, '3.40.50.360-FF-000112', NULL, 'NAD(P)H dehydrogenase (Quinone) FQR1', 101, NULL, NULL, 156948),
(156949, '3.40.570.10-FF-000052', NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase 3', 54, NULL, NULL, 156949),
(156950, '1.10.10.500-FF-000003', NULL, 'prospero homeobox protein 1 isoform X2', 63, NULL, NULL, 156950),
(156951, '3.20.20.140-FF-000101', NULL, 'PHP domain-containing protein', 198, NULL, NULL, 156951),
(156952, '3.10.110.10-FF-000209', NULL, 'Predicted protein', 113, NULL, NULL, 156952),
(156953, '3.30.160.60-FF-004938', NULL, NULL, 58, NULL, NULL, 156953),
(156954, '2.20.100.10-FF-000227', NULL, 'spondin-1-like', 55, NULL, NULL, 156954),
(156955, '1.25.40.180-FF-000302', NULL, NULL, 85, NULL, NULL, 156955),
(156956, '3.50.50.60-FF-000225', NULL, 'Renalase', 142, NULL, NULL, 156956),
(156957, '3.50.50.60-FF-000282', NULL, 'Lipoamide dehydrogenase', 233, NULL, NULL, 156957),
(156958, '2.60.120.200-FF-000144', NULL, 'Beta-glucan synthesis-associated protein SKN1', 239, NULL, NULL, 156958),
(156959, '4.10.640.40-FF-000007', NULL, 'Feminization Of Germline', 55, NULL, NULL, 156959),
(156960, '3.40.50.300-FF-004473', NULL, 'Uncharacterized protein', 140, NULL, NULL, 156960),
(156961, '3.80.10.10-FF-002371', NULL, 'Uncharacterized protein', 210, NULL, NULL, 156961),
(156962, '3.40.50.1220-FF-000094', NULL, 'DHS-like NAD/FAD-binding domain-containing protein', 167, NULL, NULL, 156962),
(156963, '1.25.10.10-FF-002755', NULL, 'Importin beta-3 subunit, ran-binding protein 5', 650, NULL, NULL, 156963),
(156964, '1.10.600.10-FF-000075', NULL, 'Probable farnesyl diphosphate synthase DDB_G0268742', 388, NULL, NULL, 156964);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(156965, '3.40.225.10-FF-000025', NULL, 'Adducin 1', 145, NULL, NULL, 156965),
(156966, '3.75.10.10-FF-000028', NULL, 'Uncharacterized protein', 274, NULL, NULL, 156966),
(156967, '1.10.3380.30-FF-000023', NULL, 'Ski2 like RNA helicase', 161, NULL, NULL, 156967),
(156968, '3.40.50.720-FF-000063', NULL, 'NAD(P) transhydrogenase subunit alpha', 171, NULL, NULL, 156968),
(156969, '3.40.50.620-FF-000533', NULL, 'Tryptophanyl-tRNA synthetase, putative', 108, NULL, NULL, 156969),
(156970, '3.40.50.300-FF-002882', NULL, 'Irc20p', 224, NULL, NULL, 156970),
(156971, '2.130.10.10-FF-004293', NULL, 'F7H2.18 protein', 124, NULL, NULL, 156971),
(156972, '2.40.128.80-FF-000010', NULL, 'Cathepsin C', 85, NULL, NULL, 156972),
(156973, '3.40.50.2300-FF-000783', NULL, 'Uncharacterized protein', 172, NULL, NULL, 156973),
(156974, '1.10.486.10-FF-000027', NULL, 'RecBCD enzyme subunit RecB', 149, NULL, NULL, 156974),
(156975, '1.25.40.10-FF-003100', NULL, 'Serine/threonine-protein phosphatase', 160, NULL, NULL, 156975),
(156976, '2.130.10.10-FF-004383', NULL, 'Predicted protein', 75, NULL, NULL, 156976),
(156977, '2.60.40.10-FF-000982', NULL, 'Platelet-derived growth factor receptor beta', 92, NULL, NULL, 156977),
(156978, '1.10.510.10-FF-003064', NULL, NULL, 321, NULL, NULL, 156978),
(156979, '3.30.160.60-FF-002729', NULL, 'Zinc finger protein 546', 31, NULL, NULL, 156979),
(156980, '2.60.120.10-FF-000669', NULL, 'Uncharacterized protein', 106, NULL, NULL, 156980),
(156981, '2.60.200.40-FF-000010', NULL, 'Sphingosine kinase 1', 215, NULL, NULL, 156981),
(156982, '3.40.50.1820-FF-000532', NULL, 'hormone-sensitive lipase', 139, NULL, NULL, 156982),
(156983, '3.40.50.2000-FF-000047', NULL, 'Glycosyltransferase', 192, NULL, NULL, 156983),
(156984, '3.10.110.10-FF-000356', NULL, 'Uncharacterized protein', 51, NULL, NULL, 156984),
(156985, '2.130.10.10-FF-003101', NULL, 'Transducin/WD40 repeat-like superfamily protein', 302, NULL, NULL, 156985),
(156986, '2.70.98.10-FF-000081', NULL, 'Beta-galactosidase (Eurofung)', 303, NULL, NULL, 156986),
(156987, '3.60.10.10-FF-000056', NULL, 'LINE-1 reverse transcriptase-like protein', 237, NULL, NULL, 156987),
(156988, '1.10.630.10-FF-000200', NULL, 'Cytochrome P450, family 2, subfamily d, polypeptide 22', 95, NULL, NULL, 156988),
(156989, '3.30.160.60-FF-000577', NULL, 'zinc finger protein 692 isoform X2', 31, NULL, NULL, 156989),
(156990, '3.30.40.10-FF-000334', NULL, 'MATH and UCH domain protein', 54, NULL, NULL, 156990),
(156991, '1.20.80.10-FF-000027', NULL, 'Uncharacterized protein, isoform B', 126, NULL, NULL, 156991),
(156992, '1.20.1720.10-FF-000103', NULL, NULL, 123, NULL, NULL, 156992),
(156993, '3.90.550.10-FF-000556', NULL, 'Predicted protein', 196, NULL, NULL, 156993),
(156994, '1.20.1250.20-FF-001784', NULL, 'Predicted protein', 182, NULL, NULL, 156994),
(156995, '1.10.238.10-FF-000968', NULL, 'Os04g0681500 protein', 87, NULL, NULL, 156995),
(156996, '3.40.50.720-FF-000681', NULL, '2,4-dienoyl-CoA reductase', 266, NULL, NULL, 156996),
(156997, '2.30.130.40-FF-000045', NULL, 'Protein cereblon homolog-like Protein', 120, NULL, NULL, 156997),
(156998, '2.160.20.70-FF-000038', NULL, 'Uncharacterized protein', 163, NULL, NULL, 156998),
(156999, '1.10.730.10-FF-000169', NULL, 'Leucine--tRNA ligase', 27, NULL, NULL, 156999),
(157000, '3.30.70.330-FF-002307', NULL, NULL, 137, NULL, NULL, 157000),
(157001, '2.10.110.10-FF-000281', NULL, 'Filamin binding LIM protein 1', 49, NULL, NULL, 157001),
(157002, '2.60.120.200-FF-000234', NULL, 'Calsyntenin 3', 174, NULL, NULL, 157002),
(157003, '1.10.472.10-FF-000703', NULL, 'Uncharacterized protein', 79, NULL, NULL, 157003),
(157004, '1.20.1070.10-FF-000081', NULL, 'Vomeronasal type-1 receptor', 297, NULL, NULL, 157004),
(157005, '3.50.50.60-FF-000843', NULL, 'Amine oxidase', 115, NULL, NULL, 157005),
(157006, '4.10.770.10-FF-000002', NULL, 'Runt-related transcription factor', 42, NULL, NULL, 157006),
(157007, '2.20.100.10-FF-000020', NULL, 'Thrombospondin type 1 domain containing 7A', 55, NULL, NULL, 157007),
(157008, '1.25.40.20-FF-001158', NULL, 'Serine/threonine protein kinase', 136, NULL, NULL, 157008);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(157009, '2.60.40.1360-FF-000019', NULL, 'Lysosomal alpha-mannosidase, putative', 105, NULL, NULL, 157009),
(157010, '3.30.420.40-FF-000928', NULL, 'Predicted protein', 115, NULL, NULL, 157010),
(157011, '1.20.1250.20-FF-000564', NULL, 'YFL040W-like protein', 473, NULL, NULL, 157011),
(157012, '2.60.40.420-FF-000021', NULL, 'Extracellular dihydrogeodin oxidase/laccase', 152, NULL, NULL, 157012),
(157013, '3.40.190.10-FF-000270', NULL, 'HTH-type transcriptional regulator HdfR', 99, NULL, NULL, 157013),
(157014, '3.30.70.330-FF-000424', NULL, 'RNA-binding protein 48 isoform X4', 102, NULL, NULL, 157014),
(157015, '3.30.200.20-FF-002323', NULL, 'Uncharacterized protein', 87, NULL, NULL, 157015),
(157016, '3.40.50.261-FF-000033', NULL, 'Succinyl-CoA ligase beta subunit', 175, NULL, NULL, 157016),
(157017, '1.10.1300.10-FF-000063', NULL, 'Predicted protein', 181, NULL, NULL, 157017),
(157018, '2.60.120.260-FF-000408', NULL, 'Alpha-L-arabinofuranosidase A', 151, NULL, NULL, 157018),
(157019, '3.90.1150.220-FF-000008', NULL, 'Uncharacterized protein', 80, NULL, NULL, 157019),
(157020, '2.40.50.140-FF-000814', NULL, NULL, 125, NULL, NULL, 157020),
(157021, '3.30.2170.10-FF-000006', NULL, 'Endonuclease V', 197, NULL, NULL, 157021),
(157022, '3.60.40.10-FF-000119', NULL, 'Protein phosphatase PPM7, putative', 298, NULL, NULL, 157022),
(157023, '1.20.120.230-FF-000045', NULL, 'Alpha-catenin-like protein hmp-1', 210, NULL, NULL, 157023),
(157024, '3.80.10.10-FF-000128', NULL, 'Lutropin-choriogonadotropic hormone receptor', 329, NULL, NULL, 157024),
(157025, '2.30.36.70-FF-000002', NULL, 'actin-related protein 3 isoform X1', 43, NULL, NULL, 157025),
(157026, '3.30.559.10-FF-000123', NULL, 'ATP-dependent serine activating enzyme', 196, NULL, NULL, 157026),
(157027, '3.90.830.10-FF-000010', NULL, 'Sly1p', 177, NULL, NULL, 157027),
(157028, '2.130.10.10-FF-002668', NULL, 'Uncharacterized protein', 256, NULL, NULL, 157028),
(157029, '3.90.1150.210-FF-000005', NULL, 'F-actin-capping protein subunit beta', 177, NULL, NULL, 157029),
(157030, '3.30.565.10-FF-000536', NULL, 'Histidine kinase', 158, NULL, NULL, 157030),
(157031, '1.20.1310.10-FF-000229', NULL, NULL, 126, NULL, NULL, 157031),
(157032, '3.50.50.60-FF-000309', NULL, 'Unplaced genomic scaffold supercont1.13, whole genome shotgun sequence', 238, NULL, NULL, 157032),
(157033, '1.10.510.10-FF-002659', NULL, NULL, 165, NULL, NULL, 157033),
(157034, '1.20.1260.10-FF-000056', NULL, 'Aldehyde decarbonylase', 218, NULL, NULL, 157034),
(157035, '3.30.450.20-FF-000424', NULL, 'Sensor histidine kinase, PAS domain-containing', 134, NULL, NULL, 157035),
(157036, '1.20.1250.20-FF-000620', NULL, 'MFS transporter', 205, NULL, NULL, 157036),
(157037, '3.60.15.10-FF-000016', NULL, 'N-acyl-phosphatidylethanolamine-hydrolyzing phospholipase D, putative', 295, NULL, NULL, 157037),
(157038, '1.10.510.10-FF-001029', NULL, 'Os02g0194400 protein', 208, NULL, NULL, 157038),
(157039, '1.10.10.10-FF-000809', NULL, 'DNA-binding transcriptional regulator, MarR family', 160, NULL, NULL, 157039),
(157040, '3.40.50.300-FF-001544', NULL, 'ATP-dependent DNA helicase', 232, NULL, NULL, 157040),
(157041, '3.30.900.10-FF-000001', NULL, 'Autophagy-related protein 13', 193, NULL, NULL, 157041),
(157042, '2.60.40.1490-FF-000002', NULL, 'Histone chaperone ASF1, putative', 161, NULL, NULL, 157042),
(157043, '1.10.287.70-FF-000127', NULL, 'Calcium-activated outward-rectifying potassium channel 1', 96, NULL, NULL, 157043),
(157044, '2.70.170.10-FF-000119', NULL, 'Acetylcholine receptor subunit alpha', 84, NULL, NULL, 157044),
(157045, '2.60.120.620-FF-000011', NULL, 'Prolyl alpha subunit', 193, NULL, NULL, 157045),
(157046, '2.160.20.10-FF-000189', NULL, 'Tail spike protein', 514, NULL, NULL, 157046),
(157047, '3.40.50.300-FF-002972', NULL, 'ESX-3 secretion system protein EccC3', 239, NULL, NULL, 157047),
(157048, '1.20.58.1710-FF-000004', NULL, NULL, 77, NULL, NULL, 157048),
(157049, '3.40.50.150-FF-001038', NULL, NULL, 153, NULL, NULL, 157049),
(157050, '2.130.10.30-FF-000061', NULL, 'E3 ubiquitin-protein ligase UBR5', 199, NULL, NULL, 157050);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(157051, '1.10.533.10-FF-000289', NULL, 'Uncharacterized protein', 92, NULL, NULL, 157051),
(157052, '2.10.25.10-FF-000140', NULL, 'Transmembrane agrin', 52, NULL, NULL, 157052),
(157053, '3.40.50.300-FF-001393', NULL, 'Elongation factor G', 289, NULL, NULL, 157053),
(157054, '2.60.40.10-FF-002808', NULL, 'AGAP003656-PA', 97, NULL, NULL, 157054),
(157055, '1.20.1250.20-FF-001666', NULL, 'Uncharacterized protein', 99, NULL, NULL, 157055),
(157056, '3.30.230.130-FF-000058', NULL, 'Cullin family, putative', 164, NULL, NULL, 157056),
(157057, '3.30.1490.40-FF-000005', NULL, 'CD2 antigen cytoplasmic tail-binding protein 2', 69, NULL, NULL, 157057),
(157058, '3.90.550.50-FF-000192', NULL, 'Hexosyltransferase', 207, NULL, NULL, 157058),
(157059, '3.90.226.10-FF-000168', NULL, 'Interphotoreceptor retinoid-binding protein', 200, NULL, NULL, 157059),
(157060, '3.40.50.300-FF-002646', NULL, 'ATP-dependent RNA helicase MRH4, mitochondrial', 153, NULL, NULL, 157060),
(157061, '1.10.510.10-FF-003272', NULL, NULL, 104, NULL, NULL, 157061),
(157062, '3.10.180.10-FF-000068', NULL, '4-hydroxyphenylpyruvate dioxygenase', 176, NULL, NULL, 157062),
(157063, '1.10.3720.10-FF-000229', NULL, 'Sugar ABC transporter, permease protein', 217, NULL, NULL, 157063),
(157064, '3.30.160.60-FF-005517', NULL, NULL, 65, NULL, NULL, 157064),
(157065, '3.30.2090.10-FF-000005', NULL, 'Multidrug resistance protein MdtC', 93, NULL, NULL, 157065),
(157066, '1.20.5.190-FF-000168', NULL, NULL, 63, NULL, NULL, 157066),
(157067, '3.30.60.10-FF-000009', NULL, NULL, 36, NULL, NULL, 157067),
(157068, '1.20.120.1080-FF-000115', NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase DEAH10', 170, NULL, NULL, 157068),
(157069, '2.40.10.10-FF-000379', NULL, NULL, 99, NULL, NULL, 157069),
(157070, '1.10.1320.10-FF-000007', NULL, 'DNA-directed RNA polymerase', 330, NULL, NULL, 157070),
(157071, '2.60.40.10-FF-003270', NULL, 'GD22562', 96, NULL, NULL, 157071),
(157072, '1.25.10.10-FF-002429', NULL, 'Uncharacterized protein', 242, NULL, NULL, 157072),
(157073, '1.50.10.10-FF-000100', NULL, 'alpha-1,2-Mannosidase', 503, NULL, NULL, 157073),
(157074, '1.10.640.10-FF-000021', NULL, 'Uncharacterized protein', 66, NULL, NULL, 157074),
(157075, '1.20.1070.10-FF-000463', NULL, 'Substance-K receptor', 313, NULL, NULL, 157075),
(157076, '3.40.50.300-FF-006715', NULL, 'Predicted protein', 75, NULL, NULL, 157076),
(157077, '3.30.300.130-FF-000018', NULL, 'Phenylacetate-CoA oxygenase subunit PaaJ', 97, NULL, NULL, 157077),
(157078, '1.10.8.60-FF-000200', NULL, 'Ctf18p', 74, NULL, NULL, 157078),
(157079, '3.30.1120.30-FF-000014', NULL, 'Serine/threonine-protein kinase PLK', 95, NULL, NULL, 157079),
(157080, '1.20.1250.20-FF-001722', NULL, 'Uncharacterized protein', 168, NULL, NULL, 157080),
(157081, '2.40.30.130-FF-000009', NULL, 'Alanine--tRNA ligase, mitochondrial', 77, NULL, NULL, 157081),
(157082, '3.40.630.10-FF-000405', NULL, 'Peptidase M20 domain-containing protein 2', 209, NULL, NULL, 157082),
(157083, '1.20.1560.10-FF-000045', NULL, 'ATP-binding cassette subfamily C member 10', 336, NULL, NULL, 157083),
(157084, '3.40.50.300-FF-006917', NULL, 'Protein SMG9-like Protein', 235, NULL, NULL, 157084),
(157085, '3.30.70.330-FF-002515', NULL, NULL, 64, NULL, NULL, 157085),
(157086, '3.30.160.60-FF-001302', NULL, 'Zinc finger protein 618', 84, NULL, NULL, 157086),
(157087, '1.20.1540.10-FF-000038', NULL, 'Rhomboid protease ROM10', 196, NULL, NULL, 157087),
(157088, '3.30.590.10-FF-000049', NULL, 'Uncharacterized protein', 56, NULL, NULL, 157088),
(157089, '1.10.8.710-FF-000029', NULL, NULL, 70, NULL, NULL, 157089),
(157090, '3.80.10.10-FF-000510', NULL, 'Leucine-rich-repeats and calponin homology domain protein, isoform B', 253, NULL, NULL, 157090),
(157091, '3.10.28.10-FF-000048', NULL, 'Laglidadg endonuclease', 155, NULL, NULL, 157091),
(157092, '2.40.30.170-FF-000027', NULL, 'Nodulation protein nolF', 67, NULL, NULL, 157092),
(157093, '3.40.50.410-FF-000026', NULL, 'Collagen, type VI, alpha 1', 213, NULL, NULL, 157093),
(157094, '2.10.110.10-FF-000247', NULL, 'YALI0D18898p', 68, NULL, NULL, 157094);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(157095, '3.30.1490.30-FF-000002', NULL, NULL, 12, NULL, NULL, 157095),
(157096, '2.40.30.110-FF-000003', NULL, 'Aminomethyltransferase', 83, NULL, NULL, 157096),
(157097, '3.30.50.10-FF-000037', NULL, 'Nuclear hormone receptor FTZ-F1 beta', 101, NULL, NULL, 157097),
(157098, '3.40.50.2000-FF-000373', NULL, 'Chitobiosyldiphosphodolichol beta-mannosyltransferase, putative', 171, NULL, NULL, 157098),
(157099, '2.60.40.10-FF-000892', NULL, 'Plexin B3', 139, NULL, NULL, 157099),
(157100, '1.10.510.10-FF-001181', NULL, 'MAP kinase-interacting serine/threonine-protein kinase mnk-1', 218, NULL, NULL, 157100),
(157101, '3.10.20.10-FF-000019', NULL, 'Cell death inducing DFFA like effector c', 114, NULL, NULL, 157101),
(157102, '3.30.160.60-FF-001830', NULL, 'zinc finger protein 200', 27, NULL, NULL, 157102),
(157103, '3.30.420.40-FF-000726', NULL, 'AaceriACR184Cp', 136, NULL, NULL, 157103),
(157104, '1.25.40.10-FF-001801', NULL, 'Uncharacterized protein', 211, NULL, NULL, 157104),
(157105, '1.10.510.10-FF-002283', NULL, NULL, 206, NULL, NULL, 157105),
(157106, '2.40.50.140-FF-000612', NULL, '30S ribosomal protein S1', 86, NULL, NULL, 157106),
(157107, '2.160.10.10-FF-000071', NULL, 'Translation initiation factor eIF-2B subunit epsilon', 130, NULL, NULL, 157107),
(157108, '2.60.40.60-FF-000148', NULL, 'cadherin-13 isoform X1', 84, NULL, NULL, 157108),
(157109, '2.130.10.10-FF-000870', NULL, 'WD repeat-containing protein', 186, NULL, NULL, 157109),
(157110, '1.25.10.20-FF-000021', NULL, 'Uncharacterized protein', 296, NULL, NULL, 157110),
(157111, '3.40.1280.10-FF-000118', NULL, 'tRNA/rRNA methyltransferase', 171, NULL, NULL, 157111),
(157112, '3.30.450.20-FF-000222', NULL, 'Protein CBR-TAG-180', 169, NULL, NULL, 157112),
(157113, '1.10.150.810-FF-000002', NULL, 'Polymerase (DNA directed) kappa', 93, NULL, NULL, 157113),
(157114, '3.80.10.10-FF-002601', NULL, 'Vasorin a', 68, NULL, NULL, 157114),
(157115, '3.30.40.10-FF-001644', NULL, 'Snf2 histone linker PHD ring helicase, putative', 78, NULL, NULL, 157115),
(157116, '1.10.20.10-FF-000367', NULL, NULL, 113, NULL, NULL, 157116),
(157117, '2.130.10.10-FF-002994', NULL, 'MGC89952 protein', 198, NULL, NULL, 157117),
(157118, '2.60.40.10-FF-004579', NULL, NULL, 100, NULL, NULL, 157118),
(157119, '1.25.40.20-FF-001574', NULL, 'Ankyrin repeat domain 1b (cardiac muscle)', 40, NULL, NULL, 157119),
(157120, '3.30.450.40-FF-000228', NULL, 'Sensor histidine kinase, PAS and GAF domain-containing', 175, NULL, NULL, 157120),
(157121, '3.30.70.330-FF-000626', NULL, 'Zinc finger protein 638', 97, NULL, NULL, 157121),
(157122, '2.60.200.20-FF-000263', NULL, 'Uncharacterized protein', 54, NULL, NULL, 157122),
(157123, '3.30.70.330-FF-002841', NULL, NULL, 85, NULL, NULL, 157123),
(157124, '1.20.140.20-FF-000006', NULL, 'Pkp2p', 179, NULL, NULL, 157124),
(157125, '1.10.510.10-FF-000719', NULL, 'serine/threonine-protein kinase 16 isoform X2', 86, NULL, NULL, 157125),
(157126, '3.30.160.60-FF-002286', NULL, 'Zinc finger protein 112', 25, NULL, NULL, 157126),
(157127, '2.130.10.10-FF-002466', NULL, 'U3 small nucleolar RNA-associated protein, putative', 125, NULL, NULL, 157127),
(157128, '3.30.70.330-FF-000750', NULL, 'Protein terminal ear1 homolog', 87, NULL, NULL, 157128),
(157129, '1.20.140.10-FF-000003', NULL, 'isovaleryl-CoA dehydrogenase, mitochondrial', 145, NULL, NULL, 157129),
(157130, '1.25.40.20-FF-001804', NULL, 'E3 ubiquitin-protein ligase KEG', 165, NULL, NULL, 157130),
(157131, '3.30.40.10-FF-000716', NULL, 'E3 ubiquitin-protein ligase', 59, NULL, NULL, 157131),
(157132, '2.60.120.650-FF-000172', NULL, 'Uncharacterized protein', 162, NULL, NULL, 157132),
(157133, '3.90.550.20-FF-000031', NULL, 'Uncharacterized protein', 223, NULL, NULL, 157133),
(157134, '3.40.50.410-FF-000352', NULL, 'Uncharacterized protein', 89, NULL, NULL, 157134),
(157135, '2.60.40.150-FF-000682', NULL, 'Phosphoinositide phospholipase C', 130, NULL, NULL, 157135),
(157136, '3.40.50.300-FF-006980', NULL, 'Cobalt import ATP-binding protein CbiO', 216, NULL, NULL, 157136),
(157137, '1.10.357.10-FF-000076', NULL, 'Transcriptional regulator PhaD', 203, NULL, NULL, 157137);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(157138, '3.90.190.10-FF-000511', NULL, 'Uncharacterized protein', 138, NULL, NULL, 157138),
(157139, '3.30.1010.10-FF-000085', NULL, 'DNA damage-sensing protein kinase', 92, NULL, NULL, 157139),
(157140, '3.30.40.10-FF-000065', NULL, 'Ubiquitinyl hydrolase 1', 97, NULL, NULL, 157140),
(157141, '3.40.50.720-FF-002423', NULL, 'Uncharacterized protein', 131, NULL, NULL, 157141),
(157142, '1.25.10.10-FF-002906', NULL, 'Armadillo repeat containing 8', 126, NULL, NULL, 157142),
(157143, '3.80.10.10-FF-002106', NULL, 'Uncharacterized protein', 232, NULL, NULL, 157143),
(157144, '3.40.50.2300-FF-000249', NULL, 'Alkaline phosphatase synthesis transcriptional regulatory proteinphoP', 82, NULL, NULL, 157144),
(157145, '2.60.40.10-FF-005068', NULL, NULL, 101, NULL, NULL, 157145),
(157146, '3.80.10.10-FF-000454', NULL, 'F-box and leucine-rich repeat protein 22', 136, NULL, NULL, 157146),
(157147, '3.40.50.2000-FF-000575', NULL, 'GalNAc-alpha-(1->4)-GalNAc-alpha-(1->3)-diNAcBac-PP-undecaprenol alpha-1,4-N-acetyl-D-galactosaminyltransferase', 171, NULL, NULL, 157147),
(157148, '4.10.280.10-FF-000010', NULL, 'Scleraxis bHLH transcription factor', 63, NULL, NULL, 157148),
(157149, '3.40.47.10-FF-000259', NULL, NULL, 273, NULL, NULL, 157149),
(157150, '3.30.160.60-FF-001358', NULL, 'zinc finger protein 580', 24, NULL, NULL, 157150),
(157151, '2.60.40.10-FF-003000', NULL, 'Muscle M-line assembly protein unc-89', 90, NULL, NULL, 157151),
(157152, '2.60.40.10-FF-000717', NULL, 'interleukin-13 receptor subunit alpha-1 isoform X1', 94, NULL, NULL, 157152),
(157153, '2.30.29.30-FF-000221', NULL, 'Lysosomal trafficking regulator', 102, NULL, NULL, 157153),
(157154, '3.40.640.10-FF-000226', NULL, 'Alanine aminotransferase 2', 246, NULL, NULL, 157154),
(157155, '3.50.50.60-FF-000579', NULL, 'FAD dependent oxidoreductase', 231, NULL, NULL, 157155),
(157156, '3.30.470.20-FF-000105', NULL, 'Predicted protein', 151, NULL, NULL, 157156),
(157157, '1.50.10.20-FF-000103', NULL, 'Protein farnesyltransferase subunit beta', 330, NULL, NULL, 157157),
(157158, '3.30.230.10-FF-000321', NULL, 'DNA topoisomerase 2', 132, NULL, NULL, 157158),
(157159, '1.10.287.110-FF-000258', NULL, 'Predicted protein', 93, NULL, NULL, 157159),
(157160, '3.30.160.60-FF-002932', NULL, NULL, 31, NULL, NULL, 157160),
(157161, '2.120.10.30-FF-000578', NULL, 'Uncharacterized protein', 175, NULL, NULL, 157161),
(157162, '1.20.1070.10-FF-000137', NULL, 'neuropeptide FF receptor 2', 367, NULL, NULL, 157162),
(157163, '3.10.20.870-FF-000018', NULL, NULL, 79, NULL, NULL, 157163),
(157164, '2.60.40.10-FF-002488', NULL, 'Exocyst complex component 2', 93, NULL, NULL, 157164),
(157165, '1.25.40.10-FF-002673', NULL, 'Predicted protein', 291, NULL, NULL, 157165),
(157166, '1.20.5.470-FF-000005', NULL, 'Argininosuccinate synthase', 35, NULL, NULL, 157166),
(157167, '2.60.120.260-FF-000055', NULL, 'Reelin', 200, NULL, NULL, 157167),
(157168, '3.20.20.80-FF-000444', NULL, 'Glucan endo-1,3-beta-glucosidase 1', 195, NULL, NULL, 157168),
(157169, '1.10.490.160-FF-000012', NULL, NULL, 112, NULL, NULL, 157169),
(157170, '2.60.40.10-FF-002960', NULL, 'Protein lin-41', 132, NULL, NULL, 157170),
(157171, '3.30.930.10-FF-000205', NULL, 'Glycine--tRNA ligase', 282, NULL, NULL, 157171),
(157172, '4.10.1000.10-FF-000060', NULL, 'Probable E3 ubiquitin-protein ligase makorin-3', 62, NULL, NULL, 157172),
(157173, '3.40.50.300-FF-005136', NULL, 'ABC transporter family-like protein', 241, NULL, NULL, 157173),
(157174, '1.25.10.10-FF-002227', NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit', 399, NULL, NULL, 157174),
(157175, '3.90.25.10-FF-000010', NULL, 'NmrA-like family domain-containing protein 1', 93, NULL, NULL, 157175),
(157176, '3.40.50.80-FF-000136', NULL, 'Ferric reductase transmembrane component, putative', 181, NULL, NULL, 157176),
(157177, '3.30.160.60-FF-006299', NULL, NULL, 80, NULL, NULL, 157177),
(157178, '2.10.25.10-FF-001628', NULL, 'Uncharacterized protein', 50, NULL, NULL, 157178),
(157179, '1.20.5.460-FF-000002', NULL, 'Curved DNA-binding protein', 30, NULL, NULL, 157179);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(157180, '3.30.720.150-FF-000006', NULL, 'Uncharacterized protein', 126, NULL, NULL, 157180),
(157181, '2.10.60.10-FF-000041', NULL, 'Receptor protein serine/threonine kinase', 84, NULL, NULL, 157181),
(157182, '3.40.30.10-FF-000749', NULL, 'Putative frnE protein', 210, NULL, NULL, 157182),
(157183, '1.10.150.670-FF-000027', NULL, 'Probable crossover junction endonuclease EME2', 107, NULL, NULL, 157183),
(157184, '3.30.420.140-FF-000031', NULL, 'Transcription elongation factor spt6', 176, NULL, NULL, 157184),
(157185, '2.30.42.10-FF-000240', NULL, 'Golgi reassembly-stacking protein 2 isoform X2', 42, NULL, NULL, 157185),
(157186, '2.70.160.11-FF-000075', NULL, 'Arginine N-methyltransferase, putative', 171, NULL, NULL, 157186),
(157187, '3.40.50.1820-FF-000122', NULL, 'Vitellogenin-3-like Protein', 304, NULL, NULL, 157187),
(157188, '3.40.630.10-FF-000080', NULL, 'p-aminobenzoyl-glutamate hydrolase subunit A', 137, NULL, NULL, 157188),
(157189, '1.25.40.190-FF-000013', NULL, NULL, 151, NULL, NULL, 157189),
(157190, '2.30.30.1150-FF-000019', NULL, 'Uncharacterized protein', 166, NULL, NULL, 157190),
(157191, '3.40.30.10-FF-000013', NULL, 'Blast:Protein SCO1 homolog, mitochondrial', 183, NULL, NULL, 157191),
(157192, '1.10.238.10-FF-000766', NULL, 'Naked cuticle homolog 1', 156, NULL, NULL, 157192),
(157193, '2.60.40.10-FF-001706', NULL, 'Molecular chaperone FimC', 84, NULL, NULL, 157193),
(157194, '1.10.238.180-FF-000005', NULL, 'Uncharacterized protein', 47, NULL, NULL, 157194),
(157195, '1.25.10.10-FF-003211', NULL, 'Erythrocyte membrane-associated giant protein antigen 332 containing protein', 276, NULL, NULL, 157195),
(157196, '3.30.200.20-FF-000378', NULL, 'Mitogen-activated protein kinase', 125, NULL, NULL, 157196),
(157197, '1.10.10.60-FF-000982', NULL, NULL, 91, NULL, NULL, 157197),
(157198, '3.10.20.230-FF-000001', NULL, 'serine/threonine-protein kinase DCLK1 isoform X1', 114, NULL, NULL, 157198),
(157199, '1.25.40.180-FF-000010', NULL, 'Nuclear cap-binding protein subunit 1', 192, NULL, NULL, 157199),
(157200, '3.50.4.10-FF-000038', NULL, 'FI17836p1', 102, NULL, NULL, 157200),
(157201, '1.20.1420.30-FF-000070', NULL, 'Potassium-dependent sodium-calcium exchanger, putative', 102, NULL, NULL, 157201),
(157202, '2.160.20.10-FF-000245', NULL, 'Uncharacterized protein', 123, NULL, NULL, 157202),
(157203, '3.90.1010.10-FF-000020', NULL, 'Iron-sulfur cluster assembly protein', 135, NULL, NULL, 157203),
(157204, '1.10.287.2480-FF-000003', NULL, 'Fusion glycoprotein F0', 161, NULL, NULL, 157204),
(157205, '2.130.10.10-FF-004557', NULL, 'Uncharacterized protein', 216, NULL, NULL, 157205),
(157206, '2.60.40.10-FF-001027', NULL, 'Interleukin 1 receptor type 2', 114, NULL, NULL, 157206),
(157207, '3.30.70.330-FF-002190', NULL, NULL, 124, NULL, NULL, 157207),
(157208, '1.10.10.10-FF-001119', NULL, 'ATP-dependent helicase SGS1, putative', 109, NULL, NULL, 157208),
(157209, '1.10.3120.10-FF-000026', NULL, NULL, 204, NULL, NULL, 157209),
(157210, '3.30.1370.50-FF-000005', NULL, 'probable ATP-dependent RNA helicase YTHDC2', 80, NULL, NULL, 157210),
(157211, '1.20.58.60-FF-000344', NULL, 'SMAll', 70, NULL, NULL, 157211),
(157212, '3.30.20.10-FF-000007', NULL, NULL, 24, NULL, NULL, 157212),
(157213, '2.130.10.10-FF-005046', NULL, 'Dmx like 1', 285, NULL, NULL, 157213),
(157214, '3.40.50.620-FF-000117', NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', 314, NULL, NULL, 157214),
(157215, '3.10.100.10-FF-000327', NULL, NULL, 119, NULL, NULL, 157215),
(157216, '3.50.50.60-FF-000725', NULL, 'Pyridine nucleotide-disulfide oxidoreductase', 122, NULL, NULL, 157216),
(157217, '2.40.50.140-FF-000640', NULL, NULL, 114, NULL, NULL, 157217),
(157218, '2.60.40.10-FF-004433', NULL, NULL, 89, NULL, NULL, 157218),
(157219, '1.25.40.10-FF-004527', NULL, 'Os03g0168400 protein', 70, NULL, NULL, 157219),
(157220, '3.30.160.60-FF-005192', NULL, NULL, 21, NULL, NULL, 157220),
(157221, '1.25.40.10-FF-002403', NULL, 'Os06g0493801 protein', 142, NULL, NULL, 157221),
(157222, '1.10.3370.10-FF-000016', NULL, 'Protein translocase subunit SecY', 420, NULL, NULL, 157222);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(157223, '1.20.1560.10-FF-000545', NULL, 'Uncharacterized protein', 331, NULL, NULL, 157223),
(157224, '3.20.20.300-FF-000054', NULL, NULL, 213, NULL, NULL, 157224),
(157225, '3.30.70.330-FF-003004', NULL, NULL, 82, NULL, NULL, 157225),
(157226, '2.120.10.30-FF-000432', NULL, 'Uncharacterized protein', 135, NULL, NULL, 157226),
(157227, '3.40.50.2000-FF-000603', NULL, 'UDP-GlcNAc:ribostamycin N-acetylglucosaminyltransferase', 144, NULL, NULL, 157227),
(157228, '2.40.30.10-FF-000381', NULL, 'Elongation factor G 1', 114, NULL, NULL, 157228),
(157229, '3.40.50.300-FF-006890', NULL, 'GPN-loop GTPase 2', 244, NULL, NULL, 157229),
(157230, '2.60.40.2030-FF-000029', NULL, 'Na/Ca-exchange protein, isoform F', 110, NULL, NULL, 157230),
(157231, '3.10.120.10-FF-000036', NULL, 'Damage response protein, putative', 108, NULL, NULL, 157231),
(157232, '3.80.10.10-FF-003675', NULL, 'Podocan-like protein 1', 212, NULL, NULL, 157232),
(157233, '1.25.10.10-FF-003216', NULL, 'Uncharacterized protein', 270, NULL, NULL, 157233),
(157234, '3.40.250.10-FF-000241', NULL, 'Rhodanese homology domain pair protein', 167, NULL, NULL, 157234),
(157235, '3.40.50.10990-FF-000011', NULL, '3,4-dihydroxy-2-butanone 4-phosphate synthase', 128, NULL, NULL, 157235),
(157236, '1.25.40.770-FF-000001', NULL, 'Transcription initiation factor TFIID subunit 6', 199, NULL, NULL, 157236),
(157237, '3.90.550.10-FF-000348', NULL, 'Uncharacterized glycosyltransferase EpsJ', 248, NULL, NULL, 157237),
(157238, '2.40.30.10-FF-000139', NULL, 'Elongation factor Tu', 55, NULL, NULL, 157238),
(157239, '1.20.1050.40-FF-000004', NULL, 'Thimet-like oligopeptidase', 133, NULL, NULL, 157239),
(157240, '3.30.40.10-FF-001846', NULL, 'Putative RING zinc finger domain superfamily protein', 83, NULL, NULL, 157240),
(157241, '1.20.1070.10-FF-001626', NULL, 'Predicted protein', 142, NULL, NULL, 157241),
(157242, '3.30.710.10-FF-000133', NULL, 'Suppressor of kinetochore protein 1', 167, NULL, NULL, 157242),
(157243, '2.130.10.10-FF-004736', NULL, 'Predicted protein', 163, NULL, NULL, 157243),
(157244, '2.60.120.200-FF-000621', NULL, 'Uncharacterized protein', 140, NULL, NULL, 157244),
(157245, '3.30.70.870-FF-000030', NULL, 'Tetracycline resistance protein TetM', 78, NULL, NULL, 157245),
(157246, '2.40.50.140-FF-000584', NULL, '23S rRNA (Uracil-5-)-methyltransferase RumA', 64, NULL, NULL, 157246),
(157247, '3.30.160.60-FF-001212', NULL, 'Tripartite motif-containing protein 26', 52, NULL, NULL, 157247),
(157248, '3.30.70.360-FF-000023', NULL, 'Acetylornithine deacetylase ArgE', 161, NULL, NULL, 157248),
(157249, '1.25.40.20-FF-000259', NULL, 'E3 ubiquitin-protein ligase mind-bomb', 87, NULL, NULL, 157249),
(157250, '2.130.10.10-FF-004883', NULL, 'Uncharacterized protein', 319, NULL, NULL, 157250),
(157251, '3.40.720.10-FF-000199', NULL, 'Iduronate-2-sulfatase', 449, NULL, NULL, 157251),
(157252, '2.60.120.260-FF-000673', NULL, 'Beta-galactosidase', 111, NULL, NULL, 157252),
(157253, '1.10.10.10-FF-000782', NULL, 'ATP-dependent DNA helicase', 181, NULL, NULL, 157253),
(157254, '1.10.238.10-FF-000912', NULL, 'Phosphoinositide phospholipase C', 83, NULL, NULL, 157254),
(157255, '1.25.40.790-FF-000007', NULL, 'CCR4-NOT transcription complex subunit 1, putative', 108, NULL, NULL, 157255),
(157256, '1.20.1260.20-FF-000003', NULL, 'PPE family protein', 131, NULL, NULL, 157256),
(157257, '1.10.760.10-FF-000058', NULL, 'Nitric oxide reductase subunit C', 150, NULL, NULL, 157257),
(157258, '3.30.160.20-FF-000205', NULL, 'Uncharacterized protein', 102, NULL, NULL, 157258),
(157259, '1.25.40.10-FF-000256', NULL, 'Probable pre-mRNA splicing factor prp1', 211, NULL, NULL, 157259),
(157260, '3.40.190.10-FF-000921', NULL, 'Predicted protein', 75, NULL, NULL, 157260),
(157261, '3.10.20.90-FF-000386', NULL, 'Ubiquitin carboxyl-terminal hydrolase 26', 72, NULL, NULL, 157261),
(157262, '3.90.400.10-FF-000017', NULL, 'Uncharacterized protein', 44, NULL, NULL, 157262),
(157263, '1.10.510.10-FF-003300', NULL, NULL, 84, NULL, NULL, 157263),
(157264, '1.25.10.10-FF-002901', NULL, 'Uncharacterized protein', 134, NULL, NULL, 157264);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(157265, '2.60.120.650-FF-000082', NULL, 'Uncharacterized protein', 266, NULL, NULL, 157265),
(157266, '3.30.420.40-FF-000698', NULL, 'Uncharacterized protein', 242, NULL, NULL, 157266),
(157267, '2.60.40.10-FF-002634', NULL, 'Protein-tyrosine-phosphatase', 107, NULL, NULL, 157267),
(157268, '2.60.40.150-FF-000743', NULL, 'Uncharacterized protein', 97, NULL, NULL, 157268),
(157269, '2.40.50.140-FF-000292', NULL, 'Probable ATP-dependent DNA ligase', 121, NULL, NULL, 157269),
(157270, '1.10.510.10-FF-002962', NULL, 'Uncharacterized protein', 243, NULL, NULL, 157270),
(157271, '2.40.70.10-FF-000501', NULL, NULL, 109, NULL, NULL, 157271),
(157272, '1.10.287.70-FF-000543', NULL, 'YALI0D05841p', 133, NULL, NULL, 157272),
(157273, '3.40.30.10-FF-000659', NULL, 'Uncharacterized protein', 170, NULL, NULL, 157273),
(157274, '1.20.1560.10-FF-000601', NULL, 'Uncharacterized protein', 337, NULL, NULL, 157274),
(157275, '3.30.40.10-FF-001498', NULL, 'Uncharacterized protein', 77, NULL, NULL, 157275),
(157276, '3.40.50.300-FF-006687', NULL, 'Guanylate-binding family protein', 81, NULL, NULL, 157276),
(157277, '3.40.1110.10-FF-000404', NULL, NULL, 73, NULL, NULL, 157277),
(157278, '3.40.50.1820-FF-000650', NULL, 'Lysosomal Pro-X carboxypeptidase isoform A', 180, NULL, NULL, 157278),
(157279, '3.40.50.300-FF-002848', NULL, 'ATP-dependent helicase, DinG family', 257, NULL, NULL, 157279),
(157280, '3.40.50.2300-FF-000721', NULL, 'Guanylate cyclase', 124, NULL, NULL, 157280),
(157281, '3.40.50.300-FF-005226', NULL, 'ATP-dependent DNA helicase PIF5', 203, NULL, NULL, 157281),
(157282, '3.30.479.30-FF-000038', NULL, 'Putative stomatin-like 1', 125, NULL, NULL, 157282),
(157283, '3.30.160.60-FF-002937', NULL, 'zinc finger and BTB domain-containing protein 16-A isoform X1', 55, NULL, NULL, 157283),
(157284, '3.40.50.80-FF-000108', NULL, 'Terephthalate 1,2-dioxygenase, reductase component 2', 137, NULL, NULL, 157284),
(157285, '3.30.1540.20-FF-000026', NULL, NULL, 75, NULL, NULL, 157285),
(157286, '1.20.58.60-FF-000018', NULL, 'Spectrin beta chain', 108, NULL, NULL, 157286),
(157287, '1.10.630.10-FF-000700', NULL, 'Os02g0504000 protein', 129, NULL, NULL, 157287),
(157288, '1.20.58.460-FF-000002', NULL, 'O-GlcNAcase BT_4395', 182, NULL, NULL, 157288),
(157289, '1.10.10.820-FF-000009', NULL, 'unconventional myosin-XVIIIa isoform X2', 62, NULL, NULL, 157289),
(157290, '2.30.39.10-FF-000131', NULL, 'Angiotensinogen', 104, NULL, NULL, 157290),
(157291, '2.60.40.420-FF-000026', NULL, 'Coagulation factor VIII (Predicted)', 149, NULL, NULL, 157291),
(157292, '3.40.225.10-FF-000054', NULL, NULL, 185, NULL, NULL, 157292),
(157293, '3.40.50.1910-FF-000031', NULL, 'Abhd-3.1', 101, NULL, NULL, 157293),
(157294, '3.30.479.20-FF-000035', NULL, 'Elongation factor Ts', 91, NULL, NULL, 157294),
(157295, '1.20.58.900-FF-000033', NULL, 'Uncharacterized protein', 80, NULL, NULL, 157295),
(157296, '3.40.50.1820-FF-001752', NULL, 'Uncharacterized protein', 31, NULL, NULL, 157296),
(157297, '1.10.1520.10-FF-000051', NULL, 'Ribonuclease 3, putative', 106, NULL, NULL, 157297),
(157298, '3.30.540.10-FF-000007', NULL, '3''(2''),5''-bisphosphate nucleotidase CysQ', 147, NULL, NULL, 157298),
(157299, '3.30.160.60-FF-000987', NULL, 'Zinc finger protein 275', 28, NULL, NULL, 157299),
(157300, '3.30.160.60-FF-004793', NULL, NULL, 27, NULL, NULL, 157300),
(157301, '3.40.640.10-FF-000198', NULL, 'Dubious cystathionine gamma-lyase', 254, NULL, NULL, 157301),
(157302, '3.30.70.370-FF-000026', NULL, NULL, 125, NULL, NULL, 157302),
(157303, '1.20.1070.10-FF-001767', NULL, 'Putative vasopressin/oxytocin receptor', 330, NULL, NULL, 157303),
(157304, '3.40.50.1820-FF-000032', NULL, 'KAT8 regulatory NSL complex subunit 3 isoform X2', 183, NULL, NULL, 157304),
(157305, '1.20.58.1970-FF-000003', NULL, 'Conserved oligomeric Golgi complex component', 164, NULL, NULL, 157305),
(157306, '1.10.1420.10-FF-000189', NULL, 'Uncharacterized protein', 128, NULL, NULL, 157306),
(157307, '3.10.20.590-FF-000002', NULL, 'Leucyl-tRNA synthetase', 81, NULL, NULL, 157307),
(157308, '1.10.8.60-FF-000054', NULL, 'ATPase WRNIP1 isoform 1', 85, NULL, NULL, 157308);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(157309, '1.20.1070.10-FF-000047', NULL, 'Muscarinic acetylcholine receptor', 232, NULL, NULL, 157309),
(157310, '3.40.50.2300-FF-000575', NULL, 'Glutamate receptor, ionotropic, kainate 5', 93, NULL, NULL, 157310),
(157311, '1.20.1070.10-FF-001952', NULL, 'Uncharacterized protein', 207, NULL, NULL, 157311),
(157312, '2.40.10.120-FF-000025', NULL, 'PDZ domain-containing protein C23G3.12c', 194, NULL, NULL, 157312),
(157313, '1.10.10.800-FF-000003', NULL, 'Carboxymuconolactone decarboxylase', 89, NULL, NULL, 157313),
(157314, '1.10.510.10-FF-004284', NULL, NULL, 170, NULL, NULL, 157314),
(157315, '1.10.510.10-FF-001355', NULL, 'TKL protein kinase', 281, NULL, NULL, 157315),
(157316, '1.10.238.10-FF-001132', NULL, 'Uncharacterized protein', 158, NULL, NULL, 157316),
(157317, '3.40.50.720-FF-000473', NULL, 'NADP-dependent alcohol dehydrogenase', 151, NULL, NULL, 157317),
(157318, '2.120.10.30-FF-000522', NULL, 'Uncharacterized protein', 173, NULL, NULL, 157318),
(157319, '3.30.565.10-FF-000446', NULL, 'Sensory histidine protein kinase', 111, NULL, NULL, 157319),
(157320, '2.60.40.10-FF-001701', NULL, 'CD19 molecule', 108, NULL, NULL, 157320),
(157321, '3.30.1490.190-FF-000002', NULL, 'Zinc uptake transcriptional repressor', 63, NULL, NULL, 157321),
(157322, '1.10.1040.10-FF-000025', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(P)+]', 140, NULL, NULL, 157322),
(157323, '3.50.50.60-FF-000635', NULL, 'FAD dependent oxidoreductase', 193, NULL, NULL, 157323),
(157324, '1.25.40.10-FF-002055', NULL, 'Clathrin heavy chain 2', 71, NULL, NULL, 157324),
(157325, '1.10.510.10-FF-001501', NULL, 'Protein kinase, putative', 215, NULL, NULL, 157325),
(157326, '3.90.1800.10-FF-000030', NULL, 'Uncharacterized protein', 69, NULL, NULL, 157326),
(157327, '3.90.1310.10-FF-000032', NULL, 'Penicillin-binding protein 2', 169, NULL, NULL, 157327),
(157328, '3.40.50.880-FF-000094', NULL, 'Uncharacterized peptidase Lmo0363', 202, NULL, NULL, 157328),
(157329, '3.30.420.40-FF-000754', NULL, 'AGR099Cp', 29, NULL, NULL, 157329),
(157330, '3.40.50.1980-FF-000086', NULL, 'Possible binding-protein-dependent transport lipoprotein', 182, NULL, NULL, 157330),
(157331, '3.30.460.10-FF-000006', NULL, 'non-canonical poly(A) RNA polymerase PAPD5', 108, NULL, NULL, 157331),
(157332, '3.40.630.10-FF-000259', NULL, 'Transferrin receptor, putative', 128, NULL, NULL, 157332),
(157333, '2.130.10.10-FF-002758', NULL, 'Transcription factor TFIIIC complex subunit Tfc6, putative (AFU_orthologue AFUA_3G10380)', 254, NULL, NULL, 157333),
(157334, '2.40.70.10-FF-000355', NULL, NULL, 144, NULL, NULL, 157334),
(157335, '3.90.15.10-FF-000009', NULL, 'DNA topoisomerase I', 200, NULL, NULL, 157335),
(157336, '3.80.10.10-FF-000038', NULL, 'Biglycan', 308, NULL, NULL, 157336),
(157337, '3.30.559.30-FF-000039', NULL, 'Probable non-ribosomal peptide synthetase', 241, NULL, NULL, 157337),
(157338, '3.10.129.10-FF-000117', NULL, '3-hydroxyacyl-thioester dehydratase HtdY', 154, NULL, NULL, 157338),
(157339, '2.60.40.420-FF-000111', NULL, 'OSJNBa0028I23.23 protein', 90, NULL, NULL, 157339),
(157340, '3.40.190.10-FF-000360', NULL, 'ABC transporter lipoprotein BldKB', 288, NULL, NULL, 157340),
(157341, '1.25.40.20-FF-001630', NULL, 'Uncharacterized protein', 403, NULL, NULL, 157341),
(157342, '3.30.40.10-FF-000542', NULL, 'RING/U-box superfamily protein', 66, NULL, NULL, 157342),
(157343, '1.20.120.1750-FF-000069', NULL, 'RBR-type E3 ubiquitin transferase', 71, NULL, NULL, 157343),
(157344, '1.10.510.10-FF-001411', NULL, 'Calcium-dependent protein kinase 27', 184, NULL, NULL, 157344),
(157345, '1.10.8.100-FF-000032', NULL, 'Ribosomal RNA small subunit methyltransferase A', 65, NULL, NULL, 157345),
(157346, '3.30.519.10-FF-000031', NULL, NULL, 61, NULL, NULL, 157346),
(157347, '3.40.50.300-FF-007053', NULL, 'Uncharacterized protein', 198, NULL, NULL, 157347),
(157348, '1.20.210.10-FF-000032', NULL, 'Uncharacterized protein', 79, NULL, NULL, 157348),
(157349, '3.10.10.10-FF-000047', NULL, NULL, 23, NULL, NULL, 157349),
(157350, '1.25.40.20-FF-001282', NULL, 'Uncharacterized protein', 176, NULL, NULL, 157350);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(157351, '2.40.50.140-FF-000494', NULL, 'Suppressor of Ty 6 homolog', 64, NULL, NULL, 157351),
(157352, '3.90.550.10-FF-000438', NULL, 'Cellulose synthase-like protein G3', 212, NULL, NULL, 157352),
(157353, '1.20.910.10-FF-000040', NULL, 'Uncharacterized protein', 122, NULL, NULL, 157353),
(157354, '3.30.420.40-FF-001064', NULL, 'Uncharacterized protein', 188, NULL, NULL, 157354),
(157355, '1.10.8.1240-FF-000001', NULL, 'Rap guanine nucleotide exchange factor (GEF) 4', 54, NULL, NULL, 157355),
(157356, '1.10.10.10-FF-002047', NULL, 'Uncharacterized protein', 83, NULL, NULL, 157356),
(157357, '3.40.50.620-FF-000090', NULL, 'asparagine synthetase [glutamine-hydrolyzing]', 305, NULL, NULL, 157357),
(157358, '3.30.160.60-FF-000369', NULL, 'Zinc finger protein 384 like', 31, NULL, NULL, 157358),
(157359, '3.90.1150.170-FF-000009', NULL, 'Glutamate decarboxylase 1b', 132, NULL, NULL, 157359),
(157360, '2.10.25.10-FF-000263', NULL, 'Protein delta homolog 2', 35, NULL, NULL, 157360),
(157361, '3.10.110.10-FF-000148', NULL, 'RWD domain containing protein', 112, NULL, NULL, 157361),
(157362, '1.10.287.70-FF-000217', NULL, 'Sodium channel protein', 134, NULL, NULL, 157362),
(157363, '3.30.1010.10-FF-000141', NULL, 'PIKK family atypical protein kinase', 170, NULL, NULL, 157363),
(157364, '3.30.190.20-FF-000033', NULL, 'Mitochondrial 54S ribosomal protein MRPL1', 106, NULL, NULL, 157364),
(157365, '1.25.40.210-FF-000002', NULL, 'Telomeric repeat-binding factor 2', 200, NULL, NULL, 157365),
(157366, '3.10.580.10-FF-000031', NULL, 'Chloride channel protein', 161, NULL, NULL, 157366),
(157367, '3.80.10.10-FF-000280', NULL, 'oligodendrocyte-myelin glycoprotein', 74, NULL, NULL, 157367),
(157368, '3.40.1280.10-FF-000091', NULL, 'Os08g0506500 protein', 49, NULL, NULL, 157368),
(157369, '2.60.40.10-FF-003180', NULL, 'Heparan sulfate proteoglycan 2', 88, NULL, NULL, 157369),
(157370, '3.90.70.10-FF-000637', NULL, 'Uncharacterized protein', 115, NULL, NULL, 157370),
(157371, '3.40.50.300-FF-007704', NULL, 'Predicted protein', 102, NULL, NULL, 157371),
(157372, '2.60.40.60-FF-000564', NULL, 'Uncharacterized protein', 111, NULL, NULL, 157372),
(157373, '3.40.50.1220-FF-000032', NULL, 'NAD-dependent protein deacylase', 130, NULL, NULL, 157373),
(157374, '3.30.559.10-FF-000033', NULL, 'O-acyltransferase (WSD1-like) family protein', 173, NULL, NULL, 157374),
(157375, '1.10.238.10-FF-001222', NULL, 'Calmodulin-like 4a', 127, NULL, NULL, 157375),
(157376, '1.20.120.730-FF-000009', NULL, 'Vesicle coat component', 134, NULL, NULL, 157376),
(157377, '3.80.10.10-FF-004023', NULL, 'Uncharacterized protein', 146, NULL, NULL, 157377),
(157378, '3.40.630.10-FF-000315', NULL, 'Predicted protein', 124, NULL, NULL, 157378),
(157379, '3.80.10.10-FF-001382', NULL, 'F-box/LRR-repeat protein 15', 127, NULL, NULL, 157379),
(157380, '1.25.40.20-FF-001102', NULL, 'Putative ankyrin repeat domain family protein', 246, NULL, NULL, 157380),
(157381, '1.10.510.10-FF-000922', NULL, 'Protein kinase domain protein', 270, NULL, NULL, 157381),
(157382, '3.50.30.30-FF-000030', NULL, 'Peptide hydrolase', 128, NULL, NULL, 157382),
(157383, '3.30.200.20-FF-000086', NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', 90, NULL, NULL, 157383),
(157384, '3.30.460.20-FF-000009', NULL, 'Magnesium transport protein CorA', 118, NULL, NULL, 157384),
(157385, '3.90.640.10-FF-000147', NULL, 'Actin, putative', 98, NULL, NULL, 157385),
(157386, '1.25.40.10-FF-004590', NULL, 'Pentatricopeptide repeat-containing protein At3g49240, mitochondrial', 173, NULL, NULL, 157386),
(157387, '2.130.10.10-FF-004613', NULL, 'Predicted protein', 201, NULL, NULL, 157387),
(157388, '3.60.20.10-FF-000231', NULL, NULL, 103, NULL, NULL, 157388),
(157389, '2.130.10.10-FF-005102', NULL, 'Dynein intermediate chain 2, axonemal', 250, NULL, NULL, 157389),
(157390, '3.30.200.110-FF-000012', NULL, NULL, 80, NULL, NULL, 157390),
(157391, '3.20.20.450-FF-000020', NULL, 'Biofilm architecture maintenance protein MbaA', 262, NULL, NULL, 157391),
(157392, '3.40.50.2300-FF-000665', NULL, 'Response regulator VieA', 133, NULL, NULL, 157392);
INSERT INTO "PUBLIC"."MODEL" VALUES
(157393, '1.20.120.720-FF-000006', NULL, 'Unconventional myosin-Va', 145, NULL, NULL, 157393),
(157394, '3.40.50.720-FF-000506', NULL, 'Glycerol-3-phosphate dehydrogenase (NAD(P)(+))', 185, NULL, NULL, 157394),
(157395, '1.20.1070.10-FF-002115', NULL, 'Uncharacterized protein', 283, NULL, NULL, 157395),
(157396, '1.10.40.30-FF-000031', NULL, '3-carboxy-cis,cis-muconate cycloisomerase', 80, NULL, NULL, 157396),
(157397, '3.90.226.10-FF-000258', NULL, 'S41 family peptidase', 156, NULL, NULL, 157397),
(157398, '3.30.230.10-FF-000293', NULL, 'Uncharacterized protein', 136, NULL, NULL, 157398),
(157399, '3.10.350.10-FF-000019', NULL, 'Cell wall hydrolase', 63, NULL, NULL, 157399),
(157400, '1.20.58.1120-FF-000041', NULL, NULL, 167, NULL, NULL, 157400),
(157401, '1.10.443.10-FF-000018', NULL, 'Site-specific recombinase Flp', 268, NULL, NULL, 157401),
(157402, '2.60.200.20-FF-000268', NULL, 'Predicted protein', 152, NULL, NULL, 157402),
(157403, '1.25.40.10-FF-004348', NULL, 'High chlorophyll fluorescence3', 161, NULL, NULL, 157403),
(157404, '2.60.40.1120-FF-000088', NULL, 'Uncharacterized protein', 80, NULL, NULL, 157404),
(157405, '1.25.10.10-FF-002199', NULL, 'Ring assembly protein 3', 441, NULL, NULL, 157405),
(157406, '3.10.450.50-FF-000011', NULL, 'Nuclear transport factor 2, putative', 123, NULL, NULL, 157406),
(157407, '1.25.40.20-FF-000787', NULL, 'Uncharacterized protein', 146, NULL, NULL, 157407),
(157408, '1.10.135.10-FF-000016', NULL, 'Predicted protein', 67, NULL, NULL, 157408),
(157409, '3.80.10.10-FF-001758', NULL, 'NLR family member X1', 230, NULL, NULL, 157409),
(157410, '3.40.50.1480-FF-000003', NULL, 'Adenosylhomocysteinase', 305, NULL, NULL, 157410),
(157411, '1.10.340.70-FF-000033', NULL, 'Uncharacterized protein', 72, NULL, NULL, 157411),
(157412, '3.10.20.90-FF-000908', NULL, 'Tln1 protein', 28, NULL, NULL, 157412),
(157413, '4.10.260.10-FF-000008', NULL, 'G protein gamma subunit', 90, NULL, NULL, 157413),
(157414, '3.40.50.1380-FF-000029', NULL, 'Carbamoyl-phosphate synthase large chain', 135, NULL, NULL, 157414),
(157415, '3.40.50.1820-FF-001696', NULL, 'Uncharacterized protein', 191, NULL, NULL, 157415),
(157416, '2.170.130.10-FF-000020', NULL, 'TonB-dependent receptor', 132, NULL, NULL, 157416),
(157417, '2.160.20.10-FF-000099', NULL, 'Uncharacterized protein', 273, NULL, NULL, 157417),
(157418, '3.40.50.300-FF-007789', NULL, 'Uncharacterized protein', 49, NULL, NULL, 157418),
(157419, '3.30.200.20-FF-000794', NULL, 'Acyl-CoA dehydrogenase FadE36', 102, NULL, NULL, 157419),
(157420, '2.60.40.1660-FF-000019', NULL, 'Sodium/potassium-transporting ATPase subunit beta-3', 131, NULL, NULL, 157420),
(157421, '3.20.20.30-FF-000036', NULL, 'LuxA-related protein', 358, NULL, NULL, 157421),
(157422, '3.30.450.70-FF-000006', NULL, 'Trafficking particle complex subunit 1', 148, NULL, NULL, 157422),
(157423, '1.10.510.10-FF-003182', NULL, NULL, 154, NULL, NULL, 157423),
(157424, '3.30.70.330-FF-002425', NULL, NULL, 90, NULL, NULL, 157424),
(157425, '1.25.40.10-FF-000784', NULL, 'AraC family transcriptional regulator', 173, NULL, NULL, 157425),
(157426, '1.50.10.10-FF-000044', NULL, 'alpha-1,2-Mannosidase', 231, NULL, NULL, 157426),
(157427, '2.30.42.10-FF-000184', NULL, 'Uncharacterized protein, isoform B', 101, NULL, NULL, 157427),
(157428, '3.60.21.10-FF-000492', NULL, 'Serine/threonine-protein phosphatase with EF-hands', 361, NULL, NULL, 157428),
(157429, '3.30.160.60-FF-000459', NULL, 'Zinc finger with KRAB and SCAN domains 1', 28, NULL, NULL, 157429),
(157430, '3.30.200.20-FF-000176', NULL, 'Fructosamine kinase family protein', 92, NULL, NULL, 157430),
(157431, '3.40.50.1360-FF-000023', NULL, 'Glucosamine-6-phosphate isomerase, putative', 70, NULL, NULL, 157431),
(157432, '3.40.50.1370-FF-000026', NULL, 'Ornithine carbamoyltransferase', 127, NULL, NULL, 157432),
(157433, '2.60.40.150-FF-000687', NULL, 'Phosphoinositide phospholipase C', 169, NULL, NULL, 157433),
(157434, '3.50.50.60-FF-000107', NULL, 'Rab proteins geranylgeranyltransferase component A', 144, NULL, NULL, 157434);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(157435, '3.30.300.30-FF-000130', NULL, 'Peptide synthetase', 107, NULL, NULL, 157435),
(157436, '1.10.20.10-FF-000075', NULL, 'WGS project CABT00000000 data, contig 2.56', 75, NULL, NULL, 157436),
(157437, '2.30.30.40-FF-000295', NULL, 'Blast:Tyrosine-protein kinase Src-1', 72, NULL, NULL, 157437),
(157438, '3.30.450.80-FF-000009', NULL, 'Quorum-sensing transcriptional activator EsaR', 175, NULL, NULL, 157438),
(157439, '1.10.150.20-FF-000116', NULL, 'DNA ligase', 78, NULL, NULL, 157439),
(157440, '2.20.100.10-FF-000109', NULL, 'Spondin-1', 50, NULL, NULL, 157440),
(157441, '3.20.20.20-FF-000033', NULL, 'Methionine synthase', 97, NULL, NULL, 157441),
(157442, '3.30.60.20-FF-000159', NULL, 'Uncharacterized protein', 47, NULL, NULL, 157442),
(157443, '3.30.750.24-FF-000154', NULL, 'Anti-sigma factor antagonist', 116, NULL, NULL, 157443),
(157444, '1.10.1740.100-FF-000005', NULL, 'Histone-lysine N-methyltransferase', 100, NULL, NULL, 157444),
(157445, '1.20.58.1380-FF-000012', NULL, 'Uncharacterized protein', 96, NULL, NULL, 157445),
(157446, '3.90.70.10-FF-000289', NULL, 'Ubiquitin carboxyl-terminal hydrolase 26', 379, NULL, NULL, 157446),
(157447, '3.40.50.2300-FF-000047', NULL, 'PTS system mannitol-specific transporter subunit IICBA', 106, NULL, NULL, 157447),
(157448, '1.20.1560.10-FF-000040', NULL, 'Multidrug ABC transporter ATP-binding protein', 313, NULL, NULL, 157448),
(157449, '3.40.1090.10-FF-000109', NULL, 'Patatin', 77, NULL, NULL, 157449),
(157450, '1.25.10.10-FF-000428', NULL, 'Adaptor related protein complex 3 subunit beta 1', 391, NULL, NULL, 157450),
(157451, '1.50.10.20-FF-000047', NULL, 'Complement 4B (Chido blood group)', 312, NULL, NULL, 157451),
(157452, '3.30.70.330-FF-001498', NULL, NULL, 104, NULL, NULL, 157452),
(157453, '3.90.960.10-FF-000019', NULL, 'Proline--tRNA ligase', 138, NULL, NULL, 157453),
(157454, '2.60.40.60-FF-000474', NULL, 'GD20623', 116, NULL, NULL, 157454),
(157455, '1.10.238.10-FF-000289', NULL, 'Phosphoinositide phospholipase C', 81, NULL, NULL, 157455),
(157456, '3.30.450.40-FF-000138', NULL, 'Phosphodiesterase', 165, NULL, NULL, 157456),
(157457, '3.30.50.10-FF-000127', NULL, 'Xenobiotic receptor', 103, NULL, NULL, 157457),
(157458, '1.10.10.10-FF-001029', NULL, 'Related to RPC82-RNA polymerase III subunit C82', 73, NULL, NULL, 157458),
(157459, '2.30.29.30-FF-000075', NULL, 'unconventional myosin-VIIa', 99, NULL, NULL, 157459),
(157460, '2.60.120.200-FF-000205', NULL, 'MAM and LDL receptor class A domain-containing 1', 168, NULL, NULL, 157460),
(157461, '3.30.497.10-FF-000170', NULL, 'Uncharacterized protein', 18, NULL, NULL, 157461),
(157462, '3.90.1150.10-FF-000266', NULL, '3-oxo-glucose-6-phosphate:glutamate aminotransferase', 132, NULL, NULL, 157462),
(157463, '2.40.70.10-FF-000265', NULL, 'Aspartic peptidase domain-containing protein', 176, NULL, NULL, 157463),
(157464, '3.30.160.60-FF-001920', NULL, 'Zinc finger protein 19', 27, NULL, NULL, 157464),
(157465, '3.30.390.80-FF-000010', NULL, 'Uncharacterized protein', 87, NULL, NULL, 157465),
(157466, '3.40.140.70-FF-000003', NULL, 'Ubiquitin-like modifier-activating enzyme ATG7', 159, NULL, NULL, 157466),
(157467, '3.30.40.10-FF-000626', NULL, 'Transmembrane ubiquitin ligase 1', 80, NULL, NULL, 157467),
(157468, '3.30.450.30-FF-000079', NULL, 'Profilin', 138, NULL, NULL, 157468),
(157469, '1.10.10.10-FF-000956', NULL, 'HxlR family transcriptional regulator', 110, NULL, NULL, 157469),
(157470, '3.80.10.10-FF-004107', NULL, 'Uncharacterized protein', 119, NULL, NULL, 157470),
(157471, '2.60.120.200-FF-000149', NULL, 'Beta-glucan synthesis-associated protein KRE6', 287, NULL, NULL, 157471),
(157472, '1.10.630.10-FF-000341', NULL, 'Cytochrome P450, CYP85 clan', 439, NULL, NULL, 157472),
(157473, '3.40.50.300-FF-003337', NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', 170, NULL, NULL, 157473),
(157474, '1.25.10.10-FF-001092', NULL, 'Pumilio RNA-binding family member 3', 322, NULL, NULL, 157474),
(157475, '3.40.50.300-FF-001213', NULL, 'DNA repair helicase RAD25', 239, NULL, NULL, 157475);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(157476, '2.60.40.60-FF-000766', NULL, 'Cdh-4', 117, NULL, NULL, 157476),
(157477, '2.60.470.10-FF-000010', NULL, 'Pickpocket 13', 172, NULL, NULL, 157477),
(157478, '3.30.1140.32-FF-000001', NULL, '30S ribosomal protein S3', 116, NULL, NULL, 157478),
(157479, '3.50.50.60-FF-000551', NULL, 'Spermidine dehydrogenase, SpdH', 91, NULL, NULL, 157479),
(157480, '2.60.420.10-FF-000006', NULL, 'Cellobiose phosphorylase', 79, NULL, NULL, 157480),
(157481, '2.30.29.120-FF-000001', NULL, 'RTT106p Histone chaperone', 139, NULL, NULL, 157481),
(157482, '3.90.79.10-FF-000157', NULL, 'Hydrolase, NUDIX family', 170, NULL, NULL, 157482),
(157483, '3.30.70.330-FF-002751', NULL, NULL, 88, NULL, NULL, 157483),
(157484, '1.10.287.130-FF-000123', NULL, 'Probable two-component sensor', 108, NULL, NULL, 157484),
(157485, '2.30.42.10-FF-000094', NULL, 'Zinc metalloprotease', 95, NULL, NULL, 157485),
(157486, '2.10.25.10-FF-001573', NULL, 'Uncharacterized protein', 77, NULL, NULL, 157486),
(157487, '2.130.10.10-FF-002376', NULL, 'Uncharacterized protein', 111, NULL, NULL, 157487),
(157488, '2.60.490.10-FF-000011', NULL, 'Purinergic receptor P2X5-2', 147, NULL, NULL, 157488),
(157489, '1.10.3260.10-FF-000008', NULL, 'DNA ligase 4', 245, NULL, NULL, 157489),
(157490, '3.30.200.20-FF-000468', NULL, 'LysM receptor kinase 2', 92, NULL, NULL, 157490),
(157491, '2.60.40.10-FF-003505', NULL, NULL, 89, NULL, NULL, 157491),
(157492, '1.10.287.130-FF-000180', NULL, 'Two-component hybrid sensor and regulator', 69, NULL, NULL, 157492),
(157493, '3.40.50.720-FF-001783', NULL, 'Probable 2-dehydropantoate 2-reductase', 173, NULL, NULL, 157493),
(157494, '3.90.226.10-FF-000314', NULL, 'Uncharacterized protein', 81, NULL, NULL, 157494),
(157495, '3.30.450.20-FF-000132', NULL, 'Methyl-accepting chemotaxis protein PctA', 109, NULL, NULL, 157495),
(157496, '1.20.1250.20-FF-002363', NULL, 'Predicted protein', 57, NULL, NULL, 157496),
(157497, '2.60.40.10-FF-001414', NULL, 'Anosmin 1', 111, NULL, NULL, 157497),
(157498, '1.20.1250.20-FF-000272', NULL, 'Probable anion transporter 6, chloroplastic', 182, NULL, NULL, 157498),
(157499, '3.30.530.20-FF-000190', NULL, 'Os06g0526466 protein', 64, NULL, NULL, 157499),
(157500, '3.40.190.10-FF-000562', NULL, 'LysR family transcriptional regulator', 101, NULL, NULL, 157500),
(157501, '3.30.70.980-FF-000063', NULL, 'Uncharacterized protein', 59, NULL, NULL, 157501),
(157502, '3.30.160.60-FF-003101', NULL, 'Ras-responsive element-binding protein 1', 37, NULL, NULL, 157502),
(157503, '2.60.120.10-FF-000023', NULL, 'Mannose-6-phosphate isomerase', 184, NULL, NULL, 157503),
(157504, '1.20.1250.20-FF-000233', NULL, 'Solute carrier organic anion transporter family member', 367, NULL, NULL, 157504),
(157505, '1.25.40.10-FF-002908', NULL, 'Uncharacterized protein', 193, NULL, NULL, 157505),
(157506, '1.25.40.40-FF-000001', NULL, 'Cytochrome c oxidase subunit VI', 102, NULL, NULL, 157506),
(157507, '1.25.40.10-FF-003370', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial isoform A', 63, NULL, NULL, 157507),
(157508, '3.40.50.300-FF-005052', NULL, 'Predicted protein', 74, NULL, NULL, 157508),
(157509, '3.30.160.60-FF-004085', NULL, NULL, 29, NULL, NULL, 157509),
(157510, '2.130.10.10-FF-004467', NULL, 'Uncharacterized protein', 110, NULL, NULL, 157510),
(157511, '3.30.200.20-FF-000850', NULL, 'Protein kinase, putative', 102, NULL, NULL, 157511),
(157512, '1.10.510.10-FF-000866', NULL, 'Serine/threonine-protein kinase GA29083', 275, NULL, NULL, 157512),
(157513, '3.30.465.10-FF-000028', NULL, 'Related to ALO1-D-arabinono-1,4-lactone oxidase', 123, NULL, NULL, 157513),
(157514, '3.30.9.10-FF-000301', NULL, 'Uncharacterized protein', 136, NULL, NULL, 157514),
(157515, '3.50.50.60-FF-000080', NULL, 'Spermine oxidase', 231, NULL, NULL, 157515),
(157516, '3.10.129.10-FF-000090', NULL, 'Tol-pal system-associated acyl-CoA thioesterase', 148, NULL, NULL, 157516),
(157517, '3.30.70.3490-FF-000058', NULL, NULL, 128, NULL, NULL, 157517),
(157518, '2.60.120.20-FF-000026', NULL, 'Genome polyprotein', 263, NULL, NULL, 157518);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(157519, '3.40.50.620-FF-000207', NULL, 'Tryptophan--tRNA ligase', 251, NULL, NULL, 157519),
(157520, '3.10.330.10-FF-000046', NULL, 'Peroxisome biogenesis factor 1-like Protein', 79, NULL, NULL, 157520),
(157521, '3.30.2040.10-FF-000002', NULL, 'Uncharacterized protein', 113, NULL, NULL, 157521),
(157522, '2.60.40.820-FF-000017', NULL, 'TBR1 isoform 4', 107, NULL, NULL, 157522),
(157523, '3.30.70.330-FF-002223', NULL, NULL, 94, NULL, NULL, 157523),
(157524, '2.30.30.40-FF-000564', NULL, 'Uncharacterized protein', 43, NULL, NULL, 157524),
(157525, '3.40.50.1240-FF-000038', NULL, 'venom acid phosphatase Acph-1', 350, NULL, NULL, 157525),
(157526, '3.30.450.40-FF-000195', NULL, 'Two-component hybrid sensor and regulator', 173, NULL, NULL, 157526),
(157527, '1.10.132.10-FF-000009', NULL, 'DNA topoisomerase I', 171, NULL, NULL, 157527),
(157528, '1.20.1070.10-FF-001593', NULL, 'Vomeronasal type-1 receptor', 154, NULL, NULL, 157528),
(157529, '3.40.50.1760-FF-000020', NULL, NULL, 25, NULL, NULL, 157529),
(157530, '2.170.120.12-FF-000038', NULL, 'DNA-directed RNA polymerases II IV and V subunit 3', 90, NULL, NULL, 157530),
(157531, '3.30.40.10-FF-000211', NULL, 'TNF receptor-associated factor', 59, NULL, NULL, 157531),
(157532, '2.30.30.100-FF-000194', NULL, 'Bifunctional ligase/repressor BirA', 48, NULL, NULL, 157532),
(157533, '3.40.640.10-FF-000142', NULL, 'Putative ornithine aminotransferase RocD2', 86, NULL, NULL, 157533),
(157534, '3.30.40.10-FF-000155', NULL, 'RNA binding (RRM/RBD/RNP motifs) family protein', 77, NULL, NULL, 157534),
(157535, '1.20.920.20-FF-000015', NULL, 'Dynein beta chain, putative', 338, NULL, NULL, 157535),
(157536, '3.40.640.10-FF-000518', NULL, 'Selenocysteine lyase', 20, NULL, NULL, 157536),
(157537, '3.30.530.20-FF-000077', NULL, 'START domain containing protein', 202, NULL, NULL, 157537),
(157538, '1.20.1080.10-FF-000104', NULL, 'Aquaporin 8', 164, NULL, NULL, 157538),
(157539, '2.60.210.10-FF-000053', NULL, NULL, 197, NULL, NULL, 157539),
(157540, '1.25.10.10-FF-002671', NULL, 'Uncharacterized protein', 90, NULL, NULL, 157540),
(157541, '1.20.5.420-FF-000013', NULL, 'LD24721p', 50, NULL, NULL, 157541),
(157542, '3.90.1150.170-FF-000010', NULL, 'Zgc:112198', 72, NULL, NULL, 157542),
(157543, '3.30.450.20-FF-000076', NULL, 'Phosphate regulon sensor histidine kinase PhoR', 119, NULL, NULL, 157543),
(157544, '3.80.10.10-FF-000364', NULL, 'NLR family CARD domain containing 4', 396, NULL, NULL, 157544),
(157545, '1.10.132.30-FF-000021', NULL, 'DNA-directed RNA polymerase subunit', 125, NULL, NULL, 157545),
(157546, '1.25.40.10-FF-000817', NULL, 'Unplaced genomic scaffold supercont2.15, whole genome shotgun sequence', 152, NULL, NULL, 157546),
(157547, '1.10.10.750-FF-000022', NULL, 'GTPase-activating protein', 68, NULL, NULL, 157547),
(157548, '3.40.50.1000-FF-000876', NULL, NULL, 142, NULL, NULL, 157548),
(157549, '1.25.40.990-FF-000039', NULL, '26S proteasome non-ATPase regulatory subunit 8 homolog A', 63, NULL, NULL, 157549),
(157550, '3.30.70.330-FF-000278', NULL, 'Nucleolin', 91, NULL, NULL, 157550),
(157551, '1.10.490.10-FF-000043', NULL, 'Predicted protein', 126, NULL, NULL, 157551),
(157552, '3.40.50.1820-FF-000206', NULL, 'Acetyl xylan esterase', 318, NULL, NULL, 157552),
(157553, '1.25.40.10-FF-000458', NULL, 'Pentatricopeptide, putative, expressed', 153, NULL, NULL, 157553),
(157554, '3.40.190.10-FF-000449', NULL, 'Ionotropic receptor 40a', 146, NULL, NULL, 157554),
(157555, '2.170.300.10-FF-000084', NULL, 'Uncharacterized protein', 110, NULL, NULL, 157555),
(157556, '3.40.1190.20-FF-000064', NULL, 'Ribokinase', 316, NULL, NULL, 157556),
(157557, '2.170.270.10-FF-000176', NULL, 'Uncharacterized protein', 100, NULL, NULL, 157557),
(157558, '2.40.70.10-FF-000529', NULL, NULL, 208, NULL, NULL, 157558),
(157559, '3.90.550.50-FF-000225', NULL, 'Predicted protein', 126, NULL, NULL, 157559),
(157560, '1.10.510.10-FF-001703', NULL, 'Predicted protein', 209, NULL, NULL, 157560),
(157561, '2.20.20.110-FF-000006', NULL, 'DNA repair protein RAD4', 58, NULL, NULL, 157561);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(157562, '3.90.1640.10-FF-000023', NULL, 'Protein prune-like protein', 232, NULL, NULL, 157562),
(157563, '1.20.120.1240-FF-000006', NULL, 'Dynamin-1-like protein isoform 1', 120, NULL, NULL, 157563),
(157564, '3.40.50.300-FF-004647', NULL, 'Uncharacterized protein', 195, NULL, NULL, 157564),
(157565, '3.30.70.270-FF-000092', NULL, 'Genome polyprotein', 127, NULL, NULL, 157565),
(157566, '3.30.900.10-FF-000029', NULL, 'Predicted protein', 303, NULL, NULL, 157566),
(157567, '1.25.10.10-FF-000962', NULL, 'Importin alpha-1 subunit, putative', 251, NULL, NULL, 157567),
(157568, '1.25.40.10-FF-004617', NULL, 'Uncharacterized protein', 160, NULL, NULL, 157568),
(157569, '2.60.40.10-FF-004809', NULL, NULL, 98, NULL, NULL, 157569),
(157570, '1.10.150.20-FF-000032', NULL, 'meiotic recombination protein DMC1/LIM15 homolog', 81, NULL, NULL, 157570),
(157571, '3.30.110.20-FF-000023', NULL, 'Uncharacterized protein', 168, NULL, NULL, 157571),
(157572, '3.50.50.60-FF-000927', NULL, 'Probable SOLUBLE pyridine nucleotide transhydrogenase', 161, NULL, NULL, 157572),
(157573, '1.20.930.60-FF-000005', NULL, 'DUF89 domain protein', 117, NULL, NULL, 157573),
(157574, '3.90.70.10-FF-000345', NULL, 'Ubiquitin-specific peptidase 1', 260, NULL, NULL, 157574),
(157575, '1.20.1270.10-FF-000118', NULL, 'DnaK protein', 77, NULL, NULL, 157575),
(157576, '1.20.1740.10-FF-000082', NULL, 'Uncharacterized protein, isoform B', 153, NULL, NULL, 157576),
(157577, '1.20.58.400-FF-000006', NULL, 't-SNARE VTI1', 97, NULL, NULL, 157577),
(157578, '1.20.1070.10-FF-001391', NULL, 'Uncharacterized protein', 244, NULL, NULL, 157578),
(157579, '3.30.590.10-FF-000050', NULL, 'Uncharacterized protein', 44, NULL, NULL, 157579),
(157580, '3.30.70.400-FF-000001', NULL, 'Chemotaxis protein CheA', 80, NULL, NULL, 157580),
(157581, '3.40.50.2300-FF-000491', NULL, 'Branched-chain amino acid ABC transporter substrate-binding protein', 147, NULL, NULL, 157581),
(157582, '3.80.10.10-FF-001617', NULL, 'Nyctalopin', 107, NULL, NULL, 157582),
(157583, '3.30.1520.10-FF-000022', NULL, 'Kinesin family member 16B', 134, NULL, NULL, 157583),
(157584, '1.10.510.10-FF-002631', NULL, 'Uncharacterized protein', 346, NULL, NULL, 157584),
(157585, '2.40.50.100-FF-000179', NULL, 'Pyruvate carboxylase', 70, NULL, NULL, 157585),
(157586, '3.30.1240.10-FF-000040', NULL, 'Cof-type HAD-IIB family hydrolase', 98, NULL, NULL, 157586),
(157587, '1.10.472.10-FF-000501', NULL, 'RNA polymerase II holoenzyme cyclin-like subunit', 105, NULL, NULL, 157587),
(157588, '3.90.320.10-FF-000016', NULL, 'RecBCD enzyme subunit RecB', 284, NULL, NULL, 157588),
(157589, '2.40.160.50-FF-000031', NULL, 'AaceriAER403Cp', 345, NULL, NULL, 157589),
(157590, '3.40.50.300-FF-000847', NULL, 'helicase-like transcription factor isoform X3', 267, NULL, NULL, 157590),
(157591, '3.30.40.10-FF-002341', NULL, 'Histone-lysine N-methyltransferase', 93, NULL, NULL, 157591),
(157592, '3.40.120.10-FF-000086', NULL, 'Phosphoglucomutase/phosphomannomutase family protein', 108, NULL, NULL, 157592),
(157593, '3.40.50.300-FF-002556', NULL, 'Pentafunctional AROM polypeptide', 190, NULL, NULL, 157593),
(157594, '3.30.559.10-FF-000207', NULL, 'Putative peptide synthetase', 197, NULL, NULL, 157594),
(157595, '3.10.310.10-FF-000045', NULL, 'trans-L-3-hydroxyproline dehydratase-like', 150, NULL, NULL, 157595),
(157596, '1.25.40.10-FF-000930', NULL, 'Serine/threonine protein phosphatase type 5', 128, NULL, NULL, 157596),
(157597, '1.20.1070.10-FF-000373', NULL, 'Neuropeptide F receptor', 295, NULL, NULL, 157597),
(157598, '2.40.50.770-FF-000008', NULL, 'RMi1 (RMI1) Homolog', 163, NULL, NULL, 157598),
(157599, '3.40.190.10-FF-000505', NULL, 'Oligopeptide ABC transporter,oligopeptide-binding protein', 237, NULL, NULL, 157599),
(157600, '3.30.160.60-FF-000993', NULL, 'pH-response transcription factor pacC/RIM101', 72, NULL, NULL, 157600),
(157601, '3.90.226.10-FF-000084', NULL, 'Enoyl-CoA delta isomerase 2, mitochondrial', 206, NULL, NULL, 157601),
(157602, '3.80.10.10-FF-004164', NULL, 'Uncharacterized protein', 100, NULL, NULL, 157602);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(157603, '3.40.50.20-FF-000051', NULL, 'D-alanine--D-alanine ligase', 112, NULL, NULL, 157603),
(157604, '3.40.50.2300-FF-000811', NULL, NULL, 113, NULL, NULL, 157604),
(157605, '3.10.590.10-FF-000003', NULL, 'Thymocyte nuclear protein 1', 167, NULL, NULL, 157605),
(157606, '3.20.20.190-FF-000071', NULL, 'glycerophosphocholine phosphodiesterase GPCPD1', 303, NULL, NULL, 157606),
(157607, '1.20.1420.30-FF-000069', NULL, 'Uncharacterized protein', 234, NULL, NULL, 157607),
(157608, '3.30.870.10-FF-000178', NULL, 'Uncharacterized protein', 160, NULL, NULL, 157608),
(157609, '2.130.10.10-FF-003303', NULL, 'Heterotrimeric G protein beta subunit 1', 183, NULL, NULL, 157609),
(157610, '3.40.50.720-FF-000147', NULL, 'Reticulon-4-interacting protein 1 homolog, mitochondrial', 185, NULL, NULL, 157610),
(157611, '1.10.238.10-FF-000676', NULL, 'Uncharacterized protein', 67, NULL, NULL, 157611),
(157612, '1.10.287.3550-FF-000009', NULL, 'Uncharacterized protein', 93, NULL, NULL, 157612),
(157613, '1.10.3470.10-FF-000018', NULL, 'Iron-compound ABC transporter, permease protein', 326, NULL, NULL, 157613),
(157614, '1.20.5.550-FF-000001', NULL, 'Bifunctional protein PutA', 52, NULL, NULL, 157614),
(157615, '1.25.40.10-FF-001240', NULL, 'Clathrin heavy chain', 342, NULL, NULL, 157615),
(157616, '3.30.428.10-FF-000061', NULL, 'Uncharacterized protein', 133, NULL, NULL, 157616),
(157617, '3.30.200.20-FF-000322', NULL, 'Uncharacterized protein, isoform D', 90, NULL, NULL, 157617),
(157618, '2.20.110.10-FF-000048', NULL, 'Alsin homolog', 63, NULL, NULL, 157618),
(157619, '1.20.58.760-FF-000007', NULL, 'ATP-dependent zinc metalloprotease', 154, NULL, NULL, 157619),
(157620, '2.60.40.60-FF-000709', NULL, 'Cadherin-4', 100, NULL, NULL, 157620),
(157621, '2.60.120.200-FF-000060', NULL, 'Terribly reduced optic lobes, isoform B', 176, NULL, NULL, 157621),
(157622, '3.30.70.120-FF-000041', NULL, NULL, 101, NULL, NULL, 157622),
(157623, '1.25.40.10-FF-004056', NULL, 'Predicted protein', 167, NULL, NULL, 157623),
(157624, '1.25.40.20-FF-001243', NULL, 'Uncharacterized protein', 243, NULL, NULL, 157624),
(157625, '3.40.5.10-FF-000006', NULL, '50S ribosomal protein L9, chloroplastic', 60, NULL, NULL, 157625),
(157626, '3.40.47.10-FF-000136', NULL, NULL, 114, NULL, NULL, 157626),
(157627, '1.25.40.10-FF-004674', NULL, 'Pentatricopeptide repeat-containing protein At5g42450, mitochondrial', 110, NULL, NULL, 157627),
(157628, '2.30.30.30-FF-000090', NULL, '30S ribosomal protein S4e', 65, NULL, NULL, 157628),
(157629, '2.60.40.150-FF-000395', NULL, 'Predicted protein', 138, NULL, NULL, 157629),
(157630, '2.130.10.110-FF-000028', NULL, 'Uncharacterized protein', 100, NULL, NULL, 157630),
(157631, '3.40.50.300-FF-007412', NULL, 'ATP-binding cassette transporter, subfamily C, member 14, group MRP protein PpABCC14', 78, NULL, NULL, 157631),
(157632, '3.40.50.1000-FF-000348', NULL, 'HAD hydrolase', 100, NULL, NULL, 157632),
(157633, '1.10.10.10-FF-000776', NULL, 'Unplaced genomic scaffold supercont1.9, whole genome shotgun sequence', 70, NULL, NULL, 157633),
(157634, '3.40.50.2300-FF-000339', NULL, 'Transcriptional regulator PtxS', 175, NULL, NULL, 157634),
(157635, '3.30.160.20-FF-000121', NULL, 'Glycosyl hydrolase family protein', 81, NULL, NULL, 157635),
(157636, '2.60.40.10-FF-002718', NULL, 'Inositol polyphosphate 5-phosphatase, putative', 130, NULL, NULL, 157636),
(157637, '3.30.40.10-FF-002009', NULL, 'E3 ubiquitin-protein ligase', 50, NULL, NULL, 157637),
(157638, '2.60.40.10-FF-002398', NULL, 'Beat IIb', 109, NULL, NULL, 157638),
(157639, '3.40.630.30-FF-000647', NULL, 'N-acetyltransferase ats1', 164, NULL, NULL, 157639),
(157640, '1.10.287.110-FF-000168', NULL, 'BnaC04g52570D protein', 94, NULL, NULL, 157640),
(157641, '1.25.40.120-FF-000071', NULL, 'Predicted protein', 171, NULL, NULL, 157641),
(157642, '1.10.10.60-FF-001112', NULL, NULL, 65, NULL, NULL, 157642),
(157643, '2.60.40.640-FF-000087', NULL, 'Os03g0679100 protein', 72, NULL, NULL, 157643),
(157644, '3.10.110.10-FF-000064', NULL, 'RWD domain-containing protein 1', 121, NULL, NULL, 157644);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(157645, '2.130.10.10-FF-001123', NULL, 'Unplaced genomic scaffold supercont1.24, whole genome shotgun sequence', 355, NULL, NULL, 157645),
(157646, '1.10.533.10-FF-000290', NULL, 'Predicted protein', 91, NULL, NULL, 157646),
(157647, '3.20.20.80-FF-000096', NULL, 'Xylan alpha-1,2-glucuronidase', 329, NULL, NULL, 157647),
(157648, '1.10.2000.10-FF-000051', NULL, NULL, 140, NULL, NULL, 157648),
(157649, '3.80.10.10-FF-001584', NULL, 'RNI-like superfamily protein', 88, NULL, NULL, 157649),
(157650, '3.10.20.90-FF-000616', NULL, 'AGAP008530-PA', 112, NULL, NULL, 157650),
(157651, '2.30.30.30-FF-000089', NULL, 'Transcription termination/antitermination protein NusG', 59, NULL, NULL, 157651),
(157652, '1.10.510.10-FF-002485', NULL, NULL, 268, NULL, NULL, 157652),
(157653, '3.40.190.290-FF-000109', NULL, 'LysR family transcriptional regulator', 201, NULL, NULL, 157653),
(157654, '2.130.10.10-FF-002612', NULL, 'Nuclear pore complex protein nup43', 355, NULL, NULL, 157654),
(157655, '3.40.850.10-FF-000152', NULL, 'Kinesin-like protein', 365, NULL, NULL, 157655),
(157656, '3.40.50.150-FF-001802', NULL, NULL, 129, NULL, NULL, 157656),
(157657, '2.10.25.10-FF-001393', NULL, 'Delta-like protein', 37, NULL, NULL, 157657),
(157658, '1.10.472.10-FF-000355', NULL, 'Cyclin protein 2', 71, NULL, NULL, 157658),
(157659, '3.20.180.20-FF-000018', NULL, 'Dynein heavy chain, cytosolic, putative', 109, NULL, NULL, 157659),
(157660, '1.25.40.10-FF-002875', NULL, 'Protein NRDE2-like protein', 254, NULL, NULL, 157660),
(157661, '3.80.10.10-FF-003383', NULL, 'Uncharacterized protein', 264, NULL, NULL, 157661),
(157662, '1.25.40.10-FF-002347', NULL, 'Pentatricopeptide repeat-containing protein At5g15300', 109, NULL, NULL, 157662),
(157663, '2.40.50.100-FF-000089', NULL, 'Sugar ABC transporter ATP-binding protein', 26, NULL, NULL, 157663),
(157664, '3.40.390.10-FF-000072', NULL, 'Matrix metallopeptidase 25', 153, NULL, NULL, 157664),
(157665, '1.10.730.10-FF-000085', NULL, 'Leucyl-tRNA synthetase 2, mitochondrial', 185, NULL, NULL, 157665),
(157666, '3.10.100.10-FF-000035', NULL, 'C-type mannose receptor 2', 124, NULL, NULL, 157666),
(157667, '3.40.50.1760-FF-000019', NULL, NULL, 143, NULL, NULL, 157667),
(157668, '2.40.10.10-FF-000380', NULL, NULL, 102, NULL, NULL, 157668),
(157669, '3.40.850.10-FF-000096', NULL, 'Kinesin-like protein', 384, NULL, NULL, 157669),
(157670, '2.60.40.1170-FF-000081', NULL, NULL, 101, NULL, NULL, 157670),
(157671, '1.10.220.30-FF-000012', NULL, 'Flagellar motor switch protein FliG', 98, NULL, NULL, 157671),
(157672, '1.20.5.170-FF-000213', NULL, 'Galactose-responsive transcription factor', 50, NULL, NULL, 157672),
(157673, '3.40.50.10240-FF-000022', NULL, 'Thiamine pyrophosphokinase', 154, NULL, NULL, 157673),
(157674, '3.90.950.10-FF-000047', NULL, 'Uncharacterized protein', 141, NULL, NULL, 157674),
(157675, '3.90.640.10-FF-000001', NULL, 'Actin, muscle', 92, NULL, NULL, 157675),
(157676, '2.130.10.10-FF-001033', NULL, 'Pre-mRNA-processing factor 19 2', 325, NULL, NULL, 157676),
(157677, '2.60.120.590-FF-000075', NULL, 'Uncharacterized protein', 62, NULL, NULL, 157677),
(157678, '3.90.70.10-FF-000676', NULL, 'Uncharacterized protein', 273, NULL, NULL, 157678),
(157679, '3.30.70.330-FF-000188', NULL, 'Negative elongation factor complex member E', 87, NULL, NULL, 157679),
(157680, '1.10.260.100-FF-000033', NULL, 'TPR Domain containing protein', 53, NULL, NULL, 157680),
(157681, '2.10.110.10-FF-000045', NULL, 'LIM domain-binding protein 1 isoform X1', 62, NULL, NULL, 157681),
(157682, '1.20.1280.290-FF-000032', NULL, 'Sugar transporter SWEET', 88, NULL, NULL, 157682),
(157683, '3.40.50.300-FF-006356', NULL, 'Uncharacterized protein', 141, NULL, NULL, 157683),
(157684, '2.60.40.10-FF-000690', NULL, 'Cytokine receptor like factor 1', 93, NULL, NULL, 157684),
(157685, '1.20.1250.20-FF-001492', NULL, 'Protein CBG06794', 159, NULL, NULL, 157685),
(157686, '1.10.10.60-FF-001022', NULL, NULL, 64, NULL, NULL, 157686),
(157687, '2.30.30.190-FF-000001', NULL, 'Putative CAP-Gly domain-containing linker protein 1', 89, NULL, NULL, 157687);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(157688, '2.40.170.20-FF-000129', NULL, 'Second ferric pyoverdine receptor FpvB', 543, NULL, NULL, 157688),
(157689, '3.80.10.10-FF-003854', NULL, 'PH domain and leucine rich repeat protein phosphatase 2', 76, NULL, NULL, 157689),
(157690, '3.30.70.330-FF-002189', NULL, NULL, 127, NULL, NULL, 157690),
(157691, '1.25.40.20-FF-000933', NULL, 'Ankyrin repeat domain 9', 154, NULL, NULL, 157691),
(157692, '2.60.34.10-FF-000068', NULL, 'Uncharacterized protein', 190, NULL, NULL, 157692),
(157693, '3.30.70.3080-FF-000002', NULL, 'Alpha,alpha-trehalose-phosphate synthase [UDP-forming] 2', 97, NULL, NULL, 157693),
(157694, '3.40.50.10260-FF-000028', NULL, 'YALI0D14410p', 239, NULL, NULL, 157694),
(157695, '1.10.20.10-FF-000277', NULL, NULL, 75, NULL, NULL, 157695),
(157696, '2.60.120.290-FF-000013', NULL, 'Membrane frizzled-related protein', 115, NULL, NULL, 157696),
(157697, '2.60.40.60-FF-001019', NULL, 'Uncharacterized protein', 105, NULL, NULL, 157697),
(157698, '2.60.470.10-FF-000009', NULL, 'Pickpocket protein 28', 175, NULL, NULL, 157698),
(157699, '3.40.50.150-FF-001331', NULL, NULL, 201, NULL, NULL, 157699),
(157700, '3.30.930.10-FF-000003', NULL, 'Phenylalanine--tRNA ligase alpha subunit', 326, NULL, NULL, 157700),
(157701, '1.20.58.1040-FF-000017', NULL, '1,3-beta-glucanosyltransferase', 133, NULL, NULL, 157701),
(157702, '2.40.30.30-FF-000004', NULL, 'Riboflavin biosynthesis protein', 132, NULL, NULL, 157702),
(157703, '1.20.1050.10-FF-000136', NULL, 'YqjG-type gamma-glutamylcysteinyl-hydroquinone reductase', 157, NULL, NULL, 157703),
(157704, '1.10.10.10-FF-000248', NULL, 'Fur family transcriptional regulator', 80, NULL, NULL, 157704),
(157705, '1.10.220.100-FF-000008', NULL, 'Uncharacterized protein', 49, NULL, NULL, 157705),
(157706, '2.20.25.30-FF-000010', NULL, 'Ribosomal protein', 51, NULL, NULL, 157706),
(157707, '1.25.10.10-FF-001125', NULL, 'WAPL (Wings apart-like protein regulation of heterochromatin) protein', 184, NULL, NULL, 157707),
(157708, '1.20.58.1030-FF-000014', NULL, 'DNA replication complex GINS protein SLD5, putative', 184, NULL, NULL, 157708),
(157709, '3.40.50.150-FF-000785', NULL, '5-pentadecatrienyl resorcinol O-methyltransferase', 101, NULL, NULL, 157709),
(157710, '1.10.1220.70-FF-000001', NULL, 'Olfactory receptor', 34, NULL, NULL, 157710),
(157711, '3.40.50.970-FF-000172', NULL, '2-oxoisovalerate dehydrogenase subunit alpha', 249, NULL, NULL, 157711),
(157712, '2.60.120.260-FF-000381', NULL, 'Beta-galactosidase (Eurofung)', 48, NULL, NULL, 157712),
(157713, '1.20.58.1020-FF-000011', NULL, 'Predicted protein', 98, NULL, NULL, 157713),
(157714, '3.30.70.330-FF-001205', NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', 61, NULL, NULL, 157714),
(157715, '3.90.1860.10-FF-000005', NULL, 'tRNA-splicing ligase RtcB, putative', 185, NULL, NULL, 157715),
(157716, '1.25.70.10-FF-000084', NULL, NULL, 146, NULL, NULL, 157716),
(157717, '3.30.160.60-FF-001156', NULL, 'Zinc finger protein 407', 29, NULL, NULL, 157717),
(157718, '3.40.50.720-FF-002507', NULL, 'Adenylate kinase 7', 131, NULL, NULL, 157718),
(157719, '1.25.40.10-FF-003038', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 96, NULL, NULL, 157719),
(157720, '3.90.110.10-FF-000006', NULL, 'putative malate dehydrogenase 1B', 179, NULL, NULL, 157720),
(157721, '2.60.40.10-FF-001381', NULL, 'Uncharacterized protein, isoform C', 98, NULL, NULL, 157721),
(157722, '3.30.310.10-FF-000001', NULL, 'TATA-box-binding protein 2', 86, NULL, NULL, 157722),
(157723, '1.20.120.520-FF-000008', NULL, 'BnaA01g26820D protein', 150, NULL, NULL, 157723),
(157724, '3.40.50.970-FF-000115', NULL, 'Probable acetohydroxyacid synthase ilvX', 188, NULL, NULL, 157724),
(157725, '1.20.1250.20-FF-001868', NULL, 'Uncharacterized protein', 111, NULL, NULL, 157725),
(157726, '3.40.50.300-FF-000757', NULL, 'MAGUK p55 subfamily member 7', 218, NULL, NULL, 157726),
(157727, '2.60.40.10-FF-004961', NULL, NULL, 116, NULL, NULL, 157727),
(157728, '3.40.50.300-FF-008486', NULL, 'Uncharacterized protein', 164, NULL, NULL, 157728);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(157729, '3.90.1170.10-FF-000026', NULL, 'Uncharacterized protein', 62, NULL, NULL, 157729),
(157730, '2.120.10.30-FF-000106', NULL, 'LDL receptor protein 1, isoform G', 300, NULL, NULL, 157730),
(157731, '3.30.310.20-FF-000004', NULL, '3-methyladenine DNA glycosylase 2', 118, NULL, NULL, 157731),
(157732, '1.25.10.10-FF-001182', NULL, 'Uncharacterized protein', 163, NULL, NULL, 157732),
(157733, '2.60.200.10-FF-000024', NULL, 'Interferon regulatory factor like protein', 200, NULL, NULL, 157733),
(157734, '3.30.70.330-FF-000334', NULL, 'RNA-binding protein BRN1', 111, NULL, NULL, 157734),
(157735, '1.20.890.10-FF-000009', NULL, 'DPY30 domain-containing protein 1', 44, NULL, NULL, 157735),
(157736, '3.40.850.10-FF-000242', NULL, 'Putative Unc104-like kinesin', 370, NULL, NULL, 157736),
(157737, '3.30.1360.180-FF-000010', NULL, 'AGAP000982-PA', 117, NULL, NULL, 157737),
(157738, '2.40.30.10-FF-000465', NULL, 'Nitric oxide synthase, putative', 87, NULL, NULL, 157738),
(157739, '2.70.130.10-FF-000089', NULL, NULL, 142, NULL, NULL, 157739),
(157740, '1.25.40.530-FF-000014', NULL, 'RhoGAP domain containing protein', 162, NULL, NULL, 157740),
(157741, '2.10.25.10-FF-001483', NULL, 'Uncharacterized protein', 38, NULL, NULL, 157741),
(157742, '3.60.110.10-FF-000013', NULL, 'Omega-amidase chloroplastic', 279, NULL, NULL, 157742),
(157743, '1.10.472.10-FF-000265', NULL, 'Cyclin, N-terminal domain containing protein', 19, NULL, NULL, 157743),
(157744, '1.10.630.10-FF-000228', NULL, 'Cytochrome P450 hydroxylase', 360, NULL, NULL, 157744),
(157745, '2.60.260.20-FF-000098', NULL, 'Uncharacterized protein', 84, NULL, NULL, 157745),
(157746, '2.60.40.10-FF-000358', NULL, 'Prolactin receptor', 105, NULL, NULL, 157746),
(157747, '3.30.200.20-FF-001957', NULL, 'Predicted protein', 106, NULL, NULL, 157747),
(157748, '3.90.770.10-FF-000005', NULL, '3-hydroxy-3-methylglutaryl-coenzyme A reductase', 96, NULL, NULL, 157748),
(157749, '1.20.1560.10-FF-000219', NULL, 'Pyoverdine biosynthesis protein PvdE', 313, NULL, NULL, 157749),
(157750, '3.40.50.970-FF-000025', NULL, 'Ubiquinone-dependent pyruvate dehydrogenase', 178, NULL, NULL, 157750),
(157751, '3.30.160.100-FF-000004', NULL, 'Ribosome hibernation promoting factor', 102, NULL, NULL, 157751),
(157752, '1.20.920.20-FF-000072', NULL, 'Uncharacterized protein', 144, NULL, NULL, 157752),
(157753, '3.20.20.100-FF-000022', NULL, 'Oxidoreductase, aldo/keto reductase family', 325, NULL, NULL, 157753),
(157754, '3.40.50.2000-FF-000283', NULL, 'ADP-heptose--LPS heptosyltransferase II', 144, NULL, NULL, 157754),
(157755, '3.40.50.300-FF-001628', NULL, 'DNA mismatch repair protein', 270, NULL, NULL, 157755),
(157756, '2.130.10.10-FF-000667', NULL, 'WD repeat-containing protein 82-B', 73, NULL, NULL, 157756),
(157757, '2.70.70.10-FF-000045', NULL, 'PTS system transporter subunit IIA', 75, NULL, NULL, 157757),
(157758, '3.40.50.720-FF-001726', NULL, 'Homoserine dehydrogenase', 166, NULL, NULL, 157758),
(157759, '2.60.40.10-FF-001471', NULL, 'interleukin-1 receptor-like 1 isoform X3', 94, NULL, NULL, 157759),
(157760, '1.25.40.10-FF-002257', NULL, 'Pentatricopeptide repeat-containing protein At1g31790', 135, NULL, NULL, 157760),
(157761, '1.20.920.30-FF-000075', NULL, 'Uncharacterized protein', 49, NULL, NULL, 157761),
(157762, '3.40.50.980-FF-000028', NULL, 'Bacitracin synthetase 3', 169, NULL, NULL, 157762),
(157763, '3.30.70.330-FF-001970', NULL, NULL, 96, NULL, NULL, 157763),
(157764, '2.70.98.10-FF-000018', NULL, 'Aldose 1-epimerase', 342, NULL, NULL, 157764),
(157765, '3.40.50.10090-FF-000011', NULL, 'Uroporphyrinogen-III synthase (UroS), putative', 165, NULL, NULL, 157765),
(157766, '3.30.70.2010-FF-000002', NULL, '2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-succinyltransferase', 110, NULL, NULL, 157766),
(157767, '1.20.920.30-FF-000018', NULL, 'Axonemal dynein heavy chain', 45, NULL, NULL, 157767),
(157768, '1.10.10.60-FF-000656', NULL, 'AraC family transcriptional regulator', 113, NULL, NULL, 157768),
(157769, '3.30.420.40-FF-000367', NULL, 'actin-related protein 5', 92, NULL, NULL, 157769);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(157770, '2.40.10.10-FF-000048', NULL, 'serine protease 23', 80, NULL, NULL, 157770),
(157771, '2.30.29.30-FF-000018', NULL, 'E3 SUMO-protein ligase RanBP2', 156, NULL, NULL, 157771),
(157772, '3.30.40.10-FF-002195', NULL, 'Uncharacterized protein', 75, NULL, NULL, 157772),
(157773, '1.50.40.10-FF-000102', NULL, 'Folate carrier protein Flx1', 293, NULL, NULL, 157773),
(157774, '3.40.50.970-FF-000082', NULL, 'Oxoglutarate dehydrogenase', 196, NULL, NULL, 157774),
(157775, '3.30.200.20-FF-002177', NULL, NULL, 60, NULL, NULL, 157775),
(157776, '2.120.10.80-FF-000368', NULL, 'Predicted protein', 235, NULL, NULL, 157776),
(157777, '2.30.42.10-FF-000414', NULL, NULL, 58, NULL, NULL, 157777),
(157778, '3.40.50.150-FF-001241', NULL, NULL, 90, NULL, NULL, 157778),
(157779, '2.30.38.10-FF-000016', NULL, 'NRPS-like enzyme, putative', 74, NULL, NULL, 157779),
(157780, '3.40.50.300-FF-008396', NULL, 'ATP-dependent DEAD/H DNA helicase recQ family-like protein', 181, NULL, NULL, 157780),
(157781, '3.20.20.80-FF-000152', NULL, 'Extracellular endoglucanase', 333, NULL, NULL, 157781),
(157782, '3.90.960.10-FF-000020', NULL, 'Predicted protein', 76, NULL, NULL, 157782),
(157783, '3.80.10.10-FF-004400', NULL, 'Leucine-rich repeat protein (LRRP), putative', 106, NULL, NULL, 157783),
(157784, '3.80.10.10-FF-003416', NULL, 'Uncharacterized protein', 81, NULL, NULL, 157784),
(157785, '3.20.20.80-FF-000242', NULL, 'Glycogen debranching enzyme Gdb1, putative', 244, NULL, NULL, 157785),
(157786, '3.10.450.10-FF-000078', NULL, 'Uncharacterized protein', 112, NULL, NULL, 157786),
(157787, '1.10.510.10-FF-002518', NULL, NULL, 103, NULL, NULL, 157787),
(157788, '2.40.10.10-FF-000609', NULL, NULL, 114, NULL, NULL, 157788),
(157789, '2.30.42.10-FF-000504', NULL, NULL, 96, NULL, NULL, 157789),
(157790, '3.40.190.290-FF-000076', NULL, 'Transcriptional regulator', 200, NULL, NULL, 157790),
(157791, '3.30.70.141-FF-000031', NULL, NULL, 148, NULL, NULL, 157791),
(157792, '3.30.470.30-FF-000081', NULL, 'Predicted protein', 62, NULL, NULL, 157792),
(157793, '1.25.40.10-FF-002818', NULL, 'Uncharacterized protein', 156, NULL, NULL, 157793),
(157794, '2.60.40.10-FF-005214', NULL, NULL, 91, NULL, NULL, 157794),
(157795, '3.80.10.10-FF-000600', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 270, NULL, NULL, 157795),
(157796, '3.30.70.330-FF-000391', NULL, 'Putative RNA binding protein', 88, NULL, NULL, 157796),
(157797, '3.30.160.60-FF-003011', NULL, 'zinc finger protein 521 isoform X3', 81, NULL, NULL, 157797),
(157798, '3.30.160.60-FF-001066', NULL, 'Zinc finger protein 292', 70, NULL, NULL, 157798),
(157799, '1.20.1050.10-FF-000046', NULL, 'Glutathione S-transferase rho', 139, NULL, NULL, 157799),
(157800, '3.30.60.10-FF-000010', NULL, NULL, 60, NULL, NULL, 157800),
(157801, '2.60.40.10-FF-005124', NULL, NULL, 97, NULL, NULL, 157801),
(157802, '3.40.50.300-FF-001067', NULL, 'DNA mismatch repair protein MSH5', 269, NULL, NULL, 157802),
(157803, '1.25.10.10-FF-002519', NULL, 'Apoptosis inhibitor 5 homolog-like Protein', 193, NULL, NULL, 157803),
(157804, '1.10.10.460-FF-000002', NULL, 'Ribonuclease', 47, NULL, NULL, 157804),
(157805, '2.160.20.10-FF-000043', NULL, 'Exo-beta-1,3-glucanase, putative', 334, NULL, NULL, 157805),
(157806, '1.20.1250.20-FF-002273', NULL, 'Uncharacterized protein', 95, NULL, NULL, 157806),
(157807, '3.30.1230.20-FF-000014', NULL, '40S ribosomal protein S21', 70, NULL, NULL, 157807),
(157808, '2.60.120.260-FF-000229', NULL, 'Uncharacterized protein', 151, NULL, NULL, 157808),
(157809, '3.40.50.150-FF-000875', NULL, 'O-methyltransferase family protein', 177, NULL, NULL, 157809),
(157810, '1.10.510.10-FF-003502', NULL, NULL, 255, NULL, NULL, 157810),
(157811, '2.60.40.10-FF-000919', NULL, 'Uncharacterized protein, isoform C', 98, NULL, NULL, 157811),
(157812, '1.20.920.10-FF-000102', NULL, 'Chromatin structure-remodeling complex subunit RSC1/2', 115, NULL, NULL, 157812),
(157813, '1.10.10.10-FF-000338', NULL, 'Glc operon transcriptional activator', 78, NULL, NULL, 157813),
(157814, '2.120.10.80-FF-000278', NULL, 'Predicted protein', 289, NULL, NULL, 157814);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(157815, '1.10.730.10-FF-000141', NULL, 'YALI0E24607p', 113, NULL, NULL, 157815),
(157816, '3.40.390.10-FF-000015', NULL, 'Meprin A subunit', 229, NULL, NULL, 157816),
(157817, '3.40.50.300-FF-001252', NULL, 'AIG1 family protein', 242, NULL, NULL, 157817),
(157818, '1.10.10.470-FF-000005', NULL, 'Maltooligosyltrehalose synthase', 109, NULL, NULL, 157818),
(157819, '1.10.10.480-FF-000008', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase', 69, NULL, NULL, 157819),
(157820, '2.60.120.260-FF-000471', NULL, 'Uncharacterized protein', 94, NULL, NULL, 157820),
(157821, '1.25.40.10-FF-004820', NULL, 'Uncharacterized protein', 152, NULL, NULL, 157821),
(157822, '3.40.50.1010-FF-000031', NULL, 'DNA repair protein UVH3', 144, NULL, NULL, 157822),
(157823, '2.70.170.10-FF-000209', NULL, 'Uncharacterized protein', 159, NULL, NULL, 157823),
(157824, '3.40.50.1580-FF-000033', NULL, 'GM15517', 269, NULL, NULL, 157824),
(157825, '3.40.50.720-FF-002036', NULL, 'Uncharacterized protein', 190, NULL, NULL, 157825),
(157826, '2.30.240.10-FF-000005', NULL, 'At5g19860', 133, NULL, NULL, 157826),
(157827, '1.20.1560.10-FF-000129', NULL, 'ABC bile acid transporter', 316, NULL, NULL, 157827),
(157828, '2.60.40.10-FF-004287', NULL, NULL, 203, NULL, NULL, 157828),
(157829, '3.55.40.20-FF-000023', NULL, 'Superoxide dismutase', 99, NULL, NULL, 157829),
(157830, '3.40.50.12240-FF-000004', NULL, 'F-type H+-transporting ATPase subunit alpha', 405, NULL, NULL, 157830),
(157831, '3.80.10.10-FF-004310', NULL, 'Probable serine/threonine-protein kinase roco5', 213, NULL, NULL, 157831),
(157832, '2.30.110.10-FF-000001', NULL, 'Pyridoxine/pyridoxamine 5''-phosphate oxidase', 199, NULL, NULL, 157832),
(157833, '2.30.29.30-FF-000636', NULL, 'Downstream of kinase', 107, NULL, NULL, 157833),
(157834, '1.10.8.10-FF-000180', NULL, 'WGS project CABT00000000 data, contig 2.7', 43, NULL, NULL, 157834),
(157835, '3.30.70.330-FF-000952', NULL, 'Predicted protein', 87, NULL, NULL, 157835),
(157836, '1.10.420.10-FF-000038', NULL, 'Peroxidase', 182, NULL, NULL, 157836),
(157837, '1.10.510.10-FF-002575', NULL, 'BUB1 mitotic checkpoint serine/threonine kinase Ba', 239, NULL, NULL, 157837),
(157838, '2.40.10.10-FF-000666', NULL, NULL, 58, NULL, NULL, 157838),
(157839, '2.130.10.10-FF-000577', NULL, 'WD domain G-beta repeat protein', 317, NULL, NULL, 157839),
(157840, '3.30.1360.10-FF-000015', NULL, 'DNA-directed RNA polymerase alpha chain,putative', 70, NULL, NULL, 157840),
(157841, '3.30.160.60-FF-006445', NULL, NULL, 81, NULL, NULL, 157841),
(157842, '3.30.200.20-FF-002267', NULL, NULL, 113, NULL, NULL, 157842),
(157843, '3.40.50.12230-FF-000001', NULL, 'Methionyl-tRNA formyltransferase', 308, NULL, NULL, 157843),
(157844, '2.20.70.10-FF-000103', NULL, 'nudix hydrolase 23, chloroplastic-like', 37, NULL, NULL, 157844),
(157845, '1.20.1280.20-FF-000004', NULL, 'Co-chaperone protein HscB homolog', 85, NULL, NULL, 157845),
(157846, '1.10.10.60-FF-000566', NULL, 'TetR family transcriptional regulator', 69, NULL, NULL, 157846),
(157847, '1.20.1530.20-FF-000075', NULL, 'Uncharacterized protein', 408, NULL, NULL, 157847),
(157848, '3.40.30.10-FF-001154', NULL, 'Uncharacterized protein', 30, NULL, NULL, 157848),
(157849, '3.40.1480.10-FF-000010', NULL, 'Glycerate kinase-like Protein', 219, NULL, NULL, 157849),
(157850, '3.90.1600.10-FF-000043', NULL, 'DNA-directed DNA polymerase', 159, NULL, NULL, 157850),
(157851, '1.20.1260.10-FF-000062', NULL, 'Ferritin', 138, NULL, NULL, 157851),
(157852, '3.40.1420.10-FF-000001', NULL, 'Inhibitor of vertebrate lysozyme', 129, NULL, NULL, 157852),
(157853, '1.10.510.10-FF-003215', NULL, NULL, 138, NULL, NULL, 157853),
(157854, '3.40.630.10-FF-000293', NULL, 'N-acetylated alpha-linked acidic dipeptidase 2', 75, NULL, NULL, 157854),
(157855, '3.80.10.10-FF-004405', NULL, 'Predicted protein', 94, NULL, NULL, 157855),
(157856, '1.10.1240.10-FF-000012', NULL, 'Corrinoid-binding domain protein', 74, NULL, NULL, 157856),
(157857, '3.40.850.10-FF-000562', NULL, 'Uncharacterized protein', 80, NULL, NULL, 157857);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(157858, '1.25.40.10-FF-004707', NULL, 'Putative pentatricopeptide repeat-containing protein At1g09680', 96, NULL, NULL, 157858),
(157859, '1.10.472.10-FF-000467', NULL, 'Uncharacterized protein', 170, NULL, NULL, 157859),
(157860, '2.10.25.10-FF-001281', NULL, 'Neurogenic locus notch, putative', 38, NULL, NULL, 157860),
(157861, '2.60.120.260-FF-000414', NULL, 'Centrosomal protein of 104 kDa-like Protein', 141, NULL, NULL, 157861),
(157862, '3.40.50.300-FF-003051', NULL, 'Small GTP-binding protein domain', 255, NULL, NULL, 157862),
(157863, '3.90.190.10-FF-000303', NULL, 'Tyrosine-protein phosphatase Lar-like Protein', 287, NULL, NULL, 157863),
(157864, '3.10.20.90-FF-000268', NULL, 'Ubiquitin-like modifier HUB1', 97, NULL, NULL, 157864),
(157865, '3.80.10.10-FF-003793', NULL, 'Uncharacterized protein', 94, NULL, NULL, 157865),
(157866, '1.10.10.60-FF-001235', NULL, NULL, 52, NULL, NULL, 157866),
(157867, '1.20.120.230-FF-000039', NULL, 'Serendipity alpha', 109, NULL, NULL, 157867),
(157868, '2.160.20.10-FF-000251', NULL, 'Uncharacterized protein', 90, NULL, NULL, 157868),
(157869, '3.40.50.410-FF-000032', NULL, 'Hemicentin 1', 178, NULL, NULL, 157869),
(157870, '3.40.50.261-FF-000027', NULL, 'Succinyl-CoA ligase alpha subunit', 187, NULL, NULL, 157870),
(157871, '3.40.630.30-FF-000299', NULL, 'GNAT family N-acetyltransferase', 141, NULL, NULL, 157871),
(157872, '2.130.10.30-FF-000004', NULL, 'E3 ubiquitin-protein ligase HERC2 isoform X2', 369, NULL, NULL, 157872),
(157873, '2.110.10.10-FF-000067', NULL, 'Uncharacterized protein', 127, NULL, NULL, 157873),
(157874, '3.40.50.720-FF-002210', NULL, 'Uncharacterized protein', 300, NULL, NULL, 157874),
(157875, '3.30.1490.100-FF-000043', NULL, 'DNA polymerase eta, putative', 118, NULL, NULL, 157875),
(157876, '3.30.559.70-FF-000028', NULL, 'carnitine O-acetyltransferase-like', 317, NULL, NULL, 157876),
(157877, '1.10.238.10-FF-000553', NULL, 'Centrin 3', 70, NULL, NULL, 157877),
(157878, '2.40.180.10-FF-000037', NULL, 'Catalase-related peroxidase', 208, NULL, NULL, 157878),
(157879, '3.40.50.2000-FF-000367', NULL, 'Lipopolysaccharide 1,2-N-acetylglucosaminetransferase', 148, NULL, NULL, 157879),
(157880, '3.30.40.10-FF-000278', NULL, 'cullin-9 isoform X2', 88, NULL, NULL, 157880),
(157881, '1.20.1070.10-FF-001885', NULL, 'Predicted protein', 341, NULL, NULL, 157881),
(157882, '2.120.10.30-FF-000196', NULL, 'Uncharacterized protein', 128, NULL, NULL, 157882),
(157883, '4.10.640.40-FF-000002', NULL, 'Putative Cytoplasmic polyadenylation element-binding protein 1', 60, NULL, NULL, 157883),
(157884, '1.20.120.1240-FF-000040', NULL, 'Dynamin family GTPase, putative', 233, NULL, NULL, 157884),
(157885, '1.20.1310.10-FF-000235', NULL, NULL, 100, NULL, NULL, 157885),
(157886, '3.10.129.110-FF-000015', NULL, 'CurH', 292, NULL, NULL, 157886),
(157887, '3.40.50.1820-FF-001870', NULL, 'Uncharacterized protein', 239, NULL, NULL, 157887),
(157888, '3.80.10.10-FF-003742', NULL, 'Uncharacterized protein', 130, NULL, NULL, 157888),
(157889, '3.30.40.10-FF-001964', NULL, 'Uncharacterized protein', 64, NULL, NULL, 157889),
(157890, '1.20.1070.10-FF-001508', NULL, 'Uncharacterized protein', 196, NULL, NULL, 157890),
(157891, '1.25.40.20-FF-001422', NULL, 'Uncharacterized protein', 184, NULL, NULL, 157891),
(157892, '2.40.110.10-FF-000038', NULL, 'Dehydrogenase', 91, NULL, NULL, 157892),
(157893, '1.10.510.10-FF-004317', NULL, NULL, 147, NULL, NULL, 157893),
(157894, '3.40.1090.10-FF-000087', NULL, 'Uncharacterized protein', 162, NULL, NULL, 157894),
(157895, '3.30.160.60-FF-001038', NULL, 'Zinc finger protein 217', 26, NULL, NULL, 157895),
(157896, '1.25.40.10-FF-002993', NULL, 'Os02g0191200 protein', 131, NULL, NULL, 157896),
(157897, '3.80.10.10-FF-002314', NULL, 'Uncharacterized protein', 166, NULL, NULL, 157897),
(157898, '3.60.20.10-FF-000023', NULL, 'Proteasome subunit alpha', 244, NULL, NULL, 157898),
(157899, '3.30.160.60-FF-002724', NULL, 'Similar to transcription factor Zn, C2H2', 42, NULL, NULL, 157899),
(157900, '2.30.30.40-FF-000328', NULL, 'Actin cytoskeleton-regulatory complex protein sla1', 72, NULL, NULL, 157900);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(157901, '1.25.40.10-FF-002616', NULL, 'Tetratricopeptide repeat protein 1', 247, NULL, NULL, 157901),
(157902, '1.25.10.10-FF-002435', NULL, 'Uncharacterized protein', 239, NULL, NULL, 157902),
(157903, '2.20.70.10-FF-000047', NULL, 'E3 ubiquitin-protein ligase', 51, NULL, NULL, 157903),
(157904, '1.20.1250.20-FF-001609', NULL, 'Equilibrative nucleoside transporter 1', 199, NULL, NULL, 157904),
(157905, '2.120.10.30-FF-000258', NULL, 'Uncharacterized protein', 82, NULL, NULL, 157905),
(157906, '2.40.50.140-FF-000820', NULL, NULL, 110, NULL, NULL, 157906),
(157907, '3.10.330.10-FF-000018', NULL, 'Unplaced genomic scaffold supercont2.17, whole genome shotgun sequence', 95, NULL, NULL, 157907),
(157908, '1.10.510.10-FF-003120', NULL, NULL, 190, NULL, NULL, 157908),
(157909, '1.20.1280.20-FF-000009', NULL, 'Co-chaperone protein HscB homolog', 92, NULL, NULL, 157909),
(157910, '2.60.40.10-FF-005304', NULL, NULL, 80, NULL, NULL, 157910),
(157911, '3.30.40.10-FF-000503', NULL, 'RING-H2 finger protein ATL7', 82, NULL, NULL, 157911),
(157912, '1.20.1070.10-FF-000311', NULL, 'TYRAmine receptor', 135, NULL, NULL, 157912),
(157913, '3.30.70.330-FF-002077', NULL, NULL, 82, NULL, NULL, 157913),
(157914, '2.130.10.10-FF-004377', NULL, 'Uncharacterized protein', 78, NULL, NULL, 157914),
(157915, '3.90.226.10-FF-000174', NULL, 'Probable enoyl-CoA hydratase EchA18 (Enoyl hydrase) (Unsaturated acyl-CoA hydratase) (Crotonase)', 189, NULL, NULL, 157915),
(157916, '1.10.510.10-FF-001142', NULL, 'Unplaced genomic scaffold supercont1.19, whole genome shotgun sequence', 305, NULL, NULL, 157916),
(157917, '3.40.50.2030-FF-000005', NULL, 'Carbon monoxide dehydrogenase', 176, NULL, NULL, 157917),
(157918, '3.30.200.20-FF-001598', NULL, NULL, 105, NULL, NULL, 157918),
(157919, '3.30.230.130-FF-000064', NULL, 'AaceriAGL193Wp', 148, NULL, NULL, 157919),
(157920, '2.30.230.10-FF-000010', NULL, 'Uncharacterized protein', 233, NULL, NULL, 157920),
(157921, '3.30.710.10-FF-000346', NULL, 'Uncharacterized protein', 161, NULL, NULL, 157921),
(157922, '3.30.70.270-FF-000327', NULL, NULL, 133, NULL, NULL, 157922),
(157923, '1.10.600.10-FF-000013', NULL, 'NADH dehydrogenase (ubiquinone) complex I, assembly factor 6', 260, NULL, NULL, 157923),
(157924, '2.120.10.80-FF-000071', NULL, 'kelch domain-containing protein 3 isoform X2', 148, NULL, NULL, 157924),
(157925, '1.10.3820.10-FF-000006', NULL, 'Cytochrome c-type protein NrfH', 169, NULL, NULL, 157925),
(157926, '2.30.42.10-FF-000392', NULL, NULL, 124, NULL, NULL, 157926),
(157927, '2.60.40.60-FF-001143', NULL, 'Cadherin 4', 67, NULL, NULL, 157927),
(157928, '3.40.190.10-FF-000157', NULL, 'Glutamate receptor ionotropic, NMDA 2B', 172, NULL, NULL, 157928),
(157929, '3.30.1010.10-FF-000028', NULL, 'Phosphatidylinositol kinase (PIK-G3)', 91, NULL, NULL, 157929),
(157930, '3.40.50.2020-FF-000002', NULL, 'Ribose-phosphate pyrophosphokinase', 143, NULL, NULL, 157930),
(157931, '3.40.50.300-FF-005400', NULL, 'Protein CBR-MUT-14', 197, NULL, NULL, 157931),
(157932, '1.20.1740.10-FF-000104', NULL, 'Amino-acid permease BAT1', 94, NULL, NULL, 157932),
(157933, '2.130.10.30-FF-000055', NULL, 'SCF-associated factor 1', 158, NULL, NULL, 157933),
(157934, '3.30.420.40-FF-000288', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', 180, NULL, NULL, 157934),
(157935, '1.20.1070.10-FF-001834', NULL, 'Uncharacterized protein', 304, NULL, NULL, 157935),
(157936, '2.20.80.10-FF-000019', NULL, 'Uncharacterized protein', 132, NULL, NULL, 157936),
(157937, '1.20.120.720-FF-000012', NULL, 'Myosin IIIB', 163, NULL, NULL, 157937),
(157938, '1.20.5.190-FF-000129', NULL, NULL, 47, NULL, NULL, 157938),
(157939, '3.30.1640.10-FF-000059', NULL, 'DNA replication licensing factor MCM7', 95, NULL, NULL, 157939),
(157940, '2.130.10.10-FF-001246', NULL, 'WD domain, G-beta repeat, putative', 324, NULL, NULL, 157940),
(157941, '3.90.1140.10-FF-000058', NULL, 'RNA 2'',3''-cyclic phosphodiesterase', 180, NULL, NULL, 157941),
(157942, '2.30.42.10-FF-000178', NULL, 'disks large homolog 5 isoform X2', 84, NULL, NULL, 157942);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(157943, '2.60.120.290-FF-000215', NULL, 'Metalloendopeptidase', 115, NULL, NULL, 157943),
(157944, '2.60.40.10-FF-004399', NULL, NULL, 101, NULL, NULL, 157944),
(157945, '3.90.740.10-FF-000037', NULL, 'Isoleucyl-tRNA synthetase (Mitochondrial)', 151, NULL, NULL, 157945),
(157946, '3.60.40.10-FF-000232', NULL, 'Stage II sporulation E family protein', 251, NULL, NULL, 157946),
(157947, '3.90.640.10-FF-000153', NULL, 'Endoplasmic reticulum chaperone BiP', 84, NULL, NULL, 157947),
(157948, '1.20.1560.10-FF-000006', NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 9', 342, NULL, NULL, 157948),
(157949, '1.25.10.10-FF-003003', NULL, 'Uncharacterized protein', 348, NULL, NULL, 157949),
(157950, '1.10.8.270-FF-000184', NULL, 'Uncharacterized protein', 212, NULL, NULL, 157950),
(157951, '3.20.20.80-FF-000450', NULL, 'Uncharacterized protein', 119, NULL, NULL, 157951),
(157952, '3.50.50.60-FF-000315', NULL, 'Unplaced genomic scaffold supercont2.6, whole genome shotgun sequence', 217, NULL, NULL, 157952),
(157953, '2.60.40.1170-FF-000108', NULL, NULL, 20, NULL, NULL, 157953),
(157954, '3.30.160.60-FF-002499', NULL, 'Blast:Zinc finger protein 568', 30, NULL, NULL, 157954),
(157955, '3.40.50.20-FF-000017', NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', 70, NULL, NULL, 157955),
(157956, '3.60.110.10-FF-000007', NULL, 'Glutamine-dependent NAD(+) synthetase', 314, NULL, NULL, 157956),
(157957, '3.30.50.10-FF-000155', NULL, 'Uncharacterized protein', 100, NULL, NULL, 157957),
(157958, '1.20.1250.20-FF-000300', NULL, 'Dicarboxylate MFS transporter', 192, NULL, NULL, 157958),
(157959, '2.40.50.140-FF-000606', NULL, 'Uncharacterized protein', 119, NULL, NULL, 157959),
(157960, '3.40.850.10-FF-000236', NULL, 'Kinesin-like protein', 191, NULL, NULL, 157960),
(157961, '1.20.1160.11-FF-000027', NULL, NULL, 71, NULL, NULL, 157961),
(157962, '3.40.50.300-FF-004299', NULL, 'Predicted protein', 270, NULL, NULL, 157962),
(157963, '1.20.1320.30-FF-000005', NULL, 'probable ATP-dependent RNA helicase DHX58', 123, NULL, NULL, 157963),
(157964, '1.10.1410.40-FF-000001', NULL, 'interleukin enhancer-binding factor 3 isoform X1', 124, NULL, NULL, 157964),
(157965, '2.120.10.30-FF-000584', NULL, 'Uncharacterized protein', 135, NULL, NULL, 157965),
(157966, '1.25.40.10-FF-004387', NULL, 'Pentatricopeptide repeat-containing protein At5g11310, mitochondrial', 142, NULL, NULL, 157966),
(157967, '3.50.50.60-FF-000641', NULL, 'Putative cellulose synthase A catalytic subunit 2 [UDP-forming]', 59, NULL, NULL, 157967),
(157968, '1.20.5.170-FF-000123', NULL, 'Basic region/leucine zipper protein', 83, NULL, NULL, 157968),
(157969, '1.10.510.10-FF-002277', NULL, NULL, 194, NULL, NULL, 157969),
(157970, '4.10.1000.10-FF-000003', NULL, 'Zinc finger CCCH domain-containing protein', 38, NULL, NULL, 157970),
(157971, '1.10.1820.10-FF-000006', NULL, 'Casein kinase II subunit beta', 102, NULL, NULL, 157971),
(157972, '1.10.150.280-FF-000006', NULL, 'Kinesin-like protein', 80, NULL, NULL, 157972),
(157973, '3.40.1280.10-FF-000124', NULL, 'Os08g0506500 protein', 92, NULL, NULL, 157973),
(157974, '3.30.70.1660-FF-000026', NULL, 'Mitochondrial translation release factor (RF-1), putative', 109, NULL, NULL, 157974),
(157975, '3.80.10.10-FF-000241', NULL, 'leucine-rich repeat-containing protein 73 isoform X1', 123, NULL, NULL, 157975),
(157976, '1.20.1540.10-FF-000044', NULL, 'Rhomboid family intramembrane serine protease', 210, NULL, NULL, 157976),
(157977, '2.40.110.10-FF-000089', NULL, 'Uncharacterized protein', 59, NULL, NULL, 157977),
(157978, '3.30.160.60-FF-001364', NULL, 'zinc finger protein 746 isoform X1', 60, NULL, NULL, 157978),
(157979, '3.30.40.10-FF-001638', NULL, 'Chromodomain-helicase-DNA-binding protein 3 homolog', 54, NULL, NULL, 157979),
(157980, '2.130.10.10-FF-002932', NULL, 'Uncharacterized WD repeat-containing protein C4F8.11', 150, NULL, NULL, 157980),
(157981, '3.20.20.100-FF-000061', NULL, 'Aldo/keto reductase, putative', 300, NULL, NULL, 157981),
(157982, '2.60.40.10-FF-002275', NULL, 'Coagulation factor XIII, A1 polypeptide', 185, NULL, NULL, 157982);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(157983, '3.40.250.10-FF-000033', NULL, 'Thiosulfate sulfurtransferase TUM1', 158, NULL, NULL, 157983),
(157984, '1.20.1250.20-FF-001986', NULL, 'MDR-type permease', 391, NULL, NULL, 157984),
(157985, '3.40.50.300-FF-008273', NULL, 'Predicted protein', 40, NULL, NULL, 157985),
(157986, '3.30.465.10-FF-000113', NULL, 'Isoamyl alcohol oxidase, putative (AFU_orthologue AFUA_1G01180)', 91, NULL, NULL, 157986),
(157987, '1.25.40.430-FF-000017', NULL, 'Uncharacterized protein', 206, NULL, NULL, 157987),
(157988, '3.30.160.60-FF-005630', NULL, NULL, 55, NULL, NULL, 157988),
(157989, '3.90.1800.10-FF-000024', NULL, 'DNA-directed RNA polymerase subunit beta', 121, NULL, NULL, 157989),
(157990, '1.20.5.170-FF-000011', NULL, 'Transcription factor MafG, putative', 107, NULL, NULL, 157990),
(157991, '4.10.1000.10-FF-000054', NULL, 'RING finger protein unkempt homolog', 40, NULL, NULL, 157991),
(157992, '2.60.40.10-FF-002954', NULL, 'Receptor-type tyrosine-protein phosphatase', 121, NULL, NULL, 157992),
(157993, '1.20.58.100-FF-000012', NULL, 'L-aspartate oxidase', 103, NULL, NULL, 157993),
(157994, '1.20.5.1300-FF-000005', NULL, 'Histidinol dehydrogenase', 53, NULL, NULL, 157994),
(157995, '3.40.50.11610-FF-000023', NULL, NULL, 151, NULL, NULL, 157995),
(157996, '2.60.40.790-FF-000019', NULL, 'cytochrome b5 reductase 4 isoform X1', 104, NULL, NULL, 157996),
(157997, '3.30.1490.40-FF-000011', NULL, 'Uncharacterized protein, isoform B', 76, NULL, NULL, 157997),
(157998, '3.80.10.10-FF-002899', NULL, 'Protein CBG18939', 161, NULL, NULL, 157998),
(157999, '3.10.180.10-FF-000074', NULL, 'ATP-dependent 6-phosphofructokinase', 158, NULL, NULL, 157999),
(158000, '1.20.5.170-FF-000218', NULL, 'Predicted protein', 40, NULL, NULL, 158000),
(158001, '2.30.30.140-FF-000071', NULL, 'Zinc finger CCCH-type with G patch domain-containing protein', 56, NULL, NULL, 158001),
(158002, '3.30.230.10-FF-000315', NULL, 'Predicted protein', 156, NULL, NULL, 158002),
(158003, '1.10.10.510-FF-000001', NULL, 'Replication protein E1', 71, NULL, NULL, 158003),
(158004, '2.30.250.10-FF-000005', NULL, 'M18 aspartyl aminopeptidase', 106, NULL, NULL, 158004),
(158005, '1.10.150.20-FF-000155', NULL, 'Chromosome 8, whole genome shotgun sequence', 69, NULL, NULL, 158005),
(158006, '1.25.40.10-FF-004180', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 89, NULL, NULL, 158006),
(158007, '3.30.930.10-FF-000211', NULL, 'Lysine--tRNA ligase', 367, NULL, NULL, 158007),
(158008, '3.10.28.10-FF-000054', NULL, 'Replication factor C small subunit', 173, NULL, NULL, 158008),
(158009, '3.90.120.10-FF-000029', NULL, 'Cytosine-specific methyltransferase', 148, NULL, NULL, 158009),
(158010, '1.10.1380.10-FF-000022', NULL, 'Fra mauro, isoform F', 118, NULL, NULL, 158010),
(158011, '1.25.40.10-FF-003510', NULL, 'TPR domain protein', 40, NULL, NULL, 158011),
(158012, '1.10.220.150-FF-000068', NULL, 'ArfGAP with SH3 domain, ankyrin repeat and PH domain 2a', 111, NULL, NULL, 158012),
(158013, '3.30.200.20-FF-000816', NULL, 'Ksp1p', 50, NULL, NULL, 158013),
(158014, '3.50.50.60-FF-000220', NULL, 'UDP-galactopyranose mutase', 474, NULL, NULL, 158014),
(158015, '3.10.129.10-FF-000230', NULL, 'Fatty acid synthase subunit beta', 200, NULL, NULL, 158015),
(158016, '3.80.10.10-FF-000920', NULL, 'mRNA, clone: RTFL01-33-G14', 469, NULL, NULL, 158016),
(158017, '2.40.10.10-FF-000587', NULL, NULL, 41, NULL, NULL, 158017),
(158018, '3.90.45.10-FF-000011', NULL, 'Peptide deformylase', 197, NULL, NULL, 158018),
(158019, '1.10.510.10-FF-000686', NULL, 'Serine/threonine-protein kinase ULK4', 307, NULL, NULL, 158019),
(158020, '3.30.342.10-FF-000013', NULL, 'DNA polymerase', 139, NULL, NULL, 158020),
(158021, '1.10.510.10-FF-004368', NULL, NULL, 105, NULL, NULL, 158021),
(158022, '3.40.50.300-FF-006923', NULL, 'Uncharacterized protein', 232, NULL, NULL, 158022),
(158023, '2.60.40.770-FF-000013', NULL, 'AGAP002848-PA', 130, NULL, NULL, 158023),
(158024, '3.30.200.210-FF-000003', NULL, 'Formate dehydrogenase-N subunit alpha', 125, NULL, NULL, 158024),
(158025, '1.10.287.1050-FF-000001', NULL, 'DNA-binding protein', 83, NULL, NULL, 158025);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(158026, '3.40.850.10-FF-000511', NULL, 'Kinesin-like protein, putative', 129, NULL, NULL, 158026),
(158027, '1.20.1050.10-FF-000248', NULL, 'Glutathione S-transferase Mu 5', 45, NULL, NULL, 158027),
(158028, '1.10.287.1060-FF-000004', NULL, 'ESAT-6-like protein EsxI', 69, NULL, NULL, 158028),
(158029, '1.10.1060.10-FF-000026', NULL, 'H(2):CoB-CoM heterodisulfide,ferredoxin reductase subunit C', 112, NULL, NULL, 158029),
(158030, '3.90.650.10-FF-000030', NULL, 'Phosphoribosylformylglycinamidine synthase', 178, NULL, NULL, 158030),
(158031, '3.50.50.60-FF-000366', NULL, 'Uncharacterized protein', 396, NULL, NULL, 158031),
(158032, '1.25.10.10-FF-002839', NULL, 'Uncharacterized protein', 176, NULL, NULL, 158032),
(158033, '1.20.1560.10-FF-000332', NULL, 'ATP binding cassette subfamily B member 5', 28, NULL, NULL, 158033),
(158034, '3.80.10.10-FF-000302', NULL, 'CD180 antigen', 595, NULL, NULL, 158034),
(158035, '3.30.360.110-FF-000002', NULL, 'S-adenosylmethionine decarboxylase proenzyme', 61, NULL, NULL, 158035),
(158036, '3.40.50.300-FF-003197', NULL, '26S proteasome regulatory subunit 10B', 106, NULL, NULL, 158036),
(158037, '3.40.50.300-FF-006709', NULL, 'Uncharacterized protein', 76, NULL, NULL, 158037),
(158038, '3.30.559.10-FF-000117', NULL, 'Dihydrolipoyllysine-residue acetyltransferase component of pyruvate dehydrogenase complex', 246, NULL, NULL, 158038),
(158039, '3.60.15.10-FF-000168', NULL, 'MBL fold metallo-hydrolase', 249, NULL, NULL, 158039),
(158040, '2.60.120.290-FF-000103', NULL, 'Zgc:154142', 111, NULL, NULL, 158040),
(158041, '3.55.50.30-FF-000026', NULL, 'Putative anti-sigma factor', 76, NULL, NULL, 158041),
(158042, '3.30.160.60-FF-006086', NULL, NULL, 26, NULL, NULL, 158042),
(158043, '1.25.10.10-FF-000069', NULL, 'Splicing factor 3B subunit 1', 169, NULL, NULL, 158043),
(158044, '1.10.287.130-FF-000213', NULL, 'Hybrid sensory kinase', 79, NULL, NULL, 158044),
(158045, '1.20.1270.350-FF-000003', NULL, 'CRE-CED-5 protein', 93, NULL, NULL, 158045),
(158046, '3.40.50.10810-FF-000087', NULL, 'Chromatin remodeling 38', 289, NULL, NULL, 158046),
(158047, '3.90.79.10-FF-000078', NULL, 'Peroxisomal coenzyme A diphosphatase NUDT7', 101, NULL, NULL, 158047),
(158048, '3.40.50.2000-FF-000581', NULL, 'Probable glycosyltransferase WbpH', 159, NULL, NULL, 158048),
(158049, '3.30.310.80-FF-000005', NULL, 'Non-specific serine/threonine protein kinase', 124, NULL, NULL, 158049),
(158050, '3.30.750.24-FF-000115', NULL, 'Anion transporter SULP-7d', 121, NULL, NULL, 158050),
(158051, '3.30.379.10-FF-000019', NULL, NULL, 106, NULL, NULL, 158051),
(158052, '1.25.10.10-FF-000748', NULL, 'Serine/threonine-protein kinase TOR', 168, NULL, NULL, 158052),
(158053, '1.10.8.110-FF-000001', NULL, 'Photosystem I reaction center subunit III', 158, NULL, NULL, 158053),
(158054, '1.10.287.380-FF-000029', NULL, 'ABC transporter ATP-binding protein', 79, NULL, NULL, 158054),
(158055, '3.30.497.10-FF-000052', NULL, 'Serpin, putative', 48, NULL, NULL, 158055),
(158056, '1.10.1450.10-FF-000129', NULL, 'Tetraspanin', 118, NULL, NULL, 158056),
(158057, '3.30.160.60-FF-005012', NULL, NULL, 77, NULL, NULL, 158057),
(158058, '3.30.200.20-FF-002441', NULL, 'Predicted protein', 67, NULL, NULL, 158058),
(158059, '1.25.50.20-FF-000001', NULL, 'Aminopeptidase', 325, NULL, NULL, 158059),
(158060, '3.30.70.330-FF-000486', NULL, 'Pumilio domain-containing protein c', 92, NULL, NULL, 158060),
(158061, '2.60.40.10-FF-004427', NULL, NULL, 92, NULL, NULL, 158061),
(158062, '2.120.10.30-FF-000084', NULL, 'Protein STRICTOSIDINE SYNTHASE-LIKE 12', 308, NULL, NULL, 158062),
(158063, '3.40.50.410-FF-000144', NULL, 'RNA polymerase II transcription factor B subunit, putative', 131, NULL, NULL, 158063),
(158064, '3.30.70.1180-FF-000011', NULL, 'V-type proton ATPase subunit C', 37, NULL, NULL, 158064),
(158065, '3.50.50.60-FF-000719', NULL, 'Probable oxidoreductase', 115, NULL, NULL, 158065),
(158066, '3.40.50.720-FF-000911', NULL, 'Chromosome 8, whole genome shotgun sequence', 187, NULL, NULL, 158066),
(158067, '1.20.1250.20-FF-001486', NULL, 'Uncharacterized protein', 186, NULL, NULL, 158067);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(158068, '2.40.510.10-FF-000001', NULL, 'Capsid protein VP1', 192, NULL, NULL, 158068),
(158069, '2.60.220.50-FF-000014', NULL, 'Adhesion G-protein coupled receptor G1', 186, NULL, NULL, 158069),
(158070, '3.40.50.300-FF-006648', NULL, 'Predicted protein', 88, NULL, NULL, 158070),
(158071, '2.40.10.120-FF-000019', NULL, 'Trypsin', 218, NULL, NULL, 158071),
(158072, '3.30.70.1400-FF-000027', NULL, 'Sarcosine dehydrogenase', 32, NULL, NULL, 158072),
(158073, '3.40.640.10-FF-000018', NULL, 'Alanine aminotransferase AlaC', 241, NULL, NULL, 158073),
(158074, '3.40.50.2000-FF-000255', NULL, 'Glycosyltransferase', 261, NULL, NULL, 158074),
(158075, '3.80.10.10-FF-003916', NULL, 'Uncharacterized protein', 111, NULL, NULL, 158075),
(158076, '3.90.1150.10-FF-000502', NULL, 'Putative diaminobutyrate-pyruvate aminotransferase', 108, NULL, NULL, 158076),
(158077, '3.40.850.10-FF-000450', NULL, 'Uncharacterized protein', 86, NULL, NULL, 158077),
(158078, '3.30.70.920-FF-000028', NULL, 'Transcriptional regulator AsnC family', 95, NULL, NULL, 158078),
(158079, '1.25.40.10-FF-002049', NULL, 'Pentatricopeptide repeat-containing protein', 98, NULL, NULL, 158079),
(158080, '2.40.50.90-FF-000063', NULL, 'RING finger protein 17', 28, NULL, NULL, 158080),
(158081, '3.30.70.870-FF-000024', NULL, 'Mitochondrial elongation factor G2', 74, NULL, NULL, 158081),
(158082, '3.30.1680.10-FF-000056', NULL, 'Integrin beta', 57, NULL, NULL, 158082),
(158083, '1.25.10.10-FF-002547', NULL, 'Sister chromatid cohesion protein', 179, NULL, NULL, 158083),
(158084, '1.10.510.10-FF-002777', NULL, NULL, 212, NULL, NULL, 158084),
(158085, '3.90.20.20-FF-000030', NULL, 'Protein GrpE', 115, NULL, NULL, 158085),
(158086, '3.30.40.10-FF-001852', NULL, 'Predicted protein', 81, NULL, NULL, 158086),
(158087, '3.30.160.60-FF-000807', NULL, 'Polymerase (DNA directed) kappa', 30, NULL, NULL, 158087),
(158088, '2.170.140.10-FF-000015', NULL, 'Peritrophin-A', 69, NULL, NULL, 158088),
(158089, '3.40.50.150-FF-000903', NULL, 'Uncharacterized protein', 209, NULL, NULL, 158089),
(158090, '3.30.160.60-FF-003213', NULL, 'GD13584', 32, NULL, NULL, 158090),
(158091, '1.20.1250.20-FF-000800', NULL, 'Sugar phosphate permease', 192, NULL, NULL, 158091),
(158092, '2.40.50.140-FF-000932', NULL, NULL, 90, NULL, NULL, 158092),
(158093, '2.130.10.10-FF-000903', NULL, 'DNA damage-binding protein CMR1', 336, NULL, NULL, 158093),
(158094, '3.40.30.10-FF-000131', NULL, 'migration and invasion enhancer 1', 79, NULL, NULL, 158094),
(158095, '3.90.320.10-FF-000011', NULL, 'ATP-dependent helicase/nuclease subunit A', 240, NULL, NULL, 158095),
(158096, '1.25.40.10-FF-004584', NULL, 'Uncharacterized protein', 174, NULL, NULL, 158096),
(158097, '3.40.50.300-FF-001752', NULL, 'DNA mismatch repair protein', 268, NULL, NULL, 158097),
(158098, '3.30.559.10-FF-000090', NULL, 'Choline/Carnitine o-acyltransferase-like protein', 286, NULL, NULL, 158098),
(158099, '1.10.510.10-FF-002726', NULL, 'Tyrosine-protein kinase', 264, NULL, NULL, 158099),
(158100, '1.10.472.10-FF-000260', NULL, 'Cyclin domain-containing protein', 110, NULL, NULL, 158100),
(158101, '3.40.50.720-FF-000035', NULL, 'Adenosylhomocysteinase', 159, NULL, NULL, 158101),
(158102, '2.20.28.200-FF-000010', NULL, 'NAD-dependent protein deacetylase sirtuin-6', 51, NULL, NULL, 158102),
(158103, '3.90.1180.10-FF-000004', NULL, '50S ribosomal protein L13', 141, NULL, NULL, 158103),
(158104, '2.60.40.10-FF-004192', NULL, NULL, 83, NULL, NULL, 158104),
(158105, '2.60.40.10-FF-002724', NULL, 'CoLlagen with Endostatin domain', 97, NULL, NULL, 158105),
(158106, '1.20.1250.20-FF-001935', NULL, 'Uncharacterized protein', 567, NULL, NULL, 158106),
(158107, '2.60.120.260-FF-000061', NULL, 'Beta-galactosidase', 138, NULL, NULL, 158107),
(158108, '2.60.40.10-FF-002628', NULL, 'T cell receptor alpha variable 16n', 96, NULL, NULL, 158108),
(158109, '1.25.40.10-FF-004680', NULL, 'Uncharacterized protein', 222, NULL, NULL, 158109),
(158110, '1.25.40.180-FF-000072', NULL, 'Uncharacterized protein', 157, NULL, NULL, 158110),
(158111, '3.90.660.10-FF-000036', NULL, 'Lysine-specific histone demethylase 1 homolog 3', 153, NULL, NULL, 158111);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(158112, '3.10.20.90-FF-000998', NULL, 'Autophagy protein 5', 86, NULL, NULL, 158112),
(158113, '2.20.110.10-FF-000054', NULL, NULL, 77, NULL, NULL, 158113),
(158114, '1.10.287.130-FF-000090', NULL, 'Histidine kinase sensor protein', 76, NULL, NULL, 158114),
(158115, '3.40.50.300-FF-001460', NULL, 'ATP-binding cassette transporter', 243, NULL, NULL, 158115),
(158116, '2.10.25.10-FF-000027', NULL, 'Thrombospondin 3', 48, NULL, NULL, 158116),
(158117, '3.30.260.10-FF-000064', NULL, NULL, 107, NULL, NULL, 158117),
(158118, '3.30.160.60-FF-004736', NULL, NULL, 30, NULL, NULL, 158118),
(158119, '4.10.1030.10-FF-000005', NULL, 'Cullin', 71, NULL, NULL, 158119),
(158120, '1.10.287.3550-FF-000004', NULL, 'stromal interaction molecule homolog isoform X1', 127, NULL, NULL, 158120),
(158121, '3.40.50.2300-FF-000401', NULL, 'DNA-binding response regulator', 133, NULL, NULL, 158121),
(158122, '3.80.10.10-FF-001376', NULL, 'Leucine-rich repeats and IQ motif-containing 1', 177, NULL, NULL, 158122),
(158123, '1.20.1250.20-FF-000351', NULL, 'sodium-dependent lysophosphatidylcholine symporter 1 isoform X4', 217, NULL, NULL, 158123),
(158124, '4.10.1110.10-FF-000006', NULL, 'Zinc finger AN1-type containing 1', 75, NULL, NULL, 158124),
(158125, '1.10.238.10-FF-000906', NULL, 'Mechanosensitive ion channel protein', 101, NULL, NULL, 158125),
(158126, '3.30.2350.10-FF-000071', NULL, 'Uncharacterized protein', 207, NULL, NULL, 158126),
(158127, '3.30.200.20-FF-001839', NULL, 'Receptor protein-tyrosine kinase', 105, NULL, NULL, 158127),
(158128, '2.60.200.20-FF-000089', NULL, 'Probable conserved transmembrane ATP-binding protein ABC transporter', 99, NULL, NULL, 158128),
(158129, '2.60.40.420-FF-000105', NULL, 'WGS project CABT00000000 data, contig 2.7', 232, NULL, NULL, 158129),
(158130, '2.120.10.80-FF-000312', NULL, 'Predicted protein', 176, NULL, NULL, 158130),
(158131, '2.60.40.10-FF-004753', NULL, NULL, 106, NULL, NULL, 158131),
(158132, '2.40.50.140-FF-000320', NULL, '30S ribosomal protein S1', 87, NULL, NULL, 158132),
(158133, '3.40.850.10-FF-000124', NULL, 'Kinesin-like protein', 341, NULL, NULL, 158133),
(158134, '3.40.50.2300-FF-000452', NULL, 'PTS fructose transporter subunit IIB', 103, NULL, NULL, 158134),
(158135, '3.30.420.40-FF-000788', NULL, 'Uncharacterized protein', 174, NULL, NULL, 158135),
(158136, '1.25.40.10-FF-002667', NULL, 'Uncharacterized protein', 304, NULL, NULL, 158136),
(158137, '1.10.10.10-FF-000810', NULL, 'DNA-directed RNA polymerase iii 34 kDa polypeptide, putative', 87, NULL, NULL, 158137),
(158138, '3.30.420.40-FF-001070', NULL, 'Uncharacterized protein', 38, NULL, NULL, 158138),
(158139, '3.30.565.10-FF-000098', NULL, 'Signal transduction histidine-protein kinase ArlS', 151, NULL, NULL, 158139),
(158140, '3.30.230.10-FF-000236', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 174, NULL, NULL, 158140),
(158141, '6.10.250.3430-FF-000001', NULL, 'CurK', 33, NULL, NULL, 158141),
(158142, '1.10.3380.30-FF-000028', NULL, 'Polymerase (DNA directed), theta', 207, NULL, NULL, 158142),
(158143, '3.40.50.12780-FF-000233', NULL, 'Uncharacterized protein', 168, NULL, NULL, 158143),
(158144, '1.10.3210.10-FF-000056', NULL, 'Sam/hd domain containing protein', 298, NULL, NULL, 158144),
(158145, '2.60.40.3960-FF-000001', NULL, 'Sexual development activator VeA', 212, NULL, NULL, 158145),
(158146, '1.10.101.10-FF-000011', NULL, 'PDZ domain-containing protein', 78, NULL, NULL, 158146),
(158147, '1.10.20.10-FF-000069', NULL, 'Transcription initiation factor TFIID subunit', 88, NULL, NULL, 158147),
(158148, '3.30.450.60-FF-000060', NULL, 'Coatomer subunit delta', 139, NULL, NULL, 158148),
(158149, '3.30.300.210-FF-000003', NULL, 'Spore germination protein GerHC', 147, NULL, NULL, 158149),
(158150, '3.30.70.330-FF-001846', NULL, NULL, 114, NULL, NULL, 158150),
(158151, '1.20.58.2140-FF-000010', NULL, 'Translin-like protein', 185, NULL, NULL, 158151),
(158152, '1.10.510.10-FF-003620', NULL, NULL, 196, NULL, NULL, 158152),
(158153, '3.30.470.20-FF-000167', NULL, 'Glutathione synthetase, putative (AFU_orthologue AFUA_5G06610)', 61, NULL, NULL, 158153);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(158154, '3.40.1160.10-FF-000031', NULL, 'Isopentenyl phosphate kinase', 277, NULL, NULL, 158154),
(158155, '3.30.300.90-FF-000002', NULL, 'Acid stress protein IbaG', 84, NULL, NULL, 158155),
(158156, '1.10.1040.10-FF-000031', NULL, 'Glycerol-3-phosphate dehydrogenase (NAD(P)(+))', 141, NULL, NULL, 158156),
(158157, '2.30.29.30-FF-000760', NULL, 'FACT complex subunit POB3', 112, NULL, NULL, 158157),
(158158, '1.25.40.20-FF-001810', NULL, 'E3 ubiquitin-protein ligase mind-bomb-like Protein', 162, NULL, NULL, 158158),
(158159, '1.20.1280.290-FF-000060', NULL, 'Uncharacterized protein', 90, NULL, NULL, 158159),
(158160, '3.30.200.20-FF-002115', NULL, 'Uncharacterized protein', 77, NULL, NULL, 158160),
(158161, '2.30.30.140-FF-000211', NULL, 'Histone acetyltransferase', 102, NULL, NULL, 158161),
(158162, '2.60.120.260-FF-000353', NULL, 'Beta-galactosidase 17', 38, NULL, NULL, 158162),
(158163, '4.10.520.10-FF-000012', NULL, 'DNA-binding protein HU', 91, NULL, NULL, 158163),
(158164, '3.40.50.300-FF-001185', NULL, 'GTPase Der', 176, NULL, NULL, 158164),
(158165, '3.30.910.10-FF-000002', NULL, 'DinI-like family protein', 77, NULL, NULL, 158165),
(158166, '3.30.479.20-FF-000041', NULL, 'Elongation factor Ts', 94, NULL, NULL, 158166),
(158167, '1.25.40.20-FF-000793', NULL, 'Ankyrin repeat family protein', 102, NULL, NULL, 158167),
(158168, '3.40.190.10-FF-000483', NULL, 'Sensory box sensor histidine kinase/response regulator VieS', 122, NULL, NULL, 158168),
(158169, '1.20.1730.10-FF-000053', NULL, 'Uncharacterized protein', 468, NULL, NULL, 158169),
(158170, '3.40.50.12780-FF-000020', NULL, 'Acetyl-coenzyme A synthetase', 446, NULL, NULL, 158170),
(158171, '3.30.910.20-FF-000005', NULL, 'Chaperone protein skp', 145, NULL, NULL, 158171),
(158172, '1.10.10.10-FF-000861', NULL, 'Transcriptional regulator, TrmB', 107, NULL, NULL, 158172),
(158173, '3.30.465.10-FF-000034', NULL, 'FAD binding domain in molybdopterin dehydrogenase', 82, NULL, NULL, 158173),
(158174, '1.25.40.10-FF-000790', NULL, 'Pentatricopeptide repeat-containing protein', 186, NULL, NULL, 158174),
(158175, '1.20.1250.20-FF-002149', NULL, 'Os10g0110600 protein', 198, NULL, NULL, 158175),
(158176, '1.10.510.10-FF-004194', NULL, NULL, 351, NULL, NULL, 158176),
(158177, '3.30.230.10-FF-000023', NULL, 'Putative N-acetylgalactosamine kinase', 192, NULL, NULL, 158177),
(158178, '2.10.25.10-FF-001488', NULL, 'Neurogenic locus notch-like protein 1', 37, NULL, NULL, 158178),
(158179, '3.20.20.70-FF-000121', NULL, 'Dihydropyrimidine dehydrogenase (NADP(+)), chloroplastic', 317, NULL, NULL, 158179),
(158180, '3.40.50.880-FF-000088', NULL, 'Pyridoxine biosynthesis protein PDX2', 219, NULL, NULL, 158180),
(158181, '3.30.70.330-FF-002335', NULL, NULL, 112, NULL, NULL, 158181),
(158182, '2.60.40.10-FF-000830', NULL, 'Turtle, isoform F', 122, NULL, NULL, 158182),
(158183, '1.10.3720.10-FF-000235', NULL, 'Binding-protein-dependent transport systems inner membrane component', 189, NULL, NULL, 158183),
(158184, '3.40.50.2000-FF-000816', NULL, 'Protein CBR-UGT-41', 91, NULL, NULL, 158184),
(158185, '1.10.150.20-FF-000329', NULL, 'RAD51 recombinase', 44, NULL, NULL, 158185),
(158186, '2.60.40.60-FF-000912', NULL, 'Uncharacterized protein', 102, NULL, NULL, 158186),
(158187, '1.25.40.10-FF-000638', NULL, 'Pentatricopeptide repeat domain 1', 104, NULL, NULL, 158187),
(158188, '1.25.40.10-FF-002942', NULL, 'Os02g0116100 protein', 146, NULL, NULL, 158188),
(158189, '2.40.50.140-FF-000527', NULL, 'Methionine sulfoxide reductase B1b', 115, NULL, NULL, 158189),
(158190, '3.40.50.300-FF-006474', NULL, 'ABC transporter, putative', 117, NULL, NULL, 158190),
(158191, '2.60.40.60-FF-000687', NULL, 'Cadherin-4', 104, NULL, NULL, 158191),
(158192, '3.30.479.30-FF-000044', NULL, 'Zgc:112408', 72, NULL, NULL, 158192),
(158193, '3.40.720.10-FF-000120', NULL, 'GG16284', 460, NULL, NULL, 158193),
(158194, '3.30.40.10-FF-000003', NULL, 'E3 SUMO-protein ligase PIAS2 isoform X1', 129, NULL, NULL, 158194),
(158195, '2.40.50.90-FF-000012', NULL, 'serine/threonine-protein kinase 31 isoform X1', 86, NULL, NULL, 158195);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(158196, '1.10.630.10-FF-000133', NULL, 'Putative cytochrome P450 135A1', 422, NULL, NULL, 158196),
(158197, '3.40.50.10190-FF-000041', NULL, 'DNA nucleotidylexotransferase', 102, NULL, NULL, 158197),
(158198, '3.20.20.80-FF-000124', NULL, 'Exported cellulase', 314, NULL, NULL, 158198),
(158199, '3.40.50.970-FF-000177', NULL, 'Pyruvate dehydrogenase E1 component alpha subunit, putative', 123, NULL, NULL, 158199),
(158200, '3.30.160.60-FF-001190', NULL, 'zinc finger transcription factor YY1', 32, NULL, NULL, 158200),
(158201, '3.30.54.20-FF-000010', NULL, NULL, 54, NULL, NULL, 158201),
(158202, '2.30.42.60-FF-000002', NULL, 'Uncharacterized protein', 180, NULL, NULL, 158202),
(158203, '1.10.10.850-FF-000001', NULL, 'Isocitrate lyase', 112, NULL, NULL, 158203),
(158204, '6.10.140.2230-FF-000001', NULL, 'RNA polymerase-associated protein RapA', 52, NULL, NULL, 158204),
(158205, '3.40.50.300-FF-001134', NULL, 'Probable ATP-dependent RNA helicase DDX27', 168, NULL, NULL, 158205),
(158206, '4.10.240.10-FF-000125', NULL, 'Zinc cluster transcription factor, putative', 71, NULL, NULL, 158206),
(158207, '3.90.550.10-FF-000680', NULL, 'Uncharacterized protein', 84, NULL, NULL, 158207),
(158208, '2.60.120.200-FF-000700', NULL, 'Exotoxin A', 230, NULL, NULL, 158208),
(158209, '3.30.200.20-FF-000524', NULL, 'Non-specific serine/threonine protein kinase', 97, NULL, NULL, 158209),
(158210, '3.40.50.10490-FF-000136', NULL, NULL, 151, NULL, NULL, 158210),
(158211, '3.40.1190.20-FF-000120', NULL, 'Multifunctional fusion protein', 277, NULL, NULL, 158211),
(158212, '1.20.1050.10-FF-000074', NULL, 'Elongation factor 1-gamma 1', 140, NULL, NULL, 158212),
(158213, '3.40.50.1440-FF-000098', NULL, 'Uncharacterized protein', 136, NULL, NULL, 158213),
(158214, '3.50.50.60-FF-001389', NULL, 'Lysine-specific histone demethylase 1', 356, NULL, NULL, 158214),
(158215, '3.10.10.10-FF-000053', NULL, NULL, 70, NULL, NULL, 158215),
(158216, '3.30.2350.20-FF-000074', NULL, NULL, 230, NULL, NULL, 158216),
(158217, '2.40.10.240-FF-000010', NULL, NULL, 116, NULL, NULL, 158217),
(158218, '3.30.2070.10-FF-000004', NULL, 'Anaerobic dehydrogenase typically selenocysteine-containing', 66, NULL, NULL, 158218),
(158219, '1.10.950.10-FF-000011', NULL, 'Dematin actin binding protein', 42, NULL, NULL, 158219),
(158220, '2.40.50.140-FF-000371', NULL, 'DNA-directed RNA polymerases I, II, and III subunit RPABC3', 141, NULL, NULL, 158220),
(158221, '3.30.450.20-FF-000284', NULL, 'Helix-loop-helix 34', 94, NULL, NULL, 158221),
(158222, '3.40.50.150-FF-000780', NULL, 'N2,N2-dimethylguanosine tRNA methyltransferase,putative', 112, NULL, NULL, 158222),
(158223, '3.80.10.10-FF-001943', NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase At1g17230', 85, NULL, NULL, 158223),
(158224, '3.30.505.10-FF-000229', NULL, NULL, 92, NULL, NULL, 158224),
(158225, '2.60.40.10-FF-002893', NULL, '1,4-alpha-glucan-branching enzyme-like isoform X1', 112, NULL, NULL, 158225),
(158226, '3.90.190.20-FF-000020', NULL, 'Folylpolyglutamate synthase', 178, NULL, NULL, 158226),
(158227, '2.10.25.10-FF-000471', NULL, 'Protein lin-12', 39, NULL, NULL, 158227),
(158228, '3.40.50.1000-FF-000882', NULL, NULL, 143, NULL, NULL, 158228),
(158229, '1.10.510.10-FF-003507', NULL, NULL, 253, NULL, NULL, 158229),
(158230, '3.30.70.60-FF-000042', NULL, '30S ribosomal protein S6', 94, NULL, NULL, 158230),
(158231, '3.80.10.10-FF-004113', NULL, 'Uncharacterized protein', 117, NULL, NULL, 158231),
(158232, '1.25.10.10-FF-000636', NULL, 'Nipped-B protein', 306, NULL, NULL, 158232),
(158233, '1.25.40.10-FF-004415', NULL, 'Uncharacterized protein', 131, NULL, NULL, 158233),
(158234, '2.60.40.1910-FF-000027', NULL, NULL, 94, NULL, NULL, 158234),
(158235, '2.10.70.10-FF-000103', NULL, 'Coagulation factor XIII B chain', 60, NULL, NULL, 158235),
(158236, '3.90.79.10-FF-000196', NULL, 'Predicted protein', 154, NULL, NULL, 158236),
(158237, '3.40.50.300-FF-002769', NULL, 'DNA repair helicase, putative', 206, NULL, NULL, 158237),
(158238, '3.30.160.60-FF-005080', NULL, NULL, 49, NULL, NULL, 158238);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(158239, '2.30.29.30-FF-000081', NULL, 'Citron rho-interacting serine/threonine kinase', 120, NULL, NULL, 158239),
(158240, '1.10.720.40-FF-000003', NULL, 'thymopoietin isoform X1', 56, NULL, NULL, 158240),
(158241, '4.10.60.10-FF-000216', NULL, 'Uncharacterized protein', 40, NULL, NULL, 158241),
(158242, '3.40.50.620-FF-000089', NULL, 'Bifunctional coenzyme A synthase', 152, NULL, NULL, 158242),
(158243, '1.20.1250.20-FF-001374', NULL, 'YALI0F03795p', 270, NULL, NULL, 158243),
(158244, '1.10.510.10-FF-001321', NULL, 'Myosin light chain kinase, putative', 211, NULL, NULL, 158244),
(158245, '2.40.128.20-FF-000014', NULL, 'THAP domain-containing protein 4 isoform X1', 163, NULL, NULL, 158245),
(158246, '2.10.110.10-FF-000157', NULL, 'LIM/homeobox protein Lhx2', 68, NULL, NULL, 158246),
(158247, '1.10.150.240-FF-000073', NULL, 'Indigoidine synthesis like protein', 67, NULL, NULL, 158247),
(158248, '3.10.200.10-FF-000014', NULL, 'Carbonic anhydrase 1', 268, NULL, NULL, 158248),
(158249, '2.170.300.10-FF-000033', NULL, 'platelet endothelial aggregation receptor 1', 118, NULL, NULL, 158249),
(158250, '2.170.300.10-FF-000090', NULL, 'Uncharacterized protein', 84, NULL, NULL, 158250),
(158251, '2.30.42.10-FF-000627', NULL, NULL, 75, NULL, NULL, 158251),
(158252, '3.40.50.2000-FF-000137', NULL, 'alpha-1,3/1,6-mannosyltransferase ALG2', 182, NULL, NULL, 158252),
(158253, '2.60.420.10-FF-000012', NULL, 'Glycoside hydrolase family 65 protein', 82, NULL, NULL, 158253),
(158254, '1.20.5.420-FF-000007', NULL, 'Receptor protein-tyrosine kinase', 21, NULL, NULL, 158254),
(158255, '1.20.1070.10-FF-000603', NULL, 'neuropeptides B/W receptor type 2-like', 293, NULL, NULL, 158255),
(158256, '3.40.190.290-FF-000082', NULL, 'LysR family transcriptional regulator', 194, NULL, NULL, 158256),
(158257, '3.30.780.10-FF-000002', NULL, 'Stress response translation initiation inhibitor', 81, NULL, NULL, 158257),
(158258, '3.40.50.300-FF-000111', NULL, 'DEAD-box ATP-dependent RNA helicase', 169, NULL, NULL, 158258),
(158259, '3.80.10.10-FF-001937', NULL, 'Uncharacterized protein', 66, NULL, NULL, 158259),
(158260, '3.40.50.300-FF-000696', NULL, 'GPN-loop GTPase', 259, NULL, NULL, 158260),
(158261, '1.10.287.70-FF-000004', NULL, 'Sodium channel protein', 148, NULL, NULL, 158261),
(158262, '1.20.1050.130-FF-000056', NULL, 'Glutamyl(E) Amino-acyl tRNA Synthetase', 136, NULL, NULL, 158262),
(158263, '3.40.50.1580-FF-000027', NULL, 'Uridine and thymidine phosphorylase', 285, NULL, NULL, 158263),
(158264, '1.20.140.40-FF-000052', NULL, NULL, 152, NULL, NULL, 158264),
(158265, '3.90.1150.170-FF-000004', NULL, 'Pyridoxal-dependent decarboxylase domain-containing 1', 108, NULL, NULL, 158265),
(158266, '3.30.450.380-FF-000002', NULL, 'Secretion protein, partial', 135, NULL, NULL, 158266),
(158267, '1.20.1250.20-FF-000912', NULL, 'Major facilitator superfamily MFS_1', 469, NULL, NULL, 158267),
(158268, '3.30.70.330-FF-002902', NULL, NULL, 46, NULL, NULL, 158268),
(158269, '2.40.30.10-FF-000263', NULL, 'Eukaryotic Elongation Factor, SelenoCysteine-tRNA-specific', 85, NULL, NULL, 158269),
(158270, '3.10.50.10-FF-000050', NULL, 'Uncharacterized protein', 63, NULL, NULL, 158270),
(158271, '1.10.510.10-FF-000714', NULL, 'Kinase family with leucine-rich repeat domain-containing protein', 221, NULL, NULL, 158271),
(158272, '1.20.5.400-FF-000001', NULL, 'Cell division protein FtsB', 42, NULL, NULL, 158272),
(158273, '3.30.70.3340-FF-000002', NULL, 'Sulfite reductase beta subunit', 125, NULL, NULL, 158273),
(158274, '3.10.100.10-FF-000294', NULL, NULL, 174, NULL, NULL, 158274),
(158275, '1.20.5.320-FF-000011', NULL, 'Collagen, type XX, alpha 1', 47, NULL, NULL, 158275),
(158276, '1.20.5.110-FF-000015', NULL, 'Syntaxin-18, putative', 99, NULL, NULL, 158276),
(158277, '2.130.10.10-FF-004669', NULL, 'Uncharacterized protein', 185, NULL, NULL, 158277),
(158278, '2.60.40.640-FF-000093', NULL, 'Expressed protein', 131, NULL, NULL, 158278),
(158279, '3.80.10.10-FF-001994', NULL, 'Leucine rich repeat receptor protein kinase 2', 85, NULL, NULL, 158279);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(158280, '3.30.420.40-FF-000693', NULL, 'Carbohydrate kinase FGGY', 248, NULL, NULL, 158280),
(158281, '3.80.10.10-FF-004170', NULL, 'Uncharacterized protein', 274, NULL, NULL, 158281),
(158282, '3.40.718.10-FF-000058', NULL, 'Putative isocitrate dehydrogenase [NAD] subunit-like 4', 288, NULL, NULL, 158282),
(158283, '3.30.1240.10-FF-000034', NULL, 'Cof-type HAD-IIB family hydrolase', 124, NULL, NULL, 158283),
(158284, '1.20.1250.20-FF-002037', NULL, 'Uncharacterized protein', 329, NULL, NULL, 158284),
(158285, '3.90.1150.160-FF-000001', NULL, 'Glutamate decarboxylase', 88, NULL, NULL, 158285),
(158286, '3.10.20.230-FF-000006', NULL, 'Oxygen-regulated protein 1', 105, NULL, NULL, 158286),
(158287, '1.10.510.10-FF-002844', NULL, 'Serine/threonine protein kinase', 333, NULL, NULL, 158287),
(158288, '1.20.120.1750-FF-000148', NULL, 'RBR-type E3 ubiquitin transferase', 94, NULL, NULL, 158288),
(158289, '3.40.50.300-FF-007997', NULL, 'Helicase-like protein', 152, NULL, NULL, 158289),
(158290, '3.80.10.10-FF-000802', NULL, 'F-box protein At-B', 406, NULL, NULL, 158290),
(158291, '3.30.70.3490-FF-000064', NULL, NULL, 97, NULL, NULL, 158291),
(158292, '2.130.10.10-FF-003045', NULL, 'Transducin/WD40 repeat-like superfamily protein', 149, NULL, NULL, 158292),
(158293, '3.90.70.10-FF-000558', NULL, 'Predicted protein', 169, NULL, NULL, 158293),
(158294, '3.90.180.10-FF-000134', NULL, 'Uncharacterized protein', 122, NULL, NULL, 158294),
(158295, '1.10.287.70-FF-000330', NULL, 'Uncharacterized protein', 271, NULL, NULL, 158295),
(158296, '3.30.200.20-FF-000530', NULL, 'receptor protein-tyrosine kinase CEPR1', 96, NULL, NULL, 158296),
(158297, '2.40.50.140-FF-000078', NULL, '30S ribosomal protein S1', 80, NULL, NULL, 158297),
(158298, '1.25.10.10-FF-002873', NULL, 'Meiotic check point regulator-like protein', 154, NULL, NULL, 158298),
(158299, '1.25.40.80-FF-000001', NULL, 'Cryptochrome circadian regulator 2', 125, NULL, NULL, 158299),
(158300, '3.30.200.20-FF-000316', NULL, 'Proto-oncogene serine/threonine-protein kinase mos', 91, NULL, NULL, 158300),
(158301, '1.25.40.90-FF-000004', NULL, 'splicing factor, arginine/serine-rich 15', 139, NULL, NULL, 158301),
(158302, '2.10.50.30-FF-000052', NULL, 'Vomeronasal 2 receptor p1', 37, NULL, NULL, 158302),
(158303, '3.30.1330.60-FF-000028', NULL, 'Peptidoglycan-associated protein', 140, NULL, NULL, 158303),
(158304, '3.40.50.2000-FF-000081', NULL, 'UDP-glucuronosyltransferase 2A2', 261, NULL, NULL, 158304),
(158305, '3.30.70.3030-FF-000010', NULL, 'U3 small nucleolar RNA-associated protein 22', 127, NULL, NULL, 158305),
(158306, '1.10.10.60-FF-000443', NULL, 'Transcription factor MYB36', 62, NULL, NULL, 158306),
(158307, '1.10.1170.10-FF-000029', NULL, 'Death-associated inhibitor of apoptosis 2', 111, NULL, NULL, 158307),
(158308, '3.30.70.980-FF-000057', NULL, 'DNA-binding protein Ets97D-like Protein', 73, NULL, NULL, 158308),
(158309, '1.20.58.610-FF-000007', NULL, 'Hsp90 co-chaperone Cdc37', 117, NULL, NULL, 158309),
(158310, '3.40.50.300-FF-001634', NULL, 'ABC transporter ATP-binding protein', 144, NULL, NULL, 158310),
(158311, '3.30.497.10-FF-000164', NULL, 'Uncharacterized protein', 49, NULL, NULL, 158311),
(158312, '2.60.40.10-FF-003067', NULL, 'Receptor protein-tyrosine kinase', 116, NULL, NULL, 158312),
(158313, '1.20.1510.10-FF-000003', NULL, 'Metal tolerance protein 11', 194, NULL, NULL, 158313),
(158314, '3.40.50.150-FF-000454', NULL, 'tRNA m5C-methyltransferase', 231, NULL, NULL, 158314),
(158315, '3.40.50.2020-FF-000087', NULL, 'Ribose-phosphate pyrophosphokinase, putative', 114, NULL, NULL, 158315),
(158316, '2.60.40.10-FF-005208', NULL, NULL, 91, NULL, NULL, 158316),
(158317, '1.25.40.90-FF-000061', NULL, 'UV-stimulated scaffold protein A', 164, NULL, NULL, 158317),
(158318, '3.30.1330.40-FF-000022', NULL, 'YLR143W-like protein', 122, NULL, NULL, 158318),
(158319, '3.40.50.1000-FF-000556', NULL, NULL, 140, NULL, NULL, 158319),
(158320, '1.10.10.60-FF-000179', NULL, 'Two component, sigma54 specific, transcriptional regulator, Fis family', 56, NULL, NULL, 158320);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(158321, '1.10.150.20-FF-000088', NULL, 'DNA repair protein RadC', 51, NULL, NULL, 158321),
(158322, '3.30.200.20-FF-002407', NULL, 'Uncharacterized protein', 89, NULL, NULL, 158322),
(158323, '3.40.50.300-FF-000971', NULL, 'GTPase RhebL1 isoform X2', 179, NULL, NULL, 158323),
(158324, '1.10.4160.10-FF-000006', NULL, 'NCS1 family nucleobase:cation symporter-1', 463, NULL, NULL, 158324),
(158325, '2.130.10.10-FF-002814', NULL, 'Predicted protein', 376, NULL, NULL, 158325),
(158326, '3.30.559.10-FF-000213', NULL, 'Uncharacterized protein', 195, NULL, NULL, 158326),
(158327, '3.30.160.60-FF-004298', NULL, NULL, 29, NULL, NULL, 158327),
(158328, '2.40.160.50-FF-000025', NULL, 'ShlB/FhaC/HecB family hemolysin secretion/activation protein', 380, NULL, NULL, 158328),
(158329, '1.10.1200.60-FF-000002', NULL, '50S ribosomal protein L19e', 56, NULL, NULL, 158329),
(158330, '1.25.40.20-FF-001922', NULL, 'Ion channel NompC', 105, NULL, NULL, 158330),
(158331, '1.25.40.10-FF-002493', NULL, 'Pentatricopeptide repeat-containing protein At2g18940, chloroplastic', 77, NULL, NULL, 158331),
(158332, '3.30.460.20-FF-000015', NULL, 'Magnesium transport protein CorA', 162, NULL, NULL, 158332),
(158333, '3.90.550.50-FF-000219', NULL, 'Hexosyltransferase', 139, NULL, NULL, 158333),
(158334, '3.90.950.10-FF-000042', NULL, 'dTTP/UTP pyrophosphatase', 192, NULL, NULL, 158334),
(158335, '1.25.40.10-FF-002549', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 146, NULL, NULL, 158335),
(158336, '3.40.50.720-FF-001985', NULL, 'Uncharacterized protein', 246, NULL, NULL, 158336),
(158337, '3.30.460.10-FF-000012', NULL, 'GTP pyrophosphokinase YjbM', 146, NULL, NULL, 158337),
(158338, '3.90.470.10-FF-000050', NULL, 'Uncharacterized protein', 183, NULL, NULL, 158338),
(158339, '3.90.1150.10-FF-000064', NULL, 'Serine hydroxymethyltransferase', 109, NULL, NULL, 158339),
(158340, '3.40.50.1820-FF-000419', NULL, 'Carboxylic ester hydrolase', 351, NULL, NULL, 158340),
(158341, '2.130.10.10-FF-004905', NULL, 'Coronin', 111, NULL, NULL, 158341),
(158342, '1.20.1070.10-FF-001946', NULL, 'Uncharacterized protein', 219, NULL, NULL, 158342),
(158343, '1.25.40.180-FF-000190', NULL, NULL, 225, NULL, NULL, 158343),
(158344, '1.25.40.10-FF-000464', NULL, 'Pentatricopeptide repeat-containing protein', 102, NULL, NULL, 158344),
(158345, '1.25.40.480-FF-000010', NULL, 'Uncharacterized protein', 138, NULL, NULL, 158345),
(158346, '3.90.470.20-FF-000053', NULL, '4''-phosphopantetheinyl transferase', 108, NULL, NULL, 158346),
(158347, '3.40.390.10-FF-000077', NULL, 'Metalloendopeptidase', 169, NULL, NULL, 158347),
(158348, '3.30.590.50-FF-000011', NULL, 'Gamma-glutamylcysteine synthetase', 267, NULL, NULL, 158348),
(158349, '2.60.40.10-FF-004933', NULL, NULL, 89, NULL, NULL, 158349),
(158350, '2.120.10.80-FF-000306', NULL, 'Uncharacterized protein', 184, NULL, NULL, 158350),
(158351, '2.60.40.60-FF-000980', NULL, 'Si:dkey-30k22.7', 105, NULL, NULL, 158351),
(158352, '3.40.1310.20-FF-000001', NULL, 'Replication-associated protein', 116, NULL, NULL, 158352),
(158353, '2.40.30.10-FF-000471', NULL, 'Cytochrome p450 oxidoreductase', 67, NULL, NULL, 158353),
(158354, '2.60.40.10-FF-001999', NULL, 'FiLamiN (Actin binding protein) homolog', 94, NULL, NULL, 158354),
(158355, '2.20.130.20-FF-000002', NULL, 'Complement C4-A', 54, NULL, NULL, 158355),
(158356, '3.80.10.10-FF-003388', NULL, 'F-box and leucine-rich repeat protein 18', 102, NULL, NULL, 158356),
(158357, '1.25.40.20-FF-000467', NULL, 'E3 ubiquitin-protein ligase XB3', 106, NULL, NULL, 158357),
(158358, '3.40.50.1820-FF-001836', NULL, 'Uncharacterized protein', 82, NULL, NULL, 158358),
(158359, '1.25.40.10-FF-000868', NULL, 'SET and MYND domain-containing protein 4', 129, NULL, NULL, 158359),
(158360, '2.40.50.40-FF-000008', NULL, 'Chromodomain-helicase-DNA-binding protein 2 isoform 1', 102, NULL, NULL, 158360),
(158361, '3.10.20.90-FF-000768', NULL, 'Phosphatidylinositol-3-phosphate-binding protein', 127, NULL, NULL, 158361),
(158362, '1.20.1050.10-FF-000315', NULL, 'Chromosome 7, whole genome shotgun sequence', 103, NULL, NULL, 158362);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(158363, '3.40.50.150-FF-000549', NULL, 'tRNA (adenine(58)-N(1))-methyltransferase catalytic subunit TRMT61A', 231, NULL, NULL, 158363),
(158364, '1.20.1070.10-FF-000811', NULL, 'Muscarinic acetylcholine receptor gar-2', 116, NULL, NULL, 158364),
(158365, '3.30.70.270-FF-000153', NULL, 'Uncharacterized protein', 86, NULL, NULL, 158365),
(158366, '2.120.10.80-FF-000363', NULL, 'Nitrile-specifier protein 3', 257, NULL, NULL, 158366),
(158367, '3.80.10.10-FF-004282', NULL, 'Toll-9, isoform A', 246, NULL, NULL, 158367),
(158368, '3.40.710.10-FF-000052', NULL, 'Penicillin-binding protein', 340, NULL, NULL, 158368),
(158369, '3.30.70.330-FF-002009', NULL, NULL, 81, NULL, NULL, 158369),
(158370, '1.25.40.10-FF-003898', NULL, 'Coatomer subunit epsilon-2', 73, NULL, NULL, 158370),
(158371, '1.20.1070.10-FF-001267', NULL, 'Uncharacterized protein', 328, NULL, NULL, 158371),
(158372, '3.30.70.330-FF-001003', NULL, 'Multiple RNA-binding domain-containing protein 1', 108, NULL, NULL, 158372),
(158373, '3.30.200.20-FF-000592', NULL, 'L-type lectin-domain containing receptor kinase V.9', 92, NULL, NULL, 158373),
(158374, '1.25.40.20-FF-001361', NULL, 'Uncharacterized protein', 96, NULL, NULL, 158374),
(158375, '3.30.710.10-FF-000054', NULL, 'Zinc finger and BTB domain-containing protein 14', 145, NULL, NULL, 158375),
(158376, '2.60.40.10-FF-002836', NULL, 'Glucoamylase', 104, NULL, NULL, 158376),
(158377, '3.60.10.10-FF-000230', NULL, 'Predicted protein', 258, NULL, NULL, 158377),
(158378, '1.25.40.10-FF-000189', NULL, 'Tetratricopeptide repeat domain 25', 168, NULL, NULL, 158378),
(158379, '3.40.50.300-FF-008391', NULL, 'ATP-dependent DNA helicase recQ', 191, NULL, NULL, 158379),
(158380, '3.40.50.150-FF-001443', NULL, NULL, 145, NULL, NULL, 158380),
(158381, '3.10.20.90-FF-000886', NULL, 'RanBP-type and C3HC4-type zinc finger-containing protein 1', 56, NULL, NULL, 158381),
(158382, '2.30.29.30-FF-000434', NULL, 'Rho guanine nucleotide exchange factor 17', 218, NULL, NULL, 158382),
(158383, '3.90.1310.10-FF-000037', NULL, 'Probable peptidoglycan D,D-transpeptidase PbpC', 121, NULL, NULL, 158383),
(158384, '3.40.190.10-FF-000775', NULL, 'ABC-type transport system periplasmic substrate-binding protein (Probable substrate dipeptide/oligopeptide)', 304, NULL, NULL, 158384),
(158385, '2.40.30.120-FF-000001', NULL, 'Capsid protein VP1', 96, NULL, NULL, 158385),
(158386, '3.40.50.2300-FF-000805', NULL, NULL, 80, NULL, NULL, 158386),
(158387, '3.30.160.60-FF-000875', NULL, 'zinc finger protein 236 isoform X7', 29, NULL, NULL, 158387),
(158388, '1.20.1070.10-FF-001385', NULL, 'Vomeronasal type-1 receptor', 248, NULL, NULL, 158388),
(158389, '3.40.50.80-FF-000046', NULL, 'Probable ferric reductase transmembrane component', 199, NULL, NULL, 158389),
(158390, '2.160.20.10-FF-000217', NULL, 'Uncharacterized protein', 312, NULL, NULL, 158390),
(158391, '3.10.310.40-FF-000003', NULL, 'Alanine--tRNA ligase', 108, NULL, NULL, 158391),
(158392, '1.20.140.150-FF-000036', NULL, 'Voltage-dependent calcium channel gamma-4 subunit', 151, NULL, NULL, 158392),
(158393, '2.30.30.40-FF-000558', NULL, 'Predicted protein', 63, NULL, NULL, 158393),
(158394, '3.40.50.1440-FF-000126', NULL, 'Uncharacterized protein', 216, NULL, NULL, 158394),
(158395, '3.40.50.720-FF-001928', NULL, 'Uncharacterized protein', 290, NULL, NULL, 158395),
(158396, '3.10.20.90-FF-000829', NULL, 'Autophagy-related protein', 127, NULL, NULL, 158396),
(158397, '2.40.160.110-FF-000040', NULL, 'Predicted protein', 199, NULL, NULL, 158397),
(158398, '3.40.50.300-FF-001426', NULL, 'DNA helicase', 151, NULL, NULL, 158398),
(158399, '1.25.40.10-FF-004792', NULL, 'Predicted protein', 173, NULL, NULL, 158399),
(158400, '3.40.640.10-FF-000136', NULL, 'Possible aminotransferase', 257, NULL, NULL, 158400),
(158401, '1.25.40.10-FF-003044', NULL, 'Crooked neck protein', 88, NULL, NULL, 158401),
(158402, '1.20.120.20-FF-000033', NULL, 'Uncharacterized protein At4g13230', 96, NULL, NULL, 158402),
(158403, '3.30.70.330-FF-002627', NULL, NULL, 126, NULL, NULL, 158403),
(158404, '2.60.40.60-FF-000979', NULL, 'Uncharacterized protein', 107, NULL, NULL, 158404);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(158405, '2.10.25.10-FF-001567', NULL, 'Uncharacterized protein', 58, NULL, NULL, 158405),
(158406, '1.10.510.10-FF-002159', NULL, 'Kinase, NEK', 238, NULL, NULL, 158406),
(158407, '3.30.160.60-FF-001482', NULL, 'Hunchback', 59, NULL, NULL, 158407),
(158408, '3.40.50.720-FF-000361', NULL, 'Acyl-CoA synthetase FdrA', 82, NULL, NULL, 158408),
(158409, '2.130.10.10-FF-002871', NULL, 'Related to KOG1-Subunit of TORC1, a rapamycin-sensitive complex involved in growth control', 152, NULL, NULL, 158409),
(158410, '1.20.1390.10-FF-000009', NULL, 'RNA binding (RRM/RBD/RNP motifs) family protein', 80, NULL, NULL, 158410),
(158411, '1.10.30.50-FF-000008', NULL, 'Phage endonuclease', 93, NULL, NULL, 158411),
(158412, '3.10.310.50-FF-000006', NULL, 'Sll1390 protein', 149, NULL, NULL, 158412),
(158413, '2.60.40.10-FF-005416', NULL, NULL, 84, NULL, NULL, 158413),
(158414, '3.40.850.10-FF-000444', NULL, 'Uncharacterized protein', 125, NULL, NULL, 158414),
(158415, '3.90.550.50-FF-000158', NULL, 'AGAP009562-PA', 130, NULL, NULL, 158415),
(158416, '2.40.50.140-FF-000819', NULL, NULL, 172, NULL, NULL, 158416),
(158417, '3.30.70.330-FF-000536', NULL, 'RNA-binding protein 6, isoform G', 114, NULL, NULL, 158417),
(158418, '2.40.10.10-FF-000374', NULL, NULL, 77, NULL, NULL, 158418),
(158419, '2.40.10.350-FF-000004', NULL, 'Cell shape-determining protein MreC', 90, NULL, NULL, 158419),
(158420, '1.10.472.10-FF-000647', NULL, 'Predicted protein', 115, NULL, NULL, 158420),
(158421, '2.130.10.10-FF-002606', NULL, 'Ribosome biogenesis protein WDR12 homolog', 359, NULL, NULL, 158421),
(158422, '3.30.60.30-FF-000229', NULL, 'Uncharacterized protein', 53, NULL, NULL, 158422),
(158423, '3.60.20.10-FF-000236', NULL, NULL, 89, NULL, NULL, 158423),
(158424, '3.30.420.60-FF-000002', NULL, 'Protein pelota homolog', 134, NULL, NULL, 158424),
(158425, '1.10.730.10-FF-000079', NULL, 'Isoleucyl-tRNA synthetase, cytoplasmic, putative', 190, NULL, NULL, 158425),
(158426, '2.40.50.100-FF-000095', NULL, 'Efflux transporter, RND family, MFP subunit', 71, NULL, NULL, 158426),
(158427, '1.10.20.10-FF-000283', NULL, NULL, 73, NULL, NULL, 158427),
(158428, '1.25.40.20-FF-001602', NULL, 'Diacylglycerol kinase', 111, NULL, NULL, 158428),
(158429, '3.30.420.40-FF-000816', NULL, 'Putative nodulation protein nolNO', 123, NULL, NULL, 158429),
(158430, '2.130.10.10-FF-003888', NULL, 'Uncharacterized protein', 275, NULL, NULL, 158430),
(158431, '3.30.160.60-FF-002842', NULL, 'zinc finger and BTB domain-containing protein 49 isoform X2', 29, NULL, NULL, 158431),
(158432, '2.120.10.30-FF-000376', NULL, 'Uncharacterized protein', 144, NULL, NULL, 158432),
(158433, '3.30.160.60-FF-005304', NULL, NULL, 28, NULL, NULL, 158433),
(158434, '1.20.58.60-FF-000131', NULL, 'Spectrin beta chain', 107, NULL, NULL, 158434),
(158435, '1.10.8.270-FF-000116', NULL, 'Small G protein-signaling modulator 1b', 59, NULL, NULL, 158435),
(158436, '1.10.510.10-FF-002491', NULL, NULL, 125, NULL, NULL, 158436),
(158437, '2.40.10.340-FF-000001', NULL, 'Cell shape-determining protein MreC', 72, NULL, NULL, 158437),
(158438, '2.120.10.80-FF-000284', NULL, 'Uncharacterized protein', 125, NULL, NULL, 158438),
(158439, '3.40.50.300-FF-003225', NULL, 'Structural maintenance of chromosomes protein 5', 159, NULL, NULL, 158439),
(158440, '3.80.10.10-FF-004523', NULL, 'FBD, F-box and Leucine Rich Repeat domains containing protein', 299, NULL, NULL, 158440),
(158441, '3.40.630.10-FF-000175', NULL, 'Double-zinc aminopeptidase', 239, NULL, NULL, 158441),
(158442, '3.40.190.170-FF-000006', NULL, 'C4-dicarboxylate ABC transporter', 309, NULL, NULL, 158442),
(158443, '1.10.10.410-FF-000010', NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit B, mitochondrial', 60, NULL, NULL, 158443),
(158444, '1.20.1280.120-FF-000003', NULL, 'Catalase-related peroxidase', 81, NULL, NULL, 158444),
(158445, '3.20.110.10-FF-000016', NULL, 'Alpha-mannosidase', 163, NULL, NULL, 158445),
(158446, '1.10.10.10-FF-001878', NULL, 'Uncharacterized protein', 50, NULL, NULL, 158446),
(158447, '1.20.910.10-FF-000006', NULL, 'Bifunctional TH2 protein, mitochondrial', 238, NULL, NULL, 158447);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(158448, '3.30.300.30-FF-000063', NULL, 'Acyl-CoA ligase sidI', 123, NULL, NULL, 158448),
(158449, '1.10.555.10-FF-000042', NULL, 'rho GTPase-activating protein 11A isoform X1', 253, NULL, NULL, 158449),
(158450, '3.30.760.10-FF-000057', NULL, 'Predicted gene 20696', 97, NULL, NULL, 158450),
(158451, '2.60.40.10-FF-000925', NULL, 'immunoglobulin superfamily member 10', 90, NULL, NULL, 158451),
(158452, '2.60.120.10-FF-000782', NULL, 'Uncharacterized protein', 158, NULL, NULL, 158452),
(158453, '3.10.100.10-FF-000029', NULL, 'Mannose receptor C type 2', 141, NULL, NULL, 158453),
(158454, '3.30.300.20-FF-000060', NULL, 'Uncharacterized protein', 66, NULL, NULL, 158454),
(158455, '3.40.50.720-FF-001367', NULL, 'D-2-hydroxy-acid dehydrogenase-like', 94, NULL, NULL, 158455),
(158456, '1.10.533.10-FF-000284', NULL, 'NLR family, CARD domain-containing 3-like', 92, NULL, NULL, 158456),
(158457, '2.60.40.60-FF-000704', NULL, 'Fat-like cadherin-related tumor suppressor homolog', 102, NULL, NULL, 158457),
(158458, '1.20.1280.20-FF-000010', NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', 81, NULL, NULL, 158458),
(158459, '3.40.50.150-FF-001454', NULL, NULL, 139, NULL, NULL, 158459),
(158460, '3.30.70.120-FF-000035', NULL, NULL, 103, NULL, NULL, 158460),
(158461, '3.40.190.10-FF-000500', NULL, 'CG15327', 143, NULL, NULL, 158461),
(158462, '4.10.240.10-FF-000030', NULL, 'C6 transcription factor, putative', 80, NULL, NULL, 158462),
(158463, '3.40.50.720-FF-001996', NULL, 'Uncharacterized protein', 234, NULL, NULL, 158463),
(158464, '1.25.40.10-FF-002881', NULL, 'Uncharacterized protein', 236, NULL, NULL, 158464),
(158465, '2.60.470.10-FF-000015', NULL, 'Pickpocket 20, isoform B', 179, NULL, NULL, 158465),
(158466, '2.60.40.10-FF-003331', NULL, 'Down syndrome cell adhesion molecule b', 72, NULL, NULL, 158466),
(158467, '1.10.340.30-FF-000072', NULL, 'Helix-hairpin-helix motif', 113, NULL, NULL, 158467),
(158468, '3.30.160.60-FF-004641', NULL, NULL, 56, NULL, NULL, 158468),
(158469, '3.40.50.10140-FF-000054', NULL, 'Toll-like receptor2', 149, NULL, NULL, 158469),
(158470, '2.60.40.150-FF-000389', NULL, 'Phosphoinositide phospholipase C', 129, NULL, NULL, 158470),
(158471, '3.30.70.330-FF-002285', NULL, NULL, 117, NULL, NULL, 158471),
(158472, '1.25.40.10-FF-004292', NULL, 'Pentatricopeptide repeat-containing protein 5, mitochondrial', 201, NULL, NULL, 158472),
(158473, '3.80.10.10-FF-001590', NULL, 'MDIS1-interacting receptor like kinase 1', 109, NULL, NULL, 158473),
(158474, '3.40.30.10-FF-001087', NULL, 'Sulfhydryl oxidase', 106, NULL, NULL, 158474),
(158475, '1.10.510.10-FF-000692', NULL, 'Serine/threonine protein kinase, variant', 325, NULL, NULL, 158475),
(158476, '3.40.1440.10-FF-000013', NULL, 'Structure-specific endonuclease subunit SLX1 homolog', 102, NULL, NULL, 158476),
(158477, '1.25.40.10-FF-002824', NULL, 'Mitochondrial group I intron splicing factor CCM1', 148, NULL, NULL, 158477),
(158478, '2.130.10.10-FF-004405', NULL, 'Protein CBG02012', 373, NULL, NULL, 158478),
(158479, '2.60.40.10-FF-005130', NULL, NULL, 96, NULL, NULL, 158479),
(158480, '3.20.20.80-FF-000006', NULL, 'Beta-galactosidase', 320, NULL, NULL, 158480),
(158481, '2.60.40.60-FF-001025', NULL, 'Uncharacterized protein', 101, NULL, NULL, 158481),
(158482, '3.40.640.10-FF-000344', NULL, 'Low-specificity L-threonine aldolase', 249, NULL, NULL, 158482),
(158483, '3.40.309.10-FF-000052', NULL, 'Aldehyde dehydrogenase', 193, NULL, NULL, 158483),
(158484, '3.30.470.20-FF-000072', NULL, 'Biotin carboxylase subunit of acetyl CoA carboxylase', 138, NULL, NULL, 158484),
(158485, '3.30.160.60-FF-006439', NULL, NULL, 35, NULL, NULL, 158485),
(158486, '3.40.50.2300-FF-001469', NULL, NULL, 149, NULL, NULL, 158486),
(158487, '3.30.40.10-FF-002015', NULL, 'Lysine-specific demethylase 5C', 46, NULL, NULL, 158487),
(158488, '1.20.1080.10-FF-000076', NULL, 'aquaporin-like', 255, NULL, NULL, 158488),
(158489, '2.120.10.30-FF-000319', NULL, 'Bll6325 protein', 165, NULL, NULL, 158489),
(158490, '2.60.15.10-FF-000002', NULL, 'ATP synthase epsilon chain, chloroplastic', 87, NULL, NULL, 158490);
INSERT INTO "PUBLIC"."MODEL" VALUES
(158491, '1.10.260.40-FF-000074', NULL, 'Homeobox protein cut-like', 81, NULL, NULL, 158491),
(158492, '1.10.418.10-FF-000207', NULL, 'Uncharacterized protein', 130, NULL, NULL, 158492),
(158493, '3.20.20.70-FF-000003', NULL, 'GMP reductase', 487, NULL, NULL, 158493),
(158494, '3.10.110.10-FF-000187', NULL, 'Uncharacterized protein', 113, NULL, NULL, 158494),
(158495, '3.40.50.1240-FF-000156', NULL, NULL, 217, NULL, NULL, 158495),
(158496, '1.20.1280.290-FF-000026', NULL, 'PQ loop repeat protein', 118, NULL, NULL, 158496),
(158497, '1.25.10.10-FF-003121', NULL, 'Uncharacterized protein', 209, NULL, NULL, 158497),
(158498, '3.30.1520.10-FF-000016', NULL, 'Sorting nexin 2', 127, NULL, NULL, 158498),
(158499, '3.90.640.10-FF-000271', NULL, 'Actin-like protein 3', 103, NULL, NULL, 158499),
(158500, '3.90.340.10-FF-000012', NULL, 'Uncharacterized protein', 108, NULL, NULL, 158500),
(158501, '3.20.20.80-FF-000236', NULL, 'Arabinogalactan endo-beta-1,4-galactanase', 360, NULL, NULL, 158501),
(158502, '1.10.3720.10-FF-000027', NULL, 'Arginine ABC transporter, permease protein ArtQ', 227, NULL, NULL, 158502),
(158503, '1.10.287.10-FF-000008', NULL, 'histidine--tRNA ligase, cytoplasmic isoform X6', 47, NULL, NULL, 158503),
(158504, '1.10.238.10-FF-000671', NULL, 'Uncharacterized protein', 99, NULL, NULL, 158504),
(158505, '2.30.280.10-FF-000007', NULL, NULL, 121, NULL, NULL, 158505),
(158506, '3.90.70.10-FF-000497', NULL, 'Si:ch211-165f21.4', 343, NULL, NULL, 158506),
(158507, '3.90.70.80-FF-000023', NULL, 'OTU ovarian tumor-like cysteine protease', 159, NULL, NULL, 158507),
(158508, '1.10.472.10-FF-000029', NULL, 'Cyclin h', 101, NULL, NULL, 158508),
(158509, '1.20.1740.10-FF-000222', NULL, 'Uncharacterized protein', 56, NULL, NULL, 158509),
(158510, '2.130.10.10-FF-005400', NULL, 'Uncharacterized protein', 146, NULL, NULL, 158510),
(158511, '2.60.34.10-FF-000074', NULL, 'Heat shock protein 110, putative', 170, NULL, NULL, 158511),
(158512, '1.25.40.180-FF-000122', NULL, 'CaGCR3 protein', 317, NULL, NULL, 158512),
(158513, '3.80.10.10-FF-002039', NULL, 'Insulin-like growth factor-binding protein acid labile subunit', 73, NULL, NULL, 158513),
(158514, '3.30.559.10-FF-000005', NULL, 'Dihydrolipoyllysine-residue succinyltransferase component of 2-oxoglutarate dehydrogenase complex', 244, NULL, NULL, 158514),
(158515, '3.30.260.10-FF-000025', NULL, 'Chaperonin containing TCP1 subunit 2', 105, NULL, NULL, 158515),
(158516, '3.30.420.40-FF-000075', NULL, 'Actin-related protein 10 homolog', 136, NULL, NULL, 158516),
(158517, '1.20.1280.130-FF-000006', NULL, 'Vacuolar protein sorting 54 family protein', 91, NULL, NULL, 158517),
(158518, '1.20.210.10-FF-000037', NULL, 'Cytochrome c oxidase subunit 1', 275, NULL, NULL, 158518),
(158519, '2.60.120.200-FF-000200', NULL, 'Laminin subunit alpha-3', 179, NULL, NULL, 158519),
(158520, '3.40.50.300-FF-008514', NULL, 'Valosin-containing protein homolog, putative', 149, NULL, NULL, 158520),
(158521, '2.10.109.10-FF-000036', NULL, 'DEAD/DEAH box helicase', 139, NULL, NULL, 158521),
(158522, '3.30.429.10-FF-000001', NULL, 'Macrophage migration inhibitory factor', 115, NULL, NULL, 158522),
(158523, '2.160.20.10-FF-000037', NULL, 'Probable exopolygalacturonase C', 397, NULL, NULL, 158523),
(158524, '3.90.175.10-FF-000004', NULL, 'Grass carp reovirus (GCRV)-induced gene 2e', 109, NULL, NULL, 158524),
(158525, '1.10.600.10-FF-000131', NULL, 'Uncharacterized protein', 88, NULL, NULL, 158525),
(158526, '3.30.160.60-FF-001690', NULL, 'Zinc finger and SCAN domain containing 5A', 27, NULL, NULL, 158526),
(158527, '2.60.40.10-FF-002393', NULL, 'Lys-gingipain 381', 83, NULL, NULL, 158527),
(158528, '3.40.50.720-FF-002159', NULL, 'Uncharacterized protein', 78, NULL, NULL, 158528),
(158529, '1.20.1280.50-FF-000249', NULL, 'Predicted protein', 39, NULL, NULL, 158529),
(158530, '3.10.100.10-FF-000361', NULL, NULL, 85, NULL, NULL, 158530),
(158531, '1.20.1070.10-FF-000250', NULL, 'probable G-protein coupled receptor 141', 295, NULL, NULL, 158531),
(158532, '3.30.470.30-FF-000075', NULL, 'Putative DNA ligase 4', 124, NULL, NULL, 158532);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(158533, '3.80.10.10-FF-003467', NULL, 'Uncharacterized protein', 329, NULL, NULL, 158533),
(158534, '1.25.40.10-FF-004679', NULL, 'Predicted protein', 107, NULL, NULL, 158534),
(158535, '1.10.510.10-FF-002569', NULL, 'Non-specific protein-tyrosine kinase', 254, NULL, NULL, 158535),
(158536, '1.20.1070.10-FF-002048', NULL, 'Uncharacterized protein', 104, NULL, NULL, 158536),
(158537, '1.20.1000.10-FF-000037', NULL, NULL, 251, NULL, NULL, 158537),
(158538, '1.20.1250.20-FF-000412', NULL, 'SIT1p Ferrioxamine B transporter', 207, NULL, NULL, 158538),
(158539, '1.10.510.10-FF-004289', NULL, NULL, 167, NULL, NULL, 158539),
(158540, '2.40.70.10-FF-000467', NULL, NULL, 165, NULL, NULL, 158540),
(158541, '3.30.50.10-FF-000043', NULL, 'Sexual development transcription factor NsdD', 65, NULL, NULL, 158541),
(158542, '2.130.10.10-FF-005220', NULL, 'Uncharacterized protein', 78, NULL, NULL, 158542),
(158543, '1.20.5.20-FF-000002', NULL, 'Apolipoprotein A-IV b, tandem duplicate 1', 46, NULL, NULL, 158543),
(158544, '1.10.1200.80-FF-000008', NULL, 'tRNA-dihydrouridine synthase', 70, NULL, NULL, 158544),
(158545, '3.10.20.870-FF-000024', NULL, NULL, 66, NULL, NULL, 158545),
(158546, '2.130.10.10-FF-002882', NULL, 'Katanin p80 WD40 repeat-containing subunit B1 homolog', 141, NULL, NULL, 158546),
(158547, '3.40.50.1820-FF-001757', NULL, 'Uncharacterized protein', 305, NULL, NULL, 158547),
(158548, '1.20.1250.20-FF-001694', NULL, 'Uncharacterized protein', 223, NULL, NULL, 158548),
(158549, '2.30.30.940-FF-000007', NULL, 'ATP-dependent RecD-like DNA helicase', 71, NULL, NULL, 158549),
(158550, '1.10.274.100-FF-000004', NULL, 'DNA-directed RNA polymerase subunit', 175, NULL, NULL, 158550),
(158551, '1.20.1530.20-FF-000069', NULL, 'Predicted protein', 158, NULL, NULL, 158551),
(158552, '2.130.10.10-FF-004944', NULL, 'Uncharacterized protein', 100, NULL, NULL, 158552),
(158553, '3.90.420.10-FF-000013', NULL, 'Oxidoreductase molybdopterin binding', 199, NULL, NULL, 158553),
(158554, '2.40.50.140-FF-000432', NULL, 'ABC sugar transporter, ATP-binding protein', 57, NULL, NULL, 158554),
(158555, '2.130.10.10-FF-000454', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit WDR4', 286, NULL, NULL, 158555),
(158556, '3.80.10.10-FF-001258', NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', 155, NULL, NULL, 158556),
(158557, '3.40.50.300-FF-001073', NULL, 'ATP-binding Cassette (ABC) Superfamily', 214, NULL, NULL, 158557),
(158558, '1.20.1250.20-FF-001874', NULL, 'Pyrazinamidase/nicotinamidase, putative', 108, NULL, NULL, 158558),
(158559, '1.25.70.10-FF-000078', NULL, 'Uncharacterized protein', 287, NULL, NULL, 158559),
(158560, '1.25.10.10-FF-001530', NULL, 'Serine/threonine-protein kinase sepA', 223, NULL, NULL, 158560),
(158561, '2.170.210.20-FF-000001', NULL, 'Spindle assembly abnormal protein 6 homolog', 190, NULL, NULL, 158561),
(158562, '1.20.1310.10-FF-000027', NULL, 'Anaphase-promoting complex subunit 2', 102, NULL, NULL, 158562),
(158563, '1.20.1250.20-FF-002150', NULL, 'Uncharacterized protein', 198, NULL, NULL, 158563),
(158564, '1.10.1300.10-FF-000068', NULL, 'Uncharacterized protein', 119, NULL, NULL, 158564),
(158565, '1.20.1050.130-FF-000045', NULL, 'Uncharacterized protein', 124, NULL, NULL, 158565),
(158566, '1.10.472.10-FF-000259', NULL, 'Putative cyclin-D7-1', 121, NULL, NULL, 158566),
(158567, '2.60.120.260-FF-000465', NULL, 'Reelin', 69, NULL, NULL, 158567),
(158568, '2.30.30.30-FF-000117', NULL, 'Putative ribosomal protein S4 (RPS4A) family protein', 23, NULL, NULL, 158568),
(158569, '3.50.50.60-FF-000933', NULL, 'NADH-rubredoxin oxidoreductase', 165, NULL, NULL, 158569),
(158570, '1.20.1250.20-FF-001817', NULL, 'Uncharacterized protein', 155, NULL, NULL, 158570),
(158571, '3.30.300.30-FF-000006', NULL, 'Long-chain-fatty-acid--CoA ligase FadD', 102, NULL, NULL, 158571),
(158572, '3.40.50.10490-FF-000041', NULL, 'Transcriptional regulator, RpiR family', 184, NULL, NULL, 158572),
(158573, '1.10.1370.10-FF-000016', NULL, 'Thimet oligopeptidase 1', 240, NULL, NULL, 158573);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(158574, '1.10.1320.10-FF-000013', NULL, 'DNA-directed RNA polymerase', 337, NULL, NULL, 158574),
(158575, '3.40.390.10-FF-000251', NULL, NULL, 245, NULL, NULL, 158575),
(158576, '2.10.25.10-FF-001831', NULL, 'Uncharacterized protein', 63, NULL, NULL, 158576),
(158577, '3.30.720.150-FF-000001', NULL, 'UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase 110 kDa subunit', 133, NULL, NULL, 158577),
(158578, '3.30.160.60-FF-001072', NULL, 'zinc finger and BTB domain-containing protein 11', 29, NULL, NULL, 158578),
(158579, '2.60.40.2860-FF-000008', NULL, '6-cysteine protein', 153, NULL, NULL, 158579),
(158580, '3.40.50.460-FF-000018', NULL, 'Phosphofructokinase', 159, NULL, NULL, 158580),
(158581, '3.40.190.10-FF-000707', NULL, 'Taurine ABC transporter, periplasmic taurine-binding protein', 174, NULL, NULL, 158581),
(158582, '3.80.10.10-FF-001876', NULL, 'Predicted protein', 171, NULL, NULL, 158582),
(158583, '1.10.357.10-FF-000071', NULL, 'Transcriptional regulatory protein', 134, NULL, NULL, 158583),
(158584, '3.90.226.10-FF-000286', NULL, 'Enoyl-CoA-hydratase', 207, NULL, NULL, 158584),
(158585, '1.10.510.10-FF-000978', NULL, 'Protein kinase family protein / WD-40 repeat family protein', 190, NULL, NULL, 158585),
(158586, '3.30.160.60-FF-004287', NULL, NULL, 72, NULL, NULL, 158586),
(158587, '1.10.287.3700-FF-000010', NULL, 'PAB-dependent poly(A)-specific ribonuclease subunit PAN3, putative', 59, NULL, NULL, 158587),
(158588, '2.60.40.10-FF-003410', NULL, NULL, 99, NULL, NULL, 158588),
(158589, '3.40.50.1980-FF-000153', NULL, 'Sll1202 protein', 141, NULL, NULL, 158589),
(158590, '3.30.160.60-FF-003281', NULL, 'Kruppel like factor 9', 24, NULL, NULL, 158590),
(158591, '3.30.560.10-FF-000008', NULL, 'NinaG, isoform B', 298, NULL, NULL, 158591),
(158592, '3.10.100.10-FF-000086', NULL, 'PKD1 isoform 1', 148, NULL, NULL, 158592),
(158593, '3.30.430.20-FF-000064', NULL, 'Plasmodesmata-located protein 4', 105, NULL, NULL, 158593),
(158594, '2.60.40.10-FF-004692', NULL, NULL, 95, NULL, NULL, 158594),
(158595, '2.30.42.10-FF-000009', NULL, 'Putative tight junction protein ZO-1', 59, NULL, NULL, 158595),
(158596, '2.40.50.40-FF-000076', NULL, 'Uncharacterized protein', 72, NULL, NULL, 158596),
(158597, '3.30.230.10-FF-000141', NULL, '30S ribosomal protein S9', 127, NULL, NULL, 158597),
(158598, '3.40.190.10-FF-000365', NULL, 'Oligopeptide ABC transporter OppAIV', 132, NULL, NULL, 158598),
(158599, '2.60.40.150-FF-000569', NULL, 'Multiple C2 and transmembrane domain-containing protein 1', 151, NULL, NULL, 158599),
(158600, '2.60.40.10-FF-002516', NULL, 'Twitchin', 97, NULL, NULL, 158600),
(158601, '2.60.40.10-FF-001201', NULL, 'Usherin', 109, NULL, NULL, 158601),
(158602, '3.30.750.24-FF-000087', NULL, 'Anion exchange transporter', 141, NULL, NULL, 158602),
(158603, '3.30.70.330-FF-001964', NULL, NULL, 78, NULL, NULL, 158603),
(158604, '3.30.430.20-FF-000007', NULL, 'Cysteine-rich receptor-like protein kinase 11', 109, NULL, NULL, 158604),
(158605, '1.10.357.40-FF-000001', NULL, 'Swarming motility protein ybiA', 154, NULL, NULL, 158605),
(158606, '3.90.230.10-FF-000066', NULL, NULL, 133, NULL, NULL, 158606),
(158607, '1.25.40.510-FF-000002', NULL, 'Protein GLE1', 275, NULL, NULL, 158607),
(158608, '1.10.630.10-FF-000015', NULL, 'Cholesterol side-chain cleavage enzyme, mitochondrial', 473, NULL, NULL, 158608),
(158609, '1.10.510.10-FF-003007', NULL, NULL, 58, NULL, NULL, 158609),
(158610, '3.90.930.12-FF-000026', NULL, NULL, 52, NULL, NULL, 158610),
(158611, '3.30.160.60-FF-001414', NULL, 'telomere zinc finger-associated protein isoform X1', 30, NULL, NULL, 158611),
(158612, '1.10.472.100-FF-000003', NULL, 'Presenilin', 102, NULL, NULL, 158612),
(158613, '3.50.50.60-FF-000192', NULL, 'Dihydrolipoamide dehydrogenase', 41, NULL, NULL, 158613),
(158614, '2.30.42.10-FF-000066', NULL, 'Rho GTPase activating protein 21', 123, NULL, NULL, 158614),
(158615, '3.40.720.10-FF-000002', NULL, 'Phosphopentomutase', 279, NULL, NULL, 158615),
(158616, '3.90.550.50-FF-000197', NULL, 'Hexosyltransferase', 191, NULL, NULL, 158616);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(158617, '1.25.10.10-FF-002665', NULL, 'Protein MOR1', 96, NULL, NULL, 158617),
(158618, '1.20.58.60-FF-000760', NULL, 'AT10293p', 259, NULL, NULL, 158618),
(158619, '1.25.40.10-FF-004472', NULL, 'Uncharacterized protein', 421, NULL, NULL, 158619),
(158620, '3.40.50.300-FF-004849', NULL, 'Elongation factor G, mitochondrial', 286, NULL, NULL, 158620),
(158621, '3.30.1370.10-FF-000246', NULL, 'LD38872p', 66, NULL, NULL, 158621),
(158622, '3.30.1370.120-FF-000022', NULL, 'Fimbrial assembly protein PilQ', 124, NULL, NULL, 158622),
(158623, '3.90.1150.10-FF-000053', NULL, 'Cysteine desulfurase NifS', 101, NULL, NULL, 158623),
(158624, '1.20.5.30-FF-000005', NULL, 'Matrilin 3b', 43, NULL, NULL, 158624),
(158625, '3.30.70.270-FF-000232', NULL, NULL, 93, NULL, NULL, 158625),
(158626, '1.25.40.10-FF-002263', NULL, 'Protein VAC14-like protein', 41, NULL, NULL, 158626),
(158627, '2.40.30.30-FF-000010', NULL, 'Riboflavin kinase / fad synthetase, putative', 123, NULL, NULL, 158627),
(158628, '3.40.50.1760-FF-000025', NULL, NULL, 136, NULL, NULL, 158628),
(158629, '3.30.70.600-FF-000022', NULL, 'Uncharacterized protein', 94, NULL, NULL, 158629),
(158630, '3.30.160.60-FF-004848', NULL, NULL, 40, NULL, NULL, 158630),
(158631, '3.30.40.10-FF-000391', NULL, 'E3 ubiquitin protein ligase RIE1', 69, NULL, NULL, 158631),
(158632, '3.20.20.140-FF-000399', NULL, 'Uncharacterized protein', 130, NULL, NULL, 158632),
(158633, '1.10.1420.10-FF-000077', NULL, 'DNA mismatch repair protein MSH2', 94, NULL, NULL, 158633),
(158634, '2.10.25.10-FF-000139', NULL, 'Fibulin-1', 43, NULL, NULL, 158634),
(158635, '1.25.40.530-FF-000008', NULL, 'unconventional myosin-XV', 175, NULL, NULL, 158635),
(158636, '2.120.10.10-FF-000038', NULL, 'Sortilin', 184, NULL, NULL, 158636),
(158637, '2.40.70.10-FF-000260', NULL, 'ASpartyl Protease', 160, NULL, NULL, 158637),
(158638, '3.40.50.150-FF-000662', NULL, '23S rRNA (Uracil-5-)-methyltransferase RumA', 204, NULL, NULL, 158638),
(158639, '3.40.50.10330-FF-000021', NULL, 'NAD kinase 2, mitochondrial', 169, NULL, NULL, 158639),
(158640, '1.10.238.10-FF-001053', NULL, 'EF hand family protein', 92, NULL, NULL, 158640),
(158641, '3.40.630.10-FF-000287', NULL, 'Uncharacterized protein', 297, NULL, NULL, 158641),
(158642, '1.10.600.10-FF-000070', NULL, 'Geranylgeranyl pyrophosphate synthase', 281, NULL, NULL, 158642),
(158643, '1.10.472.10-FF-000473', NULL, 'Uncharacterized protein', 69, NULL, NULL, 158643),
(158644, '2.10.25.10-FF-001275', NULL, 'Predicted protein', 94, NULL, NULL, 158644),
(158645, '1.10.8.270-FF-000178', NULL, 'TBC domain containing protein', 103, NULL, NULL, 158645),
(158646, '3.40.50.300-FF-004675', NULL, 'Type II secretion system protein E', 284, NULL, NULL, 158646),
(158647, '1.25.10.10-FF-003042', NULL, 'Uncharacterized protein', 295, NULL, NULL, 158647),
(158648, '1.10.4160.10-FF-000040', NULL, 'Uncharacterized permease C1683.05', 467, NULL, NULL, 158648),
(158649, '3.40.1090.10-FF-000048', NULL, 'Patatin-like protein, PlpD', 112, NULL, NULL, 158649),
(158650, '2.40.70.10-FF-000029', NULL, 'Aspartyl protease family protein', 184, NULL, NULL, 158650),
(158651, '1.25.10.10-FF-000928', NULL, 'Uncharacterized protein', 419, NULL, NULL, 158651),
(158652, '2.40.10.10-FF-000604', NULL, NULL, 251, NULL, NULL, 158652),
(158653, '2.70.98.10-FF-000114', NULL, 'Predicted protein', 244, NULL, NULL, 158653),
(158654, '1.20.1070.10-FF-001891', NULL, 'Uncharacterized protein', 290, NULL, NULL, 158654),
(158655, '3.40.50.300-FF-003107', NULL, 'RecBCD enzyme subunit RecC', 184, NULL, NULL, 158655),
(158656, '3.30.160.60-FF-003224', NULL, NULL, 26, NULL, NULL, 158656),
(158657, '3.30.160.60-FF-004798', NULL, NULL, 28, NULL, NULL, 158657),
(158658, '4.10.400.10-FF-000296', NULL, 'Uncharacterized protein', 40, NULL, NULL, 158658),
(158659, '1.20.1740.10-FF-000110', NULL, 'Spore germination protein SB', 363, NULL, NULL, 158659),
(158660, '3.30.160.60-FF-005422', NULL, NULL, 38, NULL, NULL, 158660),
(158661, '1.10.150.60-FF-000021', NULL, 'Chromatin structure-remodeling complex subunit rsc9', 115, NULL, NULL, 158661); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(158662, '2.40.10.10-FF-000548', NULL, NULL, 79, NULL, NULL, 158662),
(158663, '3.30.200.20-FF-000081', NULL, 'Octicosapeptide/phox/Bem1p domain kinase superfamily protein', 95, NULL, NULL, 158663),
(158664, '3.40.50.1370-FF-000021', NULL, 'Aspartate carbamoyltransferase', 159, NULL, NULL, 158664),
(158665, '3.30.160.60-FF-004854', NULL, NULL, 29, NULL, NULL, 158665),
(158666, '3.40.50.300-FF-003045', NULL, 'GD10885', 150, NULL, NULL, 158666),
(158667, '1.20.120.810-FF-000005', NULL, 'Protein CBR-DEB-1, isoform b', 226, NULL, NULL, 158667),
(158668, '3.40.50.720-FF-002160', NULL, 'Uncharacterized protein', 77, NULL, NULL, 158668),
(158669, '2.60.40.10-FF-000987', NULL, 'Protogenin', 99, NULL, NULL, 158669),
(158670, '3.30.559.70-FF-000034', NULL, 'Choline/Carnitine o-acyltransferase, putative', 193, NULL, NULL, 158670),
(158671, '2.60.40.820-FF-000051', NULL, 'Uncharacterized protein', 144, NULL, NULL, 158671),
(158672, '3.30.420.40-FF-001013', NULL, 'Forkhead-associated (FHA) domain-containing protein', 56, NULL, NULL, 158672),
(158673, '1.20.1310.10-FF-000078', NULL, 'Cullin homolog 1', 130, NULL, NULL, 158673),
(158674, '1.20.80.10-FF-000033', NULL, 'RIC1 protein', 97, NULL, NULL, 158674),
(158675, '3.30.1680.10-FF-000067', NULL, 'Integrin beta', 51, NULL, NULL, 158675),
(158676, '3.30.1050.10-FF-000036', NULL, 'Alkyl/aryl-sulfatase BDS1', 144, NULL, NULL, 158676),
(158677, '2.60.40.10-FF-004309', NULL, NULL, 101, NULL, NULL, 158677),
(158678, '3.20.20.80-FF-000118', NULL, 'Probable bifunctional chitinase/lysozyme', 312, NULL, NULL, 158678),
(158679, '3.30.160.60-FF-000583', NULL, 'Zinc finger protein 800 (Predicted)', 80, NULL, NULL, 158679),
(158680, '2.40.50.90-FF-000001', NULL, 'Staphylococcal nuclease domain-containing protein', 158, NULL, NULL, 158680),
(158681, '1.10.150.80-FF-000027', NULL, 'ATP-dependent helicase SGS1', 81, NULL, NULL, 158681),
(158682, '4.10.400.10-FF-000189', NULL, 'low-density lipoprotein receptor 1', 44, NULL, NULL, 158682),
(158683, '3.40.30.10-FF-001148', NULL, 'Uncharacterized protein', 41, NULL, NULL, 158683),
(158684, '3.30.70.330-FF-002397', NULL, NULL, 158, NULL, NULL, 158684),
(158685, '1.10.30.10-FF-000188', NULL, 'Upstream-binding factor 1-like protein 1', 94, NULL, NULL, 158685),
(158686, '3.30.160.20-FF-000200', NULL, 'Blanks', 69, NULL, NULL, 158686),
(158687, '3.30.540.10-FF-000075', NULL, 'Predicted protein', 194, NULL, NULL, 158687),
(158688, '1.10.560.10-FF-000077', NULL, 'Chaperonin 60, putative', 244, NULL, NULL, 158688),
(158689, '2.30.230.10-FF-000004', NULL, 'Vitellogenin-1', 287, NULL, NULL, 158689),
(158690, '1.10.238.10-FF-001008', NULL, 'Mitochondrial substrate carrier family protein B', 115, NULL, NULL, 158690),
(158691, '1.20.1050.10-FF-000254', NULL, 'Glutathione S-transferase, putative', 18, NULL, NULL, 158691),
(158692, '3.30.160.60-FF-001999', NULL, 'Zinc finger protein 195', 26, NULL, NULL, 158692),
(158693, '3.50.50.60-FF-000372', NULL, 'Lysine-specific histone demethylase 1', 158, NULL, NULL, 158693),
(158694, '3.30.70.330-FF-002127', NULL, NULL, 105, NULL, NULL, 158694),
(158695, '1.25.40.10-FF-004174', NULL, 'Uncharacterized protein', 96, NULL, NULL, 158695),
(158696, '3.40.50.620-FF-000443', NULL, 'Protein kinase protein with adenine nucleotide alpha hydrolase-like domain', 148, NULL, NULL, 158696),
(158697, '1.25.40.20-FF-000759', NULL, 'Uncharacterized protein', 274, NULL, NULL, 158697),
(158698, '1.10.620.20-FF-000017', NULL, 'Ribonucleoside-diphosphate reductase small chain A', 319, NULL, NULL, 158698),
(158699, '1.20.1050.10-FF-000310', NULL, 'Uncharacterized protein', 130, NULL, NULL, 158699),
(158700, '3.10.110.10-FF-000069', NULL, 'vacuolar protein sorting-associated protein 37A', 106, NULL, NULL, 158700),
(158701, '1.20.5.390-FF-000009', NULL, 'Protein CBR-EEA-1', 56, NULL, NULL, 158701),
(158702, '1.20.930.70-FF-000003', NULL, 'Uncharacterized protein', 94, NULL, NULL, 158702),
(158703, '3.20.190.10-FF-000021', NULL, 'Glycosylase', 128, NULL, NULL, 158703),
(158704, '1.20.5.370-FF-000003', NULL, 'Myosin heavy chain', 43, NULL, NULL, 158704);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(158705, '2.30.42.10-FF-000442', NULL, NULL, 125, NULL, NULL, 158705),
(158706, '2.40.160.10-FF-000069', NULL, 'Uncharacterized protein', 82, NULL, NULL, 158706),
(158707, '1.10.168.10-FF-000002', NULL, 'Phosducin, isoform CRA_a', 46, NULL, NULL, 158707),
(158708, '2.30.250.10-FF-000011', NULL, 'Aspartyl aminopeptidase', 86, NULL, NULL, 158708),
(158709, '1.25.40.180-FF-000307', NULL, NULL, 63, NULL, NULL, 158709),
(158710, '2.60.200.10-FF-000029', NULL, 'Dwarfin sma', 205, NULL, NULL, 158710),
(158711, '3.50.50.60-FF-000158', NULL, 'Rab GDP dissociation inhibitor', 175, NULL, NULL, 158711),
(158712, '3.30.310.210-FF-000005', NULL, 'Flowering locus K homology domain', 147, NULL, NULL, 158712),
(158713, '3.10.129.10-FF-000168', NULL, 'Hypothetical cytosolic protein', 259, NULL, NULL, 158713),
(158714, '1.20.1250.20-FF-001992', NULL, 'Antibiotic resistance (Efflux) protein, conjectural', 387, NULL, NULL, 158714),
(158715, '2.130.10.10-FF-002819', NULL, 'Uncharacterized protein', 137, NULL, NULL, 158715),
(158716, '3.30.565.10-FF-000385', NULL, 'Integral membrane sensor signal transduction histidine kinase', 145, NULL, NULL, 158716),
(158717, '1.10.238.10-FF-001160', NULL, 'Uncharacterized protein', 111, NULL, NULL, 158717),
(158718, '3.80.10.10-FF-001589', NULL, 'Uncharacterized protein', 158, NULL, NULL, 158718),
(158719, '2.30.42.10-FF-000335', NULL, 'NHERF (Mammalian Na/H Exchange Regulatory Factor) Like', 104, NULL, NULL, 158719),
(158720, '3.40.50.1220-FF-000004', NULL, 'Electron transfer flavoprotein', 129, NULL, NULL, 158720),
(158721, '4.10.1050.10-FF-000001', NULL, 'Zinc finger protein 706', 72, NULL, NULL, 158721),
(158722, '3.40.1160.10-FF-000020', NULL, 'Glutamate 5-kinase', 194, NULL, NULL, 158722),
(158723, '3.80.10.10-FF-002157', NULL, 'Jetlag, isoform B', 258, NULL, NULL, 158723),
(158724, '2.170.270.10-FF-000171', NULL, 'Histone-lysine N-methyltransferase set-1', 105, NULL, NULL, 158724),
(158725, '1.10.10.60-FF-000735', NULL, 'Putative transcription factor gt-2', 62, NULL, NULL, 158725),
(158726, '3.30.70.2610-FF-000002', NULL, 'RNA polymerase II transcription factor B subunit 2', 75, NULL, NULL, 158726),
(158727, '2.40.50.140-FF-000319', NULL, '30S ribosomal protein S1', 88, NULL, NULL, 158727),
(158728, '3.40.50.1820-FF-000178', NULL, 'Carboxymethylenebutenolidase homolog', 219, NULL, NULL, 158728),
(158729, '2.60.40.10-FF-003056', NULL, 'Leptin receptor', 74, NULL, NULL, 158729),
(158730, '1.20.140.150-FF-000098', NULL, 'Voltage-dependent calcium channel, putative', 155, NULL, NULL, 158730),
(158731, '1.10.287.1490-FF-000066', NULL, 'Uncharacterized protein', 189, NULL, NULL, 158731),
(158732, '1.10.10.60-FF-000628', NULL, 'Myb-like DNA-binding domain containing protein, putative', 68, NULL, NULL, 158732),
(158733, '2.130.10.10-FF-000639', NULL, 'Leucine-rich repeat and WD repeat-containing protein KIAA1239', 70, NULL, NULL, 158733),
(158734, '3.30.40.10-FF-001003', NULL, 'Zinc finger domain containing protein', 65, NULL, NULL, 158734),
(158735, '3.30.40.10-FF-001970', NULL, 'Uncharacterized protein', 62, NULL, NULL, 158735),
(158736, '1.20.120.1240-FF-000034', NULL, 'Dynamin 1 like', 212, NULL, NULL, 158736),
(158737, '1.10.287.70-FF-000341', NULL, 'Protein CBR-TWK-30', 325, NULL, NULL, 158737),
(158738, '2.60.120.200-FF-000065', NULL, 'Laminin subunit alpha 2', 161, NULL, NULL, 158738),
(158739, '2.40.20.10-FF-000088', NULL, 'Uncharacterized protein', 108, NULL, NULL, 158739),
(158740, '1.20.58.60-FF-000193', NULL, 'Spectrin repeat containing, nuclear envelope 1a', 310, NULL, NULL, 158740),
(158741, '2.70.9.30-FF-000001', NULL, 'Major capsid protein P3', 242, NULL, NULL, 158741),
(158742, '3.30.200.20-FF-002098', NULL, 'Mitogen-activated protein kinase', 80, NULL, NULL, 158742),
(158743, '1.10.472.100-FF-000008', NULL, NULL, 102, NULL, NULL, 158743),
(158744, '3.40.50.720-FF-001485', NULL, 'SUMO1 activating enzyme subunit 1', 114, NULL, NULL, 158744),
(158745, '2.130.10.10-FF-000746', NULL, 'THO Complex (Transcription factor/nuclear export) subunit', 142, NULL, NULL, 158745);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(158746, '1.20.1070.10-FF-001598', NULL, 'Uncharacterized protein', 152, NULL, NULL, 158746),
(158747, '3.30.160.60-FF-000690', NULL, 'Zinc finger protein 354C', 30, NULL, NULL, 158747),
(158748, '3.30.70.330-FF-002346', NULL, NULL, 108, NULL, NULL, 158748),
(158749, '3.30.70.20-FF-000047', NULL, 'Formate dehydrogenase, alpha subunit', 81, NULL, NULL, 158749),
(158750, '3.30.360.10-FF-000089', NULL, 'Oxidoreductase', 220, NULL, NULL, 158750),
(158751, '2.20.70.10-FF-000193', NULL, 'Uncharacterized protein', 60, NULL, NULL, 158751),
(158752, '1.20.1300.20-FF-000001', NULL, 'Ubiquitin thioesterase OTUB1', 144, NULL, NULL, 158752),
(158753, '3.55.50.30-FF-000032', NULL, 'SusC/RagA family TonB-linked outer membrane protein', 76, NULL, NULL, 158753),
(158754, '3.10.100.10-FF-000355', NULL, NULL, 95, NULL, NULL, 158754),
(158755, '3.30.420.10-FF-000240', NULL, 'YALI0F25729p', 152, NULL, NULL, 158755),
(158756, '3.30.390.30-FF-000012', NULL, 'Putative dihydrolipoamide dehydrogenase', 124, NULL, NULL, 158756),
(158757, '2.130.10.10-FF-005170', NULL, 'Uncharacterized protein', 129, NULL, NULL, 158757),
(158758, '1.10.10.60-FF-000954', NULL, NULL, 65, NULL, NULL, 158758),
(158759, '1.20.5.170-FF-000005', NULL, 'Tropomyosin alpha-1 chain', 61, NULL, NULL, 158759),
(158760, '1.10.246.90-FF-000022', NULL, 'NOP56 ribonucleoprotein homolog', 63, NULL, NULL, 158760),
(158761, '3.40.50.1000-FF-000848', NULL, NULL, 63, NULL, NULL, 158761),
(158762, '1.20.1050.90-FF-000002', NULL, 'DNA replication and repair protein RecF', 193, NULL, NULL, 158762),
(158763, '1.25.10.10-FF-002278', NULL, 'Uncharacterized protein', 334, NULL, NULL, 158763),
(158764, '2.40.50.770-FF-000003', NULL, 'tudor domain-containing protein 3 isoform X2', 78, NULL, NULL, 158764),
(158765, '1.10.287.130-FF-000207', NULL, 'GAF sensor signal transduction histidine kinase', 90, NULL, NULL, 158765),
(158766, '1.10.287.10-FF-000014', NULL, 'Methionyl-tRNA synthetase', 51, NULL, NULL, 158766),
(158767, '3.40.50.720-FF-000703', NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase', 115, NULL, NULL, 158767),
(158768, '1.10.340.30-FF-000038', NULL, 'DNA glycosylase', 120, NULL, NULL, 158768),
(158769, '1.20.1080.10-FF-000082', NULL, 'Formate transporter', 254, NULL, NULL, 158769),
(158770, '3.40.50.720-FF-000922', NULL, 'Uncharacterized protein', 254, NULL, NULL, 158770),
(158771, '3.40.190.10-FF-000039', NULL, 'Glutamate receptor', 34, NULL, NULL, 158771),
(158772, '3.30.390.50-FF-000018', NULL, 'AGAP012186-PA', 89, NULL, NULL, 158772),
(158773, '1.20.120.1080-FF-000020', NULL, 'ATP dependent RNA helicase, putative', 156, NULL, NULL, 158773),
(158774, '1.25.40.10-FF-000582', NULL, 'E3 SUMO-protein ligase RanBP2', 146, NULL, NULL, 158774),
(158775, '3.40.50.1820-FF-000234', NULL, 'GG17261', 230, NULL, NULL, 158775),
(158776, '3.40.50.300-FF-005350', NULL, 'ABC transporter ATP-binding protein uup-1', 257, NULL, NULL, 158776),
(158777, '1.25.10.10-FF-000187', NULL, 'Coatomer subunit gamma', 185, NULL, NULL, 158777),
(158778, '3.40.50.720-FF-000243', NULL, 'Ubiquitin-like modifier-activating enzyme ATG7', 360, NULL, NULL, 158778),
(158779, '1.20.1070.10-FF-000249', NULL, 'Adhesion G protein-coupled receptor G5', 282, NULL, NULL, 158779),
(158780, '1.20.58.850-FF-000001', NULL, 'Chromosome partition protein MukB', 86, NULL, NULL, 158780),
(158781, '1.20.1250.20-FF-000238', NULL, 'Major facilitator superfamily domain containing 2B', 213, NULL, NULL, 158781),
(158782, '1.20.1250.20-FF-001929', NULL, 'Transporter', 215, NULL, NULL, 158782),
(158783, '2.60.120.290-FF-000221', NULL, 'Subtilisin-like serine peptidase', 113, NULL, NULL, 158783),
(158784, '2.60.40.1510-FF-000019', NULL, 'Integrin subunit alpha 4', 149, NULL, NULL, 158784),
(158785, '1.20.1070.10-FF-001828', NULL, 'Vasopressin v1a recpetor, putative', 306, NULL, NULL, 158785),
(158786, '3.30.200.20-FF-000822', NULL, 'cAMP-dependent protein kinase catalytic subunit, putative', 102, NULL, NULL, 158786),
(158787, '2.30.170.20-FF-000013', NULL, '50S ribosomal protein L24e', 60, NULL, NULL, 158787);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(158788, '3.40.1380.20-FF-000011', NULL, 'Pyruvate kinase', 116, NULL, NULL, 158788),
(158789, '3.60.40.10-FF-000350', NULL, 'Predicted protein', 343, NULL, NULL, 158789),
(158790, '3.10.310.10-FF-000017', NULL, 'Diaminopimelate epimerase', 129, NULL, NULL, 158790),
(158791, '1.10.10.10-FF-001024', NULL, 'Heat-inducible transcription repressor HrcA', 90, NULL, NULL, 158791),
(158792, '2.30.30.40-FF-000497', NULL, 'SH3 and multiple ankyrin repeat domains 2', 60, NULL, NULL, 158792),
(158793, '2.40.50.140-FF-001101', NULL, NULL, 94, NULL, NULL, 158793),
(158794, '3.60.90.10-FF-000010', NULL, 'S-adenosylmethionine decarboxylase-ornithine decarboxylase', 267, NULL, NULL, 158794),
(158795, '1.20.1280.130-FF-000001', NULL, 'Vacuolar protein sorting-associated protein 54', 95, NULL, NULL, 158795),
(158796, '2.60.40.60-FF-001137', NULL, 'Predicted protein', 52, NULL, NULL, 158796),
(158797, '3.30.70.60-FF-000031', NULL, 'Mitochondrial ribosomal protein S6', 117, NULL, NULL, 158797),
(158798, '3.30.200.20-FF-000934', NULL, 'Kinase family protein', 95, NULL, NULL, 158798),
(158799, '3.30.70.270-FF-000119', NULL, 'GGDEF family protein', 179, NULL, NULL, 158799),
(158800, '3.80.10.10-FF-003736', NULL, 'Uncharacterized protein', 132, NULL, NULL, 158800),
(158801, '3.30.160.60-FF-003331', NULL, 'paternally-expressed gene 3 protein', 56, NULL, NULL, 158801),
(158802, '1.50.10.130-FF-000007', NULL, NULL, 17, NULL, NULL, 158802),
(158803, '3.40.50.10810-FF-000244', NULL, 'SNF2 family N-terminal domain containing protein', 169, NULL, NULL, 158803),
(158804, '3.50.50.60-FF-000484', NULL, 'Glutathione reductase, mitochondrial', 219, NULL, NULL, 158804),
(158805, '3.20.20.450-FF-000025', NULL, 'PAS-containing EAL phosphodiesterase', 241, NULL, NULL, 158805),
(158806, '2.130.10.10-FF-000965', NULL, 'Autophagy-like protein 18 Atg18', 286, NULL, NULL, 158806),
(158807, '3.30.420.40-FF-000631', NULL, 'Actin-related protein 8', 64, NULL, NULL, 158807),
(158808, '3.40.50.20-FF-000023', NULL, 'ATP-grasp domain protein', 104, NULL, NULL, 158808),
(158809, '3.30.70.1450-FF-000019', NULL, 'Putative Na+/sulfate symporter', 70, NULL, NULL, 158809),
(158810, '3.30.70.1430-FF-000013', NULL, 'Transporter, AcrB/D/F family', 112, NULL, NULL, 158810),
(158811, '3.40.50.2300-FF-000463', NULL, 'ANTAR domain-containing response regulator', 137, NULL, NULL, 158811),
(158812, '3.30.470.30-FF-000013', NULL, 'DNA ligase', 233, NULL, NULL, 158812),
(158813, '1.25.40.20-FF-000815', NULL, 'Uncharacterized protein', 108, NULL, NULL, 158813),
(158814, '3.40.50.360-FF-000090', NULL, 'NADPH oxidoreductase A', 192, NULL, NULL, 158814),
(158815, '1.20.58.110-FF-000009', NULL, '30S ribosomal protein S20 chloroplastic', 40, NULL, NULL, 158815),
(158816, '3.40.50.970-FF-000020', NULL, 'Pyruvate dehydrogenase E1 component subunit alpha, mitochondrial', 371, NULL, NULL, 158816),
(158817, '3.30.70.260-FF-000116', NULL, 'GTP pyrophosphokinase', 81, NULL, NULL, 158817),
(158818, '3.10.129.110-FF-000021', NULL, 'Non-ribosomal peptide synthase', 261, NULL, NULL, 158818),
(158819, '3.40.630.90-FF-000002', NULL, 'Uncharacterized protein', 142, NULL, NULL, 158819),
(158820, '3.10.129.10-FF-000112', NULL, 'YALI0A19096p', 127, NULL, NULL, 158820),
(158821, '1.25.40.420-FF-000071', NULL, 'Uncharacterized protein', 76, NULL, NULL, 158821),
(158822, '3.30.40.10-FF-001695', NULL, 'E3 ubiquitin-protein ligase TRIM71', 69, NULL, NULL, 158822),
(158823, '3.30.70.1440-FF-000016', NULL, NULL, 99, NULL, NULL, 158823),
(158824, '3.40.30.10-FF-000873', NULL, 'Uncharacterized protein', 62, NULL, NULL, 158824),
(158825, '1.20.58.100-FF-000006', NULL, 'L-aspartate oxidase', 111, NULL, NULL, 158825),
(158826, '3.40.47.10-FF-000164', NULL, NULL, 106, NULL, NULL, 158826),
(158827, '3.30.1700.10-FF-000002', NULL, 'Probable UDP-3-O-acyl-N-acetylglucosamine deacetylase 3, mitochondrial', 154, NULL, NULL, 158827),
(158828, '3.40.50.300-FF-006766', NULL, 'Uncharacterized protein', 62, NULL, NULL, 158828),
(158829, '2.30.42.10-FF-000386', NULL, NULL, 111, NULL, NULL, 158829),
(158830, '1.25.40.10-FF-002903', NULL, 'U3 small nucleolar RNA-associated protein 6 like', 202, NULL, NULL, 158830);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(158831, '2.60.40.150-FF-000619', NULL, 'Predicted protein', 147, NULL, NULL, 158831),
(158832, '3.40.50.1220-FF-000116', NULL, 'Uncharacterized protein', 69, NULL, NULL, 158832),
(158833, '1.20.1060.10-FF-000024', NULL, 'Uncharacterized protein', 119, NULL, NULL, 158833),
(158834, '2.60.40.60-FF-000648', NULL, 'Uncharacterized protein', 101, NULL, NULL, 158834),
(158835, '1.25.40.20-FF-001304', NULL, 'GA-binding protein subunit beta-1-like isoform X1', 153, NULL, NULL, 158835),
(158836, '1.20.5.320-FF-000016', NULL, 'Collagen type XXVI alpha 1 chain', 46, NULL, NULL, 158836),
(158837, '3.60.10.10-FF-000415', NULL, 'Uncharacterized protein', 203, NULL, NULL, 158837),
(158838, '3.30.160.60-FF-001151', NULL, 'zinc finger homeobox protein 3', 28, NULL, NULL, 158838),
(158839, '3.40.190.290-FF-000104', NULL, 'Transcriptional regulatory protein', 206, NULL, NULL, 158839),
(158840, '3.30.428.10-FF-000033', NULL, 'Hnt2p', 144, NULL, NULL, 158840),
(158841, '3.30.565.10-FF-000334', NULL, 'Two-component sensor kinase czcS', 152, NULL, NULL, 158841),
(158842, '3.10.180.10-FF-000017', NULL, 'Methylmalonyl-CoA epimerase /ethylmalonyl-CoA epimerase', 138, NULL, NULL, 158842),
(158843, '3.40.50.2000-FF-000524', NULL, '3-deoxy-D-manno-octulosonic acid transferase', 188, NULL, NULL, 158843),
(158844, '3.30.1520.10-FF-000174', NULL, 'GTPase-activating protein BEM3', 110, NULL, NULL, 158844),
(158845, '1.25.40.10-FF-001301', NULL, 'Os11g0433100 protein', 92, NULL, NULL, 158845),
(158846, '1.20.1060.20-FF-000027', NULL, NULL, 70, NULL, NULL, 158846),
(158847, '2.30.42.10-FF-000116', NULL, 'Phosphatidylinositol-3,4,5-trisphosphate dependent Rac exchange factor 2', 80, NULL, NULL, 158847),
(158848, '2.30.29.30-FF-000316', NULL, 'Arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 2', 134, NULL, NULL, 158848),
(158849, '3.30.160.60-FF-004528', NULL, NULL, 35, NULL, NULL, 158849),
(158850, '3.30.470.20-FF-000010', NULL, 'Glutathione synthetase', 121, NULL, NULL, 158850),
(158851, '1.25.40.10-FF-000812', NULL, 'Putative pentatricopeptide repeat family protein', 133, NULL, NULL, 158851),
(158852, '3.10.50.10-FF-000049', NULL, 'CHiTinase', 65, NULL, NULL, 158852),
(158853, '2.60.40.10-FF-005192', NULL, NULL, 117, NULL, NULL, 158853),
(158854, '1.25.10.10-FF-000698', NULL, 'RING-type E3 ubiquitin transferase', 201, NULL, NULL, 158854),
(158855, '2.30.29.30-FF-000193', NULL, 'arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 3', 102, NULL, NULL, 158855),
(158856, '1.10.1380.10-FF-000011', NULL, 'GM12465', 358, NULL, NULL, 158856),
(158857, '1.25.10.10-FF-001030', NULL, 'Proteasome activator complex subunit 4 isoform A', 218, NULL, NULL, 158857),
(158858, '3.30.420.40-FF-000524', NULL, 'Actin related protein 3, putative', 137, NULL, NULL, 158858),
(158859, '3.40.1110.10-FF-000489', NULL, NULL, 40, NULL, NULL, 158859),
(158860, '3.30.200.60-FF-000019', NULL, 'Uncharacterized protein', 38, NULL, NULL, 158860),
(158861, '1.10.420.10-FF-000033', NULL, 'L-ascorbate peroxidase 3', 106, NULL, NULL, 158861),
(158862, '3.50.50.60-FF-000433', NULL, 'NAD(P)/FAD-dependent oxidoreductase', 148, NULL, NULL, 158862),
(158863, '1.10.10.60-FF-001117', NULL, NULL, 64, NULL, NULL, 158863),
(158864, '3.40.50.410-FF-000150', NULL, 'Protein BONZAI 2', 129, NULL, NULL, 158864),
(158865, '1.20.930.20-FF-000016', NULL, 'Uncharacterized protein', 121, NULL, NULL, 158865),
(158866, '3.30.200.40-FF-000013', NULL, 'Uncharacterized protein', 22, NULL, NULL, 158866),
(158867, '1.10.510.10-FF-001153', NULL, 'Putative serine/threonine protein kinase', 267, NULL, NULL, 158867),
(158868, '3.30.160.60-FF-002488', NULL, 'Zinc finger protein 709', 34, NULL, NULL, 158868),
(158869, '3.60.40.10-FF-000243', NULL, 'Uncharacterized protein', 180, NULL, NULL, 158869),
(158870, '2.30.38.10-FF-000011', NULL, 'Non-ribosomal peptide synthetase', 76, NULL, NULL, 158870),
(158871, '1.10.1450.10-FF-000135', NULL, 'Uncharacterized protein', 100, NULL, NULL, 158871),
(158872, '2.10.25.10-FF-001449', NULL, 'Uncharacterized protein', 43, NULL, NULL, 158872);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(158873, '3.30.200.20-FF-002391', NULL, 'Protein CBG12765', 100, NULL, NULL, 158873),
(158874, '1.10.10.10-FF-001350', NULL, 'Crp/Fnr family transcriptional regulator', 75, NULL, NULL, 158874),
(158875, '1.10.287.3700-FF-000009', NULL, 'PAB-dependent poly(A)-specific ribonuclease subunit pan3-like', 99, NULL, NULL, 158875),
(158876, '3.30.50.10-FF-000009', NULL, 'nuclear receptor subfamily 4 group A member 2', 99, NULL, NULL, 158876),
(158877, '3.30.70.330-FF-000828', NULL, 'Eukaryotic translation initiation factor 3 subunit G', 172, NULL, NULL, 158877),
(158878, '1.10.1450.10-FF-000079', NULL, 'Tetraspanin', 111, NULL, NULL, 158878),
(158879, '1.20.930.10-FF-000013', NULL, 'Transcription factor IWS1', 142, NULL, NULL, 158879),
(158880, '3.30.497.10-FF-000046', NULL, 'RE27547p', 239, NULL, NULL, 158880),
(158881, '1.25.10.10-FF-000754', NULL, 'RING-type E3 ubiquitin transferase', 123, NULL, NULL, 158881),
(158882, '3.30.40.10-FF-000216', NULL, 'E3 ubiquitin-protein ligase TRIM41 isoform X1', 72, NULL, NULL, 158882),
(158883, '1.10.418.10-FF-000089', NULL, 'Spectrin beta chain', 76, NULL, NULL, 158883),
(158884, '2.120.10.30-FF-000078', NULL, 'low-density lipoprotein receptor-related protein 6 isoform X2', 127, NULL, NULL, 158884),
(158885, '1.10.10.10-FF-002098', NULL, 'Uncharacterized protein', 42, NULL, NULL, 158885),
(158886, '3.30.160.60-FF-001307', NULL, 'zinc finger protein 140 isoform X3', 28, NULL, NULL, 158886),
(158887, '3.30.980.10-FF-000040', NULL, 'Threonine--tRNA ligase mitochondrial 1', 62, NULL, NULL, 158887),
(158888, '3.90.1150.10-FF-000390', NULL, 'Ornithine aminotransferase', 18, NULL, NULL, 158888),
(158889, '3.30.200.160-FF-000010', NULL, 'Uncharacterized protein B18D24.130', 130, NULL, NULL, 158889),
(158890, '1.20.58.60-FF-000423', NULL, 'periplakin isoform X1', 103, NULL, NULL, 158890),
(158891, '1.10.287.1970-FF-000007', NULL, 'Alanine aminotransferase', 25, NULL, NULL, 158891),
(158892, '1.25.40.10-FF-004179', NULL, 'Uncharacterized protein', 90, NULL, NULL, 158892),
(158893, '3.40.50.2000-FF-000249', NULL, 'Trehalose phosphorylase', 231, NULL, NULL, 158893),
(158894, '2.30.30.100-FF-000216', NULL, 'Uncharacterized protein', 80, NULL, NULL, 158894),
(158895, '2.60.40.10-FF-001151', NULL, 'Uncharacterized protein, isoform F', 99, NULL, NULL, 158895),
(158896, '3.30.70.270-FF-000114', NULL, 'Sensory box/GGDEF family protein', 163, NULL, NULL, 158896),
(158897, '3.40.140.10-FF-000109', NULL, 'Predicted protein', 127, NULL, NULL, 158897),
(158898, '2.60.220.50-FF-000071', NULL, 'Uncharacterized protein', 101, NULL, NULL, 158898),
(158899, '2.130.10.10-FF-003601', NULL, 'Elongator acetyltransferase complex subunit 2', 55, NULL, NULL, 158899),
(158900, '3.30.160.60-FF-000695', NULL, 'Spalt-like transcription factor 1', 25, NULL, NULL, 158900),
(158901, '3.40.50.150-FF-001561', NULL, NULL, 74, NULL, NULL, 158901),
(158902, '3.30.70.260-FF-000111', NULL, 'GTP pyrophosphokinase', 80, NULL, NULL, 158902),
(158903, '3.40.50.300-FF-001128', NULL, 'ATP-binding cassette sub-family C member 12', 268, NULL, NULL, 158903),
(158904, '2.60.120.650-FF-000144', NULL, 'Uncharacterized protein', 335, NULL, NULL, 158904),
(158905, '3.60.110.10-FF-000041', NULL, 'Bifunctional apolipoprotein N-acyltransferase/polyprenol monophosphomannose synthase', 275, NULL, NULL, 158905),
(158906, '2.30.29.30-FF-001098', NULL, 'Uncharacterized protein', 32, NULL, NULL, 158906),
(158907, '1.25.40.10-FF-001886', NULL, 'Tetratricopeptide repeat protein 7B', 172, NULL, NULL, 158907),
(158908, '3.80.20.20-FF-000076', NULL, 'Predicted protein', 155, NULL, NULL, 158908),
(158909, '2.30.29.30-FF-000428', NULL, 'GEM-like protein 5', 120, NULL, NULL, 158909),
(158910, '3.40.1110.10-FF-000202', NULL, NULL, 43, NULL, NULL, 158910),
(158911, '1.10.60.30-FF-000004', NULL, 'UPF0307 protein NCTC10783_04020', 76, NULL, NULL, 158911),
(158912, '2.130.10.10-FF-004495', NULL, 'Uncharacterized protein', 102, NULL, NULL, 158912),
(158913, '1.20.1420.30-FF-000007', NULL, 'Vacuolar calcium ion transporter', 244, NULL, NULL, 158913);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(158914, '3.30.40.10-FF-000621', NULL, 'TNF receptor-associated factor', 66, NULL, NULL, 158914),
(158915, '1.10.950.10-FF-000005', NULL, 'Villin-1', 67, NULL, NULL, 158915),
(158916, '2.80.10.50-FF-000249', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 57, NULL, NULL, 158916),
(158917, '1.10.510.10-FF-003002', NULL, NULL, 86, NULL, NULL, 158917),
(158918, '3.40.50.300-FF-005024', NULL, 'Uncharacterized protein', 140, NULL, NULL, 158918),
(158919, '1.20.1250.20-FF-002155', NULL, 'Uncharacterized protein', 196, NULL, NULL, 158919),
(158920, '3.40.50.720-FF-000181', NULL, 'NmrA-like family domain-containing protein 1', 191, NULL, NULL, 158920),
(158921, '3.40.30.10-FF-001143', NULL, 'Uncharacterized protein', 54, NULL, NULL, 158921),
(158922, '1.10.60.20-FF-000001', NULL, '40S ribosomal protein S17', 62, NULL, NULL, 158922),
(158923, '3.30.160.60-FF-003163', NULL, 'Zinc finger protein OZF', 28, NULL, NULL, 158923),
(158924, '3.90.180.10-FF-000016', NULL, 'Quinone oxidoreductase', 143, NULL, NULL, 158924),
(158925, '2.60.40.10-FF-005422', NULL, NULL, 121, NULL, NULL, 158925),
(158926, '3.40.390.10-FF-000313', NULL, NULL, 211, NULL, NULL, 158926),
(158927, '2.130.10.10-FF-004787', NULL, 'WD40-repeat protein', 150, NULL, NULL, 158927),
(158928, '3.60.15.10-FF-000281', NULL, 'Uncharacterized protein', 95, NULL, NULL, 158928),
(158929, '3.40.50.1170-FF-000005', NULL, 'Probable L-asparaginase', 190, NULL, NULL, 158929),
(158930, '3.40.50.300-FF-004894', NULL, 'Caspase recruitment domain family, member 11', 178, NULL, NULL, 158930),
(158931, '3.40.50.300-FF-002770', NULL, 'p-loop containing nucleoside triphosphate hydrolases superfamily protein', 330, NULL, NULL, 158931),
(158932, '2.130.10.10-FF-001128', NULL, 'Transducin family protein / WD-40 repeat family protein', 234, NULL, NULL, 158932),
(158933, '2.60.120.920-FF-000011', NULL, 'RAN binding protein 10', 210, NULL, NULL, 158933),
(158934, '3.80.10.10-FF-003624', NULL, 'Predicted protein', 298, NULL, NULL, 158934),
(158935, '3.40.800.10-FF-000059', NULL, NULL, 83, NULL, NULL, 158935),
(158936, '1.20.1560.10-FF-000124', NULL, 'Putative ABC transporter transmembrane subunit', 319, NULL, NULL, 158936),
(158937, '1.10.287.470-FF-000051', NULL, 'RND efflux membrane fusion protein', 65, NULL, NULL, 158937),
(158938, '2.40.50.40-FF-000014', NULL, 'Chromodomain-helicase-DNA-binding protein 2 isoform 1', 76, NULL, NULL, 158938),
(158939, '3.30.1740.20-FF-000002', NULL, '40S ribosomal protein S26', 113, NULL, NULL, 158939),
(158940, '3.40.50.720-FF-000029', NULL, 'L-lactate dehydrogenase A chain', 161, NULL, NULL, 158940),
(158941, '1.20.1050.10-FF-000080', NULL, 'YGR201C-like protein', 141, NULL, NULL, 158941),
(158942, '2.130.10.10-FF-002371', NULL, 'Transducin', 135, NULL, NULL, 158942),
(158943, '1.10.510.10-FF-000478', NULL, 'Cell cycle protein kinase', 257, NULL, NULL, 158943),
(158944, '2.60.490.10-FF-000016', NULL, 'Uncharacterized protein', 165, NULL, NULL, 158944),
(158945, '3.40.640.10-FF-000294', NULL, 'Uncharacterized protein', 116, NULL, NULL, 158945),
(158946, '3.40.50.1820-FF-000420', NULL, 'Alpha/beta fold hydrolase', 322, NULL, NULL, 158946),
(158947, '3.30.1680.10-FF-000062', NULL, 'Uncharacterized protein', 30, NULL, NULL, 158947),
(158948, '3.40.50.720-FF-001659', NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase NAD-binding', 117, NULL, NULL, 158948),
(158949, '3.30.450.20-FF-000008', NULL, 'Nuclear receptor coactivator', 122, NULL, NULL, 158949),
(158950, '2.60.40.10-FF-004079', NULL, NULL, 119, NULL, NULL, 158950),
(158951, '1.10.10.60-FF-000561', NULL, 'Transcription factor MYB75', 65, NULL, NULL, 158951),
(158952, '6.20.10.30-FF-000006', NULL, 'DNA ligase', 51, NULL, NULL, 158952),
(158953, '3.30.160.60-FF-005641', NULL, NULL, 39, NULL, NULL, 158953),
(158954, '1.10.510.10-FF-002783', NULL, NULL, 206, NULL, NULL, 158954),
(158955, '3.90.1100.10-FF-000016', NULL, 'DNA-directed RNA polymerase subunit beta', 191, NULL, NULL, 158955),
(158956, '2.130.10.10-FF-000572', NULL, 'VPS10 domain-containing receptor SorCS2 isoform X2', 193, NULL, NULL, 158956);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(158957, '1.25.10.10-FF-002553', NULL, 'UTP20, small subunit processome component', 175, NULL, NULL, 158957),
(158958, '3.40.720.10-FF-000114', NULL, 'Putative integral membrane protein', 274, NULL, NULL, 158958),
(158959, '2.60.40.150-FF-000507', NULL, 'Synaptotagmin', 68, NULL, NULL, 158959),
(158960, '3.40.50.150-FF-001117', NULL, NULL, 45, NULL, NULL, 158960),
(158961, '1.20.1720.10-FF-000108', NULL, NULL, 132, NULL, NULL, 158961),
(158962, '3.30.420.40-FF-000850', NULL, 'ROK family protein', 160, NULL, NULL, 158962),
(158963, '1.20.1250.20-FF-002211', NULL, 'Uncharacterized protein', 138, NULL, NULL, 158963),
(158964, '1.20.144.10-FF-000057', NULL, 'Lipid phosphate phosphohydrolase', 225, NULL, NULL, 158964),
(158965, '2.60.40.10-FF-000476', NULL, 'titin isoform X1', 98, NULL, NULL, 158965),
(158966, '1.50.40.10-FF-000220', NULL, 'Chromosome 12, whole genome shotgun sequence', 187, NULL, NULL, 158966),
(158967, '2.30.42.10-FF-000509', NULL, NULL, 90, NULL, NULL, 158967),
(158968, '3.90.1150.10-FF-000019', NULL, '4-aminobutyrate aminotransferase, mitochondrial', 141, NULL, NULL, 158968),
(158969, '3.40.366.10-FF-000032', NULL, 'Malonyl CoA-acyl carrier protein transacylase', 207, NULL, NULL, 158969),
(158970, '3.30.70.330-FF-002341', NULL, NULL, 211, NULL, NULL, 158970),
(158971, '2.130.10.10-FF-004388', NULL, 'Uncharacterized protein', 67, NULL, NULL, 158971),
(158972, '1.20.1510.10-FF-000059', NULL, 'Cation efflux family protein', 224, NULL, NULL, 158972),
(158973, '1.20.1070.10-FF-002166', NULL, 'Uncharacterized protein', 132, NULL, NULL, 158973),
(158974, '1.20.1560.10-FF-000343', NULL, 'Lethal (2) 03659, isoform C', 335, NULL, NULL, 158974),
(158975, '3.30.50.10-FF-000161', NULL, 'Uncharacterized protein', 113, NULL, NULL, 158975),
(158976, '3.30.70.2610-FF-000007', NULL, 'General transcription factor IIH subunit 4', 78, NULL, NULL, 158976),
(158977, '2.40.110.10-FF-000027', NULL, 'Isovaleryl-CoA dehydrogenase', 122, NULL, NULL, 158977),
(158978, '1.10.472.90-FF-000002', NULL, 'Pyruvate carboxylase, mitochondrial', 102, NULL, NULL, 158978),
(158979, '3.10.100.10-FF-000243', NULL, NULL, 149, NULL, NULL, 158979),
(158980, '3.30.230.10-FF-000080', NULL, 'Diphosphomevalonate decarboxylase', 174, NULL, NULL, 158980),
(158981, '2.50.20.10-FF-000003', NULL, 'Sigma-E factor regulatory protein RseB', 186, NULL, NULL, 158981),
(158982, '2.150.10.10-FF-000003', NULL, 'Bifunctional hemolysin/adenylate cyclase', 110, NULL, NULL, 158982),
(158983, '3.40.50.300-FF-003601', NULL, 'Uridine kinase', 174, NULL, NULL, 158983),
(158984, '3.30.40.10-FF-001110', NULL, 'E3 ubiquitin-protein ligase ORTHRUS 3', 50, NULL, NULL, 158984),
(158985, '3.30.1360.120-FF-000099', NULL, 'Predicted protein', 113, NULL, NULL, 158985),
(158986, '3.90.1150.10-FF-000238', NULL, 'Uncharacterized protein', 153, NULL, NULL, 158986),
(158987, '3.20.20.100-FF-000117', NULL, 'Uncharacterized protein', 221, NULL, NULL, 158987),
(158988, '1.10.10.10-FF-000804', NULL, 'Transcriptional regulator, RpiR family', 82, NULL, NULL, 158988),
(158989, '2.10.10.20-FF-000007', NULL, 'Chitinase', 69, NULL, NULL, 158989),
(158990, '1.25.40.10-FF-002381', NULL, 'Subunit of the RNA polymerase III transcription initiation factor complex (TFIIIC), putative', 212, NULL, NULL, 158990),
(158991, '2.10.10.10-FF-000004', NULL, 'lymphocyte antigen 75 precursor', 56, NULL, NULL, 158991),
(158992, '3.40.850.10-FF-000118', NULL, 'Kinesin-like protein', 376, NULL, NULL, 158992),
(158993, '3.30.160.60-FF-006378', NULL, NULL, 76, NULL, NULL, 158993),
(158994, '3.40.50.300-FF-004349', NULL, 'Lipoprotein-releasing system ATP-binding protein LolD', 243, NULL, NULL, 158994),
(158995, '4.10.830.10-FF-000002', NULL, '40S ribosomal protein S29', 56, NULL, NULL, 158995),
(158996, '1.25.40.720-FF-000003', NULL, 'Telomere length regulation protein TEL2 homolog', 90, NULL, NULL, 158996),
(158997, '2.60.120.260-FF-000622', NULL, 'Putative secreted beta-galactosidase', 129, NULL, NULL, 158997),
(158998, '3.90.550.10-FF-000674', NULL, 'Uncharacterized protein', 99, NULL, NULL, 158998);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(158999, '1.25.40.10-FF-004915', NULL, 'Pentatricopeptide repeat-containing protein At1g62260, mitochondrial', 71, NULL, NULL, 158999),
(159000, '1.20.58.60-FF-000642', NULL, 'Uncharacterized protein', 259, NULL, NULL, 159000),
(159001, '1.20.920.20-FF-000010', NULL, 'Dynein heavy chain, putative', 342, NULL, NULL, 159001),
(159002, '2.60.40.10-FF-000768', NULL, 'Neural cell adhesion molecule L1-like protein', 102, NULL, NULL, 159002),
(159003, '3.40.50.670-FF-000025', NULL, 'DNA topoisomerase 2', 125, NULL, NULL, 159003),
(159004, '1.10.10.60-FF-000780', NULL, NULL, 75, NULL, NULL, 159004),
(159005, '3.30.160.60-FF-006327', NULL, NULL, 66, NULL, NULL, 159005),
(159006, '3.30.200.20-FF-002328', NULL, 'Uncharacterized protein', 75, NULL, NULL, 159006),
(159007, '3.30.2350.20-FF-000080', NULL, NULL, 37, NULL, NULL, 159007),
(159008, '1.10.472.10-FF-000147', NULL, 'PCL8p Cyclin', 192, NULL, NULL, 159008),
(159009, '2.40.10.350-FF-000009', NULL, 'Cell shape-determining protein MreC', 80, NULL, NULL, 159009),
(159010, '1.25.40.730-FF-000006', NULL, 'Clathrin heavy chain', 97, NULL, NULL, 159010),
(159011, '2.70.150.10-FF-000096', NULL, 'Phospholipid-transporting ATPase', 148, NULL, NULL, 159011),
(159012, '2.30.18.10-FF-000009', NULL, 'Transcription initiation factor IIA subunit 2', 61, NULL, NULL, 159012),
(159013, '3.40.50.10090-FF-000016', NULL, 'Uroporphyrinogen-III synthase chloroplastic', 92, NULL, NULL, 159013),
(159014, '1.20.920.30-FF-000013', NULL, 'Dynein heavy chain-like protein', 188, NULL, NULL, 159014),
(159015, '3.40.1490.10-FF-000011', NULL, 'Predicted protein', 95, NULL, NULL, 159015),
(159016, '3.30.230.70-FF-000018', NULL, 'Exosome complex exonuclease RRP43', 288, NULL, NULL, 159016),
(159017, '1.20.58.1030-FF-000042', NULL, 'Uncharacterized protein', 47, NULL, NULL, 159017),
(159018, '3.30.70.1350-FF-000034', NULL, NULL, 97, NULL, NULL, 159018),
(159019, '3.40.190.290-FF-000048', NULL, 'LysR family transcriptional regulator', 201, NULL, NULL, 159019),
(159020, '2.30.30.100-FF-000109', NULL, 'U6 snRNA-associated Sm-like protein LSm5', 82, NULL, NULL, 159020),
(159021, '1.10.565.10-FF-000104', NULL, 'Retinoic acid receptor RXR-gamma-A', 225, NULL, NULL, 159021),
(159022, '2.20.70.10-FF-000255', NULL, 'Uncharacterized protein', 45, NULL, NULL, 159022),
(159023, '2.40.10.340-FF-000006', NULL, 'Cell shape-determining protein MreC', 60, NULL, NULL, 159023),
(159024, '3.30.70.330-FF-000273', NULL, 'THO complex subunit 4', 140, NULL, NULL, 159024),
(159025, '3.30.450.30-FF-000074', NULL, 'MK1', 119, NULL, NULL, 159025),
(159026, '1.20.58.410-FF-000004', NULL, 'Peptide chain release factor 2', 112, NULL, NULL, 159026),
(159027, '2.40.50.90-FF-000006', NULL, 'Tudor domain-containing protein 7', 101, NULL, NULL, 159027),
(159028, '3.40.50.11610-FF-000034', NULL, NULL, 135, NULL, NULL, 159028),
(159029, '3.30.160.60-FF-003505', NULL, 'GD16882', 27, NULL, NULL, 159029),
(159030, '3.30.420.40-FF-000575', NULL, 'Heat shock protein 70 putative', 142, NULL, NULL, 159030),
(159031, '2.30.29.30-FF-000142', NULL, 'protein-tyrosine kinase 2-beta isoform X1', 107, NULL, NULL, 159031),
(159032, '3.40.50.1980-FF-000035', NULL, 'Iron ABC transporter substrate-binding protein', 134, NULL, NULL, 159032),
(159033, '3.40.309.10-FF-000018', NULL, 'Alpha-aminoadipic semialdehyde dehydrogenase', 193, NULL, NULL, 159033),
(159034, '3.60.40.10-FF-000024', NULL, 'probable protein phosphatase 2C 33', 323, NULL, NULL, 159034),
(159035, '3.40.50.300-FF-004568', NULL, 'DNA helicase', 204, NULL, NULL, 159035),
(159036, '1.20.58.400-FF-000001', NULL, 'Vesicle transport through interaction with t-SNAREs homolog 1A', 99, NULL, NULL, 159036),
(159037, '3.40.50.1970-FF-000032', NULL, '3-dehydroquinate synthase', 168, NULL, NULL, 159037),
(159038, '3.40.50.510-FF-000005', NULL, 'PTS-dependent dihydroxyacetone kinase phosphotransferase subunit DhaM', 121, NULL, NULL, 159038),
(159039, '3.40.50.300-FF-003040', NULL, 'Guanylate kinase', 193, NULL, NULL, 159039),
(159040, '1.20.1510.10-FF-000008', NULL, 'zinc transporter 5 isoform X1', 199, NULL, NULL, 159040);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(159041, '3.40.50.300-FF-005462', NULL, 'ABC transporter, ATP-binding protein', 230, NULL, NULL, 159041),
(159042, '1.10.1040.50-FF-000020', NULL, NULL, 86, NULL, NULL, 159042),
(159043, '2.60.120.260-FF-000347', NULL, 'Sad1 / UNC-like C-terminal, putative', 126, NULL, NULL, 159043),
(159044, '3.40.50.150-FF-000993', NULL, NULL, 211, NULL, NULL, 159044),
(159045, '1.10.287.130-FF-000202', NULL, 'Integral membrane sensor signal transduction histidine kinase', 119, NULL, NULL, 159045),
(159046, '3.30.70.330-FF-000429', NULL, 'Heterogeneous nuclear ribonucleoprotein A1-like 2', 122, NULL, NULL, 159046),
(159047, '2.30.30.100-FF-000042', NULL, 'U6 snRNA-associated Sm-like protein LSm2', 95, NULL, NULL, 159047),
(159048, '3.60.10.10-FF-000180', NULL, 'Uncharacterized protein', 256, NULL, NULL, 159048),
(159049, '3.40.47.10-FF-000057', NULL, '3-ketoacyl-CoA synthase', 350, NULL, NULL, 159049),
(159050, '3.30.450.20-FF-000071', NULL, 'PAS domain-containing sensor histidine kinase', 122, NULL, NULL, 159050),
(159051, '3.20.20.70-FF-000115', NULL, 'Isopentenyl-diphosphate delta-isomerase', 347, NULL, NULL, 159051),
(159052, '3.90.780.10-FF-000045', NULL, 'YALI0D13640p', 127, NULL, NULL, 159052),
(159053, '2.130.10.10-FF-000791', NULL, 'U3 small nucleolar RNA-associated protein 4 homolog', 275, NULL, NULL, 159053),
(159054, '2.60.40.1730-FF-000012', NULL, 'Aminopeptidase N', 214, NULL, NULL, 159054),
(159055, '3.40.50.720-FF-001608', NULL, 'UDP-glucuronic acid decarboxylase 6', 147, NULL, NULL, 159055),
(159056, '3.90.1200.10-FF-000001', NULL, 'Fructosamine kinase family protein', 189, NULL, NULL, 159056),
(159057, '3.20.20.100-FF-000050', NULL, 'Aldo-keto reductase family 1 member C2', 182, NULL, NULL, 159057),
(159058, '2.60.220.50-FF-000020', NULL, 'Adhesion G-protein coupled receptor V1', 152, NULL, NULL, 159058),
(159059, '1.10.10.10-FF-000456', NULL, 'LysR family transcriptional regulator ArgP', 76, NULL, NULL, 159059),
(159060, '3.40.50.300-FF-001191', NULL, 'Elongation factor 1-alpha', 225, NULL, NULL, 159060),
(159061, '2.130.10.10-FF-004169', NULL, 'Mediator of RNA polymerase II transcription subunit 16', 168, NULL, NULL, 159061),
(159062, '1.25.40.30-FF-000003', NULL, 'Uncharacterized protein', 162, NULL, NULL, 159062),
(159063, '1.20.58.60-FF-000081', NULL, 'Short stop, isoform K', 114, NULL, NULL, 159063),
(159064, '2.40.50.140-FF-000314', NULL, 'Protein OSB2 chloroplastic', 110, NULL, NULL, 159064),
(159065, '3.40.50.720-FF-002502', NULL, 'Lysine-ketoglutarate reductase/saccharopine dehydrogenase bifunctional enzyme', 143, NULL, NULL, 159065),
(159066, '3.30.420.40-FF-000923', NULL, 'Uncharacterized protein', 135, NULL, NULL, 159066),
(159067, '3.50.50.60-FF-000377', NULL, 'Selenate reductase subunit YgfK', 72, NULL, NULL, 159067),
(159068, '1.10.472.10-FF-000198', NULL, 'G2/mitotic-specific cyclin-B1', 112, NULL, NULL, 159068),
(159069, '3.30.40.10-FF-002077', NULL, 'Uncharacterized protein', 86, NULL, NULL, 159069),
(159070, '3.40.50.720-FF-001878', NULL, '3-hydroxyisobutyrate dehydrogenase', 168, NULL, NULL, 159070),
(159071, '1.20.5.1160-FF-000036', NULL, 'Lamin, isoform B', 72, NULL, NULL, 159071),
(159072, '2.60.120.650-FF-000200', NULL, 'Uncharacterized protein', 339, NULL, NULL, 159072),
(159073, '1.20.140.20-FF-000001', NULL, '[Pyruvate dehydrogenase (acetyl-transferring)] kinase isozyme 2, mitochondrial', 176, NULL, NULL, 159073),
(159074, '3.40.30.10-FF-000980', NULL, 'Protein disulfide-isomerase A3', 91, NULL, NULL, 159074),
(159075, '3.60.15.10-FF-000218', NULL, 'Chromosome 1, whole genome shotgun sequence', 194, NULL, NULL, 159075),
(159076, '1.20.120.330-FF-000007', NULL, 'protein-tyrosine kinase 2-beta isoform X1', 151, NULL, NULL, 159076),
(159077, '1.20.1250.20-FF-001368', NULL, 'solute carrier family 15 member 2-like', 427, NULL, NULL, 159077),
(159078, '3.30.160.60-FF-005074', NULL, NULL, 49, NULL, NULL, 159078),
(159079, '3.90.650.10-FF-000041', NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase', 171, NULL, NULL, 159079),
(159080, '1.25.10.10-FF-001204', NULL, 'Uncharacterized protein', 397, NULL, NULL, 159080);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(159081, '3.50.50.60-FF-000607', NULL, 'Glucose-inhibited division family A protein', 108, NULL, NULL, 159081),
(159082, '3.40.50.11660-FF-000021', NULL, 'Alpha3-fucosyltransferase', 207, NULL, NULL, 159082),
(159083, '1.10.400.10-FF-000088', NULL, 'Uncharacterized protein', 24, NULL, NULL, 159083),
(159084, '3.30.60.90-FF-000022', NULL, 'Histone acetyltransferase of the CBP family 12', 60, NULL, NULL, 159084),
(159085, '1.20.5.110-FF-000122', NULL, 'Synaptosomal-associated protein, 23kDa', 69, NULL, NULL, 159085),
(159086, '2.30.30.490-FF-000001', NULL, 'Metastasis-associated 1 family, member 3', 143, NULL, NULL, 159086),
(159087, '4.10.60.10-FF-000222', NULL, 'Uncharacterized protein', 53, NULL, NULL, 159087),
(159088, '1.10.8.500-FF-000005', NULL, 'Sensor histidine kinase YycG', 64, NULL, NULL, 159088),
(159089, '2.40.30.10-FF-000257', NULL, 'Putative reductase', 96, NULL, NULL, 159089),
(159090, '3.30.200.20-FF-002497', NULL, 'Uncharacterized protein', 17, NULL, NULL, 159090),
(159091, '4.10.60.10-FF-000166', NULL, 'TIMELESS-interacting protein', 43, NULL, NULL, 159091),
(159092, '3.40.850.10-FF-000270', NULL, 'Kinesin family member 21A', 245, NULL, NULL, 159092),
(159093, '2.130.10.10-FF-004618', NULL, 'Putative U4/U6 small nuclear ribonuclear protein', 200, NULL, NULL, 159093),
(159094, '3.30.710.10-FF-000009', NULL, 'Zinc finger and BTB domain-containing 37', 134, NULL, NULL, 159094),
(159095, '2.10.25.10-FF-000999', NULL, 'Wall-associated receptor kinase 2', 40, NULL, NULL, 159095),
(159096, '3.40.390.10-FF-000190', NULL, NULL, 99, NULL, NULL, 159096),
(159097, '1.20.120.310-FF-000001', NULL, 'Sulfhydryl oxidase', 151, NULL, NULL, 159097),
(159098, '3.90.190.20-FF-000014', NULL, 'Dihydrofolate synthetase', 153, NULL, NULL, 159098),
(159099, '3.30.760.10-FF-000001', NULL, 'Eukaryotic translation initiation factor 4E type 2 isoformX2', 210, NULL, NULL, 159099),
(159100, '3.30.40.10-FF-002184', NULL, 'Uncharacterized protein', 80, NULL, NULL, 159100),
(159101, '3.20.20.140-FF-000106', NULL, 'Amidohydrolase family', 316, NULL, NULL, 159101),
(159102, '1.25.40.10-FF-004409', NULL, 'Uncharacterized protein', 360, NULL, NULL, 159102),
(159103, '3.40.50.300-FF-001308', NULL, 'DEAD-box ATP-dependent RNA helicase 50', 159, NULL, NULL, 159103),
(159104, '1.25.40.20-FF-001074', NULL, 'Uncharacterized protein', 213, NULL, NULL, 159104),
(159105, '2.130.10.10-FF-003039', NULL, 'Uncharacterized protein', 150, NULL, NULL, 159105),
(159106, '3.40.50.620-FF-000038', NULL, 'Argininosuccinate synthase', 170, NULL, NULL, 159106),
(159107, '3.40.50.80-FF-000232', NULL, 'Uncharacterized protein', 109, NULL, NULL, 159107),
(159108, '3.40.50.2300-FF-000171', NULL, 'Vomeronasal 2, receptor 17', 267, NULL, NULL, 159108),
(159109, '3.30.70.330-FF-000722', NULL, 'Nuclear mRNA splicing factor-associated protein, putative', 148, NULL, NULL, 159109),
(159110, '2.40.330.10-FF-000015', NULL, NULL, 107, NULL, NULL, 159110),
(159111, '1.10.238.10-FF-000845', NULL, 'Calcium uptake protein, mitochondrial', 122, NULL, NULL, 159111),
(159112, '3.40.50.620-FF-000095', NULL, 'Phosphoadenosine phosphosulfate reductase', 231, NULL, NULL, 159112),
(159113, '1.25.40.90-FF-000055', NULL, 'Blast:Protein LST8 homolog', 155, NULL, NULL, 159113),
(159114, '1.10.150.530-FF-000008', NULL, 'Probable dual-specificity RNA methyltransferase RlmN', 61, NULL, NULL, 159114),
(159115, '3.90.70.10-FF-000665', NULL, 'Uncharacterized protein', 303, NULL, NULL, 159115),
(159116, '2.130.10.10-FF-000347', NULL, 'Pre-mRNA-splicing factor PRP46, putative', 319, NULL, NULL, 159116),
(159117, '3.40.50.920-FF-000027', NULL, 'Transketolase', 126, NULL, NULL, 159117),
(159118, '2.60.40.10-FF-001263', NULL, 'brother of CDO isoform X1', 100, NULL, NULL, 159118),
(159119, '3.40.630.30-FF-000006', NULL, 'Putative n-alpha-acetyltransferase 50', 154, NULL, NULL, 159119),
(159120, '3.40.50.2000-FF-000075', NULL, 'Lipopolysaccharide heptosyltransferase I', 163, NULL, NULL, 159120),
(159121, '3.40.50.720-FF-001934', NULL, 'Uncharacterized protein', 285, NULL, NULL, 159121);
INSERT INTO "PUBLIC"."MODEL" VALUES
(159122, '3.90.25.10-FF-000072', NULL, 'Uncharacterized protein', 70, NULL, NULL, 159122),
(159123, '1.10.730.10-FF-000017', NULL, 'Arginine--tRNA ligase, chloroplastic/mitochondrial', 122, NULL, NULL, 159123),
(159124, '3.30.160.60-FF-000869', NULL, 'Zinc finger protein 213', 28, NULL, NULL, 159124),
(159125, '3.30.160.60-FF-005130', NULL, NULL, 27, NULL, NULL, 159125),
(159126, '2.60.40.150-FF-000277', NULL, 'Nicotinic receptor-associated protein 1', 134, NULL, NULL, 159126),
(159127, '2.40.10.10-FF-000256', NULL, 'Vitamin K-dependent protein C', 106, NULL, NULL, 159127),
(159128, '1.10.275.20-FF-000006', NULL, 'CROT isoform 1', 77, NULL, NULL, 159128),
(159129, '2.60.260.20-FF-000087', NULL, 'DNAJ heat shock family protein', 82, NULL, NULL, 159129),
(159130, '2.60.40.10-FF-000369', NULL, 'Protein tyrosine phosphatase, receptor type B', 89, NULL, NULL, 159130),
(159131, '1.10.472.10-FF-000708', NULL, 'Uncharacterized protein', 62, NULL, NULL, 159131),
(159132, '1.10.1580.20-FF-000001', NULL, 'YihD family protein', 89, NULL, NULL, 159132),
(159133, '1.10.275.30-FF-000009', NULL, 'RAD3-like DNA-binding helicase protein', 160, NULL, NULL, 159133),
(159134, '3.10.350.10-FF-000053', NULL, 'LysM Domain (Peptidoglycan binding) protein', 58, NULL, NULL, 159134),
(159135, '1.10.10.60-FF-001050', NULL, NULL, 61, NULL, NULL, 159135),
(159136, '3.30.830.10-FF-000226', NULL, 'Mitochondrial processing peptidase alpha subunit', 220, NULL, NULL, 159136),
(159137, '1.10.486.10-FF-000033', NULL, 'DNA helicase', 149, NULL, NULL, 159137),
(159138, '1.10.10.60-FF-000336', NULL, 'Transcription factor MYB39', 48, NULL, NULL, 159138),
(159139, '3.50.50.60-FF-000720', NULL, 'Pyridine nucleotide-disulfide oxidoreductase', 203, NULL, NULL, 159139),
(159140, '1.25.40.20-FF-001035', NULL, 'Uncharacterized protein', 157, NULL, NULL, 159140),
(159141, '3.40.640.10-FF-000462', NULL, 'Lipopolysaccharide biosynthesis protein RfbH', 174, NULL, NULL, 159141),
(159142, '1.25.40.10-FF-004466', NULL, 'Uncharacterized protein', 109, NULL, NULL, 159142),
(159143, '1.25.10.10-FF-002727', NULL, 'Uncharacterized protein', 913, NULL, NULL, 159143),
(159144, '3.30.430.20-FF-000069', NULL, 'Uncharacterized protein', 90, NULL, NULL, 159144),
(159145, '2.40.50.40-FF-000071', NULL, 'Histone-lysine N-methyltransferase', 53, NULL, NULL, 159145),
(159146, '3.40.50.300-FF-006480', NULL, 'Uncharacterized protein', 116, NULL, NULL, 159146),
(159147, '1.20.58.1380-FF-000017', NULL, 'Nucleoporin nup131', 87, NULL, NULL, 159147),
(159148, '3.40.50.720-FF-000630', NULL, '3-hydroxyisobutyrate dehydrogenase', 181, NULL, NULL, 159148),
(159149, '1.25.40.480-FF-000004', NULL, 'Bystin', 246, NULL, NULL, 159149),
(159150, '1.10.150.670-FF-000022', NULL, 'Crossover junction endonuclease MUS81', 80, NULL, NULL, 159150),
(159151, '3.40.50.150-FF-000667', NULL, 'NucleOLar protein', 290, NULL, NULL, 159151),
(159152, '2.60.40.60-FF-000917', NULL, 'Si:dkey-1m11.5', 99, NULL, NULL, 159152),
(159153, '1.10.150.20-FF-000150', NULL, 'Predicted protein', 60, NULL, NULL, 159153),
(159154, '1.10.238.110-FF-000001', NULL, 'Diacylglycerol kinase', 43, NULL, NULL, 159154),
(159155, '3.40.50.620-FF-000151', NULL, 'Phosphoadenosine phosphosulfate reductase', 256, NULL, NULL, 159155),
(159156, '4.10.60.10-FF-000109', NULL, 'Universal minicircle sequence binding protein (UMSBP), putative', 25, NULL, NULL, 159156),
(159157, '3.40.50.1820-FF-000526', NULL, 'Carboxylesterase', 215, NULL, NULL, 159157),
(159158, '1.25.40.470-FF-000001', NULL, 'Coatomer subunit beta', 209, NULL, NULL, 159158),
(159159, '1.25.40.180-FF-000015', NULL, 'regulator of nonsense transcripts 2 isoform X1', 219, NULL, NULL, 159159),
(159160, '1.20.1560.10-FF-000337', NULL, 'Multidrug resistance-associated protein 2', 349, NULL, NULL, 159160),
(159161, '1.10.10.10-FF-000568', NULL, 'Two-component system response regulator', 101, NULL, NULL, 159161),
(159162, '3.10.350.10-FF-000014', NULL, 'Soluble lytic murein transglycosylase', 54, NULL, NULL, 159162),
(159163, '2.130.10.10-FF-003152', NULL, 'Vacuolar protein sorting-associated protein 41 homolog', 286, NULL, NULL, 159163);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(159164, '2.60.40.10-FF-002567', NULL, 'Juxtamembrane domain-associated catenin', 106, NULL, NULL, 159164),
(159165, '1.20.1070.10-FF-002110', NULL, 'Predicted protein', 124, NULL, NULL, 159165),
(159166, '3.30.450.70-FF-000001', NULL, 'Trafficking protein particle complex subunit 2', 140, NULL, NULL, 159166),
(159167, '2.70.170.10-FF-000097', NULL, 'Uncharacterized protein, isoform D', 212, NULL, NULL, 159167),
(159168, '1.25.40.10-FF-002375', NULL, 'Putative pentatricopeptide repeat-containing protein At1g09680', 93, NULL, NULL, 159168),
(159169, '1.25.10.10-FF-003334', NULL, 'Uncharacterized protein', 262, NULL, NULL, 159169),
(159170, '3.40.50.2300-FF-001587', NULL, NULL, 133, NULL, NULL, 159170),
(159171, '3.30.450.80-FF-000004', NULL, 'LuxR family transcriptional regulator', 167, NULL, NULL, 159171),
(159172, '1.25.40.10-FF-000138', NULL, 'Protein arginine methyltransferase 9', 127, NULL, NULL, 159172),
(159173, '2.60.40.150-FF-000390', NULL, 'Putative triglyceride lipase', 128, NULL, NULL, 159173),
(159174, '1.10.375.10-FF-000005', NULL, 'Gag-pro-pol polyprotein', 129, NULL, NULL, 159174),
(159175, '2.30.42.10-FF-000004', NULL, 'Disks large homolog 4 isoform 2', 98, NULL, NULL, 159175),
(159176, '3.40.50.720-FF-001991', NULL, 'Glr3777 protein', 240, NULL, NULL, 159176),
(159177, '3.40.50.2000-FF-000923', NULL, 'ADP-heptose--lipopolysaccharide heptosyltransferase', 158, NULL, NULL, 159177),
(159178, '1.25.40.10-FF-002555', NULL, 'Pentatricopeptide (PPR) repeat-containing protein-like', 157, NULL, NULL, 159178),
(159179, '2.60.40.10-FF-004697', NULL, NULL, 60, NULL, NULL, 159179),
(159180, '3.90.1150.10-FF-000058', NULL, 'Cystathionine beta-lyase', 137, NULL, NULL, 159180),
(159181, '1.10.418.10-FF-000090', NULL, 'Kinesin-like protein KIN-14D', 111, NULL, NULL, 159181),
(159182, '1.20.58.160-FF-000002', NULL, 'Golgi-associated, gamma adaptin ear containing, ARF binding protein 2', 95, NULL, NULL, 159182),
(159183, '2.60.40.10-FF-001206', NULL, 'Sallimus, isoform P', 106, NULL, NULL, 159183),
(159184, '1.20.1550.10-FF-000005', NULL, 'Disulfide bond formation protein B', 162, NULL, NULL, 159184),
(159185, '1.10.150.20-FF-000094', NULL, 'DNA polymerase IV', 50, NULL, NULL, 159185),
(159186, '1.10.3860.10-FF-000003', NULL, 'Serine/threonine transporter sstT', 399, NULL, NULL, 159186),
(159187, '3.60.15.10-FF-000112', NULL, 'Metallo-beta-lactamase domain containing protein', 253, NULL, NULL, 159187),
(159188, '2.130.10.10-FF-002590', NULL, 'Uncharacterized protein', 53, NULL, NULL, 159188),
(159189, '2.40.50.140-FF-000264', NULL, 'Uncharacterized protein, isoform A', 75, NULL, NULL, 159189),
(159190, '3.40.50.300-FF-000965', NULL, 'RecBCD enzyme subunit RecD', 118, NULL, NULL, 159190),
(159191, '3.30.450.20-FF-000520', NULL, 'Multi-sensor hybrid histidine kinase', 73, NULL, NULL, 159191),
(159192, '3.90.550.50-FF-000107', NULL, 'Uncharacterized protein', 198, NULL, NULL, 159192),
(159193, '3.80.10.10-FF-003175', NULL, 'Predicted protein', 257, NULL, NULL, 159193),
(159194, '1.20.1530.20-FF-000007', NULL, 'K(+) efflux antiporter 2 chloroplastic', 387, NULL, NULL, 159194),
(159195, '3.40.710.10-FF-000001', NULL, 'D-alanyl-D-alanine serine-type carboxypeptidase', 262, NULL, NULL, 159195),
(159196, '2.130.10.10-FF-002820', NULL, 'Anaphase-promoting complex component Cut20/Apc4, putative (AFU_orthologue AFUA_1G15710)', 134, NULL, NULL, 159196),
(159197, '1.10.10.10-FF-000748', NULL, 'LysR family transcriptional regulator', 85, NULL, NULL, 159197),
(159198, '3.40.640.10-FF-000349', NULL, 'DegT/DnrJ/EryC1/StrS aminotransferase', 97, NULL, NULL, 159198),
(159199, '2.60.120.230-FF-000012', NULL, NULL, 143, NULL, NULL, 159199),
(159200, '3.40.395.10-FF-000009', NULL, 'Deneddylase 1, isoform A', 208, NULL, NULL, 159200),
(159201, '1.10.238.10-FF-000884', NULL, 'Protein kinase, putative', 54, NULL, NULL, 159201),
(159202, '2.10.25.10-FF-001724', NULL, 'Hemicentin 1', 59, NULL, NULL, 159202),
(159203, '2.60.120.260-FF-000403', NULL, 'Extracellular exo-alpha-L-arabinofuranosidase', 157, NULL, NULL, 159203);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(159204, '1.25.40.10-FF-004741', NULL, 'Anaphase-promoting complex subunit 3', 75, NULL, NULL, 159204),
(159205, '2.10.25.10-FF-001781', NULL, 'Uncharacterized protein', 33, NULL, NULL, 159205),
(159206, '1.10.10.60-FF-001230', NULL, NULL, 55, NULL, NULL, 159206),
(159207, '1.10.10.10-FF-001243', NULL, 'AGAP002394-PA', 77, NULL, NULL, 159207),
(159208, '1.25.40.10-FF-003162', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 115, NULL, NULL, 159208),
(159209, '2.130.10.10-FF-004675', NULL, 'Uncharacterized protein', 183, NULL, NULL, 159209),
(159210, '2.20.70.10-FF-000081', NULL, 'PDZ domain-containing protein', 44, NULL, NULL, 159210),
(159211, '3.40.50.300-FF-006367', NULL, 'Uncharacterized protein', 139, NULL, NULL, 159211),
(159212, '3.40.50.720-FF-000355', NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', 208, NULL, NULL, 159212),
(159213, '1.25.10.10-FF-001423', NULL, 'Microtubule-associated protein, putative', 259, NULL, NULL, 159213),
(159214, '3.80.20.20-FF-000019', NULL, 'Tyrosine-protein kinase receptor', 50, NULL, NULL, 159214),
(159215, '3.30.40.10-FF-000840', NULL, 'E3 ubiquitin-protein ligase SINA-like 5', 53, NULL, NULL, 159215),
(159216, '3.30.1370.210-FF-000010', NULL, 'Zinc finger CCCH domain-containing protein 28', 90, NULL, NULL, 159216),
(159217, '2.60.120.680-FF-000012', NULL, 'Opossum, isoform A', 102, NULL, NULL, 159217),
(159218, '3.30.1550.10-FF-000018', NULL, 'Uncharacterized protein', 48, NULL, NULL, 159218),
(159219, '1.10.8.60-FF-000588', NULL, 'Uncharacterized protein', 114, NULL, NULL, 159219),
(159220, '3.30.450.20-FF-000340', NULL, 'Potassium voltage-gated channel, subfamily H (eag-related), member 8', 106, NULL, NULL, 159220),
(159221, '3.40.140.10-FF-000093', NULL, 'POSSIBLE DEAMINASE', 123, NULL, NULL, 159221),
(159222, '3.90.70.10-FF-000884', NULL, 'Predicted protein', 279, NULL, NULL, 159222),
(159223, '3.40.640.10-FF-000350', NULL, 'Uncharacterized protein', 83, NULL, NULL, 159223),
(159224, '3.90.70.10-FF-000901', NULL, 'Ubiquitinyl hydrolase 1', 316, NULL, NULL, 159224),
(159225, '3.90.190.20-FF-000071', NULL, 'Putative folylpolyglutamate synthase', 168, NULL, NULL, 159225),
(159226, '1.10.150.20-FF-000037', NULL, 'DNA repair protein complementing XP-G cells homolog', 69, NULL, NULL, 159226),
(159227, '2.60.40.10-FF-002842', NULL, 'Putative invasin', 95, NULL, NULL, 159227),
(159228, '3.40.50.620-FF-000331', NULL, 'Valine--tRNA ligase', 204, NULL, NULL, 159228),
(159229, '3.40.190.10-FF-000657', NULL, 'ABC transporter substrate-binding protein', 131, NULL, NULL, 159229),
(159230, '3.30.70.360-FF-000028', NULL, 'Acetylornithine deacetylase', 135, NULL, NULL, 159230),
(159231, '3.30.70.330-FF-002015', NULL, NULL, 126, NULL, NULL, 159231),
(159232, '3.40.50.300-FF-006148', NULL, 'Uncharacterized protein', 84, NULL, NULL, 159232),
(159233, '1.10.1420.10-FF-000184', NULL, 'Mismatch repair-related protein, putative', 184, NULL, NULL, 159233),
(159234, '1.10.150.510-FF-000002', NULL, 'Receptor activity-modifying protein 1', 96, NULL, NULL, 159234),
(159235, '1.10.510.10-FF-002838', NULL, NULL, 35, NULL, NULL, 159235),
(159236, '1.20.5.340-FF-000079', NULL, 'Protein hook', 128, NULL, NULL, 159236),
(159237, '1.10.8.10-FF-000202', NULL, 'Ubiquitin-conjugating enzyme family protein', 51, NULL, NULL, 159237),
(159238, '3.30.300.180-FF-000016', NULL, 'Chromosomal replication initiator protein DnaA', 80, NULL, NULL, 159238),
(159239, '2.130.10.10-FF-001241', NULL, 'Sperm-associated antigen 16 protein', 207, NULL, NULL, 159239),
(159240, '2.10.50.10-FF-000001', NULL, 'Ephrin type-A receptor 5', 65, NULL, NULL, 159240),
(159241, '1.20.1250.20-FF-000025', NULL, 'probable polyol transporter 4', 472, NULL, NULL, 159241),
(159242, '3.40.630.40-FF-000009', NULL, 'N-acetylmuramoyl-L-alanine amidase', 164, NULL, NULL, 159242),
(159243, '3.30.40.10-FF-002127', NULL, 'Uncharacterized protein', 78, NULL, NULL, 159243),
(159244, '2.30.40.10-FF-000112', NULL, 'Uncharacterized protein', 31, NULL, NULL, 159244),
(159245, '3.80.10.10-FF-002606', NULL, 'Slit guidance ligand 3', 66, NULL, NULL, 159245);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(159246, '2.60.120.260-FF-000173', NULL, 'Netrin 4', 242, NULL, NULL, 159246),
(159247, '1.20.58.60-FF-000316', NULL, 'Spectrin beta chain', 117, NULL, NULL, 159247),
(159248, '1.25.40.10-FF-004522', NULL, 'Crooked neck-like protein 1', 235, NULL, NULL, 159248),
(159249, '3.40.1000.30-FF-000020', NULL, 'Zgc:92785', 76, NULL, NULL, 159249),
(159250, '3.30.710.10-FF-000341', NULL, 'BTB/POZ domain-containing protein KCTD5', 74, NULL, NULL, 159250),
(159251, '3.30.200.20-FF-001081', NULL, 'Putative haspin protein kinase protein', 122, NULL, NULL, 159251),
(159252, '3.10.20.530-FF-000001', NULL, NULL, 100, NULL, NULL, 159252),
(159253, '1.20.5.190-FF-000163', NULL, NULL, 49, NULL, NULL, 159253),
(159254, '1.10.510.10-FF-001147', NULL, 'NNK1p Protein kinase', 182, NULL, NULL, 159254),
(159255, '2.10.50.30-FF-000007', NULL, 'Vomeronasal 2, receptor 82', 48, NULL, NULL, 159255),
(159256, '1.20.140.40-FF-000046', NULL, 'Pectinesterase', 125, NULL, NULL, 159256),
(159257, '2.70.70.10-FF-000056', NULL, 'Gll3471 protein', 164, NULL, NULL, 159257),
(159258, '3.40.50.150-FF-001162', NULL, 'DNA (cytosine-5)-methyltransferase', 252, NULL, NULL, 159258),
(159259, '3.40.50.300-FF-005911', NULL, 'ATP-binding cassette subfamily C member 10', 123, NULL, NULL, 159259),
(159260, '1.20.58.900-FF-000038', NULL, 'Small G protein signaling modulator 3', 99, NULL, NULL, 159260),
(159261, '3.30.70.141-FF-000020', NULL, 'Thioredoxin domain-containing protein 3', 155, NULL, NULL, 159261),
(159262, '1.10.510.10-FF-002895', NULL, NULL, 70, NULL, NULL, 159262),
(159263, '3.30.160.60-FF-001706', NULL, 'Uncharacterized protein', 28, NULL, NULL, 159263),
(159264, '2.60.40.1170-FF-000092', NULL, NULL, 119, NULL, NULL, 159264),
(159265, '1.10.287.3990-FF-000001', NULL, '26S proteasome regulatory subunit S5A', 73, NULL, NULL, 159265),
(159266, '3.90.190.10-FF-000011', NULL, 'Dual specificity phosphatase 6', 152, NULL, NULL, 159266),
(159267, '3.30.160.60-FF-005017', NULL, NULL, 29, NULL, NULL, 159267),
(159268, '2.130.10.10-FF-005512', NULL, 'Uncharacterized protein', 81, NULL, NULL, 159268),
(159269, '2.60.40.10-FF-004927', NULL, NULL, 100, NULL, NULL, 159269),
(159270, '3.50.50.60-FF-000427', NULL, 'NADPH-ferredoxin reductase FprA', 232, NULL, NULL, 159270),
(159271, '1.20.120.560-FF-000003', NULL, 'pH-response regulator protein palA/RIM20', 150, NULL, NULL, 159271),
(159272, '3.30.1370.10-FF-000072', NULL, 'Uncharacterized protein, isoform A', 74, NULL, NULL, 159272),
(159273, '2.10.22.10-FF-000009', NULL, NULL, 55, NULL, NULL, 159273),
(159274, '3.30.420.40-FF-000962', NULL, 'Uncharacterized protein', 155, NULL, NULL, 159274),
(159275, '2.60.40.1180-FF-000095', NULL, 'Glycoside hydrolase family 27', 93, NULL, NULL, 159275),
(159276, '3.30.590.50-FF-000005', NULL, 'glutamate--cysteine ligase catalytic subunit isoform X2', 142, NULL, NULL, 159276),
(159277, '3.30.1010.10-FF-000107', NULL, 'Uncharacterized protein', 236, NULL, NULL, 159277),
(159278, '3.10.310.50-FF-000001', NULL, 'Inner membrane protein ycfZ', 131, NULL, NULL, 159278),
(159279, '3.20.20.220-FF-000086', NULL, 'Proline dehydrogenase', 74, NULL, NULL, 159279),
(159280, '3.80.10.10-FF-001825', NULL, 'Leucine-rich repeat transmembrane protein kinase', 113, NULL, NULL, 159280),
(159281, '3.40.190.10-FF-000438', NULL, 'Ionotropic receptor IR21a', 120, NULL, NULL, 159281),
(159282, '3.40.190.10-FF-000152', NULL, 'LysR family transcriptional regulator', 108, NULL, NULL, 159282),
(159283, '1.25.40.20-FF-001310', NULL, 'Uncharacterized protein', 146, NULL, NULL, 159283),
(159284, '3.90.280.10-FF-000018', NULL, 'Mitochondrial Ribosomal Protein, Large', 176, NULL, NULL, 159284),
(159285, '2.60.40.60-FF-000356', NULL, 'Protocadherin 15', 124, NULL, NULL, 159285),
(159286, '3.30.750.24-FF-000036', NULL, 'Putative sulfate transporter YPR003C', 156, NULL, NULL, 159286),
(159287, '3.30.2350.10-FF-000037', NULL, 'TIGR01621 family pseudouridine synthase', 194, NULL, NULL, 159287),
(159288, '1.20.910.10-FF-000012', NULL, 'Heme oxygenase', 198, NULL, NULL, 159288),
(159289, '3.90.980.20-FF-000029', NULL, NULL, 184, NULL, NULL, 159289);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(159290, '3.80.10.10-FF-002101', NULL, 'Uncharacterized protein', 175, NULL, NULL, 159290),
(159291, '3.10.450.50-FF-000106', NULL, 'Predicted protein', 111, NULL, NULL, 159291),
(159292, '2.10.25.10-FF-001505', NULL, 'Uncharacterized protein', 54, NULL, NULL, 159292),
(159293, '3.30.40.10-FF-000508', NULL, 'TNF receptor-associated factor', 102, NULL, NULL, 159293),
(159294, '3.40.50.720-FF-002266', NULL, 'Uncharacterized protein', 47, NULL, NULL, 159294),
(159295, '3.40.50.150-FF-000954', NULL, NULL, 217, NULL, NULL, 159295),
(159296, '2.130.10.10-FF-002258', NULL, 'U3 small nucleolar RNA-associated protein 18 homolog', 319, NULL, NULL, 159296),
(159297, '2.60.40.10-FF-003623', NULL, NULL, 113, NULL, NULL, 159297),
(159298, '3.40.50.300-FF-007261', NULL, 'Polynucleotide 5''-hydroxyl-kinase NOL9', 157, NULL, NULL, 159298),
(159299, '3.30.1640.30-FF-000003', NULL, 'RH60875p', 66, NULL, NULL, 159299),
(159300, '3.80.10.10-FF-002045', NULL, 'Uncharacterized protein', 75, NULL, NULL, 159300),
(159301, '3.40.50.410-FF-000200', NULL, 'ATP-dependent DNA helicase II subunit 2', 98, NULL, NULL, 159301),
(159302, '1.10.510.10-FF-000927', NULL, 'Protein kinase OspG', 96, NULL, NULL, 159302),
(159303, '3.30.200.20-FF-000529', NULL, 'L-type lectin-domain containing receptor kinase IX.1', 92, NULL, NULL, 159303),
(159304, '3.30.160.60-FF-005310', NULL, NULL, 58, NULL, NULL, 159304),
(159305, '3.40.50.300-FF-004855', NULL, 'UPF1 protein', 213, NULL, NULL, 159305),
(159306, '3.90.1150.10-FF-000345', NULL, 'Alanine aminotransferase 2', 178, NULL, NULL, 159306),
(159307, '1.20.1270.60-FF-000116', NULL, 'Suppressor of yeast profilin deletion', 264, NULL, NULL, 159307),
(159308, '1.20.930.10-FF-000007', NULL, 'Transcription elongation factor S-II', 79, NULL, NULL, 159308),
(159309, '3.40.50.300-FF-003219', NULL, 'RAB30 isoform 11', 63, NULL, NULL, 159309),
(159310, '3.80.10.10-FF-000246', NULL, 'Leucine rich repeat containing 18', 224, NULL, NULL, 159310),
(159311, '3.90.1070.20-FF-000004', NULL, 'DNA-directed RNA polymerase subunit beta', 88, NULL, NULL, 159311),
(159312, '3.40.190.170-FF-000012', NULL, 'Ectoine/5-hydroxyectoine-binding periplasmic protein UehA', 312, NULL, NULL, 159312),
(159313, '3.30.230.10-FF-000079', NULL, 'DNA topoisomerase 2', 128, NULL, NULL, 159313),
(159314, '1.25.10.10-FF-002497', NULL, 'Uncharacterized protein', 202, NULL, NULL, 159314),
(159315, '3.90.1070.10-FF-000001', NULL, 'Sucrose-phosphate synthase 1', 84, NULL, NULL, 159315),
(159316, '3.40.50.300-FF-005131', NULL, 'Lipopolysaccharide biosynthesis protein', 242, NULL, NULL, 159316),
(159317, '1.10.1670.10-FF-000062', NULL, NULL, 20, NULL, NULL, 159317),
(159318, '3.30.430.20-FF-000013', NULL, 'Cysteine-rich RLK (RECEPTOR-like protein kinase) 23', 104, NULL, NULL, 159318),
(159319, '1.20.1080.10-FF-000025', NULL, 'Formate/nitrite transporter', 262, NULL, NULL, 159319),
(159320, '1.10.510.10-FF-001203', NULL, 'Related to ABC1-ubiquinol--cytochrome-c reductase complex assembly protein', 87, NULL, NULL, 159320),
(159321, '2.30.280.10-FF-000013', NULL, NULL, 70, NULL, NULL, 159321),
(159322, '1.10.400.10-FF-000032', NULL, 'G Protein, Alpha subunit', 114, NULL, NULL, 159322),
(159323, '3.40.190.10-FF-000096', NULL, 'Aliphatic sulfonates ABC transporter substrate-binding protein', 174, NULL, NULL, 159323),
(159324, '1.10.220.150-FF-000063', NULL, 'Uncharacterized protein', 141, NULL, NULL, 159324),
(159325, '1.20.1250.10-FF-000022', NULL, 'ciliary neurotrophic factor', 187, NULL, NULL, 159325),
(159326, '2.170.140.10-FF-000054', NULL, 'AGAP009022-PA', 68, NULL, NULL, 159326),
(159327, '1.10.238.10-FF-001227', NULL, 'Ryanodine receptor, putative', 110, NULL, NULL, 159327),
(159328, '2.60.210.10-FF-000081', NULL, NULL, 70, NULL, NULL, 159328),
(159329, '3.80.10.10-FF-004231', NULL, 'Uncharacterized protein', 80, NULL, NULL, 159329),
(159330, '3.40.1000.50-FF-000026', NULL, 'Uncharacterized protein', 35, NULL, NULL, 159330),
(159331, '3.40.30.10-FF-001036', NULL, 'Peroxiredoxin-6', 33, NULL, NULL, 159331),
(159332, '3.30.70.580-FF-000038', NULL, 'Pseudouridine synthase', 84, NULL, NULL, 159332);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(159333, '3.30.465.10-FF-000096', NULL, 'Cholesterol oxidase', 127, NULL, NULL, 159333),
(159334, '3.30.560.10-FF-000014', NULL, 'LD25803p', 109, NULL, NULL, 159334),
(159335, '1.10.1670.10-FF-000005', NULL, 'N-glycosylase/DNA lyase OGG1', 73, NULL, NULL, 159335),
(159336, '3.40.50.1240-FF-000162', NULL, 'Ubiquitin-associated and SH3 domain-containing protein B', 247, NULL, NULL, 159336),
(159337, '3.30.450.170-FF-000001', NULL, 'Two-component sensor histidine kinase', 125, NULL, NULL, 159337),
(159338, '2.40.50.690-FF-000018', NULL, 'RNB-domain-containing protein', 150, NULL, NULL, 159338),
(159339, '1.10.8.270-FF-000009', NULL, 'TBC1 domain family member 30', 101, NULL, NULL, 159339),
(159340, '3.30.40.10-FF-002307', NULL, 'TNF-receptor-associated factor 2', 113, NULL, NULL, 159340),
(159341, '1.10.510.10-FF-001260', NULL, 'Serine/threonine protein kinase, putative', 188, NULL, NULL, 159341),
(159342, '2.70.40.10-FF-000009', NULL, 'dCTP deaminase, dUMP-forming', 171, NULL, NULL, 159342),
(159343, '3.90.70.10-FF-000845', NULL, 'Protein CBG17829', 119, NULL, NULL, 159343),
(159344, '3.30.2350.20-FF-000079', NULL, NULL, 45, NULL, NULL, 159344),
(159345, '1.20.1560.10-FF-000450', NULL, 'Uncharacterized protein', 105, NULL, NULL, 159345),
(159346, '2.40.70.10-FF-000198', NULL, 'Uncharacterized protein', 159, NULL, NULL, 159346),
(159347, '3.40.50.1910-FF-000003', NULL, 'vacuolar protein sorting-associated protein 33B isoform X2', 171, NULL, NULL, 159347),
(159348, '3.30.160.60-FF-004579', NULL, NULL, 27, NULL, NULL, 159348),
(159349, '2.130.10.10-FF-004057', NULL, 'Uncharacterized protein', 212, NULL, NULL, 159349),
(159350, '3.30.450.190-FF-000007', NULL, 'GTP-binding protein GTR1', 138, NULL, NULL, 159350),
(159351, '3.40.50.300-FF-007204', NULL, 'Shikimate kinase', 167, NULL, NULL, 159351),
(159352, '1.10.246.110-FF-000002', NULL, 'ATP synthase-coupling factor 6, mitochondrial', 60, NULL, NULL, 159352),
(159353, '2.30.30.40-FF-000446', NULL, 'SH3 domain and tetratricopeptide repeat-containing protein 2', 67, NULL, NULL, 159353),
(159354, '2.60.120.200-FF-000470', NULL, 'Metalloendopeptidase', 221, NULL, NULL, 159354),
(159355, '1.10.510.10-FF-000984', NULL, 'CAMK family protein kinase', 294, NULL, NULL, 159355),
(159356, '3.30.420.10-FF-000127', NULL, 'Exoribonuclease, putative', 171, NULL, NULL, 159356),
(159357, '1.10.510.10-FF-003390', NULL, NULL, 312, NULL, NULL, 159357),
(159358, '3.40.50.300-FF-004911', NULL, 'Uncharacterized protein', 308, NULL, NULL, 159358),
(159359, '3.30.428.10-FF-000027', NULL, 'Histidine triad (HIT) protein', 139, NULL, NULL, 159359),
(159360, '3.40.50.360-FF-000106', NULL, 'NADPH-dependent FMN reductase', 183, NULL, NULL, 159360),
(159361, '3.75.10.10-FF-000034', NULL, 'Uncharacterized protein', 400, NULL, NULL, 159361),
(159362, '3.30.200.20-FF-000586', NULL, 'Receptor protein-tyrosine kinase', 127, NULL, NULL, 159362),
(159363, '2.30.29.70-FF-000013', NULL, 'Proteasome complex subunit Rpn13 ubiquitin receptor, putative', 113, NULL, NULL, 159363),
(159364, '3.30.70.330-FF-002633', NULL, NULL, 125, NULL, NULL, 159364),
(159365, '3.40.50.2000-FF-000305', NULL, 'RE03785p', 215, NULL, NULL, 159365),
(159366, '2.60.40.60-FF-000974', NULL, 'Uncharacterized protein', 113, NULL, NULL, 159366),
(159367, '1.10.246.120-FF-000005', NULL, 'rab5 GDP/GTP exchange factor', 101, NULL, NULL, 159367),
(159368, '3.40.50.300-FF-006985', NULL, 'Uncharacterized protein', 214, NULL, NULL, 159368),
(159369, '1.10.10.410-FF-000004', NULL, 'GatB/YqeY domain-containing protein', 61, NULL, NULL, 159369),
(159370, '1.10.287.110-FF-000376', NULL, 'Sll1384 protein', 78, NULL, NULL, 159370),
(159371, '2.170.16.10-FF-000004', NULL, 'Replicative DNA helicase DnaB', 90, NULL, NULL, 159371),
(159372, '3.10.300.10-FF-000011', NULL, 'N-methylpurine DNA glycosylase', 95, NULL, NULL, 159372),
(159373, '3.60.21.10-FF-000497', NULL, 'ABC transporter AbcH.3', 260, NULL, NULL, 159373),
(159374, '1.20.120.1150-FF-000013', NULL, 'Serine/threonine-protein phosphatase 2A activator', 34, NULL, NULL, 159374);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(159375, '1.10.510.10-FF-001821', NULL, 'Pkinase-domain-containing protein', 361, NULL, NULL, 159375),
(159376, '1.10.1060.10-FF-000032', NULL, NULL, 116, NULL, NULL, 159376),
(159377, '3.30.1010.10-FF-000146', NULL, 'Uncharacterized protein', 164, NULL, NULL, 159377),
(159378, '3.40.50.1980-FF-000147', NULL, 'Putative ferrichrome-binding protein', 160, NULL, NULL, 159378),
(159379, '3.30.559.10-FF-000151', NULL, 'Uncharacterized protein', 182, NULL, NULL, 159379),
(159380, '3.40.50.300-FF-003551', NULL, 'Signal recognition particle receptor alpha subunit family protein', 133, NULL, NULL, 159380),
(159381, '3.90.226.10-FF-000292', NULL, 'Uncharacterized protein', 175, NULL, NULL, 159381),
(159382, '2.60.120.200-FF-000357', NULL, 'Putative L-type lectin-domain containing receptor kinase S.7 isoform A', 253, NULL, NULL, 159382),
(159383, '2.130.10.10-FF-002876', NULL, '77 kDa echinoderm microtubule-associated protein', 131, NULL, NULL, 159383),
(159384, '3.40.50.2300-FF-000570', NULL, 'AGAP000803-PA-like protein', 153, NULL, NULL, 159384),
(159385, '3.30.160.60-FF-001600', NULL, 'Adr1 transcription factor', 25, NULL, NULL, 159385),
(159386, '3.30.460.10-FF-000124', NULL, 'Speckle targeted PIP5K1A-regulated poly(A) polymerase', 105, NULL, NULL, 159386),
(159387, '1.10.3720.10-FF-000078', NULL, 'Dipeptide ABC transporter permease DppB', 216, NULL, NULL, 159387),
(159388, '1.25.40.10-FF-002611', NULL, 'Tetratricopeptide repeat protein 1', 156, NULL, NULL, 159388),
(159389, '1.20.1250.20-FF-000244', NULL, 'Multidrug resistance protein', 372, NULL, NULL, 159389),
(159390, '3.30.160.60-FF-000982', NULL, 'Zinc finger and SCAN domain containing 10', 28, NULL, NULL, 159390),
(159391, '2.10.25.10-FF-000201', NULL, 'EGF-containing fibulin-like extracellular matrix protein 2', 40, NULL, NULL, 159391),
(159392, '2.10.25.10-FF-000145', NULL, 'Laminin subunit beta 1', 46, NULL, NULL, 159392),
(159393, '2.20.100.10-FF-000014', NULL, 'Thrombospondin type 1 domain containing 7A', 57, NULL, NULL, 159393),
(159394, '3.30.200.20-FF-000861', NULL, 'Mitogen-activated protein kinase', 123, NULL, NULL, 159394),
(159395, '1.10.287.3240-FF-000012', NULL, 'V-type ATP synthase subunit D', 210, NULL, NULL, 159395),
(159396, '3.10.100.10-FF-000299', NULL, NULL, 134, NULL, NULL, 159396),
(159397, '2.60.40.10-FF-004641', NULL, NULL, 91, NULL, NULL, 159397),
(159398, '3.30.160.60-FF-001420', NULL, 'Zinc finger and BTB domain containing 11', 25, NULL, NULL, 159398),
(159399, '3.40.1690.20-FF-000001', NULL, 'AFG3-like AAA ATPase 2', 96, NULL, NULL, 159399),
(159400, '3.40.50.300-FF-001421', NULL, 'ATP-dependent DNA helicase', 208, NULL, NULL, 159400),
(159401, '1.10.1540.10-FF-000001', NULL, 'neurobeachin isoform X1', 288, NULL, NULL, 159401),
(159402, '2.40.70.10-FF-000473', NULL, NULL, 160, NULL, NULL, 159402),
(159403, '1.20.1410.10-FF-000006', NULL, 'Huntingtin interacting protein', 203, NULL, NULL, 159403),
(159404, '1.10.8.720-FF-000066', NULL, 'Dynein heavy chain, cytoplasmic', 166, NULL, NULL, 159404),
(159405, '2.60.120.200-FF-000413', NULL, 'Crumbs-like protein 2b', 160, NULL, NULL, 159405),
(159406, '1.10.630.10-FF-000021', NULL, 'Cytochrome P450 61', 468, NULL, NULL, 159406),
(159407, '2.40.50.140-FF-000084', NULL, 'Single-stranded DNA-binding protein', 115, NULL, NULL, 159407),
(159408, '3.10.20.90-FF-000594', NULL, 'Uncharacterized protein', 44, NULL, NULL, 159408),
(159409, '3.30.559.10-FF-000095', NULL, 'Carnitine O-palmitoyltransferase 1, muscle isoform', 57, NULL, NULL, 159409),
(159410, '3.30.70.3030-FF-000004', NULL, 'U3 small nucleolar RNA-associated protein 22', 138, NULL, NULL, 159410),
(159411, '3.30.70.3040-FF-000007', NULL, 'Cell division protein FtsX', 112, NULL, NULL, 159411),
(159412, '1.25.40.10-FF-000576', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 128, NULL, NULL, 159412),
(159413, '1.25.40.10-FF-001032', NULL, 'PPR repeat family, putative', 131, NULL, NULL, 159413),
(159414, '3.40.190.10-FF-000770', NULL, 'Ionotropic receptor 11a', 145, NULL, NULL, 159414),
(159415, '2.40.160.10-FF-000075', NULL, 'Uncharacterized protein', 201, NULL, NULL, 159415);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(159416, '1.10.287.70-FF-000335', NULL, 'TWiK family of potassium channels protein 7', 338, NULL, NULL, 159416),
(159417, '1.25.40.20-FF-000579', NULL, 'Mga2p', 134, NULL, NULL, 159417),
(159418, '1.10.287.380-FF-000030', NULL, 'ABC transporter ATP-binding protein', 88, NULL, NULL, 159418),
(159419, '1.20.1250.20-FF-000064', NULL, 'MFS allantoate transporter', 205, NULL, NULL, 159419),
(159420, '3.30.750.24-FF-000093', NULL, 'Sulfate transporter', 123, NULL, NULL, 159420),
(159421, '3.30.710.10-FF-000161', NULL, 'Os07g0625400 protein', 140, NULL, NULL, 159421),
(159422, '3.40.30.10-FF-000979', NULL, 'NADH:ubiquinone oxidoreductase 11 kDa subunit', 91, NULL, NULL, 159422),
(159423, '1.25.40.10-FF-000756', NULL, 'RNA polymerase III transcription factor TFIIIC subunit (Tfc4), putative', 240, NULL, NULL, 159423),
(159424, '3.40.190.10-FF-000713', NULL, 'Aliphatic sulfonates binding protein', 170, NULL, NULL, 159424),
(159425, '1.10.1070.11-FF-000034', NULL, 'Serine/threonine-protein kinase Tel1', 168, NULL, NULL, 159425),
(159426, '3.80.10.10-FF-001882', NULL, 'Leucine Rich Repeat family protein', 115, NULL, NULL, 159426),
(159427, '3.40.50.300-FF-008565', NULL, 'Uncharacterized protein ABCH4', 226, NULL, NULL, 159427),
(159428, '1.10.510.10-FF-003058', NULL, NULL, 209, NULL, NULL, 159428),
(159429, '3.40.50.1820-FF-000127', NULL, 'Thyroglobulin', 535, NULL, NULL, 159429),
(159430, '1.20.1070.10-FF-002054', NULL, 'Growth hormone-releasing hormone receptor b', 96, NULL, NULL, 159430),
(159431, '3.40.30.10-FF-001093', NULL, 'Glutathione s-transferase', 83, NULL, NULL, 159431),
(159432, '3.40.50.300-FF-008508', NULL, 'ATPase, AAA family protein', 181, NULL, NULL, 159432),
(159433, '3.40.50.1820-FF-000184', NULL, 'Lipase 2', 282, NULL, NULL, 159433),
(159434, '1.10.720.30-FF-000005', NULL, 'scaffold attachment factor B2 isoform X1', 60, NULL, NULL, 159434),
(159435, '3.90.79.10-FF-000191', NULL, 'Putative ADP-ribose pyrophosphatase', 172, NULL, NULL, 159435),
(159436, '3.90.550.10-FF-000562', NULL, 'Predicted protein', 134, NULL, NULL, 159436),
(159437, '1.10.260.40-FF-000080', NULL, 'Transcriptional regulator of HTH-type, xre family', 78, NULL, NULL, 159437),
(159438, '2.20.100.10-FF-000233', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs adt-1 isoform X1', 52, NULL, NULL, 159438),
(159439, '1.10.40.30-FF-000003', NULL, 'Aspartate ammonia-lyase', 50, NULL, NULL, 159439),
(159440, '3.30.160.60-FF-002999', NULL, 'Zinc finger imprinted 2', 29, NULL, NULL, 159440),
(159441, '3.30.430.20-FF-000070', NULL, 'Os11g0681400 protein', 85, NULL, NULL, 159441),
(159442, '3.10.129.10-FF-000056', NULL, 'Hypothetical Thioesterase Protein SP_1851', 134, NULL, NULL, 159442),
(159443, '1.10.220.150-FF-000006', NULL, 'arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 3', 119, NULL, NULL, 159443),
(159444, '2.130.10.10-FF-003371', NULL, 'WD repeat-containing protein dyf-2', 210, NULL, NULL, 159444),
(159445, '3.40.50.300-FF-002876', NULL, '3''-5'' exonuclease DinG', 249, NULL, NULL, 159445),
(159446, '3.40.50.1820-FF-001544', NULL, 'Uncharacterized protein', 129, NULL, NULL, 159446),
(159447, '3.60.21.10-FF-000278', NULL, 'Protein CBG07490', 87, NULL, NULL, 159447),
(159448, '3.30.160.60-FF-000925', NULL, 'Zinc finger protein 668', 28, NULL, NULL, 159448),
(159449, '3.30.450.20-FF-000301', NULL, 'SIM bHLH transcription factor 2', 86, NULL, NULL, 159449),
(159450, '3.30.420.110-FF-000039', NULL, 'DNA mismatch repair protein msh2', 186, NULL, NULL, 159450),
(159451, '1.10.220.160-FF-000009', NULL, 'Uncharacterized protein, isoform B', 106, NULL, NULL, 159451),
(159452, '3.80.10.10-FF-001606', NULL, 'Receptor protein-tyrosine kinase CEPR1', 282, NULL, NULL, 159452),
(159453, '3.90.180.10-FF-000128', NULL, 'Uncharacterized protein', 78, NULL, NULL, 159453),
(159454, '3.30.70.660-FF-000017', NULL, 'tRNA pseudouridine(38-40) synthase', 193, NULL, NULL, 159454),
(159455, '2.60.120.200-FF-000138', NULL, 'Contactin associated protein like 4', 167, NULL, NULL, 159455),
(159456, '2.60.40.2170-FF-000015', NULL, 'Uncharacterized protein', 111, NULL, NULL, 159456);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(159457, '3.30.160.60-FF-003275', NULL, NULL, 27, NULL, NULL, 159457),
(159458, '3.30.780.10-FF-000053', NULL, 'Translation initiation factor SUI1', 83, NULL, NULL, 159458),
(159459, '1.20.1070.10-FF-001559', NULL, 'Predicted protein', 171, NULL, NULL, 159459),
(159460, '3.30.1770.10-FF-000001', NULL, 'DNA polymerase', 98, NULL, NULL, 159460),
(159461, '1.20.950.20-FF-000012', NULL, 'Cytochrome B561', 85, NULL, NULL, 159461),
(159462, '3.30.710.10-FF-000228', NULL, 'Predicted protein', 155, NULL, NULL, 159462),
(159463, '3.30.200.20-FF-000642', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 91, NULL, NULL, 159463),
(159464, '2.60.40.10-FF-003005', NULL, 'Kazal-type serine protease inhibitor domain-containing protein 1', 111, NULL, NULL, 159464),
(159465, '3.30.160.60-FF-004293', NULL, NULL, 89, NULL, NULL, 159465),
(159466, '3.40.50.300-FF-007148', NULL, 'Shikimate kinase', 176, NULL, NULL, 159466),
(159467, '2.60.40.10-FF-003062', NULL, 'Fibroblast growth factor receptor', 100, NULL, NULL, 159467),
(159468, '3.40.50.450-FF-000021', NULL, 'Probable ATP-dependent 6-phosphofructokinase', 284, NULL, NULL, 159468),
(159469, '1.10.510.10-FF-000366', NULL, 'Serine/threonine-protein kinase Nek2', 191, NULL, NULL, 159469),
(159470, '2.60.40.2860-FF-000014', NULL, 'Transmission-blocking target antigen S230', 136, NULL, NULL, 159470),
(159471, '3.30.565.10-FF-000441', NULL, 'Sensor protein QseC', 143, NULL, NULL, 159471),
(159472, '3.30.300.30-FF-000012', NULL, 'D-alanine--D-alanyl carrier protein ligase', 107, NULL, NULL, 159472),
(159473, '1.25.40.10-FF-001251', NULL, 'Type III export protein PscG', 115, NULL, NULL, 159473),
(159474, '2.10.50.30-FF-000046', NULL, 'Uncharacterized protein', 68, NULL, NULL, 159474),
(159475, '3.40.50.12780-FF-000076', NULL, 'Salicyl-AMP ligase / salicyl-S-ArCP synthetase', 438, NULL, NULL, 159475),
(159476, '3.40.50.460-FF-000024', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase', 140, NULL, NULL, 159476),
(159477, '2.130.10.10-FF-004731', NULL, 'Protein NEDD1', 165, NULL, NULL, 159477),
(159478, '2.30.18.10-FF-000010', NULL, 'Transcription initiation factor IIA subunit 2', 54, NULL, NULL, 159478),
(159479, '1.25.40.20-FF-001254', NULL, 'Predicted protein', 224, NULL, NULL, 159479),
(159480, '3.30.70.330-FF-002453', NULL, NULL, 155, NULL, NULL, 159480),
(159481, '3.40.50.720-FF-000411', NULL, 'Aspartate-semialdehyde dehydrogenase', 165, NULL, NULL, 159481),
(159482, '2.60.40.10-FF-002786', NULL, 'Contactin rig-6', 112, NULL, NULL, 159482),
(159483, '3.10.20.90-FF-000936', NULL, 'Uncharacterized protein', 79, NULL, NULL, 159483),
(159484, '3.40.50.11500-FF-000001', NULL, 'Putative DENN domain-containing protein 1A', 164, NULL, NULL, 159484),
(159485, '1.10.260.40-FF-000023', NULL, 'Cyanate hydratase', 88, NULL, NULL, 159485),
(159486, '3.40.50.2300-FF-000513', NULL, 'Uncharacterized protein', 310, NULL, NULL, 159486),
(159487, '3.40.50.1000-FF-000668', NULL, NULL, 202, NULL, NULL, 159487),
(159488, '3.80.10.10-FF-004175', NULL, 'Tubulin folding cofactor E', 98, NULL, NULL, 159488),
(159489, '3.40.630.10-FF-000467', NULL, 'Amidohydrolase, putative', 86, NULL, NULL, 159489),
(159490, '1.10.510.10-FF-004076', NULL, NULL, 178, NULL, NULL, 159490),
(159491, '2.10.110.10-FF-000360', NULL, 'Uncharacterized protein', 74, NULL, NULL, 159491),
(159492, '3.40.50.10900-FF-000018', NULL, 'Uncharacterized protein', 165, NULL, NULL, 159492),
(159493, '2.60.40.10-FF-001066', NULL, 'Obscurin-like protein 1 isoform 3', 89, NULL, NULL, 159493),
(159494, '1.10.530.40-FF-000005', NULL, 'Lysozyme', 165, NULL, NULL, 159494),
(159495, '3.30.230.70-FF-000075', NULL, 'Exosome-associated protein 2', 268, NULL, NULL, 159495),
(159496, '3.30.990.10-FF-000001', NULL, 'Formimidoyltransferase cyclodeaminase', 180, NULL, NULL, 159496),
(159497, '2.60.120.260-FF-000358', NULL, 'Cellulose synthase', 136, NULL, NULL, 159497),
(159498, '1.10.565.10-FF-000003', NULL, 'Coup transcription factor 2 isoform 1', 243, NULL, NULL, 159498),
(159499, '1.10.418.10-FF-000174', NULL, 'Uncharacterized protein', 111, NULL, NULL, 159499);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(159500, '2.60.40.420-FF-000015', NULL, 'Ceruloplasmin', 182, NULL, NULL, 159500),
(159501, '3.40.30.10-FF-001098', NULL, 'Glutathione S-transferase family protein', 72, NULL, NULL, 159501),
(159502, '3.30.70.330-FF-000430', NULL, 'Glycine-rich RNA-binding protein GRP1A', 111, NULL, NULL, 159502),
(159503, '3.40.50.1910-FF-000020', NULL, 'GD21217', 167, NULL, NULL, 159503),
(159504, '2.70.170.10-FF-000069', NULL, 'Acetylcholine-gated chloride channel subunit acc-1', 213, NULL, NULL, 159504),
(159505, '1.25.10.10-FF-000288', NULL, 'Serine/threonine-protein kinase TOR', 118, NULL, NULL, 159505),
(159506, '3.30.70.330-FF-002554', NULL, NULL, 150, NULL, NULL, 159506),
(159507, '3.30.200.20-FF-002317', NULL, 'Uncharacterized protein', 100, NULL, NULL, 159507),
(159508, '3.40.50.150-FF-000538', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', 174, NULL, NULL, 159508),
(159509, '1.10.287.810-FF-000001', NULL, 'mitochondrial import inner membrane translocase subunit TIM13', 64, NULL, NULL, 159509),
(159510, '1.10.287.820-FF-000004', NULL, 'Amiloride-sensitive Na+ channel', 96, NULL, NULL, 159510),
(159511, '3.60.21.10-FF-000379', NULL, 'Uncharacterized protein', 83, NULL, NULL, 159511),
(159512, '3.10.20.620-FF-000005', NULL, 'Autophagy protein 5', 111, NULL, NULL, 159512),
(159513, '3.90.1150.10-FF-000463', NULL, 'Kynureninase', 183, NULL, NULL, 159513),
(159514, '1.25.10.10-FF-002542', NULL, 'Uncharacterized protein', 180, NULL, NULL, 159514),
(159515, '3.30.40.10-FF-000385', NULL, 'SNF2 helicase, putative (ISWI)', 58, NULL, NULL, 159515),
(159516, '3.40.50.10680-FF-000002', NULL, 'Maternal effect embryo arrest 18', 359, NULL, NULL, 159516),
(159517, '1.20.120.810-FF-000011', NULL, NULL, 165, NULL, NULL, 159517),
(159518, '3.30.300.130-FF-000024', NULL, 'Scaffold protein Nfu/NifU N terminal/NifU-like domain containing protein, putative', 77, NULL, NULL, 159518),
(159519, '3.30.230.70-FF-000119', NULL, 'Uncharacterized protein', 239, NULL, NULL, 159519),
(159520, '1.10.630.10-FF-000043', NULL, 'Cytochrome P450 99A2', 472, NULL, NULL, 159520),
(159521, '2.160.20.10-FF-000239', NULL, 'Pectinesterase', 202, NULL, NULL, 159521),
(159522, '3.90.1150.10-FF-000507', NULL, 'Cysteine desulfurase, putative', 114, NULL, NULL, 159522),
(159523, '1.25.40.20-FF-000798', NULL, 'Ankyrin repeat family protein', 50, NULL, NULL, 159523),
(159524, '3.90.550.10-FF-000770', NULL, 'Uncharacterized protein', 232, NULL, NULL, 159524),
(159525, '1.10.1420.10-FF-000167', NULL, 'MutS domain III family protein', 218, NULL, NULL, 159525),
(159526, '1.10.268.20-FF-000001', NULL, 'EH domain-containing protein 3', 144, NULL, NULL, 159526),
(159527, '1.25.40.180-FF-000206', NULL, NULL, 220, NULL, NULL, 159527),
(159528, '3.30.590.10-FF-000055', NULL, 'Predicted protein', 136, NULL, NULL, 159528),
(159529, '1.10.150.20-FF-000099', NULL, 'DNA ligase B', 76, NULL, NULL, 159529),
(159530, '2.130.10.10-FF-001044', NULL, 'Protein HIRA', 208, NULL, NULL, 159530),
(159531, '3.40.50.12780-FF-000205', NULL, 'Uncharacterized protein', 275, NULL, NULL, 159531),
(159532, '2.10.25.10-FF-001269', NULL, 'Laminin subunit alpha-1-like Protein', 46, NULL, NULL, 159532),
(159533, '3.30.460.10-FF-000017', NULL, 'Interleukin enhancer-binding factor 2', 152, NULL, NULL, 159533),
(159534, '3.30.200.20-FF-000182', NULL, 'PTI1-like tyrosine-protein kinase 3', 114, NULL, NULL, 159534),
(159535, '2.120.10.30-FF-000409', NULL, 'Uncharacterized protein', 191, NULL, NULL, 159535),
(159536, '3.40.50.1820-FF-000335', NULL, 'Carboxypeptidase', 452, NULL, NULL, 159536),
(159537, '3.30.1120.30-FF-000020', NULL, 'Serine/threonine-protein kinase PLK', 106, NULL, NULL, 159537),
(159538, '1.25.10.10-FF-000934', NULL, 'Degreening related gene dee76 protein', 332, NULL, NULL, 159538),
(159539, '1.20.1050.10-FF-000260', NULL, 'Predicted protein', 134, NULL, NULL, 159539),
(159540, '1.25.40.10-FF-004494', NULL, 'Uncharacterized protein', 97, NULL, NULL, 159540),
(159541, '3.60.60.10-FF-000025', NULL, 'N-acylsphingosine amidohydrolase (acid ceramidase) 1', 198, NULL, NULL, 159541); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(159542, '3.50.50.60-FF-000422', NULL, 'Probable dehydrogenase', 109, NULL, NULL, 159542),
(159543, '1.10.510.10-FF-001714', NULL, 'Predicted protein', 278, NULL, NULL, 159543),
(159544, '2.60.120.650-FF-000059', NULL, 'Ecm5p', 287, NULL, NULL, 159544),
(159545, '3.30.40.10-FF-001487', NULL, 'Uncharacterized protein', 82, NULL, NULL, 159545),
(159546, '1.20.1050.10-FF-000304', NULL, 'Uncharacterized protein', 36, NULL, NULL, 159546),
(159547, '2.40.128.180-FF-000001', NULL, 'Fas apoptotic inhibitory molecule 1', 90, NULL, NULL, 159547),
(159548, '1.20.1070.10-FF-000513', NULL, 'Predicted protein', 305, NULL, NULL, 159548),
(159549, '3.30.430.20-FF-000002', NULL, 'Cysteine-rich receptor-like protein kinase 10', 106, NULL, NULL, 159549),
(159550, '3.10.350.10-FF-000025', NULL, 'N-acetylmuramoyl-L-alanine amidase', 56, NULL, NULL, 159550),
(159551, '2.40.30.170-FF-000066', NULL, NULL, 70, NULL, NULL, 159551),
(159552, '3.40.630.10-FF-000248', NULL, 'Peptidase T', 284, NULL, NULL, 159552),
(159553, '3.40.50.300-FF-004776', NULL, 'UPF1 regulator of nonsense transcripts homolog', 88, NULL, NULL, 159553),
(159554, '2.40.50.140-FF-000281', NULL, '26S protease regulatory subunit S10B, putative', 109, NULL, NULL, 159554),
(159555, '3.90.1150.10-FF-000137', NULL, 'DegT/DnrJ/EryC1/StrS aminotransferase family protein', 134, NULL, NULL, 159555),
(159556, '2.20.28.120-FF-000014', NULL, '50S ribosomal protein L33', 60, NULL, NULL, 159556),
(159557, '1.10.10.10-FF-000771', NULL, 'ATP-dependent DNA helicase RecQ', 115, NULL, NULL, 159557),
(159558, '2.60.40.10-FF-003320', NULL, 'CBN-SAX-3 protein', 114, NULL, NULL, 159558),
(159559, '1.25.40.10-FF-004168', NULL, 'TPR Domain containing protein', 100, NULL, NULL, 159559),
(159560, '1.25.40.10-FF-000806', NULL, 'Os11g0114800 protein', 141, NULL, NULL, 159560),
(159561, '2.130.10.10-FF-002781', NULL, 'Protein TRANSPARENT TESTA GLABRA, putative', 215, NULL, NULL, 159561),
(159562, '2.20.70.10-FF-000154', NULL, 'Uncharacterized protein', 44, NULL, NULL, 159562),
(159563, '1.20.58.60-FF-000350', NULL, 'Dystonin', 112, NULL, NULL, 159563),
(159564, '3.40.50.1220-FF-000043', NULL, 'NAD-dependent protein deacetylase', 128, NULL, NULL, 159564),
(159565, '3.40.50.1000-FF-000545', NULL, NULL, 201, NULL, NULL, 159565),
(159566, '1.10.510.10-FF-000888', NULL, 'Mitogen-activated protein kinase, putative', 272, NULL, NULL, 159566),
(159567, '2.30.30.100-FF-000008', NULL, 'Small nuclear ribonucleoprotein Sm D1', 82, NULL, NULL, 159567),
(159568, '1.25.40.20-FF-000809', NULL, 'Uncharacterized protein', 112, NULL, NULL, 159568),
(159569, '3.30.1370.10-FF-000156', NULL, 'RNA-binding protein', 74, NULL, NULL, 159569),
(159570, '3.40.50.2000-FF-000053', NULL, 'Phosphatidylinositol N-acetylglucosaminyltransferase GPI3 subunit', 182, NULL, NULL, 159570),
(159571, '3.30.565.10-FF-000542', NULL, 'Hybrid signal transduction histidine kinase M', 130, NULL, NULL, 159571),
(159572, '3.40.50.880-FF-000083', NULL, 'Imidazole glycerol phosphate synthase subunit HisH', 209, NULL, NULL, 159572),
(159573, '1.20.210.10-FF-000026', NULL, 'Cytochrome c oxidase subunit 1', 155, NULL, NULL, 159573),
(159574, '2.60.40.790-FF-000194', NULL, NULL, 87, NULL, NULL, 159574),
(159575, '1.20.120.1630-FF-000022', NULL, '15-cis-zeta-carotene isomerase, chloroplastic', 185, NULL, NULL, 159575),
(159576, '3.30.420.40-FF-000395', NULL, 'Actin-related protein 8', 90, NULL, NULL, 159576),
(159577, '3.40.350.10-FF-000092', NULL, 'Uncharacterized protein', 162, NULL, NULL, 159577),
(159578, '1.10.150.60-FF-000015', NULL, 'AT-rich interactive domain-containing protein 5B', 102, NULL, NULL, 159578),
(159579, '3.40.850.10-FF-000129', NULL, 'Dachs, isoform D', 178, NULL, NULL, 159579),
(159580, '1.20.1070.10-FF-001941', NULL, 'Protein CBR-DOP-6', 239, NULL, NULL, 159580),
(159581, '2.70.98.110-FF-000019', NULL, NULL, 170, NULL, NULL, 159581),
(159582, '3.40.50.300-FF-008475', NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 8', 224, NULL, NULL, 159582),
(159583, '3.40.50.2300-FF-000362', NULL, 'Probable metabotropic glutamate receptor mgl-1', 156, NULL, NULL, 159583);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(159584, '3.30.160.60-FF-000998', NULL, 'Zinc finger protein 521', 71, NULL, NULL, 159584),
(159585, '3.40.640.10-FF-000529', NULL, 'Uncharacterized protein', 90, NULL, NULL, 159585),
(159586, '3.30.40.10-FF-002004', NULL, 'Uncharacterized protein', 51, NULL, NULL, 159586),
(159587, '3.40.50.300-FF-000398', NULL, 'Type IV pilus assembly ATPase PilB', 278, NULL, NULL, 159587),
(159588, '3.40.50.1240-FF-000049', NULL, 'Acid phosphatase aph, 3-phytase phyB', 59, NULL, NULL, 159588),
(159589, '2.60.40.820-FF-000045', NULL, 'Uncharacterized protein', 129, NULL, NULL, 159589),
(159590, '2.120.10.80-FF-000273', NULL, 'F-box/LRR-repeat/kelch-repeat protein At1g09650', 232, NULL, NULL, 159590),
(159591, '1.25.40.10-FF-003988', NULL, 'Mitochondrial ribosomal protein S27', 215, NULL, NULL, 159591),
(159592, '3.20.20.100-FF-000016', NULL, '2,5-diketo-D-gluconic acid reductase B', 265, NULL, NULL, 159592),
(159593, '3.30.160.60-FF-004697', NULL, NULL, 27, NULL, NULL, 159593),
(159594, '1.10.510.10-FF-003322', NULL, NULL, 68, NULL, NULL, 159594),
(159595, '3.30.710.10-FF-000144', NULL, 'BTB/POZ domain-containing protein', 123, NULL, NULL, 159595),
(159596, '1.20.1420.30-FF-000108', NULL, 'AGAP010974-PA', 110, NULL, NULL, 159596),
(159597, '3.30.1230.20-FF-000003', NULL, '40S ribosomal protein S21', 90, NULL, NULL, 159597),
(159598, '3.40.50.150-FF-000864', NULL, 'tRNA (adenine(58)-N(1))-methyltransferase TrmI', 196, NULL, NULL, 159598),
(159599, '1.25.40.10-FF-005011', NULL, 'Uncharacterized protein', 116, NULL, NULL, 159599),
(159600, '2.20.100.10-FF-000250', NULL, 'Uncharacterized protein', 51, NULL, NULL, 159600),
(159601, '2.130.10.10-FF-002472', NULL, 'Cysteine-rich receptor-like protein kinase 26', 276, NULL, NULL, 159601),
(159602, '3.40.50.280-FF-000009', NULL, 'Methylmalonyl-CoA mutase small subunit mutA', 133, NULL, NULL, 159602),
(159603, '1.25.10.10-FF-001114', NULL, 'Related to MAPKK kinase', 248, NULL, NULL, 159603),
(159604, '1.20.1090.10-FF-000043', NULL, 'Putative iron alcohol dehydrogenase', 195, NULL, NULL, 159604),
(159605, '3.40.50.300-FF-002859', NULL, 'putative pre-mRNA-splicing factor ATP-dependent RNA helicase DHX16 isoform X1', 100, NULL, NULL, 159605),
(159606, '3.80.10.10-FF-002421', NULL, 'Uncharacterized protein', 112, NULL, NULL, 159606),
(159607, '1.10.40.30-FF-000020', NULL, 'Adenylosuccinate lyase', 81, NULL, NULL, 159607),
(159608, '1.20.1070.10-FF-000160', NULL, 'Related to Opsin-1', 242, NULL, NULL, 159608),
(159609, '1.10.510.10-FF-000681', NULL, 'Muscle M-line assembly protein unc-89-like Protein', 199, NULL, NULL, 159609),
(159610, '2.30.30.40-FF-000435', NULL, 'Uncharacterized protein', 68, NULL, NULL, 159610),
(159611, '3.10.100.10-FF-000349', NULL, NULL, 127, NULL, NULL, 159611),
(159612, '1.20.1560.10-FF-000051', NULL, 'ATP-binding cassette subfamily B member 11', 22, NULL, NULL, 159612),
(159613, '3.20.180.20-FF-000046', NULL, 'Uncharacterized protein', 56, NULL, NULL, 159613),
(159614, '3.30.260.10-FF-000036', NULL, '60 kDa heat shock protein, mitochondrial', 92, NULL, NULL, 159614),
(159615, '2.10.110.10-FF-000034', NULL, 'Insulin gene enhancer protein ISL', 58, NULL, NULL, 159615),
(159616, '2.40.70.10-FF-000361', NULL, NULL, 128, NULL, NULL, 159616),
(159617, '3.30.70.330-FF-002184', NULL, NULL, 71, NULL, NULL, 159617),
(159618, '3.40.190.10-FF-000590', NULL, 'Prephenate dehydratase', 89, NULL, NULL, 159618),
(159619, '2.10.25.10-FF-001595', NULL, 'LOC553337 protein', 34, NULL, NULL, 159619),
(159620, '3.30.710.10-FF-000453', NULL, 'Skp1 family, dimerisation domain containing protein', 142, NULL, NULL, 159620),
(159621, '1.20.1420.30-FF-000064', NULL, 'Sodium/potassium/calcium exchanger Nckx30C', 192, NULL, NULL, 159621),
(159622, '1.10.510.10-FF-002507', NULL, 'Os02g0722250 protein', 262, NULL, NULL, 159622),
(159623, '2.30.30.750-FF-000001', NULL, '5''-3'' exoribonuclease 1', 100, NULL, NULL, 159623),
(159624, '3.80.10.10-FF-004203', NULL, 'NLR family CARD domain containing 3', 89, NULL, NULL, 159624),
(159625, '1.10.238.10-FF-000772', NULL, 'Mitochondrial proton/calcium exchanger protein', 89, NULL, NULL, 159625);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(159626, '2.10.10.20-FF-000013', NULL, 'Lambda phage tail fiber protein J', 64, NULL, NULL, 159626),
(159627, '1.20.120.1920-FF-000002', NULL, 'Ubiquitin-associated protein 1-like a', 117, NULL, NULL, 159627),
(159628, '3.40.50.300-FF-008149', NULL, 'Uncharacterized protein', 95, NULL, NULL, 159628),
(159629, '2.40.100.10-FF-000173', NULL, 'Peptidyl-prolyl cis-trans isomerase', 244, NULL, NULL, 159629),
(159630, '3.30.160.60-FF-001515', NULL, 'zinc finger protein 408', 35, NULL, NULL, 159630),
(159631, '3.30.160.240-FF-000001', NULL, 'DUF1876 domain-containing protein', 80, NULL, NULL, 159631),
(159632, '3.40.50.720-FF-000821', NULL, 'Him1p', 166, NULL, NULL, 159632),
(159633, '2.60.40.10-FF-001403', NULL, 'Sallimus, isoform U', 104, NULL, NULL, 159633),
(159634, '3.90.79.10-FF-000168', NULL, 'Translation initiation factor eIF-2B subunit family protein (AFU_orthologue AFUA_2G14290)', 160, NULL, NULL, 159634),
(159635, '1.10.238.10-FF-001261', NULL, 'Uncharacterized protein', 58, NULL, NULL, 159635),
(159636, '3.40.390.10-FF-000212', NULL, NULL, 140, NULL, NULL, 159636),
(159637, '3.40.50.150-FF-001353', NULL, NULL, 190, NULL, NULL, 159637),
(159638, '4.10.800.10-FF-000017', NULL, 'Thyroglobulin', 73, NULL, NULL, 159638),
(159639, '2.10.10.10-FF-000010', NULL, 'Coagulation factor XII', 66, NULL, NULL, 159639),
(159640, '3.10.660.10-FF-000009', NULL, 'DPH4 homolog', 58, NULL, NULL, 159640),
(159641, '3.40.190.10-FF-000601', NULL, 'Predicted protein', 34, NULL, NULL, 159641),
(159642, '3.40.50.300-FF-007064', NULL, 'Predicted protein', 298, NULL, NULL, 159642),
(159643, '1.20.120.420-FF-000017', NULL, 'Putative methylthioribose-1-phosphate isomerase', 156, NULL, NULL, 159643),
(159644, '1.25.40.20-FF-001271', NULL, 'Ankyrin repeat and KH domain-containing 1', 192, NULL, NULL, 159644),
(159645, '3.30.70.330-FF-002228', NULL, NULL, 80, NULL, NULL, 159645),
(159646, '1.10.510.10-FF-002816', NULL, NULL, 153, NULL, NULL, 159646),
(159647, '1.25.40.10-FF-002370', NULL, 'Os01g0754700 protein', 103, NULL, NULL, 159647),
(159648, '3.40.50.300-FF-003332', NULL, 'Ras family gtpase', 179, NULL, NULL, 159648),
(159649, '3.30.70.260-FF-000122', NULL, 'Putative acetolactate synthase small subunit', 78, NULL, NULL, 159649),
(159650, '2.130.10.10-FF-004579', NULL, 'Protein SLOW WALKER 1', 209, NULL, NULL, 159650),
(159651, '2.130.10.10-FF-005113', NULL, 'Uncharacterized protein', 243, NULL, NULL, 159651),
(159652, '3.10.129.10-FF-000106', NULL, 'UPF0336 protein ERDMAN_0553', 155, NULL, NULL, 159652),
(159653, '1.25.40.10-FF-002886', NULL, 'Protein NPGR2', 374, NULL, NULL, 159653),
(159654, '1.10.10.60-FF-001016', NULL, NULL, 91, NULL, NULL, 159654),
(159655, '3.40.718.10-FF-000002', NULL, 'Isocitrate dehydrogenase [NADP]', 413, NULL, NULL, 159655),
(159656, '3.40.50.1000-FF-000871', NULL, NULL, 153, NULL, NULL, 159656),
(159657, '3.20.20.220-FF-000069', NULL, 'Proline dehydrogenase', 404, NULL, NULL, 159657),
(159658, '3.40.50.2300-FF-000715', NULL, 'ABC transporter permease', 138, NULL, NULL, 159658),
(159659, '1.20.1250.20-FF-000261', NULL, 'NarK/NasA family nitrate transporter', 194, NULL, NULL, 159659),
(159660, '3.50.30.30-FF-000041', NULL, 'Cell wall-associated serine proteinase', 175, NULL, NULL, 159660),
(159661, '1.20.1270.250-FF-000001', NULL, 'Inhibitor of nuclear factor kappa-B kinase subunit alpha', 274, NULL, NULL, 159661),
(159662, '3.80.20.20-FF-000098', NULL, 'Erb-b2 receptor tyrosine kinase 3a', 24, NULL, NULL, 159662),
(159663, '1.25.40.530-FF-000019', NULL, 'Heavy chain, Unconventional Myosin', 107, NULL, NULL, 159663),
(159664, '3.30.200.110-FF-000001', NULL, 'Inositol-pentakisphosphate 2-kinase', 126, NULL, NULL, 159664),
(159665, '3.30.70.2850-FF-000012', NULL, 'DNA-directed RNA polymerase subunit', 214, NULL, NULL, 159665),
(159666, '3.90.550.50-FF-000186', NULL, 'Uncharacterized protein', 212, NULL, NULL, 159666),
(159667, '3.10.110.10-FF-000277', NULL, 'Predicted protein', 128, NULL, NULL, 159667),
(159668, '3.30.70.270-FF-000125', NULL, 'Uncharacterized protein', 85, NULL, NULL, 159668);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(159669, '3.90.25.10-FF-000004', NULL, 'ADP-L-glycero-D-manno-heptose-6-epimerase', 99, NULL, NULL, 159669),
(159670, '3.80.10.10-FF-001932', NULL, 'Receptor-like protein 41', 101, NULL, NULL, 159670),
(159671, '1.20.58.1380-FF-000001', NULL, 'Nuclear pore complex protein Nup133', 92, NULL, NULL, 159671),
(159672, '2.60.40.1960-FF-000008', NULL, 'Uncharacterized protein', 63, NULL, NULL, 159672),
(159673, '3.40.50.300-FF-001550', NULL, 'DEAD box DNA helicase', 249, NULL, NULL, 159673),
(159674, '1.25.40.10-FF-004831', NULL, 'Uncharacterized protein', 146, NULL, NULL, 159674),
(159675, '2.60.40.1940-FF-000002', NULL, 'Alpha-2-macroglobulin', 121, NULL, NULL, 159675),
(159676, '3.40.50.2300-FF-000036', NULL, 'D-ribose ABC transporter substrate-binding protein', 136, NULL, NULL, 159676),
(159677, '2.160.20.10-FF-000032', NULL, 'Pectin lyase-like superfamily protein', 386, NULL, NULL, 159677),
(159678, '3.90.70.10-FF-000648', NULL, 'Ubiquitin carboxylterminal hydrolase, putative', 89, NULL, NULL, 159678),
(159679, '2.60.40.60-FF-000805', NULL, 'Predicted protein', 89, NULL, NULL, 159679),
(159680, '1.10.10.10-FF-000445', NULL, 'Response regulator transcription factor', 106, NULL, NULL, 159680),
(159681, '1.25.40.90-FF-000066', NULL, 'VHS domain containing protein, putative', 162, NULL, NULL, 159681),
(159682, '3.40.50.150-FF-001044', NULL, 'Leucine carboxyl methyltransferase 1', 357, NULL, NULL, 159682),
(159683, '3.40.190.10-FF-000910', NULL, 'ABC-type dipeptide transport system periplasmic component-like protein', 99, NULL, NULL, 159683),
(159684, '3.40.50.720-FF-001586', NULL, '3-oxoacyl-[acyl-carrier-protein] reductase (NADPH)', 229, NULL, NULL, 159684),
(159685, '1.10.10.60-FF-000527', NULL, 'Zinc Finger and Homeobox', 66, NULL, NULL, 159685),
(159686, '2.60.40.10-FF-002494', NULL, 'Uip4p', 95, NULL, NULL, 159686),
(159687, '2.130.10.10-FF-000908', NULL, 'U3 small nucleolar RNA-associated protein 18', 358, NULL, NULL, 159687),
(159688, '2.60.40.150-FF-000367', NULL, 'Protein CBR-CED-5', 194, NULL, NULL, 159688),
(159689, '2.60.40.150-FF-000676', NULL, 'Dedicator of cytokinesis 1', 111, NULL, NULL, 159689),
(159690, '3.90.1310.10-FF-000009', NULL, 'Penicillin-binding protein transpeptidase', 182, NULL, NULL, 159690),
(159691, '2.30.42.10-FF-000543', NULL, NULL, 96, NULL, NULL, 159691),
(159692, '2.40.50.140-FF-000634', NULL, 'ABC transporter ATP-binding protein', 58, NULL, NULL, 159692),
(159693, '3.40.50.1820-FF-001746', NULL, 'Uncharacterized protein', 57, NULL, NULL, 159693),
(159694, '1.10.287.10-FF-000020', NULL, 'Methionine--tRNA ligase, cytoplasmic', 57, NULL, NULL, 159694),
(159695, '3.90.180.10-FF-000050', NULL, 'Unplaced genomic scaffold supercont2.5, whole genome shotgun sequence', 172, NULL, NULL, 159695),
(159696, '2.60.40.60-FF-000794', NULL, 'Desmocollin 3', 105, NULL, NULL, 159696),
(159697, '2.30.42.10-FF-000173', NULL, 'whirlin isoform X4', 98, NULL, NULL, 159697),
(159698, '3.30.160.60-FF-005540', NULL, NULL, 43, NULL, NULL, 159698),
(159699, '1.10.12.10-FF-000022', NULL, 'Probable enoyl-CoA hydratase echA17', 41, NULL, NULL, 159699),
(159700, '2.130.10.10-FF-000538', NULL, 'Peroxisomal targeting signal 2 receptor', 366, NULL, NULL, 159700),
(159701, '3.40.50.300-FF-001241', NULL, 'Endonuclease MutS2 isoform X1', 298, NULL, NULL, 159701),
(159702, '1.25.40.10-FF-005320', NULL, 'Uncharacterized protein', 113, NULL, NULL, 159702),
(159703, '2.10.25.10-FF-001606', NULL, 'Uncharacterized protein', 44, NULL, NULL, 159703),
(159704, '3.20.20.80-FF-000601', NULL, 'Uncharacterized protein', 189, NULL, NULL, 159704),
(159705, '3.30.70.120-FF-000013', NULL, 'DUF190 domain-containing protein', 112, NULL, NULL, 159705),
(159706, '1.25.40.10-FF-004477', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 103, NULL, NULL, 159706),
(159707, '3.30.300.110-FF-000001', NULL, 'tRNA (guanine(37)-N1)-methyltransferase', 79, NULL, NULL, 159707),
(159708, '3.10.450.10-FF-000089', NULL, 'Latexin', 36, NULL, NULL, 159708),
(159709, '3.40.50.300-FF-001078', NULL, 'Elongator acetyltransferase complex subunit 6', 251, NULL, NULL, 159709);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(159710, '3.30.160.60-FF-006288', NULL, NULL, 44, NULL, NULL, 159710),
(159711, '2.60.40.2860-FF-000019', NULL, 'Cysteine-rich surface protein', 134, NULL, NULL, 159711),
(159712, '3.10.350.10-FF-000042', NULL, 'Muramidase (Invasin repeat family)', 48, NULL, NULL, 159712),
(159713, '1.20.120.720-FF-000017', NULL, 'unconventional myosin-XV', 155, NULL, NULL, 159713),
(159714, '3.30.530.20-FF-000066', NULL, 'Polyketide cyclase/dehydrase and lipid transport', 141, NULL, NULL, 159714),
(159715, '1.20.930.20-FF-000022', NULL, 'Uncharacterized protein', 103, NULL, NULL, 159715),
(159716, '3.30.200.20-FF-000491', NULL, 'Lectin-domain containing receptor kinase VI.3', 92, NULL, NULL, 159716),
(159717, '2.20.70.10-FF-000171', NULL, 'Uncharacterized protein', 44, NULL, NULL, 159717),
(159718, '2.30.30.100-FF-000025', NULL, 'U6 snRNA-associated Sm-like protein LSm7', 96, NULL, NULL, 159718),
(159719, '3.30.70.330-FF-001110', NULL, 'RNA-binding protein, putative', 122, NULL, NULL, 159719),
(159720, '1.25.40.10-FF-003679', NULL, 'Pentatricopeptide repeat-containing protein At5g39680', 185, NULL, NULL, 159720),
(159721, '3.30.160.60-FF-004388', NULL, NULL, 32, NULL, NULL, 159721),
(159722, '3.40.50.150-FF-001027', NULL, NULL, 179, NULL, NULL, 159722),
(159723, '3.40.630.30-FF-000130', NULL, 'Putative ribosomal-protein-serine acetyltransferase', 175, NULL, NULL, 159723),
(159724, '3.50.50.60-FF-000085', NULL, 'Amine oxidase', 235, NULL, NULL, 159724),
(159725, '2.30.30.40-FF-000289', NULL, 'Rho guanine nucleotide exchange factor (GEF) 4', 46, NULL, NULL, 159725),
(159726, '3.30.420.140-FF-000008', NULL, 'Putative pre-16S rRNA nuclease', 149, NULL, NULL, 159726),
(159727, '2.70.70.10-FF-000073', NULL, 'Predicted protein', 137, NULL, NULL, 159727),
(159728, '1.20.1310.10-FF-000196', NULL, NULL, 84, NULL, NULL, 159728),
(159729, '3.40.50.2300-FF-000053', NULL, 'glutamate receptor ionotropic, NMDA 1 isoform X2', 162, NULL, NULL, 159729),
(159730, '1.10.10.60-FF-000853', NULL, NULL, 58, NULL, NULL, 159730),
(159731, '3.80.10.10-FF-001578', NULL, 'Tubulin folding cofactor E', 169, NULL, NULL, 159731),
(159732, '3.30.160.60-FF-003106', NULL, 'Zinc finger protein 991', 41, NULL, NULL, 159732),
(159733, '1.20.5.190-FF-000157', NULL, NULL, 52, NULL, NULL, 159733),
(159734, '3.30.780.10-FF-000064', NULL, 'Eukaryotic translation initiation factor 1', 79, NULL, NULL, 159734),
(159735, '3.40.190.290-FF-000071', NULL, 'LysR family transcriptional regulator', 206, NULL, NULL, 159735),
(159736, '3.30.160.60-FF-002589', NULL, 'J protein JJJ1', 58, NULL, NULL, 159736),
(159737, '6.20.10.30-FF-000012', NULL, 'DNA ligase', 38, NULL, NULL, 159737),
(159738, '3.80.10.10-FF-002051', NULL, 'Os02g0553000 protein', 77, NULL, NULL, 159738),
(159739, '3.30.50.10-FF-000150', NULL, 'GATAa protein', 46, NULL, NULL, 159739),
(159740, '2.60.490.10-FF-000022', NULL, 'p2X purinoceptor,putative', 67, NULL, NULL, 159740),
(159741, '2.60.40.60-FF-000777', NULL, 'Novel protein similar to vertebrate cadherin family protein', 104, NULL, NULL, 159741),
(159742, '1.25.40.10-FF-002577', NULL, 'Pentatricopeptide repeat-containing protein isoform A', 193, NULL, NULL, 159742),
(159743, '2.60.40.150-FF-000693', NULL, 'Uncharacterized protein', 159, NULL, NULL, 159743),
(159744, '3.40.50.720-FF-001895', NULL, 'Pyrroline-5-carboxylate reductase, flame shift', 45, NULL, NULL, 159744),
(159745, '3.20.20.70-FF-000857', NULL, NULL, 52, NULL, NULL, 159745),
(159746, '2.30.29.30-FF-000541', NULL, 'CRE-MIG-10 protein', 171, NULL, NULL, 159746),
(159747, '3.30.710.10-FF-000127', NULL, 'Suppressor of kinetochore protein 1', 161, NULL, NULL, 159747),
(159748, '3.20.20.100-FF-000033', NULL, 'Aldo/keto reductase', 296, NULL, NULL, 159748),
(159749, '2.130.10.10-FF-004933', NULL, 'WD-repeat protein, putative', 104, NULL, NULL, 159749),
(159750, '2.60.40.2030-FF-000035', NULL, 'Fraser extracellular matrix complex subunit 1', 132, NULL, NULL, 159750),
(159751, '3.30.1560.10-FF-000002', NULL, 'Protein mago nashi homolog 2', 123, NULL, NULL, 159751),
(159752, '3.90.226.10-FF-000179', NULL, 'Enoyl-CoA hydratase', 212, NULL, NULL, 159752);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(159753, '3.90.550.50-FF-000214', NULL, 'Beta-1,3-galactosyltransferase pvg3', 148, NULL, NULL, 159753),
(159754, '3.40.190.10-FF-000573', NULL, 'ABC transporter substrate-binding protein', 180, NULL, NULL, 159754),
(159755, '2.60.40.10-FF-005102', NULL, NULL, 99, NULL, NULL, 159755),
(159756, '2.120.10.30-FF-000191', NULL, 'Uncharacterized protein', 80, NULL, NULL, 159756),
(159757, '3.55.50.30-FF-000021', NULL, 'Putative anti-sigma factor', 77, NULL, NULL, 159757),
(159758, '3.90.190.10-FF-000522', NULL, 'Uncharacterized protein', 115, NULL, NULL, 159758),
(159759, '3.40.50.1110-FF-000010', NULL, 'Putative rhamnogalacturonan acetylesterase', 234, NULL, NULL, 159759),
(159760, '3.30.230.70-FF-000092', NULL, 'Uncharacterized protein', 276, NULL, NULL, 159760),
(159761, '1.10.340.70-FF-000027', NULL, 'Uncharacterized protein', 84, NULL, NULL, 159761),
(159762, '3.40.190.10-FF-000247', NULL, 'Glutamate receptor', 29, NULL, NULL, 159762),
(159763, '3.40.50.1100-FF-000249', NULL, 'Uncharacterized protein', 20, NULL, NULL, 159763),
(159764, '3.40.50.10490-FF-000052', NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', 148, NULL, NULL, 159764),
(159765, '3.30.160.60-FF-002943', NULL, 'AT-rich binding protein isoform X1', 40, NULL, NULL, 159765),
(159766, '1.20.1250.20-FF-001879', NULL, 'Uncharacterized protein', 100, NULL, NULL, 159766),
(159767, '1.20.1250.20-FF-002161', NULL, 'Uncharacterized protein', 190, NULL, NULL, 159767),
(159768, '1.20.120.1750-FF-000058', NULL, 'RBR-type E3 ubiquitin transferase', 74, NULL, NULL, 159768),
(159769, '2.30.30.30-FF-000106', NULL, 'Ribosomal protein L14, putative', 85, NULL, NULL, 159769),
(159770, '2.60.40.420-FF-000032', NULL, 'Coagulation factor VIII (Predicted)', 159, NULL, NULL, 159770),
(159771, '3.40.50.720-FF-002412', NULL, 'Uncharacterized protein', 172, NULL, NULL, 159771),
(159772, '2.40.70.10-FF-000568', NULL, NULL, 74, NULL, NULL, 159772),
(159773, '3.60.20.10-FF-000051', NULL, 'Proteasome subunit beta', 206, NULL, NULL, 159773),
(159774, '3.80.10.10-FF-000151', NULL, 'Lumican', 67, NULL, NULL, 159774),
(159775, '2.90.10.30-FF-000001', NULL, 'Serine/threonine-protein kinase', 145, NULL, NULL, 159775),
(159776, '3.40.50.300-FF-006693', NULL, 'Uncharacterized protein', 80, NULL, NULL, 159776),
(159777, '2.60.40.10-FF-003174', NULL, NULL, 91, NULL, NULL, 159777),
(159778, '2.40.160.10-FF-000047', NULL, 'Translocase of outer mitochondrial membrane', 279, NULL, NULL, 159778),
(159779, '3.30.160.60-FF-004843', NULL, NULL, 58, NULL, NULL, 159779),
(159780, '1.10.10.10-FF-001260', NULL, 'RNI-like superfamily protein', 100, NULL, NULL, 159780),
(159781, '2.30.42.10-FF-000217', NULL, 'PDZ domain containing 2', 110, NULL, NULL, 159781),
(159782, '3.30.160.60-FF-000689', NULL, 'Spalt like transcription factor 1', 64, NULL, NULL, 159782),
(159783, '2.130.10.10-FF-001061', NULL, 'Type I inositol polyphosphate 5-phosphatase 13', 127, NULL, NULL, 159783),
(159784, '3.40.50.10090-FF-000022', NULL, 'Uroporphyrinogen-III synthase, chloroplastic', 91, NULL, NULL, 159784),
(159785, '3.30.300.130-FF-000007', NULL, 'Cytoplasmic protein required for cell viability', 101, NULL, NULL, 159785),
(159786, '2.60.40.10-FF-001050', NULL, 'MER proto-oncogene, tyrosine kinase', 101, NULL, NULL, 159786),
(159787, '2.130.10.10-FF-001370', NULL, 'Protein SOF1', 142, NULL, NULL, 159787),
(159788, '3.10.450.220-FF-000004', NULL, 'Uncharacterized protein', 48, NULL, NULL, 159788),
(159789, '1.10.630.10-FF-000060', NULL, 'Cytochrome P450 family 39 subfamily A member 1', 456, NULL, NULL, 159789),
(159790, '2.60.440.10-FF-000002', NULL, 'Cell division protein ZapD', 71, NULL, NULL, 159790),
(159791, '3.40.50.720-FF-000512', NULL, 'Acetyl coenzyme A synthetase (ADP forming), alpha domain-containing protein', 130, NULL, NULL, 159791),
(159792, '3.90.550.10-FF-000668', NULL, 'Glycosyltransferases', 110, NULL, NULL, 159792),
(159793, '4.10.860.10-FF-000026', NULL, NULL, 51, NULL, NULL, 159793),
(159794, '3.40.50.410-FF-000037', NULL, 'Collagen type VI alpha 3 chain', 200, NULL, NULL, 159794);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(159795, '1.10.287.520-FF-000004', NULL, 'Noggin', 58, NULL, NULL, 159795),
(159796, '3.40.50.670-FF-000019', NULL, 'Topoisomerase II large subunit', 151, NULL, NULL, 159796),
(159797, '1.10.510.10-FF-001405', NULL, 'Non-specific serine/threonine protein kinase', 340, NULL, NULL, 159797),
(159798, '3.90.550.10-FF-000753', NULL, 'Galactosylgalactosylxylosylprotein 3-beta-glucuronosyltransferase', 191, NULL, NULL, 159798),
(159799, '3.90.1150.10-FF-000154', NULL, 'Putative ornithine aminotransferase RocD1', 46, NULL, NULL, 159799),
(159800, '1.10.443.10-FF-000024', NULL, 'Uncharacterized protein', 161, NULL, NULL, 159800),
(159801, '1.10.10.750-FF-000033', NULL, 'TBC domain containing protein', 58, NULL, NULL, 159801),
(159802, '3.40.50.2000-FF-000732', NULL, 'Uncharacterized protein', 50, NULL, NULL, 159802),
(159803, '1.10.940.10-FF-000027', NULL, 'Transcription antitermination protein NusB', 147, NULL, NULL, 159803),
(159804, '3.30.1120.30-FF-000003', NULL, 'Serine/threonine-protein kinase PLK', 113, NULL, NULL, 159804),
(159805, '3.40.50.300-FF-006558', NULL, 'Uncharacterized protein', 104, NULL, NULL, 159805),
(159806, '3.30.559.10-FF-000112', NULL, 'Trichothecene 3-O-acetyltransferase', 223, NULL, NULL, 159806),
(159807, '1.10.287.510-FF-000001', NULL, 'RAD50 homolog, double strand break repair protein', 103, NULL, NULL, 159807),
(159808, '3.50.50.60-FF-000731', NULL, 'Oleate hydratase', 184, NULL, NULL, 159808),
(159809, '2.70.150.10-FF-000186', NULL, 'Calcium-transporting ATPase', 170, NULL, NULL, 159809),
(159810, '1.10.760.10-FF-000064', NULL, 'Probable cytochrome c', 122, NULL, NULL, 159810),
(159811, '3.30.70.120-FF-000030', NULL, NULL, 110, NULL, NULL, 159811),
(159812, '2.30.36.70-FF-000024', NULL, 'Predicted protein', 51, NULL, NULL, 159812),
(159813, '2.30.29.30-FF-000215', NULL, 'Oxysterol-binding protein-related protein 1C', 96, NULL, NULL, 159813),
(159814, '3.40.50.300-FF-007047', NULL, 'Signal recognition particle receptor subunit beta', 199, NULL, NULL, 159814),
(159815, '2.130.10.10-FF-000864', NULL, 'U4/U6 small nuclear ribonucleoprotein PRP4', 89, NULL, NULL, 159815),
(159816, '1.50.10.20-FF-000070', NULL, 'Mannan endo-1,6-alpha-mannosidase', 319, NULL, NULL, 159816),
(159817, '3.40.50.720-FF-001923', NULL, 'NAD(P)H-dependent anabolic L-arginine dehydrogenase DauB', 171, NULL, NULL, 159817),
(159818, '3.40.50.620-FF-000600', NULL, 'Tyrosine--tRNA ligase', 269, NULL, NULL, 159818),
(159819, '1.10.10.60-FF-001033', NULL, NULL, 61, NULL, NULL, 159819),
(159820, '3.90.1310.10-FF-000026', NULL, 'Penicillin-binding protein', 220, NULL, NULL, 159820),
(159821, '3.30.1010.10-FF-000135', NULL, 'Uncharacterized protein', 158, NULL, NULL, 159821),
(159822, '3.30.160.60-FF-003432', NULL, 'Zinc finger protein 561', 24, NULL, NULL, 159822),
(159823, '2.130.10.110-FF-000023', NULL, 'Uncharacterized protein', 182, NULL, NULL, 159823),
(159824, '3.30.160.60-FF-002926', NULL, 'Uncharacterized protein', 47, NULL, NULL, 159824),
(159825, '1.20.58.60-FF-000333', NULL, 'SMAll', 105, NULL, NULL, 159825),
(159826, '3.30.70.270-FF-000260', NULL, NULL, 163, NULL, NULL, 159826),
(159827, '2.60.120.200-FF-000301', NULL, 'Protein EMP47', 222, NULL, NULL, 159827),
(159828, '3.90.550.50-FF-000169', NULL, 'Hexosyltransferase', 158, NULL, NULL, 159828),
(159829, '1.20.120.1750-FF-000075', NULL, 'Uncharacterized protein', 63, NULL, NULL, 159829),
(159830, '3.30.750.24-FF-000008', NULL, 'Sulfate transporter YchM', 123, NULL, NULL, 159830),
(159831, '3.40.50.300-FF-001533', NULL, 'ABC transporter G family member 11', 287, NULL, NULL, 159831),
(159832, '1.20.900.10-FF-000062', NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', 212, NULL, NULL, 159832),
(159833, '3.90.190.10-FF-000213', NULL, 'Receptor tyrosine phosphatase type r2b, putative', 242, NULL, NULL, 159833),
(159834, '3.40.50.720-FF-000158', NULL, 'Zinc-binding alcohol dehydrogenase', 158, NULL, NULL, 159834),
(159835, '3.90.320.10-FF-000022', NULL, 'Mitochondrial genome maintenance exonuclease 1', 191, NULL, NULL, 159835);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(159836, '3.40.1260.10-FF-000005', NULL, 'Sulfur relay protein DsrH', 97, NULL, NULL, 159836),
(159837, '3.90.226.10-FF-000281', NULL, 'Enoyl-CoA hydratase, probable', 219, NULL, NULL, 159837),
(159838, '3.40.640.10-FF-000237', NULL, 'Methionine S-methyltransferase', 207, NULL, NULL, 159838),
(159839, '1.10.3720.10-FF-000196', NULL, 'ABC-type transport system, permease protein, involved in antimicrobial peptide resistance', 205, NULL, NULL, 159839),
(159840, '1.10.10.350-FF-000020', NULL, 'Glutamate--tRNA ligase 1', 98, NULL, NULL, 159840),
(159841, '2.40.10.10-FF-000694', NULL, NULL, 201, NULL, NULL, 159841),
(159842, '1.10.490.10-FF-000054', NULL, 'Uncharacterized protein', 60, NULL, NULL, 159842),
(159843, '2.60.120.200-FF-000610', NULL, 'Uncharacterized protein', 152, NULL, NULL, 159843),
(159844, '1.20.210.10-FF-000009', NULL, 'Cytochrome c oxidase subunit 1', 169, NULL, NULL, 159844),
(159845, '3.60.10.10-FF-000123', NULL, 'RNA exonuclease NGL2', 359, NULL, NULL, 159845),
(159846, '3.40.50.300-FF-001224', NULL, 'Sulfotransferase', 206, NULL, NULL, 159846),
(159847, '2.130.10.10-FF-001353', NULL, 'WGS project CABT00000000 data, contig 2.19', 128, NULL, NULL, 159847),
(159848, '3.10.20.320-FF-000005', NULL, 'LPXTG cell wall anchor domain-containing protein', 73, NULL, NULL, 159848),
(159849, '2.130.10.10-FF-000555', NULL, 'Dmx like 2', 128, NULL, NULL, 159849),
(159850, '2.60.40.150-FF-000384', NULL, 'Uncharacterized protein', 138, NULL, NULL, 159850),
(159851, '3.30.200.20-FF-002289', NULL, 'CDPK-related kinase 3', 49, NULL, NULL, 159851),
(159852, '1.20.120.1760-FF-000078', NULL, NULL, 221, NULL, NULL, 159852),
(159853, '1.10.730.10-FF-000236', NULL, 'Uncharacterized protein', 146, NULL, NULL, 159853),
(159854, '2.40.50.90-FF-000102', NULL, 'Nuclease', 125, NULL, NULL, 159854),
(159855, '1.10.630.10-FF-000352', NULL, 'Uncharacterized protein', 475, NULL, NULL, 159855),
(159856, '1.10.10.60-FF-000544', NULL, 'Cell division control protein, putative', 54, NULL, NULL, 159856),
(159857, '2.40.50.140-FF-000308', NULL, 'Possible replication factor-a protein', 144, NULL, NULL, 159857),
(159858, '2.120.10.80-FF-000256', NULL, 'Kelch domain-containing protein', 185, NULL, NULL, 159858),
(159859, '2.30.30.1150-FF-000008', NULL, 'PHD finger protein, putative', 82, NULL, NULL, 159859),
(159860, '2.30.42.10-FF-000190', NULL, 'Uncharacterized protein, isoform K', 102, NULL, NULL, 159860),
(159861, '2.60.40.1660-FF-000025', NULL, 'Uncharacterized protein', 292, NULL, NULL, 159861),
(159862, '2.30.42.10-FF-000526', NULL, NULL, 58, NULL, NULL, 159862),
(159863, '3.40.190.10-FF-000882', NULL, 'AGAP008759-PA', 91, NULL, NULL, 159863),
(159864, '1.10.10.820-FF-000015', NULL, 'Myosin IG', 62, NULL, NULL, 159864),
(159865, '2.40.390.10-FF-000002', NULL, 'ACR027Cp', 130, NULL, NULL, 159865),
(159866, '2.70.150.10-FF-000169', NULL, 'Cu(2+)-transporting P-type ATPase', 144, NULL, NULL, 159866),
(159867, '3.90.1150.210-FF-000016', NULL, 'F-actin-capping protein subunit beta', 178, NULL, NULL, 159867),
(159868, '3.30.160.60-FF-000791', NULL, 'B-cell CLL/lymphoma 6, member B', 27, NULL, NULL, 159868),
(159869, '3.40.50.300-FF-005147', NULL, 'Atlastin-2', 320, NULL, NULL, 159869),
(159870, '3.40.140.10-FF-000199', NULL, 'Cytidine deaminase', 146, NULL, NULL, 159870),
(159871, '1.20.5.170-FF-000016', NULL, 'MAF bZIP transcription factor', 103, NULL, NULL, 159871),
(159872, '1.10.1650.10-FF-000004', NULL, '50S ribosomal protein L19e', 51, NULL, NULL, 159872),
(159873, '3.40.50.150-FF-000847', NULL, NULL, 151, NULL, NULL, 159873),
(159874, '3.40.1130.10-FF-000001', NULL, 'Glycerol-3-phosphate dehydrogenase (NAD(P)(+))', 161, NULL, NULL, 159874),
(159875, '1.10.238.10-FF-001126', NULL, 'Uncharacterized protein', 170, NULL, NULL, 159875),
(159876, '2.130.10.10-FF-005405', NULL, 'Uncharacterized protein', 183, NULL, NULL, 159876),
(159877, '3.40.1360.10-FF-000069', NULL, 'Spo11/DNA topoisomerase VI, subunit A protein', 123, NULL, NULL, 159877),
(159878, '1.20.1070.10-FF-001587', NULL, 'Uncharacterized protein', 156, NULL, NULL, 159878);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(159879, '3.30.70.141-FF-000003', NULL, 'Nucleoside diphosphate kinase', 142, NULL, NULL, 159879),
(159880, '1.20.58.70-FF-000027', NULL, 'Putative syntaxin-3', 126, NULL, NULL, 159880),
(159881, '1.10.287.70-FF-000240', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 126, NULL, NULL, 159881),
(159882, '1.20.1420.30-FF-000081', NULL, 'Uncharacterized protein', 148, NULL, NULL, 159882),
(159883, '3.10.25.10-FF-000019', NULL, 'Methionyl-tRNA formyltransferase', 106, NULL, NULL, 159883),
(159884, '3.20.180.20-FF-000029', NULL, 'Flagellar outer dynein arm heavy chain alpha', 90, NULL, NULL, 159884),
(159885, '3.40.50.1820-FF-000009', NULL, 'NDRG family member 4', 280, NULL, NULL, 159885),
(159886, '3.30.160.60-FF-004517', NULL, NULL, 16, NULL, NULL, 159886),
(159887, '2.130.10.10-FF-004607', NULL, 'Uncharacterized protein', 202, NULL, NULL, 159887),
(159888, '2.170.8.10-FF-000008', NULL, 'Phosphoenolpyruvate carboxykinase (ATP), glycosomal', 85, NULL, NULL, 159888),
(159889, '3.40.50.720-FF-001569', NULL, 'Short chain dehydrogenase/reductase, putative (AFU_orthologue AFUA_7G00840)', 243, NULL, NULL, 159889),
(159890, '2.10.25.10-FF-001578', NULL, 'Uncharacterized protein', 39, NULL, NULL, 159890),
(159891, '2.60.40.10-FF-000695', NULL, 'Plexin A2', 94, NULL, NULL, 159891),
(159892, '1.20.1740.10-FF-000014', NULL, 'Putrescine transporter PotE', 434, NULL, NULL, 159892),
(159893, '1.20.970.10-FF-000010', NULL, 'Anthranilate phosphoribosyltransferase', 67, NULL, NULL, 159893),
(159894, '3.90.1150.10-FF-000480', NULL, 'Uncharacterized protein', 88, NULL, NULL, 159894),
(159895, '2.60.120.650-FF-000161', NULL, 'Uncharacterized protein', 250, NULL, NULL, 159895),
(159896, '2.130.10.10-FF-004916', NULL, 'Uncharacterized protein', 109, NULL, NULL, 159896),
(159897, '3.40.50.1820-FF-000318', NULL, 'Probable lysophospholipase BODYGUARD 1', 301, NULL, NULL, 159897),
(159898, '3.30.1330.10-FF-000047', NULL, 'Uncharacterized protein', 86, NULL, NULL, 159898),
(159899, '1.20.910.10-FF-000017', NULL, 'Heme oxygenase', 223, NULL, NULL, 159899),
(159900, '2.40.10.340-FF-000012', NULL, 'Cell shape-determining protein MreC', 76, NULL, NULL, 159900),
(159901, '1.10.10.10-FF-000669', NULL, 'RNA polymerase sigma factor', 84, NULL, NULL, 159901),
(159902, '2.40.50.140-FF-000179', NULL, 'rRNA biogenesis protein RRP5', 86, NULL, NULL, 159902),
(159903, '3.90.360.10-FF-000013', NULL, 'Uncharacterized protein', 118, NULL, NULL, 159903),
(159904, '2.40.10.350-FF-000015', NULL, 'Cell shape-determining protein MreC', 76, NULL, NULL, 159904),
(159905, '3.30.200.20-FF-000389', NULL, 'Receptor-like cytosolic serine/threonine-protein kinase RBK1', 101, NULL, NULL, 159905),
(159906, '3.40.50.300-FF-007401', NULL, 'Uncharacterized protein', 57, NULL, NULL, 159906),
(159907, '2.130.10.10-FF-002455', NULL, 'Uncharacterized protein', 132, NULL, NULL, 159907),
(159908, '1.20.58.60-FF-000024', NULL, 'Kalirin RhoGEF kinase a', 144, NULL, NULL, 159908),
(159909, '3.50.4.10-FF-000049', NULL, NULL, 75, NULL, NULL, 159909),
(159910, '3.40.190.10-FF-000556', NULL, 'LysR family transcriptional regulator', 90, NULL, NULL, 159910),
(159911, '2.60.120.200-FF-000155', NULL, 'Galectin', 132, NULL, NULL, 159911),
(159912, '1.25.40.20-FF-000574', NULL, 'I Kappa B homolog', 230, NULL, NULL, 159912),
(159913, '1.20.5.470-FF-000016', NULL, 'Uncharacterized protein', 34, NULL, NULL, 159913),
(159914, '3.50.50.60-FF-000613', NULL, 'Salicylate hydroxylase', 378, NULL, NULL, 159914),
(159915, '3.90.180.10-FF-000033', NULL, 'Quinone oxidoreductase PIG3', 173, NULL, NULL, 159915),
(159916, '3.40.50.11660-FF-000015', NULL, 'Predicted protein', 206, NULL, NULL, 159916),
(159917, '1.20.1080.10-FF-000087', NULL, 'MIP aquaporin (Eurofung)', 263, NULL, NULL, 159917),
(159918, '3.80.10.10-FF-001887', NULL, 'Si:ch211-156p11.1', 211, NULL, NULL, 159918),
(159919, '3.20.20.140-FF-000112', NULL, 'Amidohydrolase', 300, NULL, NULL, 159919),
(159920, '3.20.20.190-FF-000020', NULL, 'Phosphoinositide phospholipase C', 309, NULL, NULL, 159920);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(159921, '3.80.10.10-FF-003495', NULL, 'Predicted protein', 195, NULL, NULL, 159921),
(159922, '3.30.450.40-FF-000088', NULL, 'Heat-inducible transcription repressor HrcA', 133, NULL, NULL, 159922),
(159923, '1.25.40.10-FF-004359', NULL, 'Uncharacterized protein', 155, NULL, NULL, 159923),
(159924, '1.20.1530.20-FF-000097', NULL, 'Uncharacterized protein', 211, NULL, NULL, 159924),
(159925, '3.60.10.10-FF-000331', NULL, 'Uncharacterized protein', 237, NULL, NULL, 159925),
(159926, '3.40.50.300-FF-004967', NULL, 'Uncharacterized protein', 228, NULL, NULL, 159926),
(159927, '1.25.10.10-FF-002766', NULL, 'Uncharacterized protein', 597, NULL, NULL, 159927),
(159928, '3.30.70.330-FF-000076', NULL, 'Synaptojanin-1 isoform 1', 86, NULL, NULL, 159928),
(159929, '3.30.470.30-FF-000086', NULL, 'Uncharacterized protein', 15, NULL, NULL, 159929),
(159930, '1.25.40.120-FF-000003', NULL, 'Protein prenyltransferase alpha subunit repeat containing 1', 272, NULL, NULL, 159930),
(159931, '1.20.1270.60-FF-000240', NULL, 'rho GTPase-activating protein 17 isoform X1', 251, NULL, NULL, 159931),
(159932, '2.30.29.170-FF-000004', NULL, 'EF-hand domain containing 2', 127, NULL, NULL, 159932),
(159933, '3.30.390.80-FF-000004', NULL, 'Uncharacterized protein', 127, NULL, NULL, 159933),
(159934, '3.40.50.720-FF-001777', NULL, '2-dehydropantoate 2-reductase', 182, NULL, NULL, 159934),
(159935, '1.10.287.1770-FF-000009', NULL, 'Ferrous iron transport protein B', 96, NULL, NULL, 159935),
(159936, '3.30.200.20-FF-000417', NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 64', 104, NULL, NULL, 159936),
(159937, '3.90.1150.10-FF-000272', NULL, 'Uncharacterized HTH-type transcriptional regulator YdfD', 137, NULL, NULL, 159937),
(159938, '1.10.1040.10-FF-000036', NULL, '2-dehydropantoate 2-reductase', 128, NULL, NULL, 159938),
(159939, '3.40.50.300-FF-000589', NULL, 'ABC transporter, ATP-binding subunit', 234, NULL, NULL, 159939),
(159940, '3.90.930.12-FF-000037', NULL, NULL, 77, NULL, NULL, 159940),
(159941, '1.25.10.10-FF-003340', NULL, 'Condensin-2 complex subunit D3', 234, NULL, NULL, 159941),
(159942, '1.20.58.60-FF-000541', NULL, 'Nesprin-1', 135, NULL, NULL, 159942),
(159943, '3.90.190.10-FF-000005', NULL, 'receptor-type tyrosine-protein phosphatase kappa isoform X1', 287, NULL, NULL, 159943),
(159944, '3.40.50.1000-FF-000399', NULL, 'GD13364', 132, NULL, NULL, 159944),
(159945, '3.30.70.2460-FF-000002', NULL, 'DNA repair protein RAD34', 86, NULL, NULL, 159945),
(159946, '3.30.40.10-FF-000104', NULL, 'Ankyrin repeat and FYVE domain-containing 1', 66, NULL, NULL, 159946),
(159947, '2.60.120.10-FF-000658', NULL, 'Uncharacterized protein', 130, NULL, NULL, 159947),
(159948, '3.40.390.10-FF-000228', NULL, NULL, 112, NULL, NULL, 159948),
(159949, '3.30.40.10-FF-000205', NULL, 'Histone-lysine N-methyltransferase', 65, NULL, NULL, 159949),
(159950, '4.10.860.10-FF-000009', NULL, 'UvrABC system protein B', 53, NULL, NULL, 159950),
(159951, '3.40.50.300-FF-002197', NULL, 'ATP-dependent DNA helicase UvrD', 61, NULL, NULL, 159951),
(159952, '3.40.50.300-FF-002298', NULL, 'Type IV secretion system protein VirB11', 218, NULL, NULL, 159952),
(159953, '3.30.60.20-FF-000108', NULL, 'Protein kinase C', 70, NULL, NULL, 159953),
(159954, '3.30.40.10-FF-000093', NULL, 'Histone-lysine N-methyltransferase', 60, NULL, NULL, 159954),
(159955, '2.60.40.10-FF-000914', NULL, 'E3 ubiquitin-protein ligase Trim36', 90, NULL, NULL, 159955),
(159956, '2.30.30.100-FF-000143', NULL, 'Ssm4 protein, putative', 82, NULL, NULL, 159956),
(159957, '3.30.450.20-FF-000082', NULL, 'sigma-54-dependent Fis family transcriptional regulator', 114, NULL, NULL, 159957),
(159958, '3.40.5.10-FF-000012', NULL, 'Mitochondrial ribosomal protein', 64, NULL, NULL, 159958),
(159959, '1.10.472.10-FF-000670', NULL, 'Uncharacterized protein', 69, NULL, NULL, 159959),
(159960, '1.25.40.10-FF-000571', NULL, 'Aspartyl beta-hydroxylase, isoform L', 147, NULL, NULL, 159960),
(159961, '3.40.190.170-FF-000017', NULL, 'TRAP-type C4-dicarboxylate transport system, substrate-binding protein', 312, NULL, NULL, 159961); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(159962, '1.10.150.20-FF-000245', NULL, 'DNA topoisomerase I', 55, NULL, NULL, 159962),
(159963, '3.55.50.20-FF-000001', NULL, 'Phage baseplate hub subunit', 88, NULL, NULL, 159963),
(159964, '3.30.160.60-FF-001280', NULL, 'Zinc finger protein 771', 27, NULL, NULL, 159964),
(159965, '3.10.310.10-FF-000051', NULL, 'Predicted protein', 162, NULL, NULL, 159965),
(159966, '1.10.150.120-FF-000014', NULL, 'Xanthine DeHydrogenase homolog', 139, NULL, NULL, 159966),
(159967, '3.30.450.30-FF-000085', NULL, 'Uncharacterized protein', 78, NULL, NULL, 159967),
(159968, '3.30.230.10-FF-000017', NULL, 'Galactokinase', 204, NULL, NULL, 159968),
(159969, '1.10.238.10-FF-000738', NULL, 'Glycerol-3-phosphate dehydrogenase', 109, NULL, NULL, 159969),
(159970, '3.80.10.10-FF-002612', NULL, 'Dynein regulatory complex subunit 7', 236, NULL, NULL, 159970),
(159971, '1.25.40.10-FF-002706', NULL, 'rRNA processing protein Utp6, putative', 109, NULL, NULL, 159971),
(159972, '2.60.40.2030-FF-000018', NULL, 'Fras1-related extracellular matrix protein 2', 137, NULL, NULL, 159972),
(159973, '3.50.50.60-FF-001220', NULL, 'Uncharacterized protein', 260, NULL, NULL, 159973),
(159974, '3.30.450.40-FF-000189', NULL, 'ATP-binding region ATPase domain protein', 189, NULL, NULL, 159974),
(159975, '3.30.160.60-FF-002797', NULL, 'Zinc finger protein 613', 29, NULL, NULL, 159975),
(159976, '1.10.1670.10-FF-000067', NULL, NULL, 82, NULL, NULL, 159976),
(159977, '3.30.160.60-FF-003415', NULL, 'GD16884', 23, NULL, NULL, 159977),
(159978, '3.30.2010.10-FF-000017', NULL, 'CAAX prenyl protease', 82, NULL, NULL, 159978),
(159979, '1.20.990.10-FF-000011', NULL, 'Bifunctional cytochrome P450/NADPH--P450 reductase', 122, NULL, NULL, 159979),
(159980, '2.60.120.260-FF-000167', NULL, 'Transient receptor potential cation channel subfamily C member 2 (pseudogene)', 61, NULL, NULL, 159980),
(159981, '3.30.420.10-FF-000251', NULL, 'Transposon Ty4-P Gag-Pol polyprotein', 182, NULL, NULL, 159981),
(159982, '2.40.50.90-FF-000074', NULL, 'Tudor domain containing 6', 47, NULL, NULL, 159982),
(159983, '3.40.50.150-FF-000881', NULL, NULL, 31, NULL, NULL, 159983),
(159984, '1.20.58.1480-FF-000031', NULL, 'Lon protease homolog 2 peroxisomal', 86, NULL, NULL, 159984),
(159985, '2.130.10.10-FF-000881', NULL, 'Mitochondrial division protein 1', 111, NULL, NULL, 159985),
(159986, '1.25.10.10-FF-000479', NULL, 'Transportin', 214, NULL, NULL, 159986),
(159987, '3.30.450.20-FF-000183', NULL, 'Methyl-accepting chemotaxis protein', 158, NULL, NULL, 159987),
(159988, '3.30.870.10-FF-000184', NULL, 'Uncharacterized protein', 135, NULL, NULL, 159988),
(159989, '2.160.10.10-FF-000076', NULL, 'Serine acetyltransferase 3, mitochondrial', 111, NULL, NULL, 159989),
(159990, '3.10.100.10-FF-000350', NULL, NULL, 121, NULL, NULL, 159990),
(159991, '1.20.1560.10-FF-000034', NULL, 'Putative ABC transporter', 313, NULL, NULL, 159991),
(159992, '1.10.8.10-FF-000320', NULL, 'Ubiquitin family protein', 55, NULL, NULL, 159992),
(159993, '1.10.150.130-FF-000017', NULL, 'Prophage lambda integrase', 109, NULL, NULL, 159993),
(159994, '1.20.1050.10-FF-000158', NULL, 'Hematopoietic prostaglandin D synthase', 111, NULL, NULL, 159994),
(159995, '2.30.29.30-FF-000232', NULL, 'Bardet-Biedl syndrome 5 isoform 1', 97, NULL, NULL, 159995),
(159996, '3.40.50.720-FF-002283', NULL, 'Predicted protein', 221, NULL, NULL, 159996),
(159997, '3.40.50.150-FF-001235', NULL, NULL, 159, NULL, NULL, 159997),
(159998, '3.30.465.10-FF-000040', NULL, 'Putative HlyC/CorC family of transporters with 2 CBS domains', 78, NULL, NULL, 159998),
(159999, '2.10.110.10-FF-000258', NULL, 'Uncharacterized protein', 68, NULL, NULL, 159999),
(160000, '2.60.40.10-FF-001420', NULL, 'Exo-1,4-beta-xylosidase xlnD', 121, NULL, NULL, 160000),
(160001, '3.40.47.10-FF-000248', NULL, 'Uncharacterized protein', 429, NULL, NULL, 160001),
(160002, '2.60.120.650-FF-000060', NULL, 'Histone demethylase JHD2', 153, NULL, NULL, 160002),
(160003, '1.20.1250.20-FF-001907', NULL, 'Uncharacterized protein', 237, NULL, NULL, 160003),
(160004, '1.25.40.10-FF-000245', NULL, 'Tetratricopeptide repeat domain 21B', 439, NULL, NULL, 160004);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(160005, '1.20.1070.10-FF-000058', NULL, 'Adhesion G protein-coupled receptor F5', 283, NULL, NULL, 160005),
(160006, '3.40.630.30-FF-000012', NULL, 'GNAT family acetyltransferase', 147, NULL, NULL, 160006),
(160007, '3.40.50.300-FF-001207', NULL, 'Fanconi anemia group J protein-like isoform E', 250, NULL, NULL, 160007),
(160008, '3.30.70.330-FF-002330', NULL, NULL, 112, NULL, NULL, 160008),
(160009, '3.40.630.40-FF-000015', NULL, 'Putative N-acetylmuramoyl-L-alanine amidase', 181, NULL, NULL, 160009),
(160010, '1.20.1070.10-FF-001795', NULL, 'Uncharacterized protein', 360, NULL, NULL, 160010),
(160011, '1.20.140.80-FF-000013', NULL, 'Uncharacterized protein', 67, NULL, NULL, 160011),
(160012, '3.90.190.20-FF-000008', NULL, 'UDP-N-acetylmuramoyl-tripeptide--D-alanyl-D-alanine ligase', 141, NULL, NULL, 160012),
(160013, '2.10.90.10-FF-000110', NULL, 'Unc-129 protein', 111, NULL, NULL, 160013),
(160014, '3.30.70.20-FF-000036', NULL, '4Fe-4S dicluster domain-containing protein', 73, NULL, NULL, 160014),
(160015, '3.30.200.20-FF-000373', NULL, 'Mitogen-activated protein kinase 1', 127, NULL, NULL, 160015),
(160016, '1.10.357.10-FF-000048', NULL, 'TetR family transcriptional regulator', 189, NULL, NULL, 160016),
(160017, '3.40.50.12780-FF-000014', NULL, 'Nonribosomal peptide synthetase 1', 400, NULL, NULL, 160017),
(160018, '3.30.50.10-FF-000133', NULL, 'Uncharacterized protein', 62, NULL, NULL, 160018),
(160019, '3.30.470.20-FF-000083', NULL, 'Biotin carboxylase subunit of acetyl CoA carboxylase', 176, NULL, NULL, 160019),
(160020, '1.10.10.60-FF-000870', NULL, NULL, 104, NULL, NULL, 160020),
(160021, '3.40.1690.20-FF-000006', NULL, 'ATP-dependent zinc metalloprotease FTSH', 96, NULL, NULL, 160021),
(160022, '3.30.70.360-FF-000034', NULL, 'Allantoate amidohydrolase', 115, NULL, NULL, 160022),
(160023, '1.20.1070.10-FF-001486', NULL, 'Uncharacterized protein', 204, NULL, NULL, 160023),
(160024, '2.40.50.770-FF-000014', NULL, 'Tudor domain protein (DUF1767)', 130, NULL, NULL, 160024),
(160025, '3.30.70.370-FF-000037', NULL, NULL, 81, NULL, NULL, 160025),
(160026, '2.30.40.10-FF-000011', NULL, 'Probable imidazolonepropionase', 79, NULL, NULL, 160026),
(160027, '1.10.10.650-FF-000020', NULL, 'SH2 domain containing protein', 140, NULL, NULL, 160027),
(160028, '1.10.510.10-FF-003305', NULL, NULL, 79, NULL, NULL, 160028),
(160029, '2.10.25.10-FF-000151', NULL, 'FAT atypical cadherin 4', 39, NULL, NULL, 160029),
(160030, '1.20.1200.10-FF-000013', NULL, 'Uncharacterized protein', 50, NULL, NULL, 160030),
(160031, '3.40.50.150-FF-000982', NULL, NULL, 218, NULL, NULL, 160031),
(160032, '3.30.70.3490-FF-000007', NULL, 'Oxysterol-binding protein-related protein 4B', 72, NULL, NULL, 160032),
(160033, '3.50.50.60-FF-000405', NULL, 'Succinate dehydrogenase [ubiquinone] flavoprotein subunit, mitochondrial', 66, NULL, NULL, 160033),
(160034, '1.20.1070.10-FF-002104', NULL, 'Uncharacterized protein', 331, NULL, NULL, 160034),
(160035, '3.40.190.10-FF-000808', NULL, 'Uncharacterized protein', 48, NULL, NULL, 160035),
(160036, '1.10.110.10-FF-000015', NULL, 'Predicted protein', 74, NULL, NULL, 160036),
(160037, '2.40.50.140-FF-000842', NULL, NULL, 67, NULL, NULL, 160037),
(160038, '3.20.20.30-FF-000031', NULL, 'Putative FMN-dependent luciferase-like monooxygenase', 336, NULL, NULL, 160038),
(160039, '3.80.10.10-FF-002303', NULL, 'Fgr38p', 199, NULL, NULL, 160039),
(160040, '3.40.50.1220-FF-000026', NULL, 'NAD-dependent protein deacetylase sirtuin-2', 90, NULL, NULL, 160040),
(160041, '3.50.50.60-FF-000293', NULL, 'FAD-dependent oxidoreductase', 206, NULL, NULL, 160041),
(160042, '3.30.9.80-FF-000002', NULL, NULL, 138, NULL, NULL, 160042),
(160043, '1.20.1070.10-FF-002060', NULL, 'Uncharacterized protein', 88, NULL, NULL, 160043),
(160044, '1.10.10.10-FF-000754', NULL, 'Z-DNA binding protein kinase', 70, NULL, NULL, 160044),
(160045, '3.40.50.300-FF-006249', NULL, 'SNF2 DNA repair protein, putative', 198, NULL, NULL, 160045),
(160046, '3.30.70.330-FF-000284', NULL, '39S ribosomal protein L23, mitochondrial', 151, NULL, NULL, 160046);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(160047, '1.10.238.10-FF-001143', NULL, 'WD repeat-containing protein 66-like Protein', 143, NULL, NULL, 160047),
(160048, '3.40.50.880-FF-000049', NULL, 'Catalase HPII', 154, NULL, NULL, 160048),
(160049, '3.30.160.60-FF-002808', NULL, 'Zinc finger protein 311', 26, NULL, NULL, 160049),
(160050, '3.40.630.30-FF-000698', NULL, 'RNA cytidine acetyltransferase', 116, NULL, NULL, 160050),
(160051, '3.10.390.10-FF-000016', NULL, 'Sp140 nuclear body protein', 65, NULL, NULL, 160051),
(160052, '3.40.630.10-FF-000383', NULL, 'Uncharacterized protein', 75, NULL, NULL, 160052),
(160053, '1.25.40.10-FF-002369', NULL, 'Pentatricopeptide repeat-containing protein isoform A', 103, NULL, NULL, 160053),
(160054, '3.40.50.2000-FF-000036', NULL, 'Alpha,alpha-trehalose-phosphate synthase subunit Tps2', 195, NULL, NULL, 160054),
(160055, '1.10.490.10-FF-000037', NULL, 'GH09296p', 60, NULL, NULL, 160055),
(160056, '3.10.20.90-FF-000667', NULL, 'Ubiquitin-like protein ATG12', 79, NULL, NULL, 160056),
(160057, '2.60.40.10-FF-001521', NULL, 'Interleukin 27 receptor subunit alpha', 102, NULL, NULL, 160057),
(160058, '3.40.50.300-FF-008458', NULL, 'Uncharacterized protein', 250, NULL, NULL, 160058),
(160059, '1.20.1720.10-FF-000114', NULL, NULL, 223, NULL, NULL, 160059),
(160060, '2.40.50.40-FF-000003', NULL, 'chromodomain-helicase-DNA-binding protein 3 isoform X1', 60, NULL, NULL, 160060),
(160061, '1.10.510.10-FF-000990', NULL, 'Guanylate cyclase', 248, NULL, NULL, 160061),
(160062, '3.40.630.10-FF-000265', NULL, 'Peptidase M14, carboxypeptidase A', 298, NULL, NULL, 160062),
(160063, '3.40.50.10190-FF-000052', NULL, 'Transcription coactivator', 111, NULL, NULL, 160063),
(160064, '1.10.10.2590-FF-000006', NULL, 'uncharacterized protein LOC108744368 isoform X1', 114, NULL, NULL, 160064),
(160065, '3.40.50.300-FF-000959', NULL, 'structural maintenance of chromosomes protein 6', 202, NULL, NULL, 160065),
(160066, '1.10.472.10-FF-000462', NULL, 'Predicted protein', 97, NULL, NULL, 160066),
(160067, '3.90.190.10-FF-000314', NULL, 'Uncharacterized protein', 281, NULL, NULL, 160067),
(160068, '3.20.20.80-FF-000040', NULL, 'Beta-galactosidase A', 357, NULL, NULL, 160068),
(160069, '3.30.565.10-FF-000525', NULL, 'Putative methanol utilization control sensor protein moxY', 134, NULL, NULL, 160069),
(160070, '3.30.200.20-FF-000726', NULL, 'Uncharacterized protein, isoform A', 125, NULL, NULL, 160070),
(160071, '1.10.8.270-FF-000189', NULL, 'Uncharacterized protein', 100, NULL, NULL, 160071),
(160072, '3.80.10.10-FF-000049', NULL, 'Dynein light chain 1', 190, NULL, NULL, 160072),
(160073, '3.40.1190.20-FF-000013', NULL, 'ATP-dependent (S)-NAD(P)H-hydrate dehydratase', 294, NULL, NULL, 160073),
(160074, '1.25.10.10-FF-000417', NULL, 'Wings apart-like protein-like isoform A', 296, NULL, NULL, 160074),
(160075, '2.40.10.10-FF-000559', NULL, NULL, 72, NULL, NULL, 160075),
(160076, '3.50.50.60-FF-001496', NULL, 'Protoporphyrinogen oxidase', 38, NULL, NULL, 160076),
(160077, '1.10.30.10-FF-000199', NULL, 'Uncharacterized protein', 97, NULL, NULL, 160077),
(160078, '3.30.428.10-FF-000055', NULL, 'ADP-glucose phosphorylase', 133, NULL, NULL, 160078),
(160079, '3.40.1090.10-FF-000059', NULL, 'Intracelllar PhosphoLipase A family', 306, NULL, NULL, 160079),
(160080, '1.20.58.860-FF-000009', NULL, 'Ubiquitin carboxyl-terminal hydrolase isozyme L5', 77, NULL, NULL, 160080),
(160081, '3.30.200.20-FF-000844', NULL, 'NIMA related kinase 2', 86, NULL, NULL, 160081),
(160082, '3.30.40.10-FF-000413', NULL, 'PHD zinc finger protein', 61, NULL, NULL, 160082),
(160083, '3.40.50.1820-FF-001628', NULL, 'Carboxylic ester hydrolase', 470, NULL, NULL, 160083),
(160084, '3.30.160.60-FF-002909', NULL, 'Zinc finger protein 142', 91, NULL, NULL, 160084),
(160085, '2.40.320.10-FF-000037', NULL, 'Thiamine triphosphatase', 112, NULL, NULL, 160085),
(160086, '3.30.70.270-FF-000243', NULL, NULL, 140, NULL, NULL, 160086),
(160087, '1.10.510.10-FF-004278', NULL, NULL, 176, NULL, NULL, 160087),
(160088, '3.30.1050.10-FF-000020', NULL, 'AGAP003091-PA', 106, NULL, NULL, 160088);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(160089, '3.30.50.10-FF-000032', NULL, 'Transcription factor GATA-3', 64, NULL, NULL, 160089),
(160090, '1.10.150.50-FF-000203', NULL, 'Uncharacterized protein', 68, NULL, NULL, 160090),
(160091, '2.10.70.10-FF-000002', NULL, 'CUB and Sushi multiple domains 3', 65, NULL, NULL, 160091),
(160092, '3.30.70.330-FF-002745', NULL, NULL, 92, NULL, NULL, 160092),
(160093, '3.30.1370.120-FF-000011', NULL, 'Type II secretion system protein', 160, NULL, NULL, 160093),
(160094, '1.20.1270.10-FF-000023', NULL, 'Heat shock protein 70', 74, NULL, NULL, 160094),
(160095, '3.30.750.24-FF-000143', NULL, 'Glycosyl transferase, WecB/TagA/CpsF family', 103, NULL, NULL, 160095),
(160096, '2.60.40.10-FF-004394', NULL, NULL, 95, NULL, NULL, 160096),
(160097, '2.130.10.10-FF-004681', NULL, 'WD40 repeat-containing protein', 181, NULL, NULL, 160097),
(160098, '1.25.40.990-FF-000045', NULL, 'Uncharacterized protein', 246, NULL, NULL, 160098),
(160099, '3.30.70.3170-FF-000001', NULL, 'galactokinase isoform X1', 77, NULL, NULL, 160099),
(160100, '3.40.50.620-FF-000145', NULL, 'ATP-binding domain containing protein', 158, NULL, NULL, 160100),
(160101, '3.90.70.10-FF-000396', NULL, 'Ubiquitin specific peptidase 1', 277, NULL, NULL, 160101),
(160102, '3.40.50.10990-FF-000005', NULL, '3,4-dihydroxy-2-butanone 4-phosphate synthase', 160, NULL, NULL, 160102),
(160103, '2.40.30.40-FF-000002', NULL, 'Aminopeptidase YpdE', 84, NULL, NULL, 160103),
(160104, '2.60.130.10-FF-000001', NULL, 'Protocatechuate 3,4-dioxygenase alpha chain', 200, NULL, NULL, 160104),
(160105, '3.40.50.10980-FF-000002', NULL, 'DNA damage response protein RcaA', 130, NULL, NULL, 160105),
(160106, '3.80.10.10-FF-003832', NULL, 'Uncharacterized protein', 63, NULL, NULL, 160106),
(160107, '3.10.196.10-FF-000003', NULL, 'Methionine synthase', 234, NULL, NULL, 160107),
(160108, '3.30.519.10-FF-000036', NULL, NULL, 150, NULL, NULL, 160108),
(160109, '1.10.630.10-FF-000026', NULL, 'Cytochrome P450 82C4', 488, NULL, NULL, 160109),
(160110, '2.60.40.1660-FF-000008', NULL, 'Probable sodium/potassium-transporting ATPase subunit beta-3', 293, NULL, NULL, 160110),
(160111, '2.130.10.10-FF-004372', NULL, 'Flagellar associated protein', 83, NULL, NULL, 160111),
(160112, '3.40.640.10-FF-000193', NULL, 'DegT/DnrJ/EryC1/StrS aminotransferase family protein', 260, NULL, NULL, 160112),
(160113, '2.130.10.10-FF-002679', NULL, 'Uncharacterized protein', 308, NULL, NULL, 160113),
(160114, '3.30.200.20-FF-000165', NULL, 'Serine/threonine-protein kinase PDIK1L', 98, NULL, NULL, 160114),
(160115, '1.25.40.180-FF-000223', NULL, NULL, 126, NULL, NULL, 160115),
(160116, '2.60.120.200-FF-000273', NULL, 'Collagen type XIX alpha 1 chain', 207, NULL, NULL, 160116),
(160117, '3.30.1520.10-FF-000117', NULL, 'Uncharacterized protein', 132, NULL, NULL, 160117),
(160118, '2.130.10.10-FF-001027', NULL, 'WD repeat-containing protein 66, putative', 323, NULL, NULL, 160118),
(160119, '1.10.1320.10-FF-000002', NULL, 'DNA-directed RNA polymerase', 320, NULL, NULL, 160119),
(160120, '1.10.400.10-FF-000026', NULL, 'Guanine nucleotide binding protein (G protein), alpha, variant', 122, NULL, NULL, 160120),
(160121, '3.10.28.10-FF-000043', NULL, 'Probable intron-encoded endonuclease aI5', 132, NULL, NULL, 160121),
(160122, '1.10.287.3990-FF-000006', NULL, '26S proteasome component', 48, NULL, NULL, 160122),
(160123, '3.40.50.80-FF-000147', NULL, 'Ferric reductase-like transmembrane component', 110, NULL, NULL, 160123),
(160124, '1.10.472.10-FF-000361', NULL, 'Transcription factor IIB family protein', 104, NULL, NULL, 160124),
(160125, '3.30.342.10-FF-000024', NULL, 'DNA polymerase', 189, NULL, NULL, 160125),
(160126, '1.10.510.10-FF-004379', NULL, NULL, 97, NULL, NULL, 160126),
(160127, '3.30.40.10-FF-000514', NULL, 'FYVE and coiled-coil domain-containing protein, putative', 79, NULL, NULL, 160127),
(160128, '2.60.40.1170-FF-000075', NULL, NULL, 103, NULL, NULL, 160128),
(160129, '3.30.2070.10-FF-000009', NULL, 'Thiosulfate reductase', 63, NULL, NULL, 160129),
(160130, '3.40.50.720-FF-000142', NULL, 'probable UDP-arabinose 4-epimerase 2', 209, NULL, NULL, 160130);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(160131, '1.20.1070.10-FF-000822', NULL, 'Uncharacterized protein', 88, NULL, NULL, 160131),
(160132, '1.10.10.10-FF-000299', NULL, 'ANTAR domain-containing response regulator', 55, NULL, NULL, 160132),
(160133, '3.40.50.12380-FF-000001', NULL, 'Nitrogenase MoFe cofactor biosynthesis protein NifE', 273, NULL, NULL, 160133),
(160134, '3.40.50.300-FF-002961', NULL, 'DYNC2H1 protein', 77, NULL, NULL, 160134),
(160135, '3.30.1520.10-FF-000073', NULL, 'Vacuolar morphogenesis protein', 117, NULL, NULL, 160135),
(160136, '4.10.1240.10-FF-000089', NULL, 'Predicted protein', 54, NULL, NULL, 160136),
(160137, '3.80.10.10-FF-003377', NULL, 'Predicted protein', 106, NULL, NULL, 160137),
(160138, '2.60.40.10-FF-004955', NULL, NULL, 96, NULL, NULL, 160138),
(160139, '3.40.50.2300-FF-000244', NULL, 'Sugar ABC transporter substrate-binding protein', 144, NULL, NULL, 160139),
(160140, '1.10.238.10-FF-000429', NULL, 'EF-hand calcium-binding domain-containing protein 6', 85, NULL, NULL, 160140),
(160141, '1.10.510.10-FF-000579', NULL, 'Sensor histidine kinase/response regulator, putative', 189, NULL, NULL, 160141),
(160142, '3.40.50.300-FF-004905', NULL, 'Predicted protein', 93, NULL, NULL, 160142),
(160143, '3.10.300.10-FF-000005', NULL, 'Putative 3-methyladenine DNA glycosylase', 181, NULL, NULL, 160143),
(160144, '3.90.1030.20-FF-000002', NULL, 'DNA polymerase delta subunit', 140, NULL, NULL, 160144),
(160145, '3.80.10.10-FF-003731', NULL, 'Uncharacterized protein', 135, NULL, NULL, 160145),
(160146, '3.60.15.10-FF-000084', NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', 383, NULL, NULL, 160146),
(160147, '3.10.20.90-FF-000919', NULL, 'Uncharacterized protein', 68, NULL, NULL, 160147),
(160148, '3.90.550.50-FF-000068', NULL, 'Hexosyltransferase', 253, NULL, NULL, 160148),
(160149, '2.60.120.1040-FF-000019', NULL, NULL, 118, NULL, NULL, 160149),
(160150, '3.50.7.10-FF-000073', NULL, NULL, 62, NULL, NULL, 160150),
(160151, '1.20.58.1020-FF-000005', NULL, 'DNA replication complex GINS protein', 117, NULL, NULL, 160151),
(160152, '2.30.40.10-FF-000117', NULL, 'Uncharacterized protein', 96, NULL, NULL, 160152),
(160153, '3.40.50.2000-FF-000070', NULL, 'probable UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SEC', 165, NULL, NULL, 160153),
(160154, '2.60.40.10-FF-001830', NULL, 'Interleukin-2 receptor subunit beta', 105, NULL, NULL, 160154),
(160155, '3.40.190.10-FF-000146', NULL, 'Prephenate dehydratase', 80, NULL, NULL, 160155),
(160156, '3.40.50.300-FF-008492', NULL, 'Uncharacterized protein', 122, NULL, NULL, 160156),
(160157, '3.30.390.150-FF-000003', NULL, 'Gastrokine 1', 103, NULL, NULL, 160157),
(160158, '3.40.850.10-FF-000146', NULL, 'Kinesin-like protein', 331, NULL, NULL, 160158),
(160159, '3.30.70.330-FF-002436', NULL, NULL, 156, NULL, NULL, 160159),
(160160, '1.10.287.130-FF-000011', NULL, 'Sensor histidine kinase DcuS', 63, NULL, NULL, 160160),
(160161, '1.10.10.60-FF-000398', NULL, 'Homeobox protein lin-39', 83, NULL, NULL, 160161),
(160162, '3.30.160.60-FF-003062', NULL, 'Tripartite motif-containing protein 40', 69, NULL, NULL, 160162),
(160163, '1.20.58.1030-FF-000008', NULL, 'Hypothetical_protein', 126, NULL, NULL, 160163),
(160164, '2.40.37.10-FF-000025', NULL, 'Diaminopimelate decarboxylase', 119, NULL, NULL, 160164),
(160165, '3.40.50.720-FF-001468', NULL, 'Uncharacterized protein', 85, NULL, NULL, 160165),
(160166, '1.20.1540.10-FF-000016', NULL, 'Derlin', 182, NULL, NULL, 160166),
(160167, '3.30.200.20-FF-002435', NULL, 'Uncharacterized protein', 73, NULL, NULL, 160167),
(160168, '2.60.40.1180-FF-000078', NULL, 'Maltase A5', 84, NULL, NULL, 160168),
(160169, '3.40.50.620-FF-000454', NULL, 'Tryptophan--tRNA ligase, cytoplasmic', 259, NULL, NULL, 160169),
(160170, '3.30.420.40-FF-001075', NULL, 'Uncharacterized protein', 150, NULL, NULL, 160170),
(160171, '3.40.850.10-FF-000500', NULL, 'Kinesin-like protein costa', 244, NULL, NULL, 160171),
(160172, '3.40.50.970-FF-000121', NULL, 'Sulfite reductase beta subunit', 251, NULL, NULL, 160172),
(160173, '2.10.25.10-FF-000504', NULL, 'LDL receptor related protein 1B', 33, NULL, NULL, 160173);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(160174, '1.10.3470.10-FF-000024', NULL, 'Iron ABC transporter permease', 345, NULL, NULL, 160174),
(160175, '1.20.120.560-FF-000008', NULL, 'Vacuolar protein-sorting protein BRO1', 179, NULL, NULL, 160175),
(160176, '3.30.40.10-FF-001739', NULL, 'Putative E3 ubiquitin-protein ligase ORTHRUS 4', 102, NULL, NULL, 160176),
(160177, '3.30.70.330-FF-000385', NULL, 'Polyadenylate-binding protein', 98, NULL, NULL, 160177),
(160178, '3.30.70.330-FF-000637', NULL, 'Nonsense-mediated mRNA decay protein Upf3, putative', 109, NULL, NULL, 160178),
(160179, '3.30.1360.120-FF-000094', NULL, 'Dimethylsulfonioproprionate demethylase DmdA', 361, NULL, NULL, 160179),
(160180, '3.90.1860.10-FF-000011', NULL, 'Uncharacterized protein', 161, NULL, NULL, 160180),
(160181, '3.40.50.1980-FF-000097', NULL, 'Periplasmic chelated iron-binding protein YfeA', 120, NULL, NULL, 160181),
(160182, '3.30.420.40-FF-000715', NULL, 'Actin-related protein 4', 78, NULL, NULL, 160182),
(160183, '3.30.160.60-FF-006187', NULL, NULL, 58, NULL, NULL, 160183),
(160184, '3.10.10.10-FF-000058', NULL, NULL, 135, NULL, NULL, 160184),
(160185, '3.50.50.60-FF-000304', NULL, 'FAD-dependent oxidoreductase', 193, NULL, NULL, 160185),
(160186, '2.120.10.80-FF-000155', NULL, 'Predicted protein', 283, NULL, NULL, 160186),
(160187, '2.40.10.500-FF-000004', NULL, NULL, 110, NULL, NULL, 160187),
(160188, '1.25.10.10-FF-000625', NULL, 'Importin-9', 1014, NULL, NULL, 160188),
(160189, '1.25.10.10-FF-003031', NULL, 'Uncharacterized protein', 314, NULL, NULL, 160189),
(160190, '1.10.1070.11-FF-000118', NULL, 'Uncharacterized protein', 222, NULL, NULL, 160190),
(160191, '2.10.25.10-FF-001786', NULL, 'Uncharacterized protein', 55, NULL, NULL, 160191),
(160192, '3.40.50.1440-FF-000093', NULL, 'Predicted protein', 330, NULL, NULL, 160192),
(160193, '2.40.30.200-FF-000002', NULL, 'Distal tail protein', 137, NULL, NULL, 160193),
(160194, '3.40.50.920-FF-000022', NULL, 'Sulfite reductase alpha subunit', 137, NULL, NULL, 160194),
(160195, '3.90.1640.10-FF-000028', NULL, 'Uncharacterized protein', 220, NULL, NULL, 160195),
(160196, '3.30.40.10-FF-002313', NULL, 'Uncharacterized protein', 107, NULL, NULL, 160196),
(160197, '3.30.70.330-FF-002537', NULL, NULL, 48, NULL, NULL, 160197),
(160198, '2.10.110.10-FF-000051', NULL, 'LIM domain transcription factor LMO4', 68, NULL, NULL, 160198),
(160199, '1.10.730.10-FF-000192', NULL, 'Uncharacterized protein', 135, NULL, NULL, 160199),
(160200, '1.50.10.160-FF-000010', NULL, 'Terpentedienyl-diphosphate synthase', 220, NULL, NULL, 160200),
(160201, '1.10.10.10-FF-000653', NULL, 'Transposase IS6110', 66, NULL, NULL, 160201),
(160202, '2.30.30.40-FF-000098', NULL, 'Protein arginine N-methyltransferase 2 isoform 1', 59, NULL, NULL, 160202),
(160203, '3.90.470.10-FF-000016', NULL, '60S ribosomal protein L17, putative', 166, NULL, NULL, 160203),
(160204, '3.40.390.10-FF-000021', NULL, 'Matrix metallopeptidase 28', 262, NULL, NULL, 160204),
(160205, '3.40.50.12390-FF-000004', NULL, '5''-3'' exoribonuclease 1', 126, NULL, NULL, 160205),
(160206, '3.30.2160.10-FF-000039', NULL, 'Predicted protein', 83, NULL, NULL, 160206),
(160207, '4.10.800.10-FF-000034', NULL, 'Uncharacterized protein', 51, NULL, NULL, 160207),
(160208, '1.20.58.60-FF-000232', NULL, 'nesprin-1 isoform X9', 290, NULL, NULL, 160208),
(160209, '1.20.80.10-FF-000050', NULL, 'Autophagy-related protein 37', 115, NULL, NULL, 160209),
(160210, '3.20.20.140-FF-000230', NULL, 'RNase P subunit p30-domain-containing protein', 170, NULL, NULL, 160210),
(160211, '3.40.50.300-FF-006704', NULL, 'Uncharacterized protein', 77, NULL, NULL, 160211),
(160212, '1.25.40.10-FF-000099', NULL, 'Clustered mitochondria protein homolog', 258, NULL, NULL, 160212),
(160213, '1.10.510.10-FF-002833', NULL, NULL, 96, NULL, NULL, 160213),
(160214, '2.130.10.10-FF-002663', NULL, 'Uncharacterized protein', 203, NULL, NULL, 160214),
(160215, '1.20.58.760-FF-000013', NULL, 'Probable inactive ATP-dependent zinc metalloprotease FTSHI 4, chloroplastic', 187, NULL, NULL, 160215),
(160216, '2.30.30.30-FF-000095', NULL, 'PTAC13', 52, NULL, NULL, 160216);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(160217, '2.30.36.100-FF-000001', NULL, 'Uncharacterized protein MJ0776', 60, NULL, NULL, 160217),
(160218, '3.90.950.10-FF-000053', NULL, 'Uncharacterized protein', 65, NULL, NULL, 160218),
(160219, '1.20.5.170-FF-000117', NULL, 'Positive regulator of galactose inducible genes', 57, NULL, NULL, 160219),
(160220, '4.10.60.10-FF-000082', NULL, 'RNA recognition motif domain containing protein', 34, NULL, NULL, 160220),
(160221, '3.40.50.1000-FF-000854', NULL, NULL, 52, NULL, NULL, 160221),
(160222, '1.25.40.10-FF-002605', NULL, 'Uncharacterized protein', 70, NULL, NULL, 160222),
(160223, '2.130.10.10-FF-000982', NULL, 'Ribosomal assembly complex component Ipi3', 183, NULL, NULL, 160223),
(160224, '3.40.50.300-FF-000853', NULL, 'Nicotinamide riboside kinase 1', 191, NULL, NULL, 160224),
(160225, '3.40.50.300-FF-004759', NULL, 'Uncharacterized protein', 89, NULL, NULL, 160225),
(160226, '3.30.479.30-FF-000049', NULL, 'Predicted protein', 24, NULL, NULL, 160226),
(160227, '3.40.50.2000-FF-000631', NULL, 'Uncharacterized protein', 254, NULL, NULL, 160227),
(160228, '3.30.200.20-FF-002525', NULL, 'WNK protein kinase', 86, NULL, NULL, 160228),
(160229, '3.75.10.10-FF-000051', NULL, NULL, 70, NULL, NULL, 160229),
(160230, '3.40.50.460-FF-000030', NULL, 'ATP-dependent 6-phosphofructokinase', 28, NULL, NULL, 160230),
(160231, '1.25.40.10-FF-004505', NULL, 'Uncharacterized protein', 90, NULL, NULL, 160231),
(160232, '2.60.40.2860-FF-000020', NULL, 'Transmission-blocking target antigen S230', 129, NULL, NULL, 160232),
(160233, '3.30.40.10-FF-000059', NULL, 'PHD finger protein 14 isoform X1', 121, NULL, NULL, 160233),
(160234, '3.30.43.10-FF-000021', NULL, 'Cytokinin oxidase 2', 121, NULL, NULL, 160234),
(160235, '3.10.180.10-FF-000079', NULL, 'Methylmalonyl-CoA epimerase', 130, NULL, NULL, 160235),
(160236, '3.30.70.270-FF-000142', NULL, 'Uncharacterized protein', 54, NULL, NULL, 160236),
(160237, '2.40.30.10-FF-000459', NULL, 'Predicted protein', 97, NULL, NULL, 160237),
(160238, '2.70.130.10-FF-000095', NULL, NULL, 156, NULL, NULL, 160238),
(160239, '2.40.50.40-FF-000109', NULL, 'Interleukin-8', 65, NULL, NULL, 160239),
(160240, '3.40.50.300-FF-006659', NULL, 'Uncharacterized protein', 86, NULL, NULL, 160240),
(160241, '3.30.160.60-FF-005214', NULL, NULL, 30, NULL, NULL, 160241),
(160242, '3.30.160.60-FF-003314', NULL, 'Sex determination protein fruitless', 90, NULL, NULL, 160242),
(160243, '2.40.330.10-FF-000010', NULL, 'B3 domain-containing protein REM1', 106, NULL, NULL, 160243),
(160244, '1.10.1300.10-FF-000091', NULL, 'Uncharacterized protein', 129, NULL, NULL, 160244),
(160245, '1.10.150.20-FF-000144', NULL, 'DNA repair endonuclease XPF', 78, NULL, NULL, 160245),
(160246, '1.20.120.1240-FF-000012', NULL, 'dynamin-3 isoform X1', 89, NULL, NULL, 160246),
(160247, '3.80.10.10-FF-000504', NULL, 'F-box family protein', 111, NULL, NULL, 160247),
(160248, '1.20.1080.10-FF-000132', NULL, 'Uncharacterized protein', 46, NULL, NULL, 160248),
(160249, '2.60.40.10-FF-000706', NULL, 'Hemicentin 1', 92, NULL, NULL, 160249),
(160250, '1.20.1270.60-FF-000032', NULL, 'Sorting nexin', 190, NULL, NULL, 160250),
(160251, '3.30.413.10-FF-000021', NULL, 'Nitrite reductase', 186, NULL, NULL, 160251),
(160252, '2.170.300.10-FF-000005', NULL, 'multiple epidermal growth factor-like domains protein 11', 127, NULL, NULL, 160252),
(160253, '2.30.30.40-FF-000659', NULL, 'Uncharacterized protein', 67, NULL, NULL, 160253),
(160254, '3.90.70.10-FF-000749', NULL, 'Clan CA, family C1, cathepsin L-like cysteine peptidase', 129, NULL, NULL, 160254),
(160255, '3.30.160.60-FF-006496', NULL, NULL, 60, NULL, NULL, 160255),
(160256, '3.80.10.10-FF-000813', NULL, 'Leucine rich repeats and guanylate kinase domain containing', 139, NULL, NULL, 160256),
(160257, '2.130.10.10-FF-004725', NULL, 'Uncharacterized protein', 166, NULL, NULL, 160257),
(160258, '3.30.1460.20-FF-000020', NULL, 'Arp2/3 complex 34 kDa subunit', 56, NULL, NULL, 160258),
(160259, '3.40.30.10-FF-000024', NULL, 'Glutathione S-transferase A4', 98, NULL, NULL, 160259),
(160260, '3.40.50.300-FF-003006', NULL, 'Rab family gtpase', 178, NULL, NULL, 160260);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(160261, '2.30.29.30-FF-000333', NULL, 'Uncharacterized protein, isoform C', 105, NULL, NULL, 160261),
(160262, '2.60.40.10-FF-004293', NULL, NULL, 61, NULL, NULL, 160262),
(160263, '1.25.40.1040-FF-000012', NULL, 'N-alpha-acetyltransferase 15, NatA auxiliary subunit, putative', 328, NULL, NULL, 160263),
(160264, '1.25.40.10-FF-004814', NULL, 'Uncharacterized protein', 157, NULL, NULL, 160264),
(160265, '3.40.850.10-FF-000455', NULL, 'Uncharacterized protein', 68, NULL, NULL, 160265),
(160266, '3.40.190.10-FF-000455', NULL, 'Glycine cleavage operon activator', 90, NULL, NULL, 160266),
(160267, '3.40.50.2000-FF-000940', NULL, 'Uncharacterized protein', 133, NULL, NULL, 160267),
(160268, '3.40.30.10-FF-001109', NULL, 'Uncharacterized protein', 26, NULL, NULL, 160268),
(160269, '2.130.10.10-FF-002573', NULL, 'Uncharacterized protein', 223, NULL, NULL, 160269),
(160270, '1.25.10.10-FF-001131', NULL, '26S proteasome non-ATPase regulatory subunit 5', 158, NULL, NULL, 160270),
(160271, '1.20.1090.10-FF-000060', NULL, 'Predicted protein', 160, NULL, NULL, 160271),
(160272, '1.20.1050.10-FF-000052', NULL, 'Glutathione S-transferase GstA', 152, NULL, NULL, 160272),
(160273, '3.30.420.10-FF-000043', NULL, 'DNA polymerase', 315, NULL, NULL, 160273),
(160274, '3.30.160.60-FF-003623', NULL, NULL, 35, NULL, NULL, 160274),
(160275, '3.30.505.10-FF-000196', NULL, NULL, 154, NULL, NULL, 160275),
(160276, '3.10.129.10-FF-000062', NULL, 'Acyl-CoA thioester hydrolase', 151, NULL, NULL, 160276),
(160277, '1.10.720.30-FF-000011', NULL, 'E3 ubiquitin-protein ligase RNF34 isoform X1', 54, NULL, NULL, 160277),
(160278, '2.170.16.10-FF-000010', NULL, 'Ataxin 1-like', 142, NULL, NULL, 160278),
(160279, '2.60.120.260-FF-000375', NULL, 'Beta-galactosidase', 89, NULL, NULL, 160279),
(160280, '3.80.10.10-FF-001786', NULL, 'Uncharacterized protein', 218, NULL, NULL, 160280),
(160281, '3.30.160.60-FF-001723', NULL, 'Zinc finger protein 408', 25, NULL, NULL, 160281),
(160282, '3.80.10.10-FF-002404', NULL, 'PH domain and leucine-rich repeat protein phosphatase 1', 154, NULL, NULL, 160282),
(160283, '1.25.40.10-FF-000762', NULL, 'tetratricopeptide repeat protein 30B', 199, NULL, NULL, 160283),
(160284, '1.10.510.10-FF-001506', NULL, 'Guanylate cyclase', 345, NULL, NULL, 160284),
(160285, '1.10.472.10-FF-000568', NULL, 'Cyclin O', 60, NULL, NULL, 160285),
(160286, '1.10.287.70-FF-000122', NULL, 'Potassium channel subfamily K member 18', 282, NULL, NULL, 160286),
(160287, '3.30.465.10-FF-000006', NULL, 'Delta(24)-sterol reductase', 124, NULL, NULL, 160287),
(160288, '2.30.42.10-FF-000408', NULL, NULL, 84, NULL, NULL, 160288),
(160289, '3.80.10.10-FF-003938', NULL, 'Predicted protein', 85, NULL, NULL, 160289),
(160290, '1.10.510.10-FF-002788', NULL, NULL, 201, NULL, NULL, 160290),
(160291, '1.10.10.60-FF-000971', NULL, NULL, 47, NULL, NULL, 160291),
(160292, '2.30.29.30-FF-000024', NULL, 'Spectrin beta chain', 117, NULL, NULL, 160292),
(160293, '2.60.40.10-FF-005220', NULL, NULL, 90, NULL, NULL, 160293),
(160294, '2.40.30.260-FF-000003', NULL, NULL, 134, NULL, NULL, 160294),
(160295, '3.30.390.110-FF-000008', NULL, 'Protein MAK16 homolog', 126, NULL, NULL, 160295),
(160296, '3.80.10.10-FF-000252', NULL, 'Leucine-rich repeat-containing protein 61', 163, NULL, NULL, 160296),
(160297, '1.10.10.60-FF-000662', NULL, 'Transcriptional regulator, AraC/XylS family', 53, NULL, NULL, 160297),
(160298, '3.30.2090.10-FF-000011', NULL, 'RND multidrug efflux transporter', 89, NULL, NULL, 160298),
(160299, '1.20.920.30-FF-000069', NULL, 'Dynein axonemal heavy chain 14', 84, NULL, NULL, 160299),
(160300, '3.90.640.10-FF-000052', NULL, 'Actin', 76, NULL, NULL, 160300),
(160301, '3.90.79.10-FF-000185', NULL, 'NUDIX hydrolase domain-like protein', 189, NULL, NULL, 160301),
(160302, '3.40.50.10260-FF-000034', NULL, 'Predicted protein', 255, NULL, NULL, 160302),
(160303, '1.10.1070.11-FF-000028', NULL, 'Serine/threonine-protein kinase TOR', 173, NULL, NULL, 160303),
(160304, '3.30.70.920-FF-000056', NULL, 'Transcriptional regulator AsnC family', 86, NULL, NULL, 160304);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(160305, '1.20.1070.10-FF-001907', NULL, 'Odorant receptor', 287, NULL, NULL, 160305),
(160306, '3.80.10.10-FF-001477', NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', 97, NULL, NULL, 160306),
(160307, '3.40.50.300-FF-001106', NULL, 'Guanine nucleotide-binding protein-like 3', 181, NULL, NULL, 160307),
(160308, '1.25.40.10-FF-000453', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 147, NULL, NULL, 160308),
(160309, '3.30.160.60-FF-001162', NULL, 'zinc finger protein 879 isoform X2', 28, NULL, NULL, 160309),
(160310, '2.40.30.270-FF-000006', NULL, 'Similar to DNA helicase', 139, NULL, NULL, 160310),
(160311, '1.10.8.270-FF-000083', NULL, 'TBC1 domain family member 9B', 105, NULL, NULL, 160311),
(160312, '2.130.10.10-FF-000673', NULL, 'WD repeat and FYVE domain-containing protein 2', 170, NULL, NULL, 160312),
(160313, '1.25.40.10-FF-002914', NULL, 'mRNA splicing protein', 328, NULL, NULL, 160313),
(160314, '1.20.920.20-FF-000066', NULL, 'Uncharacterized protein', 238, NULL, NULL, 160314),
(160315, '2.60.40.60-FF-000659', NULL, 'Cadherin 16', 105, NULL, NULL, 160315),
(160316, '3.30.230.10-FF-000208', NULL, 'Ribonuclease P protein component', 112, NULL, NULL, 160316),
(160317, '3.80.10.10-FF-003686', NULL, 'Uncharacterized protein', 186, NULL, NULL, 160317),
(160318, '2.120.10.80-FF-000065', NULL, 'Leucine-zipper-like transcription regulator 1', 159, NULL, NULL, 160318),
(160319, '1.20.1250.20-FF-002060', NULL, 'Uncharacterized protein', 298, NULL, NULL, 160319),
(160320, '1.25.10.10-FF-001440', NULL, 'Serine/threonine-protein kinase TOR', 274, NULL, NULL, 160320),
(160321, '1.10.510.10-FF-002479', NULL, 'CK1 family protein kinase', 313, NULL, NULL, 160321),
(160322, '1.10.238.10-FF-001244', NULL, 'MIP10861p', 86, NULL, NULL, 160322),
(160323, '2.40.10.10-FF-000705', NULL, NULL, 60, NULL, NULL, 160323),
(160324, '1.20.1050.10-FF-000259', NULL, 'Glutathione s-transferase', 135, NULL, NULL, 160324),
(160325, '1.10.472.30-FF-000001', NULL, 'Transcription elongation factor A (SII), 1', 117, NULL, NULL, 160325),
(160326, '1.10.10.570-FF-000013', NULL, 'Uncharacterized protein', 67, NULL, NULL, 160326),
(160327, '3.40.850.10-FF-000040', NULL, 'Kinesin-like protein', 335, NULL, NULL, 160327),
(160328, '3.30.590.50-FF-000016', NULL, 'Uncharacterized protein', 108, NULL, NULL, 160328),
(160329, '3.30.160.60-FF-002718', NULL, 'C2H2 transcription factor', 32, NULL, NULL, 160329),
(160330, '3.20.20.80-FF-000023', NULL, 'heparanase-like protein 3', 322, NULL, NULL, 160330),
(160331, '1.10.510.10-FF-002597', NULL, NULL, 184, NULL, NULL, 160331),
(160332, '3.30.750.24-FF-000098', NULL, 'Uncharacterized protein', 97, NULL, NULL, 160332),
(160333, '3.30.200.20-FF-001699', NULL, 'Predicted protein', 60, NULL, NULL, 160333),
(160334, '2.120.10.30-FF-000308', NULL, 'Predicted protein', 328, NULL, NULL, 160334),
(160335, '3.90.1170.50-FF-000010', NULL, 'Carbon monoxide dehydrogenase large chain', 104, NULL, NULL, 160335),
(160336, '2.20.100.10-FF-000042', NULL, 'ADAMTS like 2', 57, NULL, NULL, 160336),
(160337, '1.10.510.10-FF-000989', NULL, 'Wee1-like protein kinase', 198, NULL, NULL, 160337),
(160338, '1.20.1070.10-FF-000412', NULL, 'Uncharacterized protein', 304, NULL, NULL, 160338),
(160339, '3.40.50.2300-FF-000940', NULL, NULL, 173, NULL, NULL, 160339),
(160340, '2.60.40.60-FF-001042', NULL, 'Uncharacterized protein', 96, NULL, NULL, 160340),
(160341, '3.30.160.60-FF-003180', NULL, 'Zinc finger protein 786', 35, NULL, NULL, 160341),
(160342, '1.10.20.140-FF-000021', NULL, NULL, 65, NULL, NULL, 160342),
(160343, '3.20.20.70-FF-000020', NULL, 'Triosephosphate isomerase', 254, NULL, NULL, 160343),
(160344, '3.90.70.10-FF-000856', NULL, 'Predicted protein', 106, NULL, NULL, 160344),
(160345, '2.30.42.10-FF-000291', NULL, 'Partitioning defective protein 3', 129, NULL, NULL, 160345),
(160346, '3.40.50.620-FF-000336', NULL, 'Arginine--tRNA ligase', 326, NULL, NULL, 160346),
(160347, '2.120.10.80-FF-000172', NULL, 'Uncharacterized protein', 184, NULL, NULL, 160347),
(160348, '1.25.40.20-FF-001372', NULL, 'Uncharacterized protein', 87, NULL, NULL, 160348);
INSERT INTO "PUBLIC"."MODEL" VALUES
(160349, '1.25.40.10-FF-002459', NULL, 'Os02g0670700 protein', 138, NULL, NULL, 160349),
(160350, '3.40.1190.20-FF-000204', NULL, NULL, 152, NULL, NULL, 160350),
(160351, '1.10.510.10-FF-002715', NULL, NULL, 143, NULL, NULL, 160351),
(160352, '2.60.40.10-FF-001611', NULL, 'cardiomyopathy-associated protein 5', 87, NULL, NULL, 160352),
(160353, '3.80.10.10-FF-001707', NULL, 'Inactive disease susceptibility protein LOV1', 195, NULL, NULL, 160353),
(160354, '1.10.10.60-FF-000089', NULL, 'Caudal type homeobox 4', 86, NULL, NULL, 160354),
(160355, '3.30.40.10-FF-000284', NULL, 'pleckstrin homology domain-containing family F member 1', 88, NULL, NULL, 160355),
(160356, '1.10.1070.11-FF-000135', NULL, 'Uncharacterized protein', 137, NULL, NULL, 160356),
(160357, '3.40.1440.10-FF-000002', NULL, 'UPF0213 protein YhbQ', 97, NULL, NULL, 160357),
(160358, '1.20.1250.10-FF-000033', NULL, 'Interferon epsilon', 166, NULL, NULL, 160358),
(160359, '3.40.50.150-FF-001145', NULL, NULL, 227, NULL, NULL, 160359),
(160360, '2.60.40.3040-FF-000001', NULL, NULL, 43, NULL, NULL, 160360),
(160361, '3.30.70.330-FF-001947', NULL, NULL, 121, NULL, NULL, 160361),
(160362, '3.30.160.70-FF-000001', NULL, 'Methylated-DNA--protein-cysteine methyltransferase', 84, NULL, NULL, 160362),
(160363, '1.10.287.110-FF-000365', NULL, 'Co-chaperone protein HscB homolog', 73, NULL, NULL, 160363),
(160364, '1.25.40.10-FF-004713', NULL, 'Uncharacterized protein', 91, NULL, NULL, 160364),
(160365, '1.25.10.10-FF-000833', NULL, '26S proteasome non-ATPase regulatory subunit, putative', 419, NULL, NULL, 160365),
(160366, '3.40.50.720-FF-002204', NULL, 'DNA damage tolerance protein rad31', 306, NULL, NULL, 160366),
(160367, '2.60.40.10-FF-002595', NULL, 'Sallimus, isoform Z', 98, NULL, NULL, 160367),
(160368, '2.130.10.10-FF-001145', NULL, 'Lethal(2) giant larvae protein homolog 2', 149, NULL, NULL, 160368),
(160369, '1.25.40.10-FF-000907', NULL, 'YMR018W-like protein', 309, NULL, NULL, 160369),
(160370, '1.10.10.10-FF-000670', NULL, 'DNA-binding response regulator', 97, NULL, NULL, 160370),
(160371, '2.40.70.10-FF-000462', NULL, NULL, 176, NULL, NULL, 160371),
(160372, '3.40.50.300-FF-007272', NULL, 'Predicted protein', 155, NULL, NULL, 160372),
(160373, '1.10.600.10-FF-000114', NULL, 'Uncharacterized protein', 266, NULL, NULL, 160373),
(160374, '1.10.630.10-FF-000144', NULL, 'probable cytochrome P450 303a1', 483, NULL, NULL, 160374),
(160375, '1.10.10.60-FF-001241', NULL, NULL, 46, NULL, NULL, 160375),
(160376, '2.60.120.200-FF-000402', NULL, 'Galectin', 150, NULL, NULL, 160376),
(160377, '2.40.50.140-FF-000180', NULL, '40S ribosomal protein S28e', 67, NULL, NULL, 160377),
(160378, '2.10.25.10-FF-001696', NULL, 'Uncharacterized protein', 64, NULL, NULL, 160378),
(160379, '3.30.160.60-FF-005315', NULL, NULL, 79, NULL, NULL, 160379),
(160380, '1.10.287.3700-FF-000004', NULL, 'Poly(A) specific ribonuclease subunit PAN3', 53, NULL, NULL, 160380),
(160381, '3.40.50.300-FF-001016', NULL, 'ras-like protein family member 12', 168, NULL, NULL, 160381),
(160382, '1.25.40.10-FF-005112', NULL, 'Receptor-associated protein of the synapse', 115, NULL, NULL, 160382),
(160383, '1.20.1070.10-FF-000261', NULL, 'Prostaglandin E receptor 4 (subtype EP4) c', 317, NULL, NULL, 160383),
(160384, '1.10.510.10-FF-002608', NULL, NULL, 151, NULL, NULL, 160384),
(160385, '2.60.40.60-FF-000569', NULL, 'Cadherin 5', 105, NULL, NULL, 160385),
(160386, '3.80.10.10-FF-004304', NULL, 'Dual specificity protein phosphatase, putative', 218, NULL, NULL, 160386),
(160387, '1.10.472.10-FF-000580', NULL, 'Uncharacterized protein', 44, NULL, NULL, 160387),
(160388, '2.130.10.10-FF-005321', NULL, 'Uncharacterized protein', 200, NULL, NULL, 160388),
(160389, '3.20.20.80-FF-000130', NULL, 'Endoglucanase C', 342, NULL, NULL, 160389),
(160390, '3.40.525.10-FF-000043', NULL, 'Tocopherol (alpha) transfer protein', 25, NULL, NULL, 160390),
(160391, '2.60.40.1170-FF-000058', NULL, 'Adaptor-related protein complex 5 subunit mu 1', 80, NULL, NULL, 160391),
(160392, '3.80.10.10-FF-001814', NULL, 'F-box family protein', 189, NULL, NULL, 160392);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(160393, '3.30.200.20-FF-002216', NULL, 'Serine/threonine protein kinase, putative', 42, NULL, NULL, 160393),
(160394, '2.30.30.40-FF-000660', NULL, 'Tyrosine-protein kinase', 98, NULL, NULL, 160394),
(160395, '1.10.460.10-FF-000018', NULL, 'DNA topoisomerase 1', 54, NULL, NULL, 160395),
(160396, '3.30.559.10-FF-000230', NULL, 'Nonribosomal peptide synthetase easA', 172, NULL, NULL, 160396),
(160397, '3.30.230.10-FF-000107', NULL, 'Phosphomevalonate kinase', 194, NULL, NULL, 160397),
(160398, '1.10.418.10-FF-000275', NULL, 'Uncharacterized protein', 52, NULL, NULL, 160398),
(160399, '1.25.10.10-FF-001541', NULL, 'Uncharacterized protein', 482, NULL, NULL, 160399),
(160400, '3.30.70.330-FF-000531', NULL, 'Myelin expression factor 2', 80, NULL, NULL, 160400),
(160401, '3.80.10.10-FF-000712', NULL, 'F-box/LRR-repeat MAX2 homolog', 420, NULL, NULL, 160401),
(160402, '3.30.200.20-FF-000608', NULL, 'Serine/threonine kinase protein', 111, NULL, NULL, 160402),
(160403, '3.20.20.80-FF-000500', NULL, 'Beta-1,4-endoglucanase (Eurofung)', 158, NULL, NULL, 160403),
(160404, '3.40.50.2000-FF-000480', NULL, 'Glycosyltransferase', 254, NULL, NULL, 160404),
(160405, '3.30.1370.170-FF-000003', NULL, 'Erythronate-4-phosphate dehydrogenase', 88, NULL, NULL, 160405),
(160406, '1.10.600.10-FF-000007', NULL, 'Isoprene synthase, chloroplastic', 355, NULL, NULL, 160406),
(160407, '3.30.160.60-FF-004949', NULL, NULL, 112, NULL, NULL, 160407),
(160408, '1.10.238.10-FF-000654', NULL, 'Caltractin, putative', 66, NULL, NULL, 160408),
(160409, '2.60.40.60-FF-000895', NULL, 'Uncharacterized protein', 109, NULL, NULL, 160409),
(160410, '1.10.510.10-FF-003070', NULL, NULL, 204, NULL, NULL, 160410),
(160411, '3.80.20.20-FF-000008', NULL, 'Receptor protein-tyrosine kinase', 192, NULL, NULL, 160411),
(160412, '3.40.50.970-FF-000076', NULL, 'Transketolase', 203, NULL, NULL, 160412),
(160413, '1.10.287.4270-FF-000001', NULL, 'Serine/threonine-protein kinase 3', 64, NULL, NULL, 160413),
(160414, '2.60.40.60-FF-000906', NULL, 'Uncharacterized protein', 107, NULL, NULL, 160414),
(160415, '2.60.40.150-FF-000468', NULL, 'Uncharacterized protein', 132, NULL, NULL, 160415),
(160416, '3.40.50.300-FF-001342', NULL, 'ATP-dependent OLD family endonuclease', 345, NULL, NULL, 160416),
(160417, '3.60.15.10-FF-000067', NULL, 'Metallo-beta-lactamase family protein', 241, NULL, NULL, 160417),
(160418, '2.160.20.10-FF-000094', NULL, 'Putative pectinesterase/pectinesterase inhibitor 51', 94, NULL, NULL, 160418),
(160419, '3.80.10.10-FF-000033', NULL, 'FLII, actin remodeling protein', 99, NULL, NULL, 160419),
(160420, '3.30.200.20-FF-000597', NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', 119, NULL, NULL, 160420),
(160421, '2.30.30.550-FF-000014', NULL, NULL, 64, NULL, NULL, 160421),
(160422, '1.10.1820.10-FF-000012', NULL, 'Casein kinase II subunit beta', 104, NULL, NULL, 160422),
(160423, '2.60.34.10-FF-000046', NULL, 'HSP70-family chaperone protein, putative', 124, NULL, NULL, 160423),
(160424, '1.25.40.10-FF-001043', NULL, 'Predicted protein', 130, NULL, NULL, 160424),
(160425, '2.60.40.150-FF-000575', NULL, 'Uncharacterized protein', 107, NULL, NULL, 160425),
(160426, '1.10.238.10-FF-000547', NULL, 'Reticulocalbin 2', 58, NULL, NULL, 160426),
(160427, '3.30.2350.10-FF-000048', NULL, 'Pseudouridine synthase', 210, NULL, NULL, 160427),
(160428, '3.90.550.50-FF-000085', NULL, 'Hexosyltransferase', 201, NULL, NULL, 160428),
(160429, '3.40.50.80-FF-000041', NULL, '1,2-phenylacetyl-CoA epoxidase subunit E', 139, NULL, NULL, 160429),
(160430, '3.40.50.150-FF-000639', NULL, 'Met-10+ like-protein/Methyltransferase small domain/Methyltransferase domain containing protein, putative', 198, NULL, NULL, 160430),
(160431, '2.130.10.10-FF-002247', NULL, 'Coatomer subunit alpha-3', 66, NULL, NULL, 160431),
(160432, '1.20.1440.230-FF-000006', NULL, 'NADH-ubiquinone oxidoreductase 51 kDa subunit homolog SPBC18E5.10, mitochondrial', 92, NULL, NULL, 160432),
(160433, '2.30.29.70-FF-000002', NULL, 'Proteasomal ubiquitin receptor ADRM1', 54, NULL, NULL, 160433);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(160434, '3.90.79.10-FF-000286', NULL, 'Uncharacterized protein', 53, NULL, NULL, 160434),
(160435, '3.40.190.10-FF-000691', NULL, 'Sll1762 protein', 148, NULL, NULL, 160435),
(160436, '2.40.50.40-FF-000082', NULL, 'Uncharacterized protein', 63, NULL, NULL, 160436),
(160437, '1.20.1280.290-FF-000054', NULL, 'L-cystine transporter', 106, NULL, NULL, 160437),
(160438, '3.80.10.10-FF-001696', NULL, 'Receptor like protein 39', 147, NULL, NULL, 160438),
(160439, '3.40.50.620-FF-000229', NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', 330, NULL, NULL, 160439),
(160440, '3.10.110.10-FF-000176', NULL, 'RBR-type E3 ubiquitin transferase', 143, NULL, NULL, 160440),
(160441, '3.90.640.10-FF-000203', NULL, 'Heat shock 70 kDa protein 14', 83, NULL, NULL, 160441),
(160442, '3.40.50.720-FF-000057', NULL, 'Formate dehydrogenase', 197, NULL, NULL, 160442),
(160443, '1.25.40.20-FF-001046', NULL, 'Uncharacterized protein', 161, NULL, NULL, 160443),
(160444, '3.60.130.10-FF-000008', NULL, 'Alpha-ketoglutarate-dependent taurine dioxygenase', 294, NULL, NULL, 160444),
(160445, '1.20.1070.10-FF-000042', NULL, 'Taste receptor type 2 member 7', 303, NULL, NULL, 160445),
(160446, '2.60.200.20-FF-000139', NULL, 'APTX isoform 3', 85, NULL, NULL, 160446),
(160447, '3.30.70.560-FF-000004', NULL, 'Dihydropteroate synthase', 140, NULL, NULL, 160447),
(160448, '1.20.1250.20-FF-000362', NULL, 'Major Facilitator Superfamily protein', 412, NULL, NULL, 160448),
(160449, '3.40.850.10-FF-000354', NULL, 'Uncharacterized protein', 81, NULL, NULL, 160449),
(160450, '3.40.50.11610-FF-000017', NULL, '2-oxoglutarate dehydrogenase, mitochondrial', 143, NULL, NULL, 160450),
(160451, '2.10.25.10-FF-001477', NULL, 'Predicted protein', 39, NULL, NULL, 160451),
(160452, '1.25.40.10-FF-000661', NULL, 'UTP6 small subunit processome component', 189, NULL, NULL, 160452),
(160453, '3.75.10.10-FF-000039', NULL, NULL, 134, NULL, NULL, 160453),
(160454, '3.20.20.150-FF-000025', NULL, 'Hydroxypyruvate isomerase', 271, NULL, NULL, 160454),
(160455, '3.40.50.1980-FF-000142', NULL, 'Putative iron ABC transporter, periplasmic iron-binding protein', 96, NULL, NULL, 160455),
(160456, '3.40.190.10-FF-000472', NULL, 'Peptide/nickel transport system substrate-binding protein', 134, NULL, NULL, 160456),
(160457, '3.60.15.10-FF-000174', NULL, 'MBL fold metallo-hydrolase', 251, NULL, NULL, 160457),
(160458, '2.40.50.140-FF-000382', NULL, 'Cold shock protein 1', 72, NULL, NULL, 160458),
(160459, '3.20.20.190-FF-000104', NULL, 'Glycerophosphoryl diester phosphodiesterase family protein', 289, NULL, NULL, 160459),
(160460, '2.130.10.10-FF-004490', NULL, 'WD repeat domain 5B-like', 143, NULL, NULL, 160460),
(160461, '3.40.50.2300-FF-000614', NULL, 'Metabotropic GLutamate receptor family', 282, NULL, NULL, 160461),
(160462, '3.40.50.300-FF-002753', NULL, 'ABC transporter ATP-binding protein', 221, NULL, NULL, 160462),
(160463, '2.60.40.150-FF-000794', NULL, 'Os04g0644900 protein', 76, NULL, NULL, 160463),
(160464, '3.40.50.1820-FF-000083', NULL, 'Esterase YpfH', 206, NULL, NULL, 160464),
(160465, '3.40.190.10-FF-000702', NULL, 'ABC transporter substrate-binding protein', 119, NULL, NULL, 160465),
(160466, '3.80.10.10-FF-003585', NULL, 'Uncharacterized protein', 136, NULL, NULL, 160466),
(160467, '2.30.29.90-FF-000008', NULL, 'Exocyst complex component 1', 120, NULL, NULL, 160467),
(160468, '3.40.50.150-FF-000746', NULL, 'Uncharacterized protein', 269, NULL, NULL, 160468),
(160469, '3.40.50.300-FF-008576', NULL, 'Uncharacterized protein', 130, NULL, NULL, 160469),
(160470, '3.40.50.300-FF-001123', NULL, 'C-1-tetrahydrofolate synthase, cytoplasmic isoform X2', 272, NULL, NULL, 160470),
(160471, '1.20.1250.20-FF-001924', NULL, 'Uncharacterized protein', 220, NULL, NULL, 160471),
(160472, '2.60.120.200-FF-000711', NULL, 'Uncharacterized protein', 181, NULL, NULL, 160472),
(160473, '2.60.40.10-FF-005017', NULL, NULL, 105, NULL, NULL, 160473),
(160474, '3.80.10.10-FF-003950', NULL, 'Insulin like growth factor binding protein acid labile subunit', 67, NULL, NULL, 160474);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(160475, '1.20.58.1080-FF-000017', NULL, 'Uncharacterized protein', 93, NULL, NULL, 160475),
(160476, '3.20.20.100-FF-000134', NULL, 'Uncharacterized protein', 324, NULL, NULL, 160476),
(160477, '3.90.70.80-FF-000034', NULL, 'Uncharacterized protein', 182, NULL, NULL, 160477),
(160478, '2.40.50.140-FF-000073', NULL, 'DNA-directed RNA polymerases I, II, and III subunit RPABC3', 145, NULL, NULL, 160478),
(160479, '3.30.300.30-FF-000074', NULL, 'Non-ribosomal peptide synthetase', 101, NULL, NULL, 160479),
(160480, '2.60.40.60-FF-000676', NULL, 'Uncharacterized protein', 120, NULL, NULL, 160480),
(160481, '1.10.510.10-FF-004486', NULL, NULL, 241, NULL, NULL, 160481),
(160482, '4.10.400.10-FF-000020', NULL, 'LDL receptor related protein 1', 45, NULL, NULL, 160482),
(160483, '2.10.110.10-FF-000152', NULL, 'Four and a half LIM domains protein 2', 38, NULL, NULL, 160483),
(160484, '2.10.25.10-FF-000988', NULL, 'putative vitellogenin receptor', 36, NULL, NULL, 160484),
(160485, '1.25.10.10-FF-001215', NULL, 'Related to yeast Vacuolar Protein Sorting factor', 144, NULL, NULL, 160485),
(160486, '2.10.70.80-FF-000006', NULL, 'Sortilin', 51, NULL, NULL, 160486),
(160487, '1.20.120.20-FF-000011', NULL, 'Apolipoprotein A-IV b, tandem duplicate 2', 132, NULL, NULL, 160487),
(160488, '2.60.40.10-FF-002376', NULL, 'HYDIN, axonemal central pair apparatus protein', 108, NULL, NULL, 160488),
(160489, '3.10.330.10-FF-000024', NULL, 'AAA family ATPase peroxin 1', 81, NULL, NULL, 160489),
(160490, '3.40.50.1000-FF-000753', NULL, NULL, 20, NULL, NULL, 160490),
(160491, '2.40.50.700-FF-000010', NULL, NULL, 81, NULL, NULL, 160491),
(160492, '1.20.58.390-FF-000189', NULL, 'Predicted protein', 64, NULL, NULL, 160492),
(160493, '2.120.10.30-FF-000617', NULL, 'Uncharacterized protein', 71, NULL, NULL, 160493),
(160494, '1.20.120.1900-FF-000047', NULL, 'Spindle pole body component', 312, NULL, NULL, 160494),
(160495, '3.30.1640.30-FF-000014', NULL, NULL, 64, NULL, NULL, 160495),
(160496, '1.20.1260.10-FF-000005', NULL, 'Bacterioferritin', 158, NULL, NULL, 160496),
(160497, '2.120.10.30-FF-000527', NULL, 'Uncharacterized protein', 146, NULL, NULL, 160497),
(160498, '3.40.50.410-FF-000301', NULL, 'Uncharacterized protein', 172, NULL, NULL, 160498),
(160499, '1.20.1510.10-FF-000076', NULL, NULL, 64, NULL, NULL, 160499),
(160500, '3.40.50.620-FF-000701', NULL, 'Uncharacterized protein', 248, NULL, NULL, 160500),
(160501, '1.10.10.60-FF-001134', NULL, NULL, 61, NULL, NULL, 160501),
(160502, '1.25.40.280-FF-000012', NULL, 'BRO1-like domain/ALIX V-shaped domain binding to HIV, putative', 367, NULL, NULL, 160502),
(160503, '3.90.650.10-FF-000024', NULL, 'Phosphoribosylformylglycinamidine synthase', 174, NULL, NULL, 160503),
(160504, '3.30.420.40-FF-000507', NULL, 'O-sialoglycoprotein endopeptidase-like 1', 109, NULL, NULL, 160504),
(160505, '2.60.40.420-FF-000240', NULL, 'Uncharacterized protein', 113, NULL, NULL, 160505),
(160506, '2.10.10.100-FF-000003', NULL, 'UDP-N-acetylglucosamine pyrophosphorylase', 47, NULL, NULL, 160506),
(160507, '3.30.70.330-FF-000205', NULL, 'Sex lethal, isoform B', 89, NULL, NULL, 160507),
(160508, '3.30.450.30-FF-000006', NULL, 'Profilin', 139, NULL, NULL, 160508),
(160509, '1.10.150.20-FF-000009', NULL, 'Flap endonuclease 1', 68, NULL, NULL, 160509),
(160510, '1.20.5.710-FF-000015', NULL, '39S ribosomal protein L12, mitochondrial-like', 56, NULL, NULL, 160510),
(160511, '1.10.10.10-FF-001052', NULL, 'Protein CBG12577', 125, NULL, NULL, 160511),
(160512, '1.10.1420.10-FF-000066', NULL, 'DNA mismatch repair protein mutS, putative', 211, NULL, NULL, 160512),
(160513, '1.10.510.10-FF-001304', NULL, 'Kinase suppressor of Ras 2', 204, NULL, NULL, 160513),
(160514, '2.170.140.10-FF-000026', NULL, 'Blast:Peritrophin-1', 71, NULL, NULL, 160514),
(160515, '3.40.50.1820-FF-001864', NULL, 'Carboxylesterase, putative', 298, NULL, NULL, 160515),
(160516, '3.40.50.12780-FF-000104', NULL, 'Ochratoxin A non-ribosomal peptide synthetase', 142, NULL, NULL, 160516),
(160517, '2.90.10.10-FF-000046', NULL, 'Uncharacterized protein', 126, NULL, NULL, 160517);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(160518, '3.90.110.10-FF-000012', NULL, 'Malate dehydrogenase (NAD)', 184, NULL, NULL, 160518),
(160519, '3.30.70.330-FF-000845', NULL, 'CCR4-NOT transcription complex subunit 4, variant 1', 93, NULL, NULL, 160519),
(160520, '2.120.10.30-FF-000157', NULL, 'FI21413p1', 300, NULL, NULL, 160520),
(160521, '1.20.1070.10-FF-002059', NULL, 'Uncharacterized protein', 90, NULL, NULL, 160521),
(160522, '3.40.50.300-FF-000499', NULL, 'ATP-dependent DNA helicase', 266, NULL, NULL, 160522),
(160523, '1.10.220.150-FF-000074', NULL, 'Uncharacterized protein', 82, NULL, NULL, 160523),
(160524, '1.10.10.10-FF-000563', NULL, 'RNA polymerase sigma factor SigB', 54, NULL, NULL, 160524),
(160525, '3.40.50.970-FF-000227', NULL, 'Predicted protein', 295, NULL, NULL, 160525),
(160526, '3.40.50.2000-FF-000154', NULL, 'Glycosyltransferase', 195, NULL, NULL, 160526),
(160527, '1.25.40.10-FF-000677', NULL, 'Pentatricopeptide repeat-containing protein', 149, NULL, NULL, 160527),
(160528, '1.25.10.10-FF-002957', NULL, 'Exportin-T', 449, NULL, NULL, 160528),
(160529, '3.40.140.10-FF-000284', NULL, 'Predicted protein', 100, NULL, NULL, 160529),
(160530, '3.10.450.50-FF-000078', NULL, 'Uncharacterized protein', 166, NULL, NULL, 160530),
(160531, '3.50.7.10-FF-000090', NULL, NULL, 107, NULL, NULL, 160531),
(160532, '2.40.50.730-FF-000019', NULL, 'DNA polymerase', 104, NULL, NULL, 160532),
(160533, '3.30.900.10-FF-000052', NULL, 'Uncharacterized protein', 72, NULL, NULL, 160533),
(160534, '2.60.120.290-FF-000007', NULL, 'Metalloendopeptidase', 114, NULL, NULL, 160534),
(160535, '3.30.43.10-FF-000009', NULL, 'Glycolate oxidase, subunit GlcD', 98, NULL, NULL, 160535),
(160536, '1.10.510.10-FF-002934', NULL, 'Uncharacterized protein', 392, NULL, NULL, 160536),
(160537, '3.40.50.720-FF-002513', NULL, 'Uncharacterized protein', 124, NULL, NULL, 160537),
(160538, '1.20.1070.10-FF-000721', NULL, 'Uncharacterized protein', 111, NULL, NULL, 160538),
(160539, '3.30.160.60-FF-000897', NULL, 'Zinc finger and BTB domain-containing protein 21', 24, NULL, NULL, 160539),
(160540, '1.20.58.1880-FF-000027', NULL, 'Uncharacterized protein', 116, NULL, NULL, 160540),
(160541, '1.50.40.10-FF-000389', NULL, 'Protein CBG24187', 175, NULL, NULL, 160541),
(160542, '1.10.10.10-FF-000872', NULL, 'Probable hydrogen peroxide-inducible genes activator', 87, NULL, NULL, 160542),
(160543, '1.20.1250.10-FF-000140', NULL, NULL, 48, NULL, NULL, 160543),
(160544, '3.30.420.40-FF-000496', NULL, 'Hsp70 protein/TPR repeat/Tetratricopeptide repeat, putative', 105, NULL, NULL, 160544),
(160545, '1.25.40.10-FF-004404', NULL, 'Uncharacterized protein', 136, NULL, NULL, 160545),
(160546, '2.30.130.40-FF-000034', NULL, 'LON peptidase N-terminal domain and RING finger protein C14F5.10c', 116, NULL, NULL, 160546),
(160547, '3.30.70.330-FF-000166', NULL, 'Trna selenocysteine 1-associated protein 1', 78, NULL, NULL, 160547),
(160548, '1.20.1250.20-FF-000143', NULL, 'Protein NRT1/ PTR FAMILY 6.3', 531, NULL, NULL, 160548),
(160549, '2.60.40.420-FF-000116', NULL, 'Os02g0725500 protein', 106, NULL, NULL, 160549),
(160550, '3.20.20.140-FF-000022', NULL, 'Guanine deaminase', 311, NULL, NULL, 160550),
(160551, '3.40.50.300-FF-008267', NULL, 'Uncharacterized protein', 45, NULL, NULL, 160551),
(160552, '1.10.510.10-FF-001613', NULL, 'Serine/threonine-protein kinase VRK1', 410, NULL, NULL, 160552),
(160553, '3.30.450.20-FF-000003', NULL, 'Aryl hydrocarbon receptor nuclear translocator 2', 199, NULL, NULL, 160553),
(160554, '3.90.920.10-FF-000017', NULL, 'DNA primase small subunit PriS', 321, NULL, NULL, 160554),
(160555, '1.10.486.10-FF-000038', NULL, 'DNA helicase', 142, NULL, NULL, 160555),
(160556, '3.30.70.1730-FF-000013', NULL, '50S ribosomal protein L10', 115, NULL, NULL, 160556),
(160557, '2.10.110.10-FF-000242', NULL, 'YALI0A18381p', 73, NULL, NULL, 160557),
(160558, '2.40.128.130-FF-000008', NULL, 'Serine protease', 311, NULL, NULL, 160558),
(160559, '2.30.30.1190-FF-000003', NULL, 'Zinc finger CCCH domain-containing protein 17', 32, NULL, NULL, 160559),
(160560, '3.30.930.10-FF-000110', NULL, 'Lipoate-protein ligase B', 216, NULL, NULL, 160560);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(160561, '2.60.120.200-FF-000037', NULL, 'Meprin A subunit', 169, NULL, NULL, 160561),
(160562, '3.30.70.3040-FF-000002', NULL, 'Cell division protein FtsX', 109, NULL, NULL, 160562),
(160563, '1.25.10.10-FF-001322', NULL, 'Uncharacterized protein', 979, NULL, NULL, 160563),
(160564, '2.40.70.10-FF-000097', NULL, 'Aspartyl protease AED3', 192, NULL, NULL, 160564),
(160565, '1.20.58.1480-FF-000014', NULL, 'Lon protease', 127, NULL, NULL, 160565),
(160566, '3.40.225.10-FF-000003', NULL, 'Methylthioribulose-1-phosphate dehydratase', 219, NULL, NULL, 160566),
(160567, '3.30.40.10-FF-002122', NULL, 'Uncharacterized protein', 127, NULL, NULL, 160567),
(160568, '1.10.287.370-FF-000032', NULL, 'Prefoldin 5-like protein', 149, NULL, NULL, 160568),
(160569, '3.30.70.330-FF-000194', NULL, 'Eukaryotic translation initiation factor 3 subunit G', 137, NULL, NULL, 160569),
(160570, '3.30.200.20-FF-000827', NULL, 'Unplaced genomic scaffold supercont1.6, whole genome shotgun sequence', 114, NULL, NULL, 160570),
(160571, '3.50.50.60-FF-001001', NULL, 'Rab proteins geranylgeranyltransferase component A', 80, NULL, NULL, 160571),
(160572, '2.60.40.150-FF-000159', NULL, 'Synaptotagmin-7', 143, NULL, NULL, 160572),
(160573, '3.30.760.10-FF-000063', NULL, 'Putative translation initiation factor 4f cap-binding subunit eif-4e', 187, NULL, NULL, 160573),
(160574, '3.30.160.60-FF-004933', NULL, NULL, 29, NULL, NULL, 160574),
(160575, '2.30.30.150-FF-000001', NULL, 'Transcriptional repressor protein KorB', 62, NULL, NULL, 160575),
(160576, '3.30.230.10-FF-000326', NULL, 'Uncharacterized protein', 103, NULL, NULL, 160576),
(160577, '3.40.50.10540-FF-000011', NULL, 'GH11368p', 128, NULL, NULL, 160577),
(160578, '3.10.129.10-FF-000207', NULL, 'Uncharacterized protein', 132, NULL, NULL, 160578),
(160579, '3.30.160.60-FF-005006', NULL, NULL, 26, NULL, NULL, 160579),
(160580, '1.20.1740.10-FF-000031', NULL, 'Glutamate:gamma-aminobutyric acid antiporter', 475, NULL, NULL, 160580),
(160581, '1.10.287.80-FF-000018', NULL, 'ATP synthase gamma chain', 49, NULL, NULL, 160581),
(160582, '3.40.50.620-FF-000027', NULL, 'Cysteine--tRNA ligase, cytoplasmic', 333, NULL, NULL, 160582),
(160583, '1.25.40.10-FF-001060', NULL, 'Os05g0572900 protein', 178, NULL, NULL, 160583),
(160584, '2.60.40.10-FF-001302', NULL, 'Interleukin 1 receptor like 2', 99, NULL, NULL, 160584),
(160585, '3.10.450.700-FF-000007', NULL, 'Predicted protein', 74, NULL, NULL, 160585),
(160586, '1.25.40.120-FF-000020', NULL, 'Rab geranylgeranyltransferase alpha subunit, putative', 316, NULL, NULL, 160586),
(160587, '3.40.50.300-FF-008357', NULL, 'Uncharacterized protein', 118, NULL, NULL, 160587),
(160588, '3.10.20.90-FF-000583', NULL, 'Ubiquitin-like protein ATG12', 91, NULL, NULL, 160588),
(160589, '1.10.287.70-FF-000015', NULL, 'Calcium-activated potassium channel subunit alpha-1 isoform X7', 217, NULL, NULL, 160589),
(160590, '2.60.310.20-FF-000001', NULL, 'Tyrosinase', 158, NULL, NULL, 160590),
(160591, '3.30.70.1450-FF-000036', NULL, 'Calcium-gated potassium channel MthK', 78, NULL, NULL, 160591),
(160592, '3.30.565.10-FF-000317', NULL, 'DNA mismatch repair protein Mlh1 isoform X1', 219, NULL, NULL, 160592),
(160593, '2.60.120.590-FF-000002', NULL, 'RNA demethylase ALKBH5', 229, NULL, NULL, 160593),
(160594, '1.10.101.10-FF-000022', NULL, 'Spore cortex-lytic enzyme pre-pro-form', 76, NULL, NULL, 160594),
(160595, '1.25.40.20-FF-001063', NULL, 'Uncharacterized protein', 125, NULL, NULL, 160595),
(160596, '3.40.980.10-FF-000049', NULL, 'FAD synthase', 172, NULL, NULL, 160596),
(160597, '1.20.120.1750-FF-000159', NULL, 'RBR-type E3 ubiquitin transferase', 221, NULL, NULL, 160597),
(160598, '1.10.287.380-FF-000035', NULL, 'DNA-binding ATPase Uup', 82, NULL, NULL, 160598),
(160599, '2.60.40.10-FF-004484', NULL, NULL, 115, NULL, NULL, 160599),
(160600, '3.30.2450.30-FF-000005', NULL, 'Transcriptional activator protein Pur-alpha', 94, NULL, NULL, 160600),
(160601, '2.60.120.200-FF-000172', NULL, 'Adhesion G protein-coupled receptor G4', 191, NULL, NULL, 160601),
(160602, '3.40.50.2300-FF-000923', NULL, NULL, 203, NULL, NULL, 160602);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(160603, '3.40.50.150-FF-000763', NULL, 'DUF858-domain-containing protein', 238, NULL, NULL, 160603),
(160604, '1.25.40.10-FF-002454', NULL, 'Pentatricopeptide repeat-containing protein CRP1, chloroplastic', 59, NULL, NULL, 160604),
(160605, '1.10.238.10-FF-001036', NULL, 'Uncharacterized protein', 57, NULL, NULL, 160605),
(160606, '3.30.870.10-FF-000094', NULL, 'Competence protein ComE', 174, NULL, NULL, 160606),
(160607, '3.20.20.300-FF-000003', NULL, 'Beta-D-glucan exohydrolase isoenzyme ExoI', 376, NULL, NULL, 160607),
(160608, '1.10.8.270-FF-000099', NULL, 'Growth hormone-regulated TBC protein 1', 81, NULL, NULL, 160608),
(160609, '3.40.50.1000-FF-000663', NULL, NULL, 133, NULL, NULL, 160609),
(160610, '2.60.40.60-FF-000199', NULL, 'neural-cadherin isoform X1', 115, NULL, NULL, 160610),
(160611, '1.10.472.10-FF-000552', NULL, 'Uncharacterized protein', 73, NULL, NULL, 160611),
(160612, '2.40.50.120-FF-000050', NULL, 'Netrin 3', 86, NULL, NULL, 160612),
(160613, '1.25.40.20-FF-001153', NULL, 'Predicted protein', 141, NULL, NULL, 160613),
(160614, '1.25.40.10-FF-002678', NULL, 'NASP-related protein sim3', 305, NULL, NULL, 160614),
(160615, '3.80.10.10-FF-001668', NULL, 'Cytoplasmic membrane protein', 100, NULL, NULL, 160615),
(160616, '3.30.710.10-FF-000262', NULL, 'Assembly of substrate-specific ubiquitin ligase complexes modulator, putative', 123, NULL, NULL, 160616),
(160617, '3.40.50.300-FF-008593', NULL, 'Uncharacterized protein', 110, NULL, NULL, 160617),
(160618, '2.60.120.260-FF-000583', NULL, 'Uncharacterized protein', 165, NULL, NULL, 160618),
(160619, '3.30.70.660-FF-000051', NULL, 'tRNA pseudouridine synthase', 174, NULL, NULL, 160619),
(160620, '1.10.510.10-FF-002378', NULL, NULL, 137, NULL, NULL, 160620),
(160621, '3.40.50.970-FF-000222', NULL, '2-hydroxyacyl-CoA lyase 1', 56, NULL, NULL, 160621),
(160622, '2.40.10.10-FF-000469', NULL, NULL, 102, NULL, NULL, 160622),
(160623, '3.80.10.10-FF-004074', NULL, 'Uncharacterized protein', 129, NULL, NULL, 160623),
(160624, '3.40.630.10-FF-000366', NULL, 'Carboxypeptidase D, b', 125, NULL, NULL, 160624),
(160625, '2.20.100.10-FF-000025', NULL, 'ADAMTS like 1', 65, NULL, NULL, 160625),
(160626, '1.25.40.180-FF-000100', NULL, 'Pre-mRNA-splicing factor cwc22, putative', 291, NULL, NULL, 160626),
(160627, '1.20.1250.10-FF-000050', NULL, 'Chorionic somatomammotropin hormone 1', 199, NULL, NULL, 160627),
(160628, '3.40.50.300-FF-004670', NULL, 'Uncharacterized protein', 182, NULL, NULL, 160628),
(160629, '3.90.70.10-FF-000547', NULL, 'Predicted protein', 375, NULL, NULL, 160629),
(160630, '3.10.400.20-FF-000004', NULL, 'Eukaryotic Initiation Factor', 186, NULL, NULL, 160630),
(160631, '1.25.40.10-FF-004932', NULL, 'Os01g0390600 protein', 207, NULL, NULL, 160631),
(160632, '1.10.287.1060-FF-000010', NULL, 'conserved oligomeric Golgi complex subunit 4 isoform X2', 49, NULL, NULL, 160632),
(160633, '3.80.10.10-FF-000403', NULL, 'Receptor-like protein 2', 120, NULL, NULL, 160633),
(160634, '1.10.238.10-FF-000856', NULL, 'Defective in cullin neddylation protein', 127, NULL, NULL, 160634),
(160635, '1.25.10.10-FF-000850', NULL, 'Importin beta SMX1, putative', 924, NULL, NULL, 160635),
(160636, '1.20.5.1300-FF-000011', NULL, 'Putative histidinol dehydrogenase 2', 34, NULL, NULL, 160636),
(160637, '3.30.70.330-FF-000840', NULL, 'Uncharacterized protein, isoform E', 82, NULL, NULL, 160637),
(160638, '1.10.8.10-FF-000011', NULL, 'Non-specific serine/threonine protein kinase', 45, NULL, NULL, 160638),
(160639, '2.170.130.10-FF-000071', NULL, NULL, 134, NULL, NULL, 160639),
(160640, '3.30.1370.10-FF-000038', NULL, 'exosome complex component RRP40', 83, NULL, NULL, 160640),
(160641, '1.20.1560.10-FF-000017', NULL, 'Cystic fibrosis transmembrane conductance regulator', 331, NULL, NULL, 160641),
(160642, '3.30.160.60-FF-001263', NULL, 'zinc finger protein 341 isoform X1', 74, NULL, NULL, 160642),
(160643, '2.60.40.10-FF-002578', NULL, NULL, 85, NULL, NULL, 160643),
(160644, '2.40.50.140-FF-000056', NULL, '26S protease regulatory subunit 6A', 65, NULL, NULL, 160644);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(160645, '2.70.160.11-FF-000024', NULL, 'Arginine methyltransferase 8', 174, NULL, NULL, 160645),
(160646, '3.40.50.300-FF-003124', NULL, 'Uncharacterized protein, isoform A', 253, NULL, NULL, 160646),
(160647, '2.160.20.10-FF-000240', NULL, 'Exopolygalacturonase clone GBGE184', 197, NULL, NULL, 160647),
(160648, '2.70.40.10-FF-000037', NULL, 'Predicted protein', 143, NULL, NULL, 160648),
(160649, '1.25.40.10-FF-004623', NULL, 'Uncharacterized protein', 136, NULL, NULL, 160649),
(160650, '2.20.70.10-FF-000272', NULL, 'Uncharacterized protein', 36, NULL, NULL, 160650),
(160651, '2.130.10.10-FF-002887', NULL, 'Uncharacterized protein', 185, NULL, NULL, 160651),
(160652, '3.10.20.90-FF-000785', NULL, 'polycomb group protein Psc', 113, NULL, NULL, 160652),
(160653, '3.10.450.50-FF-000062', NULL, 'Austinol synthesis protein F', 139, NULL, NULL, 160653),
(160654, '2.60.120.260-FF-000274', NULL, 'O-GlcNAcase NagJ', 145, NULL, NULL, 160654),
(160655, '3.30.200.20-FF-000743', NULL, 'Non-specific serine/threonine protein kinase', 86, NULL, NULL, 160655),
(160656, '1.25.40.10-FF-001150', NULL, 'Pre-mRNA-splicing factor SYF1', 161, NULL, NULL, 160656),
(160657, '2.10.50.30-FF-000041', NULL, 'Uncharacterized protein', 76, NULL, NULL, 160657),
(160658, '3.40.50.300-FF-000960', NULL, 'Si:ch211-196f19.1', 237, NULL, NULL, 160658),
(160659, '1.10.10.440-FF-000098', NULL, 'Uncharacterized protein', 53, NULL, NULL, 160659),
(160660, '1.10.10.10-FF-000198', NULL, 'HTH-type transcriptional repressor AllR', 76, NULL, NULL, 160660),
(160661, '2.30.36.70-FF-000007', NULL, 'Actin-like 6a isoform 3', 25, NULL, NULL, 160661),
(160662, '1.10.238.10-FF-000963', NULL, 'Troponin C, isoform 2', 83, NULL, NULL, 160662),
(160663, '2.20.100.10-FF-000132', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs adt-2', 54, NULL, NULL, 160663),
(160664, '3.40.228.10-FF-000026', NULL, 'NADPH-Fe(3+) oxidoreductase subunit alpha', 195, NULL, NULL, 160664),
(160665, '1.25.10.10-FF-001232', NULL, 'armadillo repeat-containing protein 3', 193, NULL, NULL, 160665),
(160666, '3.30.2350.20-FF-000068', NULL, NULL, 211, NULL, NULL, 160666),
(160667, '3.30.450.20-FF-000110', NULL, 'Signal transduction histidine-protein kinase atoS', 109, NULL, NULL, 160667),
(160668, '1.10.510.10-FF-002687', NULL, NULL, 184, NULL, NULL, 160668),
(160669, '3.40.50.1820-FF-001645', NULL, 'Carboxylic ester hydrolase', 396, NULL, NULL, 160669),
(160670, '3.30.450.330-FF-000004', NULL, 'Stage V sporulation protein D', 129, NULL, NULL, 160670),
(160671, '1.20.272.10-FF-000091', NULL, NULL, 34, NULL, NULL, 160671),
(160672, '1.10.150.20-FF-000026', NULL, 'DNA polymerase beta', 57, NULL, NULL, 160672),
(160673, '3.40.1090.10-FF-000076', NULL, 'Patatin', 276, NULL, NULL, 160673),
(160674, '3.30.40.10-FF-001588', NULL, 'Uncharacterized protein', 85, NULL, NULL, 160674),
(160675, '2.40.340.10-FF-000027', NULL, NULL, 79, NULL, NULL, 160675),
(160676, '3.30.70.960-FF-000017', NULL, 'Mucin 13b, cell surface-associated', 96, NULL, NULL, 160676),
(160677, '1.10.3630.10-FF-000003', NULL, 'Golgi phosphoprotein 3', 180, NULL, NULL, 160677),
(160678, '2.60.40.10-FF-001274', NULL, 'tyrosine-protein phosphatase Lar isoform X1', 98, NULL, NULL, 160678),
(160679, '3.30.710.10-FF-000043', NULL, 'Zinc finger and BTB domain containing 7A', 156, NULL, NULL, 160679),
(160680, '2.130.10.10-FF-002578', NULL, 'Uncharacterized protein', 71, NULL, NULL, 160680),
(160681, '3.40.390.10-FF-000127', NULL, 'Predicted protein', 177, NULL, NULL, 160681),
(160682, '1.10.238.10-FF-000637', NULL, 'Putative calcium-binding protein CML20', 53, NULL, NULL, 160682),
(160683, '1.20.1510.10-FF-000071', NULL, NULL, 103, NULL, NULL, 160683),
(160684, '1.20.1070.10-FF-001368', NULL, 'Uncharacterized protein', 259, NULL, NULL, 160684),
(160685, '2.110.10.10-FF-000056', NULL, 'Hemopexin b', 140, NULL, NULL, 160685),
(160686, '3.40.50.720-FF-002058', NULL, 'Dehydrogenase, putative', 168, NULL, NULL, 160686),
(160687, '3.40.50.300-FF-002977', NULL, 'Uncharacterized protein', 239, NULL, NULL, 160687);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(160688, '3.10.20.90-FF-000476', NULL, 'Ubiquitin-like protein SUMO', 99, NULL, NULL, 160688),
(160689, '3.30.2070.10-FF-000010', NULL, 'Thiosulfate reductase', 61, NULL, NULL, 160689),
(160690, '3.40.50.2300-FF-000137', NULL, 'Histidine kinase 3', 147, NULL, NULL, 160690),
(160691, '1.10.8.60-FF-000110', NULL, 'Ribosome biogenesis ATPase RIX7', 97, NULL, NULL, 160691),
(160692, '3.40.50.880-FF-000184', NULL, 'Anthranilate synthase component II', 189, NULL, NULL, 160692),
(160693, '3.40.50.2000-FF-000171', NULL, 'Glycosyltransferase', 182, NULL, NULL, 160693),
(160694, '1.20.1070.10-FF-001716', NULL, 'Mu-opioid receptor', 101, NULL, NULL, 160694),
(160695, '3.20.140.10-FF-000035', NULL, 'Uncharacterized protein', 443, NULL, NULL, 160695),
(160696, '3.40.50.300-FF-005810', NULL, 'Uncharacterized protein', 251, NULL, NULL, 160696),
(160697, '3.10.50.10-FF-000061', NULL, 'Uncharacterized protein', 67, NULL, NULL, 160697),
(160698, '3.30.160.60-FF-004826', NULL, NULL, 77, NULL, NULL, 160698),
(160699, '2.60.40.10-FF-002269', NULL, 'Myotactin form B', 100, NULL, NULL, 160699),
(160700, '1.20.1080.10-FF-000014', NULL, 'Aquaporin 1', 265, NULL, NULL, 160700),
(160701, '3.10.20.90-FF-000818', NULL, 'Autophagy-related protein', 119, NULL, NULL, 160701),
(160702, '3.30.420.40-FF-000479', NULL, 'Glycerol kinase', 232, NULL, NULL, 160702),
(160703, '3.30.40.10-FF-000177', NULL, 'PHD finger protein ING', 58, NULL, NULL, 160703),
(160704, '1.10.238.10-FF-000873', NULL, 'Uncharacterized protein', 65, NULL, NULL, 160704),
(160705, '1.20.1070.10-FF-001896', NULL, 'Predicted protein', 337, NULL, NULL, 160705),
(160706, '3.30.465.10-FF-000124', NULL, 'Uncharacterized protein', 78, NULL, NULL, 160706),
(160707, '3.40.50.300-FF-005501', NULL, 'Helicase conserved C-terminal domain containing protein', 178, NULL, NULL, 160707),
(160708, '2.60.210.10-FF-000047', NULL, NULL, 131, NULL, NULL, 160708),
(160709, '3.30.2350.10-FF-000065', NULL, 'YALI0B01276p', 225, NULL, NULL, 160709),
(160710, '1.20.1700.10-FF-000006', NULL, 'Pantothenate kinase 4', 63, NULL, NULL, 160710),
(160711, '2.10.25.10-FF-001680', NULL, 'Uncharacterized protein', 44, NULL, NULL, 160711),
(160712, '3.40.50.620-FF-000246', NULL, 'NH3-dependent NAD+ synthetase', 283, NULL, NULL, 160712),
(160713, '3.40.50.80-FF-000131', NULL, 'Mitochondrial NADH-dependent fumarate reductase', 128, NULL, NULL, 160713),
(160714, '3.80.10.10-FF-000061', NULL, 'leucine-rich repeat-containing protein 7 isoform X1', 112, NULL, NULL, 160714),
(160715, '3.50.50.60-FF-000506', NULL, 'peroxisomal N(1)-acetyl-spermine/spermidine oxidase', 108, NULL, NULL, 160715),
(160716, '1.20.1070.10-FF-001677', NULL, 'Predicted protein', 121, NULL, NULL, 160716),
(160717, '1.10.150.170-FF-000012', NULL, NULL, 107, NULL, NULL, 160717),
(160718, '3.30.70.270-FF-000041', NULL, 'Uncharacterized protein', 83, NULL, NULL, 160718),
(160719, '1.10.510.10-FF-001630', NULL, 'KIT proto-oncogene receptor tyrosine kinase', 283, NULL, NULL, 160719),
(160720, '3.30.70.330-FF-002329', NULL, NULL, 113, NULL, NULL, 160720),
(160721, '1.25.40.10-FF-000880', NULL, 'Pentatricopeptide (PPR) repeat-containing protein-like', 99, NULL, NULL, 160721),
(160722, '2.60.120.200-FF-000256', NULL, 'Galectin', 144, NULL, NULL, 160722),
(160723, '3.40.30.10-FF-001227', NULL, 'Uncharacterized protein', 115, NULL, NULL, 160723),
(160724, '2.40.70.10-FF-000136', NULL, 'Putative nucleoid DNA-binding protein cnd41, chloroplast', 163, NULL, NULL, 160724),
(160725, '2.10.25.10-FF-000050', NULL, 'neurogenic locus notch homolog protein 3', 37, NULL, NULL, 160725),
(160726, '3.40.50.2000-FF-000822', NULL, 'Uncharacterized protein', 199, NULL, NULL, 160726),
(160727, '1.10.420.10-FF-000016', NULL, 'Peroxidase', 152, NULL, NULL, 160727),
(160728, '1.25.40.20-FF-000883', NULL, 'E3 ubiquitin-protein ligase KEG', 125, NULL, NULL, 160728),
(160729, '3.30.70.330-FF-002083', NULL, NULL, 134, NULL, NULL, 160729),
(160730, '3.10.20.10-FF-000014', NULL, '60S ribosomal protein L18a (partial)', 30, NULL, NULL, 160730),
(160731, '3.40.50.300-FF-002758', NULL, 'Ras-related protein Rab-1A, putative', 192, NULL, NULL, 160731);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(160732, '3.40.50.300-FF-006468', NULL, 'Ferric transport protein', 119, NULL, NULL, 160732),
(160733, '1.10.1300.10-FF-000012', NULL, 'Phosphodiesterase', 364, NULL, NULL, 160733),
(160734, '1.25.10.10-FF-001013', NULL, 'Uncharacterized ARM-like repeat-containing protein C1703.03c', 588, NULL, NULL, 160734),
(160735, '2.40.50.140-FF-000617', NULL, '30S ribosomal protein S1', 77, NULL, NULL, 160735),
(160736, '2.130.10.10-FF-003989', NULL, 'Uncharacterized protein', 231, NULL, NULL, 160736),
(160737, '3.60.20.10-FF-000141', NULL, 'Asparagine synthetase, putative', 197, NULL, NULL, 160737),
(160738, '3.40.50.1220-FF-000009', NULL, 'Pyruvate decarboxylase 1', 162, NULL, NULL, 160738),
(160739, '3.30.40.10-FF-001279', NULL, 'Uncharacterized protein', 63, NULL, NULL, 160739),
(160740, '3.10.20.70-FF-000009', NULL, 'Glutamate-ammonia ligase', 97, NULL, NULL, 160740),
(160741, '3.90.79.10-FF-000067', NULL, 'Nudix hydrolase 16', 146, NULL, NULL, 160741),
(160742, '3.90.70.10-FF-000873', NULL, 'Uncharacterized protein', 63, NULL, NULL, 160742),
(160743, '1.20.58.310-FF-000002', NULL, 'Polyphosphate kinase', 104, NULL, NULL, 160743),
(160744, '2.60.260.20-FF-000025', NULL, 'Molecular chaperone Hsp40/DnaJ family protein', 93, NULL, NULL, 160744),
(160745, '3.30.70.330-FF-000621', NULL, 'Nuclear localization sequence-binding protein', 161, NULL, NULL, 160745),
(160746, '1.20.58.2190-FF-000002', NULL, 'spermatogenesis-associated protein 2', 215, NULL, NULL, 160746),
(160747, '3.30.160.60-FF-001044', NULL, 'Zinc finger protein', 28, NULL, NULL, 160747),
(160748, '2.60.40.10-FF-002359', NULL, 'Protein sidekick homolog', 105, NULL, NULL, 160748),
(160749, '1.10.10.1420-FF-000010', NULL, NULL, 129, NULL, NULL, 160749),
(160750, '3.40.50.300-FF-008374', NULL, 'Uncharacterized protein', 193, NULL, NULL, 160750),
(160751, '2.30.30.40-FF-000199', NULL, 'Sorting nexin', 70, NULL, NULL, 160751),
(160752, '3.10.110.10-FF-000171', NULL, 'Uncharacterized protein', 174, NULL, NULL, 160752),
(160753, '3.100.10.10-FF-000013', NULL, '50S ribosomal protein L18e', 117, NULL, NULL, 160753),
(160754, '1.20.1250.20-FF-000036', NULL, 'Hexuronate transporter', 198, NULL, NULL, 160754),
(160755, '2.10.109.10-FF-000070', NULL, 'Predicted protein', 99, NULL, NULL, 160755),
(160756, '3.40.50.11210-FF-000004', NULL, 'Tuberin isoform X3', 185, NULL, NULL, 160756),
(160757, '3.40.630.10-FF-000282', NULL, 'Predicted protein', 55, NULL, NULL, 160757),
(160758, '3.40.50.2000-FF-000261', NULL, 'Putative glycosyl transferase', 208, NULL, NULL, 160758),
(160759, '3.30.70.330-FF-002638', NULL, NULL, 122, NULL, NULL, 160759),
(160760, '2.40.70.10-FF-000445', NULL, NULL, 67, NULL, NULL, 160760),
(160761, '3.30.710.10-FF-000352', NULL, 'SKP1-like protein 13', 154, NULL, NULL, 160761),
(160762, '3.30.40.10-FF-002212', NULL, 'E3 ubiquitin-protein ligase mind-bomb-like Protein', 70, NULL, NULL, 160762),
(160763, '3.30.300.180-FF-000005', NULL, 'Chromosomal replication initiator protein DnaA', 78, NULL, NULL, 160763),
(160764, '3.90.1280.20-FF-000003', NULL, 'Chloride channel protein', 64, NULL, NULL, 160764),
(160765, '3.10.129.10-FF-000180', NULL, 'Uncharacterized protein', 133, NULL, NULL, 160765),
(160766, '1.20.1070.10-FF-000266', NULL, 'Atypical chemokine receptor 1', 274, NULL, NULL, 160766),
(160767, '3.40.5.60-FF-000009', NULL, 'DNA replication complex GINS protein sld5', 55, NULL, NULL, 160767),
(160768, '3.40.190.10-FF-000337', NULL, 'ABC transporter, periplasmic substrate-binding protein YnjB', 145, NULL, NULL, 160768),
(160769, '1.25.40.20-FF-001714', NULL, 'Uncharacterized protein', 48, NULL, NULL, 160769),
(160770, '3.80.10.10-FF-002511', NULL, 'Tubulin-specific chaperone E-like Protein', 97, NULL, NULL, 160770),
(160771, '3.30.470.20-FF-000201', NULL, 'Uncharacterized protein', 81, NULL, NULL, 160771),
(160772, '3.30.70.1350-FF-000006', NULL, 'Cation transporter', 79, NULL, NULL, 160772),
(160773, '2.130.10.10-FF-000780', NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', 360, NULL, NULL, 160773),
(160774, '3.40.630.10-FF-000057', NULL, 'Vacuolar membrane protease', 300, NULL, NULL, 160774);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(160775, '2.30.30.140-FF-000104', NULL, 'Unplaced genomic scaffold supercont2.8, whole genome shotgun sequence', 94, NULL, NULL, 160775),
(160776, '3.30.1520.10-FF-000191', NULL, 'Uncharacterized protein', 69, NULL, NULL, 160776),
(160777, '3.30.1370.50-FF-000027', NULL, 'G-patch and R3H domain-containing protein C30B4.02c', 75, NULL, NULL, 160777),
(160778, '3.30.160.60-FF-003516', NULL, NULL, 26, NULL, NULL, 160778),
(160779, '1.20.1510.10-FF-000093', NULL, NULL, 169, NULL, NULL, 160779),
(160780, '1.10.510.10-FF-000809', NULL, 'Serine/threonine-protein kinase-like protein At5g23170', 209, NULL, NULL, 160780),
(160781, '2.30.29.30-FF-000131', NULL, 'Kinesin-like calmodulin-binding protein (ZWICHEL)', 110, NULL, NULL, 160781),
(160782, '3.40.50.1820-FF-001729', NULL, 'Uncharacterized protein', 95, NULL, NULL, 160782),
(160783, '2.120.10.30-FF-000488', NULL, 'Uncharacterized protein', 277, NULL, NULL, 160783),
(160784, '3.30.160.60-FF-002898', NULL, 'endothelial zinc finger protein induced by tumor necrosis factor alpha', 27, NULL, NULL, 160784),
(160785, '3.10.20.70-FF-000026', NULL, 'Extracellular developmental signal biosynthesis protein FluG', 95, NULL, NULL, 160785),
(160786, '2.70.20.10-FF-000019', NULL, 'DNA topoisomerase I', 137, NULL, NULL, 160786),
(160787, '1.10.510.10-FF-001271', NULL, 'Putative serine/threonine protein kinase', 302, NULL, NULL, 160787),
(160788, '3.50.50.60-FF-000495', NULL, 'Putative dihydrolipoamide dehydrogenase', 121, NULL, NULL, 160788),
(160789, '3.10.200.10-FF-000020', NULL, NULL, 179, NULL, NULL, 160789),
(160790, '3.30.70.1050-FF-000017', NULL, 'Trigger factor', 112, NULL, NULL, 160790),
(160791, '3.40.366.10-FF-000021', NULL, 'Malonyl-CoA:ACP transferase', 146, NULL, NULL, 160791),
(160792, '3.40.50.300-FF-001196', NULL, 'ATP-dependent helicase/nuclease subunit A', 188, NULL, NULL, 160792),
(160793, '2.30.42.10-FF-000633', NULL, NULL, 68, NULL, NULL, 160793),
(160794, '3.50.50.100-FF-000055', NULL, 'Uncharacterized protein', 408, NULL, NULL, 160794),
(160795, '3.40.190.10-FF-000028', NULL, 'Arogenate dehydratase', 89, NULL, NULL, 160795),
(160796, '1.20.5.190-FF-000039', NULL, 'Myosin VB', 52, NULL, NULL, 160796),
(160797, '2.60.220.50-FF-000082', NULL, 'Uncharacterized protein', 79, NULL, NULL, 160797),
(160798, '2.40.50.90-FF-000181', NULL, 'Uncharacterized protein', 92, NULL, NULL, 160798),
(160799, '3.90.150.10-FF-000003', NULL, 'Variant surface glycoprotein (VSG), putative', 204, NULL, NULL, 160799),
(160800, '1.25.40.820-FF-000016', NULL, 'Putative RNA polymerase II subunit B1 CTD phosphatase RPAP2', 158, NULL, NULL, 160800),
(160801, '1.20.1530.20-FF-000108', NULL, 'Uncharacterized protein', 404, NULL, NULL, 160801),
(160802, '3.30.300.30-FF-000001', NULL, 'DIP2 disco-interacting protein 2 homolog C', 111, NULL, NULL, 160802),
(160803, '3.40.50.2000-FF-000715', NULL, 'Glycosyl transferase group 1', 159, NULL, NULL, 160803),
(160804, '1.10.357.50-FF-000021', NULL, 'Exocyst complex component Sec6-domain-containing protein', 220, NULL, NULL, 160804),
(160805, '3.40.228.10-FF-000004', NULL, 'Dimethyl sulfoxide reductase subunit A', 228, NULL, NULL, 160805),
(160806, '2.10.25.10-FF-000044', NULL, 'Fibrillin 2', 84, NULL, NULL, 160806),
(160807, '1.20.58.60-FF-000434', NULL, 'Spectrin beta', 104, NULL, NULL, 160807),
(160808, '3.40.50.670-FF-000020', NULL, 'DNA topoisomerase II', 94, NULL, NULL, 160808),
(160809, '1.20.58.1080-FF-000001', NULL, 'ATP-dependent RNA helicase SUPV3L1, mitochondrial', 110, NULL, NULL, 160809),
(160810, '2.120.10.30-FF-000073', NULL, 'Protein STRICTOSIDINE SYNTHASE-LIKE 6', 310, NULL, NULL, 160810),
(160811, '1.10.274.100-FF-000032', NULL, 'RNA polymerase II largest subunit', 153, NULL, NULL, 160811),
(160812, '3.30.420.40-FF-000586', NULL, 'Actin, putative', 107, NULL, NULL, 160812),
(160813, '3.30.200.20-FF-000518', NULL, 'Tyrosine-protein kinase', 92, NULL, NULL, 160813),
(160814, '1.10.10.60-FF-000437', NULL, 'pathogenesis-related homeodomain protein', 65, NULL, NULL, 160814),
(160815, '3.40.50.300-FF-006575', NULL, 'Predicted protein', 100, NULL, NULL, 160815);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(160816, '3.40.50.300-FF-004866', NULL, 'ATP-dependent helicase, putative', 64, NULL, NULL, 160816),
(160817, '1.25.10.10-FF-002087', NULL, 'Uncharacterized protein', 219, NULL, NULL, 160817),
(160818, '3.30.70.560-FF-000021', NULL, 'Uncharacterized protein', 193, NULL, NULL, 160818),
(160819, '1.10.40.80-FF-000001', NULL, 'DsbA family protein', 64, NULL, NULL, 160819),
(160820, '1.20.1250.20-FF-001469', NULL, 'Putative monocarboxylate transporter 3 monocarboxylate transporter 3', 214, NULL, NULL, 160820),
(160821, '3.30.70.270-FF-000035', NULL, 'Diguanylate cyclase YdeH', 166, NULL, NULL, 160821),
(160822, '3.30.565.10-FF-000087', NULL, 'Histidine kinase 1', 181, NULL, NULL, 160822),
(160823, '3.80.10.10-FF-004220', NULL, 'Uncharacterized protein', 84, NULL, NULL, 160823),
(160824, '3.20.20.150-FF-000008', NULL, 'Protein arginine N-methyltransferase 5', 292, NULL, NULL, 160824),
(160825, '1.10.510.10-FF-000916', NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 42', 86, NULL, NULL, 160825),
(160826, '3.90.20.20-FF-000002', NULL, 'Protein GrpE', 129, NULL, NULL, 160826),
(160827, '3.40.850.10-FF-000371', NULL, 'Kinesin-like protein', 332, NULL, NULL, 160827),
(160828, '2.60.120.650-FF-000149', NULL, 'Uncharacterized protein', 213, NULL, NULL, 160828),
(160829, '3.30.1010.10-FF-000118', NULL, 'Uncharacterized protein', 235, NULL, NULL, 160829),
(160830, '3.60.15.10-FF-000213', NULL, 'DNA repair metallo-beta-lactamase family protein', 20, NULL, NULL, 160830),
(160831, '3.10.20.90-FF-000892', NULL, 'Uncharacterized protein', 47, NULL, NULL, 160831),
(160832, '3.30.70.330-FF-002419', NULL, NULL, 91, NULL, NULL, 160832),
(160833, '1.10.720.80-FF-000003', NULL, 'Uncharacterized protein', 76, NULL, NULL, 160833),
(160834, '2.40.170.20-FF-000096', NULL, 'SusC/RagA family TonB-linked outer membrane protein', 650, NULL, NULL, 160834),
(160835, '3.100.10.10-FF-000007', NULL, '50S ribosomal protein L15', 86, NULL, NULL, 160835),
(160836, '2.40.50.140-FF-000415', NULL, 'Single-stranded DNA-binding protein', 113, NULL, NULL, 160836),
(160837, '3.90.226.10-FF-000264', NULL, 'Nodulation efficiency, NfeD', 184, NULL, NULL, 160837),
(160838, '1.10.730.10-FF-000118', NULL, 'Methionine--tRNA ligase', 173, NULL, NULL, 160838),
(160839, '3.80.10.10-FF-000257', NULL, 'F-box protein FBW2', 210, NULL, NULL, 160839),
(160840, '1.10.472.10-FF-000136', NULL, 'Cyclin 4', 149, NULL, NULL, 160840),
(160841, '3.30.70.580-FF-000027', NULL, 'tRNA pseudouridine synthase', 120, NULL, NULL, 160841),
(160842, '3.30.559.10-FF-000027', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 242, NULL, NULL, 160842),
(160843, '3.30.70.1390-FF-000012', NULL, 'Roco6, ROCO family protein', 63, NULL, NULL, 160843),
(160844, '1.20.5.110-FF-000021', NULL, 'novel plant SNARE 11', 80, NULL, NULL, 160844),
(160845, '3.40.1280.10-FF-000085', NULL, 'tRNA/rRNA methyltransferase (SpoU)', 163, NULL, NULL, 160845),
(160846, '3.40.50.1000-FF-000769', NULL, NULL, 117, NULL, NULL, 160846),
(160847, '3.30.40.10-FF-000194', NULL, 'ERAD-associated E3 ubiquitin-protein ligase HRD1A', 76, NULL, NULL, 160847),
(160848, '3.30.200.20-FF-000266', NULL, 'probable serine/threonine-protein kinase RLCKVII', 105, NULL, NULL, 160848),
(160849, '2.130.10.10-FF-004580', NULL, 'AGAP007799-PA', 209, NULL, NULL, 160849),
(160850, '1.10.10.10-FF-001142', NULL, 'Protein CBG24678', 87, NULL, NULL, 160850),
(160851, '3.40.50.720-FF-000260', NULL, 'Prephenate dehydrogenase', 167, NULL, NULL, 160851),
(160852, '1.10.3380.20-FF-000014', NULL, NULL, 124, NULL, NULL, 160852),
(160853, '2.40.20.10-FF-000077', NULL, 'Putative macrophage stimulating 1-like protein', 102, NULL, NULL, 160853),
(160854, '3.30.413.10-FF-000004', NULL, 'Sulfite reductase [NADPH] hemoprotein beta-component', 196, NULL, NULL, 160854),
(160855, '3.90.190.10-FF-000112', NULL, 'Tyrosine-protein phosphatase CDC14 homolog', 146, NULL, NULL, 160855),
(160856, '3.20.20.100-FF-000151', NULL, 'Uncharacterized protein', 263, NULL, NULL, 160856),
(160857, '3.40.50.10810-FF-000199', NULL, 'Protein CBR-RAD-54', 182, NULL, NULL, 160857);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(160858, '2.60.120.200-FF-000481', NULL, 'MAM and LDL-receptor class A domain-containing protein 1', 76, NULL, NULL, 160858),
(160859, '3.40.50.2300-FF-000159', NULL, 'Two-component response regulator ORR5', 126, NULL, NULL, 160859),
(160860, '3.30.70.1450-FF-000053', NULL, 'Predicted protein', 69, NULL, NULL, 160860),
(160861, '1.25.10.10-FF-000743', NULL, 'Cytoplasmic export protein', 307, NULL, NULL, 160861),
(160862, '2.60.40.10-FF-000796', NULL, 'Muscle M-line assembly protein unc-89', 96, NULL, NULL, 160862),
(160863, '3.30.160.60-FF-000774', NULL, 'Zinc finger protein', 30, NULL, NULL, 160863),
(160864, '3.30.70.260-FF-000032', NULL, 'UPF0237 protein SP_0238', 89, NULL, NULL, 160864),
(160865, '2.60.40.10-FF-004068', NULL, NULL, 97, NULL, NULL, 160865),
(160866, '1.10.3380.30-FF-000017', NULL, 'DEAD/DEAH box helicase, putative', 223, NULL, NULL, 160866),
(160867, '3.30.40.10-FF-002228', NULL, 'Uncharacterized protein', 65, NULL, NULL, 160867),
(160868, '2.60.40.10-FF-002937', NULL, 'Uncharacterized protein', 81, NULL, NULL, 160868),
(160869, '3.60.20.10-FF-000034', NULL, 'Proteasome subunit beta', 210, NULL, NULL, 160869),
(160870, '2.40.50.140-FF-000724', NULL, NULL, 69, NULL, NULL, 160870),
(160871, '3.40.1110.10-FF-000101', NULL, 'Phospholipid-transporting ATPase', 29, NULL, NULL, 160871),
(160872, '2.130.10.10-FF-002808', NULL, 'WDR11 isoform 12', 168, NULL, NULL, 160872),
(160873, '1.10.510.10-FF-004177', NULL, NULL, 185, NULL, NULL, 160873),
(160874, '2.60.120.260-FF-000268', NULL, 'netrin-G2 isoform X1', 283, NULL, NULL, 160874),
(160875, '2.40.30.170-FF-000049', NULL, NULL, 99, NULL, NULL, 160875),
(160876, '1.25.10.10-FF-000378', NULL, 'Condensin complex subunit 1', 228, NULL, NULL, 160876),
(160877, '3.30.1910.20-FF-000004', NULL, 'Uncharacterized protein', 60, NULL, NULL, 160877),
(160878, '2.20.70.10-FF-000069', NULL, 'Neural precursor cell expressed, developmentally down-regulated 4-like', 57, NULL, NULL, 160878),
(160879, '3.30.70.330-FF-000514', NULL, 'Small nuclear ribonucleoprotein 70 (U1)', 74, NULL, NULL, 160879),
(160880, '3.40.50.970-FF-000205', NULL, 'Pyruvate dehydrogenase E1 component subunit beta, mitochondrial', 35, NULL, NULL, 160880),
(160881, '2.60.40.10-FF-002685', NULL, 'Tyrosine-protein kinase receptor', 107, NULL, NULL, 160881),
(160882, '2.60.40.10-FF-003303', NULL, 'Leukemia inhibitory factor receptor alpha b', 85, NULL, NULL, 160882),
(160883, '3.90.470.10-FF-000044', NULL, 'Uncharacterized protein', 116, NULL, NULL, 160883),
(160884, '3.40.50.20-FF-000028', NULL, 'D-alanine-D-alanine ligase family', 175, NULL, NULL, 160884),
(160885, '3.30.230.10-FF-000124', NULL, 'Ribonuclease P protein component', 118, NULL, NULL, 160885),
(160886, '1.20.1270.60-FF-000015', NULL, 'Islet cell autoantigen 1, 69kDa', 201, NULL, NULL, 160886),
(160887, '3.30.1050.10-FF-000025', NULL, 'GG11567', 115, NULL, NULL, 160887),
(160888, '2.130.10.10-FF-003270', NULL, 'Uncharacterized protein', 174, NULL, NULL, 160888),
(160889, '1.10.8.80-FF-000009', NULL, 'ATPase, MoxR family', 113, NULL, NULL, 160889),
(160890, '3.30.420.40-FF-000838', NULL, 'Uncharacterized protein', 159, NULL, NULL, 160890),
(160891, '1.20.1250.20-FF-001582', NULL, 'MFS general substrate transporter', 335, NULL, NULL, 160891),
(160892, '3.90.780.10-FF-000034', NULL, 'Putative 5-nucleotidase/2,3-cyclic phosphodiesterase', 189, NULL, NULL, 160892),
(160893, '3.40.50.300-FF-006794', NULL, 'Uncharacterized protein', 56, NULL, NULL, 160893),
(160894, '2.130.10.10-FF-004832', NULL, 'Uncharacterized protein', 134, NULL, NULL, 160894),
(160895, '3.40.850.10-FF-000039', NULL, 'Kinesin-like protein', 379, NULL, NULL, 160895),
(160896, '2.130.10.10-FF-000448', NULL, 'U3 small nucleolar RNA-associated protein 15 homolog', 193, NULL, NULL, 160896),
(160897, '2.60.40.10-FF-003073', NULL, 'Immunoglobulin superfamily member 3-like', 130, NULL, NULL, 160897),
(160898, '1.10.8.1320-FF-000002', NULL, 'Envelope glycoprotein', 65, NULL, NULL, 160898),
(160899, '2.60.40.10-FF-004832', NULL, NULL, 97, NULL, NULL, 160899),
(160900, '3.40.50.300-FF-008609', NULL, 'Predicted protein', 104, NULL, NULL, 160900);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(160901, '2.60.40.60-FF-000985', NULL, 'Uncharacterized protein', 98, NULL, NULL, 160901),
(160902, '3.40.190.10-FF-000781', NULL, 'Extracellular solute-binding protein family 5', 254, NULL, NULL, 160902),
(160903, '2.40.160.10-FF-000064', NULL, 'Uncharacterized protein', 224, NULL, NULL, 160903),
(160904, '3.30.750.24-FF-000025', NULL, 'Anti-sigma factor antagonist', 110, NULL, NULL, 160904),
(160905, '1.20.1310.10-FF-000089', NULL, 'Cullin family protein', 136, NULL, NULL, 160905),
(160906, '3.30.160.60-FF-006389', NULL, NULL, 71, NULL, NULL, 160906),
(160907, '3.90.470.40-FF-000002', NULL, 'DNA damage-inducible transcript 4-like protein', 136, NULL, NULL, 160907),
(160908, '1.20.1250.20-FF-000053', NULL, 'Nitrate transporter 2.1', 202, NULL, NULL, 160908),
(160909, '3.30.830.10-FF-000327', NULL, 'Protein CBG17023', 65, NULL, NULL, 160909),
(160910, '1.25.10.10-FF-002396', NULL, 'Uncharacterized protein', 259, NULL, NULL, 160910),
(160911, '3.90.180.10-FF-000140', NULL, 'Uncharacterized protein', 158, NULL, NULL, 160911),
(160912, '3.40.50.300-FF-003141', NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', 137, NULL, NULL, 160912),
(160913, '2.10.109.10-FF-000053', NULL, 'Repressor protein cI', 133, NULL, NULL, 160913),
(160914, '3.30.200.20-FF-002396', NULL, 'Uncharacterized protein', 132, NULL, NULL, 160914),
(160915, '1.20.1250.20-FF-000704', NULL, 'Uncharacterized protein', 442, NULL, NULL, 160915),
(160916, '1.10.238.10-FF-001019', NULL, 'Uncharacterized protein', 111, NULL, NULL, 160916),
(160917, '3.40.30.10-FF-001244', NULL, 'Protein disulfide isomerase family A member 2', 71, NULL, NULL, 160917),
(160918, '3.40.50.2300-FF-000272', NULL, 'Guanylate cyclase', 146, NULL, NULL, 160918),
(160919, '3.30.450.190-FF-000018', NULL, 'Uncharacterized protein', 130, NULL, NULL, 160919),
(160920, '2.60.40.150-FF-000485', NULL, 'Copine 7', 85, NULL, NULL, 160920),
(160921, '1.10.8.60-FF-000003', NULL, 'Chromosomal replication initiator protein DnaA', 71, NULL, NULL, 160921),
(160922, '1.10.510.10-FF-001052', NULL, 'FERM and PDZ domain containing 2', 203, NULL, NULL, 160922),
(160923, '1.25.40.20-FF-001607', NULL, 'Uncharacterized protein', 108, NULL, NULL, 160923),
(160924, '1.20.120.230-FF-000067', NULL, 'Talin-A', 121, NULL, NULL, 160924),
(160925, '2.60.40.10-FF-001049', NULL, 'Down syndrome cell adhesion molecule-like protein Dscam2', 86, NULL, NULL, 160925),
(160926, '3.40.50.300-FF-003702', NULL, 'ABC transporter, putative', 119, NULL, NULL, 160926),
(160927, '4.10.60.10-FF-000065', NULL, 'A/G-specific adenine DNA glycosylase', 51, NULL, NULL, 160927),
(160928, '2.40.50.140-FF-000943', NULL, NULL, 81, NULL, NULL, 160928),
(160929, '1.10.472.80-FF-000100', NULL, 'TBC1 domain protein', 135, NULL, NULL, 160929),
(160930, '1.10.260.40-FF-000012', NULL, 'HTH-type transcriptional regulator GntR', 61, NULL, NULL, 160930),
(160931, '3.30.230.10-FF-000091', NULL, 'Type 2 DNA topoisomerase 6 subunit B', 223, NULL, NULL, 160931),
(160932, '3.40.30.10-FF-001025', NULL, 'Glutathione peroxidase 4a', 51, NULL, NULL, 160932),
(160933, '3.40.50.300-FF-003450', NULL, 'ABC multidrug transporter, putative', 267, NULL, NULL, 160933),
(160934, '3.30.230.10-FF-000343', NULL, 'Uncharacterized protein', 41, NULL, NULL, 160934),
(160935, '1.10.238.10-FF-001042', NULL, 'Calmodulin-like protein', 48, NULL, NULL, 160935),
(160936, '1.25.40.10-FF-005202', NULL, 'Uncharacterized protein', 211, NULL, NULL, 160936),
(160937, '1.10.418.10-FF-000191', NULL, 'Predicted protein', 107, NULL, NULL, 160937),
(160938, '3.40.1110.10-FF-000320', NULL, NULL, 159, NULL, NULL, 160938),
(160939, '1.10.3720.10-FF-000089', NULL, 'Ectoine/hydroxyectoine ABC transporter permease subunit EhuD', 215, NULL, NULL, 160939),
(160940, '1.20.1560.10-FF-000242', NULL, 'Uncharacterized protein', 317, NULL, NULL, 160940),
(160941, '2.130.10.10-FF-003051', NULL, 'WD40-repeat-containing domain protein', 143, NULL, NULL, 160941),
(160942, '3.40.1410.10-FF-000028', NULL, 'GntR family transcriptional regulator', 141, NULL, NULL, 160942),
(160943, '2.30.29.30-FF-000440', NULL, 'Uncharacterized protein', 126, NULL, NULL, 160943);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(160944, '1.20.58.390-FF-000099', NULL, 'Cholinergic receptor, nicotinic, epsilon', 111, NULL, NULL, 160944),
(160945, '3.40.50.720-FF-002075', NULL, 'Uncharacterized protein', 149, NULL, NULL, 160945),
(160946, '2.40.70.10-FF-000552', NULL, NULL, 221, NULL, NULL, 160946),
(160947, '3.30.160.60-FF-002679', NULL, 'Zinc finger protein 726', 37, NULL, NULL, 160947),
(160948, '3.30.160.60-FF-005231', NULL, NULL, 69, NULL, NULL, 160948),
(160949, '1.25.40.10-FF-000346', NULL, 'Sodium-type flagellar protein MotX', 177, NULL, NULL, 160949),
(160950, '2.40.30.170-FF-000050', NULL, NULL, 101, NULL, NULL, 160950),
(160951, '1.10.10.10-FF-001361', NULL, 'Heat shock regulator', 102, NULL, NULL, 160951),
(160952, '3.90.70.10-FF-000766', NULL, 'Uncharacterized protein', 77, NULL, NULL, 160952),
(160953, '3.90.170.10-FF-000004', NULL, 'Adenylosuccinate synthetase', 155, NULL, NULL, 160953),
(160954, '3.40.50.880-FF-000167', NULL, 'Uncharacterized protein C18G6.12c', 242, NULL, NULL, 160954),
(160955, '2.120.10.30-FF-000179', NULL, 'Bll1368 protein', 289, NULL, NULL, 160955),
(160956, '3.30.160.60-FF-003207', NULL, NULL, 31, NULL, NULL, 160956),
(160957, '3.40.50.1820-FF-000425', NULL, 'Alpha/beta hydrolase family protein', 232, NULL, NULL, 160957),
(160958, '3.90.980.20-FF-000018', NULL, 'PHF19 isoform 10', 64, NULL, NULL, 160958),
(160959, '3.30.465.10-FF-000141', NULL, 'Oxidoreductase', 224, NULL, NULL, 160959),
(160960, '1.10.510.10-FF-004396', NULL, NULL, 87, NULL, NULL, 160960),
(160961, '1.25.40.20-FF-000989', NULL, 'Phosphate system positive regulatory protein PHO81', 184, NULL, NULL, 160961),
(160962, '3.30.1120.90-FF-000004', NULL, 'Nucleosome assembly protein 1', 189, NULL, NULL, 160962),
(160963, '3.90.920.10-FF-000023', NULL, 'DNA primase small subunit PriS', 366, NULL, NULL, 160963),
(160964, '1.20.5.170-FF-000033', NULL, 'Lamin A/C', 75, NULL, NULL, 160964),
(160965, '3.40.50.620-FF-000230', NULL, 'FAD synthetase, putative', 262, NULL, NULL, 160965),
(160966, '3.30.450.20-FF-000312', NULL, 'Nitrogen fixation regulatory protein, NifL', 127, NULL, NULL, 160966),
(160967, '2.60.40.10-FF-004719', NULL, NULL, 108, NULL, NULL, 160967),
(160968, '3.40.50.300-FF-003231', NULL, 'DNA repair helicase', 163, NULL, NULL, 160968),
(160969, '1.10.510.10-FF-003103', NULL, NULL, 195, NULL, NULL, 160969),
(160970, '3.30.1370.210-FF-000021', NULL, 'DExH-box helicase 57', 62, NULL, NULL, 160970),
(160971, '3.40.50.1000-FF-000770', NULL, NULL, 110, NULL, NULL, 160971),
(160972, '2.130.10.10-FF-002556', NULL, 'LLGL2, scribble cell polarity complex component', 148, NULL, NULL, 160972),
(160973, '1.20.58.60-FF-000125', NULL, 'Desmoplakin', 228, NULL, NULL, 160973),
(160974, '3.30.420.10-FF-000026', NULL, 'DNA polymerase I', 216, NULL, NULL, 160974),
(160975, '2.130.10.10-FF-004686', NULL, 'Uncharacterized protein', 179, NULL, NULL, 160975),
(160976, '2.130.10.10-FF-005304', NULL, 'Uncharacterized WD repeat-containing protein C343.04c', 213, NULL, NULL, 160976),
(160977, '2.60.40.10-FF-002831', NULL, NULL, 101, NULL, NULL, 160977),
(160978, '3.40.1110.10-FF-000011', NULL, 'Calcium-transporting ATPase', 197, NULL, NULL, 160978),
(160979, '2.30.29.30-FF-001289', NULL, 'KRIT 1 (Krev interaction trapped/cerebral cavernous malformation 1) homolog', 90, NULL, NULL, 160979),
(160980, '3.90.190.10-FF-000421', NULL, 'Tyrosine-protein phosphatase non-receptor type 2', 90, NULL, NULL, 160980),
(160981, '1.20.950.20-FF-000023', NULL, 'CoB--CoM heterodisulfide reductase 2 subunit E', 170, NULL, NULL, 160981),
(160982, '1.25.10.10-FF-002648', NULL, 'Uncharacterized protein', 110, NULL, NULL, 160982),
(160983, '3.40.50.150-FF-000656', NULL, '25S rRNA (adenine(2142)-N(1))-methyltransferase', 143, NULL, NULL, 160983),
(160984, '3.30.160.60-FF-002792', NULL, 'Zinc finger protein 646', 31, NULL, NULL, 160984),
(160985, '1.10.10.2590-FF-000001', NULL, 'protein BANP isoform X1', 97, NULL, NULL, 160985),
(160986, '3.30.200.20-FF-000288', NULL, 'LRR receptor-like serine/threonine-protein kinase ERECTA', 105, NULL, NULL, 160986),
(160987, '3.40.50.300-FF-006884', NULL, 'Uncharacterized protein', 245, NULL, NULL, 160987);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(160988, '3.40.50.150-FF-001460', NULL, NULL, 138, NULL, NULL, 160988),
(160989, '2.120.10.30-FF-000382', NULL, 'Uncharacterized protein', 346, NULL, NULL, 160989),
(160990, '2.60.40.10-FF-004377', NULL, NULL, 105, NULL, NULL, 160990),
(160991, '1.20.1050.10-FF-000175', NULL, 'Ganglioside-induced differentiation-associated-protein 1', 130, NULL, NULL, 160991),
(160992, '3.40.50.300-FF-004557', NULL, 'Predicted protein', 68, NULL, NULL, 160992),
(160993, '3.40.50.720-FF-000366', NULL, 'Protein FMP52, mitochondrial', 228, NULL, NULL, 160993),
(160994, '1.10.510.10-FF-003631', NULL, NULL, 192, NULL, NULL, 160994),
(160995, '3.30.2010.10-FF-000012', NULL, 'Metallopeptidase Oma1', 66, NULL, NULL, 160995),
(160996, '3.30.450.20-FF-000109', NULL, 'Sensor domain-containing diguanylate cyclase', 115, NULL, NULL, 160996),
(160997, '3.40.50.2300-FF-000468', NULL, 'G protein-coupled receptor, class C, group 6, member A', 278, NULL, NULL, 160997),
(160998, '2.60.220.50-FF-000115', NULL, 'Cadherin, EGF LAG seven-pass G-type receptor 3', 85, NULL, NULL, 160998),
(160999, '2.60.120.650-FF-000043', NULL, 'tRNA wybutosine-synthesizing protein 4', 258, NULL, NULL, 160999),
(161000, '3.30.530.20-FF-000167', NULL, 'Uncharacterized protein', 126, NULL, NULL, 161000),
(161001, '1.20.1070.10-FF-001823', NULL, 'Uncharacterized protein', 308, NULL, NULL, 161001),
(161002, '2.20.70.10-FF-000070', NULL, 'Pre-mRNA-processing protein 40C', 57, NULL, NULL, 161002),
(161003, '2.60.120.260-FF-000252', NULL, 'Endo-1,4-beta-xylanase 4', 113, NULL, NULL, 161003),
(161004, '3.90.79.10-FF-000269', NULL, '39S ribosomal protein L46, putative', 107, NULL, NULL, 161004),
(161005, '3.20.20.80-FF-000129', NULL, 'Lysozyme-like protein 7', 215, NULL, NULL, 161005),
(161006, '3.40.47.10-FF-000046', NULL, 'UPF0219 protein M1627_1703', 347, NULL, NULL, 161006),
(161007, '3.40.50.2000-FF-000406', NULL, 'Glycosyltransferase', 267, NULL, NULL, 161007),
(161008, '3.30.559.70-FF-000023', NULL, 'Si:ch211-256m1.8', 283, NULL, NULL, 161008),
(161009, '1.25.40.10-FF-002931', NULL, 'Clathrin heavy chain', 145, NULL, NULL, 161009),
(161010, '3.40.50.720-FF-002165', NULL, 'Uncharacterized protein', 75, NULL, NULL, 161010),
(161011, '1.25.10.10-FF-002851', NULL, 'Importin, putative', 170, NULL, NULL, 161011),
(161012, '3.40.50.300-FF-001432', NULL, 'Menage a trois, isoform C', 217, NULL, NULL, 161012),
(161013, '1.20.1250.20-FF-001778', NULL, 'Monocarboxylate transporter 11', 183, NULL, NULL, 161013),
(161014, '2.60.120.260-FF-000049', NULL, 'Beta-galactosidase', 137, NULL, NULL, 161014),
(161015, '3.60.40.10-FF-000142', NULL, 'Uncharacterized protein', 289, NULL, NULL, 161015),
(161016, '3.40.220.10-FF-000014', NULL, 'M17 leucyl aminopeptidase', 198, NULL, NULL, 161016),
(161017, '3.40.309.10-FF-000046', NULL, 'Aldehyde dehydrogenase', 196, NULL, NULL, 161017),
(161018, '1.20.58.150-FF-000010', NULL, 'Uncharacterized protein', 77, NULL, NULL, 161018),
(161019, '1.25.40.20-FF-000990', NULL, 'Ankyrin repeat protein C9L', 270, NULL, NULL, 161019),
(161020, '2.60.40.420-FF-000133', NULL, 'GM10275', 156, NULL, NULL, 161020),
(161021, '3.50.50.60-FF-000186', NULL, 'Succinate dehydrogenase flavoprotein subunit', 283, NULL, NULL, 161021),
(161022, '1.25.10.10-FF-000849', NULL, 'Importin beta-3 subunit family protein', 962, NULL, NULL, 161022),
(161023, '3.30.1540.10-FF-000001', NULL, 'L-carnitine CoA-transferase', 103, NULL, NULL, 161023),
(161024, '3.40.850.10-FF-000023', NULL, 'Kinesin-like protein', 369, NULL, NULL, 161024),
(161025, '2.60.120.260-FF-000139', NULL, 'Anaphase-promoting complex subunit 10', 194, NULL, NULL, 161025),
(161026, '3.10.20.770-FF-000011', NULL, 'Phosphatidylinositol-4,5-bisphosphate 3-kinase catalytic subunit delta isoform, putative', 216, NULL, NULL, 161026),
(161027, '1.25.10.10-FF-000597', NULL, 'Deoxyhypusine hydroxylase', 158, NULL, NULL, 161027),
(161028, '3.30.1320.10-FF-000018', NULL, '30S ribosomal protein S16', 89, NULL, NULL, 161028),
(161029, '3.80.10.10-FF-002730', NULL, 'Predicted protein', 205, NULL, NULL, 161029);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(161030, '3.30.200.20-FF-002290', NULL, 'Predicted protein', 104, NULL, NULL, 161030),
(161031, '2.120.10.80-FF-000391', NULL, 'Uncharacterized protein', 190, NULL, NULL, 161031),
(161032, '1.10.600.10-FF-000081', NULL, 'AGAP000326-PA', 277, NULL, NULL, 161032),
(161033, '3.30.200.20-FF-002542', NULL, 'Probable serine/threonine-protein kinase DDB_G0290859', 12, NULL, NULL, 161033),
(161034, '2.170.270.10-FF-000047', NULL, 'Histone-lysine N-methyltransferase', 277, NULL, NULL, 161034),
(161035, '3.40.50.80-FF-000024', NULL, 'NADH oxidoreductase hcr', 124, NULL, NULL, 161035),
(161036, '2.60.120.200-FF-000150', NULL, 'Laminin subunit alpha 5', 162, NULL, NULL, 161036),
(161037, '2.60.40.150-FF-000827', NULL, 'Uncharacterized protein', 80, NULL, NULL, 161037),
(161038, '3.40.350.10-FF-000018', NULL, 'Metallo-peptidase, Clan MG, Family M24', 154, NULL, NULL, 161038),
(161039, '3.40.50.720-FF-001816', NULL, 'Lovastatin nonaketide synthase, polyketide synthase component', 221, NULL, NULL, 161039),
(161040, '3.40.570.10-FF-000001', NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase family member 2', 323, NULL, NULL, 161040),
(161041, '2.130.10.10-FF-000757', NULL, 'rRNA processing WD-repeat protein, putative', 296, NULL, NULL, 161041),
(161042, '2.30.42.10-FF-000072', NULL, 'multiple PDZ domain protein isoform X1', 104, NULL, NULL, 161042),
(161043, '3.30.420.40-FF-000277', NULL, 'Cell division protein FtsA', 87, NULL, NULL, 161043),
(161044, '1.10.10.60-FF-000746', NULL, NULL, 45, NULL, NULL, 161044),
(161045, '3.90.1150.10-FF-000047', NULL, 'Ornithine aminotransferase', 125, NULL, NULL, 161045),
(161046, '3.60.150.10-FF-000010', NULL, 'Chorismate synthase', 353, NULL, NULL, 161046),
(161047, '3.30.1490.100-FF-000026', NULL, 'Putative DNA polymerase kappa', 112, NULL, NULL, 161047),
(161048, '1.25.40.10-FF-004730', NULL, 'Uncharacterized protein', 84, NULL, NULL, 161048),
(161049, '1.20.1720.10-FF-000030', NULL, 'Bcr/CflA family efflux transporter', 375, NULL, NULL, 161049),
(161050, '3.40.50.300-FF-001090', NULL, 'ATP-binding cassette subfamily C member 10', 247, NULL, NULL, 161050),
(161051, '3.30.200.20-FF-002087', NULL, 'Uncharacterized protein', 82, NULL, NULL, 161051),
(161052, '3.40.50.300-FF-007502', NULL, 'DNA replication and repair protein RecF', 221, NULL, NULL, 161052),
(161053, '3.40.50.150-FF-001128', NULL, NULL, 208, NULL, NULL, 161053),
(161054, '3.90.1170.50-FF-000009', NULL, 'Cytochrome P450', 99, NULL, NULL, 161054),
(161055, '2.160.20.10-FF-000329', NULL, 'Uncharacterized protein', 120, NULL, NULL, 161055),
(161056, '3.40.50.300-FF-005703', NULL, 'Uncharacterized protein', 174, NULL, NULL, 161056),
(161057, '3.50.50.60-FF-000528', NULL, 'Phytoene desaturase', 128, NULL, NULL, 161057),
(161058, '2.70.170.10-FF-000086', NULL, 'NtR, isoform A', 238, NULL, NULL, 161058),
(161059, '2.160.20.10-FF-000133', NULL, 'PKHD1, fibrocystin/polyductin', 475, NULL, NULL, 161059),
(161060, '2.10.25.10-FF-001825', NULL, 'Uncharacterized protein', 49, NULL, NULL, 161060),
(161061, '3.60.10.10-FF-000314', NULL, 'Type I inositol-1,4,5-trisphosphate 5-phosphatase, putative', 285, NULL, NULL, 161061),
(161062, '3.40.980.20-FF-000001', NULL, 'Ketose-bisphosphate aldolase class-II family protein', 183, NULL, NULL, 161062),
(161063, '3.30.830.10-FF-000294', NULL, 'Uncharacterized protein', 82, NULL, NULL, 161063),
(161064, '1.10.1520.10-FF-000101', NULL, 'ADL023Wp', 210, NULL, NULL, 161064),
(161065, '3.50.50.60-FF-000276', NULL, 'Protoporphyrinogen oxidase', 518, NULL, NULL, 161065),
(161066, '1.10.340.30-FF-000066', NULL, 'Uncharacterized protein', 78, NULL, NULL, 161066),
(161067, '1.10.4160.10-FF-000012', NULL, 'Cytosine-purine permease, putative', 446, NULL, NULL, 161067),
(161068, '1.20.1560.10-FF-000152', NULL, 'MDR-like ABC transporter', 612, NULL, NULL, 161068),
(161069, '3.40.50.150-FF-001370', NULL, NULL, 179, NULL, NULL, 161069),
(161070, '2.40.50.140-FF-000163', NULL, 'Probable DNA ligase', 131, NULL, NULL, 161070),
(161071, '2.30.29.30-FF-000350', NULL, 'AGC family protein kinase', 100, NULL, NULL, 161071);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(161072, '1.20.58.70-FF-000128', NULL, 'Uncharacterized protein', 83, NULL, NULL, 161072),
(161073, '3.30.565.10-FF-000396', NULL, 'Two-component system sensor histidine kinase', 142, NULL, NULL, 161073),
(161074, '3.90.550.10-FF-000298', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 135, NULL, NULL, 161074),
(161075, '1.20.1740.10-FF-000115', NULL, 'Cationic amino acid transporter, putative', 130, NULL, NULL, 161075),
(161076, '2.30.29.30-FF-000108', NULL, 'C-Jun-amino-terminal kinase-interacting protein 1 isoform X2', 149, NULL, NULL, 161076),
(161077, '2.30.42.10-FF-000324', NULL, 'Probable serine protease PepD (Serine proteinase) (MTB32B)', 90, NULL, NULL, 161077),
(161078, '1.10.150.20-FF-000228', NULL, 'DNA polymerase', 59, NULL, NULL, 161078),
(161079, '3.40.50.1820-FF-001499', NULL, 'Uncharacterized protein', 160, NULL, NULL, 161079),
(161080, '2.10.25.10-FF-001679', NULL, 'Uncharacterized protein', 44, NULL, NULL, 161080),
(161081, '2.70.130.10-FF-000179', NULL, NULL, 148, NULL, NULL, 161081),
(161082, '1.10.472.10-FF-000445', NULL, 'Cyclin domain-containing protein', 117, NULL, NULL, 161082),
(161083, '2.130.10.10-FF-004596', NULL, 'Uncharacterized protein', 205, NULL, NULL, 161083),
(161084, '2.120.10.30-FF-000292', NULL, 'E3 ubiquitin-protein ligase TRIM71', 51, NULL, NULL, 161084),
(161085, '1.20.1560.10-FF-000461', NULL, 'Uncharacterized protein', 334, NULL, NULL, 161085),
(161086, '3.30.428.10-FF-000038', NULL, 'Galactose-1-phosphate uridylyltransferase', 169, NULL, NULL, 161086),
(161087, '1.10.150.510-FF-000013', NULL, 'uncharacterized protein LOC100178270', 93, NULL, NULL, 161087),
(161088, '2.40.10.10-FF-000576', NULL, NULL, 56, NULL, NULL, 161088),
(161089, '3.30.470.20-FF-000111', NULL, 'D-alanine--D-alanine ligase', 212, NULL, NULL, 161089),
(161090, '1.25.10.10-FF-003014', NULL, 'Uncharacterized protein', 332, NULL, NULL, 161090),
(161091, '3.90.650.10-FF-000007', NULL, 'Trifunctional purine biosynthetic protein adenosine-3', 191, NULL, NULL, 161091),
(161092, '1.20.1250.20-FF-001688', NULL, 'Monocarboxylate transporter, putative', 209, NULL, NULL, 161092),
(161093, '3.30.420.40-FF-000732', NULL, 'Uncharacterized protein', 117, NULL, NULL, 161093),
(161094, '3.30.40.10-FF-000430', NULL, 'E3 ubiquitin-protein ligase RDUF2', 84, NULL, NULL, 161094),
(161095, '1.20.1250.20-FF-002306', NULL, 'Multidrug resistance protein fnx1', 190, NULL, NULL, 161095),
(161096, '2.60.40.420-FF-000223', NULL, 'Bll2293 protein', 201, NULL, NULL, 161096),
(161097, '2.170.140.10-FF-000043', NULL, 'Chitinase 12', 65, NULL, NULL, 161097),
(161098, '3.40.50.11060-FF-000015', NULL, 'LOC563225 protein', 51, NULL, NULL, 161098),
(161099, '3.40.50.300-FF-005029', NULL, 'Uncharacterized protein', 158, NULL, NULL, 161099),
(161100, '2.30.30.100-FF-000227', NULL, 'SnRNP core Sm protein Sm-X5-like protein', 55, NULL, NULL, 161100),
(161101, '1.10.150.530-FF-000019', NULL, 'Probable dual-specificity RNA methyltransferase RlmN', 56, NULL, NULL, 161101),
(161102, '1.10.510.10-FF-002917', NULL, NULL, 207, NULL, NULL, 161102),
(161103, '3.30.1370.10-FF-000173', NULL, 'Tudor and KH domain-containing protein homolog', 80, NULL, NULL, 161103),
(161104, '2.60.40.10-FF-005091', NULL, NULL, 99, NULL, NULL, 161104),
(161105, '3.20.20.300-FF-000076', NULL, NULL, 101, NULL, NULL, 161105),
(161106, '3.40.50.12780-FF-000121', NULL, 'Acyl-CoA synthetase', 405, NULL, NULL, 161106),
(161107, '3.40.47.10-FF-000265', NULL, NULL, 173, NULL, NULL, 161107),
(161108, '2.70.160.11-FF-000002', NULL, 'Probable histone-arginine methyltransferase CARM1', 199, NULL, NULL, 161108),
(161109, '2.60.40.10-FF-000886', NULL, 'Interleukin-6 receptor subunit alpha', 103, NULL, NULL, 161109),
(161110, '1.20.1640.10-FF-000097', NULL, NULL, 192, NULL, NULL, 161110),
(161111, '1.10.630.10-FF-000251', NULL, 'Cytochrome P450, family 2, subfamily X, polypeptide 10.2', 273, NULL, NULL, 161111),
(161112, '2.70.170.10-FF-000176', NULL, 'Uncharacterized protein', 73, NULL, NULL, 161112),
(161113, '3.40.630.10-FF-000512', NULL, 'Predicted protein', 145, NULL, NULL, 161113);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(161114, '2.60.40.150-FF-000266', NULL, 'Phospholipase D alpha 1', 156, NULL, NULL, 161114),
(161115, '3.80.10.10-FF-003815', NULL, 'Uncharacterized protein', 81, NULL, NULL, 161115),
(161116, '2.70.98.10-FF-000075', NULL, 'ADR339Cp', 318, NULL, NULL, 161116),
(161117, '2.60.120.260-FF-000504', NULL, 'Uncharacterized protein', 76, NULL, NULL, 161117),
(161118, '3.60.10.10-FF-000005', NULL, 'phosphatidylinositol 3,4,5-trisphosphate 5-phosphatase 1', 318, NULL, NULL, 161118),
(161119, '3.40.50.720-FF-002530', NULL, 'Uncharacterized protein', 93, NULL, NULL, 161119),
(161120, '3.30.390.50-FF-000029', NULL, 'Uncharacterized protein', 40, NULL, NULL, 161120),
(161121, '3.40.640.10-FF-000119', NULL, 'Molybdenum cofactor sulfurase', 267, NULL, NULL, 161121),
(161122, '1.20.1250.20-FF-001997', NULL, 'Multidrug-efflux transporter', 382, NULL, NULL, 161122),
(161123, '1.20.120.1080-FF-000031', NULL, 'ATP-dependent RNA helicase', 107, NULL, NULL, 161123),
(161124, '3.90.1150.10-FF-000356', NULL, 'Spore coat polysaccharide biosynthesis proteinSpsC', 122, NULL, NULL, 161124),
(161125, '3.40.50.300-FF-001651', NULL, 'EscN/YscN/HrcN family type III secretion system ATPase', 269, NULL, NULL, 161125),
(161126, '1.20.58.60-FF-000215', NULL, 'VAB-10B protein', 209, NULL, NULL, 161126),
(161127, '3.20.20.140-FF-000005', NULL, 'TatD family hydrolase', 255, NULL, NULL, 161127),
(161128, '3.40.640.10-FF-000338', NULL, 'Serine--glyoxylate aminotransferase', 83, NULL, NULL, 161128),
(161129, '3.30.1330.90-FF-000014', NULL, 'L-serine dehydratase', 44, NULL, NULL, 161129),
(161130, '1.10.8.10-FF-000213', NULL, 'Defective in cullin neddylation protein 1', 71, NULL, NULL, 161130),
(161131, '1.25.40.10-FF-002785', NULL, 'Uncharacterized protein', 135, NULL, NULL, 161131),
(161132, '2.130.10.10-FF-001252', NULL, 'Receptor of activated protein C kinase 1', 310, NULL, NULL, 161132),
(161133, '2.60.40.10-FF-000667', NULL, 'V-set and transmembrane domain containing 4', 126, NULL, NULL, 161133),
(161134, '2.60.40.10-FF-004629', NULL, NULL, 75, NULL, NULL, 161134),
(161135, '3.40.50.720-FF-002311', NULL, 'C-terminal-binding protein 1', 133, NULL, NULL, 161135),
(161136, '3.90.1600.10-FF-000026', NULL, 'DNA polymerase', 113, NULL, NULL, 161136),
(161137, '3.40.50.150-FF-000965', NULL, 'Uncharacterized methyltransferase-like C25B8.10', 245, NULL, NULL, 161137),
(161138, '3.30.160.60-FF-002483', NULL, 'Zinc finger protein 90', 29, NULL, NULL, 161138),
(161139, '3.30.54.20-FF-000009', NULL, NULL, 71, NULL, NULL, 161139),
(161140, '3.30.390.30-FF-000023', NULL, 'Ferredoxin reductase', 80, NULL, NULL, 161140),
(161141, '1.20.120.980-FF-000056', NULL, 'Uncharacterized protein', 67, NULL, NULL, 161141),
(161142, '3.30.160.60-FF-005085', NULL, NULL, 36, NULL, NULL, 161142),
(161143, '1.10.510.10-FF-003412', NULL, NULL, 296, NULL, NULL, 161143),
(161144, '2.40.370.10-FF-000001', NULL, 'Survival factor 1', 178, NULL, NULL, 161144),
(161145, '2.60.40.10-FF-004848', NULL, NULL, 94, NULL, NULL, 161145),
(161146, '3.40.640.10-FF-000428', NULL, 'Alanine aminotransferase', 180, NULL, NULL, 161146),
(161147, '1.20.1720.10-FF-000007', NULL, 'Bcr/CflA family efflux transporter', 379, NULL, NULL, 161147),
(161148, '1.25.40.10-FF-002476', NULL, 'Os08g0131000 protein', 128, NULL, NULL, 161148),
(161149, '3.30.420.40-FF-000951', NULL, 'Uncharacterized protein', 67, NULL, NULL, 161149),
(161150, '3.30.160.60-FF-002825', NULL, 'E3 ubiquitin-protein ligase TRIM17', 42, NULL, NULL, 161150),
(161151, '3.30.70.330-FF-000059', NULL, 'splicing factor 3B subunit 4', 93, NULL, NULL, 161151),
(161152, '3.40.640.10-FF-000086', NULL, 'Kynurenine--oxoglutarate transaminase 1', 240, NULL, NULL, 161152),
(161153, '1.20.5.320-FF-000005', NULL, 'collagen alpha-2(VI) chain isoform X1', 46, NULL, NULL, 161153),
(161154, '3.30.420.580-FF-000011', NULL, 'Probable actin-related protein 8', 184, NULL, NULL, 161154),
(161155, '2.60.40.10-FF-004938', NULL, NULL, 67, NULL, NULL, 161155),
(161156, '2.60.40.10-FF-001504', NULL, 'Interleukin 18 receptor accessory protein', 92, NULL, NULL, 161156);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(161157, '1.25.40.430-FF-000006', NULL, 'Pre-mRNA-splicing factor SYF1', 123, NULL, NULL, 161157),
(161158, '2.70.150.10-FF-000287', NULL, 'Phospholipid-transporting ATPase', 116, NULL, NULL, 161158),
(161159, '3.40.1280.10-FF-000012', NULL, 'RNA methyltransferase, TrmH family, group 3', 171, NULL, NULL, 161159),
(161160, '1.25.10.10-FF-002761', NULL, 'Uncharacterized protein', 605, NULL, NULL, 161160),
(161161, '3.30.210.10-FF-000016', NULL, 'Pol lambda-related class X DNA repair polymerase', 101, NULL, NULL, 161161),
(161162, '2.130.10.10-FF-001162', NULL, 'Conserved protein', 317, NULL, NULL, 161162),
(161163, '2.60.40.10-FF-000577', NULL, 'immunoglobulin superfamily DCC subclass member 3', 92, NULL, NULL, 161163),
(161164, '1.10.510.10-FF-001158', NULL, 'Probable serine/threonine-protein kinase mkcE', 271, NULL, NULL, 161164),
(161165, '2.10.110.10-FF-000135', NULL, 'LIM domain-containing protein, putative', 62, NULL, NULL, 161165),
(161166, '3.10.100.10-FF-000434', NULL, NULL, 73, NULL, NULL, 161166),
(161167, '1.20.140.40-FF-000035', NULL, 'Pectinesterase inhibitor 12', 154, NULL, NULL, 161167),
(161168, '3.40.50.150-FF-001151', NULL, NULL, 208, NULL, NULL, 161168),
(161169, '3.90.550.10-FF-000769', NULL, 'Predicted protein', 265, NULL, NULL, 161169),
(161170, '1.10.10.60-FF-001151', NULL, NULL, 99, NULL, NULL, 161170),
(161171, '3.40.50.720-FF-001693', NULL, 'Dehydrogenase', 54, NULL, NULL, 161171),
(161172, '1.25.40.10-FF-003403', NULL, 'Os06g0506100 protein', 128, NULL, NULL, 161172),
(161173, '1.10.2010.10-FF-000001', NULL, 'Ion transport peptide isoform C', 76, NULL, NULL, 161173),
(161174, '1.25.40.420-FF-000003', NULL, 'BTB/POZ domain-containing protein 3', 101, NULL, NULL, 161174),
(161175, '1.50.40.10-FF-000012', NULL, 'Phosphate carrier protein, mitochondrial', 279, NULL, NULL, 161175),
(161176, '2.40.37.10-FF-000042', NULL, NULL, 63, NULL, NULL, 161176),
(161177, '1.10.510.10-FF-000995', NULL, 'BcCMK3, calcium/calmodulin-dependent protein kinase', 290, NULL, NULL, 161177),
(161178, '2.130.10.10-FF-002674', NULL, 'Mitotic checkpoint protein bub3', 331, NULL, NULL, 161178),
(161179, '4.10.640.10-FF-000038', NULL, 'Uncharacterized protein', 44, NULL, NULL, 161179),
(161180, '3.90.1150.210-FF-000011', NULL, 'F-actin-capping protein subunit beta', 184, NULL, NULL, 161180),
(161181, '1.10.510.10-FF-002709', NULL, NULL, 188, NULL, NULL, 161181),
(161182, '3.40.50.300-FF-000937', NULL, 'Corrinoid adenosyltransferase', 191, NULL, NULL, 161182),
(161183, '3.30.70.330-FF-000418', NULL, 'heterogeneous nuclear ribonucleoprotein A0', 89, NULL, NULL, 161183),
(161184, '3.30.450.20-FF-000430', NULL, 'Sensor histidine kinase, PAS, PAS and PAS domain-containing', 98, NULL, NULL, 161184),
(161185, '3.30.230.10-FF-000220', NULL, 'Uncharacterized protein', 37, NULL, NULL, 161185),
(161186, '1.20.1250.20-FF-002166', NULL, 'Metabolite transport protein csbC-related protein', 185, NULL, NULL, 161186),
(161187, '3.40.640.10-FF-000327', NULL, 'Sphingosine Phosphate Lyase', 161, NULL, NULL, 161187),
(161188, '3.80.10.10-FF-000611', NULL, 'Capricious, isoform E', 242, NULL, NULL, 161188),
(161189, '2.60.40.150-FF-000474', NULL, 'WW domain-containing E3 ubiquitin protein ligase 1', 93, NULL, NULL, 161189),
(161190, '2.40.37.10-FF-000036', NULL, 'Alanine racemase', 157, NULL, NULL, 161190),
(161191, '2.60.40.10-FF-002707', NULL, 'CoLlagen with Endostatin domain', 103, NULL, NULL, 161191),
(161192, '3.30.160.60-FF-001622', NULL, 'Uncharacterized protein', 30, NULL, NULL, 161192),
(161193, '1.10.10.570-FF-000007', NULL, 'ESCRT-II complex, vps25 subunit', 100, NULL, NULL, 161193),
(161194, '1.10.730.10-FF-000197', NULL, 'Uncharacterized protein', 137, NULL, NULL, 161194),
(161195, '1.10.260.40-FF-000091', NULL, 'Uncharacterized protein', 65, NULL, NULL, 161195),
(161196, '1.20.1250.20-FF-000042', NULL, 'Fosmidomycin resistance protein', 185, NULL, NULL, 161196),
(161197, '1.10.3470.10-FF-000013', NULL, 'Fe(3+)-hydroxamate ABC transporter permease FhuB', 323, NULL, NULL, 161197),
(161198, '2.40.50.140-FF-000174', NULL, 'DNA replication licensing factor mcm10', 177, NULL, NULL, 161198);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(161199, '3.30.420.40-FF-000934', NULL, 'Actin-related protein 3', 91, NULL, NULL, 161199),
(161200, '1.20.1070.10-FF-000406', NULL, 'Adhesion G protein-coupled receptor B1', 169, NULL, NULL, 161200),
(161201, '3.90.550.10-FF-000758', NULL, 'Uncharacterized protein', 120, NULL, NULL, 161201),
(161202, '1.10.287.110-FF-000466', NULL, 'Uncharacterized protein', 60, NULL, NULL, 161202),
(161203, '3.40.50.720-FF-000602', NULL, 'Steroid dehydrogenase, putative', 233, NULL, NULL, 161203),
(161204, '1.20.1270.10-FF-000034', NULL, 'Chaperone protein DnaK', 83, NULL, NULL, 161204),
(161205, '1.10.1370.10-FF-000050', NULL, 'Uncharacterized protein', 102, NULL, NULL, 161205),
(161206, '2.160.20.10-FF-000346', NULL, 'Uncharacterized protein', 249, NULL, NULL, 161206),
(161207, '1.25.40.10-FF-000329', NULL, 'Pentatricopeptide repeat-containing protein', 216, NULL, NULL, 161207),
(161208, '3.90.550.50-FF-000079', NULL, 'Uncharacterized protein', 207, NULL, NULL, 161208),
(161209, '3.90.70.10-FF-000429', NULL, 'Uncharacterized protein', 164, NULL, NULL, 161209),
(161210, '2.130.10.10-FF-001151', NULL, 'Semaphorin 5C', 445, NULL, NULL, 161210),
(161211, '3.40.390.10-FF-000105', NULL, 'Zinc metalloproteinase nas-16', 235, NULL, NULL, 161211),
(161212, '3.40.50.300-FF-001443', NULL, 'ABC transporter, ATP-binding protein', 251, NULL, NULL, 161212),
(161213, '2.10.25.10-FF-001808', NULL, 'Uncharacterized protein', 38, NULL, NULL, 161213),
(161214, '2.60.40.10-FF-003308', NULL, 'DLEC1, cilia and flagella associated protein', 117, NULL, NULL, 161214),
(161215, '2.60.120.200-FF-000503', NULL, 'Basement membrane proteoglycan', 182, NULL, NULL, 161215),
(161216, '2.40.70.10-FF-000563', NULL, NULL, 115, NULL, NULL, 161216),
(161217, '3.60.15.10-FF-000073', NULL, 'MBL fold metallo-hydrolase', 237, NULL, NULL, 161217),
(161218, '1.25.10.10-FF-001007', NULL, 'ARM repeat superfamily protein', 418, NULL, NULL, 161218),
(161219, '2.60.40.720-FF-000010', NULL, 'Runx2a splice form 5', 36, NULL, NULL, 161219),
(161220, '3.30.497.10-FF-000035', NULL, 'Serine (or cysteine) peptidase inhibitor, clade H, member 2', 226, NULL, NULL, 161220),
(161221, '1.10.10.10-FF-000759', NULL, 'Ferric uptake regulation protein FUR', 92, NULL, NULL, 161221),
(161222, '2.60.40.10-FF-002696', NULL, 'Obscurin', 72, NULL, NULL, 161222),
(161223, '3.30.2350.20-FF-000057', NULL, NULL, 195, NULL, NULL, 161223),
(161224, '1.20.58.1880-FF-000033', NULL, 'Uncharacterized protein', 109, NULL, NULL, 161224),
(161225, '3.30.1070.10-FF-000004', NULL, 'Cell division topological specificity factor', 83, NULL, NULL, 161225),
(161226, '2.60.40.10-FF-004736', NULL, NULL, 73, NULL, NULL, 161226),
(161227, '1.10.3860.10-FF-000020', NULL, 'Proton glutamate symport protein', 407, NULL, NULL, 161227),
(161228, '3.30.160.60-FF-002819', NULL, 'Putative C2H2 transcription factor', 47, NULL, NULL, 161228),
(161229, '3.30.830.10-FF-000198', NULL, 'Peptidase M16C associated domain protein', 249, NULL, NULL, 161229),
(161230, '1.10.510.10-FF-001512', NULL, 'Receptor tyrosine-protein kinase erbB-2', 205, NULL, NULL, 161230),
(161231, '3.30.1520.10-FF-000112', NULL, 'Uncharacterized protein', 123, NULL, NULL, 161231),
(161232, '2.60.40.420-FF-000122', NULL, 'Ephrin-4', 153, NULL, NULL, 161232),
(161233, '3.40.50.300-FF-002966', NULL, 'ABC-type multidrug transport system fused ATPase/permease subunit', 214, NULL, NULL, 161233),
(161234, '2.20.100.10-FF-000143', NULL, 'Complement factor properdin', 64, NULL, NULL, 161234),
(161235, '2.170.140.10-FF-000032', NULL, 'BcDNA.GH02976', 69, NULL, NULL, 161235),
(161236, '1.25.10.10-FF-000395', NULL, 'transportin-3 isoform X2', 501, NULL, NULL, 161236),
(161237, '2.70.210.12-FF-000002', NULL, 'Putative gtp-binding protein 10', 136, NULL, NULL, 161237),
(161238, '1.10.510.10-FF-002698', NULL, NULL, 141, NULL, NULL, 161238),
(161239, '1.20.1250.20-FF-001565', NULL, 'MFS general substrate transporter', 388, NULL, NULL, 161239),
(161240, '1.10.20.10-FF-000266', NULL, NULL, 123, NULL, NULL, 161240),
(161241, '3.90.470.10-FF-000027', NULL, 'LSU ribosomal protein L22P', 164, NULL, NULL, 161241);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(161242, '1.10.510.10-FF-000574', NULL, 'Cell division related protein kinase 2', 207, NULL, NULL, 161242),
(161243, '2.40.100.10-FF-000066', NULL, 'Peptidyl-prolyl cis-trans isomerase-like 2', 181, NULL, NULL, 161243),
(161244, '3.40.50.300-FF-008368', NULL, 'Uncharacterized protein', 193, NULL, NULL, 161244),
(161245, '1.25.40.190-FF-000007', NULL, 'Actin-related protein 2/3 complex subunit 5', 125, NULL, NULL, 161245),
(161246, '3.30.70.330-FF-002661', NULL, NULL, 118, NULL, NULL, 161246),
(161247, '1.10.10.10-FF-000664', NULL, 'Lactose phosphotransferase system repressor', 58, NULL, NULL, 161247),
(161248, '3.40.50.2300-FF-000255', NULL, 'BMP family ABC transporter substrate-binding protein', 163, NULL, NULL, 161248),
(161249, '2.60.40.10-FF-003213', NULL, NULL, 82, NULL, NULL, 161249),
(161250, '2.60.40.10-FF-004950', NULL, NULL, 93, NULL, NULL, 161250),
(161251, '1.10.238.10-FF-000974', NULL, 'Uncharacterized protein', 72, NULL, NULL, 161251),
(161252, '2.120.10.80-FF-000166', NULL, 'Klhl4 protein', 86, NULL, NULL, 161252),
(161253, '3.40.50.720-FF-002305', NULL, 'Uncharacterized protein', 143, NULL, NULL, 161253),
(161254, '1.25.40.180-FF-000004', NULL, 'pre-mRNA-splicing factor CWC22 homolog', 291, NULL, NULL, 161254),
(161255, '1.20.900.10-FF-000101', NULL, 'Rho guanine nucleotide exchange factor (GEF) 26', 93, NULL, NULL, 161255),
(161256, '3.30.710.10-FF-000251', NULL, 'Uncharacterized protein, isoform A', 128, NULL, NULL, 161256),
(161257, '3.30.160.60-FF-005321', NULL, NULL, 76, NULL, NULL, 161257),
(161258, '1.10.8.790-FF-000002', NULL, 'RNA-dependent RNA polymerase', 75, NULL, NULL, 161258),
(161259, '3.60.21.10-FF-000486', NULL, 'Protein CBG05769', 187, NULL, NULL, 161259),
(161260, '1.10.1070.11-FF-000129', NULL, 'Uncharacterized protein', 83, NULL, NULL, 161260),
(161261, '1.25.40.10-FF-004612', NULL, 'Uncharacterized Sel1-like repeat-containing protein C1B3.10c', 162, NULL, NULL, 161261),
(161262, '3.30.40.230-FF-000006', NULL, 'Glycine-tRNA ligase', 44, NULL, NULL, 161262),
(161263, '3.40.140.10-FF-000076', NULL, 'COP9 signalosome complex subunit 5', 220, NULL, NULL, 161263),
(161264, '2.40.30.10-FF-000454', NULL, 'Uncharacterized protein', 125, NULL, NULL, 161264),
(161265, '3.10.20.90-FF-000689', NULL, 'Non-specific serine/threonine protein kinase', 90, NULL, NULL, 161265),
(161266, '3.30.2160.10-FF-000028', NULL, 'Ubiquitin ligase e3', 70, NULL, NULL, 161266),
(161267, '1.20.90.10-FF-000011', NULL, 'Phospholipase A(2)', 131, NULL, NULL, 161267),
(161268, '1.20.1250.20-FF-000721', NULL, 'Synaptic vesicle glycoprotein 2C', 334, NULL, NULL, 161268),
(161269, '3.30.70.330-FF-000744', NULL, 'RNA recognition motif (RRM)-containing protein', 116, NULL, NULL, 161269),
(161270, '3.30.40.10-FF-000183', NULL, 'putative E3 ubiquitin-protein ligase UBR7', 60, NULL, NULL, 161270),
(161271, '2.60.120.260-FF-000370', NULL, 'Protein CBG10890', 120, NULL, NULL, 161271),
(161272, '1.20.1080.10-FF-000008', NULL, 'Nitrite transporter NirC', 259, NULL, NULL, 161272),
(161273, '1.10.150.670-FF-000033', NULL, 'Uncharacterized protein', 89, NULL, NULL, 161273),
(161274, '3.20.20.190-FF-000110', NULL, 'Uncharacterized protein', 350, NULL, NULL, 161274),
(161275, '3.40.50.1980-FF-000136', NULL, 'Periplasmic binding protein', 127, NULL, NULL, 161275),
(161276, '3.30.2010.10-FF-000028', NULL, 'Uncharacterized protein', 38, NULL, NULL, 161276),
(161277, '2.30.29.30-FF-001199', NULL, 'Mitogen-activated protein kinase associated protein 1', 63, NULL, NULL, 161277),
(161278, '1.20.58.2190-FF-000013', NULL, 'Uncharacterized protein', 94, NULL, NULL, 161278),
(161279, '3.30.70.660-FF-000028', NULL, 'tRNA pseudouridine synthase', 217, NULL, NULL, 161279),
(161280, '3.40.50.620-FF-000140', NULL, 'Cysteine--tRNA ligase', 325, NULL, NULL, 161280),
(161281, '1.10.472.10-FF-000681', NULL, 'G1/S-specific cyclin pas1', 186, NULL, NULL, 161281),
(161282, '1.10.10.10-FF-000990', NULL, 'Putative Crp-family transcriptional regulator', 79, NULL, NULL, 161282),
(161283, '2.160.10.10-FF-000065', NULL, 'Carbonic anhydrase', 212, NULL, NULL, 161283);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(161284, '3.40.50.300-FF-008582', NULL, 'Terminase, large subunit, putative', 195, NULL, NULL, 161284),
(161285, '1.20.58.1780-FF-000019', NULL, 'Nuclear pore complex protein NUP155', 120, NULL, NULL, 161285),
(161286, '3.40.50.12780-FF-000003', NULL, 'Long-chain-fatty-acid--CoA ligase FadD', 434, NULL, NULL, 161286),
(161287, '3.90.226.10-FF-000269', NULL, '3-hydroxyisobutyryl-CoA hydrolase 1', 237, NULL, NULL, 161287),
(161288, '1.25.40.10-FF-004275', NULL, 'Uncharacterized protein', 349, NULL, NULL, 161288),
(161289, '2.60.120.650-FF-000166', NULL, 'Uncharacterized protein', 202, NULL, NULL, 161289),
(161290, '3.30.40.10-FF-002318', NULL, 'Predicted protein', 104, NULL, NULL, 161290),
(161291, '1.10.150.120-FF-000003', NULL, 'Carbon monoxide dehydrogenase, small subunit', 84, NULL, NULL, 161291),
(161292, '3.30.1490.20-FF-000100', NULL, 'Cycloserine biosynthesis protein DcsG', 71, NULL, NULL, 161292),
(161293, '3.40.50.11370-FF-000013', NULL, 'Uncharacterized protein', 92, NULL, NULL, 161293),
(161294, '3.30.230.10-FF-000006', NULL, 'Translation elongation factor 2', 154, NULL, NULL, 161294),
(161295, '3.30.200.20-FF-000507', NULL, 'Non-specific serine/threonine protein kinase', 98, NULL, NULL, 161295),
(161296, '3.10.20.10-FF-000025', NULL, '60S ribosomal protein L18a', 76, NULL, NULL, 161296),
(161297, '1.25.40.20-FF-001052', NULL, 'Uncharacterized protein', 219, NULL, NULL, 161297),
(161298, '3.80.10.10-FF-001797', NULL, 'GD21685', 115, NULL, NULL, 161298),
(161299, '1.10.1170.10-FF-000052', NULL, 'Uncharacterized protein', 95, NULL, NULL, 161299),
(161300, '3.30.450.20-FF-000216', NULL, 'Sensory box/GGDEF family protein', 114, NULL, NULL, 161300),
(161301, '2.30.40.10-FF-000016', NULL, 'Guanine deaminase', 97, NULL, NULL, 161301),
(161302, '1.10.150.240-FF-000039', NULL, 'Epoxide hydrolase 2', 45, NULL, NULL, 161302),
(161303, '1.25.40.170-FF-000001', NULL, 'Protein Smaug homolog 1 isoform 2', 79, NULL, NULL, 161303),
(161304, '1.10.10.60-FF-000297', NULL, 'AraC family transcriptional regulator', 54, NULL, NULL, 161304),
(161305, '2.30.42.10-FF-000083', NULL, 'Tail-specific protease', 95, NULL, NULL, 161305),
(161306, '2.10.50.30-FF-000035', NULL, 'Uncharacterized protein', 36, NULL, NULL, 161306),
(161307, '3.40.50.1820-FF-000116', NULL, 'Sterigmatocystin biosynthesis polyketide synthase', 271, NULL, NULL, 161307),
(161308, '4.10.91.10-FF-000001', NULL, 'Cytochrome c oxidase subunit 7A1, mitochondrial', 58, NULL, NULL, 161308),
(161309, '1.20.1530.20-FF-000092', NULL, 'Predicted protein', 284, NULL, NULL, 161309),
(161310, '2.10.55.10-FF-000001', NULL, 'Leishmanolysin like peptidase', 78, NULL, NULL, 161310),
(161311, '1.25.10.10-FF-002744', NULL, 'Predicted protein', 760, NULL, NULL, 161311),
(161312, '3.50.7.10-FF-000084', NULL, NULL, 19, NULL, NULL, 161312),
(161313, '2.130.10.10-FF-004714', NULL, 'MIP10235p', 169, NULL, NULL, 161313),
(161314, '3.40.50.1000-FF-000438', NULL, 'Uncharacterized protein, isoform A', 168, NULL, NULL, 161314),
(161315, '1.25.40.10-FF-002246', NULL, 'Os01g0301700 protein', 133, NULL, NULL, 161315),
(161316, '3.40.50.2300-FF-000160', NULL, 'DNA-binding transcriptional repressor EbgR', 129, NULL, NULL, 161316),
(161317, '3.30.559.10-FF-000022', NULL, 'Trehalose-2-sulfate acyltransferase papA2', 188, NULL, NULL, 161317),
(161318, '1.10.357.90-FF-000004', NULL, 'Telomerase reverse transcriptase', 165, NULL, NULL, 161318),
(161319, '2.60.40.1090-FF-000011', NULL, 'Fimbrial-like adhesin protein', 148, NULL, NULL, 161319),
(161320, '3.40.190.10-FF-000466', NULL, 'ABC transporter substrate-binding protein', 285, NULL, NULL, 161320),
(161321, '1.10.150.130-FF-000006', NULL, 'Prophage DLP12 integrase', 133, NULL, NULL, 161321),
(161322, '2.60.40.10-FF-000779', NULL, 'Titin b', 100, NULL, NULL, 161322),
(161323, '3.10.129.10-FF-000067', NULL, 'Thioesterase-like family protein', 136, NULL, NULL, 161323),
(161324, '1.20.1070.10-FF-002065', NULL, 'Predicted protein', 78, NULL, NULL, 161324),
(161325, '3.40.50.720-FF-000265', NULL, 'NAD dependent epimerase/dehydratase family protein', 264, NULL, NULL, 161325);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(161326, '1.25.10.10-FF-001333', NULL, 'AGAP012183-PA', 466, NULL, NULL, 161326),
(161327, '3.30.40.10-FF-002223', NULL, 'RBR-type E3 ubiquitin transferase', 123, NULL, NULL, 161327),
(161328, '1.20.1250.20-FF-002071', NULL, 'Uncharacterized protein', 281, NULL, NULL, 161328),
(161329, '3.80.10.10-FF-003484', NULL, 'Fgr28p', 324, NULL, NULL, 161329),
(161330, '2.130.10.10-FF-005203', NULL, 'ELongator complex Protein Component', 100, NULL, NULL, 161330),
(161331, '3.40.50.300-FF-003360', NULL, 'Methylcoenzyme M reductase system, component A2', 245, NULL, NULL, 161331),
(161332, '2.60.40.420-FF-000234', NULL, 'Periplasmic cell division protein (SufI)', 144, NULL, NULL, 161332),
(161333, '1.25.40.20-FF-001731', NULL, 'Glycerophosphodiester phosphodiesterase gde1', 223, NULL, NULL, 161333),
(161334, '1.10.510.10-FF-001400', NULL, 'Mitogen-activated protein kinase-like protein', 260, NULL, NULL, 161334),
(161335, '2.60.40.10-FF-004624', NULL, NULL, 57, NULL, NULL, 161335),
(161336, '1.20.1560.10-FF-000702', NULL, 'ABC transporter, ATP-binding protein, MsbA family', 352, NULL, NULL, 161336),
(161337, '3.50.50.60-FF-000736', NULL, 'Probable oxidoreductase', 203, NULL, NULL, 161337),
(161338, '3.40.1190.20-FF-000103', NULL, 'Tagatose-6-phosphate kinase-like protein', 312, NULL, NULL, 161338),
(161339, '3.40.50.300-FF-005142', NULL, 'Putative ABC transporter ATP-binding protein VNG_1631G', 235, NULL, NULL, 161339),
(161340, '2.60.210.10-FF-000058', NULL, NULL, 122, NULL, NULL, 161340),
(161341, '3.40.850.10-FF-000141', NULL, 'Kinesin-like protein KIN-6', 363, NULL, NULL, 161341),
(161342, '3.30.2350.10-FF-000054', NULL, 'Pseudouridine synthase', 246, NULL, NULL, 161342),
(161343, '1.10.400.10-FF-000099', NULL, 'Uncharacterized protein', 118, NULL, NULL, 161343),
(161344, '3.40.50.620-FF-000235', NULL, 'Leucine--tRNA ligase, putative', 109, NULL, NULL, 161344),
(161345, '3.40.50.80-FF-000142', NULL, 'Ferric reductase-like protein', 171, NULL, NULL, 161345),
(161346, '3.40.50.300-FF-001117', NULL, 'Mitochondrial Rho GTPase 2', 102, NULL, NULL, 161346),
(161347, '2.70.230.10-FF-000001', NULL, 'Envelope glycoprotein D', 285, NULL, NULL, 161347),
(161348, '2.130.10.10-FF-004809', NULL, 'Shk1 kinase-binding protein 15', 143, NULL, NULL, 161348),
(161349, '2.30.30.40-FF-000654', NULL, 'Small G protein signaling modulator 3', 69, NULL, NULL, 161349),
(161350, '3.30.565.10-FF-000177', NULL, 'Mlh3p', 227, NULL, NULL, 161350),
(161351, '3.30.160.60-FF-000779', NULL, 'zinc finger protein 385B isoform X1', 53, NULL, NULL, 161351),
(161352, '3.40.50.2300-FF-000581', NULL, 'Metabotropic glutamate receptor-like protein D', 158, NULL, NULL, 161352),
(161353, '3.40.50.2000-FF-000272', NULL, 'Adhesin', 182, NULL, NULL, 161353),
(161354, '2.60.40.10-FF-006086', NULL, NULL, 45, NULL, NULL, 161354),
(161355, '3.40.50.11660-FF-000010', NULL, 'Uncharacterized protein', 200, NULL, NULL, 161355),
(161356, '1.10.10.60-FF-001140', NULL, NULL, 59, NULL, NULL, 161356),
(161357, '1.10.630.10-FF-000150', NULL, 'beta-amyrin 11-oxidase', 405, NULL, NULL, 161357),
(161358, '3.40.50.460-FF-000035', NULL, 'Phosphofructokinase family protein', 123, NULL, NULL, 161358),
(161359, '2.60.40.10-FF-000684', NULL, 'Dystroglycan 1', 114, NULL, NULL, 161359),
(161360, '1.20.140.20-FF-000012', NULL, '[Pyruvate dehydrogenase (acetyl-transferring)] kinase isozyme 1, mitochondrial', 56, NULL, NULL, 161360),
(161361, '3.40.50.970-FF-000109', NULL, 'Indolepyruvate oxidoreductase subunit IorA', 143, NULL, NULL, 161361),
(161362, '3.10.20.90-FF-000577', NULL, 'FERM, RhoGEF (ARHGEF) and pleckstrin domain protein 1 (chondrocyte-derived)', 77, NULL, NULL, 161362),
(161363, '1.20.5.470-FF-000011', NULL, 'Uncharacterized protein', 36, NULL, NULL, 161363),
(161364, '2.130.10.10-FF-002348', NULL, 'Guanine nucleotide-binding beta subunit-like protein', 204, NULL, NULL, 161364),
(161365, '3.30.200.20-FF-000496', NULL, 'Cell cycle protein kinase', 104, NULL, NULL, 161365),
(161366, '3.50.50.60-FF-000950', NULL, 'FAD-dependent oxidoreductase domain-containing protein 1', 211, NULL, NULL, 161366);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(161367, '1.10.287.1350-FF-000001', NULL, 'Carminomycin 4-O-methyltransferase DnrK', 76, NULL, NULL, 161367),
(161368, '1.10.238.10-FF-000648', NULL, 'Uncharacterized protein', 103, NULL, NULL, 161368),
(161369, '3.30.70.330-FF-000632', NULL, 'Poly(A) binding protein', 84, NULL, NULL, 161369),
(161370, '3.40.50.2000-FF-000058', NULL, 'Alpha-1,3-glucan synthase Ags1', 247, NULL, NULL, 161370),
(161371, '1.10.418.10-FF-000067', NULL, 'kinesin-like protein KIN-14F', 130, NULL, NULL, 161371),
(161372, '3.80.10.10-FF-001808', NULL, 'Antagonist of mitotic exit network protein 1', 70, NULL, NULL, 161372),
(161373, '3.30.505.10-FF-000089', NULL, 'Transcription elongation factor spt6', 97, NULL, NULL, 161373),
(161374, '1.10.287.70-FF-000133', NULL, 'KCNN (Potassium K ChaNNel, calcium activated)-Like', 99, NULL, NULL, 161374),
(161375, '1.20.1250.20-FF-001891', NULL, 'Uncharacterized protein', 79, NULL, NULL, 161375),
(161376, '2.60.40.10-FF-001173', NULL, 'Usherin', 102, NULL, NULL, 161376),
(161377, '3.30.40.10-FF-000071', NULL, 'Histone-lysine N-methyltransferase', 65, NULL, NULL, 161377),
(161378, '1.20.1300.10-FF-000049', NULL, 'Uncharacterized protein', 151, NULL, NULL, 161378),
(161379, '3.50.50.60-FF-000057', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 180, NULL, NULL, 161379),
(161380, '2.60.120.260-FF-000482', NULL, 'Uncharacterized protein', 136, NULL, NULL, 161380),
(161381, '3.30.300.30-FF-000080', NULL, 'Aspergillus niger contig An11c0010, genomic contig', 127, NULL, NULL, 161381),
(161382, '2.20.70.10-FF-000159', NULL, 'Predicted protein', 35, NULL, NULL, 161382),
(161383, '3.30.200.20-FF-000833', NULL, 'Protein kinase KNS1', 89, NULL, NULL, 161383),
(161384, '3.20.20.80-FF-000141', NULL, 'Glucosylceramidase beta 3 (gene/pseudogene)', 98, NULL, NULL, 161384),
(161385, '3.30.70.330-FF-000306', NULL, 'CUGBP Elav-like family member 4 isoform X47', 66, NULL, NULL, 161385),
(161386, '1.20.1070.10-FF-002082', NULL, 'Uncharacterized protein', 269, NULL, NULL, 161386),
(161387, '2.30.29.30-FF-000013', NULL, 'Putative TBC1 domain family member 8B', 106, NULL, NULL, 161387),
(161388, '1.25.10.10-FF-000518', NULL, 'Receptor mediated endocytosis 8, isoform B', 192, NULL, NULL, 161388),
(161389, '1.25.40.10-FF-005101', NULL, 'LD22235p', 44, NULL, NULL, 161389),
(161390, '3.30.2090.10-FF-000016', NULL, 'RND multidrug efflux transporter', 93, NULL, NULL, 161390),
(161391, '1.25.40.10-FF-004819', NULL, 'Uncharacterized protein', 152, NULL, NULL, 161391),
(161392, '1.25.40.10-FF-003201', NULL, 'Uncharacterized protein', 89, NULL, NULL, 161392),
(161393, '2.40.50.770-FF-000025', NULL, 'Predicted protein', 59, NULL, NULL, 161393),
(161394, '3.30.1240.10-FF-000051', NULL, 'Cof-type HAD-IIB family hydrolase', 108, NULL, NULL, 161394),
(161395, '3.30.230.10-FF-000332', NULL, 'DNA topoisomerase 2', 75, NULL, NULL, 161395),
(161396, '3.10.110.10-FF-000058', NULL, 'Ubiquitin-conjugating enzyme E2 6', 153, NULL, NULL, 161396),
(161397, '2.170.300.10-FF-000016', NULL, 'Multiple epidermal growth factor-like domains 10', 91, NULL, NULL, 161397),
(161398, '1.10.3720.10-FF-000218', NULL, 'Peptide/nickel transport system permease protein', 192, NULL, NULL, 161398),
(161399, '3.30.160.20-FF-000211', NULL, 'Predicted protein', 89, NULL, NULL, 161399),
(161400, '3.40.350.10-FF-000097', NULL, 'AGL032Cp', 155, NULL, NULL, 161400),
(161401, '3.40.640.10-FF-000439', NULL, 'Predicted protein', 206, NULL, NULL, 161401),
(161402, '1.20.1560.10-FF-000253', NULL, 'ABC transporter ATP-binding protein', 315, NULL, NULL, 161402),
(161403, '1.10.238.10-FF-000862', NULL, 'Phospholipase D B', 224, NULL, NULL, 161403),
(161404, '2.130.10.10-FF-000662', NULL, 'WD repeat domain 73', 366, NULL, NULL, 161404),
(161405, '1.25.40.10-FF-002925', NULL, 'Uncharacterized protein', 164, NULL, NULL, 161405),
(161406, '3.30.420.10-FF-000032', NULL, 'Retrovirus-related Pol polyprotein from transposon 297-like Protein', 199, NULL, NULL, 161406),
(161407, '2.30.30.40-FF-000637', NULL, 'Uncharacterized protein', 84, NULL, NULL, 161407);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(161408, '3.40.390.10-FF-000217', NULL, NULL, 203, NULL, NULL, 161408),
(161409, '1.10.10.250-FF-000001', NULL, '50S ribosomal protein L11', 72, NULL, NULL, 161409),
(161410, '3.100.10.10-FF-000030', NULL, 'Putative 60S ribosomal protein L27a-1', 37, NULL, NULL, 161410),
(161411, '3.40.630.10-FF-000372', NULL, 'ACY1L2 protein, putative', 115, NULL, NULL, 161411),
(161412, '1.10.8.10-FF-000005', NULL, 'Non-specific serine/threonine protein kinase', 45, NULL, NULL, 161412),
(161413, '2.160.20.10-FF-000234', NULL, 'Pectinesterase', 223, NULL, NULL, 161413),
(161414, '2.40.50.40-FF-000104', NULL, 'Uncharacterized protein', 73, NULL, NULL, 161414),
(161415, '1.10.8.20-FF-000008', NULL, 'SEC14 cytosolic factor family protein', 72, NULL, NULL, 161415),
(161416, '3.60.15.10-FF-000185', NULL, 'Uncharacterized protein', 282, NULL, NULL, 161416),
(161417, '2.40.10.10-FF-000571', NULL, NULL, 62, NULL, NULL, 161417),
(161418, '3.10.310.10-FF-000040', NULL, 'Diaminopimelate epimerase', 145, NULL, NULL, 161418),
(161419, '2.60.40.10-FF-002584', NULL, 'Filamin 2, putative', 104, NULL, NULL, 161419),
(161420, '2.60.40.10-FF-005225', NULL, NULL, 90, NULL, NULL, 161420),
(161421, '3.30.497.10-FF-000147', NULL, 'Serpin, putative', 105, NULL, NULL, 161421),
(161422, '3.40.50.1000-FF-000859', NULL, NULL, 49, NULL, NULL, 161422),
(161423, '3.40.50.150-FF-000757', NULL, 'Ribosomal RNA small subunit methyltransferase G', 197, NULL, NULL, 161423),
(161424, '1.20.1560.10-FF-000023', NULL, 'Multidrug ABC transporter ATP-binding protein', 323, NULL, NULL, 161424),
(161425, '1.25.40.820-FF-000011', NULL, 'AGAP008431-PA', 155, NULL, NULL, 161425),
(161426, '2.10.10.10-FF-000015', NULL, 'Binder of sperm protein homolog 2', 50, NULL, NULL, 161426),
(161427, '3.40.850.10-FF-000253', NULL, 'Kinesin-like protein', 294, NULL, NULL, 161427),
(161428, '3.10.100.10-FF-000226', NULL, 'Lymphocyte antigen 75', 149, NULL, NULL, 161428),
(161429, '1.25.40.10-FF-002684', NULL, 'Putative TPR repeat family protein', 157, NULL, NULL, 161429),
(161430, '3.30.160.60-FF-004495', NULL, NULL, 31, NULL, NULL, 161430),
(161431, '3.40.630.10-FF-000276', NULL, 'IAA-amino acid hydrolase ILR1-like 4 isoform B', 146, NULL, NULL, 161431),
(161432, '3.40.1110.10-FF-000112', NULL, 'Metal cation transporter P-type ATPase', 131, NULL, NULL, 161432),
(161433, '3.80.10.10-FF-004422', NULL, 'Leucine-rich repeat family protein', 131, NULL, NULL, 161433),
(161434, '1.10.357.10-FF-000037', NULL, 'TetR family transcriptional regulator', 194, NULL, NULL, 161434),
(161435, '1.25.40.20-FF-001501', NULL, 'Uncharacterized protein', 54, NULL, NULL, 161435),
(161436, '3.40.50.620-FF-000123', NULL, 'Universal stress protein family', 148, NULL, NULL, 161436),
(161437, '3.40.50.1820-FF-000330', NULL, 'Monoglyceride lipase', 227, NULL, NULL, 161437),
(161438, '3.40.30.10-FF-001233', NULL, 'Protein disulfide-isomerase', 106, NULL, NULL, 161438),
(161439, '2.70.150.10-FF-000079', NULL, 'Copper-transporting ATPase', 108, NULL, NULL, 161439),
(161440, '3.10.450.700-FF-000013', NULL, 'Transcription factor Pur-alpha 1', 54, NULL, NULL, 161440),
(161441, '2.60.40.1180-FF-000179', NULL, 'Lysosomal alpha-mannosidase, putative', 118, NULL, NULL, 161441),
(161442, '3.90.79.10-FF-000180', NULL, 'Uncharacterized protein', 155, NULL, NULL, 161442),
(161443, '1.10.10.1410-FF-000001', NULL, '60S acidic ribosomal protein P1', 64, NULL, NULL, 161443),
(161444, '3.50.4.10-FF-000061', NULL, NULL, 83, NULL, NULL, 161444),
(161445, '1.20.1420.30-FF-000103', NULL, 'Vacuolar cation/proton exchanger 2', 155, NULL, NULL, 161445),
(161446, '1.25.40.10-FF-001402', NULL, 'Intraflagellar transport protein 56 homolog', 237, NULL, NULL, 161446),
(161447, '3.30.300.30-FF-000107', NULL, 'PKS-NRPS hybrid synthetase psoA', 105, NULL, NULL, 161447),
(161448, '1.20.1310.10-FF-000218', NULL, NULL, 72, NULL, NULL, 161448),
(161449, '1.20.1270.60-FF-000021', NULL, 'Endophilin-A2 isoform 1', 247, NULL, NULL, 161449),
(161450, '3.40.50.2000-FF-000384', NULL, 'Glycosyltransferase', 247, NULL, NULL, 161450),
(161451, '3.40.30.10-FF-000957', NULL, 'Uncharacterized protein', 105, NULL, NULL, 161451);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(161452, '3.60.10.10-FF-000207', NULL, 'Endonuclease/exonuclease/phosphatase-like protein', 190, NULL, NULL, 161452),
(161453, '1.50.40.10-FF-000597', NULL, 'Mitochondrial amino acid carrier', 130, NULL, NULL, 161453),
(161454, '1.10.418.10-FF-000179', NULL, 'LIM domain only protein 7', 80, NULL, NULL, 161454),
(161455, '2.10.25.10-FF-001590', NULL, 'Uncharacterized protein', 51, NULL, NULL, 161455),
(161456, '1.10.10.1420-FF-000004', NULL, 'DNA replication factor Cdt1', 137, NULL, NULL, 161456),
(161457, '3.90.1150.10-FF-000261', NULL, 'Nucleotide sugar transaminase', 139, NULL, NULL, 161457),
(161458, '3.40.50.1220-FF-000015', NULL, 'NAD-dependent protein deacetylase SRT1', 176, NULL, NULL, 161458),
(161459, '1.20.58.60-FF-000552', NULL, 'Spectrin beta chain', 47, NULL, NULL, 161459),
(161460, '1.20.120.1750-FF-000165', NULL, 'RBR-type E3 ubiquitin transferase', 192, NULL, NULL, 161460),
(161461, '2.130.10.10-FF-003163', NULL, 'AGR180Wp', 374, NULL, NULL, 161461),
(161462, '1.20.120.1240-FF-000023', NULL, 'Dynamin-like protein', 263, NULL, NULL, 161462),
(161463, '3.30.1370.10-FF-000049', NULL, 'far upstream element-binding protein 2', 85, NULL, NULL, 161463),
(161464, '2.130.10.10-FF-004591', NULL, 'Uncharacterized protein', 345, NULL, NULL, 161464),
(161465, '1.25.40.20-FF-001405', NULL, 'Uncharacterized protein', 157, NULL, NULL, 161465),
(161466, '3.40.190.10-FF-000915', NULL, 'Predicted protein', 356, NULL, NULL, 161466),
(161467, '2.40.160.110-FF-000017', NULL, 'Uncharacterized protein', 174, NULL, NULL, 161467),
(161468, '3.30.60.30-FF-000089', NULL, 'Uncharacterized protein', 57, NULL, NULL, 161468),
(161469, '1.20.1070.10-FF-000620', NULL, 'Uncharacterized protein', 336, NULL, NULL, 161469),
(161470, '3.30.60.20-FF-000086', NULL, 'Thymidine kinase', 48, NULL, NULL, 161470),
(161471, '3.90.70.10-FF-000867', NULL, 'Peptidase C19 family protein', 76, NULL, NULL, 161471),
(161472, '1.20.58.390-FF-000329', NULL, 'Uncharacterized protein', 118, NULL, NULL, 161472),
(161473, '3.40.50.300-FF-004883', NULL, 'Uncharacterized protein', 183, NULL, NULL, 161473),
(161474, '3.90.1510.10-FF-000002', NULL, 'Glycerate kinase', 115, NULL, NULL, 161474),
(161475, '1.10.287.70-FF-000021', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 164, NULL, NULL, 161475),
(161476, '1.25.10.10-FF-002418', NULL, 'GTPase-binding protein rid1', 250, NULL, NULL, 161476),
(161477, '2.60.40.10-FF-001061', NULL, 'Uncharacterized protein, isoform C', 109, NULL, NULL, 161477),
(161478, '3.80.10.10-FF-000044', NULL, 'Putative leucine-rich repeat protein shoc-2', 113, NULL, NULL, 161478),
(161479, '3.40.50.11900-FF-000003', NULL, '(R)-2-hydroxyglutaryl-CoA dehydratase subunit alpha', 148, NULL, NULL, 161479),
(161480, '3.30.710.10-FF-000037', NULL, 'BTB (POZ) domain containing 1', 159, NULL, NULL, 161480),
(161481, '1.20.930.80-FF-000017', NULL, 'Uncharacterized protein', 119, NULL, NULL, 161481),
(161482, '3.40.50.1820-FF-001639', NULL, 'Esterase, putative', 412, NULL, NULL, 161482),
(161483, '3.40.50.20-FF-000034', NULL, 'D-alanine--D-alanine ligase', 126, NULL, NULL, 161483),
(161484, '3.30.1360.200-FF-000005', NULL, 'Protein translocase subunit SecD', 124, NULL, NULL, 161484),
(161485, '3.40.5.10-FF-000017', NULL, '50S ribosomal protein L9', 46, NULL, NULL, 161485),
(161486, '3.30.420.40-FF-000608', NULL, 'Glucokinase regulator family protein, putative', 118, NULL, NULL, 161486),
(161487, '1.20.5.700-FF-000001', NULL, 'Cytochrome f', 34, NULL, NULL, 161487),
(161488, '2.40.70.10-FF-000349', NULL, NULL, 153, NULL, NULL, 161488),
(161489, '2.10.50.10-FF-000012', NULL, 'tumor necrosis factor receptor superfamily member 16', 50, NULL, NULL, 161489),
(161490, '2.120.10.30-FF-000516', NULL, 'Uncharacterized protein', 192, NULL, NULL, 161490),
(161491, '3.30.70.270-FF-000018', NULL, 'Diguanylate cyclase domain protein', 162, NULL, NULL, 161491),
(161492, '3.20.20.450-FF-000014', NULL, 'Diguanylate phosphodiesterase', 251, NULL, NULL, 161492),
(161493, '2.130.10.10-FF-004826', NULL, 'Uncharacterized protein', 136, NULL, NULL, 161493); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(161494, '3.40.50.2000-FF-000513', NULL, 'UDP-glucuronosyltransferase', 167, NULL, NULL, 161494),
(161495, '3.80.10.10-FF-001685', NULL, 'Dynein regulatory complex subunit 5', 125, NULL, NULL, 161495),
(161496, '3.40.1410.10-FF-000045', NULL, 'Probable chorismate pyruvate-lyase', 170, NULL, NULL, 161496),
(161497, '1.20.930.60-FF-000011', NULL, 'Putative methyltransferase', 122, NULL, NULL, 161497),
(161498, '3.40.50.300-FF-006906', NULL, 'Uncharacterized protein', 238, NULL, NULL, 161498),
(161499, '3.30.450.20-FF-000104', NULL, 'Sensor histidine kinase/response regulator', 109, NULL, NULL, 161499),
(161500, '1.10.510.10-FF-000557', NULL, 'Serine/threonine-protein kinase 33', 350, NULL, NULL, 161500),
(161501, '2.40.50.140-FF-001112', NULL, NULL, 106, NULL, NULL, 161501),
(161502, '3.60.21.10-FF-000469', NULL, 'Uncharacterized protein', 91, NULL, NULL, 161502),
(161503, '3.30.230.130-FF-000047', NULL, 'Uncharacterized protein', 164, NULL, NULL, 161503),
(161504, '3.30.40.10-FF-000306', NULL, 'PHD finger alfin-like protein', 57, NULL, NULL, 161504),
(161505, '3.30.200.20-FF-000737', NULL, 'Protein kinase putative (CRK)', 83, NULL, NULL, 161505),
(161506, '1.20.5.710-FF-000004', NULL, '50S ribosomal protein L7/L12', 53, NULL, NULL, 161506),
(161507, '2.60.120.260-FF-000044', NULL, 'Reelin', 142, NULL, NULL, 161507),
(161508, '1.10.1600.10-FF-000029', NULL, 'ATP-dependent DNA helicase', 104, NULL, NULL, 161508),
(161509, '2.60.40.10-FF-004169', NULL, NULL, 87, NULL, NULL, 161509),
(161510, '1.20.1250.20-FF-001918', NULL, 'Putative nitrate transporter', 223, NULL, NULL, 161510),
(161511, '2.60.40.10-FF-006069', NULL, NULL, 95, NULL, NULL, 161511),
(161512, '3.40.630.40-FF-000026', NULL, 'Uncharacterized protein', 222, NULL, NULL, 161512),
(161513, '3.30.70.330-FF-002431', NULL, NULL, 156, NULL, NULL, 161513),
(161514, '3.40.50.150-FF-001246', NULL, NULL, 218, NULL, NULL, 161514),
(161515, '3.40.50.720-FF-001788', NULL, 'Uncharacterized protein', 200, NULL, NULL, 161515),
(161516, '3.30.60.20-FF-000069', NULL, 'SET domain binding factor', 62, NULL, NULL, 161516),
(161517, '1.25.10.10-FF-002856', NULL, 'Uncharacterized protein', 167, NULL, NULL, 161517),
(161518, '1.10.510.10-FF-001063', NULL, 'Protein kinase-like protein', 220, NULL, NULL, 161518),
(161519, '3.20.20.100-FF-000140', NULL, 'Predicted protein', 295, NULL, NULL, 161519),
(161520, '3.50.50.60-FF-000287', NULL, 'Cholesterol oxidase ChoD', 175, NULL, NULL, 161520),
(161521, '2.30.30.100-FF-000132', NULL, 'Putative small nuclear ribonucleoprotein G', 61, NULL, NULL, 161521),
(161522, '3.30.70.330-FF-002644', NULL, NULL, 121, NULL, NULL, 161522),
(161523, '1.25.40.10-FF-002358', NULL, 'ERAD-associated E3 ubiquitin-protein ligase component HRD3A', 114, NULL, NULL, 161523),
(161524, '3.90.640.10-FF-000170', NULL, 'Actin-related protein 8', 103, NULL, NULL, 161524),
(161525, '3.30.460.20-FF-000032', NULL, 'Magnesium transport protein CorA', 138, NULL, NULL, 161525),
(161526, '1.20.58.1380-FF-000006', NULL, 'Nuclear pore complex protein Nup133', 94, NULL, NULL, 161526),
(161527, '1.10.150.50-FF-000102', NULL, 'uncharacterized protein LOC108093779', 84, NULL, NULL, 161527),
(161528, '3.30.160.60-FF-003067', NULL, NULL, 27, NULL, NULL, 161528),
(161529, '3.40.50.720-FF-002064', NULL, 'Oxidoreductase, short-chain dehydrogenase/reductase family', 157, NULL, NULL, 161529),
(161530, '3.40.50.1370-FF-000032', NULL, 'Aspartate carbamoyltransferase', 132, NULL, NULL, 161530),
(161531, '2.10.25.10-FF-000611', NULL, 'Cysteine rich with EGF like domains 1', 42, NULL, NULL, 161531),
(161532, '3.30.160.60-FF-002578', NULL, 'Blast:Zinc finger protein 568', 25, NULL, NULL, 161532),
(161533, '3.40.50.1380-FF-000035', NULL, 'Carbamoyl-phosphate synthase large chain', 139, NULL, NULL, 161533),
(161534, '3.40.50.2300-FF-000608', NULL, 'Histidine kinase', 128, NULL, NULL, 161534),
(161535, '1.10.10.10-FF-001602', NULL, 'Ribosomal protein S19', 83, NULL, NULL, 161535),
(161536, '2.70.170.10-FF-000288', NULL, 'Si:ch211-39a7.1', 49, NULL, NULL, 161536),
(161537, '3.30.70.260-FF-000015', NULL, 'Glycine cleavage system transcriptional repressor', 97, NULL, NULL, 161537);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(161538, '2.60.40.10-FF-001622', NULL, 'titin isoform X1', 98, NULL, NULL, 161538),
(161539, '3.55.50.30-FF-000009', NULL, 'DUF4974 domain-containing protein', 76, NULL, NULL, 161539),
(161540, '1.20.58.1370-FF-000003', NULL, 'Lysine-specific demethylase jmjd-3.1', 75, NULL, NULL, 161540),
(161541, '3.40.50.620-FF-000561', NULL, 'YALI0A19624p', 212, NULL, NULL, 161541),
(161542, '2.130.10.10-FF-004265', NULL, 'Uncharacterized protein', 135, NULL, NULL, 161542),
(161543, '1.20.1050.10-FF-000170', NULL, 'Uncharacterized protein', 137, NULL, NULL, 161543),
(161544, '1.25.10.10-FF-002289', NULL, 'Uncharacterized protein', 327, NULL, NULL, 161544),
(161545, '3.40.50.1110-FF-000100', NULL, 'Uncharacterized protein', 218, NULL, NULL, 161545),
(161546, '3.30.200.20-FF-002424', NULL, 'Protein kinase C delta', 127, NULL, NULL, 161546),
(161547, '1.25.40.10-FF-004258', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 227, NULL, NULL, 161547),
(161548, '3.40.50.300-FF-000954', NULL, 'Upregulator of cell proliferation', 133, NULL, NULL, 161548),
(161549, '1.10.150.120-FF-000020', NULL, NULL, 82, NULL, NULL, 161549),
(161550, '3.30.830.10-FF-000086', NULL, 'Os01g0779100 protein', 62, NULL, NULL, 161550),
(161551, '3.30.160.60-FF-004169', NULL, NULL, 36, NULL, NULL, 161551),
(161552, '3.50.50.60-FF-000512', NULL, 'Dihydropyrimidine dehydrogenase, putative', 122, NULL, NULL, 161552),
(161553, '2.10.110.10-FF-000253', NULL, 'Ci-Fhl1/2/3 protein', 61, NULL, NULL, 161553),
(161554, '2.160.20.60-FF-000007', NULL, 'Formyltransferase/hydrolase complex Fhc subunit C', 202, NULL, NULL, 161554),
(161555, '3.40.1280.10-FF-000107', NULL, 'Ribosomal RNA large subunit methyltransferase H', 139, NULL, NULL, 161555),
(161556, '2.40.160.50-FF-000042', NULL, 'Protein CBR-GOP-3', 205, NULL, NULL, 161556),
(161557, '1.10.20.10-FF-000378', NULL, NULL, 61, NULL, NULL, 161557),
(161558, '2.60.120.200-FF-000262', NULL, 'OSJNBa0027H06.10-like protein', 232, NULL, NULL, 161558),
(161559, '1.20.1070.10-FF-000053', NULL, 'Frizzled class receptor 8a', 349, NULL, NULL, 161559),
(161560, '3.30.50.10-FF-000138', NULL, 'Uncharacterized protein', 95, NULL, NULL, 161560),
(161561, '1.20.1070.10-FF-001929', NULL, 'Uncharacterized protein', 278, NULL, NULL, 161561),
(161562, '2.40.50.140-FF-000623', NULL, 'mRNA-capping enzyme', 94, NULL, NULL, 161562),
(161563, '3.30.420.40-FF-000485', NULL, 'Chaperone protein DNAK, putative', 184, NULL, NULL, 161563),
(161564, '3.40.50.300-FF-003130', NULL, 'RNA helicase', 222, NULL, NULL, 161564),
(161565, '3.10.180.10-FF-000006', NULL, 'Methylmalonyl-CoA epimerase', 134, NULL, NULL, 161565),
(161566, '2.60.40.10-FF-003090', NULL, 'Sialic-acid binding protein-4', 105, NULL, NULL, 161566),
(161567, '3.10.110.10-FF-000384', NULL, 'Uncharacterized protein', 139, NULL, NULL, 161567),
(161568, '2.10.25.10-FF-001713', NULL, 'Uncharacterized protein', 60, NULL, NULL, 161568),
(161569, '3.30.200.20-FF-001013', NULL, 'Protein kinase domain containing protein', 105, NULL, NULL, 161569),
(161570, '2.10.50.30-FF-000018', NULL, 'Uncharacterized protein', 78, NULL, NULL, 161570),
(161571, '3.40.50.1000-FF-000298', NULL, 'Haloacid dehalogenase like hydrolase domain containing 2', 132, NULL, NULL, 161571),
(161572, '3.40.390.10-FF-000094', NULL, 'Meltrin, isoform D', 203, NULL, NULL, 161572),
(161573, '3.30.63.10-FF-000005', NULL, 'Guanylate kinase', 60, NULL, NULL, 161573),
(161574, '3.30.519.10-FF-000025', NULL, NULL, 86, NULL, NULL, 161574),
(161575, '1.25.40.180-FF-000330', NULL, NULL, 108, NULL, NULL, 161575),
(161576, '3.90.1800.10-FF-000007', NULL, 'DNA-directed RNA polymerase subunit beta', 137, NULL, NULL, 161576),
(161577, '3.40.50.300-FF-006777', NULL, 'Uncharacterized protein', 60, NULL, NULL, 161577),
(161578, '3.30.70.330-FF-000177', NULL, 'U2 snRNP-associated SURP motif-containing protein-like isoform X2', 166, NULL, NULL, 161578),
(161579, '3.30.465.10-FF-000130', NULL, 'Uncharacterized protein', 110, NULL, NULL, 161579),
(161580, '3.20.140.10-FF-000041', NULL, 'Nicotinate phosphoribosyltransferase', 147, NULL, NULL, 161580);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(161581, '3.30.63.20-FF-000008', NULL, 'Uncharacterized protein', 89, NULL, NULL, 161581),
(161582, '3.40.50.300-FF-002854', NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', 208, NULL, NULL, 161582),
(161583, '3.10.129.10-FF-000084', NULL, 'Phenylacetic acid degradation protein PaaD', 118, NULL, NULL, 161583),
(161584, '3.40.50.300-FF-003343', NULL, 'ATP/GTP hydrolase', 149, NULL, NULL, 161584),
(161585, '3.30.40.10-FF-000519', NULL, 'Histone-lysine N-methyltransferase ATX4', 62, NULL, NULL, 161585),
(161586, '3.30.70.2850-FF-000023', NULL, 'DNA-directed RNA polymerase subunit', 224, NULL, NULL, 161586),
(161587, '4.10.1000.10-FF-000071', NULL, 'Zinc finger protein family member', 98, NULL, NULL, 161587),
(161588, '3.40.366.10-FF-000015', NULL, 'Malonyl CoA-acyl carrier protein transacylase', 214, NULL, NULL, 161588),
(161589, '3.40.50.300-FF-004439', NULL, 'ATP-binding cassette protein subfamily G member 3', 158, NULL, NULL, 161589),
(161590, '3.15.10.30-FF-000008', NULL, 'GM10364', 223, NULL, NULL, 161590),
(161591, '4.10.860.10-FF-000021', NULL, NULL, 47, NULL, NULL, 161591),
(161592, '3.30.870.10-FF-000077', NULL, 'Phosphatidylcholine-hydrolyzing phospholipase D (PLD) family', 146, NULL, NULL, 161592),
(161593, '2.30.29.30-FF-000125', NULL, 'Putative rab gtpase-activating protein 1', 148, NULL, NULL, 161593),
(161594, '3.30.200.20-FF-000945', NULL, 'Receptor protein-tyrosine kinase', 103, NULL, NULL, 161594),
(161595, '3.10.100.10-FF-000439', NULL, NULL, 57, NULL, NULL, 161595),
(161596, '3.30.70.330-FF-002318', NULL, NULL, 277, NULL, NULL, 161596),
(161597, '2.60.200.20-FF-000229', NULL, 'Kinesin-like protein', 79, NULL, NULL, 161597),
(161598, '1.10.238.10-FF-000199', NULL, 'Uncharacterized protein', 78, NULL, NULL, 161598),
(161599, '2.70.40.10-FF-000026', NULL, 'dUTPase', 136, NULL, NULL, 161599),
(161600, '2.60.40.2760-FF-000001', NULL, 'Alpha-galactosidase', 43, NULL, NULL, 161600),
(161601, '3.40.50.300-FF-006569', NULL, 'Uncharacterized protein', 102, NULL, NULL, 161601),
(161602, '3.40.50.360-FF-000123', NULL, 'Flavoprotein wrbA', 38, NULL, NULL, 161602),
(161603, '2.130.10.10-FF-000774', NULL, 'Coronin', 344, NULL, NULL, 161603),
(161604, '1.10.10.10-FF-001035', NULL, 'AfsR/SARP family transcriptional regulator', 97, NULL, NULL, 161604),
(161605, '2.10.70.80-FF-000017', NULL, 'Sortilin', 55, NULL, NULL, 161605),
(161606, '1.25.40.10-FF-004371', NULL, 'Uncharacterized protein', 150, NULL, NULL, 161606),
(161607, '1.20.58.60-FF-000013', NULL, 'Spectrin alpha chain, non-erythrocytic 1', 106, NULL, NULL, 161607),
(161608, '3.30.565.10-FF-000194', NULL, 'Histidine kinase', 153, NULL, NULL, 161608),
(161609, '1.10.490.160-FF-000001', NULL, 'Ryanodine receptor 2 (Cardiac)', 114, NULL, NULL, 161609),
(161610, '3.40.50.2300-FF-000710', NULL, 'Uncharacterized protein', 128, NULL, NULL, 161610),
(161611, '3.30.160.60-FF-003522', NULL, 'Zinc finger and BTB domain-containing 17', 29, NULL, NULL, 161611),
(161612, '2.60.40.10-FF-000807', NULL, 'Protein-glutamine gamma-glutamyltransferase 5', 114, NULL, NULL, 161612),
(161613, '3.40.50.2000-FF-000721', NULL, 'ADP-heptose:LPS heptosyltransferase II', 144, NULL, NULL, 161613),
(161614, '3.30.1370.50-FF-000033', NULL, 'Uncharacterized protein', 75, NULL, NULL, 161614),
(161615, '1.10.510.10-FF-004497', NULL, NULL, 230, NULL, NULL, 161615),
(161616, '2.60.40.10-FF-005107', NULL, NULL, 98, NULL, NULL, 161616),
(161617, '2.60.40.60-FF-000671', NULL, 'Uncharacterized protein', 90, NULL, NULL, 161617),
(161618, '1.25.40.10-FF-002813', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 166, NULL, NULL, 161618),
(161619, '3.90.190.10-FF-000106', NULL, 'Protein-tyrosine phosphatase 2', 321, NULL, NULL, 161619),
(161620, '2.60.40.150-FF-000698', NULL, 'Phosphoinositide phospholipase C', 152, NULL, NULL, 161620),
(161621, '3.90.660.10-FF-000070', NULL, NULL, 230, NULL, NULL, 161621),
(161622, '1.20.58.1030-FF-000019', NULL, 'DNA replication complex GINS protein SLD5', 214, NULL, NULL, 161622),
(161623, '2.160.20.10-FF-000116', NULL, 'Exopolygalacturonase clone GBGE184', 373, NULL, NULL, 161623);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(161624, '3.80.10.10-FF-000370', NULL, 'Relaxin family peptide receptor 1', 173, NULL, NULL, 161624),
(161625, '2.60.120.260-FF-000611', NULL, 'Predicted protein', 140, NULL, NULL, 161625),
(161626, '2.60.40.60-FF-000772', NULL, 'Cadherin', 111, NULL, NULL, 161626),
(161627, '1.10.340.30-FF-000049', NULL, 'Endonuclease III family protein', 112, NULL, NULL, 161627),
(161628, '2.30.30.1040-FF-000003', NULL, 'Bromodomain and WD repeat domain containing 1', 63, NULL, NULL, 161628),
(161629, '2.40.10.10-FF-000683', NULL, NULL, 61, NULL, NULL, 161629),
(161630, '4.10.320.10-FF-000008', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 49, NULL, NULL, 161630),
(161631, '3.30.160.60-FF-004618', NULL, NULL, 19, NULL, NULL, 161631),
(161632, '1.10.260.40-FF-000006', NULL, 'Transcriptional Regulator BldD', 71, NULL, NULL, 161632),
(161633, '1.10.287.130-FF-000230', NULL, 'Sensor histidine kinase, HAMP domain-containing', 83, NULL, NULL, 161633),
(161634, '3.40.50.150-FF-000869', NULL, 'GD20534', 179, NULL, NULL, 161634),
(161635, '3.50.50.60-FF-000074', NULL, 'Squalene monooxygenase 2', 381, NULL, NULL, 161635),
(161636, '3.40.630.10-FF-000484', NULL, 'Uncharacterized protein', 111, NULL, NULL, 161636),
(161637, '3.30.40.10-FF-000632', NULL, 'RING-H2 finger protein ATL73', 86, NULL, NULL, 161637),
(161638, '1.20.1560.10-FF-000135', NULL, 'ATP-binding cassette sub-family B member 10', 269, NULL, NULL, 161638),
(161639, '3.80.10.10-FF-001359', NULL, 'Toll-like receptor 1', 93, NULL, NULL, 161639),
(161640, '3.30.70.1730-FF-000030', NULL, '50S ribosomal protein L10', 135, NULL, NULL, 161640),
(161641, '3.30.565.10-FF-000289', NULL, 'Bacteriophytochrome', 158, NULL, NULL, 161641),
(161642, '3.30.160.60-FF-005225', NULL, NULL, 62, NULL, NULL, 161642),
(161643, '1.20.58.60-FF-000108', NULL, 'microtubule-actin cross-linking factor 1 isoform X8', 118, NULL, NULL, 161643),
(161644, '3.30.750.200-FF-000005', NULL, NULL, 66, NULL, NULL, 161644),
(161645, '1.20.1070.10-FF-000171', NULL, 'KISS1 receptor b', 335, NULL, NULL, 161645),
(161646, '1.20.1420.30-FF-000075', NULL, 'Uncharacterized protein', 197, NULL, NULL, 161646),
(161647, '3.30.70.330-FF-002217', NULL, NULL, 94, NULL, NULL, 161647),
(161648, '3.80.10.10-FF-003596', NULL, 'Uncharacterized protein', 128, NULL, NULL, 161648),
(161649, '3.30.1010.10-FF-000124', NULL, 'Predicted protein', 59, NULL, NULL, 161649),
(161650, '1.10.760.10-FF-000053', NULL, 'Cytochrome c554', 83, NULL, NULL, 161650),
(161651, '1.10.260.50-FF-000009', NULL, NULL, 90, NULL, NULL, 161651),
(161652, '3.30.40.10-FF-002335', NULL, 'ATP-dependent RNA helicase DEAH12, chloroplastic', 96, NULL, NULL, 161652),
(161653, '3.10.310.10-FF-000039', NULL, 'Diaminopimelate epimerase', 120, NULL, NULL, 161653),
(161654, '2.60.120.200-FF-000054', NULL, 'Galectin', 155, NULL, NULL, 161654),
(161655, '3.90.960.10-FF-000014', NULL, 'Prolyl-tRNA synthetase', 143, NULL, NULL, 161655),
(161656, '1.25.40.20-FF-000675', NULL, 'Ankyrin repeat and death domain-containing protein 1B', 338, NULL, NULL, 161656),
(161657, '2.30.29.30-FF-000552', NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', 112, NULL, NULL, 161657),
(161658, '2.130.10.10-FF-004473', NULL, 'Uncharacterized protein', 180, NULL, NULL, 161658),
(161659, '2.60.40.10-FF-005012', NULL, NULL, 105, NULL, NULL, 161659),
(161660, '2.30.30.30-FF-000084', NULL, 'Related to SPT5-transcription elongation protein', 70, NULL, NULL, 161660),
(161661, '1.10.472.10-FF-000338', NULL, 'Cyclin domain-containing protein, variant 2', 142, NULL, NULL, 161661),
(161662, '3.30.160.60-FF-000667', NULL, 'Zinc finger protein 33B', 29, NULL, NULL, 161662),
(161663, '3.40.50.410-FF-000161', NULL, 'Mesocentin', 153, NULL, NULL, 161663),
(161664, '1.20.58.1480-FF-000019', NULL, 'Lon protease homolog 2, peroxisomal', 134, NULL, NULL, 161664),
(161665, '1.25.40.430-FF-000001', NULL, 'Mitotic checkpoint serine/threonine-protein kinase BUB1', 150, NULL, NULL, 161665),
(161666, '2.130.10.10-FF-002915', NULL, 'Chromosome 10, whole genome shotgun sequence', 319, NULL, NULL, 161666);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(161667, '3.30.470.20-FF-000190', NULL, 'Uncharacterized protein', 80, NULL, NULL, 161667),
(161668, '3.40.50.1980-FF-000119', NULL, 'Iron-siderophore ABC transporter substrate-binding protein', 99, NULL, NULL, 161668),
(161669, '3.40.50.2000-FF-000608', NULL, 'Os01g0598000 protein', 55, NULL, NULL, 161669),
(161670, '1.25.40.10-FF-000672', NULL, 'DNAJ heat shock N-terminal domain-containing protein', 133, NULL, NULL, 161670),
(161671, '2.60.40.2310-FF-000001', NULL, 'Subtilisin-like protease SBT1.5', 128, NULL, NULL, 161671),
(161672, '3.30.160.60-FF-004950', NULL, NULL, 32, NULL, NULL, 161672),
(161673, '3.30.160.60-FF-001381', NULL, 'zinc finger protein 566 isoform X2', 28, NULL, NULL, 161673),
(161674, '3.50.50.60-FF-000169', NULL, 'Flavin-containing monooxygenase', 154, NULL, NULL, 161674),
(161675, '3.30.1490.100-FF-000009', NULL, 'DNA polymerase eta subunit', 114, NULL, NULL, 161675),
(161676, '1.20.120.1630-FF-000033', NULL, 'Uncharacterized protein', 173, NULL, NULL, 161676),
(161677, '1.10.10.60-FF-000763', NULL, 'Zinc finger homeobox 2', 84, NULL, NULL, 161677),
(161678, '1.10.1030.10-FF-000007', NULL, 'Carbamoyl-phosphate synthase large chain', 139, NULL, NULL, 161678),
(161679, '1.20.120.80-FF-000006', NULL, 'Cytochrome C oxidase', 178, NULL, NULL, 161679),
(161680, '2.30.30.40-FF-000087', NULL, 'Src substrate cortactin', 71, NULL, NULL, 161680),
(161681, '3.40.50.300-FF-007300', NULL, 'Uncharacterized protein', 151, NULL, NULL, 161681),
(161682, '1.25.40.280-FF-000017', NULL, 'pH-response regulator protein palC', 369, NULL, NULL, 161682),
(161683, '3.30.1230.20-FF-000008', NULL, '40S ribosomal protein S21', 82, NULL, NULL, 161683),
(161684, '2.120.10.30-FF-000067', NULL, 'HHIP-like 1', 417, NULL, NULL, 161684),
(161685, '3.90.70.10-FF-000188', NULL, 'Competence factor transporting ATP-binding protein/permease ComA', 149, NULL, NULL, 161685),
(161686, '3.40.50.720-FF-002390', NULL, 'Uncharacterized protein', 125, NULL, NULL, 161686),
(161687, '3.40.50.300-FF-007620', NULL, 'Predicted protein', 148, NULL, NULL, 161687),
(161688, '2.20.25.350-FF-000002', NULL, 'Eukaryotic translation initiation factor 5', 44, NULL, NULL, 161688),
(161689, '2.120.10.30-FF-000387', NULL, 'Uncharacterized protein', 297, NULL, NULL, 161689),
(161690, '3.40.30.10-FF-001019', NULL, 'Uncharacterized protein', 55, NULL, NULL, 161690),
(161691, '3.40.50.720-FF-000153', NULL, 'Altronate oxidoreductase', 267, NULL, NULL, 161691),
(161692, '2.40.160.10-FF-000058', NULL, 'Eukaryotic translation initiation factor 2 alpha', 281, NULL, NULL, 161692),
(161693, '3.80.20.20-FF-000093', NULL, 'Predicted protein', 91, NULL, NULL, 161693),
(161694, '1.25.10.10-FF-002194', NULL, 'Uncharacterized protein', 447, NULL, NULL, 161694),
(161695, '2.40.128.180-FF-000012', NULL, NULL, 82, NULL, NULL, 161695),
(161696, '3.40.50.150-FF-001600', NULL, NULL, 260, NULL, NULL, 161696),
(161697, '1.20.120.980-FF-000039', NULL, 'Prolylcarboxypeptidase, putative', 94, NULL, NULL, 161697),
(161698, '3.30.2230.10-FF-000011', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 107, NULL, NULL, 161698),
(161699, '3.80.10.10-FF-003697', NULL, 'Predicted protein', 171, NULL, NULL, 161699),
(161700, '3.40.50.1970-FF-000021', NULL, 'multifunctional protein ADE2', 159, NULL, NULL, 161700),
(161701, '3.30.930.10-FF-000020', NULL, 'Octanoyltransferase', 196, NULL, NULL, 161701),
(161702, '3.40.190.10-FF-000354', NULL, 'Transcriptional regulator, LysR family', 99, NULL, NULL, 161702),
(161703, '1.25.40.20-FF-000776', NULL, 'Transcription factor', 264, NULL, NULL, 161703),
(161704, '3.40.190.10-FF-000236', NULL, 'Molybdate ABC transporter substrate-binding protein', 121, NULL, NULL, 161704),
(161705, '1.20.1050.10-FF-000271', NULL, 'Uncharacterized protein', 128, NULL, NULL, 161705),
(161706, '1.10.155.10-FF-000006', NULL, NULL, 74, NULL, NULL, 161706),
(161707, '2.60.40.4100-FF-000010', NULL, 'Dusky-like, isoform A', 120, NULL, NULL, 161707),
(161708, '3.40.50.720-FF-000052', NULL, 'D-lactate dehydrogenase', 118, NULL, NULL, 161708),
(161709, '3.90.1600.10-FF-000009', NULL, 'DNA polymerase', 99, NULL, NULL, 161709);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(161710, '1.10.30.10-FF-000098', NULL, 'Uncharacterized protein', 108, NULL, NULL, 161710),
(161711, '3.90.550.50-FF-000181', NULL, 'Predicted protein', 230, NULL, NULL, 161711),
(161712, '3.60.40.10-FF-000035', NULL, 'Leucine rich repeat protein phosphatase 2c domain containing protein', 251, NULL, NULL, 161712),
(161713, '3.10.20.90-FF-000791', NULL, 'Uncharacterized protein', 63, NULL, NULL, 161713),
(161714, '1.25.10.10-FF-000956', NULL, 'Importin alpha-1 subunit, putative', 162, NULL, NULL, 161714),
(161715, '3.90.226.10-FF-000157', NULL, 'Enoyl CoA hydratase (PaaF-4)', 207, NULL, NULL, 161715),
(161716, '1.20.58.400-FF-000012', NULL, 'Vesicle transport through interaction with t-SNAREs 1A', 64, NULL, NULL, 161716),
(161717, '1.20.1070.10-FF-000502', NULL, 'Uncharacterized protein', 110, NULL, NULL, 161717),
(161718, '3.40.50.2000-FF-000401', NULL, 'Exopolysaccharide biosynthesis protein EpsF', 195, NULL, NULL, 161718),
(161719, '3.30.200.20-FF-000625', NULL, 'Os04g0372100 protein', 94, NULL, NULL, 161719),
(161720, '3.40.50.300-FF-002399', NULL, 'GTPase SAR1-related small G protein', 242, NULL, NULL, 161720),
(161721, '3.30.200.20-FF-002183', NULL, 'Predicted protein', 57, NULL, NULL, 161721),
(161722, '3.90.780.10-FF-000028', NULL, 'Uncharacterized protein', 144, NULL, NULL, 161722),
(161723, '3.40.50.300-FF-003017', NULL, 'Phosphoglycerate transport system transcriptional regulatory protein PgtA', 150, NULL, NULL, 161723),
(161724, '3.30.160.20-FF-000003', NULL, 'Ribonuclease 3', 71, NULL, NULL, 161724),
(161725, '1.20.1250.20-FF-001806', NULL, 'Uncharacterized protein', 169, NULL, NULL, 161725),
(161726, '2.60.40.60-FF-000558', NULL, 'Cadherin-related tumor suppressor', 108, NULL, NULL, 161726),
(161727, '3.30.590.10-FF-000044', NULL, 'Glutamate-ammonia ligase', 126, NULL, NULL, 161727),
(161728, '2.30.30.40-FF-000188', NULL, 'Insulin receptor tyrosine kinase substrate', 62, NULL, NULL, 161728),
(161729, '2.30.42.10-FF-000419', NULL, NULL, 59, NULL, NULL, 161729),
(161730, '3.30.1370.10-FF-000167', NULL, 'Exosome complex component Rrp4', 84, NULL, NULL, 161730),
(161731, '3.40.50.720-FF-001676', NULL, 'Bll6549 protein', 110, NULL, NULL, 161731),
(161732, '3.30.160.60-FF-001061', NULL, 'zinc finger and BTB domain-containing protein 40', 59, NULL, NULL, 161732),
(161733, '1.10.730.10-FF-000225', NULL, 'Valine--tRNA ligase', 179, NULL, NULL, 161733),
(161734, '3.30.160.60-FF-001173', NULL, 'Zinc finger protein 613', 29, NULL, NULL, 161734),
(161735, '3.40.50.970-FF-000194', NULL, 'Thiamine diphosphate dependent-3-acetyloctanal synthase PigD', 182, NULL, NULL, 161735),
(161736, '3.40.50.300-FF-001005', NULL, 'MoxR family ATPase', 184, NULL, NULL, 161736),
(161737, '3.40.50.1820-FF-000004', NULL, 'Protein FAM135A isoform a', 209, NULL, NULL, 161737),
(161738, '2.30.42.10-FF-000195', NULL, 'Serine protease, DegP/HtrA', 102, NULL, NULL, 161738),
(161739, '3.40.50.880-FF-000173', NULL, 'Imidazole glycerol phosphate synthase subunit HisH', 216, NULL, NULL, 161739),
(161740, '3.40.50.150-FF-001134', NULL, 'Ribosomal RNA-processing protein 8', 217, NULL, NULL, 161740),
(161741, '2.30.42.10-FF-000307', NULL, 'CBN-SHN-1 protein', 104, NULL, NULL, 161741),
(161742, '2.60.40.820-FF-000023', NULL, 'CSON002431 protein', 74, NULL, NULL, 161742),
(161743, '1.20.1740.10-FF-000121', NULL, 'Uncharacterized protein', 425, NULL, NULL, 161743),
(161744, '2.60.34.10-FF-000063', NULL, 'Heat shock 70 kDa protein cognate 1-like Protein', 132, NULL, NULL, 161744),
(161745, '2.60.40.1120-FF-000077', NULL, 'Predicted protein', 78, NULL, NULL, 161745),
(161746, '3.30.420.40-FF-001002', NULL, 'Uncharacterized protein', 73, NULL, NULL, 161746),
(161747, '3.30.1520.10-FF-000084', NULL, 'Serine/threonine protein kinase, putative', 117, NULL, NULL, 161747),
(161748, '3.30.160.60-FF-004719', NULL, NULL, 27, NULL, NULL, 161748),
(161749, '1.20.5.2020-FF-000002', NULL, 'Flagellar motor switch protein FliG', 41, NULL, NULL, 161749),
(161750, '3.40.50.2000-FF-000390', NULL, 'Glycosyltransferase', 123, NULL, NULL, 161750);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(161751, '1.20.120.1530-FF-000003', NULL, 'Atypical/HisK protein kinase', 143, NULL, NULL, 161751),
(161752, '1.10.3720.10-FF-000095', NULL, 'Nitrate/sulfonate/bicarbonate ABC transporter permease', 198, NULL, NULL, 161752),
(161753, '3.80.10.10-FF-003708', NULL, 'Predicted protein', 158, NULL, NULL, 161753),
(161754, '3.60.10.10-FF-000112', NULL, 'Probable type I inositol 1,4,5-trisphosphate 5-phosphatase', 347, NULL, NULL, 161754),
(161755, '1.25.10.10-FF-003020', NULL, 'Predicted protein', 581, NULL, NULL, 161755),
(161756, '2.60.120.650-FF-000048', NULL, 'Lysine-specific demethylase 4A', 346, NULL, NULL, 161756),
(161757, '3.40.50.1910-FF-000025', NULL, 'Protein transport Sec1b', 146, NULL, NULL, 161757),
(161758, '1.10.472.170-FF-000018', NULL, 'Uncharacterized protein', 173, NULL, NULL, 161758),
(161759, '1.20.1250.20-FF-000480', NULL, 'Integral membrane efflux protein', 190, NULL, NULL, 161759),
(161760, '3.30.70.860-FF-000004', NULL, 'UPF0234 protein AWC22_11905', 66, NULL, NULL, 161760),
(161761, '1.25.40.20-FF-001613', NULL, 'Uncharacterized protein', 104, NULL, NULL, 161761),
(161762, '2.10.25.10-FF-001258', NULL, 'Uncharacterized protein', 37, NULL, NULL, 161762),
(161763, '2.20.100.10-FF-000031', NULL, 'Thrombospondin type 1 domain containing 7A', 50, NULL, NULL, 161763),
(161764, '3.30.70.330-FF-001121', NULL, 'tRNA selenocysteine 1-associated protein', 84, NULL, NULL, 161764),
(161765, '1.10.510.10-FF-002468', NULL, 'STE family protein kinase', 262, NULL, NULL, 161765),
(161766, '2.120.10.30-FF-000275', NULL, 'E3 ubiquitin-protein ligase TRIM71', 232, NULL, NULL, 161766),
(161767, '3.90.980.10-FF-000009', NULL, 'DNA primase', 127, NULL, NULL, 161767),
(161768, '3.90.226.10-FF-000056', NULL, 'Tricorn protease homolog', 210, NULL, NULL, 161768),
(161769, '2.60.40.150-FF-000715', NULL, 'Predicted protein', 132, NULL, NULL, 161769),
(161770, '3.30.70.850-FF-000001', NULL, 'Proprotein convertase subtilisin/kexin type 5', 88, NULL, NULL, 161770),
(161771, '2.60.40.10-FF-001055', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', 94, NULL, NULL, 161771),
(161772, '3.30.70.1450-FF-000047', NULL, 'DASS family transport protein', 75, NULL, NULL, 161772),
(161773, '2.30.36.70-FF-000013', NULL, 'Brahma associated protein 55kD', 48, NULL, NULL, 161773),
(161774, '3.30.40.10-FF-001829', NULL, 'Predicted protein', 63, NULL, NULL, 161774),
(161775, '1.20.272.10-FF-000074', NULL, NULL, 119, NULL, NULL, 161775),
(161776, '3.30.70.870-FF-000007', NULL, 'Ribosome-releasing factor 2, mitochondrial', 75, NULL, NULL, 161776),
(161777, '3.30.540.10-FF-000097', NULL, 'Uncharacterized protein', 157, NULL, NULL, 161777),
(161778, '1.10.418.10-FF-000185', NULL, 'Uncharacterized protein', 122, NULL, NULL, 161778),
(161779, '3.40.109.10-FF-000048', NULL, 'Nitroreductase family protein', 198, NULL, NULL, 161779),
(161780, '3.40.50.300-FF-005046', NULL, 'Uncharacterized protein', 91, NULL, NULL, 161780),
(161781, '3.60.110.10-FF-000030', NULL, 'Carbon-nitrogen hydrolase', 273, NULL, NULL, 161781),
(161782, '2.70.150.10-FF-000085', NULL, 'Cation-transporting ATPase', 144, NULL, NULL, 161782),
(161783, '1.10.10.60-FF-000651', NULL, 'AraC family transcriptional regulator', 105, NULL, NULL, 161783),
(161784, '3.40.50.1820-FF-000212', NULL, 'Acetyl-CoA--deacetylcephalosporin C acetyltransferase', 393, NULL, NULL, 161784),
(161785, '3.10.20.90-FF-000459', NULL, 'F15C11.2', 87, NULL, NULL, 161785),
(161786, '2.40.50.140-FF-000303', NULL, 'Protection of telomeres protein 1', 161, NULL, NULL, 161786),
(161787, '1.25.40.10-FF-001610', NULL, 'Clustered mitochondria protein homolog', 248, NULL, NULL, 161787),
(161788, '1.10.10.60-FF-000858', NULL, NULL, 47, NULL, NULL, 161788),
(161789, '3.90.1200.10-FF-000012', NULL, 'Spore coat protein YsxE', 229, NULL, NULL, 161789),
(161790, '3.30.230.70-FF-000086', NULL, 'Polyribonucleotide nucleotidyltransferase', 313, NULL, NULL, 161790),
(161791, '1.25.40.10-FF-000559', NULL, 'Mitochondrial RNA binding protein 1', 103, NULL, NULL, 161791),
(161792, '3.80.10.10-FF-002073', NULL, 'Leucine-rich repeat-containing 24', 129, NULL, NULL, 161792);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(161793, '2.40.50.140-FF-000286', NULL, 'Exosome complex component RRP4, putative', 90, NULL, NULL, 161793),
(161794, '3.40.50.300-FF-004771', NULL, 'BRCA1 interacting protein C-terminal helicase 1', 244, NULL, NULL, 161794),
(161795, '2.130.10.10-FF-000869', NULL, 'Zinc finger CCCH domain-containing protein 48', 209, NULL, NULL, 161795),
(161796, '1.20.58.60-FF-000440', NULL, 'Dystrophin-1', 302, NULL, NULL, 161796),
(161797, '3.30.160.60-FF-006395', NULL, NULL, 80, NULL, NULL, 161797),
(161798, '3.30.1050.10-FF-000019', NULL, 'Probable hydrolase', 122, NULL, NULL, 161798),
(161799, '1.20.1310.10-FF-000095', NULL, 'Cullin family protein', 173, NULL, NULL, 161799),
(161800, '1.25.10.10-FF-000844', NULL, 'TFIIH regulator', 213, NULL, NULL, 161800),
(161801, '3.40.50.300-FF-006805', NULL, 'Uncharacterized protein', 50, NULL, NULL, 161801),
(161802, '3.40.50.670-FF-000014', NULL, 'DNA topoisomerase 2', 219, NULL, NULL, 161802),
(161803, '3.30.230.10-FF-000219', NULL, 'Ribosome-releasing factor 2, mitochondrial', 144, NULL, NULL, 161803),
(161804, '2.170.8.10-FF-000019', NULL, 'Uncharacterized protein', 64, NULL, NULL, 161804),
(161805, '2.30.42.10-FF-000212', NULL, 'PDZ domain-containing protein 11', 76, NULL, NULL, 161805),
(161806, '1.20.1250.20-FF-001795', NULL, 'Putative membrane protein', 176, NULL, NULL, 161806),
(161807, '3.30.70.920-FF-000045', NULL, 'Lrp/AsnC family transcription regulator', 93, NULL, NULL, 161807),
(161808, '1.10.510.10-FF-003075', NULL, NULL, 202, NULL, NULL, 161808),
(161809, '3.90.1150.10-FF-000373', NULL, 'Ornithine aminotransferase', 27, NULL, NULL, 161809),
(161810, '3.40.47.10-FF-000260', NULL, NULL, 261, NULL, NULL, 161810),
(161811, '3.40.390.10-FF-000122', NULL, 'Zinc metalloproteinase', 186, NULL, NULL, 161811),
(161812, '2.70.98.10-FF-000092', NULL, 'Beta-galactosidase', 263, NULL, NULL, 161812),
(161813, '1.25.40.10-FF-000773', NULL, 'Os11g0583200 protein', 96, NULL, NULL, 161813),
(161814, '1.25.10.10-FF-003019', NULL, 'Sister chromatid cohesion protein', 328, NULL, NULL, 161814),
(161815, '3.40.140.10-FF-000188', NULL, 'Cytosine/adenosine deaminase', 152, NULL, NULL, 161815),
(161816, '1.20.1070.10-FF-001694', NULL, 'Predicted protein', 111, NULL, NULL, 161816),
(161817, '3.30.750.24-FF-000019', NULL, 'STAS domain protein', 106, NULL, NULL, 161817),
(161818, '3.30.160.40-FF-000009', NULL, 'Probable porphobilinogen deaminase', 80, NULL, NULL, 161818),
(161819, '3.30.160.60-FF-000566', NULL, 'zinc finger protein 133 isoform X2', 27, NULL, NULL, 161819),
(161820, '3.40.309.10-FF-000029', NULL, 'Aldehyde dehydrogenase family 16 member A1', 185, NULL, NULL, 161820),
(161821, '3.30.40.10-FF-001947', NULL, 'Uncharacterized protein', 67, NULL, NULL, 161821),
(161822, '3.30.70.3270-FF-000020', NULL, 'Uncharacterized protein', 114, NULL, NULL, 161822),
(161823, '3.40.190.290-FF-000059', NULL, 'Probable transcriptional regulator', 207, NULL, NULL, 161823),
(161824, '3.80.10.10-FF-003719', NULL, 'Uncharacterized protein', 147, NULL, NULL, 161824),
(161825, '3.30.70.330-FF-002094', NULL, NULL, 124, NULL, NULL, 161825),
(161826, '4.10.230.10-FF-000001', NULL, 'Amyloid beta A4 protein', 40, NULL, NULL, 161826),
(161827, '2.10.25.10-FF-000403', NULL, 'Delta-like 3 (Drosophila), isoform CRA_b', 40, NULL, NULL, 161827),
(161828, '2.10.25.140-FF-000003', NULL, 'Delta-like protein', 46, NULL, NULL, 161828),
(161829, '1.20.1250.20-FF-000160', NULL, 'monocarboxylate transporter 12 isoform X1', 191, NULL, NULL, 161829),
(161830, '3.30.870.10-FF-000195', NULL, 'Uncharacterized protein', 191, NULL, NULL, 161830),
(161831, '3.30.9.20-FF-000001', NULL, '2-polyprenyl-6-methoxyphenol hydroxylase', 154, NULL, NULL, 161831),
(161832, '1.10.3380.30-FF-000012', NULL, 'Probable helicase HelY', 220, NULL, NULL, 161832),
(161833, '2.60.40.10-FF-005001', NULL, NULL, 106, NULL, NULL, 161833),
(161834, '1.20.1420.30-FF-000086', NULL, 'AGAP008342-PA', 124, NULL, NULL, 161834),
(161835, '2.60.40.150-FF-000592', NULL, 'Synaptotagmin 15a', 118, NULL, NULL, 161835),
(161836, '2.10.25.10-FF-000061', NULL, 'Delta-like protein', 38, NULL, NULL, 161836);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(161837, '1.25.40.20-FF-001490', NULL, 'Palmitoyltransferase', 82, NULL, NULL, 161837),
(161838, '1.10.3120.10-FF-000015', NULL, 'Trigger factor', 186, NULL, NULL, 161838),
(161839, '2.60.40.60-FF-000878', NULL, 'E-cadherin-like protein', 113, NULL, NULL, 161839),
(161840, '2.60.40.10-FF-002483', NULL, 'Jitterbug, isoform M', 86, NULL, NULL, 161840),
(161841, '2.60.40.820-FF-000034', NULL, 'Uncharacterized protein', 110, NULL, NULL, 161841),
(161842, '3.30.780.10-FF-000070', NULL, 'Chromosome 1, whole genome shotgun sequence', 120, NULL, NULL, 161842),
(161843, '1.20.1070.10-FF-001576', NULL, 'Olfactory receptor', 162, NULL, NULL, 161843),
(161844, '2.60.40.10-FF-003101', NULL, NULL, 98, NULL, NULL, 161844),
(161845, '3.100.10.10-FF-000024', NULL, 'RPL27A isoform 10', 91, NULL, NULL, 161845),
(161846, '3.40.640.10-FF-000445', NULL, 'Uncharacterized protein', 128, NULL, NULL, 161846),
(161847, '1.10.287.70-FF-000251', NULL, 'TAX2', 238, NULL, NULL, 161847),
(161848, '1.10.486.10-FF-000050', NULL, 'DNA helicase', 158, NULL, NULL, 161848),
(161849, '1.20.1720.10-FF-000024', NULL, 'MFS multidrug transporter, putative', 247, NULL, NULL, 161849),
(161850, '3.40.50.300-FF-001325', NULL, 'Type II secretion system protein E', 229, NULL, NULL, 161850),
(161851, '3.30.9.30-FF-000004', NULL, 'Expressed protein', 46, NULL, NULL, 161851),
(161852, '3.40.50.1820-FF-001847', NULL, 'Uncharacterized protein', 71, NULL, NULL, 161852),
(161853, '2.30.42.10-FF-000318', NULL, 'Arc, isoform A', 108, NULL, NULL, 161853),
(161854, '1.10.246.200-FF-000001', NULL, 'WPP domain-containing protein 2', 97, NULL, NULL, 161854),
(161855, '2.40.10.10-FF-000672', NULL, NULL, 252, NULL, NULL, 161855),
(161856, '1.10.10.60-FF-000752', NULL, 'Transcriptional adapter 2A', 49, NULL, NULL, 161856),
(161857, '1.10.150.20-FF-000234', NULL, 'DNA-dependent RNA polymerase', 203, NULL, NULL, 161857),
(161858, '2.10.25.10-FF-001685', NULL, 'Uncharacterized protein', 108, NULL, NULL, 161858),
(161859, '3.30.70.330-FF-000295', NULL, 'RNA-binding motif protein 45', 100, NULL, NULL, 161859),
(161860, '3.40.1090.10-FF-000071', NULL, 'Patatin', 382, NULL, NULL, 161860),
(161861, '2.170.120.40-FF-000011', NULL, 'Putative exported protein', 86, NULL, NULL, 161861),
(161862, '3.30.160.60-FF-001504', NULL, 'zinc finger protein 517 isoform X3', 28, NULL, NULL, 161862),
(161863, '1.20.970.10-FF-000021', NULL, 'Similar to anthranilate phosphoribosyltransferase', 87, NULL, NULL, 161863),
(161864, '3.40.50.2300-FF-000816', NULL, NULL, 58, NULL, NULL, 161864),
(161865, '1.10.640.10-FF-000105', NULL, 'Uncharacterized protein', 522, NULL, NULL, 161865),
(161866, '1.20.1090.10-FF-000048', NULL, 'Probable oxidoreductase (Iron-containing alcohol dehydrogenase family)', 200, NULL, NULL, 161866),
(161867, '3.40.50.720-FF-000714', NULL, 'Probable oxidoreductase', 266, NULL, NULL, 161867),
(161868, '2.130.10.10-FF-000763', NULL, 'U4/U6 small nuclear ribonucleoprotein PRP4-like protein', 185, NULL, NULL, 161868),
(161869, '2.60.260.20-FF-000126', NULL, 'YALI0F12551p', 66, NULL, NULL, 161869),
(161870, '3.40.50.300-FF-004978', NULL, 'Uncharacterized protein', 201, NULL, NULL, 161870),
(161871, '2.130.10.10-FF-002792', NULL, 'RE36115p', 206, NULL, NULL, 161871),
(161872, '3.40.190.10-FF-000674', NULL, 'Uncharacterized solute-binding protein OE_3270R', 74, NULL, NULL, 161872),
(161873, '3.30.70.2460-FF-000007', NULL, NULL, 74, NULL, NULL, 161873),
(161874, '3.30.70.1350-FF-000023', NULL, 'Cation efflux family protein', 85, NULL, NULL, 161874),
(161875, '3.50.50.60-FF-000624', NULL, 'Amine oxidase', 205, NULL, NULL, 161875),
(161876, '2.30.42.10-FF-000420', NULL, NULL, 80, NULL, NULL, 161876),
(161877, '3.40.50.300-FF-005254', NULL, 'ABC transporter, putative (Eurofung)', 188, NULL, NULL, 161877),
(161878, '3.90.1310.10-FF-000021', NULL, 'Penicillin-binding protein', 174, NULL, NULL, 161878),
(161879, '1.10.3430.10-FF-000016', NULL, 'Ammonium transporter', 445, NULL, NULL, 161879),
(161880, '3.30.450.40-FF-000099', NULL, 'Sensor histidine kinase, KdpD', 145, NULL, NULL, 161880);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(161881, '3.30.200.20-FF-002536', NULL, 'Mitogen activated kinase-like protein', 103, NULL, NULL, 161881),
(161882, '1.25.10.10-FF-001221', NULL, 'HEAT repeat domain containing protein', 347, NULL, NULL, 161882),
(161883, '2.10.25.10-FF-000162', NULL, 'Coagulation factor X (Predicted)', 41, NULL, NULL, 161883),
(161884, '1.25.40.530-FF-000031', NULL, NULL, 73, NULL, NULL, 161884),
(161885, '3.30.70.330-FF-000065', NULL, 'mRNA binding post-transcriptional regulator', 91, NULL, NULL, 161885),
(161886, '3.30.70.330-FF-002195', NULL, NULL, 118, NULL, NULL, 161886),
(161887, '1.20.1050.10-FF-000282', NULL, 'Uncharacterized protein', 33, NULL, NULL, 161887),
(161888, '1.25.10.10-FF-000945', NULL, 'Importin beta 3 family protein', 1091, NULL, NULL, 161888),
(161889, '3.40.50.620-FF-000353', NULL, 'DUF218 domain', 131, NULL, NULL, 161889),
(161890, '2.60.40.1390-FF-000011', NULL, 'Myelin regulatory factor-like', 136, NULL, NULL, 161890),
(161891, '3.40.366.10-FF-000004', NULL, 'Fatty acid synthase beta subunit dehydratase', 168, NULL, NULL, 161891),
(161892, '3.30.460.10-FF-000141', NULL, 'Iojap-like ribosome-associated protein', 115, NULL, NULL, 161892),
(161893, '2.40.50.140-FF-000511', NULL, 'OB-fold nucleic acid binding domain containing protein', 127, NULL, NULL, 161893),
(161894, '3.40.50.2000-FF-000160', NULL, 'Glycosyltransferase, group 1 family protein', 166, NULL, NULL, 161894),
(161895, '3.40.1190.20-FF-000221', NULL, 'Bifunctional NAD(P)H-hydrate repair enzyme Nnr', 284, NULL, NULL, 161895),
(161896, '1.20.1070.10-FF-001817', NULL, 'Vasopressin/oxytocin-related Peptide receptor', 355, NULL, NULL, 161896),
(161897, '3.90.550.10-FF-000646', NULL, 'Uncharacterized protein', 144, NULL, NULL, 161897),
(161898, '2.60.40.790-FF-000087', NULL, '22.0 kDa heat shock protein', 107, NULL, NULL, 161898),
(161899, '1.25.40.570-FF-000014', NULL, 'COP9 signalosome complex subunit 1', 347, NULL, NULL, 161899),
(161900, '2.70.170.10-FF-000193', NULL, 'Uncharacterized protein', 199, NULL, NULL, 161900),
(161901, '3.90.79.10-FF-000275', NULL, 'Uncharacterized protein', 85, NULL, NULL, 161901),
(161902, '2.40.50.140-FF-000387', NULL, 'Unplaced genomic scaffold supercont2.24, whole genome shotgun sequence', 87, NULL, NULL, 161902),
(161903, '3.40.50.10930-FF-000004', NULL, 'RecBCD enzyme subunit RecC', 142, NULL, NULL, 161903),
(161904, '3.30.200.20-FF-000384', NULL, 'Receptor protein-tyrosine kinase', 128, NULL, NULL, 161904),
(161905, '1.10.357.90-FF-000010', NULL, NULL, 53, NULL, NULL, 161905),
(161906, '2.10.25.160-FF-000009', NULL, 'Progranulin', 46, NULL, NULL, 161906),
(161907, '2.70.150.10-FF-000293', NULL, 'Cation-transporting ATPase', 169, NULL, NULL, 161907),
(161908, '1.10.510.10-FF-004391', NULL, NULL, 89, NULL, NULL, 161908),
(161909, '3.40.228.10-FF-000021', NULL, 'NADH-quinone oxidoreductase', 62, NULL, NULL, 161909),
(161910, '1.50.10.20-FF-000081', NULL, 'Uncharacterized protein', 203, NULL, NULL, 161910),
(161911, '2.60.200.10-FF-000018', NULL, 'Dwarfin sma', 222, NULL, NULL, 161911),
(161912, '1.25.40.540-FF-000034', NULL, 'Uncharacterized protein', 68, NULL, NULL, 161912),
(161913, '3.30.420.40-FF-000384', NULL, 'Actin-like protein, putative', 103, NULL, NULL, 161913),
(161914, '3.60.20.10-FF-000040', NULL, 'Proteasome subunit beta', 216, NULL, NULL, 161914),
(161915, '1.10.472.10-FF-000349', NULL, 'Cyclin A', 129, NULL, NULL, 161915),
(161916, '1.20.1270.250-FF-000006', NULL, NULL, 271, NULL, NULL, 161916),
(161917, '2.60.120.260-FF-000156', NULL, 'Beta-galactosidase', 155, NULL, NULL, 161917),
(161918, '3.90.650.10-FF-000013', NULL, 'Phosphoribosylformylglycinamidine synthase subunit PurL', 171, NULL, NULL, 161918),
(161919, '2.40.70.10-FF-000237', NULL, 'Acid protease', 211, NULL, NULL, 161919),
(161920, '3.30.1360.10-FF-000009', NULL, 'RNA polymerase I and III subunit C', 35, NULL, NULL, 161920),
(161921, '3.90.1640.10-FF-000017', NULL, 'Uncharacterized protein', 228, NULL, NULL, 161921),
(161922, '3.30.40.10-FF-002324', NULL, 'Ubiquitinyl hydrolase 1', 100, NULL, NULL, 161922),
(161923, '3.20.20.300-FF-000082', NULL, NULL, 156, NULL, NULL, 161923);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(161924, '1.20.50.60-FF-000001', NULL, 'Exocrine gland secreted peptide 6', 55, NULL, NULL, 161924),
(161925, '1.10.1070.20-FF-000002', NULL, 'Uncharacterized protein', 76, NULL, NULL, 161925),
(161926, '1.25.40.10-FF-004163', NULL, 'Uncharacterized protein', 103, NULL, NULL, 161926),
(161927, '1.10.238.10-FF-001025', NULL, 'Uncharacterized protein', 108, NULL, NULL, 161927),
(161928, '1.50.10.130-FF-000018', NULL, NULL, 58, NULL, NULL, 161928),
(161929, '1.25.40.10-FF-003887', NULL, 'Uncharacterized protein', 80, NULL, NULL, 161929),
(161930, '1.10.510.10-FF-000669', NULL, 'Tau TuBulin Kinase', 298, NULL, NULL, 161930),
(161931, '3.40.1280.10-FF-000006', NULL, 'Uncharacterized tRNA/rRNA methyltransferase HI_0380', 172, NULL, NULL, 161931),
(161932, '1.20.120.420-FF-000006', NULL, 'Methylthioribose-1-phosphate isomerase', 202, NULL, NULL, 161932),
(161933, '2.40.30.170-FF-000055', NULL, NULL, 64, NULL, NULL, 161933),
(161934, '1.25.10.10-FF-003250', NULL, 'Uncharacterized protein', 228, NULL, NULL, 161934),
(161935, '3.30.160.60-FF-004596', NULL, NULL, 64, NULL, NULL, 161935),
(161936, '3.30.70.60-FF-000008', NULL, '28S ribosomal protein S6, mitochondrial', 124, NULL, NULL, 161936),
(161937, '3.30.230.10-FF-000118', NULL, 'Lon protease homolog 2, peroxisomal', 184, NULL, NULL, 161937),
(161938, '2.130.10.10-FF-001600', NULL, 'WD repeat-containing protein JIP5', 206, NULL, NULL, 161938),
(161939, '2.30.30.100-FF-000233', NULL, 'Uncharacterized protein', 44, NULL, NULL, 161939),
(161940, '2.120.10.80-FF-000374', NULL, 'Host cell factor-like Protein', 162, NULL, NULL, 161940),
(161941, '3.90.1410.10-FF-000085', NULL, 'SET domain containing protein, putative', 261, NULL, NULL, 161941),
(161942, '1.20.1280.180-FF-000004', NULL, 'Carnitine palmitoyltransferase family member cpt-2', 43, NULL, NULL, 161942),
(161943, '1.20.58.1070-FF-000003', NULL, 'Spliceosomal snRNP component', 184, NULL, NULL, 161943),
(161944, '2.60.120.830-FF-000001', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 1', 137, NULL, NULL, 161944),
(161945, '3.30.428.10-FF-000044', NULL, 'Galactose-1-phosphate uridylyltransferase', 141, NULL, NULL, 161945),
(161946, '3.30.160.60-FF-002696', NULL, 'Brain tumor, isoform E', 49, NULL, NULL, 161946),
(161947, '2.60.110.10-FF-000011', NULL, 'Thaumatin family protein', 232, NULL, NULL, 161947),
(161948, '1.20.58.1080-FF-000006', NULL, 'DExH-box ATP-dependent RNA helicase', 104, NULL, NULL, 161948),
(161949, '1.20.5.190-FF-000146', NULL, NULL, 74, NULL, NULL, 161949),
(161950, '1.20.1280.170-FF-000001', NULL, 'Exocyst complex component 7', 172, NULL, NULL, 161950),
(161951, '3.30.750.24-FF-000132', NULL, 'Anti-sigma factor antagonist', 111, NULL, NULL, 161951),
(161952, '3.40.50.300-FF-000488', NULL, 'Small monomeric GTPase (Gtr1)', 183, NULL, NULL, 161952),
(161953, '1.10.510.10-FF-002923', NULL, NULL, 110, NULL, NULL, 161953),
(161954, '2.40.50.140-FF-000409', NULL, 'Lysine--tRNA ligase', 166, NULL, NULL, 161954),
(161955, '1.20.1720.10-FF-000013', NULL, 'Related to multidrug resistance proteins', 216, NULL, NULL, 161955),
(161956, '1.20.1540.10-FF-000027', NULL, 'Rhomboid family intramembrane serine protease', 214, NULL, NULL, 161956),
(161957, '3.40.30.10-FF-000856', NULL, 'NADH-quinone oxidoreductase, E subunit', 102, NULL, NULL, 161957),
(161958, '2.60.120.10-FF-000759', NULL, 'Uncharacterized protein', 76, NULL, NULL, 161958),
(161959, '1.20.1060.10-FF-000013', NULL, 'Mitochondrial DNA polymerase A', 121, NULL, NULL, 161959),
(161960, '3.80.10.10-FF-000162', NULL, 'Relaxin family peptide receptor 1', 133, NULL, NULL, 161960),
(161961, '1.20.120.430-FF-000009', NULL, 'tRNA modification GTPase MnmE', 167, NULL, NULL, 161961),
(161962, '1.10.238.10-FF-000761', NULL, 'EF-hand calcium-binding domain 6', 75, NULL, NULL, 161962),
(161963, '3.40.50.300-FF-006682', NULL, 'Uncharacterized protein', 82, NULL, NULL, 161963),
(161964, '3.30.2300.10-FF-000017', NULL, 'Uncharacterized protein', 90, NULL, NULL, 161964),
(161965, '3.30.559.10-FF-000134', NULL, 'Putative carnitine acetyltransferase', 134, NULL, NULL, 161965);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(161966, '3.40.50.720-FF-001687', NULL, 'YALI0F02211p', 72, NULL, NULL, 161966),
(161967, '1.25.10.10-FF-002974', NULL, 'Uncharacterized protein', 403, NULL, NULL, 161967),
(161968, '3.10.110.10-FF-000266', NULL, 'Uncharacterized protein', 78, NULL, NULL, 161968),
(161969, '3.90.1170.40-FF-000012', NULL, 'Molybdopterin synthase catalytic subunit', 145, NULL, NULL, 161969),
(161970, '3.80.10.10-FF-001567', NULL, 'Chitin binding protein', 83, NULL, NULL, 161970),
(161971, '3.40.630.10-FF-000164', NULL, 'Os01g0740650 protein', 231, NULL, NULL, 161971),
(161972, '3.30.40.10-FF-000424', NULL, 'RBR-type E3 ubiquitin transferase', 85, NULL, NULL, 161972),
(161973, '2.60.40.10-FF-004944', NULL, NULL, 50, NULL, NULL, 161973),
(161974, '3.40.390.10-FF-000009', NULL, 'Oligopeptidase A', 151, NULL, NULL, 161974),
(161975, '3.90.920.10-FF-000006', NULL, 'DNA primase small subunit PriS', 330, NULL, NULL, 161975),
(161976, '3.30.310.80-FF-000022', NULL, 'Non-specific serine/threonine protein kinase', 68, NULL, NULL, 161976),
(161977, '3.10.50.10-FF-000066', NULL, 'Chitinase, putative', 42, NULL, NULL, 161977),
(161978, '3.90.1170.50-FF-000015', NULL, 'Xanthine dehydrogenase/oxidase', 93, NULL, NULL, 161978),
(161979, '3.10.180.10-FF-000091', NULL, '4-hydroxyphenylpyruvic acid dioxgenase', 201, NULL, NULL, 161979),
(161980, '3.40.5.60-FF-000010', NULL, 'Chromosome 7, whole genome shotgun sequence', 53, NULL, NULL, 161980),
(161981, '2.60.40.10-FF-001510', NULL, 'Jitterbug, isoform M', 98, NULL, NULL, 161981),
(161982, '1.10.150.60-FF-000010', NULL, 'PHD transcription factor (Rum1)', 131, NULL, NULL, 161982),
(161983, '3.20.20.140-FF-000011', NULL, 'Uronate isomerase', 358, NULL, NULL, 161983),
(161984, '1.20.58.1030-FF-000020', NULL, 'DNA replication complex GINS protein PSF1', 136, NULL, NULL, 161984),
(161985, '1.25.40.10-FF-002572', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 129, NULL, NULL, 161985),
(161986, '2.40.50.140-FF-000741', NULL, NULL, 93, NULL, NULL, 161986),
(161987, '3.90.380.10-FF-000020', NULL, NULL, 192, NULL, NULL, 161987),
(161988, '3.80.10.10-FF-004214', NULL, 'Uncharacterized protein', 86, NULL, NULL, 161988),
(161989, '3.10.100.10-FF-000338', NULL, NULL, 69, NULL, NULL, 161989),
(161990, '2.60.40.420-FF-000010', NULL, 'Early nodulin-like protein 1', 108, NULL, NULL, 161990),
(161991, '1.20.120.230-FF-000062', NULL, 'Probable vinculin', 71, NULL, NULL, 161991),
(161992, '3.40.50.300-FF-004198', NULL, 'Secretion related GTPase SrgD (AFU_orthologue AFUA_1G07680)', 140, NULL, NULL, 161992),
(161993, '1.20.1200.10-FF-000002', NULL, 'Cob(I)yrinic acid a,c-diamide adenosyltransferase', 171, NULL, NULL, 161993),
(161994, '3.30.160.60-FF-005433', NULL, NULL, 81, NULL, NULL, 161994),
(161995, '2.30.29.30-FF-000114', NULL, 'Phospholipase', 112, NULL, NULL, 161995),
(161996, '3.60.130.10-FF-000025', NULL, 'Probable gamma-butyrobetaine dioxygenase', 301, NULL, NULL, 161996),
(161997, '3.40.50.1820-FF-000442', NULL, 'Subfamily S9C unassigned peptidase', 294, NULL, NULL, 161997),
(161998, '3.40.140.10-FF-000177', NULL, 'Eukaryotic translation initiation factor 3 subunit F', 186, NULL, NULL, 161998),
(161999, '1.10.8.70-FF-000001', NULL, 'Glutamate--tRNA ligase', 54, NULL, NULL, 161999),
(162000, '1.20.5.170-FF-000140', NULL, 'BZIP transcription factor family', 77, NULL, NULL, 162000),
(162001, '3.30.1050.10-FF-000008', NULL, 'N-acetyltransferase Eis', 101, NULL, NULL, 162001),
(162002, '3.30.1520.10-FF-000106', NULL, 'Vacuolar protein sorting-associated protein 17', 124, NULL, NULL, 162002),
(162003, '3.80.10.10-FF-002062', NULL, 'GH20134p', 124, NULL, NULL, 162003),
(162004, '3.30.70.560-FF-000015', NULL, 'Folic acid synthesis protein fol1', 171, NULL, NULL, 162004),
(162005, '2.170.130.10-FF-000076', NULL, NULL, 143, NULL, NULL, 162005),
(162006, '1.20.58.890-FF-000001', NULL, 'BAG family molecular chaperone regulator 2', 87, NULL, NULL, 162006),
(162007, '3.30.1140.40-FF-000007', NULL, 'Dynein light chain Tctex-type', 99, NULL, NULL, 162007),
(162008, '1.20.58.860-FF-000021', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 112, NULL, NULL, 162008);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(162009, '2.30.42.10-FF-000650', NULL, NULL, 83, NULL, NULL, 162009),
(162010, '3.40.50.150-FF-000971', NULL, NULL, 230, NULL, NULL, 162010),
(162011, '1.25.40.180-FF-000212', NULL, NULL, 153, NULL, NULL, 162011),
(162012, '2.10.110.10-FF-000039', NULL, 'LIM/homeobox protein Lhx9 isoform 2', 82, NULL, NULL, 162012),
(162013, '3.40.47.10-FF-000029', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 1', 151, NULL, NULL, 162013),
(162014, '1.10.600.10-FF-000108', NULL, 'Uncharacterized protein', 291, NULL, NULL, 162014),
(162015, '3.90.1150.10-FF-000362', NULL, 'DegT/DnrJ/EryC1/StrS family aminotransferase', 118, NULL, NULL, 162015),
(162016, '1.25.40.10-FF-004724', NULL, 'Uncharacterized protein', 85, NULL, NULL, 162016),
(162017, '3.40.50.12780-FF-000115', NULL, 'Non-ribosomal peptide synthetase', 397, NULL, NULL, 162017),
(162018, '3.10.450.50-FF-000067', NULL, 'Nuclear transport factor 2 (NTF2) family protein', 123, NULL, NULL, 162018),
(162019, '1.20.58.60-FF-000451', NULL, 'Spectrin, beta, non-erythrocytic 5', 203, NULL, NULL, 162019),
(162020, '1.10.287.10-FF-000031', NULL, '28S ribosomal protein S15, mitochondrial', 92, NULL, NULL, 162020),
(162021, '1.50.10.10-FF-000201', NULL, 'Predicted protein', 207, NULL, NULL, 162021),
(162022, '2.170.120.12-FF-000033', NULL, 'DNA-directed RNA polymerase subunit alpha', 117, NULL, NULL, 162022),
(162023, '3.40.50.360-FF-000022', NULL, 'NADPH azoreductase', 174, NULL, NULL, 162023),
(162024, '3.20.20.150-FF-000014', NULL, 'Putative sugar phosphate isomerase/epimerase', 262, NULL, NULL, 162024),
(162025, '3.10.330.10-FF-000041', NULL, 'Vesicle-fusing ATPase', 99, NULL, NULL, 162025),
(162026, '2.30.30.100-FF-000014', NULL, 'Small nuclear ribonucleoprotein Sm D1', 33, NULL, NULL, 162026),
(162027, '3.40.50.720-FF-002182', NULL, 'Fatty acyl-CoA reductase', 56, NULL, NULL, 162027),
(162028, '3.40.50.1220-FF-000127', NULL, 'Predicted protein', 169, NULL, NULL, 162028),
(162029, '3.30.230.70-FF-000097', NULL, 'Exosome non-catalytic core subunit', 257, NULL, NULL, 162029),
(162030, '1.20.930.10-FF-000024', NULL, 'GM26494', 91, NULL, NULL, 162030),
(162031, '3.50.50.100-FF-000049', NULL, 'Uncharacterized protein', 341, NULL, NULL, 162031),
(162032, '2.20.70.10-FF-000064', NULL, 'rho GTPase-activating protein 9 isoform X2', 53, NULL, NULL, 162032),
(162033, '3.40.50.1000-FF-000764', NULL, NULL, 129, NULL, NULL, 162033),
(162034, '2.60.40.10-FF-002825', NULL, NULL, 93, NULL, NULL, 162034),
(162035, '1.25.40.10-FF-005000', NULL, 'Uncharacterized protein', 242, NULL, NULL, 162035),
(162036, '3.10.20.620-FF-000011', NULL, NULL, 96, NULL, NULL, 162036),
(162037, '3.40.50.11610-FF-000006', NULL, '2-oxoglutarate dehydrogenase, mitochondrial', 149, NULL, NULL, 162037),
(162038, '3.10.20.90-FF-000897', NULL, 'UBX domain-containing protein 10', 103, NULL, NULL, 162038),
(162039, '3.30.830.10-FF-000299', NULL, 'Predicted protein', 260, NULL, NULL, 162039),
(162040, '1.20.90.10-FF-000005', NULL, 'Secretory phospholipase A2', 127, NULL, NULL, 162040),
(162041, '2.60.40.720-FF-000004', NULL, 'runt-related transcription factor 3', 99, NULL, NULL, 162041),
(162042, '1.25.40.10-FF-002471', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 278, NULL, NULL, 162042),
(162043, '1.20.58.760-FF-000002', NULL, 'ATP-dependent zinc metalloprotease FtsH', 194, NULL, NULL, 162043),
(162044, '2.40.70.10-FF-000557', NULL, NULL, 198, NULL, NULL, 162044),
(162045, '3.40.640.10-FF-000333', NULL, 'Aromatic-amino-acid transaminase, hypothetical (Eurofung)', 219, NULL, NULL, 162045),
(162046, '1.25.40.10-FF-004595', NULL, 'Pentatricopeptide repeat domain 1', 170, NULL, NULL, 162046),
(162047, '1.10.3470.10-FF-000007', NULL, 'Iron ABC transporter permease', 324, NULL, NULL, 162047),
(162048, '2.60.40.10-FF-004837', NULL, NULL, 68, NULL, NULL, 162048),
(162049, '3.40.1000.50-FF-000009', NULL, 'Unplaced genomic scaffold supercont1.257, whole genome shotgun sequence', 37, NULL, NULL, 162049),
(162050, '2.60.40.710-FF-000001', NULL, 'Endoglucanase 1', 154, NULL, NULL, 162050),
(162051, '3.40.50.1000-FF-000646', NULL, NULL, 201, NULL, NULL, 162051);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(162052, '3.40.1000.30-FF-000003', NULL, 'Uncharacterized protein', 177, NULL, NULL, 162052),
(162053, '3.30.710.10-FF-000245', NULL, 'Uncharacterized protein', 127, NULL, NULL, 162053),
(162054, '3.30.200.20-FF-001221', NULL, 'Cyclin dependent kinase', 91, NULL, NULL, 162054),
(162055, '2.60.40.420-FF-000009', NULL, 'Ceruloplasmin', 351, NULL, NULL, 162055),
(162056, '3.90.810.10-FF-000003', NULL, 'Neural Wiskott-Aldrich syndrome protein-like', 71, NULL, NULL, 162056),
(162057, '3.40.50.80-FF-000029', NULL, 'NADPH oxidase A', 201, NULL, NULL, 162057),
(162058, '1.20.1270.10-FF-000040', NULL, 'Heat shock 70 kDa protein BIP5', 92, NULL, NULL, 162058),
(162059, '3.30.390.150-FF-000008', NULL, 'Uncharacterized protein', 97, NULL, NULL, 162059),
(162060, '2.60.15.10-FF-000024', NULL, 'ATP synthase epsilon chain, chloroplastic', 93, NULL, NULL, 162060),
(162061, '3.40.50.720-FF-000501', NULL, 'Undecaprenyl-phosphate glucose phosphotransferase', 124, NULL, NULL, 162061),
(162062, '4.10.240.10-FF-000041', NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', 72, NULL, NULL, 162062),
(162063, '2.60.40.10-FF-000566', NULL, 'fibronectin type III and SPRY domain-containing protein 1', 101, NULL, NULL, 162063),
(162064, '2.120.10.80-FF-000267', NULL, 'Uncharacterized protein', 224, NULL, NULL, 162064),
(162065, '3.40.50.460-FF-000041', NULL, 'ATP-dependent 6-phosphofructokinase', 121, NULL, NULL, 162065),
(162066, '2.20.20.150-FF-000001', NULL, 'Blast:Protein giant-lens', 61, NULL, NULL, 162066),
(162067, '3.90.470.10-FF-000033', NULL, 'Probable 39S ribosomal protein L22, mitochondrial', 169, NULL, NULL, 162067),
(162068, '2.70.160.11-FF-000007', NULL, 'Protein arginine N-methyltransferase 2', 189, NULL, NULL, 162068),
(162069, '3.30.420.40-FF-000940', NULL, 'Actin-like protein arp10', 67, NULL, NULL, 162069),
(162070, '1.25.40.180-FF-000105', NULL, 'Uncharacterized protein, isoform A', 202, NULL, NULL, 162070),
(162071, '3.40.390.10-FF-000004', NULL, 'Metalloendopeptidase', 199, NULL, NULL, 162071),
(162072, '2.30.29.30-FF-000900', NULL, 'Uncharacterized protein', 68, NULL, NULL, 162072),
(162073, '1.10.510.10-FF-000568', NULL, 'Calmodulin-domain protein kinase 1', 196, NULL, NULL, 162073),
(162074, '1.10.10.1180-FF-000005', NULL, 'Inner nuclear membrane protein SRC1', 98, NULL, NULL, 162074),
(162075, '2.60.40.10-FF-000459', NULL, 'Intercellular adhesion molecule 1', 95, NULL, NULL, 162075),
(162076, '1.10.238.10-FF-000980', NULL, 'Calcium-dependent protein kinase 25', 35, NULL, NULL, 162076),
(162077, '1.25.40.10-FF-004606', NULL, 'Uncharacterized protein', 164, NULL, NULL, 162077),
(162078, '3.10.100.10-FF-000097', NULL, 'Uninflatable, isoform B', 149, NULL, NULL, 162078),
(162079, '3.90.1150.10-FF-000036', NULL, '8-amino-7-oxononanoate synthase', 112, NULL, NULL, 162079),
(162080, '3.40.50.12780-FF-000093', NULL, 'Probable acyl-activating enzyme 18, peroxisomal', 505, NULL, NULL, 162080),
(162081, '3.40.50.720-FF-000490', NULL, 'Dehydrogenase/reductase SDR family member on chromosome X', 292, NULL, NULL, 162081),
(162082, '3.30.420.40-FF-000833', NULL, 'Uncharacterized protein', 112, NULL, NULL, 162082),
(162083, '3.40.630.170-FF-000001', NULL, 'Glycylpeptide N-tetradecanoyltransferase', 390, NULL, NULL, 162083),
(162084, '3.30.70.330-FF-000519', NULL, 'heterogeneous nuclear ribonucleoprotein 1', 93, NULL, NULL, 162084),
(162085, '2.60.120.260-FF-000257', NULL, 'Uncharacterized protein', 218, NULL, NULL, 162085),
(162086, '2.130.10.10-FF-002680', NULL, 'Uncharacterized protein', 250, NULL, NULL, 162086),
(162087, '3.80.10.10-FF-000605', NULL, 'F-box/LRR-repeat protein 15 isoform C', 144, NULL, NULL, 162087),
(162088, '3.40.50.1260-FF-000004', NULL, 'Phosphoglycerate kinase', 151, NULL, NULL, 162088),
(162089, '1.10.510.10-FF-000894', NULL, 'Serine/threonine-protein kinase srpk2', 85, NULL, NULL, 162089),
(162090, '3.30.160.60-FF-004377', NULL, NULL, 38, NULL, NULL, 162090),
(162091, '3.50.50.60-FF-000742', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 155, NULL, NULL, 162091);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(162092, '3.90.70.10-FF-000761', NULL, 'Predicted protein', 91, NULL, NULL, 162092),
(162093, '1.20.1250.20-FF-002065', NULL, 'Uncharacterized protein', 286, NULL, NULL, 162093),
(162094, '1.10.730.10-FF-000096', NULL, 'Arginine--tRNA ligase, cytoplasmic', 132, NULL, NULL, 162094),
(162095, '3.30.1370.10-FF-000162', NULL, 'KRR1 small subunit processome component', 123, NULL, NULL, 162095),
(162096, '3.30.70.120-FF-000007', NULL, 'ATP phosphoribosyltransferase, chloroplastic', 78, NULL, NULL, 162096),
(162097, '3.30.760.10-FF-000080', NULL, 'Eukaryotic translation initiation factor 4E', 154, NULL, NULL, 162097),
(162098, '1.10.1450.10-FF-000096', NULL, 'Tetraspanin', 76, NULL, NULL, 162098),
(162099, '1.20.950.20-FF-000028', NULL, 'Cytochrome b', 217, NULL, NULL, 162099),
(162100, '3.30.160.60-FF-003073', NULL, 'GM13855', 34, NULL, NULL, 162100),
(162101, '1.20.930.10-FF-000030', NULL, 'Transcription elongation factor TFIIS', 100, NULL, NULL, 162101),
(162102, '3.40.50.300-FF-000836', NULL, 'ABC transporter B family member 25', 242, NULL, NULL, 162102),
(162103, '3.30.497.10-FF-000029', NULL, 'Serpin family B member 12', 169, NULL, NULL, 162103),
(162104, '3.90.1150.10-FF-000143', NULL, 'Glycine cleavage system P protein', 98, NULL, NULL, 162104),
(162105, '1.20.272.10-FF-000079', NULL, NULL, 92, NULL, NULL, 162105),
(162106, '3.30.559.10-FF-000016', NULL, 'Nonribosomal peptide synthase Pes1', 171, NULL, NULL, 162106),
(162107, '1.10.287.70-FF-000032', NULL, 'Voltage-dependent T-type calcium channel subunit alpha', 151, NULL, NULL, 162107),
(162108, '2.10.25.10-FF-001814', NULL, 'Keratin-associated protein 5-8, putative', 55, NULL, NULL, 162108),
(162109, '2.130.10.10-FF-004815', NULL, 'Uncharacterized WD repeat-containing protein C17D11.16', 139, NULL, NULL, 162109),
(162110, '3.30.230.10-FF-000096', NULL, 'Homoserine kinase', 174, NULL, NULL, 162110),
(162111, '3.60.10.10-FF-000090', NULL, 'Actin', 313, NULL, NULL, 162111),
(162112, '3.90.550.10-FF-000764', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 366, NULL, NULL, 162112),
(162113, '3.30.160.60-FF-005001', NULL, NULL, 45, NULL, NULL, 162113),
(162114, '3.40.50.150-FF-000870', NULL, 'tRNA/rRNA cytosine-C5-methylase, NOL1/NOP2/Sun family', 206, NULL, NULL, 162114),
(162115, '3.90.980.10-FF-000010', NULL, 'Uncharacterized protein', 54, NULL, NULL, 162115),
(162116, '2.60.210.10-FF-000064', NULL, NULL, 107, NULL, NULL, 162116),
(162117, '3.30.200.20-FF-002418', NULL, 'Protein lin-2', 86, NULL, NULL, 162117),
(162118, '3.30.70.270-FF-000024', NULL, 'Predicted diguanylate cyclase', 148, NULL, NULL, 162118),
(162119, '2.130.10.10-FF-004708', NULL, 'Uncharacterized protein', 171, NULL, NULL, 162119),
(162120, '1.20.1250.20-FF-002172', NULL, 'Uncharacterized protein', 177, NULL, NULL, 162120),
(162121, '1.20.1070.10-FF-002071', NULL, 'Retinal G protein coupled receptor', 66, NULL, NULL, 162121),
(162122, '3.10.129.10-FF-000073', NULL, 'Putative acyl-ACP thioesterase', 244, NULL, NULL, 162122),
(162123, '1.25.10.10-FF-000496', NULL, 'Cell proliferation regulating inhibitor of protein phosphatase 2A', 305, NULL, NULL, 162123),
(162124, '3.30.70.260-FF-000021', NULL, 'Formyltetrahydrofolate deformylase', 74, NULL, NULL, 162124),
(162125, '1.10.472.10-FF-000675', NULL, 'Cyclin D2, a', 24, NULL, NULL, 162125),
(162126, '3.50.50.60-FF-000523', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 146, NULL, NULL, 162126),
(162127, '1.10.510.10-FF-003423', NULL, NULL, 290, NULL, NULL, 162127),
(162128, '3.10.20.10-FF-000031', NULL, 'Uncharacterized protein', 64, NULL, NULL, 162128),
(162129, '3.30.160.60-FF-000908', NULL, 'Zinc finger and BTB domain containing 41', 27, NULL, NULL, 162129),
(162130, '1.10.150.130-FF-000012', NULL, 'Tyrosine recombinase XerC', 95, NULL, NULL, 162130),
(162131, '3.60.150.10-FF-000015', NULL, 'Chorismate synthase', 361, NULL, NULL, 162131),
(162132, '3.40.50.300-FF-005041', NULL, 'Guanylate-binding protein 6', 65, NULL, NULL, 162132),
(162133, '2.60.40.10-FF-003421', NULL, NULL, 108, NULL, NULL, 162133),
(162134, '3.30.70.660-FF-000034', NULL, 'Similar to pseudouridylate synthase 3', 225, NULL, NULL, 162134);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(162135, '3.50.50.60-FF-000063', NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', 220, NULL, NULL, 162135),
(162136, '1.25.40.20-FF-001170', NULL, 'Ankyrin repeat and SOCS box-containing 2b', 52, NULL, NULL, 162136),
(162137, '1.20.5.420-FF-000018', NULL, 'Ribonuclease P protein component 4', 60, NULL, NULL, 162137),
(162138, '3.30.200.20-FF-000513', NULL, 'Receptor-like protein kinase HSL1', 103, NULL, NULL, 162138),
(162139, '3.80.10.10-FF-004091', NULL, 'Roco6, ROCO family protein', 123, NULL, NULL, 162139),
(162140, '3.40.50.150-FF-001252', NULL, 'tRNA (cytosine(48)-C(5))-methyltransferase', 206, NULL, NULL, 162140),
(162141, '3.30.70.100-FF-000001', NULL, 'ATPase copper transporting beta', 73, NULL, NULL, 162141),
(162142, '3.30.200.20-FF-001114', NULL, 'Serine/threonine protein kinase', 59, NULL, NULL, 162142),
(162143, '3.40.50.10260-FF-000017', NULL, 'Multifunctional fusion protein', 212, NULL, NULL, 162143),
(162144, '1.10.150.240-FF-000045', NULL, 'CBBY-like protein', 85, NULL, NULL, 162144),
(162145, '3.30.200.20-FF-000283', NULL, 'Mitogen-activated protein kinase kinase kinase 8', 147, NULL, NULL, 162145),
(162146, '1.25.10.10-FF-002862', NULL, 'Condensin complex subunit 1', 163, NULL, NULL, 162146),
(162147, '3.30.200.20-FF-001002', NULL, 'Non-specific serine/threonine protein kinase', 21, NULL, NULL, 162147),
(162148, '3.10.290.10-FF-000099', NULL, 'Pseudouridine synthase', 62, NULL, NULL, 162148),
(162149, '3.30.70.360-FF-000051', NULL, 'Peptidase T', 112, NULL, NULL, 162149),
(162150, '3.30.70.1390-FF-000001', NULL, 'Leucine-rich repeat serine/threonine-protein kinase 2', 79, NULL, NULL, 162150),
(162151, '3.30.1010.10-FF-000129', NULL, 'Putative actin-fragmin kinase DDB_G0279609', 167, NULL, NULL, 162151),
(162152, '3.30.40.10-FF-002094', NULL, 'Uncharacterized protein', 83, NULL, NULL, 162152),
(162153, '1.25.10.10-FF-000726', NULL, 'Deoxyhypusine hydroxylase', 158, NULL, NULL, 162153),
(162154, '3.40.50.1820-FF-000543', NULL, 'Uncharacterized protein', 307, NULL, NULL, 162154),
(162155, '2.30.30.40-FF-000536', NULL, 'F-BAR and double SH3 domains protein 2', 76, NULL, NULL, 162155),
(162156, '3.40.50.620-FF-000022', NULL, 'Argininosuccinate synthase', 140, NULL, NULL, 162156),
(162157, '2.30.30.40-FF-000648', NULL, 'Tyrosine-protein kinase sid-3', 74, NULL, NULL, 162157),
(162158, '2.60.420.10-FF-000001', NULL, 'Family 65 glycosyl hydrolase', 71, NULL, NULL, 162158),
(162159, '3.30.1250.10-FF-000001', NULL, 'SBDS, ribosome maturation factor', 94, NULL, NULL, 162159),
(162160, '1.10.10.10-FF-000439', NULL, 'IclR family transcriptional regulator', 82, NULL, NULL, 162160),
(162161, '3.15.10.30-FF-000003', NULL, 'GL26316', 225, NULL, NULL, 162161),
(162162, '3.90.20.20-FF-000007', NULL, 'Protein GrpE', 112, NULL, NULL, 162162),
(162163, '3.90.226.10-FF-000275', NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', 324, NULL, NULL, 162163),
(162164, '3.40.50.1000-FF-000539', NULL, NULL, 181, NULL, NULL, 162164),
(162165, '4.10.60.10-FF-000188', NULL, 'Cold shock domain protein 1', 48, NULL, NULL, 162165),
(162166, '3.10.350.10-FF-000031', NULL, 'Murein DD-endopeptidase MepM/ murein hydrolase activator NlpD', 65, NULL, NULL, 162166),
(162167, '1.20.1080.10-FF-000121', NULL, 'Uncharacterized protein', 74, NULL, NULL, 162167),
(162168, '1.10.12.70-FF-000017', NULL, NULL, 88, NULL, NULL, 162168),
(162169, '3.30.160.60-FF-004489', NULL, NULL, 27, NULL, NULL, 162169),
(162170, '2.40.70.10-FF-000338', NULL, NULL, 164, NULL, NULL, 162170),
(162171, '3.40.228.10-FF-000009', NULL, 'Formate dehydrogenase, alpha subunit, selenocysteine-containing', 81, NULL, NULL, 162171),
(162172, '2.60.40.10-FF-002932', NULL, 'Connectin', 101, NULL, NULL, 162172),
(162173, '3.20.110.10-FF-000005', NULL, 'Alpha-mannosidase', 392, NULL, NULL, 162173),
(162174, '2.60.40.10-FF-004618', NULL, NULL, 101, NULL, NULL, 162174),
(162175, '1.25.40.530-FF-000025', NULL, NULL, 178, NULL, NULL, 162175),
(162176, '1.25.40.540-FF-000028', NULL, 'Uncharacterized protein', 135, NULL, NULL, 162176);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(162177, '3.30.40.10-FF-002105', NULL, 'Uncharacterized protein', 60, NULL, NULL, 162177),
(162178, '3.30.160.60-FF-005113', NULL, NULL, 59, NULL, NULL, 162178),
(162179, '1.10.510.10-FF-000782', NULL, 'Leucine-rich repeat protein kinase family protein', 222, NULL, NULL, 162179),
(162180, '3.90.1150.10-FF-000255', NULL, 'ATLCB1', 60, NULL, NULL, 162180),
(162181, '1.25.10.10-FF-002750', NULL, 'Predicted protein', 676, NULL, NULL, 162181),
(162182, '3.30.2350.20-FF-000063', NULL, NULL, 239, NULL, NULL, 162182),
(162183, '3.40.50.300-FF-003354', NULL, 'Dynein heavy chain', 126, NULL, NULL, 162183),
(162184, '1.20.1530.20-FF-000086', NULL, 'Predicted protein', 322, NULL, NULL, 162184),
(162185, '3.30.2350.10-FF-000060', NULL, 'Trans-splicing factor Raa2, chloroplastic', 119, NULL, NULL, 162185),
(162186, '1.10.10.10-FF-000658', NULL, 'COP9 signalosome complex subunit 4, putative', 80, NULL, NULL, 162186),
(162187, '2.130.10.10-FF-004585', NULL, 'Uncharacterized protein', 345, NULL, NULL, 162187),
(162188, '3.40.50.620-FF-000241', NULL, 'Isoleucine--tRNA ligase', 209, NULL, NULL, 162188),
(162189, '2.10.50.30-FF-000029', NULL, 'Metabotropic glutamate receptor 3', 75, NULL, NULL, 162189),
(162190, '3.40.50.300-FF-008481', NULL, 'Uncharacterized protein', 195, NULL, NULL, 162190),
(162191, '3.90.79.10-FF-000174', NULL, 'Uncharacterized protein', 195, NULL, NULL, 162191),
(162192, '3.90.550.10-FF-000545', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 351, NULL, NULL, 162192),
(162193, '2.170.300.10-FF-000022', NULL, 'Uncharacterized protein', 49, NULL, NULL, 162193),
(162194, '2.40.100.10-FF-000167', NULL, 'Uncharacterized protein', 72, NULL, NULL, 162194),
(162195, '3.40.50.300-FF-004984', NULL, 'Uncharacterized protein', 242, NULL, NULL, 162195),
(162196, '2.60.40.10-FF-003207', NULL, 'Inducible T cell costimulator', 124, NULL, NULL, 162196),
(162197, '1.10.274.100-FF-000015', NULL, 'DNA-directed RNA polymerase subunit', 181, NULL, NULL, 162197),
(162198, '3.40.50.2300-FF-000154', NULL, 'Stage 0 sporulation protein A', 133, NULL, NULL, 162198),
(162199, '2.40.50.140-FF-000168', NULL, '26S protease regulatory subunit 10B', 67, NULL, NULL, 162199),
(162200, '2.30.42.10-FF-000077', NULL, 'Periplasmic serine peptidase DegS', 97, NULL, NULL, 162200),
(162201, '1.10.1030.10-FF-000002', NULL, 'Carbamoyl-phosphate synthase large chain', 147, NULL, NULL, 162201),
(162202, '3.40.50.10240-FF-000011', NULL, 'Thiamin pyrophosphokinase 1', 99, NULL, NULL, 162202),
(162203, '3.30.420.100-FF-000019', NULL, 'Uncharacterized protein', 140, NULL, NULL, 162203),
(162204, '1.20.120.1750-FF-000064', NULL, 'RBR-type E3 ubiquitin transferase', 85, NULL, NULL, 162204),
(162205, '1.20.1070.10-FF-002183', NULL, 'Uncharacterized protein', 94, NULL, NULL, 162205),
(162206, '1.25.10.10-FF-001120', NULL, 'Uncharacterized protein', 859, NULL, NULL, 162206),
(162207, '3.30.70.1350-FF-000017', NULL, 'Related to cation diffusion facilitator 10', 77, NULL, NULL, 162207),
(162208, '1.25.40.10-FF-004269', NULL, 'Uncharacterized protein', 216, NULL, NULL, 162208),
(162209, '3.40.190.290-FF-000065', NULL, 'LysR family transcriptional regulator', 195, NULL, NULL, 162209),
(162210, '2.30.30.40-FF-000643', NULL, 'Protein vav-1', 78, NULL, NULL, 162210),
(162211, '2.30.30.100-FF-000019', NULL, 'Small nuclear ribonucleoprotein G', 75, NULL, NULL, 162211),
(162212, '3.40.50.10810-FF-000227', NULL, 'ERCC excision repair 6, chromatin remodeling factor', 274, NULL, NULL, 162212),
(162213, '3.10.350.10-FF-000036', NULL, 'Membrane-bound lytic murein transglycosylase D', 51, NULL, NULL, 162213),
(162214, '3.90.1150.10-FF-000148', NULL, 'Perosamine synthase', 112, NULL, NULL, 162214),
(162215, '2.60.120.260-FF-000476', NULL, 'Uncharacterized protein', 162, NULL, NULL, 162215),
(162216, '1.25.40.10-FF-002919', NULL, 'Os09g0412900 protein', 175, NULL, NULL, 162216),
(162217, '1.10.10.60-FF-000319', NULL, 'Mushroom body large-type Kenyon cell-specific protein 1', 41, NULL, NULL, 162217),
(162218, '2.20.70.10-FF-000165', NULL, 'Yes-associated protein homolog 1', 44, NULL, NULL, 162218);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(162219, '3.40.525.10-FF-000026', NULL, 'ECM25p protein', 168, NULL, NULL, 162219),
(162220, '2.130.10.10-FF-006058', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', 294, NULL, NULL, 162220),
(162221, '3.30.465.10-FF-000017', NULL, 'Xanthine dehydrogenase, FAD binding subunit', 117, NULL, NULL, 162221),
(162222, '2.60.40.10-FF-000678', NULL, 'Down syndrome cell adhesion molecule-like protein Dscam2', 94, NULL, NULL, 162222),
(162223, '3.40.50.300-FF-006457', NULL, 'Uncharacterized protein', 121, NULL, NULL, 162223),
(162224, '1.25.40.10-FF-004825', NULL, 'Putative pentatricopeptide repeat family protein', 149, NULL, NULL, 162224),
(162225, '3.60.10.10-FF-000213', NULL, 'Type I inositol polyphosphate 5-phosphatase 10', 103, NULL, NULL, 162225),
(162226, '3.20.20.100-FF-000027', NULL, 'Aldo/keto reductase', 326, NULL, NULL, 162226),
(162227, '1.25.40.10-FF-004483', NULL, 'Uncharacterized protein', 102, NULL, NULL, 162227),
(162228, '1.25.40.990-FF-000028', NULL, 'GM24516', 231, NULL, NULL, 162228),
(162229, '2.40.50.40-FF-000110', NULL, 'Uncharacterized protein', 63, NULL, NULL, 162229),
(162230, '2.40.50.770-FF-000019', NULL, 'RecQ-mediated genome instability protein 1', 175, NULL, NULL, 162230),
(162231, '3.30.559.10-FF-000235', NULL, 'Uncharacterized protein', 158, NULL, NULL, 162231),
(162232, '3.40.390.10-FF-000116', NULL, 'Metalloendopeptidase', 68, NULL, NULL, 162232),
(162233, '3.50.4.10-FF-000055', NULL, NULL, 79, NULL, NULL, 162233),
(162234, '2.10.25.10-FF-001691', NULL, 'Uncharacterized protein', 65, NULL, NULL, 162234),
(162235, '1.10.10.10-FF-000546', NULL, 'Two-component response regulator GraR', 101, NULL, NULL, 162235),
(162236, '3.30.300.130-FF-000013', NULL, 'NifU-like scaffold protein, putative', 76, NULL, NULL, 162236),
(162237, '3.40.50.1220-FF-000021', NULL, 'IlvB (bacterial acetolactate synthase)-like', 176, NULL, NULL, 162237),
(162238, '2.160.20.10-FF-000228', NULL, 'SHC SH2 domain-binding protein 1-like Protein', 248, NULL, NULL, 162238),
(162239, '3.40.50.720-FF-000613', NULL, 'Ubiquitin-activating enzyme', 33, NULL, NULL, 162239),
(162240, '3.10.20.370-FF-000003', NULL, 'Transposon Tf2-6 polyprotein', 72, NULL, NULL, 162240),
(162241, '3.30.310.50-FF-000047', NULL, 'KEOPS complex subunit Pcc1', 82, NULL, NULL, 162241),
(162242, '3.40.50.150-FF-001033', NULL, NULL, 165, NULL, NULL, 162242),
(162243, '1.10.940.10-FF-000033', NULL, 'Transcription antitermination protein NusB', 146, NULL, NULL, 162243),
(162244, '2.120.10.80-FF-000379', NULL, 'AGAP009495-PA', 144, NULL, NULL, 162244),
(162245, '3.30.1330.60-FF-000039', NULL, 'OmpA family protein', 97, NULL, NULL, 162245),
(162246, '2.10.25.10-FF-001584', NULL, 'Uncharacterized protein', 39, NULL, NULL, 162246),
(162247, '1.10.150.20-FF-000133', NULL, 'DNA repair protein RAD51 homolog', 80, NULL, NULL, 162247),
(162248, '2.130.10.10-FF-004259', NULL, 'Predicted protein', 137, NULL, NULL, 162248),
(162249, '3.30.1330.40-FF-000033', NULL, 'ATP-binding region containing protein, putative', 174, NULL, NULL, 162249),
(162250, '3.40.50.150-FF-001701', NULL, NULL, 78, NULL, NULL, 162250),
(162251, '3.80.10.10-FF-004102', NULL, 'Uncharacterized protein', 119, NULL, NULL, 162251),
(162252, '4.10.60.10-FF-000183', NULL, 'Serine/arginine-rich splicing factor RSZ21', 56, NULL, NULL, 162252),
(162253, '1.10.510.10-FF-003204', NULL, NULL, 146, NULL, NULL, 162253),
(162254, '2.130.10.10-FF-003511', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 224, NULL, NULL, 162254),
(162255, '3.30.950.10-FF-000010', NULL, 'Uroporphyrin-III C-methyltransferase', 123, NULL, NULL, 162255),
(162256, '3.80.10.10-FF-003478', NULL, 'Leucine Rich Repeat family protein', 207, NULL, NULL, 162256),
(162257, '1.10.472.10-FF-000456', NULL, 'Origin recognition complex subunit 6', 106, NULL, NULL, 162257),
(162258, '1.10.4160.10-FF-000023', NULL, 'Allantoin permease', 482, NULL, NULL, 162258),
(162259, '3.40.190.10-FF-000567', NULL, 'Predicted protein', 44, NULL, NULL, 162259),
(162260, '3.30.710.10-FF-000026', NULL, 'E3 ubiquitin ligase complex SCF subunit', 161, NULL, NULL, 162260);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(162261, '2.120.10.30-FF-000281', NULL, 'Uncharacterized protein', 137, NULL, NULL, 162261),
(162262, '1.10.8.270-FF-000195', NULL, 'Uncharacterized protein', 69, NULL, NULL, 162262),
(162263, '1.25.40.10-FF-000902', NULL, 'Testis expressed 11', 217, NULL, NULL, 162263),
(162264, '3.30.160.60-FF-000785', NULL, 'zinc finger protein 648', 27, NULL, NULL, 162264),
(162265, '3.30.60.20-FF-000075', NULL, 'Rho-associated protein kinase 1', 68, NULL, NULL, 162265),
(162266, '3.40.50.12780-FF-000216', NULL, 'Uncharacterized protein', 339, NULL, NULL, 162266),
(162267, '3.80.10.10-FF-003826', NULL, 'SYM-1 protein', 71, NULL, NULL, 162267),
(162268, '3.40.50.1820-FF-000324', NULL, 'Homoserine O-acetyltransferase', 364, NULL, NULL, 162268),
(162269, '3.40.50.720-FF-000271', NULL, 'oxidoreductase HTATIP2 isoform X1', 240, NULL, NULL, 162269),
(162270, '3.90.1590.10-FF-000001', NULL, 'Putative DUF636 domain protein (AFU_orthologue AFUA_2G15290)', 130, NULL, NULL, 162270),
(162271, '1.25.40.10-FF-003302', NULL, 'Uncharacterized protein', 72, NULL, NULL, 162271),
(162272, '3.40.140.10-FF-000289', NULL, 'STAM binding protein like 1', 133, NULL, NULL, 162272),
(162273, '3.40.50.720-FF-001794', NULL, 'Shikimate dehydrogenase (NADP(+))', 137, NULL, NULL, 162273),
(162274, '3.40.50.1000-FF-000865', NULL, NULL, 25, NULL, NULL, 162274),
(162275, '2.60.40.60-FF-001047', NULL, 'Uncharacterized protein', 93, NULL, NULL, 162275),
(162276, '1.20.1250.20-FF-000603', NULL, 'Acetyl-coenzyme A transporter 1', 408, NULL, NULL, 162276),
(162277, '3.40.390.10-FF-000223', NULL, NULL, 141, NULL, NULL, 162277),
(162278, '3.40.50.2000-FF-000159', NULL, 'Glycosyltransferase, group 1 family protein', 186, NULL, NULL, 162278),
(162279, '2.10.10.10-FF-000021', NULL, 'HGF activator', 51, NULL, NULL, 162279),
(162280, '3.30.1640.10-FF-000048', NULL, 'DNA helicase', 85, NULL, NULL, 162280),
(162281, '3.60.15.10-FF-000191', NULL, 'Prostate cancer susceptibility protein-like protein', 318, NULL, NULL, 162281),
(162282, '1.10.287.130-FF-000112', NULL, 'Sensor histidine kinase', 64, NULL, NULL, 162282),
(162283, '2.40.10.10-FF-000565', NULL, NULL, 68, NULL, NULL, 162283),
(162284, '3.40.50.2300-FF-000373', NULL, 'DNA-binding response regulator', 122, NULL, NULL, 162284),
(162285, '3.40.850.10-FF-000247', NULL, 'Kinesin family member 4A', 89, NULL, NULL, 162285),
(162286, '2.60.40.10-FF-000785', NULL, 'Myosin light chain kinase, smooth muscle', 72, NULL, NULL, 162286),
(162287, '3.80.10.10-FF-002174', NULL, 'Leucine-rich repeat protein (LRRP), putative', 348, NULL, NULL, 162287),
(162288, '2.30.40.10-FF-000022', NULL, 'Dihydropyrimidinase-related protein 2', 110, NULL, NULL, 162288),
(162289, '3.40.50.720-FF-002070', NULL, 'Dihydroflavonol-4-reductase', 152, NULL, NULL, 162289),
(162290, '3.40.50.300-FF-000729', NULL, 'ATP-binding cassette, sub-family A (ABC1), member 5', 253, NULL, NULL, 162290),
(162291, '3.90.1150.10-FF-000474', NULL, 'Uncharacterized protein', 110, NULL, NULL, 162291),
(162292, '3.40.50.300-FF-001218', NULL, 'AAA family ATPase, putative', 177, NULL, NULL, 162292),
(162293, '3.40.50.300-FF-003910', NULL, 'Adenylate kinase isoenzyme 6 homolog', 211, NULL, NULL, 162293),
(162294, '1.25.40.90-FF-000072', NULL, 'ANTH domain-domain-containing protein', 134, NULL, NULL, 162294),
(162295, '1.20.5.170-FF-000241', NULL, 'transcription factor protein isoform X1', 62, NULL, NULL, 162295),
(162296, '3.30.160.60-FF-005332', NULL, NULL, 72, NULL, NULL, 162296),
(162297, '3.30.160.60-FF-002691', NULL, 'Blast:Zinc finger protein 425', 23, NULL, NULL, 162297),
(162298, '1.25.40.10-FF-000554', NULL, 'Pentatricopeptide repeat-containing protein At2g41720', 161, NULL, NULL, 162298),
(162299, '2.30.30.100-FF-000126', NULL, 'Uncharacterized protein', 100, NULL, NULL, 162299),
(162300, '1.20.1250.20-FF-001683', NULL, 'Siderophore iron transporter 3', 289, NULL, NULL, 162300),
(162301, '3.30.160.60-FF-006294', NULL, NULL, 39, NULL, NULL, 162301),
(162302, '1.20.5.710-FF-000010', NULL, '50S ribosomal protein L7/L12', 54, NULL, NULL, 162302);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(162303, '3.40.1280.10-FF-000113', NULL, 'Predicted protein', 58, NULL, NULL, 162303),
(162304, '2.60.40.10-FF-003202', NULL, 'Uncharacterized protein', 106, NULL, NULL, 162304),
(162305, '1.10.10.10-FF-000984', NULL, 'U5 small nuclear ribonucleoprotein helicase, putative', 108, NULL, NULL, 162305),
(162306, '3.40.50.300-FF-005153', NULL, 'Uncharacterized protein', 231, NULL, NULL, 162306),
(162307, '3.30.1340.10-FF-000008', NULL, 'Phosphocarrier protein NPr', 88, NULL, NULL, 162307),
(162308, '3.30.497.10-FF-000136', NULL, 'Serpin 2 precursor, putative', 226, NULL, NULL, 162308),
(162309, '2.40.10.10-FF-000458', NULL, 'Probable trypsin-like serine protease', 322, NULL, NULL, 162309),
(162310, '2.30.29.30-FF-000451', NULL, 'Pez, isoform A', 93, NULL, NULL, 162310),
(162311, '2.60.120.260-FF-000038', NULL, 'BTB/POZ domain-containing protein 9', 134, NULL, NULL, 162311),
(162312, '1.10.260.40-FF-000001', NULL, 'POU domain protein', 71, NULL, NULL, 162312),
(162313, '2.130.10.10-FF-004478', NULL, 'Uncharacterized protein', 195, NULL, NULL, 162313),
(162314, '3.40.50.20-FF-000040', NULL, 'D-alanine--D-alanine ligase', 118, NULL, NULL, 162314),
(162315, '3.30.70.330-FF-001020', NULL, 'Unplaced genomic scaffold supercont1.57, whole genome shotgun sequence', 116, NULL, NULL, 162315),
(162316, '3.50.7.10-FF-000078', NULL, NULL, 42, NULL, NULL, 162316),
(162317, '3.40.50.300-FF-004877', NULL, 'Uncharacterized protein', 202, NULL, NULL, 162317),
(162318, '1.10.510.10-FF-003311', NULL, NULL, 75, NULL, NULL, 162318),
(162319, '2.120.10.30-FF-000174', NULL, 'Uncharacterized protein', 271, NULL, NULL, 162319),
(162320, '2.10.25.10-FF-001707', NULL, 'Protein CBR-STR-90', 41, NULL, NULL, 162320),
(162321, '3.20.20.450-FF-000008', NULL, 'Cyclic di-GMP phosphodiesterase', 255, NULL, NULL, 162321),
(162322, '1.20.1070.10-FF-000614', NULL, 'Uncharacterized protein', 318, NULL, NULL, 162322),
(162323, '3.60.130.10-FF-000020', NULL, 'GG15479', 279, NULL, NULL, 162323),
(162324, '1.10.640.10-FF-000100', NULL, 'Uncharacterized protein', 196, NULL, NULL, 162324),
(162325, '3.30.70.330-FF-000396', NULL, 'Putative Pre-mRNA-splicing factor slt11', 67, NULL, NULL, 162325),
(162326, '3.30.200.20-FF-002295', NULL, 'Uncharacterized protein', 24, NULL, NULL, 162326),
(162327, '1.10.10.60-FF-001027', NULL, NULL, 58, NULL, NULL, 162327),
(162328, '3.40.720.10-FF-000030', NULL, 'Phosphoethanolamine transferase eptB', 314, NULL, NULL, 162328),
(162329, '3.40.47.10-FF-000147', NULL, 'Polyketide synthase type I', 438, NULL, NULL, 162329),
(162330, '1.10.357.50-FF-000026', NULL, 'Uncharacterized protein', 189, NULL, NULL, 162330),
(162331, '3.40.50.300-FF-006564', NULL, 'Uncharacterized protein', 102, NULL, NULL, 162331),
(162332, '3.40.50.2000-FF-000507', NULL, 'Glycosyltransferase', 251, NULL, NULL, 162332),
(162333, '1.20.1740.10-FF-000020', NULL, 'Putative cadaverine/lysine antiporter CadB', 442, NULL, NULL, 162333),
(162334, '3.30.519.10-FF-000019', NULL, 'Rab proteins geranylgeranyltransferase', 189, NULL, NULL, 162334),
(162335, '3.10.110.10-FF-000378', NULL, 'RBR-type E3 ubiquitin transferase', 74, NULL, NULL, 162335),
(162336, '3.40.50.720-FF-001575', NULL, 'Acetoacetyl-CoA reductase', 240, NULL, NULL, 162336),
(162337, '1.25.10.10-FF-003132', NULL, 'Serine/threonine-protein kinase TOR', 128, NULL, NULL, 162337),
(162338, '3.30.450.20-FF-000317', NULL, 'Methyl-accepting chemotaxis protein', 88, NULL, NULL, 162338),
(162339, '3.90.940.10-FF-000013', NULL, NULL, 118, NULL, NULL, 162339),
(162340, '1.10.220.150-FF-000079', NULL, 'Uncharacterized protein', 57, NULL, NULL, 162340),
(162341, '2.10.25.10-FF-001365', NULL, 'Coagulation factor X', 59, NULL, NULL, 162341),
(162342, '3.30.40.10-FF-000312', NULL, 'Zinc finger, FYVE-type, endofin', 79, NULL, NULL, 162342),
(162343, '1.20.120.1240-FF-000017', NULL, 'Dynamin-2A', 111, NULL, NULL, 162343),
(162344, '2.10.50.30-FF-000024', NULL, 'Uncharacterized protein', 37, NULL, NULL, 162344),
(162345, '3.30.260.10-FF-000047', NULL, 'Bardet-Biedl syndrome 10 protein', 97, NULL, NULL, 162345);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(162346, '3.40.50.300-FF-004658', NULL, 'Guanylate kinase family protein', 97, NULL, NULL, 162346),
(162347, '3.30.1370.10-FF-000055', NULL, 'protein quaking isoform X1', 167, NULL, NULL, 162347),
(162348, '3.40.50.300-FF-006783', NULL, 'Uncharacterized protein', 59, NULL, NULL, 162348),
(162349, '3.80.10.10-FF-002522', NULL, 'Uncharacterized protein', 130, NULL, NULL, 162349),
(162350, '2.60.220.50-FF-000110', NULL, 'Uncharacterized protein', 115, NULL, NULL, 162350),
(162351, '1.10.510.10-FF-000787', NULL, 'NEK protein kinase', 270, NULL, NULL, 162351),
(162352, '1.25.10.10-FF-002643', NULL, 'Armadillo repeat-containing 4', 117, NULL, NULL, 162352),
(162353, '1.20.1280.290-FF-000037', NULL, 'Uncharacterized protein', 93, NULL, NULL, 162353),
(162354, '2.30.30.1190-FF-000014', NULL, 'Zinc finger C-x8-C-x5-C-x3-H type family protein', 82, NULL, NULL, 162354),
(162355, '3.60.21.70-FF-000003', NULL, 'WW domain protein', 443, NULL, NULL, 162355),
(162356, '3.30.450.190-FF-000029', NULL, 'Uncharacterized protein', 61, NULL, NULL, 162356),
(162357, '1.10.10.60-FF-000196', NULL, 'Multiple antibiotic resistance protein MarA', 65, NULL, NULL, 162357),
(162358, '2.40.160.50-FF-000036', NULL, 'Hemolysin activator protein', 379, NULL, NULL, 162358),
(162359, '3.30.1490.130-FF-000001', NULL, 'N-acyl-D-amino acid deacylase protein', 57, NULL, NULL, 162359),
(162360, '2.30.42.10-FF-000532', NULL, NULL, 109, NULL, NULL, 162360),
(162361, '3.60.110.10-FF-000018', NULL, 'Protein N-terminal asparagine amidohydrolase', 304, NULL, NULL, 162361),
(162362, '3.30.470.20-FF-000212', NULL, 'Predicted protein', 128, NULL, NULL, 162362),
(162363, '1.20.120.20-FF-000016', NULL, 'Plant Late Embryo Abundant (LEA) related', 134, NULL, NULL, 162363),
(162364, '1.25.40.820-FF-000005', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 159, NULL, NULL, 162364),
(162365, '1.10.10.60-FF-000538', NULL, 'AraC family transcriptional regulator', 104, NULL, NULL, 162365),
(162366, '3.40.50.300-FF-000948', NULL, 'Thymidine kinase', 142, NULL, NULL, 162366),
(162367, '1.25.10.10-FF-002295', NULL, 'Uncharacterized protein', 324, NULL, NULL, 162367),
(162368, '2.130.10.10-FF-002803', NULL, 'WD repeat domain 5', 178, NULL, NULL, 162368),
(162369, '3.40.50.10810-FF-000098', NULL, 'Uncharacterized protein, isoform A', 93, NULL, NULL, 162369),
(162370, '1.10.1370.10-FF-000044', NULL, 'Mitochondrial intermediate peptidase', 234, NULL, NULL, 162370),
(162371, '3.30.230.70-FF-000108', NULL, 'EXOSome (Multiexonuclease complex) component', 276, NULL, NULL, 162371),
(162372, '2.130.10.10-FF-001038', NULL, 'WD repeat domain 70', 117, NULL, NULL, 162372),
(162373, '1.20.5.170-FF-000022', NULL, 'Tripartite motif containing 55', 60, NULL, NULL, 162373),
(162374, '3.20.20.80-FF-000028', NULL, 'Chitinase domain-containing protein 1', 255, NULL, NULL, 162374),
(162375, '2.60.40.3180-FF-000003', NULL, 'Knot, isoform C', 226, NULL, NULL, 162375),
(162376, '3.40.50.300-FF-001437', NULL, 'Plasmid partition protein A', 292, NULL, NULL, 162376),
(162377, '1.20.1720.10-FF-000131', NULL, NULL, 134, NULL, NULL, 162377),
(162378, '2.130.10.10-FF-000549', NULL, 'Small nucleolar ribonucleoprotein complex subunit', 354, NULL, NULL, 162378),
(162379, '2.130.10.10-FF-005889', NULL, 'Uncharacterized protein', 296, NULL, NULL, 162379),
(162380, '3.50.50.60-FF-000068', NULL, 'Glutamate synthase small subunit', 188, NULL, NULL, 162380),
(162381, '2.70.170.10-FF-000294', NULL, 'Cholinergic receptor, nicotinic, alpha 6', 163, NULL, NULL, 162381),
(162382, '3.40.50.720-FF-002406', NULL, 'Uncharacterized protein', 275, NULL, NULL, 162382),
(162383, '2.60.120.40-FF-000066', NULL, 'Elastin microfibril interfacer 1', 47, NULL, NULL, 162383),
(162384, '3.40.50.1820-FF-000105', NULL, 'Fatty acid synthase', 81, NULL, NULL, 162384),
(162385, '3.30.1680.10-FF-000039', NULL, 'Semaphorin 4B', 67, NULL, NULL, 162385),
(162386, '1.10.490.10-FF-000048', NULL, 'Uncharacterized protein', 136, NULL, NULL, 162386),
(162387, '3.40.850.10-FF-000028', NULL, 'Kinesin-like protein', 352, NULL, NULL, 162387); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(162388, '1.10.10.10-FF-000765', NULL, 'Transcriptional regulator HrpG', 114, NULL, NULL, 162388),
(162389, '3.40.50.300-FF-001095', NULL, 'Intraflagellar transport protein 27 homolog', 183, NULL, NULL, 162389),
(162390, '1.10.510.10-FF-003530', NULL, NULL, 240, NULL, NULL, 162390),
(162391, '1.20.120.160-FF-000012', NULL, 'Phosphorelay protein LuxU', 111, NULL, NULL, 162391),
(162392, '3.80.10.10-FF-003259', NULL, 'Uncharacterized protein', 170, NULL, NULL, 162392),
(162393, '3.30.200.20-FF-002082', NULL, 'Protein kinase, putative', 83, NULL, NULL, 162393),
(162394, '3.10.310.10-FF-000034', NULL, 'Uncharacterized protein', 157, NULL, NULL, 162394),
(162395, '1.10.10.10-FF-001041', NULL, 'Probable transcriptional regulator', 82, NULL, NULL, 162395),
(162396, '3.30.9.10-FF-000110', NULL, 'tRNA 5-methylaminomethyl-2-thiouridine biosynthesis bifunctional protein MnmC', 150, NULL, NULL, 162396),
(162397, '1.10.1820.10-FF-000017', NULL, 'Casein kinase II subunit beta', 101, NULL, NULL, 162397),
(162398, '3.40.50.300-FF-006912', NULL, 'Uncharacterized protein', 237, NULL, NULL, 162398),
(162399, '1.25.40.10-FF-002690', NULL, 'Coatomer subunit epsilon', 320, NULL, NULL, 162399),
(162400, '3.40.50.720-FF-001917', NULL, 'SUMO1 activating enzyme subunit 1', 42, NULL, NULL, 162400),
(162401, '2.60.40.150-FF-000822', NULL, 'Uncharacterized protein', 147, NULL, NULL, 162401),
(162402, '1.10.287.570-FF-000002', NULL, 'Solute carrier family 4 member 11', 46, NULL, NULL, 162402),
(162403, '1.25.10.10-FF-000389', NULL, 'Serine/threonine-protein phosphatase 2A 56 kDa regulatory subunit', 219, NULL, NULL, 162403),
(162404, '1.10.472.10-FF-000237', NULL, 'Cyclin-D1-2', 97, NULL, NULL, 162404),
(162405, '2.130.10.10-FF-005080', NULL, 'Uncharacterized protein', 266, NULL, NULL, 162405),
(162406, '3.30.470.30-FF-000092', NULL, 'Uncharacterized protein', 118, NULL, NULL, 162406),
(162407, '3.30.565.10-FF-000188', NULL, 'Two-component sensor histidine kinase', 149, NULL, NULL, 162407),
(162408, '1.25.40.10-FF-002807', NULL, 'tetratricopeptide repeat protein 7B-like', 303, NULL, NULL, 162408),
(162409, '1.25.10.10-FF-002188', NULL, 'Uncharacterized protein', 452, NULL, NULL, 162409),
(162410, '1.20.58.60-FF-000007', NULL, 'Spectrin alpha chain non-erythrocytic 1', 110, NULL, NULL, 162410),
(162411, '2.60.40.10-FF-004495', NULL, NULL, 97, NULL, NULL, 162411),
(162412, '3.80.10.10-FF-003607', NULL, 'Predicted protein', 126, NULL, NULL, 162412),
(162413, '3.30.420.10-FF-000150', NULL, 'Ribonuclease', 197, NULL, NULL, 162413),
(162414, '2.60.40.150-FF-000816', NULL, 'Uncharacterized protein', 118, NULL, NULL, 162414),
(162415, '1.20.1560.10-FF-000141', NULL, 'Thiol reductant ABC exporter subunit CydC', 314, NULL, NULL, 162415),
(162416, '3.30.465.10-FF-000129', NULL, 'D-lactate dehydrogenase', 163, NULL, NULL, 162416),
(162417, '1.10.150.870-FF-000003', NULL, 'DNA-directed DNA polymerase', 96, NULL, NULL, 162417),
(162418, '2.60.40.10-FF-005113', NULL, NULL, 98, NULL, NULL, 162418),
(162419, '1.20.140.60-FF-000001', NULL, 'Calmodulin-sensitive adenylate cyclase', 156, NULL, NULL, 162419),
(162420, '2.20.70.10-FF-000277', NULL, 'Uncharacterized protein', 26, NULL, NULL, 162420),
(162421, '3.30.450.30-FF-000091', NULL, 'Uncharacterized protein', 131, NULL, NULL, 162421),
(162422, '2.30.29.30-FF-000119', NULL, 'FACT complex subunit SSRP1', 94, NULL, NULL, 162422),
(162423, '3.40.50.1240-FF-000139', NULL, 'YALI0A08019p', 268, NULL, NULL, 162423),
(162424, '3.30.70.20-FF-000137', NULL, NULL, 91, NULL, NULL, 162424),
(162425, '1.20.1070.10-FF-001688', NULL, 'Predicted protein', 112, NULL, NULL, 162425),
(162426, '1.20.1250.20-FF-001896', NULL, 'Monocarboxylate transporter, putative', 69, NULL, NULL, 162426),
(162427, '3.20.20.80-FF-000253', NULL, 'glycoprotein endo-alpha-1,2-mannosidase', 335, NULL, NULL, 162427),
(162428, '3.10.100.10-FF-000445', NULL, NULL, 45, NULL, NULL, 162428),
(162429, '2.70.40.10-FF-000032', NULL, 'Putative inactive deoxyuridine 5''-triphosphate nucleotidohydrolase-like protein FLJ16323', 106, NULL, NULL, 162429);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(162430, '1.10.10.60-FF-000864', NULL, NULL, 110, NULL, NULL, 162430),
(162431, '3.40.50.1220-FF-000133', NULL, 'Uncharacterized protein', 112, NULL, NULL, 162431),
(162432, '2.60.120.290-FF-000024', NULL, 'Low-density lipoprotein receptor-related protein 12', 116, NULL, NULL, 162432),
(162433, '3.30.420.40-FF-000159', NULL, 'L-fuculokinase', 244, NULL, NULL, 162433),
(162434, '3.30.70.920-FF-000039', NULL, 'Transcriptional regulator, AsnC family', 94, NULL, NULL, 162434),
(162435, '2.10.25.10-FF-001472', NULL, 'Neurocan core protein', 58, NULL, NULL, 162435),
(162436, '1.20.1050.10-FF-000057', NULL, 'Glutathione S-transferase, N-terminal domain protein', 106, NULL, NULL, 162436),
(162437, '2.60.40.60-FF-000665', NULL, 'Uncharacterized protein', 101, NULL, NULL, 162437),
(162438, '3.30.300.30-FF-000102', NULL, 'AM-toxin synthetase', 100, NULL, NULL, 162438),
(162439, '1.10.238.10-FF-001250', NULL, 'Uncharacterized protein', 78, NULL, NULL, 162439),
(162440, '3.30.200.20-FF-002076', NULL, 'NimA-related protein kinase 8', 83, NULL, NULL, 162440),
(162441, '2.30.42.10-FF-000206', NULL, 'Glutamate receptor-interacting protein 1', 105, NULL, NULL, 162441),
(162442, '3.30.70.560-FF-000009', NULL, '2-amino-4-hydroxy-6-hydroxymethyldihydropteridine pyrophosphokinase FolK-like protein', 177, NULL, NULL, 162442),
(162443, '2.60.120.590-FF-000007', NULL, 'Alpha-ketoglutarate-dependent dioxygenase alkB homolog 6', 224, NULL, NULL, 162443),
(162444, '2.130.10.10-FF-000768', NULL, 'Syntaxin-binding protein 5 isoform B', 151, NULL, NULL, 162444),
(162445, '3.30.870.10-FF-000083', NULL, 'Phospholipase', 191, NULL, NULL, 162445),
(162446, '2.130.10.10-FF-000875', NULL, 'WD repeat-containing protein 82', 70, NULL, NULL, 162446),
(162447, '2.40.50.140-FF-000516', NULL, 'Ribonuclease E/G', 79, NULL, NULL, 162447),
(162448, '3.80.10.10-FF-004208', NULL, 'Uncharacterized protein', 88, NULL, NULL, 162448),
(162449, '1.10.760.10-FF-000047', NULL, 'Hydrazine synthase subunit gamma', 102, NULL, NULL, 162449),
(162450, '1.20.1050.10-FF-000164', NULL, 'Predicted protein', 104, NULL, NULL, 162450),
(162451, '3.30.1380.10-FF-000005', NULL, 'Sonic hedgehog signaling molecule', 100, NULL, NULL, 162451),
(162452, '3.30.70.330-FF-002324', NULL, NULL, 116, NULL, NULL, 162452),
(162453, '3.30.2010.10-FF-000023', NULL, 'YALI0E12309p', 76, NULL, NULL, 162453),
(162454, '3.30.70.330-FF-000183', NULL, 'R3H domain containing protein', 109, NULL, NULL, 162454),
(162455, '3.40.50.1820-FF-000111', NULL, 'Alpha/beta-Hydrolases superfamily protein', 287, NULL, NULL, 162455),
(162456, '3.30.930.10-FF-000121', NULL, 'Histidine--tRNA ligase', 323, NULL, NULL, 162456),
(162457, '3.30.50.10-FF-000026', NULL, 'DNA gyrase inhibitor YacG', 65, NULL, NULL, 162457),
(162458, '3.80.10.10-FF-001792', NULL, 'Leucine-rich repeat protein 1', 105, NULL, NULL, 162458),
(162459, '3.30.420.40-FF-000491', NULL, 'Chaperone protein HscA', 54, NULL, NULL, 162459),
(162460, '1.10.150.20-FF-000239', NULL, 'DNA transformation protein TfoX2', 82, NULL, NULL, 162460),
(162461, '3.80.10.10-FF-002410', NULL, 'Toll-like receptor 6', 133, NULL, NULL, 162461),
(162462, '1.20.5.170-FF-000134', NULL, 'Transcription factor', 80, NULL, NULL, 162462),
(162463, '3.30.40.10-FF-000531', NULL, 'RING/FYVE/PHD zinc finger superfamily protein', 78, NULL, NULL, 162463),
(162464, '1.10.510.10-FF-002474', NULL, NULL, 176, NULL, NULL, 162464),
(162465, '1.20.1250.20-FF-001789', NULL, 'Sodium-dependent glucose transporter, putative', 179, NULL, NULL, 162465),
(162466, '2.30.29.30-FF-000226', NULL, 'Pleckstrin', 123, NULL, NULL, 162466),
(162467, '2.130.10.10-FF-002909', NULL, 'Uncharacterized protein', 192, NULL, NULL, 162467),
(162468, '3.90.940.10-FF-000007', NULL, 'DNA-directed RNA polymerase subunit, putative', 101, NULL, NULL, 162468),
(162469, '3.40.50.2300-FF-000603', NULL, 'Nitrogen regulation protein NR(I)', 134, NULL, NULL, 162469),
(162470, '3.30.420.140-FF-000003', NULL, 'Putative pre-16S rRNA nuclease', 138, NULL, NULL, 162470),
(162471, '3.30.470.20-FF-000100', NULL, 'Succinate--CoA ligase [GDP-forming] subunit beta, mitochondrial', 142, NULL, NULL, 162471); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(162472, '1.20.58.60-FF-000114', NULL, 'dystonin isoform X1', 213, NULL, NULL, 162472),
(162473, '1.10.1820.10-FF-000023', NULL, 'Probable casein kinase II subunit beta-2', 102, NULL, NULL, 162473),
(162474, '3.40.50.11610-FF-000012', NULL, '2-oxoglutarate dehydrogenase E1 component', 154, NULL, NULL, 162474),
(162475, '3.10.450.50-FF-000073', NULL, 'Zgc:101555', 44, NULL, NULL, 162475),
(162476, '1.20.1070.10-FF-000165', NULL, 'Probable G-protein coupled receptor 19', 332, NULL, NULL, 162476),
(162477, '2.30.30.1190-FF-000008', NULL, 'Zinc finger CCCH domain-containing protein 33', 65, NULL, NULL, 162477),
(162478, '2.160.20.10-FF-000009', NULL, 'Pectate lyase', 343, NULL, NULL, 162478),
(162479, '1.10.510.10-FF-001170', NULL, 'Ribosomal protein S6 kinase alpha-1', 247, NULL, NULL, 162479),
(162480, '2.60.120.260-FF-000605', NULL, 'Arylsulfatase homolog b1498', 143, NULL, NULL, 162480),
(162481, '3.20.20.150-FF-000020', NULL, 'Protein arginine N-methyltransferase', 334, NULL, NULL, 162481),
(162482, '3.90.1150.10-FF-000367', NULL, 'Pleiotropic regulatory protein, conjectural', 149, NULL, NULL, 162482),
(162483, '3.40.50.300-FF-003242', NULL, 'Predicted protein', 309, NULL, NULL, 162483),
(162484, '3.40.50.670-FF-000008', NULL, 'DNA topoisomerase 2', 127, NULL, NULL, 162484),
(162485, '3.30.420.150-FF-000006', NULL, 'Ppx/GppA family phosphatase', 180, NULL, NULL, 162485),
(162486, '3.30.160.60-FF-004725', NULL, NULL, 72, NULL, NULL, 162486),
(162487, '3.30.1520.10-FF-000090', NULL, 'PX domain-containing protein', 100, NULL, NULL, 162487),
(162488, '2.30.130.40-FF-000039', NULL, 'Uncharacterized protein', 108, NULL, NULL, 162488),
(162489, '3.30.160.60-FF-001274', NULL, 'Uncharacterized protein', 28, NULL, NULL, 162489),
(162490, '3.30.2380.10-FF-000005', NULL, 'Kinase binding protein CGI-121, putative', 176, NULL, NULL, 162490),
(162491, '3.90.70.80-FF-000051', NULL, 'Uncharacterized protein', 153, NULL, NULL, 162491),
(162492, '3.80.10.10-FF-003933', NULL, 'Leucine-rich repeats and death domain-containing 1', 92, NULL, NULL, 162492),
(162493, '2.60.40.1120-FF-000083', NULL, 'Uncharacterized protein', 77, NULL, NULL, 162493),
(162494, '1.10.340.30-FF-000055', NULL, 'HhH-GPD family protein', 111, NULL, NULL, 162494),
(162495, '3.30.260.10-FF-000053', NULL, 'Chaperonin-containing TCP1 subunit 3', 36, NULL, NULL, 162495),
(162496, '3.40.50.1000-FF-000197', NULL, '4-nitrophenylphosphatase, putative', 135, NULL, NULL, 162496),
(162497, '3.40.630.10-FF-000490', NULL, 'Peptidase M20 domain-containing protein 2', 54, NULL, NULL, 162497),
(162498, '3.40.190.10-FF-000129', NULL, 'LysR family transcriptional regulator', 85, NULL, NULL, 162498),
(162499, '3.40.50.970-FF-000104', NULL, '1-deoxy-D-xylulose-5-phosphate synthase', 168, NULL, NULL, 162499),
(162500, '1.10.220.30-FF-000001', NULL, 'Flagellar motor switch protein FliG', 140, NULL, NULL, 162500),
(162501, '2.60.40.10-FF-004388', NULL, NULL, 137, NULL, NULL, 162501),
(162502, '3.30.160.60-FF-001167', NULL, 'zinc finger protein 691', 30, NULL, NULL, 162502),
(162503, '3.60.110.10-FF-000024', NULL, 'Deaminated glutathione amidase', 303, NULL, NULL, 162503),
(162504, '2.60.120.200-FF-000161', NULL, 'Laminin subunit alpha 1', 190, NULL, NULL, 162504),
(162505, '1.20.58.1030-FF-000025', NULL, 'Uncharacterized protein', 145, NULL, NULL, 162505),
(162506, '1.10.510.10-FF-004508', NULL, NULL, 27, NULL, NULL, 162506),
(162507, '3.10.110.10-FF-000272', NULL, 'Predicted protein', 139, NULL, NULL, 162507),
(162508, '1.10.510.10-FF-002367', NULL, NULL, 177, NULL, NULL, 162508),
(162509, '3.30.1520.10-FF-000101', NULL, 'Uncharacterized protein', 143, NULL, NULL, 162509),
(162510, '3.30.40.10-FF-001835', NULL, 'Uncharacterized protein', 79, NULL, NULL, 162510),
(162511, '2.10.25.10-FF-001359', NULL, 'laminin subunit beta-1 isoform X7', 48, NULL, NULL, 162511),
(162512, '3.30.910.20-FF-000016', NULL, 'Outer membrane protein 26', 76, NULL, NULL, 162512),
(162513, '3.40.309.10-FF-000035', NULL, 'Aldehyde dehydrogenase, dimeric NADP-preferring', 57, NULL, NULL, 162513);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(162514, '3.30.160.60-FF-002584', NULL, 'Zinc finger protein 445', 39, NULL, NULL, 162514),
(162515, '1.10.238.10-FF-001137', NULL, 'Uncharacterized protein', 149, NULL, NULL, 162515),
(162516, '1.10.8.270-FF-000088', NULL, 'TBC domain containing protein', 116, NULL, NULL, 162516),
(162517, '1.25.40.20-FF-001400', NULL, 'Uncharacterized protein', 250, NULL, NULL, 162517),
(162518, '1.10.460.10-FF-000007', NULL, 'DNA topoisomerase', 164, NULL, NULL, 162518),
(162519, '1.10.472.10-FF-000563', NULL, 'Uncharacterized protein', 64, NULL, NULL, 162519),
(162520, '1.10.510.10-FF-003081', NULL, NULL, 201, NULL, NULL, 162520),
(162521, '3.40.50.1980-FF-000018', NULL, 'Iron(III) dicitrate-binding periplasmic protein', 176, NULL, NULL, 162521),
(162522, '3.40.50.720-FF-000046', NULL, 'UDP-N-acetylmuramate--L-alanine ligase', 98, NULL, NULL, 162522),
(162523, '3.40.50.150-FF-000976', NULL, NULL, 222, NULL, NULL, 162523),
(162524, '3.10.129.10-FF-000185', NULL, 'Mitochondrial hydroxyacyl-thioester dehydratase, putative', 199, NULL, NULL, 162524),
(162525, '3.80.10.10-FF-004321', NULL, 'Uncharacterized protein', 205, NULL, NULL, 162525),
(162526, '3.40.30.10-FF-001126', NULL, 'Predicted protein', 78, NULL, NULL, 162526),
(162527, '3.30.930.10-FF-000014', NULL, 'Glycine--tRNA ligase', 316, NULL, NULL, 162527),
(162528, '3.30.70.330-FF-000290', NULL, 'RNA-binding protein 45 isoform X1', 95, NULL, NULL, 162528),
(162529, '2.130.10.10-FF-004366', NULL, 'Uncharacterized protein', 86, NULL, NULL, 162529),
(162530, '2.160.20.10-FF-000341', NULL, 'Uncharacterized protein', 280, NULL, NULL, 162530),
(162531, '1.20.1280.290-FF-000043', NULL, 'Sugar transporter SWEET', 89, NULL, NULL, 162531),
(162532, '3.40.50.300-FF-004765', NULL, 'neuron navigator 2', 137, NULL, NULL, 162532),
(162533, '3.40.50.1970-FF-000015', NULL, 'Maleylacetate reductase 1', 159, NULL, NULL, 162533),
(162534, '3.50.50.60-FF-000175', NULL, 'Pyridine nucleotide-disulfide oxidoreductase family protein', 231, NULL, NULL, 162534),
(162535, '3.40.190.10-FF-000348', NULL, 'LysR family transcriptional regulator', 93, NULL, NULL, 162535),
(162536, '3.60.40.10-FF-000041', NULL, 'Protein phosphatase 2C 51', 308, NULL, NULL, 162536),
(162537, '1.10.10.10-FF-000097', NULL, 'Protein c-ets-1 isoform 1', 139, NULL, NULL, 162537),
(162538, '1.10.1410.10-FF-000099', NULL, 'Uncharacterized protein', 16, NULL, NULL, 162538),
(162539, '3.40.50.970-FF-000093', NULL, '1-deoxy-D-xylulose-5-phosphate synthase', 168, NULL, NULL, 162539),
(162540, '2.40.128.180-FF-000006', NULL, NULL, 82, NULL, NULL, 162540),
(162541, '2.30.42.10-FF-000425', NULL, NULL, 96, NULL, NULL, 162541),
(162542, '3.40.50.150-FF-001140', NULL, NULL, 250, NULL, NULL, 162542),
(162543, '1.20.1560.10-FF-000028', NULL, 'ABC transporter B family member 20', 342, NULL, NULL, 162543),
(162544, '2.70.98.10-FF-000086', NULL, 'Chondroitin sulfate ABC exolyase', 277, NULL, NULL, 162544),
(162545, '3.80.10.10-FF-000050', NULL, 'FLII, actin remodeling protein', 92, NULL, NULL, 162545),
(162546, '3.40.50.12090-FF-000004', NULL, 'Endolysin CS74L', 78, NULL, NULL, 162546),
(162547, '1.10.510.10-FF-001057', NULL, 'Serine/threonine protein kinase', 165, NULL, NULL, 162547),
(162548, '3.40.50.300-FF-006676', NULL, 'RecQ DNA helicase-like protein C212.06c', 83, NULL, NULL, 162548),
(162549, '1.10.10.60-FF-000645', NULL, 'Os07g0634900 protein', 60, NULL, NULL, 162549),
(162550, '3.30.420.40-FF-000378', NULL, 'Actin-related protein 9', 78, NULL, NULL, 162550),
(162551, '3.30.1370.120-FF-000005', NULL, 'Type III secretion system outer membrane pore InvG', 95, NULL, NULL, 162551),
(162552, '1.20.120.420-FF-000012', NULL, 'Putative methylthioribose-1-phosphate isomerase', 180, NULL, NULL, 162552),
(162553, '3.10.129.10-FF-000202', NULL, 'Thioesterase', 138, NULL, NULL, 162553),
(162554, '3.40.50.2000-FF-000614', NULL, 'Predicted protein', 122, NULL, NULL, 162554),
(162555, '3.50.50.60-FF-000394', NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase, putative', 251, NULL, NULL, 162555),
(162556, '3.10.110.10-FF-000159', NULL, 'Putative ubiquitin-conjugating enzyme E2 24', 270, NULL, NULL, 162556);
INSERT INTO "PUBLIC"."MODEL" VALUES
(162557, '3.40.47.10-FF-000254', NULL, NULL, 366, NULL, NULL, 162557),
(162558, '1.25.10.10-FF-000838', NULL, 'HEAT repeat domain containing protein', 1058, NULL, NULL, 162558),
(162559, '3.80.10.10-FF-001679', NULL, 'Uncharacterized protein', 79, NULL, NULL, 162559),
(162560, '3.30.230.10-FF-000225', NULL, 'DNA mismatch repair protein pms2, putative', 128, NULL, NULL, 162560),
(162561, '1.25.40.20-FF-000782', NULL, 'Uncharacterized protein', 125, NULL, NULL, 162561),
(162562, '2.60.40.150-FF-000709', NULL, 'Uncharacterized protein', 139, NULL, NULL, 162562),
(162563, '2.60.40.4100-FF-000004', NULL, 'Zona pellucida sperm-binding protein 2', 172, NULL, NULL, 162563),
(162564, '1.20.1560.10-FF-000360', NULL, 'Os01g0533900 protein', 309, NULL, NULL, 162564),
(162565, '1.10.472.10-FF-000344', NULL, 'CCNK isoform 5', 71, NULL, NULL, 162565),
(162566, '2.120.10.30-FF-000393', NULL, 'Uncharacterized protein', 269, NULL, NULL, 162566),
(162567, '2.150.10.10-FF-000020', NULL, NULL, 156, NULL, NULL, 162567),
(162568, '3.90.960.10-FF-000008', NULL, 'Proline--tRNA ligase', 152, NULL, NULL, 162568),
(162569, '1.20.58.1480-FF-000025', NULL, 'Protein cereblon', 66, NULL, NULL, 162569),
(162570, '2.40.37.10-FF-000031', NULL, 'Ornithine decarboxylase 1', 132, NULL, NULL, 162570),
(162571, '2.60.40.10-FF-002590', NULL, 'Putative Filamin-A', 101, NULL, NULL, 162571),
(162572, '3.30.160.60-FF-003421', NULL, 'Si:dkey-7i4.10', 28, NULL, NULL, 162572),
(162573, '3.90.190.10-FF-000320', NULL, 'Predicted protein', 78, NULL, NULL, 162573),
(162574, '3.30.565.10-FF-000295', NULL, 'Sensor histidine kinase/response regulator LuxN', 151, NULL, NULL, 162574),
(162575, '1.20.58.60-FF-000226', NULL, 'Uncharacterized protein, isoform C', 214, NULL, NULL, 162575),
(162576, '1.10.510.10-FF-002586', NULL, NULL, 213, NULL, NULL, 162576),
(162577, '3.10.180.10-FF-000096', NULL, 'Uncharacterized protein', 149, NULL, NULL, 162577),
(162578, '3.40.50.720-FF-001682', NULL, 'D-3-phosphoglycerate dehydrogenase', 94, NULL, NULL, 162578),
(162579, '3.40.50.720-FF-002300', NULL, 'Uncharacterized protein', 160, NULL, NULL, 162579),
(162580, '1.20.1250.20-FF-001677', NULL, 'Solute carrier organic anion transporter family member', 223, NULL, NULL, 162580),
(162581, '2.70.130.10-FF-000078', NULL, NULL, 121, NULL, NULL, 162581),
(162582, '3.40.50.10900-FF-000029', NULL, 'Proteasome assembly chaperone 2', 144, NULL, NULL, 162582),
(162583, '1.10.150.20-FF-000127', NULL, 'Unplaced genomic scaffold supercont1.238, whole genome shotgun sequence', 69, NULL, NULL, 162583),
(162584, '1.10.8.10-FF-000112', NULL, 'Phosphoprotein', 49, NULL, NULL, 162584),
(162585, '1.10.565.10-FF-000020', NULL, 'Nuclear receptor subfamily 2 group F member 6', 242, NULL, NULL, 162585),
(162586, '2.60.40.790-FF-000199', NULL, NULL, 66, NULL, NULL, 162586),
(162587, '3.90.550.10-FF-000197', NULL, 'Alpha-1,6-mannosyltransferase subunit, putative', 113, NULL, NULL, 162587),
(162588, '3.40.50.1820-FF-001398', NULL, 'Conditioned medium factor', 212, NULL, NULL, 162588),
(162589, '3.40.50.1370-FF-000037', NULL, 'Aspartate carbamoyltransferase', 148, NULL, NULL, 162589),
(162590, '2.40.10.10-FF-000677', NULL, NULL, 89, NULL, NULL, 162590),
(162591, '3.40.50.2300-FF-000367', NULL, 'Histidine kinase 1', 152, NULL, NULL, 162591),
(162592, '3.60.10.10-FF-000106', NULL, 'Unplaced genomic scaffold supercont1.219, whole genome shotgun sequence', 235, NULL, NULL, 162592),
(162593, '2.60.40.10-FF-000908', NULL, 'Interleukin 31 receptor A', 103, NULL, NULL, 162593),
(162594, '2.60.40.10-FF-000897', NULL, 'Immunoglobulin kappa variable 3-20', 105, NULL, NULL, 162594),
(162595, '2.60.120.290-FF-000131', NULL, 'SOL-1 related protein', 107, NULL, NULL, 162595),
(162596, '1.20.140.80-FF-000007', NULL, 'Transcription factor dpl-1', 164, NULL, NULL, 162596),
(162597, '2.40.10.250-FF-000002', NULL, 'Replicase polyprotein 1a', 112, NULL, NULL, 162597),
(162598, '3.40.50.1440-FF-000087', NULL, 'Uncharacterized protein', 117, NULL, NULL, 162598),
(162599, '2.60.120.650-FF-000054', NULL, 'Histone H3-K36 demethylase', 299, NULL, NULL, 162599);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(162600, '2.130.10.10-FF-004927', NULL, 'Uncharacterized protein', 105, NULL, NULL, 162600),
(162601, '3.40.50.300-FF-003023', NULL, 'Uncharacterized ATP-dependent helicase IRC5', 305, NULL, NULL, 162601),
(162602, '1.10.730.10-FF-000219', NULL, 'Valyl-tRNA synthetase', 131, NULL, NULL, 162602),
(162603, '2.170.270.10-FF-000148', NULL, 'Predicted protein', 44, NULL, NULL, 162603),
(162604, '3.30.1010.10-FF-000130', NULL, 'Predicted protein', 164, NULL, NULL, 162604),
(162605, '3.30.830.10-FF-000193', NULL, 'Uncharacterized protein', 227, NULL, NULL, 162605),
(162606, '2.40.50.90-FF-000080', NULL, 'Staphylococcal_nuclease_homologue /Tudor_domain_containing_protein_-_putative', 151, NULL, NULL, 162606),
(162607, '2.60.40.10-FF-004276', NULL, NULL, 104, NULL, NULL, 162607),
(162608, '3.30.160.60-FF-001055', NULL, 'Zinc finger and BTB domain-containing protein 24', 26, NULL, NULL, 162608),
(162609, '2.60.40.180-FF-000016', NULL, 'Uncharacterized protein', 123, NULL, NULL, 162609),
(162610, '3.60.20.10-FF-000152', NULL, NULL, 131, NULL, NULL, 162610),
(162611, '1.10.110.10-FF-000021', NULL, 'Bifunctional inhibitor/lipid-transfer protein/seed storage 2S albumin superfamily protein', 79, NULL, NULL, 162611),
(162612, '3.50.50.60-FF-001012', NULL, 'Uncharacterized protein', 188, NULL, NULL, 162612),
(162613, '3.40.50.12780-FF-000222', NULL, 'Disco interacting protein 2 homolog A', 282, NULL, NULL, 162613),
(162614, '2.70.150.10-FF-000298', NULL, 'Uncharacterized protein', 105, NULL, NULL, 162614),
(162615, '3.40.50.300-FF-005260', NULL, 'YALI0C18447p', 294, NULL, NULL, 162615),
(162616, '3.40.50.2300-FF-000822', NULL, NULL, 133, NULL, NULL, 162616),
(162617, '3.30.40.10-FF-000750', NULL, 'Chromatin modification-related protein YNG2', 89, NULL, NULL, 162617),
(162618, '3.30.160.60-FF-000892', NULL, 'zinc finger and BTB domain-containing protein 3', 28, NULL, NULL, 162618),
(162619, '3.30.870.10-FF-000189', NULL, 'Uncharacterized protein', 99, NULL, NULL, 162619),
(162620, '1.10.150.190-FF-000007', NULL, 'Translation initiation factor 2 subunit alpha', 90, NULL, NULL, 162620),
(162621, '2.60.40.1170-FF-000069', NULL, NULL, 117, NULL, NULL, 162621),
(162622, '3.40.50.620-FF-000460', NULL, 'Tryptophan--tRNA ligase, cytoplasmic', 192, NULL, NULL, 162622),
(162623, '1.10.3120.10-FF-000021', NULL, NULL, 210, NULL, NULL, 162623),
(162624, '3.10.180.10-FF-000107', NULL, '4-hydroxyphenylpyruvate dioxygenase', 158, NULL, NULL, 162624),
(162625, '1.10.3380.30-FF-000006', NULL, 'DExH-box ATP-dependent RNA helicase DExH10', 226, NULL, NULL, 162625),
(162626, '3.10.330.10-FF-000035', NULL, 'Nsf-1', 65, NULL, NULL, 162626),
(162627, '3.30.160.60-FF-001510', NULL, 'Endolytic murein transglycosylase', 38, NULL, NULL, 162627),
(162628, '2.130.10.10-FF-002786', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit wdr4', 212, NULL, NULL, 162628),
(162629, '3.30.160.60-FF-003640', NULL, 'Related to RNA splicing factor PRP9', 49, NULL, NULL, 162629),
(162630, '3.40.50.2300-FF-000480', NULL, 'Response regulator', 125, NULL, NULL, 162630),
(162631, '3.10.28.10-FF-000037', NULL, 'Probable intron-encoded DNA endonuclease 1', 146, NULL, NULL, 162631),
(162632, '3.40.50.300-FF-003461', NULL, 'Uncharacterized protein', 52, NULL, NULL, 162632),
(162633, '1.20.1250.20-FF-000154', NULL, 'Solute carrier family 22 member 16', 409, NULL, NULL, 162633),
(162634, '1.10.510.10-FF-004385', NULL, NULL, 92, NULL, NULL, 162634),
(162635, '3.40.190.10-FF-000680', NULL, 'Uncharacterized protein', 33, NULL, NULL, 162635),
(162636, '3.30.565.10-FF-000418', NULL, 'Probable heat shock protein (Hsp90 family)', 211, NULL, NULL, 162636),
(162637, '3.30.465.10-FF-000023', NULL, 'Magnesium and cobalt transporter', 83, NULL, NULL, 162637),
(162638, '1.10.3380.20-FF-000003', NULL, 'Helicase and polymerase-containing protein TEBICHI', 144, NULL, NULL, 162638),
(162639, '2.130.10.10-FF-003404', NULL, 'Uncharacterized protein', 200, NULL, NULL, 162639),
(162640, '2.60.40.10-FF-002819', NULL, 'High Incidence of Males (Increased X chromosome loss)', 95, NULL, NULL, 162640);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(162641, '1.10.150.170-FF-000001', NULL, 'Ribosomal RNA small subunit methyltransferase H', 104, NULL, NULL, 162641),
(162642, '2.130.10.10-FF-003062', NULL, 'WD repeat-containing protein 36', 323, NULL, NULL, 162642),
(162643, '2.60.40.150-FF-000586', NULL, 'Uncharacterized protein', 59, NULL, NULL, 162643),
(162644, '2.10.25.10-FF-000055', NULL, 'alpha-tectorin isoform X1', 57, NULL, NULL, 162644),
(162645, '3.40.50.620-FF-000802', NULL, 'Uncharacterized protein', 102, NULL, NULL, 162645),
(162646, '2.30.29.30-FF-000007', NULL, 'Calcium-dependent secretion activator 2 isoform B', 111, NULL, NULL, 162646),
(162647, '3.90.180.10-FF-000151', NULL, 'D-arabinitol dehydrogenase 1', 165, NULL, NULL, 162647),
(162648, '3.30.70.330-FF-002088', NULL, NULL, 74, NULL, NULL, 162648),
(162649, '2.130.10.30-FF-000072', NULL, 'Regulator of chromosome condensation, putative', 344, NULL, NULL, 162649),
(162650, '1.10.150.20-FF-000240', NULL, 'DNA polymerase', 66, NULL, NULL, 162650),
(162651, '2.170.120.12-FF-000027', NULL, 'DNA-directed RNA polymerase, alpha subunit, putative', 156, NULL, NULL, 162651),
(162652, '2.60.40.60-FF-000884', NULL, 'Si:dkey-30k22.7', 115, NULL, NULL, 162652),
(162653, '1.10.8.60-FF-000211', NULL, 'RuvB-like helicase', 89, NULL, NULL, 162653),
(162654, '2.60.40.10-FF-002477', NULL, 'Protein CBR-UNC-22', 98, NULL, NULL, 162654),
(162655, '2.20.80.10-FF-000008', NULL, 'Vitellogenin-like Protein', 222, NULL, NULL, 162655),
(162656, '2.70.170.10-FF-000187', NULL, 'Predicted protein', 215, NULL, NULL, 162656),
(162657, '3.90.550.10-FF-000539', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 406, NULL, NULL, 162657),
(162658, '2.40.50.140-FF-000393', NULL, 'Sugar ABC transporter ATP-binding protein', 43, NULL, NULL, 162658),
(162659, '3.40.50.1000-FF-000758', NULL, NULL, 143, NULL, NULL, 162659),
(162660, '3.40.50.300-FF-001331', NULL, 'Replication factor C subunit 4, putative', 162, NULL, NULL, 162660),
(162661, '3.30.200.20-FF-002188', NULL, 'Uncharacterized protein', 55, NULL, NULL, 162661),
(162662, '3.40.50.300-FF-005602', NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 9', 154, NULL, NULL, 162662),
(162663, '2.130.10.10-FF-000656', NULL, 'Nuclear pore complex protein NUP133', 392, NULL, NULL, 162663),
(162664, '1.20.1070.10-FF-001924', NULL, 'Uncharacterized protein', 281, NULL, NULL, 162664),
(162665, '3.90.870.10-FF-000001', NULL, 'Riboflavin biosynthesis protein RibBA', 205, NULL, NULL, 162665),
(162666, '1.10.150.50-FF-000001', NULL, 'Ephrin type-A receptor 5', 79, NULL, NULL, 162666),
(162667, '3.30.559.10-FF-000241', NULL, 'Carnitine O-palmitoyltransferase 2, mitochondrial', 124, NULL, NULL, 162667),
(162668, '1.25.40.10-FF-004718', NULL, 'Putative pentatricopeptide repeat-containing protein', 89, NULL, NULL, 162668),
(162669, '3.40.1410.10-FF-000040', NULL, 'GntR family transcriptional regulator', 147, NULL, NULL, 162669),
(162670, '1.20.1070.10-FF-001469', NULL, 'Predicted protein', 214, NULL, NULL, 162670),
(162671, '2.60.40.820-FF-000028', NULL, 'T-box transcription factor Ci-mT', 198, NULL, NULL, 162671),
(162672, '2.120.10.80-FF-000048', NULL, 'Kelch-like family, member 42', 282, NULL, NULL, 162672),
(162673, '3.30.2340.10-FF-000008', NULL, 'tRNA pseudouridine synthase D', 132, NULL, NULL, 162673),
(162674, '3.30.450.20-FF-000211', NULL, 'Protein TWIN LOV 1', 116, NULL, NULL, 162674),
(162675, '3.30.1050.10-FF-000014', NULL, 'DeHydrogenases, Short chain', 118, NULL, NULL, 162675),
(162676, '1.10.287.70-FF-000700', NULL, 'Uncharacterized protein', 42, NULL, NULL, 162676),
(162677, '2.20.70.10-FF-000058', NULL, 'Formin binding protein 4', 46, NULL, NULL, 162677),
(162678, '3.40.5.60-FF-000004', NULL, 'DNA replication complex GINS protein SLD5', 61, NULL, NULL, 162678),
(162679, '3.30.200.20-FF-000732', NULL, 'Mitogen-activated protein kinase kinase', 103, NULL, NULL, 162679),
(162680, '1.25.10.10-FF-003025', NULL, 'Uncharacterized protein', 322, NULL, NULL, 162680),
(162681, '3.40.1090.10-FF-000065', NULL, 'Patatin', 339, NULL, NULL, 162681),
(162682, '3.30.160.60-FF-005107', NULL, NULL, 37, NULL, NULL, 162682);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(162683, '3.30.420.40-FF-000939', NULL, 'ARP6 actin related protein 6 homolog', 74, NULL, NULL, 162683),
(162684, '3.30.70.330-FF-000413', NULL, 'Serine/arginine-rich splicing factor 1', 86, NULL, NULL, 162684),
(162685, '2.10.55.10-FF-000006', NULL, 'GP63', 65, NULL, NULL, 162685),
(162686, '3.20.20.190-FF-000003', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 311, NULL, NULL, 162686),
(162687, '2.10.25.10-FF-000510', NULL, 'Signal peptide, CUB and EGF-like domain-containing protein 1', 43, NULL, NULL, 162687),
(162688, '1.20.1090.10-FF-000054', NULL, '3-dehydroquinate synthase', 187, NULL, NULL, 162688),
(162689, '1.25.10.10-FF-000619', NULL, 'Hsp70 nucleotide exchange factor', 248, NULL, NULL, 162689),
(162690, '1.10.274.100-FF-000021', NULL, 'DNA-directed RNA polymerase subunit', 119, NULL, NULL, 162690),
(162691, '1.25.10.10-FF-002749', NULL, 'Uncharacterized protein', 705, NULL, NULL, 162691),
(162692, '3.30.420.40-FF-000597', NULL, 'Os08g0369300 protein', 78, NULL, NULL, 162692),
(162693, '1.10.1050.10-FF-000003', NULL, '30S ribosomal protein S4', 102, NULL, NULL, 162693),
(162694, '1.10.150.60-FF-000004', NULL, 'AT-rich interactive domain-containing protein 5B', 112, NULL, NULL, 162694),
(162695, '3.30.40.10-FF-002217', NULL, 'Uncharacterized protein', 69, NULL, NULL, 162695),
(162696, '3.90.550.50-FF-000074', NULL, 'Hexosyltransferase', 253, NULL, NULL, 162696),
(162697, '3.40.50.2300-FF-000148', NULL, 'Catabolite control protein A', 131, NULL, NULL, 162697),
(162698, '2.40.50.140-FF-000735', NULL, NULL, 130, NULL, NULL, 162698),
(162699, '2.40.70.10-FF-000344', NULL, NULL, 158, NULL, NULL, 162699),
(162700, '3.60.15.10-FF-000078', NULL, 'Ribonuclease Z, putative', 274, NULL, NULL, 162700),
(162701, '3.90.1800.10-FF-000002', NULL, 'DNA-directed RNA polymerase subunit beta', 110, NULL, NULL, 162701),
(162702, '3.40.50.880-FF-000066', NULL, 'CTP synthase', 153, NULL, NULL, 162702),
(162703, '3.30.43.10-FF-000004', NULL, 'Berberine bridge enzyme-like 15', 107, NULL, NULL, 162703),
(162704, '1.20.1070.10-FF-001582', NULL, 'Uncharacterized protein', 158, NULL, NULL, 162704),
(162705, '2.60.40.10-FF-003191', NULL, 'Lin1840 protein', 125, NULL, NULL, 162705),
(162706, '1.25.40.10-FF-000447', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 82, NULL, NULL, 162706),
(162707, '1.10.287.130-FF-000005', NULL, 'Nitrogen regulation histidine kinase', 76, NULL, NULL, 162707),
(162708, '1.10.10.10-FF-000877', NULL, 'Anaphase-promoting complex subunit', 72, NULL, NULL, 162708),
(162709, '1.25.40.10-FF-001161', NULL, 'Pentatricopeptide repeat-containing protein', 129, NULL, NULL, 162709),
(162710, '1.20.1250.20-FF-001790', NULL, 'Monocarboxylate transporter, putative', 179, NULL, NULL, 162710),
(162711, '3.30.413.10-FF-000015', NULL, '4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase (flavodoxin)', 101, NULL, NULL, 162711),
(162712, '3.30.40.10-FF-000418', NULL, 'Peroxisome biogenesis factor 10', 76, NULL, NULL, 162712),
(162713, '1.20.1080.10-FF-000115', NULL, 'Uncharacterized protein', 105, NULL, NULL, 162713),
(162714, '2.40.50.140-FF-001011', NULL, NULL, 73, NULL, NULL, 162714),
(162715, '3.30.40.10-FF-000076', NULL, 'E3 ubiquitin-protein ligase Mdm2', 65, NULL, NULL, 162715),
(162716, '2.40.50.90-FF-000203', NULL, 'Methyltransferase', 133, NULL, NULL, 162716),
(162717, '3.30.70.330-FF-000289', NULL, 'RNA-binding protein 40 isoform X1', 111, NULL, NULL, 162717),
(162718, '3.30.590.10-FF-000038', NULL, 'Arginine kinase, putative', 106, NULL, NULL, 162718),
(162719, '1.10.472.170-FF-000024', NULL, 'Uncharacterized protein', 185, NULL, NULL, 162719),
(162720, '3.40.350.10-FF-000007', NULL, 'Xaa-Pro dipeptidase', 180, NULL, NULL, 162720),
(162721, '1.20.5.420-FF-000024', NULL, 'Putative small glutamine-rich tetratricopeptide repeat-containing protein alpha', 51, NULL, NULL, 162721),
(162722, '2.170.130.10-FF-000082', NULL, NULL, 153, NULL, NULL, 162722),
(162723, '3.90.1410.10-FF-000079', NULL, 'Protein-lysine N-methyltransferase', 286, NULL, NULL, 162723);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(162724, '3.40.50.1820-FF-000217', NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', 321, NULL, NULL, 162724),
(162725, '1.10.600.10-FF-000092', NULL, 'Squalene synthase 1', 71, NULL, NULL, 162725),
(162726, '1.10.10.10-FF-001153', NULL, 'GM24041', 81, NULL, NULL, 162726),
(162727, '3.40.50.1820-FF-001179', NULL, 'Uncharacterized protein', 205, NULL, NULL, 162727),
(162728, '1.25.40.10-FF-000885', NULL, 'Tetratricopeptide repeat protein 37', 131, NULL, NULL, 162728),
(162729, '2.30.30.40-FF-000194', NULL, 'SH3 and PX domains 2A', 74, NULL, NULL, 162729),
(162730, '3.30.160.60-FF-003308', NULL, 'Zinc finger protein 27', 25, NULL, NULL, 162730),
(162731, '3.100.10.10-FF-000018', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 85, NULL, NULL, 162731),
(162732, '1.25.40.10-FF-004157', NULL, 'Uncharacterized protein', 107, NULL, NULL, 162732),
(162733, '1.25.10.10-FF-000277', NULL, 'AP-3 complex subunit beta', 561, NULL, NULL, 162733),
(162734, '3.40.5.50-FF-000001', NULL, 'DNA replication complex GINS protein PSF2', 66, NULL, NULL, 162734),
(162735, '3.30.540.10-FF-000092', NULL, 'Uncharacterized protein', 61, NULL, NULL, 162735),
(162736, '3.30.70.270-FF-000136', NULL, 'Diguanylate cyclase or phosphodiesterase', 172, NULL, NULL, 162736),
(162737, '2.120.10.80-FF-000380', NULL, 'Predicted protein', 141, NULL, NULL, 162737),
(162738, '2.60.40.640-FF-000076', NULL, 'Arrestin domain-containing protein 15', 134, NULL, NULL, 162738),
(162739, '3.30.70.60-FF-000014', NULL, '28S ribosomal protein S6, mitochondrial', 129, NULL, NULL, 162739),
(162740, '3.80.10.10-FF-001915', NULL, 'Lysine (K)-specific demethylase 2B', 76, NULL, NULL, 162740),
(162741, '3.80.10.10-FF-001573', NULL, 'Leucine-rich repeats and immunoglobulin-like domains protein sma-10', 195, NULL, NULL, 162741),
(162742, '3.90.20.20-FF-000013', NULL, 'GrpE protein homolog', 129, NULL, NULL, 162742),
(162743, '3.40.630.10-FF-000377', NULL, 'Uncharacterized protein', 92, NULL, NULL, 162743),
(162744, '1.10.238.10-FF-001031', NULL, 'Uncharacterized protein', 60, NULL, NULL, 162744),
(162745, '1.25.40.20-FF-000888', NULL, 'Zgc:77223 protein', 82, NULL, NULL, 162745),
(162746, '3.30.750.24-FF-000126', NULL, 'Sulfate permease', 123, NULL, NULL, 162746),
(162747, '3.30.40.10-FF-002330', NULL, 'Uncharacterized protein', 97, NULL, NULL, 162747),
(162748, '1.25.40.20-FF-001506', NULL, 'Ankyrin repeat and SOCS box-containing 2b', 30, NULL, NULL, 162748),
(162749, '1.20.58.60-FF-000445', NULL, 'AGAP009554-PA', 217, NULL, NULL, 162749),
(162750, '3.40.20.10-FF-000102', NULL, 'VILL isoform 1', 120, NULL, NULL, 162750),
(162751, '4.10.800.10-FF-000028', NULL, 'Thyroglobulin', 63, NULL, NULL, 162751),
(162752, '3.30.70.330-FF-002762', NULL, NULL, 79, NULL, NULL, 162752),
(162753, '1.10.10.520-FF-000015', NULL, 'Ubiquitin-activating enzyme E1 1', 194, NULL, NULL, 162753),
(162754, '2.160.10.10-FF-000059', NULL, 'Acetyltransferase RfbO, CysE/LacA/LpxA/NodL family', 171, NULL, NULL, 162754),
(162755, '3.40.50.300-FF-006895', NULL, 'Glr3264 protein', 242, NULL, NULL, 162755),
(162756, '3.40.50.12470-FF-000011', NULL, 'Oxoglutarate dehydrogenase (Succinyl-transferring), E1 component, variant 3', 291, NULL, NULL, 162756),
(162757, '3.40.50.300-FF-003129', NULL, 'DEAD box ATP-dependent RNA helicase', 233, NULL, NULL, 162757),
(162758, '2.30.30.100-FF-000020', NULL, 'Small nuclear ribonucleoprotein Sm D2', 93, NULL, NULL, 162758),
(162759, '2.60.34.10-FF-000057', NULL, 'Hypoxia up-regulated protein, putative', 151, NULL, NULL, 162759),
(162760, '3.40.47.10-FF-000035', NULL, '3-ketoacyl-CoA thiolase A, peroxisomal', 392, NULL, NULL, 162760),
(162761, '3.30.710.10-FF-000470', NULL, 'Uncharacterized protein', 106, NULL, NULL, 162761),
(162762, '2.60.40.2070-FF-000007', NULL, 'Usher CupA3', 92, NULL, NULL, 162762),
(162763, '1.25.40.20-FF-001164', NULL, 'Serine/threonine protein kinase', 124, NULL, NULL, 162763),
(162764, '1.25.40.10-FF-002920', NULL, 'Anaphase-promoting complex subunit 5', 174, NULL, NULL, 162764); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(162765, '1.10.287.1060-FF-000021', NULL, 'Uncharacterized protein', 64, NULL, NULL, 162765),
(162766, '3.30.428.10-FF-000050', NULL, 'CWF19-like protein mug161', 169, NULL, NULL, 162766),
(162767, '3.30.70.330-FF-002543', NULL, NULL, 43, NULL, NULL, 162767),
(162768, '3.30.200.20-FF-000619', NULL, 'macrophage colony-stimulating factor 1 receptor isoform X2', 49, NULL, NULL, 162768),
(162769, '3.20.130.10-FF-000001', NULL, 'Fumarate hydratase class I', 191, NULL, NULL, 162769),
(162770, '3.40.366.10-FF-000010', NULL, 'Polyketide synthase', 343, NULL, NULL, 162770),
(162771, '2.60.110.10-FF-000005', NULL, 'Osmotin-like protein OSM34', 123, NULL, NULL, 162771),
(162772, '3.40.50.300-FF-007171', NULL, 'Small GTP-binding protein, putative', 173, NULL, NULL, 162772),
(162773, '2.60.120.200-FF-000048', NULL, 'Calnexin homolog', 212, NULL, NULL, 162773),
(162774, '3.60.21.10-FF-000368', NULL, 'Serine/threonine-protein phosphatase', 124, NULL, NULL, 162774),
(162775, '3.90.226.10-FF-000163', NULL, 'Propionyl-CoA carboxylase subunit beta', 254, NULL, NULL, 162775),
(162776, '3.30.1010.10-FF-000017', NULL, 'Inositol kinase kinase (UvsB)', 115, NULL, NULL, 162776),
(162777, '3.40.50.300-FF-004546', NULL, 'Dynein, axonemal, heavy chain 2', 132, NULL, NULL, 162777),
(162778, '1.10.3210.30-FF-000005', NULL, 'ATP-dependent RNA helicase', 175, NULL, NULL, 162778),
(162779, '1.10.510.10-FF-000675', NULL, 'cyclin-dependent kinase 1 isoform X2', 130, NULL, NULL, 162779),
(162780, '2.30.30.30-FF-000078', NULL, 'Transcription termination/antitermination protein NusG', 58, NULL, NULL, 162780),
(162781, '3.30.70.660-FF-000040', NULL, 'tRNA pseudouridine synthase, putative', 92, NULL, NULL, 162781),
(162782, '4.10.60.10-FF-000076', NULL, 'Zinc knuckle domain protein (Byr3), putative (AFU_orthologue AFUA_1G07630)', 28, NULL, NULL, 162782),
(162783, '1.20.140.150-FF-000019', NULL, 'Peripheral myelin protein 22', 160, NULL, NULL, 162783),
(162784, '1.50.10.130-FF-000024', NULL, NULL, 157, NULL, NULL, 162784),
(162785, '3.30.200.20-FF-000390', NULL, 'probable LRR receptor-like serine/threonine-protein kinase RKF3', 119, NULL, NULL, 162785),
(162786, '2.30.30.140-FF-000003', NULL, 'Protein kinase C-binding protein 1 isoform C', 88, NULL, NULL, 162786),
(162787, '3.40.50.12780-FF-000109', NULL, 'Probable non-ribosomal peptide synthetase', 396, NULL, NULL, 162787),
(162788, '1.25.40.10-FF-004376', NULL, 'Uncharacterized protein', 255, NULL, NULL, 162788),
(162789, '1.10.400.10-FF-000009', NULL, 'Guanine nucleotide-binding protein G(O) subunit alpha', 119, NULL, NULL, 162789),
(162790, '3.90.1170.50-FF-000021', NULL, 'Uncharacterized protein', 58, NULL, NULL, 162790),
(162791, '3.30.710.10-FF-000138', NULL, 'Fruitless, isoform N', 138, NULL, NULL, 162791),
(162792, '2.40.50.100-FF-000078', NULL, 'Exosome complex component CSL4', 52, NULL, NULL, 162792),
(162793, '1.20.930.40-FF-000039', NULL, 'Uncharacterized protein', 152, NULL, NULL, 162793),
(162794, '1.20.1060.10-FF-000007', NULL, 'DNA-directed DNA polymerase', 182, NULL, NULL, 162794),
(162795, '3.40.50.2300-FF-000261', NULL, 'glutamate receptor 4 isoform X7', 104, NULL, NULL, 162795),
(162796, '2.30.30.830-FF-000002', NULL, 'Fimbrial assembly protein PilP', 93, NULL, NULL, 162796),
(162797, '2.60.120.200-FF-000380', NULL, 'Uncharacterized protein', 182, NULL, NULL, 162797),
(162798, '2.30.29.30-FF-000120', NULL, 'rho GTPase-activating protein 22 isoform X1', 111, NULL, NULL, 162798),
(162799, '3.50.50.60-FF-000630', NULL, 'FAD-dependent pyridine nucleotide-disulphide oxidoreductase', 108, NULL, NULL, 162799),
(162800, '2.60.40.2030-FF-000024', NULL, 'sodium/calcium exchanger 1-like', 159, NULL, NULL, 162800),
(162801, '3.40.190.10-FF-000461', NULL, 'GM24642', 166, NULL, NULL, 162801),
(162802, '1.20.120.230-FF-000056', NULL, 'Uncharacterized protein', 106, NULL, NULL, 162802),
(162803, '3.10.20.90-FF-000684', NULL, 'Ubiquitin-60S ribosomal protein L40', 88, NULL, NULL, 162803),
(162804, '2.40.50.770-FF-000020', NULL, 'Uncharacterized protein', 94, NULL, NULL, 162804);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(162805, '3.40.630.10-FF-000158', NULL, 'Peptide hydrolase', 276, NULL, NULL, 162805),
(162806, '1.20.58.1080-FF-000012', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 102, NULL, NULL, 162806),
(162807, '1.10.287.130-FF-000224', NULL, 'Histidine kinase', 100, NULL, NULL, 162807),
(162808, '1.25.10.10-FF-000951', NULL, 'Anaphase-promoting complex subunit, putative', 206, NULL, NULL, 162808),
(162809, '3.30.160.60-FF-004944', NULL, NULL, 33, NULL, NULL, 162809),
(162810, '3.40.50.620-FF-000128', NULL, 'Isoleucyl-tRNA synthetase 2, mitochondrial', 124, NULL, NULL, 162810),
(162811, '3.40.50.1820-FF-000094', NULL, 'Homoserine O-acetyltransferase', 381, NULL, NULL, 162811),
(162812, '1.10.238.10-FF-000755', NULL, 'Uncharacterized protein', 78, NULL, NULL, 162812),
(162813, '3.40.250.10-FF-000050', NULL, 'Dual specificity phosphatase, putative', 143, NULL, NULL, 162813),
(162814, '3.30.559.10-FF-000128', NULL, 'Ferricrocin synthetase (Nonribosomal peptide siderophore synthase ) (Eurofung)', 182, NULL, NULL, 162814),
(162815, '1.10.287.70-FF-000026', NULL, 'Voltage-dependent R-type calcium channel subunit alpha', 117, NULL, NULL, 162815),
(162816, '3.40.50.720-FF-000720', NULL, 'Carbonyl reductase, isoform A', 293, NULL, NULL, 162816),
(162817, '1.25.40.10-FF-000666', NULL, 'DNA repair and transcription protein (Xab2)', 142, NULL, NULL, 162817),
(162818, '3.30.200.20-FF-000058', NULL, 'Putative serine/threonine-protein kinase N2', 116, NULL, NULL, 162818),
(162819, '3.40.50.1820-FF-001853', NULL, 'Uncharacterized protein', 59, NULL, NULL, 162819),
(162820, '3.30.70.2760-FF-000002', NULL, 'SAM and HD domain-containing deoxynucleoside triphosphate triphosphohydrolase 1', 132, NULL, NULL, 162820),
(162821, '3.90.79.10-FF-000281', NULL, 'Uncharacterized protein', 68, NULL, NULL, 162821),
(162822, '3.30.160.20-FF-000110', NULL, '30S ribosomal protein S5', 71, NULL, NULL, 162822),
(162823, '1.20.1540.10-FF-000033', NULL, 'Rhomboid family membrane protein', 215, NULL, NULL, 162823),
(162824, '1.25.40.20-FF-000669', NULL, 'SPRY domain/Ankyrin repeats (3 copies), putative', 207, NULL, NULL, 162824),
(162825, '3.40.190.10-FF-000803', NULL, 'Excitatory amino acid transporter, putative', 113, NULL, NULL, 162825),
(162826, '1.20.58.1780-FF-000014', NULL, 'Nucleoporin NUP170, putative', 319, NULL, NULL, 162826),
(162827, '3.30.160.60-FF-005220', NULL, NULL, 19, NULL, NULL, 162827),
(162828, '2.40.30.170-FF-000061', NULL, NULL, 86, NULL, NULL, 162828),
(162829, '2.60.40.10-FF-003314', NULL, 'Contactin rig-6', 106, NULL, NULL, 162829),
(162830, '3.80.10.10-FF-000156', NULL, 'volume-regulated anion channel subunit LRRC8C isoform X2', 241, NULL, NULL, 162830),
(162831, '3.30.200.20-FF-000951', NULL, 'Uncharacterized protein', 101, NULL, NULL, 162831),
(162832, '3.90.70.10-FF-000755', NULL, 'Uncharacterized protein', 101, NULL, NULL, 162832),
(162833, '3.30.710.10-FF-000239', NULL, 'Potassium voltage-gated channel, shaker-related subfamily, member 7', 100, NULL, NULL, 162833),
(162834, '1.10.600.10-FF-000120', NULL, 'Uncharacterized protein', 149, NULL, NULL, 162834),
(162835, '1.10.1070.11-FF-000141', NULL, 'Uncharacterized protein', 77, NULL, NULL, 162835),
(162836, '1.20.120.1810-FF-000003', NULL, 'RNA polymerase sigma factor', 102, NULL, NULL, 162836),
(162837, '2.60.40.60-FF-001036', NULL, 'Uncharacterized protein', 100, NULL, NULL, 162837),
(162838, '3.40.1050.10-FF-000034', NULL, 'Carbonic anhydrase', 245, NULL, NULL, 162838),
(162839, '3.40.50.80-FF-000035', NULL, 'FRE4p Ferric reductase', 182, NULL, NULL, 162839),
(162840, '1.10.560.10-FF-000032', NULL, 'HSPD1 isoform 4', 131, NULL, NULL, 162840),
(162841, '1.10.10.60-FF-000139', NULL, 'cyclin-D-binding Myb-like transcription factor 1 isoform X2', 67, NULL, NULL, 162841),
(162842, '3.40.50.150-FF-001578', NULL, NULL, 53, NULL, NULL, 162842),
(162843, '3.30.1640.10-FF-000071', NULL, 'DNA helicase', 117, NULL, NULL, 162843),
(162844, '1.10.8.60-FF-000571', NULL, 'Os05g0376200 protein', 68, NULL, NULL, 162844),
(162845, '3.30.40.10-FF-000290', NULL, 'probable E3 ubiquitin-protein ligase TRIM8', 82, NULL, NULL, 162845);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(162846, '1.25.40.10-FF-000857', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 142, NULL, NULL, 162846),
(162847, '2.40.10.230-FF-000013', NULL, 'Uncharacterized protein', 80, NULL, NULL, 162847),
(162848, '3.40.190.290-FF-000003', NULL, 'HTH-type transcriptional activator AaeR', 207, NULL, NULL, 162848),
(162849, '2.10.25.10-FF-001820', NULL, 'Uncharacterized protein', 40, NULL, NULL, 162849),
(162850, '3.40.1000.50-FF-000015', NULL, 'Repressor of RNA polymerase III transcription MAF1', 132, NULL, NULL, 162850),
(162851, '4.10.280.110-FF-000004', NULL, 'U4/U6 small nuclear ribonucleoprotein PRP4-like protein', 72, NULL, NULL, 162851),
(162852, '3.90.1170.40-FF-000001', NULL, 'Molybdopterin synthase catalytic subunit MoaE', 150, NULL, NULL, 162852),
(162853, '1.20.810.10-FF-000021', NULL, 'Cytochrome b/b6 complex, cytochrome b subunit', 205, NULL, NULL, 162853),
(162854, '2.102.10.10-FF-000068', NULL, 'Gll0366 protein', 105, NULL, NULL, 162854),
(162855, '3.40.50.300-FF-002601', NULL, 'Ras-related protein R-Ras2, putative', 71, NULL, NULL, 162855),
(162856, '3.80.10.10-FF-001218', NULL, 'Leucine rich repeat containing 15', 261, NULL, NULL, 162856),
(162857, '3.40.20.10-FF-000086', NULL, 'Actin-binding protein, cofilin/tropomyosin family protein', 142, NULL, NULL, 162857),
(162858, '3.30.160.60-FF-004276', NULL, NULL, 30, NULL, NULL, 162858),
(162859, '1.50.10.10-FF-000145', NULL, 'Neutral/alkaline invertase 5', 165, NULL, NULL, 162859),
(162860, '1.10.246.130-FF-000025', NULL, NULL, 124, NULL, NULL, 162860),
(162861, '1.10.510.10-FF-002119', NULL, 'Predicted protein', 277, NULL, NULL, 162861),
(162862, '2.30.29.30-FF-000945', NULL, 'Sca1 complex protein phr', 119, NULL, NULL, 162862),
(162863, '3.60.20.30-FF-000023', NULL, NULL, 99, NULL, NULL, 162863),
(162864, '3.40.1410.10-FF-000017', NULL, 'GntR family transcriptional regulator', 157, NULL, NULL, 162864),
(162865, '1.10.150.50-FF-000063', NULL, 'ETS-related transcription factor Elf-3 isoform X1', 71, NULL, NULL, 162865),
(162866, '2.40.30.10-FF-000510', NULL, 'Uncharacterized protein', 78, NULL, NULL, 162866),
(162867, '3.20.20.60-FF-000011', NULL, 'Pyruvate kinase', 234, NULL, NULL, 162867),
(162868, '1.10.640.10-FF-000066', NULL, 'Uncharacterized protein', 183, NULL, NULL, 162868),
(162869, '3.40.50.1000-FF-000157', NULL, 'HAD phosphatase, family IIIA', 144, NULL, NULL, 162869),
(162870, '3.20.20.210-FF-000015', NULL, 'Uroporphyrinogen decarboxylase', 340, NULL, NULL, 162870),
(162871, '3.20.20.80-FF-000017', NULL, 'Beta-galactosidase', 280, NULL, NULL, 162871),
(162872, '3.30.590.50-FF-000022', NULL, 'Glutamate-cysteine ligase catalytic subunit', 172, NULL, NULL, 162872),
(162873, '1.20.1280.20-FF-000021', NULL, 'Chaperone protein dnaJ', 89, NULL, NULL, 162873),
(162874, '3.10.20.90-FF-000807', NULL, 'Uncharacterized protein', 81, NULL, NULL, 162874),
(162875, '3.90.550.10-FF-000073', NULL, 'UTP--glucose-1-phosphate uridylyltransferase', 359, NULL, NULL, 162875),
(162876, '3.40.50.300-FF-008380', NULL, 'Zinc finger, NFX1-type-containing 1', 231, NULL, NULL, 162876),
(162877, '4.10.70.10-FF-000003', NULL, 'Disintegrin and metalloproteinase domain-containing protein 17', 85, NULL, NULL, 162877),
(162878, '3.40.50.620-FF-000342', NULL, 'Valine--tRNA ligase', 229, NULL, NULL, 162878),
(162879, '3.90.226.10-FF-000067', NULL, 'ATP-dependent Clp protease proteolytic subunit', 194, NULL, NULL, 162879),
(162880, '3.60.10.10-FF-000039', NULL, '72 kDa inositol polyphosphate 5-phosphatase', 356, NULL, NULL, 162880),
(162881, '3.30.200.20-FF-002222', NULL, 'Uncharacterized protein', 40, NULL, NULL, 162881),
(162882, '1.10.20.10-FF-000322', NULL, NULL, 126, NULL, NULL, 162882),
(162883, '2.60.120.920-FF-000051', NULL, 'Fibronectin type III and SPRY domain containing 2', 176, NULL, NULL, 162883),
(162884, '3.40.50.10230-FF-000002', NULL, 'Predicted protein', 133, NULL, NULL, 162884),
(162885, '1.10.10.60-FF-001128', NULL, NULL, 101, NULL, NULL, 162885),
(162886, '3.10.100.10-FF-000254', NULL, NULL, 123, NULL, NULL, 162886),
(162887, '2.130.10.10-FF-005001', NULL, 'Angio-associated migratory protein', 62, NULL, NULL, 162887);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(162888, '3.30.160.60-FF-005265', NULL, NULL, 26, NULL, NULL, 162888),
(162889, '2.60.40.10-FF-004360', NULL, NULL, 98, NULL, NULL, 162889),
(162890, '3.30.1440.10-FF-000004', NULL, '60S ribosomal protein L11, putative', 175, NULL, NULL, 162890),
(162891, '1.10.472.80-FF-000016', NULL, 'TBC1 domain family, member 9', 138, NULL, NULL, 162891),
(162892, '2.60.120.620-FF-000112', NULL, 'Predicted protein', 170, NULL, NULL, 162892),
(162893, '3.90.1290.10-FF-000052', NULL, 'Uncharacterized protein', 126, NULL, NULL, 162893),
(162894, '1.25.40.660-FF-000013', NULL, 'Vacuolar protein sorting 35', 279, NULL, NULL, 162894),
(162895, '3.40.1190.10-FF-000044', NULL, NULL, 170, NULL, NULL, 162895),
(162896, '3.40.50.300-FF-007805', NULL, 'Translational initiation factor IF2, putative', 37, NULL, NULL, 162896),
(162897, '1.20.5.170-FF-000230', NULL, 'Putative basic region leucine zipper transcription factor', 75, NULL, NULL, 162897),
(162898, '3.30.70.330-FF-000997', NULL, 'U4/U6 snRNP-associated protein', 82, NULL, NULL, 162898),
(162899, '1.10.220.10-FF-000074', NULL, 'Annexin', 45, NULL, NULL, 162899),
(162900, '3.30.70.100-FF-000102', NULL, 'Cadmium, zinc and cobalt-transporting ATPase', 59, NULL, NULL, 162900),
(162901, '3.40.50.300-FF-005827', NULL, 'Predicted protein', 182, NULL, NULL, 162901),
(162902, '3.50.50.60-FF-000208', NULL, '3-ketosteroid dehydrogenase', 374, NULL, NULL, 162902),
(162903, '2.160.20.10-FF-000144', NULL, 'Probable polygalacturonase At2g43860', 379, NULL, NULL, 162903),
(162904, '2.40.50.140-FF-000067', NULL, '26S protease regulatory subunit 4', 102, NULL, NULL, 162904),
(162905, '3.40.30.10-FF-000704', NULL, 'Predicted gene 6665', 71, NULL, NULL, 162905),
(162906, '3.30.160.60-FF-003820', NULL, NULL, 28, NULL, NULL, 162906),
(162907, '3.90.70.10-FF-000536', NULL, 'Uncharacterized protein', 309, NULL, NULL, 162907),
(162908, '3.40.50.720-FF-001535', NULL, 'AGAP002484-PA', 270, NULL, NULL, 162908),
(162909, '1.10.10.10-FF-000557', NULL, 'Rrf2 family transcriptional regulator', 138, NULL, NULL, 162909),
(162910, '1.10.10.540-FF-000004', NULL, 'UV excision repair protein Rad23', 55, NULL, NULL, 162910),
(162911, '1.20.1070.10-FF-000890', NULL, 'Vomeronasal type-1 receptor', 173, NULL, NULL, 162911),
(162912, '2.60.40.10-FF-000465', NULL, 'Granulocyte colony-stimulating factor receptor', 105, NULL, NULL, 162912),
(162913, '1.10.420.10-FF-000022', NULL, 'Predicted protein', 106, NULL, NULL, 162913),
(162914, '3.30.1520.10-FF-000005', NULL, 'SH3 and PX domain-containing protein 2B', 134, NULL, NULL, 162914),
(162915, '1.10.555.10-FF-000082', NULL, 'Rho GTPase activating protein, putative', 191, NULL, NULL, 162915),
(162916, '3.30.1240.10-FF-000023', NULL, 'Haloacid dehalogenase-like hydrolase', 132, NULL, NULL, 162916),
(162917, '3.30.70.330-FF-002942', NULL, NULL, 111, NULL, NULL, 162917),
(162918, '3.30.1600.10-FF-000006', NULL, 'SIR2 family histone deacetylase', 127, NULL, NULL, 162918),
(162919, '3.80.10.10-FF-000229', NULL, 'F-box only protein 41', 256, NULL, NULL, 162919),
(162920, '3.10.580.10-FF-000222', NULL, 'Chloride channel protein', 105, NULL, NULL, 162920),
(162921, '3.20.20.80-FF-000489', NULL, 'Glycoside hydrolase', 345, NULL, NULL, 162921),
(162922, '3.30.70.330-FF-001514', NULL, 'Uncharacterized protein', 121, NULL, NULL, 162922),
(162923, '2.130.10.10-FF-001139', NULL, 'DIP2p Nucleolar protein', 305, NULL, NULL, 162923),
(162924, '3.30.200.20-FF-000277', NULL, 'serine/threonine-protein kinase greatwall isoform X1', 86, NULL, NULL, 162924),
(162925, '1.20.1740.10-FF-000211', NULL, 'Uncharacterized protein', 133, NULL, NULL, 162925),
(162926, '2.130.10.10-FF-002567', NULL, 'Elongator complex protein 2', 130, NULL, NULL, 162926),
(162927, '1.25.40.180-FF-000111', NULL, 'Sugar 1-phosphate guanyl transferase, putative', 163, NULL, NULL, 162927),
(162928, '3.90.1410.10-FF-000141', NULL, 'Uncharacterized protein', 151, NULL, NULL, 162928),
(162929, '3.30.160.60-FF-000914', NULL, 'Zinc finger protein 16', 30, NULL, NULL, 162929),
(162930, '3.40.50.2300-FF-000620', NULL, 'Hybrid sensor histidine kinase/response regulator', 132, NULL, NULL, 162930);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(162931, '2.130.10.10-FF-004012', NULL, 'WD repeat-containing protein 76', 224, NULL, NULL, 162931),
(162932, '3.30.60.20-FF-000030', NULL, 'Chimaerin', 59, NULL, NULL, 162932),
(162933, '1.50.10.130-FF-000030', NULL, NULL, 35, NULL, NULL, 162933),
(162934, '3.80.10.10-FF-000881', NULL, 'Toll-like receptor 21', 211, NULL, NULL, 162934),
(162935, '2.20.25.530-FF-000011', NULL, 'Uncharacterized protein, isoform A', 77, NULL, NULL, 162935),
(162936, '3.30.160.690-FF-000001', NULL, 'CP4-57 prophage RNase LS', 90, NULL, NULL, 162936),
(162937, '1.10.3380.30-FF-000040', NULL, 'DEAD-box family ATP dependent helicase', 229, NULL, NULL, 162937),
(162938, '2.30.29.30-FF-001081', NULL, 'Uncharacterized protein', 64, NULL, NULL, 162938),
(162939, '2.30.30.100-FF-000059', NULL, 'Small nuclear ribonucleoprotein E', 92, NULL, NULL, 162939),
(162940, '1.50.10.20-FF-000002', NULL, 'Terpene cyclase/mutase family member', 287, NULL, NULL, 162940),
(162941, '1.10.287.470-FF-000096', NULL, 'Sll0180 protein', 68, NULL, NULL, 162941),
(162942, '3.40.1380.20-FF-000056', NULL, 'Pyruvate kinase', 134, NULL, NULL, 162942),
(162943, '3.40.50.300-FF-002281', NULL, 'DNA repair helicase rad3/xp-D, putative', 204, NULL, NULL, 162943),
(162944, '3.40.50.1400-FF-000041', NULL, 'Uncharacterized protein', 65, NULL, NULL, 162944),
(162945, '2.60.120.260-FF-000100', NULL, 'von Willebrand factor D and EGF domain-containing protein', 67, NULL, NULL, 162945),
(162946, '3.40.50.300-FF-001645', NULL, 'ABC transporter I family member 11 chloroplastic', 237, NULL, NULL, 162946),
(162947, '1.10.238.10-FF-000221', NULL, 'Protein S100-A14 isoform X1', 104, NULL, NULL, 162947),
(162948, '2.10.110.10-FF-000146', NULL, 'ALP/Enigma encoding', 59, NULL, NULL, 162948),
(162949, '3.20.20.70-FF-000340', NULL, 'IMP dehydrogenase', 499, NULL, NULL, 162949),
(162950, '3.20.20.140-FF-000146', NULL, 'AMP deaminase, putative', 414, NULL, NULL, 162950),
(162951, '2.40.128.20-FF-000054', NULL, 'Uncharacterized protein', 184, NULL, NULL, 162951),
(162952, '3.30.40.10-FF-002088', NULL, 'Uncharacterized protein', 44, NULL, NULL, 162952),
(162953, '2.60.40.1080-FF-000014', NULL, 'Nucleoporin 210 like', 93, NULL, NULL, 162953),
(162954, '3.40.50.10190-FF-000029', NULL, 'DNA topoisomerase II binding protein 1', 95, NULL, NULL, 162954),
(162955, '2.60.40.10-FF-000818', NULL, 'Interleukin 5 receptor subunit alpha', 105, NULL, NULL, 162955),
(162956, '4.10.400.10-FF-000200', NULL, 'Uncharacterized protein, isoform AB', 42, NULL, NULL, 162956),
(162957, '3.30.860.10-FF-000014', NULL, 'Uncharacterized protein', 92, NULL, NULL, 162957),
(162958, '2.40.50.90-FF-000170', NULL, 'Uncharacterized protein', 131, NULL, NULL, 162958),
(162959, '3.40.50.2000-FF-001137', NULL, 'Uncharacterized protein', 40, NULL, NULL, 162959),
(162960, '3.40.50.300-FF-001292', NULL, 'NLR family CARD domain-containing protein 4', 208, NULL, NULL, 162960),
(162961, '3.40.50.2300-FF-001076', NULL, 'Uncharacterized protein', 277, NULL, NULL, 162961),
(162962, '1.25.20.10-FF-000002', NULL, 'Soluble lytic murein transglycosylase', 361, NULL, NULL, 162962),
(162963, '2.60.120.260-FF-000572', NULL, 'Cry21a', 206, NULL, NULL, 162963),
(162964, '3.40.50.1010-FF-000014', NULL, 'telomerase-binding protein EST1A isoform X1', 181, NULL, NULL, 162964),
(162965, '3.40.50.12470-FF-000005', NULL, 'probable 2-oxoglutarate dehydrogenase E1 component DHKTD1, mitochondrial', 224, NULL, NULL, 162965),
(162966, '1.20.1070.10-FF-001727', NULL, 'Uncharacterized protein', 96, NULL, NULL, 162966),
(162967, '1.20.1510.10-FF-000082', NULL, NULL, 157, NULL, NULL, 162967),
(162968, '3.30.420.110-FF-000028', NULL, 'DNA mismatch repair protein MutS', 133, NULL, NULL, 162968),
(162969, '3.30.160.60-FF-000094', NULL, 'Zinc finger protein 605', 28, NULL, NULL, 162969),
(162970, '3.10.20.30-FF-000104', NULL, NULL, 66, NULL, NULL, 162970),
(162971, '1.10.510.10-FF-000321', NULL, 'Bent, isoform C', 252, NULL, NULL, 162971),
(162972, '1.10.510.10-FF-003547', NULL, NULL, 233, NULL, NULL, 162972),
(162973, '3.40.50.2000-FF-000148', NULL, 'Phosphatidylinositol N-acetylglucosaminyltransferase subunit A', 165, NULL, NULL, 162973);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(162974, '3.10.20.90-FF-000487', NULL, 'Tubulin-specific chaperone E', 88, NULL, NULL, 162974),
(162975, '1.20.5.4130-FF-000011', NULL, 'Uncharacterized protein', 81, NULL, NULL, 162975),
(162976, '3.40.140.10-FF-000132', NULL, 'PSMD14 isoform 3', 57, NULL, NULL, 162976),
(162977, '1.10.510.10-FF-004036', NULL, NULL, 98, NULL, NULL, 162977),
(162978, '1.20.58.390-FF-000065', NULL, 'GABA-gated ion channel', 137, NULL, NULL, 162978),
(162979, '1.25.40.10-FF-001846', NULL, 'Regulatory protein', 116, NULL, NULL, 162979),
(162980, '1.25.10.10-FF-001665', NULL, 'Uncharacterized protein', 328, NULL, NULL, 162980),
(162981, '1.25.40.20-FF-001703', NULL, 'Protein kinase', 57, NULL, NULL, 162981),
(162982, '3.40.50.1820-FF-001651', NULL, 'Uncharacterized protein', 238, NULL, NULL, 162982),
(162983, '1.25.10.10-FF-002154', NULL, 'Uncharacterized protein', 522, NULL, NULL, 162983),
(162984, '2.30.29.30-FF-000092', NULL, 'Connector enhancer of kinase suppressor of Ras 2', 126, NULL, NULL, 162984),
(162985, '1.10.630.10-FF-000740', NULL, 'Uncharacterized protein', 85, NULL, NULL, 162985),
(162986, '1.20.1250.20-FF-000665', NULL, 'Solute carrier family 22 member 18', 234, NULL, NULL, 162986),
(162987, '2.30.30.870-FF-000003', NULL, 'Protein pelota homolog', 130, NULL, NULL, 162987),
(162988, '2.40.30.10-FF-000190', NULL, 'Putative translation initiation factor IF-2', 92, NULL, NULL, 162988),
(162989, '3.30.450.40-FF-000155', NULL, 'Bacteriophytochrome protein', 202, NULL, NULL, 162989),
(162990, '3.90.190.10-FF-000410', NULL, 'Uncharacterized protein', 232, NULL, NULL, 162990),
(162991, '1.10.510.10-FF-001310', NULL, 'Putative serine/threonine-protein kinase', 229, NULL, NULL, 162991),
(162992, '4.10.320.10-FF-000019', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 48, NULL, NULL, 162992),
(162993, '2.130.10.10-FF-005473', NULL, 'WD-40 repeat-containing protein', 156, NULL, NULL, 162993),
(162994, '3.40.50.140-FF-000001', NULL, 'DNA topoisomerase 1', 163, NULL, NULL, 162994),
(162995, '1.20.120.1240-FF-000079', NULL, 'Myxovirus (influenza virus) resistance G', 186, NULL, NULL, 162995),
(162996, '2.40.270.10-FF-000004', NULL, 'DNA-directed RNA polymerase subunit beta', 234, NULL, NULL, 162996),
(162997, '2.10.25.10-FF-000864', NULL, 'Y-linked cadherin EGF LAG seven-pass G-type receptor 2', 42, NULL, NULL, 162997),
(162998, '3.30.160.60-FF-001403', NULL, 'Zinc finger with KRAB and SCAN domains 8', 29, NULL, NULL, 162998),
(162999, '3.40.50.2000-FF-000648', NULL, 'UDP-glycosyltransferase 88A1', 21, NULL, NULL, 162999),
(163000, '3.30.40.10-FF-001599', NULL, 'Uncharacterized protein', 67, NULL, NULL, 163000),
(163001, '2.20.70.10-FF-000266', NULL, 'Uncharacterized protein', 39, NULL, NULL, 163001),
(163002, '3.40.720.10-FF-000159', NULL, 'Arylsulfatase', 371, NULL, NULL, 163002),
(163003, '1.10.472.10-FF-000248', NULL, 'Plant-specific TFIIB-related protein PTF2', 84, NULL, NULL, 163003),
(163004, '3.40.228.10-FF-000015', NULL, 'Thiosulfate reductase', 236, NULL, NULL, 163004),
(163005, '3.30.450.50-FF-000012', NULL, 'vesicle-trafficking protein SEC22c isoform X1', 126, NULL, NULL, 163005),
(163006, '1.10.10.10-FF-001485', NULL, 'Selenocysteine-specific translation elongation factor SelB', 61, NULL, NULL, 163006),
(163007, '1.20.58.60-FF-000092', NULL, 'microtubule-actin cross-linking factor 1 isoform X2', 110, NULL, NULL, 163007),
(163008, '3.50.50.60-FF-001136', NULL, 'Flavin-containing monooxygenase', 110, NULL, NULL, 163008),
(163009, '2.40.70.10-FF-000456', NULL, NULL, 115, NULL, NULL, 163009),
(163010, '2.120.10.30-FF-000005', NULL, 'Teneurin transmembrane protein 4', 104, NULL, NULL, 163010),
(163011, '2.40.50.140-FF-001056', NULL, NULL, 167, NULL, NULL, 163011),
(163012, '3.40.640.10-FF-000097', NULL, 'Serine hydroxymethyltransferase', 218, NULL, NULL, 163012),
(163013, '3.40.390.10-FF-000296', NULL, NULL, 264, NULL, NULL, 163013),
(163014, '3.40.50.2300-FF-001137', NULL, NULL, 196, NULL, NULL, 163014),
(163015, '1.20.1250.20-FF-001621', NULL, 'Transport protein', 149, NULL, NULL, 163015);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(163016, '2.130.10.10-FF-004984', NULL, 'Uncharacterized protein', 78, NULL, NULL, 163016),
(163017, '2.60.40.10-FF-001454', NULL, 'titin isoform X1', 128, NULL, NULL, 163017),
(163018, '2.40.10.10-FF-000008', NULL, 'Cationic trypsin', 108, NULL, NULL, 163018),
(163019, '1.10.630.10-FF-000268', NULL, 'Cytochrome P-450, putative', 442, NULL, NULL, 163019),
(163020, '2.60.40.3210-FF-000024', NULL, 'Endoglin', 112, NULL, NULL, 163020),
(163021, '3.30.1740.10-FF-000016', NULL, 'Poly [ADP-ribose] polymerase', 117, NULL, NULL, 163021),
(163022, '1.10.10.10-FF-001546', NULL, 'YALI0A02200p', 81, NULL, NULL, 163022),
(163023, '3.40.50.300-FF-000656', NULL, 'Leucine-rich repeat serine/threonine-protein kinase 2', 103, NULL, NULL, 163023),
(163024, '2.60.40.3510-FF-000024', NULL, 'Delta-like protein', 147, NULL, NULL, 163024),
(163025, '3.30.70.330-FF-001953', NULL, NULL, 142, NULL, NULL, 163025),
(163026, '3.90.1150.10-FF-000042', NULL, 'Histidinol-phosphate aminotransferase', 124, NULL, NULL, 163026),
(163027, '3.60.10.10-FF-000191', NULL, 'RNA exonuclease, putative', 386, NULL, NULL, 163027),
(163028, '2.130.10.10-FF-001578', NULL, 'Protein SEC13 homolog', 295, NULL, NULL, 163028),
(163029, '3.30.200.20-FF-001266', NULL, 'Kinase', 99, NULL, NULL, 163029),
(163030, '3.40.720.10-FF-000098', NULL, 'Arylsulfatase', 460, NULL, NULL, 163030),
(163031, '3.40.50.1100-FF-000041', NULL, 'Threonine ammonia-lyase, variant', 97, NULL, NULL, 163031),
(163032, '3.30.530.20-FF-000150', NULL, 'Uncharacterized protein', 176, NULL, NULL, 163032),
(163033, '1.25.40.10-FF-000065', NULL, 'Programmed cell death 11', 195, NULL, NULL, 163033),
(163034, '3.30.30.30-FF-000059', NULL, 'Uncharacterized protein', 57, NULL, NULL, 163034),
(163035, '3.90.79.10-FF-000117', NULL, 'Protein CBG19301', 168, NULL, NULL, 163035),
(163036, '3.60.21.10-FF-000328', NULL, 'Uncharacterized protein', 125, NULL, NULL, 163036),
(163037, '3.40.50.720-FF-000546', NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', 198, NULL, NULL, 163037),
(163038, '3.40.50.450-FF-000089', NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase', 150, NULL, NULL, 163038),
(163039, '3.10.129.10-FF-000157', NULL, 'Uncharacterized protein', 150, NULL, NULL, 163039),
(163040, '1.25.40.10-FF-001785', NULL, 'Putative pentatricopeptide repeat-containing protein At3g01580', 212, NULL, NULL, 163040),
(163041, '1.10.10.10-FF-000057', NULL, 'Heat shock transcription factor 1', 98, NULL, NULL, 163041),
(163042, '3.10.310.10-FF-000028', NULL, 'Probable phenazine biosynthesis protein', 147, NULL, NULL, 163042),
(163043, '3.30.230.10-FF-000276', NULL, 'Mevalonate kinase', 208, NULL, NULL, 163043),
(163044, '1.10.630.10-FF-000801', NULL, 'Uncharacterized protein', 83, NULL, NULL, 163044),
(163045, '1.10.238.10-FF-001177', NULL, 'Uncharacterized protein', 90, NULL, NULL, 163045),
(163046, '2.60.120.10-FF-000478', NULL, 'Cysteine dioxygenase', 178, NULL, NULL, 163046),
(163047, '3.40.50.1820-FF-000695', NULL, 'Type IV secretory pathway, VirJ component', 205, NULL, NULL, 163047),
(163048, '3.10.180.10-FF-000113', NULL, '4-hydroxyphenylpyruvate dioxygenase', 180, NULL, NULL, 163048),
(163049, '3.40.33.10-FF-000065', NULL, 'Predicted extracellular protein', 143, NULL, NULL, 163049),
(163050, '1.20.1250.20-FF-002110', NULL, 'Uncharacterized protein', 233, NULL, NULL, 163050),
(163051, '1.10.418.10-FF-000106', NULL, 'Scp1p', 159, NULL, NULL, 163051),
(163052, '2.60.40.60-FF-000108', NULL, 'FAT atypical cadherin 4', 115, NULL, NULL, 163052),
(163053, '1.20.140.40-FF-000063', NULL, NULL, 160, NULL, NULL, 163053),
(163054, '3.60.21.10-FF-000267', NULL, 'UDP-sugar hydrolase 5-nucleotidase', 283, NULL, NULL, 163054),
(163055, '1.10.287.380-FF-000041', NULL, 'Uncharacterized protein', 72, NULL, NULL, 163055),
(163056, '3.10.20.90-FF-001004', NULL, 'Uncharacterized protein', 54, NULL, NULL, 163056),
(163057, '3.40.50.10130-FF-000057', NULL, 'Uncharacterized protein', 94, NULL, NULL, 163057),
(163058, '2.60.40.10-FF-003871', NULL, NULL, 91, NULL, NULL, 163058),
(163059, '3.30.200.20-FF-000777', NULL, 'probably inactive receptor-like protein kinase At2g46850', 105, NULL, NULL, 163059);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(163060, '3.80.10.10-FF-003135', NULL, 'U2 small nuclear ribonucleoprotein A, putative', 63, NULL, NULL, 163060),
(163061, '1.25.10.10-FF-000176', NULL, 'Cell division control protein', 227, NULL, NULL, 163061),
(163062, '3.30.70.330-FF-002442', NULL, NULL, 156, NULL, NULL, 163062),
(163063, '3.30.200.20-FF-000305', NULL, 'PTI1-like tyrosine-protein kinase At3g15890', 104, NULL, NULL, 163063),
(163064, '2.60.120.620-FF-000079', NULL, '2OG-Fe(II) oxygenase family protein', 224, NULL, NULL, 163064),
(163065, '1.10.10.60-FF-001067', NULL, NULL, 69, NULL, NULL, 163065),
(163066, '3.80.10.10-FF-000729', NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g34110', 96, NULL, NULL, 163066),
(163067, '2.60.40.150-FF-000642', NULL, 'Uncharacterized protein', 127, NULL, NULL, 163067),
(163068, '3.40.50.300-FF-002129', NULL, 'ATPase, putative', 203, NULL, NULL, 163068),
(163069, '3.30.160.60-FF-000122', NULL, 'Zinc finger protein 568', 28, NULL, NULL, 163069),
(163070, '3.10.450.40-FF-000053', NULL, NULL, 114, NULL, NULL, 163070),
(163071, '3.30.420.40-FF-000035', NULL, 'Cell division protein FtsA', 89, NULL, NULL, 163071),
(163072, '1.25.40.10-FF-001346', NULL, 'Clathrin heavy chain', 360, NULL, NULL, 163072),
(163073, '4.10.240.10-FF-000165', NULL, 'Znc1p', 108, NULL, NULL, 163073),
(163074, '1.25.10.10-FF-002654', NULL, 'Uncharacterized protein', 106, NULL, NULL, 163074),
(163075, '1.25.40.20-FF-000394', NULL, 'Arginine N-methyltransferase 2', 172, NULL, NULL, 163075),
(163076, '3.40.50.300-FF-007452', NULL, 'Helicase, putative', 246, NULL, NULL, 163076),
(163077, '3.40.50.720-FF-001182', NULL, 'GD25538', 296, NULL, NULL, 163077),
(163078, '3.30.300.30-FF-000170', NULL, 'Acyl-CoA synthetase', 118, NULL, NULL, 163078),
(163079, '2.60.120.40-FF-000021', NULL, 'Tumor necrosis factor ligand superfamily member 13', 138, NULL, NULL, 163079),
(163080, '1.10.555.10-FF-000143', NULL, 'Uncharacterized protein', 172, NULL, NULL, 163080),
(163081, '2.60.40.10-FF-003724', NULL, NULL, 88, NULL, NULL, 163081),
(163082, '3.30.160.60-FF-000414', NULL, 'Zinc finger protein 398', 28, NULL, NULL, 163082),
(163083, '3.10.290.10-FF-000003', NULL, 'Pseudouridine synthase', 60, NULL, NULL, 163083),
(163084, '1.20.1440.170-FF-000016', NULL, NULL, 71, NULL, NULL, 163084),
(163085, '3.90.550.50-FF-000118', NULL, 'Hexosyltransferase', 223, NULL, NULL, 163085),
(163086, '3.40.120.10-FF-000102', NULL, 'Phosphoglucomutase/phosphomannomutase family protein', 105, NULL, NULL, 163086),
(163087, '1.10.287.110-FF-000185', NULL, 'Putative heat shock protein', 80, NULL, NULL, 163087),
(163088, '2.60.120.920-FF-000112', NULL, 'Uncharacterized protein', 187, NULL, NULL, 163088),
(163089, '1.10.8.60-FF-000099', NULL, 'Replication factor C subunit 1', 72, NULL, NULL, 163089),
(163090, '3.40.1110.10-FF-000152', NULL, 'Cation transporter E1-E2 family ATPase', 117, NULL, NULL, 163090),
(163091, '1.10.10.1890-FF-000004', NULL, 'Spindle and kinetochore-associated protein 1', 123, NULL, NULL, 163091),
(163092, '2.40.30.10-FF-000010', NULL, 'Translation elongation factor 2', 140, NULL, NULL, 163092),
(163093, '1.20.1560.10-FF-000646', NULL, 'Uncharacterized protein', 137, NULL, NULL, 163093),
(163094, '3.40.50.300-FF-006024', NULL, 'Poly [ADP-ribose] polymerase', 254, NULL, NULL, 163094),
(163095, '3.40.50.300-FF-003562', NULL, 'ras-related protein Rab-11A isoform X1', 115, NULL, NULL, 163095),
(163096, '1.25.40.10-FF-002774', NULL, 'Uncharacterized protein', 67, NULL, NULL, 163096),
(163097, '1.20.1070.10-FF-001227', NULL, 'Predicted protein', 270, NULL, NULL, 163097),
(163098, '3.30.70.260-FF-000156', NULL, 'Ribose-5-phosphate isomerase A', 72, NULL, NULL, 163098),
(163099, '3.30.930.10-FF-000189', NULL, 'Octanoyltransferase', 207, NULL, NULL, 163099),
(163100, '1.20.1050.90-FF-000013', NULL, NULL, 186, NULL, NULL, 163100),
(163101, '1.20.1730.10-FF-000093', NULL, 'High affinity choline transporter, putative', 334, NULL, NULL, 163101),
(163102, '3.80.10.10-FF-003282', NULL, 'Uncharacterized protein', 121, NULL, NULL, 163102);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(163103, '1.20.5.110-FF-000139', NULL, 'Syntaxin-like protein 1', 113, NULL, NULL, 163103),
(163104, '1.10.10.2660-FF-000011', NULL, 'Ubiquitin-activating enzyme', 42, NULL, NULL, 163104),
(163105, '3.30.160.60-FF-004337', NULL, NULL, 28, NULL, NULL, 163105),
(163106, '3.30.200.20-FF-001766', NULL, 'Non-specific serine/threonine protein kinase', 111, NULL, NULL, 163106),
(163107, '3.30.160.60-FF-001875', NULL, 'pH-response transcription factor pacC/RIM101', 82, NULL, NULL, 163107),
(163108, '3.30.160.390-FF-000001', NULL, 'Phage integrase', 89, NULL, NULL, 163108),
(163109, '1.20.1560.10-FF-000938', NULL, 'Uncharacterized protein', 622, NULL, NULL, 163109),
(163110, '3.10.350.10-FF-000093', NULL, 'Vacuolar assembly protein vps41, putative', 44, NULL, NULL, 163110),
(163111, '3.40.50.1360-FF-000068', NULL, 'Uncharacterized protein', 45, NULL, NULL, 163111),
(163112, '3.30.70.330-FF-001453', NULL, 'Nucleic acid binding protein', 94, NULL, NULL, 163112),
(163113, '2.60.40.10-FF-002382', NULL, 'Stretchin-Mlck, isoform V', 98, NULL, NULL, 163113),
(163114, '1.10.510.10-FF-002058', NULL, 'Protein kinase, putative', 293, NULL, NULL, 163114),
(163115, '1.10.10.1100-FF-000021', NULL, 'Glycerol-3-phosphate dehydrogenase', 68, NULL, NULL, 163115),
(163116, '3.30.1120.10-FF-000076', NULL, 'LOC402795 protein', 54, NULL, NULL, 163116),
(163117, '4.10.60.10-FF-000177', NULL, 'Uncharacterized protein', 44, NULL, NULL, 163117),
(163118, '2.130.10.10-FF-001078', NULL, 'Transducin family protein / WD-40 repeat family protein', 209, NULL, NULL, 163118),
(163119, '2.10.50.30-FF-000030', NULL, 'Extracellular calcium-sensing receptor', 75, NULL, NULL, 163119),
(163120, '1.25.40.20-FF-001675', NULL, 'Uncharacterized protein', 80, NULL, NULL, 163120),
(163121, '3.65.10.20-FF-000009', NULL, 'RNA 3''-terminal phosphate cyclase-like protein,putative', 185, NULL, NULL, 163121),
(163122, '3.40.850.10-FF-000343', NULL, 'Kinesin-like protein', 198, NULL, NULL, 163122),
(163123, '1.25.40.10-FF-005236', NULL, 'Uncharacterized protein', 171, NULL, NULL, 163123),
(163124, '3.40.50.1950-FF-000003', NULL, 'Dipicolinate synthase subunit B', 199, NULL, NULL, 163124),
(163125, '3.40.50.150-FF-001078', NULL, 'Leucine carboxyl methyltransferase 1', 330, NULL, NULL, 163125),
(163126, '3.55.10.10-FF-000001', NULL, 'protein archease isoform X1', 140, NULL, NULL, 163126),
(163127, '3.40.50.300-FF-004990', NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 8', 81, NULL, NULL, 163127),
(163128, '2.30.29.30-FF-000592', NULL, 'Uncharacterized protein', 121, NULL, NULL, 163128),
(163129, '1.20.120.310-FF-000018', NULL, NULL, 114, NULL, NULL, 163129),
(163130, '3.40.50.12710-FF-000033', NULL, 'Protein arginine methyltransferase NDUFAF7', 416, NULL, NULL, 163130),
(163131, '3.90.1480.20-FF-000064', NULL, 'Uncharacterized protein', 165, NULL, NULL, 163131),
(163132, '2.10.25.10-FF-001320', NULL, 'Laminin subunit gamma-1', 55, NULL, NULL, 163132),
(163133, '3.30.160.60-FF-001583', NULL, 'UBP1-associated proteins 1C', 44, NULL, NULL, 163133),
(163134, '3.30.40.10-FF-001099', NULL, 'E3 ubiquitin-protein ligase CHIP', 98, NULL, NULL, 163134),
(163135, '2.40.30.10-FF-000038', NULL, 'Sulfite reductase [NADPH] flavoprotein alpha-component', 102, NULL, NULL, 163135),
(163136, '3.40.50.300-FF-007744', NULL, 'Helicase', 79, NULL, NULL, 163136),
(163137, '3.30.300.10-FF-000012', NULL, 'S-adenosylmethionine synthase', 129, NULL, NULL, 163137),
(163138, '3.30.70.980-FF-000046', NULL, 'Probable transcriptional regulatory protein RW64_15025', 72, NULL, NULL, 163138),
(163139, '2.60.40.1910-FF-000038', NULL, NULL, 89, NULL, NULL, 163139),
(163140, '3.90.730.10-FF-000019', NULL, 'Ribonuclease T2', 225, NULL, NULL, 163140),
(163141, '2.130.10.10-FF-004484', NULL, 'Target of rapamycin complex 1 subunit mip1', 95, NULL, NULL, 163141),
(163142, '3.40.50.1970-FF-000009', NULL, 'Fe-containing alcohol dehydrogenase', 196, NULL, NULL, 163142),
(163143, '3.40.850.10-FF-000051', NULL, 'Kinesin-like protein bimC', 379, NULL, NULL, 163143),
(163144, '1.10.3430.10-FF-000027', NULL, 'Uncharacterized protein', 440, NULL, NULL, 163144);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(163145, '2.130.10.10-FF-003995', NULL, 'Predicted protein', 230, NULL, NULL, 163145),
(163146, '3.20.20.80-FF-000809', NULL, 'Uncharacterized protein', 113, NULL, NULL, 163146),
(163147, '2.60.40.630-FF-000011', NULL, 'Novel protein similar to human signal transduction and activator of transcription 4 (STAT4)', 133, NULL, NULL, 163147),
(163148, '1.10.510.10-FF-000793', NULL, 'Serine/threonine protein kinase', 177, NULL, NULL, 163148),
(163149, '1.10.510.10-FF-000613', NULL, 'Mitogen-activated protein kinase', 180, NULL, NULL, 163149),
(163150, '2.60.40.10-FF-005669', NULL, NULL, 85, NULL, NULL, 163150),
(163151, '3.40.1810.10-FF-000065', NULL, NULL, 82, NULL, NULL, 163151),
(163152, '2.60.120.620-FF-000051', NULL, 'Uncharacterized protein', 246, NULL, NULL, 163152),
(163153, '2.130.10.10-FF-003556', NULL, 'WD repeat domain 3', 294, NULL, NULL, 163153),
(163154, '3.40.50.1820-FF-000723', NULL, 'Carboxylic ester hydrolase', 546, NULL, NULL, 163154),
(163155, '3.40.930.10-FF-000052', NULL, NULL, 104, NULL, NULL, 163155),
(163156, '3.80.20.20-FF-000031', NULL, 'FI18055p1', 171, NULL, NULL, 163156),
(163157, '1.20.58.190-FF-000005', NULL, 'Translin associated factor X', 92, NULL, NULL, 163157),
(163158, '3.40.50.300-FF-005799', NULL, 'Uncharacterized protein', 55, NULL, NULL, 163158),
(163159, '3.30.70.330-FF-001014', NULL, 'Homologous to Drosophila SQD (Squid) protein', 106, NULL, NULL, 163159),
(163160, '3.30.930.10-FF-000430', NULL, 'Phenylalanine--tRNA ligase beta subunit', 187, NULL, NULL, 163160),
(163161, '3.30.760.10-FF-000097', NULL, 'Uncharacterized protein', 62, NULL, NULL, 163161),
(163162, '3.30.9.10-FF-000138', NULL, 'Pipecolic acid oxidase', 159, NULL, NULL, 163162),
(163163, '1.10.287.70-FF-000291', NULL, 'TWiK family of potassium channels', 306, NULL, NULL, 163163),
(163164, '3.30.1370.110-FF-000025', NULL, 'Smr domain-containing protein C1235.03', 105, NULL, NULL, 163164),
(163165, '1.20.120.350-FF-000070', NULL, 'K+ channel tetramerization domain protein', 175, NULL, NULL, 163165),
(163166, '3.40.50.150-FF-000330', NULL, 'Trimethylguanosine synthase', 224, NULL, NULL, 163166),
(163167, '1.10.132.30-FF-000004', NULL, 'DNA-directed RNA polymerase subunit', 108, NULL, NULL, 163167),
(163168, '3.30.1680.10-FF-000045', NULL, 'Semaphorin 7A', 51, NULL, NULL, 163168),
(163169, '3.20.20.80-FF-000517', NULL, 'Putative galactocerebrosidase', 187, NULL, NULL, 163169),
(163170, '2.130.10.10-FF-004192', NULL, 'IFT140', 160, NULL, NULL, 163170),
(163171, '3.30.800.10-FF-000005', NULL, '1-phosphatidylinositol-3-phosphate 5-kinase (Fab1)', 168, NULL, NULL, 163171),
(163172, '2.60.40.1180-FF-000218', NULL, 'Glucosidase 2 subunit alpha', 130, NULL, NULL, 163172),
(163173, '1.10.840.10-FF-000014', NULL, 'SH2 domain containing 3A', 307, NULL, NULL, 163173),
(163174, '1.20.1060.20-FF-000010', NULL, 'Structural maintenance of chromosomes protein 1', 131, NULL, NULL, 163174),
(163175, '3.10.20.90-FF-000779', NULL, 'Ubiquitin carboxyl-terminal hydrolase 7', 99, NULL, NULL, 163175),
(163176, '1.20.120.20-FF-000022', NULL, 'Si:dkey-7f3.14', 102, NULL, NULL, 163176),
(163177, '3.30.160.60-FF-005765', NULL, NULL, 34, NULL, NULL, 163177),
(163178, '1.10.8.60-FF-000071', NULL, 'Cell division cycle-like protein', 93, NULL, NULL, 163178),
(163179, '1.10.10.10-FF-002002', NULL, 'Predicted protein', 133, NULL, NULL, 163179),
(163180, '1.10.238.10-FF-000660', NULL, 'FI14603p', 49, NULL, NULL, 163180),
(163181, '3.30.720.10-FF-000004', NULL, 'Signal recognition particle 14 kDa protein', 121, NULL, NULL, 163181),
(163182, '2.60.15.10-FF-000013', NULL, 'ATP synthase epsilon chain', 88, NULL, NULL, 163182),
(163183, '2.60.120.10-FF-000450', NULL, 'Mannose-6-phosphate isomerase', 165, NULL, NULL, 163183),
(163184, '2.30.30.40-FF-000547', NULL, 'Uncharacterized protein', 145, NULL, NULL, 163184),
(163185, '3.30.460.90-FF-000002', NULL, 'Mitochondrial dynamics protein MID51', 192, NULL, NULL, 163185),
(163186, '2.60.40.10-FF-000998', NULL, 'Immunoglobulin heavy constant epsilon', 102, NULL, NULL, 163186),
(163187, '2.30.29.30-FF-000884', NULL, 'Uncharacterized protein', 111, NULL, NULL, 163187);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(163188, '3.30.1120.30-FF-000054', NULL, 'Uncharacterized protein', 36, NULL, NULL, 163188),
(163189, '2.60.120.260-FF-000280', NULL, 'Beta-galactosidase', 86, NULL, NULL, 163189),
(163190, '1.20.1250.20-FF-001593', NULL, 'Membrane-associated transporter protein', 277, NULL, NULL, 163190),
(163191, '3.30.160.60-FF-006254', NULL, NULL, 88, NULL, NULL, 163191),
(163192, '1.20.1070.10-FF-000738', NULL, 'Uncharacterized protein', 254, NULL, NULL, 163192),
(163193, '1.20.5.110-FF-000291', NULL, 'Uncharacterized protein', 98, NULL, NULL, 163193),
(163194, '1.20.120.1750-FF-000024', NULL, 'RBR-type E3 ubiquitin transferase', 79, NULL, NULL, 163194),
(163195, '3.40.50.150-FF-001639', NULL, NULL, 233, NULL, NULL, 163195),
(163196, '2.60.120.380-FF-000023', NULL, 'Kinesin, putative', 160, NULL, NULL, 163196),
(163197, '2.40.50.690-FF-000029', NULL, 'Uncharacterized protein', 68, NULL, NULL, 163197),
(163198, '2.10.25.10-FF-000572', NULL, 'Nidogen 2', 41, NULL, NULL, 163198),
(163199, '3.70.10.10-FF-000050', NULL, 'Checkpoint protein', 205, NULL, NULL, 163199),
(163200, '3.30.160.60-FF-002331', NULL, 'Zinc finger protein 672', 32, NULL, NULL, 163200),
(163201, '2.30.29.30-FF-000445', NULL, 'ephexin-1 isoform X2', 138, NULL, NULL, 163201),
(163202, '3.10.20.30-FF-000076', NULL, NULL, 63, NULL, NULL, 163202),
(163203, '3.80.10.10-FF-002646', NULL, 'F-box/LRR-repeat protein 15', 157, NULL, NULL, 163203),
(163204, '3.30.420.40-FF-000827', NULL, 'Predicted protein', 29, NULL, NULL, 163204),
(163205, '2.120.10.30-FF-000477', NULL, 'Predicted protein', 54, NULL, NULL, 163205),
(163206, '3.30.70.330-FF-000525', NULL, 'RNA-binding protein 8A', 145, NULL, NULL, 163206),
(163207, '3.30.9.10-FF-000285', NULL, 'Uncharacterized protein', 179, NULL, NULL, 163207),
(163208, '2.60.40.420-FF-000066', NULL, 'Early nodulin-like protein 9', 114, NULL, NULL, 163208),
(163209, '3.30.1140.60-FF-000013', NULL, 'F-actin-capping protein subunit alpha', 107, NULL, NULL, 163209),
(163210, '3.30.70.1730-FF-000002', NULL, '60S acidic ribosomal protein P0', 129, NULL, NULL, 163210),
(163211, '3.30.70.330-FF-001161', NULL, 'Peptidyl prolyl cis-trans isomerase Cyclophilin, putative', 128, NULL, NULL, 163211),
(163212, '3.40.50.300-FF-004046', NULL, 'ATP-dependent DNA helicase, putative', 101, NULL, NULL, 163212),
(163213, '3.40.50.410-FF-000217', NULL, 'Uncharacterized protein', 184, NULL, NULL, 163213),
(163214, '3.40.50.1820-FF-001212', NULL, 'Uncharacterized protein', 141, NULL, NULL, 163214),
(163215, '1.10.760.10-FF-000013', NULL, 'Cbb3-type cytochrome c oxidase subunit', 118, NULL, NULL, 163215),
(163216, '3.10.50.40-FF-000114', NULL, 'Peptidyl-prolyl cis-trans isomerase', 72, NULL, NULL, 163216),
(163217, '3.30.497.10-FF-000063', NULL, 'Serpin family E member 3', 58, NULL, NULL, 163217),
(163218, '2.70.50.40-FF-000018', NULL, 'Unc-119 lipid binding chaperone', 45, NULL, NULL, 163218),
(163219, '3.40.718.10-FF-000070', NULL, 'Uncharacterized protein', 133, NULL, NULL, 163219),
(163220, '3.10.50.10-FF-000038', NULL, 'Chitinase domain-containing protein 1', 55, NULL, NULL, 163220),
(163221, '3.40.1170.60-FF-000035', NULL, NULL, 94, NULL, NULL, 163221),
(163222, '3.30.70.360-FF-000040', NULL, 'Acetylornithine deacetylase ArgE', 108, NULL, NULL, 163222),
(163223, '1.25.10.10-FF-000737', NULL, 'Splicing factor 3B subunit 1, putative', 328, NULL, NULL, 163223),
(163224, '2.60.40.10-FF-004208', NULL, NULL, 75, NULL, NULL, 163224),
(163225, '1.10.4160.10-FF-000017', NULL, 'Permease for cytosine/purines uracil thiamine allantoin', 464, NULL, NULL, 163225),
(163226, '2.60.40.10-FF-001746', NULL, 'Carbohydrate-binding-like fold', 73, NULL, NULL, 163226),
(163227, '3.90.550.10-FF-000101', NULL, 'Probable glycosyltransferase 5', 147, NULL, NULL, 163227),
(163228, '2.40.110.10-FF-000050', NULL, 'Acyl-coenzyme A oxidase', 139, NULL, NULL, 163228),
(163229, '3.30.900.10-FF-000041', NULL, 'Uncharacterized protein', 201, NULL, NULL, 163229),
(163230, '2.60.120.200-FF-000661', NULL, 'Uncharacterized protein', 82, NULL, NULL, 163230),
(163231, '3.40.50.300-FF-006816', NULL, 'Predicted protein', 41, NULL, NULL, 163231);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(163232, '1.25.40.20-FF-000214', NULL, 'No mechanoreceptor potential C, isoform D', 253, NULL, NULL, 163232),
(163233, '1.25.10.10-FF-002946', NULL, 'Uncharacterized protein', 59, NULL, NULL, 163233),
(163234, '2.130.10.10-FF-005501', NULL, 'Predicted protein', 105, NULL, NULL, 163234),
(163235, '1.20.5.340-FF-000011', NULL, 'Stromal interaction molecule 1', 104, NULL, NULL, 163235),
(163236, '3.30.40.10-FF-002116', NULL, 'Predicted protein', 105, NULL, NULL, 163236),
(163237, '2.30.30.490-FF-000046', NULL, 'DNA (cytosine-5)-methyltransferase 3', 176, NULL, NULL, 163237),
(163238, '3.30.70.360-FF-000068', NULL, 'Predicted protein', 78, NULL, NULL, 163238),
(163239, '1.25.40.10-FF-001493', NULL, 'Predicted protein', 102, NULL, NULL, 163239),
(163240, '1.20.1070.10-FF-001374', NULL, 'Uncharacterized protein', 256, NULL, NULL, 163240),
(163241, '3.40.910.10-FF-000022', NULL, 'Deoxyhypusine synthase', 95, NULL, NULL, 163241),
(163242, '3.30.160.60-FF-005618', NULL, NULL, 58, NULL, NULL, 163242),
(163243, '2.60.40.10-FF-000026', NULL, 'roundabout homolog 2 isoform X1', 109, NULL, NULL, 163243),
(163244, '3.40.30.10-FF-000884', NULL, 'Ganglioside-induced differentiation-associated protein 1, 2 gdap, putative', 91, NULL, NULL, 163244),
(163245, '3.40.50.970-FF-000216', NULL, 'Pyruvate decarboxylase 2', 88, NULL, NULL, 163245),
(163246, '3.40.50.720-FF-002463', NULL, 'Uncharacterized protein', 143, NULL, NULL, 163246),
(163247, '1.10.238.20-FF-000050', NULL, 'AGAP002190-PA', 117, NULL, NULL, 163247),
(163248, '1.20.58.60-FF-000120', NULL, 'proto-oncogene DBL isoform X1', 321, NULL, NULL, 163248),
(163249, '3.40.109.10-FF-000059', NULL, 'Nitroreductase family protein', 209, NULL, NULL, 163249),
(163250, '2.60.120.200-FF-000689', NULL, 'Uncharacterized protein', 202, NULL, NULL, 163250),
(163251, '1.20.120.1770-FF-000002', NULL, 'Cytochrome b561 domain-containing protein 2', 213, NULL, NULL, 163251),
(163252, '1.10.3210.10-FF-000016', NULL, 'HD domain-containing protein 2', 191, NULL, NULL, 163252),
(163253, '3.40.50.1820-FF-001151', NULL, 'Dienelactone hydrolase', 317, NULL, NULL, 163253),
(163254, '1.10.12.10-FF-000039', NULL, 'Enoyl-CoA hydratase', 58, NULL, NULL, 163254),
(163255, '3.40.50.360-FF-000067', NULL, 'Putative p450 reductase', 195, NULL, NULL, 163255),
(163256, '3.10.50.40-FF-000053', NULL, 'Peptidylprolyl isomerase', 127, NULL, NULL, 163256),
(163257, '2.60.40.790-FF-000098', NULL, 'Nuclear movement protein nudc, putative', 135, NULL, NULL, 163257),
(163258, '4.10.1060.10-FF-000052', NULL, 'Npp-9', 38, NULL, NULL, 163258),
(163259, '2.60.40.10-FF-002943', NULL, 'Twitchin', 100, NULL, NULL, 163259),
(163260, '3.30.40.10-FF-000582', NULL, 'Transcription factor jumonji (JmjC) domain-containing protein', 95, NULL, NULL, 163260),
(163261, '3.30.830.10-FF-000125', NULL, 'Uncharacterized protein C05D11.1', 218, NULL, NULL, 163261),
(163262, '1.25.10.10-FF-001726', NULL, 'Exportin-T', 1007, NULL, NULL, 163262),
(163263, '1.20.1070.10-FF-001166', NULL, 'AGAP002229-PA', 341, NULL, NULL, 163263),
(163264, '1.20.58.1030-FF-000031', NULL, 'Uncharacterized protein', 189, NULL, NULL, 163264),
(163265, '3.40.50.300-FF-000156', NULL, 'ATP-dependent DNA helicase recQ', 133, NULL, NULL, 163265),
(163266, '3.40.50.11960-FF-000004', NULL, 'YALI0F12947p', 193, NULL, NULL, 163266),
(163267, '1.25.40.10-FF-003263', NULL, 'Pentatricopeptide repeat-containing protein At3g48250, chloroplastic', 154, NULL, NULL, 163267),
(163268, '1.20.1410.10-FF-000046', NULL, 'Uncharacterized protein', 116, NULL, NULL, 163268),
(163269, '3.30.70.660-FF-000068', NULL, 'tRNA pseudouridine synthase', 167, NULL, NULL, 163269),
(163270, '1.10.730.20-FF-000014', NULL, 'Isoleucine--tRNA ligase', 286, NULL, NULL, 163270),
(163271, '1.20.1270.420-FF-000007', NULL, 'Uncharacterized protein', 257, NULL, NULL, 163271),
(163272, '3.40.50.300-FF-005535', NULL, 'Uncharacterized protein', 65, NULL, NULL, 163272),
(163273, '3.30.70.330-FF-001806', NULL, NULL, 139, NULL, NULL, 163273),
(163274, '3.90.1150.190-FF-000004', NULL, 'Polycomb protein Scm', 112, NULL, NULL, 163274);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(163275, '3.40.50.720-FF-000254', NULL, 'UDP-glucose 4-epimerase GalE', 221, NULL, NULL, 163275),
(163276, '1.10.1520.10-FF-000034', NULL, 'Mini-ribonuclease 3', 140, NULL, NULL, 163276),
(163277, '2.60.40.10-FF-003399', NULL, NULL, 116, NULL, NULL, 163277),
(163278, '1.50.40.10-FF-000473', NULL, 'Predicted protein', 294, NULL, NULL, 163278),
(163279, '1.20.1050.10-FF-000063', NULL, 'Putative glutathione S-transferase', 174, NULL, NULL, 163279),
(163280, '3.40.50.620-FF-000634', NULL, 'Tyrosine--tRNA ligase', 218, NULL, NULL, 163280),
(163281, '3.30.70.330-FF-001222', NULL, 'Putative Transcriptional repressor NOT4Hp', 79, NULL, NULL, 163281),
(163282, '2.60.40.10-FF-000318', NULL, 'Growth hormone receptor', 100, NULL, NULL, 163282),
(163283, '3.40.630.30-FF-000546', NULL, 'Slr8037 protein', 152, NULL, NULL, 163283),
(163284, '2.40.50.730-FF-000002', NULL, 'DNA polymerase', 69, NULL, NULL, 163284),
(163285, '1.20.5.440-FF-000007', NULL, 'ATP synthase epsilon chain', 44, NULL, NULL, 163285),
(163286, '3.40.720.10-FF-000131', NULL, 'Uncharacterized protein', 259, NULL, NULL, 163286),
(163287, '1.10.3380.10-FF-000062', NULL, 'Activating signal cointegrator 1 complex subunit 3, helc1, putative', 91, NULL, NULL, 163287),
(163288, '3.10.620.30-FF-000024', NULL, 'Slr8037 protein', 156, NULL, NULL, 163288),
(163289, '2.10.50.10-FF-000052', NULL, 'Cysteine repeat modular protein 1', 64, NULL, NULL, 163289),
(163290, '3.30.160.60-FF-005557', NULL, NULL, 31, NULL, NULL, 163290),
(163291, '3.30.160.60-FF-004129', NULL, NULL, 26, NULL, NULL, 163291),
(163292, '3.30.1360.40-FF-000046', NULL, 'Predicted protein', 75, NULL, NULL, 163292),
(163293, '3.10.20.90-FF-000987', NULL, 'Uncharacterized protein', 91, NULL, NULL, 163293),
(163294, '1.20.58.70-FF-000010', NULL, 'Syntaxin-43', 213, NULL, NULL, 163294),
(163295, '3.40.630.30-FF-000107', NULL, 'N-terminal acetyltransferase complex ARD1 subunit', 238, NULL, NULL, 163295),
(163296, '1.10.1410.40-FF-000012', NULL, 'spermatid perinuclear RNA-binding protein isoform X4', 72, NULL, NULL, 163296),
(163297, '3.90.70.80-FF-000045', NULL, 'Uncharacterized protein', 102, NULL, NULL, 163297),
(163298, '2.30.29.30-FF-000653', NULL, 'Quattro', 119, NULL, NULL, 163298),
(163299, '3.40.30.10-FF-000412', NULL, 'Glutaredoxin family protein', 83, NULL, NULL, 163299),
(163300, '1.10.20.10-FF-000030', NULL, 'Transcription initiation factor TFIID subunit 6', 68, NULL, NULL, 163300),
(163301, '1.20.58.60-FF-000384', NULL, 'AcTiniN', 122, NULL, NULL, 163301),
(163302, '3.80.10.10-FF-002938', NULL, 'Uncharacterized protein', 95, NULL, NULL, 163302),
(163303, '1.10.238.10-FF-000249', NULL, 'calcium and calcium/calmodulin-dependent serine/threonine-protein kinase DMI-3', 170, NULL, NULL, 163303),
(163304, '1.10.533.10-FF-000065', NULL, 'Ectodysplasin-A receptor-associated adapter protein', 96, NULL, NULL, 163304),
(163305, '3.30.40.10-FF-001571', NULL, 'Fgr3p', 131, NULL, NULL, 163305),
(163306, '1.20.1300.10-FF-000009', NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit, mitochondrial', 115, NULL, NULL, 163306),
(163307, '2.130.10.10-FF-002859', NULL, 'Uncharacterized protein', 330, NULL, NULL, 163307),
(163308, '3.30.565.10-FF-000137', NULL, 'Unplaced genomic scaffold supercont1.28, whole genome shotgun sequence', 178, NULL, NULL, 163308),
(163309, '2.60.40.1230-FF-000020', NULL, 'VHS domain-domain-containing protein', 113, NULL, NULL, 163309),
(163310, '2.60.260.20-FF-000137', NULL, 'Chaperone protein DnaJ 2', 105, NULL, NULL, 163310),
(163311, '2.40.10.10-FF-000155', NULL, 'Flocculation FLO11-like protein', 242, NULL, NULL, 163311),
(163312, '1.25.50.20-FF-000012', NULL, 'Aminopeptidase N', 333, NULL, NULL, 163312),
(163313, '2.170.270.10-FF-000075', NULL, 'Histone-lysine N-methyltransferase 2D', 113, NULL, NULL, 163313),
(163314, '1.20.1110.10-FF-000265', NULL, NULL, 143, NULL, NULL, 163314),
(163315, '1.10.630.10-FF-000768', NULL, 'Protein CBG01387', 196, NULL, NULL, 163315),
(163316, '1.10.30.50-FF-000020', NULL, 'Sll2007 protein', 83, NULL, NULL, 163316);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(163317, '3.40.630.20-FF-000009', NULL, 'Pyrrolidone-carboxylate peptidase', 217, NULL, NULL, 163317),
(163318, '3.30.420.60-FF-000013', NULL, 'Protein PELOTA 1', 111, NULL, NULL, 163318),
(163319, '3.90.550.10-FF-000365', NULL, 'Uncharacterized protein', 200, NULL, NULL, 163319),
(163320, '2.60.40.10-FF-000173', NULL, 'Neural cell adhesion molecule 1', 102, NULL, NULL, 163320),
(163321, '1.10.1450.10-FF-000118', NULL, 'Putative tetraspanin family', 90, NULL, NULL, 163321),
(163322, '2.60.120.650-FF-000155', NULL, 'Uncharacterized protein', 285, NULL, NULL, 163322),
(163323, '3.40.33.10-FF-000126', NULL, 'SCP-Like extracellular protein', 198, NULL, NULL, 163323),
(163324, '3.90.190.10-FF-000382', NULL, 'Protein tyrosine phosphatase, receptor type T', 289, NULL, NULL, 163324),
(163325, '2.130.10.10-FF-002275', NULL, 'Hypothetical_protein_-_conserved', 260, NULL, NULL, 163325),
(163326, '2.70.70.10-FF-000005', NULL, 'Hypothetical lipoprotein YgeR', 163, NULL, NULL, 163326),
(163327, '2.60.40.10-FF-001954', NULL, 'CD48 antigen', 113, NULL, NULL, 163327),
(163328, '2.30.30.910-FF-000004', NULL, 'Basal-body rod modification protein FlgD', 38, NULL, NULL, 163328),
(163329, '1.20.5.100-FF-000018', NULL, 'Integrin beta', 73, NULL, NULL, 163329),
(163330, '3.30.70.330-FF-002650', NULL, NULL, 120, NULL, NULL, 163330),
(163331, '3.30.1360.120-FF-000026', NULL, 'Sarcosine dehydrogenase', 204, NULL, NULL, 163331),
(163332, '3.30.160.60-FF-000386', NULL, 'Tripartite motif-containing 5 (Predicted)', 43, NULL, NULL, 163332),
(163333, '1.20.58.90-FF-000016', NULL, 'Tubulin-specific chaperone A', 115, NULL, NULL, 163333),
(163334, '3.30.310.280-FF-000003', NULL, 'Siderophore biosynthesis IucC family protein', 127, NULL, NULL, 163334),
(163335, '3.10.580.10-FF-000194', NULL, 'Uncharacterized protein', 107, NULL, NULL, 163335),
(163336, '1.10.510.10-FF-003991', NULL, NULL, 46, NULL, NULL, 163336),
(163337, '3.10.20.90-FF-000515', NULL, 'FERM domain (Protein4.1-ezrin-radixin-moesin) family', 61, NULL, NULL, 163337),
(163338, '2.120.10.80-FF-000031', NULL, 'attractin', 176, NULL, NULL, 163338),
(163339, '1.10.3710.10-FF-000009', NULL, 'AAA family ATPase', 74, NULL, NULL, 163339),
(163340, '1.10.10.10-FF-000849', NULL, 'O-methyltransferase GliM', 96, NULL, NULL, 163340),
(163341, '1.10.20.10-FF-000294', NULL, NULL, 64, NULL, NULL, 163341),
(163342, '3.40.50.720-FF-001243', NULL, '4-hydroxy-tetrahydrodipicolinate reductase', 140, NULL, NULL, 163342),
(163343, '3.40.525.10-FF-000054', NULL, 'Clavesin-2', 58, NULL, NULL, 163343),
(163344, '3.40.30.10-FF-000676', NULL, 'Methionyl-tRNA synthetase, putative', 37, NULL, NULL, 163344),
(163345, '3.40.50.200-FF-000008', NULL, 'Membrane-bound transcription factor site-1 protease preproprotein', 287, NULL, NULL, 163345),
(163346, '1.10.720.30-FF-000045', NULL, 'T. brucei spp.-specific protein', 50, NULL, NULL, 163346),
(163347, '3.40.50.2300-FF-000120', NULL, 'Alginate biosynthesis transcriptional regulator AlgB', 139, NULL, NULL, 163347),
(163348, '3.40.50.300-FF-002781', NULL, 'DEAD-box ATP-dependent RNA helicase 39', 250, NULL, NULL, 163348),
(163349, '3.30.43.10-FF-000032', NULL, 'Carbon monoxide dehydrogenase medium chain', 55, NULL, NULL, 163349),
(163350, '3.20.20.70-FF-000632', NULL, NULL, 265, NULL, NULL, 163350),
(163351, '3.40.605.10-FF-000055', NULL, 'Delta-1-pyrroline-5-carboxylate synthase', 72, NULL, NULL, 163351),
(163352, '3.80.10.10-FF-004063', NULL, 'Uncharacterized protein', 132, NULL, NULL, 163352),
(163353, '3.40.50.1240-FF-000145', NULL, NULL, 159, NULL, NULL, 163353),
(163354, '3.40.50.1440-FF-000025', NULL, 'Tubulin beta chain', 172, NULL, NULL, 163354),
(163355, '1.25.40.20-FF-000894', NULL, 'Protein ACCELERATED CELL DEATH 6', 170, NULL, NULL, 163355),
(163356, '2.60.200.30-FF-000018', NULL, 'NAD kinase', 120, NULL, NULL, 163356),
(163357, '3.40.30.10-FF-000204', NULL, 'Protein disulfide isomerase-like 1-6', 114, NULL, NULL, 163357),
(163358, '2.60.40.10-FF-003663', NULL, NULL, 56, NULL, NULL, 163358),
(163359, '3.40.50.200-FF-000160', NULL, 'Predicted protein', 173, NULL, NULL, 163359);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(163360, '1.20.1250.20-FF-002138', NULL, 'Uncharacterized transporter C757.13', 204, NULL, NULL, 163360),
(163361, '1.25.10.10-FF-001518', NULL, 'Diaphanous protein, homolog 1, putative', 285, NULL, NULL, 163361),
(163362, '1.20.1560.10-FF-000293', NULL, 'ATP binding cassette subfamily B member 1', 25, NULL, NULL, 163362),
(163363, '3.40.50.1820-FF-000431', NULL, 'Membrane bound polyketide synthase Pks6', 288, NULL, NULL, 163363),
(163364, '4.10.40.20-FF-000004', NULL, 'HtrA serine peptidase 3', 77, NULL, NULL, 163364),
(163365, '3.80.10.10-FF-003343', NULL, 'Uncharacterized protein', 120, NULL, NULL, 163365),
(163366, '2.30.42.10-FF-000431', NULL, NULL, 113, NULL, NULL, 163366),
(163367, '1.25.40.20-FF-000422', NULL, 'E3 ubiquitin-protein ligase mind-bomb', 122, NULL, NULL, 163367),
(163368, '3.60.40.10-FF-000159', NULL, 'Probable protein phosphatase 2C 26', 225, NULL, NULL, 163368),
(163369, '3.40.30.10-FF-000092', NULL, 'Monothiol glutaredoxin', 117, NULL, NULL, 163369),
(163370, '1.10.472.130-FF-000063', NULL, 'Uncharacterized protein', 166, NULL, NULL, 163370),
(163371, '1.10.510.10-FF-004183', NULL, NULL, 94, NULL, NULL, 163371),
(163372, '3.40.50.170-FF-000044', NULL, 'Uncharacterized protein', 88, NULL, NULL, 163372),
(163373, '3.40.50.10190-FF-000176', NULL, 'DNA ligase 4', 122, NULL, NULL, 163373),
(163374, '3.40.50.790-FF-000022', NULL, 'Uncharacterized protein', 93, NULL, NULL, 163374),
(163375, '3.60.10.10-FF-000011', NULL, 'Type II inositol polyphosphate 5-phosphatase 15', 392, NULL, NULL, 163375),
(163376, '3.30.200.20-FF-000569', NULL, 'Mitogen-activated protein kinase', 114, NULL, NULL, 163376),
(163377, '3.40.50.150-FF-000089', NULL, 'S-adenosylmethionine sensor upstream of mTORC1', 206, NULL, NULL, 163377),
(163378, '2.60.40.1170-FF-000041', NULL, 'AP-2 complex subunit mu', 115, NULL, NULL, 163378),
(163379, '1.20.1070.10-FF-000446', NULL, 'Prostaglandin E receptor subtype EP4', 168, NULL, NULL, 163379),
(163380, '1.20.1560.10-FF-000877', NULL, 'Protein CBG20250', 68, NULL, NULL, 163380),
(163381, '3.30.1370.240-FF-000013', NULL, 'tRNA synthetases class II core domain (F)-domain-containing protein', 69, NULL, NULL, 163381),
(163382, '1.20.120.350-FF-000215', NULL, NULL, 112, NULL, NULL, 163382),
(163383, '3.40.390.10-FF-000032', NULL, 'Probable thimet oligopeptidase', 151, NULL, NULL, 163383),
(163384, '3.40.50.460-FF-000007', NULL, 'ATP-dependent 6-phosphofructokinase', 145, NULL, NULL, 163384),
(163385, '2.60.40.1510-FF-000042', NULL, 'Integrin beta', 89, NULL, NULL, 163385),
(163386, '3.30.160.60-FF-002100', NULL, 'Paternally-expressed gene 3 protein', 63, NULL, NULL, 163386),
(163387, '4.10.240.10-FF-000226', NULL, 'Uncharacterized transcriptional regulatory protein C16G5.17', 82, NULL, NULL, 163387),
(163388, '1.20.58.80-FF-000070', NULL, 'serine/threonine-protein kinase ULK3', 71, NULL, NULL, 163388),
(163389, '3.40.50.2000-FF-001076', NULL, 'Beta-1,4 mannosyltransferase', 198, NULL, NULL, 163389),
(163390, '3.40.50.300-FF-002101', NULL, 'DNA replication helicase DNA2', 211, NULL, NULL, 163390),
(163391, '3.90.70.10-FF-000244', NULL, 'Cysteine protease 18', 372, NULL, NULL, 163391),
(163392, '1.25.40.20-FF-000186', NULL, 'Transient receptor potential cation channel A1, isoform K', 166, NULL, NULL, 163392),
(163393, '4.10.280.10-FF-000083', NULL, 'Neuronal PAS domain protein 1', 57, NULL, NULL, 163393),
(163394, '1.10.730.10-FF-000124', NULL, 'Leucyl-tRNA synthetase', 30, NULL, NULL, 163394),
(163395, '3.80.10.10-FF-001718', NULL, 'Os02g0317300 protein', 87, NULL, NULL, 163395),
(163396, '3.30.160.60-FF-003848', NULL, NULL, 34, NULL, NULL, 163396),
(163397, '2.170.130.10-FF-000065', NULL, NULL, 146, NULL, NULL, 163397),
(163398, '3.80.10.10-FF-003927', NULL, 'Predicted protein', 244, NULL, NULL, 163398),
(163399, '1.20.1270.60-FF-000009', NULL, 'Protein kinase C and casein kinase substrate in neurons 2', 290, NULL, NULL, 163399),
(163400, '2.70.98.10-FF-000125', NULL, 'Uncharacterized protein', 56, NULL, NULL, 163400),
(163401, '1.10.510.10-FF-004244', NULL, NULL, 197, NULL, NULL, 163401);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(163402, '1.10.260.40-FF-000063', NULL, 'HTH-type transcriptional regulator prtR', 68, NULL, NULL, 163402),
(163403, '1.10.4020.10-FF-000007', NULL, 'Uncharacterized protein', 96, NULL, NULL, 163403),
(163404, '3.90.190.10-FF-000590', NULL, 'Uncharacterized protein', 271, NULL, NULL, 163404),
(163405, '3.30.505.10-FF-000128', NULL, 'Tyrosine-protein kinase', 113, NULL, NULL, 163405),
(163406, '3.40.50.720-FF-001035', NULL, 'Saccharopine dehydrogenase', 119, NULL, NULL, 163406),
(163407, '3.40.50.1820-FF-001504', NULL, 'Uncharacterized protein', 158, NULL, NULL, 163407),
(163408, '2.60.40.1460-FF-000004', NULL, 'integrin alpha-3 isoform X2', 141, NULL, NULL, 163408),
(163409, '3.40.50.300-FF-001792', NULL, 'Putative abc transporter', 250, NULL, NULL, 163409),
(163410, '3.40.1010.20-FF-000006', NULL, '4-hydroxy-3-methylbut-2-enyl diphosphate reductase, chloroplastic', 119, NULL, NULL, 163410),
(163411, '3.20.20.140-FF-000207', NULL, 'DNA polymerase III subunit alpha', 276, NULL, NULL, 163411),
(163412, '3.40.50.2000-FF-000620', NULL, 'Uncharacterized protein', 197, NULL, NULL, 163412),
(163413, '3.40.190.10-FF-000135', NULL, 'DNA-binding transcriptional regulator DsdC', 105, NULL, NULL, 163413),
(163414, '3.30.710.10-FF-000178', NULL, 'Armadillo/beta-catenin repeat family protein', 145, NULL, NULL, 163414),
(163415, '1.20.1070.10-FF-001519', NULL, 'Predicted protein', 191, NULL, NULL, 163415),
(163416, '2.60.40.60-FF-000339', NULL, 'Cadherin-related hmr-1', 118, NULL, NULL, 163416),
(163417, '3.30.420.40-FF-000535', NULL, 'Heat shock 70 kDa protein 1A', 157, NULL, NULL, 163417),
(163418, '1.10.10.350-FF-000037', NULL, NULL, 99, NULL, NULL, 163418),
(163419, '2.20.100.10-FF-000183', NULL, 'Thrombospondin type-1 domain-containing protein 7A', 49, NULL, NULL, 163419),
(163420, '3.30.810.10-FF-000011', NULL, 'Phosphoinositide kinase, putative', 141, NULL, NULL, 163420),
(163421, '3.30.420.40-FF-000799', NULL, 'Actin, epsilon 1', 52, NULL, NULL, 163421),
(163422, '1.25.40.10-FF-002010', NULL, 'Os12g0109800 protein', 132, NULL, NULL, 163422),
(163423, '2.40.160.120-FF-000065', NULL, 'Oxysterol-binding protein', 96, NULL, NULL, 163423),
(163424, '3.40.50.740-FF-000001', NULL, 'Periplasmic nitrate reductase', 267, NULL, NULL, 163424),
(163425, '1.25.10.10-FF-002093', NULL, 'Uncharacterized protein', 199, NULL, NULL, 163425),
(163426, '3.60.15.10-FF-000207', NULL, 'Uncharacterized protein', 53, NULL, NULL, 163426),
(163427, '1.50.10.10-FF-000084', NULL, 'Uncharacterized protein', 476, NULL, NULL, 163427),
(163428, '3.40.50.980-FF-000045', NULL, 'AMP dependent CoA ligase, putative', 92, NULL, NULL, 163428),
(163429, '3.40.50.2020-FF-000042', NULL, 'Putative ribose-phosphate pyrophosphokinase', 141, NULL, NULL, 163429),
(163430, '1.20.920.10-FF-000142', NULL, 'Putative polybromo 1', 139, NULL, NULL, 163430),
(163431, '3.40.50.11340-FF-000026', NULL, 'Uncharacterized protein', 59, NULL, NULL, 163431),
(163432, '3.90.190.10-FF-000438', NULL, 'Dual-specificity phosphatase 12', 57, NULL, NULL, 163432),
(163433, '3.40.50.720-FF-002171', NULL, 'Uncharacterized protein', 69, NULL, NULL, 163433),
(163434, '1.25.40.10-FF-002982', NULL, 'Pre-mRNA-splicing factor 6', 147, NULL, NULL, 163434),
(163435, '3.30.160.60-FF-004837', NULL, NULL, 73, NULL, NULL, 163435),
(163436, '2.40.50.140-FF-000567', NULL, 'Cold-shock DNA-binding domain containing protein, putative', 74, NULL, NULL, 163436),
(163437, '3.80.10.10-FF-001157', NULL, 'Leucine-rich receptor-like protein kinase family protein', 112, NULL, NULL, 163437),
(163438, '3.40.50.10490-FF-000029', NULL, 'RpiR family transcriptional regulator', 181, NULL, NULL, 163438),
(163439, '3.40.800.20-FF-000017', NULL, 'Histone deacetylase', 386, NULL, NULL, 163439),
(163440, '1.10.8.10-FF-000045', NULL, 'Putative FAS-associated factor 1', 45, NULL, NULL, 163440),
(163441, '2.60.40.150-FF-000434', NULL, 'Synaptotagmin XV', 118, NULL, NULL, 163441),
(163442, '3.40.50.2000-FF-000709', NULL, 'GM18614', 168, NULL, NULL, 163442),
(163443, '3.30.160.60-FF-002067', NULL, 'Zinc finger protein 6', 70, NULL, NULL, 163443);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(163444, '3.40.50.11260-FF-000036', NULL, 'Uncharacterized protein', 49, NULL, NULL, 163444),
(163445, '3.40.50.300-FF-006524', NULL, 'Uncharacterized protein', 110, NULL, NULL, 163445),
(163446, '1.20.144.10-FF-000080', NULL, 'Uncharacterized protein', 73, NULL, NULL, 163446),
(163447, '2.60.120.10-FF-000506', NULL, 'Protein kinase cGMP-dependent 1', 70, NULL, NULL, 163447),
(163448, '3.50.50.60-FF-000388', NULL, 'Probable monooxygenase', 200, NULL, NULL, 163448),
(163449, '1.25.40.10-FF-002274', NULL, 'U3 small nucleolar RNA-associated protein 6 isogeny', 178, NULL, NULL, 163449),
(163450, '3.30.420.10-FF-000431', NULL, NULL, 65, NULL, NULL, 163450),
(163451, '3.20.20.70-FF-000840', NULL, NULL, 95, NULL, NULL, 163451),
(163452, '2.130.10.10-FF-003787', NULL, 'Uncharacterized protein', 314, NULL, NULL, 163452),
(163453, '2.130.10.10-FF-003264', NULL, 'WD domain, G-beta repeat, putative', 189, NULL, NULL, 163453),
(163454, '3.30.70.330-FF-000817', NULL, 'Polyadenylate-binding protein 1', 64, NULL, NULL, 163454),
(163455, '3.10.450.10-FF-000038', NULL, 'Retinoic acid receptor responder (tazarotene-induced) 1', 99, NULL, NULL, 163455),
(163456, '1.10.1300.10-FF-000023', NULL, 'Phosphodiesterase', 328, NULL, NULL, 163456),
(163457, '1.10.510.10-FF-001574', NULL, 'Si:ch211-63o20.7', 219, NULL, NULL, 163457),
(163458, '3.30.200.60-FF-000002', NULL, 'ubiquitin thioesterase OTUB2 isoform X2', 78, NULL, NULL, 163458),
(163459, '3.30.160.430-FF-000002', NULL, NULL, 60, NULL, NULL, 163459),
(163460, '3.90.180.10-FF-000145', NULL, 'Uncharacterized protein', 196, NULL, NULL, 163460),
(163461, '2.60.120.10-FF-000006', NULL, 'cAMP-dependent protein kinase type I-alpha regulatory subunit', 145, NULL, NULL, 163461),
(163462, '2.30.39.10-FF-000024', NULL, 'Spn43Ac', 154, NULL, NULL, 163462),
(163463, '3.90.228.10-FF-000049', NULL, 'Poly [ADP-ribose] polymerase', 127, NULL, NULL, 163463),
(163464, '3.30.540.10-FF-000086', NULL, '3''(2''),5''-bisphosphate nucleotidase', 80, NULL, NULL, 163464),
(163465, '3.40.50.300-FF-001853', NULL, 'Dynamin family protein', 302, NULL, NULL, 163465),
(163466, '3.30.160.60-FF-003292', NULL, NULL, 23, NULL, NULL, 163466),
(163467, '1.10.30.10-FF-000120', NULL, 'protein polybromo-1 isoform X1', 97, NULL, NULL, 163467),
(163468, '4.10.240.10-FF-000018', NULL, 'Casein kinase II subunit beta', 80, NULL, NULL, 163468),
(163469, '3.40.640.10-FF-000389', NULL, 'Cobalamin biosynthetic protein CobC', 191, NULL, NULL, 163469),
(163470, '3.40.50.300-FF-001084', NULL, 'RecQ like helicase 4', 155, NULL, NULL, 163470),
(163471, '1.20.1070.10-FF-000238', NULL, 'Opsin-VA', 293, NULL, NULL, 163471),
(163472, '1.10.510.10-FF-000349', NULL, 'probable serine/threonine-protein kinase DDB_G0280111', 296, NULL, NULL, 163472),
(163473, '3.40.50.450-FF-000061', NULL, '6-phosphofructokinase', 196, NULL, NULL, 163473),
(163474, '3.40.470.10-FF-000033', NULL, NULL, 210, NULL, NULL, 163474),
(163475, '1.20.1280.50-FF-000148', NULL, 'Uncharacterized protein, isoform C', 88, NULL, NULL, 163475),
(163476, '1.10.8.140-FF-000004', NULL, 'DNA-binding protein PAE3044', 81, NULL, NULL, 163476),
(163477, '3.40.710.10-FF-000041', NULL, 'Penicillin-binding protein 1A', 346, NULL, NULL, 163477),
(163478, '3.40.50.300-FF-006463', NULL, 'Uncharacterized protein', 120, NULL, NULL, 163478),
(163479, '2.30.30.40-FF-000339', NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', 70, NULL, NULL, 163479),
(163480, '1.10.510.10-FF-000293', NULL, 'SRSF protein kinase 1', 282, NULL, NULL, 163480),
(163481, '2.130.10.10-FF-005973', NULL, 'Uncharacterized protein', 238, NULL, NULL, 163481),
(163482, '2.20.60.10-FF-000001', NULL, 'Pleiotrophin', 64, NULL, NULL, 163482),
(163483, '2.20.130.20-FF-000013', NULL, 'Thioester-containing protein 4, isoform D', 88, NULL, NULL, 163483),
(163484, '3.40.1350.10-FF-000046', NULL, 'tRNA-splicing endonuclease subunit SEN15', 106, NULL, NULL, 163484),
(163485, '1.10.8.10-FF-000106', NULL, 'Ubiquitin-associated protein', 62, NULL, NULL, 163485),
(163486, '3.40.50.1820-FF-000223', NULL, 'Lipase/serine esterase', 222, NULL, NULL, 163486);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(163487, '4.10.400.10-FF-000228', NULL, 'Serine protease nudel', 38, NULL, NULL, 163487),
(163488, '3.90.550.10-FF-000601', NULL, 'Uncharacterized protein', 223, NULL, NULL, 163488),
(163489, '3.30.160.60-FF-003348', NULL, 'ZFP90 zinc finger protein', 26, NULL, NULL, 163489),
(163490, '3.30.160.20-FF-000161', NULL, 'Ribonuclease 3', 82, NULL, NULL, 163490),
(163491, '3.30.70.330-FF-002150', NULL, NULL, 96, NULL, NULL, 163491),
(163492, '1.25.40.20-FF-000686', NULL, 'Oxysterol-binding protein', 88, NULL, NULL, 163492),
(163493, '3.30.2130.10-FF-000015', NULL, 'Aspartokinase', 151, NULL, NULL, 163493),
(163494, '3.10.20.90-FF-000279', NULL, 'Blast:Serine/threonine-protein kinase WNK3', 94, NULL, NULL, 163494),
(163495, '3.40.50.2000-FF-000356', NULL, 'Glycosyltransferase, group 1 family', 195, NULL, NULL, 163495),
(163496, '3.40.50.11660-FF-000004', NULL, 'Glycoprotein 3-alpha-L-fucosyltransferase A', 209, NULL, NULL, 163496),
(163497, '1.10.8.720-FF-000049', NULL, 'YALI0E32857p', 163, NULL, NULL, 163497),
(163498, '3.40.449.10-FF-000017', NULL, 'Predicted protein', 181, NULL, NULL, 163498),
(163499, '4.10.60.10-FF-000205', NULL, 'Nucleic acid binding protein, putative', 52, NULL, NULL, 163499),
(163500, '2.60.40.420-FF-000274', NULL, 'Plastocyanin-like domain-containing protein', 68, NULL, NULL, 163500),
(163501, '3.40.50.261-FF-000016', NULL, 'Acyl-CoA synthetase FdrA', 154, NULL, NULL, 163501),
(163502, '2.40.30.10-FF-000482', NULL, 'Predicted protein', 43, NULL, NULL, 163502),
(163503, '1.25.40.10-FF-002482', NULL, 'Os11g0587100 protein', 129, NULL, NULL, 163503),
(163504, '3.40.50.300-FF-003854', NULL, 'Uncharacterized protein', 240, NULL, NULL, 163504),
(163505, '3.30.160.60-FF-001903', NULL, 'Zinc finger protein 16', 29, NULL, NULL, 163505),
(163506, '3.30.40.10-FF-001419', NULL, 'HMG1/2 (High mobility group) box-containing protein', 79, NULL, NULL, 163506),
(163507, '2.40.160.110-FF-000028', NULL, 'Lysosomal-associated membrane protein 2', 165, NULL, NULL, 163507),
(163508, '1.20.120.1510-FF-000003', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 100, NULL, NULL, 163508),
(163509, '1.25.10.10-FF-001165', NULL, 'UvrB/uvrC_motif_containing_protein_-_putative', 247, NULL, NULL, 163509),
(163510, '3.40.50.300-FF-006316', NULL, 'Chromodomain-helicase-DNA-binding protein 3-like Protein', 33, NULL, NULL, 163510),
(163511, '1.20.1560.10-FF-000354', NULL, 'ABC a-pheromone efflux pump AtrD', 12, NULL, NULL, 163511),
(163512, '3.80.10.10-FF-002438', NULL, 'Leucine-rich repeat-containing 15', 143, NULL, NULL, 163512),
(163513, '1.25.40.20-FF-001203', NULL, 'Phosphocholine transferase AnkX', 106, NULL, NULL, 163513),
(163514, '3.40.50.1820-FF-001712', NULL, 'Uncharacterized protein', 143, NULL, NULL, 163514),
(163515, '2.10.50.10-FF-000113', NULL, 'Uncharacterized protein', 59, NULL, NULL, 163515),
(163516, '3.30.1320.10-FF-000024', NULL, 'Uncharacterized protein', 106, NULL, NULL, 163516),
(163517, '2.40.50.140-FF-000831', NULL, NULL, 164, NULL, NULL, 163517),
(163518, '2.70.20.10-FF-000002', NULL, 'DNA topoisomerase 1', 136, NULL, NULL, 163518),
(163519, '2.40.70.10-FF-000248', NULL, 'Uncharacterized protein', 124, NULL, NULL, 163519),
(163520, '3.30.160.60-FF-004629', NULL, NULL, 37, NULL, NULL, 163520),
(163521, '1.20.900.10-FF-000079', NULL, 'Obscurin', 72, NULL, NULL, 163521),
(163522, '3.90.1600.10-FF-000032', NULL, 'DNA polymerase zeta catalytic subunit, putative', 165, NULL, NULL, 163522),
(163523, '3.40.50.1010-FF-000278', NULL, NULL, 77, NULL, NULL, 163523),
(163524, '2.130.10.10-FF-003056', NULL, 'Uncharacterized protein', 138, NULL, NULL, 163524),
(163525, '2.130.10.10-FF-000330', NULL, 'Dynein, cytoplasmic 1, intermediate chain 2b', 185, NULL, NULL, 163525),
(163526, '3.70.10.10-FF-000106', NULL, 'DNA repair protein rad9, putative', 263, NULL, NULL, 163526),
(163527, '2.60.220.30-FF-000020', NULL, 'Ankyrin, isoform B', 170, NULL, NULL, 163527),
(163528, '3.30.830.10-FF-000333', NULL, 'Uncharacterized protein', 206, NULL, NULL, 163528),
(163529, '2.10.70.10-FF-000227', NULL, 'C-type LECtin', 66, NULL, NULL, 163529); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(163530, '3.30.420.40-FF-000327', NULL, 'Hsp70 family', 162, NULL, NULL, 163530),
(163531, '3.30.70.330-FF-001745', NULL, NULL, 132, NULL, NULL, 163531),
(163532, '1.10.287.70-FF-000352', NULL, 'Calcium channel, voltage-dependent, P/Q type, alpha 1A subunit, b', 120, NULL, NULL, 163532),
(163533, '1.20.120.610-FF-000018', NULL, 'V-atpase subunit', 130, NULL, NULL, 163533),
(163534, '2.60.200.40-FF-000055', NULL, 'Diacylglycerol kinase A', 186, NULL, NULL, 163534),
(163535, '3.30.200.20-FF-001474', NULL, 'Kinase, NEK', 38, NULL, NULL, 163535),
(163536, '3.30.200.20-FF-002194', NULL, 'Uncharacterized protein', 52, NULL, NULL, 163536),
(163537, '3.10.110.10-FF-000311', NULL, 'Protein CBG21481', 75, NULL, NULL, 163537),
(163538, '1.10.10.60-FF-000639', NULL, 'V-myb avian myeloblastosis viral oncogene homolog-like 2b', 57, NULL, NULL, 163538),
(163539, '4.10.460.10-FF-000001', NULL, 'Inositol polyphosphate 1-phosphatase', 47, NULL, NULL, 163539),
(163540, '3.90.70.10-FF-000305', NULL, 'GM20254', 319, NULL, NULL, 163540),
(163541, '3.30.70.1990-FF-000001', NULL, 'Amine oxidase, flavin-containing superfamily', 99, NULL, NULL, 163541),
(163542, '4.10.400.10-FF-000172', NULL, 'Low-density lipoprotein receptor-related protein', 37, NULL, NULL, 163542),
(163543, '2.60.40.10-FF-001246', NULL, 'Centrosomal protein of 192 kDa', 122, NULL, NULL, 163543),
(163544, '1.20.1250.20-FF-001121', NULL, 'Uncharacterized protein', 183, NULL, NULL, 163544),
(163545, '1.10.287.1040-FF-000004', NULL, 'Exodeoxyribonuclease 7 small subunit', 70, NULL, NULL, 163545),
(163546, '1.20.58.60-FF-000737', NULL, 'Predicted protein', 98, NULL, NULL, 163546),
(163547, '2.70.170.10-FF-000136', NULL, 'Uncharacterized protein', 136, NULL, NULL, 163547),
(163548, '3.30.450.260-FF-000011', NULL, 'Soluble guanylyl cyclase beta2 subunit', 78, NULL, NULL, 163548),
(163549, '1.10.510.10-FF-001782', NULL, 'Protein CBG12789', 336, NULL, NULL, 163549),
(163550, '3.40.50.150-FF-000914', NULL, NULL, 197, NULL, NULL, 163550),
(163551, '1.10.10.1590-FF-000004', NULL, 'Uncharacterized protein', 44, NULL, NULL, 163551),
(163552, '2.10.25.10-FF-001409', NULL, 'Uncharacterized protein', 39, NULL, NULL, 163552),
(163553, '3.40.50.300-FF-007952', NULL, 'Uncharacterized protein', 168, NULL, NULL, 163553),
(163554, '2.60.120.200-FF-000189', NULL, 'MAM domain containing 2', 160, NULL, NULL, 163554),
(163555, '3.30.70.1430-FF-000002', NULL, 'Efflux pump membrane transporter', 102, NULL, NULL, 163555),
(163556, '3.30.56.70-FF-000006', NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', 57, NULL, NULL, 163556),
(163557, '1.20.120.1900-FF-000058', NULL, 'Spindle pole body component', 280, NULL, NULL, 163557),
(163558, '3.10.260.20-FF-000004', NULL, 'V-ski avian sarcoma viral oncogene homolog b', 46, NULL, NULL, 163558),
(163559, '1.20.1090.10-FF-000037', NULL, '3-dehydroquinate synthase', 190, NULL, NULL, 163559),
(163560, '2.60.40.10-FF-000526', NULL, 'Contactin 1', 86, NULL, NULL, 163560),
(163561, '1.25.10.10-FF-002446', NULL, 'Hsp70 nucleotide exchange factor fes1', 232, NULL, NULL, 163561),
(163562, '3.40.640.10-FF-000125', NULL, 'Probable L-tyrosine/L-aspartate decarboxylase', 252, NULL, NULL, 163562),
(163563, '3.30.360.10-FF-000021', NULL, 'Acetaldehyde dehydrogenase', 154, NULL, NULL, 163563),
(163564, '1.10.10.10-FF-000265', NULL, 'Cell division control protein', 99, NULL, NULL, 163564),
(163565, '3.30.40.10-FF-000790', NULL, 'Uncharacterized protein', 82, NULL, NULL, 163565),
(163566, '1.10.238.10-FF-000749', NULL, 'Uncharacterized protein', 124, NULL, NULL, 163566),
(163567, '3.40.50.300-FF-004107', NULL, 'DNA helicase', 177, NULL, NULL, 163567),
(163568, '3.40.50.620-FF-000842', NULL, 'Asparagine synthetase', 276, NULL, NULL, 163568),
(163569, '2.60.40.60-FF-000991', NULL, 'Protein CBR-CDH-12', 105, NULL, NULL, 163569),
(163570, '1.25.40.10-FF-004691', NULL, 'Uncharacterized protein', 101, NULL, NULL, 163570),
(163571, '3.30.1490.20-FF-000044', NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta, mitochondrial', 97, NULL, NULL, 163571),
(163572, '1.10.510.10-FF-003839', NULL, NULL, 107, NULL, NULL, 163572);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(163573, '3.10.450.50-FF-000090', NULL, 'Nuclear transport factor 2 (NTF2) family protein', 127, NULL, NULL, 163573),
(163574, '3.50.50.60-FF-000591', NULL, 'Glycerol-3-phosphate dehydrogenase', 218, NULL, NULL, 163574),
(163575, '3.40.50.1000-FF-000365', NULL, 'Nuclear LIM interactor-interacting factor 1', 185, NULL, NULL, 163575),
(163576, '2.60.40.10-FF-001807', NULL, 'Roundabout 1, isoform A', 112, NULL, NULL, 163576),
(163577, '1.10.530.10-FF-000092', NULL, 'Uncharacterized protein', 131, NULL, NULL, 163577),
(163578, '3.30.70.100-FF-000069', NULL, 'Acylphosphatase', 91, NULL, NULL, 163578),
(163579, '1.25.10.10-FF-003374', NULL, 'Uncharacterized protein', 156, NULL, NULL, 163579),
(163580, '1.10.167.10-FF-000022', NULL, 'A-kinase anchor protein 10, mitochondrial', 183, NULL, NULL, 163580),
(163581, '6.20.240.60-FF-000001', NULL, 'Spore cortex-lytic enzyme', 36, NULL, NULL, 163581),
(163582, '3.30.70.1230-FF-000122', NULL, 'Adenylate cyclase 1', 214, NULL, NULL, 163582),
(163583, '1.10.287.110-FF-000393', NULL, 'DNAJ heat shock family protein', 62, NULL, NULL, 163583),
(163584, '3.20.200.10-FF-000001', NULL, 'Transient receptor potential cation channel, subfamily M, member 7', 106, NULL, NULL, 163584),
(163585, '1.20.58.830-FF-000034', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 144, NULL, NULL, 163585),
(163586, '3.40.50.720-FF-000990', NULL, 'SDR family oxidoreductase', 262, NULL, NULL, 163586),
(163587, '1.20.58.60-FF-000884', NULL, 'Uncharacterized protein', 262, NULL, NULL, 163587),
(163588, '1.10.405.10-FF-000043', NULL, 'Gll0991 protein', 21, NULL, NULL, 163588),
(163589, '2.60.40.10-FF-002735', NULL, 'Cysteine protease', 93, NULL, NULL, 163589),
(163590, '3.40.30.10-FF-001132', NULL, 'Os01g0949750 protein', 74, NULL, NULL, 163590),
(163591, '3.30.530.20-FF-000206', NULL, 'Predicted protein', 156, NULL, NULL, 163591),
(163592, '1.25.10.10-FF-000237', NULL, 'Pumilio homolog 9', 331, NULL, NULL, 163592),
(163593, '1.10.1060.10-FF-000015', NULL, 'Cytochrome c oxidase accessory protein CcoG', 71, NULL, NULL, 163593),
(163594, '1.25.40.990-FF-000056', NULL, 'Uncharacterized protein', 227, NULL, NULL, 163594),
(163595, '3.40.50.620-FF-000134', NULL, 'L-cysteine:1D-myo-inositol 2-amino-2-deoxy-alpha-D-glucopyranoside ligase', 326, NULL, NULL, 163595),
(163596, '2.40.10.310-FF-000003', NULL, 'Uncharacterized protein', 60, NULL, NULL, 163596),
(163597, '3.40.630.30-FF-000607', NULL, 'Uncharacterized protein', 208, NULL, NULL, 163597),
(163598, '1.25.40.10-FF-003763', NULL, 'Uncharacterized protein', 163, NULL, NULL, 163598),
(163599, '1.10.1140.10-FF-000016', NULL, 'ATP synthase subunit beta', 37, NULL, NULL, 163599),
(163600, '2.170.16.10-FF-000044', NULL, 'DNA topoisomerase 1', 123, NULL, NULL, 163600),
(163601, '3.30.70.60-FF-000020', NULL, 'Unplaced genomic scaffold supercont1.170, whole genome shotgun sequence', 122, NULL, NULL, 163601),
(163602, '3.30.160.60-FF-000622', NULL, 'zinc finger protein 26 isoform X3', 34, NULL, NULL, 163602),
(163603, '3.40.1110.10-FF-000213', NULL, 'CU (Copper) ATPase', 180, NULL, NULL, 163603),
(163604, '1.10.8.60-FF-000419', NULL, 'Replication factor C subunit 2/4', 63, NULL, NULL, 163604),
(163605, '3.30.2130.30-FF-000026', NULL, 'Predicted protein', 107, NULL, NULL, 163605),
(163606, '3.30.9.10-FF-000077', NULL, 'Putative malatequinone oxidoreductase protein', 162, NULL, NULL, 163606),
(163607, '1.10.287.410-FF-000005', NULL, 'Carboxypeptidase', 72, NULL, NULL, 163607),
(163608, '3.40.50.300-FF-005035', NULL, 'ABC transporter family protein', 166, NULL, NULL, 163608),
(163609, '3.90.1030.20-FF-000013', NULL, NULL, 123, NULL, NULL, 163609),
(163610, '1.10.10.10-FF-001193', NULL, 'Uncharacterized protein', 71, NULL, NULL, 163610),
(163611, '1.20.58.340-FF-000039', NULL, 'Magnesium/cobalt transporter CorA', 58, NULL, NULL, 163611),
(163612, '2.40.50.100-FF-000050', NULL, 'Exosome complex component rrp4 protein', 56, NULL, NULL, 163612),
(163613, '3.10.180.20-FF-000003', NULL, 'GLYcosylation related', 77, NULL, NULL, 163613),
(163614, '1.20.1260.10-FF-000073', NULL, 'Ferritin', 180, NULL, NULL, 163614);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(163615, '3.30.420.10-FF-000167', NULL, 'Ribonuclease HII', 209, NULL, NULL, 163615),
(163616, '3.40.630.10-FF-000040', NULL, 'zinc carboxypeptidase', 306, NULL, NULL, 163616),
(163617, '3.40.50.2300-FF-001401', NULL, NULL, 122, NULL, NULL, 163617),
(163618, '6.10.140.2220-FF-000048', NULL, 'GM24612', 53, NULL, NULL, 163618),
(163619, '3.30.450.20-FF-000205', NULL, 'Hypoxia-inducible factor 1', 131, NULL, NULL, 163619),
(163620, '1.10.60.10-FF-000004', NULL, 'DtxR family transcriptional regulator', 64, NULL, NULL, 163620),
(163621, '1.10.287.80-FF-000001', NULL, 'ATP synthase gamma chain', 60, NULL, NULL, 163621),
(163622, '3.30.420.270-FF-000031', NULL, 'Sll0479 protein', 69, NULL, NULL, 163622),
(163623, '1.10.3730.10-FF-000011', NULL, 'Pyrroline-5-carboxylate reductase 3', 107, NULL, NULL, 163623),
(163624, '3.30.160.60-FF-002831', NULL, 'Zinc finger protein 36', 55, NULL, NULL, 163624),
(163625, '1.10.472.80-FF-000196', NULL, NULL, 148, NULL, NULL, 163625),
(163626, '3.40.50.300-FF-007244', NULL, 'Uncharacterized protein', 160, NULL, NULL, 163626),
(163627, '2.60.40.290-FF-000010', NULL, 'Putative secreted cellulase', 108, NULL, NULL, 163627),
(163628, '2.30.30.1020-FF-000020', NULL, 'CCR4/NOT transcription complex subunit 3, putative', 185, NULL, NULL, 163628),
(163629, '3.30.460.10-FF-000085', NULL, 'DNA polymerase', 120, NULL, NULL, 163629),
(163630, '3.30.565.10-FF-000345', NULL, 'Phytochrome-like protein', 181, NULL, NULL, 163630),
(163631, '3.30.930.10-FF-000397', NULL, 'Uncharacterized protein', 127, NULL, NULL, 163631),
(163632, '1.25.40.10-FF-001554', NULL, 'Predicted protein', 104, NULL, NULL, 163632),
(163633, '3.90.870.10-FF-000029', NULL, 'Glr3274 protein', 205, NULL, NULL, 163633),
(163634, '3.40.50.720-FF-000838', NULL, 'Glyoxylate reductase, putative', 125, NULL, NULL, 163634),
(163635, '3.10.196.10-FF-000014', NULL, 'Uncharacterized protein', 150, NULL, NULL, 163635),
(163636, '3.30.40.10-FF-000082', NULL, 'Polycomb group ring finger 2', 108, NULL, NULL, 163636),
(163637, '4.10.280.10-FF-000139', NULL, 'Clockwork orange, isoform B', 43, NULL, NULL, 163637),
(163638, '3.40.630.30-FF-000046', NULL, 'Dopamine N-acetyltransferase', 217, NULL, NULL, 163638),
(163639, '3.40.50.300-FF-000364', NULL, 'ATP-dependent RNA helicase DDX6', 224, NULL, NULL, 163639),
(163640, '3.30.70.20-FF-000120', NULL, NULL, 96, NULL, NULL, 163640),
(163641, '1.20.930.40-FF-000011', NULL, 'Tre2p', 157, NULL, NULL, 163641),
(163642, '2.10.90.10-FF-000026', NULL, 'Nodal homolog 3-A', 113, NULL, NULL, 163642),
(163643, '2.60.120.330-FF-000177', NULL, 'Uncharacterized protein', 231, NULL, NULL, 163643),
(163644, '3.30.450.20-FF-000469', NULL, 'PAS domain-containing protein', 56, NULL, NULL, 163644),
(163645, '1.10.287.1060-FF-000015', NULL, 'SNF7 family protein', 78, NULL, NULL, 163645),
(163646, '3.30.559.10-FF-000224', NULL, 'Protein CBG13268', 178, NULL, NULL, 163646),
(163647, '2.130.10.10-FF-004692', NULL, 'Uncharacterized protein', 176, NULL, NULL, 163647),
(163648, '3.30.160.60-FF-000886', NULL, 'zinc finger protein 64 isoform X1', 29, NULL, NULL, 163648),
(163649, '3.10.20.90-FF-000015', NULL, 'B-Raf proto-oncogene serine/threonine-protein kinase', 82, NULL, NULL, 163649),
(163650, '3.40.50.300-FF-005299', NULL, 'YALI0F09009p', 287, NULL, NULL, 163650),
(163651, '3.80.10.10-FF-004271', NULL, 'Si:ch211-156p11.1', 54, NULL, NULL, 163651),
(163652, '3.40.50.300-FF-002573', NULL, 'Pre-mRNA-splicing factor', 334, NULL, NULL, 163652),
(163653, '2.10.270.10-FF-000011', NULL, 'Dextransucrase', 63, NULL, NULL, 163653),
(163654, '3.40.190.80-FF-000083', NULL, 'Monophosphatase', 113, NULL, NULL, 163654),
(163655, '3.60.20.10-FF-000068', NULL, 'NAD(P)H-dependent glutamate synthase, putative', 196, NULL, NULL, 163655),
(163656, '1.10.3080.10-FF-000045', NULL, 'Chloride channel protein', 505, NULL, NULL, 163656),
(163657, '1.10.287.820-FF-000010', NULL, NULL, 81, NULL, NULL, 163657),
(163658, '2.40.170.20-FF-000005', NULL, 'TonB-dependent siderophore receptor', 525, NULL, NULL, 163658),
(163659, '1.10.1420.10-FF-000173', NULL, 'Uncharacterized protein', 56, NULL, NULL, 163659);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(163660, '2.40.20.10-FF-000037', NULL, 'Uncharacterized protein', 77, NULL, NULL, 163660),
(163661, '3.40.30.10-FF-000120', NULL, 'Thioredoxin family protein', 84, NULL, NULL, 163661),
(163662, '2.60.40.10-FF-002651', NULL, 'Hibris, isoform B', 94, NULL, NULL, 163662),
(163663, '3.40.50.2300-FF-000884', NULL, NULL, 166, NULL, NULL, 163663),
(163664, '1.25.10.10-FF-001434', NULL, 'Related to yeast Vacuolar Protein Sorting factor', 187, NULL, NULL, 163664),
(163665, '3.40.50.200-FF-000188', NULL, 'Uncharacterized protein', 107, NULL, NULL, 163665),
(163666, '3.40.50.2300-FF-000412', NULL, 'Glutamate receptor', 163, NULL, NULL, 163666),
(163667, '2.60.120.260-FF-000364', NULL, 'Endo-1,4-beta-xylanase A', 158, NULL, NULL, 163667),
(163668, '3.40.50.1910-FF-000014', NULL, 'Vacuolar protein sorting 33', 194, NULL, NULL, 163668),
(163669, '3.40.30.10-FF-000592', NULL, 'Uncharacterized protein', 90, NULL, NULL, 163669),
(163670, '2.10.110.10-FF-000354', NULL, 'ISL LIM homeobox 2', 11, NULL, NULL, 163670),
(163671, '3.20.20.140-FF-000354', NULL, 'N-acetylglucosamine-6-phosphate deacetylase NAGA', 301, NULL, NULL, 163671),
(163672, '1.10.287.110-FF-000421', NULL, 'Uncharacterized protein', 149, NULL, NULL, 163672),
(163673, '3.40.50.2300-FF-000356', NULL, 'DNA-binding response regulator', 79, NULL, NULL, 163673),
(163674, '3.30.160.60-FF-001139', NULL, 'zinc finger protein 202 isoform X1', 30, NULL, NULL, 163674),
(163675, '2.60.210.10-FF-000013', NULL, 'TRAF-like family protein', 145, NULL, NULL, 163675),
(163676, '3.10.20.90-FF-000695', NULL, 'YALI0D13046p', 76, NULL, NULL, 163676),
(163677, '3.40.50.1370-FF-000009', NULL, 'Ornithine carbamoyltransferase, mitochondrial', 159, NULL, NULL, 163677),
(163678, '2.20.25.420-FF-000006', NULL, 'Zn finger containing protein', 52, NULL, NULL, 163678),
(163679, '3.40.50.300-FF-008469', NULL, 'ABC transporter, putative', 241, NULL, NULL, 163679),
(163680, '1.20.1070.10-FF-000946', NULL, 'AGAP001774-PA', 172, NULL, NULL, 163680),
(163681, '1.20.1070.10-FF-001935', NULL, 'Uncharacterized protein', 256, NULL, NULL, 163681),
(163682, '1.25.40.10-FF-002038', NULL, 'Putative pentatricopeptide repeat-containing protein At5g08490', 134, NULL, NULL, 163682),
(163683, '3.30.710.10-FF-000150', NULL, 'Potassium channel tetramerization domain containing 14', 78, NULL, NULL, 163683),
(163684, '2.60.220.50-FF-000003', NULL, 'adhesion G-protein coupled receptor G2 isoform X2', 182, NULL, NULL, 163684),
(163685, '3.40.50.1820-FF-000931', NULL, 'Homoserine O-acetyltransferase', 360, NULL, NULL, 163685),
(163686, '3.80.10.10-FF-001073', NULL, 'Leucine rich repeats and IQ motif containing 1', 108, NULL, NULL, 163686),
(163687, '3.60.15.10-FF-000123', NULL, 'Metallo-beta-lactamase domain containing protein', 261, NULL, NULL, 163687),
(163688, '3.40.50.880-FF-000077', NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', 230, NULL, NULL, 163688),
(163689, '1.10.510.10-FF-003755', NULL, NULL, 142, NULL, NULL, 163689),
(163690, '3.30.565.10-FF-000429', NULL, 'Hybrid signal transduction histidine kinase J', 165, NULL, NULL, 163690),
(163691, '3.40.50.1820-FF-001443', NULL, 'Uncharacterized protein', 188, NULL, NULL, 163691),
(163692, '2.130.10.10-FF-002303', NULL, 'WD repeat-containing protein 73', 374, NULL, NULL, 163692),
(163693, '2.30.30.140-FF-000195', NULL, 'SGF29 tudor-like domain-domain-containing protein', 54, NULL, NULL, 163693),
(163694, '3.30.160.60-FF-006462', NULL, NULL, 56, NULL, NULL, 163694),
(163695, '3.40.50.10330-FF-000061', NULL, 'GM18115', 124, NULL, NULL, 163695),
(163696, '1.10.10.10-FF-001810', NULL, 'Predicted protein', 63, NULL, NULL, 163696),
(163697, '2.40.50.140-FF-000331', NULL, 'Nucleoporin NUP116/NSP116', 173, NULL, NULL, 163697),
(163698, '3.40.630.30-FF-000310', NULL, 'Acteyltransferase GNAT family', 155, NULL, NULL, 163698),
(163699, '3.10.320.10-FF-000001', NULL, 'HLA class II histocompatibility antigen, DRB1-1 beta chain', 111, NULL, NULL, 163699),
(163700, '1.10.357.150-FF-000011', NULL, 'Uncharacterized protein', 138, NULL, NULL, 163700);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(163701, '1.10.8.50-FF-000034', NULL, 'Uncharacterized protein', 63, NULL, NULL, 163701),
(163702, '3.40.50.10190-FF-000237', NULL, 'Uncharacterized protein', 54, NULL, NULL, 163702),
(163703, '1.25.10.10-FF-001873', NULL, 'Slr1098 protein', 139, NULL, NULL, 163703),
(163704, '1.20.120.350-FF-000098', NULL, 'Calcium channel subunit Cch1', 117, NULL, NULL, 163704),
(163705, '3.20.20.70-FF-000071', NULL, 'Hydroxymethylglutaryl-CoA lyase', 299, NULL, NULL, 163705),
(163706, '2.120.10.30-FF-000213', NULL, 'Tricorn protease homolog', 91, NULL, NULL, 163706),
(163707, '2.130.10.10-FF-005265', NULL, 'Uncharacterized protein', 258, NULL, NULL, 163707),
(163708, '3.80.10.10-FF-002590', NULL, 'Uncharacterized protein', 90, NULL, NULL, 163708),
(163709, '3.50.50.60-FF-000888', NULL, 'Uncharacterized protein', 254, NULL, NULL, 163709),
(163710, '3.40.50.2000-FF-000856', NULL, 'Chalcone 4''-O-glucosyltransferase', 228, NULL, NULL, 163710),
(163711, '1.10.510.10-FF-002030', NULL, 'Tau TuBulin Kinase', 346, NULL, NULL, 163711),
(163712, '3.40.50.410-FF-000133', NULL, 'Protein transport protein Sec24C, putative', 238, NULL, NULL, 163712),
(163713, '2.130.10.10-FF-003287', NULL, 'Kinesin-related protein 8', 271, NULL, NULL, 163713),
(163714, '3.30.710.10-FF-000094', NULL, 'Armadillo repeat containing 5', 143, NULL, NULL, 163714),
(163715, '3.30.70.330-FF-000317', NULL, 'Rox8, isoform B', 100, NULL, NULL, 163715),
(163716, '3.40.390.10-FF-000088', NULL, 'Uncharacterized protein', 238, NULL, NULL, 163716),
(163717, '1.20.1280.50-FF-000125', NULL, 'Predicted protein', 48, NULL, NULL, 163717),
(163718, '3.40.850.10-FF-000079', NULL, 'Probable chitin synthase', 35, NULL, NULL, 163718),
(163719, '3.80.10.10-FF-002854', NULL, 'Uncharacterized protein', 159, NULL, NULL, 163719),
(163720, '1.20.120.420-FF-000023', NULL, 'Methylthioribose-1-phosphate isomerase-like Protein', 94, NULL, NULL, 163720),
(163721, '3.40.50.970-FF-000132', NULL, '2-oxoisovalerate dehydrogenase, E1 component, alpha and beta subunit', 195, NULL, NULL, 163721),
(163722, '3.30.160.60-FF-002623', NULL, 'Zinc finger protein 422, related sequence 1', 31, NULL, NULL, 163722),
(163723, '1.20.1560.10-FF-000910', NULL, 'ABC transporter B family member 29 chloroplastic', 151, NULL, NULL, 163723),
(163724, '3.50.50.60-FF-000944', NULL, 'Uncharacterized protein', 97, NULL, NULL, 163724),
(163725, '2.40.160.10-FF-000030', NULL, 'Outer membrane protein, putative', 310, NULL, NULL, 163725),
(163726, '3.30.40.10-FF-001863', NULL, 'Predicted protein', 79, NULL, NULL, 163726),
(163727, '1.20.58.390-FF-000301', NULL, 'AcetylCholine Receptor', 76, NULL, NULL, 163727),
(163728, '2.40.240.10-FF-000031', NULL, '50S ribosomal protein L25', 91, NULL, NULL, 163728),
(163729, '3.10.110.10-FF-000283', NULL, 'Uncharacterized protein', 120, NULL, NULL, 163729),
(163730, '3.40.50.880-FF-000133', NULL, 'Predicted protein', 226, NULL, NULL, 163730),
(163731, '1.25.40.20-FF-000006', NULL, 'Arf-GAP with SH3 domain, ANK repeat and PH domain-containing protein 2', 140, NULL, NULL, 163731),
(163732, '3.90.550.10-FF-000657', NULL, 'Glycoside transferase family 2', 126, NULL, NULL, 163732),
(163733, '3.90.1260.10-FF-000016', NULL, 'Uncharacterized protein', 167, NULL, NULL, 163733),
(163734, '1.10.238.210-FF-000014', NULL, 'Uncharacterized protein', 84, NULL, NULL, 163734),
(163735, '3.90.1180.10-FF-000015', NULL, '60S ribosomal protein L13a isoform X2', 67, NULL, NULL, 163735),
(163736, '1.10.286.10-FF-000006', NULL, 'GTP cyclohydrolase 1', 48, NULL, NULL, 163736),
(163737, '3.40.190.10-FF-000904', NULL, 'Periplasmic substrate-binding histidine kinase', 95, NULL, NULL, 163737),
(163738, '3.40.50.2300-FF-001345', NULL, NULL, 70, NULL, NULL, 163738),
(163739, '1.10.590.10-FF-000005', NULL, 'Chorismate mutase1', 127, NULL, NULL, 163739),
(163740, '3.40.50.300-FF-000448', NULL, 'RAB3D, member RAS oncogene family', 186, NULL, NULL, 163740),
(163741, '2.130.10.10-FF-001050', NULL, 'Predicted protein', 98, NULL, NULL, 163741),
(163742, '2.40.10.10-FF-000216', NULL, 'Chymase 1', 18, NULL, NULL, 163742);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(163743, '1.10.287.2620-FF-000017', NULL, 'Dynein heavy chain, putative', 67, NULL, NULL, 163743),
(163744, '1.25.40.790-FF-000024', NULL, 'Uncharacterized protein', 129, NULL, NULL, 163744),
(163745, '3.50.50.60-FF-001405', NULL, 'Sarcosine oxidase, alpha subunit', 161, NULL, NULL, 163745),
(163746, '3.40.630.30-FF-000254', NULL, 'Ribosomal-protein-S18p-alanine acetyltransferase', 152, NULL, NULL, 163746),
(163747, '3.90.176.10-FF-000006', NULL, 'RNA polymerase ADP-ribosylase', 139, NULL, NULL, 163747),
(163748, '2.60.40.10-FF-003163', NULL, NULL, 98, NULL, NULL, 163748),
(163749, '1.20.120.350-FF-000154', NULL, NULL, 111, NULL, NULL, 163749),
(163750, '1.20.900.10-FF-000051', NULL, 'Phosphatidylinositol-3,4,5-trisphosphate dependent Rac exchange factor 1', 69, NULL, NULL, 163750),
(163751, '3.10.20.90-FF-000223', NULL, 'Transcription initiation factor TFIID subunit 1', 91, NULL, NULL, 163751),
(163752, '1.10.287.3810-FF-000003', NULL, 'Uncharacterized protein', 51, NULL, NULL, 163752),
(163753, '1.50.40.10-FF-000181', NULL, 'Mitochondrial folate transporter/carrier', 210, NULL, NULL, 163753),
(163754, '3.30.460.20-FF-000026', NULL, 'Divalent cation transporter', 121, NULL, NULL, 163754),
(163755, '3.30.160.60-FF-000678', NULL, 'Myoneurin isoform X1', 28, NULL, NULL, 163755),
(163756, '3.40.50.720-FF-002255', NULL, 'Uncharacterized protein', 62, NULL, NULL, 163756),
(163757, '3.40.50.10090-FF-000033', NULL, 'Tetrapyrrole biosynthesis, uroporphyrinogen III synthase', 127, NULL, NULL, 163757),
(163758, '3.20.80.10-FF-000017', NULL, 'Uncharacterized protein', 181, NULL, NULL, 163758),
(163759, '1.50.40.10-FF-000029', NULL, 'Solute carrier family 25 member 28', 205, NULL, NULL, 163759),
(163760, '3.30.830.10-FF-000097', NULL, 'Zn-dependent peptidase, putative', 240, NULL, NULL, 163760),
(163761, '2.60.40.10-FF-003899', NULL, NULL, 96, NULL, NULL, 163761),
(163762, '3.30.230.10-FF-000012', NULL, 'DNA topoisomerase 4 subunit B', 174, NULL, NULL, 163762),
(163763, '2.60.410.10-FF-000017', NULL, NULL, 86, NULL, NULL, 163763),
(163764, '3.20.20.80-FF-000225', NULL, 'Protein PslG', 316, NULL, NULL, 163764),
(163765, '1.10.8.1220-FF-000034', NULL, NULL, 92, NULL, NULL, 163765),
(163766, '1.25.10.10-FF-000092', NULL, 'apoptosis inhibitor 5 isoform X2', 304, NULL, NULL, 163766),
(163767, '3.40.50.150-FF-001786', NULL, NULL, 175, NULL, NULL, 163767),
(163768, '1.20.58.70-FF-000038', NULL, 'Unplaced genomic scaffold supercont1.17, whole genome shotgun sequence', 125, NULL, NULL, 163768),
(163769, '3.30.60.30-FF-000151', NULL, 'KAZ1-type serine protease inhibitor-like protein type epsilon', 61, NULL, NULL, 163769),
(163770, '1.20.1070.10-FF-001082', NULL, 'Uncharacterized protein', 324, NULL, NULL, 163770),
(163771, '3.30.160.60-FF-003612', NULL, 'Pre-mRNA splicing factor Prp8', 65, NULL, NULL, 163771),
(163772, '3.40.50.300-FF-000072', NULL, 'Transcription termination factor Rho', 290, NULL, NULL, 163772),
(163773, '1.20.120.1080-FF-000008', NULL, 'probable ATP-dependent RNA helicase YTHDC2', 103, NULL, NULL, 163773),
(163774, '3.40.50.1460-FF-000008', NULL, 'caspase-8 isoform X1', 256, NULL, NULL, 163774),
(163775, '1.10.10.60-FF-000403', NULL, 'Transcription repressor MYB4', 67, NULL, NULL, 163775),
(163776, '1.10.730.10-FF-000101', NULL, 'Isoleucine--tRNA ligase protein', 183, NULL, NULL, 163776),
(163777, '2.120.10.10-FF-000027', NULL, 'Predicted protein', 211, NULL, NULL, 163777),
(163778, '3.30.1330.90-FF-000008', NULL, 'L-serine dehydratase', 148, NULL, NULL, 163778),
(163779, '2.60.40.1250-FF-000003', NULL, 'Thiol:disulfide interchange protein DsbD', 124, NULL, NULL, 163779),
(163780, '1.10.630.10-FF-000829', NULL, 'Os06g0267400 protein', 207, NULL, NULL, 163780),
(163781, '2.60.40.1180-FF-000162', NULL, 'Alpha-D-1,4-glucosidase', 66, NULL, NULL, 163781),
(163782, '3.40.30.10-FF-000968', NULL, 'Thioredoxin domain containing 8', 98, NULL, NULL, 163782),
(163783, '1.20.58.1780-FF-000025', NULL, 'Nuclear pore complex protein NUP155', 167, NULL, NULL, 163783),
(163784, '2.60.470.10-FF-000026', NULL, 'FLR-1', 177, NULL, NULL, 163784);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(163785, '3.40.50.300-FF-002865', NULL, 'DNA-binding protein MutS2', 189, NULL, NULL, 163785),
(163786, '3.40.50.150-FF-000858', NULL, 'Hypothetical_protein_-_conserved', 248, NULL, NULL, 163786),
(163787, '3.30.60.20-FF-000119', NULL, 'AGAP005583-PA', 83, NULL, NULL, 163787),
(163788, '3.40.50.11060-FF-000009', NULL, 'GTPase HflX', 97, NULL, NULL, 163788),
(163789, '2.130.10.10-FF-004720', NULL, 'Uncharacterized protein', 167, NULL, NULL, 163789),
(163790, '3.30.160.60-FF-000206', NULL, 'zinc finger protein 202 isoform X1', 28, NULL, NULL, 163790),
(163791, '1.10.20.10-FF-000058', NULL, 'Histone H4', 99, NULL, NULL, 163791),
(163792, '2.60.290.11-FF-000002', NULL, 'N-acetylmuramoyl-L-alanine amidase family 2', 104, NULL, NULL, 163792),
(163793, '1.10.287.70-FF-000436', NULL, 'Protein CBR-TWK-47', 190, NULL, NULL, 163793),
(163794, '3.80.10.10-FF-002910', NULL, 'Uncharacterized protein', 218, NULL, NULL, 163794),
(163795, '3.40.50.1580-FF-000050', NULL, 'Uncharacterized protein', 157, NULL, NULL, 163795),
(163796, '1.10.510.10-FF-001338', NULL, 'Uncharacterized protein', 340, NULL, NULL, 163796),
(163797, '1.10.220.120-FF-000003', NULL, NULL, 63, NULL, NULL, 163797),
(163798, '1.20.1250.20-FF-001885', NULL, 'SLC (SoLute Carrier) homolog', 92, NULL, NULL, 163798),
(163799, '1.20.5.110-FF-000111', NULL, 'GH06387p', 100, NULL, NULL, 163799),
(163800, '3.20.20.80-FF-000753', NULL, 'Uncharacterized protein', 49, NULL, NULL, 163800),
(163801, '3.40.50.720-FF-002199', NULL, 'Uncharacterized protein', 318, NULL, NULL, 163801),
(163802, '3.40.1180.10-FF-000015', NULL, 'Diterpene synthase', 255, NULL, NULL, 163802),
(163803, '2.60.40.150-FF-000373', NULL, 'Phosphatidylinositol 3-kinase VPS34', 151, NULL, NULL, 163803),
(163804, '3.30.830.10-FF-000041', NULL, 'Protease 3', 230, NULL, NULL, 163804),
(163805, '3.40.50.150-FF-001842', NULL, NULL, 51, NULL, NULL, 163805),
(163806, '1.20.1270.280-FF-000010', NULL, 'Dynein heavy chain', 168, NULL, NULL, 163806),
(163807, '4.10.1000.10-FF-000127', NULL, 'Uncharacterized protein', 40, NULL, NULL, 163807),
(163808, '1.10.10.1760-FF-000016', NULL, 'Uncharacterized protein', 110, NULL, NULL, 163808),
(163809, '3.40.1160.10-FF-000008', NULL, 'Acetylglutamate kinase', 258, NULL, NULL, 163809),
(163810, '3.40.50.10860-FF-000045', NULL, 'Repressor protein', 93, NULL, NULL, 163810),
(163811, '2.40.30.10-FF-000302', NULL, 'G1 to S phase transition protein 1, putative', 89, NULL, NULL, 163811),
(163812, '3.30.1460.50-FF-000023', NULL, 'Autophagy-related protein 3', 150, NULL, NULL, 163812),
(163813, '3.90.190.10-FF-000202', NULL, 'Protein tyrosine phosphatase Pps1, putative', 112, NULL, NULL, 163813),
(163814, '1.25.40.10-FF-004983', NULL, 'Tetratricopeptide repeat domain 21A', 140, NULL, NULL, 163814),
(163815, '3.30.410.40-FF-000001', NULL, 'Choline oxidase (CodA)', 191, NULL, NULL, 163815),
(163816, '2.130.10.10-FF-002775', NULL, 'Angio-associated, migratory cell protein', 223, NULL, NULL, 163816),
(163817, '3.30.565.10-FF-000053', NULL, 'DNA topoisomerase 6 subunit B', 235, NULL, NULL, 163817),
(163818, '3.30.365.10-FF-000009', NULL, 'Aldehyde oxidase', 190, NULL, NULL, 163818),
(163819, '1.10.10.440-FF-000064', NULL, 'Transcription elongation regulator', 83, NULL, NULL, 163819),
(163820, '1.10.472.80-FF-000224', NULL, NULL, 123, NULL, NULL, 163820),
(163821, '3.30.160.60-FF-004101', NULL, NULL, 61, NULL, NULL, 163821),
(163822, '3.30.160.60-FF-001791', NULL, 'Zinc finger protein 766', 29, NULL, NULL, 163822),
(163823, '3.30.1330.30-FF-000036', NULL, 'Putative 60s ribosomal protein L7a', 185, NULL, NULL, 163823),
(163824, '1.20.1270.280-FF-000066', NULL, 'Uncharacterized protein', 139, NULL, NULL, 163824),
(163825, '3.30.70.330-FF-001245', NULL, 'nuclear receptor coactivator 5 isoform X2', 97, NULL, NULL, 163825),
(163826, '1.20.58.2050-FF-000005', NULL, 'CG2222-PA', 165, NULL, NULL, 163826),
(163827, '2.160.10.10-FF-000110', NULL, 'Uncharacterized protein', 141, NULL, NULL, 163827),
(163828, '3.30.40.10-FF-001335', NULL, 'NEP1-interacting protein-like 2', 86, NULL, NULL, 163828);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(163829, '2.60.200.20-FF-000044', NULL, 'Chromosome 8, whole genome shotgun sequence', 95, NULL, NULL, 163829),
(163830, '2.60.40.10-FF-004888', NULL, NULL, 105, NULL, NULL, 163830),
(163831, '3.30.70.2450-FF-000004', NULL, 'Octylphenol 4-monooxygenase', 92, NULL, NULL, 163831),
(163832, '3.10.120.10-FF-000053', NULL, 'Predicted protein', 63, NULL, NULL, 163832),
(163833, '3.80.10.10-FF-001926', NULL, 'Disease resistance protein RGA5', 367, NULL, NULL, 163833),
(163834, '2.40.300.10-FF-000002', NULL, 'Preneck appendage protein', 121, NULL, NULL, 163834),
(163835, '2.60.40.60-FF-000311', NULL, 'Kugelei, isoform E', 104, NULL, NULL, 163835),
(163836, '2.40.50.90-FF-000198', NULL, 'Suppressor of fused homolog-like Protein', 40, NULL, NULL, 163836),
(163837, '3.80.10.10-FF-003490', NULL, 'AGAP007465-PA', 201, NULL, NULL, 163837),
(163838, '1.20.1560.10-FF-000854', NULL, 'Predicted protein', 254, NULL, NULL, 163838),
(163839, '1.10.150.20-FF-000279', NULL, 'Uncharacterized protein', 69, NULL, NULL, 163839),
(163840, '3.30.1330.10-FF-000030', NULL, 'Selenophosphate synthetase 2, isoform C', 140, NULL, NULL, 163840),
(163841, '3.30.200.20-FF-001974', NULL, 'Mitogen-activated protein kinase', 102, NULL, NULL, 163841),
(163842, '1.10.565.10-FF-000172', NULL, 'Uncharacterized protein', 175, NULL, NULL, 163842),
(163843, '3.20.20.220-FF-000075', NULL, 'Methylenetetrahydrofolate reductase', 297, NULL, NULL, 163843),
(163844, '3.40.30.10-FF-000912', NULL, 'Thioredoxin fold domain-containing protein', 131, NULL, NULL, 163844),
(163845, '3.30.200.20-FF-002014', NULL, 'Uncharacterized protein', 94, NULL, NULL, 163845),
(163846, '3.40.850.10-FF-000135', NULL, 'Putative kinesin', 373, NULL, NULL, 163846),
(163847, '3.40.50.150-FF-001347', NULL, NULL, 192, NULL, NULL, 163847),
(163848, '1.25.40.10-FF-001262', NULL, 'Heat shock protein 70 (HSP70)-interacting protein, putative', 130, NULL, NULL, 163848),
(163849, '2.60.40.1180-FF-000134', NULL, 'Uncharacterized protein', 121, NULL, NULL, 163849),
(163850, '1.20.1740.10-FF-000003', NULL, 'Y+L amino acid transporter 1 isoform X1', 444, NULL, NULL, 163850),
(163851, '1.20.1110.10-FF-000118', NULL, 'Sarcoplasmic/endoplasmic reticulum calcium ATPase 3', 167, NULL, NULL, 163851),
(163852, '3.40.50.1440-FF-000002', NULL, 'Tubulin alpha chain', 268, NULL, NULL, 163852),
(163853, '3.40.50.300-FF-007536', NULL, 'DEAQ box RNA-dependent ATPase 1', 203, NULL, NULL, 163853),
(163854, '3.30.365.10-FF-000072', NULL, 'Uncharacterized protein', 102, NULL, NULL, 163854),
(163855, '3.40.1160.10-FF-000071', NULL, 'Aspartokinase 1 chloroplastic', 87, NULL, NULL, 163855),
(163856, '3.40.720.10-FF-000070', NULL, 'Arylsulfatase A', 351, NULL, NULL, 163856),
(163857, '3.40.50.720-FF-001743', NULL, 'Enoyl-[acyl-carrier-protein] reductase, mitochondrial', 177, NULL, NULL, 163857),
(163858, '2.60.220.50-FF-000059', NULL, 'Adhesion G protein-coupled receptor G11', 137, NULL, NULL, 163858),
(163859, '3.30.160.60-FF-001667', NULL, 'tissue-resident T-cell transcription regulator protein ZNF683', 29, NULL, NULL, 163859),
(163860, '2.60.120.650-FF-000239', NULL, '40S ribosomal protein S4-3', 94, NULL, NULL, 163860),
(163861, '3.40.190.10-FF-000899', NULL, 'Probable sensor/response regulator hybrid', 132, NULL, NULL, 163861),
(163862, '3.30.200.20-FF-000069', NULL, 'Non-specific serine/threonine protein kinase', 137, NULL, NULL, 163862),
(163863, '1.20.1070.10-FF-000682', NULL, 'NeuroPeptide Receptor family', 305, NULL, NULL, 163863),
(163864, '2.60.40.1730-FF-000080', NULL, NULL, 196, NULL, NULL, 163864),
(163865, '1.10.1780.10-FF-000019', NULL, 'ATP-dependent Clp protease ATP-binding subunit ClpA', 142, NULL, NULL, 163865),
(163866, '3.40.1360.10-FF-000052', NULL, 'Uncharacterized protein', 152, NULL, NULL, 163866),
(163867, '2.20.100.10-FF-000244', NULL, 'Uncharacterized protein', 82, NULL, NULL, 163867),
(163868, '1.25.40.10-FF-003819', NULL, 'Uncharacterized protein', 131, NULL, NULL, 163868),
(163869, '3.10.580.10-FF-000014', NULL, 'Cystathionine beta-synthase', 153, NULL, NULL, 163869);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(163870, '3.20.20.100-FF-000185', NULL, 'Uncharacterized protein', 120, NULL, NULL, 163870),
(163871, '3.40.50.1460-FF-000036', NULL, 'Predicted protein', 215, NULL, NULL, 163871),
(163872, '3.40.50.150-FF-000061', NULL, 'Caffeic acid O-methyltransferase', 248, NULL, NULL, 163872),
(163873, '1.20.120.1080-FF-000071', NULL, 'CBN-RHA-2 protein', 172, NULL, NULL, 163873),
(163874, '2.60.120.330-FF-000205', NULL, 'Uncharacterized protein', 127, NULL, NULL, 163874),
(163875, '1.25.40.10-FF-004191', NULL, 'Cytochrome c maturation system haem lyase subunit SirG', 79, NULL, NULL, 163875),
(163876, '1.10.510.10-FF-003339', NULL, NULL, 48, NULL, NULL, 163876),
(163877, '3.40.50.2300-FF-001340', NULL, NULL, 231, NULL, NULL, 163877),
(163878, '1.20.1250.20-FF-000396', NULL, 'MFS general substrate transporter', 269, NULL, NULL, 163878),
(163879, '3.40.50.1820-FF-000807', NULL, 'Uncharacterized protein', 268, NULL, NULL, 163879),
(163880, '3.30.230.10-FF-000040', NULL, 'Galactokinase 1', 214, NULL, NULL, 163880),
(163881, '1.25.70.10-FF-000005', NULL, 'Transcription termination factor MTERF4, chloroplastic', 217, NULL, NULL, 163881),
(163882, '3.40.50.300-FF-004607', NULL, 'Regulator of nonsense transcripts 1-like protein', 274, NULL, NULL, 163882),
(163883, '3.40.30.10-FF-000176', NULL, 'Glutathione S-transferase theta-1', 81, NULL, NULL, 163883),
(163884, '3.40.50.1820-FF-000987', NULL, 'Putative thioesterase, MmyT', 249, NULL, NULL, 163884),
(163885, '3.90.10.10-FF-000004', NULL, NULL, 114, NULL, NULL, 163885),
(163886, '1.10.3720.10-FF-000162', NULL, 'Binding-protein-dependent transport systems inner membrane component', 254, NULL, NULL, 163886),
(163887, '3.30.10.30-FF-000001', NULL, 'Dual specificity tyrosine-phosphorylation-regulated kinase 2', 67, NULL, NULL, 163887),
(163888, '3.40.50.1820-FF-000459', NULL, 'Hydrolase, alpha/beta fold family protein', 289, NULL, NULL, 163888),
(163889, '3.30.160.60-FF-005534', NULL, NULL, 29, NULL, NULL, 163889),
(163890, '3.30.160.60-FF-006338', NULL, NULL, 26, NULL, NULL, 163890),
(163891, '3.40.109.10-FF-000031', NULL, 'Nitroreductase family protein', 218, NULL, NULL, 163891),
(163892, '3.20.20.70-FF-000132', NULL, 'FMN dependent dehydrogenase', 367, NULL, NULL, 163892),
(163893, '3.30.1610.10-FF-000012', NULL, 'Uncharacterized protein', 140, NULL, NULL, 163893),
(163894, '3.80.10.10-FF-000673', NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At2g02780', 176, NULL, NULL, 163894),
(163895, '2.170.120.30-FF-000014', NULL, 'YbbR family protein', 108, NULL, NULL, 163895),
(163896, '3.40.50.360-FF-000011', NULL, 'Protein NrdI', 119, NULL, NULL, 163896),
(163897, '4.10.1000.10-FF-000099', NULL, 'Zinc finger CCCH domain-containing protein 19', 71, NULL, NULL, 163897),
(163898, '1.10.20.70-FF-000002', NULL, 'Related to Cleavage stimulation factor', 43, NULL, NULL, 163898),
(163899, '1.20.58.60-FF-000653', NULL, 'Uncharacterized protein', 145, NULL, NULL, 163899),
(163900, '3.40.605.10-FF-000116', NULL, 'Uncharacterized protein', 37, NULL, NULL, 163900),
(163901, '1.25.10.10-FF-000029', NULL, 'Transportin-1 isoform 1', 549, NULL, NULL, 163901),
(163902, '2.130.10.10-FF-000414', NULL, 'Cytoplasmic dynein intermediate chain', 169, NULL, NULL, 163902),
(163903, '3.20.20.70-FF-000076', NULL, 'Nicotinate phosphoribosyltransferase', 170, NULL, NULL, 163903),
(163904, '3.30.1450.10-FF-000005', NULL, 'Cell envelope protein SmpA', 101, NULL, NULL, 163904),
(163905, '2.130.10.30-FF-000128', NULL, NULL, 132, NULL, NULL, 163905),
(163906, '2.10.70.10-FF-000171', NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain containing 1', 63, NULL, NULL, 163906),
(163907, '1.25.40.10-FF-003971', NULL, 'Predicted protein', 228, NULL, NULL, 163907),
(163908, '1.20.1270.60-FF-000217', NULL, 'Uncharacterized protein', 293, NULL, NULL, 163908),
(163909, '3.40.250.10-FF-000106', NULL, 'Thiosulfate sulfurtransferase GlpE', 117, NULL, NULL, 163909),
(163910, '3.90.105.20-FF-000014', NULL, 'Uncharacterized protein', 46, NULL, NULL, 163910),
(163911, '3.40.1180.10-FF-000010', NULL, 'Alkyl transferase', 244, NULL, NULL, 163911);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(163912, '1.20.120.80-FF-000017', NULL, 'Cytochrome c oxidase subunit 3', 118, NULL, NULL, 163912),
(163913, '1.10.287.950-FF-000049', NULL, 'Methyl-accepting chemotaxis sensory transducer, class 34H-related protein', 268, NULL, NULL, 163913),
(163914, '2.120.10.30-FF-000185', NULL, 'Acylaminoacyl peptidase', 152, NULL, NULL, 163914),
(163915, '1.20.1250.20-FF-000873', NULL, 'YALI0D20350p', 213, NULL, NULL, 163915),
(163916, '3.30.50.10-FF-000200', NULL, 'Uncharacterized protein', 85, NULL, NULL, 163916),
(163917, '1.20.80.60-FF-000008', NULL, 'Sorting nexin-27', 58, NULL, NULL, 163917),
(163918, '3.40.50.2300-FF-001284', NULL, NULL, 164, NULL, NULL, 163918),
(163919, '3.30.200.20-FF-000541', NULL, 'leucine-rich repeat receptor-like serine/threonine/tyrosine-protein kinase SOBIR1', 105, NULL, NULL, 163919),
(163920, '3.10.20.310-FF-000036', NULL, 'POTRA domain protein, ShlB-type', 64, NULL, NULL, 163920),
(163921, '2.60.120.310-FF-000014', NULL, 'Uncharacterized protein', 159, NULL, NULL, 163921),
(163922, '3.30.70.330-FF-002678', NULL, NULL, 139, NULL, NULL, 163922),
(163923, '3.40.50.300-FF-000920', NULL, 'Molybdopterin-guanine dinucleotide biosynthesis protein B', 170, NULL, NULL, 163923),
(163924, '1.10.167.10-FF-000045', NULL, 'GD24046', 137, NULL, NULL, 163924),
(163925, '2.60.40.1910-FF-000010', NULL, 'Aminopeptidase', 82, NULL, NULL, 163925),
(163926, '3.30.40.10-FF-000851', NULL, 'Alcohol sensitive Ring/PHD finger', 95, NULL, NULL, 163926),
(163927, '3.50.50.60-FF-001344', NULL, 'Uncharacterized protein', 64, NULL, NULL, 163927),
(163928, '3.30.450.20-FF-000677', NULL, 'Blue-light receptor phototropin 2', 77, NULL, NULL, 163928),
(163929, '3.30.70.1130-FF-000002', NULL, 'Translation initiation factor 2 subunit alpha', 90, NULL, NULL, 163929),
(163930, '3.30.200.20-FF-001502', NULL, 'Uncharacterized protein', 90, NULL, NULL, 163930),
(163931, '3.30.70.330-FF-000441', NULL, 'Polyadenylate-binding protein', 118, NULL, NULL, 163931),
(163932, '1.20.80.40-FF-000002', NULL, 'U5 snRNA-associated splicing factor', 95, NULL, NULL, 163932),
(163933, '1.25.40.20-FF-001591', NULL, 'Uncharacterized protein', 117, NULL, NULL, 163933),
(163934, '1.25.40.10-FF-002510', NULL, 'Proteinaceous RNase P 1, chloroplastic/mitochondrial', 81, NULL, NULL, 163934),
(163935, '1.10.520.20-FF-000004', NULL, 'ATP synthase subunit b-delta', 88, NULL, NULL, 163935),
(163936, '2.130.10.10-FF-000066', NULL, 'retinoblastoma-binding protein 5 isoform X2', 298, NULL, NULL, 163936),
(163937, '2.60.40.60-FF-000255', NULL, 'protocadherin-23 isoform X2', 106, NULL, NULL, 163937),
(163938, '3.30.160.60-FF-005349', NULL, NULL, 62, NULL, NULL, 163938),
(163939, '3.30.50.10-FF-000144', NULL, 'Nuclear Hormone Receptor family', 108, NULL, NULL, 163939),
(163940, '3.40.190.10-FF-000051', NULL, 'Membrane-bound lytic murein transglycosylase F', 97, NULL, NULL, 163940),
(163941, '3.30.160.60-FF-001611', NULL, 'Zinc finger protein 501', 28, NULL, NULL, 163941),
(163942, '1.20.1250.20-FF-000401', NULL, 'Vesicular amine transporter', 193, NULL, NULL, 163942),
(163943, '1.20.1250.20-FF-001413', NULL, 'Major facilitator superfamily MFS_1', 182, NULL, NULL, 163943),
(163944, '2.170.190.11-FF-000019', NULL, 'LOC100124966 protein', 62, NULL, NULL, 163944),
(163945, '3.90.79.10-FF-000033', NULL, 'nucleoside diphosphate-linked moiety X motif 17 isoform X1', 146, NULL, NULL, 163945),
(163946, '3.40.50.1240-FF-000206', NULL, NULL, 185, NULL, NULL, 163946),
(163947, '1.25.40.10-FF-000149', NULL, 'Clathrin-coated vesiclec protein (Bud7)', 451, NULL, NULL, 163947),
(163948, '3.30.40.10-FF-001071', NULL, 'Ring finger protein 180', 124, NULL, NULL, 163948),
(163949, '1.20.120.1750-FF-000108', NULL, 'RBR-type E3 ubiquitin transferase', 82, NULL, NULL, 163949),
(163950, '3.30.310.10-FF-000041', NULL, 'Coatomer subunit gamma', 115, NULL, NULL, 163950),
(163951, '3.40.50.720-FF-000815', NULL, 'Probable short-chain type dehydrogenase/reductase', 255, NULL, NULL, 163951),
(163952, '2.170.240.10-FF-000011', NULL, 'Uncharacterized protein', 62, NULL, NULL, 163952);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(163953, '1.25.40.1010-FF-000020', NULL, 'N-terminal acetyltransferase, putative', 152, NULL, NULL, 163953),
(163954, '2.60.40.10-FF-002179', NULL, 'Hemicentin 2', 85, NULL, NULL, 163954),
(163955, '3.40.50.2000-FF-000120', NULL, 'UDP-glycosyltransferase 76C1', 241, NULL, NULL, 163955),
(163956, '3.30.390.60-FF-000015', NULL, 'Heat-inducible transcription repressor HrcA', 89, NULL, NULL, 163956),
(163957, '1.20.1250.10-FF-000067', NULL, 'Interleukin-3', 113, NULL, NULL, 163957),
(163958, '3.40.50.300-FF-002073', NULL, 'Pfk27p', 220, NULL, NULL, 163958),
(163959, '1.10.8.60-FF-000363', NULL, 'Predicted protein', 80, NULL, NULL, 163959),
(163960, '1.10.510.10-FF-001046', NULL, 'Protein kinase Cdc7', 100, NULL, NULL, 163960),
(163961, '3.40.50.300-FF-000864', NULL, 'Mov10-like RISC complex RNA helicase 1', 204, NULL, NULL, 163961),
(163962, '3.40.50.300-FF-003793', NULL, 'Probable disease resistance protein At5g66900', 150, NULL, NULL, 163962),
(163963, '1.20.1260.110-FF-000002', NULL, 'DNA integrity scanning protein DisA', 151, NULL, NULL, 163963),
(163964, '1.25.40.1030-FF-000026', NULL, 'Protein transport protein SEC31', 399, NULL, NULL, 163964),
(163965, '1.10.10.10-FF-001338', NULL, 'Regulatory protein CysR homolog', 84, NULL, NULL, 163965),
(163966, '3.30.420.150-FF-000017', NULL, 'Putative exopolyphosphatase', 188, NULL, NULL, 163966),
(163967, '1.10.390.10-FF-000024', NULL, 'Peptidase M28', 166, NULL, NULL, 163967),
(163968, '2.130.10.10-FF-000561', NULL, 'Putative WD repeat protein', 399, NULL, NULL, 163968),
(163969, '3.80.10.10-FF-000965', NULL, 'Os12g0108500 protein', 101, NULL, NULL, 163969),
(163970, '1.10.287.3240-FF-000023', NULL, 'Uncharacterized protein', 211, NULL, NULL, 163970),
(163971, '2.130.10.30-FF-000044', NULL, 'Serine/threonine-protein kinase-like protein CR4', 171, NULL, NULL, 163971),
(163972, '3.30.160.60-FF-002595', NULL, 'Zinc finger and SCAN domain containing 10', 25, NULL, NULL, 163972),
(163973, '3.30.160.60-FF-004192', NULL, NULL, 28, NULL, NULL, 163973),
(163974, '3.30.1490.10-FF-000007', NULL, NULL, 49, NULL, NULL, 163974),
(163975, '3.40.50.2020-FF-000126', NULL, 'Uncharacterized protein', 210, NULL, NULL, 163975),
(163976, '3.30.2420.10-FF-000003', NULL, 'Protein TonB', 80, NULL, NULL, 163976),
(163977, '1.10.287.70-FF-000583', NULL, 'Glutamate receptor 3.5', 73, NULL, NULL, 163977),
(163978, '3.40.50.620-FF-000898', NULL, 'Uncharacterized protein', 75, NULL, NULL, 163978),
(163979, '3.30.60.30-FF-000095', NULL, 'Complement component C7', 74, NULL, NULL, 163979),
(163980, '2.40.50.100-FF-000111', NULL, 'Oxaloacetate decarboxylase, alpha subunit', 75, NULL, NULL, 163980),
(163981, '2.40.440.10-FF-000012', NULL, 'L,D-transpeptidase catalytic domain', 128, NULL, NULL, 163981),
(163982, '1.25.40.550-FF-000008', NULL, 'A1 cistron-splicing factor AAR2', 239, NULL, NULL, 163982),
(163983, '1.10.418.10-FF-000022', NULL, 'Short stop, isoform K', 118, NULL, NULL, 163983),
(163984, '1.10.10.60-FF-000111', NULL, 'Two-component system response regulator GlrR', 55, NULL, NULL, 163984),
(163985, '3.30.160.60-FF-003556', NULL, NULL, 28, NULL, NULL, 163985),
(163986, '2.60.40.790-FF-000070', NULL, 'CG7409', 97, NULL, NULL, 163986),
(163987, '1.10.110.10-FF-000009', NULL, 'Non-specific lipid transfer protein-like 1', 79, NULL, NULL, 163987),
(163988, '3.30.70.120-FF-000024', NULL, NULL, 107, NULL, NULL, 163988),
(163989, '2.60.40.200-FF-000028', NULL, 'Uncharacterized protein', 154, NULL, NULL, 163989),
(163990, '2.130.10.10-FF-004304', NULL, 'Uncharacterized protein', 116, NULL, NULL, 163990),
(163991, '3.40.5.10-FF-000023', NULL, '50S ribosomal protein L9', 61, NULL, NULL, 163991),
(163992, '3.90.70.10-FF-000480', NULL, 'Uncharacterized protein', 314, NULL, NULL, 163992),
(163993, '2.60.40.780-FF-000005', NULL, 'Iduronate-sulfatase (Partial) and sulfatase 1', 81, NULL, NULL, 163993),
(163994, '1.20.58.100-FF-000023', NULL, NULL, 100, NULL, NULL, 163994),
(163995, '3.40.1260.10-FF-000011', NULL, 'Intracellular sulfur oxidation protein DsrF', 119, NULL, NULL, 163995);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(163996, '3.30.160.60-FF-004540', NULL, NULL, 76, NULL, NULL, 163996),
(163997, '1.20.1250.20-FF-001705', NULL, 'Organic anion transporter, putative', 138, NULL, NULL, 163997),
(163998, '2.102.10.10-FF-000040', NULL, 'Toluene 12-dioxygenase system ferredoxin subunit protein', 100, NULL, NULL, 163998),
(163999, '2.10.77.10-FF-000001', NULL, 'Hemagglutinin', 93, NULL, NULL, 163999),
(164000, '1.10.1410.10-FF-000060', NULL, 'Predicted protein', 177, NULL, NULL, 164000),
(164001, '2.60.40.150-FF-000378', NULL, 'Putative copine', 129, NULL, NULL, 164001),
(164002, '2.70.130.10-FF-000162', NULL, NULL, 100, NULL, NULL, 164002),
(164003, '3.30.720.170-FF-000001', NULL, 'Perilipin', 51, NULL, NULL, 164003),
(164004, '1.10.510.10-FF-001102', NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', 324, NULL, NULL, 164004),
(164005, '1.25.40.20-FF-000478', NULL, 'Palmitoyltransferase', 233, NULL, NULL, 164005),
(164006, '1.10.1240.40-FF-000004', NULL, 'Protein EMSY-LIKE 4', 134, NULL, NULL, 164006),
(164007, '2.10.50.10-FF-000136', NULL, 'Zgc:153759', 38, NULL, NULL, 164007),
(164008, '3.30.40.10-FF-000879', NULL, 'abscission/NoCut checkpoint regulator', 67, NULL, NULL, 164008),
(164009, '1.10.533.10-FF-000273', NULL, 'Uncharacterized protein', 97, NULL, NULL, 164009),
(164010, '3.60.21.10-FF-000183', NULL, 'Serine/threonine protein phosphatase 7', 402, NULL, NULL, 164010),
(164011, '3.90.550.10-FF-000281', NULL, '16S rRNA processing protein RimM family', 373, NULL, NULL, 164011),
(164012, '2.60.200.20-FF-000100', NULL, 'Serine/threonine protein kinase cds1, putative', 119, NULL, NULL, 164012),
(164013, '2.60.40.10-FF-003955', NULL, NULL, 104, NULL, NULL, 164013),
(164014, '1.10.1520.10-FF-000118', NULL, 'DsRNA-specific nuclease dicer and related ribonuclease', 116, NULL, NULL, 164014),
(164015, '1.50.40.10-FF-000557', NULL, 'Mitochondrial fusion and transport protein ugo1', 125, NULL, NULL, 164015),
(164016, '2.130.10.30-FF-000100', NULL, NULL, 243, NULL, NULL, 164016),
(164017, '2.60.40.1930-FF-000016', NULL, 'Thioester-containing protein 6', 97, NULL, NULL, 164017),
(164018, '1.25.10.30-FF-000007', NULL, NULL, 76, NULL, NULL, 164018),
(164019, '3.30.70.260-FF-000072', NULL, 'Probable aspartokinase', 82, NULL, NULL, 164019),
(164020, '3.30.70.330-FF-000789', NULL, 'RNA binding protein', 114, NULL, NULL, 164020),
(164021, '3.30.40.10-FF-001627', NULL, 'Tripartite motif-containing protein 28', 63, NULL, NULL, 164021),
(164022, '3.60.21.10-FF-000036', NULL, 'Serine/threonine protein phosphatase 5', 319, NULL, NULL, 164022),
(164023, '2.60.40.650-FF-000022', NULL, 'Uncharacterized protein', 79, NULL, NULL, 164023),
(164024, '2.40.10.10-FF-000211', NULL, 'serine proteinase stubble isoform X2', 153, NULL, NULL, 164024),
(164025, '1.20.1250.20-FF-000581', NULL, 'Major Facilitator Superfamily protein', 187, NULL, NULL, 164025),
(164026, '3.40.50.2000-FF-000912', NULL, 'Uncharacterized protein', 163, NULL, NULL, 164026),
(164027, '1.20.5.110-FF-000055', NULL, 'vesicle-associated membrane protein 8', 96, NULL, NULL, 164027),
(164028, '3.30.499.10-FF-000045', NULL, NULL, 154, NULL, NULL, 164028),
(164029, '2.170.270.10-FF-000159', NULL, 'Histone methyltransferase', 141, NULL, NULL, 164029),
(164030, '3.30.70.1560-FF-000013', NULL, 'tRNA pseudouridine synthase A, putative', 84, NULL, NULL, 164030),
(164031, '3.50.50.60-FF-000416', NULL, 'NADH oxidase', 245, NULL, NULL, 164031),
(164032, '3.30.160.60-FF-004045', NULL, NULL, 32, NULL, NULL, 164032),
(164033, '3.90.1150.210-FF-000022', NULL, 'F-actin-capping protein subunit beta', 185, NULL, NULL, 164033),
(164034, '1.25.10.10-FF-000001', NULL, 'CLIP-associating protein 1 isoform 2', 232, NULL, NULL, 164034),
(164035, '1.10.287.110-FF-000005', NULL, 'DnaJ (Hsp40) homolog, subfamily B, member 4', 111, NULL, NULL, 164035),
(164036, '3.50.50.60-FF-001400', NULL, 'Uncharacterized protein', 175, NULL, NULL, 164036),
(164037, '1.20.1250.20-FF-000957', NULL, 'MFS transporter, putative', 188, NULL, NULL, 164037),
(164038, '3.30.200.20-FF-002430', NULL, 'Uncharacterized protein', 77, NULL, NULL, 164038);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(164039, '1.10.20.10-FF-000114', NULL, 'Taf3p', 93, NULL, NULL, 164039),
(164040, '1.10.10.10-FF-001254', NULL, 'Crp/Fnr family transcriptional regulator', 87, NULL, NULL, 164040),
(164041, '1.10.510.10-FF-000085', NULL, 'Serine/threonine-protein kinase SRK2E', 189, NULL, NULL, 164041),
(164042, '3.30.70.330-FF-001189', NULL, 'RNA-binding protein putative', 104, NULL, NULL, 164042),
(164043, '1.20.1250.20-FF-001357', NULL, 'Uncharacterized protein', 201, NULL, NULL, 164043),
(164044, '2.60.40.10-FF-002235', NULL, 'Diverse immunoglobulin domain-containing protein 1.16', 100, NULL, NULL, 164044),
(164045, '1.20.140.150-FF-000047', NULL, 'transmembrane protein 114 isoform X2', 78, NULL, NULL, 164045),
(164046, '3.30.160.60-FF-003409', NULL, 'zinc finger protein 236', 27, NULL, NULL, 164046),
(164047, '1.25.40.20-FF-001411', NULL, 'Oxysterol-binding protein homolog C2F12.05c', 134, NULL, NULL, 164047),
(164048, '3.30.40.230-FF-000012', NULL, 'GlycyltRNA synthetase. Putative', 61, NULL, NULL, 164048),
(164049, '3.90.550.20-FF-000014', NULL, 'Glycosyl transferase, putative (AFU_orthologue AFUA_8G02040)', 230, NULL, NULL, 164049),
(164050, '2.60.40.60-FF-000783', NULL, 'Predicted protein', 64, NULL, NULL, 164050),
(164051, '3.30.70.330-FF-002734', NULL, NULL, 96, NULL, NULL, 164051),
(164052, '3.80.10.10-FF-000437', NULL, 'NLR family pyrin domain-containing 2', 194, NULL, NULL, 164052),
(164053, '1.10.287.1490-FF-000150', NULL, 'Kinesin-like protein', 165, NULL, NULL, 164053),
(164054, '3.30.1370.10-FF-000004', NULL, 'Fragile X mental retardation 1, isoform CRA_e', 64, NULL, NULL, 164054),
(164055, '2.130.10.10-FF-002359', NULL, 'Guanine nucleotide-binding protein subunit beta-like protein 1', 167, NULL, NULL, 164055),
(164056, '2.60.90.10-FF-000001', NULL, 'Fiber', 192, NULL, NULL, 164056),
(164057, '1.10.533.10-FF-000126', NULL, 'Tumor necrosis factor receptor superfamily, member 1a', 102, NULL, NULL, 164057),
(164058, '1.20.120.790-FF-000027', NULL, 'Uncharacterized protein', 146, NULL, NULL, 164058),
(164059, '3.60.15.10-FF-000179', NULL, 'Uncharacterized protein', 59, NULL, NULL, 164059),
(164060, '3.90.470.20-FF-000013', NULL, 'L-aminoadipate-semialdehyde dehydrogenase-phosphopantetheinyl transferase', 117, NULL, NULL, 164060),
(164061, '1.20.1070.10-FF-000974', NULL, 'Uncharacterized protein', 290, NULL, NULL, 164061),
(164062, '3.40.250.10-FF-000022', NULL, 'Thiosulfate sulfurtransferase/rhodanese-like domain-containing protein 2', 155, NULL, NULL, 164062),
(164063, '2.40.50.220-FF-000001', NULL, 'Ethanolamine utilization microcompartment protein EutN', 95, NULL, NULL, 164063),
(164064, '3.30.70.260-FF-000009', NULL, 'Acetolactate synthase isozyme 2 small subunit', 87, NULL, NULL, 164064),
(164065, '3.90.70.10-FF-000328', NULL, 'Ubiquitin carboxyl-terminal hydrolase 38', 425, NULL, NULL, 164065),
(164066, '1.25.10.10-FF-003435', NULL, 'Uncharacterized protein', 135, NULL, NULL, 164066),
(164067, '1.20.58.530-FF-000034', NULL, 'Heavy chain, Unconventional Myosin', 154, NULL, NULL, 164067),
(164068, '3.10.20.90-FF-000751', NULL, 'Uncharacterized protein', 95, NULL, NULL, 164068),
(164069, '2.10.70.10-FF-000204', NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', 57, NULL, NULL, 164069),
(164070, '1.10.238.10-FF-000513', NULL, 'Magu, isoform F', 131, NULL, NULL, 164070),
(164071, '1.10.10.10-FF-001777', NULL, 'Selenocysteine-specific translation elongation factor', 57, NULL, NULL, 164071),
(164072, '1.25.40.20-FF-001439', NULL, 'Uncharacterized protein', 150, NULL, NULL, 164072),
(164073, '1.10.287.130-FF-000163', NULL, 'Sensor histidine kinase', 65, NULL, NULL, 164073),
(164074, '2.10.70.10-FF-000019', NULL, 'Complement factor b,-like', 58, NULL, NULL, 164074),
(164075, '3.90.320.10-FF-000056', NULL, 'Predicted protein', 143, NULL, NULL, 164075),
(164076, '3.30.200.20-FF-000485', NULL, 'Dual-specificity kinase', 79, NULL, NULL, 164076),
(164077, '2.130.10.10-FF-000122', NULL, 'THO complex subunit 3', 171, NULL, NULL, 164077),
(164078, '3.10.50.10-FF-000010', NULL, 'Chitinase A1', 84, NULL, NULL, 164078);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(164079, '2.40.50.140-FF-000275', NULL, 'mRNA-capping enzyme subunit alpha', 148, NULL, NULL, 164079),
(164080, '3.90.550.10-FF-000129', NULL, 'Glycosyltransferase family 2 protein', 225, NULL, NULL, 164080),
(164081, '3.20.20.80-FF-000697', NULL, 'Alpha-amylase 4', 188, NULL, NULL, 164081),
(164082, '3.40.1190.20-FF-000081', NULL, 'Pyridoxal kinase', 285, NULL, NULL, 164082),
(164083, '2.60.120.340-FF-000034', NULL, 'Uncharacterized protein', 115, NULL, NULL, 164083),
(164084, '3.40.50.1100-FF-000272', NULL, 'Uncharacterized protein', 32, NULL, NULL, 164084),
(164085, '3.30.420.10-FF-000228', NULL, 'ISPsy11, transposase OrfB', 160, NULL, NULL, 164085),
(164086, '3.40.50.620-FF-000903', NULL, 'Uncharacterized protein', 66, NULL, NULL, 164086),
(164087, '1.10.510.10-FF-003491', NULL, NULL, 263, NULL, NULL, 164087),
(164088, '3.90.190.20-FF-000003', NULL, 'UDP-N-acetylmuramoylalanine--D-glutamate ligase', 135, NULL, NULL, 164088),
(164089, '3.30.930.10-FF-000222', NULL, 'Prolyl-tRNA synthetase, mitochondrial, isoform B', 121, NULL, NULL, 164089),
(164090, '1.20.140.50-FF-000004', NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', 183, NULL, NULL, 164090),
(164091, '2.60.120.260-FF-000072', NULL, 'Proprotein convertase subtilisin/kexin type', 145, NULL, NULL, 164091),
(164092, '3.40.50.2300-FF-000704', NULL, NULL, 119, NULL, NULL, 164092),
(164093, '3.20.20.80-FF-000309', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', 281, NULL, NULL, 164093),
(164094, '3.40.50.300-FF-006047', NULL, 'ATP-binding cassette subfamily B member 1', 172, NULL, NULL, 164094),
(164095, '3.30.930.10-FF-000166', NULL, 'Histidine--tRNA ligase', 325, NULL, NULL, 164095),
(164096, '3.40.190.10-FF-000612', NULL, 'Phosphate ABC transporter, periplasmic phosphate-binding protein PstS', 130, NULL, NULL, 164096),
(164097, '2.130.10.10-FF-003472', NULL, 'WD repeat-containing protein 66-like Protein', 338, NULL, NULL, 164097),
(164098, '2.30.29.30-FF-001165', NULL, 'Expressed protein', 225, NULL, NULL, 164098),
(164099, '2.30.30.140-FF-000048', NULL, 'Tudor domain containing 1', 71, NULL, NULL, 164099),
(164100, '3.40.630.30-FF-000490', NULL, '[Ribosomal protein S18]-alanine N-acetyltransferase', 145, NULL, NULL, 164100),
(164101, '2.30.180.10-FF-000022', NULL, 'fasciclin-like arabinogalactan protein 4', 153, NULL, NULL, 164101),
(164102, '3.80.10.10-FF-001365', NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', 99, NULL, NULL, 164102),
(164103, '3.40.50.620-FF-000050', NULL, 'Isoleucyl-tRNA synthetase,cytoplasmic', 282, NULL, NULL, 164103),
(164104, '3.30.1520.10-FF-000185', NULL, 'Predicted protein', 86, NULL, NULL, 164104),
(164105, '1.20.120.350-FF-000007', NULL, 'Voltage-dependent T-type calcium channel subunit alpha', 121, NULL, NULL, 164105),
(164106, '3.10.250.10-FF-000057', NULL, 'Uncharacterized protein', 74, NULL, NULL, 164106),
(164107, '3.40.190.90-FF-000001', NULL, 'Fructose-1,6-bisphosphatase', 154, NULL, NULL, 164107),
(164108, '3.50.50.60-FF-001113', NULL, 'Uncharacterized protein', 158, NULL, NULL, 164108),
(164109, '4.10.1000.10-FF-000043', NULL, 'tRNA methyltransferase 44 homolog', 39, NULL, NULL, 164109),
(164110, '2.130.10.10-FF-000830', NULL, 'Putative chromatin assembly factor 1 subunit', 299, NULL, NULL, 164110),
(164111, '3.10.250.10-FF-000113', NULL, NULL, 82, NULL, NULL, 164111),
(164112, '1.10.287.10-FF-000025', NULL, 'Glycine-tRNA ligase', 52, NULL, NULL, 164112),
(164113, '1.10.1060.10-FF-000043', NULL, NULL, 118, NULL, NULL, 164113),
(164114, '3.80.10.10-FF-001893', NULL, 'Pxn-1', 214, NULL, NULL, 164114),
(164115, '3.30.70.920-FF-000051', NULL, 'Uncharacterized HTH-type transcriptional regulator PH1519', 95, NULL, NULL, 164115),
(164116, '3.40.50.720-FF-000310', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(P)+]', 170, NULL, NULL, 164116),
(164117, '3.40.50.300-FF-006996', NULL, 'Uncharacterized protein', 212, NULL, NULL, 164117),
(164118, '3.30.70.330-FF-001661', NULL, NULL, 55, NULL, NULL, 164118),
(164119, '2.60.120.200-FF-000745', NULL, 'Collagen XV alpha 1 chain', 145, NULL, NULL, 164119);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(164120, '3.30.30.30-FF-000031', NULL, 'Protein CBG02604', 55, NULL, NULL, 164120),
(164121, '1.25.10.10-FF-003290', NULL, 'SNF2 superfamily protein', 184, NULL, NULL, 164121),
(164122, '2.70.150.10-FF-000253', NULL, 'Calcium-transporting ATPase', 55, NULL, NULL, 164122),
(164123, '2.30.30.180-FF-000009', NULL, 'Ribosome maturation factor RimP', 62, NULL, NULL, 164123),
(164124, '2.60.40.60-FF-000816', NULL, 'Uncharacterized protein', 113, NULL, NULL, 164124),
(164125, '3.30.1120.120-FF-000006', NULL, 'Serine/threonine-protein kinase PLK4', 38, NULL, NULL, 164125),
(164126, '1.20.1070.10-FF-001643', NULL, 'Secretin receptor, putative', 137, NULL, NULL, 164126),
(164127, '3.40.50.300-FF-008177', NULL, 'RuvB-like helicase', 83, NULL, NULL, 164127),
(164128, '3.40.50.1100-FF-000125', NULL, 'Putative cysteine synthase', 157, NULL, NULL, 164128),
(164129, '3.30.200.20-FF-001558', NULL, 'AGAP010162-PA', 85, NULL, NULL, 164129),
(164130, '2.130.10.10-FF-001286', NULL, 'WD repeat-containing protein, putative', 272, NULL, NULL, 164130),
(164131, '3.30.420.40-FF-000058', NULL, 'Putative actin-related protein 5', 29, NULL, NULL, 164131),
(164132, '1.10.472.10-FF-000720', NULL, 'Predicted protein', 115, NULL, NULL, 164132),
(164133, '2.60.40.10-FF-004124', NULL, NULL, 92, NULL, NULL, 164133),
(164134, '1.25.40.10-FF-000621', NULL, 'Pentatricopeptide repeat-containing protein', 152, NULL, NULL, 164134),
(164135, '3.10.129.10-FF-000101', NULL, '3-hydroxyacyl-thioester dehydratase HtdY', 134, NULL, NULL, 164135),
(164136, '2.40.420.20-FF-000042', NULL, 'HlyD family secretion protein', 90, NULL, NULL, 164136),
(164137, '1.10.510.10-FF-004452', NULL, NULL, 28, NULL, NULL, 164137),
(164138, '1.10.150.20-FF-000195', NULL, 'DNA polymerase eta', 75, NULL, NULL, 164138),
(164139, '3.90.1800.10-FF-000013', NULL, 'DNA-directed RNA polymerase subunit beta', 111, NULL, NULL, 164139),
(164140, '1.20.120.340-FF-000010', NULL, 'Flagellar protein FliS', 121, NULL, NULL, 164140),
(164141, '3.90.1720.10-FF-000012', NULL, 'Uncharacterized protein', 152, NULL, NULL, 164141),
(164142, '3.20.20.140-FF-000062', NULL, 'Adenosine deaminase', 341, NULL, NULL, 164142),
(164143, '3.30.460.10-FF-000113', NULL, 'Interleukin enhancer-binding factor 2', 36, NULL, NULL, 164143),
(164144, '3.90.190.20-FF-000059', NULL, 'Bifunctional folylpolyglutamate synthase/dihydrofolate synthase', 134, NULL, NULL, 164144),
(164145, '1.20.1070.10-FF-002099', NULL, 'Uncharacterized protein', 357, NULL, NULL, 164145),
(164146, '3.40.50.300-FF-004338', NULL, 'Predicted protein', 252, NULL, NULL, 164146),
(164147, '3.30.420.10-FF-000195', NULL, 'Chromosome 1, whole genome shotgun sequence', 243, NULL, NULL, 164147),
(164148, '1.10.238.10-FF-001238', NULL, 'NKD2, WNT signaling pathway inhibitor', 97, NULL, NULL, 164148),
(164149, '2.60.120.330-FF-000172', NULL, 'Predicted protein', 261, NULL, NULL, 164149),
(164150, '1.20.1250.20-FF-000429', NULL, 'MFS drug efflux transporter, putative', 196, NULL, NULL, 164150),
(164151, '1.10.10.160-FF-000047', NULL, 'DNA helicase', 86, NULL, NULL, 164151),
(164152, '3.60.20.10-FF-000253', NULL, NULL, 180, NULL, NULL, 164152),
(164153, '2.60.40.10-FF-004652', NULL, NULL, 75, NULL, NULL, 164153),
(164154, '3.30.310.130-FF-000037', NULL, 'Uncharacterized protein', 76, NULL, NULL, 164154),
(164155, '2.130.10.10-FF-005557', NULL, 'Type II inositol polyphosphate 5-phosphatase 15', 219, NULL, NULL, 164155),
(164156, '1.25.10.10-FF-001249', NULL, 'MMS19 nucleotide excision repair protein homolog', 212, NULL, NULL, 164156),
(164157, '2.60.40.3120-FF-000002', NULL, 'cytosolic carboxypeptidase-like protein 5 isoform X2', 158, NULL, NULL, 164157),
(164158, '3.40.50.1780-FF-000014', NULL, 'Long irondependent hydrogenase, putative', 127, NULL, NULL, 164158),
(164159, '3.40.50.1010-FF-000250', NULL, NULL, 167, NULL, NULL, 164159),
(164160, '2.70.150.10-FF-000197', NULL, 'Phospholipid-transporting ATPase', 181, NULL, NULL, 164160),
(164161, '2.60.40.10-FF-001690', NULL, 'Immunoglobulin heavy constant epsilon', 103, NULL, NULL, 164161);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(164162, '1.25.10.10-FF-001581', NULL, 'Predicted protein', 228, NULL, NULL, 164162),
(164163, '1.10.1670.10-FF-000073', NULL, NULL, 43, NULL, NULL, 164163),
(164164, '3.30.70.870-FF-000013', NULL, 'Elongation factor G, mitochondrial', 74, NULL, NULL, 164164),
(164165, '1.10.1420.10-FF-000026', NULL, 'DNA mismatch repair protein MSH5', 227, NULL, NULL, 164165),
(164166, '1.10.510.10-FF-001810', NULL, 'Protein CBG24469', 173, NULL, NULL, 164166),
(164167, '2.30.30.360-FF-000002', NULL, 'Unconventional myosin-VI', 50, NULL, NULL, 164167),
(164168, '1.20.1740.10-FF-000239', NULL, 'Uncharacterized protein', 382, NULL, NULL, 164168),
(164169, '2.180.10.10-FF-000013', NULL, 'Si:dkey-34l15.2', 211, NULL, NULL, 164169),
(164170, '3.40.50.300-FF-008233', NULL, 'Uncharacterized protein', 59, NULL, NULL, 164170),
(164171, '4.10.410.10-FF-000026', NULL, 'Serine protease inhibitor, putative', 62, NULL, NULL, 164171),
(164172, '1.10.1510.30-FF-000011', NULL, 'Probable tRNA pseudouridine synthase D', 86, NULL, NULL, 164172),
(164173, '3.50.70.10-FF-000009', NULL, 'Predicted protein', 149, NULL, NULL, 164173),
(164174, '2.40.100.10-FF-000105', NULL, 'Peptidyl-prolyl cis-trans isomerase', 184, NULL, NULL, 164174),
(164175, '1.20.1270.60-FF-000184', NULL, 'Uncharacterized protein', 347, NULL, NULL, 164175),
(164176, '2.60.120.290-FF-000176', NULL, 'Uncharacterized protein', 116, NULL, NULL, 164176),
(164177, '3.90.640.10-FF-000164', NULL, 'Os08g0369300 protein', 53, NULL, NULL, 164177),
(164178, '3.30.310.10-FF-000069', NULL, 'AP complex subunit beta', 68, NULL, NULL, 164178),
(164179, '3.30.710.10-FF-000386', NULL, 'Uncharacterized protein', 154, NULL, NULL, 164179),
(164180, '1.25.40.10-FF-000565', NULL, 'Pentatricopeptide repeat-containing protein', 104, NULL, NULL, 164180),
(164181, '2.130.10.10-FF-001342', NULL, 'Target of rapamycin complex subunit lst8', 184, NULL, NULL, 164181),
(164182, '1.10.506.10-FF-000070', NULL, 'Uncharacterized protein', 131, NULL, NULL, 164182),
(164183, '1.10.510.10-FF-002794', NULL, NULL, 194, NULL, NULL, 164183),
(164184, '3.30.160.60-FF-003792', NULL, NULL, 27, NULL, NULL, 164184),
(164185, '3.90.180.10-FF-000084', NULL, 'NADH oxidoreductase', 180, NULL, NULL, 164185),
(164186, '3.40.50.450-FF-000066', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase', 228, NULL, NULL, 164186),
(164187, '2.40.70.10-FF-000372', NULL, NULL, 202, NULL, NULL, 164187),
(164188, '1.10.10.60-FF-000550', NULL, 'Homeobox domaincontaining protein', 94, NULL, NULL, 164188),
(164189, '2.30.30.570-FF-000003', NULL, 'Major vault protein-like protein', 53, NULL, NULL, 164189),
(164190, '2.40.50.1070-FF-000004', NULL, '23S rRNA (uracil(1939)-C(5))-methyltransferase RlmD', 137, NULL, NULL, 164190),
(164191, '3.30.160.60-FF-003264', NULL, 'Juxtaposed with another zinc finger protein 1', 56, NULL, NULL, 164191),
(164192, '3.30.479.20-FF-000052', NULL, 'Elongation factor Ts, mitochondrial', 101, NULL, NULL, 164192),
(164193, '3.40.50.150-FF-001494', NULL, NULL, 118, NULL, NULL, 164193),
(164194, '2.130.10.10-FF-003848', NULL, 'Uncharacterized protein', 289, NULL, NULL, 164194),
(164195, '3.40.50.12780-FF-000065', NULL, 'Fatty-acid-CoA ligase FadD34', 421, NULL, NULL, 164195),
(164196, '4.10.400.10-FF-000256', NULL, 'Serine protease P146', 39, NULL, NULL, 164196),
(164197, '1.25.40.10-FF-003999', NULL, 'Pentatricopeptide repeat-containing protein 1, mitochondrial', 209, NULL, NULL, 164197),
(164198, '2.130.10.10-FF-004776', NULL, 'Predicted protein', 327, NULL, NULL, 164198),
(164199, '3.30.230.10-FF-000068', NULL, 'Homoserine kinase', 173, NULL, NULL, 164199),
(164200, '3.40.50.620-FF-000426', NULL, 'Leucyl-tRNA synthetase a', 201, NULL, NULL, 164200),
(164201, '3.40.50.970-FF-000188', NULL, 'Pyruvate:ferredoxin oxidoreductase F', 67, NULL, NULL, 164201),
(164202, '1.10.3060.10-FF-000010', NULL, 'Protein translocase subunit SecA 2', 98, NULL, NULL, 164202),
(164203, '3.30.40.10-FF-002032', NULL, 'Uncharacterized protein', 99, NULL, NULL, 164203),
(164204, '3.10.110.10-FF-000316', NULL, 'Os06g0506600 protein', 60, NULL, NULL, 164204);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(164205, '1.50.40.10-FF-000265', NULL, 'Mitochondrial glycine transporter', 210, NULL, NULL, 164205),
(164206, '3.30.70.3460-FF-000004', NULL, 'Putative heme biosynthesis protein', 89, NULL, NULL, 164206),
(164207, '3.30.559.10-FF-000196', NULL, 'Alcohol acetyltransferase', 188, NULL, NULL, 164207),
(164208, '2.30.30.40-FF-000255', NULL, 'Tyrosine-protein kinase', 57, NULL, NULL, 164208),
(164209, '2.40.160.180-FF-000004', NULL, 'Porin', 419, NULL, NULL, 164209),
(164210, '3.40.50.1820-FF-000195', NULL, 'Proline iminopeptidase', 300, NULL, NULL, 164210),
(164211, '1.20.1310.10-FF-000162', NULL, NULL, 124, NULL, NULL, 164211),
(164212, '1.25.40.340-FF-000002', NULL, 'Dihydroxyacetone kinase, L subunit', 208, NULL, NULL, 164212),
(164213, '3.40.50.1000-FF-000096', NULL, 'Trehalose 6-phosphate phosphatase', 149, NULL, NULL, 164213),
(164214, '2.40.50.140-FF-000359', NULL, 'Translation initiation factor IF-1', 84, NULL, NULL, 164214),
(164215, '3.40.630.30-FF-000338', NULL, 'Ribosomal-protein-alanine acetyltransferase', 159, NULL, NULL, 164215),
(164216, '3.90.550.10-FF-000573', NULL, 'Mannosyl-3-phosphoglycerate synthase/mannosyl-3-phosphoglycerate phosphatase', 395, NULL, NULL, 164216),
(164217, '2.60.40.1120-FF-000015', NULL, 'carboxypeptidase D isoform X4', 84, NULL, NULL, 164217),
(164218, '2.60.40.10-FF-000381', NULL, 'Neural cell adhesion molecule 2', 96, NULL, NULL, 164218),
(164219, '1.10.8.870-FF-000015', NULL, 'Glycerol-3-phosphate dehydrogenase', 134, NULL, NULL, 164219),
(164220, '1.50.10.10-FF-000061', NULL, 'LanC-like protein 2', 399, NULL, NULL, 164220),
(164221, '2.60.40.10-FF-002090', NULL, 'Muscle M-line assembly protein unc-89', 100, NULL, NULL, 164221),
(164222, '3.30.40.10-FF-000374', NULL, 'Autoimmune regulator', 65, NULL, NULL, 164222),
(164223, '3.80.30.30-FF-000006', NULL, 'DNA repair photolyase', 212, NULL, NULL, 164223),
(164224, '1.10.472.10-FF-000012', NULL, 'G1/S-specific cyclin-D1', 115, NULL, NULL, 164224),
(164225, '3.20.70.20-FF-000053', NULL, 'Predicted protein', 177, NULL, NULL, 164225),
(164226, '1.20.940.10-FF-000025', NULL, 'Predicted protein', 109, NULL, NULL, 164226),
(164227, '3.30.70.1170-FF-000019', NULL, 'RNA methylase, NOL1/NOP2/sun family', 110, NULL, NULL, 164227),
(164228, '3.40.50.300-FF-003118', NULL, 'ATP-dependent RNA helicase, DEAD box family', 211, NULL, NULL, 164228),
(164229, '1.10.238.10-FF-000457', NULL, 'mRNA, clone: RTFL01-44-H24', 81, NULL, NULL, 164229),
(164230, '1.20.120.740-FF-000001', NULL, 'UPF0149 protein YgfB', 189, NULL, NULL, 164230),
(164231, '3.90.740.10-FF-000020', NULL, 'Leucine--tRNA ligase, putative', 266, NULL, NULL, 164231),
(164232, '3.40.50.150-FF-000622', NULL, 'Uncharacterized protein', 212, NULL, NULL, 164232),
(164233, '2.60.120.200-FF-000458', NULL, 'Predicted protein', 164, NULL, NULL, 164233),
(164234, '3.50.50.60-FF-000708', NULL, 'Amine oxidase', 423, NULL, NULL, 164234),
(164235, '3.30.40.10-FF-000935', NULL, 'E3 ubiquitin-protein ligase RNF187', 81, NULL, NULL, 164235),
(164236, '2.10.25.10-FF-000100', NULL, 'neurogenic locus notch homolog protein 3', 39, NULL, NULL, 164236),
(164237, '3.80.10.10-FF-004416', NULL, 'Uncharacterized protein', 59, NULL, NULL, 164237),
(164238, '3.60.110.10-FF-000086', NULL, NULL, 156, NULL, NULL, 164238),
(164239, '1.25.10.10-FF-003379', NULL, 'Uncharacterized protein', 148, NULL, NULL, 164239),
(164240, '1.25.40.20-FF-001883', NULL, 'Uncharacterized protein', 121, NULL, NULL, 164240),
(164241, '1.10.510.10-FF-002322', NULL, 'Protein kinase', 291, NULL, NULL, 164241),
(164242, '3.40.50.740-FF-000029', NULL, 'NADH-quinone oxidoreductase', 110, NULL, NULL, 164242),
(164243, '1.25.40.610-FF-000015', NULL, 'Uncharacterized protein', 95, NULL, NULL, 164243),
(164244, '3.10.450.10-FF-000010', NULL, 'Alpha-2-HS-glycoprotein', 94, NULL, NULL, 164244),
(164245, '2.10.25.10-FF-001264', NULL, 'Uncharacterized protein', 38, NULL, NULL, 164245),
(164246, '1.10.510.10-FF-003608', NULL, NULL, 199, NULL, NULL, 164246),
(164247, '3.30.450.150-FF-000001', NULL, 'Cob(I)yrinic acid a,c-diamide adenosyltransferase', 147, NULL, NULL, 164247);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(164248, '1.10.10.650-FF-000014', NULL, 'Uncharacterized protein', 157, NULL, NULL, 164248),
(164249, '1.20.5.110-FF-000347', NULL, 'Uncharacterized protein', 39, NULL, NULL, 164249),
(164250, '1.20.120.1080-FF-000099', NULL, 'Atp-dependent RNA helicase', 165, NULL, NULL, 164250),
(164251, '3.90.70.10-FF-000036', NULL, 'Serine repeat antigen 5', 265, NULL, NULL, 164251),
(164252, '3.80.10.10-FF-000145', NULL, 'Tubulin-specific chaperone cofactor E-like protein', 165, NULL, NULL, 164252),
(164253, '3.40.50.300-FF-003826', NULL, 'SNF2_family_N-terminal_domain /Helicase_conserved_C-terminal_domain_containing_protein_-_putative', 275, NULL, NULL, 164253),
(164254, '4.10.470.10-FF-000002', NULL, 'Antiviral protein I', 81, NULL, NULL, 164254),
(164255, '2.60.120.1440-FF-000015', NULL, 'Protein containing FecR protein domain protein', 139, NULL, NULL, 164255),
(164256, '3.40.50.1000-FF-000657', NULL, NULL, 77, NULL, NULL, 164256),
(164257, '3.40.1770.10-FF-000010', NULL, 'Uncharacterized protein', 167, NULL, NULL, 164257),
(164258, '1.20.1720.10-FF-000120', NULL, NULL, 330, NULL, NULL, 164258),
(164259, '1.10.287.110-FF-000477', NULL, 'DnaJ domain containing protein', 98, NULL, NULL, 164259),
(164260, '3.30.450.90-FF-000001', NULL, 'Type II secretion system ATPase GspE', 133, NULL, NULL, 164260),
(164261, '3.10.20.90-FF-000307', NULL, 'Phosphatidylinositol 4-kinase gamma 4', 80, NULL, NULL, 164261),
(164262, '1.10.8.60-FF-000127', NULL, 'Vesicular-fusion protein SEC18', 96, NULL, NULL, 164262),
(164263, '3.90.1150.10-FF-000103', NULL, 'Serine hydroxymethyltransferase', 145, NULL, NULL, 164263),
(164264, '1.20.1070.10-FF-002155', NULL, 'Uncharacterized protein', 152, NULL, NULL, 164264),
(164265, '3.40.190.10-FF-000871', NULL, 'Uncharacterized protein', 72, NULL, NULL, 164265),
(164266, '3.40.50.1100-FF-000069', NULL, 'Pyridoxal-phosphate dependent protein', 185, NULL, NULL, 164266),
(164267, '2.130.10.10-FF-002067', NULL, 'Cleavage and polyadenylation specificity factor-like protein', 396, NULL, NULL, 164267),
(164268, '3.40.50.1010-FF-000194', NULL, NULL, 129, NULL, NULL, 164268),
(164269, '1.10.510.10-FF-000377', NULL, 'Checkpoint protein kinase', 196, NULL, NULL, 164269),
(164270, '1.10.150.20-FF-000251', NULL, 'DNA polymerase IV', 62, NULL, NULL, 164270),
(164271, '2.60.40.10-FF-005377', NULL, NULL, 59, NULL, NULL, 164271),
(164272, '3.40.50.2300-FF-000648', NULL, 'Guanylate cyclase', 185, NULL, NULL, 164272),
(164273, '3.30.420.10-FF-000459', NULL, NULL, 74, NULL, NULL, 164273),
(164274, '2.20.100.10-FF-000059', NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 12', 61, NULL, NULL, 164274),
(164275, '3.40.630.10-FF-000332', NULL, 'Carboxypeptidase Z', 239, NULL, NULL, 164275),
(164276, '3.30.70.330-FF-000497', NULL, 'flowering time control protein FPA', 95, NULL, NULL, 164276),
(164277, '3.40.50.300-FF-007721', NULL, 'Putative ABC transporter ATP-binding protein', 289, NULL, NULL, 164277),
(164278, '1.25.40.10-FF-004308', NULL, 'Uncharacterized protein', 185, NULL, NULL, 164278),
(164279, '1.25.40.10-FF-001077', NULL, 'Pentatricopeptide repeat-containing protein', 98, NULL, NULL, 164279),
(164280, '1.10.1370.10-FF-000033', NULL, 'Peptidase M3A and M3B domain-containing protein', 323, NULL, NULL, 164280),
(164281, '3.40.50.300-FF-004810', NULL, 'Elongation factor 1 alpha-like protein', 138, NULL, NULL, 164281),
(164282, '3.40.50.300-FF-004490', NULL, 'ABC transporter, ATP-binding protein', 253, NULL, NULL, 164282),
(164283, '2.130.10.130-FF-000057', NULL, NULL, 115, NULL, NULL, 164283),
(164284, '3.90.70.10-FF-000800', NULL, 'Predicted protein', 322, NULL, NULL, 164284),
(164285, '3.40.50.2300-FF-001576', NULL, NULL, 149, NULL, NULL, 164285),
(164286, '1.20.5.1190-FF-000005', NULL, 'ISWI chromatin-remodeling complex ATPase ISW1', 33, NULL, NULL, 164286),
(164287, '3.40.50.1980-FF-000102', NULL, 'Iron(III) ABC transporter, solute-binding protein', 101, NULL, NULL, 164287),
(164288, '3.30.160.60-FF-006046', NULL, NULL, 70, NULL, NULL, 164288),
(164289, '1.20.1250.20-FF-002054', NULL, 'Uncharacterized protein', 308, NULL, NULL, 164289);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(164290, '2.60.40.2610-FF-000001', NULL, 'Outer membrane fimbrial usher protein', 91, NULL, NULL, 164290),
(164291, '2.60.120.10-FF-000186', NULL, 'Cyclic nucleotide-binding transporter 1', 125, NULL, NULL, 164291),
(164292, '1.25.40.10-FF-000801', NULL, 'Pentatricopeptide repeat-containing protein', 129, NULL, NULL, 164292),
(164293, '2.130.10.10-FF-002270', NULL, 'Subunit of the COMPASS complex, putative', 283, NULL, NULL, 164293),
(164294, '3.10.330.70-FF-000002', NULL, 'Predicted protein', 54, NULL, NULL, 164294),
(164295, '1.20.120.1900-FF-000030', NULL, 'Spindle pole body component', 285, NULL, NULL, 164295),
(164296, '2.60.120.10-FF-000242', NULL, 'Uncharacterized protein, isoform A', 111, NULL, NULL, 164296),
(164297, '3.40.50.1980-FF-000046', NULL, 'Nitrogenase molybdenum-iron protein beta chain', 146, NULL, NULL, 164297),
(164298, '2.60.40.10-FF-004091', NULL, NULL, 94, NULL, NULL, 164298),
(164299, '3.30.230.70-FF-000007', NULL, 'Exosome complex component RRP45B', 289, NULL, NULL, 164299),
(164300, '1.10.287.3990-FF-000012', NULL, '26S proteasome regulatory subunit rpn10', 41, NULL, NULL, 164300),
(164301, '3.40.50.800-FF-000036', NULL, 'Histidine--tRNA ligase, putative', 86, NULL, NULL, 164301),
(164302, '3.40.190.10-FF-000668', NULL, 'Uncharacterized protein', 113, NULL, NULL, 164302),
(164303, '1.10.510.10-FF-003047', NULL, NULL, 213, NULL, NULL, 164303),
(164304, '3.30.56.10-FF-000011', NULL, 'Phenylalanine--tRNA ligase beta subunit', 75, NULL, NULL, 164304),
(164305, '1.20.58.2220-FF-000045', NULL, 'Uncharacterized protein', 341, NULL, NULL, 164305),
(164306, '3.90.230.10-FF-000026', NULL, 'Intermediate cleaving peptidase 55', 269, NULL, NULL, 164306),
(164307, '3.30.870.10-FF-000015', NULL, 'Cardiolipin synthase B', 139, NULL, NULL, 164307),
(164308, '1.10.510.10-FF-002827', NULL, 'Kinase, NEK', 292, NULL, NULL, 164308),
(164309, '2.130.10.10-FF-001994', NULL, 'PRP4 pre-mRNA processing factor 4-like protein', 105, NULL, NULL, 164309),
(164310, '1.20.1230.10-FF-000009', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 244, NULL, NULL, 164310),
(164311, '2.60.120.620-FF-000135', NULL, 'Kanamycin B dioxygenase', 244, NULL, NULL, 164311),
(164312, '3.40.50.2000-FF-000064', NULL, 'Glycosyltransferase', 187, NULL, NULL, 164312),
(164313, '3.40.50.1820-FF-000515', NULL, 'Hydrolase, alpha/beta fold family domain containing protein', 279, NULL, NULL, 164313),
(164314, '2.60.120.230-FF-000001', NULL, 'Monooxygenase, DBH-like 1', 150, NULL, NULL, 164314),
(164315, '3.40.50.300-FF-005119', NULL, 'Polysaccharide biosynthesis tyrosine autokinase', 252, NULL, NULL, 164315),
(164316, '3.30.160.60-FF-000594', NULL, 'Transcription factor HIVEP2', 26, NULL, NULL, 164316),
(164317, '1.10.287.1150-FF-000014', NULL, 'Oxoglutarate dehydrogenase (Succinyl-transferring)', 82, NULL, NULL, 164317),
(164318, '3.30.70.890-FF-000024', NULL, 'Mevalonate kinase', 141, NULL, NULL, 164318),
(164319, '2.60.40.1530-FF-000020', NULL, 'Integrin, alpha 2b', 219, NULL, NULL, 164319),
(164320, '2.30.30.380-FF-000013', NULL, 'Protein transport protein SEC23', 63, NULL, NULL, 164320),
(164321, '3.30.200.20-FF-000013', NULL, 'Ribosomal protein S6 kinase', 104, NULL, NULL, 164321),
(164322, '3.80.10.10-FF-000201', NULL, 'protein phosphatase 1 regulatory subunit 42', 133, NULL, NULL, 164322),
(164323, '2.60.40.10-FF-001723', NULL, 'Interference hedgehog', 117, NULL, NULL, 164323),
(164324, '2.60.40.10-FF-001538', NULL, 'immunoglobulin superfamily member 22', 95, NULL, NULL, 164324),
(164325, '2.170.150.80-FF-000008', NULL, 'NAC domain-containing protein 72-like', 145, NULL, NULL, 164325),
(164326, '1.20.1110.10-FF-000034', NULL, 'Cation-transporting ATPase', 118, NULL, NULL, 164326),
(164327, '3.40.50.300-FF-007160', NULL, 'Uncharacterized protein', 175, NULL, NULL, 164327),
(164328, '1.10.630.10-FF-000032', NULL, 'Cytochrome P450 aromatase', 459, NULL, NULL, 164328),
(164329, '1.20.1640.10-FF-000063', NULL, 'PaTched Related family', 182, NULL, NULL, 164329),
(164330, '3.30.1390.20-FF-000008', NULL, '60S ribosomal protein L7', 89, NULL, NULL, 164330);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(164331, '3.30.420.10-FF-000515', NULL, NULL, 125, NULL, NULL, 164331),
(164332, '3.40.50.410-FF-000189', NULL, 'ATP-dependent DNA helicase 2 subunit KU80', 190, NULL, NULL, 164332),
(164333, '2.30.30.100-FF-000031', NULL, 'Small nuclear ribonucleoprotein E', 91, NULL, NULL, 164333),
(164334, '2.170.270.10-FF-000103', NULL, 'Hamlet, isoform B', 128, NULL, NULL, 164334),
(164335, '2.130.10.10-FF-005737', NULL, 'Transducin/WD40 repeat-like superfamily protein', 127, NULL, NULL, 164335),
(164336, '3.20.20.100-FF-000218', NULL, 'Aldo-keto-reductase-like protein', 58, NULL, NULL, 164336),
(164337, '2.30.29.30-FF-001345', NULL, 'Rac guanyl-nucleotide exchange factor', 144, NULL, NULL, 164337),
(164338, '3.30.56.30-FF-000017', NULL, 'Signal recognition particle 19 kDa protein', 95, NULL, NULL, 164338),
(164339, '1.25.10.10-FF-002362', NULL, 'Binding', 280, NULL, NULL, 164339),
(164340, '2.40.33.10-FF-000016', NULL, 'Pyruvate kinase', 95, NULL, NULL, 164340),
(164341, '3.40.20.10-FF-000147', NULL, 'Uncharacterized protein (Fragment)', 107, NULL, NULL, 164341),
(164342, '3.30.160.60-FF-005973', NULL, NULL, 65, NULL, NULL, 164342),
(164343, '2.10.25.10-FF-000156', NULL, 'cadherin EGF LAG seven-pass G-type receptor 2', 46, NULL, NULL, 164343),
(164344, '1.25.40.10-FF-001638', NULL, 'Pentatricopeptide repeat-containing protein At5g06540', 164, NULL, NULL, 164344),
(164345, '1.20.1070.10-FF-000715', NULL, 'Uncharacterized protein', 292, NULL, NULL, 164345),
(164346, '1.10.3120.10-FF-000009', NULL, 'Trigger factor', 220, NULL, NULL, 164346),
(164347, '1.20.920.10-FF-000226', NULL, 'Predicted protein', 146, NULL, NULL, 164347),
(164348, '3.90.290.10-FF-000002', NULL, 'Latent-transforming growth factor beta-binding protein 3 isoform 1', 70, NULL, NULL, 164348),
(164349, '1.10.1420.10-FF-000206', NULL, 'Uncharacterized protein', 62, NULL, NULL, 164349),
(164350, '3.40.950.10-FF-000019', NULL, 'Periplasmic [Fe] hydrogenase 1', 133, NULL, NULL, 164350),
(164351, '3.40.50.1700-FF-000064', NULL, 'Predicted protein', 71, NULL, NULL, 164351),
(164352, '3.90.199.10-FF-000014', NULL, NULL, 184, NULL, NULL, 164352),
(164353, '2.70.98.30-FF-000047', NULL, 'Predicted protein', 294, NULL, NULL, 164353),
(164354, '1.20.990.10-FF-000028', NULL, 'NADPH-cytochrome P450 reductase', 18, NULL, NULL, 164354),
(164355, '2.60.40.10-FF-000049', NULL, 'Leukocyte immunoglobulin-like receptor subfamily B member 1', 101, NULL, NULL, 164355),
(164356, '3.30.200.20-FF-002486', NULL, 'Non-specific serine/threonine protein kinase', 28, NULL, NULL, 164356),
(164357, '1.10.540.10-FF-000002', NULL, 'Acyl-CoA dehydrogenase FadE19', 121, NULL, NULL, 164357),
(164358, '1.25.40.10-FF-003494', NULL, 'Pentatricopeptide repeat-containing protein At1g62720', 71, NULL, NULL, 164358),
(164359, '1.20.1110.10-FF-000181', NULL, NULL, 211, NULL, NULL, 164359),
(164360, '2.130.10.10-FF-001903', NULL, 'Sortilin', 152, NULL, NULL, 164360),
(164361, '3.30.300.160-FF-000016', NULL, 'Protein transport protein HofB homolog', 71, NULL, NULL, 164361),
(164362, '1.10.12.10-FF-000016', NULL, 'Probable enoyl-CoA hydratase echA7', 56, NULL, NULL, 164362),
(164363, '3.10.105.10-FF-000097', NULL, 'Oligopeptide ABC transporter, periplasmic oligopeptide-binding protein OppA', 210, NULL, NULL, 164363),
(164364, '2.130.10.10-FF-001847', NULL, 'Nucleolar protein, component of the U3 processome', 98, NULL, NULL, 164364),
(164365, '3.30.420.40-FF-000619', NULL, 'Protein CBG19480', 79, NULL, NULL, 164365),
(164366, '3.40.1110.10-FF-000444', NULL, NULL, 253, NULL, NULL, 164366),
(164367, '3.30.70.330-FF-000733', NULL, 'YGR250C-like protein', 114, NULL, NULL, 164367),
(164368, '3.30.559.10-FF-000140', NULL, 'Glycoside hydrolase family 128 protein', 204, NULL, NULL, 164368),
(164369, '1.20.120.850-FF-000034', NULL, 'Uncharacterized protein', 96, NULL, NULL, 164369),
(164370, '1.25.40.10-FF-002190', NULL, 'Pentatricopeptide repeat-containing protein At3g18110, chloroplastic', 69, NULL, NULL, 164370),
(164371, '2.130.10.10-FF-006013', NULL, 'Spliceosomal protein sap, putative', 180, NULL, NULL, 164371);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(164372, '2.120.10.30-FF-000269', NULL, 'Low-density lipoprotein receptor-related protein', 308, NULL, NULL, 164372),
(164373, '2.130.10.10-FF-000358', NULL, 'Hermansky-Pudlak syndrome 5 protein homolog', 237, NULL, NULL, 164373),
(164374, '3.30.450.20-FF-000385', NULL, 'Transcriptional regulator, PpsR', 120, NULL, NULL, 164374),
(164375, '3.30.70.1230-FF-000206', NULL, 'Guanylate cyclase', 221, NULL, NULL, 164375),
(164376, '1.10.510.10-FF-001490', NULL, 'Kinase, CAMK CAMKL', 336, NULL, NULL, 164376),
(164377, '3.30.450.60-FF-000077', NULL, 'AP complex subunit sigma', 97, NULL, NULL, 164377),
(164378, '2.70.98.10-FF-000041', NULL, 'Aldose 1-epimerase', 351, NULL, NULL, 164378),
(164379, '3.40.50.1000-FF-000713', NULL, NULL, 96, NULL, NULL, 164379),
(164380, '1.20.1250.20-FF-001093', NULL, 'Predicted protein', 128, NULL, NULL, 164380),
(164381, '1.20.120.1760-FF-000061', NULL, NULL, 191, NULL, NULL, 164381),
(164382, '1.25.40.180-FF-000083', NULL, 'Uncharacterized protein, isoform B', 201, NULL, NULL, 164382),
(164383, '2.80.10.50-FF-000171', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 96, NULL, NULL, 164383),
(164384, '2.20.25.10-FF-000015', NULL, 'Multifunctional methyltransferase subunit TRM112-like protein', 123, NULL, NULL, 164384),
(164385, '1.25.10.10-FF-001957', NULL, 'BEACH domain-containing protein B', 268, NULL, NULL, 164385),
(164386, '2.30.29.30-FF-001401', NULL, 'Uncharacterized protein', 76, NULL, NULL, 164386),
(164387, '3.90.1750.20-FF-000017', NULL, NULL, 153, NULL, NULL, 164387),
(164388, '3.30.310.50-FF-000002', NULL, 'Phosphoglucomutase 5', 161, NULL, NULL, 164388),
(164389, '3.40.50.720-FF-001474', NULL, 'Pyrroline-5-carboxylate reductase', 166, NULL, NULL, 164389),
(164390, '1.20.5.340-FF-000034', NULL, 'Myosin heavy chain, isoform U', 112, NULL, NULL, 164390),
(164391, '1.20.120.1770-FF-000007', NULL, 'Cytochrome b561 and DOMON domain-containing protein', 189, NULL, NULL, 164391),
(164392, '3.90.1750.10-FF-000071', NULL, 'E3 ubiquitin-protein ligase hyd', 186, NULL, NULL, 164392),
(164393, '3.30.160.60-FF-005826', NULL, NULL, 29, NULL, NULL, 164393),
(164394, '1.20.5.190-FF-000005', NULL, 'IQ motif containing GTPase activating protein 1', 57, NULL, NULL, 164394),
(164395, '3.40.50.300-FF-006608', NULL, 'Predicted protein', 96, NULL, NULL, 164395),
(164396, '3.30.200.20-FF-001182', NULL, 'Uncharacterized protein', 108, NULL, NULL, 164396),
(164397, '2.30.30.40-FF-000311', NULL, 'Polarized growth protein (Boi2)', 63, NULL, NULL, 164397),
(164398, '1.10.8.720-FF-000021', NULL, 'Dynein heavy chain family protein', 164, NULL, NULL, 164398),
(164399, '3.90.530.10-FF-000010', NULL, NULL, 81, NULL, NULL, 164399),
(164400, '2.130.10.10-FF-004068', NULL, 'Uncharacterized protein', 206, NULL, NULL, 164400),
(164401, '3.30.230.130-FF-000075', NULL, 'Predicted protein', 153, NULL, NULL, 164401),
(164402, '2.60.40.10-FF-003668', NULL, NULL, 53, NULL, NULL, 164402),
(164403, '3.50.7.10-FF-000067', NULL, NULL, 200, NULL, NULL, 164403),
(164404, '1.25.10.10-FF-002738', NULL, 'Uncharacterized protein', 814, NULL, NULL, 164404),
(164405, '1.20.1070.10-FF-000154', NULL, 'Vomeronasal type-1 receptor', 297, NULL, NULL, 164405),
(164406, '1.50.40.10-FF-000501', NULL, 'Uncharacterized protein', 261, NULL, NULL, 164406),
(164407, '2.60.40.10-FF-000234', NULL, 'Collagen, type XII, alpha 1', 93, NULL, NULL, 164407),
(164408, '3.80.10.10-FF-002146', NULL, 'Uncharacterized protein', 93, NULL, NULL, 164408),
(164409, '3.30.450.40-FF-000071', NULL, 'IclR family transcriptional regulator', 168, NULL, NULL, 164409),
(164410, '2.10.25.10-FF-001117', NULL, 'Protein glp-1', 40, NULL, NULL, 164410),
(164411, '3.30.360.50-FF-000005', NULL, 'S-adenosylmethionine decarboxylase proenzyme', 66, NULL, NULL, 164411),
(164412, '3.30.460.10-FF-000169', NULL, 'Uncharacterized protein', 100, NULL, NULL, 164412),
(164413, '3.30.40.10-FF-000407', NULL, 'Histone-lysine N-methyltransferase MLL3', 113, NULL, NULL, 164413),
(164414, '3.30.420.40-FF-000390', NULL, 'ROK family transcriptional regulator', 159, NULL, NULL, 164414);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(164415, '3.40.50.150-FF-001550', NULL, NULL, 83, NULL, NULL, 164415),
(164416, '1.25.40.10-FF-003527', NULL, 'Uncharacterized protein', 75, NULL, NULL, 164416),
(164417, '3.30.160.60-FF-001898', NULL, 'Zinc finger protein with KRAB and SCAN domains 5', 34, NULL, NULL, 164417),
(164418, '2.40.290.10-FF-000034', NULL, 'KU80 protein', 137, NULL, NULL, 164418),
(164419, '2.60.40.10-FF-005433', NULL, NULL, 93, NULL, NULL, 164419),
(164420, '1.25.40.20-FF-000714', NULL, 'Poly [ADP-ribose] polymerase', 197, NULL, NULL, 164420),
(164421, '3.10.180.10-FF-000085', NULL, '4-hydroxyphenylpyruvate dioxygenase', 165, NULL, NULL, 164421),
(164422, '3.40.640.10-FF-000361', NULL, 'Predicted protein', 143, NULL, NULL, 164422),
(164423, '2.130.10.120-FF-000020', NULL, 'Prolyl oligopeptidase family protein', 87, NULL, NULL, 164423),
(164424, '2.40.37.10-FF-000076', NULL, NULL, 159, NULL, NULL, 164424),
(164425, '3.80.20.20-FF-000087', NULL, 'Predicted protein', 102, NULL, NULL, 164425),
(164426, '2.10.220.10-FF-000036', NULL, 'Receptor protein-tyrosine kinase', 93, NULL, NULL, 164426),
(164427, '1.10.10.60-FF-000347', NULL, 'Regulatory protein Ada', 59, NULL, NULL, 164427),
(164428, '3.80.10.10-FF-003635', NULL, 'Uncharacterized protein', 154, NULL, NULL, 164428),
(164429, '2.80.10.50-FF-000024', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 128, NULL, NULL, 164429),
(164430, '3.30.160.60-FF-003320', NULL, 'Cys2/His2 zinc finger protein', 24, NULL, NULL, 164430),
(164431, '2.20.25.120-FF-000001', NULL, 'Molybdopterin molybdenumtransferase', 21, NULL, NULL, 164431),
(164432, '2.60.40.10-FF-005613', NULL, NULL, 102, NULL, NULL, 164432),
(164433, '3.40.50.300-FF-002337', NULL, 'Transcription factor bHLH140', 170, NULL, NULL, 164433),
(164434, '1.10.3520.10-FF-000034', NULL, 'Uncharacterized protein', 113, NULL, NULL, 164434),
(164435, '1.10.8.10-FF-000337', NULL, 'Uncharacterized protein', 38, NULL, NULL, 164435),
(164436, '2.60.40.10-FF-001162', NULL, 'PKHD1 like 1', 87, NULL, NULL, 164436),
(164437, '3.90.1140.10-FF-000041', NULL, 'Uncharacterized protein UNK4,15', 175, NULL, NULL, 164437),
(164438, '1.20.58.1540-FF-000004', NULL, NULL, 134, NULL, NULL, 164438),
(164439, '1.10.10.60-FF-001275', NULL, NULL, 73, NULL, NULL, 164439),
(164440, '3.30.200.20-FF-002519', NULL, 'Ribosomal protein S6 kinase A1', 106, NULL, NULL, 164440),
(164441, '1.25.40.470-FF-000046', NULL, 'Intraflagellar Transport Protein 122', 164, NULL, NULL, 164441),
(164442, '1.20.5.1230-FF-000001', NULL, 'Heparin-binding hemagglutinin HbhA', 122, NULL, NULL, 164442),
(164443, '3.90.70.80-FF-000040', NULL, 'Extracellular OTU-like cysteine protease, putative', 98, NULL, NULL, 164443),
(164444, '3.20.20.80-FF-000461', NULL, 'Beta-glucosidase, putative', 437, NULL, NULL, 164444),
(164445, '1.20.5.190-FF-000152', NULL, NULL, 45, NULL, NULL, 164445),
(164446, '1.10.860.10-FF-000021', NULL, 'Replicative DNA helicase', 154, NULL, NULL, 164446),
(164447, '3.40.50.1440-FF-000109', NULL, 'Tubulin beta chain', 262, NULL, NULL, 164447),
(164448, '1.10.630.10-FF-000537', NULL, 'Uncharacterized protein', 365, NULL, NULL, 164448),
(164449, '3.30.420.10-FF-000700', NULL, NULL, 116, NULL, NULL, 164449),
(164450, '3.40.50.2300-FF-001053', NULL, NULL, 132, NULL, NULL, 164450),
(164451, '3.40.50.300-FF-001409', NULL, 'ABC transporter G family member 23', 238, NULL, NULL, 164451),
(164452, '2.10.25.10-FF-001792', NULL, 'Uncharacterized protein', 30, NULL, NULL, 164452),
(164453, '3.40.720.10-FF-000215', NULL, 'Arylsulfatase A', 329, NULL, NULL, 164453),
(164454, '2.120.10.80-FF-000059', NULL, 'F-box only protein 6', 286, NULL, NULL, 164454),
(164455, '1.10.8.60-FF-000599', NULL, 'Lon protease homolog 3, mitochondrial', 148, NULL, NULL, 164455),
(164456, '2.60.40.150-FF-000142', NULL, 'DnaJ protein ERDJ2A', 122, NULL, NULL, 164456),
(164457, '2.40.50.430-FF-000002', NULL, 'DNA polymerase delta subunit', 135, NULL, NULL, 164457),
(164458, '3.30.160.60-FF-002336', NULL, 'Regular, isoform C', 27, NULL, NULL, 164458),
(164459, '3.30.420.40-FF-000243', NULL, 'Heat shock protein 105 kDa', 57, NULL, NULL, 164459);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(164460, '3.30.160.20-FF-000189', NULL, 'Uncharacterized protein', 70, NULL, NULL, 164460),
(164461, '2.60.120.290-FF-000232', NULL, 'Uncharacterized protein', 81, NULL, NULL, 164461),
(164462, '1.10.1740.10-FF-000045', NULL, 'RNA polymerase sigma factor SigI1', 105, NULL, NULL, 164462),
(164463, '3.30.70.330-FF-000025', NULL, 'RNA-binding protein Musashi homolog 2 isoform X1', 82, NULL, NULL, 164463),
(164464, '1.10.10.10-FF-000613', NULL, 'Heme response regulator HssR', 105, NULL, NULL, 164464),
(164465, '3.40.50.80-FF-000243', NULL, 'Uncharacterized protein', 153, NULL, NULL, 164465),
(164466, '2.10.220.10-FF-000183', NULL, 'Receptor protein-tyrosine kinase', 66, NULL, NULL, 164466),
(164467, '3.80.10.10-FF-002707', NULL, 'MDIS1-interacting receptor like kinase 2', 137, NULL, NULL, 164467),
(164468, '3.40.50.300-FF-001937', NULL, 'Adenylyl-sulfate kinase', 208, NULL, NULL, 164468),
(164469, '2.130.10.10-FF-002831', NULL, 'Coatomer subunit beta''-3', 102, NULL, NULL, 164469),
(164470, '1.20.1170.10-FF-000010', NULL, NULL, 271, NULL, NULL, 164470),
(164471, '2.130.10.10-FF-005029', NULL, 'Coronin', 304, NULL, NULL, 164471),
(164472, '1.10.357.70-FF-000032', NULL, 'Uncharacterized protein', 146, NULL, NULL, 164472),
(164473, '1.20.1560.10-FF-000585', NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 13', 214, NULL, NULL, 164473),
(164474, '1.20.1070.10-FF-000210', NULL, 'probable G-protein coupled receptor 101', 320, NULL, NULL, 164474),
(164475, '3.40.50.10810-FF-000255', NULL, 'Snf2 histone linker PHD ring helicase, putative', 64, NULL, NULL, 164475),
(164476, '2.130.10.10-FF-005181', NULL, 'AEL269Cp', 123, NULL, NULL, 164476),
(164477, '3.40.1110.10-FF-000388', NULL, NULL, 124, NULL, NULL, 164477),
(164478, '1.10.510.10-FF-001866', NULL, 'Protein kinase C, alpha', 149, NULL, NULL, 164478),
(164479, '3.20.20.70-FF-000363', NULL, 'Oxygen-independent coproporphyrinogen III oxidase', 214, NULL, NULL, 164479),
(164480, '2.40.30.10-FF-000246', NULL, 'Protein CBG12339', 88, NULL, NULL, 164480),
(164481, '1.20.120.980-FF-000022', NULL, 'Thymus-specific serine protease', 155, NULL, NULL, 164481),
(164482, '2.60.40.10-FF-001870', NULL, 'V-set and immunoglobulin domain containing 8', 113, NULL, NULL, 164482),
(164483, '1.10.510.10-FF-002266', NULL, NULL, 174, NULL, NULL, 164483),
(164484, '1.10.275.10-FF-000009', NULL, 'Phenylalanine ammonia-lyase', 248, NULL, NULL, 164484),
(164485, '2.60.40.10-FF-004596', NULL, NULL, 98, NULL, NULL, 164485),
(164486, '2.10.25.10-FF-001084', NULL, 'Thrombospondin-3a', 37, NULL, NULL, 164486),
(164487, '1.10.472.10-FF-000664', NULL, 'Os08g0421100 protein', 80, NULL, NULL, 164487),
(164488, '1.20.58.420-FF-000001', NULL, 'Atlastin-1 isoform 1', 113, NULL, NULL, 164488),
(164489, '1.25.40.10-FF-002566', NULL, 'UDP-N-acetylglucosaminyltransferase (AFU_orthologue AFUA_1G03380)', 124, NULL, NULL, 164489),
(164490, '1.10.630.10-FF-000684', NULL, 'Uncharacterized protein', 155, NULL, NULL, 164490),
(164491, '3.80.10.10-FF-003074', NULL, 'Uncharacterized protein', 132, NULL, NULL, 164491),
(164492, '3.40.50.300-FF-006232', NULL, 'Predicted protein', 121, NULL, NULL, 164492),
(164493, '3.30.740.10-FF-000011', NULL, 'Dynein light chain', 89, NULL, NULL, 164493),
(164494, '3.40.50.2000-FF-000592', NULL, 'Glycosyltransferase', 255, NULL, NULL, 164494),
(164495, '3.40.50.720-FF-001327', NULL, 'Ubiquitin activating enzyme, putative', 264, NULL, NULL, 164495),
(164496, '3.40.850.10-FF-000551', NULL, 'Uncharacterized protein', 178, NULL, NULL, 164496),
(164497, '2.60.40.10-FF-005580', NULL, NULL, 103, NULL, NULL, 164497),
(164498, '3.50.50.60-FF-001080', NULL, 'Succinate dehydrogenase [ubiquinone] flavoprotein subunit, mitochondrial', 250, NULL, NULL, 164498),
(164499, '2.30.29.30-FF-000384', NULL, 'Uncharacterized protein, isoform A', 114, NULL, NULL, 164499),
(164500, '3.40.720.10-FF-000362', NULL, 'Uncharacterized protein HI_0841', 172, NULL, NULL, 164500),
(164501, '3.30.160.60-FF-006193', NULL, NULL, 52, NULL, NULL, 164501),
(164502, '2.70.170.10-FF-000052', NULL, 'Ligand-Gated ion Channel', 204, NULL, NULL, 164502);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(164503, '4.10.60.10-FF-000121', NULL, 'HCL585Cp', 21, NULL, NULL, 164503),
(164504, '1.10.150.240-FF-000056', NULL, '5-amino-6-(5-phospho-D-ribitylamino)uracil phosphatase, chloroplastic', 74, NULL, NULL, 164504),
(164505, '3.40.47.10-FF-000299', NULL, NULL, 51, NULL, NULL, 164505),
(164506, '3.30.1490.80-FF-000039', NULL, 'Uncharacterized protein', 13, NULL, NULL, 164506),
(164507, '1.20.1720.10-FF-000064', NULL, 'MFS transporter, DHA2 family, multidrug resistance protein', 206, NULL, NULL, 164507),
(164508, '3.30.160.60-FF-001375', NULL, 'Zinc finger and BTB domain-containing protein 39', 61, NULL, NULL, 164508),
(164509, '3.40.50.300-FF-001376', NULL, 'tRNA modification GTPase MnmE', 163, NULL, NULL, 164509),
(164510, '3.30.70.580-FF-000050', NULL, 'tRNA pseudouridine synthase A', 106, NULL, NULL, 164510),
(164511, '1.25.40.10-FF-004511', NULL, 'Uncharacterized protein', 87, NULL, NULL, 164511),
(164512, '1.10.225.10-FF-000006', NULL, 'prosaposin isoform X2', 84, NULL, NULL, 164512),
(164513, '3.40.50.2300-FF-001429', NULL, NULL, 150, NULL, NULL, 164513),
(164514, '1.10.418.10-FF-000078', NULL, 'Putative Filamin-A', 106, NULL, NULL, 164514),
(164515, '1.20.120.140-FF-000006', NULL, 'Cell division FtsY, chloroplastic-like protein', 102, NULL, NULL, 164515),
(164516, '1.20.1560.10-FF-000438', NULL, 'Multidrug resistance protein 1, putative', 242, NULL, NULL, 164516),
(164517, '3.60.15.10-FF-000090', NULL, 'DNA repair protein', 171, NULL, NULL, 164517),
(164518, '3.40.980.10-FF-000032', NULL, 'Molybdopterin adenylyltransferase MoaB, putative', 163, NULL, NULL, 164518),
(164519, '2.40.50.990-FF-000001', NULL, 'Elongation factor 3', 110, NULL, NULL, 164519),
(164520, '3.20.20.140-FF-000438', NULL, 'Uncharacterized protein', 105, NULL, NULL, 164520),
(164521, '2.30.30.1020-FF-000048', NULL, NULL, 175, NULL, NULL, 164521),
(164522, '3.40.50.150-FF-000566', NULL, 'tRNA (adenine(58)-N(1))-methyltransferase non-catalytic subunit TRM6', 117, NULL, NULL, 164522),
(164523, '1.10.472.130-FF-000068', NULL, 'Dynein axonemal heavy chain 3', 121, NULL, NULL, 164523),
(164524, '1.20.120.550-FF-000011', NULL, 'Uncharacterized protein', 144, NULL, NULL, 164524),
(164525, '2.30.40.10-FF-000180', NULL, 'Gll3171 protein', 51, NULL, NULL, 164525),
(164526, '1.10.510.10-FF-003811', NULL, NULL, 117, NULL, NULL, 164526),
(164527, '3.90.190.10-FF-000146', NULL, 'Predicted protein', 294, NULL, NULL, 164527),
(164528, '2.170.270.10-FF-000070', NULL, 'protein msta', 113, NULL, NULL, 164528),
(164529, '3.40.190.10-FF-000320', NULL, 'LysR family transcriptional regulator', 104, NULL, NULL, 164529),
(164530, '3.40.50.20-FF-000068', NULL, 'Trifunctional purine biosynthetic protein adenosine-3', 50, NULL, NULL, 164530),
(164531, '3.40.50.150-FF-001634', NULL, NULL, 329, NULL, NULL, 164531),
(164532, '3.30.230.70-FF-000131', NULL, '3'' exoribonuclease family, domain 1 containing protein', 199, NULL, NULL, 164532),
(164533, '1.10.287.1250-FF-000005', NULL, 'Phosphotransferase', 38, NULL, NULL, 164533),
(164534, '3.30.70.330-FF-002498', NULL, NULL, 73, NULL, NULL, 164534),
(164535, '2.70.98.10-FF-000120', NULL, 'Glucan 14-alpha-glucosidase Cga', 294, NULL, NULL, 164535),
(164536, '2.10.25.10-FF-001325', NULL, 'Notch receptor 3', 28, NULL, NULL, 164536),
(164537, '3.80.10.10-FF-001713', NULL, 'Immunoglobulin superfamily-containing leucine-rich repeat 2', 115, NULL, NULL, 164537),
(164538, '3.40.50.300-FF-002545', NULL, 'ATP-dependent DNA helicase DinG', 179, NULL, NULL, 164538),
(164539, '1.10.510.10-FF-003171', NULL, NULL, 242, NULL, NULL, 164539),
(164540, '1.25.40.10-FF-000913', NULL, 'Os01g0814300 protein', 161, NULL, NULL, 164540),
(164541, '2.130.10.10-FF-001634', NULL, 'Dynein, axonemal, intermediate chain 2b', 183, NULL, NULL, 164541),
(164542, '1.10.540.10-FF-000025', NULL, 'Related to Dibenzothiophene desulfurization enzyme C', 118, NULL, NULL, 164542),
(164543, '2.40.40.50-FF-000005', NULL, 'Ubiquitin recognition factor in ER-associated degradation 1', 75, NULL, NULL, 164543),
(164544, '2.60.40.60-FF-000524', NULL, 'Dachsous cadherin-related 1a', 107, NULL, NULL, 164544); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(164545, '3.30.500.10-FF-000016', NULL, NULL, 106, NULL, NULL, 164545),
(164546, '2.30.29.30-FF-000889', NULL, 'Uncharacterized protein', 168, NULL, NULL, 164546),
(164547, '2.60.40.1120-FF-000043', NULL, 'Predicted protein', 80, NULL, NULL, 164547),
(164548, '1.10.510.10-FF-001607', NULL, 'Protein kinase, putative', 325, NULL, NULL, 164548),
(164549, '2.60.40.10-FF-000993', NULL, 'vascular endothelial growth factor receptor 3', 84, NULL, NULL, 164549),
(164550, '3.10.129.10-FF-000281', NULL, 'Uncharacterized protein', 59, NULL, NULL, 164550),
(164551, '3.40.30.10-FF-000648', NULL, 'Thioredoxin (TrxA-1)', 109, NULL, NULL, 164551),
(164552, '2.60.40.10-FF-005293', NULL, NULL, 82, NULL, NULL, 164552),
(164553, '1.10.600.10-FF-000064', NULL, 'Terpene synthase', 320, NULL, NULL, 164553),
(164554, '1.20.1250.20-FF-001126', NULL, 'Related to multidrug resistance proteins', 188, NULL, NULL, 164554),
(164555, '3.20.10.10-FF-000075', NULL, 'Predicted protein', 42, NULL, NULL, 164555),
(164556, '2.30.29.30-FF-000417', NULL, 'Trio, isoform B', 123, NULL, NULL, 164556),
(164557, '1.25.40.10-FF-001369', NULL, 'Pentatricopeptide repeat-containing protein At3g05340', 97, NULL, NULL, 164557),
(164558, '3.40.50.1360-FF-000012', NULL, 'LsrR family transcriptional regulator', 248, NULL, NULL, 164558),
(164559, '3.10.580.10-FF-000166', NULL, 'Chloride channel protein A', 80, NULL, NULL, 164559),
(164560, '3.60.21.10-FF-000391', NULL, 'Protein phosphatase from PCR D6', 24, NULL, NULL, 164560),
(164561, '3.40.20.10-FF-000142', NULL, 'Gelsolin-related protein of 125 kDa', 113, NULL, NULL, 164561),
(164562, '3.40.50.1360-FF-000063', NULL, 'Predicted protein', 107, NULL, NULL, 164562),
(164563, '3.30.559.10-FF-000168', NULL, 'Uncharacterized protein', 169, NULL, NULL, 164563),
(164564, '3.80.10.10-FF-000706', NULL, 'Ubiquitin-protein ligase', 105, NULL, NULL, 164564),
(164565, '1.10.287.70-FF-000228', NULL, 'Cyclic nucleotide-binding transporter 1', 256, NULL, NULL, 164565),
(164566, '3.30.160.60-FF-005793', NULL, NULL, 36, NULL, NULL, 164566),
(164567, '3.90.70.10-FF-000272', NULL, 'Ubiquitin carboxyl-terminal hydrolase domain containing protein', 267, NULL, NULL, 164567),
(164568, '3.40.630.10-FF-000304', NULL, 'Uncharacterized protein', 219, NULL, NULL, 164568),
(164569, '3.30.70.100-FF-000097', NULL, 'Copper chaperone', 69, NULL, NULL, 164569),
(164570, '2.60.120.970-FF-000009', NULL, 'bone morphogenetic protein 2', 244, NULL, NULL, 164570),
(164571, '1.20.1270.60-FF-000004', NULL, 'Arf-GAP with SH3 domain, ANK repeat and PH domain-containing protein 1', 254, NULL, NULL, 164571),
(164572, '2.130.10.10-FF-005849', NULL, 'Uncharacterized protein', 335, NULL, NULL, 164572),
(164573, '3.30.200.20-FF-001322', NULL, 'Protein_kinase_-_putative', 58, NULL, NULL, 164573),
(164574, '4.10.240.10-FF-000142', NULL, 'Fungal zinc cluster transcription factor, putative', 86, NULL, NULL, 164574),
(164575, '3.40.50.620-FF-000870', NULL, 'Uncharacterized protein', 136, NULL, NULL, 164575),
(164576, '3.30.200.20-FF-001761', NULL, 'TP53-regulating kinase-like protein', 46, NULL, NULL, 164576),
(164577, '1.50.40.10-FF-000237', NULL, 'Solute carrier family 25 member 46-B', 167, NULL, NULL, 164577),
(164578, '2.60.120.380-FF-000046', NULL, 'Calpain 14', 97, NULL, NULL, 164578),
(164579, '1.10.10.10-FF-000181', NULL, 'LysR family transcriptional regulator', 88, NULL, NULL, 164579),
(164580, '2.80.10.70-FF-000002', NULL, 'spindlin-2B isoform X2', 34, NULL, NULL, 164580),
(164581, '3.30.190.20-FF-000022', NULL, 'LSU ribosomal protein L1P', 103, NULL, NULL, 164581),
(164582, '3.30.160.60-FF-004753', NULL, NULL, 58, NULL, NULL, 164582),
(164583, '3.30.920.10-FF-000008', NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', 116, NULL, NULL, 164583),
(164584, '2.60.40.10-FF-003747', NULL, NULL, 106, NULL, NULL, 164584),
(164585, '3.30.70.330-FF-001458', NULL, NULL, 116, NULL, NULL, 164585),
(164586, '2.130.10.10-FF-002191', NULL, 'WD repeat-containing protein 48 homolog', 276, NULL, NULL, 164586),
(164587, '1.20.1740.10-FF-000155', NULL, 'Uncharacterized protein', 129, NULL, NULL, 164587);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(164588, '3.30.70.330-FF-003015', NULL, NULL, 74, NULL, NULL, 164588),
(164589, '3.50.50.60-FF-001260', NULL, 'L-amino-acid oxidase', 108, NULL, NULL, 164589),
(164590, '2.40.10.10-FF-000071', NULL, 'Prothrombin', 117, NULL, NULL, 164590),
(164591, '3.40.190.10-FF-000371', NULL, 'Alpha-keto acid-binding periplasmic protein TakP', 114, NULL, NULL, 164591),
(164592, '1.25.40.10-FF-004224', NULL, 'Uncharacterized protein', 266, NULL, NULL, 164592),
(164593, '3.40.33.10-FF-000042', NULL, 'Venom allergen 3-like Protein', 177, NULL, NULL, 164593),
(164594, '3.30.420.40-FF-000451', NULL, 'Actin, putative', 148, NULL, NULL, 164594),
(164595, '2.60.200.10-FF-000035', NULL, 'interferon regulatory factor like protein isoform X1', 185, NULL, NULL, 164595),
(164596, '2.10.25.10-FF-001376', NULL, 'Growth arrest-specific 6', 38, NULL, NULL, 164596),
(164597, '3.40.1110.10-FF-000180', NULL, 'Phospholipid-transporting ATPase', 161, NULL, NULL, 164597),
(164598, '1.10.520.10-FF-000063', NULL, 'Os01g0293900 protein', 72, NULL, NULL, 164598),
(164599, '1.50.40.10-FF-000288', NULL, 'Putative mitochondrial carrier protein', 124, NULL, NULL, 164599),
(164600, '3.10.100.10-FF-000198', NULL, 'Intimin', 98, NULL, NULL, 164600),
(164601, '1.20.120.1900-FF-000053', NULL, 'Spindle pole body component', 301, NULL, NULL, 164601),
(164602, '3.40.1170.10-FF-000037', NULL, 'DNA mismatch repair protein', 159, NULL, NULL, 164602),
(164603, '3.30.470.20-FF-000004', NULL, 'Carbamoyl-phosphate synthase (glutamine-hydrolyzing)', 198, NULL, NULL, 164603),
(164604, '3.30.900.10-FF-000046', NULL, 'Uncharacterized protein', 156, NULL, NULL, 164604),
(164605, '1.20.85.10-FF-000010', NULL, 'Uncharacterized protein', 123, NULL, NULL, 164605),
(164606, '1.20.5.170-FF-000174', NULL, 'Predicted protein', 139, NULL, NULL, 164606),
(164607, '2.60.40.60-FF-000575', NULL, 'Uncharacterized protein', 103, NULL, NULL, 164607),
(164608, '1.20.1250.20-FF-000137', NULL, 'Probable inositol transporter 2', 140, NULL, NULL, 164608),
(164609, '3.40.50.1980-FF-000041', NULL, 'Iron-hydroxamate ABC transporter substrate-binding protein', 161, NULL, NULL, 164609),
(164610, '3.40.250.10-FF-000258', NULL, 'Uncharacterized protein', 154, NULL, NULL, 164610),
(164611, '1.10.510.10-FF-001658', NULL, 'Os03g0748400 protein', 85, NULL, NULL, 164611),
(164612, '3.40.50.300-FF-004574', NULL, 'Adenylate/guanylate cyclase domain-containing protein', 202, NULL, NULL, 164612),
(164613, '1.10.1370.40-FF-000008', NULL, 'Oligopeptidase, putative', 153, NULL, NULL, 164613),
(164614, '3.80.10.10-FF-002270', NULL, 'YALI0C06556p', 97, NULL, NULL, 164614),
(164615, '3.40.850.10-FF-000399', NULL, 'Kinesin-like protein', 279, NULL, NULL, 164615),
(164616, '3.40.605.10-FF-000083', NULL, 'Uncharacterized protein', 218, NULL, NULL, 164616),
(164617, '3.10.180.10-FF-000118', NULL, 'Uncharacterized protein', 113, NULL, NULL, 164617),
(164618, '1.10.630.10-FF-000245', NULL, 'Cytochrome P450 monooxygenase, putative', 479, NULL, NULL, 164618),
(164619, '2.110.10.10-FF-000016', NULL, 'Matrix metallopeptidase 25', 197, NULL, NULL, 164619),
(164620, '2.40.70.10-FF-000080', NULL, 'Plasmepsin V', 193, NULL, NULL, 164620),
(164621, '3.40.47.10-FF-000063', NULL, 'Trifunctional enzyme subunit beta, mitochondrial', 105, NULL, NULL, 164621),
(164622, '2.70.150.10-FF-000225', NULL, 'Uncharacterized protein', 35, NULL, NULL, 164622),
(164623, '1.25.40.20-FF-001259', NULL, 'Predicted protein', 210, NULL, NULL, 164623),
(164624, '1.20.920.20-FF-000004', NULL, 'Dynein axonemal heavy chain 5', 353, NULL, NULL, 164624),
(164625, '2.60.40.150-FF-000518', NULL, 'Uncharacterized protein', 111, NULL, NULL, 164625),
(164626, '2.30.42.10-FF-000015', NULL, 'Membrane associated guanylate kinase, WW and PDZ domain containing 1', 111, NULL, NULL, 164626),
(164627, '2.10.25.10-FF-000920', NULL, 'protein eyes shut homolog', 39, NULL, NULL, 164627),
(164628, '2.60.120.10-FF-000422', NULL, 'Oxalate decarboxylase', 195, NULL, NULL, 164628),
(164629, '3.90.230.10-FF-000021', NULL, 'Transcription factor-like protein', 256, NULL, NULL, 164629);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(164630, '1.20.120.140-FF-000001', NULL, 'Signal recognition particle GTPase', 110, NULL, NULL, 164630),
(164631, '1.20.58.400-FF-000046', NULL, 'Uncharacterized protein', 96, NULL, NULL, 164631),
(164632, '3.40.50.2300-FF-001132', NULL, NULL, 101, NULL, NULL, 164632),
(164633, '2.60.40.10-FF-001982', NULL, 'Titin homolog', 96, NULL, NULL, 164633),
(164634, '3.30.1680.10-FF-000073', NULL, 'Plexin C1', 30, NULL, NULL, 164634),
(164635, '1.25.10.10-FF-002098', NULL, 'Os03g0435300 protein', 106, NULL, NULL, 164635),
(164636, '1.10.472.80-FF-000191', NULL, NULL, 128, NULL, NULL, 164636),
(164637, '3.40.50.300-FF-007328', NULL, 'Uncharacterized protein MJECL44', 144, NULL, NULL, 164637),
(164638, '1.10.1370.20-FF-000002', NULL, 'Oligoendopeptidase F homolog', 373, NULL, NULL, 164638),
(164639, '3.90.190.10-FF-000354', NULL, 'Dual-specificity phosphatase 19b', 143, NULL, NULL, 164639),
(164640, '2.60.120.1190-FF-000013', NULL, 'Uncharacterized protein', 181, NULL, NULL, 164640),
(164641, '3.90.550.10-FF-000337', NULL, 'Glycosyl transferase', 206, NULL, NULL, 164641),
(164642, '3.40.50.12780-FF-000149', NULL, 'Nonribosomal peptide synthase Pes1 (Eurofung)', 397, NULL, NULL, 164642),
(164643, '1.25.40.10-FF-001470', NULL, 'Putative pentatricopeptide repeat-containing protein At5g59200, chloroplastic', 133, NULL, NULL, 164643),
(164644, '3.40.50.1240-FF-000061', NULL, 'YDR051C-like protein', 220, NULL, NULL, 164644),
(164645, '3.20.20.300-FF-000014', NULL, 'Beta-hexosaminidase, lipoprotein', 378, NULL, NULL, 164645),
(164646, '1.25.40.20-FF-001698', NULL, 'Kinase, NEK', 63, NULL, NULL, 164646),
(164647, '3.40.33.10-FF-000093', NULL, 'Os07g0128700 protein', 163, NULL, NULL, 164647),
(164648, '1.10.3720.10-FF-000010', NULL, 'Maltose ABC transporter permease MalG', 283, NULL, NULL, 164648),
(164649, '3.80.10.10-FF-003579', NULL, 'Uncharacterized protein', 141, NULL, NULL, 164649),
(164650, '2.30.30.40-FF-000603', NULL, 'Uncharacterized protein', 57, NULL, NULL, 164650),
(164651, '3.30.70.1350-FF-000040', NULL, NULL, 98, NULL, NULL, 164651),
(164652, '1.20.120.1070-FF-000011', NULL, 'Translation initiation factor eIF-2B alpha subunit', 104, NULL, NULL, 164652),
(164653, '3.30.30.30-FF-000036', NULL, 'Hsp70_protein_-_putative', 75, NULL, NULL, 164653),
(164654, '2.130.10.10-FF-003612', NULL, 'U3 small nucleolar RNA-associated protein 15 homolog-like Protein', 169, NULL, NULL, 164654),
(164655, '2.40.50.140-FF-001000', NULL, NULL, 56, NULL, NULL, 164655),
(164656, '4.10.400.10-FF-000144', NULL, 'enteropeptidase', 40, NULL, NULL, 164656),
(164657, '1.10.443.20-FF-000004', NULL, 'Uncharacterized protein', 369, NULL, NULL, 164657),
(164658, '3.30.160.20-FF-000245', NULL, 'Double-stranded RNA-specific editase B2, putative', 87, NULL, NULL, 164658),
(164659, '3.40.50.200-FF-000036', NULL, 'Serin endopeptidase', 239, NULL, NULL, 164659),
(164660, '1.10.3730.20-FF-000053', NULL, 'EamA-like transporter family protein', 143, NULL, NULL, 164660),
(164661, '3.20.20.70-FF-000284', NULL, 'Possible oxidoreductase', 321, NULL, NULL, 164661),
(164662, '3.40.50.2300-FF-000676', NULL, 'Hybrid sensor histidine kinase/response regulator', 139, NULL, NULL, 164662),
(164663, '2.40.420.20-FF-000014', NULL, 'Cation efflux system protein', 91, NULL, NULL, 164663),
(164664, '1.10.287.920-FF-000006', NULL, 'Uncharacterized protein', 80, NULL, NULL, 164664),
(164665, '2.60.120.10-FF-000034', NULL, 'Homogentisate 1,2-dioxygenase', 137, NULL, NULL, 164665),
(164666, '2.60.120.200-FF-000245', NULL, 'Similar to lectin family integral membrane protein', 221, NULL, NULL, 164666),
(164667, '3.10.28.10-FF-000003', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 114, NULL, NULL, 164667),
(164668, '1.10.8.530-FF-000003', NULL, 'DNA polymerase alpha subunit B', 79, NULL, NULL, 164668),
(164669, '3.40.50.960-FF-000011', NULL, '6,7-dimethyl-8-ribityllumazine synthase', 156, NULL, NULL, 164669),
(164670, '3.80.10.10-FF-000353', NULL, 'Zyg-11 family member B, cell cycle regulator', 120, NULL, NULL, 164670),
(164671, '1.10.275.40-FF-000001', NULL, 'DNA repair helicase (Rad3)', 114, NULL, NULL, 164671);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(164672, '3.30.310.130-FF-000032', NULL, 'Uncharacterized protein', 133, NULL, NULL, 164672),
(164673, '3.30.70.330-FF-002818', NULL, NULL, 92, NULL, NULL, 164673),
(164674, '3.30.565.10-FF-000340', NULL, 'Histidine kinase', 137, NULL, NULL, 164674),
(164675, '2.170.16.10-FF-000049', NULL, 'ATP-dependent DNA helicase Hel308', 102, NULL, NULL, 164675),
(164676, '2.60.40.1730-FF-000113', NULL, NULL, 108, NULL, NULL, 164676),
(164677, '3.90.79.10-FF-000292', NULL, 'Adenine DNA glycosylase', 182, NULL, NULL, 164677),
(164678, '3.30.2130.30-FF-000049', NULL, 'Predicted protein', 31, NULL, NULL, 164678),
(164679, '3.90.70.10-FF-000221', NULL, 'Ubiquitin-specific peptidase 32', 107, NULL, NULL, 164679),
(164680, '3.10.20.90-FF-000482', NULL, 'Small ubiquitin-related modifier 2', 93, NULL, NULL, 164680),
(164681, '1.20.1560.10-FF-000169', NULL, 'Drug efflux ABC transporter, ATP-binding/permease protein', 295, NULL, NULL, 164681),
(164682, '3.30.160.60-FF-000419', NULL, 'Early growth response protein 4', 28, NULL, NULL, 164682),
(164683, '3.90.79.10-FF-000241', NULL, 'MutT/nudix family protein', 179, NULL, NULL, 164683),
(164684, '1.25.40.10-FF-003786', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 150, NULL, NULL, 164684),
(164685, '2.160.20.10-FF-000088', NULL, 'Cell surface protein', 263, NULL, NULL, 164685),
(164686, '3.20.20.150-FF-000031', NULL, 'Probable endonuclease 4', 282, NULL, NULL, 164686),
(164687, '3.40.50.300-FF-005563', NULL, 'Polynucleotide kinase 3''-phosphatase, putative', 176, NULL, NULL, 164687),
(164688, '3.40.50.980-FF-000017', NULL, 'Acetyl-CoA synthetase', 233, NULL, NULL, 164688),
(164689, '1.25.10.10-FF-001642', NULL, 'TELO2-interacting protein 2', 442, NULL, NULL, 164689),
(164690, '1.25.40.10-FF-003347', NULL, 'Pre-mRNA-splicing factor CLF1', 84, NULL, NULL, 164690),
(164691, '3.40.50.300-FF-005451', NULL, 'Related to ATP-binding cassette, sub-family A', 242, NULL, NULL, 164691),
(164692, '3.10.290.60-FF-000001', NULL, 'Ubiquitin-activating enzyme E1 2', 93, NULL, NULL, 164692),
(164693, '2.60.120.260-FF-000577', NULL, 'Uncharacterized protein', 179, NULL, NULL, 164693),
(164694, '1.25.40.10-FF-003235', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 198, NULL, NULL, 164694),
(164695, '3.40.50.280-FF-000021', NULL, 'Uncharacterized protein', 106, NULL, NULL, 164695),
(164696, '3.40.50.720-FF-000170', NULL, 'T-protein', 165, NULL, NULL, 164696),
(164697, '3.20.20.300-FF-000065', NULL, NULL, 332, NULL, NULL, 164697),
(164698, '3.30.1360.10-FF-000026', NULL, 'RNA polymerase II subunit Rpb11', 126, NULL, NULL, 164698),
(164699, '3.30.450.50-FF-000068', NULL, 'Uncharacterized protein', 47, NULL, NULL, 164699),
(164700, '3.30.450.20-FF-000525', NULL, 'Histidine kinase', 49, NULL, NULL, 164700),
(164701, '3.30.300.10-FF-000017', NULL, 'GMP synthase [glutamine-hydrolyzing]', 115, NULL, NULL, 164701),
(164702, '2.40.290.10-FF-000011', NULL, 'DNA binding protein', 113, NULL, NULL, 164702),
(164703, '3.60.110.10-FF-000058', NULL, NULL, 78, NULL, NULL, 164703),
(164704, '2.40.10.10-FF-000183', NULL, 'Complement component 1, s subcomponent', 252, NULL, NULL, 164704),
(164705, '3.30.70.60-FF-000025', NULL, '30S ribosomal protein S6', 101, NULL, NULL, 164705),
(164706, '3.30.420.10-FF-000083', NULL, 'SET domain and mariner transposase fusion gene', 226, NULL, NULL, 164706),
(164707, '3.30.450.20-FF-000121', NULL, 'Uncharacterized protein, isoform B', 111, NULL, NULL, 164707),
(164708, '2.40.50.100-FF-000218', NULL, 'Iron(III)-transport ATP-binding protein sfuC', 35, NULL, NULL, 164708),
(164709, '3.60.40.10-FF-000344', NULL, 'Os02g0599200 protein', 105, NULL, NULL, 164709),
(164710, '1.10.472.10-FF-000372', NULL, 'Uncharacterized protein', 95, NULL, NULL, 164710),
(164711, '1.25.10.10-FF-001693', NULL, 'AGR238Cp', 279, NULL, NULL, 164711),
(164712, '2.40.128.20-FF-000031', NULL, 'Phenolic acid decarboxylase', 166, NULL, NULL, 164712),
(164713, '3.40.50.10810-FF-000250', NULL, 'Uncharacterized protein', 134, NULL, NULL, 164713),
(164714, '3.40.50.300-FF-004462', NULL, 'Uncharacterized protein', 17, NULL, NULL, 164714); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(164715, '3.80.10.10-FF-002382', NULL, 'YALI0C14740p', 120, NULL, NULL, 164715),
(164716, '3.30.70.1430-FF-000007', NULL, 'Multidrug transporter AcrB', 104, NULL, NULL, 164716),
(164717, '3.40.630.30-FF-000523', NULL, 'Uncharacterized protein', 111, NULL, NULL, 164717),
(164718, '3.30.200.20-FF-001710', NULL, 'Serine/threonine protein kinase', 42, NULL, NULL, 164718),
(164719, '3.90.1750.10-FF-000076', NULL, 'UBR E3 ubiquitin ligase homolog', 158, NULL, NULL, 164719),
(164720, '1.25.40.10-FF-003286', NULL, 'Uncharacterized protein', 129, NULL, NULL, 164720),
(164721, '2.30.110.10-FF-000012', NULL, 'Predicted protein', 196, NULL, NULL, 164721),
(164722, '1.20.920.20-FF-000055', NULL, 'Uncharacterized protein', 158, NULL, NULL, 164722),
(164723, '3.40.850.10-FF-000287', NULL, 'Predicted protein', 147, NULL, NULL, 164723),
(164724, '3.40.50.300-FF-000780', NULL, 'Rho GTPase Rho3', 186, NULL, NULL, 164724),
(164725, '3.30.1640.10-FF-000008', NULL, 'DNA helicase', 105, NULL, NULL, 164725),
(164726, '2.20.70.10-FF-000210', NULL, 'Rho GTPase activating protein 27', 31, NULL, NULL, 164726),
(164727, '2.30.30.40-FF-000103', NULL, 'Amphiphysin', 82, NULL, NULL, 164727),
(164728, '2.60.120.290-FF-000092', NULL, 'Cubilin homolog', 115, NULL, NULL, 164728),
(164729, '1.10.8.10-FF-000073', NULL, 'NEDD8 ultimate buster 1 isoform X1', 38, NULL, NULL, 164729),
(164730, '2.130.10.10-FF-002039', NULL, 'WD_domain_-_G-beta_repeat_-_putative', 217, NULL, NULL, 164730),
(164731, '3.10.20.90-FF-000431', NULL, 'Protein CBG06226', 100, NULL, NULL, 164731),
(164732, '1.25.40.20-FF-001147', NULL, 'Serine/threonine-protein kinase NEK', 143, NULL, NULL, 164732),
(164733, '3.40.605.10-FF-000032', NULL, 'Aldehyde dehydrogenase family 16 member A1', 246, NULL, NULL, 164733),
(164734, '3.30.70.2760-FF-000013', NULL, NULL, 91, NULL, NULL, 164734),
(164735, '1.20.1310.10-FF-000010', NULL, 'Cullin 4B', 132, NULL, NULL, 164735),
(164736, '3.40.50.150-FF-000274', NULL, 'ERF1 methyltransferase catalytic subunit MTQ2', 249, NULL, NULL, 164736),
(164737, '4.10.240.10-FF-000193', NULL, 'Uncharacterized protein', 67, NULL, NULL, 164737),
(164738, '3.40.800.20-FF-000045', NULL, 'Histone deacetylase', 233, NULL, NULL, 164738),
(164739, '3.40.390.10-FF-000268', NULL, NULL, 172, NULL, NULL, 164739),
(164740, '2.120.10.80-FF-000115', NULL, 'Kelch like family member 42', 172, NULL, NULL, 164740),
(164741, '3.80.10.10-FF-004068', NULL, 'Uncharacterized protein', 131, NULL, NULL, 164741),
(164742, '3.30.70.330-FF-000109', NULL, 'Heterogeneous nuclear ribonucleoprotein a1 isoform', 81, NULL, NULL, 164742),
(164743, '1.10.630.10-FF-000296', NULL, 'Cholesterol side-chain cleavage enzyme, mitochondrial', 132, NULL, NULL, 164743),
(164744, '3.40.50.300-FF-002157', NULL, 'Type IV pilus twitching motility protein PilT', 230, NULL, NULL, 164744),
(164745, '2.60.120.10-FF-000534', NULL, 'Uncharacterized protein', 118, NULL, NULL, 164745),
(164746, '4.10.400.10-FF-000195', NULL, 'Sortilin-related receptor', 45, NULL, NULL, 164746),
(164747, '3.90.190.10-FF-000466', NULL, 'Uncharacterized protein', 188, NULL, NULL, 164747),
(164748, '2.120.10.30-FF-000033', NULL, 'teneurin-a isoform X3', 153, NULL, NULL, 164748),
(164749, '2.40.50.140-FF-000595', NULL, 'Uncharacterized protein 100H1.110', 125, NULL, NULL, 164749),
(164750, '3.40.850.10-FF-000348', NULL, 'Myosin XVIIIB', 222, NULL, NULL, 164750),
(164751, '3.40.50.720-FF-002047', NULL, 'Uncharacterized protein', 177, NULL, NULL, 164751),
(164752, '2.60.40.150-FF-000406', NULL, 'Activating signal cointegrator 1 complex subunit 3', 140, NULL, NULL, 164752),
(164753, '1.20.1560.10-FF-000118', NULL, 'Multidrug resistance protein 2 (Heavy metal transport family)', 340, NULL, NULL, 164753),
(164754, '2.40.30.10-FF-000015', NULL, 'Translation factor GUF1, mitochondrial', 99, NULL, NULL, 164754),
(164755, '3.30.1460.70-FF-000001', NULL, 'Putative sensory transduction regulator', 152, NULL, NULL, 164755),
(164756, '3.30.160.60-FF-006310', NULL, NULL, 29, NULL, NULL, 164756),
(164757, '2.80.10.50-FF-000255', NULL, 'Fascin', 107, NULL, NULL, 164757);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(164758, '3.80.10.10-FF-000757', NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', 89, NULL, NULL, 164758),
(164759, '3.90.226.10-FF-000123', NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', 385, NULL, NULL, 164759),
(164760, '3.40.630.30-FF-000462', NULL, 'Lmo1129 protein', 170, NULL, NULL, 164760),
(164761, '3.90.550.10-FF-000449', NULL, 'Predicted protein', 473, NULL, NULL, 164761),
(164762, '3.10.150.10-FF-000021', NULL, 'DNA polymerase III, beta subunit', 126, NULL, NULL, 164762),
(164763, '2.30.38.10-FF-000005', NULL, 'Luciferin 4-monooxygenase', 80, NULL, NULL, 164763),
(164764, '1.10.640.10-FF-000010', NULL, 'Thyroid peroxidase', 146, NULL, NULL, 164764),
(164765, '2.30.29.30-FF-000529', NULL, 'Nuclear protein export protein Yrb2', 191, NULL, NULL, 164765),
(164766, '2.40.10.10-FF-000424', NULL, 'AGAP001252-PA', 233, NULL, NULL, 164766),
(164767, '3.40.50.300-FF-007249', NULL, 'Uncharacterized protein', 159, NULL, NULL, 164767),
(164768, '3.40.190.80-FF-000060', NULL, 'Uncharacterized protein', 129, NULL, NULL, 164768),
(164769, '1.25.40.20-FF-000742', NULL, 'Kinase, NEK', 87, NULL, NULL, 164769),
(164770, '3.40.50.300-FF-007980', NULL, 'Uncharacterized protein', 159, NULL, NULL, 164770),
(164771, '1.25.40.450-FF-000012', NULL, 'Nuclear pore complex protein Nup155', 172, NULL, NULL, 164771),
(164772, '1.20.58.340-FF-000016', NULL, 'Magnesium transporter ALR1', 120, NULL, NULL, 164772),
(164773, '3.40.120.10-FF-000097', NULL, 'Phosphoglucomutase/phosphomannomutase family protein', 109, NULL, NULL, 164773),
(164774, '1.20.58.1210-FF-000017', NULL, 'Uncharacterized protein', 81, NULL, NULL, 164774),
(164775, '3.10.129.10-FF-000213', NULL, 'Acyl-CoA thioesterase', 129, NULL, NULL, 164775),
(164776, '1.10.560.10-FF-000088', NULL, 'T-complex protein 1 delta subunit putative', 122, NULL, NULL, 164776),
(164777, '3.50.50.60-FF-000203', NULL, 'Related to sulfide:quinone oxidoreductase, mitochondrial', 146, NULL, NULL, 164777),
(164778, '3.30.420.140-FF-000020', NULL, 'Putative pre-16S rRNA nuclease', 140, NULL, NULL, 164778),
(164779, '3.40.33.10-FF-000121', NULL, 'Uncharacterized protein', 158, NULL, NULL, 164779),
(164780, '1.25.40.10-FF-004303', NULL, 'Uncharacterized protein', 193, NULL, NULL, 164780),
(164781, '3.30.60.270-FF-000005', NULL, 'Sortilin', 81, NULL, NULL, 164781),
(164782, '3.10.20.90-FF-000931', NULL, 'Uncharacterized protein', 80, NULL, NULL, 164782),
(164783, '3.90.1490.10-FF-000005', NULL, 'Cytoplasmic protein, variant', 93, NULL, NULL, 164783),
(164784, '2.30.42.10-FF-000515', NULL, NULL, 78, NULL, NULL, 164784),
(164785, '1.10.10.60-FF-001123', NULL, NULL, 101, NULL, NULL, 164785),
(164786, '1.25.10.10-FF-002598', NULL, 'Os04g0608500 protein', 149, NULL, NULL, 164786),
(164787, '1.25.40.10-FF-003735', NULL, 'Predicted protein', 115, NULL, NULL, 164787),
(164788, '1.25.40.20-FF-000450', NULL, 'Kinase D-interacting substrate 220', 90, NULL, NULL, 164788),
(164789, '1.10.238.10-FF-001233', NULL, 'Myosin light chain 1', 104, NULL, NULL, 164789),
(164790, '3.90.226.10-FF-000191', NULL, '6-oxocamphor hydrolase', 257, NULL, NULL, 164790),
(164791, '1.10.10.60-FF-000555', NULL, 'Homeobox domain containing protein 10', 58, NULL, NULL, 164791),
(164792, '1.10.10.10-FF-000113', NULL, 'ETS domain-containing protein Elk-3', 101, NULL, NULL, 164792),
(164793, '1.20.58.60-FF-000709', NULL, 'Spectrin repeat containing nuclear envelope protein 2', 110, NULL, NULL, 164793),
(164794, '1.25.40.250-FF-000003', NULL, 'Eukaryotic translation initiation factor 3 subunit K', 135, NULL, NULL, 164794),
(164795, '3.50.50.60-FF-000383', NULL, 'protein anon-37Cs', 225, NULL, NULL, 164795),
(164796, '1.10.510.10-FF-003575', NULL, NULL, 215, NULL, NULL, 164796),
(164797, '2.40.10.10-FF-000132', NULL, 'Inactive serine protease 54', 115, NULL, NULL, 164797),
(164798, '2.170.120.20-FF-000005', NULL, '50S ribosomal protein L25', 87, NULL, NULL, 164798),
(164799, '1.10.420.10-FF-000027', NULL, 'Peroxidase', 144, NULL, NULL, 164799),
(164800, '3.40.50.2300-FF-001632', NULL, NULL, 268, NULL, NULL, 164800);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(164801, '3.40.50.1010-FF-000042', NULL, 'Ribonuclease VapC', 133, NULL, NULL, 164801),
(164802, '1.10.533.10-FF-000042', NULL, 'Tumor necrosis factor receptor type 1-associated DEATH domain protein', 90, NULL, NULL, 164802),
(164803, '2.60.40.150-FF-000165', NULL, 'rho GTPase-activating protein 100F isoform X6', 127, NULL, NULL, 164803),
(164804, '1.10.238.10-FF-000957', NULL, 'Probable calcium-binding protein CML21', 177, NULL, NULL, 164804),
(164805, '1.20.960.20-FF-000001', NULL, 'Genome polyprotein', 87, NULL, NULL, 164805),
(164806, '1.20.1250.20-FF-000249', NULL, 'facilitated trehalose transporter Tret1', 453, NULL, NULL, 164806),
(164807, '3.40.50.300-FF-000628', NULL, 'Endoribonuclease Dicer', 234, NULL, NULL, 164807),
(164808, '1.20.5.1230-FF-000006', NULL, NULL, 116, NULL, NULL, 164808),
(164809, '2.60.40.1230-FF-000025', NULL, 'AdaPTin or adaptin-related protein', 137, NULL, NULL, 164809),
(164810, '2.10.25.10-FF-001404', NULL, 'Uncharacterized protein', 37, NULL, NULL, 164810),
(164811, '3.80.10.10-FF-002202', NULL, 'DmMstProx', 164, NULL, NULL, 164811),
(164812, '1.10.630.10-FF-000745', NULL, 'Uncharacterized protein', 80, NULL, NULL, 164812),
(164813, '1.25.10.10-FF-003166', NULL, 'Serine/threonine-protein kinase TOR', 347, NULL, NULL, 164813),
(164814, '1.25.40.470-FF-000018', NULL, 'Reduced mechanoreceptor potential A', 189, NULL, NULL, 164814),
(164815, '2.40.70.10-FF-000012', NULL, 'Aspartyl protease family protein 1', 194, NULL, NULL, 164815),
(164816, '3.40.50.2020-FF-000070', NULL, 'Ribose-phosphate pyrophosphokinase, putative', 153, NULL, NULL, 164816),
(164817, '3.80.10.10-FF-003630', NULL, 'Uncharacterized protein', 201, NULL, NULL, 164817),
(164818, '1.20.1250.20-FF-000688', NULL, 'Predicted arabinose efflux permease, MFS family', 180, NULL, NULL, 164818),
(164819, '3.30.1490.20-FF-000016', NULL, 'phosphoribosylaminoimidazole carboxylase, chloroplastic', 70, NULL, NULL, 164819),
(164820, '3.30.160.60-FF-002836', NULL, 'Spalt-related protein', 76, NULL, NULL, 164820),
(164821, '1.20.1740.10-FF-000267', NULL, 'Low affinity cationic amino acid transporter 2-like Protein', 354, NULL, NULL, 164821),
(164822, '3.90.105.10-FF-000005', NULL, 'Molybdopterin molybdenumtransferase', 56, NULL, NULL, 164822),
(164823, '3.40.50.1820-FF-001656', NULL, 'Carboxypeptidase', 313, NULL, NULL, 164823),
(164824, '2.40.10.10-FF-000475', NULL, 'Azurocidin', 112, NULL, NULL, 164824),
(164825, '3.40.30.10-FF-001137', NULL, 'Os01g0353400 protein', 67, NULL, NULL, 164825),
(164826, '3.30.160.60-FF-002887', NULL, 'Zinc finger protein 263 isoform X2', 26, NULL, NULL, 164826),
(164827, '3.40.50.300-FF-003938', NULL, 'Shikimate kinase', 174, NULL, NULL, 164827),
(164828, '3.30.160.60-FF-001931', NULL, 'Zinc finger protein 92', 25, NULL, NULL, 164828),
(164829, '3.30.450.20-FF-000413', NULL, 'Hybrid signal transduction histidine kinase I', 106, NULL, NULL, 164829),
(164830, '2.130.10.10-FF-002691', NULL, 'Uncharacterized protein', 329, NULL, NULL, 164830),
(164831, '1.20.5.170-FF-000106', NULL, 'Chromatin structure-remodeling complex subunit snf21', 75, NULL, NULL, 164831),
(164832, '1.10.8.60-FF-000594', NULL, 'Cell division control protein', 88, NULL, NULL, 164832),
(164833, '1.10.10.10-FF-001018', NULL, 'LysR family transcriptional regulator', 85, NULL, NULL, 164833),
(164834, '2.40.30.70-FF-000005', NULL, 'Nef-associated protein 1', 143, NULL, NULL, 164834),
(164835, '2.120.10.30-FF-000533', NULL, 'Uncharacterized protein', 134, NULL, NULL, 164835),
(164836, '3.30.160.60-FF-005293', NULL, NULL, 85, NULL, NULL, 164836),
(164837, '2.60.40.3210-FF-000029', NULL, 'Zona pellucida glycoprotein 3b', 41, NULL, NULL, 164837),
(164838, '3.40.50.150-FF-001555', NULL, NULL, 79, NULL, NULL, 164838),
(164839, '1.25.40.470-FF-000069', NULL, 'WD repeat protein, putative', 173, NULL, NULL, 164839),
(164840, '3.30.1490.20-FF-000067', NULL, 'D-alanine--D-alanine ligase', 71, NULL, NULL, 164840),
(164841, '3.30.70.330-FF-002970', NULL, NULL, 99, NULL, NULL, 164841),
(164842, '3.30.160.60-FF-000066', NULL, 'Putative zinc finger E-box-binding homeobox 2', 24, NULL, NULL, 164842);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(164843, '2.70.170.10-FF-000108', NULL, 'Ligand-Gated ion Channel', 214, NULL, NULL, 164843),
(164844, '1.10.510.10-FF-002114', NULL, 'Tyrosine-protein kinase', 244, NULL, NULL, 164844),
(164845, '3.60.21.60-FF-000034', NULL, 'DNA polymerase epsilon subunit', 233, NULL, NULL, 164845),
(164846, '3.40.50.2300-FF-000917', NULL, NULL, 207, NULL, NULL, 164846),
(164847, '1.10.3210.10-FF-000039', NULL, 'Protein CBG02420', 368, NULL, NULL, 164847),
(164848, '2.30.30.140-FF-000279', NULL, 'Probable histone-lysine N-methyltransferase Mes-4', 143, NULL, NULL, 164848),
(164849, '2.60.40.10-FF-005372', NULL, NULL, 60, NULL, NULL, 164849),
(164850, '2.40.50.140-FF-000191', NULL, 'DNA-directed RNA polymerases I, II, and III subunit RPABC3', 145, NULL, NULL, 164850),
(164851, '1.10.533.10-FF-000093', NULL, 'Death-associated protein kinase dapk-1', 94, NULL, NULL, 164851),
(164852, '3.10.20.90-FF-000835', NULL, 'Chromosome 23, whole genome shotgun sequence', 93, NULL, NULL, 164852),
(164853, '2.30.30.100-FF-000115', NULL, 'Yeast Enhancer of DeCapping homolog', 76, NULL, NULL, 164853),
(164854, '3.30.460.10-FF-000080', NULL, 'Predicted protein', 152, NULL, NULL, 164854),
(164855, '1.10.630.10-FF-000796', NULL, 'Uncharacterized protein', 94, NULL, NULL, 164855),
(164856, '2.130.10.10-FF-002983', NULL, 'Protein CBG03993', 205, NULL, NULL, 164856),
(164857, '1.20.58.60-FF-000417', NULL, 'Spectrin repeat containing nuclear envelope family member 3', 138, NULL, NULL, 164857),
(164858, '3.30.590.20-FF-000002', NULL, 'Putative glutamate--cysteine ligase 2', 372, NULL, NULL, 164858),
(164859, '3.90.430.10-FF-000002', NULL, 'Uncharacterized protein', 44, NULL, NULL, 164859),
(164860, '1.10.150.20-FF-000043', NULL, 'Meiotic recombination protein DMC1 homolog', 79, NULL, NULL, 164860),
(164861, '2.30.30.1020-FF-000025', NULL, 'Subunit of the ccr4not complex', 147, NULL, NULL, 164861),
(164862, '1.10.510.10-FF-000265', NULL, 'Putative LOV domain-containing protein', 216, NULL, NULL, 164862),
(164863, '2.60.40.1970-FF-000005', NULL, 'YEATS domain-containing protein 4 isoform X2', 37, NULL, NULL, 164863),
(164864, '3.30.420.40-FF-000530', NULL, 'Heat shock protein, putative', 22, NULL, NULL, 164864),
(164865, '3.90.226.10-FF-000011', NULL, 'Fatty acid oxidation complex subunit alpha', 313, NULL, NULL, 164865),
(164866, '2.10.25.10-FF-000387', NULL, 'basement membrane-specific heparan sulfate proteoglycan core protein-like', 36, NULL, NULL, 164866),
(164867, '3.30.160.60-FF-006198', NULL, NULL, 48, NULL, NULL, 164867),
(164868, '3.30.930.10-FF-000374', NULL, 'Uncharacterized protein', 172, NULL, NULL, 164868),
(164869, '3.10.490.10-FF-000007', NULL, 'Gamma-glutamylcyclotransferase', 188, NULL, NULL, 164869),
(164870, '6.10.250.3250-FF-000003', NULL, 'Uncharacterized protein', 38, NULL, NULL, 164870),
(164871, '2.40.270.10-FF-000027', NULL, NULL, 77, NULL, NULL, 164871),
(164872, '3.40.50.2300-FF-000968', NULL, NULL, 134, NULL, NULL, 164872),
(164873, '1.10.8.60-FF-000543', NULL, 'Uncharacterized protein', 111, NULL, NULL, 164873),
(164874, '2.60.40.10-FF-001038', NULL, 'Immunoglobulin superfamily DCC subclass member 4', 107, NULL, NULL, 164874),
(164875, '1.10.560.10-FF-000060', NULL, '60 kDa chaperonin', 243, NULL, NULL, 164875),
(164876, '3.30.40.10-FF-000666', NULL, 'E3 ubiquitin-protein ligase MYLIP', 73, NULL, NULL, 164876),
(164877, '1.10.40.30-FF-000008', NULL, 'Fumarate hydratase class II', 56, NULL, NULL, 164877),
(164878, '2.60.40.10-FF-001931', NULL, 'Uncharacterized LOC100216153', 104, NULL, NULL, 164878),
(164879, '3.30.160.60-FF-003376', NULL, 'GD10244', 63, NULL, NULL, 164879),
(164880, '2.60.120.290-FF-000120', NULL, 'Uncharacterized protein', 101, NULL, NULL, 164880),
(164881, '2.30.29.30-FF-000940', NULL, 'UDP-sugar-dependent glycosyltransferase 52', 114, NULL, NULL, 164881),
(164882, '3.40.50.300-FF-007828', NULL, 'Uncharacterized protein', 270, NULL, NULL, 164882),
(164883, '3.20.190.10-FF-000010', NULL, 'Endonuclease', 99, NULL, NULL, 164883),
(164884, '1.10.287.1040-FF-000009', NULL, 'Exodeoxyribonuclease 7 small subunit', 68, NULL, NULL, 164884);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(164885, '1.10.10.10-FF-001069', NULL, 'Response regulator VieA', 69, NULL, NULL, 164885),
(164886, '3.30.2460.20-FF-000014', NULL, 'Protein Wnt', 47, NULL, NULL, 164886),
(164887, '3.40.50.11210-FF-000010', NULL, 'Tuberous sclerosis complex 2 tsc2', 187, NULL, NULL, 164887),
(164888, '1.10.3500.10-FF-000027', NULL, 'Predicted protein', 281, NULL, NULL, 164888),
(164889, '1.20.1690.10-FF-000010', NULL, 'V-type proton ATPase subunit', 115, NULL, NULL, 164889),
(164890, '1.10.238.10-FF-000165', NULL, 'Calbindin 2', 85, NULL, NULL, 164890),
(164891, '3.40.630.30-FF-000170', NULL, 'Acetyltransferase, putative', 131, NULL, NULL, 164891),
(164892, '3.40.532.10-FF-000014', NULL, 'ubiquitin carboxyl-terminal hydrolase BAP1 isoform X2', 159, NULL, NULL, 164892),
(164893, '1.10.246.130-FF-000002', NULL, 'glutathione hydrolase 1 proenzyme', 111, NULL, NULL, 164893),
(164894, '2.40.40.20-FF-000081', NULL, 'DNA-directed RNA polymerase subunit', 30, NULL, NULL, 164894),
(164895, '2.160.20.10-FF-000200', NULL, 'Uncharacterized protein', 263, NULL, NULL, 164895),
(164896, '3.40.1350.10-FF-000023', NULL, 'Putative helicase', 146, NULL, NULL, 164896),
(164897, '2.60.40.10-FF-003247', NULL, 'Uncharacterized protein', 101, NULL, NULL, 164897),
(164898, '1.10.8.10-FF-000314', NULL, 'Protein DDI1 homolog', 103, NULL, NULL, 164898),
(164899, '3.40.50.300-FF-005855', NULL, 'Lon protease', 190, NULL, NULL, 164899),
(164900, '2.60.120.650-FF-000071', NULL, 'Lysine (K)-specific demethylase 4B', 216, NULL, NULL, 164900),
(164901, '1.25.40.10-FF-000121', NULL, 'Tetratricopeptide repeat domain 8', 136, NULL, NULL, 164901),
(164902, '1.50.10.10-FF-000168', NULL, 'alpha-1,2-Mannosidase', 433, NULL, NULL, 164902),
(164903, '2.120.10.80-FF-000183', NULL, 'F-box/kelch-repeat protein isoform A', 229, NULL, NULL, 164903),
(164904, '3.40.395.10-FF-000015', NULL, 'Protease ElaD', 213, NULL, NULL, 164904),
(164905, '3.10.20.90-FF-000190', NULL, 'Small ubiquitin-related modifier', 97, NULL, NULL, 164905),
(164906, '1.10.8.10-FF-000101', NULL, 'Nascent polypeptide associated complex alpha chain', 40, NULL, NULL, 164906),
(164907, '1.20.120.1900-FF-000002', NULL, 'Gamma-tubulin complex component', 311, NULL, NULL, 164907),
(164908, '2.60.120.970-FF-000110', NULL, 'Uncharacterized protein', 126, NULL, NULL, 164908),
(164909, '3.10.110.10-FF-000024', NULL, 'Ubiquitin-conjugating enzyme 5, E2', 159, NULL, NULL, 164909),
(164910, '1.10.1070.11-FF-000146', NULL, 'Serine/threonine-protein kinase TOR', 198, NULL, NULL, 164910),
(164911, '1.10.640.10-FF-000089', NULL, 'Predicted protein', 476, NULL, NULL, 164911),
(164912, '3.90.70.10-FF-000660', NULL, 'Ubiquitinyl hydrolase 1', 49, NULL, NULL, 164912),
(164913, '1.10.510.10-FF-003963', NULL, NULL, 45, NULL, NULL, 164913),
(164914, '1.10.20.10-FF-000350', NULL, NULL, 94, NULL, NULL, 164914),
(164915, '3.30.420.10-FF-000015', NULL, 'DNA polymerase epsilon catalytic subunit', 199, NULL, NULL, 164915),
(164916, '1.20.1560.10-FF-000562', NULL, 'Chromosome 21, whole genome shotgun sequence', 76, NULL, NULL, 164916),
(164917, '1.10.640.10-FF-000061', NULL, 'Uncharacterized protein', 206, NULL, NULL, 164917),
(164918, '3.40.120.10-FF-000046', NULL, 'Pgm3p', 134, NULL, NULL, 164918),
(164919, '1.25.10.10-FF-000361', NULL, 'GCN1, eIF2 alpha kinase activator homolog', 412, NULL, NULL, 164919),
(164920, '3.30.70.270-FF-000069', NULL, 'Probable diguanylate cyclase DgcE', 172, NULL, NULL, 164920),
(164921, '3.30.450.40-FF-000239', NULL, 'Sensor histidine kinase, GAF domain-containing', 159, NULL, NULL, 164921),
(164922, '2.60.40.60-FF-000171', NULL, 'FAT atypical cadherin 4', 107, NULL, NULL, 164922),
(164923, '1.20.58.340-FF-000067', NULL, 'Polynucleotide adenylyltransferase family protein', 67, NULL, NULL, 164923),
(164924, '2.60.40.60-FF-000075', NULL, 'FAT atypical cadherin 1', 97, NULL, NULL, 164924),
(164925, '3.30.310.50-FF-000007', NULL, 'Phosphomannomutase/phosphoglucomutase', 93, NULL, NULL, 164925),
(164926, '1.10.287.70-FF-000616', NULL, 'Predicted protein', 243, NULL, NULL, 164926),
(164927, '2.60.300.12-FF-000034', NULL, NULL, 49, NULL, NULL, 164927);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(164928, '2.60.120.290-FF-000171', NULL, 'Cubilin homolog', 130, NULL, NULL, 164928),
(164929, '2.130.10.10-FF-005057', NULL, 'Uncharacterized protein', 277, NULL, NULL, 164929),
(164930, '3.10.110.10-FF-000075', NULL, 'RWD domain-containing protein (Gir2)', 121, NULL, NULL, 164930),
(164931, '1.25.60.10-FF-000004', NULL, NULL, 129, NULL, NULL, 164931),
(164932, '2.40.50.140-FF-000983', NULL, NULL, 69, NULL, NULL, 164932),
(164933, '3.40.50.720-FF-001479', NULL, 'Uncharacterized protein', 125, NULL, NULL, 164933),
(164934, '2.60.40.10-FF-003808', NULL, 'Tyrosine-protein kinase receptor', 140, NULL, NULL, 164934),
(164935, '1.10.390.10-FF-000108', NULL, 'Uncharacterized protein', 199, NULL, NULL, 164935),
(164936, '3.40.50.300-FF-003034', NULL, 'RAB34, member RAS oncogene family b', 203, NULL, NULL, 164936),
(164937, '1.20.1070.10-FF-001722', NULL, 'Endothelin receptor type B', 99, NULL, NULL, 164937),
(164938, '2.40.50.140-FF-000887', NULL, NULL, 49, NULL, NULL, 164938),
(164939, '3.30.70.100-FF-000046', NULL, 'Nipsnap, isoform F', 121, NULL, NULL, 164939),
(164940, '1.10.460.10-FF-000024', NULL, 'DNA topoisomerase', 60, NULL, NULL, 164940),
(164941, '3.40.470.10-FF-000010', NULL, 'G/U mismatch-specific DNA glycosylase', 204, NULL, NULL, 164941),
(164942, '3.30.60.20-FF-000035', NULL, 'Diacylglycerol kinase', 54, NULL, NULL, 164942),
(164943, '1.20.5.170-FF-000286', NULL, 'Uncharacterized protein', 51, NULL, NULL, 164943),
(164944, '2.60.40.790-FF-000103', NULL, 'Spore coat protein M', 82, NULL, NULL, 164944),
(164945, '3.30.1240.10-FF-000028', NULL, 'Hydrolase, haloacid dehalogenase-like family', 128, NULL, NULL, 164945),
(164946, '1.25.10.10-FF-001721', NULL, 'Predicted protein', 216, NULL, NULL, 164946),
(164947, '3.40.50.2000-FF-000204', NULL, 'UDP-glucuronosyltransferase', 259, NULL, NULL, 164947),
(164948, '2.130.10.10-FF-001134', NULL, 'Protein transport protein Sec31, putative', 351, NULL, NULL, 164948),
(164949, '2.60.40.150-FF-000114', NULL, 'Extended synaptotagmin 3', 159, NULL, NULL, 164949),
(164950, '3.30.40.10-FF-001104', NULL, 'Histone acetyltransferase', 65, NULL, NULL, 164950),
(164951, '3.40.50.880-FF-000217', NULL, 'Uncharacterized protein', 168, NULL, NULL, 164951),
(164952, '3.40.50.1000-FF-000213', NULL, 'HAD hydrolase, family IA, variant 3', 138, NULL, NULL, 164952),
(164953, '2.60.120.10-FF-000826', NULL, 'Uncharacterized protein', 40, NULL, NULL, 164953),
(164954, '1.10.274.30-FF-000024', NULL, 'Uncharacterized protein', 103, NULL, NULL, 164954),
(164955, '1.10.238.150-FF-000007', NULL, 'Formin 3, isoform B', 110, NULL, NULL, 164955),
(164956, '3.30.230.120-FF-000010', NULL, 'Protein CBG25497', 347, NULL, NULL, 164956),
(164957, '4.10.410.10-FF-000021', NULL, 'Serine protease inhibitor, putative', 56, NULL, NULL, 164957),
(164958, '3.30.40.10-FF-000615', NULL, 'E3 ubiquitin ligase BIG BROTHER', 86, NULL, NULL, 164958),
(164959, '1.10.10.10-FF-001962', NULL, 'Uncharacterized protein', 72, NULL, NULL, 164959),
(164960, '1.20.1070.10-FF-000362', NULL, 'D(4) dopamine receptor', 105, NULL, NULL, 164960),
(164961, '3.40.50.300-FF-005804', NULL, 'p-GlycoProtein related', 25, NULL, NULL, 164961),
(164962, '3.40.50.2000-FF-000300', NULL, 'Glycosyltransferase', 252, NULL, NULL, 164962),
(164963, '1.25.10.10-FF-002210', NULL, 'Uncharacterized protein', 425, NULL, NULL, 164963),
(164964, '2.60.120.920-FF-000056', NULL, 'Tripartite motif containing 14', 186, NULL, NULL, 164964),
(164965, '1.10.8.10-FF-000365', NULL, 'Putative countin receptor Cnr4', 50, NULL, NULL, 164965),
(164966, '3.40.50.620-FF-000718', NULL, 'Uncharacterized protein', 214, NULL, NULL, 164966),
(164967, '1.20.1280.300-FF-000001', NULL, 'DNA-directed DNA polymerase', 67, NULL, NULL, 164967),
(164968, '3.40.50.720-FF-000198', NULL, 'UDP-glucuronate 4-epimerase 3', 332, NULL, NULL, 164968),
(164969, '3.10.20.70-FF-000032', NULL, 'Predicted protein', 89, NULL, NULL, 164969),
(164970, '2.60.40.10-FF-005585', NULL, NULL, 68, NULL, NULL, 164970),
(164971, '1.25.40.20-FF-000630', NULL, 'G9a, isoform B', 139, NULL, NULL, 164971);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(164972, '1.20.1250.20-FF-001418', NULL, 'Uncharacterized protein', 180, NULL, NULL, 164972),
(164973, '3.40.1110.10-FF-000421', NULL, NULL, 26, NULL, NULL, 164973),
(164974, '3.10.20.30-FF-000109', NULL, NULL, 97, NULL, NULL, 164974),
(164975, '3.80.10.10-FF-001421', NULL, 'Trophoblast glycoprotein a', 280, NULL, NULL, 164975),
(164976, '1.10.8.1220-FF-000006', NULL, 'Dynein axonemal heavy chain 14', 123, NULL, NULL, 164976),
(164977, '2.80.10.50-FF-000176', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 128, NULL, NULL, 164977),
(164978, '3.80.10.10-FF-003551', NULL, 'Si:ch211-214j8.12', 290, NULL, NULL, 164978),
(164979, '3.30.300.70-FF-000007', NULL, 'Ribosome maturation factor RimP', 80, NULL, NULL, 164979),
(164980, '2.30.30.100-FF-000087', NULL, 'U6 snRNA-associated Sm-like protein LSm4', 83, NULL, NULL, 164980),
(164981, '2.40.50.90-FF-000175', NULL, 'Uncharacterized protein', 160, NULL, NULL, 164981),
(164982, '2.30.140.10-FF-000020', NULL, 'Spermine synthase', 66, NULL, NULL, 164982),
(164983, '3.40.30.10-FF-000356', NULL, 'Glutathione S-Transferase', 86, NULL, NULL, 164983),
(164984, '3.10.20.550-FF-000001', NULL, 'Histone deacetylase complex subunit SAP18', 142, NULL, NULL, 164984),
(164985, '2.40.50.120-FF-000033', NULL, 'Uncharacterized protein', 97, NULL, NULL, 164985),
(164986, '2.70.160.11-FF-000092', NULL, 'Shk1 kinase-binding protein (Skb1), putative', 63, NULL, NULL, 164986),
(164987, '1.10.10.10-FF-000001', NULL, 'LysR family transcriptional regulator', 84, NULL, NULL, 164987),
(164988, '3.40.390.10-FF-000240', NULL, NULL, 59, NULL, NULL, 164988),
(164989, '2.60.40.10-FF-003455', NULL, NULL, 102, NULL, NULL, 164989),
(164990, '3.40.1670.10-FF-000002', NULL, 'Menaquinone biosynthesis decarboxylase', 115, NULL, NULL, 164990),
(164991, '1.10.510.10-FF-003463', NULL, NULL, 273, NULL, NULL, 164991),
(164992, '2.30.42.10-FF-000111', NULL, 'Whirlin a', 113, NULL, NULL, 164992),
(164993, '3.40.630.10-FF-000063', NULL, 'Glutamate carboxypeptidase, putative', 279, NULL, NULL, 164993),
(164994, '1.20.58.670-FF-000031', NULL, NULL, 87, NULL, NULL, 164994),
(164995, '1.25.40.20-FF-001708', NULL, 'Uncharacterized protein', 52, NULL, NULL, 164995),
(164996, '1.10.340.70-FF-000016', NULL, 'Retrovirus-related Pol polyprotein from transposon opus-like Protein', 100, NULL, NULL, 164996),
(164997, '2.10.25.10-FF-001617', NULL, 'Brevican', 84, NULL, NULL, 164997),
(164998, '1.20.140.10-FF-000043', NULL, 'Acyl-CoA dehydrogenase', 168, NULL, NULL, 164998),
(164999, '3.40.50.1820-FF-001095', NULL, 'Uncharacterized protein', 90, NULL, NULL, 164999),
(165000, '1.20.58.390-FF-000060', NULL, 'Ligand-Gated ion Channel', 130, NULL, NULL, 165000),
(165001, '1.10.555.10-FF-000166', NULL, NULL, 206, NULL, NULL, 165001),
(165002, '3.40.50.300-FF-005479', NULL, 'DNA repair protein RecN', 303, NULL, NULL, 165002),
(165003, '2.160.20.70-FF-000027', NULL, 'Adenylyl cyclase-associated protein', 180, NULL, NULL, 165003),
(165004, '1.50.40.10-FF-000529', NULL, 'Uncharacterized protein', 160, NULL, NULL, 165004),
(165005, '2.130.10.10-FF-004040', NULL, 'Vacuolar assembly protein', 219, NULL, NULL, 165005),
(165006, '1.10.357.10-FF-000060', NULL, 'TetR family transcriptional regulator', 188, NULL, NULL, 165006),
(165007, '2.10.25.10-FF-001033', NULL, 'Mesocentin', 41, NULL, NULL, 165007),
(165008, '2.130.10.10-FF-004568', NULL, 'Uncharacterized protein', 213, NULL, NULL, 165008),
(165009, '3.20.20.150-FF-000059', NULL, 'Protein arginine N-methyltransferase', 267, NULL, NULL, 165009),
(165010, '1.20.5.110-FF-000116', NULL, 'Vacuolar v-SNARE', 86, NULL, NULL, 165010),
(165011, '3.30.70.330-FF-001166', NULL, 'SAFB like transcription modulator', 136, NULL, NULL, 165011),
(165012, '3.30.160.60-FF-001870', NULL, 'Zinc finger protein 425', 27, NULL, NULL, 165012),
(165013, '1.20.1070.10-FF-000070', NULL, 'Parathyroid hormone/parathyroid hormone-related peptide receptor', 320, NULL, NULL, 165013),
(165014, '2.40.10.170-FF-000006', NULL, 'ATP synthase subunit beta', 83, NULL, NULL, 165014),
(165015, '3.30.710.10-FF-000442', NULL, 'Uncharacterized protein', 158, NULL, NULL, 165015);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(165016, '3.10.110.10-FF-000367', NULL, 'Predicted protein', 131, NULL, NULL, 165016),
(165017, '3.90.520.10-FF-000009', NULL, 'Mothers against decapentaplegic homolog', 50, NULL, NULL, 165017),
(165018, '2.30.30.40-FF-000042', NULL, 'SH3 and PX domain-containing protein 2A', 62, NULL, NULL, 165018),
(165019, '1.10.1410.20-FF-000006', NULL, '2''-5'' oligoadenylate synthetase 1H', 68, NULL, NULL, 165019),
(165020, '3.30.160.60-FF-000919', NULL, 'Zinc finger protein 260', 27, NULL, NULL, 165020),
(165021, '2.20.70.10-FF-000182', NULL, 'E3 ubiquitin-protein ligase', 49, NULL, NULL, 165021),
(165022, '3.50.50.60-FF-001164', NULL, 'Uncharacterized protein', 31, NULL, NULL, 165022),
(165023, '1.20.1070.10-FF-001222', NULL, 'Uncharacterized protein', 111, NULL, NULL, 165023),
(165024, '3.90.1410.10-FF-000146', NULL, 'Predicted protein', 275, NULL, NULL, 165024),
(165025, '2.160.10.10-FF-000031', NULL, 'Translation initiation factor eIF-2B subunit gamma', 115, NULL, NULL, 165025),
(165026, '1.10.12.70-FF-000006', NULL, 'serine/threonine-protein kinase svkA', 87, NULL, NULL, 165026),
(165027, '3.20.20.70-FF-000784', NULL, NULL, 73, NULL, NULL, 165027),
(165028, '3.40.605.10-FF-000111', NULL, 'Uncharacterized protein', 166, NULL, NULL, 165028),
(165029, '3.40.50.2300-FF-000064', NULL, 'HTH-type transcriptional regulator GntR', 132, NULL, NULL, 165029),
(165030, '3.40.50.1110-FF-000134', NULL, 'Predicted protein', 219, NULL, NULL, 165030),
(165031, '3.80.10.10-FF-002562', NULL, 'Cysteine peptidase, Clan CA, family C2, putative', 135, NULL, NULL, 165031),
(165032, '1.10.3370.10-FF-000033', NULL, 'Sec61 alpha subunit putative', 195, NULL, NULL, 165032),
(165033, '1.10.1200.260-FF-000005', NULL, 'Predicted protein', 41, NULL, NULL, 165033),
(165034, '1.10.630.10-FF-000824', NULL, 'Cytochrome P450, putative', 233, NULL, NULL, 165034),
(165035, '3.40.50.720-FF-001187', NULL, 'UDP-glucuronic acid decarboxylase 5', 98, NULL, NULL, 165035),
(165036, '3.40.50.300-FF-004282', NULL, 'Uncharacterized protein', 161, NULL, NULL, 165036),
(165037, '2.60.40.60-FF-000283', NULL, 'neural-cadherin isoform X9', 105, NULL, NULL, 165037),
(165038, '1.10.287.70-FF-000796', NULL, 'Uncharacterized protein', 137, NULL, NULL, 165038),
(165039, '3.90.228.10-FF-000026', NULL, 'Poly [ADP-ribose] polymerase', 180, NULL, NULL, 165039),
(165040, '1.25.40.10-FF-004516', NULL, 'DNA-binding protein', 86, NULL, NULL, 165040),
(165041, '3.30.40.10-FF-002083', NULL, 'Uncharacterized protein', 85, NULL, NULL, 165041),
(165042, '1.25.10.10-FF-003227', NULL, 'Predicted protein', 258, NULL, NULL, 165042),
(165043, '3.50.30.30-FF-000165', NULL, 'Extracellular serine alkaline protease SapSH', 142, NULL, NULL, 165043),
(165044, '3.40.190.10-FF-000663', NULL, 'p-protein (PheA)', 87, NULL, NULL, 165044),
(165045, '1.25.40.10-FF-001762', NULL, 'Tetratricopeptide repeat domain 28', 193, NULL, NULL, 165045),
(165046, '3.90.190.10-FF-000062', NULL, 'Receptor-type tyrosine-protein phosphatase kappa', 289, NULL, NULL, 165046),
(165047, '1.20.120.790-FF-000004', NULL, 'Heat shock protein 75 kDa', 139, NULL, NULL, 165047),
(165048, '3.40.50.300-FF-007036', NULL, 'Predicted protein', 202, NULL, NULL, 165048),
(165049, '2.60.40.10-FF-006102', NULL, NULL, 108, NULL, NULL, 165049),
(165050, '1.25.10.20-FF-000010', NULL, 'GD24418', 304, NULL, NULL, 165050),
(165051, '1.10.287.110-FF-000269', NULL, 'Chaperone protein DNAj, putative', 67, NULL, NULL, 165051),
(165052, '3.30.420.40-FF-000007', NULL, 'Glycerol kinase', 243, NULL, NULL, 165052),
(165053, '2.60.40.10-FF-000650', NULL, 'Mannosidase beta', 87, NULL, NULL, 165053),
(165054, '2.40.50.40-FF-000121', NULL, 'Histone-lysine N-methyltransferase', 31, NULL, NULL, 165054),
(165055, '3.30.160.60-FF-002044', NULL, 'Cardiomyopathy associated 5', 77, NULL, NULL, 165055),
(165056, '2.10.110.20-FF-000008', NULL, NULL, 66, NULL, NULL, 165056),
(165057, '1.50.10.10-FF-000117', NULL, 'Uncharacterized protein', 427, NULL, NULL, 165057),
(165058, '1.10.10.10-FF-002030', NULL, 'RNA polymerase sigma factor sigC', 78, NULL, NULL, 165058);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(165059, '2.60.40.150-FF-000226', NULL, 'Tcb1p', 143, NULL, NULL, 165059),
(165060, '3.20.20.80-FF-000692', NULL, 'Uncharacterized protein', 288, NULL, NULL, 165060),
(165061, '2.60.120.10-FF-000714', NULL, 'Uncharacterized protein', 146, NULL, NULL, 165061),
(165062, '2.30.29.30-FF-000709', NULL, 'Coactivator-associated arginine methyltransferase 1,-like', 111, NULL, NULL, 165062),
(165063, '1.10.533.10-FF-000121', NULL, 'Uncharacterized protein', 94, NULL, NULL, 165063),
(165064, '2.10.25.10-FF-000948', NULL, 'Crumbs homolog 2', 41, NULL, NULL, 165064),
(165065, '2.10.110.10-FF-000062', NULL, 'LIM domain-containing protein', 84, NULL, NULL, 165065),
(165066, '4.10.990.10-FF-000002', NULL, NULL, 47, NULL, NULL, 165066),
(165067, '3.40.50.1820-FF-000690', NULL, 'Lipid particle protein, variant', 234, NULL, NULL, 165067),
(165068, '2.60.40.60-FF-000867', NULL, 'Uncharacterized protein', 103, NULL, NULL, 165068),
(165069, '2.40.30.10-FF-000358', NULL, 'Uncharacterized protein', 99, NULL, NULL, 165069),
(165070, '3.10.290.10-FF-000059', NULL, '30S ribosomal protein S4e', 111, NULL, NULL, 165070),
(165071, '1.10.10.60-FF-000959', NULL, NULL, 58, NULL, NULL, 165071),
(165072, '1.10.8.500-FF-000011', NULL, 'Histidine kinase', 47, NULL, NULL, 165072),
(165073, '3.40.50.2000-FF-000917', NULL, 'Uncharacterized protein', 162, NULL, NULL, 165073),
(165074, '2.10.90.10-FF-000003', NULL, 'Bone morphogenetic protein 5', 113, NULL, NULL, 165074),
(165075, '3.40.50.2300-FF-001424', NULL, NULL, 37, NULL, NULL, 165075),
(165076, '2.60.40.10-FF-005321', NULL, NULL, 77, NULL, NULL, 165076),
(165077, '1.10.10.60-FF-000055', NULL, 'Homeobox protein Hox-A5', 83, NULL, NULL, 165077),
(165078, '2.10.110.10-FF-000270', NULL, 'LIM domain-containing protein', 61, NULL, NULL, 165078),
(165079, '3.40.50.300-FF-007896', NULL, 'Predicted protein', 304, NULL, NULL, 165079),
(165080, '3.30.160.60-FF-003668', NULL, NULL, 28, NULL, NULL, 165080),
(165081, '2.130.10.10-FF-005288', NULL, 'Uncharacterized protein', 226, NULL, NULL, 165081),
(165082, '3.30.40.10-FF-000958', NULL, 'Cellulose synthase', 89, NULL, NULL, 165082),
(165083, '2.20.100.10-FF-000008', NULL, 'Unc-5 netrin receptor C', 54, NULL, NULL, 165083),
(165084, '2.30.180.10-FF-000174', NULL, NULL, 81, NULL, NULL, 165084),
(165085, '3.20.20.30-FF-000019', NULL, 'F420-dependent oxidoreductase', 106, NULL, NULL, 165085),
(165086, '1.10.286.10-FF-000001', NULL, 'GTP cyclohydrolase 1', 54, NULL, NULL, 165086),
(165087, '3.20.20.70-FF-000508', NULL, 'Uncharacterized protein', 311, NULL, NULL, 165087),
(165088, '3.30.70.330-FF-001430', NULL, 'RNA-binding protein', 114, NULL, NULL, 165088),
(165089, '3.40.50.620-FF-000786', NULL, 'Uncharacterized protein', 77, NULL, NULL, 165089),
(165090, '1.25.10.10-FF-002502', NULL, 'Uncharacterized protein', 201, NULL, NULL, 165090),
(165091, '2.130.10.10-FF-005506', NULL, 'Predicted protein', 95, NULL, NULL, 165091),
(165092, '1.10.150.20-FF-000200', NULL, 'DNA damage repair protein, putative', 97, NULL, NULL, 165092),
(165093, '1.10.510.10-FF-002035', NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 182', 147, NULL, NULL, 165093),
(165094, '3.40.50.10330-FF-000089', NULL, 'NAD kinase', 171, NULL, NULL, 165094),
(165095, '1.10.510.10-FF-003671', NULL, NULL, 176, NULL, NULL, 165095),
(165096, '3.40.50.720-FF-002547', NULL, 'D-3-phosphoglycerate dehydrogenase', 69, NULL, NULL, 165096),
(165097, '1.10.510.10-FF-003783', NULL, NULL, 132, NULL, NULL, 165097),
(165098, '1.10.132.60-FF-000024', NULL, 'DNA polymerase', 154, NULL, NULL, 165098),
(165099, '2.10.25.10-FF-000095', NULL, 'Notch, isoform B', 37, NULL, NULL, 165099),
(165100, '1.20.120.350-FF-000238', NULL, NULL, 140, NULL, NULL, 165100),
(165101, '3.40.50.2060-FF-000003', NULL, 'vacuolar protein sorting-associated protein 45 isoform X1', 127, NULL, NULL, 165101),
(165102, '2.70.130.10-FF-000050', NULL, NULL, 152, NULL, NULL, 165102),
(165103, '3.30.70.330-FF-000992', NULL, 'Hrb1p', 97, NULL, NULL, 165103),
(165104, '3.30.572.10-FF-000013', NULL, 'Thymidylate synthase', 284, NULL, NULL, 165104);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(165105, '1.20.1170.10-FF-000015', NULL, NULL, 234, NULL, NULL, 165105),
(165106, '1.20.58.60-FF-000861', NULL, 'BetaH spectrin', 126, NULL, NULL, 165106),
(165107, '2.60.40.10-FF-005872', NULL, NULL, 77, NULL, NULL, 165107),
(165108, '2.30.29.30-FF-000861', NULL, 'Predicted protein', 144, NULL, NULL, 165108),
(165109, '1.20.1070.10-FF-001430', NULL, 'Uncharacterized protein', 225, NULL, NULL, 165109),
(165110, '3.20.20.10-FF-000013', NULL, 'Alanine/ornithine racemase family PLP-dependent enzyme', 213, NULL, NULL, 165110),
(165111, '1.10.1300.10-FF-000079', NULL, 'Phosphodiesterase', 379, NULL, NULL, 165111),
(165112, '3.40.190.10-FF-000820', NULL, 'Glutamate receptor', 65, NULL, NULL, 165112),
(165113, '3.40.1160.10-FF-000099', NULL, 'Carbamate kinase, putative', 164, NULL, NULL, 165113),
(165114, '1.25.40.10-FF-001026', NULL, 'CTR9 homolog, Paf1/RNA polymerase II complex component', 318, NULL, NULL, 165114),
(165115, '3.40.50.300-FF-007772', NULL, 'Uncharacterized protein', 59, NULL, NULL, 165115),
(165116, '1.10.10.10-FF-000905', NULL, 'transcription factor RFX4 isoform X4', 53, NULL, NULL, 165116),
(165117, '2.40.40.20-FF-000013', NULL, 'Dimethyl sulfoxide reductase subunit A', 184, NULL, NULL, 165117),
(165118, '3.90.70.10-FF-000772', NULL, 'Uncharacterized protein', 65, NULL, NULL, 165118),
(165119, '2.60.40.10-FF-002095', NULL, 'Gamma interferon receptor', 111, NULL, NULL, 165119),
(165120, '1.20.120.1760-FF-000089', NULL, NULL, 211, NULL, NULL, 165120),
(165121, '3.30.200.20-FF-002227', NULL, 'Uncharacterized protein', 38, NULL, NULL, 165121),
(165122, '3.100.10.10-FF-000058', NULL, NULL, 79, NULL, NULL, 165122),
(165123, '3.30.300.180-FF-000022', NULL, 'Chromosomal replication initiator protein DnaA', 110, NULL, NULL, 165123),
(165124, '3.80.10.10-FF-003219', NULL, 'Uncharacterized protein', 205, NULL, NULL, 165124),
(165125, '3.40.1190.20-FF-000137', NULL, 'Hydroxyethylthiazole kinase family-domain-containing protein', 276, NULL, NULL, 165125),
(165126, '4.10.280.110-FF-000009', NULL, 'U4/U6 small nuclear ribonucleoprotein Prp4, putative', 75, NULL, NULL, 165126),
(165127, '3.40.1390.30-FF-000026', NULL, 'Uncharacterized protein', 78, NULL, NULL, 165127),
(165128, '3.40.1280.10-FF-000079', NULL, 'Uncharacterized protein', 185, NULL, NULL, 165128),
(165129, '1.10.357.20-FF-000006', NULL, 'Protein CBG01586', 189, NULL, NULL, 165129),
(165130, '2.60.200.20-FF-000072', NULL, 'Mutator 2, isoform B', 101, NULL, NULL, 165130),
(165131, '2.30.39.10-FF-000047', NULL, 'Serpin-1 precursor, putative', 101, NULL, NULL, 165131),
(165132, '3.40.225.10-FF-000014', NULL, 'Rhamnulose-1-phosphate aldolase', 259, NULL, NULL, 165132),
(165133, '3.50.50.60-FF-001372', NULL, 'Flavin-containing monooxygenase', 163, NULL, NULL, 165133),
(165134, '3.10.100.10-FF-000170', NULL, 'Predicted protein', 143, NULL, NULL, 165134),
(165135, '3.60.130.10-FF-000093', NULL, 'Uncharacterized protein', 197, NULL, NULL, 165135),
(165136, '3.40.1110.10-FF-000096', NULL, 'Phospholipid-transporting ATPase', 172, NULL, NULL, 165136),
(165137, '3.30.1330.30-FF-000064', NULL, 'RNA methyltransferase, TrmH family', 96, NULL, NULL, 165137),
(165138, '1.20.1250.20-FF-000637', NULL, 'MFS transporter', 179, NULL, NULL, 165138),
(165139, '2.60.40.1400-FF-000037', NULL, NULL, 163, NULL, NULL, 165139),
(165140, '1.10.1200.10-FF-000015', NULL, 'Putative acyl-activating enzyme 19', 73, NULL, NULL, 165140),
(165141, '3.10.100.10-FF-000018', NULL, 'Mannose receptor, C type 2', 135, NULL, NULL, 165141),
(165142, '3.50.50.60-FF-000832', NULL, 'Sll0703 protein', 110, NULL, NULL, 165142),
(165143, '3.80.10.10-FF-000696', NULL, 'GH23033', 214, NULL, NULL, 165143),
(165144, '2.60.40.60-FF-000463', NULL, 'Cadherin 3', 106, NULL, NULL, 165144),
(165145, '3.10.580.10-FF-000227', NULL, 'Chloride channel, voltage-sensitive Kb', 76, NULL, NULL, 165145),
(165146, '3.60.10.10-FF-000067', NULL, 'Carbon catabolite repressor protein 4 homolog 4', 347, NULL, NULL, 165146),
(165147, '1.20.1270.280-FF-000038', NULL, 'AT13908p', 73, NULL, NULL, 165147),
(165148, '3.30.40.10-FF-000323', NULL, 'TNF receptor-associated factor', 56, NULL, NULL, 165148);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(165149, '3.50.30.10-FF-000007', NULL, 'Phosphoenolpyruvate synthase', 103, NULL, NULL, 165149),
(165150, '1.20.80.10-FF-000038', NULL, 'Myosin 28B1, isoform B', 124, NULL, NULL, 165150),
(165151, '1.20.900.10-FF-000135', NULL, 'Predicted protein', 225, NULL, NULL, 165151),
(165152, '3.20.20.140-FF-000331', NULL, 'Non-ATP-dependent L-selective hydantoinase, putative', 47, NULL, NULL, 165152),
(165153, '3.30.160.60-FF-004461', NULL, NULL, 75, NULL, NULL, 165153),
(165154, '3.30.750.44-FF-000025', NULL, NULL, 92, NULL, NULL, 165154),
(165155, '1.20.5.4820-FF-000010', NULL, 'Unconventional myosin-X', 113, NULL, NULL, 165155),
(165156, '1.50.10.20-FF-000058', NULL, 'Terpene cyclase/mutase family member', 131, NULL, NULL, 165156),
(165157, '3.40.50.2000-FF-001109', NULL, 'Uncharacterized protein', 12, NULL, NULL, 165157),
(165158, '1.20.1250.10-FF-000016', NULL, 'Fms-related tyrosine kinase 3 ligand', 134, NULL, NULL, 165158),
(165159, '2.60.40.10-FF-002679', NULL, 'Uncharacterized protein', 130, NULL, NULL, 165159),
(165160, '3.40.50.300-FF-002253', NULL, 'U5 small nuclear ribonucleoprotein 200 kDa helicase', 124, NULL, NULL, 165160),
(165161, '3.30.70.1230-FF-000066', NULL, 'Predicted protein', 224, NULL, NULL, 165161),
(165162, '3.30.160.60-FF-005821', NULL, NULL, 66, NULL, NULL, 165162),
(165163, '2.40.70.10-FF-000580', NULL, NULL, 112, NULL, NULL, 165163),
(165164, '1.10.10.60-FF-000342', NULL, 'trihelix transcription factor PTL-like', 63, NULL, NULL, 165164),
(165165, '1.25.40.550-FF-000003', NULL, 'AAR2 family protein', 229, NULL, NULL, 165165),
(165166, '1.20.58.1290-FF-000002', NULL, 'Transcriptional regulator, CarD', 91, NULL, NULL, 165166),
(165167, '2.130.10.10-FF-000353', NULL, 'Transcriptional corepressor LEUNIG', 159, NULL, NULL, 165167),
(165168, '2.60.40.1770-FF-000013', NULL, 'Si:ch73-40a2.1', 51, NULL, NULL, 165168),
(165169, '1.20.58.60-FF-000529', NULL, 'Uncharacterized protein', 201, NULL, NULL, 165169),
(165170, '2.10.25.10-FF-000836', NULL, 'Wall-associated receptor kinase-like 14 isoform A', 36, NULL, NULL, 165170),
(165171, '3.90.1290.10-FF-000057', NULL, 'Microtubule-actin crosslinking factor 1', 83, NULL, NULL, 165171),
(165172, '2.130.10.10-FF-004164', NULL, 'Predicted protein', 170, NULL, NULL, 165172),
(165173, '3.40.50.300-FF-005355', NULL, 'Preprotein translocase SecA subunit', 270, NULL, NULL, 165173),
(165174, '1.25.40.10-FF-000981', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 94, NULL, NULL, 165174),
(165175, '3.30.160.60-FF-003404', NULL, 'Palmate-like pentafoliata 1 transcription factor', 67, NULL, NULL, 165175),
(165176, '3.40.50.300-FF-002949', NULL, 'Putative dynein heavy chain, cytosolic', 173, NULL, NULL, 165176),
(165177, '3.20.20.190-FF-000144', NULL, NULL, 63, NULL, NULL, 165177),
(165178, '1.10.510.10-FF-003283', NULL, NULL, 99, NULL, NULL, 165178),
(165179, '3.60.60.10-FF-000014', NULL, 'Choloylglycine hydrolase', 319, NULL, NULL, 165179),
(165180, '3.30.2160.10-FF-000051', NULL, 'Uncharacterized protein', 78, NULL, NULL, 165180),
(165181, '1.10.10.60-FF-000263', NULL, 'Putative homeodomain-like transcription factor superfamily protein', 69, NULL, NULL, 165181),
(165182, '1.10.506.10-FF-000075', NULL, 'Predicted protein', 204, NULL, NULL, 165182),
(165183, '2.30.29.30-FF-001053', NULL, 'Uncharacterized protein', 105, NULL, NULL, 165183),
(165184, '3.40.50.1820-FF-000751', NULL, 'Carboxylic ester hydrolase', 496, NULL, NULL, 165184),
(165185, '3.90.190.10-FF-000415', NULL, 'Predicted protein', 105, NULL, NULL, 165185),
(165186, '3.30.40.10-FF-000458', NULL, 'Unkempt, isoform F', 69, NULL, NULL, 165186),
(165187, '1.20.1070.10-FF-000766', NULL, 'Secretin receptor', 289, NULL, NULL, 165187),
(165188, '3.40.50.2300-FF-000300', NULL, 'Vomeronasal 2, receptor 4', 298, NULL, NULL, 165188),
(165189, '1.10.238.10-FF-000373', NULL, '45 kDa calcium-binding protein', 95, NULL, NULL, 165189),
(165190, '3.90.280.10-FF-000024', NULL, NULL, 121, NULL, NULL, 165190),
(165191, '1.10.30.10-FF-000064', NULL, 'Mutant transcription factor sox9a', 42, NULL, NULL, 165191);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(165192, '3.40.50.10810-FF-000171', NULL, 'Uncharacterized protein', 268, NULL, NULL, 165192),
(165193, '1.10.405.20-FF-000012', NULL, NULL, 114, NULL, NULL, 165193),
(165194, '2.30.30.30-FF-000050', NULL, '60S ribosomal protein L14', 86, NULL, NULL, 165194),
(165195, '3.30.420.10-FF-000695', NULL, NULL, 119, NULL, NULL, 165195),
(165196, '1.10.150.50-FF-000086', NULL, 'Alpha-globin transcription factor CP2', 73, NULL, NULL, 165196),
(165197, '2.60.40.10-FF-005664', NULL, NULL, 88, NULL, NULL, 165197),
(165198, '2.10.25.10-FF-000595', NULL, 'von Willebrand factor D and EGF domain-containing protein', 76, NULL, NULL, 165198),
(165199, '3.40.50.300-FF-006991', NULL, 'ATP-dependent DNA helicase', 213, NULL, NULL, 165199),
(165200, '1.10.287.460-FF-000003', NULL, 'Peptidyl-prolyl cis-trans isomerase', 104, NULL, NULL, 165200),
(165201, '3.90.980.20-FF-000035', NULL, NULL, 48, NULL, NULL, 165201),
(165202, '3.90.70.10-FF-000452', NULL, 'Ubiquitin carboxyl-terminal hydrolase 13', 94, NULL, NULL, 165202),
(165203, '1.10.620.20-FF-000012', NULL, 'R2-like ligand binding oxidase', 285, NULL, NULL, 165203),
(165204, '1.20.5.440-FF-000002', NULL, 'ATP synthase subunit delta, mitochondrial', 43, NULL, NULL, 165204),
(165205, '3.40.50.720-FF-001822', NULL, 'Ubiquitin-activating enzyme E1 1', 165, NULL, NULL, 165205),
(165206, '2.60.40.10-FF-004236', NULL, NULL, 47, NULL, NULL, 165206),
(165207, '3.80.10.10-FF-000196', NULL, 'Si:dkey-16p6.1', 127, NULL, NULL, 165207),
(165208, '1.25.40.730-FF-000001', NULL, 'Clathrin heavy chain', 97, NULL, NULL, 165208),
(165209, '3.40.50.10470-FF-000046', NULL, 'Translation initiation factor eIF-2B alpha subunit', 214, NULL, NULL, 165209),
(165210, '1.50.40.10-FF-000349', NULL, 'Mitochondrial carrier protein, putative', 185, NULL, NULL, 165210),
(165211, '2.130.10.10-FF-003843', NULL, 'Uncharacterized protein', 292, NULL, NULL, 165211),
(165212, '3.60.21.10-FF-000160', NULL, 'Serine/threonine-protein phosphatase', 307, NULL, NULL, 165212),
(165213, '3.30.70.1730-FF-000007', NULL, '50S ribosomal protein L10', 129, NULL, NULL, 165213),
(165214, '1.25.40.10-FF-003443', NULL, 'Pentatricopeptide repeat-containing protein', 152, NULL, NULL, 165214),
(165215, '1.10.10.1540-FF-000006', NULL, 'Uncharacterized protein', 84, NULL, NULL, 165215),
(165216, '2.40.50.140-FF-000775', NULL, NULL, 82, NULL, NULL, 165216),
(165217, '3.60.40.10-FF-000136', NULL, 'Probable two-component response regulator', 215, NULL, NULL, 165217),
(165218, '3.30.160.60-FF-004309', NULL, NULL, 20, NULL, NULL, 165218),
(165219, '2.120.10.30-FF-000241', NULL, 'Low-density lipoprotein receptor-related protein 6', 301, NULL, NULL, 165219),
(165220, '3.30.200.20-FF-001530', NULL, 'Leucine-rich repeat protein kinase family protein', 103, NULL, NULL, 165220),
(165221, '1.10.287.70-FF-000728', NULL, 'Uncharacterized protein', 125, NULL, NULL, 165221),
(165222, '3.30.200.20-FF-001210', NULL, 'Calcium-dependent protein kinase 31', 91, NULL, NULL, 165222),
(165223, '3.40.50.300-FF-002606', NULL, 'Dephospho-CoA kinase 2', 210, NULL, NULL, 165223),
(165224, '1.50.40.10-FF-000006', NULL, 'brain mitochondrial carrier protein 1 isoform X1', 284, NULL, NULL, 165224),
(165225, '2.40.50.140-FF-001051', NULL, NULL, 114, NULL, NULL, 165225),
(165226, '2.40.50.690-FF-000024', NULL, 'Exosome complex exonuclease RRP44, putative', 91, NULL, NULL, 165226),
(165227, '3.40.630.10-FF-000416', NULL, 'M28 family peptidase', 301, NULL, NULL, 165227),
(165228, '3.10.20.250-FF-000001', NULL, 'YML108W-like protein', 105, NULL, NULL, 165228),
(165229, '3.40.50.10190-FF-000153', NULL, 'Uncharacterized protein', 97, NULL, NULL, 165229),
(165230, '1.10.287.70-FF-000408', NULL, 'Predicted protein', 289, NULL, NULL, 165230),
(165231, '2.60.40.10-FF-000021', NULL, 'transcription factor COE1 isoform X2', 92, NULL, NULL, 165231),
(165232, '1.10.10.10-FF-000973', NULL, 'E74 like ETS transcription factor 1', 52, NULL, NULL, 165232),
(165233, '3.50.50.60-FF-001288', NULL, 'Rab GDP dissociation inhibitor', 50, NULL, NULL, 165233),
(165234, '3.30.1490.300-FF-000002', NULL, 'Type IV pilus assembly protein PilM', 61, NULL, NULL, 165234);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(165235, '1.10.287.30-FF-000003', NULL, 'Regulatory protein E2', 100, NULL, NULL, 165235),
(165236, '3.30.40.10-FF-000115', NULL, 'probable E3 ubiquitin-protein ligase LOG2', 66, NULL, NULL, 165236),
(165237, '3.40.50.880-FF-000105', NULL, 'CTP synthase', 229, NULL, NULL, 165237),
(165238, '3.30.160.60-FF-000358', NULL, 'zinc finger protein 24', 30, NULL, NULL, 165238),
(165239, '1.10.1520.10-FF-000062', NULL, 'Ribonuclease III domain-containing protein', 179, NULL, NULL, 165239),
(165240, '2.70.98.10-FF-000069', NULL, 'Beta-galactosidase', 311, NULL, NULL, 165240),
(165241, '3.10.20.90-FF-000543', NULL, 'OTU-like cysteine protease', 80, NULL, NULL, 165241),
(165242, '2.60.40.3510-FF-000001', NULL, 'Delta-like protein', 156, NULL, NULL, 165242),
(165243, '3.80.10.10-FF-001134', NULL, 'Leucine-rich repeat receptor-like protein kinase', 166, NULL, NULL, 165243),
(165244, '1.10.150.240-FF-000005', NULL, 'HAD hydrolase family', 80, NULL, NULL, 165244),
(165245, '1.25.10.10-FF-002710', NULL, 'Uncharacterized protein', 44, NULL, NULL, 165245),
(165246, '3.40.50.1000-FF-000101', NULL, '2,3-diketo-5-methylthio-1-phosphopentane phosphatase protein', 106, NULL, NULL, 165246),
(165247, '1.10.287.70-FF-000167', NULL, 'Two-pore potassium channel 2-like', 125, NULL, NULL, 165247),
(165248, '3.40.50.300-FF-002045', NULL, 'Type I restriction-modification system endonuclease', 210, NULL, NULL, 165248),
(165249, '1.10.8.10-FF-000253', NULL, 'baculoviral IAP repeat-containing protein 2-like', 64, NULL, NULL, 165249),
(165250, '3.40.630.30-FF-000574', NULL, 'Acyl-homoserine-lactone synthase', 102, NULL, NULL, 165250),
(165251, '2.20.70.10-FF-000030', NULL, 'Salvador family WW domain-containing protein 1', 35, NULL, NULL, 165251),
(165252, '3.30.530.20-FF-000173', NULL, 'Uncharacterized protein', 113, NULL, NULL, 165252),
(165253, '3.30.70.330-FF-002526', NULL, NULL, 59, NULL, NULL, 165253),
(165254, '3.40.1380.20-FF-000028', NULL, 'Pyruvate kinase', 121, NULL, NULL, 165254),
(165255, '3.30.450.20-FF-000172', NULL, 'Cyclic di-GMP phosphodiesterase Gmr', 125, NULL, NULL, 165255),
(165256, '3.30.505.10-FF-000105', NULL, 'Transcription elongation factor SPT6', 95, NULL, NULL, 165256),
(165257, '2.60.200.20-FF-000252', NULL, 'Uncharacterized protein', 103, NULL, NULL, 165257),
(165258, '3.30.1330.20-FF-000027', NULL, 'Tubulin alpha chain', 46, NULL, NULL, 165258),
(165259, '2.60.40.150-FF-000614', NULL, 'Uncharacterized protein', 150, NULL, NULL, 165259),
(165260, '1.10.510.10-FF-001597', NULL, 'Uncharacterized protein', 213, NULL, NULL, 165260),
(165261, '3.90.1150.10-FF-000339', NULL, 'Pyridoxal phosphate-dependent aminotransferase', 115, NULL, NULL, 165261),
(165262, '3.40.50.2000-FF-000412', NULL, 'Flavonoid glucosyl-transferase-like', 132, NULL, NULL, 165262),
(165263, '1.25.40.20-FF-001647', NULL, 'Uncharacterized protein', 89, NULL, NULL, 165263),
(165264, '3.40.50.970-FF-000008', NULL, '1-deoxy-D-xylulose-5-phosphate synthase', 233, NULL, NULL, 165264),
(165265, '2.60.120.1440-FF-000010', NULL, 'FecR family protein', 135, NULL, NULL, 165265),
(165266, '1.20.58.60-FF-000209', NULL, 'Uncharacterized protein, isoform D', 309, NULL, NULL, 165266),
(165267, '3.90.550.50-FF-000113', NULL, 'Fringe', 272, NULL, NULL, 165267),
(165268, '2.60.40.1110-FF-000006', NULL, 'Formin-like protein', 141, NULL, NULL, 165268),
(165269, '3.40.1710.10-FF-000006', NULL, 'Probable conserved transmembrane protein', 154, NULL, NULL, 165269),
(165270, '3.40.50.10190-FF-000232', NULL, 'DNA ligase', 86, NULL, NULL, 165270),
(165271, '1.10.510.10-FF-001815', NULL, 'Casein kinase 1-like protein 6', 296, NULL, NULL, 165271),
(165272, '2.60.120.10-FF-000326', NULL, 'Cyclic nucleotide-binding domain containing protein, putative', 168, NULL, NULL, 165272),
(165273, '2.30.30.40-FF-000671', NULL, 'Predicted protein', 63, NULL, NULL, 165273),
(165274, '1.20.870.10-FF-000002', NULL, 'son of sevenless homolog 1 isoform X1', 189, NULL, NULL, 165274),
(165275, '3.10.105.10-FF-000102', NULL, 'Peptide ABC transporter substrate-binding protein', 219, NULL, NULL, 165275);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(165276, '1.25.40.70-FF-000009', NULL, 'Phosphatidylinositol 3-kinase VPS34', 218, NULL, NULL, 165276),
(165277, '3.30.830.10-FF-000153', NULL, 'Metalloenzyme, LuxS/M16 peptidase-like protein', 220, NULL, NULL, 165277),
(165278, '3.30.460.10-FF-000118', NULL, 'Uncharacterized protein', 108, NULL, NULL, 165278),
(165279, '3.30.200.20-FF-000693', NULL, 'TKL protein kinase', 113, NULL, NULL, 165279),
(165280, '3.40.30.10-FF-000148', NULL, 'Elongation factor 1B gamma', 73, NULL, NULL, 165280),
(165281, '2.130.10.10-FF-003500', NULL, 'Plexin A3', 465, NULL, NULL, 165281),
(165282, '1.25.40.10-FF-002779', NULL, 'Putative chaperone protein DNAj', 148, NULL, NULL, 165282),
(165283, '3.80.10.10-FF-003287', NULL, 'Uncharacterized protein', 111, NULL, NULL, 165283),
(165284, '3.10.20.90-FF-000723', NULL, '2'',5''-oligo adenylate synthetase A', 82, NULL, NULL, 165284),
(165285, '3.40.50.2300-FF-000564', NULL, 'Vomeronasal 2 receptor, 53', 47, NULL, NULL, 165285),
(165286, '3.50.50.100-FF-000015', NULL, 'Amid-like NADH oxidoreductase, putative', 355, NULL, NULL, 165286),
(165287, '1.20.120.350-FF-000159', NULL, NULL, 117, NULL, NULL, 165287),
(165288, '3.40.50.10810-FF-000019', NULL, 'DNA excision repair protein ERCC-6-like 2 isoform X1', 260, NULL, NULL, 165288),
(165289, '1.20.1290.10-FF-000013', NULL, 'Sestrin-1', 151, NULL, NULL, 165289),
(165290, '3.80.10.10-FF-000937', NULL, 'Scribbled planar cell polarity protein', 133, NULL, NULL, 165290),
(165291, '3.90.640.90-FF-000025', NULL, 'Predicted protein', 106, NULL, NULL, 165291),
(165292, '3.40.50.720-FF-000462', NULL, 'Glyoxylate reductase (NADP+)', 191, NULL, NULL, 165292),
(165293, '1.10.150.650-FF-000010', NULL, 'Metal-dependent phosphoesterase, PHP family protein', 74, NULL, NULL, 165293),
(165294, '3.40.50.300-FF-005743', NULL, 'DNA double-strand break repair Rad50 ATPase', 145, NULL, NULL, 165294),
(165295, '3.90.110.10-FF-000023', NULL, NULL, 167, NULL, NULL, 165295),
(165296, '3.40.50.300-FF-001589', NULL, 'ras-related protein Rab-34 isoform X4', 169, NULL, NULL, 165296),
(165297, '1.25.40.10-FF-003055', NULL, 'Putative pentatricopeptide repeat-containing protein', 69, NULL, NULL, 165297),
(165298, '3.40.50.720-FF-002491', NULL, 'Uncharacterized protein', 171, NULL, NULL, 165298),
(165299, '3.40.50.10420-FF-000048', NULL, 'Uncharacterized protein', 83, NULL, NULL, 165299),
(165300, '3.40.250.10-FF-000078', NULL, 'Related to 3-mercaptopyruvate sulfurtransferase', 154, NULL, NULL, 165300),
(165301, '3.40.50.150-FF-000206', NULL, 'O-methyltransferase ZRP4', 251, NULL, NULL, 165301),
(165302, '1.25.40.20-FF-000366', NULL, 'Ankyrin repeat and SOCS box protein 16', 75, NULL, NULL, 165302),
(165303, '3.30.710.10-FF-000234', NULL, 'GD15448', 156, NULL, NULL, 165303),
(165304, '3.30.160.60-FF-005742', NULL, NULL, 50, NULL, NULL, 165304),
(165305, '3.80.10.10-FF-001213', NULL, 'Si:ch211-149a19.3', 167, NULL, NULL, 165305),
(165306, '3.40.1110.10-FF-000028', NULL, 'Cation-transporting ATPase', 142, NULL, NULL, 165306),
(165307, '3.30.1120.10-FF-000048', NULL, 'Galactosamine (N-acetyl)-6-sulfatase', 100, NULL, NULL, 165307),
(165308, '2.120.10.80-FF-000407', NULL, 'Uncharacterized protein', 277, NULL, NULL, 165308),
(165309, '3.10.440.10-FF-000009', NULL, 'Os08g0505300 protein', 72, NULL, NULL, 165309),
(165310, '3.10.20.710-FF-000004', NULL, 'SATB homeobox 1', 65, NULL, NULL, 165310),
(165311, '1.10.1470.10-FF-000001', NULL, 'CsbD family protein', 69, NULL, NULL, 165311),
(165312, '2.60.40.420-FF-000094', NULL, 'Hephaestin', 151, NULL, NULL, 165312),
(165313, '3.20.20.70-FF-000576', NULL, NULL, 78, NULL, NULL, 165313),
(165314, '1.10.150.670-FF-000016', NULL, 'YALI0E33715p', 85, NULL, NULL, 165314),
(165315, '2.130.10.10-FF-000274', NULL, 'Chromatin assembly factor 1 subunit B', 143, NULL, NULL, 165315),
(165316, '3.30.9.10-FF-000262', NULL, 'Uncharacterized protein', 155, NULL, NULL, 165316),
(165317, '3.60.21.10-FF-000008', NULL, 'Serine/threonine-protein phosphatase', 340, NULL, NULL, 165317),
(165318, '3.30.70.340-FF-000034', NULL, NULL, 46, NULL, NULL, 165318);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(165319, '3.30.420.40-FF-000979', NULL, 'Uncharacterized protein', 126, NULL, NULL, 165319),
(165320, '1.25.40.10-FF-003578', NULL, 'Uncharacterized protein', 176, NULL, NULL, 165320),
(165321, '2.40.10.10-FF-000363', NULL, NULL, 45, NULL, NULL, 165321),
(165322, '3.40.30.10-FF-000709', NULL, 'Protein disulfide isomerase 3, putative', 112, NULL, NULL, 165322),
(165323, '1.10.472.130-FF-000040', NULL, 'Dynein, axonemal, heavy chain 12', 111, NULL, NULL, 165323),
(165324, '3.10.20.30-FF-000048', NULL, 'BnaA01g28110D protein', 108, NULL, NULL, 165324),
(165325, '3.30.160.60-FF-005181', NULL, NULL, 43, NULL, NULL, 165325),
(165326, '1.10.1620.20-FF-000011', NULL, 'ATP synthase subunit epsilon, mitochondrial', 57, NULL, NULL, 165326),
(165327, '3.40.50.1820-FF-000190', NULL, 'Prolyl carboxypeptidase like protein', 239, NULL, NULL, 165327),
(165328, '3.10.20.10-FF-000042', NULL, 'Cell death-inducing DFFA-like effector b', 80, NULL, NULL, 165328),
(165329, '3.30.40.10-FF-002291', NULL, 'Breast cancer type 1 susceptibility protein homolog', 38, NULL, NULL, 165329),
(165330, '3.40.20.10-FF-000063', NULL, 'YDR063W-like protein', 148, NULL, NULL, 165330),
(165331, '3.40.50.300-FF-000179', NULL, 'ABC transporter G family member 34', 305, NULL, NULL, 165331),
(165332, '2.120.10.30-FF-000421', NULL, 'Uncharacterized protein', 166, NULL, NULL, 165332),
(165333, '1.25.40.10-FF-004016', NULL, 'Uncharacterized protein', 197, NULL, NULL, 165333),
(165334, '3.30.160.60-FF-000178', NULL, 'Zinc finger protein 14 homolog', 27, NULL, NULL, 165334),
(165335, '1.20.120.1810-FF-000008', NULL, NULL, 77, NULL, NULL, 165335),
(165336, '1.10.472.10-FF-000304', NULL, 'Cyclin 9', 151, NULL, NULL, 165336),
(165337, '1.20.1600.10-FF-000049', NULL, 'Putative outer membrane efflux protein', 415, NULL, NULL, 165337),
(165338, '3.40.50.11530-FF-000016', NULL, 'Predicted protein', 95, NULL, NULL, 165338),
(165339, '3.40.50.720-FF-002339', NULL, 'Predicted protein', 162, NULL, NULL, 165339),
(165340, '3.40.50.300-FF-004782', NULL, 'ADP-ribosylation factor-related', 213, NULL, NULL, 165340),
(165341, '3.30.40.10-FF-001751', NULL, 'Predicted protein', 88, NULL, NULL, 165341),
(165342, '3.40.930.10-FF-000057', NULL, NULL, 325, NULL, NULL, 165342),
(165343, '2.130.10.10-FF-002483', NULL, 'Centriole proteome protein', 207, NULL, NULL, 165343),
(165344, '2.60.40.10-FF-001898', NULL, 'Twitchin', 92, NULL, NULL, 165344),
(165345, '3.90.550.10-FF-000157', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 201, NULL, NULL, 165345),
(165346, '2.30.30.490-FF-000018', NULL, 'Lid2 complex component snt2', 132, NULL, NULL, 165346),
(165347, '1.25.40.20-FF-001467', NULL, 'Ankyrin repeat protein C9L', 230, NULL, NULL, 165347),
(165348, '2.60.40.10-FF-002174', NULL, 'Signal-regulatory protein beta 3', 101, NULL, NULL, 165348),
(165349, '3.60.10.10-FF-000308', NULL, 'DNA-(apurinic or apyrimidinic site) lyase', 304, NULL, NULL, 165349),
(165350, '3.40.630.30-FF-000231', NULL, 'uncharacterized protein LOC106768637', 128, NULL, NULL, 165350),
(165351, '3.90.1480.20-FF-000041', NULL, 'Uncharacterized protein', 280, NULL, NULL, 165351),
(165352, '1.20.1280.50-FF-000069', NULL, 'F-box/SPRY domain-containing protein 1', 48, NULL, NULL, 165352),
(165353, '1.25.10.10-FF-003407', NULL, 'Uncharacterized protein', 80, NULL, NULL, 165353),
(165354, '2.60.40.10-FF-005085', NULL, NULL, 100, NULL, NULL, 165354),
(165355, '3.40.50.300-FF-008093', NULL, 'Uncharacterized protein', 113, NULL, NULL, 165355),
(165356, '2.60.40.10-FF-002999', NULL, 'Chitinase', 90, NULL, NULL, 165356),
(165357, '3.40.47.10-FF-000271', NULL, NULL, 129, NULL, NULL, 165357),
(165358, '1.25.40.10-FF-000705', NULL, 'Related to PEX5-peroxisomal targeting signal receptor', 347, NULL, NULL, 165358),
(165359, '1.25.40.20-FF-000242', NULL, 'Ankyrin repeat, SAM and basic leucine zipper domain-containing protein 1', 70, NULL, NULL, 165359),
(165360, '1.20.1420.30-FF-000002', NULL, 'Sodium/potassium/calcium exchanger 2 isoform 1', 193, NULL, NULL, 165360),
(165361, '1.10.630.10-FF-000588', NULL, 'Cytochrome P450, family 4, subfamily a, polypeptide 31', 293, NULL, NULL, 165361);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(165362, '3.10.20.90-FF-000200', NULL, 'Diacylglycerol kinase', 106, NULL, NULL, 165362),
(165363, '1.10.287.280-FF-000005', NULL, 'DNA-directed RNA polymerase', 71, NULL, NULL, 165363),
(165364, '2.60.20.10-FF-000019', NULL, NULL, 89, NULL, NULL, 165364),
(165365, '1.10.510.10-FF-002614', NULL, NULL, 133, NULL, NULL, 165365),
(165366, '1.10.510.10-FF-004300', NULL, NULL, 158, NULL, NULL, 165366),
(165367, '3.80.10.10-FF-002770', NULL, 'Probable disease resistance protein At5g47260', 237, NULL, NULL, 165367),
(165368, '1.20.272.10-FF-000006', NULL, 'Replication factor C subunit 2', 93, NULL, NULL, 165368),
(165369, '3.40.1110.10-FF-000360', NULL, NULL, 137, NULL, NULL, 165369),
(165370, '1.10.510.10-FF-001254', NULL, 'Serine/threonine-protein kinase ATG1', 302, NULL, NULL, 165370),
(165371, '3.60.150.10-FF-000004', NULL, 'Chorismate synthase', 396, NULL, NULL, 165371),
(165372, '1.20.142.10-FF-000002', NULL, 'Poly [ADP-ribose] polymerase', 148, NULL, NULL, 165372),
(165373, '1.20.120.1380-FF-000003', NULL, 'Flagellar biosynthesis regulator FlhF', 55, NULL, NULL, 165373),
(165374, '2.60.40.10-FF-001774', NULL, 'Uncharacterized LOC100216153', 109, NULL, NULL, 165374),
(165375, '2.30.29.30-FF-000597', NULL, 'Protein CBG02248', 97, NULL, NULL, 165375),
(165376, '2.40.160.20-FF-000027', NULL, 'Omp-1N', 186, NULL, NULL, 165376),
(165377, '3.30.160.60-FF-002387', NULL, 'Zinc finger protein 346', 47, NULL, NULL, 165377),
(165378, '1.10.10.820-FF-000026', NULL, 'Uncharacterized protein, isoform D', 58, NULL, NULL, 165378),
(165379, '3.40.850.10-FF-000556', NULL, 'Uncharacterized protein', 130, NULL, NULL, 165379),
(165380, '1.10.132.110-FF-000003', NULL, 'Serum amyloid A protein, putative', 103, NULL, NULL, 165380),
(165381, '4.10.860.130-FF-000001', NULL, '40S ribosomal protein S13', 48, NULL, NULL, 165381),
(165382, '1.10.1280.10-FF-000026', NULL, 'Tyrosinase', 77, NULL, NULL, 165382),
(165383, '3.90.1600.10-FF-000037', NULL, 'DNA polymerase', 168, NULL, NULL, 165383),
(165384, '3.40.50.1820-FF-000875', NULL, 'Os07g0575800 protein', 195, NULL, NULL, 165384),
(165385, '3.30.70.270-FF-000226', NULL, NULL, 28, NULL, NULL, 165385),
(165386, '2.130.10.10-FF-003764', NULL, 'Ribosome biogenesis protein WDR12 homolog', 322, NULL, NULL, 165386),
(165387, '1.10.510.10-FF-000473', NULL, 'Putative wall-associated kinase', 204, NULL, NULL, 165387),
(165388, '3.80.10.10-FF-003787', NULL, 'RNI-like superfamily protein', 250, NULL, NULL, 165388),
(165389, '3.60.40.10-FF-000075', NULL, 'Protein phosphatase 2C, putative', 296, NULL, NULL, 165389),
(165390, '2.10.220.10-FF-000008', NULL, 'Receptor protein-tyrosine kinase', 144, NULL, NULL, 165390),
(165391, '1.10.8.480-FF-000016', NULL, 'rRNA adenine N(6)-methyltransferase', 90, NULL, NULL, 165391),
(165392, '2.20.110.10-FF-000065', NULL, NULL, 54, NULL, NULL, 165392),
(165393, '2.30.30.210-FF-000013', NULL, 'Ribonuclease P protein subunit', 134, NULL, NULL, 165393),
(165394, '3.80.10.10-FF-003843', NULL, 'Leucine Rich Repeat family protein', 231, NULL, NULL, 165394),
(165395, '3.60.40.10-FF-000131', NULL, 'Orphans transcription factor', 288, NULL, NULL, 165395),
(165396, '3.80.10.10-FF-004411', NULL, 'F-box family protein', 74, NULL, NULL, 165396),
(165397, '1.25.40.20-FF-000922', NULL, 'Predicted protein', 69, NULL, NULL, 165397),
(165398, '2.40.50.140-FF-001264', NULL, NULL, 62, NULL, NULL, 165398),
(165399, '3.30.1540.20-FF-000009', NULL, 'DNA mismatch repair protein MutL', 82, NULL, NULL, 165399),
(165400, '2.40.50.690-FF-000001', NULL, 'Cell wall biogenesis protein', 105, NULL, NULL, 165400),
(165401, '1.20.1250.10-FF-000128', NULL, NULL, 113, NULL, NULL, 165401),
(165402, '3.30.70.1230-FF-000127', NULL, 'Chlamyopsin-5 sensory rhodopsin', 197, NULL, NULL, 165402),
(165403, '2.130.10.10-FF-000061', NULL, 'Ribosome biogenesis protein BOP1 homolog', 359, NULL, NULL, 165403),
(165404, '2.60.40.10-FF-005933', NULL, NULL, 103, NULL, NULL, 165404),
(165405, '3.10.440.10-FF-000004', NULL, '50S ribosomal protein L31e', 89, NULL, NULL, 165405),
(165406, '3.30.40.10-FF-000379', NULL, 'transcription intermediary factor 1-alpha isoform X1', 113, NULL, NULL, 165406);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(165407, '3.80.10.10-FF-004355', NULL, 'ADR009Wp', 178, NULL, NULL, 165407),
(165408, '3.80.10.10-FF-004299', NULL, 'Si:dkey-126g1.7', 225, NULL, NULL, 165408),
(165409, '3.40.50.740-FF-000024', NULL, 'Probable oxidoreductase YoaE', 164, NULL, NULL, 165409),
(165410, '2.60.40.10-FF-005877', NULL, NULL, 84, NULL, NULL, 165410),
(165411, '3.90.360.10-FF-000002', NULL, 'Histone acetyltransferase type B catalytic subunit', 123, NULL, NULL, 165411),
(165412, '1.10.10.10-FF-001698', NULL, 'Cell division control protein', 104, NULL, NULL, 165412),
(165413, '2.30.30.40-FF-000227', NULL, 'Uncharacterized protein, isoform B', 65, NULL, NULL, 165413),
(165414, '2.30.42.10-FF-000279', NULL, 'Membrane-associated guanylate kinase, WW and PDZ domain-containing protein 3', 65, NULL, NULL, 165414),
(165415, '3.40.50.970-FF-000183', NULL, 'Transketolase-1 chloroplastic', 126, NULL, NULL, 165415),
(165416, '1.10.238.10-FF-000452', NULL, 'Calcium-dependent protein kinase 7', 76, NULL, NULL, 165416),
(165417, '3.30.420.10-FF-000291', NULL, 'Protein CBG02435', 155, NULL, NULL, 165417),
(165418, '2.130.10.10-FF-003820', NULL, 'Uncharacterized protein', 303, NULL, NULL, 165418),
(165419, '1.25.40.10-FF-004067', NULL, 'Uncharacterized protein', 193, NULL, NULL, 165419),
(165420, '3.90.1140.10-FF-000013', NULL, 'U6 snRNA phosphodiesterase', 98, NULL, NULL, 165420),
(165421, '3.40.50.300-FF-004731', NULL, 'Uncharacterized protein', 116, NULL, NULL, 165421),
(165422, '2.170.40.20-FF-000007', NULL, 'Truncated surface protein', 324, NULL, NULL, 165422),
(165423, '3.40.50.1010-FF-000222', NULL, NULL, 109, NULL, NULL, 165423),
(165424, '3.40.47.10-FF-000220', NULL, NULL, 140, NULL, NULL, 165424),
(165425, '3.40.50.300-FF-005243', NULL, 'RNA ligase/AAA domain containing protein, putative', 195, NULL, NULL, 165425),
(165426, '1.25.40.10-FF-003555', NULL, 'Uncharacterized protein', 54, NULL, NULL, 165426),
(165427, '2.130.10.10-FF-004332', NULL, 'Uncharacterized protein', 100, NULL, NULL, 165427),
(165428, '3.40.50.2000-FF-000468', NULL, 'Alpha 1 3-mannosyltransferase alg2 putative', 183, NULL, NULL, 165428),
(165429, '3.10.110.10-FF-000232', NULL, 'Uncharacterized protein', 155, NULL, NULL, 165429),
(165430, '2.40.33.10-FF-000011', NULL, 'Pyruvate kinase', 97, NULL, NULL, 165430),
(165431, '2.10.220.10-FF-000059', NULL, 'Fraser extracellular matrix complex subunit 1', 82, NULL, NULL, 165431),
(165432, '3.30.160.60-FF-003909', NULL, NULL, 27, NULL, NULL, 165432),
(165433, '2.60.40.2910-FF-000001', NULL, 'Major fimbrial subunit of aggregative adherence fimbria II', 33, NULL, NULL, 165433),
(165434, '3.30.505.10-FF-000044', NULL, 'Tyrosine-protein kinase', 111, NULL, NULL, 165434),
(165435, '1.25.40.10-FF-003504', NULL, 'AGAP000894-PA', 231, NULL, NULL, 165435),
(165436, '3.30.450.40-FF-000003', NULL, 'GTP-sensing transcriptional pleiotropic repressor CodY', 159, NULL, NULL, 165436),
(165437, '2.60.40.10-FF-004416', NULL, NULL, 98, NULL, NULL, 165437),
(165438, '3.40.50.300-FF-005294', NULL, 'YALI0E06171p', 174, NULL, NULL, 165438),
(165439, '2.130.10.10-FF-004225', NULL, 'Uncharacterized protein', 146, NULL, NULL, 165439),
(165440, '3.40.50.300-FF-001932', NULL, 'Translesion DNA synthesis-associated protein ImuA', 114, NULL, NULL, 165440),
(165441, '3.40.50.300-FF-001876', NULL, 'Type IV secretion system protein VirB4', 231, NULL, NULL, 165441),
(165442, '1.10.630.10-FF-000532', NULL, 'Predicted protein', 380, NULL, NULL, 165442),
(165443, '2.60.120.10-FF-000265', NULL, 'Phosphomannose isomerase type I, putative', 67, NULL, NULL, 165443),
(165444, '2.40.160.90-FF-000003', NULL, 'Lipoprotein binding FH', 125, NULL, NULL, 165444),
(165445, '1.20.1250.20-FF-000457', NULL, 'Uncharacterized protein', 435, NULL, NULL, 165445),
(165446, '1.25.40.10-FF-004808', NULL, 'Pentatricopeptide repeat-containing protein', 161, NULL, NULL, 165446),
(165447, '1.10.10.160-FF-000019', NULL, 'DNA helicase', 67, NULL, NULL, 165447),
(165448, '2.30.30.380-FF-000036', NULL, 'Protein transport protein SEC23', 46, NULL, NULL, 165448),
(165449, '3.10.20.90-FF-000700', NULL, 'FERM domain-containing protein A', 99, NULL, NULL, 165449);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(165450, '3.40.50.1820-FF-000982', NULL, 'Uncharacterized protein, isoform B', 256, NULL, NULL, 165450),
(165451, '3.30.230.10-FF-000309', NULL, 'Galactokinase', 218, NULL, NULL, 165451),
(165452, '3.30.70.270-FF-000333', NULL, NULL, 45, NULL, NULL, 165452),
(165453, '3.30.160.60-FF-006041', NULL, NULL, 78, NULL, NULL, 165453),
(165454, '2.10.25.10-FF-000656', NULL, 'Shifted, isoform B', 80, NULL, NULL, 165454),
(165455, '3.30.70.270-FF-000277', NULL, NULL, 118, NULL, NULL, 165455),
(165456, '1.20.1070.10-FF-000997', NULL, 'Uncharacterized protein', 303, NULL, NULL, 165456),
(165457, '2.170.130.20-FF-000006', NULL, 'Multidomain scavenger receptor', 101, NULL, NULL, 165457),
(165458, '1.25.40.500-FF-000005', NULL, 'GM23579', 143, NULL, NULL, 165458),
(165459, '2.130.10.10-FF-000010', NULL, 'Coatomer subunit alpha', 315, NULL, NULL, 165459),
(165460, '3.10.360.10-FF-000003', NULL, 'Gallin protein', 41, NULL, NULL, 165460),
(165461, '1.10.630.10-FF-000476', NULL, 'Fatty-acid-binding protein 2', 140, NULL, NULL, 165461),
(165462, '3.40.50.150-FF-001050', NULL, NULL, 88, NULL, NULL, 165462),
(165463, '3.40.250.10-FF-000027', NULL, 'Dual specificity phosphatase 4', 149, NULL, NULL, 165463),
(165464, '2.170.150.20-FF-000013', NULL, 'protein cereblon homolog', 146, NULL, NULL, 165464),
(165465, '3.30.160.20-FF-000037', NULL, '39S ribosomal protein L44, mitochondrial', 85, NULL, NULL, 165465),
(165466, '3.30.590.10-FF-000010', NULL, 'Glutamine synthetase', 191, NULL, NULL, 165466),
(165467, '3.40.50.1460-FF-000059', NULL, 'Uncharacterized protein', 299, NULL, NULL, 165467),
(165468, '1.10.10.10-FF-000237', NULL, 'DNA-directed RNA polymerase III subunit RPC6', 64, NULL, NULL, 165468),
(165469, '3.10.280.10-FF-000002', NULL, 'Mitochondrial glycoprotein family protein', 205, NULL, NULL, 165469),
(165470, '3.30.450.60-FF-000009', NULL, 'AP complex subunit sigma', 150, NULL, NULL, 165470),
(165471, '3.40.1280.10-FF-000074', NULL, 'Ribosomal RNA small subunit methyltransferase E', 247, NULL, NULL, 165471),
(165472, '3.60.10.10-FF-000303', NULL, 'Endonuclease/exonuclease/phosphatase, putative', 315, NULL, NULL, 165472),
(165473, '3.30.70.1230-FF-000178', NULL, 'Predicted protein', 178, NULL, NULL, 165473),
(165474, '1.10.10.140-FF-000013', NULL, 'Uncharacterized protein', 65, NULL, NULL, 165474),
(165475, '1.25.40.10-FF-003611', NULL, 'Adenylyl cyclase class-3/4/guanylyl cyclase', 121, NULL, NULL, 165475),
(165476, '3.40.50.10380-FF-000019', NULL, 'Malic enzyme', 251, NULL, NULL, 165476),
(165477, '2.60.40.10-FF-001662', NULL, 'Sidekick cell adhesion molecule 2b', 78, NULL, NULL, 165477),
(165478, '3.90.480.10-FF-000005', NULL, 'Sulfite reductase, assimilatory', 78, NULL, NULL, 165478),
(165479, '3.40.50.300-FF-005187', NULL, 'Uncharacterized ABC transporter ATP-binding protein HI_1618', 215, NULL, NULL, 165479),
(165480, '1.20.58.70-FF-000089', NULL, 'Syntaxin, putative', 93, NULL, NULL, 165480),
(165481, '1.10.10.10-FF-001754', NULL, 'YALI0D14520p', 107, NULL, NULL, 165481),
(165482, '2.60.120.10-FF-000158', NULL, 'Cyclic nucleotide-binding domain protein', 131, NULL, NULL, 165482),
(165483, '3.40.710.10-FF-000125', NULL, 'Penicillin-binding protein PbpC', 366, NULL, NULL, 165483),
(165484, '3.40.50.620-FF-000662', NULL, 'Uncharacterized protein', 207, NULL, NULL, 165484),
(165485, '3.30.160.60-FF-004124', NULL, NULL, 33, NULL, NULL, 165485),
(165486, '3.30.200.20-FF-001553', NULL, 'Predicted protein', 100, NULL, NULL, 165486),
(165487, '1.20.1250.20-FF-002374', NULL, 'Predicted protein', 251, NULL, NULL, 165487),
(165488, '3.40.50.300-FF-007660', NULL, 'Uncharacterized protein', 128, NULL, NULL, 165488),
(165489, '3.30.200.20-FF-000018', NULL, 'Casein kinase I isoform gamma-1', 88, NULL, NULL, 165489),
(165490, '1.20.1270.60-FF-000280', NULL, 'Uncharacterized protein', 215, NULL, NULL, 165490),
(165491, '1.25.40.10-FF-001138', NULL, 'Pentatricopeptide repeat-containing protein At1g33350', 109, NULL, NULL, 165491),
(165492, '2.30.30.140-FF-000200', NULL, 'RING finger protein 17', 70, NULL, NULL, 165492);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(165493, '1.20.1110.10-FF-000242', NULL, 'Sodium/potassium-transporting ATPase subunit alpha', 411, NULL, NULL, 165493),
(165494, '1.10.3380.10-FF-000034', NULL, 'Activating signal cointegrator 1 complex subunit 3-like', 137, NULL, NULL, 165494),
(165495, '1.25.40.10-FF-004859', NULL, 'Paf1 complex component', 236, NULL, NULL, 165495),
(165496, '3.40.50.11540-FF-000002', NULL, 'Putative oxidoreductase', 173, NULL, NULL, 165496),
(165497, '3.30.160.60-FF-004068', NULL, NULL, 46, NULL, NULL, 165497),
(165498, '1.10.285.10-FF-000015', NULL, 'Glutamate dehydrogenase', 17, NULL, NULL, 165498),
(165499, '1.10.510.10-FF-001889', NULL, 'Guanylate cyclase', 255, NULL, NULL, 165499),
(165500, '3.60.21.10-FF-000115', NULL, 'Putative metallophosphoesterase', 188, NULL, NULL, 165500),
(165501, '2.60.40.1660-FF-000036', NULL, 'ATPase Na+/K+-transporting subunit beta 3a', 33, NULL, NULL, 165501),
(165502, '2.60.450.10-FF-000019', NULL, 'Lipopolysaccharide export system protein LptA', 133, NULL, NULL, 165502),
(165503, '2.10.25.10-FF-001612', NULL, 'AGAP007850-PA', 85, NULL, NULL, 165503),
(165504, '3.90.740.10-FF-000043', NULL, 'Isoleucine-tRNA ligase', 170, NULL, NULL, 165504),
(165505, '1.25.40.20-FF-000074', NULL, 'Usher syndrome type-1G protein isoform X1', 172, NULL, NULL, 165505),
(165506, '1.20.58.1610-FF-000025', NULL, NULL, 122, NULL, NULL, 165506),
(165507, '3.40.50.1440-FF-000053', NULL, 'Predicted protein', 334, NULL, NULL, 165507),
(165508, '3.30.1370.60-FF-000002', NULL, 'Malate/L-lactate family dehydrogenase', 235, NULL, NULL, 165508),
(165509, '3.40.50.720-FF-001322', NULL, 'PERMeable eggshell', 267, NULL, NULL, 165509),
(165510, '3.90.660.10-FF-000042', NULL, 'Putative bifunctional amine oxidase DDB_G0291301', 150, NULL, NULL, 165510),
(165511, '3.30.160.60-FF-004961', NULL, NULL, 77, NULL, NULL, 165511),
(165512, '2.60.40.10-FF-003516', NULL, NULL, 86, NULL, NULL, 165512),
(165513, '3.40.50.300-FF-002314', NULL, 'Iron ABC transporter, ATP-binding protein', 242, NULL, NULL, 165513),
(165514, '2.30.30.30-FF-000005', NULL, '40S ribosomal protein S4', 71, NULL, NULL, 165514),
(165515, '3.30.160.60-FF-005473', NULL, NULL, 58, NULL, NULL, 165515),
(165516, '2.60.40.10-FF-003112', NULL, 'Fibronectin_type_III_domain_containing_protein_-_putative', 118, NULL, NULL, 165516),
(165517, '2.20.28.230-FF-000007', NULL, 'Interleukin-2 receptor subunit alpha', 20, NULL, NULL, 165517),
(165518, '3.40.1280.30-FF-000029', NULL, 'Chromosome 15, whole genome shotgun sequence', 259, NULL, NULL, 165518),
(165519, '3.90.660.10-FF-000047', NULL, 'Putative polyamine oxidase 5 isoform A', 192, NULL, NULL, 165519),
(165520, '3.40.1280.10-FF-000023', NULL, 'Ribosomal RNA small subunit methyltransferase E', 172, NULL, NULL, 165520),
(165521, '1.25.40.10-FF-000649', NULL, 'mRNA splicing factor (Prp1/Zer1), putative', 168, NULL, NULL, 165521),
(165522, '3.30.70.80-FF-000031', NULL, 'Subtilisin-like protease SBT1.1', 88, NULL, NULL, 165522),
(165523, '3.30.200.20-FF-002042', NULL, 'AGC family protein kinase', 89, NULL, NULL, 165523),
(165524, '1.10.10.350-FF-000014', NULL, 'Glutamate--tRNA ligase', 124, NULL, NULL, 165524),
(165525, '1.10.3720.10-FF-000134', NULL, 'Amino acid ABC transporter permease', 206, NULL, NULL, 165525),
(165526, '1.20.1540.10-FF-000050', NULL, 'Rhomboid-like protein', 187, NULL, NULL, 165526),
(165527, '3.30.70.330-FF-001666', NULL, NULL, 90, NULL, NULL, 165527),
(165528, '3.40.50.620-FF-000550', NULL, 'Uncharacterized protein', 257, NULL, NULL, 165528),
(165529, '3.40.50.300-FF-008172', NULL, 'Uncharacterized protein', 85, NULL, NULL, 165529),
(165530, '2.130.10.10-FF-000914', NULL, 'Transducin/WD40 repeat-like superfamily protein', 342, NULL, NULL, 165530),
(165531, '3.40.50.720-FF-000698', NULL, 'Putative oxidoreductase', 179, NULL, NULL, 165531),
(165532, '3.60.60.10-FF-000019', NULL, 'LD30995p', 186, NULL, NULL, 165532),
(165533, '2.60.40.60-FF-000811', NULL, 'Predicted protein', 102, NULL, NULL, 165533),
(165534, '1.10.287.130-FF-000084', NULL, 'Sensor histidine kinase', 70, NULL, NULL, 165534);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(165535, '3.30.1360.80-FF-000002', NULL, 'S-ribosylhomocysteine lyase', 152, NULL, NULL, 165535),
(165536, '3.90.280.10-FF-000001', NULL, 'Terminal flower 1', 172, NULL, NULL, 165536),
(165537, '1.25.10.10-FF-001081', NULL, 'Hypothetical_protein_-_conserved', 194, NULL, NULL, 165537),
(165538, '1.20.1070.10-FF-001143', NULL, 'Predicted protein', 296, NULL, NULL, 165538),
(165539, '3.30.1330.90-FF-000003', NULL, 'D-3-phosphoglycerate dehydrogenase', 147, NULL, NULL, 165539),
(165540, '3.30.505.10-FF-000156', NULL, NULL, 108, NULL, NULL, 165540),
(165541, '1.10.1370.30-FF-000011', NULL, 'Angiotensin-converting enzyme', 323, NULL, NULL, 165541),
(165542, '2.10.25.10-FF-001112', NULL, 'Uncharacterized protein', 34, NULL, NULL, 165542),
(165543, '1.10.287.70-FF-000560', NULL, 'Uncharacterized protein', 65, NULL, NULL, 165543),
(165544, '3.30.1010.10-FF-000034', NULL, 'Serine/threonine-protein kinase TOR', 130, NULL, NULL, 165544),
(165545, '3.90.440.10-FF-000003', NULL, 'Nitric oxide synthase', 32, NULL, NULL, 165545),
(165546, '3.30.1460.20-FF-000008', NULL, 'Arp2/3 complex 34 kDa subunit', 174, NULL, NULL, 165546),
(165547, '3.80.10.10-FF-000914', NULL, 'Toll-like receptor 22', 205, NULL, NULL, 165547),
(165548, '3.30.470.30-FF-000069', NULL, 'DNA ligase IV', 253, NULL, NULL, 165548),
(165549, '3.90.550.50-FF-000034', NULL, 'Parasite-infected erythrocyte surface protein', 227, NULL, NULL, 165549),
(165550, '2.60.40.10-FF-004528', NULL, NULL, 92, NULL, NULL, 165550),
(165551, '3.40.50.1580-FF-000022', NULL, 'Uridine phosphorylase 1', 146, NULL, NULL, 165551),
(165552, '3.30.505.10-FF-000100', NULL, 'phosphatidylinositol 3-kinase regulatory subunit gamma', 121, NULL, NULL, 165552),
(165553, '1.20.5.1430-FF-000010', NULL, 'Microtubule End Binding Protein', 84, NULL, NULL, 165553),
(165554, '1.10.3660.10-FF-000016', NULL, 'Prephenate dehydrogenase', 105, NULL, NULL, 165554),
(165555, '2.10.220.10-FF-000115', NULL, 'Proprotein convertase subtilisin/kexin type 5', 102, NULL, NULL, 165555),
(165556, '2.60.120.200-FF-000806', NULL, 'Uncharacterized protein', 56, NULL, NULL, 165556),
(165557, '2.30.130.10-FF-000019', NULL, 'tRNA pseudouridine synthase A', 21, NULL, NULL, 165557),
(165558, '2.10.25.10-FF-000712', NULL, 'Uncharacterized protein', 39, NULL, NULL, 165558),
(165559, '3.40.50.10420-FF-000060', NULL, '5-formyltetrahydrofolate cyclo-ligase', 176, NULL, NULL, 165559),
(165560, '1.25.10.10-FF-002441', NULL, 'TELO2-interacting protein 1 homolog-like Protein', 235, NULL, NULL, 165560),
(165561, '1.20.144.10-FF-000052', NULL, 'Uncharacterized protein, isoform A', 243, NULL, NULL, 165561),
(165562, '4.10.400.10-FF-000352', NULL, 'Vitellogenin receptor', 30, NULL, NULL, 165562),
(165563, '1.10.20.140-FF-000009', NULL, 'tRNA dimethylallyltransferase', 72, NULL, NULL, 165563),
(165564, '3.30.160.60-FF-003168', NULL, 'AGAP004651-PA', 27, NULL, NULL, 165564),
(165565, '1.20.1310.10-FF-000134', NULL, NULL, 116, NULL, NULL, 165565),
(165566, '3.30.70.2630-FF-000002', NULL, 'Telomerase reverse transcriptase', 99, NULL, NULL, 165566),
(165567, '2.40.100.10-FF-000021', NULL, 'Peptidyl-prolyl cis-trans isomerase', 179, NULL, NULL, 165567),
(165568, '3.40.50.1010-FF-000166', NULL, NULL, 221, NULL, NULL, 165568),
(165569, '2.130.10.30-FF-000049', NULL, 'HECT and RLD domain containing E3 ubiquitin protein ligase family member 6', 236, NULL, NULL, 165569),
(165570, '1.20.1080.10-FF-000031', NULL, 'Glycerol channel', 258, NULL, NULL, 165570),
(165571, '3.20.20.70-FF-000008', NULL, 'Dual-specificity RNA methyltransferase RlmN', 282, NULL, NULL, 165571),
(165572, '1.20.1280.50-FF-000176', NULL, 'Uncharacterized protein', 99, NULL, NULL, 165572),
(165573, '3.30.300.20-FF-000077', NULL, 'Uncharacterized protein', 58, NULL, NULL, 165573),
(165574, '2.60.40.10-FF-000257', NULL, 'Dyslexia-associated protein KIAA0319-like', 100, NULL, NULL, 165574),
(165575, '1.10.8.60-FF-000251', NULL, 'replication factor C familiy protein', 62, NULL, NULL, 165575),
(165576, '1.10.8.270-FF-000015', NULL, 'GTPase activating protein (Gyp2)', 100, NULL, NULL, 165576);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(165577, '1.10.10.10-FF-000349', NULL, 'Heat shock transcription factor, Y-linked', 117, NULL, NULL, 165577),
(165578, '4.10.60.10-FF-000093', NULL, 'cellular nucleic acid-binding protein-like isoform X2', 22, NULL, NULL, 165578),
(165579, '2.130.10.10-FF-004276', NULL, 'Uncharacterized protein', 129, NULL, NULL, 165579),
(165580, '1.10.565.10-FF-000048', NULL, 'Nuclear hormone receptor family member nhr-35', 257, NULL, NULL, 165580),
(165581, '3.10.250.10-FF-000118', NULL, NULL, 70, NULL, NULL, 165581),
(165582, '1.25.40.10-FF-003499', NULL, 'Putative pentatricopeptide repeat-containing protein At1g13800', 65, NULL, NULL, 165582),
(165583, '1.20.1270.280-FF-000015', NULL, 'Dynein heavy chain-like protein', 202, NULL, NULL, 165583),
(165584, '3.30.160.60-FF-002600', NULL, 'Zinc finger protein', 26, NULL, NULL, 165584),
(165585, '1.25.40.10-FF-004011', NULL, 'Uncharacterized protein', 202, NULL, NULL, 165585),
(165586, '2.60.40.10-FF-006041', NULL, NULL, 78, NULL, NULL, 165586),
(165587, '1.20.58.120-FF-000001', NULL, 'BAG family molecular chaperone regulator 4', 87, NULL, NULL, 165587),
(165588, '3.30.70.870-FF-000018', NULL, 'Translation elongation factor G', 79, NULL, NULL, 165588),
(165589, '3.30.70.270-FF-000338', NULL, NULL, 42, NULL, NULL, 165589),
(165590, '3.40.30.10-FF-000524', NULL, 'Thioredoxin', 105, NULL, NULL, 165590),
(165591, '3.40.30.10-FF-000468', NULL, 'Glutathione peroxidase', 161, NULL, NULL, 165591),
(165592, '1.10.510.10-FF-000877', NULL, 'TAO kinase 2', 214, NULL, NULL, 165592),
(165593, '3.30.40.10-FF-002296', NULL, 'RING finger protein', 118, NULL, NULL, 165593),
(165594, '3.40.1360.10-FF-000024', NULL, 'DNA primase', 124, NULL, NULL, 165594),
(165595, '3.90.740.10-FF-000048', NULL, 'Leucine--tRNA ligase', 107, NULL, NULL, 165595),
(165596, '3.30.160.60-FF-003112', NULL, 'Zinc finger imprinted 2', 35, NULL, NULL, 165596),
(165597, '3.30.420.40-FF-000182', NULL, 'Plasmid segregation protein ParM', 125, NULL, NULL, 165597),
(165598, '3.50.70.10-FF-000004', NULL, 'Altered inheritance of mitochondria protein 18, mitochondrial', 166, NULL, NULL, 165598),
(165599, '3.10.580.10-FF-000042', NULL, 'DUF21 domain-containing protein isoform A', 75, NULL, NULL, 165599),
(165600, '3.90.226.10-FF-000303', NULL, '3-hydroxyisobutyryl-CoA hydrolase 1', 133, NULL, NULL, 165600),
(165601, '3.30.160.60-FF-002544', NULL, NULL, 27, NULL, NULL, 165601),
(165602, '3.30.70.330-FF-000492', NULL, 'Blast:Myelin expression factor 2', 70, NULL, NULL, 165602),
(165603, '1.50.40.10-FF-000113', NULL, 'Mitochondrial substrate carrier family protein', 160, NULL, NULL, 165603),
(165604, '2.60.40.10-FF-000206', NULL, 'Sidekick cell adhesion molecule 2', 113, NULL, NULL, 165604),
(165605, '2.60.40.10-FF-005821', NULL, NULL, 48, NULL, NULL, 165605),
(165606, '2.30.42.10-FF-000167', NULL, 'whirlin isoform X1', 114, NULL, NULL, 165606),
(165607, '3.30.70.2840-FF-000003', NULL, 'Genome polyprotein', 50, NULL, NULL, 165607),
(165608, '3.30.200.20-FF-000193', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 3', 93, NULL, NULL, 165608),
(165609, '2.60.40.1510-FF-000014', NULL, 'Integrin subunit alpha 10', 149, NULL, NULL, 165609),
(165610, '1.10.285.10-FF-000010', NULL, 'Glutamate dehydrogenase', 48, NULL, NULL, 165610),
(165611, '3.90.79.10-FF-000084', NULL, 'RNA pyrophosphohydrolase', 151, NULL, NULL, 165611),
(165612, '1.10.4020.10-FF-000002', NULL, 'zinc finger and SCAN domain-containing protein 2', 85, NULL, NULL, 165612),
(165613, '2.130.10.10-FF-002308', NULL, 'Glycine-rich protein', 348, NULL, NULL, 165613),
(165614, '1.10.418.60-FF-000020', NULL, 'Uncharacterized protein', 163, NULL, NULL, 165614),
(165615, '3.60.20.10-FF-000192', NULL, NULL, 240, NULL, NULL, 165615),
(165616, '3.40.50.1100-FF-000193', NULL, 'Cysteine synthase', 131, NULL, NULL, 165616),
(165617, '1.10.10.10-FF-000405', NULL, 'HTH-type transcriptional regulator SinR', 85, NULL, NULL, 165617),
(165618, '3.40.50.300-FF-002421', NULL, 'DEAD boX helicase homolog', 237, NULL, NULL, 165618),
(165619, '2.40.100.10-FF-000077', NULL, 'Peptidyl-prolyl cis-trans isomerase', 65, NULL, NULL, 165619);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(165620, '3.40.630.50-FF-000001', NULL, 'D-aminoacyl-tRNA deacylase', 192, NULL, NULL, 165620),
(165621, '3.50.50.60-FF-001052', NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG 1', 246, NULL, NULL, 165621),
(165622, '1.20.1290.10-FF-000018', NULL, 'Uncharacterized protein', 140, NULL, NULL, 165622),
(165623, '1.20.58.70-FF-000033', NULL, 'Unplaced genomic scaffold supercont1.13, whole genome shotgun sequence', 215, NULL, NULL, 165623),
(165624, '3.30.519.10-FF-000042', NULL, NULL, 111, NULL, NULL, 165624),
(165625, '1.10.10.60-FF-000903', NULL, NULL, 37, NULL, NULL, 165625),
(165626, '1.25.10.10-FF-001985', NULL, 'HEAT repeat-containing protein 5B, putative', 481, NULL, NULL, 165626),
(165627, '1.20.1560.10-FF-000793', NULL, 'ATP-binding cassette sub-family C member Sur', 220, NULL, NULL, 165627),
(165628, '3.10.50.40-FF-000030', NULL, 'Peptidylprolyl isomerase', 133, NULL, NULL, 165628),
(165629, '3.40.50.300-FF-003326', NULL, 'GTP-binding protein, putative', 187, NULL, NULL, 165629),
(165630, '2.130.10.10-FF-004220', NULL, 'Predicted protein', 150, NULL, NULL, 165630),
(165631, '2.40.70.10-FF-000304', NULL, NULL, 187, NULL, NULL, 165631),
(165632, '2.40.50.1070-FF-000027', NULL, NULL, 151, NULL, NULL, 165632),
(165633, '1.20.870.10-FF-000025', NULL, 'C3G guanyl-nucleotide exchange factor, isoform L', 160, NULL, NULL, 165633),
(165634, '3.40.50.150-FF-000561', NULL, 'Hypothetical_protein_-_conserved', 230, NULL, NULL, 165634),
(165635, '3.30.830.10-FF-000046', NULL, 'Peptidase, M16 family', 222, NULL, NULL, 165635),
(165636, '1.20.58.1930-FF-000003', NULL, 'PfEMP1 variant 1 of strain MC', 243, NULL, NULL, 165636),
(165637, '2.60.40.1660-FF-000031', NULL, 'Uncharacterized protein', 181, NULL, NULL, 165637),
(165638, '2.10.25.10-FF-001056', NULL, 'Os06g0170250 protein', 30, NULL, NULL, 165638),
(165639, '1.10.510.10-FF-001838', NULL, 'Cell division protein kinase 6', 87, NULL, NULL, 165639),
(165640, '2.10.50.10-FF-000057', NULL, 'Cysteine repeat modular protein 4 PbCRM4', 59, NULL, NULL, 165640),
(165641, '2.60.40.10-FF-002730', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', 93, NULL, NULL, 165641),
(165642, '3.60.20.10-FF-000129', NULL, 'Proteasome subunit beta', 197, NULL, NULL, 165642),
(165643, '1.25.40.10-FF-002162', NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', 104, NULL, NULL, 165643),
(165644, '3.90.370.10-FF-000008', NULL, 'Metalloproteinase inhibitor 2', 100, NULL, NULL, 165644),
(165645, '3.90.320.10-FF-000005', NULL, 'Mitochondrial genome maintenance exonuclease 1', 203, NULL, NULL, 165645),
(165646, '3.40.30.10-FF-000125', NULL, 'DnaJ homolog subfamily C member 10', 111, NULL, NULL, 165646),
(165647, '3.30.160.60-FF-005585', NULL, NULL, 32, NULL, NULL, 165647),
(165648, '1.20.58.2140-FF-000004', NULL, 'Haloacid dehalogenase', 199, NULL, NULL, 165648),
(165649, '1.20.120.1320-FF-000013', NULL, 'Bifunctional aspartate kinase/diaminopimelate decarboxylase', 90, NULL, NULL, 165649),
(165650, '3.40.720.10-FF-000007', NULL, 'Arylsulfatase family, member J', 343, NULL, NULL, 165650),
(165651, '3.20.20.70-FF-000571', NULL, 'Delta-aminolevulinic acid dehydratase', 317, NULL, NULL, 165651),
(165652, '1.10.10.10-FF-001693', NULL, 'Winged-helix domain-containing putative tarnscription factor', 106, NULL, NULL, 165652),
(165653, '1.10.472.140-FF-000009', NULL, 'Retinoblastoma-like protein homolog lin-35', 135, NULL, NULL, 165653),
(165654, '3.30.565.10-FF-000553', NULL, 'PMS1 homolog 2, mismatch repair system component', 45, NULL, NULL, 165654),
(165655, '3.30.60.30-FF-000100', NULL, 'Agrin', 51, NULL, NULL, 165655),
(165656, '1.25.40.180-FF-000139', NULL, 'Eukaryotic translation initiation factor 4 gamma 1-like Protein', 200, NULL, NULL, 165656),
(165657, '4.10.1240.10-FF-000049', NULL, 'SEcretin/class B GPCR', 100, NULL, NULL, 165657),
(165658, '1.10.1420.10-FF-000178', NULL, 'DNA mismatch repair mutS protein', 125, NULL, NULL, 165658),
(165659, '2.40.100.10-FF-000026', NULL, 'Peptidyl-prolyl cis-trans isomerase', 160, NULL, NULL, 165659);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(165660, '3.30.1360.40-FF-000018', NULL, 'Ribosome-recycling factor, mitochondrial', 75, NULL, NULL, 165660),
(165661, '1.20.120.1760-FF-000033', NULL, 'CDP-alcohol phosphatidyltransferase', 168, NULL, NULL, 165661),
(165662, '3.30.450.150-FF-000006', NULL, 'UPF0303 protein EF915_34475', 157, NULL, NULL, 165662),
(165663, '3.40.50.300-FF-000572', NULL, 'Mitochondrial Rho GTPase', 172, NULL, NULL, 165663),
(165664, '1.10.287.4070-FF-000025', NULL, 'Pre-mRNA processing ribonucleoprotein, binding domain protein', 121, NULL, NULL, 165664),
(165665, '2.130.10.10-FF-005681', NULL, 'Alkaline phosphatase', 161, NULL, NULL, 165665),
(165666, '2.70.150.10-FF-000101', NULL, 'Probable cobalt/nickel-exporting P-type ATPase', 118, NULL, NULL, 165666),
(165667, '2.60.40.10-FF-002151', NULL, 'Sialic acid-binding Ig-like lectin 5', 89, NULL, NULL, 165667),
(165668, '3.40.50.10330-FF-000122', NULL, 'NAD kinase a', 55, NULL, NULL, 165668),
(165669, '1.20.5.580-FF-000004', NULL, 'Complexin-2', 55, NULL, NULL, 165669),
(165670, '3.40.50.300-FF-002365', NULL, 'Unplaced genomic scaffold supercont2.7, whole genome shotgun sequence', 267, NULL, NULL, 165670),
(165671, '2.30.130.110-FF-000002', NULL, 'Altronate hydrolase', 83, NULL, NULL, 165671),
(165672, '4.10.1000.10-FF-000048', NULL, 'ZFP family member', 67, NULL, NULL, 165672),
(165673, '1.25.40.20-FF-000130', NULL, 'Mindbomb E3 ubiquitin protein ligase 2', 170, NULL, NULL, 165673),
(165674, '3.80.10.10-FF-003051', NULL, 'Uncharacterized protein', 151, NULL, NULL, 165674),
(165675, '1.20.5.780-FF-000019', NULL, 'FXYD domain-containing ion transport regulator', 45, NULL, NULL, 165675),
(165676, '3.50.50.60-FF-000091', NULL, '15-cis-phytoene desaturase, chloroplastic/chromoplastic', 463, NULL, NULL, 165676),
(165677, '1.10.10.1940-FF-000014', NULL, NULL, 47, NULL, NULL, 165677),
(165678, '3.30.160.60-FF-001370', NULL, 'Zinc finger protein', 34, NULL, NULL, 165678),
(165679, '1.20.960.30-FF-000010', NULL, 'Uncharacterized protein', 58, NULL, NULL, 165679),
(165680, '1.20.120.720-FF-000023', NULL, 'Class V myosin', 156, NULL, NULL, 165680),
(165681, '1.20.1280.50-FF-000064', NULL, 'Os05g0177100 protein', 39, NULL, NULL, 165681),
(165682, '1.10.510.10-FF-004188', NULL, NULL, 183, NULL, NULL, 165682),
(165683, '2.60.40.10-FF-005080', NULL, NULL, 100, NULL, NULL, 165683),
(165684, '1.20.1050.10-FF-000147', NULL, 'Predicted protein', 152, NULL, NULL, 165684),
(165685, '3.40.50.80-FF-000119', NULL, 'Ferric reductase transmembrane component, putative', 199, NULL, NULL, 165685),
(165686, '1.20.1420.30-FF-000058', NULL, 'Predicted protein', 127, NULL, NULL, 165686),
(165687, '1.20.900.10-FF-000056', NULL, 'TOR unique function suppressor', 230, NULL, NULL, 165687),
(165688, '1.20.120.850-FF-000039', NULL, 'Helicase SWR1', 96, NULL, NULL, 165688),
(165689, '3.20.20.140-FF-000090', NULL, 'Adenosine deaminase', 341, NULL, NULL, 165689),
(165690, '2.40.128.330-FF-000001', NULL, 'Magnesium transporter MRS2-1', 84, NULL, NULL, 165690),
(165691, '2.170.270.10-FF-000108', NULL, 'Histone-lysine N-methyltransferase SETD5', 84, NULL, NULL, 165691),
(165692, '2.30.29.30-FF-000209', NULL, 'FYVE, RhoGEF and PH domain-containing protein 6', 103, NULL, NULL, 165692),
(165693, '3.30.870.10-FF-000043', NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', 211, NULL, NULL, 165693),
(165694, '3.40.50.800-FF-000008', NULL, 'histidine--tRNA ligase, cytoplasmic isoform X1', 101, NULL, NULL, 165694),
(165695, '2.130.10.10-FF-006018', NULL, 'Spliceosomal protein sap, putative', 153, NULL, NULL, 165695),
(165696, '3.50.50.60-FF-001395', NULL, 'Hydrogenase subunit, putative', 193, NULL, NULL, 165696),
(165697, '2.30.29.30-FF-001373', NULL, 'Uncharacterized protein', 196, NULL, NULL, 165697),
(165698, '3.30.70.330-FF-002122', NULL, NULL, 106, NULL, NULL, 165698),
(165699, '1.10.12.10-FF-000011', NULL, 'Enoyl-CoA hydratase/isomerase family protein', 48, NULL, NULL, 165699),
(165700, '3.40.1160.10-FF-000076', NULL, 'Aspartate kinase', 236, NULL, NULL, 165700),
(165701, '3.90.290.10-FF-000007', NULL, 'Fibrillin 2', 70, NULL, NULL, 165701);
INSERT INTO "PUBLIC"."MODEL" VALUES
(165702, '3.40.50.2300-FF-001368', NULL, NULL, 92, NULL, NULL, 165702),
(165703, '3.90.400.10-FF-000006', NULL, 'Alpha-glucosidase', 70, NULL, NULL, 165703),
(165704, '1.10.1580.10-FF-000015', NULL, 'Ras-like small GTPase, putative', 95, NULL, NULL, 165704),
(165705, '3.30.450.60-FF-000054', NULL, 'AP complex subunit sigma', 56, NULL, NULL, 165705),
(165706, '3.40.50.1010-FF-000273', NULL, NULL, 119, NULL, NULL, 165706),
(165707, '3.80.10.10-FF-002831', NULL, 'Uncharacterized protein', 98, NULL, NULL, 165707),
(165708, '1.25.10.10-FF-002334', NULL, 'Predicted protein', 296, NULL, NULL, 165708),
(165709, '3.40.50.300-FF-005979', NULL, 'CRISPR-associated helicase Cas3', 162, NULL, NULL, 165709),
(165710, '3.40.50.1820-FF-000015', NULL, 'Sn1-specific diacylglycerol lipase alpha', 245, NULL, NULL, 165710),
(165711, '1.10.10.60-FF-000898', NULL, NULL, 105, NULL, NULL, 165711),
(165712, '1.10.150.50-FF-000147', NULL, 'phosphatidylcholine:ceramide cholinephosphotransferase 2 isoform X1', 75, NULL, NULL, 165712),
(165713, '1.20.120.1760-FF-000084', NULL, NULL, 155, NULL, NULL, 165713),
(165714, '1.25.40.10-FF-000301', NULL, 'Nephronophthisis 3', 128, NULL, NULL, 165714),
(165715, '3.90.360.10-FF-000007', NULL, 'Histone acetyltransferase type B catalytic subunit', 15, NULL, NULL, 165715),
(165716, '3.40.1180.10-FF-000038', NULL, 'Dehydrodolichyl diphosphate synthase complex subunit nus1', 131, NULL, NULL, 165716),
(165717, '2.40.10.120-FF-000008', NULL, 'Genome polyprotein', 69, NULL, NULL, 165717),
(165718, '3.40.1000.10-FF-000031', NULL, 'Putative oxygen-evolving enhancer protein 2-2', 125, NULL, NULL, 165718),
(165719, '3.30.365.10-FF-000004', NULL, 'Xanthine dehydrogenase oxidase', 240, NULL, NULL, 165719),
(165720, '1.10.555.10-FF-000227', NULL, NULL, 131, NULL, NULL, 165720),
(165721, '1.25.40.20-FF-000181', NULL, 'Nanchung, isoform A', 289, NULL, NULL, 165721),
(165722, '1.10.238.110-FF-000018', NULL, 'Diacylglycerol kinase', 81, NULL, NULL, 165722),
(165723, '3.30.70.1230-FF-000234', NULL, 'Predicted protein', 191, NULL, NULL, 165723),
(165724, '3.20.20.80-FF-000337', NULL, 'Uncharacterized protein', 140, NULL, NULL, 165724),
(165725, '3.30.54.10-FF-000001', NULL, 'DNA replication terminus site-binding protein', 74, NULL, NULL, 165725),
(165726, '3.40.50.300-FF-006255', NULL, 'Predicted protein', 160, NULL, NULL, 165726),
(165727, '3.60.10.10-FF-000247', NULL, 'DNA-(apurinic or apyrimidinic site) lyase', 279, NULL, NULL, 165727),
(165728, '1.20.1070.10-FF-000923', NULL, 'Uncharacterized protein', 317, NULL, NULL, 165728),
(165729, '2.10.220.10-FF-000160', NULL, 'Proprotein convertase subtilisin/kexin type 5', 102, NULL, NULL, 165729),
(165730, '1.20.1050.10-FF-000203', NULL, 'Endothelial monocyte-activating polypeptide II pro-EMAP II family protein', 97, NULL, NULL, 165730),
(165731, '3.30.420.40-FF-000794', NULL, 'Actin-like protein 3', 119, NULL, NULL, 165731),
(165732, '3.90.440.10-FF-000008', NULL, 'Uncharacterized protein', 39, NULL, NULL, 165732),
(165733, '3.30.930.10-FF-000161', NULL, 'ATP phosphoribosyltransferase regulatory subunit', 329, NULL, NULL, 165733),
(165734, '1.10.510.10-FF-002327', NULL, NULL, 207, NULL, NULL, 165734),
(165735, '3.40.350.10-FF-000086', NULL, 'Xaa-Pro aminopeptidase', 148, NULL, NULL, 165735),
(165736, '2.20.110.10-FF-000060', NULL, NULL, 63, NULL, NULL, 165736),
(165737, '3.30.230.130-FF-000070', NULL, 'Cullin, putative', 153, NULL, NULL, 165737),
(165738, '3.40.50.800-FF-000059', NULL, 'Prolyl-tRNA synthetase', 114, NULL, NULL, 165738),
(165739, '3.40.630.70-FF-000007', NULL, 'Leucyl/phenylalanyl-tRNA--protein transferase', 173, NULL, NULL, 165739),
(165740, '3.40.630.10-FF-000012', NULL, 'Acetylornithine deacetylase', 224, NULL, NULL, 165740),
(165741, '1.10.510.10-FF-002390', NULL, NULL, 56, NULL, NULL, 165741),
(165742, '1.10.472.10-FF-000080', NULL, 'G1/S-specific cyclin', 114, NULL, NULL, 165742),
(165743, '2.130.10.10-FF-005529', NULL, 'Uncharacterized protein', 12, NULL, NULL, 165743),
(165744, '3.30.565.10-FF-000497', NULL, 'Uncharacterized protein', 135, NULL, NULL, 165744);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(165745, '2.70.150.10-FF-000045', NULL, 'Magnesium-translocating P-type ATPase', 104, NULL, NULL, 165745),
(165746, '2.40.30.10-FF-000370', NULL, 'NADH-cytochrome b5 reductase', 102, NULL, NULL, 165746),
(165747, '1.10.10.820-FF-000021', NULL, 'Heavy chain, Unconventional Myosin', 60, NULL, NULL, 165747),
(165748, '2.30.30.40-FF-000334', NULL, 'Uncharacterized protein', 52, NULL, NULL, 165748),
(165749, '1.25.10.10-FF-001373', NULL, 'YALI0D04444p', 1158, NULL, NULL, 165749),
(165750, '1.50.40.10-FF-000506', NULL, 'Uncharacterized mitochondrial carrier C1271.11', 245, NULL, NULL, 165750),
(165751, '3.40.50.300-FF-006603', NULL, 'Uncharacterized protein', 97, NULL, NULL, 165751),
(165752, '3.90.190.10-FF-000174', NULL, 'Protein CBG03773', 172, NULL, NULL, 165752),
(165753, '3.30.390.10-FF-000017', NULL, 'o-succinylbenzoate synthase', 111, NULL, NULL, 165753),
(165754, '2.130.10.10-FF-002707', NULL, 'AGAP009046-PA', 320, NULL, NULL, 165754),
(165755, '3.30.470.10-FF-000018', NULL, 'Branched-chain-amino-acid transaminase, putative', 175, NULL, NULL, 165755),
(165756, '1.25.40.180-FF-000291', NULL, NULL, 117, NULL, NULL, 165756),
(165757, '1.10.245.10-FF-000013', NULL, 'SWI/SNF and RSC complexes subunit ssr3', 86, NULL, NULL, 165757),
(165758, '3.40.50.300-FF-002022', NULL, 'ATP-dependent RNA helicase DBP4, putative', 259, NULL, NULL, 165758),
(165759, '1.10.510.10-FF-001097', NULL, 'Serine/threonine-protein kinase PLK', 180, NULL, NULL, 165759),
(165760, '1.20.1110.10-FF-000186', NULL, NULL, 174, NULL, NULL, 165760),
(165761, '1.10.10.60-FF-000847', NULL, NULL, 62, NULL, NULL, 165761),
(165762, '3.40.50.720-FF-000866', NULL, 'Pyrroline-5-carboxylate reductase', 175, NULL, NULL, 165762),
(165763, '1.25.10.10-FF-001934', NULL, 'Importin subunit alpha-7', 432, NULL, NULL, 165763),
(165764, '2.30.42.10-FF-000223', NULL, 'USH1 protein network component harmonin', 86, NULL, NULL, 165764),
(165765, '3.30.160.60-FF-003904', NULL, NULL, 31, NULL, NULL, 165765),
(165766, '1.20.120.530-FF-000005', NULL, 'Transcriptional regulator, GntR family', 137, NULL, NULL, 165766),
(165767, '3.40.50.720-FF-001266', NULL, '2-dehydropantoate 2-reductase', 178, NULL, NULL, 165767),
(165768, '3.40.50.1000-FF-000337', NULL, 'Phosphomannomutase', 132, NULL, NULL, 165768),
(165769, '2.60.40.150-FF-000726', NULL, 'Uncharacterized protein', 115, NULL, NULL, 165769),
(165770, '3.40.50.300-FF-006204', NULL, 'AGR113Wp', 200, NULL, NULL, 165770),
(165771, '1.10.510.10-FF-001990', NULL, 'cAMP-dependent protein kinase, putative', 211, NULL, NULL, 165771),
(165772, '3.30.70.330-FF-001722', NULL, NULL, 100, NULL, NULL, 165772),
(165773, '3.20.19.10-FF-000004', NULL, 'Aconitate hydratase B', 200, NULL, NULL, 165773),
(165774, '2.60.120.10-FF-000214', NULL, 'Pirin-like protein 2', 108, NULL, NULL, 165774),
(165775, '2.130.10.10-FF-001347', NULL, 'Cytoplasmic dynein 1 intermediate chain', 175, NULL, NULL, 165775),
(165776, '3.20.20.70-FF-000520', NULL, 'tRNA-dihydrouridine(47) synthase [NAD(P)(+)]', 272, NULL, NULL, 165776),
(165777, '3.30.70.590-FF-000024', NULL, 'Predicted protein', 61, NULL, NULL, 165777),
(165778, '3.30.420.40-FF-000119', NULL, 'tRNA threonylcarbamoyladenosine biosynthesis protein TsaB', 95, NULL, NULL, 165778),
(165779, '1.20.1720.10-FF-000092', NULL, 'Multidrug resistance transporter, Bcr family', 375, NULL, NULL, 165779),
(165780, '3.30.200.20-FF-001497', NULL, 'Uncharacterized protein', 90, NULL, NULL, 165780),
(165781, '2.130.10.10-FF-000858', NULL, 'GH16945', 339, NULL, NULL, 165781),
(165782, '3.65.10.10-FF-000012', NULL, 'Pentafunctional AROM polypeptide', 219, NULL, NULL, 165782),
(165783, '2.60.40.60-FF-000232', NULL, 'Neural-cadherin', 102, NULL, NULL, 165783),
(165784, '3.40.50.150-FF-000830', NULL, 'Ribosomal RNA small subunit methyltransferase G', 215, NULL, NULL, 165784),
(165785, '3.30.40.10-FF-002240', NULL, 'Predicted protein', 62, NULL, NULL, 165785),
(165786, '3.40.50.1820-FF-000583', NULL, 'Acylamino-acid-releasing enzyme', 265, NULL, NULL, 165786),
(165787, '3.30.160.60-FF-003000', NULL, 'Zinc finger and SCAN domain-containing 20', 31, NULL, NULL, 165787);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(165788, '1.25.70.10-FF-000073', NULL, NULL, 90, NULL, NULL, 165788),
(165789, '2.80.10.50-FF-000232', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 127, NULL, NULL, 165789),
(165790, '3.40.1110.10-FF-000365', NULL, NULL, 222, NULL, NULL, 165790),
(165791, '2.130.10.10-FF-001926', NULL, 'Autophagy-related protein 18d', 183, NULL, NULL, 165791),
(165792, '3.40.50.1400-FF-000013', NULL, 'Ferrochelatase', 146, NULL, NULL, 165792),
(165793, '3.30.1320.10-FF-000029', NULL, 'Predicted protein', 56, NULL, NULL, 165793),
(165794, '1.20.81.30-FF-000007', NULL, 'Type II secretion system inner membrane protein PulF', 115, NULL, NULL, 165794),
(165795, '3.40.50.150-FF-001342', NULL, NULL, 194, NULL, NULL, 165795),
(165796, '1.10.510.10-FF-000821', NULL, 'Serine/threonine-protein kinase gcn2', 220, NULL, NULL, 165796),
(165797, '1.20.1070.10-FF-000654', NULL, 'Adrenoceptor alpha 2A', 329, NULL, NULL, 165797),
(165798, '1.50.40.10-FF-000001', NULL, 'ADP,ATP carrier protein, mitochondrial', 296, NULL, NULL, 165798),
(165799, '3.40.1690.10-FF-000009', NULL, 'Flagellar biosynthesis protein FlhB', 85, NULL, NULL, 165799),
(165800, '2.10.90.10-FF-000054', NULL, 'Bursicon', 110, NULL, NULL, 165800),
(165801, '3.40.120.10-FF-000041', NULL, 'Phosphoglucomutase, putative', 121, NULL, NULL, 165801),
(165802, '1.25.40.10-FF-003903', NULL, 'Pentatricopeptide repeat-containing protein At3g60980, mitochondrial', 68, NULL, NULL, 165802),
(165803, '3.30.390.60-FF-000010', NULL, 'Heat-inducible transcription repressor HrcA', 89, NULL, NULL, 165803),
(165804, '3.40.50.12710-FF-000038', NULL, 'Protein arginine methyltransferase NDUFAF7', 62, NULL, NULL, 165804),
(165805, '3.30.60.20-FF-000114', NULL, 'Thymidine kinase', 49, NULL, NULL, 165805),
(165806, '2.60.40.1910-FF-000033', NULL, NULL, 85, NULL, NULL, 165806),
(165807, '2.40.30.10-FF-000307', NULL, 'GTP-binding elongation factor protein, TetM/TetO family', 109, NULL, NULL, 165807),
(165808, '1.25.40.10-FF-003847', NULL, 'Uncharacterized protein', 116, NULL, NULL, 165808),
(165809, '1.20.1070.10-FF-000598', NULL, 'Predicted protein', 334, NULL, NULL, 165809),
(165810, '1.10.390.10-FF-000029', NULL, 'Protein CBG19917', 236, NULL, NULL, 165810),
(165811, '3.30.420.10-FF-000583', NULL, NULL, 293, NULL, NULL, 165811),
(165812, '2.60.220.50-FF-000183', NULL, 'Predicted protein', 52, NULL, NULL, 165812),
(165813, '2.30.40.10-FF-000056', NULL, 'N-acyl-D-amino acid deacylase family protein', 66, NULL, NULL, 165813),
(165814, '2.70.170.10-FF-000260', NULL, 'Protein CBG24733', 156, NULL, NULL, 165814),
(165815, '1.20.1070.10-FF-000710', NULL, 'NeuroPeptide Receptor family', 291, NULL, NULL, 165815),
(165816, '1.10.8.280-FF-000001', NULL, 'UvrABC system protein A', 118, NULL, NULL, 165816),
(165817, '3.40.50.1000-FF-000505', NULL, 'Phospholipid-transporting ATPase IA, putative', 187, NULL, NULL, 165817),
(165818, '1.25.40.990-FF-000051', NULL, '26S proteasome non-ATPase regulatory subunit 8 homolog A', 218, NULL, NULL, 165818),
(165819, '3.40.50.720-FF-001827', NULL, 'Uncharacterized protein', 150, NULL, NULL, 165819),
(165820, '1.20.81.10-FF-000001', NULL, 'Alpha-2-macroglobulin receptor-associated protein', 82, NULL, NULL, 165820),
(165821, '2.30.40.10-FF-000005', NULL, 'Adenine deaminase', 97, NULL, NULL, 165821),
(165822, '1.20.58.830-FF-000006', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 129, NULL, NULL, 165822),
(165823, '3.40.720.10-FF-000238', NULL, 'Predicted protein', 350, NULL, NULL, 165823),
(165824, '1.10.510.10-FF-002951', NULL, NULL, 102, NULL, NULL, 165824),
(165825, '1.10.287.470-FF-000068', NULL, 'Discs, large homolog 4b (Drosophila)', 47, NULL, NULL, 165825),
(165826, '1.10.238.10-FF-000160', NULL, 'Lysophosphatidylcholine acyltransferase 2', 165, NULL, NULL, 165826),
(165827, '1.20.990.10-FF-000005', NULL, 'Nitric oxide synthase', 135, NULL, NULL, 165827),
(165828, '3.40.50.1700-FF-000041', NULL, 'Ngs1p', 221, NULL, NULL, 165828),
(165829, '3.30.200.20-FF-001946', NULL, 'Serine/threonine-protein kinase receptor', 108, NULL, NULL, 165829),
(165830, '1.10.287.600-FF-000028', NULL, 'Tubulin beta chain', 68, NULL, NULL, 165830);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(165831, '2.60.120.40-FF-000026', NULL, 'Tumor necrosis factor ligand superfamily member 18', 127, NULL, NULL, 165831),
(165832, '2.60.40.10-FF-005641', NULL, NULL, 94, NULL, NULL, 165832),
(165833, '1.25.40.10-FF-005360', NULL, 'Uncharacterized protein', 95, NULL, NULL, 165833),
(165834, '1.10.357.30-FF-000003', NULL, 'Exocyst complex component', 180, NULL, NULL, 165834),
(165835, '3.40.50.300-FF-003438', NULL, 'Recombinase RecB', 158, NULL, NULL, 165835),
(165836, '3.30.1330.30-FF-000013', NULL, '40S ribosomal protein S12', 134, NULL, NULL, 165836),
(165837, '1.25.40.20-FF-001815', NULL, 'Uncharacterized protein', 160, NULL, NULL, 165837),
(165838, '3.30.70.330-FF-000609', NULL, 'U2 snRNP component IST3', 112, NULL, NULL, 165838),
(165839, '1.20.1250.20-FF-000749', NULL, 'Sugar transporter family protein', 214, NULL, NULL, 165839),
(165840, '3.40.50.300-FF-008621', NULL, 'Uncharacterized protein', 387, NULL, NULL, 165840),
(165841, '3.40.1810.10-FF-000042', NULL, 'Os01g0912400 protein', 83, NULL, NULL, 165841),
(165842, '3.30.70.330-FF-001273', NULL, 'GM11803', 117, NULL, NULL, 165842),
(165843, '2.130.10.10-FF-001971', NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', 218, NULL, NULL, 165843),
(165844, '3.30.160.60-FF-003617', NULL, 'AGAP005274-PA', 29, NULL, NULL, 165844),
(165845, '3.30.420.40-FF-000743', NULL, 'actin isoform X1', 106, NULL, NULL, 165845),
(165846, '2.130.10.10-FF-005237', NULL, 'Uncharacterized protein', 319, NULL, NULL, 165846),
(165847, '3.40.30.10-FF-000199', NULL, 'Thioredoxin-like 1-2, chloroplastic', 119, NULL, NULL, 165847),
(165848, '1.25.10.10-FF-001193', NULL, 'Condensin complex subunit 1', 170, NULL, NULL, 165848),
(165849, '2.130.10.10-FF-001819', NULL, 'Probable SOF1 protein', 243, NULL, NULL, 165849),
(165850, '1.20.120.1380-FF-000008', NULL, 'Flagellar biosynthesis protein FlhF', 57, NULL, NULL, 165850),
(165851, '3.80.10.10-FF-002882', NULL, 'Predicted protein', 113, NULL, NULL, 165851),
(165852, '3.30.420.40-FF-000687', NULL, '(R)-2-hydroxyacyl-CoA dehydratase-radicalizing ATPase', 113, NULL, NULL, 165852),
(165853, '3.40.1110.10-FF-000472', NULL, NULL, 46, NULL, NULL, 165853),
(165854, '3.40.50.2300-FF-001637', NULL, NULL, 261, NULL, NULL, 165854),
(165855, '1.25.40.250-FF-000008', NULL, 'Eukaryotic translation initiation factor 3 subunit K', 119, NULL, NULL, 165855),
(165856, '1.20.5.350-FF-000008', NULL, 'Troponin I4b, tandem duplicate 2', 127, NULL, NULL, 165856),
(165857, '2.30.29.30-FF-001322', NULL, 'Uncharacterized protein', 65, NULL, NULL, 165857),
(165858, '3.30.70.330-FF-002739', NULL, NULL, 94, NULL, NULL, 165858),
(165859, '2.10.25.10-FF-001668', NULL, 'Protein eyes shut homolog', 68, NULL, NULL, 165859),
(165860, '3.90.70.10-FF-000721', NULL, 'Uncharacterized protein', 192, NULL, NULL, 165860),
(165861, '2.120.10.30-FF-000589', NULL, 'Uncharacterized protein', 117, NULL, NULL, 165861),
(165862, '1.10.357.50-FF-000009', NULL, 'Exocyst complex component 3-like 1', 182, NULL, NULL, 165862),
(165863, '3.30.60.30-FF-000156', NULL, 'Predicted protein', 57, NULL, NULL, 165863),
(165864, '1.10.3730.20-FF-000076', NULL, 'Uncharacterized protein', 110, NULL, NULL, 165864),
(165865, '2.60.40.10-FF-001370', NULL, 'Sallimus, isoform P', 96, NULL, NULL, 165865),
(165866, '1.25.10.10-FF-000529', NULL, 'RING-type E3 ubiquitin transferase', 314, NULL, NULL, 165866),
(165867, '1.10.630.10-FF-000184', NULL, 'Cytochrome P450 family protein, expressed', 459, NULL, NULL, 165867),
(165868, '3.40.50.1000-FF-000449', NULL, NULL, 80, NULL, NULL, 165868),
(165869, '1.10.10.10-FF-001462', NULL, 'ORC1-type DNA replication protein 8', 99, NULL, NULL, 165869),
(165870, '2.60.120.10-FF-000557', NULL, 'Probable mannose-6-phosphate isomerase', 232, NULL, NULL, 165870),
(165871, '1.10.510.10-FF-001366', NULL, 'Protein kinase, putative', 279, NULL, NULL, 165871),
(165872, '1.10.3730.10-FF-000016', NULL, 'Uncharacterized protein', 58, NULL, NULL, 165872),
(165873, '3.40.1710.10-FF-000001', NULL, 'Inner membrane transport permease ybhS', 155, NULL, NULL, 165873);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(165874, '2.60.300.12-FF-000011', NULL, 'Iron-sulfur assembly protein 2', 118, NULL, NULL, 165874),
(165875, '1.10.510.10-FF-000080', NULL, 'Putative activated CDC42 kinase 1', 242, NULL, NULL, 165875),
(165876, '3.40.50.300-FF-001584', NULL, 'Ras-like GTP-binding protein RYL2', 159, NULL, NULL, 165876),
(165877, '3.30.40.10-FF-000727', NULL, 'Zinc finger, C3HC4 type family protein, expressed', 84, NULL, NULL, 165877),
(165878, '3.50.50.60-FF-000596', NULL, 'Flavin-containing monooxygenase, putative', 250, NULL, NULL, 165878),
(165879, '2.60.120.920-FF-000079', NULL, 'Predicted protein', 165, NULL, NULL, 165879),
(165880, '3.30.70.2590-FF-000001', NULL, 'Cellulose synthase operon protein D', 112, NULL, NULL, 165880),
(165881, '3.60.40.10-FF-000367', NULL, 'Uncharacterized protein', 263, NULL, NULL, 165881),
(165882, '2.40.37.10-FF-000008', NULL, 'antizyme inhibitor 1', 145, NULL, NULL, 165882),
(165883, '6.10.140.2220-FF-000043', NULL, 'protein msta', 48, NULL, NULL, 165883),
(165884, '1.10.3810.10-FF-000017', NULL, 'Transglycosylase', 196, NULL, NULL, 165884),
(165885, '3.40.50.1260-FF-000044', NULL, 'Phosphoglycerate kinase', 80, NULL, NULL, 165885),
(165886, '3.40.50.150-FF-000774', NULL, 'Protein arginine N-methyltransferase 7', 134, NULL, NULL, 165886),
(165887, '3.30.160.60-FF-004416', NULL, NULL, 28, NULL, NULL, 165887),
(165888, '1.10.30.20-FF-000005', NULL, 'DNA repair helicase Rad3', 83, NULL, NULL, 165888),
(165889, '3.30.160.60-FF-002275', NULL, 'Myeloid zinc finger 1', 29, NULL, NULL, 165889),
(165890, '3.20.20.80-FF-000629', NULL, 'Uncharacterized protein', 124, NULL, NULL, 165890),
(165891, '2.30.30.140-FF-000256', NULL, 'SAGA complex associated factor 29', 41, NULL, NULL, 165891),
(165892, '3.40.50.2300-FF-000856', NULL, NULL, 66, NULL, NULL, 165892),
(165893, '1.20.1280.50-FF-000120', NULL, 'F-box/WD repeat-containing protein 1A', 105, NULL, NULL, 165893),
(165894, '4.10.640.10-FF-000010', NULL, '30S ribosomal protein S18', 56, NULL, NULL, 165894),
(165895, '3.20.20.20-FF-000022', NULL, 'Dihydropteroate synthase', 286, NULL, NULL, 165895),
(165896, '3.40.190.10-FF-000876', NULL, 'Uncharacterized protein', 129, NULL, NULL, 165896),
(165897, '2.60.220.30-FF-000025', NULL, 'Ankyrin-3', 155, NULL, NULL, 165897),
(165898, '2.60.40.10-FF-002623', NULL, 'Uncharacterized protein', 117, NULL, NULL, 165898),
(165899, '3.40.190.290-FF-000031', NULL, 'LysR family transcriptional regulator', 209, NULL, NULL, 165899),
(165900, '2.60.200.20-FF-000021', NULL, 'Kinesin family protein', 110, NULL, NULL, 165900),
(165901, '3.40.800.10-FF-000008', NULL, 'Arginase', 321, NULL, NULL, 165901),
(165902, '1.20.58.1120-FF-000030', NULL, 'Dynein heavy chain', 152, NULL, NULL, 165902),
(165903, '1.25.10.10-FF-001878', NULL, 'Slr1098 protein', 89, NULL, NULL, 165903),
(165904, '3.10.330.20-FF-000004', NULL, 'tRNA (adenine(58)-N(1))-methyltransferase', 72, NULL, NULL, 165904),
(165905, '3.40.50.720-FF-000574', NULL, 'WW domain containing oxidoreductase', 55, NULL, NULL, 165905),
(165906, '1.20.120.1080-FF-000132', NULL, 'DExH-box helicase 34', 58, NULL, NULL, 165906),
(165907, '1.20.120.1110-FF-000012', NULL, 'Uncharacterized protein', 85, NULL, NULL, 165907),
(165908, '3.30.450.20-FF-000464', NULL, 'Hypoxia-inducible factor 1 subunit alpha,-like 2', 111, NULL, NULL, 165908),
(165909, '1.10.510.10-FF-002619', NULL, NULL, 120, NULL, NULL, 165909),
(165910, '2.40.160.50-FF-000019', NULL, 'Outer membrane protein assembly factor', 310, NULL, NULL, 165910),
(165911, '3.10.400.10-FF-000007', NULL, 'Sulfate adenylyltransferase, putative', 118, NULL, NULL, 165911),
(165912, '3.40.50.1820-FF-000307', NULL, 'Probable conserved membrane protein', 274, NULL, NULL, 165912),
(165913, '3.50.50.60-FF-001321', NULL, 'Uncharacterized protein', 171, NULL, NULL, 165913),
(165914, '1.20.58.60-FF-000592', NULL, 'Putative titin isoform x14', 205, NULL, NULL, 165914),
(165915, '3.40.50.300-FF-008385', NULL, 'DNA repair helicase, putative', 201, NULL, NULL, 165915),
(165916, '1.10.20.10-FF-000119', NULL, 'Unplaced genomic scaffold supercont1.244, whole genome shotgun sequence', 70, NULL, NULL, 165916);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(165917, '2.40.20.10-FF-000032', NULL, 'Tyrosine-protein kinase receptor cam-1', 97, NULL, NULL, 165917),
(165918, '1.20.140.100-FF-000049', NULL, 'Uncharacterized protein', 138, NULL, NULL, 165918),
(165919, '2.40.160.120-FF-000037', NULL, 'Uncharacterized protein', 164, NULL, NULL, 165919),
(165920, '1.10.630.10-FF-000240', NULL, 'Cytochrome P450, putative', 176, NULL, NULL, 165920),
(165921, '1.10.10.10-FF-000681', NULL, 'MarR family transcriptional regulator', 143, NULL, NULL, 165921),
(165922, '2.60.200.40-FF-000027', NULL, 'Diacylglycerol kinase', 163, NULL, NULL, 165922),
(165923, '1.25.40.10-FF-000413', NULL, 'General transcription factor 3C polypeptide 3', 336, NULL, NULL, 165923),
(165924, '1.10.1450.10-FF-000062', NULL, 'TetraSPanin family', 87, NULL, NULL, 165924),
(165925, '3.50.50.60-FF-000883', NULL, 'Uncharacterized protein', 355, NULL, NULL, 165925),
(165926, '1.10.472.10-FF-000035', NULL, 'RB transcriptional corepressor-like 1', 181, NULL, NULL, 165926),
(165927, '1.20.1250.20-FF-002262', NULL, 'Uncharacterized protein', 103, NULL, NULL, 165927),
(165928, '1.20.1730.10-FF-000098', NULL, 'Uncharacterized protein', 289, NULL, NULL, 165928),
(165929, '3.20.20.140-FF-000270', NULL, 'Ribonuclease P protein component 3', 220, NULL, NULL, 165929),
(165930, '1.20.920.10-FF-000018', NULL, 'nucleosome-remodeling factor subunit BPTF isoform X1', 109, NULL, NULL, 165930),
(165931, '3.20.20.140-FF-000382', NULL, 'Uncharacterized protein', 182, NULL, NULL, 165931),
(165932, '3.30.420.10-FF-000307', NULL, 'DNA polymerase Pol2', 221, NULL, NULL, 165932),
(165933, '1.10.510.10-FF-003732', NULL, NULL, 151, NULL, NULL, 165933),
(165934, '2.10.25.10-FF-000364', NULL, 'Latent transforming growth factor beta binding protein 2', 41, NULL, NULL, 165934),
(165935, '3.40.50.11060-FF-000004', NULL, 'AGAP003969-PA', 126, NULL, NULL, 165935),
(165936, '1.10.220.10-FF-000046', NULL, 'Annexin', 80, NULL, NULL, 165936),
(165937, '3.80.10.10-FF-000701', NULL, 'Disease resistance protein (TIR-NBS-LRR class)', 156, NULL, NULL, 165937),
(165938, '1.25.40.10-FF-003050', NULL, 'Pre-mRNA splicing factor putative', 80, NULL, NULL, 165938),
(165939, '3.40.50.300-FF-005748', NULL, 'DNA polymerase III, gamma subunit-related protein', 139, NULL, NULL, 165939),
(165940, '1.25.10.10-FF-002042', NULL, 'Microtubule associated protein', 245, NULL, NULL, 165940),
(165941, '3.40.50.1000-FF-000781', NULL, NULL, 66, NULL, NULL, 165941),
(165942, '2.60.40.1760-FF-000004', NULL, 'Alpha-xylosidase', 245, NULL, NULL, 165942),
(165943, '3.40.50.300-FF-001297', NULL, 'Cysteine/glutathione ABC transporter ATP-binding protein/permease CydC', 243, NULL, NULL, 165943),
(165944, '1.20.5.4770-FF-000023', NULL, 'Uncharacterized protein', 35, NULL, NULL, 165944),
(165945, '3.30.160.60-FF-001763', NULL, 'Zinc finger protein 574', 27, NULL, NULL, 165945),
(165946, '3.30.60.30-FF-000212', NULL, 'Uncharacterized protein', 70, NULL, NULL, 165946),
(165947, '2.130.10.10-FF-005349', NULL, 'Uncharacterized protein', 178, NULL, NULL, 165947),
(165948, '3.90.1180.10-FF-000010', NULL, '50S ribosomal protein L13-like protein', 142, NULL, NULL, 165948),
(165949, '1.10.510.10-FF-001546', NULL, 'Uncharacterized protein', 200, NULL, NULL, 165949),
(165950, '2.60.120.920-FF-000135', NULL, 'TRIM65 isoform 4', 113, NULL, NULL, 165950),
(165951, '3.30.40.10-FF-000907', NULL, 'E3 ubiquitin-protein ligase', 68, NULL, NULL, 165951),
(165952, '3.80.10.10-FF-003394', NULL, 'Leucine Rich Repeat family protein', 99, NULL, NULL, 165952),
(165953, '3.10.120.10-FF-000025', NULL, 'Cytochrome b5-like Heme/Steroid binding domain containing protein, putative', 83, NULL, NULL, 165953),
(165954, '3.80.10.10-FF-004012', NULL, 'Uncharacterized protein', 149, NULL, NULL, 165954),
(165955, '3.40.50.300-FF-001640', NULL, 'DNA helicase', 201, NULL, NULL, 165955),
(165956, '3.10.290.10-FF-000008', NULL, 'Heat shock protein 15', 108, NULL, NULL, 165956),
(165957, '3.40.50.2000-FF-000980', NULL, 'Uncharacterized protein', 72, NULL, NULL, 165957),
(165958, '2.60.40.10-FF-004860', NULL, NULL, 96, NULL, NULL, 165958);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(165959, '1.10.238.10-FF-000901', NULL, 'Respiratory burst oxidase homolog protein C', 115, NULL, NULL, 165959),
(165960, '3.30.200.20-FF-002278', NULL, 'Tyrosine-protein kinase', 34, NULL, NULL, 165960),
(165961, '3.40.50.12390-FF-000010', NULL, 'Putative 5''-3'' exonuclease', 163, NULL, NULL, 165961),
(165962, '3.20.20.360-FF-000004', NULL, 'Malate synthase G', 178, NULL, NULL, 165962),
(165963, '1.25.40.20-FF-000473', NULL, 'Ankyrin repeat family protein', 100, NULL, NULL, 165963),
(165964, '3.30.70.330-FF-000941', NULL, 'ATP-independent RNA helicase', 74, NULL, NULL, 165964),
(165965, '3.30.160.60-FF-002095', NULL, 'ras-responsive element-binding protein 1', 30, NULL, NULL, 165965),
(165966, '3.50.50.100-FF-000010', NULL, 'Alternative NAD(P)H-ubiquinone oxidoreductase C1, chloroplastic/mitochondrial', 418, NULL, NULL, 165966),
(165967, '2.130.10.10-FF-000566', NULL, 'Dynein cytoplasmic 1 intermediate chain 1', 198, NULL, NULL, 165967),
(165968, '3.30.160.60-FF-006434', NULL, NULL, 40, NULL, NULL, 165968),
(165969, '3.30.530.20-FF-000178', NULL, 'Uncharacterized protein', 108, NULL, NULL, 165969),
(165970, '3.40.50.300-FF-006311', NULL, 'Uncharacterized protein', 167, NULL, NULL, 165970),
(165971, '1.10.8.10-FF-000258', NULL, 'Uncharacterized protein', 60, NULL, NULL, 165971),
(165972, '2.130.10.10-FF-001639', NULL, 'WD domain, G-beta repeat-containing protein', 139, NULL, NULL, 165972),
(165973, '3.40.50.300-FF-002096', NULL, 'nuclear GTPase SLIP-GC isoform X2', 199, NULL, NULL, 165973),
(165974, '2.40.50.140-FF-000207', NULL, 'Sugar ABC transporter ATP-binding protein', 43, NULL, NULL, 165974),
(165975, '3.40.50.150-FF-001286', NULL, NULL, 220, NULL, NULL, 165975),
(165976, '1.20.1740.10-FF-000216', NULL, 'Predicted protein', 96, NULL, NULL, 165976),
(165977, '3.90.76.10-FF-000055', NULL, 'Probable ABC transporter-binding protein DR_1571', 131, NULL, NULL, 165977),
(165978, '1.20.1000.10-FF-000032', NULL, NULL, 312, NULL, NULL, 165978),
(165979, '3.20.70.20-FF-000025', NULL, 'Ribonucleoside-diphosphate reductase', 563, NULL, NULL, 165979),
(165980, '1.25.40.70-FF-000004', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit beta', 204, NULL, NULL, 165980),
(165981, '3.30.450.20-FF-000177', NULL, 'Methyl-accepting chemotaxis protein', 112, NULL, NULL, 165981),
(165982, '2.60.40.10-FF-003168', NULL, 'AGAP011650-PA', 93, NULL, NULL, 165982),
(165983, '3.40.720.10-FF-000283', NULL, 'Uncharacterized protein', 299, NULL, NULL, 165983),
(165984, '2.60.60.20-FF-000025', NULL, 'Predicted protein', 126, NULL, NULL, 165984),
(165985, '1.25.10.10-FF-003115', NULL, 'Predicted protein', 213, NULL, NULL, 165985),
(165986, '3.80.10.10-FF-001769', NULL, 'NACHT, LRR and PYD domains-containing protein 16', 97, NULL, NULL, 165986),
(165987, '3.30.40.10-FF-000110', NULL, 'E3 ubiquitin-protein ligase RNF34 isoform X1', 57, NULL, NULL, 165987),
(165988, '2.60.40.1180-FF-000038', NULL, 'Lysosomal glucosyl ceramidase-like protein', 83, NULL, NULL, 165988),
(165989, '1.25.40.20-FF-001759', NULL, 'CASK-interacting protein 1', 194, NULL, NULL, 165989),
(165990, '1.20.920.10-FF-000170', NULL, 'Protein polybromo-1', 148, NULL, NULL, 165990),
(165991, '3.40.390.10-FF-000083', NULL, 'Zinc metalloproteinase', 250, NULL, NULL, 165991),
(165992, '3.90.550.10-FF-000106', NULL, 'Translation initiation factor eIF-2B subunit epsilon', 294, NULL, NULL, 165992),
(165993, '3.80.10.10-FF-003899', NULL, 'Uncharacterized protein', 281, NULL, NULL, 165993),
(165994, '3.60.40.10-FF-000187', NULL, 'Protein phosphatase 2C', 252, NULL, NULL, 165994),
(165995, '3.40.50.1760-FF-000031', NULL, NULL, 22, NULL, NULL, 165995),
(165996, '3.40.1380.10-FF-000019', NULL, 'ATP synthase subunit gamma', 139, NULL, NULL, 165996),
(165997, '1.25.40.20-FF-000978', NULL, 'Uncharacterized protein', 116, NULL, NULL, 165997),
(165998, '1.20.1070.10-FF-000474', NULL, 'Nematocin receptor 2', 317, NULL, NULL, 165998),
(165999, '1.50.40.10-FF-000057', NULL, 'Solute carrier family 25 member 46', 161, NULL, NULL, 165999),
(166000, '1.10.238.150-FF-000002', NULL, 'protein diaphanous homolog 2 isoform X2', 89, NULL, NULL, 166000); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(166001, '1.10.1410.10-FF-000065', NULL, 'Non-canonical poly(A) RNA polymerase PAPD7', 15, NULL, NULL, 166001),
(166002, '3.20.110.10-FF-000022', NULL, 'Chromosome 12, whole genome shotgun sequence', 211, NULL, NULL, 166002),
(166003, '1.10.510.10-FF-000641', NULL, 'Serine/threonine-protein kinase PEPKR2', 314, NULL, NULL, 166003),
(166004, '3.30.70.1520-FF-000001', NULL, 'Sarcosine oxidase, gamma subunit family', 82, NULL, NULL, 166004),
(166005, '3.40.50.300-FF-008109', NULL, 'Dicer-1, putative', 108, NULL, NULL, 166005),
(166006, '2.10.50.10-FF-000164', NULL, 'IGF-like family receptor 1', 85, NULL, NULL, 166006),
(166007, '3.40.50.300-FF-002657', NULL, 'WD_domain', 121, NULL, NULL, 166007),
(166008, '2.60.120.1680-FF-000003', NULL, 'Replicase polyprotein 1a', 138, NULL, NULL, 166008),
(166009, '3.40.50.620-FF-000218', NULL, 'Cysteine-tRNA ligase', 331, NULL, NULL, 166009),
(166010, '3.40.50.1100-FF-000148', NULL, 'Cysteine synthase B', 185, NULL, NULL, 166010),
(166011, '3.30.160.60-FF-003056', NULL, NULL, 28, NULL, NULL, 166011),
(166012, '1.10.287.3510-FF-000003', NULL, 'NADH-ubiquinone oxidoreductase chain 4L', 95, NULL, NULL, 166012),
(166013, '3.40.30.10-FF-000816', NULL, 'Maleylacetoacetate isomerase', 85, NULL, NULL, 166013),
(166014, '2.10.110.20-FF-000003', NULL, 'Lysine (K)-specific demethylase 6B, a', 25, NULL, NULL, 166014),
(166015, '2.130.10.10-FF-004512', NULL, 'Uncharacterized protein', 234, NULL, NULL, 166015),
(166016, '3.40.140.10-FF-000216', NULL, 'Chromosome 1, whole genome shotgun sequence', 192, NULL, NULL, 166016),
(166017, '3.30.160.60-FF-000706', NULL, 'Zinc finger protein', 28, NULL, NULL, 166017),
(166018, '3.30.530.20-FF-000122', NULL, 'Oligoketide cyclase/lipid transport protein', 142, NULL, NULL, 166018),
(166019, '2.60.120.330-FF-000093', NULL, 'Oxidoreductase, 2OG-Fe(II) oxygenase family, putative', 287, NULL, NULL, 166019),
(166020, '2.60.40.10-FF-001482', NULL, 'Protein-glutamine gamma-glutamyltransferase 4', 95, NULL, NULL, 166020),
(166021, '1.10.533.10-FF-000278', NULL, 'Uncharacterized protein', 96, NULL, NULL, 166021),
(166022, '1.10.287.500-FF-000004', NULL, 'Chemotaxis response-phosphatase CheZ', 51, NULL, NULL, 166022),
(166023, '3.90.70.10-FF-000160', NULL, 'Trophozoite cysteine proteinase', 362, NULL, NULL, 166023),
(166024, '3.10.320.10-FF-000006', NULL, 'cDNA FLJ57033, highly similar to Antigen peptide transporter 2', 59, NULL, NULL, 166024),
(166025, '1.10.10.60-FF-000611', NULL, 'MmsAB operon regulatory protein', 44, NULL, NULL, 166025),
(166026, '3.40.50.300-FF-000280', NULL, 'Putative ras-related protein Rab-4B', 187, NULL, NULL, 166026),
(166027, '3.30.40.10-FF-000166', NULL, 'E3 ubiquitin-protein ligase RNF139', 78, NULL, NULL, 166027),
(166028, '1.10.287.70-FF-000116', NULL, 'Sodium channel protein', 147, NULL, NULL, 166028),
(166029, '1.10.287.130-FF-000191', NULL, 'Histidine kinase', 87, NULL, NULL, 166029),
(166030, '2.10.25.10-FF-000887', NULL, 'Os02g0807800 protein', 43, NULL, NULL, 166030),
(166031, '3.40.50.300-FF-003950', NULL, 'IPP transferase/Zinc-finger of C2H2 type, putative', 162, NULL, NULL, 166031),
(166032, '3.40.50.620-FF-000893', NULL, 'Tryptophanyl-trna synthetase', 89, NULL, NULL, 166032),
(166033, '3.40.50.720-FF-001715', NULL, 'Glyoxylate reductase', 133, NULL, NULL, 166033),
(166034, '1.20.140.150-FF-000042', NULL, 'Clc-like protein 2', 196, NULL, NULL, 166034),
(166035, '1.10.238.10-FF-000665', NULL, 'troponin C', 85, NULL, NULL, 166035),
(166036, '2.30.30.40-FF-000047', NULL, 'Disks large homolog 2 isoform 3', 85, NULL, NULL, 166036),
(166037, '2.120.10.80-FF-000290', NULL, 'Predicted protein', 225, NULL, NULL, 166037),
(166038, '1.25.40.20-FF-001198', NULL, 'Si:ch211-209a2.2', 104, NULL, NULL, 166038),
(166039, '1.10.730.10-FF-000129', NULL, 'Methionine--tRNA ligase', 177, NULL, NULL, 166039),
(166040, '1.20.210.10-FF-000043', NULL, 'Uncharacterized protein', 94, NULL, NULL, 166040),
(166041, '1.20.140.10-FF-000104', NULL, 'Acyl-CoA dehydrogenase domain protein', 150, NULL, NULL, 166041),
(166042, '3.90.1720.10-FF-000035', NULL, 'Lysin', 132, NULL, NULL, 166042);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(166043, '1.20.58.80-FF-000075', NULL, 'Predicted protein', 71, NULL, NULL, 166043),
(166044, '2.20.25.240-FF-000008', NULL, 'AGAP003439-PA', 91, NULL, NULL, 166044),
(166045, '3.90.1110.10-FF-000005', NULL, 'DNA-directed RNA polymerase subunit beta', 181, NULL, NULL, 166045),
(166046, '3.30.559.30-FF-000090', NULL, 'HC-toxin synthetase', 261, NULL, NULL, 166046),
(166047, '3.40.50.1820-FF-001420', NULL, 'Uncharacterized protein', 200, NULL, NULL, 166047),
(166048, '3.40.50.300-FF-003618', NULL, 'Uncharacterized protein', 236, NULL, NULL, 166048),
(166049, '1.10.10.10-FF-001985', NULL, 'Protein CBR-HSF-1', 51, NULL, NULL, 166049),
(166050, '1.20.1070.10-FF-001379', NULL, 'GoNadotropin-Releasing hormone Receptor (GnRHR) related', 251, NULL, NULL, 166050),
(166051, '3.30.200.20-FF-001822', NULL, 'CHEK2 isoform 21', 54, NULL, NULL, 166051),
(166052, '3.90.1640.10-FF-000034', NULL, 'Uncharacterized protein', 147, NULL, NULL, 166052),
(166053, '3.30.70.260-FF-000004', NULL, 'Ribose-5-phosphate isomerase A', 72, NULL, NULL, 166053),
(166054, '3.40.30.10-FF-000417', NULL, 'Glutathione S-transferase Gst', 82, NULL, NULL, 166054),
(166055, '3.30.450.40-FF-000127', NULL, 'Sigma factor sigB regulation protein rsbU', 160, NULL, NULL, 166055),
(166056, '3.40.50.150-FF-001847', NULL, NULL, 41, NULL, NULL, 166056),
(166057, '3.40.50.1820-FF-001364', NULL, 'Predicted protein', 228, NULL, NULL, 166057),
(166058, '3.30.70.330-FF-001397', NULL, 'Uncharacterized protein', 75, NULL, NULL, 166058),
(166059, '3.30.830.10-FF-000102', NULL, 'Probable zinc protease PqqL', 168, NULL, NULL, 166059),
(166060, '3.40.630.10-FF-000124', NULL, 'Cytosolic leucyl aminopeptidase, putative', 339, NULL, NULL, 166060),
(166061, '3.30.160.60-FF-004017', NULL, NULL, 28, NULL, NULL, 166061),
(166062, '3.40.50.10490-FF-000092', NULL, 'RpiR family transcriptional regulator', 187, NULL, NULL, 166062),
(166063, '2.40.30.170-FF-000038', NULL, 'RND multidrug efflux membrane permease', 82, NULL, NULL, 166063),
(166064, '2.40.170.20-FF-000028', NULL, 'Outer membrane protein', 619, NULL, NULL, 166064),
(166065, '3.30.1520.10-FF-000180', NULL, 'Phospholipase', 98, NULL, NULL, 166065),
(166066, '2.102.10.10-FF-000045', NULL, 'Rieske (2Fe-2S) iron-sulphur domain protein', 108, NULL, NULL, 166066),
(166067, '1.25.40.10-FF-002830', NULL, 'Clustered mitochondria protein homolog', 140, NULL, NULL, 166067),
(166068, '3.40.50.10260-FF-000040', NULL, 'Enhancer of mRNA decapping 3 family protein', 108, NULL, NULL, 166068),
(166069, '3.30.70.1730-FF-000058', NULL, 'Uncharacterized protein', 60, NULL, NULL, 166069),
(166070, '2.130.10.10-FF-003551', NULL, 'Uncharacterized protein', 261, NULL, NULL, 166070),
(166071, '2.60.40.3500-FF-000015', NULL, NULL, 65, NULL, NULL, 166071),
(166072, '3.30.2410.10-FF-000025', NULL, 'Ubiquitin ligase (E3)', 116, NULL, NULL, 166072),
(166073, '3.10.20.90-FF-000251', NULL, 'DNA-binding protein Ets97D', 85, NULL, NULL, 166073),
(166074, '1.10.287.40-FF-000012', NULL, 'Seryl-tRNA synthetase, putative', 111, NULL, NULL, 166074),
(166075, '3.40.50.2000-FF-000704', NULL, 'UDP-glycosyltransferase 83A1', 177, NULL, NULL, 166075),
(166076, '3.30.70.330-FF-003139', NULL, NULL, 159, NULL, NULL, 166076),
(166077, '3.10.20.90-FF-000195', NULL, 'small ubiquitin-related modifier 2 isoform X2', 50, NULL, NULL, 166077),
(166078, '1.20.1250.20-FF-001149', NULL, 'Solute carrier organic anion transporter family member', 211, NULL, NULL, 166078),
(166079, '1.10.1300.10-FF-000074', NULL, 'Amino acid transporter', 56, NULL, NULL, 166079),
(166080, '2.10.25.10-FF-000600', NULL, 'cartilage matrix protein-like', 38, NULL, NULL, 166080),
(166081, '1.10.287.110-FF-000213', NULL, 'Uncharacterized protein', 81, NULL, NULL, 166081),
(166082, '1.25.40.10-FF-005180', NULL, 'Prolyl 4-hydroxylase subunit alpha-2', 42, NULL, NULL, 166082),
(166083, '3.40.50.720-FF-000754', NULL, 'Short chain dehydrogenase/reductase, putative', 312, NULL, NULL, 166083),
(166084, '2.40.100.10-FF-000133', NULL, 'Peptidyl-prolyl cis-trans isomerase', 100, NULL, NULL, 166084);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(166085, '2.60.120.740-FF-000002', NULL, 'Beta-galactosidase', 90, NULL, NULL, 166085),
(166086, '1.10.238.10-FF-000721', NULL, 'calmodulin-related protein-like isoform X1', 99, NULL, NULL, 166086),
(166087, '4.10.240.10-FF-000081', NULL, 'Zcf17p', 44, NULL, NULL, 166087),
(166088, '2.60.40.10-FF-002443', NULL, 'Ig-like and fibronectin type-III domain-containing protein 1', 107, NULL, NULL, 166088),
(166089, '3.80.10.10-FF-001426', NULL, 'Dynein regulatory complex subunit 3', 174, NULL, NULL, 166089),
(166090, '1.25.10.10-FF-003458', NULL, 'Translational activator, putative (AFU_orthologue AFUA_2G07960)', 238, NULL, NULL, 166090),
(166091, '1.20.1270.10-FF-000074', NULL, 'Heat shock 70 kDa protein 4', 71, NULL, NULL, 166091),
(166092, '3.30.70.100-FF-000041', NULL, 'Mechanosensitive ion channel protein', 99, NULL, NULL, 166092),
(166093, '2.30.42.10-FF-000459', NULL, NULL, 46, NULL, NULL, 166093),
(166094, '3.40.50.720-FF-001030', NULL, 'Alcohol dehydrogenase', 151, NULL, NULL, 166094),
(166095, '3.30.40.10-FF-001127', NULL, 'General transcription factor IIH subunit', 57, NULL, NULL, 166095),
(166096, '1.10.510.10-FF-000585', NULL, 'Probable inactive receptor kinase At1g48480', 204, NULL, NULL, 166096),
(166097, '1.25.40.20-FF-000635', NULL, 'Transient receptor potential cation channel subfamily C member 1', 303, NULL, NULL, 166097),
(166098, '3.30.565.10-FF-000261', NULL, 'Histidine kinase, putative', 145, NULL, NULL, 166098),
(166099, '2.30.30.490-FF-000069', NULL, 'Cytosine-C5 specific DNA methyltransferase', 97, NULL, NULL, 166099),
(166100, '3.30.360.20-FF-000018', NULL, NULL, 98, NULL, NULL, 166100),
(166101, '2.40.50.140-FF-000483', NULL, '30S ribosomal protein S1', 88, NULL, NULL, 166101),
(166102, '3.80.10.10-FF-000645', NULL, 'Leucine-rich repeat-containing protein 59', 127, NULL, NULL, 166102),
(166103, '1.10.132.30-FF-000032', NULL, 'DNA-directed RNA polymerase subunit', 26, NULL, NULL, 166103),
(166104, '3.30.70.330-FF-002178', NULL, NULL, 79, NULL, NULL, 166104),
(166105, '1.20.90.10-FF-000039', NULL, NULL, 81, NULL, NULL, 166105),
(166106, '2.130.10.10-FF-000802', NULL, 'Sortilin', 338, NULL, NULL, 166106),
(166107, '3.30.40.100-FF-000001', NULL, 'MORC family CW-type zinc finger protein 2', 64, NULL, NULL, 166107),
(166108, '1.10.510.10-FF-004295', NULL, NULL, 163, NULL, NULL, 166108),
(166109, '1.20.120.1080-FF-000076', NULL, 'Protein CBG04082', 131, NULL, NULL, 166109),
(166110, '3.40.50.2300-FF-000912', NULL, NULL, 122, NULL, NULL, 166110),
(166111, '3.30.70.330-FF-002234', NULL, NULL, 100, NULL, NULL, 166111),
(166112, '3.40.50.300-FF-000004', NULL, 'ATP synthase subunit beta', 272, NULL, NULL, 166112),
(166113, '1.25.40.10-FF-001993', NULL, 'Os03g0241800 protein', 93, NULL, NULL, 166113),
(166114, '3.30.160.60-FF-000127', NULL, 'Zinc finger protein 354C', 28, NULL, NULL, 166114),
(166115, '3.30.230.10-FF-000192', NULL, 'DNA mismatch repair protein MutL', 112, NULL, NULL, 166115),
(166116, '3.30.200.20-FF-000985', NULL, 'Putative serine/threonine protein kinase', 91, NULL, NULL, 166116),
(166117, '1.10.287.70-FF-000459', NULL, 'Predicted protein', 35, NULL, NULL, 166117),
(166118, '3.40.50.300-FF-000128', NULL, 'Putative DNA repair helicase RAD3', 34, NULL, NULL, 166118),
(166119, '1.20.1250.20-FF-000188', NULL, 'MFS general substrate transporter', 205, NULL, NULL, 166119),
(166120, '2.60.40.790-FF-000126', NULL, NULL, 120, NULL, NULL, 166120),
(166121, '1.10.2000.10-FF-000040', NULL, NULL, 124, NULL, NULL, 166121),
(166122, '2.30.30.140-FF-000312', NULL, 'Uncharacterized protein', 62, NULL, NULL, 166122),
(166123, '1.20.1070.10-FF-001778', NULL, 'Predicted protein', 329, NULL, NULL, 166123),
(166124, '3.30.200.20-FF-001261', NULL, 'Serine/threonine-protein kinase', 105, NULL, NULL, 166124),
(166125, '2.130.10.10-FF-000622', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 3', 307, NULL, NULL, 166125),
(166126, '1.25.10.10-FF-000024', NULL, 'Formin-like 1, isoform CRA_c', 244, NULL, NULL, 166126),
(166127, '3.60.21.10-FF-000059', NULL, 'Metallophosphoesterase, isoform B', 224, NULL, NULL, 166127);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(166128, '3.40.630.30-FF-000282', NULL, 'GCN5-related N-acetyltransferase', 152, NULL, NULL, 166128),
(166129, '1.10.287.1490-FF-000122', NULL, 'Uncharacterized protein', 154, NULL, NULL, 166129),
(166130, '2.60.40.10-FF-002387', NULL, 'Muscle M-line assembly protein unc-89', 95, NULL, NULL, 166130),
(166131, '3.60.10.10-FF-000359', NULL, 'Predicted protein', 139, NULL, NULL, 166131),
(166132, '3.10.20.90-FF-000375', NULL, 'Myosin 28B1, isoform B', 98, NULL, NULL, 166132),
(166133, '1.25.40.10-FF-001318', NULL, 'Os03g0314400 protein', 107, NULL, NULL, 166133),
(166134, '1.10.555.10-FF-000115', NULL, 'CHImaeriN (Rac-GTPase-activating protein) homolog', 187, NULL, NULL, 166134),
(166135, '1.20.1250.20-FF-001481', NULL, 'Uncharacterized protein', 341, NULL, NULL, 166135),
(166136, '3.30.70.330-FF-001958', NULL, NULL, 134, NULL, NULL, 166136),
(166137, '1.25.10.10-FF-000861', NULL, 'Protein HASTY 1', 323, NULL, NULL, 166137),
(166138, '2.60.40.10-FF-000313', NULL, 'Receptor-type tyrosine-protein phosphatase zeta', 111, NULL, NULL, 166138),
(166139, '3.40.50.300-FF-007480', NULL, 'Pre-mRNA-splicing factor cwf11', 236, NULL, NULL, 166139),
(166140, '2.170.150.10-FF-000004', NULL, 'Guanine nucleotide exchange factor MSS4', 116, NULL, NULL, 166140),
(166141, '3.40.50.1820-FF-001763', NULL, 'Uncharacterized protein', 226, NULL, NULL, 166141),
(166142, '3.30.710.10-FF-000447', NULL, 'SKP1-like protein 17', 150, NULL, NULL, 166142),
(166143, '2.60.40.10-FF-003404', NULL, NULL, 87, NULL, NULL, 166143),
(166144, '3.90.228.10-FF-000021', NULL, 'Ubiquitin conjugating enzyme, putative', 150, NULL, NULL, 166144),
(166145, '3.40.50.720-FF-000810', NULL, 'SDR family oxidoreductase', 283, NULL, NULL, 166145),
(166146, '3.10.20.70-FF-000037', NULL, 'Glutamine synthetase', 32, NULL, NULL, 166146),
(166147, '1.10.357.10-FF-000065', NULL, 'TetR/AcrR family transcriptional regulator', 133, NULL, NULL, 166147),
(166148, '3.40.710.10-FF-000069', NULL, 'D-alanyl-D-alanine carboxypeptidase DacB', 236, NULL, NULL, 166148),
(166149, '3.90.550.10-FF-000505', NULL, 'Probable dolichol-phosphate mannosyltransferase-putative membrane bound sugar transferase involved in LPS biosynthesis', 266, NULL, NULL, 166149),
(166150, '1.20.58.390-FF-000273', NULL, 'Uncharacterized protein', 70, NULL, NULL, 166150),
(166151, '1.10.437.10-FF-000066', NULL, 'Uncharacterized protein', 124, NULL, NULL, 166151),
(166152, '3.80.10.10-FF-000589', NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g06840', 107, NULL, NULL, 166152),
(166153, '2.60.120.200-FF-000537', NULL, 'Galectin', 138, NULL, NULL, 166153),
(166154, '2.130.10.10-FF-003495', NULL, 'Intraflagellar transport protein 140-like protein', 262, NULL, NULL, 166154),
(166155, '1.20.140.10-FF-000048', NULL, 'Putative acyl-CoA dehydrogenase', 145, NULL, NULL, 166155),
(166156, '3.90.260.10-FF-000062', NULL, 'Predicted protein', 246, NULL, NULL, 166156),
(166157, '3.30.1370.30-FF-000010', NULL, '30S ribosomal protein S8', 69, NULL, NULL, 166157),
(166158, '3.40.50.300-FF-004170', NULL, 'Predicted protein', 214, NULL, NULL, 166158),
(166159, '1.10.510.10-FF-001602', NULL, 'Kinase/ Serine/Threonine Kinase', 199, NULL, NULL, 166159),
(166160, '3.30.565.10-FF-000109', NULL, 'Related to MLH1-DNA mismatch repair protein', 223, NULL, NULL, 166160),
(166161, '1.25.40.10-FF-005028', NULL, 'Uncharacterized protein', 160, NULL, NULL, 166161),
(166162, '3.50.50.60-FF-000540', NULL, 'Protoporphyrinogen oxidase', 138, NULL, NULL, 166162),
(166163, '1.20.1070.10-FF-001435', NULL, 'Vasotocin receptor 3', 224, NULL, NULL, 166163),
(166164, '1.20.1250.20-FF-000805', NULL, 'Unplaced genomic scaffold supercont1.223, whole genome shotgun sequence', 249, NULL, NULL, 166164),
(166165, '3.30.160.60-FF-003399', NULL, 'zinc finger protein 184', 30, NULL, NULL, 166165),
(166166, '1.20.58.340-FF-000011', NULL, 'Magnesium transporter MRS2-1', 191, NULL, NULL, 166166),
(166167, '2.60.40.640-FF-000109', NULL, 'Uncharacterized protein', 110, NULL, NULL, 166167),
(166168, '2.160.10.10-FF-000082', NULL, 'Translation initiation factor eIF-2B subunit epsilon', 124, NULL, NULL, 166168);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(166169, '3.80.10.10-FF-000988', NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', 103, NULL, NULL, 166169),
(166170, '3.40.50.300-FF-003770', NULL, 'ATP-dependent RNA helicase DHR1, putative', 149, NULL, NULL, 166170),
(166171, '3.40.630.10-FF-000068', NULL, 'Peptidase M20 domain-containing protein 2', 234, NULL, NULL, 166171),
(166172, '3.30.1370.50-FF-000016', NULL, 'R3H domain containing protein, putative', 79, NULL, NULL, 166172),
(166173, '2.60.34.10-FF-000080', NULL, 'Molecular chaperone DnaK', 147, NULL, NULL, 166173),
(166174, '3.40.50.2060-FF-000008', NULL, 'Sec1 family superfamily', 127, NULL, NULL, 166174),
(166175, '3.40.50.300-FF-008441', NULL, 'Uncharacterized protein', 74, NULL, NULL, 166175),
(166176, '1.10.10.60-FF-000050', NULL, 'LIM homeobox 6', 65, NULL, NULL, 166176),
(166177, '1.10.150.50-FF-000035', NULL, 'lethal(3)malignant brain tumor-like protein 3 isoform X2', 82, NULL, NULL, 166177),
(166178, '1.10.167.10-FF-000073', NULL, 'Predicted protein', 152, NULL, NULL, 166178),
(166179, '3.10.20.310-FF-000008', NULL, 'Outer membrane protein, OMP85 family', 87, NULL, NULL, 166179),
(166180, '1.10.287.130-FF-000039', NULL, 'Sensor-like histidine kinase YfhK', 95, NULL, NULL, 166180),
(166181, '2.10.25.10-FF-000544', NULL, 'Merozoite surface antigen 1', 44, NULL, NULL, 166181),
(166182, '1.10.287.110-FF-000157', NULL, 'JJJ3p protein', 87, NULL, NULL, 166182),
(166183, '1.20.1250.20-FF-001205', NULL, 'Proline/betaine transporter (ProP)', 182, NULL, NULL, 166183),
(166184, '3.80.10.10-FF-000465', NULL, 'NACHT, LRR and PYD domains-containing protein 11', 149, NULL, NULL, 166184),
(166185, '4.10.400.10-FF-000121', NULL, 'low-density lipoprotein receptor-related protein 2', 42, NULL, NULL, 166185),
(166186, '3.30.590.20-FF-000007', NULL, 'Glutamate--cysteine ligase', 503, NULL, NULL, 166186),
(166187, '2.10.25.10-FF-000943', NULL, 'WNT inhibitory factor 1', 27, NULL, NULL, 166187),
(166188, '1.50.10.10-FF-000229', NULL, 'alpha-1,2-Mannosidase', 159, NULL, NULL, 166188),
(166189, '1.25.40.1040-FF-000063', NULL, 'Uncharacterized protein', 82, NULL, NULL, 166189),
(166190, '1.25.40.10-FF-000357', NULL, 'Mitochondrial proteins import receptor', 113, NULL, NULL, 166190),
(166191, '3.90.45.10-FF-000028', NULL, 'Peptide deformylase', 115, NULL, NULL, 166191),
(166192, '1.20.1250.20-FF-000929', NULL, 'Solute carrier family 18 member 2', 252, NULL, NULL, 166192),
(166193, '3.30.200.20-FF-000709', NULL, 'Unc-51 like kinase 3', 66, NULL, NULL, 166193),
(166194, '2.60.470.10-FF-000021', NULL, 'Sodium channel protein Nach', 240, NULL, NULL, 166194),
(166195, '2.60.40.10-FF-006097', NULL, NULL, 91, NULL, NULL, 166195),
(166196, '2.180.10.10-FF-000036', NULL, 'Uncharacterized protein', 128, NULL, NULL, 166196),
(166197, '1.25.40.1030-FF-000003', NULL, 'Protein transport protein sec16', 395, NULL, NULL, 166197),
(166198, '3.40.50.620-FF-000494', NULL, 'GD16539', 217, NULL, NULL, 166198),
(166199, '1.10.287.70-FF-000791', NULL, 'Uncharacterized protein', 162, NULL, NULL, 166199),
(166200, '1.10.287.110-FF-000033', NULL, 'dnaJ homolog subfamily B member 13', 112, NULL, NULL, 166200),
(166201, '3.40.350.10-FF-000030', NULL, 'Xaa-Pro aminopeptidase app-1', 158, NULL, NULL, 166201),
(166202, '1.10.510.10-FF-000242', NULL, 'Tyrosine-protein phosphatase non-receptor type 13', 187, NULL, NULL, 166202),
(166203, '3.80.10.10-FF-002697', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 70, NULL, NULL, 166203),
(166204, '3.10.490.10-FF-000035', NULL, 'Histone deacetylase 5', 213, NULL, NULL, 166204),
(166205, '3.30.420.40-FF-000878', NULL, 'Uncharacterized protein', 43, NULL, NULL, 166205),
(166206, '2.60.40.60-FF-000468', NULL, 'Uncharacterized protein', 108, NULL, NULL, 166206),
(166207, '3.40.309.10-FF-000119', NULL, 'Os06g0592400 protein', 51, NULL, NULL, 166207),
(166208, '1.10.10.60-FF-001179', NULL, NULL, 37, NULL, NULL, 166208),
(166209, '3.20.20.70-FF-000548', NULL, NULL, 207, NULL, NULL, 166209),
(166210, '2.40.50.140-FF-000808', NULL, NULL, 137, NULL, NULL, 166210);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(166211, '3.40.50.2300-FF-001508', NULL, NULL, 100, NULL, NULL, 166211),
(166212, '1.25.40.10-FF-001897', NULL, 'U1 small nuclear ribonucleoprotein component, putative', 109, NULL, NULL, 166212),
(166213, '1.25.40.10-FF-005157', NULL, 'Uncharacterized protein', 89, NULL, NULL, 166213),
(166214, '3.40.190.10-FF-000264', NULL, 'ABC transporter substrate-binding protein', 103, NULL, NULL, 166214),
(166215, '3.10.129.10-FF-000269', NULL, 'Uncharacterized protein', 153, NULL, NULL, 166215),
(166216, '1.20.1160.20-FF-000006', NULL, 'Regulator of telomere elongation helicase 1', 87, NULL, NULL, 166216),
(166217, '3.40.50.300-FF-003641', NULL, 'DNA double-strand break repair Rad50 ATPase, putative', 236, NULL, NULL, 166217),
(166218, '3.30.160.60-FF-000043', NULL, 'Scratch family zinc finger 2', 25, NULL, NULL, 166218),
(166219, '1.10.238.10-FF-001109', NULL, 'Phosphoinositide phospholipase C', 55, NULL, NULL, 166219),
(166220, '2.170.15.10-FF-000002', NULL, 'natterin-like protein', 159, NULL, NULL, 166220),
(166221, '1.10.520.10-FF-000018', NULL, 'thylakoid lumenal 29 kDa protein, chloroplastic isoform X1', 83, NULL, NULL, 166221),
(166222, '3.30.160.60-FF-000482', NULL, 'PLAG1 like zinc finger 1', 25, NULL, NULL, 166222),
(166223, '3.40.1110.10-FF-000073', NULL, 'Phospholipid-transporting ATPase', 202, NULL, NULL, 166223),
(166224, '1.25.40.20-FF-000282', NULL, 'Ankyrin repeat domain-containing protein 13C-A', 81, NULL, NULL, 166224),
(166225, '3.40.50.1820-FF-000291', NULL, 'Alpha/beta-Hydrolases superfamily protein', 292, NULL, NULL, 166225),
(166226, '2.60.20.10-FF-000031', NULL, NULL, 86, NULL, NULL, 166226),
(166227, '2.60.40.1180-FF-000010', NULL, 'Glycogen debranching enzyme', 85, NULL, NULL, 166227),
(166228, '1.10.1200.10-FF-000010', NULL, 'Acyl carrier protein', 115, NULL, NULL, 166228),
(166229, '2.60.40.150-FF-000530', NULL, 'phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit alpha-like', 159, NULL, NULL, 166229),
(166230, '3.40.50.1440-FF-000154', NULL, 'Tubulin beta chain', 46, NULL, NULL, 166230),
(166231, '1.25.40.180-FF-000162', NULL, 'YALI0E24629p', 311, NULL, NULL, 166231),
(166232, '1.20.5.170-FF-000281', NULL, 'Uncharacterized protein', 101, NULL, NULL, 166232),
(166233, '2.20.25.20-FF-000029', NULL, NULL, 52, NULL, NULL, 166233),
(166234, '3.30.200.20-FF-000226', NULL, 'receptor protein kinase TMK1', 116, NULL, NULL, 166234),
(166235, '3.90.79.20-FF-000025', NULL, 'Predicted protein', 148, NULL, NULL, 166235),
(166236, '3.50.50.60-FF-000259', NULL, 'Dihydrolipoamide dehydrogenase, putative', 203, NULL, NULL, 166236),
(166237, '1.10.510.10-FF-003159', NULL, NULL, 172, NULL, NULL, 166237),
(166238, '1.10.555.10-FF-000031', NULL, 'rho GTPase-activating protein 100F isoform X6', 223, NULL, NULL, 166238),
(166239, '1.10.286.20-FF-000015', NULL, NULL, 38, NULL, NULL, 166239),
(166240, '3.30.160.60-FF-004860', NULL, NULL, 28, NULL, NULL, 166240),
(166241, '1.20.272.10-FF-000034', NULL, 'Activator 1 40 kDa subunit, putative', 85, NULL, NULL, 166241),
(166242, '1.25.40.120-FF-000088', NULL, 'Geranylgeranyl transferase type-2 subunit alpha 2', 257, NULL, NULL, 166242),
(166243, '2.60.120.10-FF-000366', NULL, 'Mannose-6-phosphate isomerase', 89, NULL, NULL, 166243),
(166244, '3.40.20.10-FF-000035', NULL, 'Villin-1', 115, NULL, NULL, 166244),
(166245, '3.30.540.10-FF-000018', NULL, 'inositol polyphosphate 1-phosphatase', 175, NULL, NULL, 166245),
(166246, '3.40.190.10-FF-000747', NULL, 'Uncharacterized protein', 117, NULL, NULL, 166246),
(166247, '3.30.70.1230-FF-000026', NULL, 'Guanylyl cyclase, putative', 231, NULL, NULL, 166247),
(166248, '3.40.50.720-FF-002103', NULL, 'Uncharacterized protein', 126, NULL, NULL, 166248),
(166249, '2.40.70.10-FF-000035', NULL, 'Plasmepsin-2', 175, NULL, NULL, 166249),
(166250, '3.90.190.10-FF-000298', NULL, 'Uncharacterized protein', 227, NULL, NULL, 166250),
(166251, '3.30.160.60-FF-000526', NULL, 'PR domain zinc finger protein 12', 28, NULL, NULL, 166251),
(166252, '1.10.540.10-FF-000070', NULL, 'Acyl-CoA dehydrogenase', 115, NULL, NULL, 166252);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(166253, '3.40.50.620-FF-000393', NULL, 'ATP binding L-PSP endoribonuclease family protein', 134, NULL, NULL, 166253),
(166254, '1.20.1270.30-FF-000001', NULL, 'Carbon monoxide dehydrogenase', 177, NULL, NULL, 166254),
(166255, '3.40.109.10-FF-000008', NULL, 'Putative NAD(P)H nitroreductase', 218, NULL, NULL, 166255),
(166256, '2.60.40.10-FF-000077', NULL, 'Kirre like nephrin family adhesion molecule 3', 107, NULL, NULL, 166256),
(166257, '1.10.510.10-FF-000372', NULL, 'MAP3K epsilon protein kinase 1', 290, NULL, NULL, 166257),
(166258, '3.80.10.10-FF-003214', NULL, 'Uncharacterized protein', 214, NULL, NULL, 166258),
(166259, '1.25.40.10-FF-002414', NULL, 'Putative pentatricopeptide repeat-containing protein', 146, NULL, NULL, 166259),
(166260, '1.10.3370.10-FF-000005', NULL, 'Protein translocase subunit SecY', 425, NULL, NULL, 166260),
(166261, '2.130.10.10-FF-001999', NULL, 'Flowering time control protein FY', 117, NULL, NULL, 166261),
(166262, '3.60.20.10-FF-000225', NULL, NULL, 126, NULL, NULL, 166262),
(166263, '1.10.8.60-FF-000520', NULL, 'Predicted protein', 40, NULL, NULL, 166263),
(166264, '2.130.10.10-FF-003927', NULL, 'Uncharacterized protein', 259, NULL, NULL, 166264),
(166265, '1.50.10.20-FF-000053', NULL, 'Protein farnesyltransferase subunit beta', 488, NULL, NULL, 166265),
(166266, '2.30.22.10-FF-000008', NULL, 'GrpE protein homolog', 64, NULL, NULL, 166266),
(166267, '3.10.105.10-FF-000029', NULL, 'Peptide ABC transporter substrate-binding protein', 211, NULL, NULL, 166267),
(166268, '1.10.560.10-FF-000083', NULL, 'T-complex protein 1 subunit theta', 118, NULL, NULL, 166268),
(166269, '1.20.1510.10-FF-000014', NULL, 'Cation efflux protein/ zinc transporter', 207, NULL, NULL, 166269),
(166270, '1.10.890.20-FF-000003', NULL, 'fatty-acid-binding protein 1-like', 42, NULL, NULL, 166270),
(166271, '1.10.10.10-FF-001917', NULL, 'Winged-helix DNA-binding transcription factor family protein', 99, NULL, NULL, 166271),
(166272, '2.40.10.10-FF-000059', NULL, 'Complement C1s subcomponent', 101, NULL, NULL, 166272),
(166273, '3.10.20.90-FF-000419', NULL, 'UBX domain-containing protein 4', 77, NULL, NULL, 166273),
(166274, '3.40.50.300-FF-006867', NULL, 'Uncharacterized ABC transporter ATP-binding protein HI_1470', 253, NULL, NULL, 166274),
(166275, '3.40.50.620-FF-000763', NULL, 'Uncharacterized protein', 124, NULL, NULL, 166275),
(166276, '2.60.40.10-FF-003792', NULL, NULL, 117, NULL, NULL, 166276),
(166277, '3.40.50.720-FF-002575', NULL, 'Uncharacterized protein', 31, NULL, NULL, 166277),
(166278, '1.10.10.10-FF-001434', NULL, 'DNA-binding response regulator', 102, NULL, NULL, 166278),
(166279, '3.40.50.2300-FF-001025', NULL, NULL, 70, NULL, NULL, 166279),
(166280, '2.60.120.970-FF-000054', NULL, 'Bone morphogenetic protein 2a', 247, NULL, NULL, 166280),
(166281, '2.60.120.200-FF-000773', NULL, 'Calnexin', 48, NULL, NULL, 166281),
(166282, '3.20.20.70-FF-000109', NULL, 'Glutamate synthase, large subunit', 330, NULL, NULL, 166282),
(166283, '1.10.10.2050-FF-000002', NULL, 'tRNA pseudouridine(54/55) synthase', 39, NULL, NULL, 166283),
(166284, '2.10.110.10-FF-000197', NULL, 'Transforming growth factor beta 1-induced transcript 1', 57, NULL, NULL, 166284),
(166285, '3.80.10.10-FF-001269', NULL, 'Putative RNA-binding protein EEED8.10', 329, NULL, NULL, 166285),
(166286, '3.30.70.330-FF-001902', NULL, NULL, 79, NULL, NULL, 166286),
(166287, '2.30.30.40-FF-000126', NULL, 'Cytoplasmic protein', 84, NULL, NULL, 166287),
(166288, '3.30.420.10-FF-000543', NULL, NULL, 75, NULL, NULL, 166288),
(166289, '1.10.418.10-FF-000218', NULL, 'Uncharacterized protein', 121, NULL, NULL, 166289),
(166290, '2.10.70.10-FF-000295', NULL, 'Complement C1r subcomponent like', 49, NULL, NULL, 166290),
(166291, '1.10.8.880-FF-000001', NULL, 'Structural polyprotein', 60, NULL, NULL, 166291),
(166292, '2.30.29.210-FF-000005', NULL, 'Chromatin-specific transcription elongation factor, putative', 111, NULL, NULL, 166292),
(166293, '1.10.8.60-FF-000150', NULL, 'Replication factor c protein, putative', 66, NULL, NULL, 166293);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(166294, '3.40.50.300-FF-006384', NULL, 'Predicted protein', 136, NULL, NULL, 166294),
(166295, '2.10.25.10-FF-000813', NULL, 'AAEL001196-PA', 44, NULL, NULL, 166295),
(166296, '3.80.10.10-FF-000460', NULL, 'Fibromodulin', 82, NULL, NULL, 166296),
(166297, '3.90.640.10-FF-000260', NULL, 'Uncharacterized protein', 111, NULL, NULL, 166297),
(166298, '1.10.533.10-FF-000306', NULL, 'Uncharacterized protein', 60, NULL, NULL, 166298),
(166299, '3.30.160.60-FF-002090', NULL, 'Zinc finger protein 473', 35, NULL, NULL, 166299),
(166300, '3.10.250.10-FF-000141', NULL, NULL, 43, NULL, NULL, 166300),
(166301, '2.30.29.30-FF-000524', NULL, 'EXOCyst component', 110, NULL, NULL, 166301),
(166302, '2.70.170.10-FF-000232', NULL, 'Uncharacterized protein', 80, NULL, NULL, 166302),
(166303, '3.30.750.130-FF-000001', NULL, NULL, 40, NULL, NULL, 166303),
(166304, '1.25.40.610-FF-000010', NULL, 'Latrophilin 1', 95, NULL, NULL, 166304),
(166305, '4.10.1240.10-FF-000021', NULL, 'Cadherin EGF LAG seven-pass G-type receptor', 65, NULL, NULL, 166305),
(166306, '1.20.58.60-FF-000833', NULL, 'Uncharacterized protein', 163, NULL, NULL, 166306),
(166307, '2.60.40.10-FF-003803', NULL, NULL, 94, NULL, NULL, 166307),
(166308, '1.20.58.390-FF-000144', NULL, 'Protein CBR-ACR-25', 31, NULL, NULL, 166308),
(166309, '3.40.30.10-FF-001261', NULL, 'Uncharacterized protein', 105, NULL, NULL, 166309),
(166310, '3.30.160.60-FF-003269', NULL, NULL, 27, NULL, NULL, 166310),
(166311, '1.20.1310.10-FF-000033', NULL, 'Anaphase-promoting complex subunit ApcB', 121, NULL, NULL, 166311),
(166312, '2.40.70.10-FF-000405', NULL, NULL, 158, NULL, NULL, 166312),
(166313, '2.30.29.30-FF-000041', NULL, 'TBC1 domain family member 9 isoform X1', 111, NULL, NULL, 166313),
(166314, '3.40.50.300-FF-005439', NULL, 'Uncharacterized protein', 260, NULL, NULL, 166314),
(166315, '1.10.287.600-FF-000023', NULL, 'Alpha-tubulin,putative', 73, NULL, NULL, 166315),
(166316, '1.20.58.60-FF-000041', NULL, 'Nesprin-1 isoform 1', 111, NULL, NULL, 166316),
(166317, '3.90.550.10-FF-000022', NULL, 'Histo-blood group ABO system transferase', 289, NULL, NULL, 166317),
(166318, '3.30.1120.120-FF-000001', NULL, 'serine/threonine-protein kinase PLK4 isoform X2', 120, NULL, NULL, 166318),
(166319, '1.10.1240.100-FF-000004', NULL, 'Polyketide synthase/nonribosomal peptide synthetase hybrid RzxB', 82, NULL, NULL, 166319),
(166320, '1.10.510.10-FF-000725', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 202, NULL, NULL, 166320),
(166321, '1.25.40.10-FF-004331', NULL, 'Uncharacterized protein', 166, NULL, NULL, 166321),
(166322, '2.10.220.10-FF-000216', NULL, 'Proprotein convertase subtilisin/kexin type 5', 49, NULL, NULL, 166322),
(166323, '1.20.58.390-FF-000014', NULL, 'Neuronal nicotinic acetylcholine receptor alpha4 subunit', 69, NULL, NULL, 166323),
(166324, '3.40.50.300-FF-004467', NULL, 'Replicative DNA helicase', 281, NULL, NULL, 166324),
(166325, '1.20.1280.290-FF-000099', NULL, 'Uncharacterized protein', 103, NULL, NULL, 166325),
(166326, '2.130.10.10-FF-005052', NULL, 'Uncharacterized protein', 279, NULL, NULL, 166326),
(166327, '3.30.450.200-FF-000016', NULL, 'Uncharacterized protein', 155, NULL, NULL, 166327),
(166328, '3.30.40.10-FF-000722', NULL, 'Ring-H2 zinc finger protein-like', 73, NULL, NULL, 166328),
(166329, '1.20.1070.10-FF-001306', NULL, 'Chemokine (C-X-C motif) receptor 3, tandem duplicate 3', 312, NULL, NULL, 166329),
(166330, '3.40.30.10-FF-000316', NULL, 'Peroxiredoxin AHP1', 174, NULL, NULL, 166330),
(166331, '3.40.50.410-FF-000346', NULL, 'Proteasome 26S subunit, non-ATPase 4', 109, NULL, NULL, 166331),
(166332, '4.10.60.10-FF-000126', NULL, 'Serine and arginine-rich-splicing factor 7a', 53, NULL, NULL, 166332),
(166333, '2.60.200.20-FF-000257', NULL, 'SMAD/FHA domain-containing protein', 84, NULL, NULL, 166333),
(166334, '3.80.10.10-FF-003523', NULL, 'Uncharacterized protein', 171, NULL, NULL, 166334),
(166335, '3.30.2410.10-FF-000048', NULL, 'E3 ubiquitin-protein ligase', 71, NULL, NULL, 166335),
(166336, '2.60.120.380-FF-000091', NULL, 'Thermostable beta-glucosidase B', 12, NULL, NULL, 166336);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(166337, '2.60.120.260-FF-000212', NULL, 'Beta-galactosidase', 138, NULL, NULL, 166337),
(166338, '1.10.10.10-FF-001125', NULL, 'Two-component response regulator YrkQ', 111, NULL, NULL, 166338),
(166339, '1.25.10.10-FF-003194', NULL, 'Uncharacterized protein', 962, NULL, NULL, 166339),
(166340, '2.60.40.10-FF-000414', NULL, 'Interleukin-6 receptor subunit beta', 89, NULL, NULL, 166340),
(166341, '3.40.50.360-FF-000163', NULL, 'S-adenosyl-L-methionine-dependent tRNA 4-demethylwyosine synthase', 217, NULL, NULL, 166341),
(166342, '1.10.472.80-FF-000067', NULL, 'GTPase-activating protein, putative', 151, NULL, NULL, 166342),
(166343, '1.10.150.240-FF-000112', NULL, 'HAD hydrolase, family IA, variant 3', 70, NULL, NULL, 166343),
(166344, '3.20.20.330-FF-000017', NULL, 'S-adenosylmethionine-homocysteine S-methyltransferase', 306, NULL, NULL, 166344),
(166345, '1.20.58.80-FF-000047', NULL, 'Endosomal AAA ATPase-like protein', 82, NULL, NULL, 166345),
(166346, '1.10.510.10-FF-001361', NULL, 'Serine/threonine protein kinase, putative', 342, NULL, NULL, 166346),
(166347, '1.10.630.10-FF-000791', NULL, 'Predicted protein', 108, NULL, NULL, 166347),
(166348, '3.40.640.10-FF-000046', NULL, 'Cystathionine gamma-lyase', 250, NULL, NULL, 166348),
(166349, '3.40.50.300-FF-005878', NULL, 'DNA helicase', 166, NULL, NULL, 166349),
(166350, '2.130.10.10-FF-000381', NULL, 'WD repeat-containing protein 48', 288, NULL, NULL, 166350),
(166351, '1.10.860.10-FF-000009', NULL, 'DNA primase', 136, NULL, NULL, 166351),
(166352, '2.40.50.140-FF-000016', NULL, '30S ribosomal protein S1', 87, NULL, NULL, 166352),
(166353, '3.30.760.10-FF-000029', NULL, 'Eukaryotic translation initiation factor 4E, putative', 191, NULL, NULL, 166353),
(166354, '1.10.10.10-FF-002070', NULL, 'ETS proto-oncogene 2, transcription factor', 85, NULL, NULL, 166354),
(166355, '1.20.1070.10-FF-001615', NULL, 'Uncharacterized protein', 146, NULL, NULL, 166355),
(166356, '3.80.10.10-FF-004512', NULL, 'Uncharacterized protein', 94, NULL, NULL, 166356),
(166357, '3.40.50.2000-FF-000699', NULL, 'Mannosyltransferase B', 180, NULL, NULL, 166357),
(166358, '2.130.10.10-FF-000690', NULL, 'Sortilin', 164, NULL, NULL, 166358),
(166359, '3.40.50.1450-FF-000011', NULL, 'Hydrogenase formation/expression factor related protein', 150, NULL, NULL, 166359),
(166360, '3.90.15.10-FF-000015', NULL, 'DNA topoisomerase I mitochondrial', 78, NULL, NULL, 166360),
(166361, '1.10.3720.10-FF-000033', NULL, 'Polar amino acid ABC transporter permease', 212, NULL, NULL, 166361),
(166362, '2.70.98.10-FF-000013', NULL, 'Putative alpha-1,2-mannosidase', 300, NULL, NULL, 166362),
(166363, '1.10.760.10-FF-000081', NULL, 'Cytochrome C-550', 128, NULL, NULL, 166363),
(166364, '3.30.60.20-FF-000142', NULL, 'Predicted protein', 107, NULL, NULL, 166364),
(166365, '1.10.287.470-FF-000045', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 74, NULL, NULL, 166365),
(166366, '2.10.25.10-FF-000460', NULL, 'Laminin subunit alpha 3', 46, NULL, NULL, 166366),
(166367, '3.90.1290.10-FF-000001', NULL, 'Plectin a', 253, NULL, NULL, 166367),
(166368, '1.20.120.350-FF-000002', NULL, 'Sodium channel protein', 116, NULL, NULL, 166368),
(166369, '2.40.420.20-FF-000019', NULL, 'Efflux transporter, RND family, MFP subunit', 91, NULL, NULL, 166369),
(166370, '1.20.1070.10-FF-001295', NULL, 'Uncharacterized protein', 297, NULL, NULL, 166370),
(166371, '1.25.10.10-FF-002103', NULL, 'Zyg-11 family member A, cell cycle regulator', 317, NULL, NULL, 166371),
(166372, '2.130.10.10-FF-004063', NULL, 'Coronin', 207, NULL, NULL, 166372),
(166373, '2.130.10.10-FF-004433', NULL, 'Uncharacterized protein', 357, NULL, NULL, 166373),
(166374, '2.130.10.10-FF-000701', NULL, 'Protein HIR', 103, NULL, NULL, 166374),
(166375, '3.30.160.60-FF-004225', NULL, NULL, 29, NULL, NULL, 166375),
(166376, '3.30.830.10-FF-000254', NULL, 'Uncharacterized protein', 131, NULL, NULL, 166376),
(166377, '3.20.20.140-FF-000197', NULL, 'Ribonuclease P protein subunit p30, putative', 203, NULL, NULL, 166377),
(166378, '3.20.20.80-FF-000438', NULL, 'Uncharacterized protein', 319, NULL, NULL, 166378);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(166379, '1.10.238.10-FF-001098', NULL, 'Uncharacterized protein', 65, NULL, NULL, 166379),
(166380, '3.40.1380.20-FF-000005', NULL, 'Pyruvate kinase', 142, NULL, NULL, 166380),
(166381, '3.60.130.10-FF-000065', NULL, 'Uncharacterized protein', 214, NULL, NULL, 166381),
(166382, '3.50.50.80-FF-000006', NULL, 'SUMO-activating enzyme subunit 2', 67, NULL, NULL, 166382),
(166383, '3.30.70.1730-FF-000070', NULL, '50S ribosomal protein L10', 114, NULL, NULL, 166383),
(166384, '3.20.20.80-FF-000068', NULL, 'hexosaminidase D isoform X1', 315, NULL, NULL, 166384),
(166385, '1.10.10.10-FF-000136', NULL, 'ETS homologous factor isoform X1', 128, NULL, NULL, 166385),
(166386, '1.10.510.10-FF-003598', NULL, NULL, 204, NULL, NULL, 166386),
(166387, '3.40.50.2300-FF-001497', NULL, NULL, 117, NULL, NULL, 166387),
(166388, '2.20.100.10-FF-000087', NULL, 'Complement component C6', 58, NULL, NULL, 166388),
(166389, '3.30.1520.10-FF-000056', NULL, 'Phosphoinositide-binding protein, putative', 122, NULL, NULL, 166389),
(166390, '1.10.1900.10-FF-000001', NULL, 'Polyadenylate-binding protein', 93, NULL, NULL, 166390),
(166391, '1.10.10.10-FF-000506', NULL, 'LysR family transcriptional regulator', 86, NULL, NULL, 166391),
(166392, '3.30.930.10-FF-000301', NULL, 'Phenylalanine--tRNA ligase beta subunit', 208, NULL, NULL, 166392),
(166393, '1.10.10.60-FF-000370', NULL, 'AraC family transcriptional regulator', 57, NULL, NULL, 166393),
(166394, '1.10.800.10-FF-000017', NULL, 'Uncharacterized protein', 125, NULL, NULL, 166394),
(166395, '3.20.20.60-FF-000062', NULL, 'Pyruvate kinase', 240, NULL, NULL, 166395),
(166396, '2.60.40.10-FF-000869', NULL, 'Protein tyrosine phosphatase, receptor type Q', 102, NULL, NULL, 166396),
(166397, '3.80.10.10-FF-002258', NULL, 'Uncharacterized protein', 108, NULL, NULL, 166397),
(166398, '2.60.120.290-FF-000064', NULL, 'Metalloendopeptidase', 118, NULL, NULL, 166398),
(166399, '2.60.120.260-FF-000521', NULL, 'Beta-galactosidase', 94, NULL, NULL, 166399),
(166400, '2.60.220.50-FF-000155', NULL, 'Adhesion G protein-coupled receptor E1', 171, NULL, NULL, 166400),
(166401, '2.105.10.10-FF-000001', NULL, 'Adsorption protein P2', 157, NULL, NULL, 166401),
(166402, '1.25.10.10-FF-001614', NULL, 'Proteasome/cyclosome repeat family protein', 420, NULL, NULL, 166402),
(166403, '3.40.50.300-FF-001696', NULL, 'Dynamin-3', 253, NULL, NULL, 166403),
(166404, '3.30.70.100-FF-000153', NULL, NULL, 117, NULL, NULL, 166404),
(166405, '3.40.80.10-FF-000044', NULL, 'N-acetylmuramoyl-L-alanine amidase family 2', 164, NULL, NULL, 166405),
(166406, '3.40.50.1000-FF-000106', NULL, 'Beta-phosphoglucomutase', 120, NULL, NULL, 166406),
(166407, '3.30.40.10-FF-001211', NULL, 'ENOS interacting protein', 129, NULL, NULL, 166407),
(166408, '2.40.128.20-FF-000003', NULL, 'Apolipoprotein D', 167, NULL, NULL, 166408),
(166409, '3.30.70.330-FF-000593', NULL, 'Serrate RNA effector molecule homolog', 143, NULL, NULL, 166409),
(166410, '2.30.30.140-FF-000043', NULL, 'PHD finger protein 20 (Predicted)', 65, NULL, NULL, 166410),
(166411, '3.90.1030.10-FF-000027', NULL, 'Predicted protein', 106, NULL, NULL, 166411),
(166412, '3.30.70.330-FF-001082', NULL, 'RNA-binding protein 38', 52, NULL, NULL, 166412),
(166413, '1.10.510.10-FF-001670', NULL, 'Mitogen-activated protein kinase kinase kinase 9', 112, NULL, NULL, 166413),
(166414, '2.60.40.150-FF-000221', NULL, 'E3 ubiquitin-protein ligase', 141, NULL, NULL, 166414),
(166415, '3.30.160.60-FF-004208', NULL, NULL, 32, NULL, NULL, 166415),
(166416, '1.20.1070.10-FF-001278', NULL, 'Uncharacterized protein', 101, NULL, NULL, 166416),
(166417, '1.20.5.620-FF-000005', NULL, NULL, 59, NULL, NULL, 166417),
(166418, '1.10.287.1130-FF-000008', NULL, 'Cx9C motif-containing protein 4, mitochondrial', 70, NULL, NULL, 166418),
(166419, '1.10.510.10-FF-004087', NULL, NULL, 160, NULL, NULL, 166419),
(166420, '2.30.30.360-FF-000007', NULL, 'Myosin-2 heavy chain', 48, NULL, NULL, 166420),
(166421, '3.30.70.340-FF-000011', NULL, NULL, 66, NULL, NULL, 166421),
(166422, '1.10.10.720-FF-000002', NULL, 'Leucine--tRNA ligase', 66, NULL, NULL, 166422);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(166423, '3.30.1640.10-FF-000003', NULL, 'DNA helicase', 102, NULL, NULL, 166423),
(166424, '1.10.10.60-FF-000499', NULL, 'Siamois homeodomain 1', 57, NULL, NULL, 166424),
(166425, '3.40.50.10190-FF-000260', NULL, 'Uncharacterized protein', 123, NULL, NULL, 166425),
(166426, '2.40.50.140-FF-000590', NULL, 'Single-stranded DNA-binding protein', 121, NULL, NULL, 166426),
(166427, '3.30.70.360-FF-000017', NULL, 'Amidohydrolase, putative', 117, NULL, NULL, 166427),
(166428, '3.30.70.260-FF-000105', NULL, 'Aspartokinase', 49, NULL, NULL, 166428),
(166429, '3.30.40.10-FF-001548', NULL, 'Uncharacterized protein', 55, NULL, NULL, 166429),
(166430, '3.30.70.330-FF-003010', NULL, NULL, 79, NULL, NULL, 166430),
(166431, '3.20.20.80-FF-000085', NULL, 'Poly-beta-1,6-N-acetyl-D-glucosamine N-deacetylase PgaB', 364, NULL, NULL, 166431),
(166432, '3.80.10.10-FF-002567', NULL, 'Uncharacterized protein', 123, NULL, NULL, 166432),
(166433, '3.40.50.1110-FF-000139', NULL, 'Uncharacterized protein', 204, NULL, NULL, 166433),
(166434, '1.10.8.60-FF-000503', NULL, 'Uncharacterized AAA domain-containing protein C24B10.10c', 70, NULL, NULL, 166434),
(166435, '1.25.40.10-FF-002061', NULL, 'Uncharacterized protein', 71, NULL, NULL, 166435),
(166436, '2.40.10.10-FF-000076', NULL, 'Structural polyprotein', 71, NULL, NULL, 166436),
(166437, '1.20.1510.10-FF-000031', NULL, 'Zinc transporter, putative', 86, NULL, NULL, 166437),
(166438, '3.30.1370.10-FF-000139', NULL, 'Exosome complex exonuclease RRP40, putative', 81, NULL, NULL, 166438),
(166439, '2.30.29.30-FF-000833', NULL, 'Uncharacterized protein', 89, NULL, NULL, 166439),
(166440, '3.40.1160.10-FF-000104', NULL, 'Aspartokinase', 271, NULL, NULL, 166440),
(166441, '3.40.50.150-FF-000229', NULL, 'tRNA methyltransferase 2 homolog A', 235, NULL, NULL, 166441),
(166442, '2.60.40.10-FF-004129', NULL, NULL, 91, NULL, NULL, 166442),
(166443, '2.130.10.10-FF-001218', NULL, 'TEP1 isoform 2', 156, NULL, NULL, 166443),
(166444, '3.80.10.10-FF-001286', NULL, 'Leucine rich repeat and phosphatase domain containing protein', 147, NULL, NULL, 166444),
(166445, '1.20.120.1630-FF-000005', NULL, 'Phosphatidylethanolamine N-methyltransferase', 182, NULL, NULL, 166445),
(166446, '2.130.10.10-FF-003944', NULL, 'Uncharacterized protein', 249, NULL, NULL, 166446),
(166447, '3.30.420.10-FF-000560', NULL, NULL, 56, NULL, NULL, 166447),
(166448, '1.25.10.10-FF-000760', NULL, 'Condensin complex subunit 1', 192, NULL, NULL, 166448),
(166449, '1.20.1560.10-FF-000197', NULL, 'AGAP009835-PA', 166, NULL, NULL, 166449),
(166450, '2.60.40.150-FF-000058', NULL, 'Phosphoinositide phospholipase C', 136, NULL, NULL, 166450),
(166451, '2.30.30.90-FF-000017', NULL, 'Iron dependent repressor', 81, NULL, NULL, 166451),
(166452, '3.40.50.1000-FF-000045', NULL, 'Cation-transporting ATPase', 191, NULL, NULL, 166452),
(166453, '3.40.720.10-FF-000108', NULL, 'Arylsulfatase A [precursor]', 347, NULL, NULL, 166453),
(166454, '1.10.472.80-FF-000128', NULL, 'Rab GTPase activator', 148, NULL, NULL, 166454),
(166455, '3.30.160.60-FF-002308', NULL, NULL, 28, NULL, NULL, 166455),
(166456, '2.10.90.10-FF-000178', NULL, 'Uncharacterized protein', 62, NULL, NULL, 166456),
(166457, '3.40.50.300-FF-007795', NULL, 'Si:ch211-247i17.1', 46, NULL, NULL, 166457),
(166458, '1.25.40.10-FF-005287', NULL, 'Uncharacterized protein', 141, NULL, NULL, 166458),
(166459, '2.60.40.10-FF-000386', NULL, 'Cytokine receptor like factor 1', 109, NULL, NULL, 166459),
(166460, '3.20.20.80-FF-000568', NULL, 'Uncharacterized protein', 101, NULL, NULL, 166460),
(166461, '1.10.30.10-FF-000019', NULL, 'nucleolar transcription factor 1 isoform X2', 93, NULL, NULL, 166461),
(166462, '2.40.10.10-FF-000368', NULL, NULL, 103, NULL, NULL, 166462),
(166463, '3.90.640.10-FF-000243', NULL, 'Uncharacterized protein', 29, NULL, NULL, 166463),
(166464, '3.20.20.370-FF-000018', NULL, 'ChbG/HpnK family deacetylase', 277, NULL, NULL, 166464),
(166465, '1.20.1250.20-FF-001250', NULL, 'Polyamine transport-related protein, putative', 449, NULL, NULL, 166465),
(166466, '2.60.40.10-FF-003820', NULL, NULL, 98, NULL, NULL, 166466);
INSERT INTO "PUBLIC"."MODEL" VALUES
(166467, '1.10.630.10-FF-000217', NULL, 'Os08g0105600 protein', 312, NULL, NULL, 166467),
(166468, '3.40.50.2300-FF-000671', NULL, 'Uncharacterized protein', 145, NULL, NULL, 166468),
(166469, '3.10.290.60-FF-000006', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 95, NULL, NULL, 166469),
(166470, '1.20.1070.10-FF-000659', NULL, 'Predicted protein', 284, NULL, NULL, 166470),
(166471, '2.40.70.10-FF-000052', NULL, 'ASpartyl Protease', 159, NULL, NULL, 166471),
(166472, '3.30.1490.480-FF-000016', NULL, NULL, 69, NULL, NULL, 166472),
(166473, '2.60.40.2240-FF-000008', NULL, 'bile acid-CoA:amino acid N-acyltransferase isoform X4', 145, NULL, NULL, 166473),
(166474, '2.20.100.10-FF-000115', NULL, 'Thrombospondin type-1 domain-containing protein 1', 75, NULL, NULL, 166474),
(166475, '1.10.510.10-FF-000742', NULL, 'Serine/threonine-protein kinase atg1', 179, NULL, NULL, 166475),
(166476, '1.10.10.10-FF-000006', NULL, 'cAMP-activated global transcriptional regulator CRP', 69, NULL, NULL, 166476),
(166477, '3.60.40.10-FF-000108', NULL, 'Protein phosphatase 2C', 300, NULL, NULL, 166477),
(166478, '1.10.238.20-FF-000027', NULL, 'General odorant-binding protein 84a', 105, NULL, NULL, 166478),
(166479, '3.90.70.10-FF-000148', NULL, 'Alpha-hemolysin translocation ATP-binding protein HlyB', 131, NULL, NULL, 166479),
(166480, '3.30.110.80-FF-000001', NULL, 'DNA double-strand break repair protein Mre11', 83, NULL, NULL, 166480),
(166481, '3.30.450.20-FF-000357', NULL, 'Two-component sensor histidine kinase', 123, NULL, NULL, 166481),
(166482, '3.10.450.60-FF-000008', NULL, 'Arachidonate 12-lipoxygenase', 85, NULL, NULL, 166482),
(166483, '2.60.40.60-FF-000159', NULL, 'cadherin-16 isoform X1', 110, NULL, NULL, 166483),
(166484, '1.10.150.80-FF-000038', NULL, 'Ribonuclease D', 96, NULL, NULL, 166484),
(166485, '1.10.510.10-FF-003468', NULL, NULL, 272, NULL, NULL, 166485),
(166486, '3.40.720.10-FF-000210', NULL, 'Uncharacterized protein', 262, NULL, NULL, 166486),
(166487, '1.10.1070.11-FF-000062', NULL, 'Phosphatidylinositol 3-and 4-kinase, putative', 178, NULL, NULL, 166487),
(166488, '3.30.70.330-FF-000093', NULL, 'Putative DAZ-associated protein 1', 74, NULL, NULL, 166488),
(166489, '2.40.50.1060-FF-000018', NULL, 'Uncharacterized protein', 148, NULL, NULL, 166489),
(166490, '3.40.1110.10-FF-000056', NULL, 'Copper-exporting P-type ATPase', 123, NULL, NULL, 166490),
(166491, '3.40.50.300-FF-007356', NULL, 'AGAP012289-PA', 183, NULL, NULL, 166491),
(166492, '3.20.20.140-FF-000067', NULL, 'Adenine deaminase', 244, NULL, NULL, 166492),
(166493, '3.30.40.10-FF-002167', NULL, 'Uncharacterized protein', 128, NULL, NULL, 166493),
(166494, '1.25.40.20-FF-000265', NULL, 'ASPG isoform 1', 68, NULL, NULL, 166494),
(166495, '2.130.10.10-FF-005844', NULL, 'Uncharacterized protein', 344, NULL, NULL, 166495),
(166496, '2.60.40.10-FF-004000', NULL, NULL, 100, NULL, NULL, 166496),
(166497, '2.170.260.10-FF-000018', NULL, 'Endoribonuclease Dicer', 124, NULL, NULL, 166497),
(166498, '3.40.50.2000-FF-000199', NULL, 'UDP-glycosyltransferase 76C1', 247, NULL, NULL, 166498),
(166499, '3.30.200.20-FF-000209', NULL, 'MAP kinase-activated protein kinase 5 isoform X1', 102, NULL, NULL, 166499),
(166500, '2.60.40.1710-FF-000001', NULL, 'Cell wall-associated serine proteinase', 155, NULL, NULL, 166500),
(166501, '3.30.565.10-FF-000233', NULL, 'Two-component sensor EnvZ', 149, NULL, NULL, 166501),
(166502, '1.25.40.10-FF-001442', NULL, 'Os11g0483950 protein', 183, NULL, NULL, 166502),
(166503, '3.30.160.60-FF-002151', NULL, 'Zinc finger protein 670', 35, NULL, NULL, 166503),
(166504, '3.30.160.60-FF-000173', NULL, 'Mds1 and evi1 complex locus protein', 20, NULL, NULL, 166504),
(166505, '1.10.860.10-FF-000026', NULL, 'DNA primase', 143, NULL, NULL, 166505),
(166506, '1.20.1050.40-FF-000010', NULL, 'Predicted protein', 141, NULL, NULL, 166506),
(166507, '2.60.40.10-FF-005720', NULL, NULL, 35, NULL, NULL, 166507),
(166508, '3.40.1490.10-FF-000005', NULL, 'Peptidyl-tRNA hydrolase', 99, NULL, NULL, 166508);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(166509, '1.10.630.10-FF-000689', NULL, 'Os03g0850200 protein', 149, NULL, NULL, 166509),
(166510, '3.40.50.720-FF-002120', NULL, 'Uncharacterized protein', 112, NULL, NULL, 166510),
(166511, '1.10.555.10-FF-000014', NULL, 'Rho GTPase activating protein 21', 238, NULL, NULL, 166511),
(166512, '3.30.200.20-FF-001154', NULL, 'Serine/threonine-protein kinase-like protein', 129, NULL, NULL, 166512),
(166513, '2.60.120.590-FF-000047', NULL, 'Uncharacterized protein', 37, NULL, NULL, 166513),
(166514, '3.80.10.10-FF-003186', NULL, 'Protein CBR-GADR-3', 242, NULL, NULL, 166514),
(166515, '3.30.450.20-FF-000065', NULL, 'probable G-protein coupled receptor 158', 162, NULL, NULL, 166515),
(166516, '3.10.450.40-FF-000002', NULL, 'Amine oxidase', 104, NULL, NULL, 166516),
(166517, '4.10.280.10-FF-000223', NULL, 'uncharacterized protein LOC100176581', 84, NULL, NULL, 166517),
(166518, '3.40.50.300-FF-005895', NULL, 'GTPase HflX', 181, NULL, NULL, 166518),
(166519, '3.30.1490.80-FF-000034', NULL, 'Uncharacterized protein', 24, NULL, NULL, 166519),
(166520, '3.60.21.10-FF-000216', NULL, 'Sphingomyelin phosphodiesterase', 153, NULL, NULL, 166520),
(166521, '3.30.40.10-FF-000222', NULL, 'E3 ubiquitin-protein ligase COP1 isoform X2', 99, NULL, NULL, 166521),
(166522, '3.90.550.10-FF-000152', NULL, 'Glycosyltransferases', 242, NULL, NULL, 166522),
(166523, '1.20.1720.10-FF-000069', NULL, 'Multidrug resistance protein B', 234, NULL, NULL, 166523),
(166524, '2.130.10.10-FF-001662', NULL, 'CPSF_A_subunit_region_containing_protein', 361, NULL, NULL, 166524),
(166525, '3.30.40.10-FF-001650', NULL, 'Histone-lysine N-methyltransferase', 83, NULL, NULL, 166525),
(166526, '3.30.40.100-FF-000006', NULL, 'Histone-lysine N-methyltransferase', 62, NULL, NULL, 166526),
(166527, '2.60.40.10-FF-001566', NULL, 'collagen alpha-1(VII) chain isoform X2', 88, NULL, NULL, 166527),
(166528, '1.25.10.10-FF-002603', NULL, 'Uncharacterized protein', 147, NULL, NULL, 166528),
(166529, '2.10.25.10-FF-000443', NULL, 'Coagulation factor X', 54, NULL, NULL, 166529),
(166530, '3.30.60.30-FF-000128', NULL, 'MIP10102p', 49, NULL, NULL, 166530),
(166531, '2.60.120.290-FF-000108', NULL, 'SOL-1 related protein', 132, NULL, NULL, 166531),
(166532, '1.10.300.10-FF-000007', NULL, 'Adenylosuccinate synthetase', 41, NULL, NULL, 166532),
(166533, '2.60.40.10-FF-003483', NULL, NULL, 96, NULL, NULL, 166533),
(166534, '3.10.20.90-FF-000728', NULL, 'Uncharacterized protein', 73, NULL, NULL, 166534),
(166535, '3.40.800.20-FF-000040', NULL, 'Histone deacetylase 2', 82, NULL, NULL, 166535),
(166536, '1.10.10.1050-FF-000011', NULL, 'mRNA-decapping enzyme 2', 86, NULL, NULL, 166536),
(166537, '2.60.40.2220-FF-000002', NULL, 'Alpha-mannosidase', 85, NULL, NULL, 166537),
(166538, '2.120.10.30-FF-000426', NULL, 'Uncharacterized protein', 149, NULL, NULL, 166538),
(166539, '3.30.900.10-FF-000018', NULL, 'Putative mitotic spindle checkpoint component', 196, NULL, NULL, 166539),
(166540, '2.20.70.10-FF-000215', NULL, 'WW domain containing protein, putative', 60, NULL, NULL, 166540),
(166541, '2.40.30.10-FF-000061', NULL, 'Translation release factor eRF3, putative', 90, NULL, NULL, 166541),
(166542, '3.30.1480.10-FF-000001', NULL, 'Transcription termination/antitermination protein NusA', 129, NULL, NULL, 166542),
(166543, '3.40.50.300-FF-006075', NULL, 'Sulfotransferase', 326, NULL, NULL, 166543),
(166544, '1.25.40.20-FF-000826', NULL, 'Uncharacterized protein', 128, NULL, NULL, 166544),
(166545, '1.25.40.60-FF-000018', NULL, NULL, 122, NULL, NULL, 166545),
(166546, '1.10.400.10-FF-000060', NULL, 'Uncharacterized protein', 38, NULL, NULL, 166546),
(166547, '3.60.20.10-FF-000208', NULL, NULL, 186, NULL, NULL, 166547),
(166548, '1.25.10.10-FF-000788', NULL, 'E3 ubiquitin-protein ligase UPL1-like protein', 236, NULL, NULL, 166548),
(166549, '3.30.200.20-FF-001715', NULL, 'Mitogen-activated protein kinase 15', 26, NULL, NULL, 166549),
(166550, '1.10.287.470-FF-000028', NULL, 'Probable RND efflux membrane fusion protein', 74, NULL, NULL, 166550),
(166551, '1.25.40.10-FF-001925', NULL, 'Pentatricopeptide repeat-containing protein At3g04750, mitochondrial', 248, NULL, NULL, 166551);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(166552, '2.60.40.4220-FF-000001', NULL, 'Lectin alpha chain', 44, NULL, NULL, 166552),
(166553, '2.70.160.11-FF-000064', NULL, 'protein arginine N-methyltransferase 6', 185, NULL, NULL, 166553),
(166554, '1.25.40.10-FF-002723', NULL, 'Sel1 repeat, putative', 290, NULL, NULL, 166554),
(166555, '2.60.34.10-FF-000001', NULL, 'Molecular chaperone DnaK', 141, NULL, NULL, 166555),
(166556, '1.10.630.10-FF-000661', NULL, 'Uncharacterized protein', 189, NULL, NULL, 166556),
(166557, '1.10.510.10-FF-002979', NULL, NULL, 146, NULL, NULL, 166557),
(166558, '2.20.25.290-FF-000001', NULL, 'Protein kinase AMP-activated non-catalytic subunit beta 2', 34, NULL, NULL, 166558),
(166559, '3.90.650.10-FF-000069', NULL, 'Phosphoribosylformylglycinamidine synthase', 172, NULL, NULL, 166559),
(166560, '2.60.40.10-FF-002331', NULL, 'Myotactin form A', 97, NULL, NULL, 166560),
(166561, '3.90.132.10-FF-000012', NULL, 'GP63-like', 125, NULL, NULL, 166561),
(166562, '4.10.400.10-FF-000312', NULL, 'Tyrosine-protein kinase receptor', 30, NULL, NULL, 166562),
(166563, '2.10.60.10-FF-000058', NULL, 'Serine/threonine-protein kinase receptor', 72, NULL, NULL, 166563),
(166564, '1.10.10.10-FF-000153', NULL, 'LuxR family transcriptional regulator', 66, NULL, NULL, 166564),
(166565, '1.10.8.60-FF-000048', NULL, 'Katanin p60 ATPase-containing subunit A-like 2', 95, NULL, NULL, 166565),
(166566, '3.40.50.150-FF-000690', NULL, 'SAM-dependent methyltransferase', 162, NULL, NULL, 166566),
(166567, '3.40.50.10140-FF-000026', NULL, 'Toll-like receptor 2', 140, NULL, NULL, 166567),
(166568, '4.10.400.10-FF-000088', NULL, 'Heparan sulfate proteoglycan 2', 41, NULL, NULL, 166568),
(166569, '1.10.20.10-FF-000081', NULL, 'Histone H3, putative', 145, NULL, NULL, 166569),
(166570, '3.30.450.290-FF-000003', NULL, 'Sensor histidine kinase response regulator, DUF3365, PAS, PAS and Hpt domain-containing, heme-binding', 103, NULL, NULL, 166570),
(166571, '3.90.810.10-FF-000043', NULL, NULL, 38, NULL, NULL, 166571),
(166572, '1.10.1450.10-FF-000039', NULL, 'Tetraspanin', 125, NULL, NULL, 166572),
(166573, '3.30.420.40-FF-000086', NULL, 'Glycerol kinase', 256, NULL, NULL, 166573),
(166574, '3.90.550.10-FF-000461', NULL, '2-C-methyl-D-erythritol 4-phosphate cytidylyltransferase', 230, NULL, NULL, 166574),
(166575, '1.20.58.1100-FF-000007', NULL, 'Protein unc-13 B', 60, NULL, NULL, 166575),
(166576, '3.30.1490.70-FF-000014', NULL, 'Predicted protein', 59, NULL, NULL, 166576),
(166577, '1.10.287.110-FF-000281', NULL, 'DnaJ-like chaperone, putative', 129, NULL, NULL, 166577),
(166578, '1.20.1270.10-FF-000006', NULL, 'Chaperone protein HscA', 96, NULL, NULL, 166578),
(166579, '1.50.40.10-FF-000344', NULL, 'Uncharacterized protein', 178, NULL, NULL, 166579),
(166580, '3.40.50.10470-FF-000041', NULL, 'Uncharacterized protein', 231, NULL, NULL, 166580),
(166581, '3.30.450.20-FF-000048', NULL, 'Methyl-accepting chemotaxis protein', 112, NULL, NULL, 166581),
(166582, '1.20.1640.10-FF-000035', NULL, 'PaTched Related family', 188, NULL, NULL, 166582),
(166583, '3.30.160.60-FF-005978', NULL, NULL, 61, NULL, NULL, 166583),
(166584, '3.40.50.1010-FF-000126', NULL, 'Putative rrp44p homologue', 191, NULL, NULL, 166584),
(166585, '3.40.50.12120-FF-000002', NULL, 'Proteasome biogenesis-associated', 76, NULL, NULL, 166585),
(166586, '1.20.5.3310-FF-000001', NULL, 'Probable Sec-independent protein translocase protein TatE', 47, NULL, NULL, 166586),
(166587, '1.20.1070.10-FF-001323', NULL, 'Uncharacterized protein', 273, NULL, NULL, 166587),
(166588, '1.10.418.10-FF-000235', NULL, 'DIX domain-containing 1', 68, NULL, NULL, 166588),
(166589, '3.30.70.330-FF-001065', NULL, 'Predicted protein', 135, NULL, NULL, 166589),
(166590, '3.30.9.10-FF-000189', NULL, 'FAD dependent oxidoreductase', 192, NULL, NULL, 166590),
(166591, '1.20.58.1120-FF-000018', NULL, 'Dynein heavy chain-like protein', 141, NULL, NULL, 166591),
(166592, '1.10.569.10-FF-000001', NULL, 'Aldehyde:ferredoxin oxidoreductase, tungsten-containing', 187, NULL, NULL, 166592),
(166593, '1.20.5.340-FF-000062', NULL, 'Protein CBR-MYO-2', 122, NULL, NULL, 166593);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(166594, '3.40.140.10-FF-000244', NULL, 'Uncharacterized protein', 151, NULL, NULL, 166594),
(166595, '3.40.50.720-FF-001614', NULL, 'Uncharacterized protein', 117, NULL, NULL, 166595),
(166596, '1.25.10.10-FF-000125', NULL, 'cytosolic carboxypeptidase 1 isoform X1', 303, NULL, NULL, 166596),
(166597, '3.30.70.330-FF-000576', NULL, 'Uncharacterized protein, isoform B', 150, NULL, NULL, 166597),
(166598, '3.30.505.10-FF-000257', NULL, NULL, 102, NULL, NULL, 166598),
(166599, '3.40.50.10810-FF-000143', NULL, 'Eukaryotic translation initiation factor 3 subunit E', 267, NULL, NULL, 166599),
(166600, '3.20.20.190-FF-000149', NULL, NULL, 275, NULL, NULL, 166600),
(166601, '2.20.50.20-FF-000009', NULL, 'Apolipophorin, isoform B', 146, NULL, NULL, 166601),
(166602, '3.30.1330.30-FF-000120', NULL, 'ADL269Wp', 73, NULL, NULL, 166602),
(166603, '3.40.50.300-FF-005456', NULL, 'ATP-binding cassette sub-family F member 1', 313, NULL, NULL, 166603),
(166604, '2.60.40.60-FF-001087', NULL, 'Uncharacterized protein', 108, NULL, NULL, 166604),
(166605, '3.30.70.3490-FF-000024', NULL, 'Oxysterol Binding protein (OSBP) Related', 124, NULL, NULL, 166605),
(166606, '3.90.550.10-FF-000005', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 384, NULL, NULL, 166606),
(166607, '3.40.50.1820-FF-001572', NULL, 'Predicted protein', 109, NULL, NULL, 166607),
(166608, '1.10.1200.270-FF-000002', NULL, 'indole-3-acetate O-methyltransferase 1', 141, NULL, NULL, 166608),
(166609, '1.25.40.10-FF-003342', NULL, 'Pentatricopeptide repeat-containing protein At3g49710', 91, NULL, NULL, 166609),
(166610, '2.30.29.30-FF-001030', NULL, 'FERM domain-containing 3', 39, NULL, NULL, 166610),
(166611, '3.30.1360.120-FF-000110', NULL, 'Uncharacterized protein', 29, NULL, NULL, 166611),
(166612, '3.90.260.10-FF-000034', NULL, 'DNA repair protein Rad4 family protein', 230, NULL, NULL, 166612),
(166613, '3.60.10.10-FF-000270', NULL, 'DNA-(apurinic or apyrimidinic site) lyase', 95, NULL, NULL, 166613),
(166614, '3.30.160.60-FF-000026', NULL, 'Transcription factor Sp3', 32, NULL, NULL, 166614),
(166615, '1.25.10.10-FF-001277', NULL, 'AGAP001820-PA', 152, NULL, NULL, 166615),
(166616, '1.10.3430.10-FF-000078', NULL, 'Uncharacterized protein', 85, NULL, NULL, 166616),
(166617, '1.10.510.10-FF-002642', NULL, NULL, 150, NULL, NULL, 166617),
(166618, '3.40.50.200-FF-000059', NULL, 'Clan SB, family S8, subtilisin-like serine peptidase', 255, NULL, NULL, 166618),
(166619, '3.30.160.60-FF-006203', NULL, NULL, 39, NULL, NULL, 166619),
(166620, '2.60.40.10-FF-005618', NULL, NULL, 99, NULL, NULL, 166620),
(166621, '1.20.58.920-FF-000005', NULL, 'Histidine kinase', 132, NULL, NULL, 166621),
(166622, '1.20.1070.10-FF-000789', NULL, 'Probable G-protein coupled receptor AH9.4', 285, NULL, NULL, 166622),
(166623, '2.30.42.10-FF-000010', NULL, 'Neurabin-1 isoform 1', 109, NULL, NULL, 166623),
(166624, '2.30.30.40-FF-000598', NULL, 'Uncharacterized protein', 58, NULL, NULL, 166624),
(166625, '2.20.25.10-FF-000010', NULL, 'Two-component system response regulator', 39, NULL, NULL, 166625),
(166626, '3.10.290.10-FF-000054', NULL, 'Tyrosine--tRNA ligase', 97, NULL, NULL, 166626),
(166627, '3.40.50.800-FF-000031', NULL, 'Threonine-tRNA ligase', 118, NULL, NULL, 166627),
(166628, '3.30.200.20-FF-002334', NULL, 'Uncharacterized protein', 70, NULL, NULL, 166628),
(166629, '2.60.40.150-FF-000513', NULL, 'Uncharacterized protein', 150, NULL, NULL, 166629),
(166630, '2.160.20.10-FF-000195', NULL, 'F-box only protein 10', 305, NULL, NULL, 166630),
(166631, '3.60.21.10-FF-000396', NULL, 'Sphingomyelin phosphodiesterase', 324, NULL, NULL, 166631),
(166632, '3.40.930.10-FF-000001', NULL, 'Anion exchange protein', 315, NULL, NULL, 166632),
(166633, '3.40.50.80-FF-000086', NULL, 'NADPH-dependent ferric siderophore reductase', 128, NULL, NULL, 166633),
(166634, '3.90.70.80-FF-000096', NULL, 'Uncharacterized protein', 130, NULL, NULL, 166634),
(166635, '3.20.20.70-FF-000211', NULL, 'Nitronate monooxygenase', 303, NULL, NULL, 166635),
(166636, '3.30.420.10-FF-000690', NULL, NULL, 127, NULL, NULL, 166636);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(166637, '3.30.160.60-FF-005714', NULL, NULL, 41, NULL, NULL, 166637),
(166638, '2.40.128.50-FF-000001', NULL, 'D-aminopeptidase domain C', 98, NULL, NULL, 166638),
(166639, '2.40.50.40-FF-000020', NULL, 'C-X-C motif chemokine 14', 78, NULL, NULL, 166639),
(166640, '1.10.1450.10-FF-000141', NULL, 'Tetraspanin', 96, NULL, NULL, 166640),
(166641, '3.20.20.330-FF-000034', NULL, 'Uncharacterized protein HI_1042', 53, NULL, NULL, 166641),
(166642, '1.20.58.900-FF-000027', NULL, 'Uncharacterized protein', 83, NULL, NULL, 166642),
(166643, '1.25.10.10-FF-003222', NULL, 'Uncharacterized protein', 262, NULL, NULL, 166643),
(166644, '2.20.28.10-FF-000033', NULL, 'DNA replication licensing factor MCM7', 67, NULL, NULL, 166644),
(166645, '2.60.40.10-FF-005309', NULL, NULL, 79, NULL, NULL, 166645),
(166646, '1.10.10.10-FF-002053', NULL, 'Uncharacterized protein', 163, NULL, NULL, 166646),
(166647, '3.60.90.10-FF-000027', NULL, 'Uncharacterized protein', 265, NULL, NULL, 166647),
(166648, '3.30.760.10-FF-000046', NULL, 'AGAP007172-PB', 210, NULL, NULL, 166648),
(166649, '2.30.33.40-FF-000020', NULL, 'Chaperonin 23', 106, NULL, NULL, 166649),
(166650, '3.40.250.10-FF-000235', NULL, 'Uncharacterized protein', 114, NULL, NULL, 166650),
(166651, '1.10.287.1480-FF-000001', NULL, '30S ribosomal protein S14', 91, NULL, NULL, 166651),
(166652, '2.60.40.10-FF-005057', NULL, NULL, 101, NULL, NULL, 166652),
(166653, '2.40.50.40-FF-000048', NULL, 'Polycomb group protein Pc', 55, NULL, NULL, 166653),
(166654, '3.60.15.10-FF-000275', NULL, 'Putative DNA interstrand cross-link repair protein', 178, NULL, NULL, 166654),
(166655, '4.10.240.10-FF-000086', NULL, 'C6 transcription factor, putative', 87, NULL, NULL, 166655),
(166656, '3.20.20.70-FF-000239', NULL, 'tRNA-dihydrouridine synthase', 236, NULL, NULL, 166656),
(166657, '2.60.120.620-FF-000028', NULL, 'Phytanoyl-CoA dioxygenase', 263, NULL, NULL, 166657),
(166658, '2.40.50.1020-FF-000001', NULL, 'Two-component response regulator yehT', 110, NULL, NULL, 166658),
(166659, '2.10.60.10-FF-000030', NULL, 'Lymphocyte antigen 6 complex, locus G6G', 72, NULL, NULL, 166659),
(166660, '1.20.1740.10-FF-000099', NULL, 'BnaA03g01440D protein', 449, NULL, NULL, 166660),
(166661, '2.60.40.2030-FF-000052', NULL, 'Adhesion G-protein coupled receptor V1', 135, NULL, NULL, 166661),
(166662, '3.40.50.1440-FF-000137', NULL, 'Tubulin gamma-2 chain', 85, NULL, NULL, 166662),
(166663, '1.10.30.10-FF-000036', NULL, 'high mobility group protein D', 73, NULL, NULL, 166663),
(166664, '1.10.238.10-FF-001289', NULL, 'Uncharacterized protein', 83, NULL, NULL, 166664),
(166665, '1.10.287.70-FF-000431', NULL, 'Uncharacterized protein', 63, NULL, NULL, 166665),
(166666, '2.60.120.920-FF-000180', NULL, 'Uncharacterized protein', 44, NULL, NULL, 166666),
(166667, '2.10.220.10-FF-000188', NULL, 'Uncharacterized protein', 64, NULL, NULL, 166667),
(166668, '2.30.39.10-FF-000092', NULL, 'Serpin 42Db, isoform D', 126, NULL, NULL, 166668),
(166669, '2.60.40.420-FF-000195', NULL, 'Early nodulin-like protein 1', 103, NULL, NULL, 166669),
(166670, '3.30.70.2120-FF-000001', NULL, 'Flagellin', 74, NULL, NULL, 166670),
(166671, '3.30.200.20-FF-000889', NULL, 'Mitogen-activated protein kinase', 102, NULL, NULL, 166671),
(166672, '2.170.300.10-FF-000078', NULL, 'Uncharacterized protein', 125, NULL, NULL, 166672),
(166673, '2.130.10.10-FF-004624', NULL, 'Uncharacterized protein', 199, NULL, NULL, 166673),
(166674, '3.40.50.2300-FF-001160', NULL, NULL, 195, NULL, NULL, 166674),
(166675, '3.30.160.60-FF-002960', NULL, 'Zinc finger protein 19', 25, NULL, NULL, 166675),
(166676, '3.30.200.20-FF-001507', NULL, 'rho-associated protein kinase 2 isoform X3', 18, NULL, NULL, 166676),
(166677, '1.25.40.70-FF-000055', NULL, 'Age-1', 203, NULL, NULL, 166677),
(166678, '4.10.400.10-FF-000104', NULL, 'Low-density lipoprotein receptor class A domain-containing protein 3', 40, NULL, NULL, 166678),
(166679, '3.40.50.10860-FF-000017', NULL, 'Shikimate dehydrogenase', 117, NULL, NULL, 166679),
(166680, '2.30.39.10-FF-000148', NULL, 'Serpin peptidase inhibitor 31', 132, NULL, NULL, 166680);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(166681, '3.30.160.60-FF-000818', NULL, 'zinc finger transcription factor YY1', 26, NULL, NULL, 166681),
(166682, '3.30.420.10-FF-000088', NULL, 'Ribonuclease', 185, NULL, NULL, 166682),
(166683, '2.60.40.10-FF-003511', NULL, NULL, 86, NULL, NULL, 166683),
(166684, '1.25.40.10-FF-000144', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 110, NULL, NULL, 166684),
(166685, '3.40.50.300-FF-007564', NULL, 'Predicted protein', 186, NULL, NULL, 166685),
(166686, '1.25.40.10-FF-001234', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 104, NULL, NULL, 166686),
(166687, '3.30.310.10-FF-000018', NULL, 'TATA-box-binding protein', 87, NULL, NULL, 166687),
(166688, '1.10.418.10-FF-000027', NULL, 'Probable fimbrin', 117, NULL, NULL, 166688),
(166689, '1.10.10.1210-FF-000003', NULL, 'Nse3p', 130, NULL, NULL, 166689),
(166690, '1.25.40.20-FF-000618', NULL, 'Ankyrin repeat protein', 95, NULL, NULL, 166690),
(166691, '3.60.40.10-FF-000316', NULL, 'Predicted protein', 217, NULL, NULL, 166691),
(166692, '3.40.50.10730-FF-000006', NULL, 'Urocanate hydratase 1', 117, NULL, NULL, 166692),
(166693, '1.20.1440.90-FF-000004', NULL, 'Phosphoenolpyruvate carboxylase', 121, NULL, NULL, 166693),
(166694, '3.30.470.20-FF-000139', NULL, '[Butirosin acyl-carrier protein]--L-glutamate ligase', 123, NULL, NULL, 166694),
(166695, '2.30.39.10-FF-000103', NULL, 'Protein CBG15466', 188, NULL, NULL, 166695),
(166696, '3.90.245.10-FF-000010', NULL, 'Inosine-uridine preferring nucleoside hydrolase', 311, NULL, NULL, 166696),
(166697, '3.90.55.10-FF-000006', NULL, 'Molybdopterin guanine dinucleotide-containing S/N-oxide reductase', 61, NULL, NULL, 166697),
(166698, '3.30.160.60-FF-005169', NULL, NULL, 74, NULL, NULL, 166698),
(166699, '3.90.1150.10-FF-000171', NULL, 'Possible 8-amino-7-oxononanoate synthase bioF2', 104, NULL, NULL, 166699),
(166700, '3.30.1360.70-FF-000010', NULL, 'Arginyl-tRNA synthetase, putative', 108, NULL, NULL, 166700),
(166701, '4.10.780.10-FF-000008', NULL, 'Pyruvate dehydrogenase [NADP(+)], mitochondrial', 39, NULL, NULL, 166701),
(166702, '3.10.180.10-FF-000034', NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 155, NULL, NULL, 166702),
(166703, '1.25.10.10-FF-002250', NULL, 'Importin subunit alpha', 372, NULL, NULL, 166703),
(166704, '1.10.287.110-FF-000073', NULL, 'DnaJ domain protein', 94, NULL, NULL, 166704),
(166705, '1.20.1070.10-FF-001750', NULL, 'Uncharacterized protein', 78, NULL, NULL, 166705),
(166706, '2.30.30.40-FF-000570', NULL, 'Protein csh3', 90, NULL, NULL, 166706),
(166707, '2.60.40.420-FF-000206', NULL, 'Uncharacterized protein', 45, NULL, NULL, 166707),
(166708, '2.30.29.30-FF-000496', NULL, 'Rho GTPase-activating protein', 103, NULL, NULL, 166708),
(166709, '2.130.10.10-FF-003899', NULL, 'Uncharacterized protein', 271, NULL, NULL, 166709),
(166710, '3.40.50.1460-FF-000031', NULL, 'Gingipain R2', 230, NULL, NULL, 166710),
(166711, '3.30.2020.30-FF-000001', NULL, 'fe-S cluster assembly factor HCF101, chloroplastic', 90, NULL, NULL, 166711),
(166712, '3.40.50.10140-FF-000043', NULL, 'Disease resistance protein CHS1', 158, NULL, NULL, 166712),
(166713, '3.40.50.1110-FF-000078', NULL, 'Secreted protein containing Lipase, GDSL domain protein', 212, NULL, NULL, 166713),
(166714, '3.10.105.10-FF-000001', NULL, 'Oligopeptide ABC transporter, oligopeptide-binding protein', 224, NULL, NULL, 166714),
(166715, '3.40.50.300-FF-003978', NULL, 'mRNA cleavage and polyadenylation factor clp1', 273, NULL, NULL, 166715),
(166716, '1.10.540.10-FF-000098', NULL, 'Uncharacterized protein', 127, NULL, NULL, 166716),
(166717, '3.30.450.40-FF-000043', NULL, 'Phosphodiesterase', 174, NULL, NULL, 166717),
(166718, '2.60.40.1180-FF-000139', NULL, 'Glycogen debranching enzyme (TreX)', 107, NULL, NULL, 166718),
(166719, '1.10.132.20-FF-000018', NULL, 'Ribosome-recycling factor, mitochondrial', 64, NULL, NULL, 166719),
(166720, '3.30.200.20-FF-002126', NULL, 'Uncharacterized protein', 73, NULL, NULL, 166720),
(166721, '2.130.10.10-FF-001235', NULL, 'Zinc finger CCCH domain-containing protein 48', 91, NULL, NULL, 166721);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(166722, '3.30.160.60-FF-006333', NULL, NULL, 72, NULL, NULL, 166722),
(166723, '1.10.8.60-FF-000178', NULL, 'CDC48/VCP homolog, AAA superfamily', 73, NULL, NULL, 166723),
(166724, '3.40.390.10-FF-000184', NULL, NULL, 105, NULL, NULL, 166724),
(166725, '3.40.630.10-FF-000220', NULL, 'Peptidase M20 domain-containing protein 2', 100, NULL, NULL, 166725),
(166726, '3.40.50.1000-FF-000606', NULL, NULL, 157, NULL, NULL, 166726),
(166727, '1.25.40.20-FF-000034', NULL, 'Diacylglycerol kinase', 144, NULL, NULL, 166727),
(166728, '3.30.200.20-FF-001406', NULL, NULL, 96, NULL, NULL, 166728),
(166729, '2.60.120.230-FF-000006', NULL, NULL, 145, NULL, NULL, 166729),
(166730, '1.10.1450.10-FF-000011', NULL, 'Tetraspanin', 112, NULL, NULL, 166730),
(166731, '3.40.50.1820-FF-001780', NULL, 'Protein phosphatase methylesterase 1', 178, NULL, NULL, 166731),
(166732, '3.40.50.12650-FF-000003', NULL, 'DNA cross-link repair 1B', 128, NULL, NULL, 166732),
(166733, '2.30.29.30-FF-000069', NULL, 'Intersectin 1', 148, NULL, NULL, 166733),
(166734, '3.40.1230.10-FF-000003', NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex assembly factor 3', 127, NULL, NULL, 166734),
(166735, '2.60.40.10-FF-001797', NULL, 'Frazzled, isoform C', 102, NULL, NULL, 166735),
(166736, '1.10.3260.10-FF-000014', NULL, 'Unplaced genomic scaffold supercont2.7, whole genome shotgun sequence', 299, NULL, NULL, 166736),
(166737, '2.60.490.10-FF-000005', NULL, 'C12orf76 isoform 1', 48, NULL, NULL, 166737),
(166738, '3.40.50.300-FF-000544', NULL, 'Protein ROOT HAIR DEFECTIVE 3 homolog', 230, NULL, NULL, 166738),
(166739, '1.25.40.90-FF-000111', NULL, 'Uncharacterized protein', 71, NULL, NULL, 166739),
(166740, '1.10.10.10-FF-001889', NULL, 'Lmo2004 protein', 76, NULL, NULL, 166740),
(166741, '1.10.437.10-FF-000049', NULL, 'Uncharacterized protein', 124, NULL, NULL, 166741),
(166742, '3.30.70.330-FF-002846', NULL, NULL, 84, NULL, NULL, 166742),
(166743, '3.40.50.300-FF-003669', NULL, 'Peroxisomal biogenesis factor 6', 72, NULL, NULL, 166743),
(166744, '1.20.1730.10-FF-000042', NULL, 'Uncharacterized protein', 519, NULL, NULL, 166744),
(166745, '1.25.10.10-FF-000316', NULL, 'Phospholipase A2-activating protein', 265, NULL, NULL, 166745),
(166746, '1.10.540.10-FF-000109', NULL, 'short-chain specific acyl-CoA dehydrogenase, mitochondrial isoform X1', 76, NULL, NULL, 166746),
(166747, '3.80.10.10-FF-001741', NULL, 'Uncharacterized protein, isoform A', 261, NULL, NULL, 166747),
(166748, '3.40.50.150-FF-001662', NULL, NULL, 187, NULL, NULL, 166748),
(166749, '2.60.40.10-FF-005265', NULL, NULL, 86, NULL, NULL, 166749),
(166750, '3.30.160.60-FF-003724', NULL, 'Zinc finger protein 77', 52, NULL, NULL, 166750),
(166751, '1.10.150.80-FF-000055', NULL, 'Uncharacterized protein', 85, NULL, NULL, 166751),
(166752, '1.10.1670.10-FF-000022', NULL, 'Adenine DNA glycosylase', 93, NULL, NULL, 166752),
(166753, '1.25.10.10-FF-001294', NULL, 'Uncharacterized protein', 970, NULL, NULL, 166753),
(166754, '3.40.50.12670-FF-000009', NULL, 'Serine carboxypeptidase-like 39', 150, NULL, NULL, 166754),
(166755, '3.40.190.100-FF-000002', NULL, 'Choline ABC transporter substrate-binding protein', 110, NULL, NULL, 166755),
(166756, '1.10.8.60-FF-000487', NULL, 'Transitional endoplasmic reticulum ATPase, putative', 96, NULL, NULL, 166756),
(166757, '3.40.50.300-FF-005687', NULL, 'Compact plant2', 182, NULL, NULL, 166757),
(166758, '2.60.120.330-FF-000109', NULL, 'Predicted protein', 333, NULL, NULL, 166758),
(166759, '2.130.10.10-FF-004888', NULL, 'Uncharacterized protein', 117, NULL, NULL, 166759),
(166760, '3.10.105.10-FF-000046', NULL, 'Putative oligopeptide-binding lipoprotein', 234, NULL, NULL, 166760),
(166761, '3.40.50.300-FF-000443', NULL, 'Peptide transport system ATP-binding protein SapD', 328, NULL, NULL, 166761),
(166762, '3.40.50.10090-FF-000005', NULL, 'Uroporphyrinogen-III synthase', 134, NULL, NULL, 166762),
(166763, '3.30.160.60-FF-002752', NULL, 'Zinc finger protein 589', 61, NULL, NULL, 166763),
(166764, '1.10.246.60-FF-000002', NULL, 'Eukaryotic translation initiation factor 3 subunit J', 77, NULL, NULL, 166764);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(166765, '2.60.40.10-FF-004337', NULL, NULL, 124, NULL, NULL, 166765),
(166766, '2.130.10.10-FF-000510', NULL, 'WD repeat protein', 313, NULL, NULL, 166766),
(166767, '3.40.50.1820-FF-001471', NULL, 'Uncharacterized protein', 175, NULL, NULL, 166767),
(166768, '1.25.40.420-FF-000043', NULL, 'BTB/POZ domain-containing protein 1-like', 103, NULL, NULL, 166768),
(166769, '1.10.532.10-FF-000006', NULL, 'Signal transducer and activator of transcription', 123, NULL, NULL, 166769),
(166770, '3.40.50.11840-FF-000002', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 2', 95, NULL, NULL, 166770),
(166771, '2.60.40.10-FF-000594', NULL, 'Hemicentin 1', 94, NULL, NULL, 166771),
(166772, '3.20.20.380-FF-000010', NULL, 'Copper homeostasis protein CutC, putative (JCVI)', 230, NULL, NULL, 166772),
(166773, '3.40.190.120-FF-000008', NULL, 'Osmoprotection protein (ProWX)', 104, NULL, NULL, 166773),
(166774, '1.10.630.10-FF-000644', NULL, 'Os03g0603100 protein', 211, NULL, NULL, 166774),
(166775, '2.60.40.10-FF-000605', NULL, 'Tyrosine-protein kinase receptor TYRO3', 99, NULL, NULL, 166775),
(166776, '2.60.40.10-FF-005849', NULL, NULL, 101, NULL, NULL, 166776),
(166777, '1.10.287.70-FF-000223', NULL, 'Ion channel/Calcium-activated BK potassium channel alpha subunit, putative', 126, NULL, NULL, 166777),
(166778, '3.10.450.50-FF-000022', NULL, 'Alcohol dehydrogenase 3', 153, NULL, NULL, 166778),
(166779, '3.30.710.10-FF-000335', NULL, 'Zinc finger protein 570-like Protein', 135, NULL, NULL, 166779),
(166780, '3.30.70.100-FF-000092', NULL, 'Uncharacterized protein', 120, NULL, NULL, 166780),
(166781, '3.30.70.330-FF-002493', NULL, NULL, 75, NULL, NULL, 166781),
(166782, '2.70.130.10-FF-000139', NULL, NULL, 146, NULL, NULL, 166782),
(166783, '1.10.530.10-FF-000024', NULL, 'C-type lysozyme', 122, NULL, NULL, 166783),
(166784, '2.60.120.330-FF-000048', NULL, '2OG-Fe(II) oxygenase superfamily, putative', 346, NULL, NULL, 166784),
(166785, '3.40.50.720-FF-002592', NULL, 'Putative malate dehydrogenase 1B-like Protein', 157, NULL, NULL, 166785),
(166786, '2.40.50.40-FF-000065', NULL, 'Protein CHROMATIN REMODELING 4', 51, NULL, NULL, 166786),
(166787, '2.10.230.10-FF-000014', NULL, 'CG7387 protein', 64, NULL, NULL, 166787),
(166788, '2.60.40.60-FF-000923', NULL, 'Uncharacterized protein', 62, NULL, NULL, 166788),
(166789, '1.20.58.390-FF-000161', NULL, 'Uncharacterized protein', 111, NULL, NULL, 166789),
(166790, '3.30.420.230-FF-000002', NULL, 'U5 snRNA-associated splicing factor', 163, NULL, NULL, 166790),
(166791, '3.10.100.10-FF-000142', NULL, 'C-type LECtin', 150, NULL, NULL, 166791),
(166792, '1.20.58.1980-FF-000001', NULL, 'Kinesin, putative', 122, NULL, NULL, 166792),
(166793, '1.10.287.70-FF-000532', NULL, 'Putative potassium channel subunit', 115, NULL, NULL, 166793),
(166794, '2.10.25.10-FF-000252', NULL, 'Crumbs homolog 1 (Drosophila)', 40, NULL, NULL, 166794),
(166795, '3.30.930.10-FF-000329', NULL, 'Uncharacterized protein', 141, NULL, NULL, 166795),
(166796, '1.10.510.10-FF-001698', NULL, 'NUAK family, SNF1-like kinase, 1b', 263, NULL, NULL, 166796),
(166797, '1.10.1240.10-FF-000001', NULL, 'Methionine synthase', 95, NULL, NULL, 166797),
(166798, '3.30.565.10-FF-000025', NULL, 'Aerobic respiration control sensor protein', 161, NULL, NULL, 166798),
(166799, '2.40.30.10-FF-000414', NULL, 'NADPH--cytochrome P450 reductase', 108, NULL, NULL, 166799),
(166800, '3.40.50.300-FF-004130', NULL, 'Uncharacterized protein', 169, NULL, NULL, 166800),
(166801, '3.30.160.60-FF-002651', NULL, 'zinc finger protein 597', 28, NULL, NULL, 166801),
(166802, '3.90.226.10-FF-000308', NULL, 'Uncharacterized protein', 107, NULL, NULL, 166802),
(166803, '3.20.10.10-FF-000052', NULL, '4-amino-4-deoxychorismate lyase', 154, NULL, NULL, 166803),
(166804, '3.40.50.1820-FF-000852', NULL, 'Clan SC, family S28, unassigned serine peptidase', 281, NULL, NULL, 166804),
(166805, '1.50.40.10-FF-000214', NULL, 'Mitochondrial carrier protein, putative', 353, NULL, NULL, 166805),
(166806, '1.25.40.10-FF-004668', NULL, 'Uncharacterized protein', 112, NULL, NULL, 166806);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(166807, '1.10.1410.10-FF-000048', NULL, 'HESO1', 176, NULL, NULL, 166807),
(166808, '3.30.160.60-FF-005377', NULL, NULL, 26, NULL, NULL, 166808),
(166809, '1.10.1200.10-FF-000139', NULL, '7-keto-8-aminopelargonate synthetase', 86, NULL, NULL, 166809),
(166810, '2.60.120.10-FF-000349', NULL, 'Homogentisate 1,2-dioxygenase', 141, NULL, NULL, 166810),
(166811, '2.130.10.10-FF-002163', NULL, 'ABC transporter A family member 7', 100, NULL, NULL, 166811),
(166812, '3.10.20.90-FF-000083', NULL, 'Trans-2,3-enoyl-CoA reductase b', 82, NULL, NULL, 166812),
(166813, '1.10.238.270-FF-000004', NULL, 'Odorant-binding protein 50e', 168, NULL, NULL, 166813),
(166814, '3.80.10.10-FF-001314', NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase At1g17230', 136, NULL, NULL, 166814),
(166815, '3.40.50.150-FF-000673', NULL, 'N5-glutamine methyltransferase, HemK family', 180, NULL, NULL, 166815),
(166816, '2.80.10.50-FF-000283', NULL, 'Uncharacterized protein', 31, NULL, NULL, 166816),
(166817, '3.40.640.10-FF-000254', NULL, 'Aspartate aminotransferase', 155, NULL, NULL, 166817),
(166818, '3.40.50.410-FF-000138', NULL, 'general transcription factor IIH subunit 3 isoform X2', 160, NULL, NULL, 166818),
(166819, '1.10.238.10-FF-000581', NULL, 'GD21233', 148, NULL, NULL, 166819),
(166820, '3.30.70.330-FF-001402', NULL, 'Terminal EAR1-like 1', 162, NULL, NULL, 166820),
(166821, '2.120.10.30-FF-000218', NULL, 'adipocyte plasma membrane-associated protein', 224, NULL, NULL, 166821),
(166822, '1.10.1000.11-FF-000007', NULL, 'Golgi-specific brefeldin A-resistance guanine nucleotide exchange factor 1', 125, NULL, NULL, 166822),
(166823, '1.20.5.650-FF-000003', NULL, 'Transcription factor IIIB, putative', 49, NULL, NULL, 166823),
(166824, '1.10.20.10-FF-000182', NULL, 'DRAP1 corepressor homolog', 95, NULL, NULL, 166824),
(166825, '3.40.50.300-FF-000752', NULL, 'ATP-dependent DNA helicase', 235, NULL, NULL, 166825),
(166826, '2.40.240.10-FF-000036', NULL, '50S ribosomal protein L25', 96, NULL, NULL, 166826),
(166827, '1.20.120.1750-FF-000103', NULL, 'RBR-type E3 ubiquitin transferase', 229, NULL, NULL, 166827),
(166828, '1.25.10.10-FF-000108', NULL, 'N-terminal kinase-like protein isoform X1', 278, NULL, NULL, 166828),
(166829, '3.30.1890.10-FF-000004', NULL, 'LPS O-antigen length regulator', 155, NULL, NULL, 166829),
(166830, '3.10.100.10-FF-000041', NULL, 'Asialoglycoprotein receptor 1', 141, NULL, NULL, 166830),
(166831, '3.30.450.20-FF-000492', NULL, 'Histidine kinase', 125, NULL, NULL, 166831),
(166832, '3.80.10.10-FF-004467', NULL, 'Phytosulfokine receptor 1', 67, NULL, NULL, 166832),
(166833, '1.25.40.20-FF-001546', NULL, 'Os09g0331600 protein', 117, NULL, NULL, 166833),
(166834, '2.120.10.80-FF-000110', NULL, 'Kelch domain-containing protein 8B', 141, NULL, NULL, 166834),
(166835, '1.20.58.390-FF-000222', NULL, 'Uncharacterized protein', 116, NULL, NULL, 166835),
(166836, '3.30.160.60-FF-005478', NULL, NULL, 56, NULL, NULL, 166836),
(166837, '1.20.140.10-FF-000099', NULL, 'Predicted protein', 107, NULL, NULL, 166837),
(166838, '1.20.5.170-FF-000207', NULL, 'Protein tipD', 67, NULL, NULL, 166838),
(166839, '3.50.50.60-FF-001187', NULL, 'Flavin-containing monooxygenase', 71, NULL, NULL, 166839),
(166840, '1.10.510.10-FF-000933', NULL, 'Mitogen-activated protein kinase kinase 10-2', 296, NULL, NULL, 166840),
(166841, '3.30.1330.30-FF-000087', NULL, 'Ribosomal protein L7Ae/L30e/S12e/Gadd45', 103, NULL, NULL, 166841),
(166842, '3.40.190.290-FF-000115', NULL, 'Transcriptional regulator', 205, NULL, NULL, 166842),
(166843, '3.40.80.10-FF-000027', NULL, 'Peptidoglycan-recognition protein SC2-like Protein', 168, NULL, NULL, 166843),
(166844, '3.20.20.190-FF-000088', NULL, 'Phospholipase D', 273, NULL, NULL, 166844),
(166845, '3.30.160.60-FF-003932', NULL, NULL, 27, NULL, NULL, 166845),
(166846, '3.40.50.300-FF-003169', NULL, 'GD14479', 183, NULL, NULL, 166846),
(166847, '1.10.472.80-FF-000275', NULL, NULL, 89, NULL, NULL, 166847),
(166848, '2.20.100.10-FF-000216', NULL, 'Spondin-1-like Protein', 91, NULL, NULL, 166848);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(166849, '3.20.20.80-FF-000669', NULL, 'Predicted protein', 380, NULL, NULL, 166849),
(166850, '3.40.50.300-FF-000235', NULL, 'ATPase ASNA1', 330, NULL, NULL, 166850),
(166851, '3.30.70.330-FF-001874', NULL, NULL, 100, NULL, NULL, 166851),
(166852, '1.50.40.10-FF-000552', NULL, 'Uncharacterized protein', 132, NULL, NULL, 166852),
(166853, '1.25.40.10-FF-000969', NULL, 'Chromosome 14 open reading frame 102', 180, NULL, NULL, 166853),
(166854, '3.40.630.30-FF-000175', NULL, 'Acetyltransferase, putative', 183, NULL, NULL, 166854),
(166855, '1.20.120.1080-FF-000104', NULL, 'DEAH-box helicase 34', 188, NULL, NULL, 166855),
(166856, '3.30.70.1230-FF-000257', NULL, '4-phytase', 176, NULL, NULL, 166856),
(166857, '3.30.70.1170-FF-000014', NULL, 'SAM-dependent tRNA/rRNA cytosine-C5 methylase', 101, NULL, NULL, 166857),
(166858, '1.20.5.2950-FF-000011', NULL, NULL, 93, NULL, NULL, 166858),
(166859, '1.20.1530.20-FF-000035', NULL, 'Uncharacterized protein', 291, NULL, NULL, 166859),
(166860, '3.40.50.1820-FF-001128', NULL, 'Dipeptidyl Peptidase Four (IV) family', 281, NULL, NULL, 166860),
(166861, '3.40.50.1240-FF-000066', NULL, 'Phosphoglycerate mutase-like protein 1', 248, NULL, NULL, 166861),
(166862, '3.30.70.330-FF-000784', NULL, 'Serine/arginine-rich SC35-like splicing factor SCL30A', 120, NULL, NULL, 166862),
(166863, '1.20.58.60-FF-000496', NULL, 'Guanine nucleotide exchange factor UNC-73B', 245, NULL, NULL, 166863),
(166864, '3.40.570.10-FF-000029', NULL, 'GM12731', 215, NULL, NULL, 166864),
(166865, '3.10.20.90-FF-000144', NULL, 'Ubiquitin-like protein 4A', 74, NULL, NULL, 166865),
(166866, '3.30.70.330-FF-000121', NULL, 'Splicing factor 3b subunit 4', 94, NULL, NULL, 166866),
(166867, '1.25.50.20-FF-000080', NULL, 'Aminopeptidase', 208, NULL, NULL, 166867),
(166868, '1.20.120.330-FF-000024', NULL, 'Inactive tyrosine-protein kinase kin-32', 141, NULL, NULL, 166868),
(166869, '3.90.226.10-FF-000090', NULL, 'Tail-specific protease', 241, NULL, NULL, 166869),
(166870, '2.130.10.10-FF-005389', NULL, 'Uncharacterized protein', 154, NULL, NULL, 166870),
(166871, '3.50.50.60-FF-000568', NULL, 'Paromamine 6''-oxidase', 143, NULL, NULL, 166871),
(166872, '1.25.40.20-FF-000927', NULL, 'F22M8.6 protein', 225, NULL, NULL, 166872),
(166873, '3.90.1410.10-FF-000118', NULL, 'Uncharacterized protein', 200, NULL, NULL, 166873),
(166874, '3.40.50.410-FF-000329', NULL, 'Uncharacterized protein', 179, NULL, NULL, 166874),
(166875, '3.30.70.330-FF-001301', NULL, 'Peroxisome proliferator-activated receptor gamma, coactivator-related 1', 169, NULL, NULL, 166875),
(166876, '3.30.1780.10-FF-000013', NULL, 'Homolog to ornithine cyclodeaminase', 125, NULL, NULL, 166876),
(166877, '1.20.1070.10-FF-001087', NULL, 'Allatostatin-A receptor', 321, NULL, NULL, 166877),
(166878, '1.25.10.10-FF-000889', NULL, 'HEAT repeat domain containing protein', 230, NULL, NULL, 166878),
(166879, '1.10.287.70-FF-000740', NULL, 'Uncharacterized protein', 102, NULL, NULL, 166879),
(166880, '1.10.20.10-FF-000226', NULL, NULL, 141, NULL, NULL, 166880),
(166881, '1.20.1070.10-FF-002003', NULL, 'Uncharacterized protein', 142, NULL, NULL, 166881),
(166882, '3.30.720.50-FF-000016', NULL, NULL, 76, NULL, NULL, 166882),
(166883, '1.10.560.10-FF-000009', NULL, 'T-complex protein 1 subunit gamma', 230, NULL, NULL, 166883),
(166884, '3.40.50.1000-FF-000236', NULL, 'Phosphoserine phosphatase', 242, NULL, NULL, 166884),
(166885, '3.40.250.10-FF-000134', NULL, 'Arsenate reductase', 127, NULL, NULL, 166885),
(166886, '1.20.58.1590-FF-000007', NULL, 'Tethering factor for nuclear proteasome STS1', 214, NULL, NULL, 166886),
(166887, '2.60.40.10-FF-001111', NULL, 'tyrosine-protein phosphatase Lar isoform X1', 103, NULL, NULL, 166887),
(166888, '3.40.50.150-FF-001398', NULL, NULL, 168, NULL, NULL, 166888),
(166889, '3.40.50.300-FF-002230', NULL, 'Multidrug ABC transporter ATP-binding protein', 235, NULL, NULL, 166889),
(166890, '2.70.150.10-FF-000040', NULL, 'Cation-transporting ATPase', 180, NULL, NULL, 166890),
(166891, '1.25.40.10-FF-003842', NULL, 'F18B13.21 protein', 118, NULL, NULL, 166891);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(166892, '1.10.220.160-FF-000015', NULL, 'SET domain-containing protein SmydA-8, isoform A', 77, NULL, NULL, 166892),
(166893, '1.10.10.60-FF-001224', NULL, NULL, 76, NULL, NULL, 166893),
(166894, '3.30.70.330-FF-002021', NULL, NULL, 108, NULL, NULL, 166894),
(166895, '2.70.170.10-FF-000001', NULL, 'Gamma-aminobutyric acid A receptor subunit alpha-2', 219, NULL, NULL, 166895),
(166896, '3.60.10.10-FF-000399', NULL, 'Predicted protein', 51, NULL, NULL, 166896),
(166897, '3.30.750.24-FF-000042', NULL, 'Anti-sigma factor antagonist', 107, NULL, NULL, 166897),
(166898, '3.40.50.800-FF-000132', NULL, 'Predicted protein', 71, NULL, NULL, 166898),
(166899, '3.30.160.100-FF-000010', NULL, 'Ribosomal subunit interface protein', 107, NULL, NULL, 166899),
(166900, '3.10.580.10-FF-000126', NULL, 'Chloride channel protein', 83, NULL, NULL, 166900),
(166901, '1.10.287.610-FF-000014', NULL, 'DNA ligase', 70, NULL, NULL, 166901),
(166902, '1.10.287.110-FF-000426', NULL, 'DnaJ-like protein', 89, NULL, NULL, 166902),
(166903, '3.40.50.720-FF-000658', NULL, 'Oxidoreductase, NAD-binding domain protein', 125, NULL, NULL, 166903),
(166904, '3.30.70.1230-FF-000043', NULL, 'Luxr family transcriptional regulator', 82, NULL, NULL, 166904),
(166905, '1.50.40.10-FF-000405', NULL, 'Solute carrier family 25 member 46', 230, NULL, NULL, 166905),
(166906, '1.20.120.1900-FF-000081', NULL, 'Gamma-tubulin complex component', 201, NULL, NULL, 166906),
(166907, '2.130.10.10-FF-004416', NULL, 'AGAP006359-PA', 367, NULL, NULL, 166907),
(166908, '2.130.10.10-FF-003444', NULL, 'AGAP000602-PA', 139, NULL, NULL, 166908),
(166909, '3.50.30.30-FF-000142', NULL, 'Uncharacterized protein', 109, NULL, NULL, 166909),
(166910, '1.20.1250.20-FF-000536', NULL, 'Monocarboxylate transporter', 186, NULL, NULL, 166910),
(166911, '2.20.70.10-FF-000007', NULL, 'E3 ubiquitin-protein ligase HECW2 isoform X1', 43, NULL, NULL, 166911),
(166912, '1.10.472.10-FF-000271', NULL, 'Cyclin', 191, NULL, NULL, 166912),
(166913, '1.20.1560.10-FF-000225', NULL, 'Type I secretion system permease/ATPase', 312, NULL, NULL, 166913),
(166914, '3.30.500.10-FF-000044', NULL, NULL, 177, NULL, NULL, 166914),
(166915, '3.30.2310.10-FF-000001', NULL, 'tRNA (N6-threonylcarbamoyladenosine(37)-N6)-methyltransferase TrmO', 91, NULL, NULL, 166915),
(166916, '3.10.129.10-FF-000005', NULL, 'Acyl-CoA thioesterase YciA', 130, NULL, NULL, 166916),
(166917, '3.30.1360.170-FF-000001', NULL, 'Flavin-dependent thymidylate synthase', 231, NULL, NULL, 166917),
(166918, '2.130.10.10-FF-002516', NULL, 'WD repeat domain 66', 292, NULL, NULL, 166918),
(166919, '3.40.50.720-FF-001378', NULL, 'Related to ERG27-3-keto sterol reductase', 319, NULL, NULL, 166919),
(166920, '1.20.1270.60-FF-000077', NULL, 'SH3 domain-containing protein 1', 224, NULL, NULL, 166920),
(166921, '1.20.58.340-FF-000062', NULL, 'Magnesium transporter MRS2-F', 88, NULL, NULL, 166921),
(166922, '3.80.10.10-FF-003995', NULL, 'NACHT, LRR and PYD domains-containing protein 3', 154, NULL, NULL, 166922),
(166923, '3.40.1370.10-FF-000030', NULL, 'Ribosomal protein L4 domain-containing protein', 230, NULL, NULL, 166923),
(166924, '1.10.730.10-FF-000045', NULL, 'Leucyl-tRNA synthetase', 120, NULL, NULL, 166924),
(166925, '3.30.710.10-FF-000099', NULL, 'BTB/POZ domain-containing protein POB1', 129, NULL, NULL, 166925),
(166926, '3.40.50.11500-FF-000029', NULL, NULL, 145, NULL, NULL, 166926),
(166927, '2.60.40.150-FF-000193', NULL, 'Phospholipase D delta', 148, NULL, NULL, 166927),
(166928, '6.10.140.2220-FF-000071', NULL, 'Predicted protein', 45, NULL, NULL, 166928),
(166929, '3.20.20.70-FF-000756', NULL, NULL, 60, NULL, NULL, 166929),
(166930, '1.10.287.210-FF-000001', NULL, 'Envelope glycoprotein gp160', 125, NULL, NULL, 166930),
(166931, '2.60.98.10-FF-000007', NULL, 'Genome polyprotein', 132, NULL, NULL, 166931),
(166932, '3.40.50.10480-FF-000015', NULL, 'Uncharacterized protein', 161, NULL, NULL, 166932),
(166933, '2.170.220.10-FF-000004', NULL, 'Methionine-tRNA ligase, putative', 115, NULL, NULL, 166933),
(166934, '2.60.40.10-FF-003011', NULL, 'Immunoglobulin heavy chain precursor', 106, NULL, NULL, 166934);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(166935, '3.40.50.2300-FF-000199', NULL, 'Vomeronasal 2, receptor 28', 269, NULL, NULL, 166935),
(166936, '1.20.1250.20-FF-001750', NULL, 'Major facilitator superfamily MFS_1', 195, NULL, NULL, 166936),
(166937, '2.30.30.40-FF-000143', NULL, 'Caspase recruitment domain family member 10', 102, NULL, NULL, 166937),
(166938, '3.30.2280.10-FF-000003', NULL, 'GSK3-beta interaction protein', 108, NULL, NULL, 166938),
(166939, '2.130.10.10-FF-003135', NULL, 'YALI0B09977p', 64, NULL, NULL, 166939),
(166940, '3.80.10.10-FF-001078', NULL, 'Protein phosphatase PP1 regulatory subunit sds22', 97, NULL, NULL, 166940),
(166941, '3.30.540.30-FF-000013', NULL, 'Dipeptidyl peptidase 3', 69, NULL, NULL, 166941),
(166942, '1.20.1250.20-FF-001042', NULL, 'Oligopeptide transporter-like protein', 128, NULL, NULL, 166942),
(166943, '3.30.420.10-FF-000190', NULL, 'Egalitarian, isoform B', 322, NULL, NULL, 166943),
(166944, '3.80.10.10-FF-003422', NULL, 'Cf2-like protein', 358, NULL, NULL, 166944),
(166945, '2.30.110.10-FF-000119', NULL, 'Predicted protein', 156, NULL, NULL, 166945),
(166946, '3.30.60.20-FF-000007', NULL, 'Serine/threonine-protein kinase', 60, NULL, NULL, 166946),
(166947, '3.30.160.60-FF-003005', NULL, 'Uncharacterized protein', 27, NULL, NULL, 166947),
(166948, '3.60.21.10-FF-000407', NULL, 'Uncharacterized protein', 297, NULL, NULL, 166948),
(166949, '2.10.220.10-FF-000087', NULL, 'High cysteine membrane protein TMK-like', 77, NULL, NULL, 166949),
(166950, '1.10.510.10-FF-002215', NULL, 'Tyrosine-protein kinase', 265, NULL, NULL, 166950),
(166951, '3.40.630.30-FF-000630', NULL, 'Uncharacterized protein', 180, NULL, NULL, 166951),
(166952, '3.30.160.60-FF-006142', NULL, NULL, 24, NULL, NULL, 166952),
(166953, '1.20.1310.10-FF-000050', NULL, 'Cullin-5', 135, NULL, NULL, 166953),
(166954, '3.30.40.10-FF-002268', NULL, 'Uncharacterized protein', 54, NULL, NULL, 166954),
(166955, '3.40.50.1000-FF-000500', NULL, NULL, 142, NULL, NULL, 166955),
(166956, '1.25.40.10-FF-005079', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 93, NULL, NULL, 166956),
(166957, '3.40.50.720-FF-000097', NULL, 'SDR family oxidoreductase', 292, NULL, NULL, 166957),
(166958, '3.30.930.10-FF-000273', NULL, 'Histidine--tRNA ligase', 325, NULL, NULL, 166958),
(166959, '2.20.25.590-FF-000001', NULL, 'Beta-microseminoprotein', 41, NULL, NULL, 166959),
(166960, '3.20.20.140-FF-000275', NULL, 'Adenosine deaminase', 343, NULL, NULL, 166960),
(166961, '3.60.20.10-FF-000017', NULL, 'Glucosamine-fructose-6-phosphate aminotransferase, isomerising', 256, NULL, NULL, 166961),
(166962, '3.40.30.10-FF-000333', NULL, 'Thioredoxin-like protein CDSP32, chloroplastic', 115, NULL, NULL, 166962),
(166963, '3.40.50.2300-FF-001525', NULL, NULL, 84, NULL, NULL, 166963),
(166964, '2.60.40.2170-FF-000009', NULL, 'Wnt inhibitory factor 1', 50, NULL, NULL, 166964),
(166965, '3.20.20.220-FF-000001', NULL, 'Methylenetetrahydrofolate reductase', 295, NULL, NULL, 166965),
(166966, '3.30.160.60-FF-003371', NULL, 'Zinc finger protein 700', 16, NULL, NULL, 166966),
(166967, '3.30.200.20-FF-001654', NULL, 'Uncharacterized protein', 87, NULL, NULL, 166967),
(166968, '3.40.50.300-FF-001724', NULL, 'Vacuolar membrane ATPase subunit a', 125, NULL, NULL, 166968),
(166969, '2.60.120.200-FF-000110', NULL, 'pentraxin-related protein PTX3', 202, NULL, NULL, 166969),
(166970, '2.30.30.100-FF-000188', NULL, 'Sm-like protein LSM3B isoform A', 66, NULL, NULL, 166970),
(166971, '3.30.160.60-FF-001471', NULL, 'Zinc finger protein 324A', 29, NULL, NULL, 166971),
(166972, '2.10.25.10-FF-001180', NULL, 'LP19846p', 46, NULL, NULL, 166972),
(166973, '2.60.40.1170-FF-000018', NULL, 'stonin-2 isoform X2', 63, NULL, NULL, 166973),
(166974, '1.20.1560.10-FF-000534', NULL, 'Uncharacterized protein', 350, NULL, NULL, 166974),
(166975, '3.20.20.240-FF-000007', NULL, 'Predicted protein', 222, NULL, NULL, 166975),
(166976, '3.30.2410.10-FF-000065', NULL, 'Uncharacterized protein', 62, NULL, NULL, 166976),
(166977, '2.60.40.10-FF-003584', NULL, NULL, 107, NULL, NULL, 166977);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(166978, '3.40.50.10490-FF-000108', NULL, NULL, 221, NULL, NULL, 166978),
(166979, '4.10.60.10-FF-000025', NULL, 'U11/U12 small nuclear ribonucleoprotein 31 kDa protein-like', 36, NULL, NULL, 166979),
(166980, '3.30.160.60-FF-004197', NULL, NULL, 28, NULL, NULL, 166980),
(166981, '3.30.1390.10-FF-000011', NULL, 'Uncharacterized protein', 87, NULL, NULL, 166981),
(166982, '2.70.130.10-FF-000038', NULL, 'Insulin-like growth factor 2 receptor', 150, NULL, NULL, 166982),
(166983, '1.20.5.190-FF-000056', NULL, 'Uncharacterized protein, isoform C', 47, NULL, NULL, 166983),
(166984, '1.10.510.10-FF-004424', NULL, NULL, 62, NULL, NULL, 166984),
(166985, '1.10.287.70-FF-000329', NULL, 'Uncoordinated protein 58', 314, NULL, NULL, 166985),
(166986, '3.30.160.60-FF-006097', NULL, NULL, 21, NULL, NULL, 166986),
(166987, '1.10.630.10-FF-000189', NULL, 'Phenylalanine N-monooxygenase', 112, NULL, NULL, 166987),
(166988, '2.30.29.30-FF-000732', NULL, 'Collagen type IV alpha-3-binding protein', 102, NULL, NULL, 166988),
(166989, '3.40.50.720-FF-001423', NULL, 'Fatty acid synthase subunit alpha', 143, NULL, NULL, 166989),
(166990, '2.130.10.30-FF-000156', NULL, NULL, 151, NULL, NULL, 166990),
(166991, '2.60.40.10-FF-003275', NULL, 'Hypothetical_protein_-_conserved', 106, NULL, NULL, 166991),
(166992, '3.90.190.10-FF-000359', NULL, 'PTP/DSP-like', 140, NULL, NULL, 166992),
(166993, '3.40.50.300-FF-006592', NULL, 'Uncharacterized protein', 98, NULL, NULL, 166993),
(166994, '3.30.420.10-FF-000751', NULL, NULL, 58, NULL, NULL, 166994),
(166995, '1.10.10.1770-FF-000002', NULL, 'Sll1380 protein', 80, NULL, NULL, 166995),
(166996, '2.60.40.60-FF-000968', NULL, 'Predicted protein', 45, NULL, NULL, 166996),
(166997, '1.25.40.10-FF-002206', NULL, 'Uncharacterized protein', 180, NULL, NULL, 166997),
(166998, '1.10.10.10-FF-001226', NULL, 'Transcriptional regulator, GntR family', 81, NULL, NULL, 166998),
(166999, '4.10.280.10-FF-000015', NULL, 'T-cell acute lymphocytic leukemia 1', 69, NULL, NULL, 166999),
(167000, '1.50.10.10-FF-000016', NULL, 'alpha-1,2-Mannosidase', 478, NULL, NULL, 167000),
(167001, '2.10.25.10-FF-001741', NULL, 'Uncharacterized protein', 38, NULL, NULL, 167001),
(167002, '3.30.65.10-FF-000009', NULL, 'DNA topoisomerase', 54, NULL, NULL, 167002),
(167003, '1.10.3720.10-FF-000050', NULL, 'Molybdenum transport system permease', 220, NULL, NULL, 167003),
(167004, '2.10.25.10-FF-001432', NULL, 'Serine protease P146', 49, NULL, NULL, 167004),
(167005, '3.40.190.10-FF-000764', NULL, 'Predicted protein', 162, NULL, NULL, 167005),
(167006, '1.10.472.10-FF-000052', NULL, 'cyclin-I isoform X1', 126, NULL, NULL, 167006),
(167007, '2.60.40.2150-FF-000003', NULL, 'Interleukin 17 receptor A1a', 98, NULL, NULL, 167007),
(167008, '1.10.510.10-FF-004115', NULL, NULL, 109, NULL, NULL, 167008),
(167009, '3.30.160.60-FF-003680', NULL, NULL, 28, NULL, NULL, 167009),
(167010, '3.40.190.10-FF-000056', NULL, 'Lactotransferrin', 163, NULL, NULL, 167010),
(167011, '3.30.2170.10-FF-000012', NULL, 'Probable dolichyl pyrophosphate Glc1Man9GlcNAc2 alpha-1,3-glucosyltransferase', 279, NULL, NULL, 167011),
(167012, '2.40.50.140-FF-000090', NULL, 'Replication protein A subunit', 187, NULL, NULL, 167012),
(167013, '3.30.70.270-FF-000097', NULL, 'Related to DNA polymerase eta', 68, NULL, NULL, 167013),
(167014, '1.10.3210.10-FF-000084', NULL, 'Uncharacterized protein', 237, NULL, NULL, 167014),
(167015, '3.30.980.10-FF-000012', NULL, 'Threonyl/alanyl tRNA synthetase', 162, NULL, NULL, 167015),
(167016, '2.120.10.80-FF-000008', NULL, 'host cell factor 1 isoform X1', 116, NULL, NULL, 167016),
(167017, '1.25.10.10-FF-002002', NULL, 'Uncharacterized protein', 229, NULL, NULL, 167017),
(167018, '3.30.565.10-FF-000008', NULL, 'Nitrogen regulation histidine kinase', 159, NULL, NULL, 167018),
(167019, '2.130.10.10-FF-002724', NULL, 'Putative WD-repeat family protein', 304, NULL, NULL, 167019),
(167020, '1.25.40.10-FF-002987', NULL, 'Pre-mRNA-splicing factor 6', 142, NULL, NULL, 167020),
(167021, '1.20.1730.10-FF-000126', NULL, 'Uncharacterized protein', 344, NULL, NULL, 167021);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(167022, '3.20.20.220-FF-000024', NULL, 'Methylenetetrahydrofolate reductase', 289, NULL, NULL, 167022),
(167023, '2.60.40.10-FF-003691', NULL, NULL, 83, NULL, NULL, 167023),
(167024, '3.30.70.330-FF-003116', NULL, NULL, 68, NULL, NULL, 167024),
(167025, '3.90.190.10-FF-000253', NULL, 'Map kinase phosphatase-M B1 isoform', 146, NULL, NULL, 167025),
(167026, '1.25.10.10-FF-001378', NULL, 'ARM repeat superfamily protein', 729, NULL, NULL, 167026),
(167027, '3.40.1090.10-FF-000104', NULL, 'Lysophospholipase', 390, NULL, NULL, 167027),
(167028, '3.40.190.10-FF-000848', NULL, 'ABC-type transport system substrate binding component', 94, NULL, NULL, 167028),
(167029, '3.90.550.50-FF-000141', NULL, 'Hexosyltransferase', 273, NULL, NULL, 167029),
(167030, '3.90.550.10-FF-000230', NULL, 'Uncharacterized protein', 51, NULL, NULL, 167030),
(167031, '3.40.50.720-FF-002148', NULL, 'F1F0-ATPase inhibitor protein', 89, NULL, NULL, 167031),
(167032, '2.40.100.10-FF-000009', NULL, 'Peptidyl-prolyl cis-trans isomerase D', 184, NULL, NULL, 167032),
(167033, '3.40.50.300-FF-006283', NULL, 'Spastin', 188, NULL, NULL, 167033),
(167034, '1.25.40.10-FF-002515', NULL, 'LD41803p', 194, NULL, NULL, 167034),
(167035, '2.10.110.10-FF-000298', NULL, 'LIM domain-containing protein F', 66, NULL, NULL, 167035),
(167036, '3.60.20.10-FF-000124', NULL, 'Proteasome endopeptidase complex', 157, NULL, NULL, 167036),
(167037, '3.40.30.10-FF-001160', NULL, 'Uncharacterized protein', 100, NULL, NULL, 167037),
(167038, '3.30.420.40-FF-000294', NULL, 'Actin-related protein 8', 41, NULL, NULL, 167038),
(167039, '1.10.510.10-FF-000517', NULL, 'Putative receptor kinase Lecrk', 206, NULL, NULL, 167039),
(167040, '2.70.130.10-FF-000111', NULL, NULL, 137, NULL, NULL, 167040),
(167041, '3.20.20.140-FF-000298', NULL, 'Blr5239 protein', 84, NULL, NULL, 167041),
(167042, '1.20.1270.10-FF-000079', NULL, 'Major heat shock 70 kDa protein Bbb', 108, NULL, NULL, 167042),
(167043, '3.30.559.10-FF-000067', NULL, 'Transferase family protein', 221, NULL, NULL, 167043),
(167044, '3.40.50.150-FF-000482', NULL, 'Probable S-adenosylmethionine-dependent methyltransferase CRG1', 287, NULL, NULL, 167044),
(167045, '3.20.20.60-FF-000118', NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase 1 mitochondrial', 90, NULL, NULL, 167045),
(167046, '1.10.8.10-FF-000174', NULL, 'Ubiquitin-associated (UBA)/TS-N domain-containing protein', 37, NULL, NULL, 167046),
(167047, '1.10.530.10-FF-000047', NULL, 'Predicted protein', 124, NULL, NULL, 167047),
(167048, '1.10.150.910-FF-000004', NULL, 'Pic', 96, NULL, NULL, 167048),
(167049, '1.20.1270.60-FF-000105', NULL, 'Ysp1p', 261, NULL, NULL, 167049),
(167050, '3.60.21.10-FF-000290', NULL, 'Uncharacterized protein', 164, NULL, NULL, 167050),
(167051, '2.160.20.10-FF-000296', NULL, 'Predicted protein', 163, NULL, NULL, 167051),
(167052, '3.40.630.30-FF-000198', NULL, 'Acyl-CoA N-acyltransferases (NAT) superfamily protein', 202, NULL, NULL, 167052),
(167053, '3.90.550.10-FF-000713', NULL, 'AFL235Wp', 267, NULL, NULL, 167053),
(167054, '3.30.70.1400-FF-000010', NULL, 'Protein CBG22093', 112, NULL, NULL, 167054),
(167055, '3.30.160.60-FF-000627', NULL, 'Zinc finger protein 341', 28, NULL, NULL, 167055),
(167056, '3.30.110.110-FF-000003', NULL, 'Double-strand break repair protein', 112, NULL, NULL, 167056),
(167057, '3.10.20.90-FF-000274', NULL, 'Tether containing UBX domain for GLUT4', 114, NULL, NULL, 167057),
(167058, '2.160.20.10-FF-000301', NULL, 'Cell surface protein', 109, NULL, NULL, 167058),
(167059, '2.170.270.10-FF-000215', NULL, 'AGAP003597-PA', 268, NULL, NULL, 167059),
(167060, '3.40.30.10-FF-000547', NULL, 'Putative glutathione S-transferase', 83, NULL, NULL, 167060),
(167061, '3.40.50.2300-FF-001396', NULL, NULL, 124, NULL, NULL, 167061),
(167062, '1.20.5.500-FF-000014', NULL, NULL, 90, NULL, NULL, 167062),
(167063, '2.170.150.80-FF-000031', NULL, 'At1g19040', 74, NULL, NULL, 167063),
(167064, '3.40.367.20-FF-000043', NULL, 'Hexokinase', 231, NULL, NULL, 167064),
(167065, '1.20.1600.10-FF-000044', NULL, 'TolC family protein', 396, NULL, NULL, 167065);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(167066, '3.30.70.330-FF-000368', NULL, 'EWS RNA binding protein 1', 166, NULL, NULL, 167066),
(167067, '3.30.1540.20-FF-000021', NULL, NULL, 36, NULL, NULL, 167067),
(167068, '3.10.20.90-FF-000167', NULL, 'Ubiquitin-like 3a', 97, NULL, NULL, 167068),
(167069, '2.60.60.20-FF-000042', NULL, NULL, 117, NULL, NULL, 167069),
(167070, '3.30.200.20-FF-000125', NULL, 'Protein STRUBBELIG-RECEPTOR FAMILY 8', 113, NULL, NULL, 167070),
(167071, '1.25.10.10-FF-001485', NULL, 'Condensin-2 complex subunit D3', 165, NULL, NULL, 167071),
(167072, '3.90.226.10-FF-000224', NULL, 'Methylglutaconyl-CoA hydratase', 255, NULL, NULL, 167072),
(167073, '3.50.50.60-FF-001512', NULL, 'Uncharacterized protein', 142, NULL, NULL, 167073),
(167074, '3.20.20.40-FF-000005', NULL, 'uncharacterized protein LOC100181482', 374, NULL, NULL, 167074),
(167075, '1.10.720.30-FF-000073', NULL, 'ATP-dependent DNA helicase ku70', 49, NULL, NULL, 167075),
(167076, '1.10.540.10-FF-000126', NULL, 'Acyl-CoA dehydrogenase', 121, NULL, NULL, 167076),
(167077, '3.30.9.10-FF-000161', NULL, 'Glycerol-3-phosphate dehydrogenase', 61, NULL, NULL, 167077),
(167078, '2.60.120.200-FF-000346', NULL, 'Apical endosomal glycoprotein', 154, NULL, NULL, 167078),
(167079, '2.60.40.10-FF-005826', NULL, NULL, 44, NULL, NULL, 167079),
(167080, '1.10.8.270-FF-000127', NULL, 'Uncharacterized protein', 108, NULL, NULL, 167080),
(167081, '3.30.40.10-FF-000823', NULL, 'E3 ubiquitin-protein ligase', 100, NULL, NULL, 167081),
(167082, '3.40.1360.10-FF-000001', NULL, 'Recombination protein RecR', 95, NULL, NULL, 167082),
(167083, '1.20.1560.10-FF-000326', NULL, 'ATP-binding cassette protein subfamily D, member 3', 340, NULL, NULL, 167083),
(167084, '1.10.437.10-FF-000021', NULL, 'Apoptosis regulator BHRF1', 160, NULL, NULL, 167084),
(167085, '3.40.30.10-FF-000541', NULL, 'Protein disulfide-isomerase', 134, NULL, NULL, 167085),
(167086, '3.40.50.2300-FF-001609', NULL, NULL, 60, NULL, NULL, 167086),
(167087, '3.40.50.1820-FF-001336', NULL, 'GH06241p', 251, NULL, NULL, 167087),
(167088, '1.10.565.10-FF-000060', NULL, 'Nuclear hormone receptor family member nhr-8', 229, NULL, NULL, 167088),
(167089, '3.40.1380.10-FF-000014', NULL, 'ATP synthase gamma chain', 129, NULL, NULL, 167089),
(167090, '1.20.1070.10-FF-001407', NULL, 'G-protein coupled receptor, putative', 234, NULL, NULL, 167090),
(167091, '2.60.200.30-FF-000041', NULL, 'Predicted protein', 140, NULL, NULL, 167091),
(167092, '3.40.50.300-FF-005664', NULL, 'Uncharacterized protein', 310, NULL, NULL, 167092),
(167093, '3.40.630.10-FF-000192', NULL, 'Succinyl-diaminopimelate desuccinylase', 118, NULL, NULL, 167093),
(167094, '3.30.70.100-FF-000198', NULL, NULL, 109, NULL, NULL, 167094),
(167095, '1.25.40.10-FF-003134', NULL, 'Interferon-induced protein with tetratricopeptide repeats 1', 53, NULL, NULL, 167095),
(167096, '3.40.1360.10-FF-000007', NULL, 'DNA primase', 124, NULL, NULL, 167096),
(167097, '1.10.1420.10-FF-000122', NULL, 'AGAP002642-PA', 223, NULL, NULL, 167097),
(167098, '3.80.10.10-FF-002359', NULL, 'Uncharacterized protein', 110, NULL, NULL, 167098),
(167099, '3.10.129.110-FF-000009', NULL, 'Probable polyketide synthase 2', 285, NULL, NULL, 167099),
(167100, '3.40.50.2300-FF-000305', NULL, 'Putative Two-component transcriptional regulator', 81, NULL, NULL, 167100),
(167101, '3.40.50.300-FF-001488', NULL, 'Putative helicase CHR10', 320, NULL, NULL, 167101),
(167102, '3.90.1100.10-FF-000044', NULL, 'DNA-directed RNA polymerase subunit beta', 360, NULL, NULL, 167102),
(167103, '1.20.1070.10-FF-001514', NULL, 'Melanocortin 1 receptor protein', 194, NULL, NULL, 167103),
(167104, '1.10.510.10-FF-000141', NULL, 'Non-specific serine/threonine protein kinase', 69, NULL, NULL, 167104),
(167105, '3.40.350.10-FF-000035', NULL, 'Aminopeptidase P, putative', 171, NULL, NULL, 167105),
(167106, '2.60.120.260-FF-000420', NULL, 'Probable cytochrome c', 123, NULL, NULL, 167106),
(167107, '1.20.120.350-FF-000047', NULL, 'Uncharacterized protein, isoform C', 164, NULL, NULL, 167107),
(167108, '1.10.510.10-FF-004323', NULL, NULL, 144, NULL, NULL, 167108);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(167109, '2.60.40.1130-FF-000001', NULL, 'Geranylgeranyl transferase type-2 subunit alpha', 103, NULL, NULL, 167109),
(167110, '2.70.98.30-FF-000007', NULL, 'Alpha-mannosidase', 278, NULL, NULL, 167110),
(167111, '1.20.58.670-FF-000003', NULL, 'RAD50-interacting protein 1', 125, NULL, NULL, 167111),
(167112, '1.10.510.10-FF-003699', NULL, NULL, 165, NULL, NULL, 167112),
(167113, '1.10.3110.10-FF-000003', NULL, 'Protoporphyrinogen oxidase', 107, NULL, NULL, 167113),
(167114, '1.10.630.10-FF-000088', NULL, 'Cytochrome P450 monooxygenase', 497, NULL, NULL, 167114),
(167115, '2.30.110.10-FF-000113', NULL, 'Uncharacterized protein', 183, NULL, NULL, 167115),
(167116, '3.30.56.70-FF-000001', NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', 59, NULL, NULL, 167116),
(167117, '1.10.510.10-FF-000034', NULL, 'Tyrosine-protein kinase receptor', 206, NULL, NULL, 167117),
(167118, '1.25.10.10-FF-003430', NULL, 'Uncharacterized protein', 327, NULL, NULL, 167118),
(167119, '3.20.20.70-FF-000447', NULL, 'N-(5''-phosphoribosyl)anthranilate isomerase', 214, NULL, NULL, 167119),
(167120, '3.80.10.10-FF-003894', NULL, 'Uncharacterized protein', 138, NULL, NULL, 167120),
(167121, '2.40.50.140-FF-000707', NULL, NULL, 134, NULL, NULL, 167121),
(167122, '3.40.50.10310-FF-000010', NULL, 'Creatinine amidohydrolase superfamily protein', 235, NULL, NULL, 167122),
(167123, '1.20.1070.10-FF-001194', NULL, 'Predicted protein', 97, NULL, NULL, 167123),
(167124, '1.10.506.10-FF-000047', NULL, 'Uncharacterized protein', 233, NULL, NULL, 167124),
(167125, '3.30.40.10-FF-001756', NULL, 'Ubiquitinyl hydrolase 1', 123, NULL, NULL, 167125),
(167126, '2.60.40.640-FF-000008', NULL, 'Down syndrome critical region protein 3', 134, NULL, NULL, 167126),
(167127, '3.40.850.10-FF-000186', NULL, 'Kinesin-like protein', 354, NULL, NULL, 167127),
(167128, '3.40.1110.10-FF-000281', NULL, NULL, 120, NULL, NULL, 167128),
(167129, '3.40.50.300-FF-001825', NULL, 'Bifunctional adenosylcobalamin biosynthesis protein', 168, NULL, NULL, 167129),
(167130, '2.130.10.10-FF-002410', NULL, 'Flagellar associated protein', 130, NULL, NULL, 167130),
(167131, '3.30.930.10-FF-000082', NULL, 'Phenylalanine--tRNA ligase chloroplastic/mitochondrial', 156, NULL, NULL, 167131),
(167132, '3.30.390.10-FF-000012', NULL, 'Mandelate racemase/muconate lactonizing protein', 107, NULL, NULL, 167132),
(167133, '2.10.25.10-FF-000549', NULL, 'Vitamin K-dependent protein C', 52, NULL, NULL, 167133),
(167134, '3.80.10.10-FF-001505', NULL, 'F-box/LRR-repeat protein 14', 107, NULL, NULL, 167134),
(167135, '1.20.120.330-FF-000041', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 137, NULL, NULL, 167135),
(167136, '3.40.50.620-FF-000538', NULL, 'Putative tRNA 2-thiolation protein', 319, NULL, NULL, 167136),
(167137, '3.30.200.20-FF-001429', NULL, 'Receptor protein serine/threonine kinase', 113, NULL, NULL, 167137),
(167138, '3.30.2350.20-FF-000012', NULL, 'Putative tRNA pseudouridine synthase D', 196, NULL, NULL, 167138),
(167139, '3.30.505.10-FF-000151', NULL, NULL, 113, NULL, NULL, 167139),
(167140, '1.10.230.10-FF-000007', NULL, 'Citrate synthase', 101, NULL, NULL, 167140),
(167141, '1.25.40.10-FF-001689', NULL, 'RNA polymerase-associated protein CTR9', 308, NULL, NULL, 167141),
(167142, '3.90.550.10-FF-000606', NULL, 'Uncharacterized protein', 218, NULL, NULL, 167142),
(167143, '1.10.510.10-FF-002395', NULL, NULL, 233, NULL, NULL, 167143),
(167144, '3.60.15.10-FF-000230', NULL, 'Metallo-beta-lactamase fold-containing protein ST1585', 261, NULL, NULL, 167144),
(167145, '3.90.25.10-FF-000061', NULL, 'GDP-L-fucose synthetase, putative', 69, NULL, NULL, 167145),
(167146, '1.10.287.340-FF-000001', NULL, 'Phosphoprotein', 52, NULL, NULL, 167146),
(167147, '2.40.10.10-FF-000284', NULL, 'Serine protease', 102, NULL, NULL, 167147),
(167148, '3.90.190.10-FF-000623', NULL, 'Uncharacterized protein', 57, NULL, NULL, 167148),
(167149, '3.40.50.150-FF-000802', NULL, NULL, 28, NULL, NULL, 167149),
(167150, '3.40.50.2300-FF-001289', NULL, NULL, 146, NULL, NULL, 167150);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(167151, '3.90.640.10-FF-000035', NULL, 'Actin-related protein 8', 104, NULL, NULL, 167151),
(167152, '1.25.40.10-FF-003943', NULL, 'Pentatricopeptide repeat (PPR) superfamily protein', 277, NULL, NULL, 167152),
(167153, '1.20.1270.60-FF-000324', NULL, 'Uncharacterized protein', 91, NULL, NULL, 167153),
(167154, '3.40.50.1400-FF-000018', NULL, 'Ferrochelatase', 181, NULL, NULL, 167154),
(167155, '2.40.30.270-FF-000023', NULL, 'Immunoglobulin mu DNA-binding protein 2', 53, NULL, NULL, 167155),
(167156, '2.30.29.30-FF-001261', NULL, 'Putative histone-arginine methyltransferase CARMER-like Protein', 104, NULL, NULL, 167156),
(167157, '3.30.870.10-FF-000122', NULL, 'Phospholipase D/Transphosphatidylase', 147, NULL, NULL, 167157),
(167158, '3.40.1800.20-FF-000033', NULL, NULL, 70, NULL, NULL, 167158),
(167159, '1.25.10.10-FF-003306', NULL, 'Uncharacterized protein', 167, NULL, NULL, 167159),
(167160, '3.30.1380.20-FF-000042', NULL, 'Trafficking protein particle complex subunit', 171, NULL, NULL, 167160),
(167161, '2.130.10.10-FF-001426', NULL, 'Sema domain, immunoglobulin domain (Ig), short basic domain, secreted, (semaphorin) 3E', 493, NULL, NULL, 167161),
(167162, '3.80.10.10-FF-001494', NULL, 'Uncharacterized protein', 105, NULL, NULL, 167162),
(167163, '3.30.160.60-FF-001246', NULL, 'Zinc finger protein 446', 32, NULL, NULL, 167163),
(167164, '1.20.1070.10-FF-000098', NULL, 'Sphingosine 1-phosphate receptor 1', 311, NULL, NULL, 167164),
(167165, '1.10.238.10-FF-000345', NULL, 'Mechanosensitive ion channel protein', 113, NULL, NULL, 167165),
(167166, '3.40.50.360-FF-000062', NULL, 'NAD(P)H quinone oxidoreductase', 231, NULL, NULL, 167166),
(167167, '1.10.630.10-FF-000425', NULL, 'Cytochrome P450, putative', 55, NULL, NULL, 167167),
(167168, '4.10.1000.40-FF-000018', NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', 45, NULL, NULL, 167168),
(167169, '1.20.120.1760-FF-000016', NULL, 'ethanolaminephosphotransferase 1', 223, NULL, NULL, 167169),
(167170, '2.60.120.10-FF-000135', NULL, 'Neuropathy target esterase sws', 142, NULL, NULL, 167170),
(167171, '3.40.50.300-FF-002444', NULL, 'DEAD/DEAH box ATP-dependent RNA helicase, putative', 121, NULL, NULL, 167171),
(167172, '2.10.110.10-FF-000303', NULL, 'Zyxin', 51, NULL, NULL, 167172),
(167173, '2.60.40.60-FF-000367', NULL, 'Protocadherin 1', 59, NULL, NULL, 167173),
(167174, '3.40.50.300-FF-002814', NULL, 'Translation factor GUF1, mitochondrial', 219, NULL, NULL, 167174),
(167175, '1.25.40.10-FF-002622', NULL, 'Pentatricopeptide repeat-containing protein At4g39952, mitochondrial', 99, NULL, NULL, 167175),
(167176, '3.30.40.10-FF-002375', NULL, 'PHD finger protein-like protein', 52, NULL, NULL, 167176),
(167177, '1.10.8.720-FF-000077', NULL, 'Dynein heavy chain 3', 101, NULL, NULL, 167177),
(167178, '2.60.40.10-FF-003848', NULL, NULL, 94, NULL, NULL, 167178),
(167179, '3.30.450.20-FF-000273', NULL, 'Uncharacterized protein', 112, NULL, NULL, 167179),
(167180, '2.60.40.10-FF-000285', NULL, 'Hemicentin 1', 93, NULL, NULL, 167180),
(167181, '2.40.170.20-FF-000056', NULL, 'Ferrioxamine receptor FoxA', 530, NULL, NULL, 167181),
(167182, '2.10.25.10-FF-001168', NULL, 'Uncharacterized protein', 36, NULL, NULL, 167182),
(167183, '3.30.420.10-FF-000335', NULL, 'Pro-Pol polyprotein', 163, NULL, NULL, 167183),
(167184, '1.20.1070.10-FF-000103', NULL, 'Muscarinic acetylcholine receptor', 127, NULL, NULL, 167184),
(167185, '3.40.190.10-FF-000539', NULL, 'Glutamate receptor', 37, NULL, NULL, 167185),
(167186, '3.40.190.10-FF-000163', NULL, 'Glutamate ionotropic receptor NMDA type subunit 3B', 136, NULL, NULL, 167186),
(167187, '3.40.50.300-FF-006176', NULL, 'Uncharacterized protein', 106, NULL, NULL, 167187),
(167188, '3.30.50.10-FF-000088', NULL, 'Nuclear receptor', 95, NULL, NULL, 167188),
(167189, '3.90.120.10-FF-000001', NULL, 'DNA (cytosine-5)-methyltransferase', 188, NULL, NULL, 167189),
(167190, '1.25.10.10-FF-001980', NULL, 'YALI0E33774p', 154, NULL, NULL, 167190),
(167191, '1.10.1410.10-FF-000020', NULL, 'U3 small nucleolar RNA-associated protein 22', 47, NULL, NULL, 167191);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(167192, '3.40.50.720-FF-000759', NULL, 'Thiamine biosynthesis protein ThiF', 269, NULL, NULL, 167192),
(167193, '3.40.50.720-FF-001159', NULL, 'Polyketide synthase RzxD', 424, NULL, NULL, 167193),
(167194, '2.30.30.100-FF-000082', NULL, 'U6 snRNA-associated Sm-like protein LSm3', 89, NULL, NULL, 167194),
(167195, '3.40.50.300-FF-001269', NULL, 'SNF2 family helicase/ATPase', 248, NULL, NULL, 167195),
(167196, '1.20.920.10-FF-000046', NULL, 'Histone acetyltransferase GCN5', 118, NULL, NULL, 167196),
(167197, '2.60.40.10-FF-002067', NULL, 'Myosin light chain kinase isoform-II', 90, NULL, NULL, 167197),
(167198, '3.30.160.60-FF-002191', NULL, 'Hamlet, isoform B', 25, NULL, NULL, 167198),
(167199, '3.30.230.70-FF-000030', NULL, 'Exosome complex component RRP42', 263, NULL, NULL, 167199),
(167200, '1.10.510.10-FF-001922', NULL, 'Protein kinase, putative', 101, NULL, NULL, 167200),
(167201, '2.70.150.10-FF-000124', NULL, 'Phospholipid-transporting ATPase', 126, NULL, NULL, 167201),
(167202, '2.30.40.10-FF-000073', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 80, NULL, NULL, 167202),
(167203, '3.30.420.40-FF-000187', NULL, 'Actin-related protein 6', 59, NULL, NULL, 167203),
(167204, '3.30.40.10-FF-000014', NULL, 'probable E3 ubiquitin-protein ligase MID2', 102, NULL, NULL, 167204),
(167205, '1.20.120.1760-FF-000010', NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', 190, NULL, NULL, 167205),
(167206, '3.40.50.10330-FF-000010', NULL, 'NAD kinase', 85, NULL, NULL, 167206),
(167207, '1.10.630.10-FF-000453', NULL, 'Cytochrome P450, family 705, subfamily A, polypeptide 28', 327, NULL, NULL, 167207),
(167208, '3.90.1420.10-FF-000063', NULL, 'Uncharacterized protein', 130, NULL, NULL, 167208),
(167209, '2.130.10.10-FF-001454', NULL, 'WD repeat domain phosphoinositide-interacting protein', 203, NULL, NULL, 167209),
(167210, '1.20.1070.10-FF-001879', NULL, 'Uncharacterized protein', 344, NULL, NULL, 167210),
(167211, '1.10.510.10-FF-003704', NULL, NULL, 164, NULL, NULL, 167211),
(167212, '2.10.90.10-FF-000094', NULL, 'Transforming growth factor beta', 65, NULL, NULL, 167212),
(167213, '2.130.10.10-FF-005597', NULL, 'Peptidyl-prolyl cis-trans isomerase 9', 194, NULL, NULL, 167213),
(167214, '3.30.450.20-FF-000149', NULL, 'Peroxide stress-activated histidine kinase mak1', 113, NULL, NULL, 167214),
(167215, '3.30.420.10-FF-000644', NULL, NULL, 139, NULL, NULL, 167215),
(167216, '1.20.1250.20-FF-001834', NULL, 'Glucose transport protein, putative', 142, NULL, NULL, 167216),
(167217, '2.40.70.10-FF-000299', NULL, NULL, 192, NULL, NULL, 167217),
(167218, '3.40.50.2000-FF-000805', NULL, 'Uncharacterized protein', 297, NULL, NULL, 167218),
(167219, '1.25.40.10-FF-001998', NULL, 'Os06g0493801 protein', 151, NULL, NULL, 167219),
(167220, '3.30.70.1230-FF-000251', NULL, 'Uncharacterized protein', 194, NULL, NULL, 167220),
(167221, '1.25.10.10-FF-002811', NULL, 'Uncharacterized protein', 200, NULL, NULL, 167221),
(167222, '3.30.160.60-FF-002988', NULL, 'RCG45242, isoform CRA_a', 28, NULL, NULL, 167222),
(167223, '3.40.50.1820-FF-001555', NULL, 'Uncharacterized protein', 122, NULL, NULL, 167223),
(167224, '3.40.640.10-FF-000501', NULL, 'Kynurenine aminotransferase, putative', 112, NULL, NULL, 167224),
(167225, '3.60.40.10-FF-000007', NULL, 'Phosphatase 2C and cyclic nucleotide-binding/kinase domain-containing protein', 298, NULL, NULL, 167225),
(167226, '3.40.50.300-FF-006159', NULL, 'Uncharacterized protein', 54, NULL, NULL, 167226),
(167227, '2.60.120.200-FF-000329', NULL, 'laminin subunit alpha', 184, NULL, NULL, 167227),
(167228, '1.20.1250.20-FF-001306', NULL, 'Major facilitator superfamily protein', 214, NULL, NULL, 167228),
(167229, '1.10.10.440-FF-000013', NULL, 'pre-mRNA-processing protein 40A isoform X1', 56, NULL, NULL, 167229),
(167230, '1.10.565.10-FF-000065', NULL, 'Nuclear hormone receptor family member nhr-91', 229, NULL, NULL, 167230),
(167231, '3.30.70.141-FF-000048', NULL, NULL, 49, NULL, NULL, 167231),
(167232, '3.40.50.200-FF-000076', NULL, 'Uncharacterized protein', 59, NULL, NULL, 167232);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(167233, '1.20.58.60-FF-000069', NULL, 'dystonin isoform X2', 114, NULL, NULL, 167233),
(167234, '2.30.180.10-FF-000146', NULL, NULL, 87, NULL, NULL, 167234),
(167235, '3.30.1010.10-FF-000051', NULL, 'Phosphatidylinositol 4-kinase alpha', 70, NULL, NULL, 167235),
(167236, '1.20.58.630-FF-000002', NULL, 'Diaphanous, isoform D', 107, NULL, NULL, 167236),
(167237, '2.30.30.40-FF-000351', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', 66, NULL, NULL, 167237),
(167238, '3.40.30.10-FF-000232', NULL, 'Endoplasmic reticulum resident protein 27', 129, NULL, NULL, 167238),
(167239, '2.130.10.10-FF-003360', NULL, 'Predicted protein', 216, NULL, NULL, 167239),
(167240, '2.60.120.780-FF-000014', NULL, 'SUMO ligase', 155, NULL, NULL, 167240),
(167241, '4.10.1000.10-FF-000155', NULL, 'Uncharacterized protein', 70, NULL, NULL, 167241),
(167242, '3.40.50.10420-FF-000043', NULL, '5-formyltetrahydrofolate cyclo-ligase', 144, NULL, NULL, 167242),
(167243, '3.40.50.850-FF-000006', NULL, 'Bifunctional pyrazinamidase/nicotinamidase', 206, NULL, NULL, 167243),
(167244, '2.130.10.10-FF-004208', NULL, 'Uncharacterized protein', 155, NULL, NULL, 167244),
(167245, '2.60.120.330-FF-000149', NULL, '2-oxoglutarate (2OG) and Fe(II)-dependent oxygenase superfamily protein', 270, NULL, NULL, 167245),
(167246, '3.30.710.10-FF-000419', NULL, 'Leucine-zipper-like transcription regulator 1', 116, NULL, NULL, 167246),
(167247, '3.40.50.12550-FF-000013', NULL, 'Os12g0105975 protein', 94, NULL, NULL, 167247),
(167248, '3.30.450.40-FF-000026', NULL, 'Ethylene response sensor', 173, NULL, NULL, 167248),
(167249, '1.20.1250.20-FF-000452', NULL, 'sialin-like isoform X1', 197, NULL, NULL, 167249),
(167250, '1.20.58.60-FF-000597', NULL, 'Microtubule actin crosslinking factor 1a', 163, NULL, NULL, 167250),
(167251, '1.20.5.110-FF-000004', NULL, 'Vesicle-associated membrane protein 7', 86, NULL, NULL, 167251),
(167252, '2.60.120.200-FF-000565', NULL, 'Uncharacterized protein', 195, NULL, NULL, 167252),
(167253, '3.60.120.10-FF-000019', NULL, 'Isochorismate synthase MenF', 468, NULL, NULL, 167253),
(167254, '2.60.40.10-FF-006029', NULL, NULL, 72, NULL, NULL, 167254),
(167255, '3.30.160.60-FF-002196', NULL, 'zinc finger protein 850-like isoform X3', 29, NULL, NULL, 167255),
(167256, '1.10.533.10-FF-000177', NULL, 'CARD domain-containing protein E10', 114, NULL, NULL, 167256),
(167257, '2.70.150.10-FF-000141', NULL, 'Putative calcium-transporting ATPase', 171, NULL, NULL, 167257),
(167258, '1.25.10.10-FF-001850', NULL, 'Integrator complex subunit 4-like Protein', 244, NULL, NULL, 167258),
(167259, '2.60.40.10-FF-002106', NULL, 'Soluble VEGFR3 variant 2', 69, NULL, NULL, 167259),
(167260, '1.20.1250.20-FF-000980', NULL, 'AGAP003684-PA', 413, NULL, NULL, 167260),
(167261, '3.30.200.20-FF-001053', NULL, 'Non-specific serine/threonine protein kinase', 98, NULL, NULL, 167261),
(167262, '3.30.2130.30-FF-000021', NULL, 'THUMP domain-containing 3', 71, NULL, NULL, 167262),
(167263, '4.10.1110.10-FF-000012', NULL, 'DNA-binding protein SMUBP-2', 63, NULL, NULL, 167263),
(167264, '3.30.70.330-FF-001773', NULL, NULL, 147, NULL, NULL, 167264),
(167265, '3.40.50.1820-FF-001027', NULL, 'Dihydrofolate reductase (AFU_orthologue AFUA_3G06620)', 184, NULL, NULL, 167265),
(167266, '3.40.50.620-FF-000319', NULL, 'Putative transcriptional regulatory protein NadR', 150, NULL, NULL, 167266),
(167267, '1.10.238.10-FF-000564', NULL, 'Calmodulin-like protein 1', 101, NULL, NULL, 167267),
(167268, '2.20.25.10-FF-000055', NULL, 'DNA-direcetd RNA polymerase II, subunit 9, putative', 68, NULL, NULL, 167268),
(167269, '3.40.50.300-FF-008065', NULL, 'ATP-dependent DNA helicase', 123, NULL, NULL, 167269),
(167270, '3.40.50.40-FF-000006', NULL, 'L-asparaginase I', 116, NULL, NULL, 167270),
(167271, '2.130.10.10-FF-002415', NULL, 'Polyadenylation factor subunit 2', 112, NULL, NULL, 167271),
(167272, '3.10.10.10-FF-000013', NULL, 'Pro-Pol polyprotein', 106, NULL, NULL, 167272),
(167273, '3.60.15.10-FF-000011', NULL, 'integrator complex subunit 9', 157, NULL, NULL, 167273);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(167274, '3.40.50.20-FF-000091', NULL, 'D-alanine--D-alanine ligase A', 120, NULL, NULL, 167274),
(167275, '1.50.10.20-FF-000137', NULL, 'Uncharacterized protein', 138, NULL, NULL, 167275),
(167276, '1.10.287.1490-FF-000094', NULL, 'Uncharacterized protein', 188, NULL, NULL, 167276),
(167277, '1.10.510.10-FF-001445', NULL, 'Kinase, CMGC RCK', 222, NULL, NULL, 167277),
(167278, '3.30.450.20-FF-000020', NULL, 'Aryl hydrocarbon receptor nuclear translocator 2', 128, NULL, NULL, 167278),
(167279, '1.10.472.10-FF-000405', NULL, 'Cyclin domain-containing protein', 144, NULL, NULL, 167279),
(167280, '2.70.170.10-FF-000007', NULL, 'Gamma-aminobutyric acid type A receptor rho2 subunit', 215, NULL, NULL, 167280),
(167281, '1.10.8.10-FF-000197', NULL, 'Inhibitor of apoptosis protein 3', 54, NULL, NULL, 167281),
(167282, '1.10.1000.11-FF-000024', NULL, 'Pleckstrin and Sec7 domain-containing 2', 84, NULL, NULL, 167282),
(167283, '2.10.60.10-FF-000013', NULL, 'Urokinase plasminogen activator surface receptor', 81, NULL, NULL, 167283),
(167284, '3.40.50.10190-FF-000125', NULL, 'Replication factor C subunit 1', 100, NULL, NULL, 167284),
(167285, '3.40.50.1820-FF-000936', NULL, 'Protein phosphatase methylesterase 1', 335, NULL, NULL, 167285),
(167286, '3.40.50.620-FF-000847', NULL, 'Kinase with adenine nucleotide alpha hydrolases-like domain-containing protein', 130, NULL, NULL, 167286),
(167287, '4.10.80.20-FF-000001', NULL, 'DNA polymerase', 30, NULL, NULL, 167287),
(167288, '2.20.28.200-FF-000004', NULL, 'Transcriptional regulatory protein sir2b', 50, NULL, NULL, 167288),
(167289, '3.30.465.10-FF-000068', NULL, 'HlyC/CorC family transporter', 89, NULL, NULL, 167289),
(167290, '1.10.510.10-FF-002406', NULL, NULL, 192, NULL, NULL, 167290),
(167291, '1.10.20.140-FF-000004', NULL, 'tRNA dimethylallyltransferase', 75, NULL, NULL, 167291),
(167292, '3.30.40.10-FF-000795', NULL, 'E3 ubiquitin-protein ligase RMA1H1', 95, NULL, NULL, 167292),
(167293, '2.30.42.10-FF-000616', NULL, NULL, 90, NULL, NULL, 167293),
(167294, '1.10.150.910-FF-000009', NULL, 'Damaged DNA binding protein', 87, NULL, NULL, 167294),
(167295, '3.80.10.10-FF-004276', NULL, 'Uncharacterized protein', 47, NULL, NULL, 167295),
(167296, '3.40.50.300-FF-001516', NULL, 'LR34', 239, NULL, NULL, 167296),
(167297, '1.10.150.50-FF-000187', NULL, 'Kinase suppressor of Ras 2-like Protein', 70, NULL, NULL, 167297),
(167298, '2.130.10.10-FF-000807', NULL, 'WD repeat-containing protein 60 isoform X2', 115, NULL, NULL, 167298),
(167299, '2.60.40.150-FF-000777', NULL, 'Uncharacterized protein', 104, NULL, NULL, 167299),
(167300, '2.30.42.10-FF-000274', NULL, 'inactivation-no-after-potential D protein', 107, NULL, NULL, 167300),
(167301, '3.30.40.10-FF-001447', NULL, 'Uncharacterized protein', 62, NULL, NULL, 167301),
(167302, '3.40.50.620-FF-000499', NULL, 'Probable valine--tRNA ligase, mitochondrial', 209, NULL, NULL, 167302),
(167303, '2.40.10.480-FF-000003', NULL, 'Serine/threonine protein kinase', 78, NULL, NULL, 167303),
(167304, '3.30.200.20-FF-000434', NULL, 'Receptor-like serine/threonine-protein kinase', 105, NULL, NULL, 167304),
(167305, '3.30.559.10-FF-000084', NULL, 'Spermidine coumaroyl-CoA acyltransferase', 223, NULL, NULL, 167305),
(167306, '3.90.640.90-FF-000002', NULL, 'BTG anti-proliferation factor 4', 122, NULL, NULL, 167306),
(167307, '4.10.1220.10-FF-000003', NULL, 'Basement membrane proteoglycan', 33, NULL, NULL, 167307),
(167308, '1.25.40.20-FF-001355', NULL, 'Predicted protein', 101, NULL, NULL, 167308),
(167309, '2.170.270.10-FF-000210', NULL, 'Uncharacterized protein', 154, NULL, NULL, 167309),
(167310, '3.90.25.10-FF-000044', NULL, 'Uncharacterized protein', 87, NULL, NULL, 167310),
(167311, '2.130.10.10-FF-000465', NULL, 'Autophagy-related protein 18g', 411, NULL, NULL, 167311),
(167312, '3.10.110.10-FF-000204', NULL, 'Ubiquitin-conjugating enzyme E2 2', 116, NULL, NULL, 167312),
(167313, '3.40.50.1010-FF-000143', NULL, NULL, 122, NULL, NULL, 167313),
(167314, '1.25.40.10-FF-001217', NULL, 'Pentatricopeptide repeat-containing protein', 160, NULL, NULL, 167314);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(167315, '2.60.120.370-FF-000009', NULL, 'Uncharacterized protein HI_0227', 155, NULL, NULL, 167315),
(167316, '1.20.1640.10-FF-000018', NULL, 'Transmembrane transport protein MmpL10', 206, NULL, NULL, 167316),
(167317, '3.30.160.60-FF-005933', NULL, NULL, 22, NULL, NULL, 167317),
(167318, '3.30.160.60-FF-000251', NULL, 'FEZ family zinc finger 2', 28, NULL, NULL, 167318),
(167319, '3.40.50.300-FF-001140', NULL, 'Zinc finger NFX1-type containing 1', 194, NULL, NULL, 167319),
(167320, '3.40.50.300-FF-007581', NULL, 'RNA helicase, putative', 178, NULL, NULL, 167320),
(167321, '1.20.1560.10-FF-000298', NULL, 'Uncharacterized protein', 287, NULL, NULL, 167321),
(167322, '2.60.40.10-FF-002286', NULL, 'Cdon', 94, NULL, NULL, 167322),
(167323, '1.10.418.60-FF-000008', NULL, 'NDC80 kinetochore complex component NUF2', 167, NULL, NULL, 167323),
(167324, '2.60.40.60-FF-000732', NULL, 'Cadherin-4', 92, NULL, NULL, 167324),
(167325, '1.20.1270.280-FF-000061', NULL, 'Dynein heavy chain family protein', 169, NULL, NULL, 167325),
(167326, '1.20.20.10-FF-000029', NULL, 'ATP synthase subunit c', 81, NULL, NULL, 167326),
(167327, '3.40.50.1110-FF-000038', NULL, 'Probable carbohydrate esterase At4g34215', 241, NULL, NULL, 167327),
(167328, '3.10.200.10-FF-000003', NULL, 'Carbonic anhydrase 12', 261, NULL, NULL, 167328),
(167329, '1.10.287.110-FF-000056', NULL, 'DnaJ (Hsp40) homolog, subfamily C, member 24', 86, NULL, NULL, 167329),
(167330, '1.10.10.60-FF-000454', NULL, 'Even-skipped homeobox 2', 109, NULL, NULL, 167330),
(167331, '2.10.25.10-FF-001533', NULL, 'Predicted protein', 33, NULL, NULL, 167331),
(167332, '3.40.367.20-FF-000026', NULL, 'Phosphotransferase', 251, NULL, NULL, 167332),
(167333, '3.30.200.20-FF-002379', NULL, 'Checkpoint kinase 2', 58, NULL, NULL, 167333),
(167334, '2.70.50.30-FF-000021', NULL, NULL, 146, NULL, NULL, 167334),
(167335, '1.10.1200.10-FF-000116', NULL, 'Polyketide synthase', 94, NULL, NULL, 167335),
(167336, '2.60.200.20-FF-000049', NULL, 'Forkhead box protein K1', 122, NULL, NULL, 167336),
(167337, '1.10.246.140-FF-000011', NULL, 'Enhancer of yellow 2 transcription factor', 80, NULL, NULL, 167337),
(167338, '3.40.1800.20-FF-000005', NULL, 'Uncharacterized protein, isoform A', 78, NULL, NULL, 167338),
(167339, '2.40.10.10-FF-000031', NULL, 'Haptoglobin', 89, NULL, NULL, 167339),
(167340, '1.25.40.10-FF-003387', NULL, 'Uncharacterized protein', 144, NULL, NULL, 167340),
(167341, '3.30.70.1180-FF-000005', NULL, 'V-type proton ATPase subunit C', 56, NULL, NULL, 167341),
(167342, '4.10.80.40-FF-000007', NULL, 'Pre-neck appendage protein', 40, NULL, NULL, 167342),
(167343, '1.10.510.10-FF-003923', NULL, NULL, 74, NULL, NULL, 167343),
(167344, '2.160.20.10-FF-000279', NULL, 'Uncharacterized protein', 239, NULL, NULL, 167344),
(167345, '2.70.98.50-FF-000002', NULL, 'Glycoside hydrolase family 95', 370, NULL, NULL, 167345),
(167346, '3.90.190.10-FF-000258', NULL, 'Predicted protein', 297, NULL, NULL, 167346),
(167347, '3.80.10.10-FF-004383', NULL, 'Uncharacterized protein', 361, NULL, NULL, 167347),
(167348, '3.30.230.10-FF-000416', NULL, 'Putative MLH3, MutL protein 3', 119, NULL, NULL, 167348),
(167349, '3.40.50.300-FF-003433', NULL, 'tRNA dimethylallyltransferase', 304, NULL, NULL, 167349),
(167350, '1.25.40.20-FF-001462', NULL, 'Uncharacterized protein', 117, NULL, NULL, 167350),
(167351, '3.30.160.60-FF-001662', NULL, 'Zinc finger protein 64', 28, NULL, NULL, 167351),
(167352, '1.20.1300.10-FF-000004', NULL, 'Succinate dehydrogenase cytochrome B558', 207, NULL, NULL, 167352),
(167353, '3.80.10.10-FF-001977', NULL, 'Uncharacterized protein', 100, NULL, NULL, 167353),
(167354, '3.40.50.10310-FF-000015', NULL, 'Creatininase domain protein', 249, NULL, NULL, 167354),
(167355, '2.20.90.10-FF-000014', NULL, 'Vitellogenin 3', 64, NULL, NULL, 167355),
(167356, '3.30.40.10-FF-002392', NULL, 'Uncharacterized protein', 78, NULL, NULL, 167356),
(167357, '3.30.200.20-FF-000917', NULL, 'Serine/threonine-protein kinase unc-51', 90, NULL, NULL, 167357),
(167358, '3.40.190.10-FF-000180', NULL, 'Iron ABC transporter substrate-binding protein', 145, NULL, NULL, 167358);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(167359, '1.25.40.10-FF-004567', NULL, 'Uncharacterized protein', 196, NULL, NULL, 167359),
(167360, '3.40.1090.10-FF-000132', NULL, 'Uncharacterized protein', 121, NULL, NULL, 167360),
(167361, '3.40.50.10190-FF-000344', NULL, 'Uncharacterized protein', 97, NULL, NULL, 167361),
(167362, '1.20.5.690-FF-000009', NULL, 'Importin subunit alpha', 43, NULL, NULL, 167362),
(167363, '3.40.1190.20-FF-000058', NULL, 'ATP-dependent (S)-NAD(P)H-hydrate dehydratase', 306, NULL, NULL, 167363),
(167364, '1.10.390.10-FF-000075', NULL, 'Clan MA, family M1, aminopeptidase N-like metallopeptidase', 237, NULL, NULL, 167364),
(167365, '2.60.40.10-FF-004231', NULL, NULL, 61, NULL, NULL, 167365),
(167366, '2.60.40.420-FF-000279', NULL, 'Uncharacterized protein', 137, NULL, NULL, 167366),
(167367, '2.60.40.60-FF-000384', NULL, 'Cadherin 74A, isoform A', 126, NULL, NULL, 167367),
(167368, '3.40.50.300-FF-004231', NULL, 'Endonuclease MutS2', 306, NULL, NULL, 167368),
(167369, '1.10.10.60-FF-000235', NULL, 'Zinc fingers and homeoboxes protein 1', 70, NULL, NULL, 167369),
(167370, '1.20.1310.10-FF-000139', NULL, NULL, 112, NULL, NULL, 167370),
(167371, '2.60.120.430-FF-000033', NULL, 'Mannan endo-1,4-beta-mannosidase', 174, NULL, NULL, 167371),
(167372, '2.40.40.10-FF-000016', NULL, NULL, 101, NULL, NULL, 167372),
(167373, '3.30.110.10-FF-000014', NULL, 'Translation initiation factor IF3-2, chloroplastic', 79, NULL, NULL, 167373),
(167374, '3.30.200.20-FF-001845', NULL, 'Mitogen-activated protein kinase kinase 7', 96, NULL, NULL, 167374),
(167375, '3.30.40.10-FF-000828', NULL, 'E3 ubiquitin-protein ligase At3g02290 family', 70, NULL, NULL, 167375),
(167376, '3.90.226.10-FF-000207', NULL, 'Benzoyl-CoA-dihydrodiol lyase', 315, NULL, NULL, 167376),
(167377, '3.40.50.300-FF-008284', NULL, 'Uncharacterized protein', 32, NULL, NULL, 167377),
(167378, '1.10.357.140-FF-000042', NULL, '2-carboxy-1,4-naphthoquinone phytyltransferase', 148, NULL, NULL, 167378),
(167379, '2.60.40.10-FF-001583', NULL, 'Frazzled, isoform B', 102, NULL, NULL, 167379),
(167380, '3.40.50.300-FF-008104', NULL, 'Uncharacterized protein', 274, NULL, NULL, 167380),
(167381, '1.25.40.10-FF-000514', NULL, 'Peptidylprolyl isomerase', 153, NULL, NULL, 167381),
(167382, '1.25.40.20-FF-000051', NULL, 'E3 ubiquitin-protein ligase HACE1 isoform X1', 184, NULL, NULL, 167382),
(167383, '3.30.40.10-FF-000486', NULL, 'PHD finger and BAH domain (Snt2)', 61, NULL, NULL, 167383),
(167384, '1.20.5.350-FF-000020', NULL, NULL, 127, NULL, NULL, 167384),
(167385, '1.10.238.10-FF-000480', NULL, 'Probable calcium-binding protein CML27', 82, NULL, NULL, 167385),
(167386, '3.20.20.10-FF-000081', NULL, 'Uncharacterized protein', 40, NULL, NULL, 167386),
(167387, '3.40.50.300-FF-002449', NULL, 'Adenylate kinase 9', 226, NULL, NULL, 167387),
(167388, '1.25.40.10-FF-004876', NULL, 'Pentatricopeptide repeat-containing protein At1g62590', 107, NULL, NULL, 167388),
(167389, '3.30.70.100-FF-000193', NULL, NULL, 63, NULL, NULL, 167389),
(167390, '3.40.30.10-FF-000917', NULL, 'Glutathione PeroXidase', 127, NULL, NULL, 167390),
(167391, '1.20.1250.10-FF-000123', NULL, NULL, 135, NULL, NULL, 167391),
(167392, '1.20.1310.20-FF-000024', NULL, 'Duffy receptor', 184, NULL, NULL, 167392),
(167393, '4.10.1240.50-FF-000005', NULL, 'Mesoderm induction early response protein 3', 104, NULL, NULL, 167393),
(167394, '3.40.50.300-FF-004361', NULL, 'ABC transporter ATP-binding protein', 228, NULL, NULL, 167394),
(167395, '3.40.50.300-FF-003742', NULL, 'Dynamin-related protein 1E', 94, NULL, NULL, 167395),
(167396, '3.40.50.1110-FF-000055', NULL, 'Isoamyl acetate-hydrolyzing esterase', 145, NULL, NULL, 167396),
(167397, '3.30.160.60-FF-000734', NULL, 'Zinc finger protein 462', 86, NULL, NULL, 167397),
(167398, '3.40.50.1820-FF-000408', NULL, 'Carboxypeptidase', 409, NULL, NULL, 167398),
(167399, '1.10.3550.10-FF-000002', NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase', 124, NULL, NULL, 167399),
(167400, '1.25.40.10-FF-005056', NULL, 'Tetratricopeptide repeat domain 21A', 108, NULL, NULL, 167400);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(167401, '3.40.190.10-FF-000955', NULL, 'Uncharacterized lipoprotein MG412', 141, NULL, NULL, 167401),
(167402, '1.25.40.10-FF-003948', NULL, 'Uncharacterized protein', 270, NULL, NULL, 167402),
(167403, '1.10.3260.10-FF-000031', NULL, 'DNA ligase IV', 132, NULL, NULL, 167403),
(167404, '1.10.510.10-FF-000826', NULL, 'Serine/threonine-protein kinase-like protein CCR1', 77, NULL, NULL, 167404),
(167405, '1.10.1080.10-FF-000022', NULL, 'Uncharacterized protein', 47, NULL, NULL, 167405),
(167406, '1.20.5.170-FF-000073', NULL, 'Voltage-gated hydrogen channel 1', 55, NULL, NULL, 167406),
(167407, '2.60.120.330-FF-000121', NULL, 'Naringenin,2-oxoglutarate 3-dioxygenase', 234, NULL, NULL, 167407),
(167408, '3.90.470.20-FF-000064', NULL, 'Putative 4''-phosphopantetheinyl transferase HI_0152', 63, NULL, NULL, 167408),
(167409, '3.30.60.90-FF-000011', NULL, 'Transcriptional adapter', 50, NULL, NULL, 167409),
(167410, '1.20.1070.10-FF-000575', NULL, 'Hector, isoform A', 279, NULL, NULL, 167410),
(167411, '2.130.10.10-FF-003343', NULL, 'DENN/MADD domain-containing 3a', 221, NULL, NULL, 167411),
(167412, '4.10.1080.10-FF-000014', NULL, 'Uncharacterized protein', 129, NULL, NULL, 167412),
(167413, '1.20.58.60-FF-000288', NULL, 'Karst, isoform C', 211, NULL, NULL, 167413),
(167414, '3.90.1580.10-FF-000017', NULL, 'Sulfatase-modifying factor 1', 93, NULL, NULL, 167414),
(167415, '2.130.10.10-FF-004517', NULL, 'Uncharacterized protein', 233, NULL, NULL, 167415),
(167416, '1.10.472.80-FF-000168', NULL, NULL, 148, NULL, NULL, 167416),
(167417, '1.10.1200.10-FF-000083', NULL, 'Nonribosomal peptide synthase 2', 84, NULL, NULL, 167417),
(167418, '3.30.2020.30-FF-000007', NULL, 'Probable gamma-butyrobetaine dioxygenase', 98, NULL, NULL, 167418),
(167419, '2.60.40.2840-FF-000008', NULL, 'Phosphatidylethanolamine N-methyltransferase', 138, NULL, NULL, 167419),
(167420, '2.130.10.10-FF-003719', NULL, 'Sema domain, immunoglobulin domain (Ig), short basic domain, secreted, (semaphorin) 3bl', 64, NULL, NULL, 167420),
(167421, '3.20.20.100-FF-000078', NULL, 'Aldo-keto reductase family 1 member D1', 143, NULL, NULL, 167421),
(167422, '1.20.1250.20-FF-000345', NULL, 'Monosaccharide-sensing protein 3', 244, NULL, NULL, 167422),
(167423, '2.60.40.10-FF-004540', NULL, NULL, 88, NULL, NULL, 167423),
(167424, '1.20.120.620-FF-000004', NULL, 'Two-component sensor histidine kinase', 106, NULL, NULL, 167424),
(167425, '3.30.160.60-FF-005405', NULL, NULL, 44, NULL, NULL, 167425),
(167426, '3.80.10.10-FF-000089', NULL, 'volume-regulated anion channel subunit LRRC8B', 244, NULL, NULL, 167426),
(167427, '1.20.58.390-FF-000245', NULL, 'Si:ch211-256e16.4', 157, NULL, NULL, 167427),
(167428, '1.20.1070.10-FF-001986', NULL, 'Predicted protein', 158, NULL, NULL, 167428),
(167429, '1.10.3720.10-FF-000139', NULL, 'Glycine betaine/carnitine/choline/L-proline ABC transporter permease ProW', 195, NULL, NULL, 167429),
(167430, '1.10.10.790-FF-000017', NULL, 'Splicing factor 3A subunit 1', 52, NULL, NULL, 167430),
(167431, '1.10.3710.10-FF-000004', NULL, 'Putative ATPase, AAA family', 96, NULL, NULL, 167431),
(167432, '3.30.40.10-FF-000267', NULL, 'E3 ubiquitin-protein ligase RNF138 isoform X1', 109, NULL, NULL, 167432),
(167433, '1.10.246.10-FF-000004', NULL, 'Serum albumin', 86, NULL, NULL, 167433),
(167434, '3.40.50.1820-FF-000066', NULL, 'Monoglyceride lipase', 302, NULL, NULL, 167434),
(167435, '2.130.10.10-FF-000246', NULL, 'striatin-4 isoform X1', 118, NULL, NULL, 167435),
(167436, '3.90.660.10-FF-000126', NULL, NULL, 99, NULL, NULL, 167436),
(167437, '3.40.50.300-FF-004703', NULL, 'Uncharacterized protein', 154, NULL, NULL, 167437),
(167438, '2.60.40.3500-FF-000010', NULL, NULL, 105, NULL, NULL, 167438),
(167439, '3.40.50.300-FF-000336', NULL, 'rac-like GTP-binding protein RHO1', 188, NULL, NULL, 167439),
(167440, '3.30.200.20-FF-001070', NULL, 'Si:ch211-63o20.7', 92, NULL, NULL, 167440),
(167441, '1.20.1250.20-FF-001941', NULL, 'Uncharacterized protein', 460, NULL, NULL, 167441),
(167442, '3.40.50.300-FF-000521', NULL, 'Type II secretion system protein E', 244, NULL, NULL, 167442);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(167443, '3.60.10.10-FF-000298', NULL, 'Uncharacterized protein', 331, NULL, NULL, 167443),
(167444, '3.40.50.300-FF-008413', NULL, 'ATP-dependent DEAD/H RNA helicase, putative', 144, NULL, NULL, 167444),
(167445, '3.40.50.1820-FF-000375', NULL, 'Uncharacterized protein', 235, NULL, NULL, 167445),
(167446, '2.60.450.10-FF-000014', NULL, 'Lipopolysaccharide export system protein LptA', 141, NULL, NULL, 167446),
(167447, '1.10.287.130-FF-000067', NULL, 'Methylmalonic aciduria type A homolog, mitochondrial', 67, NULL, NULL, 167447),
(167448, '3.40.50.10490-FF-000097', NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', 212, NULL, NULL, 167448),
(167449, '3.90.740.10-FF-000060', NULL, 'Uncharacterized protein', 173, NULL, NULL, 167449),
(167450, '2.10.250.10-FF-000004', NULL, 'CNE1p Calnexin', 146, NULL, NULL, 167450),
(167451, '3.20.180.20-FF-000001', NULL, 'Dynein axonemal heavy chain 5', 98, NULL, NULL, 167451),
(167452, '3.40.50.720-FF-002367', NULL, 'Uncharacterized protein', 56, NULL, NULL, 167452),
(167453, '1.10.530.10-FF-000064', NULL, 'Conjugal transfer protein', 152, NULL, NULL, 167453),
(167454, '2.130.10.10-FF-001870', NULL, 'WD repeat and HMG-box DNA-binding protein 1', 237, NULL, NULL, 167454),
(167455, '3.30.420.40-FF-000642', NULL, 'Exopolyphosphatase', 138, NULL, NULL, 167455),
(167456, '3.60.21.10-FF-000087', NULL, 'Serine/threonine-protein phosphatase with EF-hands', 153, NULL, NULL, 167456),
(167457, '3.40.50.300-FF-001741', NULL, 'Formate--tetrahydrofolate ligase', 158, NULL, NULL, 167457),
(167458, '3.30.465.10-FF-000085', NULL, 'Hemolysin C', 92, NULL, NULL, 167458),
(167459, '3.40.50.2020-FF-000093', NULL, 'Ribose-phosphate pyrophosphokinase, putative', 44, NULL, NULL, 167459),
(167460, '2.60.260.20-FF-000188', NULL, 'Uncharacterized protein', 24, NULL, NULL, 167460),
(167461, '1.25.40.10-FF-001661', NULL, 'Uncharacterized protein', 222, NULL, NULL, 167461),
(167462, '3.90.190.10-FF-000489', NULL, 'Uncharacterized protein', 160, NULL, NULL, 167462),
(167463, '2.30.29.30-FF-001221', NULL, 'Phosphoinositide phospholipase C', 99, NULL, NULL, 167463),
(167464, '1.20.1250.20-FF-000906', NULL, 'Solute carrier organic anion transporter family member', 289, NULL, NULL, 167464),
(167465, '2.60.40.10-FF-002887', NULL, 'Short-form leptin receptor 1', 95, NULL, NULL, 167465),
(167466, '3.30.365.10-FF-000032', NULL, 'Cytochrome P450', 219, NULL, NULL, 167466),
(167467, '1.10.238.10-FF-000800', NULL, 'Phosphoinositide phospholipase C', 85, NULL, NULL, 167467),
(167468, '1.25.40.90-FF-000010', NULL, 'EH domain binding protein', 153, NULL, NULL, 167468),
(167469, '1.10.510.10-FF-000181', NULL, 'Nuclear receptor-binding protein 1', 176, NULL, NULL, 167469),
(167470, '3.40.50.1820-FF-000627', NULL, 'Alpha/beta-Hydrolases superfamily protein', 222, NULL, NULL, 167470),
(167471, '3.30.160.60-FF-006226', NULL, NULL, 50, NULL, NULL, 167471),
(167472, '1.25.40.20-FF-000135', NULL, 'KN motif and ankyrin repeat domains 4', 243, NULL, NULL, 167472),
(167473, '3.50.30.30-FF-000114', NULL, 'Uncharacterized protein', 165, NULL, NULL, 167473),
(167474, '3.10.350.10-FF-000098', NULL, 'Intracellular hyphae protein 1', 62, NULL, NULL, 167474),
(167475, '3.40.50.300-FF-000651', NULL, 'Lon protease homolog 2, peroxisomal', 179, NULL, NULL, 167475),
(167476, '3.40.710.10-FF-000153', NULL, 'Glutaminase like', 328, NULL, NULL, 167476),
(167477, '3.40.50.300-FF-007665', NULL, 'Uncharacterized protein', 123, NULL, NULL, 167477),
(167478, '1.10.510.10-FF-003940', NULL, NULL, 65, NULL, NULL, 167478),
(167479, '3.40.250.10-FF-000218', NULL, 'Uncharacterized protein', 142, NULL, NULL, 167479),
(167480, '2.30.170.20-FF-000002', NULL, '60S ribosomal protein L24', 68, NULL, NULL, 167480),
(167481, '3.40.50.11980-FF-000010', NULL, 'Zinc finger CCCH-type containing 12D', 72, NULL, NULL, 167481),
(167482, '2.160.20.80-FF-000024', NULL, NULL, 77, NULL, NULL, 167482),
(167483, '1.10.510.10-FF-002850', NULL, NULL, 256, NULL, NULL, 167483),
(167484, '3.90.70.10-FF-000564', NULL, 'HL02756p', 78, NULL, NULL, 167484);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(167485, '3.50.50.60-FF-001057', NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', 113, NULL, NULL, 167485),
(167486, '3.40.605.10-FF-000004', NULL, 'Aldehyde dehydrogenase', 219, NULL, NULL, 167486),
(167487, '3.90.70.130-FF-000002', NULL, 'Zinc finger containing ubiquitin peptidase 1', 223, NULL, NULL, 167487),
(167488, '3.30.1330.10-FF-000007', NULL, 'Phosphoribosylformylglycinamidine synthase, putative', 185, NULL, NULL, 167488),
(167489, '1.20.1540.10-FF-000078', NULL, 'Rhomboid protein', 194, NULL, NULL, 167489),
(167490, '1.20.1250.20-FF-001380', NULL, 'monocarboxylate transporter 5-like', 193, NULL, NULL, 167490),
(167491, '3.40.50.300-FF-000212', NULL, 'Adenylyl-sulfate kinase', 200, NULL, NULL, 167491),
(167492, '2.70.50.30-FF-000004', NULL, 'Rho GDP-dissociation inhibitor 1', 200, NULL, NULL, 167492),
(167493, '3.40.50.720-FF-001294', NULL, 'Glyoxylate reductase', 119, NULL, NULL, 167493),
(167494, '3.40.50.720-FF-000675', NULL, 'Trk system potassium uptake protein TrkA', 142, NULL, NULL, 167494),
(167495, '1.20.1070.10-FF-000553', NULL, 'Uncharacterized protein', 291, NULL, NULL, 167495),
(167496, '3.80.10.10-FF-000797', NULL, 'CTF13p Subunit of the CBF3 complex', 230, NULL, NULL, 167496),
(167497, '3.30.450.20-FF-000621', NULL, 'Protein single-minded-like Protein', 102, NULL, NULL, 167497),
(167498, '1.25.10.10-FF-000541', NULL, 'Splicing factor 3B subunit 1, putative', 123, NULL, NULL, 167498),
(167499, '1.10.8.530-FF-000008', NULL, 'DNA polymerase alpha subunit B', 78, NULL, NULL, 167499),
(167500, '2.60.40.790-FF-000154', NULL, NULL, 146, NULL, NULL, 167500),
(167501, '3.40.50.300-FF-007137', NULL, 'Uncharacterized protein', 179, NULL, NULL, 167501),
(167502, '3.40.970.10-FF-000003', NULL, 'Transactivator/viroplasmin protein', 48, NULL, NULL, 167502),
(167503, '1.20.1250.20-FF-000761', NULL, 'Major facilitator superfamily MFS_1', 424, NULL, NULL, 167503),
(167504, '3.40.50.1000-FF-000461', NULL, 'Uncharacterized protein', 194, NULL, NULL, 167504),
(167505, '1.20.1420.10-FF-000024', NULL, NULL, 154, NULL, NULL, 167505),
(167506, '1.20.1110.10-FF-000158', NULL, NULL, 17, NULL, NULL, 167506),
(167507, '1.20.1250.20-FF-001273', NULL, 'Conserved hypthetical protein', 207, NULL, NULL, 167507),
(167508, '2.60.40.10-FF-001903', NULL, 'Starch synthase 3, chloroplastic/amyloplastic', 101, NULL, NULL, 167508),
(167509, '3.30.70.80-FF-000054', NULL, 'Uncharacterized protein', 51, NULL, NULL, 167509),
(167510, '1.25.40.570-FF-000054', NULL, 'Uncharacterized protein', 329, NULL, NULL, 167510),
(167511, '3.90.550.50-FF-000006', NULL, 'Fringe-related protein-like', 259, NULL, NULL, 167511),
(167512, '1.25.40.10-FF-001133', NULL, 'Crooked neck protein, putative', 211, NULL, NULL, 167512),
(167513, '3.50.7.10-FF-000011', NULL, 'McKusick-Kaufman/Bardet-Biedl syndromes putative chaperonin', 153, NULL, NULL, 167513),
(167514, '1.25.10.10-FF-002339', NULL, 'Uncharacterized protein', 292, NULL, NULL, 167514),
(167515, '3.30.70.330-FF-001329', NULL, 'GM22984', 123, NULL, NULL, 167515),
(167516, '3.40.50.2000-FF-000772', NULL, 'AGAP005163-PA', 169, NULL, NULL, 167516),
(167517, '2.60.40.10-FF-002994', NULL, 'Chitinase', 90, NULL, NULL, 167517),
(167518, '2.60.40.60-FF-000131', NULL, 'FAT atypical cadherin 4', 103, NULL, NULL, 167518),
(167519, '1.10.418.80-FF-000003', NULL, NULL, 73, NULL, NULL, 167519),
(167520, '1.25.40.120-FF-000048', NULL, 'Uncharacterized protein', 280, NULL, NULL, 167520),
(167521, '3.40.50.720-FF-000203', NULL, 'D-3-phosphoglycerate dehydrogenase (SerA)', 190, NULL, NULL, 167521),
(167522, '3.60.20.10-FF-000197', NULL, NULL, 221, NULL, NULL, 167522),
(167523, '2.10.25.10-FF-001516', NULL, 'Neurogenic locus protein delta-like Protein', 71, NULL, NULL, 167523),
(167524, '1.10.400.10-FF-000043', NULL, 'Guanine nucleotide-binding protein-like alpha-11 subunit', 124, NULL, NULL, 167524),
(167525, '3.40.50.1820-FF-001100', NULL, 'ENC6 protein', 92, NULL, NULL, 167525),
(167526, '3.30.160.60-FF-001807', NULL, 'Blast:Transcription factor Sp4', 30, NULL, NULL, 167526);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(167527, '3.40.30.10-FF-000463', NULL, 'Pheromone-regulated membrane protein', 131, NULL, NULL, 167527),
(167528, '3.30.70.3250-FF-000003', NULL, 'Ribonuclease P/MRP protein subunit POP5', 120, NULL, NULL, 167528),
(167529, '2.130.10.30-FF-000151', NULL, NULL, 177, NULL, NULL, 167529),
(167530, '1.25.40.20-FF-001771', NULL, 'Uncharacterized protein', 188, NULL, NULL, 167530),
(167531, '1.20.58.70-FF-000061', NULL, 'Syntaxin 16/TLG2-like protein, putative', 204, NULL, NULL, 167531),
(167532, '1.25.10.10-FF-000209', NULL, 'Protein kinase family protein / WD-40 repeat family protein', 210, NULL, NULL, 167532),
(167533, '3.10.50.40-FF-000002', NULL, 'Peptidylprolyl isomerase', 112, NULL, NULL, 167533),
(167534, '2.60.120.10-FF-000219', NULL, 'Probable mannose-6-phosphate isomerase manA', 86, NULL, NULL, 167534),
(167535, '2.60.120.650-FF-000099', NULL, 'Jumonji, AT-rich interactive domain 2a', 280, NULL, NULL, 167535),
(167536, '3.90.550.10-FF-000045', NULL, 'UTP--glucose-1-phosphate uridylyltransferase', 281, NULL, NULL, 167536),
(167537, '3.40.50.300-FF-003394', NULL, 'GCN20-type ATP-binding cassette protein GCN3, putative', 267, NULL, NULL, 167537),
(167538, '3.30.160.60-FF-004989', NULL, NULL, 76, NULL, NULL, 167538),
(167539, '3.40.140.10-FF-000137', NULL, 'Uncharacterized protein', 159, NULL, NULL, 167539),
(167540, '1.25.40.10-FF-001818', NULL, 'Pentatricopeptide repeat-containing protein At1g06140, mitochondrial', 108, NULL, NULL, 167540),
(167541, '3.40.720.10-FF-000182', NULL, 'DEAD-box ATP-dependent RNA helicase 18', 61, NULL, NULL, 167541),
(167542, '3.40.50.720-FF-000889', NULL, 'Oxidoreductase, Gfo/Idh/MocA family', 118, NULL, NULL, 167542),
(167543, '3.40.50.300-FF-004922', NULL, 'Zgc:153654', 197, NULL, NULL, 167543),
(167544, '4.10.240.10-FF-000013', NULL, 'C6 transcription factor, putative', 74, NULL, NULL, 167544),
(167545, '3.40.50.720-FF-001979', NULL, 'Predicted protein', 249, NULL, NULL, 167545),
(167546, '3.50.50.60-FF-000023', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 33, NULL, NULL, 167546),
(167547, '2.130.10.10-FF-005613', NULL, 'Uncharacterized protein', 187, NULL, NULL, 167547),
(167548, '3.30.420.40-FF-000114', NULL, 'Heat shock 70 kDa protein 13', 128, NULL, NULL, 167548),
(167549, '1.10.10.10-FF-000052', NULL, 'Cell cycle response regulator', 110, NULL, NULL, 167549),
(167550, '1.10.2000.10-FF-000028', NULL, NULL, 119, NULL, NULL, 167550),
(167551, '3.30.40.10-FF-001195', NULL, 'Protein ENHANCED DOWNY MILDEW 2', 62, NULL, NULL, 167551),
(167552, '1.10.640.10-FF-000038', NULL, 'Peroxinectin, putative', 82, NULL, NULL, 167552),
(167553, '1.10.287.1490-FF-000077', NULL, 'Predicted protein', 161, NULL, NULL, 167553),
(167554, '2.20.28.10-FF-000056', NULL, 'DNA helicase', 51, NULL, NULL, 167554),
(167555, '3.30.1460.20-FF-000003', NULL, 'Arp2/3 complex 34 kDa subunit', 186, NULL, NULL, 167555),
(167556, '2.60.120.260-FF-000448', NULL, 'Carboxypeptidase X (M14 family), member 2', 78, NULL, NULL, 167556),
(167557, '2.40.10.10-FF-000632', NULL, NULL, 233, NULL, NULL, 167557),
(167558, '2.170.130.10-FF-000014', NULL, 'SusC/RagA family TonB-linked outer membrane protein', 135, NULL, NULL, 167558),
(167559, '1.20.1050.10-FF-000012', NULL, 'Tau class glutathione S-transferase', 137, NULL, NULL, 167559),
(167560, '2.60.120.200-FF-000801', NULL, 'Os07g0569800 protein', 178, NULL, NULL, 167560),
(167561, '3.40.390.10-FF-000291', NULL, NULL, 86, NULL, NULL, 167561),
(167562, '1.20.1070.10-FF-001059', NULL, 'Vomeronasal type-1 receptor', 167, NULL, NULL, 167562),
(167563, '3.60.10.10-FF-000168', NULL, 'Predicted protein', 95, NULL, NULL, 167563),
(167564, '1.25.10.10-FF-001833', NULL, 'Uncharacterized protein', 220, NULL, NULL, 167564),
(167565, '3.40.50.11540-FF-000007', NULL, 'Uncharacterized protein', 88, NULL, NULL, 167565),
(167566, '3.20.140.10-FF-000018', NULL, 'Nicotinate phosphoribosyltransferase', 153, NULL, NULL, 167566),
(167567, '1.10.3470.10-FF-000041', NULL, 'Lipoprotein, SirC, putative', 304, NULL, NULL, 167567),
(167568, '3.30.40.10-FF-001520', NULL, 'Uncharacterized protein', 72, NULL, NULL, 167568);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(167569, '1.25.40.20-FF-001916', NULL, 'Uncharacterized protein', 193, NULL, NULL, 167569),
(167570, '1.10.10.60-FF-001095', NULL, NULL, 122, NULL, NULL, 167570),
(167571, '3.40.630.10-FF-000309', NULL, 'Uncharacterized protein', 304, NULL, NULL, 167571),
(167572, '3.40.50.1000-FF-000680', NULL, NULL, 164, NULL, NULL, 167572),
(167573, '1.20.58.760-FF-000030', NULL, 'Uncharacterized protein', 184, NULL, NULL, 167573),
(167574, '2.70.170.10-FF-000029', NULL, 'Cholinergic receptor nicotinic alpha 10 subunit', 215, NULL, NULL, 167574),
(167575, '2.130.10.10-FF-000015', NULL, 'Semaphorin 3B', 494, NULL, NULL, 167575),
(167576, '1.50.10.10-FF-000241', NULL, 'alpha-1,2-Mannosidase', 167, NULL, NULL, 167576),
(167577, '1.20.5.170-FF-000179', NULL, 'Autophagy-related protein 16 isoform A', 74, NULL, NULL, 167577),
(167578, '2.60.120.10-FF-000821', NULL, 'Uncharacterized protein', 86, NULL, NULL, 167578),
(167579, '3.90.1150.10-FF-000070', NULL, 'Putative cystathionine gamma-synthase', 85, NULL, NULL, 167579),
(167580, '1.10.238.100-FF-000004', NULL, 'Arr1p', 63, NULL, NULL, 167580),
(167581, '3.40.50.2000-FF-000463', NULL, 'Lipid-A-disaccharide synthase', 116, NULL, NULL, 167581),
(167582, '3.40.50.300-FF-003539', NULL, 'ADP-ribosylation factor 1', 180, NULL, NULL, 167582),
(167583, '2.10.25.10-FF-000679', NULL, 'Latent-transforming growth factor beta-binding protein 4', 38, NULL, NULL, 167583),
(167584, '3.40.1190.20-FF-000188', NULL, NULL, 289, NULL, NULL, 167584),
(167585, '3.40.50.12780-FF-000177', NULL, 'LP07340p', 293, NULL, NULL, 167585),
(167586, '3.40.50.300-FF-008520', NULL, 'Uncharacterized protein', 33, NULL, NULL, 167586),
(167587, '1.10.10.10-FF-001670', NULL, 'Putative transcriptional regulator', 137, NULL, NULL, 167587),
(167588, '3.90.79.20-FF-000002', NULL, 'Peroxisomal NADH pyrophosphatase NUDT12', 184, NULL, NULL, 167588),
(167589, '3.40.800.10-FF-000020', NULL, 'Putative agmatinase', 304, NULL, NULL, 167589),
(167590, '3.40.50.11030-FF-000001', NULL, 'Threonylcarbamoyl-AMP synthase', 129, NULL, NULL, 167590),
(167591, '2.60.120.200-FF-000790', NULL, 'Galectin', 81, NULL, NULL, 167591),
(167592, '3.90.1140.10-FF-000018', NULL, 'Putative eukaryotic LigT', 215, NULL, NULL, 167592),
(167593, '3.40.50.720-FF-001507', NULL, 'Predicted protein', 131, NULL, NULL, 167593),
(167594, '3.40.630.30-FF-000214', NULL, 'Predicted protein', 139, NULL, NULL, 167594),
(167595, '3.80.10.10-FF-000566', NULL, 'Putative leucine-rich repeat receptor-like protein kinase', 96, NULL, NULL, 167595),
(167596, '3.30.2160.10-FF-000056', NULL, 'Uncharacterized protein', 71, NULL, NULL, 167596),
(167597, '3.40.20.10-FF-000170', NULL, 'Predicted protein', 40, NULL, NULL, 167597),
(167598, '3.40.50.450-FF-000010', NULL, 'ATP-dependent 6-phosphofructokinase', 222, NULL, NULL, 167598),
(167599, '3.30.565.10-FF-000452', NULL, 'Hybrid sensor histidine kinase/response regulator', 190, NULL, NULL, 167599),
(167600, '3.40.50.300-FF-000319', NULL, 'DNA repair protein RecN', 257, NULL, NULL, 167600),
(167601, '1.25.40.10-FF-004640', NULL, 'Uncharacterized protein', 126, NULL, NULL, 167601),
(167602, '3.90.70.10-FF-000457', NULL, 'Clan CA, family C1, cathepsin L-like cysteine peptidase', 304, NULL, NULL, 167602),
(167603, '1.10.1070.11-FF-000045', NULL, 'Serine/threonine-protein kinase smg-1', 187, NULL, NULL, 167603),
(167604, '2.40.160.10-FF-000007', NULL, 'Outer membrane protein', 461, NULL, NULL, 167604),
(167605, '3.40.50.300-FF-004158', NULL, 'Putative multidrug resistance-associated protein lethal(2)03659-like Protein', 241, NULL, NULL, 167605),
(167606, '3.30.420.110-FF-000051', NULL, 'DNA mismatch repair protein Msh2', 165, NULL, NULL, 167606),
(167607, '1.10.287.70-FF-000324', NULL, 'GLutamate Receptor family (AMPA)', 171, NULL, NULL, 167607),
(167608, '3.40.710.10-FF-000046', NULL, 'Transglycosylase', 418, NULL, NULL, 167608),
(167609, '1.20.1740.10-FF-000059', NULL, 'Na(+)-linked D-alanine glycine permease', 405, NULL, NULL, 167609),
(167610, '3.40.50.2300-FF-000980', NULL, NULL, 136, NULL, NULL, 167610),
(167611, '1.10.418.10-FF-000134', NULL, 'kinesin-4-like', 141, NULL, NULL, 167611);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(167612, '1.10.238.200-FF-000028', NULL, 'Defective in cullin neddylation protein', 42, NULL, NULL, 167612),
(167613, '3.50.30.20-FF-000004', NULL, 'Carbamoyl-phosphate synthase, large subunit', 154, NULL, NULL, 167613),
(167614, '2.120.10.80-FF-000082', NULL, 'Serine/threonine-protein phosphatase', 116, NULL, NULL, 167614),
(167615, '2.60.40.1730-FF-000001', NULL, 'Leucyl-cystinyl aminopeptidase', 210, NULL, NULL, 167615),
(167616, '3.90.190.10-FF-000275', NULL, 'Tensin 1', 85, NULL, NULL, 167616),
(167617, '3.30.479.20-FF-000029', NULL, 'Elongation factor Ts', 92, NULL, NULL, 167617),
(167618, '3.30.830.10-FF-000018', NULL, 'Cytochrome b-c1 complex subunit 2, mitochondrial', 235, NULL, NULL, 167618),
(167619, '2.60.40.790-FF-000047', NULL, '23.6 kDa heat shock protein mitochondrial', 149, NULL, NULL, 167619),
(167620, '1.25.40.20-FF-000843', NULL, 'Uncharacterized protein', 235, NULL, NULL, 167620),
(167621, '3.30.200.20-FF-001738', NULL, 'Non-specific serine/threonine protein kinase', 77, NULL, NULL, 167621),
(167622, '1.10.238.10-FF-000036', NULL, 'Phosphoinositide phospholipase C', 76, NULL, NULL, 167622),
(167623, '1.10.287.380-FF-000018', NULL, 'Putative ABC transporter ATP-binding potein', 83, NULL, NULL, 167623),
(167624, '2.60.40.10-FF-003612', NULL, NULL, 87, NULL, NULL, 167624),
(167625, '3.30.420.40-FF-000895', NULL, 'N-acetylgalactosamine kinase AgaK', 171, NULL, NULL, 167625),
(167626, '3.40.33.10-FF-000014', NULL, 'C-type lectin domain family 18 member A', 184, NULL, NULL, 167626),
(167627, '2.40.50.140-FF-000691', NULL, 'Lysine--tRNA ligase, mitochondrial', 149, NULL, NULL, 167627),
(167628, '3.90.180.10-FF-000196', NULL, 'Uncharacterized protein', 173, NULL, NULL, 167628),
(167629, '3.30.200.20-FF-001614', NULL, 'Uncharacterized protein', 123, NULL, NULL, 167629),
(167630, '1.20.5.110-FF-000223', NULL, 'Uncharacterized protein', 64, NULL, NULL, 167630),
(167631, '1.10.8.270-FF-000043', NULL, 'AGAP000552-PA-like protein', 96, NULL, NULL, 167631),
(167632, '3.40.50.1820-FF-000858', NULL, 'Uncharacterized protein', 305, NULL, NULL, 167632),
(167633, '3.30.160.60-FF-003825', NULL, NULL, 30, NULL, NULL, 167633),
(167634, '1.10.10.10-FF-001198', NULL, 'MarR family transcriptional regulator', 136, NULL, NULL, 167634),
(167635, '3.40.50.1820-FF-000482', NULL, 'DltD N-terminal domain-containing protein', 186, NULL, NULL, 167635),
(167636, '1.25.10.10-FF-001305', NULL, 'Uncharacterized protein', 318, NULL, NULL, 167636),
(167637, '3.30.420.320-FF-000001', NULL, 'Tripartite terminase subunit 3', 257, NULL, NULL, 167637),
(167638, '2.170.150.20-FF-000018', NULL, 'AGAP004264-PA', 138, NULL, NULL, 167638),
(167639, '1.25.40.10-FF-000037', NULL, 'Putative pre-mRNA-processing factor 6', 209, NULL, NULL, 167639),
(167640, '3.80.10.10-FF-003978', NULL, 'Uncharacterized protein', 160, NULL, NULL, 167640),
(167641, '3.40.190.290-FF-000132', NULL, 'Uncharacterized protein', 200, NULL, NULL, 167641),
(167642, '3.60.20.10-FF-000091', NULL, 'Proteasome subunit beta', 198, NULL, NULL, 167642),
(167643, '3.80.10.10-FF-000544', NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3', 72, NULL, NULL, 167643),
(167644, '3.40.50.720-FF-001530', NULL, 'Uncharacterized protein', 285, NULL, NULL, 167644),
(167645, '1.20.1250.20-FF-001525', NULL, 'Predicted protein', 362, NULL, NULL, 167645),
(167646, '3.40.50.300-FF-000105', NULL, 'BMS1 ribosome biogenesis factor', 163, NULL, NULL, 167646),
(167647, '3.30.450.40-FF-000251', NULL, 'Uncharacterized protein', 73, NULL, NULL, 167647),
(167648, '3.30.300.30-FF-000147', NULL, 'O-succinylbenzoic acid CoA ligase MenE', 107, NULL, NULL, 167648),
(167649, '1.20.120.1750-FF-000092', NULL, 'Uncharacterized protein', 81, NULL, NULL, 167649),
(167650, '3.30.160.820-FF-000001', NULL, 'Orf1ab polyprotein', 65, NULL, NULL, 167650),
(167651, '1.20.120.350-FF-000266', NULL, NULL, 111, NULL, NULL, 167651),
(167652, '3.40.30.10-FF-000991', NULL, 'Uncharacterized protein', 83, NULL, NULL, 167652),
(167653, '1.10.100.10-FF-000003', NULL, 'Insulin', 86, NULL, NULL, 167653);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(167654, '3.90.1750.10-FF-000048', NULL, 'E3 ubiquitin-protein ligase UPL3', 239, NULL, NULL, 167654),
(167655, '3.40.50.880-FF-000021', NULL, 'Anthranilate phosphoribosyltransferase', 190, NULL, NULL, 167655),
(167656, '1.20.1270.60-FF-000072', NULL, 'Sorting nexin MVP1', 229, NULL, NULL, 167656),
(167657, '2.60.40.10-FF-001667', NULL, 'Sallimus, isoform P', 101, NULL, NULL, 167657),
(167658, '3.90.79.10-FF-000213', NULL, 'Bll2550 protein', 139, NULL, NULL, 167658),
(167659, '3.30.70.330-FF-001857', NULL, NULL, 167, NULL, NULL, 167659),
(167660, '2.30.30.30-FF-000033', NULL, 'Woronin body major protein HEX1', 74, NULL, NULL, 167660),
(167661, '3.40.50.300-FF-002466', NULL, 'Rab B GTPase', 196, NULL, NULL, 167661),
(167662, '1.20.5.170-FF-000090', NULL, 'Propionate catabolism operon regulatory protein PrpR', 42, NULL, NULL, 167662),
(167663, '4.10.280.10-FF-000246', NULL, 'Uncharacterized protein', 64, NULL, NULL, 167663),
(167664, '2.60.40.10-FF-001358', NULL, 'Cilia and flagella associated protein 221', 100, NULL, NULL, 167664),
(167665, '1.10.10.60-FF-000004', NULL, 'Meis2 homeobox isoform 2c', 67, NULL, NULL, 167665),
(167666, '2.60.40.4370-FF-000006', NULL, 'GD10187', 111, NULL, NULL, 167666),
(167667, '1.20.1440.180-FF-000002', NULL, 'Serine/threonine-protein kinase/endoribonuclease IRE1', 133, NULL, NULL, 167667),
(167668, '3.30.450.50-FF-000040', NULL, 'vesicle-associated membrane protein 7-like', 124, NULL, NULL, 167668),
(167669, '1.10.10.2320-FF-000004', NULL, NULL, 47, NULL, NULL, 167669),
(167670, '3.30.60.30-FF-000235', NULL, 'Agrin-like Protein', 49, NULL, NULL, 167670),
(167671, '2.60.40.10-FF-005181', NULL, NULL, 93, NULL, NULL, 167671),
(167672, '3.40.630.30-FF-000670', NULL, 'Protein CBG11297', 147, NULL, NULL, 167672),
(167673, '3.30.470.30-FF-000024', NULL, 'ATP-dependent DNA ligase', 203, NULL, NULL, 167673),
(167674, '1.20.900.10-FF-000028', NULL, 'Puratrophin-1-like, isoform D', 207, NULL, NULL, 167674),
(167675, '1.10.472.130-FF-000091', NULL, 'Dynein heavy chain, cytosolic, putative', 161, NULL, NULL, 167675),
(167676, '3.40.50.150-FF-001746', NULL, NULL, 195, NULL, NULL, 167676),
(167677, '1.10.540.10-FF-000093', NULL, 'Glutaryl-CoA dehydrogenase, mitochondrial', 81, NULL, NULL, 167677),
(167678, '3.30.830.10-FF-000237', NULL, 'Uncharacterized protein', 236, NULL, NULL, 167678),
(167679, '1.20.1560.10-FF-000309', NULL, 'ABC transporter family protein', 271, NULL, NULL, 167679),
(167680, '3.30.70.330-FF-001296', NULL, 'Alternative splicing factor', 87, NULL, NULL, 167680),
(167681, '3.30.40.10-FF-000806', NULL, 'PHD finger family protein', 113, NULL, NULL, 167681),
(167682, '3.30.450.50-FF-000017', NULL, 'Synaptobrevin-like protein Sybl1', 147, NULL, NULL, 167682),
(167683, '3.10.105.10-FF-000006', NULL, 'Peptide ABC transporter substrate-binding protein', 227, NULL, NULL, 167683),
(167684, '3.40.430.10-FF-000019', NULL, 'Riboflavin biosynthesis protein RibD', 222, NULL, NULL, 167684),
(167685, '3.30.70.330-FF-001638', NULL, 'EWS RNA-binding protein 1b', 148, NULL, NULL, 167685),
(167686, '3.30.200.20-FF-002143', NULL, 'Mitogen-activated protein kinase', 69, NULL, NULL, 167686),
(167687, '3.40.50.300-FF-005647', NULL, 'DNA replication licensing factor, MCM2/3/5 family', 327, NULL, NULL, 167687),
(167688, '1.10.1170.10-FF-000012', NULL, 'E3 ubiquitin-protein ligase XIAP isoform X1', 71, NULL, NULL, 167688),
(167689, '1.25.40.10-FF-003151', NULL, 'Uncharacterized protein', 121, NULL, NULL, 167689),
(167690, '1.10.8.60-FF-000256', NULL, 'Nuclear VCP-like', 95, NULL, NULL, 167690),
(167691, '1.10.287.70-FF-000779', NULL, 'Uncharacterized protein', 100, NULL, NULL, 167691),
(167692, '3.30.450.20-FF-000256', NULL, 'Hypothetical regulatory protein', 107, NULL, NULL, 167692),
(167693, '3.40.50.300-FF-006940', NULL, 'ABC transporter', 316, NULL, NULL, 167693),
(167694, '1.10.10.10-FF-000361', NULL, 'Terminase small subunit nu1', 68, NULL, NULL, 167694),
(167695, '3.40.50.1010-FF-000227', NULL, NULL, 88, NULL, NULL, 167695),
(167696, '3.40.50.150-FF-001218', NULL, 'Predicted protein', 262, NULL, NULL, 167696);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(167697, '3.40.50.970-FF-000059', NULL, '2-oxoisovalerate dehydrogenase E1 component', 196, NULL, NULL, 167697),
(167698, '3.40.50.300-FF-005794', NULL, 'Vesicular fusion ATPase, putative (AFU_orthologue AFUA_3G12510)', 65, NULL, NULL, 167698),
(167699, '2.60.40.10-FF-005956', NULL, NULL, 88, NULL, NULL, 167699),
(167700, '1.10.510.10-FF-004340', NULL, NULL, 131, NULL, NULL, 167700),
(167701, '1.25.10.10-FF-001069', NULL, 'Uncharacterized protein', 247, NULL, NULL, 167701),
(167702, '1.10.260.40-FF-000068', NULL, 'Uncharacterized protein', 69, NULL, NULL, 167702),
(167703, '3.40.395.10-FF-000043', NULL, 'Predicted protein', 109, NULL, NULL, 167703),
(167704, '1.25.10.10-FF-000996', NULL, 'Armadillo repeat-containing protein 8', 119, NULL, NULL, 167704),
(167705, '3.80.10.10-FF-001185', NULL, 'Acid labile subunit', 182, NULL, NULL, 167705),
(167706, '2.60.40.10-FF-000633', NULL, 'Sushi, nidogen and EGF like domains 1', 97, NULL, NULL, 167706),
(167707, '2.10.90.10-FF-000077', NULL, 'TransformIng Growth factor beta family', 103, NULL, NULL, 167707),
(167708, '2.60.120.1540-FF-000023', NULL, 'Complement component C5', 52, NULL, NULL, 167708),
(167709, '1.10.10.10-FF-001209', NULL, 'Metallo-beta-lactamase superfamily protein', 93, NULL, NULL, 167709),
(167710, '3.20.20.70-FF-000183', NULL, 'Orotidine-5-phosphate decarboxylase/orotate phosphoribosyltransferase', 260, NULL, NULL, 167710),
(167711, '3.30.40.10-FF-000031', NULL, 'Cellulose synthase', 92, NULL, NULL, 167711),
(167712, '3.50.50.60-FF-000675', NULL, 'Aerobic glycerol-3-phosphate dehydrogenase', 202, NULL, NULL, 167712),
(167713, '2.40.30.10-FF-000375', NULL, 'YALI0F29161p', 120, NULL, NULL, 167713),
(167714, '3.90.245.10-FF-000038', NULL, 'Uncharacterized protein', 163, NULL, NULL, 167714),
(167715, '1.10.30.10-FF-000013', NULL, 'High mobility group protein B3', 80, NULL, NULL, 167715),
(167716, '2.60.40.10-FF-001139', NULL, 'Hemicentin 1', 91, NULL, NULL, 167716),
(167717, '3.30.70.330-FF-000677', NULL, 'Cytoplasmic polyadenylation element-binding protein 3', 104, NULL, NULL, 167717),
(167718, '3.40.50.300-FF-007901', NULL, 'Uncharacterized protein', 189, NULL, NULL, 167718),
(167719, '3.30.1330.40-FF-000005', NULL, 'Enamine deaminase RidA (YjgF/YER057c/UK114 family)', 135, NULL, NULL, 167719),
(167720, '2.60.200.20-FF-000156', NULL, 'Kinesin-like protein', 71, NULL, NULL, 167720),
(167721, '1.10.730.10-FF-000028', NULL, 'Methionine--tRNA ligase, chloroplastic/mitochondrial', 181, NULL, NULL, 167721),
(167722, '3.20.20.70-FF-000525', NULL, 'Fructose-bisphosphate aldolase class 1', 258, NULL, NULL, 167722),
(167723, '2.60.120.10-FF-000113', NULL, 'cAMP-dependent protein kinase type II-alpha regulatory subunit isoform X2', 81, NULL, NULL, 167723),
(167724, '3.30.420.40-FF-000423', NULL, 'Chaperone protein DNAK, putative', 81, NULL, NULL, 167724),
(167725, '3.30.1130.10-FF-000026', NULL, 'Folic acid synthesis protein fol1', 126, NULL, NULL, 167725),
(167726, '1.10.10.10-FF-001541', NULL, 'General transcription factor IIE subunit 1', 86, NULL, NULL, 167726),
(167727, '3.30.160.60-FF-001555', NULL, 'Draculin-like 1', 26, NULL, NULL, 167727),
(167728, '1.25.40.10-FF-001239', NULL, 'Pentatricopeptide repeat-containing protein At4g31850, chloroplastic', 138, NULL, NULL, 167728),
(167729, '3.30.160.60-FF-002207', NULL, 'Zinc finger protein 74', 33, NULL, NULL, 167729),
(167730, '3.20.20.80-FF-000332', NULL, 'Alpha-L-fucosidase', 361, NULL, NULL, 167730),
(167731, '1.20.140.10-FF-000060', NULL, 'Acyl-CoA dehydrogenase FadE18', 146, NULL, NULL, 167731),
(167732, '3.30.2020.30-FF-000029', NULL, 'AEL035Wp', 90, NULL, NULL, 167732),
(167733, '1.20.890.10-FF-000032', NULL, 'Guanylate kinase, putative', 38, NULL, NULL, 167733),
(167734, '2.10.70.10-FF-000064', NULL, 'Fibulin 7', 60, NULL, NULL, 167734),
(167735, '3.30.70.330-FF-003083', NULL, NULL, 160, NULL, NULL, 167735),
(167736, '3.30.870.10-FF-000144', NULL, 'Uncharacterized protein', 198, NULL, NULL, 167736),
(167737, '1.25.40.10-FF-000060', NULL, 'Golgi to ER traffic protein 4 homolog', 293, NULL, NULL, 167737);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(167738, '3.40.30.10-FF-000772', NULL, 'OST3/OST6 family protein', 163, NULL, NULL, 167738),
(167739, '1.20.190.50-FF-000007', NULL, 'Nuclear pore complex protein', 258, NULL, NULL, 167739),
(167740, '3.40.50.300-FF-006412', NULL, 'Uncharacterized protein', 131, NULL, NULL, 167740),
(167741, '3.90.1200.10-FF-000063', NULL, 'Hydroxylysine kinase', 212, NULL, NULL, 167741),
(167742, '1.10.8.10-FF-000157', NULL, 'Phosphoprotein', 53, NULL, NULL, 167742),
(167743, '3.60.21.10-FF-000323', NULL, 'Slr0306 protein', 289, NULL, NULL, 167743),
(167744, '1.20.58.60-FF-000524', NULL, 'Uncharacterized protein', 317, NULL, NULL, 167744),
(167745, '3.30.430.20-FF-000058', NULL, 'Putative DUF26-domain protein kinase family protein', 115, NULL, NULL, 167745),
(167746, '3.40.50.1000-FF-000129', NULL, 'Calcium-translocating P-type ATPase PMCA-type', 156, NULL, NULL, 167746),
(167747, '1.10.840.10-FF-000019', NULL, 'Guanine nucleotide exchange factor LTE1', 264, NULL, NULL, 167747),
(167748, '3.40.50.150-FF-000038', NULL, 'Site-specific DNA-methyltransferase (adenine-specific)', 134, NULL, NULL, 167748),
(167749, '1.20.5.650-FF-000008', NULL, 'Transcription initiation factor IIIB chain BRF, putative', 45, NULL, NULL, 167749),
(167750, '1.10.20.10-FF-000187', NULL, 'Uncharacterized protein', 75, NULL, NULL, 167750),
(167751, '2.10.60.10-FF-000035', NULL, 'Receptor protein serine/threonine kinase', 80, NULL, NULL, 167751),
(167752, '1.10.472.10-FF-000299', NULL, 'BRF2, RNA polymerase III transcription initiation factor subunit', 102, NULL, NULL, 167752),
(167753, '1.25.10.10-FF-003323', NULL, 'Serine/threonine-protein kinase TOR', 139, NULL, NULL, 167753),
(167754, '3.90.1150.10-FF-000446', NULL, 'Aminotransferase, class III', 150, NULL, NULL, 167754),
(167755, '2.130.10.10-FF-005361', NULL, 'Wd-repeat protein, putative', 172, NULL, NULL, 167755),
(167756, '1.10.3730.20-FF-000008', NULL, 'EamA family transporter', 88, NULL, NULL, 167756),
(167757, '3.30.160.60-FF-006102', NULL, NULL, 61, NULL, NULL, 167757),
(167758, '1.25.10.10-FF-002233', NULL, 'Exportin-4', 1057, NULL, NULL, 167758),
(167759, '3.30.930.10-FF-000402', NULL, 'Uncharacterized protein', 112, NULL, NULL, 167759),
(167760, '1.10.510.10-FF-002086', NULL, 'Probable serine/threonine-protein kinase cdc7', 169, NULL, NULL, 167760),
(167761, '3.30.70.330-FF-000929', NULL, 'RNA-binding protein, putative', 89, NULL, NULL, 167761),
(167762, '3.40.50.80-FF-000187', NULL, 'YALI0C21362p', 120, NULL, NULL, 167762),
(167763, '3.40.50.300-FF-001033', NULL, 'Shikimate kinase 2, chloroplastic', 211, NULL, NULL, 167763),
(167764, '1.10.4080.10-FF-000011', NULL, 'Predicted protein', 306, NULL, NULL, 167764),
(167765, '3.20.20.60-FF-000085', NULL, '2,4-dihydroxyhept-2-ene-1,7-dioic acid aldolase', 264, NULL, NULL, 167765),
(167766, '2.130.10.10-FF-005158', NULL, 'Protein DECREASED SIZE EXCLUSION LIMIT 1', 139, NULL, NULL, 167766),
(167767, '3.30.300.20-FF-000054', NULL, 'Ribosome-binding factor A', 117, NULL, NULL, 167767),
(167768, '3.30.420.10-FF-000116', NULL, 'Putative DNA polymerase III epsilon subunit (3''-5'' exonuclease)', 54, NULL, NULL, 167768),
(167769, '3.20.10.10-FF-000035', NULL, 'Branched-chain-amino-acid aminotransferase', 164, NULL, NULL, 167769),
(167770, '1.25.40.60-FF-000012', NULL, 'SNARE docking complex subunit', 130, NULL, NULL, 167770),
(167771, '3.40.190.80-FF-000032', NULL, 'Putative inositol monophosphatase', 112, NULL, NULL, 167771),
(167772, '3.30.160.60-FF-002516', NULL, 'Zinc finger and SCAN domain-containing protein 26', 27, NULL, NULL, 167772),
(167773, '3.30.450.40-FF-000048', NULL, 'Free methionine-R-sulfoxide reductase', 183, NULL, NULL, 167773),
(167774, '3.60.10.10-FF-000371', NULL, 'Inositol polyphosphate-5-phosphatase Ka', 108, NULL, NULL, 167774),
(167775, '3.30.160.60-FF-005394', NULL, NULL, 23, NULL, NULL, 167775),
(167776, '1.10.3080.10-FF-000005', NULL, 'H(+)/Cl(-) exchange transporter ClcA', 446, NULL, NULL, 167776),
(167777, '2.80.10.50-FF-000148', NULL, 'Botulinum neurotoxin type B', 191, NULL, NULL, 167777),
(167778, '3.40.1170.60-FF-000030', NULL, NULL, 53, NULL, NULL, 167778);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(167779, '3.40.50.1220-FF-000088', NULL, 'Acetolactate synthase, large subunit, putative', 187, NULL, NULL, 167779),
(167780, '3.10.129.120-FF-000001', NULL, 'CurJ', 158, NULL, NULL, 167780),
(167781, '3.30.470.20-FF-000055', NULL, 'D-alanine--D-alanine ligase', 144, NULL, NULL, 167781),
(167782, '1.10.10.10-FF-000922', NULL, 'DNA-binding response regulator', 98, NULL, NULL, 167782),
(167783, '2.10.25.10-FF-001769', NULL, 'Uncharacterized protein', 35, NULL, NULL, 167783),
(167784, '3.40.50.1000-FF-000005', NULL, 'Calcium-transporting ATPase 1', 156, NULL, NULL, 167784),
(167785, '3.30.160.60-FF-002174', NULL, 'Zinc finger protein 786', 30, NULL, NULL, 167785),
(167786, '2.60.40.10-FF-004995', NULL, NULL, 107, NULL, NULL, 167786),
(167787, '2.60.40.150-FF-000322', NULL, 'Extended SYnapTotagmin homolog', 147, NULL, NULL, 167787),
(167788, '3.20.20.190-FF-000048', NULL, 'PI-PLC X domain-containing protein', 276, NULL, NULL, 167788),
(167789, '2.60.120.290-FF-000209', NULL, 'Uncharacterized protein', 132, NULL, NULL, 167789),
(167790, '3.20.20.140-FF-000314', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 303, NULL, NULL, 167790),
(167791, '3.40.50.1000-FF-000152', NULL, 'Phospholipid-transporting ATPase', 181, NULL, NULL, 167791),
(167792, '1.10.10.10-FF-000580', NULL, 'Cell division control protein', 94, NULL, NULL, 167792),
(167793, '3.40.850.10-FF-000528', NULL, 'Kinesin-like protein KIN-7N', 89, NULL, NULL, 167793),
(167794, '3.40.50.300-FF-002921', NULL, 'ATP-dependent DNA helicase', 162, NULL, NULL, 167794),
(167795, '1.50.40.10-FF-000321', NULL, 'Mitochondrial phosphate carrier protein, putative', 297, NULL, NULL, 167795),
(167796, '3.30.505.10-FF-000021', NULL, 'Putative SH2 domain-containing adapter protein F', 115, NULL, NULL, 167796),
(167797, '1.10.3460.10-FF-000012', NULL, 'Fucoxanthin chlorophyll a/c protein, LI818 clade', 183, NULL, NULL, 167797),
(167798, '3.30.160.20-FF-000065', NULL, 'Peptidyl-tRNA hydrolase domain protein', 102, NULL, NULL, 167798),
(167799, '2.30.140.10-FF-000025', NULL, 'Polyamine aminopropyltransferase', 52, NULL, NULL, 167799),
(167800, '3.40.720.10-FF-000339', NULL, 'Uncharacterized protein', 102, NULL, NULL, 167800),
(167801, '3.40.50.2000-FF-000569', NULL, 'UDP-glucosyltransferase', 179, NULL, NULL, 167801),
(167802, '1.10.1040.30-FF-000014', NULL, 'Uncharacterized protein', 133, NULL, NULL, 167802),
(167803, '3.40.970.40-FF-000001', NULL, 'Fibronectin-binding protein / Fibrinogen-binding protein', 50, NULL, NULL, 167803),
(167804, '3.40.50.300-FF-002213', NULL, 'Putative dynein heavy chain', 190, NULL, NULL, 167804),
(167805, '1.25.40.80-FF-000018', NULL, '(6-4) photolyase', 155, NULL, NULL, 167805),
(167806, '3.60.10.10-FF-000062', NULL, 'Putative phosphatase family protein', 360, NULL, NULL, 167806),
(167807, '1.10.238.270-FF-000009', NULL, 'GM21538', 155, NULL, NULL, 167807),
(167808, '2.130.10.10-FF-005922', NULL, 'Uncharacterized protein', 272, NULL, NULL, 167808),
(167809, '2.20.28.230-FF-000002', NULL, 'Interleukin-2 receptor subunit alpha', 62, NULL, NULL, 167809),
(167810, '3.80.10.10-FF-003107', NULL, 'Uncharacterized protein', 106, NULL, NULL, 167810),
(167811, '2.20.100.10-FF-000188', NULL, 'Uncharacterized protein, isoform B', 61, NULL, NULL, 167811),
(167812, '3.40.50.2300-FF-000777', NULL, NULL, 143, NULL, NULL, 167812),
(167813, '1.20.1560.10-FF-000770', NULL, 'Uncharacterized protein', 313, NULL, NULL, 167813),
(167814, '1.10.630.10-FF-000009', NULL, 'Cytochrome P450 26B1 isoform 1', 455, NULL, NULL, 167814),
(167815, '3.40.50.150-FF-001527', NULL, NULL, 101, NULL, NULL, 167815),
(167816, '3.30.1640.10-FF-000076', NULL, 'DNA helicase', 95, NULL, NULL, 167816),
(167817, '2.60.40.420-FF-000190', NULL, 'Blue copper protein', 121, NULL, NULL, 167817),
(167818, '1.25.40.180-FF-000263', NULL, NULL, 221, NULL, NULL, 167818),
(167819, '3.40.850.10-FF-000219', NULL, 'Kinesin-like protein', 315, NULL, NULL, 167819),
(167820, '3.20.20.80-FF-000641', NULL, 'Uncharacterized protein', 103, NULL, NULL, 167820),
(167821, '3.40.630.10-FF-000203', NULL, 'Carboxypeptidase M', 302, NULL, NULL, 167821); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(167822, '1.50.40.10-FF-000445', NULL, 'GH07093p', 145, NULL, NULL, 167822),
(167823, '3.10.580.10-FF-000143', NULL, 'Meiotically up-regulated gene 70 protein', 179, NULL, NULL, 167823),
(167824, '2.60.40.10-FF-000178', NULL, 'E3 ubiquitin-protein ligase TRIM9 isoform X1', 102, NULL, NULL, 167824),
(167825, '3.80.10.10-FF-002798', NULL, 'Uncharacterized protein', 157, NULL, NULL, 167825),
(167826, '2.40.160.40-FF-000005', NULL, 'Outer membrane protein', 208, NULL, NULL, 167826),
(167827, '3.30.160.60-FF-002735', NULL, 'Uncharacterized protein, isoform C', 80, NULL, NULL, 167827),
(167828, '2.60.120.260-FF-000105', NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', 143, NULL, NULL, 167828),
(167829, '3.40.50.300-FF-005086', NULL, 'Ras family protein', 63, NULL, NULL, 167829),
(167830, '3.40.50.300-FF-001960', NULL, 'Adenylate kinase 2', 218, NULL, NULL, 167830),
(167831, '1.25.40.10-FF-004112', NULL, 'Slr1196 protein', 136, NULL, NULL, 167831),
(167832, '3.80.10.10-FF-002674', NULL, 'Nodule autoregulation receptor-like protein kinase', 116, NULL, NULL, 167832),
(167833, '3.30.479.10-FF-000010', NULL, '6-carboxy-5,6,7,8-tetrahydropterin synthase', 115, NULL, NULL, 167833),
(167834, '3.40.50.410-FF-000369', NULL, 'Uncharacterized protein', 204, NULL, NULL, 167834),
(167835, '3.40.1110.10-FF-000264', NULL, 'Phospholipid-transporting ATPase', 161, NULL, NULL, 167835),
(167836, '1.10.287.770-FF-000028', NULL, 'Fusion glycoprotein F0', 48, NULL, NULL, 167836),
(167837, '2.60.40.10-FF-002522', NULL, 'Titin b', 96, NULL, NULL, 167837),
(167838, '2.40.50.90-FF-000158', NULL, 'Uncharacterized protein', 108, NULL, NULL, 167838),
(167839, '3.30.70.1660-FF-000037', NULL, 'Peptide chain release factor 1', 139, NULL, NULL, 167839),
(167840, '4.10.60.30-FF-000003', NULL, NULL, 70, NULL, NULL, 167840),
(167841, '1.10.10.60-FF-001308', NULL, NULL, 38, NULL, NULL, 167841),
(167842, '1.10.630.10-FF-000560', NULL, 'Predicted protein', 330, NULL, NULL, 167842),
(167843, '4.10.830.40-FF-000005', NULL, 'E3 ubiquitin-protein ligase TRIM9', 57, NULL, NULL, 167843),
(167844, '2.40.10.10-FF-000267', NULL, 'Uncharacterized protein', 103, NULL, NULL, 167844),
(167845, '1.25.40.10-FF-003712', NULL, 'Uncharacterized protein', 160, NULL, NULL, 167845),
(167846, '2.120.10.30-FF-000325', NULL, 'Putative quinoprotein dehydrogenase', 343, NULL, NULL, 167846),
(167847, '2.40.30.20-FF-000035', NULL, 'ATP synthase subunit alpha, mitochondrial', 69, NULL, NULL, 167847),
(167848, '3.60.10.10-FF-000404', NULL, 'Uncharacterized protein', 179, NULL, NULL, 167848),
(167849, '1.10.1280.10-FF-000003', NULL, 'Tyrosinase', 349, NULL, NULL, 167849),
(167850, '3.40.50.300-FF-002360', NULL, 'Ras-related protein Rab-2', 141, NULL, NULL, 167850),
(167851, '3.40.640.10-FF-000029', NULL, '4-aminobutyrate aminotransferase, mitochondrial', 301, NULL, NULL, 167851),
(167852, '1.20.920.30-FF-000041', NULL, 'Uncharacterized protein', 196, NULL, NULL, 167852),
(167853, '3.30.300.130-FF-000041', NULL, NULL, 69, NULL, NULL, 167853),
(167854, '2.130.10.10-FF-001319', NULL, 'Gastrulation defective protein 1', 196, NULL, NULL, 167854),
(167855, '1.25.40.10-FF-002167', NULL, 'Putative pentatricopeptide repeat-containing protein', 133, NULL, NULL, 167855),
(167856, '1.25.40.420-FF-000060', NULL, 'Uncharacterized protein', 103, NULL, NULL, 167856),
(167857, '1.25.40.10-FF-003926', NULL, 'Predicted protein', 291, NULL, NULL, 167857),
(167858, '1.10.510.10-FF-001467', NULL, 'Uncharacterized protein', 224, NULL, NULL, 167858),
(167859, '3.90.70.80-FF-000017', NULL, 'ubiquitin thioesterase OTU1', 173, NULL, NULL, 167859),
(167860, '3.30.70.1230-FF-000173', NULL, 'Adenylate/guanylate cyclase domain-containing protein', 190, NULL, NULL, 167860),
(167861, '2.60.120.970-FF-000077', NULL, 'Myoglianin', 240, NULL, NULL, 167861),
(167862, '3.40.50.410-FF-000245', NULL, 'Uncharacterized protein', 101, NULL, NULL, 167862),
(167863, '3.30.230.70-FF-000136', NULL, 'Uncharacterized protein', 177, NULL, NULL, 167863),
(167864, '1.20.1280.50-FF-000041', NULL, 'F-box only protein 48', 101, NULL, NULL, 167864);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(167865, '3.80.10.10-FF-002489', NULL, 'Uncharacterized protein', 123, NULL, NULL, 167865),
(167866, '2.60.40.4390-FF-000001', NULL, 'Flagellin', 105, NULL, NULL, 167866),
(167867, '1.10.840.10-FF-000042', NULL, 'Phosphoinositide phospholipase C', 267, NULL, NULL, 167867),
(167868, '3.40.50.300-FF-006631', NULL, 'Uncharacterized protein', 91, NULL, NULL, 167868),
(167869, '1.20.1530.20-FF-000018', NULL, 'Probable sodium/metabolite cotransporter BASS1, chloroplastic', 313, NULL, NULL, 167869),
(167870, '1.10.10.10-FF-000029', NULL, 'Proliferation-associated 2G4, a', 62, NULL, NULL, 167870),
(167871, '2.130.10.10-FF-005366', NULL, 'Uncharacterized protein', 170, NULL, NULL, 167871),
(167872, '3.30.540.30-FF-000018', NULL, 'Dipeptidyl peptidase 3', 172, NULL, NULL, 167872),
(167873, '3.40.50.300-FF-004153', NULL, 'Ras-related protein Rab-32B', 255, NULL, NULL, 167873),
(167874, '2.40.10.10-FF-000492', NULL, NULL, 166, NULL, NULL, 167874),
(167875, '1.10.287.70-FF-000667', NULL, 'Predicted protein', 118, NULL, NULL, 167875),
(167876, '2.60.40.10-FF-004787', NULL, NULL, 111, NULL, NULL, 167876),
(167877, '1.10.418.10-FF-000230', NULL, 'Uncharacterized protein', 91, NULL, NULL, 167877),
(167878, '1.20.920.10-FF-000147', NULL, 'Uncharacterized protein', 128, NULL, NULL, 167878),
(167879, '3.30.540.10-FF-000030', NULL, 'Inositol monophosphatase', 142, NULL, NULL, 167879),
(167880, '3.10.450.10-FF-000033', NULL, 'Cysteine proteinase inhibitor', 111, NULL, NULL, 167880),
(167881, '3.40.50.2300-FF-001502', NULL, NULL, 109, NULL, NULL, 167881),
(167882, '3.40.50.720-FF-001058', NULL, 'Pyrroline-5-carboxylate reductase', 174, NULL, NULL, 167882),
(167883, '3.30.160.60-FF-003808', NULL, NULL, 22, NULL, NULL, 167883),
(167884, '3.40.50.300-FF-007912', NULL, 'RuvB-like helicase', 184, NULL, NULL, 167884),
(167885, '3.30.70.330-FF-002026', NULL, NULL, 102, NULL, NULL, 167885),
(167886, '1.10.20.10-FF-000215', NULL, NULL, 128, NULL, NULL, 167886),
(167887, '3.30.479.20-FF-000024', NULL, 'Elongation factor Ts', 89, NULL, NULL, 167887),
(167888, '3.30.160.60-FF-000049', NULL, 'transcriptional repressor CTCF isoform X1', 29, NULL, NULL, 167888),
(167889, '3.40.50.1010-FF-000121', NULL, '20S-pre-rRNA D-site endonuclease NOB1', 147, NULL, NULL, 167889),
(167890, '3.30.160.60-FF-004332', NULL, NULL, 33, NULL, NULL, 167890),
(167891, '3.10.100.10-FF-000147', NULL, 'GD24195', 143, NULL, NULL, 167891),
(167892, '2.60.40.10-FF-001561', NULL, 'Jitterbug, isoform C', 87, NULL, NULL, 167892),
(167893, '3.30.980.10-FF-000017', NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', 174, NULL, NULL, 167893),
(167894, '1.10.555.10-FF-000019', NULL, 'Arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 3', 196, NULL, NULL, 167894),
(167895, '3.40.50.10190-FF-000136', NULL, 'DNA polymerase lambda subunit', 102, NULL, NULL, 167895),
(167896, '2.30.30.140-FF-000296', NULL, 'Predicted protein', 78, NULL, NULL, 167896),
(167897, '1.20.58.1590-FF-000002', NULL, 'Uncharacterized protein, isoform A', 197, NULL, NULL, 167897),
(167898, '3.60.15.10-FF-000022', NULL, 'DNA cross-link repair 1B', 170, NULL, NULL, 167898),
(167899, '1.10.238.20-FF-000022', NULL, 'Odorant-binding protein 21', 115, NULL, NULL, 167899),
(167900, '3.30.1120.10-FF-000071', NULL, 'Aryl-sulphate sulphohydrolase', 75, NULL, NULL, 167900),
(167901, '3.40.50.300-FF-002106', NULL, 'ATP-dependent helicase Lhr', 158, NULL, NULL, 167901),
(167902, '2.115.10.20-FF-000003', NULL, 'Levanbiose-producing levanase', 323, NULL, NULL, 167902),
(167903, '3.90.640.10-FF-000248', NULL, 'Endoplasmic reticulum chaperone BiP', 12, NULL, NULL, 167903),
(167904, '1.10.287.70-FF-000184', NULL, 'Two pore segment channel 2', 140, NULL, NULL, 167904),
(167905, '2.60.40.10-FF-000521', NULL, 'leukocyte surface antigen CD47', 102, NULL, NULL, 167905),
(167906, '3.30.1960.10-FF-000004', NULL, 'Transcription factor INI', 213, NULL, NULL, 167906),
(167907, '2.60.40.1170-FF-000013', NULL, 'AP-5 complex subunit mu-1 isoform X1', 116, NULL, NULL, 167907);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(167908, '3.30.60.270-FF-000022', NULL, 'Sortilin', 74, NULL, NULL, 167908),
(167909, '2.40.10.10-FF-000503', NULL, NULL, 87, NULL, NULL, 167909),
(167910, '2.10.25.10-FF-000819', NULL, 'Fibulin 7', 41, NULL, NULL, 167910),
(167911, '2.60.120.330-FF-000025', NULL, 'Gibberellin 2-beta-dioxygenase 2', 316, NULL, NULL, 167911),
(167912, '2.30.29.30-FF-000838', NULL, 'Associated with RAN (Nuclear import/export) function', 193, NULL, NULL, 167912),
(167913, '3.40.30.10-FF-000209', NULL, 'Protein disulfide isomerase like, testis expressed', 106, NULL, NULL, 167913),
(167914, '1.10.150.20-FF-000060', NULL, 'Mitochondrial DNA polymerase I protein C', 157, NULL, NULL, 167914),
(167915, '3.30.70.1820-FF-000001', NULL, 'Uncharacterized protein', 98, NULL, NULL, 167915),
(167916, '1.20.1250.20-FF-000558', NULL, 'MFS quinate transporter, putative', 482, NULL, NULL, 167916),
(167917, '1.10.10.60-FF-001191', NULL, NULL, 90, NULL, NULL, 167917),
(167918, '2.60.40.10-FF-006018', NULL, NULL, 98, NULL, NULL, 167918),
(167919, '3.30.505.50-FF-000005', NULL, 'Dormancy associated translation inhibitor', 48, NULL, NULL, 167919),
(167920, '1.25.40.180-FF-000055', NULL, 'Uncharacterized protein', 219, NULL, NULL, 167920),
(167921, '2.40.160.120-FF-000060', NULL, 'Uncharacterized protein', 74, NULL, NULL, 167921),
(167922, '1.20.1250.20-FF-001177', NULL, 'Uncharacterized protein', 205, NULL, NULL, 167922),
(167923, '1.10.510.10-FF-000618', NULL, 'Ribonuclease L', 265, NULL, NULL, 167923),
(167924, '2.70.98.40-FF-000016', NULL, NULL, 122, NULL, NULL, 167924),
(167925, '3.80.10.10-FF-002691', NULL, 'Receptor-like protein kinase HSL1', 77, NULL, NULL, 167925),
(167926, '1.20.1280.50-FF-000024', NULL, 'F-box/SPRY domain-containing protein 1', 39, NULL, NULL, 167926),
(167927, '1.25.40.10-FF-000964', NULL, 'Ethylene-overproduction protein 1', 80, NULL, NULL, 167927),
(167928, '3.20.20.80-FF-000545', NULL, 'Uncharacterized protein', 336, NULL, NULL, 167928),
(167929, '3.50.50.60-FF-000787', NULL, 'Amine oxidase', 247, NULL, NULL, 167929),
(167930, '3.40.50.300-FF-003534', NULL, 'Uncharacterized protein', 293, NULL, NULL, 167930),
(167931, '1.10.510.10-FF-002182', NULL, NULL, 82, NULL, NULL, 167931),
(167932, '1.10.8.140-FF-000009', NULL, 'Apoptosis-related protein', 81, NULL, NULL, 167932),
(167933, '2.10.25.10-FF-000336', NULL, 'von Willebrand factor A domain containing 2', 38, NULL, NULL, 167933),
(167934, '3.90.550.50-FF-000242', NULL, 'RFNG O-fucosylpeptide 3-beta-N-acetylglucosaminyltransferase', 175, NULL, NULL, 167934),
(167935, '3.40.50.620-FF-000769', NULL, 'ATP-binding protein', 115, NULL, NULL, 167935),
(167936, '3.40.50.2300-FF-000985', NULL, NULL, 83, NULL, NULL, 167936),
(167937, '3.30.70.330-FF-001407', NULL, NULL, 79, NULL, NULL, 167937),
(167938, '1.20.120.1080-FF-000109', NULL, 'Pre-mRNA splicing factor ATP-dependent RNA helicase, putative', 158, NULL, NULL, 167938),
(167939, '2.40.230.10-FF-000002', NULL, 'Phospholipase', 261, NULL, NULL, 167939),
(167940, '1.10.1170.10-FF-000001', NULL, 'baculoviral IAP repeat-containing protein 6 isoform X1', 107, NULL, NULL, 167940),
(167941, '2.40.50.90-FF-000046', NULL, 'Nuclease domain-containing protein 1', 168, NULL, NULL, 167941),
(167942, '3.40.950.10-FF-000042', NULL, NULL, 46, NULL, NULL, 167942),
(167943, '3.30.1370.10-FF-000212', NULL, 'Predicted protein', 127, NULL, NULL, 167943),
(167944, '3.30.160.60-FF-003713', NULL, NULL, 32, NULL, NULL, 167944),
(167945, '1.20.1070.10-FF-000783', NULL, 'Dopamine receptor D4b', 104, NULL, NULL, 167945),
(167946, '1.25.40.770-FF-000018', NULL, 'Uncharacterized protein', 100, NULL, NULL, 167946),
(167947, '3.30.530.20-FF-000105', NULL, 'Blr4478 protein', 150, NULL, NULL, 167947),
(167948, '3.10.20.90-FF-000852', NULL, 'Uncharacterized protein', 80, NULL, NULL, 167948),
(167949, '1.25.40.10-FF-003718', NULL, 'U3 small nucleolar RNA-associated protein 6 homolog', 187, NULL, NULL, 167949),
(167950, '1.10.510.10-FF-003592', NULL, NULL, 210, NULL, NULL, 167950),
(167951, '3.30.450.20-FF-000481', NULL, 'Chemotaxis protein', 132, NULL, NULL, 167951);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(167952, '3.30.60.30-FF-000252', NULL, 'Predicted protein', 39, NULL, NULL, 167952),
(167953, '3.30.40.10-FF-001543', NULL, 'YALI0E34650p', 59, NULL, NULL, 167953),
(167954, '1.10.287.1130-FF-000003', NULL, 'Cytochrome c oxidase copper chaperone', 66, NULL, NULL, 167954),
(167955, '2.40.30.10-FF-000066', NULL, 'Elongation factor Tu GTP-binding domain-containing protein 1', 164, NULL, NULL, 167955),
(167956, '1.10.10.10-FF-000130', NULL, 'COP9 signalosome complex subunit 4', 80, NULL, NULL, 167956),
(167957, '3.40.1160.10-FF-000109', NULL, 'Putative inactive aspartokinase 3 HI_1632', 36, NULL, NULL, 167957),
(167958, '1.10.8.60-FF-000043', NULL, 'Lon protease homolog, mitochondrial', 93, NULL, NULL, 167958),
(167959, '3.90.930.1-FF-000006', NULL, NULL, 134, NULL, NULL, 167959),
(167960, '3.30.160.60-FF-001459', NULL, 'Zinc finger protein 823', 28, NULL, NULL, 167960),
(167961, '2.30.30.100-FF-000183', NULL, 'Probable small nuclear ribonucleoprotein G', 76, NULL, NULL, 167961),
(167962, '3.30.70.890-FF-000047', NULL, 'Phosphomevalonate decarboxylase', 139, NULL, NULL, 167962),
(167963, '1.10.2000.10-FF-000017', NULL, 'Alpha 1 type XVIII collagen', 117, NULL, NULL, 167963),
(167964, '3.20.20.70-FF-000216', NULL, '3-dehydroquinate dehydratase', 238, NULL, NULL, 167964),
(167965, '2.60.40.10-FF-000942', NULL, 'Immunoglobulin heavy variable 3-23', 115, NULL, NULL, 167965),
(167966, '2.60.120.620-FF-000005', NULL, 'Egl nine homolog 1', 239, NULL, NULL, 167966),
(167967, '3.40.50.620-FF-000286', NULL, 'Isoleucine--tRNA ligase', 265, NULL, NULL, 167967),
(167968, '1.10.1450.10-FF-000146', NULL, 'Uncharacterized protein', 121, NULL, NULL, 167968),
(167969, '3.30.70.870-FF-000041', NULL, 'Elongation factor G 2', 77, NULL, NULL, 167969),
(167970, '1.10.246.60-FF-000013', NULL, NULL, 78, NULL, NULL, 167970),
(167971, '3.40.50.10490-FF-000024', NULL, '30S ribosomal protein S2', 202, NULL, NULL, 167971),
(167972, '3.30.420.10-FF-000436', NULL, NULL, 68, NULL, NULL, 167972),
(167973, '1.10.510.10-FF-003603', NULL, NULL, 201, NULL, NULL, 167973),
(167974, '3.50.50.60-FF-000692', NULL, 'Pyridine_nucleotide-disulphide_oxidoreductase_-_putative', 52, NULL, NULL, 167974),
(167975, '1.20.1560.10-FF-000753', NULL, 'ABC transporter B family member 27', 64, NULL, NULL, 167975),
(167976, '3.20.20.140-FF-000191', NULL, 'Amidohydrolase 2', 330, NULL, NULL, 167976),
(167977, '3.30.930.10-FF-000306', NULL, 'Phenylalanyl-tRNA synthetase alpha chain, putative', 82, NULL, NULL, 167977),
(167978, '3.90.180.10-FF-000117', NULL, 'Uncharacterized protein', 173, NULL, NULL, 167978),
(167979, '1.10.565.10-FF-000205', NULL, 'Uncharacterized protein', 165, NULL, NULL, 167979),
(167980, '4.10.60.10-FF-000250', NULL, 'DNA topoisomerase', 48, NULL, NULL, 167980),
(167981, '3.30.2350.10-FF-000003', NULL, 'tRNA pseudouridine synthase B', 249, NULL, NULL, 167981),
(167982, '3.30.70.330-FF-001088', NULL, 'RNA-binding protein, putative', 86, NULL, NULL, 167982),
(167983, '3.30.460.10-FF-000192', NULL, 'Predicted protein', 118, NULL, NULL, 167983),
(167984, '3.90.245.10-FF-000015', NULL, 'Inosine-uridine preferring nucleoside hydrolase', 314, NULL, NULL, 167984),
(167985, '2.30.30.490-FF-000041', NULL, 'Polybromo', 146, NULL, NULL, 167985),
(167986, '1.10.418.20-FF-000019', NULL, 'Uncharacterized protein', 65, NULL, NULL, 167986),
(167987, '2.60.40.4070-FF-000006', NULL, 'OmpA family protein', 83, NULL, NULL, 167987),
(167988, '3.30.1360.40-FF-000041', NULL, 'DNA topoisomerase 2', 103, NULL, NULL, 167988),
(167989, '1.25.10.10-FF-001058', NULL, 'U3 snoRNP protein', 520, NULL, NULL, 167989),
(167990, '3.30.65.10-FF-000004', NULL, 'Predicted DNA topoisomerase', 47, NULL, NULL, 167990),
(167991, '3.30.2410.10-FF-000042', NULL, 'MKIAA1625 protein', 84, NULL, NULL, 167991),
(167992, '3.40.50.720-FF-002468', NULL, 'Uncharacterized protein', 53, NULL, NULL, 167992),
(167993, '1.20.1080.10-FF-000059', NULL, 'Aquaporin-like protein', 265, NULL, NULL, 167993),
(167994, '3.40.30.10-FF-000440', NULL, 'BnaC02g02860D protein', 95, NULL, NULL, 167994);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(167995, '3.10.20.90-FF-000060', NULL, 'ubiquitin-like domain-containing CTD phosphatase 1', 81, NULL, NULL, 167995),
(167996, '3.40.140.10-FF-000008', NULL, 'Cytidine deaminase', 135, NULL, NULL, 167996),
(167997, '3.90.190.10-FF-000045', NULL, 'Tyrosine-protein phosphatase non-receptor type 12', 298, NULL, NULL, 167997),
(167998, '1.25.40.10-FF-002307', NULL, 'Uncharacterized protein', 246, NULL, NULL, 167998),
(167999, '2.60.40.10-FF-005725', NULL, NULL, 119, NULL, NULL, 167999),
(168000, '3.40.50.1240-FF-000173', NULL, NULL, 238, NULL, NULL, 168000),
(168001, '2.130.10.10-FF-003028', NULL, 'YALI0A20636p', 160, NULL, NULL, 168001),
(168002, '3.40.50.300-FF-006491', NULL, 'Predicted protein', 115, NULL, NULL, 168002),
(168003, '3.30.1390.20-FF-000003', NULL, '60S ribosomal protein L7', 105, NULL, NULL, 168003),
(168004, '3.90.550.10-FF-000028', NULL, 'beta-1,4-galactosyltransferase 1', 278, NULL, NULL, 168004),
(168005, '3.30.70.1230-FF-000279', NULL, 'Uncharacterized protein', 65, NULL, NULL, 168005),
(168006, '2.60.200.40-FF-000050', NULL, 'Diacylglycerol kinase, delta', 90, NULL, NULL, 168006),
(168007, '2.30.39.10-FF-000108', NULL, 'Serpin peptidase inhibitor 27', 149, NULL, NULL, 168007),
(168008, '3.30.60.20-FF-000018', NULL, 'Citron rho-interacting serine/threonine kinase', 57, NULL, NULL, 168008),
(168009, '1.20.1420.10-FF-000029', NULL, NULL, 174, NULL, NULL, 168009),
(168010, '2.60.40.10-FF-003359', NULL, NULL, 91, NULL, NULL, 168010),
(168011, '3.40.630.30-FF-000102', NULL, 'N-acetyltransferase', 97, NULL, NULL, 168011),
(168012, '1.10.287.770-FF-000023', NULL, 'Pickpocket 27', 56, NULL, NULL, 168012),
(168013, '3.40.720.10-FF-000103', NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase-like', 257, NULL, NULL, 168013),
(168014, '3.40.50.2000-FF-000221', NULL, 'Glycosyltransferase, group 1 family protein', 179, NULL, NULL, 168014),
(168015, '2.60.120.10-FF-000473', NULL, 'JmjC domain-containing protein E', 344, NULL, NULL, 168015),
(168016, '3.80.10.10-FF-001393', NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', 174, NULL, NULL, 168016),
(168017, '3.40.630.30-FF-000091', NULL, 'Peptide alpha-N-acetyltransferase', 160, NULL, NULL, 168017),
(168018, '3.40.50.300-FF-000196', NULL, 'Cell division control 3', 299, NULL, NULL, 168018),
(168019, '3.30.780.10-FF-000036', NULL, 'Protein CBG02294', 63, NULL, NULL, 168019),
(168020, '3.10.50.40-FF-000007', NULL, 'Chaperone SurA', 102, NULL, NULL, 168020),
(168021, '1.10.287.470-FF-000040', NULL, 'Membrane fusion protein (MFP) family protein', 85, NULL, NULL, 168021),
(168022, '3.80.10.10-FF-001281', NULL, 'Cyclic nucleotide-binding domain-containing protein', 179, NULL, NULL, 168022),
(168023, '2.130.10.10-FF-003921', NULL, 'Uncharacterized protein', 261, NULL, NULL, 168023),
(168024, '1.10.555.10-FF-000250', NULL, NULL, 144, NULL, NULL, 168024),
(168025, '2.60.40.1530-FF-000025', NULL, NULL, 114, NULL, NULL, 168025),
(168026, '2.60.120.10-FF-000585', NULL, 'CooA protein', 132, NULL, NULL, 168026),
(168027, '1.25.40.20-FF-001568', NULL, 'Uncharacterized protein', 75, NULL, NULL, 168027),
(168028, '1.10.510.10-FF-001237', NULL, 'GM20338', 200, NULL, NULL, 168028),
(168029, '1.10.150.50-FF-000170', NULL, 'Uncharacterized protein', 80, NULL, NULL, 168029),
(168030, '3.40.50.620-FF-000639', NULL, 'Phosphatidylinositol-binding clathrin assembly protein, putative', 73, NULL, NULL, 168030),
(168031, '1.20.1070.10-FF-001300', NULL, 'Olfactory receptor', 199, NULL, NULL, 168031),
(168032, '3.40.50.2000-FF-000676', NULL, 'Algn-2', 201, NULL, NULL, 168032),
(168033, '3.40.50.1480-FF-000014', NULL, 'Adenosylhomocysteinase', 116, NULL, NULL, 168033),
(168034, '3.40.50.1820-FF-001105', NULL, 'Carboxypeptidase', 298, NULL, NULL, 168034),
(168035, '2.130.10.10-FF-002623', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit', 204, NULL, NULL, 168035),
(168036, '1.20.58.90-FF-000044', NULL, NULL, 108, NULL, NULL, 168036),
(168037, '2.60.40.10-FF-002319', NULL, 'Zgc:162154', 94, NULL, NULL, 168037),
(168038, '3.20.20.80-FF-000192', NULL, 'Predicted protein', 331, NULL, NULL, 168038);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(168039, '1.20.1440.90-FF-000009', NULL, 'Phosphoenolpyruvate carboxylase', 123, NULL, NULL, 168039),
(168040, '1.10.287.370-FF-000105', NULL, 'Uncharacterized protein', 113, NULL, NULL, 168040),
(168041, '1.10.510.10-FF-004008', NULL, NULL, 155, NULL, NULL, 168041),
(168042, '3.40.50.1000-FF-000601', NULL, NULL, 100, NULL, NULL, 168042),
(168043, '1.10.10.60-FF-000246', NULL, 'Telomeric repeat-binding factor 2-interacting protein 1', 59, NULL, NULL, 168043),
(168044, '3.30.70.330-FF-000469', NULL, 'Heterogeneous nuclear ribonucleoprotein 1', 128, NULL, NULL, 168044),
(168045, '2.40.50.120-FF-000016', NULL, 'Metalloproteinase inhibitor 1', 92, NULL, NULL, 168045),
(168046, '3.30.50.10-FF-000060', NULL, 'GATA transcription factor 16', 66, NULL, NULL, 168046),
(168047, '3.40.50.10320-FF-000001', NULL, 'Mycothiol S-conjugate amidase', 291, NULL, NULL, 168047),
(168048, '3.30.505.10-FF-000252', NULL, NULL, 50, NULL, NULL, 168048),
(168049, '3.60.21.10-FF-000082', NULL, 'Endopolyphosphatase', 242, NULL, NULL, 168049),
(168050, '3.40.395.10-FF-000032', NULL, 'SUMO protease', 248, NULL, NULL, 168050),
(168051, '3.30.200.20-FF-001390', NULL, 'Uncharacterized protein', 78, NULL, NULL, 168051),
(168052, '1.25.40.70-FF-000032', NULL, 'Phosphatidylinositol-4,5-bisphosphate 3-kinase, putative', 216, NULL, NULL, 168052),
(168053, '3.40.1090.10-FF-000003', NULL, 'Patatin-like phospholipase domain-containing protein 2', 169, NULL, NULL, 168053),
(168054, '1.50.40.10-FF-000080', NULL, 'Mitochondrial substrate carrier protein-like', 164, NULL, NULL, 168054),
(168055, '3.40.50.1820-FF-000830', NULL, 'Alpha/beta-hydrolase', 123, NULL, NULL, 168055),
(168056, '1.10.3170.10-FF-000001', NULL, 'RecBCD enzyme subunit RecB', 195, NULL, NULL, 168056),
(168057, '3.30.40.10-FF-000587', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 113, NULL, NULL, 168057),
(168058, '3.80.10.10-FF-002702', NULL, 'CLL3 clavata1-like receptor S/T protein kinase protein', 281, NULL, NULL, 168058),
(168059, '1.20.1250.20-FF-000997', NULL, 'MFS transporter', 380, NULL, NULL, 168059),
(168060, '3.30.160.60-FF-002415', NULL, 'Zinc finger protein 700', 28, NULL, NULL, 168060),
(168061, '1.10.150.380-FF-000002', NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit E', 60, NULL, NULL, 168061),
(168062, '3.10.105.10-FF-000023', NULL, 'Peptide ABC transporter, periplasmic peptide-binding protein', 219, NULL, NULL, 168062),
(168063, '2.70.98.20-FF-000010', NULL, 'Amine oxidase', 503, NULL, NULL, 168063),
(168064, '4.10.280.10-FF-000004', NULL, 'Basic helix-loop-helix transcription factor', 64, NULL, NULL, 168064),
(168065, '3.40.50.300-FF-005872', NULL, 'Zinc finger NFX1-type containing homolog', 217, NULL, NULL, 168065),
(168066, '1.25.40.90-FF-000038', NULL, 'TOM1-like protein 2', 160, NULL, NULL, 168066),
(168067, '1.10.10.160-FF-000042', NULL, 'DNA helicase', 93, NULL, NULL, 168067),
(168068, '3.40.50.720-FF-002356', NULL, 'Uncharacterized protein', 123, NULL, NULL, 168068),
(168069, '3.30.160.60-FF-005725', NULL, NULL, 33, NULL, NULL, 168069),
(168070, '2.60.40.10-FF-003264', NULL, 'Cytokine receptor', 109, NULL, NULL, 168070),
(168071, '3.90.70.10-FF-000581', NULL, 'Uncharacterized protein', 304, NULL, NULL, 168071),
(168072, '1.10.1450.10-FF-000034', NULL, 'Tetraspanin', 82, NULL, NULL, 168072),
(168073, '1.10.30.10-FF-000143', NULL, 'Protein CBG07235', 97, NULL, NULL, 168073),
(168074, '3.30.700.10-FF-000014', NULL, 'Fimbrial protein', 130, NULL, NULL, 168074),
(168075, '3.20.20.150-FF-000082', NULL, 'Protein arginine N-methyltransferase 1.5', 172, NULL, NULL, 168075),
(168076, '3.90.1410.10-FF-000017', NULL, 'YBR030W-like protein', 281, NULL, NULL, 168076),
(168077, '2.60.40.150-FF-000086', NULL, 'Ras GTPase-activating protein 2 isoform 3', 156, NULL, NULL, 168077),
(168078, '2.10.50.10-FF-000080', NULL, 'Uninflatable, isoform C', 54, NULL, NULL, 168078),
(168079, '1.20.1560.10-FF-000641', NULL, 'Uncharacterized protein', 152, NULL, NULL, 168079),
(168080, '3.30.110.30-FF-000003', NULL, 'Proline--tRNA ligase, cytoplasmic', 80, NULL, NULL, 168080);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(168081, '2.60.120.200-FF-000554', NULL, 'Sex hormone binding globulin', 76, NULL, NULL, 168081),
(168082, '2.160.10.10-FF-000014', NULL, 'dynactin subunit 5', 165, NULL, NULL, 168082),
(168083, '2.120.10.80-FF-000424', NULL, 'Predicted protein', 130, NULL, NULL, 168083),
(168084, '2.40.50.140-FF-000915', NULL, NULL, 153, NULL, NULL, 168084),
(168085, '3.20.20.70-FF-000655', NULL, NULL, 231, NULL, NULL, 168085),
(168086, '3.30.1360.140-FF-000009', NULL, 'DNA-directed RNA polymerase subunit', 134, NULL, NULL, 168086),
(168087, '2.60.40.60-FF-000154', NULL, 'FAT atypical cadherin 4', 114, NULL, NULL, 168087),
(168088, '2.60.40.420-FF-000173', NULL, 'Laccase-like multicopper oxidase 2', 187, NULL, NULL, 168088),
(168089, '2.130.10.10-FF-003449', NULL, 'Uncharacterized protein', 124, NULL, NULL, 168089),
(168090, '3.90.1740.10-FF-000002', NULL, 'Uncharacterized protein', 225, NULL, NULL, 168090),
(168091, '2.130.10.10-FF-000257', NULL, 'semaphorin-4A isoform X2', 457, NULL, NULL, 168091),
(168092, '3.20.20.140-FF-000174', NULL, 'Dihydropyrimidinase-related protein 2', 373, NULL, NULL, 168092),
(168093, '3.30.200.20-FF-001401', NULL, 'Serine/threonine protein kinase', 125, NULL, NULL, 168093),
(168094, '3.10.450.120-FF-000002', NULL, 'PUA domain containing protein', 71, NULL, NULL, 168094),
(168095, '1.10.510.10-FF-004429', NULL, NULL, 59, NULL, NULL, 168095),
(168096, '1.25.10.10-FF-000232', NULL, 'leucine-rich repeat serine/threonine-protein kinase 2 isoform X1', 314, NULL, NULL, 168096),
(168097, '2.60.200.10-FF-000052', NULL, 'Uncharacterized protein', 132, NULL, NULL, 168097),
(168098, '3.40.50.300-FF-003989', NULL, 'ABC ATPase, putative (AFU_orthologue AFUA_1G16440)', 346, NULL, NULL, 168098),
(168099, '1.10.510.10-FF-001675', NULL, 'Predicted protein', 248, NULL, NULL, 168099),
(168100, '3.40.50.300-FF-007800', NULL, 'Uncharacterized protein', 44, NULL, NULL, 168100),
(168101, '3.30.200.20-FF-001631', NULL, 'Protein kinase superfamily protein', 94, NULL, NULL, 168101),
(168102, '3.40.50.150-FF-000706', NULL, 'O-methyltransferase', 261, NULL, NULL, 168102),
(168103, '2.60.40.10-FF-001010', NULL, 'Tyrosine-protein kinase receptor', 73, NULL, NULL, 168103),
(168104, '3.40.50.10190-FF-000024', NULL, 'Nibrin', 93, NULL, NULL, 168104),
(168105, '1.20.1560.10-FF-000539', NULL, 'Uncharacterized protein', 335, NULL, NULL, 168105),
(168106, '4.10.240.10-FF-000221', NULL, 'Casein kinase II subunit beta', 27, NULL, NULL, 168106),
(168107, '3.30.70.330-FF-002386', NULL, NULL, 98, NULL, NULL, 168107),
(168108, '2.70.170.10-FF-000237', NULL, 'Glycine receptor alpha 1 variant, putative', 71, NULL, NULL, 168108),
(168109, '2.10.220.10-FF-000082', NULL, 'Proprotein convertase subtilisin/kexin type 5a', 102, NULL, NULL, 168109),
(168110, '1.20.1070.10-FF-001290', NULL, 'Predicted protein', 277, NULL, NULL, 168110),
(168111, '1.10.287.70-FF-000537', NULL, 'Protein CBR-TWK-47', 72, NULL, NULL, 168111),
(168112, '3.60.10.10-FF-000163', NULL, 'Probable RNA-directed DNA polymerase from transposon BS', 214, NULL, NULL, 168112),
(168113, '3.10.20.410-FF-000004', NULL, 'Fimbrial biogenesis outer membrane usher protein', 114, NULL, NULL, 168113),
(168114, '3.40.50.10480-FF-000004', NULL, 'Ribosome production factor 1', 193, NULL, NULL, 168114),
(168115, '3.30.9.10-FF-000178', NULL, 'Slr0734 protein', 156, NULL, NULL, 168115),
(168116, '3.30.160.60-FF-004444', NULL, NULL, 68, NULL, NULL, 168116),
(168117, '2.30.29.30-FF-000968', NULL, 'Uncharacterized protein', 105, NULL, NULL, 168117),
(168118, '3.80.10.10-FF-003079', NULL, 'Uncharacterized protein', 128, NULL, NULL, 168118),
(168119, '3.40.50.1000-FF-000230', NULL, 'copper-transporting ATPase 1 isoform X1', 124, NULL, NULL, 168119),
(168120, '1.25.40.20-FF-000158', NULL, 'E3 ubiquitin-protein ligase MIB2 isoform X3', 129, NULL, NULL, 168120),
(168121, '2.60.40.60-FF-000603', NULL, 'Cadherin 4', 61, NULL, NULL, 168121),
(168122, '3.40.50.720-FF-000670', NULL, 'Probable peptide synthetase nrp', 437, NULL, NULL, 168122),
(168123, '1.20.5.5160-FF-000005', NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', 50, NULL, NULL, 168123);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(168124, '3.90.1150.10-FF-000210', NULL, 'Cysteine desulfurase', 123, NULL, NULL, 168124),
(168125, '1.10.150.80-FF-000050', NULL, 'Ribonuclease D, putative', 70, NULL, NULL, 168125),
(168126, '1.10.20.10-FF-000327', NULL, NULL, 122, NULL, NULL, 168126),
(168127, '1.10.287.110-FF-000292', NULL, 'Translocation protein SEC63-like protein', 86, NULL, NULL, 168127),
(168128, '3.30.450.40-FF-000262', NULL, 'Chromosome 21, whole genome shotgun sequence', 154, NULL, NULL, 168128),
(168129, '3.40.50.1000-FF-000573', NULL, NULL, 145, NULL, NULL, 168129),
(168130, '3.40.50.300-FF-002236', NULL, 'Shikimate kinase', 177, NULL, NULL, 168130),
(168131, '3.40.640.10-FF-000153', NULL, 'Serine palmitoyltransferase component', 246, NULL, NULL, 168131),
(168132, '3.30.930.10-FF-000296', NULL, 'Lysine--tRNA ligase', 357, NULL, NULL, 168132),
(168133, '1.25.10.10-FF-000653', NULL, 'RING-type E3 ubiquitin transferase', 133, NULL, NULL, 168133),
(168134, '3.20.20.80-FF-000433', NULL, 'Chromosome 16, whole genome shotgun sequence', 191, NULL, NULL, 168134),
(168135, '1.20.1070.10-FF-000002', NULL, 'Olfactory receptor', 293, NULL, NULL, 168135),
(168136, '2.130.10.10-FF-002511', NULL, 'Histidine kinase/response regulator hybrid protein', 305, NULL, NULL, 168136),
(168137, '3.40.50.300-FF-001617', NULL, 'Adenylate kinase 8', 208, NULL, NULL, 168137),
(168138, '1.20.1250.20-FF-001065', NULL, 'MFS general substrate transporter', 192, NULL, NULL, 168138),
(168139, '1.10.510.10-FF-000506', NULL, 'Serine/threonine-protein kinase rio2', 147, NULL, NULL, 168139),
(168140, '3.30.1310.30-FF-000001', NULL, 'Calcium channel, voltage-dependent, beta 4b subunit', 62, NULL, NULL, 168140),
(168141, '4.10.60.10-FF-000233', NULL, 'Uncharacterized protein', 28, NULL, NULL, 168141),
(168142, '2.30.30.190-FF-000041', NULL, NULL, 81, NULL, NULL, 168142),
(168143, '3.40.30.10-FF-000569', NULL, 'Glutathionyl-hydroquinone reductase YqjG', 159, NULL, NULL, 168143),
(168144, '3.30.160.60-FF-003685', NULL, NULL, 56, NULL, NULL, 168144),
(168145, '3.30.70.330-FF-002043', NULL, NULL, 125, NULL, NULL, 168145),
(168146, '3.40.1090.10-FF-000115', NULL, 'Patatin', 307, NULL, NULL, 168146),
(168147, '3.30.2170.10-FF-000017', NULL, NULL, 245, NULL, NULL, 168147),
(168148, '3.30.1540.20-FF-000032', NULL, NULL, 94, NULL, NULL, 168148),
(168149, '1.20.1260.10-FF-000045', NULL, 'Rubrerythrin family protein', 141, NULL, NULL, 168149),
(168150, '3.20.20.70-FF-000767', NULL, NULL, 351, NULL, NULL, 168150),
(168151, '3.80.10.10-FF-002814', NULL, 'Uncharacterized protein', 344, NULL, NULL, 168151),
(168152, '2.60.40.60-FF-000507', NULL, 'AGAP003579-PA', 104, NULL, NULL, 168152),
(168153, '3.50.50.60-FF-000332', NULL, 'Probable malate:quinone oxidoreductase', 138, NULL, NULL, 168153),
(168154, '2.30.180.10-FF-000045', NULL, 'Fasciclin domain family protein', 165, NULL, NULL, 168154),
(168155, '3.40.190.10-FF-000303', NULL, 'C4-dicarboxylate ABC transporter substrate-binding protein', 132, NULL, NULL, 168155),
(168156, '3.40.50.150-FF-001651', NULL, NULL, 223, NULL, NULL, 168156),
(168157, '2.60.40.10-FF-005276', NULL, NULL, 84, NULL, NULL, 168157),
(168158, '2.60.40.10-FF-001914', NULL, 'TAP binding protein-like variant', 141, NULL, NULL, 168158),
(168159, '2.60.270.20-FF-000003', NULL, 'Predicted protein', 90, NULL, NULL, 168159),
(168160, '2.120.10.80-FF-000003', NULL, 'Ectoderm-neural cortex protein 1', 83, NULL, NULL, 168160),
(168161, '1.25.40.20-FF-000607', NULL, 'Ankyrin repeat family protein', 178, NULL, NULL, 168161),
(168162, '1.10.238.10-FF-000244', NULL, 'Phospholipase C, epsilon 1', 81, NULL, NULL, 168162),
(168163, '2.30.30.40-FF-000019', NULL, 'Chemotaxis protein CheW', 59, NULL, NULL, 168163),
(168164, '3.90.70.10-FF-000351', NULL, 'Uncharacterized protein', 215, NULL, NULL, 168164),
(168165, '3.40.50.261-FF-000044', NULL, 'Uncharacterized protein', 63, NULL, NULL, 168165),
(168166, '3.80.10.10-FF-003528', NULL, 'Uncharacterized protein', 168, NULL, NULL, 168166),
(168167, '3.20.20.210-FF-000010', NULL, 'Uroporphyrinogen decarboxylase', 216, NULL, NULL, 168167);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(168168, '2.40.70.10-FF-000400', NULL, 'Uncharacterized protein', 271, NULL, NULL, 168168),
(168169, '2.10.25.10-FF-000696', NULL, 'Integrin beta', 44, NULL, NULL, 168169),
(168170, '3.10.129.10-FF-000264', NULL, 'Uncharacterized protein', 44, NULL, NULL, 168170),
(168171, '3.30.360.10-FF-000044', NULL, 'Uncharacterized protein', 113, NULL, NULL, 168171),
(168172, '2.60.40.10-FF-003376', NULL, 'Si:dkey-13m1.2', 95, NULL, NULL, 168172),
(168173, '2.60.120.320-FF-000005', NULL, 'Thiamine pyrophosphokinase', 72, NULL, NULL, 168173),
(168174, '2.60.40.2130-FF-000003', NULL, 'Spondin 2', 175, NULL, NULL, 168174),
(168175, '3.30.200.20-FF-000092', NULL, 'Serine/threonine-protein kinase 24', 92, NULL, NULL, 168175),
(168176, '1.20.120.350-FF-000030', NULL, 'sodium leak channel non-selective protein', 125, NULL, NULL, 168176),
(168177, '3.30.70.100-FF-000176', NULL, NULL, 67, NULL, NULL, 168177),
(168178, '3.30.70.1230-FF-000150', NULL, 'Guanylate cyclase', 168, NULL, NULL, 168178),
(168179, '1.20.140.150-FF-000070', NULL, 'peripheral myelin protein 22-like', 157, NULL, NULL, 168179),
(168180, '1.10.8.60-FF-000498', NULL, 'Predicted protein', 111, NULL, NULL, 168180),
(168181, '2.70.130.10-FF-000033', NULL, 'Lysosomal enzyme receptor protein', 151, NULL, NULL, 168181),
(168182, '1.10.3480.10-FF-000002', NULL, 'Tat proofreading chaperone DmsD', 204, NULL, NULL, 168182),
(168183, '1.20.1540.10-FF-000095', NULL, 'Rhomboid domain-containing protein 3', 168, NULL, NULL, 168183),
(168184, '1.20.120.220-FF-000019', NULL, 'ATP synthase subunit a', 161, NULL, NULL, 168184),
(168185, '3.60.21.10-FF-000401', NULL, 'Uncharacterized protein', 309, NULL, NULL, 168185),
(168186, '3.40.50.300-FF-003085', NULL, 'Rab family GTPase', 182, NULL, NULL, 168186),
(168187, '3.30.70.3600-FF-000001', NULL, NULL, 64, NULL, NULL, 168187),
(168188, '3.30.420.40-FF-000434', NULL, 'Actin-related protein 2', 120, NULL, NULL, 168188),
(168189, '2.130.10.10-FF-005496', NULL, 'Uncharacterized protein', 114, NULL, NULL, 168189),
(168190, '2.60.40.60-FF-000024', NULL, 'FAT atypical cadherin 3', 103, NULL, NULL, 168190),
(168191, '3.90.1410.10-FF-000129', NULL, 'Cytochrome c lysine N-methyltransferase 1', 281, NULL, NULL, 168191),
(168192, '3.40.50.300-FF-001168', NULL, 'nucleolar RNA helicase 2', 234, NULL, NULL, 168192),
(168193, '2.30.29.30-FF-000389', NULL, 'FYVE, RhoGEF and PH domain containing 3', 99, NULL, NULL, 168193),
(168194, '3.90.1600.10-FF-000060', NULL, 'DNA polymerase', 150, NULL, NULL, 168194),
(168195, '4.10.280.10-FF-000116', NULL, 'Putative HLH transcription factor', 93, NULL, NULL, 168195),
(168196, '2.170.270.10-FF-000182', NULL, 'Uncharacterized protein', 65, NULL, NULL, 168196),
(168197, '1.10.357.140-FF-000025', NULL, 'Protoheme IX farnesyltransferase', 152, NULL, NULL, 168197),
(168198, '3.50.50.60-FF-001181', NULL, 'NADPH-adrenodoxin reductase', 134, NULL, NULL, 168198),
(168199, '1.20.1250.20-FF-001626', NULL, 'FabG, Dehydrogenase', 116, NULL, NULL, 168199),
(168200, '3.40.30.10-FF-001188', NULL, 'Uncharacterized protein', 146, NULL, NULL, 168200),
(168201, '2.40.50.140-FF-000674', NULL, 'Related to RFA2-DNA replication factor A, 36 kDa subunit', 136, NULL, NULL, 168201),
(168202, '3.10.28.10-FF-000071', NULL, 'Replicative DNA helicase', 101, NULL, NULL, 168202),
(168203, '1.25.10.10-FF-000310', NULL, 'RING-type E3 ubiquitin transferase', 321, NULL, NULL, 168203),
(168204, '2.60.40.10-FF-003831', NULL, NULL, 106, NULL, NULL, 168204),
(168205, '1.10.10.1600-FF-000002', NULL, 'DNA polymerase III subunit alpha', 81, NULL, NULL, 168205),
(168206, '3.60.40.10-FF-000327', NULL, 'Uncharacterized protein', 172, NULL, NULL, 168206),
(168207, '1.25.40.10-FF-004207', NULL, 'Pentatricopeptide repeat-containing protein', 67, NULL, NULL, 168207),
(168208, '3.30.160.60-FF-006018', NULL, NULL, 32, NULL, NULL, 168208),
(168209, '3.30.1360.170-FF-000007', NULL, 'FAD-dependent thymidylate synthase', 214, NULL, NULL, 168209),
(168210, '3.40.33.10-FF-000025', NULL, 'Predicted protein', 144, NULL, NULL, 168210),
(168211, '3.40.1010.20-FF-000001', NULL, '4-hydroxy-3-methylbut-2-enyl diphosphate reductase', 100, NULL, NULL, 168211);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(168212, '3.30.70.330-FF-000918', NULL, 'Regulatory protein E2', 86, NULL, NULL, 168212),
(168213, '2.130.10.10-FF-003904', NULL, 'Uncharacterized protein', 269, NULL, NULL, 168213),
(168214, '3.20.20.140-FF-000202', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 287, NULL, NULL, 168214),
(168215, '3.40.50.300-FF-004591', NULL, '6-phosphofructo-2-kinase-like protein', 168, NULL, NULL, 168215),
(168216, '3.80.10.10-FF-002253', NULL, 'GH22922p', 115, NULL, NULL, 168216),
(168217, '2.10.110.10-FF-000202', NULL, 'LIM-domain protein', 39, NULL, NULL, 168217),
(168218, '3.50.50.80-FF-000001', NULL, 'ubiquitin-like modifier-activating enzyme 1', 119, NULL, NULL, 168218),
(168219, '3.80.10.10-FF-004147', NULL, 'Predicted protein', 107, NULL, NULL, 168219),
(168220, '2.40.30.10-FF-000403', NULL, 'Uncharacterized protein', 77, NULL, NULL, 168220),
(168221, '2.30.30.620-FF-000001', NULL, 'major vault protein-like', 75, NULL, NULL, 168221),
(168222, '3.50.50.60-FF-000815', NULL, 'Zgc:77439', 167, NULL, NULL, 168222),
(168223, '3.40.50.880-FF-000004', NULL, 'Homoserine O-succinyltransferase', 301, NULL, NULL, 168223),
(168224, '3.30.160.20-FF-000166', NULL, 'Uncharacterized protein', 109, NULL, NULL, 168224),
(168225, '2.30.30.40-FF-000120', NULL, 'dynamin-binding protein isoform X1', 64, NULL, NULL, 168225),
(168226, '3.40.50.150-FF-000145', NULL, 'Methyltransferase-like protein', 268, NULL, NULL, 168226),
(168227, '1.25.10.10-FF-002570', NULL, 'Predicted protein', 166, NULL, NULL, 168227),
(168228, '3.40.47.10-FF-000080', NULL, '3-oxoacyl-[acyl-carrier protein] synthase II', 328, NULL, NULL, 168228),
(168229, '1.20.1440.100-FF-000012', NULL, 'Possible phosphoserine phosphatase', 74, NULL, NULL, 168229),
(168230, '1.10.10.10-FF-000501', NULL, 'Ferric uptake regulator family protein', 84, NULL, NULL, 168230),
(168231, '1.10.1740.10-FF-000022', NULL, 'RNA polymerase sigma factor', 106, NULL, NULL, 168231),
(168232, '2.30.42.10-FF-000487', NULL, NULL, 121, NULL, NULL, 168232),
(168233, '1.20.1270.60-FF-000313', NULL, 'BAI1-associated protein 2b', 49, NULL, NULL, 168233),
(168234, '3.40.50.2000-FF-000564', NULL, 'CalG3', 221, NULL, NULL, 168234),
(168235, '2.130.10.10-FF-004540', NULL, 'Uncharacterized protein', 224, NULL, NULL, 168235),
(168236, '3.30.200.20-FF-000221', NULL, 'Putative serine/threonine-protein kinase PLK4', 89, NULL, NULL, 168236),
(168237, '3.30.1010.10-FF-000079', NULL, 'Probable serine/threonine-protein kinase atr1', 176, NULL, NULL, 168237),
(168238, '3.40.1800.20-FF-000022', NULL, 'Uncharacterized protein, isoform A', 75, NULL, NULL, 168238),
(168239, '2.80.10.50-FF-000272', NULL, 'Predicted protein', 107, NULL, NULL, 168239),
(168240, '2.60.40.150-FF-000069', NULL, 'Ras GTPase-activating protein 4 isoform 1', 130, NULL, NULL, 168240),
(168241, '1.10.1410.10-FF-000037', NULL, 'Topoisomerase, putative', 163, NULL, NULL, 168241),
(168242, '2.40.50.140-FF-000011', NULL, '30S ribosomal protein S1', 88, NULL, NULL, 168242),
(168243, '2.30.110.10-FF-000080', NULL, 'Protein CREG1 isoform A', 78, NULL, NULL, 168243),
(168244, '3.30.70.1230-FF-000049', NULL, 'Guanylyl cyclase', 199, NULL, NULL, 168244),
(168245, '3.90.70.40-FF-000005', NULL, 'Ataxin 3', 129, NULL, NULL, 168245),
(168246, '1.20.120.1240-FF-000074', NULL, 'Dynamin-related protein 3A', 162, NULL, NULL, 168246),
(168247, '1.50.10.10-FF-000038', NULL, 'Phosphorylase b kinase regulatory subunit', 312, NULL, NULL, 168247),
(168248, '3.30.1780.10-FF-000018', NULL, 'Ornithine cyclodeaminase', 89, NULL, NULL, 168248),
(168249, '3.40.850.10-FF-000427', NULL, 'Motor domain of KIF6', 164, NULL, NULL, 168249),
(168250, '3.30.420.610-FF-000009', NULL, 'Tudor domain-containing protein 7 isoform X2', 82, NULL, NULL, 168250),
(168251, '1.25.40.10-FF-005152', NULL, 'Uncharacterized protein', 92, NULL, NULL, 168251),
(168252, '3.40.30.10-FF-000339', NULL, 'Os03g0335300 protein', 132, NULL, NULL, 168252),
(168253, '3.30.450.20-FF-000593', NULL, 'BfiS', 134, NULL, NULL, 168253),
(168254, '1.20.58.390-FF-000121', NULL, 'Uncharacterized protein', 74, NULL, NULL, 168254);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(168255, '2.10.25.10-FF-001308', NULL, 'Uncharacterized protein', 34, NULL, NULL, 168255),
(168256, '1.25.10.10-FF-003087', NULL, 'Predicted protein', 231, NULL, NULL, 168256),
(168257, '2.30.39.10-FF-000125', NULL, 'Uncharacterized protein', 28, NULL, NULL, 168257),
(168258, '3.30.1400.10-FF-000002', NULL, 'Cell division protein ZipA', 138, NULL, NULL, 168258),
(168259, '3.30.230.10-FF-000383', NULL, 'Uncharacterized protein', 175, NULL, NULL, 168259),
(168260, '3.40.50.300-FF-003646', NULL, 'ATP-dependent RNA helicase', 208, NULL, NULL, 168260),
(168261, '1.10.238.10-FF-000114', NULL, 'RAS guanyl releasing protein 4', 79, NULL, NULL, 168261),
(168262, '3.80.10.10-FF-001730', NULL, 'Uncharacterized protein', 151, NULL, NULL, 168262),
(168263, '1.10.510.10-FF-002294', NULL, NULL, 120, NULL, NULL, 168263),
(168264, '3.80.10.10-FF-001634', NULL, 'Si:ch211-201o1.1', 263, NULL, NULL, 168264),
(168265, '3.40.366.10-FF-000066', NULL, 'Chromosome 23, whole genome shotgun sequence', 127, NULL, NULL, 168265),
(168266, '1.20.1250.10-FF-000090', NULL, NULL, 159, NULL, NULL, 168266),
(168267, '1.50.10.10-FF-000140', NULL, 'alpha-1,2-Mannosidase', 502, NULL, NULL, 168267),
(168268, '1.20.58.390-FF-000149', NULL, 'Uncharacterized protein', 68, NULL, NULL, 168268),
(168269, '3.40.800.10-FF-000025', NULL, 'Agmatinase protein', 286, NULL, NULL, 168269),
(168270, '3.40.140.10-FF-000025', NULL, 'Riboflavin biosynthesis protein RibD', 141, NULL, NULL, 168270),
(168271, '1.10.472.80-FF-000044', NULL, 'GTPase-activating protein GYP5', 177, NULL, NULL, 168271),
(168272, '3.30.1370.10-FF-000100', NULL, 'Putative branch point binding protein', 120, NULL, NULL, 168272),
(168273, '1.10.10.10-FF-001653', NULL, 'Ribosomal protein S25', 76, NULL, NULL, 168273),
(168274, '3.40.630.30-FF-000074', NULL, 'N(alpha)-acetyltransferase 50, NatE catalytic subunit', 78, NULL, NULL, 168274),
(168275, '3.50.50.60-FF-001304', NULL, 'Mercuric reductase, putative', 125, NULL, NULL, 168275),
(168276, '1.10.472.80-FF-000140', NULL, 'TBC domain containing protein', 132, NULL, NULL, 168276),
(168277, '3.10.20.90-FF-000043', NULL, 'serine/threonine-protein kinase OSR1 isoform X1', 96, NULL, NULL, 168277),
(168278, '3.40.50.1240-FF-000190', NULL, NULL, 67, NULL, NULL, 168278),
(168279, '1.10.600.10-FF-000047', NULL, 'Terpene synthase', 307, NULL, NULL, 168279),
(168280, '3.10.290.70-FF-000021', NULL, NULL, 44, NULL, NULL, 168280),
(168281, '3.90.660.20-FF-000005', NULL, 'NAD(P)-binding Rossmann-like domain protein', 20, NULL, NULL, 168281),
(168282, '3.30.160.60-FF-001347', NULL, 'Transcription factor IIIA', 26, NULL, NULL, 168282),
(168283, '3.10.580.10-FF-000149', NULL, 'Uncharacterized protein', 166, NULL, NULL, 168283),
(168284, '3.30.70.330-FF-002947', NULL, NULL, 110, NULL, NULL, 168284),
(168285, '3.10.130.10-FF-000003', NULL, 'Inactive ribonuclease-like protein 9', 126, NULL, NULL, 168285),
(168286, '1.25.40.10-FF-000481', NULL, 'Mitochondrial fission 1 protein', 119, NULL, NULL, 168286),
(168287, '1.20.1250.20-FF-001969', NULL, 'Uncharacterized protein', 410, NULL, NULL, 168287),
(168288, '3.40.50.300-FF-000549', NULL, 'ABC transporter ATP-binding protein arb1', 240, NULL, NULL, 168288),
(168289, '2.60.120.40-FF-000009', NULL, 'Multimerin-1', 138, NULL, NULL, 168289),
(168290, '2.10.70.10-FF-000300', NULL, 'Uncharacterized protein', 41, NULL, NULL, 168290),
(168291, '3.40.50.300-FF-008317', NULL, 'Uncharacterized protein', 251, NULL, NULL, 168291),
(168292, '1.10.287.70-FF-000307', NULL, 'TWiK family of potassium channels', 317, NULL, NULL, 168292),
(168293, '3.30.1360.150-FF-000001', NULL, 'Alkaline phosphatase PhoK', 125, NULL, NULL, 168293),
(168294, '2.60.120.260-FF-000656', NULL, 'Uncharacterized protein', 86, NULL, NULL, 168294),
(168295, '2.60.40.10-FF-001347', NULL, 'Vascular endothelial growth factor receptor 1', 114, NULL, NULL, 168295),
(168296, '3.30.70.330-FF-001537', NULL, 'AGAP002655-PA', 141, NULL, NULL, 168296),
(168297, '3.40.50.1100-FF-000176', NULL, 'YALI0B16214p', 204, NULL, NULL, 168297),
(168298, '1.20.920.10-FF-000035', NULL, 'Uncharacterized protein', 131, NULL, NULL, 168298);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(168299, '3.30.420.10-FF-000324', NULL, NULL, 112, NULL, NULL, 168299),
(168300, '1.25.10.10-FF-001625', NULL, 'Uncharacterized protein', 496, NULL, NULL, 168300),
(168301, '3.30.300.30-FF-000158', NULL, 'Predicted protein', 102, NULL, NULL, 168301),
(168302, '2.40.50.100-FF-000139', NULL, 'Exosome complex exonuclease subunit, putative', 65, NULL, NULL, 168302),
(168303, '2.40.10.10-FF-000520', NULL, NULL, 35, NULL, NULL, 168303),
(168304, '3.40.50.300-FF-005900', NULL, 'tRNA modification GTPase GTPBP3, mitochondrial', 184, NULL, NULL, 168304),
(168305, '1.20.1250.20-FF-002245', NULL, 'Os05g0169700 protein', 112, NULL, NULL, 168305),
(168306, '3.30.420.140-FF-000048', NULL, 'Uncharacterized protein', 69, NULL, NULL, 168306),
(168307, '3.40.50.1820-FF-000279', NULL, 'Family of serine hydrolases', 243, NULL, NULL, 168307),
(168308, '2.130.10.10-FF-004877', NULL, 'Uncharacterized protein', 120, NULL, NULL, 168308),
(168309, '1.25.10.10-FF-002238', NULL, 'Uncharacterized protein', 381, NULL, NULL, 168309),
(168310, '2.70.50.40-FF-000013', NULL, 'Uncharacterized protein', 124, NULL, NULL, 168310),
(168311, '3.80.10.10-FF-002461', NULL, 'Uncharacterized protein', 110, NULL, NULL, 168311),
(168312, '1.20.1560.10-FF-000669', NULL, 'ATP-binding cassette transporter, subfamily B, member 21, group MDR/PGP protein PpABCB21', 39, NULL, NULL, 168312),
(168313, '3.20.20.70-FF-000312', NULL, '7-carboxy-7-deazaguanine synthase', 233, NULL, NULL, 168313),
(168314, '3.30.160.60-FF-000830', NULL, 'zinc finger protein 596 isoform X1', 28, NULL, NULL, 168314),
(168315, '3.30.870.10-FF-000127', NULL, 'AaceriAAR169Cp', 293, NULL, NULL, 168315),
(168316, '3.20.20.100-FF-000089', NULL, 'Aldo-keto reductase family 1, member B1 (aldose reductase)', 318, NULL, NULL, 168316),
(168317, '2.40.70.10-FF-000271', NULL, NULL, 155, NULL, NULL, 168317),
(168318, '3.30.1360.10-FF-000043', NULL, 'RNA polymerase Rpb3/Rpb11 dimerization domain-containing protein', 106, NULL, NULL, 168318),
(168319, '1.20.1280.50-FF-000272', NULL, 'F-box/leucine rich repeat protein, putative', 33, NULL, NULL, 168319),
(168320, '1.10.3720.10-FF-000038', NULL, 'Nickel ABC transporter permease subunit NikC', 207, NULL, NULL, 168320),
(168321, '3.40.50.300-FF-003293', NULL, 'Putative insertion sequence ATP-binding protein', 82, NULL, NULL, 168321),
(168322, '2.30.42.10-FF-000583', NULL, NULL, 128, NULL, NULL, 168322),
(168323, '1.20.1250.20-FF-000328', NULL, 'Solute carrier family 45 member 4', 252, NULL, NULL, 168323),
(168324, '1.25.40.20-FF-001670', NULL, 'Uncharacterized protein', 82, NULL, NULL, 168324),
(168325, '2.60.200.20-FF-000173', NULL, 'FHA domain containing protein, putative', 96, NULL, NULL, 168325),
(168326, '3.30.160.60-FF-003472', NULL, 'Zinc finger protein 985', 25, NULL, NULL, 168326),
(168327, '3.30.160.60-FF-000279', NULL, 'gastrula zinc finger protein XlCGF58.1-like isoform X1', 29, NULL, NULL, 168327),
(168328, '3.30.40.10-FF-001200', NULL, 'RING finger protein', 97, NULL, NULL, 168328),
(168329, '1.10.565.10-FF-000195', NULL, 'Uncharacterized protein', 93, NULL, NULL, 168329),
(168330, '2.30.30.40-FF-000463', NULL, 'Uncharacterized protein', 61, NULL, NULL, 168330),
(168331, '2.60.120.10-FF-000130', NULL, 'Protein kinase, cGMP-dependent', 134, NULL, NULL, 168331),
(168332, '3.40.50.300-FF-003877', NULL, 'Uncharacterized protein', 122, NULL, NULL, 168332),
(168333, '2.120.10.30-FF-000550', NULL, 'Uncharacterized protein', 86, NULL, NULL, 168333),
(168334, '3.30.70.330-FF-000132', NULL, 'Small nuclear ribonucleoprotein U11/U12 subunit 35', 122, NULL, NULL, 168334),
(168335, '2.60.40.10-FF-004545', NULL, NULL, 83, NULL, NULL, 168335),
(168336, '2.10.60.10-FF-000018', NULL, 'BMP and activin membrane-bound inhibitor homolog', 99, NULL, NULL, 168336),
(168337, '3.30.70.2100-FF-000001', NULL, 'Amine oxidase', 64, NULL, NULL, 168337),
(168338, '1.10.340.30-FF-000004', NULL, 'DNA-3-methyladenine glycosylase II', 121, NULL, NULL, 168338),
(168339, '3.40.50.1220-FF-000083', NULL, 'Pyruvate oxidase', 167, NULL, NULL, 168339),
(168340, '3.40.50.720-FF-000782', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', 194, NULL, NULL, 168340);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(168341, '3.50.50.60-FF-000124', NULL, 'Glutamate synthase small subunit', 126, NULL, NULL, 168341),
(168342, '3.90.660.10-FF-000019', NULL, 'lysine-specific histone demethylase 1 homolog 3', 237, NULL, NULL, 168342),
(168343, '2.60.34.10-FF-000006', NULL, 'Heat shock protein cognate 5', 125, NULL, NULL, 168343),
(168344, '1.10.10.10-FF-000473', NULL, 'Caffeic acid O-methyltransferase', 110, NULL, NULL, 168344),
(168345, '3.90.550.10-FF-000466', NULL, 'Slr1070 protein', 226, NULL, NULL, 168345),
(168346, '2.130.10.10-FF-003000', NULL, 'Utp5p', 190, NULL, NULL, 168346),
(168347, '1.20.1280.290-FF-000094', NULL, 'Uncharacterized protein', 88, NULL, NULL, 168347),
(168348, '2.130.10.10-FF-004085', NULL, 'Uncharacterized protein', 200, NULL, NULL, 168348),
(168349, '1.25.10.10-FF-000102', NULL, 'Sister chromatid cohesion protein PDS5 homolog A', 378, NULL, NULL, 168349),
(168350, '1.25.40.10-FF-004887', NULL, 'Uncharacterized protein', 222, NULL, NULL, 168350),
(168351, '2.60.40.60-FF-000715', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1', 100, NULL, NULL, 168351),
(168352, '3.30.565.10-FF-000244', NULL, 'Two-component sensor histidine kinase', 161, NULL, NULL, 168352),
(168353, '2.40.50.140-FF-000466', NULL, 'Replication factor A (SsDNA-binding protein)', 107, NULL, NULL, 168353),
(168354, '2.60.40.10-FF-002415', NULL, 'Predicted gene 15448', 95, NULL, NULL, 168354),
(168355, '3.40.50.1240-FF-000201', NULL, NULL, 78, NULL, NULL, 168355),
(168356, '3.30.300.20-FF-000037', NULL, 'Organic hydroperoxide resistance protein', 97, NULL, NULL, 168356),
(168357, '3.30.240.10-FF-000001', NULL, 'Regulatory protein cro', 66, NULL, NULL, 168357),
(168358, '1.10.510.10-FF-002423', NULL, NULL, 128, NULL, NULL, 168358),
(168359, '3.90.190.10-FF-000483', NULL, 'Uncharacterized protein', 168, NULL, NULL, 168359),
(168360, '1.10.510.10-FF-003362', NULL, NULL, 123, NULL, NULL, 168360),
(168361, '1.10.405.10-FF-000020', NULL, 'Rab proteins geranylgeranyltransferase component', 113, NULL, NULL, 168361),
(168362, '3.40.50.1820-FF-000728', NULL, 'Lipase', 254, NULL, NULL, 168362),
(168363, '1.20.1560.10-FF-000192', NULL, 'ABC transporter B family member 6', 19, NULL, NULL, 168363),
(168364, '1.10.287.370-FF-000009', NULL, 'Prefoldin chaperone subunit family protein', 127, NULL, NULL, 168364),
(168365, '3.80.10.10-FF-001842', NULL, 'Leucine-rich repeat-containing protein 70', 67, NULL, NULL, 168365),
(168366, '1.10.472.80-FF-000252', NULL, NULL, 102, NULL, NULL, 168366),
(168367, '2.40.30.10-FF-000162', NULL, 'Iron ABC transporter ATP-binding protein/permease IrtA', 102, NULL, NULL, 168367),
(168368, '3.30.890.10-FF-000027', NULL, 'Methyl-CpG-binding domain protein 4', 120, NULL, NULL, 168368),
(168369, '3.40.630.30-FF-000653', NULL, 'Predicted protein', 161, NULL, NULL, 168369),
(168370, '2.130.10.10-FF-003579', NULL, 'Uncharacterized protein', 221, NULL, NULL, 168370),
(168371, '3.90.1290.10-FF-000012', NULL, 'Microtubule-actin cross-linking factor 1', 193, NULL, NULL, 168371),
(168372, '1.25.40.10-FF-002858', NULL, 'Pentatricopeptide repeat-containing protein', 101, NULL, NULL, 168372),
(168373, '3.40.50.300-FF-002674', NULL, 'GTP-binding protein, putative', 214, NULL, NULL, 168373),
(168374, '3.80.10.10-FF-001522', NULL, 'Leucine_rich_repeat/Leucine_Rich_repeat/Leucine_R ich_Repeat', 121, NULL, NULL, 168374),
(168375, '2.60.120.430-FF-000038', NULL, 'Uncharacterized protein', 90, NULL, NULL, 168375),
(168376, '3.40.190.10-FF-000399', NULL, 'Predicted protein', 131, NULL, NULL, 168376),
(168377, '1.10.132.20-FF-000012', NULL, 'ribosome-recycling factor, mitochondrial-like', 96, NULL, NULL, 168377),
(168378, '3.30.60.30-FF-000004', NULL, 'SPARC isoform 1', 84, NULL, NULL, 168378),
(168379, '3.10.20.90-FF-000622', NULL, 'Uncharacterized protein', 87, NULL, NULL, 168379),
(168380, '3.30.450.60-FF-000037', NULL, 'AP complex subunit sigma', 149, NULL, NULL, 168380),
(168381, '3.40.50.1000-FF-000022', NULL, 'Phosphoglycolate phosphatase', 133, NULL, NULL, 168381),
(168382, '3.30.420.40-FF-001047', NULL, 'Uncharacterized protein', 12, NULL, NULL, 168382);
INSERT INTO "PUBLIC"."MODEL" VALUES
(168383, '3.40.47.10-FF-000304', NULL, 'Sterigmatocystin biosynthesis fatty acid synthase subunit alpha', 591, NULL, NULL, 168383),
(168384, '1.10.230.10-FF-000024', NULL, 'ATP-citrate synthase', 61, NULL, NULL, 168384),
(168385, '3.30.160.60-FF-001004', NULL, 'Zinc finger protein 426', 28, NULL, NULL, 168385),
(168386, '1.10.10.720-FF-000007', NULL, 'Leucine--tRNA ligase', 48, NULL, NULL, 168386),
(168387, '2.60.40.3210-FF-000001', NULL, 'Zona pellucida sperm-binding protein 3', 130, NULL, NULL, 168387),
(168388, '2.60.40.10-FF-005973', NULL, NULL, 103, NULL, NULL, 168388),
(168389, '3.30.160.60-FF-005613', NULL, NULL, 66, NULL, NULL, 168389),
(168390, '3.60.10.10-FF-000275', NULL, 'CCR4-NOT transcription complex subunit 6-like', 281, NULL, NULL, 168390),
(168391, '3.40.50.720-FF-001400', NULL, 'NADP-dependent alcohol dehydrogenase', 141, NULL, NULL, 168391),
(168392, '3.90.79.10-FF-000112', NULL, 'NUDIX hydrolase dihydroneopterin triphosphate pyrophosphohydrolase/hydrolase', 159, NULL, NULL, 168392),
(168393, '3.30.450.270-FF-000003', NULL, 'Phytochrome-like protein', 128, NULL, NULL, 168393),
(168394, '1.10.555.10-FF-000267', NULL, NULL, 72, NULL, NULL, 168394),
(168395, '3.40.50.620-FF-000741', NULL, 'Uncharacterized protein', 154, NULL, NULL, 168395),
(168396, '2.60.120.290-FF-000069', NULL, 'Dorsal-ventral patterning tolloid protein', 132, NULL, NULL, 168396),
(168397, '3.90.1430.10-FF-000001', NULL, '116 kDa U5 small nuclear ribonucleoprotein component', 105, NULL, NULL, 168397),
(168398, '2.130.10.10-FF-002382', NULL, 'Glycosyl hydrolase BNR repeat-containing protein', 369, NULL, NULL, 168398),
(168399, '3.40.720.10-FF-000075', NULL, 'GPI ethanolamine phosphate transferase 3,putative', 140, NULL, NULL, 168399),
(168400, '2.170.150.10-FF-000021', NULL, 'Uncharacterized protein', 175, NULL, NULL, 168400),
(168401, '2.40.50.100-FF-000027', NULL, 'DNA-binding transcriptional regulator ModE', 69, NULL, NULL, 168401),
(168402, '1.10.238.10-FF-001093', NULL, 'Glycerol-3-phosphate dehydrogenase', 70, NULL, NULL, 168402),
(168403, '3.30.430.20-FF-000030', NULL, 'Cysteine-rich repeat secretory protein 9', 106, NULL, NULL, 168403),
(168404, '2.130.10.10-FF-004989', NULL, 'WD repeat domain 18', 76, NULL, NULL, 168404),
(168405, '1.10.510.10-FF-000169', NULL, 'Serine/threonine-protein kinase 32A', 197, NULL, NULL, 168405),
(168406, '2.130.10.10-FF-000145', NULL, 'WD repeat domain phosphoinositide-interacting protein 2', 340, NULL, NULL, 168406),
(168407, '3.10.20.30-FF-000071', NULL, NULL, 77, NULL, NULL, 168407),
(168408, '1.10.10.10-FF-001569', NULL, 'Purple acid phosphatase 3', 32, NULL, NULL, 168408),
(168409, '3.30.70.270-FF-000086', NULL, 'Protein FimX', 174, NULL, NULL, 168409),
(168410, '2.30.29.30-FF-000277', NULL, 'src kinase-associated phosphoprotein 1', 108, NULL, NULL, 168410),
(168411, '2.60.40.10-FF-006001', NULL, NULL, 59, NULL, NULL, 168411),
(168412, '3.30.70.270-FF-000198', NULL, NULL, 71, NULL, NULL, 168412),
(168413, '3.90.550.10-FF-000258', NULL, 'Uncharacterized protein', 253, NULL, NULL, 168413),
(168414, '2.60.40.10-FF-003825', NULL, NULL, 93, NULL, NULL, 168414),
(168415, '2.20.25.20-FF-000024', NULL, NULL, 56, NULL, NULL, 168415),
(168416, '2.30.31.10-FF-000018', NULL, 'Uncharacterized protein', 72, NULL, NULL, 168416),
(168417, '3.80.10.10-FF-004259', NULL, 'Si:ch211-208f21.3', 65, NULL, NULL, 168417),
(168418, '1.25.10.10-FF-000440', NULL, 'Armadillo repeat-containing protein 8', 252, NULL, NULL, 168418),
(168419, '1.25.40.20-FF-001338', NULL, 'Predicted protein', 120, NULL, NULL, 168419),
(168420, '1.10.287.70-FF-000088', NULL, 'Intermediate conductance calcium-activated potassium channel protein 4', 94, NULL, NULL, 168420),
(168421, '1.20.5.110-FF-000324', NULL, 'Uncharacterized protein', 106, NULL, NULL, 168421),
(168422, '1.20.120.1900-FF-000070', NULL, 'Spindle pole body component', 366, NULL, NULL, 168422),
(168423, '3.30.70.330-FF-002594', NULL, NULL, 135, NULL, NULL, 168423),
(168424, '1.10.630.10-FF-000116', NULL, 'Oxidoreductase A;oxidoreductase/cytochrome P450 monooxygenase', 474, NULL, NULL, 168424);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(168425, '1.20.920.30-FF-000024', NULL, 'Dynein heavy chain, cytosolic, putative', 194, NULL, NULL, 168425),
(168426, '1.20.58.60-FF-000277', NULL, 'Spectrin beta chain, non-erythrocytic', 96, NULL, NULL, 168426),
(168427, '1.20.1250.20-FF-000660', NULL, 'Unplaced genomic scaffold supercont2.3, whole genome shotgun sequence', 233, NULL, NULL, 168427),
(168428, '2.40.30.130-FF-000026', NULL, 'Alanyl-tRNA synthetase', 107, NULL, NULL, 168428),
(168429, '2.120.10.30-FF-000342', NULL, 'Uncharacterized protein', 229, NULL, NULL, 168429),
(168430, '2.40.30.10-FF-000515', NULL, 'Elongation factor 2', 121, NULL, NULL, 168430),
(168431, '1.20.1070.10-FF-001851', NULL, 'Uncharacterized protein', 299, NULL, NULL, 168431),
(168432, '3.30.470.10-FF-000035', NULL, 'Branched-chain amino acid aminotransferase', 125, NULL, NULL, 168432),
(168433, '3.40.50.300-FF-000420', NULL, 'Endoribonuclease dicer-like 1', 164, NULL, NULL, 168433),
(168434, '3.40.50.720-FF-001619', NULL, 'Os09g0491804 protein', 91, NULL, NULL, 168434),
(168435, '2.60.40.10-FF-000493', NULL, 'Coxsackievirus and adenovirus receptor homolog', 126, NULL, NULL, 168435),
(168436, '3.30.160.60-FF-002628', NULL, 'Zinc finger and BTB domain containing 11', 37, NULL, NULL, 168436),
(168437, '1.10.510.10-FF-002743', NULL, 'Uncharacterized protein', 296, NULL, NULL, 168437),
(168438, '1.25.40.10-FF-001453', NULL, 'Pentatricopeptide repeat-containing protein PNM1 mitochondrial', 186, NULL, NULL, 168438),
(168439, '3.60.21.10-FF-000295', NULL, 'Predicted protein', 109, NULL, NULL, 168439),
(168440, '1.10.630.10-FF-000667', NULL, 'Uncharacterized protein', 181, NULL, NULL, 168440),
(168441, '3.40.50.1820-FF-001347', NULL, 'Uncharacterized protein', 244, NULL, NULL, 168441),
(168442, '4.10.400.10-FF-000205', NULL, 'Sortilin-related receptor', 35, NULL, NULL, 168442),
(168443, '1.10.1000.11-FF-000001', NULL, 'IQ motif and SEC7 domain-containing protein 1', 118, NULL, NULL, 168443),
(168444, '1.25.40.370-FF-000005', NULL, 'Uncharacterized protein', 152, NULL, NULL, 168444),
(168445, '2.60.40.10-FF-000066', NULL, 'receptor-type tyrosine-protein phosphatase delta isoform X1', 117, NULL, NULL, 168445),
(168446, '3.40.50.12500-FF-000009', NULL, 'Uncharacterized protein', 162, NULL, NULL, 168446),
(168447, '3.40.50.300-FF-007345', NULL, 'Uncharacterized protein', 123, NULL, NULL, 168447),
(168448, '1.20.140.10-FF-000088', NULL, 'Acyl-CoA dehydrogenase', 144, NULL, NULL, 168448),
(168449, '1.10.287.70-FF-000751', NULL, 'Calcium voltage-gated channel subunit alpha1 H', 78, NULL, NULL, 168449),
(168450, '3.90.1520.10-FF-000008', NULL, 'Soluble guanylate cyclase gcy-33', 188, NULL, NULL, 168450),
(168451, '2.30.29.30-FF-001114', NULL, 'Uncharacterized protein', 136, NULL, NULL, 168451),
(168452, '3.30.470.30-FF-000041', NULL, 'DNA ligase', 246, NULL, NULL, 168452),
(168453, '3.30.500.10-FF-000033', NULL, NULL, 92, NULL, NULL, 168453),
(168454, '3.10.129.10-FF-000258', NULL, 'Uncharacterized protein', 93, NULL, NULL, 168454),
(168455, '4.10.1000.10-FF-000150', NULL, 'Dosage compensation regulator-like Protein', 34, NULL, NULL, 168455),
(168456, '3.30.160.60-FF-004091', NULL, NULL, 32, NULL, NULL, 168456),
(168457, '2.40.10.10-FF-000407', NULL, NULL, 199, NULL, NULL, 168457),
(168458, '3.30.200.20-FF-002250', NULL, NULL, 115, NULL, NULL, 168458),
(168459, '3.40.50.12650-FF-000026', NULL, 'Beta-lactamase superfamily domain/DNA repair metallo-beta-lactamase, putative', 97, NULL, NULL, 168459),
(168460, '3.50.30.30-FF-000013', NULL, 'E3 ubiquitin-protein ligase RNF167', 143, NULL, NULL, 168460),
(168461, '3.40.50.2000-FF-000884', NULL, 'Glycosyl transferase group 1', 182, NULL, NULL, 168461),
(168462, '2.130.10.10-FF-001763', NULL, 'Uncharacterized protein', 178, NULL, NULL, 168462),
(168463, '3.40.50.720-FF-002570', NULL, 'Uncharacterized protein', 38, NULL, NULL, 168463),
(168464, '3.40.30.10-FF-000777', NULL, 'Mitosis protein dim1', 144, NULL, NULL, 168464),
(168465, '3.40.630.10-FF-000208', NULL, 'Protein CBG05161', 262, NULL, NULL, 168465),
(168466, '2.120.10.80-FF-000211', NULL, 'attractin-like protein 1', 143, NULL, NULL, 168466);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(168467, '1.20.1050.20-FF-000009', NULL, 'Signal transducer and activator of transcription 5', 136, NULL, NULL, 168467),
(168468, '3.40.50.10810-FF-000148', NULL, 'CHD gene family protein containing chromodomain, helicase domain, and DNA-binding domain', 234, NULL, NULL, 168468),
(168469, '3.40.190.80-FF-000037', NULL, 'Inositol monophosphatase', 114, NULL, NULL, 168469),
(168470, '1.25.40.20-FF-000719', NULL, 'Putative ankyrin repeat and btb poz domain protein', 91, NULL, NULL, 168470),
(168471, '3.20.20.190-FF-000065', NULL, 'Phosphoinositide phospholipase C', 296, NULL, NULL, 168471),
(168472, '1.20.1310.10-FF-000038', NULL, 'CDC53p Cullin', 110, NULL, NULL, 168472),
(168473, '2.60.60.20-FF-000053', NULL, NULL, 113, NULL, NULL, 168473),
(168474, '1.20.58.60-FF-000838', NULL, 'Uncharacterized protein', 154, NULL, NULL, 168474),
(168475, '3.40.190.10-FF-000511', NULL, 'Oligopeptide-binding protein oppA', 111, NULL, NULL, 168475),
(168476, '3.30.505.10-FF-000004', NULL, 'Tyrosine-protein kinase', 112, NULL, NULL, 168476),
(168477, '3.10.490.10-FF-000024', NULL, 'Putative gamma-glutamylcyclotransferase YkqA', 157, NULL, NULL, 168477),
(168478, '3.30.559.30-FF-000062', NULL, 'Nonribosomal peptide synthase Pes1', 210, NULL, NULL, 168478),
(168479, '2.60.40.10-FF-005164', NULL, NULL, 94, NULL, NULL, 168479),
(168480, '3.10.110.10-FF-000103', NULL, 'Ubiquitin conjugating enzyme, putative', 157, NULL, NULL, 168480),
(168481, '2.60.120.200-FF-000796', NULL, 'Galectin', 44, NULL, NULL, 168481),
(168482, '2.60.120.650-FF-000211', NULL, 'Predicted protein', 71, NULL, NULL, 168482),
(168483, '2.60.40.150-FF-000182', NULL, 'Synaptotagmin 8', 140, NULL, NULL, 168483),
(168484, '3.90.740.10-FF-000071', NULL, 'Isoleucyl tRNA synthetase, putative', 140, NULL, NULL, 168484),
(168485, '2.160.20.10-FF-000060', NULL, 'Pectin lyase-like superfamily protein', 389, NULL, NULL, 168485),
(168486, '3.40.47.10-FF-000203', NULL, NULL, 206, NULL, NULL, 168486),
(168487, '2.10.25.10-FF-001421', NULL, 'Uncharacterized protein', 50, NULL, NULL, 168487),
(168488, '1.10.472.10-FF-000063', NULL, 'cyclin-H1-1', 113, NULL, NULL, 168488),
(168489, '2.40.70.10-FF-000057', NULL, 'Eukaryotic aspartyl protease family protein', 178, NULL, NULL, 168489),
(168490, '3.40.50.300-FF-004714', NULL, 'DEAD/DEAH box helicase', 182, NULL, NULL, 168490),
(168491, '2.40.50.140-FF-001180', NULL, NULL, 87, NULL, NULL, 168491),
(168492, '2.10.109.10-FF-000002', NULL, 'Signal peptidase I', 137, NULL, NULL, 168492),
(168493, '3.20.20.70-FF-000104', NULL, 'Thiamine biosynthetic bifunctional enzyme', 222, NULL, NULL, 168493),
(168494, '1.25.40.10-FF-004084', NULL, 'Pentatricopeptide repeat-containing protein At2g40240, mitochondrial', 156, NULL, NULL, 168494),
(168495, '1.50.40.10-FF-000428', NULL, 'Predicted protein', 181, NULL, NULL, 168495),
(168496, '2.70.98.20-FF-000038', NULL, 'Amine oxidase', 61, NULL, NULL, 168496),
(168497, '1.10.1130.10-FF-000010', NULL, 'C-type polyheme cytochrome OmcB', 209, NULL, NULL, 168497),
(168498, '3.60.10.10-FF-000376', NULL, 'Uncharacterized protein', 91, NULL, NULL, 168498),
(168499, '3.40.1110.10-FF-000157', NULL, 'Phospholipid-transporting ATPase', 231, NULL, NULL, 168499),
(168500, '1.10.1080.10-FF-000005', NULL, 'Glutathione synthetase', 47, NULL, NULL, 168500),
(168501, '1.10.437.10-FF-000026', NULL, 'BCL2 associated X, apoptosis regulator', 60, NULL, NULL, 168501),
(168502, '3.40.309.10-FF-000086', NULL, 'Uncharacterized protein', 44, NULL, NULL, 168502),
(168503, '1.10.510.10-FF-002535', NULL, 'Uncharacterized protein', 309, NULL, NULL, 168503),
(168504, '3.90.1150.10-FF-000098', NULL, 'Transcriptional regulator, GntR family', 141, NULL, NULL, 168504),
(168505, '3.30.160.60-FF-000942', NULL, 'Snail zinc finger protein', 27, NULL, NULL, 168505),
(168506, '2.60.40.10-FF-005517', NULL, NULL, 74, NULL, NULL, 168506),
(168507, '3.90.180.10-FF-000089', NULL, 'GroES-like zinc-binding alcohol dehydrogenase family protein', 155, NULL, NULL, 168507),
(168508, '2.40.110.10-FF-000055', NULL, 'Acyl-Coenzyme A dehydrogenase', 110, NULL, NULL, 168508);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(168509, '3.20.16.10-FF-000003', NULL, 'Capsid scaffolding protein', 230, NULL, NULL, 168509),
(168510, '1.20.1250.20-FF-002346', NULL, 'Uncharacterized protein', 199, NULL, NULL, 168510),
(168511, '3.30.450.40-FF-000020', NULL, 'Acetate operon transcriptional repressor IclR', 178, NULL, NULL, 168511),
(168512, '2.60.40.1850-FF-000003', NULL, 'Sortase B protein-sorting domain-containing protein', 143, NULL, NULL, 168512),
(168513, '2.60.40.60-FF-000592', NULL, 'Si:dkey-1m11.5', 85, NULL, NULL, 168513),
(168514, '3.40.720.10-FF-000311', NULL, 'Alkaline phosphatase', 209, NULL, NULL, 168514),
(168515, '1.10.10.750-FF-000005', NULL, 'TBC1 domain family member 14', 66, NULL, NULL, 168515),
(168516, '3.40.50.300-FF-000763', NULL, 'Genome polyprotein', 159, NULL, NULL, 168516),
(168517, '1.20.5.350-FF-000025', NULL, NULL, 88, NULL, NULL, 168517),
(168518, '1.25.40.120-FF-000065', NULL, 'Uncharacterized protein', 203, NULL, NULL, 168518),
(168519, '1.10.510.10-FF-000405', NULL, 'Mitogen-activated protein kinase', 71, NULL, NULL, 168519),
(168520, '2.60.40.10-FF-000150', NULL, 'Leucine rich repeats and immunoglobulin like domains 3', 94, NULL, NULL, 168520),
(168521, '3.30.420.110-FF-000056', NULL, 'YALI0B10197p', 142, NULL, NULL, 168521),
(168522, '1.25.10.10-FF-002126', NULL, 'Coatomer subunit gamma', 236, NULL, NULL, 168522),
(168523, '3.30.1360.120-FF-000003', NULL, 'tRNA modification GTPase MnmE', 124, NULL, NULL, 168523),
(168524, '1.10.10.10-FF-001445', NULL, 'Replication Protein A homolog', 66, NULL, NULL, 168524),
(168525, '2.70.160.11-FF-000069', NULL, 'Uncharacterized protein', 185, NULL, NULL, 168525),
(168526, '1.10.287.70-FF-000296', NULL, 'TWiK family of potassium channels', 302, NULL, NULL, 168526),
(168527, '2.30.42.10-FF-000032', NULL, 'Afadin isoform A', 101, NULL, NULL, 168527),
(168528, '1.20.1070.10-FF-001531', NULL, 'Predicted protein', 183, NULL, NULL, 168528),
(168529, '1.10.20.110-FF-000001', NULL, 'Bifunctional aspartate aminotransferase and L-aspartate beta-decarboxylase', 148, NULL, NULL, 168529),
(168530, '3.40.50.410-FF-000009', NULL, 'Putative vitrin', 187, NULL, NULL, 168530),
(168531, '2.40.20.10-FF-000110', NULL, 'Metalloendopeptidase', 88, NULL, NULL, 168531),
(168532, '1.10.630.10-FF-000324', NULL, 'Uncharacterized protein', 148, NULL, NULL, 168532),
(168533, '3.30.450.60-FF-000026', NULL, 'Signal recognition particle receptor alpha subunit', 119, NULL, NULL, 168533),
(168534, '3.40.50.300-FF-007688', NULL, 'Predicted protein', 110, NULL, NULL, 168534),
(168535, '3.40.50.300-FF-000100', NULL, 'Translation elongation factor 3', 217, NULL, NULL, 168535),
(168536, '3.30.1360.70-FF-000033', NULL, NULL, 99, NULL, NULL, 168536),
(168537, '1.25.40.180-FF-000167', NULL, NULL, 212, NULL, NULL, 168537),
(168538, '1.10.287.110-FF-000050', NULL, 'Chaperone protein dnaJ 50', 101, NULL, NULL, 168538),
(168539, '6.10.140.2220-FF-000060', NULL, 'Predicted protein', 46, NULL, NULL, 168539),
(168540, '3.40.930.10-FF-000012', NULL, 'Anion exchange protein', 323, NULL, NULL, 168540),
(168541, '2.60.40.790-FF-000042', NULL, 'heat shock protein 27', 122, NULL, NULL, 168541),
(168542, '3.30.559.10-FF-000191', NULL, 'Uncharacterized protein', 168, NULL, NULL, 168542),
(168543, '2.10.25.10-FF-000780', NULL, 'Slit homolog 1b (Drosophila)', 38, NULL, NULL, 168543),
(168544, '2.60.120.10-FF-000681', NULL, 'Uncharacterized protein', 87, NULL, NULL, 168544),
(168545, '2.130.10.10-FF-000706', NULL, 'Ribosome biogenesis protein YTM1', 366, NULL, NULL, 168545),
(168546, '1.25.40.20-FF-001776', NULL, 'Uncharacterized protein', 186, NULL, NULL, 168546),
(168547, '2.10.80.10-FF-000020', NULL, 'Uncharacterized protein', 83, NULL, NULL, 168547),
(168548, '1.20.58.1120-FF-000013', NULL, 'Dynein heavy chain-like protein', 148, NULL, NULL, 168548),
(168549, '1.10.510.10-FF-003154', NULL, NULL, 174, NULL, NULL, 168549),
(168550, '3.40.50.10810-FF-000042', NULL, 'SNF2 family helicase-like protein', 259, NULL, NULL, 168550),
(168551, '2.60.40.640-FF-000025', NULL, 'Putative Beta-arrestin-2', 215, NULL, NULL, 168551);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(168552, '3.30.70.270-FF-000209', NULL, NULL, 101, NULL, NULL, 168552),
(168553, '3.40.50.200-FF-000183', NULL, 'Gll1055 protein', 200, NULL, NULL, 168553),
(168554, '3.40.50.1700-FF-000013', NULL, 'Glycoside hydrolase family 3 protein', 262, NULL, NULL, 168554),
(168555, '1.20.1250.20-FF-001385', NULL, 'Major facilitator superfamily MFS_1', 192, NULL, NULL, 168555),
(168556, '1.20.58.390-FF-000037', NULL, 'Nicotinic acetylcholine receptor subunit alpha6', 78, NULL, NULL, 168556),
(168557, '3.40.50.300-FF-006064', NULL, 'Predicted protein', 167, NULL, NULL, 168557),
(168558, '2.40.10.10-FF-000615', NULL, NULL, 106, NULL, NULL, 168558),
(168559, '3.40.1010.10-FF-000009', NULL, 'ATP-binding protein', 132, NULL, NULL, 168559),
(168560, '2.130.10.10-FF-003455', NULL, 'Uncharacterized protein', 109, NULL, NULL, 168560),
(168561, '3.30.230.10-FF-000175', NULL, 'Small nuclear ribonucleoprotein component-like protein', 158, NULL, NULL, 168561),
(168562, '1.10.238.220-FF-000006', NULL, NULL, 88, NULL, NULL, 168562),
(168563, '3.40.50.1820-FF-000622', NULL, 'Ferri-bacillibactin esterase BesA', 255, NULL, NULL, 168563),
(168564, '3.80.10.10-FF-000780', NULL, '18 wheeler', 102, NULL, NULL, 168564),
(168565, '3.30.70.20-FF-000064', NULL, 'Ion-translocating oxidoreductase complex subunit B', 44, NULL, NULL, 168565),
(168566, '1.25.10.10-FF-003295', NULL, 'Probable sulfatase atsG', 177, NULL, NULL, 168566),
(168567, '1.10.3080.10-FF-000022', NULL, 'Chloride channel protein', 485, NULL, NULL, 168567),
(168568, '2.60.120.650-FF-000003', NULL, 'Lysine-specific demethylase 4D', 334, NULL, NULL, 168568),
(168569, '4.10.1240.10-FF-000010', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', 54, NULL, NULL, 168569),
(168570, '3.30.420.10-FF-000223', NULL, 'Probable CCR4-associated factor 1 homolog 5', 250, NULL, NULL, 168570),
(168571, '1.10.246.10-FF-000009', NULL, 'Vitamin D-binding protein', 77, NULL, NULL, 168571),
(168572, '1.20.5.990-FF-000009', NULL, 'Optineurin', 91, NULL, NULL, 168572),
(168573, '3.30.200.20-FF-000120', NULL, 'STE20-like serine/threonine-protein kinase', 97, NULL, NULL, 168573),
(168574, '3.40.50.1460-FF-000137', NULL, 'Uncharacterized protein', 203, NULL, NULL, 168574),
(168575, '2.60.40.150-FF-000305', NULL, 'Phosphatidylinositol 3-kinase putative', 142, NULL, NULL, 168575),
(168576, '3.30.160.60-FF-005719', NULL, NULL, 87, NULL, NULL, 168576),
(168577, '2.60.120.590-FF-000069', NULL, 'Predicted protein', 146, NULL, NULL, 168577),
(168578, '1.20.1160.20-FF-000001', NULL, 'harmonin isoform X1', 81, NULL, NULL, 168578),
(168579, '3.10.20.90-FF-000291', NULL, 'Next to BRCA1 gene 1 protein', 83, NULL, NULL, 168579),
(168580, '1.10.287.1490-FF-000105', NULL, 'Uncharacterized protein', 165, NULL, NULL, 168580),
(168581, '1.10.260.100-FF-000027', NULL, 'Ankyrin repeat-containing protein 2', 62, NULL, NULL, 168581),
(168582, '3.30.70.330-FF-002835', NULL, NULL, 86, NULL, NULL, 168582),
(168583, '3.30.200.20-FF-001289', NULL, 'Possible macrolide 2-phosphotransferase', 91, NULL, NULL, 168583),
(168584, '2.130.10.10-FF-001555', NULL, 'Similar to U4/U6 small nuclear ribonucleoprotein Prp4', 186, NULL, NULL, 168584),
(168585, '3.40.50.2300-FF-001036', NULL, NULL, 135, NULL, NULL, 168585),
(168586, '3.40.50.300-FF-008205', NULL, 'Predicted protein', 73, NULL, NULL, 168586),
(168587, '3.40.50.300-FF-007929', NULL, 'Uncharacterized protein', 173, NULL, NULL, 168587),
(168588, '1.20.1740.10-FF-000076', NULL, 'Spore germination protein (Amino acid permease)', 361, NULL, NULL, 168588),
(168589, '2.60.40.10-FF-004107', NULL, NULL, 93, NULL, NULL, 168589),
(168590, '3.40.710.10-FF-000029', NULL, 'Penicillin-binding protein 2', 370, NULL, NULL, 168590),
(168591, '3.40.50.720-FF-001951', NULL, 'Short chain dehydrogenase', 261, NULL, NULL, 168591),
(168592, '1.20.1070.10-FF-000570', NULL, 'Uncharacterized protein', 135, NULL, NULL, 168592),
(168593, '3.40.50.1100-FF-000064', NULL, 'Threonine synthase', 139, NULL, NULL, 168593),
(168594, '2.40.240.10-FF-000059', NULL, 'Uncharacterized protein', 80, NULL, NULL, 168594);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(168595, '1.10.10.60-FF-000134', NULL, 'Homeobox protein MSX-1', 101, NULL, NULL, 168595),
(168596, '3.90.226.10-FF-000331', NULL, 'Uncharacterized protein', 96, NULL, NULL, 168596),
(168597, '3.30.920.10-FF-000025', NULL, 'Predicted protein', 65, NULL, NULL, 168597),
(168598, '3.80.20.20-FF-000036', NULL, 'Predicted protein', 93, NULL, NULL, 168598),
(168599, '3.30.70.330-FF-003111', NULL, NULL, 77, NULL, NULL, 168599),
(168600, '3.40.50.1820-FF-000167', NULL, 'Abhydrolase domain containing 1', 268, NULL, NULL, 168600),
(168601, '2.30.29.30-FF-001249', NULL, 'Tyrosine-protein kinase', 159, NULL, NULL, 168601),
(168602, '2.40.50.1060-FF-000013', NULL, 'Uncharacterized protein', 211, NULL, NULL, 168602),
(168603, '3.40.1050.10-FF-000006', NULL, 'Carbonic anhydrase', 205, NULL, NULL, 168603),
(168604, '1.20.120.920-FF-000004', NULL, 'CRISPR-associated endonuclease Cas1', 210, NULL, NULL, 168604),
(168605, '3.30.56.10-FF-000039', NULL, 'Phenylalanine--tRNA ligase beta subunit', 65, NULL, NULL, 168605),
(168606, '2.120.10.30-FF-000112', NULL, 'Tyrosine-protein kinase receptor', 284, NULL, NULL, 168606),
(168607, '3.40.1110.10-FF-000051', NULL, 'Phospholipid-transporting ATPase', 224, NULL, NULL, 168607),
(168608, '1.10.472.10-FF-000613', NULL, 'Uncharacterized protein', 134, NULL, NULL, 168608),
(168609, '2.40.10.10-FF-000054', NULL, 'Complement C1r subcomponent', 130, NULL, NULL, 168609),
(168610, '3.90.1520.10-FF-000019', NULL, 'Uncharacterized protein', 78, NULL, NULL, 168610),
(168611, '1.20.1250.20-FF-000766', NULL, 'MFS transporter', 403, NULL, NULL, 168611),
(168612, '3.40.50.300-FF-004815', NULL, 'Uncharacterized protein', 168, NULL, NULL, 168612),
(168613, '3.30.60.30-FF-000139', NULL, 'Agr-1', 53, NULL, NULL, 168613),
(168614, '1.10.575.10-FF-000021', NULL, 'Uncharacterized protein', 270, NULL, NULL, 168614),
(168615, '2.130.10.10-FF-001898', NULL, 'Ribosome biogenesis protein WDR12 homolog', 126, NULL, NULL, 168615),
(168616, '1.10.8.190-FF-000002', NULL, 'Carbon monoxide dehydrogenase, alpha subunit', 112, NULL, NULL, 168616),
(168617, '3.90.70.10-FF-000704', NULL, 'Ubiquitin-specific protease, putative', 213, NULL, NULL, 168617),
(168618, '1.50.40.10-FF-000097', NULL, 'Protein MITOFERRINLIKE 1, chloroplastic', 157, NULL, NULL, 168618),
(168619, '3.90.79.10-FF-000218', NULL, 'RPS10-NUDT3 readthrough', 95, NULL, NULL, 168619),
(168620, '3.30.70.330-FF-000340', NULL, 'RNA-binding motif protein 28', 118, NULL, NULL, 168620),
(168621, '2.70.98.10-FF-000024', NULL, 'Galactose mutarotase', 131, NULL, NULL, 168621),
(168622, '3.30.160.60-FF-005158', NULL, NULL, 39, NULL, NULL, 168622),
(168623, '3.90.1200.10-FF-000080', NULL, 'Uncharacterized protein', 127, NULL, NULL, 168623),
(168624, '3.10.20.90-FF-000414', NULL, 'Tubulin-specific chaperone B', 85, NULL, NULL, 168624),
(168625, '1.20.1640.10-FF-000012', NULL, 'Cation efflux system protein CusA', 210, NULL, NULL, 168625),
(168626, '3.90.1100.10-FF-000027', NULL, 'DNA-directed RNA polymerase subunit beta', 143, NULL, NULL, 168626),
(168627, '3.70.10.10-FF-000073', NULL, 'Checkpoint protein hus1 homolog', 269, NULL, NULL, 168627),
(168628, '3.40.50.1010-FF-000149', NULL, 'Exonuclease 1', 204, NULL, NULL, 168628),
(168629, '1.20.1250.20-FF-000901', NULL, 'Sucrose transport protein SUC5, putative', 218, NULL, NULL, 168629),
(168630, '2.40.50.140-FF-000123', NULL, '30S ribosomal protein S17', 85, NULL, NULL, 168630),
(168631, '3.40.50.720-FF-001390', NULL, 'Oxidoreductase', 124, NULL, NULL, 168631),
(168632, '3.30.160.60-FF-000487', NULL, 'ras-responsive element-binding protein 1 isoform X1', 24, NULL, NULL, 168632),
(168633, '1.20.58.530-FF-000006', NULL, 'Putative unconventional myosin-VI', 160, NULL, NULL, 168633),
(168634, '1.20.120.230-FF-000005', NULL, 'Talin 1', 124, NULL, NULL, 168634),
(168635, '2.60.40.150-FF-000535', NULL, 'Protein kinase C', 148, NULL, NULL, 168635),
(168636, '3.50.7.10-FF-000016', NULL, '1-phosphatidylinositol 3-phosphate 5-kinase', 166, NULL, NULL, 168636),
(168637, '2.40.30.170-FF-000010', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 88, NULL, NULL, 168637);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(168638, '1.20.1250.20-FF-001520', NULL, 'Os07g0131200 protein', 196, NULL, NULL, 168638),
(168639, '2.30.42.10-FF-000375', NULL, 'Slip1, isoform C', 107, NULL, NULL, 168639),
(168640, '1.25.40.340-FF-000007', NULL, NULL, 209, NULL, NULL, 168640),
(168641, '3.30.1130.10-FF-000009', NULL, 'GTP cyclohydrolase I', 128, NULL, NULL, 168641),
(168642, '3.60.40.10-FF-000215', NULL, 'Ptc8p', 261, NULL, NULL, 168642),
(168643, '2.30.30.40-FF-000362', NULL, 'Tyrosine-protein kinase', 63, NULL, NULL, 168643),
(168644, '3.40.630.30-FF-000445', NULL, 'Ribosomal-protein-alanine acetyltransferase', 194, NULL, NULL, 168644),
(168645, '1.20.1270.60-FF-000212', NULL, 'Uncharacterized protein', 127, NULL, NULL, 168645),
(168646, '3.40.109.10-FF-000003', NULL, 'Probable malonic semialdehyde reductase RutE', 187, NULL, NULL, 168646),
(168647, '3.30.70.260-FF-000184', NULL, 'Putative prephenate dehydratase', 80, NULL, NULL, 168647),
(168648, '3.40.50.300-FF-006968', NULL, 'Uncharacterized protein', 220, NULL, NULL, 168648),
(168649, '2.60.40.10-FF-002207', NULL, 'Poliovirus receptor-related 2 like', 123, NULL, NULL, 168649),
(168650, '1.20.58.60-FF-000176', NULL, 'Spectrin beta chain', 216, NULL, NULL, 168650),
(168651, '3.40.50.2300-FF-001492', NULL, NULL, 125, NULL, NULL, 168651),
(168652, '3.30.530.20-FF-000094', NULL, 'Bet v I allergen family protein', 152, NULL, NULL, 168652),
(168653, '1.25.40.10-FF-005264', NULL, 'Uncharacterized protein', 325, NULL, NULL, 168653),
(168654, '2.30.230.10-FF-000038', NULL, 'Histone-lysine N-methyltransferase', 121, NULL, NULL, 168654),
(168655, '1.20.5.110-FF-000083', NULL, 'syntaxin-4 isoform X2', 106, NULL, NULL, 168655),
(168656, '3.30.230.80-FF-000021', NULL, 'HSP90 family protein', 123, NULL, NULL, 168656),
(168657, '1.20.1250.20-FF-002003', NULL, 'Uncharacterized protein', 378, NULL, NULL, 168657),
(168658, '3.40.50.410-FF-000341', NULL, 'Integrin beta-like protein C', 138, NULL, NULL, 168658),
(168659, '1.10.132.70-FF-000016', NULL, 'Telomerase reverse transcriptase', 251, NULL, NULL, 168659),
(168660, '3.40.50.720-FF-000439', NULL, 'Short chain dehydrogenase/reductase (AFU_orthologue AFUA_2G00830)', 267, NULL, NULL, 168660),
(168661, '3.90.730.10-FF-000014', NULL, 'Ribonuclease T2', 215, NULL, NULL, 168661),
(168662, '3.40.50.1820-FF-001448', NULL, 'Uncharacterized protein', 186, NULL, NULL, 168662),
(168663, '1.10.510.10-FF-002878', NULL, NULL, 178, NULL, NULL, 168663),
(168664, '3.40.50.150-FF-001763', NULL, NULL, 220, NULL, NULL, 168664),
(168665, '3.40.50.10860-FF-000040', NULL, 'Shikimate biosynthesis protein AroDE', 106, NULL, NULL, 168665),
(168666, '3.20.20.20-FF-000005', NULL, '4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase (flavodoxin)', 287, NULL, NULL, 168666),
(168667, '3.40.50.12780-FF-000172', NULL, 'Long-chain-fatty-acid--CoA ligase, putative', 390, NULL, NULL, 168667),
(168668, '1.25.40.10-FF-004988', NULL, 'Uncharacterized protein', 136, NULL, NULL, 168668),
(168669, '3.40.50.150-FF-000353', NULL, 'Ribosomal RNA small subunit methyltransferase G', 207, NULL, NULL, 168669),
(168670, '2.40.70.10-FF-000512', NULL, NULL, 88, NULL, NULL, 168670),
(168671, '1.10.246.90-FF-000005', NULL, 'Nucleolar protein 5, putative', 124, NULL, NULL, 168671),
(168672, '2.10.25.10-FF-000448', NULL, 'Stabilin 2', 34, NULL, NULL, 168672),
(168673, '2.30.29.30-FF-000288', NULL, 'Leucine-rich repeat, isoform C', 108, NULL, NULL, 168673),
(168674, '3.90.190.20-FF-000031', NULL, 'Folylpolyglutamate synthase', 178, NULL, NULL, 168674),
(168675, '2.60.220.50-FF-000166', NULL, 'Uncharacterized protein', 143, NULL, NULL, 168675),
(168676, '1.25.40.20-FF-000057', NULL, 'Ankyrin repeat domain-containing protein 13B', 112, NULL, NULL, 168676),
(168677, '2.60.40.10-FF-001589', NULL, 'Tyrosine-protein phosphatase 10D', 95, NULL, NULL, 168677),
(168678, '3.20.20.140-FF-000410', NULL, 'TatD DNase domain-containing 2', 89, NULL, NULL, 168678),
(168679, '3.90.70.10-FF-000143', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 338, NULL, NULL, 168679),
(168680, '3.30.420.10-FF-000566', NULL, NULL, 44, NULL, NULL, 168680);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(168681, '3.30.470.10-FF-000046', NULL, 'Uncharacterized protein', 124, NULL, NULL, 168681),
(168682, '3.40.50.970-FF-000031', NULL, 'Pyruvate dehydrogenase [ubiquinone]', 228, NULL, NULL, 168682),
(168683, '1.10.8.60-FF-000386', NULL, 'Putative nuclear aaa atpase vcp subfamily protein', 85, NULL, NULL, 168683),
(168684, '3.40.50.300-FF-005434', NULL, 'Uncharacterized protein', 85, NULL, NULL, 168684),
(168685, '1.20.58.80-FF-000058', NULL, 'Probable ubiquitin thioesterase DG1039', 137, NULL, NULL, 168685),
(168686, '1.10.510.10-FF-003715', NULL, NULL, 158, NULL, NULL, 168686),
(168687, '1.25.40.10-FF-003364', NULL, 'Pentatricopeptide repeat-containing protein At1g56690, mitochondrial', 70, NULL, NULL, 168687),
(168688, '2.30.40.10-FF-000084', NULL, 'Cytosine deaminase', 85, NULL, NULL, 168688),
(168689, '3.40.50.620-FF-000398', NULL, 'Cytoplasmic protein', 168, NULL, NULL, 168689),
(168690, '3.30.40.10-FF-001442', NULL, 'RNA binding protein', 117, NULL, NULL, 168690),
(168691, '2.130.10.10-FF-002174', NULL, 'F-box and WD repeat domain-containing 5', 200, NULL, NULL, 168691),
(168692, '2.60.120.1540-FF-000006', NULL, 'MHC-linked complement C4', 82, NULL, NULL, 168692),
(168693, '3.30.450.20-FF-000604', NULL, 'Uncharacterized protein', 116, NULL, NULL, 168693),
(168694, '2.70.150.10-FF-000017', NULL, 'Cation-transporting ATPase', 152, NULL, NULL, 168694),
(168695, '2.60.120.260-FF-000201', NULL, 'Si:dkey-147f3.8', 141, NULL, NULL, 168695),
(168696, '1.25.40.10-FF-001678', NULL, 'Pentatricopeptide repeat-containing protein At2g36730', 124, NULL, NULL, 168696),
(168697, '2.40.160.110-FF-000051', NULL, 'Uncharacterized protein', 103, NULL, NULL, 168697),
(168698, '1.25.40.20-FF-000950', NULL, 'Ankyrin repeat domain 12', 120, NULL, NULL, 168698),
(168699, '2.60.40.10-FF-005405', NULL, NULL, 42, NULL, NULL, 168699),
(168700, '3.30.565.10-FF-000002', NULL, 'DNA gyrase subunit B', 218, NULL, NULL, 168700),
(168701, '1.20.1560.10-FF-000433', NULL, 'ABC transporter, multidrug resistance associated protein', 145, NULL, NULL, 168701),
(168702, '3.80.10.10-FF-003315', NULL, 'Toll-9, isoform B', 175, NULL, NULL, 168702),
(168703, '1.25.40.620-FF-000007', NULL, 'Uncharacterized protein', 70, NULL, NULL, 168703),
(168704, '4.10.110.10-FF-000009', NULL, 'integumentary mucin A.1-like', 52, NULL, NULL, 168704),
(168705, '3.30.540.30-FF-000024', NULL, 'Uncharacterized protein', 52, NULL, NULL, 168705),
(168706, '1.10.510.10-FF-002081', NULL, 'Kinase', 328, NULL, NULL, 168706),
(168707, '3.80.10.10-FF-000561', NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At2g16250', 160, NULL, NULL, 168707),
(168708, '3.40.50.300-FF-004147', NULL, 'Uncharacterized MCM-type protein MJ0961', 343, NULL, NULL, 168708),
(168709, '3.30.499.10-FF-000022', NULL, 'Aconitate hydratase', 164, NULL, NULL, 168709),
(168710, '3.40.30.10-FF-000108', NULL, 'NHL repeat-containing protein 2', 169, NULL, NULL, 168710),
(168711, '2.130.10.10-FF-003236', NULL, 'U4/U6-U5 snRNP complex subunit', 248, NULL, NULL, 168711),
(168712, '2.130.10.10-FF-005372', NULL, 'Uncharacterized protein', 164, NULL, NULL, 168712),
(168713, '1.20.1070.10-FF-002020', NULL, 'Uncharacterized protein', 127, NULL, NULL, 168713),
(168714, '1.10.238.10-FF-000013', NULL, 'Microtubule-actin cross-linking factor 1', 80, NULL, NULL, 168714),
(168715, '3.40.50.10490-FF-000125', NULL, NULL, 61, NULL, NULL, 168715),
(168716, '3.40.50.10330-FF-000105', NULL, 'Uncharacterized kinase C1B1.02c', 107, NULL, NULL, 168716),
(168717, '2.60.120.200-FF-000453', NULL, 'Uncharacterized protein', 190, NULL, NULL, 168717),
(168718, '2.60.120.10-FF-000793', NULL, 'Uncharacterized protein', 139, NULL, NULL, 168718),
(168719, '3.40.50.150-FF-000010', NULL, 'Protein-L-isoaspartate O-methyltransferase', 209, NULL, NULL, 168719),
(168720, '2.10.70.10-FF-000194', NULL, 'CUB and sushi domain-containing protein 1', 63, NULL, NULL, 168720),
(168721, '1.25.40.470-FF-000041', NULL, 'intraflagellar transport protein 140 homolog', 175, NULL, NULL, 168721),
(168722, '1.25.40.10-FF-003027', NULL, 'Pentatricopeptide repeat-containing protein', 106, NULL, NULL, 168722);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(168723, '3.40.50.300-FF-002005', NULL, 'Type IV secretion system protein VirD4', 234, NULL, NULL, 168723),
(168724, '3.30.160.60-FF-005950', NULL, NULL, 36, NULL, NULL, 168724),
(168725, '3.40.1190.20-FF-000160', NULL, 'ATP-dependent (S)-NAD(P)H-hydrate dehydratase', 294, NULL, NULL, 168725),
(168726, '1.10.730.10-FF-000152', NULL, 'Valyl tRNA Synthetase, putative', 234, NULL, NULL, 168726),
(168727, '2.40.50.140-FF-000224', NULL, 'RecQ mediated genome instability 2', 133, NULL, NULL, 168727),
(168728, '3.40.50.1820-FF-001004', NULL, 'ADR202Cp', 228, NULL, NULL, 168728),
(168729, '1.10.10.60-FF-001090', NULL, NULL, 73, NULL, NULL, 168729),
(168730, '2.60.120.310-FF-000019', NULL, 'Dopamine beta-hydroxylase', 162, NULL, NULL, 168730),
(168731, '3.40.50.300-FF-005771', NULL, 'SNF2 helicase', 274, NULL, NULL, 168731),
(168732, '3.30.9.10-FF-000054', NULL, 'Unplaced genomic scaffold supercont1.188, whole genome shotgun sequence', 182, NULL, NULL, 168732),
(168733, '1.25.40.20-FF-001911', NULL, 'Uncharacterized protein', 104, NULL, NULL, 168733),
(168734, '3.30.559.30-FF-000067', NULL, 'Putative peptide synthetase', 280, NULL, NULL, 168734),
(168735, '1.25.40.600-FF-000001', NULL, 'Acid-activated urea channel', 195, NULL, NULL, 168735),
(168736, '1.20.5.190-FF-000180', NULL, NULL, 55, NULL, NULL, 168736),
(168737, '1.10.246.20-FF-000001', NULL, 'E1A binding protein p300', 87, NULL, NULL, 168737),
(168738, '1.25.10.10-FF-000445', NULL, 'Related to MOT1-transcriptional accessory protein', 351, NULL, NULL, 168738),
(168739, '2.130.10.10-FF-000482', NULL, 'WD repeat-containing protein 44', 298, NULL, NULL, 168739),
(168740, '3.80.10.10-FF-002803', NULL, 'Uncharacterized protein', 71, NULL, NULL, 168740),
(168741, '1.10.287.110-FF-000409', NULL, 'Uncharacterized protein', 132, NULL, NULL, 168741),
(168742, '2.60.40.10-FF-006024', NULL, NULL, 89, NULL, NULL, 168742),
(168743, '1.50.40.10-FF-000074', NULL, 'Solute carrier family 25 member 36', 113, NULL, NULL, 168743),
(168744, '1.20.58.1800-FF-000003', NULL, 'Trehalose-phosphatase', 114, NULL, NULL, 168744),
(168745, '1.10.287.70-FF-000768', NULL, 'Uncharacterized protein', 97, NULL, NULL, 168745),
(168746, '3.20.20.370-FF-000029', NULL, 'Uncharacterized protein', 213, NULL, NULL, 168746),
(168747, '3.40.50.1110-FF-000162', NULL, 'Uncharacterized protein', 77, NULL, NULL, 168747),
(168748, '2.40.128.630-FF-000001', NULL, 'Cell surface protein', 81, NULL, NULL, 168748),
(168749, '1.10.238.10-FF-000120', NULL, '45 kDa calcium-binding protein', 66, NULL, NULL, 168749),
(168750, '1.10.510.10-FF-001462', NULL, 'Kinase, CMGC CDK', 234, NULL, NULL, 168750),
(168751, '3.40.50.300-FF-004254', NULL, 'Putative vesicular-fusion ATPase-like protein', 164, NULL, NULL, 168751),
(168752, '2.20.25.90-FF-000005', NULL, 'Thiosulfate reductase PhsA', 62, NULL, NULL, 168752),
(168753, '2.80.10.50-FF-000047', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 128, NULL, NULL, 168753),
(168754, '3.20.20.80-FF-000646', NULL, 'Uncharacterized protein', 88, NULL, NULL, 168754),
(168755, '2.60.260.20-FF-000053', NULL, 'Related to DnaJ homolog subfamily A member 2', 71, NULL, NULL, 168755),
(168756, '2.120.10.80-FF-000323', NULL, 'Uncharacterized protein', 316, NULL, NULL, 168756),
(168757, '1.20.120.350-FF-000261', NULL, NULL, 122, NULL, NULL, 168757),
(168758, '2.40.10.10-FF-000391', NULL, NULL, 40, NULL, NULL, 168758),
(168759, '2.20.70.10-FF-000002', NULL, 'Membrane-associated guanylate kinase, WW and PDZ domain-containing protein 3 isoform 1', 42, NULL, NULL, 168759),
(168760, '3.80.10.10-FF-001180', NULL, 'Receptor like protein 1', 348, NULL, NULL, 168760),
(168761, '3.30.200.20-FF-001862', NULL, 'Cyclin dependent kinase 19', 41, NULL, NULL, 168761),
(168762, '1.10.10.10-FF-000821', NULL, 'LysR family transcriptional regulator', 88, NULL, NULL, 168762),
(168763, '2.60.120.330-FF-000126', NULL, '2OG-Fe(II) oxygenase superfamily, putative', 170, NULL, NULL, 168763),
(168764, '3.40.50.720-FF-000445', NULL, 'Shikimate dehydrogenase (NADP(+))', 133, NULL, NULL, 168764);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(168765, '3.40.50.2300-FF-000991', NULL, NULL, 80, NULL, NULL, 168765),
(168766, '3.40.140.10-FF-000233', NULL, 'Uncharacterized protein', 167, NULL, NULL, 168766),
(168767, '1.10.510.10-FF-004216', NULL, NULL, 314, NULL, NULL, 168767),
(168768, '3.30.160.60-FF-002179', NULL, 'Zinc finger protein 961', 27, NULL, NULL, 168768),
(168769, '2.60.40.10-FF-000622', NULL, 'Fibronectin 1', 94, NULL, NULL, 168769),
(168770, '3.40.50.300-FF-008418', NULL, 'ATP-dependent DNA helicase chl1', 126, NULL, NULL, 168770),
(168771, '1.10.530.10-FF-000041', NULL, 'Serine/threonine protein kinase', 150, NULL, NULL, 168771),
(168772, '1.10.10.10-FF-000714', NULL, 'MarR family transcriptional regulator', 140, NULL, NULL, 168772),
(168773, '2.30.29.30-FF-000844', NULL, 'Nuclear pore complex protein Nup50', 121, NULL, NULL, 168773),
(168774, '3.40.50.300-FF-008525', NULL, 'ATP-dependent helicase hrpA', 200, NULL, NULL, 168774),
(168775, '1.10.3130.10-FF-000010', NULL, 'Serine acetyltransferase 1, putative', 139, NULL, NULL, 168775),
(168776, '3.30.479.10-FF-000015', NULL, '6-carboxy-5,6,7,8-tetrahydropterin synthase', 122, NULL, NULL, 168776),
(168777, '1.25.40.10-FF-000273', NULL, 'Tetratricopeptide repeat domain 39B', 113, NULL, NULL, 168777),
(168778, '3.40.1120.10-FF-000006', NULL, NULL, 189, NULL, NULL, 168778),
(168779, '3.10.50.40-FF-000013', NULL, 'Peptidylprolyl isomerase', 116, NULL, NULL, 168779),
(168780, '1.20.140.10-FF-000071', NULL, 'Acyl-CoA dehydrogenase, mitochondrial,putative', 88, NULL, NULL, 168780),
(168781, '3.40.50.300-FF-003309', NULL, 'L-seryl-tRNA(Sec) kinase, putative', 210, NULL, NULL, 168781),
(168782, '3.30.170.10-FF-000006', NULL, 'Cyclin-dependent kinases regulatory subunit', 90, NULL, NULL, 168782),
(168783, '3.30.70.580-FF-000055', NULL, 'Uncharacterized protein', 116, NULL, NULL, 168783),
(168784, '2.60.120.310-FF-000031', NULL, 'Uncharacterized protein', 81, NULL, NULL, 168784),
(168785, '3.30.40.10-FF-000930', NULL, 'RING finger protein', 82, NULL, NULL, 168785),
(168786, '3.40.50.1820-FF-000487', NULL, 'Dienelactone hydrolase', 252, NULL, NULL, 168786),
(168787, '3.90.1580.10-FF-000012', NULL, 'Protein PvdO', 285, NULL, NULL, 168787),
(168788, '3.80.10.10-FF-000549', NULL, 'Carboxypeptidase N subunit 2', 240, NULL, NULL, 168788),
(168789, '2.60.220.50-FF-000054', NULL, 'Polycystin 1 like 3, transient receptor potential channel interacting', 191, NULL, NULL, 168789),
(168790, '3.40.50.720-FF-000338', NULL, '3-oxoacyl-ACP reductase FabG', 245, NULL, NULL, 168790),
(168791, '2.120.10.80-FF-000216', NULL, 'Flagellar outer dynein arm heavy chain alpha', 236, NULL, NULL, 168791),
(168792, '2.60.40.1180-FF-000111', NULL, 'GM24746', 131, NULL, NULL, 168792),
(168793, '1.25.40.10-FF-000380', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 152, NULL, NULL, 168793),
(168794, '2.60.120.260-FF-000313', NULL, 'Beta-glucuronidase (GusB)', 161, NULL, NULL, 168794),
(168795, '1.20.58.70-FF-000050', NULL, 'EhSyntaxin 1A, putative', 125, NULL, NULL, 168795),
(168796, '1.10.220.150-FF-000023', NULL, 'Arf-GAP with ANK repeat and PH domain-containing protein cnt-2', 135, NULL, NULL, 168796),
(168797, '3.90.550.20-FF-000019', NULL, 'WD repeat and SOF domain-containing protein 1', 105, NULL, NULL, 168797),
(168798, '3.40.1110.10-FF-000287', NULL, NULL, 85, NULL, NULL, 168798),
(168799, '1.10.1200.270-FF-000019', NULL, 'Uncharacterized protein', 139, NULL, NULL, 168799),
(168800, '3.40.718.10-FF-000047', NULL, 'Isocitrate dehydrogenase [NAD] subunit gamma, mitochondrial', 199, NULL, NULL, 168800),
(168801, '2.130.10.10-FF-001786', NULL, 'Probable cytosolic iron-sulfur protein assembly protein Ciao1', 51, NULL, NULL, 168801),
(168802, '3.30.160.60-FF-005164', NULL, NULL, 84, NULL, NULL, 168802),
(168803, '2.60.40.640-FF-000002', NULL, 'Vacuolar protein sorting-associated protein 26A', 177, NULL, NULL, 168803),
(168804, '2.30.29.30-FF-001137', NULL, 'Uncharacterized protein', 181, NULL, NULL, 168804),
(168805, '4.10.1060.10-FF-000024', NULL, 'RNA-binding protein', 39, NULL, NULL, 168805);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(168806, '3.30.2020.30-FF-000024', NULL, 'IP11527p', 81, NULL, NULL, 168806),
(168807, '2.10.70.10-FF-000087', NULL, 'Complement component receptor type 1', 63, NULL, NULL, 168807),
(168808, '1.25.40.10-FF-001577', NULL, 'Peptidylprolyl isomerase', 154, NULL, NULL, 168808),
(168809, '1.10.533.10-FF-000205', NULL, 'Uncharacterized protein', 104, NULL, NULL, 168809),
(168810, '3.90.70.40-FF-000011', NULL, 'GM12472', 136, NULL, NULL, 168810),
(168811, '3.40.50.300-FF-006620', NULL, 'LL-diaminopimelate aminotransferase chloroplastic', 93, NULL, NULL, 168811),
(168812, '2.40.50.90-FF-000147', NULL, 'AGAP012831-PA', 56, NULL, NULL, 168812),
(168813, '1.20.1250.20-FF-001278', NULL, 'Membrane transport protein, possible multidrug resistance protein', 163, NULL, NULL, 168813),
(168814, '3.40.605.10-FF-000009', NULL, 'Cytosolic 10-formyltetrahydrofolate dehydrogenase', 281, NULL, NULL, 168814),
(168815, '3.30.160.60-FF-004652', NULL, NULL, 37, NULL, NULL, 168815),
(168816, '3.30.200.20-FF-001058', NULL, 'Mitogen-activated protein kinase', 101, NULL, NULL, 168816),
(168817, '2.60.40.10-FF-000841', NULL, 'obscurin isoform X4', 92, NULL, NULL, 168817),
(168818, '3.40.120.10-FF-000001', NULL, 'Phosphoglucosamine mutase', 151, NULL, NULL, 168818),
(168819, '3.30.60.30-FF-000027', NULL, 'Complement factor I', 48, NULL, NULL, 168819),
(168820, '1.10.1410.10-FF-000043', NULL, 'Poly(A) polymerase', 68, NULL, NULL, 168820),
(168821, '1.10.150.50-FF-000164', NULL, 'Tyrosine kinase, non-receptor, 1', 67, NULL, NULL, 168821),
(168822, '3.40.50.410-FF-000240', NULL, 'Uncharacterized protein', 168, NULL, NULL, 168822),
(168823, '2.60.40.640-FF-000132', NULL, 'Arrestin 3', 176, NULL, NULL, 168823),
(168824, '2.30.29.30-FF-000625', NULL, 'target of rapamycin complex 2 subunit MAPKAP1 isoform X3', 85, NULL, NULL, 168824),
(168825, '2.30.29.30-FF-000737', NULL, 'Uncharacterized protein', 107, NULL, NULL, 168825),
(168826, '1.20.1070.10-FF-000558', NULL, 'Thromboxane A2 receptor', 137, NULL, NULL, 168826),
(168827, '1.10.8.10-FF-000281', NULL, 'SBP (S-ribonuclease binding protein) family protein', 26, NULL, NULL, 168827),
(168828, '3.40.50.10470-FF-000018', NULL, 'Methylthioribose-1-phosphate isomerase', 172, NULL, NULL, 168828),
(168829, '1.10.230.10-FF-000001', NULL, 'Citrate synthase', 115, NULL, NULL, 168829),
(168830, '1.20.1110.10-FF-000169', NULL, 'Uncharacterized protein', 384, NULL, NULL, 168830),
(168831, '2.60.120.200-FF-000560', NULL, 'L-type lectin-domain containing receptor kinase V.9', 160, NULL, NULL, 168831),
(168832, '4.10.900.10-FF-000013', NULL, 'transcription factor 7-like 1', 75, NULL, NULL, 168832),
(168833, '1.20.1530.20-FF-000030', NULL, 'Na(+)/H(+) antiporter NhaP', 413, NULL, NULL, 168833),
(168834, '1.20.5.190-FF-000073', NULL, 'Abnormal spindle microtubule assembly', 43, NULL, NULL, 168834),
(168835, '3.15.20.10-FF-000003', NULL, 'BPI fold-containing family B member 3', 257, NULL, NULL, 168835),
(168836, '3.40.50.720-FF-001283', NULL, 'D-3-phosphoglycerate dehydrogenase', 22, NULL, NULL, 168836),
(168837, '3.20.20.80-FF-000776', NULL, 'Uncharacterized protein', 376, NULL, NULL, 168837),
(168838, '3.40.50.1700-FF-000018', NULL, 'Glycosyl hydrolase family 3 C terminal domain containing protein', 71, NULL, NULL, 168838),
(168839, '3.40.50.300-FF-007587', NULL, 'Uncharacterized protein', 176, NULL, NULL, 168839),
(168840, '2.60.120.10-FF-000686', NULL, 'Predicted protein', 77, NULL, NULL, 168840),
(168841, '1.20.1420.10-FF-000035', NULL, NULL, 153, NULL, NULL, 168841),
(168842, '2.40.30.10-FF-000167', NULL, 'Slm3p', 98, NULL, NULL, 168842),
(168843, '3.30.160.60-FF-004433', NULL, NULL, 27, NULL, NULL, 168843),
(168844, '2.60.260.20-FF-000160', NULL, 'Uncharacterized protein', 78, NULL, NULL, 168844),
(168845, '3.40.50.300-FF-000095', NULL, 'Rho-related GTP-binding protein RhoC', 193, NULL, NULL, 168845),
(168846, '2.60.40.10-FF-004101', NULL, NULL, 94, NULL, NULL, 168846),
(168847, '3.40.720.10-FF-000316', NULL, 'Predicted protein', 192, NULL, NULL, 168847),
(168848, '2.60.120.330-FF-000233', NULL, 'Os05g0514600 protein', 88, NULL, NULL, 168848);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(168849, '3.90.260.10-FF-000045', NULL, 'Uncharacterized protein', 118, NULL, NULL, 168849),
(168850, '3.40.50.920-FF-000050', NULL, 'Pyruvate dehydrogenase E1 component subunit beta, mitochondrial', 85, NULL, NULL, 168850),
(168851, '1.20.900.10-FF-000039', NULL, 'Uncharacterized protein, isoform C', 229, NULL, NULL, 168851),
(168852, '3.40.50.10190-FF-000367', NULL, 'Predicted protein', 104, NULL, NULL, 168852),
(168853, '3.40.30.10-FF-001053', NULL, 'Glutathione S-transferase kappa', 208, NULL, NULL, 168853),
(168854, '3.40.50.10190-FF-000361', NULL, 'Uncharacterized protein', 54, NULL, NULL, 168854),
(168855, '3.40.50.300-FF-004366', NULL, 'Probable metal transport system ATP-binding protein CT_416', 225, NULL, NULL, 168855),
(168856, '3.40.50.1110-FF-000050', NULL, 'N-acetylneuraminate 9-O-acetyltransferase', 220, NULL, NULL, 168856),
(168857, '1.10.246.60-FF-000007', NULL, 'Eukaryotic translation initiation factor 3 subunit J', 79, NULL, NULL, 168857),
(168858, '1.25.40.10-FF-004432', NULL, 'Uncharacterized protein', 122, NULL, NULL, 168858),
(168859, '3.40.50.1100-FF-000165', NULL, 'Uncharacterized protein', 25, NULL, NULL, 168859),
(168860, '3.40.640.10-FF-000496', NULL, 'Uncharacterized protein', 266, NULL, NULL, 168860),
(168861, '1.10.1200.10-FF-000111', NULL, 'Peptidyl carrier protein type II', 78, NULL, NULL, 168861),
(168862, '3.30.70.330-FF-002251', NULL, NULL, 110, NULL, NULL, 168862),
(168863, '1.20.90.10-FF-000056', NULL, NULL, 57, NULL, NULL, 168863),
(168864, '3.30.310.130-FF-000009', NULL, 'Unplaced genomic scaffold supercont2.24, whole genome shotgun sequence', 61, NULL, NULL, 168864),
(168865, '3.30.470.20-FF-000156', NULL, 'Uncharacterized protein', 156, NULL, NULL, 168865),
(168866, '1.25.40.10-FF-000958', NULL, 'Pentatricopeptide repeat-containing protein At4g39530', 107, NULL, NULL, 168866),
(168867, '2.50.20.10-FF-000020', NULL, 'Outer membrane lipoprotein carrier protein LolA', 183, NULL, NULL, 168867),
(168868, '2.10.25.10-FF-000128', NULL, 'laminin subunit alpha-2 isoform X1', 55, NULL, NULL, 168868),
(168869, '2.70.50.30-FF-000027', NULL, NULL, 78, NULL, NULL, 168869),
(168870, '1.20.1440.90-FF-000015', NULL, NULL, 130, NULL, NULL, 168870),
(168871, '3.60.21.10-FF-000076', NULL, 'Putative nucleotidase', 334, NULL, NULL, 168871),
(168872, '1.10.2000.10-FF-000023', NULL, 'Tyrosine-protein kinase transmembrane receptor ROR2', 133, NULL, NULL, 168872),
(168873, '1.10.10.10-FF-001333', NULL, 'PCI domain-containing 2', 43, NULL, NULL, 168873),
(168874, '1.10.287.130-FF-000056', NULL, 'Sensor histidine kinase', 65, NULL, NULL, 168874),
(168875, '1.25.40.10-FF-000161', NULL, 'prolyl 4-hydroxylase subunit alpha-3 isoform X1', 145, NULL, NULL, 168875),
(168876, '3.30.70.380-FF-000006', NULL, 'Phenylalanyl-tRNA synthetase subunit alpha', 103, NULL, NULL, 168876),
(168877, '1.10.3260.10-FF-000019', NULL, 'DNA ligase', 231, NULL, NULL, 168877),
(168878, '3.90.470.20-FF-000081', NULL, 'Uncharacterized protein', 34, NULL, NULL, 168878),
(168879, '3.30.160.60-FF-005849', NULL, NULL, 20, NULL, NULL, 168879),
(168880, '1.10.238.10-FF-000805', NULL, 'Defective in cullin neddylation protein', 79, NULL, NULL, 168880),
(168881, '1.20.58.670-FF-000008', NULL, 'Protein transport protein TIP20', 137, NULL, NULL, 168881),
(168882, '3.40.50.620-FF-000078', NULL, 'Valine--tRNA ligase, mitochondrial', 229, NULL, NULL, 168882),
(168883, '3.20.20.70-FF-000317', NULL, '2-isopropylmalate synthase', 307, NULL, NULL, 168883),
(168884, '1.25.40.20-FF-000495', NULL, 'Uncharacterized protein, isoform A', 132, NULL, NULL, 168884),
(168885, '1.10.510.10-FF-000164', NULL, 'Casein kinase 1-like protein', 328, NULL, NULL, 168885),
(168886, '1.10.555.10-FF-000244', NULL, NULL, 192, NULL, NULL, 168886),
(168887, '2.70.170.10-FF-000131', NULL, 'Uncharacterized protein', 207, NULL, NULL, 168887),
(168888, '1.20.1050.130-FF-000028', NULL, 'Predicted protein', 240, NULL, NULL, 168888),
(168889, '3.90.70.10-FF-000805', NULL, 'Ubiquitin carboxyl-terminal hydrolase, putative', 316, NULL, NULL, 168889),
(168890, '3.10.100.10-FF-000046', NULL, 'Secretory phospholipase A2 receptor', 144, NULL, NULL, 168890);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(168891, '1.10.470.10-FF-000002', NULL, 'Variant surface glycoprotein (VSG, atypical), putative', 147, NULL, NULL, 168891),
(168892, '3.90.550.10-FF-000360', NULL, 'UDP-N-acetylglucosamine pyrophosphorylase 1', 194, NULL, NULL, 168892),
(168893, '1.20.120.350-FF-000024', NULL, 'Potassium voltage-gated channel subfamily G member 1', 157, NULL, NULL, 168893),
(168894, '3.30.1370.10-FF-000111', NULL, 'Uncharacterized protein, isoform A', 95, NULL, NULL, 168894),
(168895, '1.10.510.10-FF-004435', NULL, NULL, 56, NULL, NULL, 168895),
(168896, '3.20.20.140-FF-000303', NULL, 'Putative cell surface-anchored phosphoesterase', 219, NULL, NULL, 168896),
(168897, '4.10.1000.40-FF-000012', NULL, 'Nuclear polyadenylated RNA-binding protein NAB2', 67, NULL, NULL, 168897),
(168898, '1.10.287.770-FF-000017', NULL, 'T-cell surface glycoprotein CD3 delta chain', 32, NULL, NULL, 168898),
(168899, '3.40.50.2020-FF-000103', NULL, 'Ribose-phosphate pyrophosphokinase', 144, NULL, NULL, 168899),
(168900, '2.80.10.50-FF-000159', NULL, 'Dolichyl-phosphate-mannose-protein mannosyltransferase', 216, NULL, NULL, 168900),
(168901, '3.30.160.60-FF-000381', NULL, 'zinc finger protein 574', 27, NULL, NULL, 168901),
(168902, '1.10.1520.10-FF-000039', NULL, '39S ribosomal protein L44, mitochondrial', 138, NULL, NULL, 168902),
(168903, '3.30.160.60-FF-003477', NULL, 'FI01424p', 31, NULL, NULL, 168903),
(168904, '3.40.50.300-FF-007906', NULL, 'DNA helicase', 187, NULL, NULL, 168904),
(168905, '3.30.160.60-FF-001802', NULL, 'zinc finger protein 133 isoform X1', 28, NULL, NULL, 168905),
(168906, '2.40.50.100-FF-000004', NULL, '50S ribosomal protein L27', 80, NULL, NULL, 168906),
(168907, '1.10.287.70-FF-000190', NULL, 'Uncharacterized protein, isoform A', 305, NULL, NULL, 168907),
(168908, '1.10.15.40-FF-000004', NULL, 'Fe-S cluster domain protein', 53, NULL, NULL, 168908),
(168909, '2.60.40.10-FF-005512', NULL, NULL, 78, NULL, NULL, 168909),
(168910, '3.30.70.330-FF-001306', NULL, 'RE24187p', 104, NULL, NULL, 168910),
(168911, '1.20.58.60-FF-000625', NULL, 'Spectrin repeat-containing, nuclear envelope 1b', 112, NULL, NULL, 168911),
(168912, '1.10.533.10-FF-000194', NULL, 'Protein MC160', 86, NULL, NULL, 168912),
(168913, '2.30.30.140-FF-000172', NULL, 'Maternal protein tudor', 80, NULL, NULL, 168913),
(168914, '3.90.1290.10-FF-000029', NULL, 'Dystonin', 48, NULL, NULL, 168914),
(168915, '3.40.50.2300-FF-000772', NULL, NULL, 121, NULL, NULL, 168915),
(168916, '3.30.70.330-FF-000020', NULL, 'RNA-binding protein Musashi homolog 2 isoform X1', 96, NULL, NULL, 168916),
(168917, '3.30.70.330-FF-001290', NULL, 'Nucleolin 2', 111, NULL, NULL, 168917),
(168918, '1.10.510.10-FF-001681', NULL, 'Putative tyrosine-protein kinase Wsck', 196, NULL, NULL, 168918),
(168919, '3.80.10.10-FF-003427', NULL, 'Uncharacterized protein', 68, NULL, NULL, 168919),
(168920, '3.30.450.40-FF-000256', NULL, 'Transcriptional regulator (IclR family)', 177, NULL, NULL, 168920),
(168921, '3.40.50.1000-FF-000814', NULL, NULL, 119, NULL, NULL, 168921),
(168922, '1.25.40.20-FF-000506', NULL, 'E3 ubiquitin-protein ligase XBAT32', 123, NULL, NULL, 168922),
(168923, '3.40.50.10480-FF-000010', NULL, 'Ribosome biogenesis protein putative', 184, NULL, NULL, 168923),
(168924, '3.30.160.60-FF-004438', NULL, NULL, 30, NULL, NULL, 168924),
(168925, '1.20.200.10-FF-000014', NULL, '3-carboxy-cis,cis-muconate cycloisomerase', 360, NULL, NULL, 168925),
(168926, '3.40.50.300-FF-004259', NULL, 'Dicer-like 1 protein', 225, NULL, NULL, 168926),
(168927, '3.10.110.10-FF-000108', NULL, 'Ubiquitin-conjugating enzyme family protein', 161, NULL, NULL, 168927),
(168928, '1.25.40.180-FF-000268', NULL, NULL, 206, NULL, NULL, 168928),
(168929, '3.30.890.10-FF-000022', NULL, 'Methyl-CpG-binding domain-containing protein 13', 144, NULL, NULL, 168929),
(168930, '1.10.1420.10-FF-000105', NULL, 'DNA mismatch repair protein Msh2', 223, NULL, NULL, 168930),
(168931, '3.30.50.10-FF-000195', NULL, 'Uncharacterized protein', 29, NULL, NULL, 168931),
(168932, '3.40.50.300-FF-006171', NULL, 'Rad3-related DNA helicase', 214, NULL, NULL, 168932); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(168933, '3.30.170.10-FF-000001', NULL, 'Cyclin-dependent kinases regulatory subunit', 78, NULL, NULL, 168933),
(168934, '3.40.50.2000-FF-000777', NULL, 'UDP-glucuronosyltransferase', 162, NULL, NULL, 168934),
(168935, '1.20.120.1750-FF-000120', NULL, 'RBR-type E3 ubiquitin transferase', 126, NULL, NULL, 168935),
(168936, '3.40.50.2000-FF-001053', NULL, 'Uncharacterized protein', 118, NULL, NULL, 168936),
(168937, '2.60.40.10-FF-002527', NULL, 'Uncharacterized protein, isoform B', 104, NULL, NULL, 168937),
(168938, '3.30.420.10-FF-000330', NULL, 'DNA polymerase III subunit epsilon', 167, NULL, NULL, 168938),
(168939, '1.20.920.10-FF-000041', NULL, 'ATP-dependent helicase brm', 123, NULL, NULL, 168939),
(168940, '1.25.40.570-FF-000059', NULL, 'COP9 signalosome complex-related / CSN complex-like protein', 277, NULL, NULL, 168940),
(168941, '1.10.730.10-FF-000040', NULL, 'Methionyl-tRNA synthetase, cytoplasmic, putative', 166, NULL, NULL, 168941),
(168942, '1.10.225.10-FF-000034', NULL, 'sphingomyelin phosphodiesterase', 73, NULL, NULL, 168942),
(168943, '2.60.40.60-FF-000491', NULL, 'Cadherin 17, LI cadherin (Liver-intestine)', 101, NULL, NULL, 168943),
(168944, '3.90.660.20-FF-000011', NULL, 'Uncharacterized protein', 28, NULL, NULL, 168944),
(168945, '3.40.50.150-FF-000807', NULL, 'Protein-lysine N-methyltransferase CBG01728', 196, NULL, NULL, 168945),
(168946, '3.90.70.10-FF-000249', NULL, 'Ubiquitin carboxyl-terminal hydrolase domain containing protein', 329, NULL, NULL, 168946),
(168947, '3.30.70.2280-FF-000010', NULL, 'Uncharacterized protein', 79, NULL, NULL, 168947),
(168948, '2.60.98.10-FF-000002', NULL, 'Structural polyprotein', 87, NULL, NULL, 168948),
(168949, '3.40.50.150-FF-001319', NULL, NULL, 207, NULL, NULL, 168949),
(168950, '3.30.1330.10-FF-000002', NULL, 'Phosphoribosylformylglycinamidine synthase', 207, NULL, NULL, 168950),
(168951, '3.40.630.30-FF-000422', NULL, 'Acetyltransferase, GNAT family protein', 173, NULL, NULL, 168951),
(168952, '3.30.160.60-FF-006350', NULL, NULL, 22, NULL, NULL, 168952),
(168953, '3.80.10.10-FF-002915', NULL, 'Uncharacterized protein', 84, NULL, NULL, 168953),
(168954, '3.40.50.2300-FF-001391', NULL, NULL, 78, NULL, NULL, 168954),
(168955, '1.25.40.20-FF-000613', NULL, 'Ankyrin repeat family protein', 220, NULL, NULL, 168955),
(168956, '1.20.1250.20-FF-002239', NULL, 'Solute carrier family 37 member 4b', 118, NULL, NULL, 168956),
(168957, '1.10.1280.10-FF-000009', NULL, 'Tyrosinase', 383, NULL, NULL, 168957),
(168958, '3.40.710.10-FF-000142', NULL, 'Serine hydrolase', 377, NULL, NULL, 168958),
(168959, '3.80.10.10-FF-003534', NULL, 'AER398Wp', 297, NULL, NULL, 168959),
(168960, '1.20.1250.20-FF-000789', NULL, 'Permease, multidrug efflux', 198, NULL, NULL, 168960),
(168961, '3.30.479.30-FF-000010', NULL, 'major vault protein-like', 116, NULL, NULL, 168961),
(168962, '2.10.25.10-FF-001292', NULL, 'Stabilin 1, isoform CRA_a', 41, NULL, NULL, 168962),
(168963, '3.80.10.10-FF-002808', NULL, 'Uncharacterized protein', 95, NULL, NULL, 168963),
(168964, '1.20.1070.10-FF-000339', NULL, 'Uncharacterized protein', 332, NULL, NULL, 168964),
(168965, '1.10.3060.10-FF-000015', NULL, 'Protein translocase subunit SecA', 174, NULL, NULL, 168965),
(168966, '1.10.10.2740-FF-000001', NULL, 'Transcription elongation factor spt6', 95, NULL, NULL, 168966),
(168967, '1.10.472.10-FF-000512', NULL, 'Uncharacterized protein', 99, NULL, NULL, 168967),
(168968, '2.10.90.10-FF-000071', NULL, 'PDGF-and VEGF-related factor 1, isoform B', 134, NULL, NULL, 168968),
(168969, '1.10.510.10-FF-003816', NULL, NULL, 115, NULL, NULL, 168969),
(168970, '2.30.29.30-FF-001244', NULL, 'Ras GTPase-activating protein gap-1', 112, NULL, NULL, 168970),
(168971, '3.30.559.70-FF-000051', NULL, 'Uncharacterized protein', 321, NULL, NULL, 168971),
(168972, '3.30.720.210-FF-000002', NULL, 'ATP-dependent zinc metalloprotease FTSH chloroplastic', 81, NULL, NULL, 168972),
(168973, '1.10.287.310-FF-000014', NULL, 'Uncharacterized protein', 47, NULL, NULL, 168973),
(168974, '3.90.190.10-FF-000606', NULL, 'Protein-tyrosine-phosphatase', 165, NULL, NULL, 168974);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(168975, '3.80.10.10-FF-004372', NULL, 'Uncharacterized protein', 173, NULL, NULL, 168975),
(168976, '3.20.20.150-FF-000076', NULL, 'Si:ch211-141o9.10', 74, NULL, NULL, 168976),
(168977, '3.40.50.150-FF-000465', NULL, 'Carnosine N-methyltransferase', 194, NULL, NULL, 168977),
(168978, '4.10.1060.10-FF-000029', NULL, 'ubiquitin thioesterase trabid', 33, NULL, NULL, 168978),
(168979, '3.40.50.300-FF-003298', NULL, 'ATPase involved in chromosome partitioning', 251, NULL, NULL, 168979),
(168980, '3.40.50.2020-FF-000098', NULL, 'Probable PRS4-ribose-phosphate pyrophosphokinase 3', 88, NULL, NULL, 168980),
(168981, '1.25.40.10-FF-003920', NULL, 'Uncharacterized protein', 293, NULL, NULL, 168981),
(168982, '3.40.390.10-FF-000167', NULL, 'Uncharacterized protein', 145, NULL, NULL, 168982),
(168983, '3.40.1190.20-FF-000165', NULL, 'ATP-dependent (S)-NAD(P)H-hydrate dehydratase', 261, NULL, NULL, 168983),
(168984, '2.70.170.10-FF-000243', NULL, 'Uncharacterized protein', 181, NULL, NULL, 168984),
(168985, '1.10.287.70-FF-000195', NULL, 'Uncharacterized protein', 135, NULL, NULL, 168985),
(168986, '1.10.472.10-FF-000057', NULL, 'Cyclin N-terminal domain containing 2', 112, NULL, NULL, 168986),
(168987, '2.60.40.10-FF-001353', NULL, 'Sallimus, isoform P', 98, NULL, NULL, 168987),
(168988, '2.10.25.10-FF-001640', NULL, 'Uncharacterized protein', 76, NULL, NULL, 168988),
(168989, '3.40.190.10-FF-000972', NULL, 'Predicted protein', 13, NULL, NULL, 168989),
(168990, '2.60.40.150-FF-000294', NULL, 'Synaptotagmin 1-like Protein', 133, NULL, NULL, 168990),
(168991, '2.170.300.10-FF-000073', NULL, 'Uncharacterized protein', 127, NULL, NULL, 168991),
(168992, '3.40.50.150-FF-000358', NULL, 'Ribosomal RNA-processing protein 8', 170, NULL, NULL, 168992),
(168993, '3.30.365.10-FF-000021', NULL, 'Carbon monoxide dehydrogenase, large subunit', 170, NULL, NULL, 168993),
(168994, '1.20.5.1160-FF-000002', NULL, 'Type I keratin 10', 113, NULL, NULL, 168994),
(168995, '2.40.20.10-FF-000116', NULL, 'Uncharacterized protein', 114, NULL, NULL, 168995),
(168996, '1.10.3200.20-FF-000007', NULL, 'DNA polymerase', 171, NULL, NULL, 168996),
(168997, '1.20.20.10-FF-000001', NULL, 'ATP synthase subunit c, chloroplastic', 78, NULL, NULL, 168997),
(168998, '3.30.420.10-FF-000667', NULL, NULL, 182, NULL, NULL, 168998),
(168999, '3.90.70.10-FF-000120', NULL, 'Ubiquitinyl hydrolase 1', 200, NULL, NULL, 168999),
(169000, '1.10.287.2900-FF-000011', NULL, 'Coiled-coil-helix-coiled-coil-helix domain-containing 4b', 81, NULL, NULL, 169000),
(169001, '3.40.50.300-FF-000999', NULL, 'Mov10 like RISC complex RNA helicase 1', 284, NULL, NULL, 169001),
(169002, '3.90.1150.10-FF-000204', NULL, 'Hypothetical aminotransferase', 125, NULL, NULL, 169002),
(169003, '3.40.50.720-FF-001631', NULL, 'Uncharacterized protein', 330, NULL, NULL, 169003),
(169004, '3.10.490.20-FF-000021', NULL, 'Dynein heavy chain, cytoplasmic', 120, NULL, NULL, 169004),
(169005, '1.20.120.900-FF-000004', NULL, 'Peroxisomal membrane protein receptor Pex19', 120, NULL, NULL, 169005),
(169006, '2.60.120.290-FF-000204', NULL, 'Uncharacterized protein', 124, NULL, NULL, 169006),
(169007, '1.10.472.10-FF-000164', NULL, 'CYC2-like cyclin, putative', 109, NULL, NULL, 169007),
(169008, '4.10.110.20-FF-000001', NULL, 'Variant surface glycoprotein (VSG), putative', 83, NULL, NULL, 169008),
(169009, '3.20.20.140-FF-000415', NULL, 'Uncharacterized protein', 78, NULL, NULL, 169009),
(169010, '2.130.10.10-FF-001893', NULL, 'Coronin, actin-binding protein, 1Cb', 70, NULL, NULL, 169010),
(169011, '3.80.10.10-FF-002466', NULL, 'Cell surface protein', 210, NULL, NULL, 169011),
(169012, '3.60.110.10-FF-000081', NULL, NULL, 245, NULL, NULL, 169012),
(169013, '2.70.150.10-FF-000129', NULL, 'Probable cadmium/zinc-transporting ATPase HMA1, chloroplastic', 126, NULL, NULL, 169013),
(169014, '3.30.160.60-FF-004096', NULL, NULL, 32, NULL, NULL, 169014),
(169015, '1.10.510.10-FF-003255', NULL, NULL, 112, NULL, NULL, 169015),
(169016, '3.40.50.300-FF-002461', NULL, 'GTP-binding protein CIN4', 186, NULL, NULL, 169016);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(169017, '3.30.505.10-FF-000027', NULL, 'Cytoplasmic protein nck1', 100, NULL, NULL, 169017),
(169018, '3.50.50.60-FF-000809', NULL, 'Putative monooxygenase NMA2164', 222, NULL, NULL, 169018),
(169019, '1.25.40.20-FF-000490', NULL, 'ANKS1B isoform 4', 120, NULL, NULL, 169019),
(169020, '1.25.10.10-FF-001064', NULL, 'Putative gtp binding protein', 356, NULL, NULL, 169020),
(169021, '2.10.25.10-FF-001185', NULL, 'Uncharacterized protein', 39, NULL, NULL, 169021),
(169022, '3.60.20.10-FF-000096', NULL, 'Ferredoxin-dependent glutamate synthase, chloroplastic', 431, NULL, NULL, 169022),
(169023, '3.30.830.10-FF-000029', NULL, 'Presequence protease 1', 205, NULL, NULL, 169023),
(169024, '2.10.70.10-FF-000199', NULL, 'Mannan-binding lectin serine peptidase 1', 61, NULL, NULL, 169024),
(169025, '3.30.1150.10-FF-000016', NULL, 'Energy transducer TonB', 83, NULL, NULL, 169025),
(169026, '1.25.10.10-FF-001406', NULL, 'U3 small nucleolar RNA-associated protein 10', 168, NULL, NULL, 169026),
(169027, '3.20.20.190-FF-000172', NULL, NULL, 74, NULL, NULL, 169027),
(169028, '3.40.33.10-FF-000149', NULL, 'Pathogenesis-related protein 1', 137, NULL, NULL, 169028),
(169029, '3.40.50.150-FF-001426', NULL, NULL, 154, NULL, NULL, 169029),
(169030, '3.40.50.150-FF-000015', NULL, 'Protein-L-isoaspartate (D-aspartate) O-methyltransferase domain-containing 1', 221, NULL, NULL, 169030),
(169031, '3.30.1130.10-FF-000003', NULL, '7,8-dihydroneopterin aldolase', 120, NULL, NULL, 169031),
(169032, '3.90.1670.10-FF-000002', NULL, 'Protein FdhE homolog', 280, NULL, NULL, 169032),
(169033, '3.30.420.40-FF-000428', NULL, 'Uncharacterized protein', 181, NULL, NULL, 169033),
(169034, '3.10.450.240-FF-000021', NULL, 'Mitochondrial inner membrane protein Mba1', 135, NULL, NULL, 169034),
(169035, '2.30.30.770-FF-000012', NULL, NULL, 82, NULL, NULL, 169035),
(169036, '3.50.30.30-FF-000018', NULL, 'E3 ubiquitin-protein ligase ZNRF3', 164, NULL, NULL, 169036),
(169037, '2.160.10.10-FF-000003', NULL, 'Acyl-[acyl-carrier-protein]--UDP-N-acetylglucosamine O-acyltransferase', 196, NULL, NULL, 169037),
(169038, '3.30.160.60-FF-002640', NULL, 'Uncharacterized protein, isoform B', 31, NULL, NULL, 169038),
(169039, '3.90.199.10-FF-000019', NULL, NULL, 14, NULL, NULL, 169039),
(169040, '2.60.40.10-FF-004096', NULL, NULL, 94, NULL, NULL, 169040),
(169041, '2.40.50.150-FF-000008', NULL, 'DNA-directed RNA polymerase subunit beta', 135, NULL, NULL, 169041),
(169042, '3.40.630.30-FF-000203', NULL, 'N-alpha-acetyltransferase NAT5', 176, NULL, NULL, 169042),
(169043, '2.20.110.10-FF-000037', NULL, 'Phosphatidylinositol 4-phosphate 5-kinase', 47, NULL, NULL, 169043),
(169044, '2.60.120.10-FF-000574', NULL, 'Bacterial regulatory s, crp family protein', 150, NULL, NULL, 169044),
(169045, '2.60.40.10-FF-001908', NULL, 'Uncharacterized protein, isoform B', 99, NULL, NULL, 169045),
(169046, '2.60.40.1820-FF-000011', NULL, 'Os01g0624400 protein', 85, NULL, NULL, 169046),
(169047, '2.70.98.30-FF-000024', NULL, 'Alpha-mannosidase', 272, NULL, NULL, 169047),
(169048, '1.10.10.60-FF-000471', NULL, 'Homeobox domain protein', 67, NULL, NULL, 169048),
(169049, '3.50.50.60-FF-000467', NULL, 'NAD(P)-binding Rossmann-like domain protein', 416, NULL, NULL, 169049),
(169050, '1.10.8.270-FF-000144', NULL, 'Uncharacterized protein', 60, NULL, NULL, 169050),
(169051, '1.10.1040.10-FF-000008', NULL, '2-hydroxy-3-oxopropionate reductase', 131, NULL, NULL, 169051),
(169052, '2.40.160.10-FF-000002', NULL, 'Outer membrane porin F', 328, NULL, NULL, 169052),
(169053, '3.40.800.10-FF-000031', NULL, 'Formimidoylglutamase', 303, NULL, NULL, 169053),
(169054, '2.30.30.790-FF-000018', NULL, '39S ribosomal protein L19, mitochondrial', 128, NULL, NULL, 169054),
(169055, '3.30.930.10-FF-000065', NULL, 'Proline--tRNA ligase', 104, NULL, NULL, 169055),
(169056, '3.40.33.10-FF-000019', NULL, 'Pathogenesis-related protein 1', 153, NULL, NULL, 169056),
(169057, '3.20.20.220-FF-000007', NULL, 'Bifunctional homocysteine S-methyltransferase/methylenetetrahydrofolate reductase', 306, NULL, NULL, 169057);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(169058, '3.30.930.10-FF-000407', NULL, 'Os04g0398300 protein', 74, NULL, NULL, 169058),
(169059, '1.25.40.20-FF-001799', NULL, 'Uncharacterized protein', 168, NULL, NULL, 169059),
(169060, '3.40.50.150-FF-001769', NULL, NULL, 206, NULL, NULL, 169060),
(169061, '1.10.3080.10-FF-000028', NULL, 'Chloride channel protein', 427, NULL, NULL, 169061),
(169062, '3.50.50.60-FF-001428', NULL, 'Protoporphyrinogen oxidase', 116, NULL, NULL, 169062),
(169063, '3.30.160.60-FF-005057', NULL, NULL, 32, NULL, NULL, 169063),
(169064, '2.40.30.10-FF-000274', NULL, 'Adenylyl-sulfate kinase', 88, NULL, NULL, 169064),
(169065, '3.90.190.10-FF-000270', NULL, 'Protein-tyrosine-phosphatase', 124, NULL, NULL, 169065),
(169066, '2.60.40.10-FF-004444', NULL, NULL, 120, NULL, NULL, 169066),
(169067, '1.20.5.340-FF-000039', NULL, 'Nance-Horan syndrome protein isoform X1', 87, NULL, NULL, 169067),
(169068, '2.130.10.10-FF-005153', NULL, 'Wd-repeat protein, putative', 141, NULL, NULL, 169068),
(169069, '3.30.70.330-FF-002599', NULL, NULL, 182, NULL, NULL, 169069),
(169070, '3.30.70.330-FF-001413', NULL, 'Uncharacterized protein', 116, NULL, NULL, 169070),
(169071, '1.10.290.10-FF-000011', NULL, 'DNA topoisomerase 1', 127, NULL, NULL, 169071),
(169072, '1.10.3430.10-FF-000050', NULL, 'Uncharacterized protein', 323, NULL, NULL, 169072),
(169073, '2.20.25.420-FF-000001', NULL, 'Zinc finger protein ZPR1', 56, NULL, NULL, 169073),
(169074, '1.25.10.10-FF-001749', NULL, 'Importin, putative', 127, NULL, NULL, 169074),
(169075, '2.60.40.10-FF-005950', NULL, NULL, 93, NULL, NULL, 169075),
(169076, '1.20.120.1080-FF-000003', NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase PRP43', 104, NULL, NULL, 169076),
(169077, '3.90.1150.10-FF-000199', NULL, 'Predicted protein', 79, NULL, NULL, 169077),
(169078, '1.10.238.200-FF-000017', NULL, 'DCN1-like protein', 80, NULL, NULL, 169078),
(169079, '1.20.1740.10-FF-000071', NULL, 'Amino acid permease', 448, NULL, NULL, 169079),
(169080, '3.40.50.720-FF-001850', NULL, 'Putative malate dehydrogenase 1B', 157, NULL, NULL, 169080),
(169081, '3.30.60.20-FF-000131', NULL, 'Uncharacterized protein', 69, NULL, NULL, 169081),
(169082, '1.25.40.120-FF-000060', NULL, 'Uncharacterized protein', 225, NULL, NULL, 169082),
(169083, '2.60.40.10-FF-000734', NULL, 'plexin-B1 isoform X1', 139, NULL, NULL, 169083),
(169084, '3.40.30.10-FF-000671', NULL, 'Pyruvate decarboxylase 2', 155, NULL, NULL, 169084),
(169085, '2.30.30.30-FF-000022', NULL, '60S ribosomal protein L14', 86, NULL, NULL, 169085),
(169086, '3.30.70.330-FF-000924', NULL, 'RNA-binding protein CP33, chloroplastic', 111, NULL, NULL, 169086),
(169087, '1.20.58.60-FF-000732', NULL, 'Uncharacterized protein', 104, NULL, NULL, 169087),
(169088, '3.40.50.1000-FF-000028', NULL, 'Calcium-transporting P-type ATPase, putative', 157, NULL, NULL, 169088),
(169089, '4.10.410.10-FF-000049', NULL, 'Protein CBR-MEC-1', 70, NULL, NULL, 169089),
(169090, '2.20.25.10-FF-000038', NULL, 'DNA-directed RNA polymerase 30 kDa polypeptide', 66, NULL, NULL, 169090),
(169091, '3.80.10.10-FF-002247', NULL, 'Uncharacterized protein', 123, NULL, NULL, 169091),
(169092, '2.60.120.290-FF-000199', NULL, 'Uncharacterized protein', 81, NULL, NULL, 169092),
(169093, '3.90.1200.10-FF-000086', NULL, 'Protein-ribulosamine 3-kinase chloroplastic', 162, NULL, NULL, 169093),
(169094, '2.60.120.650-FF-000104', NULL, 'Lysine-specific demethylase 4B', 43, NULL, NULL, 169094),
(169095, '2.130.10.10-FF-001443', NULL, 'WD domain, G-beta repeat-containing protein', 311, NULL, NULL, 169095),
(169096, '3.30.420.40-FF-000215', NULL, 'Actin-related protein RO7, putative', 135, NULL, NULL, 169096),
(169097, '3.20.20.70-FF-000424', NULL, 'Inosine-5''-monophosphate dehydrogenase 2', 471, NULL, NULL, 169097),
(169098, '3.40.930.10-FF-000029', NULL, 'PTS system fructose-specific IIA component', 145, NULL, NULL, 169098),
(169099, '3.10.100.10-FF-000153', NULL, 'Mannose receptor, C type 1a', 142, NULL, NULL, 169099),
(169100, '1.25.10.10-FF-002025', NULL, 'Armadillo repeat-containing 4', 298, NULL, NULL, 169100);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(169101, '2.60.120.10-FF-000118', NULL, 'cAMP-dependent protein kinase regulatory subunit', 133, NULL, NULL, 169101),
(169102, '3.30.450.20-FF-000380', NULL, 'PAS/PAC sensor-containing diguanylate cyclase/phosphodiesterase', 126, NULL, NULL, 169102),
(169103, '2.70.170.10-FF-000024', NULL, 'Histamine-gated chloride channel subunit', 211, NULL, NULL, 169103),
(169104, '3.30.360.10-FF-000049', NULL, 'Aspartate-semialdehyde dehydrogenase', 184, NULL, NULL, 169104),
(169105, '3.30.565.10-FF-000238', NULL, 'Response regulator', 161, NULL, NULL, 169105),
(169106, '2.60.40.10-FF-004551', NULL, NULL, 66, NULL, NULL, 169106),
(169107, '3.40.50.2000-FF-000671', NULL, 'Uncharacterized protein', 207, NULL, NULL, 169107),
(169108, '2.130.10.10-FF-002966', NULL, 'Ribosome biogenesis protein NSA1', 225, NULL, NULL, 169108),
(169109, '1.10.472.80-FF-000145', NULL, 'AGAP002392-PA-like protein', 136, NULL, NULL, 169109),
(169110, '3.70.10.10-FF-000078', NULL, 'Cell cycle checkpoint protein RAD1', 261, NULL, NULL, 169110),
(169111, '3.30.40.10-FF-001094', NULL, 'Similar to PHD finger domain protein', 70, NULL, NULL, 169111),
(169112, '3.30.230.10-FF-000388', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 153, NULL, NULL, 169112),
(169113, '1.20.1560.10-FF-000085', NULL, 'Probable ATP-binding cassette (ABC) transporter', 331, NULL, NULL, 169113),
(169114, '1.10.150.20-FF-000296', NULL, 'Uncharacterized protein', 108, NULL, NULL, 169114),
(169115, '2.130.10.10-FF-005714', NULL, 'Uncharacterized protein', 142, NULL, NULL, 169115),
(169116, '3.20.20.80-FF-000197', NULL, 'Alpha-amylase', 115, NULL, NULL, 169116),
(169117, '3.30.460.10-FF-000214', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 221, NULL, NULL, 169117),
(169118, '3.30.300.10-FF-000040', NULL, 'Os07g0477250 protein', 29, NULL, NULL, 169118),
(169119, '3.30.160.60-FF-001908', NULL, 'Zinc finger protein 425', 27, NULL, NULL, 169119),
(169120, '3.40.50.150-FF-001870', NULL, NULL, 89, NULL, NULL, 169120),
(169121, '1.10.287.130-FF-000168', NULL, 'Sensor histidine kinase', 120, NULL, NULL, 169121),
(169122, '1.10.1900.10-FF-000024', NULL, 'Predicted protein', 78, NULL, NULL, 169122),
(169123, '3.40.50.1000-FF-000360', NULL, 'Trehalose 6-phosphate phosphatase', 87, NULL, NULL, 169123),
(169124, '3.10.100.10-FF-000389', NULL, NULL, 126, NULL, NULL, 169124),
(169125, '1.10.287.110-FF-000180', NULL, 'WGS project CABT00000000 data, contig 2.6', 90, NULL, NULL, 169125),
(169126, '3.30.70.330-FF-001762', NULL, NULL, 98, NULL, NULL, 169126),
(169127, '1.10.630.10-FF-000436', NULL, 'Ferulate-5-hydroxylase', 347, NULL, NULL, 169127),
(169128, '3.30.200.20-FF-002019', NULL, 'Receptor protein serine/threonine kinase', 93, NULL, NULL, 169128),
(169129, '1.10.8.60-FF-000279', NULL, 'Replication factor C small subunit', 64, NULL, NULL, 169129),
(169130, '1.20.120.720-FF-000040', NULL, 'myosin-IB isoform X2', 107, NULL, NULL, 169130),
(169131, '2.60.120.590-FF-000064', NULL, 'Predicted protein', 168, NULL, NULL, 169131),
(169132, '2.60.120.290-FF-000075', NULL, 'Blast:Cubilin', 113, NULL, NULL, 169132),
(169133, '3.40.50.1450-FF-000016', NULL, 'Ni,Fe-hydrogenase maturation factor', 132, NULL, NULL, 169133),
(169134, '3.40.50.720-FF-001406', NULL, 'NmrA-like family protein', 182, NULL, NULL, 169134),
(169135, '3.90.70.10-FF-000137', NULL, 'Putative ubiquitin carboxyl-terminal hydrolase', 328, NULL, NULL, 169135),
(169136, '3.40.640.10-FF-000041', NULL, 'Adenosylmethionine-8-amino-7-oxononanoate aminotransferase', 271, NULL, NULL, 169136),
(169137, '1.25.40.10-FF-000722', NULL, 'Pentatricopeptide repeat-containing protein At3g49740', 107, NULL, NULL, 169137),
(169138, '3.40.50.2300-FF-001261', NULL, NULL, 12, NULL, NULL, 169138),
(169139, '1.20.1420.30-FF-000030', NULL, 'Cation/calcium exchanger 4', 131, NULL, NULL, 169139),
(169140, '3.40.50.10810-FF-000047', NULL, 'DEAD/DEAH box helicase', 230, NULL, NULL, 169140),
(169141, '1.20.120.670-FF-000002', NULL, 'GD22403', 283, NULL, NULL, 169141),
(169142, '1.50.40.10-FF-000422', NULL, 'Uncharacterized protein', 190, NULL, NULL, 169142);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(169143, '1.10.510.10-FF-001911', NULL, 'Myosin light chain kinase', 199, NULL, NULL, 169143),
(169144, '3.40.50.300-FF-008076', NULL, 'Uncharacterized protein', 118, NULL, NULL, 169144),
(169145, '3.30.70.330-FF-000126', NULL, 'paraspeckle component 1 isoform X1', 97, NULL, NULL, 169145),
(169146, '3.30.450.40-FF-000150', NULL, 'Hybrid sensory kinase', 221, NULL, NULL, 169146),
(169147, '1.10.565.10-FF-000200', NULL, 'Retinoic X receptor alpha', 49, NULL, NULL, 169147),
(169148, '2.60.40.10-FF-001791', NULL, 'Ig gamma-2B chain C region', 118, NULL, NULL, 169148),
(169149, '3.30.1380.20-FF-000047', NULL, 'Uncharacterized protein', 126, NULL, NULL, 169149),
(169150, '2.60.40.690-FF-000006', NULL, 'Alpha-2-macroglobulin like 1', 131, NULL, NULL, 169150),
(169151, '3.40.50.300-FF-001729', NULL, 'Transcriptional regulator ATRX homolog', 323, NULL, NULL, 169151),
(169152, '2.30.30.140-FF-000060', NULL, 'Scm-like with four mbt domains 1, isoform CRA_b', 118, NULL, NULL, 169152),
(169153, '3.60.15.10-FF-000258', NULL, 'Cleavage and polyadenylation specific factor 3', 121, NULL, NULL, 169153),
(169154, '1.10.1040.30-FF-000003', NULL, 'ISWI chromatin-remodeling complex ATPase ISW2', 115, NULL, NULL, 169154),
(169155, '3.40.50.1760-FF-000008', NULL, 'Glutathione synthetase', 130, NULL, NULL, 169155),
(169156, '3.40.190.80-FF-000043', NULL, 'Inositol polyphosphate 1-phosphatase', 139, NULL, NULL, 169156),
(169157, '1.10.565.10-FF-000088', NULL, 'Nuclear Hormone Receptor family', 160, NULL, NULL, 169157),
(169158, '2.60.40.10-FF-003932', NULL, NULL, 106, NULL, NULL, 169158),
(169159, '1.10.630.10-FF-000329', NULL, 'Uncharacterized protein', 170, NULL, NULL, 169159),
(169160, '1.25.10.10-FF-001619', NULL, 'ARM repeat superfamily protein', 552, NULL, NULL, 169160),
(169161, '1.20.58.930-FF-000002', NULL, 'Biosynthetic arginine decarboxylase', 91, NULL, NULL, 169161),
(169162, '2.40.50.100-FF-000134', NULL, 'EXOSome (Multiexonuclease complex) component', 56, NULL, NULL, 169162),
(169163, '3.60.21.10-FF-000188', NULL, 'Metallophosphoesterase', 213, NULL, NULL, 169163),
(169164, '1.20.5.170-FF-000078', NULL, 'Methylmalonic aciduria type A homolog, mitochondrial', 66, NULL, NULL, 169164),
(169165, '3.40.50.620-FF-000527', NULL, 'Nicotinamide-nucleotide adenylyltransferase', 202, NULL, NULL, 169165),
(169166, '3.30.450.20-FF-000609', NULL, 'Sensor histidine kinase, Cache_1 and HAMP domain-containing', 128, NULL, NULL, 169166),
(169167, '4.10.1000.10-FF-000144', NULL, 'Uncharacterized protein', 88, NULL, NULL, 169167),
(169168, '3.30.70.330-FF-001649', NULL, NULL, 100, NULL, NULL, 169168),
(169169, '2.60.40.10-FF-001459', NULL, 'Titin a', 105, NULL, NULL, 169169),
(169170, '1.10.420.10-FF-000050', NULL, 'Uncharacterized protein', 30, NULL, NULL, 169170),
(169171, '3.40.50.300-FF-001836', NULL, 'DEAD box helicase, putative', 224, NULL, NULL, 169171),
(169172, '3.90.740.10-FF-000065', NULL, 'Uncharacterized protein', 123, NULL, NULL, 169172),
(169173, '3.40.50.2300-FF-000547', NULL, 'Guanylate cyclase', 111, NULL, NULL, 169173),
(169174, '3.30.2310.10-FF-000006', NULL, 'tRNA-Thr(GGU) m(6)t(6)A37 methyltransferase TsaA', 85, NULL, NULL, 169174),
(169175, '3.30.40.10-FF-000475', NULL, 'RING-H2 finger protein ATL3', 81, NULL, NULL, 169175),
(169176, '1.25.40.10-FF-004320', NULL, 'Pentatricopeptide repeat-containing protein At5g61370, mitochondrial', 174, NULL, NULL, 169176),
(169177, '3.60.10.10-FF-000382', NULL, 'Predicted protein', 77, NULL, NULL, 169177),
(169178, '3.10.580.10-FF-000019', NULL, 'Chloride voltage-gated channel 2', 113, NULL, NULL, 169178),
(169179, '3.20.20.70-FF-000099', NULL, 'tRNA-dihydrouridine synthase', 237, NULL, NULL, 169179),
(169180, '3.40.30.10-FF-000783', NULL, '1,2-dihydroxy-3-keto-5-methylthiopentene dioxygenase', 121, NULL, NULL, 169180),
(169181, '2.120.10.30-FF-000117', NULL, 'AGAP007095-PA-like protein', 126, NULL, NULL, 169181),
(169182, '2.60.40.10-FF-005748', NULL, NULL, 125, NULL, NULL, 169182),
(169183, '2.30.29.30-FF-000176', NULL, 'ras-specific guanine nucleotide-releasing factor 1 isoform X2', 116, NULL, NULL, 169183);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(169184, '2.60.200.20-FF-000280', NULL, 'Serine/threonine-protein kinase cds1', 159, NULL, NULL, 169184),
(169185, '2.60.40.150-FF-000081', NULL, 'otoferlin isoform X1', 152, NULL, NULL, 169185),
(169186, '3.30.160.60-FF-002527', NULL, 'Zinc finger protein 772', 29, NULL, NULL, 169186),
(169187, '1.25.40.10-FF-002066', NULL, 'GM12478', 232, NULL, NULL, 169187),
(169188, '3.30.70.1230-FF-000274', NULL, 'Predicted protein', 109, NULL, NULL, 169188),
(169189, '1.20.1740.10-FF-000183', NULL, 'Predicted protein', 359, NULL, NULL, 169189),
(169190, '3.40.47.10-FF-000198', NULL, NULL, 83, NULL, NULL, 169190),
(169191, '3.30.300.30-FF-000046', NULL, 'Long-chain-fatty-acid--ACP ligase MbtM', 107, NULL, NULL, 169191),
(169192, '3.40.50.300-FF-006732', NULL, 'Os07g0226000 protein', 70, NULL, NULL, 169192),
(169193, '2.60.40.10-FF-000280', NULL, 'HLA class II histocompatibility antigen, DR alpha chain', 111, NULL, NULL, 169193),
(169194, '1.10.10.10-FF-000372', NULL, 'ArsR family transcriptional regulator', 97, NULL, NULL, 169194),
(169195, '2.40.50.140-FF-001079', NULL, NULL, 85, NULL, NULL, 169195),
(169196, '3.40.630.30-FF-000439', NULL, 'Acetyltransferase', 84, NULL, NULL, 169196),
(169197, '1.20.1440.160-FF-000002', NULL, 'Tumor necrosis factor, alpha-induced protein 8-like protein 2 A', 192, NULL, NULL, 169197),
(169198, '3.40.50.300-FF-000313', NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase PRP16', 225, NULL, NULL, 169198),
(169199, '3.40.630.10-FF-000433', NULL, 'Uncharacterized protein', 331, NULL, NULL, 169199),
(169200, '3.90.550.10-FF-000472', NULL, 'Glycosyltransferase HpnI', 217, NULL, NULL, 169200),
(169201, '3.30.230.70-FF-000035', NULL, 'Exosome complex component MTR3', 251, NULL, NULL, 169201),
(169202, '2.130.10.10-FF-002062', NULL, 'WD repeat and SOF domain-containing protein 1', 143, NULL, NULL, 169202),
(169203, '3.30.470.10-FF-000041', NULL, 'Branched-chain amino acid aminotransferase', 104, NULL, NULL, 169203),
(169204, '3.10.20.90-FF-000408', NULL, 'Small ubiquitin protein, putative', 110, NULL, NULL, 169204),
(169205, '3.30.160.60-FF-005506', NULL, NULL, 31, NULL, NULL, 169205),
(169206, '2.30.30.30-FF-000134', NULL, 'Transcription elongation factor SPT5', 63, NULL, NULL, 169206),
(169207, '1.10.10.60-FF-000920', NULL, NULL, 54, NULL, NULL, 169207),
(169208, '3.20.20.80-FF-000208', NULL, 'Glycosyl hydrolase superfamily protein', 331, NULL, NULL, 169208),
(169209, '4.10.60.10-FF-000020', NULL, 'Zinc finger CCHC domain-containing protein 7', 80, NULL, NULL, 169209),
(169210, '2.130.10.10-FF-004203', NULL, 'Nucleoporin 133', 157, NULL, NULL, 169210),
(169211, '3.40.50.300-FF-004602', NULL, 'Dynein heavy chain, cytosolic, putative', 120, NULL, NULL, 169211),
(169212, '3.40.250.10-FF-000230', NULL, 'Uncharacterized protein', 170, NULL, NULL, 169212),
(169213, '2.40.50.1060-FF-000007', NULL, 'GD22536', 143, NULL, NULL, 169213),
(169214, '2.130.10.10-FF-000931', NULL, 'WD repeat-containing protein 66', 292, NULL, NULL, 169214),
(169215, '2.30.29.30-FF-001013', NULL, 'FERM domain-containing 3', 104, NULL, NULL, 169215),
(169216, '3.30.70.1820-FF-000006', NULL, 'Uncharacterized protein', 96, NULL, NULL, 169216),
(169217, '3.40.50.1460-FF-000132', NULL, 'Predicted protein', 75, NULL, NULL, 169217),
(169218, '1.25.40.10-FF-003471', NULL, 'Putative pentatricopeptide repeat-containing protein', 98, NULL, NULL, 169218),
(169219, '2.130.10.10-FF-001550', NULL, 'Kinesin-like protein', 219, NULL, NULL, 169219),
(169220, '3.30.420.40-FF-000322', NULL, 'probable tRNA N6-adenosine threonylcarbamoyltransferase', 59, NULL, NULL, 169220),
(169221, '3.40.1090.10-FF-000008', NULL, 'Phospholipase, patatin family', 113, NULL, NULL, 169221),
(169222, '1.10.560.10-FF-000116', NULL, 'Putative GroEL-like chaperonine protein', 247, NULL, NULL, 169222),
(169223, '2.30.29.30-FF-000283', NULL, 'Ras GTPase-activating protein 4 isoform 1', 150, NULL, NULL, 169223),
(169224, '1.10.10.10-FF-001676', NULL, 'Helix-turn-helix iron-sulfur cluster-binding transcriptional regulator IscR', 154, NULL, NULL, 169224);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(169225, '1.25.10.10-FF-003082', NULL, 'Predicted protein', 238, NULL, NULL, 169225),
(169226, '1.20.58.60-FF-000283', NULL, 'Dystrophin', 140, NULL, NULL, 169226),
(169227, '3.30.40.10-FF-001998', NULL, 'Uncharacterized protein', 53, NULL, NULL, 169227),
(169228, '2.10.25.10-FF-000673', NULL, 'Heart development protein with EGF like domains 1', 77, NULL, NULL, 169228),
(169229, '1.10.620.20-FF-000040', NULL, 'Uncharacterized protein', 78, NULL, NULL, 169229),
(169230, '2.40.10.10-FF-000508', NULL, NULL, 82, NULL, NULL, 169230),
(169231, '3.30.200.20-FF-002351', NULL, NULL, 48, NULL, NULL, 169231),
(169232, '3.40.20.10-FF-000046', NULL, 'Cofilin/actin-depolymerizing factor like 1', 122, NULL, NULL, 169232),
(169233, '3.40.50.300-FF-005327', NULL, 'Nucleoid maintenance ATPase YjeE', 150, NULL, NULL, 169233),
(169234, '3.10.110.10-FF-000092', NULL, 'Constitutive photomorphogenesis protein 10', 155, NULL, NULL, 169234),
(169235, '4.10.240.10-FF-000114', NULL, 'Transcription factor Upc2', 79, NULL, NULL, 169235),
(169236, '3.40.50.720-FF-000883', NULL, '4-phosphoerythronate dehydrogenase', 109, NULL, NULL, 169236),
(169237, '3.40.630.30-FF-000315', NULL, 'Acetyltransferase, GNAT family protein', 182, NULL, NULL, 169237),
(169238, '3.30.70.330-FF-001981', NULL, NULL, 110, NULL, NULL, 169238),
(169239, '1.20.1310.20-FF-000047', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 239, NULL, NULL, 169239),
(169240, '2.60.40.10-FF-002314', NULL, 'Immunoglobulin kappa variable 5-2', 104, NULL, NULL, 169240),
(169241, '1.20.1110.10-FF-000057', NULL, 'Uncharacterized protein', 251, NULL, NULL, 169241),
(169242, '2.130.10.10-FF-005945', NULL, 'Sensor histidine kinase/response regulator', 252, NULL, NULL, 169242),
(169243, '3.20.20.80-FF-000540', NULL, 'Putative catalytically inactive chitinase-like lectins', 263, NULL, NULL, 169243),
(169244, '2.60.40.1430-FF-000001', NULL, 'Thiol-activated cytolysin', 112, NULL, NULL, 169244),
(169245, '3.40.50.1000-FF-000253', NULL, 'TIGR01456 family HAD hydrolase', 145, NULL, NULL, 169245),
(169246, '3.30.160.20-FF-000054', NULL, 'Chromosome 12 open reading frame 65', 113, NULL, NULL, 169246),
(169247, '3.30.70.260-FF-000077', NULL, 'D-3-phosphoglycerate dehydrogenase', 82, NULL, NULL, 169247),
(169248, '3.40.50.150-FF-001538', NULL, NULL, 95, NULL, NULL, 169248),
(169249, '3.30.70.600-FF-000005', NULL, '28S ribosomal protein S10, mitochondrial', 103, NULL, NULL, 169249),
(169250, '1.10.510.10-FF-002530', NULL, 'Predicted protein', 322, NULL, NULL, 169250),
(169251, '3.40.50.720-FF-001395', NULL, 'Erythronate-4-phosphate dehydrogenase', 161, NULL, NULL, 169251),
(169252, '3.40.50.1010-FF-000019', NULL, 'U3 small nucleolar RNA-associated protein 24', 143, NULL, NULL, 169252),
(169253, '2.30.30.40-FF-000250', NULL, 'Dynamin associated protein isoform Dap160-2', 67, NULL, NULL, 169253),
(169254, '3.30.160.60-FF-004888', NULL, NULL, 28, NULL, NULL, 169254),
(169255, '1.20.272.10-FF-000023', NULL, 'Replication factor C subunit 2', 91, NULL, NULL, 169255),
(169256, '1.20.58.2220-FF-000017', NULL, 'Formin-like protein', 372, NULL, NULL, 169256),
(169257, '3.10.490.10-FF-000030', NULL, 'putative gamma-glutamylcyclotransferase CG2811', 152, NULL, NULL, 169257),
(169258, '2.60.120.10-FF-000343', NULL, 'HSPB1-associated protein 1 isoform X3', 264, NULL, NULL, 169258),
(169259, '1.10.10.60-FF-001207', NULL, NULL, 82, NULL, NULL, 169259),
(169260, '1.10.3210.10-FF-000067', NULL, 'HD domain protein', 159, NULL, NULL, 169260),
(169261, '2.60.60.20-FF-000047', NULL, NULL, 121, NULL, NULL, 169261),
(169262, '1.20.1050.10-FF-000220', NULL, 'Uncharacterized protein', 108, NULL, NULL, 169262),
(169263, '2.60.120.330-FF-000020', NULL, 'Lipid A hydroxylase LpxO', 181, NULL, NULL, 169263),
(169264, '1.10.510.10-FF-000512', NULL, 'AKT serine/threonine kinase 1', 46, NULL, NULL, 169264),
(169265, '3.40.190.290-FF-000008', NULL, 'LysR family transcriptional regulator', 205, NULL, NULL, 169265),
(169266, '4.10.400.10-FF-000099', NULL, 'Complement component C7', 35, NULL, NULL, 169266),
(169267, '3.40.50.10810-FF-000154', NULL, 'SNF2 histone linker PHD RING helicase', 133, NULL, NULL, 169267);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(169268, '3.90.550.50-FF-000130', NULL, 'Hexosyltransferase', 286, NULL, NULL, 169268),
(169269, '3.40.50.300-FF-002680', NULL, 'Peroxisomal ABC transporter 1', 236, NULL, NULL, 169269),
(169270, '1.20.1070.10-FF-000345', NULL, '40S ribosomal protein S27', 315, NULL, NULL, 169270),
(169271, '3.30.70.330-FF-000233', NULL, 'Zinc finger CCHC-type and RNA-binding motif-containing protein 1', 91, NULL, NULL, 169271),
(169272, '3.30.450.30-FF-000034', NULL, 'Profilin', 119, NULL, NULL, 169272),
(169273, '1.10.132.30-FF-000009', NULL, 'DNA-directed RNA polymerase subunit', 147, NULL, NULL, 169273),
(169274, '1.10.10.440-FF-000036', NULL, 'Pre-mRNA-processing factor 40', 80, NULL, NULL, 169274),
(169275, '1.10.260.100-FF-000022', NULL, 'Heat shock protein STI1, putative', 77, NULL, NULL, 169275),
(169276, '1.25.10.10-FF-002463', NULL, 'AP-5 complex subunit beta-1', 218, NULL, NULL, 169276),
(169277, '3.90.1520.10-FF-000014', NULL, 'Guanylate cyclase soluble subunit beta-1', 187, NULL, NULL, 169277),
(169278, '1.10.3500.10-FF-000044', NULL, 'Uncharacterized protein', 47, NULL, NULL, 169278),
(169279, '2.20.70.10-FF-000114', NULL, 'Transcription elongation regulator', 68, NULL, NULL, 169279),
(169280, '2.30.42.10-FF-000482', NULL, NULL, 95, NULL, NULL, 169280),
(169281, '2.60.40.1860-FF-000012', NULL, NULL, 50, NULL, NULL, 169281),
(169282, '3.20.10.10-FF-000058', NULL, 'Uncharacterized protein', 123, NULL, NULL, 169282),
(169283, '1.25.10.10-FF-000097', NULL, 'Serine/threonine-protein phosphatase 4 regulatory subunit 4', 629, NULL, NULL, 169283),
(169284, '3.60.21.10-FF-000300', NULL, 'UDP-2,3-diacylglucosamine pyrophosphatase LpxH', 114, NULL, NULL, 169284),
(169285, '2.60.120.260-FF-000549', NULL, 'Uncharacterized protein', 61, NULL, NULL, 169285),
(169286, '2.60.40.10-FF-001802', NULL, 'Myotactin form A', 107, NULL, NULL, 169286),
(169287, '1.25.10.10-FF-001856', NULL, 'Hypothetical nuclear condensin complex subunit 3 (Eurofung)', 188, NULL, NULL, 169287),
(169288, '1.10.10.10-FF-000260', NULL, 'Forkhead transcription factor (Sep1)', 101, NULL, NULL, 169288),
(169289, '1.25.40.10-FF-001447', NULL, 'general transcription factor 3C polypeptide 3', 188, NULL, NULL, 169289),
(169290, '3.40.50.2000-FF-000339', NULL, 'Glycogen synthase', 263, NULL, NULL, 169290),
(169291, '3.90.1300.10-FF-000020', NULL, 'Uncharacterized protein', 351, NULL, NULL, 169291),
(169292, '2.60.120.370-FF-000003', NULL, 'Uncharacterized protein, YhcH/YjgK/YiaL family', 153, NULL, NULL, 169292),
(169293, '2.130.10.10-FF-005821', NULL, 'Uncharacterized protein', 67, NULL, NULL, 169293),
(169294, '3.40.50.150-FF-000246', NULL, 'Methyltransferase protein 17', 166, NULL, NULL, 169294),
(169295, '1.10.510.10-FF-003946', NULL, NULL, 59, NULL, NULL, 169295),
(169296, '1.10.20.10-FF-000086', NULL, 'Histone H2A', 129, NULL, NULL, 169296),
(169297, '3.40.50.10130-FF-000034', NULL, 'Uncharacterized protein', 133, NULL, NULL, 169297),
(169298, '3.40.50.300-FF-007351', NULL, 'Uncharacterized protein', 85, NULL, NULL, 169298),
(169299, '1.20.1070.10-FF-000906', NULL, 'Uncharacterized protein', 254, NULL, NULL, 169299),
(169300, '3.40.30.10-FF-000564', NULL, 'Glutathione S-transferase mu 1', 51, NULL, NULL, 169300),
(169301, '3.30.70.1130-FF-000007', NULL, 'Eukaryotic translation initiation factor 2 alpha subunit', 113, NULL, NULL, 169301),
(169302, '1.10.246.10-FF-000015', NULL, 'Serum albumin 1 protein', 88, NULL, NULL, 169302),
(169303, '2.60.120.430-FF-000044', NULL, 'Uncharacterized protein', 80, NULL, NULL, 169303),
(169304, '1.25.40.10-FF-003595', NULL, 'Formate-dependent nitrite reductase complex bifunctional subunit NrfFG', 146, NULL, NULL, 169304),
(169305, '1.10.8.60-FF-000155', NULL, 'Lon protease homolog, mitochondrial', 92, NULL, NULL, 169305),
(169306, '3.30.930.10-FF-000290', NULL, 'Leucyl-tRNA synthetase', 372, NULL, NULL, 169306),
(169307, '1.10.540.10-FF-000103', NULL, 'Acyl-CoA dehydrogenase, short-chain specific', 118, NULL, NULL, 169307),
(169308, '1.10.418.60-FF-000003', NULL, 'Probable kinetochore protein nuf2', 166, NULL, NULL, 169308);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(169309, '3.30.160.60-FF-006125', NULL, NULL, 83, NULL, NULL, 169309),
(169310, '3.80.10.10-FF-002354', NULL, 'Leucine-rich repeat-containing 8 VRAC subunit C', 101, NULL, NULL, 169310),
(169311, '3.60.21.10-FF-000424', NULL, 'Uncharacterized protein C1020.05', 265, NULL, NULL, 169311),
(169312, '1.10.238.10-FF-000137', NULL, 'Calmodulin-like protein 11', 26, NULL, NULL, 169312),
(169313, '2.40.50.1020-FF-000006', NULL, 'Sensory transduction protein LytR', 110, NULL, NULL, 169313),
(169314, '3.30.9.10-FF-000184', NULL, 'Uncharacterized protein', 110, NULL, NULL, 169314),
(169315, '3.40.50.620-FF-000746', NULL, 'Electron transferring flavoprotein, beta polypeptide-like', 149, NULL, NULL, 169315),
(169316, '3.30.160.60-FF-003584', NULL, NULL, 25, NULL, NULL, 169316),
(169317, '3.30.200.20-FF-001637', NULL, 'Uncharacterized protein', 91, NULL, NULL, 169317),
(169318, '1.10.10.60-FF-000027', NULL, 'LIM/homeobox protein Lhx9', 65, NULL, NULL, 169318),
(169319, '3.30.70.340-FF-000017', NULL, NULL, 90, NULL, NULL, 169319),
(169320, '1.10.260.170-FF-000003', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', 156, NULL, NULL, 169320),
(169321, '3.30.40.10-FF-000694', NULL, 'Putative lysine-specific histone demethylase 1', 87, NULL, NULL, 169321),
(169322, '1.25.40.20-FF-001782', NULL, 'Uncharacterized protein', 181, NULL, NULL, 169322),
(169323, '1.25.40.420-FF-000048', NULL, 'Uncharacterized protein', 51, NULL, NULL, 169323),
(169324, '3.30.160.60-FF-004202', NULL, NULL, 20, NULL, NULL, 169324),
(169325, '3.30.40.10-FF-001312', NULL, 'RING finger protein 5', 73, NULL, NULL, 169325),
(169326, '3.30.160.60-FF-001454', NULL, 'C2H2 finger domain protein', 35, NULL, NULL, 169326),
(169327, '1.10.287.110-FF-000286', NULL, 'DnaJ-like protein subfamily A member 2', 99, NULL, NULL, 169327),
(169328, '3.40.50.300-FF-008312', NULL, 'DNA helicase', 255, NULL, NULL, 169328),
(169329, '2.20.25.80-FF-000019', NULL, NULL, 73, NULL, NULL, 169329),
(169330, '3.30.70.980-FF-000074', NULL, 'Uncharacterized protein', 17, NULL, NULL, 169330),
(169331, '2.130.10.10-FF-005260', NULL, 'Uncharacterized protein', 268, NULL, NULL, 169331),
(169332, '3.20.20.380-FF-000015', NULL, 'Uncharacterized protein', 99, NULL, NULL, 169332),
(169333, '3.90.550.50-FF-000017', NULL, 'Glycoprotein-N-acetylgalactosamine 3-beta-galactosyltransferase 1', 192, NULL, NULL, 169333),
(169334, '2.130.10.10-FF-003348', NULL, 'Predicted protein', 214, NULL, NULL, 169334),
(169335, '3.40.50.11840-FF-000007', NULL, 'Diphthamide biosynthesis protein 2, putative', 72, NULL, NULL, 169335),
(169336, '3.90.70.10-FF-000013', NULL, 'ubiquitin carboxyl-terminal hydrolase 15 isoform X1', 225, NULL, NULL, 169336),
(169337, '1.25.40.10-FF-005051', NULL, 'LP07472p', 115, NULL, NULL, 169337),
(169338, '3.40.50.880-FF-000009', NULL, 'Imidazole glycerol phosphate synthase subunit HisH', 197, NULL, NULL, 169338),
(169339, '3.40.630.30-FF-000658', NULL, 'Uncharacterized protein', 155, NULL, NULL, 169339),
(169340, '3.40.50.1000-FF-000472', NULL, NULL, 107, NULL, NULL, 169340),
(169341, '1.10.510.10-FF-002187', NULL, 'LRR receptor-like serine/threonine-protein kinase EFR', 135, NULL, NULL, 169341),
(169342, '3.40.50.300-FF-003747', NULL, 'Uncharacterized protein', 237, NULL, NULL, 169342),
(169343, '1.25.40.10-FF-003139', NULL, 'Uncharacterized protein', 61, NULL, NULL, 169343),
(169344, '3.90.640.10-FF-000136', NULL, 'Uncharacterized protein', 68, NULL, NULL, 169344),
(169345, '2.130.10.10-FF-005602', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit', 192, NULL, NULL, 169345),
(169346, '3.80.10.10-FF-001050', NULL, 'Probable disease resistance protein At5g66900', 274, NULL, NULL, 169346),
(169347, '2.60.40.10-FF-002191', NULL, 'Trehalose-phosphatase, putative', 114, NULL, NULL, 169347),
(169348, '2.70.130.10-FF-000134', NULL, NULL, 113, NULL, NULL, 169348),
(169349, '3.40.50.150-FF-000122', NULL, 'probable methyltransferase PMT2', 199, NULL, NULL, 169349),
(169350, '1.25.40.570-FF-000065', NULL, 'Uncharacterized protein', 127, NULL, NULL, 169350);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(169351, '3.30.200.20-FF-000114', NULL, 'serine/threonine-protein kinase OSR1 isoform X1', 92, NULL, NULL, 169351),
(169352, '1.50.10.10-FF-000033', NULL, 'alpha-1,2-Mannosidase', 552, NULL, NULL, 169352),
(169353, '3.90.950.10-FF-000002', NULL, 'Inosine/xanthosine triphosphatase', 176, NULL, NULL, 169353),
(169354, '2.60.40.10-FF-003039', NULL, 'Embigin', 110, NULL, NULL, 169354),
(169355, '3.30.70.100-FF-000170', NULL, NULL, 97, NULL, NULL, 169355),
(169356, '3.40.1160.10-FF-000003', NULL, 'Glutamate 5-kinase', 204, NULL, NULL, 169356),
(169357, '1.20.1250.10-FF-000095', NULL, NULL, 204, NULL, NULL, 169357),
(169358, '2.60.40.630-FF-000016', NULL, 'Signal transducer and activator of transcription', 133, NULL, NULL, 169358),
(169359, '3.30.565.10-FF-000132', NULL, 'GHKL domain-containing protein', 108, NULL, NULL, 169359),
(169360, '3.40.50.300-FF-004023', NULL, 'Os02g0780800 protein', 92, NULL, NULL, 169360),
(169361, '3.30.980.50-FF-000001', NULL, 'Microbial collagenase', 111, NULL, NULL, 169361),
(169362, '1.20.5.650-FF-000020', NULL, NULL, 41, NULL, NULL, 169362),
(169363, '3.80.10.10-FF-000774', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 142, NULL, NULL, 169363),
(169364, '1.10.10.10-FF-001097', NULL, 'Helix-turn-helix transcriptional regulator', 94, NULL, NULL, 169364),
(169365, '1.25.40.10-FF-004775', NULL, 'Uncharacterized protein', 195, NULL, NULL, 169365),
(169366, '1.10.1420.10-FF-000094', NULL, 'DNA mismatch repair protein MSH2, putative', 181, NULL, NULL, 169366),
(169367, '3.40.50.1820-FF-000616', NULL, 'Putative peptidase S9 family protein', 271, NULL, NULL, 169367),
(169368, '2.130.10.10-FF-000370', NULL, 'Kinesin family member 21A', 193, NULL, NULL, 169368),
(169369, '1.20.5.530-FF-000001', NULL, 'Serine/threonine-protein kinase pelle', 52, NULL, NULL, 169369),
(169370, '3.50.30.30-FF-000125', NULL, 'Transferrin receptor 2', 196, NULL, NULL, 169370),
(169371, '3.10.129.10-FF-000022', NULL, 'Phenylacetic acid degradation protein', 138, NULL, NULL, 169371),
(169372, '3.40.850.10-FF-000539', NULL, 'Uncharacterized protein', 324, NULL, NULL, 169372),
(169373, '3.40.50.80-FF-000198', NULL, 'FRE family ferric-chelate reductase, putative (AFU_orthologue AFUA_1G17270)', 74, NULL, NULL, 169373),
(169374, '1.25.40.10-FF-001684', NULL, 'Pentatricopeptide repeat-containing protein', 141, NULL, NULL, 169374),
(169375, '1.25.40.10-FF-004090', NULL, 'Signal recognition particle subunit SRP72', 152, NULL, NULL, 169375),
(169376, '2.60.40.10-FF-004332', NULL, NULL, 71, NULL, NULL, 169376),
(169377, '3.40.50.300-FF-004708', NULL, '26S protease regulatory subunit 6B', 134, NULL, NULL, 169377),
(169378, '3.40.1010.10-FF-000015', NULL, 'Probable uroporphyrin-III c-methyltransferase hemD', 124, NULL, NULL, 169378),
(169379, '1.20.1440.130-FF-000004', NULL, 'Thiol-disulfide oxidoreductase LTO1', 185, NULL, NULL, 169379),
(169380, '1.20.1070.10-FF-001183', NULL, 'Uncharacterized protein', 335, NULL, NULL, 169380),
(169381, '1.20.1250.20-FF-000553', NULL, 'Organic cation transporter protein', 415, NULL, NULL, 169381),
(169382, '2.40.50.100-FF-000010', NULL, 'Acetyltransferase component of pyruvate dehydrogenase complex', 105, NULL, NULL, 169382),
(169383, '1.10.287.70-FF-000644', NULL, 'Protein CBR-TWK-49', 179, NULL, NULL, 169383),
(169384, '3.30.200.20-FF-000676', NULL, 'Choline kinase', 85, NULL, NULL, 169384),
(169385, '2.130.10.10-FF-000038', NULL, 'Lissencephaly-1 homolog B', 310, NULL, NULL, 169385),
(169386, '2.130.10.10-FF-004309', NULL, 'Uncharacterized protein', 114, NULL, NULL, 169386),
(169387, '1.10.287.2250-FF-000013', NULL, 'Uncharacterized protein', 80, NULL, NULL, 169387),
(169388, '3.30.160.60-FF-000835', NULL, 'Zinc finger and BTB domain-containing protein 49', 28, NULL, NULL, 169388),
(169389, '3.40.50.1820-FF-000274', NULL, 'Aminopeptidase C', 279, NULL, NULL, 169389),
(169390, '2.60.40.420-FF-000178', NULL, 'Multicopper oxidase, manganese oxidase family', 257, NULL, NULL, 169390),
(169391, '1.10.390.10-FF-000052', NULL, 'Aminopeptidase', 256, NULL, NULL, 169391);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(169392, '3.40.50.1100-FF-000277', NULL, 'Uncharacterized protein', 81, NULL, NULL, 169392),
(169393, '3.50.50.60-FF-000012', NULL, 'Thioredoxin reductase 1, cytoplasmic', 124, NULL, NULL, 169393),
(169394, '1.10.510.10-FF-003148', NULL, NULL, 177, NULL, NULL, 169394),
(169395, '3.90.640.90-FF-000008', NULL, 'Uncharacterized protein', 93, NULL, NULL, 169395),
(169396, '3.10.20.870-FF-000007', NULL, 'WD_domain', 78, NULL, NULL, 169396),
(169397, '3.10.250.10-FF-000034', NULL, 'Hepsin', 71, NULL, NULL, 169397),
(169398, '1.20.58.670-FF-000014', NULL, NULL, 136, NULL, NULL, 169398),
(169399, '1.20.5.500-FF-000003', NULL, 'ATPase inhibitor B, mitochondrial', 36, NULL, NULL, 169399),
(169400, '2.60.40.200-FF-000005', NULL, 'Superoxide dismutase [Cu-Zn]', 153, NULL, NULL, 169400),
(169401, '1.20.58.1120-FF-000007', NULL, 'Dynein heavy chain 4', 143, NULL, NULL, 169401),
(169402, '2.40.50.140-FF-000679', NULL, NULL, 80, NULL, NULL, 169402),
(169403, '2.130.10.10-FF-004641', NULL, 'Uncharacterized protein', 193, NULL, NULL, 169403),
(169404, '1.10.10.60-FF-001196', NULL, NULL, 87, NULL, NULL, 169404),
(169405, '2.170.260.10-FF-000029', NULL, 'Dicer-1, putative', 77, NULL, NULL, 169405),
(169406, '1.20.58.60-FF-000844', NULL, 'Uncharacterized protein', 305, NULL, NULL, 169406),
(169407, '3.80.10.10-FF-000336', NULL, 'Si:dkey-222h21.2', 177, NULL, NULL, 169407),
(169408, '3.30.420.340-FF-000001', NULL, 'UvrABC system protein C', 170, NULL, NULL, 169408),
(169409, '3.90.1150.10-FF-000311', NULL, 'Tryptophan aminotransferase-related protein 2', 109, NULL, NULL, 169409),
(169410, '3.90.79.10-FF-000005', NULL, 'Cleavage and polyadenylation specificity factor subunit 5', 199, NULL, NULL, 169410),
(169411, '3.80.10.10-FF-002011', NULL, 'Uncharacterized protein', 195, NULL, NULL, 169411),
(169412, '3.30.160.60-FF-000493', NULL, 'Zinc finger protein 805', 28, NULL, NULL, 169412),
(169413, '1.20.1250.20-FF-001733', NULL, 'Uncharacterized protein', 202, NULL, NULL, 169413),
(169414, '2.60.40.10-FF-005169', NULL, NULL, 94, NULL, NULL, 169414),
(169415, '1.20.58.240-FF-000003', NULL, 'Si:dkey-183c6.8', 183, NULL, NULL, 169415),
(169416, '1.10.287.130-FF-000062', NULL, 'Hybrid sensor histidine kinase/response regulator', 76, NULL, NULL, 169416),
(169417, '1.10.10.10-FF-002058', NULL, 'Transcriptional regulator (PhoB-like)', 99, NULL, NULL, 169417),
(169418, '1.10.238.10-FF-001317', NULL, 'YALI0D26147p', 90, NULL, NULL, 169418),
(169419, '3.30.710.10-FF-000318', NULL, 'Uncharacterized protein', 95, NULL, NULL, 169419),
(169420, '2.60.120.200-FF-000666', NULL, 'Os04g0531400 protein', 75, NULL, NULL, 169420),
(169421, '1.10.150.240-FF-000101', NULL, 'HAD family hydrolase', 68, NULL, NULL, 169421),
(169422, '2.30.39.10-FF-000120', NULL, 'Uncharacterized protein', 90, NULL, NULL, 169422),
(169423, '3.50.50.60-FF-000916', NULL, 'Uncharacterized protein', 186, NULL, NULL, 169423),
(169424, '1.25.10.10-FF-001513', NULL, 'Uncharacterized protein', 172, NULL, NULL, 169424),
(169425, '3.30.190.20-FF-000005', NULL, 'Ribosomal L1 domain-containing protein 1', 61, NULL, NULL, 169425),
(169426, '3.10.110.10-FF-000215', NULL, 'Ubiquitin-fold modifier-conjugating enzyme 1', 164, NULL, NULL, 169426),
(169427, '3.30.540.10-FF-000035', NULL, 'Golgi-resident PAp (PAP) 3-Phosphatase homolog', 171, NULL, NULL, 169427),
(169428, '1.20.58.1100-FF-000001', NULL, 'Protein unc-13 homolog B', 169, NULL, NULL, 169428),
(169429, '1.20.1050.20-FF-000004', NULL, 'Signal transducer and transcription activator 6', 171, NULL, NULL, 169429),
(169430, '1.10.30.10-FF-000148', NULL, 'HMG box family protein', 80, NULL, NULL, 169430),
(169431, '3.20.20.190-FF-000060', NULL, 'Phosphoinositide phospholipase C', 75, NULL, NULL, 169431),
(169432, '3.40.50.980-FF-000040', NULL, 'AMP-binding enzyme, putative', 116, NULL, NULL, 169432),
(169433, '1.10.287.370-FF-000004', NULL, 'Probable prefoldin subunit 5', 144, NULL, NULL, 169433),
(169434, '3.40.190.10-FF-000404', NULL, 'Nitrate ABC transporter substrate-binding protein', 118, NULL, NULL, 169434),
(169435, '3.40.50.1820-FF-000835', NULL, 'GPI inositol-deacylase', 149, NULL, NULL, 169435);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(169436, '1.20.58.60-FF-000389', NULL, 'Microtubule-actin crosslinking factor 1', 240, NULL, NULL, 169436),
(169437, '1.10.510.10-FF-003709', NULL, NULL, 162, NULL, NULL, 169437),
(169438, '3.60.130.10-FF-000076', NULL, 'Uncharacterized protein', 319, NULL, NULL, 169438),
(169439, '2.70.98.20-FF-000033', NULL, 'Amine oxidase', 179, NULL, NULL, 169439),
(169440, '3.40.50.11660-FF-000055', NULL, NULL, 68, NULL, NULL, 169440),
(169441, '3.40.50.1820-FF-001235', NULL, 'Uncharacterized protein', 334, NULL, NULL, 169441),
(169442, '1.10.510.10-FF-003367', NULL, NULL, 187, NULL, NULL, 169442),
(169443, '1.10.490.20-FF-000001', NULL, 'Allophycocyanin alpha chain', 160, NULL, NULL, 169443),
(169444, '2.130.10.10-FF-003680', NULL, 'Uncharacterized protein', 156, NULL, NULL, 169444),
(169445, '1.20.1250.20-FF-001172', NULL, 'Uncharacterized protein', 153, NULL, NULL, 169445),
(169446, '3.40.50.20-FF-000096', NULL, 'Uncharacterized protein', 23, NULL, NULL, 169446),
(169447, '2.60.40.60-FF-000608', NULL, 'Uncharacterized protein', 75, NULL, NULL, 169447),
(169448, '1.25.10.10-FF-000552', NULL, 'USO1p protein', 670, NULL, NULL, 169448),
(169449, '3.40.140.10-FF-000002', NULL, 'Pre-mRNA-processing-splicing factor 8', 278, NULL, NULL, 169449),
(169450, '3.40.50.1820-FF-000959', NULL, 'Uncharacterized protein', 285, NULL, NULL, 169450),
(169451, '1.20.5.110-FF-000212', NULL, 'Syntaxin-21', 101, NULL, NULL, 169451),
(169452, '3.90.260.10-FF-000039', NULL, 'Cdc-73', 318, NULL, NULL, 169452),
(169453, '2.30.40.10-FF-000078', NULL, 'Non-ATP-dependent L-selective hydantoinase, putative', 52, NULL, NULL, 169453),
(169454, '3.50.50.60-FF-000231', NULL, 'Cholesterol oxidase ChoD', 149, NULL, NULL, 169454),
(169455, '2.40.20.10-FF-000009', NULL, 'Hepatocyte growth factor-like 1', 92, NULL, NULL, 169455),
(169456, '3.40.50.1820-FF-001111', NULL, 'Putative secreted tripeptidyl aminopeptidase', 154, NULL, NULL, 169456),
(169457, '3.10.20.90-FF-000066', NULL, 'Talin 1', 65, NULL, NULL, 169457),
(169458, '3.10.50.40-FF-000137', NULL, 'Peptidylprolyl isomerase', 91, NULL, NULL, 169458),
(169459, '2.60.34.10-FF-000113', NULL, 'Uncharacterized protein', 173, NULL, NULL, 169459),
(169460, '2.160.10.10-FF-000115', NULL, 'Uncharacterized protein', 69, NULL, NULL, 169460),
(169461, '2.70.50.80-FF-000002', NULL, 'transcriptional enhancer factor TEF-4 isoform X1', 233, NULL, NULL, 169461),
(169462, '3.40.50.720-FF-000102', NULL, 'GDP-mannose 4,6-dehydratase', 231, NULL, NULL, 169462),
(169463, '3.40.630.30-FF-000097', NULL, 'Histone acetyltransferase HPA2 and related acetyltransferases', 180, NULL, NULL, 169463),
(169464, '1.20.1250.20-FF-000772', NULL, 'Multidrug efflux transporter MdtP', 228, NULL, NULL, 169464),
(169465, '2.40.50.1040-FF-000001', NULL, 'Stn1p', 189, NULL, NULL, 169465),
(169466, '3.40.50.2300-FF-000204', NULL, 'glutamate receptor ionotropic, NMDA 1 isoform X2', 182, NULL, NULL, 169466),
(169467, '2.130.10.10-FF-004080', NULL, 'Uncharacterized protein', 202, NULL, NULL, 169467),
(169468, '2.30.30.190-FF-000046', NULL, NULL, 89, NULL, NULL, 169468),
(169469, '3.10.290.10-FF-000031', NULL, 'Tyrosine--tRNA ligase', 83, NULL, NULL, 169469),
(169470, '3.40.605.10-FF-000015', NULL, 'alpha-aminoadipic semialdehyde dehydrogenase', 262, NULL, NULL, 169470),
(169471, '3.90.25.10-FF-000049', NULL, 'UDP-galactose 4-epimerase', 125, NULL, NULL, 169471),
(169472, '2.30.42.10-FF-000588', NULL, NULL, 107, NULL, NULL, 169472),
(169473, '3.30.160.60-FF-001111', NULL, 'Zinc finger protein 92 homolog', 28, NULL, NULL, 169473),
(169474, '3.50.7.10-FF-000022', NULL, 'T-complex protein 1 alpha subunit putative', 159, NULL, NULL, 169474),
(169475, '3.90.70.10-FF-000356', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 183, NULL, NULL, 169475),
(169476, '2.130.10.10-FF-002168', NULL, 'Predicted protein', 290, NULL, NULL, 169476),
(169477, '4.10.400.10-FF-000335', NULL, 'Uncharacterized protein', 39, NULL, NULL, 169477),
(169478, '1.25.40.330-FF-000010', NULL, 'Adenylyl cyclase-associated protein', 176, NULL, NULL, 169478);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(169479, '2.40.100.10-FF-000004', NULL, 'Peptidyl-prolyl cis-trans isomerase', 164, NULL, NULL, 169479),
(169480, '3.30.1110.10-FF-000002', NULL, 'Putative sugar kinase slr0537', 64, NULL, NULL, 169480),
(169481, '1.25.40.10-FF-001341', NULL, 'Heat shock protein STI1, putative', 103, NULL, NULL, 169481),
(169482, '1.10.8.270-FF-000032', NULL, 'GTPase activating protein (Gyp7)', 115, NULL, NULL, 169482),
(169483, '3.40.50.12780-FF-000166', NULL, 'Chromosome 19, whole genome shotgun sequence', 420, NULL, NULL, 169483),
(169484, '3.30.160.60-FF-004545', NULL, NULL, 39, NULL, NULL, 169484),
(169485, '3.30.200.20-FF-000333', NULL, 'Serine/threonine-protein kinase AGC1-5', 86, NULL, NULL, 169485),
(169486, '3.30.1520.10-FF-000157', NULL, 'Sorting nexin-4', 150, NULL, NULL, 169486),
(169487, '1.20.1270.10-FF-000107', NULL, 'Uncharacterized protein', 99, NULL, NULL, 169487),
(169488, '1.20.1250.20-FF-000896', NULL, 'Amino acid/peptide transporter', 240, NULL, NULL, 169488),
(169489, '3.40.630.10-FF-000091', NULL, 'Hippurate hydrolase', 244, NULL, NULL, 169489),
(169490, '2.40.170.20-FF-000051', NULL, 'SusC/RagA family TonB-linked outer membrane protein', 722, NULL, NULL, 169490),
(169491, '1.20.1600.10-FF-000021', NULL, 'Membrane protein', 384, NULL, NULL, 169491),
(169492, '1.25.10.10-FF-000333', NULL, 'Nipped-B protein', 571, NULL, NULL, 169492),
(169493, '1.10.1200.270-FF-000025', NULL, 'Os06g0243400 protein', 15, NULL, NULL, 169493),
(169494, '3.40.50.300-FF-007457', NULL, 'Uncharacterized protein', 244, NULL, NULL, 169494),
(169495, '1.25.40.10-FF-001902', NULL, 'Exomer complex subunit', 477, NULL, NULL, 169495),
(169496, '3.30.40.10-FF-001655', NULL, 'Checkpoint with forkhead and ring finger domains, E3 ubiquitin protein ligase', 114, NULL, NULL, 169496),
(169497, '3.80.10.10-FF-004484', NULL, 'Os01g0957100 protein', 115, NULL, NULL, 169497),
(169498, '1.10.418.30-FF-000005', NULL, 'LD33040p', 122, NULL, NULL, 169498),
(169499, '1.25.40.20-FF-001563', NULL, 'Ankyrin repeat family protein', 82, NULL, NULL, 169499),
(169500, '3.40.50.150-FF-000701', NULL, 'Methyltransferase-like protein', 148, NULL, NULL, 169500),
(169501, '3.30.720.90-FF-000005', NULL, 'Uncharacterized protein', 94, NULL, NULL, 169501),
(169502, '2.60.40.60-FF-000047', NULL, 'protocadherin-15 isoform X1', 109, NULL, NULL, 169502),
(169503, '1.10.510.10-FF-000950', NULL, 'Inactive receptor-like serine/threonine-protein kinase At2g40270', 195, NULL, NULL, 169503),
(169504, '1.10.506.10-FF-000058', NULL, 'Ras GTPase-activating protein', 377, NULL, NULL, 169504),
(169505, '1.10.1200.120-FF-000008', NULL, 'Mechanosensitive ion channel protein MscL', 99, NULL, NULL, 169505),
(169506, '1.10.238.10-FF-000356', NULL, 'Myosin II light chain', 68, NULL, NULL, 169506),
(169507, '1.20.1730.10-FF-000025', NULL, 'High-affinity choline transporter 1', 480, NULL, NULL, 169507),
(169508, '1.10.472.10-FF-000400', NULL, 'Cyclin-K', 111, NULL, NULL, 169508),
(169509, '1.25.40.10-FF-002302', NULL, 'LD39177p', 142, NULL, NULL, 169509),
(169510, '1.10.132.60-FF-000007', NULL, 'DNA polymerase', 167, NULL, NULL, 169510),
(169511, '3.40.50.620-FF-000185', NULL, 'nicotinamide mononucleotide adenylyltransferase 3 isoform X2', 34, NULL, NULL, 169511),
(169512, '3.40.50.200-FF-000053', NULL, 'Subtilisin-like serine protease', 346, NULL, NULL, 169512),
(169513, '1.25.40.10-FF-001009', NULL, 'Chitin biosynthesis protein CHS6', 650, NULL, NULL, 169513),
(169514, '3.40.50.10420-FF-000020', NULL, '5-formyltetrahydrofolate cyclo-ligase', 191, NULL, NULL, 169514),
(169515, '2.60.120.780-FF-000019', NULL, 'Uncharacterized protein', 93, NULL, NULL, 169515),
(169516, '3.40.605.10-FF-000139', NULL, 'Aldehyde dehydrogenase 4 family member A1', 47, NULL, NULL, 169516),
(169517, '3.90.550.10-FF-000253', NULL, 'Capsule polysaccharide synthase Cps1, putative', 233, NULL, NULL, 169517),
(169518, '3.40.120.10-FF-000018', NULL, 'Glucose 1,6-bisphosphate synthase', 118, NULL, NULL, 169518),
(169519, '1.20.120.350-FF-000255', NULL, NULL, 169, NULL, NULL, 169519),
(169520, '1.10.510.10-FF-004328', NULL, NULL, 138, NULL, NULL, 169520); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(169521, '3.40.1190.20-FF-000053', NULL, 'Ribokinase', 289, NULL, NULL, 169521),
(169522, '3.40.50.300-FF-003186', NULL, 'Helicase SEN1', 151, NULL, NULL, 169522),
(169523, '3.30.572.10-FF-000030', NULL, 'Uncharacterized protein', 65, NULL, NULL, 169523),
(169524, '3.30.160.60-FF-000274', NULL, 'zinc finger protein 16', 28, NULL, NULL, 169524),
(169525, '3.90.79.10-FF-000224', NULL, 'Predicted protein', 162, NULL, NULL, 169525),
(169526, '1.20.120.350-FF-000131', NULL, 'Sodium channel protein', 121, NULL, NULL, 169526),
(169527, '2.30.30.40-FF-000356', NULL, 'Cell death abnormality protein 2', 74, NULL, NULL, 169527),
(169528, '3.30.450.60-FF-000032', NULL, 'AP complex subunit sigma', 143, NULL, NULL, 169528),
(169529, '3.10.20.90-FF-000627', NULL, 'Uncharacterized protein', 71, NULL, NULL, 169529),
(169530, '1.10.287.70-FF-000083', NULL, 'Potassium/sodium hyperpolarization-activated cyclic nucleotide-gated channel', 259, NULL, NULL, 169530),
(169531, '2.40.30.180-FF-000007', NULL, 'Putative ubiquitin-activating enzyme e1', 94, NULL, NULL, 169531),
(169532, '3.10.450.580-FF-000005', NULL, 'Mediator of RNA polymerase II transcription subunit 6', 128, NULL, NULL, 169532),
(169533, '4.10.280.10-FF-000111', NULL, 'HLH transcription factor (Hpa3)', 91, NULL, NULL, 169533),
(169534, '3.90.1750.10-FF-000059', NULL, 'Uncharacterized protein', 148, NULL, NULL, 169534),
(169535, '1.10.10.10-FF-001439', NULL, 'DtxR family transcriptional regulator', 71, NULL, NULL, 169535),
(169536, '2.40.30.130-FF-000021', NULL, 'Alanyl-tRNA synthetase, putative', 110, NULL, NULL, 169536),
(169537, '2.30.180.10-FF-000157', NULL, NULL, 134, NULL, NULL, 169537),
(169538, '2.60.40.10-FF-002078', NULL, 'Juxtamembrane domain-associated catenin', 97, NULL, NULL, 169538),
(169539, '2.70.130.10-FF-000010', NULL, 'Insulin-like growth factor 2 receptor', 135, NULL, NULL, 169539),
(169540, '2.40.70.10-FF-000164', NULL, 'Uncharacterized protein', 127, NULL, NULL, 169540),
(169541, '3.30.160.60-FF-000150', NULL, 'Mds1 and evi1 complex locus protein', 30, NULL, NULL, 169541),
(169542, '2.60.40.60-FF-000940', NULL, 'Protocadherin alpha 11', 85, NULL, NULL, 169542),
(169543, '1.10.510.10-FF-000057', NULL, 'Non-specific serine/threonine protein kinase', 125, NULL, NULL, 169543),
(169544, '3.90.1480.20-FF-000069', NULL, 'Uncharacterized protein', 101, NULL, NULL, 169544),
(169545, '3.40.570.10-FF-000046', NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase 1', 311, NULL, NULL, 169545),
(169546, '3.30.230.10-FF-000169', NULL, 'SSU ribosomal protein S9P/S16', 145, NULL, NULL, 169546),
(169547, '3.30.70.270-FF-000193', NULL, NULL, 37, NULL, NULL, 169547),
(169548, '1.20.1250.20-FF-001514', NULL, 'Uncharacterized protein', 283, NULL, NULL, 169548),
(169549, '2.60.40.10-FF-003371', NULL, 'Synaptogenesis protein syg-2', 93, NULL, NULL, 169549),
(169550, '2.10.25.10-FF-000235', NULL, 'Prostaglandin G/H synthase 2', 45, NULL, NULL, 169550),
(169551, '4.10.860.120-FF-000010', NULL, 'DNA-directed RNA polymerase subunit', 117, NULL, NULL, 169551),
(169552, '3.30.70.260-FF-000173', NULL, 'Uncharacterized protein', 73, NULL, NULL, 169552),
(169553, '3.30.559.30-FF-000073', NULL, 'Nonribosomal peptide synthase Pes1 (Eurofung)', 240, NULL, NULL, 169553),
(169554, '1.20.1730.10-FF-000076', NULL, 'Uncharacterized protein', 282, NULL, NULL, 169554),
(169555, '1.10.8.770-FF-000002', NULL, 'C-1-tetrahydrofolate synthase, mitochondrial', 64, NULL, NULL, 169555),
(169556, '3.30.70.1230-FF-000077', NULL, 'Adenylyl CYclase', 212, NULL, NULL, 169556),
(169557, '1.25.10.10-FF-000400', NULL, '20S cyclosome subunit (APC1/BimE), putative', 148, NULL, NULL, 169557),
(169558, '1.20.1560.10-FF-000955', NULL, 'Uncharacterized protein', 18, NULL, NULL, 169558),
(169559, '3.40.1110.10-FF-000135', NULL, 'Copper-transporting ATPase HMA5', 134, NULL, NULL, 169559),
(169560, '3.30.40.10-FF-001436', NULL, 'TNF receptor-associated factor 4', 64, NULL, NULL, 169560),
(169561, '2.40.30.20-FF-000030', NULL, 'Yellow fluorescent protein', 96, NULL, NULL, 169561),
(169562, '2.10.25.10-FF-000229', NULL, 'Delta-like protein', 35, NULL, NULL, 169562); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(169563, '2.40.50.140-FF-000230', NULL, '3''-5'' exoribonuclease YhaM', 77, NULL, NULL, 169563),
(169564, '1.20.900.10-FF-000096', NULL, 'Uncharacterized protein', 236, NULL, NULL, 169564),
(169565, '3.30.70.330-FF-001470', NULL, 'RNA-binding protein-like protein', 130, NULL, NULL, 169565),
(169566, '3.40.50.2300-FF-001446', NULL, NULL, 48, NULL, NULL, 169566),
(169567, '3.30.710.10-FF-000195', NULL, 'Hypothetical_protein', 163, NULL, NULL, 169567),
(169568, '3.40.30.10-FF-001210', NULL, 'Glutathione peroxidase', 45, NULL, NULL, 169568),
(169569, '3.65.10.10-FF-000023', NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', 198, NULL, NULL, 169569),
(169570, '2.120.10.80-FF-000222', NULL, 'Kelch domain-containing protein 9', 103, NULL, NULL, 169570),
(169571, '3.90.190.10-FF-000247', NULL, 'Tyrosine specific protein phosphatase, putative', 306, NULL, NULL, 169571),
(169572, '2.130.10.10-FF-001095', NULL, 'Ribosome biogenesis protein YTM1', 379, NULL, NULL, 169572),
(169573, '3.40.50.300-FF-008424', NULL, 'EG:33C11.2 protein', 113, NULL, NULL, 169573),
(169574, '3.30.500.10-FF-000010', NULL, 'Histocompatibility 2, T region locus 22', 165, NULL, NULL, 169574),
(169575, '3.10.20.90-FF-000324', NULL, 'Diacylglycerol kinase', 102, NULL, NULL, 169575),
(169576, '3.30.200.20-FF-001749', NULL, 'Putative serine/threonine protein kinase IREH1', 18, NULL, NULL, 169576),
(169577, '2.60.40.10-FF-005299', NULL, NULL, 81, NULL, NULL, 169577),
(169578, '4.10.160.10-FF-000001', NULL, 'Methanol dehydrogenase [cytochrome c] subunit 2', 72, NULL, NULL, 169578),
(169579, '1.25.40.10-FF-005219', NULL, 'Predicted protein', 195, NULL, NULL, 169579),
(169580, '3.40.190.10-FF-000798', NULL, 'Prephenate dehydratase', 83, NULL, NULL, 169580),
(169581, '3.30.160.60-FF-000105', NULL, 'B-cell CLL/lymphoma 6, member B', 29, NULL, NULL, 169581),
(169582, '1.10.20.120-FF-000015', NULL, 'Chromosome 1, whole genome shotgun sequence', 191, NULL, NULL, 169582),
(169583, '2.130.10.10-FF-002084', NULL, 'Nan1p', 274, NULL, NULL, 169583),
(169584, '3.65.10.20-FF-000026', NULL, 'Predicted protein', 214, NULL, NULL, 169584),
(169585, '1.25.10.10-FF-001974', NULL, 'Similarity to HELICASE MOT1', 176, NULL, NULL, 169585),
(169586, '1.10.10.250-FF-000024', NULL, 'Uncharacterized protein', 56, NULL, NULL, 169586),
(169587, '2.10.70.10-FF-000244', NULL, 'Complement factor B', 60, NULL, NULL, 169587),
(169588, '1.25.40.10-FF-003128', NULL, 'Uncharacterized protein', 112, NULL, NULL, 169588),
(169589, '1.10.238.200-FF-000023', NULL, 'DCN1-like protein', 71, NULL, NULL, 169589),
(169590, '1.20.1740.10-FF-000048', NULL, 'Fructoselysine transporter frlA', 439, NULL, NULL, 169590),
(169591, '2.70.130.10-FF-000061', NULL, NULL, 147, NULL, NULL, 169591),
(169592, '3.30.70.1400-FF-000004', NULL, 'Sarcosine dehydrogenase, mitochondrial', 126, NULL, NULL, 169592),
(169593, '4.10.1240.10-FF-000072', NULL, 'Uncharacterized protein', 70, NULL, NULL, 169593),
(169594, '1.25.40.10-FF-001476', NULL, 'Os12g0557800 protein', 121, NULL, NULL, 169594),
(169595, '1.10.10.10-FF-000720', NULL, 'Two-component system response regulator', 112, NULL, NULL, 169595),
(169596, '3.40.50.300-FF-006333', NULL, 'Uncharacterized protein', 16, NULL, NULL, 169596),
(169597, '1.25.40.10-FF-004117', NULL, 'Uncharacterized protein', 130, NULL, NULL, 169597),
(169598, '3.30.420.40-FF-000344', NULL, 'Conserved hypothetical proline rich protein', 135, NULL, NULL, 169598),
(169599, '3.30.70.270-FF-000176', NULL, NULL, 111, NULL, NULL, 169599),
(169600, '3.40.50.2000-FF-000957', NULL, 'Lipid-A-disaccharide synthase', 103, NULL, NULL, 169600),
(169601, '1.10.730.10-FF-000202', NULL, 'Arginine--tRNA ligase', 128, NULL, NULL, 169601),
(169602, '2.60.40.10-FF-005506', NULL, NULL, 86, NULL, NULL, 169602),
(169603, '3.40.50.1100-FF-000171', NULL, 'Threonine dehydratase', 100, NULL, NULL, 169603),
(169604, '3.30.160.60-FF-003657', NULL, 'transcription factor grauzone', 52, NULL, NULL, 169604),
(169605, '2.60.200.30-FF-000035', NULL, 'NAD kinase', 149, NULL, NULL, 169605),
(169606, '1.25.40.10-FF-003454', NULL, 'Pentatricopeptide repeat-containing protein', 122, NULL, NULL, 169606);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(169607, '3.40.50.200-FF-000143', NULL, 'Predicted protein', 82, NULL, NULL, 169607),
(169608, '3.40.33.10-FF-000048', NULL, 'AGAP007584-PA', 149, NULL, NULL, 169608),
(169609, '3.40.930.10-FF-000035', NULL, 'Anion exchange protein', 263, NULL, NULL, 169609),
(169610, '3.30.230.10-FF-000259', NULL, 'Uncharacterized protein', 128, NULL, NULL, 169610),
(169611, '3.40.630.30-FF-000681', NULL, 'Uncharacterized protein', 95, NULL, NULL, 169611),
(169612, '3.30.9.10-FF-000155', NULL, 'FAD-dependent oxidoreductase domain-containing 1', 96, NULL, NULL, 169612),
(169613, '3.10.580.10-FF-000059', NULL, 'mRNA, clone: RTFL01-01-J02', 191, NULL, NULL, 169613),
(169614, '1.20.140.40-FF-000080', NULL, NULL, 105, NULL, NULL, 169614),
(169615, '1.20.1560.10-FF-000276', NULL, 'Multidrug ABC transporter ATP-binding protein', 320, NULL, NULL, 169615),
(169616, '3.30.40.10-FF-000773', NULL, 'FYVE and coiled-coil domain-containing protein', 78, NULL, NULL, 169616),
(169617, '2.60.120.10-FF-000315', NULL, 'Protein kinase, putative', 125, NULL, NULL, 169617),
(169618, '1.10.3520.10-FF-000017', NULL, 'Predicted protein', 213, NULL, NULL, 169618),
(169619, '1.10.10.10-FF-000074', NULL, 'Arginine repressor', 74, NULL, NULL, 169619),
(169620, '3.90.930.12-FF-000003', NULL, '60S ribosomal protein L9', 104, NULL, NULL, 169620),
(169621, '3.30.160.60-FF-005748', NULL, NULL, 28, NULL, NULL, 169621),
(169622, '4.10.240.10-FF-000148', NULL, 'Uncharacterized protein', 74, NULL, NULL, 169622),
(169623, '1.20.1110.10-FF-000017', NULL, 'Sodium/potassium-transporting ATPase subunit alpha', 408, NULL, NULL, 169623),
(169624, '1.25.40.990-FF-000011', NULL, 'COP9 signalosome complex subunit 8-like Protein', 154, NULL, NULL, 169624),
(169625, '3.30.160.60-FF-002229', NULL, 'IKAROS family zinc finger 3', 28, NULL, NULL, 169625),
(169626, '1.10.510.10-FF-003710', NULL, NULL, 161, NULL, NULL, 169626),
(169627, '2.60.40.1180-FF-000061', NULL, 'Alpha-1,4-glucan:maltose-1-phosphate maltosyltransferase', 104, NULL, NULL, 169627),
(169628, '3.30.420.40-FF-000018', NULL, 'Actin-like protein (Centractin)', 157, NULL, NULL, 169628),
(169629, '1.20.1070.10-FF-000901', NULL, 'Predicted protein', 205, NULL, NULL, 169629),
(169630, '3.40.50.2000-FF-001093', NULL, 'Starch synthase, chloroplastic/amyloplastic', 68, NULL, NULL, 169630),
(169631, '3.40.50.1440-FF-000103', NULL, 'Tubulin beta chain', 262, NULL, NULL, 169631),
(169632, '3.40.50.620-FF-000179', NULL, '7-cyano-7-deazaguanine synthase', 221, NULL, NULL, 169632),
(169633, '3.40.50.300-FF-007435', NULL, 'Predicted protein', 256, NULL, NULL, 169633),
(169634, '3.90.550.50-FF-000135', NULL, 'Uncharacterized protein, isoform B', 229, NULL, NULL, 169634),
(169635, '1.25.40.120-FF-000037', NULL, 'Protein farnesyltransferase alpha subunit, putative', 238, NULL, NULL, 169635),
(169636, '3.40.50.1460-FF-000109', NULL, 'Uncharacterized protein', 112, NULL, NULL, 169636),
(169637, '3.40.1110.10-FF-000461', NULL, NULL, 265, NULL, NULL, 169637),
(169638, '3.40.630.150-FF-000028', NULL, 'Malonyl-CoA decarboxylase, mitochondrial, putative', 232, NULL, NULL, 169638),
(169639, '3.10.20.90-FF-000650', NULL, 'Autophagy-related protein', 133, NULL, NULL, 169639),
(169640, '2.60.40.10-FF-002752', NULL, 'CD3 glycoprotein', 79, NULL, NULL, 169640),
(169641, '2.40.50.100-FF-000212', NULL, 'sn-glycerol-3-phosphate import ATP-binding protein UgpC', 48, NULL, NULL, 169641),
(169642, '1.10.260.40-FF-000046', NULL, 'Cyanate hydratase', 83, NULL, NULL, 169642),
(169643, '1.10.287.370-FF-000049', NULL, 'Protein CBG01589', 123, NULL, NULL, 169643),
(169644, '3.40.50.10580-FF-000006', NULL, 'V-type proton ATPase subunit F', 59, NULL, NULL, 169644),
(169645, '1.10.510.10-FF-001765', NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 168', 84, NULL, NULL, 169645),
(169646, '1.20.5.170-FF-000067', NULL, 'BZIP transcription factor', 68, NULL, NULL, 169646),
(169647, '3.40.50.300-FF-003899', NULL, 'Site-determining protein', 241, NULL, NULL, 169647),
(169648, '3.50.30.30-FF-000092', NULL, 'Predicted protein', 127, NULL, NULL, 169648);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(169649, '3.40.630.10-FF-000023', NULL, 'M20/M25/M40 family metallo-hydrolase', 200, NULL, NULL, 169649),
(169650, '1.20.140.10-FF-000065', NULL, 'Acyl-coenzyme A oxidase', 141, NULL, NULL, 169650),
(169651, '2.10.25.10-FF-000555', NULL, 'Dumpy, isoform I', 46, NULL, NULL, 169651),
(169652, '3.40.50.410-FF-000234', NULL, 'Predicted protein', 191, NULL, NULL, 169652),
(169653, '2.30.30.140-FF-000094', NULL, 'Histone-lysine N-methyltransferase', 105, NULL, NULL, 169653),
(169654, '3.40.50.300-FF-006007', NULL, 'Uncharacterized protein', 337, NULL, NULL, 169654),
(169655, '3.30.70.330-FF-001144', NULL, 'U11/U12 small nuclear ribonucleoprotein 31 kDa protein', 137, NULL, NULL, 169655),
(169656, '3.10.20.30-FF-000093', NULL, NULL, 39, NULL, NULL, 169656),
(169657, '1.10.760.10-FF-000030', NULL, 'L-cysteine S-thiosulfotransferase subunit SoxA', 90, NULL, NULL, 169657),
(169658, '2.60.40.10-FF-001763', NULL, 'Sallimus, isoform Q', 99, NULL, NULL, 169658),
(169659, '3.40.50.10190-FF-000338', NULL, 'Uncharacterized protein', 75, NULL, NULL, 169659),
(169660, '3.30.70.250-FF-000018', NULL, NULL, 70, NULL, NULL, 169660),
(169661, '3.30.70.330-FF-000042', NULL, 'Polyadenylate-binding protein', 106, NULL, NULL, 169661),
(169662, '3.30.497.10-FF-000080', NULL, 'Serine protease inhibitor (serpin) 4', 84, NULL, NULL, 169662),
(169663, '1.10.630.10-FF-000431', NULL, 'Uncharacterized protein', 311, NULL, NULL, 169663),
(169664, '3.30.460.10-FF-000068', NULL, 'DNA-directed DNA/RNA polymerase mu', 138, NULL, NULL, 169664),
(169665, '3.30.830.10-FF-000203', NULL, 'Predicted protein', 235, NULL, NULL, 169665),
(169666, '1.20.5.110-FF-000156', NULL, 'Syntaxin binding protein 6 (amisyn), like', 58, NULL, NULL, 169666),
(169667, '3.30.70.2740-FF-000013', NULL, 'Putative oxidoreductase', 84, NULL, NULL, 169667),
(169668, '3.40.50.1000-FF-000320', NULL, 'Probable hydrolase', 129, NULL, NULL, 169668),
(169669, '1.10.472.80-FF-000179', NULL, NULL, 131, NULL, NULL, 169669),
(169670, '2.70.70.10-FF-000022', NULL, 'Peptidase, M23 family', 148, NULL, NULL, 169670),
(169671, '3.90.550.10-FF-000382', NULL, 'Alpha-1,6-mannosyltransferase, putative', 204, NULL, NULL, 169671),
(169672, '1.20.190.50-FF-000001', NULL, 'Nuclear pore complex protein', 269, NULL, NULL, 169672),
(169673, '1.25.40.10-FF-004882', NULL, 'Uncharacterized protein', 102, NULL, NULL, 169673),
(169674, '1.10.510.10-FF-003856', NULL, NULL, 101, NULL, NULL, 169674),
(169675, '3.30.70.240-FF-000015', NULL, 'Elongation factor G, mitochondrial', 97, NULL, NULL, 169675),
(169676, '3.40.50.12710-FF-000016', NULL, 'Protein arginine methyltransferase NDUFAF7', 258, NULL, NULL, 169676),
(169677, '3.30.70.330-FF-002779', NULL, NULL, 66, NULL, NULL, 169677),
(169678, '2.60.120.290-FF-000159', NULL, 'Cubilin homolog', 124, NULL, NULL, 169678),
(169679, '3.90.25.10-FF-000038', NULL, 'Uncharacterized protein', 98, NULL, NULL, 169679),
(169680, '3.10.20.230-FF-000029', NULL, 'probable serine/threonine-protein kinase kinX isoform X1', 88, NULL, NULL, 169680),
(169681, '1.10.10.2170-FF-000004', NULL, 'Uncharacterized protein', 62, NULL, NULL, 169681),
(169682, '3.40.630.20-FF-000026', NULL, 'Predicted protein', 136, NULL, NULL, 169682),
(169683, '1.10.287.70-FF-000509', NULL, 'Ionotropic glutamate receptor, putative', 74, NULL, NULL, 169683),
(169684, '1.10.287.70-FF-000774', NULL, 'Uncharacterized protein', 115, NULL, NULL, 169684),
(169685, '2.60.40.640-FF-000031', NULL, 'Uncharacterized protein, isoform A', 200, NULL, NULL, 169685),
(169686, '2.30.30.490-FF-000029', NULL, 'Origin recognition complex subunit 1', 130, NULL, NULL, 169686),
(169687, '3.10.310.20-FF-000020', NULL, NULL, 146, NULL, NULL, 169687),
(169688, '3.40.605.10-FF-000038', NULL, 'Aldehyde dehydrogenase 1 family member L1', 94, NULL, NULL, 169688),
(169689, '3.40.630.30-FF-000029', NULL, 'Bifunctional acetylglutamate kinase/N-acetyl-gamma-glutamyl-phosphate reductase', 155, NULL, NULL, 169689),
(169690, '2.130.10.10-FF-001741', NULL, 'Pre-mRNA-splicing factor PRP46, putative', 274, NULL, NULL, 169690),
(169691, '3.20.20.190-FF-000037', NULL, 'Phosphoinositide phospholipase C', 310, NULL, NULL, 169691);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(169692, '3.90.80.10-FF-000025', NULL, 'Uncharacterized protein', 86, NULL, NULL, 169692),
(169693, '1.20.1250.20-FF-000295', NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', 197, NULL, NULL, 169693),
(169694, '3.90.70.10-FF-000699', NULL, 'Ubiquitin carboxyl-terminal hydrolase 17', 219, NULL, NULL, 169694),
(169695, '3.20.20.140-FF-000455', NULL, 'Guanine deaminase', 314, NULL, NULL, 169695),
(169696, '3.40.710.10-FF-000024', NULL, 'Penicillin-binding protein 2', 353, NULL, NULL, 169696),
(169697, '3.40.50.10300-FF-000001', NULL, 'Coenzyme A biosynthesis bifunctional protein CoaBC', 222, NULL, NULL, 169697),
(169698, '2.40.290.10-FF-000017', NULL, 'ATP-dependent DNA helicase 2 subunit KU70', 35, NULL, NULL, 169698),
(169699, '3.80.10.10-FF-004254', NULL, 'Uncharacterized protein', 70, NULL, NULL, 169699),
(169700, '3.40.50.300-FF-002590', NULL, 'Sulfotransferase', 61, NULL, NULL, 169700),
(169701, '3.40.50.800-FF-000109', NULL, 'Threonine--tRNA ligase', 100, NULL, NULL, 169701),
(169702, '1.10.510.10-FF-000630', NULL, 'Tyrosine-protein kinase', 199, NULL, NULL, 169702),
(169703, '2.60.40.10-FF-003854', NULL, NULL, 86, NULL, NULL, 169703),
(169704, '3.50.50.60-FF-001506', NULL, 'Chromosome 1, whole genome shotgun sequence', 24, NULL, NULL, 169704),
(169705, '3.40.1810.10-FF-000082', NULL, NULL, 50, NULL, NULL, 169705),
(169706, '3.40.50.10310-FF-000004', NULL, '3-dehydro-scyllo-inosose hydrolase', 262, NULL, NULL, 169706),
(169707, '3.90.228.10-FF-000066', NULL, 'Poly [ADP-ribose] polymerase 1', 96, NULL, NULL, 169707),
(169708, '2.10.25.10-FF-000494', NULL, 'Weary, isoform B', 38, NULL, NULL, 169708),
(169709, '3.40.50.1820-FF-000706', NULL, 'Lypla1 protein', 122, NULL, NULL, 169709),
(169710, '3.40.50.10320-FF-000007', NULL, '2''-N-acetylparomamine deacetylase', 237, NULL, NULL, 169710),
(169711, '1.10.840.10-FF-000031', NULL, 'Phospholipase C, epsilon 1', 240, NULL, NULL, 169711),
(169712, '3.40.50.300-FF-003692', NULL, 'SNF2 family protein', 290, NULL, NULL, 169712),
(169713, '3.40.50.620-FF-000825', NULL, 'Leucine--tRNA ligase', 239, NULL, NULL, 169713),
(169714, '3.80.10.10-FF-003152', NULL, 'Protein CBG22557', 294, NULL, NULL, 169714),
(169715, '1.10.540.10-FF-000132', NULL, 'Uncharacterized protein', 104, NULL, NULL, 169715),
(169716, '2.30.39.10-FF-000069', NULL, 'Serine protease inhibitor (serpin) 19', 139, NULL, NULL, 169716),
(169717, '3.40.50.300-FF-000347', NULL, 'Heparan-sulfate 6-O-sulfotransferase', 299, NULL, NULL, 169717),
(169718, '1.50.40.10-FF-000456', NULL, 'Uncharacterized protein', 99, NULL, NULL, 169718),
(169719, '1.25.40.20-FF-000231', NULL, '2-5A-dependent ribonuclease', 303, NULL, NULL, 169719),
(169720, '2.40.10.10-FF-000317', NULL, 'serine protease gd isoform X1', 275, NULL, NULL, 169720),
(169721, '1.10.8.10-FF-000354', NULL, 'Uncharacterized protein', 42, NULL, NULL, 169721),
(169722, '1.10.10.10-FF-001855', NULL, 'Manganese ABC transporter permease protein', 161, NULL, NULL, 169722),
(169723, '3.10.620.10-FF-000001', NULL, 'Blast:Protein N-terminal glutamine amidohydrolase', 202, NULL, NULL, 169723),
(169724, '2.30.30.190-FF-000029', NULL, 'Cytoskeleton associated protein', 75, NULL, NULL, 169724),
(169725, '3.30.800.10-FF-000022', NULL, 'Zinc finger protein', 172, NULL, NULL, 169725),
(169726, '3.40.50.150-FF-000313', NULL, 'methyltransferase-like protein 22', 195, NULL, NULL, 169726),
(169727, '3.60.10.10-FF-000348', NULL, 'Uncharacterized protein', 173, NULL, NULL, 169727),
(169728, '2.70.150.10-FF-000270', NULL, 'Uncharacterized protein', 163, NULL, NULL, 169728),
(169729, '1.20.1270.60-FF-000257', NULL, 'BAR domaincontaining protein', 190, NULL, NULL, 169729),
(169730, '1.10.555.10-FF-000126', NULL, 'Uncharacterized protein', 184, NULL, NULL, 169730),
(169731, '3.30.413.10-FF-000038', NULL, 'Probable oxidoreductase', 161, NULL, NULL, 169731),
(169732, '1.10.167.10-FF-000005', NULL, 'Putative A-kinase anchor protein 10 mitochondrial', 138, NULL, NULL, 169732),
(169733, '3.40.430.10-FF-000042', NULL, 'Riboflavin biosynthesis protein RibD', 223, NULL, NULL, 169733);
INSERT INTO "PUBLIC"."MODEL" VALUES
(169734, '2.130.10.10-FF-001269', NULL, 'telomerase Cajal body protein 1', 69, NULL, NULL, 169734),
(169735, '3.40.50.300-FF-000201', NULL, 'Glycine betaine/L-proline ABC transporter ATP-binding protein', 254, NULL, NULL, 169735),
(169736, '3.10.620.30-FF-000007', NULL, 'Transglutaminase domain-containing protein', 180, NULL, NULL, 169736),
(169737, '1.20.120.350-FF-000053', NULL, 'Sodium channel protein', 125, NULL, NULL, 169737),
(169738, '1.10.274.30-FF-000013', NULL, 'MSL3-like 2', 144, NULL, NULL, 169738),
(169739, '1.20.5.190-FF-000106', NULL, NULL, 47, NULL, NULL, 169739),
(169740, '1.20.1600.10-FF-000038', NULL, 'Outer membrane channel protein', 416, NULL, NULL, 169740),
(169741, '3.90.1440.10-FF-000013', NULL, 'Uncharacterized protein', 146, NULL, NULL, 169741),
(169742, '1.10.287.950-FF-000009', NULL, 'Signal transduction four helix bundle sensory module', 358, NULL, NULL, 169742),
(169743, '3.30.200.20-FF-001575', NULL, 'Predicted protein', 74, NULL, NULL, 169743),
(169744, '1.10.238.10-FF-000058', NULL, 'Calmodulin', 74, NULL, NULL, 169744),
(169745, '3.30.390.10-FF-000006', NULL, 'Mitochondrial enolase superfamily member 1', 131, NULL, NULL, 169745),
(169746, '2.80.10.50-FF-000070', NULL, 'Botulinum neurotoxin type A', 195, NULL, NULL, 169746),
(169747, '1.10.630.10-FF-000577', NULL, 'Uncharacterized protein', 307, NULL, NULL, 169747),
(169748, '2.130.10.10-FF-001948', NULL, 'WD-40 repeat family protein', 326, NULL, NULL, 169748),
(169749, '1.20.120.1750-FF-000007', NULL, 'RBR-type E3 ubiquitin transferase', 238, NULL, NULL, 169749),
(169750, '3.80.10.10-FF-001527', NULL, 'Leucine-rich repeat-like protein', 202, NULL, NULL, 169750),
(169751, '1.20.120.1910-FF-000050', NULL, 'Cysteinyl-tRNA synthetase family protein', 155, NULL, NULL, 169751),
(169752, '1.10.10.10-FF-001176', NULL, 'Uncharacterized protein', 100, NULL, NULL, 169752),
(169753, '2.60.40.1730-FF-000119', NULL, NULL, 70, NULL, NULL, 169753),
(169754, '2.30.30.40-FF-000064', NULL, 'Plectin a', 69, NULL, NULL, 169754),
(169755, '1.25.40.10-FF-003780', NULL, 'Uncharacterized protein', 154, NULL, NULL, 169755),
(169756, '1.10.287.940-FF-000006', NULL, 'p2X purinoceptor 1', 16, NULL, NULL, 169756),
(169757, '3.30.260.10-FF-000087', NULL, NULL, 104, NULL, NULL, 169757),
(169758, '2.40.50.140-FF-000876', NULL, NULL, 85, NULL, NULL, 169758),
(169759, '3.90.550.10-FF-000056', NULL, 'Hexosyltransferase', 268, NULL, NULL, 169759),
(169760, '2.20.100.10-FF-000166', NULL, 'Zinc metalloproteinase', 60, NULL, NULL, 169760),
(169761, '2.60.40.10-FF-003915', NULL, NULL, 109, NULL, NULL, 169761),
(169762, '3.80.10.10-FF-002629', NULL, 'Uncharacterized protein', 165, NULL, NULL, 169762),
(169763, '1.10.565.10-FF-000071', NULL, 'Steroid receptor seven-up, isoform A', 232, NULL, NULL, 169763),
(169764, '1.25.40.10-FF-003393', NULL, 'Pentatricopeptide repeat-containing protein At2g22070', 139, NULL, NULL, 169764),
(169765, '2.40.50.100-FF-000151', NULL, 'Component of multidrug efflux system', 60, NULL, NULL, 169765),
(169766, '1.10.472.80-FF-000033', NULL, 'TBC1 domain family member 9B isoform X1', 176, NULL, NULL, 169766),
(169767, '2.130.10.10-FF-000167', NULL, 'Actin-interacting protein 1', 269, NULL, NULL, 169767),
(169768, '2.120.10.30-FF-000140', NULL, 'Tol-Pal system protein TolB', 260, NULL, NULL, 169768),
(169769, '3.40.50.720-FF-001226', NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase, putative', 112, NULL, NULL, 169769),
(169770, '1.10.3330.10-FF-000008', NULL, '2-oxo-4-hydroxy-4-carboxy--5-ureidoimidazoline (OHCU) decarboxylase', 169, NULL, NULL, 169770),
(169771, '3.40.33.10-FF-000109', NULL, 'Antigen 5/SCP domain-containing protein, putative', 91, NULL, NULL, 169771),
(169772, '1.10.510.10-FF-003917', NULL, NULL, 75, NULL, NULL, 169772),
(169773, '3.30.160.60-FF-002022', NULL, 'Transcriptional regulator MET31', 59, NULL, NULL, 169773),
(169774, '1.10.510.10-FF-001439', NULL, 'Predicted protein', 214, NULL, NULL, 169774),
(169775, '1.25.40.10-FF-002291', NULL, 'Putative pentatricopeptide repeat-containing protein At3g15130', 246, NULL, NULL, 169775);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(169776, '1.20.1250.20-FF-000974', NULL, 'Sodium-dependent lysophosphatidylcholine symporter 1-A', 412, NULL, NULL, 169776),
(169777, '3.60.20.30-FF-000006', NULL, 'Threonine aspartase', 154, NULL, NULL, 169777),
(169778, '3.60.21.10-FF-000019', NULL, 'Double-strand break repair protein', 302, NULL, NULL, 169778),
(169779, '1.50.40.10-FF-000602', NULL, 'Uncharacterized protein', 102, NULL, NULL, 169779),
(169780, '2.10.25.10-FF-000881', NULL, 'Uninflatable, isoform B', 29, NULL, NULL, 169780),
(169781, '3.40.50.300-FF-005844', NULL, 'Os04g0413000 protein', 144, NULL, NULL, 169781),
(169782, '3.90.700.10-FF-000001', NULL, 'Mitochondrial succinate dehydrogenase flavoprotein subunit', 104, NULL, NULL, 169782),
(169783, '3.40.50.1010-FF-000177', NULL, NULL, 166, NULL, NULL, 169783),
(169784, '1.50.40.10-FF-000310', NULL, 'Uncharacterized protein', 319, NULL, NULL, 169784),
(169785, '3.40.50.12550-FF-000007', NULL, 'Ubiquitin like modifier activating enzyme 6', 130, NULL, NULL, 169785),
(169786, '2.170.270.10-FF-000204', NULL, 'Uncharacterized protein', 170, NULL, NULL, 169786),
(169787, '3.40.910.10-FF-000005', NULL, 'deoxyhypusine synthase isoform X2', 233, NULL, NULL, 169787),
(169788, '3.40.50.720-FF-001518', NULL, 'Uncharacterized protein', 256, NULL, NULL, 169788),
(169789, '4.10.400.10-FF-000363', NULL, 'Uncharacterized protein', 43, NULL, NULL, 169789),
(169790, '2.60.40.10-FF-005771', NULL, NULL, 82, NULL, NULL, 169790),
(169791, '4.10.410.10-FF-000009', NULL, 'WAP, Kazal, immunoglobulin, Kunitz and NTR domain-containing protein 2', 58, NULL, NULL, 169791),
(169792, '2.40.50.40-FF-000099', NULL, 'Chromodomain-helicase-DNA-binding protein 3', 59, NULL, NULL, 169792),
(169793, '3.40.50.300-FF-008250', NULL, 'Uncharacterized protein', 52, NULL, NULL, 169793),
(169794, '3.20.20.70-FF-000469', NULL, 'Cinnamate reductase', 404, NULL, NULL, 169794),
(169795, '3.40.50.10420-FF-000037', NULL, '5-formyltetrahydrofolate cyclo-ligase', 186, NULL, NULL, 169795),
(169796, '3.30.1490.120-FF-000026', NULL, 'Uncharacterized protein', 75, NULL, NULL, 169796),
(169797, '3.30.830.10-FF-000142', NULL, 'Cytochrome b-c1 complex subunit 2, mitochondrial', 140, NULL, NULL, 169797),
(169798, '3.80.10.10-FF-002337', NULL, 'Putative leucine-rich repeat receptor-like serine/threonine-protein kinase', 94, NULL, NULL, 169798),
(169799, '1.20.1250.20-FF-001312', NULL, 'monocarboxylate transporter 2-like', 275, NULL, NULL, 169799),
(169800, '3.40.50.300-FF-000173', NULL, 'GTPase HflX', 171, NULL, NULL, 169800),
(169801, '1.10.1070.11-FF-000011', NULL, 'Serine-protein kinase ATM', 200, NULL, NULL, 169801),
(169802, '1.10.150.50-FF-000193', NULL, 'Uncharacterized protein', 59, NULL, NULL, 169802),
(169803, '3.40.250.10-FF-000005', NULL, 'Rhodanese-like domain-containing protein', 120, NULL, NULL, 169803),
(169804, '3.30.420.10-FF-000268', NULL, 'Putative ribonuclease', 168, NULL, NULL, 169804),
(169805, '2.60.40.10-FF-001437', NULL, 'Echinoid, isoform C', 95, NULL, NULL, 169805),
(169806, '3.40.50.200-FF-000082', NULL, 'Serine protease, subtilisin family', 296, NULL, NULL, 169806),
(169807, '2.60.40.10-FF-000009', NULL, 'receptor-type tyrosine-protein phosphatase U isoform X1', 95, NULL, NULL, 169807),
(169808, '1.10.287.70-FF-000189', NULL, 'Potassium channel, two pore domain subfamily K, member 3', 182, NULL, NULL, 169808),
(169809, '3.40.720.10-FF-000261', NULL, 'Uncharacterized protein', 26, NULL, NULL, 169809),
(169810, '3.40.50.10190-FF-000131', NULL, 'Deoxycytidyl transferase, putative', 90, NULL, NULL, 169810),
(169811, '3.40.50.150-FF-000813', NULL, NULL, 97, NULL, NULL, 169811),
(169812, '4.10.400.10-FF-000037', NULL, 'Sortilin related receptor 1', 41, NULL, NULL, 169812),
(169813, '1.10.10.60-FF-000156', NULL, 'AraC family transcriptional regulator', 52, NULL, NULL, 169813),
(169814, '1.25.40.10-FF-003628', NULL, 'Pentatricopeptide repeat-containing protein At5g64320, mitochondrial', 69, NULL, NULL, 169814),
(169815, '1.10.287.470-FF-000079', NULL, 'Sll1053 protein', 50, NULL, NULL, 169815),
(169816, '1.25.10.10-FF-001709', NULL, 'Proteasome 26S subunit, non-ATPase 5', 239, NULL, NULL, 169816);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(169817, '1.20.272.40-FF-000009', NULL, 'RNA helicase', 18, NULL, NULL, 169817),
(169818, '1.10.12.10-FF-000056', NULL, 'Uncharacterized protein', 33, NULL, NULL, 169818),
(169819, '3.30.60.30-FF-000050', NULL, 'Follistatin like 5', 43, NULL, NULL, 169819),
(169820, '2.130.10.10-FF-003539', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', 321, NULL, NULL, 169820),
(169821, '3.40.50.790-FF-000005', NULL, '50S ribosomal protein L1', 90, NULL, NULL, 169821),
(169822, '3.40.50.10190-FF-000159', NULL, 'Telomeric repeat-binding factor 2-interacting protein 1', 78, NULL, NULL, 169822),
(169823, '3.40.50.1400-FF-000024', NULL, 'Ferrochelatase-like protein', 15, NULL, NULL, 169823),
(169824, '1.20.810.10-FF-000004', NULL, 'Cytochrome b', 404, NULL, NULL, 169824),
(169825, '2.130.10.10-FF-004321', NULL, 'Uncharacterized protein', 107, NULL, NULL, 169825),
(169826, '1.20.1250.20-FF-000795', NULL, 'Protein CBG05932', 205, NULL, NULL, 169826),
(169827, '3.40.50.300-FF-005198', NULL, 'Dephospho-CoA kinase', 211, NULL, NULL, 169827),
(169828, '3.40.190.290-FF-000020', NULL, 'LysR family transcriptional regulator', 195, NULL, NULL, 169828),
(169829, '3.20.20.100-FF-000084', NULL, 'Glycerol dehydrogenase (GCY1), putative', 184, NULL, NULL, 169829),
(169830, '2.10.90.10-FF-000127', NULL, 'Predicted protein', 105, NULL, NULL, 169830),
(169831, '1.10.630.10-FF-000077', NULL, 'Cytochrome P450 71A1-like', 492, NULL, NULL, 169831),
(169832, '1.25.10.10-FF-003273', NULL, 'Serine/threonine-protein kinase tor', 201, NULL, NULL, 169832),
(169833, '1.20.120.350-FF-000232', NULL, NULL, 115, NULL, NULL, 169833),
(169834, '3.60.20.40-FF-000009', NULL, 'Predicted protein', 195, NULL, NULL, 169834),
(169835, '2.10.60.10-FF-000007', NULL, 'Receptor protein serine/threonine kinase', 73, NULL, NULL, 169835),
(169836, '1.10.1000.11-FF-000030', NULL, 'Predicted protein', 115, NULL, NULL, 169836),
(169837, '3.30.70.330-FF-003061', NULL, NULL, 105, NULL, NULL, 169837),
(169838, '1.10.1670.40-FF-000014', NULL, 'DNA glycosylase', 25, NULL, NULL, 169838),
(169839, '2.30.29.30-FF-001390', NULL, 'Predicted protein', 119, NULL, NULL, 169839),
(169840, '4.10.240.10-FF-000209', NULL, 'Uncharacterized transcriptional regulatory protein C3H8.08c', 67, NULL, NULL, 169840),
(169841, '1.50.10.10-FF-000128', NULL, 'alpha-1,2-Mannosidase', 118, NULL, NULL, 169841),
(169842, '3.40.50.300-FF-001275', NULL, 'Dynein heavy chain, putative', 184, NULL, NULL, 169842),
(169843, '3.40.50.10810-FF-000064', NULL, 'SWI/SNF family DNA-dependent ATPase Ris1, putative', 286, NULL, NULL, 169843),
(169844, '1.10.510.10-FF-000304', NULL, 'Receptor protein serine/threonine kinase', 214, NULL, NULL, 169844),
(169845, '3.30.160.360-FF-000003', NULL, 'Histone-lysine N-methyltransferase', 117, NULL, NULL, 169845),
(169846, '1.25.40.10-FF-001829', NULL, 'Pentatricopeptide repeat-containing protein At5g39980, chloroplastic', 140, NULL, NULL, 169846),
(169847, '3.40.50.800-FF-000082', NULL, 'Histidyl-tRNA synthetase, putative', 102, NULL, NULL, 169847),
(169848, '2.20.25.10-FF-000061', NULL, 'DNA-directed RNA polymerase II subunit, putative', 68, NULL, NULL, 169848),
(169849, '2.40.30.230-FF-000011', NULL, 'Uncharacterized protein', 89, NULL, NULL, 169849),
(169850, '3.40.1280.30-FF-000012', NULL, 'RNA (Guanine-9-) methyltransferase domain containing protein', 192, NULL, NULL, 169850),
(169851, '3.30.160.60-FF-006237', NULL, NULL, 56, NULL, NULL, 169851),
(169852, '3.30.565.10-FF-000154', NULL, 'PAS domain-containing sensor histidine kinase', 160, NULL, NULL, 169852),
(169853, '1.20.1250.20-FF-001284', NULL, 'Major facilitator superfamily MFS_1', 219, NULL, NULL, 169853),
(169854, '3.40.50.300-FF-003719', NULL, 'ATP-binding cassette transporter, subfamily C, member 12, group MRP protein PpABCC12', 261, NULL, NULL, 169854),
(169855, '3.40.50.1460-FF-000082', NULL, 'Uncharacterized protein', 242, NULL, NULL, 169855),
(169856, '1.20.1070.10-FF-001244', NULL, 'Uncharacterized protein', 130, NULL, NULL, 169856),
(169857, '1.10.510.10-FF-004053', NULL, NULL, 257, NULL, NULL, 169857);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(169858, '1.20.1250.20-FF-000648', NULL, 'MFS superfamily vanillate transporter', 414, NULL, NULL, 169858),
(169859, '1.20.1560.10-FF-000629', NULL, 'Predicted protein', 255, NULL, NULL, 169859),
(169860, '1.20.58.390-FF-000082', NULL, 'Glutamate-gated ChLoride channel', 134, NULL, NULL, 169860),
(169861, '1.10.510.10-FF-004227', NULL, NULL, 205, NULL, NULL, 169861),
(169862, '2.10.25.10-FF-000729', NULL, 'Blast:Protein slit', 37, NULL, NULL, 169862),
(169863, '3.30.450.40-FF-000172', NULL, 'Sigma factor SibG regulation protein RsbU', 155, NULL, NULL, 169863),
(169864, '2.130.10.10-FF-002404', NULL, 'Elongator acetyltransferase complex subunit 2', 233, NULL, NULL, 169864),
(169865, '2.130.10.10-FF-005456', NULL, 'Uncharacterized protein', 184, NULL, NULL, 169865),
(169866, '3.10.350.10-FF-000076', NULL, 'LysM domain receptor-like kinase 3', 57, NULL, NULL, 169866),
(169867, '2.60.40.4370-FF-000001', NULL, 'general transcription factor 3C polypeptide 6', 108, NULL, NULL, 169867),
(169868, '3.90.1170.10-FF-000003', NULL, '54S ribosomal protein L16, mitochondrial', 167, NULL, NULL, 169868),
(169869, '2.60.40.2030-FF-000001', NULL, 'sodium/calcium exchanger 1 isoform X1', 137, NULL, NULL, 169869),
(169870, '2.10.25.10-FF-001011', NULL, 'Slit protein', 51, NULL, NULL, 169870),
(169871, '3.50.50.60-FF-000989', NULL, 'Pyridine nucleotide-disulphide oxidoreductase, putative', 157, NULL, NULL, 169871),
(169872, '3.90.190.10-FF-000573', NULL, 'Uncharacterized protein', 141, NULL, NULL, 169872),
(169873, '3.40.50.1820-FF-001521', NULL, 'Uncharacterized protein', 148, NULL, NULL, 169873),
(169874, '3.30.160.60-FF-001892', NULL, 'Zinc finger protein 786', 31, NULL, NULL, 169874),
(169875, '3.90.1170.20-FF-000006', NULL, 'Nicotinate-nucleotide diphosphorylase (Carboxylating)', 116, NULL, NULL, 169875),
(169876, '3.40.1500.10-FF-000007', NULL, 'Oxygen-dependent coproporphyrinogen-III oxidase', 325, NULL, NULL, 169876),
(169877, '3.90.640.10-FF-000294', NULL, 'Immunoglobulin heavy chain binding protein, putative', 14, NULL, NULL, 169877),
(169878, '1.20.1070.10-FF-001536', NULL, 'Uncharacterized protein', 181, NULL, NULL, 169878),
(169879, '1.20.1540.10-FF-000100', NULL, 'Uncharacterized rhomboid protein C19B12.06c', 188, NULL, NULL, 169879),
(169880, '3.30.420.10-FF-000594', NULL, NULL, 200, NULL, NULL, 169880),
(169881, '2.40.100.10-FF-000122', NULL, 'Peptidyl-prolyl isomerase CWC27', 155, NULL, NULL, 169881),
(169882, '1.10.390.10-FF-000069', NULL, 'Uncharacterized protein', 137, NULL, NULL, 169882),
(169883, '3.30.160.380-FF-000009', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 111, NULL, NULL, 169883),
(169884, '1.20.58.1880-FF-000010', NULL, 'Nuclear receptor corepressor 1', 86, NULL, NULL, 169884),
(169885, '3.30.160.60-FF-005927', NULL, NULL, 30, NULL, NULL, 169885),
(169886, '3.90.1170.30-FF-000009', NULL, 'Pyrimidine-nucleoside phosphorylase', 92, NULL, NULL, 169886),
(169887, '2.40.10.10-FF-000025', NULL, 'serine proteases 1/2', 120, NULL, NULL, 169887),
(169888, '2.130.10.10-FF-004967', NULL, 'Uncharacterized protein', 316, NULL, NULL, 169888),
(169889, '2.60.120.650-FF-000110', NULL, 'Predicted protein', 74, NULL, NULL, 169889),
(169890, '2.60.40.3510-FF-000007', NULL, 'Delta-like protein', 159, NULL, NULL, 169890),
(169891, '2.30.29.30-FF-000575', NULL, 'Uncharacterized protein, isoform A', 132, NULL, NULL, 169891),
(169892, '2.60.40.10-FF-004051', NULL, NULL, 97, NULL, NULL, 169892),
(169893, '2.130.10.10-FF-005810', NULL, 'Chromosome 7, whole genome shotgun sequence', 398, NULL, NULL, 169893),
(169894, '3.30.300.20-FF-000032', NULL, 'AGAP010622-PA-like protein', 102, NULL, NULL, 169894),
(169895, '2.60.40.60-FF-000210', NULL, 'FAT atypical cadherin 2', 104, NULL, NULL, 169895),
(169896, '3.20.20.70-FF-000823', NULL, NULL, 193, NULL, NULL, 169896),
(169897, '1.20.1280.50-FF-000047', NULL, 'Tubby-like F-box protein', 54, NULL, NULL, 169897),
(169898, '3.20.20.80-FF-000826', NULL, 'Predicted protein', 360, NULL, NULL, 169898),
(169899, '3.40.440.10-FF-000014', NULL, NULL, 109, NULL, NULL, 169899);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(169900, '3.40.50.300-FF-007761', NULL, 'Predicted protein', 71, NULL, NULL, 169900),
(169901, '3.60.21.10-FF-000345', NULL, 'MRE11 eukaryotic DNA repair protein', 163, NULL, NULL, 169901),
(169902, '3.30.10.20-FF-000009', NULL, 'Serine/threonine protein kinase', 66, NULL, NULL, 169902),
(169903, '3.40.50.10140-FF-000077', NULL, 'Uncharacterized protein', 50, NULL, NULL, 169903),
(169904, '4.10.900.10-FF-000002', NULL, 'transcription factor 7-like 2 isoform X1', 62, NULL, NULL, 169904),
(169905, '2.60.40.3500-FF-000004', NULL, 'N-acetylmuramoyl-L-alanine amidase', 113, NULL, NULL, 169905),
(169906, '3.40.50.10090-FF-000073', NULL, 'Uncharacterized protein', 41, NULL, NULL, 169906),
(169907, '2.40.170.20-FF-000106', NULL, 'SusC homolog', 540, NULL, NULL, 169907),
(169908, '3.90.70.10-FF-000114', NULL, 'Calpain a', 144, NULL, NULL, 169908),
(169909, '3.40.1620.60-FF-000008', NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 8', 96, NULL, NULL, 169909),
(169910, '1.20.1070.10-FF-000429', NULL, 'Uncharacterized protein', 340, NULL, NULL, 169910),
(169911, '2.60.40.60-FF-000417', NULL, 'Dachsous cadherin-related 1a', 108, NULL, NULL, 169911),
(169912, '3.40.50.620-FF-000679', NULL, 'Uncharacterized protein', 201, NULL, NULL, 169912),
(169913, '3.30.505.10-FF-000206', NULL, NULL, 121, NULL, NULL, 169913),
(169914, '2.30.29.30-FF-001064', NULL, 'Uncharacterized protein', 76, NULL, NULL, 169914),
(169915, '3.80.10.10-FF-003444', NULL, 'Uncharacterized protein', 53, NULL, NULL, 169915),
(169916, '1.10.238.10-FF-000204', NULL, 'EF-hand domain containing 1', 80, NULL, NULL, 169916),
(169917, '1.25.40.20-FF-000523', NULL, 'Os07g0193200 protein', 97, NULL, NULL, 169917),
(169918, '2.130.10.10-FF-003865', NULL, 'Uncharacterized WD repeat-containing protein C16H5.13', 282, NULL, NULL, 169918),
(169919, '1.25.70.10-FF-000022', NULL, 'BnaA06g33880D protein', 246, NULL, NULL, 169919),
(169920, '3.40.1380.20-FF-000073', NULL, 'Uncharacterized protein', 156, NULL, NULL, 169920),
(169921, '3.90.226.10-FF-000230', NULL, 'ATP-dependent Clp protease proteolytic subunit', 201, NULL, NULL, 169921),
(169922, '3.50.50.60-FF-000782', NULL, 'FAD dependent oxidoreductase', 210, NULL, NULL, 169922),
(169923, '1.25.40.10-FF-000520', NULL, 'pentatricopeptide repeat-containing protein At5g39980, chloroplastic', 73, NULL, NULL, 169923),
(169924, '2.10.25.10-FF-001218', NULL, 'von Willebrand factor D and EGF domains', 63, NULL, NULL, 169924),
(169925, '3.30.930.10-FF-000059', NULL, 'phenylalanine--tRNA ligase beta subunit', 201, NULL, NULL, 169925),
(169926, '3.40.20.10-FF-000069', NULL, 'Sfb3p', 144, NULL, NULL, 169926),
(169927, '2.40.128.20-FF-000071', NULL, 'apolipoprotein D-like', 184, NULL, NULL, 169927),
(169928, '3.40.50.11530-FF-000010', NULL, 'Interleukin cytokine receptor-related protein 1', 152, NULL, NULL, 169928),
(169929, '1.10.10.60-FF-001084', NULL, NULL, 65, NULL, NULL, 169929),
(169930, '2.60.120.10-FF-000580', NULL, 'Crp/Fnr family transcriptional regulator', 142, NULL, NULL, 169930),
(169931, '2.60.40.10-FF-000335', NULL, 'Intercellular adhesion molecule 5', 80, NULL, NULL, 169931),
(169932, '4.10.280.110-FF-000021', NULL, NULL, 66, NULL, NULL, 169932),
(169933, '3.40.190.10-FF-000213', NULL, 'Glutamate receptor', 38, NULL, NULL, 169933),
(169934, '1.20.1410.10-FF-000029', NULL, 'AGR286Cp', 184, NULL, NULL, 169934),
(169935, '3.60.20.10-FF-000259', NULL, NULL, 39, NULL, NULL, 169935),
(169936, '3.40.50.150-FF-001741', NULL, NULL, 250, NULL, NULL, 169936),
(169937, '3.80.10.10-FF-001235', NULL, 'Uncharacterized protein', 142, NULL, NULL, 169937),
(169938, '3.40.630.30-FF-000416', NULL, 'N-terminal acetyltransferase complex ARD1 subunit homolog', 193, NULL, NULL, 169938),
(169939, '2.60.120.810-FF-000001', NULL, 'TCP pilus virulence regulatory protein ToxT', 164, NULL, NULL, 169939),
(169940, '2.170.150.30-FF-000004', NULL, 'DEXH (Asp-Glu-X-His) box polypeptide 58', 136, NULL, NULL, 169940),
(169941, '3.40.50.2300-FF-001059', NULL, NULL, 124, NULL, NULL, 169941),
(169942, '3.40.50.410-FF-000088', NULL, 'RNA polymerase II transcription factor B subunit 4', 221, NULL, NULL, 169942);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(169943, '1.25.40.10-FF-001184', NULL, 'Putative pentatricopeptide repeat-containing protein At3g18840', 95, NULL, NULL, 169943),
(169944, '3.30.1140.32-FF-000029', NULL, 'Uncharacterized protein', 56, NULL, NULL, 169944),
(169945, '1.10.10.10-FF-001468', NULL, 'histone H1-delta-like', 83, NULL, NULL, 169945),
(169946, '1.25.10.10-FF-001682', NULL, 'AGAP003488-PA', 293, NULL, NULL, 169946),
(169947, '3.40.50.1000-FF-000174', NULL, 'Phosphoenolpyruvate and 6-phosphogluconate phosphatase', 119, NULL, NULL, 169947),
(169948, '3.30.530.20-FF-000015', NULL, 'Steroidogenic acute regulatory protein, mitochondrial', 220, NULL, NULL, 169948),
(169949, '1.25.40.10-FF-003954', NULL, 'Uncharacterized protein', 259, NULL, NULL, 169949),
(169950, '3.40.50.11350-FF-000046', NULL, 'Uncharacterized protein', 157, NULL, NULL, 169950),
(169951, '3.40.50.10180-FF-000009', NULL, 'Uncharacterized protein', 105, NULL, NULL, 169951),
(169952, '1.20.1560.10-FF-000776', NULL, 'ABC transporter, putative', 294, NULL, NULL, 169952),
(169953, '1.20.58.1120-FF-000069', NULL, NULL, 167, NULL, NULL, 169953),
(169954, '1.20.1280.50-FF-000226', NULL, 'Uncharacterized protein', 159, NULL, NULL, 169954),
(169955, '3.30.160.60-FF-000431', NULL, 'zinc finger protein 629 isoform X2', 29, NULL, NULL, 169955),
(169956, '3.50.30.30-FF-000120', NULL, 'Peptide hydrolase', 77, NULL, NULL, 169956),
(169957, '2.30.30.40-FF-000210', NULL, 'Karst, isoform B', 69, NULL, NULL, 169957),
(169958, '2.60.40.10-FF-005978', NULL, NULL, 98, NULL, NULL, 169958),
(169959, '1.25.10.10-FF-002171', NULL, 'Predicted protein', 489, NULL, NULL, 169959),
(169960, '3.80.10.10-FF-002955', NULL, 'Disease resistance protein RPP8', 97, NULL, NULL, 169960),
(169961, '3.90.550.10-FF-000410', NULL, 'Cellulose synthase-like protein E6', 164, NULL, NULL, 169961),
(169962, '3.30.450.20-FF-000099', NULL, 'Sensory box sensor histidine kinase', 115, NULL, NULL, 169962),
(169963, '2.60.40.60-FF-000182', NULL, 'Blast:Putative neural-cadherin 2', 110, NULL, NULL, 169963),
(169964, '1.10.472.80-FF-000207', NULL, NULL, 137, NULL, NULL, 169964),
(169965, '3.50.30.30-FF-000058', NULL, 'Uncharacterized protein', 165, NULL, NULL, 169965),
(169966, '2.130.10.10-FF-003478', NULL, 'Protein CBR-DAF-15', 313, NULL, NULL, 169966),
(169967, '4.10.800.20-FF-000003', NULL, 'Putative adenosine monophosphate deaminase', 88, NULL, NULL, 169967),
(169968, '4.10.800.30-FF-000006', NULL, 'Essential meiotic structure-specific endonuclease 1', 104, NULL, NULL, 169968),
(169969, '3.40.1110.10-FF-000427', NULL, NULL, 201, NULL, NULL, 169969),
(169970, '2.40.50.140-FF-000994', NULL, NULL, 90, NULL, NULL, 169970),
(169971, '3.30.1330.30-FF-000019', NULL, '40S ribosomal protein S12', 135, NULL, NULL, 169971),
(169972, '3.60.21.10-FF-000137', NULL, 'Calcineurin-like metallo-phosphoesterase superfamily protein', 312, NULL, NULL, 169972),
(169973, '1.10.10.440-FF-000081', NULL, 'Uncharacterized protein', 73, NULL, NULL, 169973),
(169974, '3.50.50.60-FF-001119', NULL, 'Squalene monooxygenase, putative', 142, NULL, NULL, 169974),
(169975, '3.40.50.2000-FF-000665', NULL, 'Glycosyltransferase', 221, NULL, NULL, 169975),
(169976, '1.10.287.2250-FF-000018', NULL, 'Cathepsin Lb', 51, NULL, NULL, 169976),
(169977, '3.30.1330.20-FF-000016', NULL, 'Cell division protein FtsZ', 108, NULL, NULL, 169977),
(169978, '3.40.50.720-FF-001344', NULL, 'Molybdopterin biosynthesis MoeB protein', 240, NULL, NULL, 169978),
(169979, '3.40.605.10-FF-000010', NULL, 'N-succinylglutamate 5-semialdehyde dehydrogenase', 265, NULL, NULL, 169979),
(169980, '2.170.260.10-FF-000001', NULL, 'Protein argonaute-2', 133, NULL, NULL, 169980),
(169981, '3.30.1380.20-FF-000053', NULL, 'Predicted protein', 74, NULL, NULL, 169981),
(169982, '1.25.40.20-FF-001658', NULL, 'Kinase, NEK', 86, NULL, NULL, 169982),
(169983, '3.30.260.10-FF-000002', NULL, 'T-complex protein 1 subunit delta', 107, NULL, NULL, 169983),
(169984, '1.20.120.1760-FF-000044', NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', 190, NULL, NULL, 169984);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(169985, '2.120.10.30-FF-000022', NULL, 'Tol-Pal system protein TolB', 266, NULL, NULL, 169985),
(169986, '3.30.200.20-FF-002031', NULL, 'Mitogen-activated protein kinase', 91, NULL, NULL, 169986),
(169987, '2.30.30.30-FF-000027', NULL, 'Transcription elongation factor SPT5', 58, NULL, NULL, 169987),
(169988, '1.20.1250.20-FF-001430', NULL, 'Uncharacterized protein', 146, NULL, NULL, 169988),
(169989, '3.40.720.10-FF-000176', NULL, 'Predicted protein', 48, NULL, NULL, 169989),
(169990, '2.70.160.11-FF-000098', NULL, 'Uncharacterized protein', 127, NULL, NULL, 169990),
(169991, '3.90.1410.10-FF-000039', NULL, 'SET domain protein (AFU_orthologue AFUA_4G11040)', 269, NULL, NULL, 169991),
(169992, '3.80.10.10-FF-001409', NULL, 'Ribonuclease inhibitor', 194, NULL, NULL, 169992),
(169993, '1.10.510.10-FF-003890', NULL, NULL, 88, NULL, NULL, 169993),
(169994, '2.60.120.200-FF-000644', NULL, 'Uncharacterized protein', 110, NULL, NULL, 169994),
(169995, '3.40.50.720-FF-000737', NULL, 'NAD(P)-binding protein', 214, NULL, NULL, 169995),
(169996, '3.30.1330.10-FF-000013', NULL, 'Phosphoribosylformylglycinamidine synthase', 159, NULL, NULL, 169996),
(169997, '3.90.70.10-FF-000614', NULL, 'Uncharacterized protein', 155, NULL, NULL, 169997),
(169998, '2.60.40.10-FF-004017', NULL, NULL, 98, NULL, NULL, 169998),
(169999, '3.30.60.30-FF-000049', NULL, 'Predicted protein', 52, NULL, NULL, 169999),
(170000, '3.40.50.300-FF-006625', NULL, 'Uncharacterized protein', 92, NULL, NULL, 170000),
(170001, '3.30.450.40-FF-000200', NULL, 'GAF domain-containing protein', 170, NULL, NULL, 170001),
(170002, '3.50.50.60-FF-000990', NULL, '67 kDa Myosin-crossreactive antigen', 222, NULL, NULL, 170002),
(170003, '3.40.50.10180-FF-000010', NULL, 'AGAP007988-PA', 137, NULL, NULL, 170003),
(170004, '2.170.270.10-FF-000030', NULL, 'Histone-lysine N-methyltransferase ATX4', 155, NULL, NULL, 170004),
(170005, '3.30.450.20-FF-000571', NULL, 'Uncharacterized protein', 97, NULL, NULL, 170005),
(170006, '3.30.40.10-FF-001144', NULL, 'Nitric oxide synthase-interacting protein', 106, NULL, NULL, 170006),
(170007, '3.30.160.60-FF-001858', NULL, 'Spalt like transcription factor 3', 42, NULL, NULL, 170007),
(170008, '3.40.50.150-FF-000252', NULL, 'EEF1A lysine methyltransferase 4', 232, NULL, NULL, 170008),
(170009, '2.60.40.790-FF-000204', NULL, NULL, 48, NULL, NULL, 170009),
(170010, '4.10.410.60-FF-000002', NULL, '50S ribosomal protein L35', 62, NULL, NULL, 170010),
(170011, '3.40.532.10-FF-000003', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 224, NULL, NULL, 170011),
(170012, '2.130.10.10-FF-005664', NULL, 'GPI inositol-deacylase', 165, NULL, NULL, 170012),
(170013, '3.40.1360.10-FF-000035', NULL, 'AGAP010898-PA', 216, NULL, NULL, 170013),
(170014, '1.10.3370.10-FF-000039', NULL, 'Uncharacterized protein', 230, NULL, NULL, 170014),
(170015, '1.10.8.970-FF-000005', NULL, 'Genome polyprotein', 75, NULL, NULL, 170015),
(170016, '3.50.50.60-FF-000017', NULL, 'Fumarate reductase flavoprotein subunit', 273, NULL, NULL, 170016),
(170017, '3.40.1380.10-FF-000036', NULL, 'Uncharacterized protein', 36, NULL, NULL, 170017),
(170018, '1.20.1250.20-FF-001519', NULL, 'Os05g0338933 protein', 121, NULL, NULL, 170018),
(170019, '1.25.10.10-FF-002137', NULL, 'Predicted protein', 567, NULL, NULL, 170019),
(170020, '2.60.40.1530-FF-000003', NULL, 'Integrin alpha M', 174, NULL, NULL, 170020),
(170021, '2.60.40.10-FF-000217', NULL, 'High affinity immunoglobulin gamma Fc receptor I', 86, NULL, NULL, 170021),
(170022, '2.70.98.110-FF-000002', NULL, 'Mannosyl-oligosaccharide glucosidase GCS1', 282, NULL, NULL, 170022),
(170023, '1.10.10.60-FF-000010', NULL, 'Transcriptional activator Myb isoform A', 53, NULL, NULL, 170023),
(170024, '2.60.120.10-FF-000169', NULL, 'cAMP-binding domain (Catabolite gene activator) transcriptional regulator', 218, NULL, NULL, 170024),
(170025, '1.25.40.570-FF-000060', NULL, 'Uncharacterized protein', 185, NULL, NULL, 170025),
(170026, '3.80.10.10-FF-003652', NULL, 'Predicted protein', 126, NULL, NULL, 170026),
(170027, '1.20.58.1220-FF-000009', NULL, 'Exocyst complex component 8', 105, NULL, NULL, 170027);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(170028, '1.25.40.20-FF-000731', NULL, 'Ankyrin repeat domain 6b', 100, NULL, NULL, 170028),
(170029, '3.30.160.60-FF-006063', NULL, NULL, 37, NULL, NULL, 170029),
(170030, '1.10.196.10-FF-000016', NULL, 'Regulator of G protein-signaling 14a', 25, NULL, NULL, 170030),
(170031, '1.20.58.70-FF-000111', NULL, 'Uncharacterized protein', 209, NULL, NULL, 170031),
(170032, '3.80.10.10-FF-004546', NULL, 'Uncharacterized protein', 426, NULL, NULL, 170032),
(170033, '2.20.25.10-FF-000122', NULL, 'Uncharacterized protein', 33, NULL, NULL, 170033),
(170034, '3.40.50.150-FF-001387', NULL, NULL, 172, NULL, NULL, 170034),
(170035, '2.60.40.10-FF-002460', NULL, 'CRE-TWK-32 protein', 98, NULL, NULL, 170035),
(170036, '3.30.70.890-FF-000007', NULL, 'Galactokinase 1', 165, NULL, NULL, 170036),
(170037, '1.10.510.10-FF-002900', NULL, 'Serine/threonine kinase', 275, NULL, NULL, 170037),
(170038, '3.90.230.10-FF-000043', NULL, 'Ab1-334', 188, NULL, NULL, 170038),
(170039, '1.20.120.1900-FF-000013', NULL, 'Spindle pole body component', 358, NULL, NULL, 170039),
(170040, '3.50.30.50-FF-000013', NULL, 'Cyclase family protein', 207, NULL, NULL, 170040),
(170041, '3.40.1380.20-FF-000039', NULL, 'Pyruvate kinase', 172, NULL, NULL, 170041),
(170042, '3.40.50.2300-FF-000749', NULL, 'Guanylate cyclase 2G', 103, NULL, NULL, 170042),
(170043, '1.10.287.110-FF-000230', NULL, 'Uncharacterized protein', 98, NULL, NULL, 170043),
(170044, '3.10.110.10-FF-000002', NULL, 'Ubiquitin-conjugating enzyme E2 D3', 147, NULL, NULL, 170044),
(170045, '3.40.50.300-FF-005962', NULL, 'ATP-dependent DNA helicase, RecQ family', 201, NULL, NULL, 170045),
(170046, '3.40.1370.10-FF-000007', NULL, '50S ribosomal protein L4', 196, NULL, NULL, 170046),
(170047, '1.10.8.60-FF-000228', NULL, 'ESX-1 secretion system protein EccA1', 98, NULL, NULL, 170047),
(170048, '3.30.300.30-FF-000153', NULL, 'Nonribosomal peptide synthetase asqK', 109, NULL, NULL, 170048),
(170049, '1.25.10.10-FF-000046', NULL, 'Coatomer subunit gamma', 314, NULL, NULL, 170049),
(170050, '1.10.240.10-FF-000002', NULL, 'Tryptophan--tRNA ligase', 113, NULL, NULL, 170050),
(170051, '1.20.120.1750-FF-000041', NULL, 'Zinc finger protein', 81, NULL, NULL, 170051),
(170052, '2.40.33.10-FF-000033', NULL, 'Predicted protein', 74, NULL, NULL, 170052),
(170053, '1.10.10.10-FF-000102', NULL, 'LexA repressor', 68, NULL, NULL, 170053),
(170054, '1.10.510.10-FF-003564', NULL, NULL, 223, NULL, NULL, 170054),
(170055, '1.20.120.1910-FF-000016', NULL, 'Putative cysteinyl-tRNA synthetase', 186, NULL, NULL, 170055),
(170056, '1.25.40.10-FF-001655', NULL, 'Uncharacterized protein', 237, NULL, NULL, 170056),
(170057, '3.40.140.100-FF-000009', NULL, 'ubiquitin-like modifier-activating enzyme ATG7', 145, NULL, NULL, 170057),
(170058, '3.30.565.10-FF-000300', NULL, 'Uncharacterized protein', 219, NULL, NULL, 170058),
(170059, '3.40.30.10-FF-000249', NULL, 'Peroxiredoxin', 200, NULL, NULL, 170059),
(170060, '3.90.190.10-FF-000539', NULL, 'Dual specificity protein phosphatase CDC14A, putative', 170, NULL, NULL, 170060),
(170061, '2.60.220.50-FF-000189', NULL, 'Uncharacterized protein', 197, NULL, NULL, 170061),
(170062, '3.40.50.10190-FF-000277', NULL, 'Uncharacterized protein', 105, NULL, NULL, 170062),
(170063, '2.30.30.140-FF-000155', NULL, 'Histone acetyltransferase', 132, NULL, NULL, 170063),
(170064, '1.20.1070.10-FF-000755', NULL, 'Uncharacterized protein', 143, NULL, NULL, 170064),
(170065, '1.10.510.10-FF-000130', NULL, 'Ephrin type-A receptor 7', 193, NULL, NULL, 170065),
(170066, '2.60.40.10-FF-003707', NULL, NULL, 94, NULL, NULL, 170066),
(170067, '2.10.90.10-FF-000099', NULL, 'Uncharacterized protein', 79, NULL, NULL, 170067),
(170068, '3.30.160.60-FF-000077', NULL, 'Sp8 transcription factor', 35, NULL, NULL, 170068),
(170069, '1.20.1560.10-FF-000568', NULL, 'Uncharacterized protein', 22, NULL, NULL, 170069),
(170070, '1.20.58.390-FF-000048', NULL, 'Cholinergic receptor nicotinic epsilon subunit', 81, NULL, NULL, 170070),
(170071, '1.20.58.1210-FF-000006', NULL, 'Exocyst complex component EXO84', 128, NULL, NULL, 170071);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(170072, '1.20.1250.20-FF-000856', NULL, 'Permease, multidrug efflux', 255, NULL, NULL, 170072),
(170073, '1.20.58.390-FF-000256', NULL, 'Uncharacterized protein', 103, NULL, NULL, 170073),
(170074, '3.10.490.10-FF-000001', NULL, 'Gamma-glutamylcyclotransferase ytfP', 113, NULL, NULL, 170074),
(170075, '3.30.200.20-FF-001783', NULL, NULL, 101, NULL, NULL, 170075),
(170076, '3.10.20.90-FF-000178', NULL, 'Probable splicing factor 3A subunit 1', 111, NULL, NULL, 170076),
(170077, '2.10.25.10-FF-001191', NULL, 'Sperm transmembrane protein 9', 44, NULL, NULL, 170077),
(170078, '3.40.50.300-FF-004063', NULL, 'DNA helicase', 182, NULL, NULL, 170078),
(170079, '3.80.10.10-FF-002781', NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', 283, NULL, NULL, 170079),
(170080, '1.20.1070.10-FF-001418', NULL, 'Uncharacterized protein', 230, NULL, NULL, 170080),
(170081, '2.40.10.10-FF-000110', NULL, 'Hepsin', 71, NULL, NULL, 170081),
(170082, '3.30.70.330-FF-001436', NULL, 'HNRNPD isoform 12', 90, NULL, NULL, 170082),
(170083, '3.20.20.70-FF-000470', NULL, '2,4-dienoyl-coa reductase-like protein', 398, NULL, NULL, 170083),
(170084, '3.10.490.20-FF-000004', NULL, 'Cytoplasmic dynein heavy chain 2', 131, NULL, NULL, 170084),
(170085, '2.60.120.330-FF-000071', NULL, 'Predicted protein', 330, NULL, NULL, 170085),
(170086, '3.40.50.10610-FF-000004', NULL, 'Putative lipoprotein YmbA', 166, NULL, NULL, 170086),
(170087, '3.40.850.10-FF-000534', NULL, 'Uncharacterized protein', 351, NULL, NULL, 170087),
(170088, '2.60.40.10-FF-004225', NULL, NULL, 112, NULL, NULL, 170088),
(170089, '3.30.40.10-FF-001880', NULL, 'Predicted protein', 76, NULL, NULL, 170089),
(170090, '1.20.5.340-FF-000112', NULL, 'Rho-associated protein kinase 1', 107, NULL, NULL, 170090),
(170091, '1.10.2000.10-FF-000079', NULL, NULL, 81, NULL, NULL, 170091),
(170092, '2.60.40.150-FF-000007', NULL, 'Synaptotagmin 1', 154, NULL, NULL, 170092),
(170093, '2.40.160.20-FF-000016', NULL, 'Lipid A deacylase', 150, NULL, NULL, 170093),
(170094, '1.10.287.70-FF-000627', NULL, 'Predicted protein', 217, NULL, NULL, 170094),
(170095, '2.70.170.10-FF-000035', NULL, 'Ligand-Gated ion Channel', 208, NULL, NULL, 170095),
(170096, '1.25.40.10-FF-005253', NULL, 'Uncharacterized protein', 163, NULL, NULL, 170096),
(170097, '3.40.50.40-FF-000001', NULL, 'L-asparaginase 1', 127, NULL, NULL, 170097),
(170098, '1.25.10.10-FF-001356', NULL, 'Potential nuclear cohesin complex subunit', 238, NULL, NULL, 170098),
(170099, '1.10.510.10-FF-004345', NULL, NULL, 126, NULL, NULL, 170099),
(170100, '2.30.30.380-FF-000053', NULL, 'Nei like DNA glycosylase 3', 52, NULL, NULL, 170100),
(170101, '3.30.70.1230-FF-000223', NULL, 'Uncharacterized protein', 56, NULL, NULL, 170101),
(170102, '1.20.120.1080-FF-000138', NULL, 'Uncharacterized protein', 172, NULL, NULL, 170102),
(170103, '2.130.10.10-FF-000021', NULL, 'histone-binding protein RBBP4 isoform X1', 424, NULL, NULL, 170103),
(170104, '1.20.140.150-FF-000064', NULL, 'Integral membrane protein (AFU_orthologue AFUA_6G07470)', 202, NULL, NULL, 170104),
(170105, '2.40.160.10-FF-000013', NULL, 'Voltage-dependent anion channel protein 2', 293, NULL, NULL, 170105),
(170106, '1.10.268.10-FF-000032', NULL, NULL, 176, NULL, NULL, 170106),
(170107, '1.20.120.140-FF-000023', NULL, 'Signal recognition particle 54 kDa protein putative', 96, NULL, NULL, 170107),
(170108, '3.40.50.720-FF-001552', NULL, 'Short chain dehydrogenase', 255, NULL, NULL, 170108),
(170109, '1.10.10.2210-FF-000005', NULL, NULL, 96, NULL, NULL, 170109),
(170110, '3.20.20.80-FF-000591', NULL, 'Arabinogalactan endo-beta-1,4-galactanase', 207, NULL, NULL, 170110),
(170111, '1.10.10.2200-FF-000002', NULL, 'Rab family protein', 87, NULL, NULL, 170111),
(170112, '3.10.580.10-FF-000205', NULL, 'Uncharacterized protein', 117, NULL, NULL, 170112),
(170113, '3.60.21.10-FF-000430', NULL, 'Metallophosphoesterase', 250, NULL, NULL, 170113),
(170114, '2.40.180.10-FF-000014', NULL, 'Catalase (Eurofung)', 483, NULL, NULL, 170114),
(170115, '1.20.1270.10-FF-000057', NULL, 'Endoplasmic reticulum chaperone BiP homolog', 75, NULL, NULL, 170115);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(170116, '3.10.580.10-FF-000093', NULL, 'Chloride channel protein', 77, NULL, NULL, 170116),
(170117, '2.70.130.10-FF-000027', NULL, 'Glucosidase 2 subunit beta', 99, NULL, NULL, 170117),
(170118, '2.60.40.10-FF-003354', NULL, NULL, 101, NULL, NULL, 170118),
(170119, '3.40.30.10-FF-000513', NULL, 'Phosducin, putative', 132, NULL, NULL, 170119),
(170120, '2.130.10.10-FF-002230', NULL, 'NACHT and WD domain protein', 126, NULL, NULL, 170120),
(170121, '3.30.2140.20-FF-000007', NULL, 'Arylamine N-acetyltransferase 6', 214, NULL, NULL, 170121),
(170122, '3.20.80.10-FF-000034', NULL, 'Uncharacterized protein', 149, NULL, NULL, 170122),
(170123, '2.30.42.10-FF-000476', NULL, NULL, 104, NULL, NULL, 170123),
(170124, '3.90.1180.10-FF-000032', NULL, NULL, 120, NULL, NULL, 170124),
(170125, '3.20.10.10-FF-000029', NULL, '4-amino-4-deoxychorismate lyase', 108, NULL, NULL, 170125),
(170126, '1.10.1420.10-FF-000133', NULL, 'Putative mis-match repair protein', 178, NULL, NULL, 170126),
(170127, '2.60.40.10-FF-001645', NULL, 'Protein tyrosine phosphatase, receptor type Q', 116, NULL, NULL, 170127),
(170128, '1.20.120.350-FF-000171', NULL, NULL, 160, NULL, NULL, 170128),
(170129, '1.20.5.170-FF-000185', NULL, 'BZIP transcription factor', 54, NULL, NULL, 170129),
(170130, '1.10.30.10-FF-000165', NULL, 'Uncharacterized protein', 49, NULL, NULL, 170130),
(170131, '2.130.10.30-FF-000027', NULL, 'Protein FMP25, mitochondrial', 449, NULL, NULL, 170131),
(170132, '1.20.120.350-FF-000114', NULL, 'Potassium voltage-gated channel modifier subfamily V member 1', 143, NULL, NULL, 170132),
(170133, '1.10.555.10-FF-000008', NULL, 'Rho GTPase-activating protein 42', 193, NULL, NULL, 170133),
(170134, '1.10.555.10-FF-000065', NULL, 'Rho GTPase activator, putative', 242, NULL, NULL, 170134),
(170135, '2.80.10.50-FF-000131', NULL, 'Uncharacterized protein', 96, NULL, NULL, 170135),
(170136, '3.20.20.70-FF-000531', NULL, NULL, 247, NULL, NULL, 170136),
(170137, '3.30.540.10-FF-000041', NULL, 'inositol polyphosphate 1-phosphatase', 176, NULL, NULL, 170137),
(170138, '3.40.50.10810-FF-000272', NULL, 'Predicted protein', 106, NULL, NULL, 170138),
(170139, '2.60.120.340-FF-000017', NULL, 'Nucleophosmin (Nucleolar phosphoprotein B23, numatrin)', 119, NULL, NULL, 170139),
(170140, '3.40.630.30-FF-000501', NULL, 'Hypothetical conserved protein', 121, NULL, NULL, 170140),
(170141, '3.40.50.1240-FF-000100', NULL, '6-phosphofructo-2-kinase/fructose-2,6-biphosphata se-1-like protein', 235, NULL, NULL, 170141),
(170142, '2.60.20.10-FF-000008', NULL, 'very large A-kinase anchor protein', 86, NULL, NULL, 170142),
(170143, '3.20.20.70-FF-000677', NULL, NULL, 204, NULL, NULL, 170143),
(170144, '2.60.120.330-FF-000014', NULL, 'Gibberellin 2-beta-dioxygenase 1', 315, NULL, NULL, 170144),
(170145, '3.40.50.20-FF-000079', NULL, 'Uncharacterized protein', 88, NULL, NULL, 170145),
(170146, '3.40.50.300-FF-002410', NULL, 'YML133C-like protein', 184, NULL, NULL, 170146),
(170147, '2.40.37.10-FF-000059', NULL, NULL, 150, NULL, NULL, 170147),
(170148, '3.60.20.10-FF-000085', NULL, 'Proteasome subunit beta', 231, NULL, NULL, 170148),
(170149, '3.10.105.10-FF-000113', NULL, 'ABC-type dipeptide/oligopeptide transport system, probable periplasmic component', 220, NULL, NULL, 170149),
(170150, '1.20.120.160-FF-000029', NULL, 'Histidine kinase', 115, NULL, NULL, 170150),
(170151, '1.10.533.10-FF-000020', NULL, 'CASP8 and FADD like apoptosis regulator', 84, NULL, NULL, 170151),
(170152, '1.25.10.10-FF-001827', NULL, 'Importin 8', 514, NULL, NULL, 170152),
(170153, '1.10.10.60-FF-001258', NULL, NULL, 80, NULL, NULL, 170153),
(170154, '2.10.220.10-FF-000019', NULL, 'Proprotein convertase subtilisin/kexin type 6', 76, NULL, NULL, 170154),
(170155, '2.60.34.10-FF-000130', NULL, 'Heat shock protein family A (Hsp70) member 9', 98, NULL, NULL, 170155),
(170156, '3.20.20.80-FF-000534', NULL, 'Beta-galactosidase', 61, NULL, NULL, 170156),
(170157, '2.130.10.10-FF-000605', NULL, 'Transducin beta-like protein 3', 118, NULL, NULL, 170157),
(170158, '1.10.260.30-FF-000009', NULL, 'Putative signal peptide binding domain protein', 138, NULL, NULL, 170158);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(170159, '2.60.40.60-FF-000125', NULL, 'Neural-cadherin', 112, NULL, NULL, 170159),
(170160, '2.60.120.320-FF-000011', NULL, 'Uncharacterized protein', 46, NULL, NULL, 170160),
(170161, '3.90.70.10-FF-000406', NULL, 'Ubiquitinyl hydrolase 1', 269, NULL, NULL, 170161),
(170162, '1.10.533.10-FF-000109', NULL, 'GG10810', 93, NULL, NULL, 170162),
(170163, '3.30.160.60-FF-003691', NULL, NULL, 32, NULL, NULL, 170163),
(170164, '2.30.29.30-FF-000867', NULL, 'PH domain protein (AFU_orthologue AFUA_3G13830)', 133, NULL, NULL, 170164),
(170165, '3.40.50.1820-FF-000268', NULL, 'Carboxylic ester hydrolase', 296, NULL, NULL, 170165),
(170166, '3.90.1150.10-FF-000497', NULL, 'Uncharacterized protein', 21, NULL, NULL, 170166),
(170167, '3.40.50.1000-FF-000202', NULL, 'Cation transporting P-ATPase', 75, NULL, NULL, 170167),
(170168, '2.60.120.10-FF-000815', NULL, 'Uncharacterized protein', 203, NULL, NULL, 170168),
(170169, '1.10.10.2480-FF-000007', NULL, NULL, 63, NULL, NULL, 170169),
(170170, '1.10.575.10-FF-000009', NULL, 'Phospholipase C', 180, NULL, NULL, 170170),
(170171, '3.30.710.10-FF-000487', NULL, 'Uncharacterized protein', 81, NULL, NULL, 170171),
(170172, '3.40.1000.10-FF-000014', NULL, 'Nuclear import protein MOG1', 188, NULL, NULL, 170172),
(170173, '2.30.29.30-FF-000928', NULL, 'Predicted protein', 136, NULL, NULL, 170173),
(170174, '3.30.1390.20-FF-000025', NULL, 'Uncharacterized protein', 53, NULL, NULL, 170174),
(170175, '3.30.420.10-FF-000740', NULL, NULL, 250, NULL, NULL, 170175),
(170176, '2.130.10.10-FF-005782', NULL, 'Zgc:77560', 102, NULL, NULL, 170176),
(170177, '3.40.50.300-FF-001483', NULL, 'Small GTP-binding protein Rab1', 184, NULL, NULL, 170177),
(170178, '1.25.50.20-FF-000057', NULL, 'Aminopeptidase', 169, NULL, NULL, 170178),
(170179, '3.40.50.1010-FF-000205', NULL, NULL, 125, NULL, NULL, 170179),
(170180, '3.90.570.10-FF-000001', NULL, 'Amyloid beta A4 protein', 107, NULL, NULL, 170180),
(170181, '2.40.20.10-FF-000054', NULL, 'Uncharacterized protein', 86, NULL, NULL, 170181),
(170182, '3.30.160.60-FF-006271', NULL, NULL, 21, NULL, NULL, 170182),
(170183, '3.40.1050.10-FF-000017', NULL, 'Carbonic anhydrase', 211, NULL, NULL, 170183),
(170184, '2.60.40.150-FF-000125', NULL, 'Phosphatidylinositol-4-phosphate 3-kinase catalytic subunit type 2 gamma', 122, NULL, NULL, 170184),
(170185, '3.40.50.10900-FF-000001', NULL, 'Proteasome assembly chaperone 2', 153, NULL, NULL, 170185),
(170186, '3.60.20.40-FF-000043', NULL, 'Gamma glutamyl transpeptidase, putative', 88, NULL, NULL, 170186),
(170187, '2.60.40.10-FF-000627', NULL, 'Nectin cell adhesion molecule 4', 94, NULL, NULL, 170187),
(170188, '3.30.2160.10-FF-000005', NULL, 'E3 ubiquitin-protein ligase HECW2 isoform X1', 78, NULL, NULL, 170188),
(170189, '3.40.1390.20-FF-000012', NULL, 'HPr kinase/phosphorylase', 128, NULL, NULL, 170189),
(170190, '3.10.100.10-FF-000271', NULL, NULL, 144, NULL, NULL, 170190),
(170191, '2.60.40.60-FF-000064', NULL, 'FAT atypical cadherin 1', 113, NULL, NULL, 170191),
(170192, '3.40.50.1000-FF-000820', NULL, NULL, 97, NULL, NULL, 170192),
(170193, '1.10.455.10-FF-000001', NULL, '30S ribosomal protein S7', 155, NULL, NULL, 170193),
(170194, '3.80.10.10-FF-003091', NULL, 'Uncharacterized protein', 120, NULL, NULL, 170194),
(170195, '3.40.50.300-FF-006215', NULL, 'Uncharacterized protein MJ0325', 130, NULL, NULL, 170195),
(170196, '3.30.160.60-FF-005248', NULL, NULL, 61, NULL, NULL, 170196),
(170197, '1.10.510.10-FF-002193', NULL, 'Receptor protein serine/threonine kinase', 235, NULL, NULL, 170197),
(170198, '2.120.10.80-FF-000340', NULL, 'Uncharacterized protein', 309, NULL, NULL, 170198),
(170199, '1.10.238.10-FF-000143', NULL, 'probable calcium-binding protein CML13', 78, NULL, NULL, 170199),
(170200, '1.25.40.10-FF-005045', NULL, 'Pentatricopeptide repeat-containing protein At4g39530', 123, NULL, NULL, 170200),
(170201, '1.10.150.20-FF-000178', NULL, 'DNA-directed RNA polymerase subunit alpha', 80, NULL, NULL, 170201),
(170202, '1.20.960.40-FF-000001', NULL, 'FGFR1 oncogene partner', 82, NULL, NULL, 170202);
INSERT INTO "PUBLIC"."MODEL" VALUES
(170203, '1.10.275.10-FF-000026', NULL, NULL, 91, NULL, NULL, 170203),
(170204, '3.30.70.330-FF-000250', NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', 88, NULL, NULL, 170204),
(170205, '3.40.1350.10-FF-000001', NULL, 'tRNA-splicing endonuclease subunit Sen2', 99, NULL, NULL, 170205),
(170206, '1.20.1070.10-FF-002138', NULL, 'Uncharacterized protein', 225, NULL, NULL, 170206),
(170207, '3.30.40.10-FF-001262', NULL, 'YALI0F18634p', 80, NULL, NULL, 170207),
(170208, '1.10.533.10-FF-000227', NULL, 'Si:dkey-61p9.9', 88, NULL, NULL, 170208),
(170209, '3.40.1160.10-FF-000054', NULL, 'Aspartokinase', 255, NULL, NULL, 170209),
(170210, '1.25.40.20-FF-000023', NULL, 'short transient receptor potential channel 4 isoform X1', 291, NULL, NULL, 170210),
(170211, '3.40.50.300-FF-003399', NULL, 'Bifunctional polynucleotide phosphatase/kinase', 63, NULL, NULL, 170211),
(170212, '3.30.420.10-FF-000622', NULL, NULL, 172, NULL, NULL, 170212),
(170213, '2.60.120.290-FF-000098', NULL, 'AAEL003472-PA', 131, NULL, NULL, 170213),
(170214, '1.20.1740.10-FF-000166', NULL, 'Uncharacterized protein', 298, NULL, NULL, 170214),
(170215, '2.160.10.10-FF-000008', NULL, 'Maltose O-acetyltransferase', 186, NULL, NULL, 170215),
(170216, '1.25.40.10-FF-000020', NULL, 'Stress-induced phosphoprotein 1', 117, NULL, NULL, 170216),
(170217, '3.40.50.150-FF-001269', NULL, NULL, 231, NULL, NULL, 170217),
(170218, '1.10.630.10-FF-000459', NULL, 'Uncharacterized protein', 271, NULL, NULL, 170218),
(170219, '3.40.30.10-FF-000721', NULL, 'Uncharacterized protein', 218, NULL, NULL, 170219),
(170220, '1.10.601.10-FF-000009', NULL, NULL, 181, NULL, NULL, 170220),
(170221, '2.10.70.10-FF-000070', NULL, 'Complement C3d receptor 2', 65, NULL, NULL, 170221),
(170222, '3.30.70.330-FF-002925', NULL, NULL, 122, NULL, NULL, 170222),
(170223, '3.30.710.10-FF-000369', NULL, 'BTB/POZ domain-containing protein, putative', 153, NULL, NULL, 170223),
(170224, '3.90.190.10-FF-000129', NULL, 'Dual specificity protein phosphatase, putative', 163, NULL, NULL, 170224),
(170225, '1.10.1410.10-FF-000014', NULL, 'U3 small nucleolar RNA-associated protein 22', 163, NULL, NULL, 170225),
(170226, '3.40.50.300-FF-007553', NULL, 'Uncharacterized protein', 192, NULL, NULL, 170226),
(170227, '3.40.30.10-FF-000103', NULL, '28S ribosomal protein S25, mitochondrial', 120, NULL, NULL, 170227),
(170228, '3.30.1300.10-FF-000011', NULL, NULL, 105, NULL, NULL, 170228),
(170229, '2.40.10.10-FF-000525', NULL, NULL, 102, NULL, NULL, 170229),
(170230, '2.30.30.140-FF-000273', NULL, 'Retinoblastoma-binding protein', 108, NULL, NULL, 170230),
(170231, '3.40.50.1820-FF-000886', NULL, 'Carboxylic ester hydrolase', 281, NULL, NULL, 170231),
(170232, '2.60.200.20-FF-000206', NULL, 'Serine/threonine-protein kinase', 157, NULL, NULL, 170232),
(170233, '3.40.30.10-FF-000367', NULL, 'Glutaredoxin 1', 111, NULL, NULL, 170233),
(170234, '1.10.238.10-FF-001278', NULL, 'Troponin C', 72, NULL, NULL, 170234),
(170235, '3.10.130.10-FF-000008', NULL, 'Liver ribonuclease A', 129, NULL, NULL, 170235),
(170236, '1.10.287.950-FF-000043', NULL, 'Laminin subunit alpha-1-like Protein', 150, NULL, NULL, 170236),
(170237, '2.60.120.10-FF-000579', NULL, 'Crp/Fnr family transcriptional regulator', 142, NULL, NULL, 170237),
(170238, '3.20.20.80-FF-000798', NULL, 'Uncharacterized protein', 155, NULL, NULL, 170238),
(170239, '3.30.160.60-FF-003803', NULL, NULL, 75, NULL, NULL, 170239),
(170240, '3.30.559.10-FF-000179', NULL, 'HC-toxin synthetase', 223, NULL, NULL, 170240),
(170241, '4.10.1000.10-FF-000026', NULL, 'Zinc finger CCCH domain-containing protein 11A', 60, NULL, NULL, 170241),
(170242, '3.20.20.220-FF-000035', NULL, 'Proline dehydrogenase', 110, NULL, NULL, 170242),
(170243, '3.10.250.10-FF-000074', NULL, NULL, 66, NULL, NULL, 170243),
(170244, '3.20.20.70-FF-000177', NULL, 'Alpha-galactosidase', 285, NULL, NULL, 170244),
(170245, '3.80.10.10-FF-000538', NULL, 'Si:ch211-127b6.2', 119, NULL, NULL, 170245),
(170246, '2.40.160.120-FF-000020', NULL, 'Oxysterol-binding protein', 198, NULL, NULL, 170246);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(170247, '1.25.40.10-FF-000110', NULL, 'Peroxisome biogenesis protein 5', 289, NULL, NULL, 170247),
(170248, '1.25.10.10-FF-001620', NULL, 'Importin 11', 550, NULL, NULL, 170248),
(170249, '3.30.160.60-FF-000223', NULL, 'zinc finger protein 64 isoform X1', 25, NULL, NULL, 170249),
(170250, '1.10.287.810-FF-000018', NULL, 'Mitochondrial import inner membrane translocase subunit tim-10', 78, NULL, NULL, 170250),
(170251, '1.10.510.10-FF-002136', NULL, 'Kinase, NEK', 321, NULL, NULL, 170251),
(170252, '3.30.750.24-FF-000177', NULL, 'Uncharacterized protein', 51, NULL, NULL, 170252),
(170253, '3.40.50.2300-FF-001093', NULL, NULL, 155, NULL, NULL, 170253),
(170254, '3.40.50.300-FF-007289', NULL, 'Uncharacterized protein', 152, NULL, NULL, 170254),
(170255, '3.90.550.10-FF-000202', NULL, 'Polypeptide N-acetylgalactosaminyltransferase 6', 258, NULL, NULL, 170255),
(170256, '3.30.930.10-FF-000352', NULL, 'Uncharacterized protein', 49, NULL, NULL, 170256),
(170257, '3.40.50.1820-FF-001460', NULL, 'Uncharacterized protein', 180, NULL, NULL, 170257),
(170258, '3.40.33.10-FF-000020', NULL, 'Pathogenesis-related protein 1', 143, NULL, NULL, 170258),
(170259, '3.30.160.60-FF-001448', NULL, 'Zinc finger and BTB domain containing 7a', 30, NULL, NULL, 170259),
(170260, '1.10.630.10-FF-000369', NULL, 'Uncharacterized protein', 446, NULL, NULL, 170260),
(170261, '3.40.395.10-FF-000037', NULL, 'Predicted protein', 199, NULL, NULL, 170261),
(170262, '3.40.50.450-FF-000105', NULL, 'Uncharacterized protein', 40, NULL, NULL, 170262),
(170263, '3.30.40.10-FF-000688', NULL, 'Histone-lysine N-methyltransferase', 108, NULL, NULL, 170263),
(170264, '2.40.420.20-FF-000025', NULL, 'Cation efflux system protein', 76, NULL, NULL, 170264),
(170265, '1.10.1580.10-FF-000026', NULL, 'YALI0E01760p', 84, NULL, NULL, 170265),
(170266, '1.10.565.10-FF-000037', NULL, 'Hormone receptor 3, isoform C', 250, NULL, NULL, 170266),
(170267, '1.10.630.10-FF-000723', NULL, 'Uncharacterized protein', 102, NULL, NULL, 170267),
(170268, '2.60.40.10-FF-004989', NULL, NULL, 108, NULL, NULL, 170268),
(170269, '3.40.50.1820-FF-001403', NULL, 'Uncharacterized protein', 210, NULL, NULL, 170269),
(170270, '3.80.10.10-FF-002837', NULL, 'Probable inactive receptor kinase At5g67200', 111, NULL, NULL, 170270),
(170271, '2.40.30.10-FF-000173', NULL, 'Selenocysteine-specific elongation factor selB', 93, NULL, NULL, 170271),
(170272, '4.10.49.10-FF-000004', NULL, 'Related to COX8-cytochrome-c oxidase chain VIII', 47, NULL, NULL, 170272),
(170273, '1.10.510.10-FF-001939', NULL, 'Os05g0270875 protein', 103, NULL, NULL, 170273),
(170274, '1.25.10.10-FF-001474', NULL, 'Splicing factor 3B subunit 1, putative', 169, NULL, NULL, 170274),
(170275, '3.30.450.50-FF-000057', NULL, 'Putative synaptobrevin homolog YKT6', 143, NULL, NULL, 170275),
(170276, '1.25.40.20-FF-001866', NULL, 'Kinase, NEK', 130, NULL, NULL, 170276),
(170277, '3.30.450.30-FF-000051', NULL, 'Uncharacterized protein', 121, NULL, NULL, 170277),
(170278, '1.10.286.30-FF-000001', NULL, 'Baseplate wedge completion tail pin', 63, NULL, NULL, 170278),
(170279, '1.10.287.110-FF-000084', NULL, 'chaperone protein dnaJ 8, chloroplastic', 89, NULL, NULL, 170279),
(170280, '2.10.25.10-FF-000847', NULL, 'Faulty attraction, isoform F', 39, NULL, NULL, 170280),
(170281, '2.60.120.970-FF-000116', NULL, 'Uncharacterized protein', 73, NULL, NULL, 170281),
(170282, '3.90.70.10-FF-000053', NULL, 'Ubiquitin carboxyl-terminal hydrolase 1', 275, NULL, NULL, 170282),
(170283, '3.40.50.11660-FF-000049', NULL, NULL, 103, NULL, NULL, 170283),
(170284, '3.50.50.60-FF-001153', NULL, 'Flavin-containing monooxygenase', 67, NULL, NULL, 170284),
(170285, '2.60.40.10-FF-002426', NULL, 'Immunoglobulin heavy variable V15-2', 107, NULL, NULL, 170285),
(170286, '1.25.10.10-FF-000900', NULL, 'Uncharacterized protein', 259, NULL, NULL, 170286),
(170287, '2.40.50.140-FF-001039', NULL, NULL, 135, NULL, NULL, 170287),
(170288, '1.20.1740.10-FF-000256', NULL, 'Uncharacterized protein', 275, NULL, NULL, 170288),
(170289, '3.40.50.300-FF-000673', NULL, 'Origin recognition complex subunit 5', 163, NULL, NULL, 170289);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(170290, '3.30.70.100-FF-000024', NULL, 'Mechanosensitive ion channel family protein', 88, NULL, NULL, 170290),
(170291, '1.20.1250.20-FF-001019', NULL, 'Uncharacterized protein', 196, NULL, NULL, 170291),
(170292, '1.10.10.10-FF-000220', NULL, 'SAM pointed domain-containing Ets transcription factor', 118, NULL, NULL, 170292),
(170293, '1.10.1040.30-FF-000008', NULL, 'Uncharacterized protein', 114, NULL, NULL, 170293),
(170294, '2.40.30.20-FF-000029', NULL, 'Riboflavin synthase alpha chain', 103, NULL, NULL, 170294),
(170295, '3.30.160.60-FF-005809', NULL, NULL, 36, NULL, NULL, 170295),
(170296, '1.25.40.70-FF-000021', NULL, 'PI-3 kinase', 206, NULL, NULL, 170296),
(170297, '1.10.238.10-FF-000704', NULL, 'Uncharacterized protein', 71, NULL, NULL, 170297),
(170298, '3.30.160.60-FF-005866', NULL, NULL, 54, NULL, NULL, 170298),
(170299, '3.40.50.720-FF-000529', NULL, 'Shikimate dehydrogenase (NADP(+))', 141, NULL, NULL, 170299),
(170300, '3.90.1200.10-FF-000057', NULL, 'Uncharacterized protein', 179, NULL, NULL, 170300),
(170301, '4.10.970.10-FF-000012', NULL, 'DNA binding protein', 73, NULL, NULL, 170301),
(170302, '2.30.29.30-FF-001272', NULL, 'PH domain-containing protein DDB_G0287875', 99, NULL, NULL, 170302),
(170303, '1.10.510.10-FF-003682', NULL, NULL, 171, NULL, NULL, 170303),
(170304, '3.50.30.30-FF-000119', NULL, 'Glr2658 protein', 122, NULL, NULL, 170304),
(170305, '1.20.920.10-FF-000187', NULL, 'Uncharacterized protein', 85, NULL, NULL, 170305),
(170306, '3.30.420.10-FF-000476', NULL, NULL, 110, NULL, NULL, 170306),
(170307, '2.60.120.200-FF-000498', NULL, 'Adhesion G protein-coupled receptor G6', 188, NULL, NULL, 170307),
(170308, '1.10.10.790-FF-000045', NULL, NULL, 96, NULL, NULL, 170308),
(170309, '3.50.80.20-FF-000002', NULL, 'D-alanyl-D-alanine carboxypeptidase dacB', 68, NULL, NULL, 170309),
(170310, '3.30.930.10-FF-000088', NULL, 'Proline--tRNA ligase', 117, NULL, NULL, 170310),
(170311, '1.25.40.10-FF-004325', NULL, 'Uncharacterized protein', 319, NULL, NULL, 170311),
(170312, '3.30.450.40-FF-000054', NULL, 'Diguanylate cyclase (GGDEF) domain protein', 167, NULL, NULL, 170312),
(170313, '3.30.565.10-FF-000036', NULL, 'Sensor histidine kinase YpdA', 147, NULL, NULL, 170313),
(170314, '3.80.10.10-FF-002129', NULL, 'Uncharacterized protein', 162, NULL, NULL, 170314),
(170315, '3.40.50.620-FF-000797', NULL, 'Uncharacterized protein', 202, NULL, NULL, 170315),
(170316, '1.10.510.10-FF-002400', NULL, 'CAMKK1 isoform 3', 267, NULL, NULL, 170316),
(170317, '3.30.70.1060-FF-000003', NULL, 'Possible muconolactone isomerase', 96, NULL, NULL, 170317),
(170318, '1.20.1070.10-FF-000547', NULL, 'urotensin-2 receptor-like', 313, NULL, NULL, 170318),
(170319, '3.40.50.1980-FF-000063', NULL, 'Periplasmic chelated iron-binding protein YfeA', 148, NULL, NULL, 170319),
(170320, '3.40.50.300-FF-004416', NULL, 'Ras-related protein Rab-1B', 177, NULL, NULL, 170320),
(170321, '3.30.2020.30-FF-000035', NULL, 'Uncharacterized protein', 67, NULL, NULL, 170321),
(170322, '3.30.70.1070-FF-000006', NULL, 'Cell division protein', 75, NULL, NULL, 170322),
(170323, '3.40.50.300-FF-000055', NULL, 'GTP-binding protein TypA', 197, NULL, NULL, 170323),
(170324, '3.40.50.300-FF-005698', NULL, 'Uncharacterized protein', 298, NULL, NULL, 170324),
(170325, '3.40.120.10-FF-000024', NULL, 'Phosphoglucosamine mutase', 151, NULL, NULL, 170325),
(170326, '2.130.10.10-FF-004759', NULL, 'Predicted protein', 157, NULL, NULL, 170326),
(170327, '1.25.10.10-FF-003065', NULL, 'Uncharacterized protein', 264, NULL, NULL, 170327),
(170328, '3.90.230.10-FF-000009', NULL, 'xaa-Pro aminopeptidase 2', 299, NULL, NULL, 170328),
(170329, '3.90.226.10-FF-000112', NULL, '6-oxocyclohex-1-ene-1-carbonyl-CoA hydrolase', 309, NULL, NULL, 170329),
(170330, '3.40.50.300-FF-002000', NULL, 'Putative heat shock protein', 305, NULL, NULL, 170330),
(170331, '1.50.40.10-FF-000282', NULL, 'Transporter of the mitochondrial inner membrane, putative', 182, NULL, NULL, 170331),
(170332, '1.10.437.10-FF-000015', NULL, 'BCL2 like 13', 206, NULL, NULL, 170332);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(170333, '3.20.70.20-FF-000008', NULL, 'Hypothetical formate acetyltransferase 3', 795, NULL, NULL, 170333),
(170334, '3.40.50.300-FF-002264', NULL, 'Clp1-related protein, putative', 251, NULL, NULL, 170334),
(170335, '3.30.160.60-FF-000313', NULL, 'Zinc finger protein 281', 27, NULL, NULL, 170335),
(170336, '3.40.50.300-FF-002207', NULL, 'ATP-dependent Clp protease, putative', 192, NULL, NULL, 170336),
(170337, '3.30.70.3400-FF-000020', NULL, 'Protein translocase subunit SecD', 75, NULL, NULL, 170337),
(170338, '2.170.150.80-FF-000025', NULL, 'NAC domain-containing protein 73', 154, NULL, NULL, 170338),
(170339, '1.10.1170.10-FF-000006', NULL, 'Baculoviral IAP repeat containing 2', 107, NULL, NULL, 170339),
(170340, '2.10.80.10-FF-000008', NULL, 'Dickkopf WNT-signaling pathway inhibitor 3a', 98, NULL, NULL, 170340),
(170341, '3.10.150.10-FF-000010', NULL, 'Proliferating cell nuclear antigen', 165, NULL, NULL, 170341),
(170342, '2.60.40.1120-FF-000032', NULL, 'Uncharacterized protein', 87, NULL, NULL, 170342),
(170343, '1.25.40.860-FF-000023', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 122, NULL, NULL, 170343),
(170344, '3.40.630.30-FF-000355', NULL, 'Histone acetyltransferase type B catalytic subunit', 133, NULL, NULL, 170344),
(170345, '1.20.58.60-FF-000575', NULL, 'Vab-10', 254, NULL, NULL, 170345),
(170346, '1.10.8.60-FF-000262', NULL, '26S protease regulatory subunit 6A', 83, NULL, NULL, 170346),
(170347, '3.30.450.210-FF-000002', NULL, 'Sensor protein CpxA', 128, NULL, NULL, 170347),
(170348, '3.40.50.300-FF-007643', NULL, 'Uncharacterized protein', 138, NULL, NULL, 170348),
(170349, '1.10.357.10-FF-000014', NULL, 'Transcriptional regulator, TetR family', 128, NULL, NULL, 170349),
(170350, '3.40.50.12650-FF-000037', NULL, 'Predicted protein', 114, NULL, NULL, 170350),
(170351, '3.40.950.10-FF-000036', NULL, NULL, 168, NULL, NULL, 170351),
(170352, '3.40.50.150-FF-000605', NULL, 'Os06g0322400 protein', 65, NULL, NULL, 170352),
(170353, '1.10.1200.10-FF-000061', NULL, 'Putative acyl carrier protein', 74, NULL, NULL, 170353),
(170354, '3.90.550.10-FF-000090', NULL, 'Alpha-1,3-mannosyl-glycoprotein 2-beta-N-acetylglucosaminyltransferase', 224, NULL, NULL, 170354),
(170355, '1.25.40.10-FF-001863', NULL, 'Coatomer subunit epsilon', 311, NULL, NULL, 170355),
(170356, '1.10.357.20-FF-000017', NULL, 'Solute carrier family 41 member 2', 149, NULL, NULL, 170356),
(170357, '1.20.990.10-FF-000045', NULL, 'Pyruvate:ferredoxin oxidoreductase/NADPH-cytochrome P450 reductase PNO', 134, NULL, NULL, 170357),
(170358, '1.20.1250.40-FF-000042', NULL, 'Uncharacterized protein', 123, NULL, NULL, 170358),
(170359, '3.40.50.1820-FF-001049', NULL, 'Uncharacterized protein', 470, NULL, NULL, 170359),
(170360, '3.80.30.20-FF-000020', NULL, 'tRNA 2-methylthioadenosine synthase', 239, NULL, NULL, 170360),
(170361, '3.80.10.10-FF-002747', NULL, 'Glucose-induced repressor, putative', 205, NULL, NULL, 170361),
(170362, '3.40.1190.20-FF-000148', NULL, 'Ribokinase', 306, NULL, NULL, 170362),
(170363, '1.10.20.10-FF-000221', NULL, NULL, 82, NULL, NULL, 170363),
(170364, '2.130.10.10-FF-000049', NULL, 'DDB1-and CUL4-associated factor 7', 334, NULL, NULL, 170364),
(170365, '3.90.550.10-FF-000174', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 117, NULL, NULL, 170365),
(170366, '2.40.50.140-FF-000758', NULL, NULL, 73, NULL, NULL, 170366),
(170367, '2.60.40.60-FF-000002', NULL, 'Protocadherin alpha 2', 109, NULL, NULL, 170367),
(170368, '3.30.40.10-FF-001380', NULL, 'DNA-binding E3 ubiquitin-protein ligase', 125, NULL, NULL, 170368),
(170369, '3.60.21.10-FF-000429', NULL, 'Uncharacterized protein', 252, NULL, NULL, 170369),
(170370, '2.60.40.730-FF-000001', NULL, 'Desulfoferrodoxin', 122, NULL, NULL, 170370),
(170371, '2.30.29.30-FF-000367', NULL, 'Neutral sphingomyelinase activation associated factor', 91, NULL, NULL, 170371),
(170372, '3.30.200.20-FF-001811', NULL, NULL, 127, NULL, NULL, 170372),
(170373, '3.30.40.10-FF-000918', NULL, 'E3 ubiquitin-protein ligase EL5', 81, NULL, NULL, 170373);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(170374, '3.30.450.20-FF-000368', NULL, 'Uncharacterized protein', 36, NULL, NULL, 170374),
(170375, '1.25.10.10-FF-000338', NULL, 'Anaphase-promoting complex subunit 1', 166, NULL, NULL, 170375),
(170376, '1.20.1250.20-FF-001076', NULL, 'Bypass of stop codon protein, putative', 210, NULL, NULL, 170376),
(170377, '1.25.40.10-FF-001947', NULL, 'Uncharacterized protein', 47, NULL, NULL, 170377),
(170378, '4.10.240.10-FF-000092', NULL, 'Aflatoxin regulatory protein', 37, NULL, NULL, 170378),
(170379, '2.60.120.10-FF-000372', NULL, 'Transcriptional regulator, Crp/Fnr family', 125, NULL, NULL, 170379),
(170380, '3.90.79.20-FF-000019', NULL, 'NUDIX hydrolase domain-like protein', 140, NULL, NULL, 170380),
(170381, '3.30.200.20-FF-001165', NULL, 'Kinase, AGC PKA', 107, NULL, NULL, 170381),
(170382, '4.10.280.10-FF-000156', NULL, 'Myogenic determination factor', 67, NULL, NULL, 170382),
(170383, '1.20.272.10-FF-000028', NULL, 'Replication factor C subunit 2/4', 93, NULL, NULL, 170383),
(170384, '3.40.50.1000-FF-000112', NULL, 'CTD small phosphatase-like protein 2', 201, NULL, NULL, 170384),
(170385, '3.40.50.1010-FF-000115', NULL, 'Mitotic control protein dis3', 184, NULL, NULL, 170385),
(170386, '3.30.70.330-FF-002987', NULL, NULL, 87, NULL, NULL, 170386),
(170387, '1.20.1250.10-FF-000084', NULL, NULL, 165, NULL, NULL, 170387),
(170388, '1.20.1720.10-FF-000047', NULL, 'Major facilitator superfamily (MFS) transporter', 225, NULL, NULL, 170388),
(170389, '3.40.50.450-FF-000044', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase', 279, NULL, NULL, 170389),
(170390, '3.30.160.60-FF-002084', NULL, 'RB-associated KRAB zinc finger protein-like', 32, NULL, NULL, 170390),
(170391, '1.25.40.180-FF-000156', NULL, 'MIF4G domain containing protein', 314, NULL, NULL, 170391),
(170392, '3.30.200.20-FF-000232', NULL, 'Serine/threonine-protein kinase pim-1', 102, NULL, NULL, 170392),
(170393, '1.10.1760.20-FF-000009', NULL, 'Riboflavin transporter', 198, NULL, NULL, 170393),
(170394, '3.90.470.20-FF-000030', NULL, '4''phosphopantetheinyl transferase superfamily protein', 86, NULL, NULL, 170394),
(170395, '1.20.5.340-FF-000051', NULL, 'Rabaptin, RAB GTPase binding effector protein 2', 58, NULL, NULL, 170395),
(170396, '1.25.40.10-FF-001419', NULL, 'Yop proteins translocation protein Y', 109, NULL, NULL, 170396),
(170397, '2.130.10.10-FF-000105', NULL, 'Protein HIRA', 107, NULL, NULL, 170397),
(170398, '1.10.1760.10-FF-000006', NULL, 'Uncharacterized protein', 163, NULL, NULL, 170398),
(170399, '1.20.1250.20-FF-000087', NULL, 'L-fucose:H+ symporter permease', 195, NULL, NULL, 170399),
(170400, '2.60.40.3170-FF-000006', NULL, 'Uncharacterized protein', 132, NULL, NULL, 170400),
(170401, '3.40.50.10090-FF-000039', NULL, 'Uroporphyrinogen-III C-methyltransferase', 123, NULL, NULL, 170401),
(170402, '3.30.70.330-FF-000896', NULL, 'RNA-binding protein with serine-rich domain 1 homolog', 138, NULL, NULL, 170402),
(170403, '2.10.290.10-FF-000001', NULL, 'PF07191 family protein', 71, NULL, NULL, 170403),
(170404, '3.60.130.10-FF-000071', NULL, 'Uncharacterized protein', 116, NULL, NULL, 170404),
(170405, '3.40.50.1820-FF-000824', NULL, 'Poly(3-hydroxyalkanoate) depolymerase', 119, NULL, NULL, 170405),
(170406, '1.10.510.10-FF-001557', NULL, 'Protein CBG13435', 337, NULL, NULL, 170406),
(170407, '1.20.1280.50-FF-000081', NULL, 'Unplaced genomic scaffold supercont1.10, whole genome shotgun sequence', 79, NULL, NULL, 170407),
(170408, '3.40.50.150-FF-001533', NULL, NULL, 97, NULL, NULL, 170408),
(170409, '2.130.10.10-FF-006035', NULL, 'Centriole proteome protein 16', 290, NULL, NULL, 170409),
(170410, '3.40.50.300-FF-003484', NULL, 'Dynamin central region family protein', 302, NULL, NULL, 170410),
(170411, '2.60.40.10-FF-003646', NULL, 'GM20392', 120, NULL, NULL, 170411),
(170412, '2.60.40.10-FF-000127', NULL, 'titin isoform X1', 100, NULL, NULL, 170412),
(170413, '1.10.10.60-FF-000038', NULL, 'Homeobox-containing protein 1 isoform X2', 72, NULL, NULL, 170413),
(170414, '3.20.20.190-FF-000155', NULL, NULL, 214, NULL, NULL, 170414);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(170415, '3.40.50.300-FF-002702', NULL, 'Ras-related protein RABA5d', 193, NULL, NULL, 170415),
(170416, '3.30.160.270-FF-000010', NULL, '2-isopropylmalate synthase', 108, NULL, NULL, 170416),
(170417, '2.10.220.10-FF-000053', NULL, 'Proprotein convertase subtilisin/kexin type 5', 101, NULL, NULL, 170417),
(170418, '1.10.3810.10-FF-000028', NULL, 'Penicillin binding protein transpeptidase, putative', 139, NULL, NULL, 170418),
(170419, '3.30.160.60-FF-006355', NULL, NULL, 50, NULL, NULL, 170419),
(170420, '2.130.10.10-FF-001679', NULL, 'Uncharacterized protein', 206, NULL, NULL, 170420),
(170421, '1.50.40.10-FF-000338', NULL, 'Carnitine-acylcarnitine carrier protein, putative', 170, NULL, NULL, 170421),
(170422, '1.20.58.60-FF-000783', NULL, 'Dystonin', 221, NULL, NULL, 170422),
(170423, '3.40.50.150-FF-001477', NULL, NULL, 129, NULL, NULL, 170423),
(170424, '1.10.10.60-FF-001292', NULL, NULL, 34, NULL, NULL, 170424),
(170425, '1.25.40.470-FF-000029', NULL, 'Intraflagellar transport protein 122', 149, NULL, NULL, 170425),
(170426, '3.30.1370.210-FF-000038', NULL, 'Uncharacterized protein', 56, NULL, NULL, 170426),
(170427, '2.10.25.10-FF-001426', NULL, 'Multiple epidermal growth factor-like domains protein 8', 53, NULL, NULL, 170427),
(170428, '2.60.40.10-FF-001555', NULL, 'Protein tyrosine phosphatase, receptor type Q', 96, NULL, NULL, 170428),
(170429, '1.10.10.41-FF-000005', NULL, NULL, 87, NULL, NULL, 170429),
(170430, '1.10.10.10-FF-001647', NULL, 'Ferric uptake regulation protein', 80, NULL, NULL, 170430),
(170431, '1.20.1640.10-FF-000046', NULL, 'Multidrug transporter AcrB', 211, NULL, NULL, 170431),
(170432, '3.80.10.10-FF-000656', NULL, 'CG12283', 121, NULL, NULL, 170432),
(170433, '1.10.630.10-FF-000195', NULL, 'Putative cytochrome P450 136', 441, NULL, NULL, 170433),
(170434, '1.25.40.20-FF-000169', NULL, 'Cyclin-dependent kinase 4 inhibitor D', 161, NULL, NULL, 170434),
(170435, '2.40.30.10-FF-000116', NULL, 'Elongation factor Tu', 56, NULL, NULL, 170435),
(170436, '3.90.79.10-FF-000016', NULL, 'ADP-sugar pyrophosphatase isoform X1', 208, NULL, NULL, 170436),
(170437, '1.20.1280.50-FF-000018', NULL, 'F-box/LRR-repeat protein 7 isoform X2', 49, NULL, NULL, 170437),
(170438, '1.20.940.10-FF-000008', NULL, 'Related to potassium channel regulatory factor', 175, NULL, NULL, 170438),
(170439, '1.20.1270.60-FF-000049', NULL, 'Sorting nexin 8', 230, NULL, NULL, 170439),
(170440, '3.30.160.60-FF-004231', NULL, NULL, 23, NULL, NULL, 170440),
(170441, '2.40.70.10-FF-000411', NULL, NULL, 107, NULL, NULL, 170441),
(170442, '2.60.40.10-FF-002016', NULL, 'Immunoglobulin heavy constant alpha 2', 99, NULL, NULL, 170442),
(170443, '4.10.280.10-FF-000212', NULL, 'Transcription factor DYT1', 87, NULL, NULL, 170443),
(170444, '3.30.160.60-FF-002140', NULL, 'paternally-expressed gene 3 protein', 32, NULL, NULL, 170444),
(170445, '3.50.50.60-FF-001035', NULL, 'Probable lysine-specific histone demethylase 1', 81, NULL, NULL, 170445),
(170446, '3.40.50.720-FF-001108', NULL, 'Alanine dehydrogenase, truncation', 13, NULL, NULL, 170446),
(170447, '3.60.20.10-FF-000175', NULL, NULL, 190, NULL, NULL, 170447),
(170448, '3.30.70.1730-FF-000047', NULL, '50S ribosomal protein L10', 130, NULL, NULL, 170448),
(170449, '3.40.50.300-FF-002500', NULL, 'Ras-related protein Rap-2a', 105, NULL, NULL, 170449),
(170450, '3.40.50.1820-FF-000768', NULL, 'Serine hydrolase-like protein', 289, NULL, NULL, 170450),
(170451, '2.130.10.10-FF-003394', NULL, 'Uncharacterized protein', 211, NULL, NULL, 170451),
(170452, '3.40.50.300-FF-006125', NULL, 'Retrovirus-related Pol polyprotein LINE-1', 157, NULL, NULL, 170452),
(170453, '2.40.30.10-FF-000291', NULL, 'Mitochondrial tRNA-specific 2-thiouridylase 1', 93, NULL, NULL, 170453),
(170454, '3.30.460.10-FF-000186', NULL, 'Uncharacterized protein', 28, NULL, NULL, 170454),
(170455, '3.60.21.10-FF-000053', NULL, 'Serine/threonine-protein phosphatase', 427, NULL, NULL, 170455),
(170456, '1.10.510.10-FF-001883', NULL, 'Related to yeast Vacuolar Protein Sorting factor', 229, NULL, NULL, 170456);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(170457, '1.20.58.340-FF-000056', NULL, 'Mitochondrial inner membrane magnesium transporter LPE10', 174, NULL, NULL, 170457),
(170458, '3.80.10.10-FF-002545', NULL, 'Ubiquitin-like domain containing protein, putative', 157, NULL, NULL, 170458),
(170459, '3.30.160.60-FF-001948', NULL, 'zinc finger and BTB domain-containing protein 1', 26, NULL, NULL, 170459),
(170460, '3.30.450.20-FF-000694', NULL, 'Diguanylate cyclase with PAS sensory domain', 125, NULL, NULL, 170460),
(170461, '1.25.40.10-FF-002201', NULL, 'Predicted protein', 147, NULL, NULL, 170461),
(170462, '1.10.565.10-FF-000099', NULL, 'Nuclear hormone receptor family member nhr-6', 181, NULL, NULL, 170462),
(170463, '1.10.720.30-FF-000028', NULL, 'Myocardin-related transcription factor, isoform D', 67, NULL, NULL, 170463),
(170464, '3.30.200.20-FF-002469', NULL, 'Uncharacterized protein', 49, NULL, NULL, 170464),
(170465, '2.60.40.420-FF-000167', NULL, 'Coagulation factor V', 93, NULL, NULL, 170465),
(170466, '3.40.960.10-FF-000008', NULL, 'DEAD/DEAH box helicase domain protein', 93, NULL, NULL, 170466),
(170467, '3.40.980.10-FF-000015', NULL, 'Molybdopterin molybdenumtransferase', 153, NULL, NULL, 170467),
(170468, '1.20.120.1750-FF-000125', NULL, 'Uncharacterized protein', 107, NULL, NULL, 170468),
(170469, '3.90.228.10-FF-000009', NULL, 'Poly [ADP-ribose] polymerase', 210, NULL, NULL, 170469),
(170470, '3.40.50.2300-FF-001654', NULL, NULL, 199, NULL, NULL, 170470),
(170471, '3.30.2010.30-FF-000001', NULL, 'Leukotriene A(4) hydrolase', 98, NULL, NULL, 170471),
(170472, '1.20.5.110-FF-000038', NULL, 'BET1-like protein isoform X2', 64, NULL, NULL, 170472),
(170473, '2.60.120.970-FF-000060', NULL, 'Bone morphogenetic protein 4', 242, NULL, NULL, 170473),
(170474, '1.10.287.600-FF-000017', NULL, 'Tubulin beta chain', 61, NULL, NULL, 170474),
(170475, '3.30.160.60-FF-000195', NULL, 'Hypermethylated in cancer 1 protein-like', 27, NULL, NULL, 170475),
(170476, '2.60.120.200-FF-000767', NULL, 'Calciumbinding protein Calnexin family protein', 68, NULL, NULL, 170476),
(170477, '2.60.40.10-FF-005563', NULL, NULL, 110, NULL, NULL, 170477),
(170478, '3.40.50.300-FF-007227', NULL, 'Predicted protein', 163, NULL, NULL, 170478),
(170479, '1.20.5.100-FF-000035', NULL, 'Uncharacterized protein', 43, NULL, NULL, 170479),
(170480, '2.40.50.140-FF-000022', NULL, 'DNA helicase', 76, NULL, NULL, 170480),
(170481, '3.30.70.1620-FF-000014', NULL, 'Chromosome partition protein Smc', 84, NULL, NULL, 170481),
(170482, '1.10.8.60-FF-000346', NULL, 'Predicted protein', 82, NULL, NULL, 170482),
(170483, '1.10.533.10-FF-000143', NULL, 'Caspase 8, apoptosis-related cysteine peptidase,-like 2', 89, NULL, NULL, 170483),
(170484, '1.10.510.10-FF-003974', NULL, NULL, 332, NULL, NULL, 170484),
(170485, '1.10.287.70-FF-000397', NULL, 'Predicted protein', 125, NULL, NULL, 170485),
(170486, '1.25.40.10-FF-002083', NULL, 'Pentatricopeptide repeat-containing protein At3g16010', 63, NULL, NULL, 170486),
(170487, '1.20.1070.10-FF-000991', NULL, 'Uncharacterized protein', 315, NULL, NULL, 170487),
(170488, '3.70.10.10-FF-000123', NULL, 'Uncharacterized protein', 153, NULL, NULL, 170488),
(170489, '3.40.50.720-FF-001434', NULL, 'Chorismate mutase', 165, NULL, NULL, 170489),
(170490, '1.25.40.20-FF-000113', NULL, 'E3 ubiquitin-protein ligase mib1 isoform X3', 128, NULL, NULL, 170490),
(170491, '2.60.120.620-FF-000157', NULL, 'Predicted protein', 202, NULL, NULL, 170491),
(170492, '4.10.410.10-FF-000066', NULL, 'Predicted protein', 52, NULL, NULL, 170492),
(170493, '2.130.10.10-FF-000375', NULL, 'Sortilin', 176, NULL, NULL, 170493),
(170494, '3.20.20.190-FF-000099', NULL, NULL, 249, NULL, NULL, 170494),
(170495, '3.30.160.60-FF-003921', NULL, 'AGAP001525-PA', 60, NULL, NULL, 170495),
(170496, '3.80.10.10-FF-003034', NULL, 'Antagonist of mitotic exit network 1 homolog', 166, NULL, NULL, 170496),
(170497, '2.60.120.290-FF-000070', NULL, 'Suppression of tumorigenicity 14b', 113, NULL, NULL, 170497),
(170498, '3.40.50.1000-FF-000258', NULL, 'YER134C-like protein', 176, NULL, NULL, 170498);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(170499, '3.30.870.10-FF-000060', NULL, 'Phospholipase', 127, NULL, NULL, 170499),
(170500, '3.40.190.80-FF-000009', NULL, 'Fructose-1,6-bisphosphatase, chloroplastic', 137, NULL, NULL, 170500),
(170501, '2.60.40.10-FF-000251', NULL, 'Tyrosine-protein kinase receptor', 91, NULL, NULL, 170501),
(170502, '3.10.20.30-FF-000031', NULL, 'Mitochondrial ribosomal protein L39', 64, NULL, NULL, 170502),
(170503, '3.90.650.10-FF-000058', NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase (AIRS) (PurM)', 157, NULL, NULL, 170503),
(170504, '2.10.90.10-FF-000043', NULL, 'Neurotrophin 1, isoform A', 103, NULL, NULL, 170504),
(170505, '3.30.420.40-FF-000136', NULL, 'Putative fructokinase', 189, NULL, NULL, 170505),
(170506, '2.130.10.10-FF-003450', NULL, 'Prp-8', 128, NULL, NULL, 170506),
(170507, '3.30.160.60-FF-006029', NULL, NULL, 26, NULL, NULL, 170507),
(170508, '2.60.120.10-FF-000107', NULL, 'Potassium voltage-gated channel unc-103', 164, NULL, NULL, 170508),
(170509, '3.40.30.10-FF-000283', NULL, 'Glutathione peroxidase', 198, NULL, NULL, 170509),
(170510, '1.20.120.1880-FF-000018', NULL, 'Nucleoporin 155', 80, NULL, NULL, 170510),
(170511, '1.10.10.10-FF-000012', NULL, 'U5 small nuclear ribonucleoprotein helicase', 95, NULL, NULL, 170511),
(170512, '1.10.10.60-FF-000364', NULL, 'Propionate catabolism operon regulatory protein PrpR', 31, NULL, NULL, 170512),
(170513, '1.25.40.10-FF-001099', NULL, 'Pentatricopeptide repeat-containing protein', 168, NULL, NULL, 170513),
(170514, '1.25.40.10-FF-003662', NULL, 'Uncharacterized protein', 188, NULL, NULL, 170514),
(170515, '1.20.58.200-FF-000008', NULL, NULL, 75, NULL, NULL, 170515),
(170516, '1.10.287.130-FF-000270', NULL, 'Sensory histidine protein kinase', 57, NULL, NULL, 170516),
(170517, '3.10.50.40-FF-000036', NULL, 'Peptidylprolyl isomerase', 164, NULL, NULL, 170517),
(170518, '1.20.1070.10-FF-000839', NULL, 'Purinergic receptor P2Y14', 295, NULL, NULL, 170518),
(170519, '1.20.5.1430-FF-000016', NULL, 'Actin binding protein', 79, NULL, NULL, 170519),
(170520, '3.30.160.60-FF-006153', NULL, NULL, 30, NULL, NULL, 170520),
(170521, '1.10.555.10-FF-000183', NULL, NULL, 174, NULL, NULL, 170521),
(170522, '1.10.1040.10-FF-000115', NULL, 'Uncharacterized protein', 43, NULL, NULL, 170522),
(170523, '3.15.10.10-FF-000019', NULL, 'Uncharacterized protein', 159, NULL, NULL, 170523),
(170524, '3.30.70.660-FF-000085', NULL, 'Uncharacterized protein', 102, NULL, NULL, 170524),
(170525, '3.40.50.1820-FF-001134', NULL, 'Carboxylic ester hydrolase', 267, NULL, NULL, 170525),
(170526, '3.30.1240.10-FF-000068', NULL, 'Uncharacterized hydrolase C215.10', 115, NULL, NULL, 170526),
(170527, '3.30.40.100-FF-000012', NULL, 'Uncharacterized protein', 58, NULL, NULL, 170527),
(170528, '1.25.10.10-FF-001917', NULL, 'DDB1- and CUL4-associated factor homolog 1', 393, NULL, NULL, 170528),
(170529, '3.30.830.10-FF-000260', NULL, 'Uncharacterized protein', 70, NULL, NULL, 170529),
(170530, '1.10.10.10-FF-002103', NULL, 'Uncharacterized protein', 85, NULL, NULL, 170530),
(170531, '3.30.160.60-FF-001297', NULL, 'Zinc finger and SCAN domain-containing protein 2', 28, NULL, NULL, 170531),
(170532, '1.10.150.110-FF-000028', NULL, 'Uncharacterized protein', 64, NULL, NULL, 170532),
(170533, '3.30.420.40-FF-000226', NULL, 'Chromatin remodeling complex subunit (Arp9), putative', 76, NULL, NULL, 170533),
(170534, '3.90.190.10-FF-000039', NULL, 'receptor-type tyrosine-protein phosphatase O isoform X1', 296, NULL, NULL, 170534),
(170535, '2.40.50.150-FF-000025', NULL, 'GH25170', 21, NULL, NULL, 170535),
(170536, '2.170.270.10-FF-000120', NULL, 'Predicted protein', 190, NULL, NULL, 170536),
(170537, '1.10.150.240-FF-000106', NULL, 'Putative beta-phosphoglucomutase', 77, NULL, NULL, 170537),
(170538, '1.20.1440.100-FF-000001', NULL, 'Inhibition of morphological differentiation protein', 76, NULL, NULL, 170538),
(170539, '2.60.40.740-FF-000004', NULL, 'Collagen adhesin', 168, NULL, NULL, 170539),
(170540, '3.40.50.300-FF-000229', NULL, 'Probable Ras-related protein Rab-6A', 194, NULL, NULL, 170540);
INSERT INTO "PUBLIC"."MODEL" VALUES
(170541, '1.10.287.1490-FF-000043', NULL, 'WH2 motif domain contaning, putative', 165, NULL, NULL, 170541),
(170542, '1.10.167.10-FF-000062', NULL, 'Uncharacterized protein', 208, NULL, NULL, 170542),
(170543, '3.10.20.310-FF-000019', NULL, 'Protein TOC75-3, chloroplastic isoform A', 76, NULL, NULL, 170543),
(170544, '1.10.3500.10-FF-000016', NULL, 'Transcription accessory protein (S1 RNA-binding domain)', 151, NULL, NULL, 170544),
(170545, '3.30.870.10-FF-000150', NULL, 'Uncharacterized protein', 181, NULL, NULL, 170545),
(170546, '3.40.30.10-FF-000603', NULL, 'Glutathione S-transferase Mu 1', 112, NULL, NULL, 170546),
(170547, '1.25.10.10-FF-003357', NULL, 'Uncharacterized protein', 193, NULL, NULL, 170547),
(170548, '1.10.510.10-FF-002344', NULL, NULL, 248, NULL, NULL, 170548),
(170549, '3.30.930.10-FF-000144', NULL, 'Octanoyltransferase', 228, NULL, NULL, 170549),
(170550, '1.10.132.130-FF-000003', NULL, 'Legumain', 127, NULL, NULL, 170550),
(170551, '3.30.30.170-FF-000008', NULL, NULL, 132, NULL, NULL, 170551),
(170552, '1.25.10.10-FF-001266', NULL, 'Pumilio/PUF RNA binding protein 8, putative', 192, NULL, NULL, 170552),
(170553, '3.40.850.10-FF-000388', NULL, 'Kinesin-like protein', 298, NULL, NULL, 170553),
(170554, '2.10.25.10-FF-000639', NULL, 'Notch 2', 38, NULL, NULL, 170554),
(170555, '3.30.40.10-FF-001554', NULL, 'RING/U-box superfamily protein', 48, NULL, NULL, 170555),
(170556, '3.30.565.10-FF-000070', NULL, 'Sensor histidine kinase RstB', 144, NULL, NULL, 170556),
(170557, '1.20.1250.20-FF-001020', NULL, 'AFR578Cp', 431, NULL, NULL, 170557),
(170558, '2.130.10.10-FF-002320', NULL, 'Protein CBG05554', 145, NULL, NULL, 170558),
(170559, '1.20.140.10-FF-000149', NULL, 'Uncharacterized protein', 89, NULL, NULL, 170559),
(170560, '1.10.510.10-FF-004137', NULL, NULL, 75, NULL, NULL, 170560),
(170561, '3.40.50.300-FF-003809', NULL, 'Dynein heavy chain 5, axonemal', 162, NULL, NULL, 170561),
(170562, '3.30.710.10-FF-000077', NULL, 'transcriptional regulator Kaiso isoform X1', 115, NULL, NULL, 170562),
(170563, '3.30.160.60-FF-001976', NULL, 'Klumpfuss, isoform B', 32, NULL, NULL, 170563),
(170564, '1.20.1250.20-FF-000738', NULL, 'Azole resistance protein', 193, NULL, NULL, 170564),
(170565, '3.40.50.300-FF-004271', NULL, 'X-ray repair-complementing defective repair in Chinese hamster cells 3', 263, NULL, NULL, 170565),
(170566, '2.130.10.10-FF-003596', NULL, 'GATOR complex protein MIOS', 277, NULL, NULL, 170566),
(170567, '2.170.270.10-FF-000092', NULL, 'Pleiomorphic adenoma gene-like 1', 171, NULL, NULL, 170567),
(170568, '3.40.50.1780-FF-000031', NULL, 'Cytosolic Fe-S cluster assembly factor NAR1 homolog', 111, NULL, NULL, 170568),
(170569, '3.30.160.60-FF-000700', NULL, 'zinc finger protein 346 isoform X1', 54, NULL, NULL, 170569),
(170570, '3.30.70.270-FF-000294', NULL, NULL, 67, NULL, NULL, 170570),
(170571, '3.80.10.10-FF-002871', NULL, 'YALI0A17358p', 138, NULL, NULL, 170571),
(170572, '2.20.25.100-FF-000006', NULL, '30S ribosomal protein S27e', 57, NULL, NULL, 170572),
(170573, '3.40.140.10-FF-000210', NULL, 'Uncharacterized protein', 141, NULL, NULL, 170573),
(170574, '3.30.1330.30-FF-000081', NULL, 'TrmH family tRNA/rRNA methyltransferase YacO', 71, NULL, NULL, 170574),
(170575, '3.90.660.10-FF-000093', NULL, NULL, 188, NULL, NULL, 170575),
(170576, '2.30.30.40-FF-000148', NULL, 'Caspase recruitment domain family member 11', 111, NULL, NULL, 170576),
(170577, '3.30.30.30-FF-000014', NULL, 'Chaperone protein DnaK', 16, NULL, NULL, 170577),
(170578, '3.40.50.880-FF-000150', NULL, 'GMP synthase [glutamine-hydrolyzing] subunit A', 188, NULL, NULL, 170578),
(170579, '3.40.980.10-FF-000010', NULL, 'Phosphoadenosine phosphosulfate reductase family protein', 160, NULL, NULL, 170579),
(170580, '3.30.2010.30-FF-000006', NULL, 'Aminopeptidase O', 98, NULL, NULL, 170580),
(170581, '3.40.50.1100-FF-000086', NULL, 'Related to CYS4-cystathionine beta-synthase', 47, NULL, NULL, 170581),
(170582, '3.40.50.2300-FF-000103', NULL, 'DNA-binding response regulator PrrA', 83, NULL, NULL, 170582);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(170583, '3.40.50.300-FF-000465', NULL, 'ATP-binding cassette, sub-family A (ABC1), member 3', 245, NULL, NULL, 170583),
(170584, '2.30.29.30-FF-000491', NULL, 'Stress-activated map kinase interacting 1', 114, NULL, NULL, 170584),
(170585, '2.40.240.10-FF-000014', NULL, 'bifunctional glutamate/proline--tRNA ligase', 102, NULL, NULL, 170585),
(170586, '3.40.50.300-FF-008542', NULL, 'DNA mismatch repair protein', 283, NULL, NULL, 170586),
(170587, '1.20.1310.10-FF-000055', NULL, 'Cullin family protein', 111, NULL, NULL, 170587),
(170588, '3.30.499.10-FF-000005', NULL, 'cytoplasmic aconitate hydratase', 224, NULL, NULL, 170588),
(170589, '2.30.180.10-FF-000005', NULL, 'Stabilin 2', 137, NULL, NULL, 170589),
(170590, '1.25.40.10-FF-002111', NULL, 'Pentatricopeptide (PPR) repeat-containing protein-like', 100, NULL, NULL, 170590),
(170591, '3.40.50.1110-FF-000089', NULL, 'Uncharacterized protein', 287, NULL, NULL, 170591),
(170592, '3.30.70.2820-FF-000003', NULL, 'DNA polymerase', 115, NULL, NULL, 170592),
(170593, '1.10.510.10-FF-001973', NULL, NULL, 119, NULL, NULL, 170593),
(170594, '3.90.25.10-FF-000095', NULL, 'NmrA-like family domain-containing protein 1', 37, NULL, NULL, 170594),
(170595, '3.80.10.10-FF-001112', NULL, 'Leucine rich repeat protein phosphatase 2c domain containing protein', 86, NULL, NULL, 170595),
(170596, '2.130.10.10-FF-000521', NULL, 'syntaxin-binding protein 5-like isoform X1', 265, NULL, NULL, 170596),
(170597, '3.30.160.60-FF-003775', NULL, NULL, 27, NULL, NULL, 170597),
(170598, '3.20.20.100-FF-000168', NULL, 'Uncharacterized protein', 183, NULL, NULL, 170598),
(170599, '1.10.510.10-FF-000394', NULL, 'Serine/threonine-protein kinase HSL1', 367, NULL, NULL, 170599),
(170600, '2.40.30.330-FF-000007', NULL, 'Protein CLP1 homolog', 121, NULL, NULL, 170600),
(170601, '1.10.10.10-FF-001737', NULL, 'ATP-dependent DNA helicase, RecQ family', 136, NULL, NULL, 170601),
(170602, '3.10.110.10-FF-000120', NULL, 'Ubiquitin-conjugating enzyme E2 E3', 160, NULL, NULL, 170602),
(170603, '1.10.287.2210-FF-000001', NULL, 'BLM10p Proteasome activator', 76, NULL, NULL, 170603),
(170604, '6.10.20.180-FF-000002', NULL, 'Uncharacterized protein', 79, NULL, NULL, 170604),
(170605, '3.30.70.1230-FF-000195', NULL, 'Predicted protein', 134, NULL, NULL, 170605),
(170606, '3.30.200.20-FF-001160', NULL, 'Cyclin-dependent kinase 4 homolog', 93, NULL, NULL, 170606),
(170607, '1.20.1310.20-FF-000058', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 195, NULL, NULL, 170607),
(170608, '1.10.10.60-FF-000510', NULL, 'Pdc2p', 61, NULL, NULL, 170608),
(170609, '1.10.150.50-FF-000136', NULL, 'Protein VTS1', 79, NULL, NULL, 170609),
(170610, '1.25.40.10-FF-003572', NULL, 'protein RRP5 homolog isoform X1', 198, NULL, NULL, 170610),
(170611, '4.10.640.10-FF-000021', NULL, 'Mitochondrial Ribosomal Protein, Small', 63, NULL, NULL, 170611),
(170612, '1.10.580.10-FF-000016', NULL, 'Citrate synthase', 224, NULL, NULL, 170612),
(170613, '1.10.3720.10-FF-000055', NULL, 'ABC transporter, permease component', 200, NULL, NULL, 170613),
(170614, '1.10.8.720-FF-000043', NULL, 'Dynein heavy chain, cytosolic, putative', 169, NULL, NULL, 170614),
(170615, '3.30.60.90-FF-000045', NULL, 'At2g17740', 55, NULL, NULL, 170615),
(170616, '1.10.357.120-FF-000013', NULL, 'DNA-directed RNA polymerase subunit', 133, NULL, NULL, 170616),
(170617, '1.25.10.10-FF-002255', NULL, 'Uncharacterized protein', 361, NULL, NULL, 170617),
(170618, '1.20.1340.10-FF-000001', NULL, 'Histidine decarboxylase', 81, NULL, NULL, 170618),
(170619, '3.30.1360.120-FF-000104', NULL, 'Putative transferase caf17, mitochondrial', 160, NULL, NULL, 170619),
(170620, '2.130.10.10-FF-003781', NULL, 'Predicted protein', 316, NULL, NULL, 170620),
(170621, '3.40.50.1820-FF-000594', NULL, 'Putative phospholipase', 411, NULL, NULL, 170621),
(170622, '3.30.160.60-FF-003247', NULL, NULL, 60, NULL, NULL, 170622),
(170623, '3.30.1490.180-FF-000027', NULL, 'Putative rna polymerase iii large subunit', 75, NULL, NULL, 170623),
(170624, '1.25.40.300-FF-000001', NULL, 'SPI-1 type III secretion system effector HECT-type E3 ubiquitin transferase SopA', 195, NULL, NULL, 170624);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(170625, '2.60.40.10-FF-003472', NULL, NULL, 125, NULL, NULL, 170625),
(170626, '1.10.287.70-FF-000690', NULL, 'Uncharacterized protein', 74, NULL, NULL, 170626),
(170627, '2.30.140.10-FF-000003', NULL, 'Spermidine synthase 1', 74, NULL, NULL, 170627),
(170628, '3.30.160.60-FF-000515', NULL, 'early growth response protein 4', 94, NULL, NULL, 170628),
(170629, '3.30.930.10-FF-000149', NULL, 'Lysine--tRNA ligase', 374, NULL, NULL, 170629),
(170630, '2.40.170.20-FF-000022', NULL, 'TonB-dependent heme receptor HutR', 548, NULL, NULL, 170630),
(170631, '3.40.630.30-FF-000563', NULL, 'Putative increased recombination centers protein 11', 121, NULL, NULL, 170631),
(170632, '1.50.40.10-FF-000248', NULL, 'Mitochondrial phosphate carrier protein 1, mitochondrial', 159, NULL, NULL, 170632),
(170633, '3.40.50.300-FF-002472', NULL, 'Midasin', 181, NULL, NULL, 170633),
(170634, '3.10.20.90-FF-000532', NULL, 'Auxin-responsive protein', 95, NULL, NULL, 170634),
(170635, '3.10.290.70-FF-000015', NULL, NULL, 101, NULL, NULL, 170635),
(170636, '1.50.40.10-FF-000490', NULL, 'Uncharacterized protein', 275, NULL, NULL, 170636),
(170637, '3.90.550.10-FF-000590', NULL, 'Uncharacterized protein', 234, NULL, NULL, 170637),
(170638, '3.40.50.10330-FF-000044', NULL, 'Long-chain base (LCB) kinase 1', 132, NULL, NULL, 170638),
(170639, '3.30.70.1320-FF-000014', NULL, 'Efflux pump membrane transporter', 100, NULL, NULL, 170639),
(170640, '2.20.50.20-FF-000015', NULL, 'Uncharacterized protein', 118, NULL, NULL, 170640),
(170641, '3.30.70.1230-FF-000285', NULL, 'Guanylate cyclase', 222, NULL, NULL, 170641),
(170642, '1.50.10.10-FF-000185', NULL, 'Uncharacterized protein', 319, NULL, NULL, 170642),
(170643, '1.10.630.10-FF-000515', NULL, 'Uncharacterized protein', 414, NULL, NULL, 170643),
(170644, '3.40.50.1100-FF-000142', NULL, 'Uncharacterized protein', 87, NULL, NULL, 170644),
(170645, '3.40.50.2000-FF-000547', NULL, 'UDP-glucuronosyltransferase', 206, NULL, NULL, 170645),
(170646, '1.20.5.110-FF-000274', NULL, 'Qc-SNARE SYP6-like protein', 60, NULL, NULL, 170646),
(170647, '3.40.50.1110-FF-000145', NULL, 'Uncharacterized protein', 172, NULL, NULL, 170647),
(170648, '3.30.160.60-FF-002314', NULL, 'E3 ubiquitin/ISG15 ligase TRIM25', 69, NULL, NULL, 170648),
(170649, '3.30.230.10-FF-000377', NULL, 'Uncharacterized protein', 177, NULL, NULL, 170649),
(170650, '1.10.510.10-FF-003738', NULL, NULL, 149, NULL, NULL, 170650),
(170651, '3.60.10.10-FF-000264', NULL, 'Uncharacterized protein', 150, NULL, NULL, 170651),
(170652, '3.30.70.80-FF-000014', NULL, 'Epidermin leader peptide processing serine protease EpiP', 66, NULL, NULL, 170652),
(170653, '3.40.50.1260-FF-000055', NULL, 'Phosphoglycerate kinase', 54, NULL, NULL, 170653),
(170654, '3.30.40.10-FF-001470', NULL, 'PHD finger protein 10', 188, NULL, NULL, 170654),
(170655, '3.60.110.10-FF-000069', NULL, 'Carbon-nitrogen hydrolase', 305, NULL, NULL, 170655),
(170656, '3.30.160.60-FF-004354', NULL, NULL, 46, NULL, NULL, 170656),
(170657, '2.30.110.10-FF-000057', NULL, 'Uncharacterized protein', 148, NULL, NULL, 170657),
(170658, '1.25.40.20-FF-001748', NULL, 'Uncharacterized protein', 207, NULL, NULL, 170658),
(170659, '1.20.1250.40-FF-000008', NULL, 'RNA polymerase II, Rpb4, core protein', 116, NULL, NULL, 170659),
(170660, '2.40.30.70-FF-000022', NULL, 'Predicted protein', 41, NULL, NULL, 170660),
(170661, '1.10.10.440-FF-000047', NULL, 'TransCription Elongation Regulator homolog', 56, NULL, NULL, 170661),
(170662, '3.40.1190.20-FF-000238', NULL, NULL, 111, NULL, NULL, 170662),
(170663, '1.10.472.80-FF-000117', NULL, 'Rab GTPase activating protein, putative', 119, NULL, NULL, 170663),
(170664, '3.10.250.10-FF-000135', NULL, NULL, 59, NULL, NULL, 170664),
(170665, '4.10.400.10-FF-000306', NULL, 'Uncharacterized protein', 48, NULL, NULL, 170665),
(170666, '1.10.565.10-FF-000155', NULL, 'Uncharacterized protein', 222, NULL, NULL, 170666),
(170667, '3.50.30.30-FF-000148', NULL, 'Predicted protein', 132, NULL, NULL, 170667),
(170668, '1.10.1070.11-FF-000101', NULL, 'Uncharacterized protein', 175, NULL, NULL, 170668);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(170669, '1.20.1460.10-FF-000004', NULL, 'V-type proton ATPase subunit C', 155, NULL, NULL, 170669),
(170670, '3.90.1150.10-FF-000120', NULL, 'Serine hydroxymethyltransferase', 177, NULL, NULL, 170670),
(170671, '3.90.70.10-FF-000822', NULL, 'Uncharacterized protein', 177, NULL, NULL, 170671),
(170672, '1.25.40.10-FF-000166', NULL, 'Cartilage associated protein', 154, NULL, NULL, 170672),
(170673, '3.30.40.10-FF-001228', NULL, 'E3 ubiquitin-protein ligase hrd-like protein 1', 63, NULL, NULL, 170673),
(170674, '1.25.40.10-FF-001745', NULL, 'Uncharacterized protein', 51, NULL, NULL, 170674),
(170675, '3.30.70.100-FF-000142', NULL, NULL, 96, NULL, NULL, 170675),
(170676, '2.130.10.10-FF-002292', NULL, 'Lambda-carrageenase', 197, NULL, NULL, 170676),
(170677, '2.130.10.10-FF-004118', NULL, 'Uncharacterized protein', 189, NULL, NULL, 170677),
(170678, '3.20.20.10-FF-000058', NULL, 'Alanine racemase', 214, NULL, NULL, 170678),
(170679, '3.30.70.2190-FF-000011', NULL, 'Oxidoreductase', 119, NULL, NULL, 170679),
(170680, '3.40.50.300-FF-000611', NULL, 'RAB GTPase Vps21/Ypt51, putative', 199, NULL, NULL, 170680),
(170681, '1.20.1250.20-FF-000002', NULL, 'Sugar transport protein 13', 474, NULL, NULL, 170681),
(170682, '3.90.550.50-FF-000051', NULL, 'Hexosyltransferase', 201, NULL, NULL, 170682),
(170683, '3.40.50.300-FF-000555', NULL, 'ATP-dependent RNA helicase SrmB', 170, NULL, NULL, 170683),
(170684, '3.30.70.260-FF-000139', NULL, 'Homoserine dehydrogenase', 69, NULL, NULL, 170684),
(170685, '3.40.50.300-FF-007519', NULL, 'ATP-dependent RNA helicase mss116, mitochondrial', 212, NULL, NULL, 170685),
(170686, '1.10.238.10-FF-000822', NULL, 'Uncharacterized protein', 62, NULL, NULL, 170686),
(170687, '1.10.530.10-FF-000013', NULL, 'Pneumococcal vaccine antigen A', 166, NULL, NULL, 170687),
(170688, '3.40.50.10470-FF-000035', NULL, 'Translation initiation factor eif-2B alpha subunit, putative', 173, NULL, NULL, 170688),
(170689, '3.40.50.300-FF-007699', NULL, 'ATP-dependent DEAD/H RNA helicase, putative', 104, NULL, NULL, 170689),
(170690, '1.25.40.10-FF-001094', NULL, 'Intraflagellar transport particle protein IFT88', 337, NULL, NULL, 170690),
(170691, '1.25.40.20-FF-001097', NULL, 'Si:ch211-119c20.2', 84, NULL, NULL, 170691),
(170692, '1.10.10.10-FF-001092', NULL, 'Uncharacterized protein', 102, NULL, NULL, 170692),
(170693, '3.40.140.10-FF-000031', NULL, 'Probable C->U-editing enzyme APOBEC-2', 184, NULL, NULL, 170693),
(170694, '3.90.550.10-FF-000320', NULL, 'Uncharacterized glycosyltransferase HI_0868', 242, NULL, NULL, 170694),
(170695, '3.40.50.1010-FF-000087', NULL, 'Unplaced genomic scaffold supercont2.30, whole genome shotgun sequence', 159, NULL, NULL, 170695),
(170696, '3.40.50.300-FF-002382', NULL, 'DNA repair protein RAD51C, putative', 253, NULL, NULL, 170696),
(170697, '3.30.160.60-FF-001010', NULL, 'zinc finger protein 64 isoform X3', 30, NULL, NULL, 170697),
(170698, '3.60.90.10-FF-000033', NULL, 'Uncharacterized protein', 113, NULL, NULL, 170698),
(170699, '3.40.50.300-FF-003961', NULL, 'ATP binding protein', 276, NULL, NULL, 170699),
(170700, '3.40.50.620-FF-000589', NULL, 'Arginyl-tRNA synthetase, putative', 35, NULL, NULL, 170700),
(170701, '3.90.180.10-FF-000067', NULL, 'alcohol dehydrogenase 1-like isoform X1', 162, NULL, NULL, 170701),
(170702, '3.40.50.200-FF-000025', NULL, 'Peptidase', 298, NULL, NULL, 170702),
(170703, '3.40.50.11480-FF-000001', NULL, 'tubulin--tyrosine ligase', 63, NULL, NULL, 170703),
(170704, '3.90.70.10-FF-000171', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 316, NULL, NULL, 170704),
(170705, '4.10.950.10-FF-000005', NULL, 'Uncharacterized protein', 68, NULL, NULL, 170705),
(170706, '3.80.10.10-FF-000982', NULL, 'UBA/TS-N domain containing protein', 147, NULL, NULL, 170706),
(170707, '3.40.50.300-FF-004208', NULL, 'Predicted protein', 233, NULL, NULL, 170707),
(170708, '3.30.572.10-FF-000002', NULL, 'Possible thymidylate synthase', 290, NULL, NULL, 170708),
(170709, '2.20.100.10-FF-000076', NULL, 'ADAMTS-like protein 3', 60, NULL, NULL, 170709);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(170710, '3.40.50.1390-FF-000004', NULL, 'Resolvase YneB', 154, NULL, NULL, 170710),
(170711, '3.40.50.1820-FF-001050', NULL, 'Serine carboxypeptidase-like 18', 453, NULL, NULL, 170711),
(170712, '3.40.30.10-FF-000485', NULL, 'GM25516', 195, NULL, NULL, 170712),
(170713, '1.20.1280.290-FF-000088', NULL, 'PQ loop repeat-containing 2', 66, NULL, NULL, 170713),
(170714, '1.25.40.320-FF-000007', NULL, 'Putative bifunctional leukotriene a4 hydrolase/aminopeptidase lta4h', 145, NULL, NULL, 170714),
(170715, '3.40.50.1380-FF-000001', NULL, 'Bifunctional purine biosynthesis protein PurH', 201, NULL, NULL, 170715),
(170716, '1.20.1070.10-FF-000665', NULL, '5-hydroxytryptamine receptor 1-like Protein', 236, NULL, NULL, 170716),
(170717, '1.10.357.70-FF-000010', NULL, 'Hypothetical_protein_-_conserved', 188, NULL, NULL, 170717),
(170718, '3.40.50.1820-FF-000678', NULL, 'Acetyl esterase/lipase', 280, NULL, NULL, 170718),
(170719, '3.30.420.610-FF-000015', NULL, 'GD25688', 74, NULL, NULL, 170719),
(170720, '1.10.510.10-FF-003648', NULL, NULL, 186, NULL, NULL, 170720),
(170721, '3.30.160.60-FF-003865', NULL, 'Zinc finger protein 587', 56, NULL, NULL, 170721),
(170722, '3.40.50.2300-FF-001031', NULL, NULL, 231, NULL, NULL, 170722),
(170723, '1.10.357.140-FF-000019', NULL, 'Protoheme IX farnesyltransferase', 168, NULL, NULL, 170723),
(170724, '3.80.10.10-FF-000746', NULL, 'Plant intracellular Ras-group-related LRR protein 2', 175, NULL, NULL, 170724),
(170725, '4.10.400.10-FF-000273', NULL, 'Receptor Mediated Endocytosis', 43, NULL, NULL, 170725),
(170726, '1.10.8.1310-FF-000016', NULL, 'TBC1 domain protein', 92, NULL, NULL, 170726),
(170727, '2.10.50.10-FF-000097', NULL, 'Tumor necrosis factor receptor superfamily, member 1a', 61, NULL, NULL, 170727),
(170728, '3.40.630.30-FF-000473', NULL, 'Elongator complex protein 3', 159, NULL, NULL, 170728),
(170729, '3.40.50.12780-FF-000048', NULL, 'Coenzyme A ligase', 406, NULL, NULL, 170729),
(170730, '3.80.10.10-FF-001292', NULL, 'Tubulin-specific chaperone E', 111, NULL, NULL, 170730),
(170731, '1.20.144.10-FF-000006', NULL, 'Phospholipid phosphatase-related protein type 2 isoform X1', 207, NULL, NULL, 170731),
(170732, '1.20.5.50-FF-000011', NULL, 'Fibrinogen gamma chain', 135, NULL, NULL, 170732),
(170733, '3.40.50.300-FF-008014', NULL, 'Uncharacterized protein', 142, NULL, NULL, 170733),
(170734, '3.30.420.10-FF-000537', NULL, NULL, 87, NULL, NULL, 170734),
(170735, '3.20.20.80-FF-000388', NULL, 'Predicted protein', 307, NULL, NULL, 170735),
(170736, '3.40.30.10-FF-000575', NULL, 'Protein disulfide-isomerase', 123, NULL, NULL, 170736),
(170737, '1.10.418.10-FF-000241', NULL, 'Predicted protein', 138, NULL, NULL, 170737),
(170738, '3.90.70.10-FF-000261', NULL, 'calpain-15', 133, NULL, NULL, 170738),
(170739, '3.90.640.10-FF-000237', NULL, 'Uncharacterized protein', 37, NULL, NULL, 170739),
(170740, '3.40.20.10-FF-000041', NULL, 'Protein transport protein SEC23', 105, NULL, NULL, 170740),
(170741, '1.25.40.10-FF-004966', NULL, 'Uncharacterized protein', 155, NULL, NULL, 170741),
(170742, '1.20.58.60-FF-000693', NULL, 'Uncharacterized protein', 293, NULL, NULL, 170742),
(170743, '1.10.8.60-FF-000144', NULL, 'Replication factor C subunit 4', 43, NULL, NULL, 170743),
(170744, '1.10.287.110-FF-000314', NULL, 'Chloroplast DnaJ-like protein', 111, NULL, NULL, 170744),
(170745, '2.130.10.10-FF-000431', NULL, 'WD repeat-containing protein 41 isoform X2', 205, NULL, NULL, 170745),
(170746, '1.10.510.10-FF-000427', NULL, 'SRSF protein kinase 2 isoform X1', 93, NULL, NULL, 170746),
(170747, '2.60.40.1230-FF-000008', NULL, 'AP-1 complex subunit gamma', 128, NULL, NULL, 170747),
(170748, '3.10.20.90-FF-000442', NULL, 'RanBP-type and C3HC4-type zinc finger-containing protein 1', 84, NULL, NULL, 170748),
(170749, '4.10.240.10-FF-000182', NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', 44, NULL, NULL, 170749),
(170750, '1.25.40.20-FF-001012', NULL, 'Uncharacterized protein', 211, NULL, NULL, 170750),
(170751, '1.25.10.10-FF-003183', NULL, 'Probable inactive serine/threonine-protein kinase DDB_G0278909', 316, NULL, NULL, 170751);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(170752, '1.10.10.60-FF-000420', NULL, 'Uncharacterized protein, isoform A', 62, NULL, NULL, 170752),
(170753, '3.10.580.10-FF-000121', NULL, 'Glycine betaine/carnitine/choline ABC transporter, ATP-binding protein', 126, NULL, NULL, 170753),
(170754, '2.60.40.1130-FF-000006', NULL, 'geranylgeranyl transferase type-2 subunit alpha', 99, NULL, NULL, 170754),
(170755, '2.60.120.10-FF-000079', NULL, '1,2-dihydroxy-3-keto-5-methylthiopentene dioxygenase', 173, NULL, NULL, 170755),
(170756, '3.20.20.70-FF-000385', NULL, 'Multifunctional tryptophan biosynthesis protein', 208, NULL, NULL, 170756),
(170757, '3.30.420.510-FF-000013', NULL, 'Pantothenate kinase family protein', 120, NULL, NULL, 170757),
(170758, '3.40.850.10-FF-000298', NULL, 'Uncharacterized protein', 352, NULL, NULL, 170758),
(170759, '1.20.1640.10-FF-000041', NULL, 'Multidrug transporter AcrB', 198, NULL, NULL, 170759),
(170760, '3.40.50.10190-FF-000069', NULL, 'DNA ligase', 80, NULL, NULL, 170760),
(170761, '2.60.40.10-FF-002544', NULL, 'L1 CAM ADhesion molecule homolog', 102, NULL, NULL, 170761),
(170762, '3.40.50.300-FF-006069', NULL, 'Uncharacterized protein', 157, NULL, NULL, 170762),
(170763, '3.30.1360.120-FF-000071', NULL, 'Putative transferase CAF17, mitochondrial', 166, NULL, NULL, 170763),
(170764, '3.30.200.20-FF-001721', NULL, 'Uncharacterized protein', 112, NULL, NULL, 170764),
(170765, '3.30.2350.20-FF-000017', NULL, 'Putative pseudouridine synthase B0024.11', 191, NULL, NULL, 170765),
(170766, '2.60.120.1040-FF-000002', NULL, 'zinc finger protein ZPR1', 140, NULL, NULL, 170766),
(170767, '3.40.50.10860-FF-000062', NULL, 'Uncharacterized protein', 105, NULL, NULL, 170767),
(170768, '3.40.50.1820-FF-001611', NULL, 'Protein CBG13037', 68, NULL, NULL, 170768),
(170769, '2.40.50.100-FF-000033', NULL, 'Dihydrolipoyllysine-residue succinyltransferase component of 2-oxoglutarate dehydrogenase complex, mitochondrial', 102, NULL, NULL, 170769),
(170770, '3.40.120.10-FF-000029', NULL, 'Phosphomannomutase/phosphoglucomutase', 102, NULL, NULL, 170770),
(170771, '3.30.60.30-FF-000111', NULL, 'Solute carrier organic anion transporter family member', 55, NULL, NULL, 170771),
(170772, '1.10.3200.20-FF-000002', NULL, 'DNA polymerase', 188, NULL, NULL, 170772),
(170773, '1.10.3730.20-FF-000031', NULL, 'EamA-like transporter family protein', 130, NULL, NULL, 170773),
(170774, '1.20.1070.10-FF-001160', NULL, 'Free fatty acid receptor 4', 342, NULL, NULL, 170774),
(170775, '2.60.40.10-FF-003977', NULL, NULL, 102, NULL, NULL, 170775),
(170776, '1.10.10.790-FF-000040', NULL, NULL, 61, NULL, NULL, 170776),
(170777, '3.90.190.10-FF-000601', NULL, 'Uncharacterized protein', 215, NULL, NULL, 170777),
(170778, '3.40.50.300-FF-000701', NULL, 'Sulfotransferase', 304, NULL, NULL, 170778),
(170779, '3.30.420.10-FF-000206', NULL, 'Exonuclease, DNA polymerase III, epsilon subunit family', 164, NULL, NULL, 170779),
(170780, '3.30.2410.10-FF-000014', NULL, 'E3 ubiquitin-protein ligase SMURF1', 123, NULL, NULL, 170780),
(170781, '3.30.1490.20-FF-000084', NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', 69, NULL, NULL, 170781),
(170782, '3.30.420.270-FF-000014', NULL, 'Biopolymer transporter ExbD', 90, NULL, NULL, 170782),
(170783, '3.30.70.20-FF-000081', NULL, 'Anaerobic sulfite reductase subunit C', 49, NULL, NULL, 170783),
(170784, '3.80.10.10-FF-002455', NULL, 'Receptor-like protein 30', 75, NULL, NULL, 170784),
(170785, '3.30.160.60-FF-004028', NULL, NULL, 24, NULL, NULL, 170785),
(170786, '2.60.300.12-FF-000017', NULL, 'FeS cluster insertion', 109, NULL, NULL, 170786),
(170787, '3.40.50.300-FF-001685', NULL, 'Dynein heavy chain, putative', 124, NULL, NULL, 170787),
(170788, '3.80.10.10-FF-002399', NULL, 'Chondroadherin like', 61, NULL, NULL, 170788),
(170789, '3.40.50.300-FF-004501', NULL, 'Uncharacterized protein', 373, NULL, NULL, 170789),
(170790, '3.30.360.10-FF-000061', NULL, 'Chromosome 8, whole genome shotgun sequence', 172, NULL, NULL, 170790),
(170791, '2.60.40.420-FF-000257', NULL, 'Spore germination protein 270-11', 87, NULL, NULL, 170791);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(170792, '1.10.1520.10-FF-000079', NULL, 'Uncharacterized protein', 176, NULL, NULL, 170792),
(170793, '1.10.630.10-FF-000285', NULL, 'Cytochrome P450, putative', 160, NULL, NULL, 170793),
(170794, '1.20.58.60-FF-000491', NULL, 'Spectrin alpha, non-erythrocytic 1', 73, NULL, NULL, 170794),
(170795, '2.90.20.10-FF-000001', NULL, '25 kDa ookinete surface antigen', 161, NULL, NULL, 170795),
(170796, '3.30.160.60-FF-000341', NULL, 'Spalt-like transcription factor 1', 29, NULL, NULL, 170796),
(170797, '1.10.357.70-FF-000009', NULL, 'Exocyst complex component, putative', 184, NULL, NULL, 170797),
(170798, '1.25.40.20-FF-000085', NULL, 'Notch-regulated ankyrin repeat-containing protein A', 110, NULL, NULL, 170798),
(170799, '1.25.40.180-FF-000297', NULL, NULL, 100, NULL, NULL, 170799),
(170800, '3.40.50.150-FF-000403', NULL, 'Phenazine-specific methyltransferase', 246, NULL, NULL, 170800),
(170801, '1.25.40.10-FF-000082', NULL, 'Clathrin heavy chain', 327, NULL, NULL, 170801),
(170802, '2.130.10.10-FF-003955', NULL, 'Uncharacterized protein', 243, NULL, NULL, 170802),
(170803, '3.20.20.80-FF-000298', NULL, 'Chromosome 1, whole genome shotgun sequence', 228, NULL, NULL, 170803),
(170804, '2.60.120.10-FF-000080', NULL, 'Auxin-binding protein 1', 162, NULL, NULL, 170804),
(170805, '3.30.160.60-FF-003949', NULL, NULL, 29, NULL, NULL, 170805),
(170806, '1.25.40.20-FF-000028', NULL, 'ankyrin repeat domain-containing protein 17 isoform X1', 67, NULL, NULL, 170806),
(170807, '2.60.120.10-FF-000551', NULL, 'Uncharacterized protein', 151, NULL, NULL, 170807),
(170808, '3.40.50.300-FF-003776', NULL, 'Uncharacterized protein', 228, NULL, NULL, 170808),
(170809, '1.25.40.70-FF-000049', NULL, 'Uncharacterized protein', 201, NULL, NULL, 170809),
(170810, '1.10.555.10-FF-000216', NULL, NULL, 256, NULL, NULL, 170810),
(170811, '3.40.50.2020-FF-000143', NULL, 'Uncharacterized protein', 214, NULL, NULL, 170811),
(170812, '3.30.70.980-FF-000006', NULL, 'Probable transcriptional regulatory protein J113_18170', 73, NULL, NULL, 170812),
(170813, '1.10.390.10-FF-000041', NULL, 'Leukotriene A-4 hydrolase-like protein', 113, NULL, NULL, 170813),
(170814, '3.40.50.300-FF-005428', NULL, 'ATP-binding cassette transporter, subfamily A, member 7, group AOH protein PpABCA7', 86, NULL, NULL, 170814),
(170815, '1.20.1270.280-FF-000083', NULL, 'Dynein heavy chain, cytosolic, putative', 207, NULL, NULL, 170815),
(170816, '3.40.50.1000-FF-000404', NULL, 'Unplaced genomic scaffold supercont2.16, whole genome shotgun sequence', 170, NULL, NULL, 170816),
(170817, '3.40.50.2300-FF-001323', NULL, NULL, 99, NULL, NULL, 170817),
(170818, '2.60.40.60-FF-000333', NULL, 'Protocadherin-related 15b', 109, NULL, NULL, 170818),
(170819, '3.40.50.150-FF-000931', NULL, 'mRNA cap guanine-N7 methyltransferase', 283, NULL, NULL, 170819),
(170820, '2.130.10.10-FF-003629', NULL, 'Uncharacterized protein', 239, NULL, NULL, 170820),
(170821, '2.60.40.10-FF-003562', NULL, NULL, 92, NULL, NULL, 170821),
(170822, '3.30.200.20-FF-000996', NULL, 'Rac serine-threonine kinase, putative', 101, NULL, NULL, 170822),
(170823, '3.90.1290.10-FF-000006', NULL, 'microtubule-actin cross-linking factor 1 isoform X10', 123, NULL, NULL, 170823),
(170824, '1.25.40.10-FF-003746', NULL, 'Uncharacterized protein', 238, NULL, NULL, 170824),
(170825, '3.40.30.10-FF-000193', NULL, 'Protein disulfide isomerase-like 5-2', 137, NULL, NULL, 170825),
(170826, '2.40.30.10-FF-000408', NULL, 'Uncharacterized protein', 120, NULL, NULL, 170826),
(170827, '1.50.40.10-FF-000046', NULL, 'Phosphate carrier protein, mitochondrial', 186, NULL, NULL, 170827),
(170828, '2.60.40.10-FF-006052', NULL, NULL, 71, NULL, NULL, 170828),
(170829, '1.10.220.150-FF-000040', NULL, 'Uncharacterized protein', 129, NULL, NULL, 170829),
(170830, '3.20.90.10-FF-000006', NULL, 'Uncharacterized protein', 221, NULL, NULL, 170830),
(170831, '2.30.30.40-FF-000620', NULL, 'Predicted protein', 46, NULL, NULL, 170831),
(170832, '1.10.287.70-FF-000274', NULL, 'ATP-sensitive inward rectifier potassium channel 10', 113, NULL, NULL, 170832);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(170833, '1.10.10.10-FF-001086', NULL, 'Uncharacterized protein', 102, NULL, NULL, 170833),
(170834, '1.25.40.420-FF-000037', NULL, 'GD17043', 106, NULL, NULL, 170834),
(170835, '1.10.45.10-FF-000008', NULL, 'D-arabinono-1,4-lactone oxidase', 37, NULL, NULL, 170835),
(170836, '3.10.20.90-FF-001021', NULL, 'Uncharacterized protein', 96, NULL, NULL, 170836),
(170837, '1.20.140.100-FF-000010', NULL, 'Dynein heavy chain, putative', 153, NULL, NULL, 170837),
(170838, '3.30.70.330-FF-002369', NULL, NULL, 163, NULL, NULL, 170838),
(170839, '1.10.238.10-FF-000148', NULL, 'alpha-actinin, sarcomeric isoform X2', 83, NULL, NULL, 170839),
(170840, '3.30.360.10-FF-000004', NULL, '4-hydroxy-tetrahydrodipicolinate reductase', 108, NULL, NULL, 170840),
(170841, '1.20.1250.20-FF-000379', NULL, 'Uncharacterized protein, isoform A', 140, NULL, NULL, 170841),
(170842, '3.30.160.60-FF-005720', NULL, NULL, 36, NULL, NULL, 170842),
(170843, '2.60.120.380-FF-000068', NULL, 'Calpain 11', 100, NULL, NULL, 170843),
(170844, '3.10.290.20-FF-000023', NULL, 'Ubiquitin-activating enzyme-like protein', 149, NULL, NULL, 170844),
(170845, '3.90.76.10-FF-000010', NULL, 'Peptide ABC transporter substrate-binding protein', 123, NULL, NULL, 170845),
(170846, '3.10.290.10-FF-000020', NULL, 'Ribosomal protein S4', 84, NULL, NULL, 170846),
(170847, '3.40.50.150-FF-001185', NULL, NULL, 89, NULL, NULL, 170847),
(170848, '1.10.287.470-FF-000023', NULL, 'Multidrug resistance protein MexA', 60, NULL, NULL, 170848),
(170849, '1.10.10.10-FF-001939', NULL, 'Uncharacterized protein', 86, NULL, NULL, 170849),
(170850, '3.30.70.330-FF-001059', NULL, 'Putative polypyrimidine tract binding protein', 102, NULL, NULL, 170850),
(170851, '2.10.50.10-FF-000153', NULL, 'Predicted protein', 61, NULL, NULL, 170851),
(170852, '3.30.360.20-FF-000007', NULL, 'RNA 3''-terminal phosphate cyclase-like protein,putative', 80, NULL, NULL, 170852),
(170853, '3.20.20.370-FF-000001', NULL, 'Chitooligosaccharide deacetylase', 252, NULL, NULL, 170853),
(170854, '3.30.2130.10-FF-000032', NULL, 'Prephenate dehydrogenase', 74, NULL, NULL, 170854),
(170855, '3.40.630.10-FF-000113', NULL, 'Dug2p', 277, NULL, NULL, 170855),
(170856, '2.40.50.140-FF-000668', NULL, NULL, 68, NULL, NULL, 170856),
(170857, '3.30.420.10-FF-000678', NULL, NULL, 164, NULL, NULL, 170857),
(170858, '2.60.40.1930-FF-000033', NULL, 'Complement component 4A (Rodgers blood group)', 119, NULL, NULL, 170858),
(170859, '3.40.50.10470-FF-000029', NULL, 'Methylthioribose-1-phosphate isomerase', 202, NULL, NULL, 170859),
(170860, '2.60.40.10-FF-001847', NULL, 'Titin homolog', 95, NULL, NULL, 170860),
(170861, '1.10.101.10-FF-000039', NULL, 'Matrix metallopeptidase 19', 67, NULL, NULL, 170861),
(170862, '1.20.1270.60-FF-000291', NULL, 'Predicted protein', 158, NULL, NULL, 170862),
(170863, '3.40.50.300-FF-000903', NULL, 'ABC transporter G family member 7', 240, NULL, NULL, 170863),
(170864, '3.40.1110.10-FF-000045', NULL, 'Calcium-transporting ATPase', 199, NULL, NULL, 170864),
(170865, '3.20.20.380-FF-000004', NULL, 'Copper homeostasis protein CutC', 222, NULL, NULL, 170865),
(170866, '3.40.50.300-FF-008340', NULL, 'Uncharacterized protein', 197, NULL, NULL, 170866),
(170867, '3.30.160.710-FF-000002', NULL, 'Hemagglutinin', 72, NULL, NULL, 170867),
(170868, '1.20.58.60-FF-000159', NULL, 'Uncharacterized protein, isoform B', 111, NULL, NULL, 170868),
(170869, '2.20.100.10-FF-000082', NULL, 'Complement component C8 beta chain', 49, NULL, NULL, 170869),
(170870, '3.50.50.60-FF-001327', NULL, 'LD39082p', 134, NULL, NULL, 170870),
(170871, '3.30.160.60-FF-002230', NULL, 'Zinc finger protein 469', 66, NULL, NULL, 170871),
(170872, '1.20.1250.20-FF-001104', NULL, 'Glucuronide transporter UidB', 413, NULL, NULL, 170872),
(170873, '2.60.120.200-FF-000003', NULL, 'neurexin-1 isoform X1', 210, NULL, NULL, 170873),
(170874, '1.10.287.70-FF-000745', NULL, 'Predicted protein', 87, NULL, NULL, 170874),
(170875, '3.30.160.60-FF-004410', NULL, NULL, 36, NULL, NULL, 170875),
(170876, '1.10.20.10-FF-000131', NULL, 'Histone H2B', 126, NULL, NULL, 170876);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(170877, '3.40.50.1820-FF-001465', NULL, 'Uncharacterized protein', 178, NULL, NULL, 170877),
(170878, '2.60.40.10-FF-004343', NULL, NULL, 118, NULL, NULL, 170878),
(170879, '1.10.510.10-FF-001647', NULL, 'WGS project CABT00000000 data, contig 2.1', 197, NULL, NULL, 170879),
(170880, '1.25.40.10-FF-005129', NULL, 'Predicted protein', 105, NULL, NULL, 170880),
(170881, '2.60.40.10-FF-000072', NULL, 'RIMS-binding protein 2 isoform X1', 98, NULL, NULL, 170881),
(170882, '2.60.40.60-FF-000390', NULL, 'Protocadherin Fat', 106, NULL, NULL, 170882),
(170883, '1.10.510.10-FF-000068', NULL, 'STE20/SPS1-related proline-alanine-rich protein kinase', 212, NULL, NULL, 170883),
(170884, '4.10.75.10-FF-000008', NULL, 'Whey acidic protein', 49, NULL, NULL, 170884),
(170885, '1.10.287.110-FF-000022', NULL, 'DnaJ homolog subfamily B member 6', 112, NULL, NULL, 170885),
(170886, '2.40.70.10-FF-000063', NULL, 'aspartic proteinase nepenthesin-1', 200, NULL, NULL, 170886),
(170887, '3.40.50.300-FF-004181', NULL, 'Predicted protein', 177, NULL, NULL, 170887),
(170888, '2.60.40.10-FF-002252', NULL, 'Glycoside hydrolase family 2', 95, NULL, NULL, 170888),
(170889, '3.30.1370.100-FF-000005', NULL, 'DNA mismatch repair protein MutL', 96, NULL, NULL, 170889),
(170890, '3.30.70.330-FF-002897', NULL, NULL, 51, NULL, NULL, 170890),
(170891, '1.10.3090.10-FF-000034', NULL, 'tRNA nucleotidyltransferase cca1', 149, NULL, NULL, 170891),
(170892, '1.20.1270.60-FF-000139', NULL, 'Uncharacterized protein', 278, NULL, NULL, 170892),
(170893, '3.30.1490.20-FF-000027', NULL, 'Pyruvate, phosphate dikinase', 156, NULL, NULL, 170893),
(170894, '1.10.287.130-FF-000269', NULL, 'Uncharacterized protein', 108, NULL, NULL, 170894),
(170895, '1.20.5.990-FF-000015', NULL, 'Uncharacterized protein', 101, NULL, NULL, 170895),
(170896, '1.20.120.350-FF-000176', NULL, NULL, 153, NULL, NULL, 170896),
(170897, '1.10.510.10-FF-000012', NULL, 'microtubule-associated serine/threonine-protein kinase 2 isoform X1', 211, NULL, NULL, 170897),
(170898, '3.30.1370.110-FF-000008', NULL, 'YPL199C-like protein', 100, NULL, NULL, 170898),
(170899, '3.40.50.300-FF-002090', NULL, 'ADP-ribosylation factor, putative', 179, NULL, NULL, 170899),
(170900, '3.40.50.300-FF-000381', NULL, 'TFIIH basal transcription factor complex helicase subunit', 275, NULL, NULL, 170900),
(170901, '3.40.50.720-FF-000945', NULL, 'UDP-glucose/GDP-mannose dehydrogenase family protein', 227, NULL, NULL, 170901),
(170902, '3.30.1600.10-FF-000023', NULL, 'Transcriptional regulator, Sir2 family protein', 124, NULL, NULL, 170902),
(170903, '3.40.50.410-FF-000116', NULL, 'Voltage-dependent calcium channel unc-36', 187, NULL, NULL, 170903),
(170904, '2.40.110.10-FF-000004', NULL, 'Isovaleryl-CoA dehydrogenase, mitochondrial', 115, NULL, NULL, 170904),
(170905, '3.40.630.30-FF-000271', NULL, 'L-2,4-diaminobutyric acid acetyltransferase', 162, NULL, NULL, 170905),
(170906, '3.40.50.1100-FF-000232', NULL, 'Uncharacterized protein', 66, NULL, NULL, 170906),
(170907, '1.10.287.1490-FF-000133', NULL, 'Phosphoinositide-3-kinase regulatory subunit 2', 104, NULL, NULL, 170907),
(170908, '3.40.50.620-FF-000735', NULL, 'Uncharacterized protein', 170, NULL, NULL, 170908),
(170909, '2.70.150.10-FF-000034', NULL, 'Sodium ion P-type ATPase', 157, NULL, NULL, 170909),
(170910, '1.10.10.10-FF-001794', NULL, 'Uncharacterized protein', 83, NULL, NULL, 170910),
(170911, '1.10.150.80-FF-000004', NULL, 'ATP-dependent DNA helicase RecQ', 80, NULL, NULL, 170911),
(170912, '3.80.10.10-FF-001151', NULL, 'F-box/LRR-repeat protein 14', 113, NULL, NULL, 170912),
(170913, '3.40.50.720-FF-000001', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', 161, NULL, NULL, 170913),
(170914, '1.10.238.10-FF-000530', NULL, 'Zgc:85932', 171, NULL, NULL, 170914),
(170915, '3.10.20.90-FF-000240', NULL, 'ISG15 ubiquitin-like modifier', 80, NULL, NULL, 170915),
(170916, '2.60.40.10-FF-005686', NULL, NULL, 77, NULL, NULL, 170916),
(170917, '3.40.50.2300-FF-000957', NULL, NULL, 106, NULL, NULL, 170917),
(170918, '3.90.550.10-FF-000207', NULL, 'Ceramide glucosyltransferase 1', 232, NULL, NULL, 170918);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(170919, '3.30.40.10-FF-000683', NULL, 'RING/U-box superfamily protein', 70, NULL, NULL, 170919),
(170920, '1.10.30.10-FF-000047', NULL, 'Axial regulator YABBY', 73, NULL, NULL, 170920),
(170921, '1.10.510.10-FF-000540', NULL, 'Serine/threonine-protein kinase-like protein', 204, NULL, NULL, 170921),
(170922, '3.40.50.300-FF-007935', NULL, 'Conjugal transfer protein, conjectural', 172, NULL, NULL, 170922),
(170923, '2.130.10.10-FF-004091', NULL, 'Predicted protein', 199, NULL, NULL, 170923),
(170924, '2.80.10.50-FF-000277', NULL, 'Uncharacterized protein', 88, NULL, NULL, 170924),
(170925, '3.30.160.60-FF-003573', NULL, 'KLF17 isoform 1', 39, NULL, NULL, 170925),
(170926, '1.10.510.10-FF-003356', NULL, NULL, 269, NULL, NULL, 170926),
(170927, '3.40.50.10190-FF-000215', NULL, 'Uncharacterized protein', 93, NULL, NULL, 170927),
(170928, '3.30.565.10-FF-000031', NULL, 'DNA mismatch repair protein Mlh3', 207, NULL, NULL, 170928),
(170929, '2.60.120.200-FF-000436', NULL, 'Beta-1,3-glucan binding protein', 304, NULL, NULL, 170929),
(170930, '3.40.50.300-FF-004124', NULL, 'ATP-binding cassette protein subfamily C, member 8', 295, NULL, NULL, 170930),
(170931, '3.40.50.300-FF-007558', NULL, 'Uncharacterized protein', 187, NULL, NULL, 170931),
(170932, '2.10.70.10-FF-000154', NULL, 'Complement component 1, r subcomponent', 74, NULL, NULL, 170932),
(170933, '3.40.50.300-FF-007845', NULL, 'Uncharacterized protein', 229, NULL, NULL, 170933),
(170934, '1.20.1600.10-FF-000010', NULL, 'Outer membrane efflux protein', 419, NULL, NULL, 170934),
(170935, '1.50.10.10-FF-000218', NULL, 'Uncharacterized protein', 102, NULL, NULL, 170935),
(170936, '1.25.40.10-FF-001386', NULL, 'Pentatricopeptide repeat-containing protein At3g26782, mitochondrial', 108, NULL, NULL, 170936),
(170937, '3.40.50.740-FF-000007', NULL, 'Formate dehydrogenase, alpha subunit, selenocysteine-containing', 166, NULL, NULL, 170937),
(170938, '3.40.50.10810-FF-000002', NULL, 'ISWI chromatin-remodeling complex ATPase CHR11 isoform A', 213, NULL, NULL, 170938),
(170939, '3.40.50.200-FF-000109', NULL, 'Clan SB, family S8, subtilisin-like serine peptidase', 141, NULL, NULL, 170939),
(170940, '1.25.40.10-FF-001329', NULL, 'ESX-1 secretion system protein EccA1', 275, NULL, NULL, 170940),
(170941, '3.60.40.10-FF-000322', NULL, 'Uncharacterized protein', 203, NULL, NULL, 170941),
(170942, '2.60.40.60-FF-000620', NULL, 'Uncharacterized protein', 112, NULL, NULL, 170942),
(170943, '3.30.70.100-FF-000086', NULL, 'Heavy metal translocatin', 77, NULL, NULL, 170943),
(170944, '3.40.1350.10-FF-000006', NULL, 'tRNA-splicing endonuclease', 95, NULL, NULL, 170944),
(170945, '3.30.160.60-FF-005664', NULL, NULL, 77, NULL, NULL, 170945),
(170946, '3.40.50.10330-FF-000128', NULL, 'Uncharacterized protein', 36, NULL, NULL, 170946),
(170947, '1.10.238.10-FF-000620', NULL, 'Putative polycystic kidney disease protein 2', 80, NULL, NULL, 170947),
(170948, '2.40.40.20-FF-000064', NULL, 'Predicted protein', 83, NULL, NULL, 170948),
(170949, '3.40.630.30-FF-000181', NULL, 'Acetyltransferase', 218, NULL, NULL, 170949),
(170950, '3.70.10.10-FF-000033', NULL, 'Rad9 protein', 259, NULL, NULL, 170950),
(170951, '2.30.42.10-FF-000358', NULL, 'Sperm Meiosis PDZ domain containing proteins', 87, NULL, NULL, 170951),
(170952, '1.20.58.60-FF-000867', NULL, 'Uncharacterized protein', 300, NULL, NULL, 170952),
(170953, '1.20.140.10-FF-000094', NULL, 'Acyl-coenzyme A oxidase', 120, NULL, NULL, 170953),
(170954, '1.10.10.60-FF-000712', NULL, 'V-myb avian myeloblastosis viral oncogene homolog-like 2a', 83, NULL, NULL, 170954),
(170955, '2.70.130.10-FF-000145', NULL, NULL, 144, NULL, NULL, 170955),
(170956, '1.10.150.50-FF-000046', NULL, 'ephrin type-A receptor 3', 77, NULL, NULL, 170956),
(170957, '1.25.40.20-FF-001389', NULL, 'Uncharacterized protein', 58, NULL, NULL, 170957),
(170958, '2.60.34.20-FF-000015', NULL, NULL, 106, NULL, NULL, 170958),
(170959, '3.10.20.90-FF-000150', NULL, 'Ubiquitin-like protein ATG12', 93, NULL, NULL, 170959),
(170960, '3.90.550.10-FF-000264', NULL, 'Glycosyltransferases', 65, NULL, NULL, 170960);
INSERT INTO "PUBLIC"."MODEL" VALUES
(170961, '2.170.16.10-FF-000027', NULL, 'Replicative DNA helicase', 143, NULL, NULL, 170961),
(170962, '2.130.10.10-FF-000723', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 123, NULL, NULL, 170962),
(170963, '1.25.10.10-FF-000254', NULL, 'Uncharacterized protein, isoform C', 228, NULL, NULL, 170963),
(170964, '3.30.160.60-FF-000228', NULL, 'Wilms tumor 1-KTS isoform', 32, NULL, NULL, 170964),
(170965, '2.60.120.10-FF-000495', NULL, 'Uncharacterized protein', 162, NULL, NULL, 170965),
(170966, '3.30.40.10-FF-001026', NULL, 'baculoviral IAP repeat-containing protein 7 isoform X1', 71, NULL, NULL, 170966),
(170967, '2.60.34.10-FF-000012', NULL, 'Heat shock 70 kDa protein', 156, NULL, NULL, 170967),
(170968, '3.30.9.10-FF-000245', NULL, 'Uncharacterized protein', 29, NULL, NULL, 170968),
(170969, '1.50.40.10-FF-000574', NULL, 'Uncharacterized protein', 76, NULL, NULL, 170969),
(170970, '3.50.4.10-FF-000010', NULL, 'GD21471', 78, NULL, NULL, 170970),
(170971, '3.30.160.60-FF-000285', NULL, 'Zinc finger matrin-type protein 3', 42, NULL, NULL, 170971),
(170972, '3.10.20.90-FF-000296', NULL, 'Ubiquitin-like protein-NEDD8-like protein RUB3', 78, NULL, NULL, 170972),
(170973, '3.70.10.10-FF-000090', NULL, 'Checkpoint protein', 281, NULL, NULL, 170973),
(170974, '3.20.20.70-FF-000559', NULL, 'Uncharacterized protein', 352, NULL, NULL, 170974),
(170975, '1.10.8.60-FF-000436', NULL, 'Peroxisomal ATPase PEX1', 144, NULL, NULL, 170975),
(170976, '2.10.60.10-FF-000069', NULL, 'Serine/threonine-protein kinase receptor', 59, NULL, NULL, 170976),
(170977, '3.30.230.130-FF-000002', NULL, 'cullin-3 isoform X1', 181, NULL, NULL, 170977),
(170978, '1.10.150.60-FF-000049', NULL, NULL, 88, NULL, NULL, 170978),
(170979, '3.40.190.80-FF-000066', NULL, 'Inositol-1-monophosphatase', 124, NULL, NULL, 170979),
(170980, '2.60.120.780-FF-000008', NULL, 'SIZ1p SUMO/Smt3 ligase', 155, NULL, NULL, 170980),
(170981, '3.50.70.20-FF-000001', NULL, 'Cytochrome P460', 139, NULL, NULL, 170981),
(170982, '3.90.730.10-FF-000031', NULL, 'Os07g0629300 protein', 135, NULL, NULL, 170982),
(170983, '1.10.472.10-FF-000411', NULL, 'Uncharacterized protein', 102, NULL, NULL, 170983),
(170984, '3.90.76.10-FF-000009', NULL, 'Peptide/nickel transport system substrate-binding protein', 110, NULL, NULL, 170984),
(170985, '1.10.630.10-FF-000807', NULL, 'Uncharacterized protein', 395, NULL, NULL, 170985),
(170986, '3.40.50.2000-FF-000839', NULL, 'Uncharacterized protein', 60, NULL, NULL, 170986),
(170987, '1.10.10.10-FF-001940', NULL, 'Os06g0553100 protein', 86, NULL, NULL, 170987),
(170988, '1.25.10.10-FF-001558', NULL, 'Uncharacterized protein', 187, NULL, NULL, 170988),
(170989, '2.60.40.1280-FF-000001', NULL, 'Agglutinin-like protein 3', 161, NULL, NULL, 170989),
(170990, '1.10.510.10-FF-002013', NULL, 'Kinase, CDC7', 233, NULL, NULL, 170990),
(170991, '3.30.200.20-FF-001867', NULL, 'Fibroblast growth factor receptor', 67, NULL, NULL, 170991),
(170992, '3.30.505.10-FF-000055', NULL, 'Tyrosine-protein kinase', 113, NULL, NULL, 170992),
(170993, '2.130.10.10-FF-005248', NULL, 'Uncharacterized protein', 288, NULL, NULL, 170993),
(170994, '3.90.1420.10-FF-000006', NULL, 'SET domain-containing protein', 138, NULL, NULL, 170994),
(170995, '3.30.70.330-FF-001352', NULL, 'Serine and arginine rich splicing factor 4', 71, NULL, NULL, 170995),
(170996, '3.40.50.150-FF-000167', NULL, 'Protein arginine N-methyltransferase', 148, NULL, NULL, 170996),
(170997, '1.20.5.110-FF-000190', NULL, 'Predicted_coiled-coil_domain-containing_protein_(DUF2360)_-_putative', 64, NULL, NULL, 170997),
(170998, '3.90.190.10-FF-000365', NULL, 'AGAP012901-PA', 131, NULL, NULL, 170998),
(170999, '3.30.565.10-FF-000362', NULL, 'YALI0E10769p', 219, NULL, NULL, 170999),
(171000, '2.60.40.150-FF-000209', NULL, 'Synaptotagmin 4', 145, NULL, NULL, 171000),
(171001, '3.30.160.60-FF-004500', NULL, NULL, 25, NULL, NULL, 171001),
(171002, '3.30.200.20-FF-001339', NULL, 'Protein kinase, putative', 90, NULL, NULL, 171002),
(171003, '1.20.1560.10-FF-000837', NULL, 'Uncharacterized protein', 337, NULL, NULL, 171003); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(171004, '2.60.40.1730-FF-000035', NULL, 'Putative aminopeptidase-2', 223, NULL, NULL, 171004),
(171005, '3.30.930.10-FF-000060', NULL, 'ATP phosphoribosyltransferase regulatory subunit', 324, NULL, NULL, 171005),
(171006, '3.40.250.10-FF-000185', NULL, 'Uncharacterized protein', 150, NULL, NULL, 171006),
(171007, '3.40.50.720-FF-000855', NULL, 'NAD-dependent epimerase/dehydratase / Alpha/beta hydrolase', 300, NULL, NULL, 171007),
(171008, '3.40.50.150-FF-000370', NULL, 'Si:ch211-93g23.2', 264, NULL, NULL, 171008),
(171009, '3.30.70.850-FF-000018', NULL, 'Uncharacterized protein', 100, NULL, NULL, 171009),
(171010, '3.90.1480.20-FF-000024', NULL, 'Uncharacterized protein', 120, NULL, NULL, 171010),
(171011, '1.20.58.90-FF-000033', NULL, NULL, 91, NULL, NULL, 171011),
(171012, '2.30.29.30-FF-000783', NULL, 'RHo Guanine nucleotide exchange Factor', 122, NULL, NULL, 171012),
(171013, '3.40.50.11340-FF-000009', NULL, 'GDP-fucose protein O-fucosyltransferase 2, putative', 193, NULL, NULL, 171013),
(171014, '1.10.287.110-FF-000112', NULL, 'Uncharacterized protein, isoform A', 92, NULL, NULL, 171014),
(171015, '3.10.580.10-FF-000177', NULL, 'Cystathionine beta-synthase', 163, NULL, NULL, 171015),
(171016, '1.10.150.110-FF-000034', NULL, 'MUS81 structure-specific endonuclease subunit', 55, NULL, NULL, 171016),
(171017, '2.60.40.150-FF-000451', NULL, 'Coiled-coil domain-containing protein 33', 121, NULL, NULL, 171017),
(171018, '3.20.20.120-FF-000033', NULL, 'L-amino acid-D/L-Glu epimerase', 240, NULL, NULL, 171018),
(171019, '2.60.120.10-FF-000731', NULL, 'Uncharacterized protein', 130, NULL, NULL, 171019),
(171020, '2.60.40.10-FF-002342', NULL, 'Uncharacterized protein', 91, NULL, NULL, 171020),
(171021, '3.20.20.80-FF-000675', NULL, 'Predicted protein', 346, NULL, NULL, 171021),
(171022, '3.40.800.20-FF-000062', NULL, 'Histone deacetylase', 166, NULL, NULL, 171022),
(171023, '2.60.40.3850-FF-000002', NULL, 'Interleukin-3 receptor subunit alpha', 84, NULL, NULL, 171023),
(171024, '1.10.10.10-FF-000304', NULL, 'LuxR family transcriptional regulator', 67, NULL, NULL, 171024),
(171025, '1.20.120.1320-FF-000019', NULL, NULL, 37, NULL, NULL, 171025),
(171026, '3.20.20.60-FF-000141', NULL, 'Predicted protein', 228, NULL, NULL, 171026),
(171027, '3.30.160.60-FF-005484', NULL, NULL, 42, NULL, NULL, 171027),
(171028, '2.60.120.330-FF-000194', NULL, 'Predicted protein', 170, NULL, NULL, 171028),
(171029, '3.90.1410.10-FF-000034', NULL, 'SET domain-containing protein', 249, NULL, NULL, 171029),
(171030, '1.10.533.10-FF-000104', NULL, 'Si:dkey-103e21.5', 89, NULL, NULL, 171030),
(171031, '2.40.10.10-FF-000233', NULL, 'Blast:Transmembrane protease serine 6', 136, NULL, NULL, 171031),
(171032, '2.30.29.30-FF-000726', NULL, 'AGAP012332-PA', 117, NULL, NULL, 171032),
(171033, '3.50.50.60-FF-001237', NULL, 'Uncharacterized protein', 195, NULL, NULL, 171033),
(171034, '3.40.50.720-FF-001075', NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', 270, NULL, NULL, 171034),
(171035, '3.40.50.1440-FF-000042', NULL, 'Tubulin delta chain', 412, NULL, NULL, 171035),
(171036, '1.10.238.10-FF-001076', NULL, 'Penta-EF-hand domain containing 1', 73, NULL, NULL, 171036),
(171037, '3.20.20.70-FF-000672', NULL, NULL, 208, NULL, NULL, 171037),
(171038, '3.40.50.300-FF-006070', NULL, 'Uncharacterized protein', 163, NULL, NULL, 171038),
(171039, '1.25.10.10-FF-001272', NULL, 'HEAT repeat protein (DRIM), putative', 362, NULL, NULL, 171039),
(171040, '1.10.10.10-FF-000158', NULL, 'La ribonucleoprotein domain family member 7', 92, NULL, NULL, 171040),
(171041, '1.10.238.10-FF-000002', NULL, 'Sodium channel protein', 120, NULL, NULL, 171041),
(171042, '1.25.40.1030-FF-000048', NULL, 'Uncharacterized protein', 249, NULL, NULL, 171042),
(171043, '3.20.20.70-FF-000615', NULL, NULL, 135, NULL, NULL, 171043),
(171044, '3.60.40.10-FF-000086', NULL, 'Protein phosphatase 2C-like protein', 285, NULL, NULL, 171044),
(171045, '3.30.160.60-FF-002701', NULL, 'zinc finger protein 646', 28, NULL, NULL, 171045),
(171046, '3.30.160.60-FF-002645', NULL, 'Transcription factor IIIA', 25, NULL, NULL, 171046);
INSERT INTO "PUBLIC"."MODEL" VALUES
(171047, '3.10.290.10-FF-000076', NULL, 'Ribosomal large subunit pseudouridine synthase D', 67, NULL, NULL, 171047),
(171048, '1.10.560.10-FF-000015', NULL, 'T-complex protein 1 subunit gamma', 231, NULL, NULL, 171048),
(171049, '3.40.50.300-FF-000139', NULL, 'ras-related protein Rab-6A isoform X1', 176, NULL, NULL, 171049),
(171050, '3.40.50.2300-FF-000867', NULL, NULL, 39, NULL, NULL, 171050),
(171051, '1.10.10.1100-FF-000009', NULL, 'Bacterioferritin-associated ferredoxin', 53, NULL, NULL, 171051),
(171052, '1.10.3080.10-FF-000062', NULL, 'Uncharacterized protein MJ0305', 380, NULL, NULL, 171052),
(171053, '2.130.10.10-FF-001651', NULL, 'GM18507', 274, NULL, NULL, 171053),
(171054, '3.90.650.10-FF-000064', NULL, 'Probable phosphoribosylformylglycinamidine synthase', 160, NULL, NULL, 171054),
(171055, '3.30.450.20-FF-000655', NULL, 'Diguanylate cyclase with PAS/PAC sensor', 115, NULL, NULL, 171055),
(171056, '2.30.30.60-FF-000008', NULL, 'Mechanosensitive ion channel protein', 49, NULL, NULL, 171056),
(171057, '3.40.50.300-FF-005518', NULL, 'EIF2-interacting protein ABC50, putative (Fragment)', 128, NULL, NULL, 171057),
(171058, '1.10.630.10-FF-000846', NULL, 'Uncharacterized protein', 92, NULL, NULL, 171058),
(171059, '1.10.238.20-FF-000005', NULL, 'Odorant-binding protein 99a', 122, NULL, NULL, 171059),
(171060, '1.10.510.10-FF-002428', NULL, NULL, 131, NULL, NULL, 171060),
(171061, '2.30.29.30-FF-001002', NULL, 'Rab-GTPase-TBC domain-domain-containing protein', 127, NULL, NULL, 171061),
(171062, '3.40.50.720-FF-002564', NULL, 'Uncharacterized protein', 44, NULL, NULL, 171062),
(171063, '3.30.70.1660-FF-000003', NULL, 'Peptide chain release factor 1', 135, NULL, NULL, 171063),
(171064, '3.30.70.330-FF-001823', NULL, NULL, 189, NULL, NULL, 171064),
(171065, '2.30.30.50-FF-000005', NULL, 'Nitrile hydratase subunit beta', 102, NULL, NULL, 171065),
(171066, '2.60.40.10-FF-000543', NULL, 'Alpha-protein kinase 3', 77, NULL, NULL, 171066),
(171067, '3.30.70.330-FF-001880', NULL, NULL, 97, NULL, NULL, 171067),
(171068, '1.20.190.20-FF-000009', NULL, '14-3-3 protein gamma', 47, NULL, NULL, 171068),
(171069, '1.10.510.10-FF-003446', NULL, NULL, 278, NULL, NULL, 171069),
(171070, '1.25.40.10-FF-000312', NULL, 'Mitochondrial import receptor subunit TOM34', 129, NULL, NULL, 171070),
(171071, '1.10.10.10-FF-000490', NULL, 'DNA-binding response regulator', 108, NULL, NULL, 171071),
(171072, '3.40.930.10-FF-000006', NULL, 'Fructose-specific PTS system IIA component', 142, NULL, NULL, 171072),
(171073, '3.40.50.300-FF-005760', NULL, 'Dynein heavy chain, cytoplasmic', 123, NULL, NULL, 171073),
(171074, '1.20.58.830-FF-000017', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 146, NULL, NULL, 171074),
(171075, '2.130.10.10-FF-005866', NULL, 'Uncharacterized protein', 310, NULL, NULL, 171075),
(171076, '3.30.160.60-FF-005574', NULL, NULL, 41, NULL, NULL, 171076),
(171077, '4.10.280.10-FF-000066', NULL, 'BHLH transcription factor', 69, NULL, NULL, 171077),
(171078, '3.40.50.720-FF-000765', NULL, 'YPL033C-like protein', 236, NULL, NULL, 171078),
(171079, '3.30.1360.40-FF-000029', NULL, 'Ribosome_recycling_factor_-_putative', 73, NULL, NULL, 171079),
(171080, '1.20.1070.10-FF-000929', NULL, 'Uncharacterized protein', 222, NULL, NULL, 171080),
(171081, '1.20.1530.20-FF-000041', NULL, 'Sodium/bile acid cotransporter', 145, NULL, NULL, 171081),
(171082, '2.30.30.40-FF-000002', NULL, 'abl interactor 1 isoform X1', 72, NULL, NULL, 171082),
(171083, '3.40.250.10-FF-000095', NULL, 'Tyrosine phosphatase', 146, NULL, NULL, 171083),
(171084, '3.40.50.150-FF-000223', NULL, 'Caffeic acid 3-O-methyltransferase', 246, NULL, NULL, 171084),
(171085, '3.40.50.1820-FF-000914', NULL, 'Uncharacterized protein', 231, NULL, NULL, 171085),
(171086, '2.10.110.10-FF-000101', NULL, 'Zinc finger protein 185 with LIM domain', 74, NULL, NULL, 171086),
(171087, '3.10.450.240-FF-000010', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 148, NULL, NULL, 171087),
(171088, '1.20.1300.10-FF-000026', NULL, 'Quinol:fumarate reductase menaquinol-oxidizing subunit FrdC', 227, NULL, NULL, 171088);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(171089, '3.30.40.10-FF-001700', NULL, 'Lysine demethylase 5B', 66, NULL, NULL, 171089),
(171090, '1.25.40.20-FF-000315', NULL, 'serine/threonine-protein phosphatase 6 regulatory ankyrin repeat subunit A', 70, NULL, NULL, 171090),
(171091, '1.25.10.10-FF-001890', NULL, 'C11.1, isoform A', 307, NULL, NULL, 171091),
(171092, '3.80.10.10-FF-003236', NULL, 'Uncharacterized protein', 188, NULL, NULL, 171092),
(171093, '2.40.37.20-FF-000011', NULL, NULL, 78, NULL, NULL, 171093),
(171094, '1.25.10.10-FF-001648', NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit', 398, NULL, NULL, 171094),
(171095, '1.10.520.10-FF-000041', NULL, 'Predicted protein', 152, NULL, NULL, 171095),
(171096, '3.40.50.300-FF-002180', NULL, 'ABC transporter ATP-binding protein', 202, NULL, NULL, 171096),
(171097, '1.20.1560.10-FF-000747', NULL, 'Uncharacterized protein', 108, NULL, NULL, 171097),
(171098, '2.130.10.10-FF-002522', NULL, 'AGAP005330-PA-like protein', 262, NULL, NULL, 171098),
(171099, '2.60.40.10-FF-005271', NULL, NULL, 86, NULL, NULL, 171099),
(171100, '3.40.50.720-FF-001018', NULL, '4-phosphoerythronate dehydrogenase', 190, NULL, NULL, 171100),
(171101, '2.40.10.10-FF-000290', NULL, NULL, 40, NULL, NULL, 171101),
(171102, '3.40.50.300-FF-001775', NULL, 'Protein virC1', 212, NULL, NULL, 171102),
(171103, '3.40.50.2000-FF-000991', NULL, 'Uncharacterized protein', 52, NULL, NULL, 171103),
(171104, '3.30.70.680-FF-000001', NULL, 'Tumor necrosis factor receptor type 1-associated DEATH domain protein', 179, NULL, NULL, 171104),
(171105, '3.30.420.40-FF-000552', NULL, 'Related to ARP5-Actin-related protein', 67, NULL, NULL, 171105),
(171106, '2.20.70.10-FF-000013', NULL, 'E3 ubiquitin-protein ligase HECW2 isoform X1', 35, NULL, NULL, 171106),
(171107, '3.40.50.12660-FF-000012', NULL, 'Metacaspase', 337, NULL, NULL, 171107),
(171108, '1.25.40.10-FF-003185', NULL, 'Uncharacterized protein', 97, NULL, NULL, 171108),
(171109, '2.60.120.920-FF-000034', NULL, 'Fibronectin type III and SPRY domain-containing protein 1', 208, NULL, NULL, 171109),
(171110, '3.30.200.20-FF-001491', NULL, 'Uncharacterized protein', 61, NULL, NULL, 171110),
(171111, '1.25.40.10-FF-002965', NULL, 'Pentatricopeptide repeat-containing protein', 127, NULL, NULL, 171111),
(171112, '3.40.1090.10-FF-000020', NULL, 'neuropathy target esterase-like isoform X2', 73, NULL, NULL, 171112),
(171113, '2.60.40.10-FF-001937', NULL, NULL, 92, NULL, NULL, 171113),
(171114, '1.10.287.70-FF-000689', NULL, 'Uncharacterized protein', 78, NULL, NULL, 171114),
(171115, '3.30.930.10-FF-000436', NULL, 'Proline--tRNA ligase', 279, NULL, NULL, 171115),
(171116, '3.90.190.10-FF-000455', NULL, 'Uncharacterized protein', 212, NULL, NULL, 171116),
(171117, '2.130.10.10-FF-005580', NULL, 'Chromosome 16, whole genome shotgun sequence', 206, NULL, NULL, 171117),
(171118, '3.30.230.40-FF-000009', NULL, 'Imidazoleglycerol-phosphate dehydratase', 83, NULL, NULL, 171118),
(171119, '1.20.5.4770-FF-000012', NULL, 'GD13604', 57, NULL, NULL, 171119),
(171120, '3.30.160.60-FF-001774', NULL, 'Myoneurin', 28, NULL, NULL, 171120),
(171121, '3.30.70.330-FF-001262', NULL, 'RNA recognition motif domain containing protein', 115, NULL, NULL, 171121),
(171122, '2.130.10.10-FF-005338', NULL, 'Uncharacterized protein', 183, NULL, NULL, 171122),
(171123, '3.40.50.150-FF-000257', NULL, '16S rRNA methyltransferase', 294, NULL, NULL, 171123),
(171124, '1.20.1280.50-FF-000108', NULL, 'F-box domain containing protein, expressed', 60, NULL, NULL, 171124),
(171125, '1.10.8.10-FF-000028', NULL, 'ATP-dependent protease ATPase subunit HslU', 99, NULL, NULL, 171125),
(171126, '1.20.140.10-FF-000150', NULL, 'Uncharacterized protein', 77, NULL, NULL, 171126),
(171127, '2.40.50.800-FF-000001', NULL, 'Single-stranded TG1-3 telomere G-tails binding protein', 149, NULL, NULL, 171127),
(171128, '3.40.50.300-FF-002028', NULL, 'Related to GTR1-GTP-binding protein', 197, NULL, NULL, 171128),
(171129, '3.30.70.330-FF-001913', NULL, NULL, 67, NULL, NULL, 171129),
(171130, '3.30.200.20-FF-001249', NULL, 'Serine/threonine-protein kinase-like protein At5g23170', 97, NULL, NULL, 171130);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(171131, '2.60.40.10-FF-005922', NULL, NULL, 109, NULL, NULL, 171131),
(171132, '3.40.720.10-FF-000053', NULL, 'GPI ethanolamine phosphate transferase 2 isoform X1', 183, NULL, NULL, 171132),
(171133, '4.10.1240.10-FF-000038', NULL, 'Vasoactive intestinal peptide receptor 2', 71, NULL, NULL, 171133),
(171134, '1.10.30.10-FF-000160', NULL, 'FACT complex subunit SSRP1', 66, NULL, NULL, 171134),
(171135, '3.40.470.10-FF-000016', NULL, 'Uracil-DNA glycosylase', 231, NULL, NULL, 171135),
(171136, '3.40.50.2300-FF-001177', NULL, NULL, 84, NULL, NULL, 171136),
(171137, '3.40.640.10-FF-000052', NULL, 'Aspartate aminotransferase', 242, NULL, NULL, 171137),
(171138, '3.30.980.10-FF-000006', NULL, '39S ribosomal protein L39, mitochondrial', 166, NULL, NULL, 171138),
(171139, '2.130.10.10-FF-001538', NULL, 'Sortilin', 176, NULL, NULL, 171139),
(171140, '3.40.50.300-FF-006541', NULL, 'Uncharacterized protein', 107, NULL, NULL, 171140),
(171141, '3.40.30.10-FF-000805', NULL, 'Putative glutathione S-transferase C460.02c', 79, NULL, NULL, 171141),
(171142, '2.130.10.10-FF-001595', NULL, 'Trichohyalin/putative WD40 domain protein', 280, NULL, NULL, 171142),
(171143, '2.60.40.10-FF-001229', NULL, 'titin isoform X1', 96, NULL, NULL, 171143),
(171144, '3.40.50.2300-FF-001362', NULL, NULL, 18, NULL, NULL, 171144),
(171145, '1.25.40.10-FF-003836', NULL, 'Gamma-soluble NSF attachment protein', 121, NULL, NULL, 171145),
(171146, '3.40.50.2000-FF-000749', NULL, 'Uncharacterized protein', 99, NULL, NULL, 171146),
(171147, '3.40.50.12670-FF-000015', NULL, 'Uncharacterized protein', 79, NULL, NULL, 171147),
(171148, '2.60.200.40-FF-000038', NULL, 'Diacylglycerol kinase, delta', 106, NULL, NULL, 171148),
(171149, '1.10.730.10-FF-000051', NULL, 'Leucine--tRNA ligase', 115, NULL, NULL, 171149),
(171150, '1.10.8.10-FF-000270', NULL, 'E3 ubiquitin-protein ligase AMFR isoform X2', 51, NULL, NULL, 171150),
(171151, '3.30.530.20-FF-000133', NULL, 'Chromosome 19, whole genome shotgun sequence', 160, NULL, NULL, 171151),
(171152, '1.25.40.10-FF-000402', NULL, 'Uncharacterized protein, isoform C', 351, NULL, NULL, 171152),
(171153, '3.40.50.720-FF-001260', NULL, 'Nucleoside-diphosphate-sugar epimerase', 186, NULL, NULL, 171153),
(171154, '1.25.40.20-FF-000405', NULL, 'Serine/threonine-protein phosphatase 6 regulatory ankyrin repeat subunit A', 86, NULL, NULL, 171154),
(171155, '1.10.1450.10-FF-000163', NULL, 'Tetraspanin', 70, NULL, NULL, 171155),
(171156, '3.10.100.10-FF-000001', NULL, 'Hyaluronan proteoglycan link protein 1', 94, NULL, NULL, 171156),
(171157, '3.30.505.10-FF-000145', NULL, 'Tyrosine-protein kinase', 107, NULL, NULL, 171157),
(171158, '1.10.8.470-FF-000002', NULL, 'Serine_hydrolase_(FSH1)/50S_ribosome-binding_GTPase/GTPase_of_uncharacterized_function_C-terminal_-_putative', 87, NULL, NULL, 171158),
(171159, '3.90.245.10-FF-000004', NULL, 'Probable uridine nucleosidase 1', 321, NULL, NULL, 171159),
(171160, '3.20.20.140-FF-000129', NULL, 'Related to guanine deaminase', 124, NULL, NULL, 171160),
(171161, '2.60.40.2240-FF-000002', NULL, 'Acyl-CoA thioesterase 18', 145, NULL, NULL, 171161),
(171162, '1.25.10.10-FF-002053', NULL, 'RING-type E3 ubiquitin transferase', 128, NULL, NULL, 171162),
(171163, '2.60.200.20-FF-000122', NULL, 'Probable serine/threonine-protein kinase fhkC', 116, NULL, NULL, 171163),
(171164, '2.10.70.10-FF-000098', NULL, 'Complement component 4 binding protein beta', 68, NULL, NULL, 171164),
(171165, '3.20.20.140-FF-000039', NULL, 'Adenine deaminase', 344, NULL, NULL, 171165),
(171166, '3.20.20.70-FF-000705', NULL, NULL, 146, NULL, NULL, 171166),
(171167, '3.20.20.80-FF-000618', NULL, 'Uncharacterized protein', 148, NULL, NULL, 171167),
(171168, '3.60.40.10-FF-000176', NULL, 'Protein phosphatase 2C 32', 211, NULL, NULL, 171168),
(171169, '2.30.29.30-FF-001036', NULL, 'Uncharacterized protein', 96, NULL, NULL, 171169),
(171170, '3.20.20.140-FF-000281', NULL, 'Dihydroorotase', 329, NULL, NULL, 171170),
(171171, '3.80.10.10-FF-003326', NULL, 'Si:ch211-191a16.5', 100, NULL, NULL, 171171),
(171172, '3.30.160.60-FF-001589', NULL, 'putative transcription factor Ovo-like 1', 27, NULL, NULL, 171172);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(171173, '2.60.40.1180-FF-000027', NULL, 'Oligo-1,6-glucosidase IMA1', 77, NULL, NULL, 171173),
(171174, '3.20.20.80-FF-000708', NULL, 'Amylo-alpha-1,6-glucosidase family protein', 288, NULL, NULL, 171174),
(171175, '3.60.40.10-FF-000266', NULL, 'Uncharacterized protein', 290, NULL, NULL, 171175),
(171176, '3.40.50.300-FF-001718', NULL, 'Elongation factor Tu, putative', 238, NULL, NULL, 171176),
(171177, '1.20.1560.10-FF-000186', NULL, 'Long-chain fatty acid transporter subunit', 339, NULL, NULL, 171177),
(171178, '3.30.70.2580-FF-000004', NULL, 'Uncharacterized protein', 55, NULL, NULL, 171178),
(171179, '1.20.1560.10-FF-000894', NULL, 'Uncharacterized protein', 14, NULL, NULL, 171179),
(171180, '1.10.30.10-FF-000103', NULL, 'HMG box-containing protein', 70, NULL, NULL, 171180),
(171181, '1.10.510.10-FF-002052', NULL, 'Protein CBG25248', 270, NULL, NULL, 171181),
(171182, '2.60.40.1170-FF-000024', NULL, 'AP-1 complex subunit mu, putative', 114, NULL, NULL, 171182),
(171183, '1.20.1280.50-FF-000165', NULL, 'F-box only protein 31', 79, NULL, NULL, 171183),
(171184, '3.40.50.720-FF-000799', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', 120, NULL, NULL, 171184),
(171185, '3.30.70.2570-FF-000001', NULL, 'Translation factor GUF1, mitochondrial', 75, NULL, NULL, 171185),
(171186, '3.20.20.140-FF-000371', NULL, 'Uncharacterized protein', 220, NULL, NULL, 171186),
(171187, '2.130.10.10-FF-005395', NULL, 'Uncharacterized protein', 149, NULL, NULL, 171187),
(171188, '1.10.220.10-FF-000001', NULL, 'Annexin', 72, NULL, NULL, 171188),
(171189, '2.130.10.10-FF-005956', NULL, 'Uncharacterized protein', 247, NULL, NULL, 171189),
(171190, '2.60.120.10-FF-000641', NULL, 'D-lyxose ketol-isomerase', 171, NULL, NULL, 171190),
(171191, '1.20.58.80-FF-000030', NULL, 'Regulator of free ubiquitin chains 1', 135, NULL, NULL, 171191),
(171192, '3.40.50.720-FF-001636', NULL, 'Ketoreductase', 367, NULL, NULL, 171192),
(171193, '2.60.40.1180-FF-000212', NULL, 'Uncharacterized protein', 71, NULL, NULL, 171193),
(171194, '3.20.20.60-FF-000051', NULL, 'Pyruvate kinase family protein', 163, NULL, NULL, 171194),
(171195, '1.10.3380.10-FF-000045', NULL, 'Uncharacterized protein', 173, NULL, NULL, 171195),
(171196, '3.20.20.70-FF-000054', NULL, 'KHG/KDPG aldolase', 213, NULL, NULL, 171196),
(171197, '2.60.40.150-FF-000541', NULL, 'Translocation protein SEC63-like protein', 129, NULL, NULL, 171197),
(171198, '2.60.40.10-FF-005832', NULL, NULL, 112, NULL, NULL, 171198),
(171199, '2.30.29.30-FF-000693', NULL, 'Pleckstrin domain-containing family J member 1', 122, NULL, NULL, 171199),
(171200, '3.30.1310.10-FF-000012', NULL, 'Nucleoid-associated protein Tpet_0244', 95, NULL, NULL, 171200),
(171201, '3.30.200.20-FF-001159', NULL, 'Si:ch73-206d17.1', 110, NULL, NULL, 171201),
(171202, '3.30.10.20-FF-000010', NULL, 'Serine/threonine-protein kinase PknB', 67, NULL, NULL, 171202),
(171203, '1.20.1310.20-FF-000002', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 197, NULL, NULL, 171203),
(171204, '1.25.40.10-FF-003218', NULL, 'Pentatricopeptide repeat-containing protein', 69, NULL, NULL, 171204),
(171205, '2.130.10.10-FF-001685', NULL, 'WD domain, G-beta repeat-containing protein', 77, NULL, NULL, 171205),
(171206, '3.30.160.60-FF-004270', NULL, NULL, 25, NULL, NULL, 171206),
(171207, '1.20.1250.20-FF-001082', NULL, 'Solute carrier organic anion transporter family member', 225, NULL, NULL, 171207),
(171208, '2.10.25.10-FF-000757', NULL, 'Fibrillin-1', 42, NULL, NULL, 171208),
(171209, '3.40.50.300-FF-001977', NULL, 'Dynamin GTPase, putative', 383, NULL, NULL, 171209),
(171210, '1.25.10.10-FF-000344', NULL, 'Tubulin folding cofactor D', 175, NULL, NULL, 171210),
(171211, '3.30.70.330-FF-003066', NULL, NULL, 155, NULL, NULL, 171211),
(171212, '2.130.10.10-FF-004326', NULL, 'Uncharacterized protein', 103, NULL, NULL, 171212),
(171213, '3.40.50.300-FF-005193', NULL, 'Adenylate kinase, putative', 213, NULL, NULL, 171213),
(171214, '2.30.330.10-FF-000006', NULL, 'SPI-2 type III secretion system apparatus protein SsaQ', 78, NULL, NULL, 171214);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(171215, '1.20.5.110-FF-000358', NULL, 'Syntaxin 1A', 62, NULL, NULL, 171215),
(171216, '3.80.10.10-FF-001651', NULL, 'Leucine-rich repeat protein (LRRP), putative', 94, NULL, NULL, 171216),
(171217, '3.40.1110.10-FF-000079', NULL, 'Phospholipid-transporting ATPase', 155, NULL, NULL, 171217),
(171218, '1.20.1560.10-FF-000899', NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 13', 338, NULL, NULL, 171218),
(171219, '3.40.50.300-FF-004091', NULL, 'Tudor domain-containing 12', 237, NULL, NULL, 171219),
(171220, '1.20.58.480-FF-000013', NULL, 'Uncharacterized protein', 80, NULL, NULL, 171220),
(171221, '3.40.50.720-FF-002098', NULL, 'Uncharacterized protein', 128, NULL, NULL, 171221),
(171222, '3.60.21.10-FF-000435', NULL, 'Uncharacterized protein', 237, NULL, NULL, 171222),
(171223, '3.40.50.150-FF-001100', NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', 325, NULL, NULL, 171223),
(171224, '2.130.10.10-FF-002202', NULL, 'Sema domain, transmembrane domain (TM), and cytoplasmic domain, (semaphorin) 6A', 154, NULL, NULL, 171224),
(171225, '2.60.120.650-FF-000020', NULL, 'Lysine (K)-specific demethylase 5Bb', 255, NULL, NULL, 171225),
(171226, '3.40.30.10-FF-000070', NULL, 'Arsenate reductase', 118, NULL, NULL, 171226),
(171227, '1.20.5.170-FF-000269', NULL, 'ADR293C-Ap', 71, NULL, NULL, 171227),
(171228, '2.40.10.10-FF-000020', NULL, 'Genome polyprotein', 100, NULL, NULL, 171228),
(171229, '1.10.10.10-FF-001799', NULL, 'Selenocysteine-specific translation elongation factor SelB', 66, NULL, NULL, 171229),
(171230, '1.20.58.60-FF-000777', NULL, 'Uncharacterized protein', 228, NULL, NULL, 171230),
(171231, '3.60.21.10-FF-000340', NULL, 'YALI0D13640p', 323, NULL, NULL, 171231),
(171232, '1.20.1270.60-FF-000055', NULL, 'Uncharacterized protein, isoform F', 301, NULL, NULL, 171232),
(171233, '3.30.160.60-FF-006361', NULL, NULL, 35, NULL, NULL, 171233),
(171234, '3.40.50.300-FF-007379', NULL, 'Dynamin 3', 294, NULL, NULL, 171234),
(171235, '3.60.10.10-FF-000146', NULL, 'Endonuclease exonuclease phosphatase family protein', 297, NULL, NULL, 171235),
(171236, '3.90.1170.20-FF-000001', NULL, 'Nicotinate-nucleotide diphosphorylase (Carboxylating)', 118, NULL, NULL, 171236),
(171237, '3.30.70.100-FF-000108', NULL, 'Stress responsive A/B Barrel Domain, putative', 107, NULL, NULL, 171237),
(171238, '3.30.70.1230-FF-000133', NULL, 'Predicted protein', 76, NULL, NULL, 171238),
(171239, '3.20.20.220-FF-000030', NULL, 'Methylenetetrahydrofolate reductase', 291, NULL, NULL, 171239),
(171240, '2.60.40.10-FF-003685', NULL, NULL, 93, NULL, NULL, 171240),
(171241, '2.60.40.150-FF-000035', NULL, 'LOW QUALITY PROTEIN: E3 ubiquitin-protein ligase HECW2', 152, NULL, NULL, 171241),
(171242, '3.40.50.300-FF-006182', NULL, '6-phosphofructo-2-kinase/fructose-2,6-biphosphatase 2b', 36, NULL, NULL, 171242),
(171243, '1.10.10.60-FF-000151', NULL, 'histone H2A deubiquitinase MYSM1 isoform X2', 49, NULL, NULL, 171243),
(171244, '1.10.8.60-FF-000138', NULL, 'ATP-dependent Clp protease ATP-binding subunit ClpX', 104, NULL, NULL, 171244),
(171245, '1.10.630.10-FF-000633', NULL, 'Uncharacterized protein', 227, NULL, NULL, 171245),
(171246, '3.40.50.1010-FF-000172', NULL, NULL, 209, NULL, NULL, 171246),
(171247, '2.30.310.10-FF-000011', NULL, NULL, 161, NULL, NULL, 171247),
(171248, '2.60.40.10-FF-005776', NULL, NULL, 107, NULL, NULL, 171248),
(171249, '3.30.160.60-FF-005372', NULL, NULL, 27, NULL, NULL, 171249),
(171250, '1.10.601.10-FF-000004', NULL, 'RNA polymerase sigma factor sigA', 117, NULL, NULL, 171250),
(171251, '2.10.220.10-FF-000014', NULL, 'Tyrosine-protein kinase receptor', 62, NULL, NULL, 171251),
(171252, '3.40.50.1820-FF-000881', NULL, 'Acyl-protein thioesterase 1 homolog 2', 224, NULL, NULL, 171252),
(171253, '3.40.1500.10-FF-000002', NULL, 'oxygen-dependent coproporphyrinogen-III oxidase, mitochondrial', 332, NULL, NULL, 171253),
(171254, '1.10.1200.210-FF-000001', NULL, 'Chaperonin-like RBCX protein 1, chloroplastic', 128, NULL, NULL, 171254),
(171255, '6.20.200.30-FF-000001', NULL, 'Prostaglandin E synthase 2', 43, NULL, NULL, 171255);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(171256, '3.30.160.270-FF-000004', NULL, '2-isopropylmalate synthase B', 121, NULL, NULL, 171256),
(171257, '1.10.287.110-FF-000027', NULL, 'DnaJ (Hsp40) homolog, subfamily C, member 11', 95, NULL, NULL, 171257),
(171258, '2.10.220.10-FF-000109', NULL, 'Proprotein convertase subtilisin/kexin type 5', 51, NULL, NULL, 171258),
(171259, '2.102.20.10-FF-000001', NULL, 'Beta-galactosidase A', 180, NULL, NULL, 171259),
(171260, '2.130.10.10-FF-004231', NULL, 'Uncharacterized protein', 145, NULL, NULL, 171260),
(171261, '3.30.70.1230-FF-000228', NULL, 'Adenylate cyclase', 201, NULL, NULL, 171261),
(171262, '3.30.160.60-FF-006035', NULL, NULL, 23, NULL, NULL, 171262),
(171263, '1.10.720.30-FF-000067', NULL, 'Vacuole membrane protein 1-like Protein', 69, NULL, NULL, 171263),
(171264, '2.40.33.10-FF-000005', NULL, 'Pyruvate kinase', 107, NULL, NULL, 171264),
(171265, '3.20.10.10-FF-000024', NULL, 'Branched-chain-amino-acid aminotransferase', 176, NULL, NULL, 171265),
(171266, '4.10.400.10-FF-000239', NULL, 'LDL receptor protein 1, isoform F', 43, NULL, NULL, 171266),
(171267, '3.30.40.10-FF-001913', NULL, 'Uncharacterized protein', 111, NULL, NULL, 171267),
(171268, '1.10.8.60-FF-000526', NULL, 'Predicted protein', 14, NULL, NULL, 171268),
(171269, '3.40.50.200-FF-000087', NULL, 'Uncharacterized protein', 92, NULL, NULL, 171269),
(171270, '2.60.40.10-FF-002550', NULL, 'Titin homolog', 103, NULL, NULL, 171270),
(171271, '1.25.40.10-FF-003398', NULL, 'Putative pentatricopeptide repeat-containing protein At3g18840', 134, NULL, NULL, 171271),
(171272, '1.20.5.900-FF-000005', NULL, 'Uncharacterized protein', 39, NULL, NULL, 171272),
(171273, '1.20.1280.50-FF-000075', NULL, 'F-box protein SKIP1', 42, NULL, NULL, 171273),
(171274, '3.40.630.30-FF-000411', NULL, 'protein O-GlcNAcase-like isoform X2', 204, NULL, NULL, 171274),
(171275, '3.40.50.720-FF-001642', NULL, 'YALI0F09075p', 316, NULL, NULL, 171275),
(171276, '3.30.160.60-FF-003859', NULL, NULL, 31, NULL, NULL, 171276),
(171277, '1.10.287.130-FF-000264', NULL, 'Two component system histidine kinase', 82, NULL, NULL, 171277),
(171278, '3.40.50.2300-FF-001295', NULL, NULL, 137, NULL, NULL, 171278),
(171279, '3.30.420.110-FF-000073', NULL, 'DNA mismatch repair protein MSH3', 134, NULL, NULL, 171279),
(171280, '2.60.120.10-FF-000259', NULL, 'Cyclic nucleotide-binding protein', 120, NULL, NULL, 171280),
(171281, '1.20.58.2220-FF-000028', NULL, 'Formin-D', 385, NULL, NULL, 171281),
(171282, '3.40.50.300-FF-001926', NULL, 'Putative GTP-binding protein', 190, NULL, NULL, 171282),
(171283, '3.10.580.10-FF-000115', NULL, 'Manganese-dependent inorganic pyrophosphatase, putative', 52, NULL, NULL, 171283),
(171284, '3.20.20.60-FF-000017', NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', 272, NULL, NULL, 171284),
(171285, '3.40.50.1000-FF-000264', NULL, 'TIGR01456 family HAD hydrolase', 153, NULL, NULL, 171285),
(171286, '3.40.50.150-FF-000162', NULL, 'Orf1ab polyprotein', 299, NULL, NULL, 171286),
(171287, '1.10.510.10-FF-003912', NULL, NULL, 79, NULL, NULL, 171287),
(171288, '3.30.870.30-FF-000004', NULL, 'MIT domain-containing protein 1', 64, NULL, NULL, 171288),
(171289, '2.130.10.10-FF-002140', NULL, 'WD domain, G-beta repeat/PFU (PLAA family ubiquitin binding), putative', 228, NULL, NULL, 171289),
(171290, '3.40.50.1010-FF-000267', NULL, NULL, 149, NULL, NULL, 171290),
(171291, '1.10.1040.10-FF-000082', NULL, 'Uncharacterized protein', 108, NULL, NULL, 171291),
(171292, '3.30.160.60-FF-001089', NULL, 'zinc finger protein 140 isoform X2', 32, NULL, NULL, 171292),
(171293, '3.30.70.330-FF-001621', NULL, NULL, 76, NULL, NULL, 171293),
(171294, '2.60.40.10-FF-003910', NULL, NULL, 151, NULL, NULL, 171294),
(171295, '3.40.640.10-FF-000170', NULL, '4-aminobutyrate aminotransferase', 260, NULL, NULL, 171295),
(171296, '3.30.420.40-FF-000985', NULL, 'Actin-related protein 8', 107, NULL, NULL, 171296),
(171297, '1.20.5.100-FF-000029', NULL, 'Uncharacterized protein', 75, NULL, NULL, 171297),
(171298, '3.30.1360.120-FF-000037', NULL, 'Glycine cleavage T protein-like', 259, NULL, NULL, 171298);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(171299, '1.10.3380.10-FF-000040', NULL, 'Activating signal cointegrator 1 complex subunit 3', 136, NULL, NULL, 171299),
(171300, '3.40.50.300-FF-005934', NULL, 'Type II secretion system protein, virB homolog (GspE-1)', 282, NULL, NULL, 171300),
(171301, '3.30.160.60-FF-001768', NULL, 'Zinc finger and BTB domain-containing protein 45', 26, NULL, NULL, 171301),
(171302, '3.80.10.10-FF-004198', NULL, 'Uncharacterized protein', 90, NULL, NULL, 171302),
(171303, '2.60.120.200-FF-000296', NULL, 'Cadherin-related hmr-1', 161, NULL, NULL, 171303),
(171304, '3.40.50.410-FF-000083', NULL, 'Poly [ADP-ribose] polymerase', 171, NULL, NULL, 171304),
(171305, '3.40.30.10-FF-000811', NULL, 'Glutathione S-transferase, putative', 60, NULL, NULL, 171305),
(171306, '3.40.50.2060-FF-000020', NULL, 'Vacuolar protein sorting-associated protein 33A', 133, NULL, NULL, 171306),
(171307, '3.40.50.720-FF-001428', NULL, 'CurK', 248, NULL, NULL, 171307),
(171308, '1.25.40.10-FF-004758', NULL, 'Uncharacterized protein', 61, NULL, NULL, 171308),
(171309, '3.40.980.10-FF-000009', NULL, 'Molybdopterin molybdenumtransferase', 156, NULL, NULL, 171309),
(171310, '1.20.59.10-FF-000017', NULL, 'Chorismate mutase family protein', 97, NULL, NULL, 171310),
(171311, '3.90.1750.10-FF-000025', NULL, 'Putative E3 ubiquitin-protein ligase HECTD3', 138, NULL, NULL, 171311),
(171312, '1.10.510.10-FF-002552', NULL, 'Uncharacterized protein', 282, NULL, NULL, 171312),
(171313, '2.130.10.10-FF-003337', NULL, 'YALI0E28226p', 214, NULL, NULL, 171313),
(171314, '3.60.21.10-FF-000109', NULL, 'UDP-2,3-diacylglucosamine hydrolase', 239, NULL, NULL, 171314),
(171315, '1.10.287.110-FF-000078', NULL, 'Chaperone protein dnaJ 49', 129, NULL, NULL, 171315),
(171316, '3.40.366.10-FF-000049', NULL, 'Uncharacterized protein', 157, NULL, NULL, 171316),
(171317, '3.20.20.70-FF-000346', NULL, 'Thiamine-phosphate synthase', 194, NULL, NULL, 171317),
(171318, '2.30.29.30-FF-000159', NULL, 'mRNA-decapping enzyme-like protein', 128, NULL, NULL, 171318),
(171319, '2.30.110.10-FF-000063', NULL, 'Unplaced genomic scaffold supercont1.16, whole genome shotgun sequence', 136, NULL, NULL, 171319),
(171320, '2.60.40.10-FF-000184', NULL, 'cell adhesion molecule 1 isoform X2', 100, NULL, NULL, 171320),
(171321, '3.40.50.300-FF-004411', NULL, 'Dynamin-like 120 kDa protein, mitochondrial', 181, NULL, NULL, 171321),
(171322, '3.30.40.10-FF-001060', NULL, 'Uncharacterized protein', 79, NULL, NULL, 171322),
(171323, '3.30.420.10-FF-000178', NULL, 'Ribonuclease', 186, NULL, NULL, 171323),
(171324, '1.10.3260.10-FF-000042', NULL, 'Ligase4-like protein', 208, NULL, NULL, 171324),
(171325, '3.30.70.1320-FF-000008', NULL, 'RND multidrug efflux transporter', 98, NULL, NULL, 171325),
(171326, '2.120.10.80-FF-000020', NULL, 'Kelch repeat and BTB domain-containing protein 8', 326, NULL, NULL, 171326),
(171327, '2.60.40.790-FF-000120', NULL, 'Related to SGT1 protein', 112, NULL, NULL, 171327),
(171328, '2.170.270.10-FF-000114', NULL, 'PR domain zinc finger protein 10-like Protein', 169, NULL, NULL, 171328),
(171329, '3.30.710.10-FF-000397', NULL, 'BTB/POZ domain-containing protein 3', 119, NULL, NULL, 171329),
(171330, '2.60.120.10-FF-000164', NULL, 'Crp/Fnr family transcriptional regulator', 149, NULL, NULL, 171330),
(171331, '3.30.565.10-FF-000210', NULL, 'Two-component sensor histidine kinase', 145, NULL, NULL, 171331),
(171332, '3.30.200.20-FF-001547', NULL, 'Probable protein kinase DDB_G0277539', 110, NULL, NULL, 171332),
(171333, '2.130.10.10-FF-003388', NULL, 'Uncharacterized protein', 371, NULL, NULL, 171333),
(171334, '3.50.50.60-FF-001097', NULL, 'Predicted protein', 244, NULL, NULL, 171334),
(171335, '3.60.10.10-FF-000197', NULL, 'ANGeL-like deadenylase', 258, NULL, NULL, 171335),
(171336, '3.30.930.10-FF-000262', NULL, 'Aminoacyl-tRNA synthetase, class II (D, K and N) domain protein', 328, NULL, NULL, 171336),
(171337, '1.20.960.10-FF-000009', NULL, 'Uncharacterized protein', 94, NULL, NULL, 171337),
(171338, '2.40.50.150-FF-000031', NULL, 'DNA-directed RNA polymerase III subunit rpc2', 135, NULL, NULL, 171338);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(171339, '1.20.120.1750-FF-000131', NULL, 'RBR-type E3 ubiquitin transferase', 80, NULL, NULL, 171339),
(171340, '3.30.70.330-FF-001672', NULL, NULL, 108, NULL, NULL, 171340),
(171341, '2.170.270.10-FF-000002', NULL, 'Histone-lysine N-methyltransferase', 229, NULL, NULL, 171341),
(171342, '1.25.70.10-FF-000027', NULL, 'Os05g0413000 protein', 224, NULL, NULL, 171342),
(171343, '1.25.40.20-FF-000528', NULL, 'Kinase, NEK', 56, NULL, NULL, 171343),
(171344, '3.30.450.20-FF-000576', NULL, 'Neuronal PAS domain protein 4a', 78, NULL, NULL, 171344),
(171345, '1.10.472.80-FF-000123', NULL, 'GTPase activating protein, conserved', 139, NULL, NULL, 171345),
(171346, '1.10.1420.10-FF-000009', NULL, 'DNA mismatch repair protein', 102, NULL, NULL, 171346),
(171347, '2.130.10.10-FF-000162', NULL, 'vacuolar protein sorting-associated protein 8 homolog', 252, NULL, NULL, 171347),
(171348, '1.25.10.10-FF-000018', NULL, 'E3 ubiquitin-protein ligase TRIP12 isoform X3', 292, NULL, NULL, 171348),
(171349, '2.60.120.260-FF-000639', NULL, 'Uncharacterized protein', 105, NULL, NULL, 171349),
(171350, '3.90.70.80-FF-000091', NULL, 'Uncharacterized protein', 67, NULL, NULL, 171350),
(171351, '3.40.50.450-FF-000083', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit beta 2', 66, NULL, NULL, 171351),
(171352, '2.60.200.20-FF-000201', NULL, 'Uncharacterized protein', 132, NULL, NULL, 171352),
(171353, '3.90.550.10-FF-000612', NULL, 'Uncharacterized protein', 216, NULL, NULL, 171353),
(171354, '3.40.50.300-FF-004832', NULL, 'RecBCD enzyme subunit RecB', 251, NULL, NULL, 171354),
(171355, '2.40.50.100-FF-000156', NULL, 'Uncharacterized protein', 50, NULL, NULL, 171355),
(171356, '3.30.70.980-FF-000040', NULL, 'Probable transcriptional regulatory protein XCC3027', 77, NULL, NULL, 171356),
(171357, '2.130.10.120-FF-000003', NULL, 'Protease II', 334, NULL, NULL, 171357),
(171358, '1.10.510.10-FF-000186', NULL, 'Mitogen-activated protein kinase kinase kinase', 283, NULL, NULL, 171358),
(171359, '1.20.1110.10-FF-000080', NULL, 'Plasma membrane ATPase', 147, NULL, NULL, 171359),
(171360, '1.10.238.10-FF-001284', NULL, 'Uncharacterized protein', 58, NULL, NULL, 171360),
(171361, '1.25.10.10-FF-001704', NULL, 'Hsp70 nucleotide exchange factor FES1', 250, NULL, NULL, 171361),
(171362, '2.60.120.200-FF-000649', NULL, 'Laminin subunit alpha 5', 102, NULL, NULL, 171362),
(171363, '3.40.50.150-FF-001685', NULL, NULL, 120, NULL, NULL, 171363),
(171364, '3.40.50.300-FF-005288', NULL, 'Shikimate kinase', 176, NULL, NULL, 171364),
(171365, '2.130.10.10-FF-003663', NULL, 'Uncharacterized protein', 325, NULL, NULL, 171365),
(171366, '2.60.40.10-FF-000133', NULL, 'Neogenin isoform 1', 102, NULL, NULL, 171366),
(171367, '3.30.160.60-FF-003455', NULL, 'ZNF749 isoform 1', 44, NULL, NULL, 171367),
(171368, '3.40.33.10-FF-000104', NULL, 'OSJNBb0096E05.15 protein', 140, NULL, NULL, 171368),
(171369, '3.40.50.10090-FF-000078', NULL, 'Uncharacterized protein', 138, NULL, NULL, 171369),
(171370, '1.10.1040.10-FF-000109', NULL, 'Uncharacterized protein', 135, NULL, NULL, 171370),
(171371, '3.30.160.60-FF-006147', NULL, NULL, 41, NULL, NULL, 171371),
(171372, '1.10.10.60-FF-001286', NULL, NULL, 54, NULL, NULL, 171372),
(171373, '2.30.130.10-FF-000025', NULL, 'tRNA pseudouridine synthase B', 60, NULL, NULL, 171373),
(171374, '1.10.510.10-FF-002226', NULL, NULL, 123, NULL, NULL, 171374),
(171375, '3.30.160.60-FF-000633', NULL, 'Zinc finger and BTB domain containing 11', 28, NULL, NULL, 171375),
(171376, '3.30.40.10-FF-002369', NULL, 'Ubiquitinyl hydrolase 1', 51, NULL, NULL, 171376),
(171377, '1.10.3720.10-FF-000061', NULL, 'Peptide ABC transporter permease', 211, NULL, NULL, 171377),
(171378, '1.10.238.10-FF-000502', NULL, 'Probable calcium-binding protein CML30', 114, NULL, NULL, 171378),
(171379, '4.10.240.10-FF-000204', NULL, 'Uncharacterized protein', 92, NULL, NULL, 171379),
(171380, '1.10.8.60-FF-000464', NULL, 'Uncharacterized protein', 69, NULL, NULL, 171380),
(171381, '3.40.50.300-FF-002320', NULL, 'Shikimate kinase', 176, NULL, NULL, 171381);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(171382, '3.30.70.330-FF-002869', NULL, NULL, 74, NULL, NULL, 171382),
(171383, '3.70.10.10-FF-000005', NULL, 'Cell cycle checkpoint control protein', 266, NULL, NULL, 171383),
(171384, '1.10.287.70-FF-000279', NULL, 'Cyclic nucleotide-gated ion channel 18', 264, NULL, NULL, 171384),
(171385, '1.10.10.60-FF-000797', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', 115, NULL, NULL, 171385),
(171386, '2.130.10.10-FF-005754', NULL, 'Protein CBG24565', 119, NULL, NULL, 171386),
(171387, '2.60.40.10-FF-002224', NULL, 'Uncharacterized protein', 90, NULL, NULL, 171387),
(171388, '1.50.40.10-FF-000400', NULL, 'Carnitine/acylcarnitine translocase', 170, NULL, NULL, 171388),
(171389, '2.130.10.10-FF-001297', NULL, 'RNA polymerase II Elongator subunit, putative', 80, NULL, NULL, 171389),
(171390, '1.10.510.10-FF-000135', NULL, 'Putative myosin light chain kinase 3', 218, NULL, NULL, 171390),
(171391, '1.10.268.10-FF-000004', NULL, 'DNA topoisomerase 2', 168, NULL, NULL, 171391),
(171392, '3.30.200.20-FF-002036', NULL, 'Serine/threonine-protein kinase fray1', 90, NULL, NULL, 171392),
(171393, '2.130.10.10-FF-000111', NULL, 'Transcriptional repressor rco-1', 360, NULL, NULL, 171393),
(171394, '3.30.40.10-FF-001172', NULL, 'Elfless, isoform B', 121, NULL, NULL, 171394),
(171395, '1.10.1740.10-FF-000005', NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', 82, NULL, NULL, 171395),
(171396, '1.10.630.10-FF-000307', NULL, 'Protein CBG06602', 268, NULL, NULL, 171396),
(171397, '2.60.40.790-FF-000171', NULL, NULL, 155, NULL, NULL, 171397),
(171398, '3.30.230.70-FF-000001', NULL, 'Polyribonucleotide nucleotidyltransferase', 232, NULL, NULL, 171398),
(171399, '1.10.10.60-FF-000100', NULL, 'AraC family transcriptional regulator', 111, NULL, NULL, 171399),
(171400, '3.40.50.1820-FF-000976', NULL, 'Uncharacterized protein', 263, NULL, NULL, 171400),
(171401, '3.30.420.110-FF-000022', NULL, 'DNA mismatch repair protein Msh1', 134, NULL, NULL, 171401),
(171402, '4.10.680.10-FF-000001', NULL, 'activated CDC42 kinase 1 isoform X1', 40, NULL, NULL, 171402),
(171403, '1.25.10.10-FF-001479', NULL, 'eIF-2-alpha kinase activator GCN1', 161, NULL, NULL, 171403),
(171404, '3.40.109.10-FF-000020', NULL, 'Oxygen-insensitive NADPH nitroreductase', 244, NULL, NULL, 171404),
(171405, '3.40.50.720-FF-001316', NULL, 'Uncharacterized protein', 285, NULL, NULL, 171405),
(171406, '3.10.110.10-FF-000007', NULL, 'Ubiquitin-conjugating enzyme E2 2', 151, NULL, NULL, 171406),
(171407, '3.30.200.20-FF-000350', NULL, 'Cyclin-dependent kinase e-1', 96, NULL, NULL, 171407),
(171408, '1.10.287.160-FF-000014', NULL, 'Protein Kinase N (PKN) homolog', 75, NULL, NULL, 171408),
(171409, '2.60.120.330-FF-000155', NULL, 'Uncharacterized protein', 92, NULL, NULL, 171409),
(171410, '3.40.50.1820-FF-001605', NULL, 'Uncharacterized protein', 78, NULL, NULL, 171410),
(171411, '3.40.50.300-FF-003517', NULL, 'Activator 1 subunit, putative', 171, NULL, NULL, 171411),
(171412, '1.20.5.110-FF-000184', NULL, 'Qb-SNARE protein, putative', 80, NULL, NULL, 171412),
(171413, '1.20.58.390-FF-000172', NULL, 'Uncharacterized protein', 116, NULL, NULL, 171413),
(171414, '1.20.1070.10-FF-001334', NULL, 'Uncharacterized protein', 277, NULL, NULL, 171414),
(171415, '3.30.70.330-FF-000778', NULL, 'RNA-binding protein-like protein', 118, NULL, NULL, 171415),
(171416, '2.60.40.60-FF-000120', NULL, 'Protocadherin 8', 103, NULL, NULL, 171416),
(171417, '3.40.630.10-FF-000225', NULL, 'YALI0A20416p', 256, NULL, NULL, 171417),
(171418, '3.10.20.90-FF-000094', NULL, 'Sorting nexin-17 isoform1', 97, NULL, NULL, 171418),
(171419, '1.20.1270.280-FF-000021', NULL, 'Dynein heavy chain at 16F', 171, NULL, NULL, 171419),
(171420, '3.30.830.10-FF-000001', NULL, 'Mitochondrial-processing peptidase subunit beta, mitochondrial', 215, NULL, NULL, 171420),
(171421, '3.40.50.2300-FF-001570', NULL, NULL, 157, NULL, NULL, 171421),
(171422, '3.30.160.60-FF-002550', NULL, 'Si:ch73-221f6.3', 26, NULL, NULL, 171422),
(171423, '2.130.10.10-FF-001746', NULL, 'Uncharacterized protein', 334, NULL, NULL, 171423);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(171424, '3.30.70.260-FF-000049', NULL, 'Diaminopimelate decarboxylase, putative', 72, NULL, NULL, 171424),
(171425, '2.130.10.10-FF-002314', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', 192, NULL, NULL, 171425),
(171426, '1.10.530.10-FF-000070', NULL, 'Uncharacterized protein', 107, NULL, NULL, 171426),
(171427, '1.10.287.940-FF-000001', NULL, 'P2X purinoceptor', 41, NULL, NULL, 171427),
(171428, '3.60.21.10-FF-000261', NULL, 'Capsular biosynthesis protein', 226, NULL, NULL, 171428),
(171429, '1.10.1200.10-FF-000066', NULL, 'Phenyloxazoline synthase MbtB', 76, NULL, NULL, 171429),
(171430, '3.30.70.100-FF-000029', NULL, 'Zinc/cadmium/lead-transporting P-type ATPase', 72, NULL, NULL, 171430),
(171431, '3.30.40.10-FF-001560', NULL, 'Replication termination factor 2', 138, NULL, NULL, 171431),
(171432, '3.40.50.300-FF-002415', NULL, 'Probable ATP-dependent RNA helicase DDX28', 169, NULL, NULL, 171432),
(171433, '3.30.70.330-FF-001054', NULL, 'RNA-binding protein, putative', 85, NULL, NULL, 171433),
(171434, '3.30.70.1970-FF-000001', NULL, 'RET2, RNA editing complex MP57', 97, NULL, NULL, 171434),
(171435, '1.10.287.950-FF-000004', NULL, 'Methyl-accepting chemotaxis protein', 309, NULL, NULL, 171435),
(171436, '3.40.30.10-FF-000518', NULL, 'Glutathione peroxidase', 134, NULL, NULL, 171436),
(171437, '3.30.160.60-FF-001982', NULL, 'MEP-1, isoform A', 63, NULL, NULL, 171437),
(171438, '3.40.50.2000-FF-001098', NULL, 'Uncharacterized protein', 57, NULL, NULL, 171438),
(171439, '3.30.1680.10-FF-000005', NULL, 'Integrin beta', 59, NULL, NULL, 171439),
(171440, '3.40.50.1220-FF-000066', NULL, 'NAD-dependent protein deacetylase sir-2.4', 167, NULL, NULL, 171440),
(171441, '2.30.30.40-FF-000154', NULL, 'Alpha spectrin, isoform C', 56, NULL, NULL, 171441),
(171442, '3.60.10.10-FF-000258', NULL, 'Uncharacterized protein', 375, NULL, NULL, 171442),
(171443, '1.20.1310.10-FF-000061', NULL, 'Related to cullulin 3', 152, NULL, NULL, 171443),
(171444, '3.30.70.240-FF-000043', NULL, 'Uncharacterized protein', 117, NULL, NULL, 171444),
(171445, '3.30.200.20-FF-001098', NULL, 'Spore coat protein S', 100, NULL, NULL, 171445),
(171446, '2.60.40.10-FF-000212', NULL, 'Immunoglobulin kappa chain variable 12-38', 116, NULL, NULL, 171446),
(171447, '3.30.70.1230-FF-000021', NULL, 'Adenylate cyclase type 10', 217, NULL, NULL, 171447),
(171448, '2.40.160.60-FF-000011', NULL, 'Long-chain fatty acid transport protein', 410, NULL, NULL, 171448),
(171449, '2.10.50.10-FF-000063', NULL, 'signal peptide, CUB and EGF-like domain-containing protein 3 isoform X4', 51, NULL, NULL, 171449),
(171450, '1.20.58.1000-FF-000005', NULL, 'Copper homeostasis operon regulatory protein', 94, NULL, NULL, 171450),
(171451, '1.10.287.70-FF-000358', NULL, 'Uncharacterized protein', 140, NULL, NULL, 171451),
(171452, '2.10.25.10-FF-000645', NULL, 'Protocadherin Fat 2', 36, NULL, NULL, 171452),
(171453, '3.40.50.300-FF-000342', NULL, 'Protein strawberry notch homolog 2', 193, NULL, NULL, 171453),
(171454, '3.10.280.10-FF-000019', NULL, 'Mitochondrial acidic protein MAM33', 116, NULL, NULL, 171454),
(171455, '3.30.70.660-FF-000079', NULL, 'Zgc:56653 protein', 44, NULL, NULL, 171455),
(171456, '2.30.30.30-FF-000151', NULL, 'Os01g0140500 protein', 66, NULL, NULL, 171456),
(171457, '2.30.30.100-FF-000166', NULL, 'SnRNP Sm related protein', 94, NULL, NULL, 171457),
(171458, '2.60.40.10-FF-003859', NULL, NULL, 109, NULL, NULL, 171458),
(171459, '3.10.20.740-FF-000002', NULL, 'NADH-quinone oxidoreductase', 127, NULL, NULL, 171459),
(171460, '3.40.50.20-FF-000085', NULL, 'Predicted protein', 70, NULL, NULL, 171460),
(171461, '3.40.50.620-FF-000595', NULL, 'Diphthamide biosynthesis protein Dph6', 139, NULL, NULL, 171461),
(171462, '2.30.29.30-FF-001148', NULL, 'Uncharacterized protein', 112, NULL, NULL, 171462),
(171463, '2.60.120.330-FF-000104', NULL, 'Validamycin A dioxygenase', 319, NULL, NULL, 171463),
(171464, '2.30.39.10-FF-000159', NULL, 'Uncharacterized protein', 98, NULL, NULL, 171464);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(171465, '1.10.472.80-FF-000174', NULL, NULL, 127, NULL, NULL, 171465),
(171466, '3.40.50.300-FF-004214', NULL, 'DNA replication licensing factor MCM7', 166, NULL, NULL, 171466),
(171467, '1.20.1250.20-FF-001143', NULL, 'Uncharacterized protein', 198, NULL, NULL, 171467),
(171468, '1.10.580.10-FF-000022', NULL, 'Citrate synthase', 32, NULL, NULL, 171468),
(171469, '1.10.418.10-FF-000151', NULL, 'Hook microtubule-tethering protein 2', 115, NULL, NULL, 171469),
(171470, '2.60.120.10-FF-000085', NULL, 'Cyclic nucleotide-binding domain protein', 197, NULL, NULL, 171470),
(171471, '1.10.287.370-FF-000077', NULL, 'Predicted protein', 135, NULL, NULL, 171471),
(171472, '1.10.10.60-FF-000504', NULL, 'Transcription factor RFX3', 102, NULL, NULL, 171472),
(171473, '1.25.10.10-FF-001979', NULL, 'Protein CELLULOSE SYNTHASE INTERACTIVE 1', 162, NULL, NULL, 171473),
(171474, '1.20.1110.10-FF-000141', NULL, 'Calcium-transporting ATPase', 294, NULL, NULL, 171474),
(171475, '1.25.10.10-FF-002261', NULL, 'AGAP000048-PA', 352, NULL, NULL, 171475),
(171476, '3.30.160.60-FF-000521', NULL, 'Krueppel-like factor 9', 31, NULL, NULL, 171476),
(171477, '1.20.1560.10-FF-000692', NULL, 'Uncharacterized protein', 337, NULL, NULL, 171477),
(171478, '1.20.120.530-FF-000011', NULL, 'Transcriptional regulator, GntR family', 138, NULL, NULL, 171478),
(171479, '2.60.40.10-FF-001089', NULL, 'Titin novex-3', 89, NULL, NULL, 171479),
(171480, '3.70.10.10-FF-000117', NULL, 'Uncharacterized protein', 186, NULL, NULL, 171480),
(171481, '3.30.830.10-FF-000052', NULL, 'Ubiquinol-cytochrome c reductase core protein 2', 140, NULL, NULL, 171481),
(171482, '2.30.29.170-FF-000027', NULL, NULL, 117, NULL, NULL, 171482),
(171483, '1.10.40.60-FF-000006', NULL, 'Type II secretion system protein K', 62, NULL, NULL, 171483),
(171484, '2.60.120.10-FF-000490', NULL, 'YALI0F27819p', 91, NULL, NULL, 171484),
(171485, '3.20.200.10-FF-000012', NULL, 'Uncharacterized protein', 110, NULL, NULL, 171485),
(171486, '1.50.40.10-FF-000512', NULL, 'Mitochondrial fusion and transport protein ugo1', 198, NULL, NULL, 171486),
(171487, '2.130.10.10-FF-000515', NULL, 'Autophagy-related 16, isoform C', 154, NULL, NULL, 171487),
(171488, '3.90.850.10-FF-000045', NULL, NULL, 146, NULL, NULL, 171488),
(171489, '3.40.720.10-FF-000171', NULL, 'Bisphosphoglycerate-independent phosphoglycerate mutase family protein', 215, NULL, NULL, 171489),
(171490, '3.40.50.1000-FF-000090', NULL, 'Putative transferase', 164, NULL, NULL, 171490),
(171491, '1.20.1310.20-FF-000064', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 194, NULL, NULL, 171491),
(171492, '4.10.280.10-FF-000038', NULL, 'achaete-scute homolog 3', 56, NULL, NULL, 171492),
(171493, '3.20.20.10-FF-000064', NULL, 'Pyridoxal phosphate homeostasis protein', 223, NULL, NULL, 171493),
(171494, '3.30.160.60-FF-003781', NULL, NULL, 49, NULL, NULL, 171494),
(171495, '1.10.10.60-FF-001174', NULL, NULL, 40, NULL, NULL, 171495),
(171496, '2.30.42.10-FF-000566', NULL, NULL, 105, NULL, NULL, 171496),
(171497, '3.30.780.10-FF-000019', NULL, 'Putative translation factor sui1', 106, NULL, NULL, 171497),
(171498, '3.40.50.300-FF-002820', NULL, 'Chromosomal replication initiator protein DnaA', 180, NULL, NULL, 171498),
(171499, '3.40.50.11500-FF-000024', NULL, NULL, 45, NULL, NULL, 171499),
(171500, '3.30.365.10-FF-000049', NULL, 'Isoquinoline 1-oxidoreductase, beta subunit, putative', 93, NULL, NULL, 171500),
(171501, '3.30.40.10-FF-001234', NULL, 'Lysine (K)-specific demethylase 2Aa', 70, NULL, NULL, 171501),
(171502, '2.30.29.30-FF-000485', NULL, 'Ran-binding protein', 194, NULL, NULL, 171502),
(171503, '3.30.200.20-FF-001047', NULL, 'Elongation factor-2 kinase, putative', 124, NULL, NULL, 171503),
(171504, '3.40.50.1010-FF-000093', NULL, 'Exonuclease, putative', 212, NULL, NULL, 171504),
(171505, '2.130.10.10-FF-001797', NULL, 'Ribosome biogenesis protein WDR12 homolog', 195, NULL, NULL, 171505),
(171506, '2.130.10.10-FF-002640', NULL, 'Sema domain, transmembrane domain (TM), and cytoplasmic domain, (semaphorin) 6D,-like', 181, NULL, NULL, 171506);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(171507, '3.30.250.20-FF-000010', NULL, 'Uncharacterized protein', 51, NULL, NULL, 171507),
(171508, '3.20.20.80-FF-000175', NULL, 'Alpha-1,3-glucan synthase Ags2', 136, NULL, NULL, 171508),
(171509, '2.30.180.10-FF-000062', NULL, 'Vacuolar membrane protein, putative', 144, NULL, NULL, 171509),
(171510, '2.40.155.10-FF-000006', NULL, 'GD10735', 252, NULL, NULL, 171510),
(171511, '1.10.10.440-FF-000053', NULL, 'TransCription Elongation Regulator homolog', 60, NULL, NULL, 171511),
(171512, '3.40.50.1260-FF-000049', NULL, 'Uncharacterized protein', 101, NULL, NULL, 171512),
(171513, '3.30.40.10-FF-001464', NULL, 'Uncharacterized protein', 90, NULL, NULL, 171513),
(171514, '1.10.1580.10-FF-000021', NULL, 'Mitochondrial GTPase, putative', 91, NULL, NULL, 171514),
(171515, '3.40.50.720-FF-001142', NULL, 'NmrA family protein', 205, NULL, NULL, 171515),
(171516, '3.30.70.2190-FF-000005', NULL, 'FAD-binding oxidoreductase', 115, NULL, NULL, 171516),
(171517, '3.30.420.10-FF-000066', NULL, 'DNA polymerase theta', 257, NULL, NULL, 171517),
(171518, '3.40.50.2000-FF-000867', NULL, 'UDP-N-acetylglucosamine 2-epimerase', 196, NULL, NULL, 171518),
(171519, '1.10.1370.30-FF-000022', NULL, 'Angiotensin-converting enzyme', 231, NULL, NULL, 171519),
(171520, '3.30.1330.80-FF-000017', NULL, 'AT hook motif DNA-binding family protein', 132, NULL, NULL, 171520),
(171521, '3.30.70.1450-FF-000002', NULL, 'Trk system potassium transporter TrkA', 92, NULL, NULL, 171521),
(171522, '3.30.200.20-FF-001659', NULL, 'Uncharacterized protein', 146, NULL, NULL, 171522),
(171523, '3.30.200.20-FF-001373', NULL, 'Eukaryotic translation initiation factor 2 alpha kinase 1', 123, NULL, NULL, 171523),
(171524, '3.20.20.70-FF-000172', NULL, 'D-allulose-6-phosphate 3-epimerase', 231, NULL, NULL, 171524),
(171525, '3.40.50.300-FF-006131', NULL, 'Predicted protein', 139, NULL, NULL, 171525),
(171526, '2.120.10.80-FF-000132', NULL, 'F-box/kelch-repeat protein', 112, NULL, NULL, 171526),
(171527, '1.20.1250.40-FF-000014', NULL, 'RNA polymerase II Rpb4 core protein', 129, NULL, NULL, 171527),
(171528, '3.40.50.300-FF-003955', NULL, 'Ras homolog family member B', 146, NULL, NULL, 171528),
(171529, '1.25.40.1010-FF-000003', NULL, 'N-alpha-acetyltransferase 15, NatA auxiliary subunit, putative', 107, NULL, NULL, 171529),
(171530, '3.40.630.30-FF-000506', NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', 202, NULL, NULL, 171530),
(171531, '2.20.70.10-FF-000131', NULL, 'WW domain-containing oxidoreductase', 44, NULL, NULL, 171531),
(171532, '4.10.410.10-FF-000072', NULL, 'Kunitz-type serine protease inhibitor BmKTT-3', 70, NULL, NULL, 171532),
(171533, '2.60.200.40-FF-000033', NULL, 'Diacylglycerol kinase', 188, NULL, NULL, 171533),
(171534, '2.40.30.130-FF-000043', NULL, 'Alanyl-tRNA synthetase', 117, NULL, NULL, 171534),
(171535, '3.30.1330.60-FF-000011', NULL, 'Flagellar motor protein MotS', 150, NULL, NULL, 171535),
(171536, '3.40.630.30-FF-000383', NULL, 'Amino-acid acetyltransferase, mitochondrial', 149, NULL, NULL, 171536),
(171537, '1.25.10.10-FF-001772', NULL, 'Cullin-associated NEDD8-dissociated protein 1', 1146, NULL, NULL, 171537),
(171538, '3.40.50.11720-FF-000005', NULL, '3-deoxy-D-manno-octulosonic acid transferase', 178, NULL, NULL, 171538),
(171539, '3.30.70.80-FF-000020', NULL, 'Subtilisin-like serine protease Pen ch 13.0101', 82, NULL, NULL, 171539),
(171540, '1.10.287.110-FF-000320', NULL, 'Uncharacterized protein', 95, NULL, NULL, 171540),
(171541, '2.60.200.30-FF-000030', NULL, 'ATP-NAD kinase', 141, NULL, NULL, 171541),
(171542, '2.40.50.140-FF-001163', NULL, NULL, 73, NULL, NULL, 171542),
(171543, '3.80.10.10-FF-001325', NULL, 'Leucine-rich repeat protein kinase family protein', 125, NULL, NULL, 171543),
(171544, '2.180.10.10-FF-000030', NULL, 'N-acetylglucosamine-1-phosphodiester alpha-N-acetylglucosaminidase, putative', 602, NULL, NULL, 171544),
(171545, '3.90.550.10-FF-000500', NULL, 'Slr1065 protein', 270, NULL, NULL, 171545),
(171546, '3.40.50.1440-FF-000047', NULL, 'Tubulin delta chain', 363, NULL, NULL, 171546);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(171547, '1.20.1110.10-FF-000192', NULL, NULL, 144, NULL, NULL, 171547),
(171548, '1.10.565.10-FF-000161', NULL, 'Uncharacterized protein', 211, NULL, NULL, 171548),
(171549, '2.60.120.1000-FF-000013', NULL, 'Uncharacterized protein', 195, NULL, NULL, 171549),
(171550, '3.30.160.60-FF-004118', NULL, NULL, 62, NULL, NULL, 171550),
(171551, '1.25.40.1030-FF-000009', NULL, 'Secretory 16, isoform E', 342, NULL, NULL, 171551),
(171552, '1.20.120.550-FF-000017', NULL, 'Microsomal glutathione S-transferase 2', 151, NULL, NULL, 171552),
(171553, '3.30.70.330-FF-001380', NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', 89, NULL, NULL, 171553),
(171554, '4.10.280.10-FF-000190', NULL, 'Protein INO4, putative', 83, NULL, NULL, 171554),
(171555, '1.20.1070.10-FF-000699', NULL, 'Adenosine receptor A1', 185, NULL, NULL, 171555),
(171556, '3.40.33.10-FF-000172', NULL, 'Uncharacterized protein', 93, NULL, NULL, 171556),
(171557, '3.30.70.1470-FF-000008', NULL, 'caspase-3', 107, NULL, NULL, 171557),
(171558, '3.10.20.90-FF-000352', NULL, 'Protein phosphatase 1, regulatory subunit 13Ba', 83, NULL, NULL, 171558),
(171559, '2.60.40.10-FF-004702', NULL, NULL, 99, NULL, NULL, 171559),
(171560, '3.40.50.2300-FF-000755', NULL, NULL, 46, NULL, NULL, 171560),
(171561, '3.40.50.1820-FF-000684', NULL, 'Protein CBG03928', 265, NULL, NULL, 171561),
(171562, '3.40.50.12440-FF-000002', NULL, 'Anaerobic dimethyl sulfoxide reductase, A subunit', 71, NULL, NULL, 171562),
(171563, '3.30.200.20-FF-000884', NULL, 'Receptor protein serine/threonine kinase', 106, NULL, NULL, 171563),
(171564, '3.40.50.360-FF-000168', NULL, 'Uncharacterized protein', 71, NULL, NULL, 171564),
(171565, '1.20.5.110-FF-000307', NULL, 'Predicted protein', 62, NULL, NULL, 171565),
(171566, '3.40.50.300-FF-008008', NULL, 'RecBCD enzyme subunit RecB', 144, NULL, NULL, 171566),
(171567, '1.50.40.10-FF-000158', NULL, 'Mitochondrial carrier protein', 200, NULL, NULL, 171567),
(171568, '2.30.30.40-FF-000480', NULL, 'Positive regulator of CheA protein activity (CheW)', 60, NULL, NULL, 171568),
(171569, '1.25.40.10-FF-001532', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 135, NULL, NULL, 171569),
(171570, '1.10.8.10-FF-000152', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 39, NULL, NULL, 171570),
(171571, '3.20.90.10-FF-000012', NULL, NULL, 93, NULL, NULL, 171571),
(171572, '3.40.30.10-FF-000311', NULL, 'Thioredoxin-dependent peroxide reductase', 197, NULL, NULL, 171572),
(171573, '3.40.50.1390-FF-000010', NULL, 'Recombinase resolvase family', 169, NULL, NULL, 171573),
(171574, '4.10.400.10-FF-000127', NULL, 'basement membrane-specific heparan sulfate proteoglycan core protein', 43, NULL, NULL, 171574),
(171575, '3.40.190.10-FF-000949', NULL, 'Predicted protein', 139, NULL, NULL, 171575),
(171576, '4.10.860.120-FF-000015', NULL, 'DNA-directed RNA polymerase subunit', 116, NULL, NULL, 171576),
(171577, '1.25.40.660-FF-000019', NULL, 'Vacuolar protein sorting-associated protein 35', 313, NULL, NULL, 171577),
(171578, '3.40.50.11030-FF-000012', NULL, NULL, 130, NULL, NULL, 171578),
(171579, '1.20.1270.130-FF-000004', NULL, 'Type III effector NopM1-1', 83, NULL, NULL, 171579),
(171580, '3.80.10.10-FF-003096', NULL, 'Leucine-rich repeat-containing 41', 116, NULL, NULL, 171580),
(171581, '3.30.1360.40-FF-000024', NULL, 'DNA topoisomerase 2', 99, NULL, NULL, 171581),
(171582, '2.60.40.10-FF-005708', NULL, NULL, 50, NULL, NULL, 171582),
(171583, '3.40.50.1820-FF-000588', NULL, 'CocE/NonD family hydrolase', 277, NULL, NULL, 171583),
(171584, '1.25.40.10-FF-002324', NULL, 'General transcription factor 3C polypeptide 3 (Transcription factor C subunit 4)', 79, NULL, NULL, 171584),
(171585, '3.40.50.720-FF-000653', NULL, 'Voltage-gated Ion Channel (VIC) Superfamily', 151, NULL, NULL, 171585),
(171586, '3.30.960.10-FF-000005', NULL, 'Eukaryotic peptide chain release factor subunit 1-3', 66, NULL, NULL, 171586),
(171587, '2.40.100.10-FF-000032', NULL, 'Peptidyl-prolyl cis-trans isomerase', 163, NULL, NULL, 171587),
(171588, '1.10.20.10-FF-000018', NULL, 'Transcription initiation factor TFIID subunit 9', 68, NULL, NULL, 171588);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(171589, '3.40.30.10-FF-000923', NULL, 'Uncharacterized protein', 124, NULL, NULL, 171589),
(171590, '3.30.70.330-FF-002695', NULL, NULL, 122, NULL, NULL, 171590),
(171591, '1.25.40.20-FF-000175', NULL, 'protein fem-1 homolog B', 72, NULL, NULL, 171591),
(171592, '1.10.238.110-FF-000024', NULL, 'Diacylglycerol kinase', 36, NULL, NULL, 171592),
(171593, '3.40.50.11040-FF-000015', NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', 201, NULL, NULL, 171593),
(171594, '1.25.40.10-FF-000172', NULL, 'Tetratricopeptide repeat domain 28', 127, NULL, NULL, 171594),
(171595, '3.30.9.10-FF-000099', NULL, 'Oxidoreductase', 160, NULL, NULL, 171595),
(171596, '3.40.50.150-FF-000111', NULL, 'EEF1A lysine methyltransferase 4', 211, NULL, NULL, 171596),
(171597, '3.30.70.3250-FF-000008', NULL, 'Ribonuclease P/MRP protein subunit POP5', 112, NULL, NULL, 171597),
(171598, '3.90.70.10-FF-000204', NULL, 'Papain', 312, NULL, NULL, 171598),
(171599, '1.25.10.10-FF-003396', NULL, 'Uncharacterized protein', 130, NULL, NULL, 171599),
(171600, '3.30.420.40-FF-000400', NULL, 'Actin-related protein 9', 184, NULL, NULL, 171600),
(171601, '3.30.160.60-FF-001656', NULL, 'CCCTC-binding factor like', 27, NULL, NULL, 171601),
(171602, '3.10.170.20-FF-000020', NULL, NULL, 117, NULL, NULL, 171602),
(171603, '3.40.50.2300-FF-001244', NULL, NULL, 35, NULL, NULL, 171603),
(171604, '1.20.1250.20-FF-001194', NULL, 'Putative integral membrane protein', 189, NULL, NULL, 171604),
(171605, '2.30.180.10-FF-000011', NULL, 'Fasciclin-like arabinogalactan protein 16', 152, NULL, NULL, 171605),
(171606, '3.80.10.10-FF-004456', NULL, 'Predicted protein', 98, NULL, NULL, 171606),
(171607, '3.40.50.150-FF-001393', NULL, NULL, 168, NULL, NULL, 171607),
(171608, '3.10.105.10-FF-000091', NULL, 'Putative lipoprotein', 98, NULL, NULL, 171608),
(171609, '3.30.160.60-FF-005579', NULL, NULL, 34, NULL, NULL, 171609),
(171610, '1.10.455.10-FF-000040', NULL, 'Mitochondrial ribosomal protein S7', 169, NULL, NULL, 171610),
(171611, '2.60.40.10-FF-004141', NULL, NULL, 90, NULL, NULL, 171611),
(171612, '3.40.1160.10-FF-000082', NULL, 'Glutamate 5-kinase', 104, NULL, NULL, 171612),
(171613, '3.10.20.90-FF-000026', NULL, 'Mitogen-activated protein kinase kinase kinase 3 isoform 2', 81, NULL, NULL, 171613),
(171614, '1.10.510.10-FF-004025', NULL, NULL, 112, NULL, NULL, 171614),
(171615, '3.40.50.300-FF-004383', NULL, 'Uncharacterized protein', 207, NULL, NULL, 171615),
(171616, '3.40.50.300-FF-001691', NULL, 'Probable ATP-dependent kinase TDA10', 289, NULL, NULL, 171616),
(171617, '3.30.160.60-FF-002432', NULL, NULL, 30, NULL, NULL, 171617),
(171618, '3.40.50.1110-FF-000033', NULL, 'Acyltransferase family protein', 168, NULL, NULL, 171618),
(171619, '3.40.50.11350-FF-000041', NULL, 'Uncharacterized protein', 171, NULL, NULL, 171619),
(171620, '2.30.110.10-FF-000029', NULL, 'YGR017W-like protein', 221, NULL, NULL, 171620),
(171621, '3.30.40.10-FF-001672', NULL, 'Lysine demethylase 5B', 80, NULL, NULL, 171621),
(171622, '2.60.120.260-FF-000122', NULL, 'Anaphase-promoting complex subunit 10', 166, NULL, NULL, 171622),
(171623, '3.40.50.410-FF-000318', NULL, 'Uncharacterized protein', 105, NULL, NULL, 171623),
(171624, '3.40.50.1100-FF-000030', NULL, 'Threonine synthase 1, chloroplastic', 261, NULL, NULL, 171624),
(171625, '3.30.428.10-FF-000010', NULL, 'Galactose-1-phosphate uridylyltransferase', 123, NULL, NULL, 171625),
(171626, '2.130.10.10-FF-005136', NULL, 'Intraflagellar transport particle protein IFT140', 124, NULL, NULL, 171626),
(171627, '2.30.30.190-FF-000024', NULL, 'CAP-Gly domain-containing linker protein 1 homolog', 92, NULL, NULL, 171627),
(171628, '1.10.238.10-FF-000261', NULL, 'Uncharacterized protein, isoform B', 104, NULL, NULL, 171628),
(171629, '3.20.20.70-FF-000790', NULL, NULL, 60, NULL, NULL, 171629),
(171630, '3.30.310.10-FF-000024', NULL, 'Transcription initiation factor-like protein (TFIID-like protein)', 96, NULL, NULL, 171630),
(171631, '2.130.10.10-FF-001864', NULL, 'Cleavage stimulation factor subunit', 96, NULL, NULL, 171631),
(171632, '1.10.10.10-FF-001524', NULL, 'Uncharacterized protein', 103, NULL, NULL, 171632);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(171633, '3.40.1110.10-FF-000371', NULL, NULL, 167, NULL, NULL, 171633),
(171634, '2.60.40.640-FF-000036', NULL, 'beta-arrestin-2 isoform X2', 194, NULL, NULL, 171634),
(171635, '3.10.20.30-FF-000115', NULL, NULL, 42, NULL, NULL, 171635),
(171636, '3.40.630.30-FF-000057', NULL, 'N-acetylaspartate synthetase', 129, NULL, NULL, 171636),
(171637, '1.20.58.60-FF-000485', NULL, 'Microtubule actin crosslinking factor 1a', 106, NULL, NULL, 171637),
(171638, '1.10.287.470-FF-000074', NULL, 'HAE1 family efflux pump MFP component MexE', 74, NULL, NULL, 171638),
(171639, '1.20.58.530-FF-000017', NULL, 'Chitin synthase ChsE', 147, NULL, NULL, 171639),
(171640, '1.25.40.10-FF-001599', NULL, 'Mitochondrial import receptor subunit TOM20-3', 149, NULL, NULL, 171640),
(171641, '2.40.160.210-FF-000013', NULL, 'Acyl-CoA thioesterase II', 313, NULL, NULL, 171641),
(171642, '3.30.420.10-FF-000684', NULL, NULL, 273, NULL, NULL, 171642),
(171643, '1.10.8.10-FF-000359', NULL, 'NOG1', 34, NULL, NULL, 171643),
(171644, '3.30.420.270-FF-000008', NULL, 'Biopolymer transporter ExbD', 72, NULL, NULL, 171644),
(171645, '2.60.120.10-FF-000613', NULL, 'Uncharacterized protein', 166, NULL, NULL, 171645),
(171646, '3.40.1690.10-FF-000015', NULL, 'FlhB domain protein', 81, NULL, NULL, 171646),
(171647, '3.30.310.10-FF-000063', NULL, 'AP complex subunit beta', 136, NULL, NULL, 171647),
(171648, '2.60.40.150-FF-000327', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit gamma, putative', 136, NULL, NULL, 171648),
(171649, '3.30.1370.10-FF-000021', NULL, 'Heterogeneous nuclear ribonucleoprotein K, like', 73, NULL, NULL, 171649),
(171650, '3.40.50.1820-FF-001139', NULL, 'Serine carboxypeptidase, putative', 247, NULL, NULL, 171650),
(171651, '2.20.25.240-FF-000003', NULL, 'Broad-complex core protein isoform 6', 83, NULL, NULL, 171651),
(171652, '3.40.50.1260-FF-000050', NULL, 'Phosphoglycerate kinase', 96, NULL, NULL, 171652),
(171653, '3.50.50.100-FF-000004', NULL, 'Pyridine nucleotide-disulfide oxidoreductase', 403, NULL, NULL, 171653),
(171654, '1.20.1270.60-FF-000285', NULL, 'Uncharacterized protein', 194, NULL, NULL, 171654),
(171655, '3.30.420.10-FF-000627', NULL, NULL, 271, NULL, NULL, 171655),
(171656, '1.10.472.10-FF-000181', NULL, 'Protein CBR-CIT-1.1', 141, NULL, NULL, 171656),
(171657, '1.10.238.10-FF-000210', NULL, 'NADPH oxidase 5 isoform X2', 179, NULL, NULL, 171657),
(171658, '3.30.70.1020-FF-000008', NULL, 'Putative alpha,alpha-trehalose phosphate synthase subunit', 81, NULL, NULL, 171658),
(171659, '1.20.1560.10-FF-000624', NULL, 'ATP-binding cassette transporter, subfamily B, member 19, group MDR/PGP protein PpABCB19', 310, NULL, NULL, 171659),
(171660, '3.30.160.60-FF-005658', NULL, NULL, 79, NULL, NULL, 171660),
(171661, '2.60.120.460-FF-000002', NULL, 'Secondary thiamine-phosphate synthase enzyme', 149, NULL, NULL, 171661),
(171662, '1.20.5.110-FF-000072', NULL, 'Syntaxin, t-snare coiled-coil domain family', 64, NULL, NULL, 171662),
(171663, '3.30.200.20-FF-001608', NULL, 'Kinase, CAMK unique', 101, NULL, NULL, 171663),
(171664, '1.10.10.10-FF-002075', NULL, 'Uncharacterized protein', 96, NULL, NULL, 171664),
(171665, '1.20.58.390-FF-000104', NULL, 'AcetylCholine Receptor', 67, NULL, NULL, 171665),
(171666, '2.30.30.140-FF-000099', NULL, 'Histone-lysine N-methyltransferase', 103, NULL, NULL, 171666),
(171667, '2.30.29.30-FF-001215', NULL, 'Phosphoinositide phospholipase C', 54, NULL, NULL, 171667),
(171668, '3.30.2350.10-FF-000020', NULL, 'tRNA pseudouridine(55) synthase', 238, NULL, NULL, 171668),
(171669, '2.130.10.10-FF-003949', NULL, 'RE68083p', 246, NULL, NULL, 171669),
(171670, '3.40.50.410-FF-000375', NULL, 'voltage-dependent calcium channel subunit alpha-2/delta-1', 184, NULL, NULL, 171670),
(171671, '2.60.120.330-FF-000222', NULL, 'Predicted protein', 64, NULL, NULL, 171671),
(171672, '3.30.160.60-FF-003567', NULL, NULL, 25, NULL, NULL, 171672),
(171673, '3.30.2350.20-FF-000023', NULL, 'Probable tRNA pseudouridine synthase D', 202, NULL, NULL, 171673),
(171674, '1.20.1280.50-FF-000171', NULL, 'Uncharacterized protein', 72, NULL, NULL, 171674);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(171675, '3.30.70.1010-FF-000005', NULL, NULL, 96, NULL, NULL, 171675),
(171676, '1.10.20.10-FF-000344', NULL, NULL, 98, NULL, NULL, 171676),
(171677, '3.40.140.10-FF-000143', NULL, 'Cytidine and dCMP deaminase domain containing 1', 97, NULL, NULL, 171677),
(171678, '3.20.20.140-FF-000483', NULL, '2-amino-3-carboxymuconate-6-semialdehyde decarboxylase', 74, NULL, NULL, 171678),
(171679, '1.10.860.10-FF-000004', NULL, 'DNA primase', 140, NULL, NULL, 171679),
(171680, '3.40.1110.10-FF-000258', NULL, 'Phospholipid-transporting ATPase', 162, NULL, NULL, 171680),
(171681, '3.30.70.330-FF-002689', NULL, NULL, 118, NULL, NULL, 171681),
(171682, '2.60.120.200-FF-000588', NULL, 'Beta-galactosidase', 162, NULL, NULL, 171682),
(171683, '1.10.287.1490-FF-000127', NULL, 'LD20207p', 146, NULL, NULL, 171683),
(171684, '1.10.8.10-FF-000264', NULL, 'Uncharacterized protein', 55, NULL, NULL, 171684),
(171685, '3.60.140.10-FF-000009', NULL, 'Polyphenol oxidase', 255, NULL, NULL, 171685),
(171686, '2.30.29.30-FF-000698', NULL, 'Serine/threonine-protein kinase, putative', 127, NULL, NULL, 171686),
(171687, '2.80.10.50-FF-000075', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 134, NULL, NULL, 171687),
(171688, '1.20.1250.20-FF-001317', NULL, 'Uncharacterized protein', 195, NULL, NULL, 171688),
(171689, '3.40.50.300-FF-006210', NULL, 'Uncharacterized protein', 59, NULL, NULL, 171689),
(171690, '3.30.160.60-FF-003955', NULL, 'Zinc finger protein 277', 78, NULL, NULL, 171690),
(171691, '2.130.10.10-FF-001825', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', 314, NULL, NULL, 171691),
(171692, '3.40.50.1820-FF-000476', NULL, 'Carboxylic ester hydrolase', 556, NULL, NULL, 171692),
(171693, '2.70.130.10-FF-000151', NULL, NULL, 138, NULL, NULL, 171693),
(171694, '3.40.50.720-FF-000939', NULL, 'Protein CBG19189', 180, NULL, NULL, 171694),
(171695, '2.10.70.10-FF-000160', NULL, 'Membrane cofactor protein', 61, NULL, NULL, 171695),
(171696, '3.30.160.750-FF-000002', NULL, 'S-adenosylmethionine decarboxylase proenzyme', 56, NULL, NULL, 171696),
(171697, '3.40.50.300-FF-005642', NULL, 'ATP-binding subunit of ABC transporter', 231, NULL, NULL, 171697),
(171698, '3.30.390.50-FF-000001', NULL, 'Xanthine dehydrogenase oxidase', 117, NULL, NULL, 171698),
(171699, '3.30.420.10-FF-000532', NULL, NULL, 97, NULL, NULL, 171699),
(171700, '2.60.120.40-FF-000032', NULL, 'Tumor necrosis factor ligand superfamily member 9', 158, NULL, NULL, 171700),
(171701, '1.25.40.180-FF-000246', NULL, NULL, 127, NULL, NULL, 171701),
(171702, '2.160.20.80-FF-000018', NULL, NULL, 211, NULL, NULL, 171702),
(171703, '3.30.1600.10-FF-000017', NULL, 'SIR2 family protein', 104, NULL, NULL, 171703),
(171704, '2.20.230.10-FF-000001', NULL, 'Signal peptide protein, YSIRK family', 79, NULL, NULL, 171704),
(171705, '1.20.120.350-FF-000058', NULL, 'Sodium channel protein', 110, NULL, NULL, 171705),
(171706, '3.30.160.60-FF-004562', NULL, NULL, 79, NULL, NULL, 171706),
(171707, '3.30.710.10-FF-000279', NULL, 'Kelch repeat and BTB domain-containing protein', 90, NULL, NULL, 171707),
(171708, '3.30.160.60-FF-005990', NULL, NULL, 47, NULL, NULL, 171708),
(171709, '1.20.5.190-FF-000101', NULL, NULL, 46, NULL, NULL, 171709),
(171710, '1.20.5.4770-FF-000017', NULL, 'Uncharacterized protein', 59, NULL, NULL, 171710),
(171711, '3.30.390.60-FF-000004', NULL, 'Heat-inducible transcription repressor HrcA', 98, NULL, NULL, 171711),
(171712, '4.10.1060.10-FF-000058', NULL, 'Nuclear pore complex protein Nup153-like Protein', 44, NULL, NULL, 171712),
(171713, '2.60.40.10-FF-003298', NULL, 'DLEC1, cilia and flagella associated protein', 115, NULL, NULL, 171713),
(171714, '1.10.555.10-FF-000121', NULL, 'Rho GTPase-activating protein gacJ', 239, NULL, NULL, 171714),
(171715, '4.10.1080.10-FF-000008', NULL, 'Uncharacterized protein', 59, NULL, NULL, 171715),
(171716, '3.30.420.10-FF-000296', NULL, 'DNA polymerase I', 189, NULL, NULL, 171716),
(171717, '1.10.8.710-FF-000001', NULL, 'Dynein axonemal heavy chain 2', 109, NULL, NULL, 171717);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(171718, '3.30.9.10-FF-000032', NULL, 'L-2-hydroxyglutarate dehydrogenase, mitochondrial', 120, NULL, NULL, 171718),
(171719, '1.10.10.10-FF-001299', NULL, 'Plectin/S10 domain containing protein', 108, NULL, NULL, 171719),
(171720, '3.30.450.20-FF-000458', NULL, 'GAF domain-containing protein', 105, NULL, NULL, 171720),
(171721, '3.80.10.10-FF-002657', NULL, 'Phytosulfokine receptor 1', 153, NULL, NULL, 171721),
(171722, '3.40.1110.10-FF-000219', NULL, 'Phospholipid-transporting ATPase', 127, NULL, NULL, 171722),
(171723, '1.10.8.720-FF-000004', NULL, 'Dynein heavy chain 5, axonemal', 165, NULL, NULL, 171723),
(171724, '3.30.40.10-FF-000778', NULL, 'E3 ubiquitin-protein ligase RMA1H1 isoform A', 82, NULL, NULL, 171724),
(171725, '3.40.50.300-FF-003725', NULL, 'Similar to AAA family ATPase', 161, NULL, NULL, 171725),
(171726, '1.25.40.10-FF-002959', NULL, 'Os09g0573000 protein', 138, NULL, NULL, 171726),
(171727, '3.30.160.60-FF-002224', NULL, 'AZF1p Zinc-finger transcription factor', 28, NULL, NULL, 171727),
(171728, '1.10.530.10-FF-000069', NULL, 'Invertebrate LYSozyme', 64, NULL, NULL, 171728),
(171729, '2.60.40.2690-FF-000002', NULL, 'Splicing factor 3a subunit 2', 125, NULL, NULL, 171729),
(171730, '3.30.160.60-FF-000015', NULL, 'Zinc finger protein 569', 28, NULL, NULL, 171730),
(171731, '3.80.10.10-FF-000595', NULL, 'EIN3-binding F-box protein 1', 138, NULL, NULL, 171731),
(171732, '3.40.720.10-FF-000345', NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase, putative', 75, NULL, NULL, 171732),
(171733, '3.40.50.300-FF-005849', NULL, 'GTPase Era', 183, NULL, NULL, 171733),
(171734, '2.130.10.10-FF-006030', NULL, 'Predicted protein', 104, NULL, NULL, 171734),
(171735, '3.40.50.300-FF-006305', NULL, 'Uncharacterized protein', 146, NULL, NULL, 171735),
(171736, '1.20.5.340-FF-000056', NULL, 'Monopolin complex subunit CSM1', 82, NULL, NULL, 171736),
(171737, '1.25.40.120-FF-000099', NULL, 'Uncharacterized protein', 109, NULL, NULL, 171737),
(171738, '3.40.50.2000-FF-000985', NULL, 'Sucrose synthase 3', 63, NULL, NULL, 171738),
(171739, '2.10.25.10-FF-000319', NULL, 'Dumpy, isoform P', 39, NULL, NULL, 171739),
(171740, '3.40.50.2300-FF-001536', NULL, NULL, 63, NULL, NULL, 171740),
(171741, '1.20.120.850-FF-000051', NULL, 'Uncharacterized protein', 48, NULL, NULL, 171741),
(171742, '1.10.510.10-FF-004401', NULL, NULL, 85, NULL, NULL, 171742),
(171743, '2.60.120.620-FF-000039', NULL, 'Phytanoyl-CoA dioxygenase', 277, NULL, NULL, 171743),
(171744, '3.40.50.300-FF-001359', NULL, 'ATPase GET3', 350, NULL, NULL, 171744),
(171745, '1.10.510.10-FF-000074', NULL, 'G protein-coupled receptor kinase', 206, NULL, NULL, 171745),
(171746, '3.10.450.580-FF-000022', NULL, 'Mediator of RNA polymerase II transcription subunit 6', 65, NULL, NULL, 171746),
(171747, '3.90.850.10-FF-000039', NULL, NULL, 233, NULL, NULL, 171747),
(171748, '3.40.50.300-FF-008334', NULL, 'Chromatin remodeling factor mit1', 236, NULL, NULL, 171748),
(171749, '3.10.450.230-FF-000001', NULL, 'Type IV secretion system protein virB8', 142, NULL, NULL, 171749),
(171750, '3.10.450.240-FF-000004', NULL, 'Mitochondrial import inner membrane translocase subunit TIM44', 179, NULL, NULL, 171750),
(171751, '1.25.10.10-FF-001884', NULL, 'Condensin complex subunit 1', 363, NULL, NULL, 171751),
(171752, '1.10.225.10-FF-000023', NULL, 'Granulysin', 73, NULL, NULL, 171752),
(171753, '2.170.190.11-FF-000002', NULL, 'Molybdopterin molybdenumtransferase', 104, NULL, NULL, 171753),
(171754, '3.10.400.10-FF-000013', NULL, NULL, 164, NULL, NULL, 171754),
(171755, '3.40.50.150-FF-000083', NULL, '7SK snRNA methylphosphate capping enzyme', 225, NULL, NULL, 171755),
(171756, '2.70.150.10-FF-000146', NULL, 'Uncharacterized protein, isoform A', 111, NULL, NULL, 171756),
(171757, '2.80.10.50-FF-000007', NULL, 'Fibroblast growth factor', 162, NULL, NULL, 171757),
(171758, '3.40.1170.60-FF-000024', NULL, 'DNA polymerase kappa', 55, NULL, NULL, 171758),
(171759, '2.10.90.10-FF-000155', NULL, 'Vascular endothelial growth factor B', 91, NULL, NULL, 171759),
(171760, '2.60.40.60-FF-000007', NULL, 'Protocadherin alpha 2', 111, NULL, NULL, 171760);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(171761, '3.40.50.1820-FF-000358', NULL, 'Alpha/beta hydrolase', 245, NULL, NULL, 171761),
(171762, '3.30.70.330-FF-001554', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 85, NULL, NULL, 171762),
(171763, '2.30.40.10-FF-000163', NULL, 'Metal-dependent hydrolase, subgroup D', 81, NULL, NULL, 171763),
(171764, '1.10.10.60-FF-001168', NULL, NULL, 47, NULL, NULL, 171764),
(171765, '2.130.10.10-FF-001179', NULL, 'Transcription factor tau 60 kDa subunit', 170, NULL, NULL, 171765),
(171766, '3.30.160.60-FF-000133', NULL, 'Zinc finger protein 347', 28, NULL, NULL, 171766),
(171767, '1.20.1070.10-FF-001542', NULL, 'Uncharacterized protein', 177, NULL, NULL, 171767),
(171768, '3.90.76.10-FF-000004', NULL, 'Peptide ABC transporter substrate-binding protein', 121, NULL, NULL, 171768),
(171769, '3.40.640.10-FF-000411', NULL, 'Uncharacterized protein', 322, NULL, NULL, 171769),
(171770, '2.40.30.10-FF-000206', NULL, 'NADPH-cytochrome p450 reductase-like protein', 105, NULL, NULL, 171770),
(171771, '1.10.510.10-FF-000017', NULL, 'Mitogen-activated protein kinase', 229, NULL, NULL, 171771),
(171772, '3.30.200.20-FF-001665', NULL, 'Kinase, CMGC RCK', 83, NULL, NULL, 171772),
(171773, '3.40.50.10190-FF-000333', NULL, 'Breast cancer type 1 susceptibility protein homolog', 108, NULL, NULL, 171773),
(171774, '1.20.1300.10-FF-000021', NULL, 'Succinate dehydrogenase hydrophobic membrane anchor subunit', 122, NULL, NULL, 171774),
(171775, '2.40.110.10-FF-000010', NULL, 'Acyl-CoA dehydrogenase', 124, NULL, NULL, 171775),
(171776, '1.10.287.70-FF-000684', NULL, 'Uncharacterized protein', 83, NULL, NULL, 171776),
(171777, '2.60.120.480-FF-000008', NULL, 'Ureidoglycolate hydrolase', 212, NULL, NULL, 171777),
(171778, '3.40.50.1820-FF-001370', NULL, 'Uncharacterized protein', 226, NULL, NULL, 171778),
(171779, '3.30.450.20-FF-000363', NULL, 'Histidine kinase', 141, NULL, NULL, 171779),
(171780, '3.40.50.261-FF-000010', NULL, 'Succinate--CoA ligase [ADP-forming] subunit alpha', 173, NULL, NULL, 171780),
(171781, '1.25.40.10-FF-001824', NULL, 'Selenium binding protein-like protein', 112, NULL, NULL, 171781),
(171782, '1.20.200.10-FF-000031', NULL, 'Uncharacterized protein', 154, NULL, NULL, 171782),
(171783, '3.40.50.1820-FF-001252', NULL, 'Carboxylic ester hydrolase', 545, NULL, NULL, 171783),
(171784, '2.60.40.790-FF-000053', NULL, '17.5 kDa class I heat shock protein', 138, NULL, NULL, 171784),
(171785, '3.20.20.70-FF-000413', NULL, 'tRNA-dihydrouridine(16/17) synthase (NAD(P)(+))', 234, NULL, NULL, 171785),
(171786, '1.20.1730.10-FF-000109', NULL, 'Uncharacterized protein', 177, NULL, NULL, 171786),
(171787, '1.10.4080.10-FF-000005', NULL, 'Uncharacterized protein', 181, NULL, NULL, 171787),
(171788, '1.10.10.10-FF-000164', NULL, 'Transcriptional regulator, Rrf2 family', 139, NULL, NULL, 171788),
(171789, '2.40.20.10-FF-000026', NULL, 'Uncharacterized protein', 89, NULL, NULL, 171789),
(171790, '1.10.1870.10-FF-000009', NULL, 'Uncharacterized protein', 51, NULL, NULL, 171790),
(171791, '1.10.287.470-FF-000017', NULL, 'RND family efflux transporter, MFP subunit', 74, NULL, NULL, 171791),
(171792, '3.10.290.10-FF-000014', NULL, 'Tyrosine--tRNA ligase', 97, NULL, NULL, 171792),
(171793, '2.60.120.470-FF-000005', NULL, 'AT08565p', 168, NULL, NULL, 171793),
(171794, '3.20.100.10-FF-000010', NULL, 'mRNA capping enzyme subunit beta, putative', 321, NULL, NULL, 171794),
(171795, '2.160.10.10-FF-000132', NULL, 'Acetyltransferase CysE/LacA/LpxA/NodL family', 48, NULL, NULL, 171795),
(171796, '3.60.20.40-FF-000015', NULL, 'Putative gamma-glutamyltranspeptidase GgtB', 199, NULL, NULL, 171796),
(171797, '3.40.30.10-FF-000069', NULL, 'Chloride intracellular channel 2', 102, NULL, NULL, 171797),
(171798, '3.30.160.60-FF-002319', NULL, 'Uncharacterized protein', 30, NULL, NULL, 171798),
(171799, '3.40.50.2300-FF-000221', NULL, 'Two component transcriptional regulator DevR', 207, NULL, NULL, 171799),
(171800, '1.25.40.10-FF-000407', NULL, 'Putative pentatricopeptide repeat-containing protein', 263, NULL, NULL, 171800);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(171801, '3.40.30.10-FF-000631', NULL, 'Protein disulfide-isomerase', 105, NULL, NULL, 171801),
(171802, '3.30.360.20-FF-000013', NULL, NULL, 98, NULL, NULL, 171802),
(171803, '3.40.1110.10-FF-000466', NULL, NULL, 145, NULL, NULL, 171803),
(171804, '3.10.50.40-FF-000154', NULL, 'Peptidylprolyl isomerase', 85, NULL, NULL, 171804),
(171805, '3.60.20.30-FF-000012', NULL, NULL, 133, NULL, NULL, 171805),
(171806, '3.30.160.60-FF-000072', NULL, 'zinc finger protein 143 isoform X1', 30, NULL, NULL, 171806),
(171807, '2.30.29.30-FF-000985', NULL, 'Uncharacterized protein', 39, NULL, NULL, 171807),
(171808, '1.10.10.10-FF-000630', NULL, 'DNA replication licensing factor (Mcm)', 85, NULL, NULL, 171808),
(171809, '2.60.210.10-FF-000030', NULL, NULL, 169, NULL, NULL, 171809),
(171810, '3.40.720.10-FF-000137', NULL, 'Phosphatidylinositol-glycan biosynthesis class O protein, putative', 207, NULL, NULL, 171810),
(171811, '3.10.290.20-FF-000017', NULL, 'Ubiquitin-activating enzyme E1-like', 125, NULL, NULL, 171811),
(171812, '1.25.40.10-FF-000200', NULL, 'protein sel-1 homolog 1 precursor', 133, NULL, NULL, 171812),
(171813, '3.40.50.300-FF-005754', NULL, 'F0F1 ATP synthase subunit alpha', 127, NULL, NULL, 171813),
(171814, '3.80.10.10-FF-001033', NULL, 'LRR receptor-like serine/threonine-protein kinase GSO1', 103, NULL, NULL, 171814),
(171815, '3.80.10.10-FF-001090', NULL, 'Uncharacterized protein', 79, NULL, NULL, 171815),
(171816, '3.40.80.10-FF-000016', NULL, 'N-acetylmuramoyl-L-alanine amidase', 140, NULL, NULL, 171816),
(171817, '3.40.630.150-FF-000023', NULL, 'Malonyl-CoA decarboxylase', 108, NULL, NULL, 171817),
(171818, '3.90.550.10-FF-000051', NULL, 'Alpha-1,2-mannosyltransferase (Ktr4)', 339, NULL, NULL, 171818),
(171819, '3.30.160.20-FF-000149', NULL, 'Double stranded RNA-binding protein', 82, NULL, NULL, 171819),
(171820, '3.30.360.10-FF-000010', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', 166, NULL, NULL, 171820),
(171821, '3.30.70.330-FF-003145', NULL, NULL, 73, NULL, NULL, 171821),
(171822, '1.10.630.10-FF-000083', NULL, 'Thromboxane A synthase 1', 393, NULL, NULL, 171822),
(171823, '3.40.50.300-FF-004006', NULL, 'DEAD/DEAH box helicase', 214, NULL, NULL, 171823),
(171824, '2.60.40.340-FF-000002', NULL, 'Nuclear factor of activated T-cells 5, tonicity-responsive', 170, NULL, NULL, 171824),
(171825, '3.30.70.330-FF-001267', NULL, 'RNA recognition motif domain containing protein', 100, NULL, NULL, 171825),
(171826, '3.90.550.10-FF-000730', NULL, 'Uncharacterized protein', 252, NULL, NULL, 171826),
(171827, '3.40.50.1700-FF-000047', NULL, 'Beta-glucosidase, putative', 128, NULL, NULL, 171827),
(171828, '3.30.40.10-FF-000896', NULL, 'SNF2 domain-containing protein / helicase domain-containing protein / zinc finger protein-like protein', 67, NULL, NULL, 171828),
(171829, '1.25.40.10-FF-005135', NULL, 'Pentatricopeptide repeat-containing protein At5g04810, chloroplastic', 102, NULL, NULL, 171829),
(171830, '3.20.20.80-FF-000416', NULL, 'Putative lysosomal beta-galactosid', 126, NULL, NULL, 171830),
(171831, '1.25.40.180-FF-000038', NULL, 'Nuclear cap-binding protein subunit 1', 249, NULL, NULL, 171831),
(171832, '1.20.120.1240-FF-000057', NULL, 'Dynamin-related protein, putative', 149, NULL, NULL, 171832),
(171833, '3.80.10.10-FF-003124', NULL, 'NLR family, pyrin domain-containing 2', 83, NULL, NULL, 171833),
(171834, '3.30.930.10-FF-000054', NULL, 'Histidine--tRNA ligase chloroplastic/mitochondrial', 328, NULL, NULL, 171834),
(171835, '2.40.70.10-FF-000203', NULL, 'YALI0D02024p', 165, NULL, NULL, 171835),
(171836, '2.80.10.50-FF-000064', NULL, 'Fascin', 109, NULL, NULL, 171836),
(171837, '3.40.50.300-FF-007199', NULL, 'Mevalonate-3-phosphate 5-kinase', 168, NULL, NULL, 171837),
(171838, '3.30.310.80-FF-000056', NULL, 'CAMK family protein kinase', 118, NULL, NULL, 171838),
(171839, '3.30.1330.30-FF-000143', NULL, 'Uncharacterized protein', 57, NULL, NULL, 171839),
(171840, '3.90.260.10-FF-000011', NULL, 'DNA repair protein RAD4', 307, NULL, NULL, 171840),
(171841, '1.10.287.660-FF-000018', NULL, 'Si:ch211-284f22.3', 89, NULL, NULL, 171841);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(171842, '3.40.1190.10-FF-000033', NULL, 'Folylpolyglutamate synthase', 304, NULL, NULL, 171842),
(171843, '1.20.1070.10-FF-001042', NULL, 'Uncharacterized protein', 258, NULL, NULL, 171843),
(171844, '3.30.70.330-FF-001060', NULL, 'Mip6p', 79, NULL, NULL, 171844),
(171845, '1.10.10.10-FF-001592', NULL, 'S-adenosyl-L-methionine-dependent methyl transferase PigF', 81, NULL, NULL, 171845),
(171846, '1.20.120.980-FF-000005', NULL, 'Clan SC, family S28, unassigned serine peptidase', 131, NULL, NULL, 171846),
(171847, '3.30.10.20-FF-000004', NULL, 'Serine/threonine-protein kinase B PknB', 69, NULL, NULL, 171847),
(171848, '2.40.30.10-FF-000083', NULL, 'Eukaryotic elongation factor, selenocysteine-tRNA-specific', 113, NULL, NULL, 171848),
(171849, '3.80.10.10-FF-001533', NULL, 'NACHT, LRR and PYD domains-containing protein 9', 159, NULL, NULL, 171849),
(171850, '1.10.760.10-FF-000114', NULL, 'Glr3801 protein', 207, NULL, NULL, 171850),
(171851, '3.40.1620.60-FF-000003', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 1', 78, NULL, NULL, 171851),
(171852, '3.10.20.30-FF-000003', NULL, 'Developmentally-regulated GTP-binding protein 1', 85, NULL, NULL, 171852),
(171853, '1.25.10.10-FF-000170', NULL, 'Splicing factor 3B subunit 1', 148, NULL, NULL, 171853),
(171854, '2.60.120.620-FF-000073', NULL, 'Uncharacterized protein, isoform C', 163, NULL, NULL, 171854),
(171855, '2.40.50.140-FF-001096', NULL, NULL, 75, NULL, NULL, 171855),
(171856, '1.20.1270.60-FF-000167', NULL, 'Bridging integrator 2', 206, NULL, NULL, 171856),
(171857, '1.10.20.70-FF-000008', NULL, NULL, 40, NULL, NULL, 171857),
(171858, '3.40.1190.20-FF-000036', NULL, 'Phosphofructokinase', 304, NULL, NULL, 171858),
(171859, '2.10.25.10-FF-000937', NULL, 'Putative thrombospondin', 51, NULL, NULL, 171859),
(171860, '2.30.29.30-FF-000777', NULL, 'YALI0F15719p', 89, NULL, NULL, 171860),
(171861, '3.30.10.30-FF-000007', NULL, 'Probable serine/threonine-protein kinase dyrk2', 127, NULL, NULL, 171861),
(171862, '1.25.10.10-FF-000810', NULL, 'Splicing factor 3B subunit 1', 336, NULL, NULL, 171862),
(171863, '3.20.20.70-FF-000138', NULL, 'NADPH dehydrogenase 1', 382, NULL, NULL, 171863),
(171864, '1.20.1070.10-FF-001328', NULL, 'Uncharacterized protein', 119, NULL, NULL, 171864),
(171865, '1.20.5.190-FF-000112', NULL, NULL, 40, NULL, NULL, 171865),
(171866, '2.60.40.150-FF-000215', NULL, 'Putative pre-mRNA-splicing helicase BRR2', 118, NULL, NULL, 171866),
(171867, '2.60.11.10-FF-000004', NULL, 'Cytochrome c oxidase subunit 5B', 93, NULL, NULL, 171867),
(171868, '2.60.40.1730-FF-000029', NULL, 'Aminopeptidase', 226, NULL, NULL, 171868),
(171869, '2.60.120.10-FF-000725', NULL, 'cGMP-dependent protein kinase', 135, NULL, NULL, 171869),
(171870, '1.10.287.70-FF-000066', NULL, 'Sodium leak channel non-selective protein', 137, NULL, NULL, 171870),
(171871, '3.40.1360.10-FF-000030', NULL, 'Uncharacterized protein', 256, NULL, NULL, 171871),
(171872, '3.40.50.2000-FF-000013', NULL, 'Bifunctional UDP-N-acetylglucosamine 2-epimerase/N-acetylmannosamine kinase', 163, NULL, NULL, 171872),
(171873, '1.10.1780.10-FF-000002', NULL, 'ATP-dependent Clp protease ATP-binding subunit ClpA', 143, NULL, NULL, 171873),
(171874, '1.25.10.10-FF-002789', NULL, 'Tetratricopeptide repeat protein 12', 188, NULL, NULL, 171874),
(171875, '3.80.10.10-FF-002668', NULL, 'Predicted protein', 159, NULL, NULL, 171875),
(171876, '1.10.287.3240-FF-000029', NULL, 'V-type ATPase V1 subunit D', 198, NULL, NULL, 171876),
(171877, '2.40.150.20-FF-000021', NULL, 'Ribosomal protein L14', 67, NULL, NULL, 171877),
(171878, '3.40.50.1820-FF-001313', NULL, 'Predicted protein', 262, NULL, NULL, 171878),
(171879, '2.40.100.10-FF-000127', NULL, 'Peptidyl-prolyl cis-trans isomerase', 185, NULL, NULL, 171879),
(171880, '1.10.565.10-FF-000127', NULL, 'Thyroid hormone receptor', 272, NULL, NULL, 171880),
(171881, '3.90.550.10-FF-000112', NULL, 'Cellulose synthase-like protein E1', 172, NULL, NULL, 171881),
(171882, '3.20.20.330-FF-000012', NULL, 'Os01g0772900 protein', 106, NULL, NULL, 171882);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(171883, '3.10.170.20-FF-000019', NULL, NULL, 76, NULL, NULL, 171883),
(171884, '1.20.58.60-FF-000608', NULL, 'Spectrin repeat containing nuclear envelope family member 3', 117, NULL, NULL, 171884),
(171885, '3.30.559.30-FF-000106', NULL, 'Tryptophan N-acetyltransferase ivoA', 242, NULL, NULL, 171885),
(171886, '1.10.506.10-FF-000030', NULL, 'probable Ras GTPase-activating protein isoform X8', 176, NULL, NULL, 171886),
(171887, '1.10.3380.10-FF-000039', NULL, 'Uncharacterized protein', 137, NULL, NULL, 171887),
(171888, '3.30.200.20-FF-001873', NULL, NULL, 60, NULL, NULL, 171888),
(171889, '3.40.50.620-FF-000269', NULL, 'Cytoplasmic tRNA 2-thiolation protein 1', 316, NULL, NULL, 171889),
(171890, '3.30.70.330-FF-001346', NULL, NULL, 80, NULL, NULL, 171890),
(171891, '3.90.132.10-FF-000023', NULL, 'GP63-like', 99, NULL, NULL, 171891),
(171892, '3.30.10.10-FF-000001', NULL, 'Serine protease inhibitor, potato inhibitor I-type family protein', 69, NULL, NULL, 171892),
(171893, '1.10.1410.10-FF-000071', NULL, 'Caffeine-induced protein 16', 171, NULL, NULL, 171893),
(171894, '2.130.10.130-FF-000006', NULL, 'Integrin, alpha 9', 433, NULL, NULL, 171894),
(171895, '3.80.10.10-FF-000870', NULL, 'Leucine-rich repeat protein', 177, NULL, NULL, 171895),
(171896, '3.90.1410.10-FF-000040', NULL, 'Hypothetical_protein_-_conserved', 289, NULL, NULL, 171896),
(171897, '3.40.50.300-FF-003568', NULL, 'ATPase ASNA1 homolog', 325, NULL, NULL, 171897),
(171898, '1.10.510.10-FF-002434', NULL, 'Uncharacterized protein', 263, NULL, NULL, 171898),
(171899, '3.30.420.10-FF-000419', NULL, NULL, 161, NULL, NULL, 171899),
(171900, '1.20.58.2170-FF-000002', NULL, NULL, 66, NULL, NULL, 171900),
(171901, '3.20.20.140-FF-000045', NULL, 'Amidohydrolase family protein, expressed', 305, NULL, NULL, 171901),
(171902, '3.40.50.300-FF-004506', NULL, 'Repair helicase UvrD', 226, NULL, NULL, 171902),
(171903, '2.60.40.3500-FF-000009', NULL, NULL, 103, NULL, NULL, 171903),
(171904, '3.30.110.110-FF-000008', NULL, 'Double-strand break repair protein', 107, NULL, NULL, 171904),
(171905, '3.30.479.20-FF-000007', NULL, 'Elongation factor Ts, mitochondrial', 101, NULL, NULL, 171905),
(171906, '3.10.450.10-FF-000050', NULL, 'Uncharacterized protein', 98, NULL, NULL, 171906),
(171907, '2.60.60.20-FF-000019', NULL, 'Uncharacterized protein', 120, NULL, NULL, 171907),
(171908, '3.40.50.360-FF-000056', NULL, 'NADPH-dependent diflavin oxidoreductase 1', 178, NULL, NULL, 171908),
(171909, '3.30.230.70-FF-000052', NULL, 'Exosome complex exonuclease RRP41, putative', 234, NULL, NULL, 171909),
(171910, '1.10.1650.20-FF-000001', NULL, 'Ribonucleoside-diphosphate reductase', 54, NULL, NULL, 171910),
(171911, '2.60.120.260-FF-000111', NULL, 'anaphase-promoting complex subunit 10 isoform X4', 116, NULL, NULL, 171911),
(171912, '1.20.58.80-FF-000024', NULL, 'Endosome-associated ubiquitin isopeptidase (AmsH)', 133, NULL, NULL, 171912),
(171913, '3.20.20.70-FF-000621', NULL, NULL, 302, NULL, NULL, 171913),
(171914, '3.40.50.1820-FF-000796', NULL, 'Putative serine carboxypeptidase-like 52', 152, NULL, NULL, 171914),
(171915, '3.40.30.10-FF-000423', NULL, 'Thiol:disulfide interchange protein', 107, NULL, NULL, 171915),
(171916, '3.30.70.890-FF-000064', NULL, 'Mevalonate kinase', 133, NULL, NULL, 171916),
(171917, '3.10.250.10-FF-000130', NULL, NULL, 34, NULL, NULL, 171917),
(171918, '1.10.8.60-FF-000352', NULL, 'Werner helicase-interacting protein 1', 89, NULL, NULL, 171918),
(171919, '1.10.238.10-FF-000614', NULL, 'Centrin, putative', 74, NULL, NULL, 171919),
(171920, '3.40.50.150-FF-001797', NULL, NULL, 143, NULL, NULL, 171920),
(171921, '2.60.40.1180-FF-000033', NULL, 'Calpain-like cysteine peptidase, putative', 116, NULL, NULL, 171921),
(171922, '1.20.58.90-FF-000027', NULL, NULL, 112, NULL, NULL, 171922),
(171923, '1.25.40.20-FF-000287', NULL, 'Uveal autoantigen with coiled-coil domains and ankyrin repeats', 109, NULL, NULL, 171923),
(171924, '3.40.50.2020-FF-000019', NULL, 'Hypoxanthine phosphoribosyltransferase', 218, NULL, NULL, 171924),
(171925, '1.50.40.10-FF-000451', NULL, 'Uncharacterized protein', 119, NULL, NULL, 171925);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(171926, '3.20.20.60-FF-000135', NULL, 'Pyruvate kinase', 15, NULL, NULL, 171926),
(171927, '2.10.25.10-FF-000550', NULL, 'Growth arrest-specific protein 6', 43, NULL, NULL, 171927),
(171928, '3.30.160.60-FF-005922', NULL, NULL, 58, NULL, NULL, 171928),
(171929, '2.40.50.100-FF-000038', NULL, '50S ribosomal protein L27', 92, NULL, NULL, 171929),
(171930, '1.20.1070.10-FF-001660', NULL, 'Predicted protein', 127, NULL, NULL, 171930),
(171931, '1.10.167.10-FF-000067', NULL, 'Uncharacterized protein', 102, NULL, NULL, 171931),
(171932, '3.10.105.10-FF-000057', NULL, 'ABC-type uncharacterized transport system, periplasmic component', 193, NULL, NULL, 171932),
(171933, '3.40.50.300-FF-001769', NULL, 'ras-related protein RABF2a', 200, NULL, NULL, 171933),
(171934, '1.10.287.110-FF-000106', NULL, 'Putative heat shock protein-like protein', 108, NULL, NULL, 171934),
(171935, '3.30.450.40-FF-000110', NULL, 'Histidine kinase sensor protein', 143, NULL, NULL, 171935),
(171936, '3.30.479.10-FF-000004', NULL, '6-carboxytetrahydropterin synthase QueD', 59, NULL, NULL, 171936),
(171937, '3.40.50.720-FF-000861', NULL, 'Shikimate dehydrogenase', 139, NULL, NULL, 171937),
(171938, '1.10.510.10-FF-000635', NULL, 'Casein kinase I', 319, NULL, NULL, 171938),
(171939, '2.60.40.1170-FF-000030', NULL, 'AP-1 complex subunit mu-1', 180, NULL, NULL, 171939),
(171940, '2.130.10.10-FF-005574', NULL, 'Vacuolar protein sorting/targeting protein 10', 208, NULL, NULL, 171940),
(171941, '2.60.260.20-FF-000070', NULL, 'DnaJ domain containing protein', 78, NULL, NULL, 171941),
(171942, '3.20.20.80-FF-000624', NULL, 'Uncharacterized protein', 133, NULL, NULL, 171942),
(171943, '2.60.40.10-FF-002336', NULL, 'B-cell receptor CD22', 127, NULL, NULL, 171943),
(171944, '3.40.50.620-FF-000887', NULL, 'Uncharacterized protein', 100, NULL, NULL, 171944),
(171945, '2.10.25.10-FF-001213', NULL, 'Uncharacterized protein', 33, NULL, NULL, 171945),
(171946, '1.10.150.50-FF-000041', NULL, 'Chromosome 19 C19orf47 homolog', 71, NULL, NULL, 171946),
(171947, '1.10.730.20-FF-000003', NULL, 'Isoleucine--tRNA ligase', 284, NULL, NULL, 171947),
(171948, '3.30.70.940-FF-000017', NULL, 'Transcription termination/antitermination protein NusG', 109, NULL, NULL, 171948),
(171949, '1.25.40.10-FF-001189', NULL, 'Tetratricopeptide repeat domain 21A', 139, NULL, NULL, 171949),
(171950, '2.60.120.200-FF-000762', NULL, 'Uncharacterized protein', 83, NULL, NULL, 171950),
(171951, '3.20.20.80-FF-000293', NULL, 'Alpha-L-fucosidase', 197, NULL, NULL, 171951),
(171952, '3.40.190.290-FF-000025', NULL, 'LysR family transcriptional regulator', 203, NULL, NULL, 171952),
(171953, '2.60.40.10-FF-003893', NULL, NULL, 96, NULL, NULL, 171953),
(171954, '2.30.30.140-FF-000088', NULL, 'Protein EMSY-LIKE 3', 53, NULL, NULL, 171954),
(171955, '3.80.10.10-FF-003113', NULL, 'D111/G-patch domain-containing protein', 100, NULL, NULL, 171955),
(171956, '3.20.20.70-FF-000290', NULL, '3-dehydroquinate dehydratase', 228, NULL, NULL, 171956),
(171957, '1.10.472.80-FF-000241', NULL, NULL, 132, NULL, NULL, 171957),
(171958, '3.40.50.1000-FF-000730', NULL, NULL, 74, NULL, NULL, 171958),
(171959, '1.10.238.20-FF-000056', NULL, 'IP02289p', 107, NULL, NULL, 171959),
(171960, '3.30.420.40-FF-000900', NULL, 'Predicted protein', 98, NULL, NULL, 171960),
(171961, '3.30.40.10-FF-001352', NULL, 'RBR-type E3 ubiquitin transferase', 90, NULL, NULL, 171961),
(171962, '3.40.50.2000-FF-000755', NULL, 'Os03g0757000 protein', 137, NULL, NULL, 171962),
(171963, '3.40.50.1100-FF-000294', NULL, 'Bifunctional D-cysteine desulfhydrase/1-aminocyclopropane-1-carboxylate deaminase mitochondrial', 78, NULL, NULL, 171963),
(171964, '3.40.50.300-FF-003489', NULL, 'ABC transporter G family member 39', 108, NULL, NULL, 171964),
(171965, '3.40.50.300-FF-003843', NULL, 'Ras-associated protein 2-like, isoform C', 114, NULL, NULL, 171965),
(171966, '1.20.1110.10-FF-000074', NULL, 'Calcium-transporting ATPase', 286, NULL, NULL, 171966),
(171967, '4.10.1120.10-FF-000001', NULL, 'retinal rod rhodopsin-sensitive cGMP 3'',5''-cyclic phosphodiesterase subunit gamma', 86, NULL, NULL, 171967);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(171968, '1.20.120.1080-FF-000082', NULL, 'Putative RNA helicase family protein', 104, NULL, NULL, 171968),
(171969, '3.40.50.720-FF-001024', NULL, 'Oxidoreductase domain protein', 150, NULL, NULL, 171969),
(171970, '3.90.180.10-FF-000191', NULL, 'Uncharacterized protein', 42, NULL, NULL, 171970),
(171971, '3.40.50.2300-FF-001126', NULL, NULL, 69, NULL, NULL, 171971),
(171972, '3.60.21.10-FF-000227', NULL, 'Serine/threonine-protein phosphatase', 316, NULL, NULL, 171972),
(171973, '3.40.50.150-FF-001179', NULL, 'PKS-NRPS hybrid synthetase psoA', 303, NULL, NULL, 171973),
(171974, '3.10.250.10-FF-000017', NULL, 'CD6 molecule', 103, NULL, NULL, 171974),
(171975, '1.25.40.20-FF-000080', NULL, 'ankyrin repeat domain-containing protein 17 isoform X3', 99, NULL, NULL, 171975),
(171976, '3.40.50.2020-FF-000171', NULL, 'Uncharacterized protein', 89, NULL, NULL, 171976),
(171977, '1.10.238.10-FF-000053', NULL, 'Putative testican-3 isoform 3', 117, NULL, NULL, 171977),
(171978, '3.40.50.150-FF-000044', NULL, 'Ribosomal RNA large subunit methyltransferase I', 215, NULL, NULL, 171978),
(171979, '3.90.1750.10-FF-000031', NULL, 'E3 ubiquitin-protein ligase TOM1', 191, NULL, NULL, 171979),
(171980, '2.170.130.30-FF-000003', NULL, 'Transcobalamin 1', 103, NULL, NULL, 171980),
(171981, '1.10.10.10-FF-000400', NULL, 'DiSHevelled related', 100, NULL, NULL, 171981),
(171982, '3.40.50.2060-FF-000014', NULL, 'SNARE-interacting protein KEULE', 139, NULL, NULL, 171982),
(171983, '1.10.510.10-FF-003862', NULL, NULL, 99, NULL, NULL, 171983),
(171984, '3.30.860.10-FF-000003', NULL, 'Ribosomal protein S19, mitochondrial', 90, NULL, NULL, 171984),
(171985, '3.30.160.60-FF-001538', NULL, 'Zinc finger 202 m1', 31, NULL, NULL, 171985),
(171986, '2.10.220.10-FF-000222', NULL, 'Proprotein convertase subtilisin/kexin type 5a', 109, NULL, NULL, 171986),
(171987, '3.40.50.620-FF-000909', NULL, 'Uncharacterized protein', 47, NULL, NULL, 171987),
(171988, '1.20.1050.80-FF-000022', NULL, 'UPF0507 protein YALI0E18612g', 157, NULL, NULL, 171988),
(171989, '3.40.50.12160-FF-000008', NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase', 132, NULL, NULL, 171989),
(171990, '4.10.75.10-FF-000014', NULL, 'Uromodulin-like 1', 45, NULL, NULL, 171990),
(171991, '1.10.10.160-FF-000025', NULL, 'ATP-dependent DNA helicase', 76, NULL, NULL, 171991),
(171992, '3.40.250.10-FF-000213', NULL, 'Uncharacterized protein', 114, NULL, NULL, 171992),
(171993, '3.30.160.60-FF-005580', NULL, NULL, 34, NULL, NULL, 171993),
(171994, '3.30.160.60-FF-004023', NULL, NULL, 25, NULL, NULL, 171994),
(171995, '2.60.40.10-FF-005484', NULL, NULL, 100, NULL, NULL, 171995),
(171996, '3.50.50.60-FF-000658', NULL, 'Prenylcysteine oxidase 1', 71, NULL, NULL, 171996),
(171997, '3.30.40.10-FF-000857', NULL, 'E3 ubiquitin-protein ligase DTX3L', 66, NULL, NULL, 171997),
(171998, '1.25.10.10-FF-002047', NULL, 'cytoskeleton-associated protein 5 isoform X2', 100, NULL, NULL, 171998),
(171999, '2.40.420.20-FF-000059', NULL, 'Acriflavin resistance periplasmic protein', 91, NULL, NULL, 171999),
(172000, '1.10.1450.10-FF-000112', NULL, 'Tetraspanin', 99, NULL, NULL, 172000),
(172001, '3.20.20.80-FF-000854', NULL, 'Uncharacterized protein', 82, NULL, NULL, 172001),
(172002, '3.90.1100.10-FF-000050', NULL, 'DNA-directed RNA polymerase subunit beta', 91, NULL, NULL, 172002),
(172003, '1.20.58.1250-FF-000001', NULL, 'Tubulin-specific chaperone C', 112, NULL, NULL, 172003),
(172004, '3.30.160.60-FF-003747', NULL, 'Zinc finger protein 1182', 30, NULL, NULL, 172004),
(172005, '3.40.50.1000-FF-000056', NULL, 'Cation-transporting ATPase', 177, NULL, NULL, 172005),
(172006, '1.10.3080.10-FF-000056', NULL, 'Chloride channel protein', 113, NULL, NULL, 172006),
(172007, '3.40.50.720-FF-001081', NULL, '3-oxoacyl-[acyl-carrier-protein] reductase FabG', 253, NULL, NULL, 172007),
(172008, '1.10.10.390-FF-000009', NULL, 'Histone acetyltransferase type B catalytic subunit', 52, NULL, NULL, 172008),
(172009, '1.25.40.20-FF-000641', NULL, 'Serine/threonine protein kinase', 93, NULL, NULL, 172009);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(172010, '3.40.50.2300-FF-001183', NULL, NULL, 59, NULL, NULL, 172010),
(172011, '1.20.1640.10-FF-000102', NULL, NULL, 222, NULL, NULL, 172011),
(172012, '2.60.120.620-FF-000152', NULL, 'Uncharacterized protein', 226, NULL, NULL, 172012),
(172013, '3.30.200.20-FF-000030', NULL, 'Non-specific serine/threonine protein kinase', 95, NULL, NULL, 172013),
(172014, '2.40.10.120-FF-000002', NULL, 'HtrA serine peptidase 3', 214, NULL, NULL, 172014),
(172015, '3.90.640.10-FF-000119', NULL, 'ARP5 actin related protein 5 homolog', 52, NULL, NULL, 172015),
(172016, '2.130.10.10-FF-001589', NULL, 'Mahjong, isoform B', 317, NULL, NULL, 172016),
(172017, '3.40.50.11990-FF-000007', NULL, 'RNA polymerase-associated protein CDC73, putative', 188, NULL, NULL, 172017),
(172018, '4.10.280.10-FF-000072', NULL, 'enhancer of split mgamma protein-like', 68, NULL, NULL, 172018),
(172019, '2.20.25.10-FF-000066', NULL, 'DNA-directed RNA polymerase subunit', 53, NULL, NULL, 172019),
(172020, '3.40.50.1010-FF-000059', NULL, 'Putative 5''-3'' exonuclease, N-terminal resolvase-like domain', 140, NULL, NULL, 172020),
(172021, '3.30.470.160-FF-000002', NULL, 'Kinase', 286, NULL, NULL, 172021),
(172022, '2.60.40.10-FF-002050', NULL, 'Muscle M-line assembly protein unc-89', 93, NULL, NULL, 172022),
(172023, '1.10.8.60-FF-000077', NULL, 'Peroxisome biogenesis protein 6', 88, NULL, NULL, 172023),
(172024, '1.10.10.10-FF-001535', NULL, 'Subunit of ESCRT-II complex', 89, NULL, NULL, 172024),
(172025, '4.10.1200.10-FF-000002', NULL, 'Nitrate reductase subunit alpha', 36, NULL, NULL, 172025),
(172026, '4.10.1250.10-FF-000005', NULL, 'Glycine cleavage system T protein', 46, NULL, NULL, 172026),
(172027, '4.10.1240.10-FF-000044', NULL, 'Uncharacterized protein', 72, NULL, NULL, 172027),
(172028, '2.10.25.10-FF-000196', NULL, 'Fibrillin 2', 40, NULL, NULL, 172028),
(172029, '3.40.50.2000-FF-001031', NULL, 'Uncharacterized protein', 170, NULL, NULL, 172029),
(172030, '3.40.50.11980-FF-000004', NULL, 'Telomerase-binding protein EST1A', 161, NULL, NULL, 172030),
(172031, '3.30.60.30-FF-000105', NULL, 'AGAP010646-PA', 43, NULL, NULL, 172031),
(172032, '3.30.200.20-FF-001255', NULL, 'CMGC family protein kinase', 86, NULL, NULL, 172032),
(172033, '3.30.1660.10-FF-000004', NULL, 'Calcium dodecin', 71, NULL, NULL, 172033),
(172034, '2.60.40.10-FF-000307', NULL, 'collagen alpha-1(VII) chain isoform X1', 91, NULL, NULL, 172034),
(172035, '1.20.1560.10-FF-000399', NULL, 'ATP-binding cassette transporter (ABC transporter) family C member 11', 322, NULL, NULL, 172035),
(172036, '1.10.8.50-FF-000017', NULL, 'Fibronectin-binding protein / Fibrinogen-binding protein', 68, NULL, NULL, 172036),
(172037, '3.40.640.10-FF-000001', NULL, 'Serine hydroxymethyltransferase', 244, NULL, NULL, 172037),
(172038, '3.40.50.1480-FF-000031', NULL, NULL, 28, NULL, NULL, 172038),
(172039, '3.30.70.330-FF-001907', NULL, NULL, 74, NULL, NULL, 172039),
(172040, '1.25.50.20-FF-000018', NULL, 'Aminopeptidase', 337, NULL, NULL, 172040),
(172041, '2.10.50.10-FF-000158', NULL, 'Uncharacterized protein', 56, NULL, NULL, 172041),
(172042, '2.40.128.310-FF-000001', NULL, 'Protein HRI1', 95, NULL, NULL, 172042),
(172043, '1.20.1250.20-FF-001132', NULL, 'Uncharacterized protein', 206, NULL, NULL, 172043),
(172044, '2.40.30.20-FF-000024', NULL, 'Riboflavin synthase, alpha subunit', 81, NULL, NULL, 172044),
(172045, '3.40.5.120-FF-000007', NULL, 'Chromodomain-helicase-DNA-binding protein 8', 35, NULL, NULL, 172045),
(172046, '2.30.310.10-FF-000005', NULL, 'FbpA domain protein, putative', 179, NULL, NULL, 172046),
(172047, '3.40.50.1820-FF-000919', NULL, 'Predicted protein', 141, NULL, NULL, 172047),
(172048, '2.40.30.30-FF-000027', NULL, 'Riboflavin biosynthesis protein', 133, NULL, NULL, 172048),
(172049, '1.10.10.10-FF-001816', NULL, 'Glr1376 protein', 101, NULL, NULL, 172049),
(172050, '2.40.30.10-FF-000021', NULL, 'NADH-cytochrome b5 reductase', 117, NULL, NULL, 172050),
(172051, '1.10.10.580-FF-000010', NULL, 'DNA repair protein Rad21, putative', 80, NULL, NULL, 172051),
(172052, '1.25.40.10-FF-004123', NULL, 'Uncharacterized protein', 126, NULL, NULL, 172052);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(172053, '3.40.50.1390-FF-000009', NULL, 'Recombinase family protein', 133, NULL, NULL, 172053),
(172054, '3.40.50.150-FF-000049', NULL, '23S rRNA (uracil(747)-C(5))-methyltransferase RlmC', 199, NULL, NULL, 172054),
(172055, '2.60.40.10-FF-002218', NULL, 'roundabout homolog 2', 102, NULL, NULL, 172055),
(172056, '2.10.25.10-FF-001331', NULL, 'Delta-like protein', 43, NULL, NULL, 172056),
(172057, '3.30.160.60-FF-005366', NULL, NULL, 27, NULL, NULL, 172057),
(172058, '3.20.20.60-FF-000056', NULL, 'Macrophomate synthase, putative', 286, NULL, NULL, 172058),
(172059, '2.60.40.150-FF-000041', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', 152, NULL, NULL, 172059),
(172060, '3.40.50.300-FF-001983', NULL, 'DNA helicase', 196, NULL, NULL, 172060),
(172061, '1.10.630.10-FF-000583', NULL, 'Uncharacterized protein', 300, NULL, NULL, 172061),
(172062, '3.30.1490.180-FF-000022', NULL, 'DNA-directed RNA polymerase subunit', 20, NULL, NULL, 172062),
(172063, '3.40.50.150-FF-000105', NULL, 'Genome polyprotein', 272, NULL, NULL, 172063),
(172064, '3.90.1200.10-FF-000052', NULL, 'Uncharacterized protein', 169, NULL, NULL, 172064),
(172065, '3.30.1370.100-FF-000033', NULL, 'DNA mismatch repair protein PMS1', 123, NULL, NULL, 172065),
(172066, '3.40.50.150-FF-001628', NULL, NULL, 241, NULL, NULL, 172066),
(172067, '3.40.50.300-FF-000353', NULL, 'Dynein axonemal heavy chain 1', 189, NULL, NULL, 172067),
(172068, '1.10.437.10-FF-000009', NULL, 'Uncharacterized protein, isoform A', 195, NULL, NULL, 172068),
(172069, '1.20.1740.10-FF-000054', NULL, 'Large neutral amino acids transporter small subunit 2', 323, NULL, NULL, 172069),
(172070, '3.40.47.10-FF-000113', NULL, 'Putative 3-oxoacyl-(Acyl-carrier-protein) synthase III', 196, NULL, NULL, 172070),
(172071, '3.30.230.120-FF-000004', NULL, 'Putative fucose kinase', 366, NULL, NULL, 172071),
(172072, '1.20.144.10-FF-000001', NULL, 'Lipid phosphate phosphatase 2', 233, NULL, NULL, 172072),
(172073, '3.30.160.20-FF-000088', NULL, 'Uncharacterized protein ZK632.2', 95, NULL, NULL, 172073),
(172074, '2.60.40.10-FF-001499', NULL, 'Interleukin-27 subunit beta', 99, NULL, NULL, 172074),
(172075, '3.40.20.10-FF-000136', NULL, 'Actin depolymerizing protein', 153, NULL, NULL, 172075),
(172076, '3.10.20.90-FF-000318', NULL, 'polycomb group protein Psc', 117, NULL, NULL, 172076),
(172077, '3.40.5.100-FF-000001', NULL, 'Arsenite methyltransferase', 74, NULL, NULL, 172077),
(172078, '2.40.240.10-FF-000019', NULL, '50S ribosomal protein L25', 93, NULL, NULL, 172078),
(172079, '3.40.50.800-FF-000115', NULL, 'Uncharacterized protein', 92, NULL, NULL, 172079),
(172080, '3.30.1330.120-FF-000003', NULL, '2-methylcitrate dehydratase PrpD', 133, NULL, NULL, 172080),
(172081, '3.90.70.10-FF-000322', NULL, 'Ubiquitinyl hydrolase 1', 187, NULL, NULL, 172081),
(172082, '3.30.70.100-FF-000147', NULL, NULL, 63, NULL, NULL, 172082),
(172083, '3.40.630.30-FF-000349', NULL, 'Glucosamine 6-phosphate N-acetyltransferase', 141, NULL, NULL, 172083),
(172084, '4.10.400.10-FF-000301', NULL, 'Vitellogenin receptor', 38, NULL, NULL, 172084),
(172085, '4.10.860.120-FF-000004', NULL, 'DNA-directed RNA polymerase subunit', 129, NULL, NULL, 172085),
(172086, '1.20.1110.10-FF-000023', NULL, 'Cation-transporting ATPase', 141, NULL, NULL, 172086),
(172087, '1.10.3080.10-FF-000090', NULL, 'Chloride channel protein', 95, NULL, NULL, 172087),
(172088, '3.40.190.10-FF-000421', NULL, 'HTH-type transcriptional regulator IlvY', 81, NULL, NULL, 172088),
(172089, '2.30.29.240-FF-000014', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 182, NULL, NULL, 172089),
(172090, '3.90.226.10-FF-000022', NULL, 'methylglutaconyl-CoA hydratase, mitochondrial isoform X1', 210, NULL, NULL, 172090),
(172091, '3.80.10.10-FF-004248', NULL, 'Uncharacterized protein', 72, NULL, NULL, 172091),
(172092, '1.20.1250.20-FF-002329', NULL, 'Uncharacterized protein', 169, NULL, NULL, 172092),
(172093, '3.40.50.300-FF-004624', NULL, 'Dynein heavy chain', 230, NULL, NULL, 172093),
(172094, '1.10.10.10-FF-001861', NULL, 'Predicted protein', 73, NULL, NULL, 172094);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(172095, '3.40.710.10-FF-000018', NULL, 'D-alanyl-D-alanine carboxypeptidase dacB', 235, NULL, NULL, 172095),
(172096, '1.20.120.1910-FF-000044', NULL, 'Cysteine--tRNA ligase', 179, NULL, NULL, 172096),
(172097, '3.40.109.10-FF-000014', NULL, 'Putative NAD(P)H nitroreductase acg', 224, NULL, NULL, 172097),
(172098, '3.40.50.880-FF-000026', NULL, 'Protein/nucleic acid deglycase HchA', 282, NULL, NULL, 172098),
(172099, '1.25.40.10-FF-003448', NULL, 'Pentatricopeptide repeat-containing protein', 139, NULL, NULL, 172099),
(172100, '3.90.228.10-FF-000072', NULL, 'Poly [ADP-ribose] polymerase', 215, NULL, NULL, 172100),
(172101, '1.20.1740.10-FF-000161', NULL, 'Putative amino acid transporter', 438, NULL, NULL, 172101),
(172102, '3.10.580.10-FF-000172', NULL, 'Chloride channel protein', 147, NULL, NULL, 172102),
(172103, '3.40.50.720-FF-000647', NULL, 'YNL181W-like protein', 332, NULL, NULL, 172103),
(172104, '4.10.240.10-FF-000187', NULL, 'Zcf21p', 85, NULL, NULL, 172104),
(172105, '2.60.40.10-FF-004410', NULL, NULL, 100, NULL, NULL, 172105),
(172106, '2.40.30.330-FF-000002', NULL, 'Protein CLP1 homolog', 111, NULL, NULL, 172106),
(172107, '1.20.1560.10-FF-000916', NULL, 'Uncharacterized protein', 122, NULL, NULL, 172107),
(172108, '1.10.510.10-FF-000422', NULL, 'serine/threonine-protein kinase 17B', 239, NULL, NULL, 172108),
(172109, '2.60.40.1280-FF-000006', NULL, NULL, 158, NULL, NULL, 172109),
(172110, '3.40.50.11780-FF-000001', NULL, 'Major tail sheath protein', 196, NULL, NULL, 172110),
(172111, '3.30.160.60-FF-004910', NULL, NULL, 54, NULL, NULL, 172111),
(172112, '1.25.10.10-FF-001822', NULL, 'Protein CBG25999', 182, NULL, NULL, 172112),
(172113, '2.40.50.140-FF-001157', NULL, NULL, 92, NULL, NULL, 172113),
(172114, '3.90.1750.10-FF-000082', NULL, 'Apoptosis-resistant E3 ubiquitin protein ligase 1', 163, NULL, NULL, 172114),
(172115, '1.25.40.120-FF-000094', NULL, 'Uncharacterized protein', 174, NULL, NULL, 172115),
(172116, '2.30.30.40-FF-000272', NULL, 'Chemotaxis protein CheW', 57, NULL, NULL, 172116),
(172117, '3.20.20.70-FF-000059', NULL, 'N-ethylmaleimide reductase, FMN-linked', 360, NULL, NULL, 172117),
(172118, '1.10.20.10-FF-000052', NULL, 'Histone H2A', 63, NULL, NULL, 172118),
(172119, '3.30.200.20-FF-001367', NULL, 'Protein CBR-DYF-18', 88, NULL, NULL, 172119),
(172120, '3.30.230.130-FF-000007', NULL, 'Cullin-3A like', 155, NULL, NULL, 172120),
(172121, '3.90.70.10-FF-000373', NULL, 'Probable papain cyctein protease', 337, NULL, NULL, 172121),
(172122, '3.40.50.2000-FF-001036', NULL, 'Uncharacterized protein', 167, NULL, NULL, 172122),
(172123, '3.40.50.1440-FF-000160', NULL, 'Uncharacterized protein', 161, NULL, NULL, 172123),
(172124, '3.30.160.20-FF-000144', NULL, 'Protein CBG12024', 102, NULL, NULL, 172124),
(172125, '1.20.1250.20-FF-001025', NULL, 'Solute carrier family 22 (organic cation transporter), member 21', 413, NULL, NULL, 172125),
(172126, '1.10.8.60-FF-000470', NULL, 'ATPase, AAA family protein', 77, NULL, NULL, 172126),
(172127, '2.10.25.10-FF-000763', NULL, 'Matrilin-4', 38, NULL, NULL, 172127),
(172128, '3.40.920.10-FF-000006', NULL, 'Sulfite reductase alpha subunit', 186, NULL, NULL, 172128),
(172129, '2.130.10.10-FF-001477', NULL, 'WD domain, G-beta repeat-containing protein', 207, NULL, NULL, 172129),
(172130, '2.60.40.60-FF-000625', NULL, 'Cadherin-related neuronal receptor 9', 107, NULL, NULL, 172130),
(172131, '3.40.50.150-FF-001679', NULL, NULL, 143, NULL, NULL, 172131),
(172132, '1.25.40.10-FF-001324', NULL, 'Empty pericarp7', 98, NULL, NULL, 172132),
(172133, '1.10.560.10-FF-000133', NULL, 'Uncharacterized protein', 45, NULL, NULL, 172133),
(172134, '3.30.70.340-FF-000039', NULL, NULL, 47, NULL, NULL, 172134),
(172135, '2.10.80.10-FF-000003', NULL, 'Dickkopf WNT-signaling pathway inhibitor 3', 93, NULL, NULL, 172135),
(172136, '3.80.10.10-FF-001319', NULL, 'Leucine-rich repeat receptor-like protein kinase TDR', 105, NULL, NULL, 172136),
(172137, '2.130.10.10-FF-003657', NULL, 'Uncharacterized protein', 316, NULL, NULL, 172137),
(172138, '3.40.50.20-FF-000074', NULL, 'Glutathione synthetase', 118, NULL, NULL, 172138);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(172139, '3.40.630.10-FF-000017', NULL, 'Succinylglutamate desuccinylase', 322, NULL, NULL, 172139),
(172140, '1.10.1790.10-FF-000003', NULL, 'Transcription antiterminator LicT', 110, NULL, NULL, 172140),
(172141, '1.10.287.70-FF-000622', NULL, 'Uncharacterized protein', 224, NULL, NULL, 172141),
(172142, '3.40.50.10130-FF-000068', NULL, 'Uncharacterized protein', 81, NULL, NULL, 172142),
(172143, '3.30.70.260-FF-000167', NULL, 'ACT domain protein', 77, NULL, NULL, 172143),
(172144, '2.60.120.290-FF-000165', NULL, 'Cubilin homolog', 120, NULL, NULL, 172144),
(172145, '3.90.70.10-FF-000266', NULL, 'Ubiquitin-specific peptidase 1', 345, NULL, NULL, 172145),
(172146, '4.10.780.10-FF-000003', NULL, 'Pyruvate:ferredoxin (Flavodoxin) oxidoreductase', 41, NULL, NULL, 172146),
(172147, '1.10.3720.10-FF-000004', NULL, 'Sulfate transport system permease protein CysT', 259, NULL, NULL, 172147),
(172148, '2.40.70.10-FF-000181', NULL, 'Acid extracellular protease', 165, NULL, NULL, 172148),
(172149, '3.30.460.10-FF-000074', NULL, 'Repair DNA polymerase X', 108, NULL, NULL, 172149),
(172150, '2.60.40.10-FF-004461', NULL, NULL, 105, NULL, NULL, 172150),
(172151, '2.10.25.10-FF-000437', NULL, 'Laminin subunit alpha 5', 51, NULL, NULL, 172151),
(172152, '1.10.472.80-FF-000185', NULL, NULL, 134, NULL, NULL, 172152),
(172153, '3.40.50.1820-FF-001813', NULL, 'Protein phosphatase methylesterase 1', 112, NULL, NULL, 172153),
(172154, '2.60.40.10-FF-001881', NULL, 'immunoglobulin superfamily DCC subclass member 3', 99, NULL, NULL, 172154),
(172155, '3.30.160.60-FF-004062', NULL, NULL, 36, NULL, NULL, 172155),
(172156, '3.30.70.920-FF-000011', NULL, 'Lrp/AsnC family transcriptional regulator', 97, NULL, NULL, 172156),
(172157, '1.25.10.10-FF-000136', NULL, 'serine/threonine-protein kinase SMG1 isoform X1', 225, NULL, NULL, 172157),
(172158, '3.40.50.11990-FF-000002', NULL, 'protein CDC73 homolog', 168, NULL, NULL, 172158),
(172159, '2.130.10.10-FF-005748', NULL, 'Uncharacterized protein', 121, NULL, NULL, 172159),
(172160, '2.60.40.10-FF-000190', NULL, 'Ephrin type-A receptor 7', 109, NULL, NULL, 172160),
(172161, '1.10.510.10-FF-001945', NULL, 'Predicted protein', 291, NULL, NULL, 172161),
(172162, '3.30.40.10-FF-001054', NULL, 'Ubiquitinyl hydrolase 1', 102, NULL, NULL, 172162),
(172163, '3.30.420.10-FF-000184', NULL, 'Gag-Pol polyprotein', 164, NULL, NULL, 172163),
(172164, '1.10.10.10-FF-000512', NULL, 'Chromatin modification-related protein YNG2', 92, NULL, NULL, 172164),
(172165, '3.10.20.90-FF-000644', NULL, 'Uncharacterized protein', 115, NULL, NULL, 172165),
(172166, '2.170.300.10-FF-000056', NULL, 'Uncharacterized protein', 57, NULL, NULL, 172166),
(172167, '3.30.1780.10-FF-000007', NULL, 'YGL159W-like protein', 131, NULL, NULL, 172167),
(172168, '3.30.70.1070-FF-000001', NULL, 'Cell division protein DedD', 73, NULL, NULL, 172168),
(172169, '1.25.40.120-FF-000043', NULL, 'Protein farnesyltransferase alpha subunit / Protein geranylgeranyltransferase type I, alpha subunit', 236, NULL, NULL, 172169),
(172170, '2.60.40.10-FF-000420', NULL, 'Sidekick cell adhesion molecule 2', 100, NULL, NULL, 172170),
(172171, '3.40.50.300-FF-008216', NULL, 'Uncharacterized protein', 67, NULL, NULL, 172171),
(172172, '1.25.40.10-FF-001268', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial isoform A', 182, NULL, NULL, 172172),
(172173, '3.30.300.30-FF-000029', NULL, 'Fatty-acid-CoA ligase FadD31', 122, NULL, NULL, 172173),
(172174, '1.10.287.130-FF-000146', NULL, 'PAS domain S-box protein', 80, NULL, NULL, 172174),
(172175, '1.10.20.10-FF-000007', NULL, 'Histone H4', 102, NULL, NULL, 172175),
(172176, '1.25.10.10-FF-001766', NULL, 'Importin-alpha re-exporter protein, putative', 944, NULL, NULL, 172176),
(172177, '3.30.310.10-FF-000029', NULL, 'AP-2 complex subunit alpha', 115, NULL, NULL, 172177),
(172178, '3.30.559.10-FF-000269', NULL, 'GH02484p', 170, NULL, NULL, 172178),
(172179, '1.10.418.60-FF-000025', NULL, 'Protein CBR-HIM-10', 82, NULL, NULL, 172179),
(172180, '2.120.10.30-FF-000027', NULL, 'Regucalcin homologue', 301, NULL, NULL, 172180);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(172181, '3.40.50.200-FF-000137', NULL, 'Tripeptidyl-peptidase 2-like protein', 93, NULL, NULL, 172181),
(172182, '3.30.70.20-FF-000103', NULL, NULL, 73, NULL, NULL, 172182),
(172183, '3.40.50.10130-FF-000012', NULL, 'ERCC1 nucleotide excision repair protein, putative', 115, NULL, NULL, 172183),
(172184, '3.30.160.60-FF-005692', NULL, NULL, 66, NULL, NULL, 172184),
(172185, '1.10.287.70-FF-000566', NULL, 'Uncharacterized protein', 276, NULL, NULL, 172185),
(172186, '3.40.50.300-FF-000134', NULL, 'Iron-enterobactin ABC transporter ATP-binding protein', 251, NULL, NULL, 172186),
(172187, '2.130.10.10-FF-003545', NULL, 'Uncharacterized protein', 193, NULL, NULL, 172187),
(172188, '3.20.20.190-FF-000043', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', 175, NULL, NULL, 172188),
(172189, '2.10.25.10-FF-000488', NULL, 'von Willebrand factor D and EGF domains', 42, NULL, NULL, 172189),
(172190, '1.10.1000.11-FF-000029', NULL, 'Protein transport protein sec72', 120, NULL, NULL, 172190),
(172191, '3.40.710.10-FF-000176', NULL, 'Penicillin-binding protein 1A', 80, NULL, NULL, 172191),
(172192, '3.30.40.10-FF-000565', NULL, 'RING-type E3 ubiquitin transferase', 93, NULL, NULL, 172192),
(172193, '3.20.20.140-FF-000449', NULL, 'Sodium/hydrogen exchanger 2', 49, NULL, NULL, 172193),
(172194, '2.60.40.10-FF-005658', NULL, NULL, 89, NULL, NULL, 172194),
(172195, '4.10.400.10-FF-000071', NULL, 'Prolow-density lipoprotein receptor-related protein 1', 44, NULL, NULL, 172195),
(172196, '3.30.360.10-FF-000066', NULL, 'Aspartate-semialdehyde dehydrogenase', 159, NULL, NULL, 172196),
(172197, '3.10.110.10-FF-000125', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 160, NULL, NULL, 172197),
(172198, '1.10.10.10-FF-000282', NULL, 'RNA polymerase sigma factor SigX', 56, NULL, NULL, 172198),
(172199, '3.40.50.620-FF-000387', NULL, 'Probable nicotinate-nucleotide adenylyltransferase', 164, NULL, NULL, 172199),
(172200, '3.40.630.30-FF-000675', NULL, 'Uncharacterized protein', 144, NULL, NULL, 172200),
(172201, '3.80.10.10-FF-003006', NULL, 'Predicted protein', 244, NULL, NULL, 172201),
(172202, '3.40.250.10-FF-000090', NULL, 'Uncharacterized protein, isoform A', 139, NULL, NULL, 172202),
(172203, '1.10.287.1490-FF-000015', NULL, 'WD repeat-containing protein 65, putative', 147, NULL, NULL, 172203),
(172204, '2.30.30.40-FF-000502', NULL, 'BAR domaincontaining protein', 90, NULL, NULL, 172204),
(172205, '2.30.29.30-FF-001210', NULL, 'Amyloid beta precursor protein binding family A member 3', 159, NULL, NULL, 172205),
(172206, '3.30.70.330-FF-001615', NULL, NULL, 93, NULL, NULL, 172206),
(172207, '3.30.160.60-FF-003449', NULL, 'Zinc finger protein 223', 26, NULL, NULL, 172207),
(172208, '1.10.10.10-FF-001709', NULL, 'Transcriptional regulator, LysR family', 91, NULL, NULL, 172208),
(172209, '1.25.40.10-FF-002032', NULL, 'Putative pentatricopeptide repeat-containing protein', 111, NULL, NULL, 172209),
(172210, '3.30.2410.10-FF-000019', NULL, 'G2/M-phase specific E3 ubiquitin protein ligase', 85, NULL, NULL, 172210),
(172211, '2.130.10.10-FF-005636', NULL, 'Uncharacterized protein', 176, NULL, NULL, 172211),
(172212, '3.90.70.80-FF-000085', NULL, 'Uncharacterized protein', 97, NULL, NULL, 172212),
(172213, '2.60.120.10-FF-000321', NULL, 'Uncharacterized protein', 157, NULL, NULL, 172213),
(172214, '3.40.50.150-FF-000431', NULL, 'tRNA(Phe) (4-demethylwyosine(37)-C(7)) aminocarboxypropyltransferase', 192, NULL, NULL, 172214),
(172215, '1.10.3520.10-FF-000023', NULL, 'Uncharacterized protein', 134, NULL, NULL, 172215),
(172216, '2.10.70.10-FF-000126', NULL, 'Complement C1r subcomponent like', 51, NULL, NULL, 172216),
(172217, '3.40.50.2020-FF-000064', NULL, 'Hypoxanthine phosphoribosyltransferase', 231, NULL, NULL, 172217),
(172218, '3.40.50.720-FF-000973', NULL, 'Pyrroline-5-carboxylate reductase', 173, NULL, NULL, 172218),
(172219, '1.10.287.110-FF-000140', NULL, 'Chaperone protein DNAj', 114, NULL, NULL, 172219),
(172220, '1.10.510.10-FF-000192', NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', 204, NULL, NULL, 172220);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(172221, '3.40.50.11340-FF-000004', NULL, 'Galactoside 2-alpha-L-fucosyltransferase', 51, NULL, NULL, 172221),
(172222, '3.30.160.60-FF-002437', NULL, NULL, 28, NULL, NULL, 172222),
(172223, '2.10.50.10-FF-000119', NULL, 'Predicted protein', 58, NULL, NULL, 172223),
(172224, '1.10.10.10-FF-001642', NULL, 'Transcriptional regulator, BadM/Rrf2 family', 143, NULL, NULL, 172224),
(172225, '2.40.50.140-FF-001219', NULL, NULL, 71, NULL, NULL, 172225),
(172226, '1.20.5.170-FF-000275', NULL, 'Uncharacterized protein', 66, NULL, NULL, 172226),
(172227, '3.90.660.10-FF-000098', NULL, NULL, 103, NULL, NULL, 172227),
(172228, '3.20.10.10-FF-000030', NULL, 'Aminotransferase, class IV', 162, NULL, NULL, 172228),
(172229, '1.20.1110.10-FF-000079', NULL, 'Sodium/potassium-transporting ATPase subunit alpha', 262, NULL, NULL, 172229),
(172230, '3.40.250.10-FF-000157', NULL, 'LOC100124764 protein', 103, NULL, NULL, 172230),
(172231, '3.30.70.260-FF-000055', NULL, '(P)ppGpp synthetase', 78, NULL, NULL, 172231),
(172232, '2.60.40.10-FF-003972', NULL, NULL, 103, NULL, NULL, 172232),
(172233, '3.40.50.300-FF-007497', NULL, 'ATP-dependent DNA helicase', 223, NULL, NULL, 172233),
(172234, '2.130.10.130-FF-000012', NULL, 'Integrin alpha-IIb', 454, NULL, NULL, 172234),
(172235, '2.60.120.200-FF-000088', NULL, 'Contactin associated protein-like 2', 189, NULL, NULL, 172235),
(172236, '3.30.160.60-FF-000751', NULL, 'zinc finger protein 629 isoform X2', 28, NULL, NULL, 172236),
(172237, '3.40.1110.10-FF-000253', NULL, NULL, 131, NULL, NULL, 172237),
(172238, '2.60.120.260-FF-000004', NULL, 'Ephrin type-B receptor 2', 179, NULL, NULL, 172238),
(172239, '1.10.510.10-FF-003569', NULL, NULL, 221, NULL, NULL, 172239),
(172240, '3.10.20.90-FF-000088', NULL, 'polycomb group RING finger protein 5 isoform X1', 107, NULL, NULL, 172240),
(172241, '3.40.1170.10-FF-000026', NULL, 'DNA mismatch repair protein MutS 1', 108, NULL, NULL, 172241),
(172242, '2.60.120.920-FF-000062', NULL, 'Tripartite motif-containing protein 49', 174, NULL, NULL, 172242),
(172243, '3.30.1490.20-FF-000022', NULL, 'D-alanine--D-alanine ligase', 66, NULL, NULL, 172243),
(172244, '1.20.58.390-FF-000166', NULL, 'Uncharacterized protein', 70, NULL, NULL, 172244),
(172245, '2.40.10.10-FF-000082', NULL, 'Plasma kallikrein', 248, NULL, NULL, 172245),
(172246, '2.40.170.20-FF-000073', NULL, 'Probable TonB-dependent receptor', 484, NULL, NULL, 172246),
(172247, '2.60.40.10-FF-005765', NULL, NULL, 112, NULL, NULL, 172247),
(172248, '3.40.50.410-FF-000094', NULL, 'Voltage-dependent calcium channel subunit alpha-2/delta-3', 43, NULL, NULL, 172248),
(172249, '3.30.70.1230-FF-000015', NULL, 'Guanylate cyclase', 195, NULL, NULL, 172249),
(172250, '2.120.10.30-FF-000134', NULL, 'Low-density lipoprotein RecePtor related', 310, NULL, NULL, 172250),
(172251, '1.10.630.10-FF-000695', NULL, 'Uncharacterized protein', 142, NULL, NULL, 172251),
(172252, '2.40.50.140-FF-001152', NULL, NULL, 208, NULL, NULL, 172252),
(172253, '1.10.630.10-FF-000751', NULL, 'Uncharacterized protein', 65, NULL, NULL, 172253),
(172254, '3.30.497.10-FF-000102', NULL, 'Serpin peptidase inhibitor 4', 172, NULL, NULL, 172254),
(172255, '2.60.40.10-FF-001729', NULL, 'Uncharacterized protein, isoform B', 102, NULL, NULL, 172255),
(172256, '1.10.560.10-FF-000138', NULL, 'Chaperonin complex component, TCP-1 delta subunit, putative', 93, NULL, NULL, 172256),
(172257, '2.130.10.10-FF-000173', NULL, 'Cilia- and flagella-associated protein 52', 300, NULL, NULL, 172257),
(172258, '1.10.287.160-FF-000020', NULL, 'Serine/threonine-protein kinase N2', 77, NULL, NULL, 172258),
(172259, '3.40.630.10-FF-000231', NULL, 'Uncharacterized protein', 101, NULL, NULL, 172259),
(172260, '3.40.50.11500-FF-000018', NULL, 'DENN domain-containing protein 1A', 164, NULL, NULL, 172260),
(172261, '1.10.10.10-FF-001294', NULL, 'Protein CBR-ETS-9', 128, NULL, NULL, 172261),
(172262, '2.110.10.10-FF-000005', NULL, 'Stromelysin-3 preproprotein', 193, NULL, NULL, 172262),
(172263, '1.10.1760.10-FF-000001', NULL, 'Actin-related protein 2/3 complex subunit 3', 178, NULL, NULL, 172263);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(172264, '2.60.40.10-FF-004135', NULL, NULL, 90, NULL, NULL, 172264),
(172265, '3.60.21.10-FF-000222', NULL, 'Serine/threonine-protein phosphatase', 320, NULL, NULL, 172265),
(172266, '1.10.8.60-FF-000318', NULL, 'Peroxisome biosynthesis protein-like protein', 142, NULL, NULL, 172266),
(172267, '1.20.58.60-FF-000715', NULL, 'Spectrin, beta, non-erythrocytic 5', 280, NULL, NULL, 172267),
(172268, '1.10.510.10-FF-002108', NULL, NULL, 69, NULL, NULL, 172268),
(172269, '3.40.50.720-FF-001760', NULL, 'Zgc:110348', 151, NULL, NULL, 172269),
(172270, '1.10.10.1050-FF-000005', NULL, 'mRNA decapping complex subunit 2', 85, NULL, NULL, 172270),
(172271, '3.40.720.10-FF-000058', NULL, 'Phosphoethanolamine N-methyltransferase, putative (AFU_orthologue AFUA_6G04290)', 192, NULL, NULL, 172271),
(172272, '1.20.1500.20-FF-000005', NULL, NULL, 130, NULL, NULL, 172272),
(172273, '2.60.40.10-FF-005714', NULL, NULL, 44, NULL, NULL, 172273),
(172274, '3.40.50.2000-FF-000598', NULL, 'Glycosyl transferase', 176, NULL, NULL, 172274),
(172275, '3.40.50.300-FF-002707', NULL, 'ATLastiN (Endoplasmic reticulum GTPase) related', 320, NULL, NULL, 172275),
(172276, '3.10.20.90-FF-000206', NULL, 'Type VII secretion integral membrane protein EccD', 85, NULL, NULL, 172276),
(172277, '3.30.70.3250-FF-000014', NULL, NULL, 114, NULL, NULL, 172277),
(172278, '3.40.1110.10-FF-000197', NULL, 'Cation transport ATPase, E1-E2 family', 119, NULL, NULL, 172278),
(172279, '3.40.630.30-FF-000237', NULL, 'GNAT family acetyltransferase', 181, NULL, NULL, 172279),
(172280, '2.130.10.10-FF-002022', NULL, 'Uncharacterized protein', 191, NULL, NULL, 172280),
(172281, '3.40.33.10-FF-000115', NULL, 'Uncharacterized protein', 150, NULL, NULL, 172281),
(172282, '1.20.1110.10-FF-000135', NULL, NULL, 95, NULL, NULL, 172282),
(172283, '1.20.810.10-FF-000010', NULL, 'Cytochrome b', 430, NULL, NULL, 172283),
(172284, '1.25.10.10-FF-000131', NULL, 'Vacuolar protein 8', 156, NULL, NULL, 172284),
(172285, '2.40.30.10-FF-000240', NULL, 'predicted NADPH oxidase 2', 93, NULL, NULL, 172285),
(172286, '3.40.33.10-FF-000166', NULL, 'Uncharacterized protein', 110, NULL, NULL, 172286),
(172287, '3.40.1090.10-FF-000025', NULL, 'Patatin-like phospholipase domain containing 6', 119, NULL, NULL, 172287),
(172288, '1.20.1560.10-FF-000686', NULL, 'Uncharacterized protein', 346, NULL, NULL, 172288),
(172289, '1.20.900.10-FF-000129', NULL, 'Predicted protein', 67, NULL, NULL, 172289),
(172290, '3.30.300.10-FF-000023', NULL, 'GMP synthase (glutamine-hydrolyzing)', 90, NULL, NULL, 172290),
(172291, '3.30.505.10-FF-000212', NULL, NULL, 112, NULL, NULL, 172291),
(172292, '2.60.120.620-FF-000034', NULL, '2-oxoglutarate and iron-dependent oxygenase domain-containing 1', 255, NULL, NULL, 172292),
(172293, '3.30.310.40-FF-000010', NULL, 'AGAP001854-PA', 85, NULL, NULL, 172293),
(172294, '3.30.360.10-FF-000122', NULL, 'Uncharacterized protein', 165, NULL, NULL, 172294),
(172295, '1.20.1560.10-FF-000394', NULL, 'Cystic Fibrosis Transmembrane conductance regulator homolog', 340, NULL, NULL, 172295),
(172296, '2.30.30.140-FF-000329', NULL, 'Protein lin-61', 110, NULL, NULL, 172296),
(172297, '3.30.40.10-FF-000891', NULL, 'General transcription factor IIH subunit', 84, NULL, NULL, 172297),
(172298, '4.10.410.20-FF-000018', NULL, 'Uncharacterized protein', 51, NULL, NULL, 172298),
(172299, '1.20.1310.10-FF-000004', NULL, 'Cullin 4B', 104, NULL, NULL, 172299),
(172300, '2.40.160.60-FF-000005', NULL, 'Transporter, Ompp1/FadL/TodX family', 422, NULL, NULL, 172300),
(172301, '3.30.70.330-FF-001503', NULL, NULL, 92, NULL, NULL, 172301),
(172302, '3.90.1150.10-FF-000289', NULL, 'Serine-pyruvate aminotransferase (AgxT)', 121, NULL, NULL, 172302),
(172303, '3.20.20.140-FF-000337', NULL, 'Uncharacterized protein', 222, NULL, NULL, 172303),
(172304, '3.10.150.10-FF-000015', NULL, 'Proliferating cell nuclear antigen', 124, NULL, NULL, 172304),
(172305, '3.30.300.20-FF-000026', NULL, 'Ribosome-binding factor A', 103, NULL, NULL, 172305),
(172306, '3.70.10.10-FF-000095', NULL, 'DNA damage checkpoint protein 1', 154, NULL, NULL, 172306);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(172307, '1.25.10.10-FF-001715', NULL, 'Neurochondrin homolog', 232, NULL, NULL, 172307),
(172308, '1.20.1560.10-FF-000742', NULL, 'Predicted protein', 138, NULL, NULL, 172308),
(172309, '2.60.120.1000-FF-000007', NULL, 'Collagen type V alpha 3 chain', 226, NULL, NULL, 172309),
(172310, '1.10.10.60-FF-000162', NULL, 'trihelix transcription factor GT-1', 63, NULL, NULL, 172310),
(172311, '4.10.410.10-FF-000015', NULL, 'WAP four-disulfide core domain 6A', 58, NULL, NULL, 172311),
(172312, '2.40.30.10-FF-000532', NULL, 'Uncharacterized protein', 87, NULL, NULL, 172312),
(172313, '3.30.310.50-FF-000013', NULL, 'Phosphoglucosamine mutase', 72, NULL, NULL, 172313),
(172314, '3.30.420.10-FF-000706', NULL, NULL, 106, NULL, NULL, 172314),
(172315, '3.10.50.40-FF-000159', NULL, 'Peptidylprolyl isomerase', 116, NULL, NULL, 172315),
(172316, '1.20.1310.20-FF-000007', NULL, 'Erythrocyte-binding antigen 175', 176, NULL, NULL, 172316),
(172317, '1.10.8.10-FF-000146', NULL, 'Toll-interacting protein', 51, NULL, NULL, 172317),
(172318, '2.60.120.10-FF-000433', NULL, 'Crp/Fnr family transcriptional regulator', 126, NULL, NULL, 172318),
(172319, '3.40.50.150-FF-001409', NULL, NULL, 164, NULL, NULL, 172319),
(172320, '3.10.105.10-FF-000107', NULL, 'Putative binding protein HI_0213', 205, NULL, NULL, 172320),
(172321, '1.20.58.60-FF-000367', NULL, 'SMAll', 110, NULL, NULL, 172321),
(172322, '1.10.1420.10-FF-000015', NULL, 'DNA mismatch repair protein Msh2', 83, NULL, NULL, 172322),
(172323, '2.20.25.20-FF-000007', NULL, 'RBR-type E3 ubiquitin transferase', 51, NULL, NULL, 172323),
(172324, '3.90.1420.10-FF-000040', NULL, 'Uncharacterized protein', 153, NULL, NULL, 172324),
(172325, '3.40.50.1820-FF-001257', NULL, 'Uncharacterized protein', 311, NULL, NULL, 172325),
(172326, '2.20.25.10-FF-000004', NULL, 'DNA-directed RNA polymerase subunit', 69, NULL, NULL, 172326),
(172327, '3.30.200.20-FF-000878', NULL, 'Serine/threonine protein kinase', 85, NULL, NULL, 172327),
(172328, '3.40.140.10-FF-000261', NULL, 'Uncharacterized protein', 118, NULL, NULL, 172328),
(172329, '2.130.10.30-FF-000179', NULL, NULL, 237, NULL, NULL, 172329),
(172330, '3.40.50.1000-FF-000051', NULL, 'Phospholysine phosphohistidine inorganic pyrophosphate phosphatase', 105, NULL, NULL, 172330),
(172331, '4.10.400.10-FF-000357', NULL, 'Uncharacterized protein', 45, NULL, NULL, 172331),
(172332, '1.25.40.10-FF-005197', NULL, 'Uncharacterized protein', 215, NULL, NULL, 172332),
(172333, '1.20.1260.10-FF-000028', NULL, 'tRNA-(MS[2]IO[6]A)-hydroxylase', 203, NULL, NULL, 172333),
(172334, '3.80.10.10-FF-002949', NULL, 'Uncharacterized protein', 73, NULL, NULL, 172334),
(172335, '3.40.50.300-FF-004001', NULL, 'DEAD-box ATP-dependent RNA helicase 36', 248, NULL, NULL, 172335),
(172336, '3.40.50.2000-FF-000873', NULL, 'Predicted protein', 305, NULL, NULL, 172336),
(172337, '1.20.1280.50-FF-000232', NULL, 'F-box protein pof12', 88, NULL, NULL, 172337),
(172338, '3.30.379.10-FF-000002', NULL, 'Beta-hexosaminidase', 217, NULL, NULL, 172338),
(172339, '3.30.505.10-FF-000263', NULL, NULL, 75, NULL, NULL, 172339),
(172340, '3.10.100.10-FF-000411', NULL, NULL, 104, NULL, NULL, 172340),
(172341, '2.10.60.10-FF-000064', NULL, 'Serine/threonine-protein kinase receptor', 110, NULL, NULL, 172341),
(172342, '1.10.472.10-FF-000203', NULL, 'CyCliN K', 107, NULL, NULL, 172342),
(172343, '3.50.50.60-FF-001271', NULL, 'Uncharacterized protein', 76, NULL, NULL, 172343),
(172344, '3.30.420.10-FF-000358', NULL, NULL, 152, NULL, NULL, 172344),
(172345, '1.25.10.10-FF-002204', NULL, 'Uncharacterized protein', 437, NULL, NULL, 172345),
(172346, '3.50.50.60-FF-001451', NULL, 'Uncharacterized protein', 79, NULL, NULL, 172346),
(172347, '1.20.920.10-FF-000069', NULL, 'RSC complex subunit (RSC1), putative', 126, NULL, NULL, 172347),
(172348, '3.30.310.130-FF-000026', NULL, 'Uncharacterized protein', 51, NULL, NULL, 172348),
(172349, '1.10.260.100-FF-000005', NULL, 'Ubiquitin domain-containing protein DSK2b', 57, NULL, NULL, 172349),
(172350, '3.40.50.300-FF-006417', NULL, 'Uncharacterized protein', 130, NULL, NULL, 172350);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(172351, '1.10.510.10-FF-001771', NULL, 'Uncharacterized protein', 277, NULL, NULL, 172351),
(172352, '1.20.920.10-FF-000125', NULL, 'Chromatin structure remodeling complex subunit, putative', 111, NULL, NULL, 172352),
(172353, '2.60.40.10-FF-005147', NULL, NULL, 95, NULL, NULL, 172353),
(172354, '3.30.530.20-FF-000009', NULL, 'StAR related lipid transfer domain containing 13', 187, NULL, NULL, 172354),
(172355, '1.10.10.1100-FF-000004', NULL, '(2Fe-2S)-binding protein', 52, NULL, NULL, 172355),
(172356, '3.40.50.720-FF-001136', NULL, 'Alcohol dehydrogenase', 137, NULL, NULL, 172356),
(172357, '3.20.20.110-FF-000002', NULL, '2,3-diketo-5-methylthiopentyl-1-phosphate enolase', 293, NULL, NULL, 172357),
(172358, '4.10.860.120-FF-000009', NULL, 'DNA-directed RNA polymerase subunit', 123, NULL, NULL, 172358),
(172359, '1.10.8.60-FF-000195', NULL, 'AAA-type ATPase family protein', 76, NULL, NULL, 172359),
(172360, '2.130.10.10-FF-005804', NULL, 'Uncharacterized protein', 88, NULL, NULL, 172360),
(172361, '3.40.50.300-FF-005928', NULL, 'Uncharacterized protein', 250, NULL, NULL, 172361),
(172362, '3.40.50.150-FF-000375', NULL, 'SAM-dependent methyltransferase', 208, NULL, NULL, 172362),
(172363, '3.30.70.330-FF-000891', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 118, NULL, NULL, 172363),
(172364, '1.20.1070.10-FF-000761', NULL, '7 transmembrane receptor, putative', 154, NULL, NULL, 172364),
(172365, '3.40.50.2300-FF-001238', NULL, NULL, 233, NULL, NULL, 172365),
(172366, '3.40.50.2000-FF-001087', NULL, 'Protein CBG00513', 99, NULL, NULL, 172366),
(172367, '2.60.40.1730-FF-000063', NULL, NULL, 236, NULL, NULL, 172367),
(172368, '3.40.50.10130-FF-000017', NULL, 'Zip2p', 128, NULL, NULL, 172368),
(172369, '3.30.420.10-FF-000414', NULL, 'Uncharacterized protein', 334, NULL, NULL, 172369),
(172370, '1.10.750.20-FF-000004', NULL, 'Ankyrin repeat and SOCS box containing 7', 40, NULL, NULL, 172370),
(172371, '2.60.40.10-FF-005984', NULL, NULL, 95, NULL, NULL, 172371),
(172372, '3.90.810.10-FF-000037', NULL, NULL, 43, NULL, NULL, 172372),
(172373, '3.30.110.170-FF-000004', NULL, 'Putative lipoprotein LpqG', 88, NULL, NULL, 172373),
(172374, '3.20.20.120-FF-000005', NULL, 'Putative L-rhamnonate dehydratase', 247, NULL, NULL, 172374),
(172375, '1.10.880.10-FF-000005', NULL, 'Uncharacterized protein', 62, NULL, NULL, 172375),
(172376, '3.10.100.10-FF-000063', NULL, 'Lymphocyte antigen 75', 137, NULL, NULL, 172376),
(172377, '1.25.10.10-FF-001592', NULL, 'Uncharacterized protein', 158, NULL, NULL, 172377),
(172378, '2.60.40.10-FF-000425', NULL, 'Myosin light chain kinase', 99, NULL, NULL, 172378),
(172379, '3.80.10.10-FF-004462', NULL, 'Uncharacterized protein', 86, NULL, NULL, 172379),
(172380, '1.25.70.10-FF-000016', NULL, 'Mitochondrial transcription termination factor-like', 83, NULL, NULL, 172380),
(172381, '1.25.40.690-FF-000005', NULL, 'Related to Nucleoporin nup189 (SonB)', 92, NULL, NULL, 172381),
(172382, '1.10.750.10-FF-000001', NULL, 'von Hippel-Lindau disease tumor suppressor', 52, NULL, NULL, 172382),
(172383, '1.20.1560.10-FF-000809', NULL, 'Uncharacterized protein', 155, NULL, NULL, 172383),
(172384, '2.10.25.10-FF-001550', NULL, 'Uncharacterized protein', 48, NULL, NULL, 172384),
(172385, '3.30.70.2870-FF-000001', NULL, 'E4 11 kDa protein', 116, NULL, NULL, 172385),
(172386, '3.50.50.60-FF-000995', NULL, 'Predicted protein', 79, NULL, NULL, 172386),
(172387, '3.10.450.10-FF-000055', NULL, 'Si:ch211-262h13.5', 110, NULL, NULL, 172387),
(172388, '1.50.40.10-FF-000164', NULL, 'Dicarboxylate transporter', 277, NULL, NULL, 172388),
(172389, '3.40.50.11040-FF-000009', NULL, 'N-acetyltransferase-like protein', 266, NULL, NULL, 172389),
(172390, '2.130.10.10-FF-001533', NULL, 'UTP13p Nucleolar protein', 92, NULL, NULL, 172390),
(172391, '3.90.730.10-FF-000036', NULL, 'Uncharacterized protein', 220, NULL, NULL, 172391),
(172392, '3.40.50.1000-FF-000612', NULL, NULL, 104, NULL, NULL, 172392),
(172393, '3.40.50.150-FF-001735', NULL, NULL, 100, NULL, NULL, 172393),
(172394, '3.20.20.140-FF-000157', NULL, 'D-amino acid aminohydrolase', 220, NULL, NULL, 172394);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(172395, '3.40.50.10810-FF-000070', NULL, 'DNA helicase, putative', 312, NULL, NULL, 172395),
(172396, '1.10.287.370-FF-000083', NULL, 'Predicted protein', 117, NULL, NULL, 172396),
(172397, '3.40.30.10-FF-000305', NULL, 'SelT-like protein', 58, NULL, NULL, 172397),
(172398, '1.20.1260.10-FF-000079', NULL, 'Ferritin 2 light chain-like protein', 94, NULL, NULL, 172398),
(172399, '3.20.20.70-FF-000733', NULL, NULL, 89, NULL, NULL, 172399),
(172400, '3.50.50.60-FF-000776', NULL, 'Sulfide Quinone oxidoReDuctase', 50, NULL, NULL, 172400),
(172401, '1.10.510.10-FF-001496', NULL, 'Cell division cycle 7 homolog (S. cerevisiae)', 96, NULL, NULL, 172401),
(172402, '3.90.190.10-FF-000360', NULL, 'AGAP012901-PA', 172, NULL, NULL, 172402),
(172403, '3.40.50.1460-FF-000115', NULL, 'GPI-anchor transamidase', 49, NULL, NULL, 172403),
(172404, '3.90.1410.10-FF-000152', NULL, 'Chromosome 9, whole genome shotgun sequence', 153, NULL, NULL, 172404),
(172405, '2.60.40.10-FF-005366', NULL, NULL, 62, NULL, NULL, 172405),
(172406, '1.25.40.10-FF-003336', NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', 96, NULL, NULL, 172406),
(172407, '3.40.50.11030-FF-000006', NULL, 'Threonylcarbamoyl-AMP synthase', 110, NULL, NULL, 172407),
(172408, '3.30.60.20-FF-000041', NULL, 'Diacylglycerol kinase', 61, NULL, NULL, 172408),
(172409, '3.30.70.980-FF-000001', NULL, 'Probable transcriptional regulatory protein YebC', 76, NULL, NULL, 172409),
(172410, '2.30.29.30-FF-000608', NULL, 'Myosin 28B1, isoform B', 95, NULL, NULL, 172410),
(172411, '2.30.30.140-FF-000149', NULL, 'WGS project CABT00000000 data, contig 2.3', 87, NULL, NULL, 172411),
(172412, '3.40.50.150-FF-000723', NULL, 'Predicted protein', 224, NULL, NULL, 172412),
(172413, '1.20.1050.10-FF-000198', NULL, 'Glutathione S-transferase', 74, NULL, NULL, 172413),
(172414, '1.20.1280.50-FF-000013', NULL, 'F-box/LRR-repeat protein 20 isoform X1', 49, NULL, NULL, 172414),
(172415, '1.10.220.30-FF-000035', NULL, 'Flagellar motor switch protein FliG', 103, NULL, NULL, 172415),
(172416, '2.30.29.30-FF-001154', NULL, 'Uncharacterized protein', 110, NULL, NULL, 172416),
(172417, '1.20.1560.10-FF-000068', NULL, 'Transporter 1 ATP-binding cassette sub-family B', 323, NULL, NULL, 172417),
(172418, '1.10.1760.20-FF-000004', NULL, 'Riboflavin transporter', 184, NULL, NULL, 172418),
(172419, '2.60.40.60-FF-000069', NULL, 'Protocadherin-11 X-linked', 119, NULL, NULL, 172419),
(172420, '3.30.365.10-FF-000055', NULL, 'Uncharacterized protein', 131, NULL, NULL, 172420),
(172421, '3.30.160.60-FF-005984', NULL, NULL, 57, NULL, NULL, 172421),
(172422, '3.30.1330.60-FF-000005', NULL, 'Outer membrane porin F', 121, NULL, NULL, 172422),
(172423, '1.10.1410.20-FF-000012', NULL, 'Predicted protein', 72, NULL, NULL, 172423),
(172424, '1.10.533.10-FF-000222', NULL, 'NLR family, CARD domain-containing 3-like 1', 93, NULL, NULL, 172424),
(172425, '1.10.630.10-FF-000190', NULL, 'Cytochrome P450, family 2, subfamily K, polypeptide17', 473, NULL, NULL, 172425),
(172426, '3.40.50.12370-FF-000015', NULL, 'Uncharacterized protein', 161, NULL, NULL, 172426),
(172427, '3.30.60.30-FF-000044', NULL, 'Serine protease inhibitor dipetalogastin', 58, NULL, NULL, 172427),
(172428, '3.30.160.60-FF-002145', NULL, 'Zinc finger protein 354B', 30, NULL, NULL, 172428),
(172429, '3.30.420.40-FF-000052', NULL, 'Ectonucleoside triphosphate diphosphohydrolase 5', 129, NULL, NULL, 172429),
(172430, '3.40.50.300-FF-002146', NULL, 'ATP-dependent DNA helicase', 215, NULL, NULL, 172430),
(172431, '3.20.20.80-FF-000793', NULL, 'Probable glycosyl hydrolase', 172, NULL, NULL, 172431),
(172432, '1.25.40.10-FF-003741', NULL, 'Uncharacterized protein', 126, NULL, NULL, 172432),
(172433, '2.60.40.1180-FF-000145', NULL, 'Alpha-galactosidase', 94, NULL, NULL, 172433),
(172434, '1.20.58.2220-FF-000034', NULL, 'Diaphanous-related formin 2', 256, NULL, NULL, 172434),
(172435, '3.80.10.10-FF-000010', NULL, 'F-box/LRR-repeat protein 3 isoform X1', 352, NULL, NULL, 172435),
(172436, '2.130.10.10-FF-005462', NULL, 'Nucleolar protein, component of the U3 processome', 176, NULL, NULL, 172436);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(172437, '3.20.20.80-FF-000736', NULL, 'Uncharacterized protein', 86, NULL, NULL, 172437),
(172438, '1.10.10.2420-FF-000001', NULL, 'Glutamine--tRNA ligase cytoplasmic', 69, NULL, NULL, 172438),
(172439, '3.30.1460.50-FF-000006', NULL, 'Ubiquitin-like-conjugating enzyme ATG10', 167, NULL, NULL, 172439),
(172440, '1.25.40.10-FF-004230', NULL, 'Uncharacterized protein', 256, NULL, NULL, 172440),
(172441, '3.60.40.10-FF-000294', NULL, 'Uncharacterized protein', 225, NULL, NULL, 172441),
(172442, '3.30.70.330-FF-001228', NULL, 'RNA-binding protein RBP10, putative', 126, NULL, NULL, 172442),
(172443, '2.40.30.10-FF-000313', NULL, 'GD11452', 109, NULL, NULL, 172443),
(172444, '2.10.90.10-FF-000048', NULL, 'Glycoprotein hormone beta 5', 115, NULL, NULL, 172444),
(172445, '1.20.58.390-FF-000054', NULL, 'Gamma-aminobutyric acid (GABA-A) receptor, subunit theta', 123, NULL, NULL, 172445),
(172446, '1.20.5.110-FF-000066', NULL, 'Putative SNARE protein', 63, NULL, NULL, 172446),
(172447, '1.25.10.10-FF-001148', NULL, 'cilia- and flagella-associated protein 69 isoform X4', 545, NULL, NULL, 172447),
(172448, '2.80.10.50-FF-000182', NULL, 'Fascin', 133, NULL, NULL, 172448),
(172449, '3.40.50.1820-FF-001201', NULL, 'Carboxypeptidase', 97, NULL, NULL, 172449),
(172450, '1.25.10.10-FF-003278', NULL, 'Predicted protein', 194, NULL, NULL, 172450),
(172451, '3.30.1330.20-FF-000022', NULL, 'Tubulin alpha chain', 52, NULL, NULL, 172451),
(172452, '3.10.50.40-FF-000103', NULL, 'Peptidyl-prolyl cis-trans isomerase', 140, NULL, NULL, 172452),
(172453, '1.20.58.390-FF-000110', NULL, 'Uncharacterized protein', 146, NULL, NULL, 172453),
(172454, '1.20.1250.20-FF-001424', NULL, 'Uncharacterized protein', 169, NULL, NULL, 172454),
(172455, '2.60.40.60-FF-000176', NULL, 'FAT atypical cadherin 4', 100, NULL, NULL, 172455),
(172456, '2.60.40.10-FF-005591', NULL, NULL, 92, NULL, NULL, 172456),
(172457, '2.60.40.10-FF-004023', NULL, NULL, 98, NULL, NULL, 172457),
(172458, '3.40.50.1110-FF-000027', NULL, 'Esterase EstA', 320, NULL, NULL, 172458),
(172459, '3.30.200.20-FF-001991', NULL, NULL, 121, NULL, NULL, 172459),
(172460, '3.90.1410.10-FF-000101', NULL, 'CIA6', 63, NULL, NULL, 172460),
(172461, '1.25.40.860-FF-000028', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 130, NULL, NULL, 172461),
(172462, '3.30.930.10-FF-000228', NULL, 'phenylalanine--tRNA ligase beta subunit isoform X2', 97, NULL, NULL, 172462),
(172463, '3.90.1410.10-FF-000045', NULL, 'SET domain-containing protein 6', 196, NULL, NULL, 172463),
(172464, '1.25.50.20-FF-000063', NULL, 'Predicted protein', 191, NULL, NULL, 172464),
(172465, '1.20.1070.10-FF-001216', NULL, 'Protein CBR-SER-1', 245, NULL, NULL, 172465),
(172466, '2.60.40.1180-FF-000201', NULL, 'Alpha-glucosidase AlgA', 75, NULL, NULL, 172466),
(172467, '2.60.40.1180-FF-000151', NULL, 'Alpha glucosidase-like protein', 130, NULL, NULL, 172467),
(172468, '3.40.630.30-FF-000063', NULL, 'RNA cytidine acetyltransferase', 202, NULL, NULL, 172468),
(172469, '3.40.50.720-FF-002446', NULL, 'Ketopantoate reductase', 126, NULL, NULL, 172469),
(172470, '2.60.220.50-FF-000138', NULL, 'Uncharacterized protein', 153, NULL, NULL, 172470),
(172471, '2.60.40.10-FF-000751', NULL, 'Uncharacterized protein, isoform B', 99, NULL, NULL, 172471),
(172472, '2.60.40.2430-FF-000003', NULL, 'Agglutinin-like protein 7', 145, NULL, NULL, 172472),
(172473, '3.10.250.10-FF-000012', NULL, 'CD163 molecule like 1', 107, NULL, NULL, 172473),
(172474, '3.80.10.10-FF-003118', NULL, 'Predicted protein', 92, NULL, NULL, 172474),
(172475, '3.10.170.20-FF-000014', NULL, NULL, 78, NULL, NULL, 172475),
(172476, '1.20.1250.20-FF-000862', NULL, 'MFS general substrate transporter', 220, NULL, NULL, 172476),
(172477, '1.10.533.10-FF-000115', NULL, 'Uncharacterized protein', 110, NULL, NULL, 172477),
(172478, '1.10.150.50-FF-000198', NULL, 'Kinase, putative', 62, NULL, NULL, 172478),
(172479, '2.30.29.30-FF-000715', NULL, 'Predicted protein', 164, NULL, NULL, 172479),
(172480, '2.60.40.200-FF-000039', NULL, 'AGAP007026-PA', 123, NULL, NULL, 172480);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(172481, '3.40.30.10-FF-000362', NULL, 'Iodothyronine deiodinase', 72, NULL, NULL, 172481),
(172482, '3.20.20.70-FF-000407', NULL, '2-isopropylmalate synthase', 311, NULL, NULL, 172482),
(172483, '2.10.90.10-FF-000009', NULL, 'Vascular endothelial growth factor A', 109, NULL, NULL, 172483),
(172484, '2.60.120.10-FF-000720', NULL, 'Uncharacterized protein', 137, NULL, NULL, 172484),
(172485, '3.40.50.300-FF-000061', NULL, 'ATPase family, AAA domain-containing 2', 185, NULL, NULL, 172485),
(172486, '3.10.20.90-FF-000032', NULL, 'Fermitin family homolog 2 (Drosophila)', 78, NULL, NULL, 172486),
(172487, '2.60.40.2440-FF-000006', NULL, 'Uncharacterized protein, isoform A', 132, NULL, NULL, 172487),
(172488, '3.40.50.1100-FF-000024', NULL, 'Probable threonine synthase', 134, NULL, NULL, 172488),
(172489, '2.40.480.10-FF-000003', NULL, 'Dirigent protein', 137, NULL, NULL, 172489),
(172490, '2.30.180.10-FF-000067', NULL, 'Transforming growth factor-beta-induced protein ig-h3', 139, NULL, NULL, 172490),
(172491, '3.40.140.10-FF-000036', NULL, 'tRNA-specific adenosine deaminase 2', 171, NULL, NULL, 172491),
(172492, '3.40.50.410-FF-000324', NULL, '60 kDa SS-A/Ro ribonucleoprotein-like Protein', 203, NULL, NULL, 172492),
(172493, '3.40.50.1110-FF-000084', NULL, 'Uncharacterized protein', 220, NULL, NULL, 172493),
(172494, '3.30.40.10-FF-001621', NULL, 'RBR-type E3 ubiquitin transferase', 83, NULL, NULL, 172494),
(172495, '3.40.50.720-FF-000299', NULL, 'Bifunctional pinoresinol-lariciresinol reductase 1', 184, NULL, NULL, 172495),
(172496, '2.130.10.10-FF-005187', NULL, 'Proteasomal ATPase associated factor 1', 118, NULL, NULL, 172496),
(172497, '2.60.40.10-FF-000419', NULL, 'KDEL (Lys-Asp-Glu-Leu) containing 1', 105, NULL, NULL, 172497),
(172498, '3.80.10.10-FF-003500', NULL, 'Uncharacterized protein', 188, NULL, NULL, 172498),
(172499, '3.40.50.300-FF-004332', NULL, 'Rad51 recombinase D', 260, NULL, NULL, 172499),
(172500, '2.30.29.30-FF-001266', NULL, 'Uncharacterized protein', 102, NULL, NULL, 172500),
(172501, '3.80.10.10-FF-003450', NULL, 'Si:ch211-214j8.12', 246, NULL, NULL, 172501),
(172502, '3.40.50.1100-FF-000081', NULL, 'D-cysteine desulfhydrase 2 mitochondrial', 199, NULL, NULL, 172502),
(172503, '3.30.930.10-FF-000267', NULL, 'Threonine--tRNA ligase', 308, NULL, NULL, 172503),
(172504, '2.80.10.50-FF-000125', NULL, 'Predicted protein', 136, NULL, NULL, 172504),
(172505, '3.90.1230.10-FF-000003', NULL, NULL, 88, NULL, NULL, 172505),
(172506, '1.10.418.20-FF-000036', NULL, 'Predicted protein', 118, NULL, NULL, 172506),
(172507, '2.60.40.10-FF-005478', NULL, NULL, 101, NULL, NULL, 172507),
(172508, '1.10.287.110-FF-000319', NULL, 'Chaperone protein DNAJ, putative', 96, NULL, NULL, 172508),
(172509, '2.40.110.10-FF-000072', NULL, 'Acyl-Coenzyme A dehydrogenase family, member 12', 52, NULL, NULL, 172509),
(172510, '1.20.120.350-FF-000108', NULL, 'Sodium channel, voltage-gated, type VIII, alpha subunit b', 112, NULL, NULL, 172510),
(172511, '3.30.1460.50-FF-000012', NULL, 'WGS project CABT00000000 data, contig 2.1', 141, NULL, NULL, 172511),
(172512, '3.30.572.10-FF-000007', NULL, 'thymidylate synthase isoform X2', 291, NULL, NULL, 172512),
(172513, '1.10.287.690-FF-000004', NULL, 'DNA polymerase', 50, NULL, NULL, 172513),
(172514, '3.10.100.10-FF-000012', NULL, 'Attractin', 151, NULL, NULL, 172514),
(172515, '3.40.50.300-FF-007727', NULL, 'Predicted protein', 91, NULL, NULL, 172515),
(172516, '3.40.50.10190-FF-000007', NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase', 96, NULL, NULL, 172516),
(172517, '1.10.418.10-FF-000033', NULL, 'nesprin-1 isoform X1', 118, NULL, NULL, 172517),
(172518, '3.40.50.300-FF-002152', NULL, 'RAD51 isoform 2', 189, NULL, NULL, 172518),
(172519, '3.40.50.720-FF-001193', NULL, 'Fatty acyl-CoA reductase', 336, NULL, NULL, 172519),
(172520, '3.80.10.10-FF-001027', NULL, 'Uncharacterized protein', 218, NULL, NULL, 172520),
(172521, '1.10.357.20-FF-000012', NULL, 'Solute carrier family 41', 187, NULL, NULL, 172521),
(172522, '3.40.50.10240-FF-000045', NULL, 'Thiamine pyrophosphokinase', 219, NULL, NULL, 172522);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(172523, '1.10.510.10-FF-002260', NULL, NULL, 218, NULL, NULL, 172523),
(172524, '2.30.33.40-FF-000014', NULL, '10 kDa heat shock protein', 95, NULL, NULL, 172524),
(172525, '3.20.20.140-FF-000163', NULL, 'Dihydroorotase', 335, NULL, NULL, 172525),
(172526, '3.20.20.80-FF-000742', NULL, 'Uncharacterized protein', 77, NULL, NULL, 172526),
(172527, '1.10.1200.10-FF-000145', NULL, 'Putative peptide synthetase', 84, NULL, NULL, 172527),
(172528, '3.30.470.20-FF-000246', NULL, 'Glutathione synthetase', 51, NULL, NULL, 172528),
(172529, '1.25.10.10-FF-003391', NULL, 'Uncharacterized protein', 136, NULL, NULL, 172529),
(172530, '2.130.10.10-FF-001185', NULL, 'WD_domain', 100, NULL, NULL, 172530),
(172531, '1.25.40.10-FF-003960', NULL, 'Uncharacterized protein', 252, NULL, NULL, 172531),
(172532, '4.10.280.10-FF-000184', NULL, 'Uncharacterized protein', 92, NULL, NULL, 172532),
(172533, '3.40.50.10170-FF-000001', NULL, 'DegV domain-containing protein Rv2417c', 144, NULL, NULL, 172533),
(172534, '3.30.70.330-FF-001560', NULL, 'RNA Binding Motif protein homolog', 103, NULL, NULL, 172534),
(172535, '3.40.50.10180-FF-000004', NULL, 'Glycerate 2-kinase', 225, NULL, NULL, 172535),
(172536, '3.20.80.10-FF-000028', NULL, 'Predicted protein', 187, NULL, NULL, 172536),
(172537, '3.40.605.10-FF-000105', NULL, 'Uncharacterized protein', 108, NULL, NULL, 172537),
(172538, '3.30.70.1020-FF-000014', NULL, NULL, 96, NULL, NULL, 172538),
(172539, '1.10.455.10-FF-000006', NULL, '37S ribosomal protein S7, mitochondrial', 148, NULL, NULL, 172539),
(172540, '2.60.40.10-FF-003348', NULL, 'Transglutaminase 1', 167, NULL, NULL, 172540),
(172541, '3.50.4.10-FF-000015', NULL, 'No-mechanoreceptor potential A long isoform', 79, NULL, NULL, 172541),
(172542, '2.30.29.30-FF-000659', NULL, 'Rhotekin 2', 113, NULL, NULL, 172542),
(172543, '1.25.40.690-FF-000011', NULL, 'Nuclear pore complex protein Nup98-Nup96', 94, NULL, NULL, 172543),
(172544, '3.30.2320.80-FF-000011', NULL, 'Hydrogenase maturation factor HypA', 122, NULL, NULL, 172544),
(172545, '2.30.180.10-FF-000123', NULL, NULL, 157, NULL, NULL, 172545),
(172546, '1.20.1530.20-FF-000052', NULL, 'Uncharacterized protein', 318, NULL, NULL, 172546),
(172547, '3.40.1390.20-FF-000017', NULL, 'Manganese-dependent inorganic pyrophosphatase, putative', 104, NULL, NULL, 172547),
(172548, '2.60.40.790-FF-000002', NULL, 'Small heat shock protein IbpA', 105, NULL, NULL, 172548),
(172549, '2.40.10.10-FF-000312', NULL, 'Coagulation factor precursor, putative', 210, NULL, NULL, 172549),
(172550, '2.60.120.10-FF-000607', NULL, 'Mannose-6-phosphate isomerase', 178, NULL, NULL, 172550),
(172551, '3.40.50.410-FF-000268', NULL, 'Uncharacterized protein', 265, NULL, NULL, 172551),
(172552, '3.40.50.300-FF-006423', NULL, 'Uncharacterized protein', 129, NULL, NULL, 172552),
(172553, '2.60.40.150-FF-000333', NULL, 'Protein Kinase N (PKN) homolog', 104, NULL, NULL, 172553),
(172554, '2.30.180.10-FF-000180', NULL, NULL, 132, NULL, NULL, 172554),
(172555, '3.50.50.60-FF-001501', NULL, 'Uncharacterized protein', 31, NULL, NULL, 172555),
(172556, '2.40.50.140-FF-000988', NULL, NULL, 64, NULL, NULL, 172556),
(172557, '1.20.1560.10-FF-000517', NULL, 'ATP-binding cassette transporter, subfamily C, member 5, group MRP protein PpABCC5', 319, NULL, NULL, 172557),
(172558, '1.25.40.10-FF-005247', NULL, 'PIKK family atypical protein kinase', 165, NULL, NULL, 172558),
(172559, '2.60.40.10-FF-005439', NULL, NULL, 121, NULL, NULL, 172559),
(172560, '3.20.20.70-FF-000464', NULL, 'Multifunctional fusion protein', 217, NULL, NULL, 172560),
(172561, '3.10.105.10-FF-000052', NULL, 'ABC transporter substrate-binding protein', 213, NULL, NULL, 172561),
(172562, '3.40.1500.10-FF-000013', NULL, 'Oxygen-dependent coproporphyrinogen-III oxidase', 300, NULL, NULL, 172562),
(172563, '3.20.20.80-FF-000467', NULL, 'Beta-galactosidase', 371, NULL, NULL, 172563),
(172564, '1.25.40.10-FF-002431', NULL, 'Pentatricopeptide repeat-containing protein At1g56690, mitochondrial', 81, NULL, NULL, 172564),
(172565, '1.10.132.60-FF-000030', NULL, 'Predicted protein', 178, NULL, NULL, 172565);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(172566, '1.10.510.10-FF-002221', NULL, NULL, 219, NULL, NULL, 172566),
(172567, '3.40.50.720-FF-001086', NULL, 'Thiamin biosynthesis protein (ThiF)', 246, NULL, NULL, 172567),
(172568, '1.10.510.10-FF-002041', NULL, 'Uncharacterized protein', 316, NULL, NULL, 172568),
(172569, '3.30.930.10-FF-000380', NULL, 'Threonyl-tRNA synthetase-like 2', 33, NULL, NULL, 172569),
(172570, '1.50.10.10-FF-000123', NULL, 'alpha-1,2-Mannosidase', 344, NULL, NULL, 172570),
(172571, '2.60.40.420-FF-000049', NULL, 'Laccase', 189, NULL, NULL, 172571),
(172572, '2.40.160.20-FF-000022', NULL, 'Accessory colonization factor AcfA', 200, NULL, NULL, 172572),
(172573, '3.30.559.30-FF-000101', NULL, 'Hydroxamate-type ferrichrome siderophore peptide synthetase', 246, NULL, NULL, 172573),
(172574, '2.40.180.10-FF-000020', NULL, 'Catalase-related peroxidase', 207, NULL, NULL, 172574),
(172575, '3.30.479.20-FF-000058', NULL, 'Elongation factor Ts, mitochondrial', 122, NULL, NULL, 172575),
(172576, '3.40.50.300-FF-001477', NULL, 'Zinc finger helicase family protein', 199, NULL, NULL, 172576),
(172577, '3.80.10.10-FF-002663', NULL, 'Os01g0742400 protein', 197, NULL, NULL, 172577),
(172578, '3.80.10.10-FF-002775', NULL, 'Si:dkey-23k10.2', 241, NULL, NULL, 172578),
(172579, '3.90.470.20-FF-000002', NULL, 'Holo-(Acyl carrier protein) synthase 2', 38, NULL, NULL, 172579),
(172580, '1.10.630.10-FF-000638', NULL, 'Cytochrome P450', 221, NULL, NULL, 172580),
(172581, '3.90.290.10-FF-000013', NULL, 'Follistatin a', 96, NULL, NULL, 172581),
(172582, '3.40.50.300-FF-005693', NULL, 'Selenocysteine-specific translation elongation factor', 180, NULL, NULL, 172582),
(172583, '3.30.160.60-FF-005815', NULL, NULL, 49, NULL, NULL, 172583),
(172584, '2.70.170.10-FF-000041', NULL, 'Acetylcholine receptor subunit gamma', 99, NULL, NULL, 172584),
(172585, '3.90.370.10-FF-000014', NULL, 'Uncharacterized protein', 91, NULL, NULL, 172585),
(172586, '3.30.70.1230-FF-000072', NULL, 'Adenylate/guanylate cyclase domain-containing protein', 180, NULL, NULL, 172586),
(172587, '1.10.510.10-FF-003570', NULL, NULL, 220, NULL, NULL, 172587),
(172588, '1.25.40.180-FF-000089', NULL, 'Nuclear cap-binding protein complex subunit 1', 277, NULL, NULL, 172588),
(172589, '1.20.1070.10-FF-000873', NULL, 'Uncharacterized protein', 152, NULL, NULL, 172589),
(172590, '1.10.10.1540-FF-000001', NULL, 'Actin-binding Rho-activating protein a', 84, NULL, NULL, 172590),
(172591, '2.30.29.30-FF-000991', NULL, 'Vacuolar protein-sorting-associated protein 36', 138, NULL, NULL, 172591),
(172592, '3.40.50.300-FF-002202', NULL, 'P-loop containing nucleoside triphosphate hydrolase', 218, NULL, NULL, 172592),
(172593, '1.20.1250.20-FF-001643', NULL, 'Uncharacterized protein', 484, NULL, NULL, 172593),
(172594, '3.40.50.300-FF-004057', NULL, 'Os11g0649100 protein', 196, NULL, NULL, 172594),
(172595, '2.80.10.50-FF-000069', NULL, 'O-mannosyl-transferase', 203, NULL, NULL, 172595),
(172596, '3.30.70.890-FF-000069', NULL, 'Mevalonate kinase', 120, NULL, NULL, 172596),
(172597, '2.70.170.10-FF-000153', NULL, 'Uncharacterized protein', 215, NULL, NULL, 172597),
(172598, '3.80.10.10-FF-001320', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 165, NULL, NULL, 172598),
(172599, '1.25.10.10-FF-001480', NULL, 'RING-type E3 ubiquitin transferase', 277, NULL, NULL, 172599),
(172600, '3.30.40.10-FF-001402', NULL, 'RBR-type E3 ubiquitin transferase', 88, NULL, NULL, 172600),
(172601, '1.10.510.10-FF-004132', NULL, NULL, 87, NULL, NULL, 172601),
(172602, '3.30.160.60-FF-000021', NULL, 'Basic krueppel-like factor 3', 37, NULL, NULL, 172602),
(172603, '2.30.29.30-FF-000934', NULL, 'UDP-sugar-dependent glycosyltransferase 52', 112, NULL, NULL, 172603),
(172604, '3.50.50.60-FF-001445', NULL, 'Uncharacterized protein', 94, NULL, NULL, 172604),
(172605, '3.40.50.300-FF-005636', NULL, 'Sca1 complex protein phr', 184, NULL, NULL, 172605),
(172606, '3.40.80.10-FF-000022', NULL, 'AGAP005552-PA', 171, NULL, NULL, 172606),
(172607, '3.30.9.10-FF-000150', NULL, 'Predicted protein', 165, NULL, NULL, 172607);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(172608, '3.40.220.10-FF-000037', NULL, 'Putative leucine aminopeptidase 1', 194, NULL, NULL, 172608),
(172609, '2.20.70.10-FF-000024', NULL, 'Rho GTPase activating protein 12', 71, NULL, NULL, 172609),
(172610, '3.20.20.70-FF-000683', NULL, NULL, 194, NULL, NULL, 172610),
(172611, '1.10.510.10-FF-003238', NULL, NULL, 120, NULL, NULL, 172611),
(172612, '2.80.10.50-FF-000013', NULL, 'Interleukin-1', 150, NULL, NULL, 172612),
(172613, '3.40.30.10-FF-000255', NULL, 'Grx4 family monothiol glutaredoxin', 96, NULL, NULL, 172613),
(172614, '3.10.490.10-FF-000052', NULL, 'Protein CBG21104', 74, NULL, NULL, 172614),
(172615, '2.40.460.10-FF-000002', NULL, 'Biotin carboxylase subunit of acetyl CoA carboxylase', 67, NULL, NULL, 172615),
(172616, '2.60.120.10-FF-000377', NULL, 'Agc protein kinase', 129, NULL, NULL, 172616),
(172617, '1.20.1610.10-FF-000005', NULL, 'Alpha-1,2-mannosidase, family protein', 165, NULL, NULL, 172617),
(172618, '3.10.50.40-FF-000160', NULL, 'Peptidylprolyl isomerase', 89, NULL, NULL, 172618),
(172619, '2.40.10.10-FF-000531', NULL, NULL, 98, NULL, NULL, 172619),
(172620, '1.10.530.10-FF-000018', NULL, 'Lysozyme g-like 2', 176, NULL, NULL, 172620),
(172621, '3.40.50.1110-FF-000140', NULL, 'Uncharacterized protein', 197, NULL, NULL, 172621),
(172622, '3.30.420.40-FF-000013', NULL, 'Actin-related protein 2', 120, NULL, NULL, 172622),
(172623, '3.20.20.80-FF-000686', NULL, 'Endo-alpha-mannosidase, putative', 315, NULL, NULL, 172623),
(172624, '3.40.50.300-FF-004276', NULL, 'Uncharacterized protein', 168, NULL, NULL, 172624),
(172625, '1.20.1270.90-FF-000002', NULL, 'Zinc metalloprotease ZmpB', 66, NULL, NULL, 172625),
(172626, '1.25.10.10-FF-002896', NULL, 'Chromosome 1, whole genome shotgun sequence', 139, NULL, NULL, 172626),
(172627, '1.10.730.10-FF-000062', NULL, 'Putative methionyl-tRNA synthetase', 176, NULL, NULL, 172627),
(172628, '3.90.850.10-FF-000040', NULL, 'Mitochondrion protein, putative', 293, NULL, NULL, 172628),
(172629, '2.40.155.10-FF-000001', NULL, 'Nidogen 1', 265, NULL, NULL, 172629),
(172630, '1.20.1630.10-FF-000006', NULL, 'Uncharacterized protein', 275, NULL, NULL, 172630),
(172631, '1.10.555.10-FF-000059', NULL, 'rho GTPase-activating protein 30 isoform X2', 71, NULL, NULL, 172631),
(172632, '3.40.1170.60-FF-000018', NULL, 'DNA repair protein REV1', 54, NULL, NULL, 172632),
(172633, '3.30.70.890-FF-000013', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 143, NULL, NULL, 172633),
(172634, '2.20.25.10-FF-000116', NULL, 'DNA-directed RNA polymerase subunit', 52, NULL, NULL, 172634),
(172635, '1.10.530.10-FF-000075', NULL, 'Uncharacterized protein', 29, NULL, NULL, 172635),
(172636, '2.40.50.140-FF-000140', NULL, 'Transcription termination/antitermination protein NusA', 64, NULL, NULL, 172636),
(172637, '3.40.1370.10-FF-000013', NULL, 'Putative mitochondrial ribosomal protein L4', 230, NULL, NULL, 172637),
(172638, '2.10.25.10-FF-000089', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', 38, NULL, NULL, 172638),
(172639, '1.10.1420.10-FF-000127', NULL, 'Predicted protein', 61, NULL, NULL, 172639),
(172640, '2.10.90.10-FF-000161', NULL, 'Uncharacterized protein', 69, NULL, NULL, 172640),
(172641, '3.30.1120.30-FF-000037', NULL, 'Serine/threonine-protein kinase PLK', 88, NULL, NULL, 172641),
(172642, '2.10.70.10-FF-000272', NULL, 'Uncharacterized protein', 64, NULL, NULL, 172642),
(172643, '2.70.150.10-FF-000152', NULL, 'P-type phospholipid transporter', 199, NULL, NULL, 172643),
(172644, '3.50.50.60-FF-001158', NULL, 'Uncharacterized protein', 52, NULL, NULL, 172644),
(172645, '3.30.1120.10-FF-000031', NULL, 'N-acetylgalactosamine 6-sulfatase (GALNS)', 71, NULL, NULL, 172645),
(172646, '1.20.58.830-FF-000051', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 124, NULL, NULL, 172646),
(172647, '1.10.30.10-FF-000171', NULL, 'HMG box-containing protein C10F6.08c', 109, NULL, NULL, 172647),
(172648, '1.10.225.10-FF-000017', NULL, 'SaPosin-like Protein family', 84, NULL, NULL, 172648),
(172649, '1.10.150.300-FF-000001', NULL, 'Ribosome-binding ATPase YchF', 90, NULL, NULL, 172649);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(172650, '2.70.160.11-FF-000047', NULL, 'Arginine methyltransferase 6', 174, NULL, NULL, 172650),
(172651, '3.40.50.2300-FF-001418', NULL, NULL, 45, NULL, NULL, 172651),
(172652, '2.110.10.10-FF-000011', NULL, 'Matrix metalloproteinase-9', 195, NULL, NULL, 172652),
(172653, '3.30.70.890-FF-000070', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 117, NULL, NULL, 172653),
(172654, '1.20.58.530-FF-000023', NULL, 'Myosin heavy chain subunit', 207, NULL, NULL, 172654),
(172655, '1.10.150.310-FF-000004', NULL, 'Ribosomal protein S1, RNA binding domain protein', 96, NULL, NULL, 172655),
(172656, '1.20.1250.20-FF-002099', NULL, 'Uncharacterized protein', 243, NULL, NULL, 172656),
(172657, '3.40.1090.10-FF-000031', NULL, 'Patatin', 399, NULL, NULL, 172657),
(172658, '3.30.160.60-FF-002106', NULL, 'GD13139', 29, NULL, NULL, 172658),
(172659, '1.10.8.270-FF-000161', NULL, 'Uncharacterized protein', 101, NULL, NULL, 172659),
(172660, '3.20.20.190-FF-000094', NULL, NULL, 85, NULL, NULL, 172660),
(172661, '1.25.10.10-FF-000462', NULL, 'Splicing factor 3B subunit 1', 184, NULL, NULL, 172661),
(172662, '2.70.98.30-FF-000002', NULL, 'Alpha-mannosidase', 282, NULL, NULL, 172662),
(172663, '1.20.920.50-FF-000002', NULL, 'Salivary androgen-binding protein beta subunit', 98, NULL, NULL, 172663),
(172664, '3.40.50.1100-FF-000204', NULL, 'Cbs-1', 116, NULL, NULL, 172664),
(172665, '3.40.309.10-FF-000001', NULL, 'Mitochondrial aldehyde dehydrogenase 2', 190, NULL, NULL, 172665),
(172666, '3.30.230.80-FF-000004', NULL, 'Heat shock protein 75 kDa', 169, NULL, NULL, 172666),
(172667, '3.40.1170.10-FF-000032', NULL, 'DNA mismatch repair protein MutS 2', 122, NULL, NULL, 172667),
(172668, '2.40.30.10-FF-000201', NULL, 'Oxidoreductase', 93, NULL, NULL, 172668),
(172669, '4.10.60.10-FF-000042', NULL, 'Transcription or splicing factor-like protein', 61, NULL, NULL, 172669),
(172670, '2.60.40.10-FF-003909', NULL, NULL, 109, NULL, NULL, 172670),
(172671, '2.40.50.140-FF-000882', NULL, NULL, 89, NULL, NULL, 172671),
(172672, '1.10.540.10-FF-000137', NULL, 'Medium-chain acyl-CoA dehydrogenase, putative', 64, NULL, NULL, 172672),
(172673, '1.20.5.110-FF-000246', NULL, 'Qa-SNARE protein, Ufe1/Syntaxin 18 family', 100, NULL, NULL, 172673),
(172674, '2.60.40.10-FF-002044', NULL, 'Mesocentin', 100, NULL, NULL, 172674),
(172675, '2.30.40.10-FF-000168', NULL, 'Aminodeoxyfutalosine deaminase', 62, NULL, NULL, 172675),
(172676, '1.10.8.50-FF-000023', NULL, 'Type 2 DNA topoisomerase 6 subunit B', 70, NULL, NULL, 172676),
(172677, '3.40.50.2020-FF-000025', NULL, 'Uridine monophosphate synthetase', 207, NULL, NULL, 172677),
(172678, '3.50.50.60-FF-000141', NULL, 'Glutathione reductase', 122, NULL, NULL, 172678),
(172679, '2.60.40.60-FF-000070', NULL, 'protocadherin-15 isoform X1', 105, NULL, NULL, 172679),
(172680, '1.10.506.10-FF-000081', NULL, 'Uncharacterized protein', 425, NULL, NULL, 172680),
(172681, '1.25.40.10-FF-001537', NULL, 'Pentatricopeptide repeat-containing protein At2g37310', 84, NULL, NULL, 172681),
(172682, '1.20.120.980-FF-000011', NULL, 'Prolyl Carboxy Peptidase like', 156, NULL, NULL, 172682),
(172683, '2.60.40.10-FF-003567', NULL, 'CD8 alpha antigen', 114, NULL, NULL, 172683),
(172684, '3.40.1190.10-FF-000027', NULL, 'Folylpolyglutamate synthase', 302, NULL, NULL, 172684),
(172685, '3.30.1330.30-FF-000137', NULL, 'Uncharacterized protein', 72, NULL, NULL, 172685),
(172686, '1.25.40.10-FF-000014', NULL, 'SMG7 nonsense mediated mRNA decay factor', 204, NULL, NULL, 172686),
(172687, '3.40.50.10330-FF-000072', NULL, 'NAD kinase', 104, NULL, NULL, 172687),
(172688, '1.10.1520.10-FF-000017', NULL, 'Ribonuclease 3', 139, NULL, NULL, 172688),
(172689, '1.10.150.240-FF-000011', NULL, 'Bifunctional epoxide hydrolase 2', 80, NULL, NULL, 172689),
(172690, '2.130.10.10-FF-003950', NULL, 'Chromosome 1, whole genome shotgun sequence', 246, NULL, NULL, 172690),
(172691, '1.10.8.60-FF-000026', NULL, 'vesicle-fusing ATPase isoform X1', 90, NULL, NULL, 172691),
(172692, '3.80.30.20-FF-000014', NULL, 'RNA modification enzyme, MiaB family', 236, NULL, NULL, 172692);
INSERT INTO "PUBLIC"."MODEL" VALUES
(172693, '1.25.40.20-FF-000017', NULL, 'KN motif and ankyrin repeat domain-containing protein 1', 255, NULL, NULL, 172693),
(172694, '1.20.1270.60-FF-000173', NULL, 'Uncharacterized protein', 116, NULL, NULL, 172694),
(172695, '2.60.40.10-FF-001768', NULL, 'Interleukin-21 receptor', 120, NULL, NULL, 172695),
(172696, '1.10.3210.10-FF-000090', NULL, 'HD family hydrolase', 167, NULL, NULL, 172696),
(172697, '3.30.110.110-FF-000014', NULL, 'DNA repair protein (Mre11)', 103, NULL, NULL, 172697),
(172698, '1.10.8.870-FF-000026', NULL, 'Glycerol-3-phosphate dehydrogenase', 70, NULL, NULL, 172698),
(172699, '3.40.50.2300-FF-001531', NULL, NULL, 73, NULL, NULL, 172699),
(172700, '3.90.79.10-FF-000134', NULL, 'Nudix hydrolase-like protein', 218, NULL, NULL, 172700),
(172701, '1.10.238.10-FF-000322', NULL, 'Probable calcium-binding protein CML17', 85, NULL, NULL, 172701),
(172702, '1.10.10.10-FF-001586', NULL, 'SAM-dependent methyltransferase', 111, NULL, NULL, 172702),
(172703, '2.170.150.40-FF-000002', NULL, 'DUF427 domain-containing protein', 114, NULL, NULL, 172703),
(172704, '3.40.960.10-FF-000003', NULL, 'RAP domain-containing protein, chloroplastic', 100, NULL, NULL, 172704),
(172705, '1.10.720.30-FF-000062', NULL, 'DNA-binding protein VF_0530', 60, NULL, NULL, 172705),
(172706, '4.10.400.10-FF-000065', NULL, 'Transmembrane protease serine 7', 42, NULL, NULL, 172706),
(172707, '1.10.287.1480-FF-000006', NULL, 'Uncharacterized protein', 60, NULL, NULL, 172707),
(172708, '2.60.40.10-FF-003966', NULL, NULL, 103, NULL, NULL, 172708),
(172709, '2.40.150.20-FF-000015', NULL, '60S ribosomal protein L23, putative', 140, NULL, NULL, 172709),
(172710, '1.25.40.20-FF-001597', NULL, 'Uncharacterized protein', 113, NULL, NULL, 172710),
(172711, '3.30.1390.20-FF-000020', NULL, 'GD23812', 97, NULL, NULL, 172711),
(172712, '2.10.25.10-FF-001106', NULL, 'Uncharacterized protein', 45, NULL, NULL, 172712),
(172713, '1.10.238.10-FF-000266', NULL, 'TPPP family protein', 98, NULL, NULL, 172713),
(172714, '1.10.10.60-FF-000212', NULL, 'Zinc fingers and homeoboxes protein 3', 88, NULL, NULL, 172714),
(172715, '3.40.50.620-FF-000617', NULL, 'Bifunctional NMN adenylyltransferase/Nudix hydrolase', 194, NULL, NULL, 172715),
(172716, '3.40.50.10810-FF-000120', NULL, 'SNF2 family N-terminal domain/Helicase conserved C-terminal domain containing protein, putative', 354, NULL, NULL, 172716),
(172717, '3.40.50.150-FF-000611', NULL, 'Uncharacterized protein', 224, NULL, NULL, 172717),
(172718, '1.10.506.10-FF-000024', NULL, 'Plexin D1', 238, NULL, NULL, 172718),
(172719, '2.30.30.140-FF-000037', NULL, 'Histone-lysine N-methyltransferase', 67, NULL, NULL, 172719),
(172720, '3.40.1190.20-FF-000087', NULL, 'Pyridoxal kinase', 192, NULL, NULL, 172720),
(172721, '1.10.287.1490-FF-000009', NULL, 'Golgin subfamily A member 5', 181, NULL, NULL, 172721),
(172722, '1.10.3210.10-FF-000033', NULL, 'GTP pyrophosphokinase', 208, NULL, NULL, 172722),
(172723, '3.40.50.10880-FF-000006', NULL, 'DUF89 domain-containing protein', 141, NULL, NULL, 172723),
(172724, '2.40.128.20-FF-000037', NULL, 'Chromophore lyase CpcS/CpeS', 185, NULL, NULL, 172724),
(172725, '1.20.1250.20-FF-000643', NULL, 'Sucrose transporter, putative', 221, NULL, NULL, 172725),
(172726, '2.130.10.10-FF-003219', NULL, 'Probable cleavage and polyadenylation specificity factor subunit 1', 316, NULL, NULL, 172726),
(172727, '3.30.160.60-FF-005872', NULL, NULL, 47, NULL, NULL, 172727),
(172728, '1.10.10.830-FF-000012', NULL, 'Isoleucine--tRNA ligase, mitochondrial', 58, NULL, NULL, 172728),
(172729, '1.20.120.230-FF-000022', NULL, 'Catenin alpha like 1', 187, NULL, NULL, 172729),
(172730, '1.10.575.10-FF-000004', NULL, 'Nuclease S1', 267, NULL, NULL, 172730),
(172731, '3.30.70.2390-FF-000003', NULL, 'Tuberculin related peptide', 90, NULL, NULL, 172731),
(172732, '3.30.420.10-FF-000745', NULL, NULL, 103, NULL, NULL, 172732),
(172733, '3.40.50.10610-FF-000009', NULL, 'Transcriptional regulator', 109, NULL, NULL, 172733),
(172734, '1.20.1460.10-FF-000009', NULL, 'V-type proton ATPase subunit C', 61, NULL, NULL, 172734);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(172735, '3.30.420.10-FF-000689', NULL, NULL, 128, NULL, NULL, 172735),
(172736, '1.25.40.10-FF-001594', NULL, 'Hypothetical_protein_-_conserved', 259, NULL, NULL, 172736),
(172737, '1.20.120.350-FF-000165', NULL, NULL, 154, NULL, NULL, 172737),
(172738, '3.40.1350.60-FF-000004', NULL, 'Sugar fermentation stimulation protein homolog', 150, NULL, NULL, 172738),
(172739, '3.40.50.300-FF-002258', NULL, 'ZO-1 (Zonula Occludens tight junctional protein) Ortholog', 162, NULL, NULL, 172739),
(172740, '1.20.5.110-FF-000302', NULL, 'Uncharacterized protein', 65, NULL, NULL, 172740),
(172741, '3.80.10.10-FF-001084', NULL, 'Predicted protein', 125, NULL, NULL, 172741),
(172742, '3.90.132.10-FF-000017', NULL, 'Uncharacterized protein', 116, NULL, NULL, 172742),
(172743, '2.130.10.10-FF-000223', NULL, 'semaphorin-7A isoform X1', 435, NULL, NULL, 172743),
(172744, '3.40.50.1000-FF-000382', NULL, 'Putative proton motive ATPase', 173, NULL, NULL, 172744),
(172745, '3.40.630.30-FF-000624', NULL, 'Uncharacterized protein', 183, NULL, NULL, 172745),
(172746, '2.60.40.60-FF-000412', NULL, 'Uncharacterized protein', 114, NULL, NULL, 172746),
(172747, '2.130.10.10-FF-000280', NULL, 'Wd40 repeat-containing protein smu1', 87, NULL, NULL, 172747),
(172748, '1.20.58.60-FF-000659', NULL, 'Uncharacterized protein', 302, NULL, NULL, 172748),
(172749, '3.40.1190.20-FF-000143', NULL, 'Putative pyridoxal kinase C6F6.11c', 323, NULL, NULL, 172749),
(172750, '3.40.30.10-FF-000075', NULL, 'Glutathione S-transferase omega-1', 108, NULL, NULL, 172750),
(172751, '1.10.20.10-FF-000013', NULL, 'Core histone macro-H2A', 124, NULL, NULL, 172751),
(172752, '3.30.360.10-FF-000072', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', 165, NULL, NULL, 172752),
(172753, '1.10.405.20-FF-000006', NULL, NULL, 137, NULL, NULL, 172753),
(172754, '1.20.58.60-FF-000698', NULL, 'Uncharacterized protein', 111, NULL, NULL, 172754),
(172755, '2.170.170.11-FF-000001', NULL, 'Malate synthase', 117, NULL, NULL, 172755),
(172756, '3.30.450.50-FF-000063', NULL, 'Uncharacterized protein', 160, NULL, NULL, 172756),
(172757, '3.30.9.10-FF-000094', NULL, 'tRNA 5-methylaminomethyl-2-thiouridine biosynthesis bifunctional protein MnmC', 146, NULL, NULL, 172757),
(172758, '1.10.405.10-FF-000003', NULL, 'Rab proteins geranylgeranyltransferase component A', 98, NULL, NULL, 172758),
(172759, '3.30.9.10-FF-000037', NULL, 'Glycerol-3-phosphate dehydrogenase', 94, NULL, NULL, 172759),
(172760, '3.30.200.20-FF-001603', NULL, 'AaceriAEL083Wp', 127, NULL, NULL, 172760),
(172761, '3.30.1360.120-FF-000043', NULL, 'Nuclear encoded Mitochondrial TRNA Carboxymethyl-amino-methyl modification of Uridine residues', 119, NULL, NULL, 172761),
(172762, '3.30.428.70-FF-000005', NULL, 'YALI0F30349p', 330, NULL, NULL, 172762),
(172763, '1.10.287.70-FF-000515', NULL, 'Tetrameric potassium-selective cyclic nucleotide gated channel', 260, NULL, NULL, 172763),
(172764, '3.30.565.10-FF-000042', NULL, 'Two-component sensor histidine kinase KdpD', 153, NULL, NULL, 172764),
(172765, '1.20.1260.140-FF-000005', NULL, 'Alternative oxidase', 142, NULL, NULL, 172765),
(172766, '3.90.70.10-FF-000047', NULL, 'ubiquitin carboxyl-terminal hydrolase 4 isoform X2', 279, NULL, NULL, 172766),
(172767, '3.40.50.10490-FF-000159', NULL, NULL, 195, NULL, NULL, 172767),
(172768, '3.40.50.300-FF-003837', NULL, 'Phosphoryl Seryl-TRNA (Ser/Sec) Kinase', 166, NULL, NULL, 172768),
(172769, '2.60.120.1440-FF-000004', NULL, 'Sigma factor regulatory protein, FecR/PupR family', 147, NULL, NULL, 172769),
(172770, '3.90.180.10-FF-000185', NULL, 'Alcohol dehydrogenase-like 3', 176, NULL, NULL, 172770),
(172771, '2.30.30.140-FF-000150', NULL, 'Chromosome 1, whole genome shotgun sequence', 56, NULL, NULL, 172771),
(172772, '3.30.559.10-FF-000275', NULL, 'Carnitine O-acetyltransferase, putative', 112, NULL, NULL, 172772),
(172773, '3.40.50.10190-FF-000226', NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase-like isoform X1', 94, NULL, NULL, 172773),
(172774, '3.30.200.20-FF-000024', NULL, 'B-Raf proto-oncogene serine/threonine-protein kinase', 89, NULL, NULL, 172774);
INSERT INTO "PUBLIC"."MODEL" VALUES
(172775, '3.40.50.12160-FF-000014', NULL, 'Ribosomal protein S12 methylthiotransferase RimO', 130, NULL, NULL, 172775),
(172776, '1.50.10.10-FF-000067', NULL, 'Phosphorylase b kinase regulatory subunit', 352, NULL, NULL, 172776),
(172777, '3.30.710.10-FF-000285', NULL, 'kelch-like protein 18', 132, NULL, NULL, 172777),
(172778, '2.160.20.80-FF-000013', NULL, 'Synaptic vesicle glycoprotein 2B-like Protein', 110, NULL, NULL, 172778),
(172779, '1.10.472.80-FF-000235', NULL, NULL, 140, NULL, NULL, 172779),
(172780, '3.30.420.210-FF-000013', NULL, 'UBX domain-containing protein 2', 72, NULL, NULL, 172780),
(172781, '3.30.160.60-FF-004236', NULL, NULL, 28, NULL, NULL, 172781),
(172782, '3.40.50.11260-FF-000019', NULL, 'Chaperone protein HtpG', 89, NULL, NULL, 172782),
(172783, '3.40.50.300-FF-007766', NULL, 'DEAH (Asp-Glu-Ala-His) box polypeptide 37', 66, NULL, NULL, 172783),
(172784, '1.25.40.10-FF-000290', NULL, 'Protein LOW PSII ACCUMULATION 1, chloroplastic', 107, NULL, NULL, 172784),
(172785, '3.30.70.920-FF-000005', NULL, 'Lrp/AsnC family transcriptional regulator', 85, NULL, NULL, 172785),
(172786, '1.10.3260.10-FF-000036', NULL, 'DNA ligase', 228, NULL, NULL, 172786),
(172787, '3.80.10.10-FF-001140', NULL, 'GM24892', 372, NULL, NULL, 172787),
(172788, '3.30.70.240-FF-000009', NULL, 'SBDS ribosome maturation factor', 80, NULL, NULL, 172788),
(172789, '3.40.50.300-FF-008222', NULL, 'Dynein heavy chain 9-related protein', 65, NULL, NULL, 172789),
(172790, '1.10.240.10-FF-000030', NULL, 'Tryptophanyl-tRNA synthetase-like protein', 70, NULL, NULL, 172790),
(172791, '3.30.160.60-FF-000307', NULL, 'Zinc finger protein ZFP69 isoform 1', 28, NULL, NULL, 172791),
(172792, '2.120.10.80-FF-000014', NULL, 'Kelch-like protein 15', 327, NULL, NULL, 172792),
(172793, '2.90.10.10-FF-000001', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', 129, NULL, NULL, 172793),
(172794, '1.10.287.110-FF-000432', NULL, 'Uncharacterized protein', 83, NULL, NULL, 172794),
(172795, '3.40.630.30-FF-000568', NULL, 'Uncharacterized protein', 116, NULL, NULL, 172795),
(172796, '1.10.510.10-FF-004351', NULL, NULL, 121, NULL, NULL, 172796),
(172797, '3.40.50.1240-FF-000105', NULL, 'Uncharacterized protein', 210, NULL, NULL, 172797),
(172798, '2.120.10.90-FF-000017', NULL, 'DNA topoisomerase 4 subunit A', 254, NULL, NULL, 172798),
(172799, '3.40.30.10-FF-000693', NULL, 'Predicted protein', 114, NULL, NULL, 172799),
(172800, '1.25.40.20-FF-001872', NULL, 'Predicted protein', 129, NULL, NULL, 172800),
(172801, '3.40.50.300-FF-008042', NULL, 'Caspase recruitment domain family, member 14', 131, NULL, NULL, 172801),
(172802, '3.90.1150.10-FF-000002', NULL, 'Cysteine desulfurase IscS', 116, NULL, NULL, 172802),
(172803, '2.130.10.10-FF-003096', NULL, '77 kDa echinoderm microtubule-associated protein', 314, NULL, NULL, 172803),
(172804, '3.10.20.90-FF-000537', NULL, 'UBX domain protein 11', 81, NULL, NULL, 172804),
(172805, '1.25.40.20-FF-000236', NULL, 'Uncharacterized protein, isoform B', 55, NULL, NULL, 172805),
(172806, '1.10.10.10-FF-001529', NULL, 'Phenylalanine--tRNA ligase alpha subunit', 96, NULL, NULL, 172806),
(172807, '3.30.30.30-FF-000042', NULL, 'Hsp70 protein, putative', 55, NULL, NULL, 172807),
(172808, '1.25.40.20-FF-000293', NULL, 'Ankyrin repeat domain-containing protein 6', 76, NULL, NULL, 172808),
(172809, '1.10.1750.10-FF-000006', NULL, 'Chromosomal replication initiator protein DnaA', 98, NULL, NULL, 172809),
(172810, '2.60.40.3110-FF-000005', NULL, 'Fimbrial biogenesis protein', 89, NULL, NULL, 172810),
(172811, '3.90.230.10-FF-000015', NULL, 'Methionine aminopeptidase 2', 218, NULL, NULL, 172811),
(172812, '3.40.50.10190-FF-000283', NULL, 'DNA topoisomerase II-binding protein 1', 63, NULL, NULL, 172812),
(172813, '2.130.10.10-FF-004113', NULL, 'SD02661p', 190, NULL, NULL, 172813),
(172814, '3.30.70.330-FF-001559', NULL, 'RNA-binding region RNP-1 domain-containing protein', 86, NULL, NULL, 172814),
(172815, '1.25.40.10-FF-001650', NULL, 'Pentatricopeptide repeat-containing protein', 131, NULL, NULL, 172815);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(172816, '1.20.1070.10-FF-001093', NULL, 'Prokineticin receptor 1', 317, NULL, NULL, 172816),
(172817, '1.20.1050.80-FF-000016', NULL, 'Alsin homolog', 153, NULL, NULL, 172817),
(172818, '1.10.1040.10-FF-000087', NULL, 'Uncharacterized protein', 142, NULL, NULL, 172818),
(172819, '1.25.10.10-FF-003059', NULL, 'HEAT repeat domain containing protein', 267, NULL, NULL, 172819),
(172820, '1.25.40.20-FF-001653', NULL, 'Kinase, NEK', 88, NULL, NULL, 172820),
(172821, '1.10.510.10-FF-003676', NULL, NULL, 173, NULL, NULL, 172821),
(172822, '3.90.226.10-FF-000016', NULL, 'Propionyl-CoA carboxylase, beta subunit', 259, NULL, NULL, 172822),
(172823, '1.10.287.70-FF-000392', NULL, 'Uncharacterized protein', 141, NULL, NULL, 172823),
(172824, '3.10.250.10-FF-000068', NULL, NULL, 102, NULL, NULL, 172824),
(172825, '4.10.1060.10-FF-000007', NULL, 'Zinc finger Ran-binding domain-containing protein 2', 41, NULL, NULL, 172825),
(172826, '3.40.50.300-FF-003276', NULL, 'Si:ch211-209n20.1', 189, NULL, NULL, 172826),
(172827, '3.30.160.60-FF-003893', NULL, NULL, 25, NULL, NULL, 172827),
(172828, '3.80.10.10-FF-000864', NULL, 'BRASSINOSTEROID INSENSITIVE 1-associated receptor kinase 1, putative, expressed', 66, NULL, NULL, 172828),
(172829, '3.20.20.220-FF-000029', NULL, 'Proline dehydrogenase', 312, NULL, NULL, 172829),
(172830, '1.10.441.10-FF-000008', NULL, 'Phosphomannose isomerase type I, putative', 74, NULL, NULL, 172830),
(172831, '3.30.460.10-FF-000181', NULL, 'DNA polymerase', 53, NULL, NULL, 172831),
(172832, '1.20.58.1210-FF-000012', NULL, 'Exocyst complex component 8', 120, NULL, NULL, 172832),
(172833, '1.20.1070.10-FF-000199', NULL, 'Gonadotropin-releasing hormone II receptor', 332, NULL, NULL, 172833),
(172834, '3.40.50.300-FF-000460', NULL, 'RNA helicase', 217, NULL, NULL, 172834),
(172835, '3.30.200.20-FF-001660', NULL, 'Cell division control protein, putative', 117, NULL, NULL, 172835),
(172836, '1.10.10.10-FF-002024', NULL, 'Uncharacterized protein', 106, NULL, NULL, 172836),
(172837, '2.130.10.10-FF-003837', NULL, 'Uncharacterized protein', 295, NULL, NULL, 172837),
(172838, '2.60.40.1670-FF-000022', NULL, 'Protein transport protein SEC23', 161, NULL, NULL, 172838),
(172839, '2.60.40.60-FF-000631', NULL, 'Cadherin-related neuronal receptor 7', 109, NULL, NULL, 172839),
(172840, '1.20.1250.20-FF-000587', NULL, 'Multi-drug resistance efflux pump PmrA', 175, NULL, NULL, 172840),
(172841, '3.30.70.330-FF-002577', NULL, NULL, 140, NULL, NULL, 172841),
(172842, '1.10.8.720-FF-000009', NULL, 'Dynein heavy chain, putative', 166, NULL, NULL, 172842),
(172843, '1.10.510.10-FF-000309', NULL, 'Leucine-rich repeat receptor-like protein kinase', 205, NULL, NULL, 172843),
(172844, '2.60.40.10-FF-003680', NULL, NULL, 97, NULL, NULL, 172844),
(172845, '3.30.70.330-FF-002919', NULL, NULL, 188, NULL, NULL, 172845),
(172846, '2.160.20.70-FF-000010', NULL, 'Adenylyl cyclase-associated protein', 166, NULL, NULL, 172846),
(172847, '3.20.20.330-FF-000006', NULL, 'Methionine synthase', 318, NULL, NULL, 172847),
(172848, '3.80.10.10-FF-001207', NULL, 'GM20089', 172, NULL, NULL, 172848),
(172849, '1.10.10.10-FF-002081', NULL, 'Spo11-like type II topoisomerase', 93, NULL, NULL, 172849),
(172850, '3.40.50.300-FF-000403', NULL, 'ATP-binding cassette sub-family B member 8, mitochondrial', 243, NULL, NULL, 172850),
(172851, '1.10.340.30-FF-000021', NULL, '8-oxoguanine DNA glycosylase', 59, NULL, NULL, 172851),
(172852, '3.40.250.10-FF-000207', NULL, 'Tyrosine protein phosphatase', 134, NULL, NULL, 172852),
(172853, '2.130.10.10-FF-000403', NULL, 'PH-interacting protein isoform X1', 170, NULL, NULL, 172853),
(172854, '3.40.50.300-FF-007547', NULL, 'Uncharacterized protein', 194, NULL, NULL, 172854),
(172855, '3.40.50.880-FF-000032', NULL, 'Glyoxalase', 217, NULL, NULL, 172855),
(172856, '3.40.50.300-FF-003894', NULL, 'Arf family GTPase', 249, NULL, NULL, 172856),
(172857, '3.30.40.10-FF-001346', NULL, 'E3 ubiquitin-protein ligase', 57, NULL, NULL, 172857),
(172858, '2.30.39.10-FF-000154', NULL, 'Uncharacterized protein', 112, NULL, NULL, 172858);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(172859, '1.10.8.710-FF-000006', NULL, 'cytoplasmic dynein 2 heavy chain 1', 117, NULL, NULL, 172859),
(172860, '3.40.50.740-FF-000018', NULL, 'Tetrathionate reductase subunit A', 128, NULL, NULL, 172860),
(172861, '2.60.40.1530-FF-000008', NULL, 'Integrin subunit alpha L', 161, NULL, NULL, 172861),
(172862, '2.60.120.330-FF-000216', NULL, 'Uncharacterized protein', 80, NULL, NULL, 172862),
(172863, '2.40.50.140-FF-001045', NULL, NULL, 118, NULL, NULL, 172863),
(172864, '1.10.287.110-FF-000090', NULL, 'Mitochondrial import inner membrane translocase subunit TIM16, putative', 62, NULL, NULL, 172864),
(172865, '1.25.40.10-FF-001717', NULL, 'Tetratricopeptide repeat domain 21B', 167, NULL, NULL, 172865),
(172866, '1.10.510.10-FF-004019', NULL, NULL, 304, NULL, NULL, 172866),
(172867, '1.20.1050.60-FF-000010', NULL, 'Glycoside hydrolase family 92 protein', 81, NULL, NULL, 172867),
(172868, '3.20.20.190-FF-000150', NULL, NULL, 260, NULL, NULL, 172868),
(172869, '4.10.400.10-FF-000245', NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein-like Protein', 39, NULL, NULL, 172869),
(172870, '1.20.1070.10-FF-001036', NULL, 'Uncharacterized protein', 110, NULL, NULL, 172870),
(172871, '3.40.1190.20-FF-000098', NULL, 'Tagatose-6-phosphate kinase, putative', 284, NULL, NULL, 172871),
(172872, '3.30.1490.180-FF-000016', NULL, 'DNA-directed RNA polymerase subunit', 53, NULL, NULL, 172872),
(172873, '3.30.1490.190-FF-000019', NULL, 'Ferric uptake regulator family protein', 67, NULL, NULL, 172873),
(172874, '3.40.50.1390-FF-000015', NULL, 'Recombinase family protein', 127, NULL, NULL, 172874),
(172875, '3.10.100.10-FF-000203', NULL, 'Predicted protein', 139, NULL, NULL, 172875),
(172876, '3.80.10.10-FF-004349', NULL, 'Dc50, putative', 183, NULL, NULL, 172876),
(172877, '2.60.40.10-FF-005927', NULL, NULL, 105, NULL, NULL, 172877),
(172878, '1.25.40.1030-FF-000037', NULL, 'COPII coat assembly protein SEC16', 308, NULL, NULL, 172878),
(172879, '1.10.8.720-FF-000032', NULL, 'Dynein heavy chain', 176, NULL, NULL, 172879),
(172880, '3.40.630.30-FF-000260', NULL, 'Acetyltransferase family protein', 121, NULL, NULL, 172880),
(172881, '1.20.1440.340-FF-000011', NULL, 'Galactokinase, putative', 175, NULL, NULL, 172881),
(172882, '1.10.260.40-FF-000097', NULL, 'Octamer-binding transcription factor 3', 45, NULL, NULL, 172882),
(172883, '2.60.40.10-FF-002701', NULL, NULL, 90, NULL, NULL, 172883),
(172884, '3.30.70.330-FF-002993', NULL, NULL, 86, NULL, NULL, 172884),
(172885, '1.25.40.10-FF-003549', NULL, 'Prolyl 3-hydroxylase 1', 77, NULL, NULL, 172885),
(172886, '1.25.40.10-FF-001425', NULL, 'Alpha-SNAP, putative', 259, NULL, NULL, 172886),
(172887, '3.90.850.10-FF-000017', NULL, 'Acylpyruvase FAHD1, mitochondrial', 216, NULL, NULL, 172887),
(172888, '2.130.10.10-FF-005861', NULL, 'Uncharacterized protein', 316, NULL, NULL, 172888),
(172889, '2.40.110.20-FF-000002', NULL, 'Acyl-CoA dehydrogenase, C-terminal domain protein', 149, NULL, NULL, 172889),
(172890, '1.10.287.70-FF-000723', NULL, 'Calcium voltage-gated channel subunit alpha1 A', 133, NULL, NULL, 172890),
(172891, '4.10.640.10-FF-000032', NULL, 'Uncharacterized protein', 61, NULL, NULL, 172891),
(172892, '3.40.50.1010-FF-000065', NULL, 'Mitochondrial structure specific endonuclease I (SSE-1)', 206, NULL, NULL, 172892),
(172893, '3.30.160.60-FF-002134', NULL, 'Zinc finger protein 616', 32, NULL, NULL, 172893),
(172894, '3.30.40.10-FF-000868', NULL, 'RING-H2 finger protein ATL3', 54, NULL, NULL, 172894),
(172895, '1.10.3090.10-FF-000023', NULL, 'Predicted protein', 241, NULL, NULL, 172895),
(172896, '2.80.10.50-FF-000002', NULL, 'Inositol 1,4,5-trisphosphate receptor type 2', 223, NULL, NULL, 172896),
(172897, '2.30.30.140-FF-000352', NULL, 'Predicted protein', 109, NULL, NULL, 172897),
(172898, '3.80.10.10-FF-001123', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 99, NULL, NULL, 172898),
(172899, '3.40.50.300-FF-008003', NULL, 'Dynein heavy chain, cytosolic, putative', 148, NULL, NULL, 172899),
(172900, '4.10.400.10-FF-000251', NULL, 'Low-density lipoprotein RecePtor related', 42, NULL, NULL, 172900);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(172901, '3.30.160.20-FF-000138', NULL, 'Probable RNA-binding protein 46', 71, NULL, NULL, 172901),
(172902, '3.10.110.10-FF-000131', NULL, 'Ubiquitin-conjugating enzyme E2 25', 171, NULL, NULL, 172902),
(172903, '1.10.3500.10-FF-000022', NULL, 'Transcription elongation factor SPT6', 298, NULL, NULL, 172903),
(172904, '1.50.10.10-FF-000196', NULL, 'Uncharacterized protein', 229, NULL, NULL, 172904),
(172905, '3.40.50.450-FF-000038', NULL, 'Diphosphate-fructose-6-phosphate 1-phosphotransferase', 157, NULL, NULL, 172905),
(172906, '3.40.50.150-FF-000055', NULL, '5-methylcytosine rRNA methyltransferase NSUN4', 226, NULL, NULL, 172906),
(172907, '3.90.1570.50-FF-000001', NULL, 'Type I restriction-modification system restriction subunit R', 170, NULL, NULL, 172907),
(172908, '2.60.40.10-FF-005883', NULL, NULL, 95, NULL, NULL, 172908),
(172909, '1.25.10.10-FF-001923', NULL, 'Protein CBR-DAAM-1', 163, NULL, NULL, 172909),
(172910, '3.40.50.720-FF-001114', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 149, NULL, NULL, 172910),
(172911, '3.40.50.1380-FF-000012', NULL, 'Bifunctional purine biosynthesis protein PurH', 201, NULL, NULL, 172911),
(172912, '3.30.1240.10-FF-000074', NULL, 'Uncharacterized protein', 105, NULL, NULL, 172912),
(172913, '1.50.10.10-FF-000207', NULL, 'Uncharacterized protein', 193, NULL, NULL, 172913),
(172914, '2.102.10.10-FF-000017', NULL, 'Ferrodoxin reductase-like protein', 117, NULL, NULL, 172914),
(172915, '1.10.580.10-FF-000027', NULL, 'Citrate synthase', 225, NULL, NULL, 172915),
(172916, '3.40.720.10-FF-000373', NULL, 'Predicted protein', 218, NULL, NULL, 172916),
(172917, '3.40.50.12370-FF-000009', NULL, 'Cation/H(+) antiporter 14', 256, NULL, NULL, 172917),
(172918, '3.40.50.300-FF-004304', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', 92, NULL, NULL, 172918),
(172919, '3.30.1640.10-FF-000020', NULL, 'DNA helicase', 100, NULL, NULL, 172919),
(172920, '1.20.120.980-FF-000016', NULL, 'IP20428p', 142, NULL, NULL, 172920),
(172921, '1.25.40.10-FF-004022', NULL, 'Uncharacterized protein', 190, NULL, NULL, 172921),
(172922, '3.30.750.44-FF-000020', NULL, NULL, 52, NULL, NULL, 172922),
(172923, '3.40.50.12350-FF-000003', NULL, 'Eyes absent homolog', 264, NULL, NULL, 172923),
(172924, '4.10.280.10-FF-000162', NULL, 'Transcription factor BHLH148', 66, NULL, NULL, 172924),
(172925, '3.90.76.10-FF-000032', NULL, 'ABC transporter substrate-binding protein', 156, NULL, NULL, 172925),
(172926, '2.130.10.10-FF-001527', NULL, 'WD repeat-containing protein SAZD, putative', 179, NULL, NULL, 172926),
(172927, '1.10.1410.10-FF-000082', NULL, 'Uncharacterized protein', 20, NULL, NULL, 172927),
(172928, '1.20.990.10-FF-000039', NULL, 'NADPH-dependent diflavin oxidoreductase 1', 128, NULL, NULL, 172928),
(172929, '1.10.630.10-FF-000526', NULL, 'Cytochrome P450, family 2, subfamily k, polypeptide 19', 387, NULL, NULL, 172929),
(172930, '2.30.29.240-FF-000020', NULL, 'Phosphoinositide phospholipase C', 128, NULL, NULL, 172930),
(172931, '3.40.720.10-FF-000047', NULL, 'Arylsulfatase', 420, NULL, NULL, 172931),
(172932, '3.30.559.30-FF-000022', NULL, 'L-2-aminoadipate reductase', 214, NULL, NULL, 172932),
(172933, '3.50.50.60-FF-001248', NULL, 'Flavin-containing monooxygenase', 151, NULL, NULL, 172933),
(172934, '1.10.1620.20-FF-000005', NULL, 'Uncharacterized protein, isoform A', 56, NULL, NULL, 172934),
(172935, '3.40.50.720-FF-000967', NULL, 'Probable polyketide synthase 30', 155, NULL, NULL, 172935),
(172936, '1.10.225.10-FF-000012', NULL, 'Proactivator polypeptide', 83, NULL, NULL, 172936),
(172937, '3.40.50.300-FF-004630', NULL, 'Transport protein', 215, NULL, NULL, 172937),
(172938, '3.30.1840.10-FF-000001', NULL, 'Polyphosphate kinase', 198, NULL, NULL, 172938),
(172939, '2.60.40.10-FF-004146', NULL, NULL, 115, NULL, NULL, 172939),
(172940, '3.90.1420.10-FF-000001', NULL, 'histone-lysine N-methyltransferase setd3 isoform X1', 170, NULL, NULL, 172940),
(172941, '2.130.10.10-FF-005905', NULL, 'Uncharacterized protein', 281, NULL, NULL, 172941);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(172942, '3.40.50.300-FF-000252', NULL, 'Uridine kinase', 207, NULL, NULL, 172942),
(172943, '3.30.70.330-FF-001891', NULL, NULL, 87, NULL, NULL, 172943),
(172944, '3.40.50.1000-FF-000062', NULL, 'Cation-transporting ATPase I', 13, NULL, NULL, 172944),
(172945, '1.10.220.30-FF-000029', NULL, 'Flagellar motor switch protein FliG', 105, NULL, NULL, 172945),
(172946, '2.60.40.1730-FF-000057', NULL, NULL, 235, NULL, NULL, 172946),
(172947, '1.25.40.20-FF-000326', NULL, 'Calmodulin-binding transcription activator 2', 185, NULL, NULL, 172947),
(172948, '1.10.8.1310-FF-000022', NULL, 'Uncharacterized protein', 57, NULL, NULL, 172948),
(172949, '2.40.170.20-FF-000011', NULL, 'Ferrioxamine B receptor', 531, NULL, NULL, 172949),
(172950, '1.50.40.10-FF-000035', NULL, 'Mitochondrial carrier homolog 2 variant', 284, NULL, NULL, 172950),
(172951, '1.25.40.10-FF-000323', NULL, 'Gamma-soluble NSF attachment protein', 270, NULL, NULL, 172951),
(172952, '3.30.1120.10-FF-000008', NULL, 'Arylsulfatase', 77, NULL, NULL, 172952),
(172953, '2.130.10.10-FF-003618', NULL, 'Ribosomal RNA processing 9, U3 small nucleolar RNA binding protein', 139, NULL, NULL, 172953),
(172954, '1.10.630.10-FF-000835', NULL, 'Uncharacterized protein', 148, NULL, NULL, 172954),
(172955, '2.130.10.10-FF-005535', NULL, 'Uncharacterized protein', 269, NULL, NULL, 172955),
(172956, '1.20.58.830-FF-000028', NULL, 'Erythrocyte membrane protein 1', 160, NULL, NULL, 172956),
(172957, '3.90.228.10-FF-000015', NULL, 'C2H2-like zinc finger protein', 213, NULL, NULL, 172957),
(172958, '1.20.1560.10-FF-000697', NULL, 'Lantibiotic mersacidin transporter system', 337, NULL, NULL, 172958),
(172959, '3.30.70.80-FF-000008', NULL, 'Alkaline protease 1', 87, NULL, NULL, 172959),
(172960, '3.50.50.100-FF-000009', NULL, 'Internal alternative NAD(P)H-ubiquinone oxidoreductase A1, mitochondrial', 445, NULL, NULL, 172960),
(172961, '1.25.40.150-FF-000001', NULL, 'V-type proton ATPase subunit H', 103, NULL, NULL, 172961),
(172962, '3.80.10.10-FF-000943', NULL, 'Disease resistance protein Pik-2', 138, NULL, NULL, 172962),
(172963, '3.90.228.20-FF-000018', NULL, NULL, 85, NULL, NULL, 172963),
(172964, '1.25.10.10-FF-000142', NULL, 'TOG array regulator of axonemal microtubules 1', 257, NULL, NULL, 172964),
(172965, '3.40.50.300-FF-001707', NULL, 'ABC transporter ATP-binding protein/permease', 252, NULL, NULL, 172965),
(172966, '3.40.50.720-FF-000288', NULL, '2,4-dienoyl-CoA reductase, mitochondrial', 301, NULL, NULL, 172966),
(172967, '2.40.10.10-FF-000222', NULL, 'GH15905p', 89, NULL, NULL, 172967),
(172968, '3.40.710.10-FF-000075', NULL, 'Possible penicillin-binding lipoprotein', 293, NULL, NULL, 172968),
(172969, '3.30.1490.20-FF-000106', NULL, 'Succinate-CoA ligase subunit beta', 92, NULL, NULL, 172969),
(172970, '3.30.930.10-FF-000138', NULL, 'Glycyl-tRNA synthetase, putative', 277, NULL, NULL, 172970),
(172971, '3.30.450.40-FF-000104', NULL, 'IclR family transcriptional regulator', 180, NULL, NULL, 172971),
(172972, '3.30.160.60-FF-005686', NULL, NULL, 22, NULL, NULL, 172972),
(172973, '2.60.40.1180-FF-000156', NULL, 'AAR017Wp', 98, NULL, NULL, 172973),
(172974, '3.90.70.80-FF-000079', NULL, 'Predicted protein', 123, NULL, NULL, 172974),
(172975, '4.10.372.10-FF-000004', NULL, 'Linoleate 13S-lipoxygenase 2-1, chloroplastic', 90, NULL, NULL, 172975),
(172976, '3.40.710.10-FF-000119', NULL, 'Penicillin-binding protein 4', 336, NULL, NULL, 172976),
(172977, '1.10.3210.10-FF-000112', NULL, 'Dihydroneopterin 2'',3''-cyclic phosphate phosphodiesterase', 141, NULL, NULL, 172977),
(172978, '1.10.287.110-FF-000134', NULL, 'DnaJ protein, putative', 62, NULL, NULL, 172978),
(172979, '3.40.980.10-FF-000021', NULL, 'Molybdopterin molybdenumtransferase', 152, NULL, NULL, 172979),
(172980, '2.60.40.10-FF-001875', NULL, 'Leucine rich repeat neuronal 4', 95, NULL, NULL, 172980),
(172981, '3.40.1620.10-FF-000005', NULL, 'Antitoxin RelJ', 38, NULL, NULL, 172981),
(172982, '3.40.50.300-FF-003787', NULL, 'ATP-dependent DNA helicase Hel308', 198, NULL, NULL, 172982),
(172983, '3.40.50.2300-FF-001188', NULL, NULL, 18, NULL, NULL, 172983);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(172984, '2.30.33.40-FF-000003', NULL, '10 kDa chaperonin', 101, NULL, NULL, 172984),
(172985, '1.10.287.1490-FF-000021', NULL, 'Elastin microfibril interfacer 3', 143, NULL, NULL, 172985),
(172986, '3.40.50.300-FF-000605', NULL, 'multidrug resistance-associated protein 5 isoform X1', 259, NULL, NULL, 172986),
(172987, '3.40.50.1000-FF-000415', NULL, 'HAD superfamily, subfamily IIIB acid phosphatase', 196, NULL, NULL, 172987),
(172988, '1.10.10.10-FF-001597', NULL, 'Uncharacterized protein', 109, NULL, NULL, 172988),
(172989, '3.40.50.720-FF-001440', NULL, 'Autophagy-related protein 7, putative', 354, NULL, NULL, 172989),
(172990, '1.20.5.490-FF-000011', NULL, 'cGMP-dependent protein kinase', 32, NULL, NULL, 172990),
(172991, '3.30.300.20-FF-000083', NULL, 'GTP-binding protein ERG', 63, NULL, NULL, 172991),
(172992, '1.20.5.190-FF-000011', NULL, 'unconventional myosin-Ib isoform X1', 56, NULL, NULL, 172992),
(172993, '3.30.40.10-FF-001048', NULL, 'Ring finger protein 32', 94, NULL, NULL, 172993),
(172994, '3.90.640.10-FF-000097', NULL, 'Molecular chaperone HscC', 73, NULL, NULL, 172994),
(172995, '3.40.50.720-FF-000597', NULL, 'Dihydroflavonol 4-reductase', 344, NULL, NULL, 172995),
(172996, '2.20.28.10-FF-000016', NULL, 'DNA helicase', 59, NULL, NULL, 172996),
(172997, '3.80.10.10-FF-001432', NULL, 'Toll-like receptor 11', 155, NULL, NULL, 172997),
(172998, '3.60.21.10-FF-000233', NULL, 'Serine/threonine-protein phosphatase', 381, NULL, NULL, 172998),
(172999, '1.20.1250.20-FF-000727', NULL, 'AGAP001782-PA', 266, NULL, NULL, 172999),
(173000, '1.25.40.20-FF-000652', NULL, 'Serine/threonine protein kinase', 125, NULL, NULL, 173000),
(173001, '3.40.140.10-FF-000070', NULL, 'Cell division protein DedD', 154, NULL, NULL, 173001),
(173002, '1.20.1270.60-FF-000162', NULL, 'Rho GTPase-activating protein 17', 246, NULL, NULL, 173002),
(173003, '1.20.140.10-FF-000127', NULL, 'Acyl-CoA dehydrogenase short chain', 81, NULL, NULL, 173003),
(173004, '3.40.1230.10-FF-000020', NULL, 'Uncharacterized protein', 93, NULL, NULL, 173004),
(173005, '3.30.160.60-FF-001954', NULL, 'Zinc finger protein 787', 30, NULL, NULL, 173005),
(173006, '2.130.10.10-FF-004124', NULL, 'Uncharacterized protein', 187, NULL, NULL, 173006),
(173007, '2.60.260.20-FF-000103', NULL, 'DnaJ family chaperone protein, mitochondrial, putative', 77, NULL, NULL, 173007),
(173008, '3.30.160.60-FF-002443', NULL, 'Zinc finger protein 687', 63, NULL, NULL, 173008),
(173009, '1.25.40.10-FF-001734', NULL, 'Os01g0589900 protein', 100, NULL, NULL, 173009),
(173010, '1.10.630.10-FF-000482', NULL, 'Cytochrome P450, family 2, subfamily K, polypeptide 8', 474, NULL, NULL, 173010),
(173011, '1.10.555.10-FF-000177', NULL, NULL, 119, NULL, NULL, 173011),
(173012, '3.40.190.80-FF-000015', NULL, 'Inositol polyphosphate 1-phosphatase', 161, NULL, NULL, 173012),
(173013, '1.10.3860.10-FF-000026', NULL, 'SDF family transport protein (Probable substrate glutamate/aspartate)', 407, NULL, NULL, 173013),
(173014, '3.90.550.50-FF-000040', NULL, 'Hexosyltransferase', 237, NULL, NULL, 173014),
(173015, '3.30.200.20-FF-001480', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 2', 107, NULL, NULL, 173015),
(173016, '1.10.238.10-FF-000272', NULL, 'ubiquitin carboxyl-terminal hydrolase 32', 67, NULL, NULL, 173016),
(173017, '3.30.70.330-FF-001239', NULL, 'RNA recognition motif domain containing protein', 136, NULL, NULL, 173017),
(173018, '3.40.50.1820-FF-001280', NULL, 'Lipase, putative', 295, NULL, NULL, 173018),
(173019, '1.25.40.20-FF-001737', NULL, 'Uncharacterized protein', 217, NULL, NULL, 173019),
(173020, '2.60.120.920-FF-000163', NULL, 'Predicted protein', 127, NULL, NULL, 173020),
(173021, '3.30.200.20-FF-002160', NULL, NULL, 65, NULL, NULL, 173021),
(173022, '2.30.29.30-FF-001204', NULL, 'Uncharacterized protein', 119, NULL, NULL, 173022),
(173023, '1.10.510.10-FF-003968', NULL, 'Uncharacterized protein', 388, NULL, NULL, 173023),
(173024, '3.40.50.1820-FF-001600', NULL, 'Uncharacterized protein', 80, NULL, NULL, 173024),
(173025, '1.10.10.980-FF-000001', NULL, 'CST complex subunit STN1', 106, NULL, NULL, 173025);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(173026, '3.30.1330.30-FF-000042', NULL, 'Ribonuclease P protein subunit p38', 155, NULL, NULL, 173026),
(173027, '3.40.50.2300-FF-001351', NULL, NULL, 44, NULL, NULL, 173027),
(173028, '3.30.9.10-FF-000217', NULL, 'Uncharacterized protein', 93, NULL, NULL, 173028),
(173029, '3.40.50.10140-FF-000009', NULL, 'X-linked interleukin-1 receptor accessory protein-like 1', 157, NULL, NULL, 173029),
(173030, '1.20.1560.10-FF-000708', NULL, 'ABC transporter, putative', 316, NULL, NULL, 173030),
(173031, '3.30.470.160-FF-000013', NULL, 'Uncharacterized inositol polyphosphate kinase C607.04', 248, NULL, NULL, 173031),
(173032, '1.50.40.10-FF-000361', NULL, 'Mitochondrial carrier protein, putative', 165, NULL, NULL, 173032),
(173033, '3.30.1460.50-FF-000017', NULL, 'YALI0D23386p', 137, NULL, NULL, 173033),
(173034, '3.30.160.60-FF-005995', NULL, NULL, 46, NULL, NULL, 173034),
(173035, '3.20.20.140-FF-000360', NULL, 'Uncharacterized protein (Fragment)', 277, NULL, NULL, 173035),
(173036, '3.90.25.10-FF-000089', NULL, 'Uncharacterized protein', 14, NULL, NULL, 173036),
(173037, '3.40.50.300-FF-005939', NULL, 'Putative ATP-dependent RNA helicase DHX40', 208, NULL, NULL, 173037),
(173038, '3.90.1750.10-FF-000020', NULL, 'LOW QUALITY PROTEIN: probable E3 ubiquitin-protein ligase HERC1', 157, NULL, NULL, 173038),
(173039, '1.10.510.10-FF-003761', NULL, NULL, 140, NULL, NULL, 173039),
(173040, '3.40.50.10130-FF-000006', NULL, 'Fanconi anemia core complex-associated protein 24', 143, NULL, NULL, 173040),
(173041, '3.30.70.330-FF-002684', NULL, NULL, 163, NULL, NULL, 173041),
(173042, '2.60.120.10-FF-000719', NULL, 'Cyclic GMP-binding protein D', 210, NULL, NULL, 173042),
(173043, '1.10.10.990-FF-000004', NULL, 'RecBCD enzyme subunit RecC', 60, NULL, NULL, 173043),
(173044, '2.60.120.620-FF-000163', NULL, 'Uncharacterized protein', 39, NULL, NULL, 173044),
(173045, '3.90.1480.20-FF-000030', NULL, 'ST6 beta-galactosamide alpha-2,6-sialyltranferase 1', 98, NULL, NULL, 173045),
(173046, '3.40.50.300-FF-003478', NULL, 'ATP-dependent RNA helicase YTHDC2', 219, NULL, NULL, 173046),
(173047, '3.40.50.2300-FF-001660', NULL, NULL, 183, NULL, NULL, 173047),
(173048, '3.30.310.10-FF-000035', NULL, 'AP complex subunit beta', 115, NULL, NULL, 173048),
(173049, '3.40.50.2000-FF-000862', NULL, 'Uncharacterized protein', 203, NULL, NULL, 173049),
(173050, '1.25.40.570-FF-000037', NULL, 'COP9 signalosome complex subunit 1', 357, NULL, NULL, 173050),
(173051, '1.10.150.290-FF-000003', NULL, NULL, 73, NULL, NULL, 173051),
(173052, '3.30.9.10-FF-000234', NULL, 'Uncharacterized protein', 62, NULL, NULL, 173052),
(173053, '3.30.30.10-FF-000002', NULL, 'Alpha-like toxin BmK-M1', 63, NULL, NULL, 173053),
(173054, '3.40.920.10-FF-000028', NULL, NULL, 91, NULL, NULL, 173054),
(173055, '3.20.20.80-FF-000377', NULL, 'Uncharacterized protein', 280, NULL, NULL, 173055),
(173056, '3.40.50.300-FF-002713', NULL, 'Sulfate adenylyltransferase subunit 1', 223, NULL, NULL, 173056),
(173057, '2.130.10.130-FF-000051', NULL, NULL, 168, NULL, NULL, 173057),
(173058, '3.40.50.1820-FF-000465', NULL, 'Kynurenine formamidase', 261, NULL, NULL, 173058),
(173059, '3.30.70.1220-FF-000006', NULL, 'General transcription factor IIH subunit 5', 70, NULL, NULL, 173059),
(173060, '3.30.70.1230-FF-000009', NULL, 'Adenylate cyclase', 193, NULL, NULL, 173060),
(173061, '2.130.10.10-FF-004450', NULL, 'Uncharacterized protein', 348, NULL, NULL, 173061),
(173062, '3.40.109.10-FF-000025', NULL, 'Putative nitroreductase', 226, NULL, NULL, 173062),
(173063, '3.40.850.10-FF-000394', NULL, 'Kinesin-like protein', 291, NULL, NULL, 173063),
(173064, '3.40.50.1110-FF-000095', NULL, 'Lipase', 233, NULL, NULL, 173064),
(173065, '3.40.1810.10-FF-000031', NULL, 'MADS-box transcription factor 54', 64, NULL, NULL, 173065),
(173066, '2.10.25.10-FF-000297', NULL, 'Nidogen 1', 39, NULL, NULL, 173066),
(173067, '1.10.560.10-FF-000144', NULL, '60 kDa heat shock protein, mitochondrial', 35, NULL, NULL, 173067),
(173068, '2.60.120.330-FF-000211', NULL, 'Uncharacterized protein', 114, NULL, NULL, 173068);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(173069, '3.40.50.1100-FF-000092', NULL, '1-aminocyclopropane-1-carboxylate deaminase', 104, NULL, NULL, 173069),
(173070, '3.30.750.44-FF-000003', NULL, 'S41 family peptidase', 71, NULL, NULL, 173070),
(173071, '3.30.70.3250-FF-000020', NULL, NULL, 134, NULL, NULL, 173071),
(173072, '1.20.120.1960-FF-000003', NULL, 'Sulfhydryl oxidase', 145, NULL, NULL, 173072),
(173073, '3.10.20.90-FF-000436', NULL, 'Phosphatidylinositol 4-kinase gamma 4', 94, NULL, NULL, 173073),
(173074, '3.40.50.2300-FF-001334', NULL, NULL, 75, NULL, NULL, 173074),
(173075, '3.40.50.1820-FF-001263', NULL, 'Carboxylic ester hydrolase', 544, NULL, NULL, 173075),
(173076, '1.20.272.10-FF-000051', NULL, NULL, 107, NULL, NULL, 173076),
(173077, '3.30.559.30-FF-000005', NULL, 'Nonribosomal peptide synthase Pes1', 257, NULL, NULL, 173077),
(173078, '1.20.1250.20-FF-001542', NULL, 'YALI0D22000p', 423, NULL, NULL, 173078),
(173079, '1.10.630.10-FF-000509', NULL, 'Uncharacterized protein', 427, NULL, NULL, 173079),
(173080, '3.30.420.80-FF-000002', NULL, '40S ribosomal protein S14', 151, NULL, NULL, 173080),
(173081, '2.60.200.20-FF-000111', NULL, 'Serine/threonine protein kinase Chk2, putative', 113, NULL, NULL, 173081),
(173082, '1.10.3090.10-FF-000006', NULL, 'tRNA nucleotidyltransferase, putative', 144, NULL, NULL, 173082),
(173083, '2.130.10.10-FF-005552', NULL, 'Uncharacterized protein', 222, NULL, NULL, 173083),
(173084, '3.80.10.10-FF-000959', NULL, 'Osteomodulin', 168, NULL, NULL, 173084),
(173085, '3.30.750.80-FF-000004', NULL, 'S-adenosyl-L-methionine-dependent methyltransferases superfamily protein', 103, NULL, NULL, 173085),
(173086, '1.10.246.220-FF-000001', NULL, 'Telomere repeat-binding protein 1', 104, NULL, NULL, 173086),
(173087, '1.20.144.10-FF-000012', NULL, 'Phospholipid phosphatase-related protein type 4', 188, NULL, NULL, 173087),
(173088, '3.30.420.510-FF-000007', NULL, 'Pantothenate kinase 2', 81, NULL, NULL, 173088),
(173089, '1.25.40.1010-FF-000014', NULL, 'N-terminal acetyltransferase A complex subunit-like protein C418.02', 163, NULL, NULL, 173089),
(173090, '3.30.30.30-FF-000008', NULL, 'heat shock 70 kDa protein 14', 55, NULL, NULL, 173090),
(173091, '3.30.70.3550-FF-000003', NULL, 'Leucyl/phenylalanyl-tRNA--protein transferase', 32, NULL, NULL, 173091),
(173092, '3.30.40.10-FF-000559', NULL, 'Cellulose synthase', 82, NULL, NULL, 173092),
(173093, '1.10.510.10-FF-002007', NULL, 'Protein kinase superfamily protein', 156, NULL, NULL, 173093),
(173094, '3.40.50.300-FF-006221', NULL, 'Uncharacterized protein', 218, NULL, NULL, 173094),
(173095, '3.60.130.10-FF-000048', NULL, 'Predicted protein', 300, NULL, NULL, 173095),
(173096, '1.10.390.10-FF-000018', NULL, 'transcription initiation factor TFIID subunit 2', 270, NULL, NULL, 173096),
(173097, '2.60.120.10-FF-000192', NULL, 'Vacuolar protein', 134, NULL, NULL, 173097),
(173098, '2.60.40.10-FF-000105', NULL, 'filamin-C isoform X1', 77, NULL, NULL, 173098),
(173099, '2.130.10.10-FF-005198', NULL, 'Damage-specific DNA binding protein, putative', 104, NULL, NULL, 173099),
(173100, '3.90.470.20-FF-000007', NULL, 'Phosphopantetheinyl transferase', 92, NULL, NULL, 173100),
(173101, '3.40.50.300-FF-002067', NULL, 'DNA helicase', 211, NULL, NULL, 173101),
(173102, '1.20.1250.20-FF-002189', NULL, 'Uncharacterized protein', 159, NULL, NULL, 173102),
(173103, '1.10.510.10-FF-002350', NULL, NULL, 196, NULL, NULL, 173103),
(173104, '1.10.1200.10-FF-000173', NULL, 'Non-ribosomal peptide synthase', 89, NULL, NULL, 173104),
(173105, '3.60.40.10-FF-000288', NULL, 'Protein IcfG', 268, NULL, NULL, 173105),
(173106, '2.90.10.10-FF-000006', NULL, 'Serine/threonine-protein kinase', 125, NULL, NULL, 173106),
(173107, '2.30.180.10-FF-000101', NULL, NULL, 138, NULL, NULL, 173107),
(173108, '1.10.472.80-FF-000084', NULL, 'Mdr1p', 157, NULL, NULL, 173108),
(173109, '2.60.20.10-FF-000014', NULL, 'Syncollin', 110, NULL, NULL, 173109),
(173110, '1.20.140.50-FF-000015', NULL, 'Enhancer of Glp-One (Glp-1)', 180, NULL, NULL, 173110),
(173111, '2.60.40.10-FF-002229', NULL, 'Twitchin', 93, NULL, NULL, 173111); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(173112, '3.30.160.60-FF-005669', NULL, NULL, 28, NULL, NULL, 173112),
(173113, '3.30.460.10-FF-000147', NULL, '2''-5''-oligoadenylate synthase 3', 106, NULL, NULL, 173113),
(173114, '1.10.357.60-FF-000001', NULL, 'Exocyst complex component EXO70', 172, NULL, NULL, 173114),
(173115, '1.20.5.110-FF-000061', NULL, 'Synaptosome associated protein 47', 57, NULL, NULL, 173115),
(173116, '4.10.1060.10-FF-000069', NULL, 'RAN-binding protein 2', 40, NULL, NULL, 173116),
(173117, '3.30.750.70-FF-000001', NULL, 'DeoR/GlpR family transcriptional regulator', 65, NULL, NULL, 173117),
(173118, '3.90.1410.10-FF-000062', NULL, 'Predicted protein', 250, NULL, NULL, 173118),
(173119, '3.40.50.300-FF-000914', NULL, 'ADP-ribosylation factor-related protein 1', 189, NULL, NULL, 173119),
(173120, '1.10.150.80-FF-000010', NULL, 'ATP-dependent DNA helicase Q-like 4A', 87, NULL, NULL, 173120),
(173121, '1.10.220.20-FF-000009', NULL, 'GTP exchange factor for ARFs 1', 78, NULL, NULL, 173121),
(173122, '1.10.10.10-FF-001743', NULL, 'SirR/DtxR family transcription regulator SirR', 73, NULL, NULL, 173122),
(173123, '1.10.506.10-FF-000002', NULL, 'Ras GTPase-activating protein nGAP isoform 2', 117, NULL, NULL, 173123),
(173124, '3.40.250.10-FF-000056', NULL, 'TBC domain-containing protein kinase protein', 119, NULL, NULL, 173124),
(173125, '1.20.58.530-FF-000028', NULL, 'Heavy chain, Unconventional Myosin', 31, NULL, NULL, 173125),
(173126, '2.30.40.10-FF-000039', NULL, 'Amidohydrolase', 80, NULL, NULL, 173126),
(173127, '1.10.8.10-FF-000096', NULL, 'UBX domain-containing protein', 44, NULL, NULL, 173127),
(173128, '2.10.25.10-FF-000752', NULL, 'Draper, isoform D', 65, NULL, NULL, 173128),
(173129, '1.10.357.70-FF-000004', NULL, 'Tumor necrosis factor alpha-induced protein 2', 173, NULL, NULL, 173129),
(173130, '3.40.640.10-FF-000063', NULL, 'probable low-specificity L-threonine aldolase 1', 250, NULL, NULL, 173130),
(173131, '3.80.10.10-FF-001106', NULL, 'Toll-like receptor Tollo', 103, NULL, NULL, 173131),
(173132, '1.20.58.1070-FF-000026', NULL, 'Uncharacterized protein', 236, NULL, NULL, 173132),
(173133, '1.10.285.10-FF-000004', NULL, 'Glutamate dehydrogenase', 52, NULL, NULL, 173133),
(173134, '3.40.50.300-FF-008020', NULL, 'ABC transporter, transmembrane ATP-binding protein, putative', 140, NULL, NULL, 173134),
(173135, '3.40.50.150-FF-000408', NULL, 'D12 class N6 adenine-specific DNA methyltransferase', 141, NULL, NULL, 173135),
(173136, '3.40.630.30-FF-000467', NULL, 'Predicted protein', 164, NULL, NULL, 173136),
(173137, '2.130.10.10-FF-002016', NULL, 'Protein CBG22378', 303, NULL, NULL, 173137),
(173138, '2.102.10.10-FF-000034', NULL, 'Uncharacterized protein', 189, NULL, NULL, 173138),
(173139, '1.10.533.10-FF-000132', NULL, 'Cell death protein 3', 93, NULL, NULL, 173139),
(173140, '1.25.40.10-FF-002105', NULL, 'Pentatricopeptide repeat domain-containing protein 3, mitochondrial', 139, NULL, NULL, 173140),
(173141, '1.20.58.60-FF-000687', NULL, 'Si:ch211-207i1.2', 113, NULL, NULL, 173141),
(173142, '1.10.10.1840-FF-000001', NULL, 'Acanthaporin', 61, NULL, NULL, 173142),
(173143, '2.60.40.10-FF-002005', NULL, 'Putative Defective proboscis extension response', 92, NULL, NULL, 173143),
(173144, '1.10.10.10-FF-001288', NULL, 'Putative peroxin 14', 68, NULL, NULL, 173144),
(173145, '1.10.472.80-FF-000230', NULL, NULL, 150, NULL, NULL, 173145),
(173146, '3.90.850.10-FF-000034', NULL, NULL, 190, NULL, NULL, 173146),
(173147, '3.40.20.10-FF-000018', NULL, 'Coactosin-like 1', 141, NULL, NULL, 173147),
(173148, '1.20.140.40-FF-000012', NULL, 'Pectinesterase', 161, NULL, NULL, 173148),
(173149, '1.10.220.10-FF-000006', NULL, 'Annexin', 71, NULL, NULL, 173149),
(173150, '2.130.10.10-FF-003298', NULL, 'Cleavage and polyadenylation specificity factor, putative', 404, NULL, NULL, 173150),
(173151, '3.40.50.12760-FF-000019', NULL, 'Cap-specific mRNA (nucleoside-2''-O-)-methyltransferase 2', 147, NULL, NULL, 173151),
(173152, '1.50.10.10-FF-000224', NULL, 'alpha-1,2-Mannosidase', 62, NULL, NULL, 173152),
(173153, '2.130.10.10-FF-000408', NULL, 'protein DAMAGED DNA-BINDING 2', 330, NULL, NULL, 173153);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(173154, '3.30.160.60-FF-002460', NULL, 'Zgc:174574', 30, NULL, NULL, 173154),
(173155, '3.40.630.60-FF-000010', NULL, NULL, 117, NULL, NULL, 173155),
(173156, '3.40.50.300-FF-004321', NULL, 'Protein ImuA', 109, NULL, NULL, 173156),
(173157, '4.10.95.10-FF-000004', NULL, 'Cytochrome c oxidase subunit VIa', 78, NULL, NULL, 173157),
(173158, '2.60.120.560-FF-000021', NULL, 'Uncharacterized protein', 242, NULL, NULL, 173158),
(173159, '2.40.50.140-FF-001253', NULL, NULL, 60, NULL, NULL, 173159),
(173160, '1.25.40.10-FF-002240', NULL, 'U3 small nucleolar RNA-associated protein 6-like', 174, NULL, NULL, 173160),
(173161, '3.30.420.10-FF-000717', NULL, NULL, 84, NULL, NULL, 173161),
(173162, '2.30.30.140-FF-000026', NULL, 'SAGA-associated factor 29 homolog', 58, NULL, NULL, 173162),
(173163, '1.25.40.10-FF-001751', NULL, 'Phosphatidyl inositol 3-kinase', 194, NULL, NULL, 173163),
(173164, '3.80.10.10-FF-003231', NULL, 'Uncharacterized protein', 197, NULL, NULL, 173164),
(173165, '1.20.5.110-FF-000268', NULL, 'Synaptosomal-associated protein', 84, NULL, NULL, 173165),
(173166, '1.50.10.150-FF-000018', NULL, 'Uncharacterized protein', 298, NULL, NULL, 173166),
(173167, '3.10.20.30-FF-000025', NULL, 'Succinate dehydrogenase/fumarate reductase iron-sulfur subunit', 103, NULL, NULL, 173167),
(173168, '1.10.510.10-FF-002333', NULL, NULL, 205, NULL, NULL, 173168),
(173169, '1.10.1200.10-FF-000156', NULL, 'Nonribosomal peptide synthetase easA', 75, NULL, NULL, 173169),
(173170, '3.40.50.80-FF-000001', NULL, 'NADPH--cytochrome P450 reductase 1', 158, NULL, NULL, 173170),
(173171, '3.30.2140.20-FF-000013', NULL, 'Uncharacterized protein', 320, NULL, NULL, 173171),
(173172, '2.60.40.790-FF-000064', NULL, 'Protein SHQ1', 121, NULL, NULL, 173172),
(173173, '1.10.565.10-FF-000149', NULL, 'Nuclear hormone receptor family member nhr-115', 240, NULL, NULL, 173173),
(173174, '1.10.1420.10-FF-000021', NULL, 'DNA mismatch repair protein MSH2', 104, NULL, NULL, 173174),
(173175, '2.130.10.10-FF-001836', NULL, 'WD-repeat membrane protein, putative', 100, NULL, NULL, 173175),
(173176, '3.20.20.140-FF-000376', NULL, 'Ribonuclease P subunit p30, putative', 209, NULL, NULL, 173176),
(173177, '3.40.850.20-FF-000003', NULL, 'Spindle pole body-associated protein VIK1', 275, NULL, NULL, 173177),
(173178, '1.20.1280.50-FF-000070', NULL, 'F-box protein GID2', 107, NULL, NULL, 173178),
(173179, '1.25.40.540-FF-000011', NULL, 'Serine/threonine-protein phosphatase 4 regulatory subunit ppfr-4', 215, NULL, NULL, 173179),
(173180, '3.30.70.1730-FF-000053', NULL, 'Uncharacterized protein', 113, NULL, NULL, 173180),
(173181, '1.25.40.20-FF-001754', NULL, 'Uncharacterized protein', 200, NULL, NULL, 173181),
(173182, '3.40.50.620-FF-000376', NULL, 'Phosphopantetheine adenylyltransferase', 147, NULL, NULL, 173182),
(173183, '1.10.238.10-FF-000507', NULL, '45 kDa calcium-binding protein', 60, NULL, NULL, 173183),
(173184, '3.40.30.10-FF-000272', NULL, 'Calsequestrin', 121, NULL, NULL, 173184),
(173185, '1.25.10.10-FF-001586', NULL, 'Uncharacterized protein', 428, NULL, NULL, 173185),
(173186, '2.60.120.920-FF-000146', NULL, 'Butyrophilin subfamily 1 member A1', 185, NULL, NULL, 173186),
(173187, '2.30.30.490-FF-000097', NULL, 'Uncharacterized protein', 217, NULL, NULL, 173187),
(173188, '3.50.50.60-FF-001265', NULL, 'Uncharacterized protein', 90, NULL, NULL, 173188),
(173189, '1.25.40.550-FF-000014', NULL, 'A1 cistron-splicing factor', 169, NULL, NULL, 173189),
(173190, '3.30.160.60-FF-003562', NULL, 'Zinc finger protein 586', 42, NULL, NULL, 173190),
(173191, '3.30.390.60-FF-000009', NULL, 'Heat-inducible transcription repressor HrcA', 101, NULL, NULL, 173191),
(173192, '1.20.1070.10-FF-000968', NULL, 'Melanin-concentrating hormone receptor 1', 120, NULL, NULL, 173192),
(173193, '1.10.287.70-FF-000577', NULL, 'Uncharacterized protein', 131, NULL, NULL, 173193),
(173194, '3.90.70.10-FF-000165', NULL, 'Tubulointerstitial nephritis antigen-like', 316, NULL, NULL, 173194),
(173195, '1.10.268.10-FF-000009', NULL, 'Gcn5-related N-acetyltransferase', 84, NULL, NULL, 173195);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(173196, '2.60.40.10-FF-003775', NULL, NULL, 76, NULL, NULL, 173196),
(173197, '1.10.10.10-FF-001417', NULL, 'LysR family transcriptional regulator', 94, NULL, NULL, 173197),
(173198, '1.20.58.2220-FF-000040', NULL, 'Uncharacterized protein', 372, NULL, NULL, 173198),
(173199, '3.30.70.100-FF-000136', NULL, NULL, 97, NULL, NULL, 173199),
(173200, '1.10.287.850-FF-000002', NULL, 'PE family immunomodulator PE15', 97, NULL, NULL, 173200),
(173201, '2.60.40.10-FF-002022', NULL, 'Sidekick, isoform B', 92, NULL, NULL, 173201),
(173202, '1.25.10.10-FF-002997', NULL, 'Uncharacterized protein', 360, NULL, NULL, 173202),
(173203, '3.30.450.150-FF-000012', NULL, 'YALI0B05808p', 161, NULL, NULL, 173203),
(173204, '3.40.50.300-FF-005586', NULL, 'Predicted protein', 54, NULL, NULL, 173204),
(173205, '3.30.497.10-FF-000012', NULL, 'Predicted protein', 207, NULL, NULL, 173205),
(173206, '3.40.50.2300-FF-001008', NULL, NULL, 172, NULL, NULL, 173206),
(173207, '1.10.220.10-FF-000023', NULL, 'AnNEXin family', 78, NULL, NULL, 173207),
(173208, '1.20.58.1060-FF-000006', NULL, 'Predicted protein', 144, NULL, NULL, 173208),
(173209, '1.25.40.10-FF-003651', NULL, 'RNA polymerase II transcription elongation factor (Ctr9), putative (AFU_orthologue AFUA_5G05870)', 234, NULL, NULL, 173209),
(173210, '1.10.510.10-FF-000433', NULL, 'MAP kinase kinase PBS2', 208, NULL, NULL, 173210),
(173211, '2.60.60.20-FF-000008', NULL, 'Polycystic kidney disease 1-like 2, isoform CRA_a', 127, NULL, NULL, 173211),
(173212, '1.10.3290.10-FF-000004', NULL, 'Cell filamentation protein Fic', 203, NULL, NULL, 173212),
(173213, '3.30.160.60-FF-004360', NULL, NULL, 74, NULL, NULL, 173213),
(173214, '3.30.60.90-FF-000039', NULL, 'Uncharacterized protein', 53, NULL, NULL, 173214),
(173215, '3.20.20.70-FF-000391', NULL, 'Shikimate biosynthesis protein AroDE', 212, NULL, NULL, 173215),
(173216, '2.30.29.30-FF-001160', NULL, 'Rhotekin 2b', 106, NULL, NULL, 173216),
(173217, '1.20.1110.10-FF-000231', NULL, 'Calcium transporting rt-atpase', 387, NULL, NULL, 173217),
(173218, '2.60.120.10-FF-000736', NULL, 'Chromosome 10, whole genome shotgun sequence', 123, NULL, NULL, 173218),
(173219, '3.90.1480.20-FF-000013', NULL, 'ST6 N-acetylgalactosaminide alpha-2,6-sialyltransferase 1', 324, NULL, NULL, 173219),
(173220, '3.30.160.60-FF-003871', NULL, NULL, 29, NULL, NULL, 173220),
(173221, '2.130.10.10-FF-006041', NULL, 'Uncharacterized protein', 221, NULL, NULL, 173221),
(173222, '1.10.630.10-FF-000818', NULL, 'Predicted protein', 254, NULL, NULL, 173222),
(173223, '3.30.40.10-FF-000885', NULL, 'Alkylbase DNA N-glycosylase, putative', 105, NULL, NULL, 173223),
(173224, '3.30.930.10-FF-000155', NULL, 'Biotin:apoprotein ligase', 236, NULL, NULL, 173224),
(173225, '1.20.1250.20-FF-001233', NULL, 'Uncharacterized protein', 361, NULL, NULL, 173225),
(173226, '3.30.160.60-FF-003769', NULL, 'Zinc finger protein 574', 81, NULL, NULL, 173226),
(173227, '1.20.1270.220-FF-000003', NULL, 'Global transcription factor group E8', 78, NULL, NULL, 173227),
(173228, '3.20.20.80-FF-000394', NULL, 'Neopullulanase SusA', 422, NULL, NULL, 173228),
(173229, '3.40.50.2300-FF-001643', NULL, NULL, 249, NULL, NULL, 173229),
(173230, '2.130.10.10-FF-004141', NULL, 'ERCC excision repair 8, CSA ubiquitin ligase complex subunit', 181, NULL, NULL, 173230),
(173231, '3.40.50.200-FF-000031', NULL, 'Serine protease, putative', 370, NULL, NULL, 173231),
(173232, '3.30.160.60-FF-004051', NULL, NULL, 19, NULL, NULL, 173232),
(173233, '3.90.1420.10-FF-000017', NULL, 'SET domain-containing protein', 113, NULL, NULL, 173233),
(173234, '1.10.472.130-FF-000012', NULL, 'Dynein heavy chain-like protein', 144, NULL, NULL, 173234),
(173235, '3.40.50.1820-FF-000774', NULL, 'Lysophospholipase', 282, NULL, NULL, 173235),
(173236, '3.90.730.10-FF-000042', NULL, 'Ribonuclease T2', 110, NULL, NULL, 173236),
(173237, '1.10.510.10-FF-000079', NULL, 'Non-specific serine/threonine protein kinase', 184, NULL, NULL, 173237),
(173238, '1.10.20.10-FF-000260', NULL, NULL, 62, NULL, NULL, 173238),
(173239, '3.30.450.20-FF-000683', NULL, 'Guanylate cyclase', 65, NULL, NULL, 173239);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(173240, '3.40.1810.10-FF-000014', NULL, 'MADS-box transcription factor 41', 80, NULL, NULL, 173240),
(173241, '3.40.1360.10-FF-000041', NULL, 'DNA primase DnaG', 108, NULL, NULL, 173241),
(173242, '2.30.30.140-FF-000335', NULL, 'Splicing factor spf30', 71, NULL, NULL, 173242),
(173243, '3.40.980.10-FF-000004', NULL, 'Molybdopterin molybdenumtransferase', 153, NULL, NULL, 173243),
(173244, '3.30.2180.10-FF-000001', NULL, 'ATP synthase mitochondrial F1 complex assembly factor 2', 62, NULL, NULL, 173244),
(173245, '2.60.120.650-FF-000189', NULL, 'Uncharacterized protein', 80, NULL, NULL, 173245),
(173246, '2.80.10.50-FF-000209', NULL, 'Proline-tRNA ligase (DUF1680)', 134, NULL, NULL, 173246),
(173247, '1.10.287.70-FF-000706', NULL, 'Predicted protein', 181, NULL, NULL, 173247),
(173248, '2.60.120.10-FF-000427', NULL, 'CRP/FNR family transcriptional regulator, anaerobic regulatory protein', 143, NULL, NULL, 173248),
(173249, '2.60.40.10-FF-000431', NULL, 'motile sperm domain-containing protein 1', 123, NULL, NULL, 173249),
(173250, '3.30.70.330-FF-000885', NULL, 'GPI mannosyltransferase 3', 126, NULL, NULL, 173250),
(173251, '3.90.105.20-FF-000020', NULL, 'Uncharacterized protein', 30, NULL, NULL, 173251),
(173252, '3.50.4.10-FF-000021', NULL, 'Uncharacterized protein, isoform A', 80, NULL, NULL, 173252),
(173253, '3.60.40.10-FF-000390', NULL, 'Uncharacterized protein', 105, NULL, NULL, 173253),
(173254, '1.25.40.10-FF-001397', NULL, 'Peptidylprolyl isomerase', 150, NULL, NULL, 173254),
(173255, '2.160.20.10-FF-000110', NULL, 'Pectin lyase-like superfamily protein', 330, NULL, NULL, 173255),
(173256, '3.40.50.150-FF-000072', NULL, 'Ribosomal RNA small subunit methyltransferase J', 193, NULL, NULL, 173256),
(173257, '1.10.238.10-FF-000300', NULL, 'Calpain-C', 166, NULL, NULL, 173257),
(173258, '2.60.120.380-FF-000074', NULL, 'Uncharacterized protein', 98, NULL, NULL, 173258),
(173259, '1.25.10.10-FF-001895', NULL, 'Uncharacterized protein', 262, NULL, NULL, 173259),
(173260, '1.10.1520.10-FF-000085', NULL, 'Uncharacterized protein', 166, NULL, NULL, 173260),
(173261, '1.10.510.10-FF-001844', NULL, 'GD24137', 181, NULL, NULL, 173261),
(173262, '3.30.505.10-FF-000050', NULL, 'Transcription elongation factor spt6', 92, NULL, NULL, 173262),
(173263, '1.10.510.10-FF-002024', NULL, 'Uncharacterized protein', 365, NULL, NULL, 173263),
(173264, '1.10.1490.10-FF-000002', NULL, 'DNA fragmentation factor subunit alpha', 86, NULL, NULL, 173264),
(173265, '3.40.50.10190-FF-000108', NULL, 'Pescadillo homolog', 70, NULL, NULL, 173265),
(173266, '2.60.40.1910-FF-000004', NULL, 'Aminopeptidase', 82, NULL, NULL, 173266),
(173267, '3.90.550.10-FF-000314', NULL, 'Glycosyltransferase 8 domain containing 1', 286, NULL, NULL, 173267),
(173268, '2.70.130.10-FF-000156', NULL, NULL, 127, NULL, NULL, 173268),
(173269, '3.30.830.10-FF-000271', NULL, 'Predicted protein', 234, NULL, NULL, 173269),
(173270, '2.60.120.290-FF-000238', NULL, 'Uncharacterized protein', 70, NULL, NULL, 173270),
(173271, '3.40.50.150-FF-000381', NULL, 'Fibrillarin-like rRNA/tRNA 2''-O-methyltransferase', 178, NULL, NULL, 173271),
(173272, '1.20.140.100-FF-000004', NULL, 'Dynein axonemal heavy chain 6', 151, NULL, NULL, 173272),
(173273, '1.10.530.10-FF-000007', NULL, 'Endo-type membrane-bound lytic murein transglycosylase A', 186, NULL, NULL, 173273),
(173274, '3.30.70.330-FF-003038', NULL, NULL, 130, NULL, NULL, 173274),
(173275, '1.20.58.830-FF-000012', NULL, 'Erythrocyte binding antigen-140', 108, NULL, NULL, 173275),
(173276, '1.10.555.10-FF-000194', NULL, NULL, 182, NULL, NULL, 173276),
(173277, '1.20.1250.20-FF-000744', NULL, 'MFS transporter', 185, NULL, NULL, 173277),
(173278, '3.30.70.1070-FF-000017', NULL, 'Type I secretion outer membrane protein', 96, NULL, NULL, 173278),
(173279, '1.10.10.790-FF-000034', NULL, NULL, 101, NULL, NULL, 173279),
(173280, '3.30.2410.10-FF-000020', NULL, 'E3 ubiquitin-protein ligase UPL5', 116, NULL, NULL, 173280),
(173281, '3.30.830.10-FF-000063', NULL, 'Zinc protease', 188, NULL, NULL, 173281),
(173282, '1.25.40.10-FF-003325', NULL, 'TPR repeat, putative', 102, NULL, NULL, 173282);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(173283, '6.10.140.2220-FF-000037', NULL, 'Methionine aminopeptidase', 60, NULL, NULL, 173283),
(173284, '2.60.40.10-FF-003983', NULL, NULL, 101, NULL, NULL, 173284),
(173285, '3.20.20.80-FF-000259', NULL, 'GLB1 isoform 3', 60, NULL, NULL, 173285),
(173286, '2.60.40.10-FF-004601', NULL, NULL, 99, NULL, NULL, 173286),
(173287, '2.60.120.10-FF-000074', NULL, 'Potassium channel KAT2', 137, NULL, NULL, 173287),
(173288, '3.30.160.60-FF-004034', NULL, NULL, 31, NULL, NULL, 173288),
(173289, '3.30.200.20-FF-001463', NULL, 'Kinase, NEK', 98, NULL, NULL, 173289),
(173290, '3.40.50.12160-FF-000036', NULL, 'Ribosomal protein S12 methylthiotransferase RimO', 117, NULL, NULL, 173290),
(173291, '2.10.70.10-FF-000047', NULL, 'CUB and Sushi multiple domains 3', 63, NULL, NULL, 173291),
(173292, '3.30.70.1620-FF-000019', NULL, 'Mitotic chromosome and X-chromosome-associated protein mix-1', 98, NULL, NULL, 173292),
(173293, '3.30.460.10-FF-000164', NULL, 'Bifunctional uridylyltransferase/uridylyl-removing enzyme', 143, NULL, NULL, 173293),
(173294, '3.10.250.10-FF-000107', NULL, NULL, 137, NULL, NULL, 173294),
(173295, '3.40.50.2300-FF-001216', NULL, NULL, 19, NULL, NULL, 173295),
(173296, '1.20.1560.10-FF-000725', NULL, 'Uncharacterized protein', 232, NULL, NULL, 173296),
(173297, '3.40.50.2020-FF-000137', NULL, 'Ribose-phosphate pyrophosphokinase', 142, NULL, NULL, 173297),
(173298, '3.80.10.10-FF-003023', NULL, 'AGAP011930-PA', 146, NULL, NULL, 173298),
(173299, '3.30.70.980-FF-000012', NULL, 'Probable transcriptional regulatory protein WHON_01306', 83, NULL, NULL, 173299),
(173300, '1.10.555.10-FF-000222', NULL, NULL, 181, NULL, NULL, 173300),
(173301, '2.80.10.50-FF-000226', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 136, NULL, NULL, 173301),
(173302, '3.10.290.10-FF-000071', NULL, 'Uncharacterized protein', 99, NULL, NULL, 173302),
(173303, '2.90.10.10-FF-000023', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', 106, NULL, NULL, 173303),
(173304, '1.10.510.10-FF-000225', NULL, 'calcium-dependent protein kinase 28-like', 194, NULL, NULL, 173304),
(173305, '4.10.410.10-FF-000077', NULL, 'AGAP012307-PA', 62, NULL, NULL, 173305),
(173306, '3.60.40.10-FF-000373', NULL, 'SigmaB regulation protein RsbU, putative', 248, NULL, NULL, 173306),
(173307, '2.10.25.10-FF-000960', NULL, 'Delta-like protein', 46, NULL, NULL, 173307),
(173308, '3.30.710.10-FF-000392', NULL, 'Protein CBG04368', 167, NULL, NULL, 173308),
(173309, '1.10.565.10-FF-000150', NULL, 'Protein CBG20720', 238, NULL, NULL, 173309),
(173310, '3.40.30.10-FF-000833', NULL, 'Uncharacterized protein', 118, NULL, NULL, 173310),
(173311, '3.40.50.300-FF-001679', NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', 138, NULL, NULL, 173311),
(173312, '3.30.1490.20-FF-000078', NULL, 'Succinate--CoA ligase', 74, NULL, NULL, 173312),
(173313, '3.40.630.30-FF-000484', NULL, 'Uncharacterized protein', 216, NULL, NULL, 173313),
(173314, '3.20.20.70-FF-000256', NULL, 'Uncharacterized protein', 211, NULL, NULL, 173314),
(173315, '3.70.10.10-FF-000027', NULL, 'Unplaced genomic scaffold supercont2.10, whole genome shotgun sequence', 331, NULL, NULL, 173315),
(173316, '3.40.50.620-FF-000100', NULL, 'probable leucine--tRNA ligase, mitochondrial', 193, NULL, NULL, 173316),
(173317, '1.10.10.10-FF-001625', NULL, 'Putative DNA-binding protein', 100, NULL, NULL, 173317),
(173318, '1.10.510.10-FF-001861', NULL, 'Hormonally up-regulated neu tumor-associated kinase-like Protein', 321, NULL, NULL, 173318),
(173319, '3.30.70.2190-FF-000016', NULL, 'Bll6224 protein', 127, NULL, NULL, 173319),
(173320, '1.10.8.60-FF-000341', NULL, 'ATP-dependent Zn protease', 48, NULL, NULL, 173320),
(173321, '1.10.3730.20-FF-000025', NULL, 'EamA/RhaT family transporter', 135, NULL, NULL, 173321),
(173322, '3.90.215.10-FF-000019', NULL, 'Angiopoietin-like 4', 227, NULL, NULL, 173322),
(173323, '2.30.30.40-FF-000513', NULL, 'Uncharacterized protein', 48, NULL, NULL, 173323),
(173324, '3.15.10.10-FF-000008', NULL, 'BPI fold containing family B member 1', 191, NULL, NULL, 173324);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(173325, '3.30.160.60-FF-000190', NULL, 'C2H2 finger domain protein', 28, NULL, NULL, 173325),
(173326, '3.40.50.300-FF-008227', NULL, 'Probable disease resistance protein At5g47260', 62, NULL, NULL, 173326),
(173327, '1.20.1250.20-FF-000699', NULL, 'MFS transporter, putative', 198, NULL, NULL, 173327),
(173328, '3.30.70.1730-FF-000036', NULL, 'Ribosomal protein L10', 144, NULL, NULL, 173328),
(173329, '3.30.9.10-FF-000251', NULL, 'Predicted protein', 165, NULL, NULL, 173329),
(173330, '4.10.1000.10-FF-000094', NULL, 'Zinc finger CCCH domain-containing protein 34 isoform A', 62, NULL, NULL, 173330),
(173331, '2.130.10.10-FF-003635', NULL, 'Uncharacterized protein', 53, NULL, NULL, 173331),
(173332, '2.40.10.10-FF-000205', NULL, 'Lysyl endopeptidase', 123, NULL, NULL, 173332),
(173333, '3.80.10.10-FF-000752', NULL, 'Tubulin-folding cofactor E', 135, NULL, NULL, 173333),
(173334, '1.10.560.10-FF-000161', NULL, 'T-complex protein 1 subunitTheta, putative', 85, NULL, NULL, 173334),
(173335, '1.10.8.60-FF-000442', NULL, 'Uncharacterized protein', 68, NULL, NULL, 173335),
(173336, '3.60.21.10-FF-000042', NULL, 'Serine/threonine-protein phosphatase with EF-hands', 264, NULL, NULL, 173336),
(173337, '3.20.20.105-FF-000016', NULL, 'Queuine tRNA-ribosyltransferase', 382, NULL, NULL, 173337),
(173338, '2.40.70.10-FF-000422', NULL, NULL, 104, NULL, NULL, 173338),
(173339, '3.40.50.300-FF-006092', NULL, 'Branched-chain amino acid ABC transporter, ATP-binding protein', 258, NULL, NULL, 173339),
(173340, '3.60.21.50-FF-000003', NULL, 'DNA polymerase II small subunit', 277, NULL, NULL, 173340),
(173341, '3.40.50.2300-FF-000699', NULL, 'Two-component response regulator', 131, NULL, NULL, 173341),
(173342, '3.30.60.30-FF-000206', NULL, 'Predicted protein', 45, NULL, NULL, 173342),
(173343, '1.10.390.10-FF-000092', NULL, 'Uncharacterized protein', 181, NULL, NULL, 173343),
(173344, '2.60.40.10-FF-006046', NULL, NULL, 94, NULL, NULL, 173344),
(173345, '2.30.180.10-FF-000073', NULL, 'Stabilin 2', 132, NULL, NULL, 173345),
(173346, '3.40.50.2300-FF-001317', NULL, NULL, 106, NULL, NULL, 173346),
(173347, '2.40.440.10-FF-000001', NULL, 'L,D-transpeptidase YbiS', 141, NULL, NULL, 173347),
(173348, '3.30.70.590-FF-000018', NULL, 'Uncharacterized protein', 140, NULL, NULL, 173348),
(173349, '2.10.60.10-FF-000075', NULL, 'Receptor protein serine/threonine kinase', 72, NULL, NULL, 173349),
(173350, '3.30.559.10-FF-000258', NULL, 'Predicted protein', 207, NULL, NULL, 173350),
(173351, '3.30.30.170-FF-000003', NULL, 'Translation initiation factor 2 subunit beta', 135, NULL, NULL, 173351),
(173352, '2.60.40.10-FF-005692', NULL, NULL, 73, NULL, NULL, 173352),
(173353, '1.10.287.110-FF-000117', NULL, 'Putative DnaJ protein', 111, NULL, NULL, 173353),
(173354, '3.30.160.60-FF-000234', NULL, 'GLIS family zinc finger 3', 31, NULL, NULL, 173354),
(173355, '2.60.120.260-FF-000021', NULL, 'Beta-galactosidase', 135, NULL, NULL, 173355),
(173356, '3.30.450.20-FF-000239', NULL, 'Sensory box/GGDEF family protein', 127, NULL, NULL, 173356),
(173357, '1.10.10.60-FF-001281', NULL, NULL, 64, NULL, NULL, 173357),
(173358, '3.40.50.1100-FF-000018', NULL, 'D-serine dehydratase', 123, NULL, NULL, 173358),
(173359, '3.30.530.20-FF-000127', NULL, 'Phosphatidylinositol transfer protein alpha isoform', 145, NULL, NULL, 173359),
(173360, '3.30.70.330-FF-001610', NULL, NULL, 100, NULL, NULL, 173360),
(173361, '3.30.200.20-FF-001036', NULL, 'Uncharacterized protein, isoform C', 134, NULL, NULL, 173361),
(173362, '1.25.40.20-FF-000091', NULL, 'NF-kappa-B inhibitor delta', 250, NULL, NULL, 173362),
(173363, '2.130.10.10-FF-002325', NULL, 'Eukaryotic translation initiation factor 2A', 183, NULL, NULL, 173363),
(173364, '2.130.10.10-FF-001292', NULL, 'Periodic tryptophan protein 2 homolog', 226, NULL, NULL, 173364),
(173365, '3.30.160.60-FF-001971', NULL, 'zinc finger and SCAN domain-containing protein 20 isoform X1', 32, NULL, NULL, 173365),
(173366, '3.10.250.10-FF-000006', NULL, 'neurotrypsin isoform X2', 107, NULL, NULL, 173366),
(173367, '1.20.5.1930-FF-000008', NULL, 'Sensor protein UhpB', 92, NULL, NULL, 173367);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(173368, '3.30.30.30-FF-000025', NULL, 'Uncharacterized protein', 47, NULL, NULL, 173368),
(173369, '1.10.630.10-FF-000291', NULL, 'Cytochrome P450 monooxygenase asqL', 431, NULL, NULL, 173369),
(173370, '3.20.20.120-FF-000011', NULL, 'D-galactonate dehydratase family member VSWAT3_13707', 253, NULL, NULL, 173370),
(173371, '2.30.29.30-FF-001159', NULL, 'Protein CBR-UNC-34', 106, NULL, NULL, 173371),
(173372, '3.40.50.300-FF-003832', NULL, 'WGS project CABT00000000 data, contig 2.20', 84, NULL, NULL, 173372),
(173373, '2.170.270.10-FF-000125', NULL, 'Histone-lysine N-methyltransferase', 230, NULL, NULL, 173373),
(173374, '2.130.10.10-FF-005759', NULL, 'Glr0823 protein', 115, NULL, NULL, 173374),
(173375, '1.10.287.950-FF-000032', NULL, 'Methyl-accepting chemotaxis protein', 289, NULL, NULL, 173375),
(173376, '1.10.10.10-FF-000799', NULL, 'Crossover junction endonuclease MUS81', 108, NULL, NULL, 173376),
(173377, '3.90.550.10-FF-000522', NULL, 'UDP-N-acetylglucosamine pyrophosphorylase', 363, NULL, NULL, 173377),
(173378, '3.60.21.60-FF-000006', NULL, 'DNA polymerase epsilon subunit', 217, NULL, NULL, 173378),
(173379, '3.50.50.60-FF-000759', NULL, 'AIFM3 isoform 8', 80, NULL, NULL, 173379),
(173380, '1.50.40.10-FF-000259', NULL, 'Solute carrier family 25 member 13', 164, NULL, NULL, 173380),
(173381, '1.25.10.10-FF-000260', NULL, 'Coatomer subunit beta', 482, NULL, NULL, 173381),
(173382, '3.10.450.10-FF-000061', NULL, 'Uncharacterized protein', 120, NULL, NULL, 173382),
(173383, '1.10.510.10-FF-003659', NULL, NULL, 181, NULL, NULL, 173383),
(173384, '2.130.10.10-FF-003326', NULL, 'WD40-repeat-containing domain protein', 106, NULL, NULL, 173384),
(173385, '1.20.920.10-FF-000119', NULL, 'SNF2-family ATP dependent chromatin remodeling factor snf21', 137, NULL, NULL, 173385),
(173386, '3.90.226.10-FF-000033', NULL, 'Protease 4', 165, NULL, NULL, 173386),
(173387, '3.40.50.300-FF-002505', NULL, 'Probable conserved ATP-binding protein ABC transporter', 242, NULL, NULL, 173387),
(173388, '1.50.40.10-FF-000153', NULL, 'Transporter, putative', 156, NULL, NULL, 173388),
(173389, '3.90.740.10-FF-000014', NULL, 'valine--tRNA ligase, mitochondrial', 70, NULL, NULL, 173389),
(173390, '1.20.990.10-FF-000056', NULL, 'Uncharacterized protein', 54, NULL, NULL, 173390),
(173391, '3.40.50.300-FF-001887', NULL, 'Midasin', 209, NULL, NULL, 173391),
(173392, '2.40.30.10-FF-000105', NULL, 'NADH-cytochrome b5 reductase', 105, NULL, NULL, 173392),
(173393, '3.80.10.10-FF-002197', NULL, 'ADP-ribosylation factor-related', 242, NULL, NULL, 173393),
(173394, '4.10.970.10-FF-000001', NULL, 'X-ray repair cross-complementing protein 6 isoform X1', 63, NULL, NULL, 173394),
(173395, '1.10.1370.30-FF-000016', NULL, 'Angiotensin-converting enzyme', 452, NULL, NULL, 173395),
(173396, '3.30.420.10-FF-000408', NULL, NULL, 182, NULL, NULL, 173396),
(173397, '2.40.40.20-FF-000036', NULL, 'DNA-directed RNA polymerase subunit', 42, NULL, NULL, 173397),
(173398, '3.30.1180.10-FF-000001', NULL, 'DegV domain-containing protein Mb2440c', 128, NULL, NULL, 173398),
(173399, '2.60.120.970-FF-000037', NULL, 'Bone morphogenetic protein 10', 227, NULL, NULL, 173399),
(173400, '2.60.40.150-FF-000030', NULL, 'Phospholipase A2', 121, NULL, NULL, 173400),
(173401, '1.10.150.50-FF-000097', NULL, 'Chromosome 19 C19orf47 homolog', 48, NULL, NULL, 173401),
(173402, '3.90.1200.10-FF-000018', NULL, 'Fructosamine-3-kinase, putative', 222, NULL, NULL, 173402),
(173403, '1.20.58.60-FF-000816', NULL, 'Uncharacterized protein', 185, NULL, NULL, 173403),
(173404, '2.40.128.150-FF-000003', NULL, 'Arylamine N-acetyltransferase', 99, NULL, NULL, 173404),
(173405, '1.25.10.10-FF-002620', NULL, 'Uncharacterized protein', 131, NULL, NULL, 173405),
(173406, '3.30.160.60-FF-005877', NULL, NULL, 42, NULL, NULL, 173406),
(173407, '3.30.2320.80-FF-000005', NULL, 'Hydrogenase maturation factor HypA', 113, NULL, NULL, 173407),
(173408, '3.40.630.30-FF-000276', NULL, 'Acetyltransferase, putative', 144, NULL, NULL, 173408),
(173409, '3.30.1180.20-FF-000004', NULL, 'Probable dihydroxyacetone kinase', 151, NULL, NULL, 173409);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(173410, '1.25.40.20-FF-000343', NULL, 'Prosap, isoform C', 136, NULL, NULL, 173410),
(173411, '1.10.8.60-FF-000133', NULL, 'AAA family ATPase', 88, NULL, NULL, 173411),
(173412, '3.30.230.130-FF-000024', NULL, 'Cullin family protein', 129, NULL, NULL, 173412),
(173413, '1.10.287.2610-FF-000003', NULL, 'Dynein heavy chain 9', 164, NULL, NULL, 173413),
(173414, '1.50.40.10-FF-000052', NULL, 'Solute carrier family 25 member 16', 302, NULL, NULL, 173414),
(173415, '3.40.50.300-FF-007873', NULL, 'Uncharacterized protein', 206, NULL, NULL, 173415),
(173416, '3.30.200.20-FF-001800', NULL, 'Serine/threonine-protein kinase NEK', 90, NULL, NULL, 173416),
(173417, '1.25.40.10-FF-001942', NULL, 'Transcription factor BIM2', 113, NULL, NULL, 173417),
(173418, '2.40.290.10-FF-000040', NULL, 'Uncharacterized protein', 103, NULL, NULL, 173418),
(173419, '3.40.50.300-FF-001578', NULL, 'Multidrug resistance protein', 217, NULL, NULL, 173419),
(173420, '2.60.390.10-FF-000003', NULL, 'Putative secreted beta-galactosidase', 74, NULL, NULL, 173420),
(173421, '2.10.70.10-FF-000148', NULL, 'Neurogenic locus notch, putative', 67, NULL, NULL, 173421),
(173422, '1.10.287.110-FF-000016', NULL, 'DnaJ (Hsp40) homolog, subfamily A, member 2', 100, NULL, NULL, 173422),
(173423, '1.10.530.10-FF-000081', NULL, 'Acidic endochitinase WIN6.2C', 48, NULL, NULL, 173423),
(173424, '2.130.10.10-FF-000201', NULL, 'WD and tetratricopeptide repeats protein 1', 110, NULL, NULL, 173424),
(173425, '3.40.1350.10-FF-000012', NULL, 'Probable tRNA-splicing endonuclease subunit sen-15', 156, NULL, NULL, 173425),
(173426, '3.30.1120.10-FF-000025', NULL, 'Putative arylsulfatase', 61, NULL, NULL, 173426),
(173427, '3.30.70.330-FF-003055', NULL, NULL, 109, NULL, NULL, 173427),
(173428, '2.60.40.10-FF-004500', NULL, NULL, 185, NULL, NULL, 173428),
(173429, '1.10.10.2670-FF-000008', NULL, 'Related to ubiquitin-protein ligase e3 component', 97, NULL, NULL, 173429),
(173430, '1.10.520.10-FF-000035', NULL, 'L-ascorbate peroxidase, cytosolic', 63, NULL, NULL, 173430),
(173431, '3.80.10.10-FF-002876', NULL, 'Uncharacterized protein', 79, NULL, NULL, 173431),
(173432, '3.40.50.150-FF-001819', NULL, NULL, 92, NULL, NULL, 173432),
(173433, '1.10.10.1100-FF-000015', NULL, 'Bacterioferritin', 59, NULL, NULL, 173433),
(173434, '2.60.120.1440-FF-000021', NULL, 'FpvR', 134, NULL, NULL, 173434),
(173435, '2.60.120.330-FF-000166', NULL, 'Sexual differentiation process protein isp7', 326, NULL, NULL, 173435),
(173436, '3.40.50.10240-FF-000039', NULL, 'Uncharacterized protein', 114, NULL, NULL, 173436),
(173437, '2.40.70.10-FF-000214', NULL, 'Pepsin-type aspartyl protease', 192, NULL, NULL, 173437),
(173438, '3.40.50.300-FF-005378', NULL, 'Guanine nucleotide-binding protein alpha-4 subunit', 174, NULL, NULL, 173438),
(173439, '2.40.30.290-FF-000001', NULL, 'Distal tail protein', 87, NULL, NULL, 173439),
(173440, '1.20.120.850-FF-000028', NULL, 'Predicted protein', 75, NULL, NULL, 173440),
(173441, '1.20.58.390-FF-000323', NULL, 'Ligand-Gated ion Channel', 49, NULL, NULL, 173441),
(173442, '3.40.1190.20-FF-000227', NULL, NULL, 144, NULL, NULL, 173442),
(173443, '1.20.1560.10-FF-000388', NULL, 'Transport protein', 312, NULL, NULL, 173443),
(173444, '1.10.510.10-FF-000534', NULL, 'Serine/threonine-protein kinase PKH2', 194, NULL, NULL, 173444),
(173445, '3.90.70.10-FF-000182', NULL, 'Ubiquitin carboxyl-terminal hydrolase 37', 205, NULL, NULL, 173445),
(173446, '3.90.810.10-FF-000026', NULL, 'Non-specific serine/threonine protein kinase', 76, NULL, NULL, 173446),
(173447, '3.10.20.90-FF-000453', NULL, 'CBN-UNC-112 protein', 77, NULL, NULL, 173447),
(173448, '2.40.10.10-FF-000093', NULL, 'Mannan-binding lectin serine protease 2', 101, NULL, NULL, 173448),
(173449, '2.10.50.10-FF-000147', NULL, 'Tumor necrosis factor receptor superfamily member 8', 43, NULL, NULL, 173449),
(173450, '1.10.1510.30-FF-000005', NULL, 'tRNA pseudouridine synthase D', 88, NULL, NULL, 173450),
(173451, '3.10.270.10-FF-000007', NULL, 'Uncharacterized protein', 99, NULL, NULL, 173451),
(173452, '3.40.50.410-FF-000167', NULL, 'Collagen, type VI, alpha 1', 41, NULL, NULL, 173452);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(173453, '1.25.10.10-FF-003385', NULL, 'Condensin-2 complex subunit D3', 373, NULL, NULL, 173453),
(173454, '3.30.70.330-FF-001711', NULL, NULL, 125, NULL, NULL, 173454),
(173455, '1.10.287.110-FF-000325', NULL, 'Chaperone protein DNAJ, putative', 91, NULL, NULL, 173455),
(173456, '2.30.140.10-FF-000008', NULL, 'spermine synthase isoform X2', 56, NULL, NULL, 173456),
(173457, '1.50.10.10-FF-000179', NULL, 'alpha-1,2-Mannosidase', 377, NULL, NULL, 173457),
(173458, '1.10.472.10-FF-000006', NULL, 'Cyclin I', 112, NULL, NULL, 173458),
(173459, '2.10.25.10-FF-000651', NULL, 'neurogenic locus notch homolog protein 4 isoform X1', 42, NULL, NULL, 173459),
(173460, '3.30.420.510-FF-000024', NULL, 'Fumble family protein', 86, NULL, NULL, 173460),
(173461, '3.40.50.150-FF-000616', NULL, 'DUF890 domain protein (AFU_orthologue AFUA_7G05590)', 267, NULL, NULL, 173461),
(173462, '2.60.120.200-FF-000739', NULL, 'Uncharacterized protein', 171, NULL, NULL, 173462),
(173463, '3.30.457.60-FF-000002', NULL, 'Mitotic spindle assembly checkpoint protein MAD1', 81, NULL, NULL, 173463),
(173464, '3.30.40.10-FF-001239', NULL, 'XIAP associated factor 1', 55, NULL, NULL, 173464),
(173465, '1.20.1740.10-FF-000245', NULL, 'Predicted protein', 336, NULL, NULL, 173465),
(173466, '1.20.1250.20-FF-001087', NULL, 'MFS multidrug transporter, putative', 288, NULL, NULL, 173466),
(173467, '1.10.510.10-FF-000107', NULL, 'kinase suppressor of Ras 1', 189, NULL, NULL, 173467),
(173468, '1.10.3080.10-FF-000067', NULL, 'Putative eukaryotic translation initiation factor 3E subunit family protein', 188, NULL, NULL, 173468),
(173469, '3.30.160.60-FF-002252', NULL, 'Uncharacterized protein', 28, NULL, NULL, 173469),
(173470, '1.25.40.10-FF-003634', NULL, 'Pentatricopeptide repeat-containing protein At2g39620', 81, NULL, NULL, 173470),
(173471, '3.40.50.150-FF-000100', NULL, 'Methyltransferase', 278, NULL, NULL, 173471),
(173472, '1.10.20.10-FF-000125', NULL, 'Transcription initiation factor TFIID subunit 9', 68, NULL, NULL, 173472),
(173473, '1.20.1070.10-FF-000867', NULL, 'CholecystoKinin Receptor homolog', 299, NULL, NULL, 173473),
(173474, '3.30.40.10-FF-000986', NULL, 'Uncharacterized protein', 84, NULL, NULL, 173474),
(173475, '1.10.720.30-FF-000056', NULL, 'Uncharacterized protein', 47, NULL, NULL, 173475),
(173476, '2.60.40.10-FF-000094', NULL, 'Kirre like nephrin family adhesion molecule 3', 100, NULL, NULL, 173476),
(173477, '1.20.120.1900-FF-000024', NULL, 'Gamma-tubulin complex component', 219, NULL, NULL, 173477),
(173478, '1.20.58.2220-FF-000039', NULL, 'Formin B', 397, NULL, NULL, 173478),
(173479, '3.40.50.300-FF-005069', NULL, 'ADP ribosylation factor like GTPase 8B', 119, NULL, NULL, 173479),
(173480, '2.80.10.50-FF-000120', NULL, 'Glucan 13-beta-glucosidase', 123, NULL, NULL, 173480),
(173481, '3.40.1110.10-FF-000247', NULL, NULL, 125, NULL, NULL, 173481),
(173482, '1.20.120.1910-FF-000027', NULL, 'AGAP011821-PA', 193, NULL, NULL, 173482),
(173483, '1.10.150.50-FF-000142', NULL, 'Uncharacterized protein', 70, NULL, NULL, 173483),
(173484, '2.20.25.10-FF-000111', NULL, 'Predicted protein', 37, NULL, NULL, 173484),
(173485, '3.30.40.10-FF-002358', NULL, 'Uncharacterized protein', 99, NULL, NULL, 173485),
(173486, '3.40.50.1700-FF-000058', NULL, 'Uncharacterized protein', 94, NULL, NULL, 173486),
(173487, '3.40.50.2060-FF-000025', NULL, NULL, 138, NULL, NULL, 173487),
(173488, '3.90.76.10-FF-000015', NULL, 'Peptide ABC transporter, periplasmic peptide-binding protein', 107, NULL, NULL, 173488),
(173489, '3.40.30.10-FF-000480', NULL, 'GLutaRedoXin', 104, NULL, NULL, 173489),
(173490, '1.20.120.140-FF-000012', NULL, 'Unplaced genomic scaffold supercont1.35, whole genome shotgun sequence', 113, NULL, NULL, 173490),
(173491, '1.10.10.10-FF-001934', NULL, 'Uncharacterized protein', 89, NULL, NULL, 173491),
(173492, '3.40.50.1240-FF-000021', NULL, 'Acid phosphatase', 371, NULL, NULL, 173492),
(173493, '1.10.3720.10-FF-000212', NULL, 'Oligopeptide ABC transporter, permease protein', 207, NULL, NULL, 173493),
(173494, '3.30.70.100-FF-000035', NULL, 'Heavy metal-associated isoprenylated plant protein 26', 76, NULL, NULL, 173494);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(173495, '1.25.40.20-FF-000309', NULL, 'No mechanoreceptor potential C, isoform D', 138, NULL, NULL, 173495),
(173496, '2.130.10.10-FF-001499', NULL, 'WD domain, G-beta repeat-containing protein', 304, NULL, NULL, 173496),
(173497, '1.20.1250.20-FF-000935', NULL, 'Uncharacterized protein', 187, NULL, NULL, 173497),
(173498, '3.40.50.150-FF-001499', NULL, NULL, 114, NULL, NULL, 173498),
(173499, '3.20.20.10-FF-000036', NULL, 'Alanine racemase', 213, NULL, NULL, 173499),
(173500, '3.30.70.590-FF-000002', NULL, 'Nuclear poly(A) polymerase 4', 117, NULL, NULL, 173500),
(173501, '2.40.40.20-FF-000070', NULL, 'NADH-quinone oxidoreductase', 94, NULL, NULL, 173501),
(173502, '3.40.50.300-FF-007839', NULL, 'Uncharacterized protein', 234, NULL, NULL, 173502),
(173503, '1.20.1110.10-FF-000085', NULL, 'Uncharacterized protein', 155, NULL, NULL, 173503),
(173504, '1.10.510.10-FF-001198', NULL, 'NIMA related kinase 11', 289, NULL, NULL, 173504),
(173505, '1.20.1560.10-FF-000843', NULL, 'FI20190p1', 404, NULL, NULL, 173505),
(173506, '2.30.30.140-FF-000234', NULL, 'Hydrolase', 75, NULL, NULL, 173506),
(173507, '1.25.10.10-FF-002412', NULL, 'Uncharacterized protein', 252, NULL, NULL, 173507),
(173508, '3.30.505.10-FF-000049', NULL, 'Suppressor of cytokine signaling 2', 128, NULL, NULL, 173508),
(173509, '1.20.144.10-FF-000113', NULL, 'Uncharacterized protein', 218, NULL, NULL, 173509),
(173510, '3.40.50.740-FF-000035', NULL, 'Molybdopterin oxidoreductase Fe4S4 region', 132, NULL, NULL, 173510),
(173511, '1.20.1560.10-FF-000489', NULL, 'Uncharacterized protein', 298, NULL, NULL, 173511),
(173512, '3.30.200.20-FF-001345', NULL, 'Putative tyrosine-protein kinase Wsck-like Protein', 114, NULL, NULL, 173512),
(173513, '1.20.120.160-FF-000018', NULL, 'Sensory box sensor histidine kinase/response regulator', 112, NULL, NULL, 173513),
(173514, '1.10.8.710-FF-000012', NULL, 'Glutathione S-transferase class-mu 26 kDa isozyme', 107, NULL, NULL, 173514),
(173515, '1.10.630.10-FF-000498', NULL, 'Sterol 14 desaturase', 453, NULL, NULL, 173515),
(173516, '3.40.50.1260-FF-000027', NULL, 'Phosphoglycerate kinase A', 130, NULL, NULL, 173516),
(173517, '1.25.40.10-FF-000306', NULL, 'Cell cycle control protein cwf4', 201, NULL, NULL, 173517),
(173518, '1.20.120.1200-FF-000011', NULL, 'NADH-quinone oxidoreductase subunit J', 164, NULL, NULL, 173518),
(173519, '2.130.10.10-FF-001853', NULL, 'Zinc finger CCCH domain-containing protein 17', 151, NULL, NULL, 173519),
(173520, '3.30.450.20-FF-000548', NULL, 'PAS sensor protein', 104, NULL, NULL, 173520),
(173521, '1.10.10.440-FF-000058', NULL, 'Pre-mRNA-processing protein 40C', 74, NULL, NULL, 173521),
(173522, '3.30.420.10-FF-000397', NULL, 'Transposase', 229, NULL, NULL, 173522),
(173523, '2.60.40.10-FF-000195', NULL, 'Fibronectin type III domain containing 3A', 98, NULL, NULL, 173523),
(173524, '3.30.200.20-FF-001816', NULL, 'Protein NSP-INTERACTING KINASE 1', 68, NULL, NULL, 173524),
(173525, '3.40.50.410-FF-000285', NULL, 'Integrin beta', 28, NULL, NULL, 173525),
(173526, '3.30.450.20-FF-000649', NULL, 'PAS sensor protein', 123, NULL, NULL, 173526),
(173527, '3.40.33.10-FF-000194', NULL, 'Uncharacterized protein', 83, NULL, NULL, 173527),
(173528, '1.20.1250.40-FF-000019', NULL, 'Related to Rpb4-16 kD subunit of DNA-directed RNA polymerase II', 157, NULL, NULL, 173528),
(173529, '2.60.40.10-FF-005574', NULL, NULL, 49, NULL, NULL, 173529),
(173530, '3.40.1110.10-FF-000348', NULL, NULL, 35, NULL, NULL, 173530),
(173531, '3.10.20.90-FF-000245', NULL, 'Small ubiquitin-related modifier', 72, NULL, NULL, 173531),
(173532, '3.30.565.10-FF-000311', NULL, 'Protein CBG23571', 193, NULL, NULL, 173532),
(173533, '2.170.270.10-FF-000007', NULL, 'PR domain zinc finger protein 10', 167, NULL, NULL, 173533),
(173534, '3.40.50.1820-FF-000566', NULL, 'CHO cell elongating factor', 193, NULL, NULL, 173534),
(173535, '3.40.50.10330-FF-000066', NULL, 'NAD kinase 2', 99, NULL, NULL, 173535),
(173536, '3.40.50.10190-FF-000209', NULL, 'DNA-directed DNA/RNA polymerase mu', 98, NULL, NULL, 173536),
(173537, '2.30.110.10-FF-000052', NULL, 'Flavin reductase (DIM6/NTAB) family NADH-FMN oxidoreductase RutF', 166, NULL, NULL, 173537);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(173538, '1.25.10.10-FF-002311', NULL, 'Uncharacterized protein', 316, NULL, NULL, 173538),
(173539, '1.25.40.1040-FF-000057', NULL, 'TPR Domain containing protein', 204, NULL, NULL, 173539),
(173540, '3.40.50.1010-FF-000082', NULL, 'Ribonuclease VapC', 130, NULL, NULL, 173540),
(173541, '2.160.20.70-FF-000004', NULL, 'Protein XRP2', 193, NULL, NULL, 173541),
(173542, '1.20.1250.20-FF-000845', NULL, 'Putative Sugar transporter', 481, NULL, NULL, 173542),
(173543, '1.25.40.1030-FF-000054', NULL, 'Uncharacterized protein', 380, NULL, NULL, 173543),
(173544, '1.20.120.1220-FF-000017', NULL, NULL, 164, NULL, NULL, 173544),
(173545, '3.30.300.160-FF-000022', NULL, 'PilB/PulE/GspE family ATPase', 80, NULL, NULL, 173545),
(173546, '3.80.10.10-FF-000297', NULL, 'Leucine-rich repeat receptor-like protein kinase PXL1', 263, NULL, NULL, 173546),
(173547, '3.80.10.10-FF-002758', NULL, 'Peroxidasin', 117, NULL, NULL, 173547),
(173548, '3.80.10.10-FF-000858', NULL, 'Mhp1p', 407, NULL, NULL, 173548),
(173549, '3.90.550.10-FF-000213', NULL, 'Blast:Beta-1,4-N-acetylgalactosaminyltransferase bre-4', 277, NULL, NULL, 173549),
(173550, '3.30.360.10-FF-000100', NULL, '4-hydroxy-tetrahydrodipicolinate reductase', 106, NULL, NULL, 173550),
(173551, '2.60.40.10-FF-002140', NULL, 'Titin homolog', 109, NULL, NULL, 173551),
(173552, '3.40.190.10-FF-000101', NULL, 'Porphobilinogen deaminase, chloroplastic', 100, NULL, NULL, 173552),
(173553, '3.90.230.10-FF-000032', NULL, 'Proliferation-associated protein 2G4, putative', 249, NULL, NULL, 173553),
(173554, '3.40.50.2000-FF-001008', NULL, 'UDP-glucose,sterol transferase', 246, NULL, NULL, 173554),
(173555, '1.20.58.80-FF-000081', NULL, 'Uncharacterized protein', 142, NULL, NULL, 173555),
(173556, '1.50.40.10-FF-000462', NULL, 'Uncharacterized protein', 90, NULL, NULL, 173556),
(173557, '3.30.70.890-FF-000075', NULL, 'Galactokinase 1', 47, NULL, NULL, 173557),
(173558, '3.40.1000.70-FF-000004', NULL, 'Transmembrane serine/threonine-protein kinase PknJ', 196, NULL, NULL, 173558),
(173559, '2.160.20.80-FF-000007', NULL, 'SPI-2 type III secretion system effector PipB', 131, NULL, NULL, 173559),
(173560, '3.30.160.60-FF-000543', NULL, 'Zinc finger protein 384 like', 31, NULL, NULL, 173560),
(173561, '3.10.20.310-FF-000014', NULL, 'Outer envelope protein 80, chloroplastic', 79, NULL, NULL, 173561),
(173562, '3.90.79.10-FF-000140', NULL, 'Uncharacterized protein', 170, NULL, NULL, 173562),
(173563, '3.30.70.1620-FF-000003', NULL, 'Structural maintenance of chromosomes 4', 86, NULL, NULL, 173563),
(173564, '3.80.10.10-FF-002096', NULL, 'Predicted protein', 163, NULL, NULL, 173564),
(173565, '3.40.50.11380-FF-000010', NULL, NULL, 66, NULL, NULL, 173565),
(173566, '2.40.50.140-FF-001118', NULL, NULL, 155, NULL, NULL, 173566),
(173567, '3.40.50.1820-FF-001072', NULL, 'Carboxypeptidase', 342, NULL, NULL, 173567),
(173568, '3.40.250.10-FF-000191', NULL, 'MBL fold metallo-hydrolase', 105, NULL, NULL, 173568),
(173569, '2.30.130.40-FF-000011', NULL, 'Lon protease homolog 2, peroxisomal', 153, NULL, NULL, 173569),
(173570, '2.130.10.10-FF-003753', NULL, 'Membrane glycoprotein spo14', 326, NULL, NULL, 173570),
(173571, '2.30.30.380-FF-000064', NULL, 'Uncharacterized protein', 46, NULL, NULL, 173571),
(173572, '1.20.1250.20-FF-001441', NULL, 'Uncharacterized protein', 98, NULL, NULL, 173572),
(173573, '1.10.472.10-FF-000214', NULL, 'Cyclin, N-terminal domain containing protein', 91, NULL, NULL, 173573),
(173574, '1.10.510.10-FF-003098', NULL, NULL, 247, NULL, NULL, 173574),
(173575, '1.25.10.10-FF-001794', NULL, 'Putative adaptor protein complex large chain subunit BetaA', 579, NULL, NULL, 173575),
(173576, '2.60.120.10-FF-000383', NULL, 'Mannose-6-phosphate isomerase', 99, NULL, NULL, 173576),
(173577, '3.40.50.2300-FF-000963', NULL, NULL, 139, NULL, NULL, 173577),
(173578, '2.60.40.60-FF-000305', NULL, 'protocadherin-23 isoform X1', 105, NULL, NULL, 173578),
(173579, '3.40.720.10-FF-000356', NULL, 'Uncharacterized protein', 53, NULL, NULL, 173579),
(173580, '3.40.50.150-FF-000173', NULL, 'methyltransferase-like protein 23 isoform X1', 167, NULL, NULL, 173580);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(173581, '1.20.1600.10-FF-000061', NULL, 'Uncharacterized protein', 394, NULL, NULL, 173581),
(173582, '1.10.8.60-FF-000548', NULL, 'Transitional endoplasmic reticulum', 88, NULL, NULL, 173582),
(173583, '2.10.25.10-FF-001123', NULL, 'Uncharacterized protein', 49, NULL, NULL, 173583),
(173584, '1.10.540.10-FF-000053', NULL, 'Probable acyl-CoA dehydrogenase', 129, NULL, NULL, 173584),
(173585, '3.90.180.10-FF-000179', NULL, 'Predicted protein', 74, NULL, NULL, 173585),
(173586, '3.40.50.1100-FF-000120', NULL, 'Cysteine synthase, chloroplastic/chromoplastic', 52, NULL, NULL, 173586),
(173587, '2.30.30.140-FF-000144', NULL, 'DNA mismatch repair protein', 131, NULL, NULL, 173587),
(173588, '3.20.20.70-FF-000402', NULL, 'Putative 12-oxophytodienoate reductase 10', 272, NULL, NULL, 173588),
(173589, '3.60.40.10-FF-000389', NULL, '5-azacytidine resistance protein azr1', 117, NULL, NULL, 173589),
(173590, '2.10.220.10-FF-000042', NULL, 'Proprotein convertase subtilisin/kexin type 5', 98, NULL, NULL, 173590),
(173591, '1.10.1200.10-FF-000038', NULL, 'Phthiocerol synthesis polyketide synthase type I PpsD', 74, NULL, NULL, 173591),
(173592, '2.130.10.130-FF-000017', NULL, 'Glycosylphosphatidylinositol specific phospholipase D1', 83, NULL, NULL, 173592),
(173593, '2.40.70.10-FF-000113', NULL, 'Lysosomal aspartic protease', 214, NULL, NULL, 173593),
(173594, '1.20.1110.10-FF-000130', NULL, NULL, 166, NULL, NULL, 173594),
(173595, '1.20.1280.50-FF-000114', NULL, 'F-box protein SKP2A isoform A', 42, NULL, NULL, 173595),
(173596, '3.40.50.300-FF-006193', NULL, 'Uncharacterized protein', 163, NULL, NULL, 173596),
(173597, '3.50.50.60-FF-000877', NULL, 'Protoporphyrinogen oxidase', 477, NULL, NULL, 173597),
(173598, '1.25.40.10-FF-003533', NULL, 'Predicted protein', 147, NULL, NULL, 173598),
(173599, '3.90.190.10-FF-000461', NULL, 'Uncharacterized protein', 198, NULL, NULL, 173599),
(173600, '3.30.160.60-FF-004242', NULL, NULL, 26, NULL, NULL, 173600),
(173601, '3.40.50.1240-FF-000111', NULL, '6-phosphofructo-2-kinase/fructose-2, 6-bisphosphatase 1 isoform X1', 221, NULL, NULL, 173601),
(173602, '3.30.70.330-FF-001256', NULL, 'RNA recognition motif domain containing protein', 93, NULL, NULL, 173602),
(173603, '2.60.40.10-FF-000240', NULL, 'MAM domain containing glycosylphosphatidylinositol anchor 1', 93, NULL, NULL, 173603),
(173604, '2.60.120.920-FF-000028', NULL, 'Ryanodine receptor, isoform E', 183, NULL, NULL, 173604),
(173605, '3.30.70.330-FF-003156', NULL, NULL, 62, NULL, NULL, 173605),
(173606, '2.80.10.50-FF-000210', NULL, 'Uncharacterized protein', 100, NULL, NULL, 173606),
(173607, '3.40.30.10-FF-000390', NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', 157, NULL, NULL, 173607),
(173608, '2.130.10.120-FF-000014', NULL, 'Uncharacterized protein', 395, NULL, NULL, 173608),
(173609, '2.60.120.1000-FF-000018', NULL, 'Collagen alpha-1(XXVII) chain A', 118, NULL, NULL, 173609),
(173610, '2.30.30.40-FF-000305', NULL, 'Nostrin, isoform H', 75, NULL, NULL, 173610),
(173611, '1.20.120.350-FF-000182', NULL, NULL, 128, NULL, NULL, 173611),
(173612, '2.130.10.10-FF-005653', NULL, 'Leucine zipper transcription factor, putative', 168, NULL, NULL, 173612),
(173613, '1.20.1310.10-FF-000212', NULL, NULL, 90, NULL, NULL, 173613),
(173614, '3.40.50.450-FF-000072', NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase LOG3', 72, NULL, NULL, 173614),
(173615, '2.130.10.10-FF-002207', NULL, 'Protein NEDD1', 168, NULL, NULL, 173615),
(173616, '1.10.555.10-FF-000076', NULL, 'Rho GTPase-activating protein', 215, NULL, NULL, 173616),
(173617, '2.130.10.10-FF-000100', NULL, 'Cleavage and polyadenylation specificity factor subunit 1', 380, NULL, NULL, 173617),
(173618, '1.10.533.10-FF-000031', NULL, 'Caspase 1, isoform CRA_b', 89, NULL, NULL, 173618),
(173619, '2.30.29.30-FF-000996', NULL, 'Epidermal growth factor receptor kinase substrate 8', 131, NULL, NULL, 173619),
(173620, '3.20.20.70-FF-000048', NULL, 'Delta-aminolevulinic acid dehydratase', 329, NULL, NULL, 173620),
(173621, '3.30.450.60-FF-000083', NULL, 'Uncharacterized protein', 174, NULL, NULL, 173621);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(173622, '1.25.40.10-FF-001279', NULL, 'Pentatricopeptide repeat-containing protein ELI1, chloroplastic', 110, NULL, NULL, 173622),
(173623, '2.130.10.10-FF-005344', NULL, 'Uncharacterized protein', 181, NULL, NULL, 173623),
(173624, '1.10.472.80-FF-000229', NULL, NULL, 151, NULL, NULL, 173624),
(173625, '2.30.29.30-FF-000687', NULL, 'Uncharacterized protein', 106, NULL, NULL, 173625),
(173626, '1.25.40.710-FF-000006', NULL, 'AGAP004870-PA', 252, NULL, NULL, 173626),
(173627, '3.20.20.70-FF-000711', NULL, NULL, 132, NULL, NULL, 173627),
(173628, '1.25.40.700-FF-000003', NULL, 'Nuclear pore complex protein Nup133', 130, NULL, NULL, 173628),
(173629, '3.80.10.10-FF-002860', NULL, 'Toll-like receptor 20, tandem duplicate 2', 181, NULL, NULL, 173629),
(173630, '1.10.510.10-FF-001653', NULL, 'Protein kinase, putative', 154, NULL, NULL, 173630),
(173631, '1.10.533.10-FF-000250', NULL, 'Uncharacterized protein', 94, NULL, NULL, 173631),
(173632, '3.20.20.60-FF-000045', NULL, 'Pyruvate kinase', 226, NULL, NULL, 173632),
(173633, '3.30.310.10-FF-000052', NULL, 'AP complex subunit beta', 155, NULL, NULL, 173633),
(173634, '1.10.287.370-FF-000055', NULL, 'Prefoldin, alpha subunit', 145, NULL, NULL, 173634),
(173635, '3.30.60.30-FF-000162', NULL, 'Solute carrier organic anion transporter family member', 46, NULL, NULL, 173635),
(173636, '1.20.1560.10-FF-000798', NULL, 'Uncharacterized protein', 202, NULL, NULL, 173636),
(173637, '3.40.1170.10-FF-000015', NULL, 'DNA mismatch repair protein, putative', 111, NULL, NULL, 173637),
(173638, '4.10.400.10-FF-000149', NULL, 'enteropeptidase isoform X2', 39, NULL, NULL, 173638),
(173639, '1.10.8.720-FF-000015', NULL, 'Dynein heavy chain 5, axonemal', 174, NULL, NULL, 173639),
(173640, '1.20.1250.20-FF-001351', NULL, 'Uncharacterized protein', 316, NULL, NULL, 173640),
(173641, '3.30.200.20-FF-001906', NULL, 'Serine/threonine protein kinase, putative', 81, NULL, NULL, 173641),
(173642, '3.40.50.10810-FF-000204', NULL, 'Uncharacterized protein', 139, NULL, NULL, 173642),
(173643, '2.60.40.10-FF-003674', NULL, NULL, 99, NULL, NULL, 173643),
(173644, '3.80.10.10-FF-000960', NULL, 'Tsukushin', 101, NULL, NULL, 173644),
(173645, '3.40.50.300-FF-001988', NULL, 'Dicer-like protein 1', 245, NULL, NULL, 173645),
(173646, '1.25.40.240-FF-000011', NULL, NULL, 150, NULL, NULL, 173646),
(173647, '3.20.20.70-FF-000357', NULL, 'Ribulose-phosphate 3-epimerase', 225, NULL, NULL, 173647),
(173648, '3.30.70.330-FF-001565', NULL, 'AT5g60980/MSL3_100', 119, NULL, NULL, 173648),
(173649, '3.20.20.70-FF-000609', NULL, 'Predicted protein', 382, NULL, NULL, 173649),
(173650, '2.60.40.150-FF-000136', NULL, 'Calpain 5', 117, NULL, NULL, 173650),
(173651, '1.25.10.10-FF-000979', NULL, 'TAF2 RNA polymerase II, TATA box binding (TBP)-associated factor, 150 kDa (TAF2), mRNA protein', 201, NULL, NULL, 173651),
(173652, '3.40.50.360-FF-000146', NULL, 'Protein NrdI', 125, NULL, NULL, 173652),
(173653, '3.30.40.10-FF-001133', NULL, 'Autoimmune regulator', 58, NULL, NULL, 173653),
(173654, '3.30.70.2820-FF-000014', NULL, NULL, 75, NULL, NULL, 173654),
(173655, '1.10.510.10-FF-001962', NULL, 'Serine/threonine-protein kinase cbk1', 214, NULL, NULL, 173655),
(173656, '1.20.1070.10-FF-001441', NULL, 'Olfactory receptor H12', 223, NULL, NULL, 173656),
(173657, '1.10.287.70-FF-000386', NULL, 'Potassium voltage-gated channel subfamily H member 2', 131, NULL, NULL, 173657),
(173658, '1.10.455.10-FF-000012', NULL, 'Ribosomal protein', 83, NULL, NULL, 173658),
(173659, '3.40.50.10190-FF-000097', NULL, 'Kinetoplastid kinetochore protein 4', 91, NULL, NULL, 173659),
(173660, '3.40.1000.10-FF-000003', NULL, 'hemojuvelin isoform X1', 154, NULL, NULL, 173660),
(173661, '1.25.10.10-FF-001906', NULL, 'importin subunit beta-1 isoform X1', 543, NULL, NULL, 173661),
(173662, '1.10.287.690-FF-000010', NULL, 'DNA polymerase', 54, NULL, NULL, 173662),
(173663, '2.40.50.140-FF-000033', NULL, 'DNA helicase', 76, NULL, NULL, 173663),
(173664, '2.40.50.150-FF-000036', NULL, 'Uncharacterized protein', 46, NULL, NULL, 173664);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(173665, '3.40.50.300-FF-003933', NULL, 'Tyrosine-protein kinase (Capsular polysaccharide biosynthesis)', 188, NULL, NULL, 173665),
(173666, '1.20.120.350-FF-000092', NULL, 'Sodium channel protein', 112, NULL, NULL, 173666),
(173667, '3.10.400.20-FF-000027', NULL, 'Uncharacterized protein', 171, NULL, NULL, 173667),
(173668, '1.10.10.2120-FF-000001', NULL, 'Mutant tan', 54, NULL, NULL, 173668),
(173669, '1.20.5.170-FF-000264', NULL, 'Tropomyosin-1, isoforms 9A/A/B-like Protein', 86, NULL, NULL, 173669),
(173670, '2.20.20.10-FF-000004', NULL, 'Defensin-like peptide 1', 42, NULL, NULL, 173670),
(173671, '2.130.10.10-FF-003399', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 204, NULL, NULL, 173671),
(173672, '3.60.21.10-FF-000250', NULL, 'Serine/threonine-protein phosphatase', 235, NULL, NULL, 173672),
(173673, '3.40.50.720-FF-000496', NULL, 'Trk system potassium uptake protein TrkA', 139, NULL, NULL, 173673),
(173674, '2.130.10.10-FF-000307', NULL, 'WD repeat domain 3', 179, NULL, NULL, 173674),
(173675, '3.30.1610.10-FF-000001', NULL, 'Nuclear pore complex protein Nup98-Nup96', 155, NULL, NULL, 173675),
(173676, '3.30.420.110-FF-000011', NULL, 'DNA mismatch repair protein', 165, NULL, NULL, 173676),
(173677, '3.30.710.10-FF-000498', NULL, 'Uncharacterized protein', 65, NULL, NULL, 173677),
(173678, '3.40.525.10-FF-000020', NULL, 'Chromosome 15, whole genome shotgun sequence', 280, NULL, NULL, 173678),
(173679, '3.30.1240.10-FF-000057', NULL, 'Hydrolase (HAD superfamily)', 106, NULL, NULL, 173679),
(173680, '1.25.40.250-FF-000014', NULL, 'Eukaryotic translation initiation factor 3 subunit K', 128, NULL, NULL, 173680),
(173681, '3.30.420.10-FF-000509', NULL, NULL, 131, NULL, NULL, 173681),
(173682, '1.20.120.1080-FF-000149', NULL, 'Uncharacterized protein', 118, NULL, NULL, 173682),
(173683, '1.25.40.10-FF-003179', NULL, 'Pentatricopeptide repeat-containing protein At2g46050, mitochondrial', 105, NULL, NULL, 173683),
(173684, '3.40.140.10-FF-000053', NULL, 'MPN domain-containing protein CG4751', 153, NULL, NULL, 173684),
(173685, '2.60.40.60-FF-000193', NULL, 'Protocadherin 12', 105, NULL, NULL, 173685),
(173686, '1.10.287.70-FF-000695', NULL, 'Uncharacterized protein', 47, NULL, NULL, 173686),
(173687, '1.20.1070.10-FF-001132', NULL, 'Melanopsin-B', 301, NULL, NULL, 173687),
(173688, '1.20.140.10-FF-000144', NULL, 'Probable acyl-CoA dehydrogenase', 149, NULL, NULL, 173688),
(173689, '2.70.150.10-FF-000202', NULL, 'Phospholipid-transporting ATPase', 168, NULL, NULL, 173689),
(173690, '3.40.50.150-FF-001584', NULL, NULL, 46, NULL, NULL, 173690),
(173691, '3.10.105.10-FF-000080', NULL, 'Peptide ABC transporter substrate-binding protein', 198, NULL, NULL, 173691),
(173692, '1.20.1610.10-FF-000016', NULL, 'Glycoside hydrolase family 92 protein', 116, NULL, NULL, 173692),
(173693, '3.30.9.10-FF-000116', NULL, 'Uncharacterized protein', 199, NULL, NULL, 173693),
(173694, '3.65.10.10-FF-000017', NULL, 'UDP-N-acetylglucosamine 1-carboxyvinyltransferase', 197, NULL, NULL, 173694),
(173695, '3.40.30.10-FF-000064', NULL, 'Nucleoredoxin', 122, NULL, NULL, 173695),
(173696, '3.30.70.330-FF-001464', NULL, 'Putative RNA-binding protein', 141, NULL, NULL, 173696),
(173697, '3.40.390.30-FF-000004', NULL, 'Sugar phosphatase YidA', 140, NULL, NULL, 173697),
(173698, '1.20.120.550-FF-000028', NULL, 'Microsomal glutathione S-transferase 2', 80, NULL, NULL, 173698),
(173699, '3.20.20.80-FF-000495', NULL, 'Putative glucan endo-13-beta-glucosidase BG1', 209, NULL, NULL, 173699),
(173700, '3.40.1110.10-FF-000129', NULL, 'Phospholipid-transporting ATPase', 115, NULL, NULL, 173700),
(173701, '3.90.190.10-FF-000197', NULL, 'Protein tyrosine phosphatase, putative', 164, NULL, NULL, 173701),
(173702, '3.60.20.40-FF-000032', NULL, 'Uncharacterized protein', 143, NULL, NULL, 173702),
(173703, '1.10.8.60-FF-000088', NULL, 'ORC1-type DNA replication protein', 16, NULL, NULL, 173703),
(173704, '2.130.10.10-FF-002090', NULL, 'Probable cleavage and polyadenylation specificity factor subunit 1', 393, NULL, NULL, 173704);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(173705, '3.30.420.40-FF-000350', NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', 114, NULL, NULL, 173705),
(173706, '3.40.50.300-FF-007429', NULL, 'Uncharacterized protein', 335, NULL, NULL, 173706),
(173707, '2.70.130.10-FF-000055', NULL, NULL, 148, NULL, NULL, 173707),
(173708, '3.20.20.70-FF-000492', NULL, 'Dihydroorotate dehydrogenase (quinone)', 366, NULL, NULL, 173708),
(173709, '3.20.80.10-FF-000062', NULL, 'Uncharacterized protein', 96, NULL, NULL, 173709),
(173710, '3.40.50.1000-FF-000207', NULL, '2,3-diketo-5-methylthio-1-phosphopentane phosphatase', 124, NULL, NULL, 173710),
(173711, '3.40.50.300-FF-000504', NULL, 'ABC transporter G family member 11', 244, NULL, NULL, 173711),
(173712, '3.10.580.10-FF-000216', NULL, 'Chloride channel protein', 134, NULL, NULL, 173712),
(173713, '3.10.580.10-FF-000065', NULL, 'Protein MAM3', 112, NULL, NULL, 173713),
(173714, '3.30.160.60-FF-003770', NULL, 'Zinc finger 30C', 57, NULL, NULL, 173714),
(173715, '3.40.20.10-FF-000092', NULL, 'Uncharacterized protein', 146, NULL, NULL, 173715),
(173716, '1.20.140.150-FF-000103', NULL, 'Uncharacterized protein', 177, NULL, NULL, 173716),
(173717, '2.30.29.30-FF-000895', NULL, 'Uncharacterized protein', 127, NULL, NULL, 173717),
(173718, '1.10.1660.10-FF-000010', NULL, 'MerR family transcriptional regulator', 84, NULL, NULL, 173718),
(173719, '2.40.150.20-FF-000010', NULL, 'Mitochondrial ribosomal protein L14, putative', 121, NULL, NULL, 173719),
(173720, '3.40.50.410-FF-000077', NULL, 'Uncharacterized protein, isoform B', 181, NULL, NULL, 173720),
(173721, '2.60.40.10-FF-002230', NULL, 'Beta-galactosidase BoGH2A', 104, NULL, NULL, 173721),
(173722, '1.50.10.20-FF-000098', NULL, 'Pre-alpha-onocerin synthase LCC', 354, NULL, NULL, 173722),
(173723, '1.20.120.350-FF-000210', NULL, NULL, 121, NULL, NULL, 173723),
(173724, '1.20.120.530-FF-000022', NULL, 'GntR family transcriptional regulator', 144, NULL, NULL, 173724),
(173725, '3.50.50.60-FF-001349', NULL, 'Uncharacterized protein', 135, NULL, NULL, 173725),
(173726, '2.40.10.10-FF-000014', NULL, 'Complement factor D', 116, NULL, NULL, 173726),
(173727, '3.30.160.60-FF-003663', NULL, 'Longitudinals lacking protein, isoforms J/P/Q/S/Z', 75, NULL, NULL, 173727),
(173728, '1.25.40.10-FF-001526', NULL, 'Pentatricopeptide repeat-containing protein At1g63130, mitochondrial', 69, NULL, NULL, 173728),
(173729, '3.80.10.10-FF-002652', NULL, 'Uncharacterized protein', 88, NULL, NULL, 173729),
(173730, '3.20.20.70-FF-000503', NULL, 'Indole-3-glycerol-phosphate synthase', 256, NULL, NULL, 173730),
(173731, '2.60.40.60-FF-000530', NULL, 'Dachsous cadherin-related 1a', 110, NULL, NULL, 173731),
(173732, '1.10.8.60-FF-000565', NULL, 'Uncharacterized protein', 82, NULL, NULL, 173732),
(173733, '3.30.70.1230-FF-000083', NULL, 'Guanylate cyclase', 150, NULL, NULL, 173733),
(173734, '1.50.10.10-FF-000095', NULL, 'lanC-like protein 1 isoform X2', 108, NULL, NULL, 173734),
(173735, '3.30.1490.120-FF-000004', NULL, 'RNA polymerase I subunit Rpa43', 110, NULL, NULL, 173735),
(173736, '1.10.506.10-FF-000092', NULL, 'Uncharacterized protein', 95, NULL, NULL, 173736),
(173737, '2.60.120.10-FF-000309', NULL, 'Cysteine dioxygenase', 161, NULL, NULL, 173737),
(173738, '2.10.25.10-FF-001224', NULL, 'Nimrod C1, isoform A', 44, NULL, NULL, 173738),
(173739, '3.30.420.10-FF-000279', NULL, 'Three prime repair exonuclease, putative', 208, NULL, NULL, 173739),
(173740, '3.40.50.300-FF-003686', NULL, 'Stage V sporulation protein K', 177, NULL, NULL, 173740),
(173741, '3.30.40.10-FF-000969', NULL, 'Histone-lysine N-methyltransferase', 56, NULL, NULL, 173741),
(173742, '1.20.1070.10-FF-001031', NULL, 'Olfactory receptor 53', 88, NULL, NULL, 173742),
(173743, '1.10.510.10-FF-002232', NULL, NULL, 182, NULL, NULL, 173743),
(173744, '2.40.50.100-FF-000162', NULL, 'Putative exosomal 3''-5'' exoribonuclease complex subunit ski4', 47, NULL, NULL, 173744),
(173745, '2.60.120.330-FF-000082', NULL, 'Uncharacterized protein', 136, NULL, NULL, 173745),
(173746, '3.30.160.60-FF-000088', NULL, 'Zinc finger and SCAN domain containing 2', 27, NULL, NULL, 173746);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(173747, '1.25.40.20-FF-001529', NULL, 'Kinase, NEK', 62, NULL, NULL, 173747),
(173748, '3.90.550.10-FF-000067', NULL, 'Hexosyltransferase', 250, NULL, NULL, 173748),
(173749, '3.40.1170.60-FF-000013', NULL, 'DNA repair protein', 54, NULL, NULL, 173749),
(173750, '3.30.1490.110-FF-000001', NULL, 'Cell division protein FtsA', 84, NULL, NULL, 173750),
(173751, '1.10.287.660-FF-000035', NULL, 'Subunit of the ESCRT-I complex', 72, NULL, NULL, 173751),
(173752, '3.30.930.10-FF-000363', NULL, 'Uncharacterized protein', 67, NULL, NULL, 173752),
(173753, '3.80.10.10-FF-001550', NULL, 'Leucine-rich repeat transmembrane protein kinase', 345, NULL, NULL, 173753),
(173754, '3.30.9.10-FF-000009', NULL, 'Sarcosine dehydrogenase, mitochondrial', 159, NULL, NULL, 173754),
(173755, '3.40.630.30-FF-000361', NULL, 'GNAT family acetyltransferase YjcF', 140, NULL, NULL, 173755),
(173756, '2.60.40.60-FF-000423', NULL, 'putative protocadherin beta-18', 118, NULL, NULL, 173756),
(173757, '3.10.310.20-FF-000014', NULL, NULL, 120, NULL, NULL, 173757),
(173758, '3.40.50.300-FF-007957', NULL, 'Predicted protein', 167, NULL, NULL, 173758),
(173759, '3.40.50.720-FF-001215', NULL, 'Putative short chain dehydrogenase', 233, NULL, NULL, 173759),
(173760, '3.30.420.40-FF-000501', NULL, 'Predicted protein', 109, NULL, NULL, 173760),
(173761, '3.20.10.10-FF-000018', NULL, 'Aminodeoxychorismate lyase', 131, NULL, NULL, 173761),
(173762, '1.10.238.10-FF-000390', NULL, 'Uncharacterized protein', 118, NULL, NULL, 173762),
(173763, '1.10.8.60-FF-000239', NULL, 'Meiotic spindle formation protein mei-1', 89, NULL, NULL, 173763),
(173764, '2.130.10.10-FF-003871', NULL, 'Uncharacterized protein', 281, NULL, NULL, 173764),
(173765, '1.25.40.10-FF-003078', NULL, 'Pentatricopeptide repeat-containing protein', 182, NULL, NULL, 173765),
(173766, '3.40.430.10-FF-000036', NULL, 'Dihydrofolate reductase-like domain-containing protein', 188, NULL, NULL, 173766),
(173767, '2.60.40.10-FF-002123', NULL, 'Titin, tandem duplicate 1', 108, NULL, NULL, 173767),
(173768, '3.20.20.140-FF-000461', NULL, 'N-acetyl-glucosamine-6-phosphate deacetylase, putative', 219, NULL, NULL, 173768),
(173769, '3.40.50.1000-FF-000314', NULL, 'Haloacid dehalogenase-like hydrolase', 130, NULL, NULL, 173769),
(173770, '2.60.120.1000-FF-000035', NULL, 'Predicted protein', 104, NULL, NULL, 173770),
(173771, '3.30.160.60-FF-006411', NULL, NULL, 60, NULL, NULL, 173771),
(173772, '3.40.50.300-FF-007755', NULL, 'Uncharacterized protein', 73, NULL, NULL, 173772),
(173773, '3.90.290.10-FF-000024', NULL, 'Fibrillin-1', 74, NULL, NULL, 173773),
(173774, '3.40.50.1360-FF-000057', NULL, 'Glucosamine-6-phosphate isomerase, putative', 85, NULL, NULL, 173774),
(173775, '3.30.160.60-FF-002033', NULL, 'Zinc finger protein 473', 36, NULL, NULL, 173775),
(173776, '1.10.510.10-FF-003553', NULL, NULL, 228, NULL, NULL, 173776),
(173777, '3.40.50.12780-FF-000099', NULL, 'Fatty-acid-CoA ligase FadD9', 468, NULL, NULL, 173777),
(173778, '3.40.50.10260-FF-000011', NULL, 'NAD(P)H-hydrate epimerase', 229, NULL, NULL, 173778),
(173779, '3.10.20.90-FF-000330', NULL, 'NPL4-like protein 1', 97, NULL, NULL, 173779),
(173780, '3.10.110.10-FF-000030', NULL, 'AKT-interacting protein-like isoform X2', 149, NULL, NULL, 173780),
(173781, '1.10.510.10-FF-002125', NULL, NULL, 96, NULL, NULL, 173781),
(173782, '2.10.70.10-FF-000238', NULL, 'Uncharacterized protein, isoform B', 61, NULL, NULL, 173782),
(173783, '3.20.20.140-FF-000152', NULL, 'Conserved protein', 207, NULL, NULL, 173783),
(173784, '2.30.30.140-FF-000251', NULL, 'Histone-lysine N-methyltransferase', 45, NULL, NULL, 173784),
(173785, '3.20.20.80-FF-000169', NULL, 'Putative alpha-glucosidase AgdA', 233, NULL, NULL, 173785),
(173786, '2.130.10.10-FF-002101', NULL, 'WD domain, G-beta repeat, putative', 132, NULL, NULL, 173786),
(173787, '3.40.440.10-FF-000008', NULL, 'Adenylosuccinate synthetase', 156, NULL, NULL, 173787),
(173788, '3.30.160.60-FF-005787', NULL, NULL, 39, NULL, NULL, 173788),
(173789, '3.50.40.10-FF-000002', NULL, 'phenylalanine--tRNA ligase beta subunit', 205, NULL, NULL, 173789);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(173790, '3.80.10.10-FF-000179', NULL, 'leucine-rich repeat serine/threonine-protein kinase 2', 227, NULL, NULL, 173790),
(173791, '3.20.20.70-FF-000166', NULL, 'Heme chaperone HemW', 219, NULL, NULL, 173791),
(173792, '3.40.50.2300-FF-001452', NULL, NULL, 15, NULL, NULL, 173792),
(173793, '1.10.238.10-FF-000401', NULL, 'Troponin C 25D', 68, NULL, NULL, 173793),
(173794, '3.30.160.60-FF-001729', NULL, 'Zinc finger protein 337', 30, NULL, NULL, 173794),
(173795, '3.10.100.10-FF-000304', NULL, NULL, 62, NULL, NULL, 173795),
(173796, '1.20.58.60-FF-000890', NULL, 'Uncharacterized protein', 214, NULL, NULL, 173796),
(173797, '3.40.30.10-FF-000171', NULL, 'Glutathione amide-dependent peroxidase', 72, NULL, NULL, 173797),
(173798, '1.20.1060.20-FF-000004', NULL, 'Structural maintenance of chromosomes flexible hinge domain containing 1', 58, NULL, NULL, 173798),
(173799, '2.30.36.90-FF-000002', NULL, 'Actin-related protein 8', 44, NULL, NULL, 173799),
(173800, '1.25.10.10-FF-003469', NULL, 'Importin subunit alpha-5', 131, NULL, NULL, 173800),
(173801, '3.60.40.10-FF-000182', NULL, 'Protein phosphatase fem-2', 292, NULL, NULL, 173801),
(173802, '3.30.930.10-FF-000256', NULL, 'Octanoyltransferase', 222, NULL, NULL, 173802),
(173803, '2.40.10.10-FF-000340', NULL, NULL, 73, NULL, NULL, 173803),
(173804, '2.130.10.10-FF-001954', NULL, 'Actin-related protein 2/3 complex subunit', 392, NULL, NULL, 173804),
(173805, '3.10.250.10-FF-000079', NULL, NULL, 60, NULL, NULL, 173805),
(173806, '1.10.10.440-FF-000103', NULL, 'Uncharacterized protein', 77, NULL, NULL, 173806),
(173807, '3.50.30.30-FF-000086', NULL, 'YALI0A20416p', 190, NULL, NULL, 173807),
(173808, '1.20.1560.10-FF-000579', NULL, 'ABC transporter NFT1', 352, NULL, NULL, 173808),
(173809, '3.10.450.720-FF-000002', NULL, 'Ribosomal RNA small subunit methyltransferase F', 165, NULL, NULL, 173809),
(173810, '3.40.50.1820-FF-000549', NULL, 'Neuroligin 1', 309, NULL, NULL, 173810),
(173811, '1.10.510.10-FF-001759', NULL, 'Os08g0376600 protein', 190, NULL, NULL, 173811),
(173812, '4.10.410.10-FF-000122', NULL, 'Uncharacterized protein', 60, NULL, NULL, 173812),
(173813, '2.60.40.1080-FF-000020', NULL, 'Surface layer protein', 107, NULL, NULL, 173813),
(173814, '2.30.29.30-FF-001305', NULL, 'GTC2', 79, NULL, NULL, 173814),
(173815, '1.25.10.10-FF-002160', NULL, 'Uncharacterized protein', 513, NULL, NULL, 173815),
(173816, '2.40.50.100-FF-000055', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 95, NULL, NULL, 173816),
(173817, '3.30.160.60-FF-006304', NULL, NULL, 30, NULL, NULL, 173817),
(173818, '1.20.1250.20-FF-000828', NULL, 'Multidrug MFS transporter', 390, NULL, NULL, 173818),
(173819, '1.10.3270.10-FF-000003', NULL, '3-hydroxy-3-methylglutaryl coenzyme A reductase', 89, NULL, NULL, 173819),
(173820, '3.30.160.60-FF-005568', NULL, NULL, 53, NULL, NULL, 173820),
(173821, '3.30.160.60-FF-002342', NULL, 'Uncharacterized protein', 27, NULL, NULL, 173821),
(173822, '1.25.50.20-FF-000029', NULL, 'Aminopeptidase', 324, NULL, NULL, 173822),
(173823, '3.10.120.10-FF-000002', NULL, 'Cytochrome b5 type B', 84, NULL, NULL, 173823),
(173824, '3.10.20.80-FF-000001', NULL, 'Translation initiation factor IF-3', 75, NULL, NULL, 173824),
(173825, '1.25.40.10-FF-000222', NULL, 'SARP family transcriptional regulator', 165, NULL, NULL, 173825),
(173826, '3.20.20.70-FF-000812', NULL, NULL, 354, NULL, NULL, 173826),
(173827, '3.40.33.10-FF-000087', NULL, 'GLIPR1-like protein 1', 193, NULL, NULL, 173827),
(173828, '1.10.1040.10-FF-000076', NULL, '2-dehydropantoate 2-reductase', 155, NULL, NULL, 173828),
(173829, '2.30.29.30-FF-001075', NULL, 'Uncharacterized protein', 70, NULL, NULL, 173829),
(173830, '3.30.70.1230-FF-000190', NULL, 'Predicted protein', 153, NULL, NULL, 173830),
(173831, '1.25.40.20-FF-000225', NULL, 'caskin-1 isoform X1', 177, NULL, NULL, 173831),
(173832, '3.40.1280.30-FF-000006', NULL, 'tRNA methyltransferase 10B', 107, NULL, NULL, 173832),
(173833, '3.30.160.60-FF-003972', NULL, NULL, 51, NULL, NULL, 173833),
(173834, '3.40.720.10-FF-000165', NULL, 'Phosphatidylinositol glycan anchor biosynthesis class N', 235, NULL, NULL, 173834);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(173835, '2.60.40.10-FF-001757', NULL, 'Fibronectin type III and SPRY domain containing 2', 103, NULL, NULL, 173835),
(173836, '2.60.40.10-FF-001976', NULL, 'Mesocentin', 105, NULL, NULL, 173836),
(173837, '3.40.50.150-FF-000307', NULL, 'mRNA-capping enzyme catalytic subunit', 302, NULL, NULL, 173837),
(173838, '3.30.70.330-FF-001801', NULL, NULL, 121, NULL, NULL, 173838),
(173839, '1.10.510.10-FF-001299', NULL, 'BUB1B, mitotic checkpoint serine/threonine kinase', 267, NULL, NULL, 173839),
(173840, '2.140.10.30-FF-000015', NULL, 'Uncharacterized protein', 462, NULL, NULL, 173840),
(173841, '1.10.167.10-FF-000011', NULL, 'Regulator of G protein signaling 22', 135, NULL, NULL, 173841),
(173842, '3.20.20.80-FF-000815', NULL, 'Uncharacterized protein', 105, NULL, NULL, 173842),
(173843, '1.10.287.940-FF-000012', NULL, 'P2X receptor A', 64, NULL, NULL, 173843),
(173844, '2.60.40.10-FF-002600', NULL, 'Uncharacterized protein, isoform A', 93, NULL, NULL, 173844),
(173845, '1.25.10.10-FF-003267', NULL, 'Non-specific serine/threonine protein kinase', 208, NULL, NULL, 173845),
(173846, '2.60.40.10-FF-003539', NULL, NULL, 123, NULL, NULL, 173846),
(173847, '1.10.287.950-FF-000015', NULL, 'Methyl-accepting chemotaxis protein', 306, NULL, NULL, 173847),
(173848, '3.30.160.60-FF-000318', NULL, 'Odd-skipped-related transciption factor 2', 28, NULL, NULL, 173848),
(173849, '2.60.40.3510-FF-000030', NULL, 'Uncharacterized protein', 99, NULL, NULL, 173849),
(173850, '3.30.160.20-FF-000239', NULL, 'Uncharacterized protein', 63, NULL, NULL, 173850),
(173851, '2.60.40.10-FF-004028', NULL, NULL, 98, NULL, NULL, 173851),
(173852, '2.130.10.10-FF-005760', NULL, 'Predicted protein', 115, NULL, NULL, 173852),
(173853, '2.30.39.10-FF-000075', NULL, 'Uncharacterized protein', 96, NULL, NULL, 173853),
(173854, '3.40.1110.10-FF-000438', NULL, NULL, 123, NULL, NULL, 173854),
(173855, '1.20.1250.20-FF-000519', NULL, 'Inorganic phosphate transporter', 230, NULL, NULL, 173855),
(173856, '3.90.190.10-FF-000562', NULL, 'Dual specificity protein phosphatase CDC14A, putative', 84, NULL, NULL, 173856),
(173857, '3.80.10.10-FF-002966', NULL, 'Uncharacterized protein', 156, NULL, NULL, 173857),
(173858, '3.30.160.60-FF-002561', NULL, 'Zinc finger protein 517', 25, NULL, NULL, 173858),
(173859, '2.130.10.10-FF-001735', NULL, 'Predicted protein', 198, NULL, NULL, 173859),
(173860, '3.60.10.10-FF-000354', NULL, 'Zgc:136374 protein', 153, NULL, NULL, 173860),
(173861, '2.10.25.10-FF-000858', NULL, 'Notch receptor protein', 38, NULL, NULL, 173861),
(173862, '3.10.280.10-FF-000025', NULL, 'complement component 1 Q subcomponent-binding protein, mitochondrial-like', 193, NULL, NULL, 173862),
(173863, '3.40.50.2300-FF-001233', NULL, NULL, 115, NULL, NULL, 173863),
(173864, '3.40.50.1240-FF-000004', NULL, 'Phosphohistidine phosphatase SixA', 161, NULL, NULL, 173864),
(173865, '1.20.1250.20-FF-000289', NULL, 'Acetyl-coenzyme A transporter 1', 408, NULL, NULL, 173865),
(173866, '2.60.40.10-FF-005782', NULL, NULL, 93, NULL, NULL, 173866),
(173867, '2.130.10.10-FF-000324', NULL, 'WD repeat-containing protein 7 isoform X1', 93, NULL, NULL, 173867),
(173868, '2.30.29.30-FF-000586', NULL, 'Dynamin', 128, NULL, NULL, 173868),
(173869, '3.40.50.300-FF-003916', NULL, 'Uncharacterized protein', 212, NULL, NULL, 173869),
(173870, '2.60.11.10-FF-000010', NULL, 'Uncharacterized protein', 96, NULL, NULL, 173870),
(173871, '2.120.10.30-FF-000151', NULL, 'Uncharacterized protein', 266, NULL, NULL, 173871),
(173872, '2.60.40.60-FF-000221', NULL, 'Cadherin related family member 2', 119, NULL, NULL, 173872),
(173873, '3.30.1490.10-FF-000002', NULL, '40S ribosomal protein S15a', 61, NULL, NULL, 173873),
(173874, '3.30.860.10-FF-000008', NULL, '40S ribosomal protein S19, mitochondrial', 77, NULL, NULL, 173874),
(173875, '1.10.630.10-FF-000734', NULL, 'Uncharacterized protein', 91, NULL, NULL, 173875),
(173876, '3.40.50.1010-FF-000290', NULL, NULL, 123, NULL, NULL, 173876),
(173877, '2.70.9.10-FF-000001', NULL, 'Hexon protein', 80, NULL, NULL, 173877),
(173878, '2.60.120.430-FF-000016', NULL, 'Kinesin-like protein KIN-14R', 156, NULL, NULL, 173878);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(173879, '3.50.80.10-FF-000004', NULL, 'Threonine--tRNA ligase', 139, NULL, NULL, 173879),
(173880, '1.25.10.10-FF-001671', NULL, 'Importin-5', 318, NULL, NULL, 173880),
(173881, '2.10.90.10-FF-000133', NULL, 'Uncharacterized protein (Fragment)', 85, NULL, NULL, 173881),
(173882, '3.30.70.1370-FF-000001', NULL, NULL, 90, NULL, NULL, 173882),
(173883, '2.60.40.830-FF-000003', NULL, 'Cytochrome f', 191, NULL, NULL, 173883),
(173884, '1.20.5.350-FF-000003', NULL, 'Troponin T isoform 5', 97, NULL, NULL, 173884),
(173885, '2.60.40.840-FF-000006', NULL, 'beta-arrestin-2 isoform X2', 63, NULL, NULL, 173885),
(173886, '3.40.720.10-FF-000255', NULL, 'Alkaline-phosphatase-like family protein', 70, NULL, NULL, 173886),
(173887, '3.40.50.300-FF-008121', NULL, 'Uncharacterized protein', 106, NULL, NULL, 173887),
(173888, '3.30.1140.32-FF-000018', NULL, 'SSU ribosomal protein S3P', 119, NULL, NULL, 173888),
(173889, '1.50.40.10-FF-000243', NULL, 'Mitochondrial carrier', 104, NULL, NULL, 173889),
(173890, '3.30.70.330-FF-001790', NULL, NULL, 104, NULL, NULL, 173890),
(173891, '1.25.40.20-FF-000534', NULL, 'Poly [ADP-ribose] polymerase', 88, NULL, NULL, 173891),
(173892, '1.20.1420.10-FF-000007', NULL, 'Talin 2', 153, NULL, NULL, 173892),
(173893, '3.30.70.240-FF-000021', NULL, 'Ribosome-releasing factor 2, mitochondrial', 89, NULL, NULL, 173893),
(173894, '1.10.510.10-FF-001389', NULL, 'Endonuclease III homolog', 308, NULL, NULL, 173894),
(173895, '1.10.533.10-FF-000233', NULL, 'Ssl-1', 111, NULL, NULL, 173895),
(173896, '1.25.70.10-FF-000033', NULL, 'F19K23.4 protein', 221, NULL, NULL, 173896),
(173897, '2.60.40.10-FF-005473', NULL, NULL, 102, NULL, NULL, 173897),
(173898, '3.30.420.40-FF-000041', NULL, 'Acetate kinase', 196, NULL, NULL, 173898),
(173899, '1.25.40.10-FF-000531', NULL, 'Pentatricopeptide repeat-containing protein', 136, NULL, NULL, 173899),
(173900, '1.20.1440.200-FF-000003', NULL, 'Vacuolar protein sorting-associated protein 28', 109, NULL, NULL, 173900),
(173901, '2.60.40.10-FF-003865', NULL, NULL, 149, NULL, NULL, 173901),
(173902, '2.40.50.100-FF-000201', NULL, 'Uncharacterized protein', 48, NULL, NULL, 173902),
(173903, '1.10.238.10-FF-000081', NULL, 'Ubiquitin carboxyl-terminal hydrolase 32', 187, NULL, NULL, 173903),
(173904, '1.25.40.10-FF-001835', NULL, 'Predicted protein', 197, NULL, NULL, 173904),
(173905, '1.10.10.10-FF-000107', NULL, 'Stage 0 sporulation protein A', 119, NULL, NULL, 173905),
(173906, '2.60.40.60-FF-000114', NULL, 'FAT atypical cadherin 4', 107, NULL, NULL, 173906),
(173907, '3.40.50.300-FF-001915', NULL, 'ADP-ribosylation factor 6-like', 176, NULL, NULL, 173907),
(173908, '3.40.140.10-FF-000154', NULL, '26S proteasome non-ATPase regulatory subunit 14', 67, NULL, NULL, 173908),
(173909, '1.25.40.20-FF-001838', NULL, 'Uncharacterized protein', 145, NULL, NULL, 173909),
(173910, '2.130.10.10-FF-003652', NULL, 'Uncharacterized protein', 236, NULL, NULL, 173910),
(173911, '3.30.2350.20-FF-000040', NULL, NULL, 230, NULL, NULL, 173911),
(173912, '3.40.50.300-FF-000813', NULL, 'helicase POLQ-like isoform X1', 202, NULL, NULL, 173912),
(173913, '3.40.50.300-FF-007974', NULL, 'Uncharacterized protein', 161, NULL, NULL, 173913),
(173914, '3.90.550.10-FF-000062', NULL, 'beta-1,4-galactosyltransferase 7 isoform X1', 248, NULL, NULL, 173914),
(173915, '1.10.8.270-FF-000060', NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', 97, NULL, NULL, 173915),
(173916, '2.60.40.150-FF-000120', NULL, 'extended synaptotagmin-1 isoform X1', 130, NULL, NULL, 173916),
(173917, '2.40.10.10-FF-000430', NULL, 'Aquarius', 226, NULL, NULL, 173917),
(173918, '1.20.930.40-FF-000016', NULL, 'Putative zinc metalloprotease', 201, NULL, NULL, 173918),
(173919, '3.40.50.300-FF-001797', NULL, 'ABC transporter, putative', 242, NULL, NULL, 173919),
(173920, '3.30.160.60-FF-003298', NULL, 'Zinc finger protein 667', 31, NULL, NULL, 173920),
(173921, '2.10.25.10-FF-000842', NULL, 'Transmembrane protein with EGF-like and two follistatin-like domains 2b', 48, NULL, NULL, 173921),
(173922, '3.80.10.10-FF-000488', NULL, 'MDIS1-interacting receptor like kinase 2', 160, NULL, NULL, 173922);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(173923, '1.20.120.1110-FF-000001', NULL, 'RUNX1 translocation partner 1', 107, NULL, NULL, 173923),
(173924, '2.30.30.40-FF-000204', NULL, 'Amidase', 100, NULL, NULL, 173924),
(173925, '3.40.50.10190-FF-000198', NULL, 'Protein CBR-MUS-101', 97, NULL, NULL, 173925),
(173926, '3.90.70.10-FF-000390', NULL, 'Uncharacterized protein', 304, NULL, NULL, 173926),
(173927, '2.60.110.10-FF-000028', NULL, 'Uncharacterized protein', 98, NULL, NULL, 173927),
(173928, '2.60.40.1360-FF-000002', NULL, 'Alpha-mannosidase', 125, NULL, NULL, 173928),
(173929, '3.90.550.10-FF-000404', NULL, 'Mannose-1-phosphate guanyltransferase', 267, NULL, NULL, 173929),
(173930, '3.90.1100.10-FF-000061', NULL, 'DNA-directed RNA polymerase subunit beta', 145, NULL, NULL, 173930),
(173931, '3.40.50.720-FF-000849', NULL, '2-dehydropantoate 2-reductase', 181, NULL, NULL, 173931),
(173932, '3.40.50.300-FF-006120', NULL, 'Rab GTPase', 206, NULL, NULL, 173932),
(173933, '1.10.10.10-FF-002013', NULL, 'Uncharacterized protein', 111, NULL, NULL, 173933),
(173934, '2.130.10.10-FF-001398', NULL, 'Putative peptidyl-prolyl cis-trans isomerase and WD40 repeat domain family protein', 289, NULL, NULL, 173934),
(173935, '1.20.5.110-FF-000145', NULL, 'synaptobrevin isoform X1', 111, NULL, NULL, 173935),
(173936, '3.10.620.30-FF-000029', NULL, 'Uncharacterized protein', 31, NULL, NULL, 173936),
(173937, '1.10.3720.10-FF-000111', NULL, 'Peptide ABC transporter permease protein', 230, NULL, NULL, 173937),
(173938, '3.40.50.300-FF-007738', NULL, 'GTP-binding protein 1', 83, NULL, NULL, 173938),
(173939, '1.25.40.20-FF-000444', NULL, 'Protein cfxQ like', 83, NULL, NULL, 173939),
(173940, '1.10.510.10-FF-003867', NULL, NULL, 96, NULL, NULL, 173940),
(173941, '3.20.20.80-FF-000478', NULL, 'Uncharacterized protein', 281, NULL, NULL, 173941),
(173942, '4.10.860.20-FF-000001', NULL, 'PKHD-type hydroxylase YbiX', 47, NULL, NULL, 173942),
(173943, '3.20.20.70-FF-000817', NULL, NULL, 332, NULL, NULL, 173943),
(173944, '3.40.50.2000-FF-000946', NULL, 'Os06g0271000 protein', 118, NULL, NULL, 173944),
(173945, '3.30.1140.60-FF-000007', NULL, 'F-actin-capping protein subunit alpha', 103, NULL, NULL, 173945),
(173946, '3.30.930.10-FF-000239', NULL, 'Prolyl-tRNA synthetase', 137, NULL, NULL, 173946),
(173947, '3.30.70.330-FF-001155', NULL, 'Zinc finger c-x8-c-x5-c-x3-h type (And similar) domain containing protein', 99, NULL, NULL, 173947),
(173948, '1.10.10.10-FF-001833', NULL, 'Predicted protein', 94, NULL, NULL, 173948),
(173949, '2.60.40.640-FF-000053', NULL, 'Conserved protein', 153, NULL, NULL, 173949),
(173950, '1.10.150.50-FF-000243', NULL, 'Uncharacterized protein', 57, NULL, NULL, 173950),
(173951, '1.25.10.10-FF-000703', NULL, 'Pumilio RNA-binding family member 3', 245, NULL, NULL, 173951),
(173952, '3.40.30.10-FF-000047', NULL, 'Calsequestrin', 137, NULL, NULL, 173952),
(173953, '3.30.200.20-FF-001446', NULL, 'Serine/threonine-protein kinase PLK', 87, NULL, NULL, 173953),
(173954, '3.40.120.10-FF-000052', NULL, 'Putative phosphomannomutase', 122, NULL, NULL, 173954),
(173955, '3.40.50.12160-FF-000019', NULL, 'MiaB family tRNA modifying enzyme, archaeal-type protein', 130, NULL, NULL, 173955),
(173956, '3.30.420.40-FF-000131', NULL, 'Actin, alpha skeletal muscle', 112, NULL, NULL, 173956),
(173957, '2.70.130.10-FF-000072', NULL, NULL, 112, NULL, NULL, 173957),
(173958, '1.10.132.60-FF-000041', NULL, 'DNA polymerase', 126, NULL, NULL, 173958),
(173959, '2.30.180.10-FF-000191', NULL, NULL, 96, NULL, NULL, 173959),
(173960, '1.25.40.10-FF-000205', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 97, NULL, NULL, 173960),
(173961, '2.30.29.30-FF-000923', NULL, 'CDC42 binding protein kinase beta', 75, NULL, NULL, 173961),
(173962, '2.40.70.10-FF-000006', NULL, 'Cathepsin E', 161, NULL, NULL, 173962),
(173963, '1.20.58.390-FF-000059', NULL, 'Nicotinic acetylcholine receptor alpha6, isoform D', 103, NULL, NULL, 173963),
(173964, '1.10.630.10-FF-000397', NULL, 'Uncharacterized protein', 490, NULL, NULL, 173964),
(173965, '3.20.20.70-FF-000475', NULL, 'Putative 2-isopropylmalate synthase', 180, NULL, NULL, 173965);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(173966, '1.20.1730.10-FF-000087', NULL, 'Uncharacterized protein', 461, NULL, NULL, 173966),
(173967, '3.80.10.10-FF-003129', NULL, 'All-trans retinoic acid-induced differentiation factor', 79, NULL, NULL, 173967),
(173968, '3.30.70.330-FF-002768', NULL, NULL, 76, NULL, NULL, 173968),
(173969, '1.50.10.10-FF-000078', NULL, 'Protein-glucosylgalactosylhydroxylysine glucosidase', 194, NULL, NULL, 173969),
(173970, '3.30.420.270-FF-000036', NULL, 'ExbD/TolR family protein', 68, NULL, NULL, 173970),
(173971, '1.25.40.20-FF-000208', NULL, 'Ankyrin repeat domain-containing protein 26', 108, NULL, NULL, 173971),
(173972, '1.10.510.10-FF-000343', NULL, 'Cysteine-rich receptor-like protein kinase 28', 204, NULL, NULL, 173972),
(173973, '1.10.510.10-FF-000208', NULL, 'serine/threonine-protein kinase BLUS1 isoform X1', 231, NULL, NULL, 173973),
(173974, '3.30.200.20-FF-000142', NULL, 'Cysteine-rich receptor-like protein kinase 10', 112, NULL, NULL, 173974),
(173975, '3.40.50.300-FF-007648', NULL, 'Uncharacterized protein', 135, NULL, NULL, 173975),
(173976, '3.90.640.10-FF-000288', NULL, 'Chromosome 10, whole genome shotgun sequence', 44, NULL, NULL, 173976),
(173977, '3.30.70.100-FF-000119', NULL, NULL, 95, NULL, NULL, 173977),
(173978, '3.80.10.10-FF-001241', NULL, 'F-box/leucine rich repeat protein', 111, NULL, NULL, 173978),
(173979, '4.10.800.20-FF-000008', NULL, 'Putative AMP deaminase', 47, NULL, NULL, 173979),
(173980, '1.20.1440.200-FF-000008', NULL, 'Vacuolar protein sorting-associated protein 28', 129, NULL, NULL, 173980),
(173981, '3.30.1360.120-FF-000048', NULL, 'Glycine cleavage system T protein', 163, NULL, NULL, 173981),
(173982, '1.20.1310.10-FF-000111', NULL, NULL, 139, NULL, NULL, 173982),
(173983, '2.60.40.10-FF-000341', NULL, 'inactive tyrosine-protein kinase 7', 88, NULL, NULL, 173983),
(173984, '3.40.30.10-FF-000850', NULL, 'Protein disulfide-isomerase', 132, NULL, NULL, 173984),
(173985, '2.60.40.1180-FF-000072', NULL, 'Alpha-galactosidase', 117, NULL, NULL, 173985),
(173986, '1.10.10.10-FF-001491', NULL, 'Probable IclR family regulator (Putative secreted protein)', 77, NULL, NULL, 173986),
(173987, '3.40.50.300-FF-004175', NULL, 'DNA mismatch repair protein MSH3', 242, NULL, NULL, 173987),
(173988, '1.10.510.10-FF-000450', NULL, 'Tyrosine-protein kinase STYK1', 200, NULL, NULL, 173988),
(173989, '1.20.1070.10-FF-001340', NULL, 'Protein PIEZO homolog', 272, NULL, NULL, 173989),
(173990, '3.40.50.360-FF-000045', NULL, 'NADPH-dependent diflavin oxidoreductase 1', 156, NULL, NULL, 173990),
(173991, '2.60.200.20-FF-000010', NULL, 'aprataxin isoform X1', 105, NULL, NULL, 173991),
(173992, '3.30.160.60-FF-000116', NULL, 'Zinc finger protein 107', 28, NULL, NULL, 173992),
(173993, '2.60.200.30-FF-000013', NULL, 'NAD kinase', 135, NULL, NULL, 173993),
(173994, '1.10.287.70-FF-000487', NULL, 'Twk-1', 171, NULL, NULL, 173994),
(173995, '4.10.860.120-FF-000021', NULL, 'DNA-directed RNA polymerase subunit', 119, NULL, NULL, 173995),
(173996, '2.60.120.330-FF-000065', NULL, 'Similar to oxidoreductase', 333, NULL, NULL, 173996),
(173997, '4.10.240.10-FF-000159', NULL, 'Zcf3p', 69, NULL, NULL, 173997),
(173998, '3.30.160.60-FF-003646', NULL, 'Similar to transcription factor Zn, C2H2', 55, NULL, NULL, 173998),
(173999, '1.25.40.10-FF-001509', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 117, NULL, NULL, 173999),
(174000, '3.30.70.330-FF-001374', NULL, 'RNA-binding protein 45', 103, NULL, NULL, 174000),
(174001, '2.60.40.640-FF-000070', NULL, 'beta-arrestin-2 isoform X5', 86, NULL, NULL, 174001),
(174002, '1.20.850.10-FF-000001', NULL, 'Hydrazine dehydrogenase', 238, NULL, NULL, 174002),
(174003, '1.10.287.1040-FF-000015', NULL, 'Exodeoxyribonuclease 7 small subunit', 72, NULL, NULL, 174003),
(174004, '2.60.40.60-FF-000204', NULL, 'Neural-cadherin', 116, NULL, NULL, 174004),
(174005, '3.10.50.40-FF-000081', NULL, 'Peptidylprolyl isomerase', 57, NULL, NULL, 174005),
(174006, '1.10.238.10-FF-000171', NULL, 'Sodium channel protein', 120, NULL, NULL, 174006),
(174007, '1.10.150.50-FF-000226', NULL, 'Eph receptor A4,-like', 70, NULL, NULL, 174007);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(174008, '3.40.30.10-FF-000608', NULL, 'Glutathione S-Transferase', 72, NULL, NULL, 174008),
(174009, '3.30.300.10-FF-000006', NULL, 'S-adenosylmethionine synthase', 110, NULL, NULL, 174009),
(174010, '3.40.50.10090-FF-000067', NULL, 'Uroporphyrinogen III synthase', 44, NULL, NULL, 174010),
(174011, '2.40.50.640-FF-000003', NULL, 'Exoribonuclease 2', 74, NULL, NULL, 174011),
(174012, '3.90.190.10-FF-000567', NULL, 'Tyrosine-protein phosphatase', 66, NULL, NULL, 174012),
(174013, '2.60.40.60-FF-000440', NULL, 'Dachsous, isoform B', 113, NULL, NULL, 174013),
(174014, '3.80.10.10-FF-001331', NULL, 'Promastigote surface antigen protein PSA', 173, NULL, NULL, 174014),
(174015, '2.10.25.10-FF-000735', NULL, 'adhesion G protein-coupled receptor L4', 36, NULL, NULL, 174015),
(174016, '2.60.120.260-FF-000398', NULL, 'Endo-1,4-beta-xylanase A', 160, NULL, NULL, 174016),
(174017, '3.40.50.300-FF-003377', NULL, 'Rad25/xp-B DNA repair helicase, putative', 224, NULL, NULL, 174017),
(174018, '3.40.50.10190-FF-000288', NULL, 'DNA ligase', 104, NULL, NULL, 174018),
(174019, '3.30.565.10-FF-000160', NULL, 'Mismatch repair endonuclease PMS2', 147, NULL, NULL, 174019),
(174020, '3.40.630.30-FF-000692', NULL, 'Predicted protein', 59, NULL, NULL, 174020),
(174021, '1.20.1070.10-FF-001250', NULL, 'Uncharacterized protein', 143, NULL, NULL, 174021),
(174022, '3.40.710.10-FF-000193', NULL, 'D-alanyl-D-alanine carboxypeptidase family protein', 255, NULL, NULL, 174022),
(174023, '3.30.300.20-FF-000009', NULL, 'Ribosome-binding factor A', 114, NULL, NULL, 174023),
(174024, '1.20.1370.30-FF-000003', NULL, 'Malic enzyme', 60, NULL, NULL, 174024),
(174025, '3.10.20.90-FF-000661', NULL, 'Protein SDE2-like', 82, NULL, NULL, 174025),
(174026, '2.10.90.10-FF-000150', NULL, 'Uncharacterized protein', 101, NULL, NULL, 174026),
(174027, '3.30.160.60-FF-000425', NULL, 'PLAG1 like zinc finger 1', 31, NULL, NULL, 174027),
(174028, '1.10.510.10-FF-000124', NULL, 'cyclin-dependent kinase 11B isoform X1', 234, NULL, NULL, 174028),
(174029, '3.90.1170.20-FF-000012', NULL, 'ModD protein', 132, NULL, NULL, 174029),
(174030, '1.20.120.350-FF-000103', NULL, 'Voltage-gated Ion Channel (VIC) Superfamily', 153, NULL, NULL, 174030),
(174031, '3.90.1170.30-FF-000015', NULL, 'Thymidine phosphorylase', 36, NULL, NULL, 174031),
(174032, '4.10.400.10-FF-000150', NULL, 'Glucosidase 2 subunit beta', 38, NULL, NULL, 174032),
(174033, '1.20.58.870-FF-000001', NULL, 'DNA helicase', 112, NULL, NULL, 174033),
(174034, '3.90.1440.10-FF-000002', NULL, 'Protein translocase subunit SecA', 134, NULL, NULL, 174034),
(174035, '3.30.70.330-FF-002785', NULL, NULL, 52, NULL, NULL, 174035),
(174036, '3.30.710.10-FF-000509', NULL, 'Uncharacterized protein', 76, NULL, NULL, 174036),
(174037, '1.20.1070.10-FF-001901', NULL, 'Predicted protein', 288, NULL, NULL, 174037),
(174038, '3.80.10.10-FF-002961', NULL, 'Uncharacterized protein', 70, NULL, NULL, 174038),
(174039, '1.10.8.60-FF-000234', NULL, 'Replication factor C small subunit', 68, NULL, NULL, 174039),
(174040, '2.40.128.20-FF-000048', NULL, 'Vomeronasal secretory protein 1', 153, NULL, NULL, 174040),
(174041, '3.40.50.1100-FF-000209', NULL, 'Threonine synthase like 2', 17, NULL, NULL, 174041),
(174042, '3.30.200.20-FF-001137', NULL, 'CMGC family protein kinase', 94, NULL, NULL, 174042),
(174043, '3.30.160.60-FF-000083', NULL, 'Immunodeficiency virus type I enhancer binding protein 1', 26, NULL, NULL, 174043),
(174044, '1.20.120.350-FF-000064', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 148, NULL, NULL, 174044),
(174045, '3.40.605.10-FF-000077', NULL, 'Probable aldehyde dehydrogenase', 271, NULL, NULL, 174045),
(174046, '3.50.50.60-FF-000040', NULL, 'Methylenetetrahydrofolate--tRNA-(uracil-5-)-methyltransferase TrmFO', 178, NULL, NULL, 174046),
(174047, '1.25.40.10-FF-003297', NULL, 'Uncharacterized protein', 122, NULL, NULL, 174047),
(174048, '3.30.530.20-FF-000021', NULL, 'Abscisic acid receptor PYL5', 186, NULL, NULL, 174048),
(174049, '3.30.800.10-FF-000011', NULL, 'Phosphatidylinositol 4-phosphate 5-kinase-like protein 1', 164, NULL, NULL, 174049);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(174050, '1.25.10.10-FF-003486', NULL, 'Sister chromatid cohesion protein', 250, NULL, NULL, 174050),
(174051, '2.40.50.140-FF-001236', NULL, NULL, 38, NULL, NULL, 174051),
(174052, '3.30.1330.30-FF-000148', NULL, 'Peptide chain release factor subunit 1', 97, NULL, NULL, 174052),
(174053, '3.30.420.10-FF-000588', NULL, NULL, 210, NULL, NULL, 174053),
(174054, '1.10.560.10-FF-000054', NULL, 'Chaperonin 1 60 kDa', 240, NULL, NULL, 174054),
(174055, '1.10.287.40-FF-000017', NULL, 'GM23510', 106, NULL, NULL, 174055),
(174056, '3.30.565.10-FF-000502', NULL, 'Uncharacterized protein', 124, NULL, NULL, 174056),
(174057, '3.40.50.150-FF-000510', NULL, 'Probable methyltransferase PMT15', 185, NULL, NULL, 174057),
(174058, '3.20.200.10-FF-000006', NULL, 'Elongation factor 2 kinase', 109, NULL, NULL, 174058),
(174059, '3.40.50.12710-FF-000027', NULL, 'Uncharacterized protein', 348, NULL, NULL, 174059),
(174060, '3.30.390.110-FF-000002', NULL, '60S ribosomal protein L28', 126, NULL, NULL, 174060),
(174061, '3.30.460.10-FF-000057', NULL, 'CCA-adding enzyme', 142, NULL, NULL, 174061),
(174062, '3.30.160.60-FF-004141', NULL, NULL, 34, NULL, NULL, 174062),
(174063, '2.40.10.10-FF-000121', NULL, 'Peptidase S46 family protein', 56, NULL, NULL, 174063),
(174064, '3.40.1190.10-FF-000022', NULL, 'Folylpolyglutamate synthase', 266, NULL, NULL, 174064),
(174065, '3.30.40.10-FF-001503', NULL, 'E3 ubiquitin-protein ligase RNF170', 113, NULL, NULL, 174065),
(174066, '3.30.70.260-FF-000162', NULL, 'Homoserine dehydrogenase', 65, NULL, NULL, 174066),
(174067, '1.25.40.10-FF-002330', NULL, 'Transcription factor BIM2', 228, NULL, NULL, 174067),
(174068, '3.50.30.30-FF-000081', NULL, 'Probable M28 family peptidase (Homolog to aminopeptidase YwaD)', 134, NULL, NULL, 174068),
(174069, '3.40.50.300-FF-000830', NULL, 'Endonuclease MutS2', 307, NULL, NULL, 174069),
(174070, '2.40.50.100-FF-000072', NULL, 'Biotin carboxylase subunit of acetyl CoA carboxylase', 71, NULL, NULL, 174070),
(174071, '2.40.170.20-FF-000112', NULL, 'SusC homolog', 613, NULL, NULL, 174071),
(174072, '3.40.50.300-FF-000027', NULL, '26S protease regulatory subunit 7', 180, NULL, NULL, 174072),
(174073, '1.25.40.20-FF-000118', NULL, 'Myotrophin', 118, NULL, NULL, 174073),
(174074, '2.130.10.30-FF-000095', NULL, 'RCC1 Chromatin-associated guanine nucleotide exchange factor for Ran (Eurofung)', 446, NULL, NULL, 174074),
(174075, '1.10.1040.10-FF-000059', NULL, '2-dehydropantoate 2-reductase', 134, NULL, NULL, 174075),
(174076, '3.40.140.100-FF-000015', NULL, 'Autophagy protein', 144, NULL, NULL, 174076),
(174077, '3.90.640.10-FF-000198', NULL, 'Actin, gamma', 37, NULL, NULL, 174077),
(174078, '2.30.29.30-FF-001058', NULL, 'Uncharacterized protein', 80, NULL, NULL, 174078),
(174079, '2.60.40.10-FF-003904', NULL, NULL, 71, NULL, NULL, 174079),
(174080, '1.10.510.10-FF-003558', NULL, NULL, 225, NULL, NULL, 174080),
(174081, '1.20.930.40-FF-000033', NULL, 'Uncharacterized protein', 100, NULL, NULL, 174081),
(174082, '3.40.50.1100-FF-000119', NULL, 'Cystathionine Beta-Synthase', 117, NULL, NULL, 174082),
(174083, '3.80.10.10-FF-001022', NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g53420', 233, NULL, NULL, 174083),
(174084, '2.60.40.10-FF-001959', NULL, 'Cilia and flagella associated protein 74', 97, NULL, NULL, 174084),
(174085, '3.90.550.10-FF-000623', NULL, 'Uncharacterized protein', 201, NULL, NULL, 174085),
(174086, '1.25.40.20-FF-000427', NULL, 'Uncharacterized protein, isoform A', 57, NULL, NULL, 174086),
(174087, '3.80.10.10-FF-000398', NULL, 'Slit guidance ligand 2', 63, NULL, NULL, 174087),
(174088, '3.30.160.60-FF-000335', NULL, 'PR domain zinc finger protein 1', 20, NULL, NULL, 174088),
(174089, '1.20.1270.60-FF-000268', NULL, 'Zgc:158689', 103, NULL, NULL, 174089),
(174090, '2.30.30.180-FF-000015', NULL, 'Ribosome maturation factor RimP', 61, NULL, NULL, 174090),
(174091, '3.30.160.60-FF-000644', NULL, 'Zinc finger protein 22', 26, NULL, NULL, 174091),
(174092, '1.10.287.70-FF-000268', NULL, 'TWiK family of potassium channels', 319, NULL, NULL, 174092);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(174093, '1.10.150.40-FF-000004', NULL, 'Barrier-to-autointegration factor', 88, NULL, NULL, 174093),
(174094, '3.30.70.890-FF-000002', NULL, 'Homoserine kinase', 132, NULL, NULL, 174094),
(174095, '2.130.10.10-FF-003961', NULL, 'Predicted protein', 240, NULL, NULL, 174095),
(174096, '1.25.40.10-FF-005242', NULL, 'Uncharacterized protein', 168, NULL, NULL, 174096),
(174097, '3.30.479.20-FF-000069', NULL, 'Elongation factor Ts, mitochondrial', 44, NULL, NULL, 174097),
(174098, '3.30.70.330-FF-001683', NULL, NULL, 136, NULL, NULL, 174098),
(174099, '2.30.30.190-FF-000018', NULL, 'BIK1p Microtubule-associated protein', 82, NULL, NULL, 174099),
(174100, '4.10.400.10-FF-000060', NULL, 'Sortilin related receptor 1', 43, NULL, NULL, 174100),
(174101, '1.25.40.10-FF-000115', NULL, 'Gamma-soluble NSF attachment protein', 276, NULL, NULL, 174101),
(174102, '3.30.160.60-FF-005771', NULL, NULL, 20, NULL, NULL, 174102),
(174103, '2.60.40.10-FF-003556', NULL, NULL, 107, NULL, NULL, 174103),
(174104, '3.40.470.10-FF-000038', NULL, NULL, 106, NULL, NULL, 174104),
(174105, '3.30.40.10-FF-001812', NULL, 'Predicted protein', 62, NULL, NULL, 174105),
(174106, '3.30.50.10-FF-000110', NULL, 'Putative GATA transcription factor 22', 34, NULL, NULL, 174106),
(174107, '1.10.1140.10-FF-000010', NULL, 'ATP synthase subunit beta', 118, NULL, NULL, 174107),
(174108, '3.10.600.10-FF-000005', NULL, 'Pyruvate carboxylase', 46, NULL, NULL, 174108),
(174109, '2.60.40.10-FF-000122', NULL, 'filamin-C isoform X2', 94, NULL, NULL, 174109),
(174110, '2.10.25.10-FF-001005', NULL, 'Laminin subunit gamma-1', 56, NULL, NULL, 174110),
(174111, '3.30.160.60-FF-001864', NULL, 'zinc finger protein 883-like', 38, NULL, NULL, 174111),
(174112, '3.90.190.10-FF-000545', NULL, 'Uncharacterized protein', 138, NULL, NULL, 174112),
(174113, '1.20.58.70-FF-000004', NULL, 'Syntaxin-22 like', 114, NULL, NULL, 174113),
(174114, '3.20.20.190-FF-000026', NULL, 'Phosphoinositide phospholipase C', 321, NULL, NULL, 174114),
(174115, '3.80.10.10-FF-000853', NULL, 'GL13952', 157, NULL, NULL, 174115),
(174116, '2.170.210.10-FF-000015', NULL, 'Non-homologous end-joining factor 1', 59, NULL, NULL, 174116),
(174117, '2.30.130.10-FF-000036', NULL, 'Uncharacterized protein', 59, NULL, NULL, 174117),
(174118, '1.20.140.10-FF-000037', NULL, 'Similar to acyl-CoA dehydrogenase', 151, NULL, NULL, 174118),
(174119, '1.10.287.110-FF-000218', NULL, 'Heat shock protein cognate 20', 112, NULL, NULL, 174119),
(174120, '1.20.1050.80-FF-000027', NULL, 'Uncharacterized protein', 185, NULL, NULL, 174120),
(174121, '3.20.20.70-FF-000834', NULL, NULL, 125, NULL, NULL, 174121),
(174122, '1.50.40.10-FF-000467', NULL, 'Uncharacterized protein', 74, NULL, NULL, 174122),
(174123, '3.40.33.10-FF-000177', NULL, 'Predicted protein', 84, NULL, NULL, 174123),
(174124, '1.20.120.1760-FF-000038', NULL, 'Aminoalcoholphosphotransferase putative', 213, NULL, NULL, 174124),
(174125, '3.40.50.300-FF-002831', NULL, 'Uncharacterized protein', 160, NULL, NULL, 174125),
(174126, '2.40.50.140-FF-001034', NULL, NULL, 183, NULL, NULL, 174126),
(174127, '2.30.110.10-FF-000035', NULL, 'Flavin reductase ActVB', 163, NULL, NULL, 174127),
(174128, '3.30.160.60-FF-003994', NULL, NULL, 47, NULL, NULL, 174128),
(174129, '1.25.40.20-FF-000079', NULL, 'Protein phosphatase 1 regulatory subunit 16B', 169, NULL, NULL, 174129),
(174130, '3.40.50.300-FF-002303', NULL, 'Rab_A02 protein', 211, NULL, NULL, 174130),
(174131, '1.10.510.10-FF-004031', NULL, NULL, 104, NULL, NULL, 174131),
(174132, '1.10.3210.10-FF-000022', NULL, 'Ribonuclease Y', 159, NULL, NULL, 174132),
(174133, '1.20.58.80-FF-000007', NULL, 'Suppressor of K+ transport growth defect 1', 70, NULL, NULL, 174133),
(174134, '3.40.50.360-FF-000129', NULL, 'NAD(P)H dehydrogenase, quinone family', 197, NULL, NULL, 174134),
(174135, '3.30.60.20-FF-000052', NULL, 'Protein kinase C', 57, NULL, NULL, 174135),
(174136, '3.40.50.11350-FF-000035', NULL, 'Predicted protein', 144, NULL, NULL, 174136),
(174137, '3.80.10.10-FF-002983', NULL, 'Uncharacterized protein', 74, NULL, NULL, 174137);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(174138, '1.10.10.10-FF-000523', NULL, 'Rrf2 family transcriptional regulator', 133, NULL, NULL, 174138),
(174139, '3.40.50.300-FF-000162', NULL, 'septin-7 isoform X1', 293, NULL, NULL, 174139),
(174140, '3.20.20.80-FF-000837', NULL, 'Chitinase, putative', 34, NULL, NULL, 174140),
(174141, '3.80.10.10-FF-003601', NULL, 'Uncharacterized protein', 127, NULL, NULL, 174141),
(174142, '3.40.250.10-FF-000073', NULL, 'YCH1p Phosphatase', 144, NULL, NULL, 174142),
(174143, '3.40.30.10-FF-000406', NULL, 'ThioredoXin Domain Containing protein homolog', 151, NULL, NULL, 174143),
(174144, '3.40.50.150-FF-000190', NULL, 'Spermidine synthase', 224, NULL, NULL, 174144),
(174145, '1.10.10.10-FF-001518', NULL, 'Uncharacterized protein', 90, NULL, NULL, 174145),
(174146, '3.30.420.10-FF-000734', NULL, NULL, 31, NULL, NULL, 174146),
(174147, '2.130.10.10-FF-000302', NULL, 'protein NEDD1 isoform X2', 186, NULL, NULL, 174147),
(174148, '2.120.10.80-FF-000025', NULL, 'Kelch-like family member 41', 318, NULL, NULL, 174148),
(174149, '3.40.50.300-FF-005956', NULL, 'DNA mismatch repair protein msh-3', 302, NULL, NULL, 174149),
(174150, '2.60.40.10-FF-005703', NULL, NULL, 57, NULL, NULL, 174150),
(174151, '1.10.150.240-FF-000022', NULL, 'Phosphonoacetaldehyde hydrolase', 78, NULL, NULL, 174151),
(174152, '1.10.510.10-FF-001760', NULL, 'Serine/threonine-protein kinase RIO3', 197, NULL, NULL, 174152),
(174153, '1.25.10.10-FF-000052', NULL, 'Cytoskeleton associated protein 5', 239, NULL, NULL, 174153),
(174154, '2.60.40.10-FF-000324', NULL, 'Down syndrome cell adhesion molecule, isoform D', 102, NULL, NULL, 174154),
(174155, '1.10.287.110-FF-000224', NULL, 'TPR-repeat-containing chaperone protein DNAJ, putative', 71, NULL, NULL, 174155),
(174156, '3.40.525.10-FF-000003', NULL, 'kalirin isoform X2', 160, NULL, NULL, 174156),
(174157, '3.40.50.300-FF-007087', NULL, 'Uncharacterized protein', 296, NULL, NULL, 174157),
(174158, '3.30.420.40-FF-001098', NULL, 'Uncharacterized protein', 66, NULL, NULL, 174158),
(174159, '3.50.30.30-FF-000064', NULL, 'Peptidase', 117, NULL, NULL, 174159),
(174160, '1.25.40.10-FF-002223', NULL, 'CCR4-NOT transcription complex subunit 10', 375, NULL, NULL, 174160),
(174161, '3.40.50.300-FF-005485', NULL, 'Uncharacterized protein, isoform C', 202, NULL, NULL, 174161),
(174162, '1.10.510.10-FF-004502', NULL, NULL, 228, NULL, NULL, 174162),
(174163, '3.30.1390.20-FF-000031', NULL, '60S ribosomal protein L7-2', 89, NULL, NULL, 174163),
(174164, '2.40.30.10-FF-000212', NULL, 'Elongation factor 1-alpha', 88, NULL, NULL, 174164),
(174165, '1.20.58.390-FF-000205', NULL, 'Uncharacterized protein', 120, NULL, NULL, 174165),
(174166, '3.40.50.300-FF-000049', NULL, 'Dynein, axonemal, heavy chain 5', 173, NULL, NULL, 174166),
(174167, '3.80.10.10-FF-003130', NULL, 'Uncharacterized protein', 77, NULL, NULL, 174167),
(174168, '1.20.5.110-FF-000167', NULL, 'Putative syntaxin-3', 106, NULL, NULL, 174168),
(174169, '2.10.25.10-FF-000426', NULL, 'Vitamin K-dependent protein S', 87, NULL, NULL, 174169),
(174170, '1.20.120.1900-FF-000007', NULL, 'Gamma-tubulin complex component', 295, NULL, NULL, 174170),
(174171, '2.60.120.560-FF-000004', NULL, 'Invertase 2', 176, NULL, NULL, 174171),
(174172, '3.40.1190.10-FF-000016', NULL, 'Folylpolyglutamate synthase', 296, NULL, NULL, 174172),
(174173, '2.60.40.10-FF-001960', NULL, 'Unc-5 netrin receptor D', 79, NULL, NULL, 174173),
(174174, '3.40.1190.20-FF-000019', NULL, 'Ribokinase', 302, NULL, NULL, 174174),
(174175, '1.25.40.10-FF-001616', NULL, 'CCR4-NOT transcription complex subunit 10 isoform A', 192, NULL, NULL, 174175),
(174176, '1.20.1250.20-FF-001323', NULL, 'Predicted protein', 218, NULL, NULL, 174176),
(174177, '2.60.120.550-FF-000001', NULL, 'Penton protein', 154, NULL, NULL, 174177),
(174178, '3.40.50.620-FF-000685', NULL, 'Uncharacterized protein', 50, NULL, NULL, 174178),
(174179, '3.40.50.10190-FF-000327', NULL, 'Uncharacterized protein', 67, NULL, NULL, 174179),
(174180, '3.30.830.10-FF-000170', NULL, 'Uncharacterized protein', 107, NULL, NULL, 174180),
(174181, '3.30.460.10-FF-000063', NULL, 'GTP pyrophosphokinase', 150, NULL, NULL, 174181);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(174182, '3.40.1360.10-FF-000029', NULL, 'Topoisomerase-like enzyme1', 75, NULL, NULL, 174182),
(174183, '1.20.1560.10-FF-000618', NULL, 'ABC transporter', 18, NULL, NULL, 174183),
(174184, '1.10.10.60-FF-000280', NULL, 'jerky protein homolog', 52, NULL, NULL, 174184),
(174185, '3.40.50.1820-FF-001044', NULL, 'Abhydrolase domain-containing 8a', 92, NULL, NULL, 174185),
(174186, '3.50.50.60-FF-000984', NULL, 'Flavin-containing monooxygenase', 73, NULL, NULL, 174186),
(174187, '2.20.25.10-FF-000072', NULL, 'Uncharacterized protein', 62, NULL, NULL, 174187),
(174188, '3.30.1330.30-FF-000058', NULL, 'Ribosomal protein', 109, NULL, NULL, 174188),
(174189, '2.60.40.1230-FF-000014', NULL, 'AP-2 complex subunit alpha', 141, NULL, NULL, 174189),
(174190, '2.60.120.200-FF-000638', NULL, 'Uncharacterized protein', 114, NULL, NULL, 174190),
(174191, '1.10.20.10-FF-000024', NULL, 'Histone H3', 135, NULL, NULL, 174191),
(174192, '3.50.30.30-FF-000171', NULL, 'Uncharacterized protein', 122, NULL, NULL, 174192),
(174193, '3.40.50.150-FF-000201', NULL, 'tRNA wybutosine-synthesizing protein 2 homolog', 221, NULL, NULL, 174193),
(174194, '3.30.710.10-FF-000493', NULL, 'Uncharacterized protein', 58, NULL, NULL, 174194),
(174195, '1.20.1280.50-FF-000221', NULL, 'Putative F-box protein At3g47020', 53, NULL, NULL, 174195),
(174196, '2.30.29.30-FF-000816', NULL, 'Rho GTPase activating protein 15', 115, NULL, NULL, 174196),
(174197, '1.20.920.10-FF-000193', NULL, 'Chromatin structure-remodeling complex subunit rsc1', 135, NULL, NULL, 174197),
(174198, '1.10.533.10-FF-000014', NULL, 'Apoptotic protease-activating factor 1', 97, NULL, NULL, 174198),
(174199, '3.30.40.10-FF-001138', NULL, 'Ankyrin_repeats_(Many_copies)/Ankyrin_repeats_(3_ copies)/Zinc_finger_-_C3HC4_type_(RING_finger )_containing_protein_-_putativ', 65, NULL, NULL, 174199),
(174200, '3.30.420.10-FF-000482', NULL, NULL, 207, NULL, NULL, 174200),
(174201, '2.130.10.10-FF-000291', NULL, 'Cilia-and flagella-associated protein 52 isoform X1', 176, NULL, NULL, 174201),
(174202, '3.40.50.720-FF-001350', NULL, 'Cation transport protein, Trk system', 134, NULL, NULL, 174202),
(174203, '1.20.1150.12-FF-000005', NULL, 'Protein disulfide-isomerase like 2-1', 99, NULL, NULL, 174203),
(174204, '3.40.50.2300-FF-000013', NULL, 'Glutamate receptor, metabotropic 4', 289, NULL, NULL, 174204),
(174205, '1.20.140.150-FF-000013', NULL, 'lens fiber membrane intrinsic protein-like', 164, NULL, NULL, 174205),
(174206, '1.20.1250.20-FF-000963', NULL, 'Siderophore iron transporter mirC', 178, NULL, NULL, 174206),
(174207, '2.30.40.10-FF-000157', NULL, 'Uncharacterized protein', 125, NULL, NULL, 174207),
(174208, '3.30.750.44-FF-000019', NULL, NULL, 55, NULL, NULL, 174208),
(174209, '2.130.10.10-FF-005670', NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', 163, NULL, NULL, 174209),
(174210, '1.10.8.50-FF-000012', NULL, 'DNA lyase', 140, NULL, NULL, 174210),
(174211, '3.30.1380.20-FF-000002', NULL, 'Trafficking protein particle complex subunit', 172, NULL, NULL, 174211),
(174212, '3.40.50.300-FF-006103', NULL, 'Uncharacterized protein', 249, NULL, NULL, 174212),
(174213, '3.30.200.20-FF-000035', NULL, 'Serine/threonine protein kinase Stk1', 94, NULL, NULL, 174213),
(174214, '3.90.70.10-FF-000081', NULL, 'cathepsin B-like protease 2', 306, NULL, NULL, 174214),
(174215, '1.25.40.180-FF-000353', NULL, NULL, 54, NULL, NULL, 174215),
(174216, '3.30.70.330-FF-000986', NULL, 'Nucleolysin TIAR-like protein', 138, NULL, NULL, 174216),
(174217, '2.40.128.20-FF-000065', NULL, 'Uncharacterized protein', 74, NULL, NULL, 174217),
(174218, '2.60.40.1220-FF-000011', NULL, 'Copper resistance protein CopC', 101, NULL, NULL, 174218),
(174219, '2.130.10.10-FF-002432', NULL, 'Uncharacterized protein AT4g01860', 211, NULL, NULL, 174219),
(174220, '3.40.630.30-FF-000158', NULL, 'Uncharacterized N-acetyltransferase B9W62_25615', 162, NULL, NULL, 174220),
(174221, '3.30.160.60-FF-004135', NULL, NULL, 35, NULL, NULL, 174221),
(174222, '3.40.50.740-FF-000052', NULL, 'Extracellular oxidoreductase molybdopterin-binding lipoprotein subunit', 200, NULL, NULL, 174222);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(174223, '1.10.510.10-FF-003884', NULL, NULL, 90, NULL, NULL, 174223),
(174224, '3.20.20.80-FF-000585', NULL, 'Si:ch211-226m16.2', 251, NULL, NULL, 174224),
(174225, '2.60.40.3510-FF-000029', NULL, 'Jag2 protein, putative', 108, NULL, NULL, 174225),
(174226, '2.10.50.10-FF-000046', NULL, 'Cysteine repeat modular protein 1', 72, NULL, NULL, 174226),
(174227, '3.10.20.90-FF-000127', NULL, 'serine/threonine-protein kinase WNK4 isoform X1', 85, NULL, NULL, 174227),
(174228, '1.20.120.160-FF-000035', NULL, 'Histidine kinase', 118, NULL, NULL, 174228),
(174229, '3.30.200.20-FF-001890', NULL, 'Inhibitor of nuclear factor kappa-B kinase subunit beta-like Protein', 89, NULL, NULL, 174229),
(174230, '3.40.50.10190-FF-000182', NULL, 'Poly [ADP-ribose] polymerase', 105, NULL, NULL, 174230),
(174231, '3.40.50.2300-FF-001542', NULL, NULL, 50, NULL, NULL, 174231),
(174232, '1.10.10.140-FF-000002', NULL, 'Cytochrome c oxidase assembly factor 6 homolog', 68, NULL, NULL, 174232),
(174233, '1.20.1250.20-FF-000598', NULL, 'YBR241C-like protein', 469, NULL, NULL, 174233),
(174234, '1.10.10.10-FF-001850', NULL, 'Rab family protein', 78, NULL, NULL, 174234),
(174235, '2.60.120.10-FF-000276', NULL, 'Uncharacterized NTE family protein ZK370.4', 133, NULL, NULL, 174235),
(174236, '3.30.1360.210-FF-000002', NULL, '60S ribosomal protein L22-2', 120, NULL, NULL, 174236),
(174237, '1.20.1250.20-FF-001216', NULL, 'Major facilitator superfamily MFS_1', 222, NULL, NULL, 174237),
(174238, '3.40.50.790-FF-000016', NULL, 'Ribosomal protein L1p/L10e family, putative', 88, NULL, NULL, 174238),
(174239, '1.10.510.10-FF-003777', NULL, NULL, 135, NULL, NULL, 174239),
(174240, '3.90.1290.10-FF-000063', NULL, 'Uncharacterized protein', 208, NULL, NULL, 174240),
(174241, '3.30.70.3000-FF-000001', NULL, 'tRNA(His) guanylyltransferase', 267, NULL, NULL, 174241),
(174242, '3.40.50.1820-FF-000791', NULL, 'Dienelactone hydrolase family protein (AFU_orthologue AFUA_6G12740)', 222, NULL, NULL, 174242),
(174243, '1.10.287.370-FF-000072', NULL, 'Prefoldin, putative', 157, NULL, NULL, 174243),
(174244, '3.30.200.20-FF-001671', NULL, 'Uncharacterized protein', 81, NULL, NULL, 174244),
(174245, '2.130.10.10-FF-003736', NULL, 'Uncharacterized protein', 334, NULL, NULL, 174245),
(174246, '3.20.80.10-FF-000040', NULL, 'Uncharacterized protein', 111, NULL, NULL, 174246),
(174247, '3.20.20.70-FF-000582', NULL, NULL, 125, NULL, NULL, 174247),
(174248, '3.40.190.80-FF-000088', NULL, 'Inositol monophosphatase family protein', 102, NULL, NULL, 174248),
(174249, '3.30.1360.220-FF-000005', NULL, 'A kinase anchor protein', 108, NULL, NULL, 174249),
(174250, '1.10.20.10-FF-000243', NULL, NULL, 100, NULL, NULL, 174250),
(174251, '2.60.40.150-FF-000119', NULL, 'C2 domain-containing protein', 146, NULL, NULL, 174251),
(174252, '3.40.50.880-FF-000043', NULL, 'Catalase', 161, NULL, NULL, 174252),
(174253, '3.30.9.10-FF-000026', NULL, 'FAD-dependent oxidoreductase domain-containing protein 1', 167, NULL, NULL, 174253),
(174254, '3.30.200.20-FF-001901', NULL, 'Protein CBR-CHK-2', 78, NULL, NULL, 174254),
(174255, '3.30.160.60-FF-000009', NULL, 'zinc finger protein 79 isoform X2', 28, NULL, NULL, 174255),
(174256, '1.25.40.20-FF-000192', NULL, 'Ankyrin repeat, SAM and basic leucine zipper domain-containing 1', 218, NULL, NULL, 174256),
(174257, '3.20.20.140-FF-000258', NULL, 'Uncharacterized protein', 91, NULL, NULL, 174257),
(174258, '3.40.1000.10-FF-000020', NULL, 'RGM domain family member drag-1', 153, NULL, NULL, 174258),
(174259, '1.25.40.10-FF-002004', NULL, 'Putative signal protein with GGDEF domain', 238, NULL, NULL, 174259),
(174260, '1.20.58.190-FF-000011', NULL, NULL, 131, NULL, NULL, 174260),
(174261, '1.10.1410.10-FF-000110', NULL, 'Uncharacterized protein', 123, NULL, NULL, 174261),
(174262, '3.40.50.300-FF-007194', NULL, 'Uncharacterized protein', 169, NULL, NULL, 174262),
(174263, '1.20.58.2010-FF-000010', NULL, 'Uncharacterized protein', 128, NULL, NULL, 174263),
(174264, '1.10.287.110-FF-000443', NULL, 'Uncharacterized protein', 68, NULL, NULL, 174264);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(174265, '3.30.160.60-FF-000560', NULL, 'Scratch family transcriptional repressor 1', 63, NULL, NULL, 174265),
(174266, '1.20.5.110-FF-000280', NULL, 'Uncharacterized protein', 79, NULL, NULL, 174266),
(174267, '3.40.50.10330-FF-000038', NULL, 'NAD kinase 2, mitochondrial', 198, NULL, NULL, 174267),
(174268, '2.40.160.120-FF-000014', NULL, 'Oxysterol-binding protein', 198, NULL, NULL, 174268),
(174269, '3.40.50.2020-FF-000036', NULL, 'Uncharacterized protein, isoform B', 147, NULL, NULL, 174269),
(174270, '3.30.497.10-FF-000113', NULL, 'Uncharacterized protein', 198, NULL, NULL, 174270),
(174271, '2.60.120.620-FF-000045', NULL, 'Uncharacterized protein', 210, NULL, NULL, 174271),
(174272, '3.40.50.620-FF-000792', NULL, 'Predicted protein', 53, NULL, NULL, 174272),
(174273, '4.10.1240.10-FF-000061', NULL, 'Adhesion G protein-coupled receptor L1', 60, NULL, NULL, 174273),
(174274, '3.30.1370.110-FF-000031', NULL, 'Protein CBG17965', 113, NULL, NULL, 174274),
(174275, '2.60.120.10-FF-000512', NULL, 'Uncharacterized protein', 155, NULL, NULL, 174275),
(174276, '3.30.160.60-FF-005916', NULL, NULL, 76, NULL, NULL, 174276),
(174277, '2.60.40.10-FF-000015', NULL, 'receptor-type tyrosine-protein phosphatase delta isoform X2', 102, NULL, NULL, 174277),
(174278, '1.25.40.10-FF-005348', NULL, 'Uncharacterized protein', 144, NULL, NULL, 174278),
(174279, '1.10.10.350-FF-000043', NULL, NULL, 82, NULL, NULL, 174279),
(174280, '1.25.40.10-FF-005096', NULL, 'Uncharacterized protein', 93, NULL, NULL, 174280),
(174281, '1.10.540.10-FF-000036', NULL, 'Acyl-CoA dehydrogenase FadE24', 128, NULL, NULL, 174281),
(174282, '3.40.50.300-FF-003596', NULL, 'Small GTPase EhRabX26, putative', 187, NULL, NULL, 174282),
(174283, '1.20.1070.10-FF-001115', NULL, 'Uncharacterized protein', 309, NULL, NULL, 174283),
(174284, '3.40.30.10-FF-000625', NULL, 'Protein disulfide isomerase, putative', 132, NULL, NULL, 174284),
(174285, '3.40.605.10-FF-000061', NULL, 'Aldehyde dehydrogenase', 111, NULL, NULL, 174285),
(174286, '1.25.40.10-FF-001970', NULL, 'Uncharacterized protein', 107, NULL, NULL, 174286),
(174287, '1.20.1070.10-FF-000497', NULL, 'Predicted protein', 293, NULL, NULL, 174287),
(174288, '3.40.830.10-FF-000010', NULL, 'Gallate dioxygenase', 225, NULL, NULL, 174288),
(174289, '3.30.200.20-FF-001362', NULL, 'Uncharacterized protein', 95, NULL, NULL, 174289),
(174290, '1.20.1070.10-FF-000749', NULL, 'Uncharacterized protein', 318, NULL, NULL, 174290),
(174291, '2.40.10.230-FF-000018', NULL, 'Uncharacterized protein', 97, NULL, NULL, 174291),
(174292, '3.30.70.330-FF-001481', NULL, 'Uncharacterized protein', 81, NULL, NULL, 174292),
(174293, '2.130.10.10-FF-003427', NULL, 'Uncharacterized protein', 168, NULL, NULL, 174293),
(174294, '4.10.240.10-FF-000069', NULL, 'C6 zinc finger domain protein', 62, NULL, NULL, 174294),
(174295, '3.10.20.30-FF-000008', NULL, 'Ferredoxin, 2Fe-2S type, ISC system', 111, NULL, NULL, 174295),
(174296, '1.25.40.450-FF-000001', NULL, 'Nuclear pore complex protein', 174, NULL, NULL, 174296),
(174297, '2.10.25.10-FF-001140', NULL, 'Protein S', 42, NULL, NULL, 174297),
(174298, '1.10.287.810-FF-000024', NULL, NULL, 52, NULL, NULL, 174298),
(174299, '2.60.40.10-FF-003758', NULL, NULL, 107, NULL, NULL, 174299),
(174300, '1.10.510.10-FF-004250', NULL, NULL, 194, NULL, NULL, 174300),
(174301, '1.10.720.30-FF-000051', NULL, 'SAP domain containing protein, putative', 54, NULL, NULL, 174301),
(174302, '3.30.40.10-FF-001357', NULL, 'Protein CBG08753', 116, NULL, NULL, 174302),
(174303, '4.10.640.10-FF-000015', NULL, '30S ribosomal protein S18', 70, NULL, NULL, 174303),
(174304, '3.60.21.10-FF-000452', NULL, 'Serine/threonine-protein phosphatase', 187, NULL, NULL, 174304),
(174305, '2.130.10.10-FF-005451', NULL, 'Uncharacterized protein', 197, NULL, NULL, 174305),
(174306, '1.10.268.10-FF-000026', NULL, NULL, 152, NULL, NULL, 174306),
(174307, '3.30.160.60-FF-001645', NULL, 'Zinc finger protein 646', 33, NULL, NULL, 174307),
(174308, '2.130.10.10-FF-003197', NULL, 'AGAP006092-PA', 106, NULL, NULL, 174308);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(174309, '1.20.1560.10-FF-000950', NULL, 'ABC transporter, putative', 116, NULL, NULL, 174309),
(174310, '2.60.40.10-FF-003197', NULL, 'Diverse immunoglobulin domain-containing protein 2.1', 101, NULL, NULL, 174310),
(174311, '2.60.40.10-FF-003449', NULL, NULL, 102, NULL, NULL, 174311),
(174312, '1.10.1600.10-FF-000012', NULL, 'AGAP002690-PA', 95, NULL, NULL, 174312),
(174313, '2.60.40.790-FF-000210', NULL, NULL, 98, NULL, NULL, 174313),
(174314, '1.20.1600.10-FF-000066', NULL, 'Outer membrane efflux protein', 323, NULL, NULL, 174314),
(174315, '3.40.50.1950-FF-000009', NULL, 'Coenzyme A biosynthesis bifunctional protein CoaBC', 179, NULL, NULL, 174315),
(174316, '3.40.50.2000-FF-000030', NULL, 'Sterol 3-beta-glucosyltransferase UGT80A2', 234, NULL, NULL, 174316),
(174317, '3.40.50.720-FF-002289', NULL, 'Uncharacterized protein', 197, NULL, NULL, 174317),
(174318, '1.20.140.90-FF-000010', NULL, 'Uncharacterized protein', 179, NULL, NULL, 174318),
(174319, '2.130.10.30-FF-000078', NULL, 'Serine/threonine-protein kinase Nek8', 183, NULL, NULL, 174319),
(174320, '3.40.30.10-FF-000934', NULL, 'Glutathione peroxidase', 116, NULL, NULL, 174320),
(174321, '3.30.1430.10-FF-000009', NULL, 'Uncharacterized protein', 79, NULL, NULL, 174321),
(174322, '1.10.10.10-FF-001827', NULL, 'O-methyltransferase', 98, NULL, NULL, 174322),
(174323, '1.20.120.350-FF-000209', NULL, NULL, 161, NULL, NULL, 174323),
(174324, '3.90.70.10-FF-000620', NULL, 'Uncharacterized protein', 140, NULL, NULL, 174324),
(174325, '2.130.10.10-FF-000072', NULL, 'Regulatory-associated protein of MTOR, complex 1', 220, NULL, NULL, 174325),
(174326, '1.25.40.10-FF-003965', NULL, 'Uncharacterized protein', 244, NULL, NULL, 174326),
(174327, '1.20.1110.10-FF-000214', NULL, NULL, 55, NULL, NULL, 174327),
(174328, '2.130.10.10-FF-004034', NULL, 'Uncharacterized protein', 219, NULL, NULL, 174328),
(174329, '3.40.50.720-FF-001131', NULL, 'Zinc-binding dehydrogenase-like protein', 140, NULL, NULL, 174329),
(174330, '3.50.50.60-FF-001350', NULL, 'Flavin-containing monooxygenase', 202, NULL, NULL, 174330),
(174331, '3.30.60.30-FF-000055', NULL, 'Solute carrier organic anion transporter family member', 50, NULL, NULL, 174331),
(174332, '2.40.10.10-FF-000104', NULL, 'Serine protease HtrA', 97, NULL, NULL, 174332),
(174333, '3.60.21.10-FF-000143', NULL, 'Acid sphingomyelinase-like phosphodiesterase', 101, NULL, NULL, 174333),
(174334, '1.10.510.10-FF-001428', NULL, 'Serine/threonine-protein kinase Nek6', 95, NULL, NULL, 174334),
(174335, '1.10.287.160-FF-000008', NULL, 'serine/threonine-protein kinase N isoform X4', 78, NULL, NULL, 174335),
(174336, '3.40.50.300-FF-000471', NULL, 'ATP-binding cassette, sub-family F (GCN20), member 1', 274, NULL, NULL, 174336),
(174337, '3.40.190.10-FF-000938', NULL, 'Uncharacterized protein', 33, NULL, NULL, 174337),
(174338, '4.10.910.10-FF-000008', NULL, 'Putative mitochondrial 37S ribosomal protein SWS2', 47, NULL, NULL, 174338),
(174339, '1.10.10.60-FF-000061', NULL, 'Trihelix transcription factor GT-2', 62, NULL, NULL, 174339),
(174340, '2.10.220.10-FF-000126', NULL, 'Endoprotease bli-4', 74, NULL, NULL, 174340),
(174341, '4.10.400.10-FF-000166', NULL, 'Low-density lipoprotein receptor-related protein 2', 42, NULL, NULL, 174341),
(174342, '3.40.1390.30-FF-000009', NULL, 'YbgI/family dinuclear metal center protein', 127, NULL, NULL, 174342),
(174343, '3.40.50.300-FF-006209', NULL, 'Uncharacterized protein', 74, NULL, NULL, 174343),
(174344, '1.25.40.10-FF-004241', NULL, 'Uncharacterized protein', 242, NULL, NULL, 174344),
(174345, '2.60.40.10-FF-005809', NULL, NULL, 67, NULL, NULL, 174345),
(174346, '2.60.40.10-FF-005467', NULL, NULL, 103, NULL, NULL, 174346),
(174347, '3.30.930.10-FF-000346', NULL, 'Uncharacterized protein', 67, NULL, NULL, 174347),
(174348, '3.30.200.20-FF-001923', NULL, 'Uncharacterized protein', 30, NULL, NULL, 174348),
(174349, '1.20.1070.10-FF-000188', NULL, 'Neuropeptide S receptor', 343, NULL, NULL, 174349),
(174350, '3.40.50.10810-FF-000221', NULL, 'E3 ubiquitin-protein ligase SHPRH-like Protein', 69, NULL, NULL, 174350);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(174351, '3.40.50.200-FF-000132', NULL, 'Furin2, putative', 131, NULL, NULL, 174351),
(174352, '2.40.240.10-FF-000008', NULL, 'probable glutamine--tRNA ligase', 88, NULL, NULL, 174352),
(174353, '1.25.40.10-FF-003095', NULL, 'YALI0B00528p', 157, NULL, NULL, 174353),
(174354, '3.40.50.300-FF-005850', NULL, 'Uncharacterized protein', 95, NULL, NULL, 174354),
(174355, '3.40.1380.10-FF-000031', NULL, 'ATP synthase gamma subunit, putative', 203, NULL, NULL, 174355),
(174356, '3.30.460.90-FF-000007', NULL, 'Mitochondrial elongation factor 2', 190, NULL, NULL, 174356),
(174357, '3.40.50.2000-FF-001115', NULL, 'Alpha-1,4 glucan phosphorylase', 177, NULL, NULL, 174357),
(174358, '3.40.33.10-FF-000071', NULL, 'Probable pathogenesis-related protein CaO19.2336', 139, NULL, NULL, 174358),
(174359, '1.10.10.60-FF-000313', NULL, 'major centromere autoantigen B', 59, NULL, NULL, 174359),
(174360, '1.10.275.10-FF-000032', NULL, NULL, 100, NULL, NULL, 174360),
(174361, '3.30.200.20-FF-001581', NULL, NULL, 40, NULL, NULL, 174361),
(174362, '1.10.510.10-FF-001737', NULL, 'Protein CBG04906', 223, NULL, NULL, 174362),
(174363, '3.40.630.150-FF-000017', NULL, 'Uncharacterized protein', 166, NULL, NULL, 174363),
(174364, '3.40.1390.20-FF-000006', NULL, 'HPr kinase/phosphorylase', 134, NULL, NULL, 174364),
(174365, '3.40.1380.20-FF-000034', NULL, 'Uncharacterized protein, isoform A', 146, NULL, NULL, 174365),
(174366, '3.10.250.10-FF-000080', NULL, NULL, 110, NULL, NULL, 174366),
(174367, '3.90.70.10-FF-000311', NULL, 'Toxin secretion transporter', 123, NULL, NULL, 174367),
(174368, '1.25.40.70-FF-000072', NULL, 'Uncharacterized protein', 104, NULL, NULL, 174368),
(174369, '3.30.70.2330-FF-000002', NULL, 'Fanconi-associated nuclease', 116, NULL, NULL, 174369),
(174370, '2.130.10.10-FF-002123', NULL, 'Elongator subunit', 134, NULL, NULL, 174370),
(174371, '1.25.40.800-FF-000005', NULL, 'NOT family protein, putative', 200, NULL, NULL, 174371),
(174372, '3.40.50.1000-FF-000281', NULL, 'Copper-transporting ATPase PAA1 chloroplastic', 20, NULL, NULL, 174372),
(174373, '3.30.160.60-FF-001499', NULL, 'Zinc finger protein', 34, NULL, NULL, 174373),
(174374, '1.20.5.2440-FF-000004', NULL, 'rab11 family-interacting protein 5 isoform X2', 65, NULL, NULL, 174374),
(174375, '3.40.1390.10-FF-000003', NULL, 'UDP-N-acetylmuramoyl-L-alanyl-D-glutamate--2, 6-diaminopimelate ligase', 98, NULL, NULL, 174375),
(174376, '2.60.40.1080-FF-000019', NULL, 'Uncharacterized protein', 77, NULL, NULL, 174376),
(174377, '3.40.50.1010-FF-000284', NULL, NULL, 159, NULL, NULL, 174377),
(174378, '3.10.20.350-FF-000003', NULL, 'ORF1a protein', 91, NULL, NULL, 174378),
(174379, '3.30.40.10-FF-001610', NULL, 'Uncharacterized protein', 124, NULL, NULL, 174379),
(174380, '2.60.120.10-FF-000528', NULL, 'cGMP binding protein with small GTPase-serine/threonine kinase-dep-rasgef-gram-and two cGMP binding domains', 127, NULL, NULL, 174380),
(174381, '3.40.50.1110-FF-000016', NULL, '9-O-acetyl-N-acetylneuraminic acid deacetylase', 286, NULL, NULL, 174381),
(174382, '2.40.10.10-FF-000323', NULL, NULL, 105, NULL, NULL, 174382),
(174383, '3.20.20.80-FF-000276', NULL, 'Putative secreted protein', 184, NULL, NULL, 174383),
(174384, '1.10.8.10-FF-000360', NULL, 'OTU deubiquitinase 7B', 34, NULL, NULL, 174384),
(174385, '2.130.10.10-FF-005119', NULL, 'Predicted protein', 116, NULL, NULL, 174385),
(174386, '2.170.16.10-FF-000050', NULL, 'DNA gyrase subunit B', 98, NULL, NULL, 174386),
(174387, '3.40.30.10-FF-000373', NULL, 'Transmembrane serine/threonine-protein kinase E', 190, NULL, NULL, 174387),
(174388, '3.20.20.220-FF-000041', NULL, 'GD14304', 283, NULL, NULL, 174388),
(174389, '1.20.1070.10-FF-002189', NULL, 'Uncharacterized protein', 74, NULL, NULL, 174389),
(174390, '1.25.10.10-FF-001687', NULL, 'Uncharacterized protein', 286, NULL, NULL, 174390),
(174391, '3.40.50.300-FF-001808', NULL, 'Rab GTPase', 202, NULL, NULL, 174391),
(174392, '3.20.20.70-FF-000273', NULL, '4-hydroxy-tetrahydrodipicolinate synthase', 300, NULL, NULL, 174392),
(174393, '3.40.50.300-FF-002522', NULL, 'DNA polymerase III subunit delta', 164, NULL, NULL, 174393);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(174394, '3.90.190.10-FF-000236', NULL, 'Uncharacterized protein', 148, NULL, NULL, 174394),
(174395, '3.40.50.800-FF-000093', NULL, 'Glycyl-tRNA synthetase', 103, NULL, NULL, 174395),
(174396, '1.25.40.10-FF-003550', NULL, 'SET and MYND domain containing 3', 74, NULL, NULL, 174396),
(174397, '3.10.20.360-FF-000006', NULL, NULL, 79, NULL, NULL, 174397),
(174398, '3.40.50.1460-FF-000087', NULL, 'Uncharacterized protein', 217, NULL, NULL, 174398),
(174399, '3.40.50.1000-FF-000623', NULL, NULL, 163, NULL, NULL, 174399),
(174400, '3.40.850.10-FF-000495', NULL, 'Uncharacterized protein', 52, NULL, NULL, 174400),
(174401, '3.80.10.10-FF-003040', NULL, 'Uncharacterized protein', 162, NULL, NULL, 174401),
(174402, '1.10.555.10-FF-000093', NULL, 'RhoGAP domain containing protein', 196, NULL, NULL, 174402),
(174403, '1.25.40.20-FF-001299', NULL, 'BCL3 transcription coactivator', 156, NULL, NULL, 174403),
(174404, '3.40.50.300-FF-004068', NULL, 'Telomerase protein component 1', 167, NULL, NULL, 174404),
(174405, '1.10.472.10-FF-000698', NULL, 'Uncharacterized protein', 54, NULL, NULL, 174405),
(174406, '3.30.70.20-FF-000114', NULL, NULL, 86, NULL, NULL, 174406),
(174407, '3.20.20.80-FF-000731', NULL, 'Uncharacterized protein', 94, NULL, NULL, 174407),
(174408, '1.10.2000.10-FF-000085', NULL, NULL, 142, NULL, NULL, 174408),
(174409, '3.10.170.20-FF-000025', NULL, NULL, 141, NULL, NULL, 174409),
(174410, '1.25.40.10-FF-001296', NULL, 'Prolyl-4-hydroxylase-alpha NE2', 135, NULL, NULL, 174410),
(174411, '2.60.40.150-FF-000013', NULL, 'copine-9 isoform X1', 130, NULL, NULL, 174411),
(174412, '1.20.1070.10-FF-000862', NULL, 'alpha-2A adrenergic receptor isoform X1', 257, NULL, NULL, 174412),
(174413, '1.10.630.10-FF-000408', NULL, 'Cytochrome P450, putative (Eurofung)', 480, NULL, NULL, 174413),
(174414, '1.10.287.550-FF-000002', NULL, 'Steroid sulfatase', 59, NULL, NULL, 174414),
(174415, '3.90.70.10-FF-000401', NULL, 'Ubiquitinyl hydrolase 1', 367, NULL, NULL, 174415),
(174416, '3.40.50.150-FF-000280', NULL, 'mRNA cap guanine-N7 methyltransferase', 286, NULL, NULL, 174416),
(174417, '3.30.70.3400-FF-000014', NULL, 'Multifunctional fusion protein', 75, NULL, NULL, 174417),
(174418, '2.130.10.10-FF-001409', NULL, 'NACHT and WD repeat domain containing 1', 157, NULL, NULL, 174418),
(174419, '2.30.30.1020-FF-000014', NULL, 'Not1_N-terminal_domain_-_CCR4-Not_complex_component/NOT2_/_NOT3_/_NOT5_family_-_putative', 148, NULL, NULL, 174419),
(174420, '3.40.1260.20-FF-000002', NULL, 'Ribonuclease E', 109, NULL, NULL, 174420),
(174421, '2.170.270.10-FF-000232', NULL, 'Uncharacterized protein', 82, NULL, NULL, 174421),
(174422, '3.50.50.60-FF-001366', NULL, 'Flavin-containing monooxygenase', 36, NULL, NULL, 174422),
(174423, '1.10.30.10-FF-000070', NULL, 'Uncharacterized protein, isoform A', 84, NULL, NULL, 174423),
(174424, '1.20.1560.10-FF-000927', NULL, 'Uncharacterized protein', 77, NULL, NULL, 174424),
(174425, '3.30.505.10-FF-000201', NULL, NULL, 113, NULL, NULL, 174425),
(174426, '3.10.580.10-FF-000087', NULL, 'Chloride channel protein', 92, NULL, NULL, 174426),
(174427, '3.30.420.10-FF-000173', NULL, 'DNA polymerase', 217, NULL, NULL, 174427),
(174428, '3.40.1160.10-FF-000048', NULL, 'Amino-acid acetyltransferase, mitochondrial', 259, NULL, NULL, 174428),
(174429, '3.40.630.30-FF-000613', NULL, 'Uncharacterized protein', 200, NULL, NULL, 174429),
(174430, '1.10.10.10-FF-001608', NULL, 'HSF transcription factor', 103, NULL, NULL, 174430),
(174431, '2.60.40.10-FF-001196', NULL, 'Sallimus, isoform P', 98, NULL, NULL, 174431),
(174432, '3.40.50.1980-FF-000012', NULL, 'Iron ABC transporter substrate-binding protein', 105, NULL, NULL, 174432),
(174433, '1.10.418.10-FF-000044', NULL, 'utrophin isoform X2', 118, NULL, NULL, 174433),
(174434, '3.20.20.60-FF-000028', NULL, '2-keto-3-deoxy-L-rhamnonate aldolase-like', 272, NULL, NULL, 174434),
(174435, '3.40.50.1100-FF-000103', NULL, 'Threonine synthase', 93, NULL, NULL, 174435),
(174436, '3.40.30.10-FF-000715', NULL, 'Iodothyronine deiodinase', 188, NULL, NULL, 174436);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(174437, '3.80.10.10-FF-001095', NULL, 'Early embryogenesis protein zyg-11', 155, NULL, NULL, 174437),
(174438, '1.25.10.10-FF-001468', NULL, 'Dynein, axonemal, assembly factor 5', 357, NULL, NULL, 174438),
(174439, '3.40.50.150-FF-001836', NULL, NULL, 59, NULL, NULL, 174439),
(174440, '3.60.21.60-FF-000023', NULL, 'DNA polymerase alpha subunit B', 112, NULL, NULL, 174440),
(174441, '1.20.1250.20-FF-002088', NULL, 'SD04201p', 266, NULL, NULL, 174441),
(174442, '1.10.510.10-FF-002451', NULL, NULL, 200, NULL, NULL, 174442),
(174443, '2.60.40.10-FF-005557', NULL, NULL, 114, NULL, NULL, 174443),
(174444, '4.10.1000.10-FF-000077', NULL, 'Zinc finger C-x8-C-x5-C-x3-H type family protein', 86, NULL, NULL, 174444),
(174445, '1.20.5.1930-FF-000003', NULL, 'Sensor protein', 77, NULL, NULL, 174445),
(174446, '1.10.506.10-FF-000103', NULL, 'Uncharacterized protein', 284, NULL, NULL, 174446),
(174447, '2.130.10.10-FF-001718', NULL, 'AaceriADR331Cp', 148, NULL, NULL, 174447),
(174448, '1.10.357.20-FF-000023', NULL, 'Predicted protein', 185, NULL, NULL, 174448),
(174449, '1.20.900.10-FF-000118', NULL, 'Uncharacterized protein', 204, NULL, NULL, 174449),
(174450, '2.60.120.10-FF-000618', NULL, 'Uncharacterized protein', 143, NULL, NULL, 174450),
(174451, '1.20.1740.10-FF-000262', NULL, 'Uncharacterized protein', 107, NULL, NULL, 174451),
(174452, '1.10.565.10-FF-000043', NULL, 'Peroxisome proliferator-activated receptor gamma', 50, NULL, NULL, 174452),
(174453, '1.10.630.10-FF-000717', NULL, 'Uncharacterized protein', 107, NULL, NULL, 174453),
(174454, '2.30.30.1160-FF-000005', NULL, 'AER067Cp', 131, NULL, NULL, 174454),
(174455, '3.30.1490.120-FF-000021', NULL, 'DNA-directed RNA polymerase I subunit RPA43', 93, NULL, NULL, 174455),
(174456, '1.10.357.10-FF-000020', NULL, 'TetR family transcriptional regulator', 149, NULL, NULL, 174456),
(174457, '2.130.10.10-FF-001376', NULL, 'Os07g0693700 protein', 397, NULL, NULL, 174457),
(174458, '2.60.120.290-FF-000047', NULL, 'Cubilin', 116, NULL, NULL, 174458),
(174459, '2.60.40.1180-FF-000050', NULL, '1,4-alpha-glucan branching enzyme', 96, NULL, NULL, 174459),
(174460, '1.10.10.60-FF-000999', NULL, NULL, 54, NULL, NULL, 174460),
(174461, '1.25.40.860-FF-000017', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 74, NULL, NULL, 174461),
(174462, '1.20.80.10-FF-000078', NULL, 'Predicted protein', 98, NULL, NULL, 174462),
(174463, '3.90.1750.10-FF-000104', NULL, 'Protein CBR-HECD-1', 78, NULL, NULL, 174463),
(174464, '3.40.50.2000-FF-001025', NULL, 'UDP-glucuronosyltransferase', 173, NULL, NULL, 174464),
(174465, '1.10.630.10-FF-000066', NULL, 'Cytochrome P450 71D7', 474, NULL, NULL, 174465),
(174466, '3.30.160.60-FF-002027', NULL, 'Blast:Sal-like protein 3', 98, NULL, NULL, 174466),
(174467, '1.10.630.10-FF-000375', NULL, 'Cytochrome p450 CYP199A2', 412, NULL, NULL, 174467),
(174468, '3.40.630.30-FF-000052', NULL, 'Ribosomal-protein-serine acetyltransferase RimL', 179, NULL, NULL, 174468),
(174469, '3.30.70.1620-FF-000020', NULL, 'Structural maintenance of chromosomes protein', 92, NULL, NULL, 174469),
(174470, '3.10.20.90-FF-000021', NULL, 'focal adhesion kinase 1 isoform X1', 100, NULL, NULL, 174470),
(174471, '3.30.63.20-FF-000002', NULL, '40S ribosomal protein S25', 85, NULL, NULL, 174471),
(174472, '1.10.530.10-FF-000086', NULL, 'Uncharacterized protein', 89, NULL, NULL, 174472),
(174473, '2.30.30.380-FF-000047', NULL, 'Protein transport protein SEC23', 58, NULL, NULL, 174473),
(174474, '3.40.50.300-FF-002051', NULL, 'Spr3p', 290, NULL, NULL, 174474),
(174475, '1.25.10.10-FF-001777', NULL, 'AT21921p', 851, NULL, NULL, 174475),
(174476, '2.60.200.20-FF-000212', NULL, 'Kinesin, putative', 120, NULL, NULL, 174476),
(174477, '3.60.21.10-FF-000014', NULL, '3'',5''-cyclic adenosine monophosphate phosphodiesterase CpdA', 265, NULL, NULL, 174477),
(174478, '1.10.510.10-FF-002142', NULL, 'Kinase, NEK', 306, NULL, NULL, 174478),
(174479, '3.60.21.50-FF-000020', NULL, 'Uncharacterized protein', 272, NULL, NULL, 174479),
(174480, '2.60.40.10-FF-005248', NULL, NULL, 88, NULL, NULL, 174480);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(174481, '4.10.410.10-FF-000116', NULL, 'Serine proteinase inhibitor, putative', 58, NULL, NULL, 174481),
(174482, '2.10.25.10-FF-000499', NULL, 'Predicted protein', 43, NULL, NULL, 174482),
(174483, '3.40.50.300-FF-006013', NULL, 'Predicted protein', 176, NULL, NULL, 174483),
(174484, '3.40.50.300-FF-000358', NULL, 'RAB39B, member RAS oncogene family', 179, NULL, NULL, 174484),
(174485, '3.30.420.40-FF-000024', NULL, 'Heat shock protein SSB1', 142, NULL, NULL, 174485),
(174486, '3.40.30.10-FF-000154', NULL, 'Protein disulfide-isomerase', 142, NULL, NULL, 174486),
(174487, '1.10.486.10-FF-000078', NULL, 'ATP-dependent DNA helicase', 163, NULL, NULL, 174487),
(174488, '2.60.120.10-FF-000057', NULL, 'Cyclic nucleotide-binding domain protein', 138, NULL, NULL, 174488),
(174489, '3.30.70.2740-FF-000018', NULL, 'FAD linked oxidase domain protein', 79, NULL, NULL, 174489),
(174490, '3.40.50.300-FF-002612', NULL, 'RAD24p Checkpoint protein', 182, NULL, NULL, 174490),
(174491, '3.10.100.10-FF-000220', NULL, NULL, 143, NULL, NULL, 174491),
(174492, '3.30.450.20-FF-000565', NULL, 'Uncharacterized protein', 94, NULL, NULL, 174492),
(174493, '3.10.100.10-FF-000310', NULL, NULL, 139, NULL, NULL, 174493),
(174494, '3.30.930.10-FF-000037', NULL, 'Proline--tRNA ligase', 282, NULL, NULL, 174494),
(174495, '3.50.50.60-FF-001456', NULL, 'Protoporphyrinogen oxidase', 77, NULL, NULL, 174495),
(174496, '3.40.50.150-FF-001617', NULL, NULL, 249, NULL, NULL, 174496),
(174497, '3.40.50.720-FF-001237', NULL, 'Redox-sensing transcriptional repressor Rex', 138, NULL, NULL, 174497),
(174498, '1.25.70.10-FF-000050', NULL, NULL, 90, NULL, NULL, 174498),
(174499, '1.10.287.90-FF-000010', NULL, 'Cytochrome c oxidase subunit 2', 86, NULL, NULL, 174499),
(174500, '3.40.50.300-FF-002270', NULL, 'Probable DNA helicase MCM9', 334, NULL, NULL, 174500),
(174501, '3.30.559.30-FF-000112', NULL, 'Siderophore peptide synthetase fer3', 268, NULL, NULL, 174501),
(174502, '2.80.10.50-FF-000081', NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', 178, NULL, NULL, 174502),
(174503, '2.60.220.30-FF-000014', NULL, 'ankyrin-3-like isoform X7', 65, NULL, NULL, 174503),
(174504, '3.40.50.2000-FF-000968', NULL, 'Glycosyl transferase group 1', 94, NULL, NULL, 174504),
(174505, '1.25.40.840-FF-000011', NULL, 'Predicted protein', 169, NULL, NULL, 174505),
(174506, '1.20.58.830-FF-000040', NULL, 'PfEMP1 variant 1 of strain MC', 155, NULL, NULL, 174506),
(174507, '3.40.720.10-FF-000272', NULL, 'Predicted protein', 369, NULL, NULL, 174507),
(174508, '3.30.870.10-FF-000200', NULL, 'Uncharacterized protein', 193, NULL, NULL, 174508),
(174509, '2.10.110.10-FF-000011', NULL, 'Lim and senescent cell antigen-like-containing', 59, NULL, NULL, 174509),
(174510, '1.20.1070.10-FF-000952', NULL, 'Uncharacterized protein', 156, NULL, NULL, 174510),
(174511, '3.40.50.300-FF-006322', NULL, 'Predicted protein', 41, NULL, NULL, 174511),
(174512, '2.40.30.10-FF-000122', NULL, 'Elongation factor Tu', 56, NULL, NULL, 174512),
(174513, '3.30.200.20-FF-001468', NULL, 'Epidermal growth factor receptor a (erythroblastic leukemia viral (v-erb-b) oncogene homolog, avian)', 67, NULL, NULL, 174513),
(174514, '3.30.70.1070-FF-000012', NULL, 'Endolytic peptidoglycan transglycosylase RlpA', 70, NULL, NULL, 174514),
(174515, '3.30.2230.10-FF-000028', NULL, 'Ubiquitin-specific peptidase 32', 77, NULL, NULL, 174515),
(174516, '3.10.105.10-FF-000063', NULL, 'Peptide ABC transporter substrate-binding protein', 215, NULL, NULL, 174516),
(174517, '1.50.40.10-FF-000136', NULL, 'Mitochondrial carrier protein, putative', 146, NULL, NULL, 174517),
(174518, '1.25.40.990-FF-000005', NULL, 'Putative SAC3/GANP family protein', 260, NULL, NULL, 174518),
(174519, '2.130.10.10-FF-001937', NULL, 'Predicted protein', 340, NULL, NULL, 174519),
(174520, '3.30.530.20-FF-000043', NULL, 'StAR-related lipid transfer protein 7', 212, NULL, NULL, 174520),
(174521, '1.10.287.410-FF-000011', NULL, 'Carboxypeptidase', 74, NULL, NULL, 174521),
(174522, '3.40.50.2300-FF-001087', NULL, NULL, 171, NULL, NULL, 174522);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(174523, '3.30.800.10-FF-000033', NULL, NULL, 183, NULL, NULL, 174523),
(174524, '3.30.160.60-FF-002117', NULL, 'Zinc finger protein 142', 54, NULL, NULL, 174524),
(174525, '3.60.130.30-FF-000003', NULL, 'Tet-like dioxygenase 1', 266, NULL, NULL, 174525),
(174526, '1.10.630.10-FF-000627', NULL, 'Uncharacterized protein', 229, NULL, NULL, 174526),
(174527, '1.20.900.10-FF-000085', NULL, 'Uncharacterized protein', 111, NULL, NULL, 174527),
(174528, '1.20.5.730-FF-000010', NULL, 'Rho kinase', 73, NULL, NULL, 174528),
(174529, '1.10.10.790-FF-000039', NULL, NULL, 48, NULL, NULL, 174529),
(174530, '1.20.120.830-FF-000005', NULL, 'Breast cancer anti-estrogen resistance protein 1', 171, NULL, NULL, 174530),
(174531, '2.30.30.1150-FF-000002', NULL, 'PHD finger protein 14 isoform X1', 161, NULL, NULL, 174531),
(174532, '3.30.70.330-FF-000767', NULL, 'Os07g0615400 protein', 100, NULL, NULL, 174532),
(174533, '3.30.70.1230-FF-000116', NULL, 'Uncharacterized protein', 135, NULL, NULL, 174533),
(174534, '3.30.230.130-FF-000041', NULL, 'Cullin family protein, putative', 157, NULL, NULL, 174534),
(174535, '2.70.150.10-FF-000163', NULL, 'Cation transporting ATPase (PacS)', 74, NULL, NULL, 174535),
(174536, '3.50.50.60-FF-001147', NULL, 'Long-chain-alcohol oxidase FAO1', 77, NULL, NULL, 174536),
(174537, '1.10.287.10-FF-000059', NULL, 'Uncharacterized protein', 29, NULL, NULL, 174537),
(174538, '3.40.50.300-FF-005395', NULL, 'Uncharacterized protein', 253, NULL, NULL, 174538),
(174539, '2.40.30.10-FF-000431', NULL, 'Predicted protein', 130, NULL, NULL, 174539),
(174540, '1.10.390.10-FF-000097', NULL, 'Predicted protein', 106, NULL, NULL, 174540),
(174541, '3.30.60.30-FF-000201', NULL, 'Uncharacterized protein', 58, NULL, NULL, 174541),
(174542, '2.130.10.10-FF-001628', NULL, 'WD domain, G-beta repeat-containing protein', 219, NULL, NULL, 174542),
(174543, '3.40.1170.60-FF-000007', NULL, 'DNA polymerase iota', 62, NULL, NULL, 174543),
(174544, '1.10.10.10-FF-000214', NULL, 'Methylated-DNA--protein-cysteine methyltransferase', 87, NULL, NULL, 174544),
(174545, '2.60.40.10-FF-005355', NULL, NULL, 66, NULL, NULL, 174545),
(174546, '3.40.50.10900-FF-000012', NULL, 'Proteasome assembly chaperone 2', 145, NULL, NULL, 174546),
(174547, '1.20.1560.10-FF-000383', NULL, 'ABC transporter ATP-binding protein', 325, NULL, NULL, 174547),
(174548, '3.50.50.60-FF-001355', NULL, 'Uncharacterized protein', 98, NULL, NULL, 174548),
(174549, '3.40.50.10190-FF-000092', NULL, 'BRCA1-associated RING domain protein 1', 106, NULL, NULL, 174549),
(174550, '3.40.50.10490-FF-000075', NULL, 'Apicoplast ribosomal protein S2', 162, NULL, NULL, 174550),
(174551, '2.130.10.10-FF-005428', NULL, 'Uncharacterized protein', 229, NULL, NULL, 174551),
(174552, '3.90.870.10-FF-000024', NULL, 'Expressed protein', 213, NULL, NULL, 174552),
(174553, '1.25.40.10-FF-001953', NULL, 'Prolyl 4-hydroxylase subunit alpha-2', 129, NULL, NULL, 174553),
(174554, '3.80.10.10-FF-002753', NULL, 'Owl monkey involucrin (small allele)', 310, NULL, NULL, 174554),
(174555, '3.40.50.300-FF-003585', NULL, 'GD16400', 206, NULL, NULL, 174555),
(174556, '1.20.1610.10-FF-000022', NULL, 'Uncharacterized protein', 66, NULL, NULL, 174556),
(174557, '3.30.160.60-FF-003764', NULL, NULL, 64, NULL, NULL, 174557),
(174558, '1.10.10.2660-FF-000016', NULL, 'Ubiquitin-activating enzyme E1', 232, NULL, NULL, 174558),
(174559, '3.10.20.600-FF-000005', NULL, 'NADH-quinone oxidoreductase subunit F', 93, NULL, NULL, 174559),
(174560, '1.25.40.470-FF-000086', NULL, 'Uncharacterized protein', 159, NULL, NULL, 174560),
(174561, '3.90.550.10-FF-000180', NULL, 'Hexosyltransferase', 262, NULL, NULL, 174561),
(174562, '3.30.420.10-FF-000392', NULL, NULL, 73, NULL, NULL, 174562),
(174563, '1.20.120.850-FF-000017', NULL, 'DNA repair and recombination protein RAD54B', 88, NULL, NULL, 174563),
(174564, '1.10.8.10-FF-000135', NULL, 'UBA/TS-N domain protein', 73, NULL, NULL, 174564),
(174565, '1.10.3450.40-FF-000009', NULL, 'Signal recognition particle subunit SRP68', 248, NULL, NULL, 174565),
(174566, '1.10.10.2670-FF-000019', NULL, 'RNA polymerase II elongation factor ell1', 95, NULL, NULL, 174566);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(174567, '1.10.472.130-FF-000017', NULL, 'Uncharacterized protein, isoform D', 89, NULL, NULL, 174567),
(174568, '3.20.20.70-FF-000604', NULL, NULL, 176, NULL, NULL, 174568),
(174569, '2.40.20.10-FF-000043', NULL, 'Metalloendopeptidase', 89, NULL, NULL, 174569),
(174570, '1.10.510.10-FF-002131', NULL, NULL, 42, NULL, NULL, 174570),
(174571, '3.10.20.310-FF-000025', NULL, 'Outer membrane protein assembly factor', 77, NULL, NULL, 174571),
(174572, '3.30.200.20-FF-001805', NULL, 'LIM domain kinase 1-like', 88, NULL, NULL, 174572),
(174573, '1.10.287.850-FF-000007', NULL, 'PE family protein', 89, NULL, NULL, 174573),
(174574, '3.20.20.10-FF-000047', NULL, 'Antizyme inhibitor 1b', 95, NULL, NULL, 174574),
(174575, '1.10.8.60-FF-000094', NULL, 'Cell division control protein', 100, NULL, NULL, 174575),
(174576, '4.10.280.10-FF-000055', NULL, 'DNA-binding protein inhibitor ID-2', 62, NULL, NULL, 174576),
(174577, '3.40.1020.10-FF-000004', NULL, 'Threonine dehydratase', 190, NULL, NULL, 174577),
(174578, '3.30.1120.10-FF-000020', NULL, 'Arylsulfatase A', 76, NULL, NULL, 174578),
(174579, '3.30.2140.20-FF-000018', NULL, 'Uncharacterized protein', 277, NULL, NULL, 174579),
(174580, '3.40.50.300-FF-002062', NULL, 'Rab-related protein 4', 176, NULL, NULL, 174580),
(174581, '3.40.50.10190-FF-000187', NULL, 'PAX transcription activation domain interacting protein', 108, NULL, NULL, 174581),
(174582, '1.25.10.10-FF-003475', NULL, 'eIF-2-alpha kinase activator GCN1', 159, NULL, NULL, 174582),
(174583, '1.10.2000.10-FF-000068', NULL, NULL, 118, NULL, NULL, 174583),
(174584, '1.10.287.810-FF-000007', NULL, 'Mitochondrial import inner membrane translocase', 70, NULL, NULL, 174584),
(174585, '1.20.1070.10-FF-000845', NULL, 'Oxytocin receptor', 284, NULL, NULL, 174585),
(174586, '2.130.10.10-FF-000532', NULL, 'semaphorin-4F isoform X2', 83, NULL, NULL, 174586),
(174587, '3.20.20.80-FF-000607', NULL, 'Beta-glucuronidase, putative', 180, NULL, NULL, 174587),
(174588, '3.10.105.10-FF-000074', NULL, 'Peptide ABC transporter substrate-binding protein', 224, NULL, NULL, 174588),
(174589, '3.40.470.10-FF-000044', NULL, NULL, 197, NULL, NULL, 174589),
(174590, '2.30.30.570-FF-000008', NULL, 'Uncharacterized protein', 35, NULL, NULL, 174590),
(174591, '1.20.120.1510-FF-000008', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 108, NULL, NULL, 174591),
(174592, '3.40.1160.10-FF-000065', NULL, 'Aspartokinase', 304, NULL, NULL, 174592),
(174593, '2.60.120.920-FF-000039', NULL, 'Tripartite motif-containing protein 26', 92, NULL, NULL, 174593),
(174594, '2.10.25.10-FF-001230', NULL, 'GD23945', 33, NULL, NULL, 174594),
(174595, '1.20.5.340-FF-000101', NULL, 'Non-muscle myosin heavy chain II', 121, NULL, NULL, 174595),
(174596, '3.90.1110.10-FF-000022', NULL, 'DNA-directed RNA polymerase subunit beta', 178, NULL, NULL, 174596),
(174597, '1.20.1050.10-FF-000299', NULL, 'Uncharacterized protein', 74, NULL, NULL, 174597),
(174598, '2.40.10.10-FF-000441', NULL, NULL, 78, NULL, NULL, 174598),
(174599, '3.20.20.80-FF-000596', NULL, 'Uncharacterized protein', 198, NULL, NULL, 174599),
(174600, '3.40.50.1240-FF-000010', NULL, 'Prostatic acid phosphatase', 345, NULL, NULL, 174600),
(174601, '1.10.287.950-FF-000021', NULL, 'Methyl-accepting chemotaxis protein', 306, NULL, NULL, 174601),
(174602, '3.20.20.70-FF-000593', NULL, NULL, 231, NULL, NULL, 174602),
(174603, '1.20.1270.280-FF-000004', NULL, 'Cytoplasmic dynein heavy chain 2', 189, NULL, NULL, 174603),
(174604, '1.10.1100.10-FF-000002', NULL, 'Transcription initiation factor TFIID subunit', 67, NULL, NULL, 174604),
(174605, '2.60.40.60-FF-000103', NULL, 'protocadherin-18 isoform X2', 104, NULL, NULL, 174605),
(174606, '1.20.1070.10-FF-001351', NULL, 'Uncharacterized protein', 267, NULL, NULL, 174606),
(174607, '1.20.990.10-FF-000051', NULL, 'Uncharacterized protein', 88, NULL, NULL, 174607),
(174608, '4.10.970.10-FF-000006', NULL, 'Inverted repeat-binding protein', 73, NULL, NULL, 174608),
(174609, '2.60.120.330-FF-000076', NULL, 'Uncharacterized protein', 337, NULL, NULL, 174609);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(174610, '1.20.120.1080-FF-000065', NULL, 'RNA helicase, putative', 107, NULL, NULL, 174610),
(174611, '1.10.1200.10-FF-000049', NULL, 'Nonribosomal siderophore peptide synthase SidC', 82, NULL, NULL, 174611),
(174612, '2.130.10.10-FF-000206', NULL, 'Rho guanine nucleotide exchange factor 17', 225, NULL, NULL, 174612),
(174613, '1.25.40.20-FF-000433', NULL, 'Probable serine/threonine-protein kinase DDB_G0278535', 227, NULL, NULL, 174613),
(174614, '2.130.10.10-FF-001729', NULL, 'Predicted protein', 302, NULL, NULL, 174614),
(174615, '3.30.2290.10-FF-000015', NULL, 'Zinc metalloprotease TldD homolog', 195, NULL, NULL, 174615),
(174616, '1.10.30.10-FF-000081', NULL, 'High mobility group protein B4, putative', 91, NULL, NULL, 174616),
(174617, '1.10.510.10-FF-004160', NULL, NULL, 198, NULL, NULL, 174617),
(174618, '1.10.238.10-FF-000070', NULL, 'Centrin-1', 84, NULL, NULL, 174618),
(174619, '3.30.70.330-FF-001037', NULL, 'IGF-II mRNA-binding protein, isoform L', 124, NULL, NULL, 174619),
(174620, '1.25.40.20-FF-001861', NULL, 'Phosphocholine transferase AnkX', 133, NULL, NULL, 174620),
(174621, '1.25.40.90-FF-000089', NULL, 'Uncharacterized protein', 133, NULL, NULL, 174621),
(174622, '2.30.29.30-FF-000794', NULL, 'BEACH domain-containing protein C1', 106, NULL, NULL, 174622),
(174623, '2.60.40.840-FF-000012', NULL, 'Cone arrestin', 122, NULL, NULL, 174623),
(174624, '1.20.140.150-FF-000002', NULL, 'Voltage-dependent calcium channel gamma-2 subunit', 210, NULL, NULL, 174624),
(174625, '2.10.50.10-FF-000142', NULL, 'Predicted protein', 63, NULL, NULL, 174625),
(174626, '1.10.510.10-FF-000091', NULL, 'Calcium/calmodulin-dependent protein kinase kinase 2 isoform 1', 179, NULL, NULL, 174626),
(174627, '3.40.50.10330-FF-000055', NULL, 'NAD kinase', 106, NULL, NULL, 174627),
(174628, '1.25.10.10-FF-003380', NULL, 'Uncharacterized protein', 148, NULL, NULL, 174628),
(174629, '3.80.10.10-FF-000499', NULL, 'Relaxin family peptide receptor 2', 112, NULL, NULL, 174629),
(174630, '1.10.530.10-FF-000002', NULL, 'Membrane-bound lytic murein transglycosylase C', 184, NULL, NULL, 174630),
(174631, '1.20.58.70-FF-000100', NULL, 'Syntaxin 4', 159, NULL, NULL, 174631),
(174632, '1.50.10.10-FF-000089', NULL, 'Predicted protein', 300, NULL, NULL, 174632),
(174633, '1.25.40.10-FF-000430', NULL, 'Tetratricopeptide repeat protein 30A', 62, NULL, NULL, 174633),
(174634, '3.30.160.60-FF-000212', NULL, 'zinc finger protein 382 isoform X2', 29, NULL, NULL, 174634),
(174635, '1.20.120.350-FF-000204', NULL, NULL, 103, NULL, NULL, 174635),
(174636, '1.10.630.10-FF-000728', NULL, 'CYtochrome P450 family', 95, NULL, NULL, 174636),
(174637, '3.40.50.300-FF-003000', NULL, 'ATP-dependent DNA helicase', 139, NULL, NULL, 174637),
(174638, '1.20.5.110-FF-000263', NULL, 'Uncharacterized protein', 105, NULL, NULL, 174638),
(174639, '2.60.40.3710-FF-000005', NULL, 'Lipoprotein-anchoring transpeptidase ErfK/SrfK', 101, NULL, NULL, 174639),
(174640, '3.80.10.10-FF-001230', NULL, 'Leucine Rich repeat, putative', 201, NULL, NULL, 174640),
(174641, '3.60.21.50-FF-000014', NULL, 'Probable DNA polymerase delta small subunit', 279, NULL, NULL, 174641),
(174642, '3.30.40.10-FF-000880', NULL, 'Unplaced genomic scaffold supercont2.7, whole genome shotgun sequence', 107, NULL, NULL, 174642),
(174643, '1.25.10.10-FF-003149', NULL, 'Unc-45 myosin chaperone A', 58, NULL, NULL, 174643),
(174644, '2.40.150.20-FF-000004', NULL, '39S ribosomal protein L14, mitochondrial', 115, NULL, NULL, 174644),
(174645, '1.20.58.80-FF-000092', NULL, 'Vacuolar sorting protein, putative', 65, NULL, NULL, 174645),
(174646, '1.25.40.20-FF-000219', NULL, 'Leucine-rich repeat serine/threonine-protein kinase 2', 128, NULL, NULL, 174646),
(174647, '2.60.40.10-FF-004253', NULL, NULL, 116, NULL, NULL, 174647),
(174648, '3.40.30.10-FF-000491', NULL, 'TlpA family protein disulfide reductase', 148, NULL, NULL, 174648),
(174649, '1.10.533.10-FF-000025', NULL, 'THO complex subunit 1', 84, NULL, NULL, 174649),
(174650, '1.20.120.550-FF-000034', NULL, 'Glutathione S-transferase', 146, NULL, NULL, 174650);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(174651, '1.20.140.160-FF-000005', NULL, 'RNA polymerase subunit sigma-70', 85, NULL, NULL, 174651),
(174652, '2.60.40.10-FF-005681', NULL, NULL, 82, NULL, NULL, 174652),
(174653, '1.25.50.20-FF-000035', NULL, 'Putative aminopeptidase-2', 332, NULL, NULL, 174653),
(174654, '3.40.1360.10-FF-000046', NULL, 'DNA primase', 130, NULL, NULL, 174654),
(174655, '3.40.50.1820-FF-000667', NULL, 'Predicted protein', 291, NULL, NULL, 174655),
(174656, '3.40.120.10-FF-000063', NULL, 'Phosphomannomutase PmmA', 135, NULL, NULL, 174656),
(174657, '3.90.105.10-FF-000022', NULL, 'Molybdenum cofactor biosynthesis protein', 55, NULL, NULL, 174657),
(174658, '2.60.40.60-FF-000092', NULL, 'Protocadherin 8', 107, NULL, NULL, 174658),
(174659, '3.40.50.360-FF-000039', NULL, 'Nitric oxide synthase', 203, NULL, NULL, 174659),
(174660, '3.40.50.300-FF-004523', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily', 192, NULL, NULL, 174660),
(174661, '2.80.10.50-FF-000204', NULL, 'Protein let-756', 154, NULL, NULL, 174661),
(174662, '2.60.40.10-FF-000228', NULL, 'obscurin isoform X4', 88, NULL, NULL, 174662),
(174663, '2.40.50.140-FF-000966', NULL, NULL, 158, NULL, NULL, 174663),
(174664, '1.10.287.40-FF-000023', NULL, 'Serine--tRNA ligase', 103, NULL, NULL, 174664),
(174665, '1.20.1250.20-FF-001340', NULL, 'Putative MFS-type transporter C09D4.1', 209, NULL, NULL, 174665),
(174666, '3.60.40.10-FF-000283', NULL, 'Uncharacterized protein', 246, NULL, NULL, 174666),
(174667, '3.20.20.105-FF-000005', NULL, 'Queuine tRNA-ribosyltransferase, putative', 444, NULL, NULL, 174667),
(174668, '3.40.50.1820-FF-001061', NULL, 'Carboxypeptidase', 245, NULL, NULL, 174668),
(174669, '1.10.10.60-FF-000521', NULL, 'SWR1-complex protein 4', 91, NULL, NULL, 174669),
(174670, '3.60.21.60-FF-000017', NULL, 'DNA polymerase alpha subunit B', 95, NULL, NULL, 174670),
(174671, '3.30.70.580-FF-000010', NULL, 'Pseudouridine synthase', 76, NULL, NULL, 174671),
(174672, '1.25.10.10-FF-000602', NULL, 'Vps15p', 341, NULL, NULL, 174672),
(174673, '1.10.472.10-FF-000321', NULL, 'Uncharacterized protein', 84, NULL, NULL, 174673),
(174674, '2.140.10.30-FF-000009', NULL, 'Uncharacterized protein, isoform D', 448, NULL, NULL, 174674),
(174675, '2.40.50.120-FF-000067', NULL, 'Uncharacterized protein', 85, NULL, NULL, 174675),
(174676, '2.100.10.50-FF-000012', NULL, 'Uncharacterized protein', 39, NULL, NULL, 174676),
(174677, '3.40.50.720-FF-001221', NULL, 'Os02g0151600 protein', 93, NULL, NULL, 174677),
(174678, '3.40.50.300-FF-007749', NULL, 'Uncharacterized protein', 75, NULL, NULL, 174678),
(174679, '3.40.47.10-FF-000012', NULL, '3-ketoacyl-CoA thiolase, peroxisomal', 224, NULL, NULL, 174679),
(174680, '3.30.70.3250-FF-000025', NULL, NULL, 130, NULL, NULL, 174680),
(174681, '3.90.70.10-FF-000530', NULL, 'Ubiquitin carboxyl-terminal hydrolase 4', 255, NULL, NULL, 174681),
(174682, '3.50.80.10-FF-000010', NULL, 'D-aminoacyl-tRNA deacylase', 150, NULL, NULL, 174682),
(174683, '1.20.1250.20-FF-000946', NULL, 'Major facilitator superfamily protein', 184, NULL, NULL, 174683),
(174684, '3.40.50.2300-FF-000030', NULL, 'PTS system, ascorbate-specific, IIB component', 92, NULL, NULL, 174684),
(174685, '4.10.320.30-FF-000003', NULL, 'Myelin transcription factor 1a', 22, NULL, NULL, 174685),
(174686, '2.30.30.1020-FF-000008', NULL, 'CCR4-NOT transcription complex subunit 2', 179, NULL, NULL, 174686),
(174687, '4.10.410.10-FF-000004', NULL, 'Tissue factor pathway inhibitor', 62, NULL, NULL, 174687),
(174688, '3.10.250.10-FF-000085', NULL, NULL, 105, NULL, NULL, 174688),
(174689, '1.20.58.390-FF-000200', NULL, 'Uncharacterized protein', 136, NULL, NULL, 174689),
(174690, '1.10.455.10-FF-000023', NULL, 'Uncharacterized protein', 41, NULL, NULL, 174690),
(174691, '2.30.29.30-FF-000468', NULL, 'Uncharacterized protein', 123, NULL, NULL, 174691),
(174692, '3.40.50.2300-FF-001227', NULL, NULL, 32, NULL, NULL, 174692),
(174693, '4.10.220.110-FF-000003', NULL, 'Type IV secretion protein Rhs', 59, NULL, NULL, 174693),
(174694, '1.25.40.70-FF-000083', NULL, 'Predicted protein', 92, NULL, NULL, 174694);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(174695, '3.40.50.150-FF-001376', NULL, NULL, 176, NULL, NULL, 174695),
(174696, '2.30.42.10-FF-000549', NULL, NULL, 79, NULL, NULL, 174696),
(174697, '3.30.930.10-FF-000357', NULL, 'ATP phosphoribosyltransferase regulatory subunit', 300, NULL, NULL, 174697),
(174698, '1.20.1250.20-FF-001435', NULL, 'Inositol transporter 4', 135, NULL, NULL, 174698),
(174699, '1.10.10.1830-FF-000003', NULL, 'Non-ribosomal peptide synthetase', 53, NULL, NULL, 174699),
(174700, '2.130.10.10-FF-003293', NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', 274, NULL, NULL, 174700),
(174701, '3.90.70.10-FF-000058', NULL, 'Ubiquitin carboxyl-terminal hydrolase 21', 355, NULL, NULL, 174701),
(174702, '1.10.238.10-FF-000182', NULL, 'E3 ubiquitin-protein ligase CBL-C', 89, NULL, NULL, 174702),
(174703, '3.40.50.300-FF-004102', NULL, 'Uncharacterized protein', 170, NULL, NULL, 174703),
(174704, '2.30.30.490-FF-000092', NULL, 'Nucleic acid binding protein', 70, NULL, NULL, 174704),
(174705, '1.25.40.10-FF-003656', NULL, 'Uncharacterized protein', 212, NULL, NULL, 174705),
(174706, '3.40.30.10-FF-000165', NULL, 'glutaredoxin-3 isoform X1', 128, NULL, NULL, 174706),
(174707, '1.20.1070.10-FF-001025', NULL, 'Olfactory receptor 1262', 119, NULL, NULL, 174707),
(174708, '2.40.30.10-FF-000324', NULL, 'YALI0C21362p', 103, NULL, NULL, 174708),
(174709, '2.10.90.10-FF-000037', NULL, 'neurturin', 103, NULL, NULL, 174709),
(174710, '3.30.40.10-FF-001481', NULL, 'YALI0F22561p', 84, NULL, NULL, 174710),
(174711, '3.90.180.10-FF-000168', NULL, 'Predicted protein', 93, NULL, NULL, 174711),
(174712, '3.40.50.2000-FF-000738', NULL, 'Glycosyltransferase', 255, NULL, NULL, 174712),
(174713, '2.60.40.60-FF-000215', NULL, 'FAT atypical cadherin 2', 107, NULL, NULL, 174713),
(174714, '3.40.50.720-FF-001900', NULL, 'Pyrroline-5-carboxylate reductase', 172, NULL, NULL, 174714),
(174715, '1.20.1560.10-FF-000478', NULL, 'Uncharacterized ABC transporter ATP-binding protein HI_0663', 314, NULL, NULL, 174715),
(174716, '3.30.420.10-FF-000487', NULL, 'REV3 like, DNA directed polymerase zeta catalytic subunit', 237, NULL, NULL, 174716),
(174717, '3.40.50.1100-FF-000013', NULL, 'Threonine synthase', 97, NULL, NULL, 174717),
(174718, '1.20.58.60-FF-000468', NULL, 'AGAP009554-PA', 218, NULL, NULL, 174718),
(174719, '1.25.40.20-FF-000096', NULL, 'Ankyrin repeat and SOCS box containing 12', 262, NULL, NULL, 174719),
(174720, '3.30.1680.10-FF-000022', NULL, 'Semaphorin 4B', 68, NULL, NULL, 174720),
(174721, '3.40.50.300-FF-001668', NULL, 'Non-structural polyprotein pORF1', 119, NULL, NULL, 174721),
(174722, '3.30.70.330-FF-001149', NULL, 'RNA binding motif protein X-linked 2', 91, NULL, NULL, 174722),
(174723, '2.10.25.10-FF-001016', NULL, 'Delta-like protein', 64, NULL, NULL, 174723),
(174724, '1.10.472.80-FF-000218', NULL, NULL, 146, NULL, NULL, 174724),
(174725, '3.40.630.30-FF-000153', NULL, 'GNAT family acetyltransferase', 162, NULL, NULL, 174725),
(174726, '3.10.50.40-FF-000058', NULL, 'Trigger factor', 95, NULL, NULL, 174726),
(174727, '3.40.50.720-FF-001007', NULL, 'Arogenate dehydrogenase 2, chloroplastic', 191, NULL, NULL, 174727),
(174728, '1.50.10.160-FF-000016', NULL, 'Os11g0474900 protein', 81, NULL, NULL, 174728),
(174729, '1.20.920.10-FF-000198', NULL, 'Putative SWI/SNF catalytic subunit', 155, NULL, NULL, 174729),
(174730, '4.10.800.20-FF-000014', NULL, 'AMP deaminase', 67, NULL, NULL, 174730),
(174731, '3.80.10.10-FF-000387', NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g06840', 162, NULL, NULL, 174731),
(174732, '3.30.160.60-FF-000324', NULL, 'Early growth response protein 4', 29, NULL, NULL, 174732),
(174733, '2.30.29.30-FF-000682', NULL, 'WASP (Actin cytoskeleton modulator) homolog', 161, NULL, NULL, 174733),
(174734, '3.30.70.590-FF-000013', NULL, 'Uncharacterized protein', 124, NULL, NULL, 174734),
(174735, '1.20.140.100-FF-000015', NULL, 'Dynein Heavy Chain', 145, NULL, NULL, 174735),
(174736, '1.20.1250.20-FF-000851', NULL, 'Gon-2 Extragenic Modifier', 236, NULL, NULL, 174736),
(174737, '3.80.10.10-FF-003028', NULL, 'Predicted protein', 133, NULL, NULL, 174737);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(174738, '3.80.30.20-FF-000031', NULL, 'Uncharacterized protein', 114, NULL, NULL, 174738),
(174739, '3.20.20.120-FF-000016', NULL, 'Mandelate racemase/muconate lactonizing protein', 271, NULL, NULL, 174739),
(174740, '1.10.1520.10-FF-000096', NULL, 'Uncharacterized protein', 140, NULL, NULL, 174740),
(174741, '3.40.50.1100-FF-000108', NULL, 'Threonine synthase', 192, NULL, NULL, 174741),
(174742, '3.40.50.1820-FF-001156', NULL, 'Carboxylic ester hydrolase', 406, NULL, NULL, 174742),
(174743, '4.10.800.10-FF-000011', NULL, 'Thyroglobulin', 63, NULL, NULL, 174743),
(174744, '2.130.10.10-FF-003079', NULL, 'Predicted protein', 105, NULL, NULL, 174744),
(174745, '3.10.20.90-FF-000122', NULL, 'Fas associated factor 1', 72, NULL, NULL, 174745),
(174746, '3.80.10.10-FF-001342', NULL, 'F-box and leucine-rich repeat protein 7', 236, NULL, NULL, 174746),
(174747, '3.40.190.10-FF-000106', NULL, 'Prephenate dehydratase', 88, NULL, NULL, 174747),
(174748, '1.10.150.50-FF-000018', NULL, 'Polycomb protein scmh1 isoform 4', 75, NULL, NULL, 174748),
(174749, '1.50.10.150-FF-000013', NULL, 'Tellurite resistance protein TehA', 312, NULL, NULL, 174749),
(174750, '1.25.40.10-FF-000104', NULL, 'Fem-1 homolog c (C.elegans)', 109, NULL, NULL, 174750),
(174751, '1.10.555.10-FF-000087', NULL, 'RalA-binding protein 1', 197, NULL, NULL, 174751),
(174752, '3.90.190.10-FF-000096', NULL, 'Tyrosine-protein phosphatase 69D', 290, NULL, NULL, 174752),
(174753, '3.40.50.12160-FF-000025', NULL, '(Dimethylallyl)adenosine tRNA methylthiotransferase', 120, NULL, NULL, 174753),
(174754, '2.160.20.80-FF-000002', NULL, 'Potassium channel tetramerization domain-containing 9a', 176, NULL, NULL, 174754),
(174755, '3.30.40.10-FF-000992', NULL, 'LD19244p', 90, NULL, NULL, 174755),
(174756, '3.40.50.1240-FF-000122', NULL, 'Phosphoglycerate mutase-like protein', 224, NULL, NULL, 174756),
(174757, '3.30.70.1620-FF-000008', NULL, 'Structural maintenance of chromosomes protein', 80, NULL, NULL, 174757),
(174758, '3.80.10.10-FF-002539', NULL, 'TOLl (Drosophila) family', 146, NULL, NULL, 174758),
(174759, '2.130.10.10-FF-003972', NULL, 'Breast carcinoma AMPlified sequence, putative', 237, NULL, NULL, 174759),
(174760, '3.30.70.330-FF-001363', NULL, 'Os02g0815200 protein', 101, NULL, NULL, 174760),
(174761, '2.40.50.100-FF-000061', NULL, '50S ribosomal protein L27', 89, NULL, NULL, 174761),
(174762, '1.20.58.60-FF-000682', NULL, 'Uncharacterized protein', 115, NULL, NULL, 174762),
(174763, '1.20.920.10-FF-000209', NULL, 'Uncharacterized protein', 112, NULL, NULL, 174763),
(174764, '3.40.50.300-FF-007963', NULL, 'Predicted protein', 165, NULL, NULL, 174764),
(174765, '1.25.40.20-FF-000107', NULL, 'cyclin-dependent kinase 4 inhibitor B', 126, NULL, NULL, 174765),
(174766, '3.10.20.90-FF-000801', NULL, 'Serine/threonine-protein kinase TBK1-like Protein', 75, NULL, NULL, 174766),
(174767, '3.20.20.70-FF-000716', NULL, NULL, 121, NULL, NULL, 174767),
(174768, '2.130.10.10-FF-003646', NULL, 'POC1 centriolar protein homolog', 111, NULL, NULL, 174768),
(174769, '3.10.590.10-FF-000026', NULL, 'Uncharacterized protein', 37, NULL, NULL, 174769),
(174770, '1.20.990.10-FF-000034', NULL, 'Nitric oxide synthase, inducible', 126, NULL, NULL, 174770),
(174771, '3.20.10.10-FF-000007', NULL, 'Branched-chain-amino-acid aminotransferase, mitochondrial', 172, NULL, NULL, 174771),
(174772, '1.10.510.10-FF-004143', NULL, NULL, 282, NULL, NULL, 174772),
(174773, '2.30.30.140-FF-000228', NULL, 'LD30829p', 85, NULL, NULL, 174773),
(174774, '1.10.510.10-FF-001967', NULL, 'Uncharacterized protein', 223, NULL, NULL, 174774),
(174775, '1.25.40.10-FF-001841', NULL, 'Hepatocellular carcinoma-associated antigen, putative', 142, NULL, NULL, 174775),
(174776, '1.20.1250.20-FF-001014', NULL, 'Nodulin-like, putative', 197, NULL, NULL, 174776),
(174777, '3.20.20.80-FF-000719', NULL, 'Uncharacterized protein', 154, NULL, NULL, 174777),
(174778, '1.20.120.1080-FF-000048', NULL, 'ATP-dependent RNA helicase prh1, putative', 172, NULL, NULL, 174778),
(174779, '3.80.10.10-FF-002865', NULL, 'AGAP005805-PA', 260, NULL, NULL, 174779);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(174780, '3.40.50.300-FF-003697', NULL, 'Dynein alpha chain, flagellar outer arm', 132, NULL, NULL, 174780),
(174781, '3.30.30.170-FF-000014', NULL, NULL, 40, NULL, NULL, 174781),
(174782, '1.10.287.1390-FF-000002', NULL, NULL, 57, NULL, NULL, 174782),
(174783, '2.30.30.870-FF-000008', NULL, 'Protein pelota homolog', 127, NULL, NULL, 174783),
(174784, '1.10.287.1490-FF-000144', NULL, 'Structural maintenance of chromosomes protein 6', 174, NULL, NULL, 174784),
(174785, '2.60.120.290-FF-000154', NULL, 'Metalloendopeptidase', 119, NULL, NULL, 174785),
(174786, '3.40.140.10-FF-000160', NULL, 'Pre-mRNA-processing-splicing factor 8A', 65, NULL, NULL, 174786),
(174787, '3.30.160.60-FF-000650', NULL, 'Zinc finger protein 197', 28, NULL, NULL, 174787),
(174788, '1.10.287.130-FF-000247', NULL, 'Hybrid signal transduction histidine kinase H', 84, NULL, NULL, 174788),
(174789, '3.40.50.300-FF-001909', NULL, 'DNA mismatch repair protein msh3', 258, NULL, NULL, 174789),
(174790, '3.30.60.30-FF-000173', NULL, 'Agr-1', 64, NULL, NULL, 174790),
(174791, '2.30.29.30-FF-001283', NULL, 'Predicted protein', 156, NULL, NULL, 174791),
(174792, '3.40.50.300-FF-000050', NULL, 'DNA repair protein RadA', 214, NULL, NULL, 174792),
(174793, '1.20.1250.20-FF-002296', NULL, 'Uncharacterized protein', 55, NULL, NULL, 174793),
(174794, '1.10.510.10-FF-002243', NULL, NULL, 166, NULL, NULL, 174794),
(174795, '1.10.20.10-FF-000041', NULL, 'DNA polymerase epsilon subunit 3', 147, NULL, NULL, 174795),
(174796, '1.20.5.170-FF-000157', NULL, 'DNA repair protein Swi5/Sae3', 65, NULL, NULL, 174796),
(174797, '1.25.40.180-FF-000229', NULL, NULL, 367, NULL, NULL, 174797),
(174798, '1.10.287.470-FF-000091', NULL, 'Probable membrane-fusion protein', 32, NULL, NULL, 174798),
(174799, '3.30.160.60-FF-005681', NULL, NULL, 72, NULL, NULL, 174799),
(174800, '1.20.5.2440-FF-000010', NULL, 'Rab-11 Family Interacting-Protein', 69, NULL, NULL, 174800),
(174801, '2.60.40.10-FF-002241', NULL, 'Titin homolog', 97, NULL, NULL, 174801),
(174802, '3.40.250.10-FF-000179', NULL, 'Uncharacterized protein', 180, NULL, NULL, 174802),
(174803, '4.10.280.10-FF-000167', NULL, 'Helix-loop-helix protein 6', 56, NULL, NULL, 174803),
(174804, '1.25.40.10-FF-003870', NULL, 'Uncharacterized protein', 97, NULL, NULL, 174804),
(174805, '1.20.1070.10-FF-000957', NULL, 'Uncharacterized protein', 347, NULL, NULL, 174805),
(174806, '3.40.50.300-FF-005951', NULL, 'DNA mismatch repair protein MSH3', 261, NULL, NULL, 174806),
(174807, '1.10.287.110-FF-000011', NULL, 'Co-chaperone protein DjlA', 84, NULL, NULL, 174807),
(174808, '1.20.58.400-FF-000029', NULL, 'Vesicle transport v-SNARE protein', 101, NULL, NULL, 174808),
(174809, '1.10.1420.10-FF-000144', NULL, 'DNA mismatch repair protein', 133, NULL, NULL, 174809),
(174810, '3.20.80.10-FF-000039', NULL, 'Heme binding protein 1', 115, NULL, NULL, 174810),
(174811, '3.30.70.330-FF-000969', NULL, 'Nuclear RNA export factor', 102, NULL, NULL, 174811),
(174812, '2.60.40.10-FF-001965', NULL, 'Cilia and flagella associated protein 65', 96, NULL, NULL, 174812),
(174813, '2.130.10.10-FF-005445', NULL, 'Predicted protein', 205, NULL, NULL, 174813),
(174814, '3.40.50.1820-FF-000993', NULL, 'Carboxylesterase', 244, NULL, NULL, 174814),
(174815, '1.20.58.530-FF-000040', NULL, NULL, 42, NULL, NULL, 174815),
(174816, '3.40.50.300-FF-005597', NULL, 'Uncharacterized protein', 91, NULL, NULL, 174816),
(174817, '3.90.226.10-FF-000140', NULL, 'ATP-dependent Clp protease proteolytic subunit', 173, NULL, NULL, 174817),
(174818, '3.30.1360.120-FF-000054', NULL, 'Folate-binding protein', 155, NULL, NULL, 174818),
(174819, '1.20.58.60-FF-000889', NULL, 'Short stop/Kakapo isoform D', 61, NULL, NULL, 174819),
(174820, '3.30.200.20-FF-001452', NULL, 'Non-specific serine/threonine protein kinase', 45, NULL, NULL, 174820),
(174821, '3.40.50.720-FF-001119', NULL, '6-phosphogluconate dehydrogenase, decarboxylating', 178, NULL, NULL, 174821),
(174822, '1.20.1280.50-FF-000103', NULL, 'Leucine rich repeat containing 29', 38, NULL, NULL, 174822),
(174823, '3.40.50.300-FF-007851', NULL, 'DNA replication licensing factor, MCM2/3/5 family', 328, NULL, NULL, 174823);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(174824, '1.25.50.20-FF-000052', NULL, 'Aminopeptidase', 331, NULL, NULL, 174824),
(174825, '1.20.5.110-FF-000049', NULL, 'Transducin family protein / WD-40 repeat family protein', 50, NULL, NULL, 174825),
(174826, '3.30.40.10-FF-000649', NULL, 'TNF receptor-associated factor', 65, NULL, NULL, 174826),
(174827, '3.10.20.90-FF-000329', NULL, 'Wnk kinase, isoform L', 100, NULL, NULL, 174827),
(174828, '2.80.10.50-FF-000221', NULL, 'Uncharacterized protein', 125, NULL, NULL, 174828),
(174829, '2.80.10.50-FF-000193', NULL, 'Tetanus toxin', 206, NULL, NULL, 174829),
(174830, '3.40.50.10190-FF-000075', NULL, 'Nijmegen breakage syndrome 1 protein', 83, NULL, NULL, 174830),
(174831, '2.40.40.20-FF-000058', NULL, 'Peroxisomal biogenesis factor 1', 63, NULL, NULL, 174831),
(174832, '1.20.920.10-FF-000086', NULL, 'ATP-dependent chromatin assembly factor large subunit', 145, NULL, NULL, 174832),
(174833, '3.30.420.10-FF-000375', NULL, NULL, 130, NULL, NULL, 174833),
(174834, '3.40.532.10-FF-000031', NULL, NULL, 185, NULL, NULL, 174834),
(174835, '1.10.10.440-FF-000070', NULL, 'Pre-mRNA-processing protein 40B', 61, NULL, NULL, 174835),
(174836, '3.40.640.10-FF-000102', NULL, '1-aminocyclopropane-1-carboxylate synthase homolog (inactive)', 249, NULL, NULL, 174836),
(174837, '3.40.50.300-FF-006114', NULL, 'Uncharacterized protein', 76, NULL, NULL, 174837),
(174838, '3.30.930.10-FF-000245', NULL, 'Phenylalanine--tRNA ligase beta subunit', 194, NULL, NULL, 174838),
(174839, '2.40.20.10-FF-000060', NULL, 'Plasminogen', 93, NULL, NULL, 174839),
(174840, '1.20.1270.60-FF-000038', NULL, 'Rho GTPase activating protein 29', 283, NULL, NULL, 174840),
(174841, '3.40.5.90-FF-000002', NULL, 'CDGSH iron-sulfur domain-containing protein 3, mitochondrial', 41, NULL, NULL, 174841),
(174842, '3.60.40.10-FF-000378', NULL, 'Uncharacterized protein', 59, NULL, NULL, 174842),
(174843, '1.10.3730.20-FF-000036', NULL, 'EamA family transporter', 127, NULL, NULL, 174843),
(174844, '1.20.1110.10-FF-000219', NULL, NULL, 48, NULL, NULL, 174844),
(174845, '1.10.150.90-FF-000002', NULL, 'Gag polyprotein', 87, NULL, NULL, 174845),
(174846, '1.10.720.60-FF-000014', NULL, 'Enolase-phosphatase E1', 88, NULL, NULL, 174846),
(174847, '3.40.20.10-FF-000125', NULL, 'Cofilin-2', 131, NULL, NULL, 174847),
(174848, '2.60.40.150-FF-000344', NULL, 'Extended SYnapTotagmin homolog', 148, NULL, NULL, 174848),
(174849, '3.40.50.300-FF-007396', NULL, 'GTP-binding protein-related', 64, NULL, NULL, 174849),
(174850, '3.30.420.40-FF-000142', NULL, 'Actin-related protein 8', 116, NULL, NULL, 174850),
(174851, '2.10.70.10-FF-000042', NULL, 'Membrane cofactor protein', 67, NULL, NULL, 174851),
(174852, '3.30.160.60-FF-001398', NULL, 'zinc finger protein 830', 46, NULL, NULL, 174852),
(174853, '1.10.8.60-FF-000217', NULL, 'Origin recognition complex subunit 1', 50, NULL, NULL, 174853),
(174854, '1.10.10.10-FF-001395', NULL, 'ArsR family transcriptional regulator', 91, NULL, NULL, 174854),
(174855, '3.40.50.200-FF-000019', NULL, 'Protease S8 tripeptidyl peptidase I', 397, NULL, NULL, 174855),
(174856, '2.40.30.330-FF-000013', NULL, 'mRNA cleavage and polyadenylation factor complex II subunit', 109, NULL, NULL, 174856),
(174857, '1.10.238.10-FF-001267', NULL, 'Defective in cullin neddylation protein', 54, NULL, NULL, 174857),
(174858, '3.30.70.330-FF-001251', NULL, 'HIV Tat-specific factor 1', 149, NULL, NULL, 174858),
(174859, '3.50.50.60-FF-000866', NULL, 'FAD dependent oxidoreductase', 433, NULL, NULL, 174859),
(174860, '1.10.287.990-FF-000004', NULL, 'Dihydrolipoamide dehydrogenase', 67, NULL, NULL, 174860),
(174861, '1.25.10.10-FF-001463', NULL, 'Protein CELLULOSE SYNTHASE INTERACTIVE 3', 157, NULL, NULL, 174861),
(174862, '1.25.10.10-FF-000035', NULL, 'adenomatous polyposis coli protein 2', 414, NULL, NULL, 174862),
(174863, '3.90.1570.40-FF-000003', NULL, 'Uncharacterized protein', 102, NULL, NULL, 174863),
(174864, '3.40.430.10-FF-000047', NULL, 'Uncharacterized protein', 69, NULL, NULL, 174864),
(174865, '1.10.287.110-FF-000241', NULL, 'Chaperone protein DNAJ, putative', 79, NULL, NULL, 174865);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(174866, '1.10.560.10-FF-000037', NULL, 'T-complex protein 1 subunit gamma', 144, NULL, NULL, 174866),
(174867, '3.40.1060.10-FF-000001', NULL, 'Aconitate hydratase, mitochondrial', 117, NULL, NULL, 174867),
(174868, '3.30.160.60-FF-004039', NULL, 'Protein suppressor of hairy wing', 53, NULL, NULL, 174868),
(174869, '1.10.510.10-FF-003980', NULL, 'Negative regulator of sexual conjugation and meiosis', 329, NULL, NULL, 174869),
(174870, '2.10.220.10-FF-000031', NULL, 'Furin 2, isoform A', 91, NULL, NULL, 174870),
(174871, '2.60.40.10-FF-000116', NULL, 'HLA class II histocompatibility antigen, DRB1-1 beta chain', 108, NULL, NULL, 174871),
(174872, '1.10.520.10-FF-000046', NULL, 'Uncharacterized protein', 120, NULL, NULL, 174872),
(174873, '2.130.10.10-FF-000083', NULL, 'WD repeat domain phosphoinositide-interacting protein 3', 303, NULL, NULL, 174873),
(174874, '3.30.1320.10-FF-000001', NULL, '30S ribosomal protein S16', 82, NULL, NULL, 174874),
(174875, '1.20.1070.10-FF-000396', NULL, 'D(2) dopamine receptor A', 153, NULL, NULL, 174875),
(174876, '3.40.50.740-FF-000046', NULL, 'Formate dehydrogenase', 146, NULL, NULL, 174876),
(174877, '2.60.120.10-FF-000394', NULL, 'Crp/Fnr family transcriptional regulator', 136, NULL, NULL, 174877),
(174878, '1.10.10.250-FF-000029', NULL, 'Uncharacterized protein', 50, NULL, NULL, 174878),
(174879, '3.40.30.10-FF-000614', NULL, 'Uncharacterized protein', 108, NULL, NULL, 174879),
(174880, '3.40.50.1820-FF-001173', NULL, 'Uncharacterized protein', 297, NULL, NULL, 174880),
(174881, '3.30.160.60-FF-004702', NULL, NULL, 39, NULL, NULL, 174881),
(174882, '3.10.50.40-FF-000075', NULL, 'Peptidyl-prolyl cis-trans isomerase FKBP42', 127, NULL, NULL, 174882),
(174883, '1.20.1110.10-FF-000012', NULL, 'Plasma membrane ATPase', 322, NULL, NULL, 174883),
(174884, '1.10.510.10-FF-000118', NULL, 'G protein-coupled receptor kinase', 199, NULL, NULL, 174884),
(174885, '3.40.1110.10-FF-000449', NULL, NULL, 144, NULL, NULL, 174885),
(174886, '3.90.1750.10-FF-000093', NULL, 'Ubiquitin-protein ligase, putative', 160, NULL, NULL, 174886),
(174887, '1.20.1070.10-FF-001008', NULL, 'Purinergic receptor P2Y, G-protein-coupled 10B', 125, NULL, NULL, 174887),
(174888, '2.130.10.10-FF-003742', NULL, 'Uncharacterized protein', 332, NULL, NULL, 174888),
(174889, '2.10.70.10-FF-000025', NULL, 'seizure 6-like protein 2 isoform X2', 60, NULL, NULL, 174889),
(174890, '1.25.40.10-FF-003639', NULL, 'Tetratricopeptide repeat protein 21B', 151, NULL, NULL, 174890),
(174891, '3.30.710.10-FF-000476', NULL, 'Protein CBG25771', 98, NULL, NULL, 174891),
(174892, '2.130.10.30-FF-000089', NULL, NULL, 161, NULL, NULL, 174892),
(174893, '2.60.220.50-FF-000099', NULL, 'Contactin-6', 192, NULL, NULL, 174893),
(174894, '3.40.50.300-FF-006440', NULL, 'Uncharacterized protein', 125, NULL, NULL, 174894),
(174895, '3.40.50.300-FF-005625', NULL, 'Uncharacterized protein', 160, NULL, NULL, 174895),
(174896, '2.130.10.10-FF-005771', NULL, 'Uncharacterized protein', 107, NULL, NULL, 174896),
(174897, '1.25.40.10-FF-001739', NULL, 'Pentatricopeptide repeat-containing protein OTP51, chloroplastic', 105, NULL, NULL, 174897),
(174898, '1.25.40.1030-FF-000032', NULL, 'COP-II coat subunit', 406, NULL, NULL, 174898),
(174899, '1.10.10.10-FF-001378', NULL, 'Demethylsterigmatocystin 6-O-methyltransferase', 88, NULL, NULL, 174899),
(174900, '1.10.268.10-FF-000021', NULL, NULL, 107, NULL, NULL, 174900),
(174901, '3.30.40.10-FF-001155', NULL, 'Uncharacterized protein', 96, NULL, NULL, 174901),
(174902, '3.50.50.60-FF-001029', NULL, 'Uncharacterized protein', 103, NULL, NULL, 174902),
(174903, '3.80.10.10-FF-001016', NULL, 'Leucine Rich Repeat, putative', 138, NULL, NULL, 174903),
(174904, '3.40.720.10-FF-000154', NULL, 'N-sulfoglucosamine sulfohydrolase', 88, NULL, NULL, 174904),
(174905, '3.40.50.720-FF-001445', NULL, 'uncharacterized protein LOC100179743', 70, NULL, NULL, 174905),
(174906, '3.40.50.410-FF-000178', NULL, 'Uncharacterized protein', 183, NULL, NULL, 174906),
(174907, '3.40.33.10-FF-000076', NULL, 'CRISP/Allergen/PR-1-like Protein', 187, NULL, NULL, 174907);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(174908, '3.90.190.10-FF-000337', NULL, 'Pps1p', 195, NULL, NULL, 174908),
(174909, '1.10.600.10-FF-000098', NULL, 'Uncharacterized protein', 59, NULL, NULL, 174909),
(174910, '2.60.40.10-FF-001398', NULL, 'Echinoid, isoform C', 82, NULL, NULL, 174910),
(174911, '2.40.50.90-FF-000097', NULL, 'Tudor domain-containing protein 1', 94, NULL, NULL, 174911),
(174912, '3.40.50.1820-FF-000897', NULL, 'Predicted protein', 236, NULL, NULL, 174912),
(174913, '3.30.160.60-FF-005804', NULL, NULL, 31, NULL, NULL, 174913),
(174914, '1.50.10.10-FF-000191', NULL, 'alpha-1,2-Mannosidase', 272, NULL, NULL, 174914),
(174915, '1.10.8.680-FF-000003', NULL, 'TBC1 domain family member', 78, NULL, NULL, 174915),
(174916, '2.60.200.10-FF-000001', NULL, 'Mothers against decapentaplegic homolog', 204, NULL, NULL, 174916),
(174917, '3.30.70.330-FF-002998', NULL, NULL, 139, NULL, NULL, 174917),
(174918, '6.10.140.2220-FF-000026', NULL, 'protein msta', 47, NULL, NULL, 174918),
(174919, '2.120.10.30-FF-000050', NULL, 'E3 ubiquitin-protein ligase TRIM56', 263, NULL, NULL, 174919),
(174920, '4.10.240.10-FF-000176', NULL, 'AflR-like C6 zinc cluster transcription factor', 60, NULL, NULL, 174920),
(174921, '3.60.20.10-FF-000169', NULL, NULL, 210, NULL, NULL, 174921),
(174922, '3.40.30.10-FF-001103', NULL, 'Glutathione S-transferase L2 chloroplastic', 56, NULL, NULL, 174922),
(174923, '2.60.200.20-FF-000004', NULL, 'pleckstrin homology-like domain family B member 1 isoform X1', 106, NULL, NULL, 174923),
(174924, '3.30.200.20-FF-001682', NULL, 'Mn2+-dependent serine-threonine protein kinase Signal transduction', 73, NULL, NULL, 174924),
(174925, '3.60.21.10-FF-000126', NULL, 'Serine/threonine-protein phosphatase with EF-hands', 344, NULL, NULL, 174925),
(174926, '1.10.10.60-FF-000072', NULL, 'Homeobox protein Hox-B8', 77, NULL, NULL, 174926),
(174927, '3.20.20.70-FF-000481', NULL, 'Predicted protein', 212, NULL, NULL, 174927),
(174928, '3.40.50.2300-FF-001553', NULL, NULL, 25, NULL, NULL, 174928),
(174929, '3.30.40.10-FF-000975', NULL, 'Uncharacterized protein', 92, NULL, NULL, 174929),
(174930, '1.10.3210.10-FF-000005', NULL, 'Bifunctional uridylyltransferase/uridylyl-removing enzyme', 143, NULL, NULL, 174930),
(174931, '2.30.30.140-FF-000245', NULL, 'Histone-lysine N-methyltransferase SETDB1-A', 59, NULL, NULL, 174931),
(174932, '3.80.10.10-FF-000836', NULL, 'Os08g0322500 protein', 156, NULL, NULL, 174932),
(174933, '3.30.160.60-FF-002241', NULL, 'Weckle, isoform B', 27, NULL, NULL, 174933),
(174934, '3.30.160.60-FF-001959', NULL, 'Zinc finger protein 564', 60, NULL, NULL, 174934),
(174935, '2.60.40.150-FF-000018', NULL, 'Phosphoinositide phospholipase C', 143, NULL, NULL, 174935),
(174936, '3.40.50.300-FF-004540', NULL, 'Adenosinetriphosphatase', 170, NULL, NULL, 174936),
(174937, '2.40.10.10-FF-000115', NULL, 'ORF1a polyprotein', 73, NULL, NULL, 174937),
(174938, '2.10.25.10-FF-000078', NULL, 'Fibulin-1', 42, NULL, NULL, 174938),
(174939, '3.90.870.10-FF-000007', NULL, 'YrdC N6-threonylcarbamoyltransferase domain containing', 204, NULL, NULL, 174939),
(174940, '2.60.120.10-FF-000517', NULL, 'cGMP-dependent protein kinase', 142, NULL, NULL, 174940),
(174941, '3.20.20.105-FF-000022', NULL, 'Queuine tRNA-ribosyltransferase accessory subunit 2', 264, NULL, NULL, 174941),
(174942, '3.30.450.40-FF-000211', NULL, 'Histidine kinase', 155, NULL, NULL, 174942),
(174943, '2.170.270.10-FF-000131', NULL, 'Histone-lysine N-methyltransferase', 243, NULL, NULL, 174943),
(174944, '3.20.20.80-FF-000484', NULL, 'Alpha-glucosidase', 169, NULL, NULL, 174944),
(174945, '3.30.230.30-FF-000001', NULL, 'IMPACT isoform 1', 123, NULL, NULL, 174945),
(174946, '1.10.510.10-FF-003654', NULL, NULL, 183, NULL, NULL, 174946),
(174947, '2.60.40.10-FF-005804', NULL, NULL, 75, NULL, NULL, 174947),
(174948, '2.60.200.30-FF-000007', NULL, 'NAD kinase', 137, NULL, NULL, 174948),
(174949, '1.10.510.10-FF-000214', NULL, 'Dual specificity mitogen-activated protein kinase kinase 7', 204, NULL, NULL, 174949),
(174950, '3.40.1110.10-FF-000242', NULL, 'Cation transporting ATPase', 217, NULL, NULL, 174950);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(174951, '1.20.120.890-FF-000001', NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', 135, NULL, NULL, 174951),
(174952, '2.130.10.10-FF-005900', NULL, 'Uncharacterized protein', 284, NULL, NULL, 174952),
(174953, '3.90.70.10-FF-000513', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 124, NULL, NULL, 174953),
(174954, '1.10.472.170-FF-000001', NULL, 'Transcription initiation factor IIB', 198, NULL, NULL, 174954),
(174955, '1.10.3520.10-FF-000012', NULL, 'Os08g0556300 protein', 213, NULL, NULL, 174955),
(174956, '2.30.29.30-FF-000917', NULL, 'Uncharacterized protein', 65, NULL, NULL, 174956),
(174957, '1.20.1740.10-FF-000138', NULL, 'Solute carrier family 7 (cationic amino acid transporter, y+ system), member 2, gene 1', 102, NULL, NULL, 174957),
(174958, '3.90.290.10-FF-000030', NULL, 'Uncharacterized protein', 71, NULL, NULL, 174958),
(174959, '2.60.120.200-FF-000728', NULL, 'Concanavalin A-like lectin family protein', 231, NULL, NULL, 174959),
(174960, '3.30.457.60-FF-000013', NULL, 'Spindle assembly checkpoint component MAD1', 85, NULL, NULL, 174960),
(174961, '1.10.8.60-FF-000447', NULL, 'Lon protease homolog 2, peroxisomal', 115, NULL, NULL, 174961),
(174962, '1.25.40.10-FF-002021', NULL, 'Os12g0552300 protein', 105, NULL, NULL, 174962),
(174963, '3.90.70.10-FF-000300', NULL, 'Uncharacterized protein', 322, NULL, NULL, 174963),
(174964, '3.90.660.10-FF-000087', NULL, NULL, 158, NULL, NULL, 174964),
(174965, '3.40.50.1000-FF-000522', NULL, NULL, 103, NULL, NULL, 174965),
(174966, '3.30.830.10-FF-000310', NULL, 'Uncharacterized protein', 62, NULL, NULL, 174966),
(174967, '3.90.1200.10-FF-000029', NULL, 'GNAT family N-acetyltransferase', 151, NULL, NULL, 174967),
(174968, '2.60.40.1120-FF-000060', NULL, 'Glycoside hydrolase', 77, NULL, NULL, 174968),
(174969, '2.10.25.10-FF-000971', NULL, 'Laminin alpha 5', 47, NULL, NULL, 174969),
(174970, '2.30.30.40-FF-000171', NULL, 'Nephrocystin 1', 67, NULL, NULL, 174970),
(174971, '3.40.1370.10-FF-000002', NULL, '60S ribosomal protein L4', 302, NULL, NULL, 174971),
(174972, '3.20.20.140-FF-000253', NULL, 'TatD related DNase', 285, NULL, NULL, 174972),
(174973, '3.40.50.150-FF-000420', NULL, 'Ribosomal lysine N-methyltransferase 5', 261, NULL, NULL, 174973),
(174974, '3.40.50.2020-FF-000053', NULL, 'Hypoxanthine phosphoribosyltransferase', 216, NULL, NULL, 174974),
(174975, '3.40.50.720-FF-000962', NULL, '4-hydroxy-tetrahydrodipicolinate reductase', 127, NULL, NULL, 174975),
(174976, '2.30.29.30-FF-001406', NULL, 'Uncharacterized protein', 83, NULL, NULL, 174976),
(174977, '1.50.40.10-FF-000254', NULL, 'Mitochondrial carrier protein-like protein', 142, NULL, NULL, 174977),
(174978, '3.90.740.10-FF-000003', NULL, 'Valine--tRNA ligase', 41, NULL, NULL, 174978),
(174979, '1.20.1110.10-FF-000220', NULL, NULL, 36, NULL, NULL, 174979),
(174980, '3.30.60.30-FF-000061', NULL, 'Follistatin, isoform A', 82, NULL, NULL, 174980),
(174981, '3.30.505.10-FF-000173', NULL, NULL, 87, NULL, NULL, 174981),
(174982, '2.40.70.10-FF-000321', NULL, NULL, 177, NULL, NULL, 174982),
(174983, '3.30.1490.20-FF-000090', NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta', 74, NULL, NULL, 174983),
(174984, '3.30.160.60-FF-006164', NULL, NULL, 81, NULL, NULL, 174984),
(174985, '1.10.506.10-FF-000007', NULL, 'RAS p21 protein activator 1', 176, NULL, NULL, 174985),
(174986, '2.60.40.10-FF-001853', NULL, 'fasciclin-2 isoform X5', 99, NULL, NULL, 174986),
(174987, '1.10.287.1490-FF-000026', NULL, 'AGAP005583-PA', 156, NULL, NULL, 174987),
(174988, '3.40.630.60-FF-000015', NULL, NULL, 77, NULL, NULL, 174988),
(174989, '3.40.50.1000-FF-000410', NULL, NULL, 64, NULL, NULL, 174989),
(174990, '2.30.29.30-FF-001171', NULL, 'Uncharacterized protein', 94, NULL, NULL, 174990),
(174991, '2.30.29.140-FF-000001', NULL, 'Stomatal closure-related actin-binding protein 1', 122, NULL, NULL, 174991),
(174992, '3.10.600.10-FF-000011', NULL, 'Pyruvate carboxylase', 78, NULL, NULL, 174992),
(174993, '3.15.10.10-FF-000020', NULL, 'Uncharacterized protein', 42, NULL, NULL, 174993);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(174994, '3.40.50.2300-FF-000598', NULL, 'DNA-binding response regulator', 127, NULL, NULL, 174994),
(174995, '3.40.1280.30-FF-000001', NULL, 'tRNA methyltransferase 10 homolog A', 194, NULL, NULL, 174995),
(174996, '3.30.450.20-FF-000672', NULL, 'Hybrid signal transduction histidine kinase A', 95, NULL, NULL, 174996),
(174997, '3.30.420.10-FF-000728', NULL, NULL, 253, NULL, NULL, 174997),
(174998, '2.130.10.10-FF-003534', NULL, 'WD40-repeat-containing domain protein', 172, NULL, NULL, 174998),
(174999, '3.20.20.470-FF-000003', NULL, 'Dextransucrase', 165, NULL, NULL, 174999),
(175000, '2.10.25.10-FF-000527', NULL, 'versican core protein isoform X2', 54, NULL, NULL, 175000),
(175001, '3.30.2410.10-FF-000008', NULL, 'Putative E3 ubiquitin-protein ligase UBR5', 117, NULL, NULL, 175001),
(175002, '2.60.40.1670-FF-000005', NULL, 'Protein transport protein SEC23', 159, NULL, NULL, 175002),
(175003, '3.40.50.12760-FF-000014', NULL, 'Predicted protein', 301, NULL, NULL, 175003),
(175004, '1.10.510.10-FF-001849', NULL, NULL, 73, NULL, NULL, 175004),
(175005, '4.10.400.10-FF-000048', NULL, 'Sortilin related receptor 1', 34, NULL, NULL, 175005),
(175006, '3.40.710.10-FF-000097', NULL, 'Uncharacterized protein', 285, NULL, NULL, 175006),
(175007, '1.25.40.180-FF-000347', NULL, NULL, 91, NULL, NULL, 175007),
(175008, '2.60.40.1090-FF-000039', NULL, 'Fimbrial-like adhesin protein', 154, NULL, NULL, 175008),
(175009, '2.140.10.30-FF-000010', NULL, 'Prolyl oligopeptidase family protein', 474, NULL, NULL, 175009),
(175010, '3.70.10.10-FF-000134', NULL, 'Checkpoint protein', 281, NULL, NULL, 175010),
(175011, '3.40.50.620-FF-000578', NULL, 'Pantoate--beta-alanine ligase', 120, NULL, NULL, 175011),
(175012, '1.20.140.50-FF-000010', NULL, 'BRO1-like domain/ALIX V-shaped domain binding to HIV, putative', 179, NULL, NULL, 175012),
(175013, '3.30.1360.30-FF-000004', NULL, 'tRNA synthetase class II family protein', 150, NULL, NULL, 175013),
(175014, '3.40.250.10-FF-000067', NULL, 'Metallo-beta-lactamase family protein', 94, NULL, NULL, 175014),
(175015, '2.40.128.20-FF-000059', NULL, 'Uncharacterized protein', 106, NULL, NULL, 175015),
(175016, '1.10.510.10-FF-000326', NULL, 'leucine-rich repeat serine/threonine-protein kinase 2', 187, NULL, NULL, 175016),
(175017, '2.60.40.1220-FF-000005', NULL, 'S-layer protein sap', 87, NULL, NULL, 175017),
(175018, '1.10.101.10-FF-000045', NULL, 'Predicted protein', 72, NULL, NULL, 175018),
(175019, '2.40.50.140-FF-001129', NULL, NULL, 79, NULL, NULL, 175019),
(175020, '2.40.100.10-FF-000150', NULL, 'Peptidyl-prolyl cis-trans isomerase', 169, NULL, NULL, 175020),
(175021, '1.50.40.10-FF-000372', NULL, 'Uncharacterized protein', 218, NULL, NULL, 175021),
(175022, '3.30.800.10-FF-000027', NULL, NULL, 137, NULL, NULL, 175022),
(175023, '1.10.630.10-FF-000279', NULL, 'Cytochrome P450 monooxygenase, putative', 504, NULL, NULL, 175023),
(175024, '1.20.5.430-FF-000010', NULL, 'Uncharacterized protein C16E9.15', 47, NULL, NULL, 175024),
(175025, '2.60.40.1660-FF-000002', NULL, 'Sodium/potassium-transporting ATPase subunit beta', 242, NULL, NULL, 175025),
(175026, '3.80.10.10-FF-000948', NULL, 'Centrosomal protein 78', 103, NULL, NULL, 175026),
(175027, '2.60.120.260-FF-000499', NULL, 'Uncharacterized protein', 86, NULL, NULL, 175027),
(175028, '3.90.1420.10-FF-000023', NULL, 'Nucleus protein, putative', 154, NULL, NULL, 175028),
(175029, '3.30.310.50-FF-000024', NULL, 'Phosphoacetylglucosamine mutase', 97, NULL, NULL, 175029),
(175030, '2.10.25.10-FF-001134', NULL, 'Putative wall-associated receptor protein kinase family protein', 86, NULL, NULL, 175030),
(175031, '3.30.1360.20-FF-000001', NULL, 'Pterin-4-alpha-carbinolamine dehydratase 2', 103, NULL, NULL, 175031),
(175032, '2.30.29.150-FF-000004', NULL, 'FACT complex subunit SPT16', 163, NULL, NULL, 175032),
(175033, '2.40.50.140-FF-001028', NULL, NULL, 149, NULL, NULL, 175033),
(175034, '3.40.50.12160-FF-000042', NULL, 'Zgc:162738 protein', 47, NULL, NULL, 175034),
(175035, '3.40.30.10-FF-000940', NULL, 'Predicted protein', 112, NULL, NULL, 175035);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(175036, '3.60.21.10-FF-000238', NULL, 'DNA double-strand break repair protein Mre11', 250, NULL, NULL, 175036),
(175037, '3.40.50.200-FF-000115', NULL, 'Tripeptidyl peptidase I', 159, NULL, NULL, 175037),
(175038, '3.30.420.10-FF-000049', NULL, 'Ribonuclease H1', 153, NULL, NULL, 175038),
(175039, '1.10.540.10-FF-000154', NULL, 'Acyl-CoA dehydrogenase family member 9, mitochondrial', 86, NULL, NULL, 175039),
(175040, '3.30.40.10-FF-001251', NULL, 'Structure-specific endonuclease subunit SLX1 homolog', 74, NULL, NULL, 175040),
(175041, '3.40.980.10-FF-000026', NULL, 'Competence-damage associated protein', 163, NULL, NULL, 175041),
(175042, '3.30.450.20-FF-000559', NULL, 'PAS/PAC sensor signal transduction histidine kinase', 107, NULL, NULL, 175042),
(175043, '3.30.10.20-FF-000015', NULL, 'Transmembrane serine/threonine-protein kinase B', 67, NULL, NULL, 175043),
(175044, '3.40.250.10-FF-000180', NULL, 'Mercaptopyruvate sulfurtransferase SseA', 140, NULL, NULL, 175044),
(175045, '2.60.40.10-FF-003882', NULL, NULL, 128, NULL, NULL, 175045),
(175046, '1.10.565.10-FF-000138', NULL, 'Uncharacterized protein', 143, NULL, NULL, 175046),
(175047, '1.10.1420.10-FF-000032', NULL, 'DNA mismatch repair protein MSH2', 128, NULL, NULL, 175047),
(175048, '1.10.3210.10-FF-000117', NULL, 'Uncharacterized protein', 87, NULL, NULL, 175048),
(175049, '1.10.287.70-FF-000476', NULL, 'Predicted protein', 71, NULL, NULL, 175049),
(175050, '3.40.50.2000-FF-001132', NULL, 'Uncharacterized protein', 69, NULL, NULL, 175050),
(175051, '3.30.342.10-FF-000047', NULL, 'DNA polymerase', 149, NULL, NULL, 175051),
(175052, '2.60.120.560-FF-000010', NULL, 'Glycoside hydrolase family 32 protein', 163, NULL, NULL, 175052),
(175053, '3.30.70.80-FF-000003', NULL, 'Subtilisin-like protease SBT1.9', 90, NULL, NULL, 175053),
(175054, '3.90.80.10-FF-000014', NULL, 'Inorganic pyrophosphatase, putative', 233, NULL, NULL, 175054),
(175055, '3.40.50.300-FF-008126', NULL, 'Uncharacterized protein', 105, NULL, NULL, 175055),
(175056, '1.10.510.10-FF-001754', NULL, 'Kinase, CAMK CAMK1', 221, NULL, NULL, 175056),
(175057, '4.10.400.10-FF-000161', NULL, 'Terribly reduced optic lobes, isoform AZ', 38, NULL, NULL, 175057),
(175058, '3.10.28.10-FF-000020', NULL, 'tRNA-splicing ligase RtcB', 200, NULL, NULL, 175058),
(175059, '2.60.40.10-FF-002027', NULL, 'Tyrosine-protein kinase-like otk', 88, NULL, NULL, 175059),
(175060, '3.30.200.20-FF-001356', NULL, 'Os11g0556400 protein', 103, NULL, NULL, 175060),
(175061, '1.25.40.150-FF-000006', NULL, 'V-type proton ATPase subunit H', 102, NULL, NULL, 175061),
(175062, '1.25.40.10-FF-001498', NULL, 'Pentatricopeptide repeat (PPR-like) superfamily protein', 102, NULL, NULL, 175062),
(175063, '2.70.150.10-FF-000303', NULL, 'Uncharacterized protein', 149, NULL, NULL, 175063),
(175064, '3.30.450.60-FF-000094', NULL, 'AP complex subunit sigma', 44, NULL, NULL, 175064),
(175065, '2.60.40.10-FF-000330', NULL, 'Apoptosis resistant E3 ubiquitin protein ligase 1', 109, NULL, NULL, 175065),
(175066, '1.10.8.1310-FF-000011', NULL, 'Uncharacterized protein', 134, NULL, NULL, 175066),
(175067, '1.25.40.10-FF-001178', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 98, NULL, NULL, 175067),
(175068, '3.30.70.1230-FF-000004', NULL, 'Guanylate cyclase', 226, NULL, NULL, 175068),
(175069, '3.30.70.240-FF-000026', NULL, 'Elongation factor G2-like protein', 70, NULL, NULL, 175069),
(175070, '1.10.1410.10-FF-000104', NULL, 'Uncharacterized protein', 174, NULL, NULL, 175070),
(175071, '1.10.357.70-FF-000015', NULL, 'Exocyst complex component Sec6-domain-containing protein', 177, NULL, NULL, 175071),
(175072, '3.30.360.10-FF-000111', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', 169, NULL, NULL, 175072),
(175073, '1.10.3720.10-FF-000201', NULL, 'ABC transporter permease protein', 195, NULL, NULL, 175073),
(175074, '3.10.110.10-FF-000041', NULL, 'Ubiquitin-conjugating enzyme E2 T', 152, NULL, NULL, 175074),
(175075, '3.40.50.10810-FF-000103', NULL, 'DNA repair and recombination protein RAD54B, putative', 255, NULL, NULL, 175075);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(175076, '3.10.20.30-FF-000014', NULL, 'Ferredoxin', 96, NULL, NULL, 175076),
(175077, '2.10.25.10-FF-000628', NULL, 'Wall-associated receptor kinase 2', 52, NULL, NULL, 175077),
(175078, '3.40.50.300-FF-000263', NULL, 'Ras-related protein RABB1c', 185, NULL, NULL, 175078),
(175079, '3.30.70.250-FF-000029', NULL, NULL, 78, NULL, NULL, 175079),
(175080, '1.10.472.80-FF-000095', NULL, 'Rab-GTPase-TBC_domain_containing_protein', 127, NULL, NULL, 175080),
(175081, '1.10.238.10-FF-000305', NULL, 'Calmodulin, variant', 80, NULL, NULL, 175081),
(175082, '3.30.70.1220-FF-000001', NULL, 'General transcription factor IIH subunit 5', 71, NULL, NULL, 175082),
(175083, '3.40.50.1820-FF-000785', NULL, 'Pyochelin biosynthetic protein PchC', 243, NULL, NULL, 175083),
(175084, '3.40.50.800-FF-000076', NULL, 'Proline--tRNA ligase', 99, NULL, NULL, 175084),
(175085, '3.40.190.80-FF-000094', NULL, 'Uncharacterized protein', 77, NULL, NULL, 175085),
(175086, '2.40.50.140-FF-001242', NULL, NULL, 132, NULL, NULL, 175086),
(175087, '3.30.1490.120-FF-000015', NULL, 'AGAP012084-PA', 96, NULL, NULL, 175087),
(175088, '1.10.510.10-FF-003199', NULL, NULL, 148, NULL, NULL, 175088),
(175089, '2.60.120.1000-FF-000030', NULL, 'Uncharacterized protein', 62, NULL, NULL, 175089),
(175090, '3.40.850.10-FF-000478', NULL, 'Kinesin motor domain containing protein', 349, NULL, NULL, 175090),
(175091, '4.10.860.120-FF-000032', NULL, 'Uncharacterized protein', 119, NULL, NULL, 175091),
(175092, '3.90.1750.10-FF-000110', NULL, 'Uncharacterized protein', 39, NULL, NULL, 175092),
(175093, '3.30.1140.60-FF-000002', NULL, 'F-actin-capping protein subunit alpha', 106, NULL, NULL, 175093),
(175094, '2.60.120.10-FF-000282', NULL, 'Uncharacterized protein', 190, NULL, NULL, 175094),
(175095, '3.40.50.10140-FF-000088', NULL, 'Uncharacterized protein', 129, NULL, NULL, 175095),
(175096, '2.130.10.10-FF-003854', NULL, 'Uncharacterized protein', 288, NULL, NULL, 175096),
(175097, '3.40.50.1100-FF-000226', NULL, 'Predicted protein', 84, NULL, NULL, 175097),
(175098, '3.30.420.40-FF-000260', NULL, 'Heat shock protein 110, putative', 97, NULL, NULL, 175098),
(175099, '1.25.40.10-FF-001291', NULL, 'Pentatricopeptide repeat-containing protein', 80, NULL, NULL, 175099),
(175100, '1.10.10.540-FF-000009', NULL, 'AGAP000733-PA', 67, NULL, NULL, 175100),
(175101, '3.90.79.10-FF-000050', NULL, 'Nudix hydrolase 14 chloroplastic', 188, NULL, NULL, 175101),
(175102, '1.20.1250.20-FF-001222', NULL, 'MFS transporter', 210, NULL, NULL, 175102),
(175103, '2.102.10.10-FF-000028', NULL, 'Protein TIC 55, chloroplastic', 130, NULL, NULL, 175103),
(175104, '2.130.10.10-FF-001488', NULL, 'WD domain, G-beta repeat-containing protein', 148, NULL, NULL, 175104),
(175105, '3.30.160.60-FF-000442', NULL, 'Zinc finger and AT-hook domain containing', 55, NULL, NULL, 175105),
(175106, '1.10.630.10-FF-000487', NULL, 'Uncharacterized protein', 471, NULL, NULL, 175106),
(175107, '2.110.10.10-FF-000033', NULL, 'Matrix metallopeptidase 28', 197, NULL, NULL, 175107),
(175108, '3.30.530.20-FF-000026', NULL, 'Homeobox-leucine zipper protein GLABRA 2', 220, NULL, NULL, 175108),
(175109, '3.30.70.3160-FF-000004', NULL, 'tRNA pseudouridine synthase D', 86, NULL, NULL, 175109),
(175110, '1.20.1560.10-FF-000832', NULL, 'Uncharacterized protein', 349, NULL, NULL, 175110),
(175111, '3.20.20.60-FF-000034', NULL, 'Pyruvate kinase 2', 109, NULL, NULL, 175111),
(175112, '2.40.170.20-FF-000101', NULL, 'SusC homolog', 601, NULL, NULL, 175112),
(175113, '3.30.70.3150-FF-000001', NULL, 'Eukaryotic translation initiation factor 2 subunit beta', 67, NULL, NULL, 175113),
(175114, '1.50.40.10-FF-000580', NULL, 'Predicted protein', 66, NULL, NULL, 175114),
(175115, '3.30.9.10-FF-000239', NULL, 'Uncharacterized protein', 49, NULL, NULL, 175115),
(175116, '2.60.40.10-FF-004270', NULL, NULL, 105, NULL, NULL, 175116),
(175117, '3.40.50.2300-FF-001115', NULL, NULL, 148, NULL, NULL, 175117),
(175118, '3.30.160.60-FF-001639', NULL, 'Si:dkey-7i4.21', 29, NULL, NULL, 175118),
(175119, '3.40.50.300-FF-000600', NULL, 'Nuclear valosin-containing protein-like', 189, NULL, NULL, 175119);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(175120, '1.20.1560.10-FF-000944', NULL, 'ABC transporter, putative', 248, NULL, NULL, 175120),
(175121, '1.10.10.10-FF-001945', NULL, 'Protein CBG00836', 84, NULL, NULL, 175121),
(175122, '3.20.20.220-FF-000046', NULL, 'Proline dehydrogenase / 1-pyrroline-5-carboxylate dehydrogenase', 370, NULL, NULL, 175122),
(175123, '3.40.920.10-FF-000023', NULL, NULL, 194, NULL, NULL, 175123),
(175124, '4.10.400.10-FF-000262', NULL, 'complement component C9', 32, NULL, NULL, 175124),
(175125, '1.20.1310.10-FF-000201', NULL, NULL, 148, NULL, NULL, 175125),
(175126, '3.40.50.1010-FF-000188', NULL, NULL, 93, NULL, NULL, 175126),
(175127, '2.130.10.10-FF-005872', NULL, 'Uncharacterized protein', 307, NULL, NULL, 175127),
(175128, '3.90.700.10-FF-000006', NULL, 'Succinate dehydrogenase flavoprotein subunit', 128, NULL, NULL, 175128),
(175129, '3.80.10.10-FF-004439', NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', 138, NULL, NULL, 175129),
(175130, '3.30.70.1230-FF-000088', NULL, 'Guanylate cyclase', 67, NULL, NULL, 175130),
(175131, '1.10.560.10-FF-000043', NULL, 'Heat shock protein family D (Hsp60) member 1', 87, NULL, NULL, 175131),
(175132, '1.10.220.50-FF-000001', NULL, 'Loader of gp41 DNA helicase', 112, NULL, NULL, 175132),
(175133, '3.50.50.60-FF-000978', NULL, 'Flavin-containing monooxygenase', 103, NULL, NULL, 175133),
(175134, '1.10.238.10-FF-000406', NULL, 'Calcium channel subunit Cch1', 72, NULL, NULL, 175134),
(175135, '1.10.8.60-FF-000560', NULL, 'Origin recognition complex subunit 1', 90, NULL, NULL, 175135),
(175136, '3.40.50.620-FF-000477', NULL, 'Asparagine synthase, putative', 172, NULL, NULL, 175136),
(175137, '3.40.50.1820-FF-001622', NULL, 'Uncharacterized protein', 56, NULL, NULL, 175137),
(175138, '3.90.1170.20-FF-000017', NULL, 'Uncharacterized protein', 35, NULL, NULL, 175138),
(175139, '3.80.10.10-FF-003242', NULL, 'Uncharacterized protein', 182, NULL, NULL, 175139),
(175140, '1.10.565.10-FF-000026', NULL, 'Hepatocyte nuclear factor 4', 235, NULL, NULL, 175140),
(175141, '1.10.540.10-FF-000042', NULL, 'Putative acyl-CoA dehydrogenase', 110, NULL, NULL, 175141),
(175142, '1.20.1280.50-FF-000215', NULL, 'F-box/WD repeat-containing protein 4-like Protein', 49, NULL, NULL, 175142),
(175143, '3.40.50.300-FF-007188', NULL, 'Uncharacterized protein', 170, NULL, NULL, 175143),
(175144, '1.20.1070.10-FF-001121', NULL, 'Beta-1 adrenergic receptor', 354, NULL, NULL, 175144),
(175145, '1.20.1250.40-FF-000031', NULL, 'DNA-directed RNA polymerases II subunit, putative', 125, NULL, NULL, 175145),
(175146, '1.10.8.50-FF-000006', NULL, 'DNA topoisomerase 6 subunit B', 78, NULL, NULL, 175146),
(175147, '2.130.10.10-FF-001393', NULL, 'Elongator complex protein 2', 116, NULL, NULL, 175147),
(175148, '3.40.50.150-FF-001589', NULL, NULL, 36, NULL, NULL, 175148),
(175149, '2.130.10.10-FF-002011', NULL, 'Transducin/WD40 repeat-like superfamily protein', 190, NULL, NULL, 175149),
(175150, '3.40.20.10-FF-000119', NULL, 'Protein transport protein Sec24-like CEF', 124, NULL, NULL, 175150),
(175151, '2.60.120.1040-FF-000013', NULL, NULL, 151, NULL, NULL, 175151),
(175152, '3.30.565.10-FF-000401', NULL, 'Sensor histidine kinase', 157, NULL, NULL, 175152),
(175153, '1.25.40.20-FF-000321', NULL, 'No mechanoreceptor potential C, isoform D', 169, NULL, NULL, 175153),
(175154, '3.30.40.210-FF-000017', NULL, 'Uncharacterized protein', 59, NULL, NULL, 175154),
(175155, '3.40.50.12060-FF-000001', NULL, 'Rif2p', 67, NULL, NULL, 175155),
(175156, '3.30.200.20-FF-000041', NULL, 'Vascular endothelial growth factor receptor 2', 112, NULL, NULL, 175156),
(175157, '2.130.10.130-FF-000040', NULL, NULL, 124, NULL, NULL, 175157),
(175158, '2.60.40.1730-FF-000052', NULL, 'Aminopeptidase', 206, NULL, NULL, 175158),
(175159, '2.60.120.290-FF-000249', NULL, 'Uncharacterized protein (Fragment)', 73, NULL, NULL, 175159),
(175160, '3.30.200.20-FF-001244', NULL, 'Serine/threonine-protein kinase ATG1c', 87, NULL, NULL, 175160),
(175161, '1.25.40.10-FF-003752', NULL, 'Pentatricopeptide repeat-containing protein At4g31850, chloroplastic', 116, NULL, NULL, 175161);
INSERT INTO "PUBLIC"."MODEL" VALUES
(175162, '1.20.120.350-FF-000081', NULL, 'Predicted protein', 148, NULL, NULL, 175162),
(175163, '2.130.10.10-FF-002106', NULL, 'Polyadenylation factor subunit 2', 97, NULL, NULL, 175163),
(175164, '3.90.640.10-FF-000187', NULL, 'Uncharacterized protein', 98, NULL, NULL, 175164),
(175165, '3.40.630.30-FF-000366', NULL, 'Putative exported protein', 93, NULL, NULL, 175165),
(175166, '3.90.550.10-FF-000421', NULL, 'Bifunctional phosphatase/dolichol-phosphate glucosyltransferase', 234, NULL, NULL, 175166),
(175167, '2.160.20.20-FF-000006', NULL, 'Antigen 43', 502, NULL, NULL, 175167),
(175168, '3.30.300.150-FF-000007', NULL, NULL, 121, NULL, NULL, 175168),
(175169, '1.20.1640.10-FF-000080', NULL, 'Putative multidrug resistance protein', 214, NULL, NULL, 175169),
(175170, '1.10.8.60-FF-000009', NULL, '26S protease regulatory subunit 6A', 75, NULL, NULL, 175170),
(175171, '3.30.70.100-FF-000125', NULL, 'Probable copper-exporting P-type ATPase', 64, NULL, NULL, 175171),
(175172, '1.10.10.10-FF-000321', NULL, 'DNA-binding transcriptional repressor LldR', 72, NULL, NULL, 175172),
(175173, '1.10.630.10-FF-000392', NULL, 'Cytochrome P450, putative (Eurofung)', 490, NULL, NULL, 175173),
(175174, '3.90.550.10-FF-000303', NULL, 'Dolichyl-phosphate beta-glucosyltransferase ALG5D', 259, NULL, NULL, 175174),
(175175, '3.30.1120.10-FF-000003', NULL, 'Arylsulfatase A', 79, NULL, NULL, 175175),
(175176, '1.10.3090.10-FF-000028', NULL, 'Uncharacterized protein', 266, NULL, NULL, 175176),
(175177, '3.10.20.90-FF-000335', NULL, 'UBX domain-containing protein', 81, NULL, NULL, 175177),
(175178, '3.40.50.300-FF-008025', NULL, 'Uncharacterized protein', 139, NULL, NULL, 175178),
(175179, '2.40.290.10-FF-000039', NULL, 'DNA binding protein', 246, NULL, NULL, 175179),
(175180, '1.20.930.40-FF-000022', NULL, 'YALI0B05258p', 184, NULL, NULL, 175180),
(175181, '1.25.10.10-FF-001575', NULL, 'Zgc:136656 protein', 123, NULL, NULL, 175181),
(175182, '3.40.50.12360-FF-000001', NULL, 'HDA1 complex subunit 3', 307, NULL, NULL, 175182),
(175183, '1.10.287.70-FF-000375', NULL, 'Glutamate receptor, ionotropic, N-methyl D-aspartate 2D, b', 82, NULL, NULL, 175183),
(175184, '2.60.40.10-FF-002128', NULL, 'Sucrose-6-phosphate hydrolase', 75, NULL, NULL, 175184),
(175185, '1.10.287.550-FF-000007', NULL, 'Arylsulfatase H', 59, NULL, NULL, 175185),
(175186, '1.10.220.60-FF-000004', NULL, 'GG17233', 57, NULL, NULL, 175186),
(175187, '2.10.220.10-FF-000143', NULL, 'Proprotein convertase subtilisin/kexin type 5', 53, NULL, NULL, 175187),
(175188, '3.40.50.1000-FF-000067', NULL, 'HAD phosphatase, family IIIA', 148, NULL, NULL, 175188),
(175189, '2.30.30.100-FF-000149', NULL, 'Small nuclear ribonucleoprotein f, putative', 51, NULL, NULL, 175189),
(175190, '3.30.70.1670-FF-000001', NULL, 'Phosphoribosylformylglycinamidine synthase subunit PurL', 96, NULL, NULL, 175190),
(175191, '3.50.50.60-FF-001243', NULL, 'Uncharacterized protein', 171, NULL, NULL, 175191),
(175192, '2.60.200.20-FF-000105', NULL, 'Nibrin', 103, NULL, NULL, 175192),
(175193, '3.20.20.70-FF-000380', NULL, '7-carboxy-7-deazaguanine synthase', 209, NULL, NULL, 175193),
(175194, '3.30.40.10-FF-001604', NULL, 'Uncharacterized protein', 41, NULL, NULL, 175194),
(175195, '3.50.50.60-FF-001473', NULL, '3-oxo-5-alpha-steroid 4-dehydrogenase', 61, NULL, NULL, 175195),
(175196, '1.20.1280.50-FF-000204', NULL, 'Actin-related protein 8', 76, NULL, NULL, 175196),
(175197, '2.60.120.200-FF-000279', NULL, 'Os09g0251100 protein', 200, NULL, NULL, 175197),
(175198, '3.50.30.30-FF-000176', NULL, 'Uncharacterized protein', 47, NULL, NULL, 175198),
(175199, '2.60.40.10-FF-000436', NULL, 'Neural cell adhesion molecule 2', 97, NULL, NULL, 175199),
(175200, '2.40.33.10-FF-000022', NULL, 'Pyruvate kinase', 70, NULL, NULL, 175200),
(175201, '3.30.160.60-FF-003876', NULL, NULL, 81, NULL, NULL, 175201),
(175202, '1.20.1300.10-FF-000032', NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit A, mitochondrial', 117, NULL, NULL, 175202),
(175203, '1.20.58.1120-FF-000058', NULL, NULL, 97, NULL, NULL, 175203);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(175204, '2.80.10.50-FF-000108', NULL, 'Protein frg1', 170, NULL, NULL, 175204),
(175205, '3.20.20.80-FF-000383', NULL, 'Lactase', 131, NULL, NULL, 175205),
(175206, '3.20.20.70-FF-000722', NULL, NULL, 106, NULL, NULL, 175206),
(175207, '1.10.418.10-FF-000050', NULL, 'nesprin-2 isoform X2', 117, NULL, NULL, 175207),
(175208, '1.10.10.10-FF-002007', NULL, 'Uncharacterized protein', 123, NULL, NULL, 175208),
(175209, '3.10.310.20-FF-000031', NULL, NULL, 116, NULL, NULL, 175209),
(175210, '1.20.58.830-FF-000023', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 173, NULL, NULL, 175210),
(175211, '2.10.220.10-FF-000132', NULL, 'Tyrosine-protein kinase receptor', 64, NULL, NULL, 175211),
(175212, '1.10.1420.10-FF-000043', NULL, 'MutS homolog 4', 56, NULL, NULL, 175212),
(175213, '3.90.1480.20-FF-000018', NULL, 'Sialyltransferase, isoform A', 322, NULL, NULL, 175213),
(175214, '1.20.1280.50-FF-000092', NULL, 'F-box protein At5g67140', 48, NULL, NULL, 175214),
(175215, '2.60.120.970-FF-000026', NULL, 'Growth differentiation factor 6', 212, NULL, NULL, 175215),
(175216, '3.90.1420.10-FF-000012', NULL, 'Predicted protein', 174, NULL, NULL, 175216),
(175217, '3.30.505.10-FF-000061', NULL, 'Tyrosine-protein kinase', 121, NULL, NULL, 175217),
(175218, '1.25.40.990-FF-000022', NULL, 'YPR045C-like protein', 264, NULL, NULL, 175218),
(175219, '3.20.20.80-FF-000725', NULL, 'Amylo-1, 6-glucosidase, 4-alpha-glucanotransferase', 133, NULL, NULL, 175219),
(175220, '3.50.50.60-FF-000967', NULL, 'Prolycopene isomerase, chloroplastic', 125, NULL, NULL, 175220),
(175221, '1.25.10.10-FF-002070', NULL, 'Uncharacterized protein', 158, NULL, NULL, 175221),
(175222, '1.25.10.10-FF-001564', NULL, 'Meiotic PUF family protein 1', 335, NULL, NULL, 175222),
(175223, '3.30.160.60-FF-005776', NULL, NULL, 29, NULL, NULL, 175223),
(175224, '4.10.75.10-FF-000003', NULL, 'WAP four-disulfide core domain protein 1', 48, NULL, NULL, 175224),
(175225, '3.40.50.300-FF-002174', NULL, 'ATP-dependent RNA helicase DBP3', 244, NULL, NULL, 175225),
(175226, '3.40.50.10090-FF-000062', NULL, 'Uroporphyrin-III C-methyltransferase/uroporphyrinogen-III synthase', 108, NULL, NULL, 175226),
(175227, '3.30.800.10-FF-000016', NULL, 'Phosphoinositide kinase putative', 174, NULL, NULL, 175227),
(175228, '3.30.1600.10-FF-000028', NULL, 'NAD-dependent protein deacetylase', 88, NULL, NULL, 175228),
(175229, '3.30.70.330-FF-001700', NULL, NULL, 100, NULL, NULL, 175229),
(175230, '3.30.460.90-FF-000013', NULL, 'Uncharacterized protein', 134, NULL, NULL, 175230),
(175231, '1.25.40.10-FF-003089', NULL, 'Putative pentatricopeptide repeat-containing protein At1g28020', 165, NULL, NULL, 175231),
(175232, '3.40.50.150-FF-000515', NULL, 'Asparaginyl-tRNA synthetase', 274, NULL, NULL, 175232),
(175233, '2.30.29.30-FF-000676', NULL, 'Uncharacterized protein', 103, NULL, NULL, 175233),
(175234, '2.130.10.10-FF-000420', NULL, 'WD repeat-containing protein 18', 252, NULL, NULL, 175234),
(175235, '2.130.10.10-FF-004017', NULL, 'Coronin', 223, NULL, NULL, 175235),
(175236, '3.90.760.10-FF-000004', NULL, 'Flavocytochrome C sulfide dehydrogenase', 64, NULL, NULL, 175236),
(175237, '3.90.1750.10-FF-000008', NULL, 'Putative ubiquitin-protein ligase E3A', 154, NULL, NULL, 175237),
(175238, '3.40.50.450-FF-000049', NULL, 'ATP-dependent 6-phosphofructokinase', 92, NULL, NULL, 175238),
(175239, '1.20.120.1760-FF-000055', NULL, NULL, 108, NULL, NULL, 175239),
(175240, '3.30.160.60-FF-002123', NULL, 'C2H2 transcription factor, putative', 29, NULL, NULL, 175240),
(175241, '3.40.20.10-FF-000097', NULL, 'Gelsolin-like protein 1', 118, NULL, NULL, 175241),
(175242, '3.30.460.80-FF-000010', NULL, 'Proton-translocating NADH-quinone oxidoreductase, C subunit', 127, NULL, NULL, 175242),
(175243, '3.30.40.10-FF-001363', NULL, 'Probable E3 ubiquitin-protein ligase WAVH2', 109, NULL, NULL, 175243),
(175244, '3.90.1440.10-FF-000007', NULL, 'Uncharacterized protein', 126, NULL, NULL, 175244),
(175245, '3.90.70.80-FF-000068', NULL, 'Uncharacterized protein', 179, NULL, NULL, 175245),
(175246, '2.10.60.10-FF-000086', NULL, 'Uncharacterized protein', 48, NULL, NULL, 175246);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(175247, '3.40.50.300-FF-001898', NULL, 'Dynein beta chain, putative', 130, NULL, NULL, 175247),
(175248, '3.30.160.60-FF-004152', NULL, NULL, 32, NULL, NULL, 175248),
(175249, '2.10.25.10-FF-001342', NULL, 'Predicted protein', 37, NULL, NULL, 175249),
(175250, '3.40.50.2300-FF-001435', NULL, NULL, 120, NULL, NULL, 175250),
(175251, '3.30.70.330-FF-001475', NULL, 'GM17146', 112, NULL, NULL, 175251),
(175252, '2.60.40.10-FF-003764', NULL, NULL, 85, NULL, NULL, 175252),
(175253, '3.30.9.10-FF-000133', NULL, 'D-amino acid oxidase', 134, NULL, NULL, 175253),
(175254, '1.25.40.10-FF-003544', NULL, 'YALI0E30217p', 92, NULL, NULL, 175254),
(175255, '3.30.160.60-FF-004253', NULL, NULL, 33, NULL, NULL, 175255),
(175256, '3.40.710.10-FF-000086', NULL, 'Probable lipase lipe', 380, NULL, NULL, 175256),
(175257, '1.10.10.1450-FF-000002', NULL, 'Uncharacterized protein', 50, NULL, NULL, 175257),
(175258, '2.130.10.10-FF-001943', NULL, 'Uncharacterized protein', 306, NULL, NULL, 175258),
(175259, '3.30.160.60-FF-001847', NULL, 'Zinc finger and BTB domain containing 11', 24, NULL, NULL, 175259),
(175260, '3.90.1290.10-FF-000080', NULL, 'Dystonin', 93, NULL, NULL, 175260),
(175261, '3.30.160.60-FF-003977', NULL, NULL, 56, NULL, NULL, 175261),
(175262, '3.20.20.140-FF-000365', NULL, 'Uncharacterized protein', 244, NULL, NULL, 175262),
(175263, '3.40.190.10-FF-000011', NULL, 'ATP phosphoribosyltransferase', 112, NULL, NULL, 175263),
(175264, '3.90.70.10-FF-000064', NULL, 'calpain-6', 146, NULL, NULL, 175264),
(175265, '1.25.40.10-FF-001392', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial isoform A', 149, NULL, NULL, 175265),
(175266, '2.60.40.10-FF-005916', NULL, NULL, 43, NULL, NULL, 175266),
(175267, '1.20.1070.10-FF-000637', NULL, '5-hydroxytryptamine receptor 2B isoform X2', 166, NULL, NULL, 175267),
(175268, '1.10.510.10-FF-001288', NULL, 'Protein kinase, putative', 187, NULL, NULL, 175268),
(175269, '2.60.40.10-FF-004040', NULL, NULL, 97, NULL, NULL, 175269),
(175270, '3.40.50.300-FF-000145', NULL, 'probable ATP-dependent RNA helicase DHX40', 175, NULL, NULL, 175270),
(175271, '2.60.120.920-FF-000157', NULL, 'Si:dkey-172k15.6', 174, NULL, NULL, 175271),
(175272, '3.40.30.10-FF-000277', NULL, 'Probable nadh-ubiquinone oxidoreductase 10.5 kDa subunit', 95, NULL, NULL, 175272),
(175273, '2.60.120.10-FF-000635', NULL, 'Glr1108 protein', 190, NULL, NULL, 175273),
(175274, '1.25.40.120-FF-000026', NULL, 'FarNesylTransferase, Alpha subunit', 308, NULL, NULL, 175274),
(175275, '3.40.1110.10-FF-000450', NULL, NULL, 143, NULL, NULL, 175275),
(175276, '1.20.140.150-FF-000120', NULL, 'Uncharacterized protein', 116, NULL, NULL, 175276),
(175277, '3.30.710.10-FF-000268', NULL, 'Uncharacterized protein, isoform C', 159, NULL, NULL, 175277),
(175278, '3.90.640.10-FF-000086', NULL, 'Actin-related protein 5', 30, NULL, NULL, 175278),
(175279, '3.40.630.30-FF-000265', NULL, 'Acetyltransferase, putative', 177, NULL, NULL, 175279),
(175280, '3.40.50.1360-FF-000046', NULL, 'Probable 6-phosphogluconolactonase', 236, NULL, NULL, 175280),
(175281, '1.20.1740.10-FF-000037', NULL, 'Uncharacterized protein, isoform F', 467, NULL, NULL, 175281),
(175282, '3.40.605.10-FF-000066', NULL, 'Alh-11', 173, NULL, NULL, 175282),
(175283, '3.30.1430.10-FF-000004', NULL, '60S ribosomal protein L3', 119, NULL, NULL, 175283),
(175284, '2.60.120.820-FF-000009', NULL, 'E3 ubiquitin-protein ligase rpm-1', 164, NULL, NULL, 175284),
(175285, '1.10.357.70-FF-000026', NULL, 'Uncharacterized protein', 171, NULL, NULL, 175285),
(175286, '3.30.160.60-FF-002353', NULL, 'Zinc finger protein 646', 31, NULL, NULL, 175286),
(175287, '2.60.40.2300-FF-000009', NULL, 'neutral ceramidase', 137, NULL, NULL, 175287),
(175288, '3.30.1370.100-FF-000011', NULL, 'Mismatch repair protein PMS1, putative', 87, NULL, NULL, 175288),
(175289, '3.30.70.330-FF-001930', NULL, NULL, 142, NULL, NULL, 175289),
(175290, '3.60.21.10-FF-000031', NULL, 'Serine/threonine-protein phosphatase', 444, NULL, NULL, 175290),
(175291, '1.10.10.10-FF-002108', NULL, 'Forkhead box P, isoform E', 77, NULL, NULL, 175291);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(175292, '1.25.40.10-FF-005343', NULL, 'Predicted protein', 40, NULL, NULL, 175292),
(175293, '3.30.160.60-FF-006052', NULL, NULL, 28, NULL, NULL, 175293),
(175294, '1.10.240.10-FF-000013', NULL, 'Tyrosine--tRNA ligase', 104, NULL, NULL, 175294),
(175295, '3.40.50.1000-FF-000421', NULL, 'HAD superfamily hydrolase', 127, NULL, NULL, 175295),
(175296, '3.90.228.10-FF-000004', NULL, 'Poly [ADP-ribose] polymerase', 118, NULL, NULL, 175296),
(175297, '2.60.40.10-FF-005905', NULL, NULL, 67, NULL, NULL, 175297),
(175298, '3.10.580.10-FF-000183', NULL, 'Uncharacterized protein', 174, NULL, NULL, 175298),
(175299, '2.60.120.40-FF-000043', NULL, 'Uncharacterized protein', 139, NULL, NULL, 175299),
(175300, '1.10.150.850-FF-000014', NULL, 'Uncharacterized protein', 54, NULL, NULL, 175300),
(175301, '1.20.58.60-FF-000794', NULL, 'Uncharacterized protein', 309, NULL, NULL, 175301),
(175302, '3.30.160.60-FF-003438', NULL, 'Uncharacterized protein', 27, NULL, NULL, 175302),
(175303, '3.30.1330.30-FF-000053', NULL, '50S ribosomal protein L30e', 101, NULL, NULL, 175303),
(175304, '3.40.1110.10-FF-000337', NULL, NULL, 160, NULL, NULL, 175304),
(175305, '1.10.10.60-FF-001269', NULL, NULL, 83, NULL, NULL, 175305),
(175306, '3.30.1330.40-FF-000056', NULL, 'Uncharacterized protein', 105, NULL, NULL, 175306),
(175307, '2.30.39.10-FF-000058', NULL, 'Putative serpin A13', 94, NULL, NULL, 175307),
(175308, '3.30.1330.20-FF-000050', NULL, 'Tubulin beta', 55, NULL, NULL, 175308),
(175309, '1.10.8.10-FF-000343', NULL, 'Uncharacterized protein', 23, NULL, NULL, 175309),
(175310, '1.10.10.10-FF-001844', NULL, 'RPS10-NUDT3 readthrough', 85, NULL, NULL, 175310),
(175311, '3.30.420.40-FF-000030', NULL, 'Cell division protein FtsA', 168, NULL, NULL, 175311),
(175312, '2.10.70.10-FF-000137', NULL, 'Beta-microseminoprotein', 50, NULL, NULL, 175312),
(175313, '3.10.20.90-FF-000234', NULL, 'Ubiquitin D', 73, NULL, NULL, 175313),
(175314, '3.90.980.20-FF-000001', NULL, 'metal-response element-binding transcription factor 2 isoform X1', 140, NULL, NULL, 175314),
(175315, '3.80.10.10-FF-001443', NULL, 'ELRR (Extracellular Leucine-Rich Repeat) ONly', 158, NULL, NULL, 175315),
(175316, '3.40.30.10-FF-000502', NULL, 'Maleylacetoacetate isomerase/glutathione S-transferase', 86, NULL, NULL, 175316),
(175317, '3.30.1640.10-FF-000025', NULL, 'DNA helicase', 98, NULL, NULL, 175317),
(175318, '1.20.1560.10-FF-000933', NULL, 'Uncharacterized protein', 15, NULL, NULL, 175318),
(175319, '3.40.50.410-FF-000296', NULL, 'Ubiquitin interaction motif family protein', 179, NULL, NULL, 175319),
(175320, '4.10.240.10-FF-000064', NULL, 'WGS project CABT00000000 data, contig 2.7', 92, NULL, NULL, 175320),
(175321, '3.40.720.10-FF-000266', NULL, 'Iduronate-2-sulfatase', 448, NULL, NULL, 175321),
(175322, '3.30.300.30-FF-000097', NULL, 'Nonribosomal peptide synthase, putative', 128, NULL, NULL, 175322),
(175323, '2.130.10.10-FF-005883', NULL, 'Uncharacterized protein', 299, NULL, NULL, 175323),
(175324, '1.25.40.10-FF-002116', NULL, 'Heat shock protein 70 (HSP70)-interacting protein, putative', 168, NULL, NULL, 175324),
(175325, '3.30.1300.30-FF-000006', NULL, 'Type II secretion system protein I', 89, NULL, NULL, 175325),
(175326, '1.10.510.10-FF-000006', NULL, 'Serine/threonine-protein kinase WNK1 isoform 2', 178, NULL, NULL, 175326),
(175327, '1.10.150.450-FF-000001', NULL, 'SDT1p Pyrimidine nucleotidase', 70, NULL, NULL, 175327),
(175328, '1.25.10.10-FF-002401', NULL, 'Uncharacterized protein', 257, NULL, NULL, 175328),
(175329, '3.40.50.2020-FF-000148', NULL, 'Adenine phosphoribosyltransferase', 177, NULL, NULL, 175329),
(175330, '2.60.120.10-FF-000405', NULL, 'cGMP-dependent protein kinase', 146, NULL, NULL, 175330),
(175331, '1.20.5.190-FF-000022', NULL, 'Unconventional myosin-IXb', 52, NULL, NULL, 175331),
(175332, '1.10.260.60-FF-000001', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', 121, NULL, NULL, 175332),
(175333, '3.30.40.10-FF-001043', NULL, 'Uncharacterized protein, isoform A', 102, NULL, NULL, 175333),
(175334, '2.60.40.10-FF-001864', NULL, 'Ferredoxin, 4Fe-4S bacterial type', 123, NULL, NULL, 175334);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(175335, '2.20.28.10-FF-000005', NULL, 'DNA helicase', 59, NULL, NULL, 175335),
(175336, '2.30.180.10-FF-000106', NULL, NULL, 171, NULL, NULL, 175336),
(175337, '3.40.30.10-FF-000732', NULL, 'Glutathione peroxidase', 139, NULL, NULL, 175337),
(175338, '3.90.190.10-FF-000449', NULL, 'Uncharacterized protein', 247, NULL, NULL, 175338),
(175339, '1.20.58.390-FF-000312', NULL, 'Protein CBG01449', 120, NULL, NULL, 175339),
(175340, '3.80.10.10-FF-000628', NULL, 'F-box and leucine-rich repeat protein 4', 108, NULL, NULL, 175340),
(175341, '1.20.120.1560-FF-000001', NULL, 'Type-3 glutamine synthetase', 148, NULL, NULL, 175341),
(175342, '3.40.50.720-FF-001333', NULL, 'Dehydrogenase', 253, NULL, NULL, 175342),
(175343, '3.30.60.30-FF-000072', NULL, 'Agrin, putative', 71, NULL, NULL, 175343),
(175344, '3.40.710.10-FF-000108', NULL, 'Beta-lactamase', 237, NULL, NULL, 175344),
(175345, '3.40.50.150-FF-001488', NULL, NULL, 122, NULL, NULL, 175345),
(175346, '3.80.10.10-FF-004338', NULL, 'Slit guidance ligand 3', 191, NULL, NULL, 175346),
(175347, '3.40.50.300-FF-006226', NULL, 'Uncharacterized protein', 39, NULL, NULL, 175347),
(175348, '3.30.505.10-FF-000072', NULL, 'SH2 domain-containing protein 5', 115, NULL, NULL, 175348),
(175349, '3.40.50.300-FF-003798', NULL, 'Conserved protein', 198, NULL, NULL, 175349),
(175350, '2.60.40.1090-FF-000028', NULL, 'Fimbrial adhesin FimH', 137, NULL, NULL, 175350),
(175351, '2.40.50.140-FF-000865', NULL, NULL, 58, NULL, NULL, 175351),
(175352, '2.60.120.10-FF-000293', NULL, 'Transcription regulator, Crp family', 132, NULL, NULL, 175352),
(175353, '2.30.29.30-FF-001182', NULL, 'BEACH domain-containing protein lvsD', 98, NULL, NULL, 175353),
(175354, '3.40.50.790-FF-000033', NULL, '54S ribosomal protein L1, mitochondrial', 91, NULL, NULL, 175354),
(175355, '2.60.220.30-FF-000008', NULL, 'SH3 domain-binding protein 4', 141, NULL, NULL, 175355),
(175356, '3.65.10.10-FF-000034', NULL, 'Uncharacterized protein', 34, NULL, NULL, 175356),
(175357, '1.25.40.20-FF-000551', NULL, 'Calmodulin-binding transcription activator 3', 164, NULL, NULL, 175357),
(175358, '1.20.58.2220-FF-000062', NULL, 'Formin-G', 393, NULL, NULL, 175358),
(175359, '3.40.50.11350-FF-000018', NULL, 'alpha-(1,6)-fucosyltransferase-like isoform X1', 171, NULL, NULL, 175359),
(175360, '1.20.1250.20-FF-001109', NULL, 'MFS transporter', 391, NULL, NULL, 175360),
(175361, '3.30.160.20-FF-000228', NULL, 'Uncharacterized protein', 49, NULL, NULL, 175361),
(175362, '1.10.3580.10-FF-000004', NULL, 'ATP12-like chaperone protein, putative', 170, NULL, NULL, 175362),
(175363, '3.20.20.70-FF-000267', NULL, 'Glycerol uptake operon antiterminator regulatory protein', 178, NULL, NULL, 175363),
(175364, '3.40.50.300-FF-005833', NULL, 'Uncharacterized protein', 47, NULL, NULL, 175364),
(175365, '3.30.200.20-FF-001564', NULL, 'Probable cyclin-dependent serine/threonine-protein kinase DDB_G0292550', 80, NULL, NULL, 175365),
(175366, '3.40.640.10-FF-000310', NULL, 'Similar to aspartate aminotransferase', 83, NULL, NULL, 175366),
(175367, '3.40.50.800-FF-000087', NULL, 'Histidyl-tRNA synthetase', 106, NULL, NULL, 175367),
(175368, '1.20.1110.10-FF-000107', NULL, NULL, 19, NULL, NULL, 175368),
(175369, '3.40.50.1820-FF-000908', NULL, 'Acetylcholinesterase 2 precursor, putative', 62, NULL, NULL, 175369),
(175370, '3.40.1380.20-FF-000051', NULL, 'Pyruvate kinase', 110, NULL, NULL, 175370),
(175371, '1.10.8.60-FF-000329', NULL, 'Predicted protein', 76, NULL, NULL, 175371),
(175372, '1.10.10.10-FF-000310', NULL, 'Bloom syndrome RecQ-like helicase', 122, NULL, NULL, 175372),
(175373, '3.30.70.1230-FF-000212', NULL, 'Uncharacterized protein', 118, NULL, NULL, 175373),
(175374, '3.40.50.11340-FF-000015', NULL, 'Uncharacterized protein', 121, NULL, NULL, 175374),
(175375, '1.10.510.10-FF-003772', NULL, NULL, 136, NULL, NULL, 175375),
(175376, '1.10.20.10-FF-000136', NULL, 'Histone H2B', 107, NULL, NULL, 175376),
(175377, '3.40.50.300-FF-000706', NULL, 'Cytoplasmic dynein 2 heavy chain 1', 234, NULL, NULL, 175377),
(175378, '1.10.3090.10-FF-000017', NULL, 'Polynucleotide adenylyltransferase family protein', 219, NULL, NULL, 175378);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(175379, '1.25.10.10-FF-000147', NULL, 'exportin-6 isoform X2', 1067, NULL, NULL, 175379),
(175380, '1.20.1170.10-FF-000004', NULL, 'Hemolysin E, chromosomal', 298, NULL, NULL, 175380),
(175381, '1.10.10.10-FF-001283', NULL, 'Transcriptional regulator, ArsR family', 92, NULL, NULL, 175381),
(175382, '1.10.150.110-FF-000017', NULL, 'Histone-lysine N-methyltransferase', 71, NULL, NULL, 175382),
(175383, '1.20.1560.10-FF-000591', NULL, 'Os01g0534700 protein', 121, NULL, NULL, 175383),
(175384, '3.30.559.30-FF-000016', NULL, 'Peptide synthetase mbtE', 226, NULL, NULL, 175384),
(175385, '3.40.50.300-FF-004074', NULL, 'UvrD/REP helicase N-terminal domain protein', 142, NULL, NULL, 175385),
(175386, '3.10.290.10-FF-000082', NULL, '30S ribosomal protein S4', 49, NULL, NULL, 175386),
(175387, '3.30.420.80-FF-000013', NULL, 'Mitochondrial ribosomal protein S11', 130, NULL, NULL, 175387),
(175388, '3.30.750.44-FF-000014', NULL, 'Carboxy-terminal processing protease', 57, NULL, NULL, 175388),
(175389, '2.130.10.10-FF-002117', NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', 324, NULL, NULL, 175389),
(175390, '3.30.160.60-FF-000004', NULL, 'zinc finger protein 184 isoform X1', 28, NULL, NULL, 175390),
(175391, '1.10.3450.20-FF-000003', NULL, 'Nuclear pore complex protein', 136, NULL, NULL, 175391),
(175392, '2.60.40.10-FF-005793', NULL, NULL, 84, NULL, NULL, 175392),
(175393, '3.30.365.10-FF-000083', NULL, 'Predicted protein', 33, NULL, NULL, 175393),
(175394, '3.30.70.980-FF-000023', NULL, 'DUF28 domain protein', 79, NULL, NULL, 175394),
(175395, '3.40.50.300-FF-004203', NULL, 'Putative RAD51D', 250, NULL, NULL, 175395),
(175396, '2.40.10.230-FF-000007', NULL, 'Chromosome 8, whole genome shotgun sequence', 112, NULL, NULL, 175396),
(175397, '1.10.287.70-FF-000717', NULL, 'Predicted protein', 140, NULL, NULL, 175397),
(175398, '3.30.559.30-FF-000123', NULL, 'Uncharacterized protein', 123, NULL, NULL, 175398),
(175399, '2.40.10.220-FF-000004', NULL, 'Cyclic diguanosine monophosphate-binding protein', 125, NULL, NULL, 175399),
(175400, '1.20.1250.40-FF-000036', NULL, 'Uncharacterized protein', 145, NULL, NULL, 175400),
(175401, '3.40.50.2000-FF-000963', NULL, 'Os01g0869400 protein', 98, NULL, NULL, 175401),
(175402, '3.30.40.10-FF-000874', NULL, 'E3 ubiquitin-protein ligase RHF1A', 68, NULL, NULL, 175402),
(175403, '1.20.1560.10-FF-000377', NULL, 'Uncharacterized protein', 30, NULL, NULL, 175403),
(175404, '3.30.420.10-FF-000386', NULL, NULL, 72, NULL, NULL, 175404),
(175405, '2.60.40.10-FF-005349', NULL, NULL, 68, NULL, NULL, 175405),
(175406, '2.30.30.140-FF-000346', NULL, 'Histone acetyltransferase', 66, NULL, NULL, 175406),
(175407, '3.40.50.1820-FF-001381', NULL, 'Phospholipase ABHD3', 221, NULL, NULL, 175407),
(175408, '1.10.472.130-FF-000023', NULL, 'Dynein heavy chain 10, axonemal', 110, NULL, NULL, 175408),
(175409, '3.40.50.10330-FF-000049', NULL, 'Diacylglycerol kinase', 125, NULL, NULL, 175409),
(175410, '3.30.160.60-FF-005905', NULL, NULL, 85, NULL, NULL, 175410),
(175411, '1.10.1270.10-FF-000003', NULL, 'Trp operon repressor', 91, NULL, NULL, 175411),
(175412, '1.10.10.10-FF-001277', NULL, 'ForKHead transcription factor family', 100, NULL, NULL, 175412),
(175413, '1.25.10.10-FF-003481', NULL, 'Uncharacterized protein', 543, NULL, NULL, 175413),
(175414, '3.40.50.300-FF-007862', NULL, 'Uncharacterized protein', 211, NULL, NULL, 175414),
(175415, '3.40.50.300-FF-003579', NULL, 'D-glycerate 3-kinase', 311, NULL, NULL, 175415),
(175416, '1.10.10.540-FF-000010', NULL, 'UV excision repair RAD23 protein, putative', 55, NULL, NULL, 175416),
(175417, '2.10.70.10-FF-000250', NULL, 'Plasminogen activator', 48, NULL, NULL, 175417),
(175418, '2.60.260.20-FF-000002', NULL, 'Dnaj homolog subfamily b member', 83, NULL, NULL, 175418),
(175419, '3.50.50.60-FF-001361', NULL, 'Flavin-containing monooxygenase', 78, NULL, NULL, 175419),
(175420, '1.10.472.10-FF-000001', NULL, 'G2/mitotic-specific cyclin', 113, NULL, NULL, 175420),
(175421, '1.10.8.720-FF-000026', NULL, 'Dynein heavy chain', 197, NULL, NULL, 175421);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(175422, '2.60.120.200-FF-000397', NULL, 'vitamin K-dependent protein S-like isoform X2', 166, NULL, NULL, 175422),
(175423, '3.40.50.10490-FF-000069', NULL, 'Glucose-6-phosphate isomerase', 193, NULL, NULL, 175423),
(175424, '2.70.150.10-FF-000062', NULL, 'Calcium/mangenease P-type ATPase, putative', 115, NULL, NULL, 175424),
(175425, '1.10.8.10-FF-000129', NULL, 'CUE4p protein', 43, NULL, NULL, 175425),
(175426, '4.10.1240.10-FF-000066', NULL, 'Receptor-type tyrosine-protein phosphatase F', 55, NULL, NULL, 175426),
(175427, '1.20.58.60-FF-000676', NULL, 'Nesprin-1', 172, NULL, NULL, 175427),
(175428, '2.40.160.120-FF-000003', NULL, 'Oxysterol-binding protein', 178, NULL, NULL, 175428),
(175429, '3.80.10.10-FF-001224', NULL, 'Uncharacterized protein', 254, NULL, NULL, 175429),
(175430, '3.40.50.300-FF-002056', NULL, 'ADP-ribosylation factor-like protein', 174, NULL, NULL, 175430),
(175431, '3.80.10.10-FF-001117', NULL, 'Leucine rich repeat and phosphatase domain containing protein', 198, NULL, NULL, 175431),
(175432, '3.10.20.310-FF-000031', NULL, 'Outer membrane protein assembly factor BamA', 82, NULL, NULL, 175432),
(175433, '3.30.160.60-FF-002128', NULL, 'Zinc finger protein 142', 30, NULL, NULL, 175433),
(175434, '3.20.20.70-FF-000610', NULL, NULL, 141, NULL, NULL, 175434),
(175435, '1.25.40.1040-FF-000046', NULL, 'Uncharacterized protein', 138, NULL, NULL, 175435),
(175436, '1.20.1440.340-FF-000005', NULL, 'Galactokinase family protein', 17, NULL, NULL, 175436),
(175437, '1.25.40.1030-FF-000043', NULL, 'Protein transport protein sec16', 402, NULL, NULL, 175437),
(175438, '2.10.25.10-FF-000179', NULL, 'FAT atypical cadherin 1', 37, NULL, NULL, 175438),
(175439, '3.40.50.720-FF-001013', NULL, 'Glyoxylate reductase', 115, NULL, NULL, 175439),
(175440, '3.40.50.300-FF-003591', NULL, 'Rab family GTPase', 194, NULL, NULL, 175440),
(175441, '1.20.1070.10-FF-001019', NULL, 'Uncharacterized protein', 137, NULL, NULL, 175441),
(175442, '3.40.50.2300-FF-001547', NULL, NULL, 30, NULL, NULL, 175442),
(175443, '1.10.8.10-FF-000236', NULL, 'Ubiquitin family protein', 56, NULL, NULL, 175443),
(175444, '1.10.10.10-FF-000080', NULL, 'paired box protein Pax-3 isoform X2', 65, NULL, NULL, 175444),
(175445, '2.30.29.30-FF-000788', NULL, 'Uncharacterized protein', 115, NULL, NULL, 175445),
(175446, '3.90.320.10-FF-000039', NULL, 'ATP-dependent DNA helicase', 139, NULL, NULL, 175446),
(175447, '3.40.50.300-FF-004192', NULL, 'ABC transporter, putative', 153, NULL, NULL, 175447),
(175448, '3.40.190.10-FF-000697', NULL, 'Sll0540 protein', 126, NULL, NULL, 175448),
(175449, '3.90.1640.20-FF-000003', NULL, 'Uncharacterized protein', 324, NULL, NULL, 175449),
(175450, '3.40.50.10190-FF-000086', NULL, 'DNA ligase', 83, NULL, NULL, 175450),
(175451, '2.40.40.20-FF-000047', NULL, 'Transitional endoplasmic reticulum ATPase, putative', 96, NULL, NULL, 175451),
(175452, '3.30.160.60-FF-002235', NULL, 'Zinc finger protein 549', 32, NULL, NULL, 175452),
(175453, '3.30.830.10-FF-000304', NULL, 'Uncharacterized protein', 162, NULL, NULL, 175453),
(175454, '3.40.50.2300-FF-000946', NULL, NULL, 143, NULL, NULL, 175454),
(175455, '2.60.220.30-FF-000003', NULL, 'Unc-5 netrin receptor C', 154, NULL, NULL, 175455),
(175456, '1.20.5.4980-FF-000002', NULL, 'Centromere protein X', 38, NULL, NULL, 175456),
(175457, '3.40.50.1100-FF-000221', NULL, 'Cysteine synthase, putative', 39, NULL, NULL, 175457),
(175458, '3.40.50.790-FF-000027', NULL, 'Ribosomal protein L1p/L10e family protein', 93, NULL, NULL, 175458),
(175459, '3.80.10.10-FF-003360', NULL, 'Uncharacterized protein', 113, NULL, NULL, 175459),
(175460, '3.30.70.330-FF-001357', NULL, 'Related to nucleolar phosphoprotein', 136, NULL, NULL, 175460),
(175461, '1.20.120.1080-FF-000059', NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase PRP43, putative', 102, NULL, NULL, 175461),
(175462, '3.40.50.620-FF-000819', NULL, 'Uncharacterized protein', 70, NULL, NULL, 175462),
(175463, '2.10.25.10-FF-000286', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', 46, NULL, NULL, 175463);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(175464, '3.20.20.140-FF-000247', NULL, '5-methylthioadenosine/S-adenosylhomocysteine deaminase', 60, NULL, NULL, 175464),
(175465, '3.30.40.10-FF-000767', NULL, 'Predicted protein', 85, NULL, NULL, 175465),
(175466, '1.10.238.10-FF-000064', NULL, 'calcium-binding mitochondrial carrier protein Aralar1 isoform X1', 170, NULL, NULL, 175466),
(175467, '3.10.100.10-FF-000102', NULL, 'Killer cell lectin-like receptor subfamily F member 2', 121, NULL, NULL, 175467),
(175468, '3.40.1160.10-FF-000059', NULL, 'Bifunctional aspartokinase-homoserine dehydrogenase protein', 198, NULL, NULL, 175468),
(175469, '1.10.1200.10-FF-000055', NULL, 'Non-ribosomal peptide synthetase', 84, NULL, NULL, 175469),
(175470, '2.60.120.620-FF-000062', NULL, 'CurA', 320, NULL, NULL, 175470),
(175471, '3.40.50.2300-FF-000839', NULL, 'Uncharacterized protein', 138, NULL, NULL, 175471),
(175472, '1.20.1250.20-FF-001227', NULL, 'Uncharacterized protein', 501, NULL, NULL, 175472),
(175473, '1.20.58.390-FF-000183', NULL, 'Uncharacterized protein', 140, NULL, NULL, 175473),
(175474, '3.30.70.330-FF-002892', NULL, NULL, 58, NULL, NULL, 175474),
(175475, '3.10.330.20-FF-000021', NULL, 'Uncharacterized protein', 121, NULL, NULL, 175475),
(175476, '3.40.50.300-FF-004310', NULL, 'Glr0464 protein', 306, NULL, NULL, 175476),
(175477, '1.10.287.160-FF-000003', NULL, 'Putative serine/threonine-protein kinase N2', 79, NULL, NULL, 175477),
(175478, '1.10.510.10-FF-002018', NULL, 'Uncharacterized protein', 239, NULL, NULL, 175478),
(175479, '1.20.1270.60-FF-000156', NULL, 'SLIT-ROBO Rho GTPase-activating protein 2 isoform X8', 170, NULL, NULL, 175479),
(175480, '2.102.10.10-FF-000023', NULL, '3-phenylpropionate/trans-cinnamate dioxygenase ferredoxin subunit', 105, NULL, NULL, 175480),
(175481, '2.40.50.360-FF-000009', NULL, 'RuvB-like helicase', 18, NULL, NULL, 175481),
(175482, '3.30.160.60-FF-005894', NULL, NULL, 30, NULL, NULL, 175482),
(175483, '2.60.120.10-FF-000742', NULL, 'Uncharacterized protein', 116, NULL, NULL, 175483),
(175484, '3.40.720.10-FF-000367', NULL, 'Uncharacterized protein', 126, NULL, NULL, 175484),
(175485, '1.20.1250.20-FF-000952', NULL, 'Multidrug efflux pump', 194, NULL, NULL, 175485),
(175486, '3.10.20.600-FF-000011', NULL, NULL, 48, NULL, NULL, 175486),
(175487, '1.10.10.10-FF-001384', NULL, 'Uncharacterized protein', 70, NULL, NULL, 175487),
(175488, '1.20.1070.10-FF-000744', NULL, 'Growth hormone releasing hormone receptor', 111, NULL, NULL, 175488),
(175489, '3.10.105.10-FF-000068', NULL, 'Solute binding protein-like protein', 231, NULL, NULL, 175489),
(175490, '1.10.150.170-FF-000018', NULL, NULL, 84, NULL, NULL, 175490),
(175491, '2.40.10.10-FF-000109', NULL, 'Hepsin', 106, NULL, NULL, 175491),
(175492, '3.40.630.30-FF-000147', NULL, 'GNAT family N-acetyltransferase', 136, NULL, NULL, 175492),
(175493, '3.40.1810.10-FF-000020', NULL, 'MADS-box protein FLOWERING LOCUS C', 70, NULL, NULL, 175493),
(175494, '3.20.20.10-FF-000053', NULL, 'Pyridoxal phosphate homeostasis protein', 222, NULL, NULL, 175494),
(175495, '2.10.90.10-FF-000138', NULL, 'Uncharacterized protein', 116, NULL, NULL, 175495),
(175496, '2.40.30.10-FF-000223', NULL, 'Protein CBR-MRPS-18C', 104, NULL, NULL, 175496),
(175497, '1.10.150.50-FF-000119', NULL, 'Kinesin-like protein', 67, NULL, NULL, 175497),
(175498, '1.20.920.10-FF-000097', NULL, 'Nucleosome-remodeling factor subunit NURF301-like', 125, NULL, NULL, 175498),
(175499, '1.10.10.250-FF-000018', NULL, 'Uncharacterized protein', 83, NULL, NULL, 175499),
(175500, '1.10.2000.10-FF-000074', NULL, NULL, 92, NULL, NULL, 175500),
(175501, '1.20.58.390-FF-000290', NULL, 'Uncharacterized protein', 145, NULL, NULL, 175501),
(175502, '2.60.260.40-FF-000008', NULL, 'Cytochrome c oxidase polypeptide Vb', 66, NULL, NULL, 175502),
(175503, '2.40.50.200-FF-000001', NULL, 'TIGR00156 family protein', 109, NULL, NULL, 175503),
(175504, '1.25.10.10-FF-000501', NULL, 'Blast:Protein VAC14 homolog', 185, NULL, NULL, 175504),
(175505, '3.30.420.10-FF-000493', NULL, NULL, 105, NULL, NULL, 175505),
(175506, '1.10.10.2660-FF-000022', NULL, 'Uncharacterized protein', 248, NULL, NULL, 175506);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(175507, '2.40.128.20-FF-000060', NULL, 'Uncharacterized protein', 102, NULL, NULL, 175507),
(175508, '3.20.20.140-FF-000028', NULL, 'DNA polymerase III subunit alpha', 270, NULL, NULL, 175508),
(175509, '1.20.1250.20-FF-001334', NULL, 'Uncharacterized protein', 267, NULL, NULL, 175509),
(175510, '1.25.40.10-FF-003757', NULL, 'Protein smg7, putative', 165, NULL, NULL, 175510),
(175511, '2.60.40.60-FF-000316', NULL, 'Cadherin 74A, isoform A', 115, NULL, NULL, 175511),
(175512, '1.25.40.10-FF-001633', NULL, 'Tetratricopeptide repeat/TPR repeat, putative', 391, NULL, NULL, 175512),
(175513, '3.40.50.1110-FF-000117', NULL, 'Phospholipase B1, membrane-associated', 257, NULL, NULL, 175513),
(175514, '2.80.10.50-FF-000092', NULL, 'recombining binding protein suppressor of hairless', 140, NULL, NULL, 175514),
(175515, '3.80.10.10-FF-004097', NULL, 'Uncharacterized protein', 121, NULL, NULL, 175515),
(175516, '3.40.630.10-FF-000141', NULL, 'Peptide hydrolase', 337, NULL, NULL, 175516),
(175517, '3.30.70.2740-FF-000007', NULL, 'FAD-binding oxidoreductase', 86, NULL, NULL, 175517),
(175518, '3.40.50.150-FF-000740', NULL, 'Anamorsin homolog 1', 162, NULL, NULL, 175518),
(175519, '3.40.33.10-FF-000205', NULL, 'Uncharacterized protein', 132, NULL, NULL, 175519),
(175520, '3.40.30.10-FF-001002', NULL, 'Uncharacterized protein', 71, NULL, NULL, 175520),
(175521, '3.30.70.580-FF-000004', NULL, 'Pseudouridine synthase', 83, NULL, NULL, 175521),
(175522, '2.130.10.10-FF-004130', NULL, 'Uncharacterized protein', 184, NULL, NULL, 175522),
(175523, '1.10.390.10-FF-000007', NULL, 'Aminopeptidase', 277, NULL, NULL, 175523),
(175524, '3.20.20.120-FF-000022', NULL, 'Enolase 4', 306, NULL, NULL, 175524),
(175525, '3.40.50.1100-FF-000114', NULL, 'Cysteine synthase', 106, NULL, NULL, 175525),
(175526, '3.10.20.90-FF-000116', NULL, 'band 4.1-like protein 4A isoform X1', 84, NULL, NULL, 175526),
(175527, '2.30.39.10-FF-000070', NULL, 'Blast:Serpin B8', 93, NULL, NULL, 175527),
(175528, '2.130.10.10-FF-003966', NULL, 'Uncharacterized protein', 238, NULL, NULL, 175528),
(175529, '1.10.1200.10-FF-000162', NULL, 'Siderophore peptide synthetase fer3', 73, NULL, NULL, 175529),
(175530, '1.10.3290.10-FF-000010', NULL, 'Type III effector protein XopAC', 186, NULL, NULL, 175530),
(175531, '3.30.40.10-FF-001149', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 100, NULL, NULL, 175531),
(175532, '3.10.25.10-FF-000002', NULL, '10-formyltetrahydrofolate dehydrogenase', 102, NULL, NULL, 175532),
(175533, '1.25.40.850-FF-000003', NULL, 'Vacuolar protein sorting 33', 96, NULL, NULL, 175533),
(175534, '3.30.160.60-FF-000330', NULL, 'Zinc finger with KRAB and SCAN domains 1', 28, NULL, NULL, 175534),
(175535, '3.40.50.300-FF-002275', NULL, 'ATP-binding cassette, subfamily A (ABC1), member 16', 234, NULL, NULL, 175535),
(175536, '3.30.1490.20-FF-000089', NULL, 'Synapsin', 60, NULL, NULL, 175536),
(175537, '2.30.30.40-FF-000070', NULL, 'Alpha-(1,6)-fucosyltransferase', 58, NULL, NULL, 175537),
(175538, '3.40.50.12160-FF-000031', NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase', 131, NULL, NULL, 175538),
(175539, '3.10.290.10-FF-000104', NULL, 'Tyrosine--tRNA ligase', 58, NULL, NULL, 175539),
(175540, '1.10.1450.10-FF-000101', NULL, 'Tetraspanin', 116, NULL, NULL, 175540),
(175541, '2.20.25.10-FF-000083', NULL, 'DNA-directed RNA polymerase subunit', 34, NULL, NULL, 175541),
(175542, '3.30.420.270-FF-000019', NULL, 'Biopolymer transporter ExbD', 67, NULL, NULL, 175542),
(175543, '3.30.530.20-FF-000144', NULL, 'Phosphatidylinositol transfer protein', 272, NULL, NULL, 175543),
(175544, '2.60.40.150-FF-000243', NULL, 'Copine-3', 128, NULL, NULL, 175544),
(175545, '3.30.160.380-FF-000015', NULL, NULL, 123, NULL, NULL, 175545),
(175546, '4.10.400.10-FF-000043', NULL, 'Very low density lipoprotein receptor', 45, NULL, NULL, 175546),
(175547, '2.10.70.10-FF-000036', NULL, 'Sushi repeat containing protein X-linked', 62, NULL, NULL, 175547),
(175548, '3.40.1110.10-FF-000343', NULL, NULL, 72, NULL, NULL, 175548),
(175549, '3.40.190.10-FF-000112', NULL, 'Hca operon transcriptional activator', 105, NULL, NULL, 175549);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(175550, '2.30.30.490-FF-000086', NULL, 'Uncharacterized protein', 150, NULL, NULL, 175550),
(175551, '3.60.40.10-FF-000277', NULL, 'Uncharacterized protein', 251, NULL, NULL, 175551),
(175552, '2.80.10.50-FF-000103', NULL, 'Protein CBG12091', 187, NULL, NULL, 175552),
(175553, '3.30.70.590-FF-000007', NULL, 'Poly(A) polymerase gamma', 126, NULL, NULL, 175553),
(175554, '3.40.50.1820-FF-000673', NULL, 'Carboxylic ester hydrolase', 542, NULL, NULL, 175554),
(175555, '2.10.50.10-FF-000029', NULL, 'Signal peptide, CUB domain and EGF like domain containing 2', 61, NULL, NULL, 175555),
(175556, '3.40.30.10-FF-000378', NULL, 'Protein disulfide isomerase', 114, NULL, NULL, 175556),
(175557, '3.40.50.1820-FF-001162', NULL, 'Lipase precursor, putative', 343, NULL, NULL, 175557),
(175558, '1.25.40.10-FF-001852', NULL, 'ER membrane protein complex subunit 2', 256, NULL, NULL, 175558),
(175559, '3.30.2290.10-FF-000009', NULL, 'Putative peptidase TldD', 221, NULL, NULL, 175559),
(175560, '3.30.200.20-FF-000968', NULL, 'Serine/threonine protein kinase-56', 120, NULL, NULL, 175560),
(175561, '2.10.25.10-FF-001022', NULL, 'Uncharacterized protein', 39, NULL, NULL, 175561),
(175562, '3.30.40.10-FF-001705', NULL, 'Metal-response element-binding transcription factor 2', 62, NULL, NULL, 175562),
(175563, '3.30.1360.120-FF-000060', NULL, 'Aminomethyltransferase', 146, NULL, NULL, 175563),
(175564, '3.30.300.110-FF-000018', NULL, 'Uncharacterized protein', 81, NULL, NULL, 175564),
(175565, '1.10.472.10-FF-000220', NULL, 'Cyclin superfamily protein, putative', 75, NULL, NULL, 175565),
(175566, '1.10.472.80-FF-000090', NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', 143, NULL, NULL, 175566),
(175567, '2.10.25.10-FF-000398', NULL, 'Delta-like protein', 42, NULL, NULL, 175567),
(175568, '3.40.50.410-FF-000291', NULL, 'Uncharacterized protein', 193, NULL, NULL, 175568),
(175569, '1.10.1200.10-FF-000167', NULL, 'Uncharacterized protein', 60, NULL, NULL, 175569),
(175570, '1.10.287.110-FF-000235', NULL, 'Chaperone protein DNAJ, putative', 102, NULL, NULL, 175570),
(175571, '1.10.510.10-FF-004154', NULL, NULL, 222, NULL, NULL, 175571),
(175572, '3.10.50.40-FF-000064', NULL, 'Chaperone SurA', 106, NULL, NULL, 175572),
(175573, '1.20.58.390-FF-000071', NULL, 'Ligand-Gated ion Channel', 121, NULL, NULL, 175573),
(175574, '3.50.50.100-FF-000032', NULL, 'Uncharacterized protein', 390, NULL, NULL, 175574),
(175575, '1.10.533.10-FF-000019', NULL, 'NACHT, LRR and PYD domains-containing protein 3', 92, NULL, NULL, 175575),
(175576, '2.30.30.180-FF-000004', NULL, 'Ribosome maturation factor RimP', 61, NULL, NULL, 175576),
(175577, '3.40.30.10-FF-000159', NULL, 'Peroxiredoxin', 155, NULL, NULL, 175577),
(175578, '2.60.120.920-FF-000045', NULL, 'E3 ubiquitin/ISG15 ligase TRIM25', 195, NULL, NULL, 175578),
(175579, '2.60.40.10-FF-004152', NULL, NULL, 89, NULL, NULL, 175579),
(175580, '3.40.50.720-FF-000389', NULL, 'Dihydrodipicolinate reductase', 119, NULL, NULL, 175580),
(175581, '1.25.10.10-FF-000041', NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit', 404, NULL, NULL, 175581),
(175582, '1.20.1560.10-FF-000484', NULL, 'ABC transporter, ATP-binding/membrane protein', 307, NULL, NULL, 175582),
(175583, '2.60.40.10-FF-001297', NULL, 'Interleukin 18 binding protein', 107, NULL, NULL, 175583),
(175584, '1.10.287.10-FF-000048', NULL, 'Tryptophanyl-tRNA synthetase', 57, NULL, NULL, 175584),
(175585, '3.90.80.10-FF-000019', NULL, 'Os01g0322300 protein', 68, NULL, NULL, 175585),
(175586, '2.60.120.820-FF-000015', NULL, 'BTB domain containing 6', 115, NULL, NULL, 175586),
(175587, '3.30.420.10-FF-000616', NULL, NULL, 175, NULL, NULL, 175587),
(175588, '1.20.58.60-FF-000895', NULL, 'Spectrin beta chain', 157, NULL, NULL, 175588),
(175589, '2.60.120.10-FF-000630', NULL, 'cGMP-dependent protein kinase, isozyme 2 forms cD5/T2', 101, NULL, NULL, 175589),
(175590, '3.40.50.300-FF-005726', NULL, 'ATP-dependent RNA helicase SUPV3L1, mitochondrial', 160, NULL, NULL, 175590),
(175591, '1.10.287.1080-FF-000010', NULL, 'MazG-related protein', 124, NULL, NULL, 175591);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(175592, '3.40.50.300-FF-000044', NULL, 'Dynein heavy chain 5, axonemal', 150, NULL, NULL, 175592),
(175593, '2.130.10.10-FF-005327', NULL, 'Uncharacterized protein', 195, NULL, NULL, 175593),
(175594, '2.100.10.50-FF-000006', NULL, 'Multivesicular body subunit 12B', 149, NULL, NULL, 175594),
(175595, '1.20.1070.10-FF-001452', NULL, 'Coagulation factor II thrombin receptor like 2', 219, NULL, NULL, 175595),
(175596, '1.25.40.20-FF-001855', NULL, 'Uncharacterized protein', 136, NULL, NULL, 175596),
(175597, '1.20.5.110-FF-000162', NULL, 'GD12459', 64, NULL, NULL, 175597),
(175598, '3.90.870.10-FF-000018', NULL, 'Riboflavin biosynthesis protein RibBA', 187, NULL, NULL, 175598),
(175599, '3.30.70.20-FF-000013', NULL, 'Formate dehydrogenase iron-sulfur subunit', 58, NULL, NULL, 175599),
(175600, '3.20.90.10-FF-000001', NULL, 'Tubby-like protein', 262, NULL, NULL, 175600),
(175601, '3.20.20.105-FF-000011', NULL, 'Queuine tRNA-ribosyltransferase accessory subunit 2', 334, NULL, NULL, 175601),
(175602, '3.30.160.60-FF-003758', NULL, NULL, 32, NULL, NULL, 175602),
(175603, '4.10.280.10-FF-000061', NULL, 'Transcription factor SPEECHLESS', 75, NULL, NULL, 175603),
(175604, '3.40.50.620-FF-000696', NULL, 'Predicted protein', 256, NULL, NULL, 175604),
(175605, '3.30.559.30-FF-000011', NULL, 'Nonribosomal siderophore peptide synthase SidC', 243, NULL, NULL, 175605),
(175606, '3.40.1810.10-FF-000025', NULL, 'AGAMOUS-like 76', 82, NULL, NULL, 175606),
(175607, '3.30.160.60-FF-001746', NULL, 'Protein SENSITIVE TO PROTON RHIZOTOXICITY 1', 25, NULL, NULL, 175607),
(175608, '4.10.970.10-FF-000017', NULL, 'ATP dependent DNA ligase 1', 67, NULL, NULL, 175608),
(175609, '3.40.50.300-FF-004315', NULL, 'Uncharacterized protein', 132, NULL, NULL, 175609),
(175610, '3.30.9.10-FF-000240', NULL, 'Uncharacterized protein', 43, NULL, NULL, 175610),
(175611, '3.30.420.40-FF-000029', NULL, 'Actin-related protein 3', 166, NULL, NULL, 175611),
(175612, '1.10.10.10-FF-001389', NULL, 'MarR family transcriptional regulator', 164, NULL, NULL, 175612),
(175613, '3.90.1750.10-FF-000109', NULL, 'Uncharacterized protein', 48, NULL, NULL, 175613),
(175614, '3.40.50.300-FF-001567', NULL, 'Dynein heavy chain, putative', 238, NULL, NULL, 175614),
(175615, '2.130.10.10-FF-005546', NULL, 'WD repeat protein, putative', 223, NULL, NULL, 175615),
(175616, '3.20.20.140-FF-000466', NULL, 'Predicted protein', 85, NULL, NULL, 175616),
(175617, '4.10.270.10-FF-000009', NULL, 'Myosin II heavy chain', 58, NULL, NULL, 175617),
(175618, '3.40.50.720-FF-001232', NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase family protein', 113, NULL, NULL, 175618),
(175619, '3.40.440.10-FF-000003', NULL, 'Adenylosuccinate synthetase', 161, NULL, NULL, 175619),
(175620, '3.30.1180.20-FF-000009', NULL, 'Predicted protein', 136, NULL, NULL, 175620),
(175621, '3.40.50.300-FF-007750', NULL, 'ATP-dependent RNA helicase Ddx1', 75, NULL, NULL, 175621),
(175622, '2.60.40.10-FF-001971', NULL, 'Protein-glutamine gamma-glutamyltransferase 5', 113, NULL, NULL, 175622),
(175623, '1.10.472.10-FF-000113', NULL, 'Cyclin', 58, NULL, NULL, 175623),
(175624, '1.10.287.990-FF-000010', NULL, 'Putative 37S ribosomal protein S26A, mitochondrial', 67, NULL, NULL, 175624),
(175625, '2.60.120.290-FF-000148', NULL, 'AGAP005526-PA', 128, NULL, NULL, 175625),
(175626, '1.10.20.10-FF-000035', NULL, 'Nuclear transcription factor Y subunit B-3', 125, NULL, NULL, 175626),
(175627, '1.10.220.20-FF-000015', NULL, 'Uncharacterized protein', 80, NULL, NULL, 175627),
(175628, '2.130.10.10-FF-001168', NULL, 'G beta-like protein GBL', 298, NULL, NULL, 175628),
(175629, '1.25.10.10-FF-001805', NULL, 'protein unc-45 homolog B', 355, NULL, NULL, 175629),
(175630, '3.80.10.10-FF-001005', NULL, 'F-box/LRR-repeat protein 3', 188, NULL, NULL, 175630),
(175631, '3.40.50.150-FF-000414', NULL, 'S-adenosyl-L-methionine-dependent methyltransferase superfamily protein', 213, NULL, NULL, 175631),
(175632, '1.50.40.10-FF-000260', NULL, 'Solute carrier family 25 member 33', 121, NULL, NULL, 175632),
(175633, '3.40.50.720-FF-000956', NULL, 'Alcohol dehydrogenase', 55, NULL, NULL, 175633);
INSERT INTO "PUBLIC"."MODEL" VALUES
(175634, '3.40.50.2300-FF-001328', NULL, NULL, 84, NULL, NULL, 175634),
(175635, '1.10.220.10-FF-000012', NULL, 'Annexin A10', 85, NULL, NULL, 175635),
(175636, '3.40.640.10-FF-000203', NULL, 'serine palmitoyltransferase 2', 253, NULL, NULL, 175636),
(175637, '3.90.780.10-FF-000011', NULL, 'YHR202W-like protein', 118, NULL, NULL, 175637),
(175638, '2.60.120.380-FF-000057', NULL, 'Cysteine peptidase, Clan CA, family C2, putative', 152, NULL, NULL, 175638),
(175639, '3.30.70.140-FF-000002', NULL, 'Aspartate carbamoyltransferase / Aspartate carbamoyltransferase regulatory chain (PyrI)', 105, NULL, NULL, 175639),
(175640, '3.60.40.10-FF-000384', NULL, 'Uncharacterized protein', 145, NULL, NULL, 175640),
(175641, '2.40.50.140-FF-001247', NULL, NULL, 91, NULL, NULL, 175641),
(175642, '3.40.50.1010-FF-000183', NULL, NULL, 217, NULL, NULL, 175642),
(175643, '3.30.160.60-FF-002016', NULL, 'Zinc finger protein 432', 31, NULL, NULL, 175643),
(175644, '1.10.630.10-FF-000167', NULL, 'GM16491', 492, NULL, NULL, 175644),
(175645, '1.10.287.90-FF-000015', NULL, 'Cytochrome c oxidase subunit II', 73, NULL, NULL, 175645),
(175646, '2.60.120.290-FF-000255', NULL, 'Cubilin-like Protein', 112, NULL, NULL, 175646),
(175647, '1.20.1250.20-FF-001008', NULL, 'Solute carrier organic anion transporter family member', 381, NULL, NULL, 175647),
(175648, '3.40.50.10380-FF-000036', NULL, 'Malic enzyme', 138, NULL, NULL, 175648),
(175649, '2.60.120.10-FF-000304', NULL, 'Sll1785 protein', 239, NULL, NULL, 175649),
(175650, '3.20.20.70-FF-000368', NULL, 'Pyruvate formate-lyase 3 activating enzyme', 242, NULL, NULL, 175650),
(175651, '1.10.3520.10-FF-000006', NULL, 'Pleckstrin homology domain-containing family A member 8', 128, NULL, NULL, 175651),
(175652, '2.60.40.150-FF-000350', NULL, 'Similar to synaptotagmin XII', 141, NULL, NULL, 175652),
(175653, '1.20.120.1080-FF-000054', NULL, 'Benign gonial cell neoplasm', 105, NULL, NULL, 175653),
(175654, '1.10.630.10-FF-000274', NULL, 'Cytochrome P450 71D11, putative, expressed', 285, NULL, NULL, 175654),
(175655, '3.80.10.10-FF-003141', NULL, 'Uncharacterized protein', 324, NULL, NULL, 175655),
(175656, '1.10.8.10-FF-000348', NULL, 'RBR-type E3 ubiquitin transferase', 71, NULL, NULL, 175656),
(175657, '1.20.1280.50-FF-000193', NULL, 'Predicted protein', 44, NULL, NULL, 175657),
(175658, '1.10.3860.10-FF-000037', NULL, 'Ulip2 protein, putative', 171, NULL, NULL, 175658),
(175659, '1.25.40.20-FF-000220', NULL, 'Poly [ADP-ribose] polymerase', 112, NULL, NULL, 175659),
(175660, '3.40.50.300-FF-001674', NULL, 'E1A-binding protein p400 isoform X7', 247, NULL, NULL, 175660),
(175661, '3.40.50.1000-FF-000180', NULL, 'Uncharacterized protein, isoform B', 197, NULL, NULL, 175661),
(175662, '1.20.140.100-FF-000021', NULL, 'Dynein heavy chain', 166, NULL, NULL, 175662),
(175663, '3.40.50.1980-FF-000001', NULL, 'Histidinol dehydrogenase', 143, NULL, NULL, 175663),
(175664, '3.40.50.410-FF-000307', NULL, 'Uncharacterized protein', 147, NULL, NULL, 175664),
(175665, '1.25.40.10-FF-004140', NULL, 'Protein O-mannosyl-transferase TMTC1', 116, NULL, NULL, 175665),
(175666, '3.30.160.60-FF-003539', NULL, NULL, 30, NULL, NULL, 175666),
(175667, '3.50.50.60-FF-001142', NULL, 'Flavin-containing monooxygenase', 85, NULL, NULL, 175667),
(175668, '1.20.1560.10-FF-000596', NULL, 'ABC transporter, putative', 207, NULL, NULL, 175668),
(175669, '2.130.10.10-FF-005439', NULL, 'WD repeat-containing protein PCN', 216, NULL, NULL, 175669),
(175670, '2.40.30.10-FF-000330', NULL, 'Translation initiation factor IF-2, putative', 106, NULL, NULL, 175670),
(175671, '3.30.2410.10-FF-000003', NULL, 'probable E3 ubiquitin-protein ligase HERC4 isoform X1', 115, NULL, NULL, 175671),
(175672, '3.30.200.20-FF-002300', NULL, 'Uncharacterized protein', 18, NULL, NULL, 175672),
(175673, '2.130.10.10-FF-005097', NULL, 'Uncharacterized protein', 254, NULL, NULL, 175673),
(175674, '3.60.40.10-FF-000058', NULL, 'Stage II sporulation protein E', 225, NULL, NULL, 175674),
(175675, '3.50.30.30-FF-000069', NULL, 'Subtilisin-like protease SBT2.1', 157, NULL, NULL, 175675);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(175676, '2.10.25.10-FF-000746', NULL, 'Dumpy, isoform Z', 38, NULL, NULL, 175676),
(175677, '4.10.410.10-FF-000105', NULL, 'Predicted protein', 53, NULL, NULL, 175677),
(175678, '1.25.40.410-FF-000006', NULL, 'Guanine nucleotide exchange factor SPIKE 1', 154, NULL, NULL, 175678),
(175679, '3.40.50.150-FF-000066', NULL, 'Trimethylguanosine synthase 1', 214, NULL, NULL, 175679),
(175680, '1.10.1070.11-FF-000112', NULL, 'PIKK family atypical protein kinase', 194, NULL, NULL, 175680),
(175681, '2.60.40.10-FF-005894', NULL, NULL, 78, NULL, NULL, 175681),
(175682, '3.30.200.20-FF-001676', NULL, 'Serine/threonine-protein kinase SSN3', 79, NULL, NULL, 175682),
(175683, '2.30.30.40-FF-000300', NULL, 'Actin cytoskeleton-regulatory complex protein SLA1', 64, NULL, NULL, 175683),
(175684, '1.10.287.70-FF-000594', NULL, 'Predicted protein', 127, NULL, NULL, 175684),
(175685, '3.20.80.10-FF-000045', NULL, 'Predicted protein', 173, NULL, NULL, 175685),
(175686, '2.60.40.150-FF-000024', NULL, 'E3 ubiquitin-protein ligase', 129, NULL, NULL, 175686),
(175687, '1.20.1070.10-FF-001233', NULL, 'Uncharacterized protein', 302, NULL, NULL, 175687),
(175688, '1.10.630.10-FF-000622', NULL, 'Os01g0197100 protein', 239, NULL, NULL, 175688),
(175689, '3.40.50.300-FF-005945', NULL, 'Uncharacterized protein', 164, NULL, NULL, 175689),
(175690, '3.40.50.300-FF-005496', NULL, 'DEAD/DEAH box helicase', 186, NULL, NULL, 175690),
(175691, '1.25.40.10-FF-003864', NULL, 'Uncharacterized protein', 104, NULL, NULL, 175691),
(175692, '3.90.1200.10-FF-000035', NULL, 'Juvenile hormone-inducible protein 26', 215, NULL, NULL, 175692),
(175693, '1.20.58.1610-FF-000008', NULL, 'NADH-quinone oxidoreductase subunit A', 116, NULL, NULL, 175693),
(175694, '2.40.160.210-FF-000030', NULL, 'Uncharacterized protein', 82, NULL, NULL, 175694),
(175695, '3.60.21.10-FF-000351', NULL, 'Protein CBG24260', 126, NULL, NULL, 175695),
(175696, '3.30.70.330-FF-000975', NULL, 'Sbp1p', 107, NULL, NULL, 175696),
(175697, '1.20.58.190-FF-000022', NULL, NULL, 89, NULL, NULL, 175697),
(175698, '3.40.50.300-FF-005838', NULL, 'ABC transporter ATP-binding/permease protein', 244, NULL, NULL, 175698),
(175699, '1.20.58.740-FF-000007', NULL, 'Protein CBR-CED-5', 129, NULL, NULL, 175699),
(175700, '3.30.1120.60-FF-000001', NULL, 'Colicin N', 97, NULL, NULL, 175700),
(175701, '1.20.1110.10-FF-000006', NULL, 'Phospholipid-transporting ATPase', 14, NULL, NULL, 175701),
(175702, '1.10.1420.10-FF-000150', NULL, 'MSH (MutS Homolog) family', 128, NULL, NULL, 175702),
(175703, '1.10.3210.10-FF-000011', NULL, 'HD domain-containing protein 2', 194, NULL, NULL, 175703),
(175704, '3.40.50.300-FF-001893', NULL, 'DNA repair protein RAD5', 219, NULL, NULL, 175704),
(175705, '2.60.120.920-FF-000152', NULL, 'Si:ch211-22k7.9', 181, NULL, NULL, 175705),
(175706, '2.10.25.10-FF-001241', NULL, 'Predicted protein', 35, NULL, NULL, 175706),
(175707, '2.130.10.10-FF-001842', NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', 335, NULL, NULL, 175707),
(175708, '1.10.520.10-FF-000052', NULL, 'Peroxidase', 47, NULL, NULL, 175708),
(175709, '3.40.1110.10-FF-000455', NULL, NULL, 201, NULL, NULL, 175709),
(175710, '1.25.40.70-FF-000077', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', 171, NULL, NULL, 175710),
(175711, '2.60.40.10-FF-005675', NULL, NULL, 83, NULL, NULL, 175711),
(175712, '3.40.50.300-FF-005277', NULL, 'YALI0D22154p', 178, NULL, NULL, 175712),
(175713, '1.25.40.10-FF-003645', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 201, NULL, NULL, 175713),
(175714, '1.10.630.10-FF-000841', NULL, 'Uncharacterized protein', 269, NULL, NULL, 175714),
(175715, '1.20.1070.10-FF-001014', NULL, 'Uncharacterized protein', 277, NULL, NULL, 175715),
(175716, '3.30.160.60-FF-002802', NULL, 'Kruppel-Like Factor (Zinc finger protein)', 28, NULL, NULL, 175716),
(175717, '1.10.10.60-FF-001157', NULL, NULL, 52, NULL, NULL, 175717),
(175718, '1.10.10.10-FF-001726', NULL, 'Probable metalloprotease ARX1', 42, NULL, NULL, 175718),
(175719, '1.10.630.10-FF-000493', NULL, '(S)-N-methylcoclaurine 3''-hydroxylase isozyme 1', 463, NULL, NULL, 175719);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(175720, '3.30.160.60-FF-005456', NULL, NULL, 113, NULL, NULL, 175720),
(175721, '2.30.29.30-FF-000569', NULL, 'pleckstrin homology domain-containing family A member 3', 51, NULL, NULL, 175721),
(175722, '3.40.430.10-FF-000053', NULL, 'Diaminohydroxyphosphoribosylaminopyrimidine deaminase', 161, NULL, NULL, 175722),
(175723, '1.10.510.10-FF-001529', NULL, 'Ribosomal protein S6 kinase C1', 89, NULL, NULL, 175723),
(175724, '3.40.50.1440-FF-000070', NULL, 'Tubulin alpha chain', 75, NULL, NULL, 175724),
(175725, '3.40.50.410-FF-000184', NULL, 'Proteasome 26S subunit, non-ATPase 4', 91, NULL, NULL, 175725),
(175726, '1.20.58.80-FF-000002', NULL, 'Vacuolar protein sorting-associated protein 4A', 87, NULL, NULL, 175726),
(175727, '3.40.30.10-FF-000620', NULL, 'Protein disulfide-isomerase', 126, NULL, NULL, 175727),
(175728, '3.20.20.60-FF-000146', NULL, 'Aldolase like', 126, NULL, NULL, 175728),
(175729, '3.40.630.150-FF-000006', NULL, 'Uncharacterized protein', 295, NULL, NULL, 175729),
(175730, '3.20.20.70-FF-000149', NULL, 'Nicotinate-nucleotide pyrophosphorylase [carboxylating]', 161, NULL, NULL, 175730),
(175731, '1.25.40.550-FF-000020', NULL, 'AGR376Wp', 153, NULL, NULL, 175731),
(175732, '2.60.120.10-FF-000523', NULL, 'Predicted protein', 132, NULL, NULL, 175732),
(175733, '1.20.5.490-FF-000005', NULL, 'Nucleoporin complex subunit 54', 62, NULL, NULL, 175733),
(175734, '3.40.50.2020-FF-000047', NULL, 'Ribose-phosphate pyrophosphokinase II', 123, NULL, NULL, 175734),
(175735, '1.10.555.10-FF-000188', NULL, NULL, 300, NULL, NULL, 175735),
(175736, '3.30.420.10-FF-000723', NULL, NULL, 71, NULL, NULL, 175736),
(175737, '2.130.10.10-FF-005765', NULL, 'Uncharacterized protein', 109, NULL, NULL, 175737),
(175738, '2.10.70.10-FF-000255', NULL, 'Cellular communication network factor 5', 33, NULL, NULL, 175738),
(175739, '2.130.10.10-FF-001494', NULL, 'PRP4p Splicing factor', 121, NULL, NULL, 175739),
(175740, '2.10.25.10-FF-000965', NULL, 'Transmembrane protein with EGF-like and two follistatin-like domains 1b', 42, NULL, NULL, 175740),
(175741, '2.60.40.1180-FF-000055', NULL, 'META domain containing protein', 120, NULL, NULL, 175741),
(175742, '3.80.10.10-FF-002298', NULL, 'lumican', 205, NULL, NULL, 175742),
(175743, '3.20.20.80-FF-000490', NULL, 'Uncharacterized protein', 128, NULL, NULL, 175743),
(175744, '3.30.70.330-FF-001138', NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', 87, NULL, NULL, 175744),
(175745, '1.25.40.10-FF-002015', NULL, 'Intraflagellar transport protein 139', 184, NULL, NULL, 175745),
(175746, '3.40.50.1460-FF-000076', NULL, 'Senescence enhanced2b', 163, NULL, NULL, 175746),
(175747, '2.60.40.10-FF-005456', NULL, NULL, 130, NULL, NULL, 175747),
(175748, '3.40.50.2000-FF-001126', NULL, 'Glycogen [starch] synthase', 140, NULL, NULL, 175748),
(175749, '3.40.33.10-FF-000082', NULL, 'Uncharacterized protein', 176, NULL, NULL, 175749),
(175750, '3.30.160.60-FF-001965', NULL, 'Zinc finger protein SNAI3', 74, NULL, NULL, 175750),
(175751, '3.30.450.20-FF-000447', NULL, 'Sensory box histidine kinase SdeK', 118, NULL, NULL, 175751),
(175752, '3.40.1110.10-FF-000236', NULL, NULL, 12, NULL, NULL, 175752),
(175753, '2.80.10.50-FF-000215', NULL, 'UDP-N-acetyl-alpha-D-galactosamine:polypeptide N-acetylgalactosaminyltransferase-like 6', 63, NULL, NULL, 175753),
(175754, '3.30.450.40-FF-000205', NULL, 'Stage II sporulation E family protein', 167, NULL, NULL, 175754),
(175755, '3.40.50.300-FF-006108', NULL, 'Kurz protein, putative', 199, NULL, NULL, 175755),
(175756, '3.40.50.300-FF-002730', NULL, 'Iron(III) ABC transporter, ATP-binding protein', 274, NULL, NULL, 175756),
(175757, '2.60.40.10-FF-001752', NULL, 'obscurin-like isoform X3', 95, NULL, NULL, 175757),
(175758, '1.10.3730.20-FF-000042', NULL, 'Nucleotide Sugar TransPorter family', 103, NULL, NULL, 175758),
(175759, '1.10.510.10-FF-000220', NULL, 'dual specificity protein kinase CLK4 isoform X1', 241, NULL, NULL, 175759),
(175760, '2.40.30.10-FF-000004', NULL, '50S ribosomal protein L3', 82, NULL, NULL, 175760),
(175761, '3.60.21.10-FF-000132', NULL, 'Serine/threonine-protein phosphatase', 350, NULL, NULL, 175761);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(175762, '1.20.140.10-FF-000026', NULL, 'Acyl-CoA dehydrogenase FadE24', 135, NULL, NULL, 175762),
(175763, '1.25.50.20-FF-000046', NULL, 'Aminopeptidase', 319, NULL, NULL, 175763),
(175764, '3.30.1370.100-FF-000016', NULL, 'MutL homolog 3 (E. coli)', 111, NULL, NULL, 175764),
(175765, '3.30.40.10-FF-000981', NULL, 'RING/U-box superfamily protein', 76, NULL, NULL, 175765),
(175766, '1.20.140.50-FF-000009', NULL, 'Programmed cell death 6-interacting protein, putative', 169, NULL, NULL, 175766),
(175767, '2.130.10.10-FF-002331', NULL, 'Uncharacterized protein', 240, NULL, NULL, 175767),
(175768, '2.30.30.140-FF-000239', NULL, 'Putative ATP-dependent RNA helicase TDRD12', 70, NULL, NULL, 175768),
(175769, '3.20.20.80-FF-000832', NULL, 'Uncharacterized protein', 45, NULL, NULL, 175769),
(175770, '3.40.80.10-FF-000005', NULL, 'N-acetylmuramoyl-L-alanine amidase', 182, NULL, NULL, 175770),
(175771, '3.30.1370.110-FF-000019', NULL, 'Endonuclease MutS2', 88, NULL, NULL, 175771),
(175772, '2.60.40.10-FF-004045', NULL, NULL, 97, NULL, NULL, 175772),
(175773, '1.10.268.10-FF-000015', NULL, 'DNA topoisomerase 2', 172, NULL, NULL, 175773),
(175774, '3.10.580.10-FF-000082', NULL, 'Chloride channel protein', 129, NULL, NULL, 175774),
(175775, '1.10.510.10-FF-002237', NULL, NULL, 226, NULL, NULL, 175775),
(175776, '1.10.3380.10-FF-000017', NULL, 'U5 small nuclear ribonucleoprotein helicase', 139, NULL, NULL, 175776),
(175777, '2.60.40.10-FF-003769', NULL, NULL, 91, NULL, NULL, 175777),
(175778, '3.40.50.720-FF-001451', NULL, 'Putative cinnamyl alcohol dehydrogenase 6', 82, NULL, NULL, 175778),
(175779, '1.20.1110.10-FF-000225', NULL, NULL, 20, NULL, NULL, 175779),
(175780, '1.20.920.10-FF-000092', NULL, 'Transcription initiation factor tfiid, putative', 117, NULL, NULL, 175780),
(175781, '3.30.930.10-FF-000251', NULL, 'Uncharacterized protein', 146, NULL, NULL, 175781),
(175782, '1.10.720.60-FF-000020', NULL, 'Enolase-phosphatase E1', 74, NULL, NULL, 175782),
(175783, '3.40.50.300-FF-005619', NULL, 'MutS homolog1', 120, NULL, NULL, 175783),
(175784, '1.20.970.10-FF-000038', NULL, 'Anthranilate phosphoribosyltransferase 2', 58, NULL, NULL, 175784),
(175785, '3.10.280.10-FF-000036', NULL, 'Uncharacterized protein C15D4.11c', 210, NULL, NULL, 175785),
(175786, '3.60.10.10-FF-000337', NULL, 'Fgr24p', 218, NULL, NULL, 175786),
(175787, '1.10.287.470-FF-000085', NULL, 'Cation efflux system (CzcB-like)', 74, NULL, NULL, 175787),
(175788, '3.80.10.10-FF-002859', NULL, 'Protein CBG18939', 96, NULL, NULL, 175788),
(175789, '3.30.9.40-FF-000001', NULL, 'Styrene monooxygenase StyA', 138, NULL, NULL, 175789),
(175790, '3.30.160.60-FF-005675', NULL, NULL, 74, NULL, NULL, 175790),
(175791, '2.60.120.10-FF-000175', NULL, 'AGC protein kinase', 144, NULL, NULL, 175791),
(175792, '3.30.420.10-FF-000381', NULL, 'Predicted protein', 322, NULL, NULL, 175792),
(175793, '2.40.30.20-FF-000007', NULL, 'Riboflavin synthase, alpha subunit', 87, NULL, NULL, 175793),
(175794, '3.40.720.10-FF-000148', NULL, 'Uncharacterized protein', 326, NULL, NULL, 175794),
(175795, '3.15.10.10-FF-000014', NULL, 'BPI fold-containing family A member 2', 222, NULL, NULL, 175795),
(175796, '3.40.50.200-FF-000014', NULL, 'Proteinase K', 277, NULL, NULL, 175796),
(175797, '1.20.58.340-FF-000084', NULL, 'Mg2+ transporter protein, CorA-like protein', 130, NULL, NULL, 175797),
(175798, '1.10.357.70-FF-000021', NULL, 'Si:dkey-45k15.1', 153, NULL, NULL, 175798),
(175799, '2.130.10.10-FF-003528', NULL, 'Uncharacterized protein', 119, NULL, NULL, 175799),
(175800, '3.20.20.70-FF-000262', NULL, 'NADH:flavin oxidoreductase', 362, NULL, NULL, 175800),
(175801, '2.30.29.150-FF-000010', NULL, 'Uncharacterized protein', 161, NULL, NULL, 175801),
(175802, '3.30.460.10-FF-000158', NULL, 'DNA-directed DNA polymerase, family X', 118, NULL, NULL, 175802),
(175803, '1.20.1560.10-FF-000719', NULL, 'ABC transporter', 251, NULL, NULL, 175803),
(175804, '2.60.120.10-FF-000068', NULL, 'cGMP-dependent protein kinase', 133, NULL, NULL, 175804),
(175805, '1.10.510.10-FF-001855', NULL, 'Tyrosine-protein kinase hopscotch', 251, NULL, NULL, 175805);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(175806, '3.40.50.620-FF-000584', NULL, 'Probable tRNA sulfurtransferase', 215, NULL, NULL, 175806),
(175807, '3.30.450.20-FF-000666', NULL, 'Uncharacterized protein', 109, NULL, NULL, 175807),
(175808, '3.30.390.30-FF-000046', NULL, 'Glr2871 protein', 114, NULL, NULL, 175808),
(175809, '2.170.270.10-FF-000024', NULL, 'Histone-lysine N-methyltransferase SETD7', 143, NULL, NULL, 175809),
(175810, '3.30.160.60-FF-006170', NULL, NULL, 70, NULL, NULL, 175810),
(175811, '1.10.3720.10-FF-000100', NULL, 'Sulfate ABC transporter permease', 198, NULL, NULL, 175811),
(175812, '1.25.10.10-FF-001676', NULL, 'Importin-alpha export receptor', 1033, NULL, NULL, 175812),
(175813, '1.25.40.10-FF-003319', NULL, 'Superkiller protein 3', 104, NULL, NULL, 175813),
(175814, '2.130.10.10-FF-005658', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 166, NULL, NULL, 175814),
(175815, '1.10.287.1490-FF-000032', NULL, 'Atg11p', 166, NULL, NULL, 175815),
(175816, '1.10.8.60-FF-000335', NULL, 'Cell division control protein', 62, NULL, NULL, 175816),
(175817, '3.30.310.50-FF-000030', NULL, 'Uncharacterized protein', 126, NULL, NULL, 175817),
(175818, '1.20.5.740-FF-000002', NULL, 'NudC domain-containing protein 2', 29, NULL, NULL, 175818),
(175819, '1.10.287.70-FF-000369', NULL, 'Si:dkey-183j2.10', 90, NULL, NULL, 175819),
(175820, '3.40.630.30-FF-000602', NULL, 'Uncharacterized protein', 68, NULL, NULL, 175820),
(175821, '3.10.620.30-FF-000018', NULL, 'Predicted protein', 117, NULL, NULL, 175821),
(175822, '3.30.40.10-FF-001150', NULL, 'E3 ubiquitin-protein ligase RMA1H1 isoform A', 123, NULL, NULL, 175822),
(175823, '1.10.630.10-FF-000386', NULL, 'Os03g0568400 protein', 258, NULL, NULL, 175823),
(175824, '3.40.50.150-FF-000291', NULL, 'Benzoquinone methyltransferase', 189, NULL, NULL, 175824),
(175825, '3.10.20.90-FF-000560', NULL, 'E3 ubiquitin-protein ligase parkin', 84, NULL, NULL, 175825),
(175826, '3.30.70.330-FF-001812', NULL, NULL, 60, NULL, NULL, 175826),
(175827, '2.140.10.30-FF-000004', NULL, 'Omega, isoform H', 466, NULL, NULL, 175827),
(175828, '1.20.120.1760-FF-000050', NULL, 'Phosphatidylcholine synthase', 226, NULL, NULL, 175828),
(175829, '2.60.40.10-FF-002353', NULL, 'Uncharacterized protein', 92, NULL, NULL, 175829),
(175830, '2.30.30.1020-FF-000003', NULL, 'CCR4-NOT transcription complex subunit 3 isoform X1', 156, NULL, NULL, 175830),
(175831, '2.130.10.10-FF-001387', NULL, 'serine/threonine-protein kinase/endoribonuclease IRE1', 253, NULL, NULL, 175831),
(175832, '1.10.472.80-FF-000089', NULL, 'GTPase-activating protein', 149, NULL, NULL, 175832),
(175833, '3.40.1380.20-FF-000045', NULL, 'Pyruvate kinase', 133, NULL, NULL, 175833),
(175834, '1.10.510.10-FF-000332', NULL, 'TBC domain-containing protein kinase-like protein', 242, NULL, NULL, 175834),
(175835, '1.20.1070.10-FF-001800', NULL, 'Uncharacterized protein', 317, NULL, NULL, 175835),
(175836, '3.30.70.330-FF-001705', NULL, NULL, 86, NULL, NULL, 175836),
(175837, '3.90.1750.10-FF-000003', NULL, 'E3 ubiquitin-protein ligase UPL1', 181, NULL, NULL, 175837),
(175838, '1.10.287.110-FF-000123', NULL, 'Exported protein family 1', 120, NULL, NULL, 175838),
(175839, '3.30.450.60-FF-000088', NULL, 'SRP54-type protein, putative', 123, NULL, NULL, 175839),
(175840, '4.10.1000.10-FF-000088', NULL, 'Uncharacterized protein', 78, NULL, NULL, 175840),
(175841, '3.70.10.10-FF-000128', NULL, 'Uncharacterized protein', 304, NULL, NULL, 175841),
(175842, '3.40.250.10-FF-000174', NULL, 'Putative rhodanese-like proteiny domain superfamily protein', 114, NULL, NULL, 175842),
(175843, '3.40.50.150-FF-000302', NULL, 'S-adenosyl-L-methionine-dependent methyltransferase, putative', 300, NULL, NULL, 175843),
(175844, '3.30.200.20-FF-001457', NULL, NULL, 110, NULL, NULL, 175844),
(175845, '2.40.170.20-FF-000090', NULL, 'TonB-dependent receptor', 451, NULL, NULL, 175845),
(175846, '3.40.50.720-FF-000844', NULL, 'Mitochondrial enoyl reductase, putative', 182, NULL, NULL, 175846),
(175847, '3.30.360.10-FF-000105', NULL, 'Uncharacterized protein', 126, NULL, NULL, 175847);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(175848, '3.30.70.260-FF-000038', NULL, 'Methionine import ATP-binding protein MetN', 89, NULL, NULL, 175848),
(175849, '3.40.50.300-FF-003927', NULL, 'Small GTPase EhRabX35, putative', 193, NULL, NULL, 175849),
(175850, '1.25.40.800-FF-000016', NULL, 'Uncharacterized protein', 90, NULL, NULL, 175850),
(175851, '3.40.630.30-FF-000591', NULL, 'Uncharacterized protein', 86, NULL, NULL, 175851),
(175852, '3.40.50.300-FF-001786', NULL, 'DEAD/DEAH box helicase', 73, NULL, NULL, 175852),
(175853, '3.30.160.60-FF-004040', NULL, 'Suppressor of hairy wing, isoform C', 80, NULL, NULL, 175853),
(175854, '2.40.70.10-FF-000220', NULL, 'Uncharacterized protein', 204, NULL, NULL, 175854),
(175855, '3.30.70.1360-FF-000003', NULL, 'Global nitrogen regulator NrpR', 103, NULL, NULL, 175855),
(175856, '1.25.40.10-FF-003426', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 114, NULL, NULL, 175856),
(175857, '1.10.472.80-FF-000106', NULL, 'TBC/Rab GTPase activating domain containing protein', 131, NULL, NULL, 175857),
(175858, '1.25.10.10-FF-001569', NULL, 'Predicted protein', 352, NULL, NULL, 175858),
(175859, '3.40.50.10810-FF-000210', NULL, 'Uncharacterized protein', 114, NULL, NULL, 175859),
(175860, '3.30.200.20-FF-001570', NULL, 'Ribosomal protein S6 kinase a, polypeptide 1', 33, NULL, NULL, 175860),
(175861, '3.90.80.10-FF-000020', NULL, 'Inorganic pyrophosphatase', 171, NULL, NULL, 175861),
(175862, '2.10.60.10-FF-000081', NULL, 'Receptor protein serine/threonine kinase', 102, NULL, NULL, 175862),
(175863, '2.10.220.10-FF-000137', NULL, 'Proprotein convertase subtilisin/kexin type 5a', 59, NULL, NULL, 175863),
(175864, '4.10.400.10-FF-000155', NULL, 'Low-density lipoprotein receptor', 43, NULL, NULL, 175864),
(175865, '3.30.365.10-FF-000077', NULL, 'Uncharacterized protein', 81, NULL, NULL, 175865),
(175866, '1.20.140.10-FF-000138', NULL, 'Uncharacterized protein', 31, NULL, NULL, 175866),
(175867, '3.20.20.190-FF-000127', NULL, NULL, 211, NULL, NULL, 175867),
(175868, '1.20.1110.10-FF-000113', NULL, 'Sodium/potassium-transporting ATPase subunit alpha', 418, NULL, NULL, 175868),
(175869, '3.20.20.70-FF-000155', NULL, 'Nicotinate phosphoribosyltransferase', 119, NULL, NULL, 175869),
(175870, '1.10.238.10-FF-000412', NULL, 'Chromatin accessibility complex protein 1', 88, NULL, NULL, 175870),
(175871, '1.10.150.110-FF-000023', NULL, 'DNA polymerase/3''-5'' exonuclease PolX', 84, NULL, NULL, 175871),
(175872, '2.60.120.10-FF-000181', NULL, 'Beta-conglycinin beta subunit 1', 205, NULL, NULL, 175872),
(175873, '1.25.10.10-FF-000153', NULL, 'Unc-45 myosin chaperone B', 435, NULL, NULL, 175873),
(175874, '2.40.50.140-FF-001135', NULL, NULL, 115, NULL, NULL, 175874),
(175875, '3.90.550.10-FF-000415', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 95, NULL, NULL, 175875),
(175876, '2.60.40.10-FF-000223', NULL, 'Platelet-derived growth factor receptor beta', 87, NULL, NULL, 175876),
(175877, '3.60.21.10-FF-000244', NULL, 'Protein CBG04124', 293, NULL, NULL, 175877),
(175878, '2.140.10.20-FF-000001', NULL, 'Nitrite reductase NirS', 426, NULL, NULL, 175878),
(175879, '3.40.50.1000-FF-000303', NULL, 'Mitochondrial import inner membrane translocase subunit TIM50', 189, NULL, NULL, 175879),
(175880, '3.80.10.10-FF-000954', NULL, 'Leucine_Rich_Repeat_-_putative', 92, NULL, NULL, 175880),
(175881, '2.130.10.10-FF-002005', NULL, 'WD repeat domain 70', 171, NULL, NULL, 175881),
(175882, '3.30.160.60-FF-005563', NULL, NULL, 61, NULL, NULL, 175882),
(175883, '2.60.40.1730-FF-000046', NULL, 'Endoplasmic reticulum aminopeptidase 2', 218, NULL, NULL, 175883),
(175884, '2.130.10.10-FF-003860', NULL, 'WD repeat protein, putative', 283, NULL, NULL, 175884),
(175885, '3.30.420.510-FF-000018', NULL, 'Pantothenate kinase', 119, NULL, NULL, 175885),
(175886, '2.130.10.10-FF-005990', NULL, 'Predicted protein', 227, NULL, NULL, 175886),
(175887, '3.30.160.60-FF-000436', NULL, 'PR domain zinc finger protein 4', 28, NULL, NULL, 175887),
(175888, '3.90.700.10-FF-000012', NULL, '3-ketosteroid-delta-1-dehydrogenase', 149, NULL, NULL, 175888);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(175889, '1.10.510.10-FF-000219', NULL, 'Putative serine/threonine-protein kinase Nek4', 200, NULL, NULL, 175889),
(175890, '2.130.10.10-FF-002112', NULL, 'Uncharacterized protein', 248, NULL, NULL, 175890),
(175891, '1.10.10.10-FF-001619', NULL, 'ArsR family transcriptional regulator', 102, NULL, NULL, 175891),
(175892, '3.40.50.12760-FF-000008', NULL, 'Uncharacterized protein', 461, NULL, NULL, 175892),
(175893, '1.20.5.300-FF-000005', NULL, 'cyclic nucleotide-gated cation channel alpha-4', 44, NULL, NULL, 175893),
(175894, '3.40.50.300-FF-002404', NULL, 'ATP-dependent dethiobiotin synthetase BioD', 225, NULL, NULL, 175894),
(175895, '3.30.70.1230-FF-000217', NULL, 'Adenylate cyclase, putative', 97, NULL, NULL, 175895),
(175896, '1.10.12.10-FF-000045', NULL, 'Probable enoyl-CoA hydratase/isomerase', 53, NULL, NULL, 175896),
(175897, '2.30.29.30-FF-001070', NULL, 'Uncharacterized protein', 74, NULL, NULL, 175897),
(175898, '3.30.505.10-FF-000066', NULL, 'suppressor of cytokine signaling 3', 152, NULL, NULL, 175898),
(175899, '3.40.1170.10-FF-000009', NULL, 'Mismatch repair ATPase', 116, NULL, NULL, 175899),
(175900, '1.50.40.10-FF-000366', NULL, 'Peroxisomal adenine nucleotide carrier 1 isoform B', 151, NULL, NULL, 175900),
(175901, '1.10.10.10-FF-000422', NULL, 'DNA-binding protein RFX7', 75, NULL, NULL, 175901),
(175902, '3.90.1600.10-FF-000003', NULL, 'DNA polymerase', 174, NULL, NULL, 175902),
(175903, '3.40.50.150-FF-001825', NULL, NULL, 80, NULL, NULL, 175903),
(175904, '1.25.40.10-FF-001285', NULL, 'Bardet-Biedl syndrome 4 (BBS4) protein-like protein', 136, NULL, NULL, 175904),
(175905, '3.30.950.10-FF-000027', NULL, 'Uroporphyrin-III C-methyltransferase', 123, NULL, NULL, 175905),
(175906, '2.40.30.10-FF-000111', NULL, 'NADPH--cytochrome P450 reductase', 90, NULL, NULL, 175906),
(175907, '3.40.50.300-FF-008019', NULL, 'Rho related BTB domain containing 3', 140, NULL, NULL, 175907),
(175908, '1.50.40.10-FF-000147', NULL, 'Solute carrier family 25 (Mitochondrial aspartate/glutamate transporter), member 12/13', 285, NULL, NULL, 175908),
(175909, '3.40.50.300-FF-002511', NULL, 'Cytidylate kinase', 217, NULL, NULL, 175909),
(175910, '1.10.3080.10-FF-000073', NULL, 'Eukaryotic translation initiation factor 3 subunit E', 92, NULL, NULL, 175910),
(175911, '3.40.50.300-FF-002623', NULL, 'Telomere length regulation protein ELG1', 217, NULL, NULL, 175911),
(175912, '3.40.50.150-FF-001718', NULL, NULL, 202, NULL, NULL, 175912),
(175913, '2.40.70.10-FF-000001', NULL, 'Gag-Pol polyprotein', 99, NULL, NULL, 175913),
(175914, '1.20.5.2050-FF-000005', NULL, 'Transcription factor with AP2 domain(S), putative', 69, NULL, NULL, 175914),
(175915, '1.10.10.10-FF-001732', NULL, 'DNA-binding response regulator', 103, NULL, NULL, 175915),
(175916, '2.130.10.10-FF-004242', NULL, 'Uncharacterized protein', 140, NULL, NULL, 175916),
(175917, '2.60.40.10-FF-003657', NULL, NULL, 96, NULL, NULL, 175917),
(175918, '3.10.580.10-FF-000188', NULL, 'Chloride channel protein', 89, NULL, NULL, 175918),
(175919, '1.25.40.10-FF-004033', NULL, 'Anaphase-promoting complex subunit cut9', 553, NULL, NULL, 175919),
(175920, '3.80.10.10-FF-004445', NULL, 'Uncharacterized protein', 116, NULL, NULL, 175920),
(175921, '3.30.70.330-FF-000868', NULL, 'RNA-binding domain-containing protein', 95, NULL, NULL, 175921),
(175922, '3.30.2160.10-FF-000011', NULL, 'LOW QUALITY PROTEIN: probable E3 ubiquitin-protein ligase HERC1', 84, NULL, NULL, 175922),
(175923, '1.10.10.10-FF-000203', NULL, 'Vacuolar protein sorting 36 homolog', 80, NULL, NULL, 175923),
(175924, '3.40.30.10-FF-000726', NULL, 'Iodothyronine deiodinase', 136, NULL, NULL, 175924),
(175925, '1.10.10.10-FF-000315', NULL, 'Developmental regulator FlbA', 115, NULL, NULL, 175925),
(175926, '2.10.70.10-FF-000249', NULL, 'fibropellin-1-like isoform X1', 53, NULL, NULL, 175926),
(175927, '2.40.100.10-FF-000043', NULL, 'Peptidyl-prolyl cis-trans isomerase', 185, NULL, NULL, 175927),
(175928, '2.60.120.1000-FF-000024', NULL, 'Uncharacterized protein', 219, NULL, NULL, 175928),
(175929, '3.40.1000.10-FF-000008', NULL, 'DUF1795 domain-containing protein', 144, NULL, NULL, 175929);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(175930, '3.40.50.1010-FF-000076', NULL, 'Ribonuclease VapC', 123, NULL, NULL, 175930),
(175931, '1.20.1310.10-FF-000100', NULL, 'WGS project CABT00000000 data, contig 2.1', 94, NULL, NULL, 175931),
(175932, '3.30.70.2030-FF-000002', NULL, 'Lysin N-acetylmuramoyl-L-alanine amidase', 81, NULL, NULL, 175932),
(175933, '3.60.20.40-FF-000037', NULL, 'Gamma-glutamyltransferase 5', 206, NULL, NULL, 175933),
(175934, '3.30.530.20-FF-000032', NULL, 'Oligoketide cyclase', 140, NULL, NULL, 175934),
(175935, '1.25.40.10-FF-002122', NULL, 'Pentatricopeptide repeat-containing protein', 126, NULL, NULL, 175935),
(175936, '2.60.40.10-FF-002134', NULL, 'Titin homolog', 99, NULL, NULL, 175936),
(175937, '3.20.20.60-FF-000152', NULL, 'Phosphonopyruvate hydrolase', 290, NULL, NULL, 175937),
(175938, '1.10.400.20-FF-000001', NULL, 'D-tagatose-1,6-bisphosphate aldolase subunit GatZ', 137, NULL, NULL, 175938),
(175939, '3.30.200.20-FF-001238', NULL, 'Os08g0179000 protein', 105, NULL, NULL, 175939),
(175940, '1.10.8.1310-FF-000005', NULL, 'GTPase-activating protein gyp10', 149, NULL, NULL, 175940),
(175941, '2.60.40.10-FF-005911', NULL, NULL, 53, NULL, NULL, 175941),
(175942, '3.40.50.1000-FF-000073', NULL, 'Trehalose 6-phosphate phosphatase', 160, NULL, NULL, 175942),
(175943, '2.60.40.150-FF-000131', NULL, 'calpain-6', 124, NULL, NULL, 175943),
(175944, '1.10.287.550-FF-000013', NULL, 'Uncharacterized protein', 62, NULL, NULL, 175944),
(175945, '3.90.870.50-FF-000002', NULL, 'Carbamoyltransferase HypF', 293, NULL, NULL, 175945),
(175946, '3.60.40.10-FF-000165', NULL, 'protein phosphatase 1F', 261, NULL, NULL, 175946),
(175947, '1.20.1280.50-FF-000209', NULL, 'Os09g0555300 protein', 45, NULL, NULL, 175947),
(175948, '1.20.58.190-FF-000016', NULL, NULL, 146, NULL, NULL, 175948),
(175949, '3.30.70.100-FF-000131', NULL, NULL, 70, NULL, NULL, 175949),
(175950, '3.90.190.10-FF-000444', NULL, 'Uncharacterized protein', 272, NULL, NULL, 175950),
(175951, '1.10.10.10-FF-001951', NULL, 'Uncharacterized protein', 81, NULL, NULL, 175951),
(175952, '3.20.20.140-FF-000359', NULL, 'Histidinol-phosphatase, putative', 279, NULL, NULL, 175952),
(175953, '2.10.220.10-FF-000025', NULL, 'Proprotein convertase subtilisin/kexin type 5', 55, NULL, NULL, 175953),
(175954, '3.30.70.330-FF-003049', NULL, NULL, 164, NULL, NULL, 175954),
(175955, '3.40.30.10-FF-000507', NULL, 'Thioredoxin, putative', 162, NULL, NULL, 175955),
(175956, '1.25.10.10-FF-001457', NULL, 'Related to VPS15-ser/thr protein kinase', 202, NULL, NULL, 175956),
(175957, '3.40.50.150-FF-001595', NULL, NULL, 265, NULL, NULL, 175957),
(175958, '2.30.30.380-FF-000058', NULL, 'Thioredoxin 1', 29, NULL, NULL, 175958),
(175959, '3.60.21.60-FF-000012', NULL, 'DNA polymerase alpha subunit B', 114, NULL, NULL, 175959),
(175960, '3.40.850.10-FF-000377', NULL, 'Uncharacterized protein', 121, NULL, NULL, 175960),
(175961, '3.10.450.350-FF-000009', NULL, 'Peptidase M23', 93, NULL, NULL, 175961),
(175962, '3.30.9.10-FF-000127', NULL, 'FAD-dependent oxidoreductase family protein', 57, NULL, NULL, 175962),
(175963, '2.130.10.130-FF-000034', NULL, NULL, 251, NULL, NULL, 175963),
(175964, '3.20.20.60-FF-000040', NULL, 'Pyruvate, phosphate dikinase, chloroplastic', 340, NULL, NULL, 175964),
(175965, '3.40.50.300-FF-006002', NULL, 'Cell division control protein 48', 165, NULL, NULL, 175965),
(175966, '3.30.10.20-FF-000021', NULL, NULL, 69, NULL, NULL, 175966),
(175967, '1.10.8.60-FF-000554', NULL, 'Uncharacterized protein', 67, NULL, NULL, 175967),
(175968, '2.130.10.10-FF-001617', NULL, 'WD40-repeat-containing domain protein', 152, NULL, NULL, 175968),
(175969, '2.30.30.40-FF-000412', NULL, 'Dynamin-binding protein', 61, NULL, NULL, 175969),
(175970, '3.30.70.1230-FF-000094', NULL, 'Guanylate cyclase soluble subunit beta-1', 193, NULL, NULL, 175970),
(175971, '1.50.10.10-FF-000090', NULL, 'alpha-1,2-Mannosidase', 445, NULL, NULL, 175971),
(175972, '3.40.50.300-FF-000257', NULL, 'UvrABC system protein B', 176, NULL, NULL, 175972),
(175973, '2.130.10.10-FF-000190', NULL, 'Nuclear pore complex subunit', 351, NULL, NULL, 175973);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(175974, '3.30.230.130-FF-000030', NULL, 'Cullin-4', 160, NULL, NULL, 175974),
(175975, '1.20.120.1910-FF-000022', NULL, 'Cysteine--tRNA ligase', 165, NULL, NULL, 175975),
(175976, '1.20.1070.10-FF-000963', NULL, 'Uncharacterized protein', 52, NULL, NULL, 175976),
(175977, '2.60.40.10-FF-001639', NULL, 'Putative beta-D-xylosidase 5', 107, NULL, NULL, 175977),
(175978, '3.30.1490.110-FF-000006', NULL, 'Cell division protein FtsA', 82, NULL, NULL, 175978),
(175979, '3.40.50.2300-FF-001109', NULL, 'Uncharacterized protein', 230, NULL, NULL, 175979),
(175980, '2.130.10.10-FF-002224', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit wuho', 285, NULL, NULL, 175980),
(175981, '3.30.70.1230-FF-000105', NULL, 'Receptor-type guanylate cyclase gcy-21', 222, NULL, NULL, 175981),
(175982, '1.10.287.70-FF-000588', NULL, 'Uncharacterized protein', 141, NULL, NULL, 175982),
(175983, '3.30.160.60-FF-005782', NULL, NULL, 45, NULL, NULL, 175983),
(175984, '4.10.860.120-FF-000026', NULL, 'DNA-directed RNA polymerase subunit', 130, NULL, NULL, 175984),
(175985, '3.90.215.10-FF-000025', NULL, 'Uncharacterized protein', 54, NULL, NULL, 175985),
(175986, '1.20.1560.10-FF-000826', NULL, 'ABC transporter multi-drug efflux transporter-like protein', 23, NULL, NULL, 175986),
(175987, '1.10.630.10-FF-000616', NULL, 'Uncharacterized protein', 252, NULL, NULL, 175987),
(175988, '1.10.565.10-FF-000144', NULL, 'Nuclear receptor subfamily 4, group A, member 3', 170, NULL, NULL, 175988),
(175989, '3.30.1490.120-FF-000009', NULL, 'DNA-directed RNA polymerase III subunit RPC8', 80, NULL, NULL, 175989),
(175990, '2.60.120.380-FF-000063', NULL, 'Uncharacterized protein', 144, NULL, NULL, 175990),
(175991, '2.60.40.10-FF-000442', NULL, 'Immunoglobulin lambda variable 2-8', 111, NULL, NULL, 175991),
(175992, '2.60.40.10-FF-003876', NULL, NULL, 128, NULL, NULL, 175992),
(175993, '3.40.50.10090-FF-000056', NULL, 'Predicted protein', 96, NULL, NULL, 175993),
(175994, '1.25.40.10-FF-003538', NULL, 'Putative TPR repeat family protein', 114, NULL, NULL, 175994),
(175995, '3.40.50.2300-FF-001098', NULL, NULL, 66, NULL, NULL, 175995),
(175996, '3.40.50.10140-FF-000094', NULL, 'Uncharacterized protein', 63, NULL, NULL, 175996),
(175997, '1.10.540.10-FF-000160', NULL, 'Uncharacterized protein', 19, NULL, NULL, 175997),
(175998, '3.40.50.10190-FF-000316', NULL, 'BRCA1-associated RING domain protein 1', 93, NULL, NULL, 175998),
(175999, '1.10.287.90-FF-000021', NULL, 'Ubiquinol oxidase subunit 2', 85, NULL, NULL, 175999),
(176000, '1.25.40.10-FF-005337', NULL, 'Pentatricopeptide repeat-containing protein At1g12300, mitochondrial', 71, NULL, NULL, 176000),
(176001, '3.20.20.70-FF-000374', NULL, 'Pyridoxal 5''-phosphate synthase subunit PdxS', 295, NULL, NULL, 176001),
(176002, '3.80.10.10-FF-000735', NULL, 'Erbb2 interacting protein', 229, NULL, NULL, 176002),
(176003, '2.30.180.10-FF-000090', NULL, 'Fasciclin-1 fasciclin i fas i fcn', 135, NULL, NULL, 176003),
(176004, '3.60.21.10-FF-000025', NULL, 'Protein UshA', 337, NULL, NULL, 176004),
(176005, '1.25.10.10-FF-002064', NULL, 'Uncharacterized protein', 194, NULL, NULL, 176005),
(176006, '3.30.420.10-FF-000274', NULL, '3''-5'' exoribonuclease parn-1', 163, NULL, NULL, 176006),
(176007, '3.30.160.60-FF-004146', NULL, NULL, 34, NULL, NULL, 176007),
(176008, '3.40.50.300-FF-004309', NULL, 'Small GTP-binding protein, putative', 180, NULL, NULL, 176008),
(176009, '3.30.70.330-FF-001582', NULL, 'U1 small nuclear ribonucleoprotein 70 kDa homolog', 120, NULL, NULL, 176009),
(176010, '4.10.240.10-FF-000171', NULL, 'Uncharacterized protein', 61, NULL, NULL, 176010),
(176011, '3.30.70.330-FF-002200', NULL, NULL, 110, NULL, NULL, 176011),
(176012, '1.10.287.110-FF-000342', NULL, 'Uncharacterized protein', 142, NULL, NULL, 176012),
(176013, '2.60.40.2300-FF-000015', NULL, 'Uncharacterized protein', 45, NULL, NULL, 176013),
(176014, '1.20.58.1120-FF-000064', NULL, NULL, 92, NULL, NULL, 176014),
(176015, '3.30.160.60-FF-000217', NULL, 'Combgap, isoform F', 29, NULL, NULL, 176015),
(176016, '2.30.29.30-FF-001300', NULL, 'Uncharacterized protein', 81, NULL, NULL, 176016);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(176017, '3.80.10.10-FF-001336', NULL, 'Tyrosine-sulfated glycopeptide receptor 1', 109, NULL, NULL, 176017),
(176018, '3.40.1080.10-FF-000002', NULL, 'Succinyl-CoA:3-ketoacid-coenzyme A transferase, mitochondrial', 235, NULL, NULL, 176018),
(176019, '3.10.20.90-FF-000341', NULL, 'Ubiquitin-like superfamily protein', 72, NULL, NULL, 176019),
(176020, '3.30.40.10-FF-001256', NULL, 'Dynein light chain, putative', 71, NULL, NULL, 176020),
(176021, '1.20.58.60-FF-000788', NULL, 'Uncharacterized protein', 215, NULL, NULL, 176021),
(176022, '3.30.1600.10-FF-000034', NULL, 'Histone deacetylase HDAC silent information regulator protein 2 Sir2 sirtuin', 120, NULL, NULL, 176022),
(176023, '1.20.1280.50-FF-000086', NULL, 'Expressed protein', 39, NULL, NULL, 176023),
(176024, '3.90.1750.10-FF-000115', NULL, 'Uncharacterized protein', 207, NULL, NULL, 176024),
(176025, '3.40.630.30-FF-000372', NULL, 'Acyl-homoserine-lactone synthase', 182, NULL, NULL, 176025),
(176026, '2.30.30.170-FF-000001', NULL, 'Internalin B', 83, NULL, NULL, 176026),
(176027, '3.90.640.10-FF-000193', NULL, 'YALI0B10538p', 48, NULL, NULL, 176027),
(176028, '3.30.160.60-FF-006400', NULL, NULL, 24, NULL, NULL, 176028),
(176029, '3.30.450.40-FF-000312', NULL, 'Phosphodiesterase 11a,-like', 39, NULL, NULL, 176029),
(176030, '3.40.1810.10-FF-000019', NULL, 'Agamous-like MADS-box protein AGL8', 67, NULL, NULL, 176030),
(176031, '3.40.50.11340-FF-000021', NULL, 'Probable fucosyltransferase 9', 120, NULL, NULL, 176031),
(176032, '3.40.605.10-FF-000072', NULL, 'Uncharacterized protein', 45, NULL, NULL, 176032),
(176033, '1.10.20.10-FF-000142', NULL, 'DNA polymerase epsilon subunit D', 175, NULL, NULL, 176033),
(176034, '1.25.40.10-FF-003196', NULL, 'Os05g0534900 protein', 93, NULL, NULL, 176034),
(176035, '3.10.20.70-FF-000003', NULL, 'Glutamine synthetase, chloroplastic', 103, NULL, NULL, 176035),
(176036, '2.60.120.970-FF-000032', NULL, 'Growth differentiation factor 7', 163, NULL, NULL, 176036),
(176037, '3.10.20.80-FF-000006', NULL, 'Translation initiation factor IF-3', 73, NULL, NULL, 176037),
(176038, '1.20.120.350-FF-000075', NULL, 'Sodium channel protein', 113, NULL, NULL, 176038),
(176039, '1.25.10.10-FF-001912', NULL, 'E3 ubiquitin-protein ligase listerin', 245, NULL, NULL, 176039),
(176040, '3.40.50.300-FF-000038', NULL, 'Dynein heavy chain 5, axonemal', 331, NULL, NULL, 176040),
(176041, '3.30.70.330-FF-001924', NULL, NULL, 148, NULL, NULL, 176041),
(176042, '3.30.420.110-FF-000005', NULL, 'DNA mismatch repair protein', 175, NULL, NULL, 176042),
(176043, '1.10.510.10-FF-000113', NULL, 'Tyrosine-protein kinase receptor', 190, NULL, NULL, 176043),
(176044, '3.40.630.10-FF-000034', NULL, 'Succinyl-diaminopimelate desuccinylase', 217, NULL, NULL, 176044),
(176045, '2.60.40.10-FF-005568', NULL, NULL, 83, NULL, NULL, 176045),
(176046, '3.40.50.2300-FF-001441', NULL, NULL, 75, NULL, NULL, 176046),
(176047, '2.30.30.140-FF-000127', NULL, 'YLR455W-like protein', 101, NULL, NULL, 176047),
(176048, '3.10.20.90-FF-000009', NULL, 'Ubiquitin-60S ribosomal protein', 77, NULL, NULL, 176048),
(176049, '3.10.50.40-FF-000070', NULL, 'Peptidylprolyl isomerase', 117, NULL, NULL, 176049),
(176050, '1.10.10.790-FF-000051', NULL, NULL, 40, NULL, NULL, 176050),
(176051, '3.30.70.940-FF-000034', NULL, 'Predicted protein', 45, NULL, NULL, 176051),
(176052, '3.40.50.300-FF-004080', NULL, 'GM17107', 117, NULL, NULL, 176052),
(176053, '1.10.510.10-FF-001636', NULL, 'Protein kinase, putative', 301, NULL, NULL, 176053),
(176054, '1.25.40.10-FF-001740', NULL, 'Clustered mitochondria protein homolog', 103, NULL, NULL, 176054),
(176055, '2.30.110.10-FF-000046', NULL, 'Transcriptional repressor of sporulation and protease synthase', 199, NULL, NULL, 176055),
(176056, '3.40.50.300-FF-003708', NULL, 'Suppressor of ascus dominance 3', 209, NULL, NULL, 176056),
(176057, '1.10.510.10-FF-004042', NULL, NULL, 80, NULL, NULL, 176057),
(176058, '1.20.1250.20-FF-000497', NULL, 'Putative MFS sugar transporter', 461, NULL, NULL, 176058),
(176059, '3.40.50.2020-FF-000154', NULL, 'Hypoxanthine phosphoribosyltransferase', 133, NULL, NULL, 176059);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(176060, '1.10.510.10-FF-003766', NULL, NULL, 139, NULL, NULL, 176060),
(176061, '3.20.20.60-FF-000039', NULL, '2,4-dihydroxyhept-2-ene-1,7-dioic acid aldolase', 265, NULL, NULL, 176061),
(176062, '3.40.50.1820-FF-000892', NULL, 'Carboxylic ester hydrolase', 343, NULL, NULL, 176062),
(176063, '2.10.50.10-FF-000035', NULL, 'Tumor necrosis factor receptor superfamily member 3', 79, NULL, NULL, 176063),
(176064, '3.40.50.1820-FF-001510', NULL, 'Uncharacterized protein', 152, NULL, NULL, 176064),
(176065, '3.40.50.150-FF-000521', NULL, 'Ribosomal RNA-processing protein 8', 190, NULL, NULL, 176065),
(176066, '1.10.1370.30-FF-000033', NULL, 'Angiotensin-converting enzyme', 216, NULL, NULL, 176066),
(176067, '3.30.160.60-FF-001853', NULL, 'Zinc finger protein 84', 53, NULL, NULL, 176067),
(176068, '3.90.70.10-FF-000070', NULL, 'Ubiquitin carboxyl-terminal hydrolase 17-like protein 17', 301, NULL, NULL, 176068),
(176069, '3.40.190.10-FF-000005', NULL, 'Porphobilinogen deaminase', 101, NULL, NULL, 176069),
(176070, '2.40.290.10-FF-000045', NULL, 'ATP-dependent DNA helicase II subunit 2', 60, NULL, NULL, 176070),
(176071, '2.40.10.10-FF-000003', NULL, 'Transmembrane serine protease 3', 241, NULL, NULL, 176071),
(176072, '3.40.50.300-FF-007637', NULL, 'Predicted protein', 141, NULL, NULL, 176072),
(176073, '1.20.1270.60-FF-000263', NULL, 'Rho GTPase-activating protein 26-like Protein', 171, NULL, NULL, 176073),
(176074, '3.30.40.10-FF-001711', NULL, 'Non-structural maintenance of chromosomes element 1 homolog', 60, NULL, NULL, 176074),
(176075, '2.60.40.10-FF-001858', NULL, 'Hemicentin 2', 93, NULL, NULL, 176075),
(176076, '3.90.70.10-FF-000412', NULL, 'Predicted protein', 204, NULL, NULL, 176076),
(176077, '3.40.50.740-FF-000041', NULL, 'Putative oxidoreductase', 173, NULL, NULL, 176077),
(176078, '3.40.50.300-FF-000370', NULL, 'Structural maintenance of chromosomes 3', 211, NULL, NULL, 176078),
(176079, '3.40.50.300-FF-008351', NULL, 'ABC transporter ATP-binding protein RamB', 241, NULL, NULL, 176079),
(176080, '3.30.1490.20-FF-000095', NULL, 'Uncharacterized protein', 41, NULL, NULL, 176080),
(176081, '2.180.10.10-FF-000002', NULL, 'Teneurin transmembrane protein 2', 575, NULL, NULL, 176081),
(176082, '3.50.50.60-FF-000973', NULL, 'Flavin-containing monooxygenase', 49, NULL, NULL, 176082),
(176083, '4.10.410.10-FF-000094', NULL, 'Seminal fluid protein 24C1', 58, NULL, NULL, 176083),
(176084, '3.40.50.450-FF-000055', NULL, 'ATP-dependent 6-phosphofructokinase', 75, NULL, NULL, 176084),
(176085, '2.60.40.60-FF-000209', NULL, 'neural-cadherin isoform X1', 120, NULL, NULL, 176085),
(176086, '2.160.20.20-FF-000001', NULL, 'Possible enzyme', 154, NULL, NULL, 176086),
(176087, '1.20.1280.50-FF-000210', NULL, 'Uncharacterized protein', 43, NULL, NULL, 176087),
(176088, '1.20.1070.10-FF-000289', NULL, 'G protein-coupled receptor 78', 323, NULL, NULL, 176088),
(176089, '3.30.420.270-FF-000025', NULL, 'Biopolymer transporter ExbD', 72, NULL, NULL, 176089),
(176090, '2.60.120.10-FF-000287', NULL, 'Mannose-6-phosphate isomerase, putative', 73, NULL, NULL, 176090),
(176091, '3.90.76.10-FF-000021', NULL, 'Putative ABC transporter substrate-binding protein', 150, NULL, NULL, 176091),
(176092, '2.60.40.1230-FF-000003', NULL, 'AP-2 complex subunit alpha', 129, NULL, NULL, 176092),
(176093, '3.30.160.60-FF-004601', NULL, NULL, 58, NULL, NULL, 176093),
(176094, '3.40.30.10-FF-000384', NULL, 'Glutaredoxin, putative', 96, NULL, NULL, 176094),
(176095, '2.60.40.10-FF-005787', NULL, NULL, 88, NULL, NULL, 176095),
(176096, '3.90.105.20-FF-000019', NULL, 'Ribosome assembly factor mrt4', 34, NULL, NULL, 176096),
(176097, '3.20.20.220-FF-000052', NULL, 'Proline dehydrogenase', 107, NULL, NULL, 176097),
(176098, '1.20.58.390-FF-000306', NULL, 'Uncharacterized protein', 60, NULL, NULL, 176098),
(176099, '3.30.300.150-FF-000002', NULL, 'DNA polymerase III subunit gamma/tau', 123, NULL, NULL, 176099),
(176100, '3.10.20.90-FF-000228', NULL, 'Uncharacterized protein, isoform B', 105, NULL, NULL, 176100),
(176101, '2.60.40.10-FF-000004', NULL, 'DCC isoform 1', 92, NULL, NULL, 176101);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(176102, '2.60.120.330-FF-000183', NULL, 'Uncharacterized protein', 193, NULL, NULL, 176102),
(176103, '3.30.1330.30-FF-000047', NULL, '40S ribosomal protein S12', 114, NULL, NULL, 176103),
(176104, '3.30.1640.10-FF-000031', NULL, 'DNA helicase', 95, NULL, NULL, 176104),
(176105, '1.20.1070.10-FF-001126', NULL, 'Uncharacterized protein', 303, NULL, NULL, 176105),
(176106, '1.25.40.10-FF-001627', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 166, NULL, NULL, 176106),
(176107, '1.10.287.4290-FF-000001', NULL, 'Peroxisomal multifunctional enzyme type 2', 70, NULL, NULL, 176107),
(176108, '1.25.10.10-FF-003368', NULL, 'Uncharacterized protein', 165, NULL, NULL, 176108),
(176109, '2.60.40.10-FF-006063', NULL, NULL, 99, NULL, NULL, 176109),
(176110, '4.10.240.10-FF-000058', NULL, 'Unplaced genomic scaffold supercont1.35, whole genome shotgun sequence', 86, NULL, NULL, 176110),
(176111, '3.40.50.1820-FF-000779', NULL, 'Serine hydrolase, putative', 256, NULL, NULL, 176111),
(176112, '1.10.10.10-FF-001838', NULL, 'Predicted protein', 88, NULL, NULL, 176112),
(176113, '3.10.250.10-FF-000091', NULL, NULL, 120, NULL, NULL, 176113),
(176114, '1.10.238.10-FF-000631', NULL, 'Uncharacterized protein', 80, NULL, NULL, 176114),
(176115, '1.10.510.10-FF-000551', NULL, 'Non-specific serine/threonine protein kinase', 86, NULL, NULL, 176115),
(176116, '3.30.70.980-FF-000017', NULL, 'Probable transcriptional regulatory protein HP_0162', 84, NULL, NULL, 176116),
(176117, '2.10.90.10-FF-000032', NULL, 'Artemin', 99, NULL, NULL, 176117),
(176118, '3.30.750.44-FF-000008', NULL, 'retinol-binding protein 3', 79, NULL, NULL, 176118),
(176119, '1.10.10.10-FF-002114', NULL, 'Two-component response regulator', 96, NULL, NULL, 176119),
(176120, '3.40.50.1820-FF-001055', NULL, 'Neuroligin 1', 564, NULL, NULL, 176120),
(176121, '1.10.150.850-FF-000008', NULL, 'Putative transcription elongation factor spt6', 71, NULL, NULL, 176121),
(176122, '1.10.287.950-FF-000026', NULL, 'Methyl-accepting chemotaxis protein', 330, NULL, NULL, 176122),
(176123, '2.20.25.630-FF-000002', NULL, 'Poly [ADP-ribose] polymerase', 61, NULL, NULL, 176123),
(176124, '1.10.10.980-FF-000006', NULL, 'CST complex subunit STN1', 104, NULL, NULL, 176124),
(176125, '2.10.70.10-FF-000143', NULL, 'CUB and sushi domain-containing protein 3 isoform X1', 56, NULL, NULL, 176125),
(176126, '2.10.25.10-FF-000634', NULL, 'Starry night, isoform G', 36, NULL, NULL, 176126),
(176127, '3.40.50.300-FF-007295', NULL, 'Si:dkey-79f11.7', 151, NULL, NULL, 176127),
(176128, '1.20.58.60-FF-000569', NULL, 'Spectrin, beta, non-erythrocytic 5', 106, NULL, NULL, 176128),
(176129, '2.60.40.1090-FF-000034', NULL, 'Fimbrial family protein', 128, NULL, NULL, 176129),
(176130, '3.30.200.20-FF-001912', NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 156', 63, NULL, NULL, 176130),
(176131, '1.10.10.60-FF-000302', NULL, 'Transcription factor TT2', 71, NULL, NULL, 176131),
(176132, '1.10.468.10-FF-000002', NULL, 'Photosynthetic reaction center cytochrome c subunit', 156, NULL, NULL, 176132),
(176133, '1.20.5.2440-FF-000015', NULL, 'Uncharacterized protein', 38, NULL, NULL, 176133),
(176134, '3.40.50.300-FF-000712', NULL, 'Midasin', 173, NULL, NULL, 176134),
(176135, '1.20.5.5200-FF-000001', NULL, 'Stimulator of interferon genes protein', 55, NULL, NULL, 176135),
(176136, '1.20.5.170-FF-000258', NULL, 'Uncharacterized protein', 40, NULL, NULL, 176136),
(176137, '1.20.58.480-FF-000002', NULL, 'Tryptophan 2,3-dioxygenase', 288, NULL, NULL, 176137),
(176138, '2.10.25.10-FF-000853', NULL, 'Integrin beta', 46, NULL, NULL, 176138),
(176139, '2.30.39.10-FF-000064', NULL, 'GM19657', 122, NULL, NULL, 176139),
(176140, '2.60.40.60-FF-000322', NULL, 'Protocadherin Fat', 101, NULL, NULL, 176140),
(176141, '3.30.1330.20-FF-000044', NULL, 'Tubulin-like protein CetZ', 134, NULL, NULL, 176141),
(176142, '3.30.160.60-FF-003983', NULL, NULL, 28, NULL, NULL, 176142),
(176143, '1.20.1250.20-FF-000839', NULL, 'Solute carrier organic anion transporter family member', 274, NULL, NULL, 176143);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(176144, '3.30.70.330-FF-002886', NULL, NULL, 60, NULL, NULL, 176144),
(176145, '2.130.10.10-FF-000313', NULL, 'Chromatin assembly factor 1 subunit C', 430, NULL, NULL, 176145),
(176146, '1.10.540.10-FF-000047', NULL, 'Putative acyl-CoA dehydrogenase', 119, NULL, NULL, 176146),
(176147, '3.40.50.11380-FF-000004', NULL, 'UDP-N-acetylglucosaminyltransferase (AFU_orthologue AFUA_1G03380)', 210, NULL, NULL, 176147),
(176148, '1.20.1070.10-FF-001345', NULL, 'Uncharacterized protein', 271, NULL, NULL, 176148),
(176149, '2.40.50.140-FF-000859', NULL, NULL, 142, NULL, NULL, 176149),
(176150, '3.90.1290.10-FF-000074', NULL, 'Short stop, isoform H', 124, NULL, NULL, 176150),
(176151, '1.10.287.70-FF-000482', NULL, 'TWiK family of potassium channels', 287, NULL, NULL, 176151),
(176152, '3.40.710.10-FF-000092', NULL, 'Cell division protein FtsI (Penicillin-binding protein 3)', 183, NULL, NULL, 176152),
(176153, '3.40.50.300-FF-004422', NULL, 'Aerobic cobaltochelatase subunit CobS', 177, NULL, NULL, 176153),
(176154, '2.130.10.10-FF-003747', NULL, 'Protein FAM234A isoform X1', 330, NULL, NULL, 176154),
(176155, '1.25.40.10-FF-005118', NULL, 'Uncharacterized protein', 113, NULL, NULL, 176155),
(176156, '3.30.30.30-FF-000019', NULL, 'Heat shock 70 kDa protein', 56, NULL, NULL, 176156),
(176157, '1.20.1250.20-FF-001115', NULL, 'AGAP006349-PA', 350, NULL, NULL, 176157),
(176158, '2.60.40.10-FF-003770', NULL, NULL, 95, NULL, NULL, 176158),
(176159, '1.10.720.30-FF-000039', NULL, 'Uncharacterized protein', 57, NULL, NULL, 176159),
(176160, '3.10.20.30-FF-000020', NULL, 'Xanthine dehydrogenase iron-sulfur subunit', 82, NULL, NULL, 176160),
(176161, '2.60.40.60-FF-000541', NULL, 'protocadherin-11 X-linked', 108, NULL, NULL, 176161),
(176162, '1.20.58.1360-FF-000006', NULL, 'Lysine (K)-specific demethylase 2Aa', 134, NULL, NULL, 176162),
(176163, '1.10.150.50-FF-000125', NULL, 'Protein CBG01454', 63, NULL, NULL, 176163),
(176164, '1.25.40.10-FF-001408', NULL, 'NASP-like protein sim3', 242, NULL, NULL, 176164),
(176165, '3.40.50.10190-FF-000193', NULL, 'DNA-directed DNA/RNA polymerase mu', 30, NULL, NULL, 176165),
(176166, '1.10.240.10-FF-000007', NULL, 'Tryptophan--tRNA ligase', 120, NULL, NULL, 176166),
(176167, '2.20.28.10-FF-000011', NULL, 'DNA replication licensing factor MCM5, putative', 72, NULL, NULL, 176167),
(176168, '2.60.120.620-FF-000056', NULL, 'GD12338', 170, NULL, NULL, 176168),
(176169, '3.30.70.240-FF-000032', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 89, NULL, NULL, 176169),
(176170, '2.130.10.10-FF-004023', NULL, 'Uncharacterized protein', 222, NULL, NULL, 176170),
(176171, '2.60.40.10-FF-003438', NULL, NULL, 104, NULL, NULL, 176171),
(176172, '1.10.555.10-FF-000205', NULL, NULL, 94, NULL, NULL, 176172),
(176173, '3.70.10.10-FF-000022', NULL, 'Checkpoint protein MEC3', 325, NULL, NULL, 176173),
(176174, '3.30.40.10-FF-001037', NULL, 'Uncharacterized protein, isoform A', 65, NULL, NULL, 176174),
(176175, '3.40.50.300-FF-000151', NULL, 'Lipopolysaccharide ABC transporter ATP-binding protein', 241, NULL, NULL, 176175),
(176176, '1.10.10.10-FF-001496', NULL, 'P protein', 76, NULL, NULL, 176176),
(176177, '3.30.310.10-FF-000046', NULL, 'TATA-box binding protein like 2', 56, NULL, NULL, 176177),
(176178, '3.40.50.300-FF-008132', NULL, 'Kl-2 protein', 104, NULL, NULL, 176178),
(176179, '3.40.50.1240-FF-000015', NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', 431, NULL, NULL, 176179),
(176180, '1.10.510.10-FF-003985', NULL, NULL, 114, NULL, NULL, 176180),
(176181, '1.10.3500.10-FF-000005', NULL, 'Transcription elongation factor Spt6', 288, NULL, NULL, 176181),
(176182, '2.170.16.10-FF-000038', NULL, 'Vitamin B12-dependent ribonucleotide reductase', 154, NULL, NULL, 176182),
(176183, '3.40.630.30-FF-000259', NULL, 'Protein CBG07665', 121, NULL, NULL, 176183),
(176184, '2.40.40.20-FF-000053', NULL, 'Formate dehydrogenase, alpha subunit, selenocysteine-containing', 177, NULL, NULL, 176184),
(176185, '3.40.50.300-FF-007856', NULL, 'Putative ABC transporter ATP-binding MG390', 215, NULL, NULL, 176185); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(176186, '3.30.60.30-FF-000066', NULL, 'Blast:Agrin', 52, NULL, NULL, 176186),
(176187, '2.130.10.10-FF-003186', NULL, 'Transducin/WD-40 repeat protein family', 135, NULL, NULL, 176187),
(176188, '1.20.144.10-FF-000130', NULL, 'PAP2 superfamily protein', 132, NULL, NULL, 176188),
(176189, '3.40.50.10470-FF-000063', NULL, 'Uncharacterized protein', 148, NULL, NULL, 176189),
(176190, '1.10.3210.10-FF-000123', NULL, 'Uncharacterized protein MG461', 325, NULL, NULL, 176190),
(176191, '3.30.70.100-FF-000018', NULL, 'MscS mechanosensitive ion channel', 90, NULL, NULL, 176191),
(176192, '1.10.510.10-FF-004261', NULL, NULL, 188, NULL, NULL, 176192),
(176193, '3.30.160.60-FF-002152', NULL, 'zinc finger protein ZFP69 isoform X2', 27, NULL, NULL, 176193),
(176194, '3.40.50.2000-FF-000441', NULL, 'Trehalose 6-phosphate synthase', 240, NULL, NULL, 176194),
(176195, '1.10.167.10-FF-000074', NULL, 'RGS domain-containing serine/threonine-protein kinase A', 141, NULL, NULL, 176195),
(176196, '1.25.40.10-FF-001959', NULL, 'Tetratricopeptide repeat domain 21B', 261, NULL, NULL, 176196),
(176197, '3.40.50.300-FF-004159', NULL, 'ABC transporter, putative', 125, NULL, NULL, 176197),
(176198, '2.60.40.2220-FF-000003', NULL, 'Alpha-mannosidase', 77, NULL, NULL, 176198),
(176199, '3.40.50.410-FF-000038', NULL, 'integrator complex subunit 14 isoform X1', 136, NULL, NULL, 176199),
(176200, '2.130.10.10-FF-002208', NULL, 'Lethal giant larvae', 147, NULL, NULL, 176200),
(176201, '3.30.40.10-FF-001392', NULL, 'SNF2 family N-terminal domain-domain-containing protein', 56, NULL, NULL, 176201),
(176202, '3.60.15.10-FF-000028', NULL, 'Integrator complex subunit 11 isoform X3', 238, NULL, NULL, 176202),
(176203, '3.30.200.20-FF-002335', NULL, 'Uncharacterized protein', 70, NULL, NULL, 176203),
(176204, '2.120.10.30-FF-000270', NULL, 'Putative low-density lipoprotein receptor', 301, NULL, NULL, 176204),
(176205, '3.80.10.10-FF-002759', NULL, 'Uncharacterized protein', 117, NULL, NULL, 176205),
(176206, '3.40.50.1010-FF-000127', NULL, 'Putative endonuclease or glycosyl hydrolase', 156, NULL, NULL, 176206),
(176207, '2.40.70.10-FF-000569', NULL, NULL, 54, NULL, NULL, 176207),
(176208, '1.10.150.80-FF-000039', NULL, 'ATP-dependent DNA helicase RecQ family protein', 87, NULL, NULL, 176208),
(176209, '3.40.50.10470-FF-000075', NULL, 'Uncharacterized protein', 195, NULL, NULL, 176209),
(176210, '3.40.50.300-FF-007918', NULL, 'Uncharacterized protein', 178, NULL, NULL, 176210),
(176211, '1.10.630.10-FF-000061', NULL, 'Cytochrome P450 90B1', 458, NULL, NULL, 176211),
(176212, '4.10.400.10-FF-000313', NULL, 'Uncharacterized protein', 31, NULL, NULL, 176212),
(176213, '1.25.40.1030-FF-000055', NULL, 'Uncharacterized protein', 355, NULL, NULL, 176213),
(176214, '3.40.367.20-FF-000004', NULL, 'Phosphotransferase', 271, NULL, NULL, 176214),
(176215, '1.10.10.580-FF-000022', NULL, 'Uncharacterized protein', 68, NULL, NULL, 176215),
(176216, '1.20.1270.220-FF-000004', NULL, 'Bdf1p', 72, NULL, NULL, 176216),
(176217, '2.160.20.10-FF-000257', NULL, 'Os04g0553650 protein', 74, NULL, NULL, 176217),
(176218, '3.30.160.60-FF-004922', NULL, NULL, 25, NULL, NULL, 176218),
(176219, '2.60.40.10-FF-001567', NULL, 'PKHD1 like 1', 81, NULL, NULL, 176219),
(176220, '3.40.30.10-FF-000497', NULL, 'Glutathione S-Transferase', 87, NULL, NULL, 176220),
(176221, '1.20.58.760-FF-000014', NULL, 'ATP-dependent zinc metalloprotease FTSH 12, chloroplastic', 216, NULL, NULL, 176221),
(176222, '1.50.40.10-FF-000086', NULL, 'Mitochondrial carrier protein', 110, NULL, NULL, 176222),
(176223, '3.30.1490.120-FF-000010', NULL, 'Uncharacterized protein', 93, NULL, NULL, 176223),
(176224, '2.20.25.10-FF-000044', NULL, 'BRF (Transcription factor) homolog', 43, NULL, NULL, 176224),
(176225, '1.25.40.180-FF-000224', NULL, NULL, 102, NULL, NULL, 176225),
(176226, '3.40.190.10-FF-000809', NULL, 'Uncharacterized protein', 194, NULL, NULL, 176226),
(176227, '3.40.50.300-FF-003703', NULL, 'ABC transporter ATP-binding protein', 227, NULL, NULL, 176227),
(176228, '3.30.1520.10-FF-000118', NULL, 'Sorting nexin', 155, NULL, NULL, 176228);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(176229, '3.40.640.10-FF-000238', NULL, 'Molybdenum cofactor sulfurase', 262, NULL, NULL, 176229),
(176230, '1.20.990.10-FF-000057', NULL, 'Nitric oxide synthase, inducible', 36, NULL, NULL, 176230),
(176231, '2.30.30.40-FF-000340', NULL, 'Cytokinesis protein 3', 66, NULL, NULL, 176231),
(176232, '3.40.50.300-FF-008493', NULL, 'Uncharacterized protein', 101, NULL, NULL, 176232),
(176233, '2.20.100.10-FF-000149', NULL, 'Protein CBR-MADD-4', 63, NULL, NULL, 176233),
(176234, '2.30.33.40-FF-000021', NULL, 'Chaperonin 20', 100, NULL, NULL, 176234),
(176235, '3.40.50.300-FF-005148', NULL, 'Uncharacterized protein', 233, NULL, NULL, 176235),
(176236, '3.40.50.150-FF-000443', NULL, 'Magnesium-protoporphyrin ix methyltransferase', 227, NULL, NULL, 176236),
(176237, '3.40.50.800-FF-000065', NULL, 'Histidine--tRNA ligase protein', 93, NULL, NULL, 176237),
(176238, '1.25.40.10-FF-003084', NULL, 'Putative pentatricopeptide repeat-containing protein', 173, NULL, NULL, 176238),
(176239, '1.10.287.690-FF-000011', NULL, 'DNA polymerase', 58, NULL, NULL, 176239),
(176240, '3.40.50.300-FF-002394', NULL, 'Possible conserved transmembrane protein', 135, NULL, NULL, 176240),
(176241, '3.30.110.30-FF-000009', NULL, 'Proline--tRNA ligase', 72, NULL, NULL, 176241),
(176242, '3.40.50.2020-FF-000008', NULL, 'Orotate phosphoribosyltransferase', 213, NULL, NULL, 176242),
(176243, '3.20.20.140-FF-000259', NULL, 'Amidohydrolase domain protein', 83, NULL, NULL, 176243),
(176244, '1.10.287.110-FF-000326', NULL, 'DnaJ domain protein (AFU_orthologue AFUA_1G03520)', 89, NULL, NULL, 176244),
(176245, '1.25.40.10-FF-004040', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 177, NULL, NULL, 176245),
(176246, '1.20.1250.10-FF-000096', NULL, NULL, 167, NULL, NULL, 176246),
(176247, '3.40.640.10-FF-000390', NULL, 'Uncharacterized protein', 179, NULL, NULL, 176247),
(176248, '3.40.50.720-FF-001648', NULL, 'Epimerase', 304, NULL, NULL, 176248),
(176249, '2.30.30.490-FF-000098', NULL, 'Predicted protein', 216, NULL, NULL, 176249),
(176250, '1.20.58.1250-FF-000007', NULL, 'Tubulin-specific chaperone C', 112, NULL, NULL, 176250),
(176251, '3.40.50.1820-FF-000836', NULL, 'Protein phosphatase methylesterase 1', 164, NULL, NULL, 176251),
(176252, '3.80.10.10-FF-000994', NULL, 'Cytoskeleton associated protein, putative', 352, NULL, NULL, 176252),
(176253, '1.25.10.10-FF-001339', NULL, 'Uncharacterized protein', 394, NULL, NULL, 176253),
(176254, '2.60.40.10-FF-002556', NULL, 'Protein CBG19196', 109, NULL, NULL, 176254),
(176255, '1.10.8.720-FF-000050', NULL, 'Uncharacterized protein', 155, NULL, NULL, 176255),
(176256, '1.20.1070.10-FF-000531', NULL, 'G-protein coupled octopamine receptor, putative', 343, NULL, NULL, 176256),
(176257, '1.10.565.10-FF-000021', NULL, 'Vitamin D3 receptor B', 298, NULL, NULL, 176257),
(176258, '3.90.70.80-FF-000097', NULL, 'Uncharacterized protein', 138, NULL, NULL, 176258),
(176259, '1.10.510.10-FF-003340', NULL, NULL, 42, NULL, NULL, 176259),
(176260, '3.40.50.11030-FF-000018', NULL, NULL, 138, NULL, NULL, 176260),
(176261, '1.20.120.1750-FF-000137', NULL, 'RBR-type E3 ubiquitin transferase', 60, NULL, NULL, 176261),
(176262, '1.20.5.340-FF-000063', NULL, 'Putative unconventional myosin-XVIIIa', 121, NULL, NULL, 176262),
(176263, '3.30.70.580-FF-000016', NULL, 'Pseudouridylate synthase 3', 144, NULL, NULL, 176263),
(176264, '3.40.50.80-FF-000148', NULL, 'Uncharacterized protein', 197, NULL, NULL, 176264),
(176265, '2.60.40.2840-FF-000014', NULL, 'Putative e3 ubiquitin ligase', 108, NULL, NULL, 176265),
(176266, '1.25.40.20-FF-000827', NULL, 'Ankyrin 1', 153, NULL, NULL, 176266),
(176267, '2.120.10.80-FF-000291', NULL, 'TatD related DNase', 222, NULL, NULL, 176267),
(176268, '3.90.1100.10-FF-000005', NULL, 'DNA-directed RNA polymerase subunit beta', 226, NULL, NULL, 176268),
(176269, '1.10.132.70-FF-000022', NULL, 'Telomerase reverse transcriptase', 151, NULL, NULL, 176269),
(176270, '1.10.472.10-FF-000541', NULL, 'Uncharacterized protein', 80, NULL, NULL, 176270),
(176271, '3.20.20.60-FF-000124', NULL, 'Predicted protein', 165, NULL, NULL, 176271);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(176272, '3.80.10.10-FF-003748', NULL, 'AGAP007451-PA', 126, NULL, NULL, 176272),
(176273, '3.30.160.60-FF-005378', NULL, NULL, 50, NULL, NULL, 176273),
(176274, '3.30.160.60-FF-003141', NULL, 'Zinc finger protein 585B-like Protein', 30, NULL, NULL, 176274),
(176275, '1.10.150.60-FF-000033', NULL, 'Uncharacterized protein', 114, NULL, NULL, 176275),
(176276, '3.40.30.10-FF-000025', NULL, 'Glutathione peroxidase', 167, NULL, NULL, 176276),
(176277, '1.10.150.50-FF-000176', NULL, 'Protein tyrosine phosphatase, receptor type, f polypeptide (PTPRF),-interacting protein (liprin), alpha 1', 52, NULL, NULL, 176277),
(176278, '3.10.20.90-FF-000280', NULL, 'Small ubiquitin-related modifier', 93, NULL, NULL, 176278),
(176279, '3.90.420.10-FF-000002', NULL, 'sulfite oxidase, mitochondrial', 249, NULL, NULL, 176279),
(176280, '1.10.230.10-FF-000013', NULL, 'Citrate synthase', 104, NULL, NULL, 176280),
(176281, '1.10.10.1050-FF-000012', NULL, 'DCP2 decapping enzyme homolog (S. cerevisiae)', 71, NULL, NULL, 176281),
(176282, '3.30.60.30-FF-000033', NULL, 'Serine peptidase inhibitor, Kazal type 5', 67, NULL, NULL, 176282),
(176283, '1.10.287.70-FF-000465', NULL, 'Uncharacterized protein', 139, NULL, NULL, 176283),
(176284, '1.10.533.10-FF-000211', NULL, 'Uncharacterized protein', 135, NULL, NULL, 176284),
(176285, '1.20.1110.10-FF-000086', NULL, 'Putative calcium-transporting ATPase', 172, NULL, NULL, 176285),
(176286, '2.60.40.420-FF-000179', NULL, 'Multicopper oxidase, manganese oxidase family', 252, NULL, NULL, 176286),
(176287, '1.10.472.80-FF-000129', NULL, 'TBC domain containing protein', 146, NULL, NULL, 176287),
(176288, '3.40.50.1000-FF-000450', NULL, NULL, 66, NULL, NULL, 176288),
(176289, '3.30.310.10-FF-000070', NULL, 'Uncharacterized protein', 56, NULL, NULL, 176289),
(176290, '3.30.160.60-FF-004130', NULL, NULL, 33, NULL, NULL, 176290),
(176291, '2.60.40.1090-FF-000017', NULL, 'Type 1 fimbrin D-mannose specific adhesin', 120, NULL, NULL, 176291),
(176292, '1.20.1050.130-FF-000001', NULL, 'Putative Elongation factor 1-beta', 70, NULL, NULL, 176292),
(176293, '2.60.40.10-FF-003545', NULL, NULL, 108, NULL, NULL, 176293),
(176294, '2.10.90.10-FF-000111', NULL, 'Platelet-derived growth factor subunit B', 167, NULL, NULL, 176294),
(176295, '2.30.110.10-FF-000069', NULL, 'Pyridoxine/pyridoxamine 5''-phosphate oxidase 2', 196, NULL, NULL, 176295),
(176296, '3.30.460.10-FF-000198', NULL, 'Ribosomal silencing factor RsfS', 97, NULL, NULL, 176296),
(176297, '2.170.270.10-FF-000008', NULL, 'Histone-lysine N-methyltransferase', 244, NULL, NULL, 176297),
(176298, '3.50.50.80-FF-000007', NULL, 'Ubiquitin-activating enzyme E1', 119, NULL, NULL, 176298),
(176299, '1.20.1250.20-FF-000306', NULL, 'MFS multidrug transporter, putative', 212, NULL, NULL, 176299),
(176300, '2.60.120.920-FF-000164', NULL, 'Ash2-like, histone lysine methyltransferase complex subunit', 124, NULL, NULL, 176300),
(176301, '3.20.20.80-FF-000782', NULL, 'Uncharacterized protein', 205, NULL, NULL, 176301),
(176302, '2.130.10.10-FF-005114', NULL, 'Uncharacterized protein', 235, NULL, NULL, 176302),
(176303, '1.10.10.60-FF-000432', NULL, 'SWR1-complex protein 4', 105, NULL, NULL, 176303),
(176304, '3.30.420.10-FF-000252', NULL, 'Ydc2-catalyt-domain-containing protein', 273, NULL, NULL, 176304),
(176305, '2.130.10.10-FF-004625', NULL, 'Uncharacterized protein', 198, NULL, NULL, 176305),
(176306, '2.30.30.620-FF-000007', NULL, 'Predicted protein', 47, NULL, NULL, 176306),
(176307, '2.10.25.10-FF-001141', NULL, 'Uncharacterized protein', 48, NULL, NULL, 176307),
(176308, '3.10.20.90-FF-000128', NULL, 'Plexin C1', 120, NULL, NULL, 176308),
(176309, '3.40.30.10-FF-000817', NULL, 'Glutathione S-transferase', 84, NULL, NULL, 176309),
(176310, '3.40.630.10-FF-000153', NULL, 'Silver, isoform N', 148, NULL, NULL, 176310),
(176311, '3.60.21.10-FF-000121', NULL, 'Probable phosphoesterase', 194, NULL, NULL, 176311),
(176312, '3.50.50.60-FF-000440', NULL, 'Flavin-containing monooxygenase', 79, NULL, NULL, 176312),
(176313, '1.50.40.10-FF-000406', NULL, 'ADP,ATP carrier protein', 227, NULL, NULL, 176313);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(176314, '3.40.1190.20-FF-000014', NULL, 'ADO1p Adenosine kinase', 257, NULL, NULL, 176314),
(176315, '2.10.220.10-FF-000121', NULL, 'Receptor protein-tyrosine kinase', 86, NULL, NULL, 176315),
(176316, '2.60.40.60-FF-000340', NULL, 'Protocadherin Fat 4', 109, NULL, NULL, 176316),
(176317, '3.40.630.30-FF-000159', NULL, 'Histone acetyltransferase', 133, NULL, NULL, 176317),
(176318, '3.30.70.330-FF-000638', NULL, 'Serine/arginine-rich splicing factor 4', 77, NULL, NULL, 176318),
(176319, '1.25.40.10-FF-001167', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 71, NULL, NULL, 176319),
(176320, '2.60.120.650-FF-000240', NULL, 'Uncharacterized protein', 83, NULL, NULL, 176320),
(176321, '2.130.10.10-FF-000443', NULL, 'U4/U6 small nuclear ribonucleoprotein Prp4', 76, NULL, NULL, 176321),
(176322, '1.25.40.10-FF-002095', NULL, 'Pentatricopeptide repeat-containing protein', 108, NULL, NULL, 176322),
(176323, '2.60.120.290-FF-000109', NULL, 'GD15286', 122, NULL, NULL, 176323),
(176324, '3.20.20.190-FF-000021', NULL, 'PI-PLC X domain-containing protein 3', 301, NULL, NULL, 176324),
(176325, '1.10.238.10-FF-000834', NULL, 'GM20995', 82, NULL, NULL, 176325),
(176326, '1.20.1560.10-FF-000759', NULL, 'ABC transporter, putative', 338, NULL, NULL, 176326),
(176327, '1.10.10.10-FF-000350', NULL, 'Selenocysteine-specific translation elongation factor', 60, NULL, NULL, 176327),
(176328, '3.50.50.60-FF-000001', NULL, 'Dihydrolipoyl dehydrogenase, mitochondrial', 209, NULL, NULL, 176328),
(176329, '1.20.950.20-FF-000001', NULL, 'Respiratory nitrate reductase subunit gamma', 215, NULL, NULL, 176329),
(176330, '3.30.40.10-FF-002229', NULL, 'Uncharacterized protein', 65, NULL, NULL, 176330),
(176331, '3.80.10.10-FF-000522', NULL, 'Leucine rich repeat neuronal 2', 144, NULL, NULL, 176331),
(176332, '3.40.50.1460-FF-000065', NULL, 'Uncharacterized protein', 267, NULL, NULL, 176332),
(176333, '1.10.150.240-FF-000113', NULL, 'HAD family hydrolase', 70, NULL, NULL, 176333),
(176334, '2.60.40.10-FF-003484', NULL, 'MIP27932p', 95, NULL, NULL, 176334),
(176335, '3.30.200.20-FF-000418', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', 110, NULL, NULL, 176335),
(176336, '4.10.280.10-FF-000224', NULL, 'Uncharacterized protein', 82, NULL, NULL, 176336),
(176337, '2.60.40.10-FF-000139', NULL, 'Protein kinase AMP-activated non-catalytic subunit beta 1', 94, NULL, NULL, 176337),
(176338, '1.10.238.10-FF-000773', NULL, 'Hypothetical_protein_-_conserved', 92, NULL, NULL, 176338),
(176339, '2.40.128.150-FF-000004', NULL, 'N-acetyltransferase', 96, NULL, NULL, 176339),
(176340, '3.30.160.60-FF-002505', NULL, 'Transcription factor steA', 33, NULL, NULL, 176340),
(176341, '1.25.40.990-FF-000080', NULL, 'Predicted protein', 52, NULL, NULL, 176341),
(176342, '3.40.50.300-FF-006929', NULL, 'Uncharacterized protein', 231, NULL, NULL, 176342),
(176343, '1.20.1110.10-FF-000147', NULL, 'Uncharacterized protein, isoform A', 352, NULL, NULL, 176343),
(176344, '1.10.510.10-FF-002412', NULL, NULL, 202, NULL, NULL, 176344),
(176345, '3.90.640.10-FF-000013', NULL, 'Chaperone protein HscA', 74, NULL, NULL, 176345),
(176346, '1.10.10.60-FF-000371', NULL, 'MYB transcription factor', 72, NULL, NULL, 176346),
(176347, '1.10.150.20-FF-000280', NULL, 'DNA repair protein RAD51 homolog', 81, NULL, NULL, 176347),
(176348, '1.10.560.10-FF-000145', NULL, 'Uncharacterized protein', 28, NULL, NULL, 176348),
(176349, '2.130.10.10-FF-003669', NULL, 'Uncharacterized protein', 207, NULL, NULL, 176349),
(176350, '3.30.200.20-FF-000570', NULL, 'Non-specific serine/threonine protein kinase', 42, NULL, NULL, 176350),
(176351, '3.40.50.300-FF-007565', NULL, 'Regulator of nonsense transcripts 1, putative', 185, NULL, NULL, 176351),
(176352, '1.10.730.10-FF-000006', NULL, 'Arginyl-tRNA synthetase 2, mitochondrial', 125, NULL, NULL, 176352),
(176353, '1.10.3720.10-FF-000067', NULL, 'ABC amino acid transporter, permease component', 227, NULL, NULL, 176353),
(176354, '2.30.30.30-FF-000011', NULL, 'Elongation factor P-like protein', 64, NULL, NULL, 176354);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(176355, '3.30.40.10-FF-001712', NULL, 'Uncharacterized protein', 60, NULL, NULL, 176355),
(176356, '1.10.8.270-FF-000044', NULL, 'TBC Kinase homolog', 100, NULL, NULL, 176356),
(176357, '3.30.160.60-FF-006367', NULL, NULL, 101, NULL, NULL, 176357),
(176358, '3.40.50.300-FF-008054', NULL, 'Caspase recruitment domain family, member 10', 126, NULL, NULL, 176358),
(176359, '3.50.30.30-FF-000042', NULL, 'Tre1p', 180, NULL, NULL, 176359),
(176360, '1.25.40.70-FF-000089', NULL, 'PI3K-CA alpha', 197, NULL, NULL, 176360),
(176361, '1.20.1070.10-FF-001520', NULL, 'Zg05', 191, NULL, NULL, 176361),
(176362, '2.10.25.10-FF-000505', NULL, 'Low-density lipoprotein receptor-related protein 1', 52, NULL, NULL, 176362),
(176363, '1.20.1560.10-FF-000698', NULL, 'Putative ABC transporter ATP-binding protein MG015', 336, NULL, NULL, 176363),
(176364, '1.20.58.390-FF-000206', NULL, 'Uncharacterized protein', 119, NULL, NULL, 176364),
(176365, '3.30.160.60-FF-000235', NULL, 'Zinc finger and BTB domain containing 38', 28, NULL, NULL, 176365),
(176366, '3.30.360.10-FF-000134', NULL, 'Predicted protein', 23, NULL, NULL, 176366),
(176367, '3.30.2460.10-FF-000001', NULL, 'Putative tail fibers protein', 59, NULL, NULL, 176367),
(176368, '2.60.40.1390-FF-000017', NULL, 'Uncharacterized protein', 161, NULL, NULL, 176368),
(176369, '3.40.190.10-FF-000017', NULL, 'Glycine cleavage system transcriptional activator', 99, NULL, NULL, 176369),
(176370, '1.10.3260.10-FF-000048', NULL, 'Predicted protein', 111, NULL, NULL, 176370),
(176371, '3.40.50.620-FF-000455', NULL, 'Glutamine-dependent NAD(+) synthetase', 142, NULL, NULL, 176371),
(176372, '1.25.40.10-FF-003876', NULL, 'Uncharacterized protein', 91, NULL, NULL, 176372),
(176373, '1.10.510.10-FF-002351', NULL, 'CAMK CAMKL CHK1 protein kinase', 246, NULL, NULL, 176373),
(176374, '3.30.70.330-FF-001274', NULL, 'Putative ribonucleo protein', 111, NULL, NULL, 176374),
(176375, '2.60.40.1180-FF-000191', NULL, 'Alpha-galactosidase', 101, NULL, NULL, 176375),
(176376, '3.30.200.20-FF-001407', NULL, 'Predicted protein', 91, NULL, NULL, 176376),
(176377, '3.40.50.150-FF-000382', NULL, 'Protein arginine N-methyltransferase', 210, NULL, NULL, 176377),
(176378, '1.20.1070.10-FF-001048', NULL, 'G-protein coupled receptor, putative', 230, NULL, NULL, 176378),
(176379, '3.30.457.60-FF-000020', NULL, 'Uncharacterized protein', 87, NULL, NULL, 176379),
(176380, '3.30.160.60-FF-001516', NULL, 'Zinc finger protein 142', 60, NULL, NULL, 176380),
(176381, '1.25.40.20-FF-001316', NULL, 'Uncharacterized protein', 140, NULL, NULL, 176381),
(176382, '1.25.40.20-FF-001496', NULL, 'Uncharacterized protein', 69, NULL, NULL, 176382),
(176383, '2.60.40.10-FF-002495', NULL, 'Pre T cell antigen receptor alpha', 75, NULL, NULL, 176383),
(176384, '1.25.50.10-FF-000004', NULL, 'Aminopeptidase N', 326, NULL, NULL, 176384),
(176385, '3.30.160.60-FF-001696', NULL, 'ZFP2 zinc finger protein', 28, NULL, NULL, 176385),
(176386, '3.50.70.10-FF-000010', NULL, 'Uncharacterized protein C18G6.01c', 123, NULL, NULL, 176386),
(176387, '3.50.50.60-FF-001249', NULL, 'Uncharacterized protein', 147, NULL, NULL, 176387),
(176388, '1.25.40.10-FF-002595', NULL, 'Pentatricopeptide repeat-containing protein', 74, NULL, NULL, 176388),
(176389, '1.10.1420.10-FF-000055', NULL, 'DNA mismatch repair protein Msh2, putative', 123, NULL, NULL, 176389),
(176390, '1.10.405.10-FF-000009', NULL, 'Amine oxidase, flavin-containing', 107, NULL, NULL, 176390),
(176391, '2.120.10.80-FF-000352', NULL, 'tRNA wybutosine-synthesizing protein 4', 307, NULL, NULL, 176391),
(176392, '1.20.920.30-FF-000002', NULL, 'Dynein axonemal heavy chain 3', 212, NULL, NULL, 176392),
(176393, '3.40.50.620-FF-000808', NULL, 'Uncharacterized protein', 46, NULL, NULL, 176393),
(176394, '3.40.50.300-FF-008554', NULL, 'Probable atp-dependent DNA helicase Q5', 219, NULL, NULL, 176394),
(176395, '3.40.50.300-FF-000769', NULL, 'Helicase arip4 isoform 2', 22, NULL, NULL, 176395),
(176396, '3.30.200.20-FF-001879', NULL, 'DsRNA activated Z-DNA binding protein kinase', 125, NULL, NULL, 176396);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(176397, '3.20.20.330-FF-000018', NULL, 'Homocysteine S-methyltransferase', 303, NULL, NULL, 176397),
(176398, '1.10.10.10-FF-001598', NULL, 'O-methyltransferase family protein', 109, NULL, NULL, 176398),
(176399, '1.25.10.10-FF-000530', NULL, 'UTP10p Nucleolar protein', 201, NULL, NULL, 176399),
(176400, '2.130.10.10-FF-000382', NULL, 'WD repeat-containing protein 13', 225, NULL, NULL, 176400),
(176401, '1.25.40.20-FF-001788', NULL, 'MIB (MIndBomb) ubiquitin ligase homolog', 176, NULL, NULL, 176401),
(176402, '3.40.605.10-FF-000140', NULL, 'Aldehyde dehydrogenase 4 family member A1', 35, NULL, NULL, 176402),
(176403, '1.10.510.10-FF-003840', NULL, NULL, 107, NULL, NULL, 176403),
(176404, '2.130.10.10-FF-002860', NULL, 'E3 ubiquitin-protein ligase', 264, NULL, NULL, 176404),
(176405, '3.30.40.10-FF-000756', NULL, 'RiNg Finger protein', 77, NULL, NULL, 176405),
(176406, '2.60.120.260-FF-000213', NULL, 'Beta-glucosidase', 177, NULL, NULL, 176406),
(176407, '2.60.40.1180-FF-000039', NULL, 'Alpha-glucosidase YihQ', 49, NULL, NULL, 176407),
(176408, '1.10.287.1490-FF-000055', NULL, 'Centrosomal protein 135kDa, isoform B', 197, NULL, NULL, 176408),
(176409, '2.60.40.10-FF-002056', NULL, 'MHC class I antigen', 92, NULL, NULL, 176409),
(176410, '3.40.50.300-FF-004631', NULL, 'ABC transporter ATP-binding protein', 213, NULL, NULL, 176410),
(176411, '2.60.120.200-FF-000302', NULL, 'Trans-sialidase, putative', 233, NULL, NULL, 176411),
(176412, '3.10.290.10-FF-000088', NULL, 'Putative 40S ribosomal protein S4', 52, NULL, NULL, 176412),
(176413, '1.25.40.10-FF-005349', NULL, 'Pentatricopeptide repeat-containing protein At1g52620', 137, NULL, NULL, 176413),
(176414, '3.40.50.300-FF-000477', NULL, 'UvrABC system protein B', 185, NULL, NULL, 176414),
(176415, '1.20.142.10-FF-000031', NULL, 'Poly [ADP-ribose] polymerase 1', 39, NULL, NULL, 176415),
(176416, '3.60.40.10-FF-000160', NULL, 'Phosphoserine phosphatase RsbX', 199, NULL, NULL, 176416),
(176417, '3.80.10.10-FF-003395', NULL, 'Uncharacterized protein', 98, NULL, NULL, 176417),
(176418, '1.10.472.10-FF-000069', NULL, 'Cyclin-D5-1', 105, NULL, NULL, 176418),
(176419, '1.25.40.20-FF-000035', NULL, 'Palmitoyltransferase', 239, NULL, NULL, 176419),
(176420, '3.40.850.10-FF-000164', NULL, 'Kinesin-like protein', 251, NULL, NULL, 176420),
(176421, '1.10.10.10-FF-001159', NULL, 'Putative ATP-dependent RNA helicase', 89, NULL, NULL, 176421),
(176422, '3.40.50.740-FF-000053', NULL, 'DMSO reductase chain A', 181, NULL, NULL, 176422),
(176423, '1.50.10.20-FF-000087', NULL, 'Terpene cyclase/mutase family member', 104, NULL, NULL, 176423),
(176424, '1.10.472.80-FF-000281', NULL, NULL, 126, NULL, NULL, 176424),
(176425, '1.25.40.10-FF-002415', NULL, 'Uncharacterized protein', 225, NULL, NULL, 176425),
(176426, '1.20.910.10-FF-000018', NULL, 'Phosphomethylpyrimidine kinase, putative', 221, NULL, NULL, 176426),
(176427, '3.80.10.10-FF-004384', NULL, 'NACHT, LRR and PYD domains-containing protein 15', 169, NULL, NULL, 176427),
(176428, '2.60.120.200-FF-000482', NULL, 'Clade XVII lectin receptor kinase', 70, NULL, NULL, 176428),
(176429, '3.10.250.10-FF-000142', NULL, NULL, 110, NULL, NULL, 176429),
(176430, '3.40.47.10-FF-000120', NULL, 'Uncharacterized protein', 99, NULL, NULL, 176430),
(176431, '1.10.8.540-FF-000001', NULL, 'Flagellar biosynthesis protein FlhA', 88, NULL, NULL, 176431),
(176432, '2.130.10.10-FF-001371', NULL, 'Os03g0145600 protein', 133, NULL, NULL, 176432),
(176433, '1.10.418.10-FF-000219', NULL, 'Uncharacterized protein', 130, NULL, NULL, 176433),
(176434, '1.20.81.10-FF-000002', NULL, 'LDL receptor related protein associated protein 1', 105, NULL, NULL, 176434),
(176435, '3.40.50.2300-FF-001189', NULL, NULL, 207, NULL, NULL, 176435),
(176436, '2.130.10.10-FF-004125', NULL, 'Autophagy-related protein 21', 187, NULL, NULL, 176436),
(176437, '1.20.1270.60-FF-000241', NULL, 'Nitric oxide synthase-trafficking', 260, NULL, NULL, 176437),
(176438, '1.10.555.10-FF-000195', NULL, NULL, 167, NULL, NULL, 176438),
(176439, '1.25.40.10-FF-000650', NULL, 'Pre-mRNA-processing factor 6', 202, NULL, NULL, 176439);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(176440, '2.30.30.140-FF-000077', NULL, 'Chromatin modification-related protein eaf3', 84, NULL, NULL, 176440),
(176441, '3.30.160.60-FF-005439', NULL, NULL, 52, NULL, NULL, 176441),
(176442, '2.40.10.10-FF-000301', NULL, NULL, 74, NULL, NULL, 176442),
(176443, '2.30.29.30-FF-001194', NULL, 'Ran-binding protein 1 homolog a', 76, NULL, NULL, 176443),
(176444, '3.40.50.720-FF-002284', NULL, 'Short-chain dehydrogenase/reductase SDR', 219, NULL, NULL, 176444),
(176445, '3.40.710.10-FF-000154', NULL, 'Uncharacterized protein', 168, NULL, NULL, 176445),
(176446, '1.20.900.10-FF-000080', NULL, 'FERM, ARHGEF and pleckstrin domain-containing protein 1', 211, NULL, NULL, 176446),
(176447, '1.10.238.10-FF-000334', NULL, 'N-terminal EF-hand calcium binding protein 2', 85, NULL, NULL, 176447),
(176448, '3.30.160.60-FF-002944', NULL, 'Prophage lambda integrase', 68, NULL, NULL, 176448),
(176449, '1.10.533.10-FF-000150', NULL, 'CASP2 and RIPK1 domain containing adaptor with death domain', 95, NULL, NULL, 176449),
(176450, '2.40.50.100-FF-000016', NULL, 'DNA-directed RNA polymerase subunit beta', 104, NULL, NULL, 176450),
(176451, '2.60.40.10-FF-000639', NULL, 'collagen alpha-1(XII) chain isoform X1', 90, NULL, NULL, 176451),
(176452, '3.50.50.100-FF-000044', NULL, 'Uncharacterized protein', 368, NULL, NULL, 176452),
(176453, '1.10.357.30-FF-000004', NULL, 'Exocyst complex component SEC15', 174, NULL, NULL, 176453),
(176454, '3.40.50.150-FF-001871', NULL, NULL, 188, NULL, NULL, 176454),
(176455, '1.10.486.10-FF-000011', NULL, 'ATP-depentend DNA helicase, putative', 192, NULL, NULL, 176455),
(176456, '3.75.10.10-FF-000012', NULL, 'Agmatine deiminase', 366, NULL, NULL, 176456),
(176457, '1.25.40.10-FF-002887', NULL, 'Uncharacterized protein', 227, NULL, NULL, 176457),
(176458, '1.10.10.60-FF-000724', NULL, 'Homeobox protein vex1', 101, NULL, NULL, 176458),
(176459, '3.30.70.330-FF-002263', NULL, NULL, 116, NULL, NULL, 176459),
(176460, '2.60.40.150-FF-000255', NULL, 'Uncharacterized protein, isoform A', 139, NULL, NULL, 176460),
(176461, '3.60.20.10-FF-000097', NULL, 'Proteasome subunit alpha type', 120, NULL, NULL, 176461),
(176462, '2.30.30.140-FF-000105', NULL, 'R-interacting factor1', 43, NULL, NULL, 176462),
(176463, '2.60.60.20-FF-000059', NULL, NULL, 58, NULL, NULL, 176463),
(176464, '1.25.10.10-FF-001278', NULL, 'RING-type E3 ubiquitin transferase', 204, NULL, NULL, 176464),
(176465, '3.60.21.10-FF-000088', NULL, 'Double-strand break repair protein MRE11', 120, NULL, NULL, 176465),
(176466, '1.10.10.2670-FF-000014', NULL, 'AAL147Cp', 102, NULL, NULL, 176466),
(176467, '1.10.238.10-FF-000042', NULL, 'Calmodulin', 74, NULL, NULL, 176467),
(176468, '1.20.80.10-FF-000011', NULL, 'Tyrosine-protein phosphatase non-receptor type 13', 112, NULL, NULL, 176468),
(176469, '3.40.50.1820-FF-001033', NULL, 'Lipase-like PAD4', 153, NULL, NULL, 176469),
(176470, '2.160.20.80-FF-000025', NULL, NULL, 148, NULL, NULL, 176470),
(176471, '2.60.40.10-FF-000611', NULL, 'Tenascin C', 91, NULL, NULL, 176471),
(176472, '3.30.160.60-FF-001224', NULL, 'zinc finger protein 771-like', 27, NULL, NULL, 176472),
(176473, '2.60.40.1220-FF-000012', NULL, 'Surface layer protein', 97, NULL, NULL, 176473),
(176474, '3.80.10.10-FF-001511', NULL, 'Os11g0197000 protein', 50, NULL, NULL, 176474),
(176475, '1.20.272.10-FF-000035', NULL, 'DNA polymerase III subunit gamma/tau', 103, NULL, NULL, 176475),
(176476, '2.60.40.10-FF-004001', NULL, NULL, 100, NULL, NULL, 176476),
(176477, '2.30.30.710-FF-000001', NULL, 'Genome polyprotein', 30, NULL, NULL, 176477),
(176478, '1.20.1250.20-FF-000486', NULL, 'Solute carrier organic anion transporter family member', 404, NULL, NULL, 176478),
(176479, '2.120.10.30-FF-000118', NULL, 'Blast:Low-density lipoprotein receptor-related protein 4', 307, NULL, NULL, 176479),
(176480, '3.40.50.300-FF-003203', NULL, 'Protein CBG22588', 349, NULL, NULL, 176480),
(176481, '3.40.50.1000-FF-000742', NULL, NULL, 173, NULL, NULL, 176481),
(176482, '3.40.50.2300-FF-001430', NULL, NULL, 130, NULL, NULL, 176482),
(176483, '3.30.70.330-FF-000346', NULL, 'Nucleolar protein 8', 116, NULL, NULL, 176483);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(176484, '2.60.40.640-FF-000014', NULL, 'arrestin domain-containing protein 2 isoform X1', 144, NULL, NULL, 176484),
(176485, '1.10.150.250-FF-000003', NULL, 'Succinate dehydrogenase assembly factor', 99, NULL, NULL, 176485),
(176486, '1.10.287.990-FF-000011', NULL, 'Uncharacterized protein', 55, NULL, NULL, 176486),
(176487, '1.10.287.70-FF-000757', NULL, 'Predicted protein', 55, NULL, NULL, 176487),
(176488, '2.10.25.10-FF-000213', NULL, 'sushi, nidogen and EGF-like domain-containing protein 1', 46, NULL, NULL, 176488),
(176489, '3.40.30.10-FF-001014', NULL, 'Uncharacterized protein', 58, NULL, NULL, 176489),
(176490, '2.60.40.1900-FF-000002', NULL, 'Uncharacterized protein', 88, NULL, NULL, 176490),
(176491, '3.10.100.10-FF-000367', NULL, NULL, 180, NULL, NULL, 176491),
(176492, '1.10.10.940-FF-000001', NULL, 'Pyruvate oxidase', 45, NULL, NULL, 176492),
(176493, '3.30.420.40-FF-000620', NULL, 'Uncharacterized protein', 221, NULL, NULL, 176493),
(176494, '2.130.10.10-FF-002708', NULL, 'Uncharacterized protein', 319, NULL, NULL, 176494),
(176495, '1.20.1250.20-FF-000778', NULL, 'MFS general substrate transporter', 193, NULL, NULL, 176495),
(176496, '3.40.50.1110-FF-000011', NULL, 'Possible lipase/acylhydrolase', 238, NULL, NULL, 176496),
(176497, '2.90.10.10-FF-000007', NULL, 'Serine/threonine-protein kinase', 124, NULL, NULL, 176497),
(176498, '3.40.50.970-FF-000037', NULL, '2-oxoacid:ferredoxin oxidoreductase subunit beta', 144, NULL, NULL, 176498),
(176499, '3.80.10.10-FF-001803', NULL, 'Dynein regulatory complex subunit 5', 98, NULL, NULL, 176499),
(176500, '1.25.10.10-FF-003256', NULL, 'Serine/threonine-protein kinase tor', 218, NULL, NULL, 176500),
(176501, '1.25.40.10-FF-003904', NULL, 'Uncharacterized protein', 65, NULL, NULL, 176501),
(176502, '3.30.1330.30-FF-000121', NULL, 'rRNA methyltransferase 1, mitochondrial', 64, NULL, NULL, 176502),
(176503, '1.20.120.980-FF-000051', NULL, 'Uncharacterized protein', 116, NULL, NULL, 176503),
(176504, '3.30.50.10-FF-000049', NULL, 'bile acid receptor isoform X3', 83, NULL, NULL, 176504),
(176505, '1.25.10.10-FF-002767', NULL, '1700016M24Rik protein', 594, NULL, NULL, 176505),
(176506, '1.10.540.10-FF-000115', NULL, 'AGAP000454-PA', 94, NULL, NULL, 176506),
(176507, '2.30.29.240-FF-000021', NULL, 'Phosphoinositide phospholipase C', 121, NULL, NULL, 176507),
(176508, '1.10.472.10-FF-000480', NULL, 'Uncharacterized protein', 123, NULL, NULL, 176508),
(176509, '2.10.109.10-FF-000014', NULL, 'Inner membrane protease subunit 1', 130, NULL, NULL, 176509),
(176510, '3.40.50.10330-FF-000027', NULL, 'NADH kinase', 128, NULL, NULL, 176510),
(176511, '2.130.10.10-FF-005586', NULL, 'Predicted protein', 202, NULL, NULL, 176511),
(176512, '2.40.30.170-FF-000067', NULL, NULL, 69, NULL, NULL, 176512),
(176513, '1.25.10.10-FF-001839', NULL, 'Anaphase-promoting complex subunit 1', 155, NULL, NULL, 176513),
(176514, '3.20.20.80-FF-000310', NULL, 'Glycosyl hydrolase', 327, NULL, NULL, 176514),
(176515, '3.30.70.330-FF-002555', NULL, NULL, 150, NULL, NULL, 176515),
(176516, '3.30.40.10-FF-001420', NULL, 'RBR-type E3 ubiquitin transferase', 88, NULL, NULL, 176516),
(176517, '3.40.50.300-FF-002714', NULL, 'RecBCD enzyme subunit RecB', 229, NULL, NULL, 176517),
(176518, '1.50.40.10-FF-000114', NULL, 'Solute carrier family 25 member 37', 128, NULL, NULL, 176518),
(176519, '3.40.1690.20-FF-000007', NULL, 'ATP dependent metalloprotease', 96, NULL, NULL, 176519),
(176520, '1.25.40.10-FF-004540', NULL, 'Chromosome 1, whole genome shotgun sequence', 234, NULL, NULL, 176520),
(176521, '3.40.630.10-FF-000445', NULL, 'Putative carboxypeptidase (Putative secreted protein)', 181, NULL, NULL, 176521),
(176522, '3.40.50.1820-FF-001825', NULL, 'Predicted protein', 95, NULL, NULL, 176522),
(176523, '3.30.9.40-FF-000002', NULL, 'Styrene monooxygenase StyA', 61, NULL, NULL, 176523),
(176524, '2.60.120.10-FF-000119', NULL, 'cAMP-dependent protein kinase type II-alpha regulatory subunit isoform X2', 53, NULL, NULL, 176524),
(176525, '1.20.1250.20-FF-001234', NULL, 'Solute carrier family 16 member 3', 142, NULL, NULL, 176525);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(176526, '1.10.510.10-FF-001895', NULL, 'eIF-2 alpha kinase', 287, NULL, NULL, 176526),
(176527, '3.30.70.330-FF-001627', NULL, NULL, 41, NULL, NULL, 176527),
(176528, '3.30.1360.120-FF-000111', NULL, 'Sarcosine dehydrogenase', 27, NULL, NULL, 176528),
(176529, '3.30.565.40-FF-000001', NULL, 'Probable conserved secreted protein TB22.2', 117, NULL, NULL, 176529),
(176530, '3.40.50.620-FF-000163', NULL, 'Predicted phosphoadenosine phosphosulfate reductase', 247, NULL, NULL, 176530),
(176531, '4.10.1240.10-FF-000022', NULL, 'Adenylate cyclase-activating polypeptide 1a (pituitary) receptor type I', 84, NULL, NULL, 176531),
(176532, '2.40.30.130-FF-000050', NULL, 'Alanine--tRNA ligase', 105, NULL, NULL, 176532),
(176533, '3.40.50.10950-FF-000005', NULL, NULL, 157, NULL, NULL, 176533),
(176534, '3.30.390.30-FF-000029', NULL, 'FAD-dependent pyridine nucleotide-disulphide oxidoreductase', 108, NULL, NULL, 176534),
(176535, '1.10.1320.10-FF-000019', NULL, 'DNA-directed RNA polymerase', 126, NULL, NULL, 176535),
(176536, '2.80.10.50-FF-000053', NULL, 'Fibroblast growth factor', 139, NULL, NULL, 176536),
(176537, '1.10.3710.10-FF-000010', NULL, 'ATPase, AAA family', 90, NULL, NULL, 176537),
(176538, '3.40.50.720-FF-000159', NULL, 'dTDP-4-dehydrorhamnose reductase', 203, NULL, NULL, 176538),
(176539, '3.30.1370.100-FF-000017', NULL, 'DNA mismatch repair protein pms2, putative', 101, NULL, NULL, 176539),
(176540, '3.30.420.10-FF-000544', NULL, NULL, 72, NULL, NULL, 176540),
(176541, '1.20.144.10-FF-000013', NULL, 'Phospholipid phosphatase 3', 255, NULL, NULL, 176541),
(176542, '1.20.5.3310-FF-000002', NULL, 'Sec-independent protein translocase protein TatB', 42, NULL, NULL, 176542),
(176543, '2.30.22.10-FF-000009', NULL, 'Unplaced genomic scaffold supercont1.138, whole genome shotgun sequence', 69, NULL, NULL, 176543),
(176544, '2.60.40.10-FF-004973', NULL, NULL, 110, NULL, NULL, 176544),
(176545, '1.20.58.70-FF-000123', NULL, 'Syntaxin 2a', 106, NULL, NULL, 176545),
(176546, '1.20.1510.10-FF-000015', NULL, 'Metal tolerance protein 4', 195, NULL, NULL, 176546),
(176547, '3.40.30.10-FF-000525', NULL, 'Glutaredoxin-related protein', 95, NULL, NULL, 176547),
(176548, '3.80.10.10-FF-001950', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 199, NULL, NULL, 176548),
(176549, '1.50.40.10-FF-000378', NULL, 'Uncharacterized protein', 108, NULL, NULL, 176549),
(176550, '3.40.50.300-FF-006076', NULL, 'V -type Na-ATPase, putative', 79, NULL, NULL, 176550),
(176551, '3.90.226.10-FF-000208', NULL, 'Carboxyl-terminal proteinase', 165, NULL, NULL, 176551),
(176552, '3.30.465.10-FF-000041', NULL, 'Glycolate oxidase, subunit GlcE', 181, NULL, NULL, 176552),
(176553, '1.20.58.1040-FF-000001', NULL, 'Glucan endo-1,3-beta-glucosidase 4', 95, NULL, NULL, 176553),
(176554, '3.40.1380.10-FF-000020', NULL, 'Uncharacterized protein', 212, NULL, NULL, 176554),
(176555, '3.40.50.10190-FF-000261', NULL, 'Chromatin-binding protein', 156, NULL, NULL, 176555),
(176556, '3.90.190.10-FF-000523', NULL, 'Dual-specificity protein phosphatase 3', 112, NULL, NULL, 176556),
(176557, '2.30.230.10-FF-000016', NULL, 'AGAP008369-PA', 260, NULL, NULL, 176557),
(176558, '3.20.20.70-FF-000392', NULL, 'Similar to quinate pathway repressor protein QutR', 242, NULL, NULL, 176558),
(176559, '3.40.50.150-FF-000943', NULL, NULL, 155, NULL, NULL, 176559),
(176560, '1.10.287.370-FF-000033', NULL, 'Prefoldin subunit 3', 147, NULL, NULL, 176560),
(176561, '3.40.50.720-FF-002104', NULL, '2,4-diaminopentanoate dehydrogenase', 124, NULL, NULL, 176561),
(176562, '2.130.10.10-FF-000090', NULL, 'E3 ubiquitin-protein ligase RFWD2 isoform X1', 334, NULL, NULL, 176562),
(176563, '3.80.10.10-FF-000494', NULL, 'F-box/LRR-repeat protein 10 isoform A', 418, NULL, NULL, 176563),
(176564, '3.90.550.10-FF-000186', NULL, 'Translation initiation factor eIF-2B epsilon subunit, putative', 316, NULL, NULL, 176564),
(176565, '3.30.420.40-FF-000087', NULL, 'Glucokinase', 137, NULL, NULL, 176565),
(176566, '1.10.238.10-FF-000481', NULL, 'EF-hand domain pair/EF-hand domain/EF hand', 89, NULL, NULL, 176566);
INSERT INTO "PUBLIC"."MODEL" VALUES
(176567, '3.30.470.30-FF-000002', NULL, 'DNA ligase', 126, NULL, NULL, 176567),
(176568, '3.40.50.1980-FF-000131', NULL, 'Putative histidinol dehydrogenase 2', 147, NULL, NULL, 176568),
(176569, '2.60.120.10-FF-000271', NULL, 'AraC family transcriptional regulator', 94, NULL, NULL, 176569),
(176570, '3.90.190.20-FF-000060', NULL, 'Folylpolyglutamate synthase', 133, NULL, NULL, 176570),
(176571, '3.40.140.10-FF-000245', NULL, 'MPN domain-containing protein, putative', 151, NULL, NULL, 176571),
(176572, '3.10.430.100-FF-000021', NULL, '50S ribosomal protein L9', 84, NULL, NULL, 176572),
(176573, '1.20.1300.10-FF-000010', NULL, 'Succinate dehydrogenase subunit 3-1, mitochondrial', 60, NULL, NULL, 176573),
(176574, '1.10.506.10-FF-000036', NULL, 'PLeXin', 256, NULL, NULL, 176574),
(176575, '1.10.630.10-FF-000353', NULL, 'Predicted protein', 498, NULL, NULL, 176575),
(176576, '1.10.510.10-FF-000434', NULL, 'Serine/threonine protein kinase', 343, NULL, NULL, 176576),
(176577, '3.40.50.300-FF-001697', NULL, 'ComF operon protein 1', 157, NULL, NULL, 176577),
(176578, '3.30.1490.20-FF-000096', NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta, mitochondrial', 20, NULL, NULL, 176578),
(176579, '1.10.150.850-FF-000003', NULL, 'Transcription elongation factor spt6', 38, NULL, NULL, 176579),
(176580, '1.10.8.240-FF-000001', NULL, '2-phospho-L-lactate transferase', 89, NULL, NULL, 176580),
(176581, '3.30.200.20-FF-002043', NULL, 'Protein CBG05605', 118, NULL, NULL, 176581),
(176582, '3.80.10.10-FF-002467', NULL, 'Uncharacterized protein', 133, NULL, NULL, 176582),
(176583, '2.60.40.10-FF-001859', NULL, 'Hemicentin 2', 93, NULL, NULL, 176583),
(176584, '3.40.50.1110-FF-000039', NULL, 'SGNH/GDSL hydrolase family protein', 227, NULL, NULL, 176584),
(176585, '1.25.40.10-FF-001667', NULL, 'Os12g0163600 protein', 171, NULL, NULL, 176585),
(176586, '3.90.190.10-FF-000023', NULL, 'Tyrosine-protein phosphatase non-receptor type', 282, NULL, NULL, 176586),
(176587, '3.90.1410.10-FF-000107', NULL, 'SET domain-containing protein 8', 237, NULL, NULL, 176587),
(176588, '1.10.10.60-FF-000932', NULL, NULL, 72, NULL, NULL, 176588),
(176589, '3.30.40.10-FF-001212', NULL, 'RING/FYVE/PHD-type zinc finger family protein', 91, NULL, NULL, 176589),
(176590, '2.130.10.10-FF-002388', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit TRM82', 254, NULL, NULL, 176590),
(176591, '4.10.410.10-FF-000050', NULL, 'Trypsin protease inhibitor-like 4', 62, NULL, NULL, 176591),
(176592, '3.30.160.60-FF-005086', NULL, NULL, 51, NULL, NULL, 176592),
(176593, '3.30.70.330-FF-002763', NULL, NULL, 79, NULL, NULL, 176593),
(176594, '3.40.50.11660-FF-000033', NULL, NULL, 122, NULL, NULL, 176594),
(176595, '2.20.25.240-FF-000009', NULL, 'Uncharacterized protein, isoform D', 87, NULL, NULL, 176595),
(176596, '1.10.390.10-FF-000053', NULL, 'Membrane alanine aminopeptidase', 211, NULL, NULL, 176596),
(176597, '2.60.120.10-FF-000619', NULL, 'Uncharacterized protein', 134, NULL, NULL, 176597),
(176598, '3.40.50.2020-FF-000155', NULL, 'Putative competence protein F', 119, NULL, NULL, 176598),
(176599, '3.30.1360.120-FF-000083', NULL, 'Aminomethyltransferase', 146, NULL, NULL, 176599),
(176600, '2.40.30.10-FF-000331', NULL, 'Uncharacterized protein', 100, NULL, NULL, 176600),
(176601, '2.40.10.10-FF-000268', NULL, 'Uncharacterized protein', 212, NULL, NULL, 176601),
(176602, '3.50.50.60-FF-000029', NULL, 'Lysine-specific histone demethylase', 129, NULL, NULL, 176602),
(176603, '3.90.190.10-FF-000495', NULL, 'Predicted protein', 153, NULL, NULL, 176603),
(176604, '3.30.360.20-FF-000019', NULL, NULL, 89, NULL, NULL, 176604),
(176605, '3.90.740.10-FF-000077', NULL, 'Predicted protein', 53, NULL, NULL, 176605),
(176606, '3.40.50.720-FF-001356', NULL, 'NADPH-dependent methylglyoxal reductase, putative', 328, NULL, NULL, 176606),
(176607, '1.25.40.10-FF-004332', NULL, 'Uncharacterized protein', 166, NULL, NULL, 176607),
(176608, '3.30.160.60-FF-004630', NULL, NULL, 28, NULL, NULL, 176608),
(176609, '3.30.360.10-FF-000073', NULL, 'Inositol 2-dehydrogenase', 130, NULL, NULL, 176609);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(176610, '3.90.660.10-FF-000076', NULL, NULL, 119, NULL, NULL, 176610),
(176611, '3.40.50.2300-FF-001661', NULL, NULL, 182, NULL, NULL, 176611),
(176612, '1.10.510.10-FF-001923', NULL, 'Cell Division Cycle related', 230, NULL, NULL, 176612),
(176613, '1.20.120.720-FF-000052', NULL, 'Myosin IA heavy chain', 175, NULL, NULL, 176613),
(176614, '1.20.58.60-FF-000025', NULL, 'microtubule-actin cross-linking factor 1', 141, NULL, NULL, 176614),
(176615, '1.10.10.750-FF-000034', NULL, 'Ankyrin repeat-containing protein', 49, NULL, NULL, 176615),
(176616, '3.40.30.10-FF-000789', NULL, 'Glutathione S-transferase', 76, NULL, NULL, 176616),
(176617, '1.10.418.60-FF-000009', NULL, 'Probable kinetochore protein NUF2', 188, NULL, NULL, 176617),
(176618, '3.40.50.300-FF-004400', NULL, 'Uncharacterized protein', 194, NULL, NULL, 176618),
(176619, '3.40.50.2300-FF-000233', NULL, 'Eg435916, gene 1', 293, NULL, NULL, 176619),
(176620, '3.30.1360.10-FF-000055', NULL, 'Uncharacterized protein', 62, NULL, NULL, 176620),
(176621, '3.20.20.70-FF-000745', NULL, NULL, 69, NULL, NULL, 176621),
(176622, '2.30.110.10-FF-000041', NULL, 'PROBABLE OXIDOREDUCTASE', 166, NULL, NULL, 176622),
(176623, '2.10.70.10-FF-000020', NULL, 'fibronectin isoform X1', 40, NULL, NULL, 176623),
(176624, '3.30.420.40-FF-000120', NULL, 'N-acetyl-D-glucosamine kinase isoform X1', 205, NULL, NULL, 176624),
(176625, '1.20.1280.50-FF-000177', NULL, 'Predicted protein', 137, NULL, NULL, 176625),
(176626, '1.10.510.10-FF-002912', NULL, NULL, 154, NULL, NULL, 176626),
(176627, '3.40.109.10-FF-000060', NULL, 'NAD(P)H-flavin oxidoreductase', 200, NULL, NULL, 176627),
(176628, '1.10.287.470-FF-000029', NULL, 'Efflux transporter periplasmic adaptor subunit', 74, NULL, NULL, 176628),
(176629, '1.20.1250.20-FF-001003', NULL, 'Sugar transporter', 480, NULL, NULL, 176629),
(176630, '3.10.110.10-FF-000340', NULL, 'Ubiquitin-conjugating enzyme E2 C-like Protein', 152, NULL, NULL, 176630),
(176631, '3.40.50.200-FF-000065', NULL, 'Furin putative serine protease', 362, NULL, NULL, 176631),
(176632, '3.30.70.330-FF-001127', NULL, 'Heterogeneous nuclear ribonucleoprotein Q', 120, NULL, NULL, 176632),
(176633, '2.60.40.10-FF-002848', NULL, 'O-GlcNAcase NagJ', 83, NULL, NULL, 176633),
(176634, '3.30.780.10-FF-000065', NULL, 'Uncharacterized protein', 79, NULL, NULL, 176634),
(176635, '2.130.10.10-FF-004097', NULL, 'Autophagy-related protein 21', 197, NULL, NULL, 176635),
(176636, '1.20.1560.10-FF-000198', NULL, 'ATP-binding cassette protein subfamily B, member 3, putative', 348, NULL, NULL, 176636),
(176637, '3.40.190.80-FF-000049', NULL, 'Inositol-1-monophosphatase', 120, NULL, NULL, 176637),
(176638, '2.30.42.10-FF-000544', NULL, NULL, 95, NULL, NULL, 176638),
(176639, '1.20.1050.10-FF-000176', NULL, 'Uncharacterized protein', 129, NULL, NULL, 176639),
(176640, '1.10.1540.10-FF-000002', NULL, 'WD repeat and FYVE domain containing 3', 291, NULL, NULL, 176640),
(176641, '3.40.630.30-FF-000659', NULL, 'Uncharacterized N-acetyltransferase C1271.07c', 154, NULL, NULL, 176641),
(176642, '3.60.130.30-FF-000004', NULL, 'Calnexin-independence factor 1', 202, NULL, NULL, 176642),
(176643, '3.80.10.10-FF-004176', NULL, 'Predicted protein', 98, NULL, NULL, 176643),
(176644, '2.30.30.40-FF-000632', NULL, 'Uncharacterized protein', 85, NULL, NULL, 176644),
(176645, '3.40.50.1100-FF-000093', NULL, 'Threonine dehydratase', 192, NULL, NULL, 176645),
(176646, '1.25.40.20-FF-000535', NULL, 'Uncharacterized protein, isoform F', 51, NULL, NULL, 176646),
(176647, '3.10.170.20-FF-000026', NULL, NULL, 139, NULL, NULL, 176647),
(176648, '3.40.50.1820-FF-001264', NULL, 'Uncharacterized protein', 305, NULL, NULL, 176648),
(176649, '3.40.390.10-FF-000145', NULL, 'Peptidase', 175, NULL, NULL, 176649),
(176650, '3.40.50.300-FF-002422', NULL, 'ATP-binding cassette (ABC) transporter, putative Pdr11p', 235, NULL, NULL, 176650),
(176651, '2.10.25.10-FF-001202', NULL, 'Predicted protein', 38, NULL, NULL, 176651),
(176652, '3.40.30.10-FF-000317', NULL, 'Glutaredoxin, putative', 104, NULL, NULL, 176652);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(176653, '3.10.20.90-FF-000628', NULL, 'Ubiquitin carboxyl-terminal hydrolase 24', 85, NULL, NULL, 176653),
(176654, '1.10.510.10-FF-004088', NULL, NULL, 159, NULL, NULL, 176654),
(176655, '3.10.20.90-FF-000572', NULL, 'Putative small ubiquitin-related modifier 6', 92, NULL, NULL, 176655),
(176656, '2.60.40.60-FF-000632', NULL, 'Uncharacterized protein', 90, NULL, NULL, 176656),
(176657, '1.25.40.10-FF-000678', NULL, 'Pentatricopeptide repeat-containing protein MRL1 chloroplastic', 149, NULL, NULL, 176657),
(176658, '1.20.1070.10-FF-001279', NULL, 'Histamine receptor H1', 164, NULL, NULL, 176658),
(176659, '3.30.160.60-FF-002005', NULL, 'Zinc finger protein 200', 32, NULL, NULL, 176659),
(176660, '3.80.10.10-FF-003456', NULL, 'Uncharacterized protein', 240, NULL, NULL, 176660),
(176661, '4.10.900.10-FF-000014', NULL, 'Uncharacterized protein, isoform B', 66, NULL, NULL, 176661),
(176662, '1.10.1520.10-FF-000091', NULL, 'Endoribonuclease dcr-1', 156, NULL, NULL, 176662),
(176663, '2.130.10.10-FF-006042', NULL, 'Uncharacterized protein', 209, NULL, NULL, 176663),
(176664, '3.80.10.10-FF-003720', NULL, 'AGAP007463-PA', 146, NULL, NULL, 176664),
(176665, '2.30.29.30-FF-000766', NULL, 'Bud site selection protein BUD4', 126, NULL, NULL, 176665),
(176666, '3.90.70.10-FF-000149', NULL, 'Type I secretion system permease/ATPase', 121, NULL, NULL, 176666),
(176667, '3.90.228.10-FF-000050', NULL, 'Poly [ADP-ribose] polymerase', 125, NULL, NULL, 176667),
(176668, '1.10.418.40-FF-000003', NULL, 'Beclin-1 protein', 198, NULL, NULL, 176668),
(176669, '3.90.470.10-FF-000005', NULL, '60S ribosomal protein L17', 175, NULL, NULL, 176669),
(176670, '3.90.550.10-FF-000006', NULL, 'Bifunctional protein GlmU', 227, NULL, NULL, 176670),
(176671, '2.20.70.10-FF-000087', NULL, 'PArtner of DroSHa (DRSH-1 interactor)', 65, NULL, NULL, 176671),
(176672, '2.30.30.40-FF-000368', NULL, 'Chemotaxis protein CheW', 59, NULL, NULL, 176672),
(176673, '1.10.510.10-FF-003368', NULL, NULL, 178, NULL, NULL, 176673),
(176674, '2.130.10.10-FF-001932', NULL, 'Yeast SEC homolog', 383, NULL, NULL, 176674),
(176675, '3.30.40.10-FF-000695', NULL, 'Chromatin modification-related protein', 57, NULL, NULL, 176675),
(176676, '3.40.190.290-FF-000088', NULL, 'Transcriptional regulatory protein', 200, NULL, NULL, 176676),
(176677, '3.30.1140.32-FF-000013', NULL, '40S ribosomal protein S3', 147, NULL, NULL, 176677),
(176678, '3.40.1110.10-FF-000326', NULL, NULL, 172, NULL, NULL, 176678),
(176679, '3.30.160.60-FF-000735', NULL, 'Transcription factor Sp7', 25, NULL, NULL, 176679),
(176680, '1.10.533.10-FF-000178', NULL, 'THO complex subunit 1 isoform X1', 80, NULL, NULL, 176680),
(176681, '3.60.21.50-FF-000021', NULL, 'Uncharacterized protein', 268, NULL, NULL, 176681),
(176682, '3.40.950.10-FF-000020', NULL, NULL, 46, NULL, NULL, 176682),
(176683, '1.10.8.720-FF-000078', NULL, 'Uncharacterized protein', 99, NULL, NULL, 176683),
(176684, '3.30.70.1230-FF-000235', NULL, 'Uncharacterized protein', 190, NULL, NULL, 176684),
(176685, '3.10.100.10-FF-000075', NULL, 'C-type lectin domain family 9 member A', 132, NULL, NULL, 176685),
(176686, '3.20.80.10-FF-000046', NULL, 'Uncharacterized protein', 74, NULL, NULL, 176686),
(176687, '1.10.287.510-FF-000002', NULL, 'DNA double-strand break repair Rad50 ATPase', 112, NULL, NULL, 176687),
(176688, '2.40.50.140-FF-000208', NULL, 'Ribonuclease E/G-like protein chloroplastic', 113, NULL, NULL, 176688),
(176689, '2.60.40.10-FF-006007', NULL, NULL, 78, NULL, NULL, 176689),
(176690, '3.20.20.60-FF-000063', NULL, 'Pyruvate kinase', 213, NULL, NULL, 176690),
(176691, '1.10.287.950-FF-000050', NULL, 'Putative bifunctional protein [include methyl-accepting chemotaxis protein and an extracellular solute-binding protein]', 305, NULL, NULL, 176691),
(176692, '2.60.40.10-FF-000078', NULL, 'Neuronal cell adhesion molecule', 90, NULL, NULL, 176692),
(176693, '2.130.10.10-FF-002652', NULL, 'Uncharacterized protein', 349, NULL, NULL, 176693),
(176694, '3.10.580.10-FF-000043', NULL, 'Sds23p', 172, NULL, NULL, 176694),
(176695, '1.25.10.10-FF-000761', NULL, 'Adenomatous polyposis coli protein-related protein 1', 380, NULL, NULL, 176695);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(176696, '3.40.47.10-FF-000209', NULL, NULL, 187, NULL, NULL, 176696),
(176697, '3.10.20.620-FF-000006', NULL, 'Autophagy protein 5', 122, NULL, NULL, 176697),
(176698, '3.90.190.10-FF-000231', NULL, 'Glomerular epithelial protein 1', 127, NULL, NULL, 176698),
(176699, '3.30.420.340-FF-000013', NULL, 'Aspartokinase', 126, NULL, NULL, 176699),
(176700, '2.20.100.10-FF-000088', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 18', 55, NULL, NULL, 176700),
(176701, '1.10.472.10-FF-000041', NULL, 'Cyclin J like', 105, NULL, NULL, 176701),
(176702, '3.30.200.20-FF-000098', NULL, 'Nuclear receptor-binding protein 1', 104, NULL, NULL, 176702),
(176703, '3.40.50.300-FF-005592', NULL, 'Predicted protein', 240, NULL, NULL, 176703),
(176704, '3.40.50.720-FF-002076', NULL, 'Uncharacterized protein', 145, NULL, NULL, 176704),
(176705, '2.10.220.10-FF-000060', NULL, 'Fraser extracellular matrix complex subunit 1', 105, NULL, NULL, 176705),
(176706, '1.25.40.10-FF-003612', NULL, 'Uncharacterized protein', 110, NULL, NULL, 176706),
(176707, '3.80.10.10-FF-001039', NULL, 'Uncharacterized protein', 253, NULL, NULL, 176707),
(176708, '3.30.830.10-FF-000238', NULL, 'Uncharacterized protein', 222, NULL, NULL, 176708),
(176709, '2.40.10.10-FF-000532', NULL, NULL, 97, NULL, NULL, 176709),
(176710, '3.40.50.300-FF-006429', NULL, 'Uncharacterized protein', 128, NULL, NULL, 176710),
(176711, '3.90.180.10-FF-000197', NULL, 'Uncharacterized protein', 153, NULL, NULL, 176711),
(176712, '1.25.40.10-FF-002623', NULL, 'Pentatricopeptide repeat-containing protein At5g52850, chloroplastic', 230, NULL, NULL, 176712),
(176713, '3.40.50.720-FF-000367', NULL, 'Pyrroline-5-carboxylate reductase', 167, NULL, NULL, 176713),
(176714, '3.40.1090.10-FF-000032', NULL, 'Uncharacterized protein', 127, NULL, NULL, 176714),
(176715, '1.10.357.140-FF-000003', NULL, '4-hydroxybenzoate polyprenyltransferase, mitochondrial', 150, NULL, NULL, 176715),
(176716, '3.90.640.10-FF-000277', NULL, 'Uncharacterized protein', 71, NULL, NULL, 176716),
(176717, '2.60.40.10-FF-003692', NULL, NULL, 83, NULL, NULL, 176717),
(176718, '3.40.50.150-FF-000590', NULL, 'Protein CBG17953', 182, NULL, NULL, 176718),
(176719, '3.40.1190.20-FF-000194', NULL, NULL, 255, NULL, NULL, 176719),
(176720, '3.40.50.450-FF-000090', NULL, 'Os03g0697200 protein', 137, NULL, NULL, 176720),
(176721, '1.10.30.10-FF-000172', NULL, 'High mobility group B protein 14', 91, NULL, NULL, 176721),
(176722, '2.120.10.80-FF-000144', NULL, 'Serine/threonine-protein phosphatase', 169, NULL, NULL, 176722),
(176723, '1.10.8.270-FF-000105', NULL, 'TBC domain containing protein', 96, NULL, NULL, 176723),
(176724, '4.10.400.10-FF-000285', NULL, 'HGF/MSP/plasminogen-like protein', 39, NULL, NULL, 176724),
(176725, '1.20.1060.10-FF-000002', NULL, 'Polymerase (DNA directed), theta', 133, NULL, NULL, 176725),
(176726, '3.30.160.60-FF-000999', NULL, 'zinc finger protein 2 homolog', 28, NULL, NULL, 176726),
(176727, '1.10.1070.11-FF-000107', NULL, 'Uncharacterized protein', 113, NULL, NULL, 176727),
(176728, '1.10.287.810-FF-000002', NULL, 'Mitochondrial import inner membrane translocase subunit tim10', 81, NULL, NULL, 176728),
(176729, '2.40.33.10-FF-000045', NULL, 'Uncharacterized protein', 27, NULL, NULL, 176729),
(176730, '3.30.160.60-FF-005850', NULL, NULL, 73, NULL, NULL, 176730),
(176731, '3.40.50.1820-FF-000336', NULL, 'Probable serine protease EDA2', 266, NULL, NULL, 176731),
(176732, '2.60.40.60-FF-000840', NULL, 'Uncharacterized protein', 119, NULL, NULL, 176732),
(176733, '1.20.20.10-FF-000002', NULL, 'ATP synthase subunit c', 76, NULL, NULL, 176733),
(176734, '3.30.70.370-FF-000010', NULL, 'DNA polymerase A', 31, NULL, NULL, 176734),
(176735, '1.10.760.10-FF-000065', NULL, '40-residue YVTN family beta-propeller', 100, NULL, NULL, 176735),
(176736, '2.60.120.920-FF-000017', NULL, 'F-box/SPRY domain-containing protein 1', 175, NULL, NULL, 176736),
(176737, '2.60.40.150-FF-000463', NULL, 'Copine-1', 103, NULL, NULL, 176737),
(176738, '2.30.30.280-FF-000006', NULL, 'Mitochondrial tRNA-specific 2-thiouridylase 1', 62, NULL, NULL, 176738);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(176739, '3.40.50.300-FF-002686', NULL, 'RAB14, member RAS oncogene family', 160, NULL, NULL, 176739),
(176740, '4.10.372.10-FF-000005', NULL, 'Lipoxygenase 7, chloroplastic', 92, NULL, NULL, 176740),
(176741, '2.60.40.10-FF-000111', NULL, 'Myosin-binding protein C, slow type', 115, NULL, NULL, 176741),
(176742, '3.30.1540.20-FF-000010', NULL, 'Mlh3p', 57, NULL, NULL, 176742),
(176743, '3.30.70.330-FF-001335', NULL, 'serine/threonine-protein kinase Kist isoform X2', 63, NULL, NULL, 176743),
(176744, '1.10.10.60-FF-000224', NULL, 'HTH-type transcriptional regulator RutR', 69, NULL, NULL, 176744),
(176745, '2.130.10.10-FF-000943', NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', 317, NULL, NULL, 176745),
(176746, '1.25.40.20-FF-000327', NULL, 'Ankyrin repeat-containing protein NPR4', 100, NULL, NULL, 176746),
(176747, '1.10.510.10-FF-000142', NULL, 'Octicosapeptide/phox/Bem1p domain kinase superfamily protein', 192, NULL, NULL, 176747),
(176748, '1.20.140.150-FF-000104', NULL, 'Uncharacterized protein', 175, NULL, NULL, 176748),
(176749, '1.10.10.10-FF-000378', NULL, 'Eukaryotic translation initiation factor 3 subunit K', 104, NULL, NULL, 176749),
(176750, '3.80.10.10-FF-003248', NULL, 'Uncharacterized protein', 344, NULL, NULL, 176750),
(176751, '2.60.120.260-FF-000393', NULL, 'Beta-glucosidase', 167, NULL, NULL, 176751),
(176752, '4.10.400.10-FF-000021', NULL, 'Low density lipoprotein receptor-related protein 1', 39, NULL, NULL, 176752),
(176753, '3.30.160.60-FF-003641', NULL, NULL, 32, NULL, NULL, 176753),
(176754, '1.10.238.200-FF-000006', NULL, 'Defective in cullin neddylation protein', 108, NULL, NULL, 176754),
(176755, '2.60.120.10-FF-000563', NULL, 'Uncharacterized protein', 137, NULL, NULL, 176755),
(176756, '3.30.565.10-FF-000458', NULL, 'Uncharacterized protein', 79, NULL, NULL, 176756),
(176757, '1.20.1160.20-FF-000007', NULL, 'PDZ domain containing 7', 71, NULL, NULL, 176757),
(176758, '3.30.60.30-FF-000180', NULL, 'AGAP005450-PA', 54, NULL, NULL, 176758),
(176759, '2.60.40.10-FF-005754', NULL, NULL, 97, NULL, NULL, 176759),
(176760, '2.30.30.100-FF-000060', NULL, 'LSM5 homolog, U6 small nuclear RNA and mRNA degradation associated', 48, NULL, NULL, 176760),
(176761, '2.130.10.10-FF-005878', NULL, 'Sortilin', 303, NULL, NULL, 176761),
(176762, '4.10.320.10-FF-000020', NULL, 'Dihydrolipoyllysine-residue acetyltransferase component 3 of pyruvate dehydrogenase complex, mitochondrial', 49, NULL, NULL, 176762),
(176763, '1.10.238.10-FF-001262', NULL, 'Calcium-binding EF-hand family protein', 58, NULL, NULL, 176763),
(176764, '3.40.50.300-FF-006368', NULL, 'TAP2', 139, NULL, NULL, 176764),
(176765, '2.30.29.30-FF-000558', NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', 102, NULL, NULL, 176765),
(176766, '2.40.150.20-FF-000027', NULL, 'Uncharacterized protein', 89, NULL, NULL, 176766),
(176767, '3.10.28.10-FF-000032', NULL, 'Intron-encoded endonuclease I-SceI', 113, NULL, NULL, 176767),
(176768, '3.90.1150.10-FF-000508', NULL, 'Uncharacterized protein', 101, NULL, NULL, 176768),
(176769, '3.30.870.10-FF-000100', NULL, 'Tyrosyl-DNA phosphodiesterase 1', 307, NULL, NULL, 176769),
(176770, '3.30.420.140-FF-000009', NULL, 'Holliday junction resolvase', 139, NULL, NULL, 176770),
(176771, '1.20.5.500-FF-000015', NULL, NULL, 54, NULL, NULL, 176771),
(176772, '3.80.10.10-FF-002731', NULL, 'Predicted protein', 165, NULL, NULL, 176772),
(176773, '1.20.120.140-FF-000030', NULL, 'Signal recognition particle receptor FtsY', 57, NULL, NULL, 176773),
(176774, '3.40.1370.10-FF-000014', NULL, '50S ribosomal protein L4', 210, NULL, NULL, 176774),
(176775, '3.10.20.10-FF-000003', NULL, 'Sulfur carrier protein FdhD', 87, NULL, NULL, 176775),
(176776, '3.30.160.60-FF-004158', NULL, NULL, 26, NULL, NULL, 176776),
(176777, '1.25.40.10-FF-002123', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 131, NULL, NULL, 176777),
(176778, '3.40.50.1100-FF-000154', NULL, 'Cystathionine beta-synthase', 55, NULL, NULL, 176778),
(176779, '2.40.50.140-FF-000360', NULL, 'Rne/Rng family ribonuclease', 80, NULL, NULL, 176779);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(176780, '3.40.50.300-FF-005912', NULL, 'ABC transporter, putative', 246, NULL, NULL, 176780),
(176781, '1.10.510.10-FF-004149', NULL, NULL, 32, NULL, NULL, 176781),
(176782, '1.20.970.10-FF-000027', NULL, 'Anthranilate phosphoribosyltransferase', 67, NULL, NULL, 176782),
(176783, '1.10.510.10-FF-001687', NULL, 'Uncharacterized protein', 296, NULL, NULL, 176783),
(176784, '3.40.1110.10-FF-000265', NULL, 'Phospholipid-transporting ATPase', 252, NULL, NULL, 176784),
(176785, '3.40.50.300-FF-008262', NULL, 'Uncharacterized protein', 48, NULL, NULL, 176785),
(176786, '3.40.50.720-FF-000631', NULL, '2-dehydropantoate 2-reductase', 178, NULL, NULL, 176786),
(176787, '3.40.930.10-FF-000018', NULL, 'Sodium bicarbonate transporter protein 11', 102, NULL, NULL, 176787),
(176788, '1.10.286.70-FF-000002', NULL, 'Ubiquitin-like protein MDY2', 40, NULL, NULL, 176788),
(176789, '1.10.287.70-FF-000257', NULL, 'TWiK family of potassium channels', 281, NULL, NULL, 176789),
(176790, '3.40.50.880-FF-000162', NULL, 'Aspartate carbamoyltransferase', 220, NULL, NULL, 176790),
(176791, '3.40.50.150-FF-000090', NULL, 'Probable methyltransferase PMT18', 180, NULL, NULL, 176791),
(176792, '2.40.30.330-FF-000019', NULL, 'mRNA cleavage and polyadenylation factor CLP1', 90, NULL, NULL, 176792),
(176793, '3.30.559.30-FF-000023', NULL, 'Non-ribosomal peptide synthetase', 186, NULL, NULL, 176793),
(176794, '3.30.200.20-FF-001115', NULL, 'Serine/threonine-protein kinase WARTS homolog', 81, NULL, NULL, 176794),
(176795, '3.40.50.1000-FF-000006', NULL, 'Plasma membrane ATPase', 147, NULL, NULL, 176795),
(176796, '1.20.1560.10-FF-000259', NULL, 'ATP-binding cassette (ABC) transporter, putative', 338, NULL, NULL, 176796),
(176797, '2.40.50.140-FF-000944', NULL, NULL, 81, NULL, NULL, 176797),
(176798, '3.30.70.330-FF-000610', NULL, 'Putative G3BP-like protein', 116, NULL, NULL, 176798),
(176799, '1.10.510.10-FF-004296', NULL, NULL, 161, NULL, NULL, 176799),
(176800, '3.40.50.80-FF-000120', NULL, 'Ferric reductase', 198, NULL, NULL, 176800),
(176801, '3.30.1120.10-FF-000009', NULL, 'Arylsulfatase', 86, NULL, NULL, 176801),
(176802, '1.25.10.10-FF-002559', NULL, 'Uncharacterized protein', 171, NULL, NULL, 176802),
(176803, '3.40.430.10-FF-000025', NULL, 'Dihydrofolate reductase', 175, NULL, NULL, 176803),
(176804, '3.40.50.300-FF-002922', NULL, 'ATP-dependent DNA helicase RecG', 252, NULL, NULL, 176804),
(176805, '2.70.170.10-FF-000249', NULL, 'Cholinergic receptor nicotinic alpha 10 subunit', 81, NULL, NULL, 176805),
(176806, '3.40.50.1980-FF-000070', NULL, 'Zinc ABC transporter, periplasmic zinc-binding protein', 168, NULL, NULL, 176806),
(176807, '2.130.10.10-FF-000235', NULL, 'POC1 centriolar protein homolog B', 90, NULL, NULL, 176807),
(176808, '3.80.10.10-FF-000022', NULL, 'Erbin isoform 7', 113, NULL, NULL, 176808),
(176809, '1.10.472.80-FF-000101', NULL, 'Rab GTPase activating protein, putative', 126, NULL, NULL, 176809),
(176810, '3.30.60.30-FF-000241', NULL, 'Predicted protein', 46, NULL, NULL, 176810),
(176811, '1.25.40.10-FF-003404', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 128, NULL, NULL, 176811),
(176812, '2.130.10.10-FF-003169', NULL, 'Cilia and flagella-associated protein 44', 143, NULL, NULL, 176812),
(176813, '3.40.50.1820-FF-001617', NULL, 'Os09g0462901 protein', 62, NULL, NULL, 176813),
(176814, '2.130.10.10-FF-005614', NULL, 'Uncharacterized protein', 186, NULL, NULL, 176814),
(176815, '3.30.160.60-FF-001808', NULL, 'Uncharacterized protein', 29, NULL, NULL, 176815),
(176816, '4.10.1290.10-FF-000002', NULL, 'Tumor necrosis factor receptor superfamily member 13B', 45, NULL, NULL, 176816),
(176817, '3.40.50.720-FF-002576', NULL, 'L-lactate dehydrogenase', 31, NULL, NULL, 176817),
(176818, '3.40.50.1970-FF-000010', NULL, 'Probable hydroxyacid-oxoacid transhydrogenase, mitochondrial', 195, NULL, NULL, 176818),
(176819, '2.130.10.10-FF-004597', NULL, 'Uncharacterized protein', 205, NULL, NULL, 176819),
(176820, '3.30.70.330-FF-001835', NULL, NULL, 212, NULL, NULL, 176820),
(176821, '2.70.130.10-FF-000011', NULL, 'Insulin-like growth factor 2 receptor', 154, NULL, NULL, 176821);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(176822, '3.30.200.20-FF-000598', NULL, 'PEK/GCN2 protein kinase, variant', 113, NULL, NULL, 176822),
(176823, '3.20.20.190-FF-000049', NULL, 'Phosphoinositide phospholipase C', 167, NULL, NULL, 176823),
(176824, '1.25.40.820-FF-000017', NULL, 'Rtr1/RPAP2 family-domain-containing protein', 154, NULL, NULL, 176824),
(176825, '2.40.110.10-FF-000016', NULL, 'Acyl-CoA dehydrogenase', 114, NULL, NULL, 176825),
(176826, '2.60.40.10-FF-003192', NULL, 'Beta-glucosidase', 133, NULL, NULL, 176826),
(176827, '1.20.1600.10-FF-000022', NULL, 'Outer membrane protein RaxC', 428, NULL, NULL, 176827),
(176828, '1.25.40.10-FF-000942', NULL, 'BnaC07g00040D protein', 104, NULL, NULL, 176828),
(176829, '2.70.50.80-FF-000003', NULL, 'Scalloped, isoform D', 230, NULL, NULL, 176829),
(176830, '3.90.70.10-FF-000621', NULL, 'Cathepsin F', 137, NULL, NULL, 176830),
(176831, '3.30.710.10-FF-000471', NULL, 'SKp1 Related (Ubiquitin ligase complex component)', 106, NULL, NULL, 176831),
(176832, '3.80.10.10-FF-001450', NULL, 'Uncharacterized F-box/LRR-repeat protein C02F5.7', 140, NULL, NULL, 176832),
(176833, '1.25.40.20-FF-000799', NULL, 'Uncharacterized protein', 49, NULL, NULL, 176833),
(176834, '3.40.50.1000-FF-000681', NULL, NULL, 163, NULL, NULL, 176834),
(176835, '1.10.510.10-FF-002851', NULL, 'AT13713p', 252, NULL, NULL, 176835),
(176836, '1.25.40.800-FF-000011', NULL, 'Uncharacterized protein', 231, NULL, NULL, 176836),
(176837, '3.30.40.10-FF-001920', NULL, 'Uncharacterized protein', 110, NULL, NULL, 176837),
(176838, '3.40.50.1370-FF-000038', NULL, 'Aspartate carbamoyltransferase PyrB', 136, NULL, NULL, 176838),
(176839, '3.40.50.300-FF-001758', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', 212, NULL, NULL, 176839),
(176840, '3.65.10.20-FF-000010', NULL, 'Rtc1', 234, NULL, NULL, 176840),
(176841, '2.60.40.3500-FF-000016', NULL, NULL, 116, NULL, NULL, 176841),
(176842, '3.40.630.10-FF-000092', NULL, 'Peptidase M14', 296, NULL, NULL, 176842),
(176843, '3.90.550.10-FF-000394', NULL, 'Glycosyltransferase family 2 protein', 257, NULL, NULL, 176843),
(176844, '1.10.10.250-FF-000007', NULL, '50S ribosomal protein L11', 73, NULL, NULL, 176844),
(176845, '3.30.200.20-FF-001790', NULL, 'Guanylate cyclase', 126, NULL, NULL, 176845),
(176846, '1.20.1250.20-FF-000806', NULL, 'Peptide transporter 3', 140, NULL, NULL, 176846),
(176847, '1.10.287.110-FF-000298', NULL, 'Uncharacterized protein', 127, NULL, NULL, 176847),
(176848, '3.40.140.10-FF-000037', NULL, 'COP9 signalosome subunit 6', 191, NULL, NULL, 176848),
(176849, '3.30.980.10-FF-000046', NULL, 'Uncharacterized protein, isoform B', 110, NULL, NULL, 176849),
(176850, '3.30.160.60-FF-005350', NULL, NULL, 61, NULL, NULL, 176850),
(176851, '1.25.40.10-FF-001459', NULL, 'Os02g0625100 protein', 131, NULL, NULL, 176851),
(176852, '3.40.50.300-FF-004367', NULL, 'Arsenical pump-driving ATPase', 224, NULL, NULL, 176852),
(176853, '1.10.10.10-FF-002115', NULL, 'Transcriptional regulatory protein', 71, NULL, NULL, 176853),
(176854, '2.10.25.10-FF-000685', NULL, 'Weary, isoform B', 40, NULL, NULL, 176854),
(176855, '1.10.555.10-FF-000256', NULL, NULL, 123, NULL, NULL, 176855),
(176856, '3.30.2350.20-FF-000001', NULL, 'tRNA pseudouridine synthase D', 186, NULL, NULL, 176856),
(176857, '2.60.40.10-FF-005962', NULL, NULL, 102, NULL, NULL, 176857),
(176858, '1.25.40.10-FF-004068', NULL, 'Uncharacterized protein', 145, NULL, NULL, 176858),
(176859, '2.60.120.10-FF-000063', NULL, 'cyclic nucleotide-gated ion channel 4', 119, NULL, NULL, 176859),
(176860, '3.30.60.20-FF-000143', NULL, 'Predicted protein', 49, NULL, NULL, 176860),
(176861, '3.30.1330.60-FF-000017', NULL, 'Outer membrane protein', 109, NULL, NULL, 176861),
(176862, '2.130.10.10-FF-001724', NULL, 'WD repeat containing protein 48', 323, NULL, NULL, 176862),
(176863, '3.30.497.10-FF-000092', NULL, 'Flagellar associated protein, protease inhibitor-like protein', 208, NULL, NULL, 176863),
(176864, '3.40.50.300-FF-000977', NULL, 'BRCA1 interacting protein C-terminal helicase 1', 234, NULL, NULL, 176864);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(176865, '1.25.10.10-FF-000030', NULL, 'AP-1 complex subunit gamma', 590, NULL, NULL, 176865),
(176866, '3.40.50.10420-FF-000021', NULL, '5-formyltetrahydrofolate cyclo-ligase', 187, NULL, NULL, 176866),
(176867, '3.40.50.2300-FF-000172', NULL, 'G-protein coupled receptor family C group 6 member A', 309, NULL, NULL, 176867),
(176868, '1.20.210.10-FF-000044', NULL, 'Laglidadg endonuclease', 47, NULL, NULL, 176868),
(176869, '3.30.379.10-FF-000008', NULL, 'Beta-hexosaminidase', 138, NULL, NULL, 176869),
(176870, '3.40.50.11500-FF-000002', NULL, 'MAP kinase-activating death domain protein-like Protein', 156, NULL, NULL, 176870),
(176871, '1.25.40.10-FF-002387', NULL, 'Pre-mRNA-splicing factor CLF1', 204, NULL, NULL, 176871),
(176872, '3.40.1740.10-FF-000003', NULL, 'Electron transporter, putative (DUF179)', 186, NULL, NULL, 176872),
(176873, '1.50.10.10-FF-000197', NULL, 'Non-lysosomal glucosylceramidase', 224, NULL, NULL, 176873),
(176874, '1.10.510.10-FF-001423', NULL, 'Calcium-dependent protein kinase 7', 63, NULL, NULL, 176874),
(176875, '3.40.720.10-FF-000183', NULL, 'Cell number regulator 8', 17, NULL, NULL, 176875),
(176876, '3.40.50.410-FF-000246', NULL, '60-kDa SS-A/Ro ribonucleoprotein homolog', 223, NULL, NULL, 176876),
(176877, '1.10.630.10-FF-000561', NULL, 'CYP2A13 isoform 1', 329, NULL, NULL, 176877),
(176878, '1.25.50.20-FF-000041', NULL, 'Aminopeptidase', 316, NULL, NULL, 176878),
(176879, '3.40.50.11980-FF-000011', NULL, 'Uncharacterized protein', 245, NULL, NULL, 176879),
(176880, '1.10.20.10-FF-000143', NULL, 'Uncharacterized protein', 43, NULL, NULL, 176880),
(176881, '1.20.58.1380-FF-000018', NULL, 'Nucleoporin nup132', 86, NULL, NULL, 176881),
(176882, '3.50.50.60-FF-001457', NULL, 'Guanosine nucleotide diphosphate dissociation inhibitor', 75, NULL, NULL, 176882),
(176883, '2.60.120.10-FF-000771', NULL, 'Uncharacterized protein', 48, NULL, NULL, 176883),
(176884, '2.30.29.210-FF-000006', NULL, 'Nucleosome binding factor SPN, SPT16 subunit', 131, NULL, NULL, 176884),
(176885, '2.10.50.10-FF-000018', NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing 1', 61, NULL, NULL, 176885),
(176886, '3.30.160.60-FF-002360', NULL, 'Zinc finger protein 418', 27, NULL, NULL, 176886),
(176887, '2.40.30.10-FF-000123', NULL, 'GTP-binding protein 1', 100, NULL, NULL, 176887),
(176888, '1.20.58.390-FF-000150', NULL, 'Neurotransmitter-gated ion-channel ligand binding domain protein', 73, NULL, NULL, 176888),
(176889, '3.30.200.20-FF-001379', NULL, 'Uncharacterized protein', 45, NULL, NULL, 176889),
(176890, '3.40.1080.10-FF-000003', NULL, 'Acetyl-coA hydrolase Ach1', 187, NULL, NULL, 176890),
(176891, '2.60.40.10-FF-004473', NULL, NULL, 90, NULL, NULL, 176891),
(176892, '3.40.50.300-FF-001197', NULL, 'Putative ATP-binding cassette family ATPase', 93, NULL, NULL, 176892),
(176893, '2.130.10.10-FF-000590', NULL, 'WD repeat domain 90', 114, NULL, NULL, 176893),
(176894, '1.50.40.10-FF-000586', NULL, 'Uncharacterized protein', 49, NULL, NULL, 176894),
(176895, '1.10.238.10-FF-000542', NULL, 'Uncharacterized protein, isoform A', 199, NULL, NULL, 176895),
(176896, '3.40.50.300-FF-005648', NULL, 'ATP-dependent RNA helicase DHR1, putative', 218, NULL, NULL, 176896),
(176897, '3.30.720.90-FF-000006', NULL, 'Os08g0541950 protein', 46, NULL, NULL, 176897),
(176898, '1.10.287.110-FF-000034', NULL, 'Chaperone protein DnaJ', 120, NULL, NULL, 176898),
(176899, '1.10.287.770-FF-000029', NULL, 'Pickpocket 22, isoform B', 62, NULL, NULL, 176899),
(176900, '3.20.110.10-FF-000023', NULL, 'Predicted protein', 308, NULL, NULL, 176900),
(176901, '2.30.29.30-FF-001222', NULL, 'Uncharacterized protein', 119, NULL, NULL, 176901),
(176902, '3.30.70.1660-FF-000038', NULL, 'Mitochondrial translational release factor 1', 106, NULL, NULL, 176902),
(176903, '3.40.50.300-FF-000269', NULL, 'ATP-dependent RNA helicase SUPV3L1, mitochondrial', 156, NULL, NULL, 176903),
(176904, '2.60.200.20-FF-000157', NULL, 'PHD finger protein, putative', 121, NULL, NULL, 176904),
(176905, '3.30.450.40-FF-000004', NULL, 'Phosphodiesterase', 202, NULL, NULL, 176905);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(176906, '1.10.510.10-FF-003632', NULL, NULL, 192, NULL, NULL, 176906),
(176907, '2.130.10.10-FF-001871', NULL, 'DAF-15', 237, NULL, NULL, 176907),
(176908, '2.170.270.10-FF-000188', NULL, 'Uncharacterized protein', 210, NULL, NULL, 176908),
(176909, '3.30.160.60-FF-004422', NULL, NULL, 29, NULL, NULL, 176909),
(176910, '1.10.10.10-FF-001659', NULL, 'IS3 family transposase orfA', 70, NULL, NULL, 176910),
(176911, '3.40.50.1220-FF-000044', NULL, 'NAD-dependent histone deacetylase SIR2', 153, NULL, NULL, 176911),
(176912, '2.40.10.220-FF-000005', NULL, 'Type 4 fimbrial biogenesis protein PilZ', 114, NULL, NULL, 176912),
(176913, '3.40.50.720-FF-001148', NULL, '2-dehydropantoate 2-reductase', 182, NULL, NULL, 176913),
(176914, '2.60.40.10-FF-002264', NULL, 'dyslexia-associated protein KIAA0319-like protein', 93, NULL, NULL, 176914),
(176915, '2.40.100.10-FF-000134', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 107, NULL, NULL, 176915),
(176916, '1.25.40.10-FF-000178', NULL, 'Anaphase promoting complex subunit 7', 146, NULL, NULL, 176916),
(176917, '1.10.8.60-FF-000476', NULL, 'Uncharacterized protein', 65, NULL, NULL, 176917),
(176918, '1.10.510.10-FF-002704', NULL, NULL, 87, NULL, NULL, 176918),
(176919, '3.40.50.300-FF-007857', NULL, 'Uncharacterized protein', 214, NULL, NULL, 176919),
(176920, '3.40.50.10810-FF-000076', NULL, 'ATP-dependent helicase ULS1', 275, NULL, NULL, 176920),
(176921, '3.30.9.10-FF-000167', NULL, 'FAD-dependent oxidoreductase', 158, NULL, NULL, 176921),
(176922, '1.10.287.130-FF-000192', NULL, 'Histidine kinase', 76, NULL, NULL, 176922),
(176923, '3.40.50.300-FF-002214', NULL, 'ABC transporter related protein', 239, NULL, NULL, 176923),
(176924, '3.10.20.90-FF-000780', NULL, 'YALI0D16335p', 98, NULL, NULL, 176924),
(176925, '3.40.1110.10-FF-000118', NULL, 'Phospholipid-transporting ATPase', 154, NULL, NULL, 176925),
(176926, '3.90.1290.10-FF-000018', NULL, 'microtubule-actin cross-linking factor 1 isoform X2', 213, NULL, NULL, 176926),
(176927, '1.20.1070.10-FF-000031', NULL, '5-hydroxytryptamine (Serotonin) receptor 2A', 290, NULL, NULL, 176927),
(176928, '3.30.160.60-FF-002213', NULL, 'Zinc finger protein 1152', 27, NULL, NULL, 176928),
(176929, '3.30.160.60-FF-000527', NULL, 'Zinc finger protein', 24, NULL, NULL, 176929),
(176930, '3.40.50.150-FF-001371', NULL, NULL, 178, NULL, NULL, 176930),
(176931, '3.40.50.720-FF-001856', NULL, 'Inositol-3-phosphate synthase isozyme 1', 144, NULL, NULL, 176931),
(176932, '1.10.10.10-FF-000581', NULL, 'LysR family transcriptional regulator', 83, NULL, NULL, 176932),
(176933, '3.40.50.2300-FF-001397', NULL, NULL, 136, NULL, NULL, 176933),
(176934, '3.50.50.60-FF-000232', NULL, 'Rab GDP dissociation inhibitor', 110, NULL, NULL, 176934),
(176935, '1.10.8.10-FF-000158', NULL, 'Caspar, isoform A', 45, NULL, NULL, 176935),
(176936, '3.80.10.10-FF-002528', NULL, 'Uncharacterized protein', 122, NULL, NULL, 176936),
(176937, '1.10.3730.20-FF-000014', NULL, 'EamA family transporter', 135, NULL, NULL, 176937),
(176938, '3.40.50.2300-FF-000733', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One component system)', 149, NULL, NULL, 176938),
(176939, '1.20.1250.20-FF-001734', NULL, 'Uncharacterized protein', 202, NULL, NULL, 176939),
(176940, '3.40.50.620-FF-000747', NULL, 'Uncharacterized protein HI_1701', 148, NULL, NULL, 176940),
(176941, '3.30.70.330-FF-002055', NULL, NULL, 93, NULL, NULL, 176941),
(176942, '3.90.70.10-FF-000357', NULL, 'Uncharacterized protein', 275, NULL, NULL, 176942),
(176943, '1.20.190.50-FF-000013', NULL, 'Nuclear pore complex protein', 150, NULL, NULL, 176943),
(176944, '1.20.1250.20-FF-001998', NULL, 'Uncharacterized protein', 382, NULL, NULL, 176944),
(176945, '3.30.1380.20-FF-000003', NULL, 'Trafficking protein particle complex subunit', 179, NULL, NULL, 176945),
(176946, '3.30.230.10-FF-000389', NULL, 'Diphosphomevalonate decarboxylase', 122, NULL, NULL, 176946),
(176947, '1.20.58.70-FF-000062', NULL, 'Syntaxin-16', 218, NULL, NULL, 176947),
(176948, '3.30.1370.210-FF-000022', NULL, 'Zinc finger CCCH domain-containing protein 42', 92, NULL, NULL, 176948);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(176949, '3.40.640.10-FF-000182', NULL, '4-aminobutyrate aminotransferase', 262, NULL, NULL, 176949),
(176950, '2.70.150.10-FF-000074', NULL, 'Phospholipid-transporting ATPase', 139, NULL, NULL, 176950),
(176951, '2.10.90.10-FF-000083', NULL, 'Neurturin', 101, NULL, NULL, 176951),
(176952, '3.40.50.300-FF-000005', NULL, 'ATP-dependent Clp protease ATP-binding subunit ClpX', 259, NULL, NULL, 176952),
(176953, '3.30.70.1230-FF-000027', NULL, 'ACXA, isoform A', 202, NULL, NULL, 176953),
(176954, '2.10.50.10-FF-000165', NULL, 'Predicted protein', 48, NULL, NULL, 176954),
(176955, '1.25.10.10-FF-003464', NULL, 'Uncharacterized protein', 185, NULL, NULL, 176955),
(176956, '3.40.50.1820-FF-001764', NULL, 'Uncharacterized protein', 224, NULL, NULL, 176956),
(176957, '3.30.930.10-FF-000190', NULL, 'Seryl-tRNA synthetase putative', 230, NULL, NULL, 176957),
(176958, '1.10.12.10-FF-000040', NULL, 'Enoyl-CoA hydratase', 58, NULL, NULL, 176958),
(176959, '1.25.40.10-FF-001870', NULL, 'Outer membrane protein assembly factor BamD', 199, NULL, NULL, 176959),
(176960, '2.130.10.10-FF-004333', NULL, 'Uncharacterized protein', 100, NULL, NULL, 176960),
(176961, '3.10.420.10-FF-000003', NULL, 'SecB-like chaperone', 143, NULL, NULL, 176961),
(176962, '1.20.58.1340-FF-000001', NULL, 'Envelope glycoprotein H', 167, NULL, NULL, 176962),
(176963, '3.40.50.720-FF-001295', NULL, 'Bifunctional rhamnulose-1-phosphate aldolase/short-chain dehydrogenase', 254, NULL, NULL, 176963),
(176964, '3.30.479.30-FF-000022', NULL, 'Membrane protease subunit, stomatin/prohibitin', 122, NULL, NULL, 176964),
(176965, '1.10.10.10-FF-001098', NULL, 'MarR family transcriptional regulator', 141, NULL, NULL, 176965),
(176966, '1.25.10.10-FF-001778', NULL, 'Uncharacterized protein', 847, NULL, NULL, 176966),
(176967, '3.30.420.80-FF-000020', NULL, '30S ribosomal protein S11', 127, NULL, NULL, 176967),
(176968, '3.30.450.40-FF-000268', NULL, 'Uncharacterized protein', 98, NULL, NULL, 176968),
(176969, '3.90.470.20-FF-000042', NULL, '4''-phosphopantetheinyl transferase superfamily protein', 87, NULL, NULL, 176969),
(176970, '3.90.550.10-FF-000506', NULL, 'Chitin synthase', 265, NULL, NULL, 176970),
(176971, '2.60.220.50-FF-000116', NULL, 'Uncharacterized protein', 73, NULL, NULL, 176971),
(176972, '3.40.33.10-FF-000178', NULL, 'SCP-Like extracellular protein', 81, NULL, NULL, 176972),
(176973, '4.10.280.10-FF-000196', NULL, 'Uncharacterized protein', 63, NULL, NULL, 176973),
(176974, '3.30.200.20-FF-000862', NULL, 'CILIATE-E2/CILIATE-E2-UNCLASSIFIED protein kinase', 95, NULL, NULL, 176974),
(176975, '1.10.8.60-FF-000212', NULL, 'Sigma-54 dependent transcriptional regulator', 77, NULL, NULL, 176975),
(176976, '3.10.20.90-FF-000072', NULL, 'Next to BRCA1 gene 1 protein', 82, NULL, NULL, 176976),
(176977, '1.25.40.20-FF-001816', NULL, 'Kinase, NEK', 159, NULL, NULL, 176977),
(176978, '2.10.110.10-FF-000231', NULL, 'LIM and PET domains protein', 63, NULL, NULL, 176978),
(176979, '3.80.10.10-FF-001303', NULL, 'NACHT, LRR and PYD domains-containing protein 7', 158, NULL, NULL, 176979),
(176980, '1.20.1280.260-FF-000001', NULL, 'Envelope glycoprotein', 97, NULL, NULL, 176980),
(176981, '1.10.510.10-FF-002087', NULL, 'Serine/threonine-protein kinase SKY1', 169, NULL, NULL, 176981),
(176982, '1.10.287.70-FF-000201', NULL, 'Two pore segment channel 1', 140, NULL, NULL, 176982),
(176983, '1.25.40.10-FF-004129', NULL, 'Uncharacterized protein', 121, NULL, NULL, 176983),
(176984, '3.30.70.3170-FF-000002', NULL, 'Galactokinase', 77, NULL, NULL, 176984),
(176985, '3.10.100.10-FF-000159', NULL, NULL, 135, NULL, NULL, 176985),
(176986, '3.30.70.100-FF-000070', NULL, 'Small-conductance mechanosensitive channel', 88, NULL, NULL, 176986),
(176987, '1.10.630.10-FF-000645', NULL, 'Uncharacterized protein', 210, NULL, NULL, 176987),
(176988, '1.10.287.70-FF-000673', NULL, 'Uncharacterized protein', 111, NULL, NULL, 176988),
(176989, '2.40.70.10-FF-000041', NULL, 'Basic 7S globulin', 216, NULL, NULL, 176989),
(176990, '3.40.50.1010-FF-000071', NULL, 'Putative 5''-3'' exonuclease', 169, NULL, NULL, 176990); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(176991, '3.30.559.10-FF-000129', NULL, 'Nonribosomal peptide synthase, putative', 178, NULL, NULL, 176991),
(176992, '1.25.10.10-FF-002503', NULL, 'Chromosome 12, whole genome shotgun sequence', 201, NULL, NULL, 176992),
(176993, '2.130.10.10-FF-005378', NULL, 'Striatin', 159, NULL, NULL, 176993),
(176994, '3.40.50.300-FF-001989', NULL, 'GTPase MSS1, mitochondrial', 175, NULL, NULL, 176994),
(176995, '2.10.70.10-FF-000256', NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', 55, NULL, NULL, 176995),
(176996, '2.10.25.10-FF-000769', NULL, 'Laminin subunit gamma-1', 50, NULL, NULL, 176996),
(176997, '2.40.70.10-FF-000480', NULL, NULL, 152, NULL, NULL, 176997),
(176998, '3.90.550.50-FF-000203', NULL, 'Uncharacterized protein', 178, NULL, NULL, 176998),
(176999, '1.10.630.10-FF-000589', NULL, 'Uncharacterized protein', 291, NULL, NULL, 176999),
(177000, '1.25.10.10-FF-002975', NULL, 'Importin, putative', 638, NULL, NULL, 177000),
(177001, '3.40.50.12230-FF-000013', NULL, 'Methionyl-tRNA formyltransferase', 325, NULL, NULL, 177001),
(177002, '1.10.730.10-FF-000214', NULL, 'Valyl-tRNA synthetase', 153, NULL, NULL, 177002),
(177003, '2.60.40.10-FF-004265', NULL, NULL, 109, NULL, NULL, 177003),
(177004, '3.90.1110.10-FF-000034', NULL, NULL, 91, NULL, NULL, 177004),
(177005, '3.40.30.80-FF-000001', NULL, 'Alkyl hydroperoxide reductase subunit F', 200, NULL, NULL, 177005),
(177006, '2.60.40.10-FF-000050', NULL, 'Titin isoform B', 89, NULL, NULL, 177006),
(177007, '3.40.720.10-FF-000008', NULL, 'Alkaline phosphatase', 477, NULL, NULL, 177007),
(177008, '3.40.1190.20-FF-000222', NULL, NULL, 284, NULL, NULL, 177008),
(177009, '1.10.10.60-FF-000163', NULL, 'Arabinose operon transcriptional regulator', 60, NULL, NULL, 177009),
(177010, '2.20.100.10-FF-000060', NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 17', 60, NULL, NULL, 177010),
(177011, '1.20.58.480-FF-000025', NULL, 'Uncharacterized protein', 246, NULL, NULL, 177011),
(177012, '3.30.530.20-FF-000055', NULL, 'Unplaced genomic scaffold supercont1.10, whole genome shotgun sequence', 163, NULL, NULL, 177012),
(177013, '1.20.1740.10-FF-000116', NULL, 'Amino acid permease family protein', 487, NULL, NULL, 177013),
(177014, '1.20.920.10-FF-000171', NULL, 'Uncharacterized protein', 139, NULL, NULL, 177014),
(177015, '1.10.10.60-FF-000640', NULL, 'Putative Myb-like transcription factor', 58, NULL, NULL, 177015),
(177016, '3.30.420.10-FF-000460', NULL, NULL, 67, NULL, NULL, 177016),
(177017, '2.10.250.10-FF-000005', NULL, 'Calreticulin family protein', 101, NULL, NULL, 177017),
(177018, '3.30.70.330-FF-001419', NULL, 'RNA-binding protein', 118, NULL, NULL, 177018),
(177019, '1.25.40.10-FF-000386', NULL, 'Signal recognition particle subunit SRP72', 95, NULL, NULL, 177019),
(177020, '3.60.10.10-FF-000096', NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', 360, NULL, NULL, 177020),
(177021, '2.40.10.10-FF-000032', NULL, 'Kallikrein 1-related peptidase C9', 109, NULL, NULL, 177021),
(177022, '2.130.10.10-FF-002591', NULL, 'Src-associated protein-like protein', 204, NULL, NULL, 177022),
(177023, '1.10.520.10-FF-000024', NULL, 'Predicted protein', 150, NULL, NULL, 177023),
(177024, '3.30.40.10-FF-001009', NULL, 'Nucleosome-remodeling factor subunit NURF301-like', 63, NULL, NULL, 177024),
(177025, '3.10.400.20-FF-000005', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 184, NULL, NULL, 177025),
(177026, '3.30.70.2610-FF-000008', NULL, 'RNA polymerase II transcription factor B subunit 2', 55, NULL, NULL, 177026),
(177027, '2.60.120.10-FF-000327', NULL, 'Crp/Fnr family transcriptional regulator', 126, NULL, NULL, 177027),
(177028, '1.10.10.10-FF-000142', NULL, 'Cullin 5', 83, NULL, NULL, 177028),
(177029, '2.40.50.140-FF-000091', NULL, 'DNA helicase', 101, NULL, NULL, 177029),
(177030, '3.30.160.60-FF-000443', NULL, 'Zinc finger protein 41', 28, NULL, NULL, 177030),
(177031, '3.40.50.300-FF-007773', NULL, 'Predicted protein', 59, NULL, NULL, 177031);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(177032, '1.10.10.10-FF-001867', NULL, 'Uncharacterized protein', 67, NULL, NULL, 177032),
(177033, '2.60.40.60-FF-000924', NULL, 'Uncharacterized protein', 62, NULL, NULL, 177033),
(177034, '1.10.287.70-FF-000196', NULL, 'Voltage-dependent T-type calcium channel subunit alpha', 101, NULL, NULL, 177034),
(177035, '2.60.40.10-FF-005198', NULL, NULL, 92, NULL, NULL, 177035),
(177036, '3.40.50.720-FF-000075', NULL, 'Mannitol-1-phosphate 5-dehydrogenase', 206, NULL, NULL, 177036),
(177037, '3.90.640.10-FF-000221', NULL, 'Actin-like protein 1-1', 71, NULL, NULL, 177037),
(177038, '3.40.50.620-FF-000247', NULL, 'Cytoplasmic tRNA 2-thiolation protein 1', 325, NULL, NULL, 177038),
(177039, '3.90.950.10-FF-000031', NULL, 'Maf-like protein, expressed', 87, NULL, NULL, 177039),
(177040, '1.20.120.160-FF-000013', NULL, 'Histidine kinase', 115, NULL, NULL, 177040),
(177041, '1.10.600.10-FF-000025', NULL, 'squalene synthase isoform X3', 97, NULL, NULL, 177041),
(177042, '2.30.29.30-FF-000002', NULL, 'Band 4.1-like protein 5 isoform 1', 91, NULL, NULL, 177042),
(177043, '3.40.50.720-FF-002020', NULL, 'Fatty acyl-CoA reductase', 208, NULL, NULL, 177043),
(177044, '1.25.40.20-FF-000771', NULL, 'LOW QUALITY PROTEIN: ankyrin repeat domain-containing protein 33', 169, NULL, NULL, 177044),
(177045, '3.40.190.10-FF-000720', NULL, 'Carbohydrate ABC transporter substrate-binding protein, CUT1 family (TC 3.A.1.1.-)', 162, NULL, NULL, 177045),
(177046, '1.20.80.10-FF-000039', NULL, 'Myosin 28B1, isoform B', 106, NULL, NULL, 177046),
(177047, '3.80.10.10-FF-004468', NULL, 'Leucine-rich repeat protein kinase family protein', 67, NULL, NULL, 177047),
(177048, '3.20.20.30-FF-000020', NULL, 'F420-dependent oxidoreductase', 259, NULL, NULL, 177048),
(177049, '2.115.10.20-FF-000015', NULL, 'Exoinulinase InuD', 129, NULL, NULL, 177049),
(177050, '1.10.238.10-FF-000565', NULL, 'Calcium-binding EF-hand family protein', 104, NULL, NULL, 177050),
(177051, '3.40.50.1970-FF-000038', NULL, 'Alcohol dehydrogenase, iron-dependent', 183, NULL, NULL, 177051),
(177052, '3.80.10.10-FF-000730', NULL, 'Toll-like receptor 11', 119, NULL, NULL, 177052),
(177053, '3.40.50.150-FF-001163', NULL, 'NOP2/Sun domain family, member 3', 242, NULL, NULL, 177053),
(177054, '1.10.3430.10-FF-000056', NULL, 'Blr0607 protein', 189, NULL, NULL, 177054),
(177055, '2.30.30.40-FF-000076', NULL, 'Growth factor receptor-bound protein 2', 51, NULL, NULL, 177055),
(177056, '2.130.10.10-FF-003405', NULL, 'WD domain, G-beta repeat, putative', 197, NULL, NULL, 177056),
(177057, '2.60.120.620-FF-000080', NULL, 'Predicted protein', 100, NULL, NULL, 177057),
(177058, '3.90.1150.10-FF-000424', NULL, 'Uga11p', 93, NULL, NULL, 177058),
(177059, '1.20.1280.290-FF-000072', NULL, 'Uncharacterized protein', 96, NULL, NULL, 177059),
(177060, '1.20.1280.170-FF-000007', NULL, 'Exocyst subunit Exo70 family protein', 519, NULL, NULL, 177060),
(177061, '2.20.70.10-FF-000115', NULL, 'WW domain-containing oxidoreductase isoform X4', 33, NULL, NULL, 177061),
(177062, '3.40.800.10-FF-000009', NULL, 'Arginase', 317, NULL, NULL, 177062),
(177063, '3.40.190.290-FF-000060', NULL, 'HTH-type transcriptional regulator ArgP', 220, NULL, NULL, 177063),
(177064, '2.60.120.200-FF-000566', NULL, 'Calreticulin family protein', 246, NULL, NULL, 177064),
(177065, '2.60.120.10-FF-000799', NULL, 'Mannose-6-phosphate isomerase, putative', 214, NULL, NULL, 177065),
(177066, '3.30.70.330-FF-001482', NULL, NULL, 79, NULL, NULL, 177066),
(177067, '3.30.930.10-FF-000274', NULL, 'Histidine--tRNA ligase protein', 325, NULL, NULL, 177067),
(177068, '3.40.30.10-FF-001222', NULL, 'Protein disulfide-isomerase', 125, NULL, NULL, 177068),
(177069, '3.30.160.60-FF-004658', NULL, NULL, 27, NULL, NULL, 177069),
(177070, '3.30.40.10-FF-000987', NULL, 'Putative E3 ubiquitin-protein ligase ubr7', 66, NULL, NULL, 177070),
(177071, '1.10.1670.10-FF-000006', NULL, 'A/G-specific adenine glycosylase', 89, NULL, NULL, 177071),
(177072, '2.60.40.1730-FF-000018', NULL, 'M1 family aminopeptidase', 187, NULL, NULL, 177072),
(177073, '1.25.10.10-FF-003487', NULL, 'Protein kinase domain-containing protein ppk3', 274, NULL, NULL, 177073);
INSERT INTO "PUBLIC"."MODEL" VALUES
(177074, '1.25.10.10-FF-001250', NULL, 'Dynein axonemal assembly factor 5', 132, NULL, NULL, 177074),
(177075, '3.10.129.10-FF-000242', NULL, 'Uncharacterized protein', 137, NULL, NULL, 177075),
(177076, '1.10.510.10-FF-000642', NULL, 'Serine/threonine-protein kinase srpk2', 176, NULL, NULL, 177076),
(177077, '1.25.40.10-FF-003668', NULL, 'Uncharacterized protein', 180, NULL, NULL, 177077),
(177078, '3.40.50.300-FF-005884', NULL, 'Protein CBG00906', 140, NULL, NULL, 177078),
(177079, '4.10.60.10-FF-000262', NULL, 'Peptidyl-prolyl cis-trans isomerase', 85, NULL, NULL, 177079),
(177080, '1.10.10.60-FF-001096', NULL, NULL, 71, NULL, NULL, 177080),
(177081, '1.20.5.4770-FF-000024', NULL, 'Uncharacterized protein', 62, NULL, NULL, 177081),
(177082, '3.40.50.10190-FF-000053', NULL, 'Microcephalin', 89, NULL, NULL, 177082),
(177083, '1.10.150.120-FF-000015', NULL, NULL, 97, NULL, NULL, 177083),
(177084, '3.40.50.1100-FF-000070', NULL, 'Diaminopropionate ammonia-lyase', 167, NULL, NULL, 177084),
(177085, '3.40.50.1000-FF-000506', NULL, 'Phospholipid-transporting ATPase-like protein', 166, NULL, NULL, 177085),
(177086, '1.10.10.10-FF-000934', NULL, 'Forkhead box protein O3', 69, NULL, NULL, 177086),
(177087, '1.20.1280.50-FF-000238', NULL, 'F-box/leucine rich repeat protein, putative', 49, NULL, NULL, 177087),
(177088, '1.20.1540.10-FF-000112', NULL, 'Uncharacterized protein', 114, NULL, NULL, 177088),
(177089, '3.40.50.300-FF-000685', NULL, 'ATP-dependent DNA helicase DinG', 185, NULL, NULL, 177089),
(177090, '3.30.2410.10-FF-000054', NULL, 'Protein CBG00511', 36, NULL, NULL, 177090),
(177091, '3.10.20.80-FF-000007', NULL, 'Translation initiation factor IF3, putative', 78, NULL, NULL, 177091),
(177092, '3.40.1350.60-FF-000005', NULL, 'Sugar fermentation stimulation protein homolog', 136, NULL, NULL, 177092),
(177093, '2.60.40.10-FF-000847', NULL, 'Hemicentin 1', 94, NULL, NULL, 177093),
(177094, '2.130.10.10-FF-000174', NULL, 'Protein phosphatase PP2A regulatory subunit B', 322, NULL, NULL, 177094),
(177095, '1.10.510.10-FF-004065', NULL, NULL, 183, NULL, NULL, 177095),
(177096, '2.10.25.10-FF-000393', NULL, 'Neurogenic locus notch homolog protein 2', 41, NULL, NULL, 177096),
(177097, '1.20.1070.10-FF-001312', NULL, 'Archaeal-type opsin 2', 233, NULL, NULL, 177097),
(177098, '3.40.50.1820-FF-001680', NULL, 'Uncharacterized protein', 233, NULL, NULL, 177098),
(177099, '3.90.70.40-FF-000017', NULL, 'Predicted protein', 133, NULL, NULL, 177099),
(177100, '1.10.510.10-FF-003429', NULL, NULL, 287, NULL, NULL, 177100),
(177101, '3.30.505.10-FF-000157', NULL, NULL, 98, NULL, NULL, 177101),
(177102, '2.60.40.10-FF-001359', NULL, '1,4-alpha-glucan-branching enzyme 3, chloroplastic/amyloplastic', 109, NULL, NULL, 177102),
(177103, '1.25.40.120-FF-000049', NULL, 'Uncharacterized protein', 276, NULL, NULL, 177103),
(177104, '2.30.140.40-FF-000001', NULL, 'Genome polyprotein', 57, NULL, NULL, 177104),
(177105, '2.130.10.10-FF-003580', NULL, 'Uncharacterized protein', 324, NULL, NULL, 177105),
(177106, '1.10.220.60-FF-000005', NULL, 'GRIP and coiled-coil domain-containing protein 1', 53, NULL, NULL, 177106),
(177107, '3.20.20.105-FF-000017', NULL, 'Queuine tRNA-ribosyltransferase accessory subunit 2', 402, NULL, NULL, 177107),
(177108, '3.30.160.60-FF-004714', NULL, NULL, 51, NULL, NULL, 177108),
(177109, '3.60.40.10-FF-000188', NULL, 'Protein phosphatase, Mg2+/Mn2+ dependent 1M', 202, NULL, NULL, 177109),
(177110, '1.20.5.170-FF-000135', NULL, 'Transcriptional activator in the Cbf1p-Met4p-Met28p complex', 78, NULL, NULL, 177110),
(177111, '3.30.160.60-FF-005642', NULL, NULL, 84, NULL, NULL, 177111),
(177112, '1.20.1080.10-FF-000032', NULL, 'Aquaporin-2', 109, NULL, NULL, 177112),
(177113, '2.60.40.10-FF-002287', NULL, 'Cell surface protein', 111, NULL, NULL, 177113),
(177114, '2.60.40.10-FF-005518', NULL, NULL, 74, NULL, NULL, 177114),
(177115, '2.60.40.790-FF-000211', NULL, NULL, 72, NULL, NULL, 177115),
(177116, '3.40.50.300-FF-004900', NULL, 'Predicted protein', 160, NULL, NULL, 177116),
(177117, '3.40.50.10810-FF-000104', NULL, 'Protein CHROMATIN REMODELING 20', 283, NULL, NULL, 177117);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(177118, '1.10.10.10-FF-000878', NULL, 'ATP-dependent DNA helicase', 131, NULL, NULL, 177118),
(177119, '1.20.58.630-FF-000003', NULL, NULL, 96, NULL, NULL, 177119),
(177120, '3.30.70.330-FF-001858', NULL, NULL, 108, NULL, NULL, 177120),
(177121, '1.20.5.710-FF-000016', NULL, '54S ribosomal protein L12, mitochondrial', 59, NULL, NULL, 177121),
(177122, '3.40.1230.10-FF-000004', NULL, 'Blast:NADH dehydrogenase', 130, NULL, NULL, 177122),
(177123, '3.30.450.20-FF-000493', NULL, 'Diguanylate cyclase and metal dependent phosphohydrolase', 124, NULL, NULL, 177123),
(177124, '1.20.140.140-FF-000011', NULL, 'Uncharacterized protein', 132, NULL, NULL, 177124),
(177125, '1.10.472.10-FF-000277', NULL, 'Uncharacterized protein', 97, NULL, NULL, 177125),
(177126, '1.10.10.10-FF-001923', NULL, 'Uncharacterized protein', 95, NULL, NULL, 177126),
(177127, '3.30.160.60-FF-000819', NULL, 'zinc finger protein 213 isoform X2', 26, NULL, NULL, 177127),
(177128, '1.25.40.10-FF-003292', NULL, 'Vacuolar protein sorting-associated protein 41', 192, NULL, NULL, 177128),
(177129, '3.90.1410.10-FF-000046', NULL, 'SET domain-containing protein', 253, NULL, NULL, 177129),
(177130, '2.60.40.4060-FF-000010', NULL, 'SPONdin (Extracellular matrix glycoprotein) family', 155, NULL, NULL, 177130),
(177131, '3.30.9.10-FF-000223', NULL, 'Uncharacterized protein', 27, NULL, NULL, 177131),
(177132, '1.10.238.10-FF-000126', NULL, 'DCN1-like protein', 90, NULL, NULL, 177132),
(177133, '2.10.60.10-FF-000047', NULL, 'Receptor protein serine/threonine kinase', 108, NULL, NULL, 177133),
(177134, '3.30.200.20-FF-002104', NULL, 'Non-specific serine/threonine protein kinase', 79, NULL, NULL, 177134),
(177135, '1.20.1270.60-FF-000325', NULL, 'Predicted protein', 67, NULL, NULL, 177135),
(177136, '2.30.30.40-FF-000132', NULL, 'jouberin isoform X2', 69, NULL, NULL, 177136),
(177137, '3.30.160.60-FF-000971', NULL, 'Zinc finger and BTB domain-containing protein 11', 29, NULL, NULL, 177137),
(177138, '3.90.70.200-FF-000024', NULL, 'Caldesmon, putative', 117, NULL, NULL, 177138),
(177139, '4.10.400.10-FF-000049', NULL, 'Very low density lipoprotein receptor', 34, NULL, NULL, 177139),
(177140, '1.10.30.10-FF-000025', NULL, 'HMG domain-containing protein 3 isoform X2', 80, NULL, NULL, 177140),
(177141, '3.90.70.10-FF-000126', NULL, 'Genome polyprotein', 167, NULL, NULL, 177141),
(177142, '1.10.400.10-FF-000021', NULL, 'Guanine nucleotide-binding protein (G protein), alpha 15 (Gq class)', 118, NULL, NULL, 177142),
(177143, '3.30.40.10-FF-000195', NULL, 'E3 ubiquitin-protein ligase RNF220', 72, NULL, NULL, 177143),
(177144, '3.40.50.20-FF-000029', NULL, 'D-alanine--D-alanine ligase', 113, NULL, NULL, 177144),
(177145, '3.80.10.10-FF-003956', NULL, 'Uncharacterized protein', 62, NULL, NULL, 177145),
(177146, '1.20.1080.10-FF-000088', NULL, 'AQuaPorin or aquaglyceroporin related', 147, NULL, NULL, 177146),
(177147, '1.20.140.10-FF-000133', NULL, 'Glutaryl-CoA dehydrogenase a', 75, NULL, NULL, 177147),
(177148, '3.30.160.360-FF-000015', NULL, 'Histone-lysine N-methyltransferase', 132, NULL, NULL, 177148),
(177149, '1.10.1410.10-FF-000049', NULL, 'Uncharacterized protein', 165, NULL, NULL, 177149),
(177150, '1.20.1250.20-FF-001503', NULL, 'Uncharacterized protein', 310, NULL, NULL, 177150),
(177151, '3.30.70.100-FF-000007', NULL, 'protein NipSnap homolog 2', 117, NULL, NULL, 177151),
(177152, '2.130.10.10-FF-001955', NULL, 'Cleavage stimulation factor 50K chain', 314, NULL, NULL, 177152),
(177153, '2.60.40.2030-FF-000013', NULL, 'Adhesion G-protein coupled receptor V1', 114, NULL, NULL, 177153),
(177154, '1.10.101.10-FF-000023', NULL, 'Uncharacterized membrane protein', 71, NULL, NULL, 177154),
(177155, '3.90.79.10-FF-000085', NULL, 'Nudix hydrolase 23, chloroplastic', 152, NULL, NULL, 177155),
(177156, '3.40.120.10-FF-000007', NULL, 'Phosphoglucomutase 5', 100, NULL, NULL, 177156),
(177157, '1.25.40.10-FF-000442', NULL, 'Pentatricopeptide repeat-containing protein At3g49710', 139, NULL, NULL, 177157),
(177158, '3.40.1800.20-FF-000039', NULL, NULL, 75, NULL, NULL, 177158);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(177159, '2.80.10.50-FF-000109', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 136, NULL, NULL, 177159),
(177160, '3.80.10.10-FF-003220', NULL, 'Uncharacterized protein', 203, NULL, NULL, 177160),
(177161, '2.60.40.10-FF-001831', NULL, 'Uncharacterized protein, isoform B', 86, NULL, NULL, 177161),
(177162, '3.40.50.300-FF-005356', NULL, 'Protein translocase subunit SecA 2', 199, NULL, NULL, 177162),
(177163, '1.20.1050.80-FF-000005', NULL, 'alsin isoform X1', 133, NULL, NULL, 177163),
(177164, '3.50.50.60-FF-001165', NULL, 'FAD/NAD(P)-binding oxidoreductase family protein', 31, NULL, NULL, 177164),
(177165, '1.10.472.130-FF-000029', NULL, 'Dynein gamma chain, flagellar outer arm', 137, NULL, NULL, 177165),
(177166, '3.40.1110.10-FF-000349', NULL, NULL, 34, NULL, NULL, 177166),
(177167, '4.10.240.10-FF-000047', NULL, 'Oleate activated transcription factor 3', 42, NULL, NULL, 177167),
(177168, '3.40.50.720-FF-000923', NULL, '3-alpha-hydroxysteroid dehydrogenase, putative', 254, NULL, NULL, 177168),
(177169, '1.20.1740.10-FF-000240', NULL, 'Predicted protein', 373, NULL, NULL, 177169),
(177170, '3.40.50.1440-FF-000110', NULL, 'Uncharacterized protein', 137, NULL, NULL, 177170),
(177171, '3.40.50.300-FF-003467', NULL, 'DNA helicase', 182, NULL, NULL, 177171),
(177172, '1.10.287.940-FF-000013', NULL, 'P2X purinoceptor', 25, NULL, NULL, 177172),
(177173, '1.20.1300.10-FF-000038', NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', 99, NULL, NULL, 177173),
(177174, '2.120.10.80-FF-000060', NULL, 'Kelch like family member 8', 166, NULL, NULL, 177174),
(177175, '2.60.120.620-FF-000141', NULL, 'Predicted protein', 180, NULL, NULL, 177175),
(177176, '3.90.480.10-FF-000006', NULL, 'Sulfite reductase subunit, putative', 75, NULL, NULL, 177176),
(177177, '1.10.472.80-FF-000045', NULL, 'TBC1 domain family member 9B isoform X2', 127, NULL, NULL, 177177),
(177178, '2.60.40.10-FF-005193', NULL, NULL, 92, NULL, NULL, 177178),
(177179, '2.70.98.30-FF-000008', NULL, 'Alpha-mannosidase mngB', 281, NULL, NULL, 177179),
(177180, '2.60.40.10-FF-003629', NULL, NULL, 95, NULL, NULL, 177180),
(177181, '2.70.98.10-FF-000002', NULL, 'Aldose 1-epimerase', 336, NULL, NULL, 177181),
(177182, '2.60.40.830-FF-000004', NULL, 'Cytochrome f, chloroplastic', 52, NULL, NULL, 177182),
(177183, '1.25.40.10-FF-005057', NULL, 'Pentatricopeptide repeat-containing protein At3g50420', 107, NULL, NULL, 177183),
(177184, '2.40.50.140-FF-000888', NULL, NULL, 188, NULL, NULL, 177184),
(177185, '3.40.50.1000-FF-000478', NULL, NULL, 115, NULL, NULL, 177185),
(177186, '3.40.50.880-FF-000218', NULL, 'Uncharacterized protein', 146, NULL, NULL, 177186),
(177187, '1.25.40.420-FF-000021', NULL, 'BTB/POZ domain-containing protein 17', 104, NULL, NULL, 177187),
(177188, '3.30.300.30-FF-000075', NULL, 'Nonribosomal peptide synthetase 7', 118, NULL, NULL, 177188),
(177189, '3.40.50.1440-FF-000054', NULL, 'Tubulin gamma chain', 269, NULL, NULL, 177189),
(177190, '1.25.40.10-FF-005293', NULL, 'Clustered mitochondria protein homolog', 137, NULL, NULL, 177190),
(177191, '3.30.70.240-FF-000055', NULL, 'Predicted protein', 60, NULL, NULL, 177191),
(177192, '2.60.40.60-FF-000076', NULL, 'Protocadherin alpha 2', 108, NULL, NULL, 177192),
(177193, '1.10.510.10-FF-000703', NULL, 'Casein kinase I gamma', 349, NULL, NULL, 177193),
(177194, '2.10.25.10-FF-001225', NULL, 'Nimrod C1, isoform B', 39, NULL, NULL, 177194),
(177195, '3.50.4.10-FF-000022', NULL, 'Serine/threonine-protein kinase', 79, NULL, NULL, 177195),
(177196, '2.10.25.10-FF-001169', NULL, 'Uncharacterized protein', 46, NULL, NULL, 177196),
(177197, '1.10.340.30-FF-000084', NULL, 'N-glycosylase/DNA lyase-like Protein', 125, NULL, NULL, 177197),
(177198, '3.80.10.10-FF-001539', NULL, 'Uncharacterized protein', 64, NULL, NULL, 177198),
(177199, '1.10.1070.11-FF-000023', NULL, 'serine/threonine-protein kinase SMG1 isoform X1', 173, NULL, NULL, 177199),
(177200, '3.20.20.70-FF-000684', NULL, NULL, 194, NULL, NULL, 177200),
(177201, '3.40.50.150-FF-000674', NULL, 'tRNA (guanine-N(7)-)-methyltransferase', 189, NULL, NULL, 177201);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(177202, '3.40.50.150-FF-000179', NULL, 'tRNA (guanine-N(7)-)-methyltransferase', 203, NULL, NULL, 177202),
(177203, '1.20.58.340-FF-000040', NULL, 'Magnesium transporter', 136, NULL, NULL, 177203),
(177204, '2.10.25.10-FF-001410', NULL, 'FEEL-1', 43, NULL, NULL, 177204),
(177205, '3.40.50.1860-FF-000005', NULL, 'Glutamate racemase', 137, NULL, NULL, 177205),
(177206, '2.60.120.200-FF-000190', NULL, 'Protein eyes shut homolog', 188, NULL, NULL, 177206),
(177207, '3.40.50.360-FF-000096', NULL, 'Putative flavodoxin', 158, NULL, NULL, 177207),
(177208, '2.60.40.60-FF-000132', NULL, 'Proto-oncogene tyrosine-protein kinase receptor Ret', 108, NULL, NULL, 177208),
(177209, '1.25.40.10-FF-005113', NULL, 'Uncharacterized protein', 115, NULL, NULL, 177209),
(177210, '3.10.450.10-FF-000062', NULL, 'Si:ch211-284e20.8', 115, NULL, NULL, 177210),
(177211, '2.40.50.100-FF-000163', NULL, 'Uncharacterized protein', 108, NULL, NULL, 177211),
(177212, '3.40.50.720-FF-000867', NULL, 'Ubiquitin activating enzyme', 255, NULL, NULL, 177212),
(177213, '3.40.50.2300-FF-000969', NULL, NULL, 148, NULL, NULL, 177213),
(177214, '3.40.120.10-FF-000070', NULL, 'Uncharacterized protein', 186, NULL, NULL, 177214),
(177215, '3.30.40.10-FF-002140', NULL, 'RBR-type E3 ubiquitin transferase', 85, NULL, NULL, 177215),
(177216, '2.30.29.30-FF-001014', NULL, 'band 4.1-like protein 4 isoform X1', 93, NULL, NULL, 177216),
(177217, '3.30.70.1660-FF-000015', NULL, 'Peptide chain release factor 1', 160, NULL, NULL, 177217),
(177218, '1.10.8.270-FF-000128', NULL, 'RabGAP/TBC protein', 112, NULL, NULL, 177218),
(177219, '1.10.1030.10-FF-000008', NULL, 'Carbamoyl-phosphate synthase large chain', 106, NULL, NULL, 177219),
(177220, '2.60.40.1170-FF-000093', NULL, NULL, 114, NULL, NULL, 177220),
(177221, '3.60.10.10-FF-000416', NULL, 'LP11751p', 179, NULL, NULL, 177221),
(177222, '1.10.510.10-FF-000518', NULL, 'serine/threonine-protein kinase 31 isoform X1', 195, NULL, NULL, 177222),
(177223, '1.10.640.10-FF-000095', NULL, 'Peroxidase, putative', 305, NULL, NULL, 177223),
(177224, '3.30.1060.10-FF-000010', NULL, 'Peptide methionine sulfoxide reductase msrA', 157, NULL, NULL, 177224),
(177225, '3.30.60.160-FF-000001', NULL, 'MBT domain-containing protein 1 isoform X1', 42, NULL, NULL, 177225),
(177226, '1.20.5.1030-FF-000003', NULL, 'Preprotein translocase subunit SecE', 57, NULL, NULL, 177226),
(177227, '1.20.1250.20-FF-001942', NULL, 'AGAP003495-PA', 456, NULL, NULL, 177227),
(177228, '3.40.50.720-FF-001620', NULL, 'Short-chain dehydrogenase, putative', 88, NULL, NULL, 177228),
(177229, '3.40.50.2300-FF-001161', NULL, NULL, 138, NULL, NULL, 177229),
(177230, '1.20.1560.10-FF-000170', NULL, 'MDR-like ABC transporter', 32, NULL, NULL, 177230),
(177231, '3.90.70.10-FF-000565', NULL, 'Putative ABC transporter ATP-binding MG390', 156, NULL, NULL, 177231),
(177232, '3.30.760.10-FF-000002', NULL, 'Eukaryotic translation initiation factor 4E', 188, NULL, NULL, 177232),
(177233, '3.30.160.60-FF-002713', NULL, 'Zinc finger protein 285', 35, NULL, NULL, 177233),
(177234, '1.20.1270.60-FF-000269', NULL, 'Uncharacterized protein', 103, NULL, NULL, 177234),
(177235, '3.20.20.70-FF-000009', NULL, '1-(5-phosphoribosyl)-5-[(5-phosphoribosylamino)methylideneamino] imidazole-4-carboxamide isomerase', 237, NULL, NULL, 177235),
(177236, '1.20.58.1080-FF-000018', NULL, 'Chromosome 15, whole genome shotgun sequence', 85, NULL, NULL, 177236),
(177237, '3.40.50.300-FF-002006', NULL, 'Pantothenate kinase', 318, NULL, NULL, 177237),
(177238, '3.90.226.10-FF-000096', NULL, 'Enoyl-CoA hydratase EchA14', 257, NULL, NULL, 177238),
(177239, '3.40.50.720-FF-001087', NULL, 'Aflatoxin biosynthesis ketoreductase nor-1', 245, NULL, NULL, 177239),
(177240, '3.30.200.20-FF-000362', NULL, 'Non-specific serine/threonine protein kinase', 86, NULL, NULL, 177240),
(177241, '3.40.50.300-FF-007357', NULL, 'Dicer-1', 165, NULL, NULL, 177241),
(177242, '3.40.50.300-FF-004428', NULL, 'Cell division protein ZapE', 170, NULL, NULL, 177242),
(177243, '1.10.287.550-FF-000019', NULL, 'Steroid sulfatase', 59, NULL, NULL, 177243);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(177244, '1.20.1250.20-FF-002015', NULL, 'Membrane protein, major facilitator transporter family', 370, NULL, NULL, 177244),
(177245, '2.40.50.40-FF-000021', NULL, 'chromodomain Y-like protein', 58, NULL, NULL, 177245),
(177246, '1.25.40.10-FF-001370', NULL, 'Pentatricopeptide repeat-containing protein', 156, NULL, NULL, 177246),
(177247, '2.130.10.10-FF-005322', NULL, 'Uncharacterized protein', 198, NULL, NULL, 177247),
(177248, '3.40.50.450-FF-000027', NULL, 'Possible lysine decarboxylase', 255, NULL, NULL, 177248),
(177249, '3.30.160.60-FF-000027', NULL, 'zinc finger protein 3 homolog', 28, NULL, NULL, 177249),
(177250, '1.10.1450.10-FF-000175', NULL, 'Tetraspanin', 46, NULL, NULL, 177250),
(177251, '1.25.40.1040-FF-000029', NULL, 'N-terminal acetyltransferase A complex auxiliary subunit NAA15', 124, NULL, NULL, 177251),
(177252, '1.10.238.10-FF-001054', NULL, 'Reticulocalbin, putative', 91, NULL, NULL, 177252),
(177253, '3.50.7.10-FF-000028', NULL, 'Chaperonin 60 subunit beta 2 chloroplastic', 112, NULL, NULL, 177253),
(177254, '2.40.180.10-FF-000026', NULL, 'Catalase', 150, NULL, NULL, 177254),
(177255, '1.20.1280.290-FF-000100', NULL, 'Uncharacterized protein', 102, NULL, NULL, 177255),
(177256, '3.30.160.360-FF-000010', NULL, 'Histone-lysine N-methyltransferase', 119, NULL, NULL, 177256),
(177257, '1.10.3470.10-FF-000002', NULL, 'Zinc ABC transporter permease subunit ZnuB', 256, NULL, NULL, 177257),
(177258, '1.10.730.10-FF-000153', NULL, 'Valyl tRNA Synthetase', 174, NULL, NULL, 177258),
(177259, '1.25.10.10-FF-000558', NULL, 'Fem-3 mRNA-binding factor 2', 390, NULL, NULL, 177259),
(177260, '1.10.3090.10-FF-000012', NULL, 'Bifunctional uridylyltransferase/uridylyl-removing enzyme', 227, NULL, NULL, 177260),
(177261, '2.20.28.120-FF-000003', NULL, '50S ribosomal protein L33', 55, NULL, NULL, 177261),
(177262, '1.20.1050.10-FF-000204', NULL, 'Rpt-6', 91, NULL, NULL, 177262),
(177263, '3.40.50.300-FF-000213', NULL, 'ATP-dependent protease ATPase subunit HslU', 198, NULL, NULL, 177263),
(177264, '1.10.20.10-FF-000351', NULL, NULL, 93, NULL, NULL, 177264),
(177265, '3.30.430.20-FF-000019', NULL, 'Cysteine-rich repeat secretory protein 15', 86, NULL, NULL, 177265),
(177266, '1.10.3170.10-FF-000013', NULL, 'RecBCD enzyme subunit RecB', 203, NULL, NULL, 177266),
(177267, '1.10.8.60-FF-000420', NULL, 'AaceriADL303Cp', 62, NULL, NULL, 177267),
(177268, '2.60.260.20-FF-000166', NULL, 'Uncharacterized protein', 52, NULL, NULL, 177268),
(177269, '2.130.10.10-FF-005030', NULL, 'Uncharacterized protein', 303, NULL, NULL, 177269),
(177270, '2.60.40.790-FF-000155', NULL, NULL, 77, NULL, NULL, 177270),
(177271, '3.90.550.10-FF-000714', NULL, 'Uncharacterized protein', 266, NULL, NULL, 177271),
(177272, '2.20.200.10-FF-000005', NULL, 'Multidrug resistance protein, putative', 83, NULL, NULL, 177272),
(177273, '3.30.750.24-FF-000099', NULL, 'Anion transporter SULP-2', 139, NULL, NULL, 177273),
(177274, '3.30.200.20-FF-002251', NULL, 'CMGC family protein kinase', 20, NULL, NULL, 177274),
(177275, '3.60.10.10-FF-000040', NULL, 'Inositol polyphosphate 5-phosphatase, putative', 343, NULL, NULL, 177275),
(177276, '1.10.3550.10-FF-000003', NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase-like protein', 141, NULL, NULL, 177276),
(177277, '1.25.10.10-FF-000266', NULL, 'mRNA transport regulator MTR10', 934, NULL, NULL, 177277),
(177278, '1.10.418.20-FF-000025', NULL, 'Sentrin-specific protease 2', 46, NULL, NULL, 177278),
(177279, '3.40.50.300-FF-000741', NULL, 'Putative mitochondrial dynamin GTPase', 351, NULL, NULL, 177279),
(177280, '2.60.40.1730-FF-000013', NULL, 'Aminopeptidase', 215, NULL, NULL, 177280),
(177281, '3.40.50.410-FF-000010', NULL, 'Integrator complex subunit 6 like', 222, NULL, NULL, 177281),
(177282, '2.60.120.1220-FF-000001', NULL, 'Surface-associated protein', 290, NULL, NULL, 177282),
(177283, '1.10.20.10-FF-000199', NULL, NULL, 128, NULL, NULL, 177283),
(177284, '3.10.50.40-FF-000019', NULL, 'Trigger factor', 93, NULL, NULL, 177284),
(177285, '1.25.10.10-FF-001194', NULL, 'Armadillo/beta-catenin repeat-like', 161, NULL, NULL, 177285);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(177286, '2.60.40.790-FF-000008', NULL, 'Alpha-crystallin A chain', 127, NULL, NULL, 177286),
(177287, '3.30.160.40-FF-000021', NULL, 'Probable porphobilinogen deaminase', 81, NULL, NULL, 177287),
(177288, '2.10.110.10-FF-000170', NULL, 'LIM domain-containing protein B', 61, NULL, NULL, 177288),
(177289, '1.25.40.10-FF-002331', NULL, 'Pentatricopeptide repeat-containing protein', 218, NULL, NULL, 177289),
(177290, '3.30.70.330-FF-003044', NULL, NULL, 122, NULL, NULL, 177290),
(177291, '1.20.140.10-FF-000077', NULL, 'Putative acyl-CoA dehydrogenase', 174, NULL, NULL, 177291),
(177292, '1.10.287.2250-FF-000002', NULL, 'Cysteine proteinase falcipain 2a', 83, NULL, NULL, 177292),
(177293, '1.10.287.470-FF-000001', NULL, 'Disks large 1 isoform X3', 51, NULL, NULL, 177293),
(177294, '2.60.40.10-FF-000903', NULL, 'obscurin isoform X6', 87, NULL, NULL, 177294),
(177295, '3.40.50.11610-FF-000035', NULL, NULL, 112, NULL, NULL, 177295),
(177296, '3.50.50.60-FF-000237', NULL, 'FAD dependent oxidoreductase', 123, NULL, NULL, 177296),
(177297, '3.40.50.1820-FF-001117', NULL, 'Acetylcholinesterase', 318, NULL, NULL, 177297),
(177298, '3.30.505.10-FF-000213', NULL, NULL, 110, NULL, NULL, 177298),
(177299, '3.40.50.300-FF-001141', NULL, 'DNA helicase', 366, NULL, NULL, 177299),
(177300, '3.30.2160.10-FF-000017', NULL, 'Putative ubiquitin-protein ligase', 42, NULL, NULL, 177300),
(177301, '3.40.1110.10-FF-000057', NULL, 'Cation-transporting ATPase', 114, NULL, NULL, 177301),
(177302, '1.25.40.10-FF-001931', NULL, 'TPR-containing protein DDB_G0280363', 148, NULL, NULL, 177302),
(177303, '3.40.50.300-FF-005412', NULL, 'ATP-dependent DNA helicase', 207, NULL, NULL, 177303),
(177304, '3.10.290.10-FF-000060', NULL, 'Pseudouridine synthase', 69, NULL, NULL, 177304),
(177305, '3.30.428.10-FF-000073', NULL, 'Uncharacterized protein', 211, NULL, NULL, 177305),
(177306, '1.10.8.500-FF-000012', NULL, 'Hybrid signal transduction histidine kinase J', 55, NULL, NULL, 177306),
(177307, '3.40.50.2300-FF-000941', NULL, NULL, 167, NULL, NULL, 177307),
(177308, '2.170.150.10-FF-000033', NULL, 'Predicted protein', 151, NULL, NULL, 177308),
(177309, '2.30.30.140-FF-000341', NULL, 'SAGA complex associated factor 29', 38, NULL, NULL, 177309),
(177310, '3.40.50.720-FF-000131', NULL, 'Short-chain dehydrogenase/reductase 3', 266, NULL, NULL, 177310),
(177311, '1.10.275.10-FF-000010', NULL, 'Adenylosuccinate lyase', 120, NULL, NULL, 177311),
(177312, '2.40.170.20-FF-000113', NULL, 'SusC homolog', 609, NULL, NULL, 177312),
(177313, '1.25.10.10-FF-001542', NULL, 'Uncharacterized protein', 888, NULL, NULL, 177313),
(177314, '3.40.640.10-FF-000007', NULL, 'glycine dehydrogenase (Decarboxylating), mitochondrial', 234, NULL, NULL, 177314),
(177315, '3.20.180.20-FF-000002', NULL, 'Cytoplasmic dynein heavy chain 1', 97, NULL, NULL, 177315),
(177316, '3.50.50.60-FF-001221', NULL, 'Thiamine thiazole synthase', 258, NULL, NULL, 177316),
(177317, '1.10.3210.10-FF-000129', NULL, 'Predicted protein', 62, NULL, NULL, 177317),
(177318, '2.60.40.1860-FF-000001', NULL, 'Protein-arginine deiminase type-2', 119, NULL, NULL, 177318),
(177319, '3.30.830.10-FF-000215', NULL, 'Insulin degrading enzyme', 224, NULL, NULL, 177319),
(177320, '1.25.40.10-FF-001398', NULL, 'Pentatricopeptide repeat-containing protein', 174, NULL, NULL, 177320),
(177321, '1.25.10.10-FF-000614', NULL, 'RING-type E3 ubiquitin transferase', 158, NULL, NULL, 177321),
(177322, '2.130.10.10-FF-003377', NULL, 'Protein tipD', 149, NULL, NULL, 177322),
(177323, '2.130.10.10-FF-005406', NULL, 'Kinesin family member 21A', 143, NULL, NULL, 177323),
(177324, '3.90.650.10-FF-000042', NULL, 'Probable phosphoribosylformylglycinamidine synthase', 191, NULL, NULL, 177324),
(177325, '3.30.40.10-FF-000223', NULL, 'Mitogen-activated protein kinase kinase kinase 1 (Predicted)', 95, NULL, NULL, 177325),
(177326, '3.90.70.10-FF-000418', NULL, 'Ubiquitin C-terminal hydrolase, putative (AFU_orthologue AFUA_2G08440)', 138, NULL, NULL, 177326),
(177327, '3.40.640.10-FF-000154', NULL, 'Aminotransferase, class V', 246, NULL, NULL, 177327);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(177328, '1.10.510.10-FF-000698', NULL, 'Serine/threonine-protein kinase tousled-like 1', 293, NULL, NULL, 177328),
(177329, '2.130.10.10-FF-000651', NULL, 'RaBConnectin related', 184, NULL, NULL, 177329),
(177330, '1.10.390.10-FF-000114', NULL, 'Uncharacterized protein', 144, NULL, NULL, 177330),
(177331, '1.10.510.10-FF-002120', NULL, 'Protein kinase, putative', 177, NULL, NULL, 177331),
(177332, '4.10.280.10-FF-000140', NULL, 'High-copy mep suppressor', 78, NULL, NULL, 177332),
(177333, '1.10.20.10-FF-000204', NULL, NULL, 93, NULL, NULL, 177333),
(177334, '2.130.10.10-FF-004389', NULL, 'Uncharacterized protein', 66, NULL, NULL, 177334),
(177335, '3.30.200.20-FF-001290', NULL, 'Spore coat, CotS family protein', 107, NULL, NULL, 177335),
(177336, '3.40.50.300-FF-008285', NULL, 'Uncharacterized protein', 32, NULL, NULL, 177336),
(177337, '2.40.30.10-FF-000100', NULL, 'NADPH--cytochrome P450 reductase', 56, NULL, NULL, 177337),
(177338, '3.30.450.20-FF-000021', NULL, 'Neuronal PAS domain-containing protein 3', 151, NULL, NULL, 177338),
(177339, '2.130.10.10-FF-001663', NULL, 'GG22837', 274, NULL, NULL, 177339),
(177340, '1.20.58.1210-FF-000018', NULL, 'Uncharacterized protein', 78, NULL, NULL, 177340),
(177341, '1.25.40.180-FF-000308', NULL, NULL, 311, NULL, NULL, 177341),
(177342, '2.60.120.290-FF-000025', NULL, 'Seizure related 6 homolog', 117, NULL, NULL, 177342),
(177343, '2.60.40.10-FF-003776', NULL, NULL, 95, NULL, NULL, 177343),
(177344, '3.90.780.10-FF-000046', NULL, '5''-nucleotidase', 197, NULL, NULL, 177344),
(177345, '1.20.58.240-FF-000009', NULL, 'Signal transducer and activator of transcription B', 115, NULL, NULL, 177345),
(177346, '3.40.50.300-FF-005064', NULL, 'ADP ribosylation factor like GTPase 8A', 135, NULL, NULL, 177346),
(177347, '3.40.640.10-FF-000502', NULL, 'Aminotransferase, conjectural', 111, NULL, NULL, 177347),
(177348, '3.40.50.10190-FF-000289', NULL, 'DNA ligase 4', 96, NULL, NULL, 177348),
(177349, '3.60.40.10-FF-000244', NULL, 'Uncharacterized protein', 165, NULL, NULL, 177349),
(177350, '3.50.50.60-FF-000996', NULL, 'Predicted protein', 395, NULL, NULL, 177350),
(177351, '1.10.510.10-FF-002643', NULL, NULL, 109, NULL, NULL, 177351),
(177352, '2.160.20.10-FF-000021', NULL, 'SHC binding and spindle associated 1 like', 253, NULL, NULL, 177352),
(177353, '3.30.300.30-FF-000108', NULL, 'Phenyloxazoline synthase MbtB (Mycobactin synthetaseprotein B)', 97, NULL, NULL, 177353),
(177354, '1.10.510.10-FF-001631', NULL, 'Uncharacterized protein', 315, NULL, NULL, 177354),
(177355, '3.30.160.60-FF-005586', NULL, NULL, 79, NULL, NULL, 177355),
(177356, '1.10.287.210-FF-000007', NULL, 'O-antigen chain length determinant', 107, NULL, NULL, 177356),
(177357, '3.40.1410.10-FF-000046', NULL, 'Putative GntR-family transcriptional regulator', 146, NULL, NULL, 177357),
(177358, '3.40.50.150-FF-000235', NULL, 'Protein-L-isoaspartate O-methyltransferase', 221, NULL, NULL, 177358),
(177359, '1.20.1280.50-FF-000233', NULL, 'Predicted protein', 87, NULL, NULL, 177359),
(177360, '3.10.100.10-FF-000103', NULL, 'Uncharacterized protein', 134, NULL, NULL, 177360),
(177361, '3.30.50.10-FF-000021', NULL, 'bile acid receptor isoform X2', 108, NULL, NULL, 177361),
(177362, '3.30.40.10-FF-001684', NULL, 'Uncharacterized protein', 73, NULL, NULL, 177362),
(177363, '1.25.40.20-FF-000299', NULL, 'Ankyrin repeat and KH domain-containing 1', 103, NULL, NULL, 177363),
(177364, '3.90.1170.10-FF-000010', NULL, '60S ribosomal protein L16, mitochondrial', 195, NULL, NULL, 177364),
(177365, '1.10.555.10-FF-000048', NULL, 'CHN2 isoform 6', 59, NULL, NULL, 177365),
(177366, '3.30.160.60-FF-002860', NULL, 'Zinc finger imprinted 2', 37, NULL, NULL, 177366),
(177367, '1.10.472.10-FF-000333', NULL, 'TFIIH complex kinase subunit', 103, NULL, NULL, 177367),
(177368, '3.40.395.10-FF-000021', NULL, 'Clan CE, family C48, Ulp1-like cysteine peptidase', 212, NULL, NULL, 177368),
(177369, '3.40.190.170-FF-000018', NULL, 'Predicted protein', 240, NULL, NULL, 177369),
(177370, '1.10.510.10-FF-004357', NULL, NULL, 114, NULL, NULL, 177370);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(177371, '3.30.1050.10-FF-000037', NULL, 'Uncharacterized protein', 143, NULL, NULL, 177371),
(177372, '1.10.10.10-FF-000406', NULL, 'DNA-binding transcriptional LysR family regulator', 86, NULL, NULL, 177372),
(177373, '2.40.10.480-FF-000004', NULL, 'Cell surface protein', 68, NULL, NULL, 177373),
(177374, '3.40.50.2000-FF-000677', NULL, 'Glycosyltransferase', 198, NULL, NULL, 177374),
(177375, '1.25.50.20-FF-000069', NULL, 'Protease m1 zinc metalloprotease, putative', 323, NULL, NULL, 177375),
(177376, '2.10.25.10-FF-000005', NULL, 'Fibrillin 2', 85, NULL, NULL, 177376),
(177377, '2.120.10.30-FF-000034', NULL, 'E3 ubiquitin-protein ligase TRIM32', 106, NULL, NULL, 177377),
(177378, '3.30.1330.20-FF-000028', NULL, 'Tubulin gamma chain', 107, NULL, NULL, 177378),
(177379, '3.30.160.60-FF-002388', NULL, 'Uncharacterized protein, isoform B', 31, NULL, NULL, 177379),
(177380, '2.40.70.10-FF-000277', NULL, 'Eukaryotic aspartyl protease family protein', 193, NULL, NULL, 177380),
(177381, '1.25.40.570-FF-000015', NULL, '26S proteasome regulatory subunit RPN6', 242, NULL, NULL, 177381),
(177382, '2.10.25.10-FF-000477', NULL, 'Stabilin 2', 50, NULL, NULL, 177382),
(177383, '2.130.10.10-FF-004102', NULL, 'AGAP009862-PA', 196, NULL, NULL, 177383),
(177384, '3.40.50.300-FF-004395', NULL, 'Ras-related protein RACG putative', 197, NULL, NULL, 177384),
(177385, '2.40.100.10-FF-000162', NULL, 'Peptidyl-prolyl cis-trans isomerase', 87, NULL, NULL, 177385),
(177386, '3.40.50.300-FF-003411', NULL, 'Ciliary dynein heavy chain 11', 173, NULL, NULL, 177386),
(177387, '1.20.1560.10-FF-000675', NULL, 'Uncharacterized protein', 26, NULL, NULL, 177387),
(177388, '1.10.150.530-FF-000020', NULL, 'Probable dual-specificity RNA methyltransferase RlmN', 75, NULL, NULL, 177388),
(177389, '1.10.287.600-FF-000001', NULL, 'Tubulin alpha chain', 53, NULL, NULL, 177389),
(177390, '2.60.40.150-FF-000194', NULL, 'Phosphatidylserine decarboxylase proenzyme 2', 115, NULL, NULL, 177390),
(177391, '3.40.50.720-FF-001851', NULL, 'Malate dehydrogenase 1B', 154, NULL, NULL, 177391),
(177392, '2.170.220.10-FF-000005', NULL, NULL, 66, NULL, NULL, 177392),
(177393, '3.40.50.300-FF-003883', NULL, 'Protein CBG01915', 69, NULL, NULL, 177393),
(177394, '1.25.40.20-FF-001732', NULL, 'Poly [ADP-ribose] polymerase', 223, NULL, NULL, 177394),
(177395, '3.30.70.330-FF-001190', NULL, 'Related to NSR1-nuclear localization sequence binding protein', 97, NULL, NULL, 177395),
(177396, '1.10.443.20-FF-000005', NULL, 'Uncharacterized protein', 364, NULL, NULL, 177396),
(177397, '1.10.3290.20-FF-000002', NULL, NULL, 120, NULL, NULL, 177397),
(177398, '1.20.1560.10-FF-000203', NULL, 'Probable ''component linked with the assembly of cytochrome'' transport transmembrane ATP-binding protein ABC transporter CydC', 306, NULL, NULL, 177398),
(177399, '3.30.40.10-FF-000700', NULL, 'E3 ubiquitin-protein ligase RNF213 isoform X2', 87, NULL, NULL, 177399),
(177400, '2.30.110.50-FF-000002', NULL, 'Actin cross-linking toxin VgrG1', 157, NULL, NULL, 177400),
(177401, '1.20.120.50-FF-000003', NULL, 'Metal-binding diguanylate cyclase (GGDEF) domain protein', 135, NULL, NULL, 177401),
(177402, '3.30.60.90-FF-000028', NULL, 'Unplaced genomic scaffold supercont1.170, whole genome shotgun sequence', 53, NULL, NULL, 177402),
(177403, '3.30.390.50-FF-000007', NULL, 'Lipoate-protein ligase 1', 85, NULL, NULL, 177403),
(177404, '3.40.50.300-FF-008138', NULL, 'Uncharacterized protein', 98, NULL, NULL, 177404),
(177405, '3.90.550.10-FF-000478', NULL, 'Alpha-L-glycero-D-manno-heptose beta-1,4-glucosyltransferase', 206, NULL, NULL, 177405),
(177406, '3.90.70.10-FF-000093', NULL, 'Ubiquitin carboxyl-terminal hydrolase, putative', 423, NULL, NULL, 177406),
(177407, '3.90.640.10-FF-000069', NULL, 'Actin-related protein 6', 92, NULL, NULL, 177407),
(177408, '1.25.10.10-FF-002211', NULL, 'Uncharacterized protein', 1062, NULL, NULL, 177408),
(177409, '2.30.30.90-FF-000006', NULL, 'Iron dependent repressor', 73, NULL, NULL, 177409),
(177410, '1.10.10.60-FF-000455', NULL, 'Transcription factor MYB1', 51, NULL, NULL, 177410);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(177411, '2.40.50.700-FF-000011', NULL, NULL, 79, NULL, NULL, 177411),
(177412, '1.10.240.10-FF-000014', NULL, 'Tryptophanyl-tRNA synthetase, cytoplasmic, putative', 112, NULL, NULL, 177412),
(177413, '1.50.10.160-FF-000011', NULL, '(E,E)-geranyllinalool synthase', 230, NULL, NULL, 177413),
(177414, '3.10.150.10-FF-000022', NULL, 'Beta sliding clamp', 175, NULL, NULL, 177414),
(177415, '3.30.470.20-FF-000089', NULL, 'Dur1,2p', 451, NULL, NULL, 177415),
(177416, '3.40.50.300-FF-007626', NULL, 'Uncharacterized protein', 147, NULL, NULL, 177416),
(177417, '3.40.50.11380-FF-000011', NULL, NULL, 40, NULL, NULL, 177417),
(177418, '3.30.70.2850-FF-000029', NULL, 'Predicted protein', 199, NULL, NULL, 177418),
(177419, '2.10.70.10-FF-000109', NULL, 'Coagulation factor XIII B chain', 57, NULL, NULL, 177419),
(177420, '3.20.20.140-FF-000023', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 300, NULL, NULL, 177420),
(177421, '2.120.10.30-FF-000562', NULL, 'Uncharacterized protein', 68, NULL, NULL, 177421),
(177422, '3.40.50.150-FF-001399', NULL, NULL, 167, NULL, NULL, 177422),
(177423, '1.25.40.10-FF-003820', NULL, 'Uncharacterized protein', 131, NULL, NULL, 177423),
(177424, '2.130.10.10-FF-005086', NULL, 'Uncharacterized protein', 262, NULL, NULL, 177424),
(177425, '3.40.50.2000-FF-000733', NULL, 'Lipid-A-disaccharide synthase', 23, NULL, NULL, 177425),
(177426, '2.170.140.10-FF-000004', NULL, 'Chitinase 5', 64, NULL, NULL, 177426),
(177427, '3.80.10.10-FF-000758', NULL, 'Uncharacterized protein, isoform A', 231, NULL, NULL, 177427),
(177428, '2.130.10.10-FF-000735', NULL, 'Quinoprotein amine dehydrogenase beta chain-like', 299, NULL, NULL, 177428),
(177429, '3.40.50.150-FF-001455', NULL, NULL, 139, NULL, NULL, 177429),
(177430, '2.20.28.10-FF-000017', NULL, 'Uncharacterized protein, isoform A', 47, NULL, NULL, 177430),
(177431, '3.30.420.10-FF-000752', NULL, NULL, 135, NULL, NULL, 177431),
(177432, '3.30.70.920-FF-000012', NULL, 'AsnC family transcriptional regulator', 85, NULL, NULL, 177432),
(177433, '3.30.160.20-FF-000190', NULL, 'Ribonuclease III domain-containing protein', 92, NULL, NULL, 177433),
(177434, '3.10.450.50-FF-000079', NULL, 'Uncharacterized protein', 130, NULL, NULL, 177434),
(177435, '4.10.240.10-FF-000194', NULL, 'Transcription activator of gluconeogenesis ERT1', 32, NULL, NULL, 177435),
(177436, '3.40.50.10800-FF-000011', NULL, 'Quinolinate synthase A', 90, NULL, NULL, 177436),
(177437, '2.30.39.10-FF-000053', NULL, 'Serpin-2 precursor, putative', 131, NULL, NULL, 177437),
(177438, '3.60.15.10-FF-000231', NULL, 'Zinc metallohydrolase, glyoxalase II family', 261, NULL, NULL, 177438),
(177439, '2.170.120.20-FF-000006', NULL, 'Ribosomal protein L25/Gln-tRNA synthetase, anti-codon-binding domain-containing protein', 86, NULL, NULL, 177439),
(177440, '2.30.40.10-FF-000118', NULL, 'Putative dihydroorotase', 96, NULL, NULL, 177440),
(177441, '1.10.8.60-FF-000448', NULL, 'Lon protease homolog, mitochondrial', 112, NULL, NULL, 177441),
(177442, '3.40.50.300-FF-001702', NULL, 'Transcriptional regulator, LuxR family', 154, NULL, NULL, 177442),
(177443, '3.40.850.10-FF-000400', NULL, 'Uncharacterized protein', 271, NULL, NULL, 177443),
(177444, '1.10.10.60-FF-000016', NULL, 'Transcriptional activator Myb isoform A', 53, NULL, NULL, 177444),
(177445, '3.40.50.300-FF-005120', NULL, 'ABC transporter ATP-binding protein', 250, NULL, NULL, 177445),
(177446, '1.10.3210.10-FF-000040', NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase-like protein', 187, NULL, NULL, 177446),
(177447, '3.40.190.10-FF-000517', NULL, 'Phosphate binding protein', 118, NULL, NULL, 177447),
(177448, '2.10.90.10-FF-000167', NULL, 'Uncharacterized protein', 102, NULL, NULL, 177448),
(177449, '3.40.120.10-FF-000098', NULL, 'Uncharacterized protein', 115, NULL, NULL, 177449),
(177450, '3.10.20.410-FF-000005', NULL, 'Putative fimbrial outer membrane usher', 120, NULL, NULL, 177450),
(177451, '3.30.2350.20-FF-000029', NULL, 'Pseudouridine_synthase_TruD_-_putative', 114, NULL, NULL, 177451),
(177452, '1.10.10.10-FF-002087', NULL, 'Uncharacterized protein', 72, NULL, NULL, 177452);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(177453, '3.30.160.60-FF-006283', NULL, NULL, 50, NULL, NULL, 177453),
(177454, '1.25.10.10-FF-003195', NULL, 'Serine/threonine-protein kinase TOR', 300, NULL, NULL, 177454),
(177455, '3.30.1240.10-FF-000052', NULL, 'Putative phosphatase YxeH', 107, NULL, NULL, 177455),
(177456, '1.10.238.10-FF-000273', NULL, 'troponin C', 65, NULL, NULL, 177456),
(177457, '2.40.170.20-FF-000057', NULL, 'Ferripyoverdine receptor', 543, NULL, NULL, 177457),
(177458, '1.10.10.10-FF-001103', NULL, 'Rrf2 family transcriptional regulator', 139, NULL, NULL, 177458),
(177459, '1.10.510.10-FF-000934', NULL, 'Serine/threonine protein kinase', 275, NULL, NULL, 177459),
(177460, '2.60.40.60-FF-000401', NULL, 'AGAP009716-PA', 69, NULL, NULL, 177460),
(177461, '3.30.160.60-FF-001932', NULL, 'Zinc finger protein 76', 32, NULL, NULL, 177461),
(177462, '2.60.40.10-FF-001011', NULL, 'leukemia inhibitory factor receptor', 82, NULL, NULL, 177462),
(177463, '3.30.200.20-FF-001851', NULL, 'Protein kinase, putative', 106, NULL, NULL, 177463),
(177464, '3.40.80.10-FF-000028', NULL, 'Amidase', 159, NULL, NULL, 177464),
(177465, '3.80.10.10-FF-002523', NULL, 'Probable inactive serine/threonine-protein kinase roco10', 358, NULL, NULL, 177465),
(177466, '3.30.1110.10-FF-000008', NULL, 'Adenosine kinase-like Protein', 64, NULL, NULL, 177466),
(177467, '2.30.29.30-FF-000997', NULL, 'Uncharacterized protein', 131, NULL, NULL, 177467),
(177468, '3.40.50.2300-FF-000177', NULL, 'DNA-binding response regulator', 80, NULL, NULL, 177468),
(177469, '3.30.160.60-FF-004153', NULL, NULL, 26, NULL, NULL, 177469),
(177470, '1.20.1250.20-FF-001178', NULL, 'Jen2p', 205, NULL, NULL, 177470),
(177471, '2.60.40.10-FF-004029', NULL, NULL, 98, NULL, NULL, 177471),
(177472, '2.40.70.10-FF-000333', NULL, NULL, 216, NULL, NULL, 177472),
(177473, '1.10.3120.10-FF-000010', NULL, 'Trigger factor', 213, NULL, NULL, 177473),
(177474, '3.40.50.10810-FF-000071', NULL, 'SNF2 domain-containing protein / helicase domain-containing protein / zinc finger protein-like protein', 90, NULL, NULL, 177474),
(177475, '3.30.300.150-FF-000008', NULL, NULL, 121, NULL, NULL, 177475),
(177476, '1.10.1200.10-FF-000044', NULL, '10-formyltetrahydrofolate dehydrogenase', 78, NULL, NULL, 177476),
(177477, '1.10.10.1730-FF-000002', NULL, 'Blast:Folliculin', 76, NULL, NULL, 177477),
(177478, '1.20.120.540-FF-000003', NULL, 'Cyclic nucleotide-gated potassium channel mll3241', 125, NULL, NULL, 177478),
(177479, '3.30.200.20-FF-001795', NULL, 'Cyclin T-dependent kinase CDK9, putative', 100, NULL, NULL, 177479),
(177480, '3.40.50.300-FF-006340', NULL, 'Dicer-like ribonuclease with helicase and Rnase III domains', 242, NULL, NULL, 177480),
(177481, '3.40.50.1820-FF-001533', NULL, 'Os06g0520000 protein', 141, NULL, NULL, 177481),
(177482, '3.90.1150.10-FF-000008', NULL, 'Cystathionine gamma-synthase', 134, NULL, NULL, 177482),
(177483, '3.30.2350.10-FF-000083', NULL, 'RNA pseudouridylate synthase protein, putative', 231, NULL, NULL, 177483),
(177484, '3.40.850.10-FF-000080', NULL, 'Kinesin-like protein', 367, NULL, NULL, 177484),
(177485, '1.10.510.10-FF-001007', NULL, 'Hal5p', 268, NULL, NULL, 177485),
(177486, '2.60.40.1180-FF-000011', NULL, 'Alpha-L-arabinofuranosidase 1', 119, NULL, NULL, 177486),
(177487, '2.40.40.20-FF-000042', NULL, 'Molybdopterin guanine dinucleotide-containing S/N-oxide reductase', 159, NULL, NULL, 177487),
(177488, '1.25.10.10-FF-000322', NULL, 'U-box domain-containing protein 4', 142, NULL, NULL, 177488),
(177489, '1.20.1720.10-FF-000025', NULL, 'Major facilitator superfamily MFS_1', 207, NULL, NULL, 177489),
(177490, '1.10.472.10-FF-000625', NULL, 'Uncharacterized protein', 123, NULL, NULL, 177490),
(177491, '1.25.40.10-FF-001875', NULL, 'Uncharacterized protein', 175, NULL, NULL, 177491),
(177492, '2.30.31.10-FF-000024', NULL, 'Uncharacterized protein', 72, NULL, NULL, 177492),
(177493, '3.30.300.130-FF-000002', NULL, 'Fe/S biogenesis protein NfuA', 88, NULL, NULL, 177493),
(177494, '1.20.1070.10-FF-000823', NULL, 'KISS1R isoform 3', 52, NULL, NULL, 177494),
(177495, '2.40.20.10-FF-000089', NULL, 'HGF/MSP/plasminogen-like protein', 98, NULL, NULL, 177495);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(177496, '1.10.150.20-FF-000044', NULL, 'DnaJ protein ERDJ2A', 60, NULL, NULL, 177496),
(177497, '2.70.150.10-FF-000158', NULL, 'Calcium-transporting ATPase', 144, NULL, NULL, 177497),
(177498, '3.40.50.1010-FF-000099', NULL, 'DNA polymerase I', 175, NULL, NULL, 177498),
(177499, '1.20.120.1910-FF-000028', NULL, 'Cysteine--tRNA ligase', 189, NULL, NULL, 177499),
(177500, '1.20.5.340-FF-000124', NULL, 'Uncharacterized protein', 58, NULL, NULL, 177500),
(177501, '3.20.20.80-FF-000602', NULL, 'Os03g0600600 protein', 188, NULL, NULL, 177501),
(177502, '1.20.120.1900-FF-000082', NULL, 'Gamma-tubulin complex component', 188, NULL, NULL, 177502),
(177503, '2.60.120.200-FF-000274', NULL, 'Uip5p', 270, NULL, NULL, 177503),
(177504, '3.60.21.10-FF-000357', NULL, 'Uncharacterized protein', 147, NULL, NULL, 177504),
(177505, '3.30.160.60-FF-000499', NULL, 'ZXD family zinc finger C', 26, NULL, NULL, 177505),
(177506, '3.40.50.300-FF-004715', NULL, 'ADP-ribosylation factor-like protein 5', 96, NULL, NULL, 177506),
(177507, '1.10.486.10-FF-000039', NULL, 'UvrD/REP helicase N-terminal domain protein', 136, NULL, NULL, 177507),
(177508, '3.40.50.150-FF-000151', NULL, 'Methyltransferase-like protein', 202, NULL, NULL, 177508),
(177509, '1.10.510.10-FF-001715', NULL, 'Probable cyclin-dependent kinase 9', 256, NULL, NULL, 177509),
(177510, '3.40.309.10-FF-000064', NULL, 'Uncharacterized protein', 60, NULL, NULL, 177510),
(177511, '1.20.120.560-FF-000009', NULL, 'BRO1-like domain/ALIX V-shaped domain binding to HIV, putative', 150, NULL, NULL, 177511),
(177512, '1.20.1250.20-FF-001650', NULL, 'Putative glucose transporter rco-3', 471, NULL, NULL, 177512),
(177513, '1.20.120.350-FF-000244', NULL, NULL, 124, NULL, NULL, 177513),
(177514, '3.50.50.60-FF-001018', NULL, 'Rab proteins geranylgeranyltransferase component A', 149, NULL, NULL, 177514),
(177515, '1.20.1640.10-FF-000024', NULL, 'Multifunctional fusion protein', 200, NULL, NULL, 177515),
(177516, '2.40.10.10-FF-000537', NULL, NULL, 93, NULL, NULL, 177516),
(177517, '3.30.1640.10-FF-000037', NULL, 'DNA helicase', 100, NULL, NULL, 177517),
(177518, '1.20.1260.60-FF-000004', NULL, 'Increased Sodium Tolerance Related', 191, NULL, NULL, 177518),
(177519, '3.40.1370.10-FF-000019', NULL, '50S ribosomal protein L4', 220, NULL, NULL, 177519),
(177520, '3.40.50.720-FF-001564', NULL, 'E1 ubiquitin-activating protein', 389, NULL, NULL, 177520),
(177521, '3.30.420.210-FF-000002', NULL, 'UBX domain-containing protein 1', 63, NULL, NULL, 177521),
(177522, '3.60.20.10-FF-000158', NULL, NULL, 149, NULL, NULL, 177522),
(177523, '3.30.70.100-FF-000154', NULL, NULL, 115, NULL, NULL, 177523),
(177524, '3.30.200.20-FF-001087', NULL, 'Protein kinase domain containing protein', 87, NULL, NULL, 177524),
(177525, '3.40.50.300-FF-005917', NULL, 'ABC multidrug transporter, putative', 237, NULL, NULL, 177525),
(177526, '2.60.40.10-FF-004181', NULL, NULL, 85, NULL, NULL, 177526),
(177527, '3.30.70.890-FF-000076', NULL, 'Predicted protein', 191, NULL, NULL, 177527),
(177528, '2.30.30.380-FF-000065', NULL, 'Nei like DNA glycosylase 3', 44, NULL, NULL, 177528),
(177529, '3.40.640.10-FF-000210', NULL, 'Aminotransferase', 240, NULL, NULL, 177529),
(177530, '1.20.140.100-FF-000022', NULL, 'Dynein heavy chain', 161, NULL, NULL, 177530),
(177531, '3.40.50.300-FF-006901', NULL, 'Branched-chain amino acid ABC transporter, ATP-binding protein', 239, NULL, NULL, 177531),
(177532, '3.40.47.10-FF-000204', NULL, NULL, 206, NULL, NULL, 177532),
(177533, '1.20.5.190-FF-000113', NULL, NULL, 37, NULL, NULL, 177533),
(177534, '3.30.160.60-FF-004097', NULL, NULL, 23, NULL, NULL, 177534),
(177535, '3.30.1540.20-FF-000038', NULL, NULL, 70, NULL, NULL, 177535),
(177536, '3.40.50.150-FF-000527', NULL, 'Unplaced genomic scaffold supercont2.5, whole genome shotgun sequence', 256, NULL, NULL, 177536),
(177537, '1.25.40.10-FF-003112', NULL, 'Developmental protein', 309, NULL, NULL, 177537),
(177538, '2.130.10.10-FF-005850', NULL, 'Predicted protein', 334, NULL, NULL, 177538),
(177539, '3.30.420.40-FF-000351', NULL, 'Heat shock cognate 70 kDa protein 2', 16, NULL, NULL, 177539);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(177540, '2.10.25.10-FF-001641', NULL, 'Matrilin 3b', 48, NULL, NULL, 177540),
(177541, '3.30.160.60-FF-005878', NULL, NULL, 40, NULL, NULL, 177541),
(177542, '2.70.150.10-FF-000102', NULL, 'Phospholipid-transporting ATPase', 135, NULL, NULL, 177542),
(177543, '1.10.10.10-FF-001575', NULL, 'Transcriptional regulator, FUR family', 80, NULL, NULL, 177543),
(177544, '3.30.160.60-FF-003697', NULL, 'Zinc finger protein 142', 58, NULL, NULL, 177544),
(177545, '1.10.437.10-FF-000055', NULL, 'BCL2 associated X, apoptosis regulator', 97, NULL, NULL, 177545),
(177546, '3.40.630.30-FF-000395', NULL, 'Histone acetyltransferase type B catalytic subunit', 140, NULL, NULL, 177546),
(177547, '1.25.10.10-FF-002470', NULL, 'Predicted protein', 216, NULL, NULL, 177547),
(177548, '1.10.630.10-FF-000830', NULL, 'Uncharacterized protein', 207, NULL, NULL, 177548),
(177549, '1.10.8.60-FF-000184', NULL, 'Lon protease homolog, mitochondrial', 91, NULL, NULL, 177549),
(177550, '3.30.1490.190-FF-000014', NULL, 'Ferric uptake regulation protein', 61, NULL, NULL, 177550),
(177551, '2.60.120.650-FF-000004', NULL, 'Putative lysine-specific demethylase 3B', 349, NULL, NULL, 177551),
(177552, '3.30.1490.20-FF-000101', NULL, 'Predicted protein', 70, NULL, NULL, 177552),
(177553, '3.90.226.10-FF-000152', NULL, 'Glutaconyl-CoA decarboxylase subunit alpha', 298, NULL, NULL, 177553),
(177554, '3.40.50.300-FF-000972', NULL, 'Uncharacterized protein, isoform K', 175, NULL, NULL, 177554),
(177555, '1.10.8.60-FF-000504', NULL, 'Katanin p60 ATPase-containing subunit A-like 2', 67, NULL, NULL, 177555),
(177556, '3.10.20.90-FF-000364', NULL, 'Unplaced genomic scaffold supercont1.163, whole genome shotgun sequence', 84, NULL, NULL, 177556),
(177557, '3.10.110.10-FF-000132', NULL, 'Ubiquitin-conjugating enzyme E2-17 kDa 3', 147, NULL, NULL, 177557),
(177558, '1.20.1310.10-FF-000067', NULL, 'Cul3p', 126, NULL, NULL, 177558),
(177559, '1.20.5.1500-FF-000010', NULL, 'AGAP002712-PA', 47, NULL, NULL, 177559),
(177560, '1.25.40.10-FF-000094', NULL, 'telomerase-binding protein EST1A isoform X1', 230, NULL, NULL, 177560),
(177561, '2.60.40.10-FF-000286', NULL, 'Myosin binding protein C, slow type', 96, NULL, NULL, 177561),
(177562, '1.10.1450.10-FF-000091', NULL, 'Tetraspanin', 101, NULL, NULL, 177562),
(177563, '1.10.10.1540-FF-000007', NULL, 'Uncharacterized protein', 51, NULL, NULL, 177563),
(177564, '3.40.50.300-FF-002630', NULL, 'ATP-dependent kinase YFH7', 353, NULL, NULL, 177564),
(177565, '2.130.10.10-FF-000207', NULL, 'Cilia- and flagella-associated protein 52', 118, NULL, NULL, 177565),
(177566, '3.30.420.40-FF-000912', NULL, 'Actin-like protein 1-1', 65, NULL, NULL, 177566),
(177567, '3.30.450.20-FF-000526', NULL, 'Response receiver sensor protein serine/threonine phosphatase, PP2C family, PAS and PAS domain-containing', 143, NULL, NULL, 177567),
(177568, '1.25.10.10-FF-001486', NULL, 'GTP binding protein, putative (AFU_orthologue AFUA_4G04560)', 412, NULL, NULL, 177568),
(177569, '2.30.30.140-FF-000285', NULL, 'Uncharacterized protein', 91, NULL, NULL, 177569),
(177570, '1.10.580.10-FF-000028', NULL, 'Citrate synthase, mitochondrial', 127, NULL, NULL, 177570),
(177571, '1.10.530.10-FF-000025', NULL, 'Resuscitation-promoting factor RpfC', 92, NULL, NULL, 177571),
(177572, '3.30.460.10-FF-000018', NULL, 'Mitochondrial assembly of ribosomal large subunit 1', 116, NULL, NULL, 177572),
(177573, '3.30.300.180-FF-000023', NULL, 'Chromosomal replication initiator protein DnaA', 81, NULL, NULL, 177573),
(177574, '3.30.160.60-FF-002444', NULL, 'Zgc:171929', 27, NULL, NULL, 177574),
(177575, '3.40.50.10490-FF-000058', NULL, 'Glucose-6-phosphate isomerase', 178, NULL, NULL, 177575),
(177576, '3.30.540.10-FF-000019', NULL, 'Fructose-1,6-bisphosphatase, chloroplastic', 202, NULL, NULL, 177576),
(177577, '1.20.1070.10-FF-001548', NULL, 'Uncharacterized protein', 176, NULL, NULL, 177577),
(177578, '2.60.120.970-FF-000038', NULL, 'Transforming growth factor beta-2', 138, NULL, NULL, 177578),
(177579, '3.30.565.10-FF-000430', NULL, 'GAF domain-containing protein', 176, NULL, NULL, 177579);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(177580, '2.60.40.10-FF-004557', NULL, NULL, 107, NULL, NULL, 177580),
(177581, '1.10.287.70-FF-000229', NULL, 'Potassium/sodium hyperpolarization-activated cyclic nucleotide-gated channel 4', 108, NULL, NULL, 177581),
(177582, '1.10.10.10-FF-000850', NULL, 'DNA-binding transcriptional regulator, MarR family', 127, NULL, NULL, 177582),
(177583, '2.130.10.10-FF-001808', NULL, 'DNA damage-binding protein CMR1', 158, NULL, NULL, 177583),
(177584, '2.40.50.140-FF-000596', NULL, 'AGAP010177-PA', 117, NULL, NULL, 177584),
(177585, '1.10.510.10-FF-000411', NULL, 'Probable Ste20-like kinase Don3', 293, NULL, NULL, 177585),
(177586, '2.20.25.10-FF-000067', NULL, 'DNA-directed RNA polymerase subunit', 53, NULL, NULL, 177586),
(177587, '3.30.70.330-FF-000262', NULL, 'Probable rna-binding protein 23 isoform', 94, NULL, NULL, 177587),
(177588, '3.30.170.10-FF-000007', NULL, 'Cyclin-dependent kinases regulatory subunit', 79, NULL, NULL, 177588),
(177589, '3.30.160.60-FF-001988', NULL, 'transcription factor E4F1 isoform X3', 31, NULL, NULL, 177589),
(177590, '3.40.50.300-FF-008610', NULL, 'Uncharacterized protein', 100, NULL, NULL, 177590),
(177591, '2.80.10.50-FF-000076', NULL, 'Beta-galactoside-specific lectin 1', 138, NULL, NULL, 177591),
(177592, '2.30.30.40-FF-000363', NULL, 'Bridging integrator 1', 81, NULL, NULL, 177592),
(177593, '3.30.1010.10-FF-000063', NULL, 'Serine/threonine-protein kinase ATM', 104, NULL, NULL, 177593),
(177594, '2.40.50.140-FF-000124', NULL, 'Ribonuclease R', 81, NULL, NULL, 177594),
(177595, '1.25.40.20-FF-001024', NULL, 'Ankyrin repeat protein', 89, NULL, NULL, 177595),
(177596, '2.60.40.420-FF-000095', NULL, 'Nitrous-oxide reductase', 120, NULL, NULL, 177596),
(177597, '1.10.510.10-FF-001395', NULL, 'Tyrosine-protein kinase', 273, NULL, NULL, 177597),
(177598, '3.40.50.2000-FF-000497', NULL, 'AGAP009137-PA', 170, NULL, NULL, 177598),
(177599, '3.40.630.10-FF-000237', NULL, 'Leucine aminopeptidase 1', 336, NULL, NULL, 177599),
(177600, '2.60.40.10-FF-005485', NULL, NULL, 98, NULL, NULL, 177600),
(177601, '1.10.565.10-FF-000077', NULL, 'Nuclear hormone receptor family member nhr-153', 195, NULL, NULL, 177601),
(177602, '1.10.10.10-FF-001070', NULL, 'Similar to anaphase-promoting complex subunit ApcB', 68, NULL, NULL, 177602),
(177603, '3.40.850.10-FF-000456', NULL, 'Predicted protein', 63, NULL, NULL, 177603),
(177604, '1.10.150.50-FF-000204', NULL, 'Uncharacterized protein', 67, NULL, NULL, 177604),
(177605, '2.30.29.30-FF-001306', NULL, 'Diacylglycerol kinase', 77, NULL, NULL, 177605),
(177606, '2.40.70.10-FF-000513', NULL, NULL, 85, NULL, NULL, 177606),
(177607, '3.40.50.720-FF-001379', NULL, 'D-3-phosphoglycerate dehydrogenase', 184, NULL, NULL, 177607),
(177608, '1.25.40.10-FF-004601', NULL, 'U4/U6-U5 snRNP complex subunit', 167, NULL, NULL, 177608),
(177609, '6.10.140.2220-FF-000072', NULL, 'Uncharacterized protein', 68, NULL, NULL, 177609),
(177610, '1.20.58.60-FF-000558', NULL, 'Microtubule actin crosslinking factor 1a', 114, NULL, NULL, 177610),
(177611, '2.130.10.10-FF-005794', NULL, 'Uncharacterized protein', 95, NULL, NULL, 177611),
(177612, '3.40.630.20-FF-000010', NULL, 'Pyroglutamyl-peptidase 1', 85, NULL, NULL, 177612),
(177613, '2.10.50.10-FF-000081', NULL, 'Tumor necrosis factor receptor superfamily member 6B', 86, NULL, NULL, 177613),
(177614, '3.30.70.330-FF-002347', NULL, NULL, 165, NULL, NULL, 177614),
(177615, '1.10.220.160-FF-000021', NULL, NULL, 82, NULL, NULL, 177615),
(177616, '2.80.10.50-FF-000261', NULL, 'Uncharacterized protein', 138, NULL, NULL, 177616),
(177617, '2.60.40.420-FF-000151', NULL, 'Similar to azurin', 121, NULL, NULL, 177617),
(177618, '2.170.270.10-FF-000160', NULL, 'Uncharacterized protein', 136, NULL, NULL, 177618),
(177619, '2.60.40.1120-FF-000072', NULL, 'Uncharacterized protein', 71, NULL, NULL, 177619),
(177620, '3.40.50.1000-FF-000242', NULL, 'Phosphomannomutase', 132, NULL, NULL, 177620),
(177621, '3.30.200.20-FF-000070', NULL, 'Protein kinase C', 113, NULL, NULL, 177621),
(177622, '2.130.10.130-FF-000018', NULL, 'YJL132W-like protein', 248, NULL, NULL, 177622); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(177623, '3.30.500.10-FF-000045', NULL, NULL, 151, NULL, NULL, 177623),
(177624, '1.10.540.10-FF-000054', NULL, 'Acyl-CoA dehydrogenase FadE27', 120, NULL, NULL, 177624),
(177625, '3.30.1330.30-FF-000093', NULL, 'rRNA methyltransferase 1, mitochondrial', 88, NULL, NULL, 177625),
(177626, '3.30.1370.10-FF-000112', NULL, 'Scp160p', 94, NULL, NULL, 177626),
(177627, '2.60.40.10-FF-004501', NULL, NULL, 125, NULL, NULL, 177627),
(177628, '3.30.420.10-FF-000044', NULL, 'Sporulation inhibitor KapD', 189, NULL, NULL, 177628),
(177629, '3.10.280.10-FF-000031', NULL, 'Putative uncharacterized protein DDB_G0288137', 130, NULL, NULL, 177629),
(177630, '3.40.50.1370-FF-000010', NULL, 'Ornithine carbamoyltransferase, mitochondrial', 140, NULL, NULL, 177630),
(177631, '3.10.20.90-FF-000600', NULL, 'Predicted protein', 64, NULL, NULL, 177631),
(177632, '3.40.50.1820-FF-000100', NULL, 'Carboxylic ester hydrolase', 537, NULL, NULL, 177632),
(177633, '2.130.10.110-FF-000012', NULL, 'Clathrin heavy chain', 382, NULL, NULL, 177633),
(177634, '3.30.1330.40-FF-000039', NULL, 'Enamine/imine deaminase', 126, NULL, NULL, 177634),
(177635, '1.50.10.10-FF-000202', NULL, 'alpha-1,2-Mannosidase', 204, NULL, NULL, 177635),
(177636, '3.15.10.10-FF-000003', NULL, 'BPI fold-containing family A member 1', 214, NULL, NULL, 177636),
(177637, '3.10.450.50-FF-000023', NULL, 'Mitogen-activated protein kinase', 130, NULL, NULL, 177637),
(177638, '1.20.1070.10-FF-000115', NULL, 'Melanin-concentrating hormone receptor 1', 323, NULL, NULL, 177638),
(177639, '3.30.230.70-FF-000064', NULL, 'Exosome complex exonuclease, putative', 277, NULL, NULL, 177639),
(177640, '3.30.420.40-FF-000295', NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase', 122, NULL, NULL, 177640),
(177641, '3.40.50.1390-FF-000016', NULL, 'Site-specific recombinase', 140, NULL, NULL, 177641),
(177642, '3.90.550.10-FF-000422', NULL, '2-phospho-L-lactate guanylyltransferase', 162, NULL, NULL, 177642),
(177643, '3.80.10.10-FF-004092', NULL, 'Uncharacterized protein', 122, NULL, NULL, 177643),
(177644, '2.60.40.1670-FF-000006', NULL, 'Protein transport protein SEC23', 121, NULL, NULL, 177644),
(177645, '1.25.40.10-FF-003640', NULL, 'Tetratricopeptide repeat protein 21B', 90, NULL, NULL, 177645),
(177646, '3.10.350.10-FF-000003', NULL, 'Membrane-bound lytic murein transglycosylase D', 50, NULL, NULL, 177646),
(177647, '3.20.20.460-FF-000001', NULL, 'Monomethylamine methyltransferase MtmB1', 458, NULL, NULL, 177647),
(177648, '3.30.70.1230-FF-000263', NULL, 'Predicted protein', 150, NULL, NULL, 177648),
(177649, '3.40.50.200-FF-000037', NULL, 'Epidermin leader peptide processing serine protease EpiP', 364, NULL, NULL, 177649),
(177650, '3.60.10.10-FF-000332', NULL, 'Gll4079 protein', 235, NULL, NULL, 177650),
(177651, '1.10.10.1390-FF-000001', NULL, 'ATP-dependent DNA helicase RecQ', 119, NULL, NULL, 177651),
(177652, '3.20.20.10-FF-000042', NULL, 'Pyridoxal phosphate homeostasis protein', 244, NULL, NULL, 177652),
(177653, '3.30.420.510-FF-000025', NULL, 'Uncharacterized protein', 168, NULL, NULL, 177653),
(177654, '3.30.160.60-FF-003169', NULL, 'Zinc finger protein 1157', 26, NULL, NULL, 177654),
(177655, '1.20.272.10-FF-000012', NULL, 'DNA polymerase III subunit delta', 122, NULL, NULL, 177655),
(177656, '3.90.740.10-FF-000072', NULL, 'Leucyl-tRNA synthetase b', 129, NULL, NULL, 177656),
(177657, '2.10.25.10-FF-001697', NULL, 'Integrin beta', 64, NULL, NULL, 177657),
(177658, '2.60.120.10-FF-000294', NULL, 'HTH-type transcriptional regulator Cmr', 129, NULL, NULL, 177658),
(177659, '3.40.50.1000-FF-000186', NULL, 'CCC2p Cu(+2)-transporting P-type ATPase', 172, NULL, NULL, 177659),
(177660, '3.40.50.300-FF-007065', NULL, 'ATP binding cassette subfamily G member 4', 195, NULL, NULL, 177660),
(177661, '2.10.25.10-FF-000713', NULL, 'Aggrecan core protein', 75, NULL, NULL, 177661),
(177662, '2.60.40.10-FF-005670', NULL, NULL, 85, NULL, NULL, 177662),
(177663, '3.30.160.60-FF-006098', NULL, NULL, 21, NULL, NULL, 177663),
(177664, '3.20.20.80-FF-000546', NULL, 'Alpha-L-arabinofuranosidase 1', 95, NULL, NULL, 177664);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(177665, '3.30.1490.220-FF-000006', NULL, 'Inositol-tetrakisphosphate 1-kinase', 100, NULL, NULL, 177665),
(177666, '3.40.1670.10-FF-000003', NULL, 'Phenolic acid decarboxylase', 115, NULL, NULL, 177666),
(177667, '3.80.10.10-FF-001742', NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', 241, NULL, NULL, 177667),
(177668, '3.40.50.300-FF-006284', NULL, 'ATP-dependent RecD-like DNA helicase', 141, NULL, NULL, 177668),
(177669, '3.40.30.10-FF-000733', NULL, 'Mitochondrial ribosome protein, putative', 136, NULL, NULL, 177669),
(177670, '2.30.29.170-FF-000005', NULL, 'Nucleoside diphosphate kinase 7', 91, NULL, NULL, 177670),
(177671, '3.15.10.30-FF-000009', NULL, 'AGAP008182-PA', 221, NULL, NULL, 177671),
(177672, '2.10.220.10-FF-000088', NULL, 'Insulin-like receptor', 69, NULL, NULL, 177672),
(177673, '3.30.559.30-FF-000107', NULL, 'Ferrichrome siderophore peptide synthetase', 241, NULL, NULL, 177673),
(177674, '3.90.70.10-FF-000273', NULL, 'Papain family cysteine protease domain containing protein', 256, NULL, NULL, 177674),
(177675, '3.90.640.10-FF-000249', NULL, 'HSP70-like protein', 113, NULL, NULL, 177675),
(177676, '3.40.630.30-FF-000631', NULL, 'Uncharacterized protein', 180, NULL, NULL, 177676),
(177677, '3.40.630.30-FF-000428', NULL, 'GNAT family N-acetyltransferase', 135, NULL, NULL, 177677),
(177678, '3.90.1530.30-FF-000004', NULL, 'Transcriptional repressor protein KorB', 69, NULL, NULL, 177678),
(177679, '3.90.660.20-FF-000017', NULL, 'NAD(P)/FAD-dependent oxidoreductase', 182, NULL, NULL, 177679),
(177680, '3.30.70.1170-FF-000020', NULL, 'Sun (Fmu) protein (Sun-2)', 59, NULL, NULL, 177680),
(177681, '3.40.50.620-FF-000663', NULL, 'Uncharacterized protein', 206, NULL, NULL, 177681),
(177682, '3.10.490.10-FF-000036', NULL, 'Gamma-glutamyl cyclotransferase', 126, NULL, NULL, 177682),
(177683, '1.10.510.10-FF-000226', NULL, 'NUAK family SNF1-like kinase 1', 322, NULL, NULL, 177683),
(177684, '1.10.150.20-FF-000100', NULL, 'DNA ligase', 82, NULL, NULL, 177684),
(177685, '3.90.190.10-FF-000579', NULL, 'Uncharacterized protein', 169, NULL, NULL, 177685),
(177686, '3.10.120.10-FF-000014', NULL, 'Chitin synthase 6', 66, NULL, NULL, 177686),
(177687, '3.30.2140.20-FF-000019', NULL, 'Uncharacterized protein', 273, NULL, NULL, 177687),
(177688, '3.30.559.10-FF-000101', NULL, 'Nonribosomal peptide synthetase 13', 177, NULL, NULL, 177688),
(177689, '2.130.10.10-FF-002360', NULL, 'DDB1- and CUL4-associated factor 13', 163, NULL, NULL, 177689),
(177690, '2.60.40.10-FF-001775', NULL, 'Jitterbug, isoform F', 95, NULL, NULL, 177690),
(177691, '3.30.420.40-FF-001076', NULL, 'Pantothenate kinase 4', 147, NULL, NULL, 177691),
(177692, '1.20.1070.10-FF-001751', NULL, 'Uncharacterized protein', 78, NULL, NULL, 177692),
(177693, '4.10.60.10-FF-000026', NULL, 'cellular nucleic acid-binding protein-like isoform X1', 24, NULL, NULL, 177693),
(177694, '4.10.410.10-FF-000078', NULL, 'GH02025p', 71, NULL, NULL, 177694),
(177695, '2.40.160.20-FF-000028', NULL, 'Outer membrane protein W', 213, NULL, NULL, 177695),
(177696, '3.90.79.10-FF-000141', NULL, 'GDP-mannose pyrophosphatase nudK', 187, NULL, NULL, 177696),
(177697, '3.40.50.10050-FF-000005', NULL, 'Translation initiation factor aIF-2', 112, NULL, NULL, 177697),
(177698, '2.30.180.10-FF-000074', NULL, 'Stabilin 2', 122, NULL, NULL, 177698),
(177699, '2.40.50.150-FF-000037', NULL, 'Uncharacterized protein', 45, NULL, NULL, 177699),
(177700, '3.30.559.10-FF-000045', NULL, 'Putative siderophore biosysnthesis protein', 168, NULL, NULL, 177700),
(177701, '1.25.40.10-FF-001111', NULL, 'WGS project CABT00000000 data, contig 2.14', 338, NULL, NULL, 177701),
(177702, '3.40.50.300-FF-006137', NULL, 'DNA mismatch repair protein', 89, NULL, NULL, 177702),
(177703, '3.40.50.800-FF-000088', NULL, 'Threonine--tRNA ligase', 104, NULL, NULL, 177703),
(177704, '2.30.29.30-FF-000289', NULL, 'Epidermal growth factor receptor kinase substrate 8', 138, NULL, NULL, 177704),
(177705, '1.10.510.10-FF-004121', NULL, NULL, 103, NULL, NULL, 177705),
(177706, '3.30.160.60-FF-004861', NULL, NULL, 61, NULL, NULL, 177706);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(177707, '1.10.472.10-FF-000569', NULL, 'Uncharacterized protein', 60, NULL, NULL, 177707),
(177708, '1.10.8.840-FF-000001', NULL, 'dnaJ homolog subfamily C member 2 isoform X1', 99, NULL, NULL, 177708),
(177709, '3.30.420.40-FF-000148', NULL, 'Actin, alpha skeletal muscle', 174, NULL, NULL, 177709),
(177710, '3.90.1290.10-FF-000081', NULL, 'Uncharacterized protein', 83, NULL, NULL, 177710),
(177711, '4.10.400.10-FF-000105', NULL, 'Lipophorin receptor 1, isoform K', 41, NULL, NULL, 177711),
(177712, '1.20.1070.10-FF-002004', NULL, 'Uncharacterized protein', 142, NULL, NULL, 177712),
(177713, '1.10.3450.20-FF-000004', NULL, 'Nuclear pore complex protein', 138, NULL, NULL, 177713),
(177714, '1.25.40.10-FF-004416', NULL, 'Pentatricopeptide repeat protein PPR868-14 isoform 1', 130, NULL, NULL, 177714),
(177715, '3.30.342.10-FF-000025', NULL, 'DNA polymerase', 146, NULL, NULL, 177715),
(177716, '1.20.1070.10-FF-001604', NULL, 'Predicted protein', 151, NULL, NULL, 177716),
(177717, '1.20.5.70-FF-000001', NULL, 'Glycophorin B', 42, NULL, NULL, 177717),
(177718, '2.60.40.10-FF-001067', NULL, 'Leucine-rich repeat transmembrane protein FLRT1', 98, NULL, NULL, 177718),
(177719, '1.10.510.10-FF-003284', NULL, NULL, 98, NULL, NULL, 177719),
(177720, '1.20.1250.20-FF-000722', NULL, 'MFS general substrate transporter', 214, NULL, NULL, 177720),
(177721, '3.30.160.60-FF-003933', NULL, NULL, 29, NULL, NULL, 177721),
(177722, '3.30.420.40-FF-000856', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', 140, NULL, NULL, 177722),
(177723, '3.90.660.10-FF-000104', NULL, NULL, 232, NULL, NULL, 177723),
(177724, '3.30.70.2660-FF-000001', NULL, 'CRISPR system Cascade subunit CasD', 224, NULL, NULL, 177724),
(177725, '3.30.470.10-FF-000047', NULL, 'Predicted protein', 124, NULL, NULL, 177725),
(177726, '3.80.10.10-FF-003164', NULL, 'Uncharacterized protein', 418, NULL, NULL, 177726),
(177727, '3.10.20.90-FF-000544', NULL, 'Protein CLMP1', 70, NULL, NULL, 177727),
(177728, '1.20.1250.20-FF-000014', NULL, 'synaptic vesicle glycoprotein 2A', 324, NULL, NULL, 177728),
(177729, '1.10.1520.10-FF-000063', NULL, 'Uncharacterized protein', 174, NULL, NULL, 177729),
(177730, '3.30.750.24-FF-000043', NULL, 'Uncharacterized protein, isoform C', 104, NULL, NULL, 177730),
(177731, '2.60.40.10-FF-002612', NULL, 'Chitodextrinase', 87, NULL, NULL, 177731),
(177732, '3.40.630.30-FF-000575', NULL, 'Acetyltransferase-like protein', 101, NULL, NULL, 177732),
(177733, '1.25.40.20-FF-000619', NULL, 'Ankyrin repeat protein', 85, NULL, NULL, 177733),
(177734, '1.25.40.10-FF-000706', NULL, 'gamma-soluble NSF attachment protein isoform X2', 194, NULL, NULL, 177734),
(177735, '2.30.42.10-FF-000628', NULL, NULL, 75, NULL, NULL, 177735),
(177736, '3.30.930.10-FF-000127', NULL, 'Phenylalanine--tRNA ligase alpha subunit', 327, NULL, NULL, 177736),
(177737, '1.25.40.20-FF-000243', NULL, 'Uncharacterized protein, isoform D', 258, NULL, NULL, 177737),
(177738, '1.20.58.60-FF-000761', NULL, 'Uncharacterized protein', 258, NULL, NULL, 177738),
(177739, '1.50.10.20-FF-000115', NULL, 'Uncharacterized protein', 150, NULL, NULL, 177739),
(177740, '2.60.40.150-FF-000755', NULL, 'Uncharacterized protein', 50, NULL, NULL, 177740),
(177741, '2.30.42.10-FF-000252', NULL, 'MAGI (Membrane Associated Guanylate kinase Inverted) homolog', 112, NULL, NULL, 177741),
(177742, '1.20.140.40-FF-000092', NULL, NULL, 60, NULL, NULL, 177742),
(177743, '2.60.40.10-FF-003012', NULL, 'Glycoprotein (transmembrane) nmb', 83, NULL, NULL, 177743),
(177744, '3.20.20.70-FF-000453', NULL, NULL, 75, NULL, NULL, 177744),
(177745, '3.20.20.80-FF-000366', NULL, 'Alpha-L-fucosidase 1', 329, NULL, NULL, 177745),
(177746, '3.40.50.300-FF-006845', NULL, 'Uncharacterized protein', 262, NULL, NULL, 177746),
(177747, '3.90.25.10-FF-000022', NULL, 'GDP-L-fucose synthase', 64, NULL, NULL, 177747),
(177748, '1.20.1070.10-FF-000059', NULL, 'G protein-coupled receptor 37', 350, NULL, NULL, 177748),
(177749, '3.10.200.10-FF-000015', NULL, NULL, 175, NULL, NULL, 177749),
(177750, '2.130.10.10-FF-001899', NULL, 'Activating molecule in BECN1-regulated autophagy protein 1', 227, NULL, NULL, 177750);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(177751, '3.10.129.10-FF-000006', NULL, 'YbgC/FadM family acyl-CoA thioesterase', 132, NULL, NULL, 177751),
(177752, '1.20.5.190-FF-000057', NULL, 'Uncharacterized protein, isoform C', 45, NULL, NULL, 177752),
(177753, '3.20.20.70-FF-000829', NULL, NULL, 137, NULL, NULL, 177753),
(177754, '3.40.390.10-FF-000229', NULL, NULL, 110, NULL, NULL, 177754),
(177755, '1.25.40.10-FF-003584', NULL, 'SARP family transcriptional regulator', 168, NULL, NULL, 177755),
(177756, '3.40.50.1820-FF-000044', NULL, 'Abhydrolase domain containing 4', 312, NULL, NULL, 177756),
(177757, '3.40.50.1240-FF-000022', NULL, 'Phosphoglycerate mutase family protein', 233, NULL, NULL, 177757),
(177758, '1.25.40.10-FF-000150', NULL, 'Nephrocystin-3', 120, NULL, NULL, 177758),
(177759, '2.60.40.1110-FF-000007', NULL, 'Phosphatidylinositol 3,4,5-trisphosphate 3-phosphatase and protein-tyrosine-phosphatase PTEN1', 113, NULL, NULL, 177759),
(177760, '3.30.870.10-FF-000072', NULL, 'Phospholipase D, putative', 203, NULL, NULL, 177760),
(177761, '2.10.110.10-FF-000259', NULL, 'Uncharacterized protein', 68, NULL, NULL, 177761),
(177762, '1.10.10.10-FF-002031', NULL, 'Cell division control protein', 98, NULL, NULL, 177762),
(177763, '3.30.160.60-FF-003225', NULL, 'Tripartite motif-containing protein 73', 46, NULL, NULL, 177763),
(177764, '3.40.50.720-FF-002492', NULL, 'Predicted protein', 169, NULL, NULL, 177764),
(177765, '2.60.120.380-FF-000052', NULL, 'Uncharacterized protein', 152, NULL, NULL, 177765),
(177766, '3.80.10.10-FF-000106', NULL, 'F-box/LRR-repeat protein 5 isoform X1', 147, NULL, NULL, 177766),
(177767, '1.20.1070.10-FF-000767', NULL, 'Uncharacterized protein', 288, NULL, NULL, 177767),
(177768, '3.30.70.330-FF-001566', NULL, NULL, 146, NULL, NULL, 177768),
(177769, '3.30.465.10-FF-000102', NULL, 'FAD linked oxidase domain protein', 218, NULL, NULL, 177769),
(177770, '1.20.120.1750-FF-000053', NULL, 'RBR-type E3 ubiquitin transferase', 84, NULL, NULL, 177770),
(177771, '2.60.40.150-FF-000047', NULL, 'Putative E3 ubiquitin-protein ligase NEDD4-like', 175, NULL, NULL, 177771),
(177772, '3.60.21.10-FF-000413', NULL, 'Serine/threonine-protein phosphatase', 286, NULL, NULL, 177772),
(177773, '3.60.130.10-FF-000026', NULL, 'Related to COX10-farnesyl transferase', 307, NULL, NULL, 177773),
(177774, '1.10.1040.10-FF-000037', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(P)+]', 142, NULL, NULL, 177774),
(177775, '3.40.630.10-FF-000417', NULL, 'Uncharacterized protein', 298, NULL, NULL, 177775),
(177776, '2.60.40.10-FF-001628', NULL, 'titin isoform X1', 103, NULL, NULL, 177776),
(177777, '1.20.5.170-FF-000051', NULL, 'mitotic spindle assembly checkpoint protein MAD1', 42, NULL, NULL, 177777),
(177778, '3.40.30.10-FF-000553', NULL, 'Peroxiredoxin-2C', 79, NULL, NULL, 177778),
(177779, '1.10.10.10-FF-000086', NULL, 'Holliday junction ATP-dependent DNA helicase RuvB', 77, NULL, NULL, 177779),
(177780, '1.10.8.710-FF-000013', NULL, 'Dynein heavy chain', 117, NULL, NULL, 177780),
(177781, '2.40.50.140-FF-000652', NULL, 'GD16141', 101, NULL, NULL, 177781),
(177782, '1.20.1270.60-FF-000033', NULL, 'Sorting nexin', 190, NULL, NULL, 177782),
(177783, '3.30.230.10-FF-000361', NULL, 'Ribonuclease P protein component', 116, NULL, NULL, 177783),
(177784, '2.130.10.10-FF-006047', NULL, 'Uncharacterized protein', 214, NULL, NULL, 177784),
(177785, '2.40.30.170-FF-000011', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 78, NULL, NULL, 177785),
(177786, '1.25.40.20-FF-000804', NULL, 'Ankyrin repeat and KH domain-containing protein mask', 219, NULL, NULL, 177786),
(177787, '1.25.10.10-FF-002267', NULL, 'Uncharacterized protein', 343, NULL, NULL, 177787),
(177788, '3.90.980.20-FF-000036', NULL, NULL, 158, NULL, NULL, 177788),
(177789, '3.30.70.1730-FF-000031', NULL, '50S ribosomal protein L10', 136, NULL, NULL, 177789),
(177790, '3.40.50.1820-FF-000752', NULL, 'Alpha/beta hydrolase', 366, NULL, NULL, 177790),
(177791, '3.80.10.10-FF-000814', NULL, 'Related to mRNA export factor mex67', 169, NULL, NULL, 177791),
(177792, '3.40.50.10480-FF-000016', NULL, 'Predicted protein', 129, NULL, NULL, 177792);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(177793, '3.90.1750.10-FF-000009', NULL, 'E3 ubiquitin-protein ligase HUWE1 isoform X1', 160, NULL, NULL, 177793),
(177794, '2.40.50.690-FF-000030', NULL, 'Uncharacterized protein', 52, NULL, NULL, 177794),
(177795, '3.30.420.10-FF-000605', NULL, NULL, 184, NULL, NULL, 177795),
(177796, '2.30.180.10-FF-000107', NULL, NULL, 169, NULL, NULL, 177796),
(177797, '3.90.550.10-FF-000681', NULL, 'Uncharacterized protein', 81, NULL, NULL, 177797),
(177798, '1.10.20.10-FF-000171', NULL, 'Histone H2B', 49, NULL, NULL, 177798),
(177799, '3.40.50.300-FF-000421', NULL, 'Branched-chain amino acid ABC transporter ATP-binding protein', 253, NULL, NULL, 177799),
(177800, '3.50.50.60-FF-000849', NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase', 248, NULL, NULL, 177800),
(177801, '2.60.40.10-FF-003809', NULL, NULL, 98, NULL, NULL, 177801),
(177802, '2.60.40.10-FF-001623', NULL, 'titin isoform X1', 107, NULL, NULL, 177802),
(177803, '3.40.50.261-FF-000045', NULL, 'Uncharacterized protein', 69, NULL, NULL, 177803),
(177804, '2.160.20.10-FF-000313', NULL, 'Uncharacterized protein', 217, NULL, NULL, 177804),
(177805, '1.10.150.340-FF-000002', NULL, 'Uncharacterized protein', 77, NULL, NULL, 177805),
(177806, '1.20.120.350-FF-000160', NULL, NULL, 83, NULL, NULL, 177806),
(177807, '3.30.505.10-FF-000005', NULL, 'SHC-transforming protein 1 isoform 3', 104, NULL, NULL, 177807),
(177808, '2.40.30.20-FF-000036', NULL, 'Riboflavin synthase, alpha subunit', 137, NULL, NULL, 177808),
(177809, '3.40.50.2000-FF-000385', NULL, 'Uncharacterized protein', 169, NULL, NULL, 177809),
(177810, '2.60.200.20-FF-000005', NULL, 'Kinesin family member 16B', 112, NULL, NULL, 177810),
(177811, '2.10.25.10-FF-000680', NULL, 'Laminin subunit alpha-3', 48, NULL, NULL, 177811),
(177812, '1.10.3480.10-FF-000003', NULL, 'Chaperone, TorD family', 182, NULL, NULL, 177812),
(177813, '3.90.70.10-FF-000334', NULL, 'Cathepsin B-like cysteine proteinase', 256, NULL, NULL, 177813),
(177814, '3.30.160.60-FF-002680', NULL, 'Zinc finger protein', 27, NULL, NULL, 177814),
(177815, '3.30.1540.20-FF-000033', NULL, NULL, 79, NULL, NULL, 177815),
(177816, '4.10.860.120-FF-000016', NULL, 'DNA-directed RNA polymerase subunit', 130, NULL, NULL, 177816),
(177817, '1.25.10.10-FF-002391', NULL, 'Uncharacterized protein', 261, NULL, NULL, 177817),
(177818, '3.20.20.60-FF-000068', NULL, 'Pyruvate kinase', 198, NULL, NULL, 177818),
(177819, '3.40.430.10-FF-000048', NULL, 'Predicted protein', 69, NULL, NULL, 177819),
(177820, '1.20.58.60-FF-000261', NULL, 'Muscle-specific protein 300 kDa, isoform L', 274, NULL, NULL, 177820),
(177821, '2.60.120.1030-FF-000011', NULL, 'Uncharacterized protein', 61, NULL, NULL, 177821),
(177822, '1.20.58.60-FF-000210', NULL, 'Spectrin beta chain', 152, NULL, NULL, 177822),
(177823, '3.80.10.10-FF-003804', NULL, 'AGAP007463-PA', 89, NULL, NULL, 177823),
(177824, '1.10.950.10-FF-000012', NULL, 'Uncharacterized protein', 65, NULL, NULL, 177824),
(177825, '3.90.550.10-FF-000242', NULL, 'Glucosyl-3-phosphoglycerate synthase', 306, NULL, NULL, 177825),
(177826, '3.40.50.880-FF-000038', NULL, 'Predicted protein', 230, NULL, NULL, 177826),
(177827, '1.10.3720.10-FF-000191', NULL, 'Putative anion ABC transporter, permease protein', 256, NULL, NULL, 177827),
(177828, '3.90.1600.10-FF-000061', NULL, 'DNA polymerase epsilon catalytic subunit', 116, NULL, NULL, 177828),
(177829, '3.30.70.100-FF-000159', NULL, NULL, 72, NULL, NULL, 177829),
(177830, '2.30.30.380-FF-000042', NULL, 'Thioredoxin TrxC', 32, NULL, NULL, 177830),
(177831, '3.30.160.60-FF-005434', NULL, NULL, 80, NULL, NULL, 177831),
(177832, '3.30.70.330-FF-000341', NULL, 'Hephaestus, isoform C', 101, NULL, NULL, 177832),
(177833, '1.20.120.1910-FF-000056', NULL, 'Cysteinyl-tRNA synthetase', 182, NULL, NULL, 177833),
(177834, '2.60.40.2690-FF-000003', NULL, 'Splicing factor 3a, subunit 2', 126, NULL, NULL, 177834),
(177835, '3.40.50.10380-FF-000025', NULL, 'Malic enzyme', 255, NULL, NULL, 177835),
(177836, '3.40.50.740-FF-000030', NULL, 'NADH-quinone oxidoreductase', 105, NULL, NULL, 177836);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(177837, '2.60.40.10-FF-005838', NULL, NULL, 109, NULL, NULL, 177837),
(177838, '3.40.350.10-FF-000047', NULL, 'FACT complex subunit SPT16', 171, NULL, NULL, 177838),
(177839, '3.65.10.10-FF-000029', NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', 197, NULL, NULL, 177839),
(177840, '3.30.2170.10-FF-000018', NULL, NULL, 171, NULL, NULL, 177840),
(177841, '3.40.50.10330-FF-000022', NULL, 'Ceramide kinase', 148, NULL, NULL, 177841),
(177842, '1.10.8.60-FF-000156', NULL, 'Ribosome biogenesis ATPase RIX7', 140, NULL, NULL, 177842),
(177843, '1.25.40.20-FF-001440', NULL, 'Uncharacterized protein', 248, NULL, NULL, 177843),
(177844, '3.60.10.10-FF-000208', NULL, 'YALI0D19778p', 365, NULL, NULL, 177844),
(177845, '3.40.50.300-FF-005204', NULL, 'Adenylate kinase, putative', 211, NULL, NULL, 177845),
(177846, '2.170.270.10-FF-000183', NULL, 'Uncharacterized protein', 63, NULL, NULL, 177846),
(177847, '1.10.472.10-FF-000485', NULL, 'Lipoate protein ligase', 84, NULL, NULL, 177847),
(177848, '1.20.1070.10-FF-000907', NULL, 'Uncharacterized protein', 123, NULL, NULL, 177848),
(177849, '3.40.50.300-FF-001882', NULL, 'ABC efflux transporter, putative', 233, NULL, NULL, 177849),
(177850, '1.10.8.750-FF-000002', NULL, 'Phosphoribosylformylglycinamidine synthase', 61, NULL, NULL, 177850),
(177851, '3.30.200.20-FF-000093', NULL, 'Putative map kinase-interacting serine/threonine-protein kinase 1', 92, NULL, NULL, 177851),
(177852, '3.90.1200.10-FF-000064', NULL, 'Choline Kinase B', 274, NULL, NULL, 177852),
(177853, '2.60.40.10-FF-002079', NULL, 'Titin homolog', 107, NULL, NULL, 177853),
(177854, '3.10.450.50-FF-000051', NULL, 'Nuclear transport factor 2 (NTF2) family protein', 127, NULL, NULL, 177854),
(177855, '2.130.10.10-FF-000707', NULL, 'prolactin regulatory element-binding protein', 348, NULL, NULL, 177855),
(177856, '3.40.50.620-FF-000399', NULL, 'Valine--tRNA ligase', 200, NULL, NULL, 177856),
(177857, '1.10.1420.10-FF-000078', NULL, 'DNA mismatch repair protein', 176, NULL, NULL, 177857),
(177858, '2.60.120.290-FF-000233', NULL, 'Metalloendopeptidase', 80, NULL, NULL, 177858),
(177859, '3.40.630.30-FF-000687', NULL, 'Uncharacterized protein', 71, NULL, NULL, 177859),
(177860, '1.10.20.10-FF-000120', NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', 39, NULL, NULL, 177860),
(177861, '1.20.920.30-FF-000025', NULL, 'Dynein heavy chain, putative', 201, NULL, NULL, 177861),
(177862, '3.40.50.300-FF-000472', NULL, 'ATP-binding cassette, sub-family F (GCN20), member 1', 287, NULL, NULL, 177862),
(177863, '2.130.10.30-FF-000073', NULL, 'Regulator of chromosome condensation, putative', 220, NULL, NULL, 177863),
(177864, '1.20.120.150-FF-000004', NULL, 'Serine/threonine-protein kinase TOR', 98, NULL, NULL, 177864),
(177865, '1.10.10.10-FF-001715', NULL, 'ATP-dependent DNA helicase RecQ', 109, NULL, NULL, 177865),
(177866, '1.20.20.10-FF-000030', NULL, 'ATP synthase C subunit, putative', 72, NULL, NULL, 177866),
(177867, '1.20.5.370-FF-000015', NULL, NULL, 97, NULL, NULL, 177867),
(177868, '3.90.1200.10-FF-000013', NULL, 'Methylthioribose kinase', 297, NULL, NULL, 177868),
(177869, '1.25.40.730-FF-000018', NULL, 'Clathrin heavy chain', 57, NULL, NULL, 177869),
(177870, '1.25.40.20-FF-001491', NULL, 'Uncharacterized protein', 77, NULL, NULL, 177870),
(177871, '3.40.47.10-FF-000176', NULL, 'Trifunctional enzyme subunit beta, mitochondrial', 430, NULL, NULL, 177871),
(177872, '3.40.50.150-FF-001747', NULL, NULL, 177, NULL, NULL, 177872),
(177873, '1.20.1600.10-FF-000050', NULL, 'Putative outer membrane efflux protein', 414, NULL, NULL, 177873),
(177874, '3.30.200.20-FF-000042', NULL, 'Aurora kinase A', 92, NULL, NULL, 177874),
(177875, '2.130.10.10-FF-003725', NULL, 'Serine/threonine-protein phosphatase 2A regulatory subunit phr2AB', 339, NULL, NULL, 177875),
(177876, '1.20.1250.20-FF-002279', NULL, 'Predicted protein', 91, NULL, NULL, 177876),
(177877, '2.60.40.10-FF-002180', NULL, 'Uncharacterized protein, isoform G', 102, NULL, NULL, 177877),
(177878, '3.40.30.10-FF-000992', NULL, 'Iodothyronine deiodinase', 83, NULL, NULL, 177878);
INSERT INTO "PUBLIC"."MODEL" VALUES
(177879, '2.40.50.140-FF-001225', NULL, NULL, 60, NULL, NULL, 177879),
(177880, '4.10.400.10-FF-000257', NULL, 'Low-density lipoprotein RecePtor related', 47, NULL, NULL, 177880),
(177881, '3.30.160.60-FF-003877', NULL, NULL, 30, NULL, NULL, 177881),
(177882, '3.10.110.10-FF-000137', NULL, 'NEDD8-conjugating enzyme Ubc12', 86, NULL, NULL, 177882),
(177883, '1.10.10.10-FF-000294', NULL, 'DNA-binding response regulator', 87, NULL, NULL, 177883),
(177884, '3.40.50.720-FF-002109', NULL, 'Predicted protein', 120, NULL, NULL, 177884),
(177885, '2.170.270.10-FF-000132', NULL, 'Histone-lysine N-methyltransferase', 213, NULL, NULL, 177885),
(177886, '3.40.50.300-FF-004687', NULL, 'DNA helicase', 390, NULL, NULL, 177886),
(177887, '3.20.20.70-FF-000717', NULL, NULL, 119, NULL, NULL, 177887),
(177888, '1.20.5.170-FF-000287', NULL, 'Keratin, type I cytoskeletal 14', 48, NULL, NULL, 177888),
(177889, '1.20.58.2220-FF-000046', NULL, 'Uncharacterized protein', 302, NULL, NULL, 177889),
(177890, '3.40.50.1820-FF-001769', NULL, 'Carboxylic ester hydrolase', 413, NULL, NULL, 177890),
(177891, '3.30.470.30-FF-000025', NULL, 'Mrna capping', 226, NULL, NULL, 177891),
(177892, '2.30.42.10-FF-000196', NULL, 'Inturned planar cell polarity protein', 90, NULL, NULL, 177892),
(177893, '1.10.506.10-FF-000059', NULL, 'Plexin A', 219, NULL, NULL, 177893),
(177894, '3.40.50.720-FF-000715', NULL, 'Possible molybdopterin biosynthesis protein moeW', 264, NULL, NULL, 177894),
(177895, '3.30.565.10-FF-000453', NULL, 'Hybrid signal transduction histidine kinase K', 174, NULL, NULL, 177895),
(177896, '1.20.120.1760-FF-000090', NULL, NULL, 152, NULL, NULL, 177896),
(177897, '3.30.70.330-FF-002999', NULL, NULL, 83, NULL, NULL, 177897),
(177898, '3.20.20.220-FF-000081', NULL, 'Proline dehydrogenase', 113, NULL, NULL, 177898),
(177899, '3.60.40.10-FF-000036', NULL, 'Protein phosphatase, Mg2+/Mn2+ dependent 1J', 353, NULL, NULL, 177899),
(177900, '3.40.50.300-FF-002219', NULL, 'Transitional endoplasmic reticulum ATPase', 189, NULL, NULL, 177900),
(177901, '3.40.50.2020-FF-000183', NULL, 'Ribose-phosphate pyrophosphokinase 2 chloroplastic', 82, NULL, NULL, 177901),
(177902, '6.10.140.2220-FF-000009', NULL, 'Zinc finger MYND domain-containing protein 10', 55, NULL, NULL, 177902),
(177903, '1.20.58.670-FF-000015', NULL, NULL, 133, NULL, NULL, 177903),
(177904, '3.80.10.10-FF-004209', NULL, '60S ribosomal protein L36', 88, NULL, NULL, 177904),
(177905, '3.80.10.10-FF-002383', NULL, 'Uncharacterized protein', 118, NULL, NULL, 177905),
(177906, '3.30.200.20-FF-001435', NULL, 'Spore coat protein YsxE', 90, NULL, NULL, 177906),
(177907, '1.25.40.10-FF-002151', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 115, NULL, NULL, 177907),
(177908, '1.10.390.10-FF-000081', NULL, 'Uncharacterized protein', 136, NULL, NULL, 177908),
(177909, '3.40.30.10-FF-000941', NULL, 'Uncharacterized protein', 111, NULL, NULL, 177909),
(177910, '3.30.450.30-FF-000063', NULL, 'IP01982p', 97, NULL, NULL, 177910),
(177911, '3.90.660.10-FF-000071', NULL, NULL, 219, NULL, NULL, 177911),
(177912, '3.30.70.940-FF-000023', NULL, 'Probable NusG-like protein-putative transcription activator', 160, NULL, NULL, 177912),
(177913, '3.40.250.10-FF-000163', NULL, 'tRNA 2-selenouridine/geranyl-2-thiouridine synthase', 122, NULL, NULL, 177913),
(177914, '3.80.10.10-FF-000819', NULL, 'Brassinosteroid LRR receptor kinase BRI1', 174, NULL, NULL, 177914),
(177915, '3.90.70.80-FF-000102', NULL, 'Uncharacterized protein', 57, NULL, NULL, 177915),
(177916, '3.70.10.10-FF-000135', NULL, 'Checkpoint protein', 275, NULL, NULL, 177916),
(177917, '3.30.40.10-FF-001768', NULL, 'E3 ubiquitin-protein ligase RNF13', 72, NULL, NULL, 177917),
(177918, '3.40.50.720-FF-000311', NULL, 'Ornithine cyclodeaminase', 175, NULL, NULL, 177918),
(177919, '3.40.630.10-FF-000029', NULL, 'Glutaminyl-peptide cyclotransferase', 325, NULL, NULL, 177919),
(177920, '3.50.30.30-FF-000098', NULL, 'Enriched in surface-labeled proteome protein 7', 136, NULL, NULL, 177920),
(177921, '1.50.40.10-FF-000530', NULL, 'Uncharacterized protein', 158, NULL, NULL, 177921);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(177922, '3.30.420.510-FF-000002', NULL, 'Pantothenate kinase 4', 140, NULL, NULL, 177922),
(177923, '1.10.630.10-FF-000437', NULL, 'Uncharacterized protein', 294, NULL, NULL, 177923),
(177924, '2.10.25.10-FF-001017', NULL, 'Otogelin', 68, NULL, NULL, 177924),
(177925, '1.20.58.1040-FF-000006', NULL, 'Os07g0539400 protein', 89, NULL, NULL, 177925),
(177926, '1.25.40.990-FF-000017', NULL, 'SAC3/GANP/Nin1/mts3/eIF-3 p25 family-domain-containing protein', 221, NULL, NULL, 177926),
(177927, '1.20.1310.10-FF-000039', NULL, 'Cullin-1, putative', 131, NULL, NULL, 177927),
(177928, '3.30.160.60-FF-000263', NULL, 'Zinc finger protein', 28, NULL, NULL, 177928),
(177929, '3.10.250.10-FF-000147', NULL, NULL, 88, NULL, NULL, 177929),
(177930, '1.20.1250.20-FF-000430', NULL, 'Jen1p', 419, NULL, NULL, 177930),
(177931, '1.10.287.1490-FF-000078', NULL, 'Filament-like plant protein 4', 140, NULL, NULL, 177931),
(177932, '1.10.287.10-FF-000026', NULL, 'SD01014p', 49, NULL, NULL, 177932),
(177933, '1.25.10.10-FF-001834', NULL, 'Uncharacterized protein', 265, NULL, NULL, 177933),
(177934, '1.25.40.10-FF-005326', NULL, 'Uncharacterized protein', 104, NULL, NULL, 177934),
(177935, '3.30.160.60-FF-003517', NULL, NULL, 31, NULL, NULL, 177935),
(177936, '1.10.10.750-FF-000039', NULL, 'Uncharacterized protein', 45, NULL, NULL, 177936),
(177937, '3.10.450.120-FF-000003', NULL, 'PUA domain containing protein', 81, NULL, NULL, 177937),
(177938, '3.30.70.330-FF-002139', NULL, NULL, 98, NULL, NULL, 177938),
(177939, '1.10.510.10-FF-000378', NULL, 'Cell division cycle 7-related protein kinase', 172, NULL, NULL, 177939),
(177940, '2.40.30.330-FF-000014', NULL, 'mRNA cleavage and polyadenylation factor CLP1', 103, NULL, NULL, 177940),
(177941, '3.30.420.10-FF-000549', NULL, NULL, 67, NULL, NULL, 177941),
(177942, '2.60.40.150-FF-000750', NULL, 'Uncharacterized protein', 82, NULL, NULL, 177942),
(177943, '1.20.1420.30-FF-000019', NULL, 'Sodium/calcium exchanger NCL2', 158, NULL, NULL, 177943),
(177944, '2.130.10.10-FF-002383', NULL, 'Putative WD-repeat family protein', 269, NULL, NULL, 177944),
(177945, '1.10.30.50-FF-000009', NULL, 'Conserved 13E12 repeat family protein', 69, NULL, NULL, 177945),
(177946, '3.30.60.30-FF-000056', NULL, 'Agrin', 52, NULL, NULL, 177946),
(177947, '3.40.50.2020-FF-000132', NULL, 'Adenine phosphoribosyltransferase 4', 103, NULL, NULL, 177947),
(177948, '1.20.140.100-FF-000050', NULL, 'Uncharacterized protein', 137, NULL, NULL, 177948),
(177949, '2.70.50.30-FF-000005', NULL, 'Probable rho GDP-dissociation inhibitor', 179, NULL, NULL, 177949),
(177950, '1.50.40.10-FF-000581', NULL, 'Mitochondrial succinate-fumarate antiporter (Eurofung)', 63, NULL, NULL, 177950),
(177951, '2.130.10.10-FF-000819', NULL, 'Dynein-associated protein, putative', 291, NULL, NULL, 177951),
(177952, '3.40.50.720-FF-001772', NULL, 'NAD-dependent glycerol-3-phosphate dehydrogenase C-terminus family protein', 50, NULL, NULL, 177952),
(177953, '3.40.50.1820-FF-001348', NULL, 'Uncharacterized protein', 244, NULL, NULL, 177953),
(177954, '1.10.555.10-FF-000251', NULL, NULL, 141, NULL, NULL, 177954),
(177955, '2.60.40.4070-FF-000007', NULL, 'Subtilisin-like protein', 76, NULL, NULL, 177955),
(177956, '1.10.1510.30-FF-000012', NULL, 'Uncharacterized protein', 98, NULL, NULL, 177956),
(177957, '2.130.10.10-FF-004069', NULL, 'Uncharacterized protein', 379, NULL, NULL, 177957),
(177958, '1.20.1310.10-FF-000191', NULL, NULL, 142, NULL, NULL, 177958),
(177959, '3.30.565.10-FF-000402', NULL, 'Sensor histidine kinase, NtrB-related protein', 156, NULL, NULL, 177959),
(177960, '2.30.30.40-FF-000284', NULL, 'Peptidase M24', 69, NULL, NULL, 177960),
(177961, '3.40.50.2300-FF-000317', NULL, 'Low molecular weight phosphotyrosine protein phosphatase', 174, NULL, NULL, 177961),
(177962, '1.10.238.10-FF-000278', NULL, 'probable calcium-binding protein CML13', 48, NULL, NULL, 177962),
(177963, '3.40.50.300-FF-003698', NULL, 'Dynein heavy chain', 124, NULL, NULL, 177963),
(177964, '1.25.40.10-FF-002100', NULL, 'Pentatricopeptide repeat-containing protein', 96, NULL, NULL, 177964);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(177965, '2.130.10.10-FF-003613', NULL, 'Predicted protein', 142, NULL, NULL, 177965),
(177966, '2.170.130.20-FF-000012', NULL, NULL, 79, NULL, NULL, 177966),
(177967, '3.30.710.10-FF-000004', NULL, 'Potassium voltage-gated channel subfamily D member 3', 143, NULL, NULL, 177967),
(177968, '3.10.110.10-FF-000188', NULL, 'Uncharacterized protein CaJ7.0157', 116, NULL, NULL, 177968),
(177969, '3.10.250.10-FF-000086', NULL, NULL, 105, NULL, NULL, 177969),
(177970, '3.30.360.10-FF-000106', NULL, 'Uncharacterized protein', 39, NULL, NULL, 177970),
(177971, '3.30.460.10-FF-000142', NULL, 'ATPase synthesis protein 25, mitochondrial', 152, NULL, NULL, 177971),
(177972, '3.30.160.60-FF-004866', NULL, NULL, 29, NULL, NULL, 177972),
(177973, '1.10.510.10-FF-001951', NULL, NULL, 76, NULL, NULL, 177973),
(177974, '2.10.25.10-FF-001517', NULL, 'Uncharacterized protein', 29, NULL, NULL, 177974),
(177975, '3.40.1110.10-FF-000321', NULL, NULL, 161, NULL, NULL, 177975),
(177976, '1.20.1250.20-FF-000481', NULL, 'MonoCarboxylate Transporter family', 220, NULL, NULL, 177976),
(177977, '2.40.70.10-FF-000221', NULL, 'ASpartyl Protease', 165, NULL, NULL, 177977),
(177978, '1.20.1050.130-FF-000057', NULL, 'Uncharacterized protein', 70, NULL, NULL, 177978),
(177979, '1.10.472.80-FF-000253', NULL, NULL, 97, NULL, NULL, 177979),
(177980, '1.25.40.10-FF-004888', NULL, 'Uncharacterized protein', 100, NULL, NULL, 177980),
(177981, '2.60.40.60-FF-000716', NULL, 'Protocadherin fat, putative', 99, NULL, NULL, 177981),
(177982, '3.10.100.10-FF-000423', NULL, NULL, 84, NULL, NULL, 177982),
(177983, '3.40.50.300-FF-006553', NULL, 'Uncharacterized protein', 105, NULL, NULL, 177983),
(177984, '1.10.3720.10-FF-000039', NULL, 'Inner membrane ABC transporter permease ydcV', 255, NULL, NULL, 177984),
(177985, '2.40.50.100-FF-000011', NULL, 'Glycine cleavage system H protein', 128, NULL, NULL, 177985),
(177986, '2.40.30.10-FF-000207', NULL, 'NADPH--cytochrome P450 reductase', 105, NULL, NULL, 177986),
(177987, '3.10.310.20-FF-000026', NULL, NULL, 139, NULL, NULL, 177987),
(177988, '2.10.10.10-FF-000016', NULL, 'Uncharacterized protein', 57, NULL, NULL, 177988),
(177989, '3.30.200.20-FF-000446', NULL, 'Wall-associated receptor kinase-like 20', 114, NULL, NULL, 177989),
(177990, '1.20.1050.10-FF-000092', NULL, 'Glutathionyl-hydroquinone reductase YqjG', 150, NULL, NULL, 177990),
(177991, '3.30.890.10-FF-000011', NULL, 'Histone-lysine N-methyltransferase eggless', 58, NULL, NULL, 177991),
(177992, '3.30.2080.10-FF-000011', NULL, 'ADR339Cp', 163, NULL, NULL, 177992),
(177993, '1.10.10.10-FF-001654', NULL, 'Ribosomal protein', 74, NULL, NULL, 177993),
(177994, '2.40.50.140-FF-001164', NULL, NULL, 70, NULL, NULL, 177994),
(177995, '2.10.22.10-FF-000004', NULL, 'cysteine-rich motor neuron 1 protein isoform X2', 48, NULL, NULL, 177995),
(177996, '3.30.1370.210-FF-000027', NULL, 'Protein CBG07137', 95, NULL, NULL, 177996),
(177997, '2.130.10.10-FF-002332', NULL, 'Uncharacterized protein', 132, NULL, NULL, 177997),
(177998, '3.30.60.30-FF-000005', NULL, 'Follistatin a', 39, NULL, NULL, 177998),
(177999, '3.40.1170.10-FF-000038', NULL, 'Uncharacterized protein', 96, NULL, NULL, 177999),
(178000, '3.40.50.300-FF-000825', NULL, 'ABC bile acid transporter', 257, NULL, NULL, 178000),
(178001, '3.20.20.140-FF-000236', NULL, 'Putative AMP deaminase', 355, NULL, NULL, 178001),
(178002, '3.30.930.10-FF-000066', NULL, 'Proline--tRNA ligase', 268, NULL, NULL, 178002),
(178003, '4.10.60.10-FF-000054', NULL, 'AGAP008075-PA-like protein', 31, NULL, NULL, 178003),
(178004, '3.90.260.10-FF-000023', NULL, 'AGAP003345-PA', 263, NULL, NULL, 178004),
(178005, '3.20.20.60-FF-000147', NULL, 'Uncharacterized protein', 126, NULL, NULL, 178005),
(178006, '2.30.30.620-FF-000002', NULL, 'Major vault protein', 74, NULL, NULL, 178006),
(178007, '3.50.50.60-FF-001305', NULL, 'Glr2871 protein', 120, NULL, NULL, 178007),
(178008, '3.30.160.60-FF-006491', NULL, NULL, 93, NULL, NULL, 178008),
(178009, '1.10.510.10-FF-003637', NULL, NULL, 189, NULL, NULL, 178009),
(178010, '1.25.40.10-FF-001611', NULL, 'Clustered mitochondria (cluA/CLU1) homolog b', 236, NULL, NULL, 178010);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(178011, '2.70.98.20-FF-000011', NULL, 'Amine oxidase', 95, NULL, NULL, 178011),
(178012, '2.60.260.20-FF-000082', NULL, 'DnaJ family protein', 93, NULL, NULL, 178012),
(178013, '3.60.21.70-FF-000004', NULL, 'Uncharacterized protein', 365, NULL, NULL, 178013),
(178014, '3.40.50.10330-FF-000090', NULL, 'ATP-NAD kinase-like domain-containing protein', 209, NULL, NULL, 178014),
(178015, '1.25.40.10-FF-002067', NULL, 'SET (Trithorax/polycomb) domain containing', 224, NULL, NULL, 178015),
(178016, '1.20.5.110-FF-000308', NULL, 'Predicted protein', 60, NULL, NULL, 178016),
(178017, '1.20.1070.10-FF-001104', NULL, 'G protein-coupled receptor Tc 45', 357, NULL, NULL, 178017),
(178018, '3.40.190.10-FF-000512', NULL, 'Bacterial extracellular solute-binding s, 5 Middle family protein', 105, NULL, NULL, 178018),
(178019, '3.40.850.10-FF-000512', NULL, 'Kinesin-like protein', 119, NULL, NULL, 178019),
(178020, '3.30.460.10-FF-000193', NULL, 'Predicted protein', 117, NULL, NULL, 178020),
(178021, '2.10.25.10-FF-000949', NULL, 'FlaMIngo (Cadherin plus 7TM domain) homolog', 38, NULL, NULL, 178021),
(178022, '1.20.5.930-FF-000003', NULL, 'Integrin subunit alpha 7', 43, NULL, NULL, 178022),
(178023, '3.40.30.10-FF-000492', NULL, 'Sulfhydryl oxidase', 146, NULL, NULL, 178023),
(178024, '2.130.10.10-FF-003793', NULL, 'Uncharacterized protein', 313, NULL, NULL, 178024),
(178025, '3.90.190.10-FF-000079', NULL, 'Protein-tyrosine-phosphatase IBR5', 151, NULL, NULL, 178025),
(178026, '3.30.930.10-FF-000358', NULL, 'Proline--tRNA ligase', 295, NULL, NULL, 178026),
(178027, '3.40.50.2000-FF-000025', NULL, 'Starch synthase, chloroplastic/amyloplastic', 213, NULL, NULL, 178027),
(178028, '3.30.70.330-FF-002639', NULL, NULL, 121, NULL, NULL, 178028),
(178029, '3.30.10.20-FF-000016', NULL, 'Serine/threonine protein kinase', 65, NULL, NULL, 178029),
(178030, '3.30.360.10-FF-000078', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase, putative', 168, NULL, NULL, 178030),
(178031, '1.10.10.10-FF-000373', NULL, 'ArsR family transcriptional regulator', 89, NULL, NULL, 178031),
(178032, '1.10.1610.10-FF-000002', NULL, 'Nicotinate-nucleotide--dimethylbenzimidazole phosphoribosyltransferase', 60, NULL, NULL, 178032),
(178033, '3.40.50.10860-FF-000006', NULL, 'Shikimate dehydrogenase (NADP(+))', 116, NULL, NULL, 178033),
(178034, '4.10.1000.10-FF-000072', NULL, 'Zinc finger protein family member', 66, NULL, NULL, 178034),
(178035, '3.30.930.10-FF-000015', NULL, 'Proline--tRNA ligase', 184, NULL, NULL, 178035),
(178036, '2.70.170.10-FF-000160', NULL, 'Achbp', 213, NULL, NULL, 178036),
(178037, '1.10.1740.10-FF-000006', NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase, chloroplastic', 85, NULL, NULL, 178037),
(178038, '3.30.70.870-FF-000042', NULL, 'AaceriAEL124Wp', 76, NULL, NULL, 178038),
(178039, '3.30.160.60-FF-001168', NULL, 'Zinc finger and SCAN domain containing 10', 30, NULL, NULL, 178039),
(178040, '1.10.287.1350-FF-000002', NULL, NULL, 21, NULL, NULL, 178040),
(178041, '1.10.8.60-FF-000268', NULL, 'Peroxisome biosynthesis protein (PAS1/Peroxin-1), putative', 81, NULL, NULL, 178041),
(178042, '1.10.1780.10-FF-000020', NULL, 'ClpC-like protein', 87, NULL, NULL, 178042),
(178043, '3.40.50.150-FF-001808', NULL, NULL, 115, NULL, NULL, 178043),
(178044, '1.20.58.70-FF-000090', NULL, 'STX1A protein', 159, NULL, NULL, 178044),
(178045, '3.30.420.40-FF-000143', NULL, 'Cell division protein FtsA', 159, NULL, NULL, 178045),
(178046, '4.10.60.10-FF-000003', NULL, 'serine/arginine-rich splicing factor RS2Z32-like isoform X1', 29, NULL, NULL, 178046),
(178047, '3.30.160.60-FF-002449', NULL, 'Zinc finger protein 1144', 29, NULL, NULL, 178047),
(178048, '1.10.10.790-FF-000023', NULL, 'Nuclear acid binding protein, putative', 81, NULL, NULL, 178048),
(178049, '3.80.10.10-FF-002736', NULL, 'At1g25320/F4F7_17', 101, NULL, NULL, 178049),
(178050, '1.10.510.10-FF-003396', NULL, NULL, 306, NULL, NULL, 178050),
(178051, '2.130.10.30-FF-000005', NULL, 'E3 ubiquitin-protein ligase MYCBP2 isoform X1', 212, NULL, NULL, 178051),
(178052, '1.10.8.710-FF-000018', NULL, NULL, 107, NULL, NULL, 178052);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(178053, '1.25.40.80-FF-000002', NULL, 'cryptochrome-1 isoform X1', 98, NULL, NULL, 178053),
(178054, '1.20.1270.60-FF-000185', NULL, 'Uncharacterized protein', 183, NULL, NULL, 178054),
(178055, '2.110.10.10-FF-000017', NULL, 'Matrix metallopeptidase 19', 77, NULL, NULL, 178055),
(178056, '3.20.20.80-FF-000254', NULL, 'Uncharacterized protein', 317, NULL, NULL, 178056),
(178057, '1.10.260.40-FF-000092', NULL, 'HipB protein, putative', 60, NULL, NULL, 178057),
(178058, '3.40.50.1240-FF-000174', NULL, NULL, 213, NULL, NULL, 178058),
(178059, '1.10.30.10-FF-000177', NULL, 'AFL219Wp', 85, NULL, NULL, 178059),
(178060, '1.20.120.330-FF-000002', NULL, 'ARF GTPase-activating protein GIT2 isoform 1', 131, NULL, NULL, 178060),
(178061, '1.10.8.270-FF-000021', NULL, 'Ypt/Rab-GAP domain of gyp1p superfamily protein', 96, NULL, NULL, 178061),
(178062, '2.60.40.10-FF-000263', NULL, 'Pro-neuregulin-1, membrane-bound isoform', 111, NULL, NULL, 178062),
(178063, '3.40.50.720-FF-002340', NULL, 'Homoserine dehydrogenase', 152, NULL, NULL, 178063),
(178064, '3.30.160.60-FF-003017', NULL, 'Si:cabz01054396.2', 30, NULL, NULL, 178064),
(178065, '3.80.10.10-FF-003304', NULL, 'Toll-like receptor13', 264, NULL, NULL, 178065),
(178066, '2.40.70.10-FF-000272', NULL, NULL, 148, NULL, NULL, 178066),
(178067, '1.20.1070.10-FF-000879', NULL, 'Apelin receptor 2', 298, NULL, NULL, 178067),
(178068, '1.50.40.10-FF-000081', NULL, 'NAD+ transporter', 198, NULL, NULL, 178068),
(178069, '2.30.42.10-FF-000128', NULL, 'T cell lymphoma invasion and metastasis 2', 89, NULL, NULL, 178069),
(178070, '3.40.30.10-FF-000441', NULL, 'YFR016C-like protein', 91, NULL, NULL, 178070),
(178071, '3.40.50.720-FF-001272', NULL, 'Shikimate dehydrogenase (NADP(+))', 144, NULL, NULL, 178071),
(178072, '3.30.160.60-FF-005030', NULL, NULL, 25, NULL, NULL, 178072),
(178073, '3.80.10.10-FF-003400', NULL, 'Uncharacterized protein', 93, NULL, NULL, 178073),
(178074, '1.10.510.10-FF-003688', NULL, NULL, 169, NULL, NULL, 178074),
(178075, '1.20.120.350-FF-000008', NULL, 'Voltage-dependent T-type calcium channel subunit alpha', 126, NULL, NULL, 178075),
(178076, '2.130.10.10-FF-005642', NULL, 'Semaphorin-5A, putative', 175, NULL, NULL, 178076),
(178077, '2.60.40.420-FF-000235', NULL, 'Bll2293 protein', 142, NULL, NULL, 178077),
(178078, '3.90.470.20-FF-000065', NULL, 'Putative 4''-phosphopantetheinyl transferase HI_0152', 61, NULL, NULL, 178078),
(178079, '3.40.50.300-FF-000921', NULL, 'RuvB-like helicase', 207, NULL, NULL, 178079),
(178080, '3.40.50.1820-FF-000864', NULL, 'Esterase, putative', 534, NULL, NULL, 178080),
(178081, '1.20.1440.100-FF-000013', NULL, 'Phosphotransferase', 73, NULL, NULL, 178081),
(178082, '3.20.20.140-FF-000287', NULL, 'Histidinol-phosphatase', 255, NULL, NULL, 178082),
(178083, '3.30.1360.120-FF-000055', NULL, 'GTPase mss1/trme, putative', 117, NULL, NULL, 178083),
(178084, '1.25.40.10-FF-001662', NULL, 'WGS project CABT00000000 data, contig 2.13', 205, NULL, NULL, 178084),
(178085, '2.130.10.10-FF-002624', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit wdr4', 174, NULL, NULL, 178085),
(178086, '1.20.58.90-FF-000045', NULL, NULL, 86, NULL, NULL, 178086),
(178087, '1.25.40.70-FF-000084', NULL, 'Uncharacterized protein', 90, NULL, NULL, 178087),
(178088, '2.60.40.10-FF-003017', NULL, 'CD47 glycoprotein isoform A', 103, NULL, NULL, 178088),
(178089, '2.60.40.10-FF-002112', NULL, 'Twitchin', 105, NULL, NULL, 178089),
(178090, '2.60.40.10-FF-004445', NULL, NULL, 116, NULL, NULL, 178090),
(178091, '3.40.50.300-FF-004136', NULL, 'PrgJ', 209, NULL, NULL, 178091),
(178092, '3.80.10.10-FF-003012', NULL, 'Uncharacterized protein', 178, NULL, NULL, 178092),
(178093, '1.10.630.10-FF-000729', NULL, 'Uncharacterized protein', 95, NULL, NULL, 178093),
(178094, '6.10.250.3260-FF-000006', NULL, 'Uncharacterized protein', 52, NULL, NULL, 178094),
(178095, '3.40.50.2300-FF-001374', NULL, NULL, 183, NULL, NULL, 178095),
(178096, '1.20.1110.10-FF-000142', NULL, 'Uncharacterized protein', 364, NULL, NULL, 178096),
(178097, '1.25.40.10-FF-003409', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 123, NULL, NULL, 178097);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(178098, '3.30.200.20-FF-001323', NULL, 'CAMKK/ELM protein kinase', 128, NULL, NULL, 178098),
(178099, '1.10.1420.10-FF-000139', NULL, 'AGAP012245-PA', 218, NULL, NULL, 178099),
(178100, '3.40.630.30-FF-000636', NULL, 'Acetyltransferase, GNAT family protein', 174, NULL, NULL, 178100),
(178101, '3.40.50.1000-FF-000394', NULL, 'Haloacid dehalogenase family hydrolase domain containing protein', 156, NULL, NULL, 178101),
(178102, '3.30.70.330-FF-000402', NULL, 'Lupus La protein homolog', 120, NULL, NULL, 178102),
(178103, '2.60.40.10-FF-003961', NULL, NULL, 132, NULL, NULL, 178103),
(178104, '2.130.10.10-FF-000027', NULL, 'Splicing factor 3B subunit 3', 390, NULL, NULL, 178104),
(178105, '3.40.50.300-FF-008110', NULL, 'Uncharacterized protein', 108, NULL, NULL, 178105),
(178106, '3.10.20.90-FF-000605', NULL, 'Uncharacterized protein', 115, NULL, NULL, 178106),
(178107, '3.30.160.60-FF-002528', NULL, 'Transcription factor Sp3', 38, NULL, NULL, 178107),
(178108, '1.10.225.10-FF-000035', NULL, 'Ecdysone dependent glycoprotein', 84, NULL, NULL, 178108),
(178109, '2.40.70.10-FF-000193', NULL, 'Pro-Pol polyprotein', 104, NULL, NULL, 178109),
(178110, '2.40.10.10-FF-000116', NULL, 'Serine protease P16', 244, NULL, NULL, 178110),
(178111, '1.20.120.1910-FF-000005', NULL, 'Cysteine-tRNA ligase, putative', 190, NULL, NULL, 178111),
(178112, '3.30.160.60-FF-001140', NULL, 'Zinc finger protein 219', 26, NULL, NULL, 178112),
(178113, '3.50.20.20-FF-000004', NULL, 'Uncharacterized protein', 138, NULL, NULL, 178113),
(178114, '3.30.2090.10-FF-000017', NULL, 'Transporter, AcrB/D/F family', 95, NULL, NULL, 178114),
(178115, '1.10.287.690-FF-000016', NULL, 'DNA-directed DNA polymerase', 104, NULL, NULL, 178115),
(178116, '2.60.120.200-FF-000779', NULL, 'Galectin', 149, NULL, NULL, 178116),
(178117, '3.30.1380.20-FF-000031', NULL, 'Trafficking protein particle complex subunit', 167, NULL, NULL, 178117),
(178118, '3.30.830.10-FF-000002', NULL, 'Mitochondrial-processing peptidase subunit beta', 222, NULL, NULL, 178118),
(178119, '2.60.40.60-FF-000637', NULL, 'AGAP002828-PA', 115, NULL, NULL, 178119),
(178120, '3.30.160.60-FF-003809', NULL, NULL, 59, NULL, NULL, 178120),
(178121, '2.60.40.10-FF-003068', NULL, 'filamin-A isoform X8', 97, NULL, NULL, 178121),
(178122, '1.25.10.10-FF-002239', NULL, 'Predicted protein', 381, NULL, NULL, 178122),
(178123, '3.30.980.10-FF-000018', NULL, 'Phosphoribulokinase/uridine kinase', 138, NULL, NULL, 178123),
(178124, '2.30.29.30-FF-000710', NULL, 'Serine/threonine-protein kinase pakC', 109, NULL, NULL, 178124),
(178125, '3.90.470.20-FF-000014', NULL, 'AflYg/ npgA protein', 160, NULL, NULL, 178125),
(178126, '3.40.50.620-FF-000511', NULL, 'Isoleucine--tRNA ligase, cytoplasmic', 274, NULL, NULL, 178126),
(178127, '1.10.20.10-FF-000019', NULL, 'Negative cofactor 2 beta', 137, NULL, NULL, 178127),
(178128, '3.30.450.60-FF-000010', NULL, 'AP complex subunit sigma', 143, NULL, NULL, 178128),
(178129, '3.30.70.330-FF-002027', NULL, NULL, 50, NULL, NULL, 178129),
(178130, '3.30.1360.150-FF-000002', NULL, 'Calcium-transporting ATPase', 119, NULL, NULL, 178130),
(178131, '1.20.1250.20-FF-001762', NULL, 'Uncharacterized protein', 190, NULL, NULL, 178131),
(178132, '3.20.20.70-FF-000768', NULL, NULL, 344, NULL, NULL, 178132),
(178133, '2.130.10.10-FF-000466', NULL, 'Chromatin assembly factor 1 subunit FAS2', 248, NULL, NULL, 178133),
(178134, '3.10.20.90-FF-000656', NULL, 'midnolin homolog isoform X2', 94, NULL, NULL, 178134),
(178135, '2.10.110.30-FF-000001', NULL, 'E3 ubiquitin-protein ligase UBR2 isoform 1', 70, NULL, NULL, 178135),
(178136, '1.10.510.10-FF-002295', NULL, NULL, 106, NULL, NULL, 178136),
(178137, '2.60.40.10-FF-000555', NULL, 'Dystroglycan 1', 108, NULL, NULL, 178137),
(178138, '2.40.50.140-FF-001113', NULL, NULL, 90, NULL, NULL, 178138),
(178139, '3.40.50.300-FF-007621', NULL, 'Uncharacterized protein', 148, NULL, NULL, 178139),
(178140, '3.10.450.240-FF-000022', NULL, 'Uncharacterized protein', 213, NULL, NULL, 178140),
(178141, '3.90.550.10-FF-000630', NULL, 'Predicted protein', 314, NULL, NULL, 178141);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(178142, '3.40.50.200-FF-000149', NULL, 'Surface-associated serine protease', 337, NULL, NULL, 178142),
(178143, '1.10.10.10-FF-001603', NULL, 'Fork head domain 3F', 64, NULL, NULL, 178143),
(178144, '2.10.220.10-FF-000065', NULL, 'Receptor protein-tyrosine kinase', 109, NULL, NULL, 178144),
(178145, '1.10.620.20-FF-000029', NULL, 'Os02g0504800 protein', 50, NULL, NULL, 178145),
(178146, '3.30.160.60-FF-005934', NULL, NULL, 121, NULL, NULL, 178146),
(178147, '1.20.1070.10-FF-000003', NULL, 'Olfactory receptor', 289, NULL, NULL, 178147),
(178148, '3.40.50.10440-FF-000004', NULL, 'Dihydroxyacetone kinase', 169, NULL, NULL, 178148),
(178149, '3.40.50.300-FF-000180', NULL, 'Member RAS oncogene family', 193, NULL, NULL, 178149),
(178150, '1.10.287.70-FF-000460', NULL, 'Ionotropic receptor 7a', 121, NULL, NULL, 178150),
(178151, '4.10.280.10-FF-000168', NULL, 'transcription factor protein', 52, NULL, NULL, 178151),
(178152, '1.10.560.10-FF-000089', NULL, 'T-complex protein 1, zeta subunit isoform 3-like protein', 45, NULL, NULL, 178152),
(178153, '2.40.30.270-FF-000035', NULL, 'YALI0A04279p', 75, NULL, NULL, 178153),
(178154, '1.10.1900.40-FF-000005', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 68, NULL, NULL, 178154),
(178155, '3.40.50.620-FF-000899', NULL, 'Predicted protein', 73, NULL, NULL, 178155),
(178156, '2.10.110.10-FF-000203', NULL, 'LIM domain-containing protein', 65, NULL, NULL, 178156),
(178157, '3.30.160.60-FF-000651', NULL, 'Putative zinc finger protein 653', 25, NULL, NULL, 178157),
(178158, '1.10.40.30-FF-000009', NULL, 'Argininosuccinate lyase', 29, NULL, NULL, 178158),
(178159, '3.40.47.10-FF-000064', NULL, 'Acetyl-CoA acetyltransferase FadA5', 169, NULL, NULL, 178159),
(178160, '2.30.130.40-FF-000023', NULL, 'Lon protease', 110, NULL, NULL, 178160),
(178161, '3.30.70.1230-FF-000151', NULL, 'Adenylate cyclase 10', 99, NULL, NULL, 178161),
(178162, '2.60.120.20-FF-000004', NULL, 'Genome polyprotein', 260, NULL, NULL, 178162),
(178163, '1.10.1060.10-FF-000044', NULL, NULL, 95, NULL, NULL, 178163),
(178164, '1.10.1020.10-FF-000002', NULL, 'D12 Class N6 Adenine-Specific DNA Methyltransferase', 99, NULL, NULL, 178164),
(178165, '3.40.50.300-FF-004575', NULL, 'Dynein heavy chain', 201, NULL, NULL, 178165),
(178166, '3.40.50.300-FF-006261', NULL, 'SWI2/SNF2-like protein', 87, NULL, NULL, 178166),
(178167, '3.40.50.300-FF-002950', NULL, 'ATP-dependent RNA helicase, putative', 201, NULL, NULL, 178167),
(178168, '3.30.60.190-FF-000021', NULL, 'Zinc finger HIT domain-containing protein 3-like Protein', 43, NULL, NULL, 178168),
(178169, '3.90.1300.10-FF-000009', NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit A', 280, NULL, NULL, 178169),
(178170, '1.10.1100.10-FF-000003', NULL, 'AGAP003882-PA', 59, NULL, NULL, 178170),
(178171, '3.30.160.60-FF-004574', NULL, NULL, 67, NULL, NULL, 178171),
(178172, '3.90.70.10-FF-000385', NULL, 'Apoptosis inhibitor', 232, NULL, NULL, 178172),
(178173, '1.20.1070.10-FF-000828', NULL, 'Adrenoceptor alpha 1B', 353, NULL, NULL, 178173),
(178174, '1.20.1560.10-FF-000815', NULL, 'Uncharacterized protein', 134, NULL, NULL, 178174),
(178175, '3.30.160.60-FF-003961', NULL, 'Protein CBG19597', 90, NULL, NULL, 178175),
(178176, '3.10.600.10-FF-000012', NULL, 'Pyruvate carboxylase', 79, NULL, NULL, 178176),
(178177, '3.40.50.10260-FF-000006', NULL, 'NAD(P)H-hydrate epimerase', 241, NULL, NULL, 178177),
(178178, '3.30.530.20-FF-000139', NULL, 'Uncharacterized protein C577.11', 215, NULL, NULL, 178178),
(178179, '3.40.1090.10-FF-000116', NULL, 'Patatin', 294, NULL, NULL, 178179),
(178180, '3.30.830.10-FF-000182', NULL, 'Uncharacterized protein', 197, NULL, NULL, 178180),
(178181, '3.90.25.10-FF-000078', NULL, 'Delta-1-pyrroline-5-carboxylate synthase B', 57, NULL, NULL, 178181),
(178182, '3.40.190.10-FF-000433', NULL, 'Probable periplasmic oligopeptide-binding lipoprotein oppA', 111, NULL, NULL, 178182),
(178183, '3.10.440.10-FF-000010', NULL, '50S ribosomal protein L31e', 101, NULL, NULL, 178183),
(178184, '3.30.70.330-FF-001690', NULL, NULL, 78, NULL, NULL, 178184);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(178185, '3.40.1160.10-FF-000032', NULL, 'Delta-1-pyrroline-5-carboxylate synthase', 297, NULL, NULL, 178185),
(178186, '3.40.710.10-FF-000070', NULL, 'GLS isoform 12', 51, NULL, NULL, 178186),
(178187, '2.10.70.10-FF-000172', NULL, 'Complement factor H related 5', 58, NULL, NULL, 178187),
(178188, '2.30.29.30-FF-001278', NULL, 'Uncharacterized protein', 96, NULL, NULL, 178188),
(178189, '3.30.1780.10-FF-000019', NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', 150, NULL, NULL, 178189),
(178190, '2.10.70.10-FF-000076', NULL, 'Furrowed, isoform A', 62, NULL, NULL, 178190),
(178191, '1.10.287.950-FF-000055', NULL, 'Putative methyl-accepting chemotaxis protein', 235, NULL, NULL, 178191),
(178192, '3.40.50.150-FF-001247', NULL, NULL, 216, NULL, NULL, 178192),
(178193, '3.30.420.10-FF-000196', NULL, 'Poly(A)-specific ribonuclease PARN', 328, NULL, NULL, 178193),
(178194, '1.10.890.30-FF-000001', NULL, 'YmgD family protein', 90, NULL, NULL, 178194),
(178195, '2.70.130.10-FF-000067', NULL, NULL, 122, NULL, NULL, 178195),
(178196, '1.20.58.240-FF-000004', NULL, 'O-GlcNAc selective N-Acetyl-beta-D-glucosaminidase (O-GlcNAcase)', 182, NULL, NULL, 178196),
(178197, '3.40.50.150-FF-001404', NULL, NULL, 164, NULL, NULL, 178197),
(178198, '1.10.3730.20-FF-000037', NULL, 'Nucleotide Sugar TransPorter family', 153, NULL, NULL, 178198),
(178199, '2.60.120.40-FF-000050', NULL, 'Tumor necrosis factor ligand superfamily member 18', 135, NULL, NULL, 178199),
(178200, '1.25.40.10-FF-001723', NULL, 'Pentatricopeptide repeat-containing protein', 93, NULL, NULL, 178200),
(178201, '3.40.50.2020-FF-000099', NULL, 'Adenine phosphoribosyltransferase', 180, NULL, NULL, 178201),
(178202, '2.60.40.10-FF-001915', NULL, 'Glucans biosynthesis protein G', 101, NULL, NULL, 178202),
(178203, '2.60.40.60-FF-000188', NULL, 'Cadherin 17', 111, NULL, NULL, 178203),
(178204, '3.30.60.20-FF-000120', NULL, 'Diacylglycerol kinase A', 71, NULL, NULL, 178204),
(178205, '2.130.10.10-FF-002444', NULL, 'Transducin beta-like protein 3', 152, NULL, NULL, 178205),
(178206, '2.60.40.10-FF-003989', NULL, NULL, 102, NULL, NULL, 178206),
(178207, '3.40.605.10-FF-000016', NULL, '4-trimethylaminobutyraldehyde dehydrogenase isoform X1', 259, NULL, NULL, 178207),
(178208, '3.90.79.10-FF-000225', NULL, 'Uncharacterized protein', 132, NULL, NULL, 178208),
(178209, '3.40.50.2000-FF-000205', NULL, 'UDP-glucuronosyltransferase', 255, NULL, NULL, 178209),
(178210, '3.40.50.300-FF-000713', NULL, 'Ras-related small GTP-binding family protein', 176, NULL, NULL, 178210),
(178211, '4.10.800.10-FF-000006', NULL, 'testican-1 isoform X2', 69, NULL, NULL, 178211),
(178212, '3.40.50.410-FF-000274', NULL, 'Uncharacterized protein', 74, NULL, NULL, 178212),
(178213, '3.30.1390.20-FF-000037', NULL, 'Uncharacterized protein', 62, NULL, NULL, 178213),
(178214, '2.40.30.10-FF-000275', NULL, 'Adenylyl-sulfate kinase', 103, NULL, NULL, 178214),
(178215, '3.30.413.10-FF-000016', NULL, 'Sulfite reductase subunit beta', 129, NULL, NULL, 178215),
(178216, '3.90.190.10-FF-000607', NULL, 'Predicted protein', 155, NULL, NULL, 178216),
(178217, '2.130.10.10-FF-005581', NULL, 'Serine/threonine-protein kinase', 206, NULL, NULL, 178217),
(178218, '3.80.10.10-FF-001955', NULL, 'Pollen receptor-like kinase 4', 91, NULL, NULL, 178218),
(178219, '1.25.40.10-FF-002179', NULL, 'Pentatricopeptide repeat-containing protein MRL1, chloroplastic', 132, NULL, NULL, 178219),
(178220, '1.10.10.2740-FF-000002', NULL, 'Transcription elongation factor Spt6', 101, NULL, NULL, 178220),
(178221, '1.25.40.10-FF-004860', NULL, 'Predicted protein', 269, NULL, NULL, 178221),
(178222, '1.20.58.60-FF-000502', NULL, 'Uncharacterized protein', 164, NULL, NULL, 178222),
(178223, '1.20.1270.60-FF-000246', NULL, 'Uncharacterized protein', 229, NULL, NULL, 178223),
(178224, '3.30.160.60-FF-005142', NULL, NULL, 35, NULL, NULL, 178224),
(178225, '2.60.40.790-FF-000071', NULL, '17.9 kDa heat shock protein 2', 142, NULL, NULL, 178225),
(178226, '3.90.105.10-FF-000006', NULL, 'Arginine decarboxylase', 57, NULL, NULL, 178226);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(178227, '3.30.760.10-FF-000007', NULL, 'Eukaryotic translation initiation factor 4E family member 3', 196, NULL, NULL, 178227),
(178228, '1.10.730.10-FF-000029', NULL, 'Leucine--tRNA ligase', 34, NULL, NULL, 178228),
(178229, '2.40.10.10-FF-000324', NULL, NULL, 99, NULL, NULL, 178229),
(178230, '3.30.565.10-FF-000161', NULL, 'Heat shock protein 90', 238, NULL, NULL, 178230),
(178231, '3.15.20.10-FF-000004', NULL, 'BPI fold containing family B member 2', 271, NULL, NULL, 178231),
(178232, '3.40.50.300-FF-004928', NULL, 'Eng_C102 protein', 234, NULL, NULL, 178232),
(178233, '1.20.1070.10-FF-000615', NULL, 'Predicted protein', 270, NULL, NULL, 178233),
(178234, '1.20.1250.20-FF-000773', NULL, 'Quinidine resistance', 291, NULL, NULL, 178234),
(178235, '3.30.40.10-FF-001740', NULL, 'Uncharacterized protein', 102, NULL, NULL, 178235),
(178236, '2.10.90.10-FF-000116', NULL, 'Uncharacterized protein', 106, NULL, NULL, 178236),
(178237, '2.130.10.10-FF-000258', NULL, 'WD repeat-containing protein 92', 357, NULL, NULL, 178237),
(178238, '1.10.1410.10-FF-000021', NULL, 'poly(A) polymerase alpha isoform X7', 129, NULL, NULL, 178238),
(178239, '3.30.1360.70-FF-000022', NULL, NULL, 108, NULL, NULL, 178239),
(178240, '2.60.40.150-FF-000339', NULL, 'U5 small nuclear ribonucleoprotein helicase, putative', 109, NULL, NULL, 178240),
(178241, '1.25.40.10-FF-003909', NULL, 'Uncharacterized protein', 53, NULL, NULL, 178241),
(178242, '3.30.70.660-FF-000029', NULL, 'tRNA pseudouridine synthase A', 138, NULL, NULL, 178242),
(178243, '1.10.510.10-FF-003424', NULL, NULL, 290, NULL, NULL, 178243),
(178244, '2.170.260.10-FF-000007', NULL, 'Dicer-like 105', 120, NULL, NULL, 178244),
(178245, '2.60.40.10-FF-000763', NULL, 'Insulin-like growth factor binding protein 7', 115, NULL, NULL, 178245),
(178246, '1.20.5.780-FF-000020', NULL, 'FXYD domain-containing ion transport regulator', 43, NULL, NULL, 178246),
(178247, '2.60.40.10-FF-002904', NULL, 'Fc receptor like 3', 80, NULL, NULL, 178247),
(178248, '3.40.50.2000-FF-000093', NULL, 'UDP-GlcNAc:PI a1-6 GlcNAc-transferase', 191, NULL, NULL, 178248),
(178249, '2.10.110.10-FF-000175', NULL, 'GD25476', 73, NULL, NULL, 178249),
(178250, '3.50.30.30-FF-000126', NULL, 'Predicted protein', 222, NULL, NULL, 178250),
(178251, '3.40.50.1820-FF-000600', NULL, 'Abhydrolase domain-containing protein lid-1', 311, NULL, NULL, 178251),
(178252, '3.40.50.300-FF-006109', NULL, 'Uncharacterized protein', 218, NULL, NULL, 178252),
(178253, '1.10.533.10-FF-000234', NULL, 'Uncharacterized protein', 109, NULL, NULL, 178253),
(178254, '3.30.200.20-FF-000334', NULL, 'Fibroblast growth factor receptor', 107, NULL, NULL, 178254),
(178255, '2.60.40.150-FF-000671', NULL, 'Synaptotagmin V, putative', 70, NULL, NULL, 178255),
(178256, '2.60.40.10-FF-005226', NULL, NULL, 115, NULL, NULL, 178256),
(178257, '3.10.105.10-FF-000007', NULL, 'Nickel ABC transporter, periplasmic nickel-binding protein', 226, NULL, NULL, 178257),
(178258, '2.20.25.570-FF-000001', NULL, 'LmbJ', 56, NULL, NULL, 178258),
(178259, '3.40.525.10-FF-000015', NULL, 'retinaldehyde-binding protein 1', 182, NULL, NULL, 178259),
(178260, '1.25.40.20-FF-000479', NULL, 'Osm-9 and Capsaicin receptor-Related', 324, NULL, NULL, 178260),
(178261, '1.10.2020.20-FF-000005', NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', 116, NULL, NULL, 178261),
(178262, '1.10.8.10-FF-000282', NULL, 'UBA/TS-N domain containing protein', 37, NULL, NULL, 178262),
(178263, '3.30.70.330-FF-001279', NULL, 'RNA recognition motif domain containing protein', 125, NULL, NULL, 178263),
(178264, '3.80.10.10-FF-001326', NULL, 'Uncharacterized protein', 137, NULL, NULL, 178264),
(178265, '3.20.20.70-FF-000689', NULL, NULL, 179, NULL, NULL, 178265),
(178266, '2.130.10.10-FF-000415', NULL, 'WD repeat domain 63', 229, NULL, NULL, 178266),
(178267, '2.40.50.1000-FF-000001', NULL, '40S ribosomal protein S11', 160, NULL, NULL, 178267),
(178268, '3.20.20.70-FF-000425', NULL, 'Quinate repressor', 243, NULL, NULL, 178268),
(178269, '2.60.40.1170-FF-000098', NULL, NULL, 117, NULL, NULL, 178269);
INSERT INTO "PUBLIC"."MODEL" VALUES
(178270, '3.30.70.3560-FF-000001', NULL, 'Late genes activator p4', 115, NULL, NULL, 178270),
(178271, '3.40.50.10190-FF-000345', NULL, 'ADL145Cp', 96, NULL, NULL, 178271),
(178272, '3.30.160.60-FF-005726', NULL, NULL, 83, NULL, NULL, 178272),
(178273, '3.30.160.60-FF-003585', NULL, NULL, 27, NULL, NULL, 178273),
(178274, '1.25.40.10-FF-003871', NULL, 'Translocase outer membrane 20-1', 97, NULL, NULL, 178274),
(178275, '3.30.420.10-FF-000600', NULL, NULL, 189, NULL, NULL, 178275),
(178276, '2.30.39.10-FF-000109', NULL, 'Uncharacterized protein', 166, NULL, NULL, 178276),
(178277, '3.40.50.300-FF-002158', NULL, 'P-type DNA transfer ATPase VirB11', 215, NULL, NULL, 178277),
(178278, '1.20.58.390-FF-000173', NULL, 'Predicted protein', 115, NULL, NULL, 178278),
(178279, '3.30.1370.10-FF-000084', NULL, 'KH domain-containing, RNA-binding, signal transduction-associated protein 1 isoform X3', 74, NULL, NULL, 178279),
(178280, '3.10.20.90-FF-000948', NULL, 'CHD gene family protein containing chromodomain, helicase domain, and DNA-binding domain', 70, NULL, NULL, 178280),
(178281, '3.30.70.980-FF-000075', NULL, 'uncharacterized protein LOC100179843', 63, NULL, NULL, 178281),
(178282, '3.90.290.10-FF-000031', NULL, 'Fibrillin-1', 62, NULL, NULL, 178282),
(178283, '3.40.50.10860-FF-000074', NULL, 'Methylenetetrahydrofolate dehydrogenase/ methylenetetrahydrofolate cyclohydrolase', 53, NULL, NULL, 178283),
(178284, '2.60.40.1090-FF-000012', NULL, 'Minor fimbrial subunit StfG', 149, NULL, NULL, 178284),
(178285, '3.60.40.10-FF-000328', NULL, 'Predicted protein', 169, NULL, NULL, 178285),
(178286, '1.10.10.60-FF-000404', NULL, 'Transcription factor MYB97', 76, NULL, NULL, 178286),
(178287, '3.40.50.720-FF-000423', NULL, 'Saccharopine dehydrogenase [NAD(+), L-lysine-forming]', 133, NULL, NULL, 178287),
(178288, '3.30.710.10-FF-000347', NULL, 'Uncharacterized protein BTB2', 163, NULL, NULL, 178288),
(178289, '3.20.20.100-FF-000062', NULL, 'Oxidoreductase, aldo/keto reductase family', 277, NULL, NULL, 178289),
(178290, '3.10.100.10-FF-000311', NULL, NULL, 150, NULL, NULL, 178290),
(178291, '1.10.150.510-FF-000014', NULL, 'Si:ch73-193i22.1', 92, NULL, NULL, 178291),
(178292, '3.90.245.10-FF-000016', NULL, 'Inosine-uridine preferring nucleoside hydrolase, putative', 315, NULL, NULL, 178292),
(178293, '2.120.10.80-FF-000088', NULL, 'Protein GLUTELIN PRECURSOR ACCUMULATION 3', 175, NULL, NULL, 178293),
(178294, '3.30.420.40-FF-000064', NULL, 'Rhamnulokinase', 233, NULL, NULL, 178294),
(178295, '3.30.420.40-FF-000704', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', 186, NULL, NULL, 178295),
(178296, '2.60.110.10-FF-000006', NULL, 'Osmotin-like protein', 221, NULL, NULL, 178296),
(178297, '1.10.1200.270-FF-000008', NULL, 'OSJNBa0087O24.14 protein', 15, NULL, NULL, 178297),
(178298, '2.10.110.10-FF-000023', NULL, 'LIM homeobox 6', 70, NULL, NULL, 178298),
(178299, '3.30.40.10-FF-002196', NULL, 'Ubiquitin-conjugating enzyme family protein', 75, NULL, NULL, 178299),
(178300, '3.10.20.90-FF-000095', NULL, 'Ubiquilin 4', 88, NULL, NULL, 178300),
(178301, '1.20.5.5160-FF-000006', NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', 44, NULL, NULL, 178301),
(178302, '3.90.70.10-FF-000042', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 95, NULL, NULL, 178302),
(178303, '3.40.50.720-FF-001204', NULL, 'NAD(P)-dependent oxidoreductase', 255, NULL, NULL, 178303),
(178304, '2.10.25.10-FF-000157', NULL, 'Neurogenic locus notch protein 1', 43, NULL, NULL, 178304),
(178305, '3.30.70.330-FF-002971', NULL, NULL, 99, NULL, NULL, 178305),
(178306, '3.30.160.60-FF-002236', NULL, 'Zinc finger protein 226', 45, NULL, NULL, 178306),
(178307, '3.40.50.300-FF-004187', NULL, 'RAD3-like DNA-binding helicase protein', 157, NULL, NULL, 178307),
(178308, '3.40.50.150-FF-000466', NULL, 'Polyamine aminopropyltransferase', 211, NULL, NULL, 178308),
(178309, '3.30.1600.10-FF-000035', NULL, 'NAD-dependent deacetylase sir2C', 119, NULL, NULL, 178309),
(178310, '2.130.10.10-FF-002596', NULL, 'Uncharacterized protein', 200, NULL, NULL, 178310);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(178311, '2.60.120.970-FF-000010', NULL, 'Transforming growth factor beta', 252, NULL, NULL, 178311),
(178312, '3.40.640.10-FF-000423', NULL, 'Serine--pyruvate aminotransferase', 22, NULL, NULL, 178312),
(178313, '2.40.270.10-FF-000033', NULL, NULL, 180, NULL, NULL, 178313),
(178314, '1.25.10.10-FF-002891', NULL, 'Uncharacterized protein', 144, NULL, NULL, 178314),
(178315, '1.10.8.60-FF-000499', NULL, 'Uncharacterized protein', 83, NULL, NULL, 178315),
(178316, '1.25.40.10-FF-002443', NULL, 'Pentatricopeptide repeat-containing protein At1g19720', 101, NULL, NULL, 178316),
(178317, '1.10.10.10-FF-000822', NULL, 'Iron-regulated virulence regulatory protein IrgB', 88, NULL, NULL, 178317),
(178318, '3.30.160.60-FF-004366', NULL, NULL, 64, NULL, NULL, 178318),
(178319, '1.25.40.10-FF-000381', NULL, 'Pentatricopeptide repeat-containing protein', 103, NULL, NULL, 178319),
(178320, '3.40.50.460-FF-000036', NULL, 'ATP-dependent 6-phosphofructokinase', 113, NULL, NULL, 178320),
(178321, '1.10.20.10-FF-000087', NULL, 'Probable histone 3', 141, NULL, NULL, 178321),
(178322, '2.40.110.10-FF-000039', NULL, 'Short-chain-specific acyl-CoA dehydrogenase, mitochondrial', 80, NULL, NULL, 178322),
(178323, '3.40.630.30-FF-000344', NULL, 'Uncharacterized protein', 151, NULL, NULL, 178323),
(178324, '1.20.1250.20-FF-000981', NULL, 'Protein BTN', 183, NULL, NULL, 178324),
(178325, '3.40.50.10190-FF-000058', NULL, 'Epithelial cell transforming 2', 101, NULL, NULL, 178325),
(178326, '1.10.510.10-FF-000439', NULL, 'Mitogen-activated protein kinase', 216, NULL, NULL, 178326),
(178327, '2.30.29.30-FF-000890', NULL, 'actin filament-associated protein 1 isoform X1', 100, NULL, NULL, 178327),
(178328, '2.40.50.140-FF-000736', NULL, NULL, 80, NULL, NULL, 178328),
(178329, '4.10.1240.30-FF-000005', NULL, 'Integrin beta', 84, NULL, NULL, 178329),
(178330, '1.25.40.1010-FF-000021', NULL, 'Uncharacterized protein', 130, NULL, NULL, 178330),
(178331, '3.20.20.380-FF-000016', NULL, 'Uncharacterized protein', 83, NULL, NULL, 178331),
(178332, '3.30.1120.10-FF-000037', NULL, 'Putative sulfatase yidJ', 87, NULL, NULL, 178332),
(178333, '1.20.1250.20-FF-001711', NULL, 'Uncharacterized protein', 118, NULL, NULL, 178333),
(178334, '3.40.50.300-FF-005704', NULL, 'Os11g0649100 protein', 174, NULL, NULL, 178334),
(178335, '3.20.20.80-FF-000597', NULL, 'Alpha-L-fucosidase, putative', 198, NULL, NULL, 178335),
(178336, '3.40.1180.10-FF-000044', NULL, 'Undecaprenyl pyrophosphate synthetase, putative', 65, NULL, NULL, 178336),
(178337, '1.10.472.130-FF-000001', NULL, 'Dynein, axonemal, heavy chain 9', 146, NULL, NULL, 178337),
(178338, '3.40.140.10-FF-000161', NULL, 'Nuclear protein localization protein 4 homolog', 253, NULL, NULL, 178338),
(178339, '3.50.50.60-FF-001513', NULL, 'Uncharacterized protein', 103, NULL, NULL, 178339),
(178340, '3.10.20.90-FF-000313', NULL, 'Blast:E3 ubiquitin-protein ligase MYLIP-A', 87, NULL, NULL, 178340),
(178341, '1.10.8.870-FF-000021', NULL, 'Uncharacterized protein', 130, NULL, NULL, 178341),
(178342, '1.10.510.10-FF-004413', NULL, NULL, 289, NULL, NULL, 178342),
(178343, '3.90.1150.10-FF-000132', NULL, 'L-tryptophan--pyruvate aminotransferase 1', 124, NULL, NULL, 178343),
(178344, '1.25.40.690-FF-000017', NULL, 'YALI0D17886p', 93, NULL, NULL, 178344),
(178345, '1.10.287.70-FF-000701', NULL, 'Inward rectifier potassium channel irk-1-like Protein', 51, NULL, NULL, 178345),
(178346, '1.10.730.10-FF-000181', NULL, 'Uncharacterized protein', 23, NULL, NULL, 178346),
(178347, '3.30.40.10-FF-000751', NULL, 'Tnf receptor associated factor, putative', 54, NULL, NULL, 178347),
(178348, '3.40.390.10-FF-000089', NULL, 'DUF3152 domain-containing protein', 161, NULL, NULL, 178348),
(178349, '1.10.10.10-FF-001154', NULL, 'IclR family transcriptional regulator', 72, NULL, NULL, 178349),
(178350, '3.40.50.1820-FF-001320', NULL, 'Carboxypeptidase', 258, NULL, NULL, 178350),
(178351, '2.60.120.200-FF-000487', NULL, 'Si:ch211-241e1.3', 213, NULL, NULL, 178351),
(178352, '1.10.10.60-FF-000247', NULL, 'Zinc fingers and homeoboxes protein 2', 61, NULL, NULL, 178352);
INSERT INTO "PUBLIC"."MODEL" VALUES
(178353, '1.10.100.10-FF-000004', NULL, 'insulin-like 3', 69, NULL, NULL, 178353),
(178354, '1.10.150.50-FF-000209', NULL, 'Predicted protein', 53, NULL, NULL, 178354),
(178355, '1.10.510.10-FF-001390', NULL, 'protein kinase with WD repeats', 215, NULL, NULL, 178355),
(178356, '1.10.286.20-FF-000004', NULL, 'Elongation factor Ts', 54, NULL, NULL, 178356),
(178357, '2.40.70.10-FF-000485', NULL, NULL, 147, NULL, NULL, 178357),
(178358, '3.30.160.100-FF-000016', NULL, 'Ribosome hibernation promoting factor', 111, NULL, NULL, 178358),
(178359, '1.25.40.20-FF-000355', NULL, 'Ankyrin repeat domain-containing protein 50', 135, NULL, NULL, 178359),
(178360, '1.20.5.650-FF-000009', NULL, 'Unplaced genomic scaffold supercont1.24, whole genome shotgun sequence', 52, NULL, NULL, 178360),
(178361, '1.10.533.10-FF-000026', NULL, 'astrocytic phosphoprotein PEA-15 isoform X1', 130, NULL, NULL, 178361),
(178362, '3.40.1090.10-FF-000037', NULL, 'Lipase 4', 292, NULL, NULL, 178362),
(178363, '2.60.260.20-FF-000110', NULL, 'Heat shock protein 40', 66, NULL, NULL, 178363),
(178364, '2.20.70.10-FF-000143', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-36 specific', 47, NULL, NULL, 178364),
(178365, '1.10.418.10-FF-000163', NULL, 'Fimbrin', 120, NULL, NULL, 178365),
(178366, '3.90.850.10-FF-000046', NULL, NULL, 110, NULL, NULL, 178366),
(178367, '3.10.20.90-FF-000836', NULL, 'Uncharacterized protein', 92, NULL, NULL, 178367),
(178368, '3.30.2160.10-FF-000012', NULL, 'probable E3 ubiquitin-protein ligase HECTD4 isoform X2', 101, NULL, NULL, 178368),
(178369, '3.40.50.1000-FF-000473', NULL, NULL, 40, NULL, NULL, 178369),
(178370, '3.60.15.10-FF-000023', NULL, 'Zinc phosphodiesterase ELAC protein 1', 313, NULL, NULL, 178370),
(178371, '3.90.70.10-FF-000413', NULL, 'Cathepsin Z', 91, NULL, NULL, 178371),
(178372, '3.20.20.70-FF-000537', NULL, NULL, 239, NULL, NULL, 178372),
(178373, '3.90.70.10-FF-000677', NULL, 'Uncharacterized protein', 273, NULL, NULL, 178373),
(178374, '3.30.70.330-FF-001982', NULL, NULL, 107, NULL, NULL, 178374),
(178375, '1.25.40.10-FF-003168', NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', 113, NULL, NULL, 178375),
(178376, '1.10.8.1190-FF-000003', NULL, 'Replicase polyprotein 1ab', 95, NULL, NULL, 178376),
(178377, '3.40.30.10-FF-000261', NULL, 'TXNL4A isoform 9', 89, NULL, NULL, 178377),
(178378, '3.90.550.50-FF-000226', NULL, 'Protein CBG18379', 126, NULL, NULL, 178378),
(178379, '3.90.1480.20-FF-000002', NULL, 'CMP-N-acetylneuraminate-beta-galactosamide- alpha-2,3-sialyltransferase 2', 289, NULL, NULL, 178379),
(178380, '1.20.1070.10-FF-002009', NULL, 'Protein CBR-NPR-17', 139, NULL, NULL, 178380),
(178381, '1.25.40.570-FF-000066', NULL, 'Uncharacterized protein', 106, NULL, NULL, 178381),
(178382, '1.20.120.1900-FF-000019', NULL, 'Spindle pole body component', 359, NULL, NULL, 178382),
(178383, '2.60.120.920-FF-000141', NULL, 'neuralized-a protein isoform X1', 149, NULL, NULL, 178383),
(178384, '3.40.50.2300-FF-000413', NULL, 'Glutamate metabotropic receptor 1', 141, NULL, NULL, 178384),
(178385, '1.25.40.470-FF-000070', NULL, 'WD repeat protein, putative', 151, NULL, NULL, 178385),
(178386, '2.30.180.10-FF-000079', NULL, 'Chromosome 1, whole genome shotgun sequence', 132, NULL, NULL, 178386),
(178387, '3.40.30.10-FF-000109', NULL, 'Protein disulfide-isomerase', 114, NULL, NULL, 178387),
(178388, '1.10.8.50-FF-000035', NULL, 'Uncharacterized protein', 78, NULL, NULL, 178388),
(178389, '1.20.1070.10-FF-001335', NULL, 'Predicted protein', 277, NULL, NULL, 178389),
(178390, '3.40.50.300-FF-003670', NULL, 'ATP binding cassette subfamily C member 3', 129, NULL, NULL, 178390),
(178391, '3.40.50.620-FF-000803', NULL, 'Uncharacterized protein', 93, NULL, NULL, 178391),
(178392, '1.10.510.10-FF-003576', NULL, NULL, 215, NULL, NULL, 178392),
(178393, '1.10.287.1490-FF-000139', NULL, 'Structural maintenance of chromosomes protein 2', 188, NULL, NULL, 178393),
(178394, '3.40.190.10-FF-000725', NULL, 'Glutamate receptor', 120, NULL, NULL, 178394),
(178395, '1.10.8.270-FF-000072', NULL, 'Cell division control protein 16', 60, NULL, NULL, 178395);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(178396, '1.25.40.420-FF-000049', NULL, 'Speckle-type POZ protein', 65, NULL, NULL, 178396),
(178397, '1.10.10.60-FF-000808', NULL, NULL, 53, NULL, NULL, 178397),
(178398, '1.10.150.20-FF-000105', NULL, 'DNA ligase', 66, NULL, NULL, 178398),
(178399, '2.60.40.60-FF-000929', NULL, 'Uncharacterized protein', 44, NULL, NULL, 178399),
(178400, '3.90.1640.20-FF-000004', NULL, 'Uncharacterized protein', 318, NULL, NULL, 178400),
(178401, '1.10.3080.10-FF-000074', NULL, 'Chloride channel protein', 71, NULL, NULL, 178401),
(178402, '3.40.718.10-FF-000031', NULL, 'Isocitrate dehydrogenase [NAD] subunit alpha, mitochondrial', 134, NULL, NULL, 178402),
(178403, '1.25.40.560-FF-000006', NULL, 'Uncharacterized protein', 72, NULL, NULL, 178403),
(178404, '3.40.50.300-FF-004344', NULL, 'Pre-mRNA cleavage complex II Clp1-like, conserved', 247, NULL, NULL, 178404),
(178405, '3.40.50.300-FF-007913', NULL, 'Uncharacterized protein', 184, NULL, NULL, 178405),
(178406, '1.10.10.1820-FF-000001', NULL, NULL, 158, NULL, NULL, 178406),
(178407, '1.10.357.30-FF-000009', NULL, NULL, 76, NULL, NULL, 178407),
(178408, '1.10.510.10-FF-000939', NULL, 'Z-DNA binding protein kinase', 192, NULL, NULL, 178408),
(178409, '1.10.400.10-FF-000049', NULL, 'Guanine nucleotide-binding protein G(I) subunit alpha', 118, NULL, NULL, 178409),
(178410, '2.40.170.20-FF-000034', NULL, 'SusC/RagA family TonB-linked outer membrane protein', 568, NULL, NULL, 178410),
(178411, '2.30.30.110-FF-000006', NULL, 'mRNA interferase', 116, NULL, NULL, 178411),
(178412, '1.25.10.10-FF-002683', NULL, 'Uncharacterized protein', 79, NULL, NULL, 178412),
(178413, '3.30.200.20-FF-000542', NULL, 'Receptor-like serine/threonine-protein kinase At4g25390', 111, NULL, NULL, 178413),
(178414, '3.30.230.70-FF-000013', NULL, 'Polyribonucleotide nucleotidyltransferase', 297, NULL, NULL, 178414),
(178415, '2.30.30.490-FF-000075', NULL, 'Histone-lysine N-methyltransferase', 213, NULL, NULL, 178415),
(178416, '3.30.160.60-FF-000712', NULL, 'Drumstick, isoform C', 24, NULL, NULL, 178416),
(178417, '2.120.10.30-FF-000146', NULL, 'Protein cueball', 253, NULL, NULL, 178417),
(178418, '1.10.132.60-FF-000008', NULL, 'DNA polymerase', 145, NULL, NULL, 178418),
(178419, '1.20.272.10-FF-000063', NULL, NULL, 90, NULL, NULL, 178419),
(178420, '2.30.180.10-FF-000158', NULL, NULL, 130, NULL, NULL, 178420),
(178421, '3.50.50.60-FF-001013', NULL, 'FAD/NAD(P)-binding domain-containing protein', 179, NULL, NULL, 178421),
(178422, '3.40.50.300-FF-002719', NULL, 'GTPase Der', 174, NULL, NULL, 178422),
(178423, '3.50.50.60-FF-000153', NULL, 'Salicylate hydroxylase, putative', 399, NULL, NULL, 178423),
(178424, '2.30.30.40-FF-000071', NULL, 'Epidermal growth factor receptor kinase substrate 8', 61, NULL, NULL, 178424),
(178425, '3.40.50.1100-FF-000210', NULL, 'Uncharacterized protein', 39, NULL, NULL, 178425),
(178426, '3.40.50.300-FF-000533', NULL, 'Helicase, Snf2 family', 243, NULL, NULL, 178426),
(178427, '1.10.510.10-FF-001159', NULL, 'Protein kinase D4', 279, NULL, NULL, 178427),
(178428, '3.30.40.10-FF-000228', NULL, 'Remodeling and spacing factor 1', 89, NULL, NULL, 178428),
(178429, '3.40.970.40-FF-000002', NULL, 'Fibronectin-binding domain-containing protein', 51, NULL, NULL, 178429),
(178430, '1.25.10.10-FF-000474', NULL, 'Serine/threonine-protein kinase TOR', 214, NULL, NULL, 178430),
(178431, '3.30.450.90-FF-000002', NULL, 'Twitching motility protein PilT', 101, NULL, NULL, 178431),
(178432, '3.40.50.1100-FF-000098', NULL, 'Predicted protein', 18, NULL, NULL, 178432),
(178433, '1.50.40.10-FF-000119', NULL, 'Mitochondrial carrier domain-containing protein', 114, NULL, NULL, 178433),
(178434, '3.30.420.40-FF-000300', NULL, 'Actin-like protein, putative', 135, NULL, NULL, 178434),
(178435, '1.25.10.10-FF-002615', NULL, 'Serine/threonine protein phosphatase 2A 59 kDa regulatory subunit B'' eta isoform', 134, NULL, NULL, 178435),
(178436, '1.10.510.10-FF-001890', NULL, 'Uncharacterized protein', 143, NULL, NULL, 178436),
(178437, '3.60.40.10-FF-000249', NULL, 'Serine/threonine-protein phosphatase', 233, NULL, NULL, 178437);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(178438, '1.10.238.10-FF-000918', NULL, 'EF-hand calcium-binding domain-containing protein 6-like', 80, NULL, NULL, 178438),
(178439, '2.60.40.10-FF-004153', NULL, NULL, 89, NULL, NULL, 178439),
(178440, '2.40.30.10-FF-000387', NULL, 'translation initiation factor IF-2, mitochondrial', 104, NULL, NULL, 178440),
(178441, '1.10.510.10-FF-003929', NULL, NULL, 72, NULL, NULL, 178441),
(178442, '3.90.215.10-FF-000008', NULL, 'Angiopoietin like 3', 222, NULL, NULL, 178442),
(178443, '3.10.20.90-FF-000448', NULL, 'Ubiquitin family protein', 77, NULL, NULL, 178443),
(178444, '3.90.550.10-FF-000130', NULL, 'Family 2 glycosyl transferase', 237, NULL, NULL, 178444),
(178445, '2.30.30.100-FF-000228', NULL, 'Uncharacterized protein', 51, NULL, NULL, 178445),
(178446, '2.30.29.30-FF-000502', NULL, 'Unc-112-related protein', 137, NULL, NULL, 178446),
(178447, '3.40.50.800-FF-000060', NULL, 'Threonine--tRNA ligase', 106, NULL, NULL, 178447),
(178448, '3.40.630.30-FF-000136', NULL, 'Glucosamine 6-phosphate N-acetyltransferase', 159, NULL, NULL, 178448),
(178449, '1.10.3110.10-FF-000004', NULL, 'Protoporphyrinogen oxidase', 94, NULL, NULL, 178449),
(178450, '1.25.10.10-FF-001334', NULL, 'Plakophilin 1b', 464, NULL, NULL, 178450),
(178451, '1.20.1560.10-FF-000462', NULL, 'ABC-type Ni2+/Co2+ export system bifunctional ATPase and permease components AtmA', 331, NULL, NULL, 178451),
(178452, '1.20.58.930-FF-000003', NULL, 'Arginine decarboxylase', 79, NULL, NULL, 178452),
(178453, '3.60.20.10-FF-000153', NULL, NULL, 147, NULL, NULL, 178453),
(178454, '3.10.20.90-FF-000105', NULL, 'phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit beta', 157, NULL, NULL, 178454),
(178455, '3.50.50.60-FF-000737', NULL, 'FAD-binding oxidoreductase', 202, NULL, NULL, 178455),
(178456, '3.40.630.30-FF-000479', NULL, 'Uncharacterized protein', 155, NULL, NULL, 178456),
(178457, '4.10.400.10-FF-000077', NULL, 'atrial natriuretic peptide-converting enzyme', 37, NULL, NULL, 178457),
(178458, '1.20.1250.20-FF-001211', NULL, 'Related to multidrug resistant protein', 120, NULL, NULL, 178458),
(178459, '3.40.50.2000-FF-000317', NULL, 'UDP-N-acetylglucosamine transferase subunit ALG14', 187, NULL, NULL, 178459),
(178460, '1.10.1380.10-FF-000023', NULL, 'NEPrilysin metallopeptidase family', 396, NULL, NULL, 178460),
(178461, '1.10.10.10-FF-001362', NULL, 'Amine oxidase family member 1', 100, NULL, NULL, 178461),
(178462, '1.10.238.10-FF-001138', NULL, 'Uncharacterized protein', 149, NULL, NULL, 178462),
(178463, '1.10.510.10-FF-004205', NULL, NULL, 319, NULL, NULL, 178463),
(178464, '1.25.40.10-FF-001903', NULL, 'RCM-1', 221, NULL, NULL, 178464),
(178465, '1.20.140.10-FF-000072', NULL, 'Acyl-CoA dehydrogenase FadE27', 152, NULL, NULL, 178465),
(178466, '1.20.1050.130-FF-000006', NULL, 'Elongation factor 1-delta 1', 76, NULL, NULL, 178466),
(178467, '3.30.530.20-FF-000078', NULL, 'Phosphatidylcholine transfer protein putative', 201, NULL, NULL, 178467),
(178468, '2.60.120.10-FF-000439', NULL, 'Seed storage protein', 188, NULL, NULL, 178468),
(178469, '3.30.160.60-FF-003309', NULL, 'Zgc:171551', 28, NULL, NULL, 178469),
(178470, '2.60.40.10-FF-000842', NULL, 'Interferon receptor 1 isoform 4', 103, NULL, NULL, 178470),
(178471, '2.130.10.10-FF-002091', NULL, 'POC1 centriolar protein homolog B', 125, NULL, NULL, 178471),
(178472, '3.80.10.10-FF-001394', NULL, 'Disease resistance-like protein DSC1', 221, NULL, NULL, 178472),
(178473, '1.10.1040.50-FF-000026', NULL, NULL, 82, NULL, NULL, 178473),
(178474, '1.10.287.370-FF-000089', NULL, 'Uncharacterized protein', 104, NULL, NULL, 178474),
(178475, '3.90.190.10-FF-000528', NULL, 'Predicted protein', 234, NULL, NULL, 178475),
(178476, '1.10.8.10-FF-000214', NULL, 'Protein phosphatase regulator', 74, NULL, NULL, 178476),
(178477, '3.30.70.980-FF-000007', NULL, 'Probable transcriptional regulatory protein BACUNI_02276', 82, NULL, NULL, 178477),
(178478, '3.30.1520.10-FF-000034', NULL, 'Vacuolar protein sorting-associated protein 17', 136, NULL, NULL, 178478),
(178479, '2.60.220.50-FF-000083', NULL, 'Uncharacterized protein', 94, NULL, NULL, 178479);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(178480, '3.40.50.2300-FF-000205', NULL, 'Two-component system response regulator', 120, NULL, NULL, 178480),
(178481, '3.30.505.10-FF-000218', NULL, NULL, 105, NULL, NULL, 178481),
(178482, '2.30.30.140-FF-000049', NULL, 'PHD finger protein 20 (Predicted)', 74, NULL, NULL, 178482),
(178483, '3.50.50.60-FF-000496', NULL, 'tRNA 5-methylaminomethyl-2-thiouridine biosynthesis bifunctional protein MnmC', 248, NULL, NULL, 178483),
(178484, '3.40.50.300-FF-006761', NULL, 'Heparan-sulfate 6-O-sulfotransferase', 275, NULL, NULL, 178484),
(178485, '1.25.40.10-FF-003348', NULL, 'Prp-6', 83, NULL, NULL, 178485),
(178486, '3.40.50.170-FF-000005', NULL, 'Phosphoribosylglycinamide formyltransferase', 212, NULL, NULL, 178486),
(178487, '2.60.40.3210-FF-000030', NULL, 'Uncharacterized protein', 130, NULL, NULL, 178487),
(178488, '2.130.10.120-FF-000021', NULL, 'Predicted protein', 27, NULL, NULL, 178488),
(178489, '2.60.40.10-FF-002972', NULL, 'fibrocystin-L-like isoform X1', 83, NULL, NULL, 178489),
(178490, '1.10.238.10-FF-000014', NULL, 'Dystrobrevin alpha', 95, NULL, NULL, 178490),
(178491, '3.30.160.60-FF-002157', NULL, 'Transcription factor', 29, NULL, NULL, 178491),
(178492, '1.25.40.180-FF-000140', NULL, 'Putative eukaryotic translation initiation factor 4 gamma 3', 195, NULL, NULL, 178492),
(178493, '3.30.70.960-FF-000001', NULL, 'NtA agrin', 92, NULL, NULL, 178493),
(178494, '2.40.30.180-FF-000008', NULL, 'Uncharacterized protein', 80, NULL, NULL, 178494),
(178495, '2.80.10.50-FF-000025', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 137, NULL, NULL, 178495),
(178496, '3.40.50.10810-FF-000132', NULL, 'Excision repair cross-complementation group 6-like 2', 60, NULL, NULL, 178496),
(178497, '1.10.510.10-FF-000198', NULL, 'receptor protein kinase TMK1', 218, NULL, NULL, 178497),
(178498, '2.30.30.140-FF-000280', NULL, 'Protein CBR-RAD-54', 101, NULL, NULL, 178498),
(178499, '3.40.50.720-FF-001328', NULL, 'mRNA, partial cds, clone: RAFL22-45-J20', 263, NULL, NULL, 178499),
(178500, '3.30.830.10-FF-000070', NULL, 'Mitochondrial processing peptidase alpha subunit, putative', 223, NULL, NULL, 178500),
(178501, '1.20.1560.10-FF-000703', NULL, 'HlyB/MsbA family ABC transporter', 325, NULL, NULL, 178501),
(178502, '2.60.40.10-FF-005777', NULL, NULL, 110, NULL, NULL, 178502),
(178503, '3.40.50.1480-FF-000015', NULL, 'Adenosylhomocysteinase', 139, NULL, NULL, 178503),
(178504, '1.20.58.420-FF-000002', NULL, 'Alpha-hemoglobin-stabilizing protein', 102, NULL, NULL, 178504),
(178505, '1.10.630.10-FF-000358', NULL, 'Cytochrome P450, putative (Eurofung)', 469, NULL, NULL, 178505),
(178506, '2.10.70.10-FF-000284', NULL, 'Uncharacterized protein', 59, NULL, NULL, 178506),
(178507, '3.30.70.270-FF-000070', NULL, 'DNA polymerase IV', 44, NULL, NULL, 178507),
(178508, '1.20.1070.10-FF-000211', NULL, 'Melanocyte-stimulating hormone receptor', 289, NULL, NULL, 178508),
(178509, '3.40.140.10-FF-000222', NULL, 'Predicted protein', 180, NULL, NULL, 178509),
(178510, '1.10.420.10-FF-000051', NULL, 'Peroxidase family protein', 28, NULL, NULL, 178510),
(178511, '2.30.170.20-FF-000019', NULL, 'Os07g0224000 protein', 90, NULL, NULL, 178511),
(178512, '3.40.50.300-FF-008077', NULL, 'Predicted protein', 118, NULL, NULL, 178512),
(178513, '4.10.400.10-FF-000318', NULL, 'Cortical granule serine protease 1; Uncharacterized protein', 44, NULL, NULL, 178513),
(178514, '3.40.50.720-FF-000103', NULL, 'Glyoxylate/hydroxypyruvate reductase B', 116, NULL, NULL, 178514),
(178515, '2.60.200.20-FF-000213', NULL, 'Uncharacterized protein', 119, NULL, NULL, 178515),
(178516, '3.40.309.10-FF-000013', NULL, 'N-succinylglutamate 5-semialdehyde dehydrogenase', 191, NULL, NULL, 178516),
(178517, '3.40.50.300-FF-005468', NULL, 'RAD50 DNA repair protein, putative', 307, NULL, NULL, 178517),
(178518, '2.130.10.10-FF-004861', NULL, 'Uncharacterized protein', 124, NULL, NULL, 178518),
(178519, '3.40.640.10-FF-000362', NULL, 'Aspartate aminotransferase', 87, NULL, NULL, 178519),
(178520, '1.10.472.10-FF-000221', NULL, 'G1/S-specific cyclin e2-like protein', 113, NULL, NULL, 178520);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(178521, '2.30.29.30-FF-001166', NULL, 'Uncharacterized protein', 103, NULL, NULL, 178521),
(178522, '2.40.10.10-FF-000088', NULL, 'kallikrein-6 isoform X1', 90, NULL, NULL, 178522),
(178523, '3.40.50.2300-FF-001306', NULL, NULL, 123, NULL, NULL, 178523),
(178524, '3.40.50.300-FF-006896', NULL, 'GPN-loop GTPase', 241, NULL, NULL, 178524),
(178525, '1.20.144.10-FF-000018', NULL, 'Glucose-6-phosphatase', 194, NULL, NULL, 178525),
(178526, '3.30.390.30-FF-000024', NULL, 'Glutathione reductase', 121, NULL, NULL, 178526),
(178527, '3.50.30.30-FF-000047', NULL, 'Lipoprotein aminopeptidase LpqL', 129, NULL, NULL, 178527),
(178528, '3.30.1120.100-FF-000001', NULL, 'Fatty acid synthase beta subunit dehydratase', 133, NULL, NULL, 178528),
(178529, '1.20.120.980-FF-000023', NULL, 'Serine protease', 162, NULL, NULL, 178529),
(178530, '2.30.29.30-FF-000261', NULL, 'Epidermal growth factor receptor kinase substrate 8-like protein 1', 140, NULL, NULL, 178530),
(178531, '3.30.497.10-FF-000171', NULL, 'Uncharacterized protein', 218, NULL, NULL, 178531),
(178532, '3.50.50.60-FF-001277', NULL, 'Polyamine oxidase', 62, NULL, NULL, 178532),
(178533, '2.150.10.10-FF-000009', NULL, 'Mannuronan C-5-epimerase', 99, NULL, NULL, 178533),
(178534, '3.80.10.10-FF-002495', NULL, 'Protein phosphatase 2C, putative', 192, NULL, NULL, 178534),
(178535, '2.120.10.80-FF-000200', NULL, 'Kelch like family member 40', 129, NULL, NULL, 178535),
(178536, '3.20.20.70-FF-000184', NULL, 'Stachyose synthase', 272, NULL, NULL, 178536),
(178537, '3.10.100.10-FF-000131', NULL, 'Lymphocyte antigen 75', 154, NULL, NULL, 178537),
(178538, '1.10.1750.10-FF-000012', NULL, NULL, 99, NULL, NULL, 178538),
(178539, '1.10.1420.10-FF-000027', NULL, 'DNA mismatch repair protein', 125, NULL, NULL, 178539),
(178540, '3.30.40.10-FF-001476', NULL, 'Uncharacterized protein', 84, NULL, NULL, 178540),
(178541, '3.30.450.20-FF-000638', NULL, 'Chromosome 8, whole genome shotgun sequence', 96, NULL, NULL, 178541),
(178542, '3.40.250.10-FF-000051', NULL, 'Protein tyrosine phosphatase (Pyp1), putative', 143, NULL, NULL, 178542),
(178543, '2.20.100.10-FF-000144', NULL, 'AGAP011765-PA', 80, NULL, NULL, 178543),
(178544, '3.30.160.20-FF-000195', NULL, 'Uncharacterized protein', 71, NULL, NULL, 178544),
(178545, '2.120.10.80-FF-000324', NULL, 'Predicted protein', 158, NULL, NULL, 178545),
(178546, '1.20.58.60-FF-000710', NULL, 'Uncharacterized protein', 110, NULL, NULL, 178546),
(178547, '1.10.238.10-FF-000357', NULL, 'Phosphoinositide phospholipase C', 50, NULL, NULL, 178547),
(178548, '3.40.50.300-FF-001253', NULL, 'ATP-binding cassette protein subfamily A, member 10', 243, NULL, NULL, 178548),
(178549, '3.40.50.2000-FF-000593', NULL, 'Uncharacterized protein', 254, NULL, NULL, 178549),
(178550, '2.40.50.40-FF-000026', NULL, 'C-C motif chemokine 25', 76, NULL, NULL, 178550),
(178551, '3.30.300.10-FF-000041', NULL, 'S-adenosylmethionine synthase', 137, NULL, NULL, 178551),
(178552, '3.30.70.141-FF-000032', NULL, NULL, 112, NULL, NULL, 178552),
(178553, '3.30.565.10-FF-000514', NULL, 'Two component signal transduction system histidine kinase RstB', 149, NULL, NULL, 178553),
(178554, '1.20.1530.20-FF-000019', NULL, 'Cation/H(+) antiporter 1', 409, NULL, NULL, 178554),
(178555, '1.10.3210.10-FF-000124', NULL, 'Metal dependent phosphohydrolase', 308, NULL, NULL, 178555),
(178556, '3.20.20.140-FF-000444', NULL, 'Uncharacterized protein', 80, NULL, NULL, 178556),
(178557, '2.170.130.10-FF-000026', NULL, 'TonB-dependent siderophore receptor', 122, NULL, NULL, 178557),
(178558, '1.25.40.20-FF-001783', NULL, 'Uncharacterized protein', 181, NULL, NULL, 178558),
(178559, '3.40.50.2300-FF-000025', NULL, 'glutamate receptor ionotropic, NMDA 1 isoform X1', 165, NULL, NULL, 178559),
(178560, '3.30.420.40-FF-000643', NULL, 'Ppx/GppA phosphatase', 124, NULL, NULL, 178560),
(178561, '2.40.50.1020-FF-000007', NULL, 'Two-component system response regulator', 115, NULL, NULL, 178561),
(178562, '3.30.40.10-FF-001656', NULL, 'Uncharacterized protein', 141, NULL, NULL, 178562),
(178563, '2.70.150.10-FF-000107', NULL, 'Phospholipid-transporting ATPase', 155, NULL, NULL, 178563);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(178564, '3.40.50.150-FF-000387', NULL, 'dTDP-3-amino-3,6-dideoxy-alpha-D-glucopyranose N,N-dimethyltransferase', 150, NULL, NULL, 178564),
(178565, '3.40.50.1440-FF-000115', NULL, 'Tubulin gamma chain', 279, NULL, NULL, 178565),
(178566, '3.40.50.300-FF-004423', NULL, 'ATP-dependent chaperone, putative', 176, NULL, NULL, 178566),
(178567, '3.50.4.10-FF-000027', NULL, 'Plasminogen', 80, NULL, NULL, 178567),
(178568, '3.30.160.60-FF-000151', NULL, 'Zinc finger and SCAN domain-containing 21', 29, NULL, NULL, 178568),
(178569, '3.10.110.10-FF-000216', NULL, 'Uncharacterized protein', 161, NULL, NULL, 178569),
(178570, '3.80.10.10-FF-002675', NULL, 'Receptor protein-tyrosine kinase CEPR2 isoform A', 109, NULL, NULL, 178570),
(178571, '2.50.20.10-FF-000009', NULL, 'Outer-membrane lipoprotein LolB', 171, NULL, NULL, 178571),
(178572, '3.90.550.10-FF-000473', NULL, 'Expressed protein', 216, NULL, NULL, 178572),
(178573, '2.40.30.160-FF-000002', NULL, 'Aminomethyltransferase, putative', 54, NULL, NULL, 178573),
(178574, '3.30.1680.10-FF-000074', NULL, 'Uncharacterized protein', 68, NULL, NULL, 178574),
(178575, '1.10.10.10-FF-002059', NULL, 'AI-3-responsive two component signal transduction system response regulator QseB', 97, NULL, NULL, 178575),
(178576, '2.30.33.40-FF-000026', NULL, 'Sterile alpha motif (SAM) domain-containing protein', 61, NULL, NULL, 178576),
(178577, '1.10.510.10-FF-002519', NULL, NULL, 260, NULL, NULL, 178577),
(178578, '3.40.50.10190-FF-000137', NULL, 'Mutagen-sensitive 101', 104, NULL, NULL, 178578),
(178579, '2.130.10.10-FF-003349', NULL, 'Predicted protein', 237, NULL, NULL, 178579),
(178580, '2.30.30.40-FF-000576', NULL, 'Cdc42 guanine nucleotide exchange factor (GEF) 9b', 59, NULL, NULL, 178580),
(178581, '3.40.50.1820-FF-001056', NULL, 'Carboxypeptidase', 391, NULL, NULL, 178581),
(178582, '1.10.510.10-FF-003188', NULL, NULL, 152, NULL, NULL, 178582),
(178583, '2.130.10.10-FF-001539', NULL, 'AASDH isoform 3', 133, NULL, NULL, 178583),
(178584, '2.60.40.150-FF-000519', NULL, 'Probable serine/threonine-protein kinase DDB_G0288795', 156, NULL, NULL, 178584),
(178585, '3.30.70.330-FF-001914', NULL, NULL, 64, NULL, NULL, 178585),
(178586, '3.20.80.10-FF-000023', NULL, 'Uncharacterized protein', 171, NULL, NULL, 178586),
(178587, '3.80.10.10-FF-000202', NULL, 'protein scribble homolog isoform X2', 68, NULL, NULL, 178587),
(178588, '3.30.230.130-FF-000076', NULL, 'Uncharacterized protein', 152, NULL, NULL, 178588),
(178589, '1.20.1070.10-FF-001964', NULL, 'Uncharacterized protein', 188, NULL, NULL, 178589),
(178590, '3.40.390.10-FF-000201', NULL, NULL, 195, NULL, NULL, 178590),
(178591, '3.30.450.20-FF-000077', NULL, 'Hybrid signal transduction histidine kinase', 116, NULL, NULL, 178591),
(178592, '1.25.40.10-FF-000886', NULL, 'Pentatricopeptide repeat-containing protein', 105, NULL, NULL, 178592),
(178593, '3.10.450.40-FF-000014', NULL, 'Peroxisomal primary amine oxidase', 109, NULL, NULL, 178593),
(178594, '2.30.42.10-FF-000016', NULL, 'peripheral plasma membrane protein CASK isoform X2', 90, NULL, NULL, 178594),
(178595, '2.170.190.11-FF-000020', NULL, 'Molybdopterin molybdenumtransferase', 95, NULL, NULL, 178595),
(178596, '3.40.50.720-FF-001480', NULL, 'dTDP-fucopyranose mutase', 164, NULL, NULL, 178596),
(178597, '1.10.3080.10-FF-000006', NULL, 'Chloride channel protein', 465, NULL, NULL, 178597),
(178598, '1.25.40.10-FF-001162', NULL, 'Pentatricopeptide repeat-containing protein', 308, NULL, NULL, 178598),
(178599, '3.40.50.300-FF-006609', NULL, 'Uncharacterized protein', 95, NULL, NULL, 178599),
(178600, '3.30.200.20-FF-000154', NULL, 'probable serine/threonine-protein kinase At4g35230', 104, NULL, NULL, 178600),
(178601, '3.30.420.10-FF-000257', NULL, 'Os07g0112200 protein', 143, NULL, NULL, 178601),
(178602, '3.80.10.10-FF-003512', NULL, 'Chromosome 7, whole genome shotgun sequence', 179, NULL, NULL, 178602),
(178603, '1.10.357.10-FF-000021', NULL, 'TetR family transcriptional regulator', 218, NULL, NULL, 178603),
(178604, '1.10.10.60-FF-000168', NULL, 'Telomere repeat-binding factor 1', 57, NULL, NULL, 178604);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(178605, '3.40.50.1980-FF-000103', NULL, 'Nitrogenase MoFe cofactor biosynthesis protein NifN', 145, NULL, NULL, 178605),
(178606, '3.30.1640.10-FF-000032', NULL, 'DNA helicase', 104, NULL, NULL, 178606),
(178607, '2.20.25.10-FF-000016', NULL, 'DNA-directed RNA polymerase II subunit RPB9', 69, NULL, NULL, 178607),
(178608, '1.10.510.10-FF-004481', NULL, NULL, 250, NULL, NULL, 178608),
(178609, '1.20.58.60-FF-000789', NULL, 'Muscle-specific protein 300 kDa, isoform M', 214, NULL, NULL, 178609),
(178610, '3.30.160.60-FF-005647', NULL, NULL, 23, NULL, NULL, 178610),
(178611, '2.130.10.10-FF-002832', NULL, 'Uncharacterized protein', 96, NULL, NULL, 178611),
(178612, '1.25.10.10-FF-000553', NULL, 'dnaJ homolog subfamily C GRV2 isoform X2', 217, NULL, NULL, 178612),
(178613, '2.60.40.790-FF-000132', NULL, NULL, 107, NULL, NULL, 178613),
(178614, '3.20.20.70-FF-000801', NULL, NULL, 181, NULL, NULL, 178614),
(178615, '3.10.290.10-FF-000032', NULL, 'Tyrosine--tRNA ligase', 75, NULL, NULL, 178615),
(178616, '2.40.160.110-FF-000001', NULL, 'lysosome-associated membrane glycoprotein 2 isoform X2', 168, NULL, NULL, 178616),
(178617, '3.30.160.60-FF-006047', NULL, NULL, 58, NULL, NULL, 178617),
(178618, '1.20.120.1080-FF-000032', NULL, 'ATP-dependent RNA helicase', 101, NULL, NULL, 178618),
(178619, '2.130.10.10-FF-000179', NULL, 'Target of rapamycin complex subunit LST8', 305, NULL, NULL, 178619),
(178620, '1.10.10.200-FF-000009', NULL, 'Endogenous retrovirus group K member 10 Pol protein', 49, NULL, NULL, 178620),
(178621, '3.40.50.80-FF-000064', NULL, 'Flavohemoprotein', 134, NULL, NULL, 178621),
(178622, '3.30.70.330-FF-000554', NULL, 'Uncharacterized protein, isoform A', 81, NULL, NULL, 178622),
(178623, '1.20.930.80-FF-000001', NULL, 'DNA primase large subunit', 254, NULL, NULL, 178623),
(178624, '2.60.40.10-FF-005434', NULL, NULL, 93, NULL, NULL, 178624),
(178625, '1.25.40.10-FF-004596', NULL, 'Uncharacterized protein', 169, NULL, NULL, 178625),
(178626, '1.25.40.20-FF-001108', NULL, 'Kinase, NEK', 51, NULL, NULL, 178626),
(178627, '1.20.5.170-FF-000079', NULL, 'Outer capsid protein VP4', 40, NULL, NULL, 178627),
(178628, '3.60.21.10-FF-000065', NULL, 'Purple acid phosphatase', 334, NULL, NULL, 178628),
(178629, '2.60.40.10-FF-002000', NULL, 'Uncharacterized protein, isoform B', 117, NULL, NULL, 178629),
(178630, '3.30.30.10-FF-000014', NULL, NULL, 72, NULL, NULL, 178630),
(178631, '1.10.640.10-FF-000090', NULL, 'Uncharacterized protein', 421, NULL, NULL, 178631),
(178632, '3.40.50.720-FF-000991', NULL, 'Oxidoreductase, short-chain dehydrogenase/reductase family', 261, NULL, NULL, 178632),
(178633, '3.30.160.100-FF-000011', NULL, 'Ribosome hibernation promoting factor', 105, NULL, NULL, 178633),
(178634, '3.90.190.10-FF-000315', NULL, 'Tyrosine-protein phosphatase-like Protein', 176, NULL, NULL, 178634),
(178635, '3.80.10.10-FF-001663', NULL, 'F-box/LRR-repeat protein 14', 114, NULL, NULL, 178635),
(178636, '3.40.190.10-FF-000276', NULL, 'Glutamate receptor 2.3', 57, NULL, NULL, 178636),
(178637, '2.70.98.10-FF-000070', NULL, 'Aldose 1-epimerase-like protein', 116, NULL, NULL, 178637),
(178638, '2.10.270.10-FF-000012', NULL, 'Dextransucrase', 60, NULL, NULL, 178638),
(178639, '3.30.420.40-FF-000412', NULL, 'Polyphosphate glucokinase', 140, NULL, NULL, 178639),
(178640, '2.130.10.10-FF-005873', NULL, 'PAN2-like protein', 306, NULL, NULL, 178640),
(178641, '3.80.10.10-FF-002231', NULL, 'Uncharacterized protein', 270, NULL, NULL, 178641),
(178642, '3.90.190.10-FF-000259', NULL, 'Uncharacterized protein', 239, NULL, NULL, 178642),
(178643, '3.80.10.10-FF-002175', NULL, 'Leucine-rich repeat protein (LRRP), putative', 182, NULL, NULL, 178643),
(178644, '2.130.10.10-FF-002152', NULL, 'Uncharacterized protein', 187, NULL, NULL, 178644),
(178645, '2.60.40.10-FF-003753', NULL, NULL, 103, NULL, NULL, 178645),
(178646, '2.60.40.10-FF-003697', NULL, NULL, 105, NULL, NULL, 178646),
(178647, '3.90.1590.10-FF-000002', NULL, 'Uncharacterized lyase C29B12.13', 132, NULL, NULL, 178647),
(178648, '2.120.10.30-FF-000326', NULL, 'Protein yellow-like Protein', 403, NULL, NULL, 178648);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(178649, '1.20.1250.20-FF-001094', NULL, 'Uncharacterized protein, isoform A', 468, NULL, NULL, 178649),
(178650, '2.130.10.10-FF-001584', NULL, 'Mtor (MTOR) associated protein, LST8 homolog', 326, NULL, NULL, 178650),
(178651, '3.30.420.40-FF-000356', NULL, 'T(6)A37 threonylcarbamoyladenosine biosynthesis protein', 91, NULL, NULL, 178651),
(178652, '1.20.1250.20-FF-001150', NULL, 'Monocarboxylate transporter, putative', 201, NULL, NULL, 178652),
(178653, '3.30.160.60-FF-002736', NULL, 'Zinc finger protein 655', 26, NULL, NULL, 178653),
(178654, '1.20.1280.290-FF-000021', NULL, 'Solute carrier family 50 member 1', 90, NULL, NULL, 178654),
(178655, '3.40.50.1000-FF-000118', NULL, 'Phospholysine phosphohistidine inorganic pyrophosphate phosphatase', 141, NULL, NULL, 178655),
(178656, '4.10.240.10-FF-000098', NULL, 'Expressed protein', 60, NULL, NULL, 178656),
(178657, '2.60.120.1040-FF-000008', NULL, 'Zn finger containing protein', 130, NULL, NULL, 178657),
(178658, '3.30.40.10-FF-001976', NULL, 'Predicted protein', 62, NULL, NULL, 178658),
(178659, '3.40.30.10-FF-000609', NULL, 'Glutathione S-transferase', 84, NULL, NULL, 178659),
(178660, '3.40.20.10-FF-000047', NULL, 'Villin like', 100, NULL, NULL, 178660),
(178661, '3.30.56.70-FF-000007', NULL, 'tRNA (guanine(26)-N(2)/guanine(27)-N(2))-dimethyltransferase', 70, NULL, NULL, 178661),
(178662, '3.30.70.330-FF-000958', NULL, 'RNA binding protein (Rbm8A), putative', 146, NULL, NULL, 178662),
(178663, '3.20.10.10-FF-000036', NULL, '4-amino-4-deoxychorismate lyase', 160, NULL, NULL, 178663),
(178664, '3.40.630.10-FF-000361', NULL, 'Uncharacterized protein', 144, NULL, NULL, 178664),
(178665, '3.30.40.10-FF-001925', NULL, 'Uncharacterized protein', 71, NULL, NULL, 178665),
(178666, '3.10.129.10-FF-000186', NULL, 'Acyl-[acyl-carrier-protein] hydrolase', 204, NULL, NULL, 178666),
(178667, '1.25.40.10-FF-001375', NULL, 'Tetratricopeptide repeat domain 21A', 95, NULL, NULL, 178667),
(178668, '1.10.540.10-FF-000031', NULL, 'Nitroalkane oxidase', 128, NULL, NULL, 178668),
(178669, '3.40.30.10-FF-001166', NULL, 'Uncharacterized protein', 91, NULL, NULL, 178669),
(178670, '3.40.50.1820-FF-001505', NULL, 'Uncharacterized protein', 157, NULL, NULL, 178670),
(178671, '3.10.580.10-FF-000127', NULL, 'Manganese-dependent inorganic pyrophosphatase, putative', 56, NULL, NULL, 178671),
(178672, '3.90.1150.10-FF-000475', NULL, 'Uncharacterized protein', 105, NULL, NULL, 178672),
(178673, '1.10.4080.10-FF-000012', NULL, 'Predicted protein', 78, NULL, NULL, 178673),
(178674, '1.10.238.10-FF-000514', NULL, 'Serine/threonine-protein phosphatase with EF-hands', 100, NULL, NULL, 178674),
(178675, '3.40.50.300-FF-006840', NULL, 'GPN-loop GTPase 2', 264, NULL, NULL, 178675),
(178676, '3.30.500.10-FF-000022', NULL, 'UL16 binding protein 1, isoform CRA_a', 172, NULL, NULL, 178676),
(178677, '3.10.20.90-FF-000336', NULL, 'E3 ubiquitin-protein ligase UHRF2 isoform A', 98, NULL, NULL, 178677),
(178678, '3.30.160.60-FF-000494', NULL, 'ras-responsive element-binding protein 1 isoform X2', 23, NULL, NULL, 178678),
(178679, '2.40.50.990-FF-000002', NULL, 'mRNA export factor elf1', 101, NULL, NULL, 178679),
(178680, '3.60.21.10-FF-000352', NULL, 'Uncharacterized protein F44B9.9', 182, NULL, NULL, 178680),
(178681, '2.60.120.650-FF-000032', NULL, 'Ribosomal oxygenase 2', 240, NULL, NULL, 178681),
(178682, '3.40.50.1820-FF-000252', NULL, 'Related to calmodulin-dependent protein kinase', 282, NULL, NULL, 178682),
(178683, '3.40.50.2300-FF-000525', NULL, 'Transcriptional regulatory protein', 145, NULL, NULL, 178683),
(178684, '3.90.1670.10-FF-000003', NULL, 'Formate dehydrogenase accessory protein FdhE, putative', 157, NULL, NULL, 178684),
(178685, '3.80.10.10-FF-001618', NULL, 'Os06g0587900 protein', 302, NULL, NULL, 178685),
(178686, '1.10.510.10-FF-003076', NULL, NULL, 202, NULL, NULL, 178686),
(178687, '1.10.437.10-FF-000027', NULL, 'Anti-apoptotic protein NR13', 169, NULL, NULL, 178687),
(178688, '2.60.40.770-FF-000025', NULL, 'Lymphocyte antigen 86', 86, NULL, NULL, 178688),
(178689, '2.30.42.10-FF-000460', NULL, NULL, 45, NULL, NULL, 178689);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(178690, '3.50.50.60-FF-001518', NULL, 'Uncharacterized protein', 75, NULL, NULL, 178690),
(178691, '1.20.1070.10-FF-000267', NULL, 'Blast:Neuromedin-U receptor 2', 346, NULL, NULL, 178691),
(178692, '3.40.630.30-FF-000367', NULL, 'GM25645', 91, NULL, NULL, 178692),
(178693, '3.90.226.10-FF-000028', NULL, 'Protease SohB family protein', 156, NULL, NULL, 178693),
(178694, '1.25.10.10-FF-002059', NULL, 'AP-3 complex subunit beta', 154, NULL, NULL, 178694),
(178695, '1.10.140.10-FF-000001', NULL, 'Met repressor', 104, NULL, NULL, 178695),
(178696, '2.60.40.10-FF-002236', NULL, 'Lin-12 And Glp-1 phenotype', 100, NULL, NULL, 178696),
(178697, '1.20.5.1500-FF-000015', NULL, 'Testis-specific Y-encoded-like protein 1', 51, NULL, NULL, 178697),
(178698, '3.40.50.1820-FF-000196', NULL, 'Endoprotease endo-Pro', 190, NULL, NULL, 178698),
(178699, '1.20.200.10-FF-000015', NULL, 'argininosuccinate lyase isoform X2', 228, NULL, NULL, 178699),
(178700, '1.10.287.940-FF-000018', NULL, 'Purinergic receptor P2X5-2', 25, NULL, NULL, 178700),
(178701, '3.40.50.300-FF-003170', NULL, 'Dda DNA helicase', 177, NULL, NULL, 178701),
(178702, '3.40.50.2300-FF-000469', NULL, 'Uncharacterized protein', 267, NULL, NULL, 178702),
(178703, '2.60.40.60-FF-000429', NULL, 'Cadherin 3', 102, NULL, NULL, 178703),
(178704, '1.25.40.10-FF-002628', NULL, 'Multidomain-containing protein family', 247, NULL, NULL, 178704),
(178705, '1.10.510.10-FF-002620', NULL, NULL, 108, NULL, NULL, 178705),
(178706, '1.10.287.110-FF-000270', NULL, 'Cell division protein Ftn2, contains DnaJ domain', 67, NULL, NULL, 178706),
(178707, '2.60.120.260-FF-000477', NULL, 'Anaphase-promoting complex subunit 10', 160, NULL, NULL, 178707),
(178708, '3.40.630.10-FF-000209', NULL, 'Nicalin', 269, NULL, NULL, 178708),
(178709, '3.90.70.10-FF-000177', NULL, 'Cysteine proteinase RD21A', 329, NULL, NULL, 178709),
(178710, '1.10.3210.10-FF-000068', NULL, 'Predicted protein', 181, NULL, NULL, 178710),
(178711, '3.40.50.720-FF-000928', NULL, 'Probable oxidoreductase', 265, NULL, NULL, 178711),
(178712, '3.40.50.1820-FF-001556', NULL, 'Uncharacterized protein', 122, NULL, NULL, 178712),
(178713, '3.40.30.10-FF-000761', NULL, 'Thioredoxin domain-containing protein 9', 81, NULL, NULL, 178713),
(178714, '3.40.50.300-FF-007278', NULL, 'Uncharacterized protein', 154, NULL, NULL, 178714),
(178715, '1.20.120.1240-FF-000052', NULL, 'Uncharacterized protein', 218, NULL, NULL, 178715),
(178716, '1.20.140.150-FF-000109', NULL, 'Uncharacterized protein', 158, NULL, NULL, 178716),
(178717, '3.40.50.150-FF-000123', NULL, 'Putative methyltransferase PMT15', 195, NULL, NULL, 178717),
(178718, '2.60.120.970-FF-000015', NULL, 'Left-right determination factor', 221, NULL, NULL, 178718),
(178719, '2.30.30.40-FF-000571', NULL, 'Uncharacterized protein', 87, NULL, NULL, 178719),
(178720, '3.30.70.260-FF-000185', NULL, 'Uncharacterized protein', 54, NULL, NULL, 178720),
(178721, '2.130.10.10-FF-005766', NULL, 'Peptidyl-prolyl cis-trans isomerase, cyclophilin-type family protein', 108, NULL, NULL, 178721),
(178722, '3.40.50.2300-FF-001082', NULL, NULL, 21, NULL, NULL, 178722),
(178723, '3.40.50.300-FF-003967', NULL, 'Hypothetical ABC transporter ATP-binding protein ybiT', 264, NULL, NULL, 178723),
(178724, '3.40.50.300-FF-007385', NULL, 'Uncharacterized protein', 306, NULL, NULL, 178724),
(178725, '1.10.10.1590-FF-000005', NULL, 'NADH dehydrogenase I, E subunit', 69, NULL, NULL, 178725),
(178726, '3.40.190.10-FF-000225', NULL, 'Amino acid ABC transporter substrate-binding protein', 110, NULL, NULL, 178726),
(178727, '1.10.150.240-FF-000080', NULL, 'HAD superfamily hydrolase, putative', 40, NULL, NULL, 178727),
(178728, '3.30.160.60-FF-001432', NULL, 'Zinc finger protein 571', 30, NULL, NULL, 178728),
(178729, '2.60.40.1730-FF-000081', NULL, NULL, 190, NULL, NULL, 178729),
(178730, '1.10.357.10-FF-000026', NULL, 'TetR family transcriptional regulator', 184, NULL, NULL, 178730),
(178731, '2.120.10.80-FF-000032', NULL, 'Gigaxonin', 311, NULL, NULL, 178731),
(178732, '3.40.50.150-FF-000230', NULL, 'tRNA (Guanine-N(7)-)-methyltransferase', 220, NULL, NULL, 178732);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(178733, '3.30.160.60-FF-001836', NULL, 'HKR1, GLI-Kruppel zinc finger family member', 24, NULL, NULL, 178733),
(178734, '2.40.160.210-FF-000020', NULL, 'Uncharacterized protein', 326, NULL, NULL, 178734),
(178735, '2.40.50.140-FF-000388', NULL, 'SsDNA binding protein, putative', 117, NULL, NULL, 178735),
(178736, '3.40.250.10-FF-000219', NULL, 'Dual specificity phosphatase ibp1', 138, NULL, NULL, 178736),
(178737, '3.30.70.330-FF-000110', NULL, 'RNA-binding protein 10 isoform X1', 97, NULL, NULL, 178737),
(178738, '1.25.40.10-FF-002679', NULL, 'peroxisomal targeting signal 1 receptor', 326, NULL, NULL, 178738),
(178739, '3.40.50.620-FF-000668', NULL, 'Probable isoleucine--tRNA ligase, cytoplasmic', 300, NULL, NULL, 178739),
(178740, '3.30.40.10-FF-001240', NULL, 'JmjC domain-containing histone demethylase, putative', 51, NULL, NULL, 178740),
(178741, '3.60.15.10-FF-000236', NULL, 'Protein CBR-NAPE-2', 180, NULL, NULL, 178741),
(178742, '3.40.50.10810-FF-000155', NULL, 'Uncharacterized protein', 89, NULL, NULL, 178742),
(178743, '3.30.310.50-FF-000031', NULL, 'Phosphohexomutase (Phosphoglucomutase / phosphomannomutase)', 82, NULL, NULL, 178743),
(178744, '3.40.1690.10-FF-000010', NULL, 'FlhB/HrpN/YscU/SpaS domain protein', 83, NULL, NULL, 178744),
(178745, '3.40.850.10-FF-000304', NULL, 'Kinesin-like protein', 362, NULL, NULL, 178745),
(178746, '3.30.70.920-FF-000017', NULL, 'Transcriptional regulator, AsnC family', 84, NULL, NULL, 178746),
(178747, '2.60.120.970-FF-000066', NULL, 'Predicted protein', 150, NULL, NULL, 178747),
(178748, '1.20.120.730-FF-000021', NULL, 'Protein transport protein SEC23', 148, NULL, NULL, 178748),
(178749, '3.30.70.330-FF-001807', NULL, NULL, 94, NULL, NULL, 178749),
(178750, '3.40.50.300-FF-005480', NULL, 'DNA helicase', 209, NULL, NULL, 178750),
(178751, '3.90.1290.10-FF-000013', NULL, 'dystonin isoform X7', 183, NULL, NULL, 178751),
(178752, '3.20.20.150-FF-000060', NULL, 'Uncharacterized protein', 125, NULL, NULL, 178752),
(178753, '3.80.10.10-FF-002967', NULL, 'Uncharacterized protein', 141, NULL, NULL, 178753),
(178754, '2.30.30.40-FF-000008', NULL, 'Disks large homolog 1 isoform 2', 27, NULL, NULL, 178754),
(178755, '1.50.40.10-FF-000294', NULL, 'Mitochondrial glycine transporter', 112, NULL, NULL, 178755),
(178756, '1.20.1070.10-FF-002184', NULL, 'Uncharacterized protein', 93, NULL, NULL, 178756),
(178757, '1.20.1070.10-FF-001672', NULL, 'Uncharacterized protein', 124, NULL, NULL, 178757),
(178758, '2.130.10.10-FF-005081', NULL, 'Uncharacterized protein', 265, NULL, NULL, 178758),
(178759, '3.30.450.40-FF-000184', NULL, 'Transcriptional regulator', 165, NULL, NULL, 178759),
(178760, '3.40.50.450-FF-000095', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit alpha 2', 105, NULL, NULL, 178760),
(178761, '3.30.160.60-FF-006215', NULL, NULL, 27, NULL, NULL, 178761),
(178762, '3.30.160.60-FF-006103', NULL, NULL, 87, NULL, NULL, 178762),
(178763, '3.80.10.10-FF-001770', NULL, 'Si:dkey-121n8.7', 249, NULL, NULL, 178763),
(178764, '3.30.30.30-FF-000060', NULL, 'Uncharacterized protein', 63, NULL, NULL, 178764),
(178765, '3.30.200.20-FF-001615', NULL, NULL, 99, NULL, NULL, 178765),
(178766, '3.30.300.30-FF-000024', NULL, 'Lipoprotein', 93, NULL, NULL, 178766),
(178767, '1.10.340.30-FF-000033', NULL, 'DNA-3-methyladenine glycosidase II', 110, NULL, NULL, 178767),
(178768, '1.10.510.10-FF-003924', NULL, NULL, 74, NULL, NULL, 178768),
(178769, '3.30.160.60-FF-003293', NULL, 'Expressed sequence AI877918', 28, NULL, NULL, 178769),
(178770, '3.30.70.240-FF-000027', NULL, 'U5 small nuclear ribonucleoprotein component, putative', 122, NULL, NULL, 178770),
(178771, '3.40.190.10-FF-000169', NULL, 'ABC transporter, substrate-binding protein, family 3', 111, NULL, NULL, 178771),
(178772, '1.10.510.10-FF-004436', NULL, NULL, 56, NULL, NULL, 178772),
(178773, '1.10.3110.10-FF-000009', NULL, 'Amine oxidase', 89, NULL, NULL, 178773),
(178774, '3.90.550.10-FF-000450', NULL, 'UDP-N-acetylglucosamine diphosphorylase 2', 185, NULL, NULL, 178774),
(178775, '2.120.10.80-FF-000083', NULL, 'Regulatory protein ral2, variant', 206, NULL, NULL, 178775);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(178776, '3.20.20.70-FF-000133', NULL, 'N-acetylneuraminate pyruvate lyase', 314, NULL, NULL, 178776),
(178777, '1.10.8.60-FF-000532', NULL, 'Uncharacterized protein', 75, NULL, NULL, 178777),
(178778, '3.40.50.2000-FF-001110', NULL, 'Uncharacterized protein', 12, NULL, NULL, 178778),
(178779, '1.10.1070.11-FF-000046', NULL, 'Phosphatidylinositol 3-kinase, putative', 190, NULL, NULL, 178779),
(178780, '2.10.60.10-FF-000019', NULL, 'Urokinase plasminogen activator surface receptor', 88, NULL, NULL, 178780),
(178781, '3.40.50.300-FF-002506', NULL, 'Uncharacterized protein, isoform A', 241, NULL, NULL, 178781),
(178782, '2.130.10.10-FF-005822', NULL, 'WD repeat and HMG-box DNA-binding protein 1', 64, NULL, NULL, 178782),
(178783, '3.30.230.70-FF-000036', NULL, 'Exosome complex subunit Rrp46, putative', 210, NULL, NULL, 178783),
(178784, '1.10.720.30-FF-000079', NULL, 'Uncharacterized protein', 67, NULL, NULL, 178784),
(178785, '1.25.40.720-FF-000021', NULL, 'Uncharacterized protein', 107, NULL, NULL, 178785),
(178786, '2.40.33.10-FF-000017', NULL, 'AT14039p', 103, NULL, NULL, 178786),
(178787, '1.25.10.10-FF-001547', NULL, 'Uncharacterized protein', 309, NULL, NULL, 178787),
(178788, '2.10.25.10-FF-000718', NULL, 'Notch receptor 3', 39, NULL, NULL, 178788),
(178789, '1.20.120.1220-FF-000001', NULL, 'Type 4 prepilin-like proteins leader peptide-processing enzyme', 159, NULL, NULL, 178789),
(178790, '1.10.10.1340-FF-000003', NULL, 'Mediator of RNA polymerase II transcription subunit 31', 84, NULL, NULL, 178790),
(178791, '1.10.10.10-FF-000018', NULL, 'DNA-binding response regulator ResD', 107, NULL, NULL, 178791),
(178792, '2.40.50.100-FF-000224', NULL, 'Sulfate/molybdate ABC transporter, ATP-binding protein', 69, NULL, NULL, 178792),
(178793, '2.60.40.10-FF-002348', NULL, 'High Incidence of Males (Increased X chromosome loss)', 96, NULL, NULL, 178793),
(178794, '3.90.79.10-FF-000146', NULL, 'Adenine DNA glycosylase', 170, NULL, NULL, 178794),
(178795, '3.40.30.10-FF-001273', NULL, 'Calsequestrin', 50, NULL, NULL, 178795),
(178796, '1.10.510.10-FF-002564', NULL, 'Uncharacterized protein', 261, NULL, NULL, 178796),
(178797, '3.30.870.10-FF-000128', NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', 213, NULL, NULL, 178797),
(178798, '3.90.70.10-FF-000065', NULL, 'Ubiquitin carboxyl-terminal hydrolase 32', 192, NULL, NULL, 178798),
(178799, '3.90.226.10-FF-000091', NULL, 'Probable methylcrotonyl-CoA carboxylase beta chain, mitochondrial', 245, NULL, NULL, 178799),
(178800, '3.40.50.300-FF-003855', NULL, 'Chromosome 23, whole genome shotgun sequence', 161, NULL, NULL, 178800),
(178801, '1.10.287.110-FF-000118', NULL, 'DnaJ domain-containing protein', 95, NULL, NULL, 178801),
(178802, '2.10.25.10-FF-001293', NULL, 'Uncharacterized protein', 42, NULL, NULL, 178802),
(178803, '3.30.2010.10-FF-000001', NULL, 'Protease HtpX', 94, NULL, NULL, 178803),
(178804, '2.60.40.10-FF-004653', NULL, NULL, 88, NULL, NULL, 178804),
(178805, '3.90.132.10-FF-000029', NULL, 'GP63-like', 123, NULL, NULL, 178805),
(178806, '3.30.10.30-FF-000002', NULL, 'Dual specificity tyrosine-phosphorylation-regulated kinase 4', 81, NULL, NULL, 178806),
(178807, '3.30.70.330-FF-002471', NULL, NULL, 81, NULL, NULL, 178807),
(178808, '1.10.472.10-FF-000721', NULL, 'Predicted protein', 114, NULL, NULL, 178808),
(178809, '2.130.10.10-FF-002096', NULL, 'WD repeat protein, putative', 297, NULL, NULL, 178809),
(178810, '1.20.1250.20-FF-000694', NULL, 'Vesicular acetylcholine transporter unc-17', 393, NULL, NULL, 178810),
(178811, '1.10.3210.10-FF-000045', NULL, 'Two-component system response regulator', 194, NULL, NULL, 178811),
(178812, '3.40.50.360-FF-000068', NULL, 'S-adenosyl-L-methionine-dependent tRNA 4-demethylwyosine synthase', 207, NULL, NULL, 178812),
(178813, '1.10.510.10-FF-000203', NULL, 'Cyclin-dependent kinase 9', 223, NULL, NULL, 178813),
(178814, '3.20.20.70-FF-000189', NULL, 'Nitronate monooxygenase', 374, NULL, NULL, 178814),
(178815, '2.130.10.10-FF-003456', NULL, 'Protein kinase family protein / WD-40 repeat family protein', 98, NULL, NULL, 178815);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(178816, '3.30.1390.20-FF-000032', NULL, 'Uncharacterized protein', 107, NULL, NULL, 178816),
(178817, '1.20.140.10-FF-000009', NULL, 'Acyl-CoA dehydrogenase', 147, NULL, NULL, 178817),
(178818, '1.20.1070.10-FF-000323', NULL, 'Uncharacterized protein', 317, NULL, NULL, 178818),
(178819, '3.90.79.20-FF-000031', NULL, 'Uncharacterized protein', 84, NULL, NULL, 178819),
(178820, '2.60.120.560-FF-000005', NULL, 'LCCL domain-containing protein', 173, NULL, NULL, 178820),
(178821, '3.30.1520.10-FF-000085', NULL, 'Liver stage antigen-like protein/ PX domain', 112, NULL, NULL, 178821),
(178822, '1.25.10.10-FF-000261', NULL, '26S proteasome non-ATPase regulatory subunit 5', 179, NULL, NULL, 178822),
(178823, '1.25.10.10-FF-002907', NULL, 'Os07g0693400 protein', 125, NULL, NULL, 178823),
(178824, '3.60.21.10-FF-000296', NULL, 'Phosphoprotein phosphatase, putative', 301, NULL, NULL, 178824),
(178825, '2.10.25.10-FF-000893', NULL, 'Uncharacterized protein', 38, NULL, NULL, 178825),
(178826, '2.40.30.10-FF-000095', NULL, 'Elongation factor Tu family protein', 185, NULL, NULL, 178826),
(178827, '1.20.950.20-FF-000029', NULL, 'Glr1270 protein', 77, NULL, NULL, 178827),
(178828, '1.10.510.10-FF-001215', NULL, 'Protein kinase domain containing protein, expressed', 207, NULL, NULL, 178828),
(178829, '3.30.450.20-FF-000318', NULL, 'Hypoxia-inducible factor 1 subunit alpha,-like', 70, NULL, NULL, 178829),
(178830, '3.30.200.20-FF-000603', NULL, 'EKC/KEOPS complex subunit bud32', 75, NULL, NULL, 178830),
(178831, '1.10.510.10-FF-002019', NULL, NULL, 172, NULL, NULL, 178831),
(178832, '1.25.40.20-FF-001608', NULL, 'Uncharacterized protein', 108, NULL, NULL, 178832),
(178833, '2.60.40.1820-FF-000012', NULL, 'Uncharacterized protein', 44, NULL, NULL, 178833),
(178834, '2.30.30.110-FF-000001', NULL, 'Endoribonuclease toxin MazF', 111, NULL, NULL, 178834),
(178835, '3.30.200.20-FF-000311', NULL, 'N-terminal kinase-like protein isoform X2', 91, NULL, NULL, 178835),
(178836, '3.30.497.10-FF-000064', NULL, 'Serine (or cysteine) peptidase inhibitor, clade B, member 6b', 107, NULL, NULL, 178836),
(178837, '3.80.10.10-FF-004529', NULL, 'Uncharacterized protein', 212, NULL, NULL, 178837),
(178838, '3.90.80.10-FF-000003', NULL, 'Inorganic pyrophosphatase', 175, NULL, NULL, 178838),
(178839, '3.10.20.30-FF-000009', NULL, 'Succinate dehydrogenase iron-sulfur subunit', 104, NULL, NULL, 178839),
(178840, '1.20.5.110-FF-000196', NULL, 'Probable Golgi SNAP receptor complex member 2', 76, NULL, NULL, 178840),
(178841, '1.10.3130.10-FF-000011', NULL, 'Serine acetyltransferase', 148, NULL, NULL, 178841),
(178842, '2.60.120.10-FF-000451', NULL, 'Phosphomannose isomerase type I', 104, NULL, NULL, 178842),
(178843, '3.40.190.10-FF-000164', NULL, 'ATP phosphoribosyltransferase', 108, NULL, NULL, 178843),
(178844, '2.120.10.30-FF-000438', NULL, 'Uncharacterized protein', 125, NULL, NULL, 178844),
(178845, '3.90.1150.10-FF-000071', NULL, 'Kynureninase', 151, NULL, NULL, 178845),
(178846, '1.10.720.30-FF-000074', NULL, 'Uncharacterized protein', 48, NULL, NULL, 178846),
(178847, '3.30.160.60-FF-005198', NULL, NULL, 20, NULL, NULL, 178847),
(178848, '3.30.70.330-FF-001414', NULL, 'Uncharacterized protein', 98, NULL, NULL, 178848),
(178849, '3.30.70.330-FF-001358', NULL, 'WGS project CABT00000000 data, contig 2.5', 67, NULL, NULL, 178849),
(178850, '3.30.160.60-FF-004653', NULL, NULL, 33, NULL, NULL, 178850),
(178851, '3.30.200.20-FF-001059', NULL, 'Tyrosine-protein kinase', 98, NULL, NULL, 178851),
(178852, '2.30.29.30-FF-000497', NULL, 'Phospholipase', 131, NULL, NULL, 178852),
(178853, '2.10.90.10-FF-000139', NULL, 'Bone morphogenetic protein, putative', 115, NULL, NULL, 178853),
(178854, '1.20.58.80-FF-000036', NULL, 'Vacuolar sorting protein-associating protein 4A, putative', 71, NULL, NULL, 178854),
(178855, '1.10.238.20-FF-000051', NULL, 'Odorant-binding protein 83ef', 116, NULL, NULL, 178855),
(178856, '1.10.2000.10-FF-000057', NULL, NULL, 113, NULL, NULL, 178856),
(178857, '2.130.10.10-FF-003905', NULL, 'Uncharacterized protein', 268, NULL, NULL, 178857);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(178858, '3.40.50.300-FF-005709', NULL, 'Peptidase S24-like family protein', 170, NULL, NULL, 178858),
(178859, '3.80.30.20-FF-000026', NULL, 'Predicted protein', 74, NULL, NULL, 178859),
(178860, '3.30.750.24-FF-000048', NULL, 'Sulfate permease family protein', 120, NULL, NULL, 178860),
(178861, '1.20.5.190-FF-000118', NULL, NULL, 51, NULL, NULL, 178861),
(178862, '2.60.40.60-FF-000368', NULL, 'Cadherin 74A, isoform A', 114, NULL, NULL, 178862),
(178863, '2.60.40.10-FF-001387', NULL, 'CD101 molecule', 120, NULL, NULL, 178863),
(178864, '1.20.90.10-FF-000040', NULL, NULL, 81, NULL, NULL, 178864),
(178865, '1.10.287.3810-FF-000004', NULL, 'Tryptophan 2,3-dioxygenase', 52, NULL, NULL, 178865),
(178866, '1.10.3210.10-FF-000101', NULL, 'Cyclic di-GMP hydrolase', 180, NULL, NULL, 178866),
(178867, '3.80.10.10-FF-000258', NULL, 'Nyctalopin', 119, NULL, NULL, 178867),
(178868, '1.10.533.10-FF-000003', NULL, 'Caspase recruitment domain family, member 11', 93, NULL, NULL, 178868),
(178869, '2.60.120.920-FF-000080', NULL, 'Uncharacterized protein', 166, NULL, NULL, 178869),
(178870, '2.30.29.30-FF-000845', NULL, 'Predicted protein', 195, NULL, NULL, 178870),
(178871, '3.30.160.60-FF-006108', NULL, NULL, 57, NULL, NULL, 178871),
(178872, '1.10.520.10-FF-000047', NULL, 'Peroxidase', 87, NULL, NULL, 178872),
(178873, '3.40.50.300-FF-004923', NULL, 'Uncharacterized protein', 158, NULL, NULL, 178873),
(178874, '2.40.30.10-FF-000151', NULL, 'Translation elongation factor EF-G', 117, NULL, NULL, 178874),
(178875, '3.30.1490.20-FF-000073', NULL, 'D-alanine--D-alanine ligase', 92, NULL, NULL, 178875),
(178876, '1.10.1740.140-FF-000001', NULL, 'ATP-dependent RNA helicase SUPV3L1, mitochondrial', 129, NULL, NULL, 178876),
(178877, '3.30.160.60-FF-000471', NULL, 'Zinc finger protein AEBP2', 79, NULL, NULL, 178877),
(178878, '3.30.420.10-FF-000757', NULL, NULL, 174, NULL, NULL, 178878),
(178879, '2.40.10.10-FF-000329', NULL, NULL, 84, NULL, NULL, 178879),
(178880, '3.30.70.2850-FF-000024', NULL, 'DNA-directed RNA polymerase I subunit rpa1', 221, NULL, NULL, 178880),
(178881, '1.10.357.10-FF-000077', NULL, 'TetR/AcrR family transcriptional regulator', 202, NULL, NULL, 178881),
(178882, '3.20.20.70-FF-000245', NULL, 'Bifunctional UMP-synthetase', 261, NULL, NULL, 178882),
(178883, '3.80.10.10-FF-000606', NULL, 'F-box and leucine-rich repeat protein 18', 426, NULL, NULL, 178883),
(178884, '3.40.50.10900-FF-000007', NULL, 'Proteasome assembly chaperone 2', 112, NULL, NULL, 178884),
(178885, '1.25.40.90-FF-000011', NULL, 'ADP-ribosylation factor-binding protein GGA3 isoform X1', 163, NULL, NULL, 178885),
(178886, '3.30.470.20-FF-000140', NULL, 'Probable alpha-L-glutamate ligase', 111, NULL, NULL, 178886),
(178887, '2.60.40.10-FF-001836', NULL, 'Immunoglobulin heavy constant mu', 103, NULL, NULL, 178887),
(178888, '3.30.160.60-FF-006159', NULL, NULL, 41, NULL, NULL, 178888),
(178889, '4.10.240.10-FF-000042', NULL, 'Lysine requiring protein', 67, NULL, NULL, 178889),
(178890, '2.60.40.10-FF-002404', NULL, 'Uncharacterized protein', 121, NULL, NULL, 178890),
(178891, '3.40.50.300-FF-001438', NULL, 'ATP-binding cassette sub-family F member 3', 281, NULL, NULL, 178891),
(178892, '2.170.210.10-FF-000004', NULL, 'XRCC4-like factor-domain-containing protein', 129, NULL, NULL, 178892),
(178893, '3.80.10.10-FF-000314', NULL, 'centriolin isoform X4', 162, NULL, NULL, 178893),
(178894, '3.30.450.200-FF-000005', NULL, 'DENN domain-containing protein 5A isoform X2', 145, NULL, NULL, 178894),
(178895, '3.20.20.80-FF-000574', NULL, 'AFR597Wp', 358, NULL, NULL, 178895),
(178896, '3.40.50.1950-FF-000004', NULL, 'Phosphopantothenoylcysteine decarboxylase', 195, NULL, NULL, 178896),
(178897, '1.10.10.60-FF-001028', NULL, NULL, 57, NULL, NULL, 178897),
(178898, '3.40.1770.10-FF-000011', NULL, 'Urocanate hydratase 1', 55, NULL, NULL, 178898),
(178899, '1.25.40.10-FF-003792', NULL, 'Uncharacterized protein', 145, NULL, NULL, 178899),
(178900, '1.20.5.420-FF-000002', NULL, 'Small glutamine-rich tetratricopeptide repeat-containing protein alpha', 68, NULL, NULL, 178900);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(178901, '3.20.20.190-FF-000105', NULL, NULL, 212, NULL, NULL, 178901),
(178902, '1.10.510.10-FF-000254', NULL, 'Serine/threonine-protein kinase RIO3', 141, NULL, NULL, 178902),
(178903, '2.130.10.10-FF-001039', NULL, 'Polyadenylation factor subunit 2', 141, NULL, NULL, 178903),
(178904, '1.10.10.10-FF-000081', NULL, 'DeoR/GlpR family transcriptional regulator', 56, NULL, NULL, 178904),
(178905, '1.10.400.10-FF-000044', NULL, 'Uncharacterized protein', 19, NULL, NULL, 178905),
(178906, '2.130.10.10-FF-003849', NULL, 'Uncharacterized protein', 289, NULL, NULL, 178906),
(178907, '3.80.10.10-FF-003535', NULL, 'Uncharacterized protein', 165, NULL, NULL, 178907),
(178908, '2.30.29.30-FF-000446', NULL, 'Protein kinase, putative', 120, NULL, NULL, 178908),
(178909, '2.160.20.10-FF-000105', NULL, 'Cell surface protein', 201, NULL, NULL, 178909),
(178910, '3.30.160.60-FF-000319', NULL, 'myoneurin isoform X1', 28, NULL, NULL, 178910),
(178911, '1.25.40.10-FF-004360', NULL, 'PPR8522', 154, NULL, NULL, 178911),
(178912, '1.20.1250.20-FF-001498', NULL, 'Uncharacterized protein', 329, NULL, NULL, 178912),
(178913, '2.70.150.10-FF-000282', NULL, 'Phospholipid-transporting ATPase', 143, NULL, NULL, 178913),
(178914, '1.50.10.10-FF-000174', NULL, 'Uncharacterized protein', 404, NULL, NULL, 178914),
(178915, '3.30.720.150-FF-000007', NULL, 'Uncharacterized protein', 92, NULL, NULL, 178915),
(178916, '2.60.120.290-FF-000076', NULL, 'Complement C1r subcomponent like', 133, NULL, NULL, 178916),
(178917, '4.10.400.10-FF-000133', NULL, 'LDL receptor related protein 2', 43, NULL, NULL, 178917),
(178918, '3.30.70.330-FF-001066', NULL, 'U2 small nuclear ribonucleoprotein B', 49, NULL, NULL, 178918),
(178919, '3.30.230.10-FF-000153', NULL, 'AGAP005013-PA', 196, NULL, NULL, 178919),
(178920, '3.30.70.100-FF-000002', NULL, 'V-type proton ATPase subunit C', 90, NULL, NULL, 178920),
(178921, '1.20.5.440-FF-000008', NULL, 'ATP synthase epsilon chain', 44, NULL, NULL, 178921),
(178922, '2.60.40.1670-FF-000034', NULL, NULL, 66, NULL, NULL, 178922),
(178923, '3.30.1640.30-FF-000015', NULL, NULL, 69, NULL, NULL, 178923),
(178924, '3.30.200.20-FF-000654', NULL, 'Uncharacterized protein', 89, NULL, NULL, 178924),
(178925, '1.10.10.10-FF-001946', NULL, 'Uncharacterized protein', 84, NULL, NULL, 178925),
(178926, '3.50.30.20-FF-000005', NULL, 'Carbamoyl-phosphate synthase small chain', 155, NULL, NULL, 178926),
(178927, '2.130.10.10-FF-002944', NULL, 'Dynein intermediate chain 2, ciliary-related protein', 222, NULL, NULL, 178927),
(178928, '1.20.120.1220-FF-000006', NULL, 'Conserved membrane protein of uncharacterized function', 137, NULL, NULL, 178928),
(178929, '3.40.50.12650-FF-000015', NULL, 'Uncharacterized protein', 160, NULL, NULL, 178929),
(178930, '3.30.40.10-FF-001072', NULL, 'Probable E3 ubiquitin-protein ligase XERICO', 77, NULL, NULL, 178930),
(178931, '3.40.1170.60-FF-000036', NULL, NULL, 77, NULL, NULL, 178931),
(178932, '3.30.70.980-FF-000052', NULL, 'Probable transcriptional regulatory protein DR_2548', 83, NULL, NULL, 178932),
(178933, '3.30.70.330-FF-000054', NULL, 'Cytoplasmic polyadenylation element-binding protein 1', 93, NULL, NULL, 178933),
(178934, '3.60.10.10-FF-000091', NULL, 'DNase I-like protein, putative', 419, NULL, NULL, 178934),
(178935, '2.130.10.10-FF-003164', NULL, 'Periodic tryptophan protein 2 homolog', 233, NULL, NULL, 178935),
(178936, '3.90.550.50-FF-000119', NULL, 'Hexosyltransferase', 258, NULL, NULL, 178936),
(178937, '2.40.50.140-FF-000444', NULL, 'Tyrosine--tRNA ligase', 168, NULL, NULL, 178937),
(178938, '1.20.1560.10-FF-000467', NULL, 'Putative ABC transporter, ATP-binding protein', 323, NULL, NULL, 178938),
(178939, '3.40.850.10-FF-000248', NULL, 'Kinesin-like protein', 385, NULL, NULL, 178939),
(178940, '2.60.40.10-FF-005277', NULL, NULL, 84, NULL, NULL, 178940),
(178941, '2.40.50.140-FF-000152', NULL, '30S ribosomal protein S1', 74, NULL, NULL, 178941),
(178942, '3.90.660.20-FF-000012', NULL, 'Phytoene desaturase', 178, NULL, NULL, 178942),
(178943, '2.60.200.20-FF-000269', NULL, 'Microspherule protein 1-like Protein', 151, NULL, NULL, 178943);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(178944, '1.10.10.10-FF-000642', NULL, 'Probable two-component response regulator', 105, NULL, NULL, 178944),
(178945, '3.60.110.10-FF-000019', NULL, 'Glutamine-dependent NAD(+) synthetase', 195, NULL, NULL, 178945),
(178946, '1.10.4160.10-FF-000018', NULL, 'Cytosine permease', 447, NULL, NULL, 178946),
(178947, '2.60.120.260-FF-000533', NULL, 'Uncharacterized protein', 88, NULL, NULL, 178947),
(178948, '1.10.10.10-FF-000586', NULL, 'Uncharacterized protein, isoform B', 116, NULL, NULL, 178948),
(178949, '1.25.40.20-FF-000248', NULL, 'Ankyrin repeat and BTB/POZ domain protein', 110, NULL, NULL, 178949),
(178950, '1.25.40.510-FF-000008', NULL, 'Nucleoporin GLE1', 332, NULL, NULL, 178950),
(178951, '3.10.20.90-FF-000387', NULL, 'Polyubiquitin', 70, NULL, NULL, 178951),
(178952, '3.40.50.10490-FF-000053', NULL, 'Glucose-6-phosphate isomerase', 130, NULL, NULL, 178952),
(178953, '1.10.510.10-FF-002171', NULL, NULL, 204, NULL, NULL, 178953),
(178954, '1.20.58.60-FF-000766', NULL, 'Alpha-actinin A', 253, NULL, NULL, 178954),
(178955, '3.40.50.300-FF-003563', NULL, 'GPN-loop GTPase 3', 259, NULL, NULL, 178955),
(178956, '3.40.30.10-FF-001161', NULL, 'Glutathione S-transferase', 100, NULL, NULL, 178956),
(178957, '3.40.109.10-FF-000032', NULL, 'Putative NAD(P)H nitroreductase', 215, NULL, NULL, 178957),
(178958, '1.25.40.20-FF-000304', NULL, 'Ankyrin repeat and sterile alpha motif domain containing 1A', 111, NULL, NULL, 178958),
(178959, '2.60.40.150-FF-000019', NULL, 'Multiple C2 and transmembrane domain-containing protein 2 isoform 1', 122, NULL, NULL, 178959),
(178960, '3.20.20.140-FF-000467', NULL, 'Uncharacterized protein', 370, NULL, NULL, 178960),
(178961, '3.40.50.1820-FF-001612', NULL, 'Cathepsin A', 67, NULL, NULL, 178961),
(178962, '1.20.1070.10-FF-001380', NULL, 'Uncharacterized protein', 251, NULL, NULL, 178962),
(178963, '3.30.160.60-FF-004310', NULL, NULL, 72, NULL, NULL, 178963),
(178964, '2.160.20.10-FF-000049', NULL, 'Putative exo-beta-1,3-glucanase', 362, NULL, NULL, 178964),
(178965, '3.90.180.10-FF-000202', NULL, 'Uncharacterized protein', 83, NULL, NULL, 178965),
(178966, '1.10.3430.10-FF-000051', NULL, 'Ammonium transporter', 279, NULL, NULL, 178966),
(178967, '1.25.40.470-FF-000075', NULL, 'Uncharacterized protein', 128, NULL, NULL, 178967),
(178968, '3.40.50.360-FF-000124', NULL, 'Neuronal nitric oxide synthase', 149, NULL, NULL, 178968),
(178969, '1.25.40.10-FF-004192', NULL, 'Uncharacterized protein', 78, NULL, NULL, 178969),
(178970, '1.20.1250.40-FF-000020', NULL, 'DNA-directed RNA polymerase III subunit rpc9', 127, NULL, NULL, 178970),
(178971, '2.40.50.140-FF-000096', NULL, 'Transcription elongation factor spt6', 99, NULL, NULL, 178971),
(178972, '1.20.1070.10-FF-001627', NULL, 'Putative olfactory receptor', 142, NULL, NULL, 178972),
(178973, '2.130.10.10-FF-002888', NULL, 'Uncharacterized protein', 163, NULL, NULL, 178973),
(178974, '3.10.100.10-FF-000154', NULL, 'C-type lectin domain family 4 member G', 146, NULL, NULL, 178974),
(178975, '2.60.120.1040-FF-000003', NULL, 'Zinc finger protein zpr1', 140, NULL, NULL, 178975),
(178976, '3.30.200.20-FF-000710', NULL, 'WNK lysine deficient protein kinase 2', 50, NULL, NULL, 178976),
(178977, '3.10.50.10-FF-000011', NULL, 'Uncharacterized protein', 102, NULL, NULL, 178977),
(178978, '2.30.30.40-FF-000520', NULL, 'Tyrosine-protein kinase', 79, NULL, NULL, 178978),
(178979, '3.30.9.10-FF-000111', NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', 99, NULL, NULL, 178979),
(178980, '1.25.10.10-FF-002115', NULL, 'Uncharacterized protein', 234, NULL, NULL, 178980),
(178981, '3.30.559.30-FF-000051', NULL, 'Nonribosomal peptide synthase Pes1', 246, NULL, NULL, 178981),
(178982, '3.40.50.300-FF-008234', NULL, 'Predicted protein', 58, NULL, NULL, 178982),
(178983, '3.90.70.10-FF-000121', NULL, 'Ubiquitinyl hydrolase 1', 207, NULL, NULL, 178983),
(178984, '2.40.50.140-FF-000500', NULL, 'Interferon-activable protein 202', 93, NULL, NULL, 178984),
(178985, '3.40.50.1440-FF-000138', NULL, 'Exosome complex exonuclease RRP44 homolog A', 83, NULL, NULL, 178985);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(178986, '1.10.490.10-FF-000049', NULL, 'Uncharacterized protein', 109, NULL, NULL, 178986),
(178987, '3.40.50.300-FF-003911', NULL, 'Terminase, large subunit', 215, NULL, NULL, 178987),
(178988, '2.115.10.20-FF-000010', NULL, 'Arabinanase/levansucrase/invertase', 324, NULL, NULL, 178988),
(178989, '1.10.238.10-FF-000121', NULL, 'EF-hand calcium-binding domain-containing protein 6', 78, NULL, NULL, 178989),
(178990, '3.40.50.12780-FF-000150', NULL, 'Enniatin synthase', 395, NULL, NULL, 178990),
(178991, '3.40.50.300-FF-007834', NULL, 'ClpC-like protein', 175, NULL, NULL, 178991),
(178992, '1.20.5.190-FF-000181', NULL, NULL, 84, NULL, NULL, 178992),
(178993, '1.25.40.20-FF-000647', NULL, 'BTB/POZ domain and ankyrin repeat-containing protein NH5.2', 176, NULL, NULL, 178993),
(178994, '2.30.180.10-FF-000135', NULL, NULL, 151, NULL, NULL, 178994),
(178995, '1.20.58.100-FF-000024', NULL, NULL, 76, NULL, NULL, 178995),
(178996, '3.40.630.30-FF-000423', NULL, 'uncharacterized protein LOC100176877', 211, NULL, NULL, 178996),
(178997, '2.60.120.10-FF-000794', NULL, 'Uncharacterized protein', 139, NULL, NULL, 178997),
(178998, '3.40.50.1000-FF-000181', NULL, 'HAD family hydrolase', 146, NULL, NULL, 178998),
(178999, '3.30.70.330-FF-001015', NULL, 'Uncharacterized protein', 145, NULL, NULL, 178999),
(179000, '3.30.930.10-FF-000279', NULL, 'Probable serine/threonine-protein kinase ifkC', 442, NULL, NULL, 179000),
(179001, '1.10.1170.10-FF-000041', NULL, 'Inhibitor of apoptosis protein 1 and 2, iap1, iap2, putative', 110, NULL, NULL, 179001),
(179002, '3.30.470.20-FF-000084', NULL, 'Pyruvate carboxylase', 256, NULL, NULL, 179002),
(179003, '1.10.510.10-FF-003132', NULL, NULL, 185, NULL, NULL, 179003),
(179004, '1.10.540.10-FF-000082', NULL, 'Uncharacterized protein', 127, NULL, NULL, 179004),
(179005, '2.40.160.210-FF-000025', NULL, 'Uncharacterized protein', 289, NULL, NULL, 179005),
(179006, '3.90.79.10-FF-000202', NULL, 'DNA topoisomerase I', 140, NULL, NULL, 179006),
(179007, '1.25.40.10-FF-004208', NULL, 'Uncharacterized protein', 66, NULL, NULL, 179007),
(179008, '2.40.50.140-FF-000101', NULL, 'Myeloid cell nuclear differentiation antigen', 111, NULL, NULL, 179008),
(179009, '1.10.1070.11-FF-000102', NULL, 'Predicted protein', 173, NULL, NULL, 179009),
(179010, '3.40.50.1260-FF-000056', NULL, 'Phosphoglycerate kinase', 40, NULL, NULL, 179010),
(179011, '1.20.140.40-FF-000064', NULL, NULL, 157, NULL, NULL, 179011),
(179012, '3.30.1600.10-FF-000012', NULL, 'NAD-dependent protein deacetylase', 96, NULL, NULL, 179012),
(179013, '3.40.630.20-FF-000015', NULL, 'Uncharacterized protein', 228, NULL, NULL, 179013),
(179014, '3.30.479.10-FF-000016', NULL, 'Queuosine biosynthesis protein', 147, NULL, NULL, 179014),
(179015, '1.10.510.10-FF-004144', NULL, NULL, 47, NULL, NULL, 179015),
(179016, '3.90.1750.10-FF-000037', NULL, 'Apoptosis resistant E3 ubiquitin protein ligase 1', 77, NULL, NULL, 179016),
(179017, '2.60.40.60-FF-000424', NULL, 'Uncharacterized protein', 111, NULL, NULL, 179017),
(179018, '3.30.565.10-FF-000110', NULL, 'Sensor histidine kinase', 153, NULL, NULL, 179018),
(179019, '3.10.129.10-FF-000130', NULL, 'Probable 3-hydroxyacyl-thioester dehydratase HtdX', 256, NULL, NULL, 179019),
(179020, '2.40.70.10-FF-000541', NULL, NULL, 187, NULL, NULL, 179020),
(179021, '3.30.160.60-FF-004361', NULL, NULL, 84, NULL, NULL, 179021),
(179022, '3.40.30.10-FF-000710', NULL, 'Uncharacterized protein', 108, NULL, NULL, 179022),
(179023, '3.30.750.24-FF-000104', NULL, 'Sulfate transporter N-terminal domain with GLY motif/Sulfate transporter family', 128, NULL, NULL, 179023),
(179024, '1.10.510.10-FF-003868', NULL, NULL, 96, NULL, NULL, 179024),
(179025, '3.40.190.10-FF-000220', NULL, 'Phosphate binding protein', 149, NULL, NULL, 179025),
(179026, '1.25.40.10-FF-000830', NULL, 'Tetratricopeptide repeat protein', 169, NULL, NULL, 179026),
(179027, '2.60.40.150-FF-000171', NULL, 'Phosphatidylinositol 3-kinase VPS34', 151, NULL, NULL, 179027),
(179028, '3.65.10.20-FF-000015', NULL, 'RNA 3''-terminal phosphate cyclase, putative (AFU_orthologue AFUA_5G07640)', 73, NULL, NULL, 179028);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(179029, '1.10.1200.270-FF-000003', NULL, 'Salicylate/benzoate carboxyl methyltransferase', 126, NULL, NULL, 179029),
(179030, '3.40.50.300-FF-003962', NULL, 'AAA family ATPase', 161, NULL, NULL, 179030),
(179031, '3.10.490.10-FF-000013', NULL, 'Gamma-glutamylcyclotransferase', 189, NULL, NULL, 179031),
(179032, '2.130.10.80-FF-000003', NULL, 'cDNA FLJ40400 fis, clone TESTI2037103', 120, NULL, NULL, 179032),
(179033, '2.60.200.20-FF-000218', NULL, 'Uncharacterized protein', 112, NULL, NULL, 179033),
(179034, '3.10.20.370-FF-000004', NULL, 'Uncharacterized protein', 63, NULL, NULL, 179034),
(179035, '3.40.720.10-FF-000244', NULL, 'Arylsulfatase H', 212, NULL, NULL, 179035),
(179036, '1.10.10.250-FF-000002', NULL, '60S ribosomal protein L12', 83, NULL, NULL, 179036),
(179037, '3.30.750.80-FF-000005', NULL, 'Uncharacterized protein', 103, NULL, NULL, 179037),
(179038, '1.10.150.240-FF-000085', NULL, 'HAD family hydrolase', 61, NULL, NULL, 179038),
(179039, '1.10.8.10-FF-000219', NULL, 'baculoviral IAP repeat-containing protein 3-like', 63, NULL, NULL, 179039),
(179040, '1.25.40.10-FF-000026', NULL, 'Interferon-induced protein with tetratricopeptide repeats 5', 273, NULL, NULL, 179040),
(179041, '3.40.50.2000-FF-000997', NULL, 'Uncharacterized protein', 38, NULL, NULL, 179041),
(179042, '1.50.40.10-FF-000350', NULL, 'Phosphate carrier protein, mitochondrial-like protein', 168, NULL, NULL, 179042),
(179043, '1.20.1730.10-FF-000003', NULL, 'Sodium/pantothenate symporter', 451, NULL, NULL, 179043),
(179044, '1.10.510.10-FF-002856', NULL, NULL, 120, NULL, NULL, 179044),
(179045, '2.30.29.30-FF-000789', NULL, 'ADP ribosylation factor, putative', 113, NULL, NULL, 179045),
(179046, '3.40.50.300-FF-007273', NULL, 'Uncharacterized protein', 155, NULL, NULL, 179046),
(179047, '3.30.1330.30-FF-000149', NULL, 'Uncharacterized protein', 70, NULL, NULL, 179047),
(179048, '1.20.1070.10-FF-001228', NULL, 'Uncharacterized protein', 296, NULL, NULL, 179048),
(179049, '3.30.60.30-FF-000117', NULL, 'GH09228p2', 52, NULL, NULL, 179049),
(179050, '3.30.497.10-FF-000176', NULL, 'Uncharacterized protein', 185, NULL, NULL, 179050),
(179051, '3.40.50.1100-FF-000042', NULL, 'Bifunctional D-cysteine desulfhydrase/1-aminocyclopropane-1-carboxylate deaminase mitochondrial', 201, NULL, NULL, 179051),
(179052, '2.130.10.10-FF-001876', NULL, 'Si:dkey-17m8.1', 236, NULL, NULL, 179052),
(179053, '3.30.420.40-FF-000648', NULL, 'Actin-related protein 4', 30, NULL, NULL, 179053),
(179054, '1.25.10.10-FF-001098', NULL, 'TELO2-interacting protein 1', 208, NULL, NULL, 179054),
(179055, '3.10.50.40-FF-000115', NULL, 'Peptidylprolyl isomerase', 135, NULL, NULL, 179055),
(179056, '4.10.800.20-FF-000015', NULL, 'Uncharacterized protein', 54, NULL, NULL, 179056),
(179057, '1.10.555.10-FF-000172', NULL, NULL, 192, NULL, NULL, 179057),
(179058, '3.30.1370.10-FF-000033', NULL, 'vigilin isoform X1', 71, NULL, NULL, 179058),
(179059, '3.40.50.920-FF-000039', NULL, 'Transketolase', 124, NULL, NULL, 179059),
(179060, '2.60.40.1180-FF-000163', NULL, 'Glycoside hydrolase, family 29, subgroup', 112, NULL, NULL, 179060),
(179061, '2.30.29.30-FF-001227', NULL, 'Si:ch211-248g20.5', 190, NULL, NULL, 179061),
(179062, '2.60.40.10-FF-001331', NULL, 'receptor-type tyrosine-protein phosphatase beta isoform X2', 87, NULL, NULL, 179062),
(179063, '3.90.190.20-FF-000032', NULL, 'Bifunctional folylpolyglutamate synthase/dihydrofolate synthase', 122, NULL, NULL, 179063),
(179064, '3.40.50.300-FF-006492', NULL, 'Predicted protein', 115, NULL, NULL, 179064),
(179065, '3.40.50.1820-FF-001213', NULL, 'Uncharacterized protein', 97, NULL, NULL, 179065),
(179066, '3.40.1110.10-FF-000377', NULL, NULL, 233, NULL, NULL, 179066),
(179067, '1.20.5.110-FF-000084', NULL, 'Syntaxin, Qa-SNARE family', 96, NULL, NULL, 179067),
(179068, '3.40.50.1580-FF-000039', NULL, 'S-methyl-5''-thioadenosine phosphorylase', 274, NULL, NULL, 179068),
(179069, '3.30.1330.40-FF-000034', NULL, 'RidA family protein', 114, NULL, NULL, 179069),
(179070, '3.30.780.10-FF-000014', NULL, 'Translation machinery-associated protein 22', 128, NULL, NULL, 179070); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(179071, '1.10.238.10-FF-000806', NULL, 'Defective in cullin neddylation protein', 35, NULL, NULL, 179071),
(179072, '3.40.50.11980-FF-000016', NULL, 'PRP38 family protein', 45, NULL, NULL, 179072),
(179073, '3.60.21.10-FF-000060', NULL, 'Acid sphingomyelinase family phosphodiesterase', 260, NULL, NULL, 179073),
(179074, '3.40.120.10-FF-000002', NULL, 'Phosphoglucosamine mutase', 84, NULL, NULL, 179074),
(179075, '1.20.120.1750-FF-000109', NULL, 'Uncharacterized protein', 80, NULL, NULL, 179075),
(179076, '1.10.1450.10-FF-000023', NULL, 'Tetraspanin', 121, NULL, NULL, 179076),
(179077, '2.60.120.200-FF-000594', NULL, 'Predicted protein', 158, NULL, NULL, 179077),
(179078, '3.10.20.90-FF-000044', NULL, 'Ubiquitin-fold modifier 1', 86, NULL, NULL, 179078),
(179079, '2.10.50.10-FF-000013', NULL, 'Tumor necrosis factor receptor superfamily member 16', 58, NULL, NULL, 179079),
(179080, '1.20.5.110-FF-000140', NULL, 'Syntaxin 13', 109, NULL, NULL, 179080),
(179081, '1.20.58.390-FF-000122', NULL, 'Uncharacterized protein', 114, NULL, NULL, 179081),
(179082, '4.10.60.10-FF-000234', NULL, 'Uncharacterized protein', 58, NULL, NULL, 179082),
(179083, '2.60.40.10-FF-001275', NULL, 'Immunoglobulin superfamily DCC subclass member 4', 91, NULL, NULL, 179083),
(179084, '3.40.630.30-FF-000075', NULL, 'Glycine N-acyltransferase', 120, NULL, NULL, 179084),
(179085, '1.10.220.10-FF-000007', NULL, 'Annexin', 80, NULL, NULL, 179085),
(179086, '1.20.1270.60-FF-000297', NULL, 'Uncharacterized protein', 140, NULL, NULL, 179086),
(179087, '1.20.120.330-FF-000025', NULL, 'Mannitol operon repressor', 173, NULL, NULL, 179087),
(179088, '3.90.70.10-FF-000626', NULL, 'Predicted protein', 132, NULL, NULL, 179088),
(179089, '3.20.20.80-FF-000810', NULL, 'Predicted protein', 111, NULL, NULL, 179089),
(179090, '1.20.1250.20-FF-000930', NULL, 'Uncharacterized protein', 341, NULL, NULL, 179090),
(179091, '1.10.40.60-FF-000001', NULL, 'Type II secretion system protein K', 117, NULL, NULL, 179091),
(179092, '2.20.28.290-FF-000003', NULL, 'Leucine--tRNA ligase', 48, NULL, NULL, 179092),
(179093, '3.40.640.10-FF-000530', NULL, 'Uncharacterized protein', 83, NULL, NULL, 179093),
(179094, '2.60.120.920-FF-000192', NULL, 'Bloodthirsty-related gene family, member 1', 64, NULL, NULL, 179094),
(179095, '2.130.10.10-FF-003057', NULL, 'Predicted protein', 138, NULL, NULL, 179095),
(179096, '3.40.720.10-FF-000188', NULL, 'Uncharacterized protein', 225, NULL, NULL, 179096),
(179097, '1.20.58.60-FF-000553', NULL, 'Spectrin, beta, non-erythrocytic 5', 283, NULL, NULL, 179097),
(179098, '3.40.50.10860-FF-000029', NULL, 'Shikimate dehydrogenase', 100, NULL, NULL, 179098),
(179099, '1.25.10.10-FF-000710', NULL, 'Nuclear_condensing_complex_subunits_-_C-term_domain_containing_protein_-_putative', 207, NULL, NULL, 179099),
(179100, '1.20.1250.20-FF-001442', NULL, 'sodium-dependent phosphate transport protein 3 isoform X3', 92, NULL, NULL, 179100),
(179101, '3.10.290.10-FF-000083', NULL, 'Probable tyrosine--tRNA ligase, mitochondrial', 104, NULL, NULL, 179101),
(179102, '2.60.40.60-FF-000137', NULL, 'FAT atypical cadherin 4', 105, NULL, NULL, 179102),
(179103, '2.130.10.10-FF-003113', NULL, 'Uncharacterized protein', 372, NULL, NULL, 179103),
(179104, '3.30.1490.80-FF-000012', NULL, 'Glutathione synthetase', 77, NULL, NULL, 179104),
(179105, '1.10.238.10-FF-000913', NULL, 'WD repeat domain 66', 82, NULL, NULL, 179105),
(179106, '2.60.40.340-FF-000014', NULL, NULL, 159, NULL, NULL, 179106),
(179107, '1.25.40.20-FF-001103', NULL, 'Kinase, NEK', 64, NULL, NULL, 179107),
(179108, '3.30.60.20-FF-000019', NULL, 'Serine/threonine-protein kinase', 75, NULL, NULL, 179108),
(179109, '1.20.58.530-FF-000035', NULL, NULL, 153, NULL, NULL, 179109),
(179110, '3.40.50.150-FF-000735', NULL, 'Fmu (Sun) domain protein', 204, NULL, NULL, 179110),
(179111, '3.30.40.10-FF-002089', NULL, 'Histone-lysine N-methyltransferase', 60, NULL, NULL, 179111),
(179112, '1.25.70.10-FF-000034', NULL, 'Os11g0206300 protein', 195, NULL, NULL, 179112),
(179113, '1.10.418.10-FF-000051', NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', 109, NULL, NULL, 179113);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(179114, '2.40.50.140-FF-000949', NULL, NULL, 67, NULL, NULL, 179114),
(179115, '3.10.120.10-FF-000037', NULL, 'GD22062', 106, NULL, NULL, 179115),
(179116, '3.80.10.10-FF-004024', NULL, 'Uncharacterized protein', 146, NULL, NULL, 179116),
(179117, '2.60.40.10-FF-005546', NULL, NULL, 142, NULL, NULL, 179117),
(179118, '2.20.25.10-FF-000128', NULL, 'Uncharacterized protein', 85, NULL, NULL, 179118),
(179119, '2.70.170.10-FF-000221', NULL, 'Uncharacterized protein', 110, NULL, NULL, 179119),
(179120, '1.20.1070.10-FF-000559', NULL, 'tachykinin-like peptides receptor 99D', 362, NULL, NULL, 179120),
(179121, '2.70.170.10-FF-000165', NULL, 'Protein CBR-ACR-8', 68, NULL, NULL, 179121),
(179122, '3.40.50.300-FF-000764', NULL, 'Midasin', 173, NULL, NULL, 179122),
(179123, '3.40.1160.10-FF-000037', NULL, 'Acetylglutamate kinase', 252, NULL, NULL, 179123),
(179124, '3.10.310.40-FF-000009', NULL, 'Alanine--tRNA ligase', 111, NULL, NULL, 179124),
(179125, '3.10.590.10-FF-000009', NULL, 'EVE domain protein', 139, NULL, NULL, 179125),
(179126, '1.25.40.10-FF-000206', NULL, '43 kDa receptor-associated protein of the synapse', 166, NULL, NULL, 179126),
(179127, '1.10.287.130-FF-000040', NULL, 'PAS domain-containing sensor histidine kinase', 76, NULL, NULL, 179127),
(179128, '3.90.1150.10-FF-000183', NULL, 'Transcriptional regulator, GntR family', 140, NULL, NULL, 179128),
(179129, '3.40.50.300-FF-004979', NULL, 'Uncharacterized protein', 257, NULL, NULL, 179129),
(179130, '1.25.40.180-FF-000196', NULL, 'Nuclear cap-binding protein subunit 1-like Protein', 227, NULL, NULL, 179130),
(179131, '3.30.70.2450-FF-000005', NULL, '2-polyprenyl-6-methoxyphenol hydroxylase and related FAD-dependent oxidoreductases', 86, NULL, NULL, 179131),
(179132, '1.25.40.10-FF-005265', NULL, 'Heat shock protein 70 (HSP70)-interacting protein, putative', 154, NULL, NULL, 179132),
(179133, '3.40.50.1260-FF-000005', NULL, 'Phosphoglycerate kinase', 72, NULL, NULL, 179133),
(179134, '3.30.70.1320-FF-000003', NULL, 'Multidrug resistance protein MdtC', 98, NULL, NULL, 179134),
(179135, '1.20.1300.10-FF-000033', NULL, 'Succinate dehydrogenase subunit b560', 143, NULL, NULL, 179135),
(179136, '1.20.120.1080-FF-000037', NULL, 'ATP-dependent RNA helicase DHX33', 159, NULL, NULL, 179136),
(179137, '2.60.40.10-FF-002528', NULL, 'Immunoglobulin heavy variable 1-49', 101, NULL, NULL, 179137),
(179138, '1.25.40.10-FF-002336', NULL, 'General transcriptional corepressor CYC8', 183, NULL, NULL, 179138),
(179139, '3.40.570.10-FF-000030', NULL, 'DNA/RNA non-specific endonuclease-like protein', 182, NULL, NULL, 179139),
(179140, '2.170.120.40-FF-000012', NULL, 'Diadenylate cyclase', 86, NULL, NULL, 179140),
(179141, '1.10.30.10-FF-000020', NULL, 'HMG box-containing protein 1', 86, NULL, NULL, 179141),
(179142, '3.40.930.10-FF-000013', NULL, 'Solute carrier family 4 member 11', 115, NULL, NULL, 179142),
(179143, '3.40.50.1820-FF-000544', NULL, 'WGS project CABT00000000 data, contig 2.28', 175, NULL, NULL, 179143),
(179144, '1.20.970.10-FF-000022', NULL, 'Anthranilate phosphoribosyltransferase', 64, NULL, NULL, 179144),
(179145, '2.60.120.260-FF-000185', NULL, 'Uncharacterized protein', 127, NULL, NULL, 179145),
(179146, '3.40.50.2300-FF-000817', NULL, NULL, 116, NULL, NULL, 179146),
(179147, '3.30.160.60-FF-001668', NULL, 'transcriptional repressor CTCF', 28, NULL, NULL, 179147),
(179148, '1.10.357.150-FF-000012', NULL, 'AFR652Wp', 192, NULL, NULL, 179148),
(179149, '3.40.50.300-FF-008526', NULL, 'DEAH (Asp-Glu-Ala-His) box polypeptide 40', 186, NULL, NULL, 179149),
(179150, '3.40.50.300-FF-001545', NULL, 'DEAD/DEAH box helicase, putative', 253, NULL, NULL, 179150),
(179151, '1.10.246.20-FF-000002', NULL, 'Mediator of RNA polymerase II transcription subunit 15', 75, NULL, NULL, 179151),
(179152, '2.60.40.10-FF-002635', NULL, 'Protein-tyrosine-phosphatase', 104, NULL, NULL, 179152),
(179153, '3.80.10.10-FF-003187', NULL, 'Uncharacterized protein', 237, NULL, NULL, 179153),
(179154, '2.60.120.320-FF-000012', NULL, 'Uncharacterized protein', 37, NULL, NULL, 179154);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(179155, '2.40.50.140-FF-000332', NULL, 'Primosomal replication protein N', 101, NULL, NULL, 179155),
(179156, '3.40.50.300-FF-008402', NULL, 'Uncharacterized protein', 172, NULL, NULL, 179156),
(179157, '3.40.50.1000-FF-000686', NULL, NULL, 147, NULL, NULL, 179157),
(179158, '3.30.40.10-FF-001364', NULL, 'RBR-type E3 ubiquitin transferase', 95, NULL, NULL, 179158),
(179159, '2.60.40.10-FF-003309', NULL, 'Myosin-light-chain kinase', 103, NULL, NULL, 179159),
(179160, '3.40.50.300-FF-004131', NULL, 'ATP-dependent RNA helicase DHX34', 40, NULL, NULL, 179160),
(179161, '3.30.40.10-FF-000964', NULL, 'Uncharacterized protein', 57, NULL, NULL, 179161),
(179162, '3.30.9.10-FF-000162', NULL, 'Uncharacterized protein', 59, NULL, NULL, 179162),
(179163, '3.20.20.70-FF-000476', NULL, 'Glutamate synthase 1 [NADH] chloroplastic', 164, NULL, NULL, 179163),
(179164, '3.20.20.70-FF-000532', NULL, 'Putative imidazole glycerol phosphate synthase subunit hisF2', 243, NULL, NULL, 179164),
(179165, '3.90.550.10-FF-000181', NULL, 'Gastricsin', 203, NULL, NULL, 179165),
(179166, '3.10.450.10-FF-000067', NULL, 'Cystatin-like protein', 98, NULL, NULL, 179166),
(179167, '1.10.472.140-FF-000010', NULL, 'AGAP006477-PA', 162, NULL, NULL, 179167),
(179168, '2.60.40.2690-FF-000008', NULL, 'Pre-mrna splicing factor, putative', 156, NULL, NULL, 179168),
(179169, '3.30.70.330-FF-001919', NULL, NULL, 151, NULL, NULL, 179169),
(179170, '1.20.920.10-FF-000199', NULL, 'Uncharacterized protein', 130, NULL, NULL, 179170),
(179171, '1.10.10.10-FF-001367', NULL, 'Apoptotic protease-activating factor 1', 74, NULL, NULL, 179171),
(179172, '3.40.50.300-FF-006216', NULL, 'GTP-binding protein, putative', 113, NULL, NULL, 179172),
(179173, '1.10.630.10-FF-000089', NULL, 'Cytochrome P450 720B1 family', 451, NULL, NULL, 179173),
(179174, '3.90.1200.10-FF-000069', NULL, 'Fructosamine kinase', 193, NULL, NULL, 179174),
(179175, '2.60.120.260-FF-000241', NULL, 'Peptidase, M23 family', 123, NULL, NULL, 179175),
(179176, '2.30.29.30-FF-001334', NULL, 'Uncharacterized protein', 50, NULL, NULL, 179176),
(179177, '2.40.30.10-FF-000382', NULL, 'Translation elongation factor G', 114, NULL, NULL, 179177),
(179178, '1.25.40.10-FF-005321', NULL, 'Uncharacterized protein', 112, NULL, NULL, 179178),
(179179, '2.130.10.10-FF-005474', NULL, 'Uncharacterized protein', 155, NULL, NULL, 179179),
(179180, '1.20.920.10-FF-000075', NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', 109, NULL, NULL, 179180),
(179181, '3.40.30.10-FF-000997', NULL, 'Uncharacterized protein', 76, NULL, NULL, 179181),
(179182, '3.30.160.60-FF-006339', NULL, NULL, 64, NULL, NULL, 179182),
(179183, '1.25.10.10-FF-002508', NULL, 'Condensin subunit', 200, NULL, NULL, 179183),
(179184, '1.10.287.980-FF-000002', NULL, 'Cytochrome b6-f complex subunit 4', 79, NULL, NULL, 179184),
(179185, '2.130.10.10-FF-005294', NULL, 'Uncharacterized protein', 222, NULL, NULL, 179185),
(179186, '3.30.930.10-FF-000335', NULL, 'Uncharacterized protein', 111, NULL, NULL, 179186),
(179187, '2.130.10.10-FF-001983', NULL, 'Uncharacterized protein', 142, NULL, NULL, 179187),
(179188, '3.40.50.1000-FF-000630', NULL, NULL, 125, NULL, NULL, 179188),
(179189, '3.30.160.60-FF-001488', NULL, 'Krueppel-like factor 15', 28, NULL, NULL, 179189),
(179190, '3.30.40.10-FF-000015', NULL, 'E3 ubiquitin-protein ligase CBL', 85, NULL, NULL, 179190),
(179191, '2.30.30.490-FF-000070', NULL, 'RSC complex protein', 238, NULL, NULL, 179191),
(179192, '3.40.50.300-FF-002894', NULL, 'AIG1 family protein', 197, NULL, NULL, 179192),
(179193, '3.40.1810.10-FF-000003', NULL, 'MADS-box transcription factor MADS-MC', 74, NULL, NULL, 179193),
(179194, '3.30.420.10-FF-000364', NULL, NULL, 167, NULL, NULL, 179194),
(179195, '3.80.10.10-FF-002787', NULL, 'Uncharacterized protein', 121, NULL, NULL, 179195),
(179196, '3.30.160.60-FF-005939', NULL, NULL, 37, NULL, NULL, 179196),
(179197, '1.10.287.110-FF-000450', NULL, 'DnaJ domain containing protein', 59, NULL, NULL, 179197),
(179198, '3.40.50.300-FF-001489', NULL, 'Adenylate kinase 7', 253, NULL, NULL, 179198);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(179199, '1.10.630.10-FF-000706', NULL, 'Cytochrome P450, family 4, subfamily a, polypeptide 31', 121, NULL, NULL, 179199),
(179200, '1.20.1070.10-FF-000379', NULL, 'prostaglandin D2 receptor', 342, NULL, NULL, 179200),
(179201, '3.30.1460.50-FF-000024', NULL, 'Ubiquitin-like-conjugating enzyme ATG10', 148, NULL, NULL, 179201),
(179202, '3.40.50.12780-FF-000094', NULL, 'Acyl-CoA synthetase, putative', 402, NULL, NULL, 179202),
(179203, '3.40.50.1820-FF-000488', NULL, 'Enterochelin esterase', 227, NULL, NULL, 179203),
(179204, '2.60.40.10-FF-006058', NULL, NULL, 106, NULL, NULL, 179204),
(179205, '3.10.105.10-FF-000119', NULL, 'Oligopeptide ABC transporter, solute-binding protein', 225, NULL, NULL, 179205),
(179206, '2.80.10.50-FF-000137', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 150, NULL, NULL, 179206),
(179207, '2.60.40.10-FF-002680', NULL, 'Uncharacterized protein', 102, NULL, NULL, 179207),
(179208, '3.20.20.120-FF-000017', NULL, 'Dipeptide epimerase', 235, NULL, NULL, 179208),
(179209, '3.40.50.150-FF-000679', NULL, 'Methyltransferase GliN', 215, NULL, NULL, 179209),
(179210, '3.30.860.10-FF-000015', NULL, 'Uncharacterized protein', 91, NULL, NULL, 179210),
(179211, '3.40.630.30-FF-000131', NULL, 'Acetyltransferase, GNAT family', 143, NULL, NULL, 179211),
(179212, '1.10.2000.10-FF-000001', NULL, 'secreted frizzled-related protein 2', 123, NULL, NULL, 179212),
(179213, '2.40.10.10-FF-000037', NULL, 'Complement C1r subcomponent', 96, NULL, NULL, 179213),
(179214, '1.25.40.90-FF-000067', NULL, 'Predicted protein', 153, NULL, NULL, 179214),
(179215, '3.30.70.3030-FF-000022', NULL, 'Nucleolar protein 6', 142, NULL, NULL, 179215),
(179216, '3.30.450.20-FF-000369', NULL, 'Hybrid sensor histidine kinase/response regulator', 112, NULL, NULL, 179216),
(179217, '3.90.20.20-FF-000008', NULL, 'Protein GrpE', 109, NULL, NULL, 179217),
(179218, '3.60.20.40-FF-000021', NULL, 'Putative inactive glutathione hydrolase 4', 143, NULL, NULL, 179218),
(179219, '3.50.50.60-FF-001226', NULL, 'Uncharacterized protein', 239, NULL, NULL, 179219),
(179220, '2.130.10.10-FF-002601', NULL, 'Transcription initiation factor TFIID subunit taf73', 205, NULL, NULL, 179220),
(179221, '1.10.10.10-FF-001311', NULL, 'Heat-inducible transcription repressor HrcA', 98, NULL, NULL, 179221),
(179222, '1.25.40.20-FF-000939', NULL, 'Uncharacterized protein', 143, NULL, NULL, 179222),
(179223, '3.40.50.720-FF-000479', NULL, '4-hydroxy-tetrahydrodipicolinate reductase', 111, NULL, NULL, 179223),
(179224, '1.20.1250.20-FF-002167', NULL, 'Solute carrier organic anion transporter family member', 181, NULL, NULL, 179224),
(179225, '1.10.510.10-FF-000726', NULL, 'Calcium-dependent protein kinase, putative', 208, NULL, NULL, 179225),
(179226, '3.30.40.10-FF-002201', NULL, 'Uncharacterized protein', 74, NULL, NULL, 179226),
(179227, '3.40.30.170-FF-000001', NULL, 'Methionine-tRNA ligase', 53, NULL, NULL, 179227),
(179228, '3.20.20.370-FF-000007', NULL, 'Poly-beta-1,6-N-acetyl-D-glucosamine N-deacetylase PgaB', 267, NULL, NULL, 179228),
(179229, '3.50.80.10-FF-000011', NULL, 'Uncharacterized protein', 168, NULL, NULL, 179229),
(179230, '1.10.10.160-FF-000020', NULL, 'DNA helicase', 78, NULL, NULL, 179230),
(179231, '3.10.20.90-FF-000100', NULL, 'Autophagy related 5', 97, NULL, NULL, 179231),
(179232, '1.25.40.10-FF-000318', NULL, 'Serine/threonine protein kinase', 184, NULL, NULL, 179232),
(179233, '1.25.40.1040-FF-000024', NULL, 'TPR Domain containing protein', 468, NULL, NULL, 179233),
(179234, '3.30.420.110-FF-000057', NULL, 'DNA mismatch repair protein MutS 1', 137, NULL, NULL, 179234),
(179235, '3.30.420.10-FF-000488', NULL, NULL, 192, NULL, NULL, 179235),
(179236, '3.30.540.30-FF-000025', NULL, 'Uncharacterized protein', 168, NULL, NULL, 179236),
(179237, '1.10.287.70-FF-000752', NULL, 'Uncharacterized protein', 74, NULL, NULL, 179237),
(179238, '3.90.700.10-FF-000007', NULL, 'NADH-dependent fumarate reductase', 153, NULL, NULL, 179238),
(179239, '2.60.40.1170-FF-000103', NULL, NULL, 45, NULL, NULL, 179239),
(179240, '1.10.510.10-FF-002963', NULL, 'Mitogen-activated protein kinase kinase 9', 289, NULL, NULL, 179240);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(179241, '3.20.20.100-FF-000011', NULL, 'Aldo/keto reductase', 312, NULL, NULL, 179241),
(179242, '2.60.220.50-FF-000088', NULL, 'Adhesion G protein-coupled receptor L2', 178, NULL, NULL, 179242),
(179243, '1.25.40.70-FF-000061', NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', 176, NULL, NULL, 179243),
(179244, '2.60.260.20-FF-000161', NULL, 'Uncharacterized protein', 75, NULL, NULL, 179244),
(179245, '1.10.238.10-FF-000065', NULL, 'calpain-3 isoform X1', 173, NULL, NULL, 179245),
(179246, '1.10.510.10-FF-004037', NULL, NULL, 97, NULL, NULL, 179246),
(179247, '3.30.900.10-FF-000002', NULL, 'Mitotic spindle assembly checkpoint protein MAD2A', 203, NULL, NULL, 179247),
(179248, '3.30.230.10-FF-000041', NULL, '37S ribosomal protein S5', 92, NULL, NULL, 179248),
(179249, '2.60.120.330-FF-000234', NULL, 'Uncharacterized protein', 87, NULL, NULL, 179249),
(179250, '3.30.160.60-FF-003854', NULL, NULL, 27, NULL, NULL, 179250),
(179251, '3.90.180.10-FF-000146', NULL, 'L-idonate 5-dehydrogenase', 187, NULL, NULL, 179251),
(179252, '3.40.640.10-FF-000474', NULL, 'Serine hydroxymethyltransferase 4', 90, NULL, NULL, 179252),
(179253, '3.20.20.140-FF-000175', NULL, 'Uncharacterized protein, isoform B', 257, NULL, NULL, 179253),
(179254, '3.20.20.80-FF-000754', NULL, 'Putative chitinase 3-like Protein', 32, NULL, NULL, 179254),
(179255, '1.10.730.10-FF-000130', NULL, 'Leucine--tRNA ligase', 181, NULL, NULL, 179255),
(179256, '1.10.940.10-FF-000011', NULL, 'Transcription antitermination protein NusB', 129, NULL, NULL, 179256),
(179257, '3.30.160.60-FF-000943', NULL, 'probable E3 ubiquitin-protein ligase TRIM8', 96, NULL, NULL, 179257),
(179258, '1.20.58.60-FF-000497', NULL, 'Guanine nucleotide exchange factor UNC-73A', 241, NULL, NULL, 179258),
(179259, '1.20.930.10-FF-000025', NULL, 'BAH and TFIIS domain-containing protein', 136, NULL, NULL, 179259),
(179260, '1.10.287.660-FF-000024', NULL, 'YALI0F18524p', 83, NULL, NULL, 179260),
(179261, '2.130.10.10-FF-002040', NULL, 'WD domain, G-beta repeat-containing protein', 213, NULL, NULL, 179261),
(179262, '3.50.50.60-FF-000445', NULL, 'Uncharacterized protein', 42, NULL, NULL, 179262),
(179263, '1.10.287.370-FF-000038', NULL, 'Uncharacterized protein', 143, NULL, NULL, 179263),
(179264, '3.40.50.1820-FF-001325', NULL, 'Homoserine O-acetyltransferase', 257, NULL, NULL, 179264),
(179265, '2.10.110.30-FF-000006', NULL, 'Uncharacterized protein', 46, NULL, NULL, 179265),
(179266, '3.40.50.2000-FF-000609', NULL, 'Alpha-1,4 glucan phosphorylase', 17, NULL, NULL, 179266),
(179267, '1.20.58.890-FF-000002', NULL, NULL, 86, NULL, NULL, 179267),
(179268, '2.60.220.50-FF-000032', NULL, 'Uncharacterized protein', 50, NULL, NULL, 179268),
(179269, '1.10.510.10-FF-001507', NULL, 'Guanylate cyclase', 255, NULL, NULL, 179269),
(179270, '1.20.58.390-FF-000178', NULL, 'Predicted protein', 70, NULL, NULL, 179270),
(179271, '3.40.1190.10-FF-000045', NULL, NULL, 168, NULL, NULL, 179271),
(179272, '3.30.160.60-FF-000420', NULL, 'Putative transcriptional repressor ctcf', 78, NULL, NULL, 179272),
(179273, '3.40.50.410-FF-000162', NULL, 'Predicted protein', 206, NULL, NULL, 179273),
(179274, '1.20.1250.20-FF-001262', NULL, 'Expressed protein', 383, NULL, NULL, 179274),
(179275, '2.60.120.200-FF-000774', NULL, 'Uncharacterized protein', 291, NULL, NULL, 179275),
(179276, '3.30.497.10-FF-000120', NULL, 'Uncharacterized protein', 231, NULL, NULL, 179276),
(179277, '3.50.50.60-FF-000501', NULL, 'FI13301p', 209, NULL, NULL, 179277),
(179278, '3.20.180.20-FF-000030', NULL, 'Dynein heavy chain, cytoplasmic', 83, NULL, NULL, 179278),
(179279, '3.10.20.90-FF-000156', NULL, 'Phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit alpha', 157, NULL, NULL, 179279),
(179280, '1.25.10.10-FF-001042', NULL, 'Ser/Thr phosphatase 2A, 65kDa reg sub A', 594, NULL, NULL, 179280),
(179281, '1.20.144.10-FF-000069', NULL, 'Phosphatidic acid phosphatase type 2/haloperoxidase', 247, NULL, NULL, 179281),
(179282, '1.10.150.50-FF-000092', NULL, 'Liprin-beta', 107, NULL, NULL, 179282);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(179283, '3.40.50.1820-FF-001269', NULL, 'Predicted protein', 302, NULL, NULL, 179283),
(179284, '2.40.160.50-FF-000020', NULL, 'Patatin-like protein, PlpD', 318, NULL, NULL, 179284),
(179285, '1.20.1560.10-FF-000754', NULL, 'Uncharacterized protein', 59, NULL, NULL, 179285),
(179286, '1.10.238.10-FF-000626', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', 82, NULL, NULL, 179286),
(179287, '2.40.100.10-FF-000038', NULL, 'Peptidyl-prolyl cis-trans isomerase', 174, NULL, NULL, 179287),
(179288, '2.60.40.790-FF-000183', NULL, 'Small heat shock protein HSP16.5', 114, NULL, NULL, 179288),
(179289, '3.30.70.330-FF-000846', NULL, 'zinc finger CCHC-type and RNA-binding motif-containing protein 1 isoform X2', 59, NULL, NULL, 179289),
(179290, '1.10.287.1060-FF-000016', NULL, 'ESAT-6-like protein', 96, NULL, NULL, 179290),
(179291, '2.60.210.10-FF-000042', NULL, NULL, 148, NULL, NULL, 179291),
(179292, '3.40.50.1220-FF-000128', NULL, 'Uncharacterized protein', 168, NULL, NULL, 179292),
(179293, '2.130.10.10-FF-004417', NULL, 'Predicted protein', 367, NULL, NULL, 179293),
(179294, '2.30.29.30-FF-000210', NULL, 'Tyrosine-protein kinase', 154, NULL, NULL, 179294),
(179295, '2.40.170.20-FF-000085', NULL, 'SusC/RagA family TonB-linked outer membrane protein', 634, NULL, NULL, 179295),
(179296, '1.10.10.1050-FF-000017', NULL, 'Hydrolase, NUDIX family protein', 91, NULL, NULL, 179296),
(179297, '3.40.50.300-FF-000241', NULL, 'DNA helicase', 348, NULL, NULL, 179297),
(179298, '2.40.50.90-FF-000131', NULL, 'Transcription factor, putative', 159, NULL, NULL, 179298),
(179299, '3.40.50.300-FF-001146', NULL, 'DNA-binding protein SMUBP-2 isoform X1', 207, NULL, NULL, 179299),
(179300, '1.10.533.10-FF-000239', NULL, 'Uncharacterized protein', 90, NULL, NULL, 179300),
(179301, '2.60.40.10-FF-005726', NULL, NULL, 118, NULL, NULL, 179301),
(179302, '3.40.630.30-FF-000187', NULL, 'Ribosomal-protein-serine acetyltransferase, putative', 174, NULL, NULL, 179302),
(179303, '2.102.10.10-FF-000006', NULL, 'Menaquinol-cytochrome c reductase, iron-sulfur subunit', 126, NULL, NULL, 179303),
(179304, '2.60.40.10-FF-006002', NULL, NULL, 54, NULL, NULL, 179304),
(179305, '1.20.58.390-FF-000234', NULL, 'Uncharacterized protein', 143, NULL, NULL, 179305),
(179306, '3.40.50.1460-FF-000060', NULL, 'Zgc:171731', 259, NULL, NULL, 179306),
(179307, '1.10.287.70-FF-000696', NULL, 'Predicted protein', 307, NULL, NULL, 179307),
(179308, '6.10.250.3260-FF-000001', NULL, '60S ribosomal protein L21', 62, NULL, NULL, 179308),
(179309, '3.40.50.1470-FF-000006', NULL, 'Peptidyl-tRNA hydrolase', 191, NULL, NULL, 179309),
(179310, '3.30.830.10-FF-000007', NULL, 'Insulin-degrading enzyme', 251, NULL, NULL, 179310),
(179311, '1.10.1450.10-FF-000147', NULL, 'Tetraspanin', 88, NULL, NULL, 179311),
(179312, '3.30.230.10-FF-000097', NULL, 'Phosphomevalonate kinase', 210, NULL, NULL, 179312),
(179313, '1.25.10.10-FF-000822', NULL, 'protein CIP2A isoform X2', 549, NULL, NULL, 179313),
(179314, '1.20.1730.10-FF-000059', NULL, 'Sodium/glucose cotransporter 1-like', 270, NULL, NULL, 179314),
(179315, '3.30.70.330-FF-001122', NULL, 'SUPpressor', 78, NULL, NULL, 179315),
(179316, '3.30.1740.20-FF-000014', NULL, '40S ribosomal protein S26', 41, NULL, NULL, 179316),
(179317, '3.30.160.60-FF-000763', NULL, 'Probable lysine-specific demethylase ELF6', 30, NULL, NULL, 179317),
(179318, '2.60.120.330-FF-000054', NULL, '1-aminocyclopropane-1-carboxylic acid oxidase-like protein', 305, NULL, NULL, 179318),
(179319, '1.20.1280.50-FF-000025', NULL, 'F-box and WD repeat domain containing 8', 96, NULL, NULL, 179319),
(179320, '1.10.150.550-FF-000003', NULL, 'Nucleoprotein', 78, NULL, NULL, 179320),
(179321, '1.25.40.10-FF-000594', NULL, 'Serine/threonine-protein phosphatase', 136, NULL, NULL, 179321),
(179322, '2.20.28.10-FF-000045', NULL, 'DNA helicase', 58, NULL, NULL, 179322),
(179323, '2.60.40.10-FF-000550', NULL, '1,4-alpha-glucan-branching enzyme isoform B', 113, NULL, NULL, 179323),
(179324, '2.30.29.30-FF-000154', NULL, 'Oxysterol-binding protein', 108, NULL, NULL, 179324);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(179325, '3.40.1280.30-FF-000030', NULL, 'Uncharacterized protein', 63, NULL, NULL, 179325),
(179326, '3.30.530.20-FF-000027', NULL, 'StAR-related lipid transfer protein 7, mitochondrial', 211, NULL, NULL, 179326),
(179327, '3.30.200.20-FF-000946', NULL, 'Transmembrane serine/threonine-protein kinase PknJ', 93, NULL, NULL, 179327),
(179328, '2.60.40.10-FF-000494', NULL, 'Leptin receptor', 108, NULL, NULL, 179328),
(179329, '3.30.70.20-FF-000121', NULL, NULL, 130, NULL, NULL, 179329),
(179330, '1.25.40.10-FF-001954', NULL, 'Uncharacterized protein, isoform B', 134, NULL, NULL, 179330),
(179331, '1.20.120.350-FF-000183', NULL, NULL, 128, NULL, NULL, 179331),
(179332, '1.10.357.50-FF-000010', NULL, 'exocyst complex component 3', 186, NULL, NULL, 179332),
(179333, '3.90.550.10-FF-000742', NULL, 'Glr3787 protein', 243, NULL, NULL, 179333),
(179334, '3.10.620.10-FF-000007', NULL, 'Uncharacterized protein', 77, NULL, NULL, 179334),
(179335, '1.25.40.560-FF-000001', NULL, 'ubiquitin thioesterase ZRANB1 isoform X1', 97, NULL, NULL, 179335),
(179336, '1.10.20.10-FF-000194', NULL, NULL, 74, NULL, NULL, 179336),
(179337, '2.30.29.30-FF-000553', NULL, 'Protein CBR-STN-1', 82, NULL, NULL, 179337),
(179338, '2.60.120.650-FF-000212', NULL, 'Putative lysine-specific demethylase JMJ16', 71, NULL, NULL, 179338),
(179339, '3.90.550.10-FF-000686', NULL, 'UDP-N-acetyl-alpha-D-galactosamine:polypeptide N-acetylgalactosaminyltransferase 6 (GalNAc-T6)', 76, NULL, NULL, 179339),
(179340, '1.10.1410.10-FF-000026', NULL, 'U3 small nucleolar RNA-associated protein 22', 188, NULL, NULL, 179340),
(179341, '4.10.1240.10-FF-000050', NULL, 'Glucagon-like peptide 1 receptor', 92, NULL, NULL, 179341),
(179342, '2.60.40.10-FF-003984', NULL, NULL, 101, NULL, NULL, 179342),
(179343, '2.40.50.90-FF-000075', NULL, 'Nuclease domain containing protein', 150, NULL, NULL, 179343),
(179344, '3.40.980.10-FF-000016', NULL, 'YMR178W-like protein', 173, NULL, NULL, 179344),
(179345, '3.40.50.300-FF-000185', NULL, 'GTPase Obg', 206, NULL, NULL, 179345),
(179346, '1.10.287.1490-FF-000027', NULL, 'Myosin heavy chain-like', 168, NULL, NULL, 179346),
(179347, '1.20.144.10-FF-000125', NULL, 'Uncharacterized protein', 286, NULL, NULL, 179347),
(179348, '3.30.565.10-FF-000222', NULL, 'Putative two-component system sensor histidine kinase', 172, NULL, NULL, 179348),
(179349, '3.10.20.30-FF-000110', NULL, NULL, 72, NULL, NULL, 179349),
(179350, '1.10.510.10-FF-003020', NULL, NULL, 182, NULL, NULL, 179350),
(179351, '3.90.1170.10-FF-000015', NULL, '50S ribosomal protein L16', 136, NULL, NULL, 179351),
(179352, '1.10.101.10-FF-000028', NULL, 'Plastid transcriptionally active 5', 75, NULL, NULL, 179352),
(179353, '4.10.40.20-FF-000005', NULL, 'Insulin-like growth factor-binding protein 6', 50, NULL, NULL, 179353),
(179354, '1.20.890.10-FF-000021', NULL, 'Protein CBG08105', 44, NULL, NULL, 179354),
(179355, '2.40.30.130-FF-000055', NULL, 'Alanyl-tRNA synthetase-related protein', 92, NULL, NULL, 179355),
(179356, '2.60.40.10-FF-004260', NULL, NULL, 113, NULL, NULL, 179356),
(179357, '3.80.10.10-FF-003243', NULL, 'Predicted protein', 181, NULL, NULL, 179357),
(179358, '3.40.710.10-FF-000182', NULL, 'Uncharacterized protein', 182, NULL, NULL, 179358),
(179359, '1.10.287.770-FF-000001', NULL, 'Acid-sensing ion channel subunit 1', 64, NULL, NULL, 179359),
(179360, '2.60.40.10-FF-004765', NULL, NULL, 97, NULL, NULL, 179360),
(179361, '3.50.50.60-FF-000788', NULL, 'L-amino acid oxidase', 93, NULL, NULL, 179361),
(179362, '3.30.450.20-FF-000026', NULL, 'single-minded homolog 1', 117, NULL, NULL, 179362),
(179363, '1.20.1270.10-FF-000035', NULL, 'Heat shock cognate 71 kDa protein', 75, NULL, NULL, 179363),
(179364, '1.10.510.10-FF-000546', NULL, 'SCY1 like pseudokinase 3', 142, NULL, NULL, 179364),
(179365, '3.40.720.10-FF-000132', NULL, 'AT28040p', 305, NULL, NULL, 179365),
(179366, '3.40.50.2000-FF-000885', NULL, 'Uncharacterized protein', 181, NULL, NULL, 179366),
(179367, '1.10.630.10-FF-000145', NULL, 'Cytochrome P450 family 26 subfamily C member 1', 300, NULL, NULL, 179367);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(179368, '1.25.10.20-FF-000027', NULL, 'Uncharacterized protein', 112, NULL, NULL, 179368),
(179369, '3.30.160.60-FF-002000', NULL, 'Zinc finger protein 445', 31, NULL, NULL, 179369),
(179370, '1.10.10.10-FF-000530', NULL, 'Forkhead box protein (AaegFOXM2)', 106, NULL, NULL, 179370),
(179371, '3.30.200.20-FF-002127', NULL, 'CAMK family protein kinase', 73, NULL, NULL, 179371),
(179372, '3.40.640.10-FF-000131', NULL, 'HISTIDINE BIOSYNTHESIS 6B', 202, NULL, NULL, 179372),
(179373, '3.40.850.10-FF-000012', NULL, 'Kinesin-like protein', 345, NULL, NULL, 179373),
(179374, '3.30.40.10-FF-001184', NULL, 'APC11, cyclin metabolism', 81, NULL, NULL, 179374),
(179375, '3.30.190.20-FF-000039', NULL, 'Uncharacterized protein', 87, NULL, NULL, 179375),
(179376, '3.30.200.20-FF-001727', NULL, 'Putative serine/threonine protein kinase', 136, NULL, NULL, 179376),
(179377, '1.25.40.10-FF-005085', NULL, 'Uncharacterized protein', 84, NULL, NULL, 179377),
(179378, '3.40.50.300-FF-004075', NULL, 'Putative dynein heavy chain, cytosolic', 141, NULL, NULL, 179378),
(179379, '4.10.400.10-FF-000026', NULL, 'Low-density lipoprotein receptor-related protein 1', 36, NULL, NULL, 179379),
(179380, '2.10.25.10-FF-000449', NULL, 'Integrin beta', 56, NULL, NULL, 179380),
(179381, '1.10.472.80-FF-000073', NULL, 'TBC/Rab GTPase activating domain containing protein', 118, NULL, NULL, 179381),
(179382, '3.30.70.2190-FF-000017', NULL, 'D-2-hydroxyglutarate dehydrogenase, mitochondrial', 120, NULL, NULL, 179382),
(179383, '2.10.25.10-FF-000269', NULL, 'Adhesion G protein-coupled receptor E2', 47, NULL, NULL, 179383),
(179384, '3.30.160.60-FF-004074', NULL, NULL, 29, NULL, NULL, 179384),
(179385, '2.60.120.260-FF-000421', NULL, 'Cellulase/esterase CelE', 119, NULL, NULL, 179385),
(179386, '1.20.58.1880-FF-000022', NULL, 'Uncharacterized protein', 131, NULL, NULL, 179386),
(179387, '1.20.1560.10-FF-000411', NULL, 'Vacuolar glutathione S-conjugate transporter of the ATP-binding cassette family, putative', 335, NULL, NULL, 179387),
(179388, '3.30.160.60-FF-001724', NULL, 'zinc finger protein 787 isoform X2', 52, NULL, NULL, 179388),
(179389, '3.30.460.10-FF-000086', NULL, 'tRNA nucleotidyltransferase, putative', 154, NULL, NULL, 179389),
(179390, '1.10.8.60-FF-000425', NULL, 'Replication factor C small subunit', 66, NULL, NULL, 179390),
(179391, '4.10.280.10-FF-000145', NULL, 'Helix-loop-helix DNA-binding domain containing protein, expressed', 58, NULL, NULL, 179391),
(179392, '1.10.238.200-FF-000001', NULL, 'DCN1-like protein', 109, NULL, NULL, 179392),
(179393, '3.90.76.10-FF-000016', NULL, 'Possible conserved lipoprotein', 108, NULL, NULL, 179393),
(179394, '3.40.50.300-FF-003675', NULL, 'Molybdopterin synthase catalytic subunit', 193, NULL, NULL, 179394),
(179395, '3.40.140.10-FF-000273', NULL, 'Uncharacterized protein', 85, NULL, NULL, 179395),
(179396, '4.10.520.10-FF-000024', NULL, NULL, 99, NULL, NULL, 179396),
(179397, '3.20.20.140-FF-000231', NULL, 'Sodium/hydrogen exchanger 2', 186, NULL, NULL, 179397),
(179398, '3.40.190.290-FF-000116', NULL, 'Transcriptional regulator', 205, NULL, NULL, 179398),
(179399, '3.90.1420.10-FF-000052', NULL, 'Uncharacterized protein', 99, NULL, NULL, 179399),
(179400, '2.60.40.10-FF-004821', NULL, NULL, 71, NULL, NULL, 179400),
(179401, '2.60.40.10-FF-000370', NULL, 'CMRF35-like molecule 1', 116, NULL, NULL, 179401),
(179402, '1.20.1250.20-FF-002223', NULL, 'Arabinose-proton symporter (Arabinose transporter)', 129, NULL, NULL, 179402),
(179403, '3.40.50.720-FF-000659', NULL, 'Protein YIM1', 189, NULL, NULL, 179403),
(179404, '1.10.510.10-FF-001783', NULL, 'Protein kinase domain-containing protein (AFU_orthologue AFUA_2G14650)', 237, NULL, NULL, 179404),
(179405, '3.30.200.20-FF-001907', NULL, 'Uncharacterized protein', 82, NULL, NULL, 179405),
(179406, '3.30.50.10-FF-000173', NULL, 'Uncharacterized protein', 41, NULL, NULL, 179406),
(179407, '1.25.10.10-FF-002003', NULL, 'HEAT domain-containing protein', 229, NULL, NULL, 179407),
(179408, '2.60.200.30-FF-000042', NULL, 'NAD kinase', 138, NULL, NULL, 179408);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(179409, '3.40.50.1360-FF-000029', NULL, 'Ribose 5-phosphate isomerase', 137, NULL, NULL, 179409),
(179410, '1.10.510.10-FF-000147', NULL, 'Inhibitor of nuclear factor kappa-B kinase subunit beta', 307, NULL, NULL, 179410),
(179411, '3.70.10.10-FF-000112', NULL, 'Cell cycle checkpoint control protein RAD9A-like Protein', 255, NULL, NULL, 179411),
(179412, '1.25.40.10-FF-002735', NULL, 'Uncharacterized protein', 248, NULL, NULL, 179412),
(179413, '3.30.565.10-FF-000166', NULL, 'Sporulation kinase B', 150, NULL, NULL, 179413),
(179414, '3.40.50.300-FF-008346', NULL, 'Outer dynein arm heavy chain beta', 181, NULL, NULL, 179414),
(179415, '6.20.250.70-FF-000005', NULL, 'DNA-directed RNA polymerase I subunit rpa34', 107, NULL, NULL, 179415),
(179416, '3.40.50.150-FF-000174', NULL, 'TRM2p tRNA methyltransferase', 222, NULL, NULL, 179416),
(179417, '2.40.160.110-FF-000052', NULL, 'Uncharacterized protein', 86, NULL, NULL, 179417),
(179418, '3.40.50.2000-FF-000941', NULL, 'ADP-heptose:LPS heptosyltransferase', 131, NULL, NULL, 179418),
(179419, '1.20.1250.20-FF-001947', NULL, 'Probable sugar-transport integral membrane protein SugI', 445, NULL, NULL, 179419),
(179420, '1.10.3860.10-FF-000021', NULL, 'Amino acid transporter', 407, NULL, NULL, 179420),
(179421, '1.10.630.10-FF-000201', NULL, 'Os06g0328900 protein', 286, NULL, NULL, 179421),
(179422, '3.40.50.10380-FF-000020', NULL, 'NADP-dependent malic enzyme', 256, NULL, NULL, 179422),
(179423, '1.10.357.70-FF-000016', NULL, 'Exocyst complex component 3-like 1', 176, NULL, NULL, 179423),
(179424, '1.25.40.10-FF-002174', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 240, NULL, NULL, 179424),
(179425, '1.20.5.100-FF-000024', NULL, 'Integrin beta', 78, NULL, NULL, 179425),
(179426, '3.40.50.970-FF-000032', NULL, '2-oxoisovalerate dehydrogenase subunit alpha', 335, NULL, NULL, 179426),
(179427, '1.25.40.90-FF-000123', NULL, 'Uncharacterized protein', 102, NULL, NULL, 179427),
(179428, '1.10.20.10-FF-000356', NULL, NULL, 91, NULL, NULL, 179428),
(179429, '2.70.98.10-FF-000025', NULL, 'GAL10 bifunctional protein', 335, NULL, NULL, 179429),
(179430, '3.30.40.10-FF-002145', NULL, 'RBR-type E3 ubiquitin transferase', 92, NULL, NULL, 179430),
(179431, '1.10.4200.10-FF-000005', NULL, 'Probable 2-(5''''-triphosphoribosyl)-3''-dephosphocoenzyme-A synthase', 150, NULL, NULL, 179431),
(179432, '3.30.200.20-FF-001166', NULL, 'Camk camk1 protein kinase', 101, NULL, NULL, 179432),
(179433, '3.30.56.50-FF-000001', NULL, 'Translation initiation factor IF-2', 49, NULL, NULL, 179433),
(179434, '2.130.10.10-FF-004237', NULL, 'Uncharacterized protein', 142, NULL, NULL, 179434),
(179435, '3.40.50.261-FF-000022', NULL, 'Succinate--CoA ligase [ADP/GDP-forming] subunit alpha, mitochondrial', 177, NULL, NULL, 179435),
(179436, '3.90.1100.10-FF-000028', NULL, 'DNA-directed RNA polymerase subunit beta', 197, NULL, NULL, 179436),
(179437, '2.30.30.140-FF-000217', NULL, 'E3 ubiquitin-protein ligase UHRF1-like Protein', 67, NULL, NULL, 179437),
(179438, '2.60.120.1520-FF-000001', NULL, 'Alkylated DNA repair protein alkB homolog 8', 146, NULL, NULL, 179438),
(179439, '2.30.29.100-FF-000001', NULL, 'Envelope glycoprotein B', 116, NULL, NULL, 179439),
(179440, '1.10.472.10-FF-000272', NULL, 'WGS project CABT00000000 data, contig 2.7', 189, NULL, NULL, 179440),
(179441, '2.40.50.140-FF-001169', NULL, NULL, 53, NULL, NULL, 179441),
(179442, '2.130.10.10-FF-000527', NULL, 'POC1 centriolar protein homolog A', 81, NULL, NULL, 179442),
(179443, '1.25.40.10-FF-001898', NULL, 'Putative leaf protein', 106, NULL, NULL, 179443),
(179444, '2.130.10.10-FF-005530', NULL, 'Uncharacterized protein', 12, NULL, NULL, 179444),
(179445, '3.40.50.2300-FF-001037', NULL, 'Glutamate receptor ionotropic, delta-1', 169, NULL, NULL, 179445),
(179446, '3.40.50.150-FF-000915', NULL, NULL, 183, NULL, NULL, 179446),
(179447, '3.30.70.330-FF-000902', NULL, 'La RNA binding protein, putative', 107, NULL, NULL, 179447),
(179448, '1.10.287.1040-FF-000010', NULL, 'Exodeoxyribonuclease 7 small subunit', 70, NULL, NULL, 179448);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(179449, '1.20.1280.170-FF-000002', NULL, 'Exocyst complex component 7', 414, NULL, NULL, 179449),
(179450, '2.40.50.100-FF-000168', NULL, 'Putative exosome complex component rrp40', 61, NULL, NULL, 179450),
(179451, '1.20.1110.10-FF-000203', NULL, NULL, 99, NULL, NULL, 179451),
(179452, '2.10.70.10-FF-000233', NULL, 'Uncharacterized protein', 63, NULL, NULL, 179452),
(179453, '4.10.400.10-FF-000369', NULL, 'Cortical granule serine protease 1; Uncharacterized protein', 40, NULL, NULL, 179453),
(179454, '3.40.366.10-FF-000044', NULL, '[acyl-carrier-protein] S-malonyltransferase', 220, NULL, NULL, 179454),
(179455, '3.30.450.40-FF-000240', NULL, 'Sensor histidine kinase, GAF domain-containing', 124, NULL, NULL, 179455),
(179456, '2.40.10.10-FF-000616', NULL, NULL, 106, NULL, NULL, 179456),
(179457, '3.30.300.20-FF-000038', NULL, 'Cleavage and polyadenylation specificity factor', 71, NULL, NULL, 179457),
(179458, '1.20.1250.20-FF-000986', NULL, 'Uncharacterized protein', 466, NULL, NULL, 179458),
(179459, '1.10.10.60-FF-000516', NULL, 'Transcription factor Toy', 83, NULL, NULL, 179459),
(179460, '3.40.50.300-FF-004636', NULL, 'GTPase Era', 182, NULL, NULL, 179460),
(179461, '3.30.70.330-FF-002976', NULL, NULL, 93, NULL, NULL, 179461),
(179462, '3.10.50.10-FF-000067', NULL, 'Uncharacterized protein', 36, NULL, NULL, 179462),
(179463, '3.40.50.300-FF-001202', NULL, 'Translation elongation factor EF-1 subunit alpha', 248, NULL, NULL, 179463),
(179464, '1.10.10.790-FF-000046', NULL, NULL, 38, NULL, NULL, 179464),
(179465, '3.40.47.10-FF-000125', NULL, '3-ketoacyl-CoA thiolase, mitochondrial', 159, NULL, NULL, 179465),
(179466, '2.60.40.10-FF-000218', NULL, 'titin isoform X1', 94, NULL, NULL, 179466),
(179467, '1.25.10.10-FF-000766', NULL, 'Cell differentiation family, rcd1 family protein', 277, NULL, NULL, 179467),
(179468, '1.20.1250.20-FF-001386', NULL, 'Predicted protein', 191, NULL, NULL, 179468),
(179469, '2.60.120.1000-FF-000019', NULL, 'Collagen type XI alpha 2 pseudogene 1', 231, NULL, NULL, 179469),
(179470, '1.10.1370.30-FF-000028', NULL, 'Angiotensin-converting enzyme', 387, NULL, NULL, 179470),
(179471, '2.60.40.10-FF-004422', NULL, NULL, 96, NULL, NULL, 179471),
(179472, '2.30.30.210-FF-000025', NULL, 'Ribonuclease P protein subunit p29-like protein', 93, NULL, NULL, 179472),
(179473, '2.130.10.10-FF-003248', NULL, 'Periodic tryptophan protein 2', 219, NULL, NULL, 179473),
(179474, '3.30.40.10-FF-000352', NULL, 'Breast cancer associated RING 1', 86, NULL, NULL, 179474),
(179475, '3.80.10.10-FF-000573', NULL, 'Leucine-rich repeat-containing protein 41', 352, NULL, NULL, 179475),
(179476, '3.30.160.60-FF-001584', NULL, 'Zinc finger protein 660', 29, NULL, NULL, 179476),
(179477, '1.25.40.10-FF-002527', NULL, 'Pentatricopeptide (PPR) repeat-containing protein', 143, NULL, NULL, 179477),
(179478, '3.40.50.620-FF-000404', NULL, 'Adenine nucleotide alpha hydrolases-like superfamily protein', 189, NULL, NULL, 179478),
(179479, '4.10.110.10-FF-000015', NULL, 'Predicted protein', 65, NULL, NULL, 179479),
(179480, '3.90.226.10-FF-000129', NULL, 'Methylcrotonoyl-CoA carboxylase', 284, NULL, NULL, 179480),
(179481, '1.25.40.10-FF-002999', NULL, 'Crooked neck protein, putative, expressed', 126, NULL, NULL, 179481),
(179482, '3.40.50.300-FF-008442', NULL, 'Predicted protein', 74, NULL, NULL, 179482),
(179483, '2.60.40.10-FF-000999', NULL, 'Uncharacterized protein, isoform D', 98, NULL, NULL, 179483),
(179484, '3.40.50.620-FF-000876', NULL, 'Uncharacterized protein', 123, NULL, NULL, 179484),
(179485, '3.30.160.60-FF-004338', NULL, NULL, 32, NULL, NULL, 179485),
(179486, '3.20.20.220-FF-000036', NULL, 'Proline dehydrogenase', 363, NULL, NULL, 179486),
(179487, '3.80.10.10-FF-003327', NULL, 'Si:ch73-233m11.2', 224, NULL, NULL, 179487),
(179488, '3.80.20.20-FF-000065', NULL, 'Predicted protein', 71, NULL, NULL, 179488),
(179489, '2.70.170.10-FF-000036', NULL, 'Gamma-aminobutyric acid receptor subunit beta-like', 212, NULL, NULL, 179489),
(179490, '3.90.1170.20-FF-000007', NULL, 'Nicotinate-nucleotide pyrophosphorylase (Carboxylating)', 112, NULL, NULL, 179490);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(179491, '2.60.40.10-FF-000527', NULL, 'E3 ubiquitin-protein ligase TRIM71', 100, NULL, NULL, 179491),
(179492, '2.60.40.1120-FF-000049', NULL, 'Transporter, outer membrane receptor (OMR) family', 77, NULL, NULL, 179492),
(179493, '2.130.10.10-FF-000494', NULL, 'DDB1- and CUL4-associated factor 4 isoform X1', 302, NULL, NULL, 179493),
(179494, '3.90.1580.10-FF-000024', NULL, 'Uncharacterized protein', 286, NULL, NULL, 179494),
(179495, '2.70.150.10-FF-000023', NULL, 'Phospholipid-transporting ATPase', 171, NULL, NULL, 179495),
(179496, '1.25.40.1030-FF-000004', NULL, 'Protein transport protein SEC31 homolog B', 417, NULL, NULL, 179496),
(179497, '2.60.40.60-FF-000391', NULL, 'Dachsous, isoform B', 107, NULL, NULL, 179497),
(179498, '1.20.1070.10-FF-001419', NULL, 'Uncharacterized protein', 230, NULL, NULL, 179498),
(179499, '2.60.40.10-FF-004905', NULL, NULL, 99, NULL, NULL, 179499),
(179500, '1.10.30.10-FF-000149', NULL, 'High mobility group protein C, putative', 104, NULL, NULL, 179500),
(179501, '3.40.50.300-FF-004743', NULL, 'GTPase HflX', 170, NULL, NULL, 179501),
(179502, '3.30.70.270-FF-000238', NULL, NULL, 59, NULL, NULL, 179502),
(179503, '3.80.10.10-FF-003799', NULL, 'Uncharacterized protein', 91, NULL, NULL, 179503),
(179504, '3.30.930.10-FF-000431', NULL, 'Putative histidyl-tRNA synthetase', 127, NULL, NULL, 179504),
(179505, '3.30.70.870-FF-000047', NULL, 'Putative tetracycline resistance protein', 77, NULL, NULL, 179505),
(179506, '3.90.550.10-FF-000135', NULL, 'Cellulose synthase-like protein G3', 159, NULL, NULL, 179506),
(179507, '3.90.1100.10-FF-000056', NULL, 'DNA-directed RNA polymerase subunit beta', 193, NULL, NULL, 179507),
(179508, '1.20.120.140-FF-000007', NULL, 'Signal recognition particle receptor subunit alpha', 113, NULL, NULL, 179508),
(179509, '1.10.246.10-FF-000016', NULL, 'Serum albumin', 64, NULL, NULL, 179509),
(179510, '2.120.10.80-FF-000240', NULL, 'Attractin-like 1b', 158, NULL, NULL, 179510),
(179511, '3.40.50.150-FF-000494', NULL, 'Arginine N-methyltransferase, type II, putative', 227, NULL, NULL, 179511),
(179512, '1.10.510.10-FF-004228', NULL, NULL, 204, NULL, NULL, 179512),
(179513, '3.40.50.2000-FF-000020', NULL, 'Glycosyltransferase', 196, NULL, NULL, 179513),
(179514, '1.20.58.390-FF-000257', NULL, 'Uncharacterized protein', 102, NULL, NULL, 179514),
(179515, '2.70.130.10-FF-000123', NULL, NULL, 160, NULL, NULL, 179515),
(179516, '3.30.230.120-FF-000016', NULL, NULL, 217, NULL, NULL, 179516),
(179517, '3.10.450.10-FF-000039', NULL, 'Putative cysteine proteinase CG12163', 121, NULL, NULL, 179517),
(179518, '2.60.34.10-FF-000114', NULL, 'DnaK protein', 144, NULL, NULL, 179518),
(179519, '3.40.50.720-FF-000890', NULL, 'Erythronate-4-phosphate dehydrogenase', 166, NULL, NULL, 179519),
(179520, '3.30.160.60-FF-002101', NULL, 'Zinc finger protein 224', 30, NULL, NULL, 179520),
(179521, '1.10.490.10-FF-000021', NULL, 'GEO09476p1', 153, NULL, NULL, 179521),
(179522, '3.30.40.10-FF-001341', NULL, 'Uncharacterized protein', 65, NULL, NULL, 179522),
(179523, '2.60.40.10-FF-003596', NULL, NULL, 122, NULL, NULL, 179523),
(179524, '3.20.120.10-FF-000001', NULL, 'Hydrophobin', 74, NULL, NULL, 179524),
(179525, '2.60.40.150-FF-000643', NULL, 'Predicted protein', 127, NULL, NULL, 179525),
(179526, '3.30.160.60-FF-005962', NULL, NULL, 26, NULL, NULL, 179526),
(179527, '3.40.50.1010-FF-000178', NULL, NULL, 164, NULL, NULL, 179527),
(179528, '3.80.10.10-FF-002708', NULL, 'Leucine-rich repeat receptor-like protein kinase', 121, NULL, NULL, 179528),
(179529, '1.25.40.10-FF-001908', NULL, 'Pet309p', 181, NULL, NULL, 179529),
(179530, '2.60.40.1510-FF-000043', NULL, 'G-protein coupled receptor 98-like isoform X1', 145, NULL, NULL, 179530),
(179531, '2.40.70.10-FF-000518', NULL, NULL, 64, NULL, NULL, 179531),
(179532, '3.40.30.10-FF-001065', NULL, 'Uncharacterized protein', 162, NULL, NULL, 179532),
(179533, '3.40.50.300-FF-004260', NULL, 'General secretion pathway protein E', 297, NULL, NULL, 179533),
(179534, '1.25.40.10-FF-003472', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 98, NULL, NULL, 179534);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(179535, '2.60.120.330-FF-000150', NULL, 'Uncharacterized protein', 172, NULL, NULL, 179535),
(179536, '2.130.10.10-FF-004193', NULL, 'Predicted protein', 160, NULL, NULL, 179536),
(179537, '3.30.70.330-FF-003140', NULL, NULL, 86, NULL, NULL, 179537),
(179538, '3.30.460.50-FF-000002', NULL, 'RET2, RNA editing complex MP57', 121, NULL, NULL, 179538),
(179539, '1.10.510.10-FF-002300', NULL, 'Uncharacterized protein', 249, NULL, NULL, 179539),
(179540, '2.60.40.790-FF-000031', NULL, 'Small heat-shock protein', 108, NULL, NULL, 179540),
(179541, '3.40.50.150-FF-001011', NULL, NULL, 197, NULL, NULL, 179541),
(179542, '3.10.110.10-FF-000244', NULL, 'Ubiquitin-conjugating enzyme E2Ka (UBC1 homolog)', 111, NULL, NULL, 179542),
(179543, '1.20.58.60-FF-000637', NULL, 'Uncharacterized protein', 294, NULL, NULL, 179543),
(179544, '3.10.330.70-FF-000003', NULL, 'Uncharacterized protein', 21, NULL, NULL, 179544),
(179545, '2.60.120.10-FF-000479', NULL, '3-hydroxyanthranilate 3,4-dioxygenase', 173, NULL, NULL, 179545),
(179546, '2.10.70.10-FF-000099', NULL, 'Seizure related 6 homolog', 64, NULL, NULL, 179546),
(179547, '3.40.50.300-FF-003754', NULL, 'Probable pre-mRNA-splicing factor ATP-dependent RNA helicase DEAH8', 212, NULL, NULL, 179547),
(179548, '3.90.1150.10-FF-000104', NULL, 'Kynureninase, putative', 50, NULL, NULL, 179548),
(179549, '3.30.565.10-FF-000346', NULL, 'MORC family CW-type zinc finger 2', 163, NULL, NULL, 179549),
(179550, '1.20.5.1430-FF-000022', NULL, 'Uncharacterized protein', 74, NULL, NULL, 179550),
(179551, '1.10.8.10-FF-000079', NULL, 'Ubiquitin family protein', 60, NULL, NULL, 179551),
(179552, '3.80.10.10-FF-000090', NULL, 'Leucine-rich repeat neuronal protein 1', 91, NULL, NULL, 179552),
(179553, '3.30.110.110-FF-000015', NULL, 'Double-strand break repair protein', 112, NULL, NULL, 179553),
(179554, '2.30.29.30-FF-001273', NULL, 'Uncharacterized protein', 98, NULL, NULL, 179554),
(179555, '1.10.1200.10-FF-000123', NULL, 'Amino acid adenylation domain protein', 81, NULL, NULL, 179555),
(179556, '1.20.58.60-FF-000154', NULL, 'nesprin-1 isoform X4', 107, NULL, NULL, 179556),
(179557, '1.10.10.10-FF-001238', NULL, 'PCI domain containing protein', 68, NULL, NULL, 179557),
(179558, '1.10.620.20-FF-000041', NULL, 'Uncharacterized protein', 68, NULL, NULL, 179558),
(179559, '2.10.25.10-FF-001192', NULL, 'Laminin subunit gamma-1', 48, NULL, NULL, 179559),
(179560, '2.40.160.120-FF-000066', NULL, 'Oxysterol-binding protein', 90, NULL, NULL, 179560),
(179561, '3.40.50.300-FF-006508', NULL, 'Ras family protein', 113, NULL, NULL, 179561),
(179562, '1.20.1310.20-FF-000036', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 192, NULL, NULL, 179562),
(179563, '3.40.50.300-FF-006188', NULL, 'DNA helicase', 273, NULL, NULL, 179563),
(179564, '3.30.160.60-FF-000639', NULL, 'Zinc finger and BTB domain-containing protein 16', 23, NULL, NULL, 179564),
(179565, '3.30.200.20-FF-001328', NULL, NULL, 70, NULL, NULL, 179565),
(179566, '1.10.287.1490-FF-000134', NULL, 'AER045Cp', 194, NULL, NULL, 179566),
(179567, '2.130.10.10-FF-001011', NULL, 'Cleavage and polyadenylation specificity factor (CPSF) A subunit protein', 384, NULL, NULL, 179567),
(179568, '3.40.50.200-FF-000161', NULL, 'Uncharacterized protein', 172, NULL, NULL, 179568),
(179569, '1.10.3080.10-FF-000051', NULL, 'Chloride channel protein', 287, NULL, NULL, 179569),
(179570, '3.30.420.40-FF-000199', NULL, 'Related to glucose regulated stress protein, HSP70-like', 144, NULL, NULL, 179570),
(179571, '4.10.400.10-FF-000364', NULL, 'Transmembrane cell adhesion receptor mua-3', 42, NULL, NULL, 179571),
(179572, '3.80.10.10-FF-000101', NULL, 'LRR receptor-like serine/threonine-protein kinase ERECTA', 163, NULL, NULL, 179572),
(179573, '3.60.20.10-FF-000029', NULL, 'Proteasome subunit alpha type', 237, NULL, NULL, 179573),
(179574, '1.10.630.10-FF-000010', NULL, 'cytochrome P450 2W1 isoform X2', 469, NULL, NULL, 179574),
(179575, '3.40.1190.20-FF-000065', NULL, 'Ribokinase', 341, NULL, NULL, 179575),
(179576, '1.10.730.10-FF-000057', NULL, 'Leucine--tRNA ligase', 34, NULL, NULL, 179576);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(179577, '3.90.550.10-FF-000618', NULL, 'Predicted protein', 209, NULL, NULL, 179577),
(179578, '3.30.1370.240-FF-000014', NULL, 'Phenylalanine--tRNA ligase alpha subunit B', 79, NULL, NULL, 179578),
(179579, '1.25.40.10-FF-005080', NULL, 'Os11g0109800 protein', 93, NULL, NULL, 179579),
(179580, '3.30.1390.20-FF-000009', NULL, '60S ribosomal protein L7-like 1', 96, NULL, NULL, 179580),
(179581, '3.90.25.10-FF-000073', NULL, 'NAD-dependent epimerase/dehydratase family protein', 120, NULL, NULL, 179581),
(179582, '3.30.1120.130-FF-000004', NULL, 'serine/threonine-protein kinase PLK4-like isoform X1', 120, NULL, NULL, 179582),
(179583, '3.30.450.20-FF-000178', NULL, 'Methyl-accepting chemotaxis protein', 109, NULL, NULL, 179583),
(179584, '3.60.10.10-FF-000383', NULL, 'Uncharacterized protein', 73, NULL, NULL, 179584),
(179585, '2.130.10.10-FF-001792', NULL, 'WD repeat protein', 237, NULL, NULL, 179585),
(179586, '1.10.510.10-FF-001827', NULL, 'Serine/threonine-protein_kinase_-_putative', 179, NULL, NULL, 179586),
(179587, '1.20.990.10-FF-000006', NULL, 'Nitric oxide synthase', 131, NULL, NULL, 179587),
(179588, '3.30.530.20-FF-000212', NULL, 'Uncharacterized protein', 80, NULL, NULL, 179588),
(179589, '3.40.50.1240-FF-000179', NULL, NULL, 183, NULL, NULL, 179589),
(179590, '3.10.28.10-FF-000009', NULL, 'HO endonuclease', 102, NULL, NULL, 179590),
(179591, '3.40.50.300-FF-005569', NULL, 'Sca1 complex protein phr', 172, NULL, NULL, 179591),
(179592, '3.20.20.190-FF-000072', NULL, 'Phosphoinositide phospholipase C', 319, NULL, NULL, 179592),
(179593, '3.30.470.30-FF-000070', NULL, 'mRNA capping enzyme, catalytic domain-containing protein', 228, NULL, NULL, 179593),
(179594, '1.20.120.1760-FF-000045', NULL, 'CDP-diacylglycerol--inositol 3-phosphatidyltransferase', 187, NULL, NULL, 179594),
(179595, '3.30.70.330-FF-000234', NULL, 'Polyadenylate-binding protein 5', 96, NULL, NULL, 179595),
(179596, '2.70.20.10-FF-000003', NULL, 'DNA topoisomerase 3', 144, NULL, NULL, 179596),
(179597, '3.40.50.80-FF-000199', NULL, 'FRE family ferric-chelate reductase, putative (AFU_orthologue AFUA_1G17270)', 50, NULL, NULL, 179597),
(179598, '3.30.1360.40-FF-000047', NULL, 'Predicted protein', 74, NULL, NULL, 179598),
(179599, '2.40.10.120-FF-000014', NULL, 'Pro-apoptotic serine protease NMA111', 210, NULL, NULL, 179599),
(179600, '3.40.50.300-FF-001837', NULL, 'Putative DEAD box helicase', 163, NULL, NULL, 179600),
(179601, '1.20.1070.10-FF-000110', NULL, 'olfactory receptor 10H1-like', 291, NULL, NULL, 179601),
(179602, '3.90.230.10-FF-000027', NULL, 'Methionine aminopeptidase', 248, NULL, NULL, 179602),
(179603, '3.40.50.300-FF-002343', NULL, 'ATP-binding Cassette (ABC) Superfamily', 264, NULL, NULL, 179603),
(179604, '3.30.70.330-FF-001678', NULL, NULL, 89, NULL, NULL, 179604),
(179605, '3.40.190.10-FF-000068', NULL, 'Phosphate ABC transporter substrate-binding protein', 130, NULL, NULL, 179605),
(179606, '3.30.420.10-FF-000673', NULL, NULL, 171, NULL, NULL, 179606),
(179607, '3.40.30.10-FF-000446', NULL, 'Thioredoxin-like protein', 109, NULL, NULL, 179607),
(179608, '3.90.1300.10-FF-000021', NULL, 'Uncharacterized protein', 512, NULL, NULL, 179608),
(179609, '3.10.20.90-FF-000549', NULL, 'Sacsin molecular chaperone', 59, NULL, NULL, 179609),
(179610, '2.60.120.430-FF-000045', NULL, 'Uncharacterized protein', 74, NULL, NULL, 179610),
(179611, '1.10.510.10-FF-002772', NULL, 'Serine/threonine-protein kinase NEK', 320, NULL, NULL, 179611),
(179612, '2.10.25.10-FF-000926', NULL, 'Multiple epidermal growth factor-like domains protein 6', 46, NULL, NULL, 179612),
(179613, '2.10.25.10-FF-001545', NULL, 'Uncharacterized protein', 55, NULL, NULL, 179613),
(179614, '3.40.250.10-FF-000039', NULL, 'ArsR family transcriptional regulator', 109, NULL, NULL, 179614),
(179615, '1.25.10.10-FF-003335', NULL, 'Nucleolar protein 9', 257, NULL, NULL, 179615),
(179616, '3.10.620.10-FF-000002', NULL, 'Protein N-terminal glutamine amidohydrolase', 205, NULL, NULL, 179616),
(179617, '3.40.225.10-FF-000043', NULL, NULL, 88, NULL, NULL, 179617);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(179618, '1.25.40.10-FF-003825', NULL, 'Coatomer subunit epsilon-1', 128, NULL, NULL, 179618),
(179619, '1.10.1520.10-FF-000068', NULL, 'Ribonuclease 3 2', 130, NULL, NULL, 179619),
(179620, '3.10.290.10-FF-000037', NULL, 'BnaA05g14690D protein', 58, NULL, NULL, 179620),
(179621, '2.60.200.40-FF-000056', NULL, 'Diacylglycerol kinase', 184, NULL, NULL, 179621),
(179622, '1.10.533.10-FF-000099', NULL, 'Uncharacterized protein', 89, NULL, NULL, 179622),
(179623, '3.90.70.80-FF-000029', NULL, 'Uncharacterized protein, isoform A', 144, NULL, NULL, 179623),
(179624, '3.40.50.300-FF-007014', NULL, 'Uncharacterized protein', 207, NULL, NULL, 179624),
(179625, '2.130.10.10-FF-001803', NULL, 'WD domain, G-beta repeat, putative', 181, NULL, NULL, 179625),
(179626, '3.20.20.140-FF-000208', NULL, 'DNA polymerase III PolC-type', 174, NULL, NULL, 179626),
(179627, '3.80.10.10-FF-001871', NULL, 'Leucine-rich repeats and IQ motif containing 1', 162, NULL, NULL, 179627),
(179628, '2.120.10.30-FF-000039', NULL, 'E3 ubiquitin-protein ligase TRIM32', 200, NULL, NULL, 179628),
(179629, '3.30.200.210-FF-000009', NULL, NULL, 125, NULL, NULL, 179629),
(179630, '3.30.60.90-FF-000023', NULL, 'Protein NBR1 homolog', 66, NULL, NULL, 179630),
(179631, '1.10.630.10-FF-000802', NULL, 'Uncharacterized protein', 74, NULL, NULL, 179631),
(179632, '3.30.160.60-FF-000286', NULL, 'Zinc finger protein 770', 27, NULL, NULL, 179632),
(179633, '2.30.30.90-FF-000001', NULL, 'Ferrous iron transporter A', 68, NULL, NULL, 179633),
(179634, '2.60.200.20-FF-000050', NULL, 'Kinesin-like protein, KLP38B', 111, NULL, NULL, 179634),
(179635, '1.20.1560.10-FF-000647', NULL, 'AGAP008437-PA', 136, NULL, NULL, 179635),
(179636, '1.10.510.10-FF-003609', NULL, NULL, 199, NULL, NULL, 179636),
(179637, '1.10.238.10-FF-000722', NULL, 'Calcium-binding allergen Ole e 8', 36, NULL, NULL, 179637),
(179638, '2.10.50.10-FF-000086', NULL, 'Predicted protein', 71, NULL, NULL, 179638),
(179639, '3.90.215.10-FF-000003', NULL, 'angiopoietin-2 isoform X1', 136, NULL, NULL, 179639),
(179640, '3.40.50.150-FF-000814', NULL, 'Methyltransferase domain-containing protein', 183, NULL, NULL, 179640),
(179641, '1.25.40.10-FF-000066', NULL, 'Tetratricopeptide repeat domain 7A', 177, NULL, NULL, 179641),
(179642, '1.20.1050.90-FF-000014', NULL, 'DNA replication and repair protein RecF', 176, NULL, NULL, 179642),
(179643, '3.90.640.90-FF-000014', NULL, 'Uncharacterized protein', 127, NULL, NULL, 179643),
(179644, '2.130.10.10-FF-002629', NULL, 'WD repeat protein, putative', 306, NULL, NULL, 179644),
(179645, '3.40.1110.10-FF-000186', NULL, 'Calcium-transporting ATPase 1', 183, NULL, NULL, 179645),
(179646, '1.10.8.60-FF-000280', NULL, 'Spermatogenesis associated 5', 60, NULL, NULL, 179646),
(179647, '1.10.418.10-FF-000011', NULL, 'Parvin, beta', 127, NULL, NULL, 179647),
(179648, '1.10.287.3240-FF-000007', NULL, 'V-type ATP synthase subunit D', 206, NULL, NULL, 179648),
(179649, '3.40.47.10-FF-000232', NULL, NULL, 71, NULL, NULL, 179649),
(179650, '2.40.10.10-FF-000189', NULL, 'Ovochymase, putative', 102, NULL, NULL, 179650),
(179651, '1.25.40.10-FF-003516', NULL, 'Serine/threonine-protein kinase TOR', 441, NULL, NULL, 179651),
(179652, '1.20.1250.20-FF-000357', NULL, 'Glucose transporter, lmgt1', 206, NULL, NULL, 179652),
(179653, '1.10.8.100-FF-000021', NULL, 'Ribosomal RNA small subunit methyltransferase A', 73, NULL, NULL, 179653),
(179654, '3.40.50.1700-FF-000025', NULL, 'Putative sugar hydrolase', 192, NULL, NULL, 179654),
(179655, '1.20.1560.10-FF-000338', NULL, 'ABC transporter, putative', 343, NULL, NULL, 179655),
(179656, '2.70.98.20-FF-000016', NULL, 'Amine oxidase', 442, NULL, NULL, 179656),
(179657, '3.40.50.2300-FF-001301', NULL, NULL, 129, NULL, NULL, 179657),
(179658, '2.130.10.10-FF-005974', NULL, 'Uncharacterized protein', 237, NULL, NULL, 179658),
(179659, '1.10.510.10-FF-001002', NULL, 'Protein CBG10779', 338, NULL, NULL, 179659),
(179660, '2.30.110.10-FF-000018', NULL, 'Deazaflavin-dependent oxidoreductase, nitroreductase family', 144, NULL, NULL, 179660);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(179661, '2.40.50.1070-FF-000005', NULL, 'tRNA (Uracil-5-)-methyltransferase homolog A isoform X1', 171, NULL, NULL, 179661),
(179662, '3.30.40.10-FF-000043', NULL, 'Putative e3 ubiquitin-protein ligase march8', 77, NULL, NULL, 179662),
(179663, '3.30.1310.10-FF-000001', NULL, 'Nucleoid-associated protein YbaB', 109, NULL, NULL, 179663),
(179664, '3.40.1700.10-FF-000006', NULL, 'Diadenylate cyclase', 167, NULL, NULL, 179664),
(179665, '3.40.1090.10-FF-000009', NULL, 'Patatin like phospholipase domain containing 7', 104, NULL, NULL, 179665),
(179666, '1.10.210.10-FF-000001', NULL, 'Uteroglobin', 73, NULL, NULL, 179666),
(179667, '4.10.1060.10-FF-000053', NULL, 'Uncharacterized protein', 36, NULL, NULL, 179667),
(179668, '2.40.10.10-FF-000509', NULL, NULL, 77, NULL, NULL, 179668),
(179669, '3.30.160.60-FF-004990', NULL, NULL, 67, NULL, NULL, 179669),
(179670, '2.60.40.10-FF-006030', NULL, NULL, 70, NULL, NULL, 179670),
(179671, '3.80.10.10-FF-000882', NULL, 'Tubulin-folding cofactor E', 169, NULL, NULL, 179671),
(179672, '3.10.20.90-FF-000179', NULL, 'Plant UBX domain-containing protein 4', 127, NULL, NULL, 179672),
(179673, '2.60.40.10-FF-002444', NULL, 'Uncharacterized protein, isoform D', 128, NULL, NULL, 179673),
(179674, '3.90.70.10-FF-000278', NULL, 'Ubiquitin carboxyl-terminal hydrolase 1', 186, NULL, NULL, 179674),
(179675, '3.60.21.10-FF-000172', NULL, 'Predicted protein', 280, NULL, NULL, 179675),
(179676, '1.50.40.10-FF-000457', NULL, 'Predicted protein', 95, NULL, NULL, 179676),
(179677, '1.10.510.10-FF-003391', NULL, NULL, 311, NULL, NULL, 179677),
(179678, '3.30.70.580-FF-000067', NULL, 'tRNA pseudouridine synthase', 68, NULL, NULL, 179678),
(179679, '1.10.510.10-FF-000046', NULL, 'probable serine/threonine-protein kinase WNK9', 181, NULL, NULL, 179679),
(179680, '1.25.40.10-FF-004461', NULL, 'Pentatricopeptide repeat-containing protein At2g28050', 111, NULL, NULL, 179680),
(179681, '2.130.10.10-FF-000022', NULL, 'Coatomer subunit alpha', 325, NULL, NULL, 179681),
(179682, '1.10.10.60-FF-000011', NULL, 'Myb transcription factor', 53, NULL, NULL, 179682),
(179683, '2.60.40.60-FF-000744', NULL, 'Fat-like cadherin-related tumor suppressor homolog', 108, NULL, NULL, 179683),
(179684, '3.40.50.10470-FF-000024', NULL, 'Translation initiation factor eIF-2B subunit alpha, putative', 205, NULL, NULL, 179684),
(179685, '1.25.40.10-FF-004091', NULL, 'Uncharacterized protein', 152, NULL, NULL, 179685),
(179686, '3.40.190.10-FF-000540', NULL, 'Uncharacterized protein', 130, NULL, NULL, 179686),
(179687, '3.30.200.20-FF-001767', NULL, 'Serine/threonine-protein kinase PLK', 93, NULL, NULL, 179687),
(179688, '3.30.950.10-FF-000005', NULL, 'Uroporphyrin-III c-methyltransferase, putative', 135, NULL, NULL, 179688),
(179689, '2.60.40.10-FF-005850', NULL, NULL, 101, NULL, NULL, 179689),
(179690, '3.30.70.330-FF-000689', NULL, 'Small nuclear ribonucleoprotein U1 subunit 70', 110, NULL, NULL, 179690),
(179691, '2.60.120.920-FF-000113', NULL, 'Uncharacterized protein', 130, NULL, NULL, 179691),
(179692, '3.40.50.1000-FF-000821', NULL, NULL, 97, NULL, NULL, 179692),
(179693, '3.30.559.30-FF-000091', NULL, 'Nonribosomal peptide synthase 2', 260, NULL, NULL, 179693),
(179694, '2.130.10.120-FF-000009', NULL, 'Probable peptidase', 349, NULL, NULL, 179694),
(179695, '2.30.29.30-FF-000654', NULL, 'Phosphoinositide phospholipase C', 117, NULL, NULL, 179695),
(179696, '1.10.3380.10-FF-000063', NULL, 'Uncharacterized protein', 87, NULL, NULL, 179696),
(179697, '3.80.10.10-FF-001399', NULL, 'Uncharacterized protein', 203, NULL, NULL, 179697),
(179698, '2.60.40.200-FF-000017', NULL, 'Extracellular superoxide dismutase [Cu-Zn] 2', 160, NULL, NULL, 179698),
(179699, '2.30.29.30-FF-001143', NULL, 'Uncharacterized protein', 228, NULL, NULL, 179699),
(179700, '1.10.1420.10-FF-000134', NULL, 'DNA mismatch repair protein', 181, NULL, NULL, 179700),
(179701, '3.30.40.10-FF-001324', NULL, 'RING-H2 finger protein ATL7', 47, NULL, NULL, 179701),
(179702, '3.30.160.60-FF-000948', NULL, 'Zinc finger protein 641', 24, NULL, NULL, 179702);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(179703, '3.40.910.10-FF-000023', NULL, 'Deoxyhypusine synthase, putative', 299, NULL, NULL, 179703),
(179704, '1.10.10.60-FF-000820', NULL, NULL, 73, NULL, NULL, 179704),
(179705, '3.40.720.10-FF-000323', NULL, 'Uncharacterized protein', 164, NULL, NULL, 179705),
(179706, '1.10.510.10-FF-003289', NULL, NULL, 240, NULL, NULL, 179706),
(179707, '2.130.10.10-FF-002276', NULL, 'Zinc finger CCCH domain-containing protein 48', 252, NULL, NULL, 179707),
(179708, '3.40.50.1820-FF-000757', NULL, 'Uncharacterized protein', 317, NULL, NULL, 179708),
(179709, '3.40.50.850-FF-000018', NULL, 'Streptothricin hydrolase', 187, NULL, NULL, 179709),
(179710, '3.20.20.110-FF-000003', NULL, 'Ribulose bisphosphate carboxylase large chain', 196, NULL, NULL, 179710),
(179711, '1.10.506.10-FF-000087', NULL, 'Uncharacterized protein', 112, NULL, NULL, 179711),
(179712, '2.40.70.10-FF-000209', NULL, 'Endopeptidase', 208, NULL, NULL, 179712),
(179713, '3.40.50.2300-FF-001638', NULL, NULL, 259, NULL, NULL, 179713),
(179714, '3.30.810.10-FF-000012', NULL, 'Phosphatidylinositol-4-phosphate 5-Kinase family protein', 169, NULL, NULL, 179714),
(179715, '1.10.100.10-FF-000009', NULL, 'Insulin-like peptide 4', 61, NULL, NULL, 179715),
(179716, '3.40.50.2300-FF-000020', NULL, 'Glutamate receptor ionotropic, NMDA 2B, putative', 159, NULL, NULL, 179716),
(179717, '2.60.40.10-FF-005541', NULL, NULL, 42, NULL, NULL, 179717),
(179718, '1.20.1530.20-FF-000047', NULL, 'Glutathione-regulated potassium-efflux system protein', 400, NULL, NULL, 179718),
(179719, '3.40.190.10-FF-000877', NULL, 'Uncharacterized protein', 127, NULL, NULL, 179719),
(179720, '3.10.150.10-FF-000027', NULL, 'Beta sliding clamp', 119, NULL, NULL, 179720),
(179721, '3.30.70.330-FF-002504', NULL, NULL, 72, NULL, NULL, 179721),
(179722, '1.20.1270.360-FF-000001', NULL, 'Copper storage protein 1', 115, NULL, NULL, 179722),
(179723, '1.25.10.10-FF-002716', NULL, 'Uncharacterized protein', 974, NULL, NULL, 179723),
(179724, '1.25.40.10-FF-004444', NULL, 'Predicted protein', 116, NULL, NULL, 179724),
(179725, '3.60.21.10-FF-000329', NULL, 'Serine/threonine-protein phosphatase', 125, NULL, NULL, 179725),
(179726, '3.40.50.720-FF-002233', NULL, '2-hydroxyacid dehydrogenase', 94, NULL, NULL, 179726),
(179727, '3.30.160.60-FF-002073', NULL, 'Zinc finger protein 214', 23, NULL, NULL, 179727),
(179728, '3.80.10.10-FF-001062', NULL, 'lumican', 84, NULL, NULL, 179728),
(179729, '3.80.10.10-FF-002490', NULL, 'Uncharacterized protein', 119, NULL, NULL, 179729),
(179730, '1.10.10.10-FF-001890', NULL, 'Ferric uptake regulator, Fur family', 83, NULL, NULL, 179730),
(179731, '1.10.437.10-FF-000050', NULL, 'Uncharacterized protein', 123, NULL, NULL, 179731),
(179732, '3.90.550.10-FF-000265', NULL, 'Protein CBG07620', 245, NULL, NULL, 179732),
(179733, '1.10.10.160-FF-000048', NULL, 'DNA helicase', 84, NULL, NULL, 179733),
(179734, '3.30.40.10-FF-001763', NULL, 'AGAP003004-PA', 63, NULL, NULL, 179734),
(179735, '3.30.420.300-FF-000001', NULL, '2-oxo-3-deoxygalactonate kinase', 76, NULL, NULL, 179735),
(179736, '2.30.42.10-FF-000140', NULL, 'Multiple PDZ domain crumbs cell polarity complex component', 113, NULL, NULL, 179736),
(179737, '3.80.10.10-FF-000926', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase isoform A', 68, NULL, NULL, 179737),
(179738, '1.20.1050.10-FF-000108', NULL, 'Thiol-dependent reductase 1', 135, NULL, NULL, 179738),
(179739, '1.20.1070.10-FF-001099', NULL, '5-hydroxytryptamine receptor-like isoform X1', 314, NULL, NULL, 179739),
(179740, '2.120.10.80-FF-000223', NULL, 'Kelch repeat-containing protein', 269, NULL, NULL, 179740),
(179741, '1.10.3080.10-FF-000034', NULL, 'Voltage-gated chloride channel protein', 389, NULL, NULL, 179741),
(179742, '1.10.1420.10-FF-000004', NULL, 'DNA mismatch repair protein Msh3', 128, NULL, NULL, 179742),
(179743, '1.10.10.10-FF-000721', NULL, 'DNA-binding response regulator', 105, NULL, NULL, 179743),
(179744, '1.20.870.10-FF-000031', NULL, 'Rap Guanine nucleotide Exchange Factor homolog', 131, NULL, NULL, 179744);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(179745, '3.30.160.60-FF-004029', NULL, NULL, 59, NULL, NULL, 179745),
(179746, '1.10.10.10-FF-001547', NULL, 'Putative dna-directed rna polymerase iii subunit rpc3', 81, NULL, NULL, 179746),
(179747, '3.80.10.10-FF-002388', NULL, 'GD10134', 253, NULL, NULL, 179747),
(179748, '3.30.420.610-FF-000021', NULL, 'Tudor domain-containing protein 7', 78, NULL, NULL, 179748),
(179749, '2.130.10.10-FF-000831', NULL, 'Polyadenylation factor subunit 2, putative', 247, NULL, NULL, 179749),
(179750, '3.20.20.70-FF-000341', NULL, 'Glycoside hydrolase family 36', 285, NULL, NULL, 179750),
(179751, '3.40.50.620-FF-000859', NULL, 'Uncharacterized protein', 175, NULL, NULL, 179751),
(179752, '1.10.1220.10-FF-000006', NULL, 'Bifunctional protein PutA', 42, NULL, NULL, 179752),
(179753, '3.40.30.10-FF-000093', NULL, 'Glutaredoxin 2', 110, NULL, NULL, 179753),
(179754, '1.25.10.10-FF-001862', NULL, 'ARM repeat superfamily protein', 171, NULL, NULL, 179754),
(179755, '3.40.50.2300-FF-001481', NULL, NULL, 136, NULL, NULL, 179755),
(179756, '3.40.50.1000-FF-000719', NULL, NULL, 94, NULL, NULL, 179756),
(179757, '2.40.50.140-FF-000231', NULL, 'RNA methyltransferase family protein', 84, NULL, NULL, 179757),
(179758, '1.25.40.180-FF-000292', NULL, NULL, 115, NULL, NULL, 179758),
(179759, '1.20.1250.20-FF-001846', NULL, 'Uncharacterized protein', 134, NULL, NULL, 179759),
(179760, '3.40.630.10-FF-000102', NULL, 'N-acetylated-alpha-linked acidic dipeptidase protein', 103, NULL, NULL, 179760),
(179761, '3.30.1520.10-FF-000186', NULL, 'Predicted protein', 84, NULL, NULL, 179761),
(179762, '1.25.40.70-FF-000038', NULL, 'Phosphoinositide-3-kinase, catalytic, alpha polypeptide', 170, NULL, NULL, 179762),
(179763, '3.40.50.300-FF-000426', NULL, 'Ferrous iron transport protein B', 169, NULL, NULL, 179763),
(179764, '3.30.1330.10-FF-000014', NULL, 'Selenophosphate synthetase 2', 118, NULL, NULL, 179764),
(179765, '2.40.30.170-FF-000016', NULL, 'Efflux transporter, RND family, MFP subunit', 78, NULL, NULL, 179765),
(179766, '3.30.160.60-FF-003692', NULL, 'Zinc finger protein ZAT10', 77, NULL, NULL, 179766),
(179767, '3.30.60.60-FF-000008', NULL, 'Histone acetyltransferase', 79, NULL, NULL, 179767),
(179768, '2.130.10.10-FF-002731', NULL, 'WD repeat domain phosphoinositide-interacting protein 4', 297, NULL, NULL, 179768),
(179769, '3.40.30.10-FF-000576', NULL, 'Protein disulfide-isomerase', 117, NULL, NULL, 179769),
(179770, '2.60.40.10-FF-004922', NULL, NULL, 88, NULL, NULL, 179770),
(179771, '1.10.10.60-FF-001000', NULL, NULL, 45, NULL, NULL, 179771),
(179772, '2.20.25.530-FF-000012', NULL, 'Uncharacterized protein', 73, NULL, NULL, 179772),
(179773, '2.60.40.1400-FF-000010', NULL, 'Uncharacterized protein, isoform A', 181, NULL, NULL, 179773),
(179774, '2.60.40.10-FF-001488', NULL, 'Interleukin-10 receptor subunit alpha', 111, NULL, NULL, 179774),
(179775, '3.30.420.10-FF-000201', NULL, 'Piwi-like protein 1', 264, NULL, NULL, 179775),
(179776, '1.25.40.10-FF-000419', NULL, 'Outer membrane protein assembly factor BamD', 243, NULL, NULL, 179776),
(179777, '3.40.1360.10-FF-000036', NULL, 'SPO11 meiotic protein covalently-bound to DSB', 125, NULL, NULL, 179777),
(179778, '3.30.160.60-FF-006255', NULL, NULL, 27, NULL, NULL, 179778),
(179779, '2.60.120.200-FF-000431', NULL, 'Concanavalin A-like lectin/glucanase domain-containing protein', 243, NULL, NULL, 179779),
(179780, '2.40.320.10-FF-000021', NULL, 'Mediator of RNA polymerase II transcription subunit 18', 261, NULL, NULL, 179780),
(179781, '3.40.50.740-FF-000002', NULL, 'NADH-ubiquinone oxidoreductase 75 kDa subunit, mitochondrial', 169, NULL, NULL, 179781),
(179782, '3.60.20.30-FF-000024', NULL, NULL, 72, NULL, NULL, 179782),
(179783, '1.20.1250.10-FF-000028', NULL, 'Granulocyte-macrophage colony-stimulating factor', 127, NULL, NULL, 179783),
(179784, '1.10.720.50-FF-000001', NULL, 'DNA (Cytosine-5)-methyltransferase 3B isoform X2', 69, NULL, NULL, 179784),
(179785, '2.60.120.10-FF-000703', NULL, 'Uncharacterized protein', 210, NULL, NULL, 179785),
(179786, '1.10.10.2210-FF-000006', NULL, NULL, 31, NULL, NULL, 179786);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(179787, '3.40.630.30-FF-000108', NULL, 'Polyamine acetyltransferase', 174, NULL, NULL, 179787),
(179788, '3.30.70.330-FF-001987', NULL, NULL, 98, NULL, NULL, 179788),
(179789, '1.20.920.30-FF-000053', NULL, 'Uncharacterized protein', 143, NULL, NULL, 179789),
(179790, '1.25.40.10-FF-003163', NULL, 'Os08g0340900 protein', 114, NULL, NULL, 179790),
(179791, '3.40.50.2300-FF-000312', NULL, 'Glutamate ionotropic receptor NMDA type subunit 2B', 87, NULL, NULL, 179791),
(179792, '2.40.30.10-FF-000191', NULL, 'Sulfate adenylyltransferase subunit 1', 105, NULL, NULL, 179792),
(179793, '2.30.330.10-FF-000001', NULL, 'Flagellar motor switch protein FliN', 92, NULL, NULL, 179793),
(179794, '1.10.10.200-FF-000004', NULL, 'Probable transcriptional regulatory protein BSBG_02618', 57, NULL, NULL, 179794),
(179795, '3.10.129.110-FF-000010', NULL, 'CurK', 294, NULL, NULL, 179795),
(179796, '2.30.30.40-FF-000391', NULL, 'ITSN (Intersectin) family', 67, NULL, NULL, 179796),
(179797, '2.60.40.200-FF-000034', NULL, 'Uncharacterized protein', 47, NULL, NULL, 179797),
(179798, '2.30.30.490-FF-000047', NULL, 'Protein CBR-LIN-40', 84, NULL, NULL, 179798),
(179799, '2.60.40.150-FF-000334', NULL, 'Phosphatidylinositol 3-kinase, putative', 146, NULL, NULL, 179799),
(179800, '1.20.1250.20-FF-001054', NULL, 'Glucitol/sorbitol-specific transport protein GutA', 205, NULL, NULL, 179800),
(179801, '1.10.555.10-FF-000144', NULL, 'inositol polyphosphate 5-phosphatase OCRL-1 isoform X3', 170, NULL, NULL, 179801),
(179802, '4.10.1060.10-FF-000036', NULL, 'SUPPRESSOR OF ABI3-5 like', 33, NULL, NULL, 179802),
(179803, '2.60.34.20-FF-000004', NULL, 'Uncharacterized protein', 141, NULL, NULL, 179803),
(179804, '3.90.1720.10-FF-000013', NULL, 'Calcium-binding mitochondrial carrier protein SCaMC-1', 187, NULL, NULL, 179804),
(179805, '3.40.50.1700-FF-000042', NULL, 'Glycoside hydrolase superfamily', 209, NULL, NULL, 179805),
(179806, '1.10.287.3240-FF-000024', NULL, 'V-type ATP synthase subunit D', 194, NULL, NULL, 179806),
(179807, '1.25.40.20-FF-000086', NULL, 'Death associated protein kinase 1', 195, NULL, NULL, 179807),
(179808, '2.60.40.10-FF-004361', NULL, NULL, 96, NULL, NULL, 179808),
(179809, '2.40.170.20-FF-000080', NULL, 'SusC/RagA family TonB-linked outer membrane protein', 540, NULL, NULL, 179809),
(179810, '3.50.30.30-FF-000154', NULL, 'Glutamate carboxypeptidase, putative', 57, NULL, NULL, 179810),
(179811, '3.20.20.80-FF-000670', NULL, 'Predicted protein', 373, NULL, NULL, 179811),
(179812, '3.40.50.720-FF-000108', NULL, 'dTDP-glucose 4,6-dehydratase', 243, NULL, NULL, 179812),
(179813, '3.40.50.1000-FF-000158', NULL, 'Phosphoserine phosphatase SerB', 146, NULL, NULL, 179813),
(179814, '2.130.10.10-FF-001320', NULL, 'Predicted protein', 178, NULL, NULL, 179814),
(179815, '1.25.40.180-FF-000275', NULL, NULL, 173, NULL, NULL, 179815),
(179816, '2.40.240.10-FF-000048', NULL, 'Glutamine--tRNA ligase', 84, NULL, NULL, 179816),
(179817, '3.30.1520.10-FF-000169', NULL, 'Non-specific serine/threonine protein kinase', 118, NULL, NULL, 179817),
(179818, '1.10.510.10-FF-003744', NULL, NULL, 147, NULL, NULL, 179818),
(179819, '3.40.50.620-FF-000904', NULL, 'Peptidase family M48 family protein', 62, NULL, NULL, 179819),
(179820, '1.10.565.10-FF-000072', NULL, 'Nuclear hormone receptor family member nhr-3', 220, NULL, NULL, 179820),
(179821, '2.170.270.10-FF-000076', NULL, 'Histone-lysine N-methyltransferase', 171, NULL, NULL, 179821),
(179822, '3.40.1190.20-FF-000082', NULL, 'ADP-dependent (S)-NAD(P)H-hydrate dehydratase', 275, NULL, NULL, 179822),
(179823, '3.30.160.60-FF-000156', NULL, 'Zinc finger protein 568', 28, NULL, NULL, 179823),
(179824, '2.40.10.10-FF-000644', NULL, NULL, 138, NULL, NULL, 179824),
(179825, '3.40.50.300-FF-004608', NULL, 'ATP-dependent DNA helicase', 96, NULL, NULL, 179825),
(179826, '1.20.1070.10-FF-000582', NULL, 'Muscarinic acetylcholine receptor gar-3', 250, NULL, NULL, 179826),
(179827, '2.40.50.180-FF-000001', NULL, 'Chemotaxis protein CheW', 68, NULL, NULL, 179827),
(179828, '1.10.10.10-FF-001255', NULL, 'Crp/Fnr family transcriptional regulator', 68, NULL, NULL, 179828);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(179829, '2.60.120.650-FF-000009', NULL, 'Putative lysine-specific demethylase 6B', 307, NULL, NULL, 179829),
(179830, '1.20.1070.10-FF-000891', NULL, 'Uncharacterized protein', 165, NULL, NULL, 179830),
(179831, '1.20.120.790-FF-000033', NULL, 'Endoplasmin', 105, NULL, NULL, 179831),
(179832, '3.40.50.150-FF-001792', NULL, NULL, 161, NULL, NULL, 179832),
(179833, '1.25.40.10-FF-003955', NULL, 'Pentatricopeptide repeat-containing protein At1g29710, mitochondrial', 259, NULL, NULL, 179833),
(179834, '2.60.40.150-FF-000204', NULL, 'No pollen', 159, NULL, NULL, 179834),
(179835, '1.10.730.10-FF-000074', NULL, 'Nam2p', 17, NULL, NULL, 179835),
(179836, '3.10.490.20-FF-000022', NULL, 'Cytoplasmic dynein 2 heavy chain 1', 126, NULL, NULL, 179836),
(179837, '3.80.10.10-FF-000590', NULL, 'Leucine-rich receptor-like protein kinase family protein', 107, NULL, NULL, 179837),
(179838, '3.30.160.60-FF-001567', NULL, 'Paternally expressed 3', 33, NULL, NULL, 179838),
(179839, '1.25.40.20-FF-000395', NULL, 'caskin-1 isoform X3', 118, NULL, NULL, 179839),
(179840, '3.40.1500.10-FF-000008', NULL, 'Coproporphyrinogen-III oxidase', 79, NULL, NULL, 179840),
(179841, '3.30.70.3250-FF-000015', NULL, NULL, 113, NULL, NULL, 179841),
(179842, '3.30.70.330-FF-001195', NULL, 'RNA-binding protein TIA-1, putative', 87, NULL, NULL, 179842),
(179843, '3.40.720.10-FF-000340', NULL, 'Uncharacterized protein', 98, NULL, NULL, 179843),
(179844, '1.20.120.230-FF-000034', NULL, 'Alpha-catenin-like protein hmp-1', 129, NULL, NULL, 179844),
(179845, '3.40.50.300-FF-006997', NULL, 'Predicted protein', 212, NULL, NULL, 179845),
(179846, '3.30.420.40-FF-000699', NULL, 'L-fuculose kinase', 241, NULL, NULL, 179846),
(179847, '3.40.50.1110-FF-000062', NULL, 'GDSL-motif lipase/hydrolase family protein', 335, NULL, NULL, 179847),
(179848, '3.40.50.150-FF-000359', NULL, 'S-adenosyl-methyltransferase Mraw', 171, NULL, NULL, 179848),
(179849, '1.20.1070.10-FF-001071', NULL, 'Predicted protein', 329, NULL, NULL, 179849),
(179850, '3.80.10.10-FF-001854', NULL, 'YALI0B18759p', 162, NULL, NULL, 179850),
(179851, '2.10.25.10-FF-000264', NULL, 'Fibrillin 2', 41, NULL, NULL, 179851),
(179852, '1.25.40.10-FF-003808', NULL, 'Uncharacterized protein', 138, NULL, NULL, 179852),
(179853, '3.30.40.10-FF-000835', NULL, 'E3 ubiquitin-protein ligase CIP8', 68, NULL, NULL, 179853),
(179854, '3.30.420.40-FF-000671', NULL, 'Uncharacterized protein', 42, NULL, NULL, 179854),
(179855, '2.130.10.10-FF-006019', NULL, 'Uncharacterized protein', 151, NULL, NULL, 179855),
(179856, '2.60.40.60-FF-000261', NULL, 'Cadherin-related family member 5', 108, NULL, NULL, 179856),
(179857, '3.40.640.10-FF-000030', NULL, 'Low-specificity L-threonine aldolase', 246, NULL, NULL, 179857),
(179858, '3.30.300.20-FF-000066', NULL, '30S ribosomal protein S3, chloroplastic', 102, NULL, NULL, 179858),
(179859, '1.25.10.10-FF-000890', NULL, 'Hsh155p', 197, NULL, NULL, 179859),
(179860, '3.30.40.10-FF-001471', NULL, 'Uncharacterized protein', 92, NULL, NULL, 179860),
(179861, '3.30.40.10-FF-002297', NULL, 'Uncharacterized protein', 118, NULL, NULL, 179861),
(179862, '1.20.120.1320-FF-000014', NULL, NULL, 100, NULL, NULL, 179862),
(179863, '3.40.190.10-FF-000085', NULL, 'LysR family transcriptional regulator', 86, NULL, NULL, 179863),
(179864, '3.30.420.40-FF-000980', NULL, 'Actin-related protein 8', 124, NULL, NULL, 179864),
(179865, '2.10.220.10-FF-000200', NULL, 'Proprotein convertase subtilisin/kexin type 5a', 60, NULL, NULL, 179865),
(179866, '3.40.50.300-FF-007486', NULL, 'ATP-dependent DNA helicase', 231, NULL, NULL, 179866),
(179867, '3.40.50.10090-FF-000017', NULL, 'Uroporphyrinogen-III synthase', 146, NULL, NULL, 179867),
(179868, '1.10.287.110-FF-000438', NULL, 'Uncharacterized protein', 74, NULL, NULL, 179868),
(179869, '1.10.10.10-FF-000619', NULL, 'IclR family transcriptional regulator', 71, NULL, NULL, 179869),
(179870, '3.40.50.300-FF-001045', NULL, 'ATP-dependent RNA helicase DDX50 isoform X1', 170, NULL, NULL, 179870),
(179871, '2.10.25.10-FF-000573', NULL, 'Neurocan core protein', 66, NULL, NULL, 179871);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(179872, '1.20.1420.30-FF-000031', NULL, 'K+-dependent Na+/Ca+ exchanger related-protein', 156, NULL, NULL, 179872),
(179873, '1.25.10.10-FF-000581', NULL, 'HEAT repeat-containing protein 3 isoform X2', 252, NULL, NULL, 179873),
(179874, '3.30.930.10-FF-000414', NULL, 'Lysine--tRNA ligase', 353, NULL, NULL, 179874),
(179875, '3.40.630.10-FF-000232', NULL, 'Carboxypeptidase T, putative', 38, NULL, NULL, 179875),
(179876, '3.70.10.10-FF-000079', NULL, 'DNA polymerase sliding clamp 2', 247, NULL, NULL, 179876),
(179877, '1.25.40.10-FF-001038', NULL, 'Transmembrane and tetratricopeptide repeat containing 4', 87, NULL, NULL, 179877),
(179878, '3.40.1050.10-FF-000035', NULL, 'Carbonic anhydrase', 207, NULL, NULL, 179878),
(179879, '1.20.120.1750-FF-000025', NULL, 'RBR-type E3 ubiquitin transferase', 232, NULL, NULL, 179879),
(179880, '3.30.200.20-FF-000339', NULL, 'serine/threonine-protein kinase Nek10', 110, NULL, NULL, 179880),
(179881, '3.40.50.150-FF-000022', NULL, 'Ribosomal RNA small subunit methyltransferase B', 200, NULL, NULL, 179881),
(179882, '3.40.1340.10-FF-000006', NULL, 'RNA polymerase Rpb5 domain containing protein', 128, NULL, NULL, 179882),
(179883, '3.40.800.10-FF-000032', NULL, 'Arginase', 299, NULL, NULL, 179883),
(179884, '2.10.25.10-FF-001062', NULL, 'Stabilin 2', 40, NULL, NULL, 179884),
(179885, '2.40.50.140-FF-000129', NULL, 'Single-stranded DNA-binding protein 1, mitochondrial', 132, NULL, NULL, 179885),
(179886, '1.10.238.10-FF-000385', NULL, 'AGAP010191-PA-like protein', 69, NULL, NULL, 179886),
(179887, '1.25.40.10-FF-002544', NULL, 'TPR Domain containing protein', 221, NULL, NULL, 179887),
(179888, '3.30.40.10-FF-001780', NULL, 'General transcription factor IIH subunit', 68, NULL, NULL, 179888),
(179889, '2.60.40.60-FF-000289', NULL, 'cadherin-86C isoform X2', 100, NULL, NULL, 179889),
(179890, '1.10.287.1490-FF-000004', NULL, 'nucleoprotein TPR isoform X2', 191, NULL, NULL, 179890),
(179891, '1.10.150.20-FF-000212', NULL, 'AGAP002805-PA', 82, NULL, NULL, 179891),
(179892, '1.10.150.50-FF-000064', NULL, 'arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 1 isoform X1', 59, NULL, NULL, 179892),
(179893, '1.10.287.110-FF-000410', NULL, 'Chaperone protein DNAJ, putative', 103, NULL, NULL, 179893),
(179894, '3.30.1330.10-FF-000031', NULL, 'Phosphoribosylformylglycinamidine synthase', 93, NULL, NULL, 179894),
(179895, '1.10.3200.20-FF-000008', NULL, NULL, 176, NULL, NULL, 179895),
(179896, '1.25.40.10-FF-002191', NULL, 'Pentatricopeptide repeat-containing protein At3g18110, chloroplastic', 154, NULL, NULL, 179896),
(179897, '1.20.1420.10-FF-000036', NULL, NULL, 151, NULL, NULL, 179897),
(179898, '3.40.50.1240-FF-000207', NULL, NULL, 141, NULL, NULL, 179898),
(179899, '2.60.40.10-FF-005069', NULL, NULL, 101, NULL, NULL, 179899),
(179900, '3.40.50.300-FF-000657', NULL, 'Probable ATP-dependent RNA helicase DDX41', 246, NULL, NULL, 179900),
(179901, '3.40.50.920-FF-000051', NULL, '2-oxoacid:ferredoxin oxidoreductase, alpha subunit', 117, NULL, NULL, 179901),
(179902, '2.60.300.12-FF-000023', NULL, NULL, 107, NULL, NULL, 179902),
(179903, '1.20.58.390-FF-000066', NULL, 'Acetylcholine receptor subunit alpha-type unc-63', 112, NULL, NULL, 179903),
(179904, '1.10.510.10-FF-003952', NULL, NULL, 54, NULL, NULL, 179904),
(179905, '1.20.5.190-FF-000006', NULL, 'Myosin VA', 54, NULL, NULL, 179905),
(179906, '3.40.1670.10-FF-000008', NULL, 'UbiD family decarboxylase', 110, NULL, NULL, 179906),
(179907, '1.25.40.90-FF-000016', NULL, 'mRNA cleavage factor complex component Pcf11', 141, NULL, NULL, 179907),
(179908, '2.130.10.10-FF-002500', NULL, 'HEAT repeat domain containing protein', 113, NULL, NULL, 179908),
(179909, '3.50.7.10-FF-000023', NULL, 'T-complex protein 1 subunit beta, putative', 153, NULL, NULL, 179909),
(179910, '2.60.120.40-FF-000038', NULL, 'CD70 isoform 1', 102, NULL, NULL, 179910),
(179911, '3.40.50.150-FF-001348', NULL, NULL, 192, NULL, NULL, 179911),
(179912, '3.80.10.10-FF-001427', NULL, 'Hypothetical_protein_-_conserved', 169, NULL, NULL, 179912);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(179913, '1.20.1250.20-FF-001863', NULL, 'Uncharacterized protein', 120, NULL, NULL, 179913),
(179914, '2.60.120.650-FF-000217', NULL, 'Uncharacterized protein', 230, NULL, NULL, 179914),
(179915, '1.20.1440.90-FF-000016', NULL, NULL, 136, NULL, NULL, 179915),
(179916, '1.20.120.1750-FF-000008', NULL, 'RBR-type E3 ubiquitin transferase', 82, NULL, NULL, 179916),
(179917, '3.40.1280.10-FF-000052', NULL, 'Putative tRNA (cytidine(34)-2''-O)-methyltransferase', 157, NULL, NULL, 179917),
(179918, '2.60.120.10-FF-000142', NULL, 'Solute carrier family 9 member C2 (putative)', 144, NULL, NULL, 179918),
(179919, '3.30.160.60-FF-006238', NULL, NULL, 31, NULL, NULL, 179919),
(179920, '2.60.40.3980-FF-000002', NULL, 'Cell fusion protein aff-1', 100, NULL, NULL, 179920),
(179921, '2.30.30.1020-FF-000054', NULL, NULL, 147, NULL, NULL, 179921),
(179922, '3.40.50.1820-FF-001685', NULL, 'Carboxypeptidase', 221, NULL, NULL, 179922),
(179923, '2.130.10.10-FF-001348', NULL, 'DDB1-and CUL4-associated factor 12-like Protein', 192, NULL, NULL, 179923),
(179924, '3.80.10.10-FF-004496', NULL, 'Probable serine/threonine-protein kinase DDB_G0278509', 68, NULL, NULL, 179924),
(179925, '3.10.20.90-FF-000960', NULL, 'Uncharacterized protein', 48, NULL, NULL, 179925),
(179926, '2.20.100.10-FF-000245', NULL, 'Uncharacterized protein', 80, NULL, NULL, 179926),
(179927, '3.40.30.10-FF-000901', NULL, 'Uncharacterized protein', 140, NULL, NULL, 179927),
(179928, '1.25.40.20-FF-001575', NULL, 'Diversin', 172, NULL, NULL, 179928),
(179929, '1.10.10.440-FF-000042', NULL, 'Pre-mRNA-splicing factor URN1', 58, NULL, NULL, 179929),
(179930, '3.30.450.50-FF-000046', NULL, 'Synaptobrevin-domain-containing protein', 132, NULL, NULL, 179930),
(179931, '3.90.660.60-FF-000001', NULL, 'Tryptophan 2-monooxygenase oxidoreductase', 315, NULL, NULL, 179931),
(179932, '3.30.505.10-FF-000241', NULL, NULL, 73, NULL, NULL, 179932),
(179933, '3.10.50.40-FF-000014', NULL, 'Chaperone SurA', 117, NULL, NULL, 179933),
(179934, '1.25.40.20-FF-000147', NULL, 'Ankyrin repeat and SOCS box containing 7', 176, NULL, NULL, 179934),
(179935, '3.30.470.160-FF-000008', NULL, 'Kinase', 241, NULL, NULL, 179935),
(179936, '1.25.10.10-FF-001199', NULL, 'Armadillo/beta-catenin repeat-like', 112, NULL, NULL, 179936),
(179937, '1.20.58.930-FF-000008', NULL, 'Arginine decarboxylase', 78, NULL, NULL, 179937),
(179938, '2.30.30.60-FF-000003', NULL, 'Predicted mechanosensitive ion channel', 50, NULL, NULL, 179938),
(179939, '3.90.950.10-FF-000003', NULL, 'Inosine triphosphate pyrophosphatase', 188, NULL, NULL, 179939),
(179940, '3.40.50.150-FF-001303', NULL, NULL, 213, NULL, NULL, 179940),
(179941, '1.10.260.100-FF-000034', NULL, 'Uncharacterized protein', 49, NULL, NULL, 179941),
(179942, '3.40.50.10490-FF-000002', NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', 149, NULL, NULL, 179942),
(179943, '1.10.275.10-FF-000015', NULL, '3-carboxy-cis,cis-muconate cycloisomerase', 98, NULL, NULL, 179943),
(179944, '3.40.50.1820-FF-001112', NULL, 'Secreted tripeptidyl aminopeptidase', 152, NULL, NULL, 179944),
(179945, '1.10.510.10-FF-002328', NULL, NULL, 207, NULL, NULL, 179945),
(179946, '2.40.110.10-FF-000084', NULL, 'Uncharacterized protein', 66, NULL, NULL, 179946),
(179947, '3.80.10.10-FF-001270', NULL, 'F-box/LRR-repeat protein 4 isoform A', 72, NULL, NULL, 179947),
(179948, '1.10.1200.10-FF-000095', NULL, 'Acyl carrier protein', 83, NULL, NULL, 179948),
(179949, '3.30.470.30-FF-000053', NULL, 'Uncharacterized protein', 128, NULL, NULL, 179949),
(179950, '2.60.40.10-FF-003416', NULL, NULL, 94, NULL, NULL, 179950),
(179951, '1.10.287.70-FF-000544', NULL, 'TOK2 potassium channel', 120, NULL, NULL, 179951),
(179952, '3.90.70.40-FF-000012', NULL, 'Uncharacterized protein', 144, NULL, NULL, 179952),
(179953, '1.25.10.10-FF-000007', NULL, 'ARVCF, delta catenin family member', 461, NULL, NULL, 179953),
(179954, '3.40.190.10-FF-000669', NULL, 'Uncharacterized protein', 107, NULL, NULL, 179954),
(179955, '3.40.50.300-FF-007677', NULL, 'Putative ATP-dependent RNA helicase', 290, NULL, NULL, 179955);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(179956, '3.30.160.60-FF-002865', NULL, NULL, 28, NULL, NULL, 179956),
(179957, '3.30.200.20-FF-002464', NULL, 'Kinase, NEK', 53, NULL, NULL, 179957),
(179958, '3.40.50.720-FF-002508', NULL, 'Predicted protein', 131, NULL, NULL, 179958),
(179959, '3.40.50.1820-FF-001584', NULL, 'Uncharacterized protein', 93, NULL, NULL, 179959),
(179960, '1.10.405.10-FF-000032', NULL, 'Uncharacterized protein', 39, NULL, NULL, 179960),
(179961, '2.60.200.20-FF-000078', NULL, 'Unplaced genomic scaffold supercont1.19, whole genome shotgun sequence', 159, NULL, NULL, 179961),
(179962, '3.20.20.80-FF-000653', NULL, 'Uncharacterized protein', 78, NULL, NULL, 179962),
(179963, '3.90.550.50-FF-000018', NULL, 'Hexosyltransferase', 264, NULL, NULL, 179963),
(179964, '1.25.40.10-FF-000049', NULL, 'Alpha-soluble NSF attachment protein-like', 286, NULL, NULL, 179964),
(179965, '3.40.470.10-FF-000022', NULL, 'Uracil-DNA glycosylase', 246, NULL, NULL, 179965),
(179966, '3.10.250.10-FF-000063', NULL, 'RIKEN cDNA 5830411N06 gene', 109, NULL, NULL, 179966),
(179967, '2.30.30.380-FF-000014', NULL, 'sharpin isoform X1', 50, NULL, NULL, 179967),
(179968, '3.60.20.10-FF-000001', NULL, 'Glutamate synthase, large subunit', 432, NULL, NULL, 179968),
(179969, '1.25.10.10-FF-002155', NULL, 'Uncharacterized protein', 522, NULL, NULL, 179969),
(179970, '3.40.50.720-FF-002497', NULL, 'Sterigmatocystin biosynthesis fatty acid synthase subunit alpha', 413, NULL, NULL, 179970),
(179971, '1.10.1670.10-FF-000034', NULL, 'Adenine DNA glycosylase', 75, NULL, NULL, 179971),
(179972, '3.40.630.10-FF-000024', NULL, 'ATP/GTP binding protein 1', 283, NULL, NULL, 179972),
(179973, '2.40.10.170-FF-000018', NULL, 'ATP synthase subunit beta', 83, NULL, NULL, 179973),
(179974, '3.90.1150.10-FF-000076', NULL, 'Cysteine desulfurase', 126, NULL, NULL, 179974),
(179975, '1.20.1070.10-FF-001863', NULL, 'Uncharacterized protein', 295, NULL, NULL, 179975),
(179976, '1.10.720.30-FF-000006', NULL, 'Cell division cycle and apoptosis regulator protein 1', 70, NULL, NULL, 179976),
(179977, '1.10.10.10-FF-001210', NULL, 'ATP-dependent DNA helicase RecQ', 176, NULL, NULL, 179977),
(179978, '1.10.10.60-FF-000511', NULL, 'Bacterial regulatory s, tetR family protein', 51, NULL, NULL, 179978),
(179979, '3.30.1390.30-FF-000001', NULL, 'Peptidoglycan D,D-transpeptidase MrdA', 76, NULL, NULL, 179979),
(179980, '1.25.40.210-FF-000008', NULL, 'Telomeric repeat binding factor 2', 210, NULL, NULL, 179980),
(179981, '2.30.30.40-FF-000048', NULL, 'Chemotaxis protein CheA, putative', 63, NULL, NULL, 179981),
(179982, '2.130.10.10-FF-000522', NULL, 'WD repeat domain 90', 293, NULL, NULL, 179982),
(179983, '2.60.40.10-FF-000971', NULL, 'leucine-rich repeat, immunoglobulin-like domain and transmembrane domain-containing protein 3', 91, NULL, NULL, 179983),
(179984, '3.90.70.10-FF-000380', NULL, 'Protein CBG01315', 300, NULL, NULL, 179984),
(179985, '2.60.120.620-FF-000113', NULL, 'Predicted protein', 169, NULL, NULL, 179985),
(179986, '3.50.50.60-FF-000361', NULL, 'Flavin-containing monooxygenase', 283, NULL, NULL, 179986),
(179987, '1.25.40.660-FF-000014', NULL, 'Vacuolar protein sorting-associated protein 35', 217, NULL, NULL, 179987),
(179988, '3.30.70.260-FF-000089', NULL, 'Arogenate dehydratase/prephenate dehydratase 1', 96, NULL, NULL, 179988),
(179989, '2.60.120.1440-FF-000016', NULL, 'Putative anti-sigma factor', 138, NULL, NULL, 179989),
(179990, '1.25.40.1010-FF-000009', NULL, 'Uncharacterized protein', 216, NULL, NULL, 179990),
(179991, '3.40.50.300-FF-000909', NULL, 'Putative ATP-dependent RNA helicase DDX11', 206, NULL, NULL, 179991),
(179992, '1.10.510.10-FF-001491', NULL, 'Kinase, CAMK CAMKL', 334, NULL, NULL, 179992),
(179993, '3.80.10.10-FF-001219', NULL, 'Serine/threonine-protein kinase 11-interacting protein', 178, NULL, NULL, 179993),
(179994, '3.40.50.10330-FF-000106', NULL, 'NAD kinase', 96, NULL, NULL, 179994),
(179995, '3.40.640.10-FF-000261', NULL, 'Aromatic aminotransferase ISS1', 378, NULL, NULL, 179995),
(179996, '1.20.58.60-FF-000654', NULL, 'Uncharacterized protein', 136, NULL, NULL, 179996);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(179997, '3.30.565.10-FF-000481', NULL, 'Postmeiotic segregation increased 2-like protein 5', 78, NULL, NULL, 179997),
(179998, '1.10.3060.10-FF-000016', NULL, 'Protein translocase subunit SecA', 210, NULL, NULL, 179998),
(179999, '2.20.100.10-FF-000200', NULL, 'Semaphorin 5c, isoform A', 65, NULL, NULL, 179999),
(180000, '1.20.1070.10-FF-000935', NULL, 'Serpentine receptor class gamma', 295, NULL, NULL, 180000),
(180001, '3.30.160.60-FF-005518', NULL, NULL, 64, NULL, NULL, 180001),
(180002, '3.40.50.300-FF-007469', NULL, 'ATP-binding cassette transporter pdr1', 240, NULL, NULL, 180002),
(180003, '1.10.3720.10-FF-000163', NULL, 'Putative 2-aminoethylphosphonate ABC transporter permease subunit', 269, NULL, NULL, 180003),
(180004, '1.20.1250.20-FF-001655', NULL, 'Uncharacterized protein', 188, NULL, NULL, 180004),
(180005, '3.40.50.300-FF-001062', NULL, 'NLR family CARD domain containing 3', 189, NULL, NULL, 180005),
(180006, '3.60.110.10-FF-000087', NULL, NULL, 149, NULL, NULL, 180006),
(180007, '1.10.472.10-FF-000412', NULL, 'Uncharacterized protein', 99, NULL, NULL, 180007),
(180008, '2.130.10.10-FF-003692', NULL, 'Transducin beta chain, putative', 176, NULL, NULL, 180008),
(180009, '3.30.565.10-FF-000054', NULL, 'Heat shock protein 90', 229, NULL, NULL, 180009),
(180010, '1.25.40.10-FF-004652', NULL, 'Tetratricopeptide repeat domain 21A', 121, NULL, NULL, 180010),
(180011, '3.40.30.10-FF-000593', NULL, 'DSBA family oxidoreductase', 231, NULL, NULL, 180011),
(180012, '3.10.450.240-FF-000027', NULL, 'Predicted protein', 164, NULL, NULL, 180012),
(180013, '3.90.226.10-FF-000101', NULL, 'ATP-dependent Clp protease proteolytic subunit', 193, NULL, NULL, 180013),
(180014, '3.40.630.10-FF-000333', NULL, 'Carboxypeptidase M', 238, NULL, NULL, 180014),
(180015, '2.130.10.10-FF-002068', NULL, 'Polyadenylation factor subunit 2', 131, NULL, NULL, 180015),
(180016, '2.170.120.30-FF-000003', NULL, 'YbbR-like domain-containing protein ybbR', 106, NULL, NULL, 180016),
(180017, '2.102.10.10-FF-000001', NULL, 'Cytochrome b-c1 complex subunit Rieske, mitochondrial', 131, NULL, NULL, 180017),
(180018, '1.25.40.120-FF-000072', NULL, 'Protein prenyltransferase alpha subunit repeat-containing 1', 150, NULL, NULL, 180018),
(180019, '3.30.70.330-FF-002959', NULL, NULL, 153, NULL, NULL, 180019),
(180020, '3.60.10.10-FF-000192', NULL, 'DNA-(apurinic or apyrimidinic site) lyase', 316, NULL, NULL, 180020),
(180021, '1.20.5.110-FF-000353', NULL, 'Syntaxin-22', 43, NULL, NULL, 180021),
(180022, '1.10.1280.10-FF-000015', NULL, 'Uncharacterized protein', 330, NULL, NULL, 180022),
(180023, '3.30.505.10-FF-000033', NULL, 'RAS p21 protein activator 1', 110, NULL, NULL, 180023),
(180024, '2.120.10.30-FF-000247', NULL, 'Uncharacterized protein', 285, NULL, NULL, 180024),
(180025, '3.90.320.10-FF-000017', NULL, 'Probable ATP-dependent DNA helicase', 133, NULL, NULL, 180025),
(180026, '3.40.30.10-FF-000137', NULL, 'DnaJ homolog subfamily C member 10', 111, NULL, NULL, 180026),
(180027, '3.30.160.60-FF-002281', NULL, NULL, 29, NULL, NULL, 180027),
(180028, '1.10.1070.11-FF-000074', NULL, 'DJ576K7.1 (FK506 binding protein 12-rapamycin associated protein 1)', 61, NULL, NULL, 180028),
(180029, '2.60.40.10-FF-004130', NULL, NULL, 116, NULL, NULL, 180029),
(180030, '3.40.50.150-FF-000623', NULL, 'Glutathione S-transferase C-terminal domain-containing protein homolog', 171, NULL, NULL, 180030),
(180031, '3.40.50.300-FF-007941', NULL, 'Uncharacterized protein', 171, NULL, NULL, 180031),
(180032, '3.20.20.210-FF-000016', NULL, 'Uroporphyrinogen decarboxylase', 332, NULL, NULL, 180032),
(180033, '2.40.30.10-FF-000044', NULL, 'Ferredoxin--NADP(+) reductase', 96, NULL, NULL, 180033),
(180034, '3.40.50.1820-FF-001376', NULL, 'Uncharacterized protein', 222, NULL, NULL, 180034),
(180035, '1.20.1310.10-FF-000163', NULL, NULL, 112, NULL, NULL, 180035),
(180036, '1.20.1250.20-FF-001155', NULL, 'Uncharacterized protein', 194, NULL, NULL, 180036),
(180037, '3.30.450.150-FF-000007', NULL, 'Cob(I)yrinic acid a,c-diamide adenosyltransferase', 142, NULL, NULL, 180037);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(180038, '3.90.1600.10-FF-000066', NULL, 'DNA polymerase', 73, NULL, NULL, 180038),
(180039, '2.130.10.10-FF-004529', NULL, 'WD40-repeat protein', 228, NULL, NULL, 180039),
(180040, '3.20.20.300-FF-000043', NULL, 'Glycoside hydrolase family 3 protein', 279, NULL, NULL, 180040),
(180041, '3.40.50.720-FF-001536', NULL, 'Chromosome 10, whole genome shotgun sequence', 264, NULL, NULL, 180041),
(180042, '2.60.40.10-FF-004344', NULL, NULL, 115, NULL, NULL, 180042),
(180043, '3.30.70.100-FF-000103', NULL, 'Stress-response A/B barrel domain-containing protein UP3', 102, NULL, NULL, 180043),
(180044, '4.10.280.10-FF-000128', NULL, 'Basic helix-loop-helix protein', 77, NULL, NULL, 180044),
(180045, '1.10.287.630-FF-000004', NULL, 'Cyclic nucleotide-gated olfactory channel', 69, NULL, NULL, 180045),
(180046, '3.40.50.1010-FF-000048', NULL, 'Ribonuclease VapC', 139, NULL, NULL, 180046),
(180047, '3.30.1370.10-FF-000140', NULL, 'RNA-binding KH domain-containing protein', 80, NULL, NULL, 180047),
(180048, '1.20.1270.10-FF-000119', NULL, 'Predicted protein', 66, NULL, NULL, 180048),
(180049, '2.60.120.230-FF-000018', NULL, NULL, 109, NULL, NULL, 180049),
(180050, '2.60.40.1120-FF-000021', NULL, 'Carboxypeptidase Z', 89, NULL, NULL, 180050),
(180051, '3.10.10.10-FF-000042', NULL, NULL, 59, NULL, NULL, 180051),
(180052, '2.60.40.10-FF-005878', NULL, NULL, 73, NULL, NULL, 180052),
(180053, '1.20.58.2220-FF-000023', NULL, 'DAAM (Disheveled-Associated Activator of Morphogenesis) homolog', 402, NULL, NULL, 180053),
(180054, '2.70.150.10-FF-000006', NULL, 'Calcium-transporting ATPase', 142, NULL, NULL, 180054),
(180055, '2.60.490.10-FF-000017', NULL, 'Uncharacterized protein', 120, NULL, NULL, 180055),
(180056, '3.90.290.10-FF-000019', NULL, 'latent-transforming growth factor beta-binding protein 2 isoform X3', 70, NULL, NULL, 180056),
(180057, '1.10.220.10-FF-000075', NULL, 'Uncharacterized protein', 109, NULL, NULL, 180057),
(180058, '2.60.120.200-FF-000223', NULL, 'Wing blister, isoform B', 198, NULL, NULL, 180058),
(180059, '1.10.1410.10-FF-000077', NULL, 'Nucleotidyltransferase domain containing protein', 153, NULL, NULL, 180059),
(180060, '3.40.50.10300-FF-000002', NULL, 'Phosphopantothenate--cysteine ligase 2', 293, NULL, NULL, 180060),
(180061, '3.30.160.60-FF-003484', NULL, NULL, 24, NULL, NULL, 180061),
(180062, '2.40.50.120-FF-000045', NULL, 'WAP, follistatin/kazal, immunoglobulin, kunitz and netrin domain-containing 1', 125, NULL, NULL, 180062),
(180063, '3.50.50.60-FF-001069', NULL, 'Uncharacterized protein', 55, NULL, NULL, 180063),
(180064, '4.10.70.10-FF-000004', NULL, 'Uncharacterized protein, isoform C', 103, NULL, NULL, 180064),
(180065, '2.60.40.10-FF-000499', NULL, 'CD276 antigen', 100, NULL, NULL, 180065),
(180066, '2.30.30.40-FF-000256', NULL, 'Actin cytoskeleton-regulatory complex protein SLA1', 59, NULL, NULL, 180066),
(180067, '3.30.2350.10-FF-000032', NULL, 'Pseudouridine synthase', 248, NULL, NULL, 180067),
(180068, '3.30.530.20-FF-000134', NULL, 'Uncharacterized protein', 51, NULL, NULL, 180068),
(180069, '3.40.30.10-FF-000238', NULL, 'Soluble secreted antigen Mpt53', 144, NULL, NULL, 180069),
(180070, '3.30.420.40-FF-000244', NULL, 'pantothenate kinase 1-like isoform X3', 105, NULL, NULL, 180070),
(180071, '3.30.70.330-FF-000026', NULL, 'APOBEC1 complementation factor isoform X1', 111, NULL, NULL, 180071),
(180072, '3.10.20.90-FF-000651', NULL, 'Autophagy-related protein', 116, NULL, NULL, 180072),
(180073, '1.20.5.100-FF-000007', NULL, 'Receptor protein-tyrosine kinase', 39, NULL, NULL, 180073),
(180074, '3.40.50.12780-FF-000043', NULL, 'Acyl-CoA synthetase', 428, NULL, NULL, 180074),
(180075, '3.30.160.60-FF-002556', NULL, 'Krueppel-like factor 5', 24, NULL, NULL, 180075),
(180076, '3.30.230.10-FF-000046', NULL, 'galactokinase-like isoform X1', 199, NULL, NULL, 180076),
(180077, '1.10.238.10-FF-000930', NULL, 'Calcium-binding protein G', 86, NULL, NULL, 180077),
(180078, '1.10.20.10-FF-000339', NULL, NULL, 105, NULL, NULL, 180078),
(180079, '3.40.250.10-FF-000247', NULL, 'Uncharacterized protein', 87, NULL, NULL, 180079);
INSERT INTO "PUBLIC"."MODEL" VALUES
(180080, '3.30.70.330-FF-000498', NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', 80, NULL, NULL, 180080),
(180081, '3.40.630.30-FF-000682', NULL, 'N-acetyltransferase, putative', 92, NULL, NULL, 180081),
(180082, '3.40.50.1010-FF-000239', NULL, NULL, 42, NULL, NULL, 180082),
(180083, '1.10.510.10-FF-002980', NULL, NULL, 181, NULL, NULL, 180083),
(180084, '3.10.105.10-FF-000030', NULL, 'SgrR family transcriptional regulator', 202, NULL, NULL, 180084),
(180085, '1.20.1740.10-FF-000184', NULL, 'Uncharacterized protein', 134, NULL, NULL, 180085),
(180086, '1.10.10.60-FF-000039', NULL, 'MYB transcription factor', 48, NULL, NULL, 180086),
(180087, '1.25.40.250-FF-000009', NULL, 'Eukaryotic translation initiation factor 3 subunit K', 139, NULL, NULL, 180087),
(180088, '2.60.40.10-FF-000398', NULL, 'Tenascin C', 86, NULL, NULL, 180088),
(180089, '3.30.750.170-FF-000002', NULL, NULL, 98, NULL, NULL, 180089),
(180090, '1.10.238.10-FF-001239', NULL, 'Sarcoplasmic calcium-binding protein', 187, NULL, NULL, 180090),
(180091, '3.40.50.300-FF-002135', NULL, 'Multidrug resistance-associated protein 4 isoform A', 259, NULL, NULL, 180091),
(180092, '2.60.40.10-FF-001016', NULL, 'Uncharacterized protein, isoform J', 104, NULL, NULL, 180092),
(180093, '3.30.70.1180-FF-000017', NULL, 'V-type proton ATPase subunit C', 40, NULL, NULL, 180093),
(180094, '3.40.50.300-FF-001629', NULL, 'Probable ATP-dependent helicase PF08_0048', 217, NULL, NULL, 180094),
(180095, '1.10.530.10-FF-000076', NULL, 'Predicted protein', 116, NULL, NULL, 180095),
(180096, '1.10.1450.10-FF-000040', NULL, 'Peripherin 2b (retinal degeneration, slow)', 103, NULL, NULL, 180096),
(180097, '3.40.50.300-FF-003771', NULL, 'Uncharacterized protein', 111, NULL, NULL, 180097),
(180098, '3.40.50.10470-FF-000007', NULL, 'Translation initiation factor eIF-2B subunit alpha', 197, NULL, NULL, 180098),
(180099, '3.30.70.1230-FF-000156', NULL, 'Photoactivated adenylate cyclase subunit beta-like protein 1224-5/9F', 142, NULL, NULL, 180099),
(180100, '1.10.1200.10-FF-000140', NULL, 'Ferrichrome siderophore peptide synthetase', 78, NULL, NULL, 180100),
(180101, '2.60.40.10-FF-001679', NULL, 'filamin-A isoform X7', 77, NULL, NULL, 180101),
(180102, '1.10.510.10-FF-000063', NULL, 'Mitogen-activated protein kinase 14', 209, NULL, NULL, 180102),
(180103, '3.30.160.60-FF-003837', NULL, NULL, 28, NULL, NULL, 180103),
(180104, '1.10.472.10-FF-000620', NULL, 'Uncharacterized protein', 128, NULL, NULL, 180104),
(180105, '3.30.230.70-FF-000160', NULL, 'Uncharacterized protein', 57, NULL, NULL, 180105),
(180106, '3.30.460.20-FF-000004', NULL, 'Magnesium transport protein CorA', 141, NULL, NULL, 180106),
(180107, '1.10.10.60-FF-001129', NULL, NULL, 63, NULL, NULL, 180107),
(180108, '1.20.1270.60-FF-000084', NULL, 'BAI1-associated protein 2-like 2b', 206, NULL, NULL, 180108),
(180109, '2.40.70.10-FF-000165', NULL, 'Transposon Tf2-9 polyprotein-like Protein', 137, NULL, NULL, 180109),
(180110, '3.30.450.30-FF-000035', NULL, 'Profilin', 120, NULL, NULL, 180110),
(180111, '2.10.110.10-FF-000310', NULL, 'Uncharacterized protein', 71, NULL, NULL, 180111),
(180112, '2.40.50.140-FF-001220', NULL, NULL, 67, NULL, NULL, 180112),
(180113, '1.10.287.4070-FF-000003', NULL, 'U4/U6 small nuclear ribonucleoprotein PRP31', 139, NULL, NULL, 180113),
(180114, '2.10.25.10-FF-001118', NULL, 'Fibulin-1', 40, NULL, NULL, 180114),
(180115, '2.70.150.10-FF-000153', NULL, 'Cation-transporting ATPase', 165, NULL, NULL, 180115),
(180116, '3.10.120.10-FF-000054', NULL, 'Uncharacterized protein', 62, NULL, NULL, 180116),
(180117, '1.10.238.110-FF-000002', NULL, 'Diacylglycerol kinase', 98, NULL, NULL, 180117),
(180118, '3.30.160.60-FF-004810', NULL, NULL, 25, NULL, NULL, 180118),
(180119, '3.30.590.20-FF-000008', NULL, 'Putative glutamate--cysteine ligase 2', 365, NULL, NULL, 180119),
(180120, '3.30.870.10-FF-000021', NULL, 'Cardiolipin synthase', 150, NULL, NULL, 180120),
(180121, '1.25.40.10-FF-003747', NULL, 'Uncharacterized protein', 113, NULL, NULL, 180121),
(180122, '2.40.50.90-FF-000024', NULL, 'Chromosome 3 C3orf33 homolog', 114, NULL, NULL, 180122);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(180123, '1.25.40.20-FF-000411', NULL, 'Calmodulin-binding transcription activator 4 isoform A', 183, NULL, NULL, 180123),
(180124, '1.20.58.390-FF-000127', NULL, 'AcetylCholine Receptor', 160, NULL, NULL, 180124),
(180125, '3.40.630.30-FF-000535', NULL, 'Uncharacterized protein MJ1136', 59, NULL, NULL, 180125),
(180126, '1.10.640.10-FF-000067', NULL, 'Uncharacterized protein', 178, NULL, NULL, 180126),
(180127, '3.10.20.90-FF-000049', NULL, 'RB1-inducible coiled-coil protein 1 isoform X1', 80, NULL, NULL, 180127),
(180128, '3.40.50.1400-FF-000042', NULL, 'Predicted protein', 149, NULL, NULL, 180128),
(180129, '2.40.50.140-FF-000601', NULL, 'RNA-editing complex protein MP63', 100, NULL, NULL, 180129),
(180130, '3.30.760.10-FF-000030', NULL, 'Translation initiation factor 4e, putative', 182, NULL, NULL, 180130),
(180131, '1.20.120.530-FF-000017', NULL, 'FadR family transcriptional regulator', 133, NULL, NULL, 180131),
(180132, '3.20.20.80-FF-000198', NULL, 'Chitinase 4', 271, NULL, NULL, 180132),
(180133, '3.40.50.300-FF-005671', NULL, 'Transitional endoplasmic reticulum ATPase', 193, NULL, NULL, 180133),
(180134, '3.40.50.300-FF-002490', NULL, 'Nicotinamide riboside kinase', 218, NULL, NULL, 180134),
(180135, '3.40.50.300-FF-004951', NULL, 'Uncharacterized protein', 234, NULL, NULL, 180135),
(180136, '2.20.25.420-FF-000007', NULL, 'Zinc finger protein zpr1, putative', 56, NULL, NULL, 180136),
(180137, '2.160.10.10-FF-000116', NULL, '40S ribosomal protein S4-3', 68, NULL, NULL, 180137),
(180138, '3.30.420.10-FF-000095', NULL, 'Transcription elongation factor, mitochondrial', 231, NULL, NULL, 180138),
(180139, '3.40.50.880-FF-000033', NULL, 'Glutamine amidotransferase class-I', 230, NULL, NULL, 180139),
(180140, '2.60.40.10-FF-002652', NULL, 'semaphorin-4D isoform X4', 96, NULL, NULL, 180140),
(180141, '1.25.40.10-FF-001690', NULL, 'Os03g0624800 protein', 68, NULL, NULL, 180141),
(180142, '1.10.510.10-FF-000838', NULL, 'NIMA related kinase 3', 263, NULL, NULL, 180142),
(180143, '1.25.10.10-FF-001435', NULL, 'E3 ubiquitin-protein ligase listerin', 201, NULL, NULL, 180143),
(180144, '3.30.40.10-FF-000627', NULL, 'RING-type E3 ubiquitin transferase', 75, NULL, NULL, 180144),
(180145, '3.30.200.20-FF-000210', NULL, 'Mitogen-activated protein kinase', 98, NULL, NULL, 180145),
(180146, '1.10.8.270-FF-000173', NULL, 'Si:ch211-266k8.4', 56, NULL, NULL, 180146),
(180147, '3.40.1110.10-FF-000394', NULL, NULL, 106, NULL, NULL, 180147),
(180148, '2.70.150.10-FF-000254', NULL, 'Uncharacterized protein', 54, NULL, NULL, 180148),
(180149, '1.20.1070.10-FF-001436', NULL, 'Uncharacterized protein', 224, NULL, NULL, 180149),
(180150, '2.30.29.30-FF-001351', NULL, 'Uncharacterized protein', 136, NULL, NULL, 180150),
(180151, '2.30.130.10-FF-000020', NULL, 'Unplaced genomic scaffold supercont1.64, whole genome shotgun sequence', 75, NULL, NULL, 180151),
(180152, '3.30.70.2570-FF-000002', NULL, 'Translation factor GUF1 homolog, mitochondrial', 69, NULL, NULL, 180152),
(180153, '2.20.25.400-FF-000001', NULL, 'Protein transport protein SEC31', 45, NULL, NULL, 180153),
(180154, '2.40.10.10-FF-000291', NULL, NULL, 36, NULL, NULL, 180154),
(180155, '2.60.40.1760-FF-000005', NULL, 'Putative alpha-glucosidase AgdA', 249, NULL, NULL, 180155),
(180156, '2.60.40.10-FF-004552', NULL, NULL, 112, NULL, NULL, 180156),
(180157, '1.10.400.10-FF-000072', NULL, 'Guanine nucleotide binding protein, alpha subunit', 27, NULL, NULL, 180157),
(180158, '3.40.640.10-FF-000159', NULL, 'Uncharacterized protein R102.4', 278, NULL, NULL, 180158),
(180159, '3.20.20.80-FF-000759', NULL, 'Uncharacterized protein', 253, NULL, NULL, 180159),
(180160, '3.40.50.300-FF-000348', NULL, 'tRNA dimethylallyltransferase', 233, NULL, NULL, 180160),
(180161, '2.10.25.10-FF-000365', NULL, 'Sushi, nidogen and EGF like domains 1', 40, NULL, NULL, 180161),
(180162, '3.30.479.20-FF-000053', NULL, 'Elongation factor Ts', 92, NULL, NULL, 180162),
(180163, '3.40.50.300-FF-002034', NULL, 'Dynein heavy chain, putative', 191, NULL, NULL, 180163),
(180164, '1.20.1110.10-FF-000198', NULL, NULL, 123, NULL, NULL, 180164);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(180165, '2.60.40.420-FF-000100', NULL, 'Uncharacterized protein', 205, NULL, NULL, 180165),
(180166, '1.20.1070.10-FF-000008', NULL, 'Olfactory receptor', 286, NULL, NULL, 180166),
(180167, '2.70.130.10-FF-000140', NULL, NULL, 115, NULL, NULL, 180167),
(180168, '2.60.120.620-FF-000012', NULL, 'Phytanoyl-CoA dioxygenase, peroxisomal', 306, NULL, NULL, 180168),
(180169, '3.40.50.150-FF-000831', NULL, 'Putative methyltransferase, putative', 214, NULL, NULL, 180169),
(180170, '3.30.9.10-FF-000190', NULL, 'Uncharacterized protein', 190, NULL, NULL, 180170),
(180171, '2.60.450.20-FF-000001', NULL, 'Centromere protein J', 182, NULL, NULL, 180171),
(180172, '1.20.1740.10-FF-000083', NULL, 'Putative alanine,valine and leucine rich integral membrane protein', 457, NULL, NULL, 180172),
(180173, '3.10.20.90-FF-000504', NULL, 'Uncharacterized protein', 69, NULL, NULL, 180173),
(180174, '2.60.40.10-FF-001943', NULL, 'Uncharacterized protein, isoform C', 110, NULL, NULL, 180174),
(180175, '2.40.128.590-FF-000001', NULL, 'Chromophore lyase CRL, chloroplastic', 206, NULL, NULL, 180175),
(180176, '3.30.310.10-FF-000002', NULL, 'TATA-box-binding protein 2', 84, NULL, NULL, 180176),
(180177, '2.40.50.140-FF-000040', NULL, 'Ribonuclease E', 95, NULL, NULL, 180177),
(180178, '3.30.200.20-FF-001559', NULL, 'STE family protein kinase', 90, NULL, NULL, 180178),
(180179, '2.40.160.10-FF-000031', NULL, 'Mitochondrial distribution and morphology protein 10', 176, NULL, NULL, 180179),
(180180, '1.25.40.790-FF-000002', NULL, 'Transcription regulator', 301, NULL, NULL, 180180),
(180181, '2.130.10.10-FF-005957', NULL, 'Phosphoinositide-3-kinase, regulatory subunit 4', 246, NULL, NULL, 180181),
(180182, '3.20.20.10-FF-000093', NULL, 'Uncharacterized protein', 78, NULL, NULL, 180182),
(180183, '1.20.120.350-FF-000132', NULL, 'Potassium voltage-gated channel, subfamily G, member 4a', 94, NULL, NULL, 180183),
(180184, '2.10.110.10-FF-000208', NULL, 'Protein CBG11874', 65, NULL, NULL, 180184),
(180185, '1.10.10.60-FF-000612', NULL, 'PROBABLE TRANSCRIPTIONAL REGULATORY PROTEIN', 46, NULL, NULL, 180185),
(180186, '3.40.50.300-FF-004243', NULL, 'Replication factor C small subunit', 171, NULL, NULL, 180186),
(180187, '3.30.70.330-FF-001206', NULL, 'Polyadenylate-binding protein', 105, NULL, NULL, 180187),
(180188, '1.20.1310.20-FF-000053', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 201, NULL, NULL, 180188),
(180189, '2.40.100.10-FF-000010', NULL, 'Peptidyl-prolyl cis-trans isomerase E', 173, NULL, NULL, 180189),
(180190, '1.10.12.10-FF-000017', NULL, 'Putative enoyl-CoA hydratase', 62, NULL, NULL, 180190),
(180191, '1.10.287.1150-FF-000015', NULL, 'Putative 2-oxoglutarate dehydrogenase E1 component', 97, NULL, NULL, 180191),
(180192, '1.25.10.10-FF-002054', NULL, 'RING-type E3 ubiquitin transferase', 313, NULL, NULL, 180192),
(180193, '1.10.510.10-FF-000277', NULL, 'protein kinase PINOID', 69, NULL, NULL, 180193),
(180194, '1.10.1740.10-FF-000051', NULL, 'Alpha amylase (Amylosucrase), Chain A', 92, NULL, NULL, 180194),
(180195, '1.10.472.10-FF-000209', NULL, 'Cyclin C, putative', 122, NULL, NULL, 180195),
(180196, '2.60.40.1180-FF-000123', NULL, 'Beta-1,6-glucanase Neg1', 79, NULL, NULL, 180196),
(180197, '2.20.25.90-FF-000012', NULL, 'Anaerobic selenocysteine-containing dehydrogenase', 66, NULL, NULL, 180197),
(180198, '3.30.230.10-FF-000310', NULL, 'Uncharacterized protein', 217, NULL, NULL, 180198),
(180199, '3.30.70.330-FF-001094', NULL, 'Splicing factor MUD2', 110, NULL, NULL, 180199),
(180200, '3.40.50.1820-FF-000965', NULL, 'Protein ABHD15', 278, NULL, NULL, 180200),
(180201, '1.10.540.10-FF-000003', NULL, 'glutaryl-CoA dehydrogenase, mitochondrial', 136, NULL, NULL, 180201),
(180202, '3.40.50.300-FF-006497', NULL, 'Uncharacterized protein', 114, NULL, NULL, 180202),
(180203, '1.20.1440.100-FF-000018', NULL, 'Uncharacterized protein', 55, NULL, NULL, 180203),
(180204, '3.90.70.10-FF-000233', NULL, 'Ubiquitin carboxyl-terminal hydrolase 26', 166, NULL, NULL, 180204),
(180205, '3.30.420.10-FF-000656', NULL, NULL, 196, NULL, NULL, 180205);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(180206, '3.10.50.10-FF-000016', NULL, 'Chitinase, putative', 70, NULL, NULL, 180206),
(180207, '3.40.50.150-FF-001803', NULL, NULL, 127, NULL, NULL, 180207),
(180208, '3.30.930.10-FF-000223', NULL, 'Phenylalanyl-tRNA synthetase alpha chain', 280, NULL, NULL, 180208),
(180209, '3.90.260.10-FF-000063', NULL, 'Uncharacterized protein', 233, NULL, NULL, 180209),
(180210, '1.20.1250.20-FF-002274', NULL, 'Uncharacterized protein', 95, NULL, NULL, 180210),
(180211, '1.20.120.550-FF-000012', NULL, 'Hypothetical glutathione S-transferase like protein', 153, NULL, NULL, 180211),
(180212, '3.30.40.10-FF-001532', NULL, 'CDK-activating kinase assembly factor MAT1', 65, NULL, NULL, 180212),
(180213, '3.20.20.70-FF-000240', NULL, 'Lipoyl synthase, mitochondrial', 218, NULL, NULL, 180213),
(180214, '1.10.1200.150-FF-000001', NULL, 'Transcriptional regulator CtsR', 81, NULL, NULL, 180214),
(180215, '3.90.180.10-FF-000129', NULL, 'Alcohol dehydrogenase 5 (class III), chi polypeptide', 64, NULL, NULL, 180215),
(180216, '2.30.30.40-FF-000609', NULL, 'Rho GTPase-activating protein 4', 55, NULL, NULL, 180216),
(180217, '3.50.50.60-FF-001333', NULL, 'Uncharacterized protein', 70, NULL, NULL, 180217),
(180218, '2.130.10.10-FF-005182', NULL, 'Uncharacterized protein', 123, NULL, NULL, 180218),
(180219, '2.60.200.20-FF-000180', NULL, 'Uncharacterized protein', 95, NULL, NULL, 180219),
(180220, '3.30.160.60-FF-001376', NULL, 'Zinc finger and BTB domain-containing protein 1', 24, NULL, NULL, 180220),
(180221, '3.30.2310.20-FF-000004', NULL, 'Toxin RelE', 91, NULL, NULL, 180221),
(180222, '1.10.10.10-FF-001682', NULL, 'SirR/DtxR family transcription regulator Idr2', 118, NULL, NULL, 180222),
(180223, '2.30.29.30-FF-000637', NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', 140, NULL, NULL, 180223),
(180224, '1.10.8.10-FF-000181', NULL, 'GD24956', 41, NULL, NULL, 180224),
(180225, '2.30.30.190-FF-000047', NULL, NULL, 84, NULL, NULL, 180225),
(180226, '3.40.50.300-FF-004288', NULL, 'Ras-related protein Rab-1B', 127, NULL, NULL, 180226),
(180227, '1.10.287.70-FF-000336', NULL, 'I[[h]] channel, isoform H', 164, NULL, NULL, 180227),
(180228, '2.60.120.920-FF-000085', NULL, 'Ssh4p', 152, NULL, NULL, 180228),
(180229, '3.40.50.1380-FF-000007', NULL, 'Carbamoyl-phosphate synthase large chain', 143, NULL, NULL, 180229),
(180230, '3.40.970.10-FF-000015', NULL, NULL, 43, NULL, NULL, 180230),
(180231, '4.10.60.10-FF-000239', NULL, 'Uncharacterized protein', 46, NULL, NULL, 180231),
(180232, '2.130.10.10-FF-000623', NULL, 'Peptidylprolyl isomerase domain and WD repeat-containing protein 1', 165, NULL, NULL, 180232),
(180233, '1.10.287.600-FF-000006', NULL, 'Tubulin beta chain', 72, NULL, NULL, 180233),
(180234, '3.30.1110.10-FF-000003', NULL, 'Adenosine kinase', 66, NULL, NULL, 180234),
(180235, '3.40.50.2300-FF-001273', NULL, NULL, 183, NULL, NULL, 180235),
(180236, '1.10.1420.10-FF-000212', NULL, 'Uncharacterized protein', 147, NULL, NULL, 180236),
(180237, '2.60.40.10-FF-001724', NULL, 'Polycystin 1, transient receptor potential channel-interacting', 77, NULL, NULL, 180237),
(180238, '3.90.1150.10-FF-000312', NULL, 'Saframycin Mx1 synthetase B', 108, NULL, NULL, 180238),
(180239, '2.70.170.10-FF-000053', NULL, 'Predicted protein', 197, NULL, NULL, 180239),
(180240, '2.60.40.10-FF-003624', NULL, NULL, 99, NULL, NULL, 180240),
(180241, '3.40.50.450-FF-000022', NULL, 'Probable ATP-dependent 6-phosphofructokinase', 283, NULL, NULL, 180241),
(180242, '2.40.30.10-FF-000090', NULL, '50S ribosomal protein L3', 117, NULL, NULL, 180242),
(180243, '3.30.830.10-FF-000058', NULL, 'Mitochondrial-processing peptidase subunit alpha-like', 209, NULL, NULL, 180243),
(180244, '1.25.40.180-FF-000084', NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', 316, NULL, NULL, 180244),
(180245, '2.60.120.10-FF-000804', NULL, 'Uncharacterized protein', 122, NULL, NULL, 180245),
(180246, '1.20.1280.50-FF-000261', NULL, 'F-box protein 6', 55, NULL, NULL, 180246),
(180247, '3.40.190.10-FF-000405', NULL, 'ABC transporter, periplasmic substrate-binding protein', 115, NULL, NULL, 180247);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(180248, '2.60.120.260-FF-000325', NULL, 'Beta-glucosidase', 170, NULL, NULL, 180248),
(180249, '1.10.10.10-FF-001991', NULL, 'Uncharacterized protein', 43, NULL, NULL, 180249),
(180250, '1.20.1250.20-FF-002010', NULL, 'Uncharacterized protein', 372, NULL, NULL, 180250),
(180251, '3.40.50.300-FF-004390', NULL, 'Dephospho-CoA kinase', 201, NULL, NULL, 180251),
(180252, '3.30.160.60-FF-004546', NULL, NULL, 30, NULL, NULL, 180252),
(180253, '2.60.40.60-FF-000609', NULL, 'Predicted protein', 61, NULL, NULL, 180253),
(180254, '3.10.20.90-FF-000196', NULL, 'UBX domain-containing protein 4', 88, NULL, NULL, 180254),
(180255, '1.10.510.10-FF-002671', NULL, NULL, 81, NULL, NULL, 180255),
(180256, '3.20.20.80-FF-000462', NULL, 'Predicted protein', 424, NULL, NULL, 180256),
(180257, '1.20.58.390-FF-000274', NULL, 'Uncharacterized protein', 68, NULL, NULL, 180257),
(180258, '2.30.30.100-FF-000195', NULL, 'YALI0B14773p', 77, NULL, NULL, 180258),
(180259, '2.60.40.10-FF-003933', NULL, NULL, 106, NULL, NULL, 180259),
(180260, '1.10.1200.270-FF-000031', NULL, 'Uncharacterized protein', 94, NULL, NULL, 180260),
(180261, '1.20.1090.10-FF-000010', NULL, 'Maleylacetate reductase 1', 191, NULL, NULL, 180261),
(180262, '1.20.5.680-FF-000001', NULL, 'Glutaconyl-CoA decarboxylase subunit alpha', 58, NULL, NULL, 180262),
(180263, '3.40.50.20-FF-000097', NULL, 'Uncharacterized protein', 105, NULL, NULL, 180263),
(180264, '3.40.1010.10-FF-000021', NULL, NULL, 136, NULL, NULL, 180264),
(180265, '3.30.559.10-FF-000096', NULL, 'Nonribosomal peptide synthase GliP2', 197, NULL, NULL, 180265),
(180266, '1.10.287.70-FF-000645', NULL, 'Uncharacterized protein', 177, NULL, NULL, 180266),
(180267, '3.60.21.10-FF-000200', NULL, 'Mre11, putative', 283, NULL, NULL, 180267),
(180268, '3.30.9.10-FF-000302', NULL, 'Putative D-amino acid oxidase', 135, NULL, NULL, 180268),
(180269, '2.160.20.10-FF-000206', NULL, 'Bifunctional pectinolytic enzyme/cytochrome c', 414, NULL, NULL, 180269),
(180270, '2.40.20.10-FF-000015', NULL, 'Prothrombin', 95, NULL, NULL, 180270),
(180271, '1.25.10.10-FF-002363', NULL, 'Os02g0169800 protein', 280, NULL, NULL, 180271),
(180272, '2.130.10.10-FF-005743', NULL, 'ELM2 domaincontaining protein', 124, NULL, NULL, 180272),
(180273, '3.40.140.20-FF-000006', NULL, 'Bifunctional purine biosynthesis protein PurH', 154, NULL, NULL, 180273),
(180274, '1.10.472.10-FF-000518', NULL, 'Predicted protein', 97, NULL, NULL, 180274),
(180275, '3.30.420.10-FF-000701', NULL, NULL, 115, NULL, NULL, 180275),
(180276, '2.60.260.20-FF-000054', NULL, 'Curved DNA binding protein', 60, NULL, NULL, 180276),
(180277, '3.30.160.60-FF-001937', NULL, 'Zinc finger protein 613', 27, NULL, NULL, 180277),
(180278, '3.30.710.10-FF-000448', NULL, 'Uncharacterized protein', 150, NULL, NULL, 180278),
(180279, '3.30.160.60-FF-001112', NULL, 'Zinc finger protein 366', 33, NULL, NULL, 180279),
(180280, '2.130.10.10-FF-000606', NULL, 'PH-interacting protein isoform X1', 199, NULL, NULL, 180280),
(180281, '3.90.360.10-FF-000008', NULL, 'Histone acetyltransferase type B catalytic subunit', 131, NULL, NULL, 180281),
(180282, '3.90.640.10-FF-000272', NULL, 'Actin-like protein arp10', 121, NULL, NULL, 180282),
(180283, '3.40.1110.10-FF-000085', NULL, 'Phospholipid-transporting ATPase', 176, NULL, NULL, 180283),
(180284, '3.40.50.620-FF-000298', NULL, 'Phosphoadenosine phosphosulfate reductase', 249, NULL, NULL, 180284),
(180285, '1.10.238.10-FF-000019', NULL, 'Myosin light chain 1 skeletal', 66, NULL, NULL, 180285),
(180286, '1.10.600.10-FF-000076', NULL, 'Terpene synthase', 298, NULL, NULL, 180286),
(180287, '1.25.10.10-FF-002008', NULL, 'Armadillo repeat-containing protein 8', 213, NULL, NULL, 180287),
(180288, '3.40.50.300-FF-003063', NULL, 'ABC transporter ATP-binding protein YnjD', 215, NULL, NULL, 180288),
(180289, '2.130.10.10-FF-004338', NULL, 'Uncharacterized protein', 99, NULL, NULL, 180289),
(180290, '3.40.50.1000-FF-000130', NULL, 'Phospholipid-transporting ATPase', 195, NULL, NULL, 180290),
(180291, '1.25.40.20-FF-000294', NULL, 'Palmitoyltransferase', 223, NULL, NULL, 180291);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(180292, '1.10.510.10-FF-001575', NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 73', 168, NULL, NULL, 180292),
(180293, '3.40.50.150-FF-000600', NULL, 'Uncharacterized protein', 174, NULL, NULL, 180293),
(180294, '3.30.450.20-FF-000386', NULL, 'Transcriptional regulator, PpsR', 114, NULL, NULL, 180294),
(180295, '1.25.40.10-FF-003617', NULL, 'Pentatricopeptide repeat-containing protein At1g74600, chloroplastic', 112, NULL, NULL, 180295),
(180296, '3.40.50.970-FF-000189', NULL, 'Uncharacterized protein', 67, NULL, NULL, 180296),
(180297, '2.10.25.10-FF-001770', NULL, 'Integrin beta', 35, NULL, NULL, 180297),
(180298, '3.40.50.1440-FF-000166', NULL, 'Beta_tubulin,putative', 84, NULL, NULL, 180298),
(180299, '1.10.630.10-FF-000701', NULL, 'Uncharacterized protein', 125, NULL, NULL, 180299),
(180300, '2.40.30.130-FF-000027', NULL, 'Alanine--tRNA ligase, cytoplasmic', 75, NULL, NULL, 180300),
(180301, '1.10.418.10-FF-000242', NULL, 'Uncharacterized protein', 131, NULL, NULL, 180301),
(180302, '1.20.80.40-FF-000003', NULL, 'Splicing factor Prp8, putative', 99, NULL, NULL, 180302),
(180303, '2.30.30.280-FF-000001', NULL, 'tRNA-specific 2-thiouridylase MnmA', 64, NULL, NULL, 180303),
(180304, '1.20.1070.10-FF-000374', NULL, 'probable G-protein coupled receptor 62', 304, NULL, NULL, 180304),
(180305, '1.10.8.60-FF-000055', NULL, 'Katanin p60 ATPase-containing subunit A1', 87, NULL, NULL, 180305),
(180306, '2.60.40.10-FF-004321', NULL, NULL, 94, NULL, NULL, 180306),
(180307, '3.60.40.10-FF-000137', NULL, 'Calmodulin-binding protein phosphatase', 269, NULL, NULL, 180307),
(180308, '2.60.120.920-FF-000012', NULL, 'Ryanodine receptor 2 (Cardiac)', 160, NULL, NULL, 180308),
(180309, '1.10.287.70-FF-000089', NULL, 'Sodium channel protein', 139, NULL, NULL, 180309),
(180310, '3.20.20.140-FF-000416', NULL, 'Uncharacterized protein', 74, NULL, NULL, 180310),
(180311, '3.90.1750.10-FF-000088', NULL, 'Uncharacterized protein', 93, NULL, NULL, 180311),
(180312, '2.60.120.260-FF-000426', NULL, 'Glycosyl hydrolase family protein', 107, NULL, NULL, 180312),
(180313, '3.40.630.10-FF-000310', NULL, 'Carboxypeptidase A', 172, NULL, NULL, 180313),
(180314, '3.30.190.20-FF-000034', NULL, 'Ribosomal protein L1p/L10e family protein', 64, NULL, NULL, 180314),
(180315, '1.10.510.10-FF-004329', NULL, NULL, 136, NULL, NULL, 180315),
(180316, '1.20.1720.10-FF-000109', NULL, NULL, 132, NULL, NULL, 180316),
(180317, '2.60.40.150-FF-000103', NULL, 'Copine 2', 131, NULL, NULL, 180317),
(180318, '1.10.10.10-FF-001339', NULL, 'AGAP002394-PA', 83, NULL, NULL, 180318),
(180319, '1.20.1720.10-FF-000098', NULL, NULL, 219, NULL, NULL, 180319),
(180320, '3.40.50.1360-FF-000024', NULL, 'Lactose phosphotransferase system repressor', 161, NULL, NULL, 180320),
(180321, '1.20.1250.20-FF-000110', NULL, 'Regulatory protein uhpC', 203, NULL, NULL, 180321),
(180322, '2.30.29.30-FF-000429', NULL, 'CLNS1A isoform 7', 144, NULL, NULL, 180322),
(180323, '1.20.58.60-FF-000738', NULL, 'Uncharacterized protein', 95, NULL, NULL, 180323),
(180324, '2.150.10.10-FF-000004', NULL, 'RTX-I toxin determinant A', 44, NULL, NULL, 180324),
(180325, '2.70.170.10-FF-000137', NULL, 'Uncharacterized protein', 122, NULL, NULL, 180325),
(180326, '2.120.10.80-FF-000329', NULL, 'Uncharacterized protein', 140, NULL, NULL, 180326),
(180327, '3.30.40.10-FF-000936', NULL, 'E3 ubiquitin-protein ligase MIEL1', 89, NULL, NULL, 180327),
(180328, '2.60.120.380-FF-000007', NULL, 'Calpain 7', 134, NULL, NULL, 180328),
(180329, '3.40.50.300-FF-000792', NULL, 'ABC transporter F family member 4', 263, NULL, NULL, 180329),
(180330, '3.80.10.10-FF-000674', NULL, 'F-box protein SKIP1', 198, NULL, NULL, 180330),
(180331, '3.40.930.10-FF-000041', NULL, NULL, 186, NULL, NULL, 180331),
(180332, '3.30.40.10-FF-000251', NULL, 'Nitric oxide synthase-interacting protein', 59, NULL, NULL, 180332),
(180333, '3.30.70.1430-FF-000019', NULL, NULL, 94, NULL, NULL, 180333),
(180334, '1.10.760.10-FF-000093', NULL, 'Uncharacterized protein', 93, NULL, NULL, 180334),
(180335, '1.25.10.10-FF-002610', NULL, 'Uncharacterized protein', 138, NULL, NULL, 180335);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(180336, '1.20.1280.120-FF-000004', NULL, 'Catalase-related peroxidase', 82, NULL, NULL, 180336),
(180337, '1.10.630.10-FF-000690', NULL, 'Uncharacterized protein', 147, NULL, NULL, 180337),
(180338, '2.60.40.10-FF-004214', NULL, NULL, 74, NULL, NULL, 180338),
(180339, '3.40.50.300-FF-000320', NULL, 'Dynein, axonemal, heavy chain 5', 124, NULL, NULL, 180339),
(180340, '3.40.50.620-FF-000303', NULL, 'tRNA (5-methylaminomethyl-2-thiouridylate)-methyltransferase, putative', 249, NULL, NULL, 180340),
(180341, '3.80.10.10-FF-002124', NULL, 'Leucine-rich repeat-containing protein', 374, NULL, NULL, 180341),
(180342, '3.40.50.720-FF-001980', NULL, 'Uncharacterized protein', 249, NULL, NULL, 180342),
(180343, '2.130.10.10-FF-001691', NULL, 'Transcriptional regulator, AraC/XylS family', 180, NULL, NULL, 180343),
(180344, '3.30.420.40-FF-000463', NULL, 'Heat shock protein 70, putative', 91, NULL, NULL, 180344),
(180345, '1.10.630.10-FF-000696', NULL, 'Uncharacterized protein', 141, NULL, NULL, 180345),
(180346, '3.40.50.300-FF-006733', NULL, 'Uncharacterized protein', 70, NULL, NULL, 180346),
(180347, '3.30.160.60-FF-001483', NULL, 'Zinc finger protein 1005', 28, NULL, NULL, 180347),
(180348, '1.10.10.60-FF-000056', NULL, 'POU domain protein', 53, NULL, NULL, 180348),
(180349, '3.30.160.60-FF-000387', NULL, 'Zinc finger protein 354A', 30, NULL, NULL, 180349),
(180350, '1.10.238.10-FF-000621', NULL, 'WGS project CABT00000000 data, contig 2.4', 227, NULL, NULL, 180350),
(180351, '2.30.29.30-FF-001042', NULL, 'Uncharacterized protein', 103, NULL, NULL, 180351),
(180352, '3.60.21.10-FF-000301', NULL, 'Uncharacterized protein', 332, NULL, NULL, 180352),
(180353, '3.40.50.1820-FF-000988', NULL, 'Esterase inpF', 249, NULL, NULL, 180353),
(180354, '3.30.160.60-FF-001011', NULL, 'Zinc finger protein 793', 28, NULL, NULL, 180354),
(180355, '1.10.510.10-FF-001682', NULL, 'SH2-protein kinase domain containing protein', 195, NULL, NULL, 180355),
(180356, '2.40.10.10-FF-000397', NULL, NULL, 119, NULL, NULL, 180356),
(180357, '4.10.260.10-FF-000009', NULL, 'Regulator of G-protein signaling 11', 51, NULL, NULL, 180357),
(180358, '3.90.79.10-FF-000034', NULL, 'Nucleotide triphosphate diphosphatase NUDT15', 162, NULL, NULL, 180358),
(180359, '1.10.10.10-FF-000827', NULL, 'RNA polymerase III subunit RPC82 family protein', 95, NULL, NULL, 180359),
(180360, '3.30.1960.10-FF-000016', NULL, 'Uncharacterized protein', 134, NULL, NULL, 180360),
(180361, '3.80.10.10-FF-003905', NULL, 'Uncharacterized protein', 130, NULL, NULL, 180361),
(180362, '2.130.10.10-FF-000067', NULL, 'Putative E3 ubiquitin-protein ligase TRAF7', 169, NULL, NULL, 180362),
(180363, '2.60.40.150-FF-000098', NULL, 'Phosphoinositide phospholipase C', 131, NULL, NULL, 180363),
(180364, '3.40.50.300-FF-005777', NULL, 'Putative DEAD-box ATP-dependent RNA helicase family protein', 102, NULL, NULL, 180364),
(180365, '2.40.30.110-FF-000021', NULL, NULL, 81, NULL, NULL, 180365),
(180366, '1.20.120.1080-FF-000133', NULL, 'Predicted protein', 184, NULL, NULL, 180366),
(180367, '3.30.540.10-FF-000042', NULL, 'Inositol-monophosphatase ImpA', 142, NULL, NULL, 180367),
(180368, '2.60.40.1460-FF-000005', NULL, 'Integrin subunit alpha 2', 137, NULL, NULL, 180368),
(180369, '1.20.1260.10-FF-000074', NULL, 'Ferritin', 177, NULL, NULL, 180369),
(180370, '3.60.130.10-FF-000077', NULL, 'uncharacterized protein LOC100177042 isoform X1', 284, NULL, NULL, 180370),
(180371, '3.30.420.40-FF-000800', NULL, 'Heat shock protein, putative', 56, NULL, NULL, 180371),
(180372, '3.40.50.300-FF-004844', NULL, 'Replication factor C subunit 1', 177, NULL, NULL, 180372),
(180373, '1.20.1250.20-FF-000582', NULL, 'POSSIBLE NITRATE/NITRITE TRANSPORTER NARK2', 187, NULL, NULL, 180373),
(180374, '3.40.1380.20-FF-000017', NULL, 'Pyruvate kinase', 135, NULL, NULL, 180374),
(180375, '3.20.20.190-FF-000173', NULL, NULL, 72, NULL, NULL, 180375),
(180376, '1.25.40.20-FF-000187', NULL, 'B-cell lymphoma 3 protein', 241, NULL, NULL, 180376),
(180377, '3.30.200.20-FF-001666', NULL, 'Serine/threonine-protein kinase, putative', 83, NULL, NULL, 180377);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(180378, '2.40.50.140-FF-000337', NULL, 'RNA guanylyltransferase', 139, NULL, NULL, 180378),
(180379, '1.10.357.150-FF-000017', NULL, 'Uncharacterized protein', 129, NULL, NULL, 180379),
(180380, '3.30.70.2840-FF-000004', NULL, 'Genome polyprotein', 42, NULL, NULL, 180380),
(180381, '2.130.10.10-FF-004445', NULL, 'Uncharacterized protein', 350, NULL, NULL, 180381),
(180382, '2.60.40.10-FF-000426', NULL, 'Down syndrome cell adhesion molecule, isoform J', 102, NULL, NULL, 180382),
(180383, '3.80.10.10-FF-003428', NULL, 'Os08g0203100 protein', 68, NULL, NULL, 180383),
(180384, '3.30.70.3490-FF-000036', NULL, NULL, 147, NULL, NULL, 180384),
(180385, '3.30.830.10-FF-000159', NULL, 'Uncharacterized protein CaJ7.0411', 181, NULL, NULL, 180385),
(180386, '1.20.58.400-FF-000007', NULL, 'Vesicle transport through interaction with t-SNAREs 1A', 90, NULL, NULL, 180386),
(180387, '2.40.10.10-FF-000408', NULL, NULL, 241, NULL, NULL, 180387),
(180388, '3.40.50.300-FF-007722', NULL, 'Uncharacterized protein', 93, NULL, NULL, 180388),
(180389, '3.40.50.980-FF-000046', NULL, 'AMP dependent CoA ligase, putative', 58, NULL, NULL, 180389),
(180390, '2.60.34.10-FF-000013', NULL, 'Heat shock 70 kDa protein 14', 126, NULL, NULL, 180390),
(180391, '3.50.50.60-FF-000125', NULL, 'Anaerobic glycerol-3-phosphate dehydrogenase subunit B', 122, NULL, NULL, 180391),
(180392, '2.170.16.10-FF-000005', NULL, 'Replicative DNA helicase', 142, NULL, NULL, 180392),
(180393, '2.60.40.10-FF-002343', NULL, 'HEMCAM', 92, NULL, NULL, 180393),
(180394, '3.40.1370.10-FF-000042', NULL, 'Uncharacterized protein', 160, NULL, NULL, 180394),
(180395, '1.25.40.20-FF-001120', NULL, 'Putative leucine-rich repeat serine/threonine-protein kinase 1', 204, NULL, NULL, 180395),
(180396, '1.25.40.10-FF-000493', NULL, 'Tetratricopeptide repeat domain 21B', 134, NULL, NULL, 180396),
(180397, '2.40.50.730-FF-000003', NULL, 'DNA polymerase', 68, NULL, NULL, 180397),
(180398, '2.30.30.40-FF-000503', NULL, 'Uncharacterized protein', 90, NULL, NULL, 180398),
(180399, '3.40.50.300-FF-000573', NULL, 'RHO family GTPase Rho2', 185, NULL, NULL, 180399),
(180400, '3.30.450.70-FF-000024', NULL, 'Sybindin-like family, putative', 140, NULL, NULL, 180400),
(180401, '2.60.220.50-FF-000184', NULL, 'Uncharacterized protein', 50, NULL, NULL, 180401),
(180402, '2.160.20.10-FF-000061', NULL, 'F-box protein 10', 177, NULL, NULL, 180402),
(180403, '2.70.160.11-FF-000076', NULL, 'Uncharacterized protein', 170, NULL, NULL, 180403),
(180404, '3.80.10.10-FF-004041', NULL, 'Predicted protein', 314, NULL, NULL, 180404),
(180405, '4.10.60.10-FF-000138', NULL, 'Putative germ-line specific RNA helicase vasa protein', 27, NULL, NULL, 180405),
(180406, '1.10.8.10-FF-000287', NULL, 'Elongation factor Ts, mitochondrial 2', 54, NULL, NULL, 180406),
(180407, '3.30.160.60-FF-003618', NULL, NULL, 21, NULL, NULL, 180407),
(180408, '3.10.129.10-FF-000135', NULL, 'Acyl-CoA thioester hydrolase', 131, NULL, NULL, 180408),
(180409, '2.60.40.10-FF-002871', NULL, 'MPL proto-oncogene, thrombopoietin receptor', 93, NULL, NULL, 180409),
(180410, '1.25.40.20-FF-000720', NULL, 'Kinase, NEK', 90, NULL, NULL, 180410),
(180411, '3.30.40.10-FF-001116', NULL, 'Ring finger protein 213', 60, NULL, NULL, 180411),
(180412, '3.30.60.30-FF-000157', NULL, 'Follistatin', 35, NULL, NULL, 180412),
(180413, '1.25.10.10-FF-000210', NULL, 'serine/threonine-protein kinase Nek10', 158, NULL, NULL, 180413),
(180414, '1.10.30.10-FF-000048', NULL, 'Putative SWI/SNF-related matrix-associated actin-dependent regulator chromatin subfamily E member', 103, NULL, NULL, 180414),
(180415, '2.130.10.10-FF-002540', NULL, 'Uncharacterized protein', 104, NULL, NULL, 180415),
(180416, '3.90.70.10-FF-000014', NULL, 'Ubiquitin carboxyl-terminal hydrolase 34', 348, NULL, NULL, 180416),
(180417, '2.130.10.10-FF-000286', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 216, NULL, NULL, 180417),
(180418, '3.30.30.30-FF-000065', NULL, 'Putative Hsp70 family ATPase KAR2', 44, NULL, NULL, 180418),
(180419, '3.30.160.60-FF-006154', NULL, NULL, 79, NULL, NULL, 180419);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(180420, '3.30.930.10-FF-000330', NULL, 'Uncharacterized protein', 141, NULL, NULL, 180420),
(180421, '2.60.40.60-FF-000183', NULL, 'Cadherin 17', 108, NULL, NULL, 180421),
(180422, '3.30.310.50-FF-000019', NULL, 'Phosphomannomutase PmmA', 83, NULL, NULL, 180422),
(180423, '2.60.40.1180-FF-000224', NULL, 'Uncharacterized protein', 16, NULL, NULL, 180423),
(180424, '1.20.120.1770-FF-000019', NULL, 'Uncharacterized protein', 154, NULL, NULL, 180424),
(180425, '1.10.1670.10-FF-000051', NULL, NULL, 92, NULL, NULL, 180425),
(180426, '1.20.1560.10-FF-000546', NULL, 'Uncharacterized protein', 329, NULL, NULL, 180426),
(180427, '3.30.160.60-FF-005754', NULL, NULL, 22, NULL, NULL, 180427),
(180428, '3.30.160.60-FF-001792', NULL, 'Zinc finger and BTB domain-containing 40', 30, NULL, NULL, 180428),
(180429, '3.80.10.10-FF-000365', NULL, 'Toll-like receptor 5', 140, NULL, NULL, 180429),
(180430, '3.40.50.300-FF-008211', NULL, 'Uncharacterized protein', 69, NULL, NULL, 180430),
(180431, '3.10.590.10-FF-000004', NULL, 'probable ATP-dependent RNA helicase YTHDC2', 178, NULL, NULL, 180431),
(180432, '1.10.10.440-FF-000065', NULL, 'Pre-mRNA processing protein, putative', 55, NULL, NULL, 180432),
(180433, '3.30.40.10-FF-001555', NULL, 'No poles, isoform B', 44, NULL, NULL, 180433),
(180434, '2.10.25.10-FF-000348', NULL, 'Crumbs 1, cell polarity complex component', 43, NULL, NULL, 180434),
(180435, '2.130.10.10-FF-002045', NULL, 'IP10750p', 199, NULL, NULL, 180435),
(180436, '2.30.140.10-FF-000037', NULL, 'Os02g0254700 protein', 69, NULL, NULL, 180436),
(180437, '3.30.1360.140-FF-000010', NULL, 'DNA-directed RNA polymerase subunit', 130, NULL, NULL, 180437),
(180438, '1.25.40.10-FF-003724', NULL, 'Uncharacterized protein', 182, NULL, NULL, 180438),
(180439, '1.10.3130.10-FF-000016', NULL, 'Serine acetyltransferase', 135, NULL, NULL, 180439),
(180440, '2.30.30.30-FF-000135', NULL, 'Transcription elongation factor SPT5', 58, NULL, NULL, 180440),
(180441, '3.40.50.150-FF-001539', NULL, NULL, 95, NULL, NULL, 180441),
(180442, '3.40.50.300-FF-008341', NULL, 'Uncharacterized protein', 232, NULL, NULL, 180442),
(180443, '3.80.10.10-FF-002596', NULL, 'Serine/threonine-protein kinase BRI1-like 2', 76, NULL, NULL, 180443),
(180444, '1.25.10.10-FF-000137', NULL, 'Protein MOR1', 245, NULL, NULL, 180444),
(180445, '3.20.20.140-FF-000079', NULL, 'Amidohydrolase', 75, NULL, NULL, 180445),
(180446, '1.50.10.10-FF-000062', NULL, 'alpha-1,2-Mannosidase', 508, NULL, NULL, 180446),
(180447, '1.20.930.60-FF-000006', NULL, 'Protein CBG04453', 127, NULL, NULL, 180447),
(180448, '1.20.58.390-FF-000043', NULL, 'AcetylCholine Receptor', 115, NULL, NULL, 180448),
(180449, '3.30.230.80-FF-000033', NULL, 'Uncharacterized protein', 132, NULL, NULL, 180449),
(180450, '1.20.58.2240-FF-000001', NULL, 'Ribulokinase', 159, NULL, NULL, 180450),
(180451, '3.90.640.10-FF-000165', NULL, 'Uncharacterized protein', 47, NULL, NULL, 180451),
(180452, '3.40.30.10-FF-000784', NULL, 'Sulfhydryl oxidase', 109, NULL, NULL, 180452),
(180453, '1.10.287.70-FF-000780', NULL, 'Uncharacterized protein', 94, NULL, NULL, 180453),
(180454, '1.10.510.10-FF-002194', NULL, 'Predicted protein', 246, NULL, NULL, 180454),
(180455, '1.10.730.10-FF-000158', NULL, 'Putative arginine--tRNA ligase, mitochondrial', 123, NULL, NULL, 180455),
(180456, '2.30.30.40-FF-000508', NULL, 'Uncharacterized protein', 53, NULL, NULL, 180456),
(180457, '1.20.58.60-FF-000845', NULL, 'Uncharacterized protein', 143, NULL, NULL, 180457),
(180458, '1.25.40.10-FF-001802', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 160, NULL, NULL, 180458),
(180459, '2.60.40.3120-FF-000003', NULL, 'cytosolic carboxypeptidase 6 isoform X2', 135, NULL, NULL, 180459),
(180460, '1.10.510.10-FF-003975', NULL, NULL, 332, NULL, NULL, 180460),
(180461, '3.30.1330.90-FF-000009', NULL, 'D-3-phosphoglycerate dehydrogenase', 139, NULL, NULL, 180461),
(180462, '3.30.565.10-FF-000245', NULL, 'Two-component sensor histidine kinase', 148, NULL, NULL, 180462),
(180463, '3.40.50.1440-FF-000059', NULL, 'Tubulin beta chain', 149, NULL, NULL, 180463);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(180464, '3.15.20.10-FF-000009', NULL, 'Nose resistant to fluoxetine protein 5', 275, NULL, NULL, 180464),
(180465, '3.40.50.300-FF-006396', NULL, 'Uncharacterized protein', 134, NULL, NULL, 180465),
(180466, '2.60.120.10-FF-000378', NULL, 'uncharacterized protein LOC100180193 isoform X2', 137, NULL, NULL, 180466),
(180467, '3.30.70.1820-FF-000013', NULL, NULL, 75, NULL, NULL, 180467),
(180468, '3.40.1190.20-FF-000166', NULL, 'Ribokinase', 256, NULL, NULL, 180468),
(180469, '1.10.150.240-FF-000017', NULL, 'HAD family hydrolase', 67, NULL, NULL, 180469),
(180470, '3.30.70.270-FF-000339', NULL, NULL, 67, NULL, NULL, 180470),
(180471, '3.40.630.30-FF-000007', NULL, 'Spermidine N(1)-acetyltransferase', 179, NULL, NULL, 180471),
(180472, '2.60.40.60-FF-000492', NULL, 'Cadherin 17, LI cadherin (Liver-intestine)', 119, NULL, NULL, 180472),
(180473, '1.10.3370.10-FF-000017', NULL, 'Os09g0512600 protein', 213, NULL, NULL, 180473),
(180474, '1.10.10.60-FF-000584', NULL, 'Unplaced genomic scaffold supercont1.70, whole genome shotgun sequence', 66, NULL, NULL, 180474),
(180475, '3.80.10.10-FF-004417', NULL, 'Uncharacterized protein', 183, NULL, NULL, 180475),
(180476, '4.10.900.10-FF-000019', NULL, 'Si:ch73-74h11.1', 78, NULL, NULL, 180476),
(180477, '1.20.1070.10-FF-002133', NULL, 'Uncharacterized protein', 258, NULL, NULL, 180477),
(180478, '3.40.190.80-FF-000044', NULL, 'Uncharacterized protein', 130, NULL, NULL, 180478),
(180479, '3.30.530.20-FF-000004', NULL, 'Phosphatidylinositol transfer protein alpha isoform', 267, NULL, NULL, 180479),
(180480, '3.40.630.10-FF-000001', NULL, 'Carboxypeptidase B', 307, NULL, NULL, 180480),
(180481, '3.40.630.30-FF-000316', NULL, 'Uncharacterized protein, isoform A', 138, NULL, NULL, 180481),
(180482, '1.20.1070.10-FF-001644', NULL, 'Uncharacterized protein', 137, NULL, NULL, 180482),
(180483, '1.10.390.10-FF-000058', NULL, 'Aminopeptidase, putative', 116, NULL, NULL, 180483),
(180484, '2.130.10.10-FF-000595', NULL, 'DDB1 and CUL4 associated factor 13', 142, NULL, NULL, 180484),
(180485, '2.60.120.10-FF-000687', NULL, 'Uncharacterized protein', 76, NULL, NULL, 180485),
(180486, '1.10.510.10-FF-000754', NULL, 'Interleukin-1 receptor-associated kinase', 200, NULL, NULL, 180486),
(180487, '3.40.50.2300-FF-000104', NULL, 'Two-component system response regulator', 130, NULL, NULL, 180487),
(180488, '3.30.750.24-FF-000172', NULL, 'Uncharacterized protein', 80, NULL, NULL, 180488),
(180489, '3.90.660.10-FF-000048', NULL, NULL, 60, NULL, NULL, 180489),
(180490, '3.40.50.150-FF-001112', NULL, NULL, 119, NULL, NULL, 180490),
(180491, '3.30.420.10-FF-000100', NULL, '3''-5'' exonuclease/helicase (Wrn), putative', 194, NULL, NULL, 180491),
(180492, '3.30.70.20-FF-000109', NULL, NULL, 55, NULL, NULL, 180492),
(180493, '2.130.10.10-FF-003826', NULL, 'Neuroblastoma-amplified sequence', 300, NULL, NULL, 180493),
(180494, '1.10.510.10-FF-003025', NULL, NULL, 228, NULL, NULL, 180494),
(180495, '3.40.50.300-FF-006952', NULL, 'Uncharacterized protein', 224, NULL, NULL, 180495),
(180496, '3.30.470.20-FF-000033', NULL, 'Probable tubulin polyglutamylase TTLL1', 213, NULL, NULL, 180496),
(180497, '1.10.8.10-FF-000315', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 60, NULL, NULL, 180497),
(180498, '1.10.418.10-FF-000112', NULL, 'MICAL like 1', 60, NULL, NULL, 180498),
(180499, '1.10.510.10-FF-000647', NULL, 'Serine/threonine-protein kinase', 204, NULL, NULL, 180499),
(180500, '3.30.1360.120-FF-000015', NULL, 'IBA57, iron-sulfur cluster assembly', 320, NULL, NULL, 180500),
(180501, '3.30.200.20-FF-002155', NULL, 'Uncharacterized protein', 67, NULL, NULL, 180501),
(180502, '3.10.100.10-FF-000047', NULL, 'lymphocyte antigen 75', 130, NULL, NULL, 180502),
(180503, '3.40.50.10130-FF-000063', NULL, 'Uncharacterized protein', 110, NULL, NULL, 180503),
(180504, '3.10.310.40-FF-000004', NULL, 'Alanyl-tRNA synthetase 2, mitochondrial', 106, NULL, NULL, 180504),
(180505, '2.40.10.340-FF-000007', NULL, 'Cell shape-determining protein MreC', 65, NULL, NULL, 180505),
(180506, '1.25.50.20-FF-000013', NULL, 'Aminopeptidase', 319, NULL, NULL, 180506);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(180507, '1.10.3210.10-FF-000096', NULL, 'AGAP006056-PA', 266, NULL, NULL, 180507),
(180508, '3.40.190.80-FF-000072', NULL, 'Inositol-phosphate phosphatase', 103, NULL, NULL, 180508),
(180509, '3.10.180.10-FF-000063', NULL, 'ATP-dependent 6-phosphofructokinase', 149, NULL, NULL, 180509),
(180510, '3.40.50.150-FF-000730', NULL, 'Polyamine aminopropyltransferase', 225, NULL, NULL, 180510),
(180511, '1.10.287.3510-FF-000009', NULL, 'Na(+)/H(+) antiporter subunit C', 101, NULL, NULL, 180511),
(180512, '3.40.50.300-FF-002681', NULL, 'Ctf18p', 207, NULL, NULL, 180512),
(180513, '3.40.140.10-FF-000121', NULL, 'NPL4 family, putative', 164, NULL, NULL, 180513),
(180514, '2.120.10.30-FF-000450', NULL, 'Predicted protein', 104, NULL, NULL, 180514),
(180515, '1.10.1450.10-FF-000046', NULL, 'Tetraspanin', 124, NULL, NULL, 180515),
(180516, '2.130.10.10-FF-002995', NULL, 'Predicted protein', 197, NULL, NULL, 180516),
(180517, '2.30.29.30-FF-000738', NULL, 'Putative Rho guanine nucleotide exchange factor FGD-1', 95, NULL, NULL, 180517),
(180518, '3.40.1520.20-FF-000001', NULL, 'Peptidoglycan-binding protein ArfA', 110, NULL, NULL, 180518),
(180519, '3.30.160.60-FF-000078', NULL, 'Zinc finger protein 180', 28, NULL, NULL, 180519),
(180520, '2.40.100.10-FF-000139', NULL, 'Uncharacterized protein', 98, NULL, NULL, 180520),
(180521, '2.60.470.10-FF-000027', NULL, 'Amiloride-sensitive sodium channel subunit beta', 174, NULL, NULL, 180521),
(180522, '3.40.50.300-FF-006424', NULL, 'Uncharacterized protein', 129, NULL, NULL, 180522),
(180523, '1.10.10.60-FF-000275', NULL, 'jerky protein homolog', 59, NULL, NULL, 180523),
(180524, '2.30.29.30-FF-001357', NULL, 'Predicted protein', 133, NULL, NULL, 180524),
(180525, '2.10.25.10-FF-001753', NULL, 'Uncharacterized protein', 36, NULL, NULL, 180525),
(180526, '2.130.10.10-FF-005749', NULL, 'Uncharacterized protein', 121, NULL, NULL, 180526),
(180527, '1.25.10.10-FF-001626', NULL, 'Uncharacterized protein', 495, NULL, NULL, 180527),
(180528, '1.20.920.10-FF-000176', NULL, 'Predicted protein', 88, NULL, NULL, 180528),
(180529, '3.30.70.330-FF-001307', NULL, 'AT20472p', 156, NULL, NULL, 180529),
(180530, '1.25.40.690-FF-000012', NULL, 'Predicted protein', 93, NULL, NULL, 180530),
(180531, '2.60.40.3210-FF-000002', NULL, 'Tectorin alpha', 124, NULL, NULL, 180531),
(180532, '3.40.33.10-FF-000026', NULL, 'Uncharacterized protein, isoform A', 248, NULL, NULL, 180532),
(180533, '2.60.40.10-FF-000162', NULL, 'Tenascin C', 91, NULL, NULL, 180533),
(180534, '1.25.10.10-FF-001519', NULL, 'Formin homology 2 domain containing, isoform F', 152, NULL, NULL, 180534),
(180535, '1.10.238.10-FF-001003', NULL, 'Defective in cullin neddylation protein', 89, NULL, NULL, 180535),
(180536, '1.10.238.150-FF-000008', NULL, 'Formin (Bud-site selection/polarity protein), putative', 98, NULL, NULL, 180536),
(180537, '1.10.10.10-FF-000030', NULL, 'Forkhead box protein K2', 107, NULL, NULL, 180537),
(180538, '3.30.230.70-FF-000148', NULL, 'Polyribonucleotide nucleotidyltransferase 1 chloroplastic', 102, NULL, NULL, 180538),
(180539, '1.20.1280.50-FF-000053', NULL, 'F-box/LRR-repeat protein At3g48880', 43, NULL, NULL, 180539),
(180540, '1.10.510.10-FF-001266', NULL, 'Protein kinase, putative', 356, NULL, NULL, 180540),
(180541, '3.30.160.60-FF-000611', NULL, 'zinc finger protein 341 isoform X1', 28, NULL, NULL, 180541),
(180542, '3.30.740.10-FF-000023', NULL, NULL, 81, NULL, NULL, 180542),
(180543, '1.20.5.110-FF-000089', NULL, 'Golgi vesicular membrane trafficking protein', 62, NULL, NULL, 180543),
(180544, '3.40.50.1240-FF-000078', NULL, 'Phosphohistidine phosphatase SixA', 155, NULL, NULL, 180544),
(180545, '1.10.510.10-FF-004014', NULL, NULL, 215, NULL, NULL, 180545),
(180546, '1.10.510.10-FF-002064', NULL, 'Kinase-like domain-containing protein', 268, NULL, NULL, 180546),
(180547, '1.25.40.10-FF-005186', NULL, 'Uncharacterized protein', 240, NULL, NULL, 180547),
(180548, '1.20.1250.20-FF-001071', NULL, 'Uncharacterized protein', 231, NULL, NULL, 180548),
(180549, '3.30.70.330-FF-000133', NULL, 'poly(U)-binding-splicing factor PUF60 isoform X1', 88, NULL, NULL, 180549);
INSERT INTO "PUBLIC"."MODEL" VALUES
(180550, '3.50.50.60-FF-000344', NULL, 'Protoporphyrinogen oxidase', 141, NULL, NULL, 180550),
(180551, '3.40.50.2300-FF-001537', NULL, NULL, 63, NULL, NULL, 180551),
(180552, '2.60.120.970-FF-000089', NULL, 'Bone morphogenetic protein 10', 201, NULL, NULL, 180552),
(180553, '3.90.190.20-FF-000037', NULL, 'Folylpolyglutamate synthase', 145, NULL, NULL, 180553),
(180554, '3.90.70.80-FF-000001', NULL, 'OTU domain-containing protein', 147, NULL, NULL, 180554),
(180555, '3.40.50.2300-FF-000885', NULL, NULL, 136, NULL, NULL, 180555),
(180556, '3.40.1110.10-FF-000080', NULL, 'Putative P-type ATPase', 131, NULL, NULL, 180556),
(180557, '1.10.8.60-FF-000072', NULL, 'probable inactive ATP-dependent zinc metalloprotease FTSHI 2, chloroplastic', 70, NULL, NULL, 180557),
(180558, '2.60.120.260-FF-000117', NULL, 'Beta-galactosidase', 162, NULL, NULL, 180558),
(180559, '3.40.50.410-FF-000353', NULL, 'Uncharacterized protein', 85, NULL, NULL, 180559),
(180560, '1.25.40.420-FF-000072', NULL, 'Predicted protein', 107, NULL, NULL, 180560),
(180561, '2.60.40.10-FF-003832', NULL, NULL, 103, NULL, NULL, 180561),
(180562, '1.25.10.10-FF-000665', NULL, 'Pumilio protein 9, putative', 296, NULL, NULL, 180562),
(180563, '3.30.1640.10-FF-000088', NULL, 'DNA helicase', 113, NULL, NULL, 180563),
(180564, '3.90.550.10-FF-000366', NULL, 'Glycosyl transferase family 8 protein', 242, NULL, NULL, 180564),
(180565, '2.30.30.30-FF-000163', NULL, 'Uncharacterized protein', 86, NULL, NULL, 180565),
(180566, '3.40.640.10-FF-000070', NULL, 'O-phosphoseryl-tRNA(Sec) selenium transferase', 463, NULL, NULL, 180566),
(180567, '3.30.420.10-FF-000465', NULL, NULL, 212, NULL, NULL, 180567),
(180568, '3.40.1160.10-FF-000009', NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase', 189, NULL, NULL, 180568),
(180569, '2.40.20.10-FF-000038', NULL, 'Coagulation factor II (thrombin)', 97, NULL, NULL, 180569),
(180570, '3.40.20.10-FF-000075', NULL, 'DreBriN 1/DreBriN-like (Where Drebrin is from Developmentally REgulated BRaIN protein) family homolog', 132, NULL, NULL, 180570),
(180571, '3.30.200.20-FF-001975', NULL, 'Uncharacterized protein', 102, NULL, NULL, 180571),
(180572, '2.60.40.2170-FF-000010', NULL, 'tyrosine-protein kinase RYK', 164, NULL, NULL, 180572),
(180573, '2.60.40.60-FF-000508', NULL, 'Predicted protein', 84, NULL, NULL, 180573),
(180574, '2.40.40.20-FF-000019', NULL, 'DNA-directed RNA polymerase II subunit RPB1', 104, NULL, NULL, 180574),
(180575, '1.10.287.380-FF-000002', NULL, 'Valine--tRNA ligase', 71, NULL, NULL, 180575),
(180576, '2.130.10.10-FF-004754', NULL, 'Uncharacterized protein', 159, NULL, NULL, 180576),
(180577, '2.60.40.10-FF-000319', NULL, 'Dyslexia-associated protein KIAA0319 homolog', 93, NULL, NULL, 180577),
(180578, '2.130.10.10-FF-003956', NULL, 'Uncharacterized protein', 242, NULL, NULL, 180578),
(180579, '3.40.190.10-FF-000776', NULL, 'Oligopeptide ABC transporter, periplasmic oligopeptide-binding protein', 287, NULL, NULL, 180579),
(180580, '2.60.210.10-FF-000014', NULL, 'Ubiquitin carboxyl-terminal hydrolase 7', 147, NULL, NULL, 180580),
(180581, '3.40.309.10-FF-000120', NULL, 'Uncharacterized protein', 104, NULL, NULL, 180581),
(180582, '3.40.50.720-FF-001435', NULL, 'Aspergillus niger contig An11c0010, genomic contig', 417, NULL, NULL, 180582),
(180583, '3.40.50.720-FF-000996', NULL, '3-oxoacyl-(acyl-carrier protein) reductase fabG2', 246, NULL, NULL, 180583),
(180584, '1.10.287.130-FF-000197', NULL, 'Sensor protein', 62, NULL, NULL, 180584),
(180585, '2.10.25.10-FF-001309', NULL, 'Uncharacterized protein', 34, NULL, NULL, 180585),
(180586, '3.90.1490.10-FF-000011', NULL, 'Diphthamide biosynthesis protein Dph6', 97, NULL, NULL, 180586),
(180587, '3.40.1110.10-FF-000422', NULL, NULL, 15, NULL, NULL, 180587),
(180588, '2.30.180.10-FF-000186', NULL, NULL, 131, NULL, NULL, 180588),
(180589, '1.10.132.60-FF-000036', NULL, 'Uncharacterized protein', 52, NULL, NULL, 180589),
(180590, '3.80.10.10-FF-001293', NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', 109, NULL, NULL, 180590);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(180591, '2.60.120.330-FF-000239', NULL, 'Predicted protein', 56, NULL, NULL, 180591),
(180592, '3.80.10.10-FF-003119', NULL, 'Cilia and flagella-associated protein 410', 89, NULL, NULL, 180592),
(180593, '3.40.1030.10-FF-000005', NULL, 'Anthranilate phosphoribosyltransferase', 296, NULL, NULL, 180593),
(180594, '3.40.830.10-FF-000005', NULL, 'AmmeMemoRadiSam system protein B, putative', 325, NULL, NULL, 180594),
(180595, '3.40.50.2300-FF-000576', NULL, 'Chemotaxis protein CheV', 137, NULL, NULL, 180595),
(180596, '3.30.160.60-FF-000864', NULL, 'Zinc fingers and homeoboxes protein 3', 86, NULL, NULL, 180596),
(180597, '3.40.630.50-FF-000002', NULL, 'D-aminoacyl-tRNA deacylase', 162, NULL, NULL, 180597),
(180598, '3.50.50.60-FF-000597', NULL, '2-octaprenyl-3-methyl-6-methoxy-1,4-benzoquinol hydroxylase', 194, NULL, NULL, 180598),
(180599, '2.60.40.4060-FF-000015', NULL, 'Uncharacterized protein', 132, NULL, NULL, 180599),
(180600, '3.40.50.1820-FF-001477', NULL, 'Uncharacterized protein', 171, NULL, NULL, 180600),
(180601, '1.25.40.10-FF-001347', NULL, 'Hsc70-interacting protein, putative', 176, NULL, NULL, 180601),
(180602, '2.30.29.230-FF-000012', NULL, 'Uncharacterized protein', 227, NULL, NULL, 180602),
(180603, '1.20.58.390-FF-000026', NULL, 'Cholinergic receptor nicotinic beta 1 subunit', 112, NULL, NULL, 180603),
(180604, '3.40.50.300-FF-004479', NULL, 'ATP-binding cassette transporter pdr1', 229, NULL, NULL, 180604),
(180605, '3.30.1370.10-FF-000005', NULL, 'poly(RC)-binding protein 2 isoform X1', 79, NULL, NULL, 180605),
(180606, '3.40.1810.10-FF-000071', NULL, NULL, 82, NULL, NULL, 180606),
(180607, '3.30.160.60-FF-006024', NULL, NULL, 82, NULL, NULL, 180607),
(180608, '1.20.1730.10-FF-000054', NULL, 'Uncharacterized protein', 531, NULL, NULL, 180608),
(180609, '2.70.150.10-FF-000231', NULL, 'Phospholipid-transporting ATPase', 139, NULL, NULL, 180609),
(180610, '1.10.510.10-FF-000271', NULL, 'Non-specific serine/threonine protein kinase', 337, NULL, NULL, 180610),
(180611, '3.40.50.2300-FF-000918', NULL, NULL, 126, NULL, NULL, 180611),
(180612, '3.40.50.720-FF-001519', NULL, 'Chromosome 19, whole genome shotgun sequence', 72, NULL, NULL, 180612),
(180613, '3.40.605.10-FF-000044', NULL, 'Aldehyde dehydrogenase 16 family member A1', 258, NULL, NULL, 180613),
(180614, '3.80.10.10-FF-001635', NULL, 'Uncharacterized protein', 229, NULL, NULL, 180614),
(180615, '2.10.230.10-FF-000026', NULL, 'Uncharacterized protein', 30, NULL, NULL, 180615),
(180616, '3.10.580.10-FF-000155', NULL, 'UPF0053 protein sll1254', 151, NULL, NULL, 180616),
(180617, '2.70.170.10-FF-000244', NULL, 'Uncharacterized protein', 173, NULL, NULL, 180617),
(180618, '1.20.1300.20-FF-000007', NULL, 'Ubiquitin thioesterase OTUB1', 146, NULL, NULL, 180618),
(180619, '2.60.40.10-FF-000735', NULL, 'V-set and transmembrane domain containing 2 like', 121, NULL, NULL, 180619),
(180620, '3.30.160.60-FF-005535', NULL, NULL, 54, NULL, NULL, 180620),
(180621, '3.40.50.300-FF-004827', NULL, 'Excision repair cross-complementation group 6', 170, NULL, NULL, 180621),
(180622, '2.60.40.10-FF-005625', NULL, NULL, 98, NULL, NULL, 180622),
(180623, '1.20.1560.10-FF-000782', NULL, 'Uncharacterized protein', 286, NULL, NULL, 180623),
(180624, '1.20.120.1380-FF-000009', NULL, 'Flagellar biosynthesis protein FlhF', 39, NULL, NULL, 180624),
(180625, '2.60.40.1170-FF-000002', NULL, 'AP-1 complex subunit mu-1 isoform 1', 111, NULL, NULL, 180625),
(180626, '2.60.200.20-FF-000281', NULL, 'Meiosis-specific serine/threonine-protein kinase mek1', 121, NULL, NULL, 180626),
(180627, '3.30.1360.10-FF-000050', NULL, 'AGAP008771-PA', 56, NULL, NULL, 180627),
(180628, '3.40.50.410-FF-000370', NULL, 'Predicted protein', 193, NULL, NULL, 180628),
(180629, '3.90.190.10-FF-000490', NULL, 'Tyrosine-protein phosphatase non-receptor type 7-like Protein', 302, NULL, NULL, 180629),
(180630, '3.30.50.10-FF-000072', NULL, 'GATA zinc finger family protein', 67, NULL, NULL, 180630),
(180631, '3.50.50.60-FF-000945', NULL, 'Sarcosine dehydrogenase, putative', 138, NULL, NULL, 180631);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(180632, '3.40.50.2000-FF-000109', NULL, 'Chitobiosyldiphosphodolichol beta-mannosyltransferase', 175, NULL, NULL, 180632),
(180633, '2.130.10.10-FF-005934', NULL, 'Uncharacterized protein', 264, NULL, NULL, 180633),
(180634, '3.90.79.10-FF-000253', NULL, 'Predicted protein', 144, NULL, NULL, 180634),
(180635, '2.130.10.10-FF-003809', NULL, 'Uncharacterized WD repeat-containing protein C25H1.06', 394, NULL, NULL, 180635),
(180636, '3.40.50.2300-FF-001065', NULL, NULL, 87, NULL, NULL, 180636),
(180637, '2.40.10.10-FF-000425', NULL, 'AGAP012315-PA', 233, NULL, NULL, 180637),
(180638, '3.40.50.300-FF-005805', NULL, 'Pilus assembly protein PilB', 267, NULL, NULL, 180638),
(180639, '3.10.110.10-FF-000328', NULL, 'Ubiquitin-conjugating enzyme E2, putative', 156, NULL, NULL, 180639),
(180640, '2.10.70.10-FF-000205', NULL, 'sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1 isoform X4', 62, NULL, NULL, 180640),
(180641, '3.40.1110.10-FF-000405', NULL, NULL, 70, NULL, NULL, 180641),
(180642, '1.10.287.1130-FF-000015', NULL, 'Copper metallochaperone', 59, NULL, NULL, 180642),
(180643, '3.30.300.30-FF-000159', NULL, 'Uncharacterized protein', 133, NULL, NULL, 180643),
(180644, '3.30.70.240-FF-000004', NULL, '116 kDa U5 small nuclear ribonucleoprotein', 122, NULL, NULL, 180644),
(180645, '3.30.70.3290-FF-000004', NULL, 'Sterigmatocystin biosynthesis polyketide synthase', 107, NULL, NULL, 180645),
(180646, '1.20.5.510-FF-000001', NULL, 'Photosystem I reaction center subunit IX', 44, NULL, NULL, 180646),
(180647, '3.30.430.20-FF-000042', NULL, 'Cysteine-rich receptor-like protein kinase 42', 89, NULL, NULL, 180647),
(180648, '3.40.50.300-FF-004052', NULL, 'Armitage, isoform C', 218, NULL, NULL, 180648),
(180649, '3.30.1370.10-FF-000224', NULL, 'Predicted protein', 77, NULL, NULL, 180649),
(180650, '1.25.10.10-FF-000215', NULL, 'leucine-rich repeat serine/threonine-protein kinase 2', 333, NULL, NULL, 180650),
(180651, '3.30.160.20-FF-000206', NULL, 'Eukaryotic translation initiation factor 2 alpha kinase 2', 82, NULL, NULL, 180651),
(180652, '3.40.50.970-FF-000060', NULL, '1-deoxy-D-xylulose-5-phosphate synthase', 170, NULL, NULL, 180652),
(180653, '3.30.530.20-FF-000111', NULL, 'Phosphatidylinositol transfer protein, beta,-like', 136, NULL, NULL, 180653),
(180654, '3.40.50.300-FF-000556', NULL, 'Methylenetetrahydrofolate dehydrogenase (NADP+ dependent) 1 like', 153, NULL, NULL, 180654),
(180655, '3.50.50.60-FF-000260', NULL, 'Dihydrolipoyl dehydrogenase', 141, NULL, NULL, 180655),
(180656, '3.40.50.10810-FF-000048', NULL, 'SNF2 helicase, putative', 233, NULL, NULL, 180656),
(180657, '3.30.420.40-FF-000435', NULL, 'SWI/SNF nucleosome remodeling complex component', 122, NULL, NULL, 180657),
(180658, '2.60.40.10-FF-000954', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', 99, NULL, NULL, 180658),
(180659, '3.20.20.140-FF-000107', NULL, 'Adenosine deaminase putative', 334, NULL, NULL, 180659),
(180660, '1.10.10.60-FF-000691', NULL, 'AraC family transcriptional regulator', 110, NULL, NULL, 180660),
(180661, '3.40.50.720-FF-000816', NULL, 'HesA/MoeB/ThiF family protein', 252, NULL, NULL, 180661),
(180662, '1.10.510.10-FF-000086', NULL, 'Non-specific serine/threonine protein kinase', 69, NULL, NULL, 180662),
(180663, '1.10.3730.10-FF-000017', NULL, 'Pyrroline-5-carboxylate reductase', 106, NULL, NULL, 180663),
(180664, '3.40.50.2000-FF-000784', NULL, 'Uncharacterized protein', 103, NULL, NULL, 180664),
(180665, '2.40.10.10-FF-000083', NULL, 'Genome polyprotein', 41, NULL, NULL, 180665),
(180666, '3.40.50.2300-FF-001407', NULL, NULL, 103, NULL, NULL, 180666),
(180667, '3.30.980.10-FF-000041', NULL, 'Uncharacterized protein', 50, NULL, NULL, 180667),
(180668, '4.10.400.10-FF-000217', NULL, 'Uncharacterized protein, isoform B', 40, NULL, NULL, 180668),
(180669, '2.20.70.70-FF-000003', NULL, 'Dihydropteridine reductase', 22, NULL, NULL, 180669),
(180670, '3.30.70.330-FF-000003', NULL, 'Polyadenylate-binding protein', 88, NULL, NULL, 180670),
(180671, '3.40.50.1820-FF-001792', NULL, 'Uncharacterized protein', 157, NULL, NULL, 180671);
INSERT INTO "PUBLIC"."MODEL" VALUES
(180672, '2.60.40.1770-FF-000002', NULL, 'ephrin type-A receptor 2', 59, NULL, NULL, 180672),
(180673, '2.10.25.10-FF-000825', NULL, 'Crumbs, isoform C', 70, NULL, NULL, 180673),
(180674, '1.20.1600.10-FF-000027', NULL, 'Outer membrane protein TolC', 412, NULL, NULL, 180674),
(180675, '2.30.130.60-FF-000001', NULL, 'Sun/nucleolar protein family protein-putative tRNA and rRNA cytosine-C5-methylase', 56, NULL, NULL, 180675),
(180676, '3.40.50.720-FF-001305', NULL, 'Malic enzyme', 301, NULL, NULL, 180676),
(180677, '1.10.287.110-FF-000186', NULL, 'GD13648', 90, NULL, NULL, 180677),
(180678, '3.40.50.300-FF-005463', NULL, 'ATPase, RecA superfamily', 227, NULL, NULL, 180678),
(180679, '2.40.10.10-FF-000392', NULL, NULL, 129, NULL, NULL, 180679),
(180680, '1.20.1560.10-FF-000563', NULL, 'ATP-binding cassette transporter, subfamily B, member 20, group MDR/PGP protein PpABCB20', 32, NULL, NULL, 180680),
(180681, '3.30.565.10-FF-000138', NULL, 'Two-component sensor histidine kinase', 153, NULL, NULL, 180681),
(180682, '1.20.1560.10-FF-000911', NULL, 'Uncharacterized protein', 148, NULL, NULL, 180682),
(180683, '2.130.10.10-FF-005373', NULL, 'Uncharacterized protein', 163, NULL, NULL, 180683),
(180684, '3.30.428.10-FF-000022', NULL, 'AP-4-A phosphorylase', 182, NULL, NULL, 180684),
(180685, '3.30.450.50-FF-000029', NULL, 'GD10048', 122, NULL, NULL, 180685),
(180686, '1.25.40.20-FF-001592', NULL, 'Uncharacterized protein', 116, NULL, NULL, 180686),
(180687, '2.60.40.3510-FF-000013', NULL, 'Uncharacterized protein', 154, NULL, NULL, 180687),
(180688, '3.40.50.620-FF-000775', NULL, 'Predicted protein', 103, NULL, NULL, 180688),
(180689, '2.70.130.10-FF-000163', NULL, NULL, 90, NULL, NULL, 180689),
(180690, '2.30.29.30-FF-000053', NULL, 'Engulfment and cell motility protein 1', 117, NULL, NULL, 180690),
(180691, '3.40.140.10-FF-000149', NULL, 'Translation initiation factor eIF3 subunit, putative', 202, NULL, NULL, 180691),
(180692, '2.60.120.650-FF-000111', NULL, 'Jumonji/ARID domain-containing protein 2', 269, NULL, NULL, 180692),
(180693, '3.40.50.300-FF-001753', NULL, 'Mitochondrial GTPase 1', 189, NULL, NULL, 180693),
(180694, '3.40.50.300-FF-005772', NULL, 'Os03g0810700 protein', 105, NULL, NULL, 180694),
(180695, '1.10.246.20-FF-000007', NULL, 'RNA polymerase II holoenzyme complex component', 85, NULL, NULL, 180695),
(180696, '3.90.550.10-FF-000282', NULL, 'Bifunctional IPC transferase and DIPP synthase', 221, NULL, NULL, 180696),
(180697, '2.70.98.10-FF-000053', NULL, 'Predicted protein', 275, NULL, NULL, 180697),
(180698, '3.30.160.20-FF-000167', NULL, 'Uncharacterized protein', 83, NULL, NULL, 180698),
(180699, '3.30.70.330-FF-003095', NULL, NULL, 100, NULL, NULL, 180699),
(180700, '3.30.200.20-FF-001536', NULL, 'Uncharacterized protein', 102, NULL, NULL, 180700),
(180701, '3.40.50.10190-FF-000165', NULL, 'PAX transcription activation domain interacting protein', 96, NULL, NULL, 180701),
(180702, '2.60.40.10-FF-002899', NULL, 'Myotactin form B', 96, NULL, NULL, 180702),
(180703, '2.130.10.10-FF-003012', NULL, 'Uncharacterized protein', 175, NULL, NULL, 180703),
(180704, '3.30.40.10-FF-000588', NULL, 'RING/U-box superfamily protein', 57, NULL, NULL, 180704),
(180705, '3.40.50.300-FF-002265', NULL, 'Elongation factor G', 250, NULL, NULL, 180705),
(180706, '1.20.1270.420-FF-000013', NULL, 'Inhibitor of nuclear factor kappa B kinase subunit epsilon', 125, NULL, NULL, 180706),
(180707, '1.10.472.10-FF-000193', NULL, 'Cyclin-D1-1', 94, NULL, NULL, 180707),
(180708, '3.40.50.1580-FF-000051', NULL, 'S-methyl-5''-thioadenosine phosphorylase', 185, NULL, NULL, 180708),
(180709, '2.60.40.10-FF-003517', NULL, 'Guanine nucleotide exchange factor UNC-73A', 86, NULL, NULL, 180709),
(180710, '3.80.10.10-FF-004069', NULL, 'Uncharacterized protein', 131, NULL, NULL, 180710),
(180711, '3.40.50.300-FF-003299', NULL, 'Os06g0114600 protein', 327, NULL, NULL, 180711),
(180712, '1.10.510.10-FF-000193', NULL, 'Serine/threonine-protein kinase CTR1', 186, NULL, NULL, 180712),
(180713, '3.30.200.20-FF-001519', NULL, 'cyclin-dependent kinase 16-like', 50, NULL, NULL, 180713);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(180714, '2.130.10.10-FF-003484', NULL, 'WD40 repeat-containing protein', 298, NULL, NULL, 180714),
(180715, '3.30.450.20-FF-000150', NULL, 'PAS domain-containing sensor histidine kinase', 122, NULL, NULL, 180715),
(180716, '3.40.50.1000-FF-000366', NULL, 'HAD-superfamily phosphatase, subfamily IIIC containing protein, expressed', 167, NULL, NULL, 180716),
(180717, '2.30.42.10-FF-000595', NULL, NULL, 103, NULL, NULL, 180717),
(180718, '1.10.760.10-FF-000014', NULL, 'Cytochrome c', 110, NULL, NULL, 180718),
(180719, '3.30.300.10-FF-000046', NULL, 'S-adenosylmethionine synthase', 127, NULL, NULL, 180719),
(180720, '3.40.50.1240-FF-000095', NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', 238, NULL, NULL, 180720),
(180721, '3.40.50.300-FF-005013', NULL, 'Mrp, putative', 267, NULL, NULL, 180721),
(180722, '1.25.40.20-FF-001676', NULL, 'Homeobox protein Wariai', 249, NULL, NULL, 180722),
(180723, '1.25.40.20-FF-000642', NULL, 'transient receptor potential cation channel subfamily V member 4 isoform X2', 92, NULL, NULL, 180723),
(180724, '1.10.533.10-FF-000071', NULL, 'NACHT, LRR and PYD domains-containing protein 5', 99, NULL, NULL, 180724),
(180725, '3.20.20.70-FF-000324', NULL, 'Dihydrouridine synthase (Dus), putative', 236, NULL, NULL, 180725),
(180726, '3.30.160.60-FF-000842', NULL, 'Zinc finger protein 383', 29, NULL, NULL, 180726),
(180727, '2.60.40.10-FF-002427', NULL, 'Uncharacterized protein', 103, NULL, NULL, 180727),
(180728, '3.30.830.10-FF-000131', NULL, 'Zinc protease PQQL-like', 243, NULL, NULL, 180728),
(180729, '3.30.390.60-FF-000016', NULL, 'Heat-inducible transcription repressor HrcA', 101, NULL, NULL, 180729),
(180730, '1.10.238.10-FF-000694', NULL, 'EF-hand domain pair, putative', 159, NULL, NULL, 180730),
(180731, '3.20.20.70-FF-000796', NULL, NULL, 36, NULL, NULL, 180731),
(180732, '3.90.180.10-FF-000101', NULL, 'Alcohol dehydrogenase 6B (class V)', 108, NULL, NULL, 180732),
(180733, '2.60.120.200-FF-000695', NULL, 'Uncharacterized protein', 196, NULL, NULL, 180733),
(180734, '3.30.450.20-FF-000633', NULL, 'Sensor histidine kinase, HAMP domain-containing', 147, NULL, NULL, 180734),
(180735, '3.40.720.10-FF-000087', NULL, 'Arylsulfatase B', 346, NULL, NULL, 180735),
(180736, '3.10.260.30-FF-000002', NULL, 'AaceriAFR690Cp', 100, NULL, NULL, 180736),
(180737, '1.10.10.10-FF-000485', NULL, 'Transcriptional regulator', 135, NULL, NULL, 180737),
(180738, '3.10.20.30-FF-000077', NULL, NULL, 92, NULL, NULL, 180738),
(180739, '2.40.10.170-FF-000012', NULL, 'ATP synthase subunit beta', 76, NULL, NULL, 180739),
(180740, '3.50.50.100-FF-000016', NULL, 'NAD(P)H dehydrogenase 3', 407, NULL, NULL, 180740),
(180741, '2.40.30.10-FF-000174', NULL, 'Ferredoxin--NADP reductase', 100, NULL, NULL, 180741),
(180742, '1.10.357.20-FF-000018', NULL, 'Solute carrier family 41, member 2', 83, NULL, NULL, 180742),
(180743, '1.20.1070.10-FF-001172', NULL, 'Vomeronasal type-1 receptor', 289, NULL, NULL, 180743),
(180744, '2.30.29.30-FF-001126', NULL, 'Pleckstrin homology domain-containing family J member 1-like Protein', 124, NULL, NULL, 180744),
(180745, '2.40.128.200-FF-000002', NULL, 'Lipoprotein LprI', 75, NULL, NULL, 180745),
(180746, '2.60.120.200-FF-000706', NULL, 'Predicted protein', 184, NULL, NULL, 180746),
(180747, '3.40.390.10-FF-000196', NULL, NULL, 219, NULL, NULL, 180747),
(180748, '1.10.472.10-FF-000204', NULL, 'Cyclin C, putative', 104, NULL, NULL, 180748),
(180749, '1.10.1040.50-FF-000021', NULL, NULL, 49, NULL, NULL, 180749),
(180750, '2.60.40.1080-FF-000003', NULL, 'Phage major tail protein', 91, NULL, NULL, 180750),
(180751, '1.20.1270.280-FF-000044', NULL, 'Inner dynein arm 1 heavy chain 1-ALPHa', 165, NULL, NULL, 180751),
(180752, '1.10.10.390-FF-000004', NULL, 'Histone acetyltransferase type B catalytic subunit', 64, NULL, NULL, 180752),
(180753, '3.90.226.10-FF-000332', NULL, 'Uncharacterized protein', 81, NULL, NULL, 180753),
(180754, '3.90.1150.10-FF-000340', NULL, 'Cysteine desulfurase IscS', 114, NULL, NULL, 180754),
(180755, '3.90.190.10-FF-000074', NULL, 'Protein tyrosine phosphatase type IVA 2', 107, NULL, NULL, 180755);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(180756, '3.30.160.60-FF-005619', NULL, NULL, 44, NULL, NULL, 180756),
(180757, '1.10.287.40-FF-000001', NULL, 'Serine--tRNA ligase', 104, NULL, NULL, 180757),
(180758, '1.10.630.10-FF-000774', NULL, 'Cytochrome P450, family 71, subfamily B, polypeptide 32', 168, NULL, NULL, 180758),
(180759, '2.60.40.10-FF-004136', NULL, NULL, 90, NULL, NULL, 180759),
(180760, '3.40.710.10-FF-000058', NULL, 'Transglycosylase', 423, NULL, NULL, 180760),
(180761, '3.40.50.720-FF-001744', NULL, 'Uncharacterized protein', 143, NULL, NULL, 180761),
(180762, '3.30.1490.20-FF-000045', NULL, 'Bifunctional urea carboxylase/allophanate hydrolase', 70, NULL, NULL, 180762),
(180763, '1.10.472.80-FF-000258', NULL, NULL, 60, NULL, NULL, 180763),
(180764, '3.90.1410.10-FF-000158', NULL, 'Uncharacterized protein', 55, NULL, NULL, 180764),
(180765, '3.30.1330.30-FF-000126', NULL, 'Uncharacterized protein', 125, NULL, NULL, 180765),
(180766, '3.30.530.20-FF-000095', NULL, 'Possible membrane oxidoreductase', 127, NULL, NULL, 180766),
(180767, '3.50.30.10-FF-000013', NULL, NULL, 105, NULL, NULL, 180767),
(180768, '2.60.40.10-FF-001808', NULL, 'Neuromusculin, isoform E', 94, NULL, NULL, 180768),
(180769, '3.30.760.10-FF-000058', NULL, 'Eukaryotic translation initiation factor 4E family member 1B', 187, NULL, NULL, 180769),
(180770, '3.30.70.380-FF-000007', NULL, 'Phenylalanine--tRNA ligase beta subunit', 91, NULL, NULL, 180770),
(180771, '1.20.58.900-FF-000011', NULL, 'Uncharacterized protein, isoform B', 179, NULL, NULL, 180771),
(180772, '2.60.40.10-FF-000870', NULL, 'sushi, nidogen and EGF-like domain-containing protein 1 isoform X3', 98, NULL, NULL, 180772),
(180773, '3.40.50.2020-FF-000104', NULL, 'Ribose-phosphate pyrophosphokinase 2 isoform x1', 129, NULL, NULL, 180773),
(180774, '2.130.10.10-FF-001775', NULL, 'WD domain, G-beta repeat, putative', 205, NULL, NULL, 180774),
(180775, '2.120.10.30-FF-000141', NULL, 'NHL repeat-containing protein', 206, NULL, NULL, 180775),
(180776, '3.40.50.2000-FF-001082', NULL, 'Glycosyltransferase', 130, NULL, NULL, 180776),
(180777, '3.30.420.10-FF-000696', NULL, NULL, 118, NULL, NULL, 180777),
(180778, '1.10.357.140-FF-000054', NULL, 'Uncharacterized protein', 57, NULL, NULL, 180778),
(180779, '3.50.30.30-FF-000019', NULL, 'Signal peptide peptidase like 2A', 114, NULL, NULL, 180779),
(180780, '3.40.50.10420-FF-000026', NULL, '5-formyltetrahydrofolate cyclo-ligase', 192, NULL, NULL, 180780),
(180781, '1.25.40.10-FF-000526', NULL, 'Transmembrane and tetratricopeptide repeat-containing 1', 89, NULL, NULL, 180781),
(180782, '1.20.1250.20-FF-001285', NULL, 'Drug resistance transporter, EmrB/QacA family', 214, NULL, NULL, 180782),
(180783, '3.60.120.10-FF-000020', NULL, 'Salicylate synthetase, putative', 417, NULL, NULL, 180783),
(180784, '2.10.50.10-FF-000114', NULL, 'Fas cell surface death receptor', 58, NULL, NULL, 180784),
(180785, '3.30.70.1450-FF-000014', NULL, 'Sulfur deprivation response regulator', 74, NULL, NULL, 180785),
(180786, '3.30.160.60-FF-002972', NULL, 'GM18664', 32, NULL, NULL, 180786),
(180787, '3.40.50.300-FF-006160', NULL, 'Uncharacterized protein', 153, NULL, NULL, 180787),
(180788, '3.90.70.10-FF-000469', NULL, 'Uncharacterized protein', 130, NULL, NULL, 180788),
(180789, '1.10.510.10-FF-002755', NULL, NULL, 44, NULL, NULL, 180789),
(180790, '2.30.110.10-FF-000092', NULL, 'Flavin reductase like domain-domain-containing protein', 193, NULL, NULL, 180790),
(180791, '2.10.25.10-FF-000909', NULL, 'Notch receptor 2', 48, NULL, NULL, 180791),
(180792, '2.30.30.140-FF-000173', NULL, 'GM24389', 59, NULL, NULL, 180792),
(180793, '2.160.20.70-FF-000033', NULL, 'Adenylyl cyclase-associated protein', 156, NULL, NULL, 180793),
(180794, '3.80.10.10-FF-003563', NULL, 'Uncharacterized protein', 147, NULL, NULL, 180794),
(180795, '3.30.450.40-FF-000156', NULL, 'Sensory transduction histidine kinase', 178, NULL, NULL, 180795),
(180796, '3.30.200.20-FF-000103', NULL, 'Protein kinase C', 154, NULL, NULL, 180796),
(180797, '3.30.160.60-FF-005193', NULL, NULL, 40, NULL, NULL, 180797);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(180798, '1.10.510.10-FF-003845', NULL, NULL, 106, NULL, NULL, 180798),
(180799, '3.90.260.10-FF-000046', NULL, 'Xeroderma pigmentosum, complementation group C', 63, NULL, NULL, 180799),
(180800, '2.60.40.790-FF-000059', NULL, '26.5 kDa heat shock protein, mitochondrial', 147, NULL, NULL, 180800),
(180801, '3.30.70.330-FF-000150', NULL, 'msx2-interacting protein-like isoform X1', 82, NULL, NULL, 180801),
(180802, '1.10.1450.10-FF-000068', NULL, 'Tetraspanin', 112, NULL, NULL, 180802),
(180803, '3.40.50.10470-FF-000047', NULL, 'Eukaryotic initiation factor', 133, NULL, NULL, 180803),
(180804, '1.10.1410.10-FF-000072', NULL, 'Uncharacterized protein', 144, NULL, NULL, 180804),
(180805, '2.160.10.20-FF-000001', NULL, 'Pre-neck appendage protein', 140, NULL, NULL, 180805),
(180806, '3.30.450.40-FF-000263', NULL, 'Uncharacterized protein', 114, NULL, NULL, 180806),
(180807, '3.40.50.300-FF-000117', NULL, 'Putative DNA repair helicase rad25', 237, NULL, NULL, 180807),
(180808, '2.60.120.970-FF-000111', NULL, 'Glass bottom boat2', 120, NULL, NULL, 180808),
(180809, '1.20.5.110-FF-000128', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 62, NULL, NULL, 180809),
(180810, '3.40.50.2000-FF-000929', NULL, 'Lipopolysaccharide core biosynthesis protein rfaQ', 155, NULL, NULL, 180810),
(180811, '2.60.40.60-FF-000036', NULL, 'Protocadherin 9', 105, NULL, NULL, 180811),
(180812, '1.20.1580.10-FF-000002', NULL, 'UvrABC system protein A', 138, NULL, NULL, 180812),
(180813, '1.25.40.10-FF-000835', NULL, 'Uncharacterized protein, isoform B', 182, NULL, NULL, 180813),
(180814, '1.10.470.10-FF-000003', NULL, 'Variant surface glycoprotein (VSG), putative', 158, NULL, NULL, 180814),
(180815, '3.40.50.1820-FF-000387', NULL, 'SAY1p Sterol deacetylase', 292, NULL, NULL, 180815),
(180816, '3.90.70.10-FF-000834', NULL, 'Uncharacterized protein', 149, NULL, NULL, 180816),
(180817, '3.30.1370.10-FF-000241', NULL, 'Uncharacterized protein', 43, NULL, NULL, 180817),
(180818, '1.20.58.760-FF-000042', NULL, 'Mitochondrial respiratory chain complexes assembly protein rca1', 191, NULL, NULL, 180818),
(180819, '1.10.20.10-FF-000311', NULL, NULL, 38, NULL, NULL, 180819),
(180820, '2.60.40.10-FF-003141', NULL, NULL, 114, NULL, NULL, 180820),
(180821, '2.70.98.20-FF-000039', NULL, 'Amine oxidase', 44, NULL, NULL, 180821),
(180822, '3.40.30.10-FF-001082', NULL, 'Sulfhydryl oxidase', 99, NULL, NULL, 180822),
(180823, '1.10.3470.10-FF-000053', NULL, 'Transport system permease protein', 312, NULL, NULL, 180823),
(180824, '3.40.190.290-FF-000037', NULL, 'LysR family transcriptional regulator', 207, NULL, NULL, 180824),
(180825, '2.60.120.960-FF-000001', NULL, 'Spike glycoprotein', 274, NULL, NULL, 180825),
(180826, '1.10.287.110-FF-000293', NULL, 'DnaJ-like protein subfamily C member 27', 79, NULL, NULL, 180826),
(180827, '2.130.10.10-FF-000628', NULL, 'Pre-mRNA-splicing factor RSE1', 387, NULL, NULL, 180827),
(180828, '3.40.430.10-FF-000020', NULL, 'Dihydrofolate reductase', 221, NULL, NULL, 180828),
(180829, '2.30.30.140-FF-000318', NULL, 'Uncharacterized protein', 59, NULL, NULL, 180829),
(180830, '3.40.50.11840-FF-000014', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase', 85, NULL, NULL, 180830),
(180831, '1.20.58.150-FF-000005', NULL, 'putative clathrin assembly protein At2g25430', 146, NULL, NULL, 180831),
(180832, '1.10.472.10-FF-000513', NULL, 'Cyclin, N-terminal domain containing protein', 99, NULL, NULL, 180832),
(180833, '1.10.510.10-FF-002227', NULL, NULL, 135, NULL, NULL, 180833),
(180834, '1.10.238.110-FF-000007', NULL, 'Diacylglycerol kinase', 38, NULL, NULL, 180834),
(180835, '2.130.10.10-FF-005827', NULL, 'Putative CPSF-domain protein', 36, NULL, NULL, 180835),
(180836, '1.10.238.10-FF-000469', NULL, 'Follistatin like 1', 110, NULL, NULL, 180836),
(180837, '3.80.10.10-FF-001163', NULL, 'Leucine-rich repeat (LRR) family protein', 139, NULL, NULL, 180837),
(180838, '2.30.29.30-FF-001379', NULL, 'Uncharacterized protein', 122, NULL, NULL, 180838),
(180839, '3.40.50.300-FF-006317', NULL, 'Uncharacterized protein', 157, NULL, NULL, 180839);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(180840, '1.10.238.10-FF-001110', NULL, 'Uncharacterized protein', 51, NULL, NULL, 180840),
(180841, '2.60.120.260-FF-000342', NULL, 'Uncharacterized protein', 159, NULL, NULL, 180841),
(180842, '2.40.240.10-FF-000065', NULL, 'Glutaminyl-tRNA synthetase family protein', 84, NULL, NULL, 180842),
(180843, '3.40.50.10900-FF-000002', NULL, 'PAC2 family protein', 232, NULL, NULL, 180843),
(180844, '3.30.450.260-FF-000012', NULL, 'Uncharacterized protein', 71, NULL, NULL, 180844),
(180845, '3.90.230.10-FF-000004', NULL, 'xaa-Pro aminopeptidase 1 isoform X1', 301, NULL, NULL, 180845),
(180846, '2.60.40.60-FF-000525', NULL, 'Dachsous cadherin-related 1a', 105, NULL, NULL, 180846),
(180847, '2.170.190.11-FF-000025', NULL, 'Molybdopterin molybdenumtransferase', 123, NULL, NULL, 180847),
(180848, '3.40.50.2300-FF-000992', NULL, NULL, 80, NULL, NULL, 180848),
(180849, '3.30.70.360-FF-000001', NULL, 'N-acetyldiaminopimelate deacetylase', 118, NULL, NULL, 180849),
(180850, '1.20.920.20-FF-000033', NULL, 'Dynein heavy chain 5, axonemal', 375, NULL, NULL, 180850),
(180851, '3.10.110.10-FF-000109', NULL, 'Ubiquitin-conjugating enzyme E2 J2-like', 173, NULL, NULL, 180851),
(180852, '2.60.120.10-FF-000350', NULL, '3'',5''-cyclic-nucleotide phosphodiesterase', 120, NULL, NULL, 180852),
(180853, '3.40.50.11040-FF-000004', NULL, 'RNA cytidine acetyltransferase', 201, NULL, NULL, 180853),
(180854, '3.40.50.10330-FF-000095', NULL, 'NAD kinase', 126, NULL, NULL, 180854),
(180855, '1.10.220.150-FF-000052', NULL, 'zinc finger protein Ci-ArfGAP-1 isoform X1', 137, NULL, NULL, 180855),
(180856, '3.40.1050.10-FF-000018', NULL, 'Carbonic anhydrase', 236, NULL, NULL, 180856),
(180857, '1.10.1660.10-FF-000005', NULL, 'MerR family transcriptional regulator', 82, NULL, NULL, 180857),
(180858, '3.30.2160.10-FF-000068', NULL, 'Uncharacterized protein', 38, NULL, NULL, 180858),
(180859, '3.40.50.880-FF-000111', NULL, 'Catalase', 179, NULL, NULL, 180859),
(180860, '3.40.800.20-FF-000023', NULL, 'Histone deacetylase', 388, NULL, NULL, 180860),
(180861, '2.160.20.10-FF-000280', NULL, 'Uncharacterized protein', 214, NULL, NULL, 180861),
(180862, '3.90.79.10-FF-000118', NULL, 'MuT/nudix family protein', 202, NULL, NULL, 180862),
(180863, '3.10.105.10-FF-000058', NULL, 'Oligopeptide transport system binding protein', 143, NULL, NULL, 180863),
(180864, '3.90.550.10-FF-000057', NULL, 'Glycosyltransferase-like protein, family 2', 229, NULL, NULL, 180864),
(180865, '2.130.10.10-FF-005518', NULL, 'Uncharacterized protein', 63, NULL, NULL, 180865),
(180866, '2.130.10.10-FF-001556', NULL, 'Elongator complex protein 2', 155, NULL, NULL, 180866),
(180867, '3.30.420.40-FF-000328', NULL, 'ROK family transcriptional regulator', 115, NULL, NULL, 180867),
(180868, '2.20.70.10-FF-000031', NULL, 'pre-mRNA-processing factor 40 homolog A isoform X1', 44, NULL, NULL, 180868),
(180869, '3.30.40.10-FF-002044', NULL, 'Uncharacterized protein', 94, NULL, NULL, 180869),
(180870, '1.20.1110.10-FF-000271', NULL, NULL, 11, NULL, NULL, 180870),
(180871, '1.25.40.20-FF-001367', NULL, 'Uncharacterized protein', 90, NULL, NULL, 180871),
(180872, '1.25.40.10-FF-001454', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 160, NULL, NULL, 180872),
(180873, '3.40.50.300-FF-001646', NULL, 'Pantothenate kinase', 306, NULL, NULL, 180873),
(180874, '3.60.15.10-FF-000051', NULL, 'Ribonuclease Z, mitochondrial', 241, NULL, NULL, 180874),
(180875, '3.80.10.10-FF-004288', NULL, 'Uncharacterized protein', 240, NULL, NULL, 180875),
(180876, '3.30.40.10-FF-001425', NULL, 'Sister chromatid cohesion protein SCC2', 95, NULL, NULL, 180876),
(180877, '3.30.1360.120-FF-000032', NULL, 'Conserved protein', 339, NULL, NULL, 180877),
(180878, '1.10.150.50-FF-000171', NULL, 'sphingomyelin synthase-related protein 1', 76, NULL, NULL, 180878),
(180879, '1.10.238.20-FF-000039', NULL, 'GM10854', 111, NULL, NULL, 180879),
(180880, '3.40.850.10-FF-000113', NULL, 'Kinesin-like protein', 382, NULL, NULL, 180880),
(180881, '2.60.120.10-FF-000726', NULL, 'Uncharacterized protein', 191, NULL, NULL, 180881);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(180882, '1.10.418.10-FF-000039', NULL, 'Transgelin', 142, NULL, NULL, 180882),
(180883, '2.60.290.11-FF-000003', NULL, 'N-acetylmuramoyl-L-alanine amidase family 2', 90, NULL, NULL, 180883),
(180884, '3.30.200.20-FF-001430', NULL, 'Non-specific serine/threonine protein kinase', 66, NULL, NULL, 180884),
(180885, '2.130.10.10-FF-001247', NULL, 'U3 small nucleolar RNA-interacting protein', 321, NULL, NULL, 180885),
(180886, '3.40.50.1820-FF-000948', NULL, 'Esterase', 300, NULL, NULL, 180886),
(180887, '3.30.420.40-FF-000019', NULL, 'Rod shape-determining protein MreB', 77, NULL, NULL, 180887),
(180888, '3.80.10.10-FF-003344', NULL, 'Centrosomal protein 78', 120, NULL, NULL, 180888),
(180889, '3.30.160.60-FF-006007', NULL, NULL, 38, NULL, NULL, 180889),
(180890, '3.80.10.10-FF-002944', NULL, 'Leucine-rich repeat protein kinase family protein', 49, NULL, NULL, 180890),
(180891, '1.10.630.10-FF-000246', NULL, 'Uncharacterized protein', 317, NULL, NULL, 180891),
(180892, '3.30.160.60-FF-004315', NULL, NULL, 34, NULL, NULL, 180892),
(180893, '1.25.40.10-FF-005164', NULL, 'Predicted protein', 76, NULL, NULL, 180893),
(180894, '3.40.50.300-FF-001270', NULL, 'Thymidine kinase', 134, NULL, NULL, 180894),
(180895, '1.10.150.670-FF-000028', NULL, 'Predicted protein', 89, NULL, NULL, 180895),
(180896, '3.10.180.10-FF-000046', NULL, '4-hydroxyphenylpyruvate dioxygenase', 167, NULL, NULL, 180896),
(180897, '3.80.20.20-FF-000048', NULL, 'Predicted protein', 107, NULL, NULL, 180897),
(180898, '3.40.50.150-FF-000128', NULL, 'DNA (cytosine-5)-methyltransferase', 253, NULL, NULL, 180898),
(180899, '1.10.287.1050-FF-000002', NULL, 'DNA-binding protein', 80, NULL, NULL, 180899),
(180900, '2.60.40.10-FF-001123', NULL, 'Amphoterin-induced protein 1 isoform X2', 87, NULL, NULL, 180900),
(180901, '1.10.540.10-FF-000110', NULL, 'Acyl-CoA dehydrogenase domain protein', 133, NULL, NULL, 180901),
(180902, '1.10.10.60-FF-001236', NULL, NULL, 49, NULL, NULL, 180902),
(180903, '3.10.20.740-FF-000008', NULL, 'Periplasmic [Fe] hydrogenase 1', 121, NULL, NULL, 180903),
(180904, '2.70.170.10-FF-000013', NULL, 'Acetylcholine receptor subunit alpha', 229, NULL, NULL, 180904),
(180905, '3.65.10.10-FF-000001', NULL, 'UDP-N-acetylglucosamine 1-carboxyvinyltransferase', 208, NULL, NULL, 180905),
(180906, '2.60.40.1170-FF-000042', NULL, 'APM2 (YHL019C)', 36, NULL, NULL, 180906),
(180907, '3.60.20.10-FF-000102', NULL, 'Asparagine synthetase', 177, NULL, NULL, 180907),
(180908, '4.10.400.10-FF-000234', NULL, 'LDL receptor repeat-containing protein egg-1', 42, NULL, NULL, 180908),
(180909, '1.10.510.10-FF-004464', NULL, NULL, 278, NULL, NULL, 180909),
(180910, '1.20.1250.20-FF-000918', NULL, 'MFS transporter', 385, NULL, NULL, 180910),
(180911, '1.20.1250.20-FF-000666', NULL, 'MonoCarboxylate Transporter family', 188, NULL, NULL, 180911),
(180912, '3.20.20.10-FF-000019', NULL, 'Putative diaminopimelate decarboxylase', 246, NULL, NULL, 180912),
(180913, '3.40.50.720-FF-000215', NULL, '3-hydroxyacyl-CoA dehydrogenase type-2', 261, NULL, NULL, 180913),
(180914, '1.20.1560.10-FF-000310', NULL, 'HlyB/MsbA family ABC transporter', 318, NULL, NULL, 180914),
(180915, '3.40.50.2300-FF-001610', NULL, NULL, 54, NULL, NULL, 180915),
(180916, '1.10.420.10-FF-000056', NULL, 'Peroxidase 12', 63, NULL, NULL, 180916),
(180917, '2.30.170.20-FF-000014', NULL, '50S ribosomal protein L24e', 58, NULL, NULL, 180917),
(180918, '3.20.20.60-FF-000012', NULL, 'Phosphoenolpyruvate-protein phosphotransferase PtsP', 333, NULL, NULL, 180918),
(180919, '3.30.160.60-FF-006463', NULL, NULL, 28, NULL, NULL, 180919),
(180920, '1.25.10.10-FF-000446', NULL, 'Serine/threonine-protein kinase TOR', 189, NULL, NULL, 180920),
(180921, '3.30.160.60-FF-004681', NULL, NULL, 26, NULL, NULL, 180921),
(180922, '1.25.40.180-FF-000191', NULL, NULL, 161, NULL, NULL, 180922),
(180923, '2.40.10.10-FF-000161', NULL, 'Serine protease DegP', 109, NULL, NULL, 180923),
(180924, '1.10.510.10-FF-002536', NULL, 'BMP-2-inducible protein kinase', 306, NULL, NULL, 180924),
(180925, '3.40.50.10810-FF-000183', NULL, 'Helicase superfamily, c-terminal domain protein', 176, NULL, NULL, 180925);
INSERT INTO "PUBLIC"."MODEL" VALUES
(180926, '3.40.50.2300-FF-001290', NULL, NULL, 144, NULL, NULL, 180926),
(180927, '1.25.40.20-FF-000748', NULL, 'Uncharacterized protein', 211, NULL, NULL, 180927),
(180928, '3.40.50.300-FF-007806', NULL, 'Uncharacterized protein', 36, NULL, NULL, 180928),
(180929, '1.20.5.190-FF-000080', NULL, 'Myosin', 50, NULL, NULL, 180929),
(180930, '3.80.10.10-FF-002579', NULL, 'NLR family CARD domain containing 5', 111, NULL, NULL, 180930),
(180931, '1.25.40.10-FF-004017', NULL, 'Uncharacterized protein', 197, NULL, NULL, 180931),
(180932, '3.40.50.720-FF-001963', NULL, 'NADH dehydrogenase (Ubiquinone) 1 alpha subcomplex 9', 256, NULL, NULL, 180932),
(180933, '1.25.70.10-FF-000011', NULL, 'Mitochondrial transcription termination factor 4', 241, NULL, NULL, 180933),
(180934, '3.30.497.10-FF-000108', NULL, 'Uncharacterized protein', 197, NULL, NULL, 180934),
(180935, '3.30.1460.50-FF-000001', NULL, 'Autophagy-related protein 3', 148, NULL, NULL, 180935),
(180936, '3.40.50.1970-FF-000061', NULL, NULL, 165, NULL, NULL, 180936),
(180937, '1.20.58.120-FF-000007', NULL, 'Starvin, isoform C', 88, NULL, NULL, 180937),
(180938, '3.30.70.260-FF-000117', NULL, 'Ribose 5-phosphate isomerase A, variant', 93, NULL, NULL, 180938),
(180939, '1.10.287.70-FF-000561', NULL, 'Uncharacterized protein', 99, NULL, NULL, 180939),
(180940, '4.10.240.10-FF-000227', NULL, 'Uncharacterized protein', 82, NULL, NULL, 180940),
(180941, '2.20.70.10-FF-000227', NULL, 'Uncharacterized protein', 44, NULL, NULL, 180941),
(180942, '3.90.190.10-FF-000383', NULL, 'Predicted protein', 123, NULL, NULL, 180942),
(180943, '1.25.40.10-FF-004545', NULL, 'Uncharacterized protein', 230, NULL, NULL, 180943),
(180944, '1.25.40.10-FF-003399', NULL, 'Putative pentatricopeptide repeat-containing protein', 131, NULL, NULL, 180944),
(180945, '3.40.630.10-FF-000440', NULL, 'Gll0760 protein', 224, NULL, NULL, 180945),
(180946, '2.130.10.10-FF-005266', NULL, 'Elongator complex protein 2 isoform 2', 257, NULL, NULL, 180946),
(180947, '1.10.10.10-FF-000266', NULL, 'Forkhead box protein L1', 111, NULL, NULL, 180947),
(180948, '3.90.226.10-FF-000023', NULL, 'Carboxyl-terminal processing protease', 161, NULL, NULL, 180948),
(180949, '3.40.30.10-FF-000677', NULL, 'Uncharacterized protein', 11, NULL, NULL, 180949),
(180950, '3.30.70.1020-FF-000003', NULL, 'Alpha,alpha-trehalose-phosphate synthase subunit Tps2', 82, NULL, NULL, 180950),
(180951, '1.25.40.20-FF-000951', NULL, 'GM22773', 120, NULL, NULL, 180951),
(180952, '3.10.10.10-FF-000025', NULL, NULL, 113, NULL, NULL, 180952),
(180953, '3.80.10.10-FF-004491', NULL, 'Uncharacterized protein', 100, NULL, NULL, 180953),
(180954, '2.60.40.1180-FF-000140', NULL, 'Neopullulanase SusA', 77, NULL, NULL, 180954),
(180955, '3.40.50.1000-FF-000057', NULL, 'Copper-exporting P-type ATPase', 167, NULL, NULL, 180955),
(180956, '1.10.3370.10-FF-000034', NULL, 'Sec61 alpha subunit putative', 141, NULL, NULL, 180956),
(180957, '2.130.10.10-FF-003720', NULL, 'Uncharacterized protein', 520, NULL, NULL, 180957),
(180958, '3.30.420.10-FF-000572', NULL, NULL, 243, NULL, NULL, 180958),
(180959, '1.20.120.1080-FF-000116', NULL, 'ATP-dependent RNA helicase', 111, NULL, NULL, 180959),
(180960, '3.40.50.720-FF-002469', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(P)+]', 36, NULL, NULL, 180960),
(180961, '3.80.10.10-FF-003872', NULL, 'Si:ch211-196h24.2', 211, NULL, NULL, 180961),
(180962, '1.20.58.2220-FF-000006', NULL, 'Cytokinesis protein sepA', 360, NULL, NULL, 180962),
(180963, '1.20.1250.20-FF-002358', NULL, 'Uncharacterized protein', 89, NULL, NULL, 180963),
(180964, '3.90.1740.10-FF-000003', NULL, '2'',3''-cyclic nucleotide 3'' phosphodiesterase', 73, NULL, NULL, 180964),
(180965, '1.25.40.10-FF-000274', NULL, 'Tetratricopeptide repeat domain 25', 227, NULL, NULL, 180965),
(180966, '1.20.144.10-FF-000081', NULL, 'Phospholipid phosphatase 2b', 267, NULL, NULL, 180966),
(180967, '1.25.50.20-FF-000092', NULL, 'AER426Cp', 251, NULL, NULL, 180967),
(180968, '2.60.40.150-FF-000227', NULL, 'Metacaspase 1', 129, NULL, NULL, 180968),
(180969, '2.30.40.10-FF-000085', NULL, 'Hydroxydechloroatrazine ethylaminohydrolase', 85, NULL, NULL, 180969); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(180970, '2.60.40.150-FF-000412', NULL, 'Protein CBG04253', 117, NULL, NULL, 180970),
(180971, '1.25.10.10-FF-002138', NULL, 'Uncharacterized protein', 565, NULL, NULL, 180971),
(180972, '2.130.10.10-FF-003265', NULL, 'Transducin, putative', 189, NULL, NULL, 180972),
(180973, '3.30.110.30-FF-000004', NULL, 'Proline--tRNA ligase, chloroplastic/mitochondrial', 72, NULL, NULL, 180973),
(180974, '1.25.10.10-FF-003228', NULL, 'HECT, UBA and WWE domain containing 1 isoform 1 family protein', 258, NULL, NULL, 180974),
(180975, '1.10.238.210-FF-000015', NULL, 'Uncharacterized protein', 80, NULL, NULL, 180975),
(180976, '2.30.30.40-FF-000492', NULL, 'Uncharacterized protein', 116, NULL, NULL, 180976),
(180977, '3.30.9.10-FF-000083', NULL, 'Predicted protein', 161, NULL, NULL, 180977),
(180978, '1.10.10.2740-FF-000007', NULL, 'Uncharacterized protein', 91, NULL, NULL, 180978),
(180979, '3.40.50.300-FF-008425', NULL, 'Uncharacterized protein', 112, NULL, NULL, 180979),
(180980, '2.130.10.10-FF-002175', NULL, 'Hybrid sensor histidine kinase/response regulator', 318, NULL, NULL, 180980),
(180981, '4.10.60.10-FF-000155', NULL, 'tRNA-splicing endonuclease, putative', 47, NULL, NULL, 180981),
(180982, '3.40.50.1000-FF-000585', NULL, NULL, 39, NULL, NULL, 180982),
(180983, '3.50.50.60-FF-001294', NULL, 'Uncharacterized Rab geranylgeranyltransferase C15C4.03', 146, NULL, NULL, 180983),
(180984, '2.60.220.50-FF-000167', NULL, 'Uncharacterized protein', 126, NULL, NULL, 180984),
(180985, '1.10.340.30-FF-000005', NULL, 'Endonuclease III-like protein 1', 104, NULL, NULL, 180985),
(180986, '3.40.50.12650-FF-000038', NULL, 'Uncharacterized protein', 96, NULL, NULL, 180986),
(180987, '1.20.1070.10-FF-001880', NULL, 'Uncharacterized protein', 344, NULL, NULL, 180987),
(180988, '3.40.50.300-FF-002574', NULL, 'Protein CBG27386', 186, NULL, NULL, 180988),
(180989, '1.20.1270.70-FF-000002', NULL, 'Putative secreted protein', 61, NULL, NULL, 180989),
(180990, '1.25.40.10-FF-003056', NULL, 'Putative pentatricopeptide repeat-containing protein At1g10330', 69, NULL, NULL, 180990),
(180991, '4.10.860.130-FF-000002', NULL, '30S ribosomal protein S15', 48, NULL, NULL, 180991),
(180992, '1.20.1070.10-FF-000790', NULL, 'Uncharacterized protein', 325, NULL, NULL, 180992),
(180993, '2.30.29.30-FF-000873', NULL, 'Uncharacterized protein', 120, NULL, NULL, 180993),
(180994, '3.30.70.330-FF-001223', NULL, NULL, 64, NULL, NULL, 180994),
(180995, '2.10.25.10-FF-001298', NULL, 'LP19846p', 39, NULL, NULL, 180995),
(180996, '1.25.40.20-FF-000063', NULL, 'SH3 and multiple ankyrin repeat domains protein 1', 231, NULL, NULL, 180996),
(180997, '2.30.30.40-FF-000020', NULL, 'SH3 and PX domain-containing protein 2A', 65, NULL, NULL, 180997),
(180998, '1.50.10.10-FF-000146', NULL, 'YALI0E05203p', 479, NULL, NULL, 180998),
(180999, '1.10.287.130-FF-000208', NULL, 'Two-component hybrid sensor and regulator', 66, NULL, NULL, 180999),
(181000, '1.10.3260.10-FF-000043', NULL, 'Uncharacterized protein', 261, NULL, NULL, 181000),
(181001, '3.30.1310.10-FF-000007', NULL, 'Nucleoid-associated protein NMC1380', 108, NULL, NULL, 181001),
(181002, '3.30.70.1070-FF-000007', NULL, 'Endolytic peptidoglycan transglycosylase RlpA', 74, NULL, NULL, 181002),
(181003, '1.10.510.10-FF-004245', NULL, NULL, 197, NULL, NULL, 181003),
(181004, '3.40.50.300-FF-005699', NULL, 'Putative apoptotic protease-activating factor', 176, NULL, NULL, 181004),
(181005, '3.30.1120.10-FF-000054', NULL, 'Predicted protein', 68, NULL, NULL, 181005),
(181006, '1.10.287.110-FF-000202', NULL, 'GM24961', 111, NULL, NULL, 181006),
(181007, '3.30.40.10-FF-001572', NULL, 'Uncharacterized protein', 93, NULL, NULL, 181007),
(181008, '1.20.120.1760-FF-000022', NULL, 'CDP-diacylglycerol--serine O-phosphatidyltransferase', 194, NULL, NULL, 181008),
(181009, '3.10.580.10-FF-000048', NULL, 'Chloride channel 2c', 114, NULL, NULL, 181009),
(181010, '2.60.120.380-FF-000029', NULL, 'Microbial collagenase', 98, NULL, NULL, 181010),
(181011, '3.60.40.10-FF-000356', NULL, 'Uncharacterized protein', 301, NULL, NULL, 181011);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(181012, '3.40.50.1110-FF-000163', NULL, 'Uncharacterized protein', 282, NULL, NULL, 181012),
(181013, '3.30.200.20-FF-002048', NULL, 'Uncharacterized protein', 89, NULL, NULL, 181013),
(181014, '3.30.40.10-FF-000279', NULL, 'E3 ubiquitin-protein ligase TRIM37 isoform X1', 90, NULL, NULL, 181014),
(181015, '1.10.630.10-FF-000465', NULL, 'Uncharacterized protein', 102, NULL, NULL, 181015),
(181016, '3.20.20.70-FF-000088', NULL, 'Transaldolase', 322, NULL, NULL, 181016),
(181017, '3.30.60.20-FF-000047', NULL, 'Diacylglycerol kinase', 56, NULL, NULL, 181017),
(181018, '1.10.472.80-FF-000152', NULL, 'Rab-GTPase-TBC domain containing protein, putative', 105, NULL, NULL, 181018),
(181019, '1.20.1070.10-FF-001205', NULL, 'Novel 7 transmembrane receptor (Rhodopsin family)', 120, NULL, NULL, 181019),
(181020, '1.10.1900.10-FF-000013', NULL, 'Polyadenylate-binding protein, putative', 72, NULL, NULL, 181020),
(181021, '2.60.40.150-FF-000070', NULL, 'rab11 family-interacting protein 2 isoform X1', 135, NULL, NULL, 181021),
(181022, '1.20.140.40-FF-000069', NULL, NULL, 105, NULL, NULL, 181022),
(181023, '1.10.10.10-FF-001811', NULL, 'Predicted protein', 43, NULL, NULL, 181023),
(181024, '1.25.40.20-FF-000372', NULL, 'Putative hect e3 ubiquitin ligase', 143, NULL, NULL, 181024),
(181025, '3.40.190.10-FF-000321', NULL, 'ABC transporter, substrate-binding protein, family 5', 30, NULL, NULL, 181025),
(181026, '3.40.120.10-FF-000030', NULL, 'Phosphoglucomutase 2', 111, NULL, NULL, 181026),
(181027, '1.10.10.10-FF-000518', NULL, 'IclR family transcriptional regulator', 72, NULL, NULL, 181027),
(181028, '3.40.640.10-FF-000266', NULL, 'Probable glycine dehydrogenase (decarboxylating) subunit 2', 237, NULL, NULL, 181028),
(181029, '1.10.3860.10-FF-000009', NULL, 'Sodium:proton antiporter', 405, NULL, NULL, 181029),
(181030, '3.90.132.10-FF-000024', NULL, 'Uncharacterized protein', 87, NULL, NULL, 181030),
(181031, '3.80.30.20-FF-000021', NULL, 'MiaB-like tRNA modifying enzyme', 235, NULL, NULL, 181031),
(181032, '3.30.470.160-FF-000003', NULL, 'Kinase', 281, NULL, NULL, 181032),
(181033, '3.30.870.10-FF-000049', NULL, 'Cardiolipin synthetase', 155, NULL, NULL, 181033),
(181034, '3.40.50.1000-FF-000618', NULL, NULL, 237, NULL, NULL, 181034),
(181035, '3.30.930.10-FF-000094', NULL, 'Lysine--tRNA ligase, mitochondrial', 364, NULL, NULL, 181035),
(181036, '3.40.50.1010-FF-000279', NULL, NULL, 69, NULL, NULL, 181036),
(181037, '3.60.10.10-FF-000309', NULL, 'Predicted protein', 300, NULL, NULL, 181037),
(181038, '3.20.20.140-FF-000096', NULL, 'Phosphonate metabolism protein PhnM', 91, NULL, NULL, 181038),
(181039, '1.20.85.10-FF-000011', NULL, 'Uncharacterized protein', 95, NULL, NULL, 181039),
(181040, '3.40.50.620-FF-000320', NULL, 'Isoleucine--tRNA ligase, cytoplasmic', 288, NULL, NULL, 181040),
(181041, '2.60.120.330-FF-000133', NULL, 'Uncharacterized protein', 139, NULL, NULL, 181041),
(181042, '2.40.70.10-FF-000081', NULL, 'Plasmepsin X', 99, NULL, NULL, 181042),
(181043, '3.30.710.10-FF-000420', NULL, 'Uncharacterized protein', 114, NULL, NULL, 181043),
(181044, '3.10.280.10-FF-000008', NULL, 'Mam33p', 224, NULL, NULL, 181044),
(181045, '3.30.200.20-FF-000811', NULL, 'L-type lectin-domain containing receptor kinase V.9', 92, NULL, NULL, 181045),
(181046, '1.20.58.60-FF-000053', NULL, 'Short stop, isoform K', 114, NULL, NULL, 181046),
(181047, '3.10.310.10-FF-000006', NULL, 'Diaminopimelate epimerase', 133, NULL, NULL, 181047),
(181048, '2.60.40.10-FF-001595', NULL, 'V-set and transmembrane domain containing 5', 107, NULL, NULL, 181048),
(181049, '1.10.10.10-FF-001446', NULL, 'ADL176Wp', 71, NULL, NULL, 181049),
(181050, '3.30.70.330-FF-001751', NULL, NULL, 82, NULL, NULL, 181050),
(181051, '1.10.287.80-FF-000002', NULL, 'Lysine-specific histone demethylase 1A', 116, NULL, NULL, 181051),
(181052, '3.30.70.1050-FF-000001', NULL, 'Trigger factor', 115, NULL, NULL, 181052),
(181053, '3.40.50.1820-FF-001005', NULL, 'Uncharacterized protein', 227, NULL, NULL, 181053),
(181054, '3.90.550.50-FF-000243', NULL, 'Uncharacterized protein', 175, NULL, NULL, 181054);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(181055, '3.30.505.10-FF-000269', NULL, NULL, 99, NULL, NULL, 181055),
(181056, '3.40.1110.10-FF-000169', NULL, 'Phospholipid-transporting ATPase', 134, NULL, NULL, 181056),
(181057, '1.20.58.530-FF-000012', NULL, 'unconventional myosin-X', 150, NULL, NULL, 181057),
(181058, '1.10.274.30-FF-000002', NULL, 'male-specific lethal 3 homolog', 100, NULL, NULL, 181058),
(181059, '3.80.10.10-FF-004524', NULL, 'Uncharacterized protein, isoform B', 272, NULL, NULL, 181059),
(181060, '3.30.70.1230-FF-000078', NULL, 'Adenylyl CYclase', 208, NULL, NULL, 181060),
(181061, '3.30.900.10-FF-000047', NULL, 'MAD (Yeast Mitosis arrest DeFicient) related', 139, NULL, NULL, 181061),
(181062, '1.10.30.10-FF-000065', NULL, 'Nhp10p', 111, NULL, NULL, 181062),
(181063, '3.30.710.10-FF-000111', NULL, 'rho-related BTB domain-containing protein 3 isoform X1', 151, NULL, NULL, 181063),
(181064, '2.60.120.650-FF-000133', NULL, 'Uncharacterized protein', 284, NULL, NULL, 181064),
(181065, '1.10.260.170-FF-000010', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', 160, NULL, NULL, 181065),
(181066, '3.40.1090.10-FF-000144', NULL, 'Uncharacterized protein', 73, NULL, NULL, 181066),
(181067, '1.50.40.10-FF-000226', NULL, 'Mitochondrial carrier protein-like protein', 192, NULL, NULL, 181067),
(181068, '3.30.1380.20-FF-000054', NULL, 'Trafficking protein particle complex 6b-like', 54, NULL, NULL, 181068),
(181069, '3.40.30.10-FF-000929', NULL, 'Iodothyronine deiodinase', 121, NULL, NULL, 181069),
(181070, '3.40.50.1820-FF-001713', NULL, 'Uncharacterized protein', 142, NULL, NULL, 181070),
(181071, '3.80.10.10-FF-000781', NULL, 'PH domain and leucine rich repeat protein phosphatase 1', 203, NULL, NULL, 181071),
(181072, '1.25.40.10-FF-004236', NULL, 'At4g28200', 388, NULL, NULL, 181072),
(181073, '3.30.70.330-FF-001442', NULL, 'LD15419p', 56, NULL, NULL, 181073),
(181074, '3.40.50.300-FF-007121', NULL, 'Septin homolog spn6', 293, NULL, NULL, 181074),
(181075, '3.30.160.60-FF-005299', NULL, NULL, 83, NULL, NULL, 181075),
(181076, '4.10.800.10-FF-000001', NULL, 'Testican-3 isoform 2', 68, NULL, NULL, 181076),
(181077, '1.20.20.10-FF-000007', NULL, 'ATP synthase subunit c', 69, NULL, NULL, 181077),
(181078, '1.20.58.80-FF-000059', NULL, 'STAM binding protein like 1', 79, NULL, NULL, 181078),
(181079, '3.30.559.30-FF-000074', NULL, 'Enniatin synthetase', 239, NULL, NULL, 181079),
(181080, '3.30.200.20-FF-000250', NULL, 'Serine/threonine-protein kinase', 108, NULL, NULL, 181080),
(181081, '3.90.1430.10-FF-000013', NULL, NULL, 112, NULL, NULL, 181081),
(181082, '2.60.40.10-FF-005086', NULL, NULL, 100, NULL, NULL, 181082),
(181083, '3.40.630.30-FF-000451', NULL, 'Acetyltransferase PA2578', 186, NULL, NULL, 181083),
(181084, '3.40.50.2300-FF-000121', NULL, 'Sensor histidine kinase RcsC', 132, NULL, NULL, 181084),
(181085, '2.60.34.10-FF-000030', NULL, 'Heat shock protein family A (Hsp70) member 4 like', 157, NULL, NULL, 181085),
(181086, '2.70.160.11-FF-000093', NULL, 'Uncharacterized protein', 177, NULL, NULL, 181086),
(181087, '1.25.40.510-FF-000003', NULL, 'Nucleoporin GLE1', 288, NULL, NULL, 181087),
(181088, '3.90.70.10-FF-000705', NULL, 'Uncharacterized protein', 212, NULL, NULL, 181088),
(181089, '3.30.70.330-FF-002712', NULL, NULL, 105, NULL, NULL, 181089),
(181090, '3.40.50.2060-FF-000015', NULL, 'Carnation, isoform C', 140, NULL, NULL, 181090),
(181091, '2.40.110.10-FF-000056', NULL, 'Putative acyl CoA oxidase', 133, NULL, NULL, 181091),
(181092, '3.40.50.300-FF-002826', NULL, 'ABC transporter ATP-binding protein', 221, NULL, NULL, 181092),
(181093, '3.10.100.10-FF-000182', NULL, 'GD10399', 128, NULL, NULL, 181093),
(181094, '3.40.50.720-FF-001199', NULL, 'Short-chain alcohol dehydrogenase', 261, NULL, NULL, 181094),
(181095, '2.60.120.10-FF-000147', NULL, '2-oxoglutarate (2OG) and Fe(II)-dependent oxygenase superfamily protein', 340, NULL, NULL, 181095),
(181096, '1.10.287.470-FF-000057', NULL, 'Disks large homolog 1', 50, NULL, NULL, 181096),
(181097, '3.40.50.300-FF-002118', NULL, 'Obg family GTPase CgtA', 110, NULL, NULL, 181097);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(181098, '3.30.499.10-FF-000023', NULL, '3-isopropylmalate dehydratase', 171, NULL, NULL, 181098),
(181099, '3.10.20.90-FF-000420', NULL, 'Phosphatidylinositol 3-kinase 1, putative', 182, NULL, NULL, 181099),
(181100, '3.60.10.10-FF-000276', NULL, 'Uncharacterized protein DDB_G0272682', 284, NULL, NULL, 181100),
(181101, '2.40.50.40-FF-000077', NULL, 'Chemokine (C-C motif) ligand 35, duplicate 1', 71, NULL, NULL, 181101),
(181102, '3.60.21.10-FF-000228', NULL, 'Sphingomyelin phosphodiesterase', 78, NULL, NULL, 181102),
(181103, '1.20.58.60-FF-000429', NULL, 'Beta-H spectrin', 104, NULL, NULL, 181103),
(181104, '2.60.120.200-FF-000330', NULL, 'Protein tyrosine phosphatase, receptor type U', 114, NULL, NULL, 181104),
(181105, '3.40.630.10-FF-000108', NULL, 'carboxypeptidase B', 301, NULL, NULL, 181105),
(181106, '2.60.40.10-FF-002213', NULL, 'Myotactin form B', 101, NULL, NULL, 181106),
(181107, '3.40.1360.10-FF-000013', NULL, 'Plastid replication-repair enzyme', 114, NULL, NULL, 181107),
(181108, '2.20.110.10-FF-000066', NULL, NULL, 53, NULL, NULL, 181108),
(181109, '1.50.40.10-FF-000535', NULL, 'Uncharacterized protein', 154, NULL, NULL, 181109),
(181110, '3.40.50.200-FF-000060', NULL, 'Tripeptidyl peptidase I', 445, NULL, NULL, 181110),
(181111, '3.40.30.10-FF-000368', NULL, 'Thioredoxin', 101, NULL, NULL, 181111),
(181112, '3.30.70.330-FF-002403', NULL, NULL, 94, NULL, NULL, 181112),
(181113, '3.30.70.330-FF-002151', NULL, NULL, 112, NULL, NULL, 181113),
(181114, '3.40.50.1010-FF-000155', NULL, NULL, 44, NULL, NULL, 181114),
(181115, '3.20.20.70-FF-000577', NULL, NULL, 222, NULL, NULL, 181115),
(181116, '2.130.10.10-FF-002736', NULL, 'Uncharacterized protein', 283, NULL, NULL, 181116),
(181117, '1.25.10.10-FF-000901', NULL, 'Sister chromatid cohesion protein PDS5 homolog B-A', 163, NULL, NULL, 181117),
(181118, '2.60.40.10-FF-005647', NULL, NULL, 92, NULL, NULL, 181118),
(181119, '1.10.10.440-FF-000025', NULL, 'Uncharacterized protein, isoform C', 63, NULL, NULL, 181119),
(181120, '1.10.238.10-FF-000705', NULL, 'Uncharacterized protein', 71, NULL, NULL, 181120),
(181121, '1.20.5.340-FF-000068', NULL, 'myosin-9 isoform X2', 120, NULL, NULL, 181121),
(181122, '2.60.120.10-FF-000456', NULL, 'Uncharacterized protein', 158, NULL, NULL, 181122),
(181123, '1.20.1250.10-FF-000101', NULL, NULL, 161, NULL, NULL, 181123),
(181124, '2.60.40.10-FF-002663', NULL, 'Immunoglobulin superfamily, member 8', 118, NULL, NULL, 181124),
(181125, '3.30.559.30-FF-000079', NULL, 'Non-ribosomal peptide synthetase', 223, NULL, NULL, 181125),
(181126, '3.40.50.170-FF-000022', NULL, 'Related to glycinamide ribonucleotide transformylase', 255, NULL, NULL, 181126),
(181127, '2.60.120.370-FF-000010', NULL, 'Flagellar motor-switch protein', 171, NULL, NULL, 181127),
(181128, '3.30.9.10-FF-000066', NULL, 'L-2-hydroxyglutarate dehydrogenase, mitochondrial', 162, NULL, NULL, 181128),
(181129, '1.20.140.150-FF-000071', NULL, 'Protein CBG10848', 175, NULL, NULL, 181129),
(181130, '3.40.640.10-FF-000283', NULL, 'O-acetyl-L-homoserine sulfhydrylase', 282, NULL, NULL, 181130),
(181131, '3.30.499.10-FF-000034', NULL, NULL, 90, NULL, NULL, 181131),
(181132, '3.40.50.10190-FF-000154', NULL, 'FI02888p', 123, NULL, NULL, 181132),
(181133, '3.40.50.300-FF-000893', NULL, 'Interferon-induced with helicase C domain 1', 262, NULL, NULL, 181133),
(181134, '3.30.160.60-FF-002096', NULL, 'Zinc finger protein 473', 31, NULL, NULL, 181134),
(181135, '1.25.40.10-FF-003039', NULL, 'Os04g0221300 protein', 94, NULL, NULL, 181135),
(181136, '1.20.1280.50-FF-000042', NULL, 'F-box protein 31', 61, NULL, NULL, 181136),
(181137, '3.60.15.10-FF-000040', NULL, 'Beta-lactamase', 229, NULL, NULL, 181137),
(181138, '3.30.565.10-FF-000014', NULL, 'Mismatch repair endonuclease pms1, putative', 220, NULL, NULL, 181138),
(181139, '2.40.50.140-FF-000236', NULL, '30S ribosomal protein S17', 100, NULL, NULL, 181139),
(181140, '3.40.50.1000-FF-000714', NULL, NULL, 96, NULL, NULL, 181140),
(181141, '2.40.20.10-FF-000010', NULL, 'Neurotrypsin', 76, NULL, NULL, 181141);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(181142, '3.30.160.60-FF-005855', NULL, NULL, 66, NULL, NULL, 181142),
(181143, '3.80.10.10-FF-003321', NULL, 'Si:ch73-233m11.2', 202, NULL, NULL, 181143),
(181144, '1.10.1200.10-FF-000016', NULL, 'Non-ribosomal peptide synthase', 86, NULL, NULL, 181144),
(181145, '3.80.10.10-FF-002815', NULL, 'Leucine-rich repeat-containing protein 10', 248, NULL, NULL, 181145),
(181146, '3.30.750.24-FF-000071', NULL, 'Anti-sigma factor antagonist', 114, NULL, NULL, 181146),
(181147, '3.50.50.60-FF-001417', NULL, 'Amine oxidase', 129, NULL, NULL, 181147),
(181148, '1.25.40.20-FF-000400', NULL, 'Serine/threonine-protein phosphatase 6 regulatory ankyrin repeat subunit A', 139, NULL, NULL, 181148),
(181149, '2.120.10.80-FF-000228', NULL, 'Predicted protein', 275, NULL, NULL, 181149),
(181150, '2.70.150.10-FF-000029', NULL, 'Calcium-transporting ATPase', 143, NULL, NULL, 181150),
(181151, '3.30.56.10-FF-000040', NULL, 'Phenylalanyl-tRNA synthetase (Beta subunit), putative', 73, NULL, NULL, 181151),
(181152, '2.60.40.10-FF-001140', NULL, 'Down syndrome cell adhesion molecule-like protein Dscam2', 102, NULL, NULL, 181152),
(181153, '1.25.40.10-FF-000285', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 102, NULL, NULL, 181153),
(181154, '2.60.40.1180-FF-000016', NULL, 'Alpha-mannosidase', 93, NULL, NULL, 181154),
(181155, '2.70.130.10-FF-000016', NULL, 'Insulin-like growth factor 2 receptor', 146, NULL, NULL, 181155),
(181156, '1.10.510.10-FF-003716', NULL, NULL, 158, NULL, NULL, 181156),
(181157, '2.70.170.10-FF-000030', NULL, 'AcetylCholine Receptor', 213, NULL, NULL, 181157),
(181158, '4.10.1240.10-FF-000027', NULL, 'Pituitary adenylate cyclase-activating polypeptide type I receptor isoform A', 111, NULL, NULL, 181158),
(181159, '1.10.8.270-FF-000151', NULL, 'Predicted protein', 116, NULL, NULL, 181159),
(181160, '3.80.10.10-FF-001085', NULL, 'Leucine-rich repeat protein soc-2', 166, NULL, NULL, 181160),
(181161, '1.20.1740.10-FF-000217', NULL, 'Uncharacterized protein', 90, NULL, NULL, 181161),
(181162, '3.30.70.330-FF-003128', NULL, NULL, 97, NULL, NULL, 181162),
(181163, '2.60.40.10-FF-005417', NULL, NULL, 82, NULL, NULL, 181163),
(181164, '3.40.50.300-FF-007930', NULL, 'Type III restriction enzyme, res subunit family protein', 173, NULL, NULL, 181164),
(181165, '3.40.50.300-FF-000904', NULL, 'ABC transporter A family member 1', 250, NULL, NULL, 181165),
(181166, '4.10.280.10-FF-000117', NULL, 'Os01g0108400 protein', 78, NULL, NULL, 181166),
(181167, '3.90.1290.10-FF-000058', NULL, 'Microtubule-actin crosslinking factor 1', 65, NULL, NULL, 181167),
(181168, '3.30.1550.10-FF-000002', NULL, '60S ribosomal protein L12', 80, NULL, NULL, 181168),
(181169, '2.70.98.30-FF-000031', NULL, 'Predicted protein', 98, NULL, NULL, 181169),
(181170, '2.70.150.10-FF-000130', NULL, 'Phospholipid-transporting ATPase', 161, NULL, NULL, 181170),
(181171, '2.40.40.10-FF-000005', NULL, 'Barwin-related endoglucanase', 107, NULL, NULL, 181171),
(181172, '3.40.50.10490-FF-000137', NULL, NULL, 150, NULL, NULL, 181172),
(181173, '3.20.20.70-FF-000560', NULL, 'Ferredoxin-dependent glutamate synthase GlsF', 352, NULL, NULL, 181173),
(181174, '2.10.110.10-FF-000315', NULL, 'Uncharacterized protein', 47, NULL, NULL, 181174),
(181175, '3.40.50.300-FF-001410', NULL, 'Primosomal protein N''', 182, NULL, NULL, 181175),
(181176, '3.30.1150.10-FF-000005', NULL, 'Protein TonB', 142, NULL, NULL, 181176),
(181177, '1.10.287.70-FF-000100', NULL, 'Cyclic nucleotide-gated cation channel', 235, NULL, NULL, 181177),
(181178, '2.130.10.10-FF-002315', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', 230, NULL, NULL, 181178),
(181179, '1.10.472.10-FF-000064', NULL, 'Cyclin O', 118, NULL, NULL, 181179),
(181180, '1.20.5.1700-FF-000002', NULL, 'Huntingtin interacting protein 1', 113, NULL, NULL, 181180),
(181181, '3.30.70.1730-FF-000008', NULL, '50S ribosomal protein L10', 128, NULL, NULL, 181181),
(181182, '3.30.450.20-FF-000285', NULL, 'Methyl-accepting chemotaxis protein', 111, NULL, NULL, 181182);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(181183, '3.30.70.1180-FF-000012', NULL, 'V-type proton ATPase subunit C', 58, NULL, NULL, 181183),
(181184, '3.30.40.10-FF-001347', NULL, 'E3 ubiquitin-protein ligase LubX', 108, NULL, NULL, 181184),
(181185, '3.40.50.150-FF-000707', NULL, 'Zgc:113054', 237, NULL, NULL, 181185),
(181186, '3.30.70.1710-FF-000002', NULL, 'Ethanolamine utilization protein EutS', 111, NULL, NULL, 181186),
(181187, '3.40.50.300-FF-002450', NULL, 'Predicted protein', 226, NULL, NULL, 181187),
(181188, '3.40.50.1100-FF-000177', NULL, 'Pyridoxal-phosphate dependent enzyme', 200, NULL, NULL, 181188),
(181189, '3.40.630.30-FF-000215', NULL, 'N-alpha-acetyltransferase 50 isoform X2', 127, NULL, NULL, 181189),
(181190, '3.90.70.10-FF-000817', NULL, 'Uncharacterized protein', 199, NULL, NULL, 181190),
(181191, '3.40.50.2000-FF-000334', NULL, 'Glycosyl transferase', 195, NULL, NULL, 181191),
(181192, '1.10.238.10-FF-000941', NULL, 'Calcium-binding protein B', 128, NULL, NULL, 181192),
(181193, '3.30.200.20-FF-001082', NULL, 'Protein kinase domain containing protein', 101, NULL, NULL, 181193),
(181194, '1.10.8.10-FF-000186', NULL, 'Tyrosine kinase, non-receptor, 2b', 57, NULL, NULL, 181194),
(181195, '3.30.930.10-FF-000419', NULL, 'Uncharacterized protein', 273, NULL, NULL, 181195),
(181196, '1.20.1270.60-FF-000117', NULL, 'SynDaPiN (Synaptic dynamin binding protein) homolog', 286, NULL, NULL, 181196),
(181197, '1.10.246.10-FF-000010', NULL, 'Vitamin D-binding protein', 88, NULL, NULL, 181197),
(181198, '2.60.120.620-FF-000118', NULL, 'Predicted protein', 152, NULL, NULL, 181198),
(181199, '2.40.160.60-FF-000012', NULL, 'Uncharacterized protein', 386, NULL, NULL, 181199),
(181200, '3.10.100.10-FF-000070', NULL, 'Low affinity immunoglobulin epsilon Fc receptor', 133, NULL, NULL, 181200),
(181201, '3.40.50.2300-FF-001615', NULL, NULL, 34, NULL, NULL, 181201),
(181202, '1.50.10.20-FF-000059', NULL, 'Complement C3', 92, NULL, NULL, 181202),
(181203, '3.40.720.10-FF-000328', NULL, 'Uncharacterized protein HI_1316', 129, NULL, NULL, 181203),
(181204, '3.40.50.2300-FF-000789', NULL, NULL, 140, NULL, NULL, 181204),
(181205, '3.40.50.1780-FF-000015', NULL, 'Cytosolic Fe-S cluster assembly factor nar1', 20, NULL, NULL, 181205),
(181206, '3.20.20.140-FF-000315', NULL, 'Predicted protein', 295, NULL, NULL, 181206),
(181207, '2.60.210.10-FF-000025', NULL, 'BTB and MATH domain containing', 142, NULL, NULL, 181207),
(181208, '2.60.40.60-FF-000284', NULL, 'Cadherin 96Cb, isoform B', 103, NULL, NULL, 181208),
(181209, '1.10.150.50-FF-000069', NULL, 'mitochondrial import inner membrane translocase subunit TIM22-like', 60, NULL, NULL, 181209),
(181210, '1.20.1070.10-FF-002032', NULL, 'Uncharacterized protein', 280, NULL, NULL, 181210),
(181211, '3.10.20.90-FF-000173', NULL, 'Tubulin-specific chaperone E', 89, NULL, NULL, 181211),
(181212, '1.25.40.180-FF-000168', NULL, NULL, 203, NULL, NULL, 181212),
(181213, '1.10.510.10-FF-000962', NULL, 'Activated met oncogene, putative', 200, NULL, NULL, 181213),
(181214, '2.130.10.10-FF-000387', NULL, 'intraflagellar transport protein 172 homolog', 242, NULL, NULL, 181214),
(181215, '3.40.470.10-FF-000011', NULL, 'Uracil-DNA glycosylase', 218, NULL, NULL, 181215),
(181216, '1.20.58.390-FF-000251', NULL, 'Uncharacterized protein', 176, NULL, NULL, 181216),
(181217, '1.20.1560.10-FF-000771', NULL, 'Uncharacterized protein', 362, NULL, NULL, 181217),
(181218, '1.10.275.20-FF-000007', NULL, NULL, 46, NULL, NULL, 181218),
(181219, '3.40.30.10-FF-000132', NULL, 'SH3 domain-binding glutamic acid-rich-like protein 3', 93, NULL, NULL, 181219),
(181220, '3.90.1150.10-FF-000211', NULL, 'Aspartate aminotransferase', 115, NULL, NULL, 181220),
(181221, '3.40.50.300-FF-003647', NULL, 'DNA helicase', 194, NULL, NULL, 181221),
(181222, '2.10.25.10-FF-001085', NULL, 'Uncharacterized protein', 86, NULL, NULL, 181222),
(181223, '2.60.11.10-FF-000005', NULL, 'Cytochrome c oxidase subunit 5b', 91, NULL, NULL, 181223),
(181224, '3.20.20.10-FF-000014', NULL, 'Pyridoxal phosphate homeostasis protein', 243, NULL, NULL, 181224);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(181225, '1.10.287.110-FF-000433', NULL, 'Predicted protein', 81, NULL, NULL, 181225),
(181226, '1.10.238.200-FF-000029', NULL, 'Defective in cullin neddylation protein', 81, NULL, NULL, 181226),
(181227, '3.30.1330.30-FF-000109', NULL, 'Os01g0924800 protein', 158, NULL, NULL, 181227),
(181228, '1.10.510.10-FF-001367', NULL, 'Serine kinase-like protein', 76, NULL, NULL, 181228),
(181229, '3.90.70.10-FF-000722', NULL, 'Uncharacterized protein', 192, NULL, NULL, 181229),
(181230, '3.30.160.60-FF-004006', NULL, NULL, 26, NULL, NULL, 181230),
(181231, '3.40.1700.10-FF-000001', NULL, 'DNA integrity scanning protein DisA', 136, NULL, NULL, 181231),
(181232, '2.130.10.10-FF-001798', NULL, 'Hypothetical_protein_-_conserved', 187, NULL, NULL, 181232),
(181233, '3.30.60.20-FF-000148', NULL, 'Diacylglycerol kinase', 65, NULL, NULL, 181233),
(181234, '3.30.420.40-FF-000564', NULL, 'Glycerol kinase 5', 179, NULL, NULL, 181234),
(181235, '1.10.630.10-FF-000797', NULL, 'Uncharacterized protein', 88, NULL, NULL, 181235),
(181236, '3.80.10.10-FF-002023', NULL, 'Leucine-rich repeat-like protein', 151, NULL, NULL, 181236),
(181237, '3.30.1390.30-FF-000006', NULL, 'Peptidoglycan D,D-transpeptidase MrdA', 76, NULL, NULL, 181237),
(181238, '3.90.1410.10-FF-000147', NULL, 'Predicted protein', 264, NULL, NULL, 181238),
(181239, '3.30.50.10-FF-000105', NULL, 'Uncharacterized protein', 74, NULL, NULL, 181239),
(181240, '3.30.420.10-FF-000128', NULL, 'Poly(A)-specific ribonuclease PARN', 167, NULL, NULL, 181240),
(181241, '2.30.42.10-FF-000145', NULL, 'serine protease HTRA2, mitochondrial', 100, NULL, NULL, 181241),
(181242, '3.40.718.10-FF-000059', NULL, 'Isocitrate dehydrogenase [NAD] subunit, mitochondrial', 269, NULL, NULL, 181242),
(181243, '2.30.30.30-FF-000034', NULL, '50S ribosomal protein L2', 78, NULL, NULL, 181243),
(181244, '2.10.70.10-FF-000104', NULL, 'Complement component 4 binding protein beta', 57, NULL, NULL, 181244),
(181245, '3.30.2020.30-FF-000030', NULL, 'AGAP005447-PA', 90, NULL, NULL, 181245),
(181246, '3.30.420.40-FF-000204', NULL, 'Actin, epsilon 1', 109, NULL, NULL, 181246),
(181247, '3.40.50.10860-FF-000057', NULL, 'Uncharacterized protein', 140, NULL, NULL, 181247),
(181248, '3.40.50.1400-FF-000047', NULL, 'Ferrochelatase-like protein', 43, NULL, NULL, 181248),
(181249, '1.25.40.10-FF-004337', NULL, 'Pentatricopeptide repeat-containing protein', 164, NULL, NULL, 181249),
(181250, '3.30.160.60-FF-004445', NULL, NULL, 24, NULL, NULL, 181250),
(181251, '3.30.830.10-FF-000053', NULL, 'Falcilysin', 277, NULL, NULL, 181251),
(181252, '1.25.40.10-FF-003848', NULL, 'CCR4-NOT transcription complex subunit 10 homolog-like Protein', 115, NULL, NULL, 181252),
(181253, '1.10.1060.10-FF-000027', NULL, 'FAD linked oxidase domain protein', 109, NULL, NULL, 181253),
(181254, '3.40.50.12100-FF-000002', NULL, 'Uncharacterized protein, isoform B', 148, NULL, NULL, 181254),
(181255, '3.60.40.10-FF-000345', NULL, 'Uncharacterized protein', 105, NULL, NULL, 181255),
(181256, '1.20.120.350-FF-000059', NULL, 'Sodium channel protein', 121, NULL, NULL, 181256),
(181257, '1.25.40.70-FF-000033', NULL, 'Uncharacterized protein', 232, NULL, NULL, 181257),
(181258, '2.30.29.30-FF-001149', NULL, 'Uncharacterized protein', 174, NULL, NULL, 181258),
(181259, '3.40.50.80-FF-000204', NULL, 'Uncharacterized protein', 57, NULL, NULL, 181259),
(181260, '3.30.70.20-FF-000076', NULL, 'CoB--CoM heterodisulfide reductase iron-sulfur subunit A', 55, NULL, NULL, 181260),
(181261, '3.30.420.10-FF-000679', NULL, NULL, 162, NULL, NULL, 181261),
(181262, '3.20.20.100-FF-000202', NULL, 'Uncharacterized protein', 96, NULL, NULL, 181262),
(181263, '2.170.300.10-FF-000085', NULL, 'Uncharacterized protein', 109, NULL, NULL, 181263),
(181264, '2.60.120.260-FF-000218', NULL, 'Uncharacterized protein, isoform D', 222, NULL, NULL, 181264),
(181265, '1.20.1070.10-FF-000587', NULL, 'Uncharacterized protein', 177, NULL, NULL, 181265),
(181266, '3.40.190.10-FF-000080', NULL, 'Spermidine/putrescine ABC transporter substrate-binding protein', 139, NULL, NULL, 181266);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(181267, '3.10.170.20-FF-000003', NULL, 'GP63-like', 171, NULL, NULL, 181267),
(181268, '1.20.1530.20-FF-000042', NULL, 'Cation/H(+) antiporter 14', 405, NULL, NULL, 181268),
(181269, '2.80.10.50-FF-000160', NULL, 'Dolichyl-phosphate-mannose--protein mannosyltransferase 5', 213, NULL, NULL, 181269),
(181270, '2.60.40.4370-FF-000007', NULL, 'General transcription factor 3C polypeptide 6', 110, NULL, NULL, 181270),
(181271, '3.40.50.300-FF-006502', NULL, 'Uncharacterized protein', 114, NULL, NULL, 181271),
(181272, '3.30.40.10-FF-000728', NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', 89, NULL, NULL, 181272),
(181273, '1.20.1070.10-FF-000475', NULL, 'Uncharacterized protein', 315, NULL, NULL, 181273),
(181274, '3.30.40.10-FF-001217', NULL, 'E3 ubiquitin-protein ligase TTC3 isoform X3', 87, NULL, NULL, 181274),
(181275, '2.160.10.10-FF-000015', NULL, 'Serine acetyltransferase, plasmid', 110, NULL, NULL, 181275),
(181276, '2.10.70.10-FF-000093', NULL, 'Complement component C6', 68, NULL, NULL, 181276),
(181277, '3.40.50.300-FF-002821', NULL, 'Multidrug resistance-associated protein 1', 240, NULL, NULL, 181277),
(181278, '3.40.50.1240-FF-000218', NULL, NULL, 185, NULL, NULL, 181278),
(181279, '1.20.1270.20-FF-000004', NULL, 'Hydroxylamine reductase', 85, NULL, NULL, 181279),
(181280, '1.10.150.50-FF-000199', NULL, 'NGFI-A-binding protein 1a (EGR1 binding protein 1)', 77, NULL, NULL, 181280),
(181281, '1.10.10.10-FF-001671', NULL, 'Rrf2 family protein', 136, NULL, NULL, 181281),
(181282, '1.10.132.60-FF-000025', NULL, 'DNA-directed DNA polymerase', 153, NULL, NULL, 181282),
(181283, '3.40.50.410-FF-000145', NULL, 'Telomerase-associated protein 1', 213, NULL, NULL, 181283),
(181284, '2.60.120.330-FF-000138', NULL, 'Putative 2og-fe oxygenase protein', 196, NULL, NULL, 181284),
(181285, '3.40.390.10-FF-000061', NULL, 'Related to mitochondrial intermediate peptidase', 90, NULL, NULL, 181285),
(181286, '1.25.40.20-FF-001709', NULL, 'LOC100005699 protein', 51, NULL, NULL, 181286),
(181287, '3.50.50.60-FF-001322', NULL, 'Uncharacterized protein', 157, NULL, NULL, 181287),
(181288, '3.40.50.1000-FF-000377', NULL, 'Hydrolase (HAD superfamily)', 73, NULL, NULL, 181288),
(181289, '2.60.40.640-FF-000037', NULL, 'Arrestin 3a, retinal (X-arrestin)', 183, NULL, NULL, 181289),
(181290, '2.30.30.40-FF-000604', NULL, 'Predicted protein', 57, NULL, NULL, 181290),
(181291, '2.60.260.20-FF-000065', NULL, 'Xdj1p', 80, NULL, NULL, 181291),
(181292, '3.90.660.10-FF-000020', NULL, 'Peroxisomal N(1)-acetyl-spermine/spermidine oxidase', 228, NULL, NULL, 181292),
(181293, '3.30.930.10-FF-000307', NULL, 'Uncharacterized protein', 91, NULL, NULL, 181293),
(181294, '3.10.28.10-FF-000004', NULL, 'Probable cell division protein WhiA', 209, NULL, NULL, 181294),
(181295, '1.10.530.10-FF-000053', NULL, 'Basic endochitinase 1', 216, NULL, NULL, 181295),
(181296, '1.10.540.10-FF-000138', NULL, 'Uncharacterized protein', 64, NULL, NULL, 181296),
(181297, '3.90.79.10-FF-000242', NULL, 'Gll1085 protein', 178, NULL, NULL, 181297),
(181298, '2.30.180.10-FF-000175', NULL, NULL, 46, NULL, NULL, 181298),
(181299, '3.30.160.60-FF-004557', NULL, NULL, 27, NULL, NULL, 181299),
(181300, '3.30.310.10-FF-000007', NULL, 'TATA-box-binding protein', 78, NULL, NULL, 181300),
(181301, '3.40.50.2300-FF-000677', NULL, 'Gamma-aminobutyric acid type B receptor subunit 2', 167, NULL, NULL, 181301),
(181302, '2.60.60.20-FF-000054', NULL, NULL, 110, NULL, NULL, 181302),
(181303, '2.130.10.10-FF-004653', NULL, 'Uncharacterized protein', 189, NULL, NULL, 181303),
(181304, '1.10.510.10-FF-000850', NULL, 'PRKACB isoform 14', 87, NULL, NULL, 181304),
(181305, '2.60.120.20-FF-000021', NULL, NULL, 180, NULL, NULL, 181305),
(181306, '3.30.160.60-FF-003826', NULL, NULL, 30, NULL, NULL, 181306),
(181307, '3.90.100.10-FF-000001', NULL, 'Lysine decarboxylase, inducible', 118, NULL, NULL, 181307),
(181308, '2.60.40.790-FF-000054', NULL, '17.4 kDa class III heat shock protein isoform A', 151, NULL, NULL, 181308),
(181309, '1.25.40.20-FF-001923', NULL, 'Ion channel NompC', 250, NULL, NULL, 181309); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(181310, '2.40.30.10-FF-000516', NULL, 'Elongation factor G', 114, NULL, NULL, 181310),
(181311, '1.10.287.1490-FF-000111', NULL, 'Uncharacterized protein', 153, NULL, NULL, 181311),
(181312, '3.40.50.300-FF-001298', NULL, 'Type VII secretion protein EccC', 301, NULL, NULL, 181312),
(181313, '3.20.70.20-FF-000054', NULL, 'Predicted protein', 141, NULL, NULL, 181313),
(181314, '1.20.1250.20-FF-000790', NULL, 'Solute carrier family 2 member 10', 340, NULL, NULL, 181314),
(181315, '1.20.1270.60-FF-000229', NULL, 'Sdpn-1', 287, NULL, NULL, 181315),
(181316, '1.10.510.10-FF-004222', NULL, NULL, 208, NULL, NULL, 181316),
(181317, '1.10.287.110-FF-000303', NULL, 'Predicted protein', 66, NULL, NULL, 181317),
(181318, '3.40.140.10-FF-000138', NULL, 'Mov34/MPN/PAD-1 metallopeptidase, putative', 183, NULL, NULL, 181318),
(181319, '2.60.40.10-FF-004006', NULL, NULL, 126, NULL, NULL, 181319),
(181320, '1.25.40.10-FF-002651', NULL, 'Uncharacterized protein', 223, NULL, NULL, 181320),
(181321, '3.40.50.300-FF-000112', NULL, 'Eukaryotic translation initiation factor 5B', 231, NULL, NULL, 181321),
(181322, '3.40.50.300-FF-007593', NULL, 'Putative uridine kinase C227.14', 169, NULL, NULL, 181322),
(181323, '1.10.10.10-FF-000726', NULL, 'Adenosine deaminase, RNA-specific', 75, NULL, NULL, 181323),
(181324, '2.60.120.40-FF-000027', NULL, 'CD70 antigen', 147, NULL, NULL, 181324),
(181325, '2.60.40.10-FF-000634', NULL, 'Interleukin 1 receptor accessory protein', 102, NULL, NULL, 181325),
(181326, '3.20.20.80-FF-000658', NULL, 'Uncharacterized protein', 61, NULL, NULL, 181326),
(181327, '3.30.1330.30-FF-000014', NULL, 'RNA methyltransferase, TrmH family, group 3', 74, NULL, NULL, 181327),
(181328, '3.90.1150.10-FF-000323', NULL, 'Serine hydroxymethyltransferase', 161, NULL, NULL, 181328),
(181329, '3.40.50.300-FF-003759', NULL, 'Predicted protein', 266, NULL, NULL, 181329),
(181330, '3.40.50.720-FF-001188', NULL, '3-hydroxybutyrate dehydrogenase, putative', 260, NULL, NULL, 181330),
(181331, '1.20.5.110-FF-000016', NULL, 'Syntaxin 12', 107, NULL, NULL, 181331),
(181332, '1.20.1090.10-FF-000015', NULL, '3-dehydroquinate synthase protein', 222, NULL, NULL, 181332),
(181333, '1.20.1280.50-FF-000154', NULL, 'Putative F-box protein At5g36200', 62, NULL, NULL, 181333),
(181334, '3.60.15.10-FF-000152', NULL, 'Subunit of mRNA cleavage and polyadenylation specificity factor', 226, NULL, NULL, 181334),
(181335, '3.30.160.60-FF-005985', NULL, NULL, 56, NULL, NULL, 181335),
(181336, '3.30.1460.50-FF-000007', NULL, 'Autophagy-related protein 3', 135, NULL, NULL, 181336),
(181337, '3.40.50.2300-FF-001296', NULL, NULL, 134, NULL, NULL, 181337),
(181338, '1.10.1420.10-FF-000111', NULL, 'DNA mismatch repair protein MutS', 126, NULL, NULL, 181338),
(181339, '3.90.550.10-FF-000613', NULL, 'Glycosyltransferases', 214, NULL, NULL, 181339),
(181340, '3.40.50.300-FF-000781', NULL, 'RAB, member RAS oncogene family like 6', 237, NULL, NULL, 181340),
(181341, '2.60.40.10-FF-002551', NULL, 'putative ST2L protein isoform X5', 114, NULL, NULL, 181341),
(181342, '1.25.40.210-FF-000003', NULL, 'Telomeric repeat-binding factor', 122, NULL, NULL, 181342),
(181343, '3.40.950.10-FF-000025', NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', 152, NULL, NULL, 181343),
(181344, '3.90.70.10-FF-000694', NULL, 'Uncharacterized protein', 226, NULL, NULL, 181344),
(181345, '3.40.710.10-FF-000047', NULL, 'Glycosyl transferase family 51', 211, NULL, NULL, 181345),
(181346, '1.25.10.10-FF-000002', NULL, 'AP complex subunit beta', 591, NULL, NULL, 181346),
(181347, '3.40.50.1000-FF-000826', NULL, NULL, 93, NULL, NULL, 181347),
(181348, '2.160.20.10-FF-000201', NULL, 'Uncharacterized protein', 81, NULL, NULL, 181348),
(181349, '1.25.40.10-FF-000173', NULL, 'Tetratricopeptide repeat domain 8', 68, NULL, NULL, 181349),
(181350, '2.40.290.10-FF-000012', NULL, 'ATP-dependent DNA helicase II subunit 1', 97, NULL, NULL, 181350),
(181351, '3.20.20.80-FF-000203', NULL, 'Glycogen debranching enzyme', 138, NULL, NULL, 181351),
(181352, '1.20.1250.20-FF-001318', NULL, 'monocarboxylate transporter 3 isoform X2', 194, NULL, NULL, 181352);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(181353, '3.40.50.300-FF-008318', NULL, 'Multidrug resistance protein, putative', 250, NULL, NULL, 181353),
(181354, '3.30.1460.30-FF-000001', NULL, 'TfoX family protein', 102, NULL, NULL, 181354),
(181355, '3.30.160.60-FF-003938', NULL, NULL, 28, NULL, NULL, 181355),
(181356, '1.10.472.10-FF-000081', NULL, 'Cyclin family protein', 150, NULL, NULL, 181356),
(181357, '2.120.10.80-FF-000116', NULL, 'Attractin like 1', 225, NULL, NULL, 181357),
(181358, '1.10.472.10-FF-000417', NULL, 'Uncharacterized protein', 84, NULL, NULL, 181358),
(181359, '3.90.950.10-FF-000008', NULL, 'Maf-like protein, expressed', 201, NULL, NULL, 181359),
(181360, '3.10.330.20-FF-000005', NULL, 'tRNA (Adenine-N(1)-)-methyltransferase catalytic subunit trm61', 86, NULL, NULL, 181360),
(181361, '3.40.47.10-FF-000193', NULL, NULL, 107, NULL, NULL, 181361),
(181362, '1.10.510.10-FF-000069', NULL, 'probable serine/threonine-protein kinase At5g41260', 192, NULL, NULL, 181362),
(181363, '1.10.510.10-FF-003828', NULL, NULL, 111, NULL, NULL, 181363),
(181364, '3.40.1090.10-FF-000133', NULL, 'Protein CBG15159', 121, NULL, NULL, 181364),
(181365, '3.30.565.10-FF-000374', NULL, 'Response receiver histidine kinase', 148, NULL, NULL, 181365),
(181366, '1.10.287.110-FF-000062', NULL, 'DnaJ protein ERDJ3B', 105, NULL, NULL, 181366),
(181367, '1.20.1250.20-FF-001739', NULL, 'Uncharacterized MFS-type transporter C18.02', 200, NULL, NULL, 181367),
(181368, '1.20.5.170-FF-000219', NULL, 'p-loop containing nucleoside triphosphate hydrolases superfamily protein', 40, NULL, NULL, 181368),
(181369, '3.30.450.60-FF-000038', NULL, 'AP complex subunit sigma', 146, NULL, NULL, 181369),
(181370, '2.170.270.10-FF-000115', NULL, 'Uncharacterized protein', 179, NULL, NULL, 181370),
(181371, '3.40.50.300-FF-004283', NULL, 'Zgc:162239', 220, NULL, NULL, 181371),
(181372, '3.30.70.270-FF-000199', NULL, NULL, 169, NULL, NULL, 181372),
(181373, '1.10.287.130-FF-000068', NULL, 'PAS domain-containing sensor histidine kinase', 80, NULL, NULL, 181373),
(181374, '3.30.470.30-FF-000042', NULL, 'Putative DNA ligase k alpha', 231, NULL, NULL, 181374),
(181375, '2.70.130.10-FF-000146', NULL, NULL, 142, NULL, NULL, 181375),
(181376, '3.90.70.10-FF-000025', NULL, 'Putative ubiquitin carboxyl-terminal hydrolase 8', 346, NULL, NULL, 181376),
(181377, '3.30.230.120-FF-000011', NULL, 'Uncharacterized protein', 375, NULL, NULL, 181377),
(181378, '3.90.70.130-FF-000003', NULL, 'Probable Ufm1-specific protease 1', 208, NULL, NULL, 181378),
(181379, '3.30.470.20-FF-000168', NULL, 'Tubulin glycylase 3E', 220, NULL, NULL, 181379),
(181380, '2.170.260.10-FF-000030', NULL, 'Dicer-1, putative', 69, NULL, NULL, 181380),
(181381, '1.10.540.10-FF-000008', NULL, 'Acyl-CoA dehydrogenase', 122, NULL, NULL, 181381),
(181382, '1.25.40.10-FF-002308', NULL, 'Signal recognition particle subunit SRP72', 119, NULL, NULL, 181382),
(181383, '3.50.50.60-FF-000024', NULL, 'Gamma-glutamylputrescine oxidoreductase', 206, NULL, NULL, 181383),
(181384, '1.10.10.10-FF-001783', NULL, 'Vacuolar protein-sorting-associated protein 25', 79, NULL, NULL, 181384),
(181385, '3.40.50.12650-FF-000032', NULL, 'Uncharacterized protein', 56, NULL, NULL, 181385),
(181386, '1.25.40.10-FF-004096', NULL, 'Uncharacterized protein', 303, NULL, NULL, 181386),
(181387, '2.60.40.10-FF-001932', NULL, 'Neural cell adhesion molecule 1a', 99, NULL, NULL, 181387),
(181388, '3.20.20.70-FF-000329', NULL, 'Triosephosphate isomerase', 249, NULL, NULL, 181388),
(181389, '3.20.20.220-FF-000013', NULL, 'Proline dehydrogenase', 375, NULL, NULL, 181389),
(181390, '2.60.120.330-FF-000026', NULL, 'DIBOA-glucoside dioxygenase BX6', 331, NULL, NULL, 181390),
(181391, '2.60.120.310-FF-000020', NULL, 'Uncharacterized protein', 134, NULL, NULL, 181391),
(181392, '2.60.40.10-FF-005294', NULL, NULL, 82, NULL, NULL, 181392),
(181393, '3.40.605.10-FF-000033', NULL, 'NAD-dependent succinate-semialdehyde dehydrogenase', 253, NULL, NULL, 181393),
(181394, '4.10.410.10-FF-000055', NULL, 'Uncharacterized protein, isoform C', 63, NULL, NULL, 181394);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(181395, '1.20.120.350-FF-000143', NULL, NULL, 118, NULL, NULL, 181395),
(181396, '3.80.10.10-FF-001404', NULL, 'Uncharacterized protein', 225, NULL, NULL, 181396),
(181397, '2.30.30.230-FF-000008', NULL, 'Fumarylacetoacetase', 109, NULL, NULL, 181397),
(181398, '1.25.10.10-FF-002031', NULL, 'Translational activator, putative (AFU_orthologue AFUA_2G07960)', 273, NULL, NULL, 181398),
(181399, '3.80.10.10-FF-000578', NULL, 'F-box/LRR-repeat protein 2 isoform X1', 65, NULL, NULL, 181399),
(181400, '3.50.50.60-FF-001434', NULL, 'Probable lysine-specific histone demethylase 1', 110, NULL, NULL, 181400),
(181401, '2.120.10.90-FF-000006', NULL, 'DNA gyrase subunit A', 321, NULL, NULL, 181401),
(181402, '2.60.40.1180-FF-000146', NULL, 'Alpha-galactosidase', 91, NULL, NULL, 181402),
(181403, '1.25.10.10-FF-000345', NULL, 'Condensin-2 complex subunit D3', 143, NULL, NULL, 181403),
(181404, '1.10.10.1940-FF-000003', NULL, 'Metalloendopeptidase', 47, NULL, NULL, 181404),
(181405, '2.60.40.10-FF-000504', NULL, 'Bent, isoform J', 99, NULL, NULL, 181405),
(181406, '2.30.30.380-FF-000025', NULL, 'Uncharacterized protein, isoform B', 44, NULL, NULL, 181406),
(181407, '2.10.25.10-FF-000792', NULL, 'Uninflatable, isoform B', 37, NULL, NULL, 181407),
(181408, '1.25.10.10-FF-000906', NULL, 'Coatomer subunit gamma', 178, NULL, NULL, 181408),
(181409, '1.25.40.10-FF-002994', NULL, 'Pentatricopeptide repeat-containing protein At5g08510', 130, NULL, NULL, 181409),
(181410, '1.25.10.10-FF-001755', NULL, 'Exportin-4 protein', 100, NULL, NULL, 181410),
(181411, '2.30.110.10-FF-000013', NULL, 'Protein CREG1 isoform A', 165, NULL, NULL, 181411),
(181412, '3.20.20.70-FF-000785', NULL, NULL, 69, NULL, NULL, 181412),
(181413, '3.80.10.10-FF-002832', NULL, 'Ras guanine nucleotide exchange factor V', 126, NULL, NULL, 181413),
(181414, '3.20.20.370-FF-000030', NULL, 'Chitin deacetylase 1', 319, NULL, NULL, 181414),
(181415, '3.40.850.10-FF-000563', NULL, 'Kinesin family member 1C', 59, NULL, NULL, 181415),
(181416, '2.60.40.1120-FF-000044', NULL, 'Bacillopeptidase', 76, NULL, NULL, 181416),
(181417, '3.40.50.1820-FF-000960', NULL, 'Uncharacterized protein', 282, NULL, NULL, 181417),
(181418, '3.30.160.60-FF-001117', NULL, 'Zinc finger and BTB domain containing 48', 29, NULL, NULL, 181418),
(181419, '1.10.10.60-FF-000376', NULL, 'Chromodomain-helicase-DNA-binding protein 1', 111, NULL, NULL, 181419),
(181420, '2.130.10.10-FF-004310', NULL, 'Uncharacterized protein', 113, NULL, NULL, 181420),
(181421, '3.40.50.200-FF-000200', NULL, 'Uncharacterized protein', 340, NULL, NULL, 181421),
(181422, '3.30.450.40-FF-000032', NULL, 'Phosphodiesterase', 183, NULL, NULL, 181422),
(181423, '1.20.1070.10-FF-001543', NULL, 'Uncharacterized protein', 177, NULL, NULL, 181423),
(181424, '2.60.40.10-FF-005855', NULL, NULL, 120, NULL, NULL, 181424),
(181425, '3.90.120.10-FF-000013', NULL, 'Cytosine-C5 specific DNA methyltransferase', 61, NULL, NULL, 181425),
(181426, '3.40.50.1380-FF-000002', NULL, 'Methylglyoxal synthase', 151, NULL, NULL, 181426),
(181427, '3.30.70.330-FF-002156', NULL, NULL, 93, NULL, NULL, 181427),
(181428, '3.30.70.100-FF-000098', NULL, 'Ysine decarboxylase-like protein', 104, NULL, NULL, 181428),
(181429, '3.30.379.10-FF-000003', NULL, 'Beta-hexosaminidase', 160, NULL, NULL, 181429),
(181430, '2.130.10.10-FF-005951', NULL, 'Uncharacterized protein', 251, NULL, NULL, 181430),
(181431, '2.60.120.230-FF-000013', NULL, NULL, 140, NULL, NULL, 181431),
(181432, '1.20.1250.20-FF-000913', NULL, 'Ascus development protein 3', 467, NULL, NULL, 181432),
(181433, '1.20.1250.20-FF-001402', NULL, 'Transporter protein, putative', 188, NULL, NULL, 181433),
(181434, '2.60.40.10-FF-004349', NULL, NULL, 133, NULL, NULL, 181434),
(181435, '3.30.200.20-FF-001986', NULL, 'Os12g0427000 protein', 98, NULL, NULL, 181435),
(181436, '3.40.33.10-FF-000155', NULL, 'Predicted protein', 126, NULL, NULL, 181436),
(181437, '4.10.1240.50-FF-000011', NULL, 'Metastasis-associated protein MTA1', 74, NULL, NULL, 181437),
(181438, '1.25.40.10-FF-001583', NULL, 'Tetratricopeptide repeat domain 7B', 124, NULL, NULL, 181438);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(181439, '3.90.190.10-FF-000175', NULL, 'Uncharacterized protein', 168, NULL, NULL, 181439),
(181440, '2.40.30.10-FF-000179', NULL, 'Sulfate adenylyltransferase subunit 1', 115, NULL, NULL, 181440),
(181441, '3.30.230.70-FF-000165', NULL, 'Uncharacterized protein', 170, NULL, NULL, 181441),
(181442, '1.20.120.530-FF-000006', NULL, 'HTH-type transcriptional repressor NanR', 138, NULL, NULL, 181442),
(181443, '3.40.50.2020-FF-000003', NULL, 'Uracil phosphoribosyltransferase', 209, NULL, NULL, 181443),
(181444, '3.40.50.300-FF-002579', NULL, 'Primosomal protein N''', 214, NULL, NULL, 181444),
(181445, '3.30.160.60-FF-003034', NULL, 'Zinc finger protein 557', 27, NULL, NULL, 181445),
(181446, '2.30.29.240-FF-000009', NULL, 'Phosphoinositide phospholipase C', 184, NULL, NULL, 181446),
(181447, '6.10.140.2220-FF-000077', NULL, 'SD20045p', 19, NULL, NULL, 181447),
(181448, '2.130.10.10-FF-005721', NULL, 'Uncharacterized protein', 139, NULL, NULL, 181448),
(181449, '2.60.40.10-FF-003377', NULL, 'Adhesion G protein-coupled receptor L3', 84, NULL, NULL, 181449),
(181450, '1.20.58.530-FF-000018', NULL, 'myosin-VIIa isoform X2', 152, NULL, NULL, 181450),
(181451, '3.40.50.720-FF-001755', NULL, 'Alcohol dehydrogenase GroES domain protein', 135, NULL, NULL, 181451),
(181452, '3.30.60.20-FF-000036', NULL, 'Rho-associated protein kinase 1', 66, NULL, NULL, 181452),
(181453, '1.25.10.10-FF-001851', NULL, 'U3 small nucleolar RNA-associated protein, putative', 201, NULL, NULL, 181453),
(181454, '3.80.10.10-FF-004277', NULL, 'Uncharacterized protein', 46, NULL, NULL, 181454),
(181455, '3.90.1750.10-FF-000060', NULL, 'Uncharacterized protein', 74, NULL, NULL, 181455),
(181456, '3.30.70.330-FF-002611', NULL, NULL, 130, NULL, NULL, 181456),
(181457, '1.10.220.150-FF-000035', NULL, 'Arf GTPase activating protein', 141, NULL, NULL, 181457),
(181458, '2.60.40.2130-FF-000004', NULL, 'M-spondin', 201, NULL, NULL, 181458),
(181459, '2.60.34.10-FF-000119', NULL, 'Predicted protein', 98, NULL, NULL, 181459),
(181460, '3.30.1240.10-FF-000029', NULL, 'Stress response protein YhaX', 113, NULL, NULL, 181460),
(181461, '1.20.58.340-FF-000068', NULL, 'Cobalt/magnesium transport protein CorA', 58, NULL, NULL, 181461),
(181462, '2.70.50.80-FF-000008', NULL, 'Transcriptional enhancer factor TEF-3', 56, NULL, NULL, 181462),
(181463, '2.130.10.10-FF-005058', NULL, 'Uncharacterized protein', 277, NULL, NULL, 181463),
(181464, '3.40.50.2000-FF-000817', NULL, 'Lipopolysaccharide heptosyltransferase III, putative', 220, NULL, NULL, 181464),
(181465, '1.25.10.10-FF-002823', NULL, 'Uncharacterized protein', 191, NULL, NULL, 181465),
(181466, '1.25.10.10-FF-003088', NULL, 'Uncharacterized protein', 227, NULL, NULL, 181466),
(181467, '3.40.50.720-FF-000783', NULL, '6-phosphogluconate dehydrogenase, decarboxylating, putative', 184, NULL, NULL, 181467),
(181468, '3.10.20.90-FF-000965', NULL, 'Uncharacterized protein', 31, NULL, NULL, 181468),
(181469, '3.60.21.10-FF-000436', NULL, 'UDP-N-2, O-3-di-(3-hydroxyacyl)glucosamine/UDP-N-2, N-3-di-(3-hydroxyacyl)glucosediamine pyrophosphatase', 235, NULL, NULL, 181469),
(181470, '1.20.1740.10-FF-000189', NULL, 'Uncharacterized protein', 255, NULL, NULL, 181470),
(181471, '3.30.70.330-FF-000711', NULL, 'Pre-mRNA splicing factor (Prp24), putative', 99, NULL, NULL, 181471),
(181472, '3.30.70.330-FF-001330', NULL, 'Os03g0363800 protein', 169, NULL, NULL, 181472),
(181473, '3.30.310.50-FF-000008', NULL, 'Cancer/testis antigen 2', 88, NULL, NULL, 181473),
(181474, '2.60.40.150-FF-000199', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', 136, NULL, NULL, 181474),
(181475, '1.20.1270.60-FF-000089', NULL, 'BAI1 associated protein 2', 107, NULL, NULL, 181475),
(181476, '1.10.10.10-FF-000277', NULL, 'LysR family transcriptional regulator', 85, NULL, NULL, 181476),
(181477, '2.30.30.30-FF-000146', NULL, 'Uncharacterized protein', 105, NULL, NULL, 181477),
(181478, '3.40.50.1000-FF-000034', NULL, 'Phospholipid-transporting ATPase', 188, NULL, NULL, 181478),
(181479, '1.10.150.240-FF-000118', NULL, 'Phosphoglycolate phosphatase', 68, NULL, NULL, 181479);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(181480, '2.40.240.10-FF-000060', NULL, 'tRNA synthetase', 118, NULL, NULL, 181480),
(181481, '2.10.25.10-FF-001438', NULL, 'Uncharacterized protein', 48, NULL, NULL, 181481),
(181482, '1.20.120.1900-FF-000087', NULL, 'Gamma-tubulin complex component', 140, NULL, NULL, 181482),
(181483, '1.10.3460.10-FF-000024', NULL, 'Photosystem I light harvesting protein', 145, NULL, NULL, 181483),
(181484, '2.30.30.210-FF-000020', NULL, 'Uncharacterized protein', 106, NULL, NULL, 181484),
(181485, '3.40.1110.10-FF-000293', NULL, NULL, 45, NULL, NULL, 181485),
(181486, '2.20.25.90-FF-000017', NULL, NULL, 62, NULL, NULL, 181486),
(181487, '3.40.30.10-FF-000924', NULL, 'Uncharacterized protein', 210, NULL, NULL, 181487),
(181488, '3.30.40.10-FF-001105', NULL, 'RIKEN cDNA 4930595M18 gene', 85, NULL, NULL, 181488),
(181489, '2.160.10.10-FF-000127', NULL, 'Probable mannose-1-phosphate guanyltransferase', 85, NULL, NULL, 181489),
(181490, '3.30.565.10-FF-000470', NULL, 'Two-component hybrid sensor and regulator', 168, NULL, NULL, 181490),
(181491, '1.20.1050.10-FF-000024', NULL, 'Glutaredoxin 2', 126, NULL, NULL, 181491),
(181492, '3.40.50.300-FF-002366', NULL, 'Uncharacterized protein', 270, NULL, NULL, 181492),
(181493, '1.20.120.290-FF-000001', NULL, 'Oxygen-evolving enhancer protein 3', 148, NULL, NULL, 181493),
(181494, '1.25.40.10-FF-000734', NULL, 'Binding protein', 181, NULL, NULL, 181494),
(181495, '3.40.250.10-FF-000242', NULL, 'Sulfurtransferase', 142, NULL, NULL, 181495),
(181496, '1.10.20.10-FF-000328', NULL, NULL, 192, NULL, NULL, 181496),
(181497, '1.20.1110.10-FF-000193', NULL, NULL, 138, NULL, NULL, 181497),
(181498, '3.90.190.10-FF-000388', NULL, 'Tyrosine-protein phosphatase non-receptor type 9', 315, NULL, NULL, 181498),
(181499, '3.40.50.1580-FF-000062', NULL, 'Protein CBG16977', 210, NULL, NULL, 181499),
(181500, '3.30.1330.60-FF-000012', NULL, 'Peptidoglycan-associated protein', 136, NULL, NULL, 181500),
(181501, '1.10.167.10-FF-000051', NULL, 'Regulator of G-protein signaling 1', 131, NULL, NULL, 181501),
(181502, '3.30.200.20-FF-001194', NULL, 'Tyrosine-protein kinase', 127, NULL, NULL, 181502),
(181503, '3.30.70.330-FF-002948', NULL, NULL, 109, NULL, NULL, 181503),
(181504, '2.130.10.10-FF-004209', NULL, 'Uncharacterized protein', 154, NULL, NULL, 181504),
(181505, '2.10.25.10-FF-000921', NULL, 'Protein gurken', 51, NULL, NULL, 181505),
(181506, '3.30.60.30-FF-000140', NULL, 'Solute carrier organic anion transporter family member', 49, NULL, NULL, 181506),
(181507, '1.25.40.1010-FF-000004', NULL, 'N-acetyltransferase subunit Nat1', 106, NULL, NULL, 181507),
(181508, '3.40.50.11030-FF-000013', NULL, NULL, 127, NULL, NULL, 181508),
(181509, '2.40.50.150-FF-000014', NULL, 'DNA-directed RNA polymerase subunit beta', 129, NULL, NULL, 181509),
(181510, '1.20.1050.10-FF-000120', NULL, 'glutathione S-transferase omega-1', 114, NULL, NULL, 181510),
(181511, '3.30.2020.30-FF-000013', NULL, 'Trimethyllysine dioxygenase', 76, NULL, NULL, 181511),
(181512, '1.20.5.990-FF-000010', NULL, 'TNFAIP3 interacting protein 3', 88, NULL, NULL, 181512),
(181513, '2.30.29.30-FF-000761', NULL, 'Ran-binding protein (RanBP), putative', 178, NULL, NULL, 181513),
(181514, '1.10.533.10-FF-000094', NULL, 'Interleukin-1 receptor-associated kinase', 104, NULL, NULL, 181514),
(181515, '3.30.160.60-FF-003377', NULL, 'LD33878p', 29, NULL, NULL, 181515),
(181516, '2.70.150.10-FF-000046', NULL, 'Phospholipid-transporting ATPase', 138, NULL, NULL, 181516),
(181517, '3.30.160.60-FF-006474', NULL, NULL, 46, NULL, NULL, 181517),
(181518, '2.30.29.30-FF-000401', NULL, 'FYVE, RhoGEF and PH domain-containing protein 3', 122, NULL, NULL, 181518),
(181519, '3.40.640.10-FF-000406', NULL, 'Aminotransferase, class I', 250, NULL, NULL, 181519),
(181520, '2.70.150.10-FF-000259', NULL, 'Uncharacterized protein', 167, NULL, NULL, 181520),
(181521, '3.40.50.80-FF-000221', NULL, 'Ferredoxin:NADP oxidoreductase, beta subunit', 112, NULL, NULL, 181521),
(181522, '2.30.29.30-FF-001250', NULL, 'Tyrosine-protein kinase', 109, NULL, NULL, 181522);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(181523, '3.30.2350.20-FF-000024', NULL, 'tRNA pseudouridine synthase D, putative', 206, NULL, NULL, 181523),
(181524, '1.10.8.870-FF-000004', NULL, 'Glycerol-3-phosphate dehydrogenase', 128, NULL, NULL, 181524),
(181525, '1.10.510.10-FF-000299', NULL, 'Tyrosine-protein kinase', 181, NULL, NULL, 181525),
(181526, '3.40.630.30-FF-000327', NULL, 'Ribosomal protein N-acetyltransferase', 183, NULL, NULL, 181526),
(181527, '3.90.290.10-FF-000008', NULL, 'Fibrillin 3', 74, NULL, NULL, 181527),
(181528, '3.80.10.10-FF-003451', NULL, 'Leucine-rich repeat protein (LRRP), putative', 246, NULL, NULL, 181528),
(181529, '2.60.120.10-FF-000698', NULL, 'Predicted gene, 28042', 226, NULL, NULL, 181529),
(181530, '3.40.50.300-FF-004266', NULL, 'Rab_B32 protein', 212, NULL, NULL, 181530),
(181531, '3.30.1130.10-FF-000010', NULL, 'Folic acid synthesis protein fol1', 115, NULL, NULL, 181531),
(181532, '3.10.129.10-FF-000034', NULL, 'Acyl-CoA thioester hydrolase', 160, NULL, NULL, 181532),
(181533, '3.40.630.10-FF-000097', NULL, 'Peptide hydrolase', 309, NULL, NULL, 181533),
(181534, '1.10.1240.40-FF-000005', NULL, 'ENT domain containing protein, expressed', 121, NULL, NULL, 181534),
(181535, '1.20.1070.10-FF-000924', NULL, 'Uncharacterized protein', 111, NULL, NULL, 181535),
(181536, '1.20.1310.20-FF-000059', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 195, NULL, NULL, 181536),
(181537, '1.20.5.190-FF-000085', NULL, 'Myosin IHa', 50, NULL, NULL, 181537),
(181538, '1.20.1070.10-FF-001413', NULL, 'Uncharacterized protein', 232, NULL, NULL, 181538),
(181539, '3.40.850.10-FF-000220', NULL, 'Kinesin-like protein', 352, NULL, NULL, 181539),
(181540, '3.40.50.620-FF-000871', NULL, 'Isoleucyl-tRNA synthetase 2, mitochondrial', 134, NULL, NULL, 181540),
(181541, '2.40.10.10-FF-000296', NULL, NULL, 103, NULL, NULL, 181541),
(181542, '3.40.50.300-FF-005676', NULL, 'Uncharacterized protein', 190, NULL, NULL, 181542),
(181543, '3.40.630.30-FF-000558', NULL, 'Uncharacterized protein', 127, NULL, NULL, 181543),
(181544, '3.40.640.10-FF-000053', NULL, 'Aminotransferase, class I', 224, NULL, NULL, 181544),
(181545, '1.10.287.70-FF-000437', NULL, 'Uncharacterized protein', 135, NULL, NULL, 181545),
(181546, '3.40.390.10-FF-000302', NULL, NULL, 40, NULL, NULL, 181546),
(181547, '1.20.1070.10-FF-000132', NULL, 'Neuromedin-B receptor', 347, NULL, NULL, 181547),
(181548, '2.30.30.40-FF-000475', NULL, 'Cell division control protein 25', 78, NULL, NULL, 181548),
(181549, '1.10.472.80-FF-000157', NULL, NULL, 150, NULL, NULL, 181549),
(181550, '2.10.25.10-FF-001540', NULL, 'Uncharacterized protein', 69, NULL, NULL, 181550),
(181551, '3.40.50.150-FF-000258', NULL, 'Probable methyltransferase PMT28', 184, NULL, NULL, 181551),
(181552, '2.60.40.60-FF-000733', NULL, 'Predicted protein', 112, NULL, NULL, 181552),
(181553, '1.10.3380.10-FF-000074', NULL, 'Activating signal cointegrator 1 complex subunit 3, helc1, putative', 148, NULL, NULL, 181553),
(181554, '1.25.40.10-FF-003269', NULL, 'Pentatricopeptide repeat-containing protein', 144, NULL, NULL, 181554),
(181555, '1.20.1080.10-FF-000060', NULL, 'Aquaporin 9, putative', 222, NULL, NULL, 181555),
(181556, '3.40.50.150-FF-001876', NULL, NULL, 225, NULL, NULL, 181556),
(181557, '3.80.10.10-FF-000921', NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', 197, NULL, NULL, 181557),
(181558, '3.30.70.1230-FF-000280', NULL, 'Guanylate cyclase', 60, NULL, NULL, 181558),
(181559, '3.50.50.60-FF-001081', NULL, 'Succinate dehydrogenase [ubiquinone] flavoprotein subunit, mitochondrial', 215, NULL, NULL, 181559),
(181560, '2.30.30.140-FF-000072', NULL, 'Scm like with four mbt domains 2', 123, NULL, NULL, 181560),
(181561, '1.10.510.10-FF-001822', NULL, 'Kinase, STE STE20', 276, NULL, NULL, 181561),
(181562, '3.30.300.20-FF-000055', NULL, 'Ribosome-binding factor A', 120, NULL, NULL, 181562),
(181563, '3.40.50.720-FF-000687', NULL, 'DgcA, Dimethylglycine catabolism', 137, NULL, NULL, 181563),
(181564, '3.90.1300.10-FF-000026', NULL, 'Uncharacterized protein', 560, NULL, NULL, 181564),
(181565, '3.30.1240.10-FF-000001', NULL, 'Sugar phosphatase YidA', 107, NULL, NULL, 181565); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(181566, '3.30.160.60-FF-006131', NULL, NULL, 101, NULL, NULL, 181566),
(181567, '2.20.70.10-FF-000244', NULL, 'ADR159Cp', 62, NULL, NULL, 181567),
(181568, '1.25.40.10-FF-000043', NULL, 'G-protein-signaling modulator 2 isoform X1', 338, NULL, NULL, 181568),
(181569, '3.40.630.10-FF-000125', NULL, 'Carboxypeptidase D', 304, NULL, NULL, 181569),
(181570, '3.30.565.10-FF-000262', NULL, 'Serine/threonine protein kinase', 120, NULL, NULL, 181570),
(181571, '3.40.50.300-FF-007149', NULL, 'Uncharacterized protein', 176, NULL, NULL, 181571),
(181572, '3.40.532.10-FF-000015', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 232, NULL, NULL, 181572),
(181573, '3.10.110.10-FF-000008', NULL, 'Ubiquitin-conjugating enzyme E2 G2', 165, NULL, NULL, 181573),
(181574, '3.30.465.10-FF-000097', NULL, 'Uncharacterized protein', 87, NULL, NULL, 181574),
(181575, '3.30.70.330-FF-001673', NULL, NULL, 95, NULL, NULL, 181575),
(181576, '1.10.10.1200-FF-000006', NULL, 'Melanoma-associated antigen E1', 96, NULL, NULL, 181576),
(181577, '3.30.160.60-FF-004102', NULL, NULL, 36, NULL, NULL, 181577),
(181578, '3.30.810.10-FF-000023', NULL, 'Uncharacterized protein', 68, NULL, NULL, 181578),
(181579, '1.20.120.1770-FF-000008', NULL, 'Translation initiation factor', 174, NULL, NULL, 181579),
(181580, '2.160.20.10-FF-000072', NULL, 'AAA family ATPase', 242, NULL, NULL, 181580),
(181581, '2.20.28.10-FF-000062', NULL, 'Uncharacterized protein', 51, NULL, NULL, 181581),
(181582, '3.30.870.10-FF-000044', NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', 203, NULL, NULL, 181582),
(181583, '3.10.280.10-FF-000003', NULL, 'Mitochondrial glycoprotein', 185, NULL, NULL, 181583),
(181584, '3.10.250.10-FF-000069', NULL, NULL, 107, NULL, NULL, 181584),
(181585, '2.40.50.140-FF-001085', NULL, NULL, 79, NULL, NULL, 181585),
(181586, '2.40.50.140-FF-000579', NULL, 'Chromosome 8, whole genome shotgun sequence', 87, NULL, NULL, 181586),
(181587, '3.80.10.10-FF-003080', NULL, 'Uncharacterized protein', 128, NULL, NULL, 181587),
(181588, '3.30.1680.10-FF-000006', NULL, 'Macrophage-stimulating 1 receptor b', 51, NULL, NULL, 181588),
(181589, '1.50.10.20-FF-000031', NULL, 'Protein farnesyltransferase subunit beta', 520, NULL, NULL, 181589),
(181590, '2.30.42.10-FF-000488', NULL, NULL, 81, NULL, NULL, 181590),
(181591, '3.90.1720.10-FF-000018', NULL, 'Hypothetical_protein_-_conserved', 184, NULL, NULL, 181591),
(181592, '3.90.930.12-FF-000010', NULL, '50S ribosomal protein L6', 82, NULL, NULL, 181592),
(181593, '4.10.400.10-FF-000009', NULL, 'Low-density lipoprotein receptor-related protein 1', 44, NULL, NULL, 181593),
(181594, '3.40.50.1240-FF-000106', NULL, 'Protein CBG12398', 223, NULL, NULL, 181594),
(181595, '2.80.10.50-FF-000289', NULL, 'Otogelin', 146, NULL, NULL, 181595),
(181596, '3.40.50.620-FF-000539', NULL, 'TIGR00269 family protein', 314, NULL, NULL, 181596),
(181597, '2.60.120.590-FF-000076', NULL, 'Fto protein', 275, NULL, NULL, 181597),
(181598, '3.40.50.1220-FF-000100', NULL, 'Uncharacterized protein', 272, NULL, NULL, 181598),
(181599, '3.30.450.30-FF-000046', NULL, 'Dynein regulation protein LC7', 114, NULL, NULL, 181599),
(181600, '3.30.160.60-FF-002545', NULL, NULL, 30, NULL, NULL, 181600),
(181601, '1.25.40.10-FF-002090', NULL, 'Os06g0143500 protein', 108, NULL, NULL, 181601),
(181602, '3.40.50.10130-FF-000046', NULL, 'Uncharacterized protein', 225, NULL, NULL, 181602),
(181603, '3.30.200.60-FF-000008', NULL, 'Ubiquitin thioesterase', 53, NULL, NULL, 181603),
(181604, '2.60.120.10-FF-000035', NULL, 'cGMP-dependent protein kinase', 133, NULL, NULL, 181604),
(181605, '1.20.1050.10-FF-000232', NULL, 'Chloride channel, putative', 88, NULL, NULL, 181605),
(181606, '2.120.10.30-FF-000455', NULL, 'Nhl repeat-containing protein, putative', 96, NULL, NULL, 181606),
(181607, '3.30.70.380-FF-000001', NULL, 'Phenylalanine--tRNA ligase beta subunit', 94, NULL, NULL, 181607),
(181608, '1.25.10.10-FF-002582', NULL, 'Uncharacterized protein', 158, NULL, NULL, 181608),
(181609, '2.40.320.10-FF-000010', NULL, 'Mediator of RNA polymerase II transcription subunit 18', 101, NULL, NULL, 181609);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(181610, '3.30.420.40-FF-000221', NULL, 'D-allose kinase', 113, NULL, NULL, 181610),
(181611, '1.25.40.10-FF-004000', NULL, 'Uncharacterized protein', 209, NULL, NULL, 181611),
(181612, '2.40.70.10-FF-000176', NULL, 'Protein CBG28002', 100, NULL, NULL, 181612),
(181613, '1.25.10.10-FF-002262', NULL, 'Chromosome 10, whole genome shotgun sequence', 350, NULL, NULL, 181613),
(181614, '3.60.10.10-FF-000388', NULL, 'Uncharacterized protein', 369, NULL, NULL, 181614),
(181615, '1.20.1440.180-FF-000014', NULL, 'Uncharacterized protein', 119, NULL, NULL, 181615),
(181616, '1.20.144.10-FF-000086', NULL, 'Uncharacterized protein', 217, NULL, NULL, 181616),
(181617, '3.80.10.10-FF-002366', NULL, 'Uncharacterized protein', 184, NULL, NULL, 181617),
(181618, '3.40.1340.10-FF-000001', NULL, 'DNA-directed RNA polymerases I, II, and III subunit RPABC1', 129, NULL, NULL, 181618),
(181619, '1.20.58.120-FF-000002', NULL, 'BAG family molecular chaperone regulator 5', 87, NULL, NULL, 181619),
(181620, '3.30.260.10-FF-000014', NULL, 'T-complex protein 1, zeta subunit', 108, NULL, NULL, 181620),
(181621, '2.60.120.650-FF-000116', NULL, 'Jmjd2b-prov protein', 155, NULL, NULL, 181621),
(181622, '3.90.1290.10-FF-000030', NULL, 'Epiplakin 1', 203, NULL, NULL, 181622),
(181623, '1.20.1250.20-FF-002375', NULL, 'Solute carrier organic anion transporter family member', 222, NULL, NULL, 181623),
(181624, '3.30.70.20-FF-000093', NULL, NULL, 72, NULL, NULL, 181624),
(181625, '3.30.50.10-FF-000201', NULL, 'Uncharacterized protein', 68, NULL, NULL, 181625),
(181626, '1.10.150.20-FF-000313', NULL, 'Uncharacterized protein', 39, NULL, NULL, 181626),
(181627, '1.20.120.1750-FF-000002', NULL, 'RBR-type E3 ubiquitin transferase', 234, NULL, NULL, 181627),
(181628, '3.30.70.20-FF-000104', NULL, NULL, 79, NULL, NULL, 181628),
(181629, '1.25.40.10-FF-001139', NULL, 'Uncharacterized protein', 130, NULL, NULL, 181629),
(181630, '1.20.1070.10-FF-001756', NULL, 'Growth hormone-releasing hormone receptor form a', 76, NULL, NULL, 181630),
(181631, '3.30.40.10-FF-001785', NULL, 'RING-H2 finger protein ATL46', 86, NULL, NULL, 181631),
(181632, '1.10.238.10-FF-000380', NULL, 'Calmodulin, putative', 132, NULL, NULL, 181632),
(181633, '1.10.565.10-FF-000206', NULL, 'PPARalpha-B', 163, NULL, NULL, 181633),
(181634, '1.20.5.1430-FF-000011', NULL, 'Microtubule-binding protein, putative', 71, NULL, NULL, 181634),
(181635, '1.20.1420.30-FF-000036', NULL, 'Sodium/calcium exchanger MaX1', 121, NULL, NULL, 181635),
(181636, '3.40.50.300-FF-006053', NULL, 'Uncharacterized protein', 146, NULL, NULL, 181636),
(181637, '1.10.8.270-FF-000049', NULL, 'Si:dkey-238d18.4', 101, NULL, NULL, 181637),
(181638, '1.20.58.60-FF-000289', NULL, 'Spectrin beta, non-erythrocytic 5', 134, NULL, NULL, 181638),
(181639, '1.10.10.10-FF-000390', NULL, 'IclR family transcriptional regulator', 75, NULL, NULL, 181639),
(181640, '1.10.8.60-FF-000285', NULL, 'ATPase family AAA domain-containing 5b', 68, NULL, NULL, 181640),
(181641, '2.60.120.200-FF-000015', NULL, 'protein kinase C-binding protein NELL1', 190, NULL, NULL, 181641),
(181642, '2.130.10.10-FF-004541', NULL, 'Uncharacterized protein', 223, NULL, NULL, 181642),
(181643, '2.130.10.10-FF-000842', NULL, 'F-box and WD repeat domain-containing 9', 151, NULL, NULL, 181643),
(181644, '3.40.50.300-FF-007481', NULL, 'ABC transporter ATP-binding protein', 235, NULL, NULL, 181644),
(181645, '1.10.10.60-FF-000831', NULL, NULL, 69, NULL, NULL, 181645),
(181646, '4.10.1000.10-FF-000055', NULL, 'Uncharacterized protein', 37, NULL, NULL, 181646),
(181647, '1.20.930.10-FF-000008', NULL, 'mediator of RNA polymerase II transcription subunit 26', 87, NULL, NULL, 181647),
(181648, '1.20.1110.10-FF-000063', NULL, 'Calcium-translocating P-type ATPase, PMCA-type', 380, NULL, NULL, 181648),
(181649, '3.20.20.190-FF-000077', NULL, 'Phosphoinositide-specific phospholipase C, efhand-like/Phosphatidylinositol-specific phospholipase C, X domain/PDZ domain (Also known as DHR or GLGF)/PDZ domain containing protein, putative', 237, NULL, NULL, 181649);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(181650, '3.30.1480.10-FF-000007', NULL, 'Transcription termination/antitermination protein NusA', 134, NULL, NULL, 181650),
(181651, '2.130.10.10-FF-002192', NULL, 'THO Complex (Transcription factor/nuclear export) subunit', 175, NULL, NULL, 181651),
(181652, '2.70.98.10-FF-000042', NULL, 'Alpha-1,2-mannosidase, putative', 359, NULL, NULL, 181652),
(181653, '1.10.260.40-FF-000069', NULL, 'Transcriptional regulator', 96, NULL, NULL, 181653),
(181654, '2.10.110.10-FF-000332', NULL, 'Uncharacterized protein', 61, NULL, NULL, 181654),
(181655, '2.30.29.30-FF-001019', NULL, 'Uncharacterized protein', 108, NULL, NULL, 181655),
(181656, '3.30.40.10-FF-001004', NULL, 'Uncharacterized protein', 64, NULL, NULL, 181656),
(181657, '3.80.10.10-FF-001747', NULL, 'Leucine rich repeat containing 18a', 205, NULL, NULL, 181657),
(181658, '3.30.1150.10-FF-000022', NULL, NULL, 107, NULL, NULL, 181658),
(181659, '3.90.1100.10-FF-000045', NULL, 'DNA-directed RNA polymerase subunit beta', 252, NULL, NULL, 181659),
(181660, '3.30.160.60-FF-000628', NULL, 'zinc finger protein 768', 31, NULL, NULL, 181660),
(181661, '1.10.510.10-FF-001479', NULL, 'Protein kinase domain containing protein', 303, NULL, NULL, 181661),
(181662, '3.40.190.10-FF-000192', NULL, 'Lipoprotein', 111, NULL, NULL, 181662),
(181663, '3.40.50.1010-FF-000043', NULL, 'MKT1 domain-containing protein', 198, NULL, NULL, 181663),
(181664, '3.40.50.200-FF-000172', NULL, 'Mbtps1 protein', 43, NULL, NULL, 181664),
(181665, '3.30.70.1430-FF-000008', NULL, 'Transporter AcrB/D/F family protein', 101, NULL, NULL, 181665),
(181666, '3.30.70.1410-FF-000002', NULL, 'Kanosamine-6-phosphate phosphatase', 86, NULL, NULL, 181666),
(181667, '1.25.40.10-FF-003477', NULL, 'Pentatricopeptide repeat-containing protein At5g12100, mitochondrial', 94, NULL, NULL, 181667),
(181668, '1.20.120.220-FF-000020', NULL, 'ATP synthase subunit a', 177, NULL, NULL, 181668),
(181669, '3.80.10.10-FF-003900', NULL, 'Predicted protein', 135, NULL, NULL, 181669),
(181670, '2.60.40.10-FF-001483', NULL, 'Ephrin type-A receptor 6', 82, NULL, NULL, 181670),
(181671, '3.40.50.12280-FF-000011', NULL, 'Energy-conserving hydrogenase (Ferredoxin), subunit C', 153, NULL, NULL, 181671),
(181672, '2.60.40.60-FF-001014', NULL, 'Uncharacterized protein', 53, NULL, NULL, 181672),
(181673, '3.30.160.60-FF-000050', NULL, 'zinc finger protein ZIC 1', 84, NULL, NULL, 181673),
(181674, '3.90.190.10-FF-000287', NULL, 'Laforin, isoform 9', 122, NULL, NULL, 181674),
(181675, '3.30.420.40-FF-000452', NULL, 'Actin, putative', 142, NULL, NULL, 181675),
(181676, '3.40.50.300-FF-000449', NULL, 'Probable ATP-dependent RNA helicase DDX41', 164, NULL, NULL, 181676),
(181677, '1.10.620.20-FF-000046', NULL, 'Scarecrow-like protein 3', 261, NULL, NULL, 181677),
(181678, '3.30.70.1400-FF-000011', NULL, 'Aminomethyltransferase', 88, NULL, NULL, 181678),
(181679, '1.20.1230.10-FF-000010', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 205, NULL, NULL, 181679),
(181680, '2.60.40.1510-FF-000048', NULL, 'Uncharacterized integrin beta-like protein C05D9.3', 181, NULL, NULL, 181680),
(181681, '3.30.200.20-FF-000233', NULL, 'Meiosis induction protein kinase', 105, NULL, NULL, 181681),
(181682, '2.10.70.10-FF-000216', NULL, 'Protein lev-9', 57, NULL, NULL, 181682),
(181683, '3.40.30.10-FF-000570', NULL, 'Os01g0950000 protein', 81, NULL, NULL, 181683),
(181684, '3.80.10.10-FF-000123', NULL, 'Volume-regulated anion channel subunit LRRC8D', 376, NULL, NULL, 181684),
(181685, '3.30.160.60-FF-005294', NULL, NULL, 33, NULL, NULL, 181685),
(181686, '3.30.1060.10-FF-000015', NULL, NULL, 178, NULL, NULL, 181686),
(181687, '3.30.70.270-FF-000103', NULL, 'Sensory box/GGDEF family protein', 172, NULL, NULL, 181687),
(181688, '3.60.21.10-FF-000306', NULL, 'Serine/threonine-protein phosphatase', 402, NULL, NULL, 181688),
(181689, '2.60.40.150-FF-000087', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit gamma isoform', 169, NULL, NULL, 181689),
(181690, '2.170.270.10-FF-000087', NULL, 'Zinc finger protein', 78, NULL, NULL, 181690);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(181691, '2.40.290.30-FF-000001', NULL, 'Mediator of RNA polymerase II transcription subunit 25', 166, NULL, NULL, 181691),
(181692, '2.20.110.10-FF-000049', NULL, NULL, 87, NULL, NULL, 181692),
(181693, '3.90.70.10-FF-000256', NULL, 'Calpain-c', 153, NULL, NULL, 181693),
(181694, '1.10.287.3510-FF-000004', NULL, 'NADH-ubiquinone oxidoreductase chain 4L', 88, NULL, NULL, 181694),
(181695, '1.25.40.10-FF-004124', NULL, 'Chitin synthase regulatory factor 4', 125, NULL, NULL, 181695),
(181696, '2.40.100.10-FF-000111', NULL, 'YALI0E00132p', 179, NULL, NULL, 181696),
(181697, '3.40.50.300-FF-004496', NULL, 'ABC transporter family protein', 314, NULL, NULL, 181697),
(181698, '2.30.330.10-FF-000007', NULL, 'Flagellar motor switch protein FliM', 84, NULL, NULL, 181698),
(181699, '3.40.190.10-FF-000416', NULL, 'Transcriptional regulator LysR family', 108, NULL, NULL, 181699),
(181700, '3.40.190.10-FF-000304', NULL, 'Amino acid ABC transporter substrate-binding protein', 127, NULL, NULL, 181700),
(181701, '1.20.58.1180-FF-000003', NULL, 'Mitochondrial 54S ribosomal protein YmL35', 141, NULL, NULL, 181701),
(181702, '3.90.1110.10-FF-000006', NULL, 'DNA-directed RNA polymerase subunit beta', 164, NULL, NULL, 181702),
(181703, '2.10.25.10-FF-001326', NULL, 'Putative laminin beta 1a', 49, NULL, NULL, 181703),
(181704, '1.10.490.10-FF-000010', NULL, 'Group 1 truncated hemoglobin', 134, NULL, NULL, 181704),
(181705, '2.130.10.10-FF-002287', NULL, 'AGAP000990-PA', 212, NULL, NULL, 181705),
(181706, '2.130.10.10-FF-001668', NULL, 'Cilia-and flagella-associated protein 52', 121, NULL, NULL, 181706),
(181707, '2.40.30.130-FF-000038', NULL, 'Alanyl-tRNA editing protein AlaX-L', 105, NULL, NULL, 181707),
(181708, '3.40.50.300-FF-003198', NULL, 'DNA helicase', 365, NULL, NULL, 181708),
(181709, '1.50.40.10-FF-000221', NULL, 'Mitochondrial carrier protein, putative', 122, NULL, NULL, 181709),
(181710, '1.10.246.60-FF-000014', NULL, NULL, 78, NULL, NULL, 181710),
(181711, '1.25.40.790-FF-000025', NULL, 'Uncharacterized protein', 54, NULL, NULL, 181711),
(181712, '3.90.550.50-FF-000012', NULL, 'Hexosyltransferase', 232, NULL, NULL, 181712),
(181713, '2.40.180.10-FF-000021', NULL, 'Catalase', 316, NULL, NULL, 181713),
(181714, '3.30.450.20-FF-000397', NULL, 'Sensory transduction histidine kinase', 130, NULL, NULL, 181714),
(181715, '1.20.1250.20-FF-000121', NULL, 'Probable inositol transporter 2', 362, NULL, NULL, 181715),
(181716, '1.10.1300.10-FF-000052', NULL, '3'', 5''-cyclic nucleotide phosphodiesterase, putative', 306, NULL, NULL, 181716),
(181717, '2.30.30.40-FF-000380', NULL, 'Variant sh3 domain containing protein', 60, NULL, NULL, 181717),
(181718, '3.30.160.60-FF-002657', NULL, 'Tripartite motif containing 75, pseudogene', 42, NULL, NULL, 181718),
(181719, '1.10.630.10-FF-000460', NULL, 'Thromboxane A synthase 1', 368, NULL, NULL, 181719),
(181720, '3.40.50.1100-FF-000289', NULL, 'Uncharacterized protein', 128, NULL, NULL, 181720),
(181721, '3.40.50.300-FF-003304', NULL, 'ATP-dependent dethiobiotin synthetase BioD', 223, NULL, NULL, 181721),
(181722, '3.10.490.20-FF-000027', NULL, 'Dynein heavy chain', 140, NULL, NULL, 181722),
(181723, '2.60.40.10-FF-003944', NULL, NULL, 105, NULL, NULL, 181723),
(181724, '3.90.1150.10-FF-000109', NULL, 'GntR family transcriptional regulator', 140, NULL, NULL, 181724),
(181725, '2.40.70.10-FF-000064', NULL, 'Eukaryotic aspartyl protease family protein', 186, NULL, NULL, 181725),
(181726, '1.20.120.350-FF-000031', NULL, 'Two pore calcium channel protein 1', 125, NULL, NULL, 181726),
(181727, '1.20.5.110-FF-000229', NULL, 'Protein BRICK1', 63, NULL, NULL, 181727),
(181728, '3.30.830.10-FF-000261', NULL, 'Ubiquinol-cytochrome c reductase core protein 2a', 70, NULL, NULL, 181728),
(181729, '3.30.160.60-FF-001123', NULL, 'Zinc finger and BTB domain-containing protein 49', 28, NULL, NULL, 181729),
(181730, '2.130.10.10-FF-000044', NULL, 'echinoderm microtubule-associated protein-like 6 isoform X1', 278, NULL, NULL, 181730),
(181731, '1.25.40.10-FF-000414', NULL, 'Tetratricopeptide repeat domain 21B', 180, NULL, NULL, 181731);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(181732, '3.90.79.20-FF-000003', NULL, 'Nucleoside diphosphate-linked moiety X motif 13', 169, NULL, NULL, 181732),
(181733, '2.10.25.10-FF-000584', NULL, 'Vitamin K-dependent protein S', 43, NULL, NULL, 181733),
(181734, '3.30.540.10-FF-000047', NULL, 'Inositol-1-monophosphatase', 143, NULL, NULL, 181734),
(181735, '3.40.50.1000-FF-000135', NULL, 'Glycerol-3-phosphate 2-O-acyltransferase 6', 114, NULL, NULL, 181735),
(181736, '3.40.20.10-FF-000176', NULL, 'Protein transport protein Sec24A, putative', 136, NULL, NULL, 181736),
(181737, '2.40.50.180-FF-000012', NULL, 'Purine-binding chemotaxis protein (CheW)', 68, NULL, NULL, 181737),
(181738, '1.25.10.10-FF-002374', NULL, 'Calcium-binding protein 39-like', 275, NULL, NULL, 181738),
(181739, '1.10.506.10-FF-000082', NULL, 'Uncharacterized protein', 163, NULL, NULL, 181739),
(181740, '3.40.50.300-FF-000325', NULL, 'ATP-dependent RNA helicase DHX29', 172, NULL, NULL, 181740),
(181741, '3.40.50.720-FF-000002', NULL, 'Succinate--CoA ligase [ADP-forming] subunit alpha', 121, NULL, NULL, 181741),
(181742, '3.50.50.60-FF-000928', NULL, 'Glutathione reductase', 74, NULL, NULL, 181742),
(181743, '1.20.140.10-FF-000105', NULL, 'Acyl-CoA dehydrogenase, putative', 161, NULL, NULL, 181743),
(181744, '1.20.58.80-FF-000076', NULL, 'Katanin p60 ATPase-containing subunit A1', 60, NULL, NULL, 181744),
(181745, '1.10.510.10-FF-003733', NULL, NULL, 151, NULL, NULL, 181745),
(181746, '2.170.150.80-FF-000014', NULL, 'NAC domain-containing protein 104', 147, NULL, NULL, 181746),
(181747, '1.20.58.60-FF-000070', NULL, 'utrophin isoform X1', 112, NULL, NULL, 181747),
(181748, '1.25.10.10-FF-001643', NULL, 'Putative death-receptor fusion protein-domain-containing protein', 441, NULL, NULL, 181748),
(181749, '3.30.70.330-FF-002499', NULL, NULL, 73, NULL, NULL, 181749),
(181750, '2.60.40.60-FF-000396', NULL, 'Protocadherin gamma subfamily C, 4', 108, NULL, NULL, 181750),
(181751, '2.30.130.30-FF-000003', NULL, 'activating signal cointegrator 1 isoform X1', 84, NULL, NULL, 181751),
(181752, '3.10.20.90-FF-000527', NULL, 'GM10755', 83, NULL, NULL, 181752),
(181753, '1.10.510.10-FF-003267', NULL, NULL, 109, NULL, NULL, 181753),
(181754, '3.40.1380.20-FF-000012', NULL, 'Pyruvate kinase', 137, NULL, NULL, 181754),
(181755, '1.10.3860.10-FF-000004', NULL, 'L-cystine transporter tcyP', 431, NULL, NULL, 181755),
(181756, '2.40.420.20-FF-000048', NULL, 'Efflux pump, RND family, membrane fusion lipoprotein', 94, NULL, NULL, 181756),
(181757, '3.10.450.50-FF-000028', NULL, 'mRNA export factor MEX67', 182, NULL, NULL, 181757),
(181758, '3.40.50.720-FF-001412', NULL, 'YALI0D20438p', 179, NULL, NULL, 181758),
(181759, '1.10.1520.10-FF-000046', NULL, 'Uncharacterized protein', 61, NULL, NULL, 181759),
(181760, '2.60.40.10-FF-002320', NULL, 'Uncharacterized protein, isoform C', 101, NULL, NULL, 181760),
(181761, '3.40.33.10-FF-000043', NULL, 'AGAP007584-PA', 153, NULL, NULL, 181761),
(181762, '2.60.40.1400-FF-000015', NULL, 'ATP-sensitive inward rectifier potassium channel 12-like Protein', 186, NULL, NULL, 181762),
(181763, '1.25.40.20-FF-000512', NULL, 'Interferon antagonist K1L', 284, NULL, NULL, 181763),
(181764, '3.40.275.10-FF-000001', NULL, 'L-fucose isomerase', 165, NULL, NULL, 181764),
(181765, '2.60.40.10-FF-001691', NULL, 'interleukin-27 receptor subunit alpha', 107, NULL, NULL, 181765),
(181766, '3.40.50.10190-FF-000266', NULL, 'DNA topoisomerase 2-binding protein 1-A', 87, NULL, NULL, 181766),
(181767, '2.30.30.140-FF-000178', NULL, 'Predicted protein', 71, NULL, NULL, 181767),
(181768, '3.20.20.80-FF-000097', NULL, 'Probable chitinase 2', 271, NULL, NULL, 181768),
(181769, '1.10.1200.10-FF-000128', NULL, 'HC-toxin synthetase', 74, NULL, NULL, 181769),
(181770, '3.40.50.300-FF-001859', NULL, 'Formate--tetrahydrofolate ligase', 190, NULL, NULL, 181770),
(181771, '3.30.1640.10-FF-000009', NULL, 'DNA helicase', 109, NULL, NULL, 181771),
(181772, '2.60.120.920-FF-000118', NULL, 'Predicted protein', 168, NULL, NULL, 181772),
(181773, '3.40.50.200-FF-000088', NULL, 'S8 family serine protease', 415, NULL, NULL, 181773);
INSERT INTO "PUBLIC"."MODEL" VALUES
(181774, '1.10.275.40-FF-000002', NULL, 'TFIIH basal transcription factor complex helicase XPD subunit', 39, NULL, NULL, 181774),
(181775, '2.60.40.150-FF-000648', NULL, 'Uncharacterized protein', 122, NULL, NULL, 181775),
(181776, '3.40.50.1010-FF-000251', NULL, NULL, 198, NULL, NULL, 181776),
(181777, '3.30.200.20-FF-001643', NULL, 'Uncharacterized protein', 89, NULL, NULL, 181777),
(181778, '1.10.510.10-FF-002305', NULL, NULL, 224, NULL, NULL, 181778),
(181779, '3.80.10.10-FF-002927', NULL, 'Uncharacterized protein', 262, NULL, NULL, 181779),
(181780, '2.130.10.10-FF-003372', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase pek-1', 254, NULL, NULL, 181780),
(181781, '3.20.20.60-FF-000091', NULL, '2,4-dihydroxyhept-2-ene-1,7-dioic acid aldolase', 116, NULL, NULL, 181781),
(181782, '1.20.1050.20-FF-000010', NULL, 'Signal transducer and activator of transcription', 127, NULL, NULL, 181782),
(181783, '3.30.200.20-FF-000025', NULL, 'Platelet-derived growth factor receptor alpha', 130, NULL, NULL, 181783),
(181784, '3.40.50.2000-FF-001065', NULL, 'Os11g0457000 protein', 90, NULL, NULL, 181784),
(181785, '1.50.40.10-FF-000322', NULL, 'Uncharacterized protein', 296, NULL, NULL, 181785),
(181786, '4.10.280.50-FF-000005', NULL, 'Glutamate decarboxylase', 44, NULL, NULL, 181786),
(181787, '3.40.50.300-FF-006177', NULL, 'Dynein heavy chain family protein', 165, NULL, NULL, 181787),
(181788, '1.10.510.10-FF-004352', NULL, NULL, 119, NULL, NULL, 181788),
(181789, '1.10.10.60-FF-000033', NULL, 'REST corepressor 3', 63, NULL, NULL, 181789),
(181790, '1.10.630.10-FF-000229', NULL, 'Cytochrome P450 oxidoreductase OrdA-like, putative', 485, NULL, NULL, 181790),
(181791, '3.40.50.2300-FF-001054', NULL, NULL, 132, NULL, NULL, 181791),
(181792, '3.40.50.720-FF-000575', NULL, 'Malate dehydrogenase', 143, NULL, NULL, 181792),
(181793, '3.30.420.10-FF-000336', NULL, NULL, 142, NULL, NULL, 181793),
(181794, '2.10.25.10-FF-001646', NULL, 'Uncharacterized protein', 75, NULL, NULL, 181794),
(181795, '1.20.1320.30-FF-000006', NULL, NULL, 40, NULL, NULL, 181795),
(181796, '1.20.1260.140-FF-000006', NULL, NULL, 236, NULL, NULL, 181796),
(181797, '3.40.190.290-FF-000032', NULL, 'Probable transcriptional regulator', 197, NULL, NULL, 181797),
(181798, '3.30.420.390-FF-000011', NULL, NULL, 228, NULL, NULL, 181798),
(181799, '3.30.70.330-FF-003016', NULL, NULL, 72, NULL, NULL, 181799),
(181800, '3.30.70.270-FF-000311', NULL, NULL, 35, NULL, NULL, 181800),
(181801, '2.130.10.10-FF-005513', NULL, 'WD repeat domain 3', 79, NULL, NULL, 181801),
(181802, '3.40.50.300-FF-004619', NULL, 'Uncharacterized protein', 38, NULL, NULL, 181802),
(181803, '3.10.129.120-FF-000002', NULL, NULL, 157, NULL, NULL, 181803),
(181804, '2.130.10.10-FF-002753', NULL, 'WD repeat-containing protein, putative', 257, NULL, NULL, 181804),
(181805, '3.30.70.3490-FF-000053', NULL, NULL, 60, NULL, NULL, 181805),
(181806, '3.40.50.1820-FF-001820', NULL, 'Uncharacterized protein', 98, NULL, NULL, 181806),
(181807, '3.90.1580.10-FF-000029', NULL, 'Uncharacterized protein', 239, NULL, NULL, 181807),
(181808, '3.30.450.20-FF-000509', NULL, 'AraC family transcriptional regulator', 112, NULL, NULL, 181808),
(181809, '3.30.450.40-FF-000280', NULL, 'Phosphodiesterase', 106, NULL, NULL, 181809),
(181810, '3.30.1370.10-FF-000016', NULL, 'Putative splicing factor 1', 127, NULL, NULL, 181810),
(181811, '3.10.450.580-FF-000011', NULL, 'Mediator of RNA polymerase II transcription subunit 6', 145, NULL, NULL, 181811),
(181812, '3.90.1410.10-FF-000130', NULL, 'AGAP013401-PA', 281, NULL, NULL, 181812),
(181813, '3.40.50.300-FF-000680', NULL, 'pachytene checkpoint protein 2 homolog', 223, NULL, NULL, 181813),
(181814, '1.10.20.120-FF-000004', NULL, 'Uncharacterized protein', 214, NULL, NULL, 181814),
(181815, '3.30.60.60-FF-000020', NULL, 'Histone acetyltransferase', 57, NULL, NULL, 181815),
(181816, '3.40.930.10-FF-000030', NULL, 'Nitrogen regulatory IIA protein', 141, NULL, NULL, 181816),
(181817, '3.30.870.10-FF-000156', NULL, 'Uncharacterized protein', 127, NULL, NULL, 181817);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(181818, '4.10.280.10-FF-000229', NULL, 'Uncharacterized protein', 72, NULL, NULL, 181818),
(181819, '1.10.455.10-FF-000007', NULL, 'Ribosomal protein', 87, NULL, NULL, 181819),
(181820, '3.40.350.10-FF-000070', NULL, 'FACT complex subunit SPT16', 160, NULL, NULL, 181820),
(181821, '1.25.40.10-FF-003932', NULL, 'Uncharacterized protein', 393, NULL, NULL, 181821),
(181822, '2.40.10.10-FF-000633', NULL, NULL, 231, NULL, NULL, 181822),
(181823, '1.20.1070.10-FF-000683', NULL, 'Serpentine receptor class alpha-12', 309, NULL, NULL, 181823),
(181824, '3.40.47.10-FF-000108', NULL, 'Beta-ketoacyl-ACP synthase III', 324, NULL, NULL, 181824),
(181825, '1.25.40.10-FF-001791', NULL, 'Pentatricopeptide repeat-containing protein At3g58590', 166, NULL, NULL, 181825),
(181826, '3.80.10.10-FF-001646', NULL, 'Putative inactive leucine-rich repeat receptor-like protein kinase', 155, NULL, NULL, 181826),
(181827, '2.120.10.30-FF-000017', NULL, 'Low-density lipoprotein receptor-related protein 6', 329, NULL, NULL, 181827),
(181828, '1.25.40.20-FF-001131', NULL, 'Kinase, NEK', 311, NULL, NULL, 181828),
(181829, '3.30.200.20-FF-002020', NULL, NULL, 93, NULL, NULL, 181829),
(181830, '1.10.840.10-FF-000043', NULL, 'Uncharacterized protein', 265, NULL, NULL, 181830),
(181831, '3.40.50.300-FF-002478', NULL, 'Flagellar biosynthesis regulator FlhF', 184, NULL, NULL, 181831),
(181832, '1.10.10.10-FF-001463', NULL, 'Transcriptional regulator', 103, NULL, NULL, 181832),
(181833, '1.25.40.10-FF-000622', NULL, 'Signal recognition particle subunit SRP72', 101, NULL, NULL, 181833),
(181834, '1.25.40.20-FF-000855', NULL, 'Calcium-independent phospholipase A2 VIA, isoform A', 149, NULL, NULL, 181834),
(181835, '2.120.10.10-FF-000011', NULL, 'Sialidase 3b', 379, NULL, NULL, 181835),
(181836, '3.10.350.10-FF-000099', NULL, 'Outer membrane antigenic lipoprotein B', 64, NULL, NULL, 181836),
(181837, '3.30.160.20-FF-000066', NULL, '30S ribosomal protein S5', 72, NULL, NULL, 181837),
(181838, '1.20.1260.10-FF-000057', NULL, 'Ferritin', 171, NULL, NULL, 181838),
(181839, '1.20.120.1080-FF-000009', NULL, 'Probable ATP-dependent RNA helicase DHX40', 101, NULL, NULL, 181839),
(181840, '1.10.238.10-FF-000486', NULL, 'Probable calcium-binding protein CML44', 62, NULL, NULL, 181840),
(181841, '1.20.58.900-FF-000039', NULL, 'RUN and FYVE domain-containing 4', 89, NULL, NULL, 181841),
(181842, '3.40.190.10-FF-000293', NULL, 'Probable sugar-binding lipoprotein lpqY', 80, NULL, NULL, 181842),
(181843, '2.60.120.970-FF-000083', NULL, 'Putative Activin/Myostatin/TGF-beta-class TGF-beta signal molecule', 217, NULL, NULL, 181843),
(181844, '1.10.510.10-FF-001024', NULL, 'AGC protein kinase', 191, NULL, NULL, 181844),
(181845, '3.40.140.70-FF-000004', NULL, 'Ubiquitin-like modifier-activating enzyme atg7', 176, NULL, NULL, 181845),
(181846, '1.20.920.10-FF-000047', NULL, 'Bromodomain-containing factor 1', 125, NULL, NULL, 181846),
(181847, '3.30.1510.10-FF-000005', NULL, 'Pugilist, isoform E', 101, NULL, NULL, 181847),
(181848, '1.20.1160.11-FF-000011', NULL, 'Paired amphipathic helix protein Sin3-like 3', 63, NULL, NULL, 181848),
(181849, '3.40.800.10-FF-000037', NULL, NULL, 194, NULL, NULL, 181849),
(181850, '3.40.50.620-FF-000770', NULL, 'Uncharacterized protein', 115, NULL, NULL, 181850),
(181851, '3.40.50.10320-FF-000002', NULL, 'Probable N-acetylglucosaminyl-phosphatidylinositol de-N-acetylase', 223, NULL, NULL, 181851),
(181852, '3.30.70.330-FF-002398', NULL, NULL, 95, NULL, NULL, 181852),
(181853, '3.40.50.300-FF-001961', NULL, 'Multidrug resistance protein', 190, NULL, NULL, 181853),
(181854, '2.40.50.140-FF-000028', NULL, 'Ribonuclease G', 97, NULL, NULL, 181854),
(181855, '2.40.160.10-FF-000019', NULL, 'Outer membrane OprD family porin', 419, NULL, NULL, 181855),
(181856, '3.30.420.40-FF-000772', NULL, 'Bifunctional 3-dehydroquinate synthase/phosphatase', 117, NULL, NULL, 181856),
(181857, '3.30.160.60-FF-000280', NULL, 'PLAG1 like zinc finger 2', 41, NULL, NULL, 181857),
(181858, '2.60.120.10-FF-000586', NULL, 'Crp/FNR family transcriptional regulator', 114, NULL, NULL, 181858);
INSERT INTO "PUBLIC"."MODEL" VALUES
(181859, '2.40.50.430-FF-000003', NULL, 'DNA polymerase delta, small subunit, putative', 136, NULL, NULL, 181859),
(181860, '1.10.8.60-FF-000509', NULL, 'Vacuolar protein-sorting protein, putative', 60, NULL, NULL, 181860),
(181861, '2.10.25.10-FF-000820', NULL, 'CBN-MEC-1 protein', 79, NULL, NULL, 181861),
(181862, '3.30.70.1820-FF-000018', NULL, NULL, 63, NULL, NULL, 181862),
(181863, '1.10.510.10-FF-002648', NULL, NULL, 193, NULL, NULL, 181863),
(181864, '2.130.10.10-FF-004996', NULL, 'Uncharacterized protein', 66, NULL, NULL, 181864),
(181865, '3.10.150.10-FF-000005', NULL, 'Beta sliding clamp', 129, NULL, NULL, 181865),
(181866, '4.10.530.10-FF-000002', NULL, 'Fibrinogen gamma chain', 94, NULL, NULL, 181866),
(181867, '1.25.40.10-FF-002752', NULL, 'YALI0C23188p', 197, NULL, NULL, 181867),
(181868, '2.60.40.60-FF-000497', NULL, 'DE-cadherin', 109, NULL, NULL, 181868),
(181869, '3.30.200.20-FF-001744', NULL, 'Fibrillarin-like rRNA/tRNA 2''-O-methyltransferase', 46, NULL, NULL, 181869),
(181870, '1.10.565.10-FF-000217', NULL, 'Uncharacterized protein', 92, NULL, NULL, 181870),
(181871, '3.30.70.2820-FF-000009', NULL, NULL, 91, NULL, NULL, 181871),
(181872, '3.40.50.2000-FF-000789', NULL, 'Glycosyltransferase', 156, NULL, NULL, 181872),
(181873, '1.10.10.10-FF-000614', NULL, 'Unplaced genomic scaffold supercont1.238, whole genome shotgun sequence', 104, NULL, NULL, 181873),
(181874, '3.90.1290.10-FF-000041', NULL, 'VAB-10A protein', 102, NULL, NULL, 181874),
(181875, '3.30.310.130-FF-000015', NULL, 'SUMO-specific peptidase 6b', 54, NULL, NULL, 181875),
(181876, '1.20.920.30-FF-000042', NULL, 'YALI0E32857p', 190, NULL, NULL, 181876),
(181877, '2.130.10.10-FF-004198', NULL, 'Predicted protein', 158, NULL, NULL, 181877),
(181878, '3.40.50.1110-FF-000067', NULL, 'Acetylxylan esterase', 186, NULL, NULL, 181878),
(181879, '3.30.160.60-FF-002180', NULL, 'Zinc finger protein 284', 28, NULL, NULL, 181879),
(181880, '3.40.50.1820-FF-001241', NULL, 'Carboxylic ester hydrolase', 324, NULL, NULL, 181880),
(181881, '1.25.40.10-FF-001471', NULL, 'RNA polymerase-associated protein CTR9', 292, NULL, NULL, 181881),
(181882, '3.40.50.300-FF-006632', NULL, 'Putative IS element ATP-binding protein', 91, NULL, NULL, 181882),
(181883, '3.40.50.300-FF-003439', NULL, 'ATP-dependent DNA helicase CHL1', 223, NULL, NULL, 181883),
(181884, '2.40.30.10-FF-000067', NULL, '39S ribosomal protein L3, mitochondrial', 102, NULL, NULL, 181884),
(181885, '3.10.50.40-FF-000143', NULL, 'Peptidylprolyl isomerase', 142, NULL, NULL, 181885),
(181886, '3.30.70.330-FF-001881', NULL, NULL, 96, NULL, NULL, 181886),
(181887, '3.30.200.20-FF-000463', NULL, 'Serine/threonine-protein kinase AFC2', 86, NULL, NULL, 181887),
(181888, '3.30.40.10-FF-000032', NULL, 'Tripartite motif containing 2', 84, NULL, NULL, 181888),
(181889, '1.10.10.10-FF-002082', NULL, 'ADR025Wp', 90, NULL, NULL, 181889),
(181890, '3.40.50.2300-FF-000334', NULL, 'Vomeronasal 2, receptor 56', 137, NULL, NULL, 181890),
(181891, '3.30.160.60-FF-003276', NULL, 'Zinc finger protein 786', 64, NULL, NULL, 181891),
(181892, '1.10.418.10-FF-000034', NULL, 'Fimbrin-2 like', 118, NULL, NULL, 181892),
(181893, '2.40.70.10-FF-000417', NULL, NULL, 130, NULL, NULL, 181893),
(181894, '1.20.1250.10-FF-000129', NULL, NULL, 111, NULL, NULL, 181894),
(181895, '1.10.10.10-FF-000035', NULL, 'General transcription factor IIF subunit 2', 69, NULL, NULL, 181895),
(181896, '2.40.128.30-FF-000001', NULL, 'Avidin-related protein 2', 128, NULL, NULL, 181896),
(181897, '2.30.30.40-FF-000267', NULL, 'E3 ubiquitin-protein ligase HECTD1 isoform X3', 70, NULL, NULL, 181897),
(181898, '3.40.50.1820-FF-001365', NULL, 'Uncharacterized protein', 228, NULL, NULL, 181898),
(181899, '1.20.1310.10-FF-000174', NULL, NULL, 124, NULL, NULL, 181899),
(181900, '1.10.1280.10-FF-000004', NULL, 'Hemocyanin subunit 2', 269, NULL, NULL, 181900),
(181901, '3.40.50.720-FF-001513', NULL, 'Thiamine biosynthesis protein ThiF', 167, NULL, NULL, 181901),
(181902, '2.80.10.50-FF-000154', NULL, 'Uncharacterized protein', 83, NULL, NULL, 181902);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(181903, '3.40.50.150-FF-001668', NULL, NULL, 175, NULL, NULL, 181903),
(181904, '3.40.50.720-FF-000895', NULL, 'Uroporphyrinogen-III C-methyltransferase', 144, NULL, NULL, 181904),
(181905, '1.20.1280.290-FF-000105', NULL, 'Predicted protein', 62, NULL, NULL, 181905),
(181906, '1.10.560.10-FF-000122', NULL, 'TCP-1/cpn60 chaperonin family protein', 121, NULL, NULL, 181906),
(181907, '1.20.5.120-FF-000002', NULL, 'proteasome activator complex subunit 2', 60, NULL, NULL, 181907),
(181908, '3.40.50.720-FF-001171', NULL, 'ARP protein (REF)', 237, NULL, NULL, 181908),
(181909, '3.90.79.10-FF-000011', NULL, 'ADP-ribose pyrophosphatase', 209, NULL, NULL, 181909),
(181910, '2.40.50.90-FF-000159', NULL, 'AGAP004543-PA', 106, NULL, NULL, 181910),
(181911, '4.10.110.10-FF-000010', NULL, 'LOC100145517 protein', 48, NULL, NULL, 181911),
(181912, '3.40.50.720-FF-000232', NULL, 'Prephenate dehydrogenase family protein', 160, NULL, NULL, 181912),
(181913, '1.10.132.30-FF-000033', NULL, 'DNA-directed RNA polymerase subunit', 166, NULL, NULL, 181913),
(181914, '2.60.120.260-FF-000106', NULL, 'Beta-galactosidase, putative', 183, NULL, NULL, 181914),
(181915, '1.20.1070.10-FF-001094', NULL, 'D(1) dopamine receptor', 316, NULL, NULL, 181915),
(181916, '3.40.910.10-FF-000028', NULL, 'Deoxyhypusine synthase', 141, NULL, NULL, 181916),
(181917, '2.160.20.10-FF-000173', NULL, 'Pectinesterase', 87, NULL, NULL, 181917),
(181918, '1.20.58.980-FF-000001', NULL, 'Kinesin, putative', 87, NULL, NULL, 181918),
(181919, '1.10.442.10-FF-000005', NULL, NULL, 55, NULL, NULL, 181919),
(181920, '2.60.40.10-FF-003489', NULL, NULL, 94, NULL, NULL, 181920),
(181921, '3.30.1370.30-FF-000011', NULL, '30S ribosomal protein S8, chloroplastic', 79, NULL, NULL, 181921),
(181922, '1.10.510.10-FF-003497', NULL, NULL, 256, NULL, NULL, 181922),
(181923, '3.90.226.10-FF-000236', NULL, '(3,5-dihydroxyphenyl)acetyl-CoA 1,2-dioxygenase', 294, NULL, NULL, 181923),
(181924, '2.40.50.100-FF-000140', NULL, 'ABC transporter ATP-binding protein', 87, NULL, NULL, 181924),
(181925, '2.40.50.1070-FF-000016', NULL, '23S rRNA (Uracil-5-)-methyltransferase RumA', 170, NULL, NULL, 181925),
(181926, '1.25.10.10-FF-002924', NULL, 'Uncharacterized protein', 101, NULL, NULL, 181926),
(181927, '2.60.120.200-FF-000690', NULL, 'Uncharacterized protein', 201, NULL, NULL, 181927),
(181928, '3.40.250.10-FF-000028', NULL, 'Sulfurtransferase', 153, NULL, NULL, 181928),
(181929, '3.40.640.10-FF-000491', NULL, 'kynurenine/alpha-aminoadipate aminotransferase, mitochondrial-like isoform X4', 429, NULL, NULL, 181929),
(181930, '3.40.50.150-FF-000819', NULL, 'Protein CBG14642', 224, NULL, NULL, 181930),
(181931, '3.20.20.70-FF-000217', NULL, '3-dehydroquinate dehydratase', 225, NULL, NULL, 181931),
(181932, '2.120.10.80-FF-000015', NULL, 'host cell factor 1 isoform X1', 232, NULL, NULL, 181932),
(181933, '1.10.472.10-FF-000176', NULL, 'origin recognition complex subunit 6', 91, NULL, NULL, 181933),
(181934, '3.30.559.70-FF-000063', NULL, 'Carnitine acyltransferase, putative', 77, NULL, NULL, 181934),
(181935, '3.30.70.330-FF-000245', NULL, 'RNA-binding protein 33 isoform X4', 89, NULL, NULL, 181935),
(181936, '1.20.1560.10-FF-000658', NULL, 'Uncharacterized protein', 90, NULL, NULL, 181936),
(181937, '3.90.1140.10-FF-000042', NULL, 'Uncharacterized protein', 174, NULL, NULL, 181937),
(181938, '3.40.605.10-FF-000145', NULL, 'Aldehyde dehydrogenase, putative', 50, NULL, NULL, 181938),
(181939, '1.10.1170.10-FF-000013', NULL, 'Baculoviral IAP repeat-containing protein 1', 114, NULL, NULL, 181939),
(181940, '3.30.160.60-FF-000403', NULL, 'Putative zinc finger protein 462', 85, NULL, NULL, 181940),
(181941, '3.80.10.10-FF-000466', NULL, 'NLR family CARD domain containing 5', 122, NULL, NULL, 181941),
(181942, '2.30.42.10-FF-000600', NULL, NULL, 100, NULL, NULL, 181942),
(181943, '3.30.160.60-FF-004237', NULL, NULL, 26, NULL, NULL, 181943),
(181944, '1.10.565.10-FF-000094', NULL, 'Protein CBG10507', 200, NULL, NULL, 181944),
(181945, '1.10.10.160-FF-000059', NULL, 'DNA helicase', 103, NULL, NULL, 181945);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(181946, '3.40.50.800-FF-000037', NULL, 'GCN2p Protein kinase', 106, NULL, NULL, 181946),
(181947, '3.40.50.2300-FF-000997', NULL, NULL, 138, NULL, NULL, 181947),
(181948, '2.60.40.10-FF-000055', NULL, 'roundabout homolog 1 isoform X2', 109, NULL, NULL, 181948),
(181949, '3.30.505.10-FF-000022', NULL, 'Growth factor receptor-bound protein 2', 114, NULL, NULL, 181949),
(181950, '1.25.10.10-FF-003200', NULL, 'AP complex subunit beta', 584, NULL, NULL, 181950),
(181951, '2.60.120.10-FF-000243', NULL, 'Phospholipase A2', 296, NULL, NULL, 181951),
(181952, '2.130.10.10-FF-002523', NULL, 'Intraflagellar transport protein osm-1', 253, NULL, NULL, 181952),
(181953, '3.40.720.10-FF-000216', NULL, 'DUF229 domain-containing protein', 319, NULL, NULL, 181953),
(181954, '3.30.460.10-FF-000125', NULL, 'DNA polymerase sigma-like protein', 61, NULL, NULL, 181954),
(181955, '2.130.10.10-FF-003933', NULL, 'Uncharacterized protein', 255, NULL, NULL, 181955),
(181956, '3.40.30.10-FF-000340', NULL, 'Omega-class glutathione transferase', 167, NULL, NULL, 181956),
(181957, '2.30.30.140-FF-000313', NULL, 'Excision repair cross-complementation group 6-like 2', 62, NULL, NULL, 181957),
(181958, '3.30.160.60-FF-006232', NULL, NULL, 29, NULL, NULL, 181958),
(181959, '2.20.70.10-FF-000014', NULL, 'E3 ubiquitin-protein ligase SMURF1', 37, NULL, NULL, 181959),
(181960, '3.40.50.150-FF-001770', NULL, NULL, 205, NULL, NULL, 181960),
(181961, '1.20.5.340-FF-000040', NULL, 'GUK-holder, isoform B', 63, NULL, NULL, 181961),
(181962, '1.25.40.10-FF-005181', NULL, 'Uncharacterized protein', 38, NULL, NULL, 181962),
(181963, '3.40.50.720-FF-002132', NULL, 'Predicted protein', 104, NULL, NULL, 181963),
(181964, '1.10.3720.10-FF-000174', NULL, 'NitT/TauT family transport system permease protein', 195, NULL, NULL, 181964),
(181965, '3.30.1330.10-FF-000019', NULL, 'Phosphoribosylformylglycinamidine synthase', 165, NULL, NULL, 181965),
(181966, '3.30.40.10-FF-001908', NULL, 'Os12g0143750 protein', 73, NULL, NULL, 181966),
(181967, '3.40.50.300-FF-003990', NULL, 'Si:ch73-63e15.2', 143, NULL, NULL, 181967),
(181968, '2.60.120.200-FF-000358', NULL, 'Putative receptor kinase Lecrk', 263, NULL, NULL, 181968),
(181969, '3.30.365.10-FF-000033', NULL, 'Nicotinate dehydrogenase subunit B', 173, NULL, NULL, 181969),
(181970, '1.20.1070.10-FF-001655', NULL, 'Predicted protein', 130, NULL, NULL, 181970),
(181971, '1.20.1410.10-FF-000007', NULL, 'Transmembrane protein 98', 91, NULL, NULL, 181971),
(181972, '1.10.730.10-FF-000052', NULL, 'Valine-tRNA ligase', 270, NULL, NULL, 181972),
(181973, '1.25.10.10-FF-001963', NULL, 'Serine/threonine-protein kinase atr', 215, NULL, NULL, 181973),
(181974, '3.40.50.300-FF-004732', NULL, 'Protein CBR-GOA-1', 106, NULL, NULL, 181974),
(181975, '2.30.130.10-FF-000008', NULL, 'Glutamate 5-kinase', 111, NULL, NULL, 181975),
(181976, '3.30.1010.10-FF-000080', NULL, 'Uncharacterized protein', 137, NULL, NULL, 181976),
(181977, '3.90.70.10-FF-000609', NULL, 'Uncharacterized protein', 170, NULL, NULL, 181977),
(181978, '2.60.40.10-FF-000179', NULL, 'Myomesin 2', 111, NULL, NULL, 181978),
(181979, '1.20.58.60-FF-000401', NULL, 'Dystrophin-related protein 2', 128, NULL, NULL, 181979),
(181980, '2.60.40.2430-FF-000004', NULL, NULL, 143, NULL, NULL, 181980),
(181981, '3.60.20.30-FF-000001', NULL, 'Isoaspartyl peptidase/L-asparaginase', 134, NULL, NULL, 181981),
(181982, '3.30.720.210-FF-000014', NULL, 'ATP-dependent zinc metalloprotease FtsH', 75, NULL, NULL, 181982),
(181983, '1.10.3210.10-FF-000091', NULL, 'Uncharacterized protein', 123, NULL, NULL, 181983),
(181984, '4.10.400.10-FF-000341', NULL, 'Vitellogenin receptor', 36, NULL, NULL, 181984),
(181985, '1.25.40.10-FF-003371', NULL, 'Pentatricopeptide repeat-containing protein At1g13040, mitochondrial', 59, NULL, NULL, 181985),
(181986, '3.30.200.20-FF-002363', NULL, 'Receptor protein serine/threonine kinase', 103, NULL, NULL, 181986),
(181987, '3.40.47.10-FF-000221', NULL, NULL, 136, NULL, NULL, 181987),
(181988, '2.40.340.10-FF-000005', NULL, 'Molybdopterin molybdenumtransferase MoeA', 76, NULL, NULL, 181988);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(181989, '3.90.1150.10-FF-000003', NULL, 'Serine hydroxymethyltransferase', 162, NULL, NULL, 181989),
(181990, '3.30.70.330-FF-001779', NULL, NULL, 84, NULL, NULL, 181990),
(181991, '3.90.550.50-FF-000147', NULL, 'Glycosyltransferase family 31 protein', 157, NULL, NULL, 181991),
(181992, '3.30.200.20-FF-001183', NULL, 'Uncharacterized protein', 82, NULL, NULL, 181992),
(181993, '3.30.40.10-FF-001448', NULL, 'Uncharacterized protein', 96, NULL, NULL, 181993),
(181994, '4.10.280.10-FF-000123', NULL, 'Transcription factor bHLH113', 72, NULL, NULL, 181994),
(181995, '3.30.479.20-FF-000036', NULL, 'Elongation factor Ts', 91, NULL, NULL, 181995),
(181996, '3.20.20.70-FF-000554', NULL, NULL, 124, NULL, NULL, 181996),
(181997, '3.40.50.2300-FF-001514', NULL, NULL, 94, NULL, NULL, 181997),
(181998, '1.25.40.10-FF-005169', NULL, 'Putative UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SEC', 71, NULL, NULL, 181998),
(181999, '1.10.1450.10-FF-000170', NULL, 'Tetraspanin', 54, NULL, NULL, 181999),
(182000, '2.130.10.10-FF-000600', NULL, 'Protein ROOT INITIATION DEFECTIVE 3', 238, NULL, NULL, 182000),
(182001, '2.60.120.620-FF-000017', NULL, 'Transmembrane prolyl 4-hydroxylase', 215, NULL, NULL, 182001),
(182002, '1.10.20.10-FF-000227', NULL, NULL, 72, NULL, NULL, 182002),
(182003, '2.130.10.10-FF-001112', NULL, 'Katanin p80 WD40 repeat-containing subunit B1', 136, NULL, NULL, 182003),
(182004, '3.10.20.90-FF-000757', NULL, 'PDZ domain-containing protein', 92, NULL, NULL, 182004),
(182005, '3.40.50.300-FF-006289', NULL, 'Putative tetracycline resistance protein', 227, NULL, NULL, 182005),
(182006, '3.40.30.10-FF-000126', NULL, 'Protein disulfide-isomerase A4', 112, NULL, NULL, 182006),
(182007, '1.25.40.180-FF-000067', NULL, 'Eukaryotic translation initiation factor 5', 146, NULL, NULL, 182007),
(182008, '3.30.420.10-FF-000448', NULL, 'DNA polymerase theta', 197, NULL, NULL, 182008),
(182009, '2.40.160.50-FF-000003', NULL, 'Outer membrane protein, OMP85 family', 312, NULL, NULL, 182009),
(182010, '3.30.710.10-FF-000212', NULL, 'Os02g0225100 protein', 173, NULL, NULL, 182010),
(182011, '1.10.150.20-FF-000072', NULL, 'Pre-mRNA-splicing helicase BRR2, putative', 59, NULL, NULL, 182011),
(182012, '3.40.50.300-FF-002023', NULL, 'ATP-dependent DNA helicase Q1', 230, NULL, NULL, 182012),
(182013, '3.40.50.720-FF-001064', NULL, '(+)-neomenthol dehydrogenase', 192, NULL, NULL, 182013),
(182014, '3.30.70.330-FF-002050', NULL, NULL, 149, NULL, NULL, 182014),
(182015, '3.30.70.330-FF-001431', NULL, 'Os05g0303600 protein', 110, NULL, NULL, 182015),
(182016, '2.60.40.1170-FF-000025', NULL, 'AP-5 complex subunit mu isoform X1', 88, NULL, NULL, 182016),
(182017, '3.40.50.880-FF-000139', NULL, 'Imidazole glycerol phosphate synthase hisHF', 263, NULL, NULL, 182017),
(182018, '3.30.160.60-FF-003725', NULL, NULL, 26, NULL, NULL, 182018),
(182019, '2.130.10.10-FF-005390', NULL, 'RaBConnectin related', 153, NULL, NULL, 182019),
(182020, '1.25.40.10-FF-000279', NULL, 'Tetratricopeptide repeat domain 21A', 176, NULL, NULL, 182020),
(182021, '2.60.40.1470-FF-000002', NULL, 'F-box only protein 3', 133, NULL, NULL, 182021),
(182022, '2.60.210.10-FF-000019', NULL, 'TNF-receptor-associated factor 2', 193, NULL, NULL, 182022),
(182023, '3.30.160.60-FF-003832', NULL, NULL, 27, NULL, NULL, 182023),
(182024, '2.130.10.10-FF-006002', NULL, 'Uncharacterized protein', 74, NULL, NULL, 182024),
(182025, '3.40.50.300-FF-006401', NULL, 'Uncharacterized protein', 133, NULL, NULL, 182025),
(182026, '2.60.120.200-FF-000459', NULL, 'Laminin, alpha 3', 154, NULL, NULL, 182026),
(182027, '3.40.50.10310-FF-000016', NULL, 'Uncharacterized protein', 234, NULL, NULL, 182027),
(182028, '1.10.287.110-FF-000427', NULL, 'Uncharacterized protein', 88, NULL, NULL, 182028),
(182029, '3.30.160.60-FF-000055', NULL, 'B-cell lymphoma/leukemia 11A isoform X1', 28, NULL, NULL, 182029),
(182030, '1.20.900.10-FF-000057', NULL, 'Rho guanine nucleotide exchange factor 38', 104, NULL, NULL, 182030),
(182031, '3.40.50.10330-FF-000123', NULL, 'Diacylglycerol kinase', 163, NULL, NULL, 182031);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(182032, '3.30.499.10-FF-000028', NULL, 'Aconitate hydratase, hypothetical (Eurofung)', 112, NULL, NULL, 182032),
(182033, '3.30.70.890-FF-000053', NULL, 'Mevalonate kinase', 129, NULL, NULL, 182033),
(182034, '1.50.10.10-FF-000157', NULL, 'Uncharacterized protein', 398, NULL, NULL, 182034),
(182035, '2.60.40.10-FF-002657', NULL, 'Brother of ihog, isoform B', 82, NULL, NULL, 182035),
(182036, '1.20.120.350-FF-000267', NULL, NULL, 111, NULL, NULL, 182036),
(182037, '3.30.110.20-FF-000012', NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', 139, NULL, NULL, 182037),
(182038, '2.60.40.10-FF-003169', NULL, 'FiLamiN (Actin binding protein) homolog', 93, NULL, NULL, 182038),
(182039, '2.60.40.150-FF-000542', NULL, 'Phosphoinositide phospholipase C', 128, NULL, NULL, 182039),
(182040, '1.20.1560.10-FF-000439', NULL, 'ATP-binding cassette transporter, subfamily B, member 21, group MDR/PGP protein PpABCB21', 192, NULL, NULL, 182040),
(182041, '3.40.50.150-FF-000606', NULL, 'Hemolysin (Tly)', 177, NULL, NULL, 182041),
(182042, '1.20.1070.10-FF-000795', NULL, 'Vomeronasal type-1 receptor', 221, NULL, NULL, 182042),
(182043, '3.40.50.410-FF-000139', NULL, 'Predicted protein', 194, NULL, NULL, 182043),
(182044, '3.30.230.10-FF-000170', NULL, 'Galactokinase-like protein', 251, NULL, NULL, 182044),
(182045, '3.10.105.10-FF-000035', NULL, 'Dipeptide-binding ABC transporter, periplasmic substrate-binding component', 209, NULL, NULL, 182045),
(182046, '3.40.50.300-FF-002130', NULL, 'DNA mismatch repair protein MSH3', 275, NULL, NULL, 182046),
(182047, '3.20.180.20-FF-000007', NULL, 'Dynein heavy chain domain 1', 115, NULL, NULL, 182047),
(182048, '3.40.395.10-FF-000044', NULL, 'Uncharacterized protein', 103, NULL, NULL, 182048),
(182049, '1.10.287.210-FF-000002', NULL, 'Syncytin-2', 103, NULL, NULL, 182049),
(182050, '3.10.20.90-FF-000864', NULL, 'Uncharacterized protein', 73, NULL, NULL, 182050),
(182051, '2.60.40.60-FF-000059', NULL, 'FAT atypical cadherin 3', 115, NULL, NULL, 182051),
(182052, '2.60.40.10-FF-003276', NULL, NULL, 103, NULL, NULL, 182052),
(182053, '3.40.50.300-FF-004058', NULL, 'Origin recognition complex subunit 1', 191, NULL, NULL, 182053),
(182054, '1.10.555.10-FF-000043', NULL, 'Rho GTPase activator Rga', 205, NULL, NULL, 182054),
(182055, '1.10.238.10-FF-000935', NULL, 'Penta-EF hand domain-containing protein 2', 192, NULL, NULL, 182055),
(182056, '1.10.470.10-FF-000008', NULL, 'Variant surface glycoprotein (VSG), putative', 158, NULL, NULL, 182056),
(182057, '3.20.20.70-FF-000661', NULL, NULL, 228, NULL, NULL, 182057),
(182058, '3.30.497.10-FF-000103', NULL, 'Serpin B10', 152, NULL, NULL, 182058),
(182059, '3.40.140.10-FF-000144', NULL, 'Cytidine deaminase', 115, NULL, NULL, 182059),
(182060, '2.60.40.60-FF-000053', NULL, 'FAT atypical cadherin 3', 104, NULL, NULL, 182060),
(182061, '4.10.280.10-FF-000016', NULL, 'Sterol regulatory element-binding transcription factor 1', 81, NULL, NULL, 182061),
(182062, '1.20.5.110-FF-000224', NULL, 'Uncharacterized protein', 72, NULL, NULL, 182062),
(182063, '1.20.1250.20-FF-001526', NULL, 'Uncharacterized protein', 470, NULL, NULL, 182063),
(182064, '3.30.160.60-FF-006468', NULL, NULL, 52, NULL, NULL, 182064),
(182065, '1.25.40.470-FF-000047', NULL, 'Coatomer subunit beta''-3', 50, NULL, NULL, 182065),
(182066, '2.40.30.10-FF-000522', NULL, 'Elongation factor Tu GTP binding domain containing protein', 135, NULL, NULL, 182066),
(182067, '3.30.200.20-FF-000238', NULL, 'Putative serine/threonine-protein kinase ULK3', 91, NULL, NULL, 182067),
(182068, '3.30.830.10-FF-000266', NULL, 'Mitochondrial presequence protease', 253, NULL, NULL, 182068),
(182069, '1.25.40.20-FF-001917', NULL, 'Uncharacterized protein', 192, NULL, NULL, 182069),
(182070, '1.20.58.80-FF-000053', NULL, 'STAM-binding protein b', 146, NULL, NULL, 182070),
(182071, '3.30.70.1230-FF-000050', NULL, 'Guanylate cyclase', 222, NULL, NULL, 182071),
(182072, '1.25.10.10-FF-003099', NULL, 'Uncharacterized protein', 222, NULL, NULL, 182072),
(182073, '1.25.10.10-FF-001986', NULL, 'Putative pumilio/PUF RNA binding protein 7', 309, NULL, NULL, 182073);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(182074, '3.40.50.1000-FF-000613', NULL, NULL, 73, NULL, NULL, 182074),
(182075, '2.40.30.10-FF-000415', NULL, 'Predicted protein', 105, NULL, NULL, 182075),
(182076, '3.30.420.610-FF-000010', NULL, 'Meiosis regulator and mRNA stability factor 1', 77, NULL, NULL, 182076),
(182077, '3.30.40.10-FF-002061', NULL, 'Uncharacterized protein', 89, NULL, NULL, 182077),
(182078, '1.10.238.20-FF-000034', NULL, 'Odorant-binding protein 8', 115, NULL, NULL, 182078),
(182079, '3.30.1490.20-FF-000056', NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta', 84, NULL, NULL, 182079),
(182080, '2.30.29.30-FF-000862', NULL, 'Ran-specific GTPase-activating protein', 144, NULL, NULL, 182080),
(182081, '1.10.150.240-FF-000012', NULL, 'Glycerol-1-phosphate phosphohydrolase 1', 62, NULL, NULL, 182081),
(182082, '3.40.50.410-FF-000358', NULL, 'Uncharacterized protein', 66, NULL, NULL, 182082),
(182083, '2.30.42.10-FF-000151', NULL, 'Still life isoforms C/SIF type 2', 95, NULL, NULL, 182083),
(182084, '2.130.10.10-FF-002416', NULL, 'Small nucleolar ribonucleoprotein complex subunit (SOF1), putative', 99, NULL, NULL, 182084),
(182085, '3.90.1410.10-FF-000023', NULL, 'YHL039W-like protein', 260, NULL, NULL, 182085),
(182086, '3.30.1370.10-FF-000117', NULL, 'Poly(rC) binding protein 4', 42, NULL, NULL, 182086),
(182087, '1.20.1070.10-FF-000688', NULL, 'Neuropeptide FF receptor 2', 341, NULL, NULL, 182087),
(182088, '2.130.10.10-FF-001904', NULL, 'Dynein intermediate chain, putative', 164, NULL, NULL, 182088),
(182089, '3.80.10.10-FF-002607', NULL, 'Nuclear RNA export factor 7', 66, NULL, NULL, 182089),
(182090, '3.90.70.10-FF-000486', NULL, 'probable ubiquitin carboxyl-terminal hydrolase FAF-X isoform X2', 220, NULL, NULL, 182090),
(182091, '2.60.98.50-FF-000003', NULL, 'Envelopment polyprotein', 82, NULL, NULL, 182091),
(182092, '1.25.10.10-FF-000682', NULL, 'Putative splicing factor 3B subunit 1', 168, NULL, NULL, 182092),
(182093, '2.60.40.10-FF-003383', NULL, NULL, 89, NULL, NULL, 182093),
(182094, '1.20.1070.10-FF-001088', NULL, 'Rhodopsin, GQ-coupled', 320, NULL, NULL, 182094),
(182095, '3.40.50.300-FF-004491', NULL, 'TFIIH basal transcription factor complex helicase subunit', 250, NULL, NULL, 182095),
(182096, '3.80.10.10-FF-003552', NULL, 'Predicted protein', 154, NULL, NULL, 182096),
(182097, '3.30.200.60-FF-000003', NULL, 'Ubiquitin thioesterase OTUB1', 82, NULL, NULL, 182097),
(182098, '2.30.30.100-FF-000088', NULL, 'Small nuclear ribonucleoprotein Sm-G', 82, NULL, NULL, 182098),
(182099, '2.80.10.50-FF-000284', NULL, 'Predicted protein', 198, NULL, NULL, 182099),
(182100, '3.55.40.20-FF-000012', NULL, 'Superoxide dismutase', 114, NULL, NULL, 182100),
(182101, '1.20.1560.10-FF-000670', NULL, 'Uncharacterized protein', 39, NULL, NULL, 182101),
(182102, '3.30.70.660-FF-000001', NULL, 'tRNA pseudouridine synthase A', 138, NULL, NULL, 182102),
(182103, '3.30.428.10-FF-000005', NULL, 'Histidine triad nucleotide-binding protein 1', 126, NULL, NULL, 182103),
(182104, '1.20.5.1190-FF-000006', NULL, 'Sodium channel protein', 36, NULL, NULL, 182104),
(182105, '3.90.226.10-FF-000337', NULL, 'Predicted protein', 47, NULL, NULL, 182105),
(182106, '1.10.287.470-FF-000052', NULL, 'RND multidrug efflux membrane fusion protein', 74, NULL, NULL, 182106),
(182107, '3.40.50.2020-FF-000109', NULL, 'Orotate phosphoribosyltransferase', 181, NULL, NULL, 182107),
(182108, '3.30.70.330-FF-002847', NULL, NULL, 84, NULL, NULL, 182108),
(182109, '2.130.10.10-FF-004092', NULL, 'Uncharacterized WD repeat-containing protein C1A6.02', 198, NULL, NULL, 182109),
(182110, '2.60.40.60-FF-000160', NULL, 'cadherin-23 isoform X1', 103, NULL, NULL, 182110),
(182111, '2.30.29.30-FF-000070', NULL, 'Neurofibromin 1', 111, NULL, NULL, 182111),
(182112, '1.10.472.130-FF-000092', NULL, 'Dynein heavy chain, putative', 158, NULL, NULL, 182112),
(182113, '2.40.10.480-FF-000009', NULL, 'Cell surface protein', 81, NULL, NULL, 182113),
(182114, '2.30.39.10-FF-000137', NULL, 'Serpin, putative', 31, NULL, NULL, 182114),
(182115, '2.30.39.10-FF-000025', NULL, 'Serpin 77Bb', 167, NULL, NULL, 182115);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(182116, '3.40.720.10-FF-000115', NULL, 'GPI ethanolamine phosphate transferase 3', 297, NULL, NULL, 182116),
(182117, '1.20.1270.280-FF-000067', NULL, 'Uncharacterized protein', 135, NULL, NULL, 182117),
(182118, '2.10.110.10-FF-000102', NULL, 'LIM and SH3 domain protein Lasp', 66, NULL, NULL, 182118),
(182119, '1.25.40.10-FF-002319', NULL, 'DNA-binding protein', 94, NULL, NULL, 182119),
(182120, '2.70.70.10-FF-000034', NULL, 'Lipoprotein NlpD', 134, NULL, NULL, 182120),
(182121, '3.40.50.720-FF-001749', NULL, 'Putative zinc-binding oxidoreductase', 185, NULL, NULL, 182121),
(182122, '2.30.180.10-FF-000051', NULL, 'YLR001C-like protein', 129, NULL, NULL, 182122),
(182123, '3.80.10.10-FF-001410', NULL, 'PRAME family member 20', 266, NULL, NULL, 182123),
(182124, '3.40.50.1110-FF-000168', NULL, 'Phospholipase B1, membrane-associated', 211, NULL, NULL, 182124),
(182125, '3.30.160.60-FF-000847', NULL, 'Putative zinc finger protein 236', 23, NULL, NULL, 182125),
(182126, '2.120.10.30-FF-000011', NULL, 'Teneurin transmembrane protein 3', 75, NULL, NULL, 182126),
(182127, '3.40.50.2000-FF-000340', NULL, 'Phosphatidylinositol N-acetylglucosaminyltransferase subunit A', 86, NULL, NULL, 182127),
(182128, '3.50.7.10-FF-000040', NULL, NULL, 162, NULL, NULL, 182128),
(182129, '1.10.418.10-FF-000135', NULL, 'Domain_of_Uncharacterized_Function_(DUF1042)_-_pu tative', 108, NULL, NULL, 182129),
(182130, '2.40.50.140-FF-000023', NULL, 'Polyribonucleotide nucleotidyltransferase', 71, NULL, NULL, 182130),
(182131, '1.20.58.390-FF-000049', NULL, 'AcetylCholine Receptor', 127, NULL, NULL, 182131),
(182132, '1.25.40.10-FF-003264', NULL, 'Uncharacterized protein', 252, NULL, NULL, 182132),
(182133, '1.10.10.10-FF-000513', NULL, 'ATP-dependent DNA helicase', 126, NULL, NULL, 182133),
(182134, '2.60.40.150-FF-000435', NULL, 'Double C2-like domains, alpha', 76, NULL, NULL, 182134),
(182135, '1.10.555.10-FF-000155', NULL, NULL, 157, NULL, NULL, 182135),
(182136, '1.10.8.60-FF-000408', NULL, 'Uncharacterized protein', 75, NULL, NULL, 182136),
(182137, '3.40.50.300-FF-003546', NULL, 'Uncharacterized protein', 123, NULL, NULL, 182137),
(182138, '2.60.120.260-FF-000005', NULL, 'Netrin G1', 244, NULL, NULL, 182138),
(182139, '3.40.50.2300-FF-000093', NULL, 'L-arabinose-binding periplasmic protein', 155, NULL, NULL, 182139),
(182140, '1.10.150.50-FF-000075', NULL, 'Serine/threonine-protein kinase STE11', 79, NULL, NULL, 182140),
(182141, '1.10.2000.10-FF-000029', NULL, 'Predicted protein', 120, NULL, NULL, 182141),
(182142, '3.80.10.10-FF-001186', NULL, 'GL12775', 130, NULL, NULL, 182142),
(182143, '1.10.1450.10-FF-000063', NULL, 'Tetraspanin', 91, NULL, NULL, 182143),
(182144, '3.80.10.10-FF-000786', NULL, 'Preferentially-expressed antigen in melanoma', 149, NULL, NULL, 182144),
(182145, '3.60.60.20-FF-000001', NULL, 'Phospholipase B-like', 321, NULL, NULL, 182145),
(182146, '1.10.287.110-FF-000197', NULL, 'DnaJ domain containing protein', 81, NULL, NULL, 182146),
(182147, '2.60.120.260-FF-000550', NULL, 'Beta-glucuronidase', 58, NULL, NULL, 182147),
(182148, '1.25.10.10-FF-000570', NULL, 'Ubiquitin-protein ligase, expressed', 201, NULL, NULL, 182148),
(182149, '2.60.120.200-FF-000678', NULL, 'Uncharacterized protein', 45, NULL, NULL, 182149),
(182150, '3.40.50.2000-FF-000126', NULL, 'Glycosyltransferase 1 domain containing 1', 180, NULL, NULL, 182150),
(182151, '3.30.200.20-FF-000019', NULL, 'Mitogen-activated protein kinase', 94, NULL, NULL, 182151),
(182152, '3.30.70.1020-FF-000009', NULL, 'Related to alpha,alpha-trehalose-phosphate synthase, 115 KD subunit', 62, NULL, NULL, 182152),
(182153, '1.20.1300.20-FF-000002', NULL, 'Ubiquitin thioesterase otubain-like', 156, NULL, NULL, 182153),
(182154, '3.30.70.360-FF-000029', NULL, 'Dug2p', 162, NULL, NULL, 182154),
(182155, '3.10.20.870-FF-000019', NULL, NULL, 80, NULL, NULL, 182155),
(182156, '3.40.50.300-FF-002815', NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', 184, NULL, NULL, 182156),
(182157, '3.40.140.10-FF-000014', NULL, 'Eukaryotic translation initiation factor 3 subunit F', 172, NULL, NULL, 182157);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(182158, '3.30.70.2820-FF-000004', NULL, 'DNA polymerase', 118, NULL, NULL, 182158),
(182159, '1.25.10.10-FF-002132', NULL, 'Serine/threonine-protein kinase TOR', 107, NULL, NULL, 182159),
(182160, '3.10.100.10-FF-000171', NULL, 'Uncharacterized protein', 76, NULL, NULL, 182160),
(182161, '1.10.8.1220-FF-000035', NULL, NULL, 111, NULL, NULL, 182161),
(182162, '1.10.418.20-FF-000020', NULL, 'Uncharacterized protein', 65, NULL, NULL, 182162),
(182163, '3.40.50.300-FF-008217', NULL, 'Uncharacterized protein', 65, NULL, NULL, 182163),
(182164, '3.40.50.1240-FF-000090', NULL, '6-phosphofructo-2-kinase 1', 222, NULL, NULL, 182164),
(182165, '2.40.40.20-FF-000014', NULL, 'NADH-quinone oxidoreductase', 94, NULL, NULL, 182165),
(182166, '2.130.10.10-FF-000730', NULL, 'Chromosome 15, whole genome shotgun sequence', 333, NULL, NULL, 182166),
(182167, '3.90.930.12-FF-000015', NULL, 'Uncharacterized protein', 35, NULL, NULL, 182167),
(182168, '1.20.5.4770-FF-000001', NULL, 'Zinc finger AN1-type containing 6', 60, NULL, NULL, 182168),
(182169, '3.60.40.10-FF-000351', NULL, 'Predicted protein', 334, NULL, NULL, 182169),
(182170, '3.10.110.10-FF-000345', NULL, 'Uncharacterized protein', 151, NULL, NULL, 182170),
(182171, '3.40.30.10-FF-000233', NULL, 'Elongation factor 1-gamma', 76, NULL, NULL, 182171),
(182172, '1.10.238.10-FF-000250', NULL, 'reticulocalbin-1', 60, NULL, NULL, 182172),
(182173, '3.40.50.300-FF-007817', NULL, 'AGAP006939-PA', 279, NULL, NULL, 182173),
(182174, '1.10.10.350-FF-000015', NULL, 'Glutamate--tRNA ligase', 102, NULL, NULL, 182174),
(182175, '3.30.830.10-FF-000047', NULL, 'M16 family peptidase', 189, NULL, NULL, 182175),
(182176, '1.25.40.20-FF-000164', NULL, 'Mindbomb E3 ubiquitin protein ligase 1', 92, NULL, NULL, 182176),
(182177, '2.60.40.150-FF-000654', NULL, 'Copine 6', 109, NULL, NULL, 182177),
(182178, '3.50.50.60-FF-001193', NULL, 'Uncharacterized protein', 16, NULL, NULL, 182178),
(182179, '3.90.550.50-FF-000035', NULL, 'Fringe glycosyltransferase', 276, NULL, NULL, 182179),
(182180, '3.40.50.300-FF-004035', NULL, 'tRNA isopentenyl transferase', 259, NULL, NULL, 182180),
(182181, '3.40.50.10130-FF-000069', NULL, 'Uncharacterized protein', 57, NULL, NULL, 182181),
(182182, '3.60.10.10-FF-000175', NULL, 'Deoxyribonuclease 1 like 2', 219, NULL, NULL, 182182),
(182183, '3.90.950.10-FF-000014', NULL, 'Inosine triphosphate pyrophosphatase', 129, NULL, NULL, 182183),
(182184, '3.40.50.1000-FF-000490', NULL, NULL, 96, NULL, NULL, 182184),
(182185, '3.30.70.340-FF-000023', NULL, NULL, 90, NULL, NULL, 182185),
(182186, '3.30.559.10-FF-000197', NULL, 'Carnitine O-palmitoyltransferase II, putative', 274, NULL, NULL, 182186),
(182187, '1.50.10.10-FF-000045', NULL, 'Alpha-fucosidase A', 439, NULL, NULL, 182187),
(182188, '3.40.630.30-FF-000440', NULL, 'Uncharacterized protein', 205, NULL, NULL, 182188),
(182189, '1.25.40.10-FF-000521', NULL, 'ETO1-like protein 1', 103, NULL, NULL, 182189),
(182190, '3.10.100.10-FF-000283', NULL, NULL, 144, NULL, NULL, 182190),
(182191, '3.30.450.20-FF-000498', NULL, 'Response regulator', 120, NULL, NULL, 182191),
(182192, '3.30.160.60-FF-004214', NULL, NULL, 23, NULL, NULL, 182192),
(182193, '3.90.550.10-FF-000607', NULL, 'Predicted protein', 218, NULL, NULL, 182193),
(182194, '1.10.238.10-FF-000149', NULL, 'Mitochondrial calcium uptake family member 3', 153, NULL, NULL, 182194),
(182195, '1.10.510.10-FF-002547', NULL, 'Protein O-mannose kinase', 290, NULL, NULL, 182195),
(182196, '1.10.1170.10-FF-000018', NULL, 'X-linked inhibitor of apoptosis', 108, NULL, NULL, 182196),
(182197, '2.30.30.380-FF-000019', NULL, 'Calpain 15', 64, NULL, NULL, 182197),
(182198, '3.30.70.100-FF-000182', NULL, NULL, 104, NULL, NULL, 182198),
(182199, '1.10.260.100-FF-000039', NULL, 'Uncharacterized protein', 68, NULL, NULL, 182199),
(182200, '3.40.395.10-FF-000049', NULL, 'Predicted protein', 88, NULL, NULL, 182200),
(182201, '2.60.120.230-FF-000007', NULL, NULL, 93, NULL, NULL, 182201),
(182202, '1.20.58.100-FF-000007', NULL, 'L-aspartate oxidase', 87, NULL, NULL, 182202);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(182203, '3.20.20.40-FF-000006', NULL, 'Glucanase', 193, NULL, NULL, 182203),
(182204, '2.130.10.10-FF-001000', NULL, 'Uncharacterized protein, isoform A', 198, NULL, NULL, 182204),
(182205, '1.20.58.60-FF-000862', NULL, 'Si:ch211-207i1.2', 125, NULL, NULL, 182205),
(182206, '1.10.472.130-FF-000097', NULL, 'Uncharacterized protein', 139, NULL, NULL, 182206),
(182207, '3.10.310.10-FF-000001', NULL, 'Diaminopimelate epimerase', 122, NULL, NULL, 182207),
(182208, '1.10.510.10-FF-003492', NULL, NULL, 262, NULL, NULL, 182208),
(182209, '3.30.505.10-FF-000264', NULL, NULL, 73, NULL, NULL, 182209),
(182210, '3.30.70.330-FF-002162', NULL, NULL, 145, NULL, NULL, 182210),
(182211, '3.30.450.50-FF-000041', NULL, 'vesicle-associated membrane protein 7 isoform X3', 79, NULL, NULL, 182211),
(182212, '1.20.1070.10-FF-001195', NULL, 'Uncharacterized protein', 292, NULL, NULL, 182212),
(182213, '2.60.40.10-FF-004681', NULL, NULL, 88, NULL, NULL, 182213),
(182214, '3.40.50.720-FF-001194', NULL, 'Uncharacterized protein', 279, NULL, NULL, 182214),
(182215, '3.30.70.330-FF-001650', NULL, NULL, 99, NULL, NULL, 182215),
(182216, '1.10.274.30-FF-000025', NULL, 'Uncharacterized protein', 180, NULL, NULL, 182216),
(182217, '3.30.60.190-FF-000004', NULL, 'HIT-type Zinc finger family protein', 47, NULL, NULL, 182217),
(182218, '3.30.420.10-FF-000229', NULL, 'exonuclease 3''-5'' domain-containing protein 2 isoform X5', 133, NULL, NULL, 182218),
(182219, '2.60.40.10-FF-003388', NULL, NULL, 93, NULL, NULL, 182219),
(182220, '1.10.510.10-FF-002199', NULL, NULL, 148, NULL, NULL, 182220),
(182221, '1.20.1250.20-FF-000222', NULL, 'Solute carrier organic anion transporter family member', 359, NULL, NULL, 182221),
(182222, '2.30.42.10-FF-000044', NULL, 'Multiple PDZ domain protein isoform X1', 107, NULL, NULL, 182222),
(182223, '2.40.70.10-FF-000412', NULL, NULL, 104, NULL, NULL, 182223),
(182224, '3.40.710.10-FF-000053', NULL, 'D-alanyl-D-alanine carboxypeptidase', 189, NULL, NULL, 182224),
(182225, '2.40.128.20-FF-000015', NULL, 'Complement component C8 gamma chain', 182, NULL, NULL, 182225),
(182226, '3.40.50.1440-FF-000161', NULL, 'Beta_tubulin,putative', 132, NULL, NULL, 182226),
(182227, '1.10.510.10-FF-002204', NULL, NULL, 59, NULL, NULL, 182227),
(182228, '3.30.200.20-FF-001306', NULL, 'Protein kinase domain containing protein expressed', 102, NULL, NULL, 182228),
(182229, '3.40.50.300-FF-007705', NULL, 'Uncharacterized protein', 101, NULL, NULL, 182229),
(182230, '3.40.50.12780-FF-000178', NULL, 'Uncharacterized protein', 273, NULL, NULL, 182230),
(182231, '3.40.50.10860-FF-000046', NULL, 'Shikimate dehydrogenase (NADP(+))', 117, NULL, NULL, 182231),
(182232, '3.30.230.130-FF-000008', NULL, 'anaphase-promoting complex subunit 2', 145, NULL, NULL, 182232),
(182233, '3.40.50.1010-FF-000150', NULL, 'Flap endonuclease 1', 216, NULL, NULL, 182233),
(182234, '3.30.930.10-FF-000195', NULL, 'Asparagine-tRNA ligase', 107, NULL, NULL, 182234),
(182235, '1.25.40.10-FF-002314', NULL, 'Pentatricopeptide repeat-containing protein At5g66500, mitochondrial', 105, NULL, NULL, 182235),
(182236, '3.30.160.60-FF-002421', NULL, 'Zinc finger protein 347', 28, NULL, NULL, 182236),
(182237, '3.30.1330.20-FF-000005', NULL, 'Cell division protein FtsZ', 106, NULL, NULL, 182237),
(182238, '2.60.40.150-FF-000547', NULL, 'Uncharacterized protein', 114, NULL, NULL, 182238),
(182239, '2.40.50.140-FF-000461', NULL, 'Single-stranded DNA-binding protein', 137, NULL, NULL, 182239),
(182240, '2.40.30.10-FF-000308', NULL, 'Nitric oxide synthase, inducible', 48, NULL, NULL, 182240),
(182241, '3.30.420.110-FF-000080', NULL, 'Predicted protein', 148, NULL, NULL, 182241),
(182242, '1.10.510.10-FF-001928', NULL, 'RIO-type serine/threonine-protein kinase Rio2', 113, NULL, NULL, 182242),
(182243, '2.60.40.60-FF-000952', NULL, 'Uncharacterized protein', 105, NULL, NULL, 182243),
(182244, '3.60.10.10-FF-000068', NULL, 'Endonuclease', 295, NULL, NULL, 182244),
(182245, '3.40.30.10-FF-000918', NULL, 'Uncharacterized protein', 127, NULL, NULL, 182245),
(182246, '3.40.50.1580-FF-000056', NULL, 'S-methyl-5''-thioadenosine phosphorylase', 262, NULL, NULL, 182246);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(182247, '3.20.20.140-FF-000091', NULL, 'Probable adenosine deaminase', 355, NULL, NULL, 182247),
(182248, '3.10.100.10-FF-000390', NULL, NULL, 123, NULL, NULL, 182248),
(182249, '2.30.30.210-FF-000014', NULL, 'Ribonuclease P protein subunit p29', 57, NULL, NULL, 182249),
(182250, '3.40.50.200-FF-000189', NULL, 'Surface layer-associated STABLE protease, conjectural', 90, NULL, NULL, 182250),
(182251, '2.60.120.10-FF-000355', NULL, 'cGMP-dependent protein kinase, isozyme 2 forms cD4/T1/T3A/T3B-like Protein', 65, NULL, NULL, 182251),
(182252, '3.30.160.60-FF-001797', NULL, 'Zinc finger protein 197', 30, NULL, NULL, 182252),
(182253, '2.10.110.10-FF-000091', NULL, 'Sciellin', 78, NULL, NULL, 182253),
(182254, '1.20.1110.10-FF-000187', NULL, NULL, 166, NULL, NULL, 182254),
(182255, '3.30.70.330-FF-001543', NULL, NULL, 75, NULL, NULL, 182255),
(182256, '2.70.170.10-FF-000261', NULL, 'Uncharacterized protein', 153, NULL, NULL, 182256),
(182257, '2.60.40.10-FF-005642', NULL, NULL, 94, NULL, NULL, 182257),
(182258, '1.25.10.10-FF-002475', NULL, 'Uncharacterized protein', 213, NULL, NULL, 182258),
(182259, '3.40.50.300-FF-000106', NULL, 'Adenylate kinase mitochondrial', 214, NULL, NULL, 182259),
(182260, '2.60.169.10-FF-000001', NULL, 'Capsid protein F', 427, NULL, NULL, 182260),
(182261, '1.20.1280.290-FF-000004', NULL, 'Sugar transporter SWEET', 90, NULL, NULL, 182261),
(182262, '2.60.40.790-FF-000048', NULL, 'Very-long-chain (3R)-3-hydroxyacyl-CoA dehydratase', 107, NULL, NULL, 182262),
(182263, '2.130.10.10-FF-003821', NULL, 'Predicted protein', 303, NULL, NULL, 182263),
(182264, '2.40.420.20-FF-000043', NULL, 'Component of multidrug efflux system', 89, NULL, NULL, 182264),
(182265, '1.25.10.10-FF-002368', NULL, 'RNA-binding protein of the pumilio family', 278, NULL, NULL, 182265),
(182266, '3.20.10.10-FF-000064', NULL, 'Branched chain amino-acid transaminase 1, cytosolic', 59, NULL, NULL, 182266),
(182267, '1.20.58.810-FF-000001', NULL, 'Photosystem II lipoprotein Psb27', 106, NULL, NULL, 182267),
(182268, '3.40.50.11710-FF-000003', NULL, 'Cyclo(L-leucyl-L-phenylalanyl) synthase', 212, NULL, NULL, 182268),
(182269, '1.10.620.20-FF-000052', NULL, 'Stearoyl-[acyl-carrier-protein] 9-desaturase 7 chloroplastic', 60, NULL, NULL, 182269),
(182270, '3.40.30.10-FF-000345', NULL, 'Glutathione S-Transferase', 79, NULL, NULL, 182270),
(182271, '2.20.28.230-FF-000008', NULL, 'Uncharacterized protein', 52, NULL, NULL, 182271),
(182272, '3.30.450.40-FF-000167', NULL, 'Diguanylate cyclase', 170, NULL, NULL, 182272),
(182273, '1.50.40.10-FF-000558', NULL, 'Mitochondrial carrier protein, putative (AFU_orthologue AFUA_1G09980)', 124, NULL, NULL, 182273),
(182274, '2.60.120.10-FF-000248', NULL, 'AraC family transcriptional regulator', 72, NULL, NULL, 182274),
(182275, '3.90.550.50-FF-000142', NULL, 'Hexosyltransferase', 206, NULL, NULL, 182275),
(182276, '3.30.40.10-FF-000144', NULL, 'Tripartite motif-containing 5 (Predicted)', 90, NULL, NULL, 182276),
(182277, '3.40.50.2000-FF-000469', NULL, 'Uncharacterized protein', 90, NULL, NULL, 182277),
(182278, '3.30.160.60-FF-005979', NULL, NULL, 61, NULL, NULL, 182278),
(182279, '3.10.50.40-FF-000031', NULL, 'Peptidylprolyl isomerase', 112, NULL, NULL, 182279),
(182280, '1.25.40.10-FF-003483', NULL, 'Putative pentatricopeptide repeat-containing protein At1g13800', 187, NULL, NULL, 182280),
(182281, '3.40.20.10-FF-000171', NULL, 'Adseverin', 39, NULL, NULL, 182281),
(182282, '1.25.40.20-FF-001232', NULL, 'Ada2a-containing complex component 3, isoform B', 270, NULL, NULL, 182282),
(182283, '3.30.1360.170-FF-000013', NULL, 'Thymidylate synthase complementing protein ThyX', 217, NULL, NULL, 182283),
(182284, '2.130.10.10-FF-002528', NULL, 'Uncharacterized protein', 79, NULL, NULL, 182284),
(182285, '2.40.50.140-FF-001080', NULL, NULL, 85, NULL, NULL, 182285),
(182286, '3.30.390.10-FF-000018', NULL, 'Enolase 3, putative', 129, NULL, NULL, 182286),
(182287, '3.40.50.2000-FF-000121', NULL, 'bifunctional UDP-N-acetylglucosamine 2-epimerase/N-acetylmannosamine kinase isoform X3', 145, NULL, NULL, 182287);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(182288, '3.30.65.10-FF-000010', NULL, 'DNA topoisomerase 1', 49, NULL, NULL, 182288),
(182289, '3.50.50.60-FF-001209', NULL, 'Uncharacterized protein MJ1182', 364, NULL, NULL, 182289),
(182290, '3.10.20.90-FF-000971', NULL, 'Uncharacterized protein', 108, NULL, NULL, 182290),
(182291, '3.30.160.60-FF-003040', NULL, 'Putative endonuclease or glycosyl hydrolase with C2H2-type zinc finger domain-containing protein', 58, NULL, NULL, 182291),
(182292, '2.30.30.40-FF-000155', NULL, 'FCH and double SH3 domains protein', 62, NULL, NULL, 182292),
(182293, '3.20.20.70-FF-000116', NULL, 'Lipoyl synthase', 215, NULL, NULL, 182293),
(182294, '2.60.40.10-FF-003725', NULL, NULL, 90, NULL, NULL, 182294),
(182295, '3.30.160.60-FF-000504', NULL, 'C2H2 transcription factor swi5', 24, NULL, NULL, 182295),
(182296, '2.60.40.10-FF-001819', NULL, 'Muscle M-line assembly protein unc-89', 101, NULL, NULL, 182296),
(182297, '3.40.50.300-FF-002927', NULL, 'Putative ABC transporter protein', 269, NULL, NULL, 182297),
(182298, '1.20.1310.10-FF-000062', NULL, 'Unplaced genomic scaffold supercont1.188, whole genome shotgun sequence', 127, NULL, NULL, 182298),
(182299, '2.60.120.10-FF-000827', NULL, 'Uncharacterized protein', 200, NULL, NULL, 182299),
(182300, '3.30.60.20-FF-000042', NULL, 'differentially expressed in FDCP 8 homolog isoform X2', 77, NULL, NULL, 182300),
(182301, '1.10.560.10-FF-000010', NULL, 'T-complex protein 1 theta subunit', 232, NULL, NULL, 182301),
(182302, '3.90.79.10-FF-000017', NULL, 'Phosphatase NudJ', 153, NULL, NULL, 182302),
(182303, '3.30.70.1230-FF-000055', NULL, 'Adenylyl cyclase beta', 209, NULL, NULL, 182303),
(182304, '3.40.50.150-FF-001556', NULL, NULL, 77, NULL, NULL, 182304),
(182305, '2.40.50.1060-FF-000019', NULL, 'AGAP012084-PA', 136, NULL, NULL, 182305),
(182306, '3.40.50.880-FF-000010', NULL, 'uncharacterized protein LOC100176842 isoform X2', 192, NULL, NULL, 182306),
(182307, '2.60.40.10-FF-002219', NULL, 'Tyrosine-protein phosphatase Lar-like', 108, NULL, NULL, 182307),
(182308, '2.30.39.10-FF-000132', NULL, 'Uncharacterized protein', 97, NULL, NULL, 182308),
(182309, '3.30.1330.50-FF-000003', NULL, '2-C-methyl-D-erythritol 2,4-cyclodiphosphate synthase', 159, NULL, NULL, 182309),
(182310, '3.30.70.1230-FF-000179', NULL, 'Predicted protein', 178, NULL, NULL, 182310),
(182311, '1.20.1250.20-FF-000907', NULL, 'Similar to MFS multidrug transporter, partial sequence', 422, NULL, NULL, 182311),
(182312, '2.40.50.430-FF-000008', NULL, 'Uncharacterized protein', 128, NULL, NULL, 182312),
(182313, '3.30.360.10-FF-000050', NULL, 'Chimeric spermidine synthase/saccharopine dehydrogenase', 169, NULL, NULL, 182313),
(182314, '3.30.70.270-FF-000210', NULL, NULL, 174, NULL, NULL, 182314),
(182315, '3.40.850.10-FF-000557', NULL, 'Uncharacterized protein', 124, NULL, NULL, 182315),
(182316, '1.10.510.10-FF-003508', NULL, NULL, 252, NULL, NULL, 182316),
(182317, '2.40.70.10-FF-000305', NULL, NULL, 116, NULL, NULL, 182317),
(182318, '3.20.20.70-FF-000791', NULL, NULL, 54, NULL, NULL, 182318),
(182319, '3.80.10.10-FF-003664', NULL, 'Uncharacterized protein', 78, NULL, NULL, 182319),
(182320, '1.10.30.10-FF-000042', NULL, 'High mobility group protein 1.2', 72, NULL, NULL, 182320),
(182321, '1.20.1250.20-FF-000565', NULL, 'MFS multidrug transporter, putative', 170, NULL, NULL, 182321),
(182322, '1.25.40.10-FF-004231', NULL, 'Uncharacterized protein', 254, NULL, NULL, 182322),
(182323, '2.60.40.650-FF-000023', NULL, 'Predicted protein', 67, NULL, NULL, 182323),
(182324, '3.40.190.80-FF-000061', NULL, 'Fructose-1,6-bisphosphatase class 1', 128, NULL, NULL, 182324),
(182325, '1.25.40.20-FF-000743', NULL, 'Kinase, NEK', 114, NULL, NULL, 182325),
(182326, '3.60.20.30-FF-000007', NULL, 'Similar to threonine aspartase', 167, NULL, NULL, 182326),
(182327, '3.80.10.10-FF-000230', NULL, 'Leucine-rich repeat-containing protein 57', 103, NULL, NULL, 182327),
(182328, '2.130.10.10-FF-003473', NULL, 'Uncharacterized protein', 326, NULL, NULL, 182328),
(182329, '1.20.1720.10-FF-000093', NULL, 'Uncharacterized protein', 302, NULL, NULL, 182329);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(182330, '3.90.1410.10-FF-000153', NULL, 'Uncharacterized protein', 125, NULL, NULL, 182330),
(182331, '1.25.40.20-FF-000956', NULL, 'Uncharacterized protein', 116, NULL, NULL, 182331),
(182332, '4.10.240.10-FF-000126', NULL, 'Rgt1p', 70, NULL, NULL, 182332),
(182333, '1.10.20.10-FF-000334', NULL, NULL, 111, NULL, NULL, 182333),
(182334, '3.40.50.720-FF-002368', NULL, 'Uncharacterized protein', 51, NULL, NULL, 182334),
(182335, '1.25.10.10-FF-003436', NULL, 'Predicted protein', 135, NULL, NULL, 182335),
(182336, '3.30.2350.10-FF-000015', NULL, 'Mitochondrial RNA pseudouridine synthase RPUSD4', 249, NULL, NULL, 182336),
(182337, '2.60.34.10-FF-000125', NULL, 'Uncharacterized protein', 139, NULL, NULL, 182337),
(182338, '3.10.250.10-FF-000046', NULL, 'Transmembrane protease serine 4', 97, NULL, NULL, 182338),
(182339, '3.90.1480.20-FF-000070', NULL, 'Uncharacterized protein', 63, NULL, NULL, 182339),
(182340, '3.40.50.880-FF-000134', NULL, 'Glutamine amidotransferase', 224, NULL, NULL, 182340),
(182341, '2.120.10.30-FF-000354', NULL, 'Uncharacterized protein', 96, NULL, NULL, 182341),
(182342, '1.10.10.10-FF-001570', NULL, 'Uncharacterized protein', 112, NULL, NULL, 182342),
(182343, '3.10.20.90-FF-000752', NULL, 'Uncharacterized protein', 95, NULL, NULL, 182343),
(182344, '2.60.120.620-FF-000124', NULL, 'Uncharacterized protein', 90, NULL, NULL, 182344),
(182345, '2.60.120.380-FF-000024', NULL, 'Serine protease/ABC transporter B family protein tagA', 122, NULL, NULL, 182345),
(182346, '3.30.40.10-FF-000487', NULL, 'tripartite motif-containing protein 72', 71, NULL, NULL, 182346),
(182347, '3.30.559.10-FF-000202', NULL, 'Carnitine Palmitoyl Transferase', 143, NULL, NULL, 182347),
(182348, '1.20.5.580-FF-000005', NULL, 'Uncharacterized protein', 62, NULL, NULL, 182348),
(182349, '2.130.10.10-FF-001909', NULL, 'WD repeat, SAM and U-box domain-containing protein', 293, NULL, NULL, 182349),
(182350, '2.60.40.10-FF-001590', NULL, 'Uncharacterized protein, isoform D', 102, NULL, NULL, 182350),
(182351, '1.10.340.40-FF-000002', NULL, 'Polyadenylated RNA binding protein', 105, NULL, NULL, 182351),
(182352, '2.130.10.10-FF-002309', NULL, 'WGS project CABT00000000 data, contig 2.18', 211, NULL, NULL, 182352),
(182353, '2.60.40.10-FF-002764', NULL, 'CRE-ZIG-5 protein', 89, NULL, NULL, 182353),
(182354, '3.40.50.150-FF-000595', NULL, 'Endo-exonuclease NUCR', 79, NULL, NULL, 182354),
(182355, '1.10.10.10-FF-000951', NULL, 'ArsR family transcriptional regulator', 83, NULL, NULL, 182355),
(182356, '3.40.50.300-FF-002242', NULL, 'Arsenical pump-driving ATPase', 260, NULL, NULL, 182356),
(182357, '1.25.40.20-FF-000271', NULL, 'Ankyrin repeat and SOCS box containing 4', 151, NULL, NULL, 182357),
(182358, '3.30.40.10-FF-001111', NULL, 'Vacuolar protein sorting-associated protein 11 homolog', 80, NULL, NULL, 182358),
(182359, '2.60.40.10-FF-003040', NULL, 'Prolactin receptor', 105, NULL, NULL, 182359),
(182360, '3.50.50.60-FF-001086', NULL, 'Predicted protein', 105, NULL, NULL, 182360),
(182361, '3.90.70.10-FF-000481', NULL, 'Uncharacterized protein', 304, NULL, NULL, 182361),
(182362, '3.30.60.30-FF-000134', NULL, 'Uncharacterized protein', 57, NULL, NULL, 182362),
(182363, '3.30.2160.10-FF-000080', NULL, 'Uncharacterized protein', 81, NULL, NULL, 182363),
(182364, '1.10.533.10-FF-000312', NULL, 'Uncharacterized protein', 113, NULL, NULL, 182364),
(182365, '3.20.20.80-FF-000338', NULL, '1,4-alpha-glucan branching enzyme, putative', 184, NULL, NULL, 182365),
(182366, '2.40.160.20-FF-000005', NULL, 'Opacity protein opA54', 228, NULL, NULL, 182366),
(182367, '3.40.50.2000-FF-001088', NULL, 'Uncharacterized protein', 97, NULL, NULL, 182367),
(182368, '1.20.58.1100-FF-000013', NULL, 'Unc-13 homolog B', 144, NULL, NULL, 182368),
(182369, '1.25.40.10-FF-002196', NULL, 'Uncharacterized protein', 180, NULL, NULL, 182369),
(182370, '1.20.5.100-FF-000002', NULL, 'Integrin beta', 73, NULL, NULL, 182370),
(182371, '3.30.160.60-FF-004670', NULL, NULL, 75, NULL, NULL, 182371),
(182372, '3.30.9.10-FF-000291', NULL, 'Uncharacterized protein', 83, NULL, NULL, 182372);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(182373, '2.80.10.50-FF-000177', NULL, 'Putative polypeptide N-acetylgalactosaminyltransferase 11', 126, NULL, NULL, 182373),
(182374, '3.90.260.10-FF-000040', NULL, 'Erythrocyte membrane protein band 4.2', 312, NULL, NULL, 182374),
(182375, '2.130.10.10-FF-001567', NULL, 'WD repeat domain 62', 295, NULL, NULL, 182375),
(182376, '3.30.420.40-FF-000339', NULL, 'Protein CBG02163', 56, NULL, NULL, 182376),
(182377, '1.10.10.10-FF-000058', NULL, 'DNA-binding response OmpR family regulator', 106, NULL, NULL, 182377),
(182378, '2.10.110.10-FF-000107', NULL, 'Protein DA1-related 2', 65, NULL, NULL, 182378),
(182379, '1.25.40.10-FF-001010', NULL, 'Bch2p', 644, NULL, NULL, 182379),
(182380, '3.30.200.20-FF-001188', NULL, '3-phosphoinositide-dependent protein kinase 1', 107, NULL, NULL, 182380),
(182381, '3.40.50.1820-FF-000628', NULL, 'Serine peptidase, Clan SC, Family S9D', 222, NULL, NULL, 182381),
(182382, '2.130.10.10-FF-005619', NULL, 'Uncharacterized protein', 185, NULL, NULL, 182382),
(182383, '2.60.40.10-FF-005861', NULL, NULL, 82, NULL, NULL, 182383),
(182384, '3.40.50.300-FF-001966', NULL, 'Hypothetical ABC transporter ATP-binding protein YddA', 199, NULL, NULL, 182384),
(182385, '3.30.70.330-FF-002954', NULL, NULL, 106, NULL, NULL, 182385),
(182386, '3.30.1490.220-FF-000001', NULL, 'Inositol-tetrakisphosphate 1-kinase', 105, NULL, NULL, 182386),
(182387, '1.10.630.10-FF-000566', NULL, 'CYP71A12 (Cytochrome P450 family 71 subfamily A polypeptide 12)', 325, NULL, NULL, 182387),
(182388, '1.25.10.10-FF-003094', NULL, 'Uncharacterized protein', 224, NULL, NULL, 182388),
(182389, '1.20.1070.10-FF-001200', NULL, 'Uncharacterized protein', 147, NULL, NULL, 182389),
(182390, '2.30.30.40-FF-000025', NULL, 'SH3 and multiple ankyrin repeat domains protein 2', 60, NULL, NULL, 182390),
(182391, '1.10.565.10-FF-000105', NULL, 'Uncharacterized protein', 208, NULL, NULL, 182391),
(182392, '4.10.60.10-FF-000150', NULL, 'Putative e3 ubiquitin ligase', 24, NULL, NULL, 182392),
(182393, '2.30.29.30-FF-001374', NULL, 'Uncharacterized protein', 124, NULL, NULL, 182393),
(182394, '3.30.1480.10-FF-000002', NULL, 'Transcription termination/antitermination protein NusA', 125, NULL, NULL, 182394),
(182395, '1.20.920.10-FF-000159', NULL, 'Uncharacterized protein', 122, NULL, NULL, 182395),
(182396, '3.20.20.370-FF-000024', NULL, 'Sll1306 protein', 287, NULL, NULL, 182396),
(182397, '3.30.200.20-FF-000126', NULL, 'Dual specificity mitogen-activated protein kinase kinase 4', 103, NULL, NULL, 182397),
(182398, '3.90.640.10-FF-000148', NULL, 'Heat shock 70 kDa protein 14', 84, NULL, NULL, 182398),
(182399, '1.20.1270.60-FF-000218', NULL, 'AEL147Wp', 256, NULL, NULL, 182399),
(182400, '3.40.640.10-FF-000058', NULL, 'ethanolamine-phosphate phospho-lyase isoform X1', 268, NULL, NULL, 182400),
(182401, '3.40.50.11840-FF-000019', NULL, 'Trr-1', 92, NULL, NULL, 182401),
(182402, '2.60.40.10-FF-005985', NULL, NULL, 93, NULL, NULL, 182402),
(182403, '2.30.29.30-FF-000974', NULL, 'Oxysterol-binding protein-domain-containing protein', 97, NULL, NULL, 182403),
(182404, '1.20.1740.10-FF-000195', NULL, 'Uncharacterized protein', 215, NULL, NULL, 182404),
(182405, '3.30.160.60-FF-002764', NULL, 'GG18288', 30, NULL, NULL, 182405),
(182406, '1.20.58.1120-FF-000019', NULL, 'Dynein heavy chain, putative', 135, NULL, NULL, 182406),
(182407, '2.170.270.10-FF-000109', NULL, 'Histone-lysine N-methyltransferase SUVR5', 301, NULL, NULL, 182407),
(182408, '2.40.30.10-FF-000527', NULL, 'Uncharacterized protein', 86, NULL, NULL, 182408),
(182409, '1.10.510.10-FF-004453', NULL, NULL, 22, NULL, NULL, 182409),
(182410, '2.40.50.100-FF-000039', NULL, 'HlyD family efflux transporter periplasmic adaptor subunit', 34, NULL, NULL, 182410),
(182411, '1.10.3260.10-FF-000020', NULL, 'DNA ligase', 288, NULL, NULL, 182411),
(182412, '1.20.1110.10-FF-000170', NULL, NULL, 109, NULL, NULL, 182412),
(182413, '3.30.470.110-FF-000005', NULL, NULL, 234, NULL, NULL, 182413),
(182414, '3.40.710.10-FF-000159', NULL, 'Monacolin J acid methylbutanoyltransferase', 413, NULL, NULL, 182414);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(182415, '1.25.10.10-FF-000114', NULL, 'MMS19 nucleotide excision repair protein homolog isoform X2', 320, NULL, NULL, 182415),
(182416, '3.40.630.30-FF-000552', NULL, 'Uncharacterized protein', 131, NULL, NULL, 182416),
(182417, '3.40.50.10810-FF-000059', NULL, 'SNF2 family helicase/ATPase, putative', 260, NULL, NULL, 182417),
(182418, '4.10.1000.10-FF-000049', NULL, 'Protein CBG18471', 59, NULL, NULL, 182418),
(182419, '3.40.250.10-FF-000135', NULL, 'Uncharacterized protein', 116, NULL, NULL, 182419),
(182420, '3.80.10.10-FF-000915', NULL, 'LRR receptor-like serine/threonine-protein kinase GSO1', 238, NULL, NULL, 182420),
(182421, '2.130.10.120-FF-000004', NULL, 'prolyl endopeptidase-like isoform X2', 216, NULL, NULL, 182421),
(182422, '2.130.10.10-FF-000836', NULL, 'Ribosome assembly protein 4', 136, NULL, NULL, 182422),
(182423, '1.20.1050.10-FF-000125', NULL, 'Uncharacterized protein', 110, NULL, NULL, 182423),
(182424, '3.30.200.20-FF-001531', NULL, 'L-type lectin-domain containing receptor kinase S.4', 92, NULL, NULL, 182424),
(182425, '3.40.50.2300-FF-001166', NULL, NULL, 166, NULL, NULL, 182425),
(182426, '2.60.40.10-FF-002421', NULL, 'Novel immune-type receptor 9', 113, NULL, NULL, 182426),
(182427, '3.40.140.70-FF-000009', NULL, 'Autophagy-related protein 7', 160, NULL, NULL, 182427),
(182428, '3.40.50.300-FF-008094', NULL, 'Uncharacterized protein', 112, NULL, NULL, 182428),
(182429, '3.30.1370.60-FF-000003', NULL, 'Malate/L-lactate dehydrogenase', 217, NULL, NULL, 182429),
(182430, '3.30.300.200-FF-000001', NULL, 'Baseplate wedge protein gp6', 77, NULL, NULL, 182430),
(182431, '3.30.70.1230-FF-000286', NULL, 'Guanylate cyclase', 221, NULL, NULL, 182431),
(182432, '3.40.1230.10-FF-000009', NULL, 'Unplaced genomic scaffold supercont2.10, whole genome shotgun sequence', 138, NULL, NULL, 182432),
(182433, '3.30.70.330-FF-000138', NULL, 'Serine/arginine-rich splicing factor 5 alpha', 103, NULL, NULL, 182433),
(182434, '3.40.50.300-FF-000218', NULL, 'Multidrug ABC transporter ATP-binding protein', 250, NULL, NULL, 182434),
(182435, '2.60.40.3510-FF-000002', NULL, 'Delta-like protein', 159, NULL, NULL, 182435),
(182436, '2.10.60.10-FF-000042', NULL, 'Pre-xenoxin-1', 66, NULL, NULL, 182436),
(182437, '1.10.565.10-FF-000212', NULL, 'Uncharacterized protein', 121, NULL, NULL, 182437),
(182438, '2.60.40.3210-FF-000013', NULL, 'Uncharacterized protein', 117, NULL, NULL, 182438),
(182439, '1.10.510.10-FF-002435', NULL, NULL, 108, NULL, NULL, 182439),
(182440, '1.10.472.10-FF-000305', NULL, 'Transcription initiation factor IIB-2', 107, NULL, NULL, 182440),
(182441, '3.30.365.10-FF-000038', NULL, 'Nicotinate dehydrogenase subunit B', 132, NULL, NULL, 182441),
(182442, '1.10.287.110-FF-000085', NULL, 'Chaperone DnaJ-domain superfamily protein', 114, NULL, NULL, 182442),
(182443, '1.20.120.1770-FF-000014', NULL, 'Uncharacterized protein', 189, NULL, NULL, 182443),
(182444, '2.30.130.10-FF-000003', NULL, 'Glutamate 5-kinase', 98, NULL, NULL, 182444),
(182445, '3.90.550.10-FF-000377', NULL, 'Glycosyltransferase family 2 protein', 240, NULL, NULL, 182445),
(182446, '2.60.40.10-FF-000185', NULL, 'Fibronectin type III domain containing 3A', 100, NULL, NULL, 182446),
(182447, '2.130.10.10-FF-005726', NULL, 'Probable inactive protein kinase DDB_G0270444', 137, NULL, NULL, 182447),
(182448, '1.50.40.10-FF-000434', NULL, 'Uncharacterized protein', 172, NULL, NULL, 182448),
(182449, '3.30.200.20-FF-000002', NULL, 'Calcium/calmodulin-dependent protein kinase type II subunit delta isoform 2', 93, NULL, NULL, 182449),
(182450, '3.40.50.300-FF-004507', NULL, 'ATP-dependent DNA helicase RecQ', 223, NULL, NULL, 182450),
(182451, '3.30.870.10-FF-000151', NULL, 'AAR169Cp', 180, NULL, NULL, 182451),
(182452, '1.10.840.10-FF-000048', NULL, 'Phosphoinositide phospholipase C', 164, NULL, NULL, 182452),
(182453, '2.120.10.30-FF-000461', NULL, 'Uncharacterized protein', 81, NULL, NULL, 182453),
(182454, '2.60.120.1540-FF-000012', NULL, 'Blast:CD109 antigen', 93, NULL, NULL, 182454),
(182455, '1.20.144.10-FF-000092', NULL, 'Lipid A 4''-phosphatase', 98, NULL, NULL, 182455);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(182456, '3.40.50.300-FF-006637', NULL, 'Sulfotransferase', 90, NULL, NULL, 182456),
(182457, '3.30.830.10-FF-000030', NULL, 'Insulin-degrading enzyme', 236, NULL, NULL, 182457),
(182458, '2.60.120.200-FF-000807', NULL, 'Uncharacterized protein', 49, NULL, NULL, 182458),
(182459, '2.60.200.20-FF-000185', NULL, 'YALI0E02508p', 105, NULL, NULL, 182459),
(182460, '3.30.50.10-FF-000100', NULL, 'Hepatocyte nuclear factor 4 alpha', 54, NULL, NULL, 182460),
(182461, '1.20.1420.30-FF-000042', NULL, 'Zydeco, isoform F', 217, NULL, NULL, 182461),
(182462, '2.60.34.10-FF-000018', NULL, 'Heat shock 70 kDa protein 4L', 140, NULL, NULL, 182462),
(182463, '1.10.10.370-FF-000004', NULL, 'Dissimilatory siroheme-sulfite reductase, gamma subunit-like protein', 62, NULL, NULL, 182463),
(182464, '3.30.160.60-FF-004001', NULL, NULL, 28, NULL, NULL, 182464),
(182465, '3.40.50.300-FF-003310', NULL, 'Ras family protein', 209, NULL, NULL, 182465),
(182466, '2.40.50.180-FF-000006', NULL, 'Chemotaxis protein CheW', 68, NULL, NULL, 182466),
(182467, '2.30.30.30-FF-000039', NULL, 'Elongation factor P', 65, NULL, NULL, 182467),
(182468, '3.10.20.90-FF-000521', NULL, 'Polycomb group RING finger protein 5-B', 114, NULL, NULL, 182468),
(182469, '2.120.10.90-FF-000001', NULL, 'DNA gyrase subunit A', 314, NULL, NULL, 182469),
(182470, '3.40.50.1980-FF-000075', NULL, 'Hemin-binding periplasmic protein hmuT', 133, NULL, NULL, 182470),
(182471, '2.60.120.290-FF-000093', NULL, 'Zinc metalloproteinase', 113, NULL, NULL, 182471),
(182472, '3.30.1360.120-FF-000038', NULL, 'Sarcosine oxidase subunit alpha', 391, NULL, NULL, 182472),
(182473, '1.25.40.10-FF-003376', NULL, 'Pentatricopeptide repeat-containing protein At4g30825, chloroplastic', 164, NULL, NULL, 182473),
(182474, '3.90.190.10-FF-000394', NULL, 'Protein kinase', 161, NULL, NULL, 182474),
(182475, '3.40.50.1460-FF-000037', NULL, 'uncharacterized protein LOC100179627 isoform X2', 262, NULL, NULL, 182475),
(182476, '3.40.50.2000-FF-000576', NULL, 'Photosynthetic NDH subunit of subcomplex B 1, chloroplastic', 166, NULL, NULL, 182476),
(182477, '1.20.1560.10-FF-000102', NULL, 'ABC multidrug transporter Mdr1', 340, NULL, NULL, 182477),
(182478, '2.130.10.10-FF-001455', NULL, 'WD repeat-containing protein', 186, NULL, NULL, 182478),
(182479, '3.30.420.40-FF-000227', NULL, 'Actin-like protein, putative', 113, NULL, NULL, 182479),
(182480, '3.30.200.40-FF-000008', NULL, 'm7GpppX diphosphatase', 109, NULL, NULL, 182480),
(182481, '2.10.25.10-FF-000578', NULL, 'Fibulin 2', 42, NULL, NULL, 182481),
(182482, '2.130.10.30-FF-000157', NULL, NULL, 150, NULL, NULL, 182482),
(182483, '3.40.50.1000-FF-000265', NULL, 'Uncharacterized protein', 29, NULL, NULL, 182483),
(182484, '3.30.9.10-FF-000307', NULL, 'Predicted protein', 62, NULL, NULL, 182484),
(182485, '3.40.50.150-FF-001775', NULL, NULL, 199, NULL, NULL, 182485),
(182486, '2.60.40.1730-FF-000114', NULL, NULL, 108, NULL, NULL, 182486),
(182487, '3.40.50.1010-FF-000256', NULL, NULL, 101, NULL, NULL, 182487),
(182488, '2.60.40.3960-FF-000002', NULL, 'VeA-like protein', 113, NULL, NULL, 182488),
(182489, '3.30.70.330-FF-001774', NULL, NULL, 75, NULL, NULL, 182489),
(182490, '1.10.1000.11-FF-000013', NULL, 'Guanine-nucleotide exchange factor YEL1', 126, NULL, NULL, 182490),
(182491, '3.40.30.10-FF-000469', NULL, '2-hydroxychromene-2-carboxylate isomerase', 199, NULL, NULL, 182491),
(182492, '3.30.505.10-FF-000134', NULL, 'SH2-protein kinase domain containing protein', 119, NULL, NULL, 182492),
(182493, '1.10.630.10-FF-000454', NULL, 'Tryptophan N-monooxygenase 2', 193, NULL, NULL, 182493),
(182494, '3.40.109.10-FF-000015', NULL, 'NAD(P)H nitroreductase', 170, NULL, NULL, 182494),
(182495, '1.10.8.60-FF-000392', NULL, 'uncharacterized protein LOC100176493', 73, NULL, NULL, 182495),
(182496, '3.90.226.10-FF-000231', NULL, '6-ketocyclohex-1-ene-1-carbonyl-CoA hydrolase', 192, NULL, NULL, 182496),
(182497, '3.40.1800.20-FF-000034', NULL, NULL, 79, NULL, NULL, 182497),
(182498, '1.20.58.340-FF-000045', NULL, 'Magnesium and cobalt transport protein CorA, putative', 77, NULL, NULL, 182498);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(182499, '1.10.510.10-FF-000294', NULL, 'Serine/threonine-protein kinase OXI1', 69, NULL, NULL, 182499),
(182500, '3.40.50.300-FF-001854', NULL, 'ABC multidrug transporter (Eurofung)', 264, NULL, NULL, 182500),
(182501, '1.20.1070.10-FF-001649', NULL, 'Uncharacterized protein', 134, NULL, NULL, 182501),
(182502, '3.40.50.360-FF-000091', NULL, 'NADPH-cytochrome P450 reductase, putative', 170, NULL, NULL, 182502),
(182503, '3.30.70.330-FF-001667', NULL, 'Splicing factor U2AF 59 kDa subunit', 100, NULL, NULL, 182503),
(182504, '2.160.20.10-FF-000066', NULL, 'F-box protein 10', 260, NULL, NULL, 182504),
(182505, '1.10.3720.10-FF-000062', NULL, 'D,D-dipeptide ABC transporter permease', 218, NULL, NULL, 182505),
(182506, '1.10.238.10-FF-000593', NULL, 'EF-hand domain containing 1', 114, NULL, NULL, 182506),
(182507, '1.10.3380.10-FF-000068', NULL, 'Activating signal cointegrator 1 complex subunit 3, helc1, putative', 59, NULL, NULL, 182507),
(182508, '3.30.70.330-FF-000470', NULL, 'RNA-binding motif protein, Y chromosome, family 1 member F/J', 122, NULL, NULL, 182508),
(182509, '1.50.40.10-FF-000327', NULL, 'Mitochondrial thiamine pyrophosphate carrier 1', 293, NULL, NULL, 182509),
(182510, '2.60.120.200-FF-000122', NULL, 'Calreticulin 3', 230, NULL, NULL, 182510),
(182511, '3.60.21.10-FF-000205', NULL, 'Uncharacterized protein', 113, NULL, NULL, 182511),
(182512, '3.10.20.740-FF-000003', NULL, 'Formate dehydrogenase subunit alpha', 122, NULL, NULL, 182512),
(182513, '2.10.220.10-FF-000205', NULL, 'Proprotein convertase subtilisin/kexin type 5a', 56, NULL, NULL, 182513),
(182514, '1.10.10.440-FF-000048', NULL, 'Conserved expressed protein', 58, NULL, NULL, 182514),
(182515, '3.30.460.10-FF-000119', NULL, 'Lmo1231 protein', 107, NULL, NULL, 182515),
(182516, '1.10.340.30-FF-000016', NULL, 'Endonuclease III homolog', 105, NULL, NULL, 182516),
(182517, '3.30.300.20-FF-000061', NULL, 'Ribosome-binding factor A', 115, NULL, NULL, 182517),
(182518, '3.90.1300.10-FF-000032', NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit A, mitochondrial', 462, NULL, NULL, 182518),
(182519, '1.25.40.10-FF-001246', NULL, 'Uncharacterized protein', 59, NULL, NULL, 182519),
(182520, '2.60.40.1510-FF-000054', NULL, 'Integrin beta-6', 77, NULL, NULL, 182520),
(182521, '3.90.550.10-FF-000490', NULL, 'Putative xyloglucan 6-xylosyltransferase 1', 156, NULL, NULL, 182521),
(182522, '3.40.50.970-FF-000161', NULL, 'Probable 2-hydroxyacyl-CoA lyase 1', 205, NULL, NULL, 182522),
(182523, '3.60.21.10-FF-000312', NULL, 'Serine/threonine-protein phosphatase', 375, NULL, NULL, 182523),
(182524, '1.10.630.10-FF-000673', NULL, 'Uncharacterized protein', 170, NULL, NULL, 182524),
(182525, '3.40.50.300-FF-002585', NULL, 'Glutathione import ATP-binding protein GsiA', 274, NULL, NULL, 182525),
(182526, '3.30.1130.10-FF-000015', NULL, 'Folic acid synthesis protein fol1', 116, NULL, NULL, 182526),
(182527, '1.10.580.10-FF-000005', NULL, 'Citrate synthase', 249, NULL, NULL, 182527),
(182528, '2.60.40.10-FF-001707', NULL, 'Frazzled, isoform B', 104, NULL, NULL, 182528),
(182529, '1.20.120.230-FF-000017', NULL, 'Catenin alpha like 1', 110, NULL, NULL, 182529),
(182530, '3.30.110.120-FF-000001', NULL, 'Carbamoyltransferase HypF', 65, NULL, NULL, 182530),
(182531, '3.30.1150.10-FF-000028', NULL, NULL, 87, NULL, NULL, 182531),
(182532, '3.80.10.10-FF-002259', NULL, 'Mhp1p', 107, NULL, NULL, 182532),
(182533, '2.30.42.10-FF-000387', NULL, NULL, 88, NULL, NULL, 182533),
(182534, '3.30.70.1430-FF-000014', NULL, 'Transporter, AcrB/D/F family', 99, NULL, NULL, 182534),
(182535, '3.90.1140.10-FF-000047', NULL, 'U6 snRNA phosphodiesterase-like Protein', 78, NULL, NULL, 182535),
(182536, '2.20.70.10-FF-000019', NULL, 'Putative transcriptional coactivator YAP1', 42, NULL, NULL, 182536),
(182537, '3.40.50.300-FF-002473', NULL, 'KappaB-Ras, isoform B', 174, NULL, NULL, 182537),
(182538, '3.30.1440.10-FF-000005', NULL, 'Unplaced genomic scaffold supercont1.6, whole genome shotgun sequence', 193, NULL, NULL, 182538),
(182539, '3.10.450.40-FF-000031', NULL, 'Peptidase M4 family protein', 81, NULL, NULL, 182539);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(182540, '3.40.50.40-FF-000007', NULL, 'L-asparaginase', 109, NULL, NULL, 182540),
(182541, '3.80.10.10-FF-004283', NULL, 'NLR family CARD domain containing 5', 246, NULL, NULL, 182541),
(182542, '3.30.160.60-FF-000634', NULL, 'Zinc finger X-chromosomal protein', 29, NULL, NULL, 182542),
(182543, '3.30.70.330-FF-003123', NULL, NULL, 176, NULL, NULL, 182543),
(182544, '3.30.40.10-FF-001903', NULL, 'Uncharacterized protein', 73, NULL, NULL, 182544),
(182545, '1.10.260.40-FF-000075', NULL, 'Response regulator receiver', 101, NULL, NULL, 182545),
(182546, '2.60.40.60-FF-000502', NULL, 'AGAP011529-PA', 89, NULL, NULL, 182546),
(182547, '4.10.240.10-FF-000019', NULL, 'C6 transcription factor, putative', 65, NULL, NULL, 182547),
(182548, '1.25.40.10-FF-004225', NULL, 'Uncharacterized protein', 266, NULL, NULL, 182548),
(182549, '1.20.58.2220-FF-000029', NULL, 'Formin 1', 303, NULL, NULL, 182549),
(182550, '3.40.50.720-FF-002025', NULL, 'Protein PLASTID TRANSCRIPTIONALLY ACTIVE 16, chloroplastic', 204, NULL, NULL, 182550),
(182551, '3.10.490.20-FF-000033', NULL, 'Cytoplasmic dynein heavy chain, putative', 132, NULL, NULL, 182551),
(182552, '3.90.226.10-FF-000124', NULL, 'Uncharacterized protein, isoform B', 233, NULL, NULL, 182552),
(182553, '1.10.10.10-FF-000165', NULL, 'Vacuolar protein sorting protein (Vps36)', 78, NULL, NULL, 182553),
(182554, '3.40.1380.20-FF-000006', NULL, 'Pyruvate kinase', 143, NULL, NULL, 182554),
(182555, '1.10.238.10-FF-001211', NULL, 'Uncharacterized protein', 160, NULL, NULL, 182555),
(182556, '2.60.40.1400-FF-000021', NULL, NULL, 133, NULL, NULL, 182556),
(182557, '2.10.25.10-FF-000814', NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', 38, NULL, NULL, 182557),
(182558, '1.20.58.70-FF-000067', NULL, 'Putative syntaxin-5', 235, NULL, NULL, 182558),
(182559, '3.30.1460.20-FF-000009', NULL, 'Arp2/3 complex 34 kDa subunit', 190, NULL, NULL, 182559),
(182560, '3.40.800.20-FF-000046', NULL, 'Histone deacetylase 3', 240, NULL, NULL, 182560),
(182561, '3.40.50.1000-FF-000141', NULL, 'Putative phospholipid-transporting ATPase', 182, NULL, NULL, 182561),
(182562, '3.40.50.300-FF-006744', NULL, 'Uncharacterized protein', 68, NULL, NULL, 182562),
(182563, '3.40.1410.10-FF-000001', NULL, 'GntR family transcriptional regulator', 169, NULL, NULL, 182563),
(182564, '1.10.506.10-FF-000076', NULL, 'Folate gamma-glutamyl hydrolase', 202, NULL, NULL, 182564),
(182565, '3.40.50.300-FF-007256', NULL, 'Uncharacterized protein', 158, NULL, NULL, 182565),
(182566, '3.40.630.10-FF-000338', NULL, 'Carboxypeptidase SOL1', 289, NULL, NULL, 182566),
(182567, '2.60.120.660-FF-000001', NULL, 'Structural polyprotein', 140, NULL, NULL, 182567),
(182568, '1.10.238.10-FF-001099', NULL, 'Uncharacterized protein', 65, NULL, NULL, 182568),
(182569, '1.25.40.10-FF-004101', NULL, 'Uncharacterized protein', 145, NULL, NULL, 182569),
(182570, '3.30.200.20-FF-002256', NULL, 'Uncharacterized protein', 11, NULL, NULL, 182570),
(182571, '1.20.1250.20-FF-000115', NULL, 'High-affinity glucose transporter', 470, NULL, NULL, 182571),
(182572, '3.80.10.10-FF-001534', NULL, 'Uncharacterized protein', 192, NULL, NULL, 182572),
(182573, '4.10.1000.10-FF-000156', NULL, 'Uncharacterized protein', 70, NULL, NULL, 182573),
(182574, '3.40.50.1440-FF-000155', NULL, 'Epsilon tubulin', 401, NULL, NULL, 182574),
(182575, '1.10.8.10-FF-000074', NULL, 'Ubiquitin-associated domain-containing protein 2', 64, NULL, NULL, 182575),
(182576, '1.10.418.70-FF-000006', NULL, 'Ift-81', 127, NULL, NULL, 182576),
(182577, '3.90.132.10-FF-000001', NULL, 'leishmanolysin-like peptidase isoform X2', 123, NULL, NULL, 182577),
(182578, '3.40.390.10-FF-000297', NULL, NULL, 72, NULL, NULL, 182578),
(182579, '3.30.930.10-FF-000083', NULL, 'Phenylalanine--tRNA ligase', 270, NULL, NULL, 182579),
(182580, '3.30.310.130-FF-000010', NULL, 'Ubiquitin-like-specific protease 1C', 128, NULL, NULL, 182580),
(182581, '3.40.50.1440-FF-000031', NULL, 'tubulin beta-4A chain isoform X5', 136, NULL, NULL, 182581),
(182582, '3.30.160.20-FF-000178', NULL, 'Uncharacterized protein', 95, NULL, NULL, 182582);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(182583, '1.25.40.10-FF-002988', NULL, 'Protein CTR9-like protein', 142, NULL, NULL, 182583),
(182584, '2.130.10.10-FF-004440', NULL, 'Block of proliferation protein, putative', 353, NULL, NULL, 182584),
(182585, '2.40.160.10-FF-000014', NULL, 'Translocase of outer mitochondrial membrane 40 like', 80, NULL, NULL, 182585),
(182586, '3.20.20.140-FF-000427', NULL, 'DNA helicase', 238, NULL, NULL, 182586),
(182587, '3.90.1750.10-FF-000077', NULL, 'Uncharacterized protein', 135, NULL, NULL, 182587),
(182588, '1.20.58.60-FF-000749', NULL, 'Uncharacterized protein', 68, NULL, NULL, 182588),
(182589, '3.30.9.10-FF-000089', NULL, 'Glycerol-3-phosphate dehydrogenase SDP6 mitochondrial', 93, NULL, NULL, 182589),
(182590, '3.40.50.720-FF-000788', NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase 1, chloroplastic', 18, NULL, NULL, 182590),
(182591, '1.20.1740.10-FF-000088', NULL, 'Sodium:alanine symporter family protein', 387, NULL, NULL, 182591),
(182592, '1.10.238.10-FF-000374', NULL, 'Probable MDR1-Mac1p interacting protein', 201, NULL, NULL, 182592),
(182593, '1.25.40.20-FF-000850', NULL, 'Kinase, NEK', 186, NULL, NULL, 182593),
(182594, '2.60.450.20-FF-000006', NULL, 'T-complex protein 10, putative', 125, NULL, NULL, 182594),
(182595, '1.50.40.10-FF-000215', NULL, 'IP15246p', 299, NULL, NULL, 182595),
(182596, '2.40.20.10-FF-000122', NULL, 'Uncharacterized protein', 60, NULL, NULL, 182596),
(182597, '1.10.1740.10-FF-000034', NULL, 'Putative prophage LambdaBa02, RNA polymerase sigma-F factor', 81, NULL, NULL, 182597),
(182598, '3.40.50.300-FF-006183', NULL, 'Flagellar outer dynein arm heavy chain gamma', 89, NULL, NULL, 182598),
(182599, '3.80.10.10-FF-003771', NULL, 'Probable disease resistance protein At5g45510', 108, NULL, NULL, 182599),
(182600, '3.40.30.10-FF-000688', NULL, 'Protein disulfide-isomerase', 117, NULL, NULL, 182600),
(182601, '3.40.50.1820-FF-001472', NULL, 'Alpha/beta-Hydrolases superfamily protein', 174, NULL, NULL, 182601),
(182602, '3.40.50.620-FF-000764', NULL, 'Uncharacterized protein', 122, NULL, NULL, 182602),
(182603, '3.30.70.330-FF-001886', NULL, NULL, 90, NULL, NULL, 182603),
(182604, '2.170.270.10-FF-000216', NULL, 'Uncharacterized protein', 138, NULL, NULL, 182604),
(182605, '2.60.120.200-FF-000010', NULL, 'neurobeachin isoform X2', 182, NULL, NULL, 182605),
(182606, '1.20.1560.10-FF-000883', NULL, 'Protein CBR-MRP-1', 200, NULL, NULL, 182606),
(182607, '1.10.10.10-FF-001002', NULL, 'DEP domain-containing 5', 112, NULL, NULL, 182607),
(182608, '2.60.40.10-FF-001696', NULL, 'Transcription factor COE3', 95, NULL, NULL, 182608),
(182609, '3.40.50.150-FF-001663', NULL, NULL, 192, NULL, NULL, 182609),
(182610, '1.25.40.650-FF-000005', NULL, 'Outer membrane lipoprotein LppC', 108, NULL, NULL, 182610),
(182611, '2.10.25.10-FF-001197', NULL, 'signal peptide, CUB and EGF-like domain-containing protein 2 isoform X1', 40, NULL, NULL, 182611),
(182612, '3.90.70.10-FF-000250', NULL, 'Cysteine protease 12', 325, NULL, NULL, 182612),
(182613, '3.40.50.20-FF-000001', NULL, 'Carbamoyl-phosphate synthase large chain', 114, NULL, NULL, 182613),
(182614, '2.60.40.10-FF-002096', NULL, 'Down syndrome cell adhesion molecule 3, isoform C', 105, NULL, NULL, 182614),
(182615, '1.25.40.10-FF-000627', NULL, 'Pentatricopeptide repeat-containing protein', 110, NULL, NULL, 182615),
(182616, '2.60.40.150-FF-000093', NULL, 'Extended synaptotagmin 3', 136, NULL, NULL, 182616),
(182617, '1.10.2020.20-FF-000022', NULL, NULL, 77, NULL, NULL, 182617),
(182618, '3.40.640.10-FF-000507', NULL, 'Predicted protein', 66, NULL, NULL, 182618),
(182619, '3.40.50.2300-FF-001060', NULL, NULL, 123, NULL, NULL, 182619),
(182620, '2.60.120.290-FF-000216', NULL, 'Metalloendopeptidase', 114, NULL, NULL, 182620),
(182621, '2.40.110.10-FF-000067', NULL, 'AGAP000454-PA', 112, NULL, NULL, 182621),
(182622, '1.20.5.1160-FF-000014', NULL, 'Lamin A/C', 79, NULL, NULL, 182622),
(182623, '1.25.10.10-FF-000238', NULL, 'Non-SMC condensin II complex subunit G2', 211, NULL, NULL, 182623),
(182624, '3.90.1290.10-FF-000035', NULL, 'AGAP011396-PA', 180, NULL, NULL, 182624);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(182625, '3.40.50.10420-FF-000049', NULL, 'ADL385Cp', 204, NULL, NULL, 182625),
(182626, '1.10.20.10-FF-000103', NULL, 'Histone H2A type 1', 129, NULL, NULL, 182626),
(182627, '2.30.30.140-FF-000184', NULL, 'Tudor, isoform B', 94, NULL, NULL, 182627),
(182628, '1.20.120.1750-FF-000132', NULL, 'RBR-type E3 ubiquitin transferase', 78, NULL, NULL, 182628),
(182629, '1.10.150.20-FF-000201', NULL, 'DNA polymerase IV', 66, NULL, NULL, 182629),
(182630, '3.20.80.10-FF-000006', NULL, 'heme-binding protein 2', 187, NULL, NULL, 182630),
(182631, '3.30.160.60-FF-005743', NULL, NULL, 42, NULL, NULL, 182631),
(182632, '1.20.1250.20-FF-000458', NULL, 'Inner membrane metabolite transport protein ydjE', 436, NULL, NULL, 182632),
(182633, '3.90.228.10-FF-000055', NULL, 'Poly [ADP-ribose] polymerase', 200, NULL, NULL, 182633),
(182634, '3.20.20.80-FF-000445', NULL, 'Os11g0118200 protein', 194, NULL, NULL, 182634),
(182635, '2.40.270.10-FF-000005', NULL, 'DNA-directed RNA polymerase subunit beta', 133, NULL, NULL, 182635),
(182636, '3.80.10.10-FF-002591', NULL, 'Tubulin-specific chaperone, putative (AFU_orthologue AFUA_4G11870)', 87, NULL, NULL, 182636),
(182637, '3.30.710.10-FF-000100', NULL, 'Zinc finger and BTB domain containing 47', 114, NULL, NULL, 182637),
(182638, '3.40.50.1820-FF-000179', NULL, 'Lipase', 373, NULL, NULL, 182638),
(182639, '3.40.50.300-FF-007694', NULL, 'Multidrug resistance protein, putative', 106, NULL, NULL, 182639),
(182640, '2.60.40.2130-FF-000009', NULL, 'Uncharacterized protein', 195, NULL, NULL, 182640),
(182641, '1.20.120.350-FF-000036', NULL, 'Voltage-dependent sodium channel SCN10A', 113, NULL, NULL, 182641),
(182642, '2.130.10.10-FF-005507', NULL, 'WD repeat domain 62', 93, NULL, NULL, 182642),
(182643, '1.25.40.120-FF-000077', NULL, 'AEL288Wp', 330, NULL, NULL, 182643),
(182644, '1.20.120.1070-FF-000012', NULL, 'Translation initiation factor eIF-2B alpha subunit', 104, NULL, NULL, 182644),
(182645, '2.60.40.60-FF-000845', NULL, 'Uncharacterized protein', 64, NULL, NULL, 182645),
(182646, '2.60.200.20-FF-000073', NULL, 'Pre-mRNA leakage protein 1', 158, NULL, NULL, 182646),
(182647, '3.30.160.60-FF-000179', NULL, 'Zinc finger protein 711', 77, NULL, NULL, 182647),
(182648, '3.40.50.2300-FF-000784', NULL, 'Uncharacterized protein', 139, NULL, NULL, 182648),
(182649, '1.10.287.900-FF-000001', NULL, 'Putative diamine N-acetyltransferase', 40, NULL, NULL, 182649),
(182650, '1.10.510.10-FF-002311', NULL, 'Cdc2-related kinase 10, putative', 262, NULL, NULL, 182650),
(182651, '1.10.3720.10-FF-000168', NULL, 'Tungstate ABC transporter, permease protein WtpB', 249, NULL, NULL, 182651),
(182652, '3.40.50.300-FF-006525', NULL, 'Uncharacterized protein', 110, NULL, NULL, 182652),
(182653, '3.10.20.30-FF-000088', NULL, NULL, 84, NULL, NULL, 182653),
(182654, '3.30.390.50-FF-000002', NULL, 'Lipoate-protein ligase A', 89, NULL, NULL, 182654),
(182655, '3.30.200.20-FF-001295', NULL, 'serine/threonine-protein kinase PLK2 isoform X2', 67, NULL, NULL, 182655),
(182656, '1.25.40.20-FF-001125', NULL, 'Kinase, NEK', 188, NULL, NULL, 182656),
(182657, '3.40.50.720-FF-000682', NULL, 'Probable short-chain type dehydrogenase/reductase', 255, NULL, NULL, 182657),
(182658, '1.20.5.540-FF-000004', NULL, 'Uncharacterized protein', 32, NULL, NULL, 182658),
(182659, '3.90.190.10-FF-000282', NULL, 'Protein tyrosine phosphatase type IVA, member 2a', 166, NULL, NULL, 182659),
(182660, '1.25.40.20-FF-001687', NULL, 'Uncharacterized protein', 74, NULL, NULL, 182660),
(182661, '1.10.510.10-FF-000170', NULL, 'Mitogen-activated protein kinase', 208, NULL, NULL, 182661),
(182662, '3.40.50.2300-FF-000441', NULL, 'Fis family transcriptional regulator', 135, NULL, NULL, 182662),
(182663, '1.20.1510.10-FF-000043', NULL, 'Cation transporter, putative', 209, NULL, NULL, 182663),
(182664, '3.40.50.150-FF-000483', NULL, 'HPM1p AdoMet-dependent methyltransferase', 239, NULL, NULL, 182664),
(182665, '3.30.160.60-FF-003489', NULL, NULL, 25, NULL, NULL, 182665),
(182666, '2.60.120.680-FF-000007', NULL, 'Oxysterol binding protein (Osh3)', 106, NULL, NULL, 182666);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(182667, '1.10.418.10-FF-000247', NULL, 'Uncharacterized protein', 107, NULL, NULL, 182667),
(182668, '3.40.50.720-FF-000007', NULL, '6-phosphogluconate dehydrogenase, decarboxylating', 180, NULL, NULL, 182668),
(182669, '3.90.70.10-FF-000593', NULL, 'Os11g0649100 protein', 205, NULL, NULL, 182669),
(182670, '4.10.81.10-FF-000001', NULL, 'Cytochrome c oxidase subunit 8B, mitochondrial', 43, NULL, NULL, 182670),
(182671, '2.60.40.150-FF-000311', NULL, 'Phosphatidylserine decarboxylase proenzyme 2', 126, NULL, NULL, 182671),
(182672, '3.90.100.10-FF-000006', NULL, 'Orn/Lys/Arg decarboxylase family protein', 99, NULL, NULL, 182672),
(182673, '3.20.20.80-FF-000102', NULL, 'Alpha-glucosidase', 113, NULL, NULL, 182673),
(182674, '1.10.10.10-FF-000507', NULL, 'Segregation and condensation protein B', 76, NULL, NULL, 182674),
(182675, '3.80.10.10-FF-001298', NULL, 'Uncharacterized protein, isoform B', 212, NULL, NULL, 182675),
(182676, '1.20.5.110-FF-000117', NULL, 'Synaptosomal-associated protein 47', 56, NULL, NULL, 182676),
(182677, '3.90.190.10-FF-000624', NULL, 'Uncharacterized protein', 49, NULL, NULL, 182677),
(182678, '3.30.160.60-FF-005069', NULL, NULL, 28, NULL, NULL, 182678),
(182679, '3.30.160.60-FF-004782', NULL, NULL, 26, NULL, NULL, 182679),
(182680, '1.10.555.10-FF-000149', NULL, NULL, 264, NULL, NULL, 182680),
(182681, '3.30.160.60-FF-004107', NULL, NULL, 29, NULL, NULL, 182681),
(182682, '2.10.25.10-FF-000472', NULL, 'Uncharacterized protein, isoform A', 77, NULL, NULL, 182682),
(182683, '3.30.160.60-FF-006362', NULL, NULL, 35, NULL, NULL, 182683),
(182684, '2.130.10.10-FF-004889', NULL, 'Uncharacterized protein', 319, NULL, NULL, 182684),
(182685, '2.170.130.10-FF-000043', NULL, 'TonB-dependent siderophore receptor', 124, NULL, NULL, 182685),
(182686, '3.30.40.10-FF-001892', NULL, 'RING/U-box superfamily protein', 112, NULL, NULL, 182686),
(182687, '3.40.190.10-FF-000641', NULL, 'Chromosome 1, whole genome shotgun sequence', 106, NULL, NULL, 182687),
(182688, '3.40.50.150-FF-000027', NULL, 'Protein-L-isoaspartate O-methyltransferase', 225, NULL, NULL, 182688),
(182689, '3.90.79.20-FF-000008', NULL, 'Nudix hydrolase 19, chloroplastic', 138, NULL, NULL, 182689),
(182690, '2.60.40.60-FF-001121', NULL, 'Predicted protein', 57, NULL, NULL, 182690),
(182691, '1.20.1310.10-FF-000168', NULL, NULL, 112, NULL, NULL, 182691),
(182692, '3.30.2130.10-FF-000021', NULL, 'Uncharacterized protein', 131, NULL, NULL, 182692),
(182693, '3.40.20.10-FF-000064', NULL, 'Unplaced genomic scaffold supercont1.19, whole genome shotgun sequence', 137, NULL, NULL, 182693),
(182694, '3.40.850.10-FF-000321', NULL, 'Kinesin-like protein', 378, NULL, NULL, 182694),
(182695, '3.40.50.2300-FF-000109', NULL, 'Histidine kinase', 135, NULL, NULL, 182695),
(182696, '3.30.930.10-FF-000206', NULL, 'Glycyl-tRNA synthetase', 310, NULL, NULL, 182696),
(182697, '3.40.350.10-FF-000064', NULL, 'Xaa-Pro aminopeptidase 1', 162, NULL, NULL, 182697),
(182698, '3.40.50.460-FF-000019', NULL, 'Probable ATP-dependent 6-phosphofructokinase', 114, NULL, NULL, 182698),
(182699, '3.40.50.720-FF-001300', NULL, 'Pyrroline-5-carboxylate reductase', 181, NULL, NULL, 182699),
(182700, '2.60.40.10-FF-000746', NULL, 'Tissue factor', 219, NULL, NULL, 182700),
(182701, '3.40.50.2300-FF-001402', NULL, NULL, 115, NULL, NULL, 182701),
(182702, '2.130.10.10-FF-005165', NULL, 'Uncharacterized protein', 134, NULL, NULL, 182702),
(182703, '3.30.2130.30-FF-000027', NULL, 'Uncharacterized protein', 76, NULL, NULL, 182703),
(182704, '3.30.565.10-FF-000037', NULL, 'Hybrid sensor histidine kinase/response regulator', 155, NULL, NULL, 182704),
(182705, '3.10.110.10-FF-000233', NULL, 'Ubiquitin-conjugating enzyme E2 E3', 154, NULL, NULL, 182705),
(182706, '3.30.160.60-FF-001359', NULL, 'E3 ubiquitin-protein ligase TRIM11', 73, NULL, NULL, 182706),
(182707, '3.30.40.10-FF-000599', NULL, 'Zinc finger protein, putative', 95, NULL, NULL, 182707),
(182708, '3.40.1180.10-FF-000016', NULL, 'Undecaprenyl diphosphate synthase', 114, NULL, NULL, 182708),
(182709, '3.10.20.710-FF-000005', NULL, 'Protein CBR-DVE-1', 101, NULL, NULL, 182709);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(182710, '2.20.100.10-FF-000228', NULL, 'Putative salivary kunitz domain protein', 55, NULL, NULL, 182710),
(182711, '3.40.50.150-FF-001320', NULL, NULL, 206, NULL, NULL, 182711),
(182712, '2.40.10.10-FF-000184', NULL, 'Prostasin', 106, NULL, NULL, 182712),
(182713, '3.40.50.300-FF-005564', NULL, 'DNA 3''-phosphatase', 196, NULL, NULL, 182713),
(182714, '3.50.30.30-FF-000143', NULL, 'Uncharacterized protein', 106, NULL, NULL, 182714),
(182715, '3.30.160.60-FF-002652', NULL, 'zinc finger protein 514-like isoform X2', 39, NULL, NULL, 182715),
(182716, '3.30.1390.10-FF-000012', NULL, 'ATP-dependent Clp protease adapter protein ClpS', 94, NULL, NULL, 182716),
(182717, '1.25.40.20-FF-001468', NULL, 'Uncharacterized protein', 229, NULL, NULL, 182717),
(182718, '2.60.40.10-FF-004237', NULL, NULL, 45, NULL, NULL, 182718),
(182719, '2.40.50.140-FF-001192', NULL, NULL, 116, NULL, NULL, 182719),
(182720, '1.10.510.10-FF-001131', NULL, 'Uncharacterized protein', 352, NULL, NULL, 182720),
(182721, '3.40.50.2020-FF-000115', NULL, 'Hypoxanthine-guanine phosphoribosyltransferase', 170, NULL, NULL, 182721),
(182722, '2.70.98.30-FF-000036', NULL, 'Alpha-mannosidase', 124, NULL, NULL, 182722),
(182723, '1.25.40.10-FF-001807', NULL, 'Pentatricopeptide repeat-containing protein', 98, NULL, NULL, 182723),
(182724, '1.20.1640.10-FF-000047', NULL, 'PaTched Related family', 225, NULL, NULL, 182724),
(182725, '2.60.40.10-FF-003837', NULL, NULL, 95, NULL, NULL, 182725),
(182726, '2.60.40.2150-FF-000004', NULL, 'Uncharacterized protein', 94, NULL, NULL, 182726),
(182727, '3.40.50.720-FF-001643', NULL, 'SDR family oxidoreductase', 315, NULL, NULL, 182727),
(182728, '3.80.10.10-FF-004389', NULL, 'Uncharacterized protein', 168, NULL, NULL, 182728),
(182729, '2.40.70.10-FF-000069', NULL, 'Eukaryotic aspartyl protease family protein', 190, NULL, NULL, 182729),
(182730, '2.30.30.100-FF-000200', NULL, 'U6 snRNA-associated Sm-like protein LSm8', 95, NULL, NULL, 182730),
(182731, '1.10.150.240-FF-000006', NULL, 'Phosphonoacetaldehyde hydrolase', 78, NULL, NULL, 182731),
(182732, '1.25.10.10-FF-001418', NULL, 'Uncharacterized protein', 305, NULL, NULL, 182732),
(182733, '3.40.1050.10-FF-000012', NULL, 'Carbonic anhydrase', 178, NULL, NULL, 182733),
(182734, '3.40.50.2000-FF-000233', NULL, 'PGL/p-HBAD biosynthesis rhamnosyltransferase', 224, NULL, NULL, 182734),
(182735, '1.20.1250.20-FF-001638', NULL, 'Uncharacterized protein', 77, NULL, NULL, 182735),
(182736, '2.60.40.10-FF-004113', NULL, NULL, 92, NULL, NULL, 182736),
(182737, '1.10.8.270-FF-000156', NULL, 'Predicted protein', 104, NULL, NULL, 182737),
(182738, '3.40.50.11460-FF-000001', NULL, 'Probable polyketide synthase pks1', 170, NULL, NULL, 182738),
(182739, '2.40.10.10-FF-000060', NULL, 'Acrosin', 108, NULL, NULL, 182739),
(182740, '3.90.1100.10-FF-000051', NULL, 'Uncharacterized protein', 75, NULL, NULL, 182740),
(182741, '1.25.10.10-FF-002711', NULL, 'Uncharacterized protein', 42, NULL, NULL, 182741),
(182742, '1.10.510.10-FF-000855', NULL, 'Protein kinase', 348, NULL, NULL, 182742),
(182743, '3.90.79.10-FF-000129', NULL, 'Isopentenyl-diphosphate delta isomerase 2', 136, NULL, NULL, 182743),
(182744, '2.70.130.10-FF-000039', NULL, 'AGAP000998-PA', 147, NULL, NULL, 182744),
(182745, '2.120.10.60-FF-000003', NULL, 'Tricorn protease homolog', 285, NULL, NULL, 182745),
(182746, '1.10.1280.10-FF-000010', NULL, 'Larval serum protein 2', 267, NULL, NULL, 182746),
(182747, '2.10.25.10-FF-001433', NULL, 'Cubilin homolog', 76, NULL, NULL, 182747),
(182748, '3.80.20.20-FF-000060', NULL, 'Related to sporulation-specific gene SPS2', 128, NULL, NULL, 182748),
(182749, '1.10.10.60-FF-000483', NULL, 'Predicted protein', 67, NULL, NULL, 182749),
(182750, '3.90.550.10-FF-000158', NULL, 'Glycosyl transferase family 2', 236, NULL, NULL, 182750),
(182751, '1.10.246.60-FF-000019', NULL, NULL, 77, NULL, NULL, 182751),
(182752, '1.10.10.60-FF-000140', NULL, 'Myb transcription factor', 48, NULL, NULL, 182752),
(182753, '3.30.70.370-FF-000015', NULL, 'DNA-directed DNA polymerase', 96, NULL, NULL, 182753);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(182754, '1.10.3210.10-FF-000085', NULL, 'HDOD domain-containing protein', 309, NULL, NULL, 182754),
(182755, '2.130.10.10-FF-000151', NULL, 'F-box/WD repeat-containing protein 2 isoform X1', 324, NULL, NULL, 182755),
(182756, '1.20.1250.20-FF-001419', NULL, 'Slr0616 protein', 174, NULL, NULL, 182756),
(182757, '3.90.550.10-FF-000034', NULL, 'Exostosin 1', 263, NULL, NULL, 182757),
(182758, '3.30.160.60-FF-001691', NULL, 'Zinc finger protein', 66, NULL, NULL, 182758),
(182759, '2.120.10.80-FF-000009', NULL, 'Kelch domain-containing protein 10', 235, NULL, NULL, 182759),
(182760, '2.40.10.10-FF-000402', NULL, NULL, 108, NULL, NULL, 182760),
(182761, '3.30.70.270-FF-000098', NULL, 'Diguanylate cyclase', 165, NULL, NULL, 182761),
(182762, '2.60.120.40-FF-000010', NULL, 'EMILIN-1 protein', 156, NULL, NULL, 182762),
(182763, '3.40.50.300-FF-000550', NULL, 'ras-related protein Rab-21', 197, NULL, NULL, 182763),
(182764, '3.40.47.10-FF-000092', NULL, 'Alpha-pyrone synthesis polyketide synthase-like Pks18', 214, NULL, NULL, 182764),
(182765, '2.130.10.10-FF-003585', NULL, 'Nucleoporin 214', 174, NULL, NULL, 182765),
(182766, '3.40.1110.10-FF-000181', NULL, 'Phospholipid-transporting ATPase', 151, NULL, NULL, 182766),
(182767, '1.20.140.150-FF-000076', NULL, 'Germ cell-specific gene 1 protein', 206, NULL, NULL, 182767),
(182768, '3.30.160.60-FF-000398', NULL, 'Zinc finger and BTB domain-containing protein 2', 29, NULL, NULL, 182768),
(182769, '1.20.120.980-FF-000006', NULL, 'Serine carboxypeptidase S28 family protein', 135, NULL, NULL, 182769),
(182770, '3.90.730.10-FF-000020', NULL, 'Uncharacterized protein', 300, NULL, NULL, 182770),
(182771, '1.25.40.10-FF-002207', NULL, 'Anaphase-promoting complex, cyclosome, subunit 3/TPR repeat, putative', 514, NULL, NULL, 182771),
(182772, '2.120.10.30-FF-000242', NULL, 'Uncharacterized protein', 280, NULL, NULL, 182772),
(182773, '3.40.50.300-FF-003984', NULL, 'tRNA-splicing endonuclease positive effector, putative', 387, NULL, NULL, 182773),
(182774, '3.40.190.10-FF-000309', NULL, 'Phosphate ABC transporter substrate-binding protein', 83, NULL, NULL, 182774),
(182775, '3.10.580.10-FF-000150', NULL, 'Uncharacterized protein', 142, NULL, NULL, 182775),
(182776, '3.40.50.10140-FF-000055', NULL, 'Uncharacterized protein', 170, NULL, NULL, 182776),
(182777, '3.40.50.2000-FF-000918', NULL, 'LOS biosynthesis enzyme LBGB', 161, NULL, NULL, 182777),
(182778, '1.20.1250.20-FF-001970', NULL, 'Uncharacterized protein', 410, NULL, NULL, 182778),
(182779, '3.50.50.60-FF-000136', NULL, 'Dihydrolipoyl dehydrogenase', 122, NULL, NULL, 182779),
(182780, '1.10.287.610-FF-000015', NULL, 'Uncharacterized protein', 40, NULL, NULL, 182780),
(182781, '3.30.200.20-FF-002150', NULL, 'Os12g0249300 protein', 68, NULL, NULL, 182781),
(182782, '1.20.1250.20-FF-000677', NULL, 'MFS transporter', 201, NULL, NULL, 182782),
(182783, '1.10.10.60-FF-000825', NULL, NULL, 68, NULL, NULL, 182783),
(182784, '1.10.510.10-FF-001816', NULL, 'Uncharacterized protein', 312, NULL, NULL, 182784),
(182785, '3.40.50.10810-FF-000172', NULL, 'Uncharacterized protein', 242, NULL, NULL, 182785),
(182786, '1.10.510.10-FF-001474', NULL, 'Pseudopodium-enriched atypical kinase 1', 197, NULL, NULL, 182786),
(182787, '1.25.10.10-FF-001750', NULL, 'Uncharacterized protein', 124, NULL, NULL, 182787),
(182788, '3.30.200.20-FF-001750', NULL, 'Uncharacterized protein', 117, NULL, NULL, 182788),
(182789, '1.25.10.10-FF-000457', NULL, 'Tubulin-folding cofactor D', 183, NULL, NULL, 182789),
(182790, '1.20.1250.20-FF-001077', NULL, 'GD11715', 210, NULL, NULL, 182790),
(182791, '2.60.120.260-FF-000112', NULL, 'Uncharacterized protein, isoform A', 153, NULL, NULL, 182791),
(182792, '2.60.40.10-FF-000403', NULL, 'collagen alpha-1(XIV) chain isoform X2', 63, NULL, NULL, 182792),
(182793, '1.10.10.60-FF-001101', NULL, NULL, 70, NULL, NULL, 182793),
(182794, '2.40.10.310-FF-000004', NULL, '30S ribosomal protein S8e', 66, NULL, NULL, 182794),
(182795, '2.30.30.230-FF-000003', NULL, 'Fumarylacetoacetase', 114, NULL, NULL, 182795);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(182796, '3.30.830.10-FF-000154', NULL, 'Mitochondrial presequence protease, putative', 260, NULL, NULL, 182796),
(182797, '3.30.200.20-FF-001874', NULL, 'Probable serine/threonine-protein kinase DDB_G0268642', 146, NULL, NULL, 182797),
(182798, '3.30.160.60-FF-001016', NULL, 'zinc finger protein 850-like', 28, NULL, NULL, 182798),
(182799, '1.10.10.60-FF-000264', NULL, 'zinc fingers and homeoboxes protein 2', 81, NULL, NULL, 182799),
(182800, '3.90.1150.10-FF-000216', NULL, 'Serine hydroxymethyltransferase', 24, NULL, NULL, 182800),
(182801, '1.10.150.650-FF-000011', NULL, 'PHP domain protein', 69, NULL, NULL, 182801),
(182802, '3.30.450.40-FF-000055', NULL, 'IclR family transcriptional regulator', 173, NULL, NULL, 182802),
(182803, '3.40.33.10-FF-000150', NULL, 'Uncharacterized protein', 137, NULL, NULL, 182803),
(182804, '1.10.287.10-FF-000009', NULL, 'Methionine--tRNA ligase, cytoplasmic', 55, NULL, NULL, 182804),
(182805, '3.90.550.10-FF-000719', NULL, 'Predicted protein', 261, NULL, NULL, 182805),
(182806, '3.40.50.300-FF-005221', NULL, 'NOD-like receptor family B, member 5', 205, NULL, NULL, 182806),
(182807, '2.130.10.10-FF-000275', NULL, 'Prolactin regulatory element binding', 344, NULL, NULL, 182807),
(182808, '3.30.70.1400-FF-000016', NULL, 'Dimethylglycine dehydrogenase, mitochondrial', 108, NULL, NULL, 182808),
(182809, '1.10.132.20-FF-000024', NULL, 'Ribosome recycling factor, putative', 19, NULL, NULL, 182809),
(182810, '2.130.10.10-FF-004546', NULL, 'Uncharacterized protein', 219, NULL, NULL, 182810),
(182811, '3.80.10.10-FF-000679', NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', 92, NULL, NULL, 182811),
(182812, '3.60.20.10-FF-000237', NULL, NULL, 80, NULL, NULL, 182812),
(182813, '3.40.1190.20-FF-000177', NULL, NULL, 72, NULL, NULL, 182813),
(182814, '1.10.1390.10-FF-000001', NULL, 'Glucose-6-phosphate isomerase', 43, NULL, NULL, 182814),
(182815, '1.10.287.1880-FF-000003', NULL, 'Protein zwilch homolog', 57, NULL, NULL, 182815),
(182816, '3.40.50.1220-FF-000095', NULL, 'Uncharacterized protein', 132, NULL, NULL, 182816),
(182817, '3.40.50.2300-FF-001621', NULL, NULL, 312, NULL, NULL, 182817),
(182818, '1.20.5.110-FF-000336', NULL, 'Uncharacterized protein', 62, NULL, NULL, 182818),
(182819, '1.10.287.70-FF-000549', NULL, 'Calcium channel subunit Cch1', 156, NULL, NULL, 182819),
(182820, '1.10.418.10-FF-000028', NULL, 'RP/EB family microtubule-associated protein', 126, NULL, NULL, 182820),
(182821, '3.30.70.100-FF-000075', NULL, 'Copper-transporting ATPase', 72, NULL, NULL, 182821),
(182822, '3.80.10.10-FF-001079', NULL, 'GM14853', 146, NULL, NULL, 182822),
(182823, '2.20.50.20-FF-000010', NULL, 'vitellogenin-like', 78, NULL, NULL, 182823),
(182824, '3.40.630.30-FF-000322', NULL, 'Spore coat maturation protein', 242, NULL, NULL, 182824),
(182825, '1.10.357.110-FF-000005', NULL, 'CRE-VPS-53 protein', 144, NULL, NULL, 182825),
(182826, '3.80.10.10-FF-003265', NULL, 'Putative inactive disease susceptibility protein LOV1', 172, NULL, NULL, 182826),
(182827, '3.40.190.10-FF-000326', NULL, 'Ferric iron-binding periplasmic protein HitA', 149, NULL, NULL, 182827),
(182828, '3.40.50.10190-FF-000098', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 131, NULL, NULL, 182828),
(182829, '3.30.2180.10-FF-000002', NULL, 'Protein ATP12, mitochondrial', 70, NULL, NULL, 182829),
(182830, '3.10.20.90-FF-000763', NULL, 'GA repeat binding protein alpha homolog isoform X1', 88, NULL, NULL, 182830),
(182831, '1.20.1560.10-FF-000389', NULL, 'ABC transporter, ATP-binding/permease protein', 309, NULL, NULL, 182831),
(182832, '1.10.287.70-FF-000095', NULL, 'Potassium sodium-activated channel subfamily T member 2', 136, NULL, NULL, 182832),
(182833, '3.30.70.2380-FF-000001', NULL, 'Subtilisin-like protease 1', 93, NULL, NULL, 182833),
(182834, '3.80.10.10-FF-001141', NULL, 'Si:ch211-250k18.7', 118, NULL, NULL, 182834),
(182835, '3.30.160.60-FF-000544', NULL, 'zinc finger protein 384 isoform X3', 31, NULL, NULL, 182835),
(182836, '1.25.40.10-FF-000341', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 152, NULL, NULL, 182836);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(182837, '1.10.357.120-FF-000008', NULL, 'DNA-directed RNA polymerase subunit', 126, NULL, NULL, 182837),
(182838, '1.10.238.20-FF-000028', NULL, 'AGAP000643-PA', 105, NULL, NULL, 182838),
(182839, '1.10.10.880-FF-000005', NULL, 'Regulatory protein', 68, NULL, NULL, 182839),
(182840, '3.40.50.1380-FF-000030', NULL, 'Uncharacterized protein', 71, NULL, NULL, 182840),
(182841, '1.10.10.10-FF-000187', NULL, 'Transcription factor-like protein DPB', 95, NULL, NULL, 182841),
(182842, '2.40.160.120-FF-000015', NULL, 'Oxysterol binding protein, putative', 194, NULL, NULL, 182842),
(182843, '2.130.10.10-FF-005923', NULL, 'Uncharacterized protein', 272, NULL, NULL, 182843),
(182844, '3.40.50.720-FF-000030', NULL, 'Glutamate dehydrogenase', 167, NULL, NULL, 182844),
(182845, '3.40.50.1000-FF-000080', NULL, 'Phospholipid-transporting ATPase', 194, NULL, NULL, 182845),
(182846, '2.60.40.10-FF-004810', NULL, NULL, 71, NULL, NULL, 182846),
(182847, '1.10.3930.10-FF-000004', NULL, 'Arginine deiminase', 86, NULL, NULL, 182847),
(182848, '3.30.1360.220-FF-000006', NULL, 'Zinc finger FYVE domain-containing protein', 65, NULL, NULL, 182848),
(182849, '3.30.450.20-FF-000392', NULL, 'Histidine kinase response regulator hybrid protein', 141, NULL, NULL, 182849),
(182850, '1.25.40.20-FF-000344', NULL, 'ankyrin repeat domain-containing protein 50', 118, NULL, NULL, 182850),
(182851, '1.25.10.10-FF-001941', NULL, 'Inositol kinase kinase (UvsB), putative', 344, NULL, NULL, 182851),
(182852, '1.20.120.350-FF-000166', NULL, NULL, 179, NULL, NULL, 182852),
(182853, '1.25.40.10-FF-003567', NULL, 'Uncharacterized protein', 232, NULL, NULL, 182853),
(182854, '1.10.8.60-FF-000049', NULL, 'Vesicle-fusing ATPase', 88, NULL, NULL, 182854),
(182855, '3.30.70.330-FF-002100', NULL, NULL, 165, NULL, NULL, 182855),
(182856, '3.30.70.1230-FF-000044', NULL, 'Guanylate cyclase', 221, NULL, NULL, 182856),
(182857, '3.50.50.60-FF-000810', NULL, 'VisC protein', 207, NULL, NULL, 182857),
(182858, '2.60.120.10-FF-000428', NULL, 'Catabolite gene activator', 142, NULL, NULL, 182858),
(182859, '2.40.10.10-FF-000610', NULL, NULL, 113, NULL, NULL, 182859),
(182860, '1.20.1310.10-FF-000084', NULL, 'Protein CBR-CUL-2', 161, NULL, NULL, 182860),
(182861, '1.10.10.60-FF-000062', NULL, 'zinc fingers and homeoboxes protein 3', 45, NULL, NULL, 182861),
(182862, '3.30.450.40-FF-000285', NULL, 'Sensory transduction histidine kinase', 67, NULL, NULL, 182862),
(182863, '2.60.120.1190-FF-000019', NULL, 'Uncharacterized protein', 92, NULL, NULL, 182863),
(182864, '3.30.559.30-FF-000040', NULL, 'Nonribosomal peptide synthase 2', 238, NULL, NULL, 182864),
(182865, '3.30.40.10-FF-000886', NULL, 'Hypothetical_protein', 63, NULL, NULL, 182865),
(182866, '3.40.50.12660-FF-000007', NULL, 'Metacaspase-4', 111, NULL, NULL, 182866),
(182867, '2.10.25.10-FF-000668', NULL, 'LIN-12 protein, putative', 39, NULL, NULL, 182867),
(182868, '1.25.10.10-FF-002604', NULL, 'Uncharacterized protein', 146, NULL, NULL, 182868),
(182869, '1.25.10.10-FF-001295', NULL, 'ARVCF delta catenin family member b', 190, NULL, NULL, 182869),
(182870, '1.20.1070.10-FF-001357', NULL, 'Uncharacterized protein', 264, NULL, NULL, 182870),
(182871, '1.10.10.60-FF-000741', NULL, NULL, 47, NULL, NULL, 182871),
(182872, '1.20.1600.10-FF-000005', NULL, 'ABC exporter outer membrane component', 397, NULL, NULL, 182872),
(182873, '1.20.58.60-FF-000688', NULL, 'AGAP009554-PA', 323, NULL, NULL, 182873),
(182874, '1.10.530.10-FF-000008', NULL, 'Lytic murein transglycosylase B', 179, NULL, NULL, 182874),
(182875, '3.80.10.10-FF-003911', NULL, 'Uncharacterized protein', 120, NULL, NULL, 182875),
(182876, '4.10.95.10-FF-000005', NULL, 'Cytochrome c oxidase subunit 6A1', 51, NULL, NULL, 182876),
(182877, '2.40.50.690-FF-000013', NULL, 'Putative ribonuclease II-like protein', 98, NULL, NULL, 182877),
(182878, '3.90.550.50-FF-000102', NULL, 'Hexosyltransferase', 245, NULL, NULL, 182878),
(182879, '3.40.1090.10-FF-000110', NULL, 'Lysophospholipase', 238, NULL, NULL, 182879),
(182880, '3.40.50.12650-FF-000004', NULL, 'DNA cross-link repair 1A protein', 148, NULL, NULL, 182880);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(182881, '1.10.10.10-FF-001289', NULL, 'Transcriptional regulator SlyA', 140, NULL, NULL, 182881),
(182882, '1.10.238.10-FF-000025', NULL, 'serine/threonine-protein phosphatase 2A regulatory subunit B'''' subunit alpha', 173, NULL, NULL, 182882),
(182883, '2.30.30.40-FF-000177', NULL, 'Rho guanine nucleotide exchange factor (GEF) 37', 91, NULL, NULL, 182883),
(182884, '2.130.10.10-FF-000073', NULL, 'DNA damage-binding protein 1', 316, NULL, NULL, 182884),
(182885, '2.60.40.10-FF-005945', NULL, NULL, 95, NULL, NULL, 182885),
(182886, '3.10.490.10-FF-000053', NULL, 'Gamma-glutamylcyclotransferase', 185, NULL, NULL, 182886),
(182887, '3.30.230.80-FF-000027', NULL, 'Uncharacterized protein', 170, NULL, NULL, 182887),
(182888, '1.10.20.10-FF-000126', NULL, 'Histone H2A', 126, NULL, NULL, 182888),
(182889, '2.40.10.10-FF-000077', NULL, 'Predicted protein', 231, NULL, NULL, 182889),
(182890, '1.10.520.10-FF-000069', NULL, 'Peroxidase', 22, NULL, NULL, 182890),
(182891, '3.40.50.970-FF-000200', NULL, 'Acetolactate synthase, catabolic, putative', 186, NULL, NULL, 182891),
(182892, '2.60.40.10-FF-004164', NULL, NULL, 88, NULL, NULL, 182892),
(182893, '3.30.160.60-FF-001679', NULL, 'Zinc finger and BTB domain-containing protein 5', 41, NULL, NULL, 182893),
(182894, '3.80.20.20-FF-000014', NULL, 'Receptor protein-tyrosine kinase', 188, NULL, NULL, 182894),
(182895, '3.50.50.60-FF-001266', NULL, 'Uncharacterized protein', 87, NULL, NULL, 182895),
(182896, '3.90.79.10-FF-000040', NULL, 'Nudix hydrolase 19, chloroplastic', 166, NULL, NULL, 182896),
(182897, '3.40.50.300-FF-003220', NULL, 'ATP-dependent DNA helicase DDX11', 64, NULL, NULL, 182897),
(182898, '3.40.50.300-FF-000786', NULL, 'E3 ubiquitin-protein ligase SHPRH isoform X1', 195, NULL, NULL, 182898),
(182899, '3.30.40.10-FF-000301', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', 103, NULL, NULL, 182899),
(182900, '1.20.58.830-FF-000046', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 162, NULL, NULL, 182900),
(182901, '1.10.510.10-FF-004166', NULL, NULL, 188, NULL, NULL, 182901),
(182902, '1.10.1420.10-FF-000072', NULL, 'Chromosome 7, whole genome shotgun sequence', 131, NULL, NULL, 182902),
(182903, '2.30.30.940-FF-000002', NULL, 'ATP-dependent RecD-like DNA helicase', 80, NULL, NULL, 182903),
(182904, '1.10.630.10-FF-000544', NULL, 'Uncharacterized protein', 351, NULL, NULL, 182904),
(182905, '1.20.85.10-FF-000016', NULL, 'Uncharacterized protein', 67, NULL, NULL, 182905),
(182906, '3.80.10.10-FF-001820', NULL, 'WGS project CABT00000000 data, contig 2.1', 128, NULL, NULL, 182906),
(182907, '3.30.200.20-FF-001716', NULL, NULL, 23, NULL, NULL, 182907),
(182908, '2.60.120.200-FF-000791', NULL, 'Uncharacterized protein', 81, NULL, NULL, 182908),
(182909, '1.20.120.980-FF-000034', NULL, 'Clan SC, family S28, unassigned serine peptidase', 126, NULL, NULL, 182909),
(182910, '2.60.40.10-FF-000095', NULL, 'immunoglobulin superfamily member 11 isoform X1', 92, NULL, NULL, 182910),
(182911, '3.40.1110.10-FF-000248', NULL, NULL, 121, NULL, NULL, 182911),
(182912, '3.60.21.10-FF-000251', NULL, 'Sphingomyelinase phosphodiesterase D', 296, NULL, NULL, 182912),
(182913, '3.20.20.100-FF-000197', NULL, 'Uncharacterized protein', 77, NULL, NULL, 182913),
(182914, '3.30.830.10-FF-000316', NULL, 'Os02g0761400 protein', 123, NULL, NULL, 182914),
(182915, '2.130.10.10-FF-002051', NULL, 'GM25543', 176, NULL, NULL, 182915),
(182916, '3.40.50.1820-FF-001342', NULL, 'Clan SC, family S9, acylaminoacyl-peptidase-like serine peptidase', 248, NULL, NULL, 182916),
(182917, '3.10.580.10-FF-000026', NULL, 'Chloride channel protein', 126, NULL, NULL, 182917),
(182918, '3.40.50.2300-FF-001559', NULL, NULL, 18, NULL, NULL, 182918),
(182919, '1.50.40.10-FF-000569', NULL, 'Predicted protein', 95, NULL, NULL, 182919),
(182920, '3.40.50.150-FF-000073', NULL, 'THUMP domain containing 3', 196, NULL, NULL, 182920),
(182921, '1.10.510.10-FF-003823', NULL, NULL, 113, NULL, NULL, 182921),
(182922, '3.30.1120.10-FF-000026', NULL, 'Sulfatase YidJ', 83, NULL, NULL, 182922);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(182923, '2.60.40.10-FF-002073', NULL, 'Ig lambda-1 chain V regions MOPC 104E/RPC20/J558/S104', 110, NULL, NULL, 182923),
(182924, '3.30.505.10-FF-000112', NULL, 'Si:ch211-25d12.7', 105, NULL, NULL, 182924),
(182925, '2.60.120.40-FF-000004', NULL, 'Ectodysplasin-A isoform A', 144, NULL, NULL, 182925),
(182926, '3.90.70.10-FF-000227', NULL, 'Ubiquitin carboxyl-terminal hydrolase, putative', 317, NULL, NULL, 182926),
(182927, '1.10.238.10-FF-000351', NULL, 'cDNA clone:J023105D07, full insert sequence', 69, NULL, NULL, 182927),
(182928, '3.40.1350.10-FF-000029', NULL, 'Endonuclease NucS', 113, NULL, NULL, 182928),
(182929, '1.20.890.10-FF-000010', NULL, 'Putative adenylate kinase 7', 51, NULL, NULL, 182929),
(182930, '2.40.20.10-FF-000049', NULL, 'Plasminogen', 110, NULL, NULL, 182930),
(182931, '3.30.70.1820-FF-000007', NULL, 'Uncharacterized protein', 92, NULL, NULL, 182931),
(182932, '3.40.630.10-FF-000462', NULL, 'Uncharacterized protein', 112, NULL, NULL, 182932),
(182933, '3.40.850.10-FF-000001', NULL, 'Unconventional myosin XI', 243, NULL, NULL, 182933),
(182934, '3.30.160.60-FF-000870', NULL, 'zinc finger protein 197 isoform X1', 28, NULL, NULL, 182934),
(182935, '1.25.40.10-FF-002432', NULL, 'Pentatricopeptide repeat-containing protein At2g17210', 158, NULL, NULL, 182935),
(182936, '2.130.10.10-FF-002197', NULL, 'Predicted protein', 336, NULL, NULL, 182936),
(182937, '3.40.640.10-FF-000401', NULL, 'Uncharacterized protein', 13, NULL, NULL, 182937),
(182938, '3.40.50.720-FF-001165', NULL, 'Pentafunctional AROM polypeptide', 164, NULL, NULL, 182938),
(182939, '3.20.20.140-FF-000422', NULL, 'Uncharacterized protein', 61, NULL, NULL, 182939),
(182940, '3.40.525.10-FF-000004', NULL, 'Neurofibromin 1', 146, NULL, NULL, 182940),
(182941, '2.60.120.920-FF-000208', NULL, 'Uncharacterized protein', 178, NULL, NULL, 182941),
(182942, '3.40.50.720-FF-001811', NULL, 'Probable polyketide synthase 16', 283, NULL, NULL, 182942),
(182943, '2.40.128.10-FF-000001', NULL, 'Protease inhibitor Inh', 100, NULL, NULL, 182943),
(182944, '3.40.50.300-FF-002231', NULL, 'Cytidylate kinase', 229, NULL, NULL, 182944),
(182945, '2.130.10.10-FF-000752', NULL, 'Coatomer alpha subunit, putative', 208, NULL, NULL, 182945),
(182946, '3.30.9.10-FF-000268', NULL, 'Predicted protein', 110, NULL, NULL, 182946),
(182947, '1.10.287.130-FF-000175', NULL, 'Sensory box histidine kinase SdeK', 69, NULL, NULL, 182947),
(182948, '3.40.630.30-FF-000468', NULL, 'Acyl-CoA N-acyltransferase (NAT) superfamily protein', 163, NULL, NULL, 182948),
(182949, '3.40.50.10710-FF-000001', NULL, 'Ribonuclease J', 151, NULL, NULL, 182949),
(182950, '3.40.50.300-FF-001303', NULL, 'ATP binding cassette subfamily C member 11', 241, NULL, NULL, 182950),
(182951, '1.10.3730.20-FF-000059', NULL, 'Predicted protein', 118, NULL, NULL, 182951),
(182952, '3.30.420.10-FF-000561', NULL, NULL, 55, NULL, NULL, 182952),
(182953, '3.30.870.10-FF-000055', NULL, 'Tyrosyl-DNA phosphodiesterase 1', 277, NULL, NULL, 182953),
(182954, '2.60.40.150-FF-000272', NULL, 'Putative RNA helicase', 116, NULL, NULL, 182954),
(182955, '2.30.29.30-FF-000103', NULL, 'Pleckstrin homology domain-containing family A member 4', 116, NULL, NULL, 182955),
(182956, '1.10.8.60-FF-000375', NULL, 'Probable transcriptional regulator', 72, NULL, NULL, 182956),
(182957, '3.30.420.510-FF-000008', NULL, 'Pantothenate kinase', 145, NULL, NULL, 182957),
(182958, '1.10.357.60-FF-000002', NULL, 'Exocyst complex protein EXO70', 194, NULL, NULL, 182958),
(182959, '3.40.50.10130-FF-000041', NULL, 'Uncharacterized protein', 87, NULL, NULL, 182959),
(182960, '2.10.25.10-FF-001450', NULL, 'Agrin', 43, NULL, NULL, 182960),
(182961, '3.60.40.10-FF-000289', NULL, 'Protein phosphatase, Mg2+/Mn2+-dependent 1G', 94, NULL, NULL, 182961),
(182962, '3.30.70.330-FF-001583', NULL, 'Activator of basal transcription 1', 147, NULL, NULL, 182962),
(182963, '2.160.20.60-FF-000002', NULL, 'Glutamate synthase, large subunit', 271, NULL, NULL, 182963),
(182964, '2.60.40.1930-FF-000028', NULL, 'Thioester-containing protein 3', 96, NULL, NULL, 182964);
INSERT INTO "PUBLIC"."MODEL" VALUES
(182965, '3.90.226.10-FF-000343', NULL, '4-chlorobenzoyl coenzyme A dehalogenase', 204, NULL, NULL, 182965),
(182966, '3.30.70.80-FF-000043', NULL, 'Subtilisin-like protease SBT2.4', 108, NULL, NULL, 182966),
(182967, '3.80.10.10-FF-002922', NULL, 'Uncharacterized protein', 169, NULL, NULL, 182967),
(182968, '1.20.58.70-FF-000106', NULL, 'Qa-SNARE, Sso1/Syntaxin1-type, SYP13 group', 228, NULL, NULL, 182968),
(182969, '3.40.50.300-FF-004322', NULL, 'Os03g0722400 protein', 105, NULL, NULL, 182969),
(182970, '3.40.50.150-FF-001854', NULL, NULL, 25, NULL, NULL, 182970),
(182971, '3.40.50.300-FF-006093', NULL, 'Uncharacterized protein', 79, NULL, NULL, 182971),
(182972, '2.60.200.20-FF-000112', NULL, 'Serine/threonine protein kinase Chk2, putative', 107, NULL, NULL, 182972),
(182973, '1.10.10.10-FF-000041', NULL, 'Interferon regulatory factor 4', 108, NULL, NULL, 182973),
(182974, '2.160.20.70-FF-000005', NULL, 'TBCC domain-containing protein 1', 174, NULL, NULL, 182974),
(182975, '2.90.10.10-FF-000024', NULL, 'Uncharacterized protein', 126, NULL, NULL, 182975),
(182976, '3.30.420.80-FF-000003', NULL, '30S ribosomal protein S11, chloroplastic', 128, NULL, NULL, 182976),
(182977, '3.10.20.90-FF-000437', NULL, 'AFaDin (Actin filament binding protein) homolog', 121, NULL, NULL, 182977),
(182978, '1.25.10.10-FF-002284', NULL, 'Uncharacterized protein', 329, NULL, NULL, 182978),
(182979, '1.50.40.10-FF-000395', NULL, 'Uncharacterized protein', 207, NULL, NULL, 182979),
(182980, '1.20.1020.10-FF-000011', NULL, NULL, 95, NULL, NULL, 182980),
(182981, '3.40.30.10-FF-000508', NULL, 'Predicted protein', 99, NULL, NULL, 182981),
(182982, '2.10.50.10-FF-000148', NULL, 'Tumor necrosis factor receptor superfamily member 1A', 42, NULL, NULL, 182982),
(182983, '3.90.550.10-FF-000523', NULL, 'Dolichol-phosphate mannosyltransferase', 248, NULL, NULL, 182983),
(182984, '2.60.120.10-FF-000754', NULL, 'Uncharacterized protein', 88, NULL, NULL, 182984),
(182985, '1.10.287.370-FF-000016', NULL, 'Prefoldin subunit 2, putative', 101, NULL, NULL, 182985),
(182986, '1.20.58.60-FF-000103', NULL, 'Nesprin-1 isoform 1', 108, NULL, NULL, 182986),
(182987, '3.15.20.10-FF-000015', NULL, 'Ovocalyxin-36 (Uncharacterized protein)', 264, NULL, NULL, 182987),
(182988, '3.40.50.10810-FF-000031', NULL, 'Helicase, SNF2/RAD54 family', 240, NULL, NULL, 182988),
(182989, '3.30.460.10-FF-000209', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 199, NULL, NULL, 182989),
(182990, '1.10.1200.10-FF-000174', NULL, 'Microperfuranone synthase', 86, NULL, NULL, 182990),
(182991, '2.130.10.10-FF-003978', NULL, 'Predicted protein', 236, NULL, NULL, 182991),
(182992, '1.10.510.10-FF-000097', NULL, 'Putative cyclin-dependent kinase 7', 216, NULL, NULL, 182992),
(182993, '1.10.506.10-FF-000053', NULL, 'Plexin A2', 172, NULL, NULL, 182993),
(182994, '2.30.29.30-FF-000749', NULL, 'Vacuolar protein sorting protein (Vps36), putative', 55, NULL, NULL, 182994),
(182995, '1.10.8.10-FF-000293', NULL, 'Ubiquitinyl hydrolase 1', 40, NULL, NULL, 182995),
(182996, '2.160.20.80-FF-000008', NULL, 'Pentapeptide repeat protein MfpA', 183, NULL, NULL, 182996),
(182997, '2.40.70.10-FF-000086', NULL, 'ASpartyl Protease', 169, NULL, NULL, 182997),
(182998, '1.25.40.10-FF-002106', NULL, 'Pentatricopeptide repeat-containing protein', 129, NULL, NULL, 182998),
(182999, '1.10.390.10-FF-000036', NULL, 'Aminopeptidase-like protein AC3.5', 255, NULL, NULL, 182999),
(183000, '3.30.457.60-FF-000003', NULL, 'Spindle assembly checkpoint component MAD1', 64, NULL, NULL, 183000),
(183001, '3.30.420.10-FF-000089', NULL, 'Ribonuclease H', 148, NULL, NULL, 183001),
(183002, '1.20.58.390-FF-000195', NULL, 'Gamma-aminobutyric acid type A receptor rho3 subunit (gene/pseudogene)', 139, NULL, NULL, 183002),
(183003, '3.30.40.10-FF-001083', NULL, 'E3 ubiquitin ligase BIG BROTHER-related', 52, NULL, NULL, 183003),
(183004, '3.40.50.300-FF-001888', NULL, 'GTP-binding protein chloroplastic', 157, NULL, NULL, 183004),
(183005, '3.40.50.10860-FF-000052', NULL, 'Uncharacterized protein', 94, NULL, NULL, 183005);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(183006, '2.130.10.10-FF-003299', NULL, 'Putative elongator complex protein 2-like Protein', 225, NULL, NULL, 183006),
(183007, '4.10.60.10-FF-000161', NULL, 'Terminal uridylyltransferase 7', 55, NULL, NULL, 183007),
(183008, '1.20.5.390-FF-000015', NULL, NULL, 68, NULL, NULL, 183008),
(183009, '2.40.30.10-FF-000140', NULL, 'Translation initiation factor IF-2, putative', 95, NULL, NULL, 183009),
(183010, '3.40.630.30-FF-000529', NULL, 'Predicted protein', 88, NULL, NULL, 183010),
(183011, '3.30.1680.10-FF-000028', NULL, 'Semaphorin-5c', 31, NULL, NULL, 183011),
(183012, '3.40.50.880-FF-000145', NULL, 'Uncharacterized protein', 228, NULL, NULL, 183012),
(183013, '1.25.10.10-FF-003386', NULL, 'Uncharacterized protein', 142, NULL, NULL, 183013),
(183014, '3.40.640.10-FF-000108', NULL, 'Serine hydroxymethyltransferase', 263, NULL, NULL, 183014),
(183015, '3.30.930.10-FF-000173', NULL, 'Octanoyl-[GcvH]:protein N-octanoyltransferase', 277, NULL, NULL, 183015),
(183016, '3.30.565.10-FF-000121', NULL, 'Putative DNA topoisomerase VI, b subunit', 230, NULL, NULL, 183016),
(183017, '1.10.510.10-FF-002042', NULL, NULL, 123, NULL, NULL, 183017),
(183018, '2.60.40.1180-FF-000202', NULL, 'Alpha-L-arabinofuranosidase 1', 78, NULL, NULL, 183018),
(183019, '3.40.50.1100-FF-000019', NULL, 'D-cysteine desulfhydrase', 201, NULL, NULL, 183019),
(183020, '3.40.50.1000-FF-000287', NULL, 'Phospholipid-transporting ATPase', 172, NULL, NULL, 183020),
(183021, '1.25.10.10-FF-000513', NULL, 'Hym1p', 342, NULL, NULL, 183021),
(183022, '2.60.40.10-FF-004490', NULL, NULL, 112, NULL, NULL, 183022),
(183023, '1.20.272.10-FF-000052', NULL, NULL, 111, NULL, NULL, 183023),
(183024, '3.30.30.10-FF-000003', NULL, 'Defensin-like protein 1', 49, NULL, NULL, 183024),
(183025, '3.40.50.2020-FF-000138', NULL, 'Phosphoribosyl pyrophosphate synthase-associated protein 2', 141, NULL, NULL, 183025),
(183026, '3.40.47.10-FF-000018', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 2', 258, NULL, NULL, 183026),
(183027, '4.10.1110.10-FF-000001', NULL, 'Zinc finger AN1-type containing 6', 81, NULL, NULL, 183027),
(183028, '1.25.40.10-FF-000015', NULL, 'Outer membrane protein assembly factor BamD', 217, NULL, NULL, 183028),
(183029, '2.40.160.110-FF-000012', NULL, 'LAMP (Lysosome-associated membrane protein) homolog', 204, NULL, NULL, 183029),
(183030, '1.10.287.470-FF-000046', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 74, NULL, NULL, 183030),
(183031, '1.20.1070.10-FF-001150', NULL, 'Uncharacterized protein', 294, NULL, NULL, 183031),
(183032, '2.60.40.790-FF-000082', NULL, 'Heat shock protein Hsp', 144, NULL, NULL, 183032),
(183033, '3.30.390.50-FF-000024', NULL, 'Lipoate-protein ligase, putative', 100, NULL, NULL, 183033),
(183034, '1.10.510.10-FF-002721', NULL, NULL, 211, NULL, NULL, 183034),
(183035, '3.30.70.330-FF-001644', NULL, NULL, 78, NULL, NULL, 183035),
(183036, '1.10.533.10-FF-000048', NULL, 'MEFV, pyrin innate immunity regulator', 97, NULL, NULL, 183036),
(183037, '1.10.275.40-FF-000007', NULL, 'DNA repair helicase rad3/xp-D, putative', 123, NULL, NULL, 183037),
(183038, '2.10.109.10-FF-000031', NULL, 'Phage repressor-like protein', 117, NULL, NULL, 183038),
(183039, '3.40.449.10-FF-000001', NULL, 'Phosphoenolpyruvate carboxykinase (ATP)', 185, NULL, NULL, 183039),
(183040, '1.10.287.1490-FF-000072', NULL, 'Uncharacterized protein', 172, NULL, NULL, 183040),
(183041, '1.20.1250.20-FF-001251', NULL, 'AGAP011492-PA', 424, NULL, NULL, 183041),
(183042, '1.10.10.60-FF-001197', NULL, NULL, 86, NULL, NULL, 183042),
(183043, '2.70.130.10-FF-000174', NULL, NULL, 173, NULL, NULL, 183043),
(183044, '3.40.720.10-FF-000109', NULL, 'Arylsulfatase A', 224, NULL, NULL, 183044),
(183045, '3.10.290.60-FF-000007', NULL, 'Ubiquitin-activating enzyme E1, putative', 94, NULL, NULL, 183045),
(183046, '1.10.455.10-FF-000029', NULL, 'Ribosomal protein S7p/S5e', 148, NULL, NULL, 183046),
(183047, '3.90.780.10-FF-000006', NULL, '2'',3''-cyclic-nucleotide 2''-phosphodiesterase / 3''-nucleotidase', 219, NULL, NULL, 183047),
(183048, '3.30.1360.210-FF-000003', NULL, '60S ribosomal protein L22-B', 120, NULL, NULL, 183048);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(183049, '3.40.50.300-FF-005783', NULL, 'cGMP binding protein with small GTPase-serine/threonine kinase-dep-rasgef-gram-and two cGMP binding domains', 94, NULL, NULL, 183049),
(183050, '1.10.3430.10-FF-000011', NULL, 'Ammonium transporter', 432, NULL, NULL, 183050),
(183051, '2.60.40.1910-FF-000022', NULL, NULL, 94, NULL, NULL, 183051),
(183052, '3.90.70.10-FF-000492', NULL, 'ubiquitin carboxyl-terminal hydrolase 44-like', 86, NULL, NULL, 183052),
(183053, '1.20.930.80-FF-000012', NULL, 'Eukaryotic-type DNA primase, large subunit family protein', 244, NULL, NULL, 183053),
(183054, '3.30.40.10-FF-001403', NULL, 'Histone acetyltransferase', 135, NULL, NULL, 183054),
(183055, '1.25.40.20-FF-000018', NULL, 'Transient receptor potential cation channel subfamily V member 1', 304, NULL, NULL, 183055),
(183056, '3.40.50.740-FF-000036', NULL, 'NADH-quinone oxidoreductase', 93, NULL, NULL, 183056),
(183057, '3.40.50.300-FF-004529', NULL, 'DNA helicase', 160, NULL, NULL, 183057),
(183058, '3.40.30.10-FF-000660', NULL, 'Alkyl hydroperoxide reductase/ Thiol specific antioxidant/ Mal allergen', 166, NULL, NULL, 183058),
(183059, '3.40.50.300-FF-007874', NULL, 'Uncharacterized protein', 205, NULL, NULL, 183059),
(183060, '2.30.180.10-FF-000152', NULL, NULL, 142, NULL, NULL, 183060),
(183061, '1.10.418.10-FF-000062', NULL, 'Kinesin-like protein KIN-14I isoform A', 153, NULL, NULL, 183061),
(183062, '3.40.50.10810-FF-000177', NULL, 'SNF2 superfamily protein', 194, NULL, NULL, 183062),
(183063, '1.10.510.10-FF-000417', NULL, 'Leucine-rich repeat receptor-like protein kinase', 216, NULL, NULL, 183063),
(183064, '2.40.33.10-FF-000028', NULL, 'Pyruvate kinase', 98, NULL, NULL, 183064),
(183065, '3.30.200.20-FF-002205', NULL, 'Uncharacterized protein', 47, NULL, NULL, 183065),
(183066, '3.90.70.10-FF-000520', NULL, 'Ubiquitin C-terminal hydrolase, putative (AFU_orthologue AFUA_2G08440)', 176, NULL, NULL, 183066),
(183067, '3.80.10.10-FF-000977', NULL, 'Extracellular matrix protein 2', 210, NULL, NULL, 183067),
(183068, '3.30.160.20-FF-000173', NULL, 'Eukaryotic translation initiation factor 2 alpha kinase 2', 71, NULL, NULL, 183068),
(183069, '3.30.1360.120-FF-000009', NULL, 'dimethylglycine dehydrogenase, mitochondrial', 175, NULL, NULL, 183069),
(183070, '3.40.50.300-FF-002377', NULL, 'Sulfate adenylyltransferase subunit 1', 195, NULL, NULL, 183070),
(183071, '1.25.70.10-FF-000017', NULL, 'Transcription termination factor MTEF18, mitochondrial', 161, NULL, NULL, 183071),
(183072, '2.60.120.330-FF-000099', NULL, 'Protein SRG1', 293, NULL, NULL, 183072),
(183073, '2.30.33.40-FF-000004', NULL, '10 kDa chaperonin', 90, NULL, NULL, 183073),
(183074, '3.30.160.60-FF-003596', NULL, NULL, 26, NULL, NULL, 183074),
(183075, '2.60.40.10-FF-000156', NULL, 'Tenascin N', 88, NULL, NULL, 183075),
(183076, '1.10.132.60-FF-000002', NULL, 'DNA polymerase epsilon catalytic subunit', 186, NULL, NULL, 183076),
(183077, '3.90.550.50-FF-000041', NULL, 'Uncharacterized protein', 230, NULL, NULL, 183077),
(183078, '3.40.50.300-FF-004029', NULL, 'Os04g0658400 protein', 262, NULL, NULL, 183078),
(183079, '3.30.160.60-FF-006058', NULL, NULL, 41, NULL, NULL, 183079),
(183080, '1.20.144.10-FF-000030', NULL, 'Phosphatidic acid phosphatase type 2D', 241, NULL, NULL, 183080),
(183081, '2.30.29.30-FF-001059', NULL, 'Uncharacterized protein', 79, NULL, NULL, 183081),
(183082, '3.40.50.10090-FF-000068', NULL, 'Uncharacterized protein', 182, NULL, NULL, 183082),
(183083, '1.10.510.10-FF-000125', NULL, 'serine/threonine-protein kinase BLUS1-like isoform X2', 230, NULL, NULL, 183083),
(183084, '3.40.50.720-FF-001665', NULL, 'Uncharacterized protein', 145, NULL, NULL, 183084),
(183085, '3.40.50.12350-FF-000004', NULL, 'Eyes absent homolog', 60, NULL, NULL, 183085),
(183086, '2.70.170.10-FF-000148', NULL, 'Ligand-Gated ion Channel', 71, NULL, NULL, 183086),
(183087, '3.90.70.10-FF-000166', NULL, 'Ubiquitinyl hydrolase 1', 237, NULL, NULL, 183087),
(183088, '3.40.190.100-FF-000003', NULL, 'Glycine betaine-binding protein OpuAC', 103, NULL, NULL, 183088);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(183089, '1.10.287.3510-FF-000015', NULL, 'NADH dehydrogenase subunit 4L (K,kappa)', 101, NULL, NULL, 183089),
(183090, '3.40.50.2000-FF-000132', NULL, 'alpha-1,3/1,6-mannosyltransferase ALG2', 199, NULL, NULL, 183090),
(183091, '3.30.565.10-FF-000267', NULL, 'Two-component sensor histidine kinase', 125, NULL, NULL, 183091),
(183092, '3.30.160.60-FF-002461', NULL, 'Zinc finger matrin-type protein 2', 45, NULL, NULL, 183092),
(183093, '1.20.5.110-FF-000095', NULL, 'TOMosyn synaptic protein', 62, NULL, NULL, 183093),
(183094, '3.60.10.10-FF-000169', NULL, 'Endonuclease/exonuclease protein-like protein', 104, NULL, NULL, 183094),
(183095, '1.20.5.50-FF-000006', NULL, 'Fibrinogen alpha chain', 191, NULL, NULL, 183095),
(183096, '3.40.80.10-FF-000045', NULL, 'Uncharacterized protein', 101, NULL, NULL, 183096),
(183097, '3.40.50.1240-FF-000128', NULL, 'Histidine phosphatase superfamily', 397, NULL, NULL, 183097),
(183098, '3.40.50.410-FF-000347', NULL, 'Uncharacterized protein', 102, NULL, NULL, 183098),
(183099, '3.30.70.1230-FF-000218', NULL, 'Uncharacterized protein', 90, NULL, NULL, 183099),
(183100, '3.40.50.300-FF-004176', NULL, 'Helicase conserved C-terminal domain containing protein', 180, NULL, NULL, 183100),
(183101, '3.40.50.1000-FF-000107', NULL, 'Bifunctional epoxide hydrolase 2', 134, NULL, NULL, 183101),
(183102, '1.50.10.150-FF-000019', NULL, 'Uncharacterized protein', 212, NULL, NULL, 183102),
(183103, '4.10.400.10-FF-000004', NULL, 'Low-density lipoprotein receptor-related protein 1', 39, NULL, NULL, 183103),
(183104, '1.10.132.70-FF-000005', NULL, 'Telomerase reverse transcriptase', 235, NULL, NULL, 183104),
(183105, '3.40.720.10-FF-000374', NULL, 'Arylsulfatase', 216, NULL, NULL, 183105),
(183106, '3.30.160.60-FF-004259', NULL, NULL, 33, NULL, NULL, 183106),
(183107, '2.60.40.1450-FF-000013', NULL, 'Uncharacterized protein', 156, NULL, NULL, 183107),
(183108, '3.40.50.10490-FF-000098', NULL, NULL, 85, NULL, NULL, 183108),
(183109, '1.50.10.130-FF-000013', NULL, NULL, 111, NULL, NULL, 183109),
(183110, '2.130.10.10-FF-002225', NULL, 'Notchless-like protein isoform 1', 339, NULL, NULL, 183110),
(183111, '3.30.70.330-FF-003089', NULL, NULL, 105, NULL, NULL, 183111),
(183112, '3.40.720.10-FF-000082', NULL, 'Protein CBG10792', 296, NULL, NULL, 183112),
(183113, '3.40.50.1820-FF-001516', NULL, 'Triacylglycerol lipase 2', 150, NULL, NULL, 183113),
(183114, '2.60.40.10-FF-001876', NULL, 'FiLamiN (Actin binding protein) homolog', 74, NULL, NULL, 183114),
(183115, '2.60.40.10-FF-001584', NULL, 'V-set and immunoglobulin domain-containing 4', 123, NULL, NULL, 183115),
(183116, '3.80.10.10-FF-002776', NULL, 'Leucine-rich repeat-containing protein 59-like Protein', 196, NULL, NULL, 183116),
(183117, '2.70.98.10-FF-000047', NULL, 'Chondroitin sulfate ABC lyase', 262, NULL, NULL, 183117),
(183118, '3.30.1330.30-FF-000104', NULL, '50S ribosomal protein L30e', 100, NULL, NULL, 183118),
(183119, '3.60.15.10-FF-000045', NULL, 'Hydroxyacylglutathione hydrolase', 271, NULL, NULL, 183119),
(183120, '3.40.50.300-FF-001388', NULL, 'Probable pre-mRNA-splicing factor ATP-dependent RNA helicase DEAH4', 181, NULL, NULL, 183120),
(183121, '3.30.110.40-FF-000001', NULL, 'SirA-like family protein', 73, NULL, NULL, 183121),
(183122, '1.25.40.10-FF-004410', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 133, NULL, NULL, 183122),
(183123, '2.40.30.180-FF-000002', NULL, 'Ubiquitin-activating enzyme E1 2', 80, NULL, NULL, 183123),
(183124, '1.20.5.490-FF-000012', NULL, 'Uncharacterized protein', 43, NULL, NULL, 183124),
(183125, '2.170.270.10-FF-000025', NULL, 'MDS1 and EVI1 complex locus protein isoform X1', 152, NULL, NULL, 183125),
(183126, '2.10.25.10-FF-001803', NULL, 'Uncharacterized protein', 54, NULL, NULL, 183126),
(183127, '2.60.40.10-FF-005592', NULL, NULL, 90, NULL, NULL, 183127),
(183128, '3.70.10.10-FF-000028', NULL, 'DNA polymerase processivity factor', 270, NULL, NULL, 183128),
(183129, '3.40.50.720-FF-001339', NULL, 'Ketoacyl reductase hetN', 248, NULL, NULL, 183129),
(183130, '3.40.50.300-FF-002731', NULL, 'Protein CBG14243', 208, NULL, NULL, 183130);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(183131, '2.40.50.430-FF-000014', NULL, 'Uncharacterized protein', 135, NULL, NULL, 183131),
(183132, '3.30.360.10-FF-000090', NULL, 'Lysine-ketoglutarate reductase/saccharopine dehydrogenase bifunctional enzyme', 53, NULL, NULL, 183132),
(183133, '1.20.1390.10-FF-000004', NULL, 'RNA-binding motif protein 25', 117, NULL, NULL, 183133),
(183134, '1.40.20.10-FF-000001', NULL, 'Adenylate cyclase, putative', 287, NULL, NULL, 183134),
(183135, '3.40.140.10-FF-000115', NULL, 'COP9 signalosome subunit, putative', 184, NULL, NULL, 183135),
(183136, '1.10.220.10-FF-000024', NULL, 'AnNEXin family', 72, NULL, NULL, 183136),
(183137, '2.60.40.60-FF-000031', NULL, 'Cadherin 3', 111, NULL, NULL, 183137),
(183138, '1.10.10.60-FF-000415', NULL, 'Transcriptional activator MltR', 50, NULL, NULL, 183138),
(183139, '1.50.40.10-FF-000423', NULL, 'Uncharacterized protein', 189, NULL, NULL, 183139),
(183140, '3.30.70.20-FF-000132', NULL, NULL, 61, NULL, NULL, 183140),
(183141, '4.10.960.10-FF-000006', NULL, 'Putative ribosomal protein L3, Translation protein, beta-barrel domain protein', 65, NULL, NULL, 183141),
(183142, '1.10.10.580-FF-000005', NULL, 'Double-strand-break repair protein rad21', 74, NULL, NULL, 183142),
(183143, '2.60.34.10-FF-000035', NULL, 'Heat shock protein 70, putative', 177, NULL, NULL, 183143),
(183144, '1.10.510.10-FF-001878', NULL, 'Uncharacterized protein', 149, NULL, NULL, 183144),
(183145, '2.60.40.1460-FF-000016', NULL, 'Uncharacterized protein', 142, NULL, NULL, 183145),
(183146, '2.60.40.10-FF-006081', NULL, NULL, 54, NULL, NULL, 183146),
(183147, '2.130.10.10-FF-000426', NULL, 'intraflagellar transport protein 122 homolog isoform X1', 73, NULL, NULL, 183147),
(183148, '2.60.40.10-FF-004310', NULL, NULL, 100, NULL, NULL, 183148),
(183149, '2.30.29.30-FF-000396', NULL, 'Phosphoinositide phospholipase C', 122, NULL, NULL, 183149),
(183150, '1.10.10.570-FF-000002', NULL, 'Vacuolar protein sorting-associated protein 25', 96, NULL, NULL, 183150),
(183151, '3.90.79.10-FF-000247', NULL, 'MutT/NUDIX hydrolase', 159, NULL, NULL, 183151),
(183152, '2.180.10.10-FF-000020', NULL, 'Uncharacterized protein', 291, NULL, NULL, 183152),
(183153, '1.10.10.60-FF-000269', NULL, 'Transcription factor MYB46', 71, NULL, NULL, 183153),
(183154, '1.10.150.240-FF-000130', NULL, 'Uncharacterized protein', 36, NULL, NULL, 183154),
(183155, '2.20.28.10-FF-000034', NULL, 'DNA replication licensing factor MCM7', 55, NULL, NULL, 183155),
(183156, '1.20.140.100-FF-000005', NULL, 'cytoplasmic dynein 2 heavy chain 1', 149, NULL, NULL, 183156),
(183157, '4.10.1000.10-FF-000139', NULL, 'LP05025p', 59, NULL, NULL, 183157),
(183158, '3.40.640.10-FF-000081', NULL, 'Cysteine desulfurase CsdA', 259, NULL, NULL, 183158),
(183159, '2.60.40.150-FF-000564', NULL, 'Multiple C2 and transmembrane domain-containing protein 1', 135, NULL, NULL, 183159),
(183160, '3.40.50.300-FF-002405', NULL, 'Cytidylate kinase', 217, NULL, NULL, 183160),
(183161, '2.30.29.90-FF-000014', NULL, 'Uncharacterized protein', 144, NULL, NULL, 183161),
(183162, '3.10.105.10-FF-000108', NULL, 'Oligopeptide-binding protein oppA', 66, NULL, NULL, 183162),
(183163, '1.10.3160.10-FF-000001', NULL, 'Putative antigen P35', 214, NULL, NULL, 183163),
(183164, '4.10.280.10-FF-000207', NULL, 'Transcription factor bHLH117', 55, NULL, NULL, 183164),
(183165, '2.60.40.10-FF-005619', NULL, NULL, 99, NULL, NULL, 183165),
(183166, '3.30.160.190-FF-000009', NULL, 'Uncharacterized protein', 39, NULL, NULL, 183166),
(183167, '2.130.10.10-FF-004142', NULL, 'Uncharacterized protein', 181, NULL, NULL, 183167),
(183168, '3.40.710.10-FF-000137', NULL, 'Penicillin-binding protein 1A', 162, NULL, NULL, 183168),
(183169, '1.10.860.10-FF-000027', NULL, 'DNA primase', 128, NULL, NULL, 183169),
(183170, '1.10.287.110-FF-000461', NULL, 'Chaperone protein dnaJ 1 mitochondrial', 79, NULL, NULL, 183170),
(183171, '3.10.330.10-FF-000013', NULL, 'N-ethylmaleimide-sensitive fusion protein', 103, NULL, NULL, 183171),
(183172, '1.10.8.210-FF-000003', NULL, 'Siroheme synthase component enzyme', 60, NULL, NULL, 183172);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(183173, '3.30.70.330-FF-001318', NULL, 'Splicing factor U2AF subunit, putative', 107, NULL, NULL, 183173),
(183174, '3.40.50.1820-FF-000499', NULL, 'Carboxylic ester hydrolase', 523, NULL, NULL, 183174),
(183175, '1.10.439.20-FF-000001', NULL, 'Phospholipase B-like', 134, NULL, NULL, 183175),
(183176, '1.10.10.60-FF-000241', NULL, 'homeobox-leucine zipper protein ATHB-40', 70, NULL, NULL, 183176),
(183177, '1.20.870.10-FF-000008', NULL, 'RAS guanyl-releasing protein 1 isoform X1', 137, NULL, NULL, 183177),
(183178, '1.10.8.270-FF-000061', NULL, 'GTPase-activating protein', 126, NULL, NULL, 183178),
(183179, '2.130.10.10-FF-003686', NULL, 'Uncharacterized protein', 260, NULL, NULL, 183179),
(183180, '1.10.10.2010-FF-000002', NULL, 'Smallminded, isoform A', 72, NULL, NULL, 183180),
(183181, '3.10.20.90-FF-000263', NULL, 'gametogenetin-binding protein 1-like', 89, NULL, NULL, 183181),
(183182, '2.60.260.20-FF-000121', NULL, 'Uncharacterized protein', 125, NULL, NULL, 183182),
(183183, '3.10.330.20-FF-000016', NULL, 'tRNA (adenine(58)-N(1))-methyltransferase catalytic subunit TRMT61A', 70, NULL, NULL, 183183),
(183184, '2.20.70.10-FF-000042', NULL, 'Histone-lysine N-methyltransferase', 55, NULL, NULL, 183184),
(183185, '3.30.160.60-FF-006204', NULL, NULL, 37, NULL, NULL, 183185),
(183186, '3.50.50.100-FF-000027', NULL, 'Mitochondrial apoptosis inducing factor', 360, NULL, NULL, 183186),
(183187, '4.10.320.10-FF-000003', NULL, 'Acetyltransferase component of pyruvate dehydrogenase complex', 46, NULL, NULL, 183187),
(183188, '3.90.228.10-FF-000033', NULL, 'UBA/TS-N domain containing protein', 143, NULL, NULL, 183188),
(183189, '3.30.160.60-FF-006384', NULL, NULL, 28, NULL, NULL, 183189),
(183190, '3.90.1150.10-FF-000025', NULL, 'Glycine cleavage system P protein', 93, NULL, NULL, 183190),
(183191, '1.20.1070.10-FF-001503', NULL, 'Uncharacterized protein', 198, NULL, NULL, 183191),
(183192, '3.20.20.330-FF-000035', NULL, 'Uncharacterized protein', 238, NULL, NULL, 183192),
(183193, '2.60.40.10-FF-005799', NULL, NULL, 81, NULL, NULL, 183193),
(183194, '3.90.280.10-FF-000013', NULL, 'Protease inhibitor (Tfs1), putative', 177, NULL, NULL, 183194),
(183195, '3.30.70.980-FF-000029', NULL, 'Probable transcriptional regulatory protein ERS082928_00922', 80, NULL, NULL, 183195),
(183196, '1.25.40.20-FF-000670', NULL, 'ankyrin repeat and KH domain-containing protein 1-like isoform X3', 83, NULL, NULL, 183196),
(183197, '3.20.20.80-FF-000001', NULL, '1,4-alpha-glucan branching enzyme', 447, NULL, NULL, 183197),
(183198, '1.20.1440.340-FF-000012', NULL, 'Uncharacterized protein', 180, NULL, NULL, 183198),
(183199, '2.130.10.10-FF-005895', NULL, 'Two component signal transduction system hybrid histidine kinase', 290, NULL, NULL, 183199),
(183200, '3.90.1100.10-FF-000022', NULL, 'DNA-directed RNA polymerase subunit beta', 180, NULL, NULL, 183200),
(183201, '3.30.70.330-FF-001291', NULL, 'Nuclear transport factor 2 (NTF2) family protein with RNA binding (RRM-RBD-RNP motifs) domain-containing protein', 120, NULL, NULL, 183201),
(183202, '1.20.5.1930-FF-000009', NULL, 'Sensor histidine kinase', 83, NULL, NULL, 183202),
(183203, '4.10.240.10-FF-000087', NULL, 'Sut2p', 69, NULL, NULL, 183203),
(183204, '3.90.226.10-FF-000051', NULL, 'Protease 4', 163, NULL, NULL, 183204),
(183205, '1.25.40.10-FF-004702', NULL, 'Uncharacterized protein', 218, NULL, NULL, 183205),
(183206, '2.60.120.970-FF-000055', NULL, 'Uncharacterized protein', 275, NULL, NULL, 183206),
(183207, '2.80.10.50-FF-000183', NULL, 'Fascin', 125, NULL, NULL, 183207),
(183208, '3.40.630.30-FF-000294', NULL, 'N-acetyltransferase', 92, NULL, NULL, 183208),
(183209, '3.30.40.100-FF-000007', NULL, 'B3 domain-containing transcription repressor VAL2', 54, NULL, NULL, 183209),
(183210, '1.25.10.10-FF-000221', NULL, 'AP-3 adaptor complex subunit beta', 563, NULL, NULL, 183210),
(183211, '3.20.20.70-FF-000083', NULL, 'tRNA-dihydrouridine(20/20a) synthase', 242, NULL, NULL, 183211),
(183212, '1.10.3900.10-FF-000002', NULL, 'Cell division protein ZapD', 163, NULL, NULL, 183212);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(183213, '3.40.50.2000-FF-001060', NULL, 'Protein CBG17822', 107, NULL, NULL, 183213),
(183214, '2.60.40.10-FF-006108', NULL, NULL, 53, NULL, NULL, 183214),
(183215, '3.30.40.10-FF-001375', NULL, 'Fancl, isoform B', 82, NULL, NULL, 183215),
(183216, '3.40.50.1000-FF-000433', NULL, 'Plasma membrane Ca2+ ATPase isoform 2', 107, NULL, NULL, 183216),
(183217, '3.20.20.60-FF-000080', NULL, 'Pyruvate kinase', 222, NULL, NULL, 183217),
(183218, '3.30.1640.10-FF-000054', NULL, 'DNA helicase', 101, NULL, NULL, 183218),
(183219, '2.120.10.80-FF-000043', NULL, 'Kelch domain-containing protein 2', 197, NULL, NULL, 183219),
(183220, '2.10.70.10-FF-000211', NULL, 'Complement regulatory membrane protein', 57, NULL, NULL, 183220),
(183221, '3.30.420.40-FF-000311', NULL, 'Xylulokinase, putative', 223, NULL, NULL, 183221),
(183222, '2.40.70.10-FF-000232', NULL, 'Acid protease', 168, NULL, NULL, 183222),
(183223, '2.60.40.790-FF-000110', NULL, 'heat shock protein 67B3', 130, NULL, NULL, 183223),
(183224, '3.30.70.340-FF-000012', NULL, NULL, 107, NULL, NULL, 183224),
(183225, '1.10.1070.11-FF-000006', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', 199, NULL, NULL, 183225),
(183226, '3.20.80.10-FF-000029', NULL, 'AT1G78460 protein', 177, NULL, NULL, 183226),
(183227, '1.25.10.10-FF-002430', NULL, 'Putative condensin subunit 1', 242, NULL, NULL, 183227),
(183228, '2.40.30.10-FF-000314', NULL, 'Mitochondrial elongation factor G2', 140, NULL, NULL, 183228),
(183229, '2.60.120.260-FF-000230', NULL, 'E3 ubiquitin-protein ligase HECTD1 isoform X1', 127, NULL, NULL, 183229),
(183230, '3.30.70.330-FF-001936', NULL, NULL, 139, NULL, NULL, 183230),
(183231, '3.40.50.300-FF-008071', NULL, 'F-box DNA helicase 1', 120, NULL, NULL, 183231),
(183232, '1.20.5.110-FF-000269', NULL, 'Synaptosomal-associated protein 25', 83, NULL, NULL, 183232),
(183233, '3.10.20.30-FF-000026', NULL, 'MOSC domain protein', 98, NULL, NULL, 183233),
(183234, '1.10.1200.80-FF-000003', NULL, 'tRNA-dihydrouridine synthase', 66, NULL, NULL, 183234),
(183235, '3.90.70.10-FF-000727', NULL, 'Uncharacterized protein', 185, NULL, NULL, 183235),
(183236, '2.40.10.10-FF-000431', NULL, 'GM19097', 223, NULL, NULL, 183236),
(183237, '1.10.3290.10-FF-000005', NULL, 'Whole genome shotgun sequence', 314, NULL, NULL, 183237),
(183238, '3.30.160.60-FF-004613', NULL, NULL, 26, NULL, NULL, 183238),
(183239, '3.30.1360.70-FF-000011', NULL, 'Arginyl-tRNA synthetase', 122, NULL, NULL, 183239),
(183240, '1.10.730.20-FF-000026', NULL, 'Isoleucine--tRNA ligase', 268, NULL, NULL, 183240),
(183241, '3.40.120.10-FF-000053', NULL, '455aa long hypothetical phospho-sugar mutase', 92, NULL, NULL, 183241),
(183242, '1.10.730.10-FF-000023', NULL, 'probable leucine--tRNA ligase, mitochondrial', 24, NULL, NULL, 183242),
(183243, '3.90.550.10-FF-000495', NULL, 'Putative UDP-N-acetylglucosamine pyrophosphorylase', 82, NULL, NULL, 183243),
(183244, '3.40.50.300-FF-003866', NULL, 'Uncharacterized protein', 188, NULL, NULL, 183244),
(183245, '3.10.110.10-FF-000210', NULL, 'Ubiquitin-conjugating enzyme, putative', 63, NULL, NULL, 183245),
(183246, '1.25.40.690-FF-000006', NULL, 'Unplaced genomic scaffold supercont1.219, whole genome shotgun sequence', 85, NULL, NULL, 183246),
(183247, '3.40.630.10-FF-000136', NULL, 'Silver, isoform N', 110, NULL, NULL, 183247),
(183248, '3.90.110.10-FF-000001', NULL, 'Malate dehydrogenase', 167, NULL, NULL, 183248),
(183249, '1.10.287.1490-FF-000100', NULL, 'AFR286Wp', 176, NULL, NULL, 183249),
(183250, '2.70.170.10-FF-000120', NULL, 'Cholinergic receptor nicotinic epsilon subunit', 151, NULL, NULL, 183250),
(183251, '2.130.10.10-FF-002551', NULL, 'Uncharacterized protein', 424, NULL, NULL, 183251),
(183252, '3.40.30.10-FF-000834', NULL, 'Protein disulfide-isomerase', 128, NULL, NULL, 183252),
(183253, '1.50.40.10-FF-000069', NULL, 'Solute carrier family 25 member 47', 213, NULL, NULL, 183253),
(183254, '3.40.50.360-FF-000079', NULL, 'Putative NAD(P)H dehydrogenase', 189, NULL, NULL, 183254),
(183255, '1.20.120.350-FF-000227', NULL, NULL, 132, NULL, NULL, 183255);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(183256, '1.10.3080.10-FF-000085', NULL, 'Chloride channel protein', 271, NULL, NULL, 183256),
(183257, '3.30.70.270-FF-000289', NULL, NULL, 82, NULL, NULL, 183257),
(183258, '3.80.10.10-FF-004367', NULL, 'Uncharacterized protein', 174, NULL, NULL, 183258),
(183259, '1.10.1050.20-FF-000001', NULL, 'DNA-binding protein rap1', 56, NULL, NULL, 183259),
(183260, '3.20.20.70-FF-000318', NULL, 'Indole-3-glycerol phosphate synthase', 251, NULL, NULL, 183260),
(183261, '2.60.40.10-FF-003467', NULL, NULL, 99, NULL, NULL, 183261),
(183262, '1.25.40.10-FF-000633', NULL, 'Pre-mRNA splicing factor (Prp24), putative', 231, NULL, NULL, 183262),
(183263, '2.30.180.10-FF-000034', NULL, 'fasciclin-1 isoform X4', 140, NULL, NULL, 183263),
(183264, '1.20.140.40-FF-000013', NULL, 'Pectinesterase', 150, NULL, NULL, 183264),
(183265, '2.10.110.10-FF-000130', NULL, 'Protein CBG03641', 65, NULL, NULL, 183265),
(183266, '1.10.510.10-FF-000243', NULL, 'mitogen-activated protein kinase kinase kinase 20 isoform X2', 223, NULL, NULL, 183266),
(183267, '1.10.8.60-FF-000403', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 101, NULL, NULL, 183267),
(183268, '2.30.30.40-FF-000531', NULL, 'BAR domaincontaining protein', 64, NULL, NULL, 183268),
(183269, '2.60.40.150-FF-000772', NULL, 'Predicted protein', 108, NULL, NULL, 183269),
(183270, '3.40.50.1820-FF-000061', NULL, 'Carboxypeptidase', 262, NULL, NULL, 183270),
(183271, '1.20.1560.10-FF-000097', NULL, 'Inner membrane ABC-transporter YbtQ', 323, NULL, NULL, 183271),
(183272, '2.160.10.10-FF-000037', NULL, 'Streptogramin A acetyltransferase', 209, NULL, NULL, 183272),
(183273, '3.30.40.10-FF-000594', NULL, 'RING/U-box superfamily protein', 82, NULL, NULL, 183273),
(183274, '2.10.25.10-FF-001039', NULL, 'Uncharacterized protein, isoform A', 32, NULL, NULL, 183274),
(183275, '2.80.10.50-FF-000244', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 81, NULL, NULL, 183275),
(183276, '1.10.1410.10-FF-000009', NULL, 'Poly(A) RNA polymerase cid14', 169, NULL, NULL, 183276),
(183277, '2.30.29.30-FF-001177', NULL, 'Uncharacterized protein', 105, NULL, NULL, 183277),
(183278, '2.10.50.30-FF-000013', NULL, 'Calcium-sensing receptor', 77, NULL, NULL, 183278),
(183279, '1.10.510.10-FF-003469', NULL, NULL, 271, NULL, NULL, 183279),
(183280, '1.20.140.50-FF-000016', NULL, 'Vacuolar protein-sorting protein bro1', 185, NULL, NULL, 183280),
(183281, '1.20.1530.20-FF-000070', NULL, 'Uncharacterized protein', 104, NULL, NULL, 183281),
(183282, '1.20.1110.10-FF-000164', NULL, NULL, 57, NULL, NULL, 183282),
(183283, '3.30.160.60-FF-006176', NULL, NULL, 64, NULL, NULL, 183283),
(183284, '2.60.40.10-FF-002365', NULL, 'AGAP003610-PA-like protein', 96, NULL, NULL, 183284),
(183285, '3.40.50.300-FF-007582', NULL, 'Ras family protein', 177, NULL, NULL, 183285),
(183286, '1.25.40.550-FF-000015', NULL, 'Uncharacterized protein', 251, NULL, NULL, 183286),
(183287, '6.10.140.2220-FF-000055', NULL, 'Uncharacterized protein', 48, NULL, NULL, 183287),
(183288, '1.10.60.40-FF-000002', NULL, 'Alkaline phosphatase', 99, NULL, NULL, 183288),
(183289, '2.30.140.10-FF-000026', NULL, 'Spermine synthase', 72, NULL, NULL, 183289),
(183290, '2.60.40.3210-FF-000007', NULL, 'Zona pellucida glycoprotein 1', 116, NULL, NULL, 183290),
(183291, '3.90.1150.10-FF-000233', NULL, 'AGAP013274-PA', 115, NULL, NULL, 183291),
(183292, '1.25.40.540-FF-000012', NULL, 'TAP42-like protein', 229, NULL, NULL, 183292),
(183293, '1.10.1200.270-FF-000020', NULL, 'Uncharacterized protein', 111, NULL, NULL, 183293),
(183294, '3.90.70.10-FF-000048', NULL, 'Ubiquitin carboxyl-terminal hydrolase 31', 206, NULL, NULL, 183294),
(183295, '3.10.100.10-FF-000412', NULL, NULL, 162, NULL, NULL, 183295),
(183296, '1.25.10.10-FF-001587', NULL, 'Anaphase promoting complex subunit 1', 205, NULL, NULL, 183296),
(183297, '3.40.50.1220-FF-000089', NULL, 'Phenylpyruvate decarboxylase', 169, NULL, NULL, 183297),
(183298, '3.40.50.300-FF-000168', NULL, 'DEAD-box ATP-dependent RNA helicase 56-like', 219, NULL, NULL, 183298),
(183299, '2.60.120.260-FF-000668', NULL, 'Uncharacterized protein', 227, NULL, NULL, 183299);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(183300, '3.80.10.10-FF-002894', NULL, 'Uncharacterized protein', 70, NULL, NULL, 183300),
(183301, '3.50.30.30-FF-000025', NULL, 'PA and RING finger domain protein', 144, NULL, NULL, 183301),
(183302, '3.90.1480.20-FF-000047', NULL, 'ST6 N-acetylgalactosaminide alpha-2,6-sialyltransferase 5', 199, NULL, NULL, 183302),
(183303, '1.10.10.10-FF-000007', NULL, 'Ferric uptake regulation protein', 84, NULL, NULL, 183303),
(183304, '1.10.287.110-FF-000135', NULL, 'Curved DNA binding protein', 125, NULL, NULL, 183304),
(183305, '3.50.50.100-FF-000061', NULL, 'Sulfide Quinone oxidoReDuctase', 200, NULL, NULL, 183305),
(183306, '3.30.160.60-FF-000252', NULL, 'Zinc finger protein 287', 27, NULL, NULL, 183306),
(183307, '1.20.1070.10-FF-001711', NULL, 'G protein-coupled receptor, putative', 104, NULL, NULL, 183307),
(183308, '1.50.40.10-FF-000541', NULL, 'Mitochondrial carrier-like protein', 146, NULL, NULL, 183308),
(183309, '3.40.50.10110-FF-000001', NULL, 'DNA polymerase III subunit chi', 147, NULL, NULL, 183309),
(183310, '3.30.200.20-FF-001896', NULL, NULL, 65, NULL, NULL, 183310),
(183311, '3.10.20.90-FF-000471', NULL, 'RAD23 protein, putative', 89, NULL, NULL, 183311),
(183312, '2.70.150.10-FF-000265', NULL, 'Calcium-transporting ATPase', 160, NULL, NULL, 183312),
(183313, '3.30.70.330-FF-001083', NULL, 'Probable splicing factor, arginine/serine-rich 6', 107, NULL, NULL, 183313),
(183314, '3.80.10.10-FF-003557', NULL, 'Secreted protein, putative', 149, NULL, NULL, 183314),
(183315, '1.25.40.20-FF-000636', NULL, 'Glycerophosphocholine phosphodiesterase Gde1', 83, NULL, NULL, 183315),
(183316, '3.40.50.620-FF-000646', NULL, 'GMP synthase, large subunit', 195, NULL, NULL, 183316),
(183317, '3.40.630.30-FF-000614', NULL, 'Gll0913 protein', 195, NULL, NULL, 183317),
(183318, '2.180.10.10-FF-000019', NULL, 'Teneurin transmembrane protein 1', 210, NULL, NULL, 183318),
(183319, '3.30.450.90-FF-000013', NULL, 'ComG operon protein 1', 106, NULL, NULL, 183319),
(183320, '3.40.50.300-FF-002259', NULL, 'Translation initiation factor IF-2', 156, NULL, NULL, 183320),
(183321, '2.130.10.10-FF-002343', NULL, 'SnoRNA-binding rRNA-processing protein', 233, NULL, NULL, 183321),
(183322, '3.40.50.2000-FF-000778', NULL, 'UDP-glucuronosyltransferase', 161, NULL, NULL, 183322),
(183323, '3.40.50.300-FF-008571', NULL, 'Multidrug resistance protein ABC transporter family', 101, NULL, NULL, 183323),
(183324, '3.40.50.300-FF-000814', NULL, 'Large 60S subunit nuclear export GTPase 1', 170, NULL, NULL, 183324),
(183325, '3.30.1330.30-FF-000076', NULL, 'NHP2 isoform 6', 75, NULL, NULL, 183325),
(183326, '1.10.287.1080-FF-000005', NULL, 'Phosphoribosyl-ATP pyrophosphatase', 93, NULL, NULL, 183326),
(183327, '3.30.70.330-FF-000037', NULL, 'RNA-binding protein with multiple splicing 2', 93, NULL, NULL, 183327),
(183328, '3.10.100.10-FF-000030', NULL, 'Mannose receptor C-type 1', 127, NULL, NULL, 183328),
(183329, '2.10.25.10-FF-001096', NULL, 'Stabilin 2', 43, NULL, NULL, 183329),
(183330, '2.120.10.30-FF-000135', NULL, 'Nhl repeat-containing protein, putative', 230, NULL, NULL, 183330),
(183331, '1.25.40.10-FF-001768', NULL, 'Pentatricopeptide repeat protein', 172, NULL, NULL, 183331),
(183332, '1.10.357.10-FF-000009', NULL, 'HTH-type transcriptional regulator BetI', 186, NULL, NULL, 183332),
(183333, '1.20.5.1160-FF-000031', NULL, 'Uveal autoantigen with coiled-coil domains and ankyrin repeats', 111, NULL, NULL, 183333),
(183334, '3.40.50.970-FF-000054', NULL, 'Putative 2-hydroxyphytanoyl-CoA lyase', 171, NULL, NULL, 183334),
(183335, '2.60.40.790-FF-000109', NULL, 'GD14174', 136, NULL, NULL, 183335),
(183336, '1.10.287.190-FF-000001', NULL, 'Transcription initiation factor IIA subunit 2', 52, NULL, NULL, 183336),
(183337, '1.25.40.10-FF-003921', NULL, 'Uncharacterized protein', 431, NULL, NULL, 183337),
(183338, '2.60.450.20-FF-000012', NULL, 'Predicted protein', 149, NULL, NULL, 183338),
(183339, '2.170.11.10-FF-000005', NULL, 'DNA topoisomerase I', 34, NULL, NULL, 183339),
(183340, '3.30.870.10-FF-000201', NULL, 'Uncharacterized protein', 151, NULL, NULL, 183340);
INSERT INTO "PUBLIC"."MODEL" VALUES
(183341, '2.130.10.10-FF-001769', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 364, NULL, NULL, 183341),
(183342, '3.40.850.10-FF-000439', NULL, 'Uncharacterized protein', 134, NULL, NULL, 183342),
(183343, '2.170.270.10-FF-000143', NULL, 'SET domain containing protein, putative', 87, NULL, NULL, 183343),
(183344, '1.20.1530.20-FF-000013', NULL, 'sodium/bile acid cotransporter 4', 294, NULL, NULL, 183344),
(183345, '3.30.420.10-FF-000589', NULL, NULL, 290, NULL, NULL, 183345),
(183346, '3.30.450.20-FF-000684', NULL, 'Predicted protein', 63, NULL, NULL, 183346),
(183347, '2.40.70.10-FF-000440', NULL, NULL, 101, NULL, NULL, 183347),
(183348, '1.20.1270.280-FF-000050', NULL, 'Uncharacterized protein', 167, NULL, NULL, 183348),
(183349, '1.20.120.350-FF-000019', NULL, 'Sodium channel protein', 115, NULL, NULL, 183349),
(183350, '3.50.50.60-FF-000895', NULL, 'Probable flavin containing oxidoreductase (Homolog to phytoene desaturase / monoamine oxidase)', 122, NULL, NULL, 183350),
(183351, '1.10.10.10-FF-000333', NULL, 'enhanced ethylene response protein 5', 73, NULL, NULL, 183351),
(183352, '1.10.238.10-FF-000643', NULL, 'EF-hand calcium-binding domain-containing protein 4B', 98, NULL, NULL, 183352),
(183353, '1.20.5.4820-FF-000016', NULL, 'Myosin XXI', 125, NULL, NULL, 183353),
(183354, '3.30.830.10-FF-000081', NULL, 'Axl1p', 229, NULL, NULL, 183354),
(183355, '3.30.160.60-FF-003916', NULL, 'ZNF177 isoform 3', 76, NULL, NULL, 183355),
(183356, '3.30.450.40-FF-000313', NULL, 'Phosphodiesterase', 187, NULL, NULL, 183356),
(183357, '1.10.510.10-FF-004458', NULL, NULL, 285, NULL, NULL, 183357),
(183358, '2.130.10.10-FF-005777', NULL, 'Predicted protein', 104, NULL, NULL, 183358),
(183359, '3.40.50.2060-FF-000009', NULL, 'sec1 family domain-containing protein 1 isoform X3', 78, NULL, NULL, 183359),
(183360, '3.30.40.10-FF-001049', NULL, 'E3 ubiquitin-protein ligase EL5', 55, NULL, NULL, 183360),
(183361, '3.30.30.30-FF-000043', NULL, 'Uncharacterized protein', 53, NULL, NULL, 183361),
(183362, '3.30.830.10-FF-000024', NULL, 'Stromal processing peptidase chloroplastic', 186, NULL, NULL, 183362),
(183363, '3.90.780.10-FF-000040', NULL, 'Uncharacterized protein', 127, NULL, NULL, 183363),
(183364, '1.10.472.10-FF-000086', NULL, 'Cyclin domain protein', 92, NULL, NULL, 183364),
(183365, '2.40.10.10-FF-000223', NULL, 'GM13756', 231, NULL, NULL, 183365),
(183366, '2.30.180.10-FF-000091', NULL, 'Fasciclin-1 fasciclin i fas i fcn', 139, NULL, NULL, 183366),
(183367, '2.60.40.10-FF-001758', NULL, 'Fibronectin type III and SPRY domain containing 2', 87, NULL, NULL, 183367),
(183368, '3.40.1230.10-FF-000021', NULL, 'Nuclear protein E3-3, isoform a, putative, expressed', 64, NULL, NULL, 183368),
(183369, '3.40.50.980-FF-000057', NULL, 'Uncharacterized protein', 68, NULL, NULL, 183369),
(183370, '1.50.40.10-FF-000277', NULL, 'Uncharacterized protein', 242, NULL, NULL, 183370),
(183371, '1.20.120.340-FF-000016', NULL, 'Perilipin', 131, NULL, NULL, 183371),
(183372, '3.30.200.20-FF-000053', NULL, 'Tyrosine-protein kinase', 86, NULL, NULL, 183372),
(183373, '1.10.510.10-FF-003795', NULL, NULL, 125, NULL, NULL, 183373),
(183374, '3.30.200.20-FF-001481', NULL, 'Kinase, NEK-frag', 53, NULL, NULL, 183374),
(183375, '3.90.730.10-FF-000003', NULL, 'Ribonuclease 3', 207, NULL, NULL, 183375),
(183376, '3.90.1140.10-FF-000053', NULL, 'Predicted protein', 204, NULL, NULL, 183376),
(183377, '3.40.390.10-FF-000100', NULL, 'Oligopeptidase A, putative', 150, NULL, NULL, 183377),
(183378, '3.40.50.300-FF-001949', NULL, 'RNA helicase', 305, NULL, NULL, 183378),
(183379, '3.90.70.10-FF-000312', NULL, 'RTX toxin transporter', 122, NULL, NULL, 183379),
(183380, '1.10.420.10-FF-000005', NULL, 'L-ascorbate peroxidase T, chloroplastic', 124, NULL, NULL, 183380),
(183381, '3.40.50.300-FF-002113', NULL, '3''-phosphoadenosine 5''-phosphosulfate synthase 1', 47, NULL, NULL, 183381),
(183382, '2.80.10.50-FF-000036', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 137, NULL, NULL, 183382),
(183383, '2.30.30.40-FF-000323', NULL, 'Muscle M-line assembly protein unc-89', 66, NULL, NULL, 183383);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(183384, '3.30.530.20-FF-000100', NULL, 'Uncharacterized protein', 195, NULL, NULL, 183384),
(183385, '2.60.40.1760-FF-000016', NULL, 'Alpha-1,4-glucosidase (Eurofung)', 241, NULL, NULL, 183385),
(183386, '3.30.1370.100-FF-000034', NULL, 'DNA mismatch repair protein (Mlh3), putative (AFU_orthologue AFUA_4G06490)', 123, NULL, NULL, 183386),
(183387, '1.20.1280.50-FF-000132', NULL, 'Cyclic nucleotide-binding domain-containing protein', 44, NULL, NULL, 183387),
(183388, '4.10.640.10-FF-000016', NULL, '30S ribosomal protein S18', 78, NULL, NULL, 183388),
(183389, '2.40.50.140-FF-001186', NULL, NULL, 144, NULL, NULL, 183389),
(183390, '1.20.1310.10-FF-000230', NULL, NULL, 113, NULL, NULL, 183390),
(183391, '1.10.510.10-FF-002660', NULL, NULL, 140, NULL, NULL, 183391),
(183392, '1.25.40.10-FF-001297', NULL, 'GM23710', 122, NULL, NULL, 183392),
(183393, '3.30.70.580-FF-000033', NULL, 'tRNA pseudouridine synthase', 118, NULL, NULL, 183393),
(183394, '3.40.720.10-FF-000289', NULL, 'Uncharacterized protein', 271, NULL, NULL, 183394),
(183395, '3.90.1750.10-FF-000054', NULL, 'Ubiquitin protein ligase, putative', 155, NULL, NULL, 183395),
(183396, '1.10.8.720-FF-000033', NULL, 'Dynein gamma chain, flagellar outer arm', 175, NULL, NULL, 183396),
(183397, '1.10.520.10-FF-000070', NULL, 'Peroxidase', 20, NULL, NULL, 183397),
(183398, '1.20.1250.20-FF-000969', NULL, 'Probable major facilitator superfamily (MFS) transporter', 222, NULL, NULL, 183398),
(183399, '3.30.70.330-FF-003117', NULL, NULL, 68, NULL, NULL, 183399),
(183400, '1.10.510.10-FF-004251', NULL, NULL, 301, NULL, NULL, 183400),
(183401, '3.30.1140.60-FF-000025', NULL, 'F-actin-capping protein subunit alpha', 87, NULL, NULL, 183401),
(183402, '3.30.930.10-FF-000291', NULL, 'Lysine--tRNA ligase', 341, NULL, NULL, 183402),
(183403, '3.30.540.10-FF-000070', NULL, 'Uncharacterized protein', 87, NULL, NULL, 183403),
(183404, '3.80.10.10-FF-003411', NULL, 'F-box and leucine-rich repeat protein 20', 86, NULL, NULL, 183404),
(183405, '2.110.10.10-FF-000062', NULL, 'Uncharacterized protein', 159, NULL, NULL, 183405),
(183406, '3.30.9.10-FF-000061', NULL, 'Fructosyl amine: oxygen oxidoreductase', 46, NULL, NULL, 183406),
(183407, '1.10.8.710-FF-000030', NULL, NULL, 63, NULL, NULL, 183407),
(183408, '2.10.25.10-FF-001303', NULL, 'cadherin EGF LAG seven-pass G-type receptor 2 isoform X2', 38, NULL, NULL, 183408),
(183409, '1.10.510.10-FF-000451', NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', 276, NULL, NULL, 183409),
(183410, '3.30.160.60-FF-004321', NULL, NULL, 32, NULL, NULL, 183410),
(183411, '3.30.160.60-FF-001241', NULL, 'Spalt like transcription factor 4', 33, NULL, NULL, 183411),
(183412, '3.30.420.40-FF-001059', NULL, 'Uncharacterized protein', 69, NULL, NULL, 183412),
(183413, '3.20.20.70-FF-000375', NULL, 'Dihydroorotate reductase PyrE', 405, NULL, NULL, 183413),
(183414, '1.10.472.10-FF-000350', NULL, 'Cyclin E-like protein', 153, NULL, NULL, 183414),
(183415, '2.60.120.1000-FF-000036', NULL, 'Predicted protein', 101, NULL, NULL, 183415),
(183416, '3.40.50.1000-FF-000725', NULL, NULL, 80, NULL, NULL, 183416),
(183417, '3.30.500.10-FF-000005', NULL, 'MHC class I antigen ZKA transcript variant 1', 186, NULL, NULL, 183417),
(183418, '4.10.410.10-FF-000095', NULL, 'Serine proteinase inhibitor, putative', 50, NULL, NULL, 183418),
(183419, '1.25.40.10-FF-001976', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform A', 115, NULL, NULL, 183419),
(183420, '3.90.1750.10-FF-000083', NULL, 'Zn-finger in Ran binding protein and others/SPRY domain/HECT-domain (Ubiquitin-transferase), putative', 153, NULL, NULL, 183420),
(183421, '3.40.50.2000-FF-000250', NULL, 'Glucosyltransferase I RfaG', 161, NULL, NULL, 183421),
(183422, '1.10.287.70-FF-000656', NULL, 'Uncharacterized protein', 142, NULL, NULL, 183422),
(183423, '1.10.630.10-FF-000836', NULL, 'Uncharacterized protein', 109, NULL, NULL, 183423),
(183424, '1.10.455.10-FF-000030', NULL, '40S ribosomal protein S5', 87, NULL, NULL, 183424),
(183425, '3.30.70.330-FF-000301', NULL, 'Nucleolysin TIAR-like protein', 99, NULL, NULL, 183425);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(183426, '3.40.30.10-FF-001031', NULL, 'Uncharacterized protein', 46, NULL, NULL, 183426),
(183427, '3.30.420.40-FF-000165', NULL, 'Propionate kinase', 188, NULL, NULL, 183427),
(183428, '4.10.400.10-FF-000330', NULL, 'Uncharacterized protein', 42, NULL, NULL, 183428),
(183429, '3.30.160.60-FF-004467', NULL, NULL, 45, NULL, NULL, 183429),
(183430, '2.60.40.10-FF-000510', NULL, 'cell adhesion molecule 3 isoform X1', 92, NULL, NULL, 183430),
(183431, '3.90.76.10-FF-000033', NULL, 'Peptide/nickel transport system substrate-binding protein', 145, NULL, NULL, 183431),
(183432, '3.30.450.40-FF-000105', NULL, 'Transcriptional regulator, IclR family', 171, NULL, NULL, 183432),
(183433, '1.20.1560.10-FF-000861', NULL, 'Multidrug resistance-associated protein Mrp2', 191, NULL, NULL, 183433),
(183434, '2.60.120.380-FF-000092', NULL, 'Flagellar associated protein', 168, NULL, NULL, 183434),
(183435, '1.20.58.1880-FF-000005', NULL, 'REST corepressor 3 isoform X3', 93, NULL, NULL, 183435),
(183436, '3.40.50.300-FF-006154', NULL, 'Predicted protein', 320, NULL, NULL, 183436),
(183437, '3.10.20.310-FF-000048', NULL, 'Translocon outer membrane complex 75-I', 57, NULL, NULL, 183437),
(183438, '2.10.70.10-FF-000065', NULL, 'Coagulation factor XIII B chain', 57, NULL, NULL, 183438),
(183439, '2.30.29.30-FF-001385', NULL, 'Predicted protein', 120, NULL, NULL, 183439),
(183440, '2.40.20.10-FF-000083', NULL, 'Urokinase-type plasminogen activator', 89, NULL, NULL, 183440),
(183441, '3.90.1420.10-FF-000035', NULL, 'Predicted protein', 169, NULL, NULL, 183441),
(183442, '2.70.130.10-FF-000056', NULL, NULL, 149, NULL, NULL, 183442),
(183443, '2.130.10.10-FF-005569', NULL, 'Predicted protein', 211, NULL, NULL, 183443),
(183444, '3.30.420.10-FF-000527', NULL, NULL, 102, NULL, NULL, 183444),
(183445, '3.30.1120.10-FF-000060', NULL, 'Aryl-sulphate sulphohydrolase', 61, NULL, NULL, 183445),
(183446, '3.40.1010.10-FF-000010', NULL, 'Cobalamin biosynthesis protein CobIJ', 111, NULL, NULL, 183446),
(183447, '2.10.70.10-FF-000183', NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain containing 1', 64, NULL, NULL, 183447),
(183448, '3.40.50.300-FF-008363', NULL, 'Uncharacterized protein', 132, NULL, NULL, 183448),
(183449, '3.40.50.2020-FF-000110', NULL, 'ribose-phosphate pyrophosphokinase 4', 162, NULL, NULL, 183449),
(183450, '2.20.25.10-FF-000027', NULL, 'Multifunctional methyltransferase subunit TRM112-like protein', 122, NULL, NULL, 183450),
(183451, '1.20.140.150-FF-000093', NULL, 'uncharacterized protein LOC100186093', 94, NULL, NULL, 183451),
(183452, '2.60.40.60-FF-000531', NULL, 'Dachsous cadherin-related 1a', 108, NULL, NULL, 183452),
(183453, '1.10.1420.10-FF-000038', NULL, 'Msh2p', 82, NULL, NULL, 183453),
(183454, '3.30.565.10-FF-000149', NULL, 'heat shock protein HSP 90-beta isoform X3', 105, NULL, NULL, 183454),
(183455, '1.10.10.60-FF-000623', NULL, 'Transcription factor MYB4', 76, NULL, NULL, 183455),
(183456, '3.40.50.1400-FF-000019', NULL, 'Ferrochelatase', 135, NULL, NULL, 183456),
(183457, '3.10.250.10-FF-000125', NULL, NULL, 101, NULL, NULL, 183457),
(183458, '1.10.540.10-FF-000071', NULL, 'Putative acyl-CoA dehydrogenase', 108, NULL, NULL, 183458),
(183459, '2.40.50.140-FF-000051', NULL, 'RNA-binding transcriptional accessory protein', 91, NULL, NULL, 183459),
(183460, '2.40.30.10-FF-000022', NULL, 'Elongation factor G, mitochondrial', 114, NULL, NULL, 183460),
(183461, '1.20.1050.10-FF-000131', NULL, 'Glutathione S-transferase omega-2', 55, NULL, NULL, 183461),
(183462, '4.10.1240.10-FF-000005', NULL, 'Parathyroid hormone/parathyroid hormone-related peptide receptor', 101, NULL, NULL, 183462),
(183463, '2.20.80.10-FF-000014', NULL, 'Uncharacterized protein', 248, NULL, NULL, 183463),
(183464, '2.130.10.10-FF-000634', NULL, 'syntaxin-binding protein 5 isoform X1', 167, NULL, NULL, 183464),
(183465, '2.40.50.100-FF-000207', NULL, 'Putative glycine cleavage system H protein, mitochondrial', 138, NULL, NULL, 183465),
(183466, '3.40.50.2300-FF-000778', NULL, NULL, 128, NULL, NULL, 183466);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(183467, '3.20.20.70-FF-000436', NULL, 'Predicted protein', 299, NULL, NULL, 183467),
(183468, '3.80.10.10-FF-003147', NULL, 'Protein CBG00902', 305, NULL, NULL, 183468),
(183469, '3.40.30.10-FF-000008', NULL, 'Stringent starvation protein A', 87, NULL, NULL, 183469),
(183470, '1.25.40.20-FF-000226', NULL, 'Ankyrin repeat domain-containing protein 9', 162, NULL, NULL, 183470),
(183471, '1.10.510.10-FF-002249', NULL, NULL, 179, NULL, NULL, 183471),
(183472, '1.25.40.10-FF-003449', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform A', 137, NULL, NULL, 183472),
(183473, '3.30.70.330-FF-001791', NULL, NULL, 131, NULL, NULL, 183473),
(183474, '1.25.40.10-FF-004023', NULL, 'Uncharacterized protein', 188, NULL, NULL, 183474),
(183475, '1.25.40.10-FF-000223', NULL, 'Tetratricopeptide repeat domain 28', 156, NULL, NULL, 183475),
(183476, '3.40.50.2300-FF-001352', NULL, NULL, 44, NULL, NULL, 183476),
(183477, '3.30.2350.20-FF-000046', NULL, NULL, 230, NULL, NULL, 183477),
(183478, '1.25.40.10-FF-001561', NULL, 'Pentatricopeptide repeat-containing protein At2g21090', 157, NULL, NULL, 183478),
(183479, '3.20.140.10-FF-000013', NULL, 'Nicotinate phosphoribosyltransferase', 201, NULL, NULL, 183479),
(183480, '1.10.8.60-FF-000167', NULL, 'AAA family ATPase', 29, NULL, NULL, 183480),
(183481, '3.40.50.720-FF-002475', NULL, 'Asperfuranone polyketide synthase afoG', 255, NULL, NULL, 183481),
(183482, '1.25.40.450-FF-000018', NULL, 'Uncharacterized protein', 102, NULL, NULL, 183482),
(183483, '3.30.160.60-FF-000370', NULL, 'Metal regulatory transcription factor 1', 29, NULL, NULL, 183483),
(183484, '2.60.40.150-FF-000064', NULL, 'synaptotagmin-17 isoform X1', 154, NULL, NULL, 183484),
(183485, '2.10.25.10-FF-001511', NULL, 'Fibulin-1', 43, NULL, NULL, 183485),
(183486, '3.20.20.70-FF-000583', NULL, NULL, 117, NULL, NULL, 183486),
(183487, '2.130.10.10-FF-002079', NULL, 'Zinc finger CCCH domain-containing protein 59', 66, NULL, NULL, 183487),
(183488, '3.30.160.60-FF-001033', NULL, 'Zinc finger protein 142', 27, NULL, NULL, 183488),
(183489, '3.80.10.10-FF-004485', NULL, 'Probable serine/threonine-protein kinase DDB_G0278509', 112, NULL, NULL, 183489),
(183490, '3.30.40.10-FF-001521', NULL, 'RING-H2 finger protein ATL67', 72, NULL, NULL, 183490),
(183491, '1.25.10.10-FF-001469', NULL, 'Dynein axonemal assembly factor 5', 258, NULL, NULL, 183491),
(183492, '3.40.33.10-FF-000133', NULL, 'Uncharacterized protein', 185, NULL, NULL, 183492),
(183493, '1.10.3720.10-FF-000230', NULL, 'Amino acid ABC transporter, permease protein', 217, NULL, NULL, 183493),
(183494, '1.20.5.1010-FF-000003', NULL, 'Transient receptor potential cation channel trpm', 55, NULL, NULL, 183494),
(183495, '2.40.37.20-FF-000001', NULL, 'D-3-hydroxyaspartate aldolase', 127, NULL, NULL, 183495),
(183496, '3.30.160.60-FF-006412', NULL, NULL, 59, NULL, NULL, 183496),
(183497, '2.40.50.1020-FF-000018', NULL, 'Two-component system response regulator', 120, NULL, NULL, 183497),
(183498, '3.90.226.10-FF-000017', NULL, 'Propionyl-CoA carboxylase subunit beta 5', 258, NULL, NULL, 183498),
(183499, '3.30.200.20-FF-001834', NULL, 'Putative serine/threonine protein kinase', 115, NULL, NULL, 183499),
(183500, '3.40.1170.60-FF-000047', NULL, NULL, 28, NULL, NULL, 183500),
(183501, '1.10.10.10-FF-000069', NULL, 'Paired box protein Pax-6', 73, NULL, NULL, 183501),
(183502, '3.30.160.60-FF-005395', NULL, NULL, 45, NULL, NULL, 183502),
(183503, '3.30.1690.10-FF-000001', NULL, 'Toxin co-regulated pilin', 171, NULL, NULL, 183503),
(183504, '3.50.50.60-FF-001148', NULL, 'FAD/NAD(P)-binding oxidoreductase family protein', 77, NULL, NULL, 183504),
(183505, '1.10.238.10-FF-000290', NULL, 'LETM1 and EF-hand domain-containing protein 1, mitochondrial', 199, NULL, NULL, 183505),
(183506, '3.10.100.10-FF-000176', NULL, 'Killer cell lectin-like receptor subfamily G member 1', 113, NULL, NULL, 183506),
(183507, '3.30.200.20-FF-001688', NULL, 'Uncharacterized protein', 68, NULL, NULL, 183507),
(183508, '1.20.1250.20-FF-000031', NULL, 'Hexose phosphate transporter', 201, NULL, NULL, 183508);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(183509, '2.70.40.10-FF-000015', NULL, 'Deoxyuridine 5''-triphosphate nucleotidohydrolase', 145, NULL, NULL, 183509),
(183510, '1.25.10.10-FF-000075', NULL, 'Anaphase promoting complex subunit 1', 203, NULL, NULL, 183510),
(183511, '1.10.510.10-FF-003941', NULL, NULL, 64, NULL, NULL, 183511),
(183512, '1.25.50.20-FF-000108', NULL, 'Uncharacterized protein', 83, NULL, NULL, 183512),
(183513, '3.40.50.150-FF-000191', NULL, 'mRNA cap guanine-N7 methyltransferase 2', 274, NULL, NULL, 183513),
(183514, '1.10.472.10-FF-000232', NULL, 'Cyclin box fold, protein binding domain protein', 113, NULL, NULL, 183514),
(183515, '1.10.10.440-FF-000076', NULL, 'YALI0D02827p', 56, NULL, NULL, 183515),
(183516, '2.40.70.10-FF-000294', NULL, NULL, 116, NULL, NULL, 183516),
(183517, '1.20.1250.40-FF-000037', NULL, 'Uncharacterized protein', 65, NULL, NULL, 183517),
(183518, '3.40.50.720-FF-001250', NULL, 'FAD dependent oxidoreductase', 194, NULL, NULL, 183518),
(183519, '2.130.10.10-FF-000191', NULL, 'mRNA splicing factor', 322, NULL, NULL, 183519),
(183520, '1.10.268.10-FF-000027', NULL, NULL, 172, NULL, NULL, 183520),
(183521, '3.80.10.10-FF-001348', NULL, 'Toll receptor 13', 116, NULL, NULL, 183521),
(183522, '3.40.50.300-FF-000932', NULL, 'ABC transporter G family member 3', 245, NULL, NULL, 183522),
(183523, '1.10.357.170-FF-000001', NULL, 'Multifunctional virulence effector protein DrrA', 211, NULL, NULL, 183523),
(183524, '1.10.3260.10-FF-000003', NULL, 'DNA ligase', 239, NULL, NULL, 183524),
(183525, '2.60.40.60-FF-000323', NULL, 'Protocadherin Fat 2', 108, NULL, NULL, 183525),
(183526, '1.10.10.60-FF-000180', NULL, 'DnaJ (Hsp40) homolog, subfamily C, member 2', 60, NULL, NULL, 183526),
(183527, '3.40.30.10-FF-000626', NULL, 'GM13104', 141, NULL, NULL, 183527),
(183528, '3.30.160.60-FF-004260', NULL, NULL, 30, NULL, NULL, 183528),
(183529, '1.20.58.2220-FF-000057', NULL, 'Formin 1', 105, NULL, NULL, 183529),
(183530, '3.80.10.10-FF-003350', NULL, 'Uncharacterized protein', 117, NULL, NULL, 183530),
(183531, '2.10.25.10-FF-000994', NULL, 'Agrin', 47, NULL, NULL, 183531),
(183532, '3.10.20.30-FF-000060', NULL, 'Small GTP-binding protein', 73, NULL, NULL, 183532),
(183533, '2.130.10.10-FF-000134', NULL, 'striatin-3 isoform X2', 127, NULL, NULL, 183533),
(183534, '3.40.630.10-FF-000344', NULL, 'D-alanine--D-alanine ligase', 237, NULL, NULL, 183534),
(183535, '3.50.50.60-FF-001412', NULL, 'Amine oxidase', 134, NULL, NULL, 183535),
(183536, '3.40.50.150-FF-000134', NULL, 'protein-lysine methyltransferase METTL21D isoform X1', 223, NULL, NULL, 183536),
(183537, '1.10.1740.10-FF-000028', NULL, 'RNA polymerase subunit sigma', 82, NULL, NULL, 183537),
(183538, '1.10.150.880-FF-000001', NULL, 'Bacteriocin, putative', 125, NULL, NULL, 183538),
(183539, '3.40.50.720-FF-000676', NULL, 'D-3-phosphoglycerate dehydrogenase', 104, NULL, NULL, 183539),
(183540, '1.10.8.530-FF-000009', NULL, 'Uncharacterized protein', 76, NULL, NULL, 183540),
(183541, '1.25.40.840-FF-000012', NULL, 'CCR4-NOT transcription complex subunit 1', 180, NULL, NULL, 183541),
(183542, '1.10.10.60-FF-000123', NULL, 'HTH-type transcriptional regulator AdiY', 111, NULL, NULL, 183542),
(183543, '3.40.50.1820-FF-000999', NULL, 'Putative esterase', 235, NULL, NULL, 183543),
(183544, '3.10.580.10-FF-000144', NULL, 'Chloride channel protein', 133, NULL, NULL, 183544),
(183545, '3.90.79.10-FF-000101', NULL, 'U8 snoRNA-decapping enzyme', 196, NULL, NULL, 183545),
(183546, '1.25.40.10-FF-005158', NULL, 'RNA binding rRNA processing protein', 87, NULL, NULL, 183546),
(183547, '1.20.5.170-FF-000298', NULL, 'Uncharacterized protein', 31, NULL, NULL, 183547),
(183548, '3.20.20.80-FF-000439', NULL, 'Chitinase, acidic.3', 203, NULL, NULL, 183548),
(183549, '1.10.10.10-FF-001761', NULL, 'Regulatory protein RecX', 44, NULL, NULL, 183549),
(183550, '2.10.220.10-FF-000166', NULL, 'Uncharacterized protein', 94, NULL, NULL, 183550),
(183551, '1.20.58.120-FF-000013', NULL, 'BAG family molecular chaperone regulator 5, mitochondrial', 108, NULL, NULL, 183551),
(183552, '2.130.10.10-FF-003771', NULL, 'Uncharacterized WD repeat-containing protein C18H10.05', 317, NULL, NULL, 183552);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(183553, '2.60.120.620-FF-000147', NULL, 'Predicted protein', 101, NULL, NULL, 183553),
(183554, '2.60.40.60-FF-000177', NULL, 'Cadherin-related family member 1', 110, NULL, NULL, 183554),
(183555, '3.40.50.1100-FF-000199', NULL, 'O-acetyl-serine sulfhydrylase chain a, putative', 73, NULL, NULL, 183555),
(183556, '3.10.20.90-FF-000319', NULL, 'Ubiquitin-like protein', 30, NULL, NULL, 183556),
(183557, '3.30.1360.40-FF-000053', NULL, 'Sugar transporter ERD6-like 6', 40, NULL, NULL, 183557),
(183558, '2.60.120.330-FF-000127', NULL, 'Predicted protein', 157, NULL, NULL, 183558),
(183559, '2.40.50.100-FF-000117', NULL, 'Multiple sugar ABC transporter ATP-bindingprotein', 66, NULL, NULL, 183559),
(183560, '2.130.10.10-FF-001562', NULL, 'Inner dynein arm I1 intermediate chain IC138', 205, NULL, NULL, 183560),
(183561, '3.10.450.50-FF-000040', NULL, 'Terephthalate 1,2-dioxygenase subunit beta', 153, NULL, NULL, 183561),
(183562, '3.30.160.60-FF-002522', NULL, 'Zinc finger protein', 28, NULL, NULL, 183562),
(183563, '3.40.50.2300-FF-001088', NULL, NULL, 150, NULL, NULL, 183563),
(183564, '3.40.50.150-FF-000752', NULL, 'Ribosomal RNA small subunit methyltransferase G', 207, NULL, NULL, 183564),
(183565, '3.30.420.10-FF-000735', NULL, NULL, 192, NULL, NULL, 183565),
(183566, '1.10.10.10-FF-001968', NULL, 'Uncharacterized protein', 69, NULL, NULL, 183566),
(183567, '1.10.530.10-FF-000042', NULL, 'Invertebrate LYSozyme', 126, NULL, NULL, 183567),
(183568, '1.10.3720.10-FF-000084', NULL, 'Peptide ABC transporter permease', 229, NULL, NULL, 183568),
(183569, '1.10.287.110-FF-000343', NULL, 'Chaperone protein DNAj, putative', 65, NULL, NULL, 183569),
(183570, '1.25.70.10-FF-000051', NULL, 'Protein CBG08723', 244, NULL, NULL, 183570),
(183571, '3.40.1550.10-FF-000011', NULL, 'CheY-P phosphatase CheX', 155, NULL, NULL, 183571),
(183572, '2.130.10.10-FF-004024', NULL, 'Uncharacterized protein', 222, NULL, NULL, 183572),
(183573, '3.30.160.60-FF-000218', NULL, 'Zinc finger protein 10', 28, NULL, NULL, 183573),
(183574, '3.40.50.300-FF-007548', NULL, 'Uncharacterized protein', 194, NULL, NULL, 183574),
(183575, '1.10.418.70-FF-000001', NULL, 'Intraflagellar transport protein 81 homolog', 128, NULL, NULL, 183575),
(183576, '2.60.40.10-FF-003967', NULL, NULL, 103, NULL, NULL, 183576),
(183577, '2.60.40.10-FF-002573', NULL, 'fibrocystin-L-like isoform X1', 96, NULL, NULL, 183577),
(183578, '1.10.287.1970-FF-000002', NULL, 'Alanine aminotransferase putative', 49, NULL, NULL, 183578),
(183579, '1.10.20.10-FF-000305', NULL, NULL, 52, NULL, NULL, 183579),
(183580, '3.40.1090.10-FF-000138', NULL, 'Predicted protein', 89, NULL, NULL, 183580),
(183581, '1.10.1450.10-FF-000074', NULL, 'GD10450', 85, NULL, NULL, 183581),
(183582, '1.10.10.10-FF-000215', NULL, 'Transcriptional regulator, LysR family', 88, NULL, NULL, 183582),
(183583, '3.40.50.720-FF-001457', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', 182, NULL, NULL, 183583),
(183584, '1.10.510.10-FF-003677', NULL, NULL, 352, NULL, NULL, 183584),
(183585, '1.10.10.2330-FF-000008', NULL, 'Phenylalanyl-tRNA synthetase alpha chain B, putative', 52, NULL, NULL, 183585),
(183586, '3.65.10.10-FF-000018', NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', 134, NULL, NULL, 183586),
(183587, '1.25.40.10-FF-003713', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 109, NULL, NULL, 183587),
(183588, '1.10.1410.10-FF-000066', NULL, 'U3 small nucleolar RNA-associated protein 22', 172, NULL, NULL, 183588),
(183589, '1.10.472.170-FF-000007', NULL, 'Transcription initiation factor IIB-2', 121, NULL, NULL, 183589),
(183590, '2.40.30.10-FF-000432', NULL, 'Translation elongation factor, putative', 94, NULL, NULL, 183590),
(183591, '3.90.70.10-FF-000519', NULL, 'Protein CBG00738', 197, NULL, NULL, 183591),
(183592, '1.25.40.990-FF-000006', NULL, 'Putative SAC3/GANP domain protein', 247, NULL, NULL, 183592),
(183593, '3.10.310.10-FF-000012', NULL, '4-hydroxyproline 2-epimerase', 153, NULL, NULL, 183593),
(183594, '1.10.30.10-FF-000071', NULL, 'High mobility group protein', 86, NULL, NULL, 183594);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(183595, '1.10.10.2320-FF-000005', NULL, NULL, 35, NULL, NULL, 183595),
(183596, '2.60.120.10-FF-000462', NULL, 'Uncharacterized protein', 89, NULL, NULL, 183596),
(183597, '2.40.50.140-FF-000989', NULL, NULL, 71, NULL, NULL, 183597),
(183598, '3.30.70.260-FF-000168', NULL, 'Probable septum site-determining protein MinC', 117, NULL, NULL, 183598),
(183599, '2.30.30.140-FF-000268', NULL, 'Chromatin modification-related protein EAF3', 143, NULL, NULL, 183599),
(183600, '1.10.10.2660-FF-000023', NULL, 'Uncharacterized protein', 242, NULL, NULL, 183600),
(183601, '1.10.10.60-FF-000270', NULL, 'Sigma-54-dependent Fis family transcriptional regulator', 46, NULL, NULL, 183601),
(183602, '1.10.565.10-FF-000184', NULL, 'Retinoid X receptor', 112, NULL, NULL, 183602),
(183603, '2.130.10.10-FF-000281', NULL, 'Plexin B2', 458, NULL, NULL, 183603),
(183604, '3.40.50.1000-FF-000315', NULL, 'TFIIF-stimulated CTD phosphatase, putative', 196, NULL, NULL, 183604),
(183605, '1.10.238.10-FF-000233', NULL, 'CDPK-related kinase 1', 173, NULL, NULL, 183605),
(183606, '3.90.1430.10-FF-000007', NULL, NULL, 122, NULL, NULL, 183606),
(183607, '1.20.1070.10-FF-001565', NULL, 'Putative gustatory receptor clone PTE03', 168, NULL, NULL, 183607),
(183608, '1.10.10.10-FF-001497', NULL, 'Transcriptional regulatory protein', 69, NULL, NULL, 183608),
(183609, '3.40.50.300-FF-005339', NULL, 'Probable DNA helicase II homolog', 217, NULL, NULL, 183609),
(183610, '2.10.25.10-FF-000022', NULL, 'Metalloendopeptidase', 39, NULL, NULL, 183610),
(183611, '3.40.50.300-FF-001596', NULL, 'Secretion protein, partial', 226, NULL, NULL, 183611),
(183612, '3.30.40.10-FF-001257', NULL, 'Uncharacterized RING finger protein P32A8.03c', 72, NULL, NULL, 183612),
(183613, '3.40.50.1820-FF-001308', NULL, 'Uncharacterized protein', 266, NULL, NULL, 183613),
(183614, '2.30.31.10-FF-000007', NULL, 'Transcriptional coactivator p15 (Pc4), putative', 64, NULL, NULL, 183614),
(183615, '2.130.10.10-FF-005159', NULL, 'ELongator complex Protein Component', 138, NULL, NULL, 183615),
(183616, '3.50.50.60-FF-001058', NULL, 'Uncharacterized protein', 153, NULL, NULL, 183616),
(183617, '1.10.510.10-FF-000804', NULL, 'Blast:Serine/threonine-protein kinase ULK3', 184, NULL, NULL, 183617),
(183618, '1.25.40.20-FF-001041', NULL, 'Protein ACCELERATED CELL DEATH 6', 93, NULL, NULL, 183618),
(183619, '3.40.250.10-FF-000118', NULL, 'Thiosulfate/3-mercaptopyruvate sulfurtransferase', 158, NULL, NULL, 183619),
(183620, '3.80.10.10-FF-001702', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 112, NULL, NULL, 183620),
(183621, '3.30.450.80-FF-000010', NULL, 'Transcriptional activator protein LuxR', 166, NULL, NULL, 183621),
(183622, '1.20.120.730-FF-000010', NULL, 'Sec23/sec24 transport family protein', 159, NULL, NULL, 183622),
(183623, '3.40.50.300-FF-003748', NULL, 'Dynein heavy chain 7', 194, NULL, NULL, 183623),
(183624, '2.30.110.10-FF-000086', NULL, 'Slr0001 protein', 158, NULL, NULL, 183624),
(183625, '2.60.120.200-FF-000757', NULL, 'Uncharacterized protein', 99, NULL, NULL, 183625),
(183626, '3.40.50.1820-FF-001550', NULL, 'Uncharacterized protein', 124, NULL, NULL, 183626),
(183627, '3.40.50.11180-FF-000001', NULL, 'Transcription-repair-coupling factor', 226, NULL, NULL, 183627),
(183628, '1.10.472.80-FF-000146', NULL, 'TBC1 domain family member 8', 147, NULL, NULL, 183628),
(183629, '3.40.630.10-FF-000254', NULL, 'Uncharacterized protein', 162, NULL, NULL, 183629),
(183630, '1.20.1070.10-FF-000806', NULL, 'Uncharacterized protein', 319, NULL, NULL, 183630),
(183631, '3.90.740.10-FF-000032', NULL, 'Isoleucine--tRNA ligase', 181, NULL, NULL, 183631),
(183632, '3.40.50.300-FF-000578', NULL, 'probable ATP-dependent RNA helicase DHX35', 221, NULL, NULL, 183632),
(183633, '3.30.70.330-FF-000155', NULL, 'serine/arginine-rich splicing factor 10 isoform X1', 104, NULL, NULL, 183633),
(183634, '3.40.50.300-FF-000314', NULL, 'Atlastin-2 isoform 2', 311, NULL, NULL, 183634),
(183635, '1.25.40.1030-FF-000038', NULL, 'Imidazole glycerol phosphate synthase hisHF chloroplastic', 198, NULL, NULL, 183635);
INSERT INTO "PUBLIC"."MODEL" VALUES
(183636, '1.25.40.10-FF-004995', NULL, 'Uncharacterized protein', 131, NULL, NULL, 183636),
(183637, '3.80.10.10-FF-001612', NULL, 'Putative kinase-like protein TMKL1', 162, NULL, NULL, 183637),
(183638, '3.40.120.10-FF-000114', NULL, 'Phosphoacetylglucosamine mutase, putative', 141, NULL, NULL, 183638),
(183639, '3.10.310.20-FF-000015', NULL, 'Manganese-dependent inorganic pyrophosphatase', 119, NULL, NULL, 183639),
(183640, '1.25.10.10-FF-000805', NULL, 'Similar to transcription factor CBF/MAK21', 285, NULL, NULL, 183640),
(183641, '1.20.5.340-FF-000107', NULL, 'Uncharacterized protein C27B12.07', 93, NULL, NULL, 183641),
(183642, '1.20.1250.20-FF-001425', NULL, 'Proton-dependent oligopeptide transport family protein', 250, NULL, NULL, 183642),
(183643, '3.90.180.10-FF-000096', NULL, 'Quinone oxidoreductase', 170, NULL, NULL, 183643),
(183644, '1.10.510.10-FF-000861', NULL, 'Serine/threonine-protein kinase RAD53', 219, NULL, NULL, 183644),
(183645, '3.30.160.60-FF-004731', NULL, NULL, 51, NULL, NULL, 183645),
(183646, '1.20.120.1900-FF-000008', NULL, 'Gamma-tubulin complex component', 310, NULL, NULL, 183646),
(183647, '3.40.50.300-FF-005957', NULL, 'Uncharacterized protein', 193, NULL, NULL, 183647),
(183648, '3.30.420.150-FF-000001', NULL, 'Guanosine-5''-triphosphate,3''-diphosphate pyrophosphatase', 180, NULL, NULL, 183648),
(183649, '3.30.70.980-FF-000030', NULL, 'Translational Activator of Cytochrome c Oxidase', 76, NULL, NULL, 183649),
(183650, '2.60.120.330-FF-000184', NULL, 'Uncharacterized protein', 192, NULL, NULL, 183650),
(183651, '3.60.20.10-FF-000198', NULL, NULL, 220, NULL, NULL, 183651),
(183652, '3.40.50.300-FF-002523', NULL, 'Midasin', 174, NULL, NULL, 183652),
(183653, '2.30.30.380-FF-000048', NULL, 'Vacuolar protein sorting protein (Vps36), putative', 44, NULL, NULL, 183653),
(183654, '2.30.42.10-FF-000589', NULL, NULL, 107, NULL, NULL, 183654),
(183655, '3.30.160.60-FF-005956', NULL, NULL, 24, NULL, NULL, 183655),
(183656, '3.30.70.100-FF-000171', NULL, NULL, 90, NULL, NULL, 183656),
(183657, '1.10.238.10-FF-000851', NULL, 'Uncharacterized protein', 112, NULL, NULL, 183657),
(183658, '1.10.8.60-FF-000583', NULL, 'Uncharacterized protein', 23, NULL, NULL, 183658),
(183659, '2.60.40.3000-FF-000001', NULL, 'Genome polyprotein', 76, NULL, NULL, 183659),
(183660, '3.30.559.30-FF-000129', NULL, 'N-(5-amino-5-carboxypentanoyl)-L-cysteinyl-D-valine synthase', 251, NULL, NULL, 183660),
(183661, '3.90.550.10-FF-000731', NULL, 'Uncharacterized protein', 252, NULL, NULL, 183661),
(183662, '3.20.20.210-FF-000027', NULL, 'Predicted protein', 90, NULL, NULL, 183662),
(183663, '1.10.510.10-FF-000535', NULL, 'Serine/threonine-protein kinase a', 320, NULL, NULL, 183663),
(183664, '3.30.230.70-FF-000081', NULL, 'Exosome non-catalytic core subunit', 335, NULL, NULL, 183664),
(183665, '1.20.140.150-FF-000121', NULL, 'PERP, TP53 apoptosis effector', 111, NULL, NULL, 183665),
(183666, '3.40.50.150-FF-000544', NULL, '23S rRNA (Adenine(2058)-N(6))-methyltransferase Erm(37)', 166, NULL, NULL, 183666),
(183667, '2.130.10.10-FF-001646', NULL, 'Protein HIRA', 90, NULL, NULL, 183667),
(183668, '3.30.40.10-FF-002010', NULL, 'RING/U-box superfamily protein', 50, NULL, NULL, 183668),
(183669, '3.30.200.20-FF-000143', NULL, 'Ephrin type-B receptor 6', 107, NULL, NULL, 183669),
(183670, '3.90.870.10-FF-000036', NULL, 'GTP cyclohydrolase II', 168, NULL, NULL, 183670),
(183671, '3.30.160.60-FF-004821', NULL, NULL, 55, NULL, NULL, 183671),
(183672, '3.40.50.150-FF-000488', NULL, 'histone-lysine N-methyltransferase, H3 lysine-79 specific isoform X6', 101, NULL, NULL, 183672),
(183673, '2.170.270.10-FF-000233', NULL, 'PR/SET domain 12', 80, NULL, NULL, 183673),
(183674, '2.170.190.11-FF-000003', NULL, 'Molybdopterin molybdenumtransferase', 92, NULL, NULL, 183674),
(183675, '3.30.70.330-FF-001526', NULL, 'Modulo, isoform C', 164, NULL, NULL, 183675),
(183676, '3.30.930.10-FF-000381', NULL, 'Glycine--tRNA ligase', 328, NULL, NULL, 183676),
(183677, '3.30.200.20-FF-001773', NULL, NULL, 96, NULL, NULL, 183677);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(183678, '3.40.50.150-FF-000016', NULL, 'Protein arginine N-methyltransferase 6', 147, NULL, NULL, 183678),
(183679, '3.90.226.10-FF-000135', NULL, 'Protease 4', 99, NULL, NULL, 183679),
(183680, '3.40.50.1000-FF-000169', NULL, 'Haloacid dehalogenase-like hydrolase family protein', 139, NULL, NULL, 183680),
(183681, '1.20.58.60-FF-000311', NULL, 'Protein CBG15811', 214, NULL, NULL, 183681),
(183682, '3.40.800.10-FF-000054', NULL, NULL, 311, NULL, NULL, 183682),
(183683, '1.20.120.1080-FF-000077', NULL, 'ATP-dependent RNA helicase DEAH12 chloroplastic', 156, NULL, NULL, 183683),
(183684, '3.40.1000.10-FF-000009', NULL, 'Secreted proline rich protein 28 kDa antigen', 142, NULL, NULL, 183684),
(183685, '2.60.40.60-FF-000441', NULL, 'Dachsous, isoform B', 114, NULL, NULL, 183685),
(183686, '1.25.10.10-FF-002492', NULL, 'Predicted protein', 207, NULL, NULL, 183686),
(183687, '4.10.280.110-FF-000016', NULL, 'Splicing factor Prp18 family protein', 79, NULL, NULL, 183687),
(183688, '4.10.400.10-FF-000358', NULL, 'SOL-2 protein', 57, NULL, NULL, 183688),
(183689, '2.40.100.10-FF-000027', NULL, 'Allophanate hydrolase subunit 2', 141, NULL, NULL, 183689),
(183690, '3.40.800.20-FF-000057', NULL, 'HDAC4', 144, NULL, NULL, 183690),
(183691, '3.40.30.10-FF-000716', NULL, 'Uncharacterized protein', 106, NULL, NULL, 183691),
(183692, '1.10.10.520-FF-000010', NULL, 'SUMO-activating enzyme subunit', 203, NULL, NULL, 183692),
(183693, '3.90.1580.10-FF-000018', NULL, 'Predicted protein', 268, NULL, NULL, 183693),
(183694, '3.30.750.24-FF-000121', NULL, 'Uncharacterized protein', 140, NULL, NULL, 183694),
(183695, '1.20.58.390-FF-000307', NULL, 'Uncharacterized protein', 34, NULL, NULL, 183695),
(183696, '1.10.510.10-FF-001996', NULL, 'Kinase-like domain-containing protein', 202, NULL, NULL, 183696),
(183697, '3.80.20.20-FF-000071', NULL, 'Predicted protein', 145, NULL, NULL, 183697),
(183698, '3.40.50.140-FF-000013', NULL, 'DNA topoisomerase', 78, NULL, NULL, 183698),
(183699, '3.10.20.90-FF-000229', NULL, 'Ubiquitin carboxyl-terminal hydrolase 11', 92, NULL, NULL, 183699),
(183700, '2.60.40.10-FF-001668', NULL, 'C3 and PZP like, alpha-2-macroglobulin domain containing 8', 95, NULL, NULL, 183700),
(183701, '1.50.40.10-FF-000187', NULL, 'Protein CBG03436', 290, NULL, NULL, 183701),
(183702, '2.30.180.10-FF-000181', NULL, NULL, 174, NULL, NULL, 183702),
(183703, '3.30.70.1170-FF-000003', NULL, '16S rRNA (Cytosine(967)-C(5))-methyltransferase RsmB', 103, NULL, NULL, 183703),
(183704, '2.30.29.30-FF-000957', NULL, 'Uncharacterized protein', 112, NULL, NULL, 183704),
(183705, '1.20.810.10-FF-000033', NULL, 'Uncharacterized protein', 51, NULL, NULL, 183705),
(183706, '2.40.30.10-FF-000078', NULL, 'Dual oxidase 2', 90, NULL, NULL, 183706),
(183707, '3.10.450.50-FF-000101', NULL, 'Uncharacterized protein', 54, NULL, NULL, 183707),
(183708, '3.30.559.70-FF-000001', NULL, 'Carnitine O-palmitoyltransferase 1, liver isoform', 316, NULL, NULL, 183708),
(183709, '3.30.379.10-FF-000025', NULL, NULL, 139, NULL, NULL, 183709),
(183710, '1.10.1420.10-FF-000128', NULL, 'MutS domain III family protein', 133, NULL, NULL, 183710),
(183711, '1.25.10.10-FF-000249', NULL, 'HEAT repeat-containing protein 5A isoform X2', 735, NULL, NULL, 183711),
(183712, '3.30.160.60-FF-004175', NULL, NULL, 66, NULL, NULL, 183712),
(183713, '3.40.50.300-FF-000522', NULL, 'Gluconokinase', 168, NULL, NULL, 183713),
(183714, '1.10.472.10-FF-000114', NULL, 'Cyclin-D5-1', 109, NULL, NULL, 183714),
(183715, '3.30.56.30-FF-000001', NULL, 'signal recognition particle 19 kDa protein', 124, NULL, NULL, 183715),
(183716, '1.20.1500.20-FF-000006', NULL, NULL, 74, NULL, NULL, 183716),
(183717, '2.60.40.420-FF-000078', NULL, 'Laccase-1', 192, NULL, NULL, 183717),
(183718, '3.40.50.300-FF-004114', NULL, 'DNA helicase', 171, NULL, NULL, 183718),
(183719, '1.10.287.160-FF-000009', NULL, 'Cytosolic regulator Pianissimo, putative', 72, NULL, NULL, 183719),
(183720, '2.70.98.30-FF-000025', NULL, 'Lysosomal alpha-mannosidase', 258, NULL, NULL, 183720),
(183721, '3.40.50.1010-FF-000026', NULL, '20S-pre-rRNA D-site endonuclease NOB1', 129, NULL, NULL, 183721);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(183722, '1.25.40.10-FF-005276', NULL, 'Uncharacterized protein', 149, NULL, NULL, 183722),
(183723, '1.10.10.10-FF-000625', NULL, 'Rrf2 family transcriptional regulator', 135, NULL, NULL, 183723),
(183724, '2.60.40.10-FF-001466', NULL, 'SPEG neighbor', 95, NULL, NULL, 183724),
(183725, '2.40.180.10-FF-000043', NULL, 'Catalase', 186, NULL, NULL, 183725),
(183726, '3.40.47.10-FF-000226', NULL, NULL, 109, NULL, NULL, 183726),
(183727, '3.40.50.1000-FF-000495', NULL, NULL, 169, NULL, NULL, 183727),
(183728, '1.25.10.10-FF-000305', NULL, 'Adenomatous polyposis coli', 396, NULL, NULL, 183728),
(183729, '3.30.420.10-FF-000297', NULL, 'Argonaut-like protein', 260, NULL, NULL, 183729),
(183730, '2.30.29.30-FF-001323', NULL, 'SH2B adapter protein 2', 65, NULL, NULL, 183730),
(183731, '2.10.25.10-FF-001242', NULL, 'Uncharacterized protein', 38, NULL, NULL, 183731),
(183732, '3.40.50.1100-FF-000227', NULL, 'Predicted protein', 82, NULL, NULL, 183732),
(183733, '3.40.50.1000-FF-000023', NULL, 'Phospholipid-transporting ATPase', 209, NULL, NULL, 183733),
(183734, '3.40.50.720-FF-000558', NULL, 'Pyrroline-5-carboxylate reductase', 153, NULL, NULL, 183734),
(183735, '2.60.40.1120-FF-000055', NULL, 'nodal modulator 1', 74, NULL, NULL, 183735),
(183736, '3.30.40.10-FF-001611', NULL, 'Transcription factor BYE1', 86, NULL, NULL, 183736),
(183737, '2.10.70.10-FF-000149', NULL, 'Uncharacterized protein, isoform A', 60, NULL, NULL, 183737),
(183738, '1.10.510.10-FF-004430', NULL, NULL, 58, NULL, NULL, 183738),
(183739, '2.70.150.10-FF-000175', NULL, 'Na+ or K+ P-type ATPase', 13, NULL, NULL, 183739),
(183740, '3.30.10.10-FF-000002', NULL, 'Elastase inhibitor AFUEI', 68, NULL, NULL, 183740),
(183741, '2.70.170.10-FF-000182', NULL, 'Uncharacterized protein', 201, NULL, NULL, 183741),
(183742, '1.10.510.10-FF-002250', NULL, NULL, 123, NULL, NULL, 183742),
(183743, '3.30.710.10-FF-000105', NULL, 'inhibitor of Bruton tyrosine kinase isoform X1', 156, NULL, NULL, 183743),
(183744, '1.25.10.10-FF-001879', NULL, 'TORTIFOLIA1-like protein 4', 74, NULL, NULL, 183744),
(183745, '3.30.565.10-FF-000503', NULL, 'Uncharacterized protein', 120, NULL, NULL, 183745),
(183746, '3.40.50.1000-FF-000225', NULL, 'Phospholipid-transporting ATPase', 188, NULL, NULL, 183746),
(183747, '1.20.5.110-FF-000331', NULL, 'Uncharacterized protein', 80, NULL, NULL, 183747),
(183748, '2.130.10.10-FF-005485', NULL, 'Uncharacterized protein', 132, NULL, NULL, 183748),
(183749, '3.40.50.300-FF-002169', NULL, 'Nucleolar preribosomal GTPase, putative', 187, NULL, NULL, 183749),
(183750, '3.40.50.2300-FF-001470', NULL, NULL, 213, NULL, NULL, 183750),
(183751, '1.10.540.10-FF-000037', NULL, 'Acyl-CoA dehydrogenase', 125, NULL, NULL, 183751),
(183752, '2.130.10.130-FF-000035', NULL, NULL, 229, NULL, NULL, 183752),
(183753, '2.120.10.80-FF-000127', NULL, 'Cellular morphogenesis protein (Rax2), putative', 266, NULL, NULL, 183753),
(183754, '3.40.50.10900-FF-000024', NULL, 'Uncharacterized protein', 93, NULL, NULL, 183754),
(183755, '2.40.50.100-FF-000180', NULL, 'Ddl-3', 62, NULL, NULL, 183755),
(183756, '3.40.30.10-FF-001115', NULL, 'Uncharacterized protein', 16, NULL, NULL, 183756),
(183757, '3.10.100.10-FF-000322', NULL, NULL, 142, NULL, NULL, 183757),
(183758, '4.10.400.10-FF-000094', NULL, 'Transmembrane serine protease 3', 34, NULL, NULL, 183758),
(183759, '3.40.50.300-FF-004737', NULL, 'Predicted protein', 137, NULL, NULL, 183759),
(183760, '1.20.1070.10-FF-001621', NULL, 'Frizzled-6', 143, NULL, NULL, 183760),
(183761, '3.80.10.10-FF-004159', NULL, 'Uncharacterized protein', 103, NULL, NULL, 183761),
(183762, '3.10.20.340-FF-000001', NULL, 'Arginine biosynthesis bifunctional protein ArgJ, chloroplastic', 128, NULL, NULL, 183762),
(183763, '3.40.50.1010-FF-000228', NULL, NULL, 85, NULL, NULL, 183763),
(183764, '1.20.144.10-FF-000114', NULL, 'Uncharacterized protein', 210, NULL, NULL, 183764),
(183765, '2.70.98.20-FF-000022', NULL, 'Amine oxidase', 141, NULL, NULL, 183765),
(183766, '2.40.10.120-FF-000020', NULL, 'Complement factor B', 203, NULL, NULL, 183766);
INSERT INTO "PUBLIC"."MODEL" VALUES
(183767, '3.30.420.40-FF-000042', NULL, 'Acetate kinase', 202, NULL, NULL, 183767),
(183768, '2.30.30.40-FF-000441', NULL, 'Caspase recruitment domain family member 10', 114, NULL, NULL, 183768),
(183769, '1.25.40.10-FF-003359', NULL, 'Pentatricopeptide repeat-containing protein At3g04760, chloroplastic', 71, NULL, NULL, 183769),
(183770, '3.20.20.190-FF-000066', NULL, 'Phosphoinositide phospholipase C', 199, NULL, NULL, 183770),
(183771, '1.10.510.10-FF-000333', NULL, 'Non-specific serine/threonine protein kinase', 351, NULL, NULL, 183771),
(183772, '2.40.30.10-FF-000229', NULL, 'Putative translation initiation factor EIF-2B gamma subunit', 142, NULL, NULL, 183772),
(183773, '3.40.50.720-FF-001873', NULL, 'Pyrroline-5-carboxylate reductase, flame shift', 128, NULL, NULL, 183773),
(183774, '3.30.160.60-FF-000752', NULL, 'Zinc finger protein 384 like', 29, NULL, NULL, 183774),
(183775, '6.20.10.30-FF-000001', NULL, 'DNA ligase', 39, NULL, NULL, 183775),
(183776, '2.130.10.120-FF-000032', NULL, 'Predicted protein', 54, NULL, NULL, 183776),
(183777, '3.40.50.10810-FF-000093', NULL, 'DNA repair protein rhp16, putative', 206, NULL, NULL, 183777),
(183778, '3.80.10.10-FF-003057', NULL, 'Uncharacterized protein', 149, NULL, NULL, 183778),
(183779, '1.10.10.10-FF-002014', NULL, 'Interferon regulatory factor', 110, NULL, NULL, 183779),
(183780, '1.25.40.20-FF-000136', NULL, 'ankyrin repeat and sterile alpha motif domain-containing protein 1B isoform X1', 187, NULL, NULL, 183780),
(183781, '1.20.120.80-FF-000001', NULL, 'Cytochrome (Ubi)quinol oxidase subunit III', 185, NULL, NULL, 183781),
(183782, '1.10.132.10-FF-000010', NULL, 'DNA topoisomerase I', 115, NULL, NULL, 183782),
(183783, '1.20.1270.60-FF-000286', NULL, 'Uncharacterized protein', 192, NULL, NULL, 183783),
(183784, '2.170.300.10-FF-000079', NULL, 'Uncharacterized protein', 144, NULL, NULL, 183784),
(183785, '3.90.550.10-FF-000405', NULL, 'Glycosyltransferase, group 2 family', 205, NULL, NULL, 183785),
(183786, '3.30.300.10-FF-000024', NULL, 'Arl-6', 69, NULL, NULL, 183786),
(183787, '3.30.365.10-FF-000078', NULL, 'Caffeine dehydrogenase subunit alpha', 133, NULL, NULL, 183787),
(183788, '2.80.10.50-FF-000098', NULL, 'Calcium up-regulated protein A', 102, NULL, NULL, 183788),
(183789, '3.40.50.10190-FF-000362', NULL, 'Predicted protein', 52, NULL, NULL, 183789),
(183790, '2.30.29.30-FF-001267', NULL, 'Uncharacterized protein', 101, NULL, NULL, 183790),
(183791, '3.40.50.300-FF-006031', NULL, 'Helicase, putative', 195, NULL, NULL, 183791),
(183792, '1.20.120.1760-FF-000039', NULL, 'Ethanolamine phosphotransferase (EPT)', 197, NULL, NULL, 183792),
(183793, '3.40.1380.20-FF-000068', NULL, 'Pyruvate kinase', 69, NULL, NULL, 183793),
(183794, '1.20.120.1750-FF-000036', NULL, 'RBR-type E3 ubiquitin transferase', 77, NULL, NULL, 183794),
(183795, '2.60.40.150-FF-000154', NULL, 'tandem C2 domains nuclear protein', 144, NULL, NULL, 183795),
(183796, '1.10.510.10-FF-004374', NULL, NULL, 101, NULL, NULL, 183796),
(183797, '3.60.21.60-FF-000041', NULL, 'Predicted protein', 116, NULL, NULL, 183797),
(183798, '2.60.200.20-FF-000230', NULL, 'Formin-J', 79, NULL, NULL, 183798),
(183799, '3.40.50.150-FF-000218', NULL, 'Sun-family protein, putative', 189, NULL, NULL, 183799),
(183800, '2.40.160.210-FF-000008', NULL, 'Acyl-CoA thioesterase II', 278, NULL, NULL, 183800),
(183801, '3.10.20.90-FF-000706', NULL, 'Uncharacterized protein', 167, NULL, NULL, 183801),
(183802, '1.10.1370.10-FF-000011', NULL, 'Oligoendopeptidase F', 194, NULL, NULL, 183802),
(183803, '3.40.50.1820-FF-000735', NULL, 'Carboxylic ester hydrolase', 230, NULL, NULL, 183803),
(183804, '4.10.400.10-FF-000212', NULL, 'Low-density lipoprotein receptor, putative', 45, NULL, NULL, 183804),
(183805, '1.10.1450.10-FF-000012', NULL, 'Tetraspanin', 107, NULL, NULL, 183805),
(183806, '3.40.950.10-FF-000003', NULL, 'Cytosolic Fe-S cluster assembly factor nar1', 168, NULL, NULL, 183806),
(183807, '3.40.605.10-FF-000095', NULL, 'Aldehyde dehydrogenase, putative', 50, NULL, NULL, 183807),
(183808, '1.10.510.10-FF-000209', NULL, 'Serine/threonine-protein kinase pim-1', 185, NULL, NULL, 183808);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(183809, '2.40.128.20-FF-000066', NULL, 'Uncharacterized protein', 68, NULL, NULL, 183809),
(183810, '3.40.50.11530-FF-000005', NULL, 'interleukin-17 receptor E isoform X11', 84, NULL, NULL, 183810),
(183811, '3.30.460.10-FF-000097', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 241, NULL, NULL, 183811),
(183812, '3.40.532.10-FF-000026', NULL, NULL, 227, NULL, NULL, 183812),
(183813, '1.10.1200.10-FF-000117', NULL, 'Polyketide synthase RzxE', 89, NULL, NULL, 183813),
(183814, '1.20.1070.10-FF-001149', NULL, 'Cephalotocin receptor 2', 373, NULL, NULL, 183814),
(183815, '2.60.40.10-FF-001792', NULL, 'Fasciclin 3, isoform C', 96, NULL, NULL, 183815),
(183816, '2.60.40.10-FF-004102', NULL, NULL, 93, NULL, NULL, 183816),
(183817, '1.10.10.10-FF-001553', NULL, 'Cullin', 76, NULL, NULL, 183817),
(183818, '1.10.1370.30-FF-000017', NULL, 'Angiotensin-converting enzyme', 318, NULL, NULL, 183818),
(183819, '3.40.720.10-FF-000290', NULL, 'Uncharacterized protein', 270, NULL, NULL, 183819),
(183820, '1.10.472.10-FF-000316', NULL, 'G2/mitotic-specific cyclin-B3', 113, NULL, NULL, 183820),
(183821, '3.30.70.1180-FF-000006', NULL, 'V-type proton ATPase subunit C', 32, NULL, NULL, 183821),
(183822, '1.10.287.230-FF-000002', NULL, 'Regulatory protein rop, putative', 63, NULL, NULL, 183822),
(183823, '3.30.830.10-FF-000108', NULL, 'Uncharacterized protein', 244, NULL, NULL, 183823),
(183824, '1.25.10.10-FF-001177', NULL, 'Importin subunit, putative', 967, NULL, NULL, 183824),
(183825, '3.40.50.1820-FF-001224', NULL, 'Uncharacterized protein', 354, NULL, NULL, 183825),
(183826, '1.10.287.140-FF-000003', NULL, 'Glutamate dehydrogenase', 58, NULL, NULL, 183826),
(183827, '1.25.40.10-FF-000072', NULL, 'Crooked neck-like protein 1', 200, NULL, NULL, 183827),
(183828, '3.30.2160.10-FF-000034', NULL, 'Ubiquitin protein ligase, putative', 78, NULL, NULL, 183828),
(183829, '1.10.132.60-FF-000031', NULL, 'DNA polymerase', 114, NULL, NULL, 183829),
(183830, '3.50.50.60-FF-001474', NULL, 'FAD-dependent oxidoreductase family protein', 61, NULL, NULL, 183830),
(183831, '1.20.1070.10-FF-001239', NULL, 'Frizzled 9/10', 348, NULL, NULL, 183831),
(183832, '3.30.1360.120-FF-000010', NULL, 'Aminomethyltransferase', 144, NULL, NULL, 183832),
(183833, '1.20.5.190-FF-000135', NULL, NULL, 51, NULL, NULL, 183833),
(183834, '3.10.290.10-FF-000015', NULL, 'Pseudouridine synthase', 58, NULL, NULL, 183834),
(183835, '3.40.50.1700-FF-000019', NULL, 'Glycosyl hydrolase', 246, NULL, NULL, 183835),
(183836, '3.30.160.60-FF-005479', NULL, NULL, 28, NULL, NULL, 183836),
(183837, '1.10.510.10-FF-001794', NULL, 'Uncharacterized protein', 353, NULL, NULL, 183837),
(183838, '1.10.510.10-FF-004104', NULL, NULL, 127, NULL, NULL, 183838),
(183839, '1.10.10.750-FF-000017', NULL, 'GTPase-activating protein', 44, NULL, NULL, 183839),
(183840, '1.10.132.30-FF-000016', NULL, 'DNA-directed RNA polymerase subunit', 87, NULL, NULL, 183840),
(183841, '3.90.1290.10-FF-000064', NULL, 'Uncharacterized protein', 192, NULL, NULL, 183841),
(183842, '1.10.132.20-FF-000013', NULL, 'Ribosome-recycling factor, mitochondrial', 100, NULL, NULL, 183842),
(183843, '1.25.10.10-FF-000631', NULL, 'Vac14, PIKFYVE complex component', 192, NULL, NULL, 183843),
(183844, '2.60.40.10-FF-003883', NULL, NULL, 36, NULL, NULL, 183844),
(183845, '1.25.40.10-FF-000133', NULL, 'Signal recognition particle subunit SRP72', 70, NULL, NULL, 183845),
(183846, '2.60.40.790-FF-000025', NULL, 'heat shock protein beta-2', 95, NULL, NULL, 183846),
(183847, '1.10.1670.40-FF-000009', NULL, 'Base excision DNA repair protein, HhH-GPD family', 74, NULL, NULL, 183847),
(183848, '4.10.60.10-FF-000043', NULL, 'Air1p', 78, NULL, NULL, 183848),
(183849, '1.25.10.10-FF-002722', NULL, 'Uncharacterized protein', 937, NULL, NULL, 183849),
(183850, '2.40.170.20-FF-000130', NULL, 'Transporter, outer membrane receptor (OMR) family', 466, NULL, NULL, 183850),
(183851, '3.90.70.10-FF-000435', NULL, 'ubiquitin carboxyl-terminal hydrolase CYLD', 377, NULL, NULL, 183851),
(183852, '2.170.140.10-FF-000021', NULL, 'Chitin deacetylase-like 4', 65, NULL, NULL, 183852);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(183853, '3.40.50.300-FF-007756', NULL, 'Uncharacterized protein', 73, NULL, NULL, 183853),
(183854, '3.40.50.10190-FF-000036', NULL, 'PAX interacting protein 1', 116, NULL, NULL, 183854),
(183855, '3.40.440.10-FF-000009', NULL, NULL, 101, NULL, NULL, 183855),
(183856, '3.30.160.60-FF-000662', NULL, 'RE1-silencing transcription factor A', 32, NULL, NULL, 183856),
(183857, '3.40.190.10-FF-000208', NULL, 'HTH-type transcriptional regulator XapR', 88, NULL, NULL, 183857),
(183858, '1.10.287.440-FF-000003', NULL, 'Bifunctional purine biosynthesis protein PurH', 43, NULL, NULL, 183858),
(183859, '1.10.510.10-FF-000361', NULL, 'Leucine-rich repeat serine/threonine-protein kinase 1', 294, NULL, NULL, 183859),
(183860, '3.40.50.150-FF-001000', NULL, NULL, 208, NULL, NULL, 183860),
(183861, '3.30.200.20-FF-000789', NULL, 'Serine/threonine protein kinase', 162, NULL, NULL, 183861),
(183862, '1.25.40.10-FF-000751', NULL, 'Coatomer subunit epsilon, putative', 277, NULL, NULL, 183862),
(183863, '2.70.170.10-FF-000210', NULL, 'Uncharacterized protein', 159, NULL, NULL, 183863),
(183864, '3.30.230.10-FF-000288', NULL, 'Rad51/RecA-like protein', 146, NULL, NULL, 183864),
(183865, '1.20.120.430-FF-000010', NULL, 'tRNA modification GTPase GTPBP3, mitochondrial isoform X1', 64, NULL, NULL, 183865),
(183866, '2.130.10.10-FF-005805', NULL, 'Predicted protein', 88, NULL, NULL, 183866),
(183867, '1.20.5.190-FF-000130', NULL, NULL, 50, NULL, NULL, 183867),
(183868, '3.90.70.10-FF-000019', NULL, 'Ubiquitinyl hydrolase 1', 363, NULL, NULL, 183868),
(183869, '1.10.238.10-FF-000379', NULL, 'Lysophosphatidylcholine acyltransferase 1', 148, NULL, NULL, 183869),
(183870, '1.10.150.50-FF-000098', NULL, 'Liprin-beta', 74, NULL, NULL, 183870),
(183871, '3.50.50.60-FF-000687', NULL, '2,6-dihydroxypyridine 3-monooxygenase', 127, NULL, NULL, 183871),
(183872, '1.25.40.20-FF-000754', NULL, 'Uncharacterized protein', 104, NULL, NULL, 183872),
(183873, '2.130.10.10-FF-000960', NULL, 'LEC14B protein-like isoform X1', 108, NULL, NULL, 183873),
(183874, '1.20.1090.10-FF-000021', NULL, 'Alcohol dehydrogenase, iron-dependent', 172, NULL, NULL, 183874),
(183875, '3.90.290.10-FF-000014', NULL, 'Fibrillin 2', 68, NULL, NULL, 183875),
(183876, '3.30.160.60-FF-000426', NULL, 'Zinc finger and BTB domain-containing protein 20', 31, NULL, NULL, 183876),
(183877, '3.30.40.10-FF-001318', NULL, 'Zinc finger domain containing protein', 64, NULL, NULL, 183877),
(183878, '2.60.40.10-FF-002781', NULL, 'Short-form leptin receptor 2', 97, NULL, NULL, 183878),
(183879, '2.30.30.40-FF-000413', NULL, 'Tyrosine-protein kinase', 56, NULL, NULL, 183879),
(183880, '1.10.8.140-FF-000016', NULL, 'DsDNA-binding protein PDCD5, putative', 81, NULL, NULL, 183880),
(183881, '3.90.230.10-FF-000038', NULL, 'Expressed protein', 246, NULL, NULL, 183881),
(183882, '2.130.10.10-FF-006025', NULL, 'Centriole proteome protein 16', 157, NULL, NULL, 183882),
(183883, '3.40.20.10-FF-000159', NULL, 'G-actin binding protein, putative', 143, NULL, NULL, 183883),
(183884, '4.10.400.10-FF-000184', NULL, 'Ecdysone-inducible gene E1', 42, NULL, NULL, 183884),
(183885, '1.20.120.350-FF-000137', NULL, 'Calcium channel protein, putative', 131, NULL, NULL, 183885),
(183886, '1.20.120.140-FF-000018', NULL, 'Putative signal peptide binding domain protein', 108, NULL, NULL, 183886),
(183887, '2.10.70.10-FF-000239', NULL, 'Peptidase domain-containing-associated with muscle regeneration 1', 75, NULL, NULL, 183887),
(183888, '1.10.287.110-FF-000404', NULL, 'Uncharacterized protein', 111, NULL, NULL, 183888),
(183889, '1.25.10.10-FF-003178', NULL, 'Probable inactive serine/threonine-protein kinase DDB_G0278909', 321, NULL, NULL, 183889),
(183890, '3.90.550.10-FF-000315', NULL, 'Hexosyltransferase', 284, NULL, NULL, 183890),
(183891, '1.10.510.10-FF-003885', NULL, NULL, 89, NULL, NULL, 183891),
(183892, '3.30.160.60-FF-006261', NULL, NULL, 61, NULL, NULL, 183892),
(183893, '3.40.50.1980-FF-000114', NULL, 'Periplasmic divalent manganese/zinc-binding lipoprotein', 180, NULL, NULL, 183893),
(183894, '3.40.50.2300-FF-000014', NULL, 'PTS system fructose-like transporter subunit IIB', 107, NULL, NULL, 183894);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(183895, '1.25.40.990-FF-000040', NULL, 'COP9 signalosome complex subunit 8', 166, NULL, NULL, 183895),
(183896, '1.20.1110.10-FF-000046', NULL, 'Sodium/potassium-transporting ATPase subunit alpha', 273, NULL, NULL, 183896),
(183897, '1.10.510.10-FF-002160', NULL, 'Kinase, NEK', 230, NULL, NULL, 183897),
(183898, '1.10.630.10-FF-000336', NULL, 'Uncharacterized protein', 364, NULL, NULL, 183898),
(183899, '1.10.8.10-FF-000259', NULL, 'Elongation factor Ts, mitochondrial', 59, NULL, NULL, 183899),
(183900, '2.60.40.10-FF-004574', NULL, NULL, 96, NULL, NULL, 183900),
(183901, '2.20.25.10-FF-000117', NULL, 'DNA-directed RNA polymerase subunit', 51, NULL, NULL, 183901),
(183902, '2.40.320.10-FF-000015', NULL, 'Predicted protein', 210, NULL, NULL, 183902),
(183903, '2.30.29.30-FF-001295', NULL, 'Uncharacterized protein', 88, NULL, NULL, 183903),
(183904, '2.80.10.50-FF-000126', NULL, 'Fibroblast growth factor 23', 157, NULL, NULL, 183904),
(183905, '3.90.260.10-FF-000068', NULL, 'AGAP003342-PA', 166, NULL, NULL, 183905),
(183906, '3.40.50.300-FF-004086', NULL, 'endoribonuclease Dicer homolog 1', 23, NULL, NULL, 183906),
(183907, '3.30.450.150-FF-000013', NULL, 'Uncharacterized protein', 93, NULL, NULL, 183907),
(183908, '1.20.58.390-FF-000077', NULL, 'Ligand-gated ion channel 50', 141, NULL, NULL, 183908),
(183909, '3.40.50.720-FF-001542', NULL, 'Uncharacterized protein', 262, NULL, NULL, 183909),
(183910, '1.10.418.20-FF-000008', NULL, 'Ubiquitin-like-specific protease 1', 80, NULL, NULL, 183910),
(183911, '3.40.800.20-FF-000001', NULL, 'Histone deacetylase', 378, NULL, NULL, 183911),
(183912, '3.40.640.10-FF-000316', NULL, 'Adenosylmethionine-8-amino-7-oxononanoate aminotransferase family protein', 259, NULL, NULL, 183912),
(183913, '3.30.160.60-FF-004349', NULL, NULL, 93, NULL, NULL, 183913),
(183914, '1.50.10.10-FF-000096', NULL, 'Mannosyl_oligosaccharide_glucosidase_-_putative', 490, NULL, NULL, 183914),
(183915, '1.20.58.390-FF-000279', NULL, 'Predicted protein', 60, NULL, NULL, 183915),
(183916, '3.40.50.300-FF-005991', NULL, 'DnaA regulatory inactivator Hda', 171, NULL, NULL, 183916),
(183917, '4.10.800.10-FF-000023', NULL, 'Iclp2 protein', 63, NULL, NULL, 183917),
(183918, '3.10.180.10-FF-000012', NULL, '2,3-dihydroxybiphenyl 1,2-dioxygenase', 167, NULL, NULL, 183918),
(183919, '3.40.50.1100-FF-000053', NULL, '1-aminocyclopropane-1-carboxylate deaminase', 198, NULL, NULL, 183919),
(183920, '2.60.40.10-FF-004046', NULL, NULL, 97, NULL, NULL, 183920),
(183921, '2.60.120.40-FF-000033', NULL, 'BclA protein', 135, NULL, NULL, 183921),
(183922, '3.90.640.10-FF-000199', NULL, 'Actin, putative', 29, NULL, NULL, 183922),
(183923, '1.20.58.480-FF-000008', NULL, 'Putative 15-hydroxyprostaglandin dehydrogenase (Nad(+)) protein', 221, NULL, NULL, 183923),
(183924, '1.25.40.10-FF-002550', NULL, 'Os01g0600400 protein', 220, NULL, NULL, 183924),
(183925, '2.40.10.10-FF-000341', NULL, NULL, 243, NULL, NULL, 183925),
(183926, '3.80.10.10-FF-002686', NULL, 'Receptor protein-tyrosine kinase CEPR2 isoform A', 92, NULL, NULL, 183926),
(183927, '3.30.1360.120-FF-000066', NULL, 'sarcosine dehydrogenase, mitochondrial-like isoform X1', 210, NULL, NULL, 183927),
(183928, '3.40.50.12160-FF-000037', NULL, 'Uncharacterized protein', 71, NULL, NULL, 183928),
(183929, '1.20.120.1910-FF-000045', NULL, 'Putative cysteine--tRNA ligase, mitochondrial-like Protein', 174, NULL, NULL, 183929),
(183930, '2.130.10.10-FF-005659', NULL, 'WD repeat protein, putative', 166, NULL, NULL, 183930),
(183931, '1.20.1560.10-FF-000653', NULL, 'Uncharacterized protein', 354, NULL, NULL, 183931),
(183932, '3.80.10.10-FF-001056', NULL, 'Leucine-rich repeat containing protein', 114, NULL, NULL, 183932),
(183933, '3.30.2300.10-FF-000006', NULL, 'Uncharacterized protein', 113, NULL, NULL, 183933),
(183934, '3.30.70.1230-FF-000128', NULL, 'Adenylate/guanylate cyclase domain-containing protein', 193, NULL, NULL, 183934),
(183935, '2.60.120.10-FF-000344', NULL, 'Germin-like protein', 122, NULL, NULL, 183935),
(183936, '3.40.50.300-FF-005749', NULL, 'Uncharacterized protein', 138, NULL, NULL, 183936);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(183937, '3.40.140.10-FF-000172', NULL, 'Uncharacterized protein', 50, NULL, NULL, 183937),
(183938, '2.30.29.30-FF-000311', NULL, 'GTP binding protein (Bud4)', 136, NULL, NULL, 183938),
(183939, '2.70.130.10-FF-000090', NULL, NULL, 141, NULL, NULL, 183939),
(183940, '3.20.10.10-FF-000053', NULL, 'Uncharacterized protein', 142, NULL, NULL, 183940),
(183941, '1.20.120.1900-FF-000042', NULL, 'Gamma-tubulin complex component', 313, NULL, NULL, 183941),
(183942, '3.30.160.60-FF-006120', NULL, NULL, 37, NULL, NULL, 183942),
(183943, '3.10.450.10-FF-000022', NULL, 'Fetuin B', 103, NULL, NULL, 183943),
(183944, '4.10.240.10-FF-000177', NULL, 'Zcf28p', 58, NULL, NULL, 183944),
(183945, '2.40.50.140-FF-001068', NULL, NULL, 92, NULL, NULL, 183945),
(183946, '3.30.70.100-FF-000137', NULL, NULL, 87, NULL, NULL, 183946),
(183947, '3.40.720.10-FF-000317', NULL, 'Uncharacterized protein', 190, NULL, NULL, 183947),
(183948, '3.30.40.10-FF-001465', NULL, 'Uncharacterized protein', 80, NULL, NULL, 183948),
(183949, '1.10.418.10-FF-000005', NULL, 'Actinin alpha 4', 116, NULL, NULL, 183949),
(183950, '3.40.50.2300-FF-001644', NULL, NULL, 246, NULL, NULL, 183950),
(183951, '4.10.400.10-FF-000268', NULL, 'Apical endosomal glycoprotein', 39, NULL, NULL, 183951),
(183952, '3.40.50.300-FF-007666', NULL, 'Uncharacterized protein', 122, NULL, NULL, 183952),
(183953, '3.40.50.1110-FF-000056', NULL, 'Predicted protein', 209, NULL, NULL, 183953),
(183954, '3.10.105.10-FF-000018', NULL, 'RGD-containing lipoprotein', 141, NULL, NULL, 183954),
(183955, '2.30.30.1020-FF-000032', NULL, NULL, 134, NULL, NULL, 183955),
(183956, '3.40.50.300-FF-008155', NULL, 'Uncharacterized protein', 92, NULL, NULL, 183956),
(183957, '3.90.1150.10-FF-000115', NULL, 'Putative serine C-palmitoyltransferase', 118, NULL, NULL, 183957),
(183958, '3.30.70.890-FF-000036', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 102, NULL, NULL, 183958),
(183959, '3.40.50.150-FF-000634', NULL, 'Uncharacterized protein', 161, NULL, NULL, 183959),
(183960, '3.30.200.20-FF-002121', NULL, 'Uncharacterized protein', 75, NULL, NULL, 183960),
(183961, '1.10.238.10-FF-000109', NULL, 'calumenin isoform X2', 131, NULL, NULL, 183961),
(183962, '1.10.8.10-FF-000349', NULL, 'Baculoviral IAP repeat containing 7', 70, NULL, NULL, 183962),
(183963, '3.20.20.220-FF-000058', NULL, 'Proline dehydrogenase', 277, NULL, NULL, 183963),
(183964, '3.80.10.10-FF-000893', NULL, 'Os08g0322500 protein', 186, NULL, NULL, 183964),
(183965, '3.40.50.300-FF-004119', NULL, 'GTPase HflX', 176, NULL, NULL, 183965),
(183966, '3.30.160.60-FF-002404', NULL, 'Zinc finger protein with KRAB and SCAN domains 16', 24, NULL, NULL, 183966),
(183967, '1.50.40.10-FF-000480', NULL, 'Predicted protein', 340, NULL, NULL, 183967),
(183968, '3.40.190.10-FF-000118', NULL, 'ATP phosphoribosyltransferase 2, chloroplastic', 105, NULL, NULL, 183968),
(183969, '1.10.287.70-FF-000179', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 145, NULL, NULL, 183969),
(183970, '1.20.1250.20-FF-002032', NULL, 'Uncharacterized protein', 344, NULL, NULL, 183970),
(183971, '1.10.400.10-FF-000004', NULL, 'Guanine nucleotide-binding protein subunit alpha-12', 122, NULL, NULL, 183971),
(183972, '3.40.50.720-FF-001401', NULL, 'Chlorophyll synthesis pathway protein BchC', 138, NULL, NULL, 183972),
(183973, '3.30.450.200-FF-000022', NULL, NULL, 67, NULL, NULL, 183973),
(183974, '1.25.50.20-FF-000047', NULL, 'Aminopeptidase', 316, NULL, NULL, 183974),
(183975, '2.130.10.10-FF-000342', NULL, 'Nuclear distribution protein PAC1', 321, NULL, NULL, 183975),
(183976, '3.30.160.60-FF-000336', NULL, 'zinc finger protein 768', 33, NULL, NULL, 183976),
(183977, '1.20.120.530-FF-000012', NULL, 'HTH-type transcriptional regulator McbR', 145, NULL, NULL, 183977),
(183978, '3.30.160.60-FF-005895', NULL, NULL, 37, NULL, NULL, 183978),
(183979, '1.20.1560.10-FF-000597', NULL, 'Uncharacterized protein', 178, NULL, NULL, 183979),
(183980, '1.10.10.10-FF-001558', NULL, 'Uncharacterized protein', 75, NULL, NULL, 183980),
(183981, '3.10.250.10-FF-000097', NULL, NULL, 41, NULL, NULL, 183981);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(183982, '1.10.418.10-FF-000152', NULL, 'Uncharacterized protein', 106, NULL, NULL, 183982),
(183983, '2.20.25.10-FF-000089', NULL, 'Uncharacterized protein', 47, NULL, NULL, 183983),
(183984, '3.40.50.1000-FF-000079', NULL, 'Enolase-phosphatase E1', 123, NULL, NULL, 183984),
(183985, '4.10.860.20-FF-000002', NULL, 'rabenosyn-5 isoform X1', 69, NULL, NULL, 183985),
(183986, '3.90.70.10-FF-000109', NULL, 'Cysteine protease', 309, NULL, NULL, 183986),
(183987, '2.130.10.10-FF-005715', NULL, 'GPI inositol-deacylase', 141, NULL, NULL, 183987),
(183988, '3.40.50.2300-FF-001560', NULL, NULL, 16, NULL, NULL, 183988),
(183989, '2.40.170.20-FF-000074', NULL, 'Ligand-gated TonB-dependent outer membrane channel', 435, NULL, NULL, 183989),
(183990, '2.10.25.10-FF-000876', NULL, 'Laminin subunit alpha-3', 46, NULL, NULL, 183990),
(183991, '1.25.10.10-FF-000923', NULL, 'Ribosomal RNA processing protein', 490, NULL, NULL, 183991),
(183992, '1.20.1250.20-FF-001543', NULL, 'Uncharacterized protein', 422, NULL, NULL, 183992),
(183993, '3.30.310.40-FF-000011', NULL, 'Purine-specific oxidized base lesion DNA N-glycosylase, putative', 94, NULL, NULL, 183993),
(183994, '1.10.510.10-FF-002805', NULL, NULL, 185, NULL, NULL, 183994),
(183995, '1.25.40.10-FF-000077', NULL, 'CTR9 homolog, Paf1/RNA polymerase II complex component', 97, NULL, NULL, 183995),
(183996, '1.10.150.20-FF-000206', NULL, 'Transcription termination/antitermination protein NusA', 75, NULL, NULL, 183996),
(183997, '3.50.7.10-FF-000045', NULL, NULL, 81, NULL, NULL, 183997),
(183998, '2.130.10.10-FF-001972', NULL, 'Uncharacterized protein', 225, NULL, NULL, 183998),
(183999, '3.30.420.10-FF-000499', NULL, NULL, 109, NULL, NULL, 183999),
(184000, '1.10.510.10-FF-001968', NULL, 'Death-associated protein kinase related-like Protein', 165, NULL, NULL, 184000),
(184001, '3.40.50.300-FF-001011', NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', 137, NULL, NULL, 184001),
(184002, '1.10.3210.10-FF-000062', NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase-like protein', 389, NULL, NULL, 184002),
(184003, '3.80.10.10-FF-003703', NULL, 'Os12g0552700 protein', 166, NULL, NULL, 184003),
(184004, '4.10.170.10-FF-000002', NULL, 'serine/threonine-protein kinase 3', 57, NULL, NULL, 184004),
(184005, '3.30.160.60-FF-001915', NULL, 'Zinc finger protein 287', 27, NULL, NULL, 184005),
(184006, '3.10.20.30-FF-000116', NULL, NULL, 49, NULL, NULL, 184006),
(184007, '3.40.1110.10-FF-000366', NULL, NULL, 153, NULL, NULL, 184007),
(184008, '3.50.50.60-FF-000602', NULL, 'Thiol-specific monooxygenase', 120, NULL, NULL, 184008),
(184009, '1.25.10.10-FF-000575', NULL, 'Serine threonine protein phosphatase 2a 59 kDa regulatory subunit b', 407, NULL, NULL, 184009),
(184010, '3.30.230.70-FF-000171', NULL, 'Polyribonucleotide phosphorylase PNPase', 97, NULL, NULL, 184010),
(184011, '1.20.120.1750-FF-000031', NULL, 'RBR-type E3 ubiquitin transferase', 234, NULL, NULL, 184011),
(184012, '3.40.50.880-FF-000061', NULL, 'AraC family transcriptional regulator', 202, NULL, NULL, 184012),
(184013, '3.40.50.300-FF-008099', NULL, 'Tudor domain containing 9', 111, NULL, NULL, 184013),
(184014, '1.10.3060.10-FF-000022', NULL, 'Protein translocase subunit SecA', 89, NULL, NULL, 184014),
(184015, '2.30.30.40-FF-000385', NULL, 'Protein arginine N-methyltransferase 2', 64, NULL, NULL, 184015),
(184016, '3.30.565.10-FF-000413', NULL, 'Two component sensor kinase', 154, NULL, NULL, 184016),
(184017, '2.60.40.1360-FF-000020', NULL, 'Alpha-mannosidase', 81, NULL, NULL, 184017),
(184018, '1.25.40.10-FF-002022', NULL, 'Pentatricopeptide repeat-containing protein At1g74850, chloroplastic', 77, NULL, NULL, 184018),
(184019, '1.20.1070.10-FF-001065', NULL, 'Brain-specific angiogenesis inhibitor 2', 89, NULL, NULL, 184019),
(184020, '1.10.246.220-FF-000002', NULL, 'Telomere repeat-binding factor 1', 80, NULL, NULL, 184020),
(184021, '3.40.250.10-FF-000236', NULL, 'Thiosulfate sulfurtransferase', 96, NULL, NULL, 184021),
(184022, '3.50.50.60-FF-001182', NULL, 'Uncharacterized protein', 104, NULL, NULL, 184022);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(184023, '1.10.472.130-FF-000046', NULL, 'Dynein heavy chain family protein', 153, NULL, NULL, 184023),
(184024, '2.60.40.3360-FF-000002', NULL, 'Uncharacterized protein', 105, NULL, NULL, 184024),
(184025, '3.40.190.10-FF-000091', NULL, 'Porphobilinogen deaminase', 106, NULL, NULL, 184025),
(184026, '1.10.287.40-FF-000018', NULL, 'Serine--tRNA ligase', 103, NULL, NULL, 184026),
(184027, '2.170.260.10-FF-000024', NULL, 'LD36719p', 77, NULL, NULL, 184027),
(184028, '1.10.630.10-FF-000752', NULL, 'Uncharacterized protein', 64, NULL, NULL, 184028),
(184029, '3.40.50.1820-FF-001078', NULL, 'Polyketide synthase RzxF', 252, NULL, NULL, 184029),
(184030, '3.40.1190.20-FF-000059', NULL, 'Ribokinase', 304, NULL, NULL, 184030),
(184031, '1.20.1540.10-FF-000005', NULL, 'Presenilins-associated rhomboid-like protein, mitochondrial', 192, NULL, NULL, 184031),
(184032, '3.40.50.300-FF-005839', NULL, 'ABC transporter ATP-binding protein', 240, NULL, NULL, 184032),
(184033, '3.30.310.50-FF-000014', NULL, 'EKC/KEOPS complex subunit PCC1', 93, NULL, NULL, 184033),
(184034, '1.25.10.10-FF-002520', NULL, 'EXPOrtin (Nuclear export receptor)', 192, NULL, NULL, 184034),
(184035, '3.30.160.60-FF-002551', NULL, 'Zinc finger protein 613', 22, NULL, NULL, 184035),
(184036, '1.10.472.10-FF-000024', NULL, 'G1/S-specific cyclin-E1', 142, NULL, NULL, 184036),
(184037, '1.10.630.10-FF-000662', NULL, 'Uncharacterized protein', 187, NULL, NULL, 184037),
(184038, '1.10.510.10-FF-004048', NULL, NULL, 54, NULL, NULL, 184038),
(184039, '1.10.472.10-FF-000642', NULL, 'Cyclin, N-terminal domain containing protein', 115, NULL, NULL, 184039),
(184040, '3.30.70.920-FF-000034', NULL, 'AsnC family transcriptional regulator', 95, NULL, NULL, 184040),
(184041, '1.10.287.1040-FF-000016', NULL, 'Exodeoxyribonuclease 7 small subunit', 71, NULL, NULL, 184041),
(184042, '1.10.287.1490-FF-000128', NULL, 'Predicted protein', 142, NULL, NULL, 184042),
(184043, '2.30.39.10-FF-000093', NULL, 'Proteinase inhibitor I4 serpin', 156, NULL, NULL, 184043),
(184044, '2.130.10.10-FF-004703', NULL, 'Uncharacterized protein', 173, NULL, NULL, 184044),
(184045, '3.10.110.10-FF-000238', NULL, 'Uncharacterized protein', 66, NULL, NULL, 184045),
(184046, '1.10.10.60-FF-000331', NULL, 'major centromere autoantigen B', 58, NULL, NULL, 184046),
(184047, '1.20.120.850-FF-000046', NULL, 'Uncharacterized protein', 137, NULL, NULL, 184047),
(184048, '2.10.220.10-FF-000161', NULL, 'Fraser extracellular matrix complex subunit 1', 102, NULL, NULL, 184048),
(184049, '2.60.40.10-FF-000033', NULL, 'Killer cell immunoglobulin-like receptor', 99, NULL, NULL, 184049),
(184050, '3.30.160.60-FF-005277', NULL, NULL, 26, NULL, NULL, 184050),
(184051, '2.10.25.10-FF-000786', NULL, 'WAK53a-OsWAK receptor-like protein kinase', 41, NULL, NULL, 184051),
(184052, '3.30.160.60-FF-005625', NULL, NULL, 26, NULL, NULL, 184052),
(184053, '3.40.1110.10-FF-000456', NULL, NULL, 129, NULL, NULL, 184053),
(184054, '3.40.50.300-FF-000432', NULL, 'Voltage-dependent L-type calcium channel subunit beta-1 isoform 1', 198, NULL, NULL, 184054),
(184055, '1.10.472.80-FF-000264', NULL, NULL, 145, NULL, NULL, 184055),
(184056, '3.30.200.20-FF-001632', NULL, 'Predicted protein', 120, NULL, NULL, 184056),
(184057, '1.20.1250.20-FF-001048', NULL, 'YALI0C16225p', 239, NULL, NULL, 184057),
(184058, '3.20.80.10-FF-000001', NULL, 'Right origin-binding protein', 168, NULL, NULL, 184058),
(184059, '3.40.50.1820-FF-001426', NULL, 'Carboxylic ester hydrolase', 517, NULL, NULL, 184059),
(184060, '1.20.58.870-FF-000002', NULL, 'DNA helicase', 111, NULL, NULL, 184060),
(184061, '2.30.130.40-FF-000012', NULL, 'Lon protease homolog, mitochondrial', 108, NULL, NULL, 184061),
(184062, '2.60.40.150-FF-000300', NULL, 'C2 domain-containing protein', 173, NULL, NULL, 184062),
(184063, '3.30.60.20-FF-000070', NULL, 'Uncharacterized protein, isoform B', 55, NULL, NULL, 184063),
(184064, '2.60.40.60-FF-000238', NULL, 'Desmoglein 1', 103, NULL, NULL, 184064),
(184065, '1.10.555.10-FF-000178', NULL, NULL, 112, NULL, NULL, 184065);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(184066, '3.90.640.90-FF-000003', NULL, 'BTG1 isoform 1', 120, NULL, NULL, 184066),
(184067, '3.40.50.300-FF-002321', NULL, 'YPL245W-like protein', 174, NULL, NULL, 184067),
(184068, '3.40.50.10860-FF-000023', NULL, 'C-1-tetrahydrofolate synthase, cytoplasmic', 18, NULL, NULL, 184068),
(184069, '3.40.190.10-FF-000034', NULL, 'Chorismate mutase/prephenate dehydratase', 86, NULL, NULL, 184069),
(184070, '3.80.10.10-FF-001433', NULL, 'Toll-like receptor 15', 187, NULL, NULL, 184070),
(184071, '2.60.40.10-FF-004607', NULL, NULL, 83, NULL, NULL, 184071),
(184072, '3.30.505.10-FF-000235', NULL, NULL, 84, NULL, NULL, 184072),
(184073, '1.10.8.260-FF-000001', NULL, 'Pyridine nucleotide-disulfide oxidoreductase family protein', 61, NULL, NULL, 184073),
(184074, '3.40.50.150-FF-000836', NULL, 'tRNA (guanine-N(7)-)-methyltransferase', 202, NULL, NULL, 184074),
(184075, '1.10.30.10-FF-000008', NULL, 'transcription factor SOX-7', 82, NULL, NULL, 184075),
(184076, '2.60.40.200-FF-000012', NULL, 'Superoxide dismutase [Cu-Zn]', 154, NULL, NULL, 184076),
(184077, '1.10.510.10-FF-004520', NULL, NULL, 98, NULL, NULL, 184077),
(184078, '2.10.50.10-FF-000058', NULL, 'Cysteine repeat modular protein 4 PbCRM4', 57, NULL, NULL, 184078),
(184079, '3.90.79.10-FF-000163', NULL, 'Hydrolase, NUDIX family protein', 118, NULL, NULL, 184079),
(184080, '1.10.150.240-FF-000040', NULL, 'HAD-superfamily hydrolase, subfamily IA, variant 3', 65, NULL, NULL, 184080),
(184081, '1.25.40.10-FF-001089', NULL, 'Pentatricopeptide repeat-containing protein', 120, NULL, NULL, 184081),
(184082, '3.30.1380.20-FF-000020', NULL, 'Trafficking protein particle complex subunit 6B', 163, NULL, NULL, 184082),
(184083, '1.10.8.270-FF-000004', NULL, 'TBC1 domain family, member 22B', 128, NULL, NULL, 184083),
(184084, '3.40.50.300-FF-004445', NULL, 'Uncharacterized protein', 151, NULL, NULL, 184084),
(184085, '1.10.150.280-FF-000001', NULL, 'Competence protein ComEA helix-hairpin-helix repeat region', 73, NULL, NULL, 184085),
(184086, '3.20.20.70-FF-000852', NULL, NULL, 70, NULL, NULL, 184086),
(184087, '3.30.70.330-FF-002280', NULL, NULL, 92, NULL, NULL, 184087),
(184088, '1.20.58.70-FF-000022', NULL, 'Syntaxin-5', 240, NULL, NULL, 184088),
(184089, '3.40.50.720-FF-001255', NULL, 'Alcohol dehydrogenase GroES domain protein', 124, NULL, NULL, 184089),
(184090, '1.25.10.10-FF-002161', NULL, 'Predicted protein', 510, NULL, NULL, 184090),
(184091, '2.130.10.10-FF-000196', NULL, 'Apoptotic protease-activating factor 1', 342, NULL, NULL, 184091),
(184092, '2.60.120.560-FF-000022', NULL, 'Glycosyl hydrolases family 32 superfamily (AFU_orthologue AFUA_6G05000)', 168, NULL, NULL, 184092),
(184093, '1.20.1250.20-FF-001341', NULL, 'MFS general substrate transporter', 208, NULL, NULL, 184093),
(184094, '2.20.70.10-FF-000250', NULL, 'Uncharacterized protein', 50, NULL, NULL, 184094),
(184095, '2.40.30.230-FF-000001', NULL, 'Regulator of nonsense transcripts 1', 90, NULL, NULL, 184095),
(184096, '1.20.58.80-FF-000025', NULL, 'serine/threonine-protein kinase ULK3', 76, NULL, NULL, 184096),
(184097, '3.40.50.300-FF-006536', NULL, 'Uncharacterized protein', 108, NULL, NULL, 184097),
(184098, '3.40.50.300-FF-008245', NULL, 'Uncharacterized protein', 53, NULL, NULL, 184098),
(184099, '3.40.30.10-FF-000424', NULL, 'Predicted protein', 120, NULL, NULL, 184099),
(184100, '3.30.160.60-FF-005569', NULL, NULL, 51, NULL, NULL, 184100),
(184101, '1.25.10.10-FF-001738', NULL, 'YALI0E01232p', 182, NULL, NULL, 184101),
(184102, '3.30.70.240-FF-000038', NULL, 'Ribosome-releasing factor 2, mitochondrial', 94, NULL, NULL, 184102),
(184103, '1.50.40.10-FF-000479', NULL, 'AFR253Wp', 285, NULL, NULL, 184103),
(184104, '3.30.1360.180-FF-000005', NULL, 'ectonucleotide pyrophosphatase/phosphodiesterase family member 7', 104, NULL, NULL, 184104),
(184105, '1.25.40.10-FF-004910', NULL, 'Uncharacterized protein', 72, NULL, NULL, 184105),
(184106, '3.40.630.10-FF-000018', NULL, 'Aminoacyl-histidine dipeptidase PepD', 117, NULL, NULL, 184106),
(184107, '1.25.40.60-FF-000007', NULL, 'Vacuolar protein sorting-associated protein 45', 122, NULL, NULL, 184107);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(184108, '1.20.58.90-FF-000028', NULL, NULL, 113, NULL, NULL, 184108),
(184109, '3.40.33.10-FF-000195', NULL, 'Uncharacterized protein', 79, NULL, NULL, 184109),
(184110, '3.90.190.10-FF-000506', NULL, 'Uncharacterized protein', 143, NULL, NULL, 184110),
(184111, '1.10.510.10-FF-002334', NULL, NULL, 204, NULL, NULL, 184111),
(184112, '2.60.200.20-FF-000084', NULL, 'FOG: FHA domain', 120, NULL, NULL, 184112),
(184113, '3.60.21.10-FF-000048', NULL, 'Metallophosphoesterase', 174, NULL, NULL, 184113),
(184114, '1.25.10.10-FF-000070', NULL, 'armadillo repeat-containing protein 8 isoform X1', 253, NULL, NULL, 184114),
(184115, '1.20.1270.60-FF-000196', NULL, 'AaceriAFR725Cp', 194, NULL, NULL, 184115),
(184116, '1.10.150.290-FF-000004', NULL, NULL, 17, NULL, NULL, 184116),
(184117, '3.30.420.110-FF-000012', NULL, 'DNA mismatch repair protein', 185, NULL, NULL, 184117),
(184118, '2.60.40.790-FF-000172', NULL, NULL, 137, NULL, NULL, 184118),
(184119, '3.30.497.10-FF-000131', NULL, 'Uncharacterized protein', 89, NULL, NULL, 184119),
(184120, '3.30.160.60-FF-003478', NULL, NULL, 27, NULL, NULL, 184120),
(184121, '3.30.1330.60-FF-000034', NULL, 'Flagellar motor protein MotD', 127, NULL, NULL, 184121),
(184122, '2.70.50.30-FF-000022', NULL, NULL, 132, NULL, NULL, 184122),
(184123, '3.30.160.60-FF-001769', NULL, 'chromosome alignment-maintaining phosphoprotein 1', 96, NULL, NULL, 184123),
(184124, '3.10.20.10-FF-000020', NULL, 'DNA fragmentation factor, alpha polypeptide', 84, NULL, NULL, 184124),
(184125, '3.30.810.10-FF-000017', NULL, '1-phosphatidylinositol-3-phosphate 5-kinase (Fab1), putative (AFU_orthologue AFUA_6G07440)', 80, NULL, NULL, 184125),
(184126, '3.40.33.10-FF-000138', NULL, 'Uncharacterized protein', 168, NULL, NULL, 184126),
(184127, '3.80.10.10-FF-002040', NULL, 'Insulin-like growth factor-binding protein acid labile subunit', 66, NULL, NULL, 184127),
(184128, '3.30.1370.10-FF-000134', NULL, 'Uncharacterized protein, isoform B', 80, NULL, NULL, 184128),
(184129, '3.40.50.300-FF-008301', NULL, 'Uncharacterized protein', 11, NULL, NULL, 184129),
(184130, '2.60.40.10-FF-003938', NULL, NULL, 106, NULL, NULL, 184130),
(184131, '3.30.200.20-FF-001626', NULL, 'Ser/Thr protein kinase, putative', 96, NULL, NULL, 184131),
(184132, '1.10.1420.10-FF-000100', NULL, 'Endonuclease MutS2', 133, NULL, NULL, 184132),
(184133, '3.40.50.2020-FF-000048', NULL, 'Hypoxanthine phosphoribosyltransferase', 178, NULL, NULL, 184133),
(184134, '1.25.40.20-FF-001569', NULL, 'Uncharacterized protein', 70, NULL, NULL, 184134),
(184135, '2.60.40.60-FF-000295', NULL, 'Cadherin 86C, isoform E', 105, NULL, NULL, 184135),
(184136, '3.40.50.300-FF-004030', NULL, 'ATP-dependent DNA helicase', 265, NULL, NULL, 184136),
(184137, '1.10.510.10-FF-000720', NULL, 'Serine/threonine-protein kinase UCNL', 192, NULL, NULL, 184137),
(184138, '1.25.10.10-FF-000159', NULL, 'Plakophilin 2', 473, NULL, NULL, 184138),
(184139, '3.30.1360.170-FF-000002', NULL, 'Thymidylate synthase ThyX', 235, NULL, NULL, 184139),
(184140, '2.20.25.10-FF-000090', NULL, 'DNA-directed RNA polymerase subunit', 55, NULL, NULL, 184140),
(184141, '3.30.200.60-FF-000014', NULL, 'Uncharacterized protein', 53, NULL, NULL, 184141),
(184142, '2.60.40.10-FF-000920', NULL, 'NXPE family member 4', 70, NULL, NULL, 184142),
(184143, '3.40.1810.10-FF-000048', NULL, NULL, 63, NULL, NULL, 184143),
(184144, '1.20.58.60-FF-000396', NULL, 'VAB-10B protein', 246, NULL, NULL, 184144),
(184145, '1.10.274.30-FF-000036', NULL, 'Uncharacterized protein', 157, NULL, NULL, 184145),
(184146, '1.20.1440.90-FF-000010', NULL, 'Phosphoenolpyruvate carboxylase 4', 85, NULL, NULL, 184146),
(184147, '2.40.10.10-FF-000700', NULL, NULL, 107, NULL, NULL, 184147),
(184148, '3.40.50.790-FF-000034', NULL, 'Uncharacterized protein', 100, NULL, NULL, 184148),
(184149, '3.40.630.10-FF-000170', NULL, 'Uncharacterized protein', 315, NULL, NULL, 184149),
(184150, '2.40.30.10-FF-000230', NULL, 'Elongation factor Tu, apicoplast', 59, NULL, NULL, 184150),
(184151, '1.10.8.810-FF-000003', NULL, 'Daxx-like protein', 89, NULL, NULL, 184151);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(184152, '3.40.50.2000-FF-000042', NULL, 'UDP-glucuronosyltransferase', 172, NULL, NULL, 184152),
(184153, '3.40.50.300-FF-004406', NULL, 'Probable exopolysaccharide polymerization protein', 183, NULL, NULL, 184153),
(184154, '3.20.20.80-FF-000855', NULL, 'Brain chitinase like protein 2', 67, NULL, NULL, 184154),
(184155, '2.130.10.10-FF-000252', NULL, 'Nucleolar protein 10', 220, NULL, NULL, 184155),
(184156, '1.20.1070.10-FF-000986', NULL, 'Melanin-concentrating hormone receptor 2', 334, NULL, NULL, 184156),
(184157, '3.10.20.90-FF-000145', NULL, 'regulator of G-protein signaling 14 isoform X1', 68, NULL, NULL, 184157),
(184158, '1.10.287.1490-FF-000038', NULL, 'Zn-ribbon protein, possibly nucleic acid-binding protein', 234, NULL, NULL, 184158),
(184159, '3.40.50.1980-FF-000030', NULL, 'ABC transporter substrate-binding protein', 153, NULL, NULL, 184159),
(184160, '3.30.565.10-FF-000211', NULL, 'Sensor protein UhpB', 129, NULL, NULL, 184160),
(184161, '3.40.50.2300-FF-001267', NULL, NULL, 208, NULL, NULL, 184161),
(184162, '3.40.50.150-FF-000308', NULL, 'endothelin-converting enzyme 2 isoform X2', 149, NULL, NULL, 184162),
(184163, '1.25.10.10-FF-002048', NULL, 'cytoskeleton-associated protein 5 isoform X2', 82, NULL, NULL, 184163),
(184164, '1.10.1780.10-FF-000003', NULL, 'ATP-dependent chaperone ClpB', 147, NULL, NULL, 184164),
(184165, '1.20.5.110-FF-000185', NULL, 'Phosphoprotein P', 80, NULL, NULL, 184165),
(184166, '1.25.40.10-FF-001566', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 118, NULL, NULL, 184166),
(184167, '3.20.20.100-FF-000112', NULL, 'Probable L-fucose dehydrogenase', 329, NULL, NULL, 184167),
(184168, '2.60.40.10-FF-005176', NULL, NULL, 118, NULL, NULL, 184168),
(184169, '3.30.40.10-FF-002100', NULL, 'Uncharacterized protein', 76, NULL, NULL, 184169),
(184170, '3.90.550.10-FF-000113', NULL, 'UDP-glucose pyrophosphorylase', 294, NULL, NULL, 184170),
(184171, '3.30.160.60-FF-001882', NULL, 'Zinc finger protein 473', 37, NULL, NULL, 184171),
(184172, '3.40.50.200-FF-000166', NULL, 'Uncharacterized protein', 131, NULL, NULL, 184172),
(184173, '3.40.50.1460-FF-000138', NULL, 'Uncharacterized protein', 196, NULL, NULL, 184173),
(184174, '3.30.160.60-FF-005951', NULL, NULL, 35, NULL, NULL, 184174),
(184175, '2.60.40.150-FF-000502', NULL, 'Copine, putative', 121, NULL, NULL, 184175),
(184176, '3.40.50.2300-FF-000340', NULL, 'Catabolite control protein A', 128, NULL, NULL, 184176),
(184177, '3.40.50.1100-FF-000194', NULL, 'L-serine ammonia-lyase, putative', 72, NULL, NULL, 184177),
(184178, '1.10.8.10-FF-000175', NULL, 'Holliday junction ATP-dependent DNA helicase RuvA', 50, NULL, NULL, 184178),
(184179, '2.130.10.10-FF-000516', NULL, 'WD repeat-containing protein 55-like', 221, NULL, NULL, 184179),
(184180, '3.90.550.10-FF-000641', NULL, 'UDP-glucose pyrophosphorylase 2b', 165, NULL, NULL, 184180),
(184181, '3.40.50.150-FF-000460', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', 210, NULL, NULL, 184181),
(184182, '3.30.200.20-FF-002413', NULL, 'Putative S-locus receptor-like protein kinase family protein', 128, NULL, NULL, 184182),
(184183, '2.60.40.10-FF-003793', NULL, NULL, 98, NULL, NULL, 184183),
(184184, '1.10.3080.10-FF-000023', NULL, 'Chloride channel protein', 468, NULL, NULL, 184184),
(184185, '1.20.1250.10-FF-000079', NULL, NULL, 42, NULL, NULL, 184185),
(184186, '3.40.50.1440-FF-000132', NULL, 'Uncharacterized protein', 151, NULL, NULL, 184186),
(184187, '1.10.287.70-FF-000595', NULL, 'Glutamate receptor, putative', 91, NULL, NULL, 184187),
(184188, '2.60.40.10-FF-005884', NULL, NULL, 94, NULL, NULL, 184188),
(184189, '2.30.30.40-FF-000093', NULL, 'Protein kinase activator Bem1', 85, NULL, NULL, 184189),
(184190, '3.30.70.1230-FF-000134', NULL, 'Predicted protein', 75, NULL, NULL, 184190),
(184191, '1.10.10.60-FF-000185', NULL, 'MYB transcription factor', 61, NULL, NULL, 184191),
(184192, '3.30.9.90-FF-000011', NULL, 'Uncharacterized protein', 106, NULL, NULL, 184192),
(184193, '1.10.238.10-FF-000525', NULL, 'Uncharacterized protein', 130, NULL, NULL, 184193);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(184194, '3.40.140.10-FF-000205', NULL, '26S proteasome non-ATPase regulatory subunit 14-like protein', 170, NULL, NULL, 184194),
(184195, '3.40.50.1780-FF-000026', NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', 143, NULL, NULL, 184195),
(184196, '3.30.160.60-FF-000044', NULL, 'zinc finger protein 37 homolog', 29, NULL, NULL, 184196),
(184197, '1.25.10.10-FF-001795', NULL, 'AP-3 complex subunit delta', 576, NULL, NULL, 184197),
(184198, '1.20.1250.20-FF-001812', NULL, 'Predicted protein', 161, NULL, NULL, 184198),
(184199, '1.25.10.10-FF-002104', NULL, 'LD16031p', 364, NULL, NULL, 184199),
(184200, '3.10.105.10-FF-000081', NULL, 'Xyloglucan ABC transport system, sugar-binding protein', 283, NULL, NULL, 184200),
(184201, '3.40.50.300-FF-000376', NULL, 'Putative heterogeneous nuclear ribonucleoprotein U', 173, NULL, NULL, 184201),
(184202, '1.10.510.10-FF-002811', NULL, NULL, 181, NULL, NULL, 184202),
(184203, '2.60.40.10-FF-002157', NULL, 'Wrapper protein', 103, NULL, NULL, 184203),
(184204, '2.60.40.10-FF-004720', NULL, NULL, 106, NULL, NULL, 184204),
(184205, '3.60.40.10-FF-000227', NULL, 'Adenylate cyclase', 292, NULL, NULL, 184205),
(184206, '2.130.10.10-FF-003916', NULL, 'Uncharacterized protein', 262, NULL, NULL, 184206),
(184207, '1.10.560.10-FF-000072', NULL, 'Mitochondrial chaperone TCM62', 95, NULL, NULL, 184207),
(184208, '3.90.550.10-FF-000169', NULL, 'Dolichyl-phosphate beta-glucosyltransferase', 272, NULL, NULL, 184208),
(184209, '1.20.58.80-FF-000082', NULL, 'Uncharacterized protein', 142, NULL, NULL, 184209),
(184210, '3.40.140.10-FF-000262', NULL, 'Predicted protein', 118, NULL, NULL, 184210),
(184211, '3.40.395.10-FF-000004', NULL, 'sentrin-specific protease 7 isoform X3', 237, NULL, NULL, 184211),
(184212, '1.20.120.350-FF-000082', NULL, 'Uncharacterized protein', 120, NULL, NULL, 184212),
(184213, '3.30.40.10-FF-001459', NULL, 'Peroxisome assembly protein, putative', 84, NULL, NULL, 184213),
(184214, '1.10.287.70-FF-000538', NULL, 'Potassium intermediate/small conductance calcium-activated channel, subfamily N, member 4', 68, NULL, NULL, 184214),
(184215, '3.30.70.3540-FF-000001', NULL, 'Orf1a polyprotein', 99, NULL, NULL, 184215),
(184216, '3.30.70.2630-FF-000003', NULL, 'Telomerase reverse transcriptase', 92, NULL, NULL, 184216),
(184217, '3.30.160.60-FF-002135', NULL, 'ZAP1p Zinc-regulated transcription factor', 31, NULL, NULL, 184217),
(184218, '2.40.30.70-FF-000017', NULL, 'Predicted protein', 60, NULL, NULL, 184218),
(184219, '1.20.1250.20-FF-001009', NULL, 'Unplaced genomic scaffold supercont2.19, whole genome shotgun sequence', 240, NULL, NULL, 184219),
(184220, '1.10.10.10-FF-001699', NULL, 'PLP-dependent aminotransferase family protein', 99, NULL, NULL, 184220),
(184221, '3.30.420.40-FF-000603', NULL, 'Heat shock protein70, hsp70A2, putative', 22, NULL, NULL, 184221),
(184222, '1.10.510.10-FF-001030', NULL, 'Protein kinase 7', 224, NULL, NULL, 184222),
(184223, '1.10.10.10-FF-000541', NULL, 'Transcriptional regulator SarA', 85, NULL, NULL, 184223),
(184224, '1.10.260.100-FF-000028', NULL, 'Hsp-70 Interacting Protein homolog', 58, NULL, NULL, 184224),
(184225, '3.40.50.1100-FF-000137', NULL, 'Tryptophan synthase beta chain 1', 177, NULL, NULL, 184225),
(184226, '2.60.40.60-FF-000093', NULL, 'Protocadherin 10', 106, NULL, NULL, 184226),
(184227, '3.40.50.2000-FF-000986', NULL, 'Sucrose synthase 3', 61, NULL, NULL, 184227),
(184228, '2.40.50.100-FF-000090', NULL, 'Sugar ABC transporter ATP-binding protein SugC', 94, NULL, NULL, 184228),
(184229, '2.120.10.30-FF-000253', NULL, 'Uncharacterized protein', 130, NULL, NULL, 184229),
(184230, '2.40.30.130-FF-000010', NULL, 'Alanine--tRNA ligase', 93, NULL, NULL, 184230),
(184231, '3.30.70.80-FF-000009', NULL, 'Organelle RRM domain-containing protein 1, chloroplastic', 100, NULL, NULL, 184231),
(184232, '2.40.30.10-FF-000050', NULL, 'NADH oxidoreductase hcr', 99, NULL, NULL, 184232),
(184233, '2.30.30.1150-FF-000020', NULL, 'Predicted protein', 182, NULL, NULL, 184233),
(184234, '3.30.1840.10-FF-000002', NULL, 'Polyphosphate kinase', 201, NULL, NULL, 184234);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(184235, '2.60.40.10-FF-004248', NULL, NULL, 103, NULL, NULL, 184235),
(184236, '1.10.10.60-FF-000505', NULL, 'Homeodomain-like transcriptional regulator', 82, NULL, NULL, 184236),
(184237, '3.50.50.60-FF-000310', NULL, 'FAD-dependent oxidoreductase family protein', 219, NULL, NULL, 184237),
(184238, '3.40.1110.10-FF-000282', NULL, NULL, 119, NULL, NULL, 184238),
(184239, '3.30.70.20-FF-000042', NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', 26, NULL, NULL, 184239),
(184240, '2.100.10.30-FF-000001', NULL, 'Jacalin-related lectin 33', 147, NULL, NULL, 184240),
(184241, '3.40.50.1820-FF-001842', NULL, 'Uncharacterized protein', 78, NULL, NULL, 184241),
(184242, '3.30.559.30-FF-000130', NULL, 'Uncharacterized protein', 272, NULL, NULL, 184242),
(184243, '2.60.40.10-FF-000538', NULL, 'Striated muscle preferentially expressed protein kinase', 101, NULL, NULL, 184243),
(184244, '3.30.40.10-FF-001791', NULL, 'Predicted protein', 58, NULL, NULL, 184244),
(184245, '3.40.50.300-FF-005665', NULL, 'Replication factor C, subunit 1', 197, NULL, NULL, 184245),
(184246, '3.40.50.2300-FF-000008', NULL, 'Two-component response regulator OmpR', 82, NULL, NULL, 184246),
(184247, '1.10.246.190-FF-000009', NULL, NULL, 69, NULL, NULL, 184247),
(184248, '2.60.220.30-FF-000032', NULL, 'Unc-5 netrin receptor C', 63, NULL, NULL, 184248),
(184249, '3.30.200.20-FF-001806', NULL, 'Kinase, CAMKK', 129, NULL, NULL, 184249),
(184250, '1.10.238.10-FF-000435', NULL, 'WGS project CABT00000000 data, contig 2.2', 82, NULL, NULL, 184250),
(184251, '3.30.710.10-FF-000398', NULL, 'Uncharacterized protein', 106, NULL, NULL, 184251),
(184252, '2.10.25.10-FF-001332', NULL, 'Notch receptor 3', 49, NULL, NULL, 184252),
(184253, '3.10.20.90-FF-000673', NULL, 'Uncharacterized protein', 62, NULL, NULL, 184253),
(184254, '2.130.10.10-FF-004226', NULL, 'Uncharacterized protein', 146, NULL, NULL, 184254),
(184255, '2.130.10.10-FF-004411', NULL, 'Predicted protein', 370, NULL, NULL, 184255),
(184256, '1.10.405.10-FF-000026', NULL, 'Rab proteins geranylgeranyltransferase component A', 100, NULL, NULL, 184256),
(184257, '3.80.10.10-FF-002692', NULL, 'Uncharacterized protein', 77, NULL, NULL, 184257),
(184258, '3.30.160.60-FF-000605', NULL, 'zinc finger protein 2 isoform X1', 28, NULL, NULL, 184258),
(184259, '3.40.30.10-FF-000098', NULL, 'Hydrogenase-1 operon protein hyaE', 132, NULL, NULL, 184259),
(184260, '1.10.20.10-FF-000036', NULL, 'CBF/NF-Y family transcription factor', 72, NULL, NULL, 184260),
(184261, '1.10.8.60-FF-000493', NULL, 'ATPase-like protein', 89, NULL, NULL, 184261),
(184262, '3.40.50.300-FF-000606', NULL, 'IS100 transposase orfB', 187, NULL, NULL, 184262),
(184263, '3.40.920.10-FF-000029', NULL, NULL, 69, NULL, NULL, 184263),
(184264, '3.30.70.60-FF-000003', NULL, '30S ribosomal protein S6', 115, NULL, NULL, 184264),
(184265, '3.80.10.10-FF-001904', NULL, 'Photoactivated adenylate cyclase subunit alpha', 120, NULL, NULL, 184265),
(184266, '3.40.50.300-FF-000286', NULL, 'ADP-ribosylation factor 6', 173, NULL, NULL, 184266),
(184267, '3.30.70.1130-FF-000014', NULL, 'Uncharacterized protein', 74, NULL, NULL, 184267),
(184268, '2.60.40.60-FF-001020', NULL, 'Si:ch211-186j3.6', 110, NULL, NULL, 184268),
(184269, '3.90.320.10-FF-000068', NULL, 'Uncharacterized protein', 123, NULL, NULL, 184269),
(184270, '3.40.30.10-FF-000188', NULL, 'Chloride intracellular channel exc-4', 111, NULL, NULL, 184270),
(184271, '1.25.40.20-FF-000462', NULL, 'Hos4p', 148, NULL, NULL, 184271),
(184272, '1.20.1740.10-FF-000190', NULL, 'Solute carrier family 12 member 10, tandem duplicate 3', 240, NULL, NULL, 184272),
(184273, '3.30.70.120-FF-000002', NULL, 'ATP phosphoribosyltransferase', 74, NULL, NULL, 184273),
(184274, '1.10.1170.10-FF-000030', NULL, 'Uncharacterized protein', 126, NULL, NULL, 184274),
(184275, '1.10.533.10-FF-000251', NULL, 'Caspase 10', 60, NULL, NULL, 184275),
(184276, '3.30.160.60-FF-002606', NULL, 'Zinc finger protein, putative', 26, NULL, NULL, 184276),
(184277, '3.40.50.300-FF-007992', NULL, 'Uncharacterized protein', 155, NULL, NULL, 184277);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(184278, '3.40.50.2300-FF-000250', NULL, 'Two-component system response regulator', 82, NULL, NULL, 184278),
(184279, '2.60.40.10-FF-006047', NULL, NULL, 83, NULL, NULL, 184279),
(184280, '2.60.98.10-FF-000008', NULL, 'Structural polyprotein', 73, NULL, NULL, 184280),
(184281, '2.40.10.10-FF-000138', NULL, 'Kallikrein related peptidase 11', 100, NULL, NULL, 184281),
(184282, '1.20.5.4820-FF-000011', NULL, 'Dachs, isoform E', 116, NULL, NULL, 184282),
(184283, '2.60.340.10-FF-000001', NULL, 'Gp8 baseplate wedge subunit', 165, NULL, NULL, 184283),
(184284, '1.10.10.10-FF-001884', NULL, 'Vacuolar-sorting protein SNF8', 33, NULL, NULL, 184284),
(184285, '2.10.110.20-FF-000009', NULL, NULL, 60, NULL, NULL, 184285),
(184286, '3.40.50.1820-FF-001039', NULL, 'Serine carboxypeptidase-like 18', 109, NULL, NULL, 184286),
(184287, '1.10.1450.10-FF-000102', NULL, 'Tetraspanin', 112, NULL, NULL, 184287),
(184288, '3.80.10.10-FF-000449', NULL, 'F-box protein SKIP2', 382, NULL, NULL, 184288),
(184289, '3.20.20.140-FF-000186', NULL, 'PHP domain protein', 191, NULL, NULL, 184289),
(184290, '3.30.530.20-FF-000128', NULL, 'Phosphatidylinositol transfer protein alpha isoform', 177, NULL, NULL, 184290),
(184291, '3.40.50.150-FF-001764', NULL, NULL, 218, NULL, NULL, 184291),
(184292, '3.40.50.1820-FF-000819', NULL, 'ATP-dependent serine activating enzyme', 358, NULL, NULL, 184292),
(184293, '1.10.287.2900-FF-000017', NULL, 'Predicted protein', 78, NULL, NULL, 184293),
(184294, '6.10.250.3280-FF-000001', NULL, 'Envelope glycoprotein B', 65, NULL, NULL, 184294),
(184295, '2.60.120.10-FF-000018', NULL, '4-deoxy-L-threo-5-hexosulose-uronate ketol-isomerase', 147, NULL, NULL, 184295),
(184296, '1.10.560.10-FF-000162', NULL, 'T-complex protein 1 subunit eta', 70, NULL, NULL, 184296),
(184297, '3.40.30.10-FF-000391', NULL, 'Unplaced genomic scaffold supercont1.8, whole genome shotgun sequence', 142, NULL, NULL, 184297),
(184298, '1.10.510.10-FF-003879', NULL, NULL, 91, NULL, NULL, 184298),
(184299, '1.10.510.10-FF-003593', NULL, NULL, 208, NULL, NULL, 184299),
(184300, '1.10.418.40-FF-000020', NULL, 'Uncharacterized protein', 135, NULL, NULL, 184300),
(184301, '2.60.120.10-FF-000546', NULL, 'Uncharacterized protein', 146, NULL, NULL, 184301),
(184302, '3.90.470.10-FF-000022', NULL, 'Mitochondrial ribosomal protein', 167, NULL, NULL, 184302),
(184303, '2.70.150.10-FF-000091', NULL, 'Metal cation transporter P-type ATPase', 125, NULL, NULL, 184303),
(184304, '2.60.40.1760-FF-000011', NULL, 'Glycosyl hydrolases family 31 protein', 305, NULL, NULL, 184304),
(184305, '3.40.630.30-FF-000086', NULL, 'Acetyltransferase, GNAT family, putative', 166, NULL, NULL, 184305),
(184306, '1.25.40.250-FF-000015', NULL, 'Uncharacterized protein', 79, NULL, NULL, 184306),
(184307, '1.25.10.10-FF-000721', NULL, 'AP-4 complex subunit epsilon', 595, NULL, NULL, 184307),
(184308, '1.25.40.240-FF-000012', NULL, NULL, 139, NULL, NULL, 184308),
(184309, '3.90.550.10-FF-000023', NULL, 'Glucose-1-phosphate thymidylyltransferase', 293, NULL, NULL, 184309),
(184310, '1.25.40.10-FF-001853', NULL, 'Soluble_NSF_attachment_protein_-_SNAP_-_putative', 162, NULL, NULL, 184310),
(184311, '3.90.470.20-FF-000025', NULL, 'Mitochondrial holo-[acyl-carrier-protein] synthase', 163, NULL, NULL, 184311),
(184312, '2.60.40.10-FF-000448', NULL, 'Neuronal cell adhesion molecule', 103, NULL, NULL, 184312),
(184313, '3.90.550.10-FF-000080', NULL, 'D-ribitol-5-phosphate cytidylyltransferase isoform X1', 238, NULL, NULL, 184313),
(184314, '3.40.50.300-FF-002085', NULL, 'ABC transporter ATP-binding protein', 227, NULL, NULL, 184314),
(184315, '2.60.40.10-FF-002303', NULL, 'Sortilin-related receptor', 100, NULL, NULL, 184315),
(184316, '3.40.50.1820-FF-001281', NULL, 'Predicted protein', 295, NULL, NULL, 184316),
(184317, '3.40.50.300-FF-007464', NULL, 'ABC transporter', 242, NULL, NULL, 184317),
(184318, '3.30.70.330-FF-001257', NULL, 'RNA recognition motif domain containing protein', 91, NULL, NULL, 184318),
(184319, '2.60.120.610-FF-000003', NULL, 'Probable arabinosyltransferase A', 173, NULL, NULL, 184319);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(184320, '2.10.110.10-FF-000006', NULL, 'LIM homeobox transcription factor 1-beta', 55, NULL, NULL, 184320),
(184321, '3.10.20.90-FF-000055', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', 108, NULL, NULL, 184321),
(184322, '3.90.550.20-FF-000026', NULL, 'Mannosyltransferase', 199, NULL, NULL, 184322),
(184323, '1.25.40.10-FF-004146', NULL, 'Uncharacterized protein', 439, NULL, NULL, 184323),
(184324, '3.40.50.300-FF-003102', NULL, 'Related to PRP12-involved in early maturation of pre-rRNA', 144, NULL, NULL, 184324),
(184325, '3.30.40.10-FF-001173', NULL, 'Uncharacterized protein', 94, NULL, NULL, 184325),
(184326, '3.30.60.20-FF-000103', NULL, 'Phorbol esters/diacylglycerol binding domain (C1 domain) domain containing protein', 48, NULL, NULL, 184326),
(184327, '3.10.50.40-FF-000126', NULL, 'Uncharacterized protein', 114, NULL, NULL, 184327),
(184328, '2.130.10.10-FF-002141', NULL, 'Uncharacterized protein', 177, NULL, NULL, 184328),
(184329, '3.40.50.2000-FF-000896', NULL, 'UDP-glucuronosyltransferase', 173, NULL, NULL, 184329),
(184330, '2.60.40.4070-FF-000001', NULL, 'Basal-body rod modification protein FlgD', 94, NULL, NULL, 184330),
(184331, '2.40.70.10-FF-000024', NULL, 'Endothiapepsin', 155, NULL, NULL, 184331),
(184332, '3.30.450.20-FF-000599', NULL, 'Sensor histidine kinase', 140, NULL, NULL, 184332),
(184333, '2.40.10.10-FF-000195', NULL, 'Uncharacterized protein, isoform B', 245, NULL, NULL, 184333),
(184334, '3.40.50.10420-FF-000004', NULL, '5-formyltetrahydrofolate cyclo-ligase-like protein COG0212', 177, NULL, NULL, 184334),
(184335, '3.30.60.30-FF-000106', NULL, 'Protein CBG17314', 57, NULL, NULL, 184335),
(184336, '2.60.40.10-FF-002450', NULL, 'HMCN2 isoform 3', 55, NULL, NULL, 184336),
(184337, '1.25.10.10-FF-000103', NULL, 'Anaphase promoting complex subunit 1', 153, NULL, NULL, 184337),
(184338, '1.20.1270.280-FF-000078', NULL, 'Uncharacterized protein', 52, NULL, NULL, 184338),
(184339, '3.20.20.70-FF-000291', NULL, 'N-acetylneuraminate lyase', 297, NULL, NULL, 184339),
(184340, '1.10.560.10-FF-000105', NULL, 'Uncharacterized protein', 167, NULL, NULL, 184340),
(184341, '1.20.58.390-FF-000133', NULL, 'Proton-gated ion channel', 121, NULL, NULL, 184341),
(184342, '3.50.50.60-FF-000400', NULL, 'FAD-dependent oxidoreductase', 207, NULL, NULL, 184342),
(184343, '2.20.20.10-FF-000005', NULL, 'Carboxypeptidase inhibitor', 37, NULL, NULL, 184343),
(184344, '3.30.160.60-FF-004405', NULL, NULL, 22, NULL, NULL, 184344),
(184345, '3.50.50.60-FF-001384', NULL, 'Uncharacterized protein', 50, NULL, NULL, 184345),
(184346, '2.102.10.10-FF-000052', NULL, 'Cytidine monophosphate-N-acetylneuraminic acid hydroxylase', 94, NULL, NULL, 184346),
(184347, '2.60.40.60-FF-000800', NULL, 'Protocadherin 15a CD3 isoform', 100, NULL, NULL, 184347),
(184348, '3.90.1410.10-FF-000068', NULL, 'Predicted protein', 258, NULL, NULL, 184348),
(184349, '3.10.250.10-FF-000041', NULL, 'Transmembrane protease, serine 5 (Spinesin), isoform CRA_c', 102, NULL, NULL, 184349),
(184350, '2.60.40.60-FF-000710', NULL, 'Cadherin-4', 100, NULL, NULL, 184350),
(184351, '2.60.120.10-FF-000636', NULL, '3-hydroxyanthranilate 3,4-dioxygenase, putative', 180, NULL, NULL, 184351),
(184352, '2.60.40.1730-FF-000092', NULL, NULL, 77, NULL, NULL, 184352),
(184353, '3.40.50.1000-FF-000641', NULL, NULL, 168, NULL, NULL, 184353),
(184354, '1.10.730.10-FF-000231', NULL, 'Uncharacterized protein', 165, NULL, NULL, 184354),
(184355, '3.30.200.20-FF-001396', NULL, 'Protein kinase superfamily protein', 104, NULL, NULL, 184355),
(184356, '3.90.105.10-FF-000023', NULL, 'Molybdopterin molybdenumtransferase', 52, NULL, NULL, 184356),
(184357, '4.10.1120.10-FF-000002', NULL, 'Retinal cone rhodopsin-sensitive cGMP 3'',5''-cyclic phosphodiesterase subunit gamma-like', 85, NULL, NULL, 184357),
(184358, '1.10.10.10-FF-000451', NULL, 'IclR family transcriptional regulator', 78, NULL, NULL, 184358),
(184359, '1.10.1160.10-FF-000001', NULL, 'Glutamine--tRNA ligase', 78, NULL, NULL, 184359),
(184360, '3.30.160.60-FF-004462', NULL, NULL, 26, NULL, NULL, 184360);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(184361, '2.60.40.10-FF-005827', NULL, NULL, 42, NULL, NULL, 184361),
(184362, '1.10.287.110-FF-000017', NULL, 'dnaJ homolog subfamily C member 5', 105, NULL, NULL, 184362),
(184363, '2.30.29.30-FF-000688', NULL, 'Anillin-like protein 1', 129, NULL, NULL, 184363),
(184364, '3.40.109.10-FF-000043', NULL, 'Nitroreductase family protein', 43, NULL, NULL, 184364),
(184365, '3.20.20.140-FF-000276', NULL, 'Adenosine deaminase', 339, NULL, NULL, 184365),
(184366, '1.20.1560.10-FF-000799', NULL, 'Putative ABC transporter C family member 15', 199, NULL, NULL, 184366),
(184367, '3.30.420.10-FF-000443', NULL, NULL, 225, NULL, NULL, 184367),
(184368, '1.10.510.10-FF-003969', NULL, NULL, 342, NULL, NULL, 184368),
(184369, '3.20.20.60-FF-000046', NULL, 'Pyruvate kinase', 129, NULL, NULL, 184369),
(184370, '2.160.20.10-FF-000190', NULL, 'Cell surface protein', 220, NULL, NULL, 184370),
(184371, '3.30.497.10-FF-000018', NULL, 'Serpin family B member 8', 160, NULL, NULL, 184371),
(184372, '2.60.120.200-FF-000673', NULL, 'Uncharacterized protein', 52, NULL, NULL, 184372),
(184373, '2.40.50.140-FF-001271', NULL, NULL, 82, NULL, NULL, 184373),
(184374, '2.60.40.640-FF-000121', NULL, 'Predicted protein', 143, NULL, NULL, 184374),
(184375, '3.30.160.60-FF-000134', NULL, 'Krueppel-like factor 11', 35, NULL, NULL, 184375),
(184376, '3.30.530.20-FF-000038', NULL, 'Conserved protein TB16.3', 141, NULL, NULL, 184376),
(184377, '3.80.10.10-FF-002978', NULL, 'Uncharacterized protein', 99, NULL, NULL, 184377),
(184378, '1.10.418.60-FF-000026', NULL, 'Sterol regulatory element-binding protein, putative', 89, NULL, NULL, 184378),
(184379, '1.20.1110.10-FF-000248', NULL, NULL, 181, NULL, NULL, 184379),
(184380, '3.40.50.1820-FF-001371', NULL, 'Uncharacterized protein', 226, NULL, NULL, 184380),
(184381, '2.60.40.10-FF-002247', NULL, 'AGAP005471-PA', 95, NULL, NULL, 184381),
(184382, '3.90.1200.10-FF-000081', NULL, 'Chromosome 9, whole genome shotgun sequence', 124, NULL, NULL, 184382),
(184383, '1.20.920.10-FF-000154', NULL, 'Uncharacterized protein', 233, NULL, NULL, 184383),
(184384, '2.60.200.20-FF-000027', NULL, 'Peptide-binding protein', 134, NULL, NULL, 184384),
(184385, '1.10.10.920-FF-000001', NULL, 'Coproporphyrinogen-III oxidase', 93, NULL, NULL, 184385),
(184386, '3.40.930.10-FF-000058', NULL, NULL, 300, NULL, NULL, 184386),
(184387, '3.30.40.10-FF-000678', NULL, 'Os01g0535300 protein', 62, NULL, NULL, 184387),
(184388, '3.40.50.1820-FF-000729', NULL, 'Carboxylic ester hydrolase', 535, NULL, NULL, 184388),
(184389, '1.10.274.100-FF-000010', NULL, 'DNA-directed RNA polymerase subunit', 140, NULL, NULL, 184389),
(184390, '2.30.30.40-FF-000615', NULL, 'Probable serine/threonine-protein kinase mkcF', 53, NULL, NULL, 184390),
(184391, '1.20.1060.20-FF-000022', NULL, NULL, 111, NULL, NULL, 184391),
(184392, '3.40.50.150-FF-001798', NULL, NULL, 138, NULL, NULL, 184392),
(184393, '3.20.20.220-FF-000002', NULL, 'Methylenetetrahydrofolate reductase', 292, NULL, NULL, 184393),
(184394, '3.40.630.30-FF-000176', NULL, 'Putative succinyl-CoA transferase Rv0802c', 218, NULL, NULL, 184394),
(184395, '1.10.10.1200-FF-000001', NULL, 'Melanoma-associated antigen D1', 101, NULL, NULL, 184395),
(184396, '1.20.140.150-FF-000031', NULL, 'Voltage-dependent calcium channel gamma-1 subunit', 222, NULL, NULL, 184396),
(184397, '1.25.10.10-FF-000160', NULL, 'Cell differentiation protein', 272, NULL, NULL, 184397),
(184398, '1.25.40.20-FF-000552', NULL, 'Ankyrin repeat-containing protein ITN1 isoform A', 201, NULL, NULL, 184398),
(184399, '1.20.1070.10-FF-001913', NULL, 'Vomeronasal type-1 receptor', 285, NULL, NULL, 184399),
(184400, '2.60.120.620-FF-000063', NULL, 'Uncharacterized protein', 181, NULL, NULL, 184400),
(184401, '1.10.287.70-FF-000651', NULL, 'Uncharacterized protein', 160, NULL, NULL, 184401),
(184402, '3.40.50.300-FF-002175', NULL, 'ABC transporter G family member 9', 238, NULL, NULL, 184402),
(184403, '3.80.10.10-FF-003473', NULL, 'Uncharacterized protein', 211, NULL, NULL, 184403),
(184404, '3.40.30.10-FF-000334', NULL, 'Protein disulfide isomerase', 113, NULL, NULL, 184404);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(184405, '1.25.40.120-FF-000066', NULL, 'Uncharacterized protein', 201, NULL, NULL, 184405),
(184406, '3.40.30.10-FF-000278', NULL, 'Peroxiredoxin (Alkyl hydroperoxide reductase subunit C)', 197, NULL, NULL, 184406),
(184407, '1.25.40.10-FF-003893', NULL, 'Uncharacterized protein', 77, NULL, NULL, 184407),
(184408, '2.60.260.20-FF-000003', NULL, 'DnaJ subfamily A member 2', 83, NULL, NULL, 184408),
(184409, '2.30.29.30-FF-000598', NULL, 'Pleckstrin homology (PH) and lipid-binding START domains-containing protein', 119, NULL, NULL, 184409),
(184410, '2.60.40.1180-FF-000117', NULL, 'Cytoskeleton-associated protein CAP5.5, putative', 102, NULL, NULL, 184410),
(184411, '1.20.1740.10-FF-000077', NULL, 'Tpo5p', 471, NULL, NULL, 184411),
(184412, '3.30.70.330-FF-001728', NULL, NULL, 127, NULL, NULL, 184412),
(184413, '1.20.58.390-FF-000223', NULL, 'Predicted protein', 121, NULL, NULL, 184413),
(184414, '1.20.58.390-FF-000280', NULL, 'Uncharacterized protein', 60, NULL, NULL, 184414),
(184415, '3.30.60.30-FF-000163', NULL, 'Follistatin-related protein 5-like Protein', 50, NULL, NULL, 184415),
(184416, '3.90.70.10-FF-000020', NULL, 'ubiquitin carboxyl-terminal hydrolase 19 isoform X4', 206, NULL, NULL, 184416),
(184417, '3.20.20.120-FF-000028', NULL, 'Muconate cycloisomerase I', 263, NULL, NULL, 184417),
(184418, '3.30.420.40-FF-000081', NULL, 'Actin-related protein 10 homolog', 118, NULL, NULL, 184418),
(184419, '2.60.40.10-FF-002337', NULL, 'Beat protein', 102, NULL, NULL, 184419),
(184420, '2.60.40.10-FF-005737', NULL, NULL, 107, NULL, NULL, 184420),
(184421, '3.40.30.10-FF-001205', NULL, 'Uncharacterized protein', 57, NULL, NULL, 184421),
(184422, '3.30.60.20-FF-000160', NULL, 'Protein kinase C', 38, NULL, NULL, 184422),
(184423, '2.60.40.150-FF-000446', NULL, 'RAC family serine/threonine-protein kinase', 122, NULL, NULL, 184423),
(184424, '2.60.40.1180-FF-000174', NULL, 'Alpha-mannosidase', 97, NULL, NULL, 184424),
(184425, '2.40.70.10-FF-000204', NULL, 'Uncharacterized protein', 148, NULL, NULL, 184425),
(184426, '2.30.30.100-FF-000189', NULL, 'SnRNP core Sm protein Sm-X5-like protein', 65, NULL, NULL, 184426),
(184427, '1.25.40.540-FF-000017', NULL, 'Uncharacterized protein', 222, NULL, NULL, 184427),
(184428, '3.30.310.10-FF-000053', NULL, 'AP complex subunit beta', 133, NULL, NULL, 184428),
(184429, '1.20.1280.50-FF-000255', NULL, 'F-box protein At5g06550', 78, NULL, NULL, 184429),
(184430, '3.30.60.30-FF-000016', NULL, 'Agrin', 51, NULL, NULL, 184430),
(184431, '3.40.50.1000-FF-000551', NULL, NULL, 185, NULL, NULL, 184431),
(184432, '2.130.10.10-FF-002427', NULL, 'dmX-like protein 1', 254, NULL, NULL, 184432),
(184433, '3.90.1410.10-FF-000124', NULL, 'Uncharacterized protein', 61, NULL, NULL, 184433),
(184434, '1.10.1740.160-FF-000001', NULL, 'Phage portal', 91, NULL, NULL, 184434),
(184435, '3.30.1490.20-FF-000079', NULL, 'Tubulin tyrosine ligase, putative', 51, NULL, NULL, 184435),
(184436, '2.60.120.620-FF-000006', NULL, 'PKHD-type hydroxylase YbiX', 177, NULL, NULL, 184436),
(184437, '2.60.40.10-FF-001994', NULL, 'tyrosine-protein phosphatase 10D isoform X4', 96, NULL, NULL, 184437),
(184438, '3.30.590.20-FF-000014', NULL, 'Putative glutamate--cysteine ligase 2', 362, NULL, NULL, 184438),
(184439, '3.30.1600.10-FF-000018', NULL, 'NAD-dependent deacetylase, Sir2 family protein', 116, NULL, NULL, 184439),
(184440, '3.10.100.10-FF-000092', NULL, 'Polycystin 1 like 3, transient receptor potential channel interacting', 120, NULL, NULL, 184440),
(184441, '3.30.70.330-FF-001167', NULL, 'SAFB-like, transcription modulator', 177, NULL, NULL, 184441),
(184442, '2.60.120.920-FF-000091', NULL, 'Uncharacterized protein', 153, NULL, NULL, 184442),
(184443, '2.40.50.140-FF-000253', NULL, 'mRNA-capping enzyme subunit alpha', 164, NULL, NULL, 184443),
(184444, '3.40.50.300-FF-003012', NULL, 'Cdc42 homolog-like Protein', 186, NULL, NULL, 184444),
(184445, '1.10.287.950-FF-000033', NULL, 'Methyl-accepting chemotaxis transmembrane protein', 311, NULL, NULL, 184445),
(184446, '3.30.60.20-FF-000013', NULL, 'Diacylglycerol kinase', 53, NULL, NULL, 184446);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(184447, '2.30.30.40-FF-000054', NULL, 'Putative e3 ubiquitin-protein ligase mind-bomb', 90, NULL, NULL, 184447),
(184448, '3.30.2410.10-FF-000009', NULL, 'Probable E3 ubiquitin-protein ligase HECTD2', 121, NULL, NULL, 184448),
(184449, '1.20.1520.10-FF-000004', NULL, 'The ARF-like 2 binding protein BART, putative', 137, NULL, NULL, 184449),
(184450, '2.60.120.920-FF-000181', NULL, 'Uncharacterized protein', 195, NULL, NULL, 184450),
(184451, '3.40.30.10-FF-000952', NULL, 'Uncharacterized protein', 107, NULL, NULL, 184451),
(184452, '3.30.70.3490-FF-000002', NULL, 'Oxysterol-binding protein', 74, NULL, NULL, 184452),
(184453, '3.30.450.20-FF-000689', NULL, 'Hybrid signal transduction histidine kinase L', 147, NULL, NULL, 184453),
(184454, '1.25.40.10-FF-004202', NULL, 'Uncharacterized protein', 277, NULL, NULL, 184454),
(184455, '1.20.1070.10-FF-001442', NULL, 'Olfactory receptor F6', 223, NULL, NULL, 184455),
(184456, '1.10.10.10-FF-001845', NULL, 'Predicted protein', 123, NULL, NULL, 184456),
(184457, '1.20.120.790-FF-000005', NULL, 'Endoplasmin-like isoform B', 147, NULL, NULL, 184457),
(184458, '3.30.590.10-FF-000011', NULL, 'Glutamine synthetase', 271, NULL, NULL, 184458),
(184459, '2.30.30.30-FF-000051', NULL, '50S ribosomal protein L24', 105, NULL, NULL, 184459),
(184460, '3.30.70.330-FF-001818', NULL, NULL, 156, NULL, NULL, 184460),
(184461, '3.40.50.2000-FF-001059', NULL, 'Glycogen [starch] synthase', 108, NULL, NULL, 184461),
(184462, '2.60.40.1180-FF-000084', NULL, 'Alpha-L-arabinofuranosidase', 121, NULL, NULL, 184462),
(184463, '3.30.1300.10-FF-000001', NULL, 'Pantothenate synthetase', 103, NULL, NULL, 184463),
(184464, '2.20.70.10-FF-000160', NULL, 'Pre-mRNA-splicing factor cwc2', 42, NULL, NULL, 184464),
(184465, '1.10.10.10-FF-000395', NULL, 'GntR family transcriptional regulator', 74, NULL, NULL, 184465),
(184466, '3.20.20.80-FF-000765', NULL, 'Beta-glucosidase 32', 125, NULL, NULL, 184466),
(184467, '1.20.140.10-FF-000055', NULL, 'Acyl-CoA dehydrogenase FadE17', 166, NULL, NULL, 184467),
(184468, '3.60.21.10-FF-000161', NULL, 'Serine/threonine-protein phosphatase', 339, NULL, NULL, 184468),
(184469, '3.90.1480.20-FF-000019', NULL, 'Glycosyl transferase family 29 protein', 248, NULL, NULL, 184469),
(184470, '2.70.170.10-FF-000266', NULL, 'Predicted protein', 135, NULL, NULL, 184470),
(184471, '1.25.40.10-FF-003983', NULL, 'Uncharacterized protein', 218, NULL, NULL, 184471),
(184472, '3.20.20.70-FF-000762', NULL, NULL, 50, NULL, NULL, 184472),
(184473, '2.30.29.30-FF-001093', NULL, 'Phospholipase C gamma 1', 50, NULL, NULL, 184473),
(184474, '2.160.10.10-FF-000032', NULL, 'Fucose-1-phosphate guanylyltransferase', 78, NULL, NULL, 184474),
(184475, '2.40.70.10-FF-000114', NULL, 'Endopeptidase, putative', 215, NULL, NULL, 184475),
(184476, '3.30.60.30-FF-000073', NULL, 'Protein CBR-OST-1', 89, NULL, NULL, 184476),
(184477, '2.30.30.210-FF-000019', NULL, 'Ribonuclease P protein subunit p29', 106, NULL, NULL, 184477),
(184478, '1.25.40.10-FF-000307', NULL, 'Clathrin heavy chain', 339, NULL, NULL, 184478),
(184479, '2.60.40.150-FF-000356', NULL, 'SYT15 isoform 4', 112, NULL, NULL, 184479),
(184480, '3.90.260.10-FF-000012', NULL, 'XPC complex subunit, DNA damage recognition and repair factor', 179, NULL, NULL, 184480),
(184481, '3.90.180.10-FF-000011', NULL, 'Crotonyl-CoA carboxylase/reductase', 283, NULL, NULL, 184481),
(184482, '3.30.460.20-FF-000010', NULL, 'CorA family metal ion transporter', 164, NULL, NULL, 184482),
(184483, '2.40.20.10-FF-000111', NULL, 'Metalloendopeptidase', 120, NULL, NULL, 184483),
(184484, '3.40.50.300-FF-006446', NULL, 'Interferon gamma-inducible protein 47', 124, NULL, NULL, 184484),
(184485, '3.40.50.720-FF-002559', NULL, 'Siroheme biosynthesis protein met8', 48, NULL, NULL, 184485),
(184486, '3.30.420.40-FF-000457', NULL, 'actin-related protein 3 isoform X1', 74, NULL, NULL, 184486),
(184487, '1.20.1070.10-FF-000458', NULL, 'G protein-coupled receptor 150', 355, NULL, NULL, 184487),
(184488, '2.40.50.140-FF-001276', NULL, NULL, 150, NULL, NULL, 184488);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(184489, '1.20.1310.10-FF-000202', NULL, NULL, 112, NULL, NULL, 184489),
(184490, '3.10.100.10-FF-000209', NULL, NULL, 134, NULL, NULL, 184490),
(184491, '3.30.160.110-FF-000002', NULL, 'spermine synthase', 114, NULL, NULL, 184491),
(184492, '1.20.58.1100-FF-000002', NULL, 'Unc-13, isoform C', 156, NULL, NULL, 184492),
(184493, '3.30.160.60-FF-000600', NULL, 'PLAG1 like zinc finger 2', 30, NULL, NULL, 184493),
(184494, '2.110.10.10-FF-000034', NULL, 'Stromelysin-1-like Protein', 190, NULL, NULL, 184494),
(184495, '3.10.450.230-FF-000002', NULL, 'Protein virB8', 148, NULL, NULL, 184495),
(184496, '1.20.810.10-FF-000027', NULL, 'Cytochrome b6', 198, NULL, NULL, 184496),
(184497, '1.10.238.10-FF-000520', NULL, 'N-terminal EF-hand calcium-binding protein 3 isoform X2', 74, NULL, NULL, 184497),
(184498, '2.60.40.10-FF-004315', NULL, NULL, 98, NULL, NULL, 184498),
(184499, '3.30.160.20-FF-000049', NULL, 'Uncharacterized protein, isoform I', 68, NULL, NULL, 184499),
(184500, '1.10.3080.10-FF-000057', NULL, 'Chloride channel protein', 80, NULL, NULL, 184500),
(184501, '1.25.40.20-FF-000872', NULL, 'Uncharacterized protein', 94, NULL, NULL, 184501),
(184502, '1.10.510.10-FF-000541', NULL, 'CMGC/SRPK protein kinase', 72, NULL, NULL, 184502),
(184503, '2.130.10.10-FF-005867', NULL, 'Uncharacterized protein', 309, NULL, NULL, 184503),
(184504, '1.20.1310.10-FF-000140', NULL, NULL, 146, NULL, NULL, 184504),
(184505, '3.30.230.130-FF-000031', NULL, 'Cullin', 167, NULL, NULL, 184505),
(184506, '1.25.10.10-FF-000362', NULL, 'Importin 11, putative', 1017, NULL, NULL, 184506),
(184507, '3.40.50.300-FF-002607', NULL, 'Nicotinamide riboside kinase 1', 219, NULL, NULL, 184507),
(184508, '1.10.10.10-FF-001766', NULL, 'Uncharacterized protein', 86, NULL, NULL, 184508),
(184509, '1.10.150.80-FF-000033', NULL, 'ATP-dependent DNA helicase RecQ', 82, NULL, NULL, 184509),
(184510, '3.40.630.30-FF-000266', NULL, 'Protein N-acetyltransferase, RimJ/RimL family', 176, NULL, NULL, 184510),
(184511, '3.30.950.30-FF-000005', NULL, 'Uncharacterized protein', 135, NULL, NULL, 184511),
(184512, '3.10.20.90-FF-000235', NULL, 'Autophagy-related protein', 117, NULL, NULL, 184512),
(184513, '3.10.450.240-FF-000005', NULL, 'Mitochondrial import inner membrane translocase subunit TIM44-2', 189, NULL, NULL, 184513),
(184514, '1.50.40.10-FF-000193', NULL, 'Related to peroxisomal membrane protein PMP47B', 111, NULL, NULL, 184514),
(184515, '1.25.10.10-FF-001885', NULL, 'MMS19 homolog, cytosolic iron-sulfur assembly component', 363, NULL, NULL, 184515),
(184516, '1.20.120.1080-FF-000083', NULL, 'GM13326', 103, NULL, NULL, 184516),
(184517, '2.130.10.10-FF-004344', NULL, 'Predicted protein', 97, NULL, NULL, 184517),
(184518, '2.40.20.10-FF-000105', NULL, 'Uncharacterized protein', 91, NULL, NULL, 184518),
(184519, '2.130.10.10-FF-003681', NULL, 'WD repeat protein, putative', 155, NULL, NULL, 184519),
(184520, '2.170.270.10-FF-000227', NULL, 'Histone-lysine N-methyltransferase', 94, NULL, NULL, 184520),
(184521, '1.20.1070.10-FF-000896', NULL, 'Protein CBR-SER-2', 275, NULL, NULL, 184521),
(184522, '3.40.630.10-FF-000260', NULL, 'Uncharacterized protein', 120, NULL, NULL, 184522),
(184523, '3.30.450.190-FF-000002', NULL, 'Ras-related GTP-binding protein A', 129, NULL, NULL, 184523),
(184524, '1.10.10.10-FF-000243', NULL, 'Ethanolamine utilization microcompartment protein EutK', 60, NULL, NULL, 184524),
(184525, '1.20.1560.10-FF-000866', NULL, 'Uncharacterized protein', 159, NULL, NULL, 184525),
(184526, '1.20.5.690-FF-000010', NULL, 'Importin subunit alpha', 42, NULL, NULL, 184526),
(184527, '3.60.40.10-FF-000087', NULL, 'Type 2C protein phosphatase', 375, NULL, NULL, 184527),
(184528, '3.40.50.300-FF-001944', NULL, 'DEAD box helicase', 263, NULL, NULL, 184528),
(184529, '2.60.120.10-FF-000277', NULL, 'Lysophospholipase NTE1', 120, NULL, NULL, 184529),
(184530, '1.20.58.60-FF-000839', NULL, 'Uncharacterized protein', 151, NULL, NULL, 184530),
(184531, '3.60.21.10-FF-000402', NULL, 'Sphingomyelinase phosphodiesterase', 305, NULL, NULL, 184531);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(184532, '3.30.160.60-FF-004815', NULL, NULL, 40, NULL, NULL, 184532),
(184533, '2.60.40.2240-FF-000003', NULL, 'Protein CBG04103', 126, NULL, NULL, 184533),
(184534, '3.40.50.1820-FF-000943', NULL, 'Predicted protein', 311, NULL, NULL, 184534),
(184535, '1.20.140.150-FF-000115', NULL, 'Uncharacterized protein', 127, NULL, NULL, 184535),
(184536, '3.30.40.10-FF-002387', NULL, 'Predicted protein', 70, NULL, NULL, 184536),
(184537, '1.25.40.20-FF-000821', NULL, 'Expressed protein', 144, NULL, NULL, 184537),
(184538, '3.90.740.10-FF-000004', NULL, 'Valine--tRNA ligase', 102, NULL, NULL, 184538),
(184539, '1.10.560.10-FF-000038', NULL, 'Chaperonin containing TCP1 subunit 6B', 117, NULL, NULL, 184539),
(184540, '1.10.510.10-FF-002665', NULL, NULL, 109, NULL, NULL, 184540),
(184541, '2.60.40.1120-FF-000061', NULL, 'Nodal modulator 3', 75, NULL, NULL, 184541),
(184542, '3.90.70.10-FF-000290', NULL, 'Cathepsin W', 171, NULL, NULL, 184542),
(184543, '3.90.1570.30-FF-000001', NULL, 'Type I restriction enzyme EcoKI subunit R', 123, NULL, NULL, 184543),
(184544, '1.10.472.170-FF-000002', NULL, 'Transcription initiation factor IIB', 189, NULL, NULL, 184544),
(184545, '2.40.50.140-FF-001181', NULL, NULL, 31, NULL, NULL, 184545),
(184546, '1.10.472.10-FF-000108', NULL, 'Cyclin-dependent protein kinase regulator, putative', 150, NULL, NULL, 184546),
(184547, '3.30.110.10-FF-000009', NULL, 'Translation initiation factor IF-3', 101, NULL, NULL, 184547),
(184548, '3.40.50.720-FF-001660', NULL, 'Glyoxylate/hydroxypyruvate reductase, putative', 60, NULL, NULL, 184548),
(184549, '2.60.40.10-FF-004366', NULL, NULL, 91, NULL, NULL, 184549),
(184550, '1.10.540.10-FF-000076', NULL, 'Related to Acyl-CoA dehydrogenase', 119, NULL, NULL, 184550),
(184551, '2.40.30.10-FF-000084', NULL, 'GTP-binding elongation factor Tu family', 87, NULL, NULL, 184551),
(184552, '3.40.190.80-FF-000089', NULL, 'Inositol-1-monophosphatase', 97, NULL, NULL, 184552),
(184553, '2.130.10.10-FF-003355', NULL, 'Vacuolar assembly protein vps41, putative', 231, NULL, NULL, 184553),
(184554, '3.40.50.140-FF-000007', NULL, 'DNA topoisomerase', 165, NULL, NULL, 184554),
(184555, '3.30.565.10-FF-000065', NULL, '[Pyruvate dehydrogenase (Acetyl-transferring)] kinase mitochondrial', 179, NULL, NULL, 184555),
(184556, '2.40.100.10-FF-000033', NULL, 'Peptidyl-prolyl cis-trans isomerase', 186, NULL, NULL, 184556),
(184557, '3.30.70.20-FF-000008', NULL, 'Respiratory nitrate reductase beta subunit', 122, NULL, NULL, 184557),
(184558, '1.20.1070.10-FF-000958', NULL, 'Predicted protein', 80, NULL, NULL, 184558),
(184559, '1.10.10.980-FF-000007', NULL, 'CST complex subunit STN1', 101, NULL, NULL, 184559),
(184560, '1.10.10.10-FF-000305', NULL, 'Transcriptional regulator, PadR family', 103, NULL, NULL, 184560),
(184561, '3.40.50.720-FF-000878', NULL, 'Oxidoreductase, short-chain dehydrogenase/reductase family', 248, NULL, NULL, 184561),
(184562, '1.10.287.110-FF-000045', NULL, 'Molecular chaperone DnaJ', 131, NULL, NULL, 184562),
(184563, '1.10.1370.30-FF-000023', NULL, 'Angiotensin-converting enzyme', 206, NULL, NULL, 184563),
(184564, '1.10.510.10-FF-003767', NULL, NULL, 139, NULL, NULL, 184564),
(184565, '3.90.190.10-FF-000158', NULL, 'Tyrosine phosphatase', 391, NULL, NULL, 184565),
(184566, '1.10.472.10-FF-000434', NULL, 'Cyclin-D5-1', 130, NULL, NULL, 184566),
(184567, '3.40.50.1820-FF-001606', NULL, 'Gsl3760 protein', 76, NULL, NULL, 184567),
(184568, '3.10.110.10-FF-000300', NULL, 'Uncharacterized protein', 99, NULL, NULL, 184568),
(184569, '3.80.10.10-FF-001764', NULL, 'Toll-like receptor 19', 184, NULL, NULL, 184569),
(184570, '1.25.10.10-FF-002109', NULL, 'HEAT repeat-containing protein 1', 262, NULL, NULL, 184570),
(184571, '1.10.1600.10-FF-000013', NULL, 'Uncharacterized protein', 91, NULL, NULL, 184571),
(184572, '3.40.50.10190-FF-000249', NULL, 'Uncharacterized protein', 94, NULL, NULL, 184572),
(184573, '3.30.160.60-FF-006002', NULL, NULL, 41, NULL, NULL, 184573),
(184574, '1.25.10.10-FF-002340', NULL, 'Uncharacterized protein', 292, NULL, NULL, 184574);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(184575, '1.10.10.440-FF-000020', NULL, 'Pre-mRNA-processing protein 40C', 61, NULL, NULL, 184575),
(184576, '3.40.50.300-FF-008009', NULL, 'Dynein heavy chain family protein', 144, NULL, NULL, 184576),
(184577, '1.10.1650.20-FF-000002', NULL, 'Ribonucleoside-diphosphate reductase', 53, NULL, NULL, 184577),
(184578, '3.30.70.1230-FF-000246', NULL, 'Predicted protein', 236, NULL, NULL, 184578),
(184579, '1.10.30.10-FF-000194', NULL, 'Putative high mobility group B protein 11', 68, NULL, NULL, 184579),
(184580, '4.10.70.10-FF-000009', NULL, NULL, 23, NULL, NULL, 184580),
(184581, '1.10.10.10-FF-002008', NULL, 'Uncharacterized protein', 120, NULL, NULL, 184581),
(184582, '3.30.160.60-FF-005485', NULL, NULL, 41, NULL, NULL, 184582),
(184583, '1.10.510.10-FF-002570', NULL, NULL, 249, NULL, NULL, 184583),
(184584, '1.10.1000.11-FF-000002', NULL, 'Cytohesin 1', 123, NULL, NULL, 184584),
(184585, '1.20.1640.10-FF-000007', NULL, 'Protein patched homolog 1', 187, NULL, NULL, 184585),
(184586, '2.60.120.380-FF-000097', NULL, 'Uncharacterized protein', 135, NULL, NULL, 184586),
(184587, '2.30.30.40-FF-000233', NULL, 'NADPH oxidase organizer 1', 53, NULL, NULL, 184587),
(184588, '1.10.3460.10-FF-000041', NULL, 'Uncharacterized protein', 219, NULL, NULL, 184588),
(184589, '3.40.1370.10-FF-000036', NULL, 'Uncharacterized protein', 189, NULL, NULL, 184589),
(184590, '3.30.390.110-FF-000014', NULL, 'LRRGT00107', 67, NULL, NULL, 184590),
(184591, '2.170.8.10-FF-000003', NULL, 'Phosphoenolpyruvate carboxykinase [GTP]', 108, NULL, NULL, 184591),
(184592, '2.40.10.10-FF-000554', NULL, NULL, 74, NULL, NULL, 184592),
(184593, '2.10.220.10-FF-000127', NULL, 'Tyrosine-protein kinase receptor', 71, NULL, NULL, 184593),
(184594, '1.20.120.730-FF-000015', NULL, 'Protein transport protein Sec24C, putative', 150, NULL, NULL, 184594),
(184595, '3.30.40.10-FF-001931', NULL, 'Predicted protein', 70, NULL, NULL, 184595),
(184596, '3.90.550.50-FF-000046', NULL, 'Hexosyltransferase', 220, NULL, NULL, 184596),
(184597, '3.40.1090.10-FF-000054', NULL, 'Triacylglycerol lipase SDP1L', 181, NULL, NULL, 184597),
(184598, '3.40.50.150-FF-000550', NULL, 'Conserved hypothetical alanine,valine and glycine rich protein', 202, NULL, NULL, 184598),
(184599, '2.30.110.10-FF-000081', NULL, 'Cellular repressor of E1A stimulated genes 1', 147, NULL, NULL, 184599),
(184600, '3.40.50.300-FF-008240', NULL, 'Uncharacterized protein', 55, NULL, NULL, 184600),
(184601, '3.80.10.10-FF-001343', NULL, 'Dynein assembly factor 1', 133, NULL, NULL, 184601),
(184602, '3.40.50.2300-FF-001262', NULL, NULL, 11, NULL, NULL, 184602),
(184603, '3.80.10.10-FF-003063', NULL, 'Predicted protein', 143, NULL, NULL, 184603),
(184604, '2.130.10.10-FF-001438', NULL, 'Receptor of-activated protein C kinase 1', 209, NULL, NULL, 184604),
(184605, '3.80.10.10-FF-000887', NULL, 'NLR family pyrin domain containing 11', 151, NULL, NULL, 184605),
(184606, '3.30.200.20-FF-001391', NULL, NULL, 106, NULL, NULL, 184606),
(184607, '3.40.50.1000-FF-000282', NULL, 'TFIIF-stimulated CTD phosphatase, putative', 191, NULL, NULL, 184607),
(184608, '1.10.238.10-FF-000227', NULL, 'Rab11 family-interacting protein 3', 63, NULL, NULL, 184608),
(184609, '3.40.630.30-FF-000592', NULL, 'Uncharacterized protein', 86, NULL, NULL, 184609),
(184610, '2.40.50.100-FF-000123', NULL, 'Exosome complex component CSL4', 51, NULL, NULL, 184610),
(184611, '1.20.144.10-FF-000120', NULL, 'PAP2 superfamily protein', 192, NULL, NULL, 184611),
(184612, '1.10.510.10-FF-000327', NULL, 'Mitogen-activated protein kinase kinase kinase 8', 182, NULL, NULL, 184612),
(184613, '1.10.730.20-FF-000021', NULL, 'Isoleucine--tRNA ligase, mitochondrial', 301, NULL, NULL, 184613),
(184614, '3.30.70.330-FF-001813', NULL, NULL, 84, NULL, NULL, 184614),
(184615, '1.20.1050.10-FF-000041', NULL, 'Lambda class glutathione S-transferase', 132, NULL, NULL, 184615),
(184616, '3.40.630.30-FF-000524', NULL, 'Acyl-CoA N-acyltransferase with RING/FYVE/PHD-type zinc finger protein', 99, NULL, NULL, 184616),
(184617, '3.40.970.10-FF-000004', NULL, 'Ribonuclease H', 52, NULL, NULL, 184617);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(184618, '3.40.50.1240-FF-000123', NULL, 'Uncharacterized protein', 223, NULL, NULL, 184618),
(184619, '1.25.40.20-FF-000142', NULL, 'Ankyrin repeat and FYVE domain containing 1', 165, NULL, NULL, 184619),
(184620, '3.40.50.150-FF-000336', NULL, 'Protein-lysine N-methyltransferase PGSY75_0916600', 199, NULL, NULL, 184620),
(184621, '3.40.50.150-FF-000224', NULL, 'S-adenosyl-L-methionine-dependent methyltransferases superfamily protein', 192, NULL, NULL, 184621),
(184622, '1.20.1070.10-FF-001801', NULL, 'Uncharacterized protein', 316, NULL, NULL, 184622),
(184623, '1.10.3210.10-FF-000118', NULL, 'Uncharacterized protein', 83, NULL, NULL, 184623),
(184624, '3.40.50.360-FF-000074', NULL, 'Sulfite reductase [NADPH] flavoprotein alpha-component', 162, NULL, NULL, 184624),
(184625, '3.40.190.10-FF-000967', NULL, 'Oligopeptide ABC transporter, periplasmic oligopeptide-binding protein', 231, NULL, NULL, 184625),
(184626, '3.60.10.10-FF-000259', NULL, 'Predicted protein', 227, NULL, NULL, 184626),
(184627, '3.40.190.80-FF-000038', NULL, 'Inositol monophosphatase family protein', 99, NULL, NULL, 184627),
(184628, '3.90.1420.10-FF-000007', NULL, 'SET domain containing protein', 154, NULL, NULL, 184628),
(184629, '3.10.250.10-FF-000035', NULL, 'Lysyl oxidase-like 2', 111, NULL, NULL, 184629),
(184630, '3.40.190.290-FF-000110', NULL, 'Transcriptional regulator lysR family', 208, NULL, NULL, 184630),
(184631, '3.30.70.330-FF-001734', NULL, NULL, 118, NULL, NULL, 184631),
(184632, '2.60.120.10-FF-000226', NULL, 'DNA-binding transcriptional activator YeiL', 195, NULL, NULL, 184632),
(184633, '3.40.50.300-FF-003861', NULL, 'AAA family ATPase', 187, NULL, NULL, 184633),
(184634, '3.40.50.10420-FF-000009', NULL, '5-formyltetrahydrofolate cyclo-ligase', 199, NULL, NULL, 184634),
(184635, '1.10.3720.10-FF-000202', NULL, 'ABC transporter permease protein', 193, NULL, NULL, 184635),
(184636, '3.30.830.10-FF-000165', NULL, 'Uncharacterized protein', 224, NULL, NULL, 184636),
(184637, '3.30.365.10-FF-000016', NULL, 'Xanthine dehydrogenase yagR molybdenum-binding subunit', 143, NULL, NULL, 184637),
(184638, '3.40.50.1100-FF-000047', NULL, 'Threonine synthase like 2', 231, NULL, NULL, 184638),
(184639, '2.40.33.10-FF-000023', NULL, 'Pyruvate kinase PKM', 103, NULL, NULL, 184639),
(184640, '3.30.450.40-FF-000015', NULL, 'Phosphodiesterase', 207, NULL, NULL, 184640),
(184641, '1.10.132.20-FF-000007', NULL, 'Ribosome recycling factor, putative', 92, NULL, NULL, 184641),
(184642, '2.40.70.10-FF-000316', NULL, NULL, 178, NULL, NULL, 184642),
(184643, '2.130.10.10-FF-005479', NULL, 'Uncharacterized protein', 142, NULL, NULL, 184643),
(184644, '3.30.160.60-FF-004136', NULL, NULL, 36, NULL, NULL, 184644),
(184645, '3.30.200.20-FF-002380', NULL, 'Protein kinase C', 46, NULL, NULL, 184645),
(184646, '1.10.510.10-FF-001676', NULL, 'Serine/threonine-protein kinase NEK', 225, NULL, NULL, 184646),
(184647, '1.10.533.10-FF-000138', NULL, 'Interleukin-1 receptor-associated kinase 4', 113, NULL, NULL, 184647),
(184648, '3.50.50.60-FF-001468', NULL, 'Amine oxidase', 65, NULL, NULL, 184648),
(184649, '3.30.450.30-FF-000012', NULL, 'Dynein light chain 2B, cytoplasmic', 106, NULL, NULL, 184649),
(184650, '1.10.132.10-FF-000004', NULL, 'Topoisomerase I', 194, NULL, NULL, 184650),
(184651, '3.40.50.1440-FF-000065', NULL, 'Tubulin-like protein CetZ', 353, NULL, NULL, 184651),
(184652, '1.10.10.10-FF-000631', NULL, 'Interferon regulatory factor 7', 103, NULL, NULL, 184652),
(184653, '3.30.420.40-FF-000513', NULL, 'Glycerol kinase-like protein 1', 257, NULL, NULL, 184653),
(184654, '1.25.40.10-FF-004028', NULL, 'Uncharacterized protein', 186, NULL, NULL, 184654),
(184655, '3.30.70.1620-FF-000009', NULL, 'Structural maintenance of chromosomes protein', 99, NULL, NULL, 184655),
(184656, '2.40.30.10-FF-000196', NULL, 'Elongation factor 1-alpha, putative', 85, NULL, NULL, 184656),
(184657, '3.40.50.1010-FF-000234', NULL, NULL, 209, NULL, NULL, 184657),
(184658, '3.40.50.1100-FF-000109', NULL, 'Cysteine synthase B (CysM)', 96, NULL, NULL, 184658);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(184659, '3.30.200.20-FF-001486', NULL, 'Probable serine/threonine-protein kinase pkgA', 82, NULL, NULL, 184659),
(184660, '1.25.40.20-FF-000193', NULL, 'Ankyrin repeat and SOCS box containing 4', 159, NULL, NULL, 184660),
(184661, '1.25.50.20-FF-000086', NULL, 'Uncharacterized protein', 323, NULL, NULL, 184661),
(184662, '2.130.10.10-FF-002253', NULL, 'Uncharacterized protein', 215, NULL, NULL, 184662),
(184663, '3.30.420.40-FF-000255', NULL, 'Glycerol kinase', 254, NULL, NULL, 184663),
(184664, '1.10.630.10-FF-000488', NULL, 'Uncharacterized protein', 469, NULL, NULL, 184664),
(184665, '2.40.37.10-FF-000003', NULL, 'Diaminopimelate decarboxylase', 150, NULL, NULL, 184665),
(184666, '1.10.510.10-FF-001788', NULL, 'STE/STE20/FRAY protein kinase', 243, NULL, NULL, 184666),
(184667, '3.30.1360.120-FF-000004', NULL, 'Aminomethyltransferase', 146, NULL, NULL, 184667),
(184668, '3.40.50.150-FF-000275', NULL, 'DNA (cytosine-5)-methyltransferase 3-like', 208, NULL, NULL, 184668),
(184669, '3.40.640.10-FF-000232', NULL, 'Adenosylmethionine-8-amino-7-oxononanoate transaminase', 277, NULL, NULL, 184669),
(184670, '3.40.50.2300-FF-001357', NULL, NULL, 27, NULL, NULL, 184670),
(184671, '1.20.1250.20-FF-001902', NULL, 'Uncharacterized protein', 47, NULL, NULL, 184671),
(184672, '2.40.37.20-FF-000006', NULL, 'D-threo-3-hydroxyaspartate dehydratase', 136, NULL, NULL, 184672),
(184673, '3.40.50.720-FF-000766', NULL, 'Putative short chain oxidoreductase', 232, NULL, NULL, 184673),
(184674, '3.40.50.1820-FF-001718', NULL, 'Predicted protein', 135, NULL, NULL, 184674),
(184675, '1.20.58.1480-FF-000003', NULL, 'Lon protease homolog, mitochondrial', 129, NULL, NULL, 184675),
(184676, '1.10.472.10-FF-000322', NULL, 'Uncharacterized protein', 85, NULL, NULL, 184676),
(184677, '2.40.100.10-FF-000145', NULL, 'Peptidyl-prolyl cis-trans isomerase-like Protein', 178, NULL, NULL, 184677),
(184678, '3.30.70.260-FF-000084', NULL, 'ACT domain-containing protein', 86, NULL, NULL, 184678),
(184679, '3.30.160.60-FF-002045', NULL, 'Zinc finger protein 1079', 31, NULL, NULL, 184679),
(184680, '3.30.830.10-FF-000114', NULL, 'Insulinase, putative', 211, NULL, NULL, 184680),
(184681, '3.60.21.10-FF-000453', NULL, '5''-nucleotidase', 361, NULL, NULL, 184681),
(184682, '1.25.40.10-FF-000190', NULL, 'Transmembrane and TPR repeat-containing protein 2', 136, NULL, NULL, 184682),
(184683, '3.30.70.370-FF-000032', NULL, NULL, 50, NULL, NULL, 184683),
(184684, '1.10.1900.10-FF-000007', NULL, 'Polyadenylate-binding protein', 89, NULL, NULL, 184684),
(184685, '3.30.450.50-FF-000018', NULL, 'Vesicle-trafficking protein SEC22b', 134, NULL, NULL, 184685),
(184686, '3.40.630.40-FF-000010', NULL, 'N-acetylmuramoyl-L-alanine amidase', 180, NULL, NULL, 184686),
(184687, '3.40.50.1000-FF-000231', NULL, 'Polynucleotide kinase', 145, NULL, NULL, 184687),
(184688, '1.20.58.340-FF-000085', NULL, 'Os04g0501100 protein', 90, NULL, NULL, 184688),
(184689, '3.30.1360.110-FF-000001', NULL, 'Phosphonoacetate hydrolase', 111, NULL, NULL, 184689),
(184690, '2.60.40.10-FF-001674', NULL, 'titin isoform X1', 94, NULL, NULL, 184690),
(184691, '3.30.50.10-FF-000010', NULL, 'Peroxisome proliferator-activated receptor gamma', 93, NULL, NULL, 184691),
(184692, '3.40.50.300-FF-000258', NULL, 'Ribulose bisphosphate carboxylase/oxygenase activase, chloroplastic', 185, NULL, NULL, 184692),
(184693, '3.30.565.10-FF-000391', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', 163, NULL, NULL, 184693),
(184694, '1.20.5.110-FF-000325', NULL, 'Syntaxin', 106, NULL, NULL, 184694),
(184695, '3.90.550.10-FF-000293', NULL, 'Glycosyltransferase-like protein, family 2', 181, NULL, NULL, 184695),
(184696, '3.40.50.1820-FF-001511', NULL, 'Carboxylic ester hydrolase', 152, NULL, NULL, 184696),
(184697, '1.10.10.440-FF-000071', NULL, 'Uncharacterized protein', 71, NULL, NULL, 184697),
(184698, '4.10.400.10-FF-000206', NULL, 'Sortilin-related receptor', 45, NULL, NULL, 184698),
(184699, '3.40.50.1000-FF-000017', NULL, 'Calcium-transporting ATPase', 153, NULL, NULL, 184699);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(184700, '3.30.160.60-FF-005597', NULL, NULL, 28, NULL, NULL, 184700),
(184701, '3.30.70.330-FF-003084', NULL, NULL, 108, NULL, NULL, 184701),
(184702, '2.60.40.10-FF-000325', NULL, 'kalirin isoform X1', 102, NULL, NULL, 184702),
(184703, '1.25.40.10-FF-003691', NULL, 'Tetratricopeptide repeat protein 21 homolog', 175, NULL, NULL, 184703),
(184704, '1.10.10.10-FF-000417', NULL, 'Transcriptional regulator, MarR family', 63, NULL, NULL, 184704),
(184705, '2.130.10.10-FF-005693', NULL, 'GPI inositol-deacylase', 153, NULL, NULL, 184705),
(184706, '1.20.5.190-FF-000017', NULL, 'unconventional myosin-Ic isoform X1', 52, NULL, NULL, 184706),
(184707, '2.70.40.10-FF-000010', NULL, 'DeoxyUTP pyrophosphatase', 147, NULL, NULL, 184707),
(184708, '3.40.532.10-FF-000032', NULL, NULL, 116, NULL, NULL, 184708),
(184709, '2.40.440.10-FF-000024', NULL, 'Peptidoglycan L,D-transpeptidase, YkuD family, LysM domain-containing', 141, NULL, NULL, 184709),
(184710, '1.20.58.1780-FF-000003', NULL, 'Non-repetitive nucleoporin, putative', 301, NULL, NULL, 184710),
(184711, '1.25.40.800-FF-000017', NULL, 'Uncharacterized protein', 39, NULL, NULL, 184711),
(184712, '3.30.200.20-FF-000997', NULL, 'NEK (NEver in mitosis Kinase) Like', 93, NULL, NULL, 184712),
(184713, '3.90.1290.10-FF-000007', NULL, 'microtubule-actin cross-linking factor 1 isoform X6', 175, NULL, NULL, 184713),
(184714, '3.40.605.10-FF-000128', NULL, 'Aldehyde dehydrogenase, putative', 32, NULL, NULL, 184714),
(184715, '3.40.1280.30-FF-000035', NULL, 'Uncharacterized protein', 137, NULL, NULL, 184715),
(184716, '2.40.240.10-FF-000043', NULL, '50S ribosomal protein L25', 100, NULL, NULL, 184716),
(184717, '3.30.360.10-FF-000095', NULL, 'Uncharacterized protein', 94, NULL, NULL, 184717),
(184718, '1.10.10.520-FF-000004', NULL, 'SUMO-activating enzyme subunit', 210, NULL, NULL, 184718),
(184719, '2.60.40.1510-FF-000020', NULL, 'Integrin subunit alpha E', 139, NULL, NULL, 184719),
(184720, '3.80.10.10-FF-001438', NULL, 'Uncharacterized protein', 166, NULL, NULL, 184720),
(184721, '2.20.25.530-FF-000017', NULL, 'Uncharacterized protein', 50, NULL, NULL, 184721),
(184722, '3.30.70.2030-FF-000003', NULL, 'N-acetylmuramoyl-L-alanine amidase', 84, NULL, NULL, 184722),
(184723, '2.40.160.210-FF-000014', NULL, 'Acyl-CoA thioesterase II', 283, NULL, NULL, 184723),
(184724, '3.80.10.10-FF-000949', NULL, 'Protein phosphatase type 1 regulator-like protein', 123, NULL, NULL, 184724),
(184725, '2.40.160.10-FF-000042', NULL, 'Mitochondrial outer membrane protein porin 1', 108, NULL, NULL, 184725),
(184726, '1.20.1310.20-FF-000031', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 300, NULL, NULL, 184726),
(184727, '2.40.30.10-FF-000145', NULL, 'NADPH-dependent diflavin oxidoreductase 1', 91, NULL, NULL, 184727),
(184728, '2.60.40.1530-FF-000026', NULL, NULL, 74, NULL, NULL, 184728),
(184729, '3.30.450.20-FF-000268', NULL, 'Uncharacterized protein', 113, NULL, NULL, 184729),
(184730, '2.60.120.620-FF-000091', NULL, 'Uncharacterized protein', 225, NULL, NULL, 184730),
(184731, '3.40.1800.20-FF-000017', NULL, 'GG18045', 75, NULL, NULL, 184731),
(184732, '2.40.30.10-FF-000437', NULL, 'Uncharacterized protein', 83, NULL, NULL, 184732),
(184733, '1.10.510.10-FF-000653', NULL, 'Non-specific serine/threonine protein kinase', 289, NULL, NULL, 184733),
(184734, '3.30.200.20-FF-001065', NULL, 'Predicted protein', 96, NULL, NULL, 184734),
(184735, '2.30.30.40-FF-000407', NULL, 'Related to YSC84-protein involved in the organization of actin cytoskeleton', 69, NULL, NULL, 184735),
(184736, '3.40.50.300-FF-001101', NULL, '6-phosphofructo-2-kinase 1', 213, NULL, NULL, 184736),
(184737, '2.130.10.10-FF-004232', NULL, 'Uncharacterized protein', 145, NULL, NULL, 184737),
(184738, '3.80.10.10-FF-003681', NULL, 'Predicted protein', 190, NULL, NULL, 184738),
(184739, '2.130.10.10-FF-005979', NULL, 'Uncharacterized protein', 234, NULL, NULL, 184739),
(184740, '3.30.457.60-FF-000008', NULL, 'Spindle assembly checkpoint component MAD1', 75, NULL, NULL, 184740),
(184741, '3.30.505.10-FF-000117', NULL, 'Non-specific protein-tyrosine kinase', 113, NULL, NULL, 184741);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(184742, '3.40.50.720-FF-001721', NULL, '6-phosphogluconate dehydrogenase, decarboxylating', 176, NULL, NULL, 184742),
(184743, '1.10.540.10-FF-000155', NULL, 'Uncharacterized protein', 88, NULL, NULL, 184743),
(184744, '3.30.200.20-FF-002503', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 4-like Protein', 118, NULL, NULL, 184744),
(184745, '1.10.10.60-FF-000617', NULL, 'ISPsy13, transposase OrfA', 75, NULL, NULL, 184745),
(184746, '2.10.25.10-FF-000663', NULL, 'Dumpy, isoform Z', 41, NULL, NULL, 184746),
(184747, '1.20.1250.20-FF-000885', NULL, 'MFS transporter, putative', 189, NULL, NULL, 184747),
(184748, '2.130.10.10-FF-003855', NULL, 'Ribosome biogenesis protein WDR12 homolog', 287, NULL, NULL, 184748),
(184749, '1.10.510.10-FF-004290', NULL, NULL, 166, NULL, NULL, 184749),
(184750, '3.40.50.300-FF-005659', NULL, 'Leucine-rich repeat and guanylate kinase domain-containing protein', 206, NULL, NULL, 184750),
(184751, '1.10.238.10-FF-000727', NULL, 'GM15808', 106, NULL, NULL, 184751),
(184752, '1.10.238.10-FF-000441', NULL, 'Myosin light chain 2', 66, NULL, NULL, 184752),
(184753, '2.130.10.10-FF-000078', NULL, 'DDB1- and CUL4-associated factor 6 isoform X1', 281, NULL, NULL, 184753),
(184754, '3.30.160.60-FF-005838', NULL, NULL, 88, NULL, NULL, 184754),
(184755, '3.20.70.20-FF-000037', NULL, 'Vitamin B12-dependent ribonucleotide reductase', 152, NULL, NULL, 184755),
(184756, '1.20.5.390-FF-000010', NULL, 'Optineurin', 67, NULL, NULL, 184756),
(184757, '1.10.30.10-FF-000126', NULL, 'Uncharacterized protein', 98, NULL, NULL, 184757),
(184758, '3.30.70.330-FF-001408', NULL, NULL, 60, NULL, NULL, 184758),
(184759, '3.30.160.60-FF-004703', NULL, NULL, 26, NULL, NULL, 184759),
(184760, '2.40.50.100-FF-000062', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 90, NULL, NULL, 184760),
(184761, '1.20.1250.20-FF-001161', NULL, 'MFS quinate transporter, putative (AFU_orthologue AFUA_4G14670)', 326, NULL, NULL, 184761),
(184762, '1.10.287.70-FF-000797', NULL, 'Uncharacterized protein', 132, NULL, NULL, 184762),
(184763, '3.60.40.10-FF-000199', NULL, 'YALI0B18759p', 284, NULL, NULL, 184763),
(184764, '3.40.140.10-FF-000059', NULL, 'Putative cytidine deaminase', 142, NULL, NULL, 184764),
(184765, '1.10.540.10-FF-000104', NULL, 'Acyl-CoA dehydrogenase', 117, NULL, NULL, 184765),
(184766, '1.20.1070.10-FF-001773', NULL, 'Olfactory receptor 58', 48, NULL, NULL, 184766),
(184767, '1.10.287.40-FF-000024', NULL, 'Serine--tRNA ligase', 100, NULL, NULL, 184767),
(184768, '2.60.40.10-FF-000651', NULL, 'Fc receptor like 1', 98, NULL, NULL, 184768),
(184769, '1.20.140.150-FF-000003', NULL, 'Voltage-dependent calcium channel gamma-7 subunit', 209, NULL, NULL, 184769),
(184770, '1.10.510.10-FF-000602', NULL, 'serine/threonine-protein kinase Nek9', 179, NULL, NULL, 184770),
(184771, '3.40.190.10-FF-000450', NULL, 'Glutamate receptor ionotropic, kainate 3-like Protein', 54, NULL, NULL, 184771),
(184772, '2.30.29.30-FF-001407', NULL, 'Uncharacterized protein', 68, NULL, NULL, 184772),
(184773, '3.20.20.10-FF-000082', NULL, 'Ornithine decarboxylase 1', 26, NULL, NULL, 184773),
(184774, '1.10.472.130-FF-000052', NULL, 'Dynein heavy chain isotype 3A', 75, NULL, NULL, 184774),
(184775, '3.30.2410.10-FF-000043', NULL, 'Uncharacterized protein', 87, NULL, NULL, 184775),
(184776, '2.70.20.10-FF-000008', NULL, 'DNA topoisomerase', 134, NULL, NULL, 184776),
(184777, '2.30.30.40-FF-000172', NULL, 'Amphiphysin, isoform B', 74, NULL, NULL, 184777),
(184778, '1.10.8.60-FF-000370', NULL, 'Uncharacterized protein', 74, NULL, NULL, 184778),
(184779, '3.30.540.10-FF-000013', NULL, 'Inositol-1-monophosphatase', 146, NULL, NULL, 184779),
(184780, '2.60.40.1360-FF-000014', NULL, 'Alpha-mannosidase', 106, NULL, NULL, 184780),
(184781, '3.30.230.10-FF-000203', NULL, 'Uncharacterized protein', 110, NULL, NULL, 184781),
(184782, '3.10.490.10-FF-000058', NULL, 'Uncharacterized protein', 157, NULL, NULL, 184782),
(184783, '3.30.559.30-FF-000096', NULL, 'Uncharacterized protein', 248, NULL, NULL, 184783);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(184784, '3.40.1020.10-FF-000005', NULL, 'Threonine dehydratase', 184, NULL, NULL, 184784),
(184785, '3.30.200.20-FF-000704', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase, putative', 88, NULL, NULL, 184785),
(184786, '3.10.280.10-FF-000037', NULL, 'Predicted protein', 197, NULL, NULL, 184786),
(184787, '3.40.50.1000-FF-000343', NULL, 'Haloacid dehalogenase/epoxide hydrolase family protein', 124, NULL, NULL, 184787),
(184788, '3.40.50.300-FF-008447', NULL, 'Uncharacterized protein', 68, NULL, NULL, 184788),
(184789, '3.40.50.1820-FF-001432', NULL, 'Carboxylic ester hydrolase', 516, NULL, NULL, 184789),
(184790, '1.10.287.70-FF-000746', NULL, 'MKIAA1123 protein', 85, NULL, NULL, 184790),
(184791, '2.60.40.10-FF-000600', NULL, 'Contactin 2', 95, NULL, NULL, 184791),
(184792, '2.60.40.10-FF-001786', NULL, 'PKD1 isoform 1', 80, NULL, NULL, 184792),
(184793, '1.10.405.10-FF-000021', NULL, 'Pseudooxynicotine oxidase', 96, NULL, NULL, 184793),
(184794, '3.40.50.300-FF-003956', NULL, 'Rab family, other', 144, NULL, NULL, 184794),
(184795, '3.30.457.50-FF-000005', NULL, 'Chromosome 9, whole genome shotgun sequence', 103, NULL, NULL, 184795),
(184796, '1.10.10.10-FF-001199', NULL, 'MarR family transcriptional regulator', 152, NULL, NULL, 184796),
(184797, '2.60.40.60-FF-000654', NULL, 'AGAP003579-PA', 45, NULL, NULL, 184797),
(184798, '3.40.50.300-FF-004524', NULL, 'AAA-like domain-containing protein', 186, NULL, NULL, 184798),
(184799, '3.90.1110.10-FF-000023', NULL, 'DNA-directed RNA polymerase subunit beta', 154, NULL, NULL, 184799),
(184800, '3.30.70.270-FF-000120', NULL, 'Diguanylate cyclase', 179, NULL, NULL, 184800),
(184801, '3.40.50.880-FF-000055', NULL, 'Phosphoribosylformylglycinamidine synthase', 309, NULL, NULL, 184801),
(184802, '3.30.70.330-FF-002302', NULL, NULL, 144, NULL, NULL, 184802),
(184803, '3.30.540.30-FF-000019', NULL, 'Uncharacterized protein', 165, NULL, NULL, 184803),
(184804, '1.20.1070.10-FF-001447', NULL, 'Uncharacterized protein', 221, NULL, NULL, 184804),
(184805, '1.25.40.20-FF-000760', NULL, 'Uncharacterized protein', 83, NULL, NULL, 184805),
(184806, '2.30.31.10-FF-000002', NULL, 'Single-stranded DNA-binding protein WHY2, mitochondrial', 176, NULL, NULL, 184806),
(184807, '3.40.50.620-FF-000848', NULL, 'Uncharacterized protein', 149, NULL, NULL, 184807),
(184808, '2.60.40.10-FF-004580', NULL, NULL, 119, NULL, NULL, 184808),
(184809, '3.40.1110.10-FF-000372', NULL, NULL, 235, NULL, NULL, 184809),
(184810, '3.30.160.60-FF-006440', NULL, NULL, 35, NULL, NULL, 184810),
(184811, '1.20.1640.10-FF-000075', NULL, 'Niemann-Pick C1 protein', 202, NULL, NULL, 184811),
(184812, '1.10.1200.10-FF-000084', NULL, 'Nonribosomal peptide synthase 2', 84, NULL, NULL, 184812),
(184813, '2.10.25.10-FF-001455', NULL, 'Uncharacterized protein', 42, NULL, NULL, 184813),
(184814, '1.20.1070.10-FF-001155', NULL, 'Pyroglutamylated RFamide peptide receptor', 344, NULL, NULL, 184814),
(184815, '3.40.47.10-FF-000013', NULL, 'Acetyl-CoA acetyltransferase', 405, NULL, NULL, 184815),
(184816, '1.25.40.10-FF-002016', NULL, 'Pre-mRNA-splicing factor SYF1-like Protein', 152, NULL, NULL, 184816),
(184817, '1.20.5.340-FF-000102', NULL, 'Kinesin-like protein KIN-14C', 120, NULL, NULL, 184817),
(184818, '3.40.50.300-FF-004232', NULL, 'Uncharacterized protein', 270, NULL, NULL, 184818),
(184819, '3.30.1960.10-FF-000005', NULL, 'Transcription factor INI', 112, NULL, NULL, 184819),
(184820, '1.10.510.10-FF-000041', NULL, 'Ribosomal protein S6 kinase', 261, NULL, NULL, 184820),
(184821, '2.60.260.20-FF-000031', NULL, 'Molecular chaperone DnaJ', 62, NULL, NULL, 184821),
(184822, '1.25.10.10-FF-002514', NULL, 'Uncharacterized protein', 195, NULL, NULL, 184822),
(184823, '3.90.780.10-FF-000001', NULL, 'NT5E isoform 3', 213, NULL, NULL, 184823),
(184824, '1.20.1720.10-FF-000076', NULL, NULL, 173, NULL, NULL, 184824),
(184825, '3.40.50.12440-FF-000003', NULL, 'Anaerobic dimethyl sulfoxide reductase subunit A', 216, NULL, NULL, 184825),
(184826, '3.60.21.10-FF-000127', NULL, 'Serine/threonine-protein phosphatase', 357, NULL, NULL, 184826);
INSERT INTO "PUBLIC"."MODEL" VALUES
(184827, '3.10.105.10-FF-000075', NULL, 'Oligopeptide-binding protein oppA', 218, NULL, NULL, 184827),
(184828, '3.30.40.10-FF-001408', NULL, 'Uncharacterized protein', 89, NULL, NULL, 184828),
(184829, '1.20.1280.50-FF-000188', NULL, 'F-box and WD repeat domain containing 4', 95, NULL, NULL, 184829),
(184830, '3.20.20.70-FF-000638', NULL, NULL, 257, NULL, NULL, 184830),
(184831, '3.30.559.30-FF-000045', NULL, 'PKS-NRPS hybrid synthetase psoA', 229, NULL, NULL, 184831),
(184832, '3.80.10.10-FF-003355', NULL, 'Uncharacterized protein', 114, NULL, NULL, 184832),
(184833, '3.40.50.150-FF-000628', NULL, 'Predicted O-methyltransferase YrrM', 216, NULL, NULL, 184833),
(184834, '1.25.40.20-FF-000434', NULL, 'Serine/threonine-protein phosphatase 6 regulatory ankyrin repeat subunit A', 69, NULL, NULL, 184834),
(184835, '3.40.1170.60-FF-000042', NULL, NULL, 64, NULL, NULL, 184835),
(184836, '3.40.50.300-FF-007672', NULL, 'GPN-loop GTPase 2', 120, NULL, NULL, 184836),
(184837, '3.10.28.10-FF-000021', NULL, 'Intron-encoded DNA endonuclease ai2a', 119, NULL, NULL, 184837),
(184838, '1.10.238.10-FF-000115', NULL, 'Calcium-binding protein 8', 100, NULL, NULL, 184838),
(184839, '2.60.40.1170-FF-000047', NULL, 'APM2p protein', 104, NULL, NULL, 184839),
(184840, '3.30.360.10-FF-000027', NULL, 'Dehydrogenase', 132, NULL, NULL, 184840),
(184841, '3.40.50.12650-FF-000009', NULL, 'DNA repair metallo-beta-lactamase protein', 146, NULL, NULL, 184841),
(184842, '2.60.120.10-FF-000338', NULL, 'Protein CBG19118', 104, NULL, NULL, 184842),
(184843, '3.40.50.1440-FF-000014', NULL, 'Cell division protein FtsZ', 214, NULL, NULL, 184843),
(184844, '2.40.20.10-FF-000044', NULL, 'Metalloendopeptidase', 85, NULL, NULL, 184844),
(184845, '3.30.540.10-FF-000064', NULL, 'Fructose-1,6-bisphosphatase class 1', 152, NULL, NULL, 184845),
(184846, '3.40.50.1780-FF-000032', NULL, 'Cytosolic Fe-S cluster assembly factor NAR1 homolog', 108, NULL, NULL, 184846),
(184847, '3.30.40.10-FF-000796', NULL, 'BnaCnng74270D protein', 72, NULL, NULL, 184847),
(184848, '1.25.40.10-FF-000431', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 186, NULL, NULL, 184848),
(184849, '2.10.25.10-FF-001129', NULL, 'Predicted protein', 84, NULL, NULL, 184849),
(184850, '6.10.140.2150-FF-000011', NULL, 'Sphingosine 1-phosphate lyase, putative', 55, NULL, NULL, 184850),
(184851, '1.20.930.40-FF-000017', NULL, 'N-acetylated-alpha-linked acidic dipeptidase-like protein', 145, NULL, NULL, 184851),
(184852, '1.10.287.110-FF-000219', NULL, 'DnaJ subfamily C member 3', 106, NULL, NULL, 184852),
(184853, '2.130.10.10-FF-004670', NULL, 'Uncharacterized protein', 185, NULL, NULL, 184853),
(184854, '3.40.50.360-FF-000169', NULL, 'Nitric oxide synthase, inducible', 70, NULL, NULL, 184854),
(184855, '3.30.160.60-FF-005889', NULL, NULL, 82, NULL, NULL, 184855),
(184856, '2.60.40.10-FF-002449', NULL, 'CD4', 113, NULL, NULL, 184856),
(184857, '3.10.20.600-FF-000006', NULL, 'Formate dehydrogenase, beta subunit', 92, NULL, NULL, 184857),
(184858, '3.30.450.20-FF-000594', NULL, 'Sensor histidine kinase, PAS and PAS domain-containing', 131, NULL, NULL, 184858),
(184859, '1.10.510.10-FF-000248', NULL, 'S-receptor-like kinase 5', 204, NULL, NULL, 184859),
(184860, '3.40.50.300-FF-000084', NULL, 'Guanylate kinase', 116, NULL, NULL, 184860),
(184861, '1.10.287.1770-FF-000004', NULL, 'Ferrous iron transport protein B', 96, NULL, NULL, 184861),
(184862, '3.40.50.2300-FF-001554', NULL, NULL, 25, NULL, NULL, 184862),
(184863, '1.20.58.340-FF-000017', NULL, 'Magnesium transport protein CorA', 119, NULL, NULL, 184863),
(184864, '3.40.50.300-FF-004850', NULL, 'Elongation factor G, mitochondrial', 284, NULL, NULL, 184864),
(184865, '1.25.40.20-FF-001895', NULL, 'Espin like a', 138, NULL, NULL, 184865),
(184866, '3.30.505.10-FF-000168', NULL, NULL, 127, NULL, NULL, 184866),
(184867, '3.30.160.60-FF-000549', NULL, 'zinc finger protein 384 isoform X1', 29, NULL, NULL, 184867),
(184868, '2.130.10.10-FF-005367', NULL, 'WD repeat protein, putative', 169, NULL, NULL, 184868),
(184869, '3.30.60.30-FF-000168', NULL, 'Agrin', 69, NULL, NULL, 184869);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(184870, '1.25.10.10-FF-000036', NULL, 'Formin-like protein 3 isoform 1', 182, NULL, NULL, 184870),
(184871, '1.20.1540.10-FF-000011', NULL, 'Putative rhomboid domain-containing protein 2', 190, NULL, NULL, 184871),
(184872, '2.120.10.80-FF-000133', NULL, 'Leucine carboxyl methyltransferase 2', 346, NULL, NULL, 184872),
(184873, '1.20.120.1510-FF-000009', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 107, NULL, NULL, 184873),
(184874, '3.50.50.60-FF-001176', NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', 227, NULL, NULL, 184874),
(184875, '1.20.1280.50-FF-000137', NULL, 'F-box/wd-repeat protein lin-23, putative', 93, NULL, NULL, 184875),
(184876, '1.10.472.10-FF-000030', NULL, 'Retinoblastoma-related protein 1', 189, NULL, NULL, 184876),
(184877, '3.40.50.1240-FF-000044', NULL, 'Multiple inositol polyphosphate phosphatase 1', 264, NULL, NULL, 184877),
(184878, '3.30.40.10-FF-001285', NULL, 'Uncharacterized protein', 88, NULL, NULL, 184878),
(184879, '2.60.40.10-FF-002242', NULL, 'Stretchin-Mlck, isoform U', 104, NULL, NULL, 184879),
(184880, '2.160.20.10-FF-000330', NULL, 'Amidase2', 92, NULL, NULL, 184880),
(184881, '2.120.10.30-FF-000051', NULL, 'Low-density lipoprotein receptor-related protein 2', 322, NULL, NULL, 184881),
(184882, '2.40.70.10-FF-000142', NULL, 'Os01g0937800 protein', 182, NULL, NULL, 184882),
(184883, '3.40.50.150-FF-001859', NULL, 'Probable polyketide synthase 1', 349, NULL, NULL, 184883),
(184884, '1.25.40.580-FF-000001', NULL, 'DNA mismatch repair protein HSM3', 167, NULL, NULL, 184884),
(184885, '3.80.10.10-FF-003142', NULL, 'Uncharacterized protein', 318, NULL, NULL, 184885),
(184886, '1.10.510.10-FF-000092', NULL, 'Ribosomal protein S6 kinase', 195, NULL, NULL, 184886),
(184887, '3.30.1330.30-FF-000082', NULL, '23S rRNA methyltransferase', 66, NULL, NULL, 184887),
(184888, '3.40.50.300-FF-008161', NULL, 'Uncharacterized protein', 89, NULL, NULL, 184888),
(184889, '3.70.10.10-FF-000118', NULL, 'Uncharacterized protein', 181, NULL, NULL, 184889),
(184890, '1.25.40.10-FF-004354', NULL, 'Uncharacterized protein', 264, NULL, NULL, 184890),
(184891, '3.30.450.30-FF-000080', NULL, 'Uncharacterized protein C1778.05c', 157, NULL, NULL, 184891),
(184892, '3.30.70.100-FF-000047', NULL, 'Copper-transporting ATPase PAA1, chloroplastic', 76, NULL, NULL, 184892),
(184893, '1.25.40.10-FF-001892', NULL, 'Pentatricopeptide repeat-containing protein At2g18520, mitochondrial', 155, NULL, NULL, 184893),
(184894, '1.10.510.10-FF-002244', NULL, NULL, 138, NULL, NULL, 184894),
(184895, '3.30.420.40-FF-000581', NULL, 'Actin, putative', 135, NULL, NULL, 184895),
(184896, '2.130.10.10-FF-005772', NULL, 'Uncharacterized protein', 107, NULL, NULL, 184896),
(184897, '3.80.10.10-FF-001146', NULL, 'F-box domain containing protein, expressed', 113, NULL, NULL, 184897),
(184898, '1.20.5.430-FF-000011', NULL, 'Glycine betaine transporter BetP', 48, NULL, NULL, 184898),
(184899, '3.30.450.40-FF-000083', NULL, 'Sensor histidine kinase/response regulator, putative (AFU_orthologue AFUA_4G00660)', 181, NULL, NULL, 184899),
(184900, '3.40.50.300-FF-005985', NULL, 'Vacuolar protein-sorting protein, putative', 161, NULL, NULL, 184900),
(184901, '3.40.1350.10-FF-000024', NULL, 'Fanconi-associated nuclease', 76, NULL, NULL, 184901),
(184902, '3.30.160.60-FF-001909', NULL, 'Zinc finger protein 425', 33, NULL, NULL, 184902),
(184903, '1.10.1170.10-FF-000035', NULL, 'Death-associated inhibitor of apoptosis 2', 88, NULL, NULL, 184903),
(184904, '1.10.150.530-FF-000003', NULL, 'Dual-specificity RNA methyltransferase RlmN', 66, NULL, NULL, 184904),
(184905, '1.25.40.10-FF-003865', NULL, 'Uncharacterized protein', 103, NULL, NULL, 184905),
(184906, '3.30.70.330-FF-000796', NULL, 'RNA binding motif protein 4.3', 79, NULL, NULL, 184906),
(184907, '3.90.226.10-FF-000141', NULL, 'Carboxyl-terminal-processing peptidase 1 chloroplastic', 52, NULL, NULL, 184907),
(184908, '3.30.420.110-FF-000040', NULL, 'Putative DNA mismatch repair protein', 183, NULL, NULL, 184908);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(184909, '3.30.160.60-FF-000246', NULL, 'Transcription factor Ovo-like 2', 25, NULL, NULL, 184909),
(184910, '3.40.50.1820-FF-000994', NULL, 'Predicted protein', 242, NULL, NULL, 184910),
(184911, '3.80.10.10-FF-002866', NULL, 'Uncharacterized protein', 117, NULL, NULL, 184911),
(184912, '3.30.160.60-FF-006114', NULL, NULL, 47, NULL, NULL, 184912),
(184913, '3.10.110.10-FF-000025', NULL, 'ubiquitin-conjugating enzyme E2 7', 165, NULL, NULL, 184913),
(184914, '2.130.10.10-FF-003776', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit wuho', 316, NULL, NULL, 184914),
(184915, '3.30.565.10-FF-000323', NULL, 'Histidine kinase', 124, NULL, NULL, 184915),
(184916, '1.25.10.10-FF-000311', NULL, 'Coatomer subunit beta', 561, NULL, NULL, 184916),
(184917, '3.40.50.1820-FF-001483', NULL, 'Uncharacterized protein', 169, NULL, NULL, 184917),
(184918, '1.10.287.110-FF-000371', NULL, 'Diphthamide biosynthesis protein 4', 82, NULL, NULL, 184918),
(184919, '1.10.1660.10-FF-000022', NULL, 'Probable transcriptional regulator', 77, NULL, NULL, 184919),
(184920, '3.90.190.10-FF-000484', NULL, 'Uncharacterized protein', 167, NULL, NULL, 184920),
(184921, '1.25.10.10-FF-001497', NULL, 'Predicted protein', 173, NULL, NULL, 184921),
(184922, '2.30.30.40-FF-000121', NULL, 'Neutrophil cytosol factor 1', 68, NULL, NULL, 184922),
(184923, '3.30.450.60-FF-000089', NULL, 'AAL079Cp', 137, NULL, NULL, 184923),
(184924, '2.60.40.10-FF-005889', NULL, NULL, 56, NULL, NULL, 184924),
(184925, '2.130.10.10-FF-004052', NULL, 'WD repeatcontaining protein 34-like family protein, putative', 214, NULL, NULL, 184925),
(184926, '2.130.10.10-FF-005928', NULL, 'Glr0823 protein', 268, NULL, NULL, 184926),
(184927, '3.50.7.10-FF-000051', NULL, NULL, 87, NULL, NULL, 184927),
(184928, '1.10.1740.10-FF-000023', NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', 86, NULL, NULL, 184928),
(184929, '3.20.19.10-FF-000011', NULL, 'Aconitate hydratase', 234, NULL, NULL, 184929),
(184930, '3.40.470.10-FF-000045', NULL, NULL, 144, NULL, NULL, 184930),
(184931, '3.40.50.1980-FF-000092', NULL, 'Iron(3+)-hydroxamate-binding protein FhuD', 155, NULL, NULL, 184931),
(184932, '3.90.550.10-FF-000225', NULL, 'GNT1p N-acetylglucosaminyltransferase', 283, NULL, NULL, 184932),
(184933, '3.50.50.60-FF-000041', NULL, 'Glutamate synthase, small subunit', 145, NULL, NULL, 184933),
(184934, '3.40.50.1820-FF-000589', NULL, 'Carboxypeptidase', 436, NULL, NULL, 184934),
(184935, '1.10.150.850-FF-000009', NULL, 'Uncharacterized protein', 71, NULL, NULL, 184935),
(184936, '3.40.50.1820-FF-001157', NULL, 'Uncharacterized protein', 246, NULL, NULL, 184936),
(184937, '1.25.40.20-FF-000580', NULL, 'Protein CBR-SHN-1', 134, NULL, NULL, 184937),
(184938, '2.40.30.10-FF-000319', NULL, 'Mitochondrial tRNA-specific 2-thiouridylase 1', 88, NULL, NULL, 184938),
(184939, '1.10.555.10-FF-000234', NULL, NULL, 152, NULL, NULL, 184939),
(184940, '2.60.40.200-FF-000006', NULL, 'Copper chaperone for superoxide dismutase', 128, NULL, NULL, 184940),
(184941, '1.10.287.310-FF-000015', NULL, '50S ribosomal protein L29', 66, NULL, NULL, 184941),
(184942, '2.40.10.10-FF-000262', NULL, 'Transmembrane serine protease 5', 88, NULL, NULL, 184942),
(184943, '2.80.10.50-FF-000188', NULL, 'Predicted protein', 130, NULL, NULL, 184943),
(184944, '3.40.449.10-FF-000006', NULL, 'Phosphoenolpyruvate carboxykinase (ATP)', 182, NULL, NULL, 184944),
(184945, '2.60.120.920-FF-000186', NULL, 'Neuralized, putative', 109, NULL, NULL, 184945),
(184946, '3.80.10.10-FF-003029', NULL, 'Uncharacterized protein', 131, NULL, NULL, 184946),
(184947, '3.30.930.10-FF-000178', NULL, 'Phenylalanyl-tRNA synthetase subunit alpha', 274, NULL, NULL, 184947),
(184948, '3.10.50.40-FF-000059', NULL, 'Peptidylprolyl isomerase', 137, NULL, NULL, 184948),
(184949, '2.30.170.40-FF-000014', NULL, '50S ribosomal protein L28', 43, NULL, NULL, 184949),
(184950, '3.40.33.10-FF-000189', NULL, 'Uncharacterized protein', 148, NULL, NULL, 184950),
(184951, '4.10.830.30-FF-000003', NULL, '50S ribosomal protein L31', 67, NULL, NULL, 184951);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(184952, '3.20.20.80-FF-000760', NULL, 'Chitinase, acidic.3', 209, NULL, NULL, 184952),
(184953, '2.130.10.10-FF-001938', NULL, 'Chromosome Transmission Fidelity factor homolog', 230, NULL, NULL, 184953),
(184954, '1.10.220.150-FF-000001', NULL, 'Arf-GAP with GTPase, ANK repeat and PH domain-containing protein 1', 135, NULL, NULL, 184954),
(184955, '3.40.50.150-FF-000842', NULL, 'Methyltransferase', 182, NULL, NULL, 184955),
(184956, '3.50.50.100-FF-000022', NULL, 'NADH:ubiquinone oxidoreductase', 395, NULL, NULL, 184956),
(184957, '1.10.418.20-FF-000003', NULL, 'SUMO specific peptidase 7', 108, NULL, NULL, 184957),
(184958, '2.130.10.10-FF-001882', NULL, 'WD repeat domain 18', 112, NULL, NULL, 184958),
(184959, '4.10.410.10-FF-000038', NULL, 'papilin isoform X2', 57, NULL, NULL, 184959),
(184960, '2.60.40.10-FF-005597', NULL, NULL, 84, NULL, NULL, 184960),
(184961, '2.30.30.40-FF-000003', NULL, 'Sorbin and SH3 domain-containing protein 1 isoform 2', 68, NULL, NULL, 184961),
(184962, '3.30.70.1320-FF-000009', NULL, 'RND multidrug efflux transporter', 98, NULL, NULL, 184962),
(184963, '3.20.20.140-FF-000074', NULL, 'Extracellular developmental signal biosynthesis protein FluG', 412, NULL, NULL, 184963),
(184964, '1.10.760.10-FF-000020', NULL, 'Cytochrome c peroxidase', 154, NULL, NULL, 184964),
(184965, '3.40.50.300-FF-005547', NULL, 'ArsA-type transport ATPase (Probable substrate arsenite)', 282, NULL, NULL, 184965),
(184966, '3.40.50.300-FF-008239', NULL, 'Lon protease-like protein', 56, NULL, NULL, 184966),
(184967, '1.10.40.40-FF-000001', NULL, '5''(3'')-deoxyribonucleotidase, cytosolic type', 55, NULL, NULL, 184967),
(184968, '2.60.120.260-FF-000140', NULL, 'Mannosidase beta', 24, NULL, NULL, 184968),
(184969, '2.60.120.330-FF-000240', NULL, 'Uncharacterized protein', 72, NULL, NULL, 184969),
(184970, '1.10.510.10-FF-004043', NULL, NULL, 78, NULL, NULL, 184970),
(184971, '1.20.5.110-FF-000090', NULL, 'Uncharacterized protein', 63, NULL, NULL, 184971),
(184972, '3.40.50.2300-FF-000126', NULL, 'DNA-binding response regulator', 80, NULL, NULL, 184972),
(184973, '2.120.10.30-FF-000612', NULL, 'Uncharacterized protein', 128, NULL, NULL, 184973),
(184974, '2.50.20.20-FF-000001', NULL, 'Putative conserved lipoprotein LppX', 188, NULL, NULL, 184974),
(184975, '3.40.120.10-FF-000047', NULL, 'Phosphoacetylglucosamine mutase', 89, NULL, NULL, 184975),
(184976, '4.10.1000.40-FF-000013', NULL, 'YALI0E13794p', 71, NULL, NULL, 184976),
(184977, '3.30.70.270-FF-000002', NULL, 'DNA polymerase IV', 109, NULL, NULL, 184977),
(184978, '1.10.8.1220-FF-000018', NULL, 'Dynein heavy chain', 90, NULL, NULL, 184978),
(184979, '1.20.1250.20-FF-001335', NULL, 'Predicted protein', 196, NULL, NULL, 184979),
(184980, '2.30.29.30-FF-001233', NULL, 'Uncharacterized protein', 114, NULL, NULL, 184980),
(184981, '1.10.3290.10-FF-000011', NULL, 'FicT toxin VbhT', 205, NULL, NULL, 184981),
(184982, '1.10.1450.10-FF-000017', NULL, 'Tetraspanin', 103, NULL, NULL, 184982),
(184983, '1.10.30.10-FF-000014', NULL, 'HMG box transcription factor BBX', 79, NULL, NULL, 184983),
(184984, '2.60.40.640-FF-000054', NULL, 'Vacuolar protein sorting-associated protein 26 containing protein', 137, NULL, NULL, 184984),
(184985, '3.10.129.10-FF-000051', NULL, 'Acyl-coa thioesterase', 154, NULL, NULL, 184985),
(184986, '2.40.30.10-FF-000224', NULL, 'Selenocysteine-specific translation elongation factor', 87, NULL, NULL, 184986),
(184987, '3.30.40.10-FF-002302', NULL, 'Uncharacterized protein', 116, NULL, NULL, 184987),
(184988, '1.10.510.10-FF-000771', NULL, 'Uncharacterized protein', 332, NULL, NULL, 184988),
(184989, '3.90.120.10-FF-000030', NULL, 'Cytosine-specific DNA methylase, putative', 143, NULL, NULL, 184989),
(184990, '1.10.287.80-FF-000007', NULL, 'ATP synthase gamma chain', 99, NULL, NULL, 184990),
(184991, '3.30.1460.50-FF-000030', NULL, 'AGAP000933-PA', 185, NULL, NULL, 184991),
(184992, '2.70.170.10-FF-000272', NULL, 'Predicted protein', 114, NULL, NULL, 184992),
(184993, '1.25.40.10-FF-000105', NULL, 'Tetratricopeptide repeat domain 7A', 306, NULL, NULL, 184993);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(184994, '1.10.10.10-FF-000535', NULL, 'DNA-binding response regulator CiaR', 103, NULL, NULL, 184994),
(184995, '2.10.10.20-FF-000002', NULL, 'Probable bifunctional chitinase/lysozyme', 58, NULL, NULL, 184995),
(184996, '3.30.420.10-FF-000645', NULL, NULL, 139, NULL, NULL, 184996),
(184997, '1.10.390.10-FF-000098', NULL, 'Uncharacterized protein', 102, NULL, NULL, 184997),
(184998, '2.20.100.10-FF-000189', NULL, 'Uncharacterized protein', 62, NULL, NULL, 184998),
(184999, '1.10.472.10-FF-000142', NULL, 'Cyclin, N-terminal domain containing protein', 127, NULL, NULL, 184999),
(185000, '1.10.150.50-FF-000165', NULL, 'Uncharacterized protein', 81, NULL, NULL, 185000),
(185001, '3.90.190.10-FF-000596', NULL, 'Protein tyrosine phosphatase, receptor type G', 161, NULL, NULL, 185001),
(185002, '3.40.1110.10-FF-000276', NULL, 'Phospholipid-transporting ATPase', 263, NULL, NULL, 185002),
(185003, '3.40.50.1820-FF-000494', NULL, 'Protein FAM135B isoform A', 182, NULL, NULL, 185003),
(185004, '1.20.58.830-FF-000018', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 181, NULL, NULL, 185004),
(185005, '3.40.50.300-FF-006441', NULL, 'Predicted protein', 125, NULL, NULL, 185005),
(185006, '1.10.510.10-FF-004082', NULL, NULL, 343, NULL, NULL, 185006),
(185007, '3.30.160.60-FF-004203', NULL, NULL, 40, NULL, NULL, 185007),
(185008, '1.10.238.10-FF-000166', NULL, 'Naked cuticle homolog 1 (Drosophila)', 93, NULL, NULL, 185008),
(185009, '1.10.10.480-FF-000003', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase', 75, NULL, NULL, 185009),
(185010, '1.20.5.340-FF-000017', NULL, 'myosin-10 isoform X2', 108, NULL, NULL, 185010),
(185011, '1.25.40.60-FF-000013', NULL, 'Syntaxin binding protein, putative', 120, NULL, NULL, 185011),
(185012, '1.10.20.10-FF-000362', NULL, NULL, 88, NULL, NULL, 185012),
(185013, '1.20.120.180-FF-000002', NULL, 'Proteasome activator complex subunit 1', 139, NULL, NULL, 185013),
(185014, '3.10.290.10-FF-000077', NULL, 'Pseudouridine synthase', 66, NULL, NULL, 185014),
(185015, '3.30.420.110-FF-000006', NULL, 'DNA mismatch repair protein', 172, NULL, NULL, 185015),
(185016, '1.20.1510.10-FF-000060', NULL, 'CDF transporter, membrane protein', 196, NULL, NULL, 185016),
(185017, '2.60.120.10-FF-000518', NULL, 'Stage II sporulation E family protein', 139, NULL, NULL, 185017),
(185018, '1.20.58.60-FF-000598', NULL, 'Dystrophin', 161, NULL, NULL, 185018),
(185019, '2.60.40.60-FF-000351', NULL, 'Cadherin 74A, isoform A', 120, NULL, NULL, 185019),
(185020, '1.10.220.160-FF-000004', NULL, 'Blast:Protein msta, isoform A', 75, NULL, NULL, 185020),
(185021, '3.30.160.60-FF-004523', NULL, NULL, 57, NULL, NULL, 185021),
(185022, '3.30.160.60-FF-004580', NULL, NULL, 72, NULL, NULL, 185022),
(185023, '2.30.30.1150-FF-000014', NULL, 'Uncharacterized protein', 127, NULL, NULL, 185023),
(185024, '1.25.40.70-FF-000016', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit gamma, putative', 199, NULL, NULL, 185024),
(185025, '1.25.40.10-FF-002229', NULL, 'Pentatricopeptide repeat domain containing protein, putative', 198, NULL, NULL, 185025),
(185026, '2.10.50.10-FF-000064', NULL, 'Cysteine repeat modular protein 3', 58, NULL, NULL, 185026),
(185027, '1.20.120.350-FF-000076', NULL, 'Ion transporter, putative', 129, NULL, NULL, 185027),
(185028, '1.10.220.10-FF-000052', NULL, 'Uncharacterized protein', 74, NULL, NULL, 185028),
(185029, '2.60.120.260-FF-000235', NULL, 'Regulator', 133, NULL, NULL, 185029),
(185030, '2.80.10.50-FF-000093', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 158, NULL, NULL, 185030),
(185031, '3.40.50.620-FF-000005', NULL, 'Argininosuccinate synthase', 146, NULL, NULL, 185031),
(185032, '1.10.510.10-FF-004138', NULL, NULL, 75, NULL, NULL, 185032),
(185033, '2.70.150.10-FF-000001', NULL, 'Calcium-transporting ATPase', 144, NULL, NULL, 185033),
(185034, '1.20.930.20-FF-000011', NULL, 'Uncharacterized protein', 121, NULL, NULL, 185034),
(185035, '1.20.5.2440-FF-000005', NULL, 'ELKS/Rab6-interacting/CAST family member 1 isoform X1', 56, NULL, NULL, 185035);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(185036, '3.90.1460.10-FF-000004', NULL, 'general transcription factor II-I isoform X1', 98, NULL, NULL, 185036),
(185037, '2.30.40.10-FF-000068', NULL, 'Triazine hydrolase', 97, NULL, NULL, 185037),
(185038, '2.60.40.150-FF-000244', NULL, 'Rabphilin, isoform A', 147, NULL, NULL, 185038),
(185039, '3.40.50.720-FF-001901', NULL, 'Pyrroline-5-carboxylate reductase', 172, NULL, NULL, 185039),
(185040, '2.40.50.140-FF-000899', NULL, 'Single-stranded DNA-binding protein', 116, NULL, NULL, 185040),
(185041, '1.10.167.10-FF-000028', NULL, 'G protein-coupled receptor kinase', 79, NULL, NULL, 185041),
(185042, '2.40.50.140-FF-000202', NULL, 'Aspartate--tRNA ligase, mitochondrial', 116, NULL, NULL, 185042),
(185043, '3.30.420.100-FF-000003', NULL, '50S ribosomal protein L18', 112, NULL, NULL, 185043),
(185044, '3.80.10.10-FF-003181', NULL, 'Protein CBG22695', 396, NULL, NULL, 185044),
(185045, '1.25.40.20-FF-000260', NULL, 'Receptor-interacting serine/threonine-protein kinase 4', 138, NULL, NULL, 185045),
(185046, '3.30.200.20-FF-001273', NULL, 'Protein kinase, putative', 88, NULL, NULL, 185046),
(185047, '1.10.287.70-FF-000589', NULL, 'Uncharacterized protein', 137, NULL, NULL, 185047),
(185048, '3.40.50.10470-FF-000053', NULL, 'Uncharacterized protein', 223, NULL, NULL, 185048),
(185049, '1.10.10.60-FF-000067', NULL, 'NK6 homeobox 1', 69, NULL, NULL, 185049),
(185050, '1.20.1270.10-FF-000086', NULL, 'Uncharacterized protein', 73, NULL, NULL, 185050),
(185051, '1.10.630.10-FF-000549', NULL, 'Cytochrome P450', 340, NULL, NULL, 185051),
(185052, '2.40.290.10-FF-000046', NULL, 'Uncharacterized protein', 224, NULL, NULL, 185052),
(185053, '3.40.50.2300-FF-000868', NULL, NULL, 64, NULL, NULL, 185053),
(185054, '1.10.8.10-FF-000169', NULL, 'Ubiquitin family protein', 67, NULL, NULL, 185054),
(185055, '4.10.970.10-FF-000007', NULL, 'Related to ATP-dependent DNA helicase II, 70 kDa subunit', 72, NULL, NULL, 185055),
(185056, '2.60.40.10-FF-002163', NULL, 'KETtiN (Drosophila actin-binding) homolog', 101, NULL, NULL, 185056),
(185057, '3.40.50.1240-FF-000005', NULL, 'GpmB, Fructose-2,6-bisphosphatase', 216, NULL, NULL, 185057),
(185058, '3.90.70.10-FF-000840', NULL, 'Uncharacterized protein', 131, NULL, NULL, 185058),
(185059, '1.10.20.10-FF-000249', NULL, NULL, 85, NULL, NULL, 185059),
(185060, '1.10.132.130-FF-000004', NULL, NULL, 127, NULL, NULL, 185060),
(185061, '1.10.3500.10-FF-000045', NULL, 'Uncharacterized protein', 34, NULL, NULL, 185061),
(185062, '1.20.920.10-FF-000148', NULL, 'YALI0E32307p', 121, NULL, NULL, 185062),
(185063, '3.30.420.10-FF-000437', NULL, NULL, 206, NULL, NULL, 185063),
(185064, '1.25.10.10-FF-001789', NULL, 'Uncharacterized protein', 1088, NULL, NULL, 185064),
(185065, '3.40.50.2000-FF-000891', NULL, 'UDP-glycosyltransferase 73D1', 176, NULL, NULL, 185065),
(185066, '1.10.940.10-FF-000005', NULL, 'Ribosomal RNA small subunit methyltransferase B', 151, NULL, NULL, 185066),
(185067, '3.40.50.790-FF-000028', NULL, 'Uncharacterized protein', 108, NULL, NULL, 185067),
(185068, '1.10.246.130-FF-000014', NULL, 'RE13973p', 108, NULL, NULL, 185068),
(185069, '2.130.10.10-FF-003804', NULL, 'Uncharacterized protein', 309, NULL, NULL, 185069),
(185070, '3.40.190.290-FF-000043', NULL, 'Transcriptional regulator, LysR family', 203, NULL, NULL, 185070),
(185071, '3.30.70.1450-FF-000020', NULL, 'Sodium/sulfate transporter, putative', 76, NULL, NULL, 185071),
(185072, '3.30.559.30-FF-000124', NULL, 'Chromosome 19, whole genome shotgun sequence', 112, NULL, NULL, 185072),
(185073, '1.20.1260.80-FF-000004', NULL, 'Uncharacterized protein', 194, NULL, NULL, 185073),
(185074, '3.50.50.60-FF-001356', NULL, 'Flavin-containing monooxygenase', 92, NULL, NULL, 185074),
(185075, '3.40.50.1110-FF-000146', NULL, 'Os06g0149100 protein', 131, NULL, NULL, 185075),
(185076, '1.25.40.10-FF-003539', NULL, 'Uncharacterized protein', 109, NULL, NULL, 185076),
(185077, '2.60.40.1180-FF-000112', NULL, 'Putative alpha-L-fucosidase-like Protein', 102, NULL, NULL, 185077),
(185078, '3.30.40.10-FF-001313', NULL, 'Zinc finger family protein', 70, NULL, NULL, 185078);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(185079, '3.30.40.10-FF-001370', NULL, 'E3 ubiquitin-protein ligase rpm-1', 83, NULL, NULL, 185079),
(185080, '3.40.50.1100-FF-000143', NULL, 'SH3 domain protein (Cyk3), putative (AFU_orthologue AFUA_5G03400)', 16, NULL, NULL, 185080),
(185081, '2.70.170.10-FF-000064', NULL, 'Uncharacterized protein', 209, NULL, NULL, 185081),
(185082, '3.10.120.10-FF-000031', NULL, 'Acyl-lipid (8-3)-desaturase', 73, NULL, NULL, 185082),
(185083, '1.20.5.340-FF-000085', NULL, 'NHS-like 1a', 89, NULL, NULL, 185083),
(185084, '2.60.40.10-FF-000443', NULL, 'host cell factor 1', 84, NULL, NULL, 185084),
(185085, '3.30.379.10-FF-000020', NULL, 'O-GlcNAcase BT_4395', 124, NULL, NULL, 185085),
(185086, '3.40.50.1100-FF-000255', NULL, 'Cysteine synthase', 166, NULL, NULL, 185086),
(185087, '2.20.25.10-FF-000084', NULL, 'transcription factor IIIB 90 kDa subunit isoform X1', 40, NULL, NULL, 185087),
(185088, '2.60.120.260-FF-000027', NULL, 'Beta-glucuronidase', 197, NULL, NULL, 185088),
(185089, '3.30.40.10-FF-001577', NULL, 'Uncharacterized protein', 89, NULL, NULL, 185089),
(185090, '3.10.450.10-FF-000016', NULL, 'Cysteine proteinase inhibitor', 96, NULL, NULL, 185090),
(185091, '4.10.280.10-FF-000090', NULL, 'Salivary gland-expressed bHLH', 67, NULL, NULL, 185091),
(185092, '2.60.40.10-FF-004254', NULL, NULL, 146, NULL, NULL, 185092),
(185093, '1.25.40.10-FF-004062', NULL, 'Predicted protein', 346, NULL, NULL, 185093),
(185094, '2.60.120.1190-FF-000014', NULL, 'Uncharacterized protein', 180, NULL, NULL, 185094),
(185095, '3.40.50.1000-FF-000843', NULL, NULL, 68, NULL, NULL, 185095),
(185096, '3.90.228.10-FF-000038', NULL, 'Predicted protein', 224, NULL, NULL, 185096),
(185097, '1.25.40.10-FF-002342', NULL, 'GM12139', 131, NULL, NULL, 185097),
(185098, '3.40.1810.10-FF-000054', NULL, NULL, 116, NULL, NULL, 185098),
(185099, '1.25.40.10-FF-001948', NULL, 'TPR-containing protein DDB_G0280363', 203, NULL, NULL, 185099),
(185100, '2.60.40.60-FF-000087', NULL, 'Protocadherin 9', 120, NULL, NULL, 185100),
(185101, '3.30.60.30-FF-000218', NULL, 'Uncharacterized protein', 58, NULL, NULL, 185101),
(185102, '3.30.2300.10-FF-000001', NULL, 'THUMP domain-containing protein 1', 86, NULL, NULL, 185102),
(185103, '3.80.10.10-FF-002574', NULL, 'Putative serine/threonine-protein kinase pats1', 117, NULL, NULL, 185103),
(185104, '3.60.21.50-FF-000009', NULL, 'DNA polymerase epsilon subunit', 199, NULL, NULL, 185104),
(185105, '2.10.90.10-FF-000072', NULL, 'Predicted protein', 97, NULL, NULL, 185105),
(185106, '3.40.50.720-FF-001160', NULL, 'Alcohol dehydrogenase 1', 147, NULL, NULL, 185106),
(185107, '1.20.58.390-FF-000021', NULL, 'glutamate-gated chloride channel isoform X12', 134, NULL, NULL, 185107),
(185108, '2.130.10.10-FF-001977', NULL, 'Histone acetyltransferase type B subunit 2', 378, NULL, NULL, 185108),
(185109, '1.25.10.10-FF-002110', NULL, 'Darlin', 279, NULL, NULL, 185109),
(185110, '4.10.40.20-FF-000011', NULL, 'insulin-like growth factor-binding protein 6 isoform X1', 85, NULL, NULL, 185110),
(185111, '1.20.1070.10-FF-000992', NULL, 'Olfactory receptor B6', 223, NULL, NULL, 185111),
(185112, '1.20.58.390-FF-000285', NULL, 'Uncharacterized protein', 51, NULL, NULL, 185112),
(185113, '3.40.50.11840-FF-000008', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 2', 95, NULL, NULL, 185113),
(185114, '3.30.2170.10-FF-000001', NULL, 'Endonuclease V', 214, NULL, NULL, 185114),
(185115, '1.20.58.190-FF-000017', NULL, NULL, 143, NULL, NULL, 185115),
(185116, '3.30.160.60-FF-004411', NULL, NULL, 66, NULL, NULL, 185116),
(185117, '2.102.10.10-FF-000057', NULL, 'Predicted protein', 138, NULL, NULL, 185117),
(185118, '2.40.160.120-FF-000043', NULL, 'Oxysterol-binding protein', 188, NULL, NULL, 185118),
(185119, '2.30.110.10-FF-000047', NULL, 'Flavin reductase domain protein FMN-binding protein', 154, NULL, NULL, 185119),
(185120, '3.10.100.10-FF-000210', NULL, 'C-type lectin domain family 12 member B', 200, NULL, NULL, 185120),
(185121, '2.70.150.10-FF-000063', NULL, 'Phospholipid-transporting ATPase', 128, NULL, NULL, 185121);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(185122, '3.30.160.60-FF-003708', NULL, NULL, 30, NULL, NULL, 185122),
(185123, '3.30.200.20-FF-001952', NULL, 'Uncharacterized protein', 106, NULL, NULL, 185123),
(185124, '3.30.160.60-FF-000196', NULL, 'Zinc finger protein 1026', 28, NULL, NULL, 185124),
(185125, '3.90.550.10-FF-000175', NULL, 'Beta-1,4-mannosyltransferase bre-3', 209, NULL, NULL, 185125),
(185126, '3.40.50.720-FF-001042', NULL, '5,10-methenyltetrahydromethanopterin hydrogenase', 254, NULL, NULL, 185126),
(185127, '1.10.1450.10-FF-000130', NULL, 'Tetraspanin', 222, NULL, NULL, 185127),
(185128, '1.20.120.1200-FF-000017', NULL, 'NADH-quinone oxidoreductase subunit J', 161, NULL, NULL, 185128),
(185129, '2.30.29.30-FF-001328', NULL, 'GM06875p', 60, NULL, NULL, 185129),
(185130, '3.40.1110.10-FF-000164', NULL, 'Calcium-transporting ATPase', 188, NULL, NULL, 185130),
(185131, '2.130.10.10-FF-005480', NULL, 'WD domain containing protein', 141, NULL, NULL, 185131),
(185132, '3.30.70.330-FF-001459', NULL, NULL, 95, NULL, NULL, 185132),
(185133, '3.40.50.11980-FF-000022', NULL, 'Uncharacterized protein', 93, NULL, NULL, 185133),
(185134, '3.30.160.60-FF-001674', NULL, 'Putative zinc finger E-box-binding homeobox 2', 67, NULL, NULL, 185134),
(185135, '2.60.120.290-FF-000188', NULL, 'AGAP005526-PA', 120, NULL, NULL, 185135),
(185136, '3.30.830.10-FF-000232', NULL, 'Protein CBG17023', 122, NULL, NULL, 185136),
(185137, '1.10.720.60-FF-000009', NULL, 'Enolase-phosphatase E1', 78, NULL, NULL, 185137),
(185138, '3.40.50.2300-FF-000986', NULL, NULL, 82, NULL, NULL, 185138),
(185139, '3.20.180.20-FF-000024', NULL, 'Dynein-1-beta heavy chain, flagellar inner arm I1 complex', 118, NULL, NULL, 185139),
(185140, '1.10.10.440-FF-000019', NULL, 'Pre-mRNA-processing protein 40A', 69, NULL, NULL, 185140),
(185141, '2.10.110.10-FF-000012', NULL, 'Paxillin isoform 1', 61, NULL, NULL, 185141),
(185142, '1.20.1250.20-FF-001256', NULL, 'Solute carrier family 46, member 2', 404, NULL, NULL, 185142),
(185143, '3.40.50.300-FF-002433', NULL, 'Endoribonuclease Dicer homolog 1', 68, NULL, NULL, 185143),
(185144, '2.60.40.10-FF-003591', NULL, NULL, 97, NULL, NULL, 185144),
(185145, '3.30.420.80-FF-000008', NULL, 'Mitochondrial ribosomal protein S11', 135, NULL, NULL, 185145),
(185146, '2.60.40.10-FF-006053', NULL, NULL, 91, NULL, NULL, 185146),
(185147, '3.90.480.20-FF-000003', NULL, 'Anaerobic sulfite reductase subunit AsrC', 98, NULL, NULL, 185147),
(185148, '3.40.1190.10-FF-000051', NULL, NULL, 179, NULL, NULL, 185148),
(185149, '3.90.70.10-FF-000222', NULL, 'Cathepsin B', 147, NULL, NULL, 185149),
(185150, '2.30.40.10-FF-000079', NULL, 'Adenine deaminase 2', 98, NULL, NULL, 185150),
(185151, '1.25.10.10-FF-001997', NULL, 'Uncharacterized protein', 240, NULL, NULL, 185151),
(185152, '3.30.750.44-FF-000009', NULL, 'Retinol-binding protein 3', 81, NULL, NULL, 185152),
(185153, '4.10.60.10-FF-000104', NULL, 'Peptidyl-prolyl cis-trans isomerase', 47, NULL, NULL, 185153),
(185154, '3.30.200.20-FF-001891', NULL, NULL, 37, NULL, NULL, 185154),
(185155, '1.50.40.10-FF-000367', NULL, 'Solute carrier family 25 member 33', 150, NULL, NULL, 185155),
(185156, '3.40.50.300-FF-006362', NULL, 'Predicted protein', 140, NULL, NULL, 185156),
(185157, '3.90.79.10-FF-000045', NULL, 'mRNA-decapping enzyme 2', 135, NULL, NULL, 185157),
(185158, '1.20.1070.10-FF-000784', NULL, 'Opsin 3 (Encephalopsin, panopsin)', 108, NULL, NULL, 185158),
(185159, '3.40.50.300-FF-000292', NULL, 'ATP-dependent dethiobiotin synthetase BioD', 222, NULL, NULL, 185159),
(185160, '3.40.5.10-FF-000001', NULL, '50S ribosomal protein L9', 50, NULL, NULL, 185160),
(185161, '2.130.10.10-FF-004462', NULL, 'Pre-mRNA-processing factor 19', 300, NULL, NULL, 185161),
(185162, '3.40.109.10-FF-000037', NULL, 'Blr4539 protein', 218, NULL, NULL, 185162),
(185163, '1.25.10.10-FF-000715', NULL, 'Os11g0518900 protein', 400, NULL, NULL, 185163),
(185164, '1.10.4020.10-FF-000014', NULL, 'Uncharacterized protein', 47, NULL, NULL, 185164),
(185165, '3.40.30.10-FF-000536', NULL, 'Protein windbeutel', 134, NULL, NULL, 185165);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(185166, '2.40.30.130-FF-000004', NULL, 'Alanine--tRNA ligase', 100, NULL, NULL, 185166),
(185167, '2.60.40.1730-FF-000086', NULL, NULL, 217, NULL, NULL, 185167),
(185168, '3.30.60.270-FF-000017', NULL, 'Sortilin', 78, NULL, NULL, 185168),
(185169, '3.40.50.10470-FF-000064', NULL, 'methylthioribose-1-phosphate isomerase-like', 47, NULL, NULL, 185169),
(185170, '3.30.160.60-FF-002612', NULL, 'Uncharacterized protein', 25, NULL, NULL, 185170),
(185171, '2.60.40.10-FF-003877', NULL, NULL, 119, NULL, NULL, 185171),
(185172, '3.90.226.10-FF-000202', NULL, 'Acetyl-CoA carboxylase/pyruvate carboxylase fusion protein, putative', 266, NULL, NULL, 185172),
(185173, '2.20.28.10-FF-000039', NULL, 'Minichromosome maintenance protein MCM', 48, NULL, NULL, 185173),
(185174, '2.170.270.10-FF-000053', NULL, 'Histone-lysine N-methyltransferase', 246, NULL, NULL, 185174),
(185175, '3.50.50.60-FF-001390', NULL, 'Uncharacterized protein', 214, NULL, NULL, 185175),
(185176, '1.20.1070.10-FF-001060', NULL, 'Olfactory receptor class A (V1r-like homolog)', 167, NULL, NULL, 185176),
(185177, '2.130.10.10-FF-005687', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 156, NULL, NULL, 185177),
(185178, '3.30.1010.10-FF-000113', NULL, 'Uncharacterized protein', 108, NULL, NULL, 185178),
(185179, '2.40.70.10-FF-000108', NULL, 'Putative aspartyl protease', 179, NULL, NULL, 185179),
(185180, '3.30.1330.20-FF-000045', NULL, 'Tubulin-like protein CetZ', 125, NULL, NULL, 185180),
(185181, '1.20.120.790-FF-000011', NULL, 'Putative heat shock protein HSP 90-alpha A4', 98, NULL, NULL, 185181),
(185182, '2.10.230.10-FF-000021', NULL, 'Chaperone protein DNAj, putative', 66, NULL, NULL, 185182),
(185183, '3.40.50.1000-FF-000635', NULL, NULL, 30, NULL, NULL, 185183),
(185184, '1.10.510.10-FF-001558', NULL, 'Protein kinase, putative', 242, NULL, NULL, 185184),
(185185, '1.10.230.10-FF-000002', NULL, 'Citrate synthase', 106, NULL, NULL, 185185),
(185186, '3.30.70.1130-FF-000008', NULL, 'Eukaryotic translation initiation factor 2 subunit alpha', 68, NULL, NULL, 185186),
(185187, '3.40.120.10-FF-000058', NULL, 'Phosphomannomutase/phosphoglucomutase', 88, NULL, NULL, 185187),
(185188, '3.30.160.60-FF-006209', NULL, NULL, 30, NULL, NULL, 185188),
(185189, '2.40.70.10-FF-000030', NULL, 'Eukaryotic aspartyl protease family protein', 176, NULL, NULL, 185189),
(185190, '1.25.40.10-FF-001448', NULL, 'Pentatricopeptide repeat-containing protein At5g06540', 169, NULL, NULL, 185190),
(185191, '3.40.50.300-FF-006323', NULL, 'AGAP002581-PA', 286, NULL, NULL, 185191),
(185192, '3.30.70.330-FF-001173', NULL, 'Nuclear acid binding protein, putative', 92, NULL, NULL, 185192),
(185193, '2.60.40.1180-FF-000090', NULL, 'Alpha-glucosidase/alpha-amylase, putative', 78, NULL, NULL, 185193),
(185194, '3.30.1330.30-FF-000048', NULL, 'Nucleolar protein family a member-like protein', 124, NULL, NULL, 185194),
(185195, '1.10.510.10-FF-002452', NULL, 'Uncharacterized protein', 269, NULL, NULL, 185195),
(185196, '2.120.10.80-FF-000245', NULL, 'Dynein regulatory complex subunit 7', 308, NULL, NULL, 185196),
(185197, '3.30.70.330-FF-000211', NULL, 'Polyadenylate-binding protein', 105, NULL, NULL, 185197),
(185198, '3.30.40.10-FF-001077', NULL, 'Zinc finger protein-like 1 homolog', 69, NULL, NULL, 185198),
(185199, '2.10.250.10-FF-000016', NULL, 'Calreticulin-3', 56, NULL, NULL, 185199),
(185200, '3.30.50.10-FF-000122', NULL, 'Nuclear hormone receptor family member nhr-115', 88, NULL, NULL, 185200),
(185201, '1.10.555.10-FF-000245', NULL, NULL, 175, NULL, NULL, 185201),
(185202, '2.60.40.150-FF-000233', NULL, 'Uncharacterized protein', 132, NULL, NULL, 185202),
(185203, '3.30.750.24-FF-000003', NULL, 'Chloride anion exchanger', 142, NULL, NULL, 185203),
(185204, '1.25.40.10-FF-003977', NULL, 'Uncharacterized protein', 221, NULL, NULL, 185204),
(185205, '3.30.70.330-FF-002010', NULL, NULL, 129, NULL, NULL, 185205),
(185206, '1.10.287.110-FF-000163', NULL, 'Chaperone protein DNAJ, putative', 83, NULL, NULL, 185206),
(185207, '2.70.70.10-FF-000051', NULL, 'Phosphotransferase system, fructose-specific EI/HPr/EIIA components', 152, NULL, NULL, 185207);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(185208, '3.30.930.10-FF-000167', NULL, 'Proline--tRNA ligase', 269, NULL, NULL, 185208),
(185209, '2.90.10.10-FF-000052', NULL, 'Curculin-like (Mannose-binding) lectin family protein', 143, NULL, NULL, 185209),
(185210, '2.60.40.10-FF-003259', NULL, 'Nectin cell adhesion molecule 4a', 121, NULL, NULL, 185210),
(185211, '2.60.40.10-FF-004815', NULL, NULL, 113, NULL, NULL, 185211),
(185212, '3.30.1330.10-FF-000042', NULL, 'Uncharacterized protein', 93, NULL, NULL, 185212),
(185213, '1.10.150.20-FF-000004', NULL, 'U5 small nuclear ribonucleoprotein helicase', 56, NULL, NULL, 185213),
(185214, '3.10.20.90-FF-000561', NULL, 'Ubiquitin family protein', 77, NULL, NULL, 185214),
(185215, '1.25.40.10-FF-003803', NULL, 'Gamma-soluble NSF attachment protein', 140, NULL, NULL, 185215),
(185216, '3.40.50.1820-FF-001218', NULL, 'Lipase, putative', 365, NULL, NULL, 185216),
(185217, '3.90.1410.10-FF-000001', NULL, 'histone-lysine N-methyltransferase setd3 isoform X1', 308, NULL, NULL, 185217),
(185218, '3.30.390.10-FF-000029', NULL, 'Alpha-enolase', 42, NULL, NULL, 185218),
(185219, '2.60.40.60-FF-000362', NULL, 'FlaMIngo (Cadherin plus 7TM domain) homolog', 101, NULL, NULL, 185219),
(185220, '3.40.50.1010-FF-000285', NULL, NULL, 147, NULL, NULL, 185220),
(185221, '1.10.238.10-FF-000177', NULL, 'Troponin C Ia', 75, NULL, NULL, 185221),
(185222, '1.10.510.10-FF-002339', NULL, 'Uncharacterized protein', 283, NULL, NULL, 185222),
(185223, '1.25.40.280-FF-000001', NULL, 'programmed cell death 6-interacting protein-like isoform X1', 360, NULL, NULL, 185223),
(185224, '2.60.40.10-FF-005389', NULL, NULL, 54, NULL, NULL, 185224),
(185225, '3.80.10.10-FF-000775', NULL, 'Predicted protein', 100, NULL, NULL, 185225),
(185226, '1.20.140.40-FF-000041', NULL, 'Pectinesterase inhibitor 8', 150, NULL, NULL, 185226),
(185227, '1.20.1110.10-FF-000254', NULL, NULL, 133, NULL, NULL, 185227),
(185228, '1.25.40.20-FF-000546', NULL, 'Ankyrin repeats (Many copies)/Ankyrin repeats (3 copies), putative', 315, NULL, NULL, 185228),
(185229, '3.80.10.10-FF-003237', NULL, 'Uncharacterized protein', 188, NULL, NULL, 185229),
(185230, '1.10.418.10-FF-000264', NULL, 'Uncharacterized protein', 45, NULL, NULL, 185230),
(185231, '1.25.40.10-FF-000313', NULL, 'Transmembrane and tetratricopeptide repeat containing 1', 84, NULL, NULL, 185231),
(185232, '1.25.10.10-FF-000154', NULL, 'Phosphoinositide 3-kinase regulatory subunit 4', 129, NULL, NULL, 185232),
(185233, '3.40.190.10-FF-000006', NULL, 'HTH-type transcriptional regulator CysB', 112, NULL, NULL, 185233),
(185234, '2.60.120.620-FF-000057', NULL, 'Uncharacterized protein', 196, NULL, NULL, 185234),
(185235, '1.10.1070.11-FF-000001', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', 204, NULL, NULL, 185235),
(185236, '2.30.30.40-FF-000621', NULL, 'Uncharacterized protein', 44, NULL, NULL, 185236),
(185237, '1.10.287.130-FF-000169', NULL, 'Sensor histidine kinase', 68, NULL, NULL, 185237),
(185238, '1.10.287.1490-FF-000033', NULL, 'GM14462', 195, NULL, NULL, 185238),
(185239, '1.20.120.1200-FF-000006', NULL, 'NADH-quinone oxidoreductase subunit J', 162, NULL, NULL, 185239),
(185240, '3.40.50.200-FF-000054', NULL, 'Uncharacterized protein', 228, NULL, NULL, 185240),
(185241, '3.30.460.90-FF-000008', NULL, 'Mitochondrial elongation factor 2', 191, NULL, NULL, 185241),
(185242, '3.40.50.300-FF-007790', NULL, 'Uncharacterized protein', 49, NULL, NULL, 185242),
(185243, '1.20.1280.50-FF-000076', NULL, 'F-box/WD repeat-containing protein 12', 77, NULL, NULL, 185243),
(185244, '3.30.572.10-FF-000031', NULL, 'Uncharacterized protein', 35, NULL, NULL, 185244),
(185245, '3.40.850.10-FF-000006', NULL, 'Kinesin-like protein', 361, NULL, NULL, 185245),
(185246, '1.25.40.10-FF-000543', NULL, 'Transmembrane and tetratricopeptide repeat containing 4', 154, NULL, NULL, 185246),
(185247, '1.20.890.10-FF-000015', NULL, 'cAMP-dependent protein kinase type II regulatory subunit', 43, NULL, NULL, 185247),
(185248, '3.80.10.10-FF-001051', NULL, 'Leucine-rich repeat-containing 23', 137, NULL, NULL, 185248);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(185249, '1.10.3720.10-FF-000140', NULL, 'ABC transporter, permease protein', 228, NULL, NULL, 185249),
(185250, '2.60.60.20-FF-000037', NULL, 'Phospholipase C', 120, NULL, NULL, 185250),
(185251, '3.30.460.10-FF-000092', NULL, 'Poly(A) polymerase, putative', 151, NULL, NULL, 185251),
(185252, '3.30.460.80-FF-000005', NULL, 'NADH dehydrogenase subunit 9', 125, NULL, NULL, 185252),
(185253, '3.30.160.60-FF-006266', NULL, NULL, 24, NULL, NULL, 185253),
(185254, '1.20.5.340-FF-000074', NULL, 'Uncharacterized protein', 68, NULL, NULL, 185254),
(185255, '3.30.70.1450-FF-000031', NULL, 'Ribosomal protein S6 glutaminyl transferase', 74, NULL, NULL, 185255),
(185256, '3.10.350.10-FF-000020', NULL, 'Peptidoglycan-binding LysM domain-containing protein', 61, NULL, NULL, 185256),
(185257, '3.40.140.10-FF-000267', NULL, 'Cytidine/deoxycytidylate deaminase family protein', 111, NULL, NULL, 185257),
(185258, '2.30.22.10-FF-000003', NULL, 'GrpE protein homolog', 63, NULL, NULL, 185258),
(185259, '3.40.50.300-FF-005867', NULL, 'ATP-dependent DNA helicase recQ', 117, NULL, NULL, 185259),
(185260, '2.60.120.200-FF-000667', NULL, 'Uncharacterized protein', 72, NULL, NULL, 185260),
(185261, '1.10.238.10-FF-000519', NULL, 'EF hand family protein', 92, NULL, NULL, 185261),
(185262, '3.30.505.10-FF-000056', NULL, 'Transcription elongation factor Spt6', 107, NULL, NULL, 185262),
(185263, '1.10.8.720-FF-000072', NULL, 'Predicted protein', 135, NULL, NULL, 185263),
(185264, '3.30.40.10-FF-001818', NULL, 'Uncharacterized protein', 79, NULL, NULL, 185264),
(185265, '3.20.20.80-FF-000529', NULL, '1,4-alpha-glucan branching enzyme, putative', 163, NULL, NULL, 185265),
(185266, '3.20.20.70-FF-000526', NULL, 'tRNA-dihydrouridine synthase 2, putative', 256, NULL, NULL, 185266),
(185267, '1.10.10.10-FF-000743', NULL, 'Rrf2 family transcriptional regulator', 149, NULL, NULL, 185267),
(185268, '3.30.160.60-FF-002337', NULL, 'chorion transcription factor Cf2 isoform X3', 27, NULL, NULL, 185268),
(185269, '2.60.40.10-FF-003798', NULL, NULL, 105, NULL, NULL, 185269),
(185270, '3.40.50.1000-FF-000405', NULL, 'Phospholysine phosphohistidine inorganic pyrophosphate phosphatase, putative', 48, NULL, NULL, 185270),
(185271, '3.90.70.10-FF-000851', NULL, 'Uncharacterized protein', 109, NULL, NULL, 185271),
(185272, '2.40.50.100-FF-000174', NULL, 'ABC-type transport system ATP-binding protein (Probable substrate glycerol-3-phosphate)', 41, NULL, NULL, 185272),
(185273, '3.30.200.20-FF-001778', NULL, 'Probable serine/threonine-protein kinase DDB_G0279719', 170, NULL, NULL, 185273),
(185274, '3.40.930.10-FF-000007', NULL, 'PTS system mannitol-specific transporter subunit IICBA', 147, NULL, NULL, 185274),
(185275, '3.40.640.10-FF-000524', NULL, 'Uncharacterized protein', 120, NULL, NULL, 185275),
(185276, '3.40.50.2300-FF-001649', NULL, NULL, 222, NULL, NULL, 185276),
(185277, '3.30.200.20-FF-001514', NULL, 'Tribbles pseudokinase 3', 43, NULL, NULL, 185277),
(185278, '2.130.10.10-FF-002433', NULL, 'Periodic tryptophan protein 2', 197, NULL, NULL, 185278),
(185279, '2.60.40.10-FF-004074', NULL, NULL, 95, NULL, NULL, 185279),
(185280, '1.10.8.560-FF-000001', NULL, 'Antirestriction protein ArdA', 42, NULL, NULL, 185280),
(185281, '3.10.580.10-FF-000178', NULL, 'Cystathionine beta-synthase', 161, NULL, NULL, 185281),
(185282, '3.30.420.40-FF-000805', NULL, 'Hexokinase-2', 185, NULL, NULL, 185282),
(185283, '1.25.10.10-FF-001379', NULL, 'AP-3 complex subunit delta', 605, NULL, NULL, 185283),
(185284, '1.10.630.10-FF-000196', NULL, 'Cytochrome P450 144', 404, NULL, NULL, 185284),
(185285, '2.130.10.10-FF-005249', NULL, 'Uncharacterized protein', 285, NULL, NULL, 185285),
(185286, '3.40.50.300-FF-006098', NULL, 'Discs, large homolog 4a (Drosophila)', 184, NULL, NULL, 185286),
(185287, '2.60.40.640-FF-000115', NULL, 'Arrestin domain-containing protein 4', 54, NULL, NULL, 185287),
(185288, '1.20.1280.50-FF-000019', NULL, 'F-box only protein 3', 89, NULL, NULL, 185288),
(185289, '3.90.190.10-FF-000366', NULL, 'Predicted protein', 177, NULL, NULL, 185289);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(185290, '1.20.1560.10-FF-000748', NULL, 'ABC transporter, multidrug resistance associated protein', 104, NULL, NULL, 185290),
(185291, '4.10.960.10-FF-000001', NULL, '60S ribosomal protein L3', 92, NULL, NULL, 185291),
(185292, '1.10.10.1050-FF-000023', NULL, 'Uncharacterized protein', 69, NULL, NULL, 185292),
(185293, '3.30.200.20-FF-002054', NULL, 'Uncharacterized protein', 88, NULL, NULL, 185293),
(185294, '1.10.760.10-FF-000019', NULL, 'Di-heme cytochrome C peroxidase', 141, NULL, NULL, 185294),
(185295, '1.20.81.30-FF-000002', NULL, 'Components of type IV pilus', 117, NULL, NULL, 185295),
(185296, '2.40.50.730-FF-000008', NULL, 'DNA polymerase', 58, NULL, NULL, 185296),
(185297, '3.30.870.10-FF-000111', NULL, 'Phospholipase D1-like protein (PLD1)', 220, NULL, NULL, 185297),
(185298, '2.60.200.20-FF-000090', NULL, 'Unplaced genomic scaffold supercont1.29, whole genome shotgun sequence', 79, NULL, NULL, 185298),
(185299, '3.10.20.90-FF-000381', NULL, 'Uncharacterized protein, isoform B', 115, NULL, NULL, 185299),
(185300, '2.60.40.10-FF-000364', NULL, 'fibronectin isoform X1', 90, NULL, NULL, 185300),
(185301, '3.40.50.300-FF-007458', NULL, 'Predicted protein', 243, NULL, NULL, 185301),
(185302, '3.40.50.720-FF-001547', NULL, 'YALI0B03190p', 258, NULL, NULL, 185302),
(185303, '3.40.1110.10-FF-000484', NULL, NULL, 81, NULL, NULL, 185303),
(185304, '3.40.50.150-FF-001005', NULL, NULL, 202, NULL, NULL, 185304),
(185305, '2.30.39.10-FF-000008', NULL, 'Serpin B5 isoform B', 150, NULL, NULL, 185305),
(185306, '1.10.510.10-FF-000153', NULL, 'Tribbles homolog 2', 201, NULL, NULL, 185306),
(185307, '1.10.560.10-FF-000156', NULL, 'Uncharacterized protein', 117, NULL, NULL, 185307),
(185308, '3.90.105.10-FF-000017', NULL, 'Molybdenum cofactor synthesis domain protein', 56, NULL, NULL, 185308),
(185309, '1.10.357.50-FF-000004', NULL, 'Exocyst complex component 3', 188, NULL, NULL, 185309),
(185310, '3.40.800.20-FF-000063', NULL, 'Histone deacetylase', 124, NULL, NULL, 185310),
(185311, '3.40.140.10-FF-000060', NULL, 'Cytidine deaminase', 128, NULL, NULL, 185311),
(185312, '1.10.10.10-FF-000125', NULL, 'DNA-binding response regulator', 99, NULL, NULL, 185312),
(185313, '1.10.630.10-FF-000538', NULL, 'Os10g0179200 protein', 363, NULL, NULL, 185313),
(185314, '1.10.510.10-FF-003587', NULL, NULL, 211, NULL, NULL, 185314),
(185315, '1.20.1250.20-FF-001610', NULL, 'Tartrate MFS transporter, putative', 197, NULL, NULL, 185315),
(185316, '3.30.160.60-FF-004080', NULL, NULL, 29, NULL, NULL, 185316),
(185317, '1.10.10.10-FF-000182', NULL, 'DEP domain-containing protein 1B isoform 1', 103, NULL, NULL, 185317),
(185318, '2.60.120.10-FF-000552', NULL, 'Uncharacterized protein', 155, NULL, NULL, 185318),
(185319, '3.40.50.300-FF-004024', NULL, 'ADP-ribosylation factor-like 2', 38, NULL, NULL, 185319),
(185320, '3.30.450.20-FF-000476', NULL, 'Sensory box histidine kinase/response regulator', 131, NULL, NULL, 185320),
(185321, '1.20.5.110-FF-000297', NULL, 'Uncharacterized protein', 110, NULL, NULL, 185321),
(185322, '3.40.50.1380-FF-000024', NULL, 'Carbamoyl-phosphate synthase, putative', 149, NULL, NULL, 185322),
(185323, '3.40.50.300-FF-002495', NULL, 'Cytoplasmic dynein 2 light intermediate chain 1', 189, NULL, NULL, 185323),
(185324, '3.30.230.130-FF-000025', NULL, 'Cullin family protein', 152, NULL, NULL, 185324),
(185325, '1.10.1070.11-FF-000091', NULL, 'Uncharacterized protein', 115, NULL, NULL, 185325),
(185326, '3.40.47.10-FF-000131', NULL, 'Uncharacterized protein', 300, NULL, NULL, 185326),
(185327, '3.30.230.120-FF-000022', NULL, NULL, 192, NULL, NULL, 185327),
(185328, '3.40.50.300-FF-002551', NULL, 'ATP-dependent RNA helicase DHX33', 52, NULL, NULL, 185328),
(185329, '2.120.10.30-FF-000320', NULL, 'Saposin B domain-containing protein', 100, NULL, NULL, 185329),
(185330, '3.40.50.150-FF-001646', NULL, NULL, 194, NULL, NULL, 185330),
(185331, '1.10.357.110-FF-000011', NULL, 'ACR044Cp', 216, NULL, NULL, 185331),
(185332, '3.30.160.60-FF-002674', NULL, 'Si:dkey-7i4.21', 39, NULL, NULL, 185332),
(185333, '3.40.50.720-FF-001603', NULL, 'Dihydroflavonol 4-reductase', 155, NULL, NULL, 185333);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(185334, '3.60.20.40-FF-000038', NULL, 'Uncharacterized protein', 196, NULL, NULL, 185334),
(185335, '1.10.3520.10-FF-000041', NULL, 'Uncharacterized protein', 219, NULL, NULL, 185335),
(185336, '2.10.25.10-FF-001337', NULL, 'Predicted protein', 60, NULL, NULL, 185336),
(185337, '3.40.30.10-FF-000598', NULL, 'Thioredoxin (TrxA-2)', 110, NULL, NULL, 185337),
(185338, '3.30.160.60-FF-000538', NULL, 'zinc finger protein 853', 27, NULL, NULL, 185338),
(185339, '3.40.190.10-FF-000332', NULL, 'ABC transporter substrate-binding protein', 252, NULL, NULL, 185339),
(185340, '3.30.2130.10-FF-000004', NULL, 'Cytosolic arginine sensor for mTORC1 subunit 1', 150, NULL, NULL, 185340),
(185341, '3.30.70.2630-FF-000008', NULL, 'Telomerase reverse transcriptase', 30, NULL, NULL, 185341),
(185342, '3.90.550.10-FF-000236', NULL, 'Uncharacterized protein', 165, NULL, NULL, 185342),
(185343, '1.10.580.10-FF-000039', NULL, 'Citrate synthase', 228, NULL, NULL, 185343),
(185344, '2.60.40.10-FF-000038', NULL, 'Neuronal cell adhesion molecule', 106, NULL, NULL, 185344),
(185345, '1.20.1640.10-FF-000013', NULL, 'PaTched Related family', 199, NULL, NULL, 185345),
(185346, '2.60.40.10-FF-003815', NULL, NULL, 145, NULL, NULL, 185346),
(185347, '3.30.450.40-FF-000291', NULL, 'cGMP-specific 3'',5''-cyclic phosphodiesterase', 35, NULL, NULL, 185347),
(185348, '3.40.50.300-FF-000371', NULL, 'RAB40C, member RAS oncogene family', 183, NULL, NULL, 185348),
(185349, '2.60.40.10-FF-003759', NULL, NULL, 107, NULL, NULL, 185349),
(185350, '2.60.40.10-FF-002129', NULL, 'Tyrosine-protein phosphatase 69D', 108, NULL, NULL, 185350),
(185351, '3.40.50.300-FF-004642', NULL, 'BRCA1 interacting protein C-terminal helicase 1', 55, NULL, NULL, 185351),
(185352, '2.130.10.10-FF-004350', NULL, 'Uncharacterized protein', 95, NULL, NULL, 185352),
(185353, '2.60.40.1120-FF-000004', NULL, 'Carboxypeptidase E', 95, NULL, NULL, 185353),
(185354, '1.50.40.10-FF-000249', NULL, 'Solute carrier family 25 member 10', 182, NULL, NULL, 185354),
(185355, '3.40.30.10-FF-000654', NULL, 'Dolichyl-diphosphooligosaccharide--protein glycosyltransferase subunit, putative', 178, NULL, NULL, 185355),
(185356, '2.40.240.10-FF-000037', NULL, 'Putative glutaminyl-tRNA synthetase', 114, NULL, NULL, 185356),
(185357, '3.40.50.1980-FF-000002', NULL, 'Histidinol dehydrogenase, chloroplastic', 198, NULL, NULL, 185357),
(185358, '1.10.510.10-FF-003817', NULL, NULL, 115, NULL, NULL, 185358),
(185359, '2.40.160.10-FF-000036', NULL, 'GG16943', 206, NULL, NULL, 185359),
(185360, '1.20.5.2950-FF-000006', NULL, 'Yop proteins translocation protein L', 88, NULL, NULL, 185360),
(185361, '3.40.50.150-FF-000067', NULL, 'Salicylate/benzoate carboxyl methyltransferase', 204, NULL, NULL, 185361),
(185362, '1.25.40.10-FF-003573', NULL, 'Putative rrna processing protein rrp5', 197, NULL, NULL, 185362),
(185363, '1.10.560.10-FF-000100', NULL, 'Chaperonin 60 subunit alpha 2 chloroplastic', 105, NULL, NULL, 185363),
(185364, '3.40.50.450-FF-000106', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase', 272, NULL, NULL, 185364),
(185365, '3.90.70.10-FF-000340', NULL, 'Cysteine protease 10', 286, NULL, NULL, 185365),
(185366, '3.40.20.10-FF-000154', NULL, 'Uncharacterized protein', 126, NULL, NULL, 185366),
(185367, '1.20.58.2220-FF-000001', NULL, 'Formin-like 1, isoform CRA_c', 386, NULL, NULL, 185367),
(185368, '3.40.50.300-FF-002613', NULL, 'Zgc:172075', 284, NULL, NULL, 185368),
(185369, '3.40.50.720-FF-000024', NULL, 'Probable ATP-citrate synthase', 137, NULL, NULL, 185369),
(185370, '3.10.110.10-FF-000143', NULL, 'Ubiquitin-conjugating enzyme E2 36', 152, NULL, NULL, 185370),
(185371, '2.110.10.10-FF-000028', NULL, 'Serpentine receptor class gamma', 196, NULL, NULL, 185371),
(185372, '3.40.50.1390-FF-000027', NULL, 'Putative integrase/recombinase', 135, NULL, NULL, 185372),
(185373, '1.10.287.2900-FF-000012', NULL, 'Uncharacterized protein', 61, NULL, NULL, 185373),
(185374, '2.60.40.1130-FF-000007', NULL, 'Rab geranylgeranyl transferase like protein', 80, NULL, NULL, 185374);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(185375, '3.30.590.10-FF-000016', NULL, 'Glutamine synthetase', 335, NULL, NULL, 185375),
(185376, '2.130.10.10-FF-000016', NULL, 'Coatomer alpha subunit, putative', 290, NULL, NULL, 185376),
(185377, '1.20.120.1240-FF-000001', NULL, 'Dynamin 1 like', 254, NULL, NULL, 185377),
(185378, '3.30.70.100-FF-000058', NULL, 'Antibiotic biosynthesis monooxygenase', 94, NULL, NULL, 185378),
(185379, '3.30.200.20-FF-002172', NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 62', 62, NULL, NULL, 185379),
(185380, '1.10.1070.11-FF-000040', NULL, 'Serine/threonine-protein kinase TOR', 186, NULL, NULL, 185380),
(185381, '3.30.160.60-FF-002051', NULL, 'Krueppel-like factor 17', 29, NULL, NULL, 185381),
(185382, '2.60.120.290-FF-000183', NULL, 'Uncharacterized protein', 107, NULL, NULL, 185382),
(185383, '1.10.20.10-FF-000070', NULL, 'Nuclear transcription factor Y subunit C-3', 92, NULL, NULL, 185383),
(185384, '2.60.120.380-FF-000058', NULL, 'Uncharacterized protein', 151, NULL, NULL, 185384),
(185385, '3.30.70.260-FF-000078', NULL, 'Fis family transcriptional regulator', 79, NULL, NULL, 185385),
(185386, '3.30.565.10-FF-000059', NULL, 'Two-component sensor histidine kinase', 157, NULL, NULL, 185386),
(185387, '1.20.1640.10-FF-000064', NULL, 'PaTched Related family', 182, NULL, NULL, 185387),
(185388, '1.10.168.20-FF-000005', NULL, '40S ribosomal protein S8', 75, NULL, NULL, 185388),
(185389, '3.40.50.1440-FF-000071', NULL, 'Uncharacterized protein', 190, NULL, NULL, 185389),
(185390, '3.20.20.70-FF-000077', NULL, 'Coproporphyrinogen-III oxidase', 229, NULL, NULL, 185390),
(185391, '1.10.472.80-FF-000028', NULL, 'TBC1 domain family member 7', 136, NULL, NULL, 185391),
(185392, '1.20.1110.10-FF-000041', NULL, 'Putative phospholipid-transporting ATPase', 97, NULL, NULL, 185392),
(185393, '1.20.1250.20-FF-001043', NULL, 'Uncharacterized protein', 85, NULL, NULL, 185393),
(185394, '3.40.91.60-FF-000001', NULL, 'RNA-directed RNA polymerase L', 183, NULL, NULL, 185394),
(185395, '3.30.70.100-FF-000165', NULL, NULL, 90, NULL, NULL, 185395),
(185396, '1.10.275.40-FF-000013', NULL, 'Uncharacterized protein', 150, NULL, NULL, 185396),
(185397, '2.60.40.10-FF-005951', NULL, NULL, 92, NULL, NULL, 185397),
(185398, '3.30.890.10-FF-000005', NULL, 'methyl-CpG-binding domain protein 3 isoform X2', 41, NULL, NULL, 185398),
(185399, '3.20.20.60-FF-000074', NULL, '4-hydroxy-2-oxovalerate aldolase', 242, NULL, NULL, 185399),
(185400, '2.160.20.10-FF-000212', NULL, 'Uncharacterized protein', 334, NULL, NULL, 185400),
(185401, '3.40.50.12650-FF-000010', NULL, 'Interstrand crosslink repair protein', 183, NULL, NULL, 185401),
(185402, '3.30.160.60-FF-006322', NULL, NULL, 85, NULL, NULL, 185402),
(185403, '1.10.246.190-FF-000004', NULL, 'Autophagy protein 5', 55, NULL, NULL, 185403),
(185404, '3.40.50.150-FF-000393', NULL, 'Regulator of secondary metabolism LaeA', 173, NULL, NULL, 185404),
(185405, '2.130.10.10-FF-005980', NULL, 'Myosin heavy chain kinase A', 234, NULL, NULL, 185405),
(185406, '1.50.40.10-FF-000305', NULL, 'Uncharacterized protein', 140, NULL, NULL, 185406),
(185407, '1.20.930.80-FF-000006', NULL, 'DNA primase large subunit', 253, NULL, NULL, 185407),
(185408, '3.40.190.80-FF-000095', NULL, 'Inositol-1-monophosphatase', 138, NULL, NULL, 185408),
(185409, '1.20.58.870-FF-000007', NULL, NULL, 96, NULL, NULL, 185409),
(185410, '3.40.50.11320-FF-000004', NULL, 'Carboxypeptidase', 100, NULL, NULL, 185410),
(185411, '3.30.450.50-FF-000024', NULL, 'SNARE protein, putative', 122, NULL, NULL, 185411),
(185412, '4.10.1130.20-FF-000005', NULL, 'Cysteine and histidine-rich domain-containing protein RAR1', 73, NULL, NULL, 185412),
(185413, '3.30.450.40-FF-000021', NULL, 'Anaerobic nitric oxide reductase transcription regulator NorR', 167, NULL, NULL, 185413),
(185414, '4.10.1130.10-FF-000002', NULL, NULL, 81, NULL, NULL, 185414),
(185415, '2.70.130.10-FF-000168', NULL, NULL, 77, NULL, NULL, 185415),
(185416, '3.30.70.1230-FF-000196', NULL, 'Predicted protein', 106, NULL, NULL, 185416),
(185417, '1.10.560.10-FF-000044', NULL, 'Bardet-Biedl syndrome 12 protein', 111, NULL, NULL, 185417);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(185418, '3.30.70.330-FF-003090', NULL, NULL, 105, NULL, NULL, 185418),
(185419, '3.90.70.10-FF-000284', NULL, 'Uncharacterized protein', 313, NULL, NULL, 185419),
(185420, '1.10.275.30-FF-000010', NULL, 'DEAD_2 domain protein', 42, NULL, NULL, 185420),
(185421, '1.25.40.10-FF-004989', NULL, 'Intraflagellar transport protein', 403, NULL, NULL, 185421),
(185422, '2.10.25.10-FF-000674', NULL, 'Mucin-2', 60, NULL, NULL, 185422),
(185423, '3.90.550.10-FF-000287', NULL, 'Lipopolysaccharide biosynthesis glycosyltransferase', 168, NULL, NULL, 185423),
(185424, '3.90.1440.10-FF-000008', NULL, 'Uncharacterized protein', 143, NULL, NULL, 185424),
(185425, '1.20.58.340-FF-000023', NULL, 'Magnesium transporter MRS2-E', 206, NULL, NULL, 185425),
(185426, '3.30.160.60-FF-002730', NULL, 'Blast:Zinc finger protein 568', 27, NULL, NULL, 185426),
(185427, '4.10.240.10-FF-000109', NULL, 'Fungal specific transcription factor', 66, NULL, NULL, 185427),
(185428, '2.60.40.60-FF-000536', NULL, 'Uncharacterized protein', 110, NULL, NULL, 185428),
(185429, '3.30.200.20-FF-001278', NULL, 'Protein kinase superfamily protein', 81, NULL, NULL, 185429),
(185430, '1.10.510.10-FF-002513', NULL, 'Predicted protein', 334, NULL, NULL, 185430),
(185431, '3.30.565.10-FF-000115', NULL, 'PAS domain-containing sensor histidine kinase', 153, NULL, NULL, 185431),
(185432, '3.40.50.11310-FF-000001', NULL, 'Phosphonate C-P lyase system protein PhnH', 194, NULL, NULL, 185432),
(185433, '3.30.420.40-FF-000249', NULL, 'Actin-related protein, putative', 161, NULL, NULL, 185433),
(185434, '2.10.25.10-FF-000781', NULL, 'Attractin', 37, NULL, NULL, 185434),
(185435, '3.30.870.10-FF-000173', NULL, 'Uncharacterized protein', 181, NULL, NULL, 185435),
(185436, '1.10.840.10-FF-000026', NULL, 'GTP/GDP exchange factor for Rsr1 protein', 240, NULL, NULL, 185436),
(185437, '2.20.20.110-FF-000001', NULL, 'DNA repair protein complementing XP-C cells', 51, NULL, NULL, 185437),
(185438, '3.30.70.1660-FF-000032', NULL, 'Uncharacterized protein', 55, NULL, NULL, 185438),
(185439, '3.30.70.330-FF-001852', NULL, NULL, 112, NULL, NULL, 185439),
(185440, '3.30.40.10-FF-001291', NULL, 'Uncharacterized protein', 67, NULL, NULL, 185440),
(185441, '2.60.40.60-FF-000643', NULL, 'AGAP004166-PA', 116, NULL, NULL, 185441),
(185442, '2.60.200.20-FF-000106', NULL, 'FHA domain family protein', 130, NULL, NULL, 185442),
(185443, '3.40.50.2000-FF-001054', NULL, 'Uncharacterized protein', 113, NULL, NULL, 185443),
(185444, '3.30.460.80-FF-000011', NULL, 'Uncharacterized protein', 76, NULL, NULL, 185444),
(185445, '3.30.9.10-FF-000229', NULL, 'Uncharacterized protein', 105, NULL, NULL, 185445),
(185446, '3.30.800.10-FF-000017', NULL, '1-phosphatidylinositol 3-phosphate 5-kinase', 147, NULL, NULL, 185446),
(185447, '3.40.50.2300-FF-001144', NULL, NULL, 140, NULL, NULL, 185447),
(185448, '2.60.40.10-FF-002511', NULL, 'NCAM (Neural cell adhesion molecule) homolog', 94, NULL, NULL, 185448),
(185449, '3.40.50.200-FF-000048', NULL, 'Peptidase S8 and S53 subtilisin kexin sedolisin', 380, NULL, NULL, 185449),
(185450, '3.40.50.10140-FF-000038', NULL, 'interleukin-18 receptor 1 isoform X3', 82, NULL, NULL, 185450),
(185451, '3.60.10.10-FF-000377', NULL, 'Uncharacterized protein', 88, NULL, NULL, 185451),
(185452, '3.40.50.10130-FF-000035', NULL, 'Expressed protein', 200, NULL, NULL, 185452),
(185453, '2.40.50.100-FF-000005', NULL, 'Acetyl-CoA carboxylase 1', 72, NULL, NULL, 185453),
(185454, '2.130.10.10-FF-003568', NULL, 'Predicted protein', 274, NULL, NULL, 185454),
(185455, '3.90.230.10-FF-000033', NULL, 'xaa-Pro dipeptidase isoform X2', 217, NULL, NULL, 185455),
(185456, '3.30.40.100-FF-000013', NULL, 'Uncharacterized protein', 55, NULL, NULL, 185456),
(185457, '1.25.10.10-FF-002166', NULL, 'Uncharacterized protein', 504, NULL, NULL, 185457),
(185458, '1.25.10.10-FF-001733', NULL, 'Predicted protein', 195, NULL, NULL, 185458),
(185459, '1.10.8.60-FF-000257', NULL, 'Transitional endoplasmic reticulum ATPase TER94-like Protein', 95, NULL, NULL, 185459),
(185460, '3.40.525.10-FF-000010', NULL, 'motile sperm domain-containing protein 2 isoform X1', 285, NULL, NULL, 185460);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(185461, '1.20.58.2220-FF-000052', NULL, 'Dishevelled-associated activator of morphogenesis 1a', 151, NULL, NULL, 185461),
(185462, '3.40.630.30-FF-000530', NULL, 'Predicted protein', 87, NULL, NULL, 185462),
(185463, '3.10.20.90-FF-000555', NULL, 'Cdc24', 85, NULL, NULL, 185463),
(185464, '2.40.440.10-FF-000018', NULL, 'Putative L,D-transpeptidase YciB', 132, NULL, NULL, 185464),
(185465, '1.20.58.860-FF-000004', NULL, 'Ubiquitin carboxyl-terminal hydrolase calypso', 91, NULL, NULL, 185465),
(185466, '3.90.550.10-FF-000517', NULL, 'Glycosyl transferase family 2', 251, NULL, NULL, 185466),
(185467, '2.10.25.10-FF-000399', NULL, 'Laminin subunit gamma 2', 52, NULL, NULL, 185467),
(185468, '3.40.630.30-FF-000586', NULL, 'Uncharacterized protein', 209, NULL, NULL, 185468),
(185469, '3.30.160.60-FF-000257', NULL, 'ZXD family zinc finger C', 31, NULL, NULL, 185469),
(185470, '1.25.10.10-FF-002222', NULL, 'Uncharacterized protein', 402, NULL, NULL, 185470),
(185471, '1.10.10.60-FF-000409', NULL, 'Sigma-54-dependent Fis family transcriptional regulator', 57, NULL, NULL, 185471),
(185472, '3.30.9.10-FF-000274', NULL, 'Uncharacterized protein', 91, NULL, NULL, 185472),
(185473, '3.30.160.60-FF-003978', NULL, 'GD17432', 77, NULL, NULL, 185473),
(185474, '2.120.10.30-FF-000601', NULL, 'Dipeptidyl-peptidase 5', 88, NULL, NULL, 185474),
(185475, '3.30.70.20-FF-000014', NULL, 'Cytochrome c nitrite reductase, Fe-S protein', 54, NULL, NULL, 185475),
(185476, '3.30.505.10-FF-000230', NULL, NULL, 91, NULL, NULL, 185476),
(185477, '3.40.50.1440-FF-000008', NULL, 'Tubulin alpha chain', 268, NULL, NULL, 185477),
(185478, '3.30.70.330-FF-001796', NULL, NULL, 108, NULL, NULL, 185478),
(185479, '3.30.450.40-FF-000072', NULL, 'PAS domain-containing protein', 182, NULL, NULL, 185479),
(185480, '3.10.110.10-FF-000036', NULL, 'ubiquitin-conjugating enzyme E2Q-like protein 1', 163, NULL, NULL, 185480),
(185481, '2.30.29.30-FF-001172', NULL, 'Meiotically up-regulated gene 183 protein', 92, NULL, NULL, 185481),
(185482, '1.25.10.10-FF-001677', NULL, 'Nipped-B protein', 300, NULL, NULL, 185482),
(185483, '2.40.420.20-FF-000026', NULL, 'Efflux transporter periplasmic adaptor subunit', 61, NULL, NULL, 185483),
(185484, '3.40.50.1820-FF-001724', NULL, 'Serine carboxypeptidase-like 33', 112, NULL, NULL, 185484),
(185485, '3.30.830.10-FF-000171', NULL, 'Axl1p', 292, NULL, NULL, 185485),
(185486, '1.10.8.60-FF-000369', NULL, 'Uncharacterized protein', 74, NULL, NULL, 185486),
(185487, '3.30.70.330-FF-001577', NULL, NULL, 127, NULL, NULL, 185487),
(185488, '3.30.160.60-FF-006092', NULL, NULL, 24, NULL, NULL, 185488),
(185489, '3.20.20.70-FF-000818', NULL, NULL, 283, NULL, NULL, 185489),
(185490, '3.30.1360.120-FF-000061', NULL, 'Aminomethyltransferase', 145, NULL, NULL, 185490),
(185491, '3.30.1330.10-FF-000036', NULL, 'Selenide, water dikinase', 152, NULL, NULL, 185491),
(185492, '1.10.238.10-FF-000407', NULL, 'Voltage-gated Ion Channel (VIC) Superfamily', 61, NULL, NULL, 185492),
(185493, '3.30.710.10-FF-000010', NULL, 'Potassium voltage-gated channel subfamily B member', 130, NULL, NULL, 185493),
(185494, '3.40.640.10-FF-000075', NULL, 'Maltose regulon modulator MalY', 223, NULL, NULL, 185494),
(185495, '3.30.50.10-FF-000004', NULL, 'Retinoic acid receptor beta isoform', 97, NULL, NULL, 185495),
(185496, '2.60.40.60-FF-001099', NULL, 'Cadherin 31', 106, NULL, NULL, 185496),
(185497, '3.40.50.300-FF-006036', NULL, 'Uncharacterized protein', 129, NULL, NULL, 185497),
(185498, '3.30.70.1230-FF-000252', NULL, 'Protein kinase, putative', 191, NULL, NULL, 185498),
(185499, '1.10.10.60-FF-000005', NULL, 'POU domain protein', 70, NULL, NULL, 185499),
(185500, '3.40.970.10-FF-000010', NULL, NULL, 49, NULL, NULL, 185500),
(185501, '1.20.1280.50-FF-000250', NULL, 'F-box/LRR-repeat/kelch-repeat protein At1g09650', 108, NULL, NULL, 185501),
(185502, '2.60.40.790-FF-000076', NULL, '15.4 kDa class V heat shock protein', 109, NULL, NULL, 185502),
(185503, '3.40.1350.10-FF-000035', NULL, 'tRNA-splicing endonuclease subunit Sen15', 98, NULL, NULL, 185503);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(185504, '2.40.70.10-FF-000092', NULL, 'Aspartic endopeptidase (AP1)', 180, NULL, NULL, 185504),
(185505, '1.10.287.490-FF-000001', NULL, 'Surfactin synthase subunit 3', 55, NULL, NULL, 185505),
(185506, '3.30.160.60-FF-002781', NULL, 'PR/SET domain 2', 89, NULL, NULL, 185506),
(185507, '2.60.120.200-FF-000032', NULL, 'pikachurin isoform X1', 180, NULL, NULL, 185507),
(185508, '1.25.40.10-FF-002224', NULL, 'Alpha-snap', 275, NULL, NULL, 185508),
(185509, '3.40.50.150-FF-000281', NULL, 'Thiocyanate methyltransferase 1', 227, NULL, NULL, 185509),
(185510, '2.60.40.640-FF-000059', NULL, 'Vacuolar protein sorting-associated protein-like protein', 147, NULL, NULL, 185510),
(185511, '3.40.50.980-FF-000023', NULL, 'Putative peptide synthase', 120, NULL, NULL, 185511),
(185512, '2.160.20.10-FF-000100', NULL, 'Right handed beta helix region', 249, NULL, NULL, 185512),
(185513, '1.20.1280.140-FF-000004', NULL, 'Uncharacterized protein', 87, NULL, NULL, 185513),
(185514, '2.130.10.10-FF-002107', NULL, 'POC1 centriolar protein homolog isoform X2', 94, NULL, NULL, 185514),
(185515, '2.60.40.10-FF-003708', NULL, NULL, 87, NULL, NULL, 185515),
(185516, '2.60.40.10-FF-004372', NULL, NULL, 89, NULL, NULL, 185516),
(185517, '3.30.160.60-FF-001887', NULL, 'Zinc finger protein 398', 48, NULL, NULL, 185517),
(185518, '2.40.50.140-FF-001063', NULL, NULL, 100, NULL, NULL, 185518),
(185519, '1.10.10.430-FF-000011', NULL, 'Predicted protein', 60, NULL, NULL, 185519),
(185520, '1.20.58.340-FF-000079', NULL, 'Uncharacterized protein', 124, NULL, NULL, 185520),
(185521, '2.60.40.60-FF-000862', NULL, 'Uncharacterized protein', 109, NULL, NULL, 185521),
(185522, '3.40.50.300-FF-000634', NULL, 'Molybdenum import ATP-binding protein ModC', 219, NULL, NULL, 185522),
(185523, '3.40.250.10-FF-000096', NULL, 'Adenylyltransferase and sulfurtransferase uba4', 129, NULL, NULL, 185523),
(185524, '3.40.50.1820-FF-001494', NULL, 'Uncharacterized protein', 163, NULL, NULL, 185524),
(185525, '3.80.10.10-FF-001556', NULL, 'Geranylgeranyl transferase type-2 subunit alpha', 293, NULL, NULL, 185525),
(185526, '2.120.10.30-FF-000101', NULL, 'Low-density lipoprotein receptor-related protein', 310, NULL, NULL, 185526),
(185527, '3.70.10.10-FF-000062', NULL, 'DNA polymerase sliding clamp 3', 244, NULL, NULL, 185527),
(185528, '2.60.40.60-FF-000317', NULL, 'Protocadherin beta-17', 110, NULL, NULL, 185528),
(185529, '3.90.1350.10-FF-000001', NULL, 'Exotoxin A', 158, NULL, NULL, 185529),
(185530, '3.30.1330.20-FF-000039', NULL, 'Tubulin alpha chain', 115, NULL, NULL, 185530),
(185531, '3.30.565.10-FF-000273', NULL, 'Sensor histidine kinase', 159, NULL, NULL, 185531),
(185532, '1.10.10.440-FF-000014', NULL, 'rho GTPase-activating protein 5 isoform X1', 67, NULL, NULL, 185532),
(185533, '3.40.50.720-FF-001373', NULL, 'D-3-phosphoglycerate dehydrogenase, putative (SerA-2)', 85, NULL, NULL, 185533),
(185534, '2.30.30.1020-FF-000037', NULL, NULL, 46, NULL, NULL, 185534),
(185535, '3.30.870.10-FF-000061', NULL, 'Phospholipase', 178, NULL, NULL, 185535),
(185536, '1.20.5.170-FF-000186', NULL, 'Basic-leucine zipper (BZIP) transcription factor family protein', 53, NULL, NULL, 185536),
(185537, '2.70.130.10-FF-000117', NULL, NULL, 80, NULL, NULL, 185537),
(185538, '3.80.10.10-FF-002916', NULL, 'Uncharacterized protein', 79, NULL, NULL, 185538),
(185539, '1.20.144.10-FF-000119', NULL, 'Uncharacterized protein', 196, NULL, NULL, 185539),
(185540, '1.10.472.10-FF-000440', NULL, 'Cya-1', 122, NULL, NULL, 185540),
(185541, '4.10.400.10-FF-000263', NULL, 'LDL receptor repeat-containing protein egg-1', 33, NULL, NULL, 185541),
(185542, '1.10.287.110-FF-000051', NULL, 'Molecular chaperone DnaJ', 113, NULL, NULL, 185542),
(185543, '1.20.1250.20-FF-000879', NULL, 'Putative alternative sulfate transporter protein', 201, NULL, NULL, 185543),
(185544, '2.120.10.30-FF-000371', NULL, 'Predicted protein', 136, NULL, NULL, 185544),
(185545, '1.20.58.1040-FF-000012', NULL, 'Predicted protein', 88, NULL, NULL, 185545),
(185546, '2.60.40.10-FF-002281', NULL, 'Protein sidekick homolog', 101, NULL, NULL, 185546);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(185547, '3.30.450.40-FF-000133', NULL, 'IclR family transcriptional regulator', 181, NULL, NULL, 185547),
(185548, '2.30.29.150-FF-000005', NULL, 'FACT complex subunit SPT16', 165, NULL, NULL, 185548),
(185549, '3.40.50.720-FF-000884', NULL, 'Formate dehydrogenase', 186, NULL, NULL, 185549),
(185550, '3.30.70.80-FF-000037', NULL, 'Uncharacterized protein', 93, NULL, NULL, 185550),
(185551, '3.30.420.40-FF-000137', NULL, 'Actin-related protein 4', 41, NULL, NULL, 185551),
(185552, '3.80.20.20-FF-000020', NULL, 'Tyrosine-protein kinase receptor', 50, NULL, NULL, 185552),
(185553, '3.40.190.10-FF-000113', NULL, 'Amino acid ABC transporter substrate-binding protein', 134, NULL, NULL, 185553),
(185554, '3.40.50.150-FF-000342', NULL, 'Probable methyltransferase PMT19', 167, NULL, NULL, 185554),
(185555, '2.90.10.10-FF-000018', NULL, 'EP1-like glycoprotein 2', 106, NULL, NULL, 185555),
(185556, '3.30.70.3150-FF-000002', NULL, 'Translation initiation factor eIF-5', 59, NULL, NULL, 185556),
(185557, '3.90.260.10-FF-000017', NULL, 'Xeroderma pigmentosum, complementation group C', 167, NULL, NULL, 185557),
(185558, '3.10.20.90-FF-000881', NULL, 'Homocysteine-inducible, endoplasmic reticulum stress-inducible, ubiquitin-like domain member 1', 60, NULL, NULL, 185558),
(185559, '3.40.50.300-FF-002383', NULL, 'ABC transporter G family member 8', 228, NULL, NULL, 185559),
(185560, '3.90.1430.10-FF-000002', NULL, 'Elongation factor like GTPase 1', 107, NULL, NULL, 185560),
(185561, '3.40.33.10-FF-000077', NULL, 'Predicted protein', 151, NULL, NULL, 185561),
(185562, '3.30.530.20-FF-000072', NULL, 'BnaC09g47310D protein', 150, NULL, NULL, 185562),
(185563, '3.40.50.300-FF-000819', NULL, 'ATP dependent RNA helicase, putative', 176, NULL, NULL, 185563),
(185564, '3.30.160.800-FF-000001', NULL, 'DNA helicase', 71, NULL, NULL, 185564),
(185565, '3.40.1170.10-FF-000044', NULL, 'Uncharacterized protein', 58, NULL, NULL, 185565),
(185566, '2.10.25.10-FF-000904', NULL, 'LAMinin related. See also lmb', 50, NULL, NULL, 185566),
(185567, '2.30.30.40-FF-000115', NULL, 'Small G protein signaling modulator 3 homolog', 70, NULL, NULL, 185567),
(185568, '3.30.60.30-FF-000011', NULL, 'reversion-inducing cysteine-rich protein with Kazal motifs isoform X1', 48, NULL, NULL, 185568),
(185569, '1.20.1310.10-FF-000022', NULL, 'Cullin-2 isoform 2', 111, NULL, NULL, 185569),
(185570, '2.60.40.10-FF-005732', NULL, NULL, 111, NULL, NULL, 185570),
(185571, '3.30.160.810-FF-000004', NULL, '50S ribosomal protein L3', 61, NULL, NULL, 185571),
(185572, '3.10.150.10-FF-000033', NULL, 'Beta sliding clamp', 190, NULL, NULL, 185572),
(185573, '1.20.58.340-FF-000028', NULL, 'Magnesium transport protein CorA', 118, NULL, NULL, 185573),
(185574, '3.40.30.10-FF-000486', NULL, 'Uncharacterized monothiol glutaredoxin F10D7.3', 114, NULL, NULL, 185574),
(185575, '1.20.1640.10-FF-000069', NULL, 'Transporter, AcrB/D/F family', 201, NULL, NULL, 185575),
(185576, '2.130.10.10-FF-001770', NULL, 'GG22870', 353, NULL, NULL, 185576),
(185577, '3.30.1610.10-FF-000018', NULL, 'Nucleoporin, putative', 144, NULL, NULL, 185577),
(185578, '1.20.58.390-FF-000228', NULL, 'Uncharacterized protein', 54, NULL, NULL, 185578),
(185579, '1.10.579.10-FF-000013', NULL, 'DNA photolyase, putative', 187, NULL, NULL, 185579),
(185580, '2.60.34.10-FF-000041', NULL, 'Endoplasmic reticulum chaperone BiP', 96, NULL, NULL, 185580),
(185581, '1.10.1200.10-FF-000090', NULL, 'Nonribosomal peptide synthetase 6', 74, NULL, NULL, 185581),
(185582, '3.40.30.10-FF-000828', NULL, 'P4HB isoform 13', 68, NULL, NULL, 185582),
(185583, '1.20.58.80-FF-000087', NULL, 'Uncharacterized protein', 119, NULL, NULL, 185583),
(185584, '2.60.120.10-FF-000395', NULL, 'cAMP-binding domain of CRP or a regulatory subunit of cAMP-dependent protein kinases', 131, NULL, NULL, 185584),
(185585, '3.40.470.10-FF-000039', NULL, NULL, 100, NULL, NULL, 185585),
(185586, '1.25.40.70-FF-000078', NULL, 'Acyl carrier protein', 171, NULL, NULL, 185586),
(185587, '2.30.30.30-FF-000112', NULL, '60S ribosomal protein RML2, mitochondrial', 77, NULL, NULL, 185587);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(185588, '3.40.30.10-FF-000542', NULL, 'Protein disulfide-isomerase', 112, NULL, NULL, 185588),
(185589, '1.50.40.10-FF-000075', NULL, 'Nicotinamide adenine dinucleotide transporter 2, mitochondrial', 293, NULL, NULL, 185589),
(185590, '3.30.200.20-FF-000255', NULL, 'serine/threonine-protein kinase Chk2 isoform X1', 93, NULL, NULL, 185590),
(185591, '2.30.29.30-FF-001121', NULL, 'Uncharacterized protein', 129, NULL, NULL, 185591),
(185592, '3.30.40.10-FF-001813', NULL, 'Uncharacterized protein', 96, NULL, NULL, 185592),
(185593, '3.10.110.10-FF-000031', NULL, 'Ubiquitin-conjugating enzyme E2 22', 154, NULL, NULL, 185593),
(185594, '1.10.20.10-FF-000300', NULL, NULL, 60, NULL, NULL, 185594),
(185595, '1.20.1600.10-FF-000067', NULL, 'Uncharacterized protein', 209, NULL, NULL, 185595),
(185596, '1.25.40.10-FF-003685', NULL, 'Pre-mRNA-splicing factor SYF1', 105, NULL, NULL, 185596),
(185597, '3.40.50.11580-FF-000003', NULL, 'Polyprotein ORF1ab', 123, NULL, NULL, 185597),
(185598, '1.10.10.10-FF-000423', NULL, 'Transcriptional regulator ArsR', 89, NULL, NULL, 185598),
(185599, '3.40.50.300-FF-002725', NULL, 'GPN-loop GTPase 2', 255, NULL, NULL, 185599),
(185600, '3.80.10.10-FF-001551', NULL, 'Protein ARABIDILLO 2', 267, NULL, NULL, 185600),
(185601, '3.40.50.150-FF-000960', NULL, NULL, 202, NULL, NULL, 185601),
(185602, '2.60.40.60-FF-000025', NULL, 'Calsyntenin 1', 98, NULL, NULL, 185602),
(185603, '3.90.70.10-FF-000514', NULL, 'Predicted protein', 64, NULL, NULL, 185603),
(185604, '3.40.50.300-FF-004530', NULL, 'ABC transporter, ATP-binding protein', 290, NULL, NULL, 185604),
(185605, '2.10.22.10-FF-000010', NULL, NULL, 42, NULL, NULL, 185605),
(185606, '3.30.930.10-FF-000408', NULL, 'Uncharacterized protein', 73, NULL, NULL, 185606),
(185607, '1.10.10.60-FF-001079', NULL, NULL, 65, NULL, NULL, 185607),
(185608, '1.10.30.10-FF-000076', NULL, 'Axial regulator YABBY 4', 67, NULL, NULL, 185608),
(185609, '3.40.720.10-FF-000076', NULL, 'Phosphoglycerol transferase MdoB-like protein, alkaline phosphatase superfamily', 295, NULL, NULL, 185609),
(185610, '3.40.850.10-FF-000299', NULL, 'Unconventional myosin-XIX', 161, NULL, NULL, 185610),
(185611, '3.40.50.300-FF-002618', NULL, 'PAPS-dependent sulfotransferase Stf3', 344, NULL, NULL, 185611),
(185612, '1.25.40.10-FF-000700', NULL, 'Soluble n-ethylmaleimide sensitive factor,putative', 281, NULL, NULL, 185612),
(185613, '3.40.50.300-FF-007907', NULL, 'Uncharacterized protein', 186, NULL, NULL, 185613),
(185614, '3.30.160.60-FF-000813', NULL, 'ras-responsive element-binding protein 1 isoform X1', 32, NULL, NULL, 185614),
(185615, '3.90.190.10-FF-000478', NULL, 'Uncharacterized protein', 347, NULL, NULL, 185615),
(185616, '3.30.1780.10-FF-000025', NULL, 'Uncharacterized protein', 86, NULL, NULL, 185616),
(185617, '1.20.1270.60-FF-000191', NULL, 'Uncharacterized protein', 247, NULL, NULL, 185617),
(185618, '1.10.20.10-FF-000244', NULL, NULL, 144, NULL, NULL, 185618),
(185619, '2.110.10.10-FF-000023', NULL, 'Matrix metalloproteinase-C', 187, NULL, NULL, 185619),
(185620, '2.30.30.770-FF-000013', NULL, NULL, 76, NULL, NULL, 185620),
(185621, '3.30.2160.10-FF-000006', NULL, 'E3 ubiquitin-protein ligase UBR5 isoform X2', 86, NULL, NULL, 185621),
(185622, '3.40.50.300-FF-008453', NULL, 'Uncharacterized protein', 55, NULL, NULL, 185622),
(185623, '1.25.40.20-FF-001889', NULL, 'Predicted protein', 176, NULL, NULL, 185623),
(185624, '1.20.120.350-FF-000233', NULL, NULL, 158, NULL, NULL, 185624),
(185625, '2.60.120.1190-FF-000020', NULL, 'RE47056p', 86, NULL, NULL, 185625),
(185626, '3.30.9.10-FF-000055', NULL, 'D-amino acid dehydrogenase small subunit', 159, NULL, NULL, 185626),
(185627, '1.25.40.20-FF-000703', NULL, 'Protein fem-1 homolog B', 141, NULL, NULL, 185627),
(185628, '1.20.1250.20-FF-001099', NULL, 'Solute carrier family 2 (facilitated glucose transporter), member 6', 440, NULL, NULL, 185628),
(185629, '2.130.10.10-FF-002219', NULL, 'Uncharacterized protein', 258, NULL, NULL, 185629),
(185630, '2.40.50.100-FF-000112', NULL, 'ABC transporter related protein', 54, NULL, NULL, 185630);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(185631, '3.40.50.720-FF-001047', NULL, 'UDP-N-acetylmuramoylalanine--D-glutamate ligase', 87, NULL, NULL, 185631),
(185632, '3.40.50.2300-FF-001149', NULL, NULL, 161, NULL, NULL, 185632),
(185633, '3.40.1090.10-FF-000043', NULL, 'Triacylglycerol lipase SDP1', 226, NULL, NULL, 185633),
(185634, '3.90.550.50-FF-000220', NULL, 'Hexosyltransferase', 138, NULL, NULL, 185634),
(185635, '3.40.50.300-FF-004182', NULL, 'Predicted protein', 219, NULL, NULL, 185635),
(185636, '3.80.10.10-FF-001500', NULL, 'Leucine-rich repeat-containing protein let-4', 142, NULL, NULL, 185636),
(185637, '1.20.120.230-FF-000040', NULL, 'TaLiN', 122, NULL, NULL, 185637),
(185638, '2.120.10.30-FF-000045', NULL, 'Blast:Protein yellow', 379, NULL, NULL, 185638),
(185639, '2.40.50.100-FF-000056', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 64, NULL, NULL, 185639),
(185640, '3.40.630.10-FF-000142', NULL, 'Acetylornithine deacetylase', 249, NULL, NULL, 185640),
(185641, '3.30.2000.30-FF-000001', NULL, 'Tail completion protein gp17', 133, NULL, NULL, 185641),
(185642, '3.40.80.10-FF-000039', NULL, 'Uncharacterized protein', 105, NULL, NULL, 185642),
(185643, '3.30.360.10-FF-000033', NULL, 'Myo-Inositol-1-Phosphate Synthase', 101, NULL, NULL, 185643),
(185644, '2.30.30.40-FF-000059', NULL, 'SH3 and PX domain-containing protein 2A', 50, NULL, NULL, 185644),
(185645, '2.30.30.30-FF-000056', NULL, '50S ribosomal subunit L24', 101, NULL, NULL, 185645),
(185646, '2.70.170.10-FF-000058', NULL, 'Ligand-gated chloride channel', 213, NULL, NULL, 185646),
(185647, '1.25.10.10-FF-003419', NULL, 'Uncharacterized protein', 322, NULL, NULL, 185647),
(185648, '4.10.280.10-FF-000095', NULL, 'Basic helix-loop-helix family protein', 70, NULL, NULL, 185648),
(185649, '2.40.70.10-FF-000322', NULL, NULL, 177, NULL, NULL, 185649),
(185650, '2.10.25.10-FF-000955', NULL, 'Neurogenic locus notch homolog protein 1', 45, NULL, NULL, 185650),
(185651, '3.40.50.300-FF-000078', NULL, 'Elongation factor 4', 184, NULL, NULL, 185651),
(185652, '3.30.70.1350-FF-000001', NULL, 'Metal tolerance protein 11', 81, NULL, NULL, 185652),
(185653, '3.60.21.10-FF-000166', NULL, 'Serine/threonine-protein phosphatase', 302, NULL, NULL, 185653),
(185654, '3.40.640.10-FF-000024', NULL, 'Kynurenine--oxoglutarate transaminase 3', 257, NULL, NULL, 185654),
(185655, '3.40.50.300-FF-006654', NULL, 'Uncharacterized protein', 87, NULL, NULL, 185655),
(185656, '3.30.1740.10-FF-000028', NULL, 'Poly [ADP-ribose] polymerase', 64, NULL, NULL, 185656),
(185657, '1.20.1310.20-FF-000025', NULL, 'Erythrocyte membrane protein 1', 199, NULL, NULL, 185657),
(185658, '3.30.40.10-FF-000919', NULL, 'Bccti6', 89, NULL, NULL, 185658),
(185659, '1.20.120.1450-FF-000002', NULL, NULL, 143, NULL, NULL, 185659),
(185660, '1.25.40.10-FF-003298', NULL, 'Os09g0555400 protein', 66, NULL, NULL, 185660),
(185661, '1.20.1250.20-FF-001217', NULL, 'Major facilitator superfamily domain-containing protein 12', 221, NULL, NULL, 185661),
(185662, '2.60.120.330-FF-000009', NULL, 'Flavonol synthase', 333, NULL, NULL, 185662),
(185663, '3.40.50.1820-FF-000201', NULL, 'Alpha/beta fold hydrolase', 280, NULL, NULL, 185663),
(185664, '3.80.10.10-FF-003349', NULL, 'Uncharacterized protein', 117, NULL, NULL, 185664),
(185665, '3.20.20.80-FF-000299', NULL, 'Uncharacterized protein', 443, NULL, NULL, 185665),
(185666, '1.25.40.10-FF-003247', NULL, 'Pentatricopeptide repeat-containing protein', 176, NULL, NULL, 185666),
(185667, '3.20.20.70-FF-000296', NULL, 'N-(5''-phosphoribosyl)anthranilate isomerase', 207, NULL, NULL, 185667),
(185668, '3.40.50.10190-FF-000238', NULL, 'Cell wall chitin catabolism-related protein, putative', 117, NULL, NULL, 185668),
(185669, '2.60.40.10-FF-002803', NULL, 'Predicted protein', 102, NULL, NULL, 185669),
(185670, '4.10.1240.10-FF-000067', NULL, 'Adhesion G protein-coupled receptor L3', 52, NULL, NULL, 185670),
(185671, '3.10.20.90-FF-000611', NULL, 'Serine/threonine protein kinase wnk1', 96, NULL, NULL, 185671),
(185672, '1.10.510.10-FF-002457', NULL, NULL, 168, NULL, NULL, 185672);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(185673, '3.20.20.70-FF-000644', NULL, NULL, 249, NULL, NULL, 185673),
(185674, '1.20.120.350-FF-000014', NULL, 'Potassium channel, voltage-gated Shaw-related subfamily C, member 4', 162, NULL, NULL, 185674),
(185675, '3.40.720.10-FF-000295', NULL, 'Uncharacterized protein', 254, NULL, NULL, 185675),
(185676, '2.60.120.310-FF-000003', NULL, 'Dopamine beta-hydroxylase', 161, NULL, NULL, 185676),
(185677, '2.70.130.10-FF-000112', NULL, NULL, 63, NULL, NULL, 185677),
(185678, '3.30.70.890-FF-000087', NULL, 'Isopentenyl-diphosphate Delta-isomerase', 137, NULL, NULL, 185678),
(185679, '3.10.20.90-FF-000443', NULL, 'Ubiquitin carboxyl-terminal hydrolase 7', 97, NULL, NULL, 185679),
(185680, '4.10.240.10-FF-000093', NULL, 'Expressed protein', 79, NULL, NULL, 185680),
(185681, '1.10.8.10-FF-000057', NULL, 'Vacuolar protein sorting 13 homolog D', 80, NULL, NULL, 185681),
(185682, '3.40.630.30-FF-000642', NULL, 'Gll0091 protein', 170, NULL, NULL, 185682),
(185683, '1.20.5.90-FF-000001', NULL, 'Protein Vpr', 45, NULL, NULL, 185683),
(185684, '2.60.200.20-FF-000151', NULL, 'Uncharacterized protein', 105, NULL, NULL, 185684),
(185685, '2.60.40.150-FF-000570', NULL, 'Extended synaptotagmin-like protein 2b', 146, NULL, NULL, 185685),
(185686, '3.40.630.30-FF-000474', NULL, 'Uncharacterized protein', 159, NULL, NULL, 185686),
(185687, '3.80.10.10-FF-000657', NULL, 'Leucine-rich repeat-containing protein 69', 262, NULL, NULL, 185687),
(185688, '1.10.8.1050-FF-000001', NULL, 'Antitoxin VbhA', 61, NULL, NULL, 185688),
(185689, '3.40.50.300-FF-007958', NULL, 'Lon peptidase 1, mitochondrial', 167, NULL, NULL, 185689),
(185690, '3.90.470.20-FF-000020', NULL, '4phosphopantetheinyl transferase EC 278', 107, NULL, NULL, 185690),
(185691, '1.10.30.10-FF-000183', NULL, 'Uncharacterized protein', 59, NULL, NULL, 185691),
(185692, '2.60.120.200-FF-000549', NULL, 'Trans-sialidase, putative', 197, NULL, NULL, 185692),
(185693, '3.40.50.300-FF-006328', NULL, 'Cell division control protein 48 homolog C', 107, NULL, NULL, 185693),
(185694, '3.30.60.30-FF-000230', NULL, 'Predicted protein', 52, NULL, NULL, 185694),
(185695, '3.90.980.20-FF-000030', NULL, NULL, 96, NULL, NULL, 185695),
(185696, '3.90.550.10-FF-000231', NULL, 'Acylneuraminate cytidylyltransferase', 223, NULL, NULL, 185696),
(185697, '1.10.3720.10-FF-000022', NULL, 'Glutathione ABC transporter permease GsiD', 207, NULL, NULL, 185697),
(185698, '2.70.170.10-FF-000114', NULL, 'Ligand-Gated ion Channel', 222, NULL, NULL, 185698),
(185699, '1.10.510.10-FF-004306', NULL, NULL, 157, NULL, NULL, 185699),
(185700, '1.10.510.10-FF-000035', NULL, 'Putative receptor-like serine/threonine-protein kinase', 211, NULL, NULL, 185700),
(185701, '2.170.270.10-FF-000019', NULL, 'PR domain zinc finger protein 1', 191, NULL, NULL, 185701),
(185702, '1.25.40.10-FF-000425', NULL, 'Pentatricopeptide repeat-containing protein At3g26540', 102, NULL, NULL, 185702),
(185703, '2.30.130.40-FF-000017', NULL, 'ATP-dependent protease La (LON) domain protein', 105, NULL, NULL, 185703),
(185704, '3.40.30.10-FF-000216', NULL, 'Putative Thioredoxin', 134, NULL, NULL, 185704),
(185705, '3.30.830.10-FF-000176', NULL, 'Mitochondrial processing peptidase alpha subunit, putative', 212, NULL, NULL, 185705),
(185706, '3.40.50.150-FF-000286', NULL, 'Leucine carboxyl methyltransferase 1', 140, NULL, NULL, 185706),
(185707, '3.30.450.40-FF-000077', NULL, 'PTS-dependent dihydroxyacetone kinase operon regulatory protein', 189, NULL, NULL, 185707),
(185708, '2.60.120.320-FF-000006', NULL, 'Thiamine pyrophosphokinase', 89, NULL, NULL, 185708),
(185709, '3.30.420.40-FF-000305', NULL, 'Exopolyphosphatase 2', 132, NULL, NULL, 185709),
(185710, '3.30.160.60-FF-003686', NULL, NULL, 22, NULL, NULL, 185710),
(185711, '3.10.28.10-FF-000015', NULL, 'Laglidadg endonuclease', 174, NULL, NULL, 185711),
(185712, '1.25.40.20-FF-000428', NULL, 'Ankyrin, isoform B', 82, NULL, NULL, 185712),
(185713, '1.20.58.530-FF-000041', NULL, NULL, 22, NULL, NULL, 185713),
(185714, '3.30.497.10-FF-000013', NULL, 'Serpin family G member 1', 165, NULL, NULL, 185714);
INSERT INTO "PUBLIC"."MODEL" VALUES
(185715, '3.40.50.1000-FF-000523', NULL, NULL, 145, NULL, NULL, 185715),
(185716, '3.30.2410.10-FF-000037', NULL, 'E3 ubiquitin-protein ligase pub2', 109, NULL, NULL, 185716),
(185717, '3.30.70.100-FF-000053', NULL, 'Antibiotic biosynthesis monooxygenase', 94, NULL, NULL, 185717),
(185718, '3.90.1410.10-FF-000006', NULL, 'Ribulose-1,5 bisphosphate carboxylase/oxygenase large subunit N-methyltransferase, chloroplastic', 261, NULL, NULL, 185718),
(185719, '1.20.120.980-FF-000028', NULL, 'Uncharacterized protein', 161, NULL, NULL, 185719),
(185720, '3.40.1350.10-FF-000030', NULL, 'tRNA-splicing endonuclease subunit Sen2', 96, NULL, NULL, 185720),
(185721, '1.20.1440.340-FF-000006', NULL, 'Galactokinase family protein', 53, NULL, NULL, 185721),
(185722, '3.90.70.10-FF-000733', NULL, 'Uncharacterized protein', 165, NULL, NULL, 185722),
(185723, '3.30.40.10-FF-001139', NULL, 'Predicted protein', 88, NULL, NULL, 185723),
(185724, '1.20.1110.10-FF-000097', NULL, 'Calcium-transporting ATPase 9 plasma membrane-type', 171, NULL, NULL, 185724),
(185725, '3.90.1110.10-FF-000017', NULL, 'DNA-directed RNA polymerase subunit beta', 217, NULL, NULL, 185725),
(185726, '2.60.120.10-FF-000670', NULL, 'Uncharacterized protein', 105, NULL, NULL, 185726),
(185727, '2.20.70.10-FF-000036', NULL, 'Phosphorylated CTD-interacting factor 1', 51, NULL, NULL, 185727),
(185728, '2.60.40.1110-FF-000001', NULL, 'cyclin-G-associated kinase isoform X2', 129, NULL, NULL, 185728),
(185729, '3.30.70.330-FF-001285', NULL, 'Minichromosome maintenance complex component 3-associated protein', 107, NULL, NULL, 185729),
(185730, '3.30.505.10-FF-000174', NULL, NULL, 121, NULL, NULL, 185730),
(185731, '1.10.238.10-FF-000733', NULL, 'GM10264', 75, NULL, NULL, 185731),
(185732, '3.40.950.10-FF-000008', NULL, 'Nuclear prelamin A recognition factor', 61, NULL, NULL, 185732),
(185733, '2.170.120.12-FF-000005', NULL, 'DNA-directed RNA polymerase family protein', 133, NULL, NULL, 185733),
(185734, '1.20.58.420-FF-000007', NULL, NULL, 106, NULL, NULL, 185734),
(185735, '1.20.5.170-FF-000293', NULL, 'cAMP-responsive element modulator a', 36, NULL, NULL, 185735),
(185736, '3.10.330.20-FF-000022', NULL, 'Chromosome 10, whole genome shotgun sequence', 76, NULL, NULL, 185736),
(185737, '3.40.720.10-FF-000368', NULL, 'Protein CBG04200', 122, NULL, NULL, 185737),
(185738, '3.30.360.10-FF-000084', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase GAPCP1 chloroplastic', 126, NULL, NULL, 185738),
(185739, '3.30.160.60-FF-002455', NULL, 'FI03704p', 33, NULL, NULL, 185739),
(185740, '3.40.30.10-FF-001110', NULL, 'Uncharacterized protein', 24, NULL, NULL, 185740),
(185741, '1.50.40.10-FF-000417', NULL, 'Uncharacterized protein', 197, NULL, NULL, 185741),
(185742, '1.10.30.10-FF-000132', NULL, 'HMG box protein, putative (AFU_orthologue AFUA_1G10040)', 93, NULL, NULL, 185742),
(185743, '1.10.238.10-FF-000172', NULL, 'Cell division control protein', 83, NULL, NULL, 185743),
(185744, '2.60.40.10-FF-005676', NULL, NULL, 83, NULL, NULL, 185744),
(185745, '1.10.220.160-FF-000010', NULL, 'Uncharacterized protein, isoform A', 92, NULL, NULL, 185745),
(185746, '2.130.10.10-FF-003563', NULL, 'Protein CBG03683', 166, NULL, NULL, 185746),
(185747, '1.25.40.180-FF-000269', NULL, NULL, 204, NULL, NULL, 185747),
(185748, '3.30.1380.20-FF-000025', NULL, 'NO signaling/Golgi transport ligand-binding domain-containing protein', 163, NULL, NULL, 185748),
(185749, '2.30.29.30-FF-001065', NULL, 'Ezrin', 75, NULL, NULL, 185749),
(185750, '1.20.120.340-FF-000011', NULL, 'Flagellar secretion chaperone FliS', 121, NULL, NULL, 185750),
(185751, '1.20.58.70-FF-000084', NULL, 't-SNARE', 121, NULL, NULL, 185751),
(185752, '1.10.730.10-FF-000080', NULL, 'Isoleucine--tRNA ligase', 185, NULL, NULL, 185752),
(185753, '3.30.160.60-FF-002056', NULL, 'transcription factor E4F1 isoform X5', 23, NULL, NULL, 185753),
(185754, '2.60.40.1180-FF-000056', NULL, 'Alpha-galactosidase A', 87, NULL, NULL, 185754),
(185755, '1.10.565.10-FF-000066', NULL, 'Nuclear Hormone Receptor family', 225, NULL, NULL, 185755);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(185756, '3.20.20.80-FF-000647', NULL, 'Predicted protein', 87, NULL, NULL, 185756),
(185757, '3.40.50.300-FF-002057', NULL, 'Pre-mRNA splicing factor RNA helicase, putative', 216, NULL, NULL, 185757),
(185758, '1.20.140.30-FF-000004', NULL, 'CBK1 kinase activator protein MOB2', 235, NULL, NULL, 185758),
(185759, '3.90.70.10-FF-000172', NULL, 'Probable ubiquitin carboxyl-terminal hydrolase 2', 384, NULL, NULL, 185759),
(185760, '3.15.10.10-FF-000009', NULL, 'phospholipid transfer protein isoform X4', 38, NULL, NULL, 185760),
(185761, '2.130.10.10-FF-005985', NULL, 'Myosin heavy chain kinase B', 229, NULL, NULL, 185761),
(185762, '2.60.40.10-FF-002455', NULL, 'Uncharacterized protein', 118, NULL, NULL, 185762),
(185763, '1.20.1280.50-FF-000194', NULL, 'Protein CBG09205', 90, NULL, NULL, 185763),
(185764, '2.60.40.10-FF-001909', NULL, 'Muscle M-line assembly protein unc-89', 100, NULL, NULL, 185764),
(185765, '3.40.50.1820-FF-000937', NULL, 'Slr1944 protein', 328, NULL, NULL, 185765),
(185766, '2.70.20.10-FF-000014', NULL, 'DNA topoisomerase I', 128, NULL, NULL, 185766),
(185767, '2.60.40.10-FF-001966', NULL, 'Uncharacterized protein', 107, NULL, NULL, 185767),
(185768, '1.10.357.120-FF-000014', NULL, 'DNA-directed RNA polymerase subunit', 142, NULL, NULL, 185768),
(185769, '1.25.40.10-FF-004141', NULL, 'Uncharacterized protein', 116, NULL, NULL, 185769),
(185770, '1.10.287.110-FF-000225', NULL, 'DnaJ homolog subfamily C member 2', 85, NULL, NULL, 185770),
(185771, '2.60.40.1170-FF-000053', NULL, 'APM2p protein', 15, NULL, NULL, 185771),
(185772, '3.30.70.330-FF-001178', NULL, 'ELAV-like protein 1 isoform X3', 101, NULL, NULL, 185772),
(185773, '3.10.610.10-FF-000001', NULL, 'General secretion pathway protein J', 122, NULL, NULL, 185773),
(185774, '3.30.160.60-FF-002382', NULL, 'Regular, isoform C', 31, NULL, NULL, 185774),
(185775, '1.10.533.10-FF-000133', NULL, 'Caspase b', 91, NULL, NULL, 185775),
(185776, '3.40.50.620-FF-000112', NULL, 'Sensor histidine kinase KdpD', 126, NULL, NULL, 185776),
(185777, '3.30.420.40-FF-000070', NULL, 'Hypoxia up-regulated protein 1', 102, NULL, NULL, 185777),
(185778, '3.40.50.150-FF-001298', NULL, NULL, 215, NULL, NULL, 185778),
(185779, '1.20.1270.60-FF-000308', NULL, 'Uncharacterized protein', 69, NULL, NULL, 185779),
(185780, '2.10.110.10-FF-000124', NULL, 'Cysteine and glycine-rich protein 1a', 73, NULL, NULL, 185780),
(185781, '3.30.420.10-FF-000651', NULL, NULL, 224, NULL, NULL, 185781),
(185782, '2.30.140.10-FF-000032', NULL, 'Polyamine aminopropyltransferase 2', 50, NULL, NULL, 185782),
(185783, '3.90.1410.10-FF-000063', NULL, 'Uncharacterized protein', 304, NULL, NULL, 185783),
(185784, '2.30.39.10-FF-000098', NULL, 'Serine protease inhibitor (Serpin-2)', 91, NULL, NULL, 185784),
(185785, '3.40.50.1400-FF-000025', NULL, 'Ferrochelatase', 175, NULL, NULL, 185785),
(185786, '1.10.533.10-FF-000127', NULL, 'Uncharacterized protein', 92, NULL, NULL, 185786),
(185787, '3.20.20.140-FF-000068', NULL, 'Amidohydrolase', 313, NULL, NULL, 185787),
(185788, '1.10.10.60-FF-000410', NULL, 'Homeobox-leucine zipper protein HOX25-like', 65, NULL, NULL, 185788),
(185789, '3.30.40.10-FF-000060', NULL, 'ubiquitin conjugation factor E4 B', 77, NULL, NULL, 185789),
(185790, '3.30.40.140-FF-000002', NULL, 'Putative RING zinc finger domain superfamily protein', 91, NULL, NULL, 185790),
(185791, '3.10.50.40-FF-000121', NULL, 'Peptidylprolyl isomerase', 86, NULL, NULL, 185791),
(185792, '2.70.20.60-FF-000001', NULL, 'Matrix protein', 154, NULL, NULL, 185792),
(185793, '3.10.50.40-FF-000065', NULL, 'Peptidylprolyl isomerase', 120, NULL, NULL, 185793),
(185794, '2.130.10.10-FF-000308', NULL, 'F-box and WD repeat domain containing 8', 227, NULL, NULL, 185794),
(185795, '2.160.10.10-FF-000043', NULL, 'K1 capsule O-acetyltransferase', 216, NULL, NULL, 185795),
(185796, '2.60.40.640-FF-000060', NULL, 'Vacuolar sorting protein 26, putative', 140, NULL, NULL, 185796),
(185797, '3.40.50.2300-FF-000132', NULL, 'Two-component response regulator', 155, NULL, NULL, 185797),
(185798, '3.90.1310.10-FF-000004', NULL, 'Penicillin-binding protein 3', 126, NULL, NULL, 185798);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(185799, '3.40.140.10-FF-000054', NULL, 'Eukaryotic translation initiation factor 3 subunit 5, putative', 183, NULL, NULL, 185799),
(185800, '1.20.1070.10-FF-001234', NULL, 'Frizzled class receptor 4', 160, NULL, NULL, 185800),
(185801, '1.25.10.10-FF-000603', NULL, 'Diaphanous, isoform E', 243, NULL, NULL, 185801),
(185802, '3.20.20.80-FF-000698', NULL, 'Alpha-amylase 4', 265, NULL, NULL, 185802),
(185803, '4.10.1000.40-FF-000007', NULL, 'Polyadenylated RNA binding protein', 69, NULL, NULL, 185803),
(185804, '1.25.40.550-FF-000009', NULL, 'protein AAR2 homolog', 182, NULL, NULL, 185804),
(185805, '2.10.90.10-FF-000066', NULL, 'Nerve growth factor a (beta polypeptide)', 142, NULL, NULL, 185805),
(185806, '1.25.10.10-FF-003296', NULL, 'Aminopeptidase', 176, NULL, NULL, 185806),
(185807, '1.10.10.60-FF-000393', NULL, 'Small nuclear RNA activating complex polypeptide 4', 49, NULL, NULL, 185807),
(185808, '6.10.300.40-FF-000003', NULL, '26S proteasome non-ATPase regulatory subunit 4', 42, NULL, NULL, 185808),
(185809, '3.10.20.90-FF-000050', NULL, 'Ubiquitin carboxyl-terminal hydrolase 13', 118, NULL, NULL, 185809),
(185810, '1.25.50.20-FF-000081', NULL, 'Aminopeptidase', 186, NULL, NULL, 185810),
(185811, '2.60.40.150-FF-000238', NULL, 'Phosphatidylinositol 3-kinase VPS34', 141, NULL, NULL, 185811),
(185812, '3.30.420.10-FF-000595', NULL, NULL, 198, NULL, NULL, 185812),
(185813, '1.10.3270.10-FF-000004', NULL, 'NAD(P)-binding protein', 72, NULL, NULL, 185813),
(185814, '2.30.180.10-FF-000028', NULL, 'Midline fasciclin, isoform E', 146, NULL, NULL, 185814),
(185815, '2.20.100.10-FF-000195', NULL, 'Uncharacterized protein', 57, NULL, NULL, 185815),
(185816, '1.20.1250.20-FF-000880', NULL, 'Nitrite transporter NrtP', 271, NULL, NULL, 185816),
(185817, '1.20.120.30-FF-000003', NULL, 'Methyl-accepting chemotaxis protein III', 162, NULL, NULL, 185817),
(185818, '3.20.20.70-FF-000695', NULL, NULL, 167, NULL, NULL, 185818),
(185819, '1.20.58.390-FF-000015', NULL, 'Gamma-aminobutyric acid (GABA-A) receptor, subunit delta', 133, NULL, NULL, 185819),
(185820, '1.20.58.390-FF-000072', NULL, 'Uncharacterized protein', 119, NULL, NULL, 185820),
(185821, '1.25.40.10-FF-003859', NULL, 'PPR repeat protein', 107, NULL, NULL, 185821),
(185822, '2.130.10.10-FF-002438', NULL, 'Small nucleolar ribonucleoprotein complex subunit (SOF1), putative', 169, NULL, NULL, 185822),
(185823, '3.10.100.10-FF-000024', NULL, 'C-type lectin domain family 4 member A', 148, NULL, NULL, 185823),
(185824, '3.90.1410.10-FF-000057', NULL, 'Uncharacterized protein', 287, NULL, NULL, 185824),
(185825, '3.20.20.70-FF-000369', NULL, 'N-(5''-phosphoribosyl)anthranilate isomerase', 219, NULL, NULL, 185825),
(185826, '1.10.287.740-FF-000003', NULL, 'Photosystem II reaction center protein Z', 62, NULL, NULL, 185826),
(185827, '2.70.160.11-FF-000059', NULL, 'Protein arginine N-methyltransferase PRMT1, putative', 170, NULL, NULL, 185827),
(185828, '1.10.455.10-FF-000024', NULL, 'Uncharacterized protein', 57, NULL, NULL, 185828),
(185829, '3.30.450.90-FF-000007', NULL, 'ComG operon protein 1', 108, NULL, NULL, 185829),
(185830, '1.10.287.80-FF-000013', NULL, 'ATP synthase subunit gamma, mitochondrial', 126, NULL, NULL, 185830),
(185831, '3.40.50.1000-FF-000517', NULL, 'Calcium-transporting ATPase', 168, NULL, NULL, 185831),
(185832, '2.60.120.330-FF-000178', NULL, 'Uncharacterized protein', 225, NULL, NULL, 185832),
(185833, '1.10.720.60-FF-000015', NULL, '2,3-diketo-5-methylthio-1-phosphopentane phosphatase', 102, NULL, NULL, 185833),
(185834, '3.40.50.410-FF-000229', NULL, 'Predicted protein', 62, NULL, NULL, 185834),
(185835, '2.130.10.10-FF-002545', NULL, 'Sensor histidine kinase TodS', 321, NULL, NULL, 185835),
(185836, '1.50.10.10-FF-000028', NULL, 'Alpha-L-fucosidase 2', 445, NULL, NULL, 185836),
(185837, '3.30.40.10-FF-001583', NULL, 'Uncharacterized protein', 86, NULL, NULL, 185837),
(185838, '1.20.1070.10-FF-001273', NULL, 'Cadherin, EGF LAG seven-pass G-type receptor 2', 147, NULL, NULL, 185838),
(185839, '1.20.1070.10-FF-001560', NULL, 'Uncharacterized protein', 171, NULL, NULL, 185839);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(185840, '2.60.40.640-FF-000003', NULL, 'beta-arrestin-1 isoform X1', 204, NULL, NULL, 185840),
(185841, '2.40.50.730-FF-000014', NULL, 'DNA polymerase', 65, NULL, NULL, 185841),
(185842, '1.10.287.70-FF-000010', NULL, 'Putative glutamate receptor ionotropic kainate 1', 157, NULL, NULL, 185842),
(185843, '2.60.120.920-FF-000203', NULL, 'Uncharacterized protein', 55, NULL, NULL, 185843),
(185844, '2.30.39.10-FF-000059', NULL, 'Serpin family B member 8', 49, NULL, NULL, 185844),
(185845, '3.40.50.300-FF-002944', NULL, 'DEAD-box ATP-dependent RNA helicase 39', 176, NULL, NULL, 185845),
(185846, '4.10.1000.30-FF-000004', NULL, 'Sut-2', 66, NULL, NULL, 185846),
(185847, '1.25.40.540-FF-000006', NULL, 'Predicted protein', 224, NULL, NULL, 185847),
(185848, '2.60.120.920-FF-000147', NULL, 'Si:dkey-207m2.4', 123, NULL, NULL, 185848),
(185849, '2.40.50.140-FF-000045', NULL, 'Phenylalanine--tRNA ligase beta subunit', 117, NULL, NULL, 185849),
(185850, '1.25.40.530-FF-000003', NULL, 'Rho GTPase-activating protein 39', 186, NULL, NULL, 185850),
(185851, '1.20.200.20-FF-000001', NULL, 'SWI5-dependent HO expression protein 2', 234, NULL, NULL, 185851),
(185852, '3.40.50.300-FF-004350', NULL, 'Protein SMG9 isoform A', 241, NULL, NULL, 185852),
(185853, '2.40.110.10-FF-000090', NULL, 'Uncharacterized protein', 83, NULL, NULL, 185853),
(185854, '3.40.50.300-FF-005873', NULL, 'ATP-dependent DNA helicase', 214, NULL, NULL, 185854),
(185855, '3.40.605.10-FF-000123', NULL, 'Predicted protein', 209, NULL, NULL, 185855),
(185856, '3.30.160.60-FF-002343', NULL, 'Zinc finger protein 33A', 46, NULL, NULL, 185856),
(185857, '3.30.930.10-FF-000285', NULL, 'Proline--tRNA ligase', 79, NULL, NULL, 185857),
(185858, '3.40.1110.10-FF-000490', NULL, NULL, 21, NULL, NULL, 185858),
(185859, '1.25.40.10-FF-000195', NULL, 'Putative TPR repeat-containing protein', 80, NULL, NULL, 185859),
(185860, '1.20.1070.10-FF-000666', NULL, 'Uncharacterized protein', 317, NULL, NULL, 185860),
(185861, '2.60.40.790-FF-000020', NULL, 'heat shock protein beta-7 isoform X1', 98, NULL, NULL, 185861),
(185862, '1.10.510.10-FF-003475', NULL, NULL, 269, NULL, NULL, 185862),
(185863, '3.20.20.140-FF-000394', NULL, 'Putative N-acetylglucosamine-6-phosphate deacetylase', 150, NULL, NULL, 185863),
(185864, '2.80.10.50-FF-000250', NULL, 'Polypeptide N-acetylgalactosaminyltransferase 2', 48, NULL, NULL, 185864),
(185865, '3.30.420.40-FF-000811', NULL, 'SWI/SNF and RSC complexes subunit arp9', 66, NULL, NULL, 185865),
(185866, '3.90.105.10-FF-000012', NULL, 'Molybdopterin molybdenumtransferase', 56, NULL, NULL, 185866),
(185867, '3.30.420.10-FF-000319', NULL, 'DNA polymerase I', 234, NULL, NULL, 185867),
(185868, '1.25.40.20-FF-000198', NULL, 'Myosin binding subunit, isoform P', 135, NULL, NULL, 185868),
(185869, '2.60.40.650-FF-000006', NULL, 'SUlfite OXidase', 127, NULL, NULL, 185869),
(185870, '3.20.19.10-FF-000016', NULL, 'Uncharacterized protein', 112, NULL, NULL, 185870),
(185871, '2.60.40.640-FF-000110', NULL, 'Uncharacterized protein', 101, NULL, NULL, 185871),
(185872, '3.10.310.20-FF-000021', NULL, NULL, 141, NULL, NULL, 185872),
(185873, '2.10.70.10-FF-000071', NULL, 'CUB and Sushi multiple domains 3', 60, NULL, NULL, 185873),
(185874, '3.30.20.10-FF-000002', NULL, 'Acidic endochitinase pcht28', 44, NULL, NULL, 185874),
(185875, '2.30.42.10-FF-000061', NULL, 'sorting nexin-27 isoform X2', 100, NULL, NULL, 185875),
(185876, '3.90.1480.20-FF-000053', NULL, 'ST3 beta-galactoside alpha-2,3-sialyltransferase 1,-like 3', 169, NULL, NULL, 185876),
(185877, '3.40.970.10-FF-000009', NULL, NULL, 47, NULL, NULL, 185877),
(185878, '3.50.4.10-FF-000033', NULL, 'Protein let-653', 84, NULL, NULL, 185878),
(185879, '1.20.5.190-FF-000051', NULL, 'Myosin-VIIa', 54, NULL, NULL, 185879),
(185880, '3.30.720.170-FF-000002', NULL, 'Perilipin', 13, NULL, NULL, 185880),
(185881, '3.40.30.10-FF-000267', NULL, 'Peroxidoxin bcpB', 153, NULL, NULL, 185881),
(185882, '3.30.160.60-FF-004473', NULL, NULL, 38, NULL, NULL, 185882),
(185883, '1.20.5.190-FF-000012', NULL, 'Myosin VIIA', 50, NULL, NULL, 185883);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(185884, '1.20.1250.20-FF-000767', NULL, 'Equilibrative nucleoside transporter, putative', 393, NULL, NULL, 185884),
(185885, '1.10.287.90-FF-000016', NULL, 'Cytochrome c oxidase subunit 2', 52, NULL, NULL, 185885),
(185886, '2.60.120.10-FF-000664', NULL, '12-dihydroxy-3-keto-5-methylthiopentene dioxygenase 4', 118, NULL, NULL, 185886),
(185887, '3.30.1360.70-FF-000016', NULL, 'Arginine--tRNA ligase', 99, NULL, NULL, 185887),
(185888, '3.30.60.30-FF-000224', NULL, 'Uncharacterized protein', 55, NULL, NULL, 185888),
(185889, '1.10.287.110-FF-000337', NULL, 'Chaperone protein dnaJ 49', 76, NULL, NULL, 185889),
(185890, '1.20.1560.10-FF-000299', NULL, 'Uncharacterized protein', 49, NULL, NULL, 185890),
(185891, '3.30.70.1560-FF-000002', NULL, 'Pseudouridine synthase', 74, NULL, NULL, 185891),
(185892, '3.80.10.10-FF-001225', NULL, 'Antagonist of mitotic exit network protein 1', 98, NULL, NULL, 185892),
(185893, '2.130.10.10-FF-000640', NULL, 'Splicing factor 3B subunit 3', 369, NULL, NULL, 185893),
(185894, '3.40.50.300-FF-007964', NULL, 'Uncharacterized protein', 165, NULL, NULL, 185894),
(185895, '2.60.40.150-FF-000620', NULL, 'Predicted protein', 146, NULL, NULL, 185895),
(185896, '3.40.50.300-FF-007784', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', 52, NULL, NULL, 185896),
(185897, '1.25.40.20-FF-000254', NULL, 'Ankyrin repeat and SOCS box containing 2', 127, NULL, NULL, 185897),
(185898, '2.30.29.30-FF-000896', NULL, 'Predicted protein', 131, NULL, NULL, 185898),
(185899, '1.10.510.10-FF-002165', NULL, 'Os10g0141200 protein', 222, NULL, NULL, 185899),
(185900, '3.30.70.330-FF-002072', NULL, NULL, 84, NULL, NULL, 185900),
(185901, '2.60.120.1440-FF-000022', NULL, 'Probable transmembrane sensor', 123, NULL, NULL, 185901),
(185902, '2.70.130.10-FF-000062', NULL, NULL, 142, NULL, NULL, 185902),
(185903, '3.40.50.11140-FF-000001', NULL, 'Transcription-repair-coupling factor', 97, NULL, NULL, 185903),
(185904, '3.30.1960.10-FF-000011', NULL, 'Methyltransferase TYW3, putative', 229, NULL, NULL, 185904),
(185905, '1.20.1250.20-FF-000548', NULL, 'Monocarboxylate permease', 192, NULL, NULL, 185905),
(185906, '1.10.287.690-FF-000022', NULL, 'Predicted protein', 67, NULL, NULL, 185906),
(185907, '1.10.167.10-FF-000034', NULL, 'Related to RAX1-Protein involved in determination of budding patterns', 123, NULL, NULL, 185907),
(185908, '1.10.510.10-FF-003582', NULL, NULL, 213, NULL, NULL, 185908),
(185909, '2.40.110.10-FF-000033', NULL, 'Acyl-[acyl-carrier-protein] dehydrogenase MbtN', 107, NULL, NULL, 185909),
(185910, '3.20.20.70-FF-000588', NULL, NULL, 86, NULL, NULL, 185910),
(185911, '1.10.510.10-FF-004200', NULL, NULL, 221, NULL, NULL, 185911),
(185912, '1.20.5.350-FF-000026', NULL, NULL, 88, NULL, NULL, 185912),
(185913, '3.30.40.10-FF-001526', NULL, 'Par-2 protein', 109, NULL, NULL, 185913),
(185914, '3.65.10.10-FF-000024', NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', 184, NULL, NULL, 185914),
(185915, '3.40.50.620-FF-000854', NULL, 'Predicted protein', 234, NULL, NULL, 185915),
(185916, '3.30.2350.20-FF-000041', NULL, NULL, 193, NULL, NULL, 185916),
(185917, '3.30.70.330-FF-001465', NULL, '31 kDa ribonucleoprotein, chloroplastic', 131, NULL, NULL, 185917),
(185918, '1.20.120.1750-FF-000154', NULL, 'RBR-type E3 ubiquitin transferase', 77, NULL, NULL, 185918),
(185919, '1.10.510.10-FF-004312', NULL, NULL, 152, NULL, NULL, 185919),
(185920, '2.70.150.10-FF-000057', NULL, 'Cation-transporting ATPase', 158, NULL, NULL, 185920),
(185921, '3.30.465.10-FF-000001', NULL, 'D-2-hydroxyglutarate dehydrogenase, mitochondrial', 121, NULL, NULL, 185921),
(185922, '1.10.287.550-FF-000008', NULL, 'Arylsulfatase D', 59, NULL, NULL, 185922),
(185923, '2.60.40.10-FF-000656', NULL, 'collagen alpha-1(XIV) chain isoform X2', 95, NULL, NULL, 185923),
(185924, '1.50.40.10-FF-000182', NULL, 'ADP/ATP mitochondrial carrier-like protein', 299, NULL, NULL, 185924),
(185925, '3.30.830.10-FF-000283', NULL, 'Uncharacterized protein', 214, NULL, NULL, 185925),
(185926, '1.25.10.10-FF-001946', NULL, 'CYtoKinesis defect', 296, NULL, NULL, 185926);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(185927, '4.10.640.10-FF-000022', NULL, 'Protein CBR-MRPS-18B', 64, NULL, NULL, 185927),
(185928, '1.25.40.20-FF-001890', NULL, 'Protein 21.1', 174, NULL, NULL, 185928),
(185929, '1.20.930.40-FF-000023', NULL, 'Uncharacterized protein', 183, NULL, NULL, 185929),
(185930, '1.20.5.340-FF-000023', NULL, 'Rho-associated protein kinase 1', 166, NULL, NULL, 185930),
(185931, '3.40.50.720-FF-001098', NULL, 'Methionine adenosyltransferase 2 subunit beta', 299, NULL, NULL, 185931),
(185932, '3.40.50.10190-FF-000244', NULL, 'DNA ligase', 91, NULL, NULL, 185932),
(185933, '2.30.36.90-FF-000003', NULL, NULL, 49, NULL, NULL, 185933),
(185934, '3.30.572.10-FF-000025', NULL, 'Uncharacterized protein', 282, NULL, NULL, 185934),
(185935, '2.30.29.30-FF-001391', NULL, 'Uncharacterized protein', 150, NULL, NULL, 185935),
(185936, '3.90.400.10-FF-000012', NULL, 'Alpha-amylase', 65, NULL, NULL, 185936),
(185937, '1.10.287.1080-FF-000011', NULL, 'NTP Pyrophosphohydrolase MazG-related, RS21-C6', 112, NULL, NULL, 185937),
(185938, '3.90.1150.10-FF-000020', NULL, 'Sphingosine-1-phosphate lyase 1', 130, NULL, NULL, 185938),
(185939, '2.170.270.10-FF-000238', NULL, 'Nuclear receptor-binding SET domain protein 1', 55, NULL, NULL, 185939),
(185940, '1.10.287.540-FF-000005', NULL, 'Pilus assembly protein, PilO', 36, NULL, NULL, 185940),
(185941, '1.25.40.10-FF-000251', NULL, 'FK506-binding protein-like isoform X1', 152, NULL, NULL, 185941),
(185942, '2.130.10.10-FF-000421', NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', 307, NULL, NULL, 185942),
(185943, '2.30.180.10-FF-000085', NULL, 'Uncharacterized protein CaJ7.0034', 132, NULL, NULL, 185943),
(185944, '3.40.50.2300-FF-001475', NULL, NULL, 141, NULL, NULL, 185944),
(185945, '3.40.50.300-FF-002164', NULL, 'ATP-binding protein', 378, NULL, NULL, 185945),
(185946, '1.10.472.10-FF-000092', NULL, 'RNA polymerase II holoenzyme cyclin-like subunit', 130, NULL, NULL, 185946),
(185947, '3.40.50.1820-FF-001106', NULL, 'AGAP002090-PA', 309, NULL, NULL, 185947),
(185948, '3.10.20.90-FF-000830', NULL, 'Small ubiquitin-related modifier', 96, NULL, NULL, 185948),
(185949, '3.10.50.40-FF-000008', NULL, 'Peptidylprolyl isomerase', 108, NULL, NULL, 185949),
(185950, '3.10.20.340-FF-000006', NULL, 'Arginine biosynthesis bifunctional protein ArgJ', 133, NULL, NULL, 185950),
(185951, '3.20.20.10-FF-000048', NULL, 'Alanine racemase', 213, NULL, NULL, 185951),
(185952, '3.80.10.10-FF-002568', NULL, 'MDIS1-interacting receptor like kinase 2', 123, NULL, NULL, 185952),
(185953, '1.10.533.10-FF-000172', NULL, 'X-linked inhibitor of apoptosis', 20, NULL, NULL, 185953),
(185954, '3.40.50.12780-FF-000200', NULL, 'Uncharacterized protein', 348, NULL, NULL, 185954),
(185955, '1.10.20.10-FF-000250', NULL, NULL, 35, NULL, NULL, 185955),
(185956, '1.10.8.720-FF-000027', NULL, 'Dynein heavy chain 6, axonemal', 175, NULL, NULL, 185956),
(185957, '4.10.410.10-FF-000089', NULL, 'Uncharacterized protein', 63, NULL, NULL, 185957),
(185958, '3.90.1480.20-FF-000008', NULL, 'ST6 N-acetylgalactosaminide alpha-2,6-sialyltransferase 3', 252, NULL, NULL, 185958),
(185959, '3.40.525.10-FF-000009', NULL, 'SEC14-like 2 (S. cerevisiae)', 260, NULL, NULL, 185959),
(185960, '3.40.50.300-FF-000820', NULL, 'MutS homolog 5 (E. coli)', 277, NULL, NULL, 185960),
(185961, '3.30.559.30-FF-000006', NULL, 'Yersiniabactin polyketide/non-ribosomal peptide synthetase', 247, NULL, NULL, 185961),
(185962, '3.90.70.10-FF-000407', NULL, 'Ubiquitinyl hydrolase 1', 173, NULL, NULL, 185962),
(185963, '3.40.50.1100-FF-000261', NULL, 'Tryptophan synthase beta subunit (TrpB), authentic frameshift', 131, NULL, NULL, 185963),
(185964, '3.40.605.10-FF-000067', NULL, 'Delta-1-pyrroline-5-carboxylate synthase', 161, NULL, NULL, 185964),
(185965, '1.25.10.10-FF-002840', NULL, 'Uncharacterized protein', 176, NULL, NULL, 185965),
(185966, '1.10.8.710-FF-000024', NULL, NULL, 114, NULL, NULL, 185966),
(185967, '1.10.3810.10-FF-000029', NULL, 'Multimodular transpeptidase-transglycosylase', 139, NULL, NULL, 185967),
(185968, '3.40.50.10470-FF-000002', NULL, 'Probable translation initiation factor eIF-2B subunit delta', 201, NULL, NULL, 185968);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(185969, '3.60.40.10-FF-000379', NULL, 'Uncharacterized protein', 261, NULL, NULL, 185969),
(185970, '1.25.40.10-FF-003915', NULL, 'Uncharacterized protein', 301, NULL, NULL, 185970),
(185971, '4.10.280.10-FF-000089', NULL, 'Transcription factor LAX PANICLE', 64, NULL, NULL, 185971),
(185972, '3.30.56.30-FF-000006', NULL, 'Signal recognition particle subunit SRP19', 116, NULL, NULL, 185972),
(185973, '2.30.39.10-FF-000115', NULL, 'Serpin peptidase inhibitor 1', 155, NULL, NULL, 185973),
(185974, '1.20.1530.20-FF-000064', NULL, 'Uncharacterized protein', 219, NULL, NULL, 185974),
(185975, '3.30.565.10-FF-000060', NULL, 'Structural maintenance of chromosomes flexible hinge domain containing 1', 229, NULL, NULL, 185975),
(185976, '1.10.10.10-FF-000075', NULL, 'Histone H1 like', 75, NULL, NULL, 185976),
(185977, '3.40.140.10-FF-000110', NULL, 'GD11395', 138, NULL, NULL, 185977),
(185978, '3.30.30.170-FF-000009', NULL, NULL, 108, NULL, NULL, 185978),
(185979, '3.30.160.60-FF-004254', NULL, NULL, 41, NULL, NULL, 185979),
(185980, '2.30.29.30-FF-000839', NULL, 'Si:dkey-40c11.1', 150, NULL, NULL, 185980),
(185981, '3.40.50.300-FF-005598', NULL, 'HELicase Q homolog', 114, NULL, NULL, 185981),
(185982, '2.40.70.10-FF-000434', NULL, NULL, 142, NULL, NULL, 185982),
(185983, '2.10.230.10-FF-000015', NULL, 'Chaperone protein DNAJ-like protein', 72, NULL, NULL, 185983),
(185984, '3.40.50.300-FF-002107', NULL, 'ATP-dependent RNA helicase ROK1', 272, NULL, NULL, 185984),
(185985, '2.40.50.140-FF-000787', NULL, NULL, 139, NULL, NULL, 185985),
(185986, '1.25.40.10-FF-003972', NULL, 'Uncharacterized protein', 345, NULL, NULL, 185986),
(185987, '3.30.565.10-FF-000003', NULL, 'DNA mismatch repair endonuclease MutL', 210, NULL, NULL, 185987),
(185988, '1.10.10.10-FF-002042', NULL, 'RNA polymerase sigma factor SigW, putative', 79, NULL, NULL, 185988),
(185989, '3.40.50.1820-FF-001163', NULL, 'Carboxypeptidase', 161, NULL, NULL, 185989),
(185990, '3.30.200.20-FF-000204', NULL, 'Serine/threonine-protein kinase Nek7', 27, NULL, NULL, 185990),
(185991, '3.10.50.30-FF-000005', NULL, 'Transcription elongation factor GreA', 80, NULL, NULL, 185991),
(185992, '1.20.1070.10-FF-000778', NULL, 'Uncharacterized protein', 84, NULL, NULL, 185992),
(185993, '3.30.160.60-FF-002163', NULL, 'Jing, isoform I', 72, NULL, NULL, 185993),
(185994, '3.30.200.20-FF-000261', NULL, 'MAP kinase kinase Ste7', 106, NULL, NULL, 185994),
(185995, '3.80.10.10-FF-003405', NULL, 'Uncharacterized protein', 91, NULL, NULL, 185995),
(185996, '2.60.40.10-FF-005384', NULL, NULL, 56, NULL, NULL, 185996),
(185997, '1.20.120.790-FF-000016', NULL, 'Chaperone protein HtpG', 121, NULL, NULL, 185997),
(185998, '3.40.50.10260-FF-000001', NULL, 'Enhancer of mRNA-decapping protein 3', 259, NULL, NULL, 185998),
(185999, '3.30.30.10-FF-000008', NULL, 'Toxin-like peptide AaF1CA7', 54, NULL, NULL, 185999),
(186000, '1.25.40.10-FF-001555', NULL, 'GD13877', 102, NULL, NULL, 186000),
(186001, '1.25.40.10-FF-001499', NULL, 'Pentatricopeptide repeat-containing protein At4g18520, chloroplastic', 99, NULL, NULL, 186001),
(186002, '3.30.1680.10-FF-000023', NULL, 'semaphorin-4G isoform X2', 60, NULL, NULL, 186002),
(186003, '2.130.10.10-FF-004170', NULL, 'Uncharacterized protein', 168, NULL, NULL, 186003),
(186004, '2.60.40.10-FF-003585', NULL, NULL, 67, NULL, NULL, 186004),
(186005, '2.40.10.350-FF-000010', NULL, 'Rod shape-determining protein mreC', 72, NULL, NULL, 186005),
(186006, '1.20.1250.20-FF-001548', NULL, 'MFS transporter, putative (AFU_orthologue AFUA_4G01480)', 418, NULL, NULL, 186006),
(186007, '1.20.58.70-FF-000101', NULL, 'Protein CBR-SYX-5', 135, NULL, NULL, 186007),
(186008, '3.30.230.80-FF-000022', NULL, 'Grp94/Hsp90', 190, NULL, NULL, 186008),
(186009, '2.10.25.10-FF-001163', NULL, 'Protein glp-1', 47, NULL, NULL, 186009),
(186010, '2.130.10.10-FF-003894', NULL, 'Uncharacterized protein', 273, NULL, NULL, 186010),
(186011, '2.10.70.10-FF-000177', NULL, 'GG11343', 34, NULL, NULL, 186011),
(186012, '3.40.1380.10-FF-000037', NULL, 'ATP synthase F1 gamma subunit', 140, NULL, NULL, 186012);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(186013, '2.30.29.30-FF-001115', NULL, 'Uncharacterized protein', 135, NULL, NULL, 186013),
(186014, '1.20.1270.60-FF-000078', NULL, 'Slm1p', 256, NULL, NULL, 186014),
(186015, '2.40.10.10-FF-000436', NULL, 'Uncharacterized protein', 266, NULL, NULL, 186015),
(186016, '3.30.160.60-FF-002904', NULL, 'Zgc:112977', 30, NULL, NULL, 186016),
(186017, '2.10.25.10-FF-000848', NULL, 'Fibrillin-1', 39, NULL, NULL, 186017),
(186018, '3.40.33.10-FF-000127', NULL, 'Uncharacterized protein', 196, NULL, NULL, 186018),
(186019, '1.10.1600.10-FF-000018', NULL, 'ATP-dependent DNA helicase ku70', 100, NULL, NULL, 186019),
(186020, '2.40.340.10-FF-000022', NULL, NULL, 70, NULL, NULL, 186020),
(186021, '1.20.5.110-FF-000207', NULL, 'LOC100127544 protein', 106, NULL, NULL, 186021),
(186022, '1.10.10.10-FF-000131', NULL, 'la-related protein 1B isoform X2', 91, NULL, NULL, 186022),
(186023, '2.60.120.260-FF-000022', NULL, 'Laminin subunit alpha 5', 237, NULL, NULL, 186023),
(186024, '2.60.40.150-FF-000126', NULL, 'Copine 6', 127, NULL, NULL, 186024),
(186025, '3.40.50.880-FF-000212', NULL, 'Aminodeoxychorismate synthase component 2', 188, NULL, NULL, 186025),
(186026, '1.20.1250.20-FF-001604', NULL, 'MFS transporter', 222, NULL, NULL, 186026),
(186027, '3.30.160.60-FF-000364', NULL, 'Zinc finger and BTB domain-containing protein 34', 27, NULL, NULL, 186027),
(186028, '1.25.40.10-FF-003354', NULL, 'Pentatricopeptide repeat-containing protein At4g11690', 75, NULL, NULL, 186028),
(186029, '3.10.110.10-FF-000362', NULL, 'Protein IMPACT homolog', 100, NULL, NULL, 186029),
(186030, '3.90.79.10-FF-000152', NULL, 'Uncharacterized protein', 195, NULL, NULL, 186030),
(186031, '1.20.272.10-FF-000057', NULL, NULL, 108, NULL, NULL, 186031),
(186032, '1.10.3090.10-FF-000018', NULL, 'CCA-adding enzyme', 238, NULL, NULL, 186032),
(186033, '1.10.8.270-FF-000066', NULL, 'GTPase activating protein (Gyp5), putative', 159, NULL, NULL, 186033),
(186034, '1.10.510.10-FF-002800', NULL, NULL, 190, NULL, NULL, 186034),
(186035, '3.40.50.300-FF-006710', NULL, 'Predicted protein', 76, NULL, NULL, 186035),
(186036, '1.10.418.10-FF-000157', NULL, 'Uncharacterized protein', 44, NULL, NULL, 186036),
(186037, '3.40.50.300-FF-000584', NULL, 'probable ATP-dependent RNA helicase DDX46', 174, NULL, NULL, 186037),
(186038, '1.10.10.60-FF-000174', NULL, 'MYB-related transcription factor', 45, NULL, NULL, 186038),
(186039, '2.130.10.10-FF-001764', NULL, 'Putative WD-repeat family protein', 170, NULL, NULL, 186039),
(186040, '3.30.420.40-FF-000250', NULL, 'Putative actin-related protein', 30, NULL, NULL, 186040),
(186041, '1.20.210.10-FF-000004', NULL, 'Cytochrome c oxidase subunit 1', 519, NULL, NULL, 186041),
(186042, '3.90.930.12-FF-000032', NULL, NULL, 55, NULL, NULL, 186042),
(186043, '3.30.70.330-FF-000503', NULL, 'Calcineurin binding protein, putative', 100, NULL, NULL, 186043),
(186044, '3.30.519.10-FF-000003', NULL, 'Rab GDP dissociation inhibitor', 161, NULL, NULL, 186044),
(186045, '3.60.21.50-FF-000004', NULL, 'DNA polymerase epsilon subunit b, putative', 259, NULL, NULL, 186045),
(186046, '2.130.10.10-FF-000128', NULL, 'WD repeat domain 46', 285, NULL, NULL, 186046),
(186047, '3.40.50.300-FF-000527', NULL, 'Tyrosine-protein kinase etk', 265, NULL, NULL, 186047),
(186048, '2.130.10.10-FF-000185', NULL, 'TBC1 domain family member 31 isoform X1', 190, NULL, NULL, 186048),
(186049, '3.30.260.10-FF-000031', NULL, 'T-complex protein 1, theta subunit', 108, NULL, NULL, 186049),
(186050, '3.30.2020.30-FF-000002', NULL, 'Putative gamma-butyrobetaine dioxygenase', 97, NULL, NULL, 186050),
(186051, '4.10.860.10-FF-000004', NULL, 'ATP-dependent Clp protease ATP-binding subunit', 55, NULL, NULL, 186051),
(186052, '4.10.410.10-FF-000033', NULL, 'CRE-MEC-1 protein', 75, NULL, NULL, 186052),
(186053, '3.40.50.300-FF-000640', NULL, 'MoxR family ATPase', 185, NULL, NULL, 186053),
(186054, '1.10.760.10-FF-000025', NULL, 'Cytochrome c2, putative', 113, NULL, NULL, 186054),
(186055, '2.20.25.10-FF-000022', NULL, 'LytR family transcriptional regulator', 38, NULL, NULL, 186055);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(186056, '3.40.1110.10-FF-000158', NULL, 'Phospholipid-transporting ATPase', 124, NULL, NULL, 186056),
(186057, '3.90.550.50-FF-000164', NULL, 'Uncharacterized protein', 266, NULL, NULL, 186057),
(186058, '3.30.70.330-FF-000161', NULL, 'RNA binding (RRM/RBD/RNP motifs) family protein', 82, NULL, NULL, 186058),
(186059, '2.120.10.80-FF-000251', NULL, 'Kel1p', 127, NULL, NULL, 186059),
(186060, '1.25.40.10-FF-002230', NULL, 'Nuclear autoantigenic sperm protein (histone-binding)', 197, NULL, NULL, 186060),
(186061, '1.25.10.10-FF-000423', NULL, 'RING-type E3 ubiquitin transferase', 324, NULL, NULL, 186061),
(186062, '1.10.565.10-FF-000178', NULL, 'Protein CBR-NHR-221', 162, NULL, NULL, 186062),
(186063, '4.10.860.20-FF-000007', NULL, 'Vacuolar segregation protein pep7', 78, NULL, NULL, 186063),
(186064, '3.10.100.10-FF-000204', NULL, 'Predicted protein', 136, NULL, NULL, 186064),
(186065, '1.20.5.340-FF-000080', NULL, 'Polycystin 2 like 1, transient receptor potential cation channel', 61, NULL, NULL, 186065),
(186066, '3.50.50.60-FF-000102', NULL, 'Glycerol-3-phosphate dehydrogenase', 122, NULL, NULL, 186066),
(186067, '2.60.40.10-FF-004602', NULL, NULL, 113, NULL, NULL, 186067),
(186068, '3.40.50.300-FF-008127', NULL, 'Uncharacterized protein', 105, NULL, NULL, 186068),
(186069, '3.90.1150.180-FF-000002', NULL, 'L-seryl-tRNA(Sec) selenium transferase', 103, NULL, NULL, 186069),
(186070, '3.50.50.60-FF-001064', NULL, 'Flavin containing monooxygenase 5', 116, NULL, NULL, 186070),
(186071, '1.10.510.10-FF-004256', NULL, NULL, 190, NULL, NULL, 186071),
(186072, '3.40.50.10470-FF-000058', NULL, 'Uncharacterized protein', 168, NULL, NULL, 186072),
(186073, '2.40.30.10-FF-000106', NULL, 'Ribosome-releasing factor 2, mitochondrial', 126, NULL, NULL, 186073),
(186074, '2.30.30.140-FF-000055', NULL, 'SAGA complex component', 63, NULL, NULL, 186074),
(186075, '1.25.10.10-FF-000081', NULL, 'Coatomer subunit beta', 618, NULL, NULL, 186075),
(186076, '1.10.246.130-FF-000008', NULL, 'Ecm38p', 110, NULL, NULL, 186076),
(186077, '2.10.25.10-FF-001562', NULL, 'Uncharacterized protein', 32, NULL, NULL, 186077),
(186078, '1.10.1820.10-FF-000001', NULL, 'Casein kinase II subunit beta', 105, NULL, NULL, 186078),
(186079, '3.70.10.10-FF-000056', NULL, 'Uncharacterized protein', 137, NULL, NULL, 186079),
(186080, '3.30.200.20-FF-001840', NULL, 'Predicted protein', 102, NULL, NULL, 186080),
(186081, '1.10.510.10-FF-001906', NULL, NULL, 93, NULL, NULL, 186081),
(186082, '1.10.150.20-FF-000111', NULL, 'DNA polymerase IV', 71, NULL, NULL, 186082),
(186083, '1.25.10.10-FF-001385', NULL, 'Cell division control protein, putative', 301, NULL, NULL, 186083),
(186084, '1.10.238.10-FF-000284', NULL, 'RAB11 family interacting protein 4', 83, NULL, NULL, 186084),
(186085, '1.10.443.10-FF-000013', NULL, 'Putative integrase', 180, NULL, NULL, 186085),
(186086, '3.90.226.10-FF-000253', NULL, 'Enoyl-CoA hydratase/isomerase, putative', 305, NULL, NULL, 186086),
(186087, '2.10.25.10-FF-001124', NULL, 'Protein eyes shut homolog', 37, NULL, NULL, 186087),
(186088, '1.10.238.10-FF-001189', NULL, 'Uncharacterized protein', 83, NULL, NULL, 186088),
(186089, '2.130.10.10-FF-004911', NULL, 'Uncharacterized protein', 110, NULL, NULL, 186089),
(186090, '1.10.1900.10-FF-000002', NULL, 'E3 ubiquitin-protein ligase UBR5 isoform X1', 61, NULL, NULL, 186090),
(186091, '3.60.21.10-FF-000458', NULL, 'Serine/threonine-protein phosphatase', 170, NULL, NULL, 186091),
(186092, '3.30.70.330-FF-001521', NULL, 'Heteroproteinous nuclear ribonucleoprotein r rrm superfamily', 100, NULL, NULL, 186092),
(186093, '1.25.10.10-FF-000480', NULL, 'Transportin', 382, NULL, NULL, 186093),
(186094, '2.30.30.550-FF-000003', NULL, 'Major vault protein-like protein', 53, NULL, NULL, 186094),
(186095, '3.40.50.300-FF-004417', NULL, 'ADP-ribosylation factor family-domain-containing protein', 179, NULL, NULL, 186095),
(186096, '2.40.40.20-FF-000048', NULL, 'Putative vesicle-fusing ATPase', 90, NULL, NULL, 186096),
(186097, '3.40.120.10-FF-000108', NULL, 'Uncharacterized protein', 21, NULL, NULL, 186097);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(186098, '1.10.3500.10-FF-000039', NULL, 'Uncharacterized protein', 98, NULL, NULL, 186098),
(186099, '1.25.40.20-FF-001558', NULL, 'Uncharacterized protein', 101, NULL, NULL, 186099),
(186100, '2.40.100.10-FF-000151', NULL, 'Peptidyl-prolyl cis-trans isomerase', 164, NULL, NULL, 186100),
(186101, '3.40.50.620-FF-000798', NULL, 'Uncharacterized protein', 131, NULL, NULL, 186101),
(186102, '1.10.1900.20-FF-000005', NULL, '50S ribosomal protein L20, chloroplastic', 56, NULL, NULL, 186102),
(186103, '3.80.10.10-FF-004479', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 139, NULL, NULL, 186103),
(186104, '2.170.120.20-FF-000017', NULL, '50S ribosomal protein L25', 82, NULL, NULL, 186104),
(186105, '2.30.30.560-FF-000006', NULL, 'Major vault protein, putative', 48, NULL, NULL, 186105),
(186106, '2.130.10.10-FF-004018', NULL, 'Uncharacterized protein', 223, NULL, NULL, 186106),
(186107, '1.10.30.50-FF-000003', NULL, 'HNH endonuclease', 81, NULL, NULL, 186107),
(186108, '3.30.70.890-FF-000031', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 118, NULL, NULL, 186108),
(186109, '1.20.120.1200-FF-000012', NULL, 'NADH-quinone oxidoreductase chain 6 protein', 158, NULL, NULL, 186109),
(186110, '3.40.50.300-FF-004237', NULL, 'SNF2 family helicase/ATPase, putative (AFU_orthologue AFUA_3G08400)', 273, NULL, NULL, 186110),
(186111, '3.40.50.150-FF-000516', NULL, 'Unplaced genomic scaffold supercont2.5, whole genome shotgun sequence', 254, NULL, NULL, 186111),
(186112, '3.40.50.10810-FF-000025', NULL, 'E3 ubiquitin-protein ligase SHPRH isoform X1', 100, NULL, NULL, 186112),
(186113, '3.40.50.10190-FF-000188', NULL, 'PAX transcription activation domain interacting protein', 127, NULL, NULL, 186113),
(186114, '3.30.160.60-FF-005833', NULL, NULL, 27, NULL, NULL, 186114),
(186115, '3.30.70.330-FF-000104', NULL, 'Heterogeneous nuclear ribonucleoprotein L like', 73, NULL, NULL, 186115),
(186116, '1.10.260.100-FF-000017', NULL, 'Stress-induced protein sti1', 63, NULL, NULL, 186116),
(186117, '1.10.1580.10-FF-000027', NULL, 'Uncharacterized protein', 94, NULL, NULL, 186117),
(186118, '1.10.8.60-FF-000549', NULL, 'Uncharacterized protein', 50, NULL, NULL, 186118),
(186119, '3.30.200.20-FF-002003', NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 201', 96, NULL, NULL, 186119),
(186120, '1.10.8.60-FF-000263', NULL, '26S protease regulatory subunit 7', 83, NULL, NULL, 186120),
(186121, '2.130.10.10-FF-000460', NULL, 'TBC1 domain family member 31 isoform X4', 110, NULL, NULL, 186121),
(186122, '3.30.460.90-FF-000014', NULL, 'IP12463p', 175, NULL, NULL, 186122),
(186123, '1.10.472.80-FF-000197', NULL, NULL, 148, NULL, NULL, 186123),
(186124, '2.30.29.30-FF-000952', NULL, 'Uncharacterized protein', 115, NULL, NULL, 186124),
(186125, '2.60.120.590-FF-000059', NULL, 'Predicted protein', 198, NULL, NULL, 186125),
(186126, '3.30.160.60-FF-005777', NULL, NULL, 60, NULL, NULL, 186126),
(186127, '3.30.200.20-FF-001565', NULL, NULL, 108, NULL, NULL, 186127),
(186128, '2.60.120.430-FF-000039', NULL, 'Uncharacterized protein C9E9.15', 170, NULL, NULL, 186128),
(186129, '3.40.640.10-FF-000311', NULL, 'Aminotransferase class-III', 275, NULL, NULL, 186129),
(186130, '3.40.50.80-FF-000013', NULL, 'Ferredoxin--NADP(+) reductase', 152, NULL, NULL, 186130),
(186131, '1.10.1420.10-FF-000033', NULL, 'Probable DNA mismatch repair protein MSH2', 181, NULL, NULL, 186131),
(186132, '1.10.287.70-FF-000297', NULL, 'Ionotropic glutamate receptor, putative', 140, NULL, NULL, 186132),
(186133, '1.10.530.10-FF-000036', NULL, 'Lytic murein transglycosylase B', 177, NULL, NULL, 186133),
(186134, '3.40.250.10-FF-000169', NULL, 'Methyltransferase domain containing protein, putative', 78, NULL, NULL, 186134),
(186135, '1.20.5.650-FF-000015', NULL, NULL, 63, NULL, NULL, 186135),
(186136, '3.80.10.10-FF-000769', NULL, 'Receptor-like protein kinase 7 isoform A', 115, NULL, NULL, 186136),
(186137, '3.40.50.2300-FF-000019', NULL, 'Chemotaxis response regulator CheY', 124, NULL, NULL, 186137),
(186138, '1.10.1450.10-FF-000080', NULL, 'Tetraspanin', 67, NULL, NULL, 186138);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(186139, '3.90.1290.10-FF-000069', NULL, 'Dystonin', 165, NULL, NULL, 186139),
(186140, '3.40.50.300-FF-000308', NULL, 'ras-related protein RABE1c-like', 206, NULL, NULL, 186140),
(186141, '3.30.200.20-FF-000148', NULL, 'Serine/threonine-protein kinase RIO1', 103, NULL, NULL, 186141),
(186142, '3.10.660.10-FF-000004', NULL, 'Diphthamide biosynthesis protein 3', 67, NULL, NULL, 186142),
(186143, '2.60.40.10-FF-000151', NULL, 'neural cell adhesion molecule 1 isoform X1', 98, NULL, NULL, 186143),
(186144, '3.90.550.10-FF-000343', NULL, 'Glycoside transferase family 2', 257, NULL, NULL, 186144),
(186145, '1.25.10.10-FF-001727', NULL, 'Predicted protein', 202, NULL, NULL, 186145),
(186146, '1.10.150.20-FF-000330', NULL, 'Uncharacterized protein', 40, NULL, NULL, 186146),
(186147, '1.20.1250.20-FF-001661', NULL, 'Uncharacterized protein', 234, NULL, NULL, 186147),
(186148, '2.60.40.150-FF-000800', NULL, 'Uncharacterized protein', 59, NULL, NULL, 186148),
(186149, '1.20.120.1900-FF-000014', NULL, 'Spindle pole body component', 384, NULL, NULL, 186149),
(186150, '1.10.12.70-FF-000001', NULL, 'Programmed cell death protein 10', 61, NULL, NULL, 186150),
(186151, '2.70.170.10-FF-000002', NULL, 'Glycine receptor alpha 1 subunit', 215, NULL, NULL, 186151),
(186152, '1.10.555.10-FF-000239', NULL, NULL, 203, NULL, NULL, 186152),
(186153, '3.10.20.30-FF-000054', NULL, 'Iron-sulfur cluster-binding protein', 78, NULL, NULL, 186153),
(186154, '3.30.160.60-FF-003798', NULL, NULL, 28, NULL, NULL, 186154),
(186155, '3.50.50.60-FF-001406', NULL, 'Uncharacterized protein', 155, NULL, NULL, 186155),
(186156, '3.40.50.10810-FF-000205', NULL, 'Uncharacterized protein', 138, NULL, NULL, 186156),
(186157, '1.10.150.50-FF-000159', NULL, 'Putative adenylate cyclase', 65, NULL, NULL, 186157),
(186158, '1.10.510.10-FF-002126', NULL, 'Uncharacterized protein', 195, NULL, NULL, 186158),
(186159, '1.10.10.60-FF-000117', NULL, 'BEL1-like homeodomain protein 9', 63, NULL, NULL, 186159),
(186160, '3.40.50.300-FF-003799', NULL, 'DEAD/DEAH box helicase', 111, NULL, NULL, 186160),
(186161, '3.30.160.60-FF-006053', NULL, NULL, 26, NULL, NULL, 186161),
(186162, '3.40.50.2020-FF-000082', NULL, 'Phosphoribosylpyrophosphate synthetase', 105, NULL, NULL, 186162),
(186163, '1.10.418.10-FF-000213', NULL, 'Rac guanyl-nucleotide exchange factor', 161, NULL, NULL, 186163),
(186164, '3.40.50.300-FF-000926', NULL, 'NACHT and WD repeat domain containing 2', 168, NULL, NULL, 186164),
(186165, '1.10.472.130-FF-000018', NULL, 'Dynein heavy chain, putative', 143, NULL, NULL, 186165),
(186166, '2.60.40.10-FF-004080', NULL, NULL, 119, NULL, NULL, 186166),
(186167, '1.20.1560.10-FF-000012', NULL, 'ATP binding cassette subfamily C member 5', 341, NULL, NULL, 186167),
(186168, '1.20.120.140-FF-000013', NULL, 'Signal recognition particle receptor subunit alpha', 147, NULL, NULL, 186168),
(186169, '2.40.10.10-FF-000217', NULL, 'HGF/MSP/plasminogen-like protein', 241, NULL, NULL, 186169),
(186170, '3.30.200.20-FF-002060', NULL, NULL, 86, NULL, NULL, 186170),
(186171, '3.30.1640.10-FF-000026', NULL, 'DNA helicase', 105, NULL, NULL, 186171),
(186172, '1.25.40.10-FF-002050', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 194, NULL, NULL, 186172),
(186173, '1.25.10.10-FF-000367', NULL, 'RING-type E3 ubiquitin transferase', 152, NULL, NULL, 186173),
(186174, '3.10.105.10-FF-000013', NULL, 'Oligopeptide ABC transporter, oligopeptide-binding protein AliB', 257, NULL, NULL, 186174),
(186175, '2.60.40.10-FF-000712', NULL, 'Poliovirus receptor homolog', 123, NULL, NULL, 186175),
(186176, '3.50.50.60-FF-000046', NULL, 'Glycerol-3-phosphate dehydrogenase', 247, NULL, NULL, 186176),
(186177, '1.10.530.10-FF-000093', NULL, 'Lysozyme', 131, NULL, NULL, 186177),
(186178, '3.40.50.300-FF-004294', NULL, 'Rab-type small G protein', 222, NULL, NULL, 186178),
(186179, '1.25.40.990-FF-000012', NULL, 'SAC3 family protein C', 276, NULL, NULL, 186179),
(186180, '1.10.10.2660-FF-000017', NULL, 'Ubiquitin activating enzyme, putative', 234, NULL, NULL, 186180),
(186181, '1.20.1640.10-FF-000070', NULL, 'GM10585', 196, NULL, NULL, 186181);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(186182, '1.10.1200.10-FF-000089', NULL, 'Nonribosomal peptide synthase, putative', 75, NULL, NULL, 186182),
(186183, '3.30.200.20-FF-001508', NULL, NULL, 25, NULL, NULL, 186183),
(186184, '3.40.1370.10-FF-000031', NULL, 'Uncharacterized protein', 222, NULL, NULL, 186184),
(186185, '3.30.450.40-FF-000307', NULL, 'Phosphodiesterase', 124, NULL, NULL, 186185),
(186186, '3.30.565.10-FF-000508', NULL, 'Sensory transduction histidine kinase', 144, NULL, NULL, 186186),
(186187, '1.10.8.270-FF-000122', NULL, 'Uncharacterized protein', 111, NULL, NULL, 186187),
(186188, '3.50.30.30-FF-000177', NULL, 'Uncharacterized protein', 42, NULL, NULL, 186188),
(186189, '2.30.30.140-FF-000274', NULL, 'Retinoblastoma-binding protein', 66, NULL, NULL, 186189),
(186190, '3.90.79.10-FF-000039', NULL, 'Nucleoside triphosphatase NudI', 141, NULL, NULL, 186190),
(186191, '1.10.510.10-FF-002401', NULL, 'Protein kinase', 230, NULL, NULL, 186191),
(186192, '3.80.10.10-FF-002681', NULL, 'Phytosulfokine receptor 1', 99, NULL, NULL, 186192),
(186193, '2.10.50.10-FF-000069', NULL, 'Cysteine repeat modular protein 3', 63, NULL, NULL, 186193),
(186194, '1.25.40.20-FF-001777', NULL, 'Predicted protein', 186, NULL, NULL, 186194),
(186195, '3.40.50.720-FF-001334', NULL, 'Short chain oxidoreductase/dehydrogenase, putative', 254, NULL, NULL, 186195),
(186196, '1.25.10.10-FF-002402', NULL, 'Uncharacterized protein', 257, NULL, NULL, 186196),
(186197, '3.80.10.10-FF-001264', NULL, 'Insulin-like growth factor-binding protein complex acid labile subunit', 125, NULL, NULL, 186197),
(186198, '1.10.418.10-FF-000270', NULL, 'Predicted protein', 104, NULL, NULL, 186198),
(186199, '3.40.50.2300-FF-001436', NULL, NULL, 86, NULL, NULL, 186199),
(186200, '3.20.20.10-FF-000087', NULL, 'Uncharacterized protein', 234, NULL, NULL, 186200),
(186201, '2.70.150.10-FF-000113', NULL, 'Cation transport ATPase, E1-E2 family', 111, NULL, NULL, 186201),
(186202, '2.30.30.100-FF-000110', NULL, 'Small nuclear ribonucleoprotein E', 80, NULL, NULL, 186202),
(186203, '2.80.10.50-FF-000031', NULL, 'FRG1 isoform 1', 154, NULL, NULL, 186203),
(186204, '1.25.40.10-FF-001774', NULL, 'Crooked neck-like protein 1', 79, NULL, NULL, 186204),
(186205, '2.70.150.10-FF-000170', NULL, 'Phospholipid-transporting ATPase', 160, NULL, NULL, 186205),
(186206, '3.40.20.10-FF-000098', NULL, 'Coronin', 117, NULL, NULL, 186206),
(186207, '1.10.510.10-FF-002137', NULL, 'Tyrosine-protein kinase', 217, NULL, NULL, 186207),
(186208, '2.10.250.10-FF-000011', NULL, 'Uncharacterized protein', 38, NULL, NULL, 186208),
(186209, '2.40.10.10-FF-000026', NULL, 'Hepatocyte growth factor', 98, NULL, NULL, 186209),
(186210, '1.20.120.230-FF-000051', NULL, 'Talin-A', 131, NULL, NULL, 186210),
(186211, '1.20.920.30-FF-000070', NULL, 'Uncharacterized protein', 77, NULL, NULL, 186211),
(186212, '3.30.420.40-FF-000362', NULL, 'Heat shock protein 70 family protein', 55, NULL, NULL, 186212),
(186213, '6.10.250.3450-FF-000002', NULL, '60S ribosomal protein L35', 48, NULL, NULL, 186213),
(186214, '3.60.20.40-FF-000044', NULL, 'Uncharacterized protein', 79, NULL, NULL, 186214),
(186215, '1.20.272.10-FF-000001', NULL, 'Putative AAA family ATPase', 104, NULL, NULL, 186215),
(186216, '1.10.3450.20-FF-000009', NULL, 'Nuclear pore complex protein', 197, NULL, NULL, 186216),
(186217, '3.90.1110.10-FF-000028', NULL, NULL, 172, NULL, NULL, 186217),
(186218, '3.40.30.10-FF-000076', NULL, 'Protein disulfide-isomerase A4', 132, NULL, NULL, 186218),
(186219, '3.30.420.40-FF-000406', NULL, 'Chaperone protein DnaK HSP70', 188, NULL, NULL, 186219),
(186220, '1.10.630.10-FF-000639', NULL, 'Uncharacterized protein', 218, NULL, NULL, 186220),
(186221, '3.40.50.1820-FF-001393', NULL, 'Chromosome 23, whole genome shotgun sequence', 216, NULL, NULL, 186221),
(186222, '3.40.1000.10-FF-000015', NULL, 'PsbP-like protein 1, chloroplastic', 162, NULL, NULL, 186222),
(186223, '3.40.50.2300-FF-001464', NULL, NULL, 163, NULL, NULL, 186223),
(186224, '2.130.10.10-FF-004400', NULL, 'Uncharacterized protein', 56, NULL, NULL, 186224),
(186225, '3.40.50.880-FF-000050', NULL, 'Catalase', 199, NULL, NULL, 186225);
INSERT INTO "PUBLIC"."MODEL" VALUES
(186226, '2.130.10.10-FF-002146', NULL, 'E3 ubiquitin-protein ligase PEP5', 235, NULL, NULL, 186226),
(186227, '3.40.50.300-FF-005199', NULL, 'Conserved expressed protein', 211, NULL, NULL, 186227),
(186228, '3.40.50.1000-FF-000219', NULL, 'P-type cation-transporting ATPase', 144, NULL, NULL, 186228),
(186229, '3.30.160.60-FF-005799', NULL, NULL, 27, NULL, NULL, 186229),
(186230, '3.30.160.60-FF-003675', NULL, 'CTCF', 32, NULL, NULL, 186230),
(186231, '3.90.550.10-FF-000091', NULL, 'UDP-sugar pyrophosphorylase', 458, NULL, NULL, 186231),
(186232, '1.25.40.10-FF-000436', NULL, 'Pentatricopeptide repeat-containing protein At5g39350 family', 115, NULL, NULL, 186232),
(186233, '3.40.50.2000-FF-000975', NULL, 'Uncharacterized protein', 83, NULL, NULL, 186233),
(186234, '3.40.50.1820-FF-001404', NULL, 'Uncharacterized protein', 210, NULL, NULL, 186234),
(186235, '1.10.10.10-FF-000092', NULL, 'Histone acetyltransferase', 85, NULL, NULL, 186235),
(186236, '1.25.40.10-FF-001864', NULL, 'DnaJ homolog subfamily C member 7', 74, NULL, NULL, 186236),
(186237, '1.20.1740.10-FF-000066', NULL, 'SPS-sensor component SSY1', 495, NULL, NULL, 186237),
(186238, '2.60.40.10-FF-004259', NULL, NULL, 119, NULL, NULL, 186238),
(186239, '1.10.730.10-FF-000220', NULL, 'Leucine--tRNA ligase', 179, NULL, NULL, 186239),
(186240, '3.10.580.10-FF-000077', NULL, 'Cystathionine beta-synthase', 118, NULL, NULL, 186240),
(186241, '3.40.50.300-FF-000365', NULL, 'Ribosome biogenesis ATPase RIX7', 184, NULL, NULL, 186241),
(186242, '1.10.10.830-FF-000002', NULL, 'Isoleucine--tRNA ligase, mitochondrial', 52, NULL, NULL, 186242),
(186243, '2.10.70.10-FF-000262', NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', 62, NULL, NULL, 186243),
(186244, '3.30.70.330-FF-001369', NULL, 'AGAP005505-PA-like protein', 135, NULL, NULL, 186244),
(186245, '3.40.50.300-FF-006351', NULL, 'Uncharacterized protein', 142, NULL, NULL, 186245),
(186246, '1.50.40.10-FF-000148', NULL, 'Mitochondrial substrate carrier family protein', 295, NULL, NULL, 186246),
(186247, '3.40.630.10-FF-000411', NULL, 'Novel protein aminoacylase 1 family 2 ACY1L2 (Homo sapiens), putative', 46, NULL, NULL, 186247),
(186248, '1.25.40.10-FF-001538', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 122, NULL, NULL, 186248),
(186249, '3.40.50.300-FF-007969', NULL, 'Uncharacterized protein', 163, NULL, NULL, 186249),
(186250, '3.30.160.60-FF-002573', NULL, 'Uncharacterized protein', 30, NULL, NULL, 186250),
(186251, '3.30.519.10-FF-000020', NULL, 'Rab proteins geranylgeranyltransferase component A', 172, NULL, NULL, 186251),
(186252, '3.90.70.10-FF-000441', NULL, 'HlyB family protein', 151, NULL, NULL, 186252),
(186253, '3.30.160.60-FF-004181', NULL, NULL, 19, NULL, NULL, 186253),
(186254, '1.25.40.10-FF-002044', NULL, 'Os05g0112900 protein', 59, NULL, NULL, 186254),
(186255, '2.80.10.50-FF-000115', NULL, 'GALNT13 isoform 8', 94, NULL, NULL, 186255),
(186256, '1.25.40.20-FF-000439', NULL, 'Integrin-linked protein kinase family', 125, NULL, NULL, 186256),
(186257, '1.25.40.20-FF-001867', NULL, 'Uncharacterized protein', 129, NULL, NULL, 186257),
(186258, '3.40.50.1460-FF-000127', NULL, 'CASP8 and FADD like apoptosis regulator', 145, NULL, NULL, 186258),
(186259, '1.20.1110.10-FF-000035', NULL, 'Sodium/potassium-transporting ATPase subunit alpha', 403, NULL, NULL, 186259),
(186260, '2.60.40.60-FF-000109', NULL, 'neural-cadherin isoform X2', 124, NULL, NULL, 186260),
(186261, '3.30.160.60-FF-002247', NULL, 'Zinc finger protein 560', 29, NULL, NULL, 186261),
(186262, '3.40.630.30-FF-000417', NULL, 'Uncharacterized protein', 205, NULL, NULL, 186262),
(186263, '1.10.8.80-FF-000010', NULL, 'MoxR family ATPase', 108, NULL, NULL, 186263),
(186264, '3.20.20.70-FF-000515', NULL, 'Dihydroorotate dehydrogenase 2', 293, NULL, NULL, 186264),
(186265, '3.30.530.20-FF-000049', NULL, 'SRPBCC family protein', 138, NULL, NULL, 186265),
(186266, '3.40.50.300-FF-004108', NULL, 'Si:dkey-23k10.5', 199, NULL, NULL, 186266),
(186267, '1.20.5.110-FF-000174', NULL, 'Protein CBR-SYX-18', 102, NULL, NULL, 186267);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(186268, '3.50.50.60-FF-001480', NULL, 'Uncharacterized protein', 55, NULL, NULL, 186268),
(186269, '1.20.1250.20-FF-001672', NULL, 'Solute carrier organic anion transporter family member', 401, NULL, NULL, 186269),
(186270, '3.40.50.11530-FF-000011', NULL, 'Uncharacterized protein', 171, NULL, NULL, 186270),
(186271, '2.40.10.10-FF-000661', NULL, NULL, 74, NULL, NULL, 186271),
(186272, '1.10.510.10-FF-004380', NULL, NULL, 291, NULL, NULL, 186272),
(186273, '3.40.50.300-FF-000409', NULL, 'Neuron navigator 1', 141, NULL, NULL, 186273),
(186274, '3.30.40.10-FF-001824', NULL, 'Uncharacterized protein', 115, NULL, NULL, 186274),
(186275, '1.20.1070.10-FF-001262', NULL, 'Uncharacterized protein', 290, NULL, NULL, 186275),
(186276, '1.20.1070.10-FF-001571', NULL, 'Uncharacterized protein', 164, NULL, NULL, 186276),
(186277, '2.60.120.10-FF-000333', NULL, 'Germin-like protein subfamily 3 member 1', 114, NULL, NULL, 186277),
(186278, '1.10.510.10-FF-004071', NULL, NULL, 182, NULL, NULL, 186278),
(186279, '3.40.50.300-FF-000039', NULL, '26S proteasome regulatory subunit 4', 181, NULL, NULL, 186279),
(186280, '1.10.3520.10-FF-000035', NULL, 'Ceramide-1-phosphate transfer protein-like Protein', 113, NULL, NULL, 186280),
(186281, '3.40.140.10-FF-000183', NULL, 'tRNA-sepcific adenosine deaminase', 169, NULL, NULL, 186281),
(186282, '3.40.350.10-FF-000103', NULL, 'FACT complex subunit spt16, putative', 124, NULL, NULL, 186282),
(186283, '1.10.510.10-FF-002463', NULL, 'CAMK family protein kinase', 311, NULL, NULL, 186283),
(186284, '1.10.287.370-FF-000067', NULL, 'Prefoldin 5', 82, NULL, NULL, 186284),
(186285, '1.25.40.120-FF-000055', NULL, 'Uncharacterized protein', 234, NULL, NULL, 186285),
(186286, '1.20.120.350-FF-000115', NULL, 'Uncharacterized protein', 146, NULL, NULL, 186286),
(186287, '3.50.80.10-FF-000016', NULL, 'D-aminoacyl-tRNA deacylase', 141, NULL, NULL, 186287),
(186288, '3.40.50.1440-FF-000121', NULL, 'Uncharacterized protein', 110, NULL, NULL, 186288),
(186289, '3.30.70.1230-FF-000139', NULL, 'Predicted protein', 86, NULL, NULL, 186289),
(186290, '1.20.58.480-FF-000019', NULL, 'Tryptophan 2,3-dioxygenase', 288, NULL, NULL, 186290),
(186291, '3.40.50.300-FF-004097', NULL, 'ABC transporter ATP-binding protein', 251, NULL, NULL, 186291),
(186292, '3.10.450.320-FF-000001', NULL, 'Mitochondrial import inner membrane translocase subunit Tim21', 114, NULL, NULL, 186292),
(186293, '3.30.497.10-FF-000142', NULL, 'Si:ch1073-416d2.3', 52, NULL, NULL, 186293),
(186294, '1.20.1270.60-FF-000292', NULL, 'Bridging integrator 2b', 156, NULL, NULL, 186294),
(186295, '3.30.70.920-FF-000023', NULL, 'HTH-type transcriptional regulator LrpC', 91, NULL, NULL, 186295),
(186296, '1.10.287.40-FF-000029', NULL, 'Uncharacterized protein', 112, NULL, NULL, 186296),
(186297, '2.40.50.100-FF-000067', NULL, 'Glycerol-3-phosphate ABC transporter ATP-binding protein', 55, NULL, NULL, 186297),
(186298, '1.10.20.10-FF-000373', NULL, NULL, 62, NULL, NULL, 186298),
(186299, '3.90.105.10-FF-000028', NULL, 'Molybdopterin molybdenumtransferase', 54, NULL, NULL, 186299),
(186300, '3.40.50.1820-FF-001067', NULL, 'Carboxypeptidase', 451, NULL, NULL, 186300),
(186301, '1.10.150.50-FF-000238', NULL, 'Uncharacterized protein', 65, NULL, NULL, 186301),
(186302, '3.30.70.940-FF-000029', NULL, 'Uncharacterized protein', 83, NULL, NULL, 186302),
(186303, '3.30.565.10-FF-000216', NULL, 'Sensor histidine kinase/response regulator', 159, NULL, NULL, 186303),
(186304, '3.20.20.80-FF-000844', NULL, 'Uncharacterized protein', 365, NULL, NULL, 186304),
(186305, '3.30.930.10-FF-000268', NULL, 'DNA polymerase subunit gamma-2, mitochondrial', 260, NULL, NULL, 186305),
(186306, '2.60.40.150-FF-000160', NULL, 'phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit gamma isoform X1', 148, NULL, NULL, 186306),
(186307, '1.25.10.10-FF-000608', NULL, 'Centrosomal protein 224', 251, NULL, NULL, 186307),
(186308, '1.20.1280.50-FF-000244', NULL, 'Predicted protein', 84, NULL, NULL, 186308),
(186309, '3.40.50.10860-FF-000001', NULL, 'Bifunctional protein FolD', 151, NULL, NULL, 186309);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(186310, '1.10.510.10-FF-003918', NULL, NULL, 75, NULL, NULL, 186310),
(186311, '3.30.160.60-FF-004501', NULL, NULL, 36, NULL, NULL, 186311),
(186312, '2.40.30.10-FF-000235', NULL, 'Elongation factor 2', 131, NULL, NULL, 186312),
(186313, '3.90.190.10-FF-000591', NULL, 'Predicted protein', 54, NULL, NULL, 186313),
(186314, '2.10.220.10-FF-000172', NULL, 'Uncharacterized protein', 84, NULL, NULL, 186314),
(186315, '3.40.640.10-FF-000013', NULL, '4-aminobutyrate aminotransferase', 266, NULL, NULL, 186315),
(186316, '3.60.40.10-FF-000194', NULL, 'Probable protein phosphatase 2C 80', 109, NULL, NULL, 186316),
(186317, '1.20.1250.20-FF-000857', NULL, 'Glucose transporter 1B/1C/1D/1F/2B', 211, NULL, NULL, 186317),
(186318, '1.50.40.10-FF-000518', NULL, 'Uncharacterized mitochondrial carrier C227.03c', 185, NULL, NULL, 186318),
(186319, '4.10.240.10-FF-000199', NULL, 'Uncharacterized protein', 95, NULL, NULL, 186319),
(186320, '2.40.170.20-FF-000124', NULL, 'Probable TonB-dependent receptor', 647, NULL, NULL, 186320),
(186321, '3.30.160.60-FF-004490', NULL, NULL, 28, NULL, NULL, 186321),
(186322, '3.30.730.10-FF-000011', NULL, 'Ethylene-responsive transcription factor ERF120', 58, NULL, NULL, 186322),
(186323, '1.25.40.10-FF-003781', NULL, 'ER membrane protein complex subunit 2-like Protein', 154, NULL, NULL, 186323),
(186324, '1.20.140.150-FF-000008', NULL, 'Transmembrane protein 204', 200, NULL, NULL, 186324),
(186325, '3.30.160.60-FF-006316', NULL, NULL, 92, NULL, NULL, 186325),
(186326, '1.25.40.710-FF-000018', NULL, 'Predicted protein', 151, NULL, NULL, 186326),
(186327, '1.10.30.10-FF-000003', NULL, 'Putative transcription factor SOX-6', 80, NULL, NULL, 186327),
(186328, '1.10.10.60-FF-000320', NULL, 'jerky protein homolog-like', 61, NULL, NULL, 186328),
(186329, '2.60.40.1670-FF-000012', NULL, 'Protein transport protein SEC23', 148, NULL, NULL, 186329),
(186330, '2.60.40.10-FF-005687', NULL, NULL, 77, NULL, NULL, 186330),
(186331, '2.30.30.760-FF-000004', NULL, NULL, 59, NULL, NULL, 186331),
(186332, '3.50.50.60-FF-001171', NULL, 'Electron transfer flavoprotein ubiquinone oxidoreductase', 272, NULL, NULL, 186332),
(186333, '2.40.10.10-FF-000352', NULL, NULL, 107, NULL, NULL, 186333),
(186334, '2.10.90.10-FF-000162', NULL, 'Glycoprotein hormones alpha chain', 64, NULL, NULL, 186334),
(186335, '2.30.30.770-FF-000007', NULL, 'Uncharacterized protein', 152, NULL, NULL, 186335),
(186336, '3.30.40.10-FF-001178', NULL, 'Ring finger protein 24', 59, NULL, NULL, 186336),
(186337, '1.20.1250.20-FF-001346', NULL, 'Putative small intestine urate exporter', 205, NULL, NULL, 186337),
(186338, '1.20.5.190-FF-000141', NULL, NULL, 42, NULL, NULL, 186338),
(186339, '3.40.50.300-FF-004434', NULL, 'Elongator complex protein 4', 347, NULL, NULL, 186339),
(186340, '3.40.50.300-FF-002652', NULL, 'RNA helicase', 276, NULL, NULL, 186340),
(186341, '3.90.1440.10-FF-000014', NULL, 'Uncharacterized protein', 106, NULL, NULL, 186341),
(186342, '3.30.200.20-FF-001930', NULL, 'Lectin receptor kinase', 89, NULL, NULL, 186342),
(186343, '1.25.50.20-FF-000058', NULL, 'Aminopeptidase', 153, NULL, NULL, 186343),
(186344, '2.60.40.10-FF-003916', NULL, NULL, 109, NULL, NULL, 186344),
(186345, '3.20.20.70-FF-000841', NULL, NULL, 95, NULL, NULL, 186345),
(186346, '3.40.50.2300-FF-001138', NULL, NULL, 127, NULL, NULL, 186346),
(186347, '3.40.30.10-FF-000755', NULL, 'SH3-binding', 102, NULL, NULL, 186347),
(186348, '3.40.33.10-FF-000099', NULL, 'Uncharacterized protein, isoform B', 235, NULL, NULL, 186348),
(186349, '2.60.40.10-FF-002814', NULL, NULL, 102, NULL, NULL, 186349),
(186350, '3.30.2160.10-FF-000040', NULL, 'Predicted protein', 33, NULL, NULL, 186350),
(186351, '1.20.1250.20-FF-001037', NULL, 'Uncharacterized protein', 191, NULL, NULL, 186351),
(186352, '3.40.50.10810-FF-000126', NULL, 'DNA helicase', 269, NULL, NULL, 186352),
(186353, '1.10.10.430-FF-000005', NULL, 'GG12191', 73, NULL, NULL, 186353),
(186354, '3.40.630.30-FF-000373', NULL, 'GNAT family N-acetyltransferase', 179, NULL, NULL, 186354),
(186355, '2.60.40.640-FF-000065', NULL, 'Arrestin domain-containing protein 17', 146, NULL, NULL, 186355);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(186356, '3.40.50.1820-FF-000578', NULL, 'Dipeptidyl peptidase 7', 32, NULL, NULL, 186356),
(186357, '2.130.10.10-FF-000331', NULL, 'Actin-related protein 2/3 complex subunit', 371, NULL, NULL, 186357),
(186358, '1.10.10.440-FF-000008', NULL, 'Transcription elongation regulator 1 (CA150)', 67, NULL, NULL, 186358),
(186359, '3.30.310.280-FF-000004', NULL, 'NTP-dependent putrebactin synthetase PubC', 133, NULL, NULL, 186359),
(186360, '4.10.860.10-FF-000010', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 45, NULL, NULL, 186360),
(186361, '3.30.60.20-FF-000081', NULL, 'Diacylglycerol kinase', 68, NULL, NULL, 186361),
(186362, '3.30.200.20-FF-001458', NULL, 'Putative inactive G-type lectin S-receptor-like serine/threonine-protein kinase SRK', 52, NULL, NULL, 186362),
(186363, '3.80.10.10-FF-001562', NULL, 'Receptor kinase-like protein', 115, NULL, NULL, 186363),
(186364, '3.10.20.90-FF-000342', NULL, 'Ubiquitin B', 72, NULL, NULL, 186364),
(186365, '3.40.50.300-FF-002282', NULL, 'Uncharacterized protein, isoform A', 179, NULL, NULL, 186365),
(186366, '3.40.190.10-FF-000231', NULL, 'Transcriptional activator MetR', 89, NULL, NULL, 186366),
(186367, '3.40.50.720-FF-001906', NULL, 'Malate dehydrogenase:SUBUNIT=A, putative', 105, NULL, NULL, 186367),
(186368, '1.25.10.10-FF-001699', NULL, 'Uncharacterized protein', 262, NULL, NULL, 186368),
(186369, '1.10.20.10-FF-000064', NULL, 'Transcription initiation factor TFIID subunit 9', 73, NULL, NULL, 186369),
(186370, '3.30.200.20-FF-002110', NULL, 'Predicted protein', 78, NULL, NULL, 186370),
(186371, '1.10.238.10-FF-000413', NULL, 'Calmodulin-like protein 1', 46, NULL, NULL, 186371),
(186372, '4.10.1240.10-FF-000090', NULL, 'Uncharacterized protein', 34, NULL, NULL, 186372),
(186373, '3.30.60.30-FF-000084', NULL, 'Agrin', 53, NULL, NULL, 186373),
(186374, '1.10.533.10-FF-000262', NULL, 'Uncharacterized protein', 44, NULL, NULL, 186374),
(186375, '3.40.50.150-FF-000185', NULL, 'O-methyltransferase family protein', 253, NULL, NULL, 186375),
(186376, '2.60.120.40-FF-000055', NULL, 'Elastin microfibril interfacer 1', 150, NULL, NULL, 186376),
(186377, '3.30.70.1230-FF-000095', NULL, 'Adenylate cyclase, putative', 108, NULL, NULL, 186377),
(186378, '2.130.10.10-FF-003883', NULL, 'Uncharacterized protein', 276, NULL, NULL, 186378),
(186379, '2.60.40.10-FF-000353', NULL, 'receptor-type tyrosine-protein phosphatase F isoform X1', 95, NULL, NULL, 186379),
(186380, '3.10.490.20-FF-000005', NULL, 'Dynein axonemal heavy chain 6', 165, NULL, NULL, 186380),
(186381, '3.40.50.720-FF-001227', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 289, NULL, NULL, 186381),
(186382, '1.10.287.110-FF-000264', NULL, 'DnaJ domain-containing protein', 98, NULL, NULL, 186382),
(186383, '1.10.10.2170-FF-000005', NULL, 'Uncharacterized protein', 47, NULL, NULL, 186383),
(186384, '1.20.140.140-FF-000005', NULL, 'calcium release-activated calcium channel protein 1', 205, NULL, NULL, 186384),
(186385, '1.10.1450.10-FF-000006', NULL, 'Tetraspanin', 94, NULL, NULL, 186385),
(186386, '3.30.70.240-FF-000049', NULL, 'Elongation factor G, domain IV family protein', 124, NULL, NULL, 186386),
(186387, '3.30.450.40-FF-000190', NULL, 'ATP-binding region ATPase domain protein', 157, NULL, NULL, 186387),
(186388, '1.20.58.860-FF-000010', NULL, 'Ubiquitin carboxyl-terminal hydrolase BAP1', 76, NULL, NULL, 186388),
(186389, '2.60.40.60-FF-000435', NULL, 'Cadherin 9', 80, NULL, NULL, 186389),
(186390, '3.40.605.10-FF-000089', NULL, 'Os12g0177900 protein', 54, NULL, NULL, 186390),
(186391, '3.40.50.1820-FF-000887', NULL, 'Uncharacterized protein', 226, NULL, NULL, 186391),
(186392, '3.10.490.10-FF-000002', NULL, 'Gamma-glutamylcyclotransferase', 185, NULL, NULL, 186392),
(186393, '3.80.10.10-FF-002973', NULL, 'Uncharacterized protein', 102, NULL, NULL, 186393),
(186394, '3.40.50.1360-FF-000069', NULL, 'Uncharacterized protein', 261, NULL, NULL, 186394),
(186395, '3.30.160.60-FF-002910', NULL, 'Zinc finger protein 557', 27, NULL, NULL, 186395),
(186396, '2.130.10.10-FF-005665', NULL, 'Rho guanine nucleotide exchange factor 10 like', 165, NULL, NULL, 186396);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(186397, '2.60.120.260-FF-000151', NULL, 'Beta-galactosidase', 133, NULL, NULL, 186397),
(186398, '3.40.20.10-FF-000148', NULL, 'Chromosome 1, whole genome shotgun sequence', 103, NULL, NULL, 186398),
(186399, '3.30.70.20-FF-000020', NULL, 'Hydrogenase 2 operon protein HybA', 154, NULL, NULL, 186399),
(186400, '3.30.590.10-FF-000022', NULL, 'Glutamine synthetase I', 352, NULL, NULL, 186400),
(186401, '2.30.30.140-FF-000139', NULL, 'Histone acetyltransferase', 102, NULL, NULL, 186401),
(186402, '3.40.50.1100-FF-000233', NULL, 'Uncharacterized protein', 63, NULL, NULL, 186402),
(186403, '2.10.25.10-FF-001236', NULL, 'Laminin, beta 1b', 47, NULL, NULL, 186403),
(186404, '3.30.505.10-FF-000224', NULL, NULL, 97, NULL, NULL, 186404),
(186405, '2.60.40.10-FF-002505', NULL, 'Synaptogenesis protein syg-2', 99, NULL, NULL, 186405),
(186406, '3.30.1300.10-FF-000012', NULL, NULL, 109, NULL, NULL, 186406),
(186407, '3.10.20.90-FF-000712', NULL, 'Uncharacterized protein', 81, NULL, NULL, 186407),
(186408, '2.60.40.10-FF-002135', NULL, 'Soluble starch synthase 3a, chloroplastic/amyloplastic', 97, NULL, NULL, 186408),
(186409, '3.30.870.10-FF-000004', NULL, 'protein FAM83H isoform X2', 181, NULL, NULL, 186409),
(186410, '3.40.50.1240-FF-000033', NULL, 'Chromosome 12, whole genome shotgun sequence', 392, NULL, NULL, 186410),
(186411, '1.10.357.10-FF-000032', NULL, 'Transcriptional regulatory protein (Probably AsnC-family)', 211, NULL, NULL, 186411),
(186412, '3.90.198.10-FF-000001', NULL, 'Single-stranded DNA binding protein', 233, NULL, NULL, 186412),
(186413, '3.90.70.10-FF-000750', NULL, 'Uncharacterized protein', 129, NULL, NULL, 186413),
(186414, '2.130.10.10-FF-005991', NULL, 'Uncharacterized protein', 227, NULL, NULL, 186414),
(186415, '3.40.50.1980-FF-000108', NULL, 'Iron(III) dicitrate-binding periplasmic protein', 115, NULL, NULL, 186415),
(186416, '3.40.50.300-FF-005862', NULL, 'Putative RNA helicase armi-like Protein', 123, NULL, NULL, 186416),
(186417, '1.10.287.70-FF-000499', NULL, 'Uncharacterized protein', 154, NULL, NULL, 186417),
(186418, '3.30.50.10-FF-000015', NULL, 'Nuclear receptor subfamily 2, group C, member 1', 107, NULL, NULL, 186418),
(186419, '1.20.1300.10-FF-000044', NULL, 'Succinate dehydrogenase subunit 3', 129, NULL, NULL, 186419),
(186420, '1.20.1280.50-FF-000098', NULL, 'F-box/kelch-repeat protein isoform A', 53, NULL, NULL, 186420),
(186421, '3.80.10.10-FF-001253', NULL, 'GD14431', 126, NULL, NULL, 186421),
(186422, '2.60.120.380-FF-000069', NULL, 'Probable subtilase-type serine protease DR_A0283', 141, NULL, NULL, 186422),
(186423, '3.40.50.720-FF-000873', NULL, 'Epimerase family protein MT2273', 286, NULL, NULL, 186423),
(186424, '3.10.110.10-FF-000261', NULL, 'Ubiquitin conjugating enzyme E2 E3', 158, NULL, NULL, 186424),
(186425, '2.170.150.20-FF-000002', NULL, 'Cereblon, isoform CRA_c', 129, NULL, NULL, 186425),
(186426, '2.130.10.10-FF-000229', NULL, 'Small nuclear ribonucleoprotein U5 subunit 40', 304, NULL, NULL, 186426),
(186427, '2.170.150.30-FF-000005', NULL, 'Dicer Related Helicase', 133, NULL, NULL, 186427),
(186428, '3.40.50.300-FF-006660', NULL, 'Uncharacterized protein', 86, NULL, NULL, 186428),
(186429, '1.10.238.10-FF-000093', NULL, 'Calcineurin B homologous protein 1', 195, NULL, NULL, 186429),
(186430, '1.10.132.20-FF-000002', NULL, 'Ribosome-recycling factor', 91, NULL, NULL, 186430),
(186431, '3.40.50.1260-FF-000039', NULL, 'Uncharacterized protein', 188, NULL, NULL, 186431),
(186432, '3.10.100.10-FF-000333', NULL, NULL, 89, NULL, NULL, 186432),
(186433, '2.30.30.40-FF-000109', NULL, 'Peroxisomal biogenesis factor 13', 66, NULL, NULL, 186433),
(186434, '1.20.1310.10-FF-000016', NULL, 'Cullin 2', 160, NULL, NULL, 186434),
(186435, '3.30.830.10-FF-000204', NULL, 'Peptidase family protein', 232, NULL, NULL, 186435),
(186436, '3.30.420.10-FF-000286', NULL, 'GM18382', 222, NULL, NULL, 186436),
(186437, '1.25.40.10-FF-003646', NULL, 'GH04440p', 166, NULL, NULL, 186437),
(186438, '2.30.30.30-FF-000062', NULL, 'Putative 40S ribosomal protein L14', 85, NULL, NULL, 186438);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(186439, '3.40.50.140-FF-000002', NULL, 'DNA topoisomerase', 169, NULL, NULL, 186439),
(186440, '1.20.120.420-FF-000001', NULL, 'Methylthioribose-1-phosphate isomerase', 152, NULL, NULL, 186440),
(186441, '3.40.140.10-FF-000166', NULL, 'Uncharacterized protein', 140, NULL, NULL, 186441),
(186442, '1.20.1310.20-FF-000019', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 250, NULL, NULL, 186442),
(186443, '3.30.70.1950-FF-000001', NULL, 'Adapter protein MecA', 92, NULL, NULL, 186443),
(186444, '3.30.1330.30-FF-000155', NULL, 'Uncharacterized protein', 39, NULL, NULL, 186444),
(186445, '1.10.510.10-FF-004054', NULL, NULL, 139, NULL, NULL, 186445),
(186446, '3.20.190.20-FF-000002', NULL, 'Protease Do-like 9', 150, NULL, NULL, 186446),
(186447, '3.60.21.10-FF-000037', NULL, 'Bifunctional 2'',3''-cyclic-nucleotide 2''-phosphodiesterase/3''-nucleotidase', 339, NULL, NULL, 186447),
(186448, '2.40.30.230-FF-000012', NULL, 'Regulator of nonsense transcripts 1', 90, NULL, NULL, 186448),
(186449, '4.10.60.10-FF-000110', NULL, 'Glycine-rich RNA-binding protein RZ1B isoform C', 39, NULL, NULL, 186449),
(186450, '2.30.30.40-FF-000065', NULL, 'adapter molecule crk isoform X1', 76, NULL, NULL, 186450),
(186451, '3.40.50.1440-FF-000104', NULL, 'Uncharacterized protein', 101, NULL, NULL, 186451),
(186452, '3.40.50.150-FF-000005', NULL, 'Ribosomal RNA large subunit methyltransferase E', 182, NULL, NULL, 186452),
(186453, '1.20.120.1910-FF-000051', NULL, 'Probable cysteinyl-trna synthetase', 152, NULL, NULL, 186453),
(186454, '1.10.510.10-FF-000355', NULL, 'Integrin-linked protein kinase family', 197, NULL, NULL, 186454),
(186455, '1.20.120.430-FF-000004', NULL, 'tRNA modification GTPase TrmE', 167, NULL, NULL, 186455),
(186456, '3.30.70.330-FF-002212', NULL, NULL, 100, NULL, NULL, 186456),
(186457, '2.130.10.10-FF-001949', NULL, 'Mediator of RNA polymerase II transcription subunit 16', 406, NULL, NULL, 186457),
(186458, '3.30.2300.10-FF-000012', NULL, 'Thump domain-containing protein, putative', 84, NULL, NULL, 186458),
(186459, '2.10.25.10-FF-000556', NULL, 'Blast:Protein slit', 49, NULL, NULL, 186459),
(186460, '1.20.930.40-FF-000028', NULL, 'AAL107Wp', 153, NULL, NULL, 186460),
(186461, '1.20.1070.10-FF-001245', NULL, 'Adhesion G protein-coupled receptor G7, tandem duplicate 2', 243, NULL, NULL, 186461),
(186462, '3.40.630.30-FF-000390', NULL, 'Uncharacterized protein', 126, NULL, NULL, 186462),
(186463, '1.10.240.10-FF-000019', NULL, 'Tryptophan--tRNA ligase', 109, NULL, NULL, 186463),
(186464, '3.30.310.270-FF-000001', NULL, 'BicC family RNA binding protein 1', 171, NULL, NULL, 186464),
(186465, '3.30.70.920-FF-000040', NULL, 'AsnC family transcriptional regulator', 92, NULL, NULL, 186465),
(186466, '1.10.510.10-FF-002154', NULL, NULL, 62, NULL, NULL, 186466),
(186467, '3.40.50.300-FF-002326', NULL, 'ATP-dependent RNA helicase DBP7', 308, NULL, NULL, 186467),
(186468, '2.40.10.10-FF-000009', NULL, 'Serine endoprotease DegS, periplasmic', 113, NULL, NULL, 186468),
(186469, '3.20.20.140-FF-000490', NULL, 'Gll3171 protein', 267, NULL, NULL, 186469),
(186470, '1.20.58.390-FF-000083', NULL, 'Ligand-Gated ion Channel', 135, NULL, NULL, 186470),
(186471, '2.130.10.10-FF-003557', NULL, 'Uncharacterized protein', 225, NULL, NULL, 186471),
(186472, '3.30.750.24-FF-000110', NULL, 'Sulfate permease family protein', 92, NULL, NULL, 186472),
(186473, '1.20.120.1800-FF-000001', NULL, NULL, 89, NULL, NULL, 186473),
(186474, '3.80.20.20-FF-000082', NULL, 'Predicted protein', 125, NULL, NULL, 186474),
(186475, '3.30.160.60-FF-000465', NULL, 'zinc finger protein 536', 25, NULL, NULL, 186475),
(186476, '3.90.190.10-FF-000574', NULL, 'Uncharacterized protein', 133, NULL, NULL, 186476),
(186477, '3.30.565.10-FF-000200', NULL, 'Hybrid sensor histidine kinase/response regulator', 169, NULL, NULL, 186477),
(186478, '3.40.50.300-FF-008503', NULL, 'Uncharacterized protein', 154, NULL, NULL, 186478),
(186479, '2.130.10.10-FF-002129', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 129, NULL, NULL, 186479);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(186480, '3.30.559.30-FF-000118', NULL, 'Uncharacterized protein', 175, NULL, NULL, 186480),
(186481, '3.90.550.10-FF-000309', NULL, 'Glycosyl transferase family 2', 212, NULL, NULL, 186481),
(186482, '3.30.420.40-FF-000053', NULL, 'Bifunctional UDP-N-acetylglucosamine 2-epimerase/N-acetylmannosamine kinase', 122, NULL, NULL, 186482),
(186483, '2.40.50.140-FF-001057', NULL, NULL, 106, NULL, NULL, 186483),
(186484, '2.10.230.10-FF-000009', NULL, 'Xdj1p', 77, NULL, NULL, 186484),
(186485, '2.120.10.80-FF-000301', NULL, 'Uncharacterized protein', 194, NULL, NULL, 186485),
(186486, '1.25.10.10-FF-000401', NULL, 'Ranbp16, isoform H', 477, NULL, NULL, 186486),
(186487, '3.30.160.60-FF-005592', NULL, NULL, 62, NULL, NULL, 186487),
(186488, '3.30.505.10-FF-000180', NULL, NULL, 110, NULL, NULL, 186488),
(186489, '3.90.550.10-FF-000444', NULL, 'Probable UDP-N-acetylglucosamine pyrophosphorylase', 484, NULL, NULL, 186489),
(186490, '3.30.70.1660-FF-000021', NULL, 'Peptide chain release factor 1, putative', 146, NULL, NULL, 186490),
(186491, '4.10.400.10-FF-000055', NULL, 'Low-density lipoprotein receptor-related protein 10', 42, NULL, NULL, 186491),
(186492, '1.10.440.10-FF-000001', NULL, 'Endonuclease V', 138, NULL, NULL, 186492),
(186493, '3.40.50.10810-FF-000110', NULL, 'Putative SNF2 family helicase', 297, NULL, NULL, 186493),
(186494, '2.80.10.50-FF-000132', NULL, 'Uncharacterized protein', 67, NULL, NULL, 186494),
(186495, '3.40.1380.20-FF-000074', NULL, 'Uncharacterized protein', 66, NULL, NULL, 186495),
(186496, '1.10.472.10-FF-000018', NULL, 'Cyclin-K (Predicted)', 110, NULL, NULL, 186496),
(186497, '2.10.90.10-FF-000145', NULL, 'Uncharacterized protein', 107, NULL, NULL, 186497),
(186498, '1.10.245.10-FF-000008', NULL, 'E3 ubiquitin-protein ligase Mdm2 isoform X2', 64, NULL, NULL, 186498),
(186499, '3.40.50.300-FF-000718', NULL, 'Ras-like protein family member 11A', 173, NULL, NULL, 186499),
(186500, '1.10.150.240-FF-000051', NULL, 'Probable hydrolase', 66, NULL, NULL, 186500),
(186501, '1.10.730.10-FF-000203', NULL, 'Valyl tRNA Synthetase', 110, NULL, NULL, 186501),
(186502, '1.10.3720.10-FF-000016', NULL, 'Oligopeptide transport system permease OppB', 217, NULL, NULL, 186502),
(186503, '1.20.1250.20-FF-001363', NULL, 'Major facilitator superfamily transporter', 198, NULL, NULL, 186503),
(186504, '1.10.510.10-FF-003891', NULL, NULL, 87, NULL, NULL, 186504),
(186505, '3.30.70.330-FF-001706', NULL, NULL, 84, NULL, NULL, 186505),
(186506, '4.10.400.10-FF-000190', NULL, 'Low-density lipoprotein receptor-related protein', 41, NULL, NULL, 186506),
(186507, '2.60.120.430-FF-000028', NULL, 'Rhamnogalacturonan acetylesterase RhgT', 148, NULL, NULL, 186507),
(186508, '3.40.50.300-FF-006334', NULL, 'Uncharacterized protein', 211, NULL, NULL, 186508),
(186509, '3.20.20.70-FF-000824', NULL, NULL, 166, NULL, NULL, 186509),
(186510, '4.10.1240.10-FF-000073', NULL, 'Uncharacterized protein', 68, NULL, NULL, 186510),
(186511, '2.60.40.10-FF-002461', NULL, 'Sushi, nidogen and EGF-like domains 1', 103, NULL, NULL, 186511),
(186512, '3.40.50.300-FF-002635', NULL, 'helicase POLQ-like', 187, NULL, NULL, 186512),
(186513, '1.10.287.70-FF-000527', NULL, 'Sodium channel, voltage-gated, type VIII, alpha subunit b', 75, NULL, NULL, 186513),
(186514, '2.130.10.130-FF-000029', NULL, NULL, 153, NULL, NULL, 186514),
(186515, '2.20.25.10-FF-000095', NULL, 'DNA-directed RNA polymerase subunit', 57, NULL, NULL, 186515),
(186516, '3.40.50.150-FF-000640', NULL, 'DNA adenine methylase', 146, NULL, NULL, 186516),
(186517, '3.30.2160.10-FF-000023', NULL, 'Os09g0484300 protein', 81, NULL, NULL, 186517),
(186518, '1.10.472.10-FF-000327', NULL, 'Cyclin D2', 99, NULL, NULL, 186518),
(186519, '1.10.287.1490-FF-000151', NULL, 'AT2G24420 protein', 164, NULL, NULL, 186519),
(186520, '2.40.30.140-FF-000002', NULL, 'Alpha-amylase', 104, NULL, NULL, 186520),
(186521, '3.90.70.10-FF-000424', NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', 390, NULL, NULL, 186521),
(186522, '1.50.40.10-FF-000474', NULL, 'Mitochondrial carrier protein, putative', 292, NULL, NULL, 186522);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(186523, '1.25.10.10-FF-000272', NULL, 'Condensin complex subunit 1', 242, NULL, NULL, 186523),
(186524, '2.10.25.10-FF-000882', NULL, 'Mucin apoprotein', 58, NULL, NULL, 186524),
(186525, '2.60.40.790-FF-000014', NULL, 'AT-rich interactive domain-containing protein 3', 109, NULL, NULL, 186525),
(186526, '2.10.25.10-FF-001371', NULL, 'Uncharacterized protein', 48, NULL, NULL, 186526),
(186527, '3.30.70.330-FF-000060', NULL, 'CUGBP Elav-like family member 4', 97, NULL, NULL, 186527),
(186528, '3.40.50.300-FF-006025', NULL, 'Uncharacterized protein', 125, NULL, NULL, 186528),
(186529, '3.30.420.40-FF-000036', NULL, 'ARP3 actin-related protein 3 homolog', 119, NULL, NULL, 186529),
(186530, '1.10.238.10-FF-000430', NULL, 'Endonuclease/exonuclease/phosphatase family protein, putative, expressed', 101, NULL, NULL, 186530),
(186531, '1.10.510.10-FF-000029', NULL, 'Homeodomain-interacting protein kinase 2 isoform 1', 254, NULL, NULL, 186531),
(186532, '3.90.70.10-FF-000295', NULL, 'MATH and UCH domain protein, putaitve', 282, NULL, NULL, 186532),
(186533, '3.40.1260.20-FF-000008', NULL, 'Ribonuclease, Rne/Rng family', 98, NULL, NULL, 186533),
(186534, '2.60.40.820-FF-000012', NULL, 'T-box transcription factor TBX2', 169, NULL, NULL, 186534),
(186535, '2.60.200.20-FF-000224', NULL, 'Uncharacterized protein', 96, NULL, NULL, 186535),
(186536, '1.20.120.1080-FF-000088', NULL, 'AGAP008081-PA', 104, NULL, NULL, 186536),
(186537, '3.20.20.140-FF-000473', NULL, 'Predicted protein', 173, NULL, NULL, 186537),
(186538, '1.25.10.10-FF-002172', NULL, 'Uncharacterized protein', 487, NULL, NULL, 186538),
(186539, '3.30.160.360-FF-000004', NULL, 'Histone-lysine N-methyltransferase', 85, NULL, NULL, 186539),
(186540, '2.70.20.10-FF-000020', NULL, 'DNA topoisomerase 1', 127, NULL, NULL, 186540),
(186541, '1.10.287.370-FF-000084', NULL, 'Predicted protein', 113, NULL, NULL, 186541),
(186542, '3.30.505.10-FF-000207', NULL, NULL, 117, NULL, NULL, 186542),
(186543, '2.60.40.10-FF-002152', NULL, 'Lachesin', 109, NULL, NULL, 186543),
(186544, '2.60.40.1180-FF-000062', NULL, 'Alpha-amylase 3, chloroplastic', 57, NULL, NULL, 186544),
(186545, '2.60.40.10-FF-000027', NULL, 'receptor-type tyrosine-protein phosphatase delta isoform X1', 87, NULL, NULL, 186545),
(186546, '2.30.39.10-FF-000087', NULL, 'Serpin 1', 153, NULL, NULL, 186546),
(186547, '1.10.1420.10-FF-000151', NULL, 'MutS family', 195, NULL, NULL, 186547),
(186548, '1.10.510.10-FF-003874', NULL, NULL, 92, NULL, NULL, 186548),
(186549, '1.20.5.350-FF-000015', NULL, NULL, 78, NULL, NULL, 186549),
(186550, '2.30.30.140-FF-000156', NULL, 'Histone acetyltransferase', 108, NULL, NULL, 186550),
(186551, '1.20.5.340-FF-000012', NULL, 'Wiskott-Aldrich syndrome protein family member 1', 85, NULL, NULL, 186551),
(186552, '2.130.10.10-FF-003866', NULL, 'Uncharacterized protein', 282, NULL, NULL, 186552),
(186553, '2.130.10.120-FF-000026', NULL, 'Predicted protein', 387, NULL, NULL, 186553),
(186554, '3.40.50.300-FF-000735', NULL, 'Lactation elevated 1 (Predicted)', 172, NULL, NULL, 186554),
(186555, '1.10.510.10-FF-002480', NULL, NULL, 75, NULL, NULL, 186555),
(186556, '2.60.40.10-FF-004052', NULL, NULL, 97, NULL, NULL, 186556),
(186557, '2.170.120.12-FF-000011', NULL, 'DNA-directed RNA polymerase, alpha subunit, putative', 139, NULL, NULL, 186557),
(186558, '3.40.50.150-FF-000331', NULL, 'Macrocin O-methyltransferase', 247, NULL, NULL, 186558),
(186559, '2.80.10.50-FF-000087', NULL, 'Putative frg1-like family protein', 172, NULL, NULL, 186559),
(186560, '1.10.10.10-FF-001873', NULL, 'Predicted protein', 56, NULL, NULL, 186560),
(186561, '2.60.40.1670-FF-000028', NULL, NULL, 154, NULL, NULL, 186561),
(186562, '3.40.605.10-FF-000117', NULL, 'Uncharacterized protein', 31, NULL, NULL, 186562),
(186563, '3.30.70.1230-FF-000241', NULL, 'Guanylate cyclase', 114, NULL, NULL, 186563),
(186564, '1.25.40.490-FF-000002', NULL, 'FA complementation group F', 195, NULL, NULL, 186564),
(186565, '3.40.50.410-FF-000089', NULL, 'Protein transport protein Sec24A', 260, NULL, NULL, 186565),
(186566, '1.10.8.60-FF-000454', NULL, '26S protease regulatory subunit 6B, putative', 50, NULL, NULL, 186566); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(186567, '3.40.50.1820-FF-001084', NULL, 'Amino acid adenylation domain protein', 191, NULL, NULL, 186567),
(186568, '2.30.180.10-FF-000129', NULL, NULL, 130, NULL, NULL, 186568),
(186569, '3.80.10.10-FF-001236', NULL, 'Leucine-rich repeat (LRR) family protein', 281, NULL, NULL, 186569),
(186570, '3.40.50.790-FF-000039', NULL, 'Uncharacterized protein', 90, NULL, NULL, 186570),
(186571, '2.130.10.10-FF-005682', NULL, 'WD repeat protein, putative', 160, NULL, NULL, 186571),
(186572, '3.90.230.10-FF-000044', NULL, 'AGAP012802-PA', 265, NULL, NULL, 186572),
(186573, '1.10.472.10-FF-000120', NULL, 'G1/S-specific cyclin-D1', 113, NULL, NULL, 186573),
(186574, '2.60.40.150-FF-000025', NULL, 'Extended synaptotagmin 2', 149, NULL, NULL, 186574),
(186575, '2.10.110.10-FF-000017', NULL, 'Lim and senescent cell antigen-like-containing', 62, NULL, NULL, 186575),
(186576, '3.40.1000.10-FF-000032', NULL, 'Uncharacterized protein', 121, NULL, NULL, 186576),
(186577, '3.40.190.290-FF-000054', NULL, 'Transcriptional regulator, LysR family', 202, NULL, NULL, 186577),
(186578, '3.40.30.10-FF-000429', NULL, 'Protein CBG18827', 91, NULL, NULL, 186578),
(186579, '3.90.1640.10-FF-000012', NULL, 'DHH phosphoesterase', 248, NULL, NULL, 186579),
(186580, '1.10.238.10-FF-000076', NULL, 'SPARC-related modular calcium binding protein 1', 126, NULL, NULL, 186580),
(186581, '3.10.100.10-FF-000316', NULL, NULL, 218, NULL, NULL, 186581),
(186582, '2.40.30.10-FF-000218', NULL, 'NAD(P)H-flavin reductase', 102, NULL, NULL, 186582),
(186583, '2.160.10.10-FF-000060', NULL, 'UTP--glucose-1-phosphate uridylyltransferase', 106, NULL, NULL, 186583),
(186584, '2.60.40.60-FF-000570', NULL, 'Uncharacterized protein', 104, NULL, NULL, 186584),
(186585, '2.70.130.10-FF-000106', NULL, NULL, 147, NULL, NULL, 186585),
(186586, '3.30.830.10-FF-000221', NULL, '[Pyruvate dehydrogenase (Acetyl-transferring)] kinase mitochondrial', 100, NULL, NULL, 186586),
(186587, '3.90.70.10-FF-000115', NULL, 'DOA4p Ubiquitin hydrolase', 366, NULL, NULL, 186587),
(186588, '1.10.1780.10-FF-000008', NULL, 'Chaperone protein ClpB', 151, NULL, NULL, 186588),
(186589, '3.40.50.10330-FF-000078', NULL, 'Mitochondrial NADH kinase POS5, putative', 67, NULL, NULL, 186589),
(186590, '1.50.40.10-FF-000165', NULL, 'Mitochondrial Carrier (MC) Family', 167, NULL, NULL, 186590),
(186591, '1.10.400.10-FF-000010', NULL, 'Guanine nucleotide-binding protein alpha-13 subunit', 118, NULL, NULL, 186591),
(186592, '3.40.50.2300-FF-000975', NULL, NULL, 51, NULL, NULL, 186592),
(186593, '1.10.10.60-FF-000292', NULL, 'Acetoacetate metabolism regulatory protein AtoC', 76, NULL, NULL, 186593),
(186594, '2.30.29.30-FF-001317', NULL, 'SHANK associated RH domain interactor', 69, NULL, NULL, 186594),
(186595, '3.40.50.300-FF-004451', NULL, 'AGAP004685-PA', 274, NULL, NULL, 186595),
(186596, '2.40.100.10-FF-000156', NULL, 'Peptidyl-prolyl cis-trans isomerase', 128, NULL, NULL, 186596),
(186597, '3.40.50.300-FF-004760', NULL, 'Guanine nucleotide-binding protein G(k) subunit alpha', 68, NULL, NULL, 186597),
(186598, '3.10.20.90-FF-000566', NULL, 'Uncharacterized protein', 73, NULL, NULL, 186598),
(186599, '2.40.50.140-FF-000894', NULL, NULL, 92, NULL, NULL, 186599),
(186600, '2.30.30.40-FF-000082', NULL, 'SH3 and PX domain-containing protein 2B', 51, NULL, NULL, 186600),
(186601, '3.40.1620.60-FF-000009', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs adt-2', 73, NULL, NULL, 186601),
(186602, '1.20.5.190-FF-000124', NULL, NULL, 40, NULL, NULL, 186602),
(186603, '2.70.98.110-FF-000003', NULL, 'Probable mannosyl-oligosaccharide glucosidase', 302, NULL, NULL, 186603),
(186604, '2.130.10.10-FF-001966', NULL, 'Ribosome biogenesis protein NSA1', 257, NULL, NULL, 186604),
(186605, '3.40.630.30-FF-000597', NULL, 'Glucosamine 6-phosphate N-acetyltransferase', 78, NULL, NULL, 186605),
(186606, '3.70.10.10-FF-000051', NULL, 'Proliferating cell nuclear antigen', 261, NULL, NULL, 186606),
(186607, '2.40.10.10-FF-000335', NULL, 'Serine protease H65', 238, NULL, NULL, 186607),
(186608, '2.30.29.30-FF-000828', NULL, 'Uncharacterized protein', 128, NULL, NULL, 186608);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(186609, '1.10.8.960-FF-000003', NULL, 'Gamma-glutamylcysteine synthetase', 63, NULL, NULL, 186609),
(186610, '3.10.100.10-FF-000007', NULL, 'L-selectin', 160, NULL, NULL, 186610),
(186611, '3.40.30.10-FF-000738', NULL, 'Uncharacterized protein', 125, NULL, NULL, 186611),
(186612, '4.10.670.10-FF-000001', NULL, 'cholecystokinin receptor type A', 42, NULL, NULL, 186612),
(186613, '3.30.200.20-FF-001593', NULL, 'AGAP005763-PA', 134, NULL, NULL, 186613),
(186614, '1.20.1270.60-FF-000275', NULL, 'Uncharacterized protein', 66, NULL, NULL, 186614),
(186615, '3.40.1280.30-FF-000013', NULL, 'tRNA methyltransferase 10 homolog B', 199, NULL, NULL, 186615),
(186616, '1.25.10.10-FF-000064', NULL, 'Sister chromatid cohesion protein PDS5 homolog A', 186, NULL, NULL, 186616),
(186617, '3.40.50.300-FF-005980', NULL, 'CRISPR-associated helicase/endonuclease Cas3', 139, NULL, NULL, 186617),
(186618, '3.55.50.30-FF-000004', NULL, 'Type III secretion outer membrane pore YscC', 85, NULL, NULL, 186618),
(186619, '3.40.50.1700-FF-000008', NULL, 'Beta-glucosidase', 274, NULL, NULL, 186619),
(186620, '3.40.190.10-FF-000040', NULL, 'Glutamate receptor, ionotropic, delta 2', 109, NULL, NULL, 186620),
(186621, '3.90.70.10-FF-000632', NULL, 'Uncharacterized protein', 119, NULL, NULL, 186621),
(186622, '3.40.50.150-FF-000314', NULL, '2-methoxy-6-polyprenyl-1,4-benzoquinol methylase, mitochondrial', 290, NULL, NULL, 186622),
(186623, '3.40.50.10810-FF-000109', NULL, 'SNF2 domain-containing protein CLASSY 4', 306, NULL, NULL, 186623),
(186624, '3.30.60.30-FF-000067', NULL, 'Thrombin inhibitor rhodniin', 51, NULL, NULL, 186624),
(186625, '3.30.60.20-FF-000064', NULL, 'Protein kinase C', 57, NULL, NULL, 186625),
(186626, '3.30.160.60-FF-004046', NULL, NULL, 33, NULL, NULL, 186626),
(186627, '3.90.1310.10-FF-000010', NULL, 'Probable peptidoglycan D,D-transpeptidase PenA', 123, NULL, NULL, 186627),
(186628, '2.60.120.260-FF-000134', NULL, 'Uncharacterized protein', 199, NULL, NULL, 186628),
(186629, '3.90.70.10-FF-000087', NULL, 'Counting factor associated protein D', 311, NULL, NULL, 186629),
(186630, '3.90.190.10-FF-000557', NULL, 'Dual-specificity protein phosphatase, putative', 99, NULL, NULL, 186630),
(186631, '2.60.40.60-FF-000244', NULL, 'Cadherin related family member 3', 112, NULL, NULL, 186631),
(186632, '3.30.160.60-FF-001876', NULL, NULL, 28, NULL, NULL, 186632),
(186633, '3.40.50.1820-FF-000595', NULL, 'Alpha/beta hydrolase family, putative', 251, NULL, NULL, 186633),
(186634, '3.80.10.10-FF-000865', NULL, 'Leucine-rich repeat-containing protein 19', 72, NULL, NULL, 186634),
(186635, '3.80.10.10-FF-001371', NULL, 'Uncharacterized protein', 144, NULL, NULL, 186635),
(186636, '1.20.140.40-FF-000007', NULL, 'Pectinesterase inhibitor', 150, NULL, NULL, 186636),
(186637, '2.40.70.10-FF-000327', NULL, NULL, 174, NULL, NULL, 186637),
(186638, '3.60.21.10-FF-000155', NULL, 'Metallophosphoesterase', 236, NULL, NULL, 186638),
(186639, '1.20.144.10-FF-000142', NULL, 'Putative lipid phosphate phosphatase 3 chloroplastic', 186, NULL, NULL, 186639),
(186640, '3.40.1360.10-FF-000053', NULL, 'DNA primase', 124, NULL, NULL, 186640),
(186641, '1.10.10.10-FF-002036', NULL, 'Putative DNA processing protein DprA', 69, NULL, NULL, 186641),
(186642, '2.160.20.10-FF-000015', NULL, 'F-box only protein 10', 167, NULL, NULL, 186642),
(186643, '3.30.70.1660-FF-000004', NULL, 'Peptide chain release factor 1', 83, NULL, NULL, 186643),
(186644, '1.10.238.10-FF-000222', NULL, 'Secretagogin', 80, NULL, NULL, 186644),
(186645, '2.60.40.10-FF-000235', NULL, 'Leucine-rich repeat and fibronectin type III domain-containing 2', 100, NULL, NULL, 186645),
(186646, '3.30.1340.30-FF-000009', NULL, 'Tri-BON domain-containing protein', 65, NULL, NULL, 186646),
(186647, '1.20.140.10-FF-000049', NULL, 'Acyl-CoA dehydrogenase', 144, NULL, NULL, 186647),
(186648, '3.90.550.10-FF-000427', NULL, 'Procollagen-lysine,2-oxoglutarate 5-dioxygenase 1', 280, NULL, NULL, 186648),
(186649, '3.40.1380.20-FF-000057', NULL, 'Pyruvate kinase', 104, NULL, NULL, 186649),
(186650, '1.10.150.240-FF-000034', NULL, 'Putative phosphoglycolate phosphatase', 67, NULL, NULL, 186650);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(186651, '3.30.40.10-FF-001633', NULL, 'Structure-specific endonuclease subunit SLX1 homolog', 64, NULL, NULL, 186651),
(186652, '1.10.510.10-FF-002272', NULL, NULL, 194, NULL, NULL, 186652),
(186653, '3.40.50.1240-FF-000050', NULL, 'Fructose-2,6-bisphosphatase, putative', 158, NULL, NULL, 186653),
(186654, '3.30.70.330-FF-001723', NULL, NULL, 142, NULL, NULL, 186654),
(186655, '2.40.50.100-FF-000084', NULL, 'AGAP005119-PA', 73, NULL, NULL, 186655),
(186656, '1.20.58.390-FF-000009', NULL, 'Cholinergic receptor nicotinic alpha 9 subunit', 116, NULL, NULL, 186656),
(186657, '2.60.40.150-FF-000351', NULL, 'Copine-A', 125, NULL, NULL, 186657),
(186658, '3.30.497.10-FF-000125', NULL, 'Serpin family B member 2', 167, NULL, NULL, 186658),
(186659, '1.10.1070.11-FF-000012', NULL, 'Phosphatidylinositol 4-kinase alpha 1', 197, NULL, NULL, 186659),
(186660, '1.10.720.60-FF-000021', NULL, 'Uncharacterized protein', 108, NULL, NULL, 186660),
(186661, '2.60.40.340-FF-000008', NULL, 'Dif, isoform A', 175, NULL, NULL, 186661),
(186662, '2.40.50.730-FF-000020', NULL, 'DNA polymerase alpha catalytic subunit', 90, NULL, NULL, 186662),
(186663, '3.40.1370.10-FF-000025', NULL, 'Related to 50S ribosomal protein L4', 282, NULL, NULL, 186663),
(186664, '1.25.40.10-FF-000212', NULL, 'Pentatricopeptide repeat-containing protein At2g03380, mitochondrial', 210, NULL, NULL, 186664),
(186665, '1.10.8.60-FF-000246', NULL, 'Phosphoglycerate transport system transcriptional regulatory protein PgtA', 61, NULL, NULL, 186665),
(186666, '2.40.70.10-FF-000226', NULL, 'Uncharacterized protein', 173, NULL, NULL, 186666),
(186667, '1.20.1280.50-FF-000227', NULL, 'F-box protein pof7', 102, NULL, NULL, 186667),
(186668, '3.30.160.60-FF-001775', NULL, 'PR domain containing 9', 29, NULL, NULL, 186668),
(186669, '4.10.1060.10-FF-000019', NULL, 'Calpain 15', 36, NULL, NULL, 186669),
(186670, '3.40.720.10-FF-000306', NULL, 'Uncharacterized protein', 221, NULL, NULL, 186670),
(186671, '3.90.1750.10-FF-000015', NULL, 'E3 ubiquitin-protein ligase HERC2 isoform X2', 158, NULL, NULL, 186671),
(186672, '2.70.170.10-FF-000171', NULL, 'Uncharacterized protein', 200, NULL, NULL, 186672),
(186673, '3.20.20.140-FF-000489', NULL, 'Predicted protein', 108, NULL, NULL, 186673),
(186674, '1.20.1070.10-FF-001127', NULL, 'Rhodopsin, GQ-coupled', 303, NULL, NULL, 186674),
(186675, '3.30.460.10-FF-000069', NULL, 'Mitochondrial editosome-like complex associated TUTase', 131, NULL, NULL, 186675),
(186676, '3.30.70.330-FF-001824', NULL, NULL, 120, NULL, NULL, 186676),
(186677, '1.20.120.1760-FF-000062', NULL, NULL, 190, NULL, NULL, 186677),
(186678, '2.120.10.30-FF-000511', NULL, 'Uncharacterized protein', 197, NULL, NULL, 186678),
(186679, '2.60.40.10-FF-003888', NULL, NULL, 90, NULL, NULL, 186679),
(186680, '1.25.10.10-FF-001492', NULL, 'Catenin (cadherin-associated protein), delta 2b', 158, NULL, NULL, 186680),
(186681, '1.20.58.2220-FF-000068', NULL, 'Uncharacterized protein', 132, NULL, NULL, 186681),
(186682, '4.10.365.10-FF-000005', NULL, 'Cyclin-dependent kinase inhibitor 7', 68, NULL, NULL, 186682),
(186683, '2.130.10.10-FF-000213', NULL, 'gem-associated protein 5 isoform X1', 351, NULL, NULL, 186683),
(186684, '2.60.120.10-FF-000187', NULL, 'Mannose-6-phosphate isomerase', 103, NULL, NULL, 186684),
(186685, '1.20.58.80-FF-000031', NULL, 'Protein CBG12661', 78, NULL, NULL, 186685),
(186686, '3.80.10.10-FF-003136', NULL, 'Predicted gene 45213', 62, NULL, NULL, 186686),
(186687, '2.10.220.10-FF-000155', NULL, 'Receptor protein-tyrosine kinase', 136, NULL, NULL, 186687),
(186688, '1.10.8.270-FF-000010', NULL, 'Putative USP6 N-terminal-like protein', 95, NULL, NULL, 186688),
(186689, '1.20.120.1900-FF-000031', NULL, 'Spindle pole body component', 362, NULL, NULL, 186689),
(186690, '3.30.160.60-FF-006081', NULL, NULL, 28, NULL, NULL, 186690),
(186691, '2.60.200.20-FF-000241', NULL, 'Predicted protein', 121, NULL, NULL, 186691),
(186692, '1.20.1560.10-FF-000838', NULL, 'Uncharacterized protein', 337, NULL, NULL, 186692),
(186693, '2.40.100.10-FF-000055', NULL, 'Peptidyl-prolyl cis-trans isomerase', 202, NULL, NULL, 186693);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(186694, '1.20.1070.10-FF-001806', NULL, 'Predicted protein', 314, NULL, NULL, 186694),
(186695, '3.90.550.10-FF-000326', NULL, 'Procollagen-lysine,2-oxoglutarate 5-dioxygenase 2', 152, NULL, NULL, 186695),
(186696, '1.10.287.700-FF-000003', NULL, 'Late embryogenesis abundant protein 29', 85, NULL, NULL, 186696),
(186697, '1.25.10.10-FF-002407', NULL, 'Proteasome/cyclosome repeat family protein', 254, NULL, NULL, 186697),
(186698, '1.10.10.60-FF-000191', NULL, 'GON-4-like protein isoform X1', 70, NULL, NULL, 186698),
(186699, '3.40.50.300-FF-004552', NULL, 'Death-associated protein kinase 1', 190, NULL, NULL, 186699),
(186700, '3.40.30.10-FF-000946', NULL, 'Thioredoxin-1', 109, NULL, NULL, 186700),
(186701, '3.30.1340.10-FF-000003', NULL, 'Phosphocarrier protein HPr', 88, NULL, NULL, 186701),
(186702, '3.30.160.60-FF-000347', NULL, 'PR domain zinc finger protein 10', 26, NULL, NULL, 186702),
(186703, '3.10.20.90-FF-000358', NULL, 'Serine/threonine-protein kinase WNK', 97, NULL, NULL, 186703),
(186704, '1.20.1250.20-FF-000874', NULL, 'SoLute Carrier Family', 194, NULL, NULL, 186704),
(186705, '3.30.160.60-FF-000095', NULL, 'Vascular endothelial zinc finger 1', 25, NULL, NULL, 186705),
(186706, '1.20.1070.10-FF-000773', NULL, 'Olfactory receptor family 2 subfamily B member 6', 150, NULL, NULL, 186706),
(186707, '2.60.40.1970-FF-000012', NULL, NULL, 117, NULL, NULL, 186707),
(186708, '3.40.140.10-FF-000211', NULL, 'tRNA(cytosine(8)) deaminase', 113, NULL, NULL, 186708),
(186709, '1.20.1560.10-FF-000529', NULL, 'Uncharacterized protein', 24, NULL, NULL, 186709),
(186710, '2.30.30.40-FF-000418', NULL, 'Meiotically up-regulated gene 137 protein', 77, NULL, NULL, 186710),
(186711, '1.20.120.1910-FF-000034', NULL, 'Cysteinyl-tRNA synthetase, class Ia family protein', 162, NULL, NULL, 186711),
(186712, '3.40.50.300-FF-008251', NULL, 'Ribosomal protein L22p/L17e family protein', 52, NULL, NULL, 186712),
(186713, '3.40.50.720-FF-001261', NULL, 'Ergot alkaloid biosynthetic protein A', 165, NULL, NULL, 186713),
(186714, '3.40.630.30-FF-000389', NULL, 'Bifunctional protein argC, mitochondrial', 161, NULL, NULL, 186714),
(186715, '1.10.240.10-FF-000020', NULL, 'Uncharacterized protein', 50, NULL, NULL, 186715),
(186716, '2.40.50.100-FF-000185', NULL, 'Spermidine/putrescine ABC transporter ATP-binding', 89, NULL, NULL, 186716),
(186717, '3.30.9.10-FF-000038', NULL, 'N-methyl-L-tryptophan oxidase', 206, NULL, NULL, 186717),
(186718, '3.10.20.90-FF-000903', NULL, 'Uncharacterized protein', 78, NULL, NULL, 186718),
(186719, '3.30.499.10-FF-000006', NULL, '3-isopropylmalate dehydratase large subunit', 283, NULL, NULL, 186719),
(186720, '1.10.510.10-FF-000563', NULL, 'Mitogen-activated protein kinase', 132, NULL, NULL, 186720),
(186721, '3.40.50.300-FF-004125', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 258, NULL, NULL, 186721),
(186722, '3.30.230.130-FF-000053', NULL, 'Anaphase-promoting complex subunit 2', 154, NULL, NULL, 186722),
(186723, '1.10.8.60-FF-000555', NULL, 'Cell division control protein 48 homolog C', 80, NULL, NULL, 186723),
(186724, '1.10.10.10-FF-001738', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 115, NULL, NULL, 186724),
(186725, '3.30.1680.10-FF-000051', NULL, 'Integrin beta', 55, NULL, NULL, 186725),
(186726, '3.30.40.230-FF-000001', NULL, 'Glycine--tRNA ligase', 84, NULL, NULL, 186726),
(186727, '3.30.230.70-FF-000103', NULL, 'Exosome complex component RRP42', 283, NULL, NULL, 186727),
(186728, '2.130.10.10-FF-004254', NULL, 'Uncharacterized protein', 138, NULL, NULL, 186728),
(186729, '3.30.9.10-FF-000156', NULL, 'Uncharacterized protein', 133, NULL, NULL, 186729),
(186730, '3.30.160.60-FF-002590', NULL, NULL, 27, NULL, NULL, 186730),
(186731, '3.30.200.20-FF-001149', NULL, 'SAPK/ERK kinase', 92, NULL, NULL, 186731),
(186732, '3.40.50.261-FF-000005', NULL, 'Succinate--CoA ligase [ADP-forming] subunit alpha, mitochondrial', 177, NULL, NULL, 186732),
(186733, '3.30.497.10-FF-000024', NULL, 'Spn43Ac', 196, NULL, NULL, 186733),
(186734, '2.60.40.150-FF-000042', NULL, 'Copine 3', 133, NULL, NULL, 186734);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(186735, '3.40.47.10-FF-000041', NULL, 'Lipid-transfer protein', 395, NULL, NULL, 186735),
(186736, '3.20.20.140-FF-000388', NULL, 'Uncharacterized protein', 170, NULL, NULL, 186736),
(186737, '1.20.58.390-FF-000318', NULL, 'Uncharacterized protein', 74, NULL, NULL, 186737),
(186738, '3.30.9.90-FF-000005', NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase, putative', 203, NULL, NULL, 186738),
(186739, '1.50.10.10-FF-000129', NULL, 'Endoplasmic reticulum mannosyl-oligosaccharide 1,2-alpha-mannosidase', 491, NULL, NULL, 186739),
(186740, '3.90.1750.10-FF-000116', NULL, 'Uncharacterized protein', 187, NULL, NULL, 186740),
(186741, '3.10.450.10-FF-000011', NULL, 'Cysteine proteinase inhibitor', 99, NULL, NULL, 186741),
(186742, '1.10.10.1890-FF-000005', NULL, 'Predicted protein', 127, NULL, NULL, 186742),
(186743, '1.25.40.20-FF-001884', NULL, 'Poly [ADP-ribose] polymerase', 120, NULL, NULL, 186743),
(186744, '1.10.1140.10-FF-000005', NULL, 'ATP synthase subunit beta', 121, NULL, NULL, 186744),
(186745, '2.110.10.10-FF-000039', NULL, 'Uncharacterized protein', 202, NULL, NULL, 186745),
(186746, '3.60.21.10-FF-000363', NULL, 'Uncharacterized protein', 137, NULL, NULL, 186746),
(186747, '1.10.10.60-FF-000202', NULL, 'REST corepressor 2', 48, NULL, NULL, 186747),
(186748, '2.30.29.30-FF-001290', NULL, 'Wiskott-Aldrich syndrome', 89, NULL, NULL, 186748),
(186749, '3.40.50.300-FF-003737', NULL, 'DNA replication licensing factor MCM7', 345, NULL, NULL, 186749),
(186750, '3.30.160.60-FF-002601', NULL, NULL, 24, NULL, NULL, 186750),
(186751, '1.20.140.150-FF-000126', NULL, 'Uncharacterized protein', 74, NULL, NULL, 186751),
(186752, '3.30.160.60-FF-000448', NULL, 'RE1-silencing transcription factor A', 27, NULL, NULL, 186752),
(186753, '1.20.5.110-FF-000191', NULL, 'Syntaxin 16', 106, NULL, NULL, 186753),
(186754, '1.10.287.90-FF-000022', NULL, 'Cytochrome c oxidase subunit 2', 91, NULL, NULL, 186754),
(186755, '3.40.50.10800-FF-000005', NULL, 'Quinolinate synthase A', 113, NULL, NULL, 186755),
(186756, '3.40.50.300-FF-001000', NULL, 'Helicase and polymerase-containing protein TEBICHI', 198, NULL, NULL, 186756),
(186757, '3.30.160.60-FF-005827', NULL, NULL, 29, NULL, NULL, 186757),
(186758, '2.60.120.10-FF-000288', NULL, 'HSPB1-associated protein 1 isoform X4', 49, NULL, NULL, 186758),
(186759, '3.30.420.10-FF-000494', NULL, NULL, 234, NULL, NULL, 186759),
(186760, '3.10.450.10-FF-000073', NULL, 'Stefin A3-like 1', 74, NULL, NULL, 186760),
(186761, '3.90.550.10-FF-000635', NULL, 'Glycoside transferase family 2', 182, NULL, NULL, 186761),
(186762, '3.40.630.30-FF-000182', NULL, 'Putative acetyltransferase', 170, NULL, NULL, 186762),
(186763, '1.10.150.50-FF-000047', NULL, 'SEC23 interacting protein', 72, NULL, NULL, 186763),
(186764, '3.10.20.90-FF-000151', NULL, 'NEDD8 ultimate buster 1 isoform X1', 98, NULL, NULL, 186764),
(186765, '2.60.40.10-FF-004405', NULL, NULL, 103, NULL, NULL, 186765),
(186766, '1.25.40.10-FF-002561', NULL, 'Uncharacterized protein', 106, NULL, NULL, 186766),
(186767, '3.40.640.10-FF-000204', NULL, 'Putative aspartate aminotransferase', 246, NULL, NULL, 186767),
(186768, '3.30.530.20-FF-000033', NULL, 'S-norcoclaurine synthase', 156, NULL, NULL, 186768),
(186769, '3.50.50.60-FF-001378', NULL, 'Chromosome 10, whole genome shotgun sequence', 75, NULL, NULL, 186769),
(186770, '3.40.50.2300-FF-001329', NULL, NULL, 81, NULL, NULL, 186770),
(186771, '3.40.395.10-FF-000010', NULL, 'Sentrin-specific protease 1', 236, NULL, NULL, 186771),
(186772, '3.40.250.10-FF-000186', NULL, 'Rhodanese-like domain-containing protein', 145, NULL, NULL, 186772),
(186773, '4.10.860.120-FF-000027', NULL, 'DNA-directed RNA polymerase subunit', 128, NULL, NULL, 186773),
(186774, '1.10.3120.10-FF-000004', NULL, 'Chloroplast trigger factor', 208, NULL, NULL, 186774),
(186775, '1.10.1370.30-FF-000045', NULL, 'Angiotensin-converting enzyme', 139, NULL, NULL, 186775),
(186776, '3.80.10.10-FF-000764', NULL, 'Putative leucine-rich repeat receptor-like protein kinase', 96, NULL, NULL, 186776),
(186777, '1.10.555.10-FF-000127', NULL, 'Rho GTPase activating protein 39', 151, NULL, NULL, 186777);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(186778, '3.30.420.150-FF-000012', NULL, 'Golgi apyrase', 290, NULL, NULL, 186778),
(186779, '3.40.50.300-FF-002534', NULL, 'Putative RecF protein', 152, NULL, NULL, 186779),
(186780, '4.10.20.10-FF-000001', NULL, 'Protein Tat', 86, NULL, NULL, 186780),
(186781, '3.40.50.10810-FF-000008', NULL, 'Chromatin structure-remodeling complex subunit snf21', 263, NULL, NULL, 186781),
(186782, '2.60.40.10-FF-004714', NULL, NULL, 85, NULL, NULL, 186782),
(186783, '1.10.10.10-FF-001429', NULL, 'Diphtheria toxin repressor', 71, NULL, NULL, 186783),
(186784, '2.60.40.10-FF-000662', NULL, 'Tyrosine-protein kinase receptor UFO', 87, NULL, NULL, 186784),
(186785, '1.25.40.10-FF-004152', NULL, 'Pentatricopeptide repeat-containing protein At1g34160', 110, NULL, NULL, 186785),
(186786, '2.10.25.10-FF-000865', NULL, 'von Willebrand factor D and EGF domains', 68, NULL, NULL, 186786),
(186787, '2.60.120.330-FF-000116', NULL, 'Oxidoreductase, 2OG-Fe(II) oxygenase family, putative', 299, NULL, NULL, 186787),
(186788, '3.20.20.120-FF-000023', NULL, 'o-succinylbenzoate synthase', 230, NULL, NULL, 186788),
(186789, '2.40.170.20-FF-000006', NULL, 'Catecholate siderophore receptor fiu', 578, NULL, NULL, 186789),
(186790, '3.90.1170.10-FF-000021', NULL, '50S ribosomal protein L10e', 167, NULL, NULL, 186790),
(186791, '3.30.572.10-FF-000019', NULL, 'Bifunctional dihydrofolate reductase-thymidylate synthase 2', 79, NULL, NULL, 186791),
(186792, '1.10.730.10-FF-000091', NULL, 'Methionine--tRNA ligase', 163, NULL, NULL, 186792),
(186793, '3.40.50.300-FF-000073', NULL, 'Holliday junction ATP-dependent DNA helicase RuvB', 162, NULL, NULL, 186793),
(186794, '1.25.10.10-FF-000300', NULL, 'U-box domain-containing protein 4', 357, NULL, NULL, 186794),
(186795, '1.10.565.10-FF-000055', NULL, 'Nuclear hormone receptor family member nhr-31', 243, NULL, NULL, 186795),
(186796, '3.40.120.10-FF-000103', NULL, 'Phosphoacetylglucosamine mutase', 100, NULL, NULL, 186796),
(186797, '3.30.70.330-FF-000998', NULL, 'U4/U6 snRNP-associated protein', 117, NULL, NULL, 186797),
(186798, '1.10.150.80-FF-000005', NULL, 'Werner syndrome ATP-dependent helicase homolog', 89, NULL, NULL, 186798),
(186799, '1.10.150.530-FF-000014', NULL, 'Predicted Fe-S-cluster redox enzyme', 47, NULL, NULL, 186799),
(186800, '3.30.160.60-FF-000139', NULL, 'zinc finger protein 1 homolog', 28, NULL, NULL, 186800),
(186801, '3.40.120.10-FF-000092', NULL, 'Slr1334 protein', 170, NULL, NULL, 186801),
(186802, '1.25.40.20-FF-000911', NULL, 'Uncharacterized protein', 255, NULL, NULL, 186802),
(186803, '3.60.21.10-FF-000054', NULL, 'DCR2p Phosphoesterase', 308, NULL, NULL, 186803),
(186804, '2.30.40.10-FF-000169', NULL, 'Probable chlorohydrolase', 55, NULL, NULL, 186804),
(186805, '1.25.40.10-FF-001881', NULL, 'Uncharacterized protein', 252, NULL, NULL, 186805),
(186806, '2.40.170.10-FF-000003', NULL, 'Maltoporin 2', 393, NULL, NULL, 186806),
(186807, '3.40.50.300-FF-002843', NULL, 'Mitofusin 2', 228, NULL, NULL, 186807),
(186808, '3.40.50.300-FF-007778', NULL, 'Uncharacterized protein', 56, NULL, NULL, 186808),
(186809, '1.20.120.430-FF-000021', NULL, 'Predicted protein', 170, NULL, NULL, 186809),
(186810, '1.20.1070.10-FF-000874', NULL, 'Wnt-receptor frizzled protein variant 2', 378, NULL, NULL, 186810),
(186811, '3.30.930.10-FF-000386', NULL, 'Uncharacterized protein', 206, NULL, NULL, 186811),
(186812, '1.10.238.10-FF-000531', NULL, 'GM20994', 73, NULL, NULL, 186812),
(186813, '3.40.50.300-FF-000382', NULL, 'Lon protease homolog 2, peroxisomal', 178, NULL, NULL, 186813),
(186814, '1.10.287.550-FF-000014', NULL, 'Uncharacterized protein', 61, NULL, NULL, 186814),
(186815, '3.80.10.10-FF-001680', NULL, 'F-box domain protein (AFU_orthologue AFUA_2G02860)', 76, NULL, NULL, 186815),
(186816, '1.10.238.10-FF-000104', NULL, 'calumenin isoform X1', 184, NULL, NULL, 186816),
(186817, '3.30.70.3000-FF-000007', NULL, 'tRNA(His) guanylyltransferase 2 isoform A', 251, NULL, NULL, 186817),
(186818, '2.120.10.30-FF-000410', NULL, 'Uncharacterized protein', 189, NULL, NULL, 186818),
(186819, '2.60.40.10-FF-003787', NULL, NULL, 115, NULL, NULL, 186819);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(186820, '1.10.510.10-FF-001766', NULL, NULL, 45, NULL, NULL, 186820),
(186821, '1.25.70.10-FF-000040', NULL, 'Mitochondrial transcription termination factor family protein', 178, NULL, NULL, 186821),
(186822, '1.20.120.1750-FF-000160', NULL, 'RBR-type E3 ubiquitin transferase', 68, NULL, NULL, 186822),
(186823, '2.60.40.150-FF-000704', NULL, 'Uncharacterized protein', 145, NULL, NULL, 186823),
(186824, '1.20.210.10-FF-000010', NULL, 'Nitric oxide reductase subunit B', 467, NULL, NULL, 186824),
(186825, '2.130.10.10-FF-001758', NULL, 'Transcription factor TFIIIC complex subunit Tfc6, putative', 232, NULL, NULL, 186825),
(186826, '1.25.40.10-FF-002353', NULL, 'Uncharacterized protein', 181, NULL, NULL, 186826),
(186827, '3.40.50.1820-FF-001275', NULL, 'Uncharacterized protein', 299, NULL, NULL, 186827),
(186828, '1.10.630.10-FF-000757', NULL, 'Cytochrome P-450b (phenobarbital-inducible)', 25, NULL, NULL, 186828),
(186829, '3.30.40.20-FF-000001', NULL, 'ORF1a polyprotein', 50, NULL, NULL, 186829),
(186830, '3.40.50.1010-FF-000195', NULL, NULL, 110, NULL, NULL, 186830),
(186831, '3.40.50.1820-FF-001319', NULL, 'Uncharacterized protein', 259, NULL, NULL, 186831),
(186832, '1.10.167.10-FF-000006', NULL, 'G protein-coupled receptor kinase', 191, NULL, NULL, 186832),
(186833, '3.30.160.60-FF-000656', NULL, 'Zinc finger protein 541', 30, NULL, NULL, 186833),
(186834, '3.40.50.2300-FF-001582', NULL, NULL, 142, NULL, NULL, 186834),
(186835, '2.60.40.10-FF-002253', NULL, 'Ig heavy chain V region 36-60', 116, NULL, NULL, 186835),
(186836, '3.40.50.1000-FF-000192', NULL, 'CTD small phosphatase-like protein', 185, NULL, NULL, 186836),
(186837, '3.30.40.10-FF-001280', NULL, 'Uncharacterized protein', 65, NULL, NULL, 186837),
(186838, '3.90.550.10-FF-000118', NULL, 'Molybdenum cofactor guanylyltransferase', 194, NULL, NULL, 186838),
(186839, '1.10.472.10-FF-000119', NULL, 'Cyclin', 223, NULL, NULL, 186839),
(186840, '2.170.270.10-FF-000154', NULL, 'Histone-lysine N-methyltransferase', 162, NULL, NULL, 186840),
(186841, '3.30.1490.20-FF-000028', NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', 63, NULL, NULL, 186841),
(186842, '1.10.533.10-FF-000245', NULL, 'Uncharacterized protein', 44, NULL, NULL, 186842),
(186843, '1.25.40.20-FF-000810', NULL, 'Ankyrin repeat-containing protein', 158, NULL, NULL, 186843),
(186844, '1.25.40.20-FF-000456', NULL, 'Ankyrin repeat and SOCS box protein 14', 56, NULL, NULL, 186844),
(186845, '3.90.470.20-FF-000019', NULL, 'L-aminoadipate-semialdehyde dehydrogenase-phosphopantetheinyl transferase', 88, NULL, NULL, 186845),
(186846, '4.10.75.10-FF-000009', NULL, 'GD21069', 49, NULL, NULL, 186846),
(186847, '3.30.360.10-FF-000005', NULL, 'Homoserine dehydrogenase', 170, NULL, NULL, 186847),
(186848, '2.130.10.10-FF-000005', NULL, 'Putative echinoderm microtubule-associated protein-like 1', 281, NULL, NULL, 186848),
(186849, '1.25.40.60-FF-000002', NULL, 'Sec1 family domain containing 1', 109, NULL, NULL, 186849),
(186850, '3.30.565.10-FF-000424', NULL, 'Sensory transduction histidine kinase', 149, NULL, NULL, 186850),
(186851, '1.20.120.350-FF-000087', NULL, 'Uncharacterized protein', 133, NULL, NULL, 186851),
(186852, '1.10.287.470-FF-000097', NULL, 'Gll2840 protein', 29, NULL, NULL, 186852),
(186853, '3.90.740.10-FF-000009', NULL, 'Isoleucyl-tRNA synthetase 2, mitochondrial', 211, NULL, NULL, 186853),
(186854, '3.40.50.300-FF-004861', NULL, 'MutS domain III family protein', 264, NULL, NULL, 186854),
(186855, '3.20.20.220-FF-000053', NULL, 'Putative proline dehydrogenase (Monofunctional)', 240, NULL, NULL, 186855),
(186856, '3.40.30.10-FF-000385', NULL, 'NADH:ubiquinone oxidoreductase subunit A2', 77, NULL, NULL, 186856),
(186857, '3.10.110.10-FF-000070', NULL, 'RWD domain containing 3', 113, NULL, NULL, 186857),
(186858, '3.30.450.190-FF-000013', NULL, 'RAs-related GTP-binding protein A', 122, NULL, NULL, 186858),
(186859, '3.10.250.10-FF-000092', NULL, NULL, 107, NULL, NULL, 186859),
(186860, '3.40.50.200-FF-000144', NULL, 'Uncharacterized protein', 63, NULL, NULL, 186860);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(186861, '3.40.50.200-FF-000043', NULL, 'Peptidase S8', 330, NULL, NULL, 186861),
(186862, '2.10.220.10-FF-000037', NULL, 'Proprotein convertase subtilisin/kexin type 5', 95, NULL, NULL, 186862),
(186863, '1.10.760.10-FF-000031', NULL, 'Di-heme cytochrome C peroxidase', 142, NULL, NULL, 186863),
(186864, '2.60.40.10-FF-005479', NULL, NULL, 194, NULL, NULL, 186864),
(186865, '4.10.410.10-FF-000027', NULL, 'Si:dkeyp-73b11.8', 67, NULL, NULL, 186865),
(186866, '3.60.21.10-FF-000464', NULL, 'Uncharacterized protein', 134, NULL, NULL, 186866),
(186867, '1.20.1250.20-FF-001554', NULL, 'Uncharacterized protein', 532, NULL, NULL, 186867),
(186868, '3.30.230.10-FF-000001', NULL, '30S ribosomal protein S9', 131, NULL, NULL, 186868),
(186869, '2.60.40.10-FF-005833', NULL, NULL, 112, NULL, NULL, 186869),
(186870, '2.40.10.10-FF-000144', NULL, 'AGAP011783-PA', 113, NULL, NULL, 186870),
(186871, '3.40.50.300-FF-008604', NULL, 'Transitional endoplasmic reticulum ATPase, putative', 174, NULL, NULL, 186871),
(186872, '3.40.630.150-FF-000029', NULL, 'Malonyl-CoA decarboxylase', 230, NULL, NULL, 186872),
(186873, '2.60.120.700-FF-000002', NULL, 'Uncharacterized protein', 203, NULL, NULL, 186873),
(186874, '3.40.50.1100-FF-000025', NULL, 'Tryptophan synthase beta chain', 216, NULL, NULL, 186874),
(186875, '1.10.10.10-FF-001839', NULL, 'Uncharacterized protein', 87, NULL, NULL, 186875),
(186876, '2.10.25.10-FF-001028', NULL, 'Drosophila CRumBs homolog', 46, NULL, NULL, 186876),
(186877, '2.60.120.1000-FF-000025', NULL, 'Predicted protein', 218, NULL, NULL, 186877),
(186878, '3.40.50.1460-FF-000099', NULL, 'Caspase 1b', 167, NULL, NULL, 186878),
(186879, '3.50.50.60-FF-000052', NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase, mitochondrial', 247, NULL, NULL, 186879),
(186880, '1.10.540.10-FF-000048', NULL, 'Acyl-CoA dehydrogenase FadE18', 116, NULL, NULL, 186880),
(186881, '3.30.300.10-FF-000029', NULL, 'S-adenosylmethionine synthetase', 136, NULL, NULL, 186881),
(186882, '2.60.40.10-FF-005378', NULL, NULL, 59, NULL, NULL, 186882),
(186883, '1.20.1070.10-FF-001700', NULL, 'Uncharacterized protein', 108, NULL, NULL, 186883),
(186884, '2.30.30.380-FF-000071', NULL, 'Uncharacterized protein', 60, NULL, NULL, 186884),
(186885, '2.60.120.10-FF-000642', NULL, 'Jumonji domain-containing 7', 168, NULL, NULL, 186885),
(186886, '3.40.50.2020-FF-000076', NULL, 'Phosphoribosylpyrophosphate synthetase', 144, NULL, NULL, 186886),
(186887, '3.40.50.300-FF-008133', NULL, 'Uncharacterized protein', 104, NULL, NULL, 186887),
(186888, '2.30.180.10-FF-000113', NULL, NULL, 126, NULL, NULL, 186888),
(186889, '3.90.550.10-FF-000220', NULL, 'Hexosyltransferase', 264, NULL, NULL, 186889),
(186890, '1.20.5.340-FF-000130', NULL, 'ATP-dependent RNA helicase DHH1, putative', 118, NULL, NULL, 186890),
(186891, '1.20.810.10-FF-000022', NULL, 'Cytochrome b', 170, NULL, NULL, 186891),
(186892, '3.90.70.10-FF-000071', NULL, 'ubiquitin carboxyl-terminal hydrolase 30 isoform X1', 371, NULL, NULL, 186892),
(186893, '3.90.550.50-FF-000170', NULL, 'Glycoprotein-N-acetylgalactosamine 3-beta-galactosyltransferase 1-B-like Protein', 221, NULL, NULL, 186893),
(186894, '3.30.1490.150-FF-000002', NULL, 'YOR289W-like protein', 73, NULL, NULL, 186894),
(186895, '3.40.532.10-FF-000037', NULL, NULL, 233, NULL, NULL, 186895),
(186896, '3.30.200.20-FF-001492', NULL, 'Protein kinase, putative (AFU_orthologue AFUA_6G09240)', 54, NULL, NULL, 186896),
(186897, '2.40.30.10-FF-000252', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 134, NULL, NULL, 186897),
(186898, '3.30.160.60-FF-000241', NULL, 'Wilms tumor 1-KTS isoform', 28, NULL, NULL, 186898),
(186899, '1.10.472.130-FF-000024', NULL, 'Putative dynein heavy chain', 156, NULL, NULL, 186899),
(186900, '2.60.40.1120-FF-000066', NULL, 'Uncharacterized protein', 81, NULL, NULL, 186900),
(186901, '2.40.70.10-FF-000120', NULL, 'Aspartic proteinase nepenthesin-2', 203, NULL, NULL, 186901),
(186902, '3.40.50.720-FF-001570', NULL, 'Uncharacterized protein', 243, NULL, NULL, 186902);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(186903, '3.30.70.3400-FF-000004', NULL, 'Multifunctional fusion protein', 84, NULL, NULL, 186903),
(186904, '3.30.310.10-FF-000047', NULL, 'TATA-box-binding protein C', 90, NULL, NULL, 186904),
(186905, '2.30.180.10-FF-000023', NULL, 'periostin isoform X2', 137, NULL, NULL, 186905),
(186906, '3.30.70.330-FF-000897', NULL, 'Scaffold attachment factor B2', 155, NULL, NULL, 186906),
(186907, '1.50.40.10-FF-000266', NULL, 'Putative ADP,ATP carrier protein', 110, NULL, NULL, 186907),
(186908, '1.25.10.10-FF-002525', NULL, 'Uncharacterized protein', 190, NULL, NULL, 186908),
(186909, '3.90.550.10-FF-000074', NULL, 'N-acylneuraminate cytidylyltransferase A', 227, NULL, NULL, 186909),
(186910, '3.30.200.20-FF-000064', NULL, 'Receptor protein serine/threonine kinase', 116, NULL, NULL, 186910),
(186911, '3.30.565.10-FF-000172', NULL, 'Histidine kinase', 144, NULL, NULL, 186911),
(186912, '3.30.160.60-FF-002702', NULL, 'Zinc finger protein 668', 31, NULL, NULL, 186912),
(186913, '1.20.1310.10-FF-000207', NULL, NULL, 117, NULL, NULL, 186913),
(186914, '3.30.450.20-FF-000695', NULL, 'Chemotaxis signal transduction system methyl accepting sensory transducer', 197, NULL, NULL, 186914),
(186915, '1.25.40.540-FF-000023', NULL, 'Chromosome 21, whole genome shotgun sequence', 230, NULL, NULL, 186915),
(186916, '3.40.30.10-FF-000637', NULL, 'Thioredoxin', 76, NULL, NULL, 186916),
(186917, '3.40.50.1820-FF-001421', NULL, 'Autocrine proliferation repressor protein A', 199, NULL, NULL, 186917),
(186918, '3.40.50.1820-FF-001730', NULL, 'Uncharacterized protein', 94, NULL, NULL, 186918),
(186919, '3.30.1370.140-FF-000001', NULL, 'Putative hydrogenase expression/formation protein', 98, NULL, NULL, 186919),
(186920, '1.10.1760.10-FF-000007', NULL, 'Actin-related protein 2/3 complex subunit 3', 191, NULL, NULL, 186920),
(186921, '3.30.70.100-FF-000148', NULL, NULL, 107, NULL, NULL, 186921),
(186922, '1.20.5.2440-FF-000016', NULL, 'Uncharacterized protein', 66, NULL, NULL, 186922),
(186923, '3.50.30.30-FF-000093', NULL, 'YALI0D09735p', 106, NULL, NULL, 186923),
(186924, '2.60.40.1180-FF-000168', NULL, 'Alpha-mannosidase', 115, NULL, NULL, 186924),
(186925, '1.25.10.10-FF-001598', NULL, 'Uncharacterized protein', 755, NULL, NULL, 186925),
(186926, '3.40.50.2000-FF-000992', NULL, 'Uncharacterized protein', 49, NULL, NULL, 186926),
(186927, '3.40.50.1000-FF-000293', NULL, 'Aminophospholipid transporter, putative', 157, NULL, NULL, 186927),
(186928, '3.90.70.10-FF-000323', NULL, 'Calpain family cysteine protease-like protein', 147, NULL, NULL, 186928),
(186929, '2.120.10.30-FF-000056', NULL, 'Low-density lipoprotein receptor-related protein 2', 323, NULL, NULL, 186929),
(186930, '2.30.29.30-FF-001109', NULL, 'Predicted protein', 204, NULL, NULL, 186930),
(186931, '3.10.660.10-FF-000010', NULL, 'Diphthamide biosynthesis protein 4', 67, NULL, NULL, 186931),
(186932, '1.10.1600.10-FF-000024', NULL, 'X-ray repair cross-complementing protein 5', 94, NULL, NULL, 186932),
(186933, '3.30.160.60-FF-003984', NULL, NULL, 27, NULL, NULL, 186933),
(186934, '1.25.40.10-FF-001847', NULL, 'Transcriptional regulator', 230, NULL, NULL, 186934),
(186935, '3.90.226.10-FF-000146', NULL, 'Carboxy-terminal processing protease', 152, NULL, NULL, 186935),
(186936, '2.120.10.30-FF-000202', NULL, 'Uncharacterized protein', 117, NULL, NULL, 186936),
(186937, '2.60.40.10-FF-003579', NULL, NULL, 89, NULL, NULL, 186937),
(186938, '3.40.50.300-FF-002091', NULL, 'Dynein-related AAA-type ATPase', 115, NULL, NULL, 186938),
(186939, '2.170.190.11-FF-000008', NULL, 'Molybdopterin molybdenumtransferase', 91, NULL, NULL, 186939),
(186940, '2.10.25.10-FF-001270', NULL, 'Receptor tyrosine kinase', 39, NULL, NULL, 186940),
(186941, '2.30.30.140-FF-000347', NULL, 'Histone acetyltransferase', 32, NULL, NULL, 186941),
(186942, '3.40.50.300-FF-007986', NULL, 'Uncharacterized protein', 157, NULL, NULL, 186942),
(186943, '1.25.40.10-FF-004253', NULL, 'Uncharacterized protein', 231, NULL, NULL, 186943),
(186944, '1.25.10.10-FF-000373', NULL, 'Importin beta-5 subunit, putative', 991, NULL, NULL, 186944);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(186945, '2.90.20.10-FF-000002', NULL, 'Uncharacterized protein', 106, NULL, NULL, 186945),
(186946, '1.20.5.4820-FF-000005', NULL, 'Myosin IIIB', 101, NULL, NULL, 186946),
(186947, '3.40.50.300-FF-002181', NULL, 'ATP-dependent RNA helicase DBP9, putative', 264, NULL, NULL, 186947),
(186948, '3.30.70.240-FF-000033', NULL, 'Elongation factor Tu GTP binding domain containing 2', 88, NULL, NULL, 186948),
(186949, '2.60.40.60-FF-000098', NULL, 'cadherin-23 isoform X1', 115, NULL, NULL, 186949),
(186950, '2.60.40.10-FF-001781', NULL, 'Uncharacterized protein, isoform C', 97, NULL, NULL, 186950),
(186951, '3.30.420.40-FF-000154', NULL, 'Fructokinase', 172, NULL, NULL, 186951),
(186952, '2.60.40.640-FF-000082', NULL, 'Vacuolar sorting protein 26 putative', 148, NULL, NULL, 186952),
(186953, '3.10.120.10-FF-000008', NULL, 'Nitrate reductase', 82, NULL, NULL, 186953),
(186954, '2.30.29.30-FF-000946', NULL, 'General transcription factor IIH subunit 1', 107, NULL, NULL, 186954),
(186955, '3.10.25.10-FF-000020', NULL, 'Aldehyde dehydrogenase 1 family, member L2', 66, NULL, NULL, 186955),
(186956, '3.30.1360.10-FF-000021', NULL, 'DNA-directed RNA polymerase II subunit RPB3', 126, NULL, NULL, 186956),
(186957, '1.10.510.10-FF-002581', NULL, NULL, 230, NULL, NULL, 186957),
(186958, '3.30.70.890-FF-000025', NULL, 'Mevalonate kinase', 138, NULL, NULL, 186958),
(186959, '3.30.160.60-FF-006401', NULL, NULL, 31, NULL, NULL, 186959),
(186960, '2.60.200.10-FF-000030', NULL, 'Interferon regulatory factor 3', 66, NULL, NULL, 186960),
(186961, '1.10.560.10-FF-000066', NULL, 'Uncharacterized protein', 235, NULL, NULL, 186961),
(186962, '2.130.10.10-FF-001848', NULL, 'UTP13p Nucleolar protein', 206, NULL, NULL, 186962),
(186963, '2.30.42.10-FF-000201', NULL, 'delphilin isoform X1', 84, NULL, NULL, 186963),
(186964, '3.40.50.150-FF-000522', NULL, 'Glycine/sarcosine N-methyltransferase', 168, NULL, NULL, 186964),
(186965, '3.30.160.60-FF-000802', NULL, 'CCCTC-binding factor like', 31, NULL, NULL, 186965),
(186966, '3.30.160.60-FF-004708', NULL, NULL, 35, NULL, NULL, 186966),
(186967, '3.30.450.40-FF-000234', NULL, 'Sensor domain-containing diguanylate cyclase', 90, NULL, NULL, 186967),
(186968, '3.90.1480.20-FF-000025', NULL, 'Uncharacterized protein', 218, NULL, NULL, 186968),
(186969, '3.40.50.2300-FF-001672', NULL, NULL, 146, NULL, NULL, 186969),
(186970, '3.40.50.10810-FF-000211', NULL, 'SWI/SNF chromatin remodeling complex component', 105, NULL, NULL, 186970),
(186971, '1.25.40.10-FF-003680', NULL, 'Pentatricopeptide repeat-containing protein At3g57430, chloroplastic', 105, NULL, NULL, 186971),
(186972, '3.30.540.30-FF-000008', NULL, 'Dipeptidyl peptidase 3', 126, NULL, NULL, 186972),
(186973, '1.10.510.10-FF-004262', NULL, NULL, 188, NULL, NULL, 186973),
(186974, '3.40.1160.10-FF-000088', NULL, 'Aspartokinase', 188, NULL, NULL, 186974),
(186975, '3.30.160.650-FF-000001', NULL, 'Alkylglycerone-phosphate synthase', 44, NULL, NULL, 186975),
(186976, '3.30.70.330-FF-001515', NULL, 'YHR086Wp-like protein', 112, NULL, NULL, 186976),
(186977, '2.70.170.10-FF-000215', NULL, 'Uncharacterized protein', 133, NULL, NULL, 186977),
(186978, '3.40.50.300-FF-006143', NULL, 'Cdc42 homolog-like Protein', 183, NULL, NULL, 186978),
(186979, '2.10.70.10-FF-000054', NULL, 'Complement inhibitory factor H', 65, NULL, NULL, 186979),
(186980, '1.20.1530.20-FF-000081', NULL, 'Predicted protein', 335, NULL, NULL, 186980),
(186981, '3.90.1420.10-FF-000046', NULL, 'Uncharacterized protein', 130, NULL, NULL, 186981),
(186982, '3.30.40.10-FF-001841', NULL, 'Predicted protein', 85, NULL, NULL, 186982),
(186983, '3.80.10.10-FF-001028', NULL, 'Putative leucine-rich repeat receptor-like serine/threonine-protein kinase', 395, NULL, NULL, 186983),
(186984, '2.60.40.60-FF-000452', NULL, 'Cadherin-89D', 124, NULL, NULL, 186984),
(186985, '2.60.40.60-FF-000761', NULL, 'Predicted protein', 106, NULL, NULL, 186985),
(186986, '1.25.10.10-FF-002216', NULL, 'Predicted protein', 414, NULL, NULL, 186986),
(186987, '1.20.1250.20-FF-001700', NULL, 'Protein CBG12921', 155, NULL, NULL, 186987);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(186988, '3.30.540.10-FF-000002', NULL, 'Fructose-1,6-bisphosphatase class 1', 194, NULL, NULL, 186988),
(186989, '3.30.2140.20-FF-000025', NULL, 'Arylamine N-acetyltransferase 4', 138, NULL, NULL, 186989),
(186990, '3.90.1150.220-FF-000003', NULL, 'Putative DNA repair protein Nse1', 97, NULL, NULL, 186990),
(186991, '3.30.70.330-FF-002797', NULL, NULL, 96, NULL, NULL, 186991),
(186992, '1.10.3380.10-FF-000046', NULL, 'Type III restriction enzyme, res subunit family protein', 133, NULL, NULL, 186992),
(186993, '3.20.20.370-FF-000002', NULL, 'Probable 4-deoxy-4-formamido-L-arabinose-phosphoundecaprenol deformylase ArnD', 227, NULL, NULL, 186993),
(186994, '2.10.25.10-FF-000764', NULL, 'Uncharacterized protein', 61, NULL, NULL, 186994),
(186995, '3.30.830.10-FF-000103', NULL, 'Metalloprotease, putative', 214, NULL, NULL, 186995),
(186996, '1.10.3720.10-FF-000207', NULL, 'Molybdenum transport system permease', 217, NULL, NULL, 186996),
(186997, '1.10.1040.10-FF-000088', NULL, 'Ketopantoate reductase PanE/ApbA-domain-containing protein', 139, NULL, NULL, 186997),
(186998, '4.10.640.10-FF-000027', NULL, '30S ribosomal protein S18', 80, NULL, NULL, 186998),
(186999, '3.40.50.150-FF-000213', NULL, 'Methyltransferases,nucleic acid binding', 195, NULL, NULL, 186999),
(187000, '3.50.4.10-FF-000050', NULL, NULL, 73, NULL, NULL, 187000),
(187001, '1.20.1280.50-FF-000109', NULL, 'F-box protein family-like', 44, NULL, NULL, 187001),
(187002, '2.20.25.10-FF-000106', NULL, '2-oxo-1,2-dihydroquinoline 8-monooxygenase, oxygenase component', 83, NULL, NULL, 187002),
(187003, '3.40.50.1240-FF-000016', NULL, 'Ubiquitin-associated and SH3 domain-containing protein A', 265, NULL, NULL, 187003),
(187004, '3.80.10.10-FF-003170', NULL, 'Protein pof5', 269, NULL, NULL, 187004),
(187005, '3.40.1190.10-FF-000028', NULL, 'GD22722', 267, NULL, NULL, 187005),
(187006, '2.60.40.10-FF-001988', NULL, 'Juxtamembrane domain-associated catenin', 110, NULL, NULL, 187006),
(187007, '1.10.287.940-FF-000024', NULL, 'Uncharacterized protein', 20, NULL, NULL, 187007),
(187008, '2.130.10.10-FF-003439', NULL, 'Uncharacterized protein', 149, NULL, NULL, 187008),
(187009, '2.60.40.150-FF-000143', NULL, 'Type II inositol 3,4-bisphosphate 4-phosphatase', 143, NULL, NULL, 187009),
(187010, '2.40.10.10-FF-000453', NULL, NULL, 98, NULL, NULL, 187010),
(187011, '3.40.50.12790-FF-000001', NULL, 'Flagellar biosynthesis protein FlhA', 94, NULL, NULL, 187011),
(187012, '1.10.150.130-FF-000001', NULL, 'Tyrosine recombinase XerC', 95, NULL, NULL, 187012),
(187013, '1.25.40.10-FF-003438', NULL, 'Tetratricopeptide repeat domain 21B', 186, NULL, NULL, 187013),
(187014, '3.40.50.800-FF-000127', NULL, 'Histidine--tRNA ligase', 101, NULL, NULL, 187014),
(187015, '3.20.20.70-FF-000307', NULL, 'Alpha-galactosidase', 315, NULL, NULL, 187015),
(187016, '3.30.160.60-FF-004147', NULL, NULL, 26, NULL, NULL, 187016),
(187017, '3.40.50.1220-FF-000010', NULL, '2-succinyl-5-enolpyruvyl-6-hydroxy-3-cyclohexene-1-carboxylate synthase', 126, NULL, NULL, 187017),
(187018, '1.10.287.950-FF-000027', NULL, 'Methyl-accepting chemotaxis protein', 329, NULL, NULL, 187018),
(187019, '2.40.50.140-FF-001265', NULL, NULL, 30, NULL, NULL, 187019),
(187020, '2.60.120.290-FF-000177', NULL, 'mannan-binding lectin serine protease 1-like', 114, NULL, NULL, 187020),
(187021, '3.40.390.10-FF-000111', NULL, 'Metalloendopeptidase', 95, NULL, NULL, 187021),
(187022, '1.10.30.10-FF-000104', NULL, 'Transcription factor SOX-2', 44, NULL, NULL, 187022),
(187023, '1.20.58.480-FF-000003', NULL, 'Indoleamine 2,3-dioxygenase 1', 268, NULL, NULL, 187023),
(187024, '4.10.400.10-FF-000156', NULL, 'basement membrane-specific heparan sulfate proteoglycan core protein isoform X4', 36, NULL, NULL, 187024),
(187025, '3.40.800.10-FF-000003', NULL, 'Agmatinase', 317, NULL, NULL, 187025),
(187026, '3.20.20.140-FF-000282', NULL, 'Metal-dependent hydrolase superfamily protein', 323, NULL, NULL, 187026),
(187027, '1.10.3210.10-FF-000034', NULL, 'HD domain containing protein, putative', 306, NULL, NULL, 187027);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(187028, '3.40.50.300-FF-006233', NULL, 'AGAP010699-PA', 264, NULL, NULL, 187028),
(187029, '3.40.50.11380-FF-000005', NULL, 'Probable UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SPINDLY', 177, NULL, NULL, 187029),
(187030, '2.130.10.10-FF-003748', NULL, 'Uncharacterized WD repeat-containing protein C1773.01', 330, NULL, NULL, 187030),
(187031, '1.10.3450.20-FF-000010', NULL, 'Nuclear pore complex protein', 159, NULL, NULL, 187031),
(187032, '2.60.40.10-FF-003990', NULL, NULL, 101, NULL, NULL, 187032),
(187033, '1.20.140.150-FF-000025', NULL, 'germ cell-specific gene 1-like protein', 97, NULL, NULL, 187033),
(187034, '1.10.460.10-FF-000002', NULL, 'DNA topoisomerase', 161, NULL, NULL, 187034),
(187035, '3.40.800.20-FF-000006', NULL, 'Histone deacetylase 8', 373, NULL, NULL, 187035),
(187036, '1.10.10.60-FF-000303', NULL, 'MYB transcription factor', 77, NULL, NULL, 187036),
(187037, '2.60.200.40-FF-000039', NULL, 'Uncharacterized protein', 162, NULL, NULL, 187037),
(187038, '2.60.200.20-FF-000033', NULL, 'proliferation marker protein Ki-67', 100, NULL, NULL, 187038),
(187039, '3.30.1330.60-FF-000040', NULL, 'OmpA family protein', 141, NULL, NULL, 187039),
(187040, '1.20.1270.280-FF-000027', NULL, 'Dynein heavy chain', 197, NULL, NULL, 187040),
(187041, '3.30.559.70-FF-000006', NULL, 'Peroxisomal carnitine O-octanoyltransferase', 316, NULL, NULL, 187041),
(187042, '2.130.10.10-FF-000314', NULL, 'mitogen-activated protein kinase-binding protein 1 isoform X1', 153, NULL, NULL, 187042),
(187043, '3.40.50.670-FF-000003', NULL, 'DNA topoisomerase 4 subunit B', 234, NULL, NULL, 187043),
(187044, '2.60.20.10-FF-000026', NULL, NULL, 46, NULL, NULL, 187044),
(187045, '3.40.50.11370-FF-000002', NULL, 'Inositol-tetrakisphosphate 1-kinase', 111, NULL, NULL, 187045),
(187046, '2.40.70.10-FF-000018', NULL, 'Aspartic proteinase-like protein 2', 180, NULL, NULL, 187046),
(187047, '1.10.510.10-FF-004172', NULL, NULL, 158, NULL, NULL, 187047),
(187048, '2.40.20.10-FF-000072', NULL, 'Uncharacterized protein', 115, NULL, NULL, 187048),
(187049, '3.80.10.10-FF-001118', NULL, 'Leucine rich repeat and phosphatase domain containing protein', 178, NULL, NULL, 187049),
(187050, '3.30.200.20-FF-001913', NULL, 'Ribosomal protein S6 kinase', 90, NULL, NULL, 187050),
(187051, '1.25.40.20-FF-000765', NULL, 'Ankyrin repeat domain 9', 165, NULL, NULL, 187051),
(187052, '3.30.60.30-FF-000112', NULL, 'Predicted protein', 71, NULL, NULL, 187052),
(187053, '2.60.200.30-FF-000036', NULL, 'ATP-NAD kinase family protein', 142, NULL, NULL, 187053),
(187054, '3.40.50.300-FF-004081', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 100, NULL, NULL, 187054),
(187055, '3.40.50.300-FF-001938', NULL, 'Uncharacterized protein', 199, NULL, NULL, 187055),
(187056, '1.25.50.20-FF-000075', NULL, 'Aminopeptidase', 252, NULL, NULL, 187056),
(187057, '1.20.1250.20-FF-001138', NULL, 'Uncharacterized protein', 329, NULL, NULL, 187057),
(187058, '2.110.10.10-FF-000040', NULL, 'Matrix metalloproteinase-A', 196, NULL, NULL, 187058),
(187059, '1.10.10.2660-FF-000028', NULL, 'ThiF family protein', 117, NULL, NULL, 187059),
(187060, '3.40.33.10-FF-000009', NULL, 'Pathogenesis-related protein 1', 144, NULL, NULL, 187060),
(187061, '3.40.50.300-FF-004209', NULL, 'RAP1A, member of RAS oncogene family', 75, NULL, NULL, 187061),
(187062, '2.60.40.180-FF-000011', NULL, 'Probable 5-hydroxyisourate hydrolase R09H10.3', 117, NULL, NULL, 187062),
(187063, '2.40.30.10-FF-000027', NULL, 'Sulfate adenylyltransferase subunit 1', 90, NULL, NULL, 187063),
(187064, '3.30.1050.10-FF-000003', NULL, 'stomatin-like protein 1 isoform X2', 108, NULL, NULL, 187064),
(187065, '1.25.40.20-FF-000350', NULL, 'Death associated protein kinase 1', 117, NULL, NULL, 187065),
(187066, '3.10.100.10-FF-000215', NULL, 'Mannose receptor, C type 1b', 144, NULL, NULL, 187066),
(187067, '1.10.510.40-FF-000004', NULL, 'Aerobactin synthase IucA', 198, NULL, NULL, 187067),
(187068, '1.10.3430.10-FF-000005', NULL, 'Ammonium transporter', 446, NULL, NULL, 187068);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(187069, '2.40.50.690-FF-000007', NULL, 'DIS3-like exonuclease 2', 105, NULL, NULL, 187069),
(187070, '2.30.30.40-FF-000183', NULL, 'Epidermal growth factor receptor kinase substrate 8', 63, NULL, NULL, 187070),
(187071, '3.80.10.10-FF-003271', NULL, 'AGAP010669-PA', 270, NULL, NULL, 187071),
(187072, '3.40.350.10-FF-000002', NULL, 'Xaa-Pro dipeptidase', 159, NULL, NULL, 187072),
(187073, '3.40.50.300-FF-007880', NULL, 'Uncharacterized protein', 200, NULL, NULL, 187073),
(187074, '3.20.20.10-FF-000059', NULL, 'Antizyme inhibitor 1a', 112, NULL, NULL, 187074),
(187075, '2.130.10.10-FF-005917', NULL, 'Uncharacterized protein', 276, NULL, NULL, 187075),
(187076, '3.30.1490.180-FF-000028', NULL, 'DNA-directed RNA polymerase I subunit rpa1', 73, NULL, NULL, 187076),
(187077, '1.10.3500.10-FF-000034', NULL, 'Transcription elongation factor spt6', 121, NULL, NULL, 187077),
(187078, '2.60.220.10-FF-000003', NULL, 'Blood-group-substance endo-1,4-beta-galactosidase', 118, NULL, NULL, 187078),
(187079, '3.10.20.90-FF-000813', NULL, 'Predicted protein', 100, NULL, NULL, 187079),
(187080, '1.10.10.580-FF-000016', NULL, 'Uncharacterized protein', 98, NULL, NULL, 187080),
(187081, '3.40.50.300-FF-006250', NULL, 'SNF2 family DNA-dependent ATPase', 189, NULL, NULL, 187081),
(187082, '2.60.40.10-FF-000471', NULL, 'Tripartite motif-containing 46, isoform CRA_c', 106, NULL, NULL, 187082),
(187083, '3.90.550.10-FF-000192', NULL, 'Polypeptide N-acetylgalactosaminyltransferase 9', 102, NULL, NULL, 187083),
(187084, '1.20.120.980-FF-000040', NULL, 'Uncharacterized protein', 94, NULL, NULL, 187084),
(187085, '1.10.8.270-FF-000190', NULL, 'Uncharacterized protein', 207, NULL, NULL, 187085),
(187086, '3.30.1370.100-FF-000039', NULL, 'DNA mismatch repair protein MutL', 91, NULL, NULL, 187086),
(187087, '2.40.10.10-FF-000560', NULL, NULL, 71, NULL, NULL, 187087),
(187088, '3.90.226.10-FF-000040', NULL, 'Ethylmalonyl-CoA decarboxylase 1', 253, NULL, NULL, 187088),
(187089, '3.40.50.10470-FF-000069', NULL, 'Initiation factor 2B related', 185, NULL, NULL, 187089),
(187090, '2.102.10.10-FF-000029', NULL, 'Protochlorophyllide-dependent translocon component 52, chloroplastic', 143, NULL, NULL, 187090),
(187091, '3.30.200.20-FF-001722', NULL, 'Uncharacterized protein', 112, NULL, NULL, 187091),
(187092, '1.10.1410.10-FF-000094', NULL, 'Nucleolar protein 6', 54, NULL, NULL, 187092),
(187093, '1.10.10.60-FF-000112', NULL, 'TyrR family transcriptional regulator', 60, NULL, NULL, 187093),
(187094, '2.30.34.10-FF-000003', NULL, 'Major surface protease gp63, putative', 94, NULL, NULL, 187094),
(187095, '3.40.1000.50-FF-000021', NULL, 'Repressor of RNA polymerase III transcription MAF1', 141, NULL, NULL, 187095),
(187096, '3.40.1090.10-FF-000060', NULL, 'Lysophospholipase NTE1', 96, NULL, NULL, 187096),
(187097, '2.60.120.10-FF-000434', NULL, 'Fumarate and nitrate reduction regulatory protein', 117, NULL, NULL, 187097),
(187098, '2.70.150.10-FF-000068', NULL, 'Copper resistance-associated P-type ATPase', 126, NULL, NULL, 187098),
(187099, '2.130.10.10-FF-000123', NULL, 'Semaphorin 3C', 492, NULL, NULL, 187099),
(187100, '1.20.1070.10-FF-000857', NULL, 'Uncharacterized protein', 136, NULL, NULL, 187100),
(187101, '1.20.5.110-FF-000275', NULL, 'TNF receptor-associated factor 1', 42, NULL, NULL, 187101),
(187102, '1.25.40.10-FF-001965', NULL, 'Uncharacterized protein', 155, NULL, NULL, 187102),
(187103, '1.25.10.10-FF-001935', NULL, 'Uncharacterized protein', 428, NULL, NULL, 187103),
(187104, '3.30.70.330-FF-003078', NULL, NULL, 96, NULL, NULL, 187104),
(187105, '3.90.1600.10-FF-000004', NULL, 'DNA polymerase', 100, NULL, NULL, 187105),
(187106, '3.30.160.60-FF-004282', NULL, NULL, 40, NULL, NULL, 187106),
(187107, '3.30.1120.10-FF-000032', NULL, 'Uncharacterized protein, isoform B', 100, NULL, NULL, 187107),
(187108, '1.10.510.10-FF-003666', NULL, NULL, 177, NULL, NULL, 187108),
(187109, '1.10.287.70-FF-000735', NULL, 'Uncharacterized protein', 114, NULL, NULL, 187109),
(187110, '1.25.40.10-FF-001437', NULL, 'Putative Dynein binding protein/ TPR repeat family', 126, NULL, NULL, 187110);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(187111, '3.40.309.10-FF-000030', NULL, 'Aldehyde dehydrogenase', 190, NULL, NULL, 187111),
(187112, '1.10.20.10-FF-000165', NULL, 'Histone H2A', 65, NULL, NULL, 187112),
(187113, '3.40.50.720-FF-000979', NULL, 'Chanoclavine-I dehydrogenase easD', 258, NULL, NULL, 187113),
(187114, '2.40.20.10-FF-000055', NULL, 'Uncharacterized protein', 89, NULL, NULL, 187114),
(187115, '3.30.1680.10-FF-000034', NULL, 'PLeXin', 53, NULL, NULL, 187115),
(187116, '2.30.30.40-FF-000290', NULL, 'Microtubule-actin cross-linking factor 1', 65, NULL, NULL, 187116),
(187117, '3.30.572.10-FF-000020', NULL, 'AGAP010457-PA', 301, NULL, NULL, 187117),
(187118, '3.40.50.12350-FF-000015', NULL, 'EYES ABSENT-like protein', 77, NULL, NULL, 187118),
(187119, '2.30.42.10-FF-000302', NULL, 'Membrane metalloprotease ARASP, chloroplastic', 95, NULL, NULL, 187119),
(187120, '1.20.1070.10-FF-001037', NULL, 'Olfactory receptor 1348', 80, NULL, NULL, 187120),
(187121, '2.60.40.10-FF-002606', NULL, 'Protein kinase domain containing protein', 92, NULL, NULL, 187121),
(187122, '3.90.780.10-FF-000012', NULL, 'LPXTG cell wall anchor domain-containing protein', 209, NULL, NULL, 187122),
(187123, '2.60.40.10-FF-002034', NULL, 'Mesocentin', 112, NULL, NULL, 187123),
(187124, '2.130.10.10-FF-006053', NULL, 'F-box and WD-40 domain protein 5', 152, NULL, NULL, 187124),
(187125, '2.60.40.10-FF-005788', NULL, NULL, 88, NULL, NULL, 187125),
(187126, '1.20.120.1150-FF-000002', NULL, 'Serine/threonine-protein phosphatase 2A activator', 115, NULL, NULL, 187126),
(187127, '3.40.1170.60-FF-000019', NULL, 'DNA polymerase kappa', 55, NULL, NULL, 187127),
(187128, '2.40.160.110-FF-000006', NULL, 'Lysosome-associated membrane glycoprotein 3', 163, NULL, NULL, 187128),
(187129, '3.40.47.10-FF-000024', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase, mitochondrial', 265, NULL, NULL, 187129),
(187130, '3.90.280.10-FF-000007', NULL, 'Raf kinase inhibitor', 188, NULL, NULL, 187130),
(187131, '1.20.1310.10-FF-000101', NULL, 'Uncharacterized protein', 87, NULL, NULL, 187131),
(187132, '3.10.100.10-FF-000108', NULL, 'C-type lectin receptor-like tyrosine-protein kinase', 155, NULL, NULL, 187132),
(187133, '1.20.140.10-FF-000139', NULL, 'Acyl-coenzyme A oxidase', 134, NULL, NULL, 187133),
(187134, '1.25.10.10-FF-002290', NULL, 'Uncharacterized protein', 326, NULL, NULL, 187134),
(187135, '4.10.400.10-FF-000307', NULL, 'Transmembrane cell adhesion receptor mua-3', 40, NULL, NULL, 187135),
(187136, '3.40.50.720-FF-001126', NULL, '4-hydroxy-tetrahydrodipicolinate reductase', 121, NULL, NULL, 187136),
(187137, '1.25.10.10-FF-001609', NULL, 'Uncharacterized protein', 477, NULL, NULL, 187137),
(187138, '3.30.160.60-FF-005698', NULL, NULL, 62, NULL, NULL, 187138),
(187139, '2.60.220.30-FF-000009', NULL, 'Ankyrin 2, isoform G', 161, NULL, NULL, 187139),
(187140, '3.30.420.110-FF-000034', NULL, 'DNA mismatch repair protein MutS', 149, NULL, NULL, 187140),
(187141, '3.40.50.1820-FF-000786', NULL, 'Acyl-protein thioesterase 1', 229, NULL, NULL, 187141),
(187142, '3.40.50.300-FF-008048', NULL, 'Uncharacterized protein', 128, NULL, NULL, 187142),
(187143, '2.40.160.120-FF-000009', NULL, 'oxysterol-binding protein-related protein 3C', 178, NULL, NULL, 187143),
(187144, '1.10.10.10-FF-000344', NULL, 'AsnC family transcriptional regulator', 52, NULL, NULL, 187144),
(187145, '2.30.180.10-FF-000130', NULL, NULL, 127, NULL, NULL, 187145),
(187146, '1.20.1310.10-FF-000090', NULL, 'Cullin family protein', 124, NULL, NULL, 187146),
(187147, '1.20.1270.60-FF-000067', NULL, 'NOSTRIN isoform 1', 261, NULL, NULL, 187147),
(187148, '2.10.25.10-FF-001135', NULL, 'Coagulation factor VIIi', 44, NULL, NULL, 187148),
(187149, '3.30.160.60-FF-000920', NULL, 'Uncharacterized protein', 28, NULL, NULL, 187149),
(187150, '3.30.1460.50-FF-000029', NULL, 'Autophagy 10 variant 1', 93, NULL, NULL, 187150),
(187151, '3.40.50.1820-FF-000679', NULL, 'Uncharacterized protein', 275, NULL, NULL, 187151),
(187152, '1.20.1020.10-FF-000005', NULL, 'Nejire, isoform C', 98, NULL, NULL, 187152),
(187153, '3.30.160.60-FF-000550', NULL, 'Zinc finger and BTB domain-containing 47', 30, NULL, NULL, 187153);
INSERT INTO "PUBLIC"."MODEL" VALUES
(187154, '2.40.30.10-FF-000134', NULL, 'Electron transfer protein FDXB', 100, NULL, NULL, 187154),
(187155, '1.10.287.4280-FF-000004', NULL, 'Uncharacterized protein', 38, NULL, NULL, 187155),
(187156, '3.40.50.300-FF-004007', NULL, 'DNA ligase-associated DEXH box helicase', 211, NULL, NULL, 187156),
(187157, '2.70.170.10-FF-000300', NULL, 'Uncharacterized protein', 132, NULL, NULL, 187157),
(187158, '2.130.10.10-FF-004136', NULL, 'Uncharacterized protein', 182, NULL, NULL, 187158),
(187159, '1.20.1740.10-FF-000274', NULL, 'Uncharacterized protein', 144, NULL, NULL, 187159),
(187160, '1.10.3730.20-FF-000065', NULL, 'Uncharacterized protein', 96, NULL, NULL, 187160),
(187161, '1.25.40.20-FF-000664', NULL, 'Uncharacterized protein', 88, NULL, NULL, 187161),
(187162, '3.40.50.2000-FF-000767', NULL, 'Predicted protein', 224, NULL, NULL, 187162),
(187163, '3.30.160.60-FF-002348', NULL, 'paternally-expressed gene 3 protein isoform X3', 45, NULL, NULL, 187163),
(187164, '2.60.40.10-FF-004523', NULL, NULL, 79, NULL, NULL, 187164),
(187165, '3.30.505.10-FF-000095', NULL, 'Signal transducer and activator of transcription', 118, NULL, NULL, 187165),
(187166, '2.40.30.10-FF-000353', NULL, 'Eukaryotic initiation factor', 63, NULL, NULL, 187166),
(187167, '1.10.10.1050-FF-000006', NULL, 'Related to decapping enzyme', 94, NULL, NULL, 187167),
(187168, '1.25.40.10-FF-001763', NULL, 'Pentatricopeptide repeat-containing protein At3g16010', 192, NULL, NULL, 187168),
(187169, '1.25.40.530-FF-000020', NULL, 'Predicted protein', 188, NULL, NULL, 187169),
(187170, '3.30.1360.120-FF-000105', NULL, 'Uncharacterized protein', 146, NULL, NULL, 187170),
(187171, '1.25.40.10-FF-000021', NULL, 'Lipoprotein NlpI', 275, NULL, NULL, 187171),
(187172, '1.25.10.10-FF-002301', NULL, 'Predicted protein', 322, NULL, NULL, 187172),
(187173, '3.30.60.30-FF-000213', NULL, 'Uncharacterized protein', 91, NULL, NULL, 187173),
(187174, '1.10.1200.10-FF-000168', NULL, 'Predicted protein', 49, NULL, NULL, 187174),
(187175, '2.130.10.10-FF-002354', NULL, 'LRS1', 172, NULL, NULL, 187175),
(187176, '1.10.455.10-FF-000035', NULL, 'Uncharacterized protein', 125, NULL, NULL, 187176),
(187177, '3.40.50.720-FF-001345', NULL, 'Putative oxidoreductase', 238, NULL, NULL, 187177),
(187178, '2.130.10.10-FF-000230', NULL, 'Transducin beta-like protein 3', 223, NULL, NULL, 187178),
(187179, '1.10.10.10-FF-001974', NULL, 'Cullin-related protein', 63, NULL, NULL, 187179),
(187180, '1.20.5.190-FF-000040', NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', 51, NULL, NULL, 187180),
(187181, '1.10.730.20-FF-000015', NULL, 'Isoleucine--tRNA ligase', 328, NULL, NULL, 187181),
(187182, '3.30.160.60-FF-003883', NULL, 'Transcription factor btd', 53, NULL, NULL, 187182),
(187183, '3.30.70.330-FF-001280', NULL, 'Polyadenylate-binding protein', 104, NULL, NULL, 187183),
(187184, '3.60.21.10-FF-000245', NULL, 'Purple acid phosphatase', 290, NULL, NULL, 187184),
(187185, '1.10.565.10-FF-000173', NULL, 'Uncharacterized protein', 174, NULL, NULL, 187185),
(187186, '2.130.10.10-FF-004501', NULL, 'Uncharacterized protein', 352, NULL, NULL, 187186),
(187187, '3.20.90.10-FF-000007', NULL, NULL, 97, NULL, NULL, 187187),
(187188, '1.10.790.10-FF-000004', NULL, 'Prion protein 1', 134, NULL, NULL, 187188),
(187189, '1.10.287.110-FF-000146', NULL, 'Chaperone protein DNAj', 81, NULL, NULL, 187189),
(187190, '2.40.50.140-FF-000978', NULL, NULL, 108, NULL, NULL, 187190),
(187191, '3.30.160.60-FF-004602', NULL, NULL, 56, NULL, NULL, 187191),
(187192, '3.30.160.60-FF-002039', NULL, 'Uncharacterized protein', 26, NULL, NULL, 187192),
(187193, '2.30.110.10-FF-000075', NULL, 'Nitrilotriacetate monooxygenase', 177, NULL, NULL, 187193),
(187194, '2.40.100.10-FF-000072', NULL, 'Peptidyl-prolyl cis-trans isomerase', 199, NULL, NULL, 187194),
(187195, '1.10.3210.10-FF-000017', NULL, 'Deoxynucleoside triphosphate triphosphohydrolase SAMHD1', 311, NULL, NULL, 187195),
(187196, '3.30.70.330-FF-002420', NULL, NULL, 91, NULL, NULL, 187196),
(187197, '3.40.50.300-FF-004535', NULL, 'Flagellar associated protein', 267, NULL, NULL, 187197);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(187198, '3.40.30.10-FF-000284', NULL, 'NADH dehydrogenase subunit NI8M', 80, NULL, NULL, 187198),
(187199, '3.40.50.300-FF-000264', NULL, 'ATP-binding cassette, sub-family A (ABC1), member 1', 265, NULL, NULL, 187199),
(187200, '1.10.3720.10-FF-000090', NULL, 'Dipeptide ABC transporter permease', 205, NULL, NULL, 187200),
(187201, '3.10.330.20-FF-000027', NULL, 'Predicted protein', 72, NULL, NULL, 187201),
(187202, '3.90.920.10-FF-000001', NULL, 'DNA primase', 410, NULL, NULL, 187202),
(187203, '3.40.1810.10-FF-000026', NULL, 'MADS-box transcription factor 29', 85, NULL, NULL, 187203),
(187204, '1.10.730.10-FF-000012', NULL, 'Leucine--tRNA ligase', 27, NULL, NULL, 187204),
(187205, '3.30.1490.100-FF-000004', NULL, 'DNA polymerase IV', 108, NULL, NULL, 187205),
(187206, '3.30.505.10-FF-000106', NULL, 'Tyrosine-protein kinase', 127, NULL, NULL, 187206),
(187207, '1.20.140.100-FF-000044', NULL, 'Dynein heavy chain 11', 153, NULL, NULL, 187207),
(187208, '2.60.120.10-FF-000069', NULL, 'Homogentisate 1,2-dioxygenase', 138, NULL, NULL, 187208),
(187209, '2.60.40.10-FF-004158', NULL, NULL, 89, NULL, NULL, 187209),
(187210, '2.60.40.10-FF-001887', NULL, 'Twitchin', 92, NULL, NULL, 187210),
(187211, '1.20.1390.10-FF-000010', NULL, 'U1 small nuclear ribonucleoprotein component SNU71', 89, NULL, NULL, 187211),
(187212, '3.30.200.20-FF-002065', NULL, 'Protein kinase superfamily protein', 86, NULL, NULL, 187212),
(187213, '1.10.472.80-FF-000096', NULL, 'GTPase activating protein, putative', 124, NULL, NULL, 187213),
(187214, '2.40.70.10-FF-000243', NULL, 'Secreted aspartic proteinase', 179, NULL, NULL, 187214),
(187215, '1.25.40.840-FF-000006', NULL, 'CCR4-NOT transcriptional complex subunit', 172, NULL, NULL, 187215),
(187216, '1.25.70.10-FF-000039', NULL, 'F8K4.20 protein', 118, NULL, NULL, 187216),
(187217, '3.40.50.150-FF-000437', NULL, 'tRNA wybutosine-synthesizing protein 2', 225, NULL, NULL, 187217),
(187218, '3.30.360.10-FF-000112', NULL, 'Uncharacterized protein', 158, NULL, NULL, 187218),
(187219, '1.10.472.80-FF-000135', NULL, 'LD17019p', 136, NULL, NULL, 187219),
(187220, '2.70.130.10-FF-000180', NULL, NULL, 164, NULL, NULL, 187220),
(187221, '3.30.1490.110-FF-000007', NULL, 'Cell division protein FtsA', 89, NULL, NULL, 187221),
(187222, '2.60.40.150-FF-000805', NULL, 'Uncharacterized protein', 142, NULL, NULL, 187222),
(187223, '3.90.1410.10-FF-000074', NULL, 'YALI0E34397p', 237, NULL, NULL, 187223),
(187224, '2.30.42.10-FF-000578', NULL, NULL, 115, NULL, NULL, 187224),
(187225, '3.40.630.30-FF-000625', NULL, 'Uncharacterized protein', 183, NULL, NULL, 187225),
(187226, '1.10.472.10-FF-000226', NULL, 'Cyclin-A1-1', 72, NULL, NULL, 187226),
(187227, '1.25.10.10-FF-000047', NULL, 'Cullin-associated NEDD8-dissociated protein 1', 1177, NULL, NULL, 187227),
(187228, '3.30.420.510-FF-000031', NULL, 'Uncharacterized protein', 164, NULL, NULL, 187228),
(187229, '1.25.40.10-FF-004034', NULL, 'Uncharacterized protein', 181, NULL, NULL, 187229),
(187230, '3.30.160.60-FF-000701', NULL, 'Zinc finger and BTB domain containing 40', 29, NULL, NULL, 187230),
(187231, '1.10.533.10-FF-000144', NULL, 'Apoptosis-associated speck-like protein-containing a CARD', 91, NULL, NULL, 187231),
(187232, '2.60.120.1040-FF-000020', NULL, NULL, 97, NULL, NULL, 187232),
(187233, '3.30.160.60-FF-001859', NULL, 'Flt3-interacting zinc finger protein 1', 33, NULL, NULL, 187233),
(187234, '2.60.120.10-FF-000097', NULL, 'Eag-like K[+] channel, isoform B', 184, NULL, NULL, 187234),
(187235, '1.10.287.70-FF-000628', NULL, 'Uncharacterized protein', 208, NULL, NULL, 187235),
(187236, '3.30.750.44-FF-000032', NULL, NULL, 57, NULL, NULL, 187236),
(187237, '1.25.10.10-FF-002317', NULL, 'Uncharacterized protein', 313, NULL, NULL, 187237),
(187238, '1.20.990.10-FF-000063', NULL, 'NADPH--cytochrome p450 reductase, putative', 149, NULL, NULL, 187238),
(187239, '3.40.50.300-FF-004316', NULL, 'GM18634', 279, NULL, NULL, 187239),
(187240, '3.40.630.30-FF-000491', NULL, 'Aminoglycoside N(6'')-acetyltransferase type 1', 145, NULL, NULL, 187240);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(187241, '1.10.8.1210-FF-000004', NULL, 'Glutamate dehydrogenase', 58, NULL, NULL, 187241),
(187242, '3.10.20.90-FF-000460', NULL, 'Tea4', 94, NULL, NULL, 187242),
(187243, '3.30.450.40-FF-000009', NULL, 'DNA-binding transcriptional regulator KdgR', 173, NULL, NULL, 187243),
(187244, '1.25.10.10-FF-001828', NULL, 'Condensin complex subunit 1', 305, NULL, NULL, 187244),
(187245, '3.30.420.40-FF-000261', NULL, 'Heat shock protein 110', 92, NULL, NULL, 187245),
(187246, '3.50.50.100-FF-000038', NULL, 'FAD-dependent pyridine nucleotide-disulphide oxidoreductase', 401, NULL, NULL, 187246),
(187247, '2.60.120.10-FF-000748', NULL, 'Uncharacterized protein', 101, NULL, NULL, 187247),
(187248, '2.60.40.150-FF-000249', NULL, 'Phosphatidylserine decarboxylase proenzyme 2', 151, NULL, NULL, 187248),
(187249, '1.10.10.10-FF-000193', NULL, 'histone H2A deubiquitinase MYSM1 isoform X1', 76, NULL, NULL, 187249),
(187250, '1.25.10.10-FF-002071', NULL, 'Uncharacterized protein', 106, NULL, NULL, 187250),
(187251, '1.10.220.10-FF-000018', NULL, 'Annexin', 79, NULL, NULL, 187251),
(187252, '3.20.20.70-FF-000723', NULL, NULL, 105, NULL, NULL, 187252),
(187253, '2.60.260.20-FF-000132', NULL, 'Chaperone DnaJ', 115, NULL, NULL, 187253),
(187254, '2.170.270.10-FF-000031', NULL, 'probable histone-lysine N-methyltransferase PRDM7', 182, NULL, NULL, 187254),
(187255, '3.30.1330.30-FF-000071', NULL, 'Ribosomal protein', 99, NULL, NULL, 187255),
(187256, '1.25.40.20-FF-001766', NULL, 'Leucine-rich repeat serine/threonine-protein kinase 1', 190, NULL, NULL, 187256),
(187257, '2.60.40.10-FF-005939', NULL, NULL, 97, NULL, NULL, 187257),
(187258, '3.30.460.80-FF-000016', NULL, 'Hydrogenase subunit, putative', 89, NULL, NULL, 187258),
(187259, '1.20.58.70-FF-000112', NULL, 't-SNARE affecting a late Golgi compartment protein 2', 208, NULL, NULL, 187259),
(187260, '2.20.70.10-FF-000053', NULL, 'E3 ubiquitin-protein ligase', 54, NULL, NULL, 187260),
(187261, '3.90.190.10-FF-000473', NULL, 'Phosphatase, putative', 179, NULL, NULL, 187261),
(187262, '3.40.50.1000-FF-000444', NULL, 'Phospholipid-transporting ATPase', 166, NULL, NULL, 187262),
(187263, '3.40.50.150-FF-001848', NULL, NULL, 41, NULL, NULL, 187263),
(187264, '3.40.50.1010-FF-000077', NULL, 'Ribonuclease VapC', 123, NULL, NULL, 187264),
(187265, '3.40.50.1000-FF-000074', NULL, 'Phospholipid-transporting ATPase', 186, NULL, NULL, 187265),
(187266, '3.40.630.10-FF-000147', NULL, 'Aminoacyl-histidine dipeptidase, putative', 115, NULL, NULL, 187266),
(187267, '3.40.30.10-FF-001003', NULL, 'Glutathione S-transferase U10', 70, NULL, NULL, 187267),
(187268, '2.60.40.10-FF-005569', NULL, NULL, 102, NULL, NULL, 187268),
(187269, '1.10.238.10-FF-001020', NULL, 'Uncharacterized protein', 66, NULL, NULL, 187269),
(187270, '2.60.40.10-FF-000780', NULL, 'Tyrosine-protein kinase receptor TYRO3', 102, NULL, NULL, 187270),
(187271, '3.40.30.10-FF-000194', NULL, 'Iodothyronine deiodinase', 206, NULL, NULL, 187271),
(187272, '3.30.559.30-FF-000034', NULL, 'Nonribosomal peptide synthetase easA', 209, NULL, NULL, 187272),
(187273, '1.10.10.10-FF-000900', NULL, '6-O-methylguanine_DNA_methyltransferase_-_DNA_binding_domain_containing_protein_-_putative', 94, NULL, NULL, 187273),
(187274, '4.10.280.10-FF-000191', NULL, 'Transcription factor UDT1', 80, NULL, NULL, 187274),
(187275, '2.120.10.80-FF-000402', NULL, 'Uncharacterized protein', 100, NULL, NULL, 187275),
(187276, '1.20.1640.10-FF-000081', NULL, 'Transporter, AcrB/D/F family', 209, NULL, NULL, 187276),
(187277, '3.30.230.10-FF-000102', NULL, 'Similar to galactokinase', 208, NULL, NULL, 187277),
(187278, '1.10.1420.10-FF-000061', NULL, 'Putative DNA mismatch repair protein', 100, NULL, NULL, 187278),
(187279, '1.25.10.10-FF-000182', NULL, 'Importin-5 isoform X2', 1063, NULL, NULL, 187279),
(187280, '1.10.1200.10-FF-000078', NULL, 'Probable non-ribosomal peptide synthetase', 85, NULL, NULL, 187280),
(187281, '3.30.200.20-FF-001357', NULL, NULL, 100, NULL, NULL, 187281),
(187282, '2.60.120.620-FF-000085', NULL, 'Procollagen-proline, 2-oxoglutarate-4-dioxygenase', 186, NULL, NULL, 187282);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(187283, '2.40.33.10-FF-000034', NULL, 'Pyruvate kinase', 94, NULL, NULL, 187283),
(187284, '3.40.50.720-FF-001671', NULL, 'Os02g0640600 protein', 195, NULL, NULL, 187284),
(187285, '1.10.8.60-FF-000471', NULL, 'Uncharacterized protein', 76, NULL, NULL, 187285),
(187286, '2.130.10.10-FF-000432', NULL, 'WD repeat domain 7', 330, NULL, NULL, 187286),
(187287, '1.10.510.10-FF-003790', NULL, NULL, 130, NULL, NULL, 187287),
(187288, '2.40.50.140-FF-001158', NULL, NULL, 87, NULL, NULL, 187288),
(187289, '2.60.120.10-FF-000743', NULL, 'Uncharacterized protein', 109, NULL, NULL, 187289),
(187290, '2.40.40.20-FF-000082', NULL, 'Predicted protein', 79, NULL, NULL, 187290),
(187291, '1.10.150.50-FF-000154', NULL, 'Protein CBG04143', 65, NULL, NULL, 187291),
(187292, '3.30.457.60-FF-000014', NULL, 'Chromosome 15, whole genome shotgun sequence', 89, NULL, NULL, 187292),
(187293, '1.10.287.1080-FF-000016', NULL, 'Uncharacterized protein', 135, NULL, NULL, 187293),
(187294, '3.90.1680.10-FF-000003', NULL, 'SOS response-associated protein', 204, NULL, NULL, 187294),
(187295, '2.10.220.10-FF-000138', NULL, 'Fraser extracellular matrix complex subunit 1', 59, NULL, NULL, 187295),
(187296, '3.50.50.60-FF-001255', NULL, 'Uncharacterized protein', 114, NULL, NULL, 187296),
(187297, '3.40.50.300-FF-008032', NULL, 'Uncharacterized protein', 136, NULL, NULL, 187297),
(187298, '2.40.30.10-FF-000443', NULL, 'Elongation factor Tu', 38, NULL, NULL, 187298),
(187299, '1.10.418.10-FF-000056', NULL, 'leucine-rich repeat and calponin homology domain-containing protein 4 isoform X2', 118, NULL, NULL, 187299),
(187300, '3.40.50.300-FF-000483', NULL, 'Sensor histidine kinase KdpD', 211, NULL, NULL, 187300),
(187301, '1.10.730.10-FF-000102', NULL, 'Valine--tRNA ligase', 182, NULL, NULL, 187301),
(187302, '3.80.10.10-FF-003922', NULL, 'Uncharacterized protein', 100, NULL, NULL, 187302),
(187303, '2.10.25.10-FF-001461', NULL, 'Delta-like protein', 40, NULL, NULL, 187303),
(187304, '3.30.160.60-FF-004591', NULL, NULL, 72, NULL, NULL, 187304),
(187305, '3.80.10.10-FF-002782', NULL, 'Uncharacterized protein', 159, NULL, NULL, 187305),
(187306, '3.90.76.10-FF-000027', NULL, 'Peptide ABC transporter substrate-binding protein', 159, NULL, NULL, 187306),
(187307, '3.40.50.720-FF-001143', NULL, 'Tar1', 188, NULL, NULL, 187307),
(187308, '3.40.50.280-FF-000010', NULL, 'Methylmalonyl-CoA mutase, mitochondrial', 56, NULL, NULL, 187308),
(187309, '2.130.10.10-FF-000084', NULL, 'mRNA export factor', 368, NULL, NULL, 187309),
(187310, '3.10.290.10-FF-000094', NULL, 'Pseudouridine synthase', 68, NULL, NULL, 187310),
(187311, '2.10.25.10-FF-000657', NULL, 'vasorin', 44, NULL, NULL, 187311),
(187312, '1.10.8.720-FF-000061', NULL, 'Dynein heavy chain family protein', 165, NULL, NULL, 187312),
(187313, '3.80.10.10-FF-003580', NULL, 'Predicted protein', 140, NULL, NULL, 187313),
(187314, '1.20.1370.60-FF-000001', NULL, 'Catalase', 115, NULL, NULL, 187314),
(187315, '1.20.1250.20-FF-000649', NULL, 'Predicted protein', 489, NULL, NULL, 187315),
(187316, '1.10.510.10-FF-001884', NULL, 'Leucine-rich repeat receptor-like protein kinase', 206, NULL, NULL, 187316),
(187317, '1.20.1560.10-FF-000855', NULL, 'Uncharacterized protein', 244, NULL, NULL, 187317),
(187318, '3.30.160.60-FF-003793', NULL, NULL, 27, NULL, NULL, 187318),
(187319, '4.10.1000.40-FF-000002', NULL, 'Nuclear polyadenylated RNA-binding protein Nab2', 67, NULL, NULL, 187319),
(187320, '3.20.20.190-FF-000156', NULL, NULL, 334, NULL, NULL, 187320),
(187321, '3.40.50.300-FF-000303', NULL, 'GTP-binding protein Di-Ras2', 177, NULL, NULL, 187321),
(187322, '1.10.10.10-FF-001648', NULL, 'Uncharacterized protein', 80, NULL, NULL, 187322),
(187323, '2.60.40.60-FF-000660', NULL, 'Cadherin 17', 105, NULL, NULL, 187323),
(187324, '2.130.10.10-FF-004355', NULL, 'Uncharacterized protein', 93, NULL, NULL, 187324),
(187325, '3.10.100.10-FF-000232', NULL, 'GD19722', 162, NULL, NULL, 187325),
(187326, '3.30.200.20-FF-002211', NULL, 'Serine/threonine-protein kinase RIO3', 46, NULL, NULL, 187326),
(187327, '1.10.10.41-FF-000006', NULL, NULL, 50, NULL, NULL, 187327);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(187328, '1.10.510.10-FF-001991', NULL, 'Uncharacterized protein CaJ7.0258', 253, NULL, NULL, 187328),
(187329, '3.30.910.20-FF-000011', NULL, 'OmpH family outer membrane protein', 144, NULL, NULL, 187329),
(187330, '2.60.220.30-FF-000026', NULL, 'Predicted protein', 168, NULL, NULL, 187330),
(187331, '3.80.10.10-FF-003052', NULL, 'Uncharacterized protein', 150, NULL, NULL, 187331),
(187332, '1.10.510.10-FF-001749', NULL, 'Serine/threonine kinase', 175, NULL, NULL, 187332),
(187333, '3.30.1640.10-FF-000060', NULL, 'DNA replication licensing factor MCM7', 128, NULL, NULL, 187333),
(187334, '3.40.50.1240-FF-000134', NULL, NULL, 170, NULL, NULL, 187334),
(187335, '1.10.530.10-FF-000031', NULL, 'Lytic transglycosylase', 149, NULL, NULL, 187335),
(187336, '3.40.50.10130-FF-000018', NULL, 'Cytosolic Fe-S cluster assembly factor NUBP1 homolog', 117, NULL, NULL, 187336),
(187337, '2.130.10.10-FF-004029', NULL, 'Uncharacterized protein', 380, NULL, NULL, 187337),
(187338, '3.40.50.1820-FF-001168', NULL, 'Uncharacterized protein', 74, NULL, NULL, 187338),
(187339, '2.60.40.10-FF-006092', NULL, NULL, 113, NULL, NULL, 187339),
(187340, '2.20.80.10-FF-000020', NULL, 'Predicted protein', 240, NULL, NULL, 187340),
(187341, '3.30.230.70-FF-000120', NULL, 'AFR109Wp', 236, NULL, NULL, 187341),
(187342, '3.40.50.1440-FF-000003', NULL, 'Tubulin beta chain', 263, NULL, NULL, 187342),
(187343, '3.30.390.50-FF-000030', NULL, 'Xanthine dehydrogenase, A subunit', 102, NULL, NULL, 187343),
(187344, '3.30.830.10-FF-000092', NULL, 'Protein CBG19672', 193, NULL, NULL, 187344),
(187345, '2.40.10.10-FF-000251', NULL, 'Zgc:92511', 112, NULL, NULL, 187345),
(187346, '2.10.70.80-FF-000001', NULL, 'Sortilin-related VPS10 domain-containing receptor 1', 53, NULL, NULL, 187346),
(187347, '3.90.550.10-FF-000219', NULL, 'Eukaryotic initiation factor eIF2B gamma subunit', 269, NULL, NULL, 187347),
(187348, '2.40.155.10-FF-000007', NULL, 'Predicted protein', 61, NULL, NULL, 187348),
(187349, '1.10.533.10-FF-000054', NULL, 'Unc-5 family C-terminal like', 97, NULL, NULL, 187349),
(187350, '2.130.10.10-FF-004271', NULL, 'Uncharacterized protein', 131, NULL, NULL, 187350),
(187351, '3.30.1360.70-FF-000005', NULL, 'Arginine--tRNA ligase', 102, NULL, NULL, 187351),
(187352, '3.40.50.11340-FF-000027', NULL, 'Uncharacterized protein', 128, NULL, NULL, 187352),
(187353, '3.30.1360.60-FF-000002', NULL, 'N-Acetyl-D-Glucosamine phosphotransferase system transporter', 80, NULL, NULL, 187353),
(187354, '1.25.40.10-FF-000352', NULL, 'Kinase with tetratricopeptide repeat domain-containing protein', 107, NULL, NULL, 187354),
(187355, '2.60.40.10-FF-001882', NULL, 'Usherin', 93, NULL, NULL, 187355),
(187356, '2.60.40.10-FF-000117', NULL, 'Fibronectin type III domain containing 5', 98, NULL, NULL, 187356),
(187357, '3.40.30.10-FF-000840', NULL, 'Protein disulfide isomerase1-1', 127, NULL, NULL, 187357),
(187358, '3.40.140.10-FF-000065', NULL, 'tRNA-specific adenosine deaminase 2', 180, NULL, NULL, 187358),
(187359, '3.40.50.1450-FF-000006', NULL, 'Hydrogenase maturation protease', 148, NULL, NULL, 187359),
(187360, '3.30.160.270-FF-000011', NULL, '2-isopropylmalate synthase', 181, NULL, NULL, 187360),
(187361, '2.60.40.10-FF-000252', NULL, 'Fibroblast growth factor receptor', 89, NULL, NULL, 187361),
(187362, '3.30.830.10-FF-000305', NULL, 'Uncharacterized protein', 129, NULL, NULL, 187362),
(187363, '1.20.5.110-FF-000292', NULL, 'Uncharacterized protein', 95, NULL, NULL, 187363),
(187364, '1.10.287.110-FF-000348', NULL, 'DnaJ domain protein (AFU_orthologue AFUA_5G03040)', 53, NULL, NULL, 187364),
(187365, '2.40.480.10-FF-000004', NULL, 'Dirigent protein 21', 150, NULL, NULL, 187365),
(187366, '3.60.21.10-FF-000273', NULL, 'Serine/threonine-protein phosphatase', 243, NULL, NULL, 187366),
(187367, '3.30.70.580-FF-000005', NULL, 'Pseudouridine synthase', 73, NULL, NULL, 187367),
(187368, '3.40.50.11610-FF-000001', NULL, '2-oxoglutarate dehydrogenase E1 component', 155, NULL, NULL, 187368),
(187369, '3.50.50.100-FF-000033', NULL, 'Uncharacterized protein', 226, NULL, NULL, 187369);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(187370, '1.10.3720.10-FF-000101', NULL, 'Peptide ABC transporter permease', 228, NULL, NULL, 187370),
(187371, '3.40.1080.10-FF-000008', NULL, 'Acetate CoA-transferase YdiF', 249, NULL, NULL, 187371),
(187372, '1.25.10.10-FF-001918', NULL, 'Protein ARABIDILLO 2', 149, NULL, NULL, 187372),
(187373, '3.30.460.10-FF-000187', NULL, 'Poly A polymerase', 16, NULL, NULL, 187373),
(187374, '3.30.160.60-FF-005709', NULL, NULL, 54, NULL, NULL, 187374),
(187375, '1.10.510.10-FF-000119', NULL, 'Putative map kinase-interacting serine/threonine-protein kinase 1', 211, NULL, NULL, 187375),
(187376, '1.10.20.10-FF-000148', NULL, 'Os07g0612500 protein', 68, NULL, NULL, 187376),
(187377, '3.10.105.10-FF-000114', NULL, 'Oligopeptide ABC transporter, solute-binding protein', 219, NULL, NULL, 187377),
(187378, '3.80.10.10-FF-000983', NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', 124, NULL, NULL, 187378),
(187379, '2.60.120.260-FF-000050', NULL, 'Beta-galactosidase', 125, NULL, NULL, 187379),
(187380, '3.30.70.590-FF-000008', NULL, 'Unplaced genomic scaffold supercont1.129, whole genome shotgun sequence', 160, NULL, NULL, 187380),
(187381, '1.25.40.10-FF-001982', NULL, 'Probable pre-mRNA splicing factor prp1', 119, NULL, NULL, 187381),
(187382, '4.10.280.10-FF-000084', NULL, 'class A basic helix-loop-helix protein 9', 77, NULL, NULL, 187382),
(187383, '3.30.160.60-FF-002129', NULL, 'Zinc finger protein 304', 28, NULL, NULL, 187383),
(187384, '1.20.1530.20-FF-000002', NULL, 'K(+)/H(+) antiporter NhaP2', 388, NULL, NULL, 187384),
(187385, '1.10.287.70-FF-000398', NULL, 'Uncharacterized protein', 128, NULL, NULL, 187385),
(187386, '3.30.40.10-FF-001369', NULL, 'Predicted protein', 82, NULL, NULL, 187386),
(187387, '2.30.30.170-FF-000007', NULL, 'Fibronectin binding autolysin', 67, NULL, NULL, 187387),
(187388, '3.30.60.30-FF-000185', NULL, 'Agrin', 37, NULL, NULL, 187388),
(187389, '3.30.160.60-FF-006390', NULL, NULL, 59, NULL, NULL, 187389),
(187390, '2.60.40.10-FF-004630', NULL, NULL, 128, NULL, NULL, 187390),
(187391, '3.40.30.10-FF-001008', NULL, 'Glutathione S-transferase U10', 64, NULL, NULL, 187391),
(187392, '1.10.3080.10-FF-000079', NULL, 'Chloride channel protein', 463, NULL, NULL, 187392),
(187393, '3.40.50.1000-FF-000220', NULL, 'Haloacid dehalogenase', 118, NULL, NULL, 187393),
(187394, '2.60.40.1230-FF-000009', NULL, 'AP-2 complex subunit alpha', 134, NULL, NULL, 187394),
(187395, '3.70.10.10-FF-000141', NULL, 'Uncharacterized protein', 93, NULL, NULL, 187395),
(187396, '1.20.870.10-FF-000014', NULL, 'Kinase non-catalytic C-lobe domain-containing 1', 148, NULL, NULL, 187396),
(187397, '2.20.28.10-FF-000040', NULL, 'Rubredoxin', 56, NULL, NULL, 187397),
(187398, '1.20.1110.10-FF-000136', NULL, NULL, 62, NULL, NULL, 187398),
(187399, '3.20.80.10-FF-000052', NULL, 'Uncharacterized protein', 164, NULL, NULL, 187399),
(187400, '1.10.630.10-FF-000387', NULL, 'Zgc:123299', 238, NULL, NULL, 187400),
(187401, '3.40.50.2020-FF-000177', NULL, 'Predicted protein', 46, NULL, NULL, 187401),
(187402, '1.10.340.30-FF-000050', NULL, 'Slr0231 protein', 89, NULL, NULL, 187402),
(187403, '1.25.40.10-FF-003910', NULL, 'Potassium ion transmembrane transporter', 41, NULL, NULL, 187403),
(187404, '2.60.40.10-FF-004175', NULL, NULL, 86, NULL, NULL, 187404),
(187405, '3.90.226.10-FF-000045', NULL, 'Propionyl-CoA carboxylase subunit beta', 245, NULL, NULL, 187405),
(187406, '2.60.40.1220-FF-000006', NULL, 'Copper resistance D domain protein', 100, NULL, NULL, 187406),
(187407, '3.30.1360.210-FF-000014', NULL, '60S ribosomal protein L22-2', 81, NULL, NULL, 187407),
(187408, '2.60.40.1210-FF-000003', NULL, 'Uncharacterized protein', 154, NULL, NULL, 187408),
(187409, '1.25.40.860-FF-000029', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 128, NULL, NULL, 187409),
(187410, '2.60.40.10-FF-005934', NULL, NULL, 102, NULL, NULL, 187410),
(187411, '3.30.1360.200-FF-000011', NULL, 'Multifunctional fusion protein', 127, NULL, NULL, 187411),
(187412, '2.160.20.80-FF-000019', NULL, NULL, 132, NULL, NULL, 187412);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(187413, '2.40.160.110-FF-000023', NULL, 'Lysosome-associated membrane glycoprotein 1', 191, NULL, NULL, 187413),
(187414, '3.30.160.60-FF-001966', NULL, 'Zinc finger protein 445', 27, NULL, NULL, 187414),
(187415, '1.10.510.10-FF-001665', NULL, 'Serine/threonine protein kinase-9', 133, NULL, NULL, 187415),
(187416, '3.80.10.10-FF-003361', NULL, 'Uncharacterized protein', 113, NULL, NULL, 187416),
(187417, '1.10.10.60-FF-000073', NULL, 'Putative LIM/homeobox protein Lhx3', 59, NULL, NULL, 187417),
(187418, '2.40.160.120-FF-000026', NULL, 'Oxysterol-binding protein', 179, NULL, NULL, 187418),
(187419, '3.40.50.300-FF-000157', NULL, 'ABC transporter G family member 34', 233, NULL, NULL, 187419),
(187420, '2.160.20.70-FF-000016', NULL, 'Tubulin binding cofactor c, putative', 165, NULL, NULL, 187420),
(187421, '3.30.565.10-FF-000290', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One component system)', 151, NULL, NULL, 187421),
(187422, '3.20.19.10-FF-000005', NULL, 'Iron-responsive element-binding protein 2', 232, NULL, NULL, 187422),
(187423, '1.20.1560.10-FF-000939', NULL, 'Mating factor M secretion protein mam1', 558, NULL, NULL, 187423),
(187424, '3.90.1150.10-FF-000031', NULL, 'Serine--glyoxylate aminotransferase', 122, NULL, NULL, 187424),
(187425, '3.30.1490.50-FF-000003', NULL, 'Glutathione synthetase', 70, NULL, NULL, 187425),
(187426, '2.90.10.10-FF-000030', NULL, 'Serine/threonine-protein kinase', 144, NULL, NULL, 187426),
(187427, '3.40.140.10-FF-000082', NULL, 'Eukaryotic translation initiation factor 3 subunit F', 182, NULL, NULL, 187427),
(187428, '2.10.25.10-FF-001500', NULL, 'Uncharacterized protein', 33, NULL, NULL, 187428),
(187429, '3.30.160.60-FF-004607', NULL, NULL, 52, NULL, NULL, 187429),
(187430, '3.30.200.20-FF-001683', NULL, NULL, 73, NULL, NULL, 187430),
(187431, '2.10.25.10-FF-001152', NULL, 'Uncharacterized protein', 62, NULL, NULL, 187431),
(187432, '1.20.1250.20-FF-000958', NULL, 'MFS general substrate transporter', 186, NULL, NULL, 187432),
(187433, '3.30.450.40-FF-000116', NULL, 'IclR family transcriptional regulator', 163, NULL, NULL, 187433),
(187434, '3.40.50.2000-FF-001037', NULL, 'Glycosyl transferase; group 1', 167, NULL, NULL, 187434),
(187435, '2.60.120.290-FF-000059', NULL, 'Zinc metalloproteinase', 121, NULL, NULL, 187435),
(187436, '2.10.90.10-FF-000061', NULL, 'Inhibin alpha chain', 101, NULL, NULL, 187436),
(187437, '1.25.40.10-FF-002145', NULL, 'Os02g0552100 protein', 107, NULL, NULL, 187437),
(187438, '3.40.850.10-FF-000130', NULL, 'Kinesin protein', 430, NULL, NULL, 187438),
(187439, '1.10.287.110-FF-000039', NULL, 'Protein translocation complex component (Npl1)', 94, NULL, NULL, 187439),
(187440, '3.10.20.550-FF-000002', NULL, 'Histone deacetylase complex subunit SAP18', 136, NULL, NULL, 187440),
(187441, '3.40.50.720-FF-001452', NULL, 'Uncharacterized protein', 68, NULL, NULL, 187441),
(187442, '3.30.70.20-FF-000126', NULL, NULL, 52, NULL, NULL, 187442),
(187443, '1.10.10.60-FF-000421', NULL, 'Mating-type protein ALPHA2', 87, NULL, NULL, 187443),
(187444, '1.20.120.140-FF-000041', NULL, 'Signal recognition particle alpha', 65, NULL, NULL, 187444),
(187445, '2.160.20.60-FF-000013', NULL, 'Putative formylmethanofurane dehydrogenase subunit', 89, NULL, NULL, 187445),
(187446, '3.40.50.150-FF-000421', NULL, 'Possible methyltransferase (Methylase)', 237, NULL, NULL, 187446),
(187447, '3.50.50.60-FF-000170', NULL, 'Flavin-containing monooxygenase', 270, NULL, NULL, 187447),
(187448, '1.25.10.10-FF-003397', NULL, 'mRNA-binding U2 snRNP complex subunit', 129, NULL, NULL, 187448),
(187449, '1.10.8.60-FF-000364', NULL, 'AAA ATPase domain-containing protein', 105, NULL, NULL, 187449),
(187450, '3.40.30.10-FF-000531', NULL, 'Peroxiredoxin Q/BCP', 152, NULL, NULL, 187450),
(187451, '1.10.246.140-FF-000006', NULL, 'Transcription and mRNA export factor ENY2', 82, NULL, NULL, 187451),
(187452, '1.10.510.10-FF-000580', NULL, 'AGC protein kinase', 71, NULL, NULL, 187452),
(187453, '3.40.50.300-FF-007885', NULL, 'DNA helicase', 195, NULL, NULL, 187453);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(187454, '4.10.280.10-FF-000174', NULL, 'YALI0D24167p', 67, NULL, NULL, 187454),
(187455, '2.60.40.10-FF-004304', NULL, NULL, 102, NULL, NULL, 187455),
(187456, '2.120.10.30-FF-000303', NULL, 'Uncharacterized protein', 115, NULL, NULL, 187456),
(187457, '3.40.50.720-FF-001800', NULL, 'Uncharacterized protein', 63, NULL, NULL, 187457),
(187458, '3.30.1370.100-FF-000023', NULL, 'ATPase, putative', 97, NULL, NULL, 187458),
(187459, '1.25.40.10-FF-001656', NULL, 'Transcription factor BIM2', 100, NULL, NULL, 187459),
(187460, '3.40.50.10810-FF-000020', NULL, 'DNA repair and recombination protein RAD54B', 265, NULL, NULL, 187460),
(187461, '2.60.120.560-FF-000016', NULL, '2,6-beta-D-fructofuranosidase', 130, NULL, NULL, 187461),
(187462, '3.30.160.60-FF-005928', NULL, NULL, 54, NULL, NULL, 187462),
(187463, '3.30.160.60-FF-006210', NULL, NULL, 30, NULL, NULL, 187463),
(187464, '1.20.1440.240-FF-000004', NULL, 'Flavin monoamine oxidase', 106, NULL, NULL, 187464),
(187465, '1.20.1250.20-FF-001447', NULL, 'Uncharacterized protein', 78, NULL, NULL, 187465),
(187466, '3.90.1410.10-FF-000102', NULL, 'N-lysine methyltransferase', 279, NULL, NULL, 187466),
(187467, '1.20.1640.10-FF-000108', NULL, NULL, 210, NULL, NULL, 187467),
(187468, '6.10.140.2150-FF-000005', NULL, 'S phingosine-1-phosphate lyase 1, putative', 49, NULL, NULL, 187468),
(187469, '2.120.10.80-FF-000037', NULL, 'Kelch-like family member 40', 308, NULL, NULL, 187469),
(187470, '3.30.160.60-FF-000555', NULL, 'Zinc finger protein 1 homolog', 29, NULL, NULL, 187470),
(187471, '2.60.260.20-FF-000115', NULL, 'Predicted protein', 81, NULL, NULL, 187471),
(187472, '1.10.246.130-FF-000003', NULL, 'Glutathione hydrolase 7', 104, NULL, NULL, 187472),
(187473, '3.50.50.60-FF-001272', NULL, 'Putative dehydrogenase', 74, NULL, NULL, 187473),
(187474, '3.90.550.10-FF-000534', NULL, 'Mannosylglycerate synthase', 147, NULL, NULL, 187474),
(187475, '3.40.1190.20-FF-000149', NULL, 'Ribokinase', 311, NULL, NULL, 187475),
(187476, '3.30.200.20-FF-002520', NULL, 'Uncharacterized protein', 105, NULL, NULL, 187476),
(187477, '3.20.20.70-FF-000740', NULL, NULL, 77, NULL, NULL, 187477),
(187478, '1.25.40.20-FF-001659', NULL, 'Kinase, NEK', 86, NULL, NULL, 187478),
(187479, '1.25.40.10-FF-001746', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 95, NULL, NULL, 187479),
(187480, '1.20.120.160-FF-000047', NULL, 'Uncharacterized protein', 120, NULL, NULL, 187480),
(187481, '3.90.76.10-FF-000044', NULL, 'ABC-type transport system periplasmic substrate-binding protein (Probable substrate dipeptide/oligopeptide)', 161, NULL, NULL, 187481),
(187482, '3.40.50.740-FF-000047', NULL, 'Thiosulfate reductase', 174, NULL, NULL, 187482),
(187483, '3.40.50.300-FF-006115', NULL, 'AGAP011982-PA', 98, NULL, NULL, 187483),
(187484, '2.40.170.20-FF-000023', NULL, 'TonB-dependent siderophore receptor', 544, NULL, NULL, 187484),
(187485, '1.20.58.2010-FF-000005', NULL, 'Rop guanine nucleotide exchange factor 2', 35, NULL, NULL, 187485),
(187486, '2.40.440.10-FF-000013', NULL, 'Hypothetical Exported Protein', 127, NULL, NULL, 187486),
(187487, '3.40.50.450-FF-000078', NULL, 'Phosphofructokinase, liver a', 141, NULL, NULL, 187487),
(187488, '3.40.50.720-FF-001362', NULL, 'Prephenate dehydrogenase', 177, NULL, NULL, 187488),
(187489, '3.30.160.60-FF-006171', NULL, NULL, 69, NULL, NULL, 187489),
(187490, '1.20.1440.230-FF-000001', NULL, 'Mitochondrial NADH dehydrogenase flavoprotein 1', 96, NULL, NULL, 187490),
(187491, '3.40.630.30-FF-000288', NULL, 'Uncharacterized protein', 205, NULL, NULL, 187491),
(187492, '2.140.10.20-FF-000002', NULL, 'Probable c-type cytochrome', 387, NULL, NULL, 187492),
(187493, '2.80.10.50-FF-000216', NULL, 'Trypsin inhibitor', 37, NULL, NULL, 187493),
(187494, '2.60.40.3450-FF-000001', NULL, 'SbsB protein', 127, NULL, NULL, 187494),
(187495, '3.10.20.90-FF-000257', NULL, 'Ras interacting protein 1', 138, NULL, NULL, 187495),
(187496, '1.20.120.350-FF-000188', NULL, NULL, 120, NULL, NULL, 187496),
(187497, '3.30.30.30-FF-000048', NULL, 'Heat shock protein 70, mitochondrial, putative', 48, NULL, NULL, 187497);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(187498, '3.30.565.10-FF-000071', NULL, 'Sensor histidine kinase', 143, NULL, NULL, 187498),
(187499, '1.10.3380.30-FF-000001', NULL, 'Ski2 ATP-dependent RNA helicase', 226, NULL, NULL, 187499),
(187500, '1.20.5.490-FF-000006', NULL, 'cGMP-dependent protein kinase 1', 48, NULL, NULL, 187500),
(187501, '3.90.228.10-FF-000027', NULL, 'Poly [ADP-ribose] polymerase', 199, NULL, NULL, 187501),
(187502, '3.40.50.720-FF-000041', NULL, 'D-3-phosphoglycerate dehydrogenase', 189, NULL, NULL, 187502),
(187503, '1.10.510.10-FF-000338', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase', 235, NULL, NULL, 187503),
(187504, '1.25.10.10-FF-000524', NULL, 'Serine/threonine-protein kinase TOR', 195, NULL, NULL, 187504),
(187505, '3.40.630.190-FF-000002', NULL, 'LytR family transcriptional regulator', 298, NULL, NULL, 187505),
(187506, '3.30.160.60-FF-004265', NULL, NULL, 28, NULL, NULL, 187506),
(187507, '1.10.238.10-FF-000328', NULL, 'Calcium-binding EF hand family protein', 87, NULL, NULL, 187507),
(187508, '3.10.20.310-FF-000037', NULL, 'Heme/hemopexin transporter protein HuxB', 94, NULL, NULL, 187508),
(187509, '1.20.5.390-FF-000004', NULL, 'Optineurin', 67, NULL, NULL, 187509),
(187510, '3.30.70.330-FF-000312', NULL, 'RNA-binding protein 3 isoform X1', 125, NULL, NULL, 187510),
(187511, '1.25.10.10-FF-001593', NULL, 'Sil1, putative', 91, NULL, NULL, 187511),
(187512, '1.20.1270.220-FF-000010', NULL, 'IP01291p', 76, NULL, NULL, 187512),
(187513, '1.10.287.110-FF-000129', NULL, 'J domain-containing protein 1', 116, NULL, NULL, 187513),
(187514, '1.10.287.1490-FF-000061', NULL, 'Kinesin-like protein', 161, NULL, NULL, 187514),
(187515, '3.80.10.10-FF-003035', NULL, 'S-phase kinase-associated protein 2, E3 ubiquitin protein ligase', 165, NULL, NULL, 187515),
(187516, '3.40.50.1000-FF-000422', NULL, 'HAD family phosphatase', 123, NULL, NULL, 187516),
(187517, '3.20.20.70-FF-000268', NULL, 'Pyruvate carboxylase', 305, NULL, NULL, 187517),
(187518, '3.40.50.11350-FF-000047', NULL, 'Glycoprotein 6-alpha-L-fucosyltransferase, putative', 151, NULL, NULL, 187518),
(187519, '3.40.630.30-FF-000608', NULL, 'Uncharacterized protein', 59, NULL, NULL, 187519),
(187520, '3.40.640.10-FF-000103', NULL, 'L-allo-threonine aldolase', 251, NULL, NULL, 187520),
(187521, '3.40.50.2300-FF-001228', NULL, NULL, 211, NULL, NULL, 187521),
(187522, '2.60.40.150-FF-000250', NULL, 'copine-9 isoform X2', 67, NULL, NULL, 187522),
(187523, '2.60.40.10-FF-001865', NULL, 'Polycystin 1, transient receptor potential channel interacting', 82, NULL, NULL, 187523),
(187524, '2.130.10.10-FF-004046', NULL, 'Uncharacterized protein', 217, NULL, NULL, 187524),
(187525, '3.30.70.980-FF-000024', NULL, 'Probable transcriptional regulatory protein RPR_05505', 81, NULL, NULL, 187525),
(187526, '1.20.1110.10-FF-000226', NULL, NULL, 266, NULL, NULL, 187526),
(187527, '1.10.357.70-FF-000027', NULL, 'SEC6 homologue, putative', 169, NULL, NULL, 187527),
(187528, '3.40.50.1240-FF-000151', NULL, NULL, 163, NULL, NULL, 187528),
(187529, '3.30.505.10-FF-000179', NULL, NULL, 111, NULL, NULL, 187529),
(187530, '3.30.40.10-FF-001734', NULL, 'Histone-lysine N-methyltransferase', 108, NULL, NULL, 187530),
(187531, '2.180.10.10-FF-000025', NULL, 'Uncharacterized protein', 438, NULL, NULL, 187531),
(187532, '3.90.230.10-FF-000061', NULL, NULL, 67, NULL, NULL, 187532),
(187533, '3.30.830.10-FF-000075', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 224, NULL, NULL, 187533),
(187534, '3.40.50.970-FF-000003', NULL, 'Transketolase', 207, NULL, NULL, 187534),
(187535, '1.10.555.10-FF-000228', NULL, NULL, 242, NULL, NULL, 187535),
(187536, '1.25.40.10-FF-002235', NULL, 'Probable UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SPINDLY', 133, NULL, NULL, 187536),
(187537, '3.40.50.980-FF-000006', NULL, 'Enterobactin synthase component F', 133, NULL, NULL, 187537),
(187538, '2.30.30.40-FF-000525', NULL, 'Teichoic acids export ATP-binding protein TagH', 69, NULL, NULL, 187538),
(187539, '3.30.2410.10-FF-000032', NULL, 'E3 ubiquitin-protein ligase HACE1', 52, NULL, NULL, 187539);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(187540, '4.10.320.10-FF-000014', NULL, 'Hef nuclease', 36, NULL, NULL, 187540),
(187541, '3.90.550.10-FF-000528', NULL, 'Glycoside transferase family 2', 244, NULL, NULL, 187541),
(187542, '4.10.400.10-FF-000072', NULL, 'Low density lipoprotein receptor', 35, NULL, NULL, 187542),
(187543, '3.30.2340.10-FF-000003', NULL, 'tRNA pseudouridine synthase D', 84, NULL, NULL, 187543),
(187544, '3.50.30.30-FF-000076', NULL, 'Uncharacterized protein', 130, NULL, NULL, 187544),
(187545, '2.60.40.10-FF-000336', NULL, 'fibronectin isoform X1', 90, NULL, NULL, 187545),
(187546, '4.10.410.40-FF-000002', NULL, 'Lambda phage major tail protein V', 151, NULL, NULL, 187546),
(187547, '1.10.10.10-FF-000428', NULL, 'Zinc finger CCCH-type containing, antiviral 1', 70, NULL, NULL, 187547),
(187548, '2.130.10.10-FF-003973', NULL, 'Uncharacterized protein', 236, NULL, NULL, 187548),
(187549, '3.40.50.2020-FF-000161', NULL, 'Hypoxanthine-guanine phosphoribosyltransferase, putative', 64, NULL, NULL, 187549),
(187550, '2.60.120.260-FF-000033', NULL, 'E3 ubiquitin-protein ligase HERC2 isoform X2', 159, NULL, NULL, 187550),
(187551, '2.60.40.10-FF-004613', NULL, NULL, 93, NULL, NULL, 187551),
(187552, '2.60.40.10-FF-000813', NULL, 'Vesicle-associated protein 1-1', 129, NULL, NULL, 187552),
(187553, '3.30.160.60-FF-005676', NULL, NULL, 26, NULL, NULL, 187553),
(187554, '2.10.70.10-FF-000059', NULL, 'Thyroid peroxidase', 61, NULL, NULL, 187554),
(187555, '6.10.140.2220-FF-000049', NULL, 'MYND finger containing protein, putative', 48, NULL, NULL, 187555),
(187556, '3.90.1420.10-FF-000041', NULL, 'Rubisco small subunit N-methyltransferase', 151, NULL, NULL, 187556),
(187557, '3.30.160.60-FF-002500', NULL, 'Schnurri, isoform F', 29, NULL, NULL, 187557),
(187558, '2.30.29.30-FF-001183', NULL, 'Uncharacterized protein', 71, NULL, NULL, 187558),
(187559, '2.80.10.50-FF-000238', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 109, NULL, NULL, 187559),
(187560, '2.10.25.10-FF-001045', NULL, 'Fibulin 2', 44, NULL, NULL, 187560),
(187561, '2.130.10.10-FF-005575', NULL, 'Uncharacterized protein', 208, NULL, NULL, 187561),
(187562, '2.60.40.790-FF-000115', NULL, 'Uncharacterized protein, isoform C', 138, NULL, NULL, 187562),
(187563, '1.10.1420.10-FF-000044', NULL, 'Putative DNA mismatch repair protein', 213, NULL, NULL, 187563),
(187564, '1.10.510.10-FF-000664', NULL, 'Serine threonine protein kinase', 129, NULL, NULL, 187564),
(187565, '3.10.28.10-FF-000026', NULL, 'Intron-encoded DNA endonuclease aI5 alpha', 115, NULL, NULL, 187565),
(187566, '2.60.40.150-FF-000721', NULL, 'Uncharacterized protein', 126, NULL, NULL, 187566),
(187567, '3.30.530.20-FF-000151', NULL, 'Predicted protein', 175, NULL, NULL, 187567),
(187568, '2.60.120.380-FF-000086', NULL, 'Calpain 6', 103, NULL, NULL, 187568),
(187569, '1.10.1520.10-FF-000097', NULL, 'Os03g0121800 protein', 68, NULL, NULL, 187569),
(187570, '2.60.120.970-FF-000061', NULL, 'Predicted protein', 230, NULL, NULL, 187570),
(187571, '3.80.10.10-FF-003506', NULL, 'Uncharacterized protein', 185, NULL, NULL, 187571),
(187572, '3.40.50.10810-FF-000216', NULL, 'Uncharacterized protein', 83, NULL, NULL, 187572),
(187573, '3.30.160.60-FF-000881', NULL, 'Zinc finger protein 605', 27, NULL, NULL, 187573),
(187574, '3.30.200.20-FF-001374', NULL, 'Serine/threonine protein kinase', 86, NULL, NULL, 187574),
(187575, '3.40.50.150-FF-000415', NULL, '2-phytyl-1,4-beta-naphthoquinone methyltransferase, chloroplastic', 221, NULL, NULL, 187575),
(187576, '1.10.150.110-FF-000029', NULL, 'Pol lambda-related class X DNA repair polymerase', 67, NULL, NULL, 187576),
(187577, '3.30.420.40-FF-000171', NULL, 'Heat shock 70 kDa protein 4', 151, NULL, NULL, 187577),
(187578, '3.40.50.300-FF-002208', NULL, 'DNA helicase', 183, NULL, NULL, 187578),
(187579, '3.90.70.10-FF-000525', NULL, 'Ubiquitin carboxyl-terminal hydrolase 30', 316, NULL, NULL, 187579),
(187580, '3.30.160.60-FF-003899', NULL, NULL, 28, NULL, NULL, 187580),
(187581, '3.30.1490.70-FF-000009', NULL, 'DNA ligase', 19, NULL, NULL, 187581),
(187582, '3.40.50.450-FF-000084', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit alpha 2', 23, NULL, NULL, 187582);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(187583, '3.40.50.1820-FF-000010', NULL, 'Acyl-protein thioesterase 2', 226, NULL, NULL, 187583),
(187584, '1.25.10.10-FF-002632', NULL, 'Serine/threonine protein phosphatase 2A 55 kDa regulatory subunit B'' delta isoform', 124, NULL, NULL, 187584),
(187585, '1.25.10.10-FF-000491', NULL, 'RING-type E3 ubiquitin transferase', 186, NULL, NULL, 187585),
(187586, '3.30.40.10-FF-001263', NULL, 'E3 ubiquitin-protein ligase AMFR', 74, NULL, NULL, 187586),
(187587, '3.10.25.10-FF-000003', NULL, 'Methionyl-tRNA formyltransferase', 108, NULL, NULL, 187587),
(187588, '2.70.150.10-FF-000214', NULL, 'P-type ATPase, putative (Eurofung)', 110, NULL, NULL, 187588),
(187589, '3.40.30.10-FF-000839', NULL, 'Protein disulfide-isomerase', 128, NULL, NULL, 187589),
(187590, '3.30.420.80-FF-000025', NULL, 'Uncharacterized protein', 122, NULL, NULL, 187590),
(187591, '2.60.40.10-FF-006070', NULL, NULL, 94, NULL, NULL, 187591),
(187592, '3.20.20.70-FF-000739', NULL, NULL, 78, NULL, NULL, 187592),
(187593, '1.25.40.20-FF-000681', NULL, 'Os09g0337300 protein', 271, NULL, NULL, 187593),
(187594, '3.30.450.40-FF-000010', NULL, 'Phosphodiesterase', 179, NULL, NULL, 187594),
(187595, '3.30.1610.10-FF-000013', NULL, 'Uncharacterized protein', 155, NULL, NULL, 187595),
(187596, '3.30.420.10-FF-000639', NULL, NULL, 150, NULL, NULL, 187596),
(187597, '1.25.40.10-FF-003764', NULL, 'Pentatricopeptide repeat-containing protein 3, mitochondrial', 162, NULL, NULL, 187597),
(187598, '3.40.50.10090-FF-000079', NULL, 'Chromosome 12, whole genome shotgun sequence', 102, NULL, NULL, 187598),
(187599, '1.10.10.10-FF-000013', NULL, 'Paired box 8 isoform 1', 74, NULL, NULL, 187599),
(187600, '1.50.40.10-FF-000064', NULL, 'Mitochondrial tricarboxylate transporter (Ctp)', 231, NULL, NULL, 187600),
(187601, '2.40.170.20-FF-000107', NULL, 'TonB-dependent siderophore receptor', 540, NULL, NULL, 187601),
(187602, '1.10.1410.10-FF-000015', NULL, 'Terminal nucleotidyltransferase 4B', 120, NULL, NULL, 187602),
(187603, '2.60.40.1180-FF-000207', NULL, 'Alpha-mannosidase', 98, NULL, NULL, 187603),
(187604, '3.30.565.10-FF-000407', NULL, 'Sensor histidine kinase/response regulator, putative (AFU_orthologue AFUA_4G00660)', 141, NULL, NULL, 187604),
(187605, '2.10.25.10-FF-000966', NULL, 'Uncharacterized protein', 49, NULL, NULL, 187605),
(187606, '1.10.1200.210-FF-000002', NULL, 'Chaperonin-like RbcX protein 2, chloroplastic', 126, NULL, NULL, 187606),
(187607, '1.10.506.10-FF-000031', NULL, 'RAS protein activator like 3', 119, NULL, NULL, 187607),
(187608, '3.30.360.10-FF-000022', NULL, 'Oxidoreductase, NAD-binding', 178, NULL, NULL, 187608),
(187609, '2.20.25.240-FF-000015', NULL, 'Modifier of mdg4', 79, NULL, NULL, 187609),
(187610, '1.10.10.10-FF-000120', NULL, 'GntR family transcriptional regulator', 66, NULL, NULL, 187610),
(187611, '3.40.50.150-FF-000095', NULL, '2-methyl-6-phytyl-1,4-hydroquinone methyltransferase, chloroplastic-like', 191, NULL, NULL, 187611),
(187612, '3.40.1350.10-FF-000018', NULL, 'Mrr restriction system protein', 159, NULL, NULL, 187612),
(187613, '1.25.40.450-FF-000013', NULL, 'Uncharacterized protein', 111, NULL, NULL, 187613),
(187614, '1.20.5.730-FF-000005', NULL, 'RABaptiN (Rab effector)', 52, NULL, NULL, 187614),
(187615, '2.60.40.10-FF-003995', NULL, NULL, 100, NULL, NULL, 187615),
(187616, '1.20.960.40-FF-000002', NULL, 'LisH domain-containing protein FOPNL', 71, NULL, NULL, 187616),
(187617, '3.30.70.3290-FF-000021', NULL, 'Lovastatin diketide synthase LovF', 132, NULL, NULL, 187617),
(187618, '1.20.82.10-FF-000004', NULL, 'Uncharacterized protein', 54, NULL, NULL, 187618),
(187619, '1.10.510.10-FF-002047', NULL, NULL, 59, NULL, NULL, 187619),
(187620, '2.40.30.270-FF-000001', NULL, 'Immunoglobulin mu DNA-binding protein 2', 108, NULL, NULL, 187620),
(187621, '3.40.910.10-FF-000006', NULL, 'Probable deoxyhypusine synthase', 324, NULL, NULL, 187621),
(187622, '3.30.2320.10-FF-000002', NULL, 'Major capsid subunit', 107, NULL, NULL, 187622),
(187623, '3.30.360.20-FF-000025', NULL, NULL, 84, NULL, NULL, 187623),
(187624, '1.10.510.10-FF-001974', NULL, 'CMGC family protein kinase', 223, NULL, NULL, 187624);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(187625, '3.40.50.300-FF-000174', NULL, 'HPr kinase/phosphorylase', 178, NULL, NULL, 187625),
(187626, '3.40.50.1820-FF-001314', NULL, 'Uncharacterized protein', 261, NULL, NULL, 187626),
(187627, '3.80.10.10-FF-001472', NULL, 'Leucine-rich repeat protein (LRRP), putative', 135, NULL, NULL, 187627),
(187628, '3.90.550.50-FF-000063', NULL, 'Uncharacterized protein', 190, NULL, NULL, 187628),
(187629, '2.40.50.140-FF-001248', NULL, NULL, 91, NULL, NULL, 187629),
(187630, '2.120.10.80-FF-000150', NULL, 'Protein CBG04780', 152, NULL, NULL, 187630),
(187631, '3.30.1370.100-FF-000040', NULL, 'Chromosome 9, whole genome shotgun sequence', 132, NULL, NULL, 187631),
(187632, '1.10.510.10-FF-000445', NULL, 'MDIS1-interacting receptor like kinase 2', 197, NULL, NULL, 187632),
(187633, '2.40.30.10-FF-000117', NULL, 'Translation initiation factor IF-2, putative', 115, NULL, NULL, 187633),
(187634, '3.30.160.40-FF-000015', NULL, 'Hydroxymethylbilane synthase', 84, NULL, NULL, 187634),
(187635, '3.30.560.10-FF-000003', NULL, 'Blast:Glucose dehydrogenase', 315, NULL, NULL, 187635),
(187636, '1.10.418.10-FF-000202', NULL, 'Actin bundling protein', 117, NULL, NULL, 187636),
(187637, '3.30.160.60-FF-000572', NULL, 'Zinc finger and BTB domain containing 7C', 55, NULL, NULL, 187637),
(187638, '2.60.40.10-FF-005940', NULL, NULL, 97, NULL, NULL, 187638),
(187639, '1.20.1280.50-FF-000126', NULL, 'WGS project CABT00000000 data, contig 2.5', 80, NULL, NULL, 187639),
(187640, '1.10.1070.11-FF-000113', NULL, 'Serine/threonine-protein kinase Tel1', 193, NULL, NULL, 187640),
(187641, '1.10.20.10-FF-000255', NULL, NULL, 66, NULL, NULL, 187641),
(187642, '3.40.50.720-FF-000957', NULL, 'Glucose 1-dehydrogenase', 183, NULL, NULL, 187642),
(187643, '3.30.200.20-FF-002301', NULL, 'Uncharacterized protein', 17, NULL, NULL, 187643),
(187644, '2.70.170.10-FF-000070', NULL, 'Ligand-Gated ion Channel', 206, NULL, NULL, 187644),
(187645, '2.60.40.10-FF-000561', NULL, 'Neural cell adhesion molecule L1', 109, NULL, NULL, 187645),
(187646, '1.10.510.10-FF-004407', NULL, NULL, 81, NULL, NULL, 187646),
(187647, '2.40.10.10-FF-000470', NULL, 'Transmembrane protease serine 9-like Protein', 252, NULL, NULL, 187647),
(187648, '1.20.1250.20-FF-001228', NULL, 'Uncharacterized protein', 436, NULL, NULL, 187648),
(187649, '3.30.200.20-FF-001267', NULL, 'Serine/threonine-protein kinase', 96, NULL, NULL, 187649),
(187650, '3.30.160.60-FF-004372', NULL, NULL, 29, NULL, NULL, 187650),
(187651, '1.10.30.10-FF-000121', NULL, 'LD26355p', 86, NULL, NULL, 187651),
(187652, '2.60.120.330-FF-000077', NULL, '2-oxoglutarate-dependent dioxygenase DAO', 292, NULL, NULL, 187652),
(187653, '1.10.1370.30-FF-000040', NULL, 'Uncharacterized protein', 212, NULL, NULL, 187653),
(187654, '1.10.10.10-FF-000209', NULL, 'Regulatory protein RecX', 51, NULL, NULL, 187654),
(187655, '1.10.1450.10-FF-000124', NULL, 'Uncharacterized protein', 95, NULL, NULL, 187655),
(187656, '3.30.200.20-FF-000047', NULL, 'focal adhesion kinase 1 isoform X2', 92, NULL, NULL, 187656),
(187657, '2.130.10.10-FF-005356', NULL, 'Uncharacterized protein', 175, NULL, NULL, 187657),
(187658, '1.20.50.20-FF-000001', NULL, 'DNA primase', 59, NULL, NULL, 187658),
(187659, '2.10.70.10-FF-000278', NULL, 'Predicted protein', 61, NULL, NULL, 187659),
(187660, '1.10.510.10-FF-003789', NULL, NULL, 130, NULL, NULL, 187660),
(187661, '1.10.287.110-FF-000455', NULL, 'Uncharacterized protein', 46, NULL, NULL, 187661),
(187662, '3.40.50.150-FF-000106', NULL, 'Trans-aconitate 2-methyltransferase', 168, NULL, NULL, 187662),
(187663, '3.10.110.10-FF-000154', NULL, 'Uncharacterized protein', 123, NULL, NULL, 187663),
(187664, '2.60.40.60-FF-000345', NULL, 'Cadherin 2', 112, NULL, NULL, 187664),
(187665, '3.50.50.60-FF-001507', NULL, 'Flavin-containing monooxygenase', 23, NULL, NULL, 187665),
(187666, '3.40.50.1820-FF-000696', NULL, 'Uncharacterized protein', 171, NULL, NULL, 187666),
(187667, '3.40.50.300-FF-005755', NULL, 'Dynein-1-beta heavy chain, flagellar inner arm I1 complex', 127, NULL, NULL, 187667),
(187668, '1.10.510.10-FF-000136', NULL, 'mitogen-activated protein kinase 6', 229, NULL, NULL, 187668);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(187669, '3.30.310.220-FF-000003', NULL, 'YALI0E06519p', 122, NULL, NULL, 187669),
(187670, '3.30.70.330-FF-001931', NULL, NULL, 142, NULL, NULL, 187670),
(187671, '3.40.50.720-FF-001036', NULL, 'Saccharopine dehydrogenase', 63, NULL, NULL, 187671),
(187672, '3.30.200.20-FF-001576', NULL, 'Uncharacterized protein', 65, NULL, NULL, 187672),
(187673, '1.20.1110.10-FF-000119', NULL, NULL, 109, NULL, NULL, 187673),
(187674, '1.10.860.10-FF-000016', NULL, 'DNA primase', 142, NULL, NULL, 187674),
(187675, '3.40.640.10-FF-000322', NULL, 'Aspartate aminotransferase', 242, NULL, NULL, 187675),
(187676, '2.160.20.10-FF-000223', NULL, 'Glr0404 protein', 270, NULL, NULL, 187676),
(187677, '2.30.30.40-FF-000110', NULL, 'Cytoplasmic protein', 66, NULL, NULL, 187677),
(187678, '3.90.80.10-FF-000026', NULL, 'Pyrophosphatase (inorganic) 2', 51, NULL, NULL, 187678),
(187679, '3.60.21.50-FF-000015', NULL, 'DNA polymerase III (Delta) subunit (Eurofung)', 306, NULL, NULL, 187679),
(187680, '1.20.1640.10-FF-000002', NULL, 'Efflux pump membrane transporter', 207, NULL, NULL, 187680),
(187681, '1.10.579.10-FF-000002', NULL, 'Deoxyribodipyrimidine photolyase', 148, NULL, NULL, 187681),
(187682, '2.60.40.1230-FF-000026', NULL, 'Probable ADP-ribosylation factor-binding protein C1F3.05', 126, NULL, NULL, 187682),
(187683, '1.10.10.60-FF-000218', NULL, 'Myb transcription factor', 53, NULL, NULL, 187683),
(187684, '3.40.50.300-FF-004226', NULL, 'eukaryotic peptide chain release factor GTP-binding subunit ERF3A', 181, NULL, NULL, 187684),
(187685, '2.60.175.20-FF-000001', NULL, 'Major capsid protein L1', 401, NULL, NULL, 187685),
(187686, '3.40.50.10190-FF-000339', NULL, 'Pescadillo homolog', 57, NULL, NULL, 187686),
(187687, '3.40.50.1000-FF-000113', NULL, 'Putative haloacid dehalogenase-like hydrolase', 113, NULL, NULL, 187687),
(187688, '3.40.50.10190-FF-000087', NULL, 'DNA ligase', 84, NULL, NULL, 187688),
(187689, '3.20.20.10-FF-000076', NULL, 'Uncharacterized protein', 188, NULL, NULL, 187689),
(187690, '1.25.40.180-FF-000258', NULL, NULL, 252, NULL, NULL, 187690),
(187691, '3.90.226.10-FF-000062', NULL, '3-hydroxyisobutyryl-CoA hydrolase-like protein 3 mitochondrial', 367, NULL, NULL, 187691),
(187692, '2.130.10.10-FF-004810', NULL, 'Predicted protein', 142, NULL, NULL, 187692),
(187693, '3.30.70.330-FF-001622', NULL, NULL, 74, NULL, NULL, 187693),
(187694, '3.40.50.300-FF-006008', NULL, 'Predicted protein', 240, NULL, NULL, 187694),
(187695, '3.60.21.60-FF-000018', NULL, 'DNA polymerase alpha subunit B', 146, NULL, NULL, 187695),
(187696, '3.30.200.20-FF-001828', NULL, 'Uncharacterized protein', 39, NULL, NULL, 187696),
(187697, '2.60.40.10-FF-005917', NULL, NULL, 112, NULL, NULL, 187697),
(187698, '3.40.190.10-FF-000141', NULL, 'Taurine ABC transporter, periplasmic taurine-binding protein', 197, NULL, NULL, 187698),
(187699, '2.10.25.10-FF-001354', NULL, 'Cysteine-rich with EGF-like domain protein 2', 37, NULL, NULL, 187699),
(187700, '1.10.560.10-FF-000049', NULL, 'T-complex protein 1 subunitTheta, putative', 117, NULL, NULL, 187700),
(187701, '3.40.50.2300-FF-001447', NULL, NULL, 47, NULL, NULL, 187701),
(187702, '1.20.1070.10-FF-001481', NULL, 'Uncharacterized protein', 208, NULL, NULL, 187702),
(187703, '2.60.200.20-FF-000140', NULL, 'Serine/threonine-protein kinase RAD53', 154, NULL, NULL, 187703),
(187704, '3.30.160.60-FF-006406', NULL, NULL, 29, NULL, NULL, 187704),
(187705, '3.40.50.300-FF-007099', NULL, 'Uncharacterized protein', 188, NULL, NULL, 187705),
(187706, '1.20.5.780-FF-000014', NULL, 'FXYD domain-containing ion transport regulator', 58, NULL, NULL, 187706),
(187707, '2.10.25.10-FF-000747', NULL, 'Protein eyes shut homolog', 35, NULL, NULL, 187707),
(187708, '1.25.40.20-FF-000349', NULL, 'Predicted protein', 109, NULL, NULL, 187708),
(187709, '4.10.400.10-FF-000291', NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein-like Protein', 42, NULL, NULL, 187709),
(187710, '3.40.50.620-FF-000697', NULL, 'Aminoacyl-tRNA synthetase class Ib', 255, NULL, NULL, 187710),
(187711, '1.20.1250.20-FF-000975', NULL, 'Proton-dependent oligopeptide transport family protein', 520, NULL, NULL, 187711);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(187712, '2.30.30.1020-FF-000009', NULL, 'Related to CDC36-transcription factor', 194, NULL, NULL, 187712),
(187713, '2.60.120.10-FF-000417', NULL, 'bifunctional peptidase and (3S)-lysyl hydroxylase JMJD7 isoform X2', 250, NULL, NULL, 187713),
(187714, '3.50.50.60-FF-000889', NULL, 'Uncharacterized protein', 247, NULL, NULL, 187714),
(187715, '1.10.8.270-FF-000111', NULL, 'GTPase-activating protein, putative', 132, NULL, NULL, 187715),
(187716, '2.10.220.10-FF-000054', NULL, 'Fraser extracellular matrix complex subunit 1', 106, NULL, NULL, 187716),
(187717, '3.90.79.10-FF-000270', NULL, 'Uncharacterized protein', 102, NULL, NULL, 187717),
(187718, '1.25.40.10-FF-002128', NULL, 'Pentatricopeptide repeat-containing protein At1g33350', 73, NULL, NULL, 187718),
(187719, '1.10.8.720-FF-000055', NULL, 'Dynein heavy chain', 172, NULL, NULL, 187719),
(187720, '2.60.40.10-FF-005608', NULL, NULL, 121, NULL, NULL, 187720),
(187721, '3.30.160.60-FF-004624', NULL, NULL, 83, NULL, NULL, 187721),
(187722, '2.130.10.10-FF-002231', NULL, 'NACHT and WD domain protein', 106, NULL, NULL, 187722),
(187723, '1.20.120.140-FF-000024', NULL, 'Signal recognition particle receptor FtsY', 121, NULL, NULL, 187723),
(187724, '3.40.980.10-FF-000050', NULL, 'Flavin adenine dinucleotide synthetase 1', 154, NULL, NULL, 187724),
(187725, '1.10.8.10-FF-000265', NULL, 'Translation elongation factor EF-1 alpha/Tu, putative', 55, NULL, NULL, 187725),
(187726, '1.20.58.830-FF-000035', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 143, NULL, NULL, 187726),
(187727, '3.30.160.60-FF-002264', NULL, 'Uncharacterized protein', 28, NULL, NULL, 187727),
(187728, '3.30.420.40-FF-000480', NULL, 'Uncharacterized protein', 187, NULL, NULL, 187728),
(187729, '2.20.25.10-FF-000123', NULL, 'DNA-directed RNA polymerase subunit', 28, NULL, NULL, 187729),
(187730, '3.40.1110.10-FF-000259', NULL, NULL, 67, NULL, NULL, 187730),
(187731, '3.30.70.20-FF-000019', NULL, 'Ferredoxin-type protein NapG', 84, NULL, NULL, 187731),
(187732, '1.10.10.10-FF-000119', NULL, 'DNA damage and replication checkpoint protein', 73, NULL, NULL, 187732),
(187733, '1.20.58.1250-FF-000002', NULL, 'Tubulin-specific chaperone c, putative', 106, NULL, NULL, 187733),
(187734, '1.20.58.380-FF-000001', NULL, 'Flagellar protein FliT', 108, NULL, NULL, 187734),
(187735, '2.170.130.30-FF-000004', NULL, NULL, 139, NULL, NULL, 187735),
(187736, '2.60.40.10-FF-006103', NULL, NULL, 100, NULL, NULL, 187736),
(187737, '3.30.70.330-FF-001841', NULL, NULL, 116, NULL, NULL, 187737),
(187738, '3.40.50.1000-FF-000528', NULL, NULL, 140, NULL, NULL, 187738),
(187739, '3.90.79.10-FF-000051', NULL, 'Probable NADH pyrophosphatase', 128, NULL, NULL, 187739),
(187740, '2.60.200.20-FF-000117', NULL, 'FHA domain containing protein', 108, NULL, NULL, 187740),
(187741, '2.60.40.60-FF-000126', NULL, 'Cadherin-related family member 1', 106, NULL, NULL, 187741),
(187742, '2.60.120.920-FF-000068', NULL, 'SPRY domain', 222, NULL, NULL, 187742),
(187743, '3.40.50.1820-FF-001623', NULL, 'Uncharacterized protein', 48, NULL, NULL, 187743),
(187744, '2.40.100.10-FF-000050', NULL, 'Peptidyl-prolyl cis-trans isomerase', 178, NULL, NULL, 187744),
(187745, '3.30.559.10-FF-000011', NULL, '2-oxoglutarate dehydrogenase E1 component', 260, NULL, NULL, 187745),
(187746, '3.30.420.40-FF-000822', NULL, 'Phosphotransferase', 83, NULL, NULL, 187746),
(187747, '1.20.58.390-FF-000004', NULL, 'Gamma-aminobutyric acid receptor subunit beta-2 isoform A', 134, NULL, NULL, 187747),
(187748, '3.40.50.1980-FF-000120', NULL, 'Iron-siderophore ABC transporter substrate-binding protein', 189, NULL, NULL, 187748),
(187749, '1.25.40.10-FF-003455', NULL, 'Pentatricopeptide repeat-containing protein At4g21300', 120, NULL, NULL, 187749),
(187750, '3.10.580.10-FF-000195', NULL, 'Predicted protein', 102, NULL, NULL, 187750),
(187751, '1.25.10.10-FF-002323', NULL, 'LP05312p', 307, NULL, NULL, 187751),
(187752, '3.30.160.60-FF-006064', NULL, NULL, 73, NULL, NULL, 187752),
(187753, '1.25.40.10-FF-000217', NULL, 'Pentatricopeptide repeat domain-containing protein', 108, NULL, NULL, 187753);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(187754, '3.20.20.80-FF-000636', NULL, 'Glycosyl hydrolase superfamily protein', 111, NULL, NULL, 187754),
(187755, '1.20.1070.10-FF-001352', NULL, 'Uncharacterized protein', 267, NULL, NULL, 187755),
(187756, '3.20.20.70-FF-000633', NULL, NULL, 263, NULL, NULL, 187756),
(187757, '3.30.2350.20-FF-000052', NULL, NULL, 231, NULL, NULL, 187757),
(187758, '3.90.1010.20-FF-000001', NULL, 'Chlorophenol reductase', 153, NULL, NULL, 187758),
(187759, '1.20.58.2220-FF-000063', NULL, 'Uncharacterized protein', 406, NULL, NULL, 187759),
(187760, '3.90.1660.10-FF-000002', NULL, 'Coenzyme F420:L-glutamate ligase', 12, NULL, NULL, 187760),
(187761, '1.20.1310.10-FF-000123', NULL, NULL, 113, NULL, NULL, 187761),
(187762, '1.20.144.10-FF-000024', NULL, 'dolichyldiphosphatase 1 isoform X2', 70, NULL, NULL, 187762),
(187763, '1.10.150.20-FF-000010', NULL, 'DNA polymerase lambda', 58, NULL, NULL, 187763),
(187764, '2.40.50.100-FF-000213', NULL, 'Sugar ABC transporter, ATP-binding protein', 48, NULL, NULL, 187764),
(187765, '3.30.360.10-FF-000128', NULL, 'Glucose-6-phosphate 1-dehydrogenase', 34, NULL, NULL, 187765),
(187766, '2.40.110.10-FF-000022', NULL, 'Nitroalkane oxidase', 134, NULL, NULL, 187766),
(187767, '3.30.40.10-FF-000897', NULL, 'Ubiquitinyl hydrolase 1', 88, NULL, NULL, 187767),
(187768, '3.40.190.80-FF-000027', NULL, 'Inositol monophosphatase family protein', 115, NULL, NULL, 187768),
(187769, '1.10.510.10-FF-004155', NULL, NULL, 218, NULL, NULL, 187769),
(187770, '3.30.1330.20-FF-000051', NULL, 'Cell division protein FtsZ', 118, NULL, NULL, 187770),
(187771, '3.40.1060.10-FF-000007', NULL, 'Aconitate hydratase, mitochondrial', 120, NULL, NULL, 187771),
(187772, '3.30.160.60-FF-004063', NULL, 'Zinc finger protein 423', 81, NULL, NULL, 187772),
(187773, '1.20.1270.220-FF-000009', NULL, 'Transcription factor GTE6', 79, NULL, NULL, 187773),
(187774, '3.30.559.30-FF-000017', NULL, 'Phenolpthiocerol synthesis type-I polyketide synthase PPSE', 276, NULL, NULL, 187774),
(187775, '3.40.50.300-FF-008026', NULL, 'Uncharacterized protein', 139, NULL, NULL, 187775),
(187776, '2.40.50.730-FF-000025', NULL, 'DNA polymerase alpha subunit one', 77, NULL, NULL, 187776),
(187777, '2.30.30.40-FF-000216', NULL, 'growth arrest-specific protein 7 isoform X1', 59, NULL, NULL, 187777),
(187778, '2.60.40.340-FF-000003', NULL, 'NFkB p65 transcription factor', 175, NULL, NULL, 187778),
(187779, '1.20.1420.10-FF-000019', NULL, 'YLR287C-like protein', 165, NULL, NULL, 187779),
(187780, '3.80.10.10-FF-000848', NULL, 'Si:dkey-22a18.2', 170, NULL, NULL, 187780),
(187781, '1.25.40.20-FF-000333', NULL, 'ankyrin repeat domain-containing protein 13C isoform X2', 67, NULL, NULL, 187781),
(187782, '1.10.510.10-FF-002356', NULL, NULL, 190, NULL, NULL, 187782),
(187783, '1.25.40.10-FF-000330', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 153, NULL, NULL, 187783),
(187784, '3.90.1140.10-FF-000002', NULL, 'U6 snRNA phosphodiesterase', 193, NULL, NULL, 187784),
(187785, '3.40.50.410-FF-000297', NULL, 'Poly [ADP-ribose] polymerase', 177, NULL, NULL, 187785),
(187786, '2.40.30.10-FF-000336', NULL, 'Sulfate adenylyltransferase subunit 1', 104, NULL, NULL, 187786),
(187787, '3.30.200.20-FF-000412', NULL, 'interleukin-1 receptor-associated kinase-like 2', 97, NULL, NULL, 187787),
(187788, '1.20.1280.50-FF-000199', NULL, 'F-box only protein 6-like Protein', 43, NULL, NULL, 187788),
(187789, '3.80.10.10-FF-003254', NULL, 'Uncharacterized protein', 173, NULL, NULL, 187789),
(187790, '3.30.230.130-FF-000036', NULL, 'Cullin_family /Cullin_protein_neddylation_domain_containing_protein_-_putative', 176, NULL, NULL, 187790),
(187791, '1.20.5.190-FF-000023', NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', 46, NULL, NULL, 187791),
(187792, '3.30.500.10-FF-000011', NULL, 'Histocompatibility antigen 60b', 158, NULL, NULL, 187792),
(187793, '1.10.472.170-FF-000013', NULL, 'Transcription initiation factor IIB 5', 189, NULL, NULL, 187793),
(187794, '3.30.1140.60-FF-000019', NULL, 'F-actin-capping protein subunit alpha', 108, NULL, NULL, 187794);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(187795, '3.60.21.10-FF-000138', NULL, 'Calcineurin-like phosphoesterase', 272, NULL, NULL, 187795),
(187796, '3.90.1480.20-FF-000042', NULL, 'Uncharacterized protein', 279, NULL, NULL, 187796),
(187797, '1.10.3720.10-FF-000123', NULL, 'NitT/TauT family transport system permease protein', 195, NULL, NULL, 187797),
(187798, '1.20.120.1200-FF-000023', NULL, 'NADH-quinone oxidoreductase subunit J', 161, NULL, NULL, 187798),
(187799, '3.40.50.300-FF-006811', NULL, 'GTPase Rho, putative', 47, NULL, NULL, 187799),
(187800, '3.30.70.330-FF-001695', NULL, NULL, 98, NULL, NULL, 187800),
(187801, '2.130.10.10-FF-001865', NULL, 'Uncharacterized protein, isoform A', 68, NULL, NULL, 187801),
(187802, '3.30.70.330-FF-002313', NULL, NULL, 51, NULL, NULL, 187802),
(187803, '2.130.10.10-FF-005884', NULL, 'Predicted protein', 298, NULL, NULL, 187803),
(187804, '3.90.70.10-FF-000216', NULL, 'Pre-mRNA-splicing factor SAD1', 327, NULL, NULL, 187804),
(187805, '1.20.1250.20-FF-000756', NULL, 'Similar to MFS sugar transporter', 466, NULL, NULL, 187805),
(187806, '1.10.3080.10-FF-000080', NULL, 'Chloride channel protein', 457, NULL, NULL, 187806),
(187807, '1.20.58.390-FF-000190', NULL, 'Uncharacterized protein', 99, NULL, NULL, 187807),
(187808, '2.40.50.140-FF-000995', NULL, NULL, 102, NULL, NULL, 187808),
(187809, '1.25.40.10-FF-000127', NULL, 'anaphase-promoting complex subunit 5 isoform X1', 222, NULL, NULL, 187809),
(187810, '1.10.4020.10-FF-000008', NULL, 'Uncharacterized protein', 96, NULL, NULL, 187810),
(187811, '2.30.29.30-FF-001216', NULL, 'Uncharacterized protein', 107, NULL, NULL, 187811),
(187812, '3.30.1120.10-FF-000015', NULL, 'Arylsulfatase H', 29, NULL, NULL, 187812),
(187813, '3.30.70.80-FF-000032', NULL, 'Minor extracellular protease VpR', 112, NULL, NULL, 187813),
(187814, '1.20.5.340-FF-000091', NULL, 'Uncharacterized protein', 113, NULL, NULL, 187814),
(187815, '3.30.70.1730-FF-000065', NULL, 'Ribosomal protein L10 family protein', 54, NULL, NULL, 187815),
(187816, '2.130.10.10-FF-003664', NULL, 'Uncharacterized protein', 409, NULL, NULL, 187816),
(187817, '2.60.40.790-FF-000205', NULL, NULL, 36, NULL, NULL, 187817),
(187818, '3.90.980.20-FF-000002', NULL, 'Ash2 like, histone lysine methyltransferase complex subunit', 177, NULL, NULL, 187818),
(187819, '2.130.10.10-FF-002702', NULL, 'Ribosome biogenesis protein NSA1', 322, NULL, NULL, 187819),
(187820, '3.30.70.330-FF-001386', NULL, NULL, 85, NULL, NULL, 187820),
(187821, '3.40.720.10-FF-000267', NULL, 'Predicted protein', 439, NULL, NULL, 187821),
(187822, '3.90.1750.10-FF-000032', NULL, 'E3 ubiquitin-protein ligase UPL5', 145, NULL, NULL, 187822),
(187823, '2.60.40.60-FF-000216', NULL, 'protocadherin gamma-C5 isoform X1', 112, NULL, NULL, 187823),
(187824, '3.30.40.10-FF-001515', NULL, 'Uncharacterized protein', 73, NULL, NULL, 187824),
(187825, '3.30.1540.20-FF-000004', NULL, 'DNA mismatch repair protein Mlh3', 65, NULL, NULL, 187825),
(187826, '1.10.260.60-FF-000002', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', 124, NULL, NULL, 187826),
(187827, '1.50.40.10-FF-000373', NULL, 'Mitochondrial carrier', 217, NULL, NULL, 187827),
(187828, '3.30.505.10-FF-000073', NULL, 'Tyrosine-protein kinase', 115, NULL, NULL, 187828),
(187829, '3.90.1410.10-FF-000091', NULL, 'Rubisco large subunit N-methyltransferase', 253, NULL, NULL, 187829),
(187830, '1.25.70.10-FF-000045', NULL, 'Uncharacterized protein', 232, NULL, NULL, 187830),
(187831, '3.40.50.300-FF-002517', NULL, 'Genetic interactor of prohibitins 3, mitochondrial', 189, NULL, NULL, 187831),
(187832, '3.40.50.1100-FF-000008', NULL, 'L-threonine dehydratase', 189, NULL, NULL, 187832),
(187833, '3.10.100.10-FF-000125', NULL, 'Mannan-binding lectin H3', 142, NULL, NULL, 187833),
(187834, '2.20.60.10-FF-000002', NULL, 'Midkine a', 59, NULL, NULL, 187834),
(187835, '3.40.50.300-FF-001899', NULL, 'ATP dependent DEAD-box helicase, putative', 90, NULL, NULL, 187835),
(187836, '1.10.533.10-FF-000161', NULL, 'Uncharacterized protein', 105, NULL, NULL, 187836),
(187837, '3.30.1600.10-FF-000041', NULL, 'Sirtuin 7', 50, NULL, NULL, 187837); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(187838, '2.10.80.10-FF-000009', NULL, 'Colipase like 1', 88, NULL, NULL, 187838),
(187839, '2.60.120.920-FF-000158', NULL, 'Uncharacterized protein', 161, NULL, NULL, 187839),
(187840, '3.40.50.11990-FF-000008', NULL, 'Hyrax', 167, NULL, NULL, 187840),
(187841, '1.50.40.10-FF-000592', NULL, 'Uncharacterized protein', 206, NULL, NULL, 187841),
(187842, '2.10.50.10-FF-000171', NULL, 'Predicted protein', 69, NULL, NULL, 187842),
(187843, '3.30.420.10-FF-000078', NULL, 'Ribonuclease HII', 203, NULL, NULL, 187843),
(187844, '3.30.160.60-FF-003568', NULL, 'Predicted protein', 33, NULL, NULL, 187844),
(187845, '2.60.40.10-FF-002051', NULL, 'Mesocentin', 92, NULL, NULL, 187845),
(187846, '3.10.20.70-FF-000010', NULL, 'Glutamine synthetase', 113, NULL, NULL, 187846),
(187847, '3.40.720.10-FF-000177', NULL, '23-bisphosphoglycerate-independent phosphoglycerate mutase 1', 232, NULL, NULL, 187847),
(187848, '3.30.870.10-FF-000105', NULL, 'Phosphatidylcholine-hydrolyzing phospholipase D (PLD) protein', 140, NULL, NULL, 187848),
(187849, '1.20.58.60-FF-000828', NULL, 'Predicted protein', 172, NULL, NULL, 187849),
(187850, '1.10.510.10-FF-003992', NULL, NULL, 32, NULL, NULL, 187850),
(187851, '3.30.420.10-FF-000729', NULL, NULL, 314, NULL, NULL, 187851),
(187852, '3.60.21.10-FF-000380', NULL, 'Uncharacterized protein', 82, NULL, NULL, 187852),
(187853, '3.40.190.10-FF-000012', NULL, 'glutamate receptor ionotropic, NMDA 1 isoform X2', 158, NULL, NULL, 187853),
(187854, '3.20.20.70-FF-000178', NULL, 'Thiamine-phosphate synthase', 212, NULL, NULL, 187854),
(187855, '2.60.120.10-FF-000765', NULL, 'Uncharacterized protein', 61, NULL, NULL, 187855),
(187856, '1.25.40.570-FF-000049', NULL, 'Uncharacterized protein', 270, NULL, NULL, 187856),
(187857, '3.90.700.10-FF-000018', NULL, 'Uncharacterized protein', 74, NULL, NULL, 187857),
(187858, '1.20.920.10-FF-000098', NULL, 'SWI/SNF nucleosome remodeling complex component', 119, NULL, NULL, 187858),
(187859, '3.40.630.10-FF-000041', NULL, 'Carboxypeptidase M', 296, NULL, NULL, 187859),
(187860, '3.30.420.10-FF-000387', NULL, NULL, 89, NULL, NULL, 187860),
(187861, '1.10.150.80-FF-000022', NULL, 'Exosome complex exonuclease RRP6', 96, NULL, NULL, 187861),
(187862, '1.10.220.10-FF-000035', NULL, 'Uncharacterized protein', 88, NULL, NULL, 187862),
(187863, '3.40.50.1440-FF-000076', NULL, 'Tubulin beta-3 chain-like Protein', 391, NULL, NULL, 187863),
(187864, '1.25.10.10-FF-000502', NULL, 'TATA-binding protein-associated factor BTAF1', 181, NULL, NULL, 187864),
(187865, '1.10.1410.10-FF-000105', NULL, 'Uncharacterized protein', 166, NULL, NULL, 187865),
(187866, '3.40.1550.10-FF-000005', NULL, 'Two-component response regulator', 190, NULL, NULL, 187866),
(187867, '1.10.238.10-FF-000306', NULL, 'Solute carrier family 25 member 12', 156, NULL, NULL, 187867),
(187868, '3.40.30.10-FF-000862', NULL, 'Uncharacterized protein', 112, NULL, NULL, 187868),
(187869, '3.30.365.10-FF-000084', NULL, 'Predicted protein', 49, NULL, NULL, 187869),
(187870, '3.90.290.10-FF-000036', NULL, 'Follistatin', 60, NULL, NULL, 187870),
(187871, '1.20.1250.40-FF-000043', NULL, 'Uncharacterized protein', 147, NULL, NULL, 187871),
(187872, '1.50.40.10-FF-000283', NULL, 'Flavin adenine dinucleotide transporter', 229, NULL, NULL, 187872),
(187873, '3.40.50.1100-FF-000250', NULL, 'Uncharacterized protein', 17, NULL, NULL, 187873),
(187874, '4.10.60.10-FF-000211', NULL, 'Uncharacterized protein', 45, NULL, NULL, 187874),
(187875, '3.40.1280.30-FF-000018', NULL, 'Os02g0725600 protein', 128, NULL, NULL, 187875),
(187876, '1.10.510.10-FF-000810', NULL, 'Uncharacterized protein', 276, NULL, NULL, 187876),
(187877, '3.40.1550.20-FF-000008', NULL, 'Transcriptional regulator MraZ', 140, NULL, NULL, 187877),
(187878, '3.40.50.11980-FF-000005', NULL, 'CCAAT-box DNA binding protein subunit B', 141, NULL, NULL, 187878),
(187879, '3.10.20.80-FF-000013', NULL, 'Predicted protein', 62, NULL, NULL, 187879),
(187880, '3.40.630.30-FF-000518', NULL, 'N-acetyltransferase, GNAT family', 144, NULL, NULL, 187880),
(187881, '1.10.510.10-FF-004301', NULL, NULL, 158, NULL, NULL, 187881);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(187882, '3.20.20.70-FF-000487', NULL, NULL, 170, NULL, NULL, 187882),
(187883, '3.30.70.330-FF-002004', NULL, NULL, 84, NULL, NULL, 187883),
(187884, '3.30.565.10-FF-000301', NULL, 'Hybrid signal transduction histidine kinase B', 167, NULL, NULL, 187884),
(187885, '3.40.1110.10-FF-000478', NULL, NULL, 163, NULL, NULL, 187885),
(187886, '3.90.70.10-FF-000306', NULL, 'Uncharacterized protein', 101, NULL, NULL, 187886),
(187887, '1.10.10.10-FF-001755', NULL, 'Uncharacterized protein', 73, NULL, NULL, 187887),
(187888, '3.30.200.20-FF-000502', NULL, 'Tyrosine-protein kinase Drl', 95, NULL, NULL, 187888),
(187889, '1.50.10.10-FF-000236', NULL, 'alpha-1,2-Mannosidase', 96, NULL, NULL, 187889),
(187890, '3.30.497.10-FF-000041', NULL, 'Serpin 42Dc, isoform A', 193, NULL, NULL, 187890),
(187891, '2.60.40.10-FF-002360', NULL, 'Si:dkey-222p3.1', 114, NULL, NULL, 187891),
(187892, '3.40.50.10470-FF-000070', NULL, 'Uncharacterized protein', 172, NULL, NULL, 187892),
(187893, '3.40.50.150-FF-001489', NULL, NULL, 121, NULL, NULL, 187893),
(187894, '1.10.3430.10-FF-000022', NULL, 'Os01g0831300 protein', 211, NULL, NULL, 187894),
(187895, '2.60.40.10-FF-002270', NULL, 'Myotactin form B', 96, NULL, NULL, 187895),
(187896, '1.10.10.10-FF-002121', NULL, 'Putative asnC-family transcriptional regulator', 40, NULL, NULL, 187896),
(187897, '2.10.60.10-FF-000087', NULL, 'Serine/threonine-protein kinase receptor', 46, NULL, NULL, 187897),
(187898, '3.60.10.10-FF-000366', NULL, 'Uncharacterized protein', 120, NULL, NULL, 187898),
(187899, '3.40.50.620-FF-000011', NULL, 'Electron transfer flavoprotein subunit beta', 249, NULL, NULL, 187899),
(187900, '3.40.30.10-FF-000059', NULL, 'Thioredoxin-like protein', 139, NULL, NULL, 187900),
(187901, '1.10.167.10-FF-000023', NULL, 'Uncharacterized protein, isoform B', 212, NULL, NULL, 187901),
(187902, '3.40.50.1970-FF-000004', NULL, 'N5-carboxyaminoimidazole ribonucleotide mutase', 169, NULL, NULL, 187902),
(187903, '1.20.1740.10-FF-000167', NULL, 'Uncharacterized protein', 100, NULL, NULL, 187903),
(187904, '1.10.110.10-FF-000010', NULL, 'Bifunctional inhibitor/lipid-transfer protein/seed storage 2S albumin superfamily protein', 81, NULL, NULL, 187904),
(187905, '3.40.50.200-FF-000127', NULL, 'Clan SB, family S8, subtilisin-like serine peptidase', 158, NULL, NULL, 187905),
(187906, '1.10.506.10-FF-000008', NULL, 'RAS p21 protein activator 1', 119, NULL, NULL, 187906),
(187907, '2.130.10.10-FF-002337', NULL, 'Uncharacterized protein', 194, NULL, NULL, 187907),
(187908, '3.40.50.300-FF-007863', NULL, 'Uncharacterized protein', 211, NULL, NULL, 187908),
(187909, '3.30.40.10-FF-001605', NULL, 'Putative RING finger domain protein', 114, NULL, NULL, 187909),
(187910, '3.90.1150.120-FF-000001', NULL, 'Mediator of RNA polymerase II transcription subunit 17', 128, NULL, NULL, 187910),
(187911, '3.80.10.10-FF-002888', NULL, 'Uncharacterized protein', 123, NULL, NULL, 187911),
(187912, '2.170.270.10-FF-000137', NULL, 'Putative transcription factor blimp-1/prdi-bf1', 187, NULL, NULL, 187912),
(187913, '3.40.50.300-FF-002736', NULL, 'Spindle B', 250, NULL, NULL, 187913),
(187914, '2.170.260.10-FF-000002', NULL, 'Putative Endoribonuclease Dicer', 130, NULL, NULL, 187914),
(187915, '3.40.50.1980-FF-000007', NULL, 'Vitamin B12-binding protein', 126, NULL, NULL, 187915),
(187916, '1.20.58.390-FF-000313', NULL, 'Uncharacterized protein', 161, NULL, NULL, 187916),
(187917, '2.60.40.10-FF-002028', NULL, 'Twitchin', 91, NULL, NULL, 187917),
(187918, '1.10.510.10-FF-000900', NULL, 'Protein kinase C alpha', 87, NULL, NULL, 187918),
(187919, '3.30.310.50-FF-000036', NULL, 'Uncharacterized protein', 86, NULL, NULL, 187919),
(187920, '3.10.250.10-FF-000018', NULL, 'Complement factor I', 106, NULL, NULL, 187920),
(187921, '3.30.710.10-FF-000021', NULL, 'Zinc finger and BTB domain-containing protein 18', 148, NULL, NULL, 187921),
(187922, '3.40.50.1000-FF-000309', NULL, 'Glycosyl hydrolase, putative', 81, NULL, NULL, 187922),
(187923, '2.60.40.1730-FF-000069', NULL, NULL, 221, NULL, NULL, 187923),
(187924, '2.130.10.10-FF-002028', NULL, 'Transducin/WD40 repeat-like superfamily protein', 374, NULL, NULL, 187924);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(187925, '3.90.1200.10-FF-000058', NULL, 'Uncharacterized protein', 210, NULL, NULL, 187925),
(187926, '2.170.130.20-FF-000001', NULL, 'Cysteine-rich secretory protein LCCL domain-containing 1', 103, NULL, NULL, 187926),
(187927, '2.70.40.10-FF-000021', NULL, 'Gag-Pro polyprotein', 134, NULL, NULL, 187927),
(187928, '1.20.1070.10-FF-001043', NULL, 'delta-type opioid receptor', 240, NULL, NULL, 187928),
(187929, '1.10.287.110-FF-000040', NULL, 'dnaJ homolog subfamily B member 11', 102, NULL, NULL, 187929),
(187930, '3.30.9.10-FF-000263', NULL, 'Uncharacterized protein', 152, NULL, NULL, 187930),
(187931, '1.10.10.440-FF-000082', NULL, 'Pre-mRNA-processing factor 40, putative', 73, NULL, NULL, 187931),
(187932, '3.40.50.300-FF-002427', NULL, 'Dipeptide-transport ATP-binding protein ABC transporter dppD', 274, NULL, NULL, 187932),
(187933, '2.60.40.10-FF-002921', NULL, 'Uncharacterized protein, isoform C', 126, NULL, NULL, 187933),
(187934, '1.10.510.10-FF-003683', NULL, NULL, 169, NULL, NULL, 187934),
(187935, '1.10.472.10-FF-000013', NULL, 'Cyclin A1', 135, NULL, NULL, 187935),
(187936, '1.10.472.130-FF-000035', NULL, 'AGAP003271-PA', 167, NULL, NULL, 187936),
(187937, '1.10.8.710-FF-000035', NULL, NULL, 149, NULL, NULL, 187937),
(187938, '3.40.50.1000-FF-000652', NULL, NULL, 75, NULL, NULL, 187938),
(187939, '1.20.120.350-FF-000222', NULL, NULL, 47, NULL, NULL, 187939),
(187940, '3.20.20.10-FF-000065', NULL, 'Arginine decarboxylase', 262, NULL, NULL, 187940),
(187941, '1.25.10.10-FF-000406', NULL, 'transportin-3 isoform X2', 358, NULL, NULL, 187941),
(187942, '2.80.10.50-FF-000008', NULL, 'Fascin', 125, NULL, NULL, 187942),
(187943, '2.10.230.10-FF-000004', NULL, 'Molecular chaperone DnaJ', 77, NULL, NULL, 187943),
(187944, '3.30.160.60-FF-005917', NULL, NULL, 26, NULL, NULL, 187944),
(187945, '2.60.40.10-FF-004271', NULL, NULL, 119, NULL, NULL, 187945),
(187946, '3.40.50.300-FF-006339', NULL, 'Uncharacterized protein', 214, NULL, NULL, 187946),
(187947, '1.10.8.60-FF-000577', NULL, 'Os09g0533400 protein', 51, NULL, NULL, 187947),
(187948, '2.40.10.230-FF-000019', NULL, 'H/ACA ribonucleoprotein complex subunit', 92, NULL, NULL, 187948),
(187949, '1.10.287.70-FF-000729', NULL, 'Uncharacterized protein', 120, NULL, NULL, 187949),
(187950, '1.10.510.10-FF-004273', NULL, NULL, 179, NULL, NULL, 187950),
(187951, '3.40.50.10900-FF-000030', NULL, 'Uncharacterized protein', 134, NULL, NULL, 187951),
(187952, '2.130.10.10-FF-000550', NULL, 'WD repeat-containing protein 82-B', 244, NULL, NULL, 187952),
(187953, '1.25.40.10-FF-001971', NULL, 'Pentatricopeptide repeat-containing protein At1g04840', 128, NULL, NULL, 187953),
(187954, '1.20.120.1810-FF-000009', NULL, NULL, 147, NULL, NULL, 187954),
(187955, '2.30.30.140-FF-000263', NULL, 'Histone acetyltransferase esa1', 108, NULL, NULL, 187955),
(187956, '3.20.20.140-FF-000366', NULL, 'Putative capsular polysaccharide biosynthesis protein', 240, NULL, NULL, 187956),
(187957, '2.60.40.10-FF-005794', NULL, NULL, 84, NULL, NULL, 187957),
(187958, '1.20.1070.10-FF-001464', NULL, 'Predicted protein', 215, NULL, NULL, 187958),
(187959, '3.30.160.60-FF-006423', NULL, NULL, 24, NULL, NULL, 187959),
(187960, '1.10.3090.10-FF-000029', NULL, 'Uncharacterized protein', 261, NULL, NULL, 187960),
(187961, '3.90.76.10-FF-000038', NULL, 'ABC transporter substrate-binding protein', 130, NULL, NULL, 187961),
(187962, '3.30.200.20-FF-001823', NULL, 'Os07g0133000 protein', 51, NULL, NULL, 187962),
(187963, '3.40.50.300-FF-006244', NULL, 'Uncharacterized protein', 306, NULL, NULL, 187963),
(187964, '1.10.150.20-FF-000122', NULL, 'DNA-directed RNA polymerase subunit alpha', 83, NULL, NULL, 187964),
(187965, '3.40.1160.10-FF-000083', NULL, 'AaceriAAL061Cp', 96, NULL, NULL, 187965),
(187966, '3.10.105.10-FF-000092', NULL, 'Extracellular solute-binding protein family 5', 230, NULL, NULL, 187966),
(187967, '3.40.50.300-FF-004215', NULL, 'Predicted protein', 173, NULL, NULL, 187967),
(187968, '2.40.170.20-FF-000017', NULL, 'TonB-dependent siderophore receptor', 550, NULL, NULL, 187968);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(187969, '3.40.50.2000-FF-000868', NULL, 'Chromosome 7, whole genome shotgun sequence', 195, NULL, NULL, 187969),
(187970, '1.10.8.720-FF-000038', NULL, 'Dynein heavy chain, cytosolic, putative', 203, NULL, NULL, 187970),
(187971, '3.40.50.150-FF-000645', NULL, 'SAM-dependent methyltransferase', 239, NULL, NULL, 187971),
(187972, '1.20.1250.40-FF-000048', NULL, 'Uncharacterized protein', 77, NULL, NULL, 187972),
(187973, '3.30.160.40-FF-000010', NULL, 'Unplaced genomic scaffold supercont1.28, whole genome shotgun sequence', 115, NULL, NULL, 187973),
(187974, '2.60.260.20-FF-000014', NULL, 'dnaJ homolog subfamily B member 11', 83, NULL, NULL, 187974),
(187975, '1.10.10.60-FF-000213', NULL, 'Homeodomain-only protein', 54, NULL, NULL, 187975),
(187976, '2.60.120.920-FF-000057', NULL, 'E3 ubiquitin-protein ligase TRIM17', 186, NULL, NULL, 187976),
(187977, '2.120.10.30-FF-000163', NULL, 'Strictosidine synthase', 330, NULL, NULL, 187977),
(187978, '3.40.50.300-FF-002080', NULL, 'Uncharacterized protein', 293, NULL, NULL, 187978),
(187979, '3.40.50.300-FF-000842', NULL, 'ATP-dependent RNA helicase DRS1', 258, NULL, NULL, 187979),
(187980, '3.30.559.30-FF-000028', NULL, 'Non-ribosomal peptide synthetase OfaC', 231, NULL, NULL, 187980),
(187981, '3.30.40.10-FF-002111', NULL, 'PHd Finger family', 50, NULL, NULL, 187981),
(187982, '3.30.930.10-FF-000049', NULL, 'aspartate--tRNA ligase, mitochondrial', 290, NULL, NULL, 187982),
(187983, '1.25.40.20-FF-000451', NULL, 'Expressed protein', 185, NULL, NULL, 187983),
(187984, '1.10.400.10-FF-000015', NULL, 'G protein alpha subunit', 78, NULL, NULL, 187984),
(187985, '3.40.47.10-FF-000030', NULL, 'Acetyl-CoA acetyltransferase', 223, NULL, NULL, 187985),
(187986, '2.30.30.870-FF-000009', NULL, NULL, 135, NULL, NULL, 187986),
(187987, '2.130.10.10-FF-001747', NULL, 'Cytoplasmic protein', 328, NULL, NULL, 187987),
(187988, '3.90.260.10-FF-000006', NULL, 'Uncharacterized protein', 180, NULL, NULL, 187988),
(187989, '3.20.20.70-FF-000397', NULL, 'Putative 12-oxophytodienoate reductase-like protein 2A', 350, NULL, NULL, 187989),
(187990, '3.10.20.310-FF-000043', NULL, 'Uncharacterized protein', 88, NULL, NULL, 187990),
(187991, '1.10.1200.10-FF-000067', NULL, 'Nonribosomal peptide synthetase easA', 79, NULL, NULL, 187991),
(187992, '3.80.10.10-FF-003158', NULL, 'Uncharacterized protein', 284, NULL, NULL, 187992),
(187993, '1.20.1250.20-FF-001239', NULL, 'GM25658', 189, NULL, NULL, 187993),
(187994, '2.60.40.10-FF-005468', NULL, NULL, 103, NULL, NULL, 187994),
(187995, '3.30.200.20-FF-001918', NULL, NULL, 67, NULL, NULL, 187995),
(187996, '3.80.10.10-FF-001034', NULL, 'Leucine-rich receptor-like protein kinase family protein', 273, NULL, NULL, 187996),
(187997, '3.40.50.300-FF-000516', NULL, 'RAB33B, member RAS oncogene family', 195, NULL, NULL, 187997),
(187998, '3.40.50.880-FF-000201', NULL, 'Biotin--protein ligase', 219, NULL, NULL, 187998),
(187999, '3.40.30.120-FF-000003', NULL, 'Aklavinone 12-hydroxylase RdmE', 142, NULL, NULL, 187999),
(188000, '2.60.120.330-FF-000094', NULL, 'Oxidoreductase, 2OG-Fe(II) oxygenase family, putative', 165, NULL, NULL, 188000),
(188001, '1.20.1280.50-FF-000093', NULL, 'F-box/WD repeat-containing protein 5 isoform X1', 76, NULL, NULL, 188001),
(188002, '3.40.140.10-FF-000290', NULL, 'STAM-binding protein-like 1', 103, NULL, NULL, 188002),
(188003, '2.40.40.20-FF-000059', NULL, 'Vesicle-fusing ATPase', 94, NULL, NULL, 188003),
(188004, '3.30.750.44-FF-000026', NULL, NULL, 95, NULL, NULL, 188004),
(188005, '3.20.20.105-FF-000023', NULL, 'Uncharacterized protein', 151, NULL, NULL, 188005),
(188006, '3.40.50.1820-FF-001286', NULL, 'Carboxylic ester hydrolase', 286, NULL, NULL, 188006),
(188007, '3.30.572.10-FF-000014', NULL, 'Putative thymidylate synthase', 193, NULL, NULL, 188007),
(188008, '3.40.50.10330-FF-000073', NULL, 'Uncharacterized protein', 98, NULL, NULL, 188008),
(188009, '1.20.1250.20-FF-001470', NULL, 'Uncharacterized protein', 427, NULL, NULL, 188009),
(188010, '1.25.10.10-FF-001929', NULL, 'PIKK family atypical protein kinase', 149, NULL, NULL, 188010);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(188011, '1.20.1270.280-FF-000022', NULL, 'Dynein heavy chain, putative', 176, NULL, NULL, 188011),
(188012, '1.10.260.50-FF-000010', NULL, NULL, 46, NULL, NULL, 188012),
(188013, '3.50.4.10-FF-000044', NULL, NULL, 75, NULL, NULL, 188013),
(188014, '3.30.1330.40-FF-000068', NULL, 'Uncharacterized protein', 83, NULL, NULL, 188014),
(188015, '1.10.3500.10-FF-000028', NULL, 'Transcription elongation factor SPT6', 255, NULL, NULL, 188015),
(188016, '3.40.980.10-FF-000027', NULL, 'Molybdopterin molybdenumtransferase', 142, NULL, NULL, 188016),
(188017, '2.40.150.20-FF-000022', NULL, '60S ribosomal protein L23 isoform B', 75, NULL, NULL, 188017),
(188018, '3.40.50.300-FF-005738', NULL, 'Uncharacterized protein', 149, NULL, NULL, 188018),
(188019, '1.25.10.10-FF-000732', NULL, 'Unplaced genomic scaffold supercont2.16, whole genome shotgun sequence', 269, NULL, NULL, 188019),
(188020, '3.90.1600.10-FF-000010', NULL, 'DNA polymerase', 190, NULL, NULL, 188020),
(188021, '1.20.870.10-FF-000003', NULL, 'Ral guanine nucleotide dissociation stimulator isoform 1', 177, NULL, NULL, 188021),
(188022, '1.10.10.60-FF-000308', NULL, 'HTH-type transcriptional activator RhaR', 56, NULL, NULL, 188022),
(188023, '1.25.40.20-FF-000237', NULL, 'NF-kappa-B inhibitor epsilon', 229, NULL, NULL, 188023),
(188024, '4.10.1240.10-FF-000078', NULL, 'Uncharacterized protein', 57, NULL, NULL, 188024),
(188025, '1.20.1740.10-FF-000268', NULL, 'Uncharacterized protein', 317, NULL, NULL, 188025),
(188026, '3.40.390.10-FF-000010', NULL, '72 kDa type IV collagenase', 189, NULL, NULL, 188026),
(188027, '1.25.40.10-FF-000234', NULL, 'Bardet-Biedl syndrome 4 (Human)', 74, NULL, NULL, 188027),
(188028, '2.60.40.10-FF-000572', NULL, 'Platelet-derived growth factor receptor beta', 105, NULL, NULL, 188028),
(188029, '2.60.40.150-FF-000148', NULL, 'UV radiation resistance associated gene', 97, NULL, NULL, 188029),
(188030, '2.40.110.10-FF-000005', NULL, 'Acyl-coenzyme A oxidase', 138, NULL, NULL, 188030),
(188031, '1.10.630.10-FF-000746', NULL, 'Uncharacterized protein', 78, NULL, NULL, 188031),
(188032, '1.20.140.150-FF-000020', NULL, 'lipoma HMGIC fusion partner-like 2 protein', 208, NULL, NULL, 188032),
(188033, '3.50.50.60-FF-001373', NULL, 'Monooxygenase, putative', 156, NULL, NULL, 188033),
(188034, '3.30.210.10-FF-000011', NULL, 'Lmo1231 protein', 65, NULL, NULL, 188034),
(188035, '3.50.50.60-FF-001047', NULL, 'Uncharacterized protein', 25, NULL, NULL, 188035),
(188036, '1.25.40.150-FF-000007', NULL, 'Related to vacuolar ATP synthase subunit H', 102, NULL, NULL, 188036),
(188037, '2.40.10.10-FF-000228', NULL, 'Probable serine protease PepD (Serine proteinase) (MTB32B)', 102, NULL, NULL, 188037),
(188038, '3.30.200.20-FF-002071', NULL, 'Serine/threonine-protein kinase ppk33', 85, NULL, NULL, 188038),
(188039, '2.30.130.40-FF-000040', NULL, 'Os11g0219000 protein', 78, NULL, NULL, 188039),
(188040, '2.60.120.330-FF-000189', NULL, 'Flavonol synthase/flavanone 3-hydroxylase, putative, expressed', 178, NULL, NULL, 188040),
(188041, '1.10.510.10-FF-004059', NULL, NULL, 254, NULL, NULL, 188041),
(188042, '3.40.50.300-FF-003389', NULL, 'Helicase-like protein', 72, NULL, NULL, 188042),
(188043, '3.30.160.60-FF-002466', NULL, 'Zinc finger protein', 26, NULL, NULL, 188043),
(188044, '3.10.50.40-FF-000093', NULL, 'Peptidylprolyl isomerase', 74, NULL, NULL, 188044),
(188045, '3.30.160.60-FF-002354', NULL, 'Uncharacterized protein', 29, NULL, NULL, 188045),
(188046, '1.25.40.10-FF-001757', NULL, 'DNA-directed RNA polymerase', 156, NULL, NULL, 188046),
(188047, '3.30.420.40-FF-000160', NULL, 'Autoinducer-2 kinase', 247, NULL, NULL, 188047),
(188048, '3.50.50.60-FF-001159', NULL, 'Flavin-containing monooxygenase', 51, NULL, NULL, 188048),
(188049, '3.40.50.2300-FF-001666', NULL, NULL, 170, NULL, NULL, 188049),
(188050, '2.60.120.560-FF-000027', NULL, 'Galactocerebrosidase', 195, NULL, NULL, 188050),
(188051, '3.30.1330.20-FF-000062', NULL, 'Uncharacterized protein', 35, NULL, NULL, 188051),
(188052, '3.30.830.10-FF-000209', NULL, 'Peptidase, putative', 215, NULL, NULL, 188052);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(188053, '2.60.40.10-FF-001769', NULL, 'Interleukin-2 receptor subunit beta', 106, NULL, NULL, 188053),
(188054, '3.40.50.10260-FF-000023', NULL, 'Enhancer of mRNA-decapping protein, putative', 295, NULL, NULL, 188054),
(188055, '3.40.50.720-FF-001351', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase B, chloroplastic', 110, NULL, NULL, 188055),
(188056, '3.40.50.300-FF-002287', NULL, 'MIT domain protein', 35, NULL, NULL, 188056),
(188057, '1.20.1270.60-FF-000168', NULL, 'Sorting nexin 7', 230, NULL, NULL, 188057),
(188058, '2.70.150.10-FF-000181', NULL, 'P-type transport ATPase (Probable substrate copper/metal cation)', 81, NULL, NULL, 188058),
(188059, '2.10.25.160-FF-000010', NULL, 'Progranulin', 38, NULL, NULL, 188059),
(188060, '3.40.50.1000-FF-000326', NULL, 'Haloacid dehalogenase-like hydrolase domain-containing protein', 120, NULL, NULL, 188060),
(188061, '2.60.40.10-FF-004057', NULL, NULL, 96, NULL, NULL, 188061),
(188062, '3.40.50.300-FF-000163', NULL, 'Multidrug resistance-associated protein member 4', 253, NULL, NULL, 188062),
(188063, '1.10.10.10-FF-001396', NULL, 'Transcriptional regulator', 89, NULL, NULL, 188063),
(188064, '3.40.1110.10-FF-000467', NULL, NULL, 182, NULL, NULL, 188064),
(188065, '3.40.50.12710-FF-000039', NULL, 'Protein arginine methyltransferase NDUFAF7', 201, NULL, NULL, 188065),
(188066, '4.10.60.10-FF-000200', NULL, 'Branchpoint-bridging protein', 57, NULL, NULL, 188066),
(188067, '3.90.940.10-FF-000002', NULL, 'DNA-directed RNA polymerase subunit omega', 72, NULL, NULL, 188067),
(188068, '1.10.510.10-FF-000911', NULL, 'Serine/threonine kinase like domain containing 1', 195, NULL, NULL, 188068),
(188069, '3.40.50.1820-FF-001191', NULL, 'Clan SC, family S28, unassigned serine peptidase', 291, NULL, NULL, 188069),
(188070, '1.10.760.10-FF-000036', NULL, 'Thiosulfate dehydrogenase', 116, NULL, NULL, 188070),
(188071, '3.10.660.10-FF-000021', NULL, 'Uncharacterized protein', 44, NULL, NULL, 188071),
(188072, '3.30.1330.30-FF-000065', NULL, 'Nucleolar protein family A, member 2', 136, NULL, NULL, 188072),
(188073, '1.10.3210.10-FF-000023', NULL, 'HD family hydrolase', 178, NULL, NULL, 188073),
(188074, '3.40.50.11380-FF-000016', NULL, NULL, 176, NULL, NULL, 188074),
(188075, '2.10.90.10-FF-000038', NULL, 'Interleukin-17A', 127, NULL, NULL, 188075),
(188076, '2.130.10.10-FF-004602', NULL, 'Dynein assembly factor with WDR repeat domains 1', 203, NULL, NULL, 188076),
(188077, '3.60.21.10-FF-000144', NULL, 'Serine/threonine-protein phosphatase', 245, NULL, NULL, 188077),
(188078, '3.30.750.24-FF-000020', NULL, 'Anti-sigma factor antagonist', 104, NULL, NULL, 188078),
(188079, '1.10.405.10-FF-000004', NULL, 'Amine oxidase', 103, NULL, NULL, 188079),
(188080, '2.130.10.130-FF-000041', NULL, NULL, 89, NULL, NULL, 188080),
(188081, '2.60.40.1180-FF-000067', NULL, 'Alpha-galactosidase', 95, NULL, NULL, 188081),
(188082, '3.40.50.10110-FF-000006', NULL, 'DNA polymerase III subunit chi', 138, NULL, NULL, 188082),
(188083, '2.30.39.10-FF-000082', NULL, 'Putative non-inhibitory serpin-Z11', 147, NULL, NULL, 188083),
(188084, '2.10.70.10-FF-000155', NULL, 'Uncharacterized protein', 67, NULL, NULL, 188084),
(188085, '3.40.1110.10-FF-000355', NULL, NULL, 73, NULL, NULL, 188085),
(188086, '1.10.225.10-FF-000018', NULL, 'SaPosin-like Protein family', 76, NULL, NULL, 188086),
(188087, '1.20.1000.10-FF-000004', NULL, 'Interferon-induced guanylate-binding protein 1', 283, NULL, NULL, 188087),
(188088, '3.30.530.20-FF-000156', NULL, 'Uncharacterized protein', 148, NULL, NULL, 188088),
(188089, '1.10.555.10-FF-000088', NULL, 'RhoGAP domain containing protein', 213, NULL, NULL, 188089),
(188090, '3.30.300.10-FF-000018', NULL, 'GMP synthase (Glutamine-hydrolyzing) domain-containing protein', 115, NULL, NULL, 188090),
(188091, '1.20.140.40-FF-000018', NULL, 'Pectinesterase', 170, NULL, NULL, 188091),
(188092, '3.90.79.10-FF-000303', NULL, 'Uncharacterized protein', 51, NULL, NULL, 188092),
(188093, '3.80.10.10-FF-003372', NULL, 'Leucine-rich repeat-containing protein egg-6', 266, NULL, NULL, 188093);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(188094, '3.40.50.980-FF-000001', NULL, 'Non-ribosomal peptide synthetase', 135, NULL, NULL, 188094),
(188095, '1.25.40.10-FF-001645', NULL, 'Os04g0676200 protein', 150, NULL, NULL, 188095),
(188096, '1.10.510.10-FF-003458', NULL, NULL, 274, NULL, NULL, 188096),
(188097, '2.60.120.10-FF-000535', NULL, 'Cyclic nucleotide-binding domain containing protein, putative', 118, NULL, NULL, 188097),
(188098, '3.40.720.10-FF-000284', NULL, 'Uncharacterized protein', 290, NULL, NULL, 188098),
(188099, '3.40.50.410-FF-000196', NULL, 'Uncharacterized protein', 132, NULL, NULL, 188099),
(188100, '3.90.190.10-FF-000467', NULL, 'Predicted protein', 186, NULL, NULL, 188100),
(188101, '2.30.180.10-FF-000124', NULL, NULL, 151, NULL, NULL, 188101),
(188102, '2.130.10.10-FF-004035', NULL, 'Uncharacterized protein', 219, NULL, NULL, 188102),
(188103, '3.30.40.10-FF-000993', NULL, 'Uncharacterized protein', 65, NULL, NULL, 188103),
(188104, '2.60.120.620-FF-000074', NULL, 'Uncharacterized protein', 103, NULL, NULL, 188104),
(188105, '2.130.10.10-FF-001859', NULL, 'Serine/threonine-protein kinase VPS15', 178, NULL, NULL, 188105),
(188106, '3.30.200.20-FF-000300', NULL, 'Interleukin-1 receptor-associated kinase 1 (Predicted)', 101, NULL, NULL, 188106),
(188107, '2.60.120.920-FF-000169', NULL, 'Uncharacterized protein', 104, NULL, NULL, 188107),
(188108, '2.30.140.10-FF-000015', NULL, 'Putative spermidine synthase', 68, NULL, NULL, 188108),
(188109, '3.40.630.30-FF-000619', NULL, 'Uncharacterized protein', 186, NULL, NULL, 188109),
(188110, '3.90.550.10-FF-000079', NULL, 'Probable glycosyl transferase', 212, NULL, NULL, 188110),
(188111, '3.40.50.300-FF-000730', NULL, 'DNA replication and repair protein RecF', 147, NULL, NULL, 188111),
(188112, '3.10.100.10-FF-000114', NULL, 'Uncharacterized protein', 131, NULL, NULL, 188112),
(188113, '1.25.70.10-FF-000062', NULL, NULL, 148, NULL, NULL, 188113),
(188114, '3.30.70.980-FF-000041', NULL, 'Probable transcriptional regulatory protein CO678_22745', 68, NULL, NULL, 188114),
(188115, '3.20.20.70-FF-000285', NULL, 'GTP 3'',8-cyclase', 320, NULL, NULL, 188115),
(188116, '1.25.40.20-FF-000563', NULL, 'Gated outwardly-rectifying K+ channel', 127, NULL, NULL, 188116),
(188117, '1.10.510.10-FF-000232', NULL, 'Serine/threonine-protein kinase RIO1', 144, NULL, NULL, 188117),
(188118, '3.40.1570.10-FF-000001', NULL, 'Hemin degrading factor', 166, NULL, NULL, 188118),
(188119, '2.40.20.10-FF-000061', NULL, 'Predicted protein', 119, NULL, NULL, 188119),
(188120, '2.60.40.150-FF-000811', NULL, 'FAM62', 132, NULL, NULL, 188120),
(188121, '3.30.40.10-FF-000779', NULL, 'Cellulose synthase A catalytic subunit 1 [UDP-forming]', 92, NULL, NULL, 188121),
(188122, '1.10.8.520-FF-000001', NULL, 'ExsD', 72, NULL, NULL, 188122),
(188123, '2.60.40.1170-FF-000064', NULL, 'Mu-adaptin 1, putative', 145, NULL, NULL, 188123),
(188124, '2.40.10.10-FF-000133', NULL, 'Glyoxysomal processing protease glyoxysomal', 104, NULL, NULL, 188124),
(188125, '1.25.40.10-FF-000560', NULL, 'CNS1p TPR-containing co-chaperone', 149, NULL, NULL, 188125),
(188126, '3.40.50.300-FF-002192', NULL, 'Dynein beta chain, putative', 166, NULL, NULL, 188126),
(188127, '3.40.30.10-FF-001121', NULL, 'Glutathione peroxidase', 133, NULL, NULL, 188127),
(188128, '3.30.1490.100-FF-000010', NULL, 'DNA-directed polymerase kappa', 112, NULL, NULL, 188128),
(188129, '1.10.418.10-FF-000281', NULL, 'Uncharacterized protein', 70, NULL, NULL, 188129),
(188130, '3.60.20.10-FF-000187', NULL, NULL, 130, NULL, NULL, 188130),
(188131, '1.20.1530.20-FF-000103', NULL, 'Uncharacterized protein', 129, NULL, NULL, 188131),
(188132, '3.80.10.10-FF-001129', NULL, 'Uncharacterized protein', 154, NULL, NULL, 188132),
(188133, '3.30.70.330-FF-001829', NULL, NULL, 149, NULL, NULL, 188133),
(188134, '1.20.5.490-FF-000017', NULL, 'Uncharacterized protein', 33, NULL, NULL, 188134),
(188135, '1.25.40.10-FF-004500', NULL, 'Os09g0411600 protein', 93, NULL, NULL, 188135),
(188136, '3.30.70.3400-FF-000009', NULL, 'Protein translocase subunit SecD', 90, NULL, NULL, 188136);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(188137, '1.10.1070.11-FF-000017', NULL, 'Serine/threonine-protein kinase TOR', 177, NULL, NULL, 188137),
(188138, '3.30.1490.120-FF-000016', NULL, 'Predicted protein', 88, NULL, NULL, 188138),
(188139, '3.40.720.10-FF-000379', NULL, 'Predicted protein', 179, NULL, NULL, 188139),
(188140, '3.30.160.60-FF-004720', NULL, NULL, 24, NULL, NULL, 188140),
(188141, '3.50.30.30-FF-000109', NULL, 'Uncharacterized protein', 180, NULL, NULL, 188141),
(188142, '3.40.50.2300-FF-001571', NULL, NULL, 153, NULL, NULL, 188142),
(188143, '3.40.1370.10-FF-000020', NULL, '50S ribosomal protein L4', 233, NULL, NULL, 188143),
(188144, '3.40.50.2020-FF-000071', NULL, 'ribose-phosphate pyrophosphokinase 2', 94, NULL, NULL, 188144),
(188145, '1.10.3410.10-FF-000004', NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase-like protein', 111, NULL, NULL, 188145),
(188146, '1.10.287.160-FF-000015', NULL, 'Protein Kinase N (PKN) homolog', 73, NULL, NULL, 188146),
(188147, '3.20.20.80-FF-000288', NULL, 'Chitinase-like protein 3', 273, NULL, NULL, 188147),
(188148, '2.30.33.40-FF-000009', NULL, '10 kDa chaperonin', 103, NULL, NULL, 188148),
(188149, '3.40.525.10-FF-000032', NULL, 'IRA1p GTPase-activating protein', 119, NULL, NULL, 188149),
(188150, '1.10.287.90-FF-000027', NULL, 'Cytochrome c oxidase subunit 2', 87, NULL, NULL, 188150),
(188151, '3.40.605.10-FF-000084', NULL, 'Uncharacterized protein', 210, NULL, NULL, 188151),
(188152, '3.30.40.10-FF-001268', NULL, 'U-box domain-containing protein 48', 96, NULL, NULL, 188152),
(188153, '1.10.287.80-FF-000024', NULL, 'ATP synthase gamma chain', 64, NULL, NULL, 188153),
(188154, '3.40.50.10810-FF-000233', NULL, 'Swi/snf family helicase_2', 231, NULL, NULL, 188154),
(188155, '4.10.400.10-FF-000178', NULL, 'Tequila, isoform D', 38, NULL, NULL, 188155),
(188156, '3.30.70.580-FF-000011', NULL, 'tRNA pseudouridine synthase', 115, NULL, NULL, 188156),
(188157, '1.10.510.10-FF-002261', NULL, NULL, 109, NULL, NULL, 188157),
(188158, '2.120.10.80-FF-000054', NULL, 'Leucine-zipper-like transcription regulator 1', 183, NULL, NULL, 188158),
(188159, '3.40.630.30-FF-000378', NULL, 'GNAT family N-acetyltransferase', 160, NULL, NULL, 188159),
(188160, '2.40.50.140-FF-000062', NULL, 'DNA ligase', 160, NULL, NULL, 188160),
(188161, '1.20.1070.10-FF-000975', NULL, 'SERotonin/octopamine receptor family', 345, NULL, NULL, 188161),
(188162, '3.90.550.10-FF-000551', NULL, 'UDP-N-acetylglucosamine pyrophosphorylase 1', 285, NULL, NULL, 188162),
(188163, '3.40.50.10810-FF-000003', NULL, 'chromodomain-helicase-DNA-binding protein 8 isoform X4', 238, NULL, NULL, 188163),
(188164, '3.80.10.10-FF-001017', NULL, 'Tubulin-specific chaperone E', 140, NULL, NULL, 188164),
(188165, '3.40.50.10190-FF-000328', NULL, 'DNA ligase', 64, NULL, NULL, 188165),
(188166, '1.10.510.10-FF-003784', NULL, NULL, 132, NULL, NULL, 188166),
(188167, '2.40.40.20-FF-000076', NULL, 'Predicted protein', 87, NULL, NULL, 188167),
(188168, '1.20.58.1480-FF-000020', NULL, 'Lon protease homolog, mitochondrial', 116, NULL, NULL, 188168),
(188169, '2.30.180.10-FF-000096', NULL, NULL, 169, NULL, NULL, 188169),
(188170, '2.70.170.10-FF-000204', NULL, 'Predicted protein', 166, NULL, NULL, 188170),
(188171, '1.10.10.10-FF-000322', NULL, 'Probable disease resistance protein At1g63360', 90, NULL, NULL, 188171),
(188172, '1.20.120.1900-FF-000036', NULL, 'Spindle pole body component', 310, NULL, NULL, 188172),
(188173, '4.10.280.10-FF-000185', NULL, 'Uncharacterized protein', 69, NULL, NULL, 188173),
(188174, '1.10.150.50-FF-000148', NULL, 'Probable serine/threonine-protein kinase samkC', 79, NULL, NULL, 188174),
(188175, '3.30.420.110-FF-000023', NULL, 'DNA mismatch repair protein MutS', 134, NULL, NULL, 188175),
(188176, '2.30.110.10-FF-000064', NULL, 'Expressed protein', 97, NULL, NULL, 188176),
(188177, '2.70.130.10-FF-000084', NULL, NULL, 145, NULL, NULL, 188177),
(188178, '3.80.10.10-FF-002883', NULL, 'Uncharacterized protein', 68, NULL, NULL, 188178),
(188179, '3.10.20.90-FF-000347', NULL, 'Autophagy protein 5', 106, NULL, NULL, 188179);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(188180, '1.20.1250.20-FF-001453', NULL, 'MFS multidrug transporter, putative (AFU_orthologue AFUA_1G16910)', 232, NULL, NULL, 188180),
(188181, '2.10.220.10-FF-000144', NULL, 'Proprotein convertase subtilisin/kexin type 5', 52, NULL, NULL, 188181),
(188182, '3.40.50.720-FF-001137', NULL, 'Glutathione-regulated potassium-efflux system protein', 160, NULL, NULL, 188182),
(188183, '2.40.70.10-FF-000451', NULL, NULL, 149, NULL, NULL, 188183),
(188184, '2.160.20.10-FF-000004', NULL, 'Pectin lyase-like superfamily protein', 379, NULL, NULL, 188184),
(188185, '3.30.200.20-FF-001935', NULL, 'Uncharacterized protein', 38, NULL, NULL, 188185),
(188186, '3.30.250.20-FF-000011', NULL, 'Uncharacterized protein', 38, NULL, NULL, 188186),
(188187, '3.20.20.70-FF-000734', NULL, NULL, 85, NULL, NULL, 188187),
(188188, '3.30.60.30-FF-000191', NULL, 'Predicted protein', 56, NULL, NULL, 188188),
(188189, '3.40.50.300-FF-006132', NULL, 'Elongation factor G, domain IV family protein', 236, NULL, NULL, 188189),
(188190, '3.40.1080.10-FF-000014', NULL, 'Citrate lyase alpha chain', 270, NULL, NULL, 188190),
(188191, '1.25.40.10-FF-002600', NULL, 'Pentatricopeptide repeat-containing protein At4g04370', 107, NULL, NULL, 188191),
(188192, '3.30.70.330-FF-001588', NULL, NULL, 80, NULL, NULL, 188192),
(188193, '2.160.20.20-FF-000007', NULL, 'Autotransporting adhesin factor family member', 499, NULL, NULL, 188193),
(188194, '1.20.1280.50-FF-000216', NULL, 'F-box protein 7', 81, NULL, NULL, 188194),
(188195, '3.30.420.10-FF-000179', NULL, 'CAF1 family ribonuclease containing protein', 143, NULL, NULL, 188195),
(188196, '3.30.830.10-FF-000311', NULL, 'Uncharacterized protein', 31, NULL, NULL, 188196),
(188197, '3.30.420.100-FF-000020', NULL, '60S ribosomal protein L5', 49, NULL, NULL, 188197),
(188198, '2.20.28.40-FF-000003', NULL, 'H/ACA ribonucleoprotein complex subunit 3', 46, NULL, NULL, 188198),
(188199, '1.10.287.110-FF-000354', NULL, 'Chaperone protein DNAj, putative', 106, NULL, NULL, 188199),
(188200, '3.50.50.60-FF-000979', NULL, 'FAD/NAD(P)-binding domain-containing protein', 98, NULL, NULL, 188200),
(188201, '4.10.320.60-FF-000001', NULL, 'Sulfhydryl oxidase', 46, NULL, NULL, 188201),
(188202, '1.10.10.60-FF-000325', NULL, 'Double homeobox protein 4', 57, NULL, NULL, 188202),
(188203, '3.20.20.80-FF-000737', NULL, 'Glycosyl hydrolase', 86, NULL, NULL, 188203),
(188204, '3.40.250.10-FF-000197', NULL, 'Probable molybdopterin biosynthesis protein MoeB', 105, NULL, NULL, 188204),
(188205, '3.40.1390.20-FF-000018', NULL, 'HPr kinase/phosphorylase', 133, NULL, NULL, 188205),
(188206, '1.25.10.10-FF-001576', NULL, 'Os01g0626100 protein', 192, NULL, NULL, 188206),
(188207, '2.60.40.10-FF-001983', NULL, 'Titin homolog', 106, NULL, NULL, 188207),
(188208, '3.40.50.2300-FF-001245', NULL, NULL, 33, NULL, NULL, 188208),
(188209, '3.40.50.300-FF-007655', NULL, 'ATP-dependent DNA helicase DDX11', 129, NULL, NULL, 188209),
(188210, '2.40.10.10-FF-000245', NULL, 'Elastase, neutrophil expressed', 107, NULL, NULL, 188210),
(188211, '3.30.1300.10-FF-000017', NULL, NULL, 120, NULL, NULL, 188211),
(188212, '3.10.20.70-FF-000015', NULL, 'Putative glutamine synthetase', 111, NULL, NULL, 188212),
(188213, '1.20.1170.10-FF-000016', NULL, NULL, 122, NULL, NULL, 188213),
(188214, '3.40.640.10-FF-000120', NULL, 'Putative cystathionine beta-lyase', 246, NULL, NULL, 188214),
(188215, '3.40.50.300-FF-007879', NULL, 'Predicted protein', 201, NULL, NULL, 188215),
(188216, '3.80.20.20-FF-000104', NULL, 'Uncharacterized protein', 177, NULL, NULL, 188216),
(188217, '1.10.1450.10-FF-000001', NULL, 'Tetraspanin', 119, NULL, NULL, 188217),
(188218, '3.30.40.10-FF-001717', NULL, 'E3 ubiquitin-protein ligase TRIM36 isoform X1', 56, NULL, NULL, 188218),
(188219, '1.10.10.10-FF-000226', NULL, 'MarR family transcriptional regulator', 144, NULL, NULL, 188219),
(188220, '1.25.40.10-FF-002460', NULL, 'Os02g0468800 protein', 128, NULL, NULL, 188220),
(188221, '3.40.50.300-FF-002528', NULL, 'RAD50 double strand break repair protein', 162, NULL, NULL, 188221);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(188222, '2.60.40.10-FF-002500', NULL, 'AXL2p Integral plasma membrane protein', 110, NULL, NULL, 188222),
(188223, '3.40.630.10-FF-000046', NULL, 'transferrin receptor protein 2 isoform X1', 267, NULL, NULL, 188223),
(188224, '2.130.10.10-FF-000319', NULL, 'Phosphoinositide 3-kinase regulatory subunit 4', 173, NULL, NULL, 188224),
(188225, '1.25.50.20-FF-000070', NULL, 'Aminopeptidase', 321, NULL, NULL, 188225),
(188226, '1.10.510.10-FF-001985', NULL, 'Cell_division_protein_kinase_-_putative', 254, NULL, NULL, 188226),
(188227, '2.60.40.10-FF-003782', NULL, NULL, 105, NULL, NULL, 188227),
(188228, '3.30.160.60-FF-004832', NULL, NULL, 72, NULL, NULL, 188228),
(188229, '3.40.50.150-FF-000319', NULL, 'Fire dancer', 90, NULL, NULL, 188229),
(188230, '2.60.120.10-FF-000209', NULL, 'YML079W-like protein', 201, NULL, NULL, 188230),
(188231, '1.10.150.490-FF-000002', NULL, 'Gag polyprotein', 100, NULL, NULL, 188231),
(188232, '1.10.1410.10-FF-000004', NULL, 'terminal uridylyltransferase 4 isoform X2', 211, NULL, NULL, 188232),
(188233, '1.10.560.10-FF-000055', NULL, 'T-complex protein 1 subunit beta', 235, NULL, NULL, 188233),
(188234, '3.40.50.720-FF-001581', NULL, 'Oxidoreductase HTATIP2', 232, NULL, NULL, 188234),
(188235, '3.40.1160.10-FF-000066', NULL, 'Aspartokinase', 278, NULL, NULL, 188235),
(188236, '3.30.310.10-FF-000058', NULL, 'Uncharacterized protein', 36, NULL, NULL, 188236),
(188237, '3.30.420.10-FF-000628', NULL, NULL, 332, NULL, NULL, 188237),
(188238, '3.30.1360.210-FF-000008', NULL, '60S ribosomal protein L22-2', 83, NULL, NULL, 188238),
(188239, '1.10.10.2100-FF-000001', NULL, 'Nucleophosmin 1', 54, NULL, NULL, 188239),
(188240, '3.30.160.60-FF-002371', NULL, NULL, 30, NULL, NULL, 188240),
(188241, '1.25.10.10-FF-000053', NULL, 'Importin 7', 989, NULL, NULL, 188241),
(188242, '1.20.1560.10-FF-000849', NULL, 'Predicted protein', 328, NULL, NULL, 188242),
(188243, '3.20.20.140-FF-000383', NULL, 'GH06023p', 182, NULL, NULL, 188243),
(188244, '3.90.70.10-FF-000643', NULL, 'Uncharacterized protein', 103, NULL, NULL, 188244),
(188245, '1.20.1560.10-FF-000945', NULL, 'Uncharacterized protein', 173, NULL, NULL, 188245),
(188246, '1.20.140.80-FF-000002', NULL, 'Transcription factor-like protein DPB', 125, NULL, NULL, 188246),
(188247, '2.40.33.10-FF-000040', NULL, 'Pyruvate kinase', 55, NULL, NULL, 188247),
(188248, '1.10.8.60-FF-000139', NULL, 'Fis family transcriptional regulator', 75, NULL, NULL, 188248),
(188249, '1.10.540.10-FF-000059', NULL, 'Acyl-CoA dehydrogenase, mitochondrial,putative', 96, NULL, NULL, 188249),
(188250, '3.40.190.10-FF-000124', NULL, 'Amino acid ABC transporter substrate-binding protein', 98, NULL, NULL, 188250),
(188251, '1.25.40.10-FF-004045', NULL, 'Uncharacterized protein', 175, NULL, NULL, 188251),
(188252, '3.40.50.920-FF-000011', NULL, 'Transketolase', 127, NULL, NULL, 188252),
(188253, '3.40.50.300-FF-008470', NULL, 'Putative ABC transporter', 235, NULL, NULL, 188253),
(188254, '3.40.50.1010-FF-000217', NULL, NULL, 130, NULL, NULL, 188254),
(188255, '1.10.455.10-FF-000041', NULL, 'Predicted protein', 211, NULL, NULL, 188255),
(188256, '1.25.40.10-FF-001869', NULL, 'Peroxisomal biogenesis factor 5 isoform d', 212, NULL, NULL, 188256),
(188257, '3.30.420.40-FF-000272', NULL, 'Actin-like protein, putative', 59, NULL, NULL, 188257),
(188258, '2.20.80.10-FF-000003', NULL, 'Apolipoprotein lipid transfer particle', 216, NULL, NULL, 188258),
(188259, '3.40.50.1100-FF-000126', NULL, 'Cystathionine beta-synthase', 114, NULL, NULL, 188259),
(188260, '1.20.1070.10-FF-001138', NULL, 'G-protein coupled receptor 15', 350, NULL, NULL, 188260),
(188261, '3.20.20.70-FF-000408', NULL, 'L-2-keto-3-deoxyarabonate dehydratase', 309, NULL, NULL, 188261),
(188262, '1.10.533.10-FF-000043', NULL, 'Tumor necrosis factor receptor superfamily member 10A', 96, NULL, NULL, 188262),
(188263, '1.25.40.10-FF-003769', NULL, 'Uncharacterized protein', 159, NULL, NULL, 188263),
(188264, '1.20.140.90-FF-000005', NULL, 'Predicted protein', 86, NULL, NULL, 188264),
(188265, '2.130.10.10-FF-002236', NULL, 'Transducin/WD40 repeat-like superfamily protein', 311, NULL, NULL, 188265);
INSERT INTO "PUBLIC"."MODEL" VALUES
(188266, '1.10.510.10-FF-001659', NULL, 'Serine/threonine protein kinase', 186, NULL, NULL, 188266),
(188267, '1.10.238.10-FF-000295', NULL, 'Myosin-2 essential light chain', 80, NULL, NULL, 188267),
(188268, '3.60.21.60-FF-000035', NULL, 'DNA polymerase alpha subunit B', 165, NULL, NULL, 188268),
(188269, '3.40.50.300-FF-006570', NULL, 'Predicted protein', 345, NULL, NULL, 188269),
(188270, '3.80.10.10-FF-002557', NULL, 'TOLl (Drosophila) family', 141, NULL, NULL, 188270),
(188271, '3.40.50.1000-FF-000214', NULL, '4-nitrophenylphosphatase', 128, NULL, NULL, 188271),
(188272, '2.60.40.10-FF-001657', NULL, 'Neuromusculin, isoform E', 108, NULL, NULL, 188272),
(188273, '2.60.40.10-FF-000246', NULL, 'Fibroblast growth factor receptor like 1', 118, NULL, NULL, 188273),
(188274, '2.10.90.10-FF-000055', NULL, 'Placenta growth factor', 112, NULL, NULL, 188274),
(188275, '2.60.120.10-FF-000647', NULL, 'Uncharacterized protein', 150, NULL, NULL, 188275),
(188276, '3.40.50.300-FF-004541', NULL, 'Peroxisome assembly protein Pex1p', 171, NULL, NULL, 188276),
(188277, '1.20.1270.280-FF-000005', NULL, 'Dynein axonemal heavy chain 10', 166, NULL, NULL, 188277),
(188278, '2.70.150.10-FF-000208', NULL, 'Phospholipid-transporting ATPase IA, putative', 123, NULL, NULL, 188278),
(188279, '3.40.220.20-FF-000001', NULL, 'Replicase polyprotein 1a', 128, NULL, NULL, 188279),
(188280, '1.25.40.10-FF-003562', NULL, 'Clustered mitochondria protein homolog', 249, NULL, NULL, 188280),
(188281, '2.130.10.10-FF-000336', NULL, 'Neutral sphingomyelinase activation-associated factor', 180, NULL, NULL, 188281),
(188282, '4.10.400.10-FF-000274', NULL, 'Uncharacterized protein', 29, NULL, NULL, 188282),
(188283, '1.20.1070.10-FF-000649', NULL, 'Uncharacterized protein', 306, NULL, NULL, 188283),
(188284, '1.10.730.10-FF-000113', NULL, 'Valyl-tRNA synthetase 2, mitochondrial (putative)', 242, NULL, NULL, 188284),
(188285, '1.10.10.440-FF-000003', NULL, 'Pre-mRNA processing factor 40 homolog A', 83, NULL, NULL, 188285),
(188286, '2.30.30.1020-FF-000026', NULL, NULL, 136, NULL, NULL, 188286),
(188287, '1.20.5.190-FF-000034', NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', 50, NULL, NULL, 188287),
(188288, '3.30.160.60-FF-004271', NULL, NULL, 28, NULL, NULL, 188288),
(188289, '1.20.120.350-FF-000194', NULL, NULL, 146, NULL, NULL, 188289),
(188290, '3.20.20.220-FF-000064', NULL, 'Methylenetetrahydrofolate reductase 2', 215, NULL, NULL, 188290),
(188291, '3.90.550.10-FF-000096', NULL, 'Glycosyltransferases', 270, NULL, NULL, 188291),
(188292, '3.30.1360.120-FF-000072', NULL, 'Glycine cleavage T protein, putative', 177, NULL, NULL, 188292),
(188293, '1.10.238.10-FF-000418', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 75, NULL, NULL, 188293),
(188294, '3.30.40.10-FF-001594', NULL, 'PHD zinc finger-containing protein', 95, NULL, NULL, 188294),
(188295, '3.60.21.10-FF-000256', NULL, 'Kinetoplastid-specific phospho-protein phosphatase, putative', 283, NULL, NULL, 188295),
(188296, '3.80.10.10-FF-001455', NULL, 'Glycoprotein V platelet', 265, NULL, NULL, 188296),
(188297, '3.40.50.1580-FF-000011', NULL, 'Purine nucleoside phosphorylase', 277, NULL, NULL, 188297),
(188298, '3.30.420.40-FF-000401', NULL, 'Actin, putative', 117, NULL, NULL, 188298),
(188299, '3.80.10.10-FF-000966', NULL, 'Uncharacterized protein', 93, NULL, NULL, 188299),
(188300, '3.30.230.70-FF-000114', NULL, 'Uncharacterized protein', 252, NULL, NULL, 188300),
(188301, '3.10.50.40-FF-000076', NULL, 'Peptidylprolyl isomerase', 106, NULL, NULL, 188301),
(188302, '3.60.15.10-FF-000101', NULL, 'Putative metallo-beta-lactamase domain protein', 236, NULL, NULL, 188302),
(188303, '3.80.10.10-FF-003046', NULL, 'Uncharacterized protein', 155, NULL, NULL, 188303),
(188304, '3.30.70.1660-FF-000009', NULL, 'Peptide chain release factor H', 99, NULL, NULL, 188304),
(188305, '3.10.20.90-FF-000914', NULL, 'Predicted protein', 129, NULL, NULL, 188305),
(188306, '3.40.710.10-FF-000098', NULL, 'PROBABLE ESTERASE LIPL', 378, NULL, NULL, 188306);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(188307, '1.25.40.20-FF-000125', NULL, 'Putative espin', 100, NULL, NULL, 188307),
(188308, '1.10.287.70-FF-000488', NULL, 'Ionotropic receptor 67c', 159, NULL, NULL, 188308),
(188309, '2.40.30.10-FF-000128', NULL, '50S ribosomal protein L3', 107, NULL, NULL, 188309),
(188310, '3.40.50.300-FF-007981', NULL, 'Phosphodiesterase', 158, NULL, NULL, 188310),
(188311, '3.30.200.20-FF-000272', NULL, 'Cyclin-dependent kinase C-2', 110, NULL, NULL, 188311),
(188312, '3.40.50.1240-FF-000140', NULL, NULL, 226, NULL, NULL, 188312),
(188313, '3.10.180.10-FF-000102', NULL, 'Putative lyase', 127, NULL, NULL, 188313),
(188314, '3.30.9.10-FF-000145', NULL, 'Glycine oxidase', 140, NULL, NULL, 188314),
(188315, '1.20.1250.20-FF-000964', NULL, 'MFS transporter', 254, NULL, NULL, 188315),
(188316, '1.20.5.110-FF-000179', NULL, 'AGAP006100-PA', 62, NULL, NULL, 188316),
(188317, '2.180.10.10-FF-000008', NULL, 'Odz, odd Oz/ten-m homolog', 216, NULL, NULL, 188317),
(188318, '3.40.30.10-FF-000183', NULL, 'NADH-quinone oxidoreductase subunit NuoE', 84, NULL, NULL, 188318),
(188319, '1.20.120.140-FF-000035', NULL, 'Signal recognition particle receptor FtsY', 96, NULL, NULL, 188319),
(188320, '3.40.50.720-FF-001704', NULL, 'UDP-glucose dehydrogenase Ugd1, putative (AFU_orthologue AFUA_8G00920)', 174, NULL, NULL, 188320),
(188321, '3.30.1140.60-FF-000020', NULL, 'F-actin-capping protein subunit alpha', 98, NULL, NULL, 188321),
(188322, '1.10.8.270-FF-000100', NULL, 'Uncharacterized protein', 129, NULL, NULL, 188322),
(188323, '2.60.40.10-FF-000342', NULL, 'Junctional adhesion molecule A', 104, NULL, NULL, 188323),
(188324, '2.130.10.10-FF-004361', NULL, 'Uncharacterized protein', 90, NULL, NULL, 188324),
(188325, '2.30.30.40-FF-000430', NULL, 'Chemotaxis protein CheW', 55, NULL, NULL, 188325),
(188326, '3.40.50.1010-FF-000088', NULL, 'Unplaced genomic scaffold supercont1.6, whole genome shotgun sequence', 157, NULL, NULL, 188326),
(188327, '1.50.40.10-FF-000513', NULL, 'Solute carrier family 25 member 22b', 258, NULL, NULL, 188327),
(188328, '3.40.50.1820-FF-001174', NULL, 'Predicted protein', 279, NULL, NULL, 188328),
(188329, '1.20.1000.10-FF-000021', NULL, 'Uncharacterized protein', 341, NULL, NULL, 188329),
(188330, '3.30.40.10-FF-001510', NULL, 'Uncharacterized protein', 74, NULL, NULL, 188330),
(188331, '1.25.40.990-FF-000034', NULL, 'Hypothetical_protein_-_conserved', 338, NULL, NULL, 188331),
(188332, '3.40.50.150-FF-000196', NULL, 'methyltransferase-like protein 17, mitochondrial', 154, NULL, NULL, 188332),
(188333, '3.30.160.60-FF-003989', NULL, NULL, 65, NULL, NULL, 188333),
(188334, '3.90.70.10-FF-000076', NULL, 'Ubiquitin carboxyl-terminal hydrolase 32', 133, NULL, NULL, 188334),
(188335, '3.20.200.10-FF-000007', NULL, 'Elongation factor 2 kinase, putative', 114, NULL, NULL, 188335),
(188336, '3.30.160.270-FF-000005', NULL, '2-isopropylmalate synthase', 108, NULL, NULL, 188336),
(188337, '1.20.120.1910-FF-000039', NULL, 'Uncharacterized protein', 129, NULL, NULL, 188337),
(188338, '3.40.50.1000-FF-000085', NULL, 'Membrane-associated phosphatidylinositol transfer protein 3', 100, NULL, NULL, 188338),
(188339, '3.30.930.10-FF-000375', NULL, 'Uncharacterized protein', 161, NULL, NULL, 188339),
(188340, '3.40.50.300-FF-000393', NULL, 'ADP-ribosylation factor-like 2, arl2', 178, NULL, NULL, 188340),
(188341, '3.30.70.330-FF-001381', NULL, 'AGAP002654-PB', 109, NULL, NULL, 188341),
(188342, '1.25.10.10-FF-000620', NULL, 'ARM repeat superfamily protein', 644, NULL, NULL, 188342),
(188343, '3.90.550.10-FF-000321', NULL, 'Glycosyl transferase', 239, NULL, NULL, 188343),
(188344, '1.25.40.10-FF-000122', NULL, 'DnaJ (Hsp40) homolog, subfamily C, member 3', 357, NULL, NULL, 188344),
(188345, '2.60.120.380-FF-000081', NULL, 'Putative calpain-like cysteine peptidase', 201, NULL, NULL, 188345),
(188346, '2.60.40.60-FF-000328', NULL, 'CaDHerin family', 112, NULL, NULL, 188346),
(188347, '3.40.50.2300-FF-000143', NULL, 'DNA-binding response regulator CiaR', 84, NULL, NULL, 188347),
(188348, '1.10.10.10-FF-000552', NULL, 'Putative transcriptional regulator', 103, NULL, NULL, 188348);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(188349, '3.40.50.1110-FF-000129', NULL, 'Uncharacterized protein', 236, NULL, NULL, 188349),
(188350, '3.40.50.280-FF-000004', NULL, 'Methionine synthase', 141, NULL, NULL, 188350),
(188351, '2.70.170.10-FF-000081', NULL, 'Ligand-Gated ion Channel', 201, NULL, NULL, 188351),
(188352, '3.90.1420.10-FF-000024', NULL, 'Putative countin receptor Cnr9', 169, NULL, NULL, 188352),
(188353, '3.30.160.60-FF-002707', NULL, 'IKAROS family zinc finger 4', 24, NULL, NULL, 188353),
(188354, '1.25.10.10-FF-002082', NULL, 'Uncharacterized protein, isoform B', 363, NULL, NULL, 188354),
(188355, '3.50.50.60-FF-001485', NULL, 'Uncharacterized protein', 49, NULL, NULL, 188355),
(188356, '3.30.160.60-FF-000342', NULL, 'zinc finger protein 394', 28, NULL, NULL, 188356),
(188357, '3.30.2410.10-FF-000026', NULL, 'Zn-finger in Ran binding protein and others/SPRY domain/HECT-domain (Ubiquitin-transferase), putative', 119, NULL, NULL, 188357),
(188358, '3.40.50.300-FF-002315', NULL, 'ABC transporter ATP-binding protein', 233, NULL, NULL, 188358),
(188359, '3.30.40.10-FF-001156', NULL, 'Degringolade, isoform A', 84, NULL, NULL, 188359),
(188360, '2.70.20.10-FF-000025', NULL, 'DNA topoisomerase 1', 124, NULL, NULL, 188360),
(188361, '1.10.472.10-FF-000243', NULL, 'Cyclin', 125, NULL, NULL, 188361),
(188362, '2.90.10.10-FF-000029', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', 127, NULL, NULL, 188362),
(188363, '3.30.160.60-FF-000780', NULL, 'myc-associated zinc finger protein isoform X1', 30, NULL, NULL, 188363),
(188364, '1.10.10.440-FF-000087', NULL, 'Predicted protein', 69, NULL, NULL, 188364),
(188365, '1.20.5.730-FF-000011', NULL, 'Rabaptin, RAB GTPase-binding effector protein 2', 58, NULL, NULL, 188365),
(188366, '3.30.200.20-FF-001469', NULL, 'RE24176p', 68, NULL, NULL, 188366),
(188367, '1.10.510.10-FF-002373', NULL, NULL, 150, NULL, NULL, 188367),
(188368, '1.10.238.10-FF-000750', NULL, 'Uncharacterized protein', 113, NULL, NULL, 188368),
(188369, '1.10.506.10-FF-000025', NULL, 'Plexin D1', 264, NULL, NULL, 188369),
(188370, '2.170.14.10-FF-000001', NULL, 'Tail spike protein', 109, NULL, NULL, 188370),
(188371, '2.60.40.1670-FF-000023', NULL, 'Protein transport protein SEC23', 159, NULL, NULL, 188371),
(188372, '3.40.50.300-FF-008144', NULL, 'Predicted protein', 96, NULL, NULL, 188372),
(188373, '1.10.3720.10-FF-000106', NULL, 'Inner membrane ABC transporter permease ynjC', 260, NULL, NULL, 188373),
(188374, '1.20.1080.10-FF-000110', NULL, 'Aquaporin, putative', 143, NULL, NULL, 188374),
(188375, '3.40.50.300-FF-005968', NULL, 'ABC transporter H family member 4', 150, NULL, NULL, 188375),
(188376, '1.10.10.10-FF-000434', NULL, 'Selenocysteine-specific translation elongation factor', 60, NULL, NULL, 188376),
(188377, '2.60.40.1660-FF-000020', NULL, 'Sodium/potassium-transporting ATPase subunit beta', 172, NULL, NULL, 188377),
(188378, '3.40.50.300-FF-003939', NULL, 'AGAP006279-PA', 179, NULL, NULL, 188378),
(188379, '1.10.510.10-FF-004514', NULL, NULL, 195, NULL, NULL, 188379),
(188380, '3.30.160.60-FF-002921', NULL, 'Human immunodeficiency virus type I enhancer binding protein 3', 55, NULL, NULL, 188380),
(188381, '2.130.10.10-FF-005676', NULL, 'Uncharacterized protein', 161, NULL, NULL, 188381),
(188382, '3.40.50.1820-FF-001640', NULL, 'Serine carboxypeptidase, putative', 408, NULL, NULL, 188382),
(188383, '3.30.70.80-FF-000015', NULL, 'Probable PRB1-protease B, vacuolar', 84, NULL, NULL, 188383),
(188384, '3.40.50.300-FF-003838', NULL, 'ATP-dependent bile acid permease, putative', 156, NULL, NULL, 188384),
(188385, '3.30.1320.10-FF-000002', NULL, '30S ribosomal protein S16', 90, NULL, NULL, 188385),
(188386, '3.80.10.10-FF-001910', NULL, 'RANGAP2', 99, NULL, NULL, 188386),
(188387, '3.30.565.10-FF-000306', NULL, 'Chaperone protein HtpG', 229, NULL, NULL, 188387),
(188388, '4.10.400.10-FF-000066', NULL, 'LDL receptor related protein 1', 40, NULL, NULL, 188388),
(188389, '3.30.450.40-FF-000212', NULL, 'GAF domain protein', 151, NULL, NULL, 188389),
(188390, '1.20.58.1780-FF-000020', NULL, 'Uncharacterized protein', 239, NULL, NULL, 188390); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(188391, '3.70.10.10-FF-000039', NULL, 'Contig, possible fusion of chromosomes 20 and 34', 240, NULL, NULL, 188391),
(188392, '1.10.510.10-FF-003997', NULL, NULL, 214, NULL, NULL, 188392),
(188393, '1.25.40.10-FF-003770', NULL, 'Cell division cycle 16 homolog (S. cerevisiae)', 159, NULL, NULL, 188393),
(188394, '1.10.390.30-FF-000002', NULL, 'Metallprotease, enhancin', 159, NULL, NULL, 188394),
(188395, '3.90.226.10-FF-000270', NULL, 'Uncharacterized protein', 90, NULL, NULL, 188395),
(188396, '3.20.20.70-FF-000846', NULL, NULL, 86, NULL, NULL, 188396),
(188397, '2.30.30.30-FF-000101', NULL, 'Elongation factor P', 66, NULL, NULL, 188397),
(188398, '2.130.10.10-FF-001298', NULL, 'WD repeat-containing protein 3 isoform A', 59, NULL, NULL, 188398),
(188399, '2.60.40.1510-FF-000003', NULL, 'Integrin beta', 113, NULL, NULL, 188399),
(188400, '2.140.10.10-FF-000004', NULL, 'Quinate/shikimate dehydrogenase', 226, NULL, NULL, 188400),
(188401, '3.40.1260.20-FF-000003', NULL, 'Ribonuclease E', 106, NULL, NULL, 188401),
(188402, '1.50.40.10-FF-000390', NULL, 'Uncharacterized protein', 290, NULL, NULL, 188402),
(188403, '1.10.630.10-FF-000297', NULL, 'Uncharacterized protein', 65, NULL, NULL, 188403),
(188404, '1.10.287.110-FF-000242', NULL, 'Hypothetical_protein_-_conserved', 123, NULL, NULL, 188404),
(188405, '2.10.25.10-FF-000972', NULL, 'Adhesion G protein-coupled receptor E5b, duplicate 3', 46, NULL, NULL, 188405),
(188406, '3.30.505.10-FF-000090', NULL, 'Uncharacterized protein', 118, NULL, NULL, 188406),
(188407, '2.60.40.10-FF-002472', NULL, 'Protein CBR-UNC-22', 99, NULL, NULL, 188407),
(188408, '3.80.10.10-FF-002995', NULL, 'Predicted protein', 109, NULL, NULL, 188408),
(188409, '3.30.565.10-FF-000205', NULL, 'Pyruvate dehydrogenase (Lipoamide) kinase, putative', 171, NULL, NULL, 188409),
(188410, '3.30.310.50-FF-000042', NULL, 'Phosphoglucomutase/phosphomannomutase alpha/beta/alpha domain I', 86, NULL, NULL, 188410),
(188411, '2.20.28.10-FF-000023', NULL, 'DNA replication factor, putative', 51, NULL, NULL, 188411),
(188412, '1.10.287.1490-FF-000044', NULL, 'Kelch-domain-containing protein', 200, NULL, NULL, 188412),
(188413, '3.40.50.2020-FF-000054', NULL, 'ComF family protein', 123, NULL, NULL, 188413),
(188414, '3.20.20.80-FF-000849', NULL, 'Uncharacterized protein', 164, NULL, NULL, 188414),
(188415, '2.30.30.40-FF-000104', NULL, 'Bacterial SH3 domain protein', 68, NULL, NULL, 188415),
(188416, '1.25.10.10-FF-001688', NULL, 'Uncharacterized protein', 286, NULL, NULL, 188416),
(188417, '3.40.250.10-FF-000085', NULL, 'Uncharacterized protein', 127, NULL, NULL, 188417),
(188418, '2.60.40.10-FF-003568', NULL, NULL, 111, NULL, NULL, 188418),
(188419, '2.40.50.140-FF-001147', NULL, NULL, 53, NULL, NULL, 188419),
(188420, '2.60.40.10-FF-004506', NULL, NULL, 101, NULL, NULL, 188420),
(188421, '1.25.40.440-FF-000004', NULL, NULL, 49, NULL, NULL, 188421),
(188422, '3.40.50.300-FF-000612', NULL, 'ATP-binding cassette, sub-family A (ABC1), member 2', 277, NULL, NULL, 188422),
(188423, '3.40.33.10-FF-000088', NULL, 'AGAP000357-PA', 242, NULL, NULL, 188423),
(188424, '1.10.10.10-FF-001957', NULL, 'Uncharacterized protein', 76, NULL, NULL, 188424),
(188425, '1.10.20.10-FF-000042', NULL, 'Transcription initiation factor TFIID subunit 13', 45, NULL, NULL, 188425),
(188426, '2.130.10.10-FF-002023', NULL, 'Uncharacterized protein', 130, NULL, NULL, 188426),
(188427, '2.130.10.10-FF-004153', NULL, 'Uncharacterized protein', 176, NULL, NULL, 188427),
(188428, '1.25.40.10-FF-002134', NULL, 'Pentatricopeptide repeat-containing protein', 71, NULL, NULL, 188428),
(188429, '1.20.1640.10-FF-000092', NULL, 'Patched domain-containing protein 3', 209, NULL, NULL, 188429),
(188430, '1.10.510.10-FF-000344', NULL, 'striated muscle preferentially expressed protein kinase isoform X1', 207, NULL, NULL, 188430),
(188431, '3.40.640.10-FF-000092', NULL, 'Tyrosine phenol-lyase', 253, NULL, NULL, 188431),
(188432, '2.60.40.1530-FF-000009', NULL, 'Integrin subunit alpha 11', 173, NULL, NULL, 188432),
(188433, '1.20.1310.10-FF-000011', NULL, 'Cullin 1', 126, NULL, NULL, 188433);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(188434, '3.30.230.80-FF-000005', NULL, 'heat shock protein 90-5, chloroplastic', 173, NULL, NULL, 188434),
(188435, '3.40.30.10-FF-000750', NULL, 'Ferredoxin, 2Fe-2s', 106, NULL, NULL, 188435),
(188436, '3.10.450.320-FF-000006', NULL, 'Uncharacterized protein', 115, NULL, NULL, 188436),
(188437, '3.30.420.10-FF-000746', NULL, NULL, 101, NULL, NULL, 188437),
(188438, '1.10.510.10-FF-000670', NULL, 'Serine/threonin protein kinase, putative', 290, NULL, NULL, 188438),
(188439, '3.30.450.20-FF-000577', NULL, 'Predicted protein', 72, NULL, NULL, 188439),
(188440, '1.10.150.190-FF-000002', NULL, 'Translation initiation factor 2, alpha subunit', 86, NULL, NULL, 188440),
(188441, '2.60.200.20-FF-000134', NULL, 'E3 ubiquitin-protein ligase CHFR-like Protein', 118, NULL, NULL, 188441),
(188442, '4.10.240.10-FF-000188', NULL, 'Activator of stress genes protein 1', 100, NULL, NULL, 188442),
(188443, '1.25.10.10-FF-002205', NULL, 'Proteasome/cyclosome repeat family protein', 436, NULL, NULL, 188443),
(188444, '3.30.9.10-FF-000257', NULL, 'Gll0956 protein', 160, NULL, NULL, 188444),
(188445, '2.10.25.10-FF-001146', NULL, 'Uncharacterized protein', 49, NULL, NULL, 188445),
(188446, '1.10.1420.10-FF-000050', NULL, 'DNA mismatch repair protein Msh5, putative', 240, NULL, NULL, 188446),
(188447, '1.20.1310.20-FF-000014', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 183, NULL, NULL, 188447),
(188448, '3.10.20.30-FF-000032', NULL, 'Stearoyl-CoA 9-desaturase', 88, NULL, NULL, 188448),
(188449, '3.40.50.1820-FF-001741', NULL, 'Uncharacterized protein', 73, NULL, NULL, 188449),
(188450, '1.10.238.10-FF-000323', NULL, 'Actin cytoskeleton-regulatory complex protein end3', 99, NULL, NULL, 188450),
(188451, '3.30.70.20-FF-000143', NULL, NULL, 56, NULL, NULL, 188451),
(188452, '3.40.228.10-FF-000010', NULL, 'Tetrathionate reductase subunit A', 310, NULL, NULL, 188452),
(188453, '2.60.40.10-FF-005709', NULL, NULL, 46, NULL, NULL, 188453),
(188454, '1.10.510.10-FF-001867', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase gcn-2', 277, NULL, NULL, 188454),
(188455, '3.30.1360.10-FF-000010', NULL, 'DNA-directed RNA polymerase subunit alpha', 85, NULL, NULL, 188455),
(188456, '1.25.40.10-FF-003657', NULL, 'Uncharacterized protein', 238, NULL, NULL, 188456),
(188457, '3.40.50.10810-FF-000121', NULL, 'DNA repair and recombination protein RAD54B', 261, NULL, NULL, 188457),
(188458, '3.40.50.300-FF-002742', NULL, 'Superkiller protein 7', 268, NULL, NULL, 188458),
(188459, '3.40.50.1440-FF-000082', NULL, 'Misato 1, mitochondrial distribution and morphology regulator', 94, NULL, NULL, 188459),
(188460, '1.10.357.70-FF-000033', NULL, 'Uncharacterized protein', 145, NULL, NULL, 188460),
(188461, '1.25.40.10-FF-001196', NULL, 'Tonsoku like, DNA repair protein', 139, NULL, NULL, 188461),
(188462, '1.10.220.110-FF-000001', NULL, 'GDNF family receptor alpha', 108, NULL, NULL, 188462),
(188463, '3.30.70.330-FF-000520', NULL, 'Polyadenylate-binding protein', 97, NULL, NULL, 188463),
(188464, '3.30.70.240-FF-000044', NULL, 'CRISPR-associated endonuclease Cas2', 100, NULL, NULL, 188464),
(188465, '1.10.287.70-FF-000494', NULL, 'T calcium channel alpha1G subunit +34+35 splice variant', 65, NULL, NULL, 188465),
(188466, '3.80.10.10-FF-003613', NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', 89, NULL, NULL, 188466),
(188467, '2.60.40.1730-FF-000064', NULL, NULL, 211, NULL, NULL, 188467),
(188468, '2.60.40.10-FF-003669', NULL, NULL, 70, NULL, NULL, 188468),
(188469, '2.20.20.110-FF-000012', NULL, 'AGR162Cp', 60, NULL, NULL, 188469),
(188470, '2.40.70.10-FF-000007', NULL, 'Beta-secretase 1', 133, NULL, NULL, 188470),
(188471, '3.40.50.1820-FF-001409', NULL, 'GPI inositol-deacylase', 207, NULL, NULL, 188471),
(188472, '3.30.1640.10-FF-000043', NULL, 'DNA helicase', 101, NULL, NULL, 188472),
(188473, '1.20.1280.50-FF-000008', NULL, 'F-box only protein 6', 40, NULL, NULL, 188473),
(188474, '3.40.630.30-FF-000406', NULL, 'Nudix hydrolase 6', 60, NULL, NULL, 188474),
(188475, '3.40.50.1820-FF-001527', NULL, 'Os01g0958800 protein', 144, NULL, NULL, 188475);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(188476, '2.60.40.3440-FF-000003', NULL, 'RTX toxins and related Ca2+-binding protein', 110, NULL, NULL, 188476),
(188477, '2.10.220.10-FF-000048', NULL, 'Proprotein convertase subtilisin/kexin type 6', 55, NULL, NULL, 188477),
(188478, '1.25.40.10-FF-002033', NULL, 'ESX-3 secretion system protein EccA3', 277, NULL, NULL, 188478),
(188479, '2.120.10.30-FF-000180', NULL, 'Gluconolaconase', 291, NULL, NULL, 188479),
(188480, '1.10.520.10-FF-000058', NULL, 'Thylakoid lumenal 29 kDa protein chloroplastic', 114, NULL, NULL, 188480),
(188481, '3.40.50.970-FF-000211', NULL, '2-oxoisovalerate dehydrogenase subunit alpha', 156, NULL, NULL, 188481),
(188482, '3.40.630.10-FF-000400', NULL, 'Carboxypeptidase D, b', 293, NULL, NULL, 188482),
(188483, '2.40.70.10-FF-000119', NULL, 'Eukaryotic aspartyl protease family protein', 178, NULL, NULL, 188483),
(188484, '3.40.50.300-FF-004653', NULL, 'DNA helicase', 169, NULL, NULL, 188484),
(188485, '3.40.50.1980-FF-000024', NULL, 'ABC transporter substrate-binding protein', 156, NULL, NULL, 188485),
(188486, '1.10.287.370-FF-000078', NULL, 'Prefoldin subunit 3', 134, NULL, NULL, 188486),
(188487, '1.10.135.10-FF-000011', NULL, 'Arginine kinase 1', 102, NULL, NULL, 188487),
(188488, '1.10.10.10-FF-001862', NULL, 'Histone acetyltransferase', 71, NULL, NULL, 188488),
(188489, '3.30.70.2330-FF-000003', NULL, 'Fanconi-associated nuclease', 118, NULL, NULL, 188489),
(188490, '2.60.40.10-FF-000134', NULL, 'Myomesin 1', 107, NULL, NULL, 188490),
(188491, '2.40.50.930-FF-000001', NULL, 'Serine/threonine-protein kinase PLK4', 89, NULL, NULL, 188491),
(188492, '1.10.10.60-FF-001287', NULL, NULL, 53, NULL, NULL, 188492),
(188493, '2.40.150.20-FF-000005', NULL, '50S ribosomal protein L14', 133, NULL, NULL, 188493),
(188494, '3.40.980.10-FF-000044', NULL, 'Molybdopterin molybdenumtransferase', 184, NULL, NULL, 188494),
(188495, '3.30.70.330-FF-001616', NULL, NULL, 93, NULL, NULL, 188495),
(188496, '1.20.58.390-FF-000330', NULL, 'Uncharacterized protein', 100, NULL, NULL, 188496),
(188497, '3.40.50.740-FF-000058', NULL, 'Gll2176 protein', 82, NULL, NULL, 188497),
(188498, '2.130.10.10-FF-003647', NULL, 'Protein raptor homolog', 102, NULL, NULL, 188498),
(188499, '3.60.20.40-FF-000049', NULL, 'Uncharacterized protein', 100, NULL, NULL, 188499),
(188500, '3.40.50.880-FF-000072', NULL, 'Aminodeoxychorismate synthase, chloroplastic', 201, NULL, NULL, 188500),
(188501, '2.60.40.10-FF-002045', NULL, 'Putative adhesin', 99, NULL, NULL, 188501),
(188502, '1.10.10.820-FF-000010', NULL, 'Chitin synthase 6', 65, NULL, NULL, 188502),
(188503, '3.40.47.10-FF-000142', NULL, 'Hydroxymethylglutaryl-CoA synthase', 444, NULL, NULL, 188503),
(188504, '1.20.1070.10-FF-001026', NULL, 'Uncharacterized protein', 336, NULL, NULL, 188504),
(188505, '3.40.50.2300-FF-001453', NULL, NULL, 147, NULL, NULL, 188505),
(188506, '1.10.10.140-FF-000014', NULL, 'Predicted protein', 54, NULL, NULL, 188506),
(188507, '1.10.287.950-FF-000038', NULL, 'Methyl-accepting chemotaxis protein', 298, NULL, NULL, 188507),
(188508, '1.10.510.10-FF-000024', NULL, 'Probable serine/threonine-protein kinase cot-1', 215, NULL, NULL, 188508),
(188509, '3.40.350.10-FF-000013', NULL, 'probable Xaa-Pro aminopeptidase 3', 180, NULL, NULL, 188509),
(188510, '3.30.230.70-FF-000002', NULL, 'Polyribonucleotide nucleotidyltransferase', 314, NULL, NULL, 188510),
(188511, '3.90.550.10-FF-000208', NULL, '2-C-methyl-D-erythritol 4-phosphate cytidylyltransferase', 230, NULL, NULL, 188511),
(188512, '1.25.10.10-FF-001368', NULL, 'YALI0C07909p', 145, NULL, NULL, 188512),
(188513, '3.30.160.60-FF-002820', NULL, 'Transcriptional regulator MET31', 43, NULL, NULL, 188513),
(188514, '3.30.200.20-FF-001368', NULL, 'Putative serine/threonine-protein kinase', 125, NULL, NULL, 188514),
(188515, '1.20.1110.10-FF-000125', NULL, NULL, 205, NULL, NULL, 188515),
(188516, '1.25.10.10-FF-000165', NULL, 'Protein MOR1', 228, NULL, NULL, 188516),
(188517, '1.25.40.450-FF-000007', NULL, 'Nuclear Pore complex Protein', 150, NULL, NULL, 188517),
(188518, '1.10.20.10-FF-000154', NULL, 'Transcription initiation factor tfiid, putative', 68, NULL, NULL, 188518);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(188519, '3.40.50.970-FF-000110', NULL, 'Pyruvate-flavodoxin oxidoreductase', 382, NULL, NULL, 188519),
(188520, '1.20.1250.20-FF-001127', NULL, 'MFS multidrug transporter', 183, NULL, NULL, 188520),
(188521, '4.10.60.10-FF-000071', NULL, 'Cleavage and polyadenylation-specific factor 4-like', 36, NULL, NULL, 188521),
(188522, '1.20.210.10-FF-000021', NULL, 'Cytochrome c oxidase subunit 1', 109, NULL, NULL, 188522),
(188523, '2.70.98.10-FF-000103', NULL, 'Aldose 1-epimerase', 357, NULL, NULL, 188523),
(188524, '1.25.10.10-FF-000283', NULL, 'Anaphase-promoting complex subunit 1', 124, NULL, NULL, 188524),
(188525, '3.20.20.190-FF-000139', NULL, NULL, 279, NULL, NULL, 188525),
(188526, '1.10.1420.10-FF-000156', NULL, 'Uncharacterized protein', 84, NULL, NULL, 188526),
(188527, '2.130.10.10-FF-003759', NULL, 'Uncharacterized protein', 324, NULL, NULL, 188527),
(188528, '3.40.50.720-FF-001249', NULL, 'D-amino acid oxidase, putative', 152, NULL, NULL, 188528),
(188529, '3.30.200.20-FF-002200', NULL, 'Uncharacterized protein', 49, NULL, NULL, 188529),
(188530, '3.30.70.3450-FF-000002', NULL, 'Alkyldihydroxyacetonephosphate synthase', 120, NULL, NULL, 188530),
(188531, '3.30.200.20-FF-001582', NULL, 'Protein kinase, putative', 96, NULL, NULL, 188531),
(188532, '3.40.50.300-FF-004092', NULL, 'Ribosome-binding ATPase YchF', 165, NULL, NULL, 188532),
(188533, '2.60.200.20-FF-000022', NULL, 'E3 ubiquitin-protein ligase CHFR isoform X2', 116, NULL, NULL, 188533),
(188534, '3.30.1010.10-FF-000012', NULL, 'Phosphatidylinositol 4-kinase alpha 1', 148, NULL, NULL, 188534),
(188535, '1.20.58.480-FF-000014', NULL, 'Uncharacterized protein', 121, NULL, NULL, 188535),
(188536, '2.70.98.110-FF-000014', NULL, 'Mannosyl-oligosaccharide glucosidase', 280, NULL, NULL, 188536),
(188537, '3.30.1380.10-FF-000011', NULL, 'Uncharacterized protein', 126, NULL, NULL, 188537),
(188538, '1.10.10.60-FF-000090', NULL, 'Transcriptional regulator ArgR, AraC family', 106, NULL, NULL, 188538),
(188539, '1.10.10.830-FF-000013', NULL, 'Isoleucyl-tRNA synthetase, mitochondrial', 57, NULL, NULL, 188539),
(188540, '2.130.10.10-FF-005996', NULL, 'Predicted protein', 117, NULL, NULL, 188540),
(188541, '3.30.1380.20-FF-000014', NULL, 'Trafficking protein particle complex subunit 6A', 156, NULL, NULL, 188541),
(188542, '1.10.10.10-FF-000114', NULL, 'Lrp/AsnC family transcriptional regulator', 52, NULL, NULL, 188542),
(188543, '3.40.50.1820-FF-000926', NULL, 'Uncharacterized protein', 224, NULL, NULL, 188543),
(188544, '1.10.510.10-FF-004161', NULL, NULL, 197, NULL, NULL, 188544),
(188545, '3.10.580.10-FF-000099', NULL, 'Sugar isomerase, KpsF/GutQ family', 127, NULL, NULL, 188545),
(188546, '1.10.3720.10-FF-000011', NULL, 'Glutamine ABC transporter permease GlnP', 218, NULL, NULL, 188546),
(188547, '1.20.1560.10-FF-000737', NULL, 'ABC transporter family protein', 174, NULL, NULL, 188547),
(188548, '1.10.357.120-FF-000003', NULL, 'DNA-directed RNA polymerase subunit', 126, NULL, NULL, 188548),
(188549, '3.30.420.80-FF-000031', NULL, 'Uncharacterized protein', 91, NULL, NULL, 188549),
(188550, '1.20.58.80-FF-000019', NULL, 'AAA-type ATPase family protein', 90, NULL, NULL, 188550),
(188551, '3.30.160.60-FF-001983', NULL, 'Transcriptional regulator Nrg1', 29, NULL, NULL, 188551),
(188552, '2.60.200.30-FF-000025', NULL, 'NAD kinase 2, mitochondrial', 97, NULL, NULL, 188552),
(188553, '1.20.1310.10-FF-000106', NULL, 'Ubiquitin-protein ligase', 132, NULL, NULL, 188553),
(188554, '3.90.70.10-FF-000104', NULL, 'Cathepsin L 1', 295, NULL, NULL, 188554),
(188555, '1.20.5.340-FF-000118', NULL, 'Myosin-2 heavy chain', 86, NULL, NULL, 188555),
(188556, '3.40.30.10-FF-000845', NULL, 'Protein disulfide-isomerase', 115, NULL, NULL, 188556),
(188557, '3.40.1000.50-FF-000004', NULL, 'Repressor of RNA polymerase III transcription MAF1', 175, NULL, NULL, 188557),
(188558, '1.50.40.10-FF-000058', NULL, 'Solute carrier family 25 member 48', 301, NULL, NULL, 188558),
(188559, '2.60.40.420-FF-000269', NULL, 'Uncharacterized protein', 136, NULL, NULL, 188559),
(188560, '3.90.740.10-FF-000021', NULL, 'Valine--tRNA ligase', 152, NULL, NULL, 188560);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(188561, '3.10.110.10-FF-000160', NULL, 'Putative pre-mrna-splicing factor atp-dependent rna helicase prp22 protein', 120, NULL, NULL, 188561),
(188562, '1.20.58.70-FF-000016', NULL, 'Syntaxin-32 like', 223, NULL, NULL, 188562),
(188563, '2.130.10.10-FF-002135', NULL, 'WD repeat and FYVE domain-containing protein 2', 154, NULL, NULL, 188563),
(188564, '3.90.470.20-FF-000031', NULL, '4''phosphopantetheinyl transferase superfamily protein', 57, NULL, NULL, 188564),
(188565, '1.10.8.60-FF-000347', NULL, 'WGS project CABT00000000 data, contig 2.3', 18, NULL, NULL, 188565),
(188566, '2.40.10.10-FF-000015', NULL, 'Atrial natriuretic peptide-converting enzyme', 247, NULL, NULL, 188566),
(188567, '1.50.40.10-FF-000485', NULL, 'Uncharacterized protein', 277, NULL, NULL, 188567),
(188568, '3.90.230.10-FF-000055', NULL, NULL, 35, NULL, NULL, 188568),
(188569, '3.30.505.10-FF-000185', NULL, NULL, 76, NULL, NULL, 188569),
(188570, '1.20.1730.10-FF-000099', NULL, 'Uncharacterized protein', 272, NULL, NULL, 188570),
(188571, '3.40.1000.40-FF-000001', NULL, 'Respiratory growth induced protein 2', 154, NULL, NULL, 188571),
(188572, '3.90.70.10-FF-000531', NULL, 'Haemolysin secretion ATP-binding protein', 146, NULL, NULL, 188572),
(188573, '3.40.30.10-FF-000418', NULL, 'Chloride intracellular channel exc-4', 109, NULL, NULL, 188573),
(188574, '1.10.238.10-FF-000087', NULL, 'Sorcin', 132, NULL, NULL, 188574),
(188575, '2.60.40.10-FF-004383', NULL, NULL, 100, NULL, NULL, 188575),
(188576, '3.40.50.150-FF-000432', NULL, 'Unplaced genomic scaffold supercont2.10, whole genome shotgun sequence', 229, NULL, NULL, 188576),
(188577, '2.60.40.10-FF-001977', NULL, 'KETtiN (Drosophila actin-binding) homolog', 100, NULL, NULL, 188577),
(188578, '1.10.8.60-FF-000465', NULL, 'Uncharacterized protein', 64, NULL, NULL, 188578),
(188579, '2.60.120.970-FF-000044', NULL, 'Inhibin beta chain', 230, NULL, NULL, 188579),
(188580, '3.40.640.10-FF-000215', NULL, 'Probable aminotransferase', 259, NULL, NULL, 188580),
(188581, '1.20.1250.20-FF-001026', NULL, 'AGL069Cp', 218, NULL, NULL, 188581),
(188582, '2.130.10.10-FF-002562', NULL, 'Intraflagellar transport particle protein 80', 287, NULL, NULL, 188582),
(188583, '2.20.100.10-FF-000178', NULL, 'Pancreatic trypsin inhibitor', 70, NULL, NULL, 188583),
(188584, '1.10.472.10-FF-000131', NULL, 'G1 cyclin', 112, NULL, NULL, 188584),
(188585, '3.40.50.1000-FF-000534', NULL, NULL, 168, NULL, NULL, 188585),
(188586, '3.30.160.60-FF-002028', NULL, 'Fruitless, isoform I', 25, NULL, NULL, 188586),
(188587, '1.20.120.1110-FF-000013', NULL, 'Uncharacterized protein', 76, NULL, NULL, 188587),
(188588, '1.10.240.10-FF-000031', NULL, 'Uncharacterized protein', 49, NULL, NULL, 188588),
(188589, '3.30.565.10-FF-000082', NULL, 'Sensor histidine kinase ComD', 150, NULL, NULL, 188589),
(188590, '1.20.58.830-FF-000041', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 152, NULL, NULL, 188590),
(188591, '3.30.70.20-FF-000025', NULL, 'Ferredoxin-type protein NapF', 70, NULL, NULL, 188591),
(188592, '3.30.40.10-FF-001622', NULL, 'Uncharacterized protein', 82, NULL, NULL, 188592),
(188593, '2.60.40.150-FF-000362', NULL, 'coiled-coil and C2 domain-containing protein 2A', 161, NULL, NULL, 188593),
(188594, '1.10.287.110-FF-000253', NULL, 'Guanine nucleotide-binding protein subunit gamma', 62, NULL, NULL, 188594),
(188595, '3.40.50.300-FF-004333', NULL, 'Iron(III) ABC superfamily ATP binding cassette transporter, ABC protein', 258, NULL, NULL, 188595),
(188596, '3.30.160.60-FF-000128', NULL, 'zinc finger protein 268 isoform X1', 28, NULL, NULL, 188596),
(188597, '2.60.40.790-FF-000003', NULL, 'prostaglandin E synthase 3', 125, NULL, NULL, 188597),
(188598, '3.40.50.300-FF-002079', NULL, 'ATP-dependent dethiobiotin synthetase BioD', 226, NULL, NULL, 188598),
(188599, '2.40.460.10-FF-000003', NULL, 'Acetyl-CoA carboxylase 2', 66, NULL, NULL, 188599),
(188600, '1.20.1310.10-FF-000117', NULL, NULL, 148, NULL, NULL, 188600),
(188601, '2.10.25.10-FF-001360', NULL, 'Laminin, beta 1b', 47, NULL, NULL, 188601),
(188602, '2.130.10.10-FF-005788', NULL, 'Uncharacterized protein', 97, NULL, NULL, 188602);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(188603, '3.30.450.40-FF-000223', NULL, 'Pca regulon regulatory protein', 188, NULL, NULL, 188603),
(188604, '3.40.50.150-FF-000078', NULL, 'Protein arginine methyltransferase 9', 137, NULL, NULL, 188604),
(188605, '3.30.160.60-FF-003894', NULL, NULL, 28, NULL, NULL, 188605),
(188606, '2.60.40.10-FF-000454', NULL, 'Tyrosine-protein phosphatase non-receptor type substrate 1', 106, NULL, NULL, 188606),
(188607, '3.30.70.330-FF-002111', NULL, NULL, 113, NULL, NULL, 188607),
(188608, '3.90.1530.30-FF-000010', NULL, 'Replication protein, putative', 67, NULL, NULL, 188608),
(188609, '1.10.10.10-FF-002025', NULL, 'Uncharacterized protein', 106, NULL, NULL, 188609),
(188610, '1.10.10.140-FF-000003', NULL, 'Cytochrome c oxidase assembly factor 6', 83, NULL, NULL, 188610),
(188611, '2.40.70.10-FF-000350', NULL, NULL, 152, NULL, NULL, 188611),
(188612, '3.30.160.60-FF-004170', NULL, NULL, 31, NULL, NULL, 188612),
(188613, '3.40.50.450-FF-000067', NULL, 'Uncharacterized protein', 191, NULL, NULL, 188613),
(188614, '1.20.120.1750-FF-000070', NULL, 'Os11g0300800 protein', 37, NULL, NULL, 188614),
(188615, '3.90.660.10-FF-000099', NULL, NULL, 88, NULL, NULL, 188615),
(188616, '3.30.60.30-FF-000090', NULL, 'GH09510p', 66, NULL, NULL, 188616),
(188617, '2.130.10.10-FF-003658', NULL, 'Chromatin modification-related protein rik1', 300, NULL, NULL, 188617),
(188618, '3.30.160.60-FF-006311', NULL, NULL, 67, NULL, NULL, 188618),
(188619, '3.30.160.60-FF-002258', NULL, 'Zinc finger protein ZIC 3', 39, NULL, NULL, 188619),
(188620, '3.30.9.10-FF-000246', NULL, 'Amino acid oxidase fmpA', 20, NULL, NULL, 188620),
(188621, '2.60.120.330-FF-000217', NULL, 'Uncharacterized protein', 77, NULL, NULL, 188621),
(188622, '3.90.1480.20-FF-000036', NULL, 'ST3 beta-galactoside alpha-2,3-sialyltransferase 2', 156, NULL, NULL, 188622),
(188623, '3.10.20.90-FF-000690', NULL, 'YALI0E14927p', 125, NULL, NULL, 188623),
(188624, '3.90.1750.10-FF-000026', NULL, 'E3 ubiquitin-protein ligase HACE1', 35, NULL, NULL, 188624),
(188625, '1.20.5.170-FF-000169', NULL, 'Predicted protein', 132, NULL, NULL, 188625),
(188626, '3.20.20.140-FF-000478', NULL, 'Uncharacterized protein', 135, NULL, NULL, 188626),
(188627, '3.80.10.10-FF-001247', NULL, 'Os06g0557400 protein', 112, NULL, NULL, 188627),
(188628, '3.30.800.10-FF-000034', NULL, NULL, 213, NULL, NULL, 188628),
(188629, '1.25.40.10-FF-005248', NULL, 'Uncharacterized protein', 165, NULL, NULL, 188629),
(188630, '3.30.930.10-FF-000257', NULL, 'Octanoyltransferase', 219, NULL, NULL, 188630),
(188631, '3.20.80.10-FF-000057', NULL, 'Uncharacterized protein', 138, NULL, NULL, 188631),
(188632, '1.20.120.1760-FF-000073', NULL, NULL, 193, NULL, NULL, 188632),
(188633, '1.10.20.10-FF-000053', NULL, 'Centromere protein W', 76, NULL, NULL, 188633),
(188634, '2.60.200.20-FF-000123', NULL, 'Predicted protein', 139, NULL, NULL, 188634),
(188635, '3.40.50.720-FF-001912', NULL, 'Os07g0602050 protein', 109, NULL, NULL, 188635),
(188636, '2.130.10.10-FF-005912', NULL, 'Predicted protein', 278, NULL, NULL, 188636),
(188637, '1.10.630.10-FF-000628', NULL, 'Os07g0464700 protein', 229, NULL, NULL, 188637),
(188638, '3.40.50.150-FF-000533', NULL, 'Site-specific DNA-methyltransferase (adenine-specific)', 143, NULL, NULL, 188638),
(188639, '3.10.20.90-FF-000802', NULL, 'Uncharacterized protein', 70, NULL, NULL, 188639),
(188640, '2.30.30.40-FF-000542', NULL, 'EPS8 like 1', 53, NULL, NULL, 188640),
(188641, '2.130.10.10-FF-005890', NULL, 'Uncharacterized protein', 295, NULL, NULL, 188641),
(188642, '3.40.50.2020-FF-000166', NULL, 'Ribose-phosphate pyrophosphokinase', 133, NULL, NULL, 188642),
(188643, '3.30.160.60-FF-004057', NULL, NULL, 66, NULL, NULL, 188643),
(188644, '2.60.120.920-FF-000175', NULL, 'Uncharacterized protein', 75, NULL, NULL, 188644),
(188645, '3.40.50.720-FF-000974', NULL, 'NAD-dependent malic enzyme', 287, NULL, NULL, 188645),
(188646, '2.60.40.1910-FF-000016', NULL, 'Uncharacterized protein, isoform B', 93, NULL, NULL, 188646),
(188647, '2.30.30.40-FF-000312', NULL, 'Related to Cell division control protein 15', 60, NULL, NULL, 188647);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(188648, '3.40.630.30-FF-000283', NULL, 'Acetyltransferase, putative', 150, NULL, NULL, 188648),
(188649, '1.10.1070.11-FF-000130', NULL, 'Uncharacterized protein', 72, NULL, NULL, 188649),
(188650, '2.60.120.40-FF-000061', NULL, 'Complement C1q B chain', 121, NULL, NULL, 188650),
(188651, '3.30.40.10-FF-001167', NULL, 'DSC E3 ubiquitin ligase complex subunit 1', 74, NULL, NULL, 188651),
(188652, '2.70.130.10-FF-000101', NULL, NULL, 149, NULL, NULL, 188652),
(188653, '3.10.100.10-FF-000002', NULL, 'Hyaluronan proteoglycan link protein 1', 98, NULL, NULL, 188653),
(188654, '3.30.43.10-FF-000010', NULL, 'probable D-lactate dehydrogenase, mitochondrial', 110, NULL, NULL, 188654),
(188655, '3.30.160.60-FF-005794', NULL, NULL, 25, NULL, NULL, 188655),
(188656, '2.10.110.10-FF-000141', NULL, 'LIM domain-containing protein', 87, NULL, NULL, 188656),
(188657, '3.20.20.70-FF-000493', NULL, NULL, 70, NULL, NULL, 188657),
(188658, '1.25.10.10-FF-002183', NULL, 'Predicted protein', 463, NULL, NULL, 188658),
(188659, '3.40.30.10-FF-000295', NULL, 'Glutathione S-transferase unclassified 1', 80, NULL, NULL, 188659),
(188660, '1.20.5.110-FF-000067', NULL, 't-SNARE', 105, NULL, NULL, 188660),
(188661, '3.10.20.90-FF-000252', NULL, 'Probable serine/threonine-protein kinase WNK3', 90, NULL, NULL, 188661),
(188662, '3.40.50.300-FF-002304', NULL, 'Nucleotide binding protein 2', 205, NULL, NULL, 188662),
(188663, '3.40.50.80-FF-000030', NULL, 'NADPH-dependent diflavin oxidoreductase 1', 153, NULL, NULL, 188663),
(188664, '1.20.120.1080-FF-000066', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 104, NULL, NULL, 188664),
(188665, '2.160.20.70-FF-000011', NULL, 'Tubulin-specific chaperone c, putative', 167, NULL, NULL, 188665),
(188666, '2.10.70.10-FF-000273', NULL, 'Uncharacterized protein', 64, NULL, NULL, 188666),
(188667, '1.20.1070.10-FF-001930', NULL, 'Uncharacterized protein', 278, NULL, NULL, 188667),
(188668, '3.30.420.40-FF-000373', NULL, 'Golgi apyrase', 146, NULL, NULL, 188668),
(188669, '1.10.530.10-FF-000019', NULL, 'lysozyme', 127, NULL, NULL, 188669),
(188670, '2.130.10.10-FF-001961', NULL, 'Protein purity of essence', 276, NULL, NULL, 188670),
(188671, '3.30.160.60-FF-004512', NULL, NULL, 28, NULL, NULL, 188671),
(188672, '3.20.20.70-FF-000835', NULL, NULL, 110, NULL, NULL, 188672),
(188673, '3.20.20.80-FF-000496', NULL, 'Glycogen debranching enzyme, putative', 228, NULL, NULL, 188673),
(188674, '1.10.287.850-FF-000008', NULL, 'PE family protein', 74, NULL, NULL, 188674),
(188675, '3.10.290.10-FF-000009', NULL, 'Pseudouridine synthase', 62, NULL, NULL, 188675),
(188676, '2.10.25.10-FF-001601', NULL, 'Uncharacterized protein', 53, NULL, NULL, 188676),
(188677, '1.10.238.10-FF-000312', NULL, 'EF-hand domain-containing protein 1 isoform 1', 114, NULL, NULL, 188677),
(188678, '3.30.70.330-FF-001493', NULL, 'Spliceosome-associated protein 49', 101, NULL, NULL, 188678),
(188679, '3.30.565.10-FF-000183', NULL, 'Heat shock protein 90-2', 189, NULL, NULL, 188679),
(188680, '2.30.29.30-FF-001312', NULL, 'FERM, RhoGEF and pleckstrin domain-containing protein, putative', 179, NULL, NULL, 188680),
(188681, '1.20.140.100-FF-000027', NULL, 'Dynein alpha chain, flagellar outer arm', 152, NULL, NULL, 188681),
(188682, '2.60.120.10-FF-000198', NULL, 'Mannose-6-phosphate isomerase, class I', 101, NULL, NULL, 188682),
(188683, '3.30.160.60-FF-006070', NULL, NULL, 21, NULL, NULL, 188683),
(188684, '1.10.268.10-FF-000038', NULL, NULL, 97, NULL, NULL, 188684),
(188685, '3.30.160.60-FF-000460', NULL, 'Putative zinc finger protein 740', 29, NULL, NULL, 188685),
(188686, '3.20.20.120-FF-000034', NULL, 'Aromatic dipeptide epimerase', 239, NULL, NULL, 188686),
(188687, '3.30.530.20-FF-000044', NULL, 'Uncharacterized protein', 204, NULL, NULL, 188687),
(188688, '2.10.25.10-FF-001247', NULL, 'Uncharacterized protein', 39, NULL, NULL, 188688),
(188689, '2.130.10.10-FF-002124', NULL, 'WD repeat-containing protein PCN', 89, NULL, NULL, 188689),
(188690, '1.10.760.10-FF-000042', NULL, 'Cytochrome c peroxidase', 150, NULL, NULL, 188690);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(188691, '3.40.50.300-FF-000281', NULL, 'ADP-ribosylation factor-like protein 3', 165, NULL, NULL, 188691),
(188692, '1.20.1070.10-FF-001256', NULL, 'Uncharacterized protein', 168, NULL, NULL, 188692),
(188693, '1.10.472.10-FF-000451', NULL, 'Cyclin-like protein', 148, NULL, NULL, 188693),
(188694, '3.90.70.10-FF-000542', NULL, 'Ubiquitin carboxyl-terminal hydrolase 1', 189, NULL, NULL, 188694),
(188695, '3.40.630.150-FF-000018', NULL, 'Malonyl-CoA decarboxylase', 160, NULL, NULL, 188695),
(188696, '3.40.50.800-FF-000094', NULL, 'Prolyl-tRNA synthetase', 103, NULL, NULL, 188696),
(188697, '3.40.1360.10-FF-000064', NULL, 'Spo11-like protein', 199, NULL, NULL, 188697),
(188698, '3.40.50.1100-FF-000244', NULL, 'Uncharacterized protein', 37, NULL, NULL, 188698),
(188699, '3.30.1120.40-FF-000001', NULL, 'Putative septation protein SpoVG', 97, NULL, NULL, 188699),
(188700, '3.30.70.1730-FF-000059', NULL, 'Uncharacterized protein', 49, NULL, NULL, 188700),
(188701, '3.40.50.1460-FF-000088', NULL, 'AGAP011693-PA', 211, NULL, NULL, 188701),
(188702, '3.80.10.10-FF-002984', NULL, 'Uncharacterized protein', 58, NULL, NULL, 188702),
(188703, '3.40.120.10-FF-000081', NULL, 'Phosphoglucosamine mutase', 145, NULL, NULL, 188703),
(188704, '3.20.20.80-FF-000838', NULL, 'CHItinase-Like', 33, NULL, NULL, 188704),
(188705, '2.60.40.2030-FF-000030', NULL, 'Adhesion G-protein coupled receptor V1', 131, NULL, NULL, 188705),
(188706, '2.10.25.10-FF-001040', NULL, 'Uncharacterized protein, isoform B', 29, NULL, NULL, 188706),
(188707, '3.40.50.300-FF-006452', NULL, 'Uncharacterized protein', 122, NULL, NULL, 188707),
(188708, '3.90.1170.10-FF-000032', NULL, 'Uncharacterized protein', 87, NULL, NULL, 188708),
(188709, '1.25.40.10-FF-000004', NULL, 'Photosystem I assembly protein Ycf3', 137, NULL, NULL, 188709),
(188710, '1.10.506.10-FF-000014', NULL, 'Neurofibromin 1', 101, NULL, NULL, 188710),
(188711, '3.30.70.2740-FF-000019', NULL, 'D-lactate dehydrogenase (acceptor)', 76, NULL, NULL, 188711),
(188712, '3.10.100.10-FF-000440', NULL, NULL, 55, NULL, NULL, 188712),
(188713, '3.30.70.1230-FF-000117', NULL, 'Guanylate cyclase', 100, NULL, NULL, 188713),
(188714, '3.10.580.10-FF-000088', NULL, 'Glycine betaine/L-proline ABC transporter ATP-binding protein', 120, NULL, NULL, 188714),
(188715, '3.90.550.10-FF-000107', NULL, 'Polypeptide N-acetylgalactosaminyltransferase-like 6', 126, NULL, NULL, 188715),
(188716, '1.20.58.60-FF-000699', NULL, 'Uncharacterized protein', 111, NULL, NULL, 188716),
(188717, '1.20.58.60-FF-000002', NULL, 'Actinin, alpha 1', 122, NULL, NULL, 188717),
(188718, '3.80.10.10-FF-001921', NULL, 'Probable WRKY transcription factor 19', 217, NULL, NULL, 188718),
(188719, '2.60.40.10-FF-005698', NULL, NULL, 65, NULL, NULL, 188719),
(188720, '2.130.10.10-FF-000224', NULL, 'cell division cycle protein 20 homolog', 339, NULL, NULL, 188720),
(188721, '3.80.10.10-FF-003260', NULL, 'Leucine-rich transmembrane protein, putative', 339, NULL, NULL, 188721),
(188722, '2.30.29.30-FF-001087', NULL, 'Uncharacterized protein', 57, NULL, NULL, 188722),
(188723, '1.10.3730.20-FF-000048', NULL, 'EamA family transporter', 81, NULL, NULL, 188723),
(188724, '2.60.40.60-FF-000233', NULL, 'Protocadherin gamma-A3 isoform 1', 106, NULL, NULL, 188724),
(188725, '3.40.980.10-FF-000033', NULL, 'Molybdopterin biosynthesis protein (MoeA-2)', 152, NULL, NULL, 188725),
(188726, '1.20.1560.10-FF-000496', NULL, 'ABC transporter ATP-binding protein', 342, NULL, NULL, 188726),
(188727, '3.80.10.10-FF-001360', NULL, 'Uncharacterized protein', 169, NULL, NULL, 188727),
(188728, '3.30.40.10-FF-001509', NULL, 'YALI0E33869p', 74, NULL, NULL, 188728),
(188729, '4.10.410.10-FF-000117', NULL, 'Trypsin inhibitor, putative', 57, NULL, NULL, 188729),
(188730, '1.10.510.10-FF-000462', NULL, 'Receptor tyrosine kinase', 195, NULL, NULL, 188730),
(188731, '3.90.550.50-FF-000080', NULL, 'Hexosyltransferase', 258, NULL, NULL, 188731),
(188732, '2.110.10.10-FF-000051', NULL, 'Albumin-2', 228, NULL, NULL, 188732),
(188733, '3.40.50.300-FF-007767', NULL, 'NF-X1 finger and helicase domain protein, putative', 288, NULL, NULL, 188733);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(188734, '3.40.50.300-FF-000404', NULL, 'Putative ras-related protein Rab-35', 201, NULL, NULL, 188734),
(188735, '1.10.3720.10-FF-000117', NULL, 'ABC transporter permease', 228, NULL, NULL, 188735),
(188736, '3.30.1680.10-FF-000040', NULL, 'Integrin beta', 53, NULL, NULL, 188736),
(188737, '1.10.8.80-FF-000004', NULL, 'Methanol dehydrogenase transcriptional regulator MoxR', 108, NULL, NULL, 188737),
(188738, '3.10.20.90-FF-000139', NULL, 'ubiquitin-like protein 7', 100, NULL, NULL, 188738),
(188739, '1.10.510.10-FF-002362', NULL, NULL, 185, NULL, NULL, 188739),
(188740, '2.130.10.10-FF-003990', NULL, 'Uncharacterized protein', 230, NULL, NULL, 188740),
(188741, '1.10.472.80-FF-000236', NULL, NULL, 140, NULL, NULL, 188741),
(188742, '2.60.40.1180-FF-000180', NULL, 'Alpha-L-arabinofuranosidase A', 116, NULL, NULL, 188742),
(188743, '1.10.590.10-FF-000006', NULL, 'Chorismate mutase 2', 78, NULL, NULL, 188743),
(188744, '1.20.120.350-FF-000109', NULL, 'Calcium channel subunit Cch1', 94, NULL, NULL, 188744),
(188745, '1.20.58.1040-FF-000023', NULL, '1,3-beta-glucanosyltransferase', 125, NULL, NULL, 188745),
(188746, '1.10.10.10-FF-001749', NULL, 'Probable D-xylose utilization operon transcriptional repressor', 76, NULL, NULL, 188746),
(188747, '1.10.8.10-FF-000248', NULL, 'Uncharacterized protein', 44, NULL, NULL, 188747),
(188748, '3.10.450.10-FF-000084', NULL, 'Cysteine proteinase inhibitor', 85, NULL, NULL, 188748),
(188749, '1.20.58.70-FF-000005', NULL, 'syntaxin-5 isoform X1', 231, NULL, NULL, 188749),
(188750, '1.10.150.80-FF-000016', NULL, 'ATP-dependent DNA helicase', 71, NULL, NULL, 188750),
(188751, '3.80.10.10-FF-003821', NULL, 'Si:ch211-213a13.5', 74, NULL, NULL, 188751),
(188752, '1.10.540.10-FF-000060', NULL, 'Acyl-CoA dehydrogenase', 100, NULL, NULL, 188752),
(188753, '2.130.10.10-FF-005558', NULL, 'Predicted protein', 219, NULL, NULL, 188753),
(188754, '1.25.40.20-FF-000900', NULL, 'Uncharacterized protein', 78, NULL, NULL, 188754),
(188755, '1.50.40.10-FF-000496', NULL, 'Uncharacterized protein', 272, NULL, NULL, 188755),
(188756, '2.40.420.20-FF-000009', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 90, NULL, NULL, 188756),
(188757, '1.25.10.10-FF-003279', NULL, 'Predicted protein', 510, NULL, NULL, 188757),
(188758, '3.90.780.10-FF-000017', NULL, 'SA0140 protein', 208, NULL, NULL, 188758),
(188759, '1.20.1060.20-FF-000016', NULL, 'Structural maintenance of chromosomes protein 2', 171, NULL, NULL, 188759),
(188760, '1.10.510.10-FF-003896', NULL, NULL, 85, NULL, NULL, 188760),
(188761, '3.40.30.10-FF-000407', NULL, 'Putative glutaredoxin-like protein', 102, NULL, NULL, 188761),
(188762, '1.20.1330.10-FF-000006', NULL, 'Flagellar hook-associated protein FlgL', 155, NULL, NULL, 188762),
(188763, '3.40.50.720-FF-001238', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like protein', 164, NULL, NULL, 188763),
(188764, '3.30.70.330-FF-001605', NULL, NULL, 114, NULL, NULL, 188764),
(188765, '1.20.144.10-FF-000041', NULL, 'Wunen-2, isoform B', 213, NULL, NULL, 188765),
(188766, '2.102.10.10-FF-000046', NULL, 'Carbazole 1,9a-dioxygenase ferredoxin subunit', 107, NULL, NULL, 188766),
(188767, '1.20.58.80-FF-000008', NULL, 'serine/threonine-protein kinase ULK3 isoform X1', 75, NULL, NULL, 188767),
(188768, '3.60.21.10-FF-000374', NULL, 'Uncharacterized protein', 104, NULL, NULL, 188768),
(188769, '3.40.50.12350-FF-000009', NULL, 'Eyes absent homolog', 230, NULL, NULL, 188769),
(188770, '1.10.533.10-FF-000155', NULL, 'Zgc:194469', 84, NULL, NULL, 188770),
(188771, '2.70.170.10-FF-000305', NULL, 'Protein CBG01074', 91, NULL, NULL, 188771),
(188772, '1.20.58.390-FF-000217', NULL, 'Uncharacterized protein', 117, NULL, NULL, 188772),
(188773, '3.20.20.70-FF-000616', NULL, NULL, 115, NULL, NULL, 188773),
(188774, '3.40.1810.10-FF-000043', NULL, 'Uncharacterized protein', 71, NULL, NULL, 188774),
(188775, '2.40.30.10-FF-000342', NULL, 'Elongation factor Tu', 56, NULL, NULL, 188775),
(188776, '1.25.10.10-FF-002306', NULL, 'Uncharacterized protein', 321, NULL, NULL, 188776),
(188777, '1.10.287.130-FF-000259', NULL, 'Histidine kinase', 78, NULL, NULL, 188777);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(188778, '3.30.200.20-FF-002306', NULL, 'Uncharacterized protein', 92, NULL, NULL, 188778),
(188779, '3.40.50.300-FF-008043', NULL, 'Predicted protein', 131, NULL, NULL, 188779),
(188780, '1.10.220.10-FF-000029', NULL, 'Annexin', 45, NULL, NULL, 188780),
(188781, '2.130.10.10-FF-003198', NULL, 'Protein CFT1', 333, NULL, NULL, 188781),
(188782, '3.40.50.300-FF-000943', NULL, 'Cellulose synthase operon protein YhjQ', 237, NULL, NULL, 188782),
(188783, '2.60.40.10-FF-002713', NULL, 'Ephrin receptor 1', 95, NULL, NULL, 188783),
(188784, '3.20.20.70-FF-000498', NULL, NULL, 248, NULL, NULL, 188784),
(188785, '1.10.418.10-FF-000180', NULL, 'Uncharacterized protein', 108, NULL, NULL, 188785),
(188786, '3.40.50.2300-FF-001458', NULL, NULL, 78, NULL, NULL, 188786),
(188787, '3.10.105.10-FF-000086', NULL, 'Putative oligopeptide ABC transporter,substrate-binding protein', 210, NULL, NULL, 188787),
(188788, '3.40.50.300-FF-007868', NULL, 'DNA helicase', 208, NULL, NULL, 188788),
(188789, '2.60.260.20-FF-000008', NULL, 'Curved DNA-binding protein', 83, NULL, NULL, 188789),
(188790, '3.40.50.10490-FF-000087', NULL, 'Predicted protein', 339, NULL, NULL, 188790),
(188791, '3.90.850.10-FF-000029', NULL, 'Fumarylacetoacetate hydrolase domain-containing protein 2A', 287, NULL, NULL, 188791),
(188792, '2.60.40.150-FF-000480', NULL, 'Phosphatidylinositol 3-kinase VPS34', 149, NULL, NULL, 188792),
(188793, '3.30.70.3190-FF-000002', NULL, 'tRNA pseudouridine(54/55) synthase', 120, NULL, NULL, 188793),
(188794, '1.20.120.350-FF-000216', NULL, NULL, 107, NULL, NULL, 188794),
(188795, '1.10.10.60-FF-000207', NULL, 'paired mesoderm homeobox protein 2A', 85, NULL, NULL, 188795),
(188796, '1.25.40.10-FF-000335', NULL, 'Factor VIII intron 22 protein', 195, NULL, NULL, 188796),
(188797, '2.40.150.20-FF-000016', NULL, 'Apicoplast ribosomal protein L14', 115, NULL, NULL, 188797),
(188798, '3.40.1160.10-FF-000077', NULL, 'Uridylate kinase', 56, NULL, NULL, 188798),
(188799, '1.10.472.130-FF-000041', NULL, 'Dynein heavy chain', 192, NULL, NULL, 188799),
(188800, '3.40.50.2000-FF-000969', NULL, 'Uncharacterized protein', 94, NULL, NULL, 188800),
(188801, '1.20.5.340-FF-000113', NULL, 'Viral A-type inclusion protein, putative', 93, NULL, NULL, 188801),
(188802, '3.40.50.300-FF-004221', NULL, 'Bifunctional fructose-2,6-bisphosphate 2-phosphatase/6-phosphofructo-2-kinase', 214, NULL, NULL, 188802),
(188803, '3.20.20.140-FF-000265', NULL, 'Uncharacterized protein', 161, NULL, NULL, 188803),
(188804, '1.25.40.10-FF-003994', NULL, 'Uncharacterized protein', 213, NULL, NULL, 188804),
(188805, '2.70.170.10-FF-000075', NULL, 'Uncharacterized protein', 223, NULL, NULL, 188805),
(188806, '1.10.150.20-FF-000021', NULL, 'DNA-directed RNA polymerase subunit alpha', 61, NULL, NULL, 188806),
(188807, '2.40.110.10-FF-000011', NULL, 'Acyl-CoA dehydrogenase FadE34', 111, NULL, NULL, 188807),
(188808, '2.70.150.10-FF-000080', NULL, 'Phospholipid-transporting ATPase', 152, NULL, NULL, 188808),
(188809, '2.30.30.140-FF-000257', NULL, 'SAGA-associated factor 29', 76, NULL, NULL, 188809),
(188810, '3.30.1490.10-FF-000008', NULL, NULL, 38, NULL, NULL, 188810),
(188811, '3.30.830.10-FF-000322', NULL, 'Uncharacterized protein', 257, NULL, NULL, 188811),
(188812, '2.130.10.10-FF-000544', NULL, 'cleavage and polyadenylation specificity factor subunit 1', 130, NULL, NULL, 188812),
(188813, '3.10.100.10-FF-000120', NULL, 'Predicted protein', 134, NULL, NULL, 188813),
(188814, '3.80.10.10-FF-001135', NULL, 'Leucine Rich Repeat family protein, expressed', 278, NULL, NULL, 188814),
(188815, '3.30.930.10-FF-000369', NULL, 'Glycyl tRNA synthetase', 312, NULL, NULL, 188815),
(188816, '3.30.70.3400-FF-000015', NULL, 'Protein-export membrane protein SecD', 58, NULL, NULL, 188816),
(188817, '4.10.280.10-FF-000067', NULL, 'upstream stimulatory factor 1 isoform X1', 93, NULL, NULL, 188817),
(188818, '3.40.50.300-FF-002074', NULL, 'Elongator acetyltransferase complex subunit 4', 318, NULL, NULL, 188818),
(188819, '2.60.120.620-FF-000068', NULL, 'Procollagen-lysine, 2-oxoglutarate 5-dioxygenase 2', 178, NULL, NULL, 188819);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(188820, '2.40.160.120-FF-000021', NULL, 'Unplaced genomic scaffold supercont2.12, whole genome shotgun sequence', 208, NULL, NULL, 188820),
(188821, '1.20.890.10-FF-000004', NULL, 'ropporin-1-like protein isoform X2', 41, NULL, NULL, 188821),
(188822, '3.30.160.60-FF-002146', NULL, 'zinc finger protein 596-like', 30, NULL, NULL, 188822),
(188823, '3.30.40.10-FF-001386', NULL, 'RUM1', 65, NULL, NULL, 188823),
(188824, '1.20.50.20-FF-000006', NULL, 'DNA primase', 55, NULL, NULL, 188824),
(188825, '1.10.20.10-FF-000272', NULL, NULL, 79, NULL, NULL, 188825),
(188826, '2.40.10.10-FF-000127', NULL, 'Probable threonine protease PRSS50', 129, NULL, NULL, 188826),
(188827, '1.10.510.10-FF-002036', NULL, 'Gliding motility related CaM kinase', 286, NULL, NULL, 188827),
(188828, '3.10.20.90-FF-000920', NULL, 'Histidine ammonia-lyase', 83, NULL, NULL, 188828),
(188829, '1.20.1440.200-FF-000009', NULL, 'Vacuolar protein sorting-associated protein 28 homolog', 80, NULL, NULL, 188829),
(188830, '3.40.1390.10-FF-000004', NULL, 'UDP-N-acetylmuramoyl-tripeptide--D-alanyl-D-alanine ligase', 80, NULL, NULL, 188830),
(188831, '3.40.640.10-FF-000440', NULL, 'Perosamine synthetase-related protein', 201, NULL, NULL, 188831),
(188832, '3.40.50.2300-FF-001565', NULL, NULL, 116, NULL, NULL, 188832),
(188833, '3.30.40.10-FF-001493', NULL, 'Zinc finger protein, putative', 79, NULL, NULL, 188833),
(188834, '3.40.50.1820-FF-001292', NULL, 'Uncharacterized protein', 280, NULL, NULL, 188834),
(188835, '2.40.40.20-FF-000065', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 69, NULL, NULL, 188835),
(188836, '3.30.160.40-FF-000004', NULL, 'Porphobilinogen deaminase', 83, NULL, NULL, 188836),
(188837, '3.30.160.60-FF-002253', NULL, 'Zinc finger protein 334', 28, NULL, NULL, 188837),
(188838, '3.30.70.890-FF-000008', NULL, 'L-arabinokinase', 133, NULL, NULL, 188838),
(188839, '2.30.33.40-FF-000015', NULL, '10 kDa chaperonin', 101, NULL, NULL, 188839),
(188840, '2.130.10.10-FF-003877', NULL, 'WD repeat protein, putative', 279, NULL, NULL, 188840),
(188841, '2.60.40.10-FF-002820', NULL, 'High Incidence of Males (Increased X chromosome loss)', 88, NULL, NULL, 188841),
(188842, '3.40.140.10-FF-000200', NULL, 'Cytidine deaminase', 112, NULL, NULL, 188842),
(188843, '1.10.418.10-FF-000073', NULL, 'Kinesin-like protein KIN-14L', 158, NULL, NULL, 188843),
(188844, '1.10.1200.10-FF-000073', NULL, 'Yersiniabactin polyketide/non-ribosomal peptide synthetase', 93, NULL, NULL, 188844),
(188845, '1.20.5.350-FF-000009', NULL, 'Troponin T, slow skeletal muscle', 62, NULL, NULL, 188845),
(188846, '3.30.70.330-FF-001375', NULL, 'Uncharacterized protein, isoform D', 156, NULL, NULL, 188846),
(188847, '2.130.10.10-FF-000437', NULL, 'cleavage and polyadenylation specificity factor subunit 1', 380, NULL, NULL, 188847),
(188848, '1.20.1250.20-FF-001245', NULL, 'Predicted protein', 311, NULL, NULL, 188848),
(188849, '2.40.170.20-FF-000118', NULL, 'SusC homolog', 546, NULL, NULL, 188849),
(188850, '1.25.40.10-FF-001858', NULL, 'TPR_repeat/Tetratricopeptide_repeat/Uncharacterized_protein_family_(UPF0121)_-_putative', 132, NULL, NULL, 188850),
(188851, '3.90.550.10-FF-000085', NULL, 'Glycogenin, isoform B', 260, NULL, NULL, 188851),
(188852, '1.20.58.390-FF-000212', NULL, 'Nicotinic acetylcholine receptor subunit', 84, NULL, NULL, 188852),
(188853, '3.90.470.20-FF-000036', NULL, 'Lipopeptide antibiotics iturin a biosynthesisprotein', 88, NULL, NULL, 188853),
(188854, '3.30.70.870-FF-000002', NULL, 'Translation elongation factor 2', 77, NULL, NULL, 188854),
(188855, '1.20.5.340-FF-000006', NULL, 'Myosin heavy chain', 114, NULL, NULL, 188855),
(188856, '1.10.510.10-FF-002822', NULL, NULL, 122, NULL, NULL, 188856),
(188857, '2.10.90.10-FF-000156', NULL, 'Glycoprotein hormone beta, putative', 90, NULL, NULL, 188857),
(188858, '3.40.50.300-FF-006345', NULL, 'Uncharacterized protein', 154, NULL, NULL, 188858),
(188859, '3.10.20.90-FF-000134', NULL, 'UBX domain-containing protein 1', 90, NULL, NULL, 188859),
(188860, '3.90.980.20-FF-000013', NULL, 'Uncharacterized protein', 119, NULL, NULL, 188860);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(188861, '3.80.10.10-FF-002765', NULL, 'Uncharacterized protein', 324, NULL, NULL, 188861),
(188862, '1.10.730.10-FF-000107', NULL, 'Protein CBG19783', 172, NULL, NULL, 188862),
(188863, '3.10.450.10-FF-000090', NULL, 'Uncharacterized protein', 120, NULL, NULL, 188863),
(188864, '3.40.720.10-FF-000278', NULL, 'Uncharacterized protein', 313, NULL, NULL, 188864),
(188865, '1.10.287.110-FF-000472', NULL, 'Uncharacterized protein', 117, NULL, NULL, 188865),
(188866, '3.40.50.2300-FF-000042', NULL, 'Metabotropic glutamate receptor 3', 286, NULL, NULL, 188866),
(188867, '3.30.40.10-FF-001504', NULL, 'Predicted protein', 75, NULL, NULL, 188867),
(188868, '3.40.50.300-FF-003597', NULL, 'UMP-CMP kinase, mitochondrial, putative', 188, NULL, NULL, 188868),
(188869, '3.40.50.300-FF-006238', NULL, 'Myb domain-containing protein', 250, NULL, NULL, 188869),
(188870, '1.10.533.10-FF-000256', NULL, 'Uncharacterized protein', 100, NULL, NULL, 188870),
(188871, '2.60.120.10-FF-000760', NULL, 'Predicted protein', 73, NULL, NULL, 188871),
(188872, '3.20.20.10-FF-000071', NULL, 'Uncharacterized protein', 60, NULL, NULL, 188872),
(188873, '3.80.10.10-FF-002658', NULL, 'MDIS1-interacting receptor like kinase 2', 71, NULL, NULL, 188873),
(188874, '3.40.630.30-FF-000165', NULL, 'IAA acetyltransferase', 147, NULL, NULL, 188874),
(188875, '3.40.50.720-FF-001019', NULL, '2-hydroxyacid dehydrogenase family protein', 187, NULL, NULL, 188875),
(188876, '3.40.50.720-FF-001805', NULL, 'Uncharacterized protein', 132, NULL, NULL, 188876),
(188877, '1.10.1450.10-FF-000107', NULL, 'Tetraspanin', 105, NULL, NULL, 188877),
(188878, '1.10.510.10-FF-002143', NULL, 'Kinase, NEK', 202, NULL, NULL, 188878),
(188879, '2.30.180.10-FF-000006', NULL, 'Fasciclin-like arabinogalactan protein 11', 164, NULL, NULL, 188879),
(188880, '2.120.10.30-FF-000062', NULL, 'NHL repeat containing 2', 154, NULL, NULL, 188880),
(188881, '1.25.40.10-FF-001639', NULL, 'Pentatricopeptide repeat-containing protein', 164, NULL, NULL, 188881),
(188882, '1.20.140.90-FF-000011', NULL, 'Uncharacterized protein', 66, NULL, NULL, 188882),
(188883, '3.40.50.2020-FF-000065', NULL, 'Ribose-phosphate pyrophosphokinase putative', 161, NULL, NULL, 188883),
(188884, '3.30.40.10-FF-000200', NULL, 'Lysine-specific demethylase 5B', 82, NULL, NULL, 188884),
(188885, '1.10.555.10-FF-000094', NULL, 'RhoGAP domain containing protein', 192, NULL, NULL, 188885),
(188886, '3.40.50.1820-FF-001185', NULL, 'Uncharacterized protein', 125, NULL, NULL, 188886),
(188887, '3.40.50.1820-FF-001073', NULL, 'Endo-1,4-beta-xylanase Y', 287, NULL, NULL, 188887),
(188888, '2.30.180.10-FF-000118', NULL, NULL, 128, NULL, NULL, 188888),
(188889, '3.80.10.10-FF-001461', NULL, 'Leucine-rich repeat-containing protein 49', 86, NULL, NULL, 188889),
(188890, '2.60.40.10-FF-004063', NULL, NULL, 96, NULL, NULL, 188890),
(188891, '3.10.50.40-FF-000087', NULL, 'Peptidylprolyl isomerase', 136, NULL, NULL, 188891),
(188892, '1.20.58.390-FF-000094', NULL, 'Ligand-Gated ion Channel', 160, NULL, NULL, 188892),
(188893, '3.10.25.10-FF-000008', NULL, 'Putative methionyl-tRNA formyltransferase', 119, NULL, NULL, 188893),
(188894, '1.20.1330.10-FF-000001', NULL, 'Flagellin', 128, NULL, NULL, 188894),
(188895, '2.100.10.30-FF-000006', NULL, 'Prostatic spermine-binding protein', 150, NULL, NULL, 188895),
(188896, '2.40.10.10-FF-000346', NULL, NULL, 128, NULL, NULL, 188896),
(188897, '2.60.120.330-FF-000195', NULL, 'Uncharacterized protein', 167, NULL, NULL, 188897),
(188898, '2.40.10.10-FF-000234', NULL, 'Coagulation factor VIIi', 123, NULL, NULL, 188898),
(188899, '3.30.1300.10-FF-000006', NULL, 'Pantoate--beta-alanine ligase', 102, NULL, NULL, 188899),
(188900, '1.10.269.10-FF-000001', NULL, 'DNA-binding protein', 98, NULL, NULL, 188900),
(188901, '3.30.70.330-FF-001268', NULL, 'RNA recognition motif domain containing protein', 96, NULL, NULL, 188901),
(188902, '2.20.28.10-FF-000028', NULL, 'DNA helicase', 65, NULL, NULL, 188902),
(188903, '1.10.510.10-FF-000905', NULL, 'Non-specific serine/threonine protein kinase', 274, NULL, NULL, 188903);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(188904, '3.30.70.330-FF-001156', NULL, 'U2 snRNP auxiliary factor small subunit, putative', 96, NULL, NULL, 188904),
(188905, '3.30.210.10-FF-000005', NULL, 'DNA polymerase IV', 76, NULL, NULL, 188905),
(188906, '2.60.120.10-FF-000541', NULL, 'Protein kinase, putative', 159, NULL, NULL, 188906),
(188907, '1.20.1000.10-FF-000010', NULL, 'Uncharacterized protein', 278, NULL, NULL, 188907),
(188908, '3.30.310.10-FF-000064', NULL, 'Uncharacterized protein', 135, NULL, NULL, 188908),
(188909, '3.30.160.60-FF-002472', NULL, NULL, 28, NULL, NULL, 188909),
(188910, '1.10.220.100-FF-000003', NULL, 'Uncharacterized protein', 79, NULL, NULL, 188910),
(188911, '2.30.39.10-FF-000076', NULL, 'Serine protease inhibitor (SERPIN) family protein', 61, NULL, NULL, 188911),
(188912, '1.20.1070.10-FF-001144', NULL, 'Probable G-protein coupled receptor C06G4.5', 348, NULL, NULL, 188912),
(188913, '2.60.120.560-FF-000033', NULL, 'Putative galactocerebrosidase', 199, NULL, NULL, 188913),
(188914, '3.40.50.920-FF-000005', NULL, 'Pyruvate dehydrogenase E1 component', 181, NULL, NULL, 188914),
(188915, '2.60.120.470-FF-000006', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 172, NULL, NULL, 188915),
(188916, '2.60.40.1180-FF-000185', NULL, 'Glycoside hydrolase family 13 protein', 96, NULL, NULL, 188916),
(188917, '2.60.40.1170-FF-000070', NULL, NULL, 113, NULL, NULL, 188917),
(188918, '3.40.1110.10-FF-000473', NULL, NULL, 14, NULL, NULL, 188918),
(188919, '1.10.10.60-FF-000314', NULL, 'Small nuclear RNA-activating complex, polypeptide 4', 51, NULL, NULL, 188919),
(188920, '1.10.10.60-FF-000533', NULL, 'Homeobox-leucine zipper protein ATHB-52', 67, NULL, NULL, 188920),
(188921, '2.80.10.50-FF-000233', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 126, NULL, NULL, 188921),
(188922, '2.10.25.160-FF-000004', NULL, 'Granulin precursor', 64, NULL, NULL, 188922),
(188923, '2.60.40.1180-FF-000073', NULL, 'Alpha-amylase', 95, NULL, NULL, 188923),
(188924, '3.40.630.10-FF-000052', NULL, 'Amidohydrolase amhX', 237, NULL, NULL, 188924),
(188925, '1.20.58.60-FF-000587', NULL, 'Plectin', 210, NULL, NULL, 188925),
(188926, '2.30.29.30-FF-000587', NULL, 'FERM domain (Protein4.1-ezrin-radixin-moesin) family', 174, NULL, NULL, 188926),
(188927, '2.10.25.10-FF-000983', NULL, 'Eyes shut, isoform E', 40, NULL, NULL, 188927),
(188928, '1.25.40.10-FF-000228', NULL, 'Serine/threonine-protein kinase TOR', 493, NULL, NULL, 188928),
(188929, '3.30.1320.10-FF-000013', NULL, 'Mitochondrial ribosomal protein', 119, NULL, NULL, 188929),
(188930, '1.20.1370.10-FF-000003', NULL, 'Larval serum protein 1 gamma', 131, NULL, NULL, 188930),
(188931, '3.40.1360.10-FF-000058', NULL, 'Zinc finger CHC2-family protein', 110, NULL, NULL, 188931),
(188932, '3.20.20.70-FF-000279', NULL, 'tRNA-dihydrouridine synthase', 237, NULL, NULL, 188932),
(188933, '3.40.640.10-FF-000114', NULL, 'Transcriptional regulator, GntR family', 370, NULL, NULL, 188933),
(188934, '3.10.20.70-FF-000021', NULL, 'L-glutamine synthetase', 118, NULL, NULL, 188934),
(188935, '1.25.40.10-FF-000009', NULL, 'Clathrin heavy chain', 216, NULL, NULL, 188935),
(188936, '1.20.5.110-FF-000168', NULL, 'Ehsyntaxin 1B, putative', 108, NULL, NULL, 188936),
(188937, '3.30.70.330-FF-000071', NULL, 'heterogeneous nuclear ribonucleoprotein H isoform X1', 100, NULL, NULL, 188937),
(188938, '3.40.1550.20-FF-000003', NULL, 'Transcriptional regulator MraZ', 140, NULL, NULL, 188938),
(188939, '3.40.50.150-FF-000651', NULL, 'Mycinamicin VI 2''''-O-methyltransferase', 223, NULL, NULL, 188939),
(188940, '3.40.50.300-FF-000724', NULL, 'F-box DNA helicase 1 isoform X2', 178, NULL, NULL, 188940),
(188941, '3.20.20.70-FF-000509', NULL, 'Biotin synthase', 310, NULL, NULL, 188941),
(188942, '3.30.1370.10-FF-000050', NULL, 'vigilin isoform X1', 65, NULL, NULL, 188942),
(188943, '3.30.2320.80-FF-000006', NULL, 'Hydrogenase maturation factor HypA 1', 113, NULL, NULL, 188943),
(188944, '4.10.1240.10-FF-000084', NULL, 'C1A receptor, putative', 63, NULL, NULL, 188944),
(188945, '2.40.30.220-FF-000003', NULL, NULL, 71, NULL, NULL, 188945);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(188946, '3.40.720.10-FF-000166', NULL, 'Type I phosphodiesterase/nucleotide pyrophosphatase', 279, NULL, NULL, 188946),
(188947, '1.25.10.10-FF-000507', NULL, 'Exportin-2', 956, NULL, NULL, 188947),
(188948, '2.160.20.10-FF-000010', NULL, 'Pectinesterase', 402, NULL, NULL, 188948),
(188949, '2.130.10.10-FF-004041', NULL, 'Uncharacterized protein', 218, NULL, NULL, 188949),
(188950, '1.10.3730.20-FF-000060', NULL, 'solute carrier family 35 member G1-like', 138, NULL, NULL, 188950),
(188951, '1.25.50.20-FF-000064', NULL, 'Peptidase family m1 protein, putative', 58, NULL, NULL, 188951),
(188952, '3.10.120.10-FF-000003', NULL, 'membrane-associated progesterone receptor component 1', 107, NULL, NULL, 188952),
(188953, '1.20.1110.10-FF-000243', NULL, 'Sodium/potassium-transporting ATPase subunit alpha', 410, NULL, NULL, 188953),
(188954, '2.40.30.230-FF-000006', NULL, 'Unplaced genomic scaffold supercont2.5, whole genome shotgun sequence', 106, NULL, NULL, 188954),
(188955, '1.20.140.40-FF-000024', NULL, 'Pectinesterase', 162, NULL, NULL, 188955),
(188956, '2.130.10.10-FF-000325', NULL, 'TAF5-like RNA polymerase II p300/CBP-associated factor-associated factor 65 kDa subunit 5L', 87, NULL, NULL, 188956),
(188957, '1.25.40.10-FF-002252', NULL, 'TPR repeat, putative', 158, NULL, NULL, 188957),
(188958, '3.30.70.330-FF-002898', NULL, NULL, 50, NULL, NULL, 188958),
(188959, '2.60.40.10-FF-005693', NULL, NULL, 73, NULL, NULL, 188959),
(188960, '3.40.50.300-FF-004440', NULL, 'tRNA (Adenosine(37)-N6)-threonylcarbamoyltransferase complex ATPase subunit type 1 TsaE', 157, NULL, NULL, 188960),
(188961, '1.20.120.1760-FF-000067', NULL, NULL, 104, NULL, NULL, 188961),
(188962, '3.20.20.140-FF-000484', NULL, 'Predicted protein', 73, NULL, NULL, 188962),
(188963, '3.30.200.20-FF-001924', NULL, 'Receptor-like protein kinase FERONIA', 104, NULL, NULL, 188963),
(188964, '1.10.240.10-FF-000025', NULL, 'Tryptophanyl-tRNA synthetase', 75, NULL, NULL, 188964),
(188965, '2.60.120.920-FF-000170', NULL, 'Uncharacterized protein', 96, NULL, NULL, 188965),
(188966, '3.40.50.10330-FF-000067', NULL, 'Ceramide kinase-like isoform 12', 56, NULL, NULL, 188966),
(188967, '1.20.1270.280-FF-000016', NULL, 'Dynein beta chain, putative', 154, NULL, NULL, 188967),
(188968, '2.10.220.10-FF-000150', NULL, 'R-spondin-3', 110, NULL, NULL, 188968),
(188969, '2.130.10.10-FF-002910', NULL, 'Predicted protein', 176, NULL, NULL, 188969),
(188970, '1.20.1250.20-FF-001464', NULL, 'Uncharacterized protein', 222, NULL, NULL, 188970),
(188971, '3.80.10.10-FF-002877', NULL, 'Septation initiation network scaffold protein cdc11', 100, NULL, NULL, 188971),
(188972, '3.60.21.10-FF-000150', NULL, 'Serine/threonine-protein phosphatase', 292, NULL, NULL, 188972),
(188973, '1.20.1070.10-FF-001363', NULL, 'Predicted protein', 263, NULL, NULL, 188973),
(188974, '3.10.20.30-FF-000037', NULL, 'YGR210C-like protein', 79, NULL, NULL, 188974),
(188975, '1.25.40.1030-FF-000049', NULL, 'Uncharacterized protein', 234, NULL, NULL, 188975),
(188976, '3.30.160.60-FF-005693', NULL, NULL, 64, NULL, NULL, 188976),
(188977, '3.30.160.60-FF-003669', NULL, NULL, 27, NULL, NULL, 188977),
(188978, '2.10.25.10-FF-001702', NULL, 'Integrin beta', 41, NULL, NULL, 188978),
(188979, '4.10.640.10-FF-000044', NULL, 'Uncharacterized protein', 64, NULL, NULL, 188979),
(188980, '3.40.50.300-FF-006126', NULL, 'Dynein heavy chain, cytoplasmic', 210, NULL, NULL, 188980),
(188981, '2.60.40.60-FF-000008', NULL, 'Cadherin 24', 109, NULL, NULL, 188981),
(188982, '3.80.10.10-FF-003501', NULL, 'Protein phosphatase 1 regulatory subunit SDS22 homolog', 188, NULL, NULL, 188982),
(188983, '1.10.510.10-FF-002255', NULL, NULL, 101, NULL, NULL, 188983),
(188984, '1.10.3090.10-FF-000035', NULL, 'Predicted protein', 146, NULL, NULL, 188984),
(188985, '2.60.120.380-FF-000075', NULL, 'Uncharacterized protein', 180, NULL, NULL, 188985),
(188986, '3.50.50.60-FF-001479', NULL, 'Rab GDP dissociation inhibitor', 56, NULL, NULL, 188986),
(188987, '3.10.20.690-FF-000004', NULL, 'DNA gyrase subunit B', 86, NULL, NULL, 188987);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(188988, '3.30.200.20-FF-001587', NULL, 'Uncharacterized protein', 92, NULL, NULL, 188988),
(188989, '3.10.20.90-FF-000701', NULL, 'Myosin-G heavy chain', 96, NULL, NULL, 188989),
(188990, '3.20.20.70-FF-000386', NULL, 'Mutator MutT protein', 188, NULL, NULL, 188990),
(188991, '2.40.50.140-FF-000410', NULL, 'CST complex subunit TEN1', 118, NULL, NULL, 188991),
(188992, '1.20.1070.10-FF-000981', NULL, 'Predicted protein', 295, NULL, NULL, 188992),
(188993, '3.40.605.10-FF-000090', NULL, 'Aldehyde dehydrogenase', 93, NULL, NULL, 188993),
(188994, '1.25.10.10-FF-002076', NULL, 'PIKK family atypical protein kinase', 253, NULL, NULL, 188994),
(188995, '3.40.50.1240-FF-000027', NULL, '3-phytase A', 391, NULL, NULL, 188995),
(188996, '2.60.40.60-FF-000901', NULL, 'Uncharacterized protein', 157, NULL, NULL, 188996),
(188997, '3.40.630.30-FF-000384', NULL, 'N-acetyltransferase, putative', 140, NULL, NULL, 188997),
(188998, '1.10.510.10-FF-001979', NULL, 'Receptor protein kinase TMK1', 219, NULL, NULL, 188998),
(188999, '3.40.50.300-FF-005856', NULL, 'Uncharacterized protein', 291, NULL, NULL, 188999),
(189000, '3.20.20.80-FF-000389', NULL, 'Uncharacterized protein', 45, NULL, NULL, 189000),
(189001, '2.40.160.10-FF-000053', NULL, 'Porin', 384, NULL, NULL, 189001),
(189002, '1.10.510.10-FF-002603', NULL, NULL, 170, NULL, NULL, 189002),
(189003, '1.10.238.10-FF-000205', NULL, 'calcineurin B homologous protein 3', 210, NULL, NULL, 189003),
(189004, '3.40.1350.10-FF-000007', NULL, 'tRNA-splicing endonuclease subunit Sen2', 107, NULL, NULL, 189004),
(189005, '1.10.1420.10-FF-000049', NULL, 'DNA mismatch repair protein MutS', 139, NULL, NULL, 189005),
(189006, '1.10.510.10-FF-003778', NULL, NULL, 134, NULL, NULL, 189006),
(189007, '3.10.270.10-FF-000008', NULL, 'Uricase', 143, NULL, NULL, 189007),
(189008, '3.60.21.10-FF-000043', NULL, 'Ser/Thr protein phosphatase family', 326, NULL, NULL, 189008),
(189009, '1.25.10.10-FF-002424', NULL, 'Sister chromatid cohesion protein mis4', 247, NULL, NULL, 189009),
(189010, '2.60.40.60-FF-000553', NULL, 'cadherin EGF LAG seven-pass G-type receptor 2 isoform X2', 105, NULL, NULL, 189010),
(189011, '1.10.560.10-FF-000061', NULL, '60 kDa chaperonin GROEL', 169, NULL, NULL, 189011),
(189012, '2.60.40.790-FF-000104', NULL, 'PTGES3L isoform 3', 59, NULL, NULL, 189012),
(189013, '1.10.555.10-FF-000099', NULL, 'T-cell activation Rho GTPase activating protein, putative', 182, NULL, NULL, 189013),
(189014, '3.20.20.140-FF-000377', NULL, 'Predicted protein', 207, NULL, NULL, 189014),
(189015, '1.10.510.10-FF-004402', NULL, NULL, 85, NULL, NULL, 189015),
(189016, '2.70.150.10-FF-000192', NULL, 'Chromosome 1, whole genome shotgun sequence', 162, NULL, NULL, 189016),
(189017, '2.60.40.10-FF-004400', NULL, NULL, 95, NULL, NULL, 189017),
(189018, '1.25.40.10-FF-003882', NULL, 'Uncharacterized protein', 84, NULL, NULL, 189018),
(189019, '1.10.287.890-FF-000003', NULL, 'Adenylate isopentenyltransferase', 108, NULL, NULL, 189019),
(189020, '3.40.50.12350-FF-000010', NULL, 'Eyes absent homolog', 216, NULL, NULL, 189020),
(189021, '3.70.10.10-FF-000034', NULL, 'Checkpoint protein', 259, NULL, NULL, 189021),
(189022, '1.20.1250.20-FF-001801', NULL, 'Solute carrier family 22 member 12', 172, NULL, NULL, 189022),
(189023, '3.40.50.300-FF-002186', NULL, 'Chromatin structure-remodeling complex subunit snf21', 302, NULL, NULL, 189023),
(189024, '3.40.50.1820-FF-001180', NULL, 'Uncharacterized protein', 196, NULL, NULL, 189024),
(189025, '3.40.50.300-FF-002860', NULL, 'Rab32/ GTPase', 187, NULL, NULL, 189025),
(189026, '1.20.1000.10-FF-000015', NULL, 'Uncharacterized protein', 312, NULL, NULL, 189026),
(189027, '3.30.420.40-FF-000047', NULL, 'Actin-like protein 6A', 118, NULL, NULL, 189027),
(189028, '3.40.30.10-FF-000963', NULL, 'Uncharacterized protein C1840.08c', 99, NULL, NULL, 189028),
(189029, '3.30.160.60-FF-000903', NULL, 'Tripartite motif-containing protein 29', 70, NULL, NULL, 189029),
(189030, '3.40.50.360-FF-000158', NULL, 'AGAP000500-PA', 98, NULL, NULL, 189030),
(189031, '1.20.1300.10-FF-000050', NULL, 'Uncharacterized protein', 77, NULL, NULL, 189031);
INSERT INTO "PUBLIC"."MODEL" VALUES
(189032, '3.30.160.60-FF-000229', NULL, 'Zinc finger protein 90 homolog', 28, NULL, NULL, 189032),
(189033, '1.10.220.10-FF-000030', NULL, 'Annexin', 72, NULL, NULL, 189033),
(189034, '1.10.8.10-FF-000366', NULL, 'Protein CBG07636', 49, NULL, NULL, 189034),
(189035, '2.60.40.150-FF-000603', NULL, 'Zgc:158659', 50, NULL, NULL, 189035),
(189036, '2.60.40.10-FF-004282', NULL, NULL, 119, NULL, NULL, 189036),
(189037, '2.30.29.30-FF-001188', NULL, 'Uncharacterized PH domain-containing protein PB16A4.02c', 136, NULL, NULL, 189037),
(189038, '3.90.190.10-FF-000568', NULL, 'Tyrosine specific protein phosphatase family protein', 49, NULL, NULL, 189038),
(189039, '3.90.230.10-FF-000050', NULL, NULL, 308, NULL, NULL, 189039),
(189040, '2.130.10.10-FF-002461', NULL, 'Uncharacterized protein', 187, NULL, NULL, 189040),
(189041, '3.30.60.30-FF-000078', NULL, 'Predicted protein', 68, NULL, NULL, 189041),
(189042, '3.90.1420.10-FF-000030', NULL, 'Protein CBR-SET-27', 141, NULL, NULL, 189042),
(189043, '3.30.540.10-FF-000103', NULL, 'Uncharacterized protein', 61, NULL, NULL, 189043),
(189044, '3.30.420.100-FF-000014', NULL, 'Ribosomal protein L5', 293, NULL, NULL, 189044),
(189045, '1.10.287.1490-FF-000049', NULL, 'Cingulin', 183, NULL, NULL, 189045),
(189046, '3.10.20.90-FF-000027', NULL, 'Ras association (RalGDS/AF-6) and pleckstrin homology domains 1', 118, NULL, NULL, 189046),
(189047, '1.20.5.730-FF-000016', NULL, 'Uncharacterized protein', 37, NULL, NULL, 189047),
(189048, '3.40.50.2300-FF-001239', NULL, NULL, 88, NULL, NULL, 189048),
(189049, '3.30.420.110-FF-000017', NULL, 'DNA mismatch repair protein MutS', 129, NULL, NULL, 189049),
(189050, '1.25.40.20-FF-000905', NULL, 'Ankyrin repeat and SOCS box protein 2', 154, NULL, NULL, 189050),
(189051, '1.25.40.20-FF-000119', NULL, 'Ankyrin repeat and SOCS box containing 1', 247, NULL, NULL, 189051),
(189052, '3.30.70.980-FF-000035', NULL, 'WGS project CABT00000000 data, contig 2.5', 82, NULL, NULL, 189052),
(189053, '1.20.1070.10-FF-001251', NULL, 'Uncharacterized protein', 255, NULL, NULL, 189053),
(189054, '2.130.10.10-FF-005457', NULL, 'Uncharacterized protein', 183, NULL, NULL, 189054),
(189055, '3.40.50.300-FF-000387', NULL, 'neuronal-specific septin-3 isoform X1', 270, NULL, NULL, 189055),
(189056, '3.30.40.10-FF-001942', NULL, 'Uncharacterized protein', 68, NULL, NULL, 189056),
(189057, '1.10.510.10-FF-004060', NULL, NULL, 232, NULL, NULL, 189057),
(189058, '3.30.70.3000-FF-000002', NULL, 'tRNA(His) guanylyltransferase 1', 259, NULL, NULL, 189058),
(189059, '3.40.630.30-FF-000058', NULL, 'N-acetyltransferase (Nat5)', 183, NULL, NULL, 189059),
(189060, '2.10.90.10-FF-000049', NULL, 'Glycoprotein hormone alpha 2', 110, NULL, NULL, 189060),
(189061, '2.60.40.1260-FF-000001', NULL, 'Lamin A/C', 151, NULL, NULL, 189061),
(189062, '3.40.1000.10-FF-000026', NULL, 'RGM domain family, member B, isoform CRA_a', 51, NULL, NULL, 189062),
(189063, '2.130.10.10-FF-000106', NULL, 'WD repeat domain 24', 308, NULL, NULL, 189063),
(189064, '2.40.30.10-FF-000241', NULL, 'Elongation factor Tu', 56, NULL, NULL, 189064),
(189065, '3.20.20.70-FF-000728', NULL, NULL, 96, NULL, NULL, 189065),
(189066, '1.20.58.390-FF-000105', NULL, 'AcetylCholine Receptor', 68, NULL, NULL, 189066),
(189067, '3.90.1600.10-FF-000021', NULL, 'DNA polymerase', 84, NULL, NULL, 189067),
(189068, '3.30.200.20-FF-001929', NULL, 'Uncharacterized protein', 94, NULL, NULL, 189068),
(189069, '1.25.70.10-FF-000056', NULL, NULL, 78, NULL, NULL, 189069),
(189070, '2.30.42.10-FF-000100', NULL, 'Shroom family member 2', 86, NULL, NULL, 189070),
(189071, '3.30.200.20-FF-001705', NULL, 'Predicted protein', 52, NULL, NULL, 189071),
(189072, '1.25.40.20-FF-000557', NULL, 'Os07g0193200 protein', 130, NULL, NULL, 189072),
(189073, '2.30.30.40-FF-000211', NULL, 'Tyrosine-protein kinase', 71, NULL, NULL, 189073),
(189074, '3.30.1330.30-FF-000059', NULL, 'Protein pelota homolog', 101, NULL, NULL, 189074),
(189075, '3.60.21.60-FF-000029', NULL, 'Uncharacterized protein', 77, NULL, NULL, 189075),
(189076, '2.130.10.10-FF-002242', NULL, 'Uncharacterized protein', 244, NULL, NULL, 189076); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(189077, '3.30.200.20-FF-000401', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase SD1-29', 101, NULL, NULL, 189077),
(189078, '3.30.420.40-FF-000614', NULL, 'Predicted protein', 54, NULL, NULL, 189078),
(189079, '2.10.110.10-FF-000040', NULL, 'LIM homeobox transcription factor 1 beta', 74, NULL, NULL, 189079),
(189080, '2.60.40.10-FF-006075', NULL, NULL, 87, NULL, NULL, 189080),
(189081, '3.90.70.10-FF-000430', NULL, 'Cysteine protease XCP1', 100, NULL, NULL, 189081),
(189082, '3.40.50.300-FF-002293', NULL, 'Putative DNA helicase', 300, NULL, NULL, 189082),
(189083, '3.60.21.50-FF-000026', NULL, 'Polymerase (DNA directed), delta 2, accessory subunit', 84, NULL, NULL, 189083),
(189084, '3.30.1490.120-FF-000027', NULL, 'Putative DNA-directed RNA polymerase III subunit', 65, NULL, NULL, 189084),
(189085, '3.40.50.300-FF-000505', NULL, 'Gluconokinase', 175, NULL, NULL, 189085),
(189086, '1.25.40.10-FF-004051', NULL, 'Uncharacterized protein', 171, NULL, NULL, 189086),
(189087, '3.40.50.300-FF-006019', NULL, 'Si:ch211-108d22.2', 211, NULL, NULL, 189087),
(189088, '3.40.50.300-FF-002641', NULL, 'MAK5p nucleolar protein', 260, NULL, NULL, 189088),
(189089, '3.40.50.1100-FF-000132', NULL, 'Predicted protein', 159, NULL, NULL, 189089),
(189090, '1.50.40.10-FF-000159', NULL, 'solute carrier family 25 member 39 isoform X1', 278, NULL, NULL, 189090),
(189091, '3.40.50.1820-FF-001303', NULL, 'Chromosome 7, whole genome shotgun sequence', 585, NULL, NULL, 189091),
(189092, '1.20.5.1230-FF-000007', NULL, NULL, 89, NULL, NULL, 189092),
(189093, '3.20.20.60-FF-000057', NULL, 'Pyruvate kinase family protein', 81, NULL, NULL, 189093),
(189094, '3.30.750.24-FF-000014', NULL, 'Testis anion transporter 1', 146, NULL, NULL, 189094),
(189095, '2.60.40.60-FF-000334', NULL, 'Protocadherin-related 15b', 101, NULL, NULL, 189095),
(189096, '3.30.1330.20-FF-000056', NULL, 'Tubulin beta-7 chain', 60, NULL, NULL, 189096),
(189097, '1.25.40.10-FF-003775', NULL, 'Tetratricopeptide repeat protein 36 homolog-like Protein', 155, NULL, NULL, 189097),
(189098, '3.30.160.60-FF-003995', NULL, NULL, 40, NULL, NULL, 189098),
(189099, '3.30.530.20-FF-000162', NULL, 'Uncharacterized protein', 138, NULL, NULL, 189099),
(189100, '1.10.533.10-FF-000037', NULL, 'Receptor-interacting serine/threonine-protein kinase 2', 106, NULL, NULL, 189100),
(189101, '1.10.260.50-FF-000004', NULL, 'Cysteine desulfurase/ selenocysteine lyase', 90, NULL, NULL, 189101),
(189102, '2.40.50.690-FF-000002', NULL, 'exosome complex exonuclease RRP44 isoform X1', 137, NULL, NULL, 189102),
(189103, '2.10.50.10-FF-000047', NULL, 'Thyroglobulin', 68, NULL, NULL, 189103),
(189104, '3.30.1140.60-FF-000014', NULL, 'F-actin-capping protein subunit alpha', 107, NULL, NULL, 189104),
(189105, '3.30.870.10-FF-000190', NULL, 'Uncharacterized protein', 95, NULL, NULL, 189105),
(189106, '3.40.30.10-FF-000744', NULL, 'Uncharacterized protein', 115, NULL, NULL, 189106),
(189107, '1.10.10.580-FF-000011', NULL, 'Cohesin complex subunit SCC1', 76, NULL, NULL, 189107),
(189108, '3.60.40.10-FF-000295', NULL, 'Predicted protein', 230, NULL, NULL, 189108),
(189109, '1.10.510.10-FF-003559', NULL, NULL, 224, NULL, NULL, 189109),
(189110, '1.50.40.10-FF-000507', NULL, 'Solute carrier protein, putative', 242, NULL, NULL, 189110),
(189111, '1.10.3080.10-FF-000091', NULL, 'Chloride channel protein', 94, NULL, NULL, 189111),
(189112, '2.60.40.10-FF-005586', NULL, NULL, 46, NULL, NULL, 189112),
(189113, '1.10.8.1310-FF-000017', NULL, 'Uncharacterized protein', 149, NULL, NULL, 189113),
(189114, '1.10.1140.10-FF-000011', NULL, 'V-type ATP synthase alpha chain', 149, NULL, NULL, 189114),
(189115, '2.30.29.30-FF-000699', NULL, 'Serine/threonine-protein kinase dkf-2', 107, NULL, NULL, 189115),
(189116, '1.10.620.20-FF-000001', NULL, 'Ribonucleoside-diphosphate reductase 1 subunit beta', 339, NULL, NULL, 189116),
(189117, '1.25.40.10-FF-000116', NULL, 'General transcription factor 3C polypeptide 3', 131, NULL, NULL, 189117),
(189118, '3.30.70.590-FF-000025', NULL, 'Putative poly(A) polymerase', 126, NULL, NULL, 189118);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(189119, '3.30.420.40-FF-000266', NULL, '2-hydroxyisocaproyl-CoA dehydratase activator', 106, NULL, NULL, 189119),
(189120, '3.40.50.1000-FF-000091', NULL, 'HAD hydrolase family', 134, NULL, NULL, 189120),
(189121, '3.40.50.1000-FF-000427', NULL, 'Haloacid dehalogenase family hydrolase', 142, NULL, NULL, 189121),
(189122, '3.40.30.10-FF-000396', NULL, 'Protein disulfide-isomerase', 111, NULL, NULL, 189122),
(189123, '3.20.200.10-FF-000013', NULL, 'Myosin heavy chain kinase A, putative', 127, NULL, NULL, 189123),
(189124, '3.40.190.10-FF-000130', NULL, 'ABC transporter substrate-binding protein', 140, NULL, NULL, 189124),
(189125, '1.10.238.10-FF-000082', NULL, 'Myosin light chain 1', 66, NULL, NULL, 189125),
(189126, '3.50.50.100-FF-000050', NULL, 'Predicted protein', 291, NULL, NULL, 189126),
(189127, '3.40.30.10-FF-000177', NULL, 'Protein disulfide isomerase like, testis expressed', 114, NULL, NULL, 189127),
(189128, '1.20.1150.12-FF-000006', NULL, NULL, 98, NULL, NULL, 189128),
(189129, '3.40.30.10-FF-001020', NULL, 'Uncharacterized protein', 55, NULL, NULL, 189129),
(189130, '3.30.70.580-FF-000022', NULL, 'tRNA pseudouridine synthase', 128, NULL, NULL, 189130),
(189131, '3.90.70.10-FF-000082', NULL, 'Ubiquitin carboxyl-terminal hydrolase 16', 253, NULL, NULL, 189131),
(189132, '2.60.40.150-FF-000261', NULL, 'Phosphatidylserine decarboxylase proenzyme 2', 153, NULL, NULL, 189132),
(189133, '2.130.10.130-FF-000052', NULL, NULL, 145, NULL, NULL, 189133),
(189134, '3.30.70.330-FF-001049', NULL, 'Putative nuclear mrna splicing factor-associated protein', 82, NULL, NULL, 189134),
(189135, '3.20.20.140-FF-000158', NULL, 'Hydrolase TatD family protein', 218, NULL, NULL, 189135),
(189136, '3.40.50.300-FF-007649', NULL, 'Uncharacterized protein ABCE1', 134, NULL, NULL, 189136),
(189137, '3.30.505.10-FF-000078', NULL, 'Tyrosine-protein kinase', 111, NULL, NULL, 189137),
(189138, '3.40.50.1400-FF-000008', NULL, 'Ferrochelatase', 158, NULL, NULL, 189138),
(189139, '3.80.10.10-FF-001242', NULL, 'Gp150, isoform D', 255, NULL, NULL, 189139),
(189140, '2.30.30.40-FF-000424', NULL, 'Nephronophthisis 1', 61, NULL, NULL, 189140),
(189141, '1.10.357.10-FF-000043', NULL, 'TetR/AcrR family transcriptional regulator', 186, NULL, NULL, 189141),
(189142, '2.180.10.10-FF-000014', NULL, 'Teneurin-m-like Protein', 478, NULL, NULL, 189142),
(189143, '3.40.50.1010-FF-000094', NULL, 'Ribonuclease VapC', 133, NULL, NULL, 189143),
(189144, '1.10.510.10-FF-002148', NULL, NULL, 175, NULL, NULL, 189144),
(189145, '3.30.200.20-FF-000620', NULL, 'Putative unc-89', 102, NULL, NULL, 189145),
(189146, '3.30.160.60-FF-002365', NULL, NULL, 28, NULL, NULL, 189146),
(189147, '3.30.9.10-FF-000139', NULL, 'Gamma-glutamylputrescine oxidoreductase', 154, NULL, NULL, 189147),
(189148, '3.30.70.330-FF-001942', NULL, NULL, 127, NULL, NULL, 189148),
(189149, '2.60.120.970-FF-000049', NULL, 'Protein DVR-1 homolog', 272, NULL, NULL, 189149),
(189150, '4.10.400.10-FF-000280', NULL, 'low-density lipoprotein receptor-related protein 6 isoform X3', 65, NULL, NULL, 189150),
(189151, '3.30.40.10-FF-001381', NULL, 'MBD9', 74, NULL, NULL, 189151),
(189152, '1.10.750.20-FF-000005', NULL, 'Suppressor of cytokine signaling 1', 35, NULL, NULL, 189152),
(189153, '3.30.420.10-FF-000634', NULL, NULL, 158, NULL, NULL, 189153),
(189154, '3.30.250.20-FF-000005', NULL, 'LINE-1 retrotransposable element ORF1 protein', 84, NULL, NULL, 189154),
(189155, '2.40.30.10-FF-000460', NULL, 'Predicted protein', 97, NULL, NULL, 189155),
(189156, '3.30.160.60-FF-006417', NULL, NULL, 53, NULL, NULL, 189156),
(189157, '1.20.850.10-FF-000002', NULL, 'Hydroxylamine oxidoreductase', 233, NULL, NULL, 189157),
(189158, '2.60.120.10-FF-000299', NULL, 'Predicted protein', 329, NULL, NULL, 189158),
(189159, '3.30.420.270-FF-000037', NULL, 'Biopolymer transport protein ExbD', 66, NULL, NULL, 189159),
(189160, '3.10.50.40-FF-000082', NULL, 'Peptidyl-prolyl cis-trans isomerase', 91, NULL, NULL, 189160),
(189161, '1.20.1250.20-FF-001240', NULL, 'Uncharacterized protein', 213, NULL, NULL, 189161);
INSERT INTO "PUBLIC"."MODEL" VALUES
(189162, '3.30.160.60-FF-003776', NULL, 'Uncharacterized protein', 82, NULL, NULL, 189162),
(189163, '1.10.238.10-FF-000424', NULL, 'GM18042', 66, NULL, NULL, 189163),
(189164, '2.60.40.10-FF-002146', NULL, 'Major histocompatibility complex class I UKA', 87, NULL, NULL, 189164),
(189165, '1.20.5.190-FF-000028', NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', 49, NULL, NULL, 189165),
(189166, '3.30.70.330-FF-001594', NULL, NULL, 67, NULL, NULL, 189166),
(189167, '2.130.10.10-FF-003872', NULL, 'Uncharacterized WD repeat-containing protein C17D11.08', 387, NULL, NULL, 189167),
(189168, '3.40.50.1580-FF-000005', NULL, 'AMP nucleosidase', 312, NULL, NULL, 189168),
(189169, '2.60.40.1910-FF-000011', NULL, 'Uncharacterized protein, isoform A', 83, NULL, NULL, 189169),
(189170, '2.30.110.10-FF-000058', NULL, 'Pyridoxamine 5-phosphate oxidase', 143, NULL, NULL, 189170),
(189171, '1.10.260.60-FF-000007', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', 119, NULL, NULL, 189171),
(189172, '1.10.8.720-FF-000044', NULL, 'Uncharacterized protein', 66, NULL, NULL, 189172),
(189173, '3.30.160.60-FF-006075', NULL, NULL, 67, NULL, NULL, 189173),
(189174, '2.60.40.60-FF-000115', NULL, 'FAT atypical cadherin 4', 101, NULL, NULL, 189174),
(189175, '1.25.40.20-FF-000338', NULL, '85/88 kDa calcium-independent phospholipase A2', 326, NULL, NULL, 189175),
(189176, '1.10.510.10-FF-003907', NULL, NULL, 81, NULL, NULL, 189176),
(189177, '3.40.1390.10-FF-000009', NULL, 'UDP-3-O-acylglucosamine N-acyltransferase', 98, NULL, NULL, 189177),
(189178, '3.30.1490.100-FF-000021', NULL, 'DNA polymerase IV', 104, NULL, NULL, 189178),
(189179, '2.60.120.920-FF-000063', NULL, 'Uncharacterized protein, isoform C', 215, NULL, NULL, 189179),
(189180, '1.25.40.10-FF-003556', NULL, 'Probable DNA-directed RNA polymerase alpha chain', 265, NULL, NULL, 189180),
(189181, '2.60.120.10-FF-000086', NULL, 'Lysophospholipase NTE1', 122, NULL, NULL, 189181),
(189182, '3.10.20.90-FF-000353', NULL, '40S ribosomal protein S30', 106, NULL, NULL, 189182),
(189183, '3.30.40.10-FF-001723', NULL, 'Ubiquitinyl hydrolase 1', 49, NULL, NULL, 189183),
(189184, '2.40.10.10-FF-000239', NULL, 'Uncharacterized protein', 112, NULL, NULL, 189184),
(189185, '1.10.30.10-FF-000093', NULL, 'AGAP002022-PA', 57, NULL, NULL, 189185),
(189186, '3.40.50.1820-FF-001522', NULL, 'Uncharacterized protein', 147, NULL, NULL, 189186),
(189187, '3.30.2290.10-FF-000027', NULL, 'Peptidase U62 modulator of DNA gyrase', 206, NULL, NULL, 189187),
(189188, '3.30.70.420-FF-000002', NULL, '3-hydroxy-3-methylglutaryl-coenzyme A reductase 2', 40, NULL, NULL, 189188),
(189189, '1.20.1070.10-FF-001470', NULL, 'Uncharacterized protein', 212, NULL, NULL, 189189),
(189190, '3.40.720.10-FF-000059', NULL, 'Arylsulfatase', 371, NULL, NULL, 189190),
(189191, '3.30.160.60-FF-004400', NULL, NULL, 29, NULL, NULL, 189191),
(189192, '1.10.287.70-FF-000387', NULL, 'Predicted protein', 111, NULL, NULL, 189192),
(189193, '3.30.1360.120-FF-000077', NULL, 'tRNA modification GTPase MnmE', 126, NULL, NULL, 189193),
(189194, '2.60.40.1960-FF-000003', NULL, 'phytepsin', 61, NULL, NULL, 189194),
(189195, '1.25.40.880-FF-000001', NULL, 'SDS hydrolase SdsA1', 141, NULL, NULL, 189195),
(189196, '3.40.50.300-FF-008150', NULL, 'Uncharacterized protein', 94, NULL, NULL, 189196),
(189197, '2.60.40.10-FF-002371', NULL, 'Papilin', 86, NULL, NULL, 189197),
(189198, '1.10.506.10-FF-000019', NULL, 'Neurofibromin 1', 138, NULL, NULL, 189198),
(189199, '3.30.200.20-FF-001475', NULL, 'LD20874p', 37, NULL, NULL, 189199),
(189200, '3.80.10.10-FF-000859', NULL, 'YDR306C-like protein', 350, NULL, NULL, 189200),
(189201, '3.40.630.30-FF-000496', NULL, 'UDP-N-acetylmuramoylpentapeptide-lysine N(6)-alanyltransferase', 149, NULL, NULL, 189201),
(189202, '3.80.10.10-FF-002989', NULL, 'Uncharacterized protein', 244, NULL, NULL, 189202),
(189203, '3.60.21.10-FF-000149', NULL, 'Serine/threonine-protein phosphatase', 307, NULL, NULL, 189203),
(189204, '1.25.10.10-FF-000058', NULL, 'AP complex subunit beta', 580, NULL, NULL, 189204);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(189205, '2.60.40.1660-FF-000014', NULL, 'GM26920', 257, NULL, NULL, 189205),
(189206, '3.40.50.300-FF-002309', NULL, 'Ras-related protein Ral-A', 172, NULL, NULL, 189206),
(189207, '3.40.1380.20-FF-000063', NULL, 'Pyruvate kinase', 127, NULL, NULL, 189207),
(189208, '1.10.10.440-FF-000093', NULL, 'Uncharacterized protein', 82, NULL, NULL, 189208),
(189209, '2.140.10.30-FF-000016', NULL, 'Dipeptidyl peptidase 8', 138, NULL, NULL, 189209),
(189210, '3.40.250.10-FF-000079', NULL, 'Adenylyltransferase and sulfurtransferase uba4', 118, NULL, NULL, 189210),
(189211, '1.10.510.10-FF-000237', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', 202, NULL, NULL, 189211),
(189212, '3.40.50.720-FF-000749', NULL, 'N(5)-(carboxyethyl)ornithine synthase', 14, NULL, NULL, 189212),
(189213, '3.40.50.10810-FF-000115', NULL, 'Nucleosome remodeling complex ATPase subunit (Snf2h)', 257, NULL, NULL, 189213),
(189214, '3.40.1280.30-FF-000007', NULL, 'Unplaced genomic scaffold supercont2.5, whole genome shotgun sequence', 204, NULL, NULL, 189214),
(189215, '1.10.287.110-FF-000141', NULL, 'Chaperone protein dnaJ', 106, NULL, NULL, 189215),
(189216, '1.20.1070.10-FF-001705', NULL, 'Uncharacterized protein', 106, NULL, NULL, 189216),
(189217, '3.30.160.60-FF-004052', NULL, NULL, 27, NULL, NULL, 189217),
(189218, '1.10.238.10-FF-000317', NULL, 'Follistatin like 4', 87, NULL, NULL, 189218),
(189219, '3.30.450.40-FF-000111', NULL, 'IclR family transcriptional regulator', 74, NULL, NULL, 189219),
(189220, '2.30.29.30-FF-001082', NULL, 'Uncharacterized protein', 64, NULL, NULL, 189220),
(189221, '3.30.360.10-FF-000123', NULL, 'Uncharacterized protein', 164, NULL, NULL, 189221),
(189222, '3.30.565.10-FF-000312', NULL, 'PMS1 protein homolog 1', 44, NULL, NULL, 189222),
(189223, '3.30.30.30-FF-000037', NULL, 'DnaK protein', 48, NULL, NULL, 189223),
(189224, '3.30.505.10-FF-000191', NULL, NULL, 61, NULL, NULL, 189224),
(189225, '3.90.230.10-FF-000049', NULL, NULL, 64, NULL, NULL, 189225),
(189226, '1.20.1250.20-FF-001913', NULL, 'Uncharacterized protein', 230, NULL, NULL, 189226),
(189227, '3.30.360.10-FF-000117', NULL, 'Uncharacterized protein', 50, NULL, NULL, 189227),
(189228, '3.30.70.1660-FF-000010', NULL, 'Peptide chain release factor 1', 71, NULL, NULL, 189228),
(189229, '3.40.50.300-FF-003945', NULL, 'ADP ribosylation factor 3 homolog', 166, NULL, NULL, 189229),
(189230, '3.30.710.10-FF-000499', NULL, 'TD and POZ domain-containing protein 3-like Protein', 134, NULL, NULL, 189230),
(189231, '3.30.450.20-FF-000678', NULL, 'Sensory transduction histidine kinase', 72, NULL, NULL, 189231),
(189232, '1.25.10.10-FF-002312', NULL, 'Predicted protein', 316, NULL, NULL, 189232),
(189233, '1.10.10.440-FF-000104', NULL, 'TransCription Elongation Regulator homolog', 73, NULL, NULL, 189233),
(189234, '3.10.250.10-FF-000119', NULL, NULL, 65, NULL, NULL, 189234),
(189235, '1.25.40.10-FF-004270', NULL, 'ABL108Cp', 215, NULL, NULL, 189235),
(189236, '1.20.1070.10-FF-001812', NULL, 'Uncharacterized protein', 312, NULL, NULL, 189236),
(189237, '1.20.1310.20-FF-000008', NULL, 'Erythrocyte binding antigen-140', 166, NULL, NULL, 189237),
(189238, '2.90.10.10-FF-000035', NULL, 'Putative S-receptor kinase', 138, NULL, NULL, 189238),
(189239, '3.40.30.10-FF-000851', NULL, 'Protein disulfide-isomerase', 102, NULL, NULL, 189239),
(189240, '1.10.3210.10-FF-000028', NULL, 'HD superfamily phosphohydrolase protein', 333, NULL, NULL, 189240),
(189241, '2.30.29.90-FF-000003', NULL, 'Exocyst complex component Sec3', 161, NULL, NULL, 189241),
(189242, '2.60.40.1970-FF-000006', NULL, 'Transcription initiation factor TFIID subunit 14', 137, NULL, NULL, 189242),
(189243, '1.10.10.10-FF-001963', NULL, 'Histone H1-I-1, putative', 72, NULL, NULL, 189243),
(189244, '2.70.98.110-FF-000020', NULL, NULL, 124, NULL, NULL, 189244),
(189245, '2.70.20.10-FF-000031', NULL, 'DNA topoisomerase type IA core', 15, NULL, NULL, 189245),
(189246, '3.30.40.10-FF-001162', NULL, 'RING-H2 finger protein ATL2', 66, NULL, NULL, 189246),
(189247, '3.30.160.60-FF-006069', NULL, NULL, 22, NULL, NULL, 189247);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(189248, '1.20.120.80-FF-000012', NULL, 'Cytochrome oxidase subunit III', 194, NULL, NULL, 189248),
(189249, '3.30.1380.20-FF-000008', NULL, 'trafficking protein particle complex subunit 6B', 171, NULL, NULL, 189249),
(189250, '2.130.10.10-FF-004147', NULL, 'Uncharacterized protein', 178, NULL, NULL, 189250),
(189251, '2.60.40.1670-FF-000017', NULL, 'Protein transport protein SEC23', 159, NULL, NULL, 189251),
(189252, '2.60.200.20-FF-000235', NULL, 'Kinesin-like protein', 41, NULL, NULL, 189252),
(189253, '3.40.50.1000-FF-000321', NULL, '5-amino-6-(5-phospho-D-ribitylamino)uracil phosphatase, chloroplastic', 125, NULL, NULL, 189253),
(189254, '3.40.630.30-FF-000507', NULL, 'RNA cytidine acetyltransferase', 199, NULL, NULL, 189254),
(189255, '1.20.272.10-FF-000080', NULL, NULL, 89, NULL, NULL, 189255),
(189256, '3.40.640.10-FF-000002', NULL, 'Serine hydroxymethyltransferase', 275, NULL, NULL, 189256),
(189257, '3.40.50.1980-FF-000125', NULL, 'ABC transporter substrate-binding protein', 157, NULL, NULL, 189257),
(189258, '2.130.10.130-FF-000046', NULL, NULL, 326, NULL, NULL, 189258),
(189259, '3.30.70.330-FF-001830', NULL, NULL, 121, NULL, NULL, 189259),
(189260, '2.10.220.10-FF-000149', NULL, 'Proprotein convertase subtilisin/kexin type 5', 113, NULL, NULL, 189260),
(189261, '2.60.200.20-FF-000128', NULL, 'Uncharacterized protein', 102, NULL, NULL, 189261),
(189262, '1.25.10.10-FF-000171', NULL, 'HEAT repeat-containing protein 6', 214, NULL, NULL, 189262),
(189263, '3.90.1420.10-FF-000029', NULL, 'Uncharacterized protein', 147, NULL, NULL, 189263),
(189264, '1.50.40.10-FF-000491', NULL, 'Uncharacterized protein', 274, NULL, NULL, 189264),
(189265, '1.20.120.730-FF-000004', NULL, 'SEC24 homolog B, COPII coat complex component', 134, NULL, NULL, 189265),
(189266, '1.10.630.10-FF-000398', NULL, 'Dammarenediol 12-hydroxylase', 76, NULL, NULL, 189266),
(189267, '2.60.40.10-FF-004512', NULL, NULL, 99, NULL, NULL, 189267),
(189268, '3.40.33.10-FF-000094', NULL, 'Uncharacterized protein, isoform A', 236, NULL, NULL, 189268),
(189269, '3.40.980.10-FF-000038', NULL, 'Uncharacterized protein', 111, NULL, NULL, 189269),
(189270, '3.30.505.10-FF-000084', NULL, 'Signal transducing adaptor family member 1', 108, NULL, NULL, 189270),
(189271, '3.40.30.10-FF-000519', NULL, 'Cytochrome C biogenesis protein transmembrane region', 119, NULL, NULL, 189271),
(189272, '2.130.10.10-FF-001399', NULL, 'Sortilin-related VPS10 domain-containing receptor 2', 283, NULL, NULL, 189272),
(189273, '2.160.20.10-FF-000122', NULL, 'Pectinesterase', 77, NULL, NULL, 189273),
(189274, '3.90.70.10-FF-000205', NULL, 'Ubiquitinyl hydrolase 1', 238, NULL, NULL, 189274),
(189275, '1.20.1640.10-FF-000086', NULL, 'Bifunctional preprotein translocase subunit SecD/SecF', 181, NULL, NULL, 189275),
(189276, '3.40.50.620-FF-000489', NULL, 'GMP synthase [glutamine-hydrolyzing] subunit B', 194, NULL, NULL, 189276),
(189277, '1.20.1310.10-FF-000005', NULL, 'Cullin 3', 108, NULL, NULL, 189277),
(189278, '1.10.510.10-FF-000350', NULL, 'Mitogen-activated protein kinase 2', 192, NULL, NULL, 189278),
(189279, '1.20.58.70-FF-000117', NULL, 'Syntaxin-4-like Protein', 123, NULL, NULL, 189279),
(189280, '1.10.565.10-FF-000156', NULL, 'Nuclear Hormone Receptor family', 221, NULL, NULL, 189280),
(189281, '1.10.10.10-FF-001637', NULL, 'Transcription factor E', 85, NULL, NULL, 189281),
(189282, '1.25.40.10-FF-002140', NULL, 'Pentatricopeptide repeat-containing protein isoform A', 133, NULL, NULL, 189282),
(189283, '1.20.120.430-FF-000015', NULL, 'Nuclear encoded Mitochondrial TRNA Carboxymethyl-amino-methyl modification of Uridine residues', 162, NULL, NULL, 189283),
(189284, '2.40.400.10-FF-000005', NULL, 'Uncharacterized protein', 283, NULL, NULL, 189284),
(189285, '3.40.50.300-FF-001798', NULL, 'ADP-ribosylation factor-like protein 1', 135, NULL, NULL, 189285),
(189286, '1.20.120.140-FF-000029', NULL, 'Signal recognition particle receptor FtsY', 118, NULL, NULL, 189286),
(189287, '3.30.70.330-FF-001717', NULL, NULL, 108, NULL, NULL, 189287),
(189288, '1.10.3720.10-FF-000112', NULL, 'Phosphate transport system permease protein', 290, NULL, NULL, 189288);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(189289, '2.60.40.10-FF-002258', NULL, 'Chaperone protein EcpD', 93, NULL, NULL, 189289),
(189290, '3.90.740.10-FF-000026', NULL, 'Leucyl-tRNA synthetase', 150, NULL, NULL, 189290),
(189291, '1.50.40.10-FF-000384', NULL, 'Uncharacterized protein', 206, NULL, NULL, 189291),
(189292, '3.30.460.10-FF-000176', NULL, 'Zinc finger RNA-binding protein 2', 73, NULL, NULL, 189292),
(189293, '3.10.20.90-FF-000465', NULL, 'E3 ubiquitin-protein ligase UHRF1-like Protein', 100, NULL, NULL, 189293),
(189294, '2.60.40.10-FF-000241', NULL, 'obscurin-like protein 1 isoform X2', 87, NULL, NULL, 189294),
(189295, '1.25.10.10-FF-001694', NULL, 'Uncharacterized protein', 274, NULL, NULL, 189295),
(189296, '3.80.10.10-FF-000972', NULL, 'Brassinosteroid LRR receptor kinase BRL2', 92, NULL, NULL, 189296),
(189297, '3.40.630.10-FF-000501', NULL, 'Peptide hydrolase', 256, NULL, NULL, 189297),
(189298, '2.130.10.10-FF-000095', NULL, 'Cytoplasmic dynein 1 intermediate chain 2', 159, NULL, NULL, 189298),
(189299, '3.20.20.220-FF-000070', NULL, 'Proline dehydrogenase', 352, NULL, NULL, 189299),
(189300, '1.10.3720.10-FF-000005', NULL, 'Microcin C ABC transporter permease', 205, NULL, NULL, 189300),
(189301, '3.60.21.10-FF-000262', NULL, 'Phosphoesterase', 189, NULL, NULL, 189301),
(189302, '3.40.109.10-FF-000054', NULL, 'NADPH-flavin oxidoreductase', 167, NULL, NULL, 189302),
(189303, '3.40.50.1820-FF-001634', NULL, 'Carboxypeptidase', 440, NULL, NULL, 189303),
(189304, '1.10.30.10-FF-000109', NULL, 'Lysine-specific histone demethylase Aof2', 103, NULL, NULL, 189304),
(189305, '3.10.180.10-FF-000001', NULL, '4-hydroxyphenylpyruvate dioxygenase', 206, NULL, NULL, 189305),
(189306, '1.10.3380.10-FF-000029', NULL, 'U5 small nuclear ribonucleoprotein helicase, putative', 138, NULL, NULL, 189306),
(189307, '2.170.270.10-FF-000036', NULL, 'Blimp-1, isoform A', 185, NULL, NULL, 189307),
(189308, '3.40.50.300-FF-000494', NULL, 'tRNA modification GTPase MnmE', 166, NULL, NULL, 189308),
(189309, '1.10.10.10-FF-000440', NULL, 'AsnC family transcriptional regulator', 51, NULL, NULL, 189309),
(189310, '1.20.1060.20-FF-000011', NULL, 'Structural maintenance of chromosomes protein', 110, NULL, NULL, 189310),
(189311, '3.90.550.10-FF-000433', NULL, 'Glr1066 protein', 238, NULL, NULL, 189311),
(189312, '3.90.79.10-FF-000062', NULL, 'Nudix hydrolase 9', 152, NULL, NULL, 189312),
(189313, '3.10.180.20-FF-000004', NULL, NULL, 66, NULL, NULL, 189313),
(189314, '2.60.40.10-FF-005816', NULL, NULL, 63, NULL, NULL, 189314),
(189315, '3.50.50.60-FF-000411', NULL, 'Flavin-containing monooxygenase', 94, NULL, NULL, 189315),
(189316, '2.10.25.10-FF-000539', NULL, 'Latent transforming growth factor beta binding protein 4', 41, NULL, NULL, 189316),
(189317, '3.40.50.12760-FF-000026', NULL, 'Uncharacterized protein', 153, NULL, NULL, 189317),
(189318, '3.30.160.60-FF-000454', NULL, 'Zinc finger protein 624', 28, NULL, NULL, 189318),
(189319, '3.55.50.30-FF-000010', NULL, 'Probable transmembrane sensor', 64, NULL, NULL, 189319),
(189320, '1.10.287.950-FF-000044', NULL, 'Uncharacterized protein', 149, NULL, NULL, 189320),
(189321, '1.10.10.140-FF-000008', NULL, 'Probable cytochrome c oxidase subunit 6B', 77, NULL, NULL, 189321),
(189322, '3.90.190.10-FF-000349', NULL, 'Predicted protein', 154, NULL, NULL, 189322),
(189323, '2.40.70.10-FF-000125', NULL, 'Eukaryotic aspartyl protease family protein, expressed', 171, NULL, NULL, 189323),
(189324, '2.40.70.10-FF-000013', NULL, 'Aspartyl protease AED1', 174, NULL, NULL, 189324),
(189325, '1.20.120.980-FF-000045', NULL, 'Uncharacterized protein', 14, NULL, NULL, 189325),
(189326, '2.40.50.100-FF-000191', NULL, 'Efflux pump, RND family, membrane fusion lipoprotein', 70, NULL, NULL, 189326),
(189327, '3.30.70.100-FF-000036', NULL, 'Transporter, major facilitator family', 65, NULL, NULL, 189327),
(189328, '1.10.540.10-FF-000065', NULL, 'Acyl-coenzyme A oxidase', 128, NULL, NULL, 189328),
(189329, '1.10.10.10-FF-001856', NULL, 'DNA replication licensing factor, MCM2/3/5 family', 75, NULL, NULL, 189329),
(189330, '2.120.10.30-FF-000404', NULL, 'Uncharacterized protein', 203, NULL, NULL, 189330);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(189331, '1.10.10.820-FF-000004', NULL, 'unconventional myosin-XVIIIa isoform X1', 61, NULL, NULL, 189331),
(189332, '3.40.50.1820-FF-000797', NULL, 'Os01g0315600 protein', 107, NULL, NULL, 189332),
(189333, '3.30.200.20-FF-000171', NULL, 'Putative cyclin-dependent kinase-like 5', 93, NULL, NULL, 189333),
(189334, '2.30.30.40-FF-000317', NULL, 'Bud emergence protein', 59, NULL, NULL, 189334),
(189335, '2.30.30.40-FF-000205', NULL, 'SH3 domain containing 19', 73, NULL, NULL, 189335),
(189336, '3.40.50.1820-FF-001415', NULL, 'Uncharacterized protein', 201, NULL, NULL, 189336),
(189337, '1.20.58.390-FF-000324', NULL, 'Uncharacterized protein', 56, NULL, NULL, 189337),
(189338, '3.90.1600.10-FF-000015', NULL, 'DNA polymerase epsilon catalytic subunit', 52, NULL, NULL, 189338),
(189339, '3.30.497.10-FF-000030', NULL, 'Uncharacterized protein', 108, NULL, NULL, 189339),
(189340, '1.10.287.110-FF-000028', NULL, 'DnaJ domain protein', 99, NULL, NULL, 189340),
(189341, '3.40.630.10-FF-000271', NULL, 'Peptide hydrolase', 331, NULL, NULL, 189341),
(189342, '3.90.260.10-FF-000001', NULL, 'Protein-glutamine gamma-glutamyltransferase 2', 321, NULL, NULL, 189342),
(189343, '1.20.810.10-FF-000005', NULL, 'Menaquinol-cytochrome c reductase cytochrome b/c subunit', 161, NULL, NULL, 189343),
(189344, '3.40.1000.50-FF-000010', NULL, 'Unplaced genomic scaffold supercont1.9, whole genome shotgun sequence', 128, NULL, NULL, 189344),
(189345, '3.30.70.1230-FF-000229', NULL, 'Uncharacterized protein', 197, NULL, NULL, 189345),
(189346, '1.20.58.480-FF-000020', NULL, 'Tryptophan 2,3-dioxygenase, putative', 55, NULL, NULL, 189346),
(189347, '2.130.10.10-FF-003765', NULL, 'Uncharacterized protein', 403, NULL, NULL, 189347),
(189348, '1.20.1070.10-FF-000868', NULL, 'Cholecystokinin-like receptor at 17D1', 136, NULL, NULL, 189348),
(189349, '1.10.10.10-FF-000327', NULL, 'Two-component system response regulator RstA', 120, NULL, NULL, 189349),
(189350, '1.20.5.4570-FF-000003', NULL, 'UbiD-like decarboxylase', 39, NULL, NULL, 189350),
(189351, '1.10.10.830-FF-000007', NULL, 'Isoleucine--tRNA ligase', 57, NULL, NULL, 189351),
(189352, '2.40.50.100-FF-000202', NULL, 'Uncharacterized protein', 46, NULL, NULL, 189352),
(189353, '3.40.50.1000-FF-000208', NULL, 'Bifunctional polynucleotide phosphatase/kinase', 86, NULL, NULL, 189353),
(189354, '1.20.58.340-FF-000006', NULL, 'CorA family metal ion transporter', 119, NULL, NULL, 189354),
(189355, '1.10.150.80-FF-000011', NULL, 'ATP-dependent DNA helicase', 91, NULL, NULL, 189355),
(189356, '2.40.170.20-FF-000012', NULL, 'TonB-dependent receptor', 504, NULL, NULL, 189356),
(189357, '3.90.280.10-FF-000002', NULL, '39S ribosomal protein L38, mitochondrial', 195, NULL, NULL, 189357),
(189358, '3.40.50.720-FF-001463', NULL, 'UDP-glucose/GDP-mannose dehydrogenase, putative', 132, NULL, NULL, 189358),
(189359, '2.130.10.10-FF-005783', NULL, 'Uncharacterized protein', 102, NULL, NULL, 189359),
(189360, '1.10.565.10-FF-000049', NULL, 'Testicular nuclear receptor 2 variant 2', 112, NULL, NULL, 189360),
(189361, '3.30.70.1220-FF-000007', NULL, 'Os05g0108500 protein', 58, NULL, NULL, 189361),
(189362, '3.30.160.60-FF-001977', NULL, 'Krueppel-like factor 17', 32, NULL, NULL, 189362),
(189363, '3.40.50.1460-FF-000094', NULL, 'Uncharacterized protein', 179, NULL, NULL, 189363),
(189364, '1.20.1310.10-FF-000224', NULL, NULL, 38, NULL, NULL, 189364),
(189365, '1.10.10.10-FF-000108', NULL, 'Mn-dependent transcriptional regulator MntR', 71, NULL, NULL, 189365),
(189366, '1.20.1310.10-FF-000112', NULL, NULL, 119, NULL, NULL, 189366),
(189367, '3.40.50.800-FF-000099', NULL, 'Uncharacterized protein', 120, NULL, NULL, 189367),
(189368, '3.30.1370.100-FF-000028', NULL, 'DNA mismatch repair protein MutL', 95, NULL, NULL, 189368),
(189369, '2.40.33.10-FF-000039', NULL, 'Pyruvate kinase', 71, NULL, NULL, 189369),
(189370, '4.10.400.10-FF-000173', NULL, 'Transmembrane protease serine 3', 33, NULL, NULL, 189370),
(189371, '3.40.50.300-FF-000511', NULL, 'ATP-binding cassette, sub-family A (ABC1), member 2', 258, NULL, NULL, 189371); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(189372, '1.25.10.10-FF-002531', NULL, 'Predicted protein', 188, NULL, NULL, 189372),
(189373, '3.30.70.240-FF-000050', NULL, 'Ribosome-releasing factor 2, mitochondrial', 37, NULL, NULL, 189373),
(189374, '3.20.20.70-FF-000167', NULL, 'tRNA-dihydrouridine synthase', 242, NULL, NULL, 189374),
(189375, '3.40.50.300-FF-002416', NULL, 'ABC multidrug transporter (Eurofung)', 240, NULL, NULL, 189375),
(189376, '3.30.70.1200-FF-000001', NULL, 'CRISPR system Cascade subunit CasE', 76, NULL, NULL, 189376),
(189377, '3.40.1080.10-FF-000020', NULL, 'Acetyl-CoA hydrolase/transferase', 179, NULL, NULL, 189377),
(189378, '1.10.287.1240-FF-000003', NULL, 'Exodeoxyribonuclease I', 53, NULL, NULL, 189378),
(189379, '1.10.20.10-FF-000160', NULL, 'Transcription initiation factor TFIID subunit, putative', 42, NULL, NULL, 189379),
(189380, '3.40.390.80-FF-000003', NULL, NULL, 86, NULL, NULL, 189380),
(189381, '1.10.268.10-FF-000033', NULL, NULL, 173, NULL, NULL, 189381),
(189382, '3.30.40.10-FF-001055', NULL, 'Zinc finger family protein', 74, NULL, NULL, 189382),
(189383, '3.10.450.620-FF-000001', NULL, 'Nucleotidyl transferase of uncharacterized function (DUF1814)', 111, NULL, NULL, 189383),
(189384, '2.60.200.20-FF-000016', NULL, 'Angiogenic factor with G patch and FHA domains 1', 141, NULL, NULL, 189384),
(189385, '1.10.287.110-FF-000360', NULL, 'AAL008Wp', 127, NULL, NULL, 189385),
(189386, '2.10.25.10-FF-000871', NULL, 'Matrilin 3', 37, NULL, NULL, 189386),
(189387, '3.40.50.2000-FF-001138', NULL, 'Uncharacterized protein', 34, NULL, NULL, 189387),
(189388, '3.30.1360.10-FF-000004', NULL, 'DNA-directed RNA polymerase II subunit RPB3', 127, NULL, NULL, 189388),
(189389, '2.60.40.1730-FF-000058', NULL, NULL, 106, NULL, NULL, 189389),
(189390, '2.130.10.10-FF-002017', NULL, 'Probable cytosolic iron-sulfur protein assembly protein CIAO1 homolog', 306, NULL, NULL, 189390),
(189391, '3.30.70.330-FF-001487', NULL, 'Heterogeneous nuclear ribonucleoprotein A3', 123, NULL, NULL, 189391),
(189392, '4.10.240.10-FF-000076', NULL, 'Tac1p', 42, NULL, NULL, 189392),
(189393, '3.80.10.10-FF-003714', NULL, 'Predicted protein', 151, NULL, NULL, 189393),
(189394, '3.30.70.330-FF-002105', NULL, NULL, 162, NULL, NULL, 189394),
(189395, '3.40.30.10-FF-000632', NULL, 'Plant UBX domain-containing protein 10', 167, NULL, NULL, 189395),
(189396, '1.10.287.1490-FF-000050', NULL, 'Kinectin', 156, NULL, NULL, 189396),
(189397, '1.10.720.30-FF-000057', NULL, 'Poly [ADP-ribose] polymerase', 46, NULL, NULL, 189397),
(189398, '1.10.1420.10-FF-000162', NULL, 'Predicted protein', 178, NULL, NULL, 189398),
(189399, '2.60.200.10-FF-000013', NULL, 'Interferon regulatory factor 8', 217, NULL, NULL, 189399),
(189400, '1.20.1250.20-FF-001133', NULL, 'Tetracycline resistance MFS efflux pump', 205, NULL, NULL, 189400),
(189401, '3.30.160.60-FF-006182', NULL, NULL, 60, NULL, NULL, 189401),
(189402, '3.30.450.350-FF-000005', NULL, 'GGDEF family protein', 223, NULL, NULL, 189402),
(189403, '1.25.40.10-FF-003663', NULL, 'Peroxisomal biogenesis factor 5-like a', 97, NULL, NULL, 189403),
(189404, '2.60.120.10-FF-000193', NULL, 'Lysophospholipase NTE1', 133, NULL, NULL, 189404),
(189405, '3.10.20.90-FF-000246', NULL, 'NADPH oxidase regulator NoxR', 77, NULL, NULL, 189405),
(189406, '3.90.550.10-FF-000214', NULL, 'Hexosyltransferase', 276, NULL, NULL, 189406),
(189407, '1.10.510.10-FF-000018', NULL, 'Receptor protein serine/threonine kinase', 217, NULL, NULL, 189407),
(189408, '1.10.630.10-FF-000179', NULL, 'Cytochrome P450', 432, NULL, NULL, 189408),
(189409, '1.10.1410.10-FF-000116', NULL, 'Uncharacterized protein', 84, NULL, NULL, 189409),
(189410, '3.30.160.60-FF-002814', NULL, 'Transcription factor IIIA', 53, NULL, NULL, 189410),
(189411, '3.30.1360.20-FF-000007', NULL, NULL, 97, NULL, NULL, 189411),
(189412, '1.10.520.10-FF-000064', NULL, 'Peroxidase', 59, NULL, NULL, 189412),
(189413, '3.90.1200.10-FF-000047', NULL, 'Spore coat protein', 237, NULL, NULL, 189413),
(189414, '3.30.450.40-FF-000094', NULL, 'dual 3'',5''-cyclic-AMP and -GMP phosphodiesterase 11A-like', 160, NULL, NULL, 189414); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(189415, '3.40.630.30-FF-000277', NULL, 'GNAT family acetyltransferase', 178, NULL, NULL, 189415),
(189416, '1.10.135.10-FF-000005', NULL, 'Glycocyamine kinase beta chain', 96, NULL, NULL, 189416),
(189417, '3.60.21.10-FF-000481', NULL, 'Serine/threonine-protein phosphatase', 365, NULL, NULL, 189417),
(189418, '3.20.170.20-FF-000001', NULL, 'Predicted protein', 115, NULL, NULL, 189418),
(189419, '2.60.40.10-FF-002039', NULL, 'EGF-like, fibronectin type III and laminin G domains', 106, NULL, NULL, 189419),
(189420, '1.10.3720.10-FF-000224', NULL, 'N-acetyltaurine ABC transporter, permease protein', 231, NULL, NULL, 189420),
(189421, '2.60.40.10-FF-002601', NULL, 'Putative invasin', 95, NULL, NULL, 189421),
(189422, '3.40.50.200-FF-000138', NULL, 'Uncharacterized protein', 92, NULL, NULL, 189422),
(189423, '3.40.50.1000-FF-000540', NULL, NULL, 44, NULL, NULL, 189423),
(189424, '1.20.140.150-FF-000132', NULL, 'Uncharacterized protein', 103, NULL, NULL, 189424),
(189425, '2.60.40.150-FF-000036', NULL, 'phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit beta', 128, NULL, NULL, 189425),
(189426, '3.40.1280.10-FF-000001', NULL, 'tRNA (guanine-N(1)-)-methyltransferase', 165, NULL, NULL, 189426),
(189427, '3.60.15.10-FF-000202', NULL, 'Uncharacterized protein', 65, NULL, NULL, 189427),
(189428, '1.10.1300.10-FF-000001', NULL, 'Phosphodiesterase', 343, NULL, NULL, 189428),
(189429, '3.80.10.10-FF-003153', NULL, 'Uncharacterized protein', 291, NULL, NULL, 189429),
(189430, '3.40.640.10-FF-000221', NULL, 'PLP-dependent transferase', 214, NULL, NULL, 189430),
(189431, '3.40.50.2300-FF-001346', NULL, NULL, 64, NULL, NULL, 189431),
(189432, '3.40.50.300-FF-004327', NULL, 'GTPase', 60, NULL, NULL, 189432),
(189433, '3.40.50.300-FF-001579', NULL, 'DNA mismatch repair protein MutS', 261, NULL, NULL, 189433),
(189434, '3.30.40.10-FF-001616', NULL, 'RBR-type E3 ubiquitin transferase', 89, NULL, NULL, 189434),
(189435, '1.25.40.190-FF-000002', NULL, 'Actin-related protein 2/3 complex subunit 5', 117, NULL, NULL, 189435),
(189436, '3.40.1370.10-FF-000008', NULL, '50S ribosomal protein L4', 210, NULL, NULL, 189436),
(189437, '1.10.20.10-FF-000047', NULL, 'Histone H3', 95, NULL, NULL, 189437),
(189438, '3.30.40.10-FF-000998', NULL, 'Zinc finger domain containing protein', 77, NULL, NULL, 189438),
(189439, '2.60.40.10-FF-004731', NULL, NULL, 113, NULL, NULL, 189439),
(189440, '3.40.50.150-FF-000426', NULL, 'Putative N6-adenosine-methyltransferase', 165, NULL, NULL, 189440),
(189441, '1.50.40.10-FF-000272', NULL, 'Mitochondrial thiamine pyrophosphate transporter, mitochondrial carrier family member, putative', 287, NULL, NULL, 189441),
(189442, '3.30.160.60-FF-001758', NULL, 'Zinc finger protein 496', 28, NULL, NULL, 189442),
(189443, '3.20.10.10-FF-000019', NULL, 'Aminotransferase class IV, putative', 171, NULL, NULL, 189443),
(189444, '1.20.140.100-FF-000033', NULL, 'Dynein heavy chain, putative', 150, NULL, NULL, 189444),
(189445, '3.30.160.60-FF-005687', NULL, NULL, 21, NULL, NULL, 189445),
(189446, '3.30.160.60-FF-006305', NULL, NULL, 30, NULL, NULL, 189446),
(189447, '3.30.160.60-FF-004164', NULL, NULL, 24, NULL, NULL, 189447),
(189448, '1.25.40.10-FF-002701', NULL, 'Uncharacterized protein', 127, NULL, NULL, 189448),
(189449, '1.10.3520.10-FF-000018', NULL, 'Glycolipid transfer protein', 103, NULL, NULL, 189449),
(189450, '3.40.50.300-FF-000056', NULL, 'Cell division ATP-binding protein FtsE', 221, NULL, NULL, 189450),
(189451, '1.10.287.1490-FF-000156', NULL, 'Viral A-type inclusion protein, putative', 158, NULL, NULL, 189451),
(189452, '2.40.20.10-FF-000066', NULL, 'Plasminogen', 89, NULL, NULL, 189452),
(189453, '3.90.70.10-FF-000317', NULL, 'Calpain-like cysteine peptidase, putative', 125, NULL, NULL, 189453),
(189454, '1.25.40.10-FF-005355', NULL, 'Uncharacterized protein', 130, NULL, NULL, 189454),
(189455, '3.30.830.10-FF-000210', NULL, 'Peptidase, putative', 211, NULL, NULL, 189455),
(189456, '3.90.780.10-FF-000023', NULL, '2'',3''-cyclic-nucleotide 2''-phosphodiesterase (CpdB)', 211, NULL, NULL, 189456);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(189457, '4.10.280.10-FF-000179', NULL, 'Aryl hydrocarbon receptor nuclear translocator-like protein 2', 59, NULL, NULL, 189457),
(189458, '3.30.160.60-FF-004506', NULL, NULL, 29, NULL, NULL, 189458),
(189459, '1.10.287.110-FF-000247', NULL, 'DnaJ like protein subfamily C member 24', 51, NULL, NULL, 189459),
(189460, '2.70.150.10-FF-000203', NULL, 'Cation-transporting ATPase', 166, NULL, NULL, 189460),
(189461, '3.50.30.30-FF-000087', NULL, 'Putative zinc metalloprotease', 190, NULL, NULL, 189461),
(189462, '3.80.20.20-FF-000003', NULL, 'Receptor protein-tyrosine kinase', 198, NULL, NULL, 189462),
(189463, '2.60.40.10-FF-000347', NULL, 'Neuronal cell adhesion molecule', 94, NULL, NULL, 189463),
(189464, '3.40.1810.10-FF-000037', NULL, 'MADS-box protein SVP isoform B', 69, NULL, NULL, 189464),
(189465, '3.30.420.40-FF-000721', NULL, 'Actin family protein', 119, NULL, NULL, 189465),
(189466, '2.60.200.30-FF-000019', NULL, 'NAD kinase', 131, NULL, NULL, 189466),
(189467, '3.40.50.720-FF-001244', NULL, '4-hydroxy-tetrahydrodipicolinate reductase', 133, NULL, NULL, 189467),
(189468, '3.30.160.60-FF-002034', NULL, 'transcription factor Ken', 26, NULL, NULL, 189468),
(189469, '3.30.40.10-FF-001274', NULL, 'Unplaced genomic scaffold supercont1.17, whole genome shotgun sequence', 115, NULL, NULL, 189469),
(189470, '2.40.30.10-FF-000016', NULL, 'GTP-binding protein TypA', 101, NULL, NULL, 189470),
(189471, '3.20.80.10-FF-000063', NULL, 'Uncharacterized protein', 92, NULL, NULL, 189471),
(189472, '3.40.190.10-FF-000023', NULL, 'ATP phosphoribosyltransferase', 125, NULL, NULL, 189472),
(189473, '1.10.1370.30-FF-000051', NULL, 'Angiotensin-converting enzyme', 245, NULL, NULL, 189473),
(189474, '3.40.30.10-FF-000289', NULL, 'Plasmoredoxin', 135, NULL, NULL, 189474),
(189475, '3.30.200.20-FF-002312', NULL, 'Uncharacterized protein', 24, NULL, NULL, 189475),
(189476, '3.80.10.10-FF-001354', NULL, 'TRK (Vertebrate neurotrophin receptor tyrosine kinase) homolog', 136, NULL, NULL, 189476),
(189477, '3.40.50.300-FF-005963', NULL, 'ATP-dependent DNA helicase', 240, NULL, NULL, 189477),
(189478, '1.10.3730.20-FF-000054', NULL, 'Predicted protein', 113, NULL, NULL, 189478),
(189479, '2.60.40.60-FF-000227', NULL, 'Dachsous cadherin-related 2', 102, NULL, NULL, 189479),
(189480, '1.20.1110.10-FF-000237', NULL, NULL, 288, NULL, NULL, 189480),
(189481, '4.10.400.10-FF-000279', NULL, 'LDL receptor related protein 2', 30, NULL, NULL, 189481),
(189482, '1.20.120.350-FF-000093', NULL, 'Uncharacterized protein', 113, NULL, NULL, 189482),
(189483, '1.10.10.60-FF-000426', NULL, 'NK3 homeobox 1', 90, NULL, NULL, 189483),
(189484, '2.130.10.10-FF-005564', NULL, 'Predicted protein', 215, NULL, NULL, 189484),
(189485, '3.30.200.20-FF-001694', NULL, 'ADR163Wp', 66, NULL, NULL, 189485),
(189486, '3.40.50.2020-FF-000172', NULL, 'Uncharacterized protein', 85, NULL, NULL, 189486),
(189487, '3.40.50.720-FF-000968', NULL, 'Phenolpthiocerol synthesis type-I polyketide synthase ppsC', 235, NULL, NULL, 189487),
(189488, '3.30.450.40-FF-000217', NULL, 'PleD gene product', 62, NULL, NULL, 189488),
(189489, '2.30.140.10-FF-000009', NULL, 'Polyamine aminopropyltransferase', 53, NULL, NULL, 189489),
(189490, '2.30.29.30-FF-000929', NULL, 'Predicted protein', 58, NULL, NULL, 189490),
(189491, '2.40.30.20-FF-000019', NULL, 'ATP synthase subunit alpha', 68, NULL, NULL, 189491),
(189492, '2.30.29.30-FF-001205', NULL, 'Uncharacterized protein', 62, NULL, NULL, 189492),
(189493, '1.10.10.10-FF-002019', NULL, 'MarR family transcriptional regulatory protein', 148, NULL, NULL, 189493),
(189494, '2.130.10.10-FF-003984', NULL, 'Uncharacterized protein', 233, NULL, NULL, 189494),
(189495, '3.30.565.10-FF-000531', NULL, 'Predicted protein', 74, NULL, NULL, 189495),
(189496, '3.30.160.60-FF-003888', NULL, NULL, 33, NULL, NULL, 189496),
(189497, '1.10.238.10-FF-000536', NULL, 'Calcium channel protein, putative', 116, NULL, NULL, 189497),
(189498, '1.20.58.70-FF-000011', NULL, 'Syntaxin 4', 130, NULL, NULL, 189498),
(189499, '1.20.1250.20-FF-001352', NULL, 'Predicted protein', 202, NULL, NULL, 189499);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(189500, '1.10.8.60-FF-000459', NULL, 'Transitional endoplasmic reticulum ATPase, putative', 90, NULL, NULL, 189500),
(189501, '3.10.580.10-FF-000094', NULL, 'Magnesium transporter MgtE', 126, NULL, NULL, 189501),
(189502, '2.130.10.10-FF-001854', NULL, 'Protein CBR-CHE-11', 161, NULL, NULL, 189502),
(189503, '2.110.10.10-FF-000045', NULL, 'Peptidase', 198, NULL, NULL, 189503),
(189504, '1.10.10.60-FF-000084', NULL, 'Homeobox protein Hox-D13', 69, NULL, NULL, 189504),
(189505, '3.40.50.150-FF-000084', NULL, 'probable methyltransferase PMT23', 185, NULL, NULL, 189505),
(189506, '3.30.565.10-FF-000076', NULL, 'Molecular chaperone HtpG', 209, NULL, NULL, 189506),
(189507, '2.130.10.10-FF-004260', NULL, 'Uncharacterized protein', 136, NULL, NULL, 189507),
(189508, '2.60.40.10-FF-003675', NULL, NULL, 89, NULL, NULL, 189508),
(189509, '3.40.50.450-FF-000073', NULL, 'Uncharacterized protein', 194, NULL, NULL, 189509),
(189510, '2.60.40.150-FF-000710', NULL, 'C2 domain containing protein', 139, NULL, NULL, 189510),
(189511, '1.10.472.10-FF-000125', NULL, 'Transcription initiation factor TFIIB, putative', 111, NULL, NULL, 189511),
(189512, '3.10.25.10-FF-000014', NULL, 'Methionyl-tRNA formyltransferase', 106, NULL, NULL, 189512),
(189513, '1.20.1640.10-FF-000103', NULL, NULL, 72, NULL, NULL, 189513),
(189514, '3.40.50.300-FF-006800', NULL, 'Uncharacterized protein', 54, NULL, NULL, 189514),
(189515, '3.40.50.1100-FF-000238', NULL, 'Predicted protein', 54, NULL, NULL, 189515),
(189516, '3.10.580.10-FF-000217', NULL, 'Chloride channel protein', 133, NULL, NULL, 189516),
(189517, '1.20.1260.30-FF-000001', NULL, 'Type I restriction enzyme StySJI M protein', 149, NULL, NULL, 189517),
(189518, '2.60.40.60-FF-000446', NULL, 'Si:dkey-30k22.7', 112, NULL, NULL, 189518),
(189519, '3.40.50.300-FF-000617', NULL, 'DNA replication and repair protein RecF', 150, NULL, NULL, 189519),
(189520, '1.20.58.80-FF-000014', NULL, 'Vacuolar protein-sorting-associated protein 4', 73, NULL, NULL, 189520),
(189521, '3.30.420.40-FF-000502', NULL, 'Actin-Related Proteins', 171, NULL, NULL, 189521),
(189522, '3.40.120.10-FF-000075', NULL, 'Phosphopentomutase', 87, NULL, NULL, 189522),
(189523, '3.40.50.2020-FF-000059', NULL, 'Orotate phosphoribosyltransferase', 281, NULL, NULL, 189523),
(189524, '3.30.559.70-FF-000012', NULL, 'Yat2p', 356, NULL, NULL, 189524),
(189525, '1.10.420.10-FF-000011', NULL, 'Adenylate/guanylate cyclase', 103, NULL, NULL, 189525),
(189526, '2.130.10.10-FF-002130', NULL, 'Probable elongator complex protein 2', 112, NULL, NULL, 189526),
(189527, '3.30.1320.10-FF-000007', NULL, '30S ribosomal protein S16', 107, NULL, NULL, 189527),
(189528, '1.20.1110.10-FF-000018', NULL, 'Magnesium-translocating P-type ATPase', 319, NULL, NULL, 189528),
(189529, '1.10.533.10-FF-000149', NULL, 'Viral CASP8 and FADD-like apoptosis regulator', 101, NULL, NULL, 189529),
(189530, '1.25.40.10-FF-002027', NULL, 'Uncharacterized protein', 158, NULL, NULL, 189530),
(189531, '3.30.530.20-FF-000050', NULL, 'Abscisic acid receptor PYL13', 176, NULL, NULL, 189531),
(189532, '2.10.25.10-FF-000977', NULL, 'Wing blister, isoform B', 87, NULL, NULL, 189532),
(189533, '3.30.457.60-FF-000019', NULL, 'Predicted protein', 34, NULL, NULL, 189533),
(189534, '3.40.50.300-FF-008037', NULL, 'Uncharacterized protein', 134, NULL, NULL, 189534),
(189535, '3.90.70.10-FF-000194', NULL, 'Ubiquitin C-terminal hydrolase', 391, NULL, NULL, 189535),
(189536, '1.10.8.50-FF-000018', NULL, '40S ribosomal protein S18, putative', 69, NULL, NULL, 189536),
(189537, '2.10.50.10-FF-000159', NULL, 'Predicted protein', 56, NULL, NULL, 189537),
(189538, '3.30.160.60-FF-005468', NULL, NULL, 66, NULL, NULL, 189538),
(189539, '1.20.144.10-FF-000035', NULL, 'Putative Lipid phosphate phosphatase 1', 230, NULL, NULL, 189539),
(189540, '1.10.1450.10-FF-000113', NULL, 'Uroplakin 1A', 96, NULL, NULL, 189540),
(189541, '1.20.120.720-FF-000001', NULL, 'Myosin heavy chain, muscle', 109, NULL, NULL, 189541),
(189542, '2.10.70.10-FF-000267', NULL, 'Uncharacterized protein', 68, NULL, NULL, 189542);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(189543, '3.20.20.105-FF-000028', NULL, 'Uncharacterized protein', 73, NULL, NULL, 189543),
(189544, '3.80.10.10-FF-002990', NULL, 'Uncharacterized protein', 242, NULL, NULL, 189544),
(189545, '1.25.10.10-FF-000390', NULL, 'Ataxin-10', 178, NULL, NULL, 189545),
(189546, '2.60.40.10-FF-000128', NULL, 'receptor-type tyrosine-protein phosphatase delta isoform X2', 100, NULL, NULL, 189546),
(189547, '2.40.100.10-FF-000061', NULL, 'Cpr8p', 178, NULL, NULL, 189547),
(189548, '3.30.160.60-FF-004383', NULL, NULL, 27, NULL, NULL, 189548),
(189549, '1.10.238.10-FF-000194', NULL, 'rhomboid-related protein 3 isoform X1', 105, NULL, NULL, 189549),
(189550, '2.10.25.10-FF-001253', NULL, 'Uncharacterized protein', 41, NULL, NULL, 189550),
(189551, '2.100.10.30-FF-000012', NULL, 'Jacalin-related lectin 34', 130, NULL, NULL, 189551),
(189552, '1.10.730.10-FF-000001', NULL, 'Arginine--tRNA ligase', 124, NULL, NULL, 189552),
(189553, '1.10.8.60-FF-000572', NULL, 'CDC48/VCP homolog, AAA superfamily', 68, NULL, NULL, 189553),
(189554, '3.40.50.300-FF-001112', NULL, 'Dynein heavy chain 12, axonemal', 189, NULL, NULL, 189554),
(189555, '2.40.10.10-FF-000240', NULL, 'Serine protease H29', 150, NULL, NULL, 189555),
(189556, '3.40.190.10-FF-000242', NULL, 'ABC transporter substrate-binding protein', 108, NULL, NULL, 189556),
(189557, '1.20.58.390-FF-000088', NULL, 'Uncharacterized protein', 116, NULL, NULL, 189557),
(189558, '2.60.120.330-FF-000088', NULL, '1-aminocyclopropane-1-carboxylate oxidase-like 9', 175, NULL, NULL, 189558),
(189559, '2.60.40.10-FF-004170', NULL, NULL, 87, NULL, NULL, 189559),
(189560, '1.10.1070.11-FF-000124', NULL, 'Uncharacterized protein', 140, NULL, NULL, 189560),
(189561, '2.40.50.140-FF-001259', NULL, NULL, 49, NULL, NULL, 189561),
(189562, '3.30.160.60-FF-000673', NULL, 'Zinc finger and BTB domain-containing 7B', 26, NULL, NULL, 189562),
(189563, '2.60.40.10-FF-000802', NULL, 'Muscle M-line assembly protein unc-89', 105, NULL, NULL, 189563),
(189564, '2.130.10.10-FF-005906', NULL, 'Uncharacterized protein', 281, NULL, NULL, 189564),
(189565, '1.10.510.10-FF-000456', NULL, 'Casein kinase I isoform gamma-3', 358, NULL, NULL, 189565),
(189566, '1.20.1270.10-FF-000069', NULL, 'Putative heat shock 70 kDa protein', 73, NULL, NULL, 189566),
(189567, '3.40.50.150-FF-000207', NULL, 'Leucine carboxyl methyltransferase 2', 317, NULL, NULL, 189567),
(189568, '2.10.25.10-FF-001034', NULL, 'Transmembrane cell adhesion receptor mua-3', 60, NULL, NULL, 189568),
(189569, '3.90.920.10-FF-000012', NULL, 'DNA primase small subunit-like', 152, NULL, NULL, 189569),
(189570, '2.10.220.10-FF-000043', NULL, 'Proprotein convertase subtilisin/kexin type 5b', 60, NULL, NULL, 189570),
(189571, '3.30.70.330-FF-003067', NULL, NULL, 104, NULL, NULL, 189571),
(189572, '2.10.70.10-FF-000048', NULL, 'Haptoglobin', 57, NULL, NULL, 189572),
(189573, '3.10.110.10-FF-000053', NULL, 'Ubiquitin-fold modifier-conjugating enzyme 1', 170, NULL, NULL, 189573),
(189574, '2.130.10.10-FF-000218', NULL, 'WD40 repeat-containing protein HOS15', 358, NULL, NULL, 189574),
(189575, '1.20.1250.20-FF-001571', NULL, 'MFS general substrate transporter', 384, NULL, NULL, 189575),
(189576, '3.40.50.300-FF-008256', NULL, 'Uncharacterized protein', 50, NULL, NULL, 189576),
(189577, '3.40.50.300-FF-000275', NULL, 'Putative ras-related protein Rab-2A', 190, NULL, NULL, 189577),
(189578, '1.20.120.1110-FF-000007', NULL, 'Core-binding factor, runt domain, alpha subunit 2; translocated to, 2', 76, NULL, NULL, 189578),
(189579, '1.10.510.10-FF-001873', NULL, 'GG16618', 202, NULL, NULL, 189579),
(189580, '3.30.70.20-FF-000031', NULL, 'Dihydropyrimidine dehydrogenase subunit B', 102, NULL, NULL, 189580),
(189581, '2.60.40.790-FF-000093', NULL, '17.4 kDa class I heat shock protein 3', 143, NULL, NULL, 189581),
(189582, '1.10.510.10-FF-002710', NULL, 'TRK (Vertebrate neurotrophin receptor tyrosine kinase) homolog', 282, NULL, NULL, 189582),
(189583, '2.60.40.10-FF-003894', NULL, NULL, 67, NULL, NULL, 189583),
(189584, '2.10.25.10-FF-000758', NULL, 'Laminin subunit gamma 1', 79, NULL, NULL, 189584);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(189585, '1.10.287.450-FF-000001', NULL, 'adenomatous polyposis coli protein isoform X1', 125, NULL, NULL, 189585),
(189586, '3.30.200.20-FF-001817', NULL, 'DM1 protein kinase', 65, NULL, NULL, 189586),
(189587, '3.90.550.10-FF-000652', NULL, 'Chitin oligosaccharide synthase', 129, NULL, NULL, 189587),
(189588, '2.60.40.10-FF-000460', NULL, 'Bent, isoform J', 83, NULL, NULL, 189588),
(189589, '1.25.10.10-FF-001817', NULL, 'Uncharacterized protein', 303, NULL, NULL, 189589),
(189590, '1.10.10.10-FF-000221', NULL, 'IclR family transcriptional regulator', 73, NULL, NULL, 189590),
(189591, '2.120.10.80-FF-000161', NULL, 'KLHDC2 isoform 4', 120, NULL, NULL, 189591),
(189592, '1.20.5.780-FF-000003', NULL, 'FXYD domain-containing ion transport regulator', 66, NULL, NULL, 189592),
(189593, '1.10.510.10-FF-001569', NULL, 'Myotonin-protein kinase', 47, NULL, NULL, 189593),
(189594, '2.60.40.180-FF-000005', NULL, '5-hydroxyisourate hydrolase', 120, NULL, NULL, 189594),
(189595, '3.90.830.10-FF-000022', NULL, 'Vacuolar protein sorting-associated protein 33A', 112, NULL, NULL, 189595),
(189596, '1.10.150.50-FF-000030', NULL, 'transcription factor ETV6', 82, NULL, NULL, 189596),
(189597, '3.90.1150.210-FF-000017', NULL, 'F-actin-capping protein subunit beta', 120, NULL, NULL, 189597),
(189598, '2.20.25.190-FF-000005', NULL, 'Transcription elongation factor 1 homolog', 61, NULL, NULL, 189598),
(189599, '1.20.1250.20-FF-001088', NULL, 'Solute carrier family 22 member 9', 201, NULL, NULL, 189599),
(189600, '3.30.200.20-FF-001233', NULL, 'Serine/threonine-protein kinase OXI1', 92, NULL, NULL, 189600),
(189601, '3.80.10.10-FF-001657', NULL, 'Predicted protein', 85, NULL, NULL, 189601),
(189602, '3.40.1110.10-FF-000091', NULL, 'Phospholipid-transporting ATPase', 27, NULL, NULL, 189602),
(189603, '3.40.50.720-FF-000985', NULL, 'NmrA-like family protein', 287, NULL, NULL, 189603),
(189604, '2.30.29.30-FF-000912', NULL, 'Rho guanine nucleotide exchange factor 10', 144, NULL, NULL, 189604),
(189605, '2.60.40.60-FF-000014', NULL, 'Cadherin 8', 114, NULL, NULL, 189605),
(189606, '2.60.40.420-FF-000033', NULL, 'Ceruloplasmin', 153, NULL, NULL, 189606),
(189607, '3.40.20.10-FF-000053', NULL, 'Villin like', 119, NULL, NULL, 189607),
(189608, '3.40.50.300-FF-003057', NULL, 'ABC transporter ATP-binding protein', 251, NULL, NULL, 189608),
(189609, '2.70.98.10-FF-000064', NULL, 'Glycoside hydrolase family 2 protein', 291, NULL, NULL, 189609),
(189610, '2.10.270.10-FF-000006', NULL, 'Toxin B', 39, NULL, NULL, 189610),
(189611, '3.90.76.10-FF-000050', NULL, 'Peptide ABC transporter substrate-binding protein', 139, NULL, NULL, 189611),
(189612, '3.40.50.150-FF-001106', NULL, NULL, 175, NULL, NULL, 189612),
(189613, '3.90.1150.10-FF-000481', NULL, 'L-allo-threonine aldolase', 85, NULL, NULL, 189613),
(189614, '3.60.130.10-FF-000083', NULL, 'Uncharacterized protein', 140, NULL, NULL, 189614),
(189615, '2.60.120.200-FF-000509', NULL, 'Laminin subunit alpha-1-like Protein', 180, NULL, NULL, 189615),
(189616, '2.60.40.60-FF-000486', NULL, 'Cadherin 16, KSP-cadherin', 109, NULL, NULL, 189616),
(189617, '3.10.100.10-FF-000221', NULL, NULL, 146, NULL, NULL, 189617),
(189618, '4.10.60.20-FF-000001', NULL, 'Predicted protein', 52, NULL, NULL, 189618),
(189619, '2.130.10.10-FF-000117', NULL, 'WD repeat-containing protein 82', 65, NULL, NULL, 189619),
(189620, '3.40.50.150-FF-000117', NULL, 'Ribosomal RNA small subunit methyltransferase G', 214, NULL, NULL, 189620),
(189621, '2.130.10.10-FF-001106', NULL, 'LLGL scribble cell polarity complex component 1', 158, NULL, NULL, 189621),
(189622, '3.30.70.330-FF-000964', NULL, 'Regulator of rDNA transcription protein 5', 109, NULL, NULL, 189622),
(189623, '2.130.10.10-FF-005440', NULL, 'Uncharacterized protein', 211, NULL, NULL, 189623),
(189624, '2.30.29.30-FF-001368', NULL, 'Predicted protein', 126, NULL, NULL, 189624),
(189625, '1.25.40.1040-FF-000058', NULL, 'RNA processing protein', 192, NULL, NULL, 189625),
(189626, '1.10.287.70-FF-000139', NULL, 'Potassium channel SKOR', 242, NULL, NULL, 189626); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(189627, '2.60.40.10-FF-003219', NULL, NULL, 96, NULL, NULL, 189627),
(189628, '3.30.420.10-FF-000398', NULL, NULL, 206, NULL, NULL, 189628),
(189629, '2.30.29.30-FF-000379', NULL, 'dynamin-1 isoform X6', 107, NULL, NULL, 189629),
(189630, '3.40.50.620-FF-000781', NULL, 'Pantoate-beta-alanine ligase', 88, NULL, NULL, 189630),
(189631, '3.40.50.2300-FF-000907', NULL, NULL, 54, NULL, NULL, 189631),
(189632, '2.10.25.10-FF-001287', NULL, 'AGAP005526-PA', 78, NULL, NULL, 189632),
(189633, '3.20.20.80-FF-000456', NULL, 'Os01g0619800 protein', 95, NULL, NULL, 189633),
(189634, '1.25.40.10-FF-005175', NULL, 'Neutrophil cytosolic factor 2', 63, NULL, NULL, 189634),
(189635, '3.40.630.10-FF-000299', NULL, 'Uncharacterized protein', 303, NULL, NULL, 189635),
(189636, '3.30.200.20-FF-000244', NULL, 'Serine/threonine-protein kinase CDL1-like', 105, NULL, NULL, 189636),
(189637, '3.40.50.720-FF-000513', NULL, 'D-amino acid oxidase', 186, NULL, NULL, 189637),
(189638, '3.40.50.150-FF-001545', NULL, NULL, 90, NULL, NULL, 189638),
(189639, '2.30.42.10-FF-000398', NULL, NULL, 103, NULL, NULL, 189639),
(189640, '3.30.450.20-FF-000436', NULL, 'Putative hypoxia-inducible factor 1/neuronal pas domain protein npas1', 68, NULL, NULL, 189640),
(189641, '1.20.900.10-FF-000107', NULL, 'Predicted protein', 161, NULL, NULL, 189641),
(189642, '2.60.40.60-FF-001003', NULL, 'Protein CBR-CDH-7', 108, NULL, NULL, 189642),
(189643, '3.30.1490.180-FF-000034', NULL, 'DNA-directed RNA polymerase subunit', 21, NULL, NULL, 189643),
(189644, '3.40.50.1000-FF-000596', NULL, NULL, 141, NULL, NULL, 189644),
(189645, '3.30.830.10-FF-000272', NULL, 'Insulinase-like metalloprotease', 233, NULL, NULL, 189645),
(189646, '1.20.1260.10-FF-000068', NULL, 'Uncharacterized protein', 98, NULL, NULL, 189646),
(189647, '1.20.1270.210-FF-000001', NULL, NULL, 113, NULL, NULL, 189647),
(189648, '3.30.1370.10-FF-000174', NULL, 'Zinc finger CCCH domain-containing protein 52', 75, NULL, NULL, 189648),
(189649, '3.30.160.540-FF-000002', NULL, 'Probable septum site-determining protein MinC', 80, NULL, NULL, 189649),
(189650, '3.40.50.300-FF-001612', NULL, 'ras-related protein Rap-2a-like', 173, NULL, NULL, 189650),
(189651, '3.40.50.2300-FF-001043', NULL, NULL, 189, NULL, NULL, 189651),
(189652, '3.30.160.60-FF-003287', NULL, 'Zgc:113343', 31, NULL, NULL, 189652),
(189653, '2.130.10.10-FF-001545', NULL, 'WD repeat-containing protein 48', 183, NULL, NULL, 189653),
(189654, '2.40.10.10-FF-000447', NULL, NULL, 69, NULL, NULL, 189654),
(189655, '1.20.1250.20-FF-000099', NULL, 'Hippocampus abundant gene transcript 1', 367, NULL, NULL, 189655),
(189656, '1.20.58.60-FF-000851', NULL, 'Uncharacterized protein', 139, NULL, NULL, 189656),
(189657, '3.30.420.140-FF-000043', NULL, 'Uncharacterized protein', 121, NULL, NULL, 189657),
(189658, '3.40.50.2000-FF-001104', NULL, 'Glycosyltransferase', 33, NULL, NULL, 189658),
(189659, '1.20.58.2010-FF-000011', NULL, 'Uncharacterized protein', 102, NULL, NULL, 189659),
(189660, '1.10.10.60-FF-000106', NULL, 'Chromodomain-helicase-DNA-binding protein 2 isoform 1', 110, NULL, NULL, 189660),
(189661, '1.10.150.20-FF-000015', NULL, 'Transcription termination/antitermination protein NusA', 60, NULL, NULL, 189661),
(189662, '1.10.30.10-FF-000087', NULL, 'Uncharacterized protein', 79, NULL, NULL, 189662),
(189663, '1.25.40.10-FF-004186', NULL, 'TPR Domain containing protein', 82, NULL, NULL, 189663),
(189664, '1.10.220.10-FF-000041', NULL, 'Annexin', 70, NULL, NULL, 189664),
(189665, '2.130.10.10-FF-000589', NULL, 'WD repeat-containing protein 70', 146, NULL, NULL, 189665),
(189666, '3.30.110.20-FF-000006', NULL, 'Ribonuclease P protein subunit p25', 111, NULL, NULL, 189666),
(189667, '1.10.510.10-FF-002997', NULL, 'Protein CBG17985', 339, NULL, NULL, 189667),
(189668, '1.25.40.10-FF-000824', NULL, 'Serine/threonine-protein kinase PknG', 129, NULL, NULL, 189668),
(189669, '1.10.10.60-FF-000578', NULL, 'Helicase/SANT-associated, DNA binding protein', 63, NULL, NULL, 189669),
(189670, '3.30.46.10-FF-000005', NULL, 'Glycine N-methyltransferase', 25, NULL, NULL, 189670);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(189671, '3.30.70.590-FF-000019', NULL, 'Uncharacterized protein', 116, NULL, NULL, 189671),
(189672, '3.30.160.60-FF-005232', NULL, NULL, 80, NULL, NULL, 189672),
(189673, '1.25.10.10-FF-003110', NULL, 'Exportin-T', 740, NULL, NULL, 189673),
(189674, '3.40.50.300-FF-007239', NULL, 'Thymidine kinase, putative', 161, NULL, NULL, 189674),
(189675, '3.40.50.300-FF-001079', NULL, 'carbohydrate sulfotransferase 15', 323, NULL, NULL, 189675),
(189676, '3.30.1360.140-FF-000004', NULL, 'DNA-directed RNA polymerase subunit', 133, NULL, NULL, 189676),
(189677, '1.10.238.10-FF-000508', NULL, 'Probable calcium-binding protein CML35', 79, NULL, NULL, 189677),
(189678, '2.30.30.100-FF-000026', NULL, 'Enhancer of mRNA-decapping protein 3', 80, NULL, NULL, 189678),
(189679, '2.10.25.10-FF-000831', NULL, 'von Willebrand factor D and EGF domains', 31, NULL, NULL, 189679),
(189680, '1.10.1450.10-FF-000057', NULL, 'Tetraspanin', 87, NULL, NULL, 189680),
(189681, '3.30.160.60-FF-001050', NULL, 'zinc finger and BTB domain-containing protein 11', 31, NULL, NULL, 189681),
(189682, '1.20.1280.290-FF-000015', NULL, 'cystinosin isoform X2', 112, NULL, NULL, 189682),
(189683, '3.40.190.10-FF-000282', NULL, 'Nitrate ABC transporter substrate-binding protein', 102, NULL, NULL, 189683),
(189684, '1.20.58.100-FF-000018', NULL, NULL, 111, NULL, NULL, 189684),
(189685, '2.60.40.150-FF-000429', NULL, 'SyNapTotagmin', 49, NULL, NULL, 189685),
(189686, '3.40.50.150-FF-000589', NULL, 'tRNA methyltransferase 9B (putative)', 103, NULL, NULL, 189686),
(189687, '3.40.1130.10-FF-000002', NULL, 'Glycerol-3-phosphate acyltransferase, chloroplastic', 282, NULL, NULL, 189687),
(189688, '3.20.20.70-FF-000127', NULL, 'Ferredoxin-dependent glutamate synthase, chloroplastic', 347, NULL, NULL, 189688),
(189689, '1.20.1720.10-FF-000115', NULL, 'Uncharacterized protein', 381, NULL, NULL, 189689),
(189690, '1.20.58.1120-FF-000053', NULL, NULL, 170, NULL, NULL, 189690),
(189691, '1.20.1250.20-FF-000632', NULL, 'YDR387C-like protein', 258, NULL, NULL, 189691),
(189692, '3.40.120.10-FF-000069', NULL, 'Phosphomannomutase/phosphoglucomutase', 125, NULL, NULL, 189692),
(189693, '3.40.50.410-FF-000364', NULL, 'Uncharacterized protein', 214, NULL, NULL, 189693),
(189694, '3.40.1050.10-FF-000001', NULL, 'Carbonic anhydrase', 214, NULL, NULL, 189694),
(189695, '3.40.50.80-FF-000002', NULL, 'Ferredoxin--NADP reductase', 155, NULL, NULL, 189695),
(189696, '3.30.70.330-FF-000172', NULL, 'RNA splicing factor Pad-1', 102, NULL, NULL, 189696),
(189697, '2.60.120.970-FF-000072', NULL, 'Uncharacterized protein', 265, NULL, NULL, 189697),
(189698, '1.10.1410.40-FF-000007', NULL, 'Cyclic GMP-AMP synthase', 177, NULL, NULL, 189698),
(189699, '3.40.50.2000-FF-000587', NULL, 'Soyasaponin III rhamnosyltransferase', 269, NULL, NULL, 189699),
(189700, '2.120.10.80-FF-000026', NULL, 'Putative LOV domain-containing protein', 133, NULL, NULL, 189700),
(189701, '3.30.40.10-FF-000610', NULL, 'TNF receptor-associated factor', 59, NULL, NULL, 189701),
(189702, '1.25.40.20-FF-001642', NULL, 'Uncharacterized protein', 93, NULL, NULL, 189702),
(189703, '2.70.160.11-FF-000082', NULL, 'Protein arginine N-methyltransferase', 71, NULL, NULL, 189703),
(189704, '3.90.180.10-FF-000079', NULL, 'Quinone oxidoreductase', 168, NULL, NULL, 189704),
(189705, '3.40.140.70-FF-000010', NULL, 'Ubiquitin-like modifier-activating enzyme ATG7', 158, NULL, NULL, 189705),
(189706, '3.40.50.300-FF-004013', NULL, 'Putative DNA repair helicase', 188, NULL, NULL, 189706),
(189707, '1.10.10.10-FF-000996', NULL, 'Predicted protein', 90, NULL, NULL, 189707),
(189708, '2.130.10.10-FF-003462', NULL, 'Type II inositol polyphosphate 5-phosphatase 15', 399, NULL, NULL, 189708),
(189709, '3.10.20.30-FF-000043', NULL, 'Putative molybdenum cofactor biosynthesis protein D 2 moaD2', 82, NULL, NULL, 189709),
(189710, '3.50.50.60-FF-000647', NULL, 'Putative oxidoreductase', 167, NULL, NULL, 189710),
(189711, '3.30.40.10-FF-000138', NULL, 'CXXC-type zinc finger protein 1', 77, NULL, NULL, 189711),
(189712, '3.40.1190.10-FF-000011', NULL, 'Folylpolyglutamate synthase/dihydrofolate synthase', 289, NULL, NULL, 189712);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(189713, '3.90.1310.10-FF-000044', NULL, 'Peptidoglycan glycosyl transferase', 39, NULL, NULL, 189713),
(189714, '3.30.70.330-FF-002729', NULL, NULL, 97, NULL, NULL, 189714),
(189715, '1.25.40.10-FF-002741', NULL, 'Outer membrane protein assembly factor BamD', 230, NULL, NULL, 189715),
(189716, '3.30.70.20-FF-000115', NULL, NULL, 75, NULL, NULL, 189716),
(189717, '3.10.110.10-FF-000339', NULL, 'Uncharacterized protein', 294, NULL, NULL, 189717),
(189718, '1.20.120.720-FF-000018', NULL, 'unconventional myosin-XVIIIa isoform X1', 160, NULL, NULL, 189718),
(189719, '3.40.109.10-FF-000026', NULL, 'Nitroreductase', 221, NULL, NULL, 189719),
(189720, '1.10.730.20-FF-000009', NULL, 'Isoleucine--tRNA ligase', 286, NULL, NULL, 189720),
(189721, '1.10.3370.10-FF-000023', NULL, 'Uncharacterized protein', 287, NULL, NULL, 189721),
(189722, '1.20.1070.10-FF-001666', NULL, 'Uncharacterized protein', 125, NULL, NULL, 189722),
(189723, '3.40.190.80-FF-000050', NULL, 'Myo-inositol-1 phosphatase, putative', 110, NULL, NULL, 189723),
(189724, '3.40.50.2300-FF-000087', NULL, 'D-xylose ABC transporter, D-xylose-binding protein', 140, NULL, NULL, 189724),
(189725, '3.30.70.3490-FF-000042', NULL, NULL, 88, NULL, NULL, 189725),
(189726, '3.80.10.10-FF-002613', NULL, 'Uncharacterized protein', 228, NULL, NULL, 189726),
(189727, '2.60.120.470-FF-000012', NULL, NULL, 189, NULL, NULL, 189727),
(189728, '1.25.10.10-FF-002593', NULL, 'Uncharacterized protein', 152, NULL, NULL, 189728),
(189729, '3.40.50.300-FF-005474', NULL, 'Type III restriction enzyme, res subunit', 218, NULL, NULL, 189729),
(189730, '1.20.5.110-FF-000106', NULL, 'Vesicle-associated membrane protein, putative', 59, NULL, NULL, 189730),
(189731, '2.70.170.10-FF-000283', NULL, 'Protein CBG01074', 73, NULL, NULL, 189731),
(189732, '3.40.50.300-FF-003849', NULL, 'MRP family ATP-binding protein', 281, NULL, NULL, 189732),
(189733, '3.40.50.720-FF-001502', NULL, 'Uncharacterized protein', 220, NULL, NULL, 189733),
(189734, '2.130.10.10-FF-003523', NULL, 'Small nucleolar ribonucleoprotein complex subunit Dip2, putative', 174, NULL, NULL, 189734),
(189735, '2.60.40.10-FF-004647', NULL, NULL, 108, NULL, NULL, 189735),
(189736, '3.30.40.10-FF-000077', NULL, 'E3 ubiquitin-protein ligase SH3RF1 isoform X1', 82, NULL, NULL, 189736),
(189737, '1.10.287.130-FF-000219', NULL, 'Sensory transduction histidine kinase', 83, NULL, NULL, 189737),
(189738, '2.130.10.10-FF-002534', NULL, 'WD40-repeat-containing domain protein', 127, NULL, NULL, 189738),
(189739, '1.25.40.510-FF-000014', NULL, 'Uncharacterized protein', 299, NULL, NULL, 189739),
(189740, '1.10.1410.20-FF-000001', NULL, '2''-5''-oligoadenylate synthetase 1', 192, NULL, NULL, 189740),
(189741, '1.20.140.10-FF-000015', NULL, 'Acyl-coenzyme A oxidase', 174, NULL, NULL, 189741),
(189742, '3.30.450.70-FF-000018', NULL, 'Unplaced genomic scaffold supercont2.18, whole genome shotgun sequence', 165, NULL, NULL, 189742),
(189743, '2.20.28.10-FF-000051', NULL, 'DNA replication licensing factor (Mcm)', 47, NULL, NULL, 189743),
(189744, '2.40.40.20-FF-000071', NULL, 'AAA family ATPase, CDC48 subfamily', 89, NULL, NULL, 189744),
(189745, '3.30.1490.20-FF-000011', NULL, 'beta-citrylglutamate synthase B isoform X1', 67, NULL, NULL, 189745),
(189746, '3.30.160.20-FF-000156', NULL, 'APOBEC1 complementation factor isoform X1', 95, NULL, NULL, 189746),
(189747, '2.60.40.150-FF-000581', NULL, 'Predicted protein', 129, NULL, NULL, 189747),
(189748, '2.20.100.10-FF-000003', NULL, 'Adhesion G protein-coupled receptor B2', 55, NULL, NULL, 189748),
(189749, '2.130.10.10-FF-003023', NULL, 'Cac2p', 163, NULL, NULL, 189749),
(189750, '3.30.2460.20-FF-000004', NULL, 'Protein Wnt', 62, NULL, NULL, 189750),
(189751, '1.20.1250.20-FF-002077', NULL, 'Plasma membrane hexose transporter, putative', 277, NULL, NULL, 189751),
(189752, '1.10.510.10-FF-002558', NULL, 'Air-1', 270, NULL, NULL, 189752),
(189753, '3.20.20.190-FF-000167', NULL, NULL, 127, NULL, NULL, 189753),
(189754, '1.10.510.10-FF-000260', NULL, 'TGF-beta receptor type-2', 219, NULL, NULL, 189754);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(189755, '3.80.10.10-FF-003102', NULL, 'Leucine-rich repeat protein kinase family protein', 112, NULL, NULL, 189755),
(189756, '3.40.50.2300-FF-000587', NULL, 'Transcriptional regulator, LacI family', 131, NULL, NULL, 189756),
(189757, '1.10.1050.10-FF-000009', NULL, '30S ribosomal protein S4, chloroplastic', 116, NULL, NULL, 189757),
(189758, '3.55.40.20-FF-000006', NULL, 'Superoxide dismutase', 117, NULL, NULL, 189758),
(189759, '3.30.40.10-FF-001919', NULL, 'Uncharacterized protein', 71, NULL, NULL, 189759),
(189760, '1.20.1070.10-FF-000205', NULL, '[Arg8]-vasotocin receptor', 334, NULL, NULL, 189760),
(189761, '2.80.10.50-FF-000227', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 135, NULL, NULL, 189761),
(189762, '2.30.39.10-FF-000019', NULL, 'Serpin 4', 149, NULL, NULL, 189762),
(189763, '3.40.30.10-FF-000351', NULL, 'Protein disulfide isomerase-like 5-1', 114, NULL, NULL, 189763),
(189764, '3.40.50.300-FF-004838', NULL, 'Response regulator receiver', 240, NULL, NULL, 189764),
(189765, '3.90.228.10-FF-000016', NULL, 'Poly [ADP-ribose] polymerase', 103, NULL, NULL, 189765),
(189766, '1.10.8.10-FF-000304', NULL, 'Uncharacterized protein', 42, NULL, NULL, 189766),
(189767, '3.90.70.10-FF-000183', NULL, 'Papain family cysteine protease', 255, NULL, NULL, 189767),
(189768, '3.90.640.10-FF-000159', NULL, 'Heat shock protein 70 putative', 34, NULL, NULL, 189768),
(189769, '2.60.120.200-FF-000156', NULL, 'Galectin', 132, NULL, NULL, 189769),
(189770, '2.60.40.10-FF-005636', NULL, NULL, 95, NULL, NULL, 189770),
(189771, '1.20.58.60-FF-000412', NULL, 'Dystonin isoform X9', 223, NULL, NULL, 189771),
(189772, '1.20.1560.10-FF-000552', NULL, 'ABC Transporter, Mitochondrial', 90, NULL, NULL, 189772),
(189773, '3.100.10.10-FF-000002', NULL, '60S ribosomal protein L27a', 91, NULL, NULL, 189773),
(189774, '2.10.55.10-FF-000007', NULL, NULL, 84, NULL, NULL, 189774),
(189775, '3.40.50.300-FF-002068', NULL, 'CTP synthase', 302, NULL, NULL, 189775),
(189776, '1.10.510.10-FF-004503', NULL, NULL, 78, NULL, NULL, 189776),
(189777, '2.70.150.10-FF-000248', NULL, 'Putative Pol polyprotein from transposon element Bs1', 85, NULL, NULL, 189777),
(189778, '3.10.330.10-FF-000030', NULL, 'N-ethylmaleimide sensitive factor', 99, NULL, NULL, 189778),
(189779, '2.40.50.140-FF-000826', NULL, NULL, 105, NULL, NULL, 189779),
(189780, '1.20.1420.30-FF-000109', NULL, 'Uncharacterized protein', 87, NULL, NULL, 189780),
(189781, '2.30.30.40-FF-000014', NULL, 'Kinase C and casein kinase substrate in neurons protein', 62, NULL, NULL, 189781),
(189782, '1.25.40.10-FF-003730', NULL, 'Putative pentatricopeptide repeat-containing protein At3g01580', 90, NULL, NULL, 189782),
(189783, '3.40.140.10-FF-000071', NULL, 'Riboflavin biosynthesis protein PYRR, chloroplastic', 143, NULL, NULL, 189783),
(189784, '3.30.1490.40-FF-000017', NULL, NULL, 55, NULL, NULL, 189784),
(189785, '2.10.110.10-FF-000085', NULL, 'PDZ and LIM domain 2 (mystique)', 60, NULL, NULL, 189785),
(189786, '3.90.640.10-FF-000098', NULL, 'Actin-related protein 5', 34, NULL, NULL, 189786),
(189787, '3.80.10.10-FF-000668', NULL, 'F-box/LRR-repeat protein 15', 160, NULL, NULL, 189787),
(189788, '3.90.226.10-FF-000034', NULL, 'Enoyl-CoA delta isomerase 1', 203, NULL, NULL, 189788),
(189789, '3.30.430.20-FF-000053', NULL, 'Uncharacterized protein', 101, NULL, NULL, 189789),
(189790, '3.30.160.60-FF-006221', NULL, NULL, 86, NULL, NULL, 189790),
(189791, '1.25.10.10-FF-000204', NULL, 'Exportin 5', 1131, NULL, NULL, 189791),
(189792, '3.40.250.10-FF-000253', NULL, 'Uncharacterized protein', 103, NULL, NULL, 189792),
(189793, '1.20.120.1920-FF-000003', NULL, 'Ubiquitin-associated/translation elongation factor EF1B protein', 78, NULL, NULL, 189793),
(189794, '3.40.1170.60-FF-000002', NULL, 'Polymerase (DNA directed) kappa', 53, NULL, NULL, 189794),
(189795, '1.10.630.10-FF-000527', NULL, 'Uncharacterized protein', 384, NULL, NULL, 189795),
(189796, '3.80.10.10-FF-002113', NULL, 'Leucine-rich repeat-containing protein 66', 245, NULL, NULL, 189796),
(189797, '1.25.10.10-FF-002913', NULL, 'Uncharacterized protein', 117, NULL, NULL, 189797);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(189798, '1.25.50.20-FF-000007', NULL, 'Uncharacterized protein, isoform A', 326, NULL, NULL, 189798),
(189799, '1.10.555.10-FF-000110', NULL, 'RhoGAP domain containing protein', 215, NULL, NULL, 189799),
(189800, '2.40.10.340-FF-000013', NULL, 'Cell shape-determining protein MreC', 71, NULL, NULL, 189800),
(189801, '3.30.60.30-FF-000179', NULL, 'Agrin', 57, NULL, NULL, 189801),
(189802, '3.40.1350.10-FF-000013', NULL, 'Fanconi-associated nuclease', 93, NULL, NULL, 189802),
(189803, '2.60.40.1730-FF-000103', NULL, NULL, 50, NULL, NULL, 189803),
(189804, '3.30.200.20-FF-002161', NULL, 'Predicted protein', 65, NULL, NULL, 189804),
(189805, '3.30.70.330-FF-002881', NULL, NULL, 64, NULL, NULL, 189805),
(189806, '3.30.420.60-FF-000008', NULL, 'Pelota, putative', 132, NULL, NULL, 189806),
(189807, '1.10.275.60-FF-000002', NULL, 'Adenylosuccinate lyase', 136, NULL, NULL, 189807),
(189808, '3.40.50.2300-FF-001104', NULL, 'Extracellular calcium-sensing receptor', 283, NULL, NULL, 189808),
(189809, '3.30.470.20-FF-000027', NULL, 'Formate-dependent phosphoribosylglycinamide formyltransferase', 195, NULL, NULL, 189809),
(189810, '3.30.420.40-FF-000002', NULL, 'Muscle actin', 161, NULL, NULL, 189810),
(189811, '3.30.160.60-FF-002798', NULL, 'Zinc finger protein 623', 28, NULL, NULL, 189811),
(189812, '2.60.120.970-FF-000100', NULL, 'Uncharacterized protein', 145, NULL, NULL, 189812),
(189813, '3.10.580.10-FF-000009', NULL, 'Glycine betaine/L-proline ABC transporter ATP-binding protein', 101, NULL, NULL, 189813),
(189814, '3.20.20.150-FF-000003', NULL, 'L-ribulose-5-phosphate 3-epimerase UlaE', 284, NULL, NULL, 189814),
(189815, '1.10.8.50-FF-000029', NULL, 'Type 2 DNA topoisomerase 6 subunit B', 59, NULL, NULL, 189815),
(189816, '1.25.40.10-FF-001313', NULL, 'Os08g0162200 protein', 127, NULL, NULL, 189816),
(189817, '1.10.20.10-FF-000289', NULL, NULL, 70, NULL, NULL, 189817),
(189818, '1.50.10.10-FF-000051', NULL, 'Cellobiose phosphorylase', 412, NULL, NULL, 189818),
(189819, '1.20.1560.10-FF-000905', NULL, 'Uncharacterized protein', 175, NULL, NULL, 189819),
(189820, '3.40.1280.10-FF-000069', NULL, 'rRNA methyltransferase', 181, NULL, NULL, 189820),
(189821, '1.10.10.10-FF-000496', NULL, 'ArsR family transcriptional regulator', 103, NULL, NULL, 189821),
(189822, '3.40.1770.10-FF-000005', NULL, 'Probable urocanate hydratase', 333, NULL, NULL, 189822),
(189823, '1.20.58.60-FF-000379', NULL, 'Spectrin beta chain, non-erythrocytic', 106, NULL, NULL, 189823),
(189824, '1.25.10.10-FF-003077', NULL, 'Predicted protein', 241, NULL, NULL, 189824),
(189825, '3.40.50.720-FF-001002', NULL, 'Molybdopterin biosynthesis protein MoeB', 224, NULL, NULL, 189825),
(189826, '3.10.580.10-FF-000189', NULL, 'Hemolysin protein', 78, NULL, NULL, 189826),
(189827, '1.25.40.10-FF-000032', NULL, 'Interferon-induced protein with tetratricopeptide repeats 5', 248, NULL, NULL, 189827),
(189828, '1.20.5.1940-FF-000001', NULL, 'Vacuolar protein sorting-associated protein 27', 89, NULL, NULL, 189828),
(189829, '3.40.50.2000-FF-000907', NULL, 'Alpha-1,4 glucan phosphorylase', 165, NULL, NULL, 189829),
(189830, '3.30.230.10-FF-000243', NULL, 'Uncharacterized protein', 193, NULL, NULL, 189830),
(189831, '3.10.20.230-FF-000013', NULL, 'Serine/threonine-protein kinase DCLK3', 91, NULL, NULL, 189831),
(189832, '2.40.10.10-FF-000386', NULL, NULL, 86, NULL, NULL, 189832),
(189833, '3.50.50.60-FF-000147', NULL, 'Flavin-containing monooxygenase', 107, NULL, NULL, 189833),
(189834, '3.20.20.140-FF-000085', NULL, 'Enamidase', 258, NULL, NULL, 189834),
(189835, '1.20.1740.10-FF-000178', NULL, 'Uncharacterized protein', 416, NULL, NULL, 189835),
(189836, '2.60.200.40-FF-000022', NULL, 'Diacylglycerol kinase', 165, NULL, NULL, 189836),
(189837, '3.40.50.300-FF-007891', NULL, 'Dynein heavy chain domain 1', 193, NULL, NULL, 189837),
(189838, '2.60.40.1170-FF-000036', NULL, 'stonin-2 isoform X1', 31, NULL, NULL, 189838),
(189839, '3.10.129.10-FF-000124', NULL, 'Putative esterase PA0474', 133, NULL, NULL, 189839),
(189840, '1.10.10.10-FF-001513', NULL, 'Transcriptional adapter 2-beta', 85, NULL, NULL, 189840); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(189841, '3.30.70.360-FF-000035', NULL, 'Probable hydrolase', 115, NULL, NULL, 189841),
(189842, '3.30.497.10-FF-000058', NULL, 'Serpin family F member 2', 201, NULL, NULL, 189842),
(189843, '3.40.50.720-FF-002430', NULL, '2-dehydropantoate 2-reductase, putative (AFU_orthologue AFUA_3G06390)', 194, NULL, NULL, 189843),
(189844, '1.25.40.20-FF-000361', NULL, 'Swi4p', 234, NULL, NULL, 189844),
(189845, '3.30.160.60-FF-000561', NULL, 'Zinc finger protein 30 homolog', 28, NULL, NULL, 189845),
(189846, '3.40.50.150-FF-000617', NULL, 'Endothelin-converting enzyme 2', 100, NULL, NULL, 189846),
(189847, '3.30.70.1050-FF-000012', NULL, 'Trigger factor', 120, NULL, NULL, 189847),
(189848, '2.60.40.10-FF-005136', NULL, NULL, 122, NULL, NULL, 189848),
(189849, '2.30.30.40-FF-000514', NULL, 'Protein CBR-SMA-1', 45, NULL, NULL, 189849),
(189850, '3.40.50.1240-FF-000084', NULL, '2-phosphoxylose phosphatase 1', 426, NULL, NULL, 189850),
(189851, '3.30.1120.30-FF-000021', NULL, 'Serine/threonine-protein kinase PLK', 122, NULL, NULL, 189851),
(189852, '2.30.29.30-FF-000851', NULL, 'TFIIH/NER complex subunit', 65, NULL, NULL, 189852),
(189853, '3.90.1410.10-FF-000080', NULL, 'Uncharacterized protein', 282, NULL, NULL, 189853),
(189854, '3.40.640.10-FF-000064', NULL, 'Aspartate aminotransferase', 243, NULL, NULL, 189854),
(189855, '3.30.40.10-FF-000577', NULL, 'RBR-type E3 ubiquitin transferase', 86, NULL, NULL, 189855),
(189856, '2.10.25.10-FF-001348', NULL, 'von Willebrand factor D and EGF domains', 66, NULL, NULL, 189856),
(189857, '1.20.140.40-FF-000030', NULL, 'OSJNBa0027P08.11 protein', 165, NULL, NULL, 189857),
(189858, '3.40.190.10-FF-000343', NULL, 'NMDA receptor 2, isoform G', 68, NULL, NULL, 189858),
(189859, '1.10.287.130-FF-000158', NULL, 'Hybrid sensor histidine kinase/response regulator', 95, NULL, NULL, 189859),
(189860, '3.30.1120.30-FF-000049', NULL, 'Uncharacterized protein', 85, NULL, NULL, 189860),
(189861, '3.10.20.90-FF-000746', NULL, 'Uncharacterized protein', 101, NULL, NULL, 189861),
(189862, '2.60.40.10-FF-002410', NULL, 'Synaptogenesis protein syg-1', 99, NULL, NULL, 189862),
(189863, '1.25.40.10-FF-001460', NULL, 'SEL1 protein', 119, NULL, NULL, 189863),
(189864, '2.60.15.10-FF-000008', NULL, 'Putative Mitochondrial ATP synthase delta subunit', 103, NULL, NULL, 189864),
(189865, '1.10.2000.10-FF-000063', NULL, NULL, 131, NULL, NULL, 189865),
(189866, '1.10.238.20-FF-000045', NULL, 'GM23030', 119, NULL, NULL, 189866),
(189867, '1.10.357.10-FF-000083', NULL, 'Uncharacterized protein', 99, NULL, NULL, 189867),
(189868, '2.60.120.380-FF-000018', NULL, 'Calpain-c', 139, NULL, NULL, 189868),
(189869, '1.20.5.190-FF-000175', NULL, NULL, 42, NULL, NULL, 189869),
(189870, '3.30.450.20-FF-000375', NULL, 'Sensor histidine kinase/response regulator, putative', 129, NULL, NULL, 189870),
(189871, '1.10.340.30-FF-000027', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 136, NULL, NULL, 189871),
(189872, '1.10.510.10-FF-000760', NULL, 'Spire, isoform F', 205, NULL, NULL, 189872),
(189873, '3.40.390.10-FF-000263', NULL, NULL, 179, NULL, NULL, 189873),
(189874, '2.130.10.10-FF-005940', NULL, 'Predicted protein', 257, NULL, NULL, 189874),
(189875, '3.50.50.60-FF-000294', NULL, 'Probable monooxygenase', 77, NULL, NULL, 189875),
(189876, '1.10.510.10-FF-003486', NULL, NULL, 264, NULL, NULL, 189876),
(189877, '3.30.9.10-FF-000105', NULL, 'FAD dependent oxidoreductase', 184, NULL, NULL, 189877),
(189878, '3.80.10.10-FF-001596', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 106, NULL, NULL, 189878),
(189879, '1.10.1070.11-FF-000080', NULL, 'Acyl carrier protein', 187, NULL, NULL, 189879),
(189880, '3.30.300.30-FF-000018', NULL, 'Non-ribosomal peptide synthetase 3', 101, NULL, NULL, 189880),
(189881, '1.10.287.110-FF-000152', NULL, 'DnaJ family protein', 120, NULL, NULL, 189881),
(189882, '3.20.20.140-FF-000113', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 298, NULL, NULL, 189882),
(189883, '1.20.1720.10-FF-000087', NULL, 'Bcr/CflA family efflux transporter', 382, NULL, NULL, 189883);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(189884, '3.40.1110.10-FF-000411', NULL, NULL, 55, NULL, NULL, 189884),
(189885, '1.10.472.10-FF-000715', NULL, 'G2/M mitosis-specific cyclin B, copy C-like protein', 14, NULL, NULL, 189885),
(189886, '3.90.180.10-FF-000112', NULL, 'Uncharacterized protein', 96, NULL, NULL, 189886),
(189887, '3.30.70.1070-FF-000018', NULL, 'Uncharacterized protein', 78, NULL, NULL, 189887),
(189888, '1.20.1070.10-FF-000705', NULL, 'Uncharacterized protein', 312, NULL, NULL, 189888),
(189889, '1.10.10.10-FF-000024', NULL, 'U5 small nuclear ribonucleoprotein helicase', 92, NULL, NULL, 189889),
(189890, '3.30.70.1230-FF-000061', NULL, 'Adenylate cyclase', 196, NULL, NULL, 189890),
(189891, '2.120.10.30-FF-000444', NULL, 'Uncharacterized protein', 114, NULL, NULL, 189891),
(189892, '3.30.900.10-FF-000036', NULL, 'Autophagy-related protein 13', 248, NULL, NULL, 189892),
(189893, '3.30.1140.60-FF-000008', NULL, 'F-actin-capping protein subunit alpha', 86, NULL, NULL, 189893),
(189894, '1.10.510.10-FF-004003', NULL, NULL, 328, NULL, NULL, 189894),
(189895, '1.10.437.20-FF-000002', NULL, 'Protein C6', 131, NULL, NULL, 189895),
(189896, '2.60.40.650-FF-000017', NULL, 'Uncharacterized protein', 138, NULL, NULL, 189896),
(189897, '2.130.10.10-FF-003170', NULL, 'Predicted protein', 189, NULL, NULL, 189897),
(189898, '2.160.20.70-FF-000022', NULL, 'Alpha tubulin, putative', 172, NULL, NULL, 189898),
(189899, '3.80.10.10-FF-003574', NULL, 'F-box and leucine rich repeat protein 18', 143, NULL, NULL, 189899),
(189900, '1.10.472.10-FF-000687', NULL, 'Predicted protein', 105, NULL, NULL, 189900),
(189901, '1.25.40.10-FF-002802', NULL, 'Uncharacterized protein', 91, NULL, NULL, 189901),
(189902, '2.60.40.60-FF-000547', NULL, 'Cadherin-related hmr-1', 106, NULL, NULL, 189902),
(189903, '2.60.40.4060-FF-000009', NULL, 'spondin-1', 61, NULL, NULL, 189903),
(189904, '3.40.20.10-FF-000114', NULL, 'YALI0B14102p', 146, NULL, NULL, 189904),
(189905, '1.20.5.170-FF-000017', NULL, 'Putative E3 ubiquitin-protein ligase TRIM9', 58, NULL, NULL, 189905),
(189906, '1.10.357.20-FF-000001', NULL, 'Solute carrier family 41 member 2', 187, NULL, NULL, 189906),
(189907, '1.10.510.10-FF-003514', NULL, NULL, 248, NULL, NULL, 189907),
(189908, '1.25.40.20-FF-000653', NULL, 'Ankyrin repeat-containing protein', 46, NULL, NULL, 189908),
(189909, '3.90.850.10-FF-000052', NULL, NULL, 43, NULL, NULL, 189909),
(189910, '3.40.50.12650-FF-000021', NULL, 'Protein artemis', 142, NULL, NULL, 189910),
(189911, '3.30.70.330-FF-001009', NULL, 'Protein CBR-RSP-5', 83, NULL, NULL, 189911),
(189912, '2.60.40.10-FF-001893', NULL, 'Twitchin', 91, NULL, NULL, 189912),
(189913, '3.30.1140.40-FF-000002', NULL, 'Dynein light chain Tctex-type 3', 100, NULL, NULL, 189913),
(189914, '1.10.287.2900-FF-000001', NULL, 'mitochondrial intermembrane space import and assembly protein 40', 78, NULL, NULL, 189914),
(189915, '2.60.40.10-FF-003719', NULL, NULL, 101, NULL, NULL, 189915),
(189916, '1.20.1250.20-FF-000132', NULL, 'sugar phosphate exchanger 3 isoform X1', 201, NULL, NULL, 189916),
(189917, '2.60.120.290-FF-000082', NULL, 'Metalloendopeptidase', 115, NULL, NULL, 189917),
(189918, '3.30.1350.20-FF-000001', NULL, NULL, 45, NULL, NULL, 189918),
(189919, '1.10.20.130-FF-000002', NULL, 'Poly [ADP-ribose] polymerase', 74, NULL, NULL, 189919),
(189920, '2.40.50.140-FF-000798', NULL, NULL, 47, NULL, NULL, 189920),
(189921, '3.30.300.30-FF-000165', NULL, 'Uncharacterized protein', 144, NULL, NULL, 189921),
(189922, '1.25.40.10-FF-002269', NULL, 'Uncharacterized protein', 204, NULL, NULL, 189922),
(189923, '3.40.50.300-FF-003557', NULL, 'L-seryl-tRNA(Sec) kinase', 184, NULL, NULL, 189923),
(189924, '3.10.450.10-FF-000005', NULL, 'Histidine-rich glycoprotein', 105, NULL, NULL, 189924),
(189925, '1.20.1560.10-FF-000113', NULL, 'ABC transporter, putative', 338, NULL, NULL, 189925),
(189926, '2.10.230.10-FF-000032', NULL, 'Uncharacterized protein', 26, NULL, NULL, 189926),
(189927, '2.130.10.10-FF-001606', NULL, 'Uncharacterized protein, isoform H', 87, NULL, NULL, 189927),
(189928, '3.30.750.24-FF-000161', NULL, 'Sodium-independent sulfate anion transporter-like Protein', 109, NULL, NULL, 189928);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(189929, '3.40.50.2000-FF-000295', NULL, 'Phosphatidylinositol N-acetylglucosaminyltransferase subunit A, putative', 162, NULL, NULL, 189929),
(189930, '3.40.720.10-FF-000065', NULL, 'Arylsulfatase A', 363, NULL, NULL, 189930),
(189931, '2.60.40.10-FF-005283', NULL, NULL, 83, NULL, NULL, 189931),
(189932, '3.30.559.10-FF-000163', NULL, 'Nonribosomal peptide synthase 2', 178, NULL, NULL, 189932),
(189933, '3.90.980.20-FF-000007', NULL, 'Uncharacterized protein', 127, NULL, NULL, 189933),
(189934, '3.40.1380.20-FF-000023', NULL, 'Pyruvate kinase', 122, NULL, NULL, 189934),
(189935, '3.40.50.300-FF-004485', NULL, 'DNA repair protein RecN', 263, NULL, NULL, 189935),
(189936, '3.30.565.10-FF-000104', NULL, 'Sensor histidine kinase/response regulator TcsB/Sln1', 166, NULL, NULL, 189936),
(189937, '3.30.450.40-FF-000122', NULL, 'Phytochrome-like protein', 201, NULL, NULL, 189937),
(189938, '3.30.930.10-FF-000156', NULL, 'YER087W-like protein', 118, NULL, NULL, 189938),
(189939, '4.10.60.10-FF-000144', NULL, 'ATP-dependent RNA helicase glh-2', 60, NULL, NULL, 189939),
(189940, '1.20.5.170-FF-000197', NULL, 'C-type lectin domain family 4 member F', 40, NULL, NULL, 189940),
(189941, '2.130.10.10-FF-004451', NULL, 'Ribosome biogenesis protein WDR12 homolog', 348, NULL, NULL, 189941),
(189942, '3.40.850.10-FF-000310', NULL, 'Kinesin family member C2', 231, NULL, NULL, 189942),
(189943, '3.30.160.60-FF-002770', NULL, 'ZNF256 isoform 1', 29, NULL, NULL, 189943),
(189944, '3.20.10.10-FF-000070', NULL, 'Uncharacterized protein', 170, NULL, NULL, 189944),
(189945, '1.20.1070.10-FF-002122', NULL, 'Uncharacterized protein', 294, NULL, NULL, 189945),
(189946, '1.10.1490.10-FF-000003', NULL, 'DNA fragmentation factor, alpha polypeptide', 62, NULL, NULL, 189946),
(189947, '3.40.50.300-FF-005766', NULL, 'Uncharacterized protein', 111, NULL, NULL, 189947),
(189948, '4.10.280.10-FF-000078', NULL, 'Transcription factor bHLH13', 75, NULL, NULL, 189948),
(189949, '1.20.1250.20-FF-002105', NULL, 'Uncharacterized protein', 240, NULL, NULL, 189949),
(189950, '3.30.1120.10-FF-000043', NULL, 'Uncharacterized protein', 117, NULL, NULL, 189950),
(189951, '2.70.130.10-FF-000157', NULL, NULL, 123, NULL, NULL, 189951),
(189952, '3.90.70.10-FF-000475', NULL, 'Uncharacterized protein', 341, NULL, NULL, 189952),
(189953, '3.30.429.10-FF-000007', NULL, 'Macrophage migration inhibitory factor', 119, NULL, NULL, 189953),
(189954, '3.30.160.60-FF-001842', NULL, 'Zinc finger protein 25', 29, NULL, NULL, 189954),
(189955, '2.40.30.30-FF-000016', NULL, 'Uncharacterized protein', 121, NULL, NULL, 189955),
(189956, '3.30.40.10-FF-001066', NULL, 'Zinc finger family protein', 69, NULL, NULL, 189956),
(189957, '3.30.60.30-FF-000207', NULL, 'Uncharacterized protein', 73, NULL, NULL, 189957),
(189958, '2.60.34.10-FF-000052', NULL, 'Hsp70_protein_-_putative', 160, NULL, NULL, 189958),
(189959, '1.10.20.10-FF-000261', NULL, NULL, 113, NULL, NULL, 189959),
(189960, '2.60.40.1910-FF-000005', NULL, 'Aminopeptidase', 86, NULL, NULL, 189960),
(189961, '3.40.1690.10-FF-000004', NULL, 'SPI-2 type III secretion system apparatus protein SsaU', 141, NULL, NULL, 189961),
(189962, '2.160.20.10-FF-000111', NULL, 'Pectin lyase-like superfamily protein', 158, NULL, NULL, 189962),
(189963, '1.20.58.1030-FF-000026', NULL, 'Psf-1', 127, NULL, NULL, 189963),
(189964, '2.10.110.10-FF-000113', NULL, 'LIM domain-containing protein', 73, NULL, NULL, 189964),
(189965, '3.30.310.80-FF-000045', NULL, 'Uncharacterized protein', 119, NULL, NULL, 189965),
(189966, '1.10.490.10-FF-000055', NULL, 'Hemoglobin cathodic subunit beta', 146, NULL, NULL, 189966),
(189967, '3.20.20.70-FF-000599', NULL, NULL, 219, NULL, NULL, 189967),
(189968, '3.40.50.10810-FF-000194', NULL, 'Uncharacterized protein', 227, NULL, NULL, 189968),
(189969, '3.40.50.10940-FF-000002', NULL, 'L-arabinose isomerase', 174, NULL, NULL, 189969),
(189970, '3.40.50.300-FF-007711', NULL, 'Uncharacterized protein', 97, NULL, NULL, 189970),
(189971, '2.40.50.140-FF-001023', NULL, NULL, 47, NULL, NULL, 189971),
(189972, '1.20.1050.10-FF-000294', NULL, 'Safener induced1', 92, NULL, NULL, 189972);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(189973, '3.40.50.2300-FF-000879', NULL, NULL, 24, NULL, NULL, 189973),
(189974, '3.30.200.20-FF-000744', NULL, 'Aminoglycoside phosphotransferase', 89, NULL, NULL, 189974),
(189975, '2.60.40.10-FF-003158', NULL, 'Titin homolog', 99, NULL, NULL, 189975),
(189976, '3.30.160.60-FF-002359', NULL, 'Zinc finger protein 432', 30, NULL, NULL, 189976),
(189977, '1.10.8.60-FF-000358', NULL, 'Predicted protein', 98, NULL, NULL, 189977),
(189978, '2.40.128.20-FF-000021', NULL, 'Outer membrane lipoprotein Blc', 168, NULL, NULL, 189978),
(189979, '3.40.33.10-FF-000032', NULL, 'Predicted extracellular protein', 164, NULL, NULL, 189979),
(189980, '4.10.280.10-FF-000050', NULL, 'Basic helix-loop-helix transcription factor', 76, NULL, NULL, 189980),
(189981, '1.20.1250.20-FF-002369', NULL, 'Uncharacterized protein', 320, NULL, NULL, 189981),
(189982, '1.10.155.10-FF-000001', NULL, 'Chemotaxis methyltransferase CheR', 74, NULL, NULL, 189982),
(189983, '3.80.10.10-FF-004058', NULL, 'Uncharacterized protein', 134, NULL, NULL, 189983),
(189984, '1.20.1560.10-FF-000260', NULL, 'ABC transporter ATP-binding/membrane-spanning-hemolysin secretion protein', 311, NULL, NULL, 189984),
(189985, '2.40.160.120-FF-000032', NULL, 'Oxysterol-binding protein', 183, NULL, NULL, 189985),
(189986, '3.40.50.10130-FF-000024', NULL, 'Histone-lysine N-methyltransferase', 143, NULL, NULL, 189986),
(189987, '1.20.120.1070-FF-000001', NULL, 'Eukaryotic translation initiation factor 2B subunit alpha', 104, NULL, NULL, 189987),
(189988, '2.40.420.20-FF-000037', NULL, 'RND family efflux transporter, MFP subunit', 99, NULL, NULL, 189988),
(189989, '4.10.240.10-FF-000132', NULL, 'Transcription factor', 64, NULL, NULL, 189989),
(189990, '3.80.10.10-FF-002905', NULL, 'Uncharacterized protein', 127, NULL, NULL, 189990),
(189991, '2.60.40.10-FF-005928', NULL, NULL, 105, NULL, NULL, 189991),
(189992, '3.40.850.10-FF-000490', NULL, 'Kinesin-like protein', 270, NULL, NULL, 189992),
(189993, '1.10.1670.10-FF-000040', NULL, NULL, 65, NULL, NULL, 189993),
(189994, '3.40.50.620-FF-000601', NULL, 'Uncharacterized protein', 245, NULL, NULL, 189994),
(189995, '1.10.10.60-FF-001034', NULL, NULL, 77, NULL, NULL, 189995),
(189996, '1.25.10.10-FF-002121', NULL, 'Cell division control protein 7', 256, NULL, NULL, 189996),
(189997, '2.130.10.10-FF-003815', NULL, 'Uncharacterized protein', 306, NULL, NULL, 189997),
(189998, '3.20.20.80-FF-000395', NULL, 'AGAP001863-PB', 262, NULL, NULL, 189998),
(189999, '3.30.70.330-FF-001420', NULL, 'RNA-binding protein', 120, NULL, NULL, 189999),
(190000, '3.40.50.300-FF-008228', NULL, 'TBC1 domain family member 15', 62, NULL, NULL, 190000),
(190001, '1.10.287.380-FF-000036', NULL, 'ABC transporter ATP-binding protein uup-1', 80, NULL, NULL, 190001),
(190002, '3.30.710.10-FF-000206', NULL, 'G protein RhoBTB', 102, NULL, NULL, 190002),
(190003, '3.40.50.880-FF-000128', NULL, 'Os01g0217500 protein', 186, NULL, NULL, 190003),
(190004, '2.130.10.10-FF-001045', NULL, 'Cleavage stimulation factor subunit 1', 179, NULL, NULL, 190004),
(190005, '1.20.1300.20-FF-000013', NULL, 'Ubiquitin thioesterase', 145, NULL, NULL, 190005),
(190006, '4.10.260.10-FF-000015', NULL, 'Guanine nucleotide-binding protein (G protein), gamma 8', 50, NULL, NULL, 190006),
(190007, '1.10.1670.10-FF-000068', NULL, NULL, 74, NULL, NULL, 190007),
(190008, '3.40.50.620-FF-000629', NULL, 'Electron transfer flavoprotein alpha-subunit', 183, NULL, NULL, 190008),
(190009, '3.30.500.40-FF-000003', NULL, 'Zinc finger FYVE domain-containing protein', 153, NULL, NULL, 190009),
(190010, '1.25.10.10-FF-001632', NULL, 'Plakophilin-4', 464, NULL, NULL, 190010),
(190011, '1.20.58.390-FF-000032', NULL, 'gamma-aminobutyric acid receptor subunit epsilon', 136, NULL, NULL, 190011),
(190012, '2.60.420.10-FF-000018', NULL, 'Nigerose phosphorylase', 53, NULL, NULL, 190012),
(190013, '3.90.70.10-FF-000211', NULL, 'Clan CA, family C1, cathepsin H-like cysteine peptidase', 314, NULL, NULL, 190013),
(190014, '1.10.260.140-FF-000001', NULL, 'Cytosine-specific methyltransferase', 69, NULL, NULL, 190014);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(190015, '3.40.30.10-FF-001099', NULL, 'Uncharacterized protein', 70, NULL, NULL, 190015),
(190016, '3.30.70.2850-FF-000030', NULL, 'DNA-directed RNA polymerase subunit', 189, NULL, NULL, 190016),
(190017, '3.30.565.10-FF-000284', NULL, 'Two-component sensor histidine kinase', 151, NULL, NULL, 190017),
(190018, '3.40.50.1000-FF-000124', NULL, 'HAD-family hydrolase IIA', 115, NULL, NULL, 190018),
(190019, '2.60.120.10-FF-000737', NULL, 'Cyclic nucleotide-gated potassium channel', 122, NULL, NULL, 190019),
(190020, '1.10.8.10-FF-000276', NULL, 'AaceriACL055Wp', 42, NULL, NULL, 190020),
(190021, '2.60.200.20-FF-000275', NULL, 'Adenylate cyclase-like protein', 114, NULL, NULL, 190021),
(190022, '3.40.50.2000-FF-000115', NULL, 'Alpha-(1-6)-phosphatidylinositol monomannoside mannosyltransferase', 171, NULL, NULL, 190022),
(190023, '3.40.50.720-FF-001974', NULL, 'Putative short-chain dehydrogenase', 250, NULL, NULL, 190023),
(190024, '3.30.160.60-FF-004304', NULL, NULL, 27, NULL, NULL, 190024),
(190025, '3.50.50.60-FF-000939', NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', 140, NULL, NULL, 190025),
(190026, '1.20.1730.10-FF-000060', NULL, 'Uncharacterized protein', 121, NULL, NULL, 190026),
(190027, '3.30.40.10-FF-000638', NULL, 'PHD finger family protein', 116, NULL, NULL, 190027),
(190028, '3.30.450.20-FF-000144', NULL, 'Nuclear receptor coactivator 2', 123, NULL, NULL, 190028),
(190029, '3.40.50.1820-FF-001207', NULL, 'Uncharacterized protein', 335, NULL, NULL, 190029),
(190030, '3.30.200.20-FF-001525', NULL, 'Ribosomal protein S6 kinase', 60, NULL, NULL, 190030),
(190031, '3.80.10.10-FF-004119', NULL, 'Uncharacterized protein', 115, NULL, NULL, 190031),
(190032, '1.10.760.10-FF-000008', NULL, 'Cytochrome c', 105, NULL, NULL, 190032),
(190033, '3.90.190.20-FF-000026', NULL, 'UDP-N-acetylmuramoylalanine--D-glutamate ligase', 136, NULL, NULL, 190033),
(190034, '3.40.50.300-FF-003349', NULL, 'Dynein heavy chain', 252, NULL, NULL, 190034),
(190035, '3.30.63.20-FF-000003', NULL, '40S ribosomal protein S25-2', 56, NULL, NULL, 190035),
(190036, '3.40.50.1100-FF-000036', NULL, 'Threonine synthase like 2', 132, NULL, NULL, 190036),
(190037, '2.30.170.20-FF-000020', NULL, 'Predicted gene 20509', 89, NULL, NULL, 190037),
(190038, '3.30.70.1350-FF-000012', NULL, 'Cation diffusion facilitator 10', 79, NULL, NULL, 190038),
(190039, '3.30.160.60-FF-001342', NULL, 'Combgap, isoform F', 64, NULL, NULL, 190039),
(190040, '1.10.472.10-FF-000187', NULL, 'Putative cyclin 9', 113, NULL, NULL, 190040),
(190041, '1.20.5.110-FF-000078', NULL, 'Vesicle transport through interaction with t-SNAREs 1A', 81, NULL, NULL, 190041),
(190042, '3.30.780.10-FF-000008', NULL, 'eukaryotic translation initiation factor 2D', 86, NULL, NULL, 190042),
(190043, '3.30.200.20-FF-001997', NULL, NULL, 96, NULL, NULL, 190043),
(190044, '1.50.40.10-FF-000440', NULL, 'Solute carrier family 25, member 38b', 160, NULL, NULL, 190044),
(190045, '1.20.1250.20-FF-000340', NULL, 'MFS transporter, SHS family, lactate transporter', 206, NULL, NULL, 190045),
(190046, '2.30.29.30-FF-000087', NULL, 'FERM, RhoGEF and pleckstrin domain-containing protein 1', 151, NULL, NULL, 190046),
(190047, '3.30.70.3220-FF-000006', NULL, 'Protein translocase subunit SecD', 99, NULL, NULL, 190047),
(190048, '3.30.70.250-FF-000002', NULL, 'Malonyl CoA-ACP transacylase', 67, NULL, NULL, 190048),
(190049, '3.40.50.1000-FF-000416', NULL, 'Bifunctional epoxide hydrolase 2', 191, NULL, NULL, 190049),
(190050, '3.30.1370.10-FF-000027', NULL, 'insulin-like growth factor 2 mRNA-binding protein 3 isoform X1', 76, NULL, NULL, 190050),
(190051, '2.170.270.10-FF-000042', NULL, 'Variant-silencing SET protein', 249, NULL, NULL, 190051),
(190052, '2.60.120.10-FF-000092', NULL, 'Mannose-6-phosphate isomerase, putative', 41, NULL, NULL, 190052),
(190053, '3.20.20.80-FF-000748', NULL, 'Uncharacterized protein', 70, NULL, NULL, 190053),
(190054, '3.40.50.300-FF-000123', NULL, 'Peptide chain release factor 3', 140, NULL, NULL, 190054),
(190055, '3.30.420.10-FF-000218', NULL, 'RNA exonuclease, putative', 188, NULL, NULL, 190055);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(190056, '3.90.79.10-FF-000264', NULL, 'Uncharacterized protein', 115, NULL, NULL, 190056),
(190057, '2.10.50.30-FF-000058', NULL, 'Uncharacterized protein', 48, NULL, NULL, 190057),
(190058, '2.60.40.790-FF-000065', NULL, 'Heat shock protein', 149, NULL, NULL, 190058),
(190059, '3.60.130.20-FF-000001', NULL, 'Putative oxidoreductase', 300, NULL, NULL, 190059),
(190060, '3.40.50.300-FF-004985', NULL, 'Branched-chain amino acid ABC transporter, ATP-binding protein', 237, NULL, NULL, 190060),
(190061, '2.60.120.200-FF-000656', NULL, 'Uncharacterized protein', 90, NULL, NULL, 190061),
(190062, '1.10.10.60-FF-000286', NULL, 'Homeobox transcription factor', 68, NULL, NULL, 190062),
(190063, '3.80.10.10-FF-004030', NULL, 'Uncharacterized protein', 145, NULL, NULL, 190063),
(190064, '3.40.850.10-FF-000338', NULL, 'Kinesin-like protein', 101, NULL, NULL, 190064),
(190065, '3.30.70.330-FF-000672', NULL, 'Splicing factor 1', 115, NULL, NULL, 190065),
(190066, '2.40.50.100-FF-000101', NULL, 'Exosome component 3', 67, NULL, NULL, 190066),
(190067, '3.30.360.10-FF-000016', NULL, 'Probable aspartate-semialdehyde dehydrogenase', 183, NULL, NULL, 190067),
(190068, '2.130.10.10-FF-000297', NULL, 'DDB1- and CUL4-associated factor 5 isoform X1', 162, NULL, NULL, 190068),
(190069, '3.10.20.870-FF-000002', NULL, 'Transducin family protein / WD-40 repeat family protein', 75, NULL, NULL, 190069),
(190070, '3.90.640.10-FF-000131', NULL, 'DnaK protein', 89, NULL, NULL, 190070),
(190071, '3.90.180.10-FF-000051', NULL, 'Alcohol dehydrogenase (Zinc)', 219, NULL, NULL, 190071),
(190072, '1.10.1520.10-FF-000001', NULL, 'Ribonuclease 3', 152, NULL, NULL, 190072),
(190073, '3.40.50.150-FF-001253', NULL, NULL, 182, NULL, NULL, 190073),
(190074, '3.30.2160.10-FF-000074', NULL, 'Uncharacterized protein', 15, NULL, NULL, 190074),
(190075, '1.25.40.10-FF-000532', NULL, 'Clustered mitochondria protein homolog', 181, NULL, NULL, 190075),
(190076, '2.130.10.10-FF-001253', NULL, 'Peroxin 7, isoform A', 326, NULL, NULL, 190076),
(190077, '3.40.50.2300-FF-000615', NULL, 'Sensor histidine kinase/response regulator', 193, NULL, NULL, 190077),
(190078, '3.40.47.10-FF-000266', NULL, NULL, 145, NULL, NULL, 190078),
(190079, '3.40.50.12780-FF-000032', NULL, 'Acyl--CoA ligase', 415, NULL, NULL, 190079),
(190080, '3.10.590.10-FF-000015', NULL, 'Benign gonial cell neoplasm', 155, NULL, NULL, 190080),
(190081, '2.60.120.290-FF-000143', NULL, 'MGC130869 protein', 115, NULL, NULL, 190081),
(190082, '3.90.550.10-FF-000540', NULL, 'Cellulose synthase-like D7, glycosyltransferase family 2', 210, NULL, NULL, 190082),
(190083, '3.30.420.80-FF-000019', NULL, 'Uncharacterized protein', 52, NULL, NULL, 190083),
(190084, '3.30.230.10-FF-000035', NULL, '28S ribosomal protein S9, mitochondrial', 134, NULL, NULL, 190084),
(190085, '3.40.50.300-FF-001904', NULL, 'U5 small nuclear ribonucleoprotein-specific protein', 237, NULL, NULL, 190085),
(190086, '2.60.40.10-FF-006064', NULL, NULL, 97, NULL, NULL, 190086),
(190087, '1.20.58.530-FF-000029', NULL, 'Probable chitin synthase 8', 136, NULL, NULL, 190087),
(190088, '3.30.860.10-FF-000009', NULL, 'Ribosomal protein S15', 66, NULL, NULL, 190088),
(190089, '3.40.630.30-FF-000513', NULL, 'Predicted protein', 147, NULL, NULL, 190089),
(190090, '3.30.530.20-FF-000145', NULL, 'Phosphatidylinositol transfer protein, membrane-associated 2', 201, NULL, NULL, 190090),
(190091, '1.20.1270.60-FF-000095', NULL, 'Hydroxyproline-rich glycoprotein family protein', 215, NULL, NULL, 190091),
(190092, '3.10.129.10-FF-000096', NULL, 'UPF0336 protein C9J59_003700', 152, NULL, NULL, 190092),
(190093, '1.10.418.50-FF-000006', NULL, 'Uncharacterized protein', 64, NULL, NULL, 190093),
(190094, '2.30.30.140-FF-000223', NULL, 'Serine/threonine-protein kinase ATM', 99, NULL, NULL, 190094),
(190095, '1.20.5.4130-FF-000006', NULL, 'Disease resistance protein RPP13 variant', 107, NULL, NULL, 190095),
(190096, '2.60.120.330-FF-000228', NULL, 'Oxidoreductase, 2OG-Fe(II) oxygenase family, putative (AFU_orthologue AFUA_5G12242)', 155, NULL, NULL, 190096);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(190097, '1.20.1560.10-FF-000052', NULL, 'Multidrug ABC transporter ATP-binding protein', 305, NULL, NULL, 190097),
(190098, '3.40.50.150-FF-000297', NULL, '7SK snRNA methylphosphate capping enzyme', 217, NULL, NULL, 190098),
(190099, '1.20.1250.20-FF-000924', NULL, 'peptide transporter family 1', 477, NULL, NULL, 190099),
(190100, '3.30.1460.50-FF-000018', NULL, 'Autophagy-related protein 3', 129, NULL, NULL, 190100),
(190101, '3.10.50.10-FF-000005', NULL, 'Endochitinase B1', 63, NULL, NULL, 190101),
(190102, '3.40.50.720-FF-000221', NULL, 'Enoyl-[acyl-carrier-protein] reductase [NADH]', 400, NULL, NULL, 190102),
(190103, '1.25.10.10-FF-000704', NULL, 'Transport and golgi organization 6 homolog (Drosophila)', 411, NULL, NULL, 190103),
(190104, '3.90.550.20-FF-000009', NULL, 'Alpha-1,6-mannosyltransferase subunit (Hoc1)', 233, NULL, NULL, 190104),
(190105, '3.30.310.130-FF-000004', NULL, 'sentrin-specific protease 6 isoform X6', 111, NULL, NULL, 190105),
(190106, '2.60.40.1180-FF-000157', NULL, 'Glycoside hydrolase superfamily', 106, NULL, NULL, 190106),
(190107, '2.10.25.10-FF-001579', NULL, 'Uncharacterized protein', 38, NULL, NULL, 190107),
(190108, '3.90.470.20-FF-000008', NULL, 'Phosphopantetheine-protein transferase domain protein', 95, NULL, NULL, 190108),
(190109, '2.60.40.10-FF-004939', NULL, NULL, 65, NULL, NULL, 190109),
(190110, '1.25.40.10-FF-004747', NULL, 'Os01g0263600 protein', 68, NULL, NULL, 190110),
(190111, '2.100.10.50-FF-000001', NULL, 'DENN domain containing 4C', 164, NULL, NULL, 190111),
(190112, '3.30.160.20-FF-000009', NULL, 'Adenosine deaminase RNA-specific B2 (inactive)', 74, NULL, NULL, 190112),
(190113, '2.30.230.10-FF-000050', NULL, 'Uncharacterized protein', 252, NULL, NULL, 190113),
(190114, '3.10.250.10-FF-000024', NULL, 'CD6 molecule', 118, NULL, NULL, 190114),
(190115, '3.90.70.10-FF-000003', NULL, 'Ubiquitin carboxyl-terminal hydrolase 46', 354, NULL, NULL, 190115),
(190116, '3.80.10.10-FF-002793', NULL, 'Uncharacterized protein', 120, NULL, NULL, 190116),
(190117, '2.90.10.10-FF-000041', NULL, 'Uncharacterized protein', 96, NULL, NULL, 190117),
(190118, '1.10.1600.10-FF-000035', NULL, 'Uncharacterized protein', 95, NULL, NULL, 190118),
(190119, '3.40.850.10-FF-000282', NULL, 'Kinesin-like protein', 159, NULL, NULL, 190119),
(190120, '3.30.70.330-FF-000200', NULL, 'transformer-2 protein homolog alpha', 165, NULL, NULL, 190120),
(190121, '3.30.260.10-FF-000071', NULL, NULL, 35, NULL, NULL, 190121),
(190122, '3.40.1110.10-FF-000383', NULL, NULL, 138, NULL, NULL, 190122),
(190123, '3.90.70.10-FF-000828', NULL, 'Uncharacterized protein', 164, NULL, NULL, 190123),
(190124, '3.30.200.20-FF-002514', NULL, 'Non-specific serine/threonine protein kinase', 111, NULL, NULL, 190124),
(190125, '3.90.70.80-FF-000012', NULL, 'OTU domain-containing protein DDB_G0284757', 154, NULL, NULL, 190125),
(190126, '1.25.40.20-FF-001142', NULL, 'Putative ankyrin repeat domain family protein', 154, NULL, NULL, 190126),
(190127, '1.10.510.10-FF-001277', NULL, 'ALK2p Protein kinase', 167, NULL, NULL, 190127),
(190128, '1.10.12.10-FF-000006', NULL, 'Chromodomain Y-like protein', 57, NULL, NULL, 190128),
(190129, '3.10.50.40-FF-000109', NULL, 'Peptidylprolyl isomerase', 121, NULL, NULL, 190129),
(190130, '1.10.472.10-FF-000395', NULL, 'Cyclin-D2-1', 102, NULL, NULL, 190130),
(190131, '3.30.40.10-FF-001358', NULL, 'Retroelement pol polyprotein-like', 82, NULL, NULL, 190131),
(190132, '3.20.20.70-FF-000066', NULL, 'Dihydroorotate dehydrogenase (quinone), mitochondrial', 364, NULL, NULL, 190132),
(190133, '1.20.58.150-FF-000011', NULL, 'Uncharacterized protein', 145, NULL, NULL, 190133),
(190134, '3.30.160.60-FF-001550', NULL, 'myc-associated zinc finger protein isoform X1', 59, NULL, NULL, 190134),
(190135, '1.25.10.10-FF-000384', NULL, 'exportin-7 isoform X5', 406, NULL, NULL, 190135),
(190136, '3.30.200.20-FF-002189', NULL, 'Uncharacterized protein', 55, NULL, NULL, 190136),
(190137, '2.60.40.10-FF-001713', NULL, 'Immunoglobulin lambda variable 3-19', 107, NULL, NULL, 190137),
(190138, '3.40.50.300-FF-002629', NULL, 'tRNA ligase,putative Trl1p', 186, NULL, NULL, 190138);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(190139, '3.40.50.300-FF-001551', NULL, 'RAB13 isoform 4', 119, NULL, NULL, 190139),
(190140, '1.20.1560.10-FF-000405', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 23, NULL, NULL, 190140),
(190141, '1.20.1740.10-FF-000150', NULL, 'Expressed sequence AU018091', 126, NULL, NULL, 190141),
(190142, '1.10.287.70-FF-000111', NULL, 'Potassium voltage-gated channel subfamily D member 3', 68, NULL, NULL, 190142),
(190143, '1.10.287.520-FF-000005', NULL, 'Bone morphogenetic protein antagonist noggin, putative', 60, NULL, NULL, 190143),
(190144, '1.10.1660.10-FF-000011', NULL, 'MerR family transcriptional regulator', 87, NULL, NULL, 190144),
(190145, '2.20.130.20-FF-000008', NULL, 'Complement component C5', 111, NULL, NULL, 190145),
(190146, '3.40.50.1100-FF-000300', NULL, 'Pyridoxal-5''-phosphate-dependent enzyme family protein', 83, NULL, NULL, 190146),
(190147, '3.30.720.210-FF-000025', NULL, 'ATP-dependent zinc metalloprotease FtsH', 73, NULL, NULL, 190147),
(190148, '1.20.1250.20-FF-001060', NULL, 'Major Facilitator Superfamily', 194, NULL, NULL, 190148),
(190149, '1.10.472.10-FF-000507', NULL, 'Uncharacterized protein', 103, NULL, NULL, 190149),
(190150, '2.70.98.30-FF-000042', NULL, 'Uncharacterized protein', 61, NULL, NULL, 190150),
(190151, '1.10.1420.10-FF-000201', NULL, 'DNA mismatch repair protein MSH2', 86, NULL, NULL, 190151),
(190152, '1.10.238.10-FF-000952', NULL, 'Lysophosphatidylcholine acyltransferase', 74, NULL, NULL, 190152),
(190153, '1.10.150.300-FF-000007', NULL, NULL, 51, NULL, NULL, 190153),
(190154, '1.20.58.400-FF-000018', NULL, 'Uncharacterized protein', 101, NULL, NULL, 190154),
(190155, '3.30.1370.10-FF-000235', NULL, 'Uncharacterized protein', 72, NULL, NULL, 190155),
(190156, '3.40.50.2000-FF-000407', NULL, 'Exopolysaccharide biosynthesis protein EpsF', 169, NULL, NULL, 190156),
(190157, '1.10.3520.10-FF-000001', NULL, 'Pleckstrin domain-containing family A member 8', 203, NULL, NULL, 190157),
(190158, '2.40.50.140-FF-000326', NULL, 'Replication protein A1, small', 207, NULL, NULL, 190158),
(190159, '1.10.357.150-FF-000006', NULL, 'Centromere/kinetochore protein zw10 homolog', 217, NULL, NULL, 190159),
(190160, '3.80.10.10-FF-000168', NULL, 'Distal membrane arm assembly complex 2', 170, NULL, NULL, 190160),
(190161, '3.30.200.20-FF-001733', NULL, 'Ephrin receptor', 103, NULL, NULL, 190161),
(190162, '3.30.559.10-FF-000219', NULL, 'Uncharacterized protein', 186, NULL, NULL, 190162),
(190163, '3.40.50.300-FF-004777', NULL, 'Ras family protein', 116, NULL, NULL, 190163),
(190164, '3.40.190.10-FF-000843', NULL, 'Ionotropic glutamate receptor, putative', 98, NULL, NULL, 190164),
(190165, '1.25.40.470-FF-000013', NULL, 'intraflagellar transport protein 172 homolog', 132, NULL, NULL, 190165),
(190166, '1.10.10.160-FF-000014', NULL, 'Unplaced genomic scaffold supercont1.10, whole genome shotgun sequence', 90, NULL, NULL, 190166),
(190167, '3.40.50.720-FF-000485', NULL, 'glyoxylate reductase/hydroxypyruvate reductase-like', 71, NULL, NULL, 190167),
(190168, '3.60.21.10-FF-000475', NULL, 'Double-strand break repair protein MRE11', 66, NULL, NULL, 190168),
(190169, '3.30.70.270-FF-000160', NULL, 'GGDEF family protein', 175, NULL, NULL, 190169),
(190170, '3.50.50.60-FF-000794', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 285, NULL, NULL, 190170),
(190171, '1.10.8.270-FF-000162', NULL, 'RabGAP, TBC domain-containing protein', 171, NULL, NULL, 190171),
(190172, '3.30.160.60-FF-004776', NULL, NULL, 37, NULL, NULL, 190172),
(190173, '1.10.30.10-FF-000115', NULL, 'AGAP005183-PA', 72, NULL, NULL, 190173),
(190174, '3.30.70.330-FF-001392', NULL, 'Cytoplasmic polyadenylation element-binding protein 2', 88, NULL, NULL, 190174),
(190175, '3.30.70.3290-FF-000015', NULL, 'Probable polyketide synthase 16', 142, NULL, NULL, 190175),
(190176, '3.80.10.10-FF-001096', NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', 159, NULL, NULL, 190176),
(190177, '3.20.20.140-FF-000405', NULL, 'Predicted protein', 113, NULL, NULL, 190177);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(190178, '3.90.79.10-FF-000056', NULL, 'Nudix hydrolase 3', 201, NULL, NULL, 190178),
(190179, '3.90.1750.10-FF-000099', NULL, 'Predicted protein', 94, NULL, NULL, 190179),
(190180, '1.20.1060.20-FF-000005', NULL, 'Structural maintenance of chromosomes 2', 71, NULL, NULL, 190180),
(190181, '2.30.29.30-FF-000351', NULL, 'Phospholipase', 128, NULL, NULL, 190181),
(190182, '3.20.20.140-FF-000293', NULL, 'PHP domain protein', 216, NULL, NULL, 190182),
(190183, '1.25.10.10-FF-000968', NULL, 'FAT domain-containing protein', 443, NULL, NULL, 190183),
(190184, '2.130.10.10-FF-004743', NULL, 'Uncharacterized protein', 162, NULL, NULL, 190184),
(190185, '1.20.1250.20-FF-001588', NULL, 'Autophagy-related protein 22', 319, NULL, NULL, 190185),
(190186, '1.10.238.110-FF-000013', NULL, 'Diacylglycerol kinase', 112, NULL, NULL, 190186),
(190187, '3.30.1490.20-FF-000039', NULL, 'D-alanine--D-alanine ligase', 66, NULL, NULL, 190187),
(190188, '2.40.70.10-FF-000131', NULL, 'Uncharacterized protein', 124, NULL, NULL, 190188),
(190189, '3.10.180.10-FF-000052', NULL, '4-hydroxyphenylpyruvate dioxygenase', 178, NULL, NULL, 190189),
(190190, '3.40.50.2300-FF-001604', NULL, NULL, 70, NULL, NULL, 190190),
(190191, '1.20.1280.50-FF-000031', NULL, 'F-box/WD repeat-containing protein 4 isoform X1', 83, NULL, NULL, 190191),
(190192, '3.40.1090.10-FF-000094', NULL, 'Patatin-like phospholipase domain-containing protein 4', 120, NULL, NULL, 190192),
(190193, '1.10.10.10-FF-001305', NULL, 'LysR family transcriptional regulator', 84, NULL, NULL, 190193),
(190194, '1.10.840.10-FF-000009', NULL, 'rap guanine nucleotide exchange factor 1', 253, NULL, NULL, 190194),
(190195, '1.20.120.850-FF-000006', NULL, 'Protein PHOTOPERIOD-INDEPENDENT EARLY FLOWERING 1', 66, NULL, NULL, 190195),
(190196, '2.30.42.10-FF-000426', NULL, NULL, 92, NULL, NULL, 190196),
(190197, '1.10.10.10-FF-001805', NULL, 'Probable transcriptional regulator', 68, NULL, NULL, 190197),
(190198, '3.80.10.10-FF-000640', NULL, 'Tubulin-specific chaperone e', 132, NULL, NULL, 190198),
(190199, '1.10.1580.10-FF-000010', NULL, 'GTP-binding protein, putative', 92, NULL, NULL, 190199),
(190200, '3.30.40.10-FF-002347', NULL, 'LON peptidase N-terminal domain and RING finger protein C14F5.10c', 89, NULL, NULL, 190200),
(190201, '1.10.418.10-FF-000045', NULL, 'Fimbrin-1 isoform A', 113, NULL, NULL, 190201),
(190202, '3.30.1520.10-FF-000152', NULL, 'Uncharacterized protein', 100, NULL, NULL, 190202),
(190203, '1.25.40.1040-FF-000030', NULL, 'N-terminal acetyltransferase A complex auxiliary subunit NAA15', 36, NULL, NULL, 190203),
(190204, '2.70.150.10-FF-000220', NULL, 'Calcium-transporting ATPase 8 family protein', 34, NULL, NULL, 190204),
(190205, '3.30.40.10-FF-000285', NULL, 'RING-H2 finger protein ATL43', 75, NULL, NULL, 190205),
(190206, '1.10.287.1150-FF-000004', NULL, '2-oxoglutarate dehydrogenase E1 component', 83, NULL, NULL, 190206),
(190207, '1.20.1110.10-FF-000001', NULL, 'Calcium-transporting ATPase', 252, NULL, NULL, 190207),
(190208, '1.10.287.820-FF-000005', NULL, 'Pickpocket 14', 104, NULL, NULL, 190208),
(190209, '3.40.50.720-FF-002019', NULL, 'NAD-dependent epimerase/dehydratase', 208, NULL, NULL, 190209),
(190210, '4.10.1000.10-FF-000010', NULL, 'zinc finger CCCH domain-containing protein 15', 77, NULL, NULL, 190210),
(190211, '2.30.29.30-FF-001076', NULL, 'Uncharacterized protein', 69, NULL, NULL, 190211),
(190212, '3.40.50.150-FF-000409', NULL, 'RNA methylase, PF01170 family', 206, NULL, NULL, 190212),
(190213, '3.30.450.260-FF-000006', NULL, 'head-specific guanylate cyclase', 128, NULL, NULL, 190213),
(190214, '2.130.10.10-FF-005732', NULL, 'Intraflagellar transport protein 122 homolog-like Protein', 132, NULL, NULL, 190214),
(190215, '1.25.40.180-FF-000106', NULL, 'Translation initiation factor 4G', 186, NULL, NULL, 190215),
(190216, '1.10.238.210-FF-000009', NULL, 'glutaminase kidney isoform, mitochondrial-like', 87, NULL, NULL, 190216),
(190217, '3.50.7.10-FF-000062', NULL, NULL, 170, NULL, NULL, 190217),
(190218, '1.25.40.10-FF-003758', NULL, 'Uncharacterized protein', 165, NULL, NULL, 190218);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(190219, '1.10.1740.10-FF-000012', NULL, 'RNA polymerase sigma factor', 104, NULL, NULL, 190219),
(190220, '3.60.40.10-FF-000098', NULL, 'Protein phosphatase 2C, putative', 346, NULL, NULL, 190220),
(190221, '3.30.70.3030-FF-000016', NULL, 'Nucleolar protein 6', 131, NULL, NULL, 190221),
(190222, '3.40.50.1820-FF-000218', NULL, 'Dihydrofolate reductase', 252, NULL, NULL, 190222),
(190223, '3.40.190.10-FF-000782', NULL, 'Oligopeptide-binding protein oppA', 231, NULL, NULL, 190223),
(190224, '2.130.10.10-FF-003670', NULL, 'Protein CBG10826', 203, NULL, NULL, 190224),
(190225, '3.50.50.60-FF-000086', NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', 298, NULL, NULL, 190225),
(190226, '1.20.1270.60-FF-000207', NULL, 'YALI0F01694p', 216, NULL, NULL, 190226),
(190227, '3.20.20.80-FF-000164', NULL, 'Chitinase, variant', 285, NULL, NULL, 190227),
(190228, '3.20.20.70-FF-000627', NULL, NULL, 286, NULL, NULL, 190228),
(190229, '3.40.50.620-FF-000337', NULL, 'Two-component sensor histidine kinase', 129, NULL, NULL, 190229),
(190230, '3.30.760.10-FF-000064', NULL, 'Uncharacterized protein', 218, NULL, NULL, 190230),
(190231, '3.30.70.270-FF-000221', NULL, NULL, 170, NULL, NULL, 190231),
(190232, '1.20.1070.10-FF-001402', NULL, 'Uncharacterized protein', 238, NULL, NULL, 190232),
(190233, '1.20.920.20-FF-000027', NULL, 'Dynein heavy chain', 338, NULL, NULL, 190233),
(190234, '1.20.1080.10-FF-000003', NULL, 'Lens fiber major intrinsic', 242, NULL, NULL, 190234),
(190235, '2.60.40.820-FF-000029', NULL, 'Uncharacterized protein', 95, NULL, NULL, 190235),
(190236, '1.25.40.10-FF-005203', NULL, 'Putative uncharacterized protein DDB_G0278921', 208, NULL, NULL, 190236),
(190237, '1.20.920.10-FF-000081', NULL, 'Bromodomain and WD repeat-containing protein', 123, NULL, NULL, 190237),
(190238, '1.10.8.60-FF-000066', NULL, 'AAA-type ATPase family protein', 84, NULL, NULL, 190238),
(190239, '3.30.420.10-FF-000370', NULL, NULL, 191, NULL, NULL, 190239),
(190240, '2.30.29.30-FF-000412', NULL, 'Phosphoinositide phospholipase C', 73, NULL, NULL, 190240),
(190241, '1.20.5.110-FF-000286', NULL, 'Uncharacterized protein', 57, NULL, NULL, 190241),
(190242, '4.10.400.10-FF-000167', NULL, 'Predicted protein', 42, NULL, NULL, 190242),
(190243, '1.10.238.10-FF-001205', NULL, 'Uncharacterized protein', 76, NULL, NULL, 190243),
(190244, '2.20.70.10-FF-000025', NULL, 'E3 ubiquitin-protein ligase NEDD4-like protein', 76, NULL, NULL, 190244),
(190245, '1.10.150.20-FF-000162', NULL, 'Probable DNA polymerase X-putative', 50, NULL, NULL, 190245),
(190246, '2.40.30.10-FF-000477', NULL, 'Uncharacterized protein', 52, NULL, NULL, 190246),
(190247, '1.10.510.10-FF-000288', NULL, 'Receptor-interacting serine/threonine-protein kinase 2', 301, NULL, NULL, 190247),
(190248, '1.10.510.10-FF-002497', NULL, 'Serine/threonine protein kinase', 227, NULL, NULL, 190248),
(190249, '2.170.240.10-FF-000006', NULL, 'Collagen, type IV, alpha 4', 153, NULL, NULL, 190249),
(190250, '2.40.70.10-FF-000395', NULL, NULL, 183, NULL, NULL, 190250),
(190251, '3.40.50.10810-FF-000222', NULL, 'Protein CBR-RAD-54', 63, NULL, NULL, 190251),
(190252, '2.60.40.60-FF-000986', NULL, 'Uncharacterized protein', 98, NULL, NULL, 190252),
(190253, '3.20.20.450-FF-000003', NULL, 'RNase E specificity factor CsrD', 249, NULL, NULL, 190253),
(190254, '1.10.220.150-FF-000046', NULL, 'ADP ribosylation factor, putative', 127, NULL, NULL, 190254),
(190255, '1.20.5.170-FF-000225', NULL, 'Uncharacterized protein', 75, NULL, NULL, 190255),
(190256, '3.90.190.10-FF-000377', NULL, 'Uncharacterized protein', 97, NULL, NULL, 190256),
(190257, '3.40.50.410-FF-000156', NULL, 'General Transcription Factor homolog', 222, NULL, NULL, 190257),
(190258, '3.30.420.40-FF-000474', NULL, 'Rhamnulokinase', 250, NULL, NULL, 190258),
(190259, '2.30.40.10-FF-000091', NULL, 'N-acyl-D-amino-acid deacylase family protein', 80, NULL, NULL, 190259),
(190260, '3.30.505.10-FF-000067', NULL, 'Src homology 2 domain-containing E', 135, NULL, NULL, 190260),
(190261, '3.50.50.60-FF-000439', NULL, 'Prolycopene isomerase, chloroplastic', 120, NULL, NULL, 190261);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(190262, '2.130.10.10-FF-004951', NULL, 'Uncharacterized protein', 97, NULL, NULL, 190262),
(190263, '3.80.10.10-FF-002585', NULL, 'Uncharacterized protein', 103, NULL, NULL, 190263),
(190264, '3.40.50.2000-FF-000615', NULL, 'Alphaalpha-trehalose-phosphate synthase [UDP-forming] 5', 68, NULL, NULL, 190264),
(190265, '3.30.160.60-FF-002270', NULL, 'PR/SET domain 16', 29, NULL, NULL, 190265),
(190266, '1.25.40.10-FF-004539', NULL, 'Uncharacterized protein', 50, NULL, NULL, 190266),
(190267, '3.30.160.20-FF-000217', NULL, 'Uncharacterized protein', 81, NULL, NULL, 190267),
(190268, '3.30.1520.10-FF-000091', NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', 125, NULL, NULL, 190268),
(190269, '1.20.58.60-FF-000620', NULL, 'Nesprin-2', 71, NULL, NULL, 190269),
(190270, '1.10.287.70-FF-000611', NULL, 'Uncharacterized protein', 264, NULL, NULL, 190270),
(190271, '3.40.50.1010-FF-000009', NULL, 'Constitutive coactivator of PPAR-gamma-like protein 1', 216, NULL, NULL, 190271),
(190272, '1.10.3810.10-FF-000012', NULL, 'Glycosyl transferase family 51', 238, NULL, NULL, 190272),
(190273, '2.60.220.50-FF-000026', NULL, 'Adhesion G protein-coupled receptor G5', 175, NULL, NULL, 190273),
(190274, '1.10.10.10-FF-000788', NULL, 'GntR family transcriptional regulator', 75, NULL, NULL, 190274),
(190275, '2.60.40.10-FF-001393', NULL, 'Junctional adhesion molecule 2', 106, NULL, NULL, 190275),
(190276, '3.40.50.300-FF-004277', NULL, 'Uncharacterized protein', 149, NULL, NULL, 190276),
(190277, '3.40.50.1110-FF-000157', NULL, 'Uncharacterized protein', 152, NULL, NULL, 190277),
(190278, '1.20.1560.10-FF-000613', NULL, 'Protein CBR-PGP-12', 166, NULL, NULL, 190278),
(190279, '1.10.10.440-FF-000031', NULL, 'Pre-mRNA-processing protein 40C isoform C', 65, NULL, NULL, 190279),
(190280, '3.30.70.260-FF-000123', NULL, 'NagB/RpiA/CoA transferase-like superfamily protein', 87, NULL, NULL, 190280),
(190281, '3.30.40.10-FF-001566', NULL, 'Uncharacterized protein', 96, NULL, NULL, 190281),
(190282, '2.160.20.10-FF-000083', NULL, 'Periplasmic copper-binding protein (NosD)/Right handed beta helix region containing protein, putative', 266, NULL, NULL, 190282),
(190283, '3.10.310.40-FF-000010', NULL, 'Alanine--tRNA ligase, cytoplasmic', 112, NULL, NULL, 190283),
(190284, '3.60.110.10-FF-000053', NULL, 'Uncharacterized protein', 310, NULL, NULL, 190284),
(190285, '2.130.10.10-FF-002034', NULL, 'Predicted protein', 142, NULL, NULL, 190285),
(190286, '2.60.40.10-FF-001449', NULL, 'Echinoid, isoform C', 103, NULL, NULL, 190286),
(190287, '3.10.20.90-FF-000162', NULL, 'E3 ubiquitin-protein ligase RING1', 110, NULL, NULL, 190287),
(190288, '2.60.40.60-FF-000839', NULL, 'Uncharacterized protein', 101, NULL, NULL, 190288),
(190289, '3.30.160.60-FF-006485', NULL, NULL, 77, NULL, NULL, 190289),
(190290, '2.60.120.650-FF-000206', NULL, 'Uncharacterized protein', 139, NULL, NULL, 190290),
(190291, '3.10.10.10-FF-000031', NULL, NULL, 114, NULL, NULL, 190291),
(190292, '2.20.100.10-FF-000234', NULL, 'Semaphorin-5A', 67, NULL, NULL, 190292),
(190293, '3.30.200.20-FF-002453', NULL, 'Uncharacterized protein', 57, NULL, NULL, 190293),
(190294, '2.60.120.650-FF-000094', NULL, 'Protein associating with small stress protein PASS1', 139, NULL, NULL, 190294),
(190295, '2.60.120.10-FF-000153', NULL, 'Hcp transcriptional regulator HcpR (Crp/Fnr family)', 220, NULL, NULL, 190295),
(190296, '2.60.120.260-FF-000600', NULL, 'Uncharacterized protein', 146, NULL, NULL, 190296),
(190297, '3.40.720.10-FF-000126', NULL, 'Arylsulfatase family member H', 21, NULL, NULL, 190297),
(190298, '3.50.50.60-FF-000586', NULL, 'Sulfide quinone oxidoreductase', 113, NULL, NULL, 190298),
(190299, '1.25.40.10-FF-000324', NULL, 'Pentatricopeptide repeat-containing protein', 123, NULL, NULL, 190299),
(190300, '3.40.50.1980-FF-000013', NULL, 'Ferrichrome ABC transporter substrate-binding protein', 159, NULL, NULL, 190300),
(190301, '1.20.144.10-FF-000131', NULL, 'Uncharacterized protein', 127, NULL, NULL, 190301),
(190302, '3.40.190.10-FF-000635', NULL, 'LysR family transcriptional regulator', 83, NULL, NULL, 190302);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(190303, '1.20.58.830-FF-000029', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 158, NULL, NULL, 190303),
(190304, '2.10.25.10-FF-000067', NULL, 'Laminin subunit gamma 1', 44, NULL, NULL, 190304),
(190305, '3.30.230.130-FF-000042', NULL, 'Predicted protein', 126, NULL, NULL, 190305),
(190306, '1.25.40.10-FF-003258', NULL, 'Os07g0172600 protein', 264, NULL, NULL, 190306),
(190307, '3.30.1460.10-FF-000001', NULL, 'CesT family type III secretion system chaperone', 101, NULL, NULL, 190307),
(190308, '1.25.40.10-FF-004686', NULL, 'Uncharacterized protein', 103, NULL, NULL, 190308),
(190309, '2.30.29.30-FF-000148', NULL, 'pleckstrin homology domain-containing family M member 2', 112, NULL, NULL, 190309),
(190310, '3.40.50.720-FF-002519', NULL, 'Uncharacterized protein', 113, NULL, NULL, 190310),
(190311, '1.10.418.10-FF-000253', NULL, 'Uncharacterized protein', 90, NULL, NULL, 190311),
(190312, '3.30.70.330-FF-001892', NULL, NULL, 85, NULL, NULL, 190312),
(190313, '2.80.10.50-FF-000199', NULL, 'FSHD region gene 1', 113, NULL, NULL, 190313),
(190314, '2.30.30.190-FF-000013', NULL, 'Tubulin-folding cofactor B', 89, NULL, NULL, 190314),
(190315, '2.130.10.10-FF-000909', NULL, 'activating molecule in BECN1-regulated autophagy protein 1', 189, NULL, NULL, 190315),
(190316, '3.30.70.1840-FF-000002', NULL, 'Putative spike glycoprotein', 57, NULL, NULL, 190316),
(190317, '1.10.238.10-FF-000188', NULL, 'Protein S100', 105, NULL, NULL, 190317),
(190318, '2.60.200.10-FF-000007', NULL, 'Interferon regulatory factor 7', 224, NULL, NULL, 190318),
(190319, '2.30.30.40-FF-000222', NULL, 'SH3 domain-containing protein Dlish', 64, NULL, NULL, 190319),
(190320, '2.30.180.10-FF-000197', NULL, NULL, 36, NULL, NULL, 190320),
(190321, '3.40.50.11350-FF-000030', NULL, 'Predicted protein', 167, NULL, NULL, 190321),
(190322, '1.10.8.60-FF-000566', NULL, 'Uncharacterized protein', 79, NULL, NULL, 190322),
(190323, '3.40.50.1820-FF-000370', NULL, 'LIPaSe related', 277, NULL, NULL, 190323),
(190324, '2.130.10.10-FF-003315', NULL, 'Elongator subunit', 161, NULL, NULL, 190324),
(190325, '3.40.50.10190-FF-000227', NULL, 'Uncharacterized protein', 92, NULL, NULL, 190325),
(190326, '3.40.630.30-FF-000193', NULL, 'Histone acetyltransferase', 32, NULL, NULL, 190326),
(190327, '1.20.120.1080-FF-000122', NULL, 'Putative ATP-dependent RNA helicase', 171, NULL, NULL, 190327),
(190328, '3.40.50.20-FF-000063', NULL, 'D-alanine--D-alanine ligase', 110, NULL, NULL, 190328),
(190329, '3.30.70.270-FF-000013', NULL, 'Polymerase (DNA directed) iota', 127, NULL, NULL, 190329),
(190330, '1.10.8.1220-FF-000029', NULL, NULL, 91, NULL, NULL, 190330),
(190331, '2.10.220.10-FF-000003', NULL, 'R-spondin 3', 120, NULL, NULL, 190331),
(190332, '1.20.120.1530-FF-000009', NULL, 'Aerotaxis transducer Aer2', 156, NULL, NULL, 190332),
(190333, '2.30.30.40-FF-000486', NULL, 'SH3 and PX domain-containing protein 2B', 80, NULL, NULL, 190333),
(190334, '3.40.50.2300-FF-000379', NULL, 'Gamma-aminobutyric acid B receptor', 103, NULL, NULL, 190334),
(190335, '1.25.40.180-FF-000050', NULL, 'Nuclear protein (Sgd1), putative', 283, NULL, NULL, 190335),
(190336, '3.40.50.1360-FF-000035', NULL, '6-phosphogluconolactonase', 241, NULL, NULL, 190336),
(190337, '3.80.10.10-FF-003866', NULL, 'Predicted protein', 143, NULL, NULL, 190337),
(190338, '3.40.50.620-FF-000129', NULL, 'Valine--tRNA ligase', 168, NULL, NULL, 190338),
(190339, '1.10.132.60-FF-000047', NULL, 'Uncharacterized protein', 181, NULL, NULL, 190339),
(190340, '1.25.40.20-FF-000945', NULL, 'Uncharacterized protein', 131, NULL, NULL, 190340),
(190341, '2.60.210.10-FF-000036', NULL, NULL, 134, NULL, NULL, 190341),
(190342, '1.20.1070.10-FF-001874', NULL, 'Uncharacterized protein', 293, NULL, NULL, 190342),
(190343, '3.30.200.20-FF-001172', NULL, 'Kinase, STE STE20', 91, NULL, NULL, 190343),
(190344, '3.40.50.300-FF-002568', NULL, 'Cell division protein (FtsH)', 186, NULL, NULL, 190344),
(190345, '2.130.10.10-FF-004804', NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', 145, NULL, NULL, 190345);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(190346, '1.25.10.10-FF-001424', NULL, 'Related to Condensin complex subunit 3', 246, NULL, NULL, 190346),
(190347, '3.80.10.10-FF-003602', NULL, 'Uncharacterized protein', 126, NULL, NULL, 190347),
(190348, '1.20.58.390-FF-000240', NULL, 'Uncharacterized protein', 128, NULL, NULL, 190348),
(190349, '3.30.160.60-FF-003607', NULL, 'Metallothionein expression activator', 31, NULL, NULL, 190349),
(190350, '2.20.70.10-FF-000233', NULL, 'Uncharacterized protein', 46, NULL, NULL, 190350),
(190351, '2.40.100.10-FF-000044', NULL, 'Cyclophilin 40', 177, NULL, NULL, 190351),
(190352, '1.10.10.60-FF-001242', NULL, NULL, 45, NULL, NULL, 190352),
(190353, '2.60.120.260-FF-000359', NULL, 'Uncharacterized protein', 150, NULL, NULL, 190353),
(190354, '2.60.200.20-FF-000067', NULL, 'Vacuolar sorting protein', 124, NULL, NULL, 190354),
(190355, '1.20.1070.10-FF-000385', NULL, 'Olfactory receptor', 255, NULL, NULL, 190355),
(190356, '1.20.1250.20-FF-000863', NULL, 'MFS transporter', 197, NULL, NULL, 190356),
(190357, '3.40.50.720-FF-001766', NULL, 'NmrA-like negative transcriptional regulator, putative', 162, NULL, NULL, 190357),
(190358, '1.20.1560.10-FF-000760', NULL, 'Uncharacterized protein', 325, NULL, NULL, 190358),
(190359, '3.30.70.2350-FF-000003', NULL, 'Probable glpG protein', 68, NULL, NULL, 190359),
(190360, '3.40.630.10-FF-000035', NULL, 'Probable aminopeptidase NPEPL1', 328, NULL, NULL, 190360),
(190361, '3.40.50.150-FF-000909', NULL, NULL, 120, NULL, NULL, 190361),
(190362, '3.30.160.60-FF-006013', NULL, NULL, 85, NULL, NULL, 190362),
(190363, '1.25.40.10-FF-000796', NULL, 'Crooked neck pre-mRNA splicing factor 1', 125, NULL, NULL, 190363),
(190364, '1.20.5.1700-FF-000013', NULL, 'Transforming acidic coiled-coil containing protein, putative', 48, NULL, NULL, 190364),
(190365, '3.10.20.70-FF-000004', NULL, 'Glutamine synthetase', 110, NULL, NULL, 190365),
(190366, '1.10.1370.30-FF-000034', NULL, 'Angiotensin-converting enzyme', 215, NULL, NULL, 190366),
(190367, '4.10.1060.50-FF-000003', NULL, 'Double zinc ribbon and ankyrin repeat domains 1', 49, NULL, NULL, 190367),
(190368, '1.10.10.10-FF-001452', NULL, 'Meiotic recombination protein SPO11, putative', 76, NULL, NULL, 190368),
(190369, '1.25.40.20-FF-001350', NULL, 'Uncharacterized protein', 107, NULL, NULL, 190369),
(190370, '3.30.200.20-FF-000805', NULL, 'L-type lectin-domain containing receptor kinase V.9', 92, NULL, NULL, 190370),
(190371, '1.20.5.2700-FF-000004', NULL, 'NADH dehydrogenase I subunit L', 76, NULL, NULL, 190371),
(190372, '3.40.50.720-FF-000721', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 167, NULL, NULL, 190372),
(190373, '3.40.50.150-FF-001314', NULL, NULL, 297, NULL, NULL, 190373),
(190374, '2.120.10.30-FF-000236', NULL, 'Uncharacterized protein', 98, NULL, NULL, 190374),
(190375, '3.40.50.2000-FF-000879', NULL, 'AHPC/TSA protein, putative', 189, NULL, NULL, 190375),
(190376, '3.40.50.970-FF-000155', NULL, '2-oxoglutarate dehydrogenase, putative', 123, NULL, NULL, 190376),
(190377, '3.30.450.30-FF-000001', NULL, 'Profilin', 126, NULL, NULL, 190377),
(190378, '1.10.10.10-FF-000524', NULL, 'Heat shock factor, isoform D', 106, NULL, NULL, 190378),
(190379, '1.10.510.10-FF-001777', NULL, 'Uncharacterized protein', 362, NULL, NULL, 190379),
(190380, '3.90.550.50-FF-000057', NULL, 'Hexosyltransferase', 230, NULL, NULL, 190380),
(190381, '3.50.50.60-FF-001103', NULL, 'Uncharacterized protein', 217, NULL, NULL, 190381),
(190382, '3.30.70.1450-FF-000008', NULL, 'Putative transport protein YidE', 67, NULL, NULL, 190382),
(190383, '2.60.40.1730-FF-000075', NULL, NULL, 142, NULL, NULL, 190383),
(190384, '1.20.1740.10-FF-000206', NULL, 'Amino acid transporter, putative', 146, NULL, NULL, 190384),
(190385, '1.10.10.60-FF-000786', NULL, NULL, 63, NULL, NULL, 190385),
(190386, '3.60.20.10-FF-000243', NULL, NULL, 66, NULL, NULL, 190386),
(190387, '3.40.50.1010-FF-000161', NULL, NULL, 206, NULL, NULL, 190387),
(190388, '3.40.50.1000-FF-000624', NULL, NULL, 150, NULL, NULL, 190388),
(190389, '3.30.70.80-FF-000026', NULL, 'Uncharacterized protein', 51, NULL, NULL, 190389);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(190390, '3.30.450.50-FF-000007', NULL, 'SNARE complex subunit SEC22', 125, NULL, NULL, 190390),
(190391, '2.60.120.200-FF-000448', NULL, 'Uncharacterized protein', 176, NULL, NULL, 190391),
(190392, '2.40.30.130-FF-000049', NULL, 'Gll2349 protein', 101, NULL, NULL, 190392),
(190393, '1.10.287.470-FF-000063', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 60, NULL, NULL, 190393),
(190394, '3.40.50.300-FF-002832', NULL, 'ABC Transporter family', 238, NULL, NULL, 190394),
(190395, '1.50.40.10-FF-000232', NULL, 'Mitochondrial succinate-fumarate transporter 1', 156, NULL, NULL, 190395),
(190396, '3.30.40.10-FF-000902', NULL, 'TNF receptor-associated factor', 131, NULL, NULL, 190396),
(190397, '2.130.10.10-FF-005468', NULL, 'Uncharacterized protein', 167, NULL, NULL, 190397),
(190398, '3.30.420.10-FF-000426', NULL, 'Chromosome-Segregation and RNAi deficient', 264, NULL, NULL, 190398),
(190399, '3.30.70.330-FF-003073', NULL, NULL, 102, NULL, NULL, 190399),
(190400, '3.80.10.10-FF-004530', NULL, 'Uncharacterized protein', 206, NULL, NULL, 190400),
(190401, '2.40.37.10-FF-000043', NULL, 'Ornithine decarboxylase, putative', 131, NULL, NULL, 190401),
(190402, '2.130.10.10-FF-000089', NULL, 'Cleavage stimulation factor subunit 1', 174, NULL, NULL, 190402),
(190403, '2.40.50.40-FF-000083', NULL, 'Uncharacterized protein', 63, NULL, NULL, 190403),
(190404, '1.10.510.10-FF-003986', NULL, NULL, 110, NULL, NULL, 190404),
(190405, '3.40.50.10140-FF-000061', NULL, 'Transmembrane receptors / ATP binding protein', 165, NULL, NULL, 190405),
(190406, '3.80.10.10-FF-002321', NULL, 'Piriformospora indica-insensitive protein 2', 141, NULL, NULL, 190406),
(190407, '3.20.20.100-FF-000152', NULL, 'Uncharacterized protein', 261, NULL, NULL, 190407),
(190408, '2.60.40.10-FF-005344', NULL, NULL, 71, NULL, NULL, 190408),
(190409, '3.40.50.850-FF-000001', NULL, 'Isochorismatase domain-containing protein 1', 196, NULL, NULL, 190409),
(190410, '3.40.50.11840-FF-000020', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', 55, NULL, NULL, 190410),
(190411, '1.20.920.10-FF-000137', NULL, 'Uncharacterized protein', 88, NULL, NULL, 190411),
(190412, '2.40.290.10-FF-000001', NULL, 'X-ray repair cross complementing 6', 123, NULL, NULL, 190412),
(190413, '3.10.110.10-FF-000047', NULL, 'ubiquitin-conjugating enzyme E2 20', 149, NULL, NULL, 190413),
(190414, '1.20.5.2210-FF-000009', NULL, 'Predicted protein', 103, NULL, NULL, 190414),
(190415, '3.90.1200.10-FF-000007', NULL, 'hydroxylysine kinase isoform X1', 214, NULL, NULL, 190415),
(190416, '3.40.50.300-FF-000623', NULL, 'Elongator acetyltransferase complex subunit 4', 340, NULL, NULL, 190416),
(190417, '3.30.70.330-FF-000464', NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', 151, NULL, NULL, 190417),
(190418, '3.30.190.20-FF-000045', NULL, 'Uncharacterized protein', 61, NULL, NULL, 190418),
(190419, '1.10.10.60-FF-000078', NULL, 'NK2 homeobox 3', 82, NULL, NULL, 190419),
(190420, '1.20.1270.10-FF-000041', NULL, 'Uncharacterized protein', 114, NULL, NULL, 190420),
(190421, '1.25.40.10-FF-001252', NULL, 'Hypothetical_protein_-_conserved', 97, NULL, NULL, 190421),
(190422, '1.10.640.10-FF-000033', NULL, 'Uncharacterized protein', 204, NULL, NULL, 190422),
(190423, '2.60.220.50-FF-000173', NULL, 'Uncharacterized protein', 92, NULL, NULL, 190423),
(190424, '3.40.50.620-FF-000281', NULL, 'Ethanolamine-phosphate cytidylyltransferase', 199, NULL, NULL, 190424),
(190425, '1.10.110.10-FF-000004', NULL, 'Alpha-amylase inhibitor 0.19', 121, NULL, NULL, 190425),
(190426, '1.10.510.10-FF-000552', NULL, 'extracellular tyrosine-protein kinase PKDCC isoform X5', 239, NULL, NULL, 190426),
(190427, '3.40.366.10-FF-000038', NULL, 'Malonyl CoA:ACP acyltransferase (mitochondrial)', 136, NULL, NULL, 190427),
(190428, '3.40.640.10-FF-000272', NULL, 'Probable 8-amino-7-oxononanoate synthase (Eurofung)', 248, NULL, NULL, 190428),
(190429, '3.40.50.2300-FF-000115', NULL, 'Two-component system response regulator', 82, NULL, NULL, 190429),
(190430, '1.20.1730.10-FF-000121', NULL, 'Uncharacterized protein', 521, NULL, NULL, 190430); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(190431, '3.40.50.300-FF-005182', NULL, 'Elongator subunit', 310, NULL, NULL, 190431),
(190432, '3.30.160.60-FF-005440', NULL, NULL, 28, NULL, NULL, 190432),
(190433, '3.40.50.300-FF-007391', NULL, 'GPA1 heterotrimeric G protein alpha subunit protein', 206, NULL, NULL, 190433),
(190434, '2.130.10.10-FF-000797', NULL, 'Transducin family protein / WD-40 repeat family protein', 168, NULL, NULL, 190434),
(190435, '1.10.510.10-FF-003014', NULL, NULL, 168, NULL, NULL, 190435),
(190436, '2.170.300.10-FF-000096', NULL, 'Predicted protein', 57, NULL, NULL, 190436),
(190437, '3.80.10.10-FF-000376', NULL, 'Slit guidance ligand 2', 131, NULL, NULL, 190437),
(190438, '3.40.1280.30-FF-000024', NULL, 'Uncharacterized protein', 194, NULL, NULL, 190438),
(190439, '3.40.630.30-FF-000305', NULL, 'N(alpha)-acetyltransferase 80, NatH catalytic subunit', 131, NULL, NULL, 190439),
(190440, '3.40.50.720-FF-000013', NULL, 'Malate dehydrogenase', 147, NULL, NULL, 190440),
(190441, '3.90.226.10-FF-000326', NULL, 'Glr1525 protein', 166, NULL, NULL, 190441),
(190442, '3.90.550.10-FF-000040', NULL, 'cellulose synthase-like protein D3', 138, NULL, NULL, 190442),
(190443, '1.25.40.20-FF-001873', NULL, 'Uncharacterized protein', 128, NULL, NULL, 190443),
(190444, '1.20.120.1240-FF-000046', NULL, 'Dynamin central region-domain-containing protein', 100, NULL, NULL, 190444),
(190445, '1.10.510.10-FF-001069', NULL, 'Germinal center kinase 1', 203, NULL, NULL, 190445),
(190446, '2.60.40.10-FF-000673', NULL, 'Titin a', 95, NULL, NULL, 190446),
(190447, '3.30.572.10-FF-000008', NULL, 'thymidylate synthase isoform X2', 291, NULL, NULL, 190447),
(190448, '3.60.60.10-FF-000009', NULL, 'Choloylglycine hydrolase', 324, NULL, NULL, 190448),
(190449, '3.30.1330.30-FF-000003', NULL, '60S ribosomal protein L7a', 185, NULL, NULL, 190449),
(190450, '3.40.50.300-FF-001287', NULL, 'Ras-related protein Rab-1B', 200, NULL, NULL, 190450),
(190451, '2.10.25.10-FF-000331', NULL, 'Multiple epidermal growth factor-like domains 8', 39, NULL, NULL, 190451),
(190452, '1.10.10.650-FF-000004', NULL, 'Transcription elongation factor Spt6', 167, NULL, NULL, 190452),
(190453, '3.40.50.300-FF-003496', NULL, 'Cullin-associated NEDD8-dissociated protein 1', 84, NULL, NULL, 190453),
(190454, '1.25.40.10-FF-001813', NULL, 'Putative pentatricopeptide repeat-containing protein', 128, NULL, NULL, 190454),
(190455, '2.40.160.50-FF-000014', NULL, 'Chromosome 7, whole genome shotgun sequence', 343, NULL, NULL, 190455),
(190456, '3.30.160.60-FF-003495', NULL, 'Zinc finger protein 680', 61, NULL, NULL, 190456),
(190457, '3.30.50.10-FF-000167', NULL, 'Uncharacterized protein', 84, NULL, NULL, 190457),
(190458, '1.10.287.660-FF-000030', NULL, 'Uncharacterized protein', 77, NULL, NULL, 190458),
(190459, '2.40.50.120-FF-000056', NULL, 'Uncharacterized protein', 66, NULL, NULL, 190459),
(190460, '3.60.10.10-FF-000006', NULL, 'Exodeoxyribonuclease III', 268, NULL, NULL, 190460),
(190461, '3.40.50.300-FF-000887', NULL, 'Ras-related protein Rab-19', 185, NULL, NULL, 190461),
(190462, '3.40.50.1820-FF-001707', NULL, 'Uncharacterized protein', 164, NULL, NULL, 190462),
(190463, '3.30.160.60-FF-000061', NULL, 'Transcription factor Sp3', 36, NULL, NULL, 190463),
(190464, '2.60.40.10-FF-002882', NULL, 'CD166 antigen homolog A', 107, NULL, NULL, 190464),
(190465, '3.40.50.11000-FF-000004', NULL, 'Fe-S cluster assembly protein DRE2', 115, NULL, NULL, 190465),
(190466, '1.10.600.10-FF-000115', NULL, 'Uncharacterized protein', 258, NULL, NULL, 190466),
(190467, '3.40.50.300-FF-000062', NULL, 'U5 small nuclear ribonucleoprotein helicase', 203, NULL, NULL, 190467),
(190468, '3.40.50.1000-FF-000708', NULL, NULL, 101, NULL, NULL, 190468),
(190469, '1.10.472.10-FF-000479', NULL, 'Nol-5', 108, NULL, NULL, 190469),
(190470, '3.40.50.1820-FF-001387', NULL, 'Predicted protein', 219, NULL, NULL, 190470),
(190471, '3.50.50.60-FF-001367', NULL, 'Uncharacterized protein', 21, NULL, NULL, 190471),
(190472, '1.20.1270.10-FF-000102', NULL, 'Hsp70 protein-domain-containing protein', 81, NULL, NULL, 190472);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(190473, '1.20.1070.10-FF-000913', NULL, 'Olfactory receptor 1447', 99, NULL, NULL, 190473),
(190474, '3.40.1110.10-FF-000147', NULL, 'Calcium-transporting ATPase', 165, NULL, NULL, 190474),
(190475, '3.30.1370.130-FF-000003', NULL, 'Type IV pilus secretin PilQ', 59, NULL, NULL, 190475),
(190476, '1.25.10.10-FF-001396', NULL, 'AER219Cp', 543, NULL, NULL, 190476),
(190477, '1.20.1070.10-FF-001897', NULL, 'Predicted protein', 337, NULL, NULL, 190477),
(190478, '1.20.1070.10-FF-001458', NULL, 'Predicted protein', 217, NULL, NULL, 190478),
(190479, '1.10.10.10-FF-001244', NULL, 'AGAP002394-PA', 100, NULL, NULL, 190479),
(190480, '1.10.472.10-FF-000007', NULL, 'Transcription factor IIIB 90 kDa subunit', 103, NULL, NULL, 190480),
(190481, '2.60.120.200-FF-000420', NULL, 'cadherin EGF LAG seven-pass G-type receptor 2 isoform X2', 201, NULL, NULL, 190481),
(190482, '2.60.40.10-FF-005900', NULL, NULL, 69, NULL, NULL, 190482),
(190483, '2.20.110.10-FF-000032', NULL, 'Radial spoke protein RSP10, putative', 48, NULL, NULL, 190483),
(190484, '1.20.870.10-FF-000048', NULL, 'Ras guanine nucleotide exchange factor N', 141, NULL, NULL, 190484),
(190485, '1.10.10.10-FF-001188', NULL, 'Putative prophage LambdaBa01, positive control factor Xpf', 79, NULL, NULL, 190485),
(190486, '3.50.50.60-FF-000855', NULL, 'Uncharacterized protein', 30, NULL, NULL, 190486),
(190487, '1.10.238.260-FF-000002', NULL, 'Homocitrate synthase, mitochondrial', 114, NULL, NULL, 190487),
(190488, '1.25.10.10-FF-000884', NULL, 'Serine/threonine-protein kinase TOR', 224, NULL, NULL, 190488),
(190489, '3.80.10.10-FF-004322', NULL, 'Predicted protein', 204, NULL, NULL, 190489),
(190490, '2.60.40.10-FF-005844', NULL, NULL, 105, NULL, NULL, 190490),
(190491, '3.40.50.300-FF-005682', NULL, 'Uncharacterized protein', 186, NULL, NULL, 190491),
(190492, '2.130.10.10-FF-002742', NULL, 'Bilobe protein, conserved', 274, NULL, NULL, 190492),
(190493, '2.70.130.10-FF-000073', NULL, NULL, 132, NULL, NULL, 190493),
(190494, '3.40.1440.10-FF-000020', NULL, NULL, 98, NULL, NULL, 190494),
(190495, '2.130.10.10-FF-005968', NULL, 'Sortilin', 241, NULL, NULL, 190495),
(190496, '3.40.50.410-FF-000100', NULL, 'Inter alpha-trypsin inhibitor, heavy chain-like protein', 181, NULL, NULL, 190496),
(190497, '2.60.40.1400-FF-000032', NULL, NULL, 138, NULL, NULL, 190497),
(190498, '1.10.510.10-FF-004267', NULL, NULL, 186, NULL, NULL, 190498),
(190499, '3.30.40.10-FF-000785', NULL, 'RING-H2 finger protein ATL5H', 77, NULL, NULL, 190499),
(190500, '3.10.400.10-FF-000002', NULL, 'ATP sulfurylase 2', 169, NULL, NULL, 190500),
(190501, '1.25.40.20-FF-000389', NULL, 'Ankyrin repeat-containing protein', 97, NULL, NULL, 190501),
(190502, '1.10.287.3240-FF-000013', NULL, 'V-type ATP synthase subunit D', 206, NULL, NULL, 190502),
(190503, '1.20.58.390-FF-000296', NULL, 'Uncharacterized protein', 96, NULL, NULL, 190503),
(190504, '1.10.3520.10-FF-000029', NULL, 'Uncharacterized protein', 167, NULL, NULL, 190504),
(190505, '1.20.1270.60-FF-000123', NULL, 'Related to SYP1/YCR030C', 250, NULL, NULL, 190505),
(190506, '1.20.1560.10-FF-000288', NULL, 'ABC transporter B family member 19', 331, NULL, NULL, 190506),
(190507, '3.40.190.10-FF-000866', NULL, 'TF protein', 32, NULL, NULL, 190507),
(190508, '2.60.120.920-FF-000107', NULL, 'Tripartite motif-containing protein 5', 130, NULL, NULL, 190508),
(190509, '1.10.287.70-FF-000050', NULL, 'ATP-sensitive inward rectifier potassium channel 11', 131, NULL, NULL, 190509),
(190510, '3.40.50.2300-FF-000323', NULL, 'Hybrid sensor histidine kinase/response regulator', 127, NULL, NULL, 190510),
(190511, '3.40.50.300-FF-007975', NULL, 'Rhogtpase, putative', 160, NULL, NULL, 190511),
(190512, '2.40.30.300-FF-000005', NULL, 'Putative ATP-dependent RNA helicase', 115, NULL, NULL, 190512),
(190513, '3.90.1100.10-FF-000062', NULL, 'DNA-directed RNA polymerase subunit beta', 130, NULL, NULL, 190513),
(190514, '3.60.15.10-FF-000085', NULL, 'Ribonuclease Z', 279, NULL, NULL, 190514),
(190515, '3.40.50.970-FF-000094', NULL, '2-oxoisovalerate dehydrogenase E1 component', 340, NULL, NULL, 190515);
INSERT INTO "PUBLIC"."MODEL" VALUES
(190516, '1.10.8.10-FF-000192', NULL, 'Ubiquitin-like 7b (bone marrow stromal cell-derived)', 67, NULL, NULL, 190516),
(190517, '1.25.40.10-FF-001544', NULL, 'Pentatricopeptide repeat-containing protein isoform A', 143, NULL, NULL, 190517),
(190518, '3.40.50.2300-FF-000795', NULL, NULL, 118, NULL, NULL, 190518),
(190519, '3.90.1640.10-FF-000006', NULL, 'Exopolyphosphatase, putative', 291, NULL, NULL, 190519),
(190520, '3.30.1330.100-FF-000003', NULL, 'Coenzyme F420:L-glutamate ligase', 110, NULL, NULL, 190520),
(190521, '2.40.50.140-FF-001231', NULL, NULL, 49, NULL, NULL, 190521),
(190522, '3.40.50.300-FF-007503', NULL, 'ATPase, RecA superfamily', 221, NULL, NULL, 190522),
(190523, '3.40.190.10-FF-000427', NULL, 'LysR family transcriptional regulator', 109, NULL, NULL, 190523),
(190524, '3.40.50.10190-FF-000199', NULL, 'DNA ligase 4', 121, NULL, NULL, 190524),
(190525, '3.30.200.20-FF-000828', NULL, 'Uncharacterized protein', 93, NULL, NULL, 190525),
(190526, '1.10.510.10-FF-000052', NULL, 'Tyrosine-protein kinase', 263, NULL, NULL, 190526),
(190527, '1.10.167.10-FF-000017', NULL, 'G protein-coupled receptor kinase', 191, NULL, NULL, 190527),
(190528, '3.80.10.10-FF-004266', NULL, 'Tyrosine-protein kinase receptor', 59, NULL, NULL, 190528),
(190529, '1.20.1090.10-FF-000004', NULL, 'Glycerol dehydrogenase', 208, NULL, NULL, 190529),
(190530, '3.30.70.330-FF-002145', NULL, NULL, 174, NULL, NULL, 190530),
(190531, '3.30.160.60-FF-002567', NULL, 'Zinc finger protein 236', 29, NULL, NULL, 190531),
(190532, '1.20.1560.10-FF-000821', NULL, 'Uncharacterized protein', 45, NULL, NULL, 190532),
(190533, '3.30.40.10-FF-000841', NULL, 'Os02g0727700 protein', 83, NULL, NULL, 190533),
(190534, '2.60.260.20-FF-000020', NULL, 'Chaperone protein DnaJ', 72, NULL, NULL, 190534),
(190535, '3.90.226.10-FF-000242', NULL, 'Enoyl-CoA hydratase', 199, NULL, NULL, 190535),
(190536, '3.40.50.620-FF-000837', NULL, 'Leucyl Amino-acyl tRNA Synthetase', 119, NULL, NULL, 190536),
(190537, '3.20.70.20-FF-000048', NULL, 'Uncharacterized protein', 80, NULL, NULL, 190537),
(190538, '2.60.120.200-FF-000364', NULL, 'NeuReXin related', 187, NULL, NULL, 190538),
(190539, '3.65.10.10-FF-000035', NULL, '3-phosphoshikimate 1-carboxyvinyltransferase (AroA)', 206, NULL, NULL, 190539),
(190540, '2.40.320.10-FF-000032', NULL, '5-methylthioadenosine/S-adenosylhomocysteine deaminase', 195, NULL, NULL, 190540),
(190541, '3.90.550.10-FF-000568', NULL, 'Uncharacterized protein', 50, NULL, NULL, 190541),
(190542, '1.10.405.10-FF-000010', NULL, 'Guanosine nucleotide diphosphate dissociation inhibitor', 106, NULL, NULL, 190542),
(190543, '3.30.710.10-FF-000414', NULL, 'Uncharacterized protein', 142, NULL, NULL, 190543),
(190544, '1.25.10.10-FF-002649', NULL, 'Uncharacterized protein', 108, NULL, NULL, 190544),
(190545, '2.60.120.10-FF-000529', NULL, 'MBL fold metallo-hydrolase', 123, NULL, NULL, 190545),
(190546, '1.20.1560.10-FF-000344', NULL, 'Cadmium ion transporter', 324, NULL, NULL, 190546),
(190547, '3.40.50.300-FF-007008', NULL, 'ATP-dependent dethiobiotin synthetase BioD', 209, NULL, NULL, 190547),
(190548, '3.40.710.10-FF-000036', NULL, 'Penicillin-binding protein, 1A family', 382, NULL, NULL, 190548),
(190549, '3.30.420.40-FF-001019', NULL, 'Uncharacterized protein', 51, NULL, NULL, 190549),
(190550, '1.25.10.10-FF-000412', NULL, 'RIC8 guanine nucleotide exchange factor B', 354, NULL, NULL, 190550),
(190551, '1.20.1250.70-FF-000006', NULL, 'Interleukin-21', 123, NULL, NULL, 190551),
(190552, '3.40.350.10-FF-000053', NULL, 'Aminopeptidase', 152, NULL, NULL, 190552),
(190553, '3.40.33.10-FF-000116', NULL, 'Golgi-associated plant pathogenesis-related protein 1', 149, NULL, NULL, 190553),
(190554, '3.90.960.10-FF-000003', NULL, 'YbaK / prolyl-tRNA synthetases associated domain protein', 165, NULL, NULL, 190554),
(190555, '3.30.160.60-FF-000589', NULL, 'B-box zinc finger protein 22', 98, NULL, NULL, 190555),
(190556, '3.40.50.720-FF-002166', NULL, 'Uncharacterized protein', 74, NULL, NULL, 190556),
(190557, '3.40.50.1000-FF-000332', NULL, 'Unplaced genomic scaffold supercont1.8, whole genome shotgun sequence', 156, NULL, NULL, 190557);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(190558, '3.40.30.10-FF-000082', NULL, 'Thioredoxin-like protein 1', 107, NULL, NULL, 190558),
(190559, '1.10.3060.10-FF-000005', NULL, 'Protein translocase subunit SecA', 130, NULL, NULL, 190559),
(190560, '3.40.605.10-FF-000106', NULL, '10-formyltetrahydrofolate dehydrogenase', 126, NULL, NULL, 190560),
(190561, '3.40.50.300-FF-006986', NULL, 'Rab GTPase domain-containing protein', 214, NULL, NULL, 190561),
(190562, '1.25.40.180-FF-000281', NULL, NULL, 159, NULL, NULL, 190562),
(190563, '1.20.58.830-FF-000001', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 162, NULL, NULL, 190563),
(190564, '3.30.450.30-FF-000057', NULL, 'Ragulator complex protein LAMTOR3 homolog', 126, NULL, NULL, 190564),
(190565, '3.30.470.30-FF-000064', NULL, 'DNA ligase 4-like protein', 215, NULL, NULL, 190565),
(190566, '3.90.640.10-FF-000070', NULL, 'DnaK protein', 75, NULL, NULL, 190566),
(190567, '3.40.50.300-FF-003265', NULL, 'Midasin', 313, NULL, NULL, 190567),
(190568, '1.25.40.10-FF-004950', NULL, 'Uncharacterized protein', 172, NULL, NULL, 190568),
(190569, '3.80.10.10-FF-002377', NULL, 'Uncharacterized protein', 145, NULL, NULL, 190569),
(190570, '2.10.25.10-FF-001079', NULL, 'Usherin', 53, NULL, NULL, 190570),
(190571, '2.130.10.10-FF-005176', NULL, 'Uncharacterized protein', 341, NULL, NULL, 190571),
(190572, '3.90.190.10-FF-000585', NULL, 'Predicted protein', 112, NULL, NULL, 190572),
(190573, '1.20.1050.90-FF-000008', NULL, 'DNA replication and repair protein RecF', 185, NULL, NULL, 190573),
(190574, '3.30.1390.30-FF-000012', NULL, NULL, 42, NULL, NULL, 190574),
(190575, '3.30.70.850-FF-000002', NULL, 'Proprotein convertase subtilisin/kexin type 7', 88, NULL, NULL, 190575),
(190576, '3.40.30.10-FF-000935', NULL, 'Uncharacterized protein', 115, NULL, NULL, 190576),
(190577, '3.40.50.1580-FF-000073', NULL, 'Uncharacterized protein', 209, NULL, NULL, 190577),
(190578, '1.25.40.700-FF-000009', NULL, 'Uncharacterized protein', 41, NULL, NULL, 190578),
(190579, '6.10.140.2220-FF-000015', NULL, 'egl nine homolog 1 isoform X1', 54, NULL, NULL, 190579),
(190580, '2.60.120.10-FF-000653', NULL, 'Uncharacterized protein', 136, NULL, NULL, 190580),
(190581, '2.170.120.12-FF-000022', NULL, 'DNA-directed RNA polymerase subunit alpha', 132, NULL, NULL, 190581),
(190582, '3.30.160.60-FF-004012', NULL, NULL, 21, NULL, NULL, 190582),
(190583, '2.60.40.420-FF-000241', NULL, 'Uncharacterized protein', 89, NULL, NULL, 190583),
(190584, '3.40.30.10-FF-000879', NULL, 'Sulfhydryl oxidase', 136, NULL, NULL, 190584),
(190585, '1.10.150.130-FF-000018', NULL, 'Site-specific recombinase, phage integrase family', 106, NULL, NULL, 190585),
(190586, '3.30.70.330-FF-002201', NULL, NULL, 109, NULL, NULL, 190586),
(190587, '2.60.120.40-FF-000049', NULL, 'Novel protein similar to vertebrate gliacolin (C1Q)', 146, NULL, NULL, 190587),
(190588, '3.40.50.720-FF-000305', NULL, 'Kef family K(+) transporter', 138, NULL, NULL, 190588),
(190589, '3.30.710.10-FF-000061', NULL, 'Zinc finger and BTB domain-containing protein 5', 149, NULL, NULL, 190589),
(190590, '1.10.730.10-FF-000063', NULL, 'Mitochondrial methionyl-tRNA synthetase', 184, NULL, NULL, 190590),
(190591, '3.30.420.40-FF-000997', NULL, 'Actin-related protein 8', 78, NULL, NULL, 190591),
(190592, '3.10.310.20-FF-000032', NULL, NULL, 157, NULL, NULL, 190592),
(190593, '2.30.29.30-FF-000648', NULL, 'Serine/threonine protein kinase, putative', 104, NULL, NULL, 190593),
(190594, '2.130.10.10-FF-005232', NULL, 'Uncharacterized protein', 44, NULL, NULL, 190594),
(190595, '2.60.40.10-FF-000196', NULL, 'Exocyst complex component 2', 99, NULL, NULL, 190595),
(190596, '1.25.40.990-FF-000079', NULL, 'Uncharacterized protein', 329, NULL, NULL, 190596),
(190597, '1.10.10.10-FF-000288', NULL, 'GntR family transcriptional regulator', 74, NULL, NULL, 190597),
(190598, '1.25.40.10-FF-004894', NULL, 'Os09g0555400 protein', 94, NULL, NULL, 190598),
(190599, '1.25.40.10-FF-004455', NULL, 'Uncharacterized protein', 113, NULL, NULL, 190599),
(190600, '3.90.226.10-FF-000298', NULL, 'ATP-dependent Clp protease proteolytic subunit', 139, NULL, NULL, 190600);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(190601, '3.40.50.300-FF-006671', NULL, 'Uncharacterized protein', 85, NULL, NULL, 190601),
(190602, '3.40.50.620-FF-000573', NULL, 'Predicted protein', 151, NULL, NULL, 190602),
(190603, '1.20.1250.20-FF-002285', NULL, 'Uncharacterized protein', 81, NULL, NULL, 190603),
(190604, '2.60.40.10-FF-003427', NULL, NULL, 107, NULL, NULL, 190604),
(190605, '1.20.120.1320-FF-000003', NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase', 95, NULL, NULL, 190605),
(190606, '3.40.50.1110-FF-000073', NULL, 'Si:dkey-177p2.18', 236, NULL, NULL, 190606),
(190607, '3.40.50.300-FF-003760', NULL, 'ATP-dependent DEAD/H DNA helicase recQ family-like protein', 186, NULL, NULL, 190607),
(190608, '1.20.1310.20-FF-000042', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 176, NULL, NULL, 190608),
(190609, '1.20.5.640-FF-000001', NULL, '50S ribosomal protein L32', 22, NULL, NULL, 190609),
(190610, '1.10.238.10-FF-000891', NULL, 'Phospholipase C, epsilon 1', 161, NULL, NULL, 190610),
(190611, '3.30.420.40-FF-000682', NULL, 'Glucose kinase', 139, NULL, NULL, 190611),
(190612, '4.10.1000.10-FF-000038', NULL, 'putative ATP-dependent RNA helicase DHX57', 90, NULL, NULL, 190612),
(190613, '2.10.25.140-FF-000004', NULL, 'Delta-like protein', 39, NULL, NULL, 190613),
(190614, '3.80.10.10-FF-003366', NULL, 'Uncharacterized protein', 111, NULL, NULL, 190614),
(190615, '1.20.120.350-FF-000121', NULL, 'Potassium channel', 145, NULL, NULL, 190615),
(190616, '1.20.1280.50-FF-000087', NULL, 'UFO1p F-box receptor protein', 82, NULL, NULL, 190616),
(190617, '3.90.199.10-FF-000009', NULL, 'DNA topoisomerase 2', 183, NULL, NULL, 190617),
(190618, '1.25.40.20-FF-000445', NULL, 'E3 ubiquitin-protein ligase mind-bomb', 88, NULL, NULL, 190618),
(190619, '3.40.50.150-FF-000797', NULL, 'Spermine synthase', 233, NULL, NULL, 190619),
(190620, '3.80.10.10-FF-001040', NULL, 'Uncharacterized protein, isoform B', 187, NULL, NULL, 190620),
(190621, '2.130.10.10-FF-001337', NULL, 'Sec 13 protein, putative', 261, NULL, NULL, 190621),
(190622, '2.60.40.10-FF-002938', NULL, 'Non-specific protein-tyrosine kinase', 106, NULL, NULL, 190622),
(190623, '3.30.310.10-FF-000013', NULL, 'AP complex subunit beta', 138, NULL, NULL, 190623),
(190624, '2.30.30.490-FF-000036', NULL, 'Origin recognition complex subunit 1', 229, NULL, NULL, 190624),
(190625, '2.30.30.790-FF-000013', NULL, '50S ribosomal protein L19', 116, NULL, NULL, 190625),
(190626, '2.60.120.290-FF-000227', NULL, 'GPRIN family member 3', 109, NULL, NULL, 190626),
(190627, '3.30.160.60-FF-003079', NULL, 'Uncharacterized protein', 25, NULL, NULL, 190627),
(190628, '3.40.50.300-FF-002776', NULL, 'ABC transporter family protein', 168, NULL, NULL, 190628),
(190629, '1.20.140.150-FF-000014', NULL, 'p53 apoptosis effector related to PMP-22', 167, NULL, NULL, 190629),
(190630, '3.30.710.10-FF-000437', NULL, 'Uncharacterized protein', 42, NULL, NULL, 190630),
(190631, '1.10.8.100-FF-000015', NULL, 'Ribosomal RNA small subunit methyltransferase A', 60, NULL, NULL, 190631),
(190632, '3.40.390.10-FF-000055', NULL, 'Related to mitochondrial intermediate peptidase', 79, NULL, NULL, 190632),
(190633, '1.20.1250.20-FF-000363', NULL, 'Solute carrier organic anion transporter family member', 233, NULL, NULL, 190633),
(190634, '1.10.1510.30-FF-000006', NULL, 'Pseudouridine synthase family protein', 90, NULL, NULL, 190634),
(190635, '3.30.519.10-FF-000014', NULL, 'Rab GDP dissociation inhibitor', 62, NULL, NULL, 190635),
(190636, '2.60.40.10-FF-003922', NULL, NULL, 107, NULL, NULL, 190636),
(190637, '2.40.20.10-FF-000004', NULL, 'Hepatocyte growth factor', 85, NULL, NULL, 190637),
(190638, '3.40.50.300-FF-005210', NULL, 'Polynucleotide 5''-hydroxyl-kinase GRC3', 209, NULL, NULL, 190638),
(190639, '3.30.40.10-FF-001830', NULL, 'Predicted protein', 58, NULL, NULL, 190639),
(190640, '2.10.25.10-FF-000623', NULL, 'Matrilin 2', 36, NULL, NULL, 190640),
(190641, '3.10.660.10-FF-000015', NULL, 'Predicted protein', 64, NULL, NULL, 190641),
(190642, '1.25.10.10-FF-000940', NULL, 'Interferon-related developmental regulator family protein / IFRD protein family', 241, NULL, NULL, 190642);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(190643, '1.10.8.1290-FF-000005', NULL, NULL, 59, NULL, NULL, 190643),
(190644, '3.40.1110.10-FF-000203', NULL, 'Plasma membrane calcium-transporting ATPase 1, putative', 190, NULL, NULL, 190644),
(190645, '3.30.160.60-FF-005024', NULL, NULL, 29, NULL, NULL, 190645),
(190646, '1.25.40.990-FF-000023', NULL, 'Leukocyte receptor cluster (Lrc) member, putative', 238, NULL, NULL, 190646),
(190647, '3.30.60.60-FF-000014', NULL, 'Histone acetyltransferase', 57, NULL, NULL, 190647),
(190648, '1.20.1070.10-FF-000593', NULL, 'Uncharacterized protein', 309, NULL, NULL, 190648),
(190649, '3.40.50.300-FF-007447', NULL, 'Uncharacterized protein', 323, NULL, NULL, 190649),
(190650, '3.90.70.80-FF-000035', NULL, 'RNA-directed RNA polymerase L', 162, NULL, NULL, 190650),
(190651, '1.20.1110.10-FF-000029', NULL, 'Plasma membrane ATPase', 324, NULL, NULL, 190651),
(190652, '3.90.1720.10-FF-000002', NULL, 'HRAS like suppressor 2', 134, NULL, NULL, 190652),
(190653, '3.50.30.80-FF-000006', NULL, NULL, 46, NULL, NULL, 190653),
(190654, '3.30.70.330-FF-001217', NULL, 'Rumpelstiltskin, isoform B', 145, NULL, NULL, 190654),
(190655, '3.20.20.100-FF-000096', NULL, 'Aldo-keto reductase family 4 member C9', 242, NULL, NULL, 190655),
(190656, '1.10.510.10-FF-001805', NULL, 'CAMK family protein kinase', 306, NULL, NULL, 190656),
(190657, '3.90.1860.10-FF-000017', NULL, 'Uncharacterized protein', 313, NULL, NULL, 190657),
(190658, '3.30.70.330-FF-000256', NULL, 'oligouridylate-binding protein 1-like isoform X2', 96, NULL, NULL, 190658),
(190659, '2.70.98.20-FF-000005', NULL, 'Amine oxidase', 454, NULL, NULL, 190659),
(190660, '1.25.10.10-FF-000468', NULL, 'mRNA-binding protein PUF2', 340, NULL, NULL, 190660),
(190661, '1.20.1540.10-FF-000022', NULL, 'Rhomboid family intramembrane serine protease', 189, NULL, NULL, 190661),
(190662, '2.60.40.1180-FF-000101', NULL, '1,3-beta-galactosyl-N-acetylhexosamine phosphorylase', 57, NULL, NULL, 190662),
(190663, '1.10.10.200-FF-000010', NULL, 'Gag-Pol polyprotein', 50, NULL, NULL, 190663),
(190664, '2.60.40.10-FF-000701', NULL, 'Tenascin-X', 92, NULL, NULL, 190664),
(190665, '2.60.260.20-FF-000076', NULL, 'Chaperone protein dnaJ GFA2 mitochondrial', 61, NULL, NULL, 190665),
(190666, '3.30.70.330-FF-002206', NULL, NULL, 105, NULL, NULL, 190666),
(190667, '3.40.47.10-FF-000243', NULL, NULL, 13, NULL, NULL, 190667),
(190668, '3.40.50.300-FF-001051', NULL, 'ATP-dependent DNA helicase RecQ', 203, NULL, NULL, 190668),
(190669, '3.40.50.150-FF-001814', NULL, NULL, 102, NULL, NULL, 190669),
(190670, '3.60.20.10-FF-000012', NULL, 'Proteasome subunit alpha type', 233, NULL, NULL, 190670),
(190671, '3.90.70.10-FF-000744', NULL, 'Uncharacterized protein', 139, NULL, NULL, 190671),
(190672, '3.40.250.10-FF-000017', NULL, 'ubiquitin carboxyl-terminal hydrolase 8', 139, NULL, NULL, 190672),
(190673, '2.30.110.10-FF-000070', NULL, 'Styrene monooxygenase component 2', 157, NULL, NULL, 190673),
(190674, '1.25.40.430-FF-000024', NULL, 'Predicted protein', 152, NULL, NULL, 190674),
(190675, '2.60.40.820-FF-000001', NULL, 'T-box transcription factor TBX18', 196, NULL, NULL, 190675),
(190676, '3.30.200.20-FF-001941', NULL, 'Protein kinase, putative', 109, NULL, NULL, 190676),
(190677, '1.20.5.110-FF-000022', NULL, 'Syntaxin 19', 96, NULL, NULL, 190677),
(190678, '3.30.160.60-FF-005496', NULL, NULL, 35, NULL, NULL, 190678),
(190679, '2.10.70.10-FF-000082', NULL, 'Complement component C6', 61, NULL, NULL, 190679),
(190680, '3.60.20.30-FF-000018', NULL, NULL, 135, NULL, NULL, 190680),
(190681, '3.40.50.1820-FF-000954', NULL, 'Alpha/beta hydrolase family, putative', 294, NULL, NULL, 190681),
(190682, '3.90.1420.10-FF-000018', NULL, 'Actin-histidine N-methyltransferase', 165, NULL, NULL, 190682),
(190683, '3.50.50.60-FF-001491', NULL, 'L-amino-acid oxidase', 42, NULL, NULL, 190683),
(190684, '1.20.1250.20-FF-001796', NULL, 'Uncharacterized protein', 176, NULL, NULL, 190684),
(190685, '1.10.565.10-FF-000083', NULL, 'Predicted protein', 212, NULL, NULL, 190685),
(190686, '3.20.20.60-FF-000006', NULL, 'Isocitrate lyase', 403, NULL, NULL, 190686);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(190687, '3.40.47.10-FF-000058', NULL, 'Acetyl-CoA C-acetyltransferase', 437, NULL, NULL, 190687),
(190688, '1.20.1070.10-FF-000969', NULL, 'G-protein coupled receptor aex-2', 349, NULL, NULL, 190688),
(190689, '1.20.1530.20-FF-000053', NULL, 'Uncharacterized protein', 297, NULL, NULL, 190689),
(190690, '1.10.150.670-FF-000011', NULL, 'Histone-lysine N-methyltransferase', 69, NULL, NULL, 190690),
(190691, '1.10.10.10-FF-000316', NULL, 'Transcriptional regulator, ArsR', 100, NULL, NULL, 190691),
(190692, '3.90.79.10-FF-000287', NULL, 'Nudix hydrolase 7', 50, NULL, NULL, 190692),
(190693, '1.10.472.10-FF-000423', NULL, 'Uncharacterized protein', 72, NULL, NULL, 190693),
(190694, '3.30.70.270-FF-000249', NULL, NULL, 76, NULL, NULL, 190694),
(190695, '1.20.120.230-FF-000028', NULL, 'Alpha-CaTuliN (Catenin/vinculin related)', 119, NULL, NULL, 190695),
(190696, '3.40.50.850-FF-000024', NULL, 'Isochorismatase domain-containing protein 2, putative', 193, NULL, NULL, 190696),
(190697, '3.30.930.10-FF-000072', NULL, 'Lipoate--protein ligase', 242, NULL, NULL, 190697),
(190698, '3.40.50.300-FF-000831', NULL, 'ATP-binding cassette sub-family G member 8', 227, NULL, NULL, 190698),
(190699, '1.10.10.60-FF-000814', NULL, NULL, 76, NULL, NULL, 190699),
(190700, '3.40.50.300-FF-004569', NULL, 'DNA helicase HCS1', 320, NULL, NULL, 190700),
(190701, '2.60.40.10-FF-001213', NULL, 'titin isoform X1', 90, NULL, NULL, 190701),
(190702, '3.40.50.300-FF-004754', NULL, 'Ras-related protein RabZ', 192, NULL, NULL, 190702),
(190703, '3.30.160.60-FF-001281', NULL, 'C2H2 transcription factor, putative', 22, NULL, NULL, 190703),
(190704, '1.20.1050.10-FF-000058', NULL, 'metaxin-1', 96, NULL, NULL, 190704),
(190705, '3.90.45.10-FF-000023', NULL, 'Peptide deformylase', 181, NULL, NULL, 190705),
(190706, '3.40.850.10-FF-000107', NULL, 'Kinesin family member 20/23', 374, NULL, NULL, 190706),
(190707, '3.90.1800.10-FF-000008', NULL, 'DNA-directed RNA polymerase subunit beta', 159, NULL, NULL, 190707),
(190708, '2.130.10.10-FF-000825', NULL, 'Regulatory-associated protein of TOR 2', 188, NULL, NULL, 190708),
(190709, '1.10.260.40-FF-000086', NULL, 'Transcription factor protein', 64, NULL, NULL, 190709),
(190710, '1.10.510.10-FF-000788', NULL, 'Serine/threonine-protein kinase Nek3', 232, NULL, NULL, 190710),
(190711, '3.30.40.10-FF-002263', NULL, 'Uncharacterized protein', 55, NULL, NULL, 190711),
(190712, '3.40.50.150-FF-000853', NULL, 'Methyltransferase', 271, NULL, NULL, 190712),
(190713, '3.80.10.10-FF-000584', NULL, 'NACHT, LRR and PYD domains-containing protein 5', 458, NULL, NULL, 190713),
(190714, '2.20.70.30-FF-000003', NULL, 'Nascent polypeptide-associated complex subunit beta', 58, NULL, NULL, 190714),
(190715, '1.25.40.20-FF-001373', NULL, 'ArfGAP with SH3 domain, ankyrin repeat and PH domain 1b', 86, NULL, NULL, 190715),
(190716, '3.90.640.90-FF-000020', NULL, 'Uncharacterized protein', 120, NULL, NULL, 190716),
(190717, '3.30.160.60-FF-003023', NULL, 'NSDC', 43, NULL, NULL, 190717),
(190718, '3.30.200.20-FF-000452', NULL, 'Receptor-like protein kinase THESEUS 1', 101, NULL, NULL, 190718),
(190719, '1.10.8.60-FF-000274', NULL, 'Origin recognition complex subunit 1', 91, NULL, NULL, 190719),
(190720, '1.10.3380.10-FF-000057', NULL, 'Uncharacterized protein', 132, NULL, NULL, 190720),
(190721, '3.30.930.10-FF-000420', NULL, 'Uncharacterized protein', 251, NULL, NULL, 190721),
(190722, '2.60.40.60-FF-000750', NULL, 'Predicted protein', 107, NULL, NULL, 190722),
(190723, '3.40.50.150-FF-001629', NULL, NULL, 239, NULL, NULL, 190723),
(190724, '3.40.1000.30-FF-000004', NULL, 'Putative proteasome inhibitor', 161, NULL, NULL, 190724),
(190725, '1.10.3080.10-FF-000040', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', 117, NULL, NULL, 190725),
(190726, '1.50.40.10-FF-000024', NULL, 'MIR1p Mitochondrial phosphate carrier', 284, NULL, NULL, 190726),
(190727, '3.30.160.60-FF-001573', NULL, 'Zinc finger protein 407', 29, NULL, NULL, 190727),
(190728, '1.25.10.10-FF-001716', NULL, 'AaceriADL093Wp', 223, NULL, NULL, 190728);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(190729, '1.20.1280.20-FF-000016', NULL, 'Uncharacterized protein', 78, NULL, NULL, 190729),
(190730, '3.30.160.60-FF-001078', NULL, 'Zinc finger protein 329', 29, NULL, NULL, 190730),
(190731, '1.25.40.70-FF-000027', NULL, 'Phosphatidylinositol 4-kinase putative', 141, NULL, NULL, 190731),
(190732, '1.10.10.10-FF-001249', NULL, 'IclR family transcriptional regulator', 72, NULL, NULL, 190732),
(190733, '1.20.930.40-FF-000034', NULL, 'Uncharacterized protein', 99, NULL, NULL, 190733),
(190734, '2.40.10.10-FF-000678', NULL, NULL, 83, NULL, NULL, 190734),
(190735, '2.70.150.10-FF-000012', NULL, 'Phospholipid-transporting ATPase', 137, NULL, NULL, 190735),
(190736, '3.30.300.20-FF-000072', NULL, 'Osmotically inducible family protein', 153, NULL, NULL, 190736),
(190737, '1.10.150.20-FF-000246', NULL, 'Uncharacterized protein', 51, NULL, NULL, 190737),
(190738, '3.90.1150.10-FF-000250', NULL, 'Aspartate aminotransferase, mitochondrial', 110, NULL, NULL, 190738),
(190739, '3.10.20.310-FF-000003', NULL, 'Outer membrane protein assembly factor BamA', 73, NULL, NULL, 190739),
(190740, '1.25.40.20-FF-001878', NULL, 'Kinase, NEK', 123, NULL, NULL, 190740),
(190741, '3.80.10.10-FF-004294', NULL, 'Uncharacterized protein', 234, NULL, NULL, 190741),
(190742, '2.60.40.640-FF-000071', NULL, 'Vacuolar protein sorting-associated protein 26 containing protein', 144, NULL, NULL, 190742),
(190743, '2.40.50.140-FF-001107', NULL, NULL, 50, NULL, NULL, 190743),
(190744, '1.10.150.900-FF-000002', NULL, 'M20/M25/M40 family peptidase', 84, NULL, NULL, 190744),
(190745, '2.60.40.10-FF-000988', NULL, 'obscurin isoform X3', 96, NULL, NULL, 190745),
(190746, '2.10.25.10-FF-001551', NULL, 'Neurexin I isoform B', 79, NULL, NULL, 190746),
(190747, '1.10.150.110-FF-000012', NULL, 'DNA polymerase', 95, NULL, NULL, 190747),
(190748, '1.20.58.1070-FF-000015', NULL, 'Gem-associated protein 2', 71, NULL, NULL, 190748),
(190749, '3.80.10.10-FF-001888', NULL, 'TOLl (Drosophila) family', 210, NULL, NULL, 190749),
(190750, '3.40.50.720-FF-000249', NULL, 'Fatty acid synthase', 334, NULL, NULL, 190750),
(190751, '1.10.1300.10-FF-000046', NULL, 'cGMP-dependent 3'',5''-cyclic phosphodiesterase', 219, NULL, NULL, 190751),
(190752, '3.40.50.10240-FF-000034', NULL, 'Thiamin pyrophosphokinase, putative', 144, NULL, NULL, 190752),
(190753, '1.10.630.10-FF-000443', NULL, 'Uncharacterized protein', 111, NULL, NULL, 190753),
(190754, '2.40.70.10-FF-000187', NULL, 'Aspartic-type endopeptidase, putative', 174, NULL, NULL, 190754),
(190755, '3.10.100.10-FF-000013', NULL, 'Attractin like 1', 143, NULL, NULL, 190755),
(190756, '3.40.50.1760-FF-000003', NULL, 'Glutathione synthetase', 101, NULL, NULL, 190756),
(190757, '3.30.1360.120-FF-000049', NULL, 'Putative transferase CAF17, mitochondrial', 272, NULL, NULL, 190757),
(190758, '1.10.510.10-FF-001013', NULL, 'CMGC/CDK protein kinase', 107, NULL, NULL, 190758),
(190759, '3.30.200.20-FF-001317', NULL, 'Protein kinase', 113, NULL, NULL, 190759),
(190760, '3.30.160.60-FF-001606', NULL, 'zinc finger protein 502 isoform X2', 27, NULL, NULL, 190760),
(190761, '2.60.40.10-FF-004355', NULL, NULL, 110, NULL, NULL, 190761),
(190762, '1.10.150.50-FF-000058', NULL, 'ephrin type-A receptor 8', 73, NULL, NULL, 190762),
(190763, '3.30.160.60-FF-004484', NULL, NULL, 36, NULL, NULL, 190763),
(190764, '2.10.25.10-FF-000567', NULL, 'Vitamin K-dependent protein C', 45, NULL, NULL, 190764),
(190765, '3.30.43.10-FF-000027', NULL, 'L-gulonolactone oxidase, putative', 72, NULL, NULL, 190765),
(190766, '1.25.40.10-FF-004039', NULL, 'Uncharacterized protein', 179, NULL, NULL, 190766),
(190767, '2.60.40.10-FF-004883', NULL, NULL, 103, NULL, NULL, 190767),
(190768, '2.40.50.100-FF-000073', NULL, 'Putative Exosome complex component RRP40', 63, NULL, NULL, 190768),
(190769, '1.10.287.3240-FF-000018', NULL, 'Vacuolar ATP synthase subunit D', 223, NULL, NULL, 190769),
(190770, '3.40.225.10-FF-000037', NULL, NULL, 204, NULL, NULL, 190770),
(190771, '3.40.50.300-FF-000859', NULL, 'ATP-dependent RNA helicase', 189, NULL, NULL, 190771);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(190772, '3.90.1720.10-FF-000007', NULL, 'Predicted lipoprotein', 184, NULL, NULL, 190772),
(190773, '3.40.50.300-FF-008464', NULL, 'DNA replication and repair protein RecF', 151, NULL, NULL, 190773),
(190774, '2.10.70.10-FF-000166', NULL, 'Uncharacterized protein', 63, NULL, NULL, 190774),
(190775, '1.10.275.20-FF-000013', NULL, NULL, 84, NULL, NULL, 190775),
(190776, '2.10.25.10-FF-001495', NULL, 'Protein CBR-CRB-1', 35, NULL, NULL, 190776),
(190777, '3.30.50.10-FF-000111', NULL, 'Protein CBG19536', 102, NULL, NULL, 190777),
(190778, '3.30.40.10-FF-001774', NULL, 'RING-type E3 ubiquitin transferase', 54, NULL, NULL, 190778),
(190779, '3.40.1340.10-FF-000012', NULL, 'DNA binding / DNA-directed RNA polymerase', 49, NULL, NULL, 190779),
(190780, '3.40.50.620-FF-000865', NULL, 'Predicted protein', 147, NULL, NULL, 190780),
(190781, '2.60.120.20-FF-000010', NULL, 'Secreted protein ORF2', 191, NULL, NULL, 190781),
(190782, '2.10.25.10-FF-000915', NULL, 'Fibrillin-1', 43, NULL, NULL, 190782),
(190783, '2.30.30.30-FF-000073', NULL, '30S ribosomal protein S4e', 57, NULL, NULL, 190783),
(190784, '1.50.40.10-FF-000171', NULL, 'Mitochondrial carrier protein, putative', 170, NULL, NULL, 190784),
(190785, '3.30.160.60-FF-001134', NULL, 'Zinc finger protein 70', 34, NULL, NULL, 190785),
(190786, '3.30.1370.240-FF-000008', NULL, 'Phenylalanine--tRNA ligase, alpha subunit', 73, NULL, NULL, 190786),
(190787, '1.10.555.10-FF-000138', NULL, 'Uncharacterized protein', 253, NULL, NULL, 190787),
(190788, '3.40.50.10090-FF-000023', NULL, 'Uroporphyrinogen-III synthase', 108, NULL, NULL, 190788),
(190789, '1.10.510.10-FF-001541', NULL, 'Protein kinase C', 207, NULL, NULL, 190789),
(190790, '3.30.1610.10-FF-000007', NULL, 'Nucleoporin autopeptidase, putative', 133, NULL, NULL, 190790),
(190791, '1.10.533.10-FF-000088', NULL, 'P53-induced death domain protein 1', 97, NULL, NULL, 190791),
(190792, '3.40.50.300-FF-001843', NULL, 'Putative dynein beta chain', 176, NULL, NULL, 190792),
(190793, '3.30.60.190-FF-000015', NULL, 'Protein CBR-ZHIT-2', 59, NULL, NULL, 190793),
(190794, '1.20.1050.10-FF-000114', NULL, 'Glutathione S-transferase, putative', 125, NULL, NULL, 190794),
(190795, '3.40.50.10260-FF-000012', NULL, 'Multifunctional fusion protein', 218, NULL, NULL, 190795),
(190796, '3.40.50.1000-FF-000388', NULL, 'Uncharacterized protein', 109, NULL, NULL, 190796),
(190797, '1.25.40.10-FF-002977', NULL, 'ERAD-associated E3 ubiquitin-protein ligase component HRD3A', 155, NULL, NULL, 190797),
(190798, '1.10.1060.10-FF-000038', NULL, NULL, 116, NULL, NULL, 190798),
(190799, '3.40.50.150-FF-000325', NULL, 'Ribosomal RNA methyltransferase Nop2', 289, NULL, NULL, 190799),
(190800, '3.50.50.60-FF-000378', NULL, 'Phytoene desaturase', 93, NULL, NULL, 190800),
(190801, '1.20.120.150-FF-000010', NULL, 'Serine/threonine-protein kinase TOR', 57, NULL, NULL, 190801),
(190802, '3.40.50.11210-FF-000005', NULL, 'Ral GTPase-activating protein, beta subunit (non-catalytic)', 123, NULL, NULL, 190802),
(190803, '2.160.10.10-FF-000054', NULL, 'Translation initiation factor eIF-2B subunit epsilon', 146, NULL, NULL, 190803),
(190804, '3.40.50.720-FF-001710', NULL, 'Dehydrogenase', 140, NULL, NULL, 190804),
(190805, '2.40.110.10-FF-000078', NULL, 'Acyl-CoA dehydrogenase-like protein', 123, NULL, NULL, 190805),
(190806, '3.30.160.60-FF-000645', NULL, 'Zinc finger and BTB domain containing 40', 29, NULL, NULL, 190806),
(190807, '3.40.1640.10-FF-000001', NULL, 'D-glutamate cyclase, mitochondrial', 119, NULL, NULL, 190807),
(190808, '3.40.50.1240-FF-000168', NULL, NULL, 315, NULL, NULL, 190808),
(190809, '3.40.50.11860-FF-000003', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase', 99, NULL, NULL, 190809),
(190810, '3.20.20.190-FF-000083', NULL, 'Phosphoinositide phospholipase C', 216, NULL, NULL, 190810),
(190811, '1.10.8.60-FF-000330', NULL, 'Protein CBR-CDC-48.3', 64, NULL, NULL, 190811),
(190812, '3.30.1680.50-FF-000001', NULL, 'Carboxypeptidase inhibitor', 38, NULL, NULL, 190812),
(190813, '3.90.550.10-FF-000624', NULL, 'Predicted protein', 201, NULL, NULL, 190813);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(190814, '3.30.200.20-FF-001380', NULL, 'Protein kinase superfamily protein', 47, NULL, NULL, 190814),
(190815, '1.20.1270.10-FF-000097', NULL, 'Uncharacterized protein', 113, NULL, NULL, 190815),
(190816, '3.20.20.80-FF-000220', NULL, 'Chitotriosidase-1', 273, NULL, NULL, 190816),
(190817, '1.20.58.1610-FF-000020', NULL, NULL, 123, NULL, NULL, 190817),
(190818, '2.130.10.10-FF-004479', NULL, 'Regulatory-associated protein of mTOR-like Protein', 174, NULL, NULL, 190818),
(190819, '2.60.40.60-FF-000694', NULL, 'Hedgehog protein', 104, NULL, NULL, 190819),
(190820, '3.40.50.410-FF-000095', NULL, 'Dihydropyridine-sensitive l-type calcium channel', 186, NULL, NULL, 190820),
(190821, '3.30.200.20-FF-000980', NULL, 'Protein kinase domain containing protein', 98, NULL, NULL, 190821),
(190822, '2.130.10.30-FF-000039', NULL, 'probable E3 ubiquitin-protein ligase HERC4 isoform X3', 245, NULL, NULL, 190822),
(190823, '2.130.10.10-FF-001753', NULL, 'GATOR complex protein Wdr59', 295, NULL, NULL, 190823),
(190824, '2.130.10.10-FF-000033', NULL, 'Semaphorin 4B', 474, NULL, NULL, 190824),
(190825, '3.90.1150.10-FF-000334', NULL, 'Kynureninase', 126, NULL, NULL, 190825),
(190826, '1.25.40.10-FF-000296', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 161, NULL, NULL, 190826),
(190827, '3.90.190.10-FF-000580', NULL, 'Uncharacterized protein', 156, NULL, NULL, 190827),
(190828, '3.30.160.60-FF-005316', NULL, NULL, 31, NULL, NULL, 190828),
(190829, '3.50.50.60-FF-000911', NULL, 'Carotene 7,8-desaturase', 453, NULL, NULL, 190829),
(190830, '2.30.29.30-FF-001104', NULL, 'Uncharacterized protein', 152, NULL, NULL, 190830),
(190831, '1.20.1250.20-FF-002341', NULL, 'Uncharacterized protein', 169, NULL, NULL, 190831),
(190832, '1.10.287.370-FF-000090', NULL, 'Uncharacterized protein', 100, NULL, NULL, 190832),
(190833, '2.30.29.30-FF-000704', NULL, 'Transcription initiation factor TFIIH subunit 1', 109, NULL, NULL, 190833),
(190834, '3.30.70.330-FF-003134', NULL, NULL, 108, NULL, NULL, 190834),
(190835, '3.30.590.10-FF-000033', NULL, 'Uncharacterized protein', 133, NULL, NULL, 190835),
(190836, '3.50.50.60-FF-001311', NULL, 'Glycerol-3-phosphate dehydrogenase, truncation', 75, NULL, NULL, 190836),
(190837, '3.40.50.720-FF-000777', NULL, 'glyoxylate reductase/hydroxypyruvate reductase', 116, NULL, NULL, 190837),
(190838, '3.40.50.1780-FF-000009', NULL, 'Cytosolic Fe-S cluster assembly factor nar1', 31, NULL, NULL, 190838),
(190839, '3.30.160.60-FF-005501', NULL, NULL, 81, NULL, NULL, 190839),
(190840, '1.10.287.70-FF-000055', NULL, 'Polycystic kidney disease 2-like 1', 141, NULL, NULL, 190840),
(190841, '2.60.120.920-FF-000102', NULL, 'Si:ch211-201o1.1', 184, NULL, NULL, 190841),
(190842, '2.60.40.10-FF-004916', NULL, NULL, 87, NULL, NULL, 190842),
(190843, '3.80.10.10-FF-001449', NULL, 'Serine/threonine kinase 11 interacting protein', 92, NULL, NULL, 190843),
(190844, '3.40.50.2000-FF-000823', NULL, 'Uncharacterized protein', 281, NULL, NULL, 190844),
(190845, '3.40.50.300-FF-005502', NULL, 'ATP-dependent RNA helicase', 176, NULL, NULL, 190845),
(190846, '3.40.605.10-FF-000078', NULL, 'L-glutamate gamma-semialdehyde dehydrogenase', 316, NULL, NULL, 190846),
(190847, '4.10.970.10-FF-000018', NULL, 'AGAP002690-PA', 71, NULL, NULL, 190847),
(190848, '1.10.10.60-FF-000022', NULL, 'ISWI chromatin-remodeling complex ATPase CHR11 isoform A', 55, NULL, NULL, 190848),
(190849, '3.40.50.1820-FF-000898', NULL, 'Clan SC, family S33, methylesterase-like serine peptidase', 218, NULL, NULL, 190849),
(190850, '3.30.450.20-FF-000291', NULL, 'Histidine kinase', 94, NULL, NULL, 190850),
(190851, '3.40.50.2300-FF-000851', NULL, 'Uncharacterized protein', 153, NULL, NULL, 190851),
(190852, '1.20.1250.20-FF-001852', NULL, 'Monocarboxylate transporter, putative', 130, NULL, NULL, 190852),
(190853, '1.20.1270.60-FF-000179', NULL, 'sorting nexin-6', 63, NULL, NULL, 190853),
(190854, '3.40.50.2300-FF-001251', NULL, NULL, 108, NULL, NULL, 190854),
(190855, '3.40.190.10-FF-000490', NULL, 'Transcriptional regulator, LysR family', 92, NULL, NULL, 190855);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(190856, '3.50.50.60-FF-001075', NULL, 'Flavin-containing monooxygenase', 99, NULL, NULL, 190856),
(190857, '1.25.40.10-FF-002241', NULL, 'Uncharacterized protein', 183, NULL, NULL, 190857),
(190858, '3.60.15.10-FF-000270', NULL, 'RNase Z-like protein', 272, NULL, NULL, 190858),
(190859, '1.10.10.10-FF-001536', NULL, 'Cullin, putative', 88, NULL, NULL, 190859),
(190860, '3.40.605.10-FF-000022', NULL, 'Aldehyde dehydrogenase A', 256, NULL, NULL, 190860),
(190861, '2.130.10.10-FF-000792', NULL, 'Dynein intermediate chain, putative', 201, NULL, NULL, 190861),
(190862, '1.25.40.10-FF-002185', NULL, 'Os03g0849700 protein', 166, NULL, NULL, 190862),
(190863, '2.60.40.3530-FF-000002', NULL, 'Early E3 18.5 kDa glycoprotein', 100, NULL, NULL, 190863),
(190864, '3.30.70.1630-FF-000001', NULL, 'tRNA-modifying protein YgfZ', 84, NULL, NULL, 190864),
(190865, '2.170.200.10-FF-000004', NULL, 'Regulatory protein E2', 108, NULL, NULL, 190865),
(190866, '2.30.30.770-FF-000002', NULL, '60S ribosomal protein L27', 133, NULL, NULL, 190866),
(190867, '3.40.50.980-FF-000012', NULL, 'Acyl-CoA synthetase', 133, NULL, NULL, 190867),
(190868, '2.60.40.10-FF-001921', NULL, 'KETtiN (Drosophila actin-binding) homolog', 102, NULL, NULL, 190868),
(190869, '3.30.50.10-FF-000139', NULL, 'Estrogen receptor beta a variant b', 82, NULL, NULL, 190869),
(190870, '2.130.10.10-FF-002450', NULL, 'Inositol requiring 1-1', 174, NULL, NULL, 190870),
(190871, '2.30.29.30-FF-000143', NULL, 'amyloid beta A4 precursor protein-binding family B member 3 isoform X2', 143, NULL, NULL, 190871),
(190872, '1.20.58.240-FF-000010', NULL, 'GH20986p', 78, NULL, NULL, 190872),
(190873, '1.10.10.350-FF-000004', NULL, 'Glutamate--tRNA ligase chloroplastic/mitochondrial', 94, NULL, NULL, 190873),
(190874, '3.70.10.10-FF-000101', NULL, 'Uncharacterized protein', 270, NULL, NULL, 190874),
(190875, '3.40.50.1170-FF-000012', NULL, 'Predicted protein', 130, NULL, NULL, 190875),
(190876, '1.20.1440.40-FF-000001', NULL, 'DUF446 domain protein', 105, NULL, NULL, 190876),
(190877, '1.20.1410.10-FF-000013', NULL, 'Talin 1', 49, NULL, NULL, 190877),
(190878, '1.20.1250.20-FF-000868', NULL, 'Uncharacterized symporter sll1374', 204, NULL, NULL, 190878),
(190879, '3.40.50.1820-FF-001679', NULL, 'Uncharacterized protein', 237, NULL, NULL, 190879),
(190880, '3.70.10.10-FF-000045', NULL, 'Cell cycle checkpoint control protein RAD9A', 273, NULL, NULL, 190880),
(190881, '3.30.450.20-FF-000200', NULL, 'Sensor histidine kinase KinD', 80, NULL, NULL, 190881),
(190882, '1.10.510.10-FF-003430', NULL, NULL, 286, NULL, NULL, 190882),
(190883, '3.40.50.300-FF-000595', NULL, 'ATPase family AAA domain-containing protein 3', 191, NULL, NULL, 190883),
(190884, '3.40.190.10-FF-000574', NULL, 'Uncharacterized protein', 236, NULL, NULL, 190884),
(190885, '3.30.420.40-FF-000710', NULL, 'Glucose kinase', 167, NULL, NULL, 190885),
(190886, '3.40.50.1820-FF-001735', NULL, 'Uncharacterized protein', 90, NULL, NULL, 190886),
(190887, '1.10.443.10-FF-000002', NULL, 'Tyrosine recombinase XerC', 176, NULL, NULL, 190887),
(190888, '1.10.720.30-FF-000012', NULL, 'apoptotic chromatin condensation inducer in the nucleus isoform X1', 42, NULL, NULL, 190888),
(190889, '2.130.10.10-FF-004535', NULL, 'WD-repeat protein, putative', 226, NULL, NULL, 190889),
(190890, '3.20.20.150-FF-000026', NULL, 'Putative hydroxypyruvate isomerase', 266, NULL, NULL, 190890),
(190891, '3.40.366.10-FF-000033', NULL, 'Fatty acid synthase', 164, NULL, NULL, 190891),
(190892, '3.40.1280.10-FF-000046', NULL, 'RNA methyltransferase, TrmH family', 151, NULL, NULL, 190892),
(190893, '1.25.40.20-FF-000097', NULL, 'NF-kappa-B inhibitor zeta isoform X1', 267, NULL, NULL, 190893),
(190894, '3.40.50.300-FF-007155', NULL, 'Uncharacterized protein', 176, NULL, NULL, 190894),
(190895, '1.10.238.10-FF-000688', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', 77, NULL, NULL, 190895),
(190896, '1.20.144.10-FF-000136', NULL, 'LD09836p', 76, NULL, NULL, 190896),
(190897, '1.10.510.10-FF-001772', NULL, 'Protein CBG12760', 354, NULL, NULL, 190897);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(190898, '3.90.190.10-FF-000613', NULL, 'Uncharacterized protein', 100, NULL, NULL, 190898),
(190899, '3.40.50.720-FF-000693', NULL, 'Alcohol dehydrogenase B', 140, NULL, NULL, 190899),
(190900, '1.20.120.20-FF-000045', NULL, 'Apolipoprotein A-IV', 56, NULL, NULL, 190900),
(190901, '2.40.440.10-FF-000007', NULL, 'Murein L,D-transpeptidase', 109, NULL, NULL, 190901),
(190902, '3.40.140.20-FF-000012', NULL, NULL, 38, NULL, NULL, 190902),
(190903, '3.30.160.60-FF-004568', NULL, NULL, 69, NULL, NULL, 190903),
(190904, '3.30.428.10-FF-000016', NULL, 'Scavenger mRNA decapping enzyme', 204, NULL, NULL, 190904),
(190905, '1.10.287.610-FF-000004', NULL, '30S ribosomal protein S2', 50, NULL, NULL, 190905),
(190906, '3.40.50.300-FF-001320', NULL, 'Heme ABC transporter ATP-binding protein', 270, NULL, NULL, 190906),
(190907, '3.40.50.300-FF-005974', NULL, 'Thymidine kinase', 143, NULL, NULL, 190907),
(190908, '2.120.10.30-FF-000505', NULL, 'Uncharacterized protein', 209, NULL, NULL, 190908),
(190909, '2.60.120.200-FF-000217', NULL, 'Gram-negative bacteria-binding protein', 314, NULL, NULL, 190909),
(190910, '3.30.1330.10-FF-000025', NULL, 'Selenide, water dikinase', 173, NULL, NULL, 190910),
(190911, '2.170.300.10-FF-000101', NULL, 'Scavenger receptor class F member 1', 40, NULL, NULL, 190911),
(190912, '2.130.10.10-FF-000409', NULL, 'Flowering time control protein FY', 209, NULL, NULL, 190912),
(190913, '3.50.50.60-FF-000563', NULL, 'FAD-binding domain', 173, NULL, NULL, 190913),
(190914, '3.30.160.60-FF-002859', NULL, 'Zinc finger protein 866', 39, NULL, NULL, 190914),
(190915, '1.10.60.30-FF-000005', NULL, 'UPF0307 protein B7D78_01970', 77, NULL, NULL, 190915),
(190916, '1.10.8.10-FF-000012', NULL, 'ATP-dependent protease ATPase subunit HslU', 69, NULL, NULL, 190916),
(190917, '3.20.180.20-FF-000041', NULL, 'Uncharacterized protein', 95, NULL, NULL, 190917),
(190918, '3.60.40.10-FF-000334', NULL, 'Uncharacterized protein', 147, NULL, NULL, 190918),
(190919, '1.10.287.70-FF-000342', NULL, 'Calcium-activated potassium channel subunit alpha-1, putative', 111, NULL, NULL, 190919),
(190920, '3.30.2350.10-FF-000026', NULL, 'RNA-binding protein S4', 174, NULL, NULL, 190920),
(190921, '3.30.200.20-FF-000536', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 2', 103, NULL, NULL, 190921),
(190922, '2.20.100.10-FF-000239', NULL, 'AGAP002424-PA', 80, NULL, NULL, 190922),
(190923, '3.30.530.20-FF-000201', NULL, 'Uncharacterized protein', 69, NULL, NULL, 190923),
(190924, '1.25.40.180-FF-000314', NULL, NULL, 263, NULL, NULL, 190924),
(190925, '3.40.50.300-FF-007683', NULL, 'RAS protein, putative', 113, NULL, NULL, 190925),
(190926, '1.10.10.60-FF-000781', NULL, NULL, 78, NULL, NULL, 190926),
(190927, '2.70.98.110-FF-000008', NULL, 'Cwh41p', 318, NULL, NULL, 190927),
(190928, '3.60.10.10-FF-000242', NULL, 'Endonuclease/exonuclease/phosphatase family protein, putative', 295, NULL, NULL, 190928),
(190929, '3.60.10.10-FF-000186', NULL, 'DNase I-like protein', 408, NULL, NULL, 190929),
(190930, '3.40.50.300-FF-007211', NULL, 'Uncharacterized protein', 165, NULL, NULL, 190930),
(190931, '3.40.1180.10-FF-000005', NULL, 'Alkyl transferase', 249, NULL, NULL, 190931),
(190932, '3.40.190.10-FF-000719', NULL, 'No message in thiamine Nmt1', 91, NULL, NULL, 190932),
(190933, '2.10.110.10-FF-000169', NULL, 'ISL LIM homeobox 2', 78, NULL, NULL, 190933),
(190934, '1.20.1330.10-FF-000012', NULL, 'Flagellar hook-filament junction protein FlgL', 204, NULL, NULL, 190934),
(190935, '3.40.1190.10-FF-000034', NULL, 'Bifunctional folylpolyglutamate synthase/dihydrofolate synthase', 299, NULL, NULL, 190935),
(190936, '1.20.1050.10-FF-000030', NULL, 'Glutathione S-transferase S1', 113, NULL, NULL, 190936),
(190937, '2.10.25.10-FF-000062', NULL, 'Slit guidance ligand 2', 40, NULL, NULL, 190937),
(190938, '2.60.40.640-FF-000099', NULL, 'Arrestin domain-containing protein A', 162, NULL, NULL, 190938),
(190939, '3.30.160.60-FF-000297', NULL, 'Zinc finger and AT-hook domain containing', 28, NULL, NULL, 190939),
(190940, '3.40.1360.10-FF-000047', NULL, 'Spo11/DNA topoisomerase VI subunit A', 221, NULL, NULL, 190940);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(190941, '1.20.1560.10-FF-000636', NULL, 'ATP-binding cassette transporter, subfamily B, member 21, group MDR/PGP protein PpABCB21', 205, NULL, NULL, 190941),
(190942, '1.20.210.10-FF-000015', NULL, 'Cytochrome c oxidase subunit I', 505, NULL, NULL, 190942),
(190943, '3.30.70.330-FF-002437', NULL, NULL, 87, NULL, NULL, 190943),
(190944, '1.10.3660.10-FF-000011', NULL, 'Prephenate dehydrogenase', 114, NULL, NULL, 190944),
(190945, '2.60.40.150-FF-000137', NULL, 'Piccolo presynaptic cytomatrix protein', 144, NULL, NULL, 190945),
(190946, '3.40.1280.10-FF-000102', NULL, 'Ribosomal RNA small subunit methyltransferase E', 239, NULL, NULL, 190946),
(190947, '3.90.930.40-FF-000005', NULL, NULL, 137, NULL, NULL, 190947),
(190948, '3.50.30.30-FF-000132', NULL, 'Uncharacterized protein', 79, NULL, NULL, 190948),
(190949, '2.10.25.10-FF-000859', NULL, 'Fibulin-1', 42, NULL, NULL, 190949),
(190950, '2.20.100.10-FF-000150', NULL, 'GM21753', 78, NULL, NULL, 190950),
(190951, '1.20.58.60-FF-000648', NULL, 'Uncharacterized protein', 194, NULL, NULL, 190951),
(190952, '3.40.50.300-FF-000067', NULL, 'ras-related protein RABA1f', 211, NULL, NULL, 190952),
(190953, '2.60.490.10-FF-000023', NULL, 'Uncharacterized protein', 52, NULL, NULL, 190953),
(190954, '2.30.29.30-FF-000620', NULL, 'dynamin-3-like isoform X2', 84, NULL, NULL, 190954),
(190955, '2.60.40.10-FF-000757', NULL, 'Beta-glucosidase G', 134, NULL, NULL, 190955),
(190956, '2.10.90.10-FF-000021', NULL, 'vascular endothelial growth factor D', 168, NULL, NULL, 190956),
(190957, '1.25.10.10-FF-003138', NULL, 'Protein VAC14-like protein', 109, NULL, NULL, 190957),
(190958, '2.60.120.10-FF-000237', NULL, 'Transcription regulator, Crp family', 135, NULL, NULL, 190958),
(190959, '3.100.10.10-FF-000025', NULL, '50S ribosomal protein L15', 88, NULL, NULL, 190959),
(190960, '3.10.50.40-FF-000020', NULL, 'Peptidylprolyl isomerase', 116, NULL, NULL, 190960),
(190961, '1.10.238.10-FF-000216', NULL, 'Putative calmodulin', 73, NULL, NULL, 190961),
(190962, '1.10.3380.30-FF-000035', NULL, 'DNA-directed DNA polymerase theta, putative (AFU_orthologue AFUA_1G05260)', 137, NULL, NULL, 190962),
(190963, '3.30.160.60-FF-002915', NULL, NULL, 25, NULL, NULL, 190963),
(190964, '1.10.3200.20-FF-000014', NULL, NULL, 167, NULL, NULL, 190964),
(190965, '1.10.10.10-FF-001160', NULL, 'Transcriptional activator domain', 103, NULL, NULL, 190965),
(190966, '3.40.50.2300-FF-000031', NULL, 'HTH-type transcriptional repressor PurR', 124, NULL, NULL, 190966),
(190967, '2.170.130.10-FF-000032', NULL, 'TonB-dependent outer membrane receptor', 148, NULL, NULL, 190967),
(190968, '2.20.25.530-FF-000001', NULL, 'Ribonuclease H2 subunit B', 79, NULL, NULL, 190968),
(190969, '2.60.40.60-FF-000778', NULL, 'Uncharacterized protein', 104, NULL, NULL, 190969),
(190970, '2.40.10.10-FF-000650', NULL, NULL, 118, NULL, NULL, 190970),
(190971, '3.30.40.10-FF-001010', NULL, 'PHD finger family', 75, NULL, NULL, 190971),
(190972, '3.40.50.10810-FF-000014', NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily A containing DEAD/H box 1', 280, NULL, NULL, 190972),
(190973, '3.30.413.10-FF-000022', NULL, 'Sulfite reductase, dissimilatory-type beta subunit', 156, NULL, NULL, 190973),
(190974, '3.40.5.10-FF-000018', NULL, '50S ribosomal protein L9', 64, NULL, NULL, 190974),
(190975, '3.40.50.300-FF-004193', NULL, 'Os05g0467501 protein', 200, NULL, NULL, 190975),
(190976, '3.30.450.40-FF-000206', NULL, 'GAF domain-containing protein', 164, NULL, NULL, 190976),
(190977, '1.10.4030.10-FF-000003', NULL, 'Peptidylprolyl isomerase', 153, NULL, NULL, 190977),
(190978, '1.10.286.20-FF-000010', NULL, NULL, 40, NULL, NULL, 190978),
(190979, '2.130.10.10-FF-004248', NULL, 'Uncharacterized protein', 140, NULL, NULL, 190979),
(190980, '2.120.10.80-FF-000262', NULL, 'KAR-UP F-box 1', 282, NULL, NULL, 190980),
(190981, '3.80.10.10-FF-002669', NULL, 'Predicted protein', 156, NULL, NULL, 190981),
(190982, '3.40.50.12280-FF-000005', NULL, 'Hydrogenase-4, I subunit', 158, NULL, NULL, 190982),
(190983, '3.40.50.2000-FF-001043', NULL, 'UDP-glycosyltransferase TURAN', 146, NULL, NULL, 190983);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(190984, '3.40.50.2000-FF-000531', NULL, 'UDP-glycosyltransferase 83A1', 106, NULL, NULL, 190984),
(190985, '1.10.10.1740-FF-000005', NULL, 'BnaCnng46150D protein', 111, NULL, NULL, 190985),
(190986, '3.10.580.10-FF-000161', NULL, 'Predicted protein', 133, NULL, NULL, 190986),
(190987, '2.170.140.10-FF-000061', NULL, 'Uncharacterized protein', 61, NULL, NULL, 190987),
(190988, '1.10.150.50-FF-000114', NULL, 'Kinesin-like protein', 67, NULL, NULL, 190988),
(190989, '2.10.25.10-FF-000770', NULL, 'Agrin', 39, NULL, NULL, 190989),
(190990, '2.30.24.10-FF-000002', NULL, 'Transcription antiterminator LicT', 55, NULL, NULL, 190990),
(190991, '3.40.1190.20-FF-000076', NULL, 'Adenosine kinase', 282, NULL, NULL, 190991),
(190992, '1.10.510.10-FF-003806', NULL, NULL, 120, NULL, NULL, 190992),
(190993, '2.60.40.10-FF-004411', NULL, NULL, 100, NULL, NULL, 190993),
(190994, '3.40.50.261-FF-000011', NULL, 'Acetyl CoA synthetase, putative', 161, NULL, NULL, 190994),
(190995, '2.40.100.10-FF-000049', NULL, 'Peptidyl-prolyl cis-trans isomerase', 179, NULL, NULL, 190995),
(190996, '3.40.50.10330-FF-000112', NULL, 'Uncharacterized kinase C24B10.02c', 169, NULL, NULL, 190996),
(190997, '3.60.15.10-FF-000118', NULL, 'Metallo-beta-lactamase L1 type 3', 269, NULL, NULL, 190997),
(190998, '1.10.3460.10-FF-000030', NULL, 'High intensity light-inducible lhc-like gene', 143, NULL, NULL, 190998),
(190999, '2.30.40.10-FF-000175', NULL, 'Hydroxydechloroatrazine ethylaminohydrolase, putative', 103, NULL, NULL, 190999),
(191000, '1.20.1260.10-FF-000040', NULL, 'Spore coat protein F', 131, NULL, NULL, 191000),
(191001, '1.10.287.1490-FF-000145', NULL, 'Uncharacterized protein', 173, NULL, NULL, 191001),
(191002, '3.40.50.300-FF-000915', NULL, 'DNA replication ATP-dependent helicase/nuclease DNA2', 171, NULL, NULL, 191002),
(191003, '2.160.20.10-FF-000347', NULL, 'Cell surface protein', 232, NULL, NULL, 191003),
(191004, '3.30.40.210-FF-000001', NULL, 'Transcription elongation factor SPT4', 105, NULL, NULL, 191004),
(191005, '1.20.120.550-FF-000006', NULL, 'Microsomal glutathione S-transferase 3', 144, NULL, NULL, 191005),
(191006, '1.25.10.10-FF-001901', NULL, 'AaceriACL132Cp', 233, NULL, NULL, 191006),
(191007, '3.40.850.10-FF-000546', NULL, 'Uncharacterized protein', 235, NULL, NULL, 191007),
(191008, '2.60.120.640-FF-000001', NULL, 'Baseplate wedge tail fiber connector', 103, NULL, NULL, 191008),
(191009, '3.30.1060.10-FF-000009', NULL, 'Methionine sulfoxide reductase A', 157, NULL, NULL, 191009),
(191010, '2.40.10.10-FF-000594', NULL, NULL, 27, NULL, NULL, 191010),
(191011, '3.40.1190.20-FF-000132', NULL, 'Bud polarity/site selection protein (BUD family), putative', 336, NULL, NULL, 191011),
(191012, '1.10.287.3990-FF-000007', NULL, '26S proteasome non-ATPase regulatory subunit 4-like protein', 68, NULL, NULL, 191012),
(191013, '3.60.40.10-FF-000103', NULL, 'Phosphatase 1G', 137, NULL, NULL, 191013),
(191014, '3.30.56.10-FF-000006', NULL, 'Phenylalanyl-tRNA synthetase subunit beta', 79, NULL, NULL, 191014),
(191015, '1.10.3720.10-FF-000157', NULL, 'Peptide/nickel/opine uptake family ABC transporter, permease protein', 220, NULL, NULL, 191015),
(191016, '3.30.70.330-FF-000880', NULL, 'Polypyrimidine tract-binding protein 3', 105, NULL, NULL, 191016),
(191017, '1.10.630.10-FF-000027', NULL, 'lanosterol 14-alpha demethylase isoform X1', 453, NULL, NULL, 191017),
(191018, '3.10.110.10-FF-000278', NULL, 'Uncharacterized protein', 128, NULL, NULL, 191018),
(191019, '3.80.10.10-FF-003310', NULL, 'Toll-like receptor 5', 198, NULL, NULL, 191019),
(191020, '3.30.40.10-FF-001482', NULL, 'Zinc finger FYVE domain-containing protein 26', 84, NULL, NULL, 191020),
(191021, '3.10.100.10-FF-000305', NULL, NULL, 157, NULL, NULL, 191021),
(191022, '1.10.8.270-FF-000167', NULL, 'Uncharacterized protein', 78, NULL, NULL, 191022),
(191023, '3.40.30.10-FF-000115', NULL, 'protein disulfide-isomerase TMX3 isoform X1', 124, NULL, NULL, 191023),
(191024, '3.40.50.300-FF-002540', NULL, 'ABC transporter, ATP-binding protein', 218, NULL, NULL, 191024);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(191025, '3.30.1490.180-FF-000011', NULL, 'DNA-directed RNA polymerase I largest subunit', 75, NULL, NULL, 191025),
(191026, '3.40.50.150-FF-001022', NULL, NULL, 185, NULL, NULL, 191026),
(191027, '2.70.170.10-FF-000103', NULL, 'Predicted protein', 191, NULL, NULL, 191027),
(191028, '1.20.120.1900-FF-000025', NULL, 'Spindle pole body component', 378, NULL, NULL, 191028),
(191029, '3.30.70.890-FF-000019', NULL, 'Homoserine kinase', 126, NULL, NULL, 191029),
(191030, '2.30.30.380-FF-000008', NULL, 'nuclear protein localization protein 4 homolog', 32, NULL, NULL, 191030),
(191031, '1.10.10.60-FF-000494', NULL, 'Snt1p', 70, NULL, NULL, 191031),
(191032, '2.60.210.10-FF-000008', NULL, 'E3 ubiquitin-protein ligase TRIM37 isoform X1', 128, NULL, NULL, 191032),
(191033, '1.10.287.70-FF-000286', NULL, 'Uncharacterized protein', 289, NULL, NULL, 191033),
(191034, '3.40.50.2300-FF-000407', NULL, 'RteA, two-component system histidine kinase, with response regulator receiver domain', 132, NULL, NULL, 191034),
(191035, '1.25.10.10-FF-001429', NULL, 'STU2-like protein', 211, NULL, NULL, 191035),
(191036, '3.30.1010.10-FF-000006', NULL, 'Serine/threonine-protein kinase TOR', 130, NULL, NULL, 191036),
(191037, '1.25.40.570-FF-000072', NULL, 'Uncharacterized protein', 199, NULL, NULL, 191037),
(191038, '3.40.640.10-FF-000356', NULL, 'C4 aminotransferase for PseB product PseC', 259, NULL, NULL, 191038),
(191039, '2.60.40.10-FF-000229', NULL, 'Down syndrome cell adhesion molecule homolog', 99, NULL, NULL, 191039),
(191040, '2.60.34.10-FF-000136', NULL, 'Uncharacterized protein', 70, NULL, NULL, 191040),
(191041, '1.10.1370.30-FF-000039', NULL, 'Uncharacterized protein', 228, NULL, NULL, 191041),
(191042, '1.25.40.790-FF-000019', NULL, 'General negative regulator of transcription subunit 1', 284, NULL, NULL, 191042),
(191043, '2.60.40.10-FF-003574', NULL, NULL, 109, NULL, NULL, 191043),
(191044, '1.20.5.320-FF-000023', NULL, 'Collagen type XVI alpha 1 chain', 53, NULL, NULL, 191044),
(191045, '3.30.160.60-FF-000353', NULL, 'Zinc finger protein', 28, NULL, NULL, 191045),
(191046, '1.10.150.510-FF-000008', NULL, 'Uncharacterized protein', 94, NULL, NULL, 191046),
(191047, '3.30.160.60-FF-003787', NULL, NULL, 34, NULL, NULL, 191047),
(191048, '3.20.20.300-FF-000037', NULL, 'Periplasmic beta-glucosidase, xylosidase/arabinosidase', 383, NULL, NULL, 191048),
(191049, '1.25.40.10-FF-003022', NULL, 'Os06g0694600 protein', 111, NULL, NULL, 191049),
(191050, '1.25.10.10-FF-001340', NULL, 'Uncharacterized protein', 386, NULL, NULL, 191050),
(191051, '3.40.50.80-FF-000238', NULL, 'Uncharacterized protein', 77, NULL, NULL, 191051),
(191052, '2.10.25.10-FF-001787', NULL, 'Uncharacterized protein', 55, NULL, NULL, 191052),
(191053, '1.10.238.10-FF-001144', NULL, 'Uncharacterized protein', 139, NULL, NULL, 191053),
(191054, '3.30.450.20-FF-000583', NULL, 'Uncharacterized protein', 48, NULL, NULL, 191054),
(191055, '3.40.50.1820-FF-001590', NULL, 'Uncharacterized protein', 90, NULL, NULL, 191055),
(191056, '1.20.120.420-FF-000018', NULL, 'Methylthioribose-1-phosphate isomerase', 180, NULL, NULL, 191056),
(191057, '1.25.40.770-FF-000013', NULL, 'TAF6-like RNA polymerase II p300/CBP-associated factor-associated factor 65 kDa subunit 6L', 194, NULL, NULL, 191057),
(191058, '1.10.287.110-FF-000236', NULL, 'Chaperone protein DNAJ, putative', 86, NULL, NULL, 191058),
(191059, '1.20.900.10-FF-000046', NULL, 'Related to CDC24-GTP/GDP exchange factor for Cdc42p', 189, NULL, NULL, 191059),
(191060, '3.90.1580.10-FF-000035', NULL, 'Uncharacterized protein', 109, NULL, NULL, 191060),
(191061, '2.60.40.10-FF-000140', NULL, 'FiLamiN (Actin binding protein) homolog', 92, NULL, NULL, 191061),
(191062, '3.30.710.10-FF-000089', NULL, 'Zinc finger and BTB domain-containing protein 7B', 161, NULL, NULL, 191062),
(191063, '3.90.550.10-FF-000332', NULL, 'Glycosyl transferase family 8 protein', 246, NULL, NULL, 191063),
(191064, '1.20.1250.20-FF-001560', NULL, 'MFS general substrate transporter', 396, NULL, NULL, 191064),
(191065, '1.25.10.10-FF-002413', NULL, 'Uncharacterized protein', 252, NULL, NULL, 191065);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(191066, '1.10.1280.10-FF-000021', NULL, 'Tyrosinase', 383, NULL, NULL, 191066),
(191067, '1.10.238.10-FF-000744', NULL, 'Calmodulin-like membrane associated Ca(2+)-binding protein', 57, NULL, NULL, 191067),
(191068, '1.10.10.10-FF-000232', NULL, 'lysine-specific histone demethylase 1B', 99, NULL, NULL, 191068),
(191069, '2.60.40.10-FF-002466', NULL, 'Muscle, skeletal, receptor tyrosine kinase', 99, NULL, NULL, 191069),
(191070, '3.30.460.10-FF-000075', NULL, 'Ribosomal silencing factor RsfS', 102, NULL, NULL, 191070),
(191071, '2.30.30.30-FF-000157', NULL, 'Ribosomal protein L29', 56, NULL, NULL, 191071),
(191072, '2.60.40.3320-FF-000001', NULL, 'ORF48', 105, NULL, NULL, 191072),
(191073, '1.20.1250.20-FF-001649', NULL, 'MFS alpha-glucoside transporter, putative', 472, NULL, NULL, 191073),
(191074, '3.90.1210.10-FF-000008', NULL, NULL, 63, NULL, NULL, 191074),
(191075, '3.30.1360.40-FF-000013', NULL, 'DNA gyrase subunit A', 97, NULL, NULL, 191075),
(191076, '3.40.140.10-FF-000099', NULL, 'Cytidine deaminase', 116, NULL, NULL, 191076),
(191077, '3.30.70.330-FF-002965', NULL, NULL, 99, NULL, NULL, 191077),
(191078, '1.25.40.180-FF-000134', NULL, 'Nuclear cap-binding protein subunit 1-B', 246, NULL, NULL, 191078),
(191079, '3.30.40.10-FF-001858', NULL, 'Uncharacterized protein', 118, NULL, NULL, 191079),
(191080, '1.25.40.1010-FF-000015', NULL, 'Narg1b protein', 135, NULL, NULL, 191080),
(191081, '1.10.2020.20-FF-000011', NULL, NULL, 117, NULL, NULL, 191081),
(191082, '3.30.230.80-FF-000011', NULL, 'Heat shock protein', 72, NULL, NULL, 191082),
(191083, '3.30.70.330-FF-000728', NULL, 'U1 small Nuclear ribonucleoprotein A, Putative', 86, NULL, NULL, 191083),
(191084, '3.30.230.70-FF-000154', NULL, 'Uncharacterized protein', 72, NULL, NULL, 191084),
(191085, '1.10.510.10-FF-001485', NULL, 'Protein kinase domain containing protein', 175, NULL, NULL, 191085),
(191086, '3.30.160.60-FF-005732', NULL, NULL, 101, NULL, NULL, 191086),
(191087, '3.60.40.10-FF-000070', NULL, 'Protein phosphatase domain containing protein', 280, NULL, NULL, 191087),
(191088, '3.40.50.10490-FF-000019', NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', 152, NULL, NULL, 191088),
(191089, '3.30.70.1180-FF-000023', NULL, 'V-type proton ATPase subunit C', 21, NULL, NULL, 191089),
(191090, '3.10.120.10-FF-000048', NULL, 'Chitin synthase', 77, NULL, NULL, 191090),
(191091, '3.30.70.3030-FF-000011', NULL, 'U3 small nucleolar RNA-associated protein 22', 146, NULL, NULL, 191091),
(191092, '1.20.1270.60-FF-000090', NULL, 'Snx4p', 240, NULL, NULL, 191092),
(191093, '3.80.10.10-FF-002293', NULL, 'YALI0C06556p', 217, NULL, NULL, 191093),
(191094, '1.10.238.10-FF-000924', NULL, 'Mitochondrial Rho GTPase 2', 76, NULL, NULL, 191094),
(191095, '3.30.160.750-FF-000003', NULL, 'S-adenosylmethionine decarboxylase proenzyme', 65, NULL, NULL, 191095),
(191096, '3.40.309.10-FF-000007', NULL, 'Aldehyde-alcohol dehydrogenase', 187, NULL, NULL, 191096),
(191097, '3.30.420.40-FF-000238', NULL, 'Cell division protein FtsA', 89, NULL, NULL, 191097),
(191098, '3.60.21.10-FF-000470', NULL, 'Serine/threonine-protein phosphatase', 89, NULL, NULL, 191098),
(191099, '1.10.287.160-FF-000026', NULL, 'Uncharacterized protein', 67, NULL, NULL, 191099),
(191100, '1.20.120.980-FF-000017', NULL, 'Dipeptidyl peptidase 7', 35, NULL, NULL, 191100),
(191101, '1.25.40.10-FF-004978', NULL, 'Flagellar associated protein', 274, NULL, NULL, 191101),
(191102, '2.40.50.840-FF-000002', NULL, 'Acetyl-CoA acetyltransferase', 74, NULL, NULL, 191102),
(191103, '3.30.70.330-FF-000548', NULL, 'Myelin expression factor 2', 85, NULL, NULL, 191103),
(191104, '3.30.30.10-FF-000020', NULL, NULL, 39, NULL, NULL, 191104),
(191105, '3.30.420.40-FF-000766', NULL, 'Actin-related protein 8', 157, NULL, NULL, 191105),
(191106, '3.30.460.10-FF-000108', NULL, 'WGS project CABT00000000 data, contig 2.10', 118, NULL, NULL, 191106),
(191107, '1.10.1600.10-FF-000030', NULL, 'Predicted protein', 92, NULL, NULL, 191107),
(191108, '3.90.740.10-FF-000015', NULL, 'Valine--tRNA ligase', 134, NULL, NULL, 191108);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(191109, '3.40.50.200-FF-000150', NULL, 'Predicted protein', 397, NULL, NULL, 191109),
(191110, '1.10.238.10-FF-001200', NULL, 'Serine/threonine-protein phosphatase', 181, NULL, NULL, 191110),
(191111, '3.40.50.300-FF-006699', NULL, 'Uncharacterized protein', 79, NULL, NULL, 191111),
(191112, '3.30.710.10-FF-000145', NULL, 'leucine-zipper-like transcriptional regulator 1', 156, NULL, NULL, 191112),
(191113, '1.10.510.10-FF-002974', NULL, NULL, 129, NULL, NULL, 191113),
(191114, '3.30.70.330-FF-000695', NULL, 'Blast:CCR4-NOT transcription complex subunit 11', 110, NULL, NULL, 191114),
(191115, '1.10.510.10-FF-002789', NULL, NULL, 200, NULL, NULL, 191115),
(191116, '1.10.10.10-FF-000608', NULL, 'Transcriptional regulator, MarR family', 139, NULL, NULL, 191116),
(191117, '2.40.30.10-FF-000393', NULL, 'Uncharacterized protein', 102, NULL, NULL, 191117),
(191118, '2.40.240.10-FF-000026', NULL, '50S ribosomal protein L25', 94, NULL, NULL, 191118),
(191119, '2.60.40.3190-FF-000001', NULL, 'Envelope glycoprotein H', 150, NULL, NULL, 191119),
(191120, '3.40.50.300-FF-005266', NULL, 'GTP-binding protein Rit1', 183, NULL, NULL, 191120),
(191121, '3.90.70.10-FF-000891', NULL, 'Transporter, truncation', 52, NULL, NULL, 191121),
(191122, '1.20.1420.30-FF-000053', NULL, 'Sodium/calcium exchanger membrane region', 156, NULL, NULL, 191122),
(191123, '1.10.510.10-FF-000844', NULL, 'Kinase, NEK', 183, NULL, NULL, 191123),
(191124, '1.20.58.60-FF-000087', NULL, 'microtubule-actin cross-linking factor 1 isoform X2', 112, NULL, NULL, 191124),
(191125, '3.40.50.80-FF-000058', NULL, 'Ferric reductase transmembrane component 4, variant', 187, NULL, NULL, 191125),
(191126, '1.20.1250.20-FF-000071', NULL, 'Inner membrane transporter ynfM', 383, NULL, NULL, 191126),
(191127, '3.40.50.1010-FF-000245', NULL, NULL, 189, NULL, NULL, 191127),
(191128, '3.30.160.60-FF-005788', NULL, NULL, 27, NULL, NULL, 191128),
(191129, '1.10.220.10-FF-000069', NULL, 'Annexin', 37, NULL, NULL, 191129),
(191130, '1.10.510.10-FF-003250', NULL, NULL, 115, NULL, NULL, 191130),
(191131, '3.40.50.620-FF-000045', NULL, 'Glutamate--tRNA ligase, mitochondrial', 333, NULL, NULL, 191131),
(191132, '3.40.630.30-FF-000013', NULL, 'cysteine-rich protein 2-binding protein-like', 145, NULL, NULL, 191132),
(191133, '1.25.40.10-FF-001021', NULL, 'Clustered mitochondria protein homolog', 100, NULL, NULL, 191133),
(191134, '1.25.40.20-FF-001081', NULL, 'Testis expressed 14, intercellular bridge forming factor', 116, NULL, NULL, 191134),
(191135, '2.80.10.50-FF-000019', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 126, NULL, NULL, 191135),
(191136, '2.10.60.10-FF-000053', NULL, 'Anti-Mullerian hormone type 2 receptor delta 2', 53, NULL, NULL, 191136),
(191137, '2.60.40.10-FF-005052', NULL, NULL, 102, NULL, NULL, 191137),
(191138, '2.130.10.120-FF-000015', NULL, 'Prolyl endopeptidase', 375, NULL, NULL, 191138),
(191139, '3.40.630.30-FF-000485', NULL, 'Acetyltransferase', 150, NULL, NULL, 191139),
(191140, '2.30.42.10-FF-000342', NULL, 'Putative proteasome 26S non-ATPase subunit 9', 112, NULL, NULL, 191140),
(191141, '2.60.40.1660-FF-000003', NULL, 'Sodium/potassium-transporting ATPase subunit beta', 223, NULL, NULL, 191141),
(191142, '2.30.180.10-FF-000017', NULL, 'Stabilin 2', 127, NULL, NULL, 191142),
(191143, '2.60.40.10-FF-002702', NULL, 'PKHD1 like 1', 97, NULL, NULL, 191143),
(191144, '3.40.50.1380-FF-000013', NULL, 'Carbamoyl-phosphate synthase large chain', 138, NULL, NULL, 191144),
(191145, '3.30.200.20-FF-000160', NULL, 'Serine/threonine-protein kinase 32C', 124, NULL, NULL, 191145),
(191146, '2.130.10.10-FF-003231', NULL, 'WD repeat-containing protein', 260, NULL, NULL, 191146),
(191147, '2.60.40.10-FF-002646', NULL, 'Disorganized muscle protein 1', 95, NULL, NULL, 191147),
(191148, '3.30.160.60-FF-003315', NULL, 'Maternal gene required for meiosis, isoform H', 31, NULL, NULL, 191148),
(191149, '3.30.565.10-FF-000520', NULL, 'Sensor histidine kinase', 130, NULL, NULL, 191149),
(191150, '1.10.840.10-FF-000037', NULL, 'Son of sevenless homolog', 112, NULL, NULL, 191150);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(191151, '3.80.10.10-FF-000904', NULL, 'AGAP010636-PA', 394, NULL, NULL, 191151),
(191152, '2.60.120.260-FF-000067', NULL, 'Putative E3 ubiquitin-protein ligase HECTD3', 151, NULL, NULL, 191152),
(191153, '3.40.50.1820-FF-000662', NULL, 'Carboxypeptidase', 443, NULL, NULL, 191153),
(191154, '2.130.10.10-FF-003607', NULL, 'chromatin assembly factor 1 subunit B-like isoform X1', 162, NULL, NULL, 191154),
(191155, '3.30.160.60-FF-004804', NULL, NULL, 32, NULL, NULL, 191155),
(191156, '3.90.660.10-FF-000014', NULL, 'Amine oxidase', 187, NULL, NULL, 191156),
(191157, '3.30.800.10-FF-000028', NULL, NULL, 179, NULL, NULL, 191157),
(191158, '1.20.1070.10-FF-000880', NULL, 'Chlamyopsin-5 sensory rhodopsin', 232, NULL, NULL, 191158),
(191159, '3.40.390.10-FF-000319', NULL, NULL, 51, NULL, NULL, 191159),
(191160, '2.60.40.10-FF-005428', NULL, NULL, 112, NULL, NULL, 191160),
(191161, '3.40.50.170-FF-000011', NULL, 'phosphoribosylglycinamide formyltransferase, chloroplastic', 227, NULL, NULL, 191161),
(191162, '3.15.10.20-FF-000006', NULL, 'Activator of Hsp90 ATPase, N-terminal/Activator of Hsp90 ATPase like protein, putative', 157, NULL, NULL, 191162),
(191163, '1.20.1310.10-FF-000157', NULL, NULL, 73, NULL, NULL, 191163),
(191164, '2.70.170.10-FF-000047', NULL, 'neuronal acetylcholine receptor subunit alpha-5 isoform X2', 163, NULL, NULL, 191164),
(191165, '3.30.870.10-FF-000162', NULL, 'Uncharacterized protein', 86, NULL, NULL, 191165),
(191166, '2.60.40.10-FF-001157', NULL, 'Natural cytotoxicity triggering receptor 1', 93, NULL, NULL, 191166),
(191167, '1.20.120.1880-FF-000002', NULL, 'Nuclear pore complex protein NUP155', 239, NULL, NULL, 191167),
(191168, '1.50.40.10-FF-000316', NULL, 'Dicarboxylate carrier 3, isoform B', 141, NULL, NULL, 191168),
(191169, '1.10.30.10-FF-000031', NULL, 'High mobility group protein 20A', 101, NULL, NULL, 191169),
(191170, '1.20.58.60-FF-000143', NULL, 'Periplakin', 186, NULL, NULL, 191170),
(191171, '3.10.350.10-FF-000060', NULL, 'Probable N-acetylmuramoyl-L-alanine amidase AmiB', 57, NULL, NULL, 191171),
(191172, '3.40.50.300-FF-006227', NULL, 'Terminase, large subunit gp2', 225, NULL, NULL, 191172),
(191173, '1.20.1070.10-FF-000677', NULL, 'Predicted protein', 102, NULL, NULL, 191173),
(191174, '3.90.1300.10-FF-000043', NULL, 'Protein CBG13308', 546, NULL, NULL, 191174),
(191175, '3.10.20.90-FF-000454', NULL, 'UBX domain protein 11', 83, NULL, NULL, 191175),
(191176, '3.30.420.10-FF-000134', NULL, 'DNA polymerase', 217, NULL, NULL, 191176),
(191177, '2.170.16.10-FF-000011', NULL, 'Pre-mRNA-processing-splicing factor 8', 171, NULL, NULL, 191177),
(191178, '3.20.20.70-FF-000543', NULL, NULL, 217, NULL, NULL, 191178),
(191179, '3.40.50.1010-FF-000189', NULL, NULL, 136, NULL, NULL, 191179),
(191180, '1.10.1200.10-FF-000134', NULL, 'HC-toxin synthetase', 69, NULL, NULL, 191180),
(191181, '3.30.9.10-FF-000044', NULL, 'Probable sarcosine oxidase', 159, NULL, NULL, 191181),
(191182, '3.30.930.10-FF-000217', NULL, 'Alanine--tRNA ligase', 258, NULL, NULL, 191182),
(191183, '1.10.565.10-FF-000167', NULL, 'Uncharacterized protein', 191, NULL, NULL, 191183),
(191184, '1.20.1250.20-FF-001032', NULL, 'Monocarboxylate transporter, putative', 138, NULL, NULL, 191184),
(191185, '3.40.30.10-FF-000587', NULL, 'Thioredoxin TrxC', 111, NULL, NULL, 191185),
(191186, '1.10.10.10-FF-000760', NULL, 'Ferric uptake regulation protein', 92, NULL, NULL, 191186),
(191187, '3.40.50.620-FF-000101', NULL, 'Nicotinamide-nucleotide adenylyltransferase', 249, NULL, NULL, 191187),
(191188, '3.40.640.10-FF-000209', NULL, 'PLP-dependent transferase', 66, NULL, NULL, 191188),
(191189, '3.10.450.40-FF-000020', NULL, 'DNA-directed RNA polymerase subunit', 92, NULL, NULL, 191189),
(191190, '1.25.10.10-FF-003341', NULL, 'Predicted protein', 231, NULL, NULL, 191190),
(191191, '3.40.50.620-FF-000606', NULL, 'Kinase with adenine nucleotide alpha hydrolases-like domain-containing protein', 144, NULL, NULL, 191191),
(191192, '3.30.70.270-FF-000305', NULL, NULL, 46, NULL, NULL, 191192),
(191193, '1.10.510.10-FF-003194', NULL, NULL, 150, NULL, NULL, 191193);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(191194, '3.40.50.720-FF-001997', NULL, 'Uncharacterized protein', 233, NULL, NULL, 191194),
(191195, '3.30.40.10-FF-000554', NULL, 'PHD finger protein MALE STERILITY 1', 75, NULL, NULL, 191195),
(191196, '3.90.190.10-FF-000293', NULL, 'Cell division cycle 14A', 51, NULL, NULL, 191196),
(191197, '3.40.1350.60-FF-000011', NULL, 'Uncharacterized protein', 90, NULL, NULL, 191197),
(191198, '2.130.10.10-FF-003046', NULL, 'Utp5p', 149, NULL, NULL, 191198),
(191199, '3.80.10.10-FF-004035', NULL, 'Uncharacterized protein', 144, NULL, NULL, 191199),
(191200, '3.40.390.10-FF-000286', NULL, NULL, 103, NULL, NULL, 191200),
(191201, '3.10.100.10-FF-000249', NULL, NULL, 146, NULL, NULL, 191201),
(191202, '3.30.470.20-FF-000235', NULL, 'Glutathione synthetase, chloroplastic', 79, NULL, NULL, 191202),
(191203, '1.20.1460.10-FF-000016', NULL, 'V-type proton ATPase subunit C', 185, NULL, NULL, 191203),
(191204, '1.10.10.440-FF-000059', NULL, 'Transcription elongation regulator', 59, NULL, NULL, 191204),
(191205, '2.60.120.680-FF-000018', NULL, 'Uncharacterized protein', 87, NULL, NULL, 191205),
(191206, '3.40.50.300-FF-003321', NULL, 'Uncharacterized protein', 192, NULL, NULL, 191206),
(191207, '3.30.230.10-FF-000304', NULL, 'Uncharacterized protein', 45, NULL, NULL, 191207),
(191208, '2.40.50.140-FF-000562', NULL, 'DNA-directed RNA polymerase II subunit putative', 88, NULL, NULL, 191208),
(191209, '1.20.1250.10-FF-000011', NULL, 'Interleukin-10', 152, NULL, NULL, 191209),
(191210, '3.40.850.10-FF-000366', NULL, 'Kinesin family member 16B', 75, NULL, NULL, 191210),
(191211, '3.10.20.30-FF-000099', NULL, NULL, 55, NULL, NULL, 191211),
(191212, '1.25.40.20-FF-001114', NULL, 'Uncharacterized protein', 378, NULL, NULL, 191212),
(191213, '1.20.1120.10-FF-000002', NULL, 'Botulinum neurotoxin type D', 412, NULL, NULL, 191213),
(191214, '2.10.50.30-FF-000053', NULL, 'Vomeronasal 2 receptor o', 36, NULL, NULL, 191214),
(191215, '2.10.70.80-FF-000018', NULL, 'Predicted protein', 54, NULL, NULL, 191215),
(191216, '2.30.40.10-FF-000028', NULL, 'Dal1p', 83, NULL, NULL, 191216),
(191217, '1.25.40.180-FF-000078', NULL, 'Translation initiation factor eIF-2B epsilon subunit, putative', 189, NULL, NULL, 191217),
(191218, '3.40.630.10-FF-000327', NULL, 'F10A2.10 protein', 89, NULL, NULL, 191218),
(191219, '1.10.10.10-FF-001013', NULL, 'ISPsy8, transposase OrfA', 57, NULL, NULL, 191219),
(191220, '2.60.120.260-FF-000595', NULL, 'Glycoside hydrolase family 95', 150, NULL, NULL, 191220),
(191221, '3.10.10.10-FF-000059', NULL, NULL, 68, NULL, NULL, 191221),
(191222, '2.40.70.10-FF-000423', NULL, NULL, 123, NULL, NULL, 191222),
(191223, '1.25.10.10-FF-002357', NULL, 'Condensin complex subunit 3', 282, NULL, NULL, 191223),
(191224, '2.40.50.140-FF-000742', NULL, 'Interferon-activable protein 202', 89, NULL, NULL, 191224),
(191225, '1.25.40.10-FF-003674', NULL, 'Uncharacterized protein', 206, NULL, NULL, 191225),
(191226, '2.130.10.10-FF-002826', NULL, 'Uncharacterized protein', 112, NULL, NULL, 191226),
(191227, '2.60.40.10-FF-003630', NULL, NULL, 94, NULL, NULL, 191227),
(191228, '3.90.370.10-FF-000003', NULL, 'TIMP2', 79, NULL, NULL, 191228),
(191229, '2.130.10.10-FF-002118', NULL, 'Mitochondrial division protein 1', 120, NULL, NULL, 191229),
(191230, '2.40.160.10-FF-000025', NULL, 'Outer membrane porin OprE', 426, NULL, NULL, 191230),
(191231, '1.25.10.10-FF-002885', NULL, 'pumilio homolog 3 isoform X3', 146, NULL, NULL, 191231),
(191232, '1.20.58.60-FF-000704', NULL, 'Uncharacterized protein', 110, NULL, NULL, 191232),
(191233, '2.30.130.10-FF-000014', NULL, 'Pseudouridine synthase/archaeosine transglycosylase', 72, NULL, NULL, 191233),
(191234, '1.25.10.10-FF-002177', NULL, 'Uncharacterized protein', 475, NULL, NULL, 191234),
(191235, '3.90.1140.10-FF-000036', NULL, 'Uncharacterized protein', 138, NULL, NULL, 191235),
(191236, '3.40.525.10-FF-000021', NULL, 'Sec14-like cytosolic factor or phosphatidylinositol/phosphatidylcholine transfer protein', 310, NULL, NULL, 191236),
(191237, '3.30.70.3310-FF-000005', NULL, 'Notch, isoform B', 143, NULL, NULL, 191237);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(191238, '3.30.465.10-FF-000012', NULL, 'delta(24)-sterol reductase isoform X1', 122, NULL, NULL, 191238),
(191239, '3.40.50.1100-FF-000031', NULL, 'L-serine dehydratase/L-threonine deaminase', 203, NULL, NULL, 191239),
(191240, '3.40.30.10-FF-000643', NULL, 'Iodothyronine deiodinase', 161, NULL, NULL, 191240),
(191241, '1.25.10.10-FF-003285', NULL, 'Uncharacterized protein', 186, NULL, NULL, 191241),
(191242, '2.40.50.140-FF-000034', NULL, 'Eukaryotic translation initiation factor 5A', 71, NULL, NULL, 191242),
(191243, '2.40.10.120-FF-000003', NULL, 'Genome polyprotein', 98, NULL, NULL, 191243),
(191244, '3.30.479.20-FF-000047', NULL, 'Elongation factor Ts, mitochondrial', 121, NULL, NULL, 191244),
(191245, '2.10.110.10-FF-000349', NULL, 'Uncharacterized protein', 62, NULL, NULL, 191245),
(191246, '3.30.230.10-FF-000119', NULL, 'Mevalonate kinase', 248, NULL, NULL, 191246),
(191247, '3.90.400.10-FF-000001', NULL, 'Maltase A3, isoform A', 73, NULL, NULL, 191247),
(191248, '3.30.1680.10-FF-000068', NULL, 'Integrin beta', 50, NULL, NULL, 191248),
(191249, '3.40.50.1400-FF-000036', NULL, 'Protoporphyrin ferrochelatase', 141, NULL, NULL, 191249),
(191250, '3.30.780.10-FF-000003', NULL, 'Eukaryotic translation initiation factor 1b', 113, NULL, NULL, 191250),
(191251, '3.40.50.12780-FF-000116', NULL, 'solute carrier family 27 member 3 isoform X1', 306, NULL, NULL, 191251),
(191252, '1.25.40.10-FF-000616', NULL, 'Tetratricopeptide repeat-containing protein', 155, NULL, NULL, 191252),
(191253, '1.20.810.10-FF-000016', NULL, 'Cytochrome b/b6 domain protein', 426, NULL, NULL, 191253),
(191254, '3.40.50.1820-FF-000134', NULL, 'Kynurenine formamidase', 256, NULL, NULL, 191254),
(191255, '1.10.10.10-FF-001721', NULL, 'Predicted protein', 103, NULL, NULL, 191255),
(191256, '1.50.10.20-FF-000025', NULL, 'Geranylgeranyl transferase type-2 subunit beta', 433, NULL, NULL, 191256),
(191257, '1.50.10.10-FF-000112', NULL, 'alpha-1,2-Mannosidase', 265, NULL, NULL, 191257),
(191258, '3.30.950.10-FF-000016', NULL, 'Probable uroporphyrin-III c-methyltransferase hemD', 140, NULL, NULL, 191258),
(191259, '2.30.30.40-FF-000306', NULL, 'Protein CBG22463', 63, NULL, NULL, 191259),
(191260, '3.40.50.200-FF-000003', NULL, 'Tripeptidyl peptidase 2', 319, NULL, NULL, 191260),
(191261, '3.40.630.30-FF-000541', NULL, 'Uncharacterized protein', 205, NULL, NULL, 191261),
(191262, '3.10.20.90-FF-000510', NULL, 'Ubiquitin-specific protease 5', 90, NULL, NULL, 191262),
(191263, '3.40.50.10190-FF-000143', NULL, 'Protein hsr-9', 122, NULL, NULL, 191263),
(191264, '3.30.40.10-FF-000369', NULL, 'TNF receptor-associated factor', 57, NULL, NULL, 191264),
(191265, '2.30.42.10-FF-000162', NULL, 'Tail-specific protease', 98, NULL, NULL, 191265),
(191266, '4.10.640.10-FF-000033', NULL, 'Mitochondrial ribosomal protein S18', 56, NULL, NULL, 191266),
(191267, '3.90.640.10-FF-000215', NULL, 'Actin-related protein 7', 83, NULL, NULL, 191267),
(191268, '4.10.110.10-FF-000004', NULL, 'zona pellucida sperm-binding protein 4 isoform X1', 49, NULL, NULL, 191268),
(191269, '1.10.940.10-FF-000022', NULL, 'SUN protein', 141, NULL, NULL, 191269),
(191270, '3.90.215.10-FF-000014', NULL, 'Blast:Protein scabrous', 207, NULL, NULL, 191270),
(191271, '3.30.70.330-FF-001509', NULL, NULL, 79, NULL, NULL, 191271),
(191272, '1.25.40.20-FF-000153', NULL, 'inactive serine/threonine-protein kinase TEX14 isoform X3', 130, NULL, NULL, 191272),
(191273, '1.25.40.10-FF-000240', NULL, 'Tetratricopeptide repeat protein 19, mitochondrial', 209, NULL, NULL, 191273),
(191274, '2.60.40.150-FF-000665', NULL, 'Copine 2', 85, NULL, NULL, 191274),
(191275, '3.40.50.300-FF-006755', NULL, 'Uncharacterized protein', 65, NULL, NULL, 191275),
(191276, '1.20.1070.10-FF-000149', NULL, 'Calcitonin receptor', 289, NULL, NULL, 191276),
(191277, '3.40.50.300-FF-006194', NULL, 'Helicase conserved C-terminal domain containing protein', 129, NULL, NULL, 191277),
(191278, '1.20.1310.10-FF-000213', NULL, NULL, 86, NULL, NULL, 191278),
(191279, '2.160.20.10-FF-000167', NULL, 'Uncharacterized protein', 174, NULL, NULL, 191279);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(191280, '3.30.160.60-FF-003843', NULL, NULL, 29, NULL, NULL, 191280),
(191281, '3.30.810.10-FF-000001', NULL, '1-phosphatidylinositol 3-phosphate 5-kinase FAB1', 143, NULL, NULL, 191281),
(191282, '1.10.3720.10-FF-000213', NULL, 'Hydroxymethylpyrimidine ABC transporter, transmembrane component', 204, NULL, NULL, 191282),
(191283, '3.90.180.10-FF-000135', NULL, 'Uncharacterized protein', 147, NULL, NULL, 191283),
(191284, '2.60.120.260-FF-000628', NULL, 'Uncharacterized protein', 121, NULL, NULL, 191284),
(191285, '1.10.510.10-FF-004211', NULL, NULL, 215, NULL, NULL, 191285),
(191286, '3.90.530.10-FF-000005', NULL, NULL, 111, NULL, NULL, 191286),
(191287, '1.10.730.10-FF-000208', NULL, 'Uncharacterized protein', 234, NULL, NULL, 191287),
(191288, '1.10.1040.10-FF-000094', NULL, 'Putative 2-dehydropantoate 2-reductase', 124, NULL, NULL, 191288),
(191289, '3.30.900.10-FF-000013', NULL, 'Autophagy-related protein 13', 253, NULL, NULL, 191289),
(191290, '1.10.630.10-FF-000499', NULL, 'Cytochrome P450', 452, NULL, NULL, 191290),
(191291, '3.30.420.10-FF-000662', NULL, NULL, 190, NULL, NULL, 191291),
(191292, '3.40.50.10470-FF-000013', NULL, 'Methylthioribose-1-phosphate isomerase', 177, NULL, NULL, 191292),
(191293, '3.80.10.10-FF-000871', NULL, 'volume-regulated anion channel subunit LRRC8A', 175, NULL, NULL, 191293),
(191294, '3.40.50.1000-FF-000860', NULL, NULL, 47, NULL, NULL, 191294),
(191295, '1.10.260.40-FF-000030', NULL, 'Coactivator bridging factor 1', 84, NULL, NULL, 191295),
(191296, '2.60.40.10-FF-001685', NULL, 'phosphatidylinositol phosphatase PTPRQ isoform X2', 93, NULL, NULL, 191296),
(191297, '4.10.240.10-FF-000008', NULL, 'C6 zinc finger domain-containing protein', 62, NULL, NULL, 191297),
(191298, '3.30.160.60-FF-002298', NULL, 'zinc finger protein 133 isoform X1', 24, NULL, NULL, 191298),
(191299, '1.25.40.20-FF-000861', NULL, 'Ankyrin repeat domain-containing protein 42', 107, NULL, NULL, 191299),
(191300, '1.20.120.1760-FF-000056', NULL, NULL, 194, NULL, NULL, 191300),
(191301, '2.60.40.1530-FF-000015', NULL, 'Integrin alpha pat-2', 199, NULL, NULL, 191301),
(191302, '3.40.50.300-FF-002484', NULL, 'ADP ribosylation factor like GTPase 8B', 153, NULL, NULL, 191302),
(191303, '3.80.10.10-FF-003597', NULL, 'Uncharacterized protein', 128, NULL, NULL, 191303),
(191304, '3.80.10.10-FF-003782', NULL, 'Os11g0695800 protein', 251, NULL, NULL, 191304),
(191305, '3.40.50.720-FF-000018', NULL, 'Malate dehydrogenase', 146, NULL, NULL, 191305),
(191306, '3.50.50.60-FF-000271', NULL, 'Hyaluronate lyase', 369, NULL, NULL, 191306),
(191307, '2.40.30.10-FF-000033', NULL, 'GTP-binding protein TypA', 101, NULL, NULL, 191307),
(191308, '1.20.1740.10-FF-000122', NULL, 'Putative solute carrier family 12 member 8-like protein', 222, NULL, NULL, 191308),
(191309, '3.10.580.10-FF-000133', NULL, 'Protein SDS23', 152, NULL, NULL, 191309),
(191310, '3.30.200.20-FF-000721', NULL, 'Myosin light chain kinase isoform-I', 108, NULL, NULL, 191310),
(191311, '3.30.559.70-FF-000046', NULL, 'Carnitine O-octanoyltransferase', 226, NULL, NULL, 191311),
(191312, '1.10.1070.11-FF-000085', NULL, 'Chromosome 12, whole genome shotgun sequence', 175, NULL, NULL, 191312),
(191313, '3.40.50.1360-FF-000030', NULL, 'Glucosamine-6-phosphate deaminase', 243, NULL, NULL, 191313),
(191314, '2.30.42.10-FF-000403', NULL, NULL, 114, NULL, NULL, 191314),
(191315, '3.40.50.12230-FF-000007', NULL, 'Methionyl-tRNA formyltransferase', 309, NULL, NULL, 191315),
(191316, '3.30.70.100-FF-000064', NULL, 'Photoactivated adenylate cyclase subunit beta-like protein ST-', 125, NULL, NULL, 191316),
(191317, '3.90.1750.10-FF-000094', NULL, 'E3 ubiquitin-protein ligase', 152, NULL, NULL, 191317),
(191318, '3.30.70.330-FF-001004', NULL, 'Os04g0682400 protein', 106, NULL, NULL, 191318),
(191319, '3.40.309.10-FF-000131', NULL, 'Predicted protein', 98, NULL, NULL, 191319),
(191320, '3.30.1490.480-FF-000011', NULL, 'Endolytic murein transglycosylase', 75, NULL, NULL, 191320),
(191321, '3.40.50.300-FF-006778', NULL, 'Uncharacterized protein', 60, NULL, NULL, 191321);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(191322, '1.10.520.10-FF-000030', NULL, 'L-ascorbate peroxidase 2 cytosolic', 20, NULL, NULL, 191322),
(191323, '3.40.50.720-FF-001497', NULL, 'Uncharacterized oxidoreductase C1739.08c', 260, NULL, NULL, 191323),
(191324, '2.60.40.1120-FF-000010', NULL, 'Carboxypeptidase Z', 84, NULL, NULL, 191324),
(191325, '3.40.50.300-FF-003113', NULL, 'Shikimate kinase', 176, NULL, NULL, 191325),
(191326, '3.40.50.20-FF-000086', NULL, 'Uncharacterized protein', 56, NULL, NULL, 191326),
(191327, '3.10.450.60-FF-000003', NULL, 'Arachidonate 5-lipoxygenase a', 116, NULL, NULL, 191327),
(191328, '3.40.30.10-FF-001216', NULL, 'Uncharacterized protein', 132, NULL, NULL, 191328),
(191329, '3.30.70.260-FF-000179', NULL, 'Guanosine-3'',5''-bis(diphosphate) 3''-pyrophosphohydrolase', 81, NULL, NULL, 191329),
(191330, '1.10.10.60-FF-000634', NULL, 'Transcriptional regulator, AraC/XylS family', 108, NULL, NULL, 191330),
(191331, '1.10.510.10-FF-001625', NULL, 'Protein kinase, putative', 210, NULL, NULL, 191331),
(191332, '3.40.800.20-FF-000012', NULL, 'Histone deacetylase 8', 250, NULL, NULL, 191332),
(191333, '2.170.130.10-FF-000060', NULL, NULL, 131, NULL, NULL, 191333),
(191334, '3.30.2130.10-FF-000010', NULL, 'GATS protein 3', 146, NULL, NULL, 191334),
(191335, '3.20.10.10-FF-000042', NULL, 'Branched-chain amino acid aminotransferase', 151, NULL, NULL, 191335),
(191336, '3.40.50.1000-FF-000068', NULL, 'Cation-transporting ATPase', 193, NULL, NULL, 191336),
(191337, '3.30.70.330-FF-001897', NULL, NULL, 154, NULL, NULL, 191337),
(191338, '2.10.25.10-FF-000775', NULL, 'Predicted protein', 48, NULL, NULL, 191338),
(191339, '1.25.10.10-FF-001508', NULL, 'AP-2 complex subunit beta-like Protein', 253, NULL, NULL, 191339),
(191340, '3.30.750.24-FF-000166', NULL, 'Chemotaxis locus antisigma factor antogonist', 99, NULL, NULL, 191340),
(191341, '2.40.50.90-FF-000013', NULL, 'Tudor domain containing 6', 77, NULL, NULL, 191341),
(191342, '1.20.5.170-FF-000192', NULL, 'RSC chromatin remodeling complex ATPase subunit', 76, NULL, NULL, 191342),
(191343, '3.40.50.2000-FF-001048', NULL, 'Uncharacterized protein', 128, NULL, NULL, 191343),
(191344, '3.30.40.10-FF-001982', NULL, 'Predicted protein', 60, NULL, NULL, 191344),
(191345, '2.40.30.30-FF-000039', NULL, 'Uncharacterized protein', 187, NULL, NULL, 191345),
(191346, '3.30.190.20-FF-000040', NULL, 'Uncharacterized protein', 75, NULL, NULL, 191346),
(191347, '3.30.70.330-FF-001476', NULL, 'Predicted protein', 109, NULL, NULL, 191347),
(191348, '1.25.10.10-FF-003054', NULL, 'Predicted protein', 562, NULL, NULL, 191348),
(191349, '3.30.429.10-FF-000002', NULL, 'Tautomerase', 60, NULL, NULL, 191349),
(191350, '3.30.160.60-FF-004771', NULL, NULL, 80, NULL, NULL, 191350),
(191351, '2.60.40.10-FF-001718', NULL, 'Neuroglian, isoform D', 108, NULL, NULL, 191351),
(191352, '1.10.630.10-FF-000651', NULL, 'Uncharacterized protein', 202, NULL, NULL, 191352),
(191353, '3.90.190.10-FF-000321', NULL, 'Dual specificity protein phosphatase', 180, NULL, NULL, 191353),
(191354, '1.10.600.10-FF-000082', NULL, 'Octaprenyl-diphosphate synthase / Dimethylallyltransferase / Geranyltranstransferase (Farnesyldiphosphate synthase) / Geranylgeranyl pyrophosphate synthetase', 272, NULL, NULL, 191354),
(191355, '1.20.1640.10-FF-000058', NULL, 'PaTched Related family', 221, NULL, NULL, 191355),
(191356, '2.20.70.10-FF-000109', NULL, 'Putative pre-mRNA-processing factor 40', 39, NULL, NULL, 191356),
(191357, '1.25.40.1050-FF-000004', NULL, '5''-3'' exonuclease, putative', 101, NULL, NULL, 191357),
(191358, '1.20.1720.10-FF-000059', NULL, 'Probable transport protein HsrA', 185, NULL, NULL, 191358),
(191359, '2.60.40.150-FF-000053', NULL, 'synaptotagmin-17 isoform X1', 141, NULL, NULL, 191359),
(191360, '4.10.240.10-FF-000160', NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', 69, NULL, NULL, 191360),
(191361, '1.20.120.160-FF-000007', NULL, 'Multistep phosphorelay regulator 1', 133, NULL, NULL, 191361),
(191362, '3.80.10.10-FF-000724', NULL, 'Class II major histocompatibility complex transactivator', 82, NULL, NULL, 191362);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(191363, '1.25.40.10-FF-000768', NULL, 'Pentatricopeptide repeat protein', 102, NULL, NULL, 191363),
(191364, '3.30.559.10-FF-000186', NULL, 'Transferase family protein', 212, NULL, NULL, 191364),
(191365, '1.25.10.10-FF-000199', NULL, 'plakophilin-3', 474, NULL, NULL, 191365),
(191366, '3.30.70.260-FF-000128', NULL, 'D-3-phosphoglycerate dehydrogenase', 74, NULL, NULL, 191366),
(191367, '1.20.5.1500-FF-000009', NULL, 'Uncharacterized protein', 47, NULL, NULL, 191367),
(191368, '3.30.160.60-FF-003343', NULL, 'Zinc finger protein 1053', 27, NULL, NULL, 191368),
(191369, '3.30.200.20-FF-000772', NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 101', 47, NULL, NULL, 191369),
(191370, '3.40.50.11260-FF-000031', NULL, 'Putative heat shock protein HSP 90-beta 4', 116, NULL, NULL, 191370),
(191371, '1.20.200.10-FF-000009', NULL, 'Phenylalanine ammonia-lyase', 327, NULL, NULL, 191371),
(191372, '3.30.2130.30-FF-000016', NULL, 'N2-methylguanosine tRNA methyltransferase', 141, NULL, NULL, 191372),
(191373, '2.130.10.10-FF-001601', NULL, 'GD19179', 199, NULL, NULL, 191373),
(191374, '3.30.70.3290-FF-000010', NULL, 'Aspergillus niger contig An11c0010, genomic contig', 142, NULL, NULL, 191374),
(191375, '1.25.40.10-FF-004242', NULL, 'Signal recognition particle subunit SRP72', 238, NULL, NULL, 191375),
(191376, '3.30.230.10-FF-000271', NULL, 'Mevalonate kinase', 235, NULL, NULL, 191376),
(191377, '1.20.920.20-FF-000022', NULL, 'Dynein_heavy_chain_-_N-terminal_region_2_-_putative', 349, NULL, NULL, 191377),
(191378, '3.30.540.10-FF-000081', NULL, 'Uncharacterized protein', 148, NULL, NULL, 191378),
(191379, '3.80.10.10-FF-002118', NULL, 'Protein CBG11124', 318, NULL, NULL, 191379),
(191380, '3.30.160.20-FF-000212', NULL, 'Double-stranded RNA-specific editase Adar-like Protein', 71, NULL, NULL, 191380),
(191381, '2.60.120.1040-FF-000014', NULL, NULL, 40, NULL, NULL, 191381),
(191382, '3.60.90.10-FF-000022', NULL, 'S-adenosylmethionine decarboxylase proenzyme', 171, NULL, NULL, 191382),
(191383, '3.30.470.20-FF-000022', NULL, 'beta-citrylglutamate synthase B isoform X1', 114, NULL, NULL, 191383),
(191384, '1.20.1250.20-FF-000155', NULL, 'Uncharacterized MFS-type transporter YhhS', 379, NULL, NULL, 191384),
(191385, '1.10.8.10-FF-000040', NULL, 'UBX domain-containing protein 7', 41, NULL, NULL, 191385),
(191386, '3.30.70.330-FF-002465', NULL, NULL, 154, NULL, NULL, 191386),
(191387, '3.30.200.20-FF-002166', NULL, 'Predicted protein', 64, NULL, NULL, 191387),
(191388, '1.10.600.10-FF-000031', NULL, 'Syn-copalyl diphosphate synthase', 151, NULL, NULL, 191388),
(191389, '1.20.930.60-FF-000012', NULL, 'AaceriABR069Wp', 116, NULL, NULL, 191389),
(191390, '3.40.50.360-FF-000006', NULL, 'Flavodoxin', 173, NULL, NULL, 191390),
(191391, '1.20.120.1920-FF-000008', NULL, 'Uncharacterized protein', 116, NULL, NULL, 191391),
(191392, '2.30.29.30-FF-000435', NULL, 'Si:ch211-193c2.2', 101, NULL, NULL, 191392),
(191393, '2.150.10.10-FF-000010', NULL, 'Mannuronan C-5-epimerase', 49, NULL, NULL, 191393),
(191394, '3.40.50.300-FF-003501', NULL, 'Si:dkey-187j14.7', 47, NULL, NULL, 191394),
(191395, '1.10.238.10-FF-001121', NULL, 'Uncharacterized protein', 36, NULL, NULL, 191395),
(191396, '3.40.50.720-FF-001446', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', 119, NULL, NULL, 191396),
(191397, '3.40.50.20-FF-000035', NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', 97, NULL, NULL, 191397),
(191398, '1.25.10.10-FF-002969', NULL, 'Uncharacterized protein', 415, NULL, NULL, 191398),
(191399, '3.90.1750.10-FF-000043', NULL, 'E3 ubiquitin-protein ligase UPL1', 161, NULL, NULL, 191399),
(191400, '3.90.70.200-FF-000018', NULL, 'Uncharacterized protein', 132, NULL, NULL, 191400),
(191401, '3.90.190.10-FF-000372', NULL, 'Dual specificity protein phosphatase, putative', 179, NULL, NULL, 191401),
(191402, '3.30.300.30-FF-000142', NULL, 'Nonribosomal peptide synthase, putative (JCVI)', 122, NULL, NULL, 191402),
(191403, '2.130.10.10-FF-005816', NULL, 'WD repeat protein, putative', 78, NULL, NULL, 191403),
(191404, '2.60.40.10-FF-003714', NULL, NULL, 93, NULL, NULL, 191404);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(191405, '1.10.800.10-FF-000012', NULL, 'Tryptophan hydroxylase 2', 238, NULL, NULL, 191405),
(191406, '2.130.10.10-FF-004395', NULL, 'Uncharacterized protein', 58, NULL, NULL, 191406),
(191407, '2.60.260.20-FF-000109', NULL, 'DnaJ-class molecular chaperone CbpA', 71, NULL, NULL, 191407),
(191408, '1.25.40.720-FF-000015', NULL, 'Uncharacterized protein', 96, NULL, NULL, 191408),
(191409, '3.40.50.300-FF-002596', NULL, 'Putative ras-like small GTPases', 210, NULL, NULL, 191409),
(191410, '2.60.120.10-FF-000440', NULL, 'Predicted protein', 296, NULL, NULL, 191410),
(191411, '3.40.630.10-FF-000355', NULL, 'Protein CBG05160', 167, NULL, NULL, 191411),
(191412, '3.40.50.2000-FF-000643', NULL, 'Putative transferase', 179, NULL, NULL, 191412),
(191413, '3.30.450.20-FF-000060', NULL, 'Sensor protein FixL', 114, NULL, NULL, 191413),
(191414, '3.40.1350.10-FF-000041', NULL, 'tRNA intron endonuclease, catalytic C-terminal domain containing protein', 88, NULL, NULL, 191414),
(191415, '3.30.40.10-FF-001122', NULL, 'E3 ubiquitin-protein ligase SINAT4', 76, NULL, NULL, 191415),
(191416, '3.90.110.10-FF-000041', NULL, NULL, 72, NULL, NULL, 191416),
(191417, '1.20.58.1030-FF-000003', NULL, 'DNA replication complex GINS protein PSF1', 147, NULL, NULL, 191417),
(191418, '1.10.510.10-FF-003019', NULL, NULL, 56, NULL, NULL, 191418),
(191419, '1.10.472.10-FF-000159', NULL, 'G1/S-specific cyclin-E isoform X2', 155, NULL, NULL, 191419),
(191420, '1.25.40.20-FF-000658', NULL, 'Espin-like b', 69, NULL, NULL, 191420),
(191421, '3.30.160.60-FF-001426', NULL, 'zinc finger protein 784', 26, NULL, NULL, 191421),
(191422, '3.40.5.50-FF-000002', NULL, 'DNA replication complex GINS protein PSF2', 36, NULL, NULL, 191422),
(191423, '1.10.10.650-FF-000009', NULL, 'Transcription elongation factor spt6, putative', 163, NULL, NULL, 191423),
(191424, '3.50.50.60-FF-000119', NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', 226, NULL, NULL, 191424),
(191425, '1.20.1560.10-FF-000057', NULL, 'ABC multidrug transporter SitT', 620, NULL, NULL, 191425),
(191426, '2.130.10.10-FF-000292', NULL, 'Lysosomal trafficking regulator', 210, NULL, NULL, 191426),
(191427, '2.60.120.200-FF-000133', NULL, 'nephronectin isoform X1', 164, NULL, NULL, 191427),
(191428, '3.40.50.2300-FF-000582', NULL, 'Autoinducer 2-binding periplasmic protein LuxP', 177, NULL, NULL, 191428),
(191429, '2.30.30.1020-FF-000043', NULL, NULL, 118, NULL, NULL, 191429),
(191430, '3.30.160.330-FF-000001', NULL, 'Protein E7', 56, NULL, NULL, 191430),
(191431, '1.20.1080.10-FF-000094', NULL, 'Uncharacterized protein', 238, NULL, NULL, 191431),
(191432, '3.40.50.2000-FF-001099', NULL, 'Uncharacterized protein', 51, NULL, NULL, 191432),
(191433, '3.40.640.10-FF-000069', NULL, 'Serine decarboxylase 1', 244, NULL, NULL, 191433),
(191434, '1.25.40.10-FF-002797', NULL, 'Intraflagellar transport protein 56 homolog', 98, NULL, NULL, 191434),
(191435, '1.10.10.10-FF-001036', NULL, 'HTH-type transcriptional regulator IlvY', 79, NULL, NULL, 191435),
(191436, '2.60.40.2030-FF-000007', NULL, 'Adhesion G-protein coupled receptor V1', 119, NULL, NULL, 191436),
(191437, '3.40.250.10-FF-000225', NULL, 'Uncharacterized protein', 107, NULL, NULL, 191437),
(191438, '3.10.590.10-FF-000010', NULL, 'thymocyte nuclear protein 1', 53, NULL, NULL, 191438),
(191439, '1.25.40.10-FF-002685', NULL, 'Uncharacterized protein', 153, NULL, NULL, 191439),
(191440, '3.30.450.40-FF-000066', NULL, 'Two-component system sensor histidine kinase KdpD', 143, NULL, NULL, 191440),
(191441, '1.10.510.10-FF-004498', NULL, NULL, 230, NULL, NULL, 191441),
(191442, '3.40.50.300-FF-000207', NULL, 'CTP synthase', 293, NULL, NULL, 191442),
(191443, '3.90.1150.10-FF-000418', NULL, 'Uncharacterized protein', 102, NULL, NULL, 191443),
(191444, '3.30.30.30-FF-000003', NULL, 'Heat shock protein 9', 56, NULL, NULL, 191444),
(191445, '3.40.50.300-FF-003973', NULL, 'MCM3', 288, NULL, NULL, 191445),
(191446, '2.60.40.790-FF-000149', NULL, NULL, 104, NULL, NULL, 191446),
(191447, '2.60.40.10-FF-000729', NULL, 'Down syndrome cell adhesion molecule', 93, NULL, NULL, 191447);
INSERT INTO "PUBLIC"."MODEL" VALUES
(191448, '3.10.110.10-FF-000042', NULL, 'Ubiquitin-fold modifier-conjugating enzyme 1', 167, NULL, NULL, 191448),
(191449, '3.90.70.10-FF-000059', NULL, 'Ubiquitin carboxyl-terminal hydrolase 38', 398, NULL, NULL, 191449),
(191450, '3.90.550.10-FF-000388', NULL, 'LARGE xylosyl- and glucuronyltransferase 1', 155, NULL, NULL, 191450),
(191451, '3.30.9.10-FF-000280', NULL, 'Uncharacterized protein', 59, NULL, NULL, 191451),
(191452, '1.10.238.10-FF-000183', NULL, 'TBC1 domain family member 8B', 244, NULL, NULL, 191452),
(191453, '2.70.150.10-FF-000276', NULL, 'E1-E2 ATPase family protein', 153, NULL, NULL, 191453),
(191454, '3.30.160.360-FF-000009', NULL, 'Histone-lysine N-methyltransferase', 111, NULL, NULL, 191454),
(191455, '3.30.70.330-FF-000048', NULL, 'Heterogeneous nuclear ribonucleoprotein a1 isoform', 91, NULL, NULL, 191455),
(191456, '1.25.10.10-FF-002065', NULL, 'Condensin complex subunit 1', 184, NULL, NULL, 191456),
(191457, '1.20.1070.10-FF-002127', NULL, 'Uncharacterized protein', 279, NULL, NULL, 191457),
(191458, '3.20.20.70-FF-000190', NULL, 'Trans-o-hydroxybenzylidenepyruvate hydratase-aldolase', 312, NULL, NULL, 191458),
(191459, '2.40.50.140-FF-000450', NULL, 'Aspartate--tRNA ligase', 93, NULL, NULL, 191459),
(191460, '3.40.50.1820-FF-000246', NULL, 'Hydrolases, acting on ester bond', 194, NULL, NULL, 191460),
(191461, '2.60.120.260-FF-000483', NULL, 'Uncharacterized protein', 135, NULL, NULL, 191461),
(191462, '1.10.357.10-FF-000088', NULL, 'Transcriptional regulator, putative', 172, NULL, NULL, 191462),
(191463, '3.40.50.300-FF-004962', NULL, 'Protein CBG08054', 197, NULL, NULL, 191463),
(191464, '1.10.238.10-FF-001172', NULL, 'Uncharacterized protein', 95, NULL, NULL, 191464),
(191465, '3.30.60.20-FF-000053', NULL, 'Diacylglycerol kinase', 61, NULL, NULL, 191465),
(191466, '1.25.40.20-FF-000597', NULL, 'Serine/threonine-protein phosphatase 6 regulatory ankyrin repeat subunit A', 92, NULL, NULL, 191466),
(191467, '1.20.120.610-FF-000013', NULL, 'Uncharacterized protein', 93, NULL, NULL, 191467),
(191468, '2.60.40.4060-FF-000004', NULL, 'Fat-spondin', 155, NULL, NULL, 191468),
(191469, '1.25.40.10-FF-001336', NULL, 'AGAP003052-PA', 149, NULL, NULL, 191469),
(191470, '2.30.42.10-FF-000454', NULL, NULL, 98, NULL, NULL, 191470),
(191471, '3.30.530.20-FF-000061', NULL, 'Ribosome association toxin RatA', 142, NULL, NULL, 191471),
(191472, '1.20.58.400-FF-000013', NULL, 'Qb-SNARE_protein_-_putative', 113, NULL, NULL, 191472),
(191473, '3.40.1170.60-FF-000025', NULL, 'Putative DNA polymerase kappa', 52, NULL, NULL, 191473),
(191474, '3.40.50.2300-FF-000531', NULL, 'Sugar ABC transporter, periplasmic sugar-binding protein', 123, NULL, NULL, 191474),
(191475, '3.10.310.10-FF-000023', NULL, 'Proline racemase', 173, NULL, NULL, 191475),
(191476, '3.60.10.10-FF-000422', NULL, 'Predicted protein', 119, NULL, NULL, 191476),
(191477, '3.30.160.60-FF-002775', NULL, 'Uncharacterized protein', 79, NULL, NULL, 191477),
(191478, '1.10.220.150-FF-000018', NULL, 'Arf-GAP domain and FG repeat-containing protein 1', 89, NULL, NULL, 191478),
(191479, '3.20.20.140-FF-000057', NULL, 'Adenosine deaminase', 339, NULL, NULL, 191479),
(191480, '3.30.160.60-FF-005608', NULL, NULL, 102, NULL, NULL, 191480),
(191481, '3.30.40.10-FF-002319', NULL, 'Predicted protein', 103, NULL, NULL, 191481),
(191482, '1.10.10.2250-FF-000001', NULL, 'Chromosome partition protein MukE', 73, NULL, NULL, 191482),
(191483, '1.10.510.10-FF-001272', NULL, 'Protein kinase-like protein', 288, NULL, NULL, 191483),
(191484, '3.40.50.12670-FF-000004', NULL, 'Carboxypeptidase', 162, NULL, NULL, 191484),
(191485, '3.30.160.60-FF-005760', NULL, NULL, 27, NULL, NULL, 191485),
(191486, '1.10.287.70-FF-000634', NULL, 'Uncharacterized protein', 197, NULL, NULL, 191486),
(191487, '2.60.40.10-FF-005260', NULL, NULL, 87, NULL, NULL, 191487),
(191488, '1.10.357.90-FF-000005', NULL, 'Telomerase reverse transcriptase', 189, NULL, NULL, 191488),
(191489, '3.80.10.10-FF-004474', NULL, 'Uncharacterized protein', 225, NULL, NULL, 191489),
(191490, '1.20.1070.10-FF-000380', NULL, 'D(3) dopamine receptor', 130, NULL, NULL, 191490);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(191491, '1.10.4080.10-FF-000006', NULL, 'ADP-ribosylglycohydrolase, putative', 109, NULL, NULL, 191491),
(191492, '2.30.30.30-FF-000129', NULL, 'Uncharacterized protein', 108, NULL, NULL, 191492),
(191493, '2.60.120.740-FF-000025', NULL, 'Uncharacterized protein', 107, NULL, NULL, 191493),
(191494, '3.30.70.330-FF-002414', NULL, NULL, 92, NULL, NULL, 191494),
(191495, '3.20.20.80-FF-000512', NULL, 'Di-N-acetylchitobiase', 206, NULL, NULL, 191495),
(191496, '2.60.120.260-FF-000123', NULL, 'Clan SB, family S8, subtilisin-like serine peptidase', 130, NULL, NULL, 191496),
(191497, '2.60.120.650-FF-000150', NULL, 'Uncharacterized protein', 118, NULL, NULL, 191497),
(191498, '3.20.20.190-FF-000111', NULL, NULL, 150, NULL, NULL, 191498),
(191499, '1.10.150.560-FF-000001', NULL, 'Major DNA-binding protein', 98, NULL, NULL, 191499),
(191500, '3.40.120.10-FF-000064', NULL, 'Putative phosphoglucosamine mutase protein', 110, NULL, NULL, 191500),
(191501, '1.10.4160.10-FF-000007', NULL, 'Pyridoxine transporter', 398, NULL, NULL, 191501),
(191502, '1.10.287.2900-FF-000006', NULL, 'Protein CBG18121', 60, NULL, NULL, 191502),
(191503, '2.130.10.10-FF-005704', NULL, 'Uncharacterized protein', 148, NULL, NULL, 191503),
(191504, '3.90.70.10-FF-000008', NULL, 'Ubiquitin carboxyl-terminal hydrolase 47', 338, NULL, NULL, 191504),
(191505, '2.70.50.40-FF-000008', NULL, 'Unc-119 lipid binding chaperone', 145, NULL, NULL, 191505),
(191506, '3.60.20.10-FF-000248', NULL, NULL, 45, NULL, NULL, 191506),
(191507, '1.10.10.10-FF-001980', NULL, 'Uncharacterized protein', 59, NULL, NULL, 191507),
(191508, '3.30.40.10-FF-000633', NULL, 'Putative BOI-related E3 ubiquitin-protein ligase 2', 63, NULL, NULL, 191508),
(191509, '1.25.40.270-FF-000009', NULL, 'Vacuolar protein sorting-associated protein vts1', 158, NULL, NULL, 191509),
(191510, '3.50.50.60-FF-001108', NULL, 'Ubiquinone monooxygenase, putative', 191, NULL, NULL, 191510),
(191511, '1.20.1070.10-FF-001790', NULL, 'Uncharacterized protein', 323, NULL, NULL, 191511),
(191512, '3.30.310.50-FF-000025', NULL, 'Transcription factor Pcc1, putative', 90, NULL, NULL, 191512),
(191513, '3.80.10.10-FF-002169', NULL, 'Uncharacterized protein', 201, NULL, NULL, 191513),
(191514, '3.60.21.10-FF-000239', NULL, 'Predicted protein', 199, NULL, NULL, 191514),
(191515, '3.40.50.1380-FF-000018', NULL, 'Carbamoyl-phosphate synthase, large subunit', 140, NULL, NULL, 191515),
(191516, '3.40.50.12780-FF-000037', NULL, 'Acyl-CoA synthetase', 298, NULL, NULL, 191516),
(191517, '2.170.210.10-FF-000010', NULL, 'Uncharacterized protein', 120, NULL, NULL, 191517),
(191518, '3.40.190.10-FF-000158', NULL, 'Glutamate receptor', 35, NULL, NULL, 191518),
(191519, '3.40.50.300-FF-003001', NULL, 'Adenylate kinase isoenzyme 6', 176, NULL, NULL, 191519),
(191520, '2.130.10.10-FF-001522', NULL, 'WD domain, G-beta repeat, putative', 89, NULL, NULL, 191520),
(191521, '3.30.60.20-FF-000002', NULL, 'Diacylglycerol kinase', 55, NULL, NULL, 191521),
(191522, '2.40.50.1000-FF-000018', NULL, 'Uncharacterized protein', 83, NULL, NULL, 191522),
(191523, '1.20.5.320-FF-000028', NULL, 'pulmonary surfactant-associated protein A1-like isoform X2', 48, NULL, NULL, 191523),
(191524, '3.30.430.20-FF-000025', NULL, 'Cysteine-rich receptor-like protein kinase 2', 105, NULL, NULL, 191524),
(191525, '1.10.472.80-FF-000039', NULL, 'TBC1 domain family member 25 isoform X1', 122, NULL, NULL, 191525),
(191526, '1.10.533.10-FF-000301', NULL, 'Uncharacterized protein', 71, NULL, NULL, 191526),
(191527, '3.40.50.2000-FF-000559', NULL, 'Alpha,alpha-trehalose-phosphate synthase', 227, NULL, NULL, 191527),
(191528, '3.30.1370.10-FF-000151', NULL, 'Protein CBG06045', 201, NULL, NULL, 191528),
(191529, '2.130.10.10-FF-005024', NULL, 'Uncharacterized protein', 305, NULL, NULL, 191529),
(191530, '3.30.300.30-FF-000081', NULL, 'NRPS-like enzyme, putative', 120, NULL, NULL, 191530),
(191531, '3.90.190.10-FF-000433', NULL, 'Uncharacterized protein', 72, NULL, NULL, 191531),
(191532, '3.40.50.150-FF-001522', NULL, NULL, 105, NULL, NULL, 191532);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(191533, '1.25.10.10-FF-002857', NULL, 'AP complex subunit beta', 167, NULL, NULL, 191533),
(191534, '2.120.10.30-FF-000388', NULL, 'Sortilin', 292, NULL, NULL, 191534),
(191535, '3.60.21.60-FF-000001', NULL, 'DNA polymerase epsilon subunit', 178, NULL, NULL, 191535),
(191536, '2.60.40.10-FF-000881', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', 93, NULL, NULL, 191536),
(191537, '1.10.555.10-FF-000054', NULL, 'Uncharacterized protein, isoform B', 247, NULL, NULL, 191537),
(191538, '3.20.20.190-FF-000162', NULL, NULL, 158, NULL, NULL, 191538),
(191539, '3.80.10.10-FF-001781', NULL, 'Protein CBG00897', 232, NULL, NULL, 191539),
(191540, '2.60.40.10-FF-003343', NULL, 'Immunoglobulin heavy variable 4-31', 106, NULL, NULL, 191540),
(191541, '3.30.70.330-FF-002353', NULL, NULL, 106, NULL, NULL, 191541),
(191542, '2.60.40.1820-FF-000006', NULL, 'Water stress/hypersensitive response protein', 132, NULL, NULL, 191542),
(191543, '3.40.30.10-FF-001104', NULL, 'Predicted protein', 54, NULL, NULL, 191543),
(191544, '3.30.70.260-FF-000067', NULL, 'Prephenate dehydratase', 84, NULL, NULL, 191544),
(191545, '1.25.40.10-FF-001257', NULL, 'Tetratricopeptide repeat-containing protein', 281, NULL, NULL, 191545),
(191546, '1.25.10.10-FF-003425', NULL, 'Uncharacterized protein', 182, NULL, NULL, 191546),
(191547, '3.60.130.10-FF-000060', NULL, 'Gll1897 protein', 286, NULL, NULL, 191547),
(191548, '3.30.200.20-FF-000249', NULL, 'twitchin isoform X2', 128, NULL, NULL, 191548),
(191549, '1.10.730.10-FF-000147', NULL, 'Arginine--tRNA ligase', 118, NULL, NULL, 191549),
(191550, '3.10.20.90-FF-000398', NULL, 'Uncharacterized protein', 124, NULL, NULL, 191550),
(191551, '3.40.50.300-FF-007267', NULL, 'Uncharacterized protein', 156, NULL, NULL, 191551),
(191552, '1.10.3130.10-FF-000005', NULL, 'Serine acetyltransferase 4', 149, NULL, NULL, 191552),
(191553, '1.25.10.10-FF-002565', NULL, 'Uncharacterized protein', 169, NULL, NULL, 191553),
(191554, '1.10.1450.10-FF-000085', NULL, 'Tetraspanin', 85, NULL, NULL, 191554),
(191555, '1.20.1070.10-FF-000441', NULL, 'Olfactory receptor', 258, NULL, NULL, 191555),
(191556, '2.40.50.140-FF-000950', NULL, NULL, 67, NULL, NULL, 191556),
(191557, '2.60.120.10-FF-000389', NULL, 'Acireductone dioxygenase, putative', 83, NULL, NULL, 191557),
(191558, '1.20.58.80-FF-000093', NULL, 'Uncharacterized protein', 64, NULL, NULL, 191558),
(191559, '3.50.30.20-FF-000011', NULL, 'Uncharacterized protein', 165, NULL, NULL, 191559),
(191560, '3.30.160.60-FF-002854', NULL, 'Uncharacterized protein', 28, NULL, NULL, 191560),
(191561, '3.30.70.330-FF-001072', NULL, 'Nucleolin', 155, NULL, NULL, 191561),
(191562, '3.40.50.2300-FF-001099', NULL, NULL, 63, NULL, NULL, 191562),
(191563, '1.25.40.20-FF-001614', NULL, 'Uncharacterized protein', 103, NULL, NULL, 191563),
(191564, '3.80.10.10-FF-001601', NULL, 'CLL1A clavata1-like receptor S/T protein kinase protein', 165, NULL, NULL, 191564),
(191565, '3.30.70.240-FF-000061', NULL, 'Elongation factor G, mitochondrial', 27, NULL, NULL, 191565),
(191566, '3.30.450.200-FF-000011', NULL, 'DENN domain containing protein 2D', 146, NULL, NULL, 191566),
(191567, '3.80.10.10-FF-004535', NULL, 'Putative F-box/LRR-repeat protein 9', 175, NULL, NULL, 191567),
(191568, '2.130.10.10-FF-004748', NULL, 'Uncharacterized protein', 328, NULL, NULL, 191568),
(191569, '1.25.40.90-FF-000005', NULL, 'Clathrin assembly protein AP180', 156, NULL, NULL, 191569),
(191570, '2.60.40.10-FF-003635', NULL, NULL, 77, NULL, NULL, 191570),
(191571, '3.40.50.1910-FF-000009', NULL, 'Sec1 family superfamily', 196, NULL, NULL, 191571),
(191572, '3.40.190.10-FF-000107', NULL, 'Phosphate ABC transporter, phosphate-binding protein', 124, NULL, NULL, 191572),
(191573, '2.60.40.10-FF-003686', NULL, NULL, 54, NULL, NULL, 191573),
(191574, '1.10.287.70-FF-000134', NULL, 'Glutamate receptor, ionotropic kainate', 82, NULL, NULL, 191574),
(191575, '2.60.120.920-FF-000023', NULL, 'Tripartite motif-containing 5 (Predicted)', 201, NULL, NULL, 191575),
(191576, '3.40.50.10190-FF-000171', NULL, 'DNA ligase 3', 104, NULL, NULL, 191576);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(191577, '2.70.98.10-FF-000087', NULL, 'Glycoside hydrolase family 92 protein', 274, NULL, NULL, 191577),
(191578, '1.20.58.60-FF-000727', NULL, 'Uncharacterized protein', 105, NULL, NULL, 191578),
(191579, '2.40.50.100-FF-000106', NULL, 'Carbamoyl-phosphate synthase L chain, ATP-binding', 91, NULL, NULL, 191579),
(191580, '3.30.40.10-FF-000133', NULL, 'E3 ubiquitin-protein ligase RNF123', 58, NULL, NULL, 191580),
(191581, '1.10.533.10-FF-000060', NULL, 'disks large homolog 5 isoform X2', 89, NULL, NULL, 191581),
(191582, '3.30.1490.180-FF-000039', NULL, 'DNA-directed RNA polymerase subunit', 67, NULL, NULL, 191582),
(191583, '3.40.50.2300-FF-000935', NULL, NULL, 180, NULL, NULL, 191583),
(191584, '3.30.70.330-FF-001976', NULL, NULL, 119, NULL, NULL, 191584),
(191585, '3.40.50.12780-FF-000088', NULL, 'Possible o-succinylbenzoic acid--CoA ligase menE', 214, NULL, NULL, 191585),
(191586, '3.40.50.300-FF-005030', NULL, 'Sulfotransferase', 257, NULL, NULL, 191586),
(191587, '3.30.160.60-FF-004299', NULL, NULL, 28, NULL, NULL, 191587),
(191588, '3.40.50.150-FF-001573', NULL, NULL, 58, NULL, NULL, 191588),
(191589, '3.20.20.70-FF-000251', NULL, '2-isopropylmalate synthase', 319, NULL, NULL, 191589),
(191590, '3.30.30.30-FF-000054', NULL, 'Uncharacterized protein', 63, NULL, NULL, 191590),
(191591, '2.60.40.150-FF-000457', NULL, 'RPGR-interacting protein 1', 120, NULL, NULL, 191591),
(191592, '3.40.50.10900-FF-000013', NULL, 'Proteasome assembly chaperone 2', 76, NULL, NULL, 191592),
(191593, '3.40.50.300-FF-002624', NULL, 'YDR336W-like protein', 196, NULL, NULL, 191593),
(191594, '1.10.720.30-FF-000017', NULL, 'heterogeneous nuclear ribonucleoprotein U-like protein 2', 46, NULL, NULL, 191594),
(191595, '3.80.30.20-FF-000032', NULL, 'Uncharacterized protein', 107, NULL, NULL, 191595),
(191596, '3.30.70.660-FF-000012', NULL, 'tRNA pseudouridine synthase', 185, NULL, NULL, 191596),
(191597, '1.20.120.1240-FF-000069', NULL, 'Dynamin-related GTPase', 227, NULL, NULL, 191597),
(191598, '2.20.70.10-FF-000261', NULL, 'Predicted protein', 43, NULL, NULL, 191598),
(191599, '3.40.1190.20-FF-000104', NULL, 'GD12805', 301, NULL, NULL, 191599),
(191600, '2.60.120.290-FF-000019', NULL, 'Adhesion G-protein coupled receptor G6', 110, NULL, NULL, 191600),
(191601, '1.20.120.340-FF-000005', NULL, 'Perilipin', 93, NULL, NULL, 191601),
(191602, '1.10.510.10-FF-002502', NULL, 'Serine/threonine-protein kinase flr-4', 333, NULL, NULL, 191602),
(191603, '1.25.40.20-FF-001665', NULL, 'GH09064p', 83, NULL, NULL, 191603),
(191604, '3.90.70.10-FF-000508', NULL, 'Cathepsin O', 312, NULL, NULL, 191604),
(191605, '3.90.1150.10-FF-000065', NULL, 'Selenocysteine lyase', 106, NULL, NULL, 191605),
(191606, '2.30.30.1190-FF-000015', NULL, 'Zinc finger CCCH domain-containing protein 34 isoform A', 53, NULL, NULL, 191606),
(191607, '3.30.470.20-FF-000090', NULL, 'BnaA09g04240D protein', 137, NULL, NULL, 191607),
(191608, '1.20.58.340-FF-000034', NULL, 'Magnesium and cobalt transport protein', 115, NULL, NULL, 191608),
(191609, '1.10.10.10-FF-000991', NULL, 'Deoxyribonucleoside regulator', 54, NULL, NULL, 191609),
(191610, '2.70.98.30-FF-000014', NULL, 'Alpha-mannosidase', 259, NULL, NULL, 191610),
(191611, '1.20.58.80-FF-000042', NULL, 'BMA-SPAS-1, isoform d', 97, NULL, NULL, 191611),
(191612, '3.10.129.10-FF-000068', NULL, 'Thioesterase superfamily protein', 132, NULL, NULL, 191612),
(191613, '2.60.40.4100-FF-000005', NULL, 'Deleted in malignant brain tumors 1', 152, NULL, NULL, 191613),
(191614, '2.160.20.10-FF-000055', NULL, 'F-box only protein 11', 155, NULL, NULL, 191614),
(191615, '1.10.220.150-FF-000069', NULL, 'Uncharacterized protein', 96, NULL, NULL, 191615),
(191616, '3.40.50.300-FF-001495', NULL, 'ATP-binding cassette protein subfamily G, member 4', 242, NULL, NULL, 191616),
(191617, '1.10.510.10-FF-003930', NULL, NULL, 72, NULL, NULL, 191617),
(191618, '3.40.605.10-FF-000050', NULL, 'Aldehyde dehydrogenase, mitochondrial', 303, NULL, NULL, 191618),
(191619, '3.90.226.10-FF-000039', NULL, 'Propionyl-CoA carboxylase subunit beta 6', 216, NULL, NULL, 191619);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(191620, '3.30.160.60-FF-001786', NULL, 'Zinc finger and SCAN domain containing 10', 39, NULL, NULL, 191620),
(191621, '3.40.50.410-FF-000128', NULL, '26S proteasome regulatory subunit S5A (AFU_orthologue AFUA_2G15070)', 187, NULL, NULL, 191621),
(191622, '3.40.50.2300-FF-000290', NULL, 'Uncharacterized protein', 271, NULL, NULL, 191622),
(191623, '3.30.200.20-FF-001609', NULL, 'Probable receptor-like serine/threonine-protein kinase At4g34500', 101, NULL, NULL, 191623),
(191624, '3.30.160.60-FF-001494', NULL, 'zinc finger protein 10 isoform X2', 31, NULL, NULL, 191624),
(191625, '3.80.10.10-FF-000663', NULL, 'F-box/LRR-repeat protein 4', 95, NULL, NULL, 191625),
(191626, '3.40.50.150-FF-000292', NULL, 'SAM-dependent methyltransferase', 303, NULL, NULL, 191626),
(191627, '3.30.200.20-FF-002245', NULL, 'Uncharacterized protein', 30, NULL, NULL, 191627),
(191628, '1.20.120.1220-FF-000012', NULL, 'Components of type IV pilus, prepilin peptidase', 142, NULL, NULL, 191628),
(191629, '3.80.10.10-FF-000371', NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3', 88, NULL, NULL, 191629),
(191630, '1.10.132.60-FF-000042', NULL, 'DNA polymerase', 111, NULL, NULL, 191630),
(191631, '2.20.100.10-FF-000026', NULL, 'Spondin 1', 49, NULL, NULL, 191631),
(191632, '2.40.37.10-FF-000020', NULL, 'Ornithine decarboxylase', 133, NULL, NULL, 191632),
(191633, '1.25.40.10-FF-003253', NULL, 'Os12g0156900 protein', 166, NULL, NULL, 191633),
(191634, '1.10.630.10-FF-000263', NULL, 'Uncharacterized protein', 514, NULL, NULL, 191634),
(191635, '3.40.850.10-FF-000254', NULL, 'Kinesin-like protein', 341, NULL, NULL, 191635),
(191636, '2.40.70.10-FF-000479', NULL, NULL, 153, NULL, NULL, 191636),
(191637, '3.30.1050.10-FF-000043', NULL, 'Stomatin-like protein 1', 123, NULL, NULL, 191637),
(191638, '3.40.50.150-FF-000112', NULL, 'tRNA (Cytosine-5-)-methyltransferase NCL1', 350, NULL, NULL, 191638),
(191639, '3.30.160.60-FF-002062', NULL, 'Ras-responsive element-binding protein 1 isoform B', 37, NULL, NULL, 191639),
(191640, '1.10.1370.10-FF-000028', NULL, 'Si:ch73-1a9.4', 153, NULL, NULL, 191640),
(191641, '3.90.470.10-FF-000011', NULL, '50S ribosomal protein L22', 113, NULL, NULL, 191641),
(191642, '1.25.40.10-FF-005147', NULL, 'Clathrin and VPS domain-containing protein', 96, NULL, NULL, 191642),
(191643, '3.60.40.10-FF-000250', NULL, 'Chromosome 1, whole genome shotgun sequence', 232, NULL, NULL, 191643),
(191644, '3.40.1410.10-FF-000012', NULL, 'GntR family transcriptional regulator', 168, NULL, NULL, 191644),
(191645, '2.30.180.10-FF-000192', NULL, NULL, 210, NULL, NULL, 191645),
(191646, '3.30.565.10-FF-000048', NULL, 'Two-component system sensor histidine kinase PmrB', 143, NULL, NULL, 191646),
(191647, '3.40.1190.20-FF-000155', NULL, 'Hypothetical sugar kinase', 296, NULL, NULL, 191647),
(191648, '3.40.140.10-FF-000155', NULL, 'Predicted protein', 162, NULL, NULL, 191648),
(191649, '2.60.120.200-FF-000212', NULL, 'Axotactin, isoform B', 192, NULL, NULL, 191649),
(191650, '2.60.120.260-FF-000191', NULL, 'Putative wall-associated protein', 167, NULL, NULL, 191650),
(191651, '3.60.110.10-FF-000025', NULL, 'N-carbamoylputrescine amidase', 287, NULL, NULL, 191651),
(191652, '3.30.40.10-FF-000925', NULL, 'Zinc finger protein, putative', 82, NULL, NULL, 191652),
(191653, '1.20.1250.20-FF-000604', NULL, 'MFS transporter', 381, NULL, NULL, 191653),
(191654, '1.10.287.110-FF-000096', NULL, 'DnaJ domain protein', 81, NULL, NULL, 191654),
(191655, '2.130.10.10-FF-002950', NULL, 'Uncharacterized protein', 271, NULL, NULL, 191655),
(191656, '3.30.70.60-FF-000043', NULL, '30S ribosomal protein S6', 91, NULL, NULL, 191656),
(191657, '1.10.10.10-FF-001328', NULL, 'Meiotic recombination protein spo-11', 113, NULL, NULL, 191657),
(191658, '3.40.50.720-FF-002014', NULL, 'Uncharacterized protein', 215, NULL, NULL, 191658),
(191659, '3.30.160.60-FF-006165', NULL, NULL, 77, NULL, NULL, 191659),
(191660, '3.55.40.20-FF-000001', NULL, 'Superoxide dismutase', 113, NULL, NULL, 191660),
(191661, '3.30.200.20-FF-001969', NULL, 'Tyrosine-protein kinase receptor', 103, NULL, NULL, 191661);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(191662, '1.10.238.10-FF-001060', NULL, 'Reticulocalbin, putative', 154, NULL, NULL, 191662),
(191663, '3.30.40.10-FF-002027', NULL, 'Chromosome 15, whole genome shotgun sequence', 145, NULL, NULL, 191663),
(191664, '3.40.50.1820-FF-000538', NULL, 'Carboxylic ester hydrolase', 468, NULL, NULL, 191664),
(191665, '2.60.40.60-FF-000019', NULL, 'Cadherin 2', 117, NULL, NULL, 191665),
(191666, '2.20.25.10-FF-000134', NULL, 'Predicted protein', 43, NULL, NULL, 191666),
(191667, '3.30.450.70-FF-000013', NULL, 'TRAPP complex subunit, variant', 148, NULL, NULL, 191667),
(191668, '3.40.50.10190-FF-000019', NULL, 'BRCA1 associated RING domain 1', 100, NULL, NULL, 191668),
(191669, '2.60.120.470-FF-000017', NULL, NULL, 68, NULL, NULL, 191669),
(191670, '3.80.10.10-FF-000320', NULL, 'Protein phosphatase 1 regulatory subunit pprA', 182, NULL, NULL, 191670),
(191671, '2.30.30.40-FF-000458', NULL, 'Uncharacterized protein', 54, NULL, NULL, 191671),
(191672, '2.60.120.10-FF-000001', NULL, 'cAMP-activated global transcriptional regulator CRP', 132, NULL, NULL, 191672),
(191673, '3.60.10.10-FF-000034', NULL, 'Exodeoxyribonuclease III', 250, NULL, NULL, 191673),
(191674, '2.130.10.10-FF-003107', NULL, 'Predicted protein', 382, NULL, NULL, 191674),
(191675, '1.10.238.10-FF-001088', NULL, 'Phosphoinositide phospholipase C', 81, NULL, NULL, 191675),
(191676, '2.40.37.10-FF-000071', NULL, NULL, 116, NULL, NULL, 191676),
(191677, '2.130.10.10-FF-000645', NULL, 'Putative nuclear pore complex subunit Nup159', 435, NULL, NULL, 191677),
(191678, '3.30.9.10-FF-000049', NULL, 'Glycine oxidase ThiO', 150, NULL, NULL, 191678),
(191679, '2.40.30.110-FF-000015', NULL, 'N,N-dimethylglycine oxidase, putative', 78, NULL, NULL, 191679),
(191680, '1.10.600.10-FF-000143', NULL, 'Uncharacterized protein', 127, NULL, NULL, 191680),
(191681, '2.170.16.10-FF-000016', NULL, 'GRounDhog (Hedgehog-like family)', 151, NULL, NULL, 191681),
(191682, '2.60.220.50-FF-000049', NULL, 'Latrophilin, putative', 37, NULL, NULL, 191682),
(191683, '3.30.160.60-FF-000033', NULL, 'Immunodeficiency virus type I enhancer binding protein 1', 30, NULL, NULL, 191683),
(191684, '3.90.550.10-FF-000012', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 379, NULL, NULL, 191684),
(191685, '3.20.20.80-FF-000580', NULL, 'Uncharacterized protein', 268, NULL, NULL, 191685),
(191686, '3.60.110.10-FF-000076', NULL, NULL, 284, NULL, NULL, 191686),
(191687, '1.20.120.1240-FF-000018', NULL, 'Dynamin-related protein 3A', 119, NULL, NULL, 191687),
(191688, '1.20.1250.20-FF-000655', NULL, 'Integral membrane protein', 397, NULL, NULL, 191688),
(191689, '3.30.160.60-FF-002803', NULL, NULL, 64, NULL, NULL, 191689),
(191690, '1.20.1280.290-FF-000038', NULL, 'PQ loop repeat containing 2', 104, NULL, NULL, 191690),
(191691, '2.130.10.10-FF-005412', NULL, 'Mitochondrial division protein 1', 231, NULL, NULL, 191691),
(191692, '2.60.40.10-FF-004703', NULL, NULL, 98, NULL, NULL, 191692),
(191693, '3.40.50.300-FF-003905', NULL, 'ABC-2 type transport system ATP-binding protein', 229, NULL, NULL, 191693),
(191694, '2.130.10.10-FF-005316', NULL, 'Uncharacterized protein', 203, NULL, NULL, 191694),
(191695, '1.20.58.150-FF-000016', NULL, NULL, 128, NULL, NULL, 191695),
(191696, '3.40.30.10-FF-000699', NULL, 'thioredoxin-like protein AAED1 isoform X3', 114, NULL, NULL, 191696),
(191697, '3.40.50.300-FF-006727', NULL, 'Predicted protein', 72, NULL, NULL, 191697),
(191698, '2.170.300.10-FF-000068', NULL, 'Uncharacterized protein', 82, NULL, NULL, 191698),
(191699, '1.10.1410.10-FF-000088', NULL, 'Poly(A) polymerase alpha', 104, NULL, NULL, 191699),
(191700, '3.30.70.2000-FF-000005', NULL, 'Inso-1', 57, NULL, NULL, 191700),
(191701, '1.10.720.30-FF-000068', NULL, 'Uncharacterized protein', 61, NULL, NULL, 191701),
(191702, '2.60.200.10-FF-000002', NULL, 'Mothers against decapentaplegic homolog', 236, NULL, NULL, 191702),
(191703, '1.20.1250.20-FF-001144', NULL, 'Drug resistance transporter, EmrB/QacA subfamily', 194, NULL, NULL, 191703),
(191704, '1.20.1740.10-FF-000234', NULL, 'Predicted protein', 408, NULL, NULL, 191704);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(191705, '1.25.10.10-FF-003133', NULL, 'Uncharacterized protein', 125, NULL, NULL, 191705),
(191706, '1.50.40.10-FF-000204', NULL, 'Peroxisomal nicotinamide adenine dinucleotide carrier', 305, NULL, NULL, 191706),
(191707, '1.10.472.10-FF-000390', NULL, 'Cyclin B3', 14, NULL, NULL, 191707),
(191708, '3.40.50.300-FF-007216', NULL, 'Uncharacterized protein C2F7.09c', 164, NULL, NULL, 191708),
(191709, '3.40.50.720-FF-001789', NULL, 'Siroheme synthase', 131, NULL, NULL, 191709),
(191710, '1.20.120.1880-FF-000007', NULL, 'Similar to non-repetitive nucleoporin', 228, NULL, NULL, 191710),
(191711, '3.40.50.360-FF-000118', NULL, 'Flavo-diiron protein FprA2', 149, NULL, NULL, 191711),
(191712, '1.10.510.10-FF-001333', NULL, 'CAMK family protein kinase', 309, NULL, NULL, 191712),
(191713, '1.20.120.310-FF-000013', NULL, 'Sulfhydryl oxidase', 173, NULL, NULL, 191713),
(191714, '2.10.110.10-FF-000080', NULL, 'actin-binding LIM protein 1 isoform X6', 67, NULL, NULL, 191714),
(191715, '3.40.50.300-FF-003405', NULL, 'RecBCD enzyme subunit RecD', 194, NULL, NULL, 191715),
(191716, '2.180.10.10-FF-000031', NULL, 'Uncharacterized protein', 519, NULL, NULL, 191716),
(191717, '2.30.30.190-FF-000036', NULL, NULL, 63, NULL, NULL, 191717),
(191718, '3.30.60.90-FF-000034', NULL, 'Transcriptional adapter 2-alpha', 73, NULL, NULL, 191718),
(191719, '2.60.120.200-FF-000712', NULL, 'Predicted protein', 179, NULL, NULL, 191719),
(191720, '1.20.120.790-FF-000022', NULL, 'Putative heat shock protein HSP 90-beta 2', 65, NULL, NULL, 191720),
(191721, '3.40.50.2300-FF-000082', NULL, 'ABC transporter periplasmic-binding protein ytfQ', 114, NULL, NULL, 191721),
(191722, '1.50.10.130-FF-000002', NULL, 'Ent-copalyl diphosphate synthase, chloroplastic', 226, NULL, NULL, 191722),
(191723, '3.30.70.330-FF-001184', NULL, 'RNA recognition motif domain containing protein', 140, NULL, NULL, 191723),
(191724, '3.40.50.1580-FF-000045', NULL, '5''-methylthioadenosine/S-adenosylhomocysteine nucleosidase', 215, NULL, NULL, 191724),
(191725, '3.30.830.10-FF-000069', NULL, 'A-factor processing enzyme, putative', 232, NULL, NULL, 191725),
(191726, '2.10.25.10-FF-001051', NULL, 'Uncharacterized protein', 46, NULL, NULL, 191726),
(191727, '3.40.50.620-FF-000106', NULL, 'Glutamine-dependent NAD(+) synthetase', 252, NULL, NULL, 191727),
(191728, '3.40.50.410-FF-000336', NULL, 'Fibronectin binding protein', 154, NULL, NULL, 191728),
(191729, '3.40.50.1400-FF-000031', NULL, 'Sirohydrochlorin cobaltochelatase CbiKP', 130, NULL, NULL, 191729),
(191730, '1.10.510.10-FF-003519', NULL, NULL, 246, NULL, NULL, 191730),
(191731, '1.20.120.330-FF-000019', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 143, NULL, NULL, 191731),
(191732, '3.40.50.410-FF-000280', NULL, 'Uncharacterized protein', 49, NULL, NULL, 191732),
(191733, '3.30.60.30-FF-000123', NULL, 'GM10857', 66, NULL, NULL, 191733),
(191734, '3.30.450.20-FF-000088', NULL, 'Sensory transduction histidine kinase', 70, NULL, NULL, 191734),
(191735, '3.30.497.10-FF-000182', NULL, 'Serpin-Z1', 111, NULL, NULL, 191735),
(191736, '3.40.50.1110-FF-000101', NULL, 'Uncharacterized protein', 211, NULL, NULL, 191736),
(191737, '3.30.70.980-FF-000018', NULL, 'DUF28 domain protein', 76, NULL, NULL, 191737),
(191738, '1.20.58.390-FF-000116', NULL, 'Gamma-aminobutyric acid type A receptor beta2 subunit', 84, NULL, NULL, 191738),
(191739, '1.25.40.570-FF-000009', NULL, '26S proteasome non-ATPase regulatory subunit 3', 129, NULL, NULL, 191739),
(191740, '2.40.50.90-FF-000193', NULL, 'Uncharacterized protein', 57, NULL, NULL, 191740),
(191741, '6.10.140.2220-FF-000010', NULL, 'Ankyrin repeat and MYND domain-containing protein 2', 48, NULL, NULL, 191741),
(191742, '2.40.50.140-FF-000039', NULL, '30S ribosomal protein S1', 81, NULL, NULL, 191742),
(191743, '3.40.225.10-FF-000032', NULL, NULL, 221, NULL, NULL, 191743),
(191744, '3.40.140.10-FF-000104', NULL, 'Nuclear protein localization, putative', 198, NULL, NULL, 191744),
(191745, '2.130.10.10-FF-003967', NULL, 'Uncharacterized protein', 238, NULL, NULL, 191745);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(191746, '1.10.240.10-FF-000008', NULL, 'Tyrosine--tRNA ligase', 115, NULL, NULL, 191746),
(191747, '3.30.40.10-FF-001690', NULL, 'Regulator Ustilago maydis 1 protein (Rum1)', 70, NULL, NULL, 191747),
(191748, '1.20.1560.10-FF-000580', NULL, 'ABC transporter NFT1', 288, NULL, NULL, 191748),
(191749, '1.20.1070.10-FF-000621', NULL, 'Predicted protein', 297, NULL, NULL, 191749),
(191750, '1.10.510.10-FF-003481', NULL, NULL, 267, NULL, NULL, 191750),
(191751, '1.20.5.110-FF-000134', NULL, 'Sporulation-specific protein 20', 68, NULL, NULL, 191751),
(191752, '3.80.10.10-FF-000820', NULL, 'slit homolog 2 protein isoform X1', 188, NULL, NULL, 191752),
(191753, '2.60.40.640-FF-000104', NULL, 'Protein ttm-2', 145, NULL, NULL, 191753),
(191754, '2.60.40.1180-FF-000213', NULL, 'Maltase-glucoamylase', 45, NULL, NULL, 191754),
(191755, '3.40.50.150-FF-000741', NULL, 'rRNA adenine N(6)-methyltransferase', 199, NULL, NULL, 191755),
(191756, '1.25.40.20-FF-001726', NULL, 'Uncharacterized protein', 226, NULL, NULL, 191756),
(191757, '1.10.510.10-FF-004470', NULL, NULL, 270, NULL, NULL, 191757),
(191758, '1.10.10.10-FF-002093', NULL, 'Uncharacterized protein', 58, NULL, NULL, 191758),
(191759, '3.90.650.10-FF-000008', NULL, 'Phosphoribosylformylglycinamidine synthase', 177, NULL, NULL, 191759),
(191760, '4.10.60.10-FF-000172', NULL, 'Zf-CCHC type zinc finger protein', 49, NULL, NULL, 191760),
(191761, '2.60.40.10-FF-005552', NULL, NULL, 115, NULL, NULL, 191761),
(191762, '3.40.50.300-FF-006486', NULL, 'Uncharacterized protein', 115, NULL, NULL, 191762),
(191763, '1.20.1530.20-FF-000058', NULL, 'Na(+)/H(+) antiporter', 385, NULL, NULL, 191763),
(191764, '4.10.800.20-FF-000009', NULL, 'AMP deaminase, putative', 96, NULL, NULL, 191764),
(191765, '1.25.40.20-FF-001086', NULL, 'Kinase, NEK', 102, NULL, NULL, 191765),
(191766, '2.10.110.10-FF-000118', NULL, 'protein-methionine sulfoxide oxidase Mical isoform X4', 76, NULL, NULL, 191766),
(191767, '2.40.160.210-FF-000031', NULL, 'Uncharacterized protein', 56, NULL, NULL, 191767),
(191768, '1.20.120.1750-FF-000047', NULL, 'RBR-type E3 ubiquitin transferase', 70, NULL, NULL, 191768),
(191769, '3.40.50.620-FF-000157', NULL, 'Electron transfer flavoprotein subunit alpha, mitochondrial', 196, NULL, NULL, 191769),
(191770, '3.30.70.330-FF-002173', NULL, NULL, 84, NULL, NULL, 191770),
(191771, '3.30.160.60-FF-005029', NULL, NULL, 30, NULL, NULL, 191771),
(191772, '1.25.70.10-FF-000028', NULL, 'Os04g0637500 protein', 201, NULL, NULL, 191772),
(191773, '3.40.720.10-FF-000250', NULL, 'Predicted protein', 99, NULL, NULL, 191773),
(191774, '1.10.8.10-FF-000332', NULL, 'Uncharacterized protein', 42, NULL, NULL, 191774),
(191775, '1.10.150.240-FF-000091', NULL, 'HAD family hydrolase', 82, NULL, NULL, 191775),
(191776, '3.30.160.60-FF-000937', NULL, 'PR domain zinc finger protein 15', 27, NULL, NULL, 191776),
(191777, '3.30.1490.80-FF-000006', NULL, 'Glutathione synthetase', 40, NULL, NULL, 191777),
(191778, '3.90.190.10-FF-000080', NULL, 'Receptor-type tyrosine-protein phosphatase mu', 291, NULL, NULL, 191778),
(191779, '1.20.58.1970-FF-000010', NULL, 'Conserved oligomeric Golgi complex subunit 4', 159, NULL, NULL, 191779),
(191780, '3.40.50.11350-FF-000002', NULL, 'GDP-fucose protein O-fucosyltransferase 2', 172, NULL, NULL, 191780),
(191781, '2.40.10.10-FF-000099', NULL, 'Kallikrein related-peptidase 10', 117, NULL, NULL, 191781),
(191782, '1.10.730.10-FF-000068', NULL, 'Methionyl-tRNA synthetase', 131, NULL, NULL, 191782),
(191783, '1.20.1070.10-FF-001610', NULL, 'Predicted protein', 149, NULL, NULL, 191783),
(191784, '3.40.350.10-FF-000081', NULL, 'Os11g0539800 protein', 135, NULL, NULL, 191784),
(191785, '3.40.640.10-FF-000148', NULL, 'Arginine decarboxylase', 278, NULL, NULL, 191785),
(191786, '2.60.260.20-FF-000099', NULL, 'Chaperone protein DnaJ', 72, NULL, NULL, 191786),
(191787, '1.10.1040.10-FF-000099', NULL, 'Ketol-acid reductoisomerase chloroplastic', 142, NULL, NULL, 191787),
(191788, '3.20.20.140-FF-000169', NULL, 'Histidinol-phosphatase', 276, NULL, NULL, 191788);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(191789, '3.80.10.10-FF-000432', NULL, 'Uncharacterized protein, isoform A', 190, NULL, NULL, 191789),
(191790, '3.40.640.10-FF-000480', NULL, 'Uncharacterized protein', 68, NULL, NULL, 191790),
(191791, '3.40.710.10-FF-000064', NULL, 'Penicillin-binding protein 2', 370, NULL, NULL, 191791),
(191792, '3.40.50.720-FF-001738', NULL, 'FAD dependent oxidoreductase', 166, NULL, NULL, 191792),
(191793, '1.25.40.10-FF-001780', NULL, 'Pentatricopeptide repeat-containing protein At4g30825, chloroplastic', 135, NULL, NULL, 191793),
(191794, '3.40.50.300-FF-002888', NULL, 'ras-related protein RABH1e isoform X2', 199, NULL, NULL, 191794),
(191795, '2.130.10.10-FF-002539', NULL, 'Chromosome 7, whole genome shotgun sequence', 107, NULL, NULL, 191795),
(191796, '3.90.25.10-FF-000084', NULL, 'Chromosome 10, whole genome shotgun sequence', 85, NULL, NULL, 191796),
(191797, '1.20.140.100-FF-000016', NULL, 'Ciliary dynein heavy chain 11', 162, NULL, NULL, 191797),
(191798, '3.40.50.720-FF-001890', NULL, 'Pyrroline-5-carboxylate reductase', 157, NULL, NULL, 191798),
(191799, '1.20.900.10-FF-000023', NULL, 'dynamin-binding protein isoform X2', 221, NULL, NULL, 191799),
(191800, '3.20.20.80-FF-000428', NULL, 'Uncharacterized protein', 266, NULL, NULL, 191800),
(191801, '3.30.930.10-FF-000341', NULL, 'Uncharacterized protein', 86, NULL, NULL, 191801),
(191802, '3.30.70.330-FF-002914', NULL, NULL, 130, NULL, NULL, 191802),
(191803, '3.40.630.30-FF-000069', NULL, 'GNAT family acetyltransferase', 170, NULL, NULL, 191803),
(191804, '3.50.80.10-FF-000005', NULL, 'D-aminoacyl-tRNA deacylase', 149, NULL, NULL, 191804),
(191805, '2.130.10.10-FF-004687', NULL, 'Uncharacterized protein', 177, NULL, NULL, 191805),
(191806, '1.25.40.10-FF-003814', NULL, 'Uncharacterized protein', 134, NULL, NULL, 191806),
(191807, '3.30.420.40-FF-000761', NULL, 'Uncharacterized protein', 97, NULL, NULL, 191807),
(191808, '3.30.710.10-FF-000297', NULL, 'Uncharacterized protein', 146, NULL, NULL, 191808),
(191809, '1.10.3370.10-FF-000051', NULL, 'Uncharacterized protein C19G7.17', 464, NULL, NULL, 191809),
(191810, '3.20.20.100-FF-000005', NULL, 'NADP(H)-dependent aldo-keto reductase', 346, NULL, NULL, 191810),
(191811, '2.130.10.10-FF-005524', NULL, 'Predicted protein', 46, NULL, NULL, 191811),
(191812, '3.40.1090.10-FF-000150', NULL, 'Predicted protein', 86, NULL, NULL, 191812),
(191813, '3.30.1330.40-FF-000040', NULL, 'Diphthine--ammonia ligase', 120, NULL, NULL, 191813),
(191814, '2.40.160.50-FF-000037', NULL, 'Sorting and assembly machinery component 50 homolog', 98, NULL, NULL, 191814),
(191815, '3.40.50.12710-FF-000005', NULL, 'Protein arginine methyltransferase NDUFAF7', 390, NULL, NULL, 191815),
(191816, '2.130.10.10-FF-005204', NULL, 'Uncharacterized protein', 100, NULL, NULL, 191816),
(191817, '2.30.29.30-FF-000727', NULL, 'Uncharacterized protein', 108, NULL, NULL, 191817),
(191818, '1.25.40.10-FF-000088', NULL, 'Clustered mitochondria (CluA/CLU1) homolog', 264, NULL, NULL, 191818),
(191819, '2.80.10.50-FF-000143', NULL, 'Pierisin', 137, NULL, NULL, 191819),
(191820, '3.10.20.90-FF-000038', NULL, 'Rap guanine nucleotide exchange factor 4', 93, NULL, NULL, 191820),
(191821, '3.40.50.300-FF-001264', NULL, 'Formate--tetrahydrofolate ligase', 190, NULL, NULL, 191821),
(191822, '1.25.40.10-FF-000476', NULL, 'Bud site selection protein', 670, NULL, NULL, 191822),
(191823, '3.30.700.20-FF-000001', NULL, 'AMME syndrome candidate gene 1', 106, NULL, NULL, 191823),
(191824, '1.10.530.10-FF-000087', NULL, 'Alpha lactabumin', 52, NULL, NULL, 191824),
(191825, '3.30.40.10-FF-002139', NULL, 'RBR-type E3 ubiquitin transferase', 85, NULL, NULL, 191825),
(191826, '1.10.418.10-FF-000101', NULL, 'Transgelin', 149, NULL, NULL, 191826),
(191827, '3.30.420.10-FF-000550', NULL, NULL, 67, NULL, NULL, 191827),
(191828, '2.130.10.10-FF-003490', NULL, 'Putative neurobeachin homolog', 282, NULL, NULL, 191828),
(191829, '2.60.220.50-FF-000150', NULL, 'Predicted protein', 218, NULL, NULL, 191829),
(191830, '3.30.70.960-FF-000012', NULL, 'MUC16 isoform 1', 100, NULL, NULL, 191830);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(191831, '3.20.70.20-FF-000020', NULL, 'Choline trimethylamine-lyase', 804, NULL, NULL, 191831),
(191832, '3.30.200.20-FF-001789', NULL, 'Myosin heavy chain kinase B', 70, NULL, NULL, 191832),
(191833, '3.40.50.2300-FF-001548', NULL, NULL, 27, NULL, NULL, 191833),
(191834, '3.30.70.100-FF-000160', NULL, NULL, 71, NULL, NULL, 191834),
(191835, '3.40.850.10-FF-000074', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', 373, NULL, NULL, 191835),
(191836, '3.40.50.300-FF-004069', NULL, 'GM13326', 159, NULL, NULL, 191836),
(191837, '2.40.50.140-FF-000270', NULL, 'Conserved membrane protein of uncharacterized function', 62, NULL, NULL, 191837),
(191838, '3.40.50.2300-FF-001020', NULL, NULL, 187, NULL, NULL, 191838),
(191839, '2.130.10.10-FF-003338', NULL, 'Myosin heavy chain kinase B', 159, NULL, NULL, 191839),
(191840, '1.20.1250.20-FF-000076', NULL, 'Nucleoside transporter YegT', 193, NULL, NULL, 191840),
(191841, '1.10.630.10-FF-000151', NULL, 'Cytochrome P450-like', 196, NULL, NULL, 191841),
(191842, '3.40.1500.10-FF-000019', NULL, 'Uncharacterized protein', 172, NULL, NULL, 191842),
(191843, '1.10.472.140-FF-000004', NULL, 'RB transcriptional corepressor like 2', 97, NULL, NULL, 191843),
(191844, '3.40.50.2000-FF-000935', NULL, 'Uncharacterized protein', 146, NULL, NULL, 191844),
(191845, '3.30.40.10-FF-000846', NULL, 'Ring-box protein, putative', 93, NULL, NULL, 191845),
(191846, '1.10.150.50-FF-000002', NULL, 'PTPRF interacting protein alpha 1', 80, NULL, NULL, 191846),
(191847, '3.30.70.120-FF-000042', NULL, NULL, 100, NULL, NULL, 191847),
(191848, '1.25.40.10-FF-005259', NULL, 'Chaperone protein DNAJ, putative', 157, NULL, NULL, 191848),
(191849, '3.40.50.1000-FF-000568', NULL, NULL, 47, NULL, NULL, 191849),
(191850, '1.20.1070.10-FF-002066', NULL, 'Uncharacterized protein', 77, NULL, NULL, 191850),
(191851, '3.30.200.20-FF-001677', NULL, 'Cell division control protein 2-like 2 isoform A', 79, NULL, NULL, 191851),
(191852, '3.30.160.60-FF-006457', NULL, NULL, 37, NULL, NULL, 191852),
(191853, '1.10.472.80-FF-000011', NULL, 'TBC1 domain family member 30', 159, NULL, NULL, 191853),
(191854, '2.60.40.10-FF-004771', NULL, NULL, 94, NULL, NULL, 191854),
(191855, '3.20.20.370-FF-000013', NULL, 'Carbohydrate degradation protein', 198, NULL, NULL, 191855),
(191856, '4.10.520.10-FF-000030', NULL, NULL, 91, NULL, NULL, 191856),
(191857, '3.10.105.10-FF-000120', NULL, 'Maltose ABC transporter, maltose binding protein', 263, NULL, NULL, 191857),
(191858, '1.25.40.10-FF-004803', NULL, 'Pentatricopeptide repeat-containing protein At5g13270, chloroplastic', 165, NULL, NULL, 191858),
(191859, '2.60.40.10-FF-001005', NULL, 'Beta-2-microglobulin', 99, NULL, NULL, 191859),
(191860, '3.30.450.20-FF-000431', NULL, 'Uncharacterized protein', 43, NULL, NULL, 191860),
(191861, '1.20.120.850-FF-000001', NULL, 'transcriptional regulator ATRX isoform X1', 71, NULL, NULL, 191861),
(191862, '1.10.238.10-FF-000896', NULL, 'Uncharacterized protein', 146, NULL, NULL, 191862),
(191863, '2.60.40.3620-FF-000001', NULL, NULL, 115, NULL, NULL, 191863),
(191864, '1.10.287.110-FF-000388', NULL, 'Uncharacterized protein', 81, NULL, NULL, 191864),
(191865, '2.60.120.780-FF-000009', NULL, 'Protein inhibitor of activated STAT', 156, NULL, NULL, 191865),
(191866, '3.40.30.10-FF-001155', NULL, 'Uncharacterized protein', 14, NULL, NULL, 191866),
(191867, '3.10.20.90-FF-000370', NULL, 'Autophagy protein 5', 150, NULL, NULL, 191867),
(191868, '3.20.20.70-FF-000594', NULL, NULL, 124, NULL, NULL, 191868),
(191869, '3.40.20.10-FF-000081', NULL, 'Uncharacterized protein', 131, NULL, NULL, 191869),
(191870, '1.25.40.10-FF-003966', NULL, 'Os01g0686600 protein', 240, NULL, NULL, 191870),
(191871, '3.30.56.30-FF-000012', NULL, 'Signal recognition particle 19 kDa protein', 123, NULL, NULL, 191871),
(191872, '2.60.40.150-FF-000396', NULL, 'SYTF', 132, NULL, NULL, 191872),
(191873, '1.20.870.10-FF-000020', NULL, 'Cell division control protein 25', 179, NULL, NULL, 191873),
(191874, '1.10.150.670-FF-000034', NULL, 'Crossover junction endonuclease mus81', 79, NULL, NULL, 191874);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(191875, '3.30.460.10-FF-000024', NULL, 'Nucleotidyltransferase family protein isoform 2', 111, NULL, NULL, 191875),
(191876, '2.40.70.10-FF-000428', NULL, NULL, 159, NULL, NULL, 191876),
(191877, '3.30.160.60-FF-004248', NULL, NULL, 26, NULL, NULL, 191877),
(191878, '1.10.238.20-FF-000017', NULL, 'Odorant-binding protein 59a', 103, NULL, NULL, 191878),
(191879, '3.50.50.60-FF-000771', NULL, 'Predicted protein', 30, NULL, NULL, 191879),
(191880, '2.10.25.10-FF-000275', NULL, 'usherin', 53, NULL, NULL, 191880),
(191881, '3.30.160.60-FF-006277', NULL, NULL, 52, NULL, NULL, 191881),
(191882, '3.40.50.450-FF-000033', NULL, 'CRE-OLRN-1 protein', 147, NULL, NULL, 191882),
(191883, '3.40.50.300-FF-006278', NULL, 'Uncharacterized protein', 122, NULL, NULL, 191883),
(191884, '1.10.437.10-FF-000061', NULL, 'Uncharacterized protein', 176, NULL, NULL, 191884),
(191885, '1.25.40.90-FF-000073', NULL, 'I/LWEQ domain-containing protein', 117, NULL, NULL, 191885),
(191886, '3.30.160.60-FF-003051', NULL, 'Molting defective, isoform F', 71, NULL, NULL, 191886),
(191887, '3.80.10.10-FF-000612', NULL, 'Uncharacterized protein, isoform B', 222, NULL, NULL, 191887),
(191888, '1.10.575.10-FF-000016', NULL, 'Uncharacterized protein', 276, NULL, NULL, 191888),
(191889, '3.40.910.10-FF-000012', NULL, 'Probable deoxyhypusine synthase', 314, NULL, NULL, 191889),
(191890, '3.40.50.150-FF-001197', NULL, NULL, 115, NULL, NULL, 191890),
(191891, '1.10.630.10-FF-000712', NULL, 'Uncharacterized protein', 116, NULL, NULL, 191891),
(191892, '1.10.8.60-FF-000190', NULL, 'DNA clamp loader, putative', 99, NULL, NULL, 191892),
(191893, '3.40.50.300-FF-003052', NULL, 'Polynucleotide 5''-hydroxyl-kinase nol-9', 216, NULL, NULL, 191893),
(191894, '3.10.350.10-FF-000065', NULL, 'LysM peptidoglycan-binding domain-containing protein', 44, NULL, NULL, 191894),
(191895, '1.20.1560.10-FF-000428', NULL, 'Multidrug resistance protein ABC transporter family', 144, NULL, NULL, 191895),
(191896, '3.30.530.20-FF-000089', NULL, 'Protein CBG16522', 139, NULL, NULL, 191896),
(191897, '1.10.8.60-FF-000038', NULL, 'spermatogenesis-associated protein 5-like protein 1', 87, NULL, NULL, 191897),
(191898, '2.10.25.10-FF-001635', NULL, 'Uncharacterized protein', 49, NULL, NULL, 191898),
(191899, '1.50.40.10-FF-000176', NULL, 'TPC1p Mitochondrial membrane transporter', 304, NULL, NULL, 191899),
(191900, '1.20.90.10-FF-000006', NULL, 'Otoconin-90', 122, NULL, NULL, 191900),
(191901, '3.40.50.10090-FF-000028', NULL, 'Related to HEM4-Uroporphyrinogen III synthase', 14, NULL, NULL, 191901),
(191902, '2.30.30.140-FF-000167', NULL, 'MBD-R2', 74, NULL, NULL, 191902),
(191903, '3.40.50.300-FF-005761', NULL, 'Uncharacterized protein', 120, NULL, NULL, 191903),
(191904, '3.40.630.10-FF-000243', NULL, 'DNPEP isoform 10', 102, NULL, NULL, 191904),
(191905, '3.40.50.720-FF-001558', NULL, 'Short chain dehydrogenase', 251, NULL, NULL, 191905),
(191906, '1.25.10.10-FF-002626', NULL, 'Huntingtin', 129, NULL, NULL, 191906),
(191907, '1.10.30.10-FF-000082', NULL, 'Mitochondrial transcription factor A, isoform B', 110, NULL, NULL, 191907),
(191908, '3.40.30.10-FF-000727', NULL, 'Iodothyronine deiodinase', 125, NULL, NULL, 191908),
(191909, '2.30.30.380-FF-000059', NULL, 'Protein transport protein SEC23', 60, NULL, NULL, 191909),
(191910, '2.60.40.650-FF-000012', NULL, 'Sulfite oxidase, mitochondrial', 126, NULL, NULL, 191910),
(191911, '2.60.210.10-FF-000059', NULL, NULL, 115, NULL, NULL, 191911),
(191912, '2.70.170.10-FF-000159', NULL, 'Transmembrane ion channel', 223, NULL, NULL, 191912),
(191913, '3.90.1150.10-FF-000014', NULL, 'Probable glycine dehydrogenase (decarboxylating) subunit 2', 128, NULL, NULL, 191913),
(191914, '1.20.58.60-FF-000227', NULL, 'Karst, isoform C', 101, NULL, NULL, 191914),
(191915, '2.40.10.10-FF-000442', NULL, NULL, 241, NULL, NULL, 191915),
(191916, '1.20.1250.20-FF-001436', NULL, 'Similar to Na+ dependent glucose transporter 1 (Predicted)', 134, NULL, NULL, 191916),
(191917, '2.60.40.790-FF-000121', NULL, NULL, 49, NULL, NULL, 191917),
(191918, '3.30.1240.10-FF-000046', NULL, 'Cof-type HAD-IIB family hydrolase', 106, NULL, NULL, 191918);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(191919, '1.25.40.10-FF-003702', NULL, 'Pentatricopeptide repeat-containing protein At5g64320, mitochondrial', 71, NULL, NULL, 191919),
(191920, '1.10.510.10-FF-002682', NULL, NULL, 104, NULL, NULL, 191920),
(191921, '2.30.30.100-FF-000003', NULL, 'U6 snRNA-associated Sm-like protein LSm5', 76, NULL, NULL, 191921),
(191922, '1.25.10.10-FF-000592', NULL, 'Coatomer subunit beta', 612, NULL, NULL, 191922),
(191923, '3.40.50.300-FF-003613', NULL, 'Hypothetical ABC transporter ATP-binding protein ybiT', 229, NULL, NULL, 191923),
(191924, '3.40.50.300-FF-005822', NULL, 'ATP-dependent DNA helicase RecQ', 204, NULL, NULL, 191924),
(191925, '3.40.50.150-FF-001073', NULL, NULL, 241, NULL, NULL, 191925),
(191926, '3.30.70.330-FF-001925', NULL, NULL, 147, NULL, NULL, 191926),
(191927, '1.25.10.10-FF-001952', NULL, 'WD domain, G-beta repeat/PFU (PLAA family ubiquitin binding), putative', 274, NULL, NULL, 191927),
(191928, '1.20.120.350-FF-000177', NULL, NULL, 175, NULL, NULL, 191928),
(191929, '1.25.10.10-FF-001216', NULL, 'Serine/threonine-protein kinase TOR', 171, NULL, NULL, 191929),
(191930, '3.50.50.60-FF-000619', NULL, 'FAD/NAD(P)-binding domain-containing protein', 261, NULL, NULL, 191930),
(191931, '2.60.120.200-FF-000504', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1', 182, NULL, NULL, 191931),
(191932, '2.60.40.10-FF-001269', NULL, 'Sallimus, isoform P', 99, NULL, NULL, 191932),
(191933, '1.10.510.10-FF-000996', NULL, 'Protein kinase superfamily protein', 220, NULL, NULL, 191933),
(191934, '1.10.287.110-FF-000449', NULL, 'Uncharacterized protein', 123, NULL, NULL, 191934),
(191935, '4.10.60.10-FF-000228', NULL, 'Uncharacterized protein', 37, NULL, NULL, 191935),
(191936, '3.90.1640.10-FF-000001', NULL, 'Probable manganese-dependent inorganic pyrophosphatase', 185, NULL, NULL, 191936),
(191937, '1.10.8.100-FF-000010', NULL, 'Ribosomal RNA small subunit methyltransferase A', 68, NULL, NULL, 191937),
(191938, '1.10.630.10-FF-000471', NULL, 'Cytochrome P450, putative', 105, NULL, NULL, 191938),
(191939, '1.10.132.50-FF-000005', NULL, 'V-type proton ATPase subunit', 116, NULL, NULL, 191939),
(191940, '3.40.50.11500-FF-000036', NULL, NULL, 108, NULL, NULL, 191940),
(191941, '3.30.230.80-FF-000016', NULL, 'Heat shock protein 92', 172, NULL, NULL, 191941),
(191942, '3.30.200.20-FF-002397', NULL, 'Phosphoacetylglucosamine mutase', 94, NULL, NULL, 191942),
(191943, '3.30.2040.10-FF-000003', NULL, 'D-glutamate cyclase', 70, NULL, NULL, 191943),
(191944, '2.40.100.10-FF-000100', NULL, 'Peptidyl-prolyl cis-trans isomerase', 161, NULL, NULL, 191944),
(191945, '2.60.120.200-FF-000780', NULL, 'Galectin', 149, NULL, NULL, 191945),
(191946, '2.60.120.920-FF-000074', NULL, 'Neuralized protein 2', 201, NULL, NULL, 191946),
(191947, '3.30.70.1730-FF-000025', NULL, 'Uncharacterized protein', 85, NULL, NULL, 191947),
(191948, '1.10.8.10-FF-000271', NULL, 'YALI0B12408p', 73, NULL, NULL, 191948),
(191949, '2.40.50.140-FF-000118', NULL, 'NfeD family protein', 57, NULL, NULL, 191949),
(191950, '1.20.930.10-FF-000019', NULL, 'mediator of RNA polymerase II transcription subunit 26 isoform X2', 67, NULL, NULL, 191950),
(191951, '3.40.50.300-FF-003529', NULL, 'NLR family member X1 isoform X2', 122, NULL, NULL, 191951),
(191952, '1.10.10.1830-FF-000004', NULL, 'Non-ribosomal peptide synthetase OfaC', 54, NULL, NULL, 191952),
(191953, '2.60.40.10-FF-001505', NULL, 'Titin novex-3', 86, NULL, NULL, 191953),
(191954, '1.10.10.60-FF-000522', NULL, 'HTH-type transcriptional regulator', 110, NULL, NULL, 191954),
(191955, '1.10.510.10-FF-001513', NULL, 'Protein kinase, putative', 306, NULL, NULL, 191955),
(191956, '1.10.10.60-FF-000281', NULL, 'DNA-3-methyladenine glycosylase 2', 107, NULL, NULL, 191956),
(191957, '1.25.40.20-FF-001906', NULL, 'Predicted protein', 80, NULL, NULL, 191957),
(191958, '2.120.10.30-FF-000500', NULL, 'Uncharacterized protein', 221, NULL, NULL, 191958),
(191959, '1.25.10.10-FF-002273', NULL, 'Uncharacterized protein', 339, NULL, NULL, 191959),
(191960, '1.20.1050.120-FF-000003', NULL, NULL, 118, NULL, NULL, 191960);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(191961, '2.30.30.1150-FF-000003', NULL, 'PHD transcription factor Rum1', 97, NULL, NULL, 191961),
(191962, '3.90.550.10-FF-000416', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 358, NULL, NULL, 191962),
(191963, '3.30.160.60-FF-005260', NULL, NULL, 32, NULL, NULL, 191963),
(191964, '2.10.50.10-FF-000075', NULL, 'Neurotrophin receptor associated death domain', 44, NULL, NULL, 191964),
(191965, '2.40.50.140-FF-000793', NULL, NULL, 116, NULL, NULL, 191965),
(191966, '1.20.1070.10-FF-001346', NULL, 'Predicted protein', 271, NULL, NULL, 191966),
(191967, '1.25.40.470-FF-000036', NULL, 'Elongator complex protein 1', 166, NULL, NULL, 191967),
(191968, '1.25.40.10-FF-003461', NULL, 'Os11g0587100 protein', 108, NULL, NULL, 191968),
(191969, '3.30.160.60-FF-004984', NULL, NULL, 83, NULL, NULL, 191969),
(191970, '4.10.280.110-FF-000027', NULL, NULL, 62, NULL, NULL, 191970),
(191971, '3.30.420.510-FF-000019', NULL, 'Fumble, isoform F', 96, NULL, NULL, 191971),
(191972, '1.20.58.390-FF-000184', NULL, 'Uncharacterized protein', 101, NULL, NULL, 191972),
(191973, '3.40.50.1820-FF-001331', NULL, 'AB hydrolase superfamily protein C4A8.06c', 254, NULL, NULL, 191973),
(191974, '3.40.50.800-FF-000003', NULL, 'Threonine--tRNA ligase 2, cytoplasmic', 112, NULL, NULL, 191974),
(191975, '2.130.10.10-FF-001814', NULL, 'LLGL1, scribble cell polarity complex component', 107, NULL, NULL, 191975),
(191976, '3.40.50.410-FF-000212', NULL, 'Putative KU70 protein', 197, NULL, NULL, 191976),
(191977, '2.40.50.90-FF-000081', NULL, 'Staphylococcal_nuclease_homologue /Tudor_domain_containing_protein_-_putative', 157, NULL, NULL, 191977),
(191978, '3.40.50.1820-FF-000038', NULL, '2-succinyl-6-hydroxy-2,4-cyclohexadiene-1-carboxylate synthase', 252, NULL, NULL, 191978),
(191979, '1.25.40.10-FF-001549', NULL, 'Pentatricopeptide repeat-containing protein At3g21470', 152, NULL, NULL, 191979),
(191980, '3.30.428.10-FF-000039', NULL, 'DUF4931 domain-containing protein', 105, NULL, NULL, 191980),
(191981, '3.30.1680.10-FF-000017', NULL, 'Semaphorin 7A', 57, NULL, NULL, 191981),
(191982, '1.25.70.10-FF-000096', NULL, NULL, 84, NULL, NULL, 191982),
(191983, '2.130.10.10-FF-000853', NULL, 'WD repeat-containing protein RUP2', 342, NULL, NULL, 191983),
(191984, '3.40.50.300-FF-000590', NULL, 'Ribosome biogenesis GTPase A', 168, NULL, NULL, 191984),
(191985, '1.10.510.10-FF-000496', NULL, 'Calcium/calmodulin-regulated receptor-like kinase 2', 209, NULL, NULL, 191985),
(191986, '3.40.50.150-FF-001281', NULL, NULL, 222, NULL, NULL, 191986),
(191987, '1.20.1050.10-FF-000086', NULL, 'Glutathione S-transferase', 120, NULL, NULL, 191987),
(191988, '3.40.1110.10-FF-000208', NULL, 'Calcium-transporting ATPase', 151, NULL, NULL, 191988),
(191989, '2.10.50.30-FF-000002', NULL, 'Vomeronasal 2 receptor, h1', 79, NULL, NULL, 191989),
(191990, '1.20.1730.10-FF-000065', NULL, 'Similar to solute carrier family 5 (Sodium/glucose cotransporter), member 1', 176, NULL, NULL, 191990),
(191991, '3.40.50.1820-FF-000426', NULL, 'PS-10 peptidase S37', 208, NULL, NULL, 191991),
(191992, '3.40.50.2300-FF-000643', NULL, 'Response regulator receiver domain-containing protein', 138, NULL, NULL, 191992),
(191993, '3.30.870.10-FF-000066', NULL, 'Tyrosyl-DNA phosphodiesterase, putative', 179, NULL, NULL, 191993),
(191994, '1.10.287.130-FF-000214', NULL, 'Histidine kinase', 61, NULL, NULL, 191994),
(191995, '2.60.40.10-FF-002354', NULL, 'Protein-tyrosine-phosphatase', 93, NULL, NULL, 191995),
(191996, '1.10.287.310-FF-000004', NULL, '50S ribosomal protein L29, chloroplastic', 66, NULL, NULL, 191996),
(191997, '2.30.42.10-FF-000634', NULL, NULL, 66, NULL, NULL, 191997),
(191998, '1.10.150.240-FF-000023', NULL, 'Uncharacterized protein', 67, NULL, NULL, 191998),
(191999, '2.130.10.10-FF-000533', NULL, 'Receptor for activated C kinase 1', 175, NULL, NULL, 191999),
(192000, '2.102.10.10-FF-000012', NULL, '3-ketosteroid-9-alpha-hydroxylase oxygenase subunit', 135, NULL, NULL, 192000),
(192001, '1.10.287.70-FF-000426', NULL, 'Uncharacterized protein', 99, NULL, NULL, 192001);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(192002, '3.10.200.10-FF-000021', NULL, NULL, 92, NULL, NULL, 192002),
(192003, '3.30.230.70-FF-000070', NULL, 'Exosome-associated protein 2, putative', 299, NULL, NULL, 192003),
(192004, '3.30.310.80-FF-000017', NULL, 'Non-specific serine/threonine protein kinase', 133, NULL, NULL, 192004),
(192005, '3.20.20.100-FF-000073', NULL, 'Prostaglandin f synthase. putative', 276, NULL, NULL, 192005),
(192006, '3.40.309.10-FF-000070', NULL, '2-aminomuconic acid semialdehyde dehydrogenase', 62, NULL, NULL, 192006),
(192007, '1.20.144.10-FF-000075', NULL, 'Putative integral membrane protein', 93, NULL, NULL, 192007),
(192008, '2.10.25.10-FF-000511', NULL, 'protein crumbs isoform X1', 40, NULL, NULL, 192008),
(192009, '1.20.58.60-FF-000435', NULL, 'AGAP009554-PA', 217, NULL, NULL, 192009),
(192010, '3.90.1150.10-FF-000357', NULL, 'DegT/DnrJ/EryC1/StrS family aminotransferase', 122, NULL, NULL, 192010),
(192011, '3.40.50.720-FF-000541', NULL, 'D-3-phosphoglycerate dehydrogenase', 85, NULL, NULL, 192011),
(192012, '1.10.238.10-FF-000003', NULL, 'Calmodulin A', 148, NULL, NULL, 192012),
(192013, '3.40.50.1470-FF-000012', NULL, 'Uncharacterized protein', 198, NULL, NULL, 192013),
(192014, '1.10.10.10-FF-000468', NULL, 'Uncharacterized protein, isoform B', 102, NULL, NULL, 192014),
(192015, '1.10.238.10-FF-000632', NULL, 'Uncharacterized protein', 68, NULL, NULL, 192015),
(192016, '1.10.400.10-FF-000083', NULL, 'Guanine nucleotide-binding protein (G protein), alpha 15 (Gq class), tandem duplicate 3', 41, NULL, NULL, 192016),
(192017, '2.40.420.20-FF-000032', NULL, 'Putative periplasmic linker protein', 102, NULL, NULL, 192017),
(192018, '2.40.70.10-FF-000507', NULL, NULL, 99, NULL, NULL, 192018),
(192019, '3.40.50.300-FF-006839', NULL, 'Gll3884 protein', 264, NULL, NULL, 192019),
(192020, '3.40.630.70-FF-000002', NULL, 'Leu/Phe-tRNA protein transferase', 176, NULL, NULL, 192020),
(192021, '2.60.40.150-FF-000749', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit, putative', 84, NULL, NULL, 192021),
(192022, '2.30.29.30-FF-000204', NULL, 'kinesin-like protein unc-104 isoform X6', 111, NULL, NULL, 192022),
(192023, '3.30.497.10-FF-000114', NULL, 'Angiotensinogen', 206, NULL, NULL, 192023),
(192024, '3.80.10.10-FF-002057', NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3', 97, NULL, NULL, 192024),
(192025, '3.40.50.1820-FF-001595', NULL, 'Uncharacterized esterase/lipase C417.12', 502, NULL, NULL, 192025),
(192026, '1.10.510.10-FF-002053', NULL, 'STE20-related kinase adapter protein strd-1', 313, NULL, NULL, 192026),
(192027, '3.30.160.60-FF-001718', NULL, 'Zinc finger and SCAN domain containing 5A', 30, NULL, NULL, 192027),
(192028, '2.60.40.10-FF-002697', NULL, 'High Incidence of Males (Increased X chromosome loss)', 96, NULL, NULL, 192028),
(192029, '1.20.1560.10-FF-000349', NULL, 'Uncharacterized protein', 326, NULL, NULL, 192029),
(192030, '1.10.1050.10-FF-000004', NULL, '30S ribosomal protein S4', 103, NULL, NULL, 192030),
(192031, '3.90.550.50-FF-000237', NULL, 'Uncharacterized protein', 238, NULL, NULL, 192031),
(192032, '3.40.50.80-FF-000007', NULL, 'Respiratory burst oxidase protein A', 197, NULL, NULL, 192032),
(192033, '1.10.3730.20-FF-000071', NULL, 'Uncharacterized protein', 74, NULL, NULL, 192033),
(192034, '1.25.40.10-FF-000829', NULL, 'Bardet-Biedl syndrome 4 protein homolog', 199, NULL, NULL, 192034),
(192035, '1.10.3860.10-FF-000015', NULL, 'Dicarboxylate/amino acid:cation symporter', 420, NULL, NULL, 192035),
(192036, '2.60.40.10-FF-002915', NULL, 'Uncharacterized protein', 78, NULL, NULL, 192036),
(192037, '3.80.10.10-FF-001337', NULL, 'Leucine-rich repeat protein (LRRP), putative', 101, NULL, NULL, 192037),
(192038, '3.10.129.10-FF-000129', NULL, 'PaaI family thioesterase', 146, NULL, NULL, 192038),
(192039, '3.40.80.10-FF-000034', NULL, 'Uncharacterized protein', 121, NULL, NULL, 192039),
(192040, '3.30.160.60-FF-005108', NULL, NULL, 31, NULL, NULL, 192040),
(192041, '3.30.40.10-FF-001302', NULL, 'Uncharacterized protein', 79, NULL, NULL, 192041),
(192042, '3.30.830.10-FF-000277', NULL, 'AGR251Cp', 224, NULL, NULL, 192042);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(192043, '3.30.160.150-FF-000003', NULL, 'LPS-assembly lipoprotein LptE', 166, NULL, NULL, 192043),
(192044, '3.10.120.10-FF-000020', NULL, 'Cytochrome b5-related protein', 80, NULL, NULL, 192044),
(192045, '1.25.40.10-FF-005091', NULL, 'Pentatricopeptide repeat-containing protein At3g26540', 72, NULL, NULL, 192045),
(192046, '3.20.20.80-FF-000187', NULL, 'Alpha-1,4-glucan:maltose-1-phosphate maltosyltransferase', 371, NULL, NULL, 192046),
(192047, '2.60.40.10-FF-003135', NULL, NULL, 101, NULL, NULL, 192047),
(192048, '3.40.50.300-FF-008352', NULL, 'Predicted protein', 240, NULL, NULL, 192048),
(192049, '3.30.342.10-FF-000031', NULL, 'Putative DNA polymerase zeta catalytic subunit', 135, NULL, NULL, 192049),
(192050, '1.25.40.10-FF-001105', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 133, NULL, NULL, 192050),
(192051, '2.10.80.10-FF-000015', NULL, 'dickkopf-related protein 3', 98, NULL, NULL, 192051),
(192052, '3.90.320.10-FF-000028', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 147, NULL, NULL, 192052),
(192053, '1.20.1250.20-FF-000716', NULL, 'Unplaced genomic scaffold supercont1.182, whole genome shotgun sequence', 462, NULL, NULL, 192053),
(192054, '3.30.40.10-FF-001190', NULL, 'Uncharacterized protein', 71, NULL, NULL, 192054),
(192055, '3.60.40.10-FF-000362', NULL, 'Predicted protein', 287, NULL, NULL, 192055),
(192056, '1.20.1070.10-FF-001689', NULL, 'Uncharacterized protein', 112, NULL, NULL, 192056),
(192057, '3.30.450.20-FF-000352', NULL, 'Uncharacterized protein', 99, NULL, NULL, 192057),
(192058, '3.30.450.40-FF-000178', NULL, 'IclR family transcriptional regulator', 177, NULL, NULL, 192058),
(192059, '1.10.10.60-FF-001186', NULL, NULL, 94, NULL, NULL, 192059),
(192060, '3.30.930.10-FF-000280', NULL, 'Alanine--tRNA ligase, mitochondrial', 239, NULL, NULL, 192060),
(192061, '3.30.200.20-FF-000952', NULL, 'Putative DUF26-domain protein kinase', 112, NULL, NULL, 192061),
(192062, '3.40.50.1820-FF-001674', NULL, 'Predicted protein', 252, NULL, NULL, 192062),
(192063, '2.40.30.170-FF-000005', NULL, 'UPF0194 membrane protein YbhG', 110, NULL, NULL, 192063),
(192064, '3.30.300.20-FF-000044', NULL, 'Osmotically inducible protein C', 147, NULL, NULL, 192064),
(192065, '2.10.90.10-FF-000173', NULL, 'Predicted protein', 48, NULL, NULL, 192065),
(192066, '3.40.50.2300-FF-000823', NULL, NULL, 145, NULL, NULL, 192066),
(192067, '1.20.1630.10-FF-000001', NULL, 'Formate-dependent nitrite reductase subunit NrfD', 301, NULL, NULL, 192067),
(192068, '2.60.120.260-FF-000415', NULL, 'Alpha-N-arabinofuranosidase 1', 139, NULL, NULL, 192068),
(192069, '3.30.710.10-FF-000358', NULL, 'Protein CBG25600', 129, NULL, NULL, 192069),
(192070, '2.70.150.10-FF-000164', NULL, 'Heavy metal translocating P-type ATPase', 111, NULL, NULL, 192070),
(192071, '3.30.70.330-FF-001689', NULL, NULL, 79, NULL, NULL, 192071),
(192072, '2.130.10.10-FF-001197', NULL, 'WD repeat domain 60', 293, NULL, NULL, 192072),
(192073, '3.30.160.60-FF-003231', NULL, 'GD20654', 65, NULL, NULL, 192073),
(192074, '3.30.160.60-FF-000437', NULL, 'zinc finger and BTB domain-containing protein 38', 31, NULL, NULL, 192074),
(192075, '2.60.40.1510-FF-000037', NULL, 'Integrin beta-7', 128, NULL, NULL, 192075),
(192076, '3.40.1180.10-FF-000033', NULL, 'Isoprenyl transferase', 243, NULL, NULL, 192076),
(192077, '3.20.20.300-FF-000032', NULL, 'uncharacterized protein LOC100182860 isoform X3', 330, NULL, NULL, 192077),
(192078, '3.80.10.10-FF-002618', NULL, 'Leucine-rich repeat and death domain-containing protein 1', 207, NULL, NULL, 192078),
(192079, '2.60.40.10-FF-005159', NULL, NULL, 95, NULL, NULL, 192079),
(192080, '3.90.1170.10-FF-000009', NULL, '50S ribosomal protein L16', 124, NULL, NULL, 192080),
(192081, '1.25.40.10-FF-004871', NULL, 'Uncharacterized protein', 110, NULL, NULL, 192081),
(192082, '2.20.25.20-FF-000019', NULL, 'E3 ubiquitin-protein ligase parkin', 35, NULL, NULL, 192082),
(192083, '3.80.10.10-FF-004086', NULL, 'Probable serine/threonine-protein kinase roco11', 125, NULL, NULL, 192083);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(192084, '3.40.50.720-FF-001946', NULL, 'Uncharacterized protein', 266, NULL, NULL, 192084),
(192085, '1.25.40.20-FF-001165', NULL, 'Zygote-specific protein 3', 124, NULL, NULL, 192085),
(192086, '3.30.499.10-FF-000017', NULL, 'Aconitate hydratase', 171, NULL, NULL, 192086),
(192087, '3.30.40.10-FF-000341', NULL, 'FYVE and coiled-coil domain containing 1', 83, NULL, NULL, 192087),
(192088, '1.20.1740.10-FF-000173', NULL, 'Amino acid transporter (Eurofung)', 172, NULL, NULL, 192088),
(192089, '1.20.1270.380-FF-000001', NULL, 'Macrodomain Ter protein', 89, NULL, NULL, 192089),
(192090, '3.40.50.150-FF-001129', NULL, NULL, 202, NULL, NULL, 192090),
(192091, '2.60.120.620-FF-000102', NULL, '2OG-Fe(II) oxygenase family protein', 186, NULL, NULL, 192091),
(192092, '3.40.50.150-FF-001461', NULL, NULL, 138, NULL, NULL, 192092),
(192093, '2.60.120.330-FF-000060', NULL, 'Os01g0830500 protein', 271, NULL, NULL, 192093),
(192094, '1.10.238.10-FF-000975', NULL, 'Uncharacterized protein', 74, NULL, NULL, 192094),
(192095, '2.30.29.30-FF-001396', NULL, 'Uncharacterized protein', 95, NULL, NULL, 192095),
(192096, '1.10.260.40-FF-000058', NULL, 'Multiprotein-bridging factor 1', 91, NULL, NULL, 192096),
(192097, '3.30.70.330-FF-002706', NULL, NULL, 163, NULL, NULL, 192097),
(192098, '2.60.40.60-FF-000542', NULL, 'Cadherin 17, LI cadherin (liver-intestine)', 105, NULL, NULL, 192098),
(192099, '1.25.40.20-FF-000889', NULL, 'Uncharacterized protein', 79, NULL, NULL, 192099),
(192100, '3.10.450.50-FF-000017', NULL, 'UBP3-associated protein BRE5', 147, NULL, NULL, 192100),
(192101, '2.60.40.10-FF-005491', NULL, NULL, 96, NULL, NULL, 192101),
(192102, '2.60.40.10-FF-000488', NULL, 'receptor-type tyrosine-protein phosphatase O isoform X1', 94, NULL, NULL, 192102),
(192103, '3.20.20.80-FF-000804', NULL, 'Uncharacterized protein', 128, NULL, NULL, 192103),
(192104, '1.20.58.1880-FF-000016', NULL, 'Myb family transcription factor', 122, NULL, NULL, 192104),
(192105, '1.10.10.60-FF-001062', NULL, NULL, 37, NULL, NULL, 192105),
(192106, '3.50.50.60-FF-000850', NULL, 'YALI0C14806p', 259, NULL, NULL, 192106),
(192107, '2.130.10.10-FF-001073', NULL, 'Protein HIR', 117, NULL, NULL, 192107),
(192108, '3.40.50.300-FF-003681', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 185, NULL, NULL, 192108),
(192109, '2.10.25.10-FF-001556', NULL, 'Notch receptor 3', 62, NULL, NULL, 192109),
(192110, '3.30.70.20-FF-000059', NULL, 'Respiratory nitrate reductase beta subunit', 84, NULL, NULL, 192110),
(192111, '3.90.1290.10-FF-000075', NULL, 'Si:ch211-157f15.1 protein', 118, NULL, NULL, 192111),
(192112, '1.25.40.10-FF-000268', NULL, 'Formate-dependent nitrite reductase complex subunit nrfG', 143, NULL, NULL, 192112),
(192113, '3.40.850.10-FF-000462', NULL, 'Uncharacterized protein', 373, NULL, NULL, 192113),
(192114, '3.40.50.300-FF-002388', NULL, 'Polyphosphate:NDP phosphotransferase 2', 271, NULL, NULL, 192114),
(192115, '2.30.30.40-FF-000519', NULL, 'Uncharacterized protein', 82, NULL, NULL, 192115),
(192116, '1.20.1050.10-FF-000266', NULL, 'Uncharacterized protein', 154, NULL, NULL, 192116),
(192117, '3.40.1190.20-FF-000216', NULL, NULL, 276, NULL, NULL, 192117),
(192118, '3.40.50.1220-FF-000134', NULL, 'Thiamine diphosphate dependent-3-acetyloctanal synthase PigD', 82, NULL, NULL, 192118),
(192119, '3.30.160.60-FF-001994', NULL, 'Tramtrack, isoform A', 68, NULL, NULL, 192119),
(192120, '3.40.1280.10-FF-000097', NULL, 'Uncharacterized protein', 185, NULL, NULL, 192120),
(192121, '1.10.287.570-FF-000003', NULL, 'Anion exchange family protein', 41, NULL, NULL, 192121),
(192122, '3.40.50.261-FF-000039', NULL, 'Succinyl-CoA synthetase subunit alpha', 150, NULL, NULL, 192122),
(192123, '3.90.1150.50-FF-000003', NULL, 'Transcription-repair-coupling factor', 116, NULL, NULL, 192123),
(192124, '3.90.1200.10-FF-000070', NULL, 'RE24176p', 173, NULL, NULL, 192124),
(192125, '3.30.40.10-FF-000402', NULL, 'TRAF-type zinc finger domain-containing protein 1', 57, NULL, NULL, 192125),
(192126, '1.25.40.20-FF-000866', NULL, 'Transient receptor potential cation channel subfamily A member 1', 76, NULL, NULL, 192126);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(192127, '1.25.40.20-FF-001434', NULL, 'Uncharacterized protein', 163, NULL, NULL, 192127),
(192128, '3.10.450.240-FF-000011', NULL, 'Mitochondrial import inner membrane translocase subunit TIM44', 187, NULL, NULL, 192128),
(192129, '3.40.50.880-FF-000100', NULL, 'Anthranilate synthase component I', 191, NULL, NULL, 192129),
(192130, '2.120.10.30-FF-000264', NULL, 'Serine/threonine protein kinase, putative', 200, NULL, NULL, 192130),
(192131, '1.20.920.30-FF-000064', NULL, 'Uncharacterized protein', 122, NULL, NULL, 192131),
(192132, '3.30.70.330-FF-000380', NULL, 'Serine/arginine-rich splicing factor 4 isoform X1', 53, NULL, NULL, 192132),
(192133, '3.30.160.60-FF-001106', NULL, 'zinc finger and BTB domain-containing protein 8B', 52, NULL, NULL, 192133),
(192134, '1.10.510.10-FF-001041', NULL, 'Cdc15p', 312, NULL, NULL, 192134),
(192135, '2.60.120.1030-FF-000005', NULL, 'mRNA cleavage and polyadenylation factor CLP1', 74, NULL, NULL, 192135),
(192136, '3.30.40.10-FF-000346', NULL, 'TNF receptor-associated factor', 54, NULL, NULL, 192136),
(192137, '2.130.10.30-FF-000016', NULL, 'E3 ubiquitin-protein ligase MYCBP2 isoform X2', 285, NULL, NULL, 192137),
(192138, '3.10.490.20-FF-000011', NULL, 'Dynein heavy chain, putative', 136, NULL, NULL, 192138),
(192139, '3.90.1600.10-FF-000055', NULL, 'DNA polymerase zeta catalytic subunit', 176, NULL, NULL, 192139),
(192140, '3.80.10.10-FF-003810', NULL, 'RNI-like superfamily protein', 84, NULL, NULL, 192140),
(192141, '3.30.950.10-FF-000011', NULL, 'S-adenosylmethionine-dependent methyltransferase, YraL family', 118, NULL, NULL, 192141),
(192142, '3.30.70.270-FF-000188', NULL, NULL, 122, NULL, NULL, 192142),
(192143, '1.25.40.20-FF-001378', NULL, 'Predicted protein', 79, NULL, NULL, 192143),
(192144, '2.40.50.140-FF-001282', NULL, NULL, 132, NULL, NULL, 192144),
(192145, '3.90.1100.10-FF-000011', NULL, 'DNA-directed RNA polymerase subunit beta', 193, NULL, NULL, 192145),
(192146, '3.30.930.10-FF-000004', NULL, 'Alanine--tRNA ligase', 242, NULL, NULL, 192146),
(192147, '3.40.50.300-FF-005261', NULL, 'AIG1 family protein, putative', 185, NULL, NULL, 192147),
(192148, '3.30.70.1230-FF-000145', NULL, 'Adenylate cyclase, aggregation specific', 207, NULL, NULL, 192148),
(192149, '1.10.1740.10-FF-000017', NULL, 'RNA polymerase sigma factor', 77, NULL, NULL, 192149),
(192150, '3.80.10.10-FF-003754', NULL, 'Uncharacterized protein', 122, NULL, NULL, 192150),
(192151, '3.60.40.10-FF-000042', NULL, 'Protein phosphatase domain containing protein', 247, NULL, NULL, 192151),
(192152, '2.130.10.10-FF-003731', NULL, 'Predicted protein', 335, NULL, NULL, 192152),
(192153, '3.30.160.60-FF-005384', NULL, NULL, 26, NULL, NULL, 192153),
(192154, '3.30.70.270-FF-000244', NULL, NULL, 58, NULL, NULL, 192154),
(192155, '2.40.37.20-FF-000012', NULL, NULL, 147, NULL, NULL, 192155),
(192156, '3.40.47.10-FF-000119', NULL, 'Anthraniloyl-CoA anthraniloyltransferase', 154, NULL, NULL, 192156),
(192157, '1.10.10.60-FF-001303', NULL, NULL, 49, NULL, NULL, 192157),
(192158, '2.60.120.340-FF-000001', NULL, 'Nucleophosmin 1', 117, NULL, NULL, 192158),
(192159, '1.25.10.10-FF-002385', NULL, 'Uncharacterized protein', 267, NULL, NULL, 192159),
(192160, '2.30.30.40-FF-000278', NULL, 'SAM domain, SH3 domain and nuclear localization signals 1', 54, NULL, NULL, 192160),
(192161, '1.10.3460.10-FF-000035', NULL, 'Uncharacterized protein', 107, NULL, NULL, 192161),
(192162, '2.60.40.10-FF-005895', NULL, NULL, 77, NULL, NULL, 192162),
(192163, '2.40.50.140-FF-000770', NULL, NULL, 106, NULL, NULL, 192163),
(192164, '1.20.1250.20-FF-001728', NULL, 'Predicted protein', 204, NULL, NULL, 192164),
(192165, '3.30.1010.10-FF-000001', NULL, 'Phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit beta', 148, NULL, NULL, 192165),
(192166, '2.130.10.10-FF-004243', NULL, 'Uncharacterized protein', 140, NULL, NULL, 192166),
(192167, '2.30.36.70-FF-000008', NULL, 'actin-related protein 3 isoform X2', 26, NULL, NULL, 192167),
(192168, '1.10.565.10-FF-000015', NULL, 'Nuclear receptor subfamily 6 group A member 1', 233, NULL, NULL, 192168);
INSERT INTO "PUBLIC"."MODEL" VALUES
(192169, '3.40.50.300-FF-000415', NULL, 'ADP-ribosylation factor-like GTPase 13B', 208, NULL, NULL, 192169),
(192170, '1.20.5.110-FF-000319', NULL, 'Predicted protein', 43, NULL, NULL, 192170),
(192171, '3.80.10.10-FF-003861', NULL, 'Uncharacterized protein', 73, NULL, NULL, 192171),
(192172, '1.25.40.10-FF-003466', NULL, 'Pentatricopeptide repeat-containing protein At5g52850, chloroplastic', 104, NULL, NULL, 192172),
(192173, '3.40.50.720-FF-002222', NULL, 'Uncharacterized protein', 107, NULL, NULL, 192173),
(192174, '2.130.10.30-FF-000123', NULL, NULL, 208, NULL, NULL, 192174),
(192175, '3.40.850.10-FF-000523', NULL, 'Kinesin-like protein', 109, NULL, NULL, 192175),
(192176, '3.40.50.2000-FF-000379', NULL, 'UDP-glucuronosyltransferase', 180, NULL, NULL, 192176),
(192177, '1.25.40.10-FF-002954', NULL, 'General transcription factor 3C polypeptide 3-like Protein', 88, NULL, NULL, 192177),
(192178, '3.80.10.10-FF-000084', NULL, 'Leucine rich repeat neuronal 2', 236, NULL, NULL, 192178),
(192179, '1.20.1310.10-FF-000185', NULL, NULL, 113, NULL, NULL, 192179),
(192180, '1.10.620.20-FF-000035', NULL, 'Uncharacterized protein', 241, NULL, NULL, 192180),
(192181, '3.60.10.10-FF-000214', NULL, 'Uncharacterized protein', 133, NULL, NULL, 192181),
(192182, '3.40.50.620-FF-000449', NULL, 'DUF218 domain-containing protein', 165, NULL, NULL, 192182),
(192183, '1.25.10.10-FF-001840', NULL, 'Uncharacterized protein', 547, NULL, NULL, 192183),
(192184, '1.10.506.10-FF-000098', NULL, 'LD15833p', 78, NULL, NULL, 192184),
(192185, '2.60.40.10-FF-001680', NULL, 'filamin-A isoform X7', 74, NULL, NULL, 192185),
(192186, '3.10.110.10-FF-000250', NULL, 'E3 ubiquitin-protein ligase RNF25', 130, NULL, NULL, 192186),
(192187, '3.30.40.10-FF-000397', NULL, 'Histone-lysine N-methyltransferase', 69, NULL, NULL, 192187),
(192188, '3.60.10.10-FF-000158', NULL, 'Uncharacterized protein', 148, NULL, NULL, 192188),
(192189, '2.40.50.140-FF-001175', NULL, NULL, 124, NULL, NULL, 192189),
(192190, '1.10.10.1580-FF-000002', NULL, 'Uncharacterized protein', 60, NULL, NULL, 192190),
(192191, '1.10.3380.10-FF-000001', NULL, 'U5 small nuclear ribonucleoprotein helicase', 142, NULL, NULL, 192191),
(192192, '2.30.30.380-FF-000003', NULL, 'SEC24 homolog D, COPII coat complex component', 75, NULL, NULL, 192192),
(192193, '3.30.160.60-FF-001157', NULL, 'Zinc finger protein 793', 30, NULL, NULL, 192193),
(192194, '3.30.230.10-FF-000327', NULL, 'Lon protease homolog 2 peroxisomal', 102, NULL, NULL, 192194),
(192195, '1.10.8.60-FF-000206', NULL, 'Origin recognition complex subunit 1', 78, NULL, NULL, 192195),
(192196, '3.30.70.330-FF-002089', NULL, NULL, 74, NULL, NULL, 192196),
(192197, '3.10.180.10-FF-000080', NULL, 'SOS-regulated glyoxalase family protein', 109, NULL, NULL, 192197),
(192198, '1.10.150.20-FF-000167', NULL, 'Transcription and mRNA export factor ENY2', 57, NULL, NULL, 192198),
(192199, '1.10.10.200-FF-000015', NULL, 'Uncharacterized protein', 53, NULL, NULL, 192199),
(192200, '1.20.1700.10-FF-000001', NULL, 'Pantothenate kinase 4', 87, NULL, NULL, 192200),
(192201, '1.10.1660.10-FF-000016', NULL, 'MerR family transcriptional regulator', 120, NULL, NULL, 192201),
(192202, '1.20.5.370-FF-000021', NULL, NULL, 95, NULL, NULL, 192202),
(192203, '1.20.58.60-FF-000204', NULL, 'Uncharacterized protein, isoform D', 206, NULL, NULL, 192203),
(192204, '3.90.70.10-FF-000391', NULL, 'Predicted protein', 179, NULL, NULL, 192204),
(192205, '3.60.40.10-FF-000093', NULL, 'Type 2C protein Phosphatase', 269, NULL, NULL, 192205),
(192206, '3.10.180.90-FF-000002', NULL, 'ATP-dependent 6-phosphofructokinase subunit alpha', 170, NULL, NULL, 192206),
(192207, '3.30.260.10-FF-000099', NULL, NULL, 143, NULL, NULL, 192207),
(192208, '2.130.10.10-FF-003782', NULL, 'Cilia and flagella associated protein 44', 398, NULL, NULL, 192208),
(192209, '2.30.30.140-FF-000162', NULL, 'Uncharacterized protein, isoform A', 57, NULL, NULL, 192209),
(192210, '3.40.50.300-FF-000359', NULL, 'Small GTP-binding protein', 200, NULL, NULL, 192210),
(192211, '2.60.40.820-FF-000006', NULL, 'T-box transcription factor', 200, NULL, NULL, 192211);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(192212, '3.30.70.1230-FF-000089', NULL, 'AAA ATPase domain protein', 183, NULL, NULL, 192212),
(192213, '1.25.40.430-FF-000029', NULL, 'Uncharacterized protein', 37, NULL, NULL, 192213),
(192214, '1.20.1250.10-FF-000039', NULL, 'Placental prolactin-related protein 2', 198, NULL, NULL, 192214),
(192215, '3.10.110.10-FF-000194', NULL, 'Ubiquitin-conjugating enzyme E2-28.4 kDa', 158, NULL, NULL, 192215),
(192216, '3.40.50.880-FF-000044', NULL, 'Glutamine amidotransferase, class-I', 229, NULL, NULL, 192216),
(192217, '3.30.565.10-FF-000492', NULL, 'MUTL protein homolog 3', 143, NULL, NULL, 192217),
(192218, '1.10.630.10-FF-000319', NULL, 'Cytochrome P450 aromatase', 142, NULL, NULL, 192218),
(192219, '3.40.250.10-FF-000045', NULL, 'Arsenate reductase (Arc2), putative', 135, NULL, NULL, 192219),
(192220, '1.10.287.1260-FF-000014', NULL, 'Small-conductance mechanosensitive channel', 127, NULL, NULL, 192220),
(192221, '3.40.50.720-FF-000665', NULL, 'Shikimate dehydrogenase (NADP(+))', 133, NULL, NULL, 192221),
(192222, '3.40.50.1220-FF-000111', NULL, 'Transcriptional regulator, Sir2 family protein', 154, NULL, NULL, 192222),
(192223, '2.60.40.10-FF-004591', NULL, NULL, 98, NULL, NULL, 192223),
(192224, '1.50.40.10-FF-000412', NULL, 'Uncharacterized protein', 214, NULL, NULL, 192224),
(192225, '1.25.40.10-FF-003522', NULL, 'Uncharacterized protein', 123, NULL, NULL, 192225),
(192226, '2.130.10.10-FF-003675', NULL, 'Zgc:109932', 267, NULL, NULL, 192226),
(192227, '2.60.40.10-FF-000145', NULL, 'Myosin light chain kinase, smooth muscle', 102, NULL, NULL, 192227),
(192228, '1.10.3080.10-FF-000012', NULL, 'Chloride channel K', 491, NULL, NULL, 192228),
(192229, '3.80.10.10-FF-000140', NULL, 'Outer arm dynein light chain 1 protein', 170, NULL, NULL, 192229),
(192230, '2.40.50.140-FF-000618', NULL, 'DIS3 like exosome 3''-5'' exoribonuclease', 96, NULL, NULL, 192230),
(192231, '4.10.240.10-FF-000216', NULL, 'Uncharacterized protein', 54, NULL, NULL, 192231),
(192232, '3.40.50.2300-FF-001363', NULL, NULL, 13, NULL, NULL, 192232),
(192233, '2.60.40.10-FF-003074', NULL, 'Immunoglobulin heavy variable 11-1', 100, NULL, NULL, 192233),
(192234, '1.20.1070.10-FF-001902', NULL, 'Serpentine receptor class X-43', 287, NULL, NULL, 192234),
(192235, '2.60.40.1360-FF-000003', NULL, 'Alpha-mannosidase', 144, NULL, NULL, 192235),
(192236, '1.10.3260.10-FF-000054', NULL, 'DNA ligase', 48, NULL, NULL, 192236),
(192237, '1.10.1580.10-FF-000033', NULL, 'Uncharacterized protein', 111, NULL, NULL, 192237),
(192238, '3.30.1490.80-FF-000029', NULL, 'Glutathione synthetase', 48, NULL, NULL, 192238),
(192239, '3.60.10.10-FF-000265', NULL, 'Uncharacterized protein', 114, NULL, NULL, 192239),
(192240, '3.30.70.330-FF-000228', NULL, 'RNA-binding motif protein 12', 85, NULL, NULL, 192240),
(192241, '3.40.50.2300-FF-001256', NULL, NULL, 69, NULL, NULL, 192241),
(192242, '1.10.287.70-FF-000347', NULL, 'Related to TOK1-Voltage-gated, outward-rectifying K+ channel protein of the plasma membrane', 139, NULL, NULL, 192242),
(192243, '2.130.10.10-FF-000876', NULL, 'Cft1p', 357, NULL, NULL, 192243),
(192244, '1.10.510.10-FF-002345', NULL, NULL, 200, NULL, NULL, 192244),
(192245, '1.10.510.10-FF-002289', NULL, NULL, 207, NULL, NULL, 192245),
(192246, '1.10.10.60-FF-000842', NULL, NULL, 103, NULL, NULL, 192246),
(192247, '2.90.10.10-FF-000069', NULL, 'Uncharacterized protein', 110, NULL, NULL, 192247),
(192248, '1.20.58.200-FF-000009', NULL, NULL, 91, NULL, NULL, 192248),
(192249, '3.30.1330.60-FF-000023', NULL, 'OmpA family protein', 141, NULL, NULL, 192249),
(192250, '1.20.120.1490-FF-000003', NULL, 'Zinc resistance-associated protein', 81, NULL, NULL, 192250),
(192251, '2.10.10.100-FF-000004', NULL, 'UDP-N-acetylhexosamine pyrophosphorylase-like protein 1', 63, NULL, NULL, 192251),
(192252, '1.10.510.10-FF-001833', NULL, NULL, 86, NULL, NULL, 192252),
(192253, '1.25.40.10-FF-002909', NULL, 'Putative TPR repeat family protein', 192, NULL, NULL, 192253),
(192254, '2.60.200.20-FF-000095', NULL, 'FHA domain containing protein, putative', 128, NULL, NULL, 192254);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(192255, '1.10.238.10-FF-001296', NULL, 'Uncharacterized protein', 96, NULL, NULL, 192255),
(192256, '1.20.1250.20-FF-001773', NULL, 'Uncharacterized protein', 187, NULL, NULL, 192256),
(192257, '2.60.40.10-FF-000201', NULL, 'Tenascin C', 84, NULL, NULL, 192257),
(192258, '3.30.870.10-FF-000010', NULL, 'Phospholipase', 189, NULL, NULL, 192258),
(192259, '3.50.30.30-FF-000160', NULL, 'Predicted protein', 166, NULL, NULL, 192259),
(192260, '2.170.270.10-FF-000126', NULL, 'Euchromatic histone lysine N-methyltransferase 2a', 129, NULL, NULL, 192260),
(192261, '1.25.40.10-FF-001049', NULL, 'Os07g0239600 protein', 82, NULL, NULL, 192261),
(192262, '3.30.300.20-FF-000021', NULL, '40S ribosomal protein S3', 92, NULL, NULL, 192262),
(192263, '2.40.50.40-FF-000088', NULL, 'Lymphotactin', 72, NULL, NULL, 192263),
(192264, '1.20.1510.10-FF-000077', NULL, NULL, 202, NULL, NULL, 192264),
(192265, '3.10.350.10-FF-000088', NULL, 'LysM domain receptor-like kinase 4', 64, NULL, NULL, 192265),
(192266, '1.10.10.10-FF-002109', NULL, 'Forkhead box P3', 63, NULL, NULL, 192266),
(192267, '2.30.42.10-FF-000078', NULL, 'Partitioning defective 3 homolog B', 104, NULL, NULL, 192267),
(192268, '1.25.40.10-FF-000537', NULL, 'Tetratricopeptide repeat domain 25', 130, NULL, NULL, 192268),
(192269, '3.90.520.10-FF-000004', NULL, 'Mothers against decapentaplegic homolog', 30, NULL, NULL, 192269),
(192270, '2.130.10.10-FF-001314', NULL, 'Autophagy-related protein 18b', 227, NULL, NULL, 192270),
(192271, '2.60.40.10-FF-003978', NULL, NULL, 128, NULL, NULL, 192271),
(192272, '3.50.50.60-FF-001070', NULL, 'Uncharacterized protein', 78, NULL, NULL, 192272),
(192273, '2.60.40.2860-FF-000026', NULL, '6-cysteine protein', 145, NULL, NULL, 192273),
(192274, '3.40.50.300-FF-008060', NULL, 'Uncharacterized protein', 125, NULL, NULL, 192274),
(192275, '2.60.40.60-FF-000699', NULL, 'Predicted protein', 103, NULL, NULL, 192275),
(192276, '3.30.450.60-FF-000072', NULL, 'Uncharacterized protein', 195, NULL, NULL, 192276),
(192277, '3.30.260.10-FF-000104', NULL, NULL, 58, NULL, NULL, 192277),
(192278, '3.30.460.10-FF-000136', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 193, NULL, NULL, 192278),
(192279, '3.20.20.80-FF-000136', NULL, 'Lysosomal glucosyl ceramidase-like protein', 339, NULL, NULL, 192279),
(192280, '3.60.160.10-FF-000005', NULL, 'Altered inheritance of mitochondria protein 24, mitochondrial', 104, NULL, NULL, 192280),
(192281, '3.30.710.10-FF-000465', NULL, 'Uncharacterized protein', 117, NULL, NULL, 192281),
(192282, '3.30.70.330-FF-002196', NULL, NULL, 116, NULL, NULL, 192282),
(192283, '1.20.1440.100-FF-000007', NULL, 'Putative hydrolase Mb0517c', 77, NULL, NULL, 192283),
(192284, '3.30.450.20-FF-000644', NULL, 'Uncharacterized protein', 162, NULL, NULL, 192284),
(192285, '3.30.40.10-FF-001706', NULL, 'UEV domain/Zinc finger, C3HC4 type (RING finger), putative', 62, NULL, NULL, 192285),
(192286, '3.40.50.800-FF-000026', NULL, 'Histidine--tRNA ligase', 93, NULL, NULL, 192286),
(192287, '1.20.1420.30-FF-000076', NULL, 'Putative cation exchanger C3A12.06c', 206, NULL, NULL, 192287),
(192288, '1.10.472.80-FF-000247', NULL, NULL, 123, NULL, NULL, 192288),
(192289, '3.40.50.150-FF-001753', NULL, NULL, 203, NULL, NULL, 192289),
(192290, '3.40.250.10-FF-000101', NULL, 'Uncharacterized protein', 125, NULL, NULL, 192290),
(192291, '3.40.50.200-FF-000099', NULL, 'Related to microbial serine proteinase', 274, NULL, NULL, 192291),
(192292, '1.10.10.60-FF-000865', NULL, NULL, 110, NULL, NULL, 192292),
(192293, '1.20.1110.10-FF-000153', NULL, 'Possible metal cation transporting P-type ATPase CtpH', 261, NULL, NULL, 192293),
(192294, '3.40.50.300-FF-001764', NULL, 'ATP-dependent RNA helicase DEAH13', 101, NULL, NULL, 192294),
(192295, '1.10.238.10-FF-000396', NULL, 'Calcium-binding mitochondrial carrier protein Aralar1', 129, NULL, NULL, 192295),
(192296, '3.30.160.60-FF-002511', NULL, 'zinc finger and SCAN domain-containing protein 10', 27, NULL, NULL, 192296),
(192297, '3.40.1090.10-FF-000155', NULL, 'Uncharacterized protein', 209, NULL, NULL, 192297);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(192298, '4.10.280.10-FF-000218', NULL, 'DNA binding protein', 39, NULL, NULL, 192298),
(192299, '3.40.50.1010-FF-000240', NULL, NULL, 205, NULL, NULL, 192299),
(192300, '2.60.40.1360-FF-000008', NULL, 'Alpha-mannosidase', 91, NULL, NULL, 192300),
(192301, '3.60.20.10-FF-000035', NULL, 'Proteasome subunit beta', 200, NULL, NULL, 192301),
(192302, '2.60.40.10-FF-003478', NULL, NULL, 98, NULL, NULL, 192302),
(192303, '3.20.20.60-FF-000130', NULL, 'Pyruvate kinase', 67, NULL, NULL, 192303),
(192304, '2.30.30.140-FF-000111', NULL, 'Histone acetyltransferase SAGA associated factor SGF29', 71, NULL, NULL, 192304),
(192305, '3.40.630.10-FF-000086', NULL, 'glutaminyl-peptide cyclotransferase-like protein isoform X3', 171, NULL, NULL, 192305),
(192306, '2.60.120.200-FF-000717', NULL, 'Uncharacterized protein', 177, NULL, NULL, 192306),
(192307, '2.60.120.10-FF-000232', NULL, 'Crp/Fnr family transcriptional regulator', 150, NULL, NULL, 192307),
(192308, '3.15.10.20-FF-000001', NULL, 'Activator of 90 kDa heat shock protein ATPase 1', 147, NULL, NULL, 192308),
(192309, '1.10.150.20-FF-000223', NULL, 'YALI0F20724p', 57, NULL, NULL, 192309),
(192310, '3.30.160.60-FF-003523', NULL, 'Fibronectin type III and SPRY domain-containing protein 2', 72, NULL, NULL, 192310),
(192311, '2.40.50.770-FF-000009', NULL, 'RMi1 (RMI1) Homolog', 156, NULL, NULL, 192311),
(192312, '2.10.25.10-FF-000562', NULL, 'Neural-cadherin', 42, NULL, NULL, 192312),
(192313, '3.30.70.1230-FF-000201', NULL, 'Guanylate cyclase 2d', 184, NULL, NULL, 192313),
(192314, '2.40.10.10-FF-000655', NULL, NULL, 104, NULL, NULL, 192314),
(192315, '3.30.70.1290-FF-000005', NULL, NULL, 133, NULL, NULL, 192315),
(192316, '3.30.505.10-FF-000011', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', 130, NULL, NULL, 192316),
(192317, '1.10.3720.10-FF-000185', NULL, 'Phosphate transport system permease protein PstA', 267, NULL, NULL, 192317),
(192318, '3.30.70.330-FF-001740', NULL, NULL, 148, NULL, NULL, 192318),
(192319, '1.50.40.10-FF-000524', NULL, 'Carnitine/acylcarnitine translocase', 170, NULL, NULL, 192319),
(192320, '1.20.1410.10-FF-000018', NULL, 'Protein CBG03842', 146, NULL, NULL, 192320),
(192321, '3.40.50.2000-FF-000435', NULL, 'Glycosyltransferase', 269, NULL, NULL, 192321),
(192322, '1.25.40.10-FF-000588', NULL, 'Intraflagellar transport protein 56', 234, NULL, NULL, 192322),
(192323, '2.30.29.30-FF-000227', NULL, 'krev interaction trapped protein 1 isoform X1', 102, NULL, NULL, 192323),
(192324, '3.40.30.10-FF-000379', NULL, 'Sulfhydryl oxidase', 107, NULL, NULL, 192324),
(192325, '2.130.10.10-FF-001365', NULL, 'Protein CBR-PFS-2', 173, NULL, NULL, 192325),
(192326, '1.20.1250.20-FF-000424', NULL, 'Major facilitator superfamily domain containing 4A', 251, NULL, NULL, 192326),
(192327, '1.20.1050.10-FF-000035', NULL, 'Hematopoietic prostaglandin D synthase', 108, NULL, NULL, 192327),
(192328, '3.30.160.60-FF-004809', NULL, NULL, 29, NULL, NULL, 192328),
(192329, '2.130.10.10-FF-004187', NULL, 'Uncharacterized protein', 161, NULL, NULL, 192329),
(192330, '3.90.1260.10-FF-000011', NULL, 'Uncharacterized protein', 29, NULL, NULL, 192330),
(192331, '3.70.10.10-FF-000129', NULL, 'Uncharacterized protein', 340, NULL, NULL, 192331),
(192332, '2.40.170.20-FF-000091', NULL, 'SusC homolog', 646, NULL, NULL, 192332),
(192333, '2.60.34.10-FF-000108', NULL, 'DnaK protein', 143, NULL, NULL, 192333),
(192334, '3.30.1370.10-FF-000207', NULL, 'Uncharacterized protein', 59, NULL, NULL, 192334),
(192335, '3.10.250.10-FF-000029', NULL, 'Enteropeptidase', 109, NULL, NULL, 192335),
(192336, '1.10.150.810-FF-000008', NULL, 'DNA polymerase kappa-related protein', 81, NULL, NULL, 192336),
(192337, '3.90.70.60-FF-000001', NULL, 'Polyprotein 1a', 116, NULL, NULL, 192337),
(192338, '3.40.50.300-FF-003237', NULL, 'Dynein, axonemal, heavy chain 6', 93, NULL, NULL, 192338),
(192339, '3.50.30.10-FF-000002', NULL, 'Phosphoenolpyruvate synthase', 119, NULL, NULL, 192339),
(192340, '1.10.260.40-FF-000035', NULL, 'Antitoxin MqsA', 69, NULL, NULL, 192340);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(192341, '2.60.40.10-FF-004439', NULL, NULL, 79, NULL, NULL, 192341),
(192342, '3.40.1190.10-FF-000039', NULL, NULL, 238, NULL, NULL, 192342),
(192343, '1.25.40.10-FF-001605', NULL, 'Putative ESP1 protein', 143, NULL, NULL, 192343),
(192344, '2.120.10.30-FF-000096', NULL, 'Uncharacterized protein', 277, NULL, NULL, 192344),
(192345, '3.30.300.350-FF-000001', NULL, 'GTPase Obg', 73, NULL, NULL, 192345),
(192346, '3.90.190.10-FF-000141', NULL, 'Tyrosine phosphatase', 338, NULL, NULL, 192346),
(192347, '3.30.160.60-FF-003074', NULL, 'D19B', 30, NULL, NULL, 192347),
(192348, '3.30.70.330-FF-002937', NULL, NULL, 115, NULL, NULL, 192348),
(192349, '3.30.2350.10-FF-000049', NULL, 'tRNA pseudouridine synthase A', 45, NULL, NULL, 192349),
(192350, '3.30.810.10-FF-000006', NULL, 'Phosphatidylinositol 4-phosphate 5-kinase-like protein 1', 188, NULL, NULL, 192350),
(192351, '1.20.910.10-FF-000024', NULL, 'Aminopyrimidine aminohydrolase', 222, NULL, NULL, 192351),
(192352, '1.20.1070.10-FF-001054', NULL, 'Uncharacterized protein', 187, NULL, NULL, 192352),
(192353, '1.10.10.10-FF-001660', NULL, 'Peroxin 14', 70, NULL, NULL, 192353),
(192354, '1.10.540.10-FF-000149', NULL, 'Probable acyl-CoA dehydrogenase', 99, NULL, NULL, 192354),
(192355, '3.40.50.2000-FF-000031', NULL, 'Trehalose-6-phosphate synthase', 222, NULL, NULL, 192355),
(192356, '2.40.70.10-FF-000215', NULL, 'Aspartyl protease family protein 2', 202, NULL, NULL, 192356),
(192357, '2.40.50.140-FF-001170', NULL, NULL, 51, NULL, NULL, 192357),
(192358, '3.40.910.10-FF-000017', NULL, 'Os09g0421100 protein', 89, NULL, NULL, 192358),
(192359, '3.20.20.100-FF-000180', NULL, 'Uncharacterized protein', 141, NULL, NULL, 192359),
(192360, '3.90.190.10-FF-000085', NULL, 'NAD kinase 2 chloroplastic', 135, NULL, NULL, 192360),
(192361, '3.80.10.10-FF-001837', NULL, 'SHOC2 isoform 2', 138, NULL, NULL, 192361),
(192362, '1.25.40.20-FF-001322', NULL, 'Predicted protein', 137, NULL, NULL, 192362),
(192363, '3.90.1100.10-FF-000067', NULL, 'DNA-directed RNA polymerase subunit beta', 55, NULL, NULL, 192363),
(192364, '3.20.20.330-FF-000024', NULL, '5-methyltetrahydrofolate--homocysteine S-methyltransferase and 5,10-methylenetetrahydrofolate reductase', 316, NULL, NULL, 192364),
(192365, '2.30.42.10-FF-000185', NULL, 'Protostome-specific GEF, isoform B', 83, NULL, NULL, 192365),
(192366, '2.130.10.10-FF-002618', NULL, 'Uncharacterized protein', 257, NULL, NULL, 192366),
(192367, '3.40.50.300-FF-007508', NULL, 'Uncharacterized protein', 219, NULL, NULL, 192367),
(192368, '1.20.58.90-FF-000039', NULL, NULL, 97, NULL, NULL, 192368),
(192369, '3.30.360.10-FF-000140', NULL, 'Nicotinate-nucleotide pyrophosphorylase AND conserved protein', 92, NULL, NULL, 192369),
(192370, '1.10.405.10-FF-000015', NULL, 'RAB GDP-dissociation inhibitor, putative', 105, NULL, NULL, 192370),
(192371, '3.80.10.10-FF-004243', NULL, 'Uncharacterized protein', 74, NULL, NULL, 192371),
(192372, '2.60.130.10-FF-000002', NULL, 'Protocatechuate 3,4-dioxygenase beta chain', 238, NULL, NULL, 192372),
(192373, '1.10.238.10-FF-000340', NULL, 'Centrin, putative', 77, NULL, NULL, 192373),
(192374, '3.40.50.720-FF-002227', NULL, 'Uncharacterized protein', 102, NULL, NULL, 192374),
(192375, '3.10.110.10-FF-000255', NULL, 'RWD domain-containing protein 1', 108, NULL, NULL, 192375),
(192376, '1.10.238.10-FF-000391', NULL, 'Uncharacterized protein', 86, NULL, NULL, 192376),
(192377, '2.170.40.20-FF-000002', NULL, 'Envelope glycoprotein gp160', 100, NULL, NULL, 192377),
(192378, '2.10.25.10-FF-000270', NULL, 'Nidogen 1', 40, NULL, NULL, 192378),
(192379, '1.20.5.110-FF-000314', NULL, 'Predicted protein', 53, NULL, NULL, 192379),
(192380, '3.30.160.60-FF-001218', NULL, 'Zinc finger protein 574', 69, NULL, NULL, 192380),
(192381, '2.60.120.200-FF-000768', NULL, 'POGO family transposase, putative', 63, NULL, NULL, 192381),
(192382, '1.20.1070.10-FF-001110', NULL, 'Putative G-protein coupled receptor 21', 310, NULL, NULL, 192382),
(192383, '1.20.1270.60-FF-000128', NULL, 'FCH domain Only (FCH stands for Fes/CIP4 homology domain)', 272, NULL, NULL, 192383);
INSERT INTO "PUBLIC"."MODEL" VALUES
(192384, '4.10.60.10-FF-000060', NULL, 'Zinc knuckle domain protein', 23, NULL, NULL, 192384),
(192385, '3.40.30.10-FF-000435', NULL, 'Phosducin/Thioredoxin', 131, NULL, NULL, 192385),
(192386, '1.10.1520.10-FF-000029', NULL, 'Mrpl15p', 225, NULL, NULL, 192386),
(192387, '3.40.50.10330-FF-000084', NULL, 'ATP-NAD kinase family protein', 128, NULL, NULL, 192387),
(192388, '3.30.70.330-FF-002701', NULL, NULL, 167, NULL, NULL, 192388),
(192389, '1.10.3080.10-FF-000068', NULL, 'Uncharacterized protein', 181, NULL, NULL, 192389),
(192390, '2.130.10.10-FF-002326', NULL, 'WD domain, G-beta repeat, putative', 175, NULL, NULL, 192390),
(192391, '1.10.10.490-FF-000001', NULL, 'beta-catenin-interacting protein 1', 54, NULL, NULL, 192391),
(192392, '3.30.70.330-FF-002589', NULL, NULL, 136, NULL, NULL, 192392),
(192393, '1.25.40.280-FF-000018', NULL, 'Tyrosine-protein phosphatase non-receptor type 23', 186, NULL, NULL, 192393),
(192394, '3.80.10.10-FF-000876', NULL, 'Reduced ocelli, isoform B', 218, NULL, NULL, 192394),
(192395, '3.40.50.300-FF-002332', NULL, 'ABC transporter, ATP-binding protein', 231, NULL, NULL, 192395),
(192396, '2.10.110.10-FF-000293', NULL, 'Probable Rho-type GTPase-activating protein 3', 72, NULL, NULL, 192396),
(192397, '4.10.1000.10-FF-000066', NULL, 'Zinc finger, matrin-type 5', 69, NULL, NULL, 192397),
(192398, '1.20.1070.10-FF-000093', NULL, 'G-protein coupled estrogen receptor 1', 299, NULL, NULL, 192398),
(192399, '2.60.40.10-FF-002674', NULL, 'HEMCAM', 113, NULL, NULL, 192399),
(192400, '3.10.105.10-FF-000125', NULL, 'Solute-binding protein', 100, NULL, NULL, 192400),
(192401, '3.30.420.270-FF-000003', NULL, 'Biopolymer transport protein ExbD/TolR', 70, NULL, NULL, 192401),
(192402, '3.40.50.300-FF-003344', NULL, 'Uncharacterized protein', 149, NULL, NULL, 192402),
(192403, '1.10.1420.10-FF-000196', NULL, 'DNA mismatch repair protein', 252, NULL, NULL, 192403),
(192404, '3.40.50.300-FF-003288', NULL, 'Nucleolar GTPase', 193, NULL, NULL, 192404),
(192405, '3.90.320.10-FF-000023', NULL, 'ATP-dependent helicase/nuclease subunit A', 243, NULL, NULL, 192405),
(192406, '3.40.50.720-FF-000480', NULL, 'Myo-inositol-1-phosphate synthase Ino1', 240, NULL, NULL, 192406),
(192407, '1.10.287.110-FF-000444', NULL, 'Uncharacterized protein', 67, NULL, NULL, 192407),
(192408, '1.10.506.10-FF-000042', NULL, 'Plexin b2a', 281, NULL, NULL, 192408),
(192409, '3.40.30.10-FF-000143', NULL, 'Protein disulfide-isomerase', 114, NULL, NULL, 192409),
(192410, '3.40.50.10330-FF-000033', NULL, 'NADH kinase, variant 3', 197, NULL, NULL, 192410),
(192411, '1.10.287.1770-FF-000010', NULL, 'Ferrous iron transport protein B', 99, NULL, NULL, 192411),
(192412, '1.10.555.10-FF-000189', NULL, NULL, 216, NULL, NULL, 192412),
(192413, '3.30.590.50-FF-000017', NULL, 'Uncharacterized protein', 276, NULL, NULL, 192413),
(192414, '3.40.630.10-FF-000479', NULL, 'Predicted protein', 144, NULL, NULL, 192414),
(192415, '3.40.50.300-FF-006547', NULL, 'Abcd4 protein', 106, NULL, NULL, 192415),
(192416, '3.90.640.10-FF-000007', NULL, 'Actin like 7B', 90, NULL, NULL, 192416),
(192417, '1.20.120.1080-FF-000094', NULL, 'DEAD/DEAH box RNA helicase', 181, NULL, NULL, 192417),
(192418, '1.20.1420.30-FF-000025', NULL, 'sodium/potassium/calcium exchanger 6, mitochondrial isoform X3', 233, NULL, NULL, 192418),
(192419, '3.40.50.300-FF-003636', NULL, 'GD23047', 247, NULL, NULL, 192419),
(192420, '1.20.120.20-FF-000017', NULL, 'Signal recognition particle receptor FtsY', 104, NULL, NULL, 192420),
(192421, '2.60.40.10-FF-002062', NULL, 'Cell adhesion molecule L1-like b', 114, NULL, NULL, 192421),
(192422, '3.30.390.110-FF-000003', NULL, 'Protein MAK16 homolog', 131, NULL, NULL, 192422),
(192423, '1.20.5.430-FF-000005', NULL, 'Non-structural glycoprotein 4', 51, NULL, NULL, 192423),
(192424, '1.10.1780.10-FF-000014', NULL, 'ATP-dependent protease ATP-binding subunit', 145, NULL, NULL, 192424),
(192425, '3.50.30.30-FF-000008', NULL, 'Glutamate carboxypeptidase 2', 223, NULL, NULL, 192425),
(192426, '3.40.50.300-FF-007559', NULL, 'Uncharacterized protein', 187, NULL, NULL, 192426);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(192427, '3.40.50.1820-FF-000718', NULL, 'Poly(3-hydroxyalkanoate) depolymerase', 103, NULL, NULL, 192427),
(192428, '3.40.190.10-FF-000787', NULL, 'ABC transporter substrate-binding protein', 85, NULL, NULL, 192428),
(192429, '3.80.10.10-FF-001152', NULL, 'F-box and leucine rich repeat protein 13', 93, NULL, NULL, 192429),
(192430, '3.40.47.10-FF-000294', NULL, NULL, 204, NULL, NULL, 192430),
(192431, '3.30.730.10-FF-000005', NULL, 'ethylene-responsive transcription factor RAP2-11', 60, NULL, NULL, 192431),
(192432, '1.20.1250.20-FF-000312', NULL, 'protein NRT1/ PTR FAMILY 4.5', 530, NULL, NULL, 192432),
(192433, '3.40.50.300-FF-002276', NULL, 'Torsin, putative', 221, NULL, NULL, 192433),
(192434, '3.40.1690.20-FF-000013', NULL, 'AFG3-like protein 2', 99, NULL, NULL, 192434),
(192435, '3.30.160.60-FF-005940', NULL, NULL, 37, NULL, NULL, 192435),
(192436, '3.30.1020.10-FF-000007', NULL, NULL, 69, NULL, NULL, 192436),
(192437, '3.20.20.80-FF-000304', NULL, 'Alpha-amylase', 366, NULL, NULL, 192437),
(192438, '3.40.50.1820-FF-001090', NULL, 'Uncharacterized protein', 541, NULL, NULL, 192438),
(192439, '3.30.450.20-FF-000588', NULL, 'Uncharacterized protein', 105, NULL, NULL, 192439),
(192440, '3.10.290.20-FF-000012', NULL, 'SUMO-activating enzyme subunit', 106, NULL, NULL, 192440),
(192441, '1.10.287.70-FF-000403', NULL, 'Potassium channel subfamily K member 1-like Protein', 274, NULL, NULL, 192441),
(192442, '2.60.40.150-FF-000688', NULL, 'Phosphoinositide phospholipase C', 164, NULL, NULL, 192442),
(192443, '3.40.50.1240-FF-000117', NULL, 'Probable phosphatase SPAC5H10.03', 209, NULL, NULL, 192443),
(192444, '4.10.1000.10-FF-000015', NULL, 'Zinc finger CCCH domain-containing protein 13', 27, NULL, NULL, 192444),
(192445, '1.10.1420.10-FF-000145', NULL, 'Chromosome 23, whole genome shotgun sequence', 193, NULL, NULL, 192445),
(192446, '3.40.50.300-FF-006199', NULL, 'Uncharacterized protein', 211, NULL, NULL, 192446),
(192447, '2.40.37.20-FF-000017', NULL, NULL, 63, NULL, NULL, 192447),
(192448, '3.90.550.50-FF-000001', NULL, 'Hexosyltransferase', 252, NULL, NULL, 192448),
(192449, '2.170.150.80-FF-000003', NULL, 'NAC domain-containing protein', 143, NULL, NULL, 192449),
(192450, '1.10.510.10-FF-003750', NULL, NULL, 143, NULL, NULL, 192450),
(192451, '2.60.40.1400-FF-000004', NULL, 'inward rectifier potassium channel 13 isoform X1', 172, NULL, NULL, 192451),
(192452, '3.40.50.12660-FF-000018', NULL, NULL, 305, NULL, NULL, 192452),
(192453, '2.30.29.30-FF-001340', NULL, 'Uncharacterized protein', 40, NULL, NULL, 192453),
(192454, '1.25.40.10-FF-005315', NULL, 'Tetratricopeptide repeat protein 37', 119, NULL, NULL, 192454),
(192455, '3.60.15.10-FF-000062', NULL, 'DNA repair metallo-beta-lactamase protein', 100, NULL, NULL, 192455),
(192456, '3.30.420.40-FF-000974', NULL, 'Xylose repressor, putative', 126, NULL, NULL, 192456),
(192457, '3.10.100.10-FF-000373', NULL, NULL, 140, NULL, NULL, 192457),
(192458, '3.40.50.1000-FF-000736', NULL, NULL, 66, NULL, NULL, 192458),
(192459, '1.25.40.10-FF-004826', NULL, 'Uncharacterized protein', 148, NULL, NULL, 192459),
(192460, '3.20.20.100-FF-000028', NULL, 'Oxidoreductase, aldo/keto reductase family', 282, NULL, NULL, 192460),
(192461, '3.30.40.10-FF-001414', NULL, 'RING/U-box superfamily protein', 83, NULL, NULL, 192461),
(192462, '3.30.420.10-FF-000538', NULL, NULL, 86, NULL, NULL, 192462),
(192463, '2.30.29.30-FF-001284', NULL, 'EPS8 like 1', 91, NULL, NULL, 192463),
(192464, '3.40.50.1820-FF-000870', NULL, 'Uncharacterized protein', 209, NULL, NULL, 192464),
(192465, '3.30.70.330-FF-001684', NULL, NULL, 136, NULL, NULL, 192465),
(192466, '3.30.710.10-FF-000173', NULL, 'BTB/POZ domain-containing protein NPY2', 110, NULL, NULL, 192466),
(192467, '1.10.10.160-FF-000037', NULL, 'DNA helicase', 73, NULL, NULL, 192467),
(192468, '1.10.1820.10-FF-000018', NULL, 'Casein kinase II subunit beta', 118, NULL, NULL, 192468),
(192469, '3.10.600.10-FF-000006', NULL, 'Pyruvate carboxylase', 59, NULL, NULL, 192469),
(192470, '1.50.40.10-FF-000468', NULL, 'Protein PGR', 73, NULL, NULL, 192470);
INSERT INTO "PUBLIC"."MODEL" VALUES
(192471, '1.10.10.60-FF-001298', NULL, NULL, 86, NULL, NULL, 192471),
(192472, '3.90.1300.10-FF-000015', NULL, 'Amidase', 454, NULL, NULL, 192472),
(192473, '3.50.40.10-FF-000008', NULL, 'Phenylalanine--tRNA ligase beta subunit', 206, NULL, NULL, 192473),
(192474, '2.30.230.10-FF-000022', NULL, 'Uncharacterized protein', 109, NULL, NULL, 192474),
(192475, '1.25.40.10-FF-001044', NULL, 'Intraflagellar transport protein IFT88, putative', 159, NULL, NULL, 192475),
(192476, '3.10.310.40-FF-000015', NULL, 'AGAP009701-PA', 54, NULL, NULL, 192476),
(192477, '3.40.50.2300-FF-000800', NULL, NULL, 129, NULL, NULL, 192477),
(192478, '1.20.5.4730-FF-000001', NULL, NULL, 112, NULL, NULL, 192478),
(192479, '3.30.710.10-FF-000353', NULL, 'Uncharacterized protein', 153, NULL, NULL, 192479),
(192480, '1.20.1070.10-FF-001846', NULL, 'Uncharacterized protein', 300, NULL, NULL, 192480),
(192481, '3.10.450.240-FF-000016', NULL, 'Uncharacterized protein', 194, NULL, NULL, 192481),
(192482, '1.20.120.1080-FF-000150', NULL, 'Uncharacterized protein', 164, NULL, NULL, 192482),
(192483, '1.25.10.10-FF-001896', NULL, 'Uncharacterized protein', 260, NULL, NULL, 192483),
(192484, '1.10.4100.10-FF-000003', NULL, '2-methylcitrate dehydratase 1', 277, NULL, NULL, 192484),
(192485, '2.60.120.200-FF-000425', NULL, 'Laminin alpha 1', 182, NULL, NULL, 192485),
(192486, '3.30.200.20-FF-000036', NULL, 'Tyrosine-protein kinase', 94, NULL, NULL, 192486),
(192487, '1.25.40.10-FF-004478', NULL, 'Uncharacterized protein', 103, NULL, NULL, 192487),
(192488, '1.25.40.10-FF-000644', NULL, 'Os12g0289800 protein', 60, NULL, NULL, 192488),
(192489, '3.40.1280.10-FF-000041', NULL, 'tRNA (pseudouridine(54)-N(1))-methyltransferase', 199, NULL, NULL, 192489),
(192490, '3.40.50.150-FF-001865', NULL, NULL, 179, NULL, NULL, 192490),
(192491, '3.20.20.80-FF-000248', NULL, 'Endo-b-N-acetylGlucosaminidase', 297, NULL, NULL, 192491),
(192492, '2.130.10.30-FF-000011', NULL, 'inhibitor of Bruton tyrosine kinase isoform X2', 359, NULL, NULL, 192492),
(192493, '3.40.30.10-FF-000087', NULL, 'DnaJ homolog subfamily C member 10', 102, NULL, NULL, 192493),
(192494, '3.40.50.10860-FF-000012', NULL, 'Methylenetetrahydrofolate dehydrogenase [NAD(+)]', 129, NULL, NULL, 192494),
(192495, '1.10.510.10-FF-002238', NULL, NULL, 199, NULL, NULL, 192495),
(192496, '3.30.930.10-FF-000009', NULL, 'Threonine--tRNA ligase 2, cytoplasmic', 308, NULL, NULL, 192496),
(192497, '3.10.105.10-FF-000069', NULL, 'Putative lipoprotein', 157, NULL, NULL, 192497),
(192498, '2.60.40.150-FF-000637', NULL, 'Uncharacterized protein', 132, NULL, NULL, 192498),
(192499, '2.60.40.10-FF-003130', NULL, 'Receptor-type tyrosine-protein phosphatase', 115, NULL, NULL, 192499),
(192500, '3.90.550.50-FF-000052', NULL, 'Hexosyltransferase', 187, NULL, NULL, 192500),
(192501, '3.40.50.200-FF-000155', NULL, 'Uncharacterized protein', 301, NULL, NULL, 192501),
(192502, '3.40.630.30-FF-000693', NULL, 'Uncharacterized protein', 56, NULL, NULL, 192502),
(192503, '1.20.1250.10-FF-000034', NULL, 'Interleukin-5', 113, NULL, NULL, 192503),
(192504, '2.40.10.10-FF-000599', NULL, NULL, 130, NULL, NULL, 192504),
(192505, '3.10.20.90-FF-000662', NULL, 'WLM domain-domain-containing protein', 81, NULL, NULL, 192505),
(192506, '2.30.42.10-FF-000134', NULL, 'syntaxin-binding protein 4 isoform X1', 89, NULL, NULL, 192506),
(192507, '3.30.479.20-FF-000019', NULL, 'Elongation factor Ts, mitochondrial', 99, NULL, NULL, 192507),
(192508, '3.80.10.10-FF-000932', NULL, 'Leucine Rich Repeat family protein', 157, NULL, NULL, 192508),
(192509, '3.30.160.60-FF-003467', NULL, NULL, 28, NULL, NULL, 192509),
(192510, '1.10.455.10-FF-000018', NULL, 'Uncharacterized protein', 204, NULL, NULL, 192510),
(192511, '3.30.70.270-FF-000300', NULL, NULL, 55, NULL, NULL, 192511),
(192512, '2.160.20.10-FF-000324', NULL, 'Cell surface protein', 156, NULL, NULL, 192512),
(192513, '2.60.40.10-FF-002854', NULL, 'Immunoglobulin domain-containing protein oig-4', 100, NULL, NULL, 192513),
(192514, '1.20.1070.10-FF-000672', NULL, 'Predicted protein', 285, NULL, NULL, 192514);
INSERT INTO "PUBLIC"."MODEL" VALUES
(192515, '3.40.50.80-FF-000182', NULL, 'Uncharacterized protein', 181, NULL, NULL, 192515),
(192516, '1.20.58.60-FF-000148', NULL, 'nesprin-1 isoform X2', 188, NULL, NULL, 192516),
(192517, '2.60.40.150-FF-000289', NULL, 'E3 ubiquitin-protein ligase', 168, NULL, NULL, 192517),
(192518, '1.20.1070.10-FF-001161', NULL, 'Somatostatin receptor type 4', 342, NULL, NULL, 192518),
(192519, '3.40.50.1820-FF-001831', NULL, 'Predicted protein', 86, NULL, NULL, 192519),
(192520, '1.20.940.10-FF-000020', NULL, 'Protein transport protein SEC31', 108, NULL, NULL, 192520),
(192521, '3.90.1470.20-FF-000002', NULL, 'Putative-diketo-5-methylthio-1-phosphopentane phosphatase protein', 106, NULL, NULL, 192521),
(192522, '3.30.470.30-FF-000087', NULL, 'Predicted protein', 230, NULL, NULL, 192522),
(192523, '3.40.50.720-FF-002278', NULL, 'Uncharacterized protein', 17, NULL, NULL, 192523),
(192524, '1.25.10.10-FF-003346', NULL, 'Uncharacterized protein', 220, NULL, NULL, 192524),
(192525, '3.10.250.10-FF-000136', NULL, NULL, 48, NULL, NULL, 192525),
(192526, '1.10.150.240-FF-000028', NULL, 'Hydrolase, haloacid dehalogenase-like family', 83, NULL, NULL, 192526),
(192527, '3.10.20.360-FF-000001', NULL, 'Calmodulin-regulated spectrin-associated protein 3 isoform 2', 119, NULL, NULL, 192527),
(192528, '3.30.750.70-FF-000002', NULL, 'Acetyl-CoA hydrolase Ach1', 91, NULL, NULL, 192528),
(192529, '3.40.50.300-FF-007003', NULL, 'YALI0F02717p', 209, NULL, NULL, 192529),
(192530, '3.10.490.20-FF-000016', NULL, 'Dynein heavy chain-like protein', 162, NULL, NULL, 192530),
(192531, '2.130.10.10-FF-001258', NULL, 'WD repeat-containing protein fzy-1', 369, NULL, NULL, 192531),
(192532, '2.60.40.10-FF-000549', NULL, 'Protein tyrosine phosphatase, receptor type S', 106, NULL, NULL, 192532),
(192533, '1.20.1070.10-FF-000885', NULL, 'p2Y purinoceptor 11', 114, NULL, NULL, 192533),
(192534, '1.25.10.10-FF-002733', NULL, 'Uncharacterized protein', 855, NULL, NULL, 192534),
(192535, '3.30.70.330-FF-001633', NULL, 'Uncharacterized protein', 179, NULL, NULL, 192535),
(192536, '2.20.25.530-FF-000006', NULL, 'Protein CBG16435', 67, NULL, NULL, 192536),
(192537, '1.25.40.20-FF-000029', NULL, 'histone-lysine N-methyltransferase EHMT1 isoform X2', 236, NULL, NULL, 192537),
(192538, '3.20.20.20-FF-000040', NULL, 'Uncharacterized protein', 184, NULL, NULL, 192538),
(192539, '3.20.70.20-FF-000043', NULL, 'Ribonucleoside-diphosphate reductase', 300, NULL, NULL, 192539),
(192540, '3.30.70.330-FF-002645', NULL, NULL, 173, NULL, NULL, 192540),
(192541, '3.10.110.10-FF-000199', NULL, 'Uncharacterized protein', 172, NULL, NULL, 192541),
(192542, '3.40.710.10-FF-000013', NULL, 'Penicillin-binding protein 1A', 90, NULL, NULL, 192542),
(192543, '3.30.420.10-FF-000139', NULL, 'Ribonuclease HII', 169, NULL, NULL, 192543),
(192544, '1.10.506.10-FF-000093', NULL, 'Uncharacterized protein', 94, NULL, NULL, 192544),
(192545, '1.10.10.60-FF-001247', NULL, NULL, 90, NULL, NULL, 192545),
(192546, '3.30.160.60-FF-003815', NULL, NULL, 37, NULL, NULL, 192546),
(192547, '3.40.449.10-FF-000012', NULL, 'Phosphoenolpyruvate carboxykinase (ATP)', 182, NULL, NULL, 192547),
(192548, '4.10.800.10-FF-000012', NULL, 'Thyroglobulin', 68, NULL, NULL, 192548),
(192549, '3.40.50.920-FF-000045', NULL, 'Pyruvate ferredoxin oxidoreductase, subunit alpha', 111, NULL, NULL, 192549),
(192550, '2.40.30.10-FF-000269', NULL, 'NADPH-cytochrome P450 reductase, putative', 81, NULL, NULL, 192550),
(192551, '3.80.10.10-FF-001949', NULL, 'Uncharacterized protein', 77, NULL, NULL, 192551),
(192552, '3.30.70.60-FF-000048', NULL, 'General secretion pathway protein M', 107, NULL, NULL, 192552),
(192553, '3.40.50.2020-FF-000149', NULL, 'Hypoxanthine-guanine phosphoribosyltransferase', 174, NULL, NULL, 192553),
(192554, '2.170.260.10-FF-000013', NULL, 'Argonaute 2, isoform E', 124, NULL, NULL, 192554),
(192555, '1.10.10.10-FF-001480', NULL, 'Let-611 protein', 84, NULL, NULL, 192555),
(192556, '2.30.30.490-FF-000013', NULL, 'DNA (cytosine-5)-methyltransferase', 209, NULL, NULL, 192556),
(192557, '1.10.390.10-FF-000047', NULL, 'GD21935', 249, NULL, NULL, 192557);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(192558, '2.30.42.10-FF-000639', NULL, NULL, 62, NULL, NULL, 192558),
(192559, '3.30.530.20-FF-000196', NULL, 'Uncharacterized protein', 243, NULL, NULL, 192559),
(192560, '1.10.510.10-FF-000765', NULL, 'Non-specific serine/threonine protein kinase', 81, NULL, NULL, 192560),
(192561, '1.25.40.70-FF-000022', NULL, 'Phosphatidylinositol 3-kinase', 233, NULL, NULL, 192561),
(192562, '3.40.50.1110-FF-000045', NULL, 'Arylesterase', 183, NULL, NULL, 192562),
(192563, '2.80.10.50-FF-000194', NULL, 'Uncharacterized protein', 89, NULL, NULL, 192563),
(192564, '3.40.50.2000-FF-000143', NULL, 'UDP-glycosyltransferase 89B1', 267, NULL, NULL, 192564),
(192565, '3.40.50.300-FF-000707', NULL, 'RAB36, member RAS oncogene family', 190, NULL, NULL, 192565),
(192566, '1.10.10.60-FF-001011', NULL, NULL, 45, NULL, NULL, 192566),
(192567, '3.30.70.660-FF-000035', NULL, 'tRNA pseudouridine synthase', 170, NULL, NULL, 192567),
(192568, '3.30.60.20-FF-000058', NULL, 'Diacylglycerol kinase', 55, NULL, NULL, 192568),
(192569, '3.40.630.30-FF-000018', NULL, '[Ribosomal protein S18]-alanine N-acetyltransferase', 148, NULL, NULL, 192569),
(192570, '1.20.5.420-FF-000019', NULL, 'Protein L', 52, NULL, NULL, 192570),
(192571, '2.30.30.100-FF-000054', NULL, 'Polyadenylate-binding protein-interacting protein 3', 72, NULL, NULL, 192571),
(192572, '3.10.290.10-FF-000026', NULL, '30S ribosomal protein S4', 75, NULL, NULL, 192572),
(192573, '3.40.30.10-FF-000323', NULL, 'Ypt homolog1', 96, NULL, NULL, 192573),
(192574, '3.40.50.10190-FF-000351', NULL, 'Uncharacterized protein', 94, NULL, NULL, 192574),
(192575, '1.10.150.240-FF-000079', NULL, 'HAD family hydrolase', 64, NULL, NULL, 192575),
(192576, '1.20.140.10-FF-000010', NULL, 'Acyl-coenzyme A oxidase', 171, NULL, NULL, 192576),
(192577, '1.25.10.10-FF-002677', NULL, 'Uncharacterized protein', 84, NULL, NULL, 192577),
(192578, '2.60.40.60-FF-000194', NULL, 'FAT atypical cadherin 2', 104, NULL, NULL, 192578),
(192579, '2.40.30.10-FF-000325', NULL, 'NADPH--cytochrome P450 reductase', 104, NULL, NULL, 192579),
(192580, '2.10.50.10-FF-000070', NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', 69, NULL, NULL, 192580),
(192581, '3.30.1330.30-FF-000031', NULL, 'Growth arrest and DNA damage-inducible protein GADD45 alpha', 122, NULL, NULL, 192581),
(192582, '3.40.50.10860-FF-000068', NULL, 'Uncharacterized protein', 137, NULL, NULL, 192582),
(192583, '2.60.120.40-FF-000044', NULL, 'Myeloid-specific peroxidase', 120, NULL, NULL, 192583),
(192584, '3.40.1810.10-FF-000060', NULL, NULL, 74, NULL, NULL, 192584),
(192585, '3.30.40.10-FF-000054', NULL, 'E3 ubiquitin-protein ligase RLIM isoform X1', 81, NULL, NULL, 192585),
(192586, '3.40.50.300-FF-002220', NULL, 'GTPase Era, mitochondrial', 188, NULL, NULL, 192586),
(192587, '3.40.50.300-FF-002837', NULL, 'Rad57p', 217, NULL, NULL, 192587),
(192588, '1.10.1040.10-FF-000104', NULL, 'AaceriAGL109Wp', 141, NULL, NULL, 192588),
(192589, '1.20.1090.10-FF-000032', NULL, '3-dehydroquinate synthase', 186, NULL, NULL, 192589),
(192590, '3.20.20.70-FF-000419', NULL, 'Putative DNA modification/repair radical SAM protein', 149, NULL, NULL, 192590),
(192591, '3.40.50.2000-FF-000828', NULL, 'Uncharacterized protein', 161, NULL, NULL, 192591),
(192592, '3.30.200.20-FF-002458', NULL, 'CDC7 protein kinase', 55, NULL, NULL, 192592),
(192593, '1.25.40.10-FF-003174', NULL, 'YALI0A15686p', 108, NULL, NULL, 192593),
(192594, '3.30.200.20-FF-000480', NULL, 'Mitogen-activated protein kinase kinase 3', 102, NULL, NULL, 192594),
(192595, '2.60.40.10-FF-003366', NULL, 'Myotactin form A', 84, NULL, NULL, 192595),
(192596, '3.90.70.10-FF-000683', NULL, 'Uncharacterized protein', 249, NULL, NULL, 192596),
(192597, '3.40.50.720-FF-002514', NULL, '3-methylornithyl-N6-L-lysine dehydrogenase', 124, NULL, NULL, 192597),
(192598, '1.25.40.10-FF-001100', NULL, 'Pentatricopeptide repeat-containing protein', 102, NULL, NULL, 192598),
(192599, '3.40.50.300-FF-004018', NULL, 'ATP-dependent RNA helicase RhlE', 169, NULL, NULL, 192599),
(192600, '3.10.20.90-FF-000898', NULL, 'Uncharacterized protein', 86, NULL, NULL, 192600);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(192601, '2.30.180.10-FF-000141', NULL, NULL, 142, NULL, NULL, 192601),
(192602, '3.30.160.60-FF-003579', NULL, 'Zinc finger protein 235', 70, NULL, NULL, 192602),
(192603, '2.60.40.10-FF-004708', NULL, NULL, 89, NULL, NULL, 192603),
(192604, '1.20.140.40-FF-000058', NULL, NULL, 135, NULL, NULL, 192604),
(192605, '3.40.50.2300-FF-001655', NULL, NULL, 198, NULL, NULL, 192605),
(192606, '3.30.470.160-FF-000014', NULL, 'Kinase', 115, NULL, NULL, 192606),
(192607, '3.30.710.10-FF-000066', NULL, 'kelch-like protein 8 isoform X1', 127, NULL, NULL, 192607),
(192608, '2.10.25.10-FF-001000', NULL, 'Stabilin 2', 36, NULL, NULL, 192608),
(192609, '3.30.160.60-FF-000201', NULL, 'C2H2 finger domain protein (Gli3)', 38, NULL, NULL, 192609),
(192610, '3.30.60.30-FF-000174', NULL, 'Uncharacterized protein', 63, NULL, NULL, 192610),
(192611, '3.30.160.60-FF-003635', NULL, NULL, 24, NULL, NULL, 192611),
(192612, '3.40.50.720-FF-002458', NULL, 'Shikimate 5-dehydrogenase', 141, NULL, NULL, 192612),
(192613, '1.25.10.10-FF-003402', NULL, 'Uncharacterized protein', 110, NULL, NULL, 192613),
(192614, '2.60.40.10-FF-003422', NULL, NULL, 107, NULL, NULL, 192614),
(192615, '1.25.40.10-FF-003230', NULL, 'Pentatricopeptide repeat-containing protein', 47, NULL, NULL, 192615),
(192616, '2.40.50.120-FF-000051', NULL, 'Netrin-1', 134, NULL, NULL, 192616),
(192617, '2.60.40.150-FF-000401', NULL, 'Uncharacterized protein', 121, NULL, NULL, 192617),
(192618, '3.30.160.60-FF-000145', NULL, 'Zinc finger protein 574', 27, NULL, NULL, 192618),
(192619, '3.90.1150.160-FF-000007', NULL, 'Glutamate decarboxylase', 101, NULL, NULL, 192619),
(192620, '3.40.190.10-FF-000894', NULL, 'Fe(III)-induced transcriptional regulator IfcR', 99, NULL, NULL, 192620),
(192621, '1.25.40.10-FF-004534', NULL, 'Uncharacterized protein', 60, NULL, NULL, 192621),
(192622, '3.90.550.10-FF-000629', NULL, 'Predicted protein', 192, NULL, NULL, 192622),
(192623, '2.10.70.10-FF-000014', NULL, 'Membrane cofactor protein', 59, NULL, NULL, 192623),
(192624, '2.60.40.10-FF-000437', NULL, 'Beat-IIIc, isoform A', 110, NULL, NULL, 192624),
(192625, '1.10.225.10-FF-000029', NULL, 'Aspartic proteinase A1', 96, NULL, NULL, 192625),
(192626, '2.40.160.210-FF-000019', NULL, 'HotDog domain-containing protein', 313, NULL, NULL, 192626),
(192627, '1.10.10.10-FF-000529', NULL, 'MurR/RpiR family transcriptional regulator', 104, NULL, NULL, 192627),
(192628, '3.40.50.1110-FF-000152', NULL, 'Os01g0543400 protein', 78, NULL, NULL, 192628),
(192629, '3.80.10.10-FF-001045', NULL, 'RANGAP1 isoform 5', 113, NULL, NULL, 192629),
(192630, '2.130.10.10-FF-001022', NULL, 'Ubiquitin ligase subunit', 375, NULL, NULL, 192630),
(192631, '2.120.10.80-FF-000138', NULL, 'Calicin', 112, NULL, NULL, 192631),
(192632, '2.130.10.10-FF-002770', NULL, 'Uncharacterized protein', 233, NULL, NULL, 192632),
(192633, '3.40.50.720-FF-001154', NULL, 'Expressed protein', 44, NULL, NULL, 192633),
(192634, '1.25.40.10-FF-004427', NULL, 'Pentatricopeptide repeat-containing protein', 126, NULL, NULL, 192634),
(192635, '3.40.50.150-FF-000792', NULL, NULL, 80, NULL, NULL, 192635),
(192636, '3.30.70.2460-FF-000008', NULL, NULL, 74, NULL, NULL, 192636),
(192637, '3.90.120.10-FF-000024', NULL, 'Uncharacterized protein', 48, NULL, NULL, 192637),
(192638, '3.30.70.330-FF-002757', NULL, NULL, 81, NULL, NULL, 192638),
(192639, '2.60.120.260-FF-000128', NULL, 'Allantoicase, putative', 168, NULL, NULL, 192639),
(192640, '2.60.40.10-FF-005496', NULL, NULL, 95, NULL, NULL, 192640),
(192641, '1.20.1270.10-FF-000092', NULL, 'Uncharacterized protein', 113, NULL, NULL, 192641),
(192642, '1.50.10.10-FF-000135', NULL, 'Glucan 1,4-alpha-glucosidase', 520, NULL, NULL, 192642),
(192643, '1.10.287.2620-FF-000012', NULL, 'Dynein heavy chain', 64, NULL, NULL, 192643),
(192644, '3.40.640.10-FF-000417', NULL, 'Uncharacterized protein', 62, NULL, NULL, 192644),
(192645, '1.10.10.10-FF-000816', NULL, 'Cell division control protein', 98, NULL, NULL, 192645),
(192646, '2.70.98.70-FF-000003', NULL, NULL, 270, NULL, NULL, 192646),
(192647, '3.40.50.300-FF-005710', NULL, 'SARP family transcriptional regulator', 168, NULL, NULL, 192647);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(192648, '1.10.150.770-FF-000007', NULL, NULL, 65, NULL, NULL, 192648),
(192649, '3.40.50.10190-FF-000120', NULL, 'WGS project CABT00000000 data, contig 2.8', 102, NULL, NULL, 192649),
(192650, '2.70.98.90-FF-000009', NULL, 'Membrane protein insertase YidC', 273, NULL, NULL, 192650),
(192651, '3.40.50.1820-FF-000269', NULL, 'Acyl-CoA thioesterase 6', 207, NULL, NULL, 192651),
(192652, '3.80.10.10-FF-001101', NULL, 'Protein phosphatase 2C, putative', 117, NULL, NULL, 192652),
(192653, '1.20.58.60-FF-000772', NULL, 'Microtubule-actin crosslinking factor 1', 240, NULL, NULL, 192653),
(192654, '3.30.1600.10-FF-000029', NULL, 'NAD-dependent protein deacetylase', 114, NULL, NULL, 192654),
(192655, '3.50.50.60-FF-001283', NULL, 'Lycopene epsilon cyclase', 44, NULL, NULL, 192655),
(192656, '2.40.20.10-FF-000100', NULL, 'Uncharacterized protein', 134, NULL, NULL, 192656),
(192657, '1.10.1420.10-FF-000089', NULL, 'mutS protein homolog 4', 187, NULL, NULL, 192657),
(192658, '2.130.10.10-FF-006036', NULL, 'Predicted protein', 285, NULL, NULL, 192658),
(192659, '3.60.21.10-FF-000003', NULL, 'Serine/threonine-protein phosphatase', 308, NULL, NULL, 192659),
(192660, '1.20.120.350-FF-000126', NULL, 'Related to CCH1-Calcium channel (Alpha subunit)', 121, NULL, NULL, 192660),
(192661, '2.40.33.40-FF-000003', NULL, 'PTS sorbitol transporter subunit IIA', 116, NULL, NULL, 192661),
(192662, '1.10.10.1760-FF-000011', NULL, 'Ribosomal protein L36, putative', 87, NULL, NULL, 192662),
(192663, '1.20.58.390-FF-000291', NULL, 'Uncharacterized protein', 117, NULL, NULL, 192663),
(192664, '3.30.930.10-FF-000392', NULL, 'Predicted protein', 166, NULL, NULL, 192664),
(192665, '3.90.800.10-FF-000009', NULL, NULL, 46, NULL, NULL, 192665),
(192666, '3.30.70.330-FF-001341', NULL, 'Regulatory protein E2', 86, NULL, NULL, 192666),
(192667, '1.10.10.10-FF-000636', NULL, 'Histone H1', 92, NULL, NULL, 192667),
(192668, '2.60.40.10-FF-001218', NULL, 'Protein tyrosine phosphatase, receptor type B', 92, NULL, NULL, 192668),
(192669, '3.30.710.10-FF-000122', NULL, 'potassium voltage-gated channel subfamily A member 7', 103, NULL, NULL, 192669),
(192670, '2.60.120.260-FF-000460', NULL, 'Arabinofuranosidase 1', 169, NULL, NULL, 192670),
(192671, '2.102.10.10-FF-000063', NULL, 'RE52861p', 134, NULL, NULL, 192671),
(192672, '2.30.29.30-FF-000772', NULL, 'RANBP3 isoform 10', 91, NULL, NULL, 192672),
(192673, '2.20.25.10-FF-000078', NULL, 'DNA-directed RNA polymerase subunit', 63, NULL, NULL, 192673),
(192674, '1.20.1070.10-FF-000941', NULL, 'Serotonin receptor-like protein', 141, NULL, NULL, 192674),
(192675, '3.90.290.10-FF-000025', NULL, 'Fibrillin-1', 68, NULL, NULL, 192675),
(192676, '2.60.40.420-FF-000117', NULL, 'Protein CBR-EFN-2', 146, NULL, NULL, 192676),
(192677, '3.30.499.10-FF-000012', NULL, 'Iron-responsive element binding protein 2', 140, NULL, NULL, 192677),
(192678, '3.30.470.20-FF-000258', NULL, 'Predicted protein', 88, NULL, NULL, 192678),
(192679, '2.60.40.1150-FF-000002', NULL, 'Beta-adaptin-like protein C', 112, NULL, NULL, 192679),
(192680, '3.30.160.60-FF-005996', NULL, NULL, 46, NULL, NULL, 192680),
(192681, '3.30.70.340-FF-000001', NULL, 'Carboxypeptidase A5', 93, NULL, NULL, 192681),
(192682, '2.60.120.620-FF-000107', NULL, 'Predicted protein', 177, NULL, NULL, 192682),
(192683, '1.10.287.990-FF-000005', NULL, 'Superoxide dismutase [Fe]', 62, NULL, NULL, 192683),
(192684, '3.10.100.10-FF-000193', NULL, 'Predicted protein', 137, NULL, NULL, 192684),
(192685, '1.20.1070.10-FF-001453', NULL, 'AKH/corazonin-related peptide', 219, NULL, NULL, 192685),
(192686, '3.10.100.10-FF-000081', NULL, 'FRAS1 related extracellular matrix 1', 137, NULL, NULL, 192686),
(192687, '3.30.40.10-FF-000689', NULL, 'RING-type E3 ubiquitin transferase', 96, NULL, NULL, 192687),
(192688, '1.25.40.10-FF-000936', NULL, 'Protein CTR9 homolog', 142, NULL, NULL, 192688),
(192689, '3.30.40.10-FF-001307', NULL, 'Peroxisome biosynthesis protein (PAS10/Peroxin-12), putative', 76, NULL, NULL, 192689),
(192690, '1.20.120.1710-FF-000002', NULL, 'NAD-dependent histone deacetylase SIR2', 134, NULL, NULL, 192690);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(192691, '2.30.30.40-FF-000626', NULL, 'Uncharacterized protein', 17, NULL, NULL, 192691),
(192692, '1.10.150.50-FF-000053', NULL, 'Bifunctional apoptosis regulator', 86, NULL, NULL, 192692),
(192693, '3.10.20.90-FF-000954', NULL, 'Uncharacterized protein', 61, NULL, NULL, 192693),
(192694, '3.30.70.980-FF-000069', NULL, 'Uncharacterized protein', 79, NULL, NULL, 192694),
(192695, '3.30.497.10-FF-000119', NULL, 'AGAP009212-PA', 212, NULL, NULL, 192695),
(192696, '3.30.200.20-FF-000660', NULL, 'Uncharacterized protein', 90, NULL, NULL, 192696),
(192697, '3.40.850.10-FF-000231', NULL, 'Kinesin like protein', 377, NULL, NULL, 192697),
(192698, '2.60.40.10-FF-002910', NULL, 'Plexin A2', 73, NULL, NULL, 192698),
(192699, '3.30.200.20-FF-000328', NULL, 'Leucine-rich repeat protein kinase family protein', 112, NULL, NULL, 192699),
(192700, '3.20.140.10-FF-000030', NULL, 'Nicotinate phosphoribosyltransferase 2', 135, NULL, NULL, 192700),
(192701, '3.40.20.10-FF-000030', NULL, 'protein flightless-1 homolog isoform X1', 97, NULL, NULL, 192701),
(192702, '3.40.50.300-FF-002040', NULL, 'ABC multidrug transporter (Eurofung)', 282, NULL, NULL, 192702),
(192703, '3.40.50.2300-FF-001599', NULL, NULL, 96, NULL, NULL, 192703),
(192704, '1.20.1600.10-FF-000016', NULL, 'Outer membrane protein', 384, NULL, NULL, 192704),
(192705, '3.40.390.10-FF-000151', NULL, NULL, 100, NULL, NULL, 192705),
(192706, '1.10.600.10-FF-000087', NULL, 'Farnesyl pyrophosphate synthase', 209, NULL, NULL, 192706),
(192707, '2.60.40.150-FF-000345', NULL, 'DnaJ domain containing protein', 120, NULL, NULL, 192707),
(192708, '3.30.780.10-FF-000071', NULL, 'Translation machinery-associated protein 22', 113, NULL, NULL, 192708),
(192709, '1.10.555.10-FF-000133', NULL, NULL, 62, NULL, NULL, 192709),
(192710, '2.60.40.1180-FF-000106', NULL, 'Glucan 1,6-alpha-glucosidase', 72, NULL, NULL, 192710),
(192711, '1.25.40.1030-FF-000021', NULL, 'Predicted protein', 413, NULL, NULL, 192711),
(192712, '2.60.120.10-FF-000445', NULL, 'Probable mannose-6-phosphate isomerase', 200, NULL, NULL, 192712),
(192713, '3.30.460.20-FF-000021', NULL, 'CorA-like Mg2+ transporter family protein', 115, NULL, NULL, 192713),
(192714, '3.90.1580.10-FF-000007', NULL, 'Formylglycine-generating enzyme family protein', 295, NULL, NULL, 192714),
(192715, '1.20.900.10-FF-000074', NULL, 'RHo Guanine nucleotide exchange Factor', 230, NULL, NULL, 192715),
(192716, '3.40.50.2000-FF-000087', NULL, 'Glycosyltransferase', 254, NULL, NULL, 192716),
(192717, '3.20.20.70-FF-000751', NULL, NULL, 67, NULL, NULL, 192717),
(192718, '3.40.50.300-FF-006435', NULL, 'Predicted protein', 127, NULL, NULL, 192718),
(192719, '3.30.70.870-FF-000036', NULL, 'Elongation factor 2', 72, NULL, NULL, 192719),
(192720, '1.10.510.10-FF-003694', NULL, NULL, 167, NULL, NULL, 192720),
(192721, '2.130.10.10-FF-004799', NULL, 'Uncharacterized protein', 147, NULL, NULL, 192721),
(192722, '1.10.510.10-FF-002906', NULL, 'CK1 family protein kinase', 323, NULL, NULL, 192722),
(192723, '2.60.260.20-FF-000104', NULL, 'DnaJ family protein chaperone, putative', 71, NULL, NULL, 192723),
(192724, '3.40.50.1000-FF-000629', NULL, NULL, 129, NULL, NULL, 192724),
(192725, '4.10.365.10-FF-000011', NULL, 'Uncharacterized protein', 67, NULL, NULL, 192725),
(192726, '3.80.10.10-FF-003462', NULL, 'Uncharacterized protein', 228, NULL, NULL, 192726),
(192727, '3.40.1620.70-FF-000001', NULL, 'Multiplexin collagen isoform Ap3', 54, NULL, NULL, 192727),
(192728, '3.20.20.140-FF-000118', NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', 177, NULL, NULL, 192728),
(192729, '3.30.1520.10-FF-000028', NULL, 'sorting nexin 1 isoform X2', 130, NULL, NULL, 192729),
(192730, '3.90.640.10-FF-000283', NULL, 'Uncharacterized protein', 92, NULL, NULL, 192730),
(192731, '1.10.510.10-FF-003306', NULL, NULL, 79, NULL, NULL, 192731),
(192732, '3.90.1410.10-FF-000113', NULL, 'Uncharacterized protein', 219, NULL, NULL, 192732),
(192733, '3.20.20.220-FF-000047', NULL, 'Proline dehydrogenase', 259, NULL, NULL, 192733),
(192734, '1.10.238.10-FF-000008', NULL, 'Dystrophin isoform 2', 82, NULL, NULL, 192734);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(192735, '2.60.40.60-FF-000250', NULL, 'Cadherin related family member 3', 106, NULL, NULL, 192735),
(192736, '2.60.40.10-FF-004203', NULL, NULL, 112, NULL, NULL, 192736),
(192737, '3.80.10.10-FF-002349', NULL, 'Uncharacterized protein', 167, NULL, NULL, 192737),
(192738, '3.40.50.2000-FF-000323', NULL, 'Starch synthase 3', 59, NULL, NULL, 192738),
(192739, '3.30.450.30-FF-000029', NULL, 'Dynein light chain roadblock', 96, NULL, NULL, 192739),
(192740, '2.120.10.30-FF-000152', NULL, 'Uncharacterized protein', 141, NULL, NULL, 192740),
(192741, '1.10.490.10-FF-000032', NULL, 'Uncharacterized protein', 154, NULL, NULL, 192741),
(192742, '2.60.40.10-FF-004147', NULL, NULL, 90, NULL, NULL, 192742),
(192743, '3.40.50.970-FF-000071', NULL, '2-hydroxyphytanoyl-CoA lyase, putative', 230, NULL, NULL, 192743),
(192744, '1.25.40.10-FF-002117', NULL, 'Pentatricopeptide repeat-containing protein', 90, NULL, NULL, 192744),
(192745, '3.30.1490.20-FF-000034', NULL, 'D-alanine--D-alanine ligase', 68, NULL, NULL, 192745),
(192746, '3.40.50.150-FF-001230', NULL, NULL, 74, NULL, NULL, 192746),
(192747, '2.40.10.10-FF-000094', NULL, 'Phage baseplate hub subunit', 116, NULL, NULL, 192747),
(192748, '1.25.10.10-FF-002621', NULL, 'Uncharacterized protein', 131, NULL, NULL, 192748),
(192749, '1.25.40.10-FF-004247', NULL, 'Uncharacterized protein', 235, NULL, NULL, 192749),
(192750, '2.30.30.100-FF-000234', NULL, 'Sm-like protein LSM6A', 37, NULL, NULL, 192750),
(192751, '3.90.550.10-FF-000068', NULL, 'ALG5, dolichyl-phosphate beta-glucosyltransferase', 286, NULL, NULL, 192751),
(192752, '2.60.40.10-FF-003927', NULL, NULL, 107, NULL, NULL, 192752),
(192753, '2.40.10.10-FF-000150', NULL, 'Chymotrypsin-like protease CTRL-1', 242, NULL, NULL, 192753),
(192754, '1.20.58.1770-FF-000006', NULL, 'Uncharacterized protein (Fragment)', 127, NULL, NULL, 192754),
(192755, '2.60.120.10-FF-000501', NULL, 'Cyclic nucleotide-gated potassium channel', 99, NULL, NULL, 192755),
(192756, '3.80.10.10-FF-002405', NULL, 'PH domain and leucine rich repeat protein phosphatase 1', 136, NULL, NULL, 192756),
(192757, '2.60.120.260-FF-000308', NULL, 'Beta-galactosidase', 148, NULL, NULL, 192757),
(192758, '3.30.70.3250-FF-000026', NULL, NULL, 101, NULL, NULL, 192758),
(192759, '2.130.10.10-FF-004456', NULL, 'Ribosome biogenesis protein WDR12 homolog', 344, NULL, NULL, 192759),
(192760, '2.40.70.10-FF-000159', NULL, 'Eukaryotic aspartyl protease family protein, expressed', 189, NULL, NULL, 192760),
(192761, '3.30.420.80-FF-000014', NULL, 'Probable ribosomal protein S11, mitochondrial', 130, NULL, NULL, 192761),
(192762, '1.10.3210.10-FF-000051', NULL, 'Cyclic di-GMP phosphodiesterase PA4781', 218, NULL, NULL, 192762),
(192763, '2.30.30.100-FF-000178', NULL, 'YALI0F30426p', 135, NULL, NULL, 192763),
(192764, '2.40.150.20-FF-000033', NULL, '60S ribosomal protein L14, mitochondrial', 129, NULL, NULL, 192764),
(192765, '3.60.40.10-FF-000311', NULL, '2C-type protein phosphatase protein', 235, NULL, NULL, 192765),
(192766, '2.30.38.10-FF-000023', NULL, 'N-(5-amino-5-carboxypentanoyl)-L-cysteinyl-D-valine synthase', 88, NULL, NULL, 192766),
(192767, '3.60.110.10-FF-000002', NULL, 'Nitrilase family member 2', 274, NULL, NULL, 192767),
(192768, '3.30.70.1230-FF-000033', NULL, 'Adenylate cyclase', 222, NULL, NULL, 192768),
(192769, '3.40.50.1780-FF-000037', NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', 13, NULL, NULL, 192769),
(192770, '1.20.1270.280-FF-000033', NULL, 'Dynein heavy chain 5, axonemal', 161, NULL, NULL, 192770),
(192771, '3.30.160.60-FF-002562', NULL, 'Zinc finger protein 556', 27, NULL, NULL, 192771),
(192772, '3.40.50.2000-FF-000267', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 216, NULL, NULL, 192772),
(192773, '3.40.50.2300-FF-000295', NULL, 'LacI family transcriptional regulator', 121, NULL, NULL, 192773),
(192774, '3.40.50.300-FF-001820', NULL, 'ABC transporter ATP-binding protein', 235, NULL, NULL, 192774),
(192775, '1.10.238.10-FF-000683', NULL, 'EH domain-containing protein 1', 100, NULL, NULL, 192775);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(192776, '2.40.10.170-FF-000001', NULL, 'CarD family transcriptional regulator', 60, NULL, NULL, 192776),
(192777, '3.30.200.20-FF-001784', NULL, 'AGC family protein kinase', 110, NULL, NULL, 192777),
(192778, '3.10.390.10-FF-000011', NULL, 'ski oncogene', 97, NULL, NULL, 192778),
(192779, '1.10.8.10-FF-000220', NULL, 'YALI0A18007p', 58, NULL, NULL, 192779),
(192780, '1.10.630.10-FF-000763', NULL, 'Uncharacterized protein', 483, NULL, NULL, 192780),
(192781, '1.10.510.10-FF-001221', NULL, 'Mitogen-activated protein kinase', 227, NULL, NULL, 192781),
(192782, '3.40.1190.20-FF-000048', NULL, 'Fructoselysine 6-kinase', 273, NULL, NULL, 192782),
(192783, '2.60.40.10-FF-005108', NULL, NULL, 98, NULL, NULL, 192783),
(192784, '3.80.10.10-FF-001444', NULL, 'ELRR (Extracellular Leucine-Rich Repeat) ONly', 116, NULL, NULL, 192784),
(192785, '1.25.40.570-FF-000004', NULL, '26S proteasome non-ATPase regulatory subunit 6', 332, NULL, NULL, 192785),
(192786, '1.10.8.10-FF-000164', NULL, 'XPC-binding_domain/UBA/TS-N_domain_containing_protein', 40, NULL, NULL, 192786),
(192787, '2.60.40.10-FF-002966', NULL, 'Periplasmic beta-glucosidase', 110, NULL, NULL, 192787),
(192788, '3.40.50.720-FF-000772', NULL, 'Hydroxyacid dehydrogenase', 116, NULL, NULL, 192788),
(192789, '3.40.50.1460-FF-000003', NULL, 'GPI-anchor transamidase', 285, NULL, NULL, 192789),
(192790, '3.30.50.10-FF-000116', NULL, 'Nuclear receptor subfamily 4, group A, member 1', 99, NULL, NULL, 192790),
(192791, '1.10.1760.20-FF-000016', NULL, NULL, 218, NULL, NULL, 192791),
(192792, '3.30.1740.10-FF-000011', NULL, 'DNA ligase', 104, NULL, NULL, 192792),
(192793, '4.10.280.10-FF-000106', NULL, 'Transcription factor ILI5', 66, NULL, NULL, 192793),
(192794, '3.20.20.190-FF-000055', NULL, 'Phosphoinositide phospholipase C', 320, NULL, NULL, 192794),
(192795, '3.40.50.410-FF-000105', NULL, 'Mesocentin', 200, NULL, NULL, 192795),
(192796, '3.30.70.120-FF-000047', NULL, NULL, 32, NULL, NULL, 192796),
(192797, '3.40.50.2300-FF-000351', NULL, 'Diguanylate cyclase', 127, NULL, NULL, 192797),
(192798, '1.10.533.10-FF-000296', NULL, 'Uncharacterized protein', 77, NULL, NULL, 192798),
(192799, '3.10.20.90-FF-000774', NULL, 'band 4.1-like protein 4 isoform X1', 94, NULL, NULL, 192799),
(192800, '3.40.50.1820-FF-001382', NULL, 'Uncharacterized protein', 221, NULL, NULL, 192800),
(192801, '2.40.50.90-FF-000018', NULL, 'Ribonuclease', 145, NULL, NULL, 192801),
(192802, '2.70.50.30-FF-000011', NULL, NULL, 133, NULL, NULL, 192802),
(192803, '3.40.50.10810-FF-000082', NULL, 'SNF2 domain-containing protein', 191, NULL, NULL, 192803),
(192804, '3.40.190.10-FF-000495', NULL, 'Hydrogen peroxide-inducible genes activator', 98, NULL, NULL, 192804),
(192805, '1.10.287.370-FF-000095', NULL, 'Uncharacterized protein', 77, NULL, NULL, 192805),
(192806, '4.10.1000.10-FF-000122', NULL, 'Uncharacterized protein', 33, NULL, NULL, 192806),
(192807, '3.40.1160.10-FF-000094', NULL, 'Uncharacterized protein', 49, NULL, NULL, 192807),
(192808, '4.10.40.10-FF-000002', NULL, 'Omega-hexatoxin-Hv2a', 45, NULL, NULL, 192808),
(192809, '2.60.11.10-FF-000016', NULL, 'Mitochondrial cytochrome c oxidase subunit 4, 13 kD', 79, NULL, NULL, 192809),
(192810, '3.20.20.80-FF-000012', NULL, 'Mannan endo-1,4-beta-mannosidase 6', 377, NULL, NULL, 192810),
(192811, '1.10.1410.10-FF-000083', NULL, 'Uncharacterized protein', 160, NULL, NULL, 192811),
(192812, '3.20.20.80-FF-000535', NULL, 'Beta-galactosidase (Eurofung)', 57, NULL, NULL, 192812),
(192813, '2.70.130.10-FF-000005', NULL, 'Insulin-like growth factor 2 receptor', 144, NULL, NULL, 192813),
(192814, '3.30.830.10-FF-000120', NULL, 'Mitochondrial-processing peptidase subunit alpha', 219, NULL, NULL, 192814),
(192815, '1.10.10.60-FF-000230', NULL, 'POU domain protein', 47, NULL, NULL, 192815),
(192816, '1.10.150.20-FF-000274', NULL, 'Predicted protein', 80, NULL, NULL, 192816),
(192817, '3.90.550.10-FF-000124', NULL, 'Glycosyl transferase family 2', 222, NULL, NULL, 192817),
(192818, '2.40.30.110-FF-000010', NULL, 'Aminomethyltransferase', 85, NULL, NULL, 192818);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(192819, '2.50.20.10-FF-000015', NULL, 'Outer-membrane lipoprotein carrier protein', 185, NULL, NULL, 192819),
(192820, '4.10.400.10-FF-000083', NULL, 'Atrial natriuretic peptide-converting enzyme', 35, NULL, NULL, 192820),
(192821, '3.40.50.10130-FF-000029', NULL, 'Predicted protein', 143, NULL, NULL, 192821),
(192822, '1.25.40.180-FF-000157', NULL, NULL, 240, NULL, NULL, 192822),
(192823, '3.30.760.10-FF-000069', NULL, 'Translation initiation factor eIF 4e-like domain-containing protein', 213, NULL, NULL, 192823),
(192824, '2.130.10.10-FF-000241', NULL, 'periodic tryptophan protein 1 homolog', 344, NULL, NULL, 192824),
(192825, '1.25.40.10-FF-005208', NULL, 'Uncharacterized protein', 203, NULL, NULL, 192825),
(192826, '3.40.50.1000-FF-000012', NULL, 'Phospholipid-transporting ATPase', 205, NULL, NULL, 192826),
(192827, '1.10.287.70-FF-000078', NULL, 'Putative Inward rectifier potassium channel', 137, NULL, NULL, 192827),
(192828, '3.40.50.2300-FF-000874', NULL, NULL, 27, NULL, NULL, 192828),
(192829, '1.20.1070.10-FF-001397', NULL, 'Uncharacterized protein', 240, NULL, NULL, 192829),
(192830, '3.30.450.20-FF-000083', NULL, 'Cyclic di-GMP phosphodiesterase Gmr', 118, NULL, NULL, 192830),
(192831, '1.25.40.10-FF-002393', NULL, 'Os01g0914600 protein', 172, NULL, NULL, 192831),
(192832, '1.20.1270.420-FF-000002', NULL, 'Inhibitor of nuclear factor kappa B kinase subunit epsilon', 243, NULL, NULL, 192832),
(192833, '1.10.8.1220-FF-000001', NULL, 'Dynein axonemal heavy chain 5', 91, NULL, NULL, 192833),
(192834, '3.40.50.10420-FF-000015', NULL, '5-formyltetrahydrofolate cyclo-ligase', 179, NULL, NULL, 192834),
(192835, '3.30.1360.40-FF-000036', NULL, 'Probable DNA topoisomerase 2', 60, NULL, NULL, 192835),
(192836, '1.20.1250.20-FF-000368', NULL, 'MFS transporter', 188, NULL, NULL, 192836),
(192837, '2.120.10.80-FF-000318', NULL, 'Predicted protein', 168, NULL, NULL, 192837),
(192838, '3.30.200.20-FF-001385', NULL, 'AGC family protein kinase', 91, NULL, NULL, 192838),
(192839, '3.40.50.2300-FF-001312', NULL, NULL, 115, NULL, NULL, 192839),
(192840, '1.10.3380.10-FF-000052', NULL, 'ER-targeted preprotein translocase subunit', 150, NULL, NULL, 192840),
(192841, '1.10.238.210-FF-000004', NULL, 'CRE-GLNA-3 protein', 86, NULL, NULL, 192841),
(192842, '1.10.287.70-FF-000639', NULL, 'Predicted protein', 188, NULL, NULL, 192842),
(192843, '3.30.379.10-FF-000014', NULL, 'O-GlcNAcase NagJ', 146, NULL, NULL, 192843),
(192844, '1.10.472.10-FF-000215', NULL, 'Transcription initiation factor IIIB chain BRF, putative', 105, NULL, NULL, 192844),
(192845, '2.130.10.10-FF-000584', NULL, 'Dynein intermediate chain 2', 166, NULL, NULL, 192845),
(192846, '2.150.10.10-FF-000015', NULL, NULL, 86, NULL, NULL, 192846),
(192847, '2.10.70.10-FF-000290', NULL, 'Uncharacterized protein', 55, NULL, NULL, 192847),
(192848, '1.20.1070.10-FF-002178', NULL, 'Uncharacterized protein', 110, NULL, NULL, 192848),
(192849, '3.90.1150.10-FF-000126', NULL, 'Aspartate aminotransferase', 109, NULL, NULL, 192849),
(192850, '1.10.20.10-FF-000137', NULL, 'DNA polymerase epsilon p12 subunit', 118, NULL, NULL, 192850),
(192851, '1.20.1110.10-FF-000260', NULL, NULL, 85, NULL, NULL, 192851),
(192852, '3.30.160.60-FF-000089', NULL, 'DNA-binding protein creA', 28, NULL, NULL, 192852),
(192853, '3.40.50.10240-FF-000006', NULL, 'Thiamin pyrophosphokinase 1', 228, NULL, NULL, 192853),
(192854, '2.130.10.10-FF-005255', NULL, 'Uncharacterized protein', 272, NULL, NULL, 192854),
(192855, '3.90.1150.10-FF-000306', NULL, 'Glutamic-oxaloacetic transaminase 1-like 1', 52, NULL, NULL, 192855),
(192856, '3.40.50.720-FF-000373', NULL, 'UDP-glucose 4-epimerase', 217, NULL, NULL, 192856),
(192857, '3.30.390.30-FF-000030', NULL, 'Uncharacterized protein', 116, NULL, NULL, 192857),
(192858, '1.20.91.20-FF-000011', NULL, 'Complement component C5', 81, NULL, NULL, 192858),
(192859, '3.40.50.720-FF-001210', NULL, 'Oxidoreductase', 249, NULL, NULL, 192859),
(192860, '3.40.50.300-FF-005654', NULL, 'Dynein heavy chain', 212, NULL, NULL, 192860),
(192861, '3.30.450.260-FF-000001', NULL, 'guanylate cyclase soluble subunit beta-1 isoform X1', 136, NULL, NULL, 192861);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(192862, '2.60.260.20-FF-000048', NULL, 'DnaJ family protein', 96, NULL, NULL, 192862),
(192863, '3.40.50.11320-FF-000010', NULL, 'Predicted protein', 81, NULL, NULL, 192863),
(192864, '2.130.10.10-FF-004979', NULL, 'Uncharacterized protein', 80, NULL, NULL, 192864),
(192865, '2.170.190.11-FF-000014', NULL, 'Molybdopterin molybdenumtransferase', 89, NULL, NULL, 192865),
(192866, '1.10.510.10-FF-004475', NULL, NULL, 328, NULL, NULL, 192866),
(192867, '3.30.160.60-FF-005491', NULL, NULL, 20, NULL, NULL, 192867),
(192868, '3.40.33.10-FF-000060', NULL, 'Uncharacterized protein', 159, NULL, NULL, 192868),
(192869, '2.60.200.40-FF-000045', NULL, 'Diacylglycerol kinase', 167, NULL, NULL, 192869),
(192870, '1.10.510.10-FF-001564', NULL, 'Si:dkey-31m14.7', 88, NULL, NULL, 192870),
(192871, '3.40.50.720-FF-000193', NULL, 'UDP-glucose 6-dehydrogenase', 221, NULL, NULL, 192871),
(192872, '3.30.200.20-FF-001441', NULL, 'TRAF2 and NCK-interacting kinase b', 48, NULL, NULL, 192872),
(192873, '1.10.10.350-FF-000032', NULL, NULL, 101, NULL, NULL, 192873),
(192874, '1.20.1070.10-FF-001958', NULL, 'Peptide receptor GPCR', 201, NULL, NULL, 192874),
(192875, '3.30.830.10-FF-000064', NULL, 'Mitochondrial-processing peptidase subunit alpha', 180, NULL, NULL, 192875),
(192876, '1.25.10.10-FF-000148', NULL, 'SIL1 nucleotide exchange factor', 289, NULL, NULL, 192876),
(192877, '1.10.8.60-FF-000482', NULL, 'Uncharacterized protein', 16, NULL, NULL, 192877),
(192878, '1.10.510.10-FF-002002', NULL, 'Uncharacterized protein', 184, NULL, NULL, 192878),
(192879, '1.20.1280.180-FF-000005', NULL, 'Prx-14', 43, NULL, NULL, 192879),
(192880, '3.40.1090.10-FF-000099', NULL, 'Phospholipase A2', 536, NULL, NULL, 192880),
(192881, '1.20.1560.10-FF-000136', NULL, 'ABC transporter ATP-binding protein', 314, NULL, NULL, 192881),
(192882, '3.40.47.10-FF-000182', NULL, 'Thiolase', 388, NULL, NULL, 192882),
(192883, '3.30.160.60-FF-001449', NULL, 'Uncharacterized protein, isoform C', 62, NULL, NULL, 192883),
(192884, '3.40.50.2000-FF-000666', NULL, 'Putative glycosyl transferase', 218, NULL, NULL, 192884),
(192885, '2.40.10.190-FF-000007', NULL, 'Uncharacterized protein', 97, NULL, NULL, 192885),
(192886, '3.40.190.10-FF-000219', NULL, 'ATP phosphoribosyltransferase His1', 120, NULL, NULL, 192886),
(192887, '1.10.630.10-FF-000420', NULL, 'Uncharacterized protein', 149, NULL, NULL, 192887),
(192888, '3.30.1370.10-FF-000090', NULL, 'KRR1 small subunit processome component', 103, NULL, NULL, 192888),
(192889, '1.20.1250.20-FF-001880', NULL, 'Uncharacterized protein', 99, NULL, NULL, 192889),
(192890, '3.40.50.1480-FF-000009', NULL, 'Adenosylhomocysteinase like 2', 82, NULL, NULL, 192890),
(192891, '3.80.10.10-FF-001388', NULL, 'Protein NSP-INTERACTING KINASE 2', 253, NULL, NULL, 192891),
(192892, '3.40.190.10-FF-000551', NULL, 'LysR family transcriptional regulator', 94, NULL, NULL, 192892),
(192893, '2.110.10.10-FF-000079', NULL, 'Matrix metallopeptidase 17b', 64, NULL, NULL, 192893),
(192894, '2.60.40.60-FF-001031', NULL, 'Uncharacterized protein', 102, NULL, NULL, 192894),
(192895, '1.20.5.110-FF-000027', NULL, 'ras association domain-containing protein 1 isoform X1', 51, NULL, NULL, 192895),
(192896, '3.30.160.60-FF-001781', NULL, 'zinc finger protein 496 isoform X2', 34, NULL, NULL, 192896),
(192897, '1.25.10.10-FF-001660', NULL, 'YALI0D05049p', 350, NULL, NULL, 192897),
(192898, '1.20.1250.20-FF-002280', NULL, 'Predicted protein', 90, NULL, NULL, 192898),
(192899, '1.10.3730.20-FF-000020', NULL, 'Uncharacterized protein', 104, NULL, NULL, 192899),
(192900, '3.30.160.60-FF-004692', NULL, NULL, 42, NULL, NULL, 192900),
(192901, '2.60.40.60-FF-000755', NULL, 'Predicted protein', 107, NULL, NULL, 192901),
(192902, '1.10.10.740-FF-000003', NULL, 'Uncharacterized protein', 41, NULL, NULL, 192902),
(192903, '2.10.25.10-FF-001343', NULL, 'Fibulin-1', 43, NULL, NULL, 192903),
(192904, '3.40.1110.10-FF-000271', NULL, NULL, 120, NULL, NULL, 192904),
(192905, '3.40.50.300-FF-004693', NULL, 'ATP-dependent DNA helicase, putative', 190, NULL, NULL, 192905);
INSERT INTO "PUBLIC"."MODEL" VALUES
(192906, '1.25.40.10-FF-003410', NULL, 'Putative pentatricopeptide repeat-containing protein', 122, NULL, NULL, 192906),
(192907, '2.30.29.110-FF-000004', NULL, 'Inositol polyphosphate 5-phosphatase OCRL-1-like Protein', 153, NULL, NULL, 192907),
(192908, '3.30.160.60-FF-005092', NULL, NULL, 48, NULL, NULL, 192908),
(192909, '1.10.420.10-FF-000045', NULL, 'Uncharacterized protein', 64, NULL, NULL, 192909),
(192910, '3.40.50.300-FF-005530', NULL, 'Ras-related protein Rab-6A', 92, NULL, NULL, 192910),
(192911, '3.40.430.10-FF-000031', NULL, 'Riboflavin biosynthesis protein PYRD, chloroplastic', 214, NULL, NULL, 192911),
(192912, '3.40.50.880-FF-000156', NULL, 'DUF4434 domain-containing protein', 209, NULL, NULL, 192912),
(192913, '3.30.200.20-FF-001109', NULL, 'Serine/threonine protein kinase', 59, NULL, NULL, 192913),
(192914, '2.130.10.30-FF-000067', NULL, 'RCC1 domain-containing protein RUG3, mitochondrial', 211, NULL, NULL, 192914),
(192915, '3.30.300.10-FF-000035', NULL, 'S-adenosylmethionine synthetase', 37, NULL, NULL, 192915),
(192916, '1.10.10.60-FF-000573', NULL, 'Transcription factor Rap1, putative (AFU_orthologue AFUA_6G07560)', 56, NULL, NULL, 192916),
(192917, '3.40.50.300-FF-000983', NULL, 'Rho family GTPase', 186, NULL, NULL, 192917),
(192918, '3.30.200.20-FF-002402', NULL, 'Uncharacterized protein', 90, NULL, NULL, 192918),
(192919, '4.10.900.10-FF-000008', NULL, 'Cadherin 5', 100, NULL, NULL, 192919),
(192920, '1.25.10.10-FF-000709', NULL, 'HEAT repeat-containing protein 1 homolog', 88, NULL, NULL, 192920),
(192921, '2.60.40.10-FF-003186', NULL, NULL, 83, NULL, NULL, 192921),
(192922, '1.20.1250.20-FF-001329', NULL, 'Sugar transporter, putative', 155, NULL, NULL, 192922),
(192923, '3.30.230.10-FF-000164', NULL, 'MLH (MutL Homolog) family', 126, NULL, NULL, 192923),
(192924, '3.90.190.10-FF-000265', NULL, 'Predicted protein', 260, NULL, NULL, 192924),
(192925, '2.40.40.20-FF-000020', NULL, 'Formate dehydrogenase subunit alpha', 114, NULL, NULL, 192925),
(192926, '3.30.160.60-FF-003236', NULL, 'GM11812', 63, NULL, NULL, 192926),
(192927, '3.30.200.20-FF-000665', NULL, 'MAP kinase kinase (Pbs2)', 69, NULL, NULL, 192927),
(192928, '3.40.50.12780-FF-000161', NULL, 'Putative siderophore synthetase (Eurofung)', 108, NULL, NULL, 192928),
(192929, '1.25.40.10-FF-004135', NULL, 'U3 small nucleolar RNA-associated protein 6 homolog', 119, NULL, NULL, 192929),
(192930, '3.90.380.10-FF-000009', NULL, 'mRNA, clone: RTFL01-01-M20', 208, NULL, NULL, 192930),
(192931, '1.20.58.1120-FF-000002', NULL, 'Dynein heavy chain 9, axonemal', 146, NULL, NULL, 192931),
(192932, '2.40.10.10-FF-000498', NULL, NULL, 110, NULL, NULL, 192932),
(192933, '3.30.230.130-FF-000019', NULL, 'Cullin-like protein-like protein', 156, NULL, NULL, 192933),
(192934, '3.60.10.10-FF-000057', NULL, 'Inositol-1, 4, 5-trisphosphate 5-Phosphatase-like protein, putative', 106, NULL, NULL, 192934),
(192935, '3.90.550.50-FF-000153', NULL, 'Fringe-related protein', 101, NULL, NULL, 192935),
(192936, '3.30.200.20-FF-002273', NULL, 'Uncharacterized protein', 111, NULL, NULL, 192936),
(192937, '3.10.400.20-FF-000011', NULL, 'PUA domain containing protein', 171, NULL, NULL, 192937),
(192938, '3.40.50.300-FF-002489', NULL, 'Small GTP binding protein rab6-like protein', 174, NULL, NULL, 192938),
(192939, '3.40.50.450-FF-000005', NULL, 'CASP-like protein', 187, NULL, NULL, 192939),
(192940, '3.40.50.300-FF-007340', NULL, 'Probable DNA helicase II homolog', 109, NULL, NULL, 192940),
(192941, '3.30.420.610-FF-000004', NULL, 'Meiosis regulator and mRNA stability factor 1', 82, NULL, NULL, 192941),
(192942, '3.40.309.10-FF-000075', NULL, 'Uncharacterized protein', 198, NULL, NULL, 192942),
(192943, '3.90.190.10-FF-000309', NULL, 'Protein CBG09113', 197, NULL, NULL, 192943),
(192944, '1.25.40.1040-FF-000007', NULL, 'N-alpha-acetyltransferase 25, NatB auxiliary subunit', 322, NULL, NULL, 192944),
(192945, '3.30.70.330-FF-002521', NULL, NULL, 60, NULL, NULL, 192945),
(192946, '1.50.10.10-FF-000163', NULL, 'Glucoamylase/glucan 1,4-alpha-glucosidase, putative', 176, NULL, NULL, 192946); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(192947, '3.40.50.720-FF-001553', NULL, 'Probable oxidoreductase (Short-chain dehydrogenase family)', 253, NULL, NULL, 192947),
(192948, '2.10.25.10-FF-000247', NULL, 'Delta/notch like EGF repeat containing', 38, NULL, NULL, 192948),
(192949, '3.90.1170.10-FF-000004', NULL, '60S ribosomal protein L10 isoform X2', 116, NULL, NULL, 192949),
(192950, '3.40.50.720-FF-001070', NULL, 'Oxidoreductase', 353, NULL, NULL, 192950),
(192951, '2.40.30.170-FF-000033', NULL, 'AcrA/AcrE family protein', 66, NULL, NULL, 192951),
(192952, '3.30.70.260-FF-000191', NULL, 'Uncharacterized protein', 90, NULL, NULL, 192952),
(192953, '1.20.120.2010-FF-000002', NULL, 'Ci-NAB1/2 protein', 138, NULL, NULL, 192953),
(192954, '1.25.10.10-FF-003009', NULL, 'Predicted protein', 338, NULL, NULL, 192954),
(192955, '1.20.1250.20-FF-001200', NULL, 'BcDNA.LD28120', 185, NULL, NULL, 192955),
(192956, '1.10.8.730-FF-000002', NULL, 'TrwK protein', 36, NULL, NULL, 192956),
(192957, '3.40.50.300-FF-002017', NULL, 'Dynein-related AAA-type ATPase', 128, NULL, NULL, 192957),
(192958, '3.40.395.10-FF-000038', NULL, 'Uncharacterized protein', 186, NULL, NULL, 192958),
(192959, '3.30.70.1400-FF-000022', NULL, 'Glycine cleavage system T protein', 85, NULL, NULL, 192959),
(192960, '2.60.40.1730-FF-000024', NULL, 'Aminopeptidase', 208, NULL, NULL, 192960),
(192961, '3.10.129.10-FF-000236', NULL, 'Gll1961 protein', 145, NULL, NULL, 192961),
(192962, '1.25.40.10-FF-000875', NULL, 'Pentatricopeptide repeat-containing protein isoform A', 181, NULL, NULL, 192962),
(192963, '3.50.50.60-FF-000698', NULL, 'Octylphenol 4-monooxygenase', 262, NULL, NULL, 192963),
(192964, '1.10.510.10-FF-000529', NULL, 'Kinase non-catalytic C-lobe domain-containing 1', 170, NULL, NULL, 192964),
(192965, '1.10.510.10-FF-001148', NULL, 'Alk1p', 124, NULL, NULL, 192965),
(192966, '1.10.1170.10-FF-000007', NULL, 'Baculoviral IAP repeat-containing protein 1', 114, NULL, NULL, 192966),
(192967, '3.30.160.60-FF-005283', NULL, NULL, 92, NULL, NULL, 192967),
(192968, '3.30.559.10-FF-000079', NULL, 'Carnitine palmitoyltransferase 1B', 59, NULL, NULL, 192968),
(192969, '3.40.50.1820-FF-000302', NULL, 'Alpha/beta hydrolase', 311, NULL, NULL, 192969),
(192970, '3.50.50.60-FF-000226', NULL, 'Flavin-containing monooxygenase', 177, NULL, NULL, 192970),
(192971, '3.40.50.1010-FF-000032', NULL, 'Flap endonuclease GEN-like 1', 204, NULL, NULL, 192971),
(192972, '2.120.10.30-FF-000365', NULL, 'Acylamino-acid-releasing enzyme, conjectural', 220, NULL, NULL, 192972),
(192973, '2.40.30.10-FF-000398', NULL, 'Predicted protein', 89, NULL, NULL, 192973),
(192974, '3.40.50.300-FF-007823', NULL, 'Uncharacterized protein', 272, NULL, NULL, 192974),
(192975, '3.30.70.330-FF-002960', NULL, NULL, 102, NULL, NULL, 192975),
(192976, '1.25.10.10-FF-000255', NULL, 'Telomere-associated protein RIF1 isoform 1', 240, NULL, NULL, 192976),
(192977, '2.130.10.10-FF-000977', NULL, 'Transcription factor', 163, NULL, NULL, 192977),
(192978, '2.60.120.620-FF-000130', NULL, 'Uncharacterized protein', 57, NULL, NULL, 192978),
(192979, '2.60.40.10-FF-004698', NULL, NULL, 103, NULL, NULL, 192979),
(192980, '3.40.720.10-FF-000014', NULL, 'Hydrolase, inner membrane', 252, NULL, NULL, 192980),
(192981, '1.10.472.80-FF-000034', NULL, 'TBC1 domain family member 5', 145, NULL, NULL, 192981),
(192982, '1.10.150.910-FF-000016', NULL, 'Uncharacterized protein', 103, NULL, NULL, 192982),
(192983, '2.160.20.10-FF-000162', NULL, 'Pectin lyase domain protein', 327, NULL, NULL, 192983),
(192984, '3.20.180.20-FF-000013', NULL, 'Putative dynein heavy chain', 98, NULL, NULL, 192984),
(192985, '2.60.40.10-FF-001033', NULL, 'Uncharacterized protein, isoform H', 112, NULL, NULL, 192985),
(192986, '1.10.150.210-FF-000003', NULL, 'Phosphoserine phosphatase SerB', 52, NULL, NULL, 192986),
(192987, '3.40.50.1000-FF-000175', NULL, 'Trehalose 6-phosphate phosphatase', 159, NULL, NULL, 192987),
(192988, '2.30.29.30-FF-000328', NULL, 'Phosphatidylinositol 4,5-bisphosphate-binding protein SLM1', 119, NULL, NULL, 192988),
(192989, '3.40.50.720-FF-000125', NULL, 'tRNA threonylcarbamoyladenosine dehydratase 2-like', 262, NULL, NULL, 192989);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(192990, '1.10.287.1890-FF-000001', NULL, 'tRNA (Adenine(22)-N(1))-methyltransferase TrmK', 65, NULL, NULL, 192990),
(192991, '2.60.40.10-FF-005524', NULL, NULL, 63, NULL, NULL, 192991),
(192992, '3.30.70.330-FF-001532', NULL, 'Multiple RNA-binding domain-containing protein 1', 92, NULL, NULL, 192992),
(192993, '1.20.1270.50-FF-000007', NULL, 'Cytosolic alpha-mannosidase', 106, NULL, NULL, 192993),
(192994, '2.130.10.10-FF-004872', NULL, 'Katanin p80 WD40 repeat-containing subunit B1', 121, NULL, NULL, 192994),
(192995, '3.40.800.10-FF-000048', NULL, NULL, 138, NULL, NULL, 192995),
(192996, '3.30.342.10-FF-000019', NULL, 'DNA polymerase epsilon catalytic subunit', 195, NULL, NULL, 192996),
(192997, '2.80.10.50-FF-000278', NULL, 'Uncharacterized protein', 84, NULL, NULL, 192997),
(192998, '2.60.40.10-FF-002770', NULL, 'Glycoside hydrolase family 2 protein', 77, NULL, NULL, 192998),
(192999, '3.30.420.10-FF-000347', NULL, NULL, 157, NULL, NULL, 192999),
(193000, '3.10.100.10-FF-000272', NULL, NULL, 128, NULL, NULL, 193000),
(193001, '2.40.50.100-FF-000230', NULL, 'Uncharacterized protein', 33, NULL, NULL, 193001),
(193002, '3.30.1240.10-FF-000041', NULL, 'Cof-type HAD-IIB family hydrolase', 111, NULL, NULL, 193002),
(193003, '3.30.1390.10-FF-000006', NULL, 'ATP-dependent Clp protease adapter protein CLPS1, chloroplastic', 79, NULL, NULL, 193003),
(193004, '1.20.920.10-FF-000058', NULL, 'WD40/YVTN repeat-like-containing domain', 107, NULL, NULL, 193004),
(193005, '2.60.40.10-FF-005215', NULL, NULL, 91, NULL, NULL, 193005),
(193006, '3.40.50.620-FF-000197', NULL, 'Valyl tRNA synthetase', 237, NULL, NULL, 193006),
(193007, '3.30.70.270-FF-000081', NULL, 'Uncharacterized protein', 88, NULL, NULL, 193007),
(193008, '3.30.1490.20-FF-000062', NULL, 'Endospore coat-associated protein YheC', 57, NULL, NULL, 193008),
(193009, '3.40.50.300-FF-000691', NULL, 'Regulator of telomere elongation helicase 1', 234, NULL, NULL, 193009),
(193010, '1.20.1560.10-FF-000181', NULL, 'ABC transporter, putative', 320, NULL, NULL, 193010),
(193011, '2.60.40.10-FF-001825', NULL, 'T cell receptor alpha variable 12D-1', 94, NULL, NULL, 193011),
(193012, '1.25.40.20-FF-000602', NULL, 'Ankyrin-like protein', 123, NULL, NULL, 193012),
(193013, '2.60.40.10-FF-000853', NULL, 'NPHS1, nephrin', 100, NULL, NULL, 193013),
(193014, '2.60.120.290-FF-000014', NULL, 'Metalloendopeptidase', 128, NULL, NULL, 193014),
(193015, '1.10.472.10-FF-000283', NULL, 'Uncharacterized protein', 122, NULL, NULL, 193015),
(193016, '3.30.40.10-FF-000498', NULL, 'Cysteine and histidine rich 1', 115, NULL, NULL, 193016),
(193017, '1.10.840.10-FF-000032', NULL, 'Uncharacterized protein', 140, NULL, NULL, 193017),
(193018, '3.40.50.1820-FF-000611', NULL, 'Kynurenine formamidase', 300, NULL, NULL, 193018),
(193019, '3.80.10.10-FF-000247', NULL, 'TLR4 interactor with leucine rich repeats', 197, NULL, NULL, 193019),
(193020, '1.25.70.10-FF-000101', NULL, NULL, 156, NULL, NULL, 193020),
(193021, '3.40.50.300-FF-002809', NULL, 'UvrD/REP helicase N-terminal domain protein', 85, NULL, NULL, 193021),
(193022, '3.40.850.10-FF-000198', NULL, 'Putative kinesin', 347, NULL, NULL, 193022),
(193023, '3.30.260.10-FF-000003', NULL, 'T-complex protein 1 subunit eta', 106, NULL, NULL, 193023),
(193024, '1.25.40.10-FF-004770', NULL, 'Uncharacterized protein', 203, NULL, NULL, 193024),
(193025, '2.60.40.10-FF-003607', NULL, NULL, 109, NULL, NULL, 193025),
(193026, '2.60.200.20-FF-000207', NULL, 'Serine/threonine protein kinase, putative', 145, NULL, NULL, 193026),
(193027, '3.40.366.10-FF-000061', NULL, 'Uncharacterized protein', 99, NULL, NULL, 193027),
(193028, '4.10.60.10-FF-000256', NULL, 'Uncharacterized protein', 39, NULL, NULL, 193028),
(193029, '3.40.50.1470-FF-000017', NULL, 'Uncharacterized protein', 128, NULL, NULL, 193029),
(193030, '3.90.930.12-FF-000021', NULL, NULL, 105, NULL, NULL, 193030),
(193031, '3.40.50.720-FF-002379', NULL, 'Zinc-type alcohol dehydrogenase-like protein C1198.01', 162, NULL, NULL, 193031),
(193032, '3.30.200.20-FF-001621', NULL, 'Wee1-like protein', 122, NULL, NULL, 193032);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(193033, '2.130.10.10-FF-003574', NULL, 'At2g20330/F11A3.12', 260, NULL, NULL, 193033),
(193034, '3.30.465.10-FF-000119', NULL, 'Putative oxidoreductase', 203, NULL, NULL, 193034),
(193035, '3.40.140.10-FF-000020', NULL, 'Eukaryotic translation initiation factor 3 subunit H', 208, NULL, NULL, 193035),
(193036, '1.10.1370.10-FF-000005', NULL, 'Mitochondrial intermediate peptidase, mitochondrial', 365, NULL, NULL, 193036),
(193037, '3.80.10.10-FF-003653', NULL, 'Predicted protein', 123, NULL, NULL, 193037),
(193038, '3.50.7.10-FF-000039', NULL, 'Bardet-Biedl syndrome 10', 103, NULL, NULL, 193038),
(193039, '3.20.20.100-FF-000129', NULL, 'NADP(+) coupled glycerol dehydrogenase (Eurofung)', 178, NULL, NULL, 193039),
(193040, '1.10.101.10-FF-000017', NULL, 'Lytic transglycosylase', 65, NULL, NULL, 193040),
(193041, '3.40.50.620-FF-000730', NULL, 'Glutamate--tRNA ligase chloroplastic/mitochondrial', 179, NULL, NULL, 193041),
(193042, '3.30.160.60-FF-006272', NULL, NULL, 20, NULL, NULL, 193042),
(193043, '2.130.10.10-FF-004563', NULL, 'Uncharacterized protein', 215, NULL, NULL, 193043),
(193044, '3.90.1150.10-FF-000093', NULL, 'DegT/DnrJ/EryC1/StrS aminotransferase family protein', 112, NULL, NULL, 193044),
(193045, '3.40.850.10-FF-000422', NULL, 'Kinesin-like protein', 187, NULL, NULL, 193045),
(193046, '1.25.10.10-FF-000564', NULL, 'Probable importin subunit beta-4-like', 1044, NULL, NULL, 193046),
(193047, '1.20.120.1750-FF-000042', NULL, 'RBR-type E3 ubiquitin transferase', 80, NULL, NULL, 193047),
(193048, '3.90.70.10-FF-000132', NULL, 'Ubiquitin carboxyl-terminal hydrolase 32', 238, NULL, NULL, 193048),
(193049, '3.30.1370.50-FF-000011', NULL, 'Transcriptional repressor NF-X1', 115, NULL, NULL, 193049),
(193050, '3.90.180.10-FF-000028', NULL, 'Probable polyketide synthase 16', 172, NULL, NULL, 193050),
(193051, '3.40.50.300-FF-005362', NULL, 'Guanylate-binding family protein', 198, NULL, NULL, 193051),
(193052, '1.20.1050.80-FF-000011', NULL, 'VPS9 domain containing 1', 164, NULL, NULL, 193052),
(193053, '1.10.3430.10-FF-000062', NULL, 'Uncharacterized protein', 122, NULL, NULL, 193053),
(193054, '2.40.128.260-FF-000003', NULL, 'IcmE', 128, NULL, NULL, 193054),
(193055, '1.10.3330.10-FF-000009', NULL, 'Uncharacterized protein', 113, NULL, NULL, 193055),
(193056, '1.10.132.30-FF-000022', NULL, 'Predicted protein', 42, NULL, NULL, 193056),
(193057, '3.40.190.170-FF-000001', NULL, 'TRAP dicarboxylate transporter, DctP subunit', 302, NULL, NULL, 193057),
(193058, '2.60.40.4330-FF-000001', NULL, 'Kinesin-like protein', 119, NULL, NULL, 193058),
(193059, '3.60.15.10-FF-000242', NULL, 'Uncharacterized protein', 82, NULL, NULL, 193059),
(193060, '1.25.40.10-FF-003146', NULL, 'Uncharacterized protein', 123, NULL, NULL, 193060),
(193061, '1.10.443.10-FF-000007', NULL, 'Tyrosine recombinase XerC', 214, NULL, NULL, 193061),
(193062, '3.90.70.10-FF-000587', NULL, 'Uncharacterized protein', 245, NULL, NULL, 193062),
(193063, '1.10.10.10-FF-001081', NULL, 'Probable methyltransferase/methylase', 85, NULL, NULL, 193063),
(193064, '1.10.150.50-FF-000081', NULL, 'EPS8 like 3', 79, NULL, NULL, 193064),
(193065, '2.70.98.30-FF-000019', NULL, 'Alpha-mannosidase', 100, NULL, NULL, 193065),
(193066, '1.10.287.2250-FF-000019', NULL, 'Uncharacterized protein', 98, NULL, NULL, 193066),
(193067, '1.10.437.10-FF-000033', NULL, 'Predicted protein', 101, NULL, NULL, 193067),
(193068, '2.40.50.1060-FF-000002', NULL, 'DNA-directed RNA polymerase', 146, NULL, NULL, 193068),
(193069, '3.40.1110.10-FF-000040', NULL, 'Calcium-transporting ATPase 1', 226, NULL, NULL, 193069),
(193070, '1.20.80.10-FF-000045', NULL, 'Kinesin-like calmodulin binding protein', 111, NULL, NULL, 193070),
(193071, '2.30.280.10-FF-000002', NULL, 'E3 ubiquitin-protein ligase ORTHRUS 2', 196, NULL, NULL, 193071),
(193072, '3.40.50.300-FF-003428', NULL, 'Protein translocase subunit SecA', 59, NULL, NULL, 193072),
(193073, '1.50.40.10-FF-000311', NULL, 'Mitochondrial substrate carrier family protein Z', 293, NULL, NULL, 193073),
(193074, '3.30.160.60-FF-000965', NULL, 'Neurotrophin receptor-interacting factor homolog', 28, NULL, NULL, 193074);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(193075, '3.10.50.40-FF-000132', NULL, 'Peptidylprolyl isomerase', 112, NULL, NULL, 193075),
(193076, '2.60.40.690-FF-000001', NULL, 'PZP, alpha-2-macroglobulin like', 137, NULL, NULL, 193076),
(193077, '3.30.40.10-FF-000509', NULL, 'Blast:JmjC domain-containing histone demethylation protein 1', 96, NULL, NULL, 193077),
(193078, '1.20.1250.20-FF-000211', NULL, 'MFS transporter, metabolite:H+ symporter family protein', 196, NULL, NULL, 193078),
(193079, '3.30.420.110-FF-000079', NULL, 'DNA mismatch repair protein Msh2, putative', 157, NULL, NULL, 193079),
(193080, '2.130.10.110-FF-000006', NULL, 'Clathrin heavy chain', 373, NULL, NULL, 193080),
(193081, '3.50.30.30-FF-000137', NULL, 'Uncharacterized protein', 143, NULL, NULL, 193081),
(193082, '1.10.8.270-FF-000139', NULL, 'Protein CBR-RBG-3', 134, NULL, NULL, 193082),
(193083, '3.40.50.300-FF-001180', NULL, 'Elongation factor 2-like protein', 217, NULL, NULL, 193083),
(193084, '2.30.29.30-FF-000963', NULL, 'Sorting nexin-17', 108, NULL, NULL, 193084),
(193085, '3.30.450.20-FF-000487', NULL, 'Two-component sensor CbrA', 127, NULL, NULL, 193085),
(193086, '3.30.1010.10-FF-000102', NULL, 'VPS34-like PI-3-kinase', 117, NULL, NULL, 193086),
(193087, '2.120.10.30-FF-000495', NULL, 'Os01g0698200 protein', 237, NULL, NULL, 193087),
(193088, '3.40.50.1820-FF-001230', NULL, 'Carboxypeptidase', 344, NULL, NULL, 193088),
(193089, '1.10.565.10-FF-000116', NULL, 'Uncharacterized protein', 264, NULL, NULL, 193089),
(193090, '1.10.3110.10-FF-000015', NULL, 'Pcyox1l protein', 95, NULL, NULL, 193090),
(193091, '3.30.70.1730-FF-000020', NULL, '50S ribosomal protein L10', 131, NULL, NULL, 193091),
(193092, '2.130.10.10-FF-000168', NULL, 'Nucleoporin Nup37', 317, NULL, NULL, 193092),
(193093, '3.40.50.1820-FF-000741', NULL, 'Glr4230 protein', 303, NULL, NULL, 193093),
(193094, '1.10.10.60-FF-000466', NULL, 'Transcription factor TFIIIB subunit', 57, NULL, NULL, 193094),
(193095, '2.60.40.10-FF-005996', NULL, NULL, 82, NULL, NULL, 193095),
(193096, '3.30.160.60-FF-005636', NULL, NULL, 27, NULL, NULL, 193096),
(193097, '1.10.238.10-FF-000929', NULL, 'Nucleobindin 2a', 50, NULL, NULL, 193097),
(193098, '3.10.20.30-FF-000094', NULL, NULL, 100, NULL, NULL, 193098),
(193099, '3.60.40.10-FF-000255', NULL, 'Os10g0541200 protein', 121, NULL, NULL, 193099),
(193100, '1.25.40.20-FF-001119', NULL, 'Serine/threonine protein kinase', 204, NULL, NULL, 193100),
(193101, '2.60.120.650-FF-000026', NULL, 'Transcription factor jumonji domain-containing protein', 366, NULL, NULL, 193101),
(193102, '1.10.1530.10-FF-000007', NULL, 'L-sulfolactate dehydrogenase', 111, NULL, NULL, 193102),
(193103, '1.20.140.10-FF-000066', NULL, 'GM20419', 128, NULL, NULL, 193103),
(193104, '2.60.40.10-FF-000044', NULL, 'Contactin 1', 103, NULL, NULL, 193104),
(193105, '1.10.10.60-FF-000157', NULL, 'Myb transcription factor', 70, NULL, NULL, 193105),
(193106, '1.10.150.20-FF-000066', NULL, 'Transcription termination/antitermination protein NusA', 65, NULL, NULL, 193106),
(193107, '3.40.390.10-FF-000179', NULL, NULL, 240, NULL, NULL, 193107),
(193108, '3.10.20.90-FF-000858', NULL, 'IQ and ubiquitin-like domain-containing protein', 76, NULL, NULL, 193108),
(193109, '3.40.640.10-FF-000513', NULL, 'Uncharacterized protein', 38, NULL, NULL, 193109),
(193110, '1.25.40.10-FF-004927', NULL, 'Uncharacterized protein', 52, NULL, NULL, 193110),
(193111, '2.60.40.420-FF-000084', NULL, 'Ceruloplasmin', 153, NULL, NULL, 193111),
(193112, '1.25.40.180-FF-000319', NULL, NULL, 117, NULL, NULL, 193112),
(193113, '3.75.10.10-FF-000046', NULL, NULL, 290, NULL, NULL, 193113),
(193114, '3.60.130.10-FF-000015', NULL, 'Gamma-butyrobetaine dioxygenase', 290, NULL, NULL, 193114),
(193115, '3.30.70.330-FF-000913', NULL, 'Unplaced genomic scaffold supercont1.13, whole genome shotgun sequence', 73, NULL, NULL, 193115),
(193116, '3.80.10.10-FF-001545', NULL, 'CAP-Gly domain containing protein', 94, NULL, NULL, 193116),
(193117, '2.60.40.10-FF-005187', NULL, NULL, 93, NULL, NULL, 193117),
(193118, '1.20.1110.10-FF-000052', NULL, 'Sarcoplasmic/endoplasmic reticulum calcium ATPase 1', 412, NULL, NULL, 193118);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(193119, '3.90.1450.10-FF-000003', NULL, 'Uncharacterized protein', 86, NULL, NULL, 193119),
(193120, '3.90.950.10-FF-000020', NULL, 'Probable bifunctional dTTP/UTP pyrophosphatase/methyltransferase protein', 204, NULL, NULL, 193120),
(193121, '1.10.1170.10-FF-000024', NULL, 'baculoviral IAP repeat-containing protein 3', 113, NULL, NULL, 193121),
(193122, '3.90.730.10-FF-000037', NULL, 'Self-incompatibility ribonuclease', 198, NULL, NULL, 193122),
(193123, '2.60.120.740-FF-000020', NULL, 'G-protein coupled receptor protein, putative', 65, NULL, NULL, 193123),
(193124, '2.30.29.30-FF-000980', NULL, 'Oxysterol-binding protein', 85, NULL, NULL, 193124),
(193125, '3.30.1640.30-FF-000009', NULL, NULL, 64, NULL, NULL, 193125),
(193126, '2.60.40.150-FF-000660', NULL, 'Uncharacterized protein', 92, NULL, NULL, 193126),
(193127, '2.10.25.10-FF-001219', NULL, 'CD248 molecule, endosialin a', 44, NULL, NULL, 193127),
(193128, '3.10.20.90-FF-000875', NULL, 'Predicted protein', 65, NULL, NULL, 193128),
(193129, '3.30.40.10-FF-000818', NULL, 'Sumoylation ligase MMS21', 54, NULL, NULL, 193129),
(193130, '3.40.50.720-FF-000581', NULL, 'Ubiquitin-activating enzyme E1, putative', 291, NULL, NULL, 193130),
(193131, '2.130.10.10-FF-003911', NULL, 'Uncharacterized protein', 265, NULL, NULL, 193131),
(193132, '3.40.50.1820-FF-001567', NULL, 'Uncharacterized protein', 114, NULL, NULL, 193132),
(193133, '3.30.200.20-FF-000795', NULL, 'Myosin light chain kinase', 100, NULL, NULL, 193133),
(193134, '3.20.20.300-FF-000060', NULL, NULL, 155, NULL, NULL, 193134),
(193135, '2.60.40.10-FF-003287', NULL, 'Mcam protein', 87, NULL, NULL, 193135),
(193136, '2.40.30.10-FF-000089', NULL, '50S ribosomal protein L3', 81, NULL, NULL, 193136),
(193137, '3.40.190.10-FF-000214', NULL, 'Porphobilinogen deaminase', 100, NULL, NULL, 193137),
(193138, '3.40.50.300-FF-005423', NULL, 'DNA repair protein RecN', 217, NULL, NULL, 193138),
(193139, '3.10.129.10-FF-000175', NULL, 'Mesaconyl-CoA hydratase', 343, NULL, NULL, 193139),
(193140, '2.60.40.60-FF-000598', NULL, 'Uncharacterized protein', 116, NULL, NULL, 193140),
(193141, '1.10.472.80-FF-000051', NULL, 'Probable MDR1-Mac1p interacting protein', 132, NULL, NULL, 193141),
(193142, '3.30.70.330-FF-000604', NULL, 'Splicing factor 3B, subunit 6', 78, NULL, NULL, 193142),
(193143, '3.30.230.10-FF-000294', NULL, 'DNA mismatch repair protein MutL', 122, NULL, NULL, 193143),
(193144, '1.20.140.40-FF-000081', NULL, NULL, 85, NULL, NULL, 193144),
(193145, '3.30.450.40-FF-000173', NULL, 'Phosphoenolpyruvate-protein phosphotransferase', 170, NULL, NULL, 193145),
(193146, '1.10.3860.10-FF-000010', NULL, 'Amino acid transporter', 224, NULL, NULL, 193146),
(193147, '3.40.20.10-FF-000165', NULL, 'Uncharacterized protein', 112, NULL, NULL, 193147),
(193148, '2.30.30.140-FF-000302', NULL, 'Uncharacterized protein', 74, NULL, NULL, 193148),
(193149, '3.90.1150.10-FF-000121', NULL, 'Phosphoserine aminotransferase', 90, NULL, NULL, 193149),
(193150, '1.10.720.30-FF-000080', NULL, 'Predicted protein', 64, NULL, NULL, 193150),
(193151, '1.10.3170.10-FF-000007', NULL, 'UvrD/REP helicase N-terminal domain protein', 34, NULL, NULL, 193151),
(193152, '3.30.160.60-FF-005153', NULL, NULL, 70, NULL, NULL, 193152),
(193153, '1.20.1070.10-FF-000256', NULL, 'Adhesion G protein-coupled receptor G7', 329, NULL, NULL, 193153),
(193154, '1.20.1250.20-FF-001981', NULL, 'Solute carrier family 22 member 7', 393, NULL, NULL, 193154),
(193155, '3.30.160.60-FF-002747', NULL, NULL, 28, NULL, NULL, 193155),
(193156, '3.30.200.20-FF-000356', NULL, 'WEE protein kinase', 89, NULL, NULL, 193156),
(193157, '2.60.40.60-FF-000418', NULL, 'Cadherin 16, KSP-cadherin', 117, NULL, NULL, 193157),
(193158, '2.60.200.20-FF-000196', NULL, 'FHA domain-containing protein', 113, NULL, NULL, 193158),
(193159, '1.10.150.20-FF-000083', NULL, 'Putative DNA polymerase 1', 134, NULL, NULL, 193159),
(193160, '3.50.4.10-FF-000016', NULL, 'Uncharacterized protein, isoform A', 83, NULL, NULL, 193160),
(193161, '1.20.1250.20-FF-000711', NULL, 'Uncharacterized protein, isoform B', 385, NULL, NULL, 193161);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(193162, '2.10.25.10-FF-001399', NULL, 'Drosophila CRumBs homolog', 55, NULL, NULL, 193162),
(193163, '3.20.20.80-FF-000344', NULL, 'Uncharacterized protein', 251, NULL, NULL, 193163),
(193164, '1.10.418.20-FF-000014', NULL, 'Related to protease ULP2 protein', 43, NULL, NULL, 193164),
(193165, '1.25.40.10-FF-005063', NULL, 'Uncharacterized protein', 104, NULL, NULL, 193165),
(193166, '3.20.20.70-FF-000206', NULL, '4-hydroxy-tetrahydrodipicolinate synthase 2, chloroplastic', 307, NULL, NULL, 193166),
(193167, '2.20.25.30-FF-000016', NULL, '60S ribosomal protein L37', 56, NULL, NULL, 193167),
(193168, '3.30.40.10-FF-001987', NULL, 'Uncharacterized protein', 104, NULL, NULL, 193168),
(193169, '3.40.50.1000-FF-000484', NULL, NULL, 145, NULL, NULL, 193169),
(193170, '3.30.420.40-FF-000345', NULL, 'Conserved hypothetical proline rich protein', 97, NULL, NULL, 193170),
(193171, '3.80.10.10-FF-002164', NULL, 'AGAP003930-PA', 381, NULL, NULL, 193171),
(193172, '1.10.555.10-FF-000161', NULL, NULL, 242, NULL, NULL, 193172),
(193173, '3.40.50.300-FF-001528', NULL, 'ATP-dependent RNA helicase YTHDC2', 165, NULL, NULL, 193173),
(193174, '3.30.1390.20-FF-000026', NULL, 'Uncharacterized protein', 58, NULL, NULL, 193174),
(193175, '3.30.497.10-FF-000007', NULL, 'Serpin peptidase inhibitor clade H member 1', 228, NULL, NULL, 193175),
(193176, '1.10.10.10-FF-000945', NULL, 'Probable transcriptional regulator', 132, NULL, NULL, 193176),
(193177, '1.25.40.10-FF-001364', NULL, 'Pentatricopeptide repeat-containing protein', 101, NULL, NULL, 193177),
(193178, '3.40.50.12500-FF-000004', NULL, 'Dcg1p', 242, NULL, NULL, 193178),
(193179, '2.70.70.10-FF-000040', NULL, 'Peptidase, M23/M37 family', 152, NULL, NULL, 193179),
(193180, '1.25.40.10-FF-004118', NULL, 'Uncharacterized protein', 130, NULL, NULL, 193180),
(193181, '1.20.58.1420-FF-000002', NULL, 'Protein transport protein TIP20', 135, NULL, NULL, 193181),
(193182, '1.20.1250.20-FF-002009', NULL, 'Uncharacterized protein', 373, NULL, NULL, 193182),
(193183, '2.60.40.10-FF-003742', NULL, NULL, 104, NULL, NULL, 193183),
(193184, '3.30.160.60-FF-004355', NULL, NULL, 56, NULL, NULL, 193184),
(193185, '1.25.40.10-FF-002218', NULL, 'Uncharacterized protein', 65, NULL, NULL, 193185),
(193186, '3.30.160.60-FF-001893', NULL, 'Uncharacterized protein', 28, NULL, NULL, 193186),
(193187, '3.10.20.90-FF-001022', NULL, 'Uncharacterized protein', 91, NULL, NULL, 193187),
(193188, '3.40.50.300-FF-006042', NULL, 'Uncharacterized protein', 286, NULL, NULL, 193188),
(193189, '3.30.9.10-FF-000201', NULL, 'Dimethylglycine dehydrogenase, mitochondrial', 170, NULL, NULL, 193189),
(193190, '3.30.40.10-FF-001807', NULL, 'Putative U-box domain-containing protein 47', 65, NULL, NULL, 193190),
(193191, '2.10.60.10-FF-000025', NULL, 'Receptor protein serine/threonine kinase', 108, NULL, NULL, 193191),
(193192, '3.40.50.300-FF-000202', NULL, 'ras-related protein Rab-8A', 199, NULL, NULL, 193192),
(193193, '2.40.50.140-FF-000455', NULL, 'Replication Factor A 28 kDa subunit, putative', 137, NULL, NULL, 193193),
(193194, '3.40.1110.10-FF-000170', NULL, 'Phospholipid-transporting ATPase', 167, NULL, NULL, 193194),
(193195, '3.30.160.60-FF-001921', NULL, 'Putative transcription factor Ovo-like 1', 81, NULL, NULL, 193195),
(193196, '2.130.10.10-FF-005709', NULL, 'phosphoinositide 3-kinase regulatory subunit 4', 143, NULL, NULL, 193196),
(193197, '1.10.10.60-FF-001085', NULL, NULL, 49, NULL, NULL, 193197),
(193198, '1.10.520.10-FF-000002', NULL, 'Catalase-peroxidase', 200, NULL, NULL, 193198),
(193199, '1.10.510.10-FF-002637', NULL, 'Si:ch211-22d5.2', 329, NULL, NULL, 193199),
(193200, '1.10.30.10-FF-000166', NULL, 'Uncharacterized protein', 47, NULL, NULL, 193200),
(193201, '3.40.1190.20-FF-000211', NULL, NULL, 63, NULL, NULL, 193201),
(193202, '1.10.630.10-FF-000095', NULL, 'Lanosterol 14-alpha-demethylase', 451, NULL, NULL, 193202),
(193203, '3.40.50.300-FF-001972', NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', 130, NULL, NULL, 193203),
(193204, '1.20.1250.20-FF-000109', NULL, 'Putative vesicular acetylcholine transporter', 415, NULL, NULL, 193204);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(193205, '3.30.1370.10-FF-000095', NULL, 'Exosome complex component Rrp4', 90, NULL, NULL, 193205),
(193206, '1.10.1040.50-FF-000004', NULL, 'Peroxisomal fatty acid beta-oxidation multifunctional protein', 224, NULL, NULL, 193206),
(193207, '3.20.20.70-FF-000678', NULL, NULL, 202, NULL, NULL, 193207),
(193208, '1.20.920.20-FF-000050', NULL, 'Uncharacterized protein', 312, NULL, NULL, 193208),
(193209, '2.60.40.1730-FF-000007', NULL, 'thyrotropin-releasing hormone-degrading ectoenzyme', 213, NULL, NULL, 193209),
(193210, '3.30.160.60-FF-002410', NULL, 'Zinc finger protein 354C', 25, NULL, NULL, 193210),
(193211, '1.25.40.10-FF-001701', NULL, 'Putative pentatricopeptide repeat-containing protein', 254, NULL, NULL, 193211),
(193212, '2.60.120.330-FF-000015', NULL, 'Protein DMR6-LIKE OXYGENASE 1', 325, NULL, NULL, 193212),
(193213, '3.40.50.620-FF-000421', NULL, 'Isoleucine--tRNA ligase', 169, NULL, NULL, 193213),
(193214, '3.10.129.10-FF-000253', NULL, 'Uncharacterized protein', 118, NULL, NULL, 193214),
(193215, '1.25.10.10-FF-000917', NULL, 'EXPOrtin (Nuclear export receptor)', 919, NULL, NULL, 193215),
(193216, '2.30.30.100-FF-000094', NULL, 'U6 snRNA-associated Sm-like protein LSm7p', 85, NULL, NULL, 193216),
(193217, '3.40.50.2300-FF-000536', NULL, 'Catabolite control protein A', 129, NULL, NULL, 193217),
(193218, '1.20.1050.10-FF-000243', NULL, 'Uncharacterized protein', 63, NULL, NULL, 193218),
(193219, '2.30.42.10-FF-000477', NULL, NULL, 102, NULL, NULL, 193219),
(193220, '3.40.50.720-FF-000434', NULL, 'NADPH-dependent pterin aldehyde reductase', 222, NULL, NULL, 193220),
(193221, '1.20.58.60-FF-000328', NULL, 'Spectrin beta, non-erythrocytic 5', 126, NULL, NULL, 193221),
(193222, '3.40.50.2000-FF-000475', NULL, 'Trehalose phosphorylase', 199, NULL, NULL, 193222),
(193223, '1.10.8.10-FF-000063', NULL, 'DNA polymerase III subunit delta', 40, NULL, NULL, 193223),
(193224, '3.50.50.60-FF-001215', NULL, 'Uncharacterized protein', 298, NULL, NULL, 193224),
(193225, '1.20.1250.20-FF-002026', NULL, 'Drug resistance protein, conjectural', 353, NULL, NULL, 193225),
(193226, '3.60.10.10-FF-000427', NULL, 'Uncharacterized protein', 102, NULL, NULL, 193226),
(193227, '3.40.50.410-FF-000004', NULL, 'collagen alpha-6(VI) chain', 185, NULL, NULL, 193227),
(193228, '1.25.40.270-FF-000004', NULL, 'Vacuolar protein sorting-associated protein VTA1', 167, NULL, NULL, 193228),
(193229, '2.40.50.140-FF-001074', NULL, NULL, 89, NULL, NULL, 193229),
(193230, '1.20.120.350-FF-000250', NULL, NULL, 49, NULL, NULL, 193230),
(193231, '2.120.10.80-FF-000094', NULL, 'Rab9 effector protein with kelch motifs', 180, NULL, NULL, 193231),
(193232, '1.25.10.70-FF-000003', NULL, 'Nuclear pore complex protein Nup188', 273, NULL, NULL, 193232),
(193233, '1.10.10.10-FF-001564', NULL, 'Phosphoserine phosphatase RsbU', 66, NULL, NULL, 193233),
(193234, '1.20.190.20-FF-000004', NULL, '14-3-3 protein gamma', 110, NULL, NULL, 193234),
(193235, '1.10.490.10-FF-000004', NULL, 'Group 2 hemoglobin yjbI', 126, NULL, NULL, 193235),
(193236, '1.10.1070.11-FF-000057', NULL, 'PIKK family atypical protein kinase', 187, NULL, NULL, 193236),
(193237, '3.40.50.10490-FF-000047', NULL, 'MurR/RpiR family transcriptional regulator', 185, NULL, NULL, 193237),
(193238, '3.30.60.90-FF-000006', NULL, 'E3 ubiquitin-protein ligase HERC2 isoform X2', 52, NULL, NULL, 193238),
(193239, '3.30.160.60-FF-001258', NULL, 'Uncharacterized protein TCIL3000_10_13860', 28, NULL, NULL, 193239),
(193240, '2.130.10.10-FF-001096', NULL, 'WD repeat-containing protein, putative', 132, NULL, NULL, 193240),
(193241, '3.30.870.10-FF-000167', NULL, 'Probable CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', 225, NULL, NULL, 193241),
(193242, '2.40.70.10-FF-000535', NULL, NULL, 193, NULL, NULL, 193242),
(193243, '1.10.1200.10-FF-000106', NULL, 'PKS-NRPS hybrid synthetase psoA', 93, NULL, NULL, 193243),
(193244, '3.90.550.10-FF-000591', NULL, 'N-acetylgalactosaminyl transferase, putative', 234, NULL, NULL, 193244),
(193245, '1.25.40.10-FF-002853', NULL, 'PsbD mRNA maturation factor Nac2, chloroplastic', 110, NULL, NULL, 193245);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(193246, '1.50.10.20-FF-000020', NULL, 'Complement C5', 327, NULL, NULL, 193246),
(193247, '3.40.30.10-FF-000222', NULL, 'Protein URE2', 125, NULL, NULL, 193247),
(193248, '1.10.287.110-FF-000101', NULL, 'DNAJ heat shock N-terminal domain-containing protein', 118, NULL, NULL, 193248),
(193249, '3.40.1090.10-FF-000026', NULL, 'Phospholipase A2', 351, NULL, NULL, 193249),
(193250, '2.60.40.10-FF-005979', NULL, NULL, 97, NULL, NULL, 193250),
(193251, '1.25.40.20-FF-001721', NULL, 'Uncharacterized protein', 234, NULL, NULL, 193251),
(193252, '1.10.510.10-FF-004363', NULL, NULL, 108, NULL, NULL, 193252),
(193253, '1.20.140.10-FF-000083', NULL, 'Acyl-CoA dehydrogenase, C-terminal domain protein', 146, NULL, NULL, 193253),
(193254, '3.30.160.60-FF-004664', NULL, NULL, 31, NULL, NULL, 193254),
(193255, '2.60.260.20-FF-000172', NULL, 'DnaJ domain containing protein', 77, NULL, NULL, 193255),
(193256, '1.20.58.60-FF-000171', NULL, 'Uncharacterized protein, isoform B', 111, NULL, NULL, 193256),
(193257, '2.170.150.10-FF-000027', NULL, 'Uncharacterized protein', 67, NULL, NULL, 193257),
(193258, '3.30.160.20-FF-000077', NULL, 'Ribonuclease 3', 71, NULL, NULL, 193258),
(193259, '1.20.5.110-FF-000218', NULL, 'Synaptosome-associated protein 29', 41, NULL, NULL, 193259),
(193260, '1.20.1080.10-FF-000071', NULL, 'Aquaporin', 228, NULL, NULL, 193260),
(193261, '1.25.10.10-FF-002481', NULL, 'Exportin, putative', 211, NULL, NULL, 193261),
(193262, '3.30.1060.10-FF-000004', NULL, 'Peptide methionine sulfoxide reductase A5', 208, NULL, NULL, 193262),
(193263, '3.20.10.10-FF-000047', NULL, 'Methionine aminotransferase BCAT4', 173, NULL, NULL, 193263),
(193264, '1.10.8.60-FF-000307', NULL, 'AAA family ATPase, putative', 110, NULL, NULL, 193264),
(193265, '3.60.40.10-FF-000238', NULL, 'Uncharacterized protein', 318, NULL, NULL, 193265),
(193266, '1.10.10.10-FF-000928', NULL, 'Regulatory protein RecX', 46, NULL, NULL, 193266),
(193267, '2.40.180.10-FF-000032', NULL, 'Uncharacterized protein', 257, NULL, NULL, 193267),
(193268, '1.10.287.130-FF-000107', NULL, 'Sensor histidine kinase YycG', 79, NULL, NULL, 193268),
(193269, '2.30.30.100-FF-000077', NULL, 'Scd6p', 82, NULL, NULL, 193269),
(193270, '3.30.780.10-FF-000031', NULL, 'Translation initiation factor', 99, NULL, NULL, 193270),
(193271, '3.40.950.10-FF-000014', NULL, 'Probable cytosolic Fe-S cluster assembly factor oxy-4', 171, NULL, NULL, 193271),
(193272, '2.60.40.10-FF-004568', NULL, NULL, 102, NULL, NULL, 193272),
(193273, '2.130.10.10-FF-001657', NULL, 'Periodic tryptophan protein 2', 205, NULL, NULL, 193273),
(193274, '1.10.20.10-FF-000238', NULL, NULL, 111, NULL, NULL, 193274),
(193275, '1.10.287.70-FF-000218', NULL, 'Putative potassium channel subunit n2P17m2-1', 325, NULL, NULL, 193275),
(193276, '2.40.50.140-FF-000585', NULL, '40S ribosomal protein S23-2', 81, NULL, NULL, 193276),
(193277, '3.90.1150.10-FF-000430', NULL, 'Uncharacterized protein', 44, NULL, NULL, 193277),
(193278, '3.10.20.410-FF-000011', NULL, 'Outer membrane usher protein PapC', 126, NULL, NULL, 193278),
(193279, '2.30.29.30-FF-001008', NULL, 'Exocyst complex component EXO84', 122, NULL, NULL, 193279),
(193280, '3.30.40.10-FF-001015', NULL, 'FHA domaincontaining protein', 118, NULL, NULL, 193280),
(193281, '1.10.630.10-FF-000656', NULL, 'Predicted protein', 198, NULL, NULL, 193281),
(193282, '1.10.472.10-FF-000636', NULL, 'Uncharacterized protein', 117, NULL, NULL, 193282),
(193283, '3.30.920.10-FF-000020', NULL, 'Frataxin homolog, mitochondrial', 123, NULL, NULL, 193283),
(193284, '1.25.40.10-FF-000392', NULL, 'Tetratricopeptide repeat domain 21A', 239, NULL, NULL, 193284),
(193285, '3.30.260.10-FF-000020', NULL, 'T-complex protein 1 subunit gamma', 110, NULL, NULL, 193285),
(193286, '3.30.70.330-FF-002858', NULL, NULL, 80, NULL, NULL, 193286),
(193287, '3.30.70.330-FF-002297', NULL, NULL, 99, NULL, NULL, 193287),
(193288, '3.40.630.30-FF-000081', NULL, 'Acetoin utilization protein AcuA', 210, NULL, NULL, 193288),
(193289, '3.50.50.60-FF-000726', NULL, 'Glutathione reductase', 122, NULL, NULL, 193289);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(193290, '3.30.470.20-FF-000078', NULL, 'Histone-lysine N-methyltransferase', 205, NULL, NULL, 193290),
(193291, '1.10.20.10-FF-000210', NULL, NULL, 110, NULL, NULL, 193291),
(193292, '3.90.930.12-FF-000004', NULL, '60S ribosomal protein L9', 85, NULL, NULL, 193292),
(193293, '3.30.200.20-FF-001284', NULL, 'Uncharacterized protein', 77, NULL, NULL, 193293),
(193294, '1.20.1540.10-FF-000101', NULL, 'Uncharacterized protein', 186, NULL, NULL, 193294),
(193295, '3.60.21.10-FF-000346', NULL, 'Serine/threonine-protein phosphatase', 197, NULL, NULL, 193295),
(193296, '2.130.10.10-FF-003602', NULL, 'AGAP006036-PA', 336, NULL, NULL, 193296),
(193297, '2.30.42.10-FF-000038', NULL, 'Multiple PDZ domain protein isoform X1', 110, NULL, NULL, 193297),
(193298, '2.60.40.2030-FF-000002', NULL, 'sodium/calcium exchanger 3 isoform X1', 159, NULL, NULL, 193298),
(193299, '4.10.240.10-FF-000036', NULL, 'Unplaced genomic scaffold supercont2.3, whole genome shotgun sequence', 73, NULL, NULL, 193299),
(193300, '3.40.50.720-FF-001053', NULL, 'GDP-mannose 4,6 dehydratase', 243, NULL, NULL, 193300),
(193301, '1.10.1450.10-FF-000169', NULL, 'Uncharacterized protein', 57, NULL, NULL, 193301),
(193302, '1.10.8.140-FF-000022', NULL, 'Uncharacterized protein', 77, NULL, NULL, 193302),
(193303, '2.10.25.10-FF-001528', NULL, 'Notch homolog 2', 49, NULL, NULL, 193303),
(193304, '3.40.225.10-FF-000060', NULL, NULL, 239, NULL, NULL, 193304),
(193305, '3.30.300.30-FF-000069', NULL, 'Nonribosomal peptide synthase 2', 98, NULL, NULL, 193305),
(193306, '3.30.160.60-FF-003719', NULL, NULL, 31, NULL, NULL, 193306),
(193307, '1.10.2000.10-FF-000012', NULL, 'Carboxypeptidase Z', 132, NULL, NULL, 193307),
(193308, '3.20.110.10-FF-000045', NULL, 'Mannosidase, alpha, class 2B, member 1', 25, NULL, NULL, 193308),
(193309, '3.10.450.10-FF-000056', NULL, 'Kininogen 1', 101, NULL, NULL, 193309),
(193310, '3.40.50.720-FF-000564', NULL, 'Short-chain type dehydrogenase/reductase', 250, NULL, NULL, 193310),
(193311, '3.40.50.2300-FF-000666', NULL, 'Lysine decarboxylase, constitutive', 132, NULL, NULL, 193311),
(193312, '3.30.930.10-FF-000105', NULL, 'Threonyl-tRNA synthetase 2, mitochondrial', 280, NULL, NULL, 193312),
(193313, '3.50.50.60-FF-001524', NULL, 'Uncharacterized protein', 238, NULL, NULL, 193313),
(193314, '1.10.418.20-FF-000031', NULL, 'Uncharacterized protein', 56, NULL, NULL, 193314),
(193315, '3.40.190.10-FF-000394', NULL, 'ABC transporter substrate-binding protein', 127, NULL, NULL, 193315),
(193316, '1.25.10.10-FF-001536', NULL, 'V-type proton ATPase subunit H', 333, NULL, NULL, 193316),
(193317, '2.60.98.20-FF-000011', NULL, 'Flagellar hook protein FlgE', 178, NULL, NULL, 193317),
(193318, '3.40.50.2300-FF-001155', NULL, NULL, 105, NULL, NULL, 193318),
(193319, '1.20.1250.20-FF-002156', NULL, 'Uncharacterized protein', 195, NULL, NULL, 193319),
(193320, '1.25.40.10-FF-000083', NULL, 'calcineurin-binding protein cabin-1 isoform X1', 242, NULL, NULL, 193320),
(193321, '3.30.70.330-FF-002830', NULL, NULL, 141, NULL, NULL, 193321),
(193322, '3.40.50.1100-FF-000087', NULL, 'Cysteine synthase', 185, NULL, NULL, 193322),
(193323, '3.30.160.60-FF-002438', NULL, 'Paternally expressed 3', 60, NULL, NULL, 193323),
(193324, '3.40.50.300-FF-004389', NULL, 'Probable thymidylate kinase', 204, NULL, NULL, 193324),
(193325, '1.10.287.310-FF-000009', NULL, 'LSU ribosomal protein L29P', 78, NULL, NULL, 193325),
(193326, '3.40.50.720-FF-001845', NULL, 'Ubiquitin activating enzyme, putative', 54, NULL, NULL, 193326),
(193327, '3.40.50.2300-FF-001172', NULL, NULL, 123, NULL, NULL, 193327),
(193328, '3.40.720.10-FF-000205', NULL, 'Metalloenzyme domain protein', 295, NULL, NULL, 193328),
(193329, '2.40.50.140-FF-001102', NULL, NULL, 83, NULL, NULL, 193329),
(193330, '1.10.1200.120-FF-000003', NULL, 'Large-conductance mechanosensitive channel', 137, NULL, NULL, 193330),
(193331, '3.40.50.10810-FF-000065', NULL, 'SNF2 DNA repair protein, putative', 249, NULL, NULL, 193331),
(193332, '2.40.10.480-FF-000010', NULL, 'Uncharacterized protein', 68, NULL, NULL, 193332);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(193333, '2.120.10.30-FF-000556', NULL, 'Uncharacterized protein', 76, NULL, NULL, 193333),
(193334, '1.20.120.1770-FF-000020', NULL, 'Uncharacterized protein', 139, NULL, NULL, 193334),
(193335, '2.30.30.70-FF-000006', NULL, 'Uncharacterized protein', 41, NULL, NULL, 193335),
(193336, '3.40.50.2000-FF-000683', NULL, 'Glycosyl transferase group 1', 191, NULL, NULL, 193336),
(193337, '1.25.40.10-FF-003281', NULL, 'Pentatricopeptide repeat-containing protein At3g48250, chloroplastic', 134, NULL, NULL, 193337),
(193338, '1.10.510.10-FF-002429', NULL, 'Protein kinase, putative', 240, NULL, NULL, 193338),
(193339, '3.30.420.40-FF-000654', NULL, 'YALI0B10538p', 68, NULL, NULL, 193339),
(193340, '2.130.10.130-FF-000001', NULL, 'Integrin subunit alpha 10', 299, NULL, NULL, 193340),
(193341, '2.70.70.10-FF-000023', NULL, 'Peptidase, M23 family', 154, NULL, NULL, 193341),
(193342, '1.10.287.130-FF-000079', NULL, 'Unplaced genomic scaffold supercont1.240, whole genome shotgun sequence', 107, NULL, NULL, 193342),
(193343, '1.20.5.170-FF-000101', NULL, 'BZIP transcription factor HacA', 74, NULL, NULL, 193343),
(193344, '3.40.140.10-FF-000048', NULL, 'CysO-cysteine peptidase', 140, NULL, NULL, 193344),
(193345, '3.40.50.300-FF-008088', NULL, 'Uncharacterized protein', 114, NULL, NULL, 193345),
(193346, '3.40.50.360-FF-000085', NULL, 'NAD(P)H-dependent oxidoreductase', 181, NULL, NULL, 193346),
(193347, '2.40.240.130-FF-000003', NULL, 'Dixin isoform 1', 90, NULL, NULL, 193347),
(193348, '1.10.10.1620-FF-000003', NULL, 'Amine oxidase, flavin-containing', 50, NULL, NULL, 193348),
(193349, '3.30.450.60-FF-000049', NULL, 'Ap-3 complex subunit sigma, putative', 67, NULL, NULL, 193349),
(193350, '2.30.42.10-FF-000055', NULL, 'PDZ and LIM domain protein 3', 97, NULL, NULL, 193350),
(193351, '2.60.40.60-FF-000727', NULL, 'Cdh-4', 97, NULL, NULL, 193351),
(193352, '2.40.420.20-FF-000060', NULL, 'Cation efflux system (CzcB-like)', 89, NULL, NULL, 193352),
(193353, '3.40.190.10-FF-000523', NULL, 'Tungstate ABC transporter, periplasmic tungstate-binding protein', 108, NULL, NULL, 193353),
(193354, '2.130.10.10-FF-002877', NULL, 'Transducin/WD40 repeat-like superfamily protein', 160, NULL, NULL, 193354),
(193355, '2.30.110.10-FF-000103', NULL, 'Uncharacterized protein', 137, NULL, NULL, 193355),
(193356, '2.30.110.10-FF-000002', NULL, 'FMN reductase (NADH) RutF', 166, NULL, NULL, 193356),
(193357, '1.20.1160.11-FF-000022', NULL, NULL, 53, NULL, NULL, 193357),
(193358, '1.10.630.10-FF-000347', NULL, 'Uncharacterized loc100145084', 379, NULL, NULL, 193358),
(193359, '1.20.1070.10-FF-002173', NULL, 'Uncharacterized protein', 117, NULL, NULL, 193359),
(193360, '1.10.238.10-FF-000267', NULL, 'Myosin light chain alkali', 65, NULL, NULL, 193360),
(193361, '3.70.10.10-FF-000096', NULL, 'Uncharacterized protein', 277, NULL, NULL, 193361),
(193362, '2.130.10.10-FF-005148', NULL, 'Predicted protein', 288, NULL, NULL, 193362),
(193363, '3.30.160.60-FF-000302', NULL, 'Spalt-like transcription factor 1', 33, NULL, NULL, 193363),
(193364, '3.40.50.410-FF-000235', NULL, 'DumPY: shorter than wild-type', 188, NULL, NULL, 193364),
(193365, '1.20.5.190-FF-000107', NULL, NULL, 41, NULL, NULL, 193365),
(193366, '1.10.630.10-FF-000448', NULL, 'Uncharacterized protein', 293, NULL, NULL, 193366),
(193367, '2.30.40.10-FF-000124', NULL, 'Imidazolonepropionase', 85, NULL, NULL, 193367),
(193368, '1.25.10.10-FF-003189', NULL, 'Uncharacterized protein', 304, NULL, NULL, 193368),
(193369, '1.25.40.80-FF-000013', NULL, 'Deoxyribodipyrimidine photolyase, type II', 209, NULL, NULL, 193369),
(193370, '2.60.40.150-FF-000188', NULL, 'Uncharacterized protein, isoform D', 144, NULL, NULL, 193370),
(193371, '3.30.470.20-FF-000050', NULL, 'Acid phosphatase, putative', 203, NULL, NULL, 193371),
(193372, '3.80.10.10-FF-000909', NULL, 'Leucine-rich repeat receptor-like protein kinase', 161, NULL, NULL, 193372),
(193373, '3.40.630.30-FF-000125', NULL, 'Histone acetyltransferase type B catalytic subunit', 162, NULL, NULL, 193373),
(193374, '1.20.1560.10-FF-000681', NULL, 'Uncharacterized protein', 14, NULL, NULL, 193374);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(193375, '2.120.10.80-FF-000369', NULL, 'Uncharacterized protein', 176, NULL, NULL, 193375),
(193376, '2.60.40.10-FF-002798', NULL, 'Periplasmic beta-glucosidase, xylosidase/arabinosidase', 119, NULL, NULL, 193376),
(193377, '3.30.200.20-FF-001104', NULL, 'Acr-10', 142, NULL, NULL, 193377),
(193378, '3.10.50.30-FF-000011', NULL, 'Transcription elongation factor', 83, NULL, NULL, 193378),
(193379, '2.60.120.620-FF-000158', NULL, 'Uncharacterized protein', 199, NULL, NULL, 193379),
(193380, '3.90.1410.10-FF-000012', NULL, 'Protein SET DOMAIN GROUP 40', 287, NULL, NULL, 193380),
(193381, '3.80.10.10-FF-001528', NULL, 'Si:ch211-214b16.4', 213, NULL, NULL, 193381),
(193382, '3.80.10.10-FF-000808', NULL, 'F-box/LRR-repeat protein 16', 165, NULL, NULL, 193382),
(193383, '3.40.50.150-FF-000685', NULL, 'Methyltransferase domain protein', 197, NULL, NULL, 193383),
(193384, '1.20.200.10-FF-000037', NULL, 'Predicted protein', 61, NULL, NULL, 193384),
(193385, '2.130.10.10-FF-003383', NULL, 'Uncharacterized protein', 171, NULL, NULL, 193385),
(193386, '3.30.40.10-FF-000161', NULL, 'Vacuolar protein sorting-associated protein 27', 66, NULL, NULL, 193386),
(193387, '3.40.50.2300-FF-000767', NULL, NULL, 66, NULL, NULL, 193387),
(193388, '3.40.50.300-FF-005923', NULL, 'Uncharacterized protein', 262, NULL, NULL, 193388),
(193389, '2.130.10.10-FF-001449', NULL, 'WD domain, G-beta repeat-containing protein', 264, NULL, NULL, 193389),
(193390, '1.10.3210.10-FF-000079', NULL, 'Metal dependent phosphohydrolase', 173, NULL, NULL, 193390),
(193391, '3.40.30.10-FF-000800', NULL, 'Uncharacterized protein', 68, NULL, NULL, 193391),
(193392, '1.10.730.20-FF-000032', NULL, 'Probable isoleucine--tRNA ligase, mitochondrial', 48, NULL, NULL, 193392),
(193393, '3.40.33.10-FF-000144', NULL, 'Predicted protein', 145, NULL, NULL, 193393),
(193394, '1.25.40.10-FF-000728', NULL, 'Putative pentatricopeptide repeat-containing protein', 135, NULL, NULL, 193394),
(193395, '1.10.275.20-FF-000018', NULL, NULL, 59, NULL, NULL, 193395),
(193396, '1.25.40.10-FF-002870', NULL, 'Pentatricopeptide repeat-containing protein', 52, NULL, NULL, 193396),
(193397, '2.170.140.10-FF-000010', NULL, 'Gasp, isoform A', 71, NULL, NULL, 193397),
(193398, '3.30.2090.10-FF-000006', NULL, 'Multidrug resistance protein MdtB', 89, NULL, NULL, 193398),
(193399, '1.10.10.10-FF-000283', NULL, 'GntR family transcriptional regulator', 69, NULL, NULL, 193399),
(193400, '1.10.10.10-FF-000867', NULL, 'Beta-lactamase-like protein 2 homolog', 78, NULL, NULL, 193400),
(193401, '3.40.50.300-FF-006643', NULL, 'Uncharacterized protein', 89, NULL, NULL, 193401),
(193402, '4.10.60.10-FF-000273', NULL, 'Replication protein A subunit', 51, NULL, NULL, 193402),
(193403, '2.30.30.30-FF-000045', NULL, '50S ribosomal protein L14e', 86, NULL, NULL, 193403),
(193404, '1.10.1080.10-FF-000017', NULL, 'Eukaryotic glutathione synthase', 78, NULL, NULL, 193404),
(193405, '3.80.10.10-FF-003670', NULL, 'ELRR (Extracellular Leucine-Rich Repeat) ONly', 223, NULL, NULL, 193405),
(193406, '1.10.150.810-FF-000003', NULL, 'DNA polymerase kappa subunit', 91, NULL, NULL, 193406),
(193407, '3.40.30.10-FF-000694', NULL, 'Endoplasmic reticulum protein 44', 96, NULL, NULL, 193407),
(193408, '2.130.10.10-FF-003703', NULL, 'TAF (TBP-associated transcription factor) family', 173, NULL, NULL, 193408),
(193409, '2.60.450.10-FF-000009', NULL, 'LPS-assembly protein LptD', 150, NULL, NULL, 193409),
(193410, '3.90.550.10-FF-000383', NULL, 'Glycosyltransferase', 200, NULL, NULL, 193410),
(193411, '2.40.50.140-FF-000910', NULL, NULL, 143, NULL, NULL, 193411),
(193412, '3.20.20.70-FF-000650', NULL, NULL, 237, NULL, NULL, 193412),
(193413, '3.30.1420.10-FF-000004', NULL, 'Sulfite reductase, dissimilatory-type gamma subunit', 40, NULL, NULL, 193413),
(193414, '3.40.50.720-FF-002351', NULL, 'Uncharacterized protein', 77, NULL, NULL, 193414),
(193415, '1.25.10.10-FF-002834', NULL, 'Uncharacterized protein', 185, NULL, NULL, 193415),
(193416, '2.40.70.10-FF-000283', NULL, 'Eukaryotic aspartyl protease family protein', 180, NULL, NULL, 193416);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(193417, '1.20.1250.20-FF-001964', NULL, 'Uncharacterized MFS-type transporter SPBC409.08', 421, NULL, NULL, 193417),
(193418, '2.40.50.700-FF-000005', NULL, 'DIS3-like exonuclease 2', 85, NULL, NULL, 193418),
(193419, '3.10.330.10-FF-000007', NULL, 'Vesicle-fusing ATPase', 99, NULL, NULL, 193419),
(193420, '3.40.1650.10-FF-000007', NULL, 'RbsD or FucU transport', 146, NULL, NULL, 193420),
(193421, '1.25.10.10-FF-001744', NULL, 'Uncharacterized protein', 165, NULL, NULL, 193421),
(193422, '3.40.250.10-FF-000141', NULL, 'Thiosulfate sulfurtransferase, mitochondrial, putative', 111, NULL, NULL, 193422),
(193423, '3.30.450.20-FF-000296', NULL, 'Diguanylate cyclase (GGDEF) domain protein', 175, NULL, NULL, 193423),
(193424, '1.10.287.70-FF-000235', NULL, 'TWiK family of potassium channels', 300, NULL, NULL, 193424),
(193425, '1.10.167.10-FF-000040', NULL, 'Rax1p', 143, NULL, NULL, 193425),
(193426, '3.40.50.1100-FF-000188', NULL, 'Cysteine synthase', 99, NULL, NULL, 193426),
(193427, '3.50.50.60-FF-000243', NULL, 'L-aspartate oxidase', 269, NULL, NULL, 193427),
(193428, '1.10.600.10-FF-000036', NULL, 'cis-abienol synthase, chloroplastic', 313, NULL, NULL, 193428),
(193429, '1.10.510.10-FF-003143', NULL, NULL, 181, NULL, NULL, 193429),
(193430, '1.10.472.10-FF-000619', NULL, 'Uncharacterized protein', 129, NULL, NULL, 193430),
(193431, '3.40.50.300-FF-001371', NULL, 'ABC transporter ATP-binding protein', 244, NULL, NULL, 193431),
(193432, '1.20.1250.20-FF-000020', NULL, 'Multidrug resistance protein MdtG', 192, NULL, NULL, 193432),
(193433, '1.10.238.10-FF-000059', NULL, 'Plastin 1', 82, NULL, NULL, 193433),
(193434, '1.10.3080.10-FF-000017', NULL, 'Chloride channel protein', 231, NULL, NULL, 193434),
(193435, '3.30.70.330-FF-002066', NULL, NULL, 140, NULL, NULL, 193435),
(193436, '2.130.10.30-FF-000062', NULL, 'Regulator of chromosome condensation (RCC1) repeat, putative', 262, NULL, NULL, 193436),
(193437, '3.40.50.300-FF-002591', NULL, 'DNA helicase B isoform X1', 192, NULL, NULL, 193437),
(193438, '3.40.50.300-FF-008296', NULL, 'tRNA dimethylallyltransferase', 267, NULL, NULL, 193438),
(193439, '3.40.50.11860-FF-000008', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase', 95, NULL, NULL, 193439),
(193440, '3.30.160.60-FF-005945', NULL, NULL, 68, NULL, NULL, 193440),
(193441, '3.40.630.30-FF-000226', NULL, 'Si:dkey-183c6.8', 205, NULL, NULL, 193441),
(193442, '3.40.50.300-FF-007262', NULL, 'Ras GTPase', 157, NULL, NULL, 193442),
(193443, '1.50.40.10-FF-000209', NULL, 'SLC (SoLute Carrier) homolog', 194, NULL, NULL, 193443),
(193444, '3.40.525.10-FF-000072', NULL, 'Phosphatidylinositol phosphatidylcholine transfer protein', 97, NULL, NULL, 193444),
(193445, '3.10.110.10-FF-000227', NULL, 'RWD domain-domain-containing protein', 88, NULL, NULL, 193445),
(193446, '1.20.58.60-FF-000300', NULL, 'Spectrin beta, non-erythrocytic 5', 103, NULL, NULL, 193446),
(193447, '3.90.950.10-FF-000048', NULL, 'Inosine triphosphate pyrophosphatase', 123, NULL, NULL, 193447),
(193448, '3.30.1130.10-FF-000021', NULL, 'Folic acid synthesis protein fol1', 132, NULL, NULL, 193448),
(193449, '1.20.120.1900-FF-000076', NULL, 'Gamma-tubulin complex component', 279, NULL, NULL, 193449),
(193450, '3.80.10.10-FF-004507', NULL, 'Uncharacterized protein', 114, NULL, NULL, 193450),
(193451, '1.10.10.60-FF-000718', NULL, 'Sigma-54-dependent Fis family transcriptional regulator', 58, NULL, NULL, 193451),
(193452, '3.30.70.330-FF-003005', NULL, NULL, 81, NULL, NULL, 193452),
(193453, '1.25.10.10-FF-001391', NULL, 'Protein phosphatase 4 regulatory subunit 1-like (pseudogene)', 205, NULL, NULL, 193453),
(193454, '3.30.70.1430-FF-000020', NULL, NULL, 104, NULL, NULL, 193454),
(193455, '1.20.1070.10-FF-001554', NULL, 'Uncharacterized protein', 173, NULL, NULL, 193455),
(193456, '2.30.30.140-FF-000291', NULL, 'Uncharacterized protein', 83, NULL, NULL, 193456),
(193457, '3.40.309.10-FF-000103', NULL, 'Phenylacetaldehyde dehydrogenase', 190, NULL, NULL, 193457),
(193458, '2.10.25.10-FF-001427', NULL, 'Crumbs cell polarity complex component 2', 83, NULL, NULL, 193458);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(193459, '3.50.50.60-FF-000670', NULL, 'Predicted protein', 386, NULL, NULL, 193459),
(193460, '3.30.160.60-FF-003736', NULL, NULL, 26, NULL, NULL, 193460),
(193461, '3.30.565.10-FF-000363', NULL, 'ATP-binding mismatch repair protein', 227, NULL, NULL, 193461),
(193462, '3.90.550.10-FF-000736', NULL, 'Uncharacterized protein', 249, NULL, NULL, 193462),
(193463, '3.20.20.140-FF-000181', NULL, 'Allantoinase', 277, NULL, NULL, 193463),
(193464, '2.170.120.40-FF-000006', NULL, 'YbbR-like domain-containing protein YbbR', 89, NULL, NULL, 193464),
(193465, '2.130.10.10-FF-000729', NULL, 'SMU1, DNA replication regulator and spliceosomal factor', 74, NULL, NULL, 193465),
(193466, '3.30.420.40-FF-000906', NULL, 'Chromosome 10, whole genome shotgun sequence', 40, NULL, NULL, 193466),
(193467, '3.30.2130.30-FF-000044', NULL, 'tRNA sulfurtransferase', 167, NULL, NULL, 193467),
(193468, '2.60.40.150-FF-000558', NULL, 'Calcium-dependent lipid-binding (CaLB domain) family protein', 72, NULL, NULL, 193468),
(193469, '1.10.10.10-FF-000592', NULL, 'Uncharacterized protein', 101, NULL, NULL, 193469),
(193470, '1.10.238.10-FF-000368', NULL, 'Calcium-binding EF hand family protein', 174, NULL, NULL, 193470),
(193471, '1.20.120.160-FF-000002', NULL, 'Histidine kinase', 114, NULL, NULL, 193471),
(193472, '3.40.50.1000-FF-000692', NULL, NULL, 138, NULL, NULL, 193472),
(193473, '3.30.450.20-FF-000532', NULL, 'Hypoxia-inducible factor 1 alpha, putative', 63, NULL, NULL, 193473),
(193474, '2.40.50.140-FF-000146', NULL, 'S1 RNA-binding domain-containing protein 1', 89, NULL, NULL, 193474),
(193475, '2.60.40.10-FF-002753', NULL, 'Transmembrane protein 130', 85, NULL, NULL, 193475),
(193476, '2.40.10.10-FF-000043', NULL, 'serine proteases 1/2', 98, NULL, NULL, 193476),
(193477, '1.10.8.10-FF-000080', NULL, 'UBC1p Ubiquitin-conjugating enzyme', 56, NULL, NULL, 193477),
(193478, '3.40.50.410-FF-000021', NULL, 'Collagen, type VI, alpha 3', 201, NULL, NULL, 193478),
(193479, '3.40.50.620-FF-000213', NULL, 'Methionine-tRNA ligase', 212, NULL, NULL, 193479),
(193480, '3.30.930.10-FF-000077', NULL, 'Putative lipoate-protein ligase A', 243, NULL, NULL, 193480),
(193481, '3.40.250.10-FF-000040', NULL, 'Zn-dependent hydroxyacylglutathione hydrolase', 110, NULL, NULL, 193481),
(193482, '1.10.10.10-FF-001581', NULL, 'Uncharacterized HTH-type transcriptional regulator HI_0143', 84, NULL, NULL, 193482),
(193483, '3.60.10.10-FF-000074', NULL, 'RNA exonuclease NGL2', 379, NULL, NULL, 193483),
(193484, '3.30.497.10-FF-000081', NULL, 'Serpin-Z1', 54, NULL, NULL, 193484),
(193485, '3.40.50.150-FF-001449', NULL, NULL, 140, NULL, NULL, 193485),
(193486, '2.30.30.490-FF-000064', NULL, 'DNA (cytosine-5)-methyltransferase', 171, NULL, NULL, 193486),
(193487, '3.90.550.50-FF-000136', NULL, 'Uncharacterized protein', 228, NULL, NULL, 193487),
(193488, '3.40.50.2000-FF-000374', NULL, 'LD38128p', 170, NULL, NULL, 193488),
(193489, '1.25.40.10-FF-001572', NULL, 'Pentatricopeptide repeat-containing protein At4g33990', 100, NULL, NULL, 193489),
(193490, '3.30.160.60-FF-003175', NULL, NULL, 30, NULL, NULL, 193490),
(193491, '1.20.1300.10-FF-000027', NULL, 'Succinate dehydrogenase cytochrome b560 subunit, mitochondrial', 137, NULL, NULL, 193491),
(193492, '1.25.40.10-FF-002398', NULL, 'PPR repeat/Pentatricopeptide repeat domain containing protein, putative', 160, NULL, NULL, 193492),
(193493, '3.90.1720.10-FF-000030', NULL, 'CHAP domain containing protein, putative', 233, NULL, NULL, 193493),
(193494, '2.130.10.10-FF-000477', NULL, 'Echinoderm microtubule-associated protein-like CG42247', 320, NULL, NULL, 193494),
(193495, '1.10.510.10-FF-000872', NULL, 'CMGC/CDK/CRK7 protein kinase', 218, NULL, NULL, 193495),
(193496, '3.40.720.10-FF-000194', NULL, 'Uncharacterized protein', 237, NULL, NULL, 193496),
(193497, '3.40.50.620-FF-000860', NULL, 'Uncharacterized protein', 171, NULL, NULL, 193497),
(193498, '3.40.50.1980-FF-000081', NULL, 'Iron(III) dicitrate-binding protein', 133, NULL, NULL, 193498),
(193499, '3.90.1200.10-FF-000075', NULL, 'Uncharacterized protein', 207, NULL, NULL, 193499);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(193500, '3.20.100.10-FF-000016', NULL, 'Uncharacterized protein', 263, NULL, NULL, 193500),
(193501, '2.10.25.10-FF-000808', NULL, 'Nimrod C1, isoform B', 33, NULL, NULL, 193501),
(193502, '1.10.287.2170-FF-000001', NULL, 'POSSIBLE RESOLVASE', 44, NULL, NULL, 193502),
(193503, '3.90.640.10-FF-000255', NULL, 'Actin family protein', 95, NULL, NULL, 193503),
(193504, '1.20.1070.10-FF-000817', NULL, 'AGAP001499-PB', 216, NULL, NULL, 193504),
(193505, '1.20.1070.10-FF-000565', NULL, 'Probable G-protein coupled receptor tkr-1', 328, NULL, NULL, 193505),
(193506, '3.30.365.10-FF-000044', NULL, 'Aldehyde oxidase and xanthine dehydrogenase, a/b hammerhead domain', 111, NULL, NULL, 193506),
(193507, '1.10.486.10-FF-000045', NULL, 'DNA helicase', 50, NULL, NULL, 193507),
(193508, '1.25.10.10-FF-000816', NULL, 'V-type proton ATPase subunit H', 315, NULL, NULL, 193508),
(193509, '3.30.2350.20-FF-000035', NULL, 'tRNA pseudouridine synthase D', 164, NULL, NULL, 193509),
(193510, '2.60.120.200-FF-000369', NULL, 'Uncharacterized protein', 256, NULL, NULL, 193510),
(193511, '2.40.250.10-FF-000004', NULL, 'Core binding factor beta subunit isoform 5', 86, NULL, NULL, 193511),
(193512, '2.30.42.10-FF-000269', NULL, 'Multiple PDZ domain protein', 109, NULL, NULL, 193512),
(193513, '3.40.1090.10-FF-000127', NULL, 'Protein CBG09699', 153, NULL, NULL, 193513),
(193514, '3.40.50.300-FF-005114', NULL, 'ABC transporter ATP-binding protein', 256, NULL, NULL, 193514),
(193515, '1.10.510.10-FF-001709', NULL, 'Protein NSP-INTERACTING KINASE 1', 148, NULL, NULL, 193515),
(193516, '3.30.230.70-FF-000058', NULL, '3 exoribonuclease family protein', 225, NULL, NULL, 193516),
(193517, '1.25.10.10-FF-003453', NULL, 'Maestro heat-like repeat-containing protein family member 1', 215, NULL, NULL, 193517),
(193518, '1.20.190.50-FF-000002', NULL, 'Nuclear pore complex protein', 274, NULL, NULL, 193518),
(193519, '3.40.50.300-FF-007470', NULL, 'Uncharacterized protein', 316, NULL, NULL, 193519),
(193520, '3.30.160.60-FF-001466', NULL, 'Uncharacterized protein', 29, NULL, NULL, 193520),
(193521, '4.10.260.20-FF-000001', NULL, 'NADP-reducing hydrogenase subunit HndD', 62, NULL, NULL, 193521),
(193522, '1.25.40.10-FF-002409', NULL, 'Pre-mRNA-splicing factor CLF1', 134, NULL, NULL, 193522),
(193523, '3.30.1010.10-FF-000057', NULL, 'Phosphatidylinositol-4,5-bisphosphate 3-kinase, putative', 134, NULL, NULL, 193523),
(193524, '3.20.80.10-FF-000012', NULL, 'Uncharacterized protein', 173, NULL, NULL, 193524),
(193525, '3.30.450.20-FF-000032', NULL, 'Aerobic respiration control sensor protein', 116, NULL, NULL, 193525),
(193526, '1.20.5.1160-FF-000020', NULL, 'Keratin 23', 111, NULL, NULL, 193526),
(193527, '2.10.25.10-FF-000910', NULL, 'laminin subunit alpha-3', 48, NULL, NULL, 193527),
(193528, '3.80.10.10-FF-000455', NULL, 'Osteomodulin', 71, NULL, NULL, 193528),
(193529, '3.40.50.150-FF-001758', NULL, NULL, 250, NULL, NULL, 193529),
(193530, '3.30.40.10-FF-000470', NULL, 'Putative RING finger U-box domain family protein', 64, NULL, NULL, 193530),
(193531, '1.10.1370.40-FF-000003', NULL, 'Endopeptidase, putative', 335, NULL, NULL, 193531),
(193532, '2.40.50.90-FF-000069', NULL, 'Tapas, isoform B', 106, NULL, NULL, 193532),
(193533, '3.40.50.300-FF-001871', NULL, 'ATP-binding cassette, putative', 290, NULL, NULL, 193533),
(193534, '3.40.50.300-FF-005570', NULL, 'Uncharacterized protein spnA', 203, NULL, NULL, 193534),
(193535, '3.40.50.720-FF-000917', NULL, '[NAD]-dependent malate oxidoreductase', 286, NULL, NULL, 193535),
(193536, '2.40.170.20-FF-000079', NULL, 'Iron(III) dicitrate transport protein (FecA)', 542, NULL, NULL, 193536),
(193537, '1.25.10.30-FF-000002', NULL, 'ryanodine receptor isoform X2', 136, NULL, NULL, 193537),
(193538, '3.10.20.90-FF-000403', NULL, 'ESX-1 secretion system protein EccD1', 91, NULL, NULL, 193538),
(193539, '1.10.510.10-FF-001457', NULL, 'Cyclin-dependent kinase C-2, putative', 243, NULL, NULL, 193539),
(193540, '2.30.30.40-FF-000357', NULL, 'Crk oncogene, isoform B', 61, NULL, NULL, 193540),
(193541, '1.10.150.240-FF-000096', NULL, 'Uncharacterized protein', 78, NULL, NULL, 193541);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(193542, '3.90.226.10-FF-000247', NULL, 'Methylcrotonoyl-CoA carboxylase beta chain, mitochondrial', 62, NULL, NULL, 193542),
(193543, '3.40.630.30-FF-000434', NULL, 'Predicted protein', 110, NULL, NULL, 193543),
(193544, '2.60.120.10-FF-000496', NULL, 'Predicted protein', 155, NULL, NULL, 193544),
(193545, '1.10.1410.10-FF-000032', NULL, 'PolyA polymerase', 155, NULL, NULL, 193545),
(193546, '3.40.190.10-FF-000978', NULL, 'Dipeptide ABC transporter, solute-binding protein', 100, NULL, NULL, 193546),
(193547, '2.60.40.2560-FF-000003', NULL, 'Serine/threonine-protein kinase PrkC', 79, NULL, NULL, 193547),
(193548, '1.10.8.430-FF-000002', NULL, 'Disease resistance protein (TIR-NBS-LRR class)', 83, NULL, NULL, 193548),
(193549, '1.10.238.10-FF-001195', NULL, 'Uncharacterized protein', 80, NULL, NULL, 193549),
(193550, '1.10.560.10-FF-000111', NULL, 'T-complex protein 1 subunit zeta', 80, NULL, NULL, 193550),
(193551, '2.70.98.40-FF-000011', NULL, 'Glycoside hydrolase family 65 protein', 235, NULL, NULL, 193551),
(193552, '1.20.1280.290-FF-000083', NULL, 'Uncharacterized protein', 92, NULL, NULL, 193552),
(193553, '2.60.40.10-FF-002298', NULL, 'Uncharacterized protein', 129, NULL, NULL, 193553),
(193554, '3.90.740.10-FF-000066', NULL, 'Leucyl-tRNA synthetase a', 95, NULL, NULL, 193554),
(193555, '3.40.1190.20-FF-000183', NULL, NULL, 315, NULL, NULL, 193555),
(193556, '1.25.10.10-FF-000772', NULL, 'YDL063C-like protein', 593, NULL, NULL, 193556),
(193557, '2.60.40.790-FF-000177', NULL, NULL, 124, NULL, NULL, 193557),
(193558, '1.10.287.370-FF-000100', NULL, 'YALI0D19822p', 60, NULL, NULL, 193558),
(193559, '1.10.238.10-FF-000576', NULL, 'Glycerol-3-phosphate dehydrogenase', 91, NULL, NULL, 193559),
(193560, '2.30.30.140-FF-000190', NULL, 'Pro-Pol polyprotein', 70, NULL, NULL, 193560),
(193561, '3.30.428.70-FF-000006', NULL, 'ATP adenylyltransferase', 294, NULL, NULL, 193561),
(193562, '2.60.40.60-FF-001115', NULL, 'Uncharacterized protein', 38, NULL, NULL, 193562),
(193563, '3.10.200.10-FF-000009', NULL, 'receptor-type tyrosine-protein phosphatase zeta isoform X2', 148, NULL, NULL, 193563),
(193564, '2.60.120.920-FF-000130', NULL, 'Uncharacterized protein', 66, NULL, NULL, 193564),
(193565, '3.30.160.60-FF-003366', NULL, 'Uncharacterized protein', 27, NULL, NULL, 193565),
(193566, '3.80.10.10-FF-004142', NULL, 'Uncharacterized protein', 109, NULL, NULL, 193566),
(193567, '2.60.120.200-FF-000105', NULL, 'Collagen type IX alpha 1 chain', 224, NULL, NULL, 193567),
(193568, '1.20.1250.20-FF-000992', NULL, 'Cation symporter', 409, NULL, NULL, 193568),
(193569, '3.40.50.300-FF-000191', NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase', 210, NULL, NULL, 193569),
(193570, '3.90.190.10-FF-000618', NULL, 'Uncharacterized protein', 79, NULL, NULL, 193570),
(193571, '3.90.70.10-FF-000795', NULL, 'Probable ubiquitin carboxyl-terminal hydrolase 16', 324, NULL, NULL, 193571),
(193572, '1.25.10.10-FF-001183', NULL, 'Serine/threonine-protein phosphatase 4 regulatory subunit 1', 388, NULL, NULL, 193572),
(193573, '3.30.160.60-FF-004456', NULL, NULL, 87, NULL, NULL, 193573),
(193574, '3.30.460.10-FF-000001', NULL, 'GTP pyrophosphokinase RelA', 134, NULL, NULL, 193574),
(193575, '1.20.1540.10-FF-000073', NULL, 'Rhomboid family serine protease', 230, NULL, NULL, 193575),
(193576, '3.80.10.10-FF-001736', NULL, 'GM22107', 86, NULL, NULL, 193576),
(193577, '3.40.50.1220-FF-000078', NULL, 'Sirtuin type 2', 100, NULL, NULL, 193577),
(193578, '1.20.120.520-FF-000014', NULL, 'Uncharacterized protein', 167, NULL, NULL, 193578),
(193579, '3.30.40.10-FF-001223', NULL, 'Protein 21.1, putative', 70, NULL, NULL, 193579),
(193580, '3.40.50.1820-FF-000050', NULL, 'prolyl endopeptidase-like isoform X2', 280, NULL, NULL, 193580),
(193581, '3.40.50.150-FF-001657', NULL, NULL, 200, NULL, NULL, 193581),
(193582, '2.160.10.10-FF-000026', NULL, 'Translation initiation factor eIF-2B subunit epsilon', 56, NULL, NULL, 193582),
(193583, '3.30.1370.10-FF-000106', NULL, 'Scp160p', 73, NULL, NULL, 193583),
(193584, '3.30.500.10-FF-000039', NULL, NULL, 90, NULL, NULL, 193584);
INSERT INTO "PUBLIC"."MODEL" VALUES
(193585, '3.80.10.10-FF-000556', NULL, 'CLUMA_CG018969, isoform B', 87, NULL, NULL, 193585),
(193586, '1.25.40.20-FF-001221', NULL, 'SH3 and multiple ankyrin repeat domains 2', 79, NULL, NULL, 193586),
(193587, '3.90.550.10-FF-000692', NULL, 'Uncharacterized protein', 58, NULL, NULL, 193587),
(193588, '3.30.450.70-FF-000041', NULL, NULL, 39, NULL, NULL, 193588),
(193589, '3.30.160.60-FF-000757', NULL, 'Transcription factor Msn2p', 25, NULL, NULL, 193589),
(193590, '3.30.1360.10-FF-000066', NULL, 'DNA-directed RNA polymerases II IV and V subunit 11', 67, NULL, NULL, 193590),
(193591, '3.30.40.10-FF-000717', NULL, 'Enhancer of yellow 3, isoform B', 114, NULL, NULL, 193591),
(193592, '1.20.120.720-FF-000041', NULL, 'Chitin synthase 6', 55, NULL, NULL, 193592),
(193593, '3.90.640.10-FF-000047', NULL, 'Actin, alpha skeletal muscle', 92, NULL, NULL, 193593),
(193594, '1.10.287.10-FF-000015', NULL, 'Mitochondrial ribosomal protein S15', 85, NULL, NULL, 193594),
(193595, '2.60.40.10-FF-000544', NULL, 'Mast/stem cell growth factor receptor', 90, NULL, NULL, 193595),
(193596, '1.25.40.20-FF-001693', NULL, 'LOC100005699 protein', 72, NULL, NULL, 193596),
(193597, '3.20.20.70-FF-000195', NULL, 'ribulose-phosphate 3-epimerase isoform X2', 159, NULL, NULL, 193597),
(193598, '3.40.50.1440-FF-000149', NULL, 'Protein DML1', 283, NULL, NULL, 193598),
(193599, '3.40.30.10-FF-001211', NULL, 'Predicted protein', 45, NULL, NULL, 193599),
(193600, '3.30.930.10-FF-000313', NULL, 'Phenylalanine--tRNA ligase beta subunit', 207, NULL, NULL, 193600),
(193601, '3.40.50.720-FF-002042', NULL, 'Uncharacterized protein', 181, NULL, NULL, 193601),
(193602, '1.10.1040.10-FF-000043', NULL, '2-dehydropantoate 2-reductase', 127, NULL, NULL, 193602),
(193603, '1.10.510.10-FF-002890', NULL, 'Non-specific serine/threonine protein kinase', 322, NULL, NULL, 193603),
(193604, '1.10.150.510-FF-000003', NULL, 'Receptor activity-modifying protein 2', 92, NULL, NULL, 193604),
(193605, '2.60.120.10-FF-000024', NULL, 'Cyclic nucleotide-gated ion channel 1', 119, NULL, NULL, 193605),
(193606, '3.90.1150.10-FF-000222', NULL, 'Methionine S-methyltransferase', 131, NULL, NULL, 193606),
(193607, '3.40.50.10890-FF-000015', NULL, 'Cleavage and polyadenylation specificity factor 73-like Protein', 99, NULL, NULL, 193607),
(193608, '3.30.160.60-FF-000038', NULL, 'Zinc finger protein 624', 28, NULL, NULL, 193608),
(193609, '3.10.110.10-FF-000126', NULL, 'Ubiquitin conjugating enzyme, putative', 240, NULL, NULL, 193609),
(193610, '3.30.830.10-FF-000013', NULL, 'Mitochondrial presequence protease', 192, NULL, NULL, 193610),
(193611, '3.30.460.10-FF-000215', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 144, NULL, NULL, 193611),
(193612, '2.40.10.10-FF-000543', NULL, NULL, 86, NULL, NULL, 193612),
(193613, '1.25.40.10-FF-003590', NULL, 'Protein CBR-UTX-1', 158, NULL, NULL, 193613),
(193614, '1.25.40.240-FF-000006', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 136, NULL, NULL, 193614),
(193615, '3.30.200.20-FF-000896', NULL, 'Protein kinase domain containing protein expressed', 98, NULL, NULL, 193615),
(193616, '1.20.58.60-FF-000755', NULL, 'Si:dkey-151c10.1 protein', 56, NULL, NULL, 193616),
(193617, '3.90.550.10-FF-000017', NULL, 'Mannan polymerase II complex ANP1 subunit', 302, NULL, NULL, 193617),
(193618, '2.160.20.110-FF-000002', NULL, 'Putative GLUG motif protein', 202, NULL, NULL, 193618),
(193619, '3.50.50.60-FF-000827', NULL, 'Oxidoreductase', 118, NULL, NULL, 193619),
(193620, '1.10.10.60-FF-000966', NULL, NULL, 52, NULL, NULL, 193620),
(193621, '2.60.120.290-FF-000222', NULL, 'Uncharacterized protein', 113, NULL, NULL, 193621),
(193622, '3.40.50.150-FF-001096', NULL, NULL, 193, NULL, NULL, 193622),
(193623, '3.40.50.2000-FF-000227', NULL, 'Alpha-1,2-mannosyltransferase', 189, NULL, NULL, 193623),
(193624, '2.60.120.200-FF-000577', NULL, 'Uncharacterized protein', 174, NULL, NULL, 193624),
(193625, '3.80.10.10-FF-002242', NULL, 'Uncharacterized protein', 91, NULL, NULL, 193625);
INSERT INTO "PUBLIC"."MODEL" VALUES
(193626, '3.40.640.10-FF-000305', NULL, '(S)-3,5-dihydroxyphenylglycine transaminase', 231, NULL, NULL, 193626),
(193627, '2.60.40.150-FF-000452', NULL, 'Coiled-coil and C2 domain containing 1A', 94, NULL, NULL, 193627),
(193628, '3.40.50.2300-FF-000458', NULL, 'Fructose repressor FruR LacI family', 172, NULL, NULL, 193628),
(193629, '3.40.50.300-FF-002697', NULL, 'Translation initiation factor IF-2, putative', 174, NULL, NULL, 193629),
(193630, '2.60.40.1510-FF-000060', NULL, 'Uncharacterized protein', 23, NULL, NULL, 193630),
(193631, '1.10.8.710-FF-000007', NULL, 'Putative dynein heavy chain', 107, NULL, NULL, 193631),
(193632, '2.30.180.10-FF-000068', NULL, NULL, 148, NULL, NULL, 193632),
(193633, '3.30.200.20-FF-000587', NULL, 'Non-specific serine/threonine protein kinase', 84, NULL, NULL, 193633),
(193634, '3.40.50.2020-FF-000121', NULL, 'Uridine kinase', 118, NULL, NULL, 193634),
(193635, '1.10.555.10-FF-000026', NULL, 'Rho GTPase activating protein 4', 254, NULL, NULL, 193635),
(193636, '2.60.40.10-FF-002859', NULL, 'Sialoadhesin', 119, NULL, NULL, 193636),
(193637, '1.20.920.10-FF-000160', NULL, 'Uncharacterized protein', 122, NULL, NULL, 193637),
(193638, '3.40.50.10190-FF-000356', NULL, 'Uncharacterized protein', 82, NULL, NULL, 193638),
(193639, '3.40.50.300-FF-004597', NULL, 'Uncharacterized protein', 146, NULL, NULL, 193639),
(193640, '1.10.1300.10-FF-000041', NULL, 'Phosphodiesterase 5A, cGMP-specific, a', 173, NULL, NULL, 193640),
(193641, '1.20.1070.10-FF-001745', NULL, 'Uncharacterized protein', 83, NULL, NULL, 193641),
(193642, '2.40.30.10-FF-000409', NULL, 'NADPH-dependent diflavin oxidoreductase 1', 78, NULL, NULL, 193642),
(193643, '3.30.200.20-FF-001093', NULL, 'Cyclin-dependent kinase-like 5', 94, NULL, NULL, 193643),
(193644, '1.20.1270.60-FF-000336', NULL, 'Uncharacterized protein', 137, NULL, NULL, 193644),
(193645, '3.90.470.20-FF-000076', NULL, 'Phosphopantetheinyltransferase family protein', 109, NULL, NULL, 193645),
(193646, '2.60.120.340-FF-000006', NULL, 'FK506-binding protein', 99, NULL, NULL, 193646),
(193647, '2.10.25.10-FF-000455', NULL, 'neurogenic locus notch homolog protein 3', 45, NULL, NULL, 193647),
(193648, '3.40.50.150-FF-000168', NULL, 'Methyltransferase', 262, NULL, NULL, 193648),
(193649, '2.130.10.10-FF-005491', NULL, 'Uncharacterized protein', 121, NULL, NULL, 193649),
(193650, '3.40.50.300-FF-005215', NULL, 'Cytidylate kinase', 208, NULL, NULL, 193650),
(193651, '3.30.70.330-FF-000588', NULL, 'Pre-mRNA splicing factor (Prp24), putative', 98, NULL, NULL, 193651),
(193652, '1.25.40.90-FF-000050', NULL, 'Pol II C-terminal Interaction Domain Suppressor', 141, NULL, NULL, 193652),
(193653, '3.40.50.300-FF-004709', NULL, 'Midasin', 276, NULL, NULL, 193653),
(193654, '3.30.710.10-FF-000196', NULL, 'BTB/POZ domain-containing protein', 155, NULL, NULL, 193654),
(193655, '3.30.1550.10-FF-000013', NULL, '50S ribosomal protein L11', 68, NULL, NULL, 193655),
(193656, '1.10.10.60-FF-000819', NULL, NULL, 50, NULL, NULL, 193656),
(193657, '1.20.144.10-FF-000108', NULL, 'Uncharacterized protein', 231, NULL, NULL, 193657),
(193658, '3.40.50.300-FF-007368', NULL, 'Uncharacterized protein', 204, NULL, NULL, 193658),
(193659, '1.10.630.10-FF-000139', NULL, '7-ethoxycoumarin O-deethylase', 282, NULL, NULL, 193659),
(193660, '1.20.1070.10-FF-000464', NULL, 'Trace amine-associated receptor 1', 295, NULL, NULL, 193660),
(193661, '1.25.40.10-FF-005271', NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', 151, NULL, NULL, 193661),
(193662, '3.20.20.80-FF-000552', NULL, 'Predicted protein', 337, NULL, NULL, 193662),
(193663, '1.20.1250.20-FF-000683', NULL, 'Multidrug efflux pump Tap', 189, NULL, NULL, 193663),
(193664, '3.30.70.330-FF-002488', NULL, NULL, 76, NULL, NULL, 193664),
(193665, '3.20.20.80-FF-000243', NULL, 'Beta-glucuronidase', 310, NULL, NULL, 193665),
(193666, '1.25.10.10-FF-000463', NULL, 'Coatomer subunit gamma', 153, NULL, NULL, 193666),
(193667, '1.10.260.40-FF-000081', NULL, 'Helix-turn-helix XRE domain protein', 74, NULL, NULL, 193667),
(193668, '3.30.70.330-FF-001869', NULL, NULL, 104, NULL, NULL, 193668); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(193669, '2.130.10.10-FF-000932', NULL, 'Related to Vacuolar assembly protein VPS41', 235, NULL, NULL, 193669),
(193670, '2.30.29.30-FF-000171', NULL, 'Actin filament-associated protein 1-like 2 isoform 1', 137, NULL, NULL, 193670),
(193671, '2.30.31.10-FF-000030', NULL, 'Uncharacterized protein', 61, NULL, NULL, 193671),
(193672, '3.30.450.50-FF-000030', NULL, 'Vesicle-associated membrane protein, putative', 130, NULL, NULL, 193672),
(193673, '1.25.40.10-FF-001229', NULL, 'Os04g0221300 protein', 103, NULL, NULL, 193673),
(193674, '3.30.70.2170-FF-000005', NULL, 'V-type ATP synthase subunit I', 63, NULL, NULL, 193674),
(193675, '1.10.580.10-FF-000011', NULL, 'Citrate synthase', 227, NULL, NULL, 193675),
(193676, '3.30.420.340-FF-000002', NULL, 'UvrABC system protein C', 159, NULL, NULL, 193676),
(193677, '2.60.40.10-FF-000089', NULL, 'calmodulin-binding transcription activator 2 isoform X1', 91, NULL, NULL, 193677),
(193678, '1.25.40.20-FF-000501', NULL, 'Ankyrin repeat protein', 49, NULL, NULL, 193678),
(193679, '3.30.310.20-FF-000005', NULL, 'Ada regulatory protein', 112, NULL, NULL, 193679),
(193680, '2.30.42.10-FF-000510', NULL, NULL, 89, NULL, NULL, 193680),
(193681, '3.30.1520.10-FF-000068', NULL, 'Atg20p', 124, NULL, NULL, 193681),
(193682, '1.10.287.610-FF-000009', NULL, '30S ribosomal protein S2', 47, NULL, NULL, 193682),
(193683, '1.10.10.60-FF-000921', NULL, NULL, 53, NULL, NULL, 193683),
(193684, '3.40.50.300-FF-006851', NULL, 'Uncharacterized protein', 260, NULL, NULL, 193684),
(193685, '1.20.1050.10-FF-000142', NULL, 'Uncharacterized protein', 56, NULL, NULL, 193685),
(193686, '2.20.100.10-FF-000099', NULL, 'SCO-spondin', 58, NULL, NULL, 193686),
(193687, '3.40.50.460-FF-000025', NULL, 'ATP-dependent 6-phosphofructokinase 2', 140, NULL, NULL, 193687),
(193688, '2.130.10.30-FF-000163', NULL, NULL, 115, NULL, NULL, 193688),
(193689, '2.60.40.10-FF-001472', NULL, 'Frazzled, isoform B', 99, NULL, NULL, 193689),
(193690, '3.40.50.10190-FF-000047', NULL, 'Microcephalin', 97, NULL, NULL, 193690),
(193691, '1.20.140.150-FF-000082', NULL, 'Uncharacterized protein', 202, NULL, NULL, 193691),
(193692, '3.40.1800.20-FF-000028', NULL, NULL, 80, NULL, NULL, 193692),
(193693, '3.40.30.10-FF-000031', NULL, 'Calsequestrin', 124, NULL, NULL, 193693),
(193694, '3.30.40.10-FF-002151', NULL, 'PDZ/DHR/GLGF domaincontaining protein', 131, NULL, NULL, 193694),
(193695, '2.60.40.150-FF-000761', NULL, 'Uncharacterized protein', 130, NULL, NULL, 193695),
(193696, '2.60.40.60-FF-000143', NULL, 'FAT atypical cadherin 4', 94, NULL, NULL, 193696),
(193697, '3.30.590.10-FF-000005', NULL, 'Probable glutamine synthetase', 339, NULL, NULL, 193697),
(193698, '3.20.20.140-FF-000225', NULL, 'Putative deoxyribonuclease TATDN3', 271, NULL, NULL, 193698),
(193699, '2.40.50.140-FF-000247', NULL, 'Exosome complex exonuclease exoribonuclease (Rrp44)', 109, NULL, NULL, 193699),
(193700, '1.20.5.500-FF-000004', NULL, 'ATPase inhibitor A, mitochondrial', 46, NULL, NULL, 193700),
(193701, '3.40.50.1370-FF-000004', NULL, 'Ornithine carbamoyltransferase', 167, NULL, NULL, 193701),
(193702, '1.25.40.10-FF-002662', NULL, 'Uncharacterized protein', 262, NULL, NULL, 193702),
(193703, '3.40.50.150-FF-000729', NULL, 'Cypemycin methyltransferase', 141, NULL, NULL, 193703),
(193704, '2.130.10.10-FF-003591', NULL, 'Protein DECREASED SIZE EXCLUSION LIMIT 1', 130, NULL, NULL, 193704),
(193705, '2.40.270.10-FF-000022', NULL, NULL, 38, NULL, NULL, 193705),
(193706, '1.20.5.690-FF-000004', NULL, 'Importin subunit alpha', 42, NULL, NULL, 193706),
(193707, '1.25.40.610-FF-000005', NULL, 'cadherin EGF LAG seven-pass G-type receptor 2', 128, NULL, NULL, 193707),
(193708, '3.30.70.330-FF-003106', NULL, NULL, 87, NULL, NULL, 193708),
(193709, '3.30.2440.10-FF-000005', NULL, 'SPI-1 type III secretion system effector SopD', 123, NULL, NULL, 193709),
(193710, '3.40.50.10380-FF-000014', NULL, 'Malic enzyme', 209, NULL, NULL, 193710),
(193711, '2.115.10.20-FF-000009', NULL, 'Extracellular invertase', 427, NULL, NULL, 193711),
(193712, '3.40.350.10-FF-000058', NULL, 'Uncharacterized protein', 142, NULL, NULL, 193712);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(193713, '3.40.140.10-FF-000003', NULL, 'COP9 signalosome complex subunit 5', 256, NULL, NULL, 193713),
(193714, '3.20.20.150-FF-000071', NULL, 'Uncharacterized protein', 142, NULL, NULL, 193714),
(193715, '3.40.47.10-FF-000086', NULL, '3-hydroxy-3-methylglutaryl-CoA synthase, putative', 492, NULL, NULL, 193715),
(193716, '3.40.50.300-FF-001163', NULL, 'RAB6B, member RAS oncogene family', 179, NULL, NULL, 193716),
(193717, '1.10.510.10-FF-001912', NULL, 'Kinase-like domain-containing protein', 190, NULL, NULL, 193717),
(193718, '1.20.120.1630-FF-000017', NULL, '3-oxo-5-alpha-steroid 4-dehydrogenase family protein', 173, NULL, NULL, 193718),
(193719, '3.30.1120.160-FF-000002', NULL, 'Signal-induced proliferation-associated 1-like protein 1', 146, NULL, NULL, 193719),
(193720, '3.30.420.40-FF-000553', NULL, 'Uncharacterized protein', 120, NULL, NULL, 193720),
(193721, '3.90.79.10-FF-000135', NULL, 'Adenine DNA glycosylase', 132, NULL, NULL, 193721),
(193722, '3.40.50.300-FF-006542', NULL, 'Uncharacterized protein', 107, NULL, NULL, 193722),
(193723, '3.90.190.10-FF-000057', NULL, 'Dual specificity phosphatase 5', 162, NULL, NULL, 193723),
(193724, '3.30.160.60-FF-003630', NULL, NULL, 27, NULL, NULL, 193724),
(193725, '3.40.50.150-FF-000477', NULL, 'Putative tRNA (cytidine(32)/guanosine(34)-2''-O)-methyltransferase', 224, NULL, NULL, 193725),
(193726, '2.60.120.260-FF-000016', NULL, 'Contactin-associated protein-like 4 isoform 1', 150, NULL, NULL, 193726),
(193727, '3.30.70.920-FF-000006', NULL, 'AsnC family transcriptional regulator', 82, NULL, NULL, 193727),
(193728, '3.30.70.370-FF-000021', NULL, 'Polymerase (DNA directed), theta', 114, NULL, NULL, 193728),
(193729, '2.60.40.10-FF-003181', NULL, 'Sensor histidine kinase/response regulator', 113, NULL, NULL, 193729),
(193730, '3.40.50.1820-FF-000403', NULL, 'RTX toxin RtxA', 190, NULL, NULL, 193730),
(193731, '3.40.50.1010-FF-000133', NULL, 'Exonuclease', 152, NULL, NULL, 193731),
(193732, '3.40.50.410-FF-000044', NULL, 'Collagen type VI alpha 6 chain', 187, NULL, NULL, 193732),
(193733, '2.60.40.10-FF-001573', NULL, 'Interleukin-4 receptor subunit alpha', 96, NULL, NULL, 193733),
(193734, '1.10.287.4070-FF-000020', NULL, 'NOP56 ribonucleoprotein', 119, NULL, NULL, 193734),
(193735, '1.10.472.10-FF-000535', NULL, 'Uncharacterized protein', 84, NULL, NULL, 193735),
(193736, '2.60.40.1150-FF-000007', NULL, 'AP complex subunit beta', 115, NULL, NULL, 193736),
(193737, '1.10.10.10-FF-001772', NULL, 'Phosphate regulon transcriptional regulatory protein PhoB (SphR)', 95, NULL, NULL, 193737),
(193738, '3.40.50.1370-FF-000027', NULL, 'Aspartate carbamoyltransferase', 167, NULL, NULL, 193738),
(193739, '2.60.120.370-FF-000004', NULL, 'Putative mannitol dehydrogenase', 151, NULL, NULL, 193739),
(193740, '1.20.140.150-FF-000065', NULL, 'GM16516', 206, NULL, NULL, 193740),
(193741, '1.20.1070.10-FF-002026', NULL, 'Uncharacterized protein', 123, NULL, NULL, 193741),
(193742, '3.40.50.2300-FF-000430', NULL, 'GntR family transcriptional regulator', 95, NULL, NULL, 193742),
(193743, '2.160.20.10-FF-000307', NULL, 'F-box protein 11a', 124, NULL, NULL, 193743),
(193744, '3.30.499.10-FF-000040', NULL, NULL, 202, NULL, NULL, 193744),
(193745, '2.60.40.1450-FF-000002', NULL, 'Recombination signal binding protein for immunoglobulin kappa J region like', 170, NULL, NULL, 193745),
(193746, '3.40.50.10330-FF-000016', NULL, 'Diacylglycerol kinase', 144, NULL, NULL, 193746),
(193747, '1.20.1280.50-FF-000036', NULL, 'F-box and leucine rich repeat protein 22', 48, NULL, NULL, 193747),
(193748, '3.50.50.60-FF-000799', NULL, 'Uncharacterized protein', 282, NULL, NULL, 193748),
(193749, '3.40.50.1820-FF-000842', NULL, 'Carboxylic ester hydrolase', 222, NULL, NULL, 193749),
(193750, '3.40.50.2000-FF-000930', NULL, 'Probable heptosyl III transferase', 155, NULL, NULL, 193750),
(193751, '3.40.140.10-FF-000239', NULL, 'Uncharacterized protein', 239, NULL, NULL, 193751),
(193752, '3.90.70.10-FF-000379', NULL, 'Cysteine proteinases superfamily protein', 287, NULL, NULL, 193752);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(193753, '2.60.40.10-FF-000628', NULL, 'Beta-glucuronidase', 104, NULL, NULL, 193753),
(193754, '1.10.1600.10-FF-000007', NULL, 'Yeast Ku70 protein', 118, NULL, NULL, 193754),
(193755, '3.90.1520.10-FF-000003', NULL, 'Guanylate cyclase soluble subunit alpha-2', 173, NULL, NULL, 193755),
(193756, '3.30.70.1150-FF-000003', NULL, 'Acetolactate synthase, small subunit', 80, NULL, NULL, 193756),
(193757, '1.20.1160.20-FF-000018', NULL, 'Regulator of telomere elongation helicase 1', 77, NULL, NULL, 193757),
(193758, '3.30.70.260-FF-000090', NULL, 'Protein translocase subunit SecD', 79, NULL, NULL, 193758),
(193759, '2.130.10.10-FF-001702', NULL, 'AGAP000009-PB', 300, NULL, NULL, 193759),
(193760, '2.60.210.10-FF-000031', NULL, 'TNF receptor-associated factor homolog 1b', 151, NULL, NULL, 193760),
(193761, '1.10.510.10-FF-000956', NULL, 'CAMK family protein kinase', 307, NULL, NULL, 193761),
(193762, '3.20.20.140-FF-000309', NULL, 'Uncharacterized protein', 272, NULL, NULL, 193762),
(193763, '1.20.58.60-FF-000199', NULL, 'Alpha spectrin, isoform B', 108, NULL, NULL, 193763),
(193764, '3.30.160.60-FF-006373', NULL, NULL, 78, NULL, NULL, 193764),
(193765, '1.25.10.10-FF-000356', NULL, 'Putative huntingtin', 253, NULL, NULL, 193765),
(193766, '3.30.160.60-FF-005861', NULL, NULL, 63, NULL, NULL, 193766),
(193767, '3.10.450.50-FF-000045', NULL, 'UBA/TS-N domain containing protein', 152, NULL, NULL, 193767),
(193768, '3.30.70.330-FF-000279', NULL, 'G-rich RNA sequence binding factor 1', 89, NULL, NULL, 193768),
(193769, '3.40.50.300-FF-006879', NULL, 'Branched-chain amino acid transport ATP-binding protein', 246, NULL, NULL, 193769),
(193770, '3.40.50.300-FF-003214', NULL, 'Uncharacterized protein', 245, NULL, NULL, 193770),
(193771, '3.40.50.1820-FF-001022', NULL, 'GPI inositol-deacylase A', 199, NULL, NULL, 193771),
(193772, '2.20.25.10-FF-000050', NULL, 'DNA-directed RNA polymerase subunit', 66, NULL, NULL, 193772),
(193773, '1.20.5.1160-FF-000003', NULL, 'protein enabled homolog isoform X2', 44, NULL, NULL, 193773),
(193774, '3.40.50.970-FF-000150', NULL, 'Pyruvate dehydrogenase E1 component beta subunit', 72, NULL, NULL, 193774),
(193775, '1.10.472.10-FF-000428', NULL, 'Mitotic cyclin', 60, NULL, NULL, 193775),
(193776, '4.10.280.10-FF-000230', NULL, 'Extra macrochaetae-like protein', 70, NULL, NULL, 193776),
(193777, '3.40.850.10-FF-000097', NULL, 'Myosin E, putative', 49, NULL, NULL, 193777),
(193778, '1.20.1280.50-FF-000143', NULL, 'Predicted protein', 39, NULL, NULL, 193778),
(193779, '1.10.510.10-FF-000428', NULL, 'inactive serine/threonine-protein kinase TEX14 isoform X1', 259, NULL, NULL, 193779),
(193780, '3.60.15.10-FF-000141', NULL, 'Ribonuclease Z 1', 265, NULL, NULL, 193780),
(193781, '1.10.472.10-FF-000058', NULL, 'cyclin-C1-2-like isoform X1', 125, NULL, NULL, 193781),
(193782, '1.25.10.10-FF-001289', NULL, 'INTegrator complex Subunit homolog', 303, NULL, NULL, 193782),
(193783, '3.40.50.10190-FF-000255', NULL, 'PIS (Pax-2, IA-1/6, Smad-2 interacting protein) homolog', 87, NULL, NULL, 193783),
(193784, '3.30.70.2510-FF-000006', NULL, NULL, 202, NULL, NULL, 193784),
(193785, '1.20.1280.110-FF-000001', NULL, 'Effector protein HopAB2', 85, NULL, NULL, 193785),
(193786, '4.10.49.10-FF-000005', NULL, NULL, 50, NULL, NULL, 193786),
(193787, '3.40.50.300-FF-000466', NULL, 'ATP-dependent DNA helicase', 189, NULL, NULL, 193787),
(193788, '2.60.120.200-FF-000471', NULL, 'Crumbs cell polarity complex component 1', 160, NULL, NULL, 193788),
(193789, '1.20.1270.20-FF-000010', NULL, 'Hybrid-cluster protein, putative', 56, NULL, NULL, 193789),
(193790, '2.30.29.30-FF-000272', NULL, 'Rho guanine nucleotide exchange factor 15', 114, NULL, NULL, 193790),
(193791, '3.40.50.410-FF-000151', NULL, 'Uncharacterized protein', 191, NULL, NULL, 193791),
(193792, '2.130.10.10-FF-005283', NULL, 'Uncharacterized protein', 231, NULL, NULL, 193792),
(193793, '1.20.5.550-FF-000002', NULL, 'Bifunctional protein PutA', 51, NULL, NULL, 193793),
(193794, '1.10.287.690-FF-000005', NULL, 'DNA polymerase epsilon catalytic subunit', 75, NULL, NULL, 193794);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(193795, '1.25.40.10-FF-004562', NULL, 'Tetratricopeptide repeat protein, putative', 202, NULL, NULL, 193795),
(193796, '3.30.1130.10-FF-000004', NULL, 'NADPH-dependent 7-cyano-7-deazaguanine reductase', 139, NULL, NULL, 193796),
(193797, '1.20.1070.10-FF-000481', NULL, 'AGAP001379-PA', 324, NULL, NULL, 193797),
(193798, '3.30.160.60-FF-003927', NULL, NULL, 38, NULL, NULL, 193798),
(193799, '1.20.144.10-FF-000007', NULL, 'phospholipid phosphatase 1 isoform X2', 269, NULL, NULL, 193799),
(193800, '1.10.510.10-FF-003290', NULL, NULL, 92, NULL, NULL, 193800),
(193801, '1.10.357.140-FF-000014', NULL, '4-hydroxybenzoate polyprenyl transferase', 160, NULL, NULL, 193801),
(193802, '3.60.21.10-FF-000447', NULL, 'Uncharacterized protein', 195, NULL, NULL, 193802),
(193803, '1.25.40.10-FF-000184', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 230, NULL, NULL, 193803),
(193804, '2.60.60.20-FF-000048', NULL, NULL, 105, NULL, NULL, 193804),
(193805, '3.30.70.141-FF-000043', NULL, 'Nucleoside diphosphate kinase', 142, NULL, NULL, 193805),
(193806, '3.30.40.10-FF-001881', NULL, 'Uncharacterized protein', 113, NULL, NULL, 193806),
(193807, '2.10.25.10-FF-001444', NULL, 'Predicted protein', 45, NULL, NULL, 193807),
(193808, '1.10.8.270-FF-000038', NULL, 'Ypt/Rab-GAP domain of gyp1p superfamily protein', 177, NULL, NULL, 193808),
(193809, '3.30.40.10-FF-000734', NULL, 'PHD finger family protein', 67, NULL, NULL, 193809),
(193810, '1.25.40.20-FF-000973', NULL, 'Uncharacterized protein', 178, NULL, NULL, 193810),
(193811, '3.40.50.1820-FF-001819', NULL, 'Uncharacterized protein', 100, NULL, NULL, 193811),
(193812, '3.10.20.90-FF-000959', NULL, 'FERM, ARH/RhoGEF and pleckstrin domain protein 2', 57, NULL, NULL, 193812),
(193813, '2.30.42.10-FF-000246', NULL, 'Uncharacterized protein, isoform A', 92, NULL, NULL, 193813),
(193814, '1.10.287.130-FF-000051', NULL, 'Two-component system sensor histidine kinase CreC', 61, NULL, NULL, 193814),
(193815, '3.40.50.300-FF-005098', NULL, 'Arsenical pump-driving ATPase', 341, NULL, NULL, 193815),
(193816, '2.60.120.650-FF-000127', NULL, 'Predicted protein', 359, NULL, NULL, 193816),
(193817, '1.10.10.10-FF-001665', NULL, 'Eukaryotic translation initiation factor 3 subunit C', 62, NULL, NULL, 193817),
(193818, '3.30.70.330-FF-002622', NULL, NULL, 127, NULL, NULL, 193818),
(193819, '3.20.20.330-FF-000029', NULL, 'Uncharacterized protein', 109, NULL, NULL, 193819),
(193820, '3.40.50.880-FF-000151', NULL, 'Peptidase E', 188, NULL, NULL, 193820),
(193821, '1.25.40.10-FF-000291', NULL, 'Pentatricopeptide repeat-containing protein PPR5, chloroplastic', 72, NULL, NULL, 193821),
(193822, '1.10.486.10-FF-000022', NULL, 'Unplaced genomic scaffold supercont2.6, whole genome shotgun sequence', 23, NULL, NULL, 193822),
(193823, '3.40.50.80-FF-000098', NULL, 'Respiratory burst oxidase-like protein F isoform A', 192, NULL, NULL, 193823),
(193824, '3.90.1180.10-FF-000033', NULL, NULL, 114, NULL, NULL, 193824),
(193825, '1.10.510.10-FF-001373', NULL, 'Ser/Thr protein kinase, putative', 116, NULL, NULL, 193825),
(193826, '1.10.8.60-FF-000381', NULL, 'Checkpoint protein rad17', 68, NULL, NULL, 193826),
(193827, '1.25.40.20-FF-000496', NULL, 'Zinc finger CCCH domain-containing protein 29', 159, NULL, NULL, 193827),
(193828, '1.20.1270.60-FF-000230', NULL, 'AaceriABR082Wp', 277, NULL, NULL, 193828),
(193829, '3.30.420.40-FF-001082', NULL, 'Predicted protein', 122, NULL, NULL, 193829),
(193830, '2.10.25.10-FF-000039', NULL, 'Crumbs cell polarity complex component 1', 38, NULL, NULL, 193830),
(193831, '3.30.60.20-FF-000154', NULL, 'Protein kinase D4', 59, NULL, NULL, 193831),
(193832, '1.10.238.10-FF-000840', NULL, 'EF-hand domain pair/EF-hand domain/EF hand, putative', 128, NULL, NULL, 193832),
(193833, '3.40.30.10-FF-000328', NULL, 'Mitochondrial ribosomal protein L51 / S25 / CI-B8 domain containing protein', 129, NULL, NULL, 193833),
(193834, '2.30.42.10-FF-000611', NULL, NULL, 94, NULL, NULL, 193834),
(193835, '3.40.50.970-FF-000043', NULL, 'IlvB acetolactate synthase like', 184, NULL, NULL, 193835);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(193836, '2.60.40.10-FF-004467', NULL, NULL, 99, NULL, NULL, 193836),
(193837, '3.40.50.300-FF-002225', NULL, 'ATP-dependent RNA helicase DOB1', 200, NULL, NULL, 193837),
(193838, '1.20.1560.10-FF-000237', NULL, 'ATP-binding cassette protein subfamily C, member 8', 332, NULL, NULL, 193838),
(193839, '3.40.50.720-FF-002273', NULL, 'Predicted protein', 25, NULL, NULL, 193839),
(193840, '3.30.390.30-FF-000018', NULL, 'Monodehydroascorbate reductase', 88, NULL, NULL, 193840),
(193841, '2.60.120.1560-FF-000007', NULL, 'Uncharacterized membrane protein YFL051C', 57, NULL, NULL, 193841),
(193842, '3.40.33.10-FF-000161', NULL, 'Protein CBG03516', 124, NULL, NULL, 193842),
(193843, '3.10.430.100-FF-000010', NULL, '50S ribosomal protein L9', 87, NULL, NULL, 193843),
(193844, '3.40.50.300-FF-006626', NULL, 'Predicted protein', 92, NULL, NULL, 193844),
(193845, '1.20.142.10-FF-000020', NULL, 'Poly [ADP-ribose] polymerase', 143, NULL, NULL, 193845),
(193846, '1.20.1560.10-FF-000765', NULL, 'Predicted protein', 323, NULL, NULL, 193846),
(193847, '1.25.50.20-FF-000103', NULL, 'Aminopeptidase', 114, NULL, NULL, 193847),
(193848, '3.30.450.60-FF-000021', NULL, 'signal recognition particle receptor subunit alpha isoform X2', 129, NULL, NULL, 193848),
(193849, '2.60.40.10-FF-002989', NULL, 'Uncharacterized protein, isoform A', 125, NULL, NULL, 193849),
(193850, '2.60.120.10-FF-000597', NULL, 'Cyclic nucleotide-binding domain containing protein', 134, NULL, NULL, 193850),
(193851, '3.90.1150.10-FF-000194', NULL, '2-aminoethylphosphonate--pyruvate transaminase', 100, NULL, NULL, 193851),
(193852, '1.10.1060.10-FF-000033', NULL, NULL, 90, NULL, NULL, 193852),
(193853, '1.25.40.10-FF-004343', NULL, 'Uncharacterized protein', 310, NULL, NULL, 193853),
(193854, '3.90.1150.10-FF-000205', NULL, 'Aminotransferase', 119, NULL, NULL, 193854),
(193855, '1.10.150.240-FF-000107', NULL, 'AAL123Wp', 60, NULL, NULL, 193855),
(193856, '3.30.160.60-FF-003028', NULL, 'Uncharacterized protein', 27, NULL, NULL, 193856),
(193857, '1.50.40.10-FF-000575', NULL, 'Uncharacterized protein', 76, NULL, NULL, 193857),
(193858, '3.30.310.40-FF-000016', NULL, 'Uncharacterized protein', 67, NULL, NULL, 193858),
(193859, '1.25.40.990-FF-000074', NULL, 'Uncharacterized protein', 282, NULL, NULL, 193859),
(193860, '3.10.100.10-FF-000417', NULL, NULL, 98, NULL, NULL, 193860),
(193861, '3.80.10.10-FF-002017', NULL, 'Uncharacterized protein', 123, NULL, NULL, 193861),
(193862, '2.70.40.10-FF-000004', NULL, 'Deoxyuridine triphosphatase', 149, NULL, NULL, 193862),
(193863, '3.30.420.40-FF-000570', NULL, 'Acetate kinase', 205, NULL, NULL, 193863),
(193864, '1.20.1560.10-FF-000080', NULL, 'ABC transporter C family member 1', 315, NULL, NULL, 193864),
(193865, '3.40.50.300-FF-007571', NULL, 'Uncharacterized protein', 182, NULL, NULL, 193865),
(193866, '2.60.40.10-FF-002562', NULL, 'Beta-glucosidase BglS', 112, NULL, NULL, 193866),
(193867, '3.30.1370.10-FF-000022', NULL, 'RNA-binding protein Nova-1 isoform 1', 79, NULL, NULL, 193867),
(193868, '3.40.50.150-FF-001421', NULL, NULL, 155, NULL, NULL, 193868),
(193869, '3.30.200.20-FF-002374', NULL, 'Protein kinase C', 80, NULL, NULL, 193869),
(193870, '1.50.10.20-FF-000065', NULL, 'Complement component C3B', 59, NULL, NULL, 193870),
(193871, '3.40.50.1000-FF-000383', NULL, 'Phosphorylated carbohydrates phosphatase TM_1254', 136, NULL, NULL, 193871),
(193872, '1.10.533.20-FF-000001', NULL, 'NLR family CARD domain containing 5', 97, NULL, NULL, 193872),
(193873, '3.30.1330.80-FF-000006', NULL, 'AT-hook motif nuclear-localized protein', 135, NULL, NULL, 193873),
(193874, '1.10.8.60-FF-000162', NULL, 'ATPase, putative', 77, NULL, NULL, 193874),
(193875, '3.40.50.300-FF-001736', NULL, 'COMF operon protein 1', 154, NULL, NULL, 193875),
(193876, '1.20.272.10-FF-000046', NULL, NULL, 87, NULL, NULL, 193876),
(193877, '2.10.110.10-FF-000309', NULL, 'Uncharacterized protein', 98, NULL, NULL, 193877),
(193878, '1.10.560.10-FF-000139', NULL, 'Uncharacterized protein', 92, NULL, NULL, 193878),
(193879, '3.90.190.10-FF-000164', NULL, 'GM24530', 310, NULL, NULL, 193879);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(193880, '3.20.20.10-FF-000020', NULL, 'S-adenosylmethionine decarboxylase/ornithine decarboxylase', 206, NULL, NULL, 193880),
(193881, '3.30.70.330-FF-002752', NULL, NULL, 88, NULL, NULL, 193881),
(193882, '3.40.30.10-FF-000019', NULL, 'Glutathione S-transferase Mu', 101, NULL, NULL, 193882),
(193883, '3.20.20.70-FF-000779', NULL, NULL, 80, NULL, NULL, 193883),
(193884, '3.30.70.330-FF-002257', NULL, NULL, 80, NULL, NULL, 193884),
(193885, '3.30.70.1230-FF-000038', NULL, 'soluble guanylate cyclase 89Da', 197, NULL, NULL, 193885),
(193886, '3.30.70.640-FF-000001', NULL, 'Cyclic pyranopterin monophosphate synthase', 161, NULL, NULL, 193886),
(193887, '1.20.1070.10-FF-000109', NULL, 'Leukotriene B4 receptor', 288, NULL, NULL, 193887),
(193888, '3.30.1330.30-FF-000110', NULL, 'YALI0B20658p', 107, NULL, NULL, 193888),
(193889, '1.25.40.20-FF-001805', NULL, 'Protein CBR-DAPK-1', 165, NULL, NULL, 193889),
(193890, '1.10.1040.10-FF-000020', NULL, 'D-mannonate oxidoreductase, NAD-binding', 208, NULL, NULL, 193890),
(193891, '2.130.10.10-FF-005608', NULL, 'Predicted protein', 189, NULL, NULL, 193891),
(193892, '3.40.630.20-FF-000004', NULL, 'Pyroglutamyl-peptidase I like', 181, NULL, NULL, 193892),
(193893, '3.40.630.10-FF-000456', NULL, 'Uncharacterized protein', 150, NULL, NULL, 193893),
(193894, '3.30.720.110-FF-000001', NULL, 'Phenazine antibiotic resistance protein EhpR', 59, NULL, NULL, 193894),
(193895, '3.10.290.70-FF-000010', NULL, '40S ribosomal protein S8', 64, NULL, NULL, 193895),
(193896, '1.25.40.10-FF-002089', NULL, 'Clathrin heavy chain', 156, NULL, NULL, 193896),
(193897, '3.90.550.20-FF-000032', NULL, 'Uncharacterized protein', 214, NULL, NULL, 193897),
(193898, '2.40.30.330-FF-000008', NULL, 'ATP/GTP-binding protein, putative', 120, NULL, NULL, 193898),
(193899, '3.30.420.40-FF-000098', NULL, 'ARP5 actin-related protein 5 homolog', 31, NULL, NULL, 193899),
(193900, '3.30.420.10-FF-000246', NULL, 'CCR4-NOT transcription complex,subunit 7-like', 271, NULL, NULL, 193900),
(193901, '2.60.120.10-FF-000602', NULL, 'Uncharacterized protein', 137, NULL, NULL, 193901),
(193902, '3.30.420.10-FF-000555', NULL, NULL, 60, NULL, NULL, 193902),
(193903, '1.20.1250.20-FF-002234', NULL, 'Uncharacterized protein', 121, NULL, NULL, 193903),
(193904, '1.20.1250.40-FF-000003', NULL, 'DNA-directed RNA polymerase II subunit rpb4', 133, NULL, NULL, 193904),
(193905, '3.90.1240.10-FF-000004', NULL, 'Botulinum neurotoxin type D', 436, NULL, NULL, 193905),
(193906, '3.40.50.300-FF-006087', NULL, 'Predicted protein', 67, NULL, NULL, 193906),
(193907, '1.10.150.50-FF-000210', NULL, 'Uncharacterized protein', 52, NULL, NULL, 193907),
(193908, '6.10.140.2220-FF-000066', NULL, 'Predicted protein', 57, NULL, NULL, 193908),
(193909, '3.30.479.30-FF-000033', NULL, 'Uncharacterized protein', 127, NULL, NULL, 193909),
(193910, '2.60.40.10-FF-003051', NULL, 'Interleukin-1 receptor type I', 91, NULL, NULL, 193910),
(193911, '1.10.1200.10-FF-000022', NULL, 'Polyketide synthase Pks13', 86, NULL, NULL, 193911),
(193912, '3.40.50.720-FF-001654', NULL, 'Predicted protein', 171, NULL, NULL, 193912),
(193913, '3.30.450.40-FF-000279', NULL, 'Two-component response regulator', 133, NULL, NULL, 193913),
(193914, '3.50.50.80-FF-000013', NULL, NULL, 61, NULL, NULL, 193914),
(193915, '1.20.20.10-FF-000024', NULL, 'ATP synthase F(0) complex subunit C1, mitochondrial', 39, NULL, NULL, 193915),
(193916, '3.30.160.60-FF-004439', NULL, NULL, 56, NULL, NULL, 193916),
(193917, '1.20.58.60-FF-000536', NULL, 'Spectrin repeat containing nuclear envelope family member 3', 130, NULL, NULL, 193917),
(193918, '3.40.710.10-FF-000148', NULL, 'Penicillin-binding protein', 194, NULL, NULL, 193918),
(193919, '1.10.287.130-FF-000181', NULL, 'HAMP domain-containing histidine kinase', 66, NULL, NULL, 193919),
(193920, '3.20.140.10-FF-000002', NULL, 'Nicotinate phosphoribosyltransferase', 160, NULL, NULL, 193920),
(193921, '3.30.70.940-FF-000001', NULL, 'Transcription termination/antitermination protein NusG', 116, NULL, NULL, 193921),
(193922, '3.40.50.2020-FF-000014', NULL, 'Ribose-phosphate pyrophosphokinase 1', 167, NULL, NULL, 193922);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(193923, '2.10.25.10-FF-001663', NULL, 'Crumbs 1, cell polarity complex component', 69, NULL, NULL, 193923),
(193924, '3.40.50.10140-FF-000066', NULL, 'Uncharacterized protein', 138, NULL, NULL, 193924),
(193925, '3.10.310.50-FF-000007', NULL, 'Uncharacterized protein', 139, NULL, NULL, 193925),
(193926, '1.25.40.20-FF-001030', NULL, 'Uncharacterized protein', 103, NULL, NULL, 193926),
(193927, '3.40.50.300-FF-000775', NULL, 'Iron(III) dicitrate ABC transporter, ATP-binding protein', 252, NULL, NULL, 193927),
(193928, '3.30.160.60-FF-001230', NULL, 'zinc finger protein WIP2-like', 24, NULL, NULL, 193928),
(193929, '1.20.1050.10-FF-000007', NULL, 'Glutathione S-transferase 1-1', 138, NULL, NULL, 193929),
(193930, '3.40.605.10-FF-000134', NULL, 'Predicted protein', 82, NULL, NULL, 193930),
(193931, '2.120.10.80-FF-000346', NULL, 'Uncharacterized protein', 92, NULL, NULL, 193931),
(193932, '3.90.1200.10-FF-000002', NULL, 'Ethanolamine kinase 1', 252, NULL, NULL, 193932),
(193933, '3.30.470.30-FF-000036', NULL, 'DNA ligase', 101, NULL, NULL, 193933),
(193934, '1.10.260.170-FF-000009', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', 133, NULL, NULL, 193934),
(193935, '3.30.470.10-FF-000030', NULL, 'Branched-chain-amino-acid aminotransferase', 169, NULL, NULL, 193935),
(193936, '3.40.1110.10-FF-000315', NULL, NULL, 121, NULL, NULL, 193936),
(193937, '3.10.310.30-FF-000001', NULL, 'Single-stranded-DNA-specific exonuclease recJ', 130, NULL, NULL, 193937),
(193938, '2.60.120.590-FF-000087', NULL, 'Uncharacterized protein', 289, NULL, NULL, 193938),
(193939, '2.40.50.140-FF-000702', NULL, NULL, 86, NULL, NULL, 193939),
(193940, '1.25.40.10-FF-000509', NULL, 'Pentatricopeptide repeat-containing protein At4g16390, chloroplastic', 145, NULL, NULL, 193940),
(193941, '3.30.200.20-FF-001413', NULL, NULL, 86, NULL, NULL, 193941),
(193942, '3.90.70.10-FF-000688', NULL, 'Uncharacterized protein', 234, NULL, NULL, 193942),
(193943, '3.40.47.10-FF-000007', NULL, 'acetyl-CoA acetyltransferase, mitochondrial', 396, NULL, NULL, 193943),
(193944, '4.10.60.10-FF-000048', NULL, 'CCHC-type zinc finger protein CG3800', 22, NULL, NULL, 193944),
(193945, '3.30.420.10-FF-000241', NULL, 'Ribonuclease H', 179, NULL, NULL, 193945),
(193946, '1.25.10.10-FF-001284', NULL, 'EXPOrtin (Nuclear export receptor)', 937, NULL, NULL, 193946),
(193947, '3.40.50.300-FF-008560', NULL, 'G-protein alpha subunit, putative', 189, NULL, NULL, 193947),
(193948, '3.30.200.20-FF-001885', NULL, 'Predicted protein', 21, NULL, NULL, 193948),
(193949, '1.10.10.10-FF-000844', NULL, 'MCM family protein', 84, NULL, NULL, 193949),
(193950, '3.30.160.60-FF-001027', NULL, 'Zinc finger protein 7', 28, NULL, NULL, 193950),
(193951, '3.40.50.620-FF-000522', NULL, 'tRNA synthetases class I-domain-containing protein', 163, NULL, NULL, 193951),
(193952, '3.30.450.20-FF-000616', NULL, 'Uncharacterized protein', 115, NULL, NULL, 193952),
(193953, '1.10.357.140-FF-000037', NULL, 'Protoheme IX farnesyltransferase 2', 153, NULL, NULL, 193953),
(193954, '3.60.40.10-FF-000210', NULL, 'Putative protein phosphatase 2C 63', 148, NULL, NULL, 193954),
(193955, '1.25.40.10-FF-000167', NULL, 'Mitochondrial fission 1 protein', 141, NULL, NULL, 193955),
(193956, '2.60.34.10-FF-000029', NULL, 'Ssz1p', 142, NULL, NULL, 193956),
(193957, '2.40.170.20-FF-000040', NULL, 'Transferrin-binding protein 1 Tbp1', 632, NULL, NULL, 193957),
(193958, '1.20.1250.20-FF-000891', NULL, 'MFS transporter', 181, NULL, NULL, 193958),
(193959, '2.60.120.260-FF-000207', NULL, 'SD03917p', 43, NULL, NULL, 193959),
(193960, '2.60.410.10-FF-000012', NULL, NULL, 91, NULL, NULL, 193960),
(193961, '3.50.50.60-FF-001440', NULL, 'Glycerol-3-phosphate dehydrogenase', 101, NULL, NULL, 193961),
(193962, '1.10.150.20-FF-000302', NULL, 'Uncharacterized protein', 74, NULL, NULL, 193962),
(193963, '2.30.30.380-FF-000031', NULL, 'Rhomboid-like protein 14 mitochondrial', 61, NULL, NULL, 193963),
(193964, '3.30.830.10-FF-000249', NULL, 'Mitochondrial processing peptidase alpha subunit', 195, NULL, NULL, 193964);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(193965, '1.20.1270.60-FF-000235', NULL, 'Uncharacterized protein', 223, NULL, NULL, 193965),
(193966, '3.40.50.2300-FF-000683', NULL, 'Receptor-type guanylate cyclase gcy-21', 167, NULL, NULL, 193966),
(193967, '2.30.30.140-FF-000083', NULL, 'Tudor domain containing 6', 71, NULL, NULL, 193967),
(193968, '1.10.486.10-FF-000005', NULL, 'ATP-dependent DNA helicase pcrA', 185, NULL, NULL, 193968),
(193969, '1.10.357.30-FF-000010', NULL, NULL, 216, NULL, NULL, 193969),
(193970, '2.60.40.10-FF-004012', NULL, NULL, 99, NULL, NULL, 193970),
(193971, '1.10.510.10-FF-001356', NULL, 'Protein kinase like protein', 262, NULL, NULL, 193971),
(193972, '1.20.1310.10-FF-000073', NULL, 'Anaphase-promoting complex subunit 2', 96, NULL, NULL, 193972),
(193973, '1.10.287.70-FF-000454', NULL, 'G protein-activated inward rectifier potassium channel 4', 135, NULL, NULL, 193973),
(193974, '1.25.10.10-FF-001761', NULL, 'Importin-11', 969, NULL, NULL, 193974),
(193975, '3.10.129.10-FF-000028', NULL, '(3R)-hydroxyacyl-ACP dehydratase subunit', 142, NULL, NULL, 193975),
(193976, '2.130.10.10-FF-004299', NULL, 'Anaphase-promoting complex subunit 4', 118, NULL, NULL, 193976),
(193977, '2.40.50.150-FF-000020', NULL, 'DNA-directed RNA polymerase subunit beta', 118, NULL, NULL, 193977),
(193978, '4.10.410.10-FF-000061', NULL, 'Uncharacterized protein, isoform C', 64, NULL, NULL, 193978),
(193979, '3.20.20.60-FF-000102', NULL, 'Uncharacterized protein', 84, NULL, NULL, 193979),
(193980, '2.60.120.290-FF-000115', NULL, 'LEV-10A protein', 144, NULL, NULL, 193980),
(193981, '1.25.40.20-FF-000041', NULL, 'ankyrin repeat and KH domain-containing protein 1 isoform X1', 145, NULL, NULL, 193981),
(193982, '2.40.30.130-FF-000044', NULL, 'Threonyl/alanyl tRNA synthetase SAD', 97, NULL, NULL, 193982),
(193983, '3.40.640.10-FF-000412', NULL, 'Alanine aminotransferase 2 mitochondrial', 100, NULL, NULL, 193983),
(193984, '1.20.58.1880-FF-000011', NULL, 'Putative MYB DNA-binding domain superfamily protein', 95, NULL, NULL, 193984),
(193985, '3.30.70.250-FF-000007', NULL, 'Malonyl CoA-acyl carrier protein transacylase', 72, NULL, NULL, 193985),
(193986, '1.20.5.520-FF-000004', NULL, 'Uncharacterized protein', 34, NULL, NULL, 193986),
(193987, '2.120.10.90-FF-000012', NULL, 'DNA gyrase subunit A', 315, NULL, NULL, 193987),
(193988, '3.40.50.300-FF-000882', NULL, 'Translation initiation regulator (Gcn20)', 295, NULL, NULL, 193988),
(193989, '3.40.50.2000-FF-000458', NULL, 'Putative polysaccharide biosynthesis protein', 137, NULL, NULL, 193989),
(193990, '1.20.1070.10-FF-002043', NULL, 'Uncharacterized protein', 110, NULL, NULL, 193990),
(193991, '1.10.510.10-FF-002901', NULL, NULL, 203, NULL, NULL, 193991),
(193992, '2.30.30.40-FF-000166', NULL, 'RIM-binding protein, isoform F', 60, NULL, NULL, 193992),
(193993, '1.25.40.10-FF-001128', NULL, 'HMG-CoA reductase degradation protein', 417, NULL, NULL, 193993),
(193994, '2.130.10.10-FF-004647', NULL, 'Uncharacterized protein', 341, NULL, NULL, 193994),
(193995, '2.130.10.10-FF-004794', NULL, 'Uncharacterized protein', 148, NULL, NULL, 193995),
(193996, '2.60.40.10-FF-001264', NULL, 'Receptor protein-tyrosine kinase', 105, NULL, NULL, 193996),
(193997, '2.10.109.10-FF-000008', NULL, 'Signal peptidase I', 137, NULL, NULL, 193997),
(193998, '2.130.10.10-FF-001921', NULL, 'Coronin', 347, NULL, NULL, 193998),
(193999, '3.10.110.10-FF-000019', NULL, 'Ubiquitin-conjugating enzyme E2 variant 1C', 143, NULL, NULL, 193999),
(194000, '2.60.120.1540-FF-000001', NULL, 'Complement C4-A', 64, NULL, NULL, 194000),
(194001, '3.40.570.10-FF-000041', NULL, 'Uncharacterized protein', 167, NULL, NULL, 194001),
(194002, '1.10.10.60-FF-000365', NULL, 'Homeobox protein ceh-14', 52, NULL, NULL, 194002),
(194003, '3.40.190.290-FF-000127', NULL, 'Rubisco operon transcriptional regulator', 204, NULL, NULL, 194003),
(194004, '1.25.10.10-FF-002464', NULL, 'Uncharacterized protein', 218, NULL, NULL, 194004),
(194005, '3.40.50.300-FF-005322', NULL, 'Shikimate kinase', 156, NULL, NULL, 194005),
(194006, '1.10.3720.10-FF-000073', NULL, 'Nickel ABC transporter permease', 205, NULL, NULL, 194006);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(194007, '2.60.40.10-FF-002197', NULL, 'T-cell antigen CD7', 122, NULL, NULL, 194007),
(194008, '3.40.47.10-FF-000187', NULL, NULL, 243, NULL, NULL, 194008),
(194009, '3.30.565.10-FF-000464', NULL, 'Putative MLH3, MutL protein 3', 193, NULL, NULL, 194009),
(194010, '3.30.505.10-FF-000123', NULL, 'Tyrosine-protein kinase', 107, NULL, NULL, 194010),
(194011, '3.90.190.10-FF-000034', NULL, 'Tyrosine-protein phosphatase non-receptor type 13', 315, NULL, NULL, 194011),
(194012, '3.40.50.300-FF-005137', NULL, 'Putative prophage LambdaBa04, terminase, large subunit', 240, NULL, NULL, 194012),
(194013, '3.40.50.300-FF-004698', NULL, 'Dynein beta chain, ciliary', 181, NULL, NULL, 194013),
(194014, '1.10.510.10-FF-000973', NULL, 'Serine/threonine kinase 16', 164, NULL, NULL, 194014),
(194015, '2.130.10.10-FF-000376', NULL, 'F-box and WD repeat domain containing 4', 141, NULL, NULL, 194015),
(194016, '2.70.170.10-FF-000154', NULL, 'Uncharacterized protein', 162, NULL, NULL, 194016),
(194017, '2.60.40.10-FF-003490', NULL, NULL, 94, NULL, NULL, 194017),
(194018, '1.10.510.10-FF-004099', NULL, NULL, 132, NULL, NULL, 194018),
(194019, '3.40.50.150-FF-000269', NULL, 'Methyltransferase-like protein 7A', 188, NULL, NULL, 194019),
(194020, '2.130.10.10-FF-005592', NULL, 'Predicted protein', 197, NULL, NULL, 194020),
(194021, '1.25.50.10-FF-000010', NULL, 'Aminopeptidase N', 326, NULL, NULL, 194021),
(194022, '3.20.20.140-FF-000326', NULL, 'Error-prone DNA polymerase 1', 256, NULL, NULL, 194022),
(194023, '3.30.160.60-FF-005844', NULL, NULL, 27, NULL, NULL, 194023),
(194024, '1.20.142.10-FF-000025', NULL, 'Poly [ADP-ribose] polymerase', 90, NULL, NULL, 194024),
(194025, '3.40.50.720-FF-001761', NULL, 'Uncharacterized protein', 181, NULL, NULL, 194025),
(194026, '3.30.200.20-FF-000581', NULL, 'Wall-associated receptor kinase 3', 101, NULL, NULL, 194026),
(194027, '3.30.70.2850-FF-000007', NULL, 'DNA-directed RNA polymerase I subunit 1', 212, NULL, NULL, 194027),
(194028, '3.40.390.10-FF-000050', NULL, 'Metalloendopeptidase', 265, NULL, NULL, 194028),
(194029, '3.30.540.10-FF-000058', NULL, 'Fructose-1,6-bisphosphatase/inositol-1-monophosphatase', 135, NULL, NULL, 194029),
(194030, '3.40.30.70-FF-000003', NULL, 'Probable GUS1-Glutamyl-tRNA synthetase', 78, NULL, NULL, 194030),
(194031, '3.40.50.10860-FF-000063', NULL, 'Shikimate 5-dehydrogenase', 96, NULL, NULL, 194031),
(194032, '3.40.50.1460-FF-000026', NULL, 'Caspase 2, apoptosis-related cysteine peptidase', 276, NULL, NULL, 194032),
(194033, '1.10.510.10-FF-000737', NULL, 'Protein kinase, putative', 206, NULL, NULL, 194033),
(194034, '3.90.190.10-FF-000181', NULL, 'Putative tyrosine phosphatase', 99, NULL, NULL, 194034),
(194035, '3.40.50.1440-FF-000020', NULL, 'protein misato homolog 1 isoform X2', 274, NULL, NULL, 194035),
(194036, '1.20.272.10-FF-000029', NULL, 'Replication factor C small subunit', 93, NULL, NULL, 194036),
(194037, '4.10.1000.10-FF-000145', NULL, 'Uncharacterized protein', 87, NULL, NULL, 194037),
(194038, '2.130.10.10-FF-004664', NULL, 'Uncharacterized protein', 186, NULL, NULL, 194038),
(194039, '1.25.10.10-FF-001845', NULL, 'Importin 4', 414, NULL, NULL, 194039),
(194040, '3.40.630.10-FF-000439', NULL, 'Nicastrin', 233, NULL, NULL, 194040),
(194041, '1.10.10.60-FF-000730', NULL, 'homeobox protein slou', 132, NULL, NULL, 194041),
(194042, '3.40.50.720-FF-000350', NULL, 'Enoyl-[acyl-carrier-protein] reductase [NADH]', 269, NULL, NULL, 194042),
(194043, '1.10.287.70-FF-000763', NULL, 'Uncharacterized protein', 25, NULL, NULL, 194043),
(194044, '1.10.238.10-FF-000475', NULL, 'Protein kinase, putative', 78, NULL, NULL, 194044),
(194045, '2.60.40.1180-FF-000005', NULL, 'Maltase-glucoamylase, intestinal', 137, NULL, NULL, 194045),
(194046, '1.10.510.10-FF-001721', NULL, 'Tyrosine-protein kinase', 153, NULL, NULL, 194046),
(194047, '1.20.5.190-FF-000079', NULL, 'Myosin VIIB', 53, NULL, NULL, 194047),
(194048, '2.60.40.10-FF-004670', NULL, NULL, 97, NULL, NULL, 194048),
(194049, '2.10.220.10-FF-000110', NULL, 'High cysteine membrane protein TMK-like', 104, NULL, NULL, 194049);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(194050, '3.40.1160.10-FF-000026', NULL, 'N-acetylglutamate synthase, mitochondrial', 283, NULL, NULL, 194050),
(194051, '1.20.1050.40-FF-000005', NULL, 'Metallopeptidase MepB', 139, NULL, NULL, 194051),
(194052, '3.30.70.3280-FF-000001', NULL, 'Peptide chain release factor 3', 140, NULL, NULL, 194052),
(194053, '1.10.8.270-FF-000055', NULL, 'TBC1 domain protein, putative', 133, NULL, NULL, 194053),
(194054, '1.25.40.10-FF-003601', NULL, 'Tetratricopeptide repeat-like superfamily protein', 132, NULL, NULL, 194054),
(194055, '3.30.200.20-FF-001992', NULL, 'Receptor protein serine/threonine kinase', 97, NULL, NULL, 194055),
(194056, '2.130.10.10-FF-000393', NULL, 'Phosphoinositide 3-kinase regulatory subunit 4', 251, NULL, NULL, 194056),
(194057, '3.75.10.10-FF-000006', NULL, 'Eukaryotic translation initiation factor 6', 225, NULL, NULL, 194057),
(194058, '2.130.10.10-FF-004428', NULL, 'Uncharacterized protein', 435, NULL, NULL, 194058),
(194059, '2.30.40.10-FF-000101', NULL, 'Adenine deaminase', 101, NULL, NULL, 194059),
(194060, '1.20.1050.130-FF-000040', NULL, 'Phenylalanyl-tRNA synthetase subunit beta', 81, NULL, NULL, 194060),
(194061, '2.40.500.10-FF-000001', NULL, NULL, 110, NULL, NULL, 194061),
(194062, '2.10.220.10-FF-000071', NULL, 'Gal/GalNAc lectin Igl2, putative', 70, NULL, NULL, 194062),
(194063, '1.10.10.60-FF-000382', NULL, 'Transcription activator snf2l1, putative', 108, NULL, NULL, 194063),
(194064, '3.30.160.60-FF-001819', NULL, 'zinc finger protein 407', 29, NULL, NULL, 194064),
(194065, '2.130.10.10-FF-004119', NULL, 'Coronin, actin-binding protein, 1A', 189, NULL, NULL, 194065),
(194066, '1.20.1250.70-FF-000001', NULL, 'Interleukin', 118, NULL, NULL, 194066),
(194067, '1.20.930.20-FF-000005', NULL, 'Mixed lineage kinase domain-like pseudokinase', 118, NULL, NULL, 194067),
(194068, '3.40.50.300-FF-004142', NULL, 'ATP-dependent Clp protease ATP-binding subunit ClpX', 68, NULL, NULL, 194068),
(194069, '3.40.50.700-FF-000007', NULL, NULL, 175, NULL, NULL, 194069),
(194070, '3.40.50.300-FF-000808', NULL, 'Small GTP-binding protein, putative', 192, NULL, NULL, 194070),
(194071, '2.130.10.10-FF-000741', NULL, 'Angio-associated migratory cell protein', 364, NULL, NULL, 194071),
(194072, '3.10.580.10-FF-000032', NULL, 'Chloride channel protein', 99, NULL, NULL, 194072),
(194073, '3.30.160.60-FF-006480', NULL, NULL, 36, NULL, NULL, 194073),
(194074, '1.25.10.10-FF-000339', NULL, 'Microtubule-associated protein TORTIFOLIA1', 123, NULL, NULL, 194074),
(194075, '1.10.510.10-FF-001226', NULL, 'NimA-related protein kinase 4', 200, NULL, NULL, 194075),
(194076, '3.30.420.360-FF-000002', NULL, 'Carbamoyltransferase', 100, NULL, NULL, 194076),
(194077, '3.30.70.340-FF-000006', NULL, 'GD14014', 89, NULL, NULL, 194077),
(194078, '3.90.650.10-FF-000076', NULL, 'Uncharacterized protein', 100, NULL, NULL, 194078),
(194079, '3.40.50.300-FF-004518', NULL, 'ATP-dependent DNA helicase', 200, NULL, NULL, 194079),
(194080, '1.10.510.10-FF-001592', NULL, 'Peripheral plasma membrane protein CASK', 50, NULL, NULL, 194080),
(194081, '2.60.40.10-FF-005316', NULL, NULL, 78, NULL, NULL, 194081),
(194082, '1.20.80.10-FF-000005', NULL, 'FERM, RhoGEF and pleckstrin domain-containing protein 1', 104, NULL, NULL, 194082),
(194083, '4.10.1240.10-FF-000016', NULL, 'Vasoactive intestinal peptide receptor 1', 79, NULL, NULL, 194083),
(194084, '2.60.40.1090-FF-000006', NULL, 'Fimbrial protein SthA', 160, NULL, NULL, 194084),
(194085, '3.40.430.10-FF-000003', NULL, 'Bifunctional dihydrofolate reductase-thymidylate synthase', 194, NULL, NULL, 194085),
(194086, '3.40.50.300-FF-000090', NULL, 'Elongation factor 1-alpha', 238, NULL, NULL, 194086),
(194087, '3.40.50.2000-FF-000328', NULL, 'Putative ADP-heptose--LPS heptosyltransferase II', 176, NULL, NULL, 194087),
(194088, '1.25.40.10-FF-002292', NULL, 'Uncharacterized protein', 275, NULL, NULL, 194088),
(194089, '1.10.1790.20-FF-000001', NULL, 'DNA-directed RNA polymerase subunit beta', 115, NULL, NULL, 194089),
(194090, '2.10.10.10-FF-000005', NULL, 'Epididymal sperm binding protein 1', 40, NULL, NULL, 194090);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(194091, '2.10.70.10-FF-000115', NULL, 'Zona pellucida sperm-binding protein 3 receptor', 67, NULL, NULL, 194091),
(194092, '2.30.29.30-FF-000519', NULL, 'Muscle M-line assembly protein unc-89-like Protein', 131, NULL, NULL, 194092),
(194093, '1.20.1250.20-FF-001756', NULL, 'Monocarboxylate transporter, putative', 192, NULL, NULL, 194093),
(194094, '2.10.109.10-FF-000048', NULL, 'Uncharacterized protein', 116, NULL, NULL, 194094),
(194095, '1.10.287.1490-FF-000089', NULL, 'TNFAIP3-interacting protein 2 isoform X1', 168, NULL, NULL, 194095),
(194096, '1.10.150.20-FF-000297', NULL, 'PolI-like DNA polymerase', 106, NULL, NULL, 194096),
(194097, '1.20.1560.10-FF-000872', NULL, 'Uncharacterized protein', 131, NULL, NULL, 194097),
(194098, '3.30.160.60-FF-004916', NULL, NULL, 87, NULL, NULL, 194098),
(194099, '2.60.120.200-FF-000476', NULL, 'Galectin', 143, NULL, NULL, 194099),
(194100, '1.10.8.1220-FF-000024', NULL, NULL, 92, NULL, NULL, 194100),
(194101, '2.60.120.10-FF-000125', NULL, 'Transcriptional activator ChrR', 94, NULL, NULL, 194101),
(194102, '3.30.565.10-FF-000380', NULL, 'Sensor histidine kinase', 167, NULL, NULL, 194102),
(194103, '1.10.287.470-FF-000035', NULL, 'Component of multidrug efflux system', 59, NULL, NULL, 194103),
(194104, '3.90.226.10-FF-000354', NULL, 'Uncharacterized protein', 220, NULL, NULL, 194104),
(194105, '3.90.1150.10-FF-000458', NULL, 'Serine palmitoyltransferase 1', 128, NULL, NULL, 194105),
(194106, '3.30.70.330-FF-000835', NULL, 'RNA binding protein, putative', 104, NULL, NULL, 194106),
(194107, '2.60.40.10-FF-000645', NULL, 'T-cell surface glycoprotein CD8 beta chain', 125, NULL, NULL, 194107),
(194108, '2.130.10.10-FF-005064', NULL, 'Uncharacterized protein', 420, NULL, NULL, 194108),
(194109, '3.30.750.24-FF-000065', NULL, 'Sulfate transporter', 109, NULL, NULL, 194109),
(194110, '3.30.300.30-FF-000041', NULL, 'Fatty-acid-CoA ligase FadD8', 114, NULL, NULL, 194110),
(194111, '3.80.10.10-FF-002809', NULL, 'Leucine-rich repeat protein lrrA', 92, NULL, NULL, 194111),
(194112, '3.80.10.10-FF-002034', NULL, 'Negative regulator of reactive oxygen species', 129, NULL, NULL, 194112),
(194113, '3.50.50.60-FF-000018', NULL, 'Sarcosine oxidase subunit beta', 198, NULL, NULL, 194113),
(194114, '3.40.50.2000-FF-000019', NULL, 'Glycosyltransferase', 187, NULL, NULL, 194114),
(194115, '2.60.120.200-FF-000785', NULL, 'Galectin', 119, NULL, NULL, 194115),
(194116, '3.20.20.70-FF-000431', NULL, 'Homocitrate synthase', 283, NULL, NULL, 194116),
(194117, '2.60.40.640-FF-000048', NULL, 'GL12550', 154, NULL, NULL, 194117),
(194118, '3.30.497.10-FF-000187', NULL, 'Uncharacterized protein', 90, NULL, NULL, 194118),
(194119, '2.30.29.240-FF-000015', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase beta-4', 53, NULL, NULL, 194119),
(194120, '1.10.150.240-FF-000124', NULL, 'Probable phosphoglycolate phosphatase, HAD superfamily', 65, NULL, NULL, 194120),
(194121, '3.40.50.1820-FF-000639', NULL, 'Acylaminoacyl-peptidase', 246, NULL, NULL, 194121),
(194122, '3.30.40.10-FF-001206', NULL, 'Protein CBG02635', 86, NULL, NULL, 194122),
(194123, '2.130.10.10-FF-002394', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One component system)', 305, NULL, NULL, 194123),
(194124, '2.40.10.10-FF-000318', NULL, 'IP20273p', 231, NULL, NULL, 194124),
(194125, '3.30.1360.10-FF-000049', NULL, 'Os02g0723600 protein', 30, NULL, NULL, 194125),
(194126, '1.25.40.10-FF-001673', NULL, 'Pentatricopeptide repeat-containing protein At4g14050, mitochondrial', 131, NULL, NULL, 194126),
(194127, '3.10.129.10-FF-000045', NULL, 'Hotdog fold thioesterase', 132, NULL, NULL, 194127),
(194128, '3.15.20.10-FF-000010', NULL, 'Protein TENP', 267, NULL, NULL, 194128),
(194129, '3.50.50.60-FF-000035', NULL, 'Methylenetetrahydrofolate--tRNA-(uracil-5-)-methyltransferase TrmFO', 146, NULL, NULL, 194129),
(194130, '2.70.50.30-FF-000016', NULL, NULL, 80, NULL, NULL, 194130),
(194131, '3.40.50.300-FF-003900', NULL, 'Branched-chain amino acid ABC transporter, ATP-binding protein', 240, NULL, NULL, 194131);
INSERT INTO "PUBLIC"."MODEL" VALUES
(194132, '2.30.180.10-FF-000040', NULL, 'Fasciclin-like AGP 6', 166, NULL, NULL, 194132),
(194133, '2.130.10.10-FF-001360', NULL, 'DDB1- and CUL4-associated factor 10', 193, NULL, NULL, 194133),
(194134, '2.70.150.10-FF-000271', NULL, 'Phospholipid-transporting ATPase', 166, NULL, NULL, 194134),
(194135, '3.30.300.20-FF-000049', NULL, 'Probable transcription termination protein NusA', 72, NULL, NULL, 194135),
(194136, '3.30.40.10-FF-001678', NULL, 'PDZ domain containing ring finger 4', 74, NULL, NULL, 194136),
(194137, '3.40.50.300-FF-004934', NULL, 'Uncharacterized protein', 278, NULL, NULL, 194137),
(194138, '1.25.40.10-FF-001145', NULL, 'Os07g0244400 protein', 89, NULL, NULL, 194138),
(194139, '3.20.20.140-FF-000080', NULL, 'Amidohydrolase', 174, NULL, NULL, 194139),
(194140, '3.40.50.300-FF-005446', NULL, 'ATP-dependent DEAD/H DNA helicase recQ, putative', 249, NULL, NULL, 194140),
(194141, '2.60.120.260-FF-000090', NULL, 'Probable allantoicase', 167, NULL, NULL, 194141),
(194142, '3.40.50.12160-FF-000003', NULL, 'CDK5 regulatory subunit-associated protein 1', 135, NULL, NULL, 194142),
(194143, '3.90.245.10-FF-000022', NULL, 'Inosine-uridine preferring nucleoside hydrolase', 291, NULL, NULL, 194143),
(194144, '1.10.1040.10-FF-000003', NULL, 'Ketol-acid reductoisomerase, mitochondrial', 64, NULL, NULL, 194144),
(194145, '3.30.565.10-FF-000155', NULL, 'Histidine kinase', 146, NULL, NULL, 194145),
(194146, '2.40.340.10-FF-000011', NULL, 'Molybdopterin molybdenumtransferase 2', 66, NULL, NULL, 194146),
(194147, '3.30.460.10-FF-000131', NULL, 'Uncharacterized protein', 115, NULL, NULL, 194147),
(194148, '3.20.20.80-FF-000799', NULL, 'Uncharacterized protein', 151, NULL, NULL, 194148),
(194149, '3.30.390.50-FF-000013', NULL, 'Lipoate--protein ligase', 87, NULL, NULL, 194149),
(194150, '1.10.287.1060-FF-000005', NULL, 'Phage terminase, small subunit', 78, NULL, NULL, 194150),
(194151, '2.60.120.10-FF-000041', NULL, 'HTH-type transcriptional activator RhaS', 80, NULL, NULL, 194151),
(194152, '1.10.400.10-FF-000055', NULL, 'Uncharacterized protein', 124, NULL, NULL, 194152),
(194153, '4.10.1000.10-FF-000061', NULL, 'Zinc finger CCCH domain-containing protein 3', 62, NULL, NULL, 194153),
(194154, '3.30.930.10-FF-000184', NULL, 'Polymerase (DNA directed), gamma 2, accessory subunit', 274, NULL, NULL, 194154),
(194155, '1.25.10.10-FF-001160', NULL, 'Catenin delta 2', 266, NULL, NULL, 194155),
(194156, '1.20.1070.10-FF-001661', NULL, 'Predicted protein', 126, NULL, NULL, 194156),
(194157, '3.90.660.10-FF-000138', NULL, NULL, 183, NULL, NULL, 194157),
(194158, '2.130.10.10-FF-005047', NULL, 'Uncharacterized protein', 284, NULL, NULL, 194158),
(194159, '2.60.40.60-FF-000834', NULL, 'Uncharacterized protein', 35, NULL, NULL, 194159),
(194160, '2.30.170.40-FF-000008', NULL, '50S ribosomal protein L28', 78, NULL, NULL, 194160),
(194161, '3.40.50.300-FF-008195', NULL, 'Uncharacterized protein', 76, NULL, NULL, 194161),
(194162, '1.20.140.10-FF-000111', NULL, 'Short-chain-specific acyl-CoA dehydrogenase, mitochondrial', 48, NULL, NULL, 194162),
(194163, '1.10.10.60-FF-000926', NULL, NULL, 81, NULL, NULL, 194163),
(194164, '3.30.780.10-FF-000059', NULL, 'Uncharacterized protein', 109, NULL, NULL, 194164),
(194165, '2.10.25.10-FF-000483', NULL, 'Tissue-type plasminogen activator', 43, NULL, NULL, 194165),
(194166, '1.20.120.350-FF-000025', NULL, 'Potassium voltage-gated channel subfamily A member 2', 183, NULL, NULL, 194166),
(194167, '1.10.357.10-FF-000015', NULL, 'TetR family transcriptional regulator', 131, NULL, NULL, 194167),
(194168, '2.40.50.150-FF-000003', NULL, 'DNA-directed RNA polymerase subunit beta', 138, NULL, NULL, 194168),
(194169, '1.25.40.10-FF-004798', NULL, 'Uncharacterized protein', 171, NULL, NULL, 194169),
(194170, '3.40.50.2000-FF-000244', NULL, 'UDP-N-acetylglucosamine transferase subunit ALG13', 182, NULL, NULL, 194170),
(194171, '3.30.200.20-FF-002138', NULL, 'Uncharacterized protein', 71, NULL, NULL, 194171),
(194172, '4.10.900.10-FF-000020', NULL, 'Uncharacterized protein', 93, NULL, NULL, 194172);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(194173, '3.60.140.10-FF-000021', NULL, 'Uncharacterized protein', 206, NULL, NULL, 194173),
(194174, '3.30.70.330-FF-001077', NULL, 'G3BP stress granule assembly factor 1', 121, NULL, NULL, 194174),
(194175, '2.40.50.140-FF-000377', NULL, 'Replication protein A subunit', 114, NULL, NULL, 194175),
(194176, '3.30.43.10-FF-000050', NULL, 'Uncharacterized protein', 90, NULL, NULL, 194176),
(194177, '1.20.910.10-FF-000001', NULL, 'Heme oxygenase 1', 230, NULL, NULL, 194177),
(194178, '3.40.50.1000-FF-000837', NULL, NULL, 77, NULL, NULL, 194178),
(194179, '1.25.40.20-FF-000529', NULL, 'Cyclin dependent kinase inhibitor Pho81, putative', 310, NULL, NULL, 194179),
(194180, '1.20.1050.10-FF-000226', NULL, 'Glutathione S-transferase, mitochondrial', 101, NULL, NULL, 194180),
(194181, '2.10.110.10-FF-000225', NULL, 'LIM domain-containing protein F', 70, NULL, NULL, 194181),
(194182, '1.20.950.20-FF-000018', NULL, 'Ni/Fe-hydrogenase, b-type cytochrome subunit', 200, NULL, NULL, 194182),
(194183, '1.10.287.370-FF-000027', NULL, 'Prefoldin subunit alpha 1', 141, NULL, NULL, 194183),
(194184, '3.30.1370.210-FF-000016', NULL, 'Putative muscleblind-like protein', 94, NULL, NULL, 194184),
(194185, '2.40.30.10-FF-000426', NULL, 'AGAP006250-PA', 120, NULL, NULL, 194185),
(194186, '2.60.40.420-FF-000218', NULL, 'Laccase family multicopper oxidase', 224, NULL, NULL, 194186),
(194187, '4.10.400.10-FF-000015', NULL, 'Low-density lipoprotein receptor-related protein 1', 46, NULL, NULL, 194187),
(194188, '1.10.533.10-FF-000228', NULL, 'Predicted protein', 87, NULL, NULL, 194188),
(194189, '3.40.50.300-FF-005553', NULL, 'TFIIH basal transcription factor complex helicase subunit', 264, NULL, NULL, 194189),
(194190, '1.20.1070.10-FF-001329', NULL, 'Olfactory receptor', 223, NULL, NULL, 194190),
(194191, '3.40.50.2300-FF-000227', NULL, 'Uncharacterized protein', 304, NULL, NULL, 194191),
(194192, '1.10.10.790-FF-000001', NULL, 'Splicing factor 3a, subunit 1', 59, NULL, NULL, 194192),
(194193, '2.30.30.40-FF-000582', NULL, 'Uncharacterized protein', 18, NULL, NULL, 194193),
(194194, '3.40.190.10-FF-000630', NULL, 'LysR family transcriptional regulator', 95, NULL, NULL, 194194),
(194195, '3.30.70.330-FF-000043', NULL, 'paraspeckle component 1 isoform X1', 88, NULL, NULL, 194195),
(194196, '3.40.50.2300-FF-001071', NULL, NULL, 173, NULL, NULL, 194196),
(194197, '1.20.1080.10-FF-000054', NULL, 'Uncharacterized protein', 258, NULL, NULL, 194197),
(194198, '2.40.70.10-FF-000390', NULL, NULL, 185, NULL, NULL, 194198),
(194199, '1.10.10.160-FF-000065', NULL, 'DNA helicase', 63, NULL, NULL, 194199),
(194200, '2.40.50.90-FF-000142', NULL, 'Transcription factor, putative', 175, NULL, NULL, 194200),
(194201, '4.10.280.10-FF-000027', NULL, 'Nescient helix-loop-helix 1', 70, NULL, NULL, 194201),
(194202, '3.80.10.10-FF-002580', NULL, 'Protein TORNADO 1', 110, NULL, NULL, 194202),
(194203, '2.30.30.100-FF-000211', NULL, 'Small nuclear ribonucleoprotein E', 86, NULL, NULL, 194203),
(194204, '3.30.2400.10-FF-000003', NULL, 'Phage capsid protein', 135, NULL, NULL, 194204),
(194205, '1.20.5.110-FF-000235', NULL, 'YALI0E17875p', 64, NULL, NULL, 194205),
(194206, '3.30.70.1440-FF-000011', NULL, 'Probable Resistance-Nodulation-Cell Division (RND) efflux transporter', 105, NULL, NULL, 194206),
(194207, '1.10.287.770-FF-000012', NULL, 'Pickpocket 10', 45, NULL, NULL, 194207),
(194208, '1.10.10.1970-FF-000001', NULL, 'Telomerase reverse transcriptase', 56, NULL, NULL, 194208),
(194209, '1.25.10.10-FF-001317', NULL, 'Uncharacterized protein', 315, NULL, NULL, 194209),
(194210, '2.160.10.30-FF-000004', NULL, 'UDP-sugar pyrophosphorylase', 138, NULL, NULL, 194210),
(194211, '3.80.10.10-FF-002473', NULL, 'NLR family CARD domain-containing 9', 121, NULL, NULL, 194211),
(194212, '1.10.10.750-FF-000040', NULL, 'Ecotropic viral integration site 5-like protein', 45, NULL, NULL, 194212),
(194213, '3.75.10.10-FF-000023', NULL, NULL, 219, NULL, NULL, 194213),
(194214, '1.10.1040.30-FF-000009', NULL, 'YALI0D05775p', 113, NULL, NULL, 194214),
(194215, '2.30.30.140-FF-000066', NULL, 'A-kinase anchor protein 1, mitochondrial', 72, NULL, NULL, 194215);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(194216, '2.40.128.20-FF-000026', NULL, 'Apolipoprotein D-like Protein', 170, NULL, NULL, 194216),
(194217, '4.10.410.10-FF-000044', NULL, 'Protein CBR-MLT-11', 63, NULL, NULL, 194217),
(194218, '1.20.1250.20-FF-001537', NULL, 'Uncharacterized protein', 431, NULL, NULL, 194218),
(194219, '3.80.10.10-FF-000325', NULL, 'Si:dkey-16p6.1', 113, NULL, NULL, 194219),
(194220, '1.10.510.10-FF-001917', NULL, 'Uncharacterized protein', 149, NULL, NULL, 194220),
(194221, '3.30.450.20-FF-000307', NULL, 'Sporulation-specific ATP-dependent proteinhistidine kinase', 114, NULL, NULL, 194221),
(194222, '1.25.40.10-FF-003707', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 111, NULL, NULL, 194222),
(194223, '1.20.1050.130-FF-000023', NULL, 'Glutamyl-prolyl-tRNA synthetase', 173, NULL, NULL, 194223),
(194224, '2.60.40.420-FF-000061', NULL, 'Laccase TilA', 178, NULL, NULL, 194224),
(194225, '2.60.40.60-FF-001132', NULL, 'Predicted protein', 94, NULL, NULL, 194225),
(194226, '1.20.1250.20-FF-000447', NULL, 'MFS multidrug transporter, putative', 202, NULL, NULL, 194226),
(194227, '1.20.58.1700-FF-000002', NULL, 'Allophanate hydrolase', 74, NULL, NULL, 194227),
(194228, '3.40.50.150-FF-001202', NULL, NULL, 84, NULL, NULL, 194228),
(194229, '3.20.20.80-FF-000113', NULL, 'Glucan 1,3-beta-glucosidase', 360, NULL, NULL, 194229),
(194230, '1.20.1730.10-FF-000048', NULL, 'Urea transporter, putative', 469, NULL, NULL, 194230),
(194231, '1.20.58.160-FF-000008', NULL, 'GM11378', 98, NULL, NULL, 194231),
(194232, '1.25.10.10-FF-002941', NULL, 'AP-3 complex subunit delta', 81, NULL, NULL, 194232),
(194233, '1.25.40.10-FF-002437', NULL, 'Os02g0670700 protein', 111, NULL, NULL, 194233),
(194234, '1.10.630.10-FF-000555', NULL, 'Cytochrome P450 family 51 subfamily A member 1', 336, NULL, NULL, 194234),
(194235, '2.60.120.970-FF-000004', NULL, 'Bone morphogenetic protein 5 preproprotein', 249, NULL, NULL, 194235),
(194236, '3.40.50.300-FF-001427', NULL, 'ATP-dependent RNA helicase DEAH13', 163, NULL, NULL, 194236),
(194237, '1.10.418.10-FF-000258', NULL, 'Uncharacterized protein', 73, NULL, NULL, 194237),
(194238, '3.80.10.10-FF-001629', NULL, 'Uncharacterized protein', 92, NULL, NULL, 194238),
(194239, '1.20.1560.10-FF-000001', NULL, 'ATP-binding cassette subfamily C member 1', 336, NULL, NULL, 194239),
(194240, '3.90.930.1-FF-000001', NULL, 'Outer surface protein A', 146, NULL, NULL, 194240),
(194241, '3.40.50.150-FF-000584', NULL, 'Methyltransferase', 244, NULL, NULL, 194241),
(194242, '1.20.80.10-FF-000022', NULL, 'acyl-CoA-binding domain-containing protein 6 isoform X1', 107, NULL, NULL, 194242),
(194243, '2.80.10.50-FF-000042', NULL, 'Fibroblast growth factor', 156, NULL, NULL, 194243),
(194244, '3.30.1480.10-FF-000013', NULL, 'Transcription termination/antitermination protein NusA', 95, NULL, NULL, 194244),
(194245, '1.25.40.420-FF-000055', NULL, 'MigA', 114, NULL, NULL, 194245),
(194246, '3.80.10.10-FF-002725', NULL, 'MDIS1-interacting receptor like kinase 2', 343, NULL, NULL, 194246),
(194247, '3.10.100.10-FF-000069', NULL, 'C-type lectin domain family 7 member A', 139, NULL, NULL, 194247),
(194248, '1.50.40.10-FF-000120', NULL, 'Uncharacterized protein, isoform A', 293, NULL, NULL, 194248),
(194249, '3.20.20.540-FF-000002', NULL, 'Phosphomethylpyrimidine synthase', 320, NULL, NULL, 194249),
(194250, '1.25.40.10-FF-000959', NULL, 'Pentatricopeptide repeat-containing protein', 66, NULL, NULL, 194250),
(194251, '1.10.246.130-FF-000020', NULL, NULL, 96, NULL, NULL, 194251),
(194252, '2.60.120.290-FF-000194', NULL, 'AGAP005526-PA', 126, NULL, NULL, 194252),
(194253, '3.30.980.10-FF-000024', NULL, 'Alanyl-tRNA synthetase family protein', 142, NULL, NULL, 194253),
(194254, '2.20.25.10-FF-000033', NULL, 'Transcription factor, putative', 54, NULL, NULL, 194254),
(194255, '1.20.920.10-FF-000030', NULL, 'transcription intermediary factor 1-beta', 114, NULL, NULL, 194255),
(194256, '1.20.5.190-FF-000096', NULL, NULL, 50, NULL, NULL, 194256),
(194257, '1.25.40.470-FF-000064', NULL, 'Coatomer subunit beta''-3', 138, NULL, NULL, 194257);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(194258, '1.20.140.150-FF-000087', NULL, 'germ cell-specific gene 1 protein isoform X1', 242, NULL, NULL, 194258),
(194259, '3.30.750.24-FF-000082', NULL, 'Anti-sigma factor antagonist', 115, NULL, NULL, 194259),
(194260, '2.10.25.10-FF-000590', NULL, 'von Willebrand factor D and EGF domains', 29, NULL, NULL, 194260),
(194261, '2.60.40.10-FF-005760', NULL, NULL, 73, NULL, NULL, 194261),
(194262, '3.90.550.10-FF-000697', NULL, 'O-glycoside alpha-1,2-mannosyltransferase homolog 6', 297, NULL, NULL, 194262),
(194263, '4.10.400.10-FF-000324', NULL, 'Uncharacterized protein', 40, NULL, NULL, 194263),
(194264, '2.40.50.1020-FF-000013', NULL, 'Transcriptional regulator protein', 105, NULL, NULL, 194264),
(194265, '1.20.5.500-FF-000009', NULL, 'Intermediate filament protein ifc-2', 71, NULL, NULL, 194265),
(194266, '2.60.40.2860-FF-000003', NULL, '6-cysteine protein', 140, NULL, NULL, 194266),
(194267, '3.30.9.10-FF-000100', NULL, 'FAD-dependent oxidoreductase', 160, NULL, NULL, 194267),
(194268, '4.10.240.10-FF-000137', NULL, 'Fungus-specific transcription factor, putative', 45, NULL, NULL, 194268),
(194269, '3.40.50.10810-FF-000273', NULL, 'Uncharacterized protein', 84, NULL, NULL, 194269),
(194270, '3.30.70.1590-FF-000005', NULL, 'unconventional myosin-Vc', 67, NULL, NULL, 194270),
(194271, '2.130.10.10-FF-001090', NULL, 'Unplaced genomic scaffold supercont2.7, whole genome shotgun sequence', 394, NULL, NULL, 194271),
(194272, '3.30.420.10-FF-000010', NULL, 'DNA polymerase epsilon catalytic subunit', 228, NULL, NULL, 194272),
(194273, '3.30.420.340-FF-000007', NULL, 'UvrABC system protein C', 169, NULL, NULL, 194273),
(194274, '3.10.20.90-FF-000089', NULL, 'Fas associated factor 1', 67, NULL, NULL, 194274),
(194275, '1.25.40.10-FF-005040', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 128, NULL, NULL, 194275),
(194276, '2.20.100.10-FF-000094', NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif, 18', 56, NULL, NULL, 194276),
(194277, '3.30.70.370-FF-000004', NULL, 'DNA polymerase gamma, mitochondrial', 76, NULL, NULL, 194277),
(194278, '3.40.50.300-FF-001955', NULL, 'ATP-dependent RNA helicase DBP4, putative', 275, NULL, NULL, 194278),
(194279, '1.10.472.110-FF-000001', NULL, 'Hypothetical_protein_-_conserved', 131, NULL, NULL, 194279),
(194280, '3.40.50.2300-FF-001380', NULL, NULL, 187, NULL, NULL, 194280),
(194281, '3.40.50.12780-FF-000189', NULL, 'Uncharacterized protein', 142, NULL, NULL, 194281),
(194282, '1.20.920.30-FF-000036', NULL, 'AGAP011441-PA', 216, NULL, NULL, 194282),
(194283, '3.10.129.10-FF-000259', NULL, 'Acyl-acyl carrier protein thioesterase ATL3 chloroplastic', 90, NULL, NULL, 194283),
(194284, '2.70.98.10-FF-000036', NULL, 'Glucose-6-phosphate 1-epimerase', 263, NULL, NULL, 194284),
(194285, '3.40.1010.10-FF-000004', NULL, 'Putative diphthine synthase', 112, NULL, NULL, 194285),
(194286, '3.90.228.10-FF-000044', NULL, 'Poly [ADP-ribose] polymerase', 207, NULL, NULL, 194286),
(194287, '3.30.70.330-FF-000352', NULL, 'Putative serine/arginine-rich splicing factor 3', 113, NULL, NULL, 194287),
(194288, '3.30.70.3270-FF-000009', NULL, 'NADH-quinone oxidoreductase subunit I', 119, NULL, NULL, 194288),
(194289, '3.40.50.1820-FF-001258', NULL, 'Uncharacterized protein', 311, NULL, NULL, 194289),
(194290, '3.40.50.300-FF-001394', NULL, 'ABC transporter ATP-binding protein', 220, NULL, NULL, 194290),
(194291, '1.10.510.10-FF-002070', NULL, 'SH3 domain binding kinase family member 2', 199, NULL, NULL, 194291),
(194292, '2.130.10.10-FF-000937', NULL, 'Cft1p', 335, NULL, NULL, 194292),
(194293, '3.20.20.70-FF-000015', NULL, 'Orotidine 5''-phosphate decarboxylase', 235, NULL, NULL, 194293),
(194294, '2.10.25.10-FF-000224', NULL, 'Usherin', 51, NULL, NULL, 194294),
(194295, '2.40.70.10-FF-000058', NULL, 'ASpartyl Protease', 157, NULL, NULL, 194295),
(194296, '3.30.160.60-FF-000729', NULL, 'Zinc finger protein 646', 30, NULL, NULL, 194296),
(194297, '1.25.40.20-FF-001457', NULL, 'Ankyrin repeat domain 2 (stretch-responsive muscle)', 124, NULL, NULL, 194297);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(194298, '1.20.1720.10-FF-000082', NULL, NULL, 242, NULL, NULL, 194298),
(194299, '1.20.930.10-FF-000014', NULL, 'Transcription factor SPN1', 108, NULL, NULL, 194299),
(194300, '3.30.70.890-FF-000042', NULL, 'Mevalonate kinase', 133, NULL, NULL, 194300),
(194301, '2.130.10.10-FF-001101', NULL, 'Blast:U4/U6 small nuclear ribonucleoprotein Prp4', 85, NULL, NULL, 194301),
(194302, '3.40.50.300-FF-001500', NULL, 'Dynein-related AAA-type ATPase', 171, NULL, NULL, 194302),
(194303, '1.10.20.140-FF-000016', NULL, 'tRNA isopentenyl transferase', 84, NULL, NULL, 194303),
(194304, '2.40.50.140-FF-001091', NULL, NULL, 68, NULL, NULL, 194304),
(194305, '3.40.47.10-FF-000114', NULL, 'Uncharacterized protein', 173, NULL, NULL, 194305),
(194306, '1.20.1250.20-FF-002049', NULL, 'Organic anion transporter, putative', 311, NULL, NULL, 194306),
(194307, '1.10.20.120-FF-000010', NULL, 'Predicted protein', 110, NULL, NULL, 194307),
(194308, '3.40.190.10-FF-000287', NULL, 'LysR family transcriptional regulator', 71, NULL, NULL, 194308),
(194309, '1.25.10.10-FF-001053', NULL, 'Microtubule associated protein, putative', 226, NULL, NULL, 194309),
(194310, '3.90.550.10-FF-000708', NULL, 'Glycosyl transferase', 275, NULL, NULL, 194310),
(194311, '1.10.3970.10-FF-000001', NULL, 'synapse-associated protein 1 isoform X1', 98, NULL, NULL, 194311),
(194312, '2.60.120.1190-FF-000008', NULL, 'Discoidin domain-containing receptor A', 173, NULL, NULL, 194312),
(194313, '1.20.5.1160-FF-000025', NULL, 'CAP-Gly domain-containing linker protein 1', 123, NULL, NULL, 194313),
(194314, '1.10.630.10-FF-000100', NULL, 'Cytochrome P450 71A26', 480, NULL, NULL, 194314),
(194315, '1.10.10.10-FF-001901', NULL, 'Mitomycin biosynthesis 6-O-methyltransferase', 89, NULL, NULL, 194315),
(194316, '2.20.100.10-FF-000127', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs adt-2', 53, NULL, NULL, 194316),
(194317, '1.20.1510.10-FF-000054', NULL, 'Uncharacterized protein, isoform A', 219, NULL, NULL, 194317),
(194318, '3.80.10.10-FF-004378', NULL, 'Disease resistance RPP13-like protein 4', 170, NULL, NULL, 194318),
(194319, '1.10.1200.270-FF-000014', NULL, 'Uncharacterized protein', 61, NULL, NULL, 194319),
(194320, '3.30.1510.10-FF-000011', NULL, '6,7,8-tetrahydrofolate synthase', 98, NULL, NULL, 194320),
(194321, '3.30.160.100-FF-000022', NULL, 'Ribosome hibernation promoting factor', 133, NULL, NULL, 194321),
(194322, '3.10.580.10-FF-000138', NULL, 'Chloride channel protein', 80, NULL, NULL, 194322),
(194323, '3.80.10.10-FF-001652', NULL, 'Probable LRR receptor-like serine/threonine-protein kinase RPK1', 143, NULL, NULL, 194323),
(194324, '1.10.8.10-FF-000208', NULL, 'AT15685p', 43, NULL, NULL, 194324),
(194325, '2.60.120.10-FF-000260', NULL, 'Homogentisate 1,2-dioxygenase', 101, NULL, NULL, 194325),
(194326, '1.10.246.60-FF-000008', NULL, 'Eukaryotic translation initiation factor 3 subunit 1 putative', 81, NULL, NULL, 194326),
(194327, '1.25.40.10-FF-002893', NULL, 'NRDE-2, necessary for RNA interference, domain-containing', 214, NULL, NULL, 194327),
(194328, '3.40.50.300-FF-004625', NULL, 'Uncharacterized protein', 176, NULL, NULL, 194328),
(194329, '3.10.50.10-FF-000056', NULL, 'Uncharacterized protein', 96, NULL, NULL, 194329),
(194330, '3.30.720.50-FF-000011', NULL, 'E3 ubiquitin protein ligase URE-B1 variant', 79, NULL, NULL, 194330),
(194331, '1.10.3460.10-FF-000007', NULL, 'Chlorophyll a-b binding protein, chloroplastic', 212, NULL, NULL, 194331),
(194332, '2.40.10.10-FF-000627', NULL, NULL, 238, NULL, NULL, 194332),
(194333, '4.10.1240.30-FF-000011', NULL, NULL, 81, NULL, NULL, 194333),
(194334, '3.40.50.2300-FF-001048', NULL, NULL, 144, NULL, NULL, 194334),
(194335, '1.10.238.10-FF-000492', NULL, 'EF-hand calcium binding domain 6', 75, NULL, NULL, 194335),
(194336, '3.90.226.10-FF-000219', NULL, 'Predicted protein', 102, NULL, NULL, 194336),
(194337, '2.120.10.80-FF-000239', NULL, 'Uncharacterized protein', 157, NULL, NULL, 194337),
(194338, '1.20.58.390-FF-000167', NULL, 'Nicotinic acetylcholine receptor subunit', 116, NULL, NULL, 194338); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(194339, '2.60.40.10-FF-003826', NULL, NULL, 88, NULL, NULL, 194339),
(194340, '3.90.1100.10-FF-000039', NULL, 'DNA-directed RNA polymerase subunit beta', 102, NULL, NULL, 194340),
(194341, '3.30.70.1400-FF-000005', NULL, 'Dimethylglycine dehydrogenase, mitochondrial', 112, NULL, NULL, 194341),
(194342, '3.65.10.20-FF-000004', NULL, 'Predicted protein', 213, NULL, NULL, 194342),
(194343, '2.10.70.10-FF-000222', NULL, 'Uncharacterized protein', 64, NULL, NULL, 194343),
(194344, '3.20.20.80-FF-000327', NULL, 'Arabinogalactan endo-beta-1,4-galactanase', 396, NULL, NULL, 194344),
(194345, '3.40.50.80-FF-000114', NULL, 'Iron utilization protein', 129, NULL, NULL, 194345),
(194346, '3.90.1150.10-FF-000227', NULL, 'PLP-dependent aminotransferase family protein', 138, NULL, NULL, 194346),
(194347, '1.20.120.720-FF-000046', NULL, 'Chitin synthase', 111, NULL, NULL, 194347),
(194348, '3.80.10.10-FF-001961', NULL, 'Probable inactive receptor kinase At5g10020', 366, NULL, NULL, 194348),
(194349, '3.30.160.60-FF-001713', NULL, 'Zinc finger protein 619', 33, NULL, NULL, 194349),
(194350, '1.20.1560.10-FF-000456', NULL, 'Cullin-associated NEDD8-dissociated protein 1', 148, NULL, NULL, 194350),
(194351, '3.20.20.10-FF-000003', NULL, 'Diaminopimelate decarboxylase', 250, NULL, NULL, 194351),
(194352, '2.130.10.30-FF-000146', NULL, NULL, 214, NULL, NULL, 194352),
(194353, '1.20.58.110-FF-000004', NULL, '30S ribosomal protein S20', 86, NULL, NULL, 194353),
(194354, '2.40.50.100-FF-000157', NULL, 'Predicted protein', 45, NULL, NULL, 194354),
(194355, '2.30.29.30-FF-000199', NULL, 'Arf-GAP with GTPase, ANK repeat and PH domain-containing protein 3', 113, NULL, NULL, 194355),
(194356, '3.40.930.10-FF-000024', NULL, 'Anion exchange protein', 154, NULL, NULL, 194356),
(194357, '3.30.420.40-FF-001042', NULL, 'Heat shock protein 4b', 18, NULL, NULL, 194357),
(194358, '3.80.10.10-FF-000691', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 162, NULL, NULL, 194358),
(194359, '3.40.50.10190-FF-000272', NULL, 'Putative dna topoisomerase 2-binding protein 1 isoform x1', 97, NULL, NULL, 194359),
(194360, '1.25.40.10-FF-000745', NULL, 'RNA polymerase II transcription elongation factor (Ctr9)', 314, NULL, NULL, 194360),
(194361, '2.130.10.10-FF-001466', NULL, 'WD repeat protein', 194, NULL, NULL, 194361),
(194362, '1.10.287.70-FF-000319', NULL, 'Predicted protein', 119, NULL, NULL, 194362),
(194363, '3.40.50.1980-FF-000064', NULL, 'Hemin ABC transporter, periplasmic hemin-binding protein HutB', 140, NULL, NULL, 194363),
(194364, '1.10.472.10-FF-000659', NULL, 'PHO85 cyclin-like protein psl1', 218, NULL, NULL, 194364),
(194365, '3.40.50.20-FF-000012', NULL, 'Carbamoyl-phosphate synthase 1, mitochondrial', 119, NULL, NULL, 194365),
(194366, '3.40.50.800-FF-000054', NULL, 'Probable proline--tRNA ligase, mitochondrial', 113, NULL, NULL, 194366),
(194367, '2.130.10.10-FF-000140', NULL, 'SMU1, DNA replication regulator and spliceosomal factor', 323, NULL, NULL, 194367),
(194368, '3.40.50.1820-FF-000533', NULL, 'Carboxypeptidase', 454, NULL, NULL, 194368),
(194369, '2.60.120.260-FF-000196', NULL, 'Alpha-L-fucosidase', 121, NULL, NULL, 194369),
(194370, '1.10.10.10-FF-001356', NULL, 'Double-stranded RNA-specific adenosine deaminase', 74, NULL, NULL, 194370),
(194371, '3.80.10.10-FF-000016', NULL, 'Leucine-rich repeat and fibronectin type III domain-containing protein 1', 136, NULL, NULL, 194371),
(194372, '1.10.287.920-FF-000001', NULL, 'Pheromone alpha factor receptor', 80, NULL, NULL, 194372),
(194373, '1.25.10.10-FF-002609', NULL, 'Protein MOR1', 139, NULL, NULL, 194373),
(194374, '3.30.40.10-FF-001914', NULL, 'Os03g0380100 protein', 72, NULL, NULL, 194374),
(194375, '1.20.1070.10-FF-001638', NULL, 'Predicted protein', 138, NULL, NULL, 194375),
(194376, '2.60.120.200-FF-000240', NULL, 'MAM and LDL receptor class A domain containing 1', 163, NULL, NULL, 194376),
(194377, '3.40.50.300-FF-000011', NULL, 'Putative ABC transporter ATP-binding component', 278, NULL, NULL, 194377),
(194378, '3.30.710.10-FF-000330', NULL, 'Rho-related BTB domain-containing protein 1', 127, NULL, NULL, 194378);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(194379, '3.40.120.10-FF-000120', NULL, 'Uncharacterized protein', 86, NULL, NULL, 194379),
(194380, '3.30.70.330-FF-001785', NULL, NULL, 104, NULL, NULL, 194380),
(194381, '1.25.40.10-FF-005310', NULL, 'Predicted protein', 125, NULL, NULL, 194381),
(194382, '3.30.110.20-FF-000001', NULL, 'Stage V sporulation protein S', 86, NULL, NULL, 194382),
(194383, '1.10.238.200-FF-000012', NULL, 'Defective in cullin neddylation protein', 102, NULL, NULL, 194383),
(194384, '3.40.50.1000-FF-000731', NULL, NULL, 74, NULL, NULL, 194384),
(194385, '1.10.287.940-FF-000007', NULL, 'p2X purinoceptor 4', 28, NULL, NULL, 194385),
(194386, '1.10.510.10-FF-002446', NULL, NULL, 97, NULL, NULL, 194386),
(194387, '3.40.50.300-FF-003664', NULL, 'Genome polyprotein', 136, NULL, NULL, 194387),
(194388, '1.25.10.10-FF-002380', NULL, 'Uncharacterized protein C1071.03c', 270, NULL, NULL, 194388),
(194389, '3.30.70.330-FF-002061', NULL, NULL, 90, NULL, NULL, 194389),
(194390, '1.20.58.60-FF-000272', NULL, 'Spectrin alpha chain, erythrocytic 1', 238, NULL, NULL, 194390),
(194391, '1.10.510.10-FF-003065', NULL, NULL, 205, NULL, NULL, 194391),
(194392, '2.60.40.150-FF-000789', NULL, 'Uncharacterized protein', 83, NULL, NULL, 194392),
(194393, '3.40.250.10-FF-000124', NULL, 'Thiosulfate sulfurtransferase GlpE', 109, NULL, NULL, 194393),
(194394, '1.50.10.20-FF-000149', NULL, 'Uncharacterized protein', 162, NULL, NULL, 194394),
(194395, '2.60.40.1400-FF-000009', NULL, 'Inward rectifier potassium channel Kirbac3.1', 175, NULL, NULL, 194395),
(194396, '1.20.1070.10-FF-001970', NULL, 'Dopamine D2-like receptor', 180, NULL, NULL, 194396),
(194397, '3.40.50.10490-FF-000148', NULL, NULL, 179, NULL, NULL, 194397),
(194398, '3.10.100.10-FF-000378', NULL, NULL, 136, NULL, NULL, 194398),
(194399, '1.10.20.10-FF-000002', NULL, 'Histone H4', 102, NULL, NULL, 194399),
(194400, '3.40.50.720-FF-002582', NULL, 'ThiF family protein', 18, NULL, NULL, 194400),
(194401, '3.30.160.60-FF-003259', NULL, 'ras-responsive element-binding protein 1', 67, NULL, NULL, 194401),
(194402, '2.60.40.10-FF-004776', NULL, NULL, 120, NULL, NULL, 194402),
(194403, '3.30.160.60-FF-005389', NULL, NULL, 25, NULL, NULL, 194403),
(194404, '3.40.309.10-FF-000098', NULL, 'Uncharacterized protein', 208, NULL, NULL, 194404),
(194405, '1.20.1270.60-FF-000319', NULL, 'Bridging integrator, putative', 179, NULL, NULL, 194405),
(194406, '3.40.50.360-FF-000113', NULL, 'Glutathione-regulated potassium-efflux system ancillary protein KefG', 213, NULL, NULL, 194406),
(194407, '3.30.1520.10-FF-000040', NULL, 'NADPH oxidase organizer 1', 144, NULL, NULL, 194407),
(194408, '3.50.30.50-FF-000014', NULL, 'Uncharacterized protein MJ0783', 185, NULL, NULL, 194408),
(194409, '3.30.160.60-FF-002663', NULL, 'Fez family zinc finger protein erm', 30, NULL, NULL, 194409),
(194410, '2.130.10.10-FF-002955', NULL, 'Uncharacterized protein', 455, NULL, NULL, 194410),
(194411, '3.90.70.10-FF-000615', NULL, 'Protein CBG21788', 152, NULL, NULL, 194411),
(194412, '1.10.540.10-FF-000020', NULL, 'Acyl-CoA dehydrogenase family member 8', 133, NULL, NULL, 194412),
(194413, '1.10.510.10-FF-001120', NULL, 'Serine/threonine kinase 17b (apoptosis-inducing)', 194, NULL, NULL, 194413),
(194414, '1.10.3720.10-FF-000180', NULL, 'Amino acid ABC transporter, permease protein, His/Glu/Gln/Arg/opine family', 217, NULL, NULL, 194414),
(194415, '3.30.70.330-FF-003022', NULL, NULL, 67, NULL, NULL, 194415),
(194416, '3.40.50.720-FF-001289', NULL, 'Os11g0229100 protein', 78, NULL, NULL, 194416),
(194417, '2.30.42.10-FF-000139', NULL, 'synaptopodin-2 isoform X1', 86, NULL, NULL, 194417),
(194418, '3.10.110.10-FF-000098', NULL, 'Ubiquitin conjugating enzyme (UbcJ)', 156, NULL, NULL, 194418),
(194419, '3.30.70.1060-FF-000004', NULL, 'Ofr1p', 93, NULL, NULL, 194419),
(194420, '3.30.160.60-FF-003500', NULL, 'zinc finger protein 271', 27, NULL, NULL, 194420),
(194421, '3.40.50.1820-FF-000078', NULL, 'Homoserine O-acetyltransferase', 229, NULL, NULL, 194421),
(194422, '1.10.287.3280-FF-000002', NULL, 'DNA damage-binding protein 2', 40, NULL, NULL, 194422);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(194423, '2.130.10.10-FF-003810', NULL, 'WD repeat-containing protein srw1', 308, NULL, NULL, 194423),
(194424, '2.40.50.140-FF-000938', NULL, NULL, 84, NULL, NULL, 194424),
(194425, '2.130.10.10-FF-004900', NULL, 'Uncharacterized protein', 113, NULL, NULL, 194425),
(194426, '2.60.120.260-FF-000651', NULL, 'Uncharacterized protein', 94, NULL, NULL, 194426),
(194427, '3.30.710.10-FF-000201', NULL, 'Os10g0438100 protein', 182, NULL, NULL, 194427),
(194428, '3.30.230.10-FF-000395', NULL, 'Uncharacterized protein', 219, NULL, NULL, 194428),
(194429, '1.20.120.1770-FF-000025', NULL, 'Transmembrane ascorbate ferrireductase 1', 155, NULL, NULL, 194429),
(194430, '3.30.200.20-FF-001520', NULL, 'Serine/threonine-protein kinase, putative', 111, NULL, NULL, 194430),
(194431, '3.40.50.1100-FF-000160', NULL, 'Uncharacterized protein', 66, NULL, NULL, 194431),
(194432, '3.30.505.10-FF-000016', NULL, 'B-cell linker protein isoform 2', 108, NULL, NULL, 194432),
(194433, '3.40.50.300-FF-002916', NULL, 'DNA topology modulation protein', 169, NULL, NULL, 194433),
(194434, '2.60.40.10-FF-001342', NULL, 'titin isoform X1', 92, NULL, NULL, 194434),
(194435, '1.10.439.10-FF-000003', NULL, 'Acyl-homoserine lactone acylase PvdQ', 170, NULL, NULL, 194435),
(194436, '2.160.10.10-FF-000009', NULL, '2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-succinyltransferase', 172, NULL, NULL, 194436),
(194437, '3.40.640.10-FF-000485', NULL, 'Uncharacterized protein', 54, NULL, NULL, 194437),
(194438, '3.30.200.20-FF-002357', NULL, NULL, 37, NULL, NULL, 194438),
(194439, '3.30.230.10-FF-000086', NULL, 'Translation elongation factor G', 126, NULL, NULL, 194439),
(194440, '2.130.10.10-FF-002646', NULL, 'Uncharacterized protein', 275, NULL, NULL, 194440),
(194441, '3.40.50.150-FF-001674', NULL, NULL, 154, NULL, NULL, 194441),
(194442, '1.25.40.10-FF-003365', NULL, 'Pentatricopeptide repeat-containing protein At4g11690', 69, NULL, NULL, 194442),
(194443, '1.20.1310.10-FF-000180', NULL, NULL, 118, NULL, NULL, 194443),
(194444, '1.25.40.20-FF-000838', NULL, 'TRPA1(A) isoform', 97, NULL, NULL, 194444),
(194445, '3.30.470.20-FF-000179', NULL, 'Carbamoyl-phosphate synthase/carboxyl transferase', 453, NULL, NULL, 194445),
(194446, '3.40.50.12780-FF-000083', NULL, 'NRPS-like enzyme, putative', 394, NULL, NULL, 194446),
(194447, '3.40.50.300-FF-007716', NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 10, mitochondrial', 96, NULL, NULL, 194447),
(194448, '1.10.510.10-FF-000501', NULL, 'testis-specific serine/threonine-protein kinase 4 isoform X1', 320, NULL, NULL, 194448),
(194449, '2.60.120.920-FF-000214', NULL, 'Uncharacterized protein', 113, NULL, NULL, 194449),
(194450, '3.80.10.10-FF-003759', NULL, 'Uncharacterized protein', 118, NULL, NULL, 194450),
(194451, '1.20.1250.10-FF-000135', NULL, NULL, 86, NULL, NULL, 194451),
(194452, '2.120.10.30-FF-000472', NULL, 'Uncharacterized protein', 60, NULL, NULL, 194452),
(194453, '2.20.70.10-FF-000137', NULL, 'Histone-lysine N-methyltransferase', 50, NULL, NULL, 194453),
(194454, '2.40.50.140-FF-000686', NULL, 'Uncharacterized protein', 110, NULL, NULL, 194454),
(194455, '2.60.120.200-FF-000021', NULL, 'Galectin', 132, NULL, NULL, 194455),
(194456, '3.40.630.10-FF-000350', NULL, 'Clan MH, family M18, aspartyl aminopeptidase-like metallopeptidase', 204, NULL, NULL, 194456),
(194457, '1.25.10.10-FF-000811', NULL, 'rotatin isoform X1', 378, NULL, NULL, 194457),
(194458, '2.40.50.1070-FF-000022', NULL, NULL, 156, NULL, NULL, 194458),
(194459, '2.60.34.10-FF-000007', NULL, 'Heat shock protein 105 kDa isoform 1', 152, NULL, NULL, 194459),
(194460, '2.60.40.10-FF-005395', NULL, NULL, 50, NULL, NULL, 194460),
(194461, '2.60.40.10-FF-006013', NULL, NULL, 100, NULL, NULL, 194461),
(194462, '3.40.50.10730-FF-000001', NULL, 'Urocanate hydratase', 208, NULL, NULL, 194462),
(194463, '3.30.40.10-FF-000026', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 108, NULL, NULL, 194463),
(194464, '1.20.120.1080-FF-000026', NULL, 'ATP-dependent RNA helicase (Hrh1)', 158, NULL, NULL, 194464),
(194465, '2.60.40.420-FF-000185', NULL, 'Uncharacterized protein', 105, NULL, NULL, 194465);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(194466, '1.20.1070.10-FF-000334', NULL, 'Uncharacterized protein', 328, NULL, NULL, 194466),
(194467, '1.20.5.170-FF-000085', NULL, 'bZIP transcription factor 49', 63, NULL, NULL, 194467),
(194468, '3.30.160.60-FF-003282', NULL, NULL, 27, NULL, NULL, 194468),
(194469, '3.40.50.620-FF-000753', NULL, 'Uncharacterized protein', 139, NULL, NULL, 194469),
(194470, '3.40.50.720-FF-002126', NULL, 'Uncharacterized protein', 109, NULL, NULL, 194470),
(194471, '1.20.58.70-FF-000056', NULL, 'Syntaxin-16', 143, NULL, NULL, 194471),
(194472, '1.10.730.10-FF-000175', NULL, 'Arginine--tRNA ligase', 116, NULL, NULL, 194472),
(194473, '1.20.58.60-FF-000519', NULL, 'Uncharacterized protein', 300, NULL, NULL, 194473),
(194474, '3.30.365.10-FF-000027', NULL, 'Xanthine dehydrogenase, molybdenum binding subunit', 210, NULL, NULL, 194474),
(194475, '1.10.238.10-FF-000020', NULL, 'spectrin alpha chain, non-erythrocytic 1', 86, NULL, NULL, 194475),
(194476, '2.120.10.30-FF-000596', NULL, 'Adipocyte plasma membrane-associated protein, putative', 96, NULL, NULL, 194476),
(194477, '3.30.160.60-FF-002882', NULL, 'Zinc finger protein 461', 24, NULL, NULL, 194477),
(194478, '3.30.260.10-FF-000109', NULL, NULL, 29, NULL, NULL, 194478),
(194479, '2.30.30.30-FF-000028', NULL, 'Transcription elongation factor SPT5', 43, NULL, NULL, 194479),
(194480, '2.30.39.10-FF-000014', NULL, 'Serpin family B member 9', 104, NULL, NULL, 194480),
(194481, '1.10.10.10-FF-000176', NULL, 'transcription factor ETV6 isoform X2', 118, NULL, NULL, 194481),
(194482, '1.25.40.20-FF-001822', NULL, 'Uncharacterized protein', 154, NULL, NULL, 194482),
(194483, '3.40.640.10-FF-000176', NULL, 'Nucleotide sugar transaminase', 366, NULL, NULL, 194483),
(194484, '2.40.50.120-FF-000005', NULL, 'Metalloproteinase inhibitor 3 precursor', 88, NULL, NULL, 194484),
(194485, '3.30.70.330-FF-000149', NULL, 'matrin-3 isoform X2', 95, NULL, NULL, 194485),
(194486, '1.10.1200.10-FF-000005', NULL, 'Nonribosomal peptide synthetase 1', 77, NULL, NULL, 194486),
(194487, '3.40.50.1000-FF-000276', NULL, 'HAD superfamily hydrolase', 105, NULL, NULL, 194487),
(194488, '3.40.50.300-FF-003445', NULL, 'DNA helicase', 247, NULL, NULL, 194488),
(194489, '2.10.25.10-FF-000803', NULL, 'C-type LECtin', 42, NULL, NULL, 194489),
(194490, '3.10.310.20-FF-000009', NULL, 'Uncharacterized protein', 150, NULL, NULL, 194490),
(194491, '1.20.90.10-FF-000051', NULL, NULL, 113, NULL, NULL, 194491),
(194492, '3.30.479.30-FF-000016', NULL, 'SPFH domain/Band 7 family protein', 126, NULL, NULL, 194492),
(194493, '3.90.1290.10-FF-000024', NULL, 'Dystonin', 199, NULL, NULL, 194493),
(194494, '3.30.70.330-FF-001908', NULL, NULL, 73, NULL, NULL, 194494),
(194495, '3.60.21.10-FF-000071', NULL, 'Serine/threonine-protein phosphatase', 297, NULL, NULL, 194495),
(194496, '3.30.40.10-FF-000392', NULL, 'Structure-specific endonuclease subunit SLX1', 71, NULL, NULL, 194496),
(194497, '3.30.9.10-FF-000173', NULL, 'FAD-dependent oxidoreductase domain-containing protein 1', 165, NULL, NULL, 194497),
(194498, '1.20.120.1750-FF-000143', NULL, 'RBR-type E3 ubiquitin transferase', 180, NULL, NULL, 194498),
(194499, '2.60.40.4200-FF-000001', NULL, 'Genome polyprotein', 98, NULL, NULL, 194499),
(194500, '1.20.1070.10-FF-000025', NULL, 'Lysophosphatidic acid receptor 1', 301, NULL, NULL, 194500),
(194501, '2.30.30.40-FF-000273', NULL, 'Actin binding protein', 70, NULL, NULL, 194501),
(194502, '2.120.10.30-FF-000449', NULL, 'Uncharacterized protein', 109, NULL, NULL, 194502),
(194503, '3.90.25.10-FF-000056', NULL, 'GDPmannose 4,6-dehydratase', 80, NULL, NULL, 194503),
(194504, '3.30.60.20-FF-000137', NULL, 'Thymidine kinase', 67, NULL, NULL, 194504),
(194505, '3.80.10.10-FF-000472', NULL, 'LRR receptor-like serine/threonine-protein kinase RCH1', 176, NULL, NULL, 194505),
(194506, '2.30.42.10-FF-000286', NULL, 'LIM domain kinase', 107, NULL, NULL, 194506),
(194507, '3.20.20.30-FF-000014', NULL, 'LLM class F420-dependent oxidoreductase', 287, NULL, NULL, 194507),
(194508, '3.80.10.10-FF-003198', NULL, 'AGAP010607-PA', 227, NULL, NULL, 194508);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(194509, '3.30.40.10-FF-000245', NULL, 'B-cell CLL/lymphoma 9-like protein', 105, NULL, NULL, 194509),
(194510, '3.30.160.60-FF-003135', NULL, 'Zinc finger protein 557', 27, NULL, NULL, 194510),
(194511, '1.25.10.10-FF-002918', NULL, 'Plakophilin 1', 108, NULL, NULL, 194511),
(194512, '3.40.50.12190-FF-000001', NULL, 'torsin-1A-interacting protein 1 isoform X1', 230, NULL, NULL, 194512),
(194513, '3.40.630.30-FF-000209', NULL, 'Uncharacterized protein 93G11.120', 187, NULL, NULL, 194513),
(194514, '2.40.40.20-FF-000003', NULL, 'Transitional endoplasmic reticulum ATPase', 105, NULL, NULL, 194514),
(194515, '1.10.510.10-FF-003374', NULL, NULL, 325, NULL, NULL, 194515),
(194516, '2.170.270.10-FF-000194', NULL, 'Histone-binding protein', 215, NULL, NULL, 194516),
(194517, '1.20.1250.20-FF-000812', NULL, 'Solute carrier organic anion transporter family member 5A1a', 148, NULL, NULL, 194517),
(194518, '1.10.510.10-FF-003935', NULL, NULL, 68, NULL, NULL, 194518),
(194519, '1.10.340.70-FF-000011', NULL, 'Uncharacterized protein', 87, NULL, NULL, 194519),
(194520, '3.30.160.60-FF-003591', NULL, 'RE1-silencing transcription factor', 64, NULL, NULL, 194520),
(194521, '3.40.50.300-FF-007031', NULL, 'Uncharacterized protein', 204, NULL, NULL, 194521),
(194522, '3.40.367.20-FF-000038', NULL, 'Phosphotransferase', 178, NULL, NULL, 194522),
(194523, '1.10.10.10-FF-001137', NULL, 'Transcription regulator E2F/DP family protein', 77, NULL, NULL, 194523),
(194524, '1.10.565.10-FF-000190', NULL, 'Uncharacterized protein', 117, NULL, NULL, 194524),
(194525, '3.30.200.20-FF-000901', NULL, 'Unplaced genomic scaffold supercont1.38, whole genome shotgun sequence', 82, NULL, NULL, 194525),
(194526, '1.10.10.10-FF-000737', NULL, 'Forkhead domain 3F', 95, NULL, NULL, 194526),
(194527, '1.25.10.10-FF-003318', NULL, 'Kinesin-like protein', 146, NULL, NULL, 194527),
(194528, '1.25.40.10-FF-001600', NULL, 'Signal recognition particle subunit SRP72', 148, NULL, NULL, 194528),
(194529, '3.40.50.620-FF-000444', NULL, 'Adenine nucleotide alpha hydrolases-like protein', 189, NULL, NULL, 194529),
(194530, '2.60.220.50-FF-000077', NULL, 'Uncharacterized protein', 229, NULL, NULL, 194530),
(194531, '3.80.10.10-FF-004182', NULL, 'Si:dkey-126g1.7', 96, NULL, NULL, 194531),
(194532, '1.20.58.60-FF-000305', NULL, 'Spectrin beta chain', 133, NULL, NULL, 194532),
(194533, '2.130.10.10-FF-002085', NULL, 'Dynein intermediate chain IC70', 248, NULL, NULL, 194533),
(194534, '2.170.210.20-FF-000002', NULL, 'Hypothetical_protein_-_conserved', 190, NULL, NULL, 194534),
(194535, '1.25.40.10-FF-004326', NULL, 'Uncharacterized protein', 171, NULL, NULL, 194535),
(194536, '3.30.40.10-FF-000953', NULL, 'LON peptidase N-terminal domain and RING finger protein 1 isoform X2', 93, NULL, NULL, 194536),
(194537, '3.10.20.770-FF-000006', NULL, 'Phosphatidylinositol-4-phosphate 3-kinase catalytic subunit type 2 gamma', 162, NULL, NULL, 194537),
(194538, '1.10.510.10-FF-003626', NULL, NULL, 194, NULL, NULL, 194538),
(194539, '2.60.120.620-FF-000023', NULL, 'Transmembrane prolyl 4-hydroxylase', 105, NULL, NULL, 194539),
(194540, '2.60.120.920-FF-000006', NULL, 'heterogeneous nuclear ribonucleoprotein U isoform X1', 210, NULL, NULL, 194540),
(194541, '2.60.40.150-FF-000536', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', 141, NULL, NULL, 194541),
(194542, '2.60.120.330-FF-000043', NULL, 'Os04g0407800 protein', 297, NULL, NULL, 194542),
(194543, '1.10.8.60-FF-000061', NULL, 'Probable inactive ATP-dependent zinc metalloprotease FTSHI 4, chloroplastic', 84, NULL, NULL, 194543),
(194544, '2.60.120.380-FF-000013', NULL, 'Alkaline serine protease', 101, NULL, NULL, 194544),
(194545, '3.40.50.1820-FF-000297', NULL, 'Lipase, putative', 217, NULL, NULL, 194545),
(194546, '1.20.58.60-FF-000744', NULL, 'Spectrin, beta, non-erythrocytic 5', 77, NULL, NULL, 194546),
(194547, '1.20.1250.20-FF-000104', NULL, 'Inner membrane transporter ydhP', 375, NULL, NULL, 194547),
(194548, '1.25.40.180-FF-000073', NULL, 'Unplaced genomic scaffold supercont2.22, whole genome shotgun sequence', 257, NULL, NULL, 194548);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(194549, '3.40.50.2300-FF-001520', NULL, NULL, 87, NULL, NULL, 194549),
(194550, '1.25.10.10-FF-002014', NULL, 'Uncharacterized protein', 164, NULL, NULL, 194550),
(194551, '3.90.550.10-FF-000725', NULL, 'Alginate synthesis-related protein', 256, NULL, NULL, 194551),
(194552, '3.60.10.10-FF-000051', NULL, 'Carbon catabolite repressor protein 4, putative', 393, NULL, NULL, 194552),
(194553, '1.20.1560.10-FF-000445', NULL, 'ABC-type multidrug transport system, ATPase and permease component', 322, NULL, NULL, 194553),
(194554, '1.25.40.470-FF-000053', NULL, 'Coatomer subunit alpha-1', 111, NULL, NULL, 194554),
(194555, '3.10.100.10-FF-000165', NULL, 'Putative invasin', 109, NULL, NULL, 194555),
(194556, '1.25.10.10-FF-002486', NULL, 'Uncharacterized protein', 209, NULL, NULL, 194556),
(194557, '3.30.160.60-FF-003731', NULL, NULL, 23, NULL, NULL, 194557),
(194558, '3.30.200.20-FF-000137', NULL, 'Serine/threonine-protein kinase', 99, NULL, NULL, 194558),
(194559, '3.30.479.20-FF-000042', NULL, 'Elongation factor Ts, mitochondrial', 118, NULL, NULL, 194559),
(194560, '1.25.40.20-FF-000288', NULL, 'Serine/threonine-protein phosphatase 6 regulatory ankyrin repeat subunit A', 106, NULL, NULL, 194560),
(194561, '1.10.10.60-FF-001202', NULL, NULL, 125, NULL, NULL, 194561),
(194562, '2.20.50.20-FF-000004', NULL, 'Vitellogenin 7', 76, NULL, NULL, 194562),
(194563, '1.25.40.10-FF-004663', NULL, 'Uncharacterized protein', 114, NULL, NULL, 194563),
(194564, '1.25.10.10-FF-000783', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 218, NULL, NULL, 194564),
(194565, '1.20.120.1080-FF-000127', NULL, 'Uncharacterized protein', 158, NULL, NULL, 194565),
(194566, '1.20.120.550-FF-000001', NULL, 'Inner membrane protein yecN', 129, NULL, NULL, 194566),
(194567, '3.30.420.40-FF-000901', NULL, 'Uncharacterized protein', 135, NULL, NULL, 194567),
(194568, '3.40.50.300-FF-003552', NULL, 'RAB13, member RAS oncogene family', 167, NULL, NULL, 194568),
(194569, '1.10.238.10-FF-000615', NULL, 'Plastin 1 (I isoform)', 121, NULL, NULL, 194569),
(194570, '2.30.29.30-FF-000856', NULL, 'Putative Sprouty-related, EVH1 domain-containing protein', 45, NULL, NULL, 194570),
(194571, '2.130.10.10-FF-002641', NULL, 'Uncharacterized protein', 228, NULL, NULL, 194571),
(194572, '1.10.238.20-FF-000040', NULL, 'AGAP006278-PA', 143, NULL, NULL, 194572),
(194573, '2.40.40.20-FF-000008', NULL, 'DNA-directed RNA polymerase subunit', 117, NULL, NULL, 194573),
(194574, '3.20.20.80-FF-000563', NULL, 'Predicted protein', 66, NULL, NULL, 194574),
(194575, '2.20.100.10-FF-000110', NULL, 'Circumsporozoite-and TRAP-related protein', 81, NULL, NULL, 194575),
(194576, '2.130.10.10-FF-001213', NULL, 'Intraflagellar transport protein 172', 186, NULL, NULL, 194576),
(194577, '3.40.50.12550-FF-000002', NULL, 'Putative ubiquitin-activating enzyme e1', 205, NULL, NULL, 194577),
(194578, '1.10.10.60-FF-000590', NULL, 'Cyclin-D-binding Myb transcription factor 1', 61, NULL, NULL, 194578),
(194579, '1.20.1250.20-FF-000576', NULL, 'Probable nitrate/nitrite transporter NarK2', 196, NULL, NULL, 194579),
(194580, '3.40.50.300-FF-002124', NULL, 'ATP-dependent RNA helicase', 236, NULL, NULL, 194580),
(194581, '3.90.640.10-FF-000266', NULL, 'Uncharacterized protein', 75, NULL, NULL, 194581),
(194582, '2.60.270.50-FF-000001', NULL, 'Hemolysin', 135, NULL, NULL, 194582),
(194583, '3.30.420.40-FF-000890', NULL, 'Glycerol kinase', 236, NULL, NULL, 194583),
(194584, '3.40.50.460-FF-000002', NULL, 'ATP-dependent 6-phosphofructokinase', 110, NULL, NULL, 194584),
(194585, '3.40.50.300-FF-001505', NULL, 'Translation elongation factor G', 287, NULL, NULL, 194585),
(194586, '3.30.1960.10-FF-000022', NULL, 'Predicted protein', 84, NULL, NULL, 194586),
(194587, '2.30.30.140-FF-000307', NULL, 'Putative ATP-dependent RNA helicase TDRD12-like Protein', 70, NULL, NULL, 194587),
(194588, '3.90.340.10-FF-000007', NULL, 'Nitric oxide synthase', 170, NULL, NULL, 194588),
(194589, '2.20.25.80-FF-000014', NULL, 'WRKY transcription factor 55', 78, NULL, NULL, 194589);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(194590, '4.10.60.10-FF-000037', NULL, 'DEAD-box ATP-dependent RNA helicase 3, chloroplastic', 29, NULL, NULL, 194590),
(194591, '3.20.20.20-FF-000017', NULL, 'Methionine synthase', 292, NULL, NULL, 194591),
(194592, '3.30.160.60-FF-002303', NULL, 'Zinc finger protein 559', 30, NULL, NULL, 194592),
(194593, '2.40.50.140-FF-000141', NULL, 'DNA helicase', 77, NULL, NULL, 194593),
(194594, '1.10.418.10-FF-000129', NULL, 'Cortexillin, putative', 117, NULL, NULL, 194594),
(194595, '3.40.30.10-FF-000227', NULL, 'glutathione S-transferase theta-1', 81, NULL, NULL, 194595),
(194596, '2.60.120.10-FF-000810', NULL, 'Uncharacterized protein', 113, NULL, NULL, 194596),
(194597, '1.20.140.40-FF-000086', NULL, NULL, 150, NULL, NULL, 194597),
(194598, '3.40.50.150-FF-001213', NULL, NULL, 93, NULL, NULL, 194598),
(194599, '3.30.1370.10-FF-000230', NULL, 'KH domain containing protein', 99, NULL, NULL, 194599),
(194600, '3.80.10.10-FF-000680', NULL, 'Probable leucine-rich repeat receptor-like protein kinase At2g33170', 96, NULL, NULL, 194600),
(194601, '3.90.950.10-FF-000025', NULL, 'Maf-like_protein_-_putative', 204, NULL, NULL, 194601),
(194602, '1.10.8.430-FF-000007', NULL, 'Putative disease resistance protein At3g14460', 82, NULL, NULL, 194602),
(194603, '1.10.510.10-FF-003621', NULL, NULL, 195, NULL, NULL, 194603),
(194604, '3.30.420.40-FF-000789', NULL, 'Type II pantothenate kinase', 170, NULL, NULL, 194604),
(194605, '2.20.90.10-FF-000009', NULL, 'Uncharacterized protein', 164, NULL, NULL, 194605),
(194606, '2.115.10.20-FF-000021', NULL, 'Alpha-L-arabinofuranosidase axhA-2', 308, NULL, NULL, 194606),
(194607, '1.10.630.10-FF-000212', NULL, 'Uncharacterized protein', 277, NULL, NULL, 194607),
(194608, '3.30.160.60-FF-001477', NULL, 'Uncharacterized protein', 28, NULL, NULL, 194608),
(194609, '2.60.40.10-FF-000960', NULL, 'NPHS1, nephrin', 100, NULL, NULL, 194609),
(194610, '3.10.20.90-FF-000870', NULL, 'Plant UBX domain-containing protein 1', 68, NULL, NULL, 194610),
(194611, '1.10.246.20-FF-000013', NULL, 'Mediator of RNA polymerase II transcription subunit 15', 55, NULL, NULL, 194611),
(194612, '2.30.39.10-FF-000031', NULL, 'Probable non-inhibitory serpin-Z9', 143, NULL, NULL, 194612),
(194613, '3.40.1190.20-FF-000172', NULL, 'Bifunctional protein HldE', 316, NULL, NULL, 194613),
(194614, '3.40.50.300-FF-006295', NULL, 'DEAD/DEAH box helicase domain protein', 182, NULL, NULL, 194614),
(194615, '2.10.25.10-FF-001764', NULL, 'Tyrosine protein kinase receptor tie-1, putative', 36, NULL, NULL, 194615),
(194616, '3.30.420.10-FF-000454', NULL, 'Piwi-like protein ergo-1', 279, NULL, NULL, 194616),
(194617, '1.20.920.10-FF-000165', NULL, 'SNF2 family N-terminal domain-domain-containing protein', 116, NULL, NULL, 194617),
(194618, '3.60.20.10-FF-000136', NULL, 'Proteasome subunit beta', 203, NULL, NULL, 194618),
(194619, '2.30.30.40-FF-000379', NULL, 'ITSN (Intersectin) family', 63, NULL, NULL, 194619),
(194620, '2.10.25.10-FF-000354', NULL, 'Putative low-density lipoprotein receptor-related protein 1B', 33, NULL, NULL, 194620),
(194621, '2.40.170.20-FF-000068', NULL, 'SusC homolog', 511, NULL, NULL, 194621),
(194622, '1.10.730.10-FF-000164', NULL, 'Isoleucine--tRNA ligase', 208, NULL, NULL, 194622),
(194623, '2.40.50.40-FF-000043', NULL, 'Testis-specific chromodomain protein Y 2', 62, NULL, NULL, 194623),
(194624, '1.10.287.380-FF-000013', NULL, 'ABC transporter ATP-binding protein', 81, NULL, NULL, 194624),
(194625, '1.10.10.10-FF-001345', NULL, 'ESCRT-II complex subunit-domain-containing protein', 76, NULL, NULL, 194625),
(194626, '3.30.980.10-FF-000035', NULL, 'Uncharacterized protein', 108, NULL, NULL, 194626),
(194627, '3.40.50.720-FF-002486', NULL, 'Predicted protein', 182, NULL, NULL, 194627),
(194628, '1.20.58.900-FF-000022', NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', 276, NULL, NULL, 194628),
(194629, '3.30.70.330-FF-001425', NULL, 'AGAP012853-PA', 85, NULL, NULL, 194629),
(194630, '1.10.2000.10-FF-000035', NULL, 'AGAP000168-PA', 82, NULL, NULL, 194630),
(194631, '1.10.1670.10-FF-000045', NULL, NULL, 74, NULL, NULL, 194631);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(194632, '3.80.10.10-FF-004518', NULL, 'Phytosulfokine receptor 2', 276, NULL, NULL, 194632),
(194633, '1.20.1070.10-FF-000812', NULL, 'Olfactory receptor 818', 130, NULL, NULL, 194633),
(194634, '1.20.1250.20-FF-002133', NULL, 'Solute carrier family 15 member 3', 208, NULL, NULL, 194634),
(194635, '1.10.1330.10-FF-000003', NULL, 'Endo-1,4-beta-xylanase Y', 61, NULL, NULL, 194635),
(194636, '3.30.2410.10-FF-000060', NULL, 'Uncharacterized protein', 102, NULL, NULL, 194636),
(194637, '1.25.50.20-FF-000002', NULL, 'Aminopeptidase', 320, NULL, NULL, 194637),
(194638, '3.20.20.80-FF-000080', NULL, 'Beta-glucuronidase UidA', 323, NULL, NULL, 194638),
(194639, '1.10.287.1150-FF-000009', NULL, '2-oxoglutarate dehydrogenase E1 component', 83, NULL, NULL, 194639),
(194640, '2.60.40.60-FF-000963', NULL, 'Predicted protein', 75, NULL, NULL, 194640),
(194641, '2.40.50.90-FF-000064', NULL, 'Endonuclease YncB', 136, NULL, NULL, 194641),
(194642, '1.10.275.10-FF-000004', NULL, 'Argininosuccinate lyase', 107, NULL, NULL, 194642),
(194643, '1.10.1450.10-FF-000164', NULL, 'Uncharacterized protein', 64, NULL, NULL, 194643),
(194644, '1.20.1070.10-FF-001998', NULL, 'Protein CBG05475', 145, NULL, NULL, 194644),
(194645, '3.30.200.20-FF-000351', NULL, 'protein kinase PINOID 2', 89, NULL, NULL, 194645),
(194646, '3.30.450.70-FF-000030', NULL, NULL, 132, NULL, NULL, 194646),
(194647, '3.40.50.300-FF-007604', NULL, 'Predicted protein', 159, NULL, NULL, 194647),
(194648, '3.30.760.10-FF-000041', NULL, 'Eukaryotic translation initiation factor 4E', 189, NULL, NULL, 194648),
(194649, '1.10.10.790-FF-000006', NULL, 'U2 snRNP-associated SURP motif-containing protein isoform X1', 83, NULL, NULL, 194649),
(194650, '3.90.70.40-FF-000023', NULL, 'Uncharacterized protein', 21, NULL, NULL, 194650),
(194651, '1.10.3730.20-FF-000003', NULL, 'Probable 4-amino-4-deoxy-L-arabinose-phosphoundecaprenol flippase subunit ArnF', 122, NULL, NULL, 194651),
(194652, '3.10.110.10-FF-000351', NULL, 'Uncharacterized protein', 114, NULL, NULL, 194652),
(194653, '3.30.40.10-FF-002162', NULL, 'Structure-specific endonuclease subunit SLX1', 87, NULL, NULL, 194653),
(194654, '3.40.50.2300-FF-000222', NULL, 'Chemotaxis protein CheV', 128, NULL, NULL, 194654),
(194655, '2.60.220.50-FF-000178', NULL, 'Uncharacterized protein', 64, NULL, NULL, 194655),
(194656, '3.80.10.10-FF-001989', NULL, 'Toll-like receptor 22', 148, NULL, NULL, 194656),
(194657, '3.40.190.170-FF-000007', NULL, 'C4-dicarboxylate-binding periplasmic protein', 300, NULL, NULL, 194657),
(194658, '3.40.50.720-FF-001867', NULL, 'Uncharacterized protein', 150, NULL, NULL, 194658),
(194659, '2.30.42.10-FF-000033', NULL, 'Rho guanine nucleotide exchange factor (GEF) 11', 87, NULL, NULL, 194659),
(194660, '2.10.110.10-FF-000220', NULL, 'Rho-GTPase-activating protein, putative', 74, NULL, NULL, 194660),
(194661, '3.40.1650.10-FF-000002', NULL, 'D-ribose pyranase', 129, NULL, NULL, 194661),
(194662, '3.90.260.10-FF-000057', NULL, 'Uncharacterized protein', 69, NULL, NULL, 194662),
(194663, '2.60.300.12-FF-000001', NULL, 'Iron-binding protein IscA', 107, NULL, NULL, 194663),
(194664, '2.60.220.50-FF-000066', NULL, 'Uncharacterized protein', 73, NULL, NULL, 194664),
(194665, '3.30.497.10-FF-000086', NULL, 'Serine protease inhibitor (SERPIN) family protein', 63, NULL, NULL, 194665),
(194666, '1.10.10.10-FF-000940', NULL, 'RpiR family transcriptional regulator', 82, NULL, NULL, 194666),
(194667, '3.30.310.180-FF-000002', NULL, 'Mediator of RNA polymerase II transcription subunit 20', 62, NULL, NULL, 194667),
(194668, '3.90.930.12-FF-000009', NULL, '60S ribosomal protein L6', 98, NULL, NULL, 194668),
(194669, '3.30.428.10-FF-000011', NULL, 'Fragile histidine triad', 148, NULL, NULL, 194669),
(194670, '1.10.3680.10-FF-000001', NULL, 'Co-chaperone protein DjlA', 148, NULL, NULL, 194670),
(194671, '3.20.20.140-FF-000220', NULL, 'Glr3518 protein', 97, NULL, NULL, 194671),
(194672, '4.10.1030.10-FF-000006', NULL, 'Uncharacterized protein', 66, NULL, NULL, 194672),
(194673, '4.10.400.10-FF-000111', NULL, 'Low density lipoprotein receptor', 44, NULL, NULL, 194673);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(194674, '3.30.160.60-FF-005176', NULL, NULL, 57, NULL, NULL, 194674),
(194675, '1.25.40.10-FF-005282', NULL, 'Uncharacterized protein', 143, NULL, NULL, 194675),
(194676, '3.40.190.150-FF-000001', NULL, 'Tricarboxylate transporter family protein', 153, NULL, NULL, 194676),
(194677, '3.80.10.10-FF-004165', NULL, 'Uncharacterized protein', 100, NULL, NULL, 194677),
(194678, '3.50.7.10-FF-000034', NULL, 'T-complex protein 1 subunit zeta, putative', 165, NULL, NULL, 194678),
(194679, '2.130.10.10-FF-002399', NULL, 'Lethal (3) 72Dn, isoform B', 201, NULL, NULL, 194679),
(194680, '4.10.900.10-FF-000025', NULL, 'Cadherin 26, tandem duplicate 1', 85, NULL, NULL, 194680),
(194681, '1.50.10.10-FF-000056', NULL, 'Uncharacterized protein, isoform D', 364, NULL, NULL, 194681),
(194682, '2.60.40.2170-FF-000004', NULL, 'tyrosine-protein kinase RYK', 70, NULL, NULL, 194682),
(194683, '3.30.70.330-FF-000599', NULL, 'Poly(A) binding protein', 101, NULL, NULL, 194683),
(194684, '3.40.120.10-FF-000013', NULL, 'Phosphoacetylglucosamine mutase', 177, NULL, NULL, 194684),
(194685, '3.30.1010.10-FF-000097', NULL, 'Uncharacterized protein', 144, NULL, NULL, 194685),
(194686, '3.40.190.10-FF-000658', NULL, 'ABC transporter, substrate-binding protein, family 5', 126, NULL, NULL, 194686),
(194687, '1.20.1260.100-FF-000011', NULL, NULL, 49, NULL, NULL, 194687),
(194688, '3.40.850.10-FF-000203', NULL, 'Kinesin motor domain containing protein', 370, NULL, NULL, 194688),
(194689, '3.40.50.300-FF-002933', NULL, 'Putative arsenical pump-driving ATPase', 347, NULL, NULL, 194689),
(194690, '1.10.532.10-FF-000001', NULL, 'Signal transducer and activator of transcription', 126, NULL, NULL, 194690),
(194691, '3.30.1330.20-FF-000011', NULL, 'Cell division protein FtsZ', 106, NULL, NULL, 194691),
(194692, '1.25.40.10-FF-001706', NULL, 'Pentatricopeptide repeat-containing protein At5g16860', 148, NULL, NULL, 194692),
(194693, '1.10.630.10-FF-000342', NULL, 'Os07g0482900 protein', 184, NULL, NULL, 194693),
(194694, '3.10.20.90-FF-000982', NULL, 'Uncharacterized protein', 96, NULL, NULL, 194694),
(194695, '3.30.160.60-FF-001365', NULL, 'Flt3-interacting zinc finger protein 1', 29, NULL, NULL, 194695),
(194696, '3.90.660.20-FF-000023', NULL, 'Protoporphyrinogen oxidase', 143, NULL, NULL, 194696),
(194697, '1.25.40.10-FF-005068', NULL, 'Pentatricopeptide repeat-containing protein At4g01030, mitochondrial', 98, NULL, NULL, 194697),
(194698, '2.60.40.10-FF-004220', NULL, NULL, 72, NULL, NULL, 194698),
(194699, '1.10.472.130-FF-000086', NULL, 'Predicted protein', 87, NULL, NULL, 194699),
(194700, '1.25.40.10-FF-002746', NULL, 'Tetratricopeptide repeat domain 19, transcript variant X1', 209, NULL, NULL, 194700),
(194701, '1.10.510.10-FF-000636', NULL, 'Non-specific serine/threonine protein kinase', 335, NULL, NULL, 194701),
(194702, '1.20.1270.10-FF-000001', NULL, 'Molecular chaperone DnaK', 101, NULL, NULL, 194702),
(194703, '3.30.420.40-FF-000659', NULL, 'Uncharacterized protein', 119, NULL, NULL, 194703),
(194704, '3.80.10.10-FF-000792', NULL, 'Predicted gene 13102', 266, NULL, NULL, 194704),
(194705, '1.10.8.60-FF-000414', NULL, 'Nitrogen fixation master sigma-54-dependent transcriptional response regulator', 74, NULL, NULL, 194705),
(194706, '3.40.1110.10-FF-000416', NULL, NULL, 43, NULL, NULL, 194706),
(194707, '1.10.555.10-FF-000037', NULL, 'Phosphatidylinositol 3-kinase regulatory subunit beta', 185, NULL, NULL, 194707),
(194708, '1.10.238.10-FF-000132', NULL, 'Ryanodine receptor 44F', 141, NULL, NULL, 194708),
(194709, '2.40.320.10-FF-000009', NULL, 'Adenylate cyclase, putative', 215, NULL, NULL, 194709),
(194710, '3.30.1330.40-FF-000017', NULL, 'Conserved protein', 120, NULL, NULL, 194710),
(194711, '1.20.5.110-FF-000230', NULL, 'SNARE protein (Ufe1), putative', 81, NULL, NULL, 194711),
(194712, '2.130.10.10-FF-004439', NULL, 'Predicted protein', 353, NULL, NULL, 194712),
(194713, '2.30.280.10-FF-000008', NULL, NULL, 40, NULL, NULL, 194713),
(194714, '3.40.50.300-FF-008335', NULL, 'DNA helicase', 236, NULL, NULL, 194714),
(194715, '2.30.29.30-FF-000064', NULL, 'Adaptin ear-binding coat-associated protein 1', 123, NULL, NULL, 194715);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(194716, '3.80.10.10-FF-002478', NULL, 'Uncharacterized protein', 221, NULL, NULL, 194716),
(194717, '2.30.110.10-FF-000108', NULL, 'Pyridoxine/pyridoxamine 5''-phosphate oxidase-like Protein', 209, NULL, NULL, 194717),
(194718, '3.40.50.2000-FF-000008', NULL, 'Glycogen synthase', 210, NULL, NULL, 194718),
(194719, '3.30.40.10-FF-000942', NULL, 'SPRY domain containing protein', 57, NULL, NULL, 194719),
(194720, '3.40.50.720-FF-000457', NULL, 'NAD dependent epimerase/dehydratase family protein', 241, NULL, NULL, 194720),
(194721, '3.30.930.10-FF-000212', NULL, 'Phenylalanine--tRNA ligase beta subunit', 193, NULL, NULL, 194721),
(194722, '3.90.79.10-FF-000028', NULL, 'Adenine DNA glycosylase', 123, NULL, NULL, 194722),
(194723, '3.10.20.90-FF-000061', NULL, 'Inhibitor of nuclear factor kappa-B kinase subunit alpha', 84, NULL, NULL, 194723),
(194724, '3.30.1370.210-FF-000011', NULL, 'Zinc finger CCCH domain-containing protein 28', 68, NULL, NULL, 194724),
(194725, '2.70.70.10-FF-000028', NULL, 'Conserved protein of uncharacterized function, possibly extracellular', 164, NULL, NULL, 194725),
(194726, '3.30.710.10-FF-000313', NULL, 'BTB domain containing 1', 80, NULL, NULL, 194726),
(194727, '3.30.70.330-FF-001313', NULL, 'Glycine-rich RNA-binding protein 7', 101, NULL, NULL, 194727),
(194728, '2.130.10.10-FF-005384', NULL, 'Uncharacterized protein', 155, NULL, NULL, 194728),
(194729, '1.25.40.10-FF-001920', NULL, 'Pentatricopeptide (PPR) repeat-containing protein-like', 123, NULL, NULL, 194729),
(194730, '2.30.39.10-FF-000143', NULL, 'Serpin-Z1', 33, NULL, NULL, 194730),
(194731, '1.20.1250.20-FF-002021', NULL, 'Uncharacterized protein', 358, NULL, NULL, 194731),
(194732, '2.60.120.260-FF-000432', NULL, 'Glycoside hydrolase family 29', 120, NULL, NULL, 194732),
(194733, '2.40.70.10-FF-000530', NULL, NULL, 205, NULL, NULL, 194733),
(194734, '2.20.25.160-FF-000002', NULL, 'N-acyl-aromatic-L-amino acid amidohydrolase (carboxylate-forming) B', 49, NULL, NULL, 194734),
(194735, '3.30.40.10-FF-001673', NULL, 'RABenoSyn (Trafficking protein) homolog', 80, NULL, NULL, 194735),
(194736, '3.40.630.30-FF-000092', NULL, 'N-alpha-acetyltransferase 60 isoform X1', 181, NULL, NULL, 194736),
(194737, '3.30.200.20-FF-001177', NULL, 'IP11267p', 73, NULL, NULL, 194737),
(194738, '3.40.50.300-FF-000567', NULL, 'ATPase, AAA family protein', 180, NULL, NULL, 194738),
(194739, '2.70.170.10-FF-000255', NULL, 'Uncharacterized protein', 197, NULL, NULL, 194739),
(194740, '2.10.25.10-FF-000466', NULL, 'adhesion G protein-coupled receptor L4 isoform X1', 48, NULL, NULL, 194740),
(194741, '1.10.3330.10-FF-000003', NULL, '2-oxo-4-hydroxy-4-carboxy-5-ureidoimidazoline decarboxylase', 159, NULL, NULL, 194741),
(194742, '2.60.40.1180-FF-000230', NULL, 'Alpha-galactosidase', 60, NULL, NULL, 194742),
(194743, '1.10.510.10-FF-001581', NULL, 'Protein kinase, putative', 200, NULL, NULL, 194743),
(194744, '1.10.490.10-FF-000009', NULL, 'hemoglobin subunit mu', 141, NULL, NULL, 194744),
(194745, '2.60.40.10-FF-001365', NULL, 'titin isoform X1', 93, NULL, NULL, 194745),
(194746, '3.30.70.330-FF-002044', NULL, NULL, 82, NULL, NULL, 194746),
(194747, '1.20.1250.20-FF-001987', NULL, 'Solute carrier organic anion transporter family member', 390, NULL, NULL, 194747),
(194748, '1.10.10.10-FF-001457', NULL, 'Replication protein', 137, NULL, NULL, 194748),
(194749, '2.130.10.10-FF-000954', NULL, 'Tup1p', 79, NULL, NULL, 194749),
(194750, '3.30.40.10-FF-002078', NULL, 'Ubiquitin-protein ligase peroxin 12', 123, NULL, NULL, 194750),
(194751, '3.10.100.10-FF-000277', NULL, NULL, 156, NULL, NULL, 194751),
(194752, '3.40.50.300-FF-003181', NULL, 'GTPase Era, mitochondrial', 182, NULL, NULL, 194752),
(194753, '3.30.1600.10-FF-000001', NULL, 'NAD-dependent deacetylase sirtuin-3, mitochondrial', 108, NULL, NULL, 194753),
(194754, '1.20.1250.20-FF-000216', NULL, 'NRT1/ PTR FAMILY 8.3 protein', 522, NULL, NULL, 194754),
(194755, '3.10.180.10-FF-000057', NULL, 'Biphenyl-2,3-diol 1,2-dioxygenase', 122, NULL, NULL, 194755),
(194756, '3.60.10.10-FF-000181', NULL, 'Sphingomyelin phosphodiesterase 2', 276, NULL, NULL, 194756);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(194757, '2.130.10.10-FF-003130', NULL, 'Predicted protein', 246, NULL, NULL, 194757),
(194758, '3.40.640.10-FF-000171', NULL, 'BnaA05g34080D protein', 259, NULL, NULL, 194758),
(194759, '3.20.20.70-FF-000200', NULL, 'Anaerobic sulfatase maturase', 367, NULL, NULL, 194759),
(194760, '3.80.10.10-FF-003097', NULL, 'Oligodendrocyte myelin glycoprotein', 115, NULL, NULL, 194760),
(194761, '3.90.550.50-FF-000029', NULL, 'Glycosyltransferase family 31 protein', 232, NULL, NULL, 194761),
(194762, '1.20.5.100-FF-000013', NULL, 'Integrin beta', 76, NULL, NULL, 194762),
(194763, '2.60.40.10-FF-005529', NULL, NULL, 57, NULL, NULL, 194763),
(194764, '3.10.105.10-FF-000024', NULL, 'Peptide ABC transporter substrate-binding protein', 221, NULL, NULL, 194764),
(194765, '2.130.10.10-FF-001230', NULL, 'WD repeat-containing protein 91', 105, NULL, NULL, 194765),
(194766, '2.130.10.10-FF-000724', NULL, 'Protein transport protein SEC31', 374, NULL, NULL, 194766),
(194767, '1.20.58.100-FF-000013', NULL, 'L-aspartate oxidase', 90, NULL, NULL, 194767),
(194768, '2.60.40.10-FF-002775', NULL, 'Fibroblast growth factor receptor', 126, NULL, NULL, 194768),
(194769, '3.40.50.150-FF-000724', NULL, 'PRIP-interacting protein PIPMT', 229, NULL, NULL, 194769),
(194770, '1.20.1070.10-FF-000020', NULL, 'Frizzled class receptor 10', 348, NULL, NULL, 194770),
(194771, '2.30.29.30-FF-000744', NULL, 'PH-protein kinase domain containing protein', 111, NULL, NULL, 194771),
(194772, '3.80.10.10-FF-000803', NULL, 'Predicted protein', 87, NULL, NULL, 194772),
(194773, '2.30.29.30-FF-000305', NULL, '3-phosphoinositide-dependent protein kinase 1', 131, NULL, NULL, 194773),
(194774, '3.40.50.10190-FF-000042', NULL, 'PAX interacting protein 1', 87, NULL, NULL, 194774),
(194775, '1.20.1560.10-FF-000557', NULL, 'Protein CBR-MRP-1', 228, NULL, NULL, 194775),
(194776, '3.30.200.20-FF-002149', NULL, 'Tyrosine-protein kinase receptor', 69, NULL, NULL, 194776),
(194777, '1.10.20.10-FF-000345', NULL, NULL, 98, NULL, NULL, 194777),
(194778, '3.30.450.50-FF-000035', NULL, 'Putative vesicle-associated membrane protein (Vamp)', 127, NULL, NULL, 194778),
(194779, '3.30.160.60-FF-004220', NULL, NULL, 30, NULL, NULL, 194779),
(194780, '2.60.40.420-FF-000201', NULL, 'Blue (Type 1) copper domain protein', 55, NULL, NULL, 194780),
(194781, '3.40.50.300-FF-006418', NULL, 'DAR GTPase 2 mitochondrial', 130, NULL, NULL, 194781),
(194782, '1.10.437.10-FF-000038', NULL, 'Zgc:153993', 169, NULL, NULL, 194782),
(194783, '1.10.150.20-FF-000190', NULL, 'DNA-binding protein MutS2', 62, NULL, NULL, 194783),
(194784, '1.10.510.10-FF-004447', NULL, NULL, 41, NULL, NULL, 194784),
(194785, '3.40.190.10-FF-000742', NULL, 'Predicted protein', 171, NULL, NULL, 194785),
(194786, '1.25.10.10-FF-000671', NULL, 'Importin beta-4 subunit, putative', 424, NULL, NULL, 194786),
(194787, '1.10.274.30-FF-000019', NULL, 'Uncharacterized protein', 179, NULL, NULL, 194787),
(194788, '3.40.50.720-FF-001429', NULL, 'Polyketide synthase type I', 475, NULL, NULL, 194788),
(194789, '3.30.420.110-FF-000074', NULL, 'DNA mismatch repair protein MutS', 133, NULL, NULL, 194789),
(194790, '1.10.510.10-FF-002553', NULL, 'Serine/threonine kinase, cell division control protein 7 related', 280, NULL, NULL, 194790),
(194791, '3.30.160.60-FF-004883', NULL, NULL, 36, NULL, NULL, 194791),
(194792, '2.40.50.40-FF-000060', NULL, 'C-C motif chemokine', 76, NULL, NULL, 194792),
(194793, '2.60.40.10-FF-000297', NULL, 'Myosin light chain kinase, smooth muscle', 109, NULL, NULL, 194793),
(194794, '3.40.1160.10-FF-000015', NULL, 'Acetylglutamate kinase', 294, NULL, NULL, 194794),
(194795, '3.50.50.60-FF-000693', NULL, 'Uncharacterized protein', 16, NULL, NULL, 194795),
(194796, '1.20.840.10-FF-000001', NULL, 'Methyl-coenzyme M reductase subunit alpha', 260, NULL, NULL, 194796),
(194797, '3.20.20.80-FF-000451', NULL, 'Os07g0538966 protein', 112, NULL, NULL, 194797),
(194798, '1.25.40.180-FF-000185', NULL, NULL, 219, NULL, NULL, 194798),
(194799, '3.80.10.10-FF-001197', NULL, 'Predicted protein', 193, NULL, NULL, 194799);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(194800, '3.60.40.10-FF-000019', NULL, 'PAS sensor protein', 218, NULL, NULL, 194800),
(194801, '1.20.1730.10-FF-000020', NULL, 'sodium/glucose cotransporter 5 isoform X2', 147, NULL, NULL, 194801),
(194802, '1.25.10.20-FF-000005', NULL, 'Apolipoprotein lipid transfer particle', 311, NULL, NULL, 194802),
(194803, '1.10.8.10-FF-000309', NULL, 'UBA/TS-N domain containing protein', 64, NULL, NULL, 194803),
(194804, '3.40.50.20-FF-000018', NULL, 'Carnosine synthase 1', 103, NULL, NULL, 194804),
(194805, '1.10.10.10-FF-001120', NULL, 'Transcriptional regulator, LuxR family', 66, NULL, NULL, 194805),
(194806, '2.60.40.60-FF-000946', NULL, 'Cad74A isoform A family protein', 120, NULL, NULL, 194806),
(194807, '3.90.640.10-FF-000154', NULL, 'Luminal-binding protein 2', 81, NULL, NULL, 194807),
(194808, '3.40.50.300-FF-003422', NULL, 'Dynein heavy chain', 120, NULL, NULL, 194808),
(194809, '3.30.160.60-FF-000960', NULL, 'zinc finger protein Rlf', 66, NULL, NULL, 194809),
(194810, '1.25.40.420-FF-000066', NULL, 'Uncharacterized protein', 47, NULL, NULL, 194810),
(194811, '2.60.40.10-FF-001606', NULL, 'uncharacterized protein LOC108091111', 108, NULL, NULL, 194811),
(194812, '2.40.128.20-FF-000009', NULL, 'Temperature-induced lipocalin', 163, NULL, NULL, 194812),
(194813, '1.20.1270.60-FF-000331', NULL, 'Uncharacterized protein', 229, NULL, NULL, 194813),
(194814, '1.10.510.10-FF-001934', NULL, 'Predicted protein', 158, NULL, NULL, 194814),
(194815, '2.130.10.10-FF-001573', NULL, 'F-box and WD domain protein', 191, NULL, NULL, 194815),
(194816, '2.60.40.150-FF-000553', NULL, 'Predicted protein', 124, NULL, NULL, 194816),
(194817, '3.30.70.330-FF-000357', NULL, 'Ribonucleoprotein A, chloroplastic', 88, NULL, NULL, 194817),
(194818, '3.40.50.410-FF-000257', NULL, 'voltage-dependent calcium channel subunit alpha-2/delta-3-like isoform X1', 180, NULL, NULL, 194818),
(194819, '1.10.630.10-FF-000572', NULL, 'Uncharacterized protein', 317, NULL, NULL, 194819),
(194820, '3.40.50.300-FF-002012', NULL, 'Large ribosomal subunit associated GTPase, putative', 176, NULL, NULL, 194820),
(194821, '2.60.40.10-FF-003394', NULL, NULL, 86, NULL, NULL, 194821),
(194822, '3.30.1640.10-FF-000094', NULL, 'DNA helicase', 102, NULL, NULL, 194822),
(194823, '3.40.50.12780-FF-000184', NULL, 'Uncharacterized protein', 131, NULL, NULL, 194823),
(194824, '3.40.50.970-FF-000178', NULL, 'Indolepyruvate oxidoreductase subunit IorA', 209, NULL, NULL, 194824),
(194825, '2.30.42.10-FF-000050', NULL, 'Periplasmic serine endoprotease DegP-like', 87, NULL, NULL, 194825),
(194826, '1.20.1740.10-FF-000105', NULL, 'Amino acid transporter, putative', 443, NULL, NULL, 194826),
(194827, '3.90.190.10-FF-000304', NULL, 'Dual-specificity phosphatase 10', 73, NULL, NULL, 194827),
(194828, '3.40.50.300-FF-007363', NULL, 'Uncharacterized protein', 76, NULL, NULL, 194828),
(194829, '2.60.120.380-FF-000030', NULL, 'Protein kinase, putative', 144, NULL, NULL, 194829),
(194830, '1.25.40.10-FF-004793', NULL, 'Enhanced entry protein enhC, tetratricopeptide repeat family', 173, NULL, NULL, 194830),
(194831, '1.10.520.10-FF-000013', NULL, 'thylakoid lumenal 29 kDa protein, chloroplastic', 169, NULL, NULL, 194831),
(194832, '3.50.50.60-FF-000350', NULL, 'Putative halogenase', 435, NULL, NULL, 194832),
(194833, '1.20.58.1120-FF-000025', NULL, 'Dynein heavy chain 6, axonemal', 146, NULL, NULL, 194833),
(194834, '1.10.510.10-FF-002210', NULL, NULL, 64, NULL, NULL, 194834),
(194835, '1.10.10.60-FF-000713', NULL, 'Gon4-like family protein', 52, NULL, NULL, 194835),
(194836, '1.25.40.10-FF-003270', NULL, 'Uncharacterized protein', 144, NULL, NULL, 194836),
(194837, '2.60.120.340-FF-000029', NULL, 'Uncharacterized protein', 86, NULL, NULL, 194837),
(194838, '3.40.50.150-FF-000241', NULL, 'S-adenosyl-L-methionine-dependent methyltransferase superfamily protein', 311, NULL, NULL, 194838),
(194839, '2.170.150.80-FF-000020', NULL, 'ANAC097', 149, NULL, NULL, 194839),
(194840, '1.25.10.10-FF-000569', NULL, 'Putative dentin phosphoryn protein', 252, NULL, NULL, 194840),
(194841, '3.50.50.60-FF-000254', NULL, 'NAD(P)-binding Rossmann-like domain protein', 63, NULL, NULL, 194841);
INSERT INTO "PUBLIC"."MODEL" VALUES
(194842, '1.20.1560.10-FF-000220', NULL, 'Unplaced genomic scaffold supercont2.6, whole genome shotgun sequence', 324, NULL, NULL, 194842),
(194843, '3.30.710.10-FF-000190', NULL, 'YIL001W-like protein', 176, NULL, NULL, 194843),
(194844, '1.10.510.10-FF-001704', NULL, 'Serine/threonine-protein kinase ATG1c', 191, NULL, NULL, 194844),
(194845, '2.30.29.30-FF-001020', NULL, 'Rho GTPase-activating protein 20-like Protein', 136, NULL, NULL, 194845),
(194846, '2.60.40.10-FF-005631', NULL, NULL, 96, NULL, NULL, 194846),
(194847, '3.30.200.20-FF-000800', NULL, 'Os02g0194600 protein', 119, NULL, NULL, 194847),
(194848, '1.25.40.10-FF-000408', NULL, 'Pentatricopeptide repeat domain 1', 81, NULL, NULL, 194848),
(194849, '1.10.510.10-FF-004110', NULL, NULL, 120, NULL, NULL, 194849),
(194850, '3.10.250.10-FF-000052', NULL, 'Uncharacterized protein', 104, NULL, NULL, 194850),
(194851, '4.10.280.10-FF-000134', NULL, 'Max-like protein X', 63, NULL, NULL, 194851),
(194852, '3.40.50.300-FF-001186', NULL, 'Origin recognition complex subunit 1', 192, NULL, NULL, 194852),
(194853, '2.40.50.140-FF-000803', NULL, NULL, 150, NULL, NULL, 194853),
(194854, '3.40.1110.10-FF-000063', NULL, 'Phospholipid-transporting ATPase', 126, NULL, NULL, 194854),
(194855, '3.40.50.12230-FF-000024', NULL, 'Uncharacterized protein', 266, NULL, NULL, 194855),
(194856, '3.60.130.10-FF-000088', NULL, 'Predicted protein', 190, NULL, NULL, 194856),
(194857, '1.50.10.10-FF-000039', NULL, 'Glycogen debranching enzyme Gdb1, putative', 446, NULL, NULL, 194857),
(194858, '3.30.160.60-FF-006148', NULL, NULL, 77, NULL, NULL, 194858),
(194859, '3.40.50.300-FF-000679', NULL, 'Thymidylate kinase', 212, NULL, NULL, 194859),
(194860, '3.10.20.90-FF-000639', NULL, 'Small ubiquitin-related modifier', 75, NULL, NULL, 194860),
(194861, '2.20.70.10-FF-000126', NULL, 'E3 ubiquitin-protein ligase', 32, NULL, NULL, 194861),
(194862, '2.40.160.20-FF-000011', NULL, 'Outer membrane protein', 201, NULL, NULL, 194862),
(194863, '1.10.640.10-FF-000056', NULL, 'Probable ovoperoxidase', 369, NULL, NULL, 194863),
(194864, '3.40.50.1820-FF-001123', NULL, 'AGAP007991-PA', 267, NULL, NULL, 194864),
(194865, '1.25.40.10-FF-002325', NULL, 'BBS4 isoform 11', 70, NULL, NULL, 194865),
(194866, '3.40.630.30-FF-000120', NULL, 'N(alpha)-acetyltransferase 40, NatD catalytic subunit', 95, NULL, NULL, 194866),
(194867, '3.10.50.40-FF-000025', NULL, 'Peptidylprolyl isomerase', 108, NULL, NULL, 194867),
(194868, '2.30.29.230-FF-000006', NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', 189, NULL, NULL, 194868),
(194869, '1.25.40.10-FF-001353', NULL, 'Os12g0289800 protein', 153, NULL, NULL, 194869),
(194870, '1.25.40.90-FF-000056', NULL, 'PCF11 cleavage and polyadenylation factor subunit', 55, NULL, NULL, 194870),
(194871, '1.10.510.10-FF-000395', NULL, 'receptor-like serine/threonine-protein kinase NCRK', 211, NULL, NULL, 194871),
(194872, '3.40.720.10-FF-000121', NULL, 'Uncharacterized protein', 181, NULL, NULL, 194872),
(194873, '3.30.40.10-FF-000150', NULL, 'Inactive histone-lysine N-methyltransferase 2E', 80, NULL, NULL, 194873),
(194874, '1.25.10.10-FF-001188', NULL, 'MMS19 nucleotide excision repair protein homolog', 277, NULL, NULL, 194874),
(194875, '1.20.120.520-FF-000003', NULL, 'Iron-sulfur cluster repair protein ScdA', 146, NULL, NULL, 194875),
(194876, '1.20.5.4770-FF-000018', NULL, 'Uncharacterized protein', 60, NULL, NULL, 194876),
(194877, '1.10.510.10-FF-003379', NULL, NULL, 322, NULL, NULL, 194877),
(194878, '3.30.160.60-FF-002758', NULL, 'Zinc finger protein 25', 35, NULL, NULL, 194878),
(194879, '2.130.10.10-FF-004086', NULL, 'Uncharacterized protein', 200, NULL, NULL, 194879),
(194880, '3.10.260.10-FF-000007', NULL, 'DNA-binding domain of Mlu1-box binding protein MBP1', 127, NULL, NULL, 194880),
(194881, '1.25.40.20-FF-001586', NULL, 'Predicted protein', 118, NULL, NULL, 194881),
(194882, '3.40.50.2000-FF-000351', NULL, 'UDP-glucuronosyltransferase', 174, NULL, NULL, 194882),
(194883, '1.10.418.10-FF-000146', NULL, 'Dystrophin', 82, NULL, NULL, 194883),
(194884, '1.10.10.10-FF-001912', NULL, 'Uncharacterized protein', 102, NULL, NULL, 194884);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(194885, '3.40.50.150-FF-001090', NULL, NULL, 216, NULL, NULL, 194885),
(194886, '2.40.430.10-FF-000001', NULL, 'Maltose ABC transporter permease MalF', 88, NULL, NULL, 194886),
(194887, '3.40.50.1240-FF-000191', NULL, NULL, 36, NULL, NULL, 194887),
(194888, '1.20.1600.10-FF-000033', NULL, 'Blr5467 protein', 411, NULL, NULL, 194888),
(194889, '2.60.120.200-FF-000572', NULL, 'Uncharacterized protein', 178, NULL, NULL, 194889),
(194890, '3.30.40.10-FF-002050', NULL, 'Predicted protein', 92, NULL, NULL, 194890),
(194891, '3.30.2350.10-FF-000021', NULL, 'Pseudouridine synthase, putative', 185, NULL, NULL, 194891),
(194892, '2.60.40.2120-FF-000001', NULL, 'Surface layer protein', 86, NULL, NULL, 194892),
(194893, '2.30.30.40-FF-000149', NULL, 'neutrophil cytosol factor 4', 79, NULL, NULL, 194893),
(194894, '2.60.120.650-FF-000021', NULL, 'Lysine-specific demethylase 7A', 284, NULL, NULL, 194894),
(194895, '3.30.30.30-FF-000071', NULL, 'DnaK protein', 48, NULL, NULL, 194895),
(194896, '3.30.930.10-FF-000324', NULL, 'Putative lipoyltransferase 2, mitochondrial', 184, NULL, NULL, 194896),
(194897, '3.20.20.70-FF-000122', NULL, '2-iminoacetate synthase ThiH', 359, NULL, NULL, 194897),
(194898, '3.30.160.60-FF-000858', NULL, 'Zinc finger protein RFP', 73, NULL, NULL, 194898),
(194899, '1.20.1280.290-FF-000010', NULL, 'Sugar transporter SWEET', 90, NULL, NULL, 194899),
(194900, '3.40.50.620-FF-000202', NULL, 'Pantetheine-phosphate adenylyltransferase family protein', 168, NULL, NULL, 194900),
(194901, '1.25.40.20-FF-001226', NULL, 'Uncharacterized protein', 181, NULL, NULL, 194901),
(194902, '1.20.120.720-FF-000063', NULL, 'Uncharacterized protein', 168, NULL, NULL, 194902),
(194903, '1.20.58.60-FF-000295', NULL, 'Spectrin beta chain', 141, NULL, NULL, 194903),
(194904, '3.30.70.330-FF-002482', NULL, NULL, 78, NULL, NULL, 194904),
(194905, '4.10.480.10-FF-000003', NULL, 'Ni/Fe hydrogenase, small subunit', 108, NULL, NULL, 194905),
(194906, '3.90.550.10-FF-000276', NULL, 'UTP--glucose-1-phosphate uridylyltransferase', 363, NULL, NULL, 194906),
(194907, '2.60.120.10-FF-000361', NULL, 'Uncharacterized protein', 93, NULL, NULL, 194907),
(194908, '1.25.10.10-FF-000699', NULL, 'Serine/threonine-protein kinase TOR', 297, NULL, NULL, 194908),
(194909, '3.30.310.40-FF-000005', NULL, 'N-glycosylase/DNA lyase OGG1', 89, NULL, NULL, 194909),
(194910, '1.10.565.10-FF-000111', NULL, 'Nuclear Hormone Receptor family', 203, NULL, NULL, 194910),
(194911, '2.40.30.10-FF-000533', NULL, 'tRNA (5-methylaminomethyl-2-thiouridylate)-methyltransferase, putative', 86, NULL, NULL, 194911),
(194912, '2.30.39.10-FF-000126', NULL, 'Serpin-4 precursor, putative', 21, NULL, NULL, 194912),
(194913, '3.40.50.1820-FF-000634', NULL, 'Bactin polyketide/non-ribosomal peptide synthetase', 256, NULL, NULL, 194913),
(194914, '1.20.1230.10-FF-000004', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 249, NULL, NULL, 194914),
(194915, '1.10.472.80-FF-000270', NULL, NULL, 97, NULL, NULL, 194915),
(194916, '4.10.400.10-FF-000223', NULL, 'Low-density lipoprotein receptor-related protein', 39, NULL, NULL, 194916),
(194917, '1.10.560.10-FF-000004', NULL, 'T-complex protein 1 subunit epsilon', 231, NULL, NULL, 194917),
(194918, '1.20.1250.20-FF-001195', NULL, 'Alpha-ketoglutarate permease (KgtP)', 190, NULL, NULL, 194918),
(194919, '3.60.20.10-FF-000119', NULL, '20S proteasome alpha subunit 7', 271, NULL, NULL, 194919),
(194920, '3.40.50.1010-FF-000037', NULL, 'Rad2-like endonuclease, putative (AFU_orthologue AFUA_3G13260)', 78, NULL, NULL, 194920),
(194921, '3.80.10.10-FF-000011', NULL, 'Lysine-specific demethylase 2B isoform X1', 271, NULL, NULL, 194921),
(194922, '3.30.70.330-FF-000487', NULL, 'Poly [ADP-ribose] polymerase', 65, NULL, NULL, 194922),
(194923, '3.40.50.2000-FF-000790', NULL, 'Granule-bound starch synthase 1 chloroplastic/amyloplastic', 74, NULL, NULL, 194923),
(194924, '3.90.245.10-FF-000033', NULL, 'Uncharacterized protein C800.11', 338, NULL, NULL, 194924),
(194925, '3.40.50.300-FF-005901', NULL, 'GTP-binding protein TrmE N-terminus-domain-containing protein', 177, NULL, NULL, 194925);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(194926, '3.80.30.30-FF-000001', NULL, 'Spore photoproduct lyase', 227, NULL, NULL, 194926),
(194927, '2.40.128.620-FF-000010', NULL, 'Uncharacterized protein', 45, NULL, NULL, 194927),
(194928, '3.40.50.2000-FF-000694', NULL, 'Lipopolysaccharide heptosyltransferase', 183, NULL, NULL, 194928),
(194929, '1.10.101.10-FF-000012', NULL, 'Lytic murein transglycosylase', 65, NULL, NULL, 194929),
(194930, '2.130.10.10-FF-003467', NULL, 'Predicted protein', 67, NULL, NULL, 194930),
(194931, '2.60.40.10-FF-002758', NULL, 'KDELC2 isoform 3', 69, NULL, NULL, 194931),
(194932, '3.30.200.40-FF-000014', NULL, 'Uncharacterized protein', 94, NULL, NULL, 194932),
(194933, '3.10.105.10-FF-000041', NULL, 'Oligopeptide ABC transporter,oligopeptide-binding protein', 197, NULL, NULL, 194933),
(194934, '3.10.110.10-FF-000334', NULL, 'Uncharacterized protein', 154, NULL, NULL, 194934),
(194935, '2.60.120.260-FF-000095', NULL, 'Teneurin transmembrane protein 1', 43, NULL, NULL, 194935),
(194936, '3.10.100.10-FF-000406', NULL, NULL, 109, NULL, NULL, 194936),
(194937, '3.40.50.2300-FF-001503', NULL, NULL, 107, NULL, NULL, 194937),
(194938, '1.25.40.10-FF-002668', NULL, 'TPR Domain containing protein', 344, NULL, NULL, 194938),
(194939, '1.25.10.10-FF-003442', NULL, 'Uncharacterized protein', 252, NULL, NULL, 194939),
(194940, '1.10.10.160-FF-000060', NULL, 'DNA helicase', 88, NULL, NULL, 194940),
(194941, '1.10.1240.30-FF-000002', NULL, 'Phosphoserine phosphatase', 82, NULL, NULL, 194941),
(194942, '3.80.10.10-FF-003658', NULL, 'Leucine rich repeat containing 29, isoform CRA_c', 239, NULL, NULL, 194942),
(194943, '1.20.120.330-FF-000036', NULL, 'Predicted protein', 135, NULL, NULL, 194943),
(194944, '3.40.190.80-FF-000055', NULL, 'Putative myo-inositol-1(Or 4)-monophosphatase', 110, NULL, NULL, 194944),
(194945, '1.25.40.20-FF-000737', NULL, 'Ankyrin repeat domain 42', 80, NULL, NULL, 194945),
(194946, '3.80.10.10-FF-000224', NULL, 'Leucine-rich repeat extensin-like protein 1', 162, NULL, NULL, 194946),
(194947, '3.40.309.10-FF-000114', NULL, 'Uncharacterized protein', 75, NULL, NULL, 194947),
(194948, '2.60.120.200-FF-000116', NULL, 'Laminin subunit alpha 1', 181, NULL, NULL, 194948),
(194949, '3.30.70.270-FF-000328', NULL, NULL, 131, NULL, NULL, 194949),
(194950, '2.40.50.140-FF-000933', NULL, NULL, 90, NULL, NULL, 194950),
(194951, '3.80.10.10-FF-004406', NULL, 'At5g27920', 91, NULL, NULL, 194951),
(194952, '2.130.10.10-FF-002978', NULL, 'Uncharacterized protein', 346, NULL, NULL, 194952),
(194953, '3.30.160.60-FF-005529', NULL, NULL, 31, NULL, NULL, 194953),
(194954, '2.120.10.30-FF-000360', NULL, 'Uncharacterized protein', 149, NULL, NULL, 194954),
(194955, '2.60.40.10-FF-000858', NULL, 'Immunoglobin superfamily member 21', 85, NULL, NULL, 194955),
(194956, '3.30.460.10-FF-000007', NULL, '2''-5''-oligoadenylate synthetase 1', 158, NULL, NULL, 194956),
(194957, '3.40.1450.10-FF-000003', NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase putative', 62, NULL, NULL, 194957),
(194958, '3.30.1360.120-FF-000021', NULL, 'Slr0635 protein', 331, NULL, NULL, 194958),
(194959, '1.10.10.60-FF-000943', NULL, NULL, 73, NULL, NULL, 194959),
(194960, '1.10.287.1010-FF-000001', NULL, 'Hypoxia-inducible factor 1-alpha inhibitor', 44, NULL, NULL, 194960),
(194961, '1.20.58.60-FF-000856', NULL, 'Uncharacterized protein', 135, NULL, NULL, 194961),
(194962, '3.40.50.720-FF-002374', NULL, 'Uncharacterized protein', 73, NULL, NULL, 194962),
(194963, '1.25.40.70-FF-000050', NULL, 'Phosphatidylinositol 3-kinase 1', 198, NULL, NULL, 194963),
(194964, '3.40.50.2030-FF-000006', NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit alpha 1', 193, NULL, NULL, 194964),
(194965, '1.20.1270.50-FF-000002', NULL, 'Alpha-mannosidase', 81, NULL, NULL, 194965),
(194966, '1.20.1070.10-FF-001189', NULL, 'Predicted protein', 195, NULL, NULL, 194966),
(194967, '1.20.1310.10-FF-000056', NULL, 'GL25796', 118, NULL, NULL, 194967),
(194968, '3.40.50.1440-FF-000048', NULL, 'Cell division protein FtsZ 1, chloroplastic', 166, NULL, NULL, 194968);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(194969, '3.40.50.10330-FF-000117', NULL, 'NAD kinase', 166, NULL, NULL, 194969),
(194970, '1.20.1250.20-FF-000559', NULL, 'Hexose transport-related protein, putative', 464, NULL, NULL, 194970),
(194971, '3.40.50.300-FF-001747', NULL, 'ATP-dependent DNA helicase', 202, NULL, NULL, 194971),
(194972, '1.20.120.1780-FF-000011', NULL, '4-hydroxybenzoate polyprenyltransferase, mitochondrial', 80, NULL, NULL, 194972),
(194973, '3.60.10.10-FF-000293', NULL, 'Predicted protein', 403, NULL, NULL, 194973),
(194974, '3.40.50.300-FF-005007', NULL, 'Polynucleotide 5''-hydroxyl-kinase grc3', 220, NULL, NULL, 194974),
(194975, '3.30.70.330-FF-000144', NULL, 'Polyadenylate-binding protein RBP47B', 103, NULL, NULL, 194975),
(194976, '3.30.470.20-FF-000151', NULL, 'Synapsin-2', 119, NULL, NULL, 194976),
(194977, '1.10.10.10-FF-000968', NULL, 'LysR family transcriptional regulator', 85, NULL, NULL, 194977),
(194978, '2.10.60.10-FF-000036', NULL, 'Serine/threonine-protein kinase receptor', 101, NULL, NULL, 194978),
(194979, '1.10.1040.50-FF-000015', NULL, NULL, 212, NULL, NULL, 194979),
(194980, '1.10.340.30-FF-000022', NULL, 'DNA-3-methyladenine glycosylase, probable', 115, NULL, NULL, 194980),
(194981, '2.60.40.10-FF-004563', NULL, NULL, 103, NULL, NULL, 194981),
(194982, '3.90.660.10-FF-000037', NULL, 'Zgc:66484', 238, NULL, NULL, 194982),
(194983, '3.30.1330.80-FF-000001', NULL, 'AT-hook motif nuclear-localized protein', 128, NULL, NULL, 194983),
(194984, '3.40.250.10-FF-000129', NULL, 'Thiosulfate sulfurtransferase, putative', 131, NULL, NULL, 194984),
(194985, '3.30.160.60-FF-001926', NULL, NULL, 30, NULL, NULL, 194985),
(194986, '3.60.10.10-FF-000405', NULL, 'Inositol polyphosphate phosphatase-like protein', 147, NULL, NULL, 194986),
(194987, '3.30.70.330-FF-002274', NULL, NULL, 143, NULL, NULL, 194987),
(194988, '3.30.160.60-FF-005631', NULL, NULL, 38, NULL, NULL, 194988),
(194989, '2.120.10.30-FF-000028', NULL, 'Pro-epidermal growth factor', 299, NULL, NULL, 194989),
(194990, '2.30.130.40-FF-000006', NULL, 'Lon protease homolog, mitochondrial', 112, NULL, NULL, 194990),
(194991, '1.25.10.10-FF-000120', NULL, 'Sister chromatid cohesion protein PDS5 homolog B', 403, NULL, NULL, 194991),
(194992, '1.20.1050.10-FF-000119', NULL, 'Glutathione S-transferase U10', 139, NULL, NULL, 194992),
(194993, '3.60.21.10-FF-000099', NULL, 'Serine/threonine-protein phosphatase', 436, NULL, NULL, 194993),
(194994, '1.10.238.10-FF-001312', NULL, 'Uncharacterized protein', 85, NULL, NULL, 194994),
(194995, '2.30.170.20-FF-000008', NULL, 'probable ribosome biogenesis protein RLP24', 27, NULL, NULL, 194995),
(194996, '3.10.450.190-FF-000001', NULL, 'Baseplate hub subunit and tail lysozyme', 45, NULL, NULL, 194996),
(194997, '2.60.200.20-FF-000191', NULL, 'SMAD/FHA domain-containing protein', 142, NULL, NULL, 194997),
(194998, '3.30.870.10-FF-000145', NULL, 'Uncharacterized protein', 210, NULL, NULL, 194998),
(194999, '1.20.120.1760-FF-000005', NULL, 'Cardiolipin synthase 1', 192, NULL, NULL, 194999),
(195000, '3.90.15.10-FF-000010', NULL, 'DNA topoisomerase I', 155, NULL, NULL, 195000),
(195001, '3.30.1240.20-FF-000004', NULL, NULL, 11, NULL, NULL, 195001),
(195002, '3.30.505.10-FF-000140', NULL, NULL, 105, NULL, NULL, 195002),
(195003, '1.20.58.340-FF-000051', NULL, 'Uncharacterized protein', 74, NULL, NULL, 195003),
(195004, '1.25.40.20-FF-000046', NULL, 'Ankyrin repeat and KH domain-containing protein 1', 168, NULL, NULL, 195004),
(195005, '3.20.20.100-FF-000106', NULL, 'Uncharacterized protein', 307, NULL, NULL, 195005),
(195006, '2.130.10.10-FF-005625', NULL, 'Uncharacterized protein', 181, NULL, NULL, 195006),
(195007, '3.90.550.10-FF-000484', NULL, 'Putative alpha-1,3-mannosyltransferase MNN12', 186, NULL, NULL, 195007),
(195008, '1.25.40.20-FF-001682', NULL, 'Transient receptor potential cation channel subfamily V member 4', 75, NULL, NULL, 195008),
(195009, '1.10.420.10-FF-000062', NULL, 'Peroxidase', 146, NULL, NULL, 195009),
(195010, '3.40.50.1240-FF-000089', NULL, 'Phosphoglycerate mutase family protein', 203, NULL, NULL, 195010);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(195011, '2.60.40.10-FF-004462', NULL, NULL, 104, NULL, NULL, 195011),
(195012, '3.40.50.300-FF-007576', NULL, 'Uncharacterized protein', 179, NULL, NULL, 195012),
(195013, '1.10.3720.10-FF-000056', NULL, 'Phosphate transport system permease protein PstA', 269, NULL, NULL, 195013),
(195014, '3.30.1370.10-FF-000128', NULL, 'Heterogeneous nuclear ribonucleoprotein K, isoform B', 77, NULL, NULL, 195014),
(195015, '3.40.50.2000-FF-000582', NULL, 'ADP-heptose--lipooligosaccharide heptosyltransferase II', 158, NULL, NULL, 195015),
(195016, '2.70.220.10-FF-000012', NULL, 'MD-2-related lipid-recognition protein ROSY1', 75, NULL, NULL, 195016),
(195017, '2.60.40.10-FF-003034', NULL, 'Uncharacterized protein', 101, NULL, NULL, 195017),
(195018, '3.40.50.720-FF-000906', NULL, 'Alcohol dehydrogenase', 186, NULL, NULL, 195018),
(195019, '3.30.300.10-FF-000052', NULL, 'S-adenosylmethionine synthase', 122, NULL, NULL, 195019),
(195020, '3.40.50.10420-FF-000032', NULL, '5-formyltetrahydrofolate cyclo-ligase', 208, NULL, NULL, 195020),
(195021, '3.40.710.10-FF-000165', NULL, 'Peptidoglycan transglycosylase and transpeptidase MrcA', 112, NULL, NULL, 195021),
(195022, '2.60.40.10-FF-001814', NULL, 'Basement membrane proteoglycan', 87, NULL, NULL, 195022),
(195023, '3.40.50.300-FF-001848', NULL, 'ABC transporter C family member 4', 246, NULL, NULL, 195023),
(195024, '1.10.472.80-FF-000056', NULL, 'Uncharacterized protein, isoform B', 121, NULL, NULL, 195024),
(195025, '1.10.8.60-FF-000302', NULL, 'Uncharacterized protein', 88, NULL, NULL, 195025),
(195026, '3.30.230.10-FF-000299', NULL, 'DNA mismatch repair protein, putative', 121, NULL, NULL, 195026),
(195027, '3.10.430.100-FF-000015', NULL, '50S ribosomal protein L9', 87, NULL, NULL, 195027),
(195028, '1.10.287.660-FF-000007', NULL, 'WGS project CABT00000000 data, contig 2.58', 85, NULL, NULL, 195028),
(195029, '3.40.50.150-FF-000937', NULL, NULL, 112, NULL, NULL, 195029),
(195030, '3.40.1800.20-FF-000040', NULL, NULL, 75, NULL, NULL, 195030),
(195031, '3.40.50.1820-FF-000746', NULL, 'Uncharacterized protein', 100, NULL, NULL, 195031),
(195032, '3.40.50.1980-FF-000069', NULL, 'Probable FEIII-dicitrate-binding periplasmic lipoprotein FecB', 171, NULL, NULL, 195032),
(195033, '1.20.1440.170-FF-000011', NULL, NULL, 98, NULL, NULL, 195033),
(195034, '3.30.60.30-FF-000022', NULL, 'Transmembrane agrin', 64, NULL, NULL, 195034),
(195035, '3.30.70.3250-FF-000009', NULL, NULL, 98, NULL, NULL, 195035),
(195036, '2.60.40.10-FF-000864', NULL, 'Titin b', 102, NULL, NULL, 195036),
(195037, '3.30.70.260-FF-000100', NULL, 'Prephenate dehydrogenase', 74, NULL, NULL, 195037),
(195038, '3.30.450.40-FF-000049', NULL, 'Heat-inducible transcription repressor HrcA', 123, NULL, NULL, 195038),
(195039, '2.40.10.10-FF-000419', NULL, 'prostasin-like', 260, NULL, NULL, 195039),
(195040, '3.40.309.10-FF-000002', NULL, 'Methylmalonate-semialdehyde dehydrogenase (Acylating)', 202, NULL, NULL, 195040),
(195041, '2.60.34.10-FF-000024', NULL, 'Uncharacterized protein, isoform B', 168, NULL, NULL, 195041),
(195042, '2.30.30.90-FF-000012', NULL, 'Metal-dependent transcriptional regulator', 83, NULL, NULL, 195042),
(195043, '3.10.150.10-FF-000016', NULL, 'DNA polymerase III subunit beta', 171, NULL, NULL, 195043),
(195044, '3.40.50.10140-FF-000049', NULL, 'Interleukin-1 receptor type I', 174, NULL, NULL, 195044),
(195045, '3.30.1360.180-FF-000011', NULL, 'Uncharacterized protein', 107, NULL, NULL, 195045),
(195046, '3.30.70.600-FF-000017', NULL, '40S ribosomal protein S10, mitochondrial', 138, NULL, NULL, 195046),
(195047, '3.40.50.11030-FF-000007', NULL, 'Threonylcarbamoyl-AMP synthase', 128, NULL, NULL, 195047),
(195048, '3.30.1640.30-FF-000004', NULL, 'Uncharacterized protein, isoform A', 69, NULL, NULL, 195048),
(195049, '2.60.40.790-FF-000166', NULL, NULL, 135, NULL, NULL, 195049),
(195050, '3.80.10.10-FF-001860', NULL, 'Ribonuclease inhibitor-like protein', 138, NULL, NULL, 195050),
(195051, '3.30.50.10-FF-000190', NULL, 'GATA transcription factor 16', 86, NULL, NULL, 195051),
(195052, '3.30.342.10-FF-000008', NULL, 'DNA polymerase zeta catalytic subunit isoform X3', 109, NULL, NULL, 195052);
INSERT INTO "PUBLIC"."MODEL" VALUES
(195053, '3.40.140.70-FF-000015', NULL, 'Autophagy-related 7, isoform B', 52, NULL, NULL, 195053),
(195054, '3.20.20.70-FF-000330', NULL, 'Fructose-bisphosphate aldolase', 364, NULL, NULL, 195054),
(195055, '1.25.40.10-FF-004904', NULL, 'Predicted protein', 213, NULL, NULL, 195055),
(195056, '3.40.1350.100-FF-000009', NULL, NULL, 122, NULL, NULL, 195056),
(195057, '3.40.50.300-FF-000224', NULL, 'Energy-coupling factor transporter ATP-binding protein EcfA', 264, NULL, NULL, 195057),
(195058, '2.60.120.290-FF-000087', NULL, 'LEV-10A protein', 128, NULL, NULL, 195058),
(195059, '3.40.190.290-FF-000138', NULL, 'Possible transcriptional regulator', 209, NULL, NULL, 195059),
(195060, '1.10.30.10-FF-000059', NULL, 'Protein pop-1', 84, NULL, NULL, 195060),
(195061, '3.40.190.10-FF-000079', NULL, 'Glycine betaine ABC transporter substrate-binding protein', 160, NULL, NULL, 195061),
(195062, '1.10.510.10-FF-000187', NULL, 'integrin-linked protein kinase', 180, NULL, NULL, 195062),
(195063, '3.40.720.10-FF-000093', NULL, 'arylsulfatase B isoform X1', 353, NULL, NULL, 195063),
(195064, '2.60.40.60-FF-000042', NULL, 'protocadherin-19 isoform X1', 102, NULL, NULL, 195064),
(195065, '3.40.50.720-FF-000114', NULL, 'UDP-glucose 6-dehydrogenase', 226, NULL, NULL, 195065),
(195066, '3.40.50.300-FF-004833', NULL, 'Probable mitochondrial Rho GTPase gemA', 188, NULL, NULL, 195066),
(195067, '3.30.1440.10-FF-000011', NULL, 'Ribosomal protein L5', 158, NULL, NULL, 195067),
(195068, '3.40.50.720-FF-002031', NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', 192, NULL, NULL, 195068),
(195069, '2.120.10.10-FF-000022', NULL, 'Sialidase', 381, NULL, NULL, 195069),
(195070, '3.20.20.80-FF-000119', NULL, 'Alpha-amylase-related protein', 381, NULL, NULL, 195070),
(195071, '3.80.10.10-FF-002265', NULL, 'Predicted protein', 102, NULL, NULL, 195071),
(195072, '3.40.50.300-FF-002467', NULL, 'AGAP010790-PA', 319, NULL, NULL, 195072),
(195073, '3.30.160.60-FF-003152', NULL, 'Zinc finger protein 384', 26, NULL, NULL, 195073),
(195074, '3.40.50.1820-FF-001011', NULL, 'Uncharacterized protein', 218, NULL, NULL, 195074),
(195075, '3.30.160.60-FF-004911', NULL, NULL, 53, NULL, NULL, 195075),
(195076, '3.40.50.300-FF-006862', NULL, 'Uncharacterized protein', 332, NULL, NULL, 195076),
(195077, '3.30.40.10-FF-000262', NULL, 'E3 ubiquitin-protein ligase MARCH5', 72, NULL, NULL, 195077),
(195078, '1.25.40.10-FF-004219', NULL, 'Uncharacterized protein', 42, NULL, NULL, 195078),
(195079, '3.80.30.20-FF-000015', NULL, 'Ribosomal protein S12 methylthiotransferase RimO', 232, NULL, NULL, 195079),
(195080, '3.90.1150.10-FF-000441', NULL, 'Uncharacterized protein', 157, NULL, NULL, 195080),
(195081, '3.40.50.1000-FF-000040', NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase', 144, NULL, NULL, 195081),
(195082, '3.30.450.20-FF-000408', NULL, 'Two component system histidine kinase', 119, NULL, NULL, 195082),
(195083, '3.30.40.10-FF-001886', NULL, 'Uncharacterized protein', 75, NULL, NULL, 195083),
(195084, '1.20.1740.10-FF-000094', NULL, 'Uncharacterized protein, isoform B', 147, NULL, NULL, 195084),
(195085, '3.80.10.10-FF-002141', NULL, 'Uncharacterized protein', 133, NULL, NULL, 195085),
(195086, '2.30.42.10-FF-000393', NULL, NULL, 117, NULL, NULL, 195086),
(195087, '1.20.120.230-FF-000023', NULL, 'Rhea, isoform B', 131, NULL, NULL, 195087),
(195088, '3.60.20.10-FF-000220', NULL, NULL, 140, NULL, NULL, 195088),
(195089, '1.20.58.60-FF-000194', NULL, 'Uncharacterized protein, isoform I', 185, NULL, NULL, 195089),
(195090, '1.10.472.10-FF-000631', NULL, 'Uncharacterized protein', 121, NULL, NULL, 195090),
(195091, '3.40.50.2300-FF-000891', NULL, NULL, 149, NULL, NULL, 195091),
(195092, '1.10.10.60-FF-001118', NULL, NULL, 64, NULL, NULL, 195092),
(195093, '1.10.238.10-FF-000587', NULL, 'Uncharacterized protein', 75, NULL, NULL, 195093),
(195094, '2.30.29.30-FF-000194', NULL, 'Putative src kinase-associated phosphoprotein 2', 110, NULL, NULL, 195094),
(195095, '2.60.40.60-FF-001138', NULL, 'Predicted protein', 46, NULL, NULL, 195095); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(195096, '4.10.240.10-FF-000025', NULL, 'C6 transcription factor, putative', 88, NULL, NULL, 195096),
(195097, '3.40.50.1010-FF-000138', NULL, 'Flap endonuclease 1-1', 193, NULL, NULL, 195097),
(195098, '1.25.40.10-FF-005170', NULL, 'Predicted protein', 70, NULL, NULL, 195098),
(195099, '3.90.70.10-FF-000368', NULL, 'Cytoskeleton-associated protein CAP5.5, putative', 154, NULL, NULL, 195099),
(195100, '3.40.430.10-FF-000014', NULL, 'Dihydrofolate reductase', 177, NULL, NULL, 195100),
(195101, '3.30.160.60-FF-004799', NULL, NULL, 33, NULL, NULL, 195101),
(195102, '3.30.160.60-FF-004675', NULL, NULL, 28, NULL, NULL, 195102),
(195103, '2.130.10.10-FF-001129', NULL, 'Transducin beta-like protein 3', 168, NULL, NULL, 195103),
(195104, '3.40.1030.10-FF-000011', NULL, 'Anthranilate phosphoribosyltransferase like', 247, NULL, NULL, 195104),
(195105, '1.10.1740.10-FF-000040', NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', 89, NULL, NULL, 195105),
(195106, '1.10.8.60-FF-000510', NULL, 'Uncharacterized protein', 55, NULL, NULL, 195106),
(195107, '2.170.270.10-FF-000199', NULL, 'Uncharacterized protein', 198, NULL, NULL, 195107),
(195108, '1.10.510.10-FF-001125', NULL, 'Serine/threonine-protein kinase RIO1', 153, NULL, NULL, 195108),
(195109, '1.10.630.10-FF-000128', NULL, 'Putative cytochrome P450 139', 423, NULL, NULL, 195109),
(195110, '3.30.70.330-FF-002605', NULL, NULL, 132, NULL, NULL, 195110),
(195111, '1.20.1250.20-FF-000672', NULL, 'MFS general substrate transporter', 172, NULL, NULL, 195111),
(195112, '1.50.40.10-FF-000333', NULL, 'Mitochondrial glycine transporter', 271, NULL, NULL, 195112),
(195113, '3.40.20.10-FF-000058', NULL, 'Quail, isoform C', 119, NULL, NULL, 195113),
(195114, '3.40.50.170-FF-000039', NULL, 'Phosphoribosylglycinamide formyltransferase', 215, NULL, NULL, 195114),
(195115, '3.40.50.410-FF-000027', NULL, 'collagen alpha-2(VI) chain isoform X1', 212, NULL, NULL, 195115),
(195116, '3.30.160.20-FF-000184', NULL, '39S ribosomal protein L44, mitochondrial', 86, NULL, NULL, 195116),
(195117, '2.60.40.1730-FF-000002', NULL, 'Aminopeptidase', 208, NULL, NULL, 195117),
(195118, '2.60.40.10-FF-005288', NULL, NULL, 83, NULL, NULL, 195118),
(195119, '3.40.50.2300-FF-000559', NULL, 'Metabotropic glutamate receptor', 307, NULL, NULL, 195119),
(195120, '3.60.15.10-FF-000169', NULL, 'Uncharacterized protein', 245, NULL, NULL, 195120),
(195121, '1.10.1240.10-FF-000007', NULL, 'Methyltransferase cognate corrinoid protein', 100, NULL, NULL, 195121),
(195122, '1.20.1250.10-FF-000118', NULL, NULL, 149, NULL, NULL, 195122),
(195123, '3.40.50.2300-FF-000435', NULL, 'Protein CBG01593', 124, NULL, NULL, 195123),
(195124, '3.80.10.10-FF-003338', NULL, 'Predicted protein', 121, NULL, NULL, 195124),
(195125, '3.30.200.20-FF-000688', NULL, 'L-type lectin-domain containing receptor kinase IV.1', 90, NULL, NULL, 195125),
(195126, '2.60.120.970-FF-000105', NULL, 'Left-right determination factor', 84, NULL, NULL, 195126),
(195127, '3.90.1180.10-FF-000038', NULL, NULL, 138, NULL, NULL, 195127),
(195128, '3.30.40.10-FF-001431', NULL, 'G protein-coupled receptor', 73, NULL, NULL, 195128),
(195129, '1.25.40.10-FF-003382', NULL, 'Pentatricopeptide repeat-containing protein isoform A', 148, NULL, NULL, 195129),
(195130, '1.25.10.10-FF-002469', NULL, 'Uncharacterized protein', 216, NULL, NULL, 195130),
(195131, '3.40.50.300-FF-005238', NULL, 'Uncharacterized protein', 197, NULL, NULL, 195131),
(195132, '3.30.300.30-FF-000058', NULL, 'Nonribosomal peptide synthase GliP', 99, NULL, NULL, 195132),
(195133, '3.60.40.10-FF-000233', NULL, 'Predicted protein', 288, NULL, NULL, 195133),
(195134, '3.40.50.150-FF-000033', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', 219, NULL, NULL, 195134),
(195135, '1.10.510.10-FF-002098', NULL, NULL, 45, NULL, NULL, 195135),
(195136, '2.60.120.200-FF-000813', NULL, 'Cnx', 123, NULL, NULL, 195136),
(195137, '3.50.50.60-FF-000462', NULL, 'FAD/NAD(P)-binding oxidoreductase family protein', 169, NULL, NULL, 195137),
(195138, '2.60.40.10-FF-001578', NULL, 'immunoglobulin superfamily member 22', 88, NULL, NULL, 195138);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(195139, '2.10.220.10-FF-000211', NULL, 'Proprotein convertase subtilisin/kexin type 5', 51, NULL, NULL, 195139),
(195140, '3.40.50.150-FF-001781', NULL, NULL, 187, NULL, NULL, 195140),
(195141, '1.20.1640.10-FF-000030', NULL, 'Patched homolog (Drosophila), isoform CRA_b', 126, NULL, NULL, 195141),
(195142, '3.40.140.10-FF-000256', NULL, 'Eukaryotic translation initiation factor 3 subunit H', 129, NULL, NULL, 195142),
(195143, '2.60.120.940-FF-000001', NULL, 'Membrane indolylacetylinositol arabinosyltransferase embC', 195, NULL, NULL, 195143),
(195144, '3.60.21.10-FF-000211', NULL, 'Sphingomyelin phosphodiesterase', 89, NULL, NULL, 195144),
(195145, '3.40.50.720-FF-002143', NULL, 'Uncharacterized protein', 91, NULL, NULL, 195145),
(195146, '1.25.10.10-FF-001525', NULL, 'Predicted protein', 118, NULL, NULL, 195146),
(195147, '1.20.58.70-FF-000073', NULL, 'Syntaxin-5', 231, NULL, NULL, 195147),
(195148, '3.80.10.10-FF-003889', NULL, 'AGAP011649-PA', 150, NULL, NULL, 195148),
(195149, '3.30.1460.20-FF-000015', NULL, 'Arp2/3 complex 34 kDa subunit', 172, NULL, NULL, 195149),
(195150, '3.30.70.330-FF-001768', NULL, NULL, 143, NULL, NULL, 195150),
(195151, '3.10.450.40-FF-000025', NULL, 'Primary amine oxidase', 115, NULL, NULL, 195151),
(195152, '3.90.190.10-FF-000512', NULL, 'Uncharacterized protein', 137, NULL, NULL, 195152),
(195153, '1.10.287.110-FF-000079', NULL, 'DnaJ subfamily C member', 89, NULL, NULL, 195153),
(195154, '1.10.10.2330-FF-000019', NULL, NULL, 52, NULL, NULL, 195154),
(195155, '1.20.1250.20-FF-001745', NULL, 'Chromosome 1, whole genome shotgun sequence', 199, NULL, NULL, 195155),
(195156, '2.130.10.10-FF-004895', NULL, 'Protein HIRA', 114, NULL, NULL, 195156),
(195157, '2.170.130.10-FF-000037', NULL, 'SusC/RagA family TonB-linked outer membrane protein', 152, NULL, NULL, 195157),
(195158, '3.10.330.10-FF-000002', NULL, 'ubiquitin fusion degradation protein 1 homolog', 75, NULL, NULL, 195158),
(195159, '3.40.50.300-FF-008548', NULL, 'Mitochondrial GTPase 1', 153, NULL, NULL, 195159),
(195160, '3.30.70.330-FF-002510', NULL, NULL, 71, NULL, NULL, 195160),
(195161, '2.40.270.10-FF-000011', NULL, 'DNA-directed RNA polymerase subunit beta', 148, NULL, NULL, 195161),
(195162, '3.40.50.1460-FF-000043', NULL, 'caspase-3-like isoform X1', 249, NULL, NULL, 195162),
(195163, '3.30.230.10-FF-000411', NULL, 'Predicted protein', 136, NULL, NULL, 195163),
(195164, '3.40.50.1820-FF-000393', NULL, 'N-formylmaleamate deformylase', 254, NULL, NULL, 195164),
(195165, '2.60.120.260-FF-000336', NULL, 'Chromosome 1, whole genome shotgun sequence', 221, NULL, NULL, 195165),
(195166, '2.60.120.680-FF-000013', NULL, 'Transmembrane emp24 domain containing 3', 78, NULL, NULL, 195166),
(195167, '2.10.25.10-FF-000011', NULL, 'Cadherin EGF LAG seven-pass G-type receptor', 46, NULL, NULL, 195167),
(195168, '2.130.10.10-FF-003922', NULL, 'Uncharacterized protein', 261, NULL, NULL, 195168),
(195169, '2.130.10.10-FF-001461', NULL, 'PRP4 pre-mRNA-processing factor 4 homolog (yeast)', 125, NULL, NULL, 195169),
(195170, '3.40.50.1000-FF-000259', NULL, 'Magnesium dependent phosphatase 1', 119, NULL, NULL, 195170),
(195171, '2.60.40.420-FF-000089', NULL, 'Cupredoxin superfamily protein', 103, NULL, NULL, 195171),
(195172, '3.80.10.10-FF-003203', NULL, 'Uncharacterized protein', 224, NULL, NULL, 195172),
(195173, '1.10.287.70-FF-000555', NULL, 'Acid-sensitive two pore domain K+ channel dTASK-7, putative', 191, NULL, NULL, 195173),
(195174, '6.10.250.3320-FF-000002', NULL, 'Proprotein convertase subtilisin/kexin type 1', 44, NULL, NULL, 195174),
(195175, '3.40.50.11050-FF-000002', NULL, 'RTX toxin RtxA', 230, NULL, NULL, 195175),
(195176, '3.30.2130.30-FF-000033', NULL, 'Uncharacterized protein', 185, NULL, NULL, 195176),
(195177, '3.40.50.1820-FF-000185', NULL, 'Alpha/beta-Hydrolases superfamily protein', 188, NULL, NULL, 195177),
(195178, '3.30.160.60-FF-003360', NULL, 'zinc finger and BTB domain-containing protein 42', 28, NULL, NULL, 195178),
(195179, '1.50.10.20-FF-000042', NULL, 'Protein farnesyltransferase subunit beta', 375, NULL, NULL, 195179);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(195180, '1.10.2020.20-FF-000016', NULL, NULL, 120, NULL, NULL, 195180),
(195181, '3.40.50.300-FF-007812', NULL, 'Predicted protein', 286, NULL, NULL, 195181),
(195182, '2.40.110.10-FF-000073', NULL, 'Putative acyl-CoA oxidase family protein', 80, NULL, NULL, 195182),
(195183, '1.20.1510.10-FF-000037', NULL, 'Cation Diffusion Facilitator (CDF) Family', 205, NULL, NULL, 195183),
(195184, '2.170.270.10-FF-000098', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-9 specific SUVH4', 263, NULL, NULL, 195184),
(195185, '1.10.3370.10-FF-000028', NULL, 'SecY subunit domain-containing protein', 468, NULL, NULL, 195185),
(195186, '1.10.3430.10-FF-000073', NULL, 'Uncharacterized protein', 144, NULL, NULL, 195186),
(195187, '1.25.40.20-FF-001018', NULL, 'Multiple ankyrin repeats single KH domain, isoform E', 93, NULL, NULL, 195187),
(195188, '2.40.50.140-FF-001208', NULL, NULL, 87, NULL, NULL, 195188),
(195189, '3.40.1120.10-FF-000001', NULL, 'Ribosomal protein L15', 203, NULL, NULL, 195189),
(195190, '1.20.58.2220-FF-000012', NULL, 'Formin-like protein', 389, NULL, NULL, 195190),
(195191, '1.20.5.1160-FF-000008', NULL, 'Lamin B2', 119, NULL, NULL, 195191),
(195192, '3.40.50.2300-FF-000790', NULL, NULL, 121, NULL, NULL, 195192),
(195193, '2.130.10.10-FF-005171', NULL, 'Uncharacterized protein', 341, NULL, NULL, 195193),
(195194, '1.20.1070.10-FF-002150', NULL, 'Uncharacterized protein', 177, NULL, NULL, 195194),
(195195, '1.25.40.10-FF-004551', NULL, 'Os07g0476200 protein', 222, NULL, NULL, 195195),
(195196, '2.160.20.10-FF-000184', NULL, 'Protein CBG11506', 274, NULL, NULL, 195196),
(195197, '3.90.70.10-FF-000267', NULL, 'Uncharacterized protein', 310, NULL, NULL, 195197),
(195198, '3.20.20.140-FF-000192', NULL, 'Histidinol-phosphatase', 286, NULL, NULL, 195198),
(195199, '3.40.50.300-FF-005558', NULL, 'Uncharacterized protein', 231, NULL, NULL, 195199),
(195200, '1.10.418.40-FF-000014', NULL, 'Uncharacterized protein', 94, NULL, NULL, 195200),
(195201, '1.25.40.20-FF-001794', NULL, 'Uncharacterized protein', 171, NULL, NULL, 195201),
(195202, '1.25.40.10-FF-000397', NULL, 'Pentatricopeptide repeat-containing protein At2g40720', 128, NULL, NULL, 195202),
(195203, '1.10.150.650-FF-000005', NULL, 'Phosphoesterase', 73, NULL, NULL, 195203),
(195204, '1.20.1250.20-FF-000464', NULL, 'Monocarboxylate transporter', 253, NULL, NULL, 195204),
(195205, '1.10.10.750-FF-000023', NULL, 'TBC domain containing protein', 49, NULL, NULL, 195205),
(195206, '3.20.20.70-FF-000094', NULL, 'Imidazole glycerol phosphate synthase hisHF', 313, NULL, NULL, 195206),
(195207, '2.10.25.10-FF-000707', NULL, 'Notch receptor 1b', 41, NULL, NULL, 195207),
(195208, '4.10.1060.10-FF-000047', NULL, 'Uncharacterized protein', 32, NULL, NULL, 195208),
(195209, '1.10.600.10-FF-000059', NULL, 'Phytoene-beta carotene synthase', 329, NULL, NULL, 195209),
(195210, '1.10.510.10-FF-000748', NULL, 'NAK protein kinase', 297, NULL, NULL, 195210),
(195211, '1.10.390.10-FF-000064', NULL, 'Aminopeptidase', 153, NULL, NULL, 195211),
(195212, '2.30.170.40-FF-000003', NULL, '54S ribosomal protein L24', 71, NULL, NULL, 195212),
(195213, '1.50.10.10-FF-000152', NULL, 'alpha-1,2-Mannosidase', 182, NULL, NULL, 195213),
(195214, '2.70.160.11-FF-000087', NULL, 'Predicted protein', 183, NULL, NULL, 195214),
(195215, '3.40.50.300-FF-004378', NULL, 'Adenylyl-sulfate kinase', 210, NULL, NULL, 195215),
(195216, '3.40.50.10490-FF-000120', NULL, NULL, 191, NULL, NULL, 195216),
(195217, '3.40.50.1000-FF-000591', NULL, NULL, 145, NULL, NULL, 195217),
(195218, '2.130.10.10-FF-003259', NULL, 'Uncharacterized protein', 193, NULL, NULL, 195218),
(195219, '3.60.10.10-FF-000282', NULL, 'Inositol 5-phosphatase 4', 352, NULL, NULL, 195219),
(195220, '3.90.190.10-FF-000276', NULL, 'Uncharacterized protein', 206, NULL, NULL, 195220),
(195221, '3.30.70.100-FF-000081', NULL, 'Copper resistance-associated P-type ATPase, putative', 78, NULL, NULL, 195221),
(195222, '1.10.533.10-FF-000200', NULL, 'Uncharacterized protein', 87, NULL, NULL, 195222),
(195223, '2.60.120.200-FF-000004', NULL, 'neurexin-1 isoform X1', 180, NULL, NULL, 195223);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(195224, '3.80.10.10-FF-003546', NULL, 'Uncharacterized protein', 158, NULL, NULL, 195224),
(195225, '3.40.50.2000-FF-000800', NULL, 'Glycosyltransferase', 44, NULL, NULL, 195225),
(195226, '1.25.40.660-FF-000003', NULL, 'Vacuolar protein sorting-associated protein 35', 310, NULL, NULL, 195226),
(195227, '3.30.830.10-FF-000148', NULL, 'Mitochondrial presequence protease', 272, NULL, NULL, 195227),
(195228, '1.25.40.120-FF-000083', NULL, 'Predicted protein', 306, NULL, NULL, 195228),
(195229, '1.10.238.10-FF-001104', NULL, 'Uncharacterized protein', 62, NULL, NULL, 195229),
(195230, '1.10.472.10-FF-000530', NULL, 'Uncharacterized protein', 89, NULL, NULL, 195230),
(195231, '3.80.10.10-FF-000112', NULL, 'F-box and leucine-rich repeat protein 7', 108, NULL, NULL, 195231),
(195232, '2.130.10.10-FF-005272', NULL, 'Uncharacterized protein', 251, NULL, NULL, 195232),
(195233, '2.60.120.260-FF-000544', NULL, 'Netrin-2', 65, NULL, NULL, 195233),
(195234, '2.130.10.10-FF-000269', NULL, 'DDB1- and CUL4-associated factor 13', 104, NULL, NULL, 195234),
(195235, '2.130.10.10-FF-004552', NULL, 'Uncharacterized protein', 218, NULL, NULL, 195235),
(195236, '3.30.160.60-FF-005417', NULL, NULL, 39, NULL, NULL, 195236),
(195237, '1.20.1070.10-FF-001301', NULL, 'Predicted protein', 316, NULL, NULL, 195237),
(195238, '3.30.710.10-FF-000229', NULL, 'Os07g0409500 protein', 167, NULL, NULL, 195238),
(195239, '1.20.120.1750-FF-000126', NULL, 'RBR-type E3 ubiquitin transferase', 97, NULL, NULL, 195239),
(195240, '3.40.50.300-FF-006519', NULL, 'Uncharacterized protein', 111, NULL, NULL, 195240),
(195241, '4.10.400.20-FF-000001', NULL, 'tumor necrosis factor receptor superfamily member 12A', 48, NULL, NULL, 195241),
(195242, '1.10.238.260-FF-000007', NULL, 'Homocitrate synthase', 109, NULL, NULL, 195242),
(195243, '2.120.10.80-FF-000099', NULL, 'Kelch like family member 14', 316, NULL, NULL, 195243),
(195244, '3.30.160.60-FF-005737', NULL, NULL, 30, NULL, NULL, 195244),
(195245, '1.10.10.10-FF-000159', NULL, '26S proteasome non-ATPase regulatory subunit 12', 80, NULL, NULL, 195245),
(195246, '1.20.1250.20-FF-001644', NULL, 'Uncharacterized protein', 482, NULL, NULL, 195246),
(195247, '1.10.238.10-FF-000828', NULL, 'Uncharacterized protein', 93, NULL, NULL, 195247),
(195248, '4.10.60.10-FF-000251', NULL, 'DNA topoisomerase', 48, NULL, NULL, 195248),
(195249, '3.80.20.20-FF-000054', NULL, 'Uncharacterized protein', 197, NULL, NULL, 195249),
(195250, '1.20.200.10-FF-000026', NULL, 'Uncharacterized protein', 187, NULL, NULL, 195250),
(195251, '1.20.120.1070-FF-000006', NULL, 'Translation initiation factor eIF-2B subunit alpha', 101, NULL, NULL, 195251),
(195252, '3.40.50.10330-FF-000005', NULL, 'Sphingosine kinase 2', 151, NULL, NULL, 195252),
(195253, '2.120.10.30-FF-000579', NULL, 'Predicted protein', 174, NULL, NULL, 195253),
(195254, '2.40.160.10-FF-000008', NULL, 'OprD family porin', 398, NULL, NULL, 195254),
(195255, '3.40.50.1700-FF-000031', NULL, 'Beta-glucosidase C', 150, NULL, NULL, 195255),
(195256, '2.10.70.10-FF-000110', NULL, 'Uncharacterized protein, isoform B', 60, NULL, NULL, 195256),
(195257, '1.25.40.10-FF-002297', NULL, 'Pentatricopeptide repeat-containing protein isoform A', 100, NULL, NULL, 195257),
(195258, '3.90.228.10-FF-000061', NULL, 'Poly [ADP-ribose] polymerase', 136, NULL, NULL, 195258),
(195259, '1.20.1250.20-FF-002364', NULL, 'LL-diaminopimelate aminotransferase chloroplastic', 55, NULL, NULL, 195259),
(195260, '3.90.380.10-FF-000004', NULL, '3-ketosteroid-9-alpha-hydroxylase oxygenase subunit', 230, NULL, NULL, 195260),
(195261, '3.40.30.10-FF-001076', NULL, 'Thiol-disulfide oxidoreductase, putative', 149, NULL, NULL, 195261),
(195262, '2.60.40.10-FF-005400', NULL, NULL, 45, NULL, NULL, 195262),
(195263, '3.40.50.10050-FF-000011', NULL, 'Translation initiation factor IF-2', 108, NULL, NULL, 195263),
(195264, '4.10.1240.30-FF-000016', NULL, NULL, 85, NULL, NULL, 195264),
(195265, '1.10.8.10-FF-000068', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 48, NULL, NULL, 195265),
(195266, '2.40.30.10-FF-000297', NULL, 'GM15722', 122, NULL, NULL, 195266); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(195267, '2.40.10.10-FF-000178', NULL, 'Trypsin-like serine protease', 238, NULL, NULL, 195267),
(195268, '3.40.50.150-FF-001438', NULL, NULL, 146, NULL, NULL, 195268),
(195269, '3.40.50.620-FF-000314', NULL, 'ECT1p Ethanolamine-phosphate cytidylyltransferase', 147, NULL, NULL, 195269),
(195270, '3.30.200.20-FF-001205', NULL, NULL, 44, NULL, NULL, 195270),
(195271, '3.30.160.60-FF-000746', NULL, 'hypermethylated in cancer 2 protein-like', 30, NULL, NULL, 195271),
(195272, '3.30.230.70-FF-000047', NULL, 'Exosome complex exonuclease RRP41A', 239, NULL, NULL, 195272),
(195273, '3.40.50.620-FF-000096', NULL, 'Arginine--tRNA ligase chloroplastic/mitochondrial', 342, NULL, NULL, 195273),
(195274, '3.30.70.330-FF-002853', NULL, NULL, 136, NULL, NULL, 195274),
(195275, '1.20.1050.60-FF-000011', NULL, 'Uncharacterized protein', 49, NULL, NULL, 195275),
(195276, '3.30.70.100-FF-000204', NULL, NULL, 59, NULL, NULL, 195276),
(195277, '3.40.1110.10-FF-000175', NULL, 'Copper-exporting P-type ATPase A', 118, NULL, NULL, 195277),
(195278, '1.20.1540.10-FF-000106', NULL, 'Uncharacterized protein', 181, NULL, NULL, 195278),
(195279, '2.30.42.10-FF-000499', NULL, NULL, 117, NULL, NULL, 195279),
(195280, '1.20.20.10-FF-000013', NULL, 'ATP synthase subunit C, putative', 71, NULL, NULL, 195280),
(195281, '3.40.50.150-FF-000696', NULL, 'Hypothetical_protein_-_conserved', 224, NULL, NULL, 195281),
(195282, '3.50.50.60-FF-000703', NULL, 'Flavin-containing monooxygenase', 134, NULL, NULL, 195282),
(195283, '1.10.510.10-FF-004239', NULL, NULL, 306, NULL, NULL, 195283),
(195284, '3.90.132.10-FF-000018', NULL, 'Uncharacterized protein', 138, NULL, NULL, 195284),
(195285, '1.20.1250.20-FF-000008', NULL, 'Galactose-proton symporter (Galactose transporter)', 446, NULL, NULL, 195285),
(195286, '3.80.10.10-FF-004395', NULL, 'Peroxidasin', 165, NULL, NULL, 195286),
(195287, '2.130.10.10-FF-002298', NULL, 'DCAF8 isoform 14', 152, NULL, NULL, 195287),
(195288, '3.30.160.60-FF-002646', NULL, 'Protein suppressor of hairy wing-like Protein', 63, NULL, NULL, 195288),
(195289, '1.25.40.20-FF-001474', NULL, 'Uncharacterized protein', 103, NULL, NULL, 195289),
(195290, '3.30.200.20-FF-000929', NULL, 'Protein CBG16624', 133, NULL, NULL, 195290),
(195291, '3.90.180.10-FF-000005', NULL, 'Quinone oxidoreductase 1', 161, NULL, NULL, 195291),
(195292, '3.40.50.300-FF-003097', NULL, 'Protein CBG04185', 169, NULL, NULL, 195292),
(195293, '1.25.10.10-FF-001300', NULL, 'Calcium binding protein 39 (Predicted), isoform CRA_a', 188, NULL, NULL, 195293),
(195294, '1.20.5.1040-FF-000001', NULL, 'Sensor histidine kinase QseC', 60, NULL, NULL, 195294),
(195295, '3.30.780.10-FF-000054', NULL, 'Translation initiation factor Sui1', 80, NULL, NULL, 195295),
(195296, '3.40.50.300-FF-005890', NULL, 'ATP-dependent DNA helicase', 65, NULL, NULL, 195296),
(195297, '3.30.70.20-FF-000082', NULL, NULL, 84, NULL, NULL, 195297),
(195298, '1.10.10.60-FF-001219', NULL, NULL, 78, NULL, NULL, 195298),
(195299, '2.30.29.30-FF-000513', NULL, 'BRag/Iqsec/Schizo related Arf GEF family member', 136, NULL, NULL, 195299),
(195300, '1.25.40.10-FF-002876', NULL, 'Uncharacterized protein', 247, NULL, NULL, 195300),
(195301, '1.20.5.110-FF-000342', NULL, 'Uncharacterized protein', 74, NULL, NULL, 195301),
(195302, '3.40.50.300-FF-004939', NULL, 'Uncharacterized protein', 276, NULL, NULL, 195302),
(195303, '3.40.50.1000-FF-000489', NULL, NULL, 100, NULL, NULL, 195303),
(195304, '3.90.210.10-FF-000003', NULL, 'ADP-ribosylating toxin CARDS', 240, NULL, NULL, 195304),
(195305, '2.60.40.60-FF-000519', NULL, 'Cadherin-87A', 112, NULL, NULL, 195305),
(195306, '3.60.40.10-FF-000339', NULL, 'Protein phosphatase 2C 29', 129, NULL, NULL, 195306),
(195307, '1.10.10.1670-FF-000001', NULL, 'Heterocyst differentiation control protein', 115, NULL, NULL, 195307),
(195308, '1.10.150.20-FF-000291', NULL, 'DNA-directed RNA polymerase', 177, NULL, NULL, 195308),
(195309, '3.40.50.720-FF-001637', NULL, 'Uncharacterized protein', 322, NULL, NULL, 195309),
(195310, '3.30.160.60-FF-001022', NULL, 'zinc finger and BTB domain-containing protein 17 isoform X1', 27, NULL, NULL, 195310);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(195311, '1.25.10.10-FF-002705', NULL, 'Uncharacterized protein', 54, NULL, NULL, 195311),
(195312, '1.20.1070.10-FF-000121', NULL, 'Histamine H2 receptor', 310, NULL, NULL, 195312),
(195313, '2.60.40.10-FF-005182', NULL, NULL, 93, NULL, NULL, 195313),
(195314, '1.20.1270.10-FF-000018', NULL, 'heat shock 70 kDa protein 4 isoform X1', 87, NULL, NULL, 195314),
(195315, '2.130.10.10-FF-005833', NULL, 'Uncharacterized protein', 376, NULL, NULL, 195315),
(195316, '2.60.40.10-FF-003843', NULL, NULL, 83, NULL, NULL, 195316),
(195317, '3.90.79.20-FF-000014', NULL, 'Nudix (nucleoside diphosphate linked moiety X)-type motif 12', 133, NULL, NULL, 195317),
(195318, '1.10.10.10-FF-000389', NULL, 'Eukaryotic translation initiation factor 3 subunit K', 98, NULL, NULL, 195318),
(195319, '3.20.20.80-FF-000771', NULL, 'Chitinase, putative', 33, NULL, NULL, 195319),
(195320, '1.20.85.10-FF-000005', NULL, 'Uncharacterized protein', 86, NULL, NULL, 195320),
(195321, '3.40.50.10810-FF-000166', NULL, 'Uncharacterized protein', 24, NULL, NULL, 195321),
(195322, '1.10.510.10-FF-002761', NULL, NULL, 141, NULL, NULL, 195322),
(195323, '3.30.450.20-FF-000043', NULL, 'DNA-binding transcriptional regulator TyrR', 109, NULL, NULL, 195323),
(195324, '3.40.850.10-FF-000315', NULL, 'Kinesin-like protein KIN-12F', 63, NULL, NULL, 195324),
(195325, '1.25.40.10-FF-000852', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform A', 105, NULL, NULL, 195325),
(195326, '2.60.40.10-FF-003282', NULL, NULL, 76, NULL, NULL, 195326),
(195327, '3.60.15.10-FF-000253', NULL, 'RNA-metabolising metallo-beta-lactamase family protein', 228, NULL, NULL, 195327),
(195328, '1.10.510.10-FF-001468', NULL, 'Uncharacterized protein', 344, NULL, NULL, 195328),
(195329, '3.30.470.10-FF-000053', NULL, 'Branched-chain-amino-acid aminotransferase 3 chloroplastic', 83, NULL, NULL, 195329),
(195330, '4.10.60.10-FF-000149', NULL, 'DNA-binding protein', 44, NULL, NULL, 195330),
(195331, '3.30.1490.20-FF-000051', NULL, 'Carbamoyl-phosphate synthase large chain', 68, NULL, NULL, 195331),
(195332, '4.10.280.10-FF-000022', NULL, 'Basic helix-loop-helix transcription factor', 58, NULL, NULL, 195332),
(195333, '1.10.287.70-FF-000212', NULL, 'No mechanoreceptor potential C, isoform F', 155, NULL, NULL, 195333),
(195334, '1.10.3200.20-FF-000019', NULL, NULL, 90, NULL, NULL, 195334),
(195335, '1.10.3260.10-FF-000037', NULL, 'DNA ligase', 226, NULL, NULL, 195335),
(195336, '3.40.190.10-FF-000315', NULL, 'Transcriptional regulator LysR', 93, NULL, NULL, 195336),
(195337, '3.10.129.10-FF-000152', NULL, 'Protein CBG07159', 155, NULL, NULL, 195337),
(195338, '2.60.40.1730-FF-000108', NULL, NULL, 138, NULL, NULL, 195338),
(195339, '1.10.1520.10-FF-000057', NULL, 'Uncharacterized protein', 163, NULL, NULL, 195339),
(195340, '3.40.50.620-FF-000657', NULL, 'Predicted protein', 89, NULL, NULL, 195340),
(195341, '3.40.630.30-FF-000569', NULL, 'GCN5-related N-acetyltransferase', 112, NULL, NULL, 195341),
(195342, '1.20.1250.20-FF-001301', NULL, 'Solute carrier organic anion transporter family member', 282, NULL, NULL, 195342),
(195343, '1.10.510.10-FF-003278', NULL, NULL, 100, NULL, NULL, 195343),
(195344, '1.10.10.10-FF-000491', NULL, 'PaaX domain-containing protein, C-domain protein', 76, NULL, NULL, 195344),
(195345, '3.30.160.60-FF-001685', NULL, 'Zinc finger and BTB domain-containing 5', 27, NULL, NULL, 195345),
(195346, '3.30.450.20-FF-000167', NULL, 'Sensory box/GGDEF family protein', 136, NULL, NULL, 195346),
(195347, '1.25.40.10-FF-000976', NULL, 'Pentatricopeptide repeat-containing protein At4g15720', 112, NULL, NULL, 195347),
(195348, '3.50.50.60-FF-000142', NULL, 'FAD dependent oxidoreductase superfamily protein', 215, NULL, NULL, 195348),
(195349, '2.60.40.10-FF-005743', NULL, NULL, 105, NULL, NULL, 195349),
(195350, '2.30.30.100-FF-000071', NULL, 'U6 snRNA-associated Sm-like protein LSm1', 115, NULL, NULL, 195350),
(195351, '2.30.29.30-FF-001132', NULL, 'Uncharacterized protein', 120, NULL, NULL, 195351),
(195352, '3.80.10.10-FF-002720', NULL, 'Receptor-like protein kinase 7', 83, NULL, NULL, 195352);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(195353, '2.10.50.10-FF-000108', NULL, 'Si:ch211-261n11.8', 39, NULL, NULL, 195353),
(195354, '2.30.29.30-FF-000295', NULL, 'pleckstrin homology domain-containing family H member 2 isoform X1', 110, NULL, NULL, 195354),
(195355, '3.10.20.90-FF-000538', NULL, 'Uncharacterized protein', 110, NULL, NULL, 195355),
(195356, '2.130.10.10-FF-000488', NULL, 'Leucine-rich repeat and WD repeat-containing protein 1', 374, NULL, NULL, 195356),
(195357, '3.30.160.60-FF-006356', NULL, NULL, 44, NULL, NULL, 195357),
(195358, '3.30.230.10-FF-000400', NULL, 'Elongation factor G', 109, NULL, NULL, 195358),
(195359, '3.60.20.40-FF-000004', NULL, 'Glutathione hydrolase 1', 210, NULL, NULL, 195359),
(195360, '1.10.510.10-FF-003722', NULL, NULL, 153, NULL, NULL, 195360),
(195361, '2.60.40.2420-FF-000001', NULL, 'Curli assembly protein', 99, NULL, NULL, 195361),
(195362, '2.130.10.10-FF-001781', NULL, 'WD domain, G-beta repeat, putative', 232, NULL, NULL, 195362),
(195363, '1.10.630.10-FF-000780', NULL, 'Protein CBG01387', 138, NULL, NULL, 195363),
(195364, '3.40.718.10-FF-000042', NULL, 'Uncharacterized protein', 70, NULL, NULL, 195364),
(195365, '2.10.25.10-FF-000146', NULL, 'Putative neurogenic locus notch', 38, NULL, NULL, 195365),
(195366, '3.10.129.10-FF-000276', NULL, 'Acyl-CoA thioesterase 11a', 85, NULL, NULL, 195366),
(195367, '1.10.10.60-FF-000477', NULL, 'Pdc2p', 66, NULL, NULL, 195367),
(195368, '2.40.70.10-FF-000075', NULL, 'Putative xylanase inhibitor', 185, NULL, NULL, 195368),
(195369, '1.20.120.350-FF-000042', NULL, 'Potassium voltage-gated channel subfamily V member 2', 162, NULL, NULL, 195369),
(195370, '1.10.238.10-FF-000609', NULL, 'EF-hand domain pair/EF-hand domain/EF hand, putative', 100, NULL, NULL, 195370),
(195371, '2.60.40.60-FF-000851', NULL, 'Cadherin-related 23', 76, NULL, NULL, 195371),
(195372, '3.30.565.10-FF-000469', NULL, 'Uncharacterized protein', 48, NULL, NULL, 195372),
(195373, '2.120.10.80-FF-000234', NULL, 'Uncharacterized protein', 284, NULL, NULL, 195373),
(195374, '2.40.50.140-FF-000242', NULL, 'Mitochondrial ribosomal protein S17,putative', 89, NULL, NULL, 195374),
(195375, '3.30.160.60-FF-002202', NULL, NULL, 28, NULL, NULL, 195375),
(195376, '3.40.50.300-FF-001511', NULL, 'Gliding motility protein MglA', 195, NULL, NULL, 195376),
(195377, '1.10.10.10-FF-000732', NULL, 'Forkhead protein', 102, NULL, NULL, 195377),
(195378, '3.80.20.20-FF-000059', NULL, 'Related to sporulation-specific gene SPS2', 136, NULL, NULL, 195378),
(195379, '2.60.120.330-FF-000037', NULL, 'Blast:1-aminocyclopropane-1-carboxylate oxidase', 342, NULL, NULL, 195379),
(195380, '1.10.1300.10-FF-000069', NULL, 'Uncharacterized protein', 116, NULL, NULL, 195380),
(195381, '1.25.40.10-FF-003045', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 87, NULL, NULL, 195381),
(195382, '3.30.160.60-FF-001578', NULL, 'Zinc finger protein 319', 49, NULL, NULL, 195382),
(195383, '3.30.9.10-FF-000072', NULL, 'Monomeric sarcosine oxidase', 155, NULL, NULL, 195383),
(195384, '1.10.8.10-FF-000203', NULL, 'GD21223', 36, NULL, NULL, 195384),
(195385, '1.10.1220.10-FF-000017', NULL, 'Programmed cell death antitoxin', 76, NULL, NULL, 195385),
(195386, '3.40.50.1820-FF-000409', NULL, 'Carboxypeptidase', 164, NULL, NULL, 195386),
(195387, '3.40.50.300-FF-007924', NULL, 'Uncharacterized protein', 175, NULL, NULL, 195387),
(195388, '3.80.10.10-FF-000567', NULL, 'nischarin isoform X1', 98, NULL, NULL, 195388),
(195389, '3.20.20.80-FF-000557', NULL, 'Uncharacterized protein', 119, NULL, NULL, 195389),
(195390, '3.40.50.10490-FF-000143', NULL, NULL, 122, NULL, NULL, 195390),
(195391, '1.25.40.10-FF-002533', NULL, 'Pentatricopeptide repeat-containing protein At3g16010', 71, NULL, NULL, 195391),
(195392, '3.40.50.720-FF-002587', NULL, 'Uncharacterized protein', 11, NULL, NULL, 195392),
(195393, '3.10.490.10-FF-000047', NULL, 'Uncharacterized protein', 141, NULL, NULL, 195393),
(195394, '2.130.10.10-FF-003254', NULL, 'Transducin, putative', 208, NULL, NULL, 195394),
(195395, '3.30.559.30-FF-000085', NULL, 'NRPS-like enzyme, putative', 152, NULL, NULL, 195395);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(195396, '3.40.850.10-FF-000102', NULL, 'CCAAT-box DNA binding protein subunit B', 383, NULL, NULL, 195396),
(195397, '3.40.640.10-FF-000277', NULL, 'UPF0425 pyridoxal phosphate-dependent protein MJ0158', 217, NULL, NULL, 195397),
(195398, '4.10.1240.10-FF-000033', NULL, 'LOC100145780 protein', 80, NULL, NULL, 195398),
(195399, '2.20.100.10-FF-000104', NULL, 'Papilin', 61, NULL, NULL, 195399),
(195400, '3.30.110.110-FF-000009', NULL, 'Related to MRE11-DNA repair and meiotic recombination protein', 100, NULL, NULL, 195400),
(195401, '1.20.58.60-FF-000750', NULL, 'Microtubule-actin crosslinking factor 1', 260, NULL, NULL, 195401),
(195402, '1.10.150.900-FF-000007', NULL, 'AEL132Wp', 88, NULL, NULL, 195402),
(195403, '2.60.40.1480-FF-000005', NULL, 'Coatomer subunit gamma', 144, NULL, NULL, 195403),
(195404, '2.70.130.10-FF-000022', NULL, 'Insulin-like growth factor 2 receptor', 153, NULL, NULL, 195404),
(195405, '3.30.110.30-FF-000015', NULL, 'Proline--tRNA ligase', 71, NULL, NULL, 195405),
(195406, '3.30.980.10-FF-000029', NULL, 'Uncharacterized protein', 144, NULL, NULL, 195406),
(195407, '3.40.190.10-FF-000759', NULL, 'Glutamate receptor', 35, NULL, NULL, 195407),
(195408, '1.20.80.60-FF-000003', NULL, 'Sorting nexin-27', 59, NULL, NULL, 195408),
(195409, '2.130.10.10-FF-004771', NULL, 'WD repeat domain-containing protein 83 homolog', 155, NULL, NULL, 195409),
(195410, '3.80.10.10-FF-002821', NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', 195, NULL, NULL, 195410),
(195411, '3.40.1190.20-FF-000071', NULL, 'Ribokinase', 333, NULL, NULL, 195411),
(195412, '3.40.50.300-FF-003653', NULL, 'BnaA08g24620D protein', 152, NULL, NULL, 195412),
(195413, '2.40.50.1070-FF-000011', NULL, '23S rRNA (uracil(1939)-C(5))-methyltransferase RlmD', 138, NULL, NULL, 195413),
(195414, '1.10.167.10-FF-000068', NULL, 'Regulator of G-protein signaling rgs-10', 161, NULL, NULL, 195414),
(195415, '1.10.730.10-FF-000170', NULL, 'Methionine--tRNA ligase', 179, NULL, NULL, 195415),
(195416, '2.60.60.20-FF-000060', NULL, NULL, 147, NULL, NULL, 195416),
(195417, '3.40.50.170-FF-000016', NULL, 'Formyltetrahydrofolate deformylase 1, mitochondrial', 208, NULL, NULL, 195417),
(195418, '3.30.70.330-FF-002628', NULL, NULL, 126, NULL, NULL, 195418),
(195419, '1.25.40.180-FF-000174', NULL, NULL, 167, NULL, NULL, 195419),
(195420, '3.40.50.10190-FF-000148', NULL, 'DNA ligase', 112, NULL, NULL, 195420),
(195421, '3.30.565.10-FF-000020', NULL, 'Histidine kinase', 167, NULL, NULL, 195421),
(195422, '3.80.10.10-FF-002714', NULL, 'Receptor-like protein kinase HSL1', 104, NULL, NULL, 195422),
(195423, '1.10.8.1120-FF-000005', NULL, 'Uncharacterized protein', 73, NULL, NULL, 195423),
(195424, '1.20.5.570-FF-000002', NULL, '3-octaprenyl-4-hydroxybenzoate carboxy-lyase', 21, NULL, NULL, 195424),
(195425, '3.40.50.150-FF-001207', NULL, NULL, 168, NULL, NULL, 195425),
(195426, '2.40.70.10-FF-000524', NULL, NULL, 36, NULL, NULL, 195426),
(195427, '3.60.15.10-FF-000034', NULL, 'N-acyl homoserine lactonase family protein', 268, NULL, NULL, 195427),
(195428, '3.30.479.30-FF-000039', NULL, 'Uncharacterized protein', 138, NULL, NULL, 195428),
(195429, '3.40.640.10-FF-000384', NULL, 'Uncharacterized protein', 200, NULL, NULL, 195429),
(195430, '1.20.1250.20-FF-000003', NULL, 'Solute carrier family 17 member 3', 202, NULL, NULL, 195430),
(195431, '3.40.50.300-FF-008543', NULL, 'MutS domain III family protein', 267, NULL, NULL, 195431),
(195432, '3.30.160.60-FF-002197', NULL, 'Metal regulatory transcription factor 1', 48, NULL, NULL, 195432),
(195433, '3.40.720.10-FF-000334', NULL, 'Uncharacterized protein', 115, NULL, NULL, 195433),
(195434, '3.40.50.1820-FF-000398', NULL, 'DUF341 family oxidoreductase, putative', 219, NULL, NULL, 195434),
(195435, '1.20.5.190-FF-000091', NULL, 'FI18026p1', 48, NULL, NULL, 195435),
(195436, '2.10.110.10-FF-000321', NULL, 'Uncharacterized protein', 61, NULL, NULL, 195436),
(195437, '2.30.180.10-FF-000169', NULL, NULL, 176, NULL, NULL, 195437),
(195438, '1.20.1730.10-FF-000037', NULL, 'Uncharacterized protein', 525, NULL, NULL, 195438);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(195439, '3.40.50.12780-FF-000060', NULL, 'Acyl-CoA synthetase', 455, NULL, NULL, 195439),
(195440, '3.30.200.20-FF-001076', NULL, 'Putative tyrosine-protein kinase F09A5.2', 141, NULL, NULL, 195440),
(195441, '1.25.40.10-FF-001914', NULL, 'General transcription factor 3C polypeptide 3-like Protein', 230, NULL, NULL, 195441),
(195442, '3.10.450.40-FF-000048', NULL, NULL, 93, NULL, NULL, 195442),
(195443, '2.120.10.80-FF-000341', NULL, 'Uncharacterized protein', 118, NULL, NULL, 195443),
(195444, '1.10.490.10-FF-000015', NULL, 'GLoBin related', 160, NULL, NULL, 195444),
(195445, '3.20.180.10-FF-000004', NULL, 'Predicted protein', 108, NULL, NULL, 195445),
(195446, '3.40.50.2000-FF-000014', NULL, 'Glycogen [starch] synthase', 193, NULL, NULL, 195446),
(195447, '2.40.50.140-FF-000135', NULL, 'Exosome complex component CSL4', 139, NULL, NULL, 195447),
(195448, '1.10.10.60-FF-000258', NULL, 'HTH-type transcriptional regulator ChbR', 123, NULL, NULL, 195448),
(195449, '3.30.200.20-FF-001868', NULL, 'Uncharacterized protein', 71, NULL, NULL, 195449),
(195450, '2.40.50.140-FF-000927', NULL, NULL, 122, NULL, NULL, 195450),
(195451, '2.30.40.10-FF-000096', NULL, 'N-ethylammeline chlorohydrolase', 59, NULL, NULL, 195451),
(195452, '3.90.550.10-FF-000141', NULL, 'Molybdenum cofactor cytidylyltransferase', 187, NULL, NULL, 195452),
(195453, '3.30.450.20-FF-000279', NULL, 'Two-component sensor histidine kinase', 112, NULL, NULL, 195453),
(195454, '2.130.10.10-FF-002635', NULL, 'Beta-transducin, putative', 298, NULL, NULL, 195454),
(195455, '3.40.50.850-FF-000029', NULL, 'Uncharacterized protein', 108, NULL, NULL, 195455),
(195456, '1.20.1250.20-FF-001189', NULL, 'Major facilitator transporter', 195, NULL, NULL, 195456),
(195457, '3.30.1150.10-FF-000011', NULL, 'Energy transducer TonB', 118, NULL, NULL, 195457),
(195458, '3.30.70.330-FF-000812', NULL, 'Splicing factor U2AF 50 kDa subunit', 21, NULL, NULL, 195458),
(195459, '2.10.50.10-FF-000092', NULL, 'Predicted protein', 48, NULL, NULL, 195459),
(195460, '3.40.50.720-FF-000356', NULL, 'Lambda-crystallin homolog', 187, NULL, NULL, 195460),
(195461, '1.25.40.10-FF-003949', NULL, 'Protein RMD9, mitochondrial', 269, NULL, NULL, 195461),
(195462, '1.20.1560.10-FF-000451', NULL, 'p-GlycoProtein related', 342, NULL, NULL, 195462),
(195463, '1.50.40.10-FF-000103', NULL, 'Mitochondrial glycine transporter', 296, NULL, NULL, 195463),
(195464, '1.10.238.10-FF-001228', NULL, 'EF-hand calcium-binding domain-containing protein 9', 106, NULL, NULL, 195464),
(195465, '1.50.40.10-FF-000092', NULL, 'Mitochondrial tricarboxylate transporter', 56, NULL, NULL, 195465),
(195466, '2.60.120.260-FF-000224', NULL, 'Alpha-L-fucosidase', 113, NULL, NULL, 195466),
(195467, '1.10.220.150-FF-000041', NULL, 'ARF GAP-like zinc finger-containing protein', 133, NULL, NULL, 195467),
(195468, '3.40.30.10-FF-000452', NULL, 'RE10237p', 113, NULL, NULL, 195468),
(195469, '2.60.120.260-FF-000331', NULL, 'Uncharacterized protein', 129, NULL, NULL, 195469),
(195470, '2.30.29.30-FF-000755', NULL, 'Predicted protein', 119, NULL, NULL, 195470),
(195471, '1.10.510.10-FF-001480', NULL, 'Serine/threonine-protein kinase AKL1', 301, NULL, NULL, 195471),
(195472, '2.10.109.10-FF-000025', NULL, 'Signal peptidase I', 142, NULL, NULL, 195472),
(195473, '3.40.50.11740-FF-000001', NULL, 'Hydrogenase maturation factor', 126, NULL, NULL, 195473),
(195474, '1.10.238.10-FF-000031', NULL, 'Short stop, isoform J', 82, NULL, NULL, 195474),
(195475, '1.25.10.10-FF-002020', NULL, 'Uncharacterized protein', 122, NULL, NULL, 195475),
(195476, '2.60.40.10-FF-004804', NULL, NULL, 117, NULL, NULL, 195476),
(195477, '3.40.50.300-FF-001399', NULL, 'RNA helicase', 262, NULL, NULL, 195477),
(195478, '3.40.50.300-FF-008329', NULL, 'Uncharacterized protein', 241, NULL, NULL, 195478),
(195479, '3.50.50.60-FF-001423', NULL, 'Amino acid oxidase fmpA', 119, NULL, NULL, 195479),
(195480, '3.30.56.10-FF-000034', NULL, 'Phenylalanine--tRNA ligase beta subunit', 63, NULL, NULL, 195480),
(195481, '3.30.70.330-FF-001105', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 99, NULL, NULL, 195481);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(195482, '2.30.31.10-FF-000013', NULL, 'GD23514', 72, NULL, NULL, 195482),
(195483, '3.90.1580.10-FF-000030', NULL, 'Uncharacterized protein', 234, NULL, NULL, 195483),
(195484, '3.40.718.10-FF-000065', NULL, 'Isocitrate dehydrogenase [NAD] subunit beta, mitochondrial', 59, NULL, NULL, 195484),
(195485, '2.60.40.10-FF-004911', NULL, NULL, 114, NULL, NULL, 195485),
(195486, '3.40.50.300-FF-008436', NULL, 'Uncharacterized protein', 87, NULL, NULL, 195486),
(195487, '3.50.50.60-FF-001316', NULL, 'Pyridine nucleotide-disulfide oxidoreductase domain-containing protein 1', 79, NULL, NULL, 195487),
(195488, '2.60.40.1180-FF-000022', NULL, 'Glucosidase II alpha subunit', 74, NULL, NULL, 195488),
(195489, '1.10.132.60-FF-000019', NULL, 'DNA polymerase', 169, NULL, NULL, 195489),
(195490, '3.40.50.1460-FF-000020', NULL, 'Clan CD, family C13, asparaginyl endopeptidase-like cysteine peptidase', 265, NULL, NULL, 195490),
(195491, '3.30.420.40-FF-000210', NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase', 66, NULL, NULL, 195491),
(195492, '1.10.510.10-FF-000849', NULL, 'receptor-like cytosolic serine/threonine-protein kinase RBK1 isoform X1', 203, NULL, NULL, 195492),
(195493, '2.10.110.10-FF-000214', NULL, 'FHL1 isoform 15', 43, NULL, NULL, 195493),
(195494, '3.30.420.40-FF-000558', NULL, 'Actin-like protein, putative', 151, NULL, NULL, 195494),
(195495, '3.10.200.10-FF-000004', NULL, 'receptor-type tyrosine-protein phosphatase zeta isoform X1', 270, NULL, NULL, 195495),
(195496, '3.90.70.10-FF-000716', NULL, 'Uncharacterized protein', 199, NULL, NULL, 195496),
(195497, '3.40.190.10-FF-000074', NULL, 'Phosphate-binding protein PstS', 166, NULL, NULL, 195497),
(195498, '1.10.510.10-FF-001249', NULL, 'Uncharacterized protein', 200, NULL, NULL, 195498),
(195499, '2.60.40.10-FF-002983', NULL, 'Titin homolog', 102, NULL, NULL, 195499),
(195500, '3.90.245.10-FF-000027', NULL, 'Inosine/uridine-preferring nucleoside hydrolase', 312, NULL, NULL, 195500),
(195501, '3.30.780.10-FF-000048', NULL, 'Uncharacterized protein', 145, NULL, NULL, 195501),
(195502, '2.60.220.50-FF-000072', NULL, 'Uncharacterized protein', 111, NULL, NULL, 195502),
(195503, '3.40.190.10-FF-000534', NULL, 'ABC-type phosphate transport system, periplasmic component', 95, NULL, NULL, 195503),
(195504, '3.50.50.60-FF-000485', NULL, 'Succinate dehydrogenase [ubiquinone] flavoprotein subunit, mitochondrial', 302, NULL, NULL, 195504),
(195505, '3.50.30.30-FF-000036', NULL, 'E3 ubiquitin-protein ligase RNF13', 131, NULL, NULL, 195505),
(195506, '2.60.40.60-FF-000278', NULL, 'LOW QUALITY PROTEIN: protocadherin-23', 105, NULL, NULL, 195506),
(195507, '1.20.1260.100-FF-000005', NULL, NULL, 153, NULL, NULL, 195507),
(195508, '3.30.70.3270-FF-000004', NULL, 'NADH-quinone oxidoreductase subunit I', 116, NULL, NULL, 195508),
(195509, '2.10.25.10-FF-001539', NULL, 'Uncharacterized protein', 78, NULL, NULL, 195509),
(195510, '3.30.1370.210-FF-000005', NULL, 'Muscleblind, isoform M', 94, NULL, NULL, 195510),
(195511, '3.90.25.10-FF-000067', NULL, 'dTDP-4-dehydrorhamnose reductase', 80, NULL, NULL, 195511),
(195512, '3.30.1370.30-FF-000005', NULL, '30S ribosomal protein S8', 70, NULL, NULL, 195512),
(195513, '3.30.160.60-FF-000162', NULL, 'E3 ubiquitin-protein ligase ZFP91 isoform X1', 25, NULL, NULL, 195513),
(195514, '1.20.1050.60-FF-000005', NULL, 'Alpha-1,2-mannosidase family protein', 96, NULL, NULL, 195514),
(195515, '1.10.287.370-FF-000022', NULL, 'Prefoldin subunit 2, putative', 108, NULL, NULL, 195515),
(195516, '3.40.50.300-FF-007020', NULL, 'Uncharacterized protein', 206, NULL, NULL, 195516),
(195517, '3.40.50.1480-FF-000026', NULL, NULL, 99, NULL, NULL, 195517),
(195518, '2.60.40.10-FF-001241', NULL, 'Hibris, isoform B', 95, NULL, NULL, 195518),
(195519, '1.10.10.1230-FF-000004', NULL, 'Cell division protein ftsI', 29, NULL, NULL, 195519),
(195520, '2.30.42.10-FF-000617', NULL, NULL, 90, NULL, NULL, 195520),
(195521, '3.40.50.150-FF-001444', NULL, NULL, 143, NULL, NULL, 195521),
(195522, '2.60.260.20-FF-000071', NULL, 'DnaJ homolog, isoform A', 84, NULL, NULL, 195522);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(195523, '2.30.29.30-FF-000536', NULL, 'Syntrophin alpha 1', 86, NULL, NULL, 195523),
(195524, '3.40.50.300-FF-007132', NULL, 'Uncharacterized protein', 181, NULL, NULL, 195524),
(195525, '1.10.630.10-FF-000004', NULL, 'cytochrome P450 2D15 isoform X1', 471, NULL, NULL, 195525),
(195526, '1.10.510.10-FF-002873', NULL, NULL, 264, NULL, NULL, 195526),
(195527, '3.20.20.80-FF-000664', NULL, 'Predicted protein', 473, NULL, NULL, 195527),
(195528, '1.25.10.10-FF-003329', NULL, 'Uncharacterized protein', 495, NULL, NULL, 195528),
(195529, '1.25.10.10-FF-003217', NULL, 'Serine/threonine-protein kinase TOR', 580, NULL, NULL, 195529),
(195530, '3.30.70.370-FF-000009', NULL, 'Mitochondrial DNA polymerase I protein C', 127, NULL, NULL, 195530),
(195531, '3.90.120.10-FF-000002', NULL, 'DNA (cytosine-5)-methyltransferase', 68, NULL, NULL, 195531),
(195532, '2.40.50.90-FF-000058', NULL, 'Tudor domain-containing protein 1', 100, NULL, NULL, 195532),
(195533, '2.130.10.10-FF-001005', NULL, 'Related to UTP21-U3 snoRNP protein', 312, NULL, NULL, 195533),
(195534, '1.25.10.10-FF-002817', NULL, 'Predicted protein', 194, NULL, NULL, 195534),
(195535, '1.10.1040.10-FF-000026', NULL, 'UDP-glucose 6-dehydrogenase', 90, NULL, NULL, 195535),
(195536, '2.10.90.10-FF-000105', NULL, 'Uncharacterized protein', 105, NULL, NULL, 195536),
(195537, '3.30.160.60-FF-004563', NULL, NULL, 37, NULL, NULL, 195537),
(195538, '2.60.40.10-FF-002438', NULL, 'Titin homolog', 101, NULL, NULL, 195538),
(195539, '3.30.160.60-FF-005052', NULL, NULL, 45, NULL, NULL, 195539),
(195540, '3.30.1520.10-FF-000175', NULL, 'Protein CBR-SNX-6', 110, NULL, NULL, 195540),
(195541, '3.30.40.10-FF-002286', NULL, 'Uncharacterized protein', 44, NULL, NULL, 195541),
(195542, '3.30.40.10-FF-001667', NULL, 'Uncharacterized protein', 84, NULL, NULL, 195542),
(195543, '1.10.510.10-FF-003385', NULL, NULL, 316, NULL, NULL, 195543),
(195544, '2.60.120.330-FF-000144', NULL, '2-oxoglutarate (2OG) and Fe(II)-dependent oxygenase superfamily protein', 100, NULL, NULL, 195544),
(195545, '1.20.970.10-FF-000005', NULL, 'Glycosyl transferase family protein', 72, NULL, NULL, 195545),
(195546, '3.30.160.60-FF-005075', NULL, NULL, 38, NULL, NULL, 195546),
(195547, '3.90.120.10-FF-000007', NULL, 'DNA (Cytosine-5)-methyltransferase', 37, NULL, NULL, 195547),
(195548, '2.60.40.60-FF-000738', NULL, 'Cadherin-4', 110, NULL, NULL, 195548),
(195549, '1.20.1250.20-FF-000784', NULL, 'MFS drug efflux pump', 188, NULL, NULL, 195549),
(195550, '2.60.40.10-FF-001926', NULL, 'KETtiN (Drosophila actin-binding) homolog', 105, NULL, NULL, 195550),
(195551, '2.60.260.20-FF-000183', NULL, 'Uncharacterized protein', 34, NULL, NULL, 195551),
(195552, '3.40.470.10-FF-000005', NULL, 'Single-strand selective monofunctional uracil DNA glycosylase', 246, NULL, NULL, 195552),
(195553, '3.40.630.30-FF-000221', NULL, 'Aminoglycoside resistance protein', 173, NULL, NULL, 195553),
(195554, '2.130.10.10-FF-003147', NULL, 'Intraflagellar transport protein 80', 174, NULL, NULL, 195554),
(195555, '3.30.230.10-FF-000063', NULL, 'DNA repair protein RadA', 163, NULL, NULL, 195555),
(195556, '1.20.1560.10-FF-000214', NULL, 'Multidrug resistance protein homolog 49', 348, NULL, NULL, 195556),
(195557, '1.20.58.530-FF-000001', NULL, 'Myosin heavy chain', 192, NULL, NULL, 195557),
(195558, '3.30.200.20-FF-000564', NULL, 'Mitogen-activated protein kinase', 93, NULL, NULL, 195558),
(195559, '2.40.30.10-FF-000292', NULL, 'Elongation factor TU mitochondrial1', 93, NULL, NULL, 195559),
(195560, '3.40.50.300-FF-001404', NULL, 'Magnesium chelatase family protein', 321, NULL, NULL, 195560),
(195561, '1.20.1070.10-FF-000469', NULL, 'SERotonin/octopamine receptor family', 339, NULL, NULL, 195561),
(195562, '3.30.70.330-FF-000700', NULL, 'Pre-mRNA splicing factor, putative', 102, NULL, NULL, 195562),
(195563, '2.60.40.10-FF-000752', NULL, 'Putative glycerophosphocholine phosphodiesterase GPCPD1', 125, NULL, NULL, 195563),
(195564, '1.20.5.1180-FF-000003', NULL, 'Spindle pole body component SPC42', 74, NULL, NULL, 195564),
(195565, '3.30.465.10-FF-000080', NULL, 'FAD-linked oxidoreductase', 126, NULL, NULL, 195565);
INSERT INTO "PUBLIC"."MODEL" VALUES
(195566, '1.10.1400.10-FF-000003', NULL, 'Acyl-homoserine lactone acylase PvdQ', 182, NULL, NULL, 195566),
(195567, '3.30.160.60-FF-006249', NULL, NULL, 121, NULL, NULL, 195567),
(195568, '3.10.290.10-FF-000043', NULL, 'Tyrosine--tRNA ligase', 65, NULL, NULL, 195568),
(195569, '1.20.5.340-FF-000057', NULL, 'Unplaced genomic scaffold supercont1.163, whole genome shotgun sequence', 97, NULL, NULL, 195569),
(195570, '1.10.510.10-FF-003615', NULL, NULL, 197, NULL, NULL, 195570),
(195571, '3.40.50.1820-FF-001814', NULL, 'Uncharacterized protein', 110, NULL, NULL, 195571),
(195572, '3.40.50.720-FF-000333', NULL, 'Shikimate 5-dehydrogenase', 168, NULL, NULL, 195572),
(195573, '1.25.10.10-FF-001401', NULL, 'Uncharacterized protein', 277, NULL, NULL, 195573),
(195574, '2.60.40.10-FF-005423', NULL, NULL, 120, NULL, NULL, 195574),
(195575, '2.40.360.10-FF-000001', NULL, 'YjbF family lipoprotein', 195, NULL, NULL, 195575),
(195576, '3.40.50.150-FF-000932', NULL, NULL, 78, NULL, NULL, 195576),
(195577, '2.40.40.10-FF-000011', NULL, NULL, 103, NULL, NULL, 195577),
(195578, '2.40.160.60-FF-000006', NULL, 'Aromatic hydrocarbon degradation protein', 501, NULL, NULL, 195578),
(195579, '1.10.238.10-FF-000716', NULL, 'Ca(2+)-binding ATP:ADP antiporter', 195, NULL, NULL, 195579),
(195580, '3.30.1240.10-FF-000018', NULL, 'HMP-PP phosphatase', 104, NULL, NULL, 195580),
(195581, '1.20.120.1080-FF-000021', NULL, 'ATP-dependent RNA helicase DEAH13', 123, NULL, NULL, 195581),
(195582, '2.60.120.1560-FF-000001', NULL, 'Flocculation protein FLO5', 216, NULL, NULL, 195582),
(195583, '1.20.1290.10-FF-000008', NULL, '4-carboxymuconolactone decarboxylase', 139, NULL, NULL, 195583),
(195584, '2.60.40.10-FF-004799', NULL, NULL, 110, NULL, NULL, 195584),
(195585, '3.50.50.60-FF-000804', NULL, 'Squalene monooxygenase', 242, NULL, NULL, 195585),
(195586, '3.40.50.80-FF-000210', NULL, 'Uncharacterized protein', 119, NULL, NULL, 195586),
(195587, '3.40.367.20-FF-000049', NULL, 'Phosphotransferase', 113, NULL, NULL, 195587),
(195588, '3.80.10.10-FF-001865', NULL, 'Os06g0587900 protein', 231, NULL, NULL, 195588),
(195589, '2.60.40.2130-FF-000015', NULL, 'F-spondin, putative', 79, NULL, NULL, 195589),
(195590, '3.50.50.60-FF-001204', NULL, 'FAD-dependent monooxygenase dbaB', 379, NULL, NULL, 195590),
(195591, '3.20.20.140-FF-000214', NULL, 'AMP deaminase Amd1, putative (AFU_orthologue AFUA_8G02860)', 100, NULL, NULL, 195591),
(195592, '3.30.70.2810-FF-000001', NULL, 'Ribosomal RNA large subunit methyltransferase M', 79, NULL, NULL, 195592),
(195593, '3.30.930.10-FF-000425', NULL, 'Lysine--tRNA ligase', 380, NULL, NULL, 195593),
(195594, '2.30.29.30-FF-000750', NULL, 'Binding protein', 146, NULL, NULL, 195594),
(195595, '3.40.50.150-FF-000718', NULL, 'Cytosine-C5 specific DNA methyltransferase', 66, NULL, NULL, 195595),
(195596, '1.50.10.20-FF-000048', NULL, 'Transcobalamin 1', 287, NULL, NULL, 195596),
(195597, '3.40.1380.40-FF-000001', NULL, 'Undecaprenyl-diphosphooligosaccharide--protein glycotransferase', 159, NULL, NULL, 195597),
(195598, '2.60.40.10-FF-002545', NULL, 'Titin homolog', 104, NULL, NULL, 195598),
(195599, '3.40.950.10-FF-000031', NULL, NULL, 193, NULL, NULL, 195599),
(195600, '1.25.40.10-FF-003157', NULL, 'TPR repeat, putative', 118, NULL, NULL, 195600),
(195601, '2.30.30.40-FF-000587', NULL, 'Uncharacterized protein', 53, NULL, NULL, 195601),
(195602, '3.40.630.30-FF-000676', NULL, 'Uncharacterized N-acetyltransferase C663.13c', 144, NULL, NULL, 195602),
(195603, '1.10.437.10-FF-000044', NULL, 'Uncharacterized protein', 153, NULL, NULL, 195603),
(195604, '2.40.290.10-FF-000006', NULL, 'ATP-dependent DNA helicase 2 subunit KU80', 202, NULL, NULL, 195604),
(195605, '1.20.1090.10-FF-000009', NULL, 'NADH-dependent butanol dehydrogenase', 202, NULL, NULL, 195605),
(195606, '1.10.472.10-FF-000075', NULL, 'Retinoblastoma-related protein 2', 211, NULL, NULL, 195606),
(195607, '1.10.8.590-FF-000010', NULL, NULL, 60, NULL, NULL, 195607),
(195608, '3.40.50.1000-FF-000832', NULL, NULL, 80, NULL, NULL, 195608),
(195609, '3.20.20.30-FF-000003', NULL, 'Pyrimidine monooxygenase RutA', 354, NULL, NULL, 195609);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(195610, '3.40.390.10-FF-000078', NULL, 'Metalloendopeptidase', 229, NULL, NULL, 195610),
(195611, '3.40.50.150-FF-000376', NULL, 'Gamma-tocopherol methyltransferase', 276, NULL, NULL, 195611),
(195612, '3.40.50.80-FF-000215', NULL, 'Uncharacterized protein', 62, NULL, NULL, 195612),
(195613, '3.10.20.90-FF-000645', NULL, 'Serine/threonine-protein kinase WNK2', 58, NULL, NULL, 195613),
(195614, '3.40.850.10-FF-000214', NULL, 'Myosin, heavy polypeptide 9a, non-muscle', 35, NULL, NULL, 195614),
(195615, '3.30.565.10-FF-000368', NULL, 'Hybrid signal transduction histidine kinase I', 159, NULL, NULL, 195615),
(195616, '3.30.190.20-FF-000017', NULL, 'UvrABC system protein A', 111, NULL, NULL, 195616),
(195617, '1.25.40.10-FF-004450', NULL, 'Os05g0370000 protein', 114, NULL, NULL, 195617),
(195618, '2.60.120.200-FF-000341', NULL, 'InTestinal NeureXin-like', 206, NULL, NULL, 195618),
(195619, '1.25.40.180-FF-000179', NULL, 'Uncharacterized protein', 289, NULL, NULL, 195619),
(195620, '2.30.110.10-FF-000114', NULL, 'Uncharacterized protein C1071.11', 178, NULL, NULL, 195620),
(195621, '3.10.20.90-FF-000297', NULL, '30S small subunit ribosomal protein S27Ae', 79, NULL, NULL, 195621),
(195622, '2.20.70.10-FF-000132', NULL, 'U1 snRNP protein', 41, NULL, NULL, 195622),
(195623, '1.25.40.10-FF-004787', NULL, 'Chromosome 1, whole genome shotgun sequence', 175, NULL, NULL, 195623),
(195624, '2.60.60.20-FF-000065', NULL, NULL, 98, NULL, NULL, 195624),
(195625, '3.30.160.60-FF-003944', NULL, NULL, 32, NULL, NULL, 195625),
(195626, '1.25.40.570-FF-000077', NULL, 'COP9 signalosome complex subunit 2', 236, NULL, NULL, 195626),
(195627, '2.130.10.10-FF-002854', NULL, 'Uncharacterized protein', 343, NULL, NULL, 195627),
(195628, '3.40.50.2000-FF-000806', NULL, 'Uncharacterized protein', 148, NULL, NULL, 195628),
(195629, '3.80.10.10-FF-002826', NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', 117, NULL, NULL, 195629),
(195630, '3.80.10.10-FF-003445', NULL, 'Leucine-rich repeat and transmembrane domain-containing protein 2', 53, NULL, NULL, 195630),
(195631, '3.50.50.60-FF-000248', NULL, 'Dihydrolipoyl dehydrogenase', 210, NULL, NULL, 195631),
(195632, '3.40.50.1820-FF-001466', NULL, 'Lecithin-cholesterol acyltransferase-like 4', 178, NULL, NULL, 195632),
(195633, '1.25.40.180-FF-000286', NULL, NULL, 146, NULL, NULL, 195633),
(195634, '2.40.50.140-FF-000354', NULL, 'ATP-dependent RNA helicase DHX8', 82, NULL, NULL, 195634),
(195635, '3.90.550.10-FF-000489', NULL, 'G protein-coupled receptor', 169, NULL, NULL, 195635),
(195636, '3.40.50.620-FF-000758', NULL, 'Uncharacterized protein', 132, NULL, NULL, 195636),
(195637, '3.60.15.10-FF-000146', NULL, 'MBL fold metallo-hydrolase', 247, NULL, NULL, 195637),
(195638, '3.40.50.10810-FF-000278', NULL, 'Uncharacterized protein', 117, NULL, NULL, 195638),
(195639, '2.30.42.10-FF-000370', NULL, NULL, 96, NULL, NULL, 195639),
(195640, '3.40.50.150-FF-001337', NULL, NULL, 196, NULL, NULL, 195640),
(195641, '3.30.1330.30-FF-000008', NULL, 'Protein pelota homolog', 116, NULL, NULL, 195641),
(195642, '3.40.50.11720-FF-000006', NULL, 'DNA mismatch repair protein MLH1', 114, NULL, NULL, 195642),
(195643, '3.80.10.10-FF-002484', NULL, 'Predicted protein', 83, NULL, NULL, 195643),
(195644, '1.25.40.10-FF-002538', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 148, NULL, NULL, 195644),
(195645, '3.30.450.60-FF-000044', NULL, 'Zeta-cop, subunit of COP-I complex', 150, NULL, NULL, 195645),
(195646, '1.20.1070.10-FF-000357', NULL, 'Rhodopsin', 289, NULL, NULL, 195646),
(195647, '3.40.605.10-FF-000027', NULL, 'Aldehyde dehydrogenase, dimeric NADP-preferring', 18, NULL, NULL, 195647),
(195648, '3.90.226.10-FF-000118', NULL, 'Probable enoyl-CoA hydratase echA10', 201, NULL, NULL, 195648),
(195649, '3.90.79.10-FF-000236', NULL, 'Uncharacterized protein', 205, NULL, NULL, 195649),
(195650, '1.10.510.10-FF-003166', NULL, NULL, 168, NULL, NULL, 195650),
(195651, '3.30.230.120-FF-000005', NULL, 'D-glycero-D-manno-heptose 1-phosphate kinase', 348, NULL, NULL, 195651);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(195652, '3.30.200.20-FF-002262', NULL, 'Non-specific serine/threonine protein kinase', 114, NULL, NULL, 195652),
(195653, '3.30.1330.60-FF-000006', NULL, 'Outer membrane protein OmpA', 117, NULL, NULL, 195653),
(195654, '3.30.70.330-FF-000363', NULL, 'RNA-binding motif protein 12', 82, NULL, NULL, 195654),
(195655, '1.20.1280.280-FF-000001', NULL, 'Multifunctional virulence effector protein DrrA', 85, NULL, NULL, 195655),
(195656, '3.10.129.10-FF-000040', NULL, 'Acyl-CoA thioesterase', 126, NULL, NULL, 195656),
(195657, '3.40.1050.10-FF-000029', NULL, 'Carbonic anhydrase', 215, NULL, NULL, 195657),
(195658, '3.40.50.620-FF-000073', NULL, 'Valine--tRNA ligase', 216, NULL, NULL, 195658),
(195659, '1.25.40.20-FF-001451', NULL, '26S proteasome non-ATPase regulatory subunit 10', 131, NULL, NULL, 195659),
(195660, '1.10.10.10-FF-001221', NULL, 'LysR family transcriptional regulator', 92, NULL, NULL, 195660),
(195661, '1.20.120.330-FF-000042', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 151, NULL, NULL, 195661),
(195662, '1.10.510.10-FF-003727', NULL, NULL, 152, NULL, NULL, 195662),
(195663, '3.30.40.10-FF-000037', NULL, 'Cdk-activating kinase assembly factor MAT1, centre', 65, NULL, NULL, 195663),
(195664, '3.90.70.10-FF-000031', NULL, 'Cathepsin B', 315, NULL, NULL, 195664),
(195665, '3.30.70.1450-FF-000003', NULL, 'Putative transport protein YbjL', 63, NULL, NULL, 195665),
(195666, '3.30.160.60-FF-002983', NULL, 'Zinc finger protein 107', 28, NULL, NULL, 195666),
(195667, '1.10.10.160-FF-000054', NULL, 'ATP-dependent DNA helicase srs2', 99, NULL, NULL, 195667),
(195668, '1.10.132.70-FF-000011', NULL, 'Telomerase reverse transcriptase', 232, NULL, NULL, 195668),
(195669, '1.10.10.10-FF-001114', NULL, 'GntR family transcriptional regulator', 118, NULL, NULL, 195669),
(195670, '2.60.120.650-FF-000234', NULL, 'Histone lysine demethylase PHF8', 126, NULL, NULL, 195670),
(195671, '3.20.20.140-FF-000433', NULL, 'Sodium/hydrogen exchanger 2', 151, NULL, NULL, 195671),
(195672, '3.80.10.10-FF-004390', NULL, 'AGAP006974-PA', 166, NULL, NULL, 195672),
(195673, '1.20.1280.50-FF-000160', NULL, 'Uncharacterized protein', 42, NULL, NULL, 195673),
(195674, '3.30.70.330-FF-000705', NULL, 'Splicing factor U2AF 50 kDa subunit', 109, NULL, NULL, 195674),
(195675, '2.40.180.10-FF-000015', NULL, 'Catalase-related peroxidase', 208, NULL, NULL, 195675),
(195676, '2.10.50.10-FF-000103', NULL, 'DNA topoisomerase I', 45, NULL, NULL, 195676),
(195677, '1.10.510.10-FF-003834', NULL, NULL, 109, NULL, NULL, 195677),
(195678, '3.30.420.40-FF-000665', NULL, 'Luminal-binding protein 2', 15, NULL, NULL, 195678),
(195679, '3.30.40.10-FF-001330', NULL, 'Uncharacterized protein', 91, NULL, NULL, 195679),
(195680, '3.40.50.1360-FF-000007', NULL, 'L-fucose operon activator', 159, NULL, NULL, 195680),
(195681, '2.130.10.30-FF-000140', NULL, 'Protein pim1', 448, NULL, NULL, 195681),
(195682, '3.30.1060.10-FF-000021', NULL, NULL, 88, NULL, NULL, 195682),
(195683, '3.40.50.2300-FF-000216', NULL, 'Vomeronasal 2, receptor 111', 274, NULL, NULL, 195683),
(195684, '2.10.25.10-FF-000123', NULL, 'Crumbs homolog 1 (Drosophila)', 38, NULL, NULL, 195684),
(195685, '1.20.58.60-FF-000513', NULL, 'Spectrin repeat containing, nuclear envelope 1a', 107, NULL, NULL, 195685),
(195686, '1.10.10.10-FF-001906', NULL, 'Uncharacterized protein', 79, NULL, NULL, 195686),
(195687, '3.40.50.1700-FF-000036', NULL, 'Putative lipoprotein YbbD', 180, NULL, NULL, 195687),
(195688, '3.40.50.300-FF-006750', NULL, 'Uncharacterized protein', 67, NULL, NULL, 195688),
(195689, '3.30.70.1030-FF-000001', NULL, 'Chlorite dismutase', 99, NULL, NULL, 195689),
(195690, '2.170.300.10-FF-000091', NULL, 'Uncharacterized protein', 84, NULL, NULL, 195690),
(195691, '1.25.40.10-FF-000953', NULL, 'Pentatricopeptide repeat-containing protein', 103, NULL, NULL, 195691),
(195692, '3.90.190.20-FF-000054', NULL, 'Folylpolyglutamate synthase', 169, NULL, NULL, 195692),
(195693, '3.30.160.60-FF-003158', NULL, 'Zinc finger protein 560', 27, NULL, NULL, 195693);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(195694, '3.30.1360.180-FF-000016', NULL, 'Uncharacterized protein', 44, NULL, NULL, 195694),
(195695, '2.40.30.10-FF-000185', NULL, 'FAD/NAD(P)-binding oxidoreductase', 99, NULL, NULL, 195695),
(195696, '1.10.150.50-FF-000070', NULL, 'ArfGAP with RhoGAP domain, ankyrin repeat and PH domain 2', 83, NULL, NULL, 195696),
(195697, '3.30.230.70-FF-000159', NULL, 'Uncharacterized protein', 58, NULL, NULL, 195697),
(195698, '3.90.190.10-FF-000517', NULL, 'Uncharacterized protein', 126, NULL, NULL, 195698),
(195699, '3.30.930.10-FF-000318', NULL, 'Uncharacterized protein', 118, NULL, NULL, 195699),
(195700, '3.30.1330.30-FF-000115', NULL, 'Protein pelota homolog', 90, NULL, NULL, 195700),
(195701, '2.160.20.10-FF-000291', NULL, 'Cell surface protein', 226, NULL, NULL, 195701),
(195702, '2.60.40.150-FF-000328', NULL, 'Phosphoinositide phospholipase C', 132, NULL, NULL, 195702),
(195703, '2.40.10.10-FF-000638', NULL, NULL, 282, NULL, NULL, 195703),
(195704, '3.30.200.20-FF-002481', NULL, 'Non-specific serine/threonine protein kinase', 37, NULL, NULL, 195704),
(195705, '1.10.287.660-FF-000002', NULL, 'Vacuolar protein sorting-associated protein 37A', 78, NULL, NULL, 195705),
(195706, '3.10.129.110-FF-000004', NULL, 'Multifunctional mycocerosic acid synthase', 298, NULL, NULL, 195706),
(195707, '3.40.630.30-FF-000114', NULL, 'Histone acetyltransferase type B catalytic subunit', 133, NULL, NULL, 195707),
(195708, '3.30.70.330-FF-001993', NULL, NULL, 93, NULL, NULL, 195708),
(195709, '3.40.50.11010-FF-000001', NULL, 'Glycosyl transferase family 1', 195, NULL, NULL, 195709),
(195710, '1.10.555.10-FF-000150', NULL, NULL, 255, NULL, NULL, 195710),
(195711, '3.30.160.60-FF-003506', NULL, 'Zinc finger and BTB domain containing 48', 26, NULL, NULL, 195711),
(195712, '1.20.120.1750-FF-000019', NULL, 'RBR-type E3 ubiquitin transferase', 119, NULL, NULL, 195712),
(195713, '3.30.200.20-FF-000345', NULL, 'Calcium/calmodulin-dependent protein kinase type 1B', 91, NULL, NULL, 195713),
(195714, '2.60.34.20-FF-000010', NULL, NULL, 156, NULL, NULL, 195714),
(195715, '3.20.20.60-FF-000113', NULL, 'Oxaloacetate decarboxylase', 285, NULL, NULL, 195715),
(195716, '1.10.1200.170-FF-000001', NULL, 'RNA silencing suppressor', 83, NULL, NULL, 195716),
(195717, '2.60.40.640-FF-000020', NULL, 'Arrestin, Arr2', 205, NULL, NULL, 195717),
(195718, '1.20.1070.10-FF-000918', NULL, 'Uncharacterized protein', 203, NULL, NULL, 195718),
(195719, '3.40.50.300-FF-003872', NULL, 'Multidrug resistance associated protein, putative', 69, NULL, NULL, 195719),
(195720, '1.20.5.990-FF-000004', NULL, 'TNFAIP3 interacting protein 3', 104, NULL, NULL, 195720),
(195721, '1.25.40.70-FF-000044', NULL, 'Phosphatidylinositol 3-kinase vps34', 210, NULL, NULL, 195721),
(195722, '3.40.710.10-FF-000160', NULL, 'D-alanyl-D-alanine carboxypeptidase', 358, NULL, NULL, 195722),
(195723, '2.60.40.1120-FF-000038', NULL, 'M56 family peptidase', 49, NULL, NULL, 195723),
(195724, '1.25.40.10-FF-003831', NULL, 'Uncharacterized protein', 125, NULL, NULL, 195724),
(195725, '2.40.50.120-FF-000028', NULL, 'Tissue Inhibitor of MetalloProtease', 116, NULL, NULL, 195725),
(195726, '3.10.20.90-FF-000302', NULL, 'plexin-B3 isoform X4', 94, NULL, NULL, 195726),
(195727, '3.60.15.10-FF-000039', NULL, 'DNA repair metallo-beta-lactamase family protein', 173, NULL, NULL, 195727),
(195728, '1.20.1070.10-FF-000576', NULL, 'Calcitonin receptor-like protein 1', 315, NULL, NULL, 195728),
(195729, '3.40.140.80-FF-000001', NULL, 'UDP-2,3-diacylglucosamine pyrophosphatase LpxI', 151, NULL, NULL, 195729),
(195730, '2.10.25.10-FF-000702', NULL, 'Uncharacterized protein, isoform C', 42, NULL, NULL, 195730),
(195731, '1.10.510.10-FF-002766', NULL, NULL, 72, NULL, NULL, 195731),
(195732, '2.20.100.10-FF-000211', NULL, 'Thrombospondin type-1 domain-containing protein 7B', 53, NULL, NULL, 195732),
(195733, '2.60.120.330-FF-000032', NULL, 'Gibberellin 20-oxidase-like protein', 293, NULL, NULL, 195733),
(195734, '1.20.1250.20-FF-000441', NULL, 'Solute carrier family 40 protein', 419, NULL, NULL, 195734);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(195735, '3.40.50.1820-FF-000847', NULL, 'Serine carboxypeptidase S28 family protein', 71, NULL, NULL, 195735),
(195736, '1.20.1270.60-FF-000100', NULL, 'Unplaced genomic scaffold supercont2.8, whole genome shotgun sequence', 305, NULL, NULL, 195736),
(195737, '2.30.110.10-FF-000007', NULL, 'General stress protein 26', 138, NULL, NULL, 195737),
(195738, '3.30.2350.20-FF-000018', NULL, 'U2 snRNA/tRNA pseudouridine synthase, putative', 186, NULL, NULL, 195738),
(195739, '3.40.630.30-FF-000333', NULL, 'Putative acetyltransferase', 162, NULL, NULL, 195739),
(195740, '2.10.110.10-FF-000326', NULL, 'Uncharacterized protein', 74, NULL, NULL, 195740),
(195741, '1.10.287.70-FF-000550', NULL, 'Uncharacterized protein', 121, NULL, NULL, 195741),
(195742, '1.10.8.870-FF-000010', NULL, 'Glycerol-3-phosphate dehydrogenase', 134, NULL, NULL, 195742),
(195743, '1.10.1220.10-FF-000012', NULL, 'DNA partition complex ParG', 76, NULL, NULL, 195743),
(195744, '1.10.510.10-FF-003042', NULL, NULL, 215, NULL, NULL, 195744),
(195745, '2.10.90.10-FF-000100', NULL, 'Putative glycoprotein hormone-beta5', 103, NULL, NULL, 195745),
(195746, '3.40.850.10-FF-000091', NULL, 'Kinesin family protein', 269, NULL, NULL, 195746),
(195747, '3.40.630.10-FF-000226', NULL, 'Uncharacterized protein', 177, NULL, NULL, 195747),
(195748, '1.20.1050.10-FF-000018', NULL, 'Glutathione S-transferase U20', 132, NULL, NULL, 195748),
(195749, '3.30.1520.10-FF-000045', NULL, 'Zinc finger CCHC domain-containing protein 2', 126, NULL, NULL, 195749),
(195750, '1.25.40.10-FF-000740', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 105, NULL, NULL, 195750),
(195751, '1.10.101.10-FF-000006', NULL, 'L,D-transpeptidase YcbB', 78, NULL, NULL, 195751),
(195752, '1.10.472.10-FF-000294', NULL, 'Cyclin domain-containing protein', 173, NULL, NULL, 195752),
(195753, '3.60.10.10-FF-000394', NULL, 'Uncharacterized protein', 71, NULL, NULL, 195753),
(195754, '3.40.50.1820-FF-000286', NULL, 'YDL086W-like protein', 241, NULL, NULL, 195754),
(195755, '2.60.120.10-FF-000029', NULL, 'HTH-type transcriptional regulator PuuR', 106, NULL, NULL, 195755),
(195756, '3.40.50.720-FF-000912', NULL, '3-hydroxyisobutyrate dehydrogenase a', 141, NULL, NULL, 195756),
(195757, '1.25.40.20-FF-001013', NULL, 'Predicted protein', 55, NULL, NULL, 195757),
(195758, '3.30.40.10-FF-000829', NULL, 'RING-H2 finger protein ATL70', 89, NULL, NULL, 195758),
(195759, '3.40.50.1820-FF-000162', NULL, 'Enterochelin esterase', 256, NULL, NULL, 195759),
(195760, '2.40.50.100-FF-000022', NULL, 'Exosome complex component RRP4', 56, NULL, NULL, 195760),
(195761, '3.40.309.10-FF-000108', NULL, 'Uncharacterized protein', 139, NULL, NULL, 195761),
(195762, '1.10.10.10-FF-001351', NULL, 'Cyclic nucleotide-binding domain protein', 73, NULL, NULL, 195762),
(195763, '1.20.58.60-FF-000643', NULL, 'Uncharacterized protein', 255, NULL, NULL, 195763),
(195764, '3.40.50.1820-FF-000510', NULL, 'AflJ/ estA/ esterase', 291, NULL, NULL, 195764),
(195765, '1.10.287.130-FF-000074', NULL, 'Histidine kinase', 80, NULL, NULL, 195765),
(195766, '2.120.10.30-FF-000573', NULL, 'Uncharacterized protein', 202, NULL, NULL, 195766),
(195767, '3.40.50.720-FF-002250', NULL, 'Uncharacterized protein', 76, NULL, NULL, 195767),
(195768, '1.25.10.10-FF-002149', NULL, 'Uncharacterized protein', 536, NULL, NULL, 195768),
(195769, '3.20.20.10-FF-000008', NULL, 'Ornithine decarboxylase', 234, NULL, NULL, 195769),
(195770, '3.30.420.10-FF-000111', NULL, 'IS3-like element IS987 family transposase', 160, NULL, NULL, 195770),
(195771, '1.20.920.30-FF-000047', NULL, 'Dynein heavy chain', 143, NULL, NULL, 195771),
(195772, '3.20.20.100-FF-000213', NULL, 'Uncharacterized protein', 103, NULL, NULL, 195772),
(195773, '3.40.50.12230-FF-000030', NULL, 'Uncharacterized protein', 60, NULL, NULL, 195773),
(195774, '3.40.50.2000-FF-000688', NULL, 'DUF3492 domain-containing protein', 284, NULL, NULL, 195774),
(195775, '1.10.10.750-FF-000028', NULL, 'Rab GTPase activating protein, putative', 58, NULL, NULL, 195775),
(195776, '3.90.70.10-FF-000823', NULL, 'Uncharacterized protein', 175, NULL, NULL, 195776);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(195777, '1.10.238.10-FF-000823', NULL, 'Putative calcium-binding protein CML27', 58, NULL, NULL, 195777),
(195778, '3.30.470.20-FF-000174', NULL, 'Glutathione synthetase', 120, NULL, NULL, 195778),
(195779, '1.20.120.1900-FF-000093', NULL, 'Gamma-tubulin complex component', 129, NULL, NULL, 195779),
(195780, '1.20.1070.10-FF-001537', NULL, 'Uncharacterized protein', 181, NULL, NULL, 195780),
(195781, '1.10.3460.10-FF-000018', NULL, 'Photosystem II 22kDa chloroplast protein', 146, NULL, NULL, 195781),
(195782, '2.60.120.260-FF-000443', NULL, 'Laminin subunit beta-1 variant', 127, NULL, NULL, 195782),
(195783, '2.60.120.650-FF-000015', NULL, 'putative lysine-specific demethylase JMJ16', 334, NULL, NULL, 195783),
(195784, '1.25.10.10-FF-002694', NULL, 'Uncharacterized protein', 69, NULL, NULL, 195784),
(195785, '1.20.5.110-FF-000005', NULL, 'Syntaxin 1B', 109, NULL, NULL, 195785),
(195786, '2.60.40.10-FF-001134', NULL, 'Calcium-activated chloride channel regulator 1', 114, NULL, NULL, 195786),
(195787, '3.40.30.10-FF-001071', NULL, 'Predicted protein', 157, NULL, NULL, 195787),
(195788, '4.10.400.10-FF-000010', NULL, 'Low-density lipoprotein receptor-related protein 1', 42, NULL, NULL, 195788),
(195789, '1.10.540.10-FF-000121', NULL, 'Uncharacterized protein', 95, NULL, NULL, 195789),
(195790, '2.60.120.260-FF-000567', NULL, 'Uncharacterized protein', 31, NULL, NULL, 195790),
(195791, '2.40.240.10-FF-000054', NULL, 'Glutamate--tRNA ligase', 84, NULL, NULL, 195791),
(195792, '3.30.70.330-FF-001324', NULL, 'Hypothetical_protein_-_conserved', 83, NULL, NULL, 195792),
(195793, '2.30.30.490-FF-000053', NULL, 'DNA (cytosine-5)-methyltransferase', 116, NULL, NULL, 195793),
(195794, '3.30.40.10-FF-000711', NULL, 'Uncharacterized protein', 59, NULL, NULL, 195794),
(195795, '2.60.200.20-FF-000179', NULL, 'Uncharacterized protein', 140, NULL, NULL, 195795),
(195796, '3.10.100.10-FF-000064', NULL, 'Natural killer cells antigen CD94', 123, NULL, NULL, 195796),
(195797, '1.20.58.670-FF-000026', NULL, NULL, 130, NULL, NULL, 195797),
(195798, '3.40.30.10-FF-000795', NULL, 'Uncharacterized protein', 22, NULL, NULL, 195798),
(195799, '2.60.40.10-FF-003506', NULL, NULL, 89, NULL, NULL, 195799),
(195800, '3.80.10.10-FF-000348', NULL, 'Polygalacturonase inhibitor 1', 305, NULL, NULL, 195800),
(195801, '4.10.1060.10-FF-000042', NULL, 'Zn-finger in Ran binding protein and others/SPRY domain/HECT-domain (Ubiquitin-transferase), putative', 32, NULL, NULL, 195801),
(195802, '2.10.109.10-FF-000020', NULL, 'Signal peptidase I', 132, NULL, NULL, 195802),
(195803, '3.40.50.300-FF-002708', NULL, 'FeS assembly ATPase SufC', 69, NULL, NULL, 195803),
(195804, '3.50.30.30-FF-000031', NULL, 'RING finger protein 215', 66, NULL, NULL, 195804),
(195805, '1.50.40.10-FF-000108', NULL, 'Solute carrier family 25 member 44', 155, NULL, NULL, 195805),
(195806, '3.20.20.70-FF-000335', NULL, 'FO synthase', 320, NULL, NULL, 195806),
(195807, '2.40.50.140-FF-000478', NULL, 'ATP-dependent DNA helicase RecG', 97, NULL, NULL, 195807),
(195808, '3.40.1230.10-FF-000015', NULL, 'Uncharacterized protein', 133, NULL, NULL, 195808),
(195809, '1.20.1540.10-FF-000090', NULL, 'Uncharacterized protein', 210, NULL, NULL, 195809),
(195810, '1.20.1070.10-FF-000126', NULL, 'Probable G-protein coupled receptor 139', 295, NULL, NULL, 195810),
(195811, '1.10.287.20-FF-000001', NULL, 'Cytochrome b-c1 complex subunit 6', 69, NULL, NULL, 195811),
(195812, '1.10.1520.10-FF-000052', NULL, 'Mitochondrial 54S ribosomal protein YmL15', 198, NULL, NULL, 195812),
(195813, '3.40.50.2300-FF-000660', NULL, 'Receptor-type guanylate cyclase gcy-19', 132, NULL, NULL, 195813),
(195814, '3.40.50.720-FF-000805', NULL, '3-beta hydroxysteroid dehydrogenase/isomerase family protein', 333, NULL, NULL, 195814),
(195815, '3.40.630.10-FF-000119', NULL, 'Acetylornithine deacetylase, putative', 192, NULL, NULL, 195815),
(195816, '1.20.120.1760-FF-000011', NULL, 'Cdp-diacylglycerol-inositol 3-phosphatidyltransferase pis', 163, NULL, NULL, 195816),
(195817, '3.30.50.10-FF-000083', NULL, 'GATA transcription factor 27', 83, NULL, NULL, 195817);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(195818, '2.40.50.170-FF-000003', NULL, NULL, 39, NULL, NULL, 195818),
(195819, '1.10.287.70-FF-000443', NULL, 'Uncharacterized protein', 135, NULL, NULL, 195819),
(195820, '3.90.640.10-FF-000030', NULL, 'Heat shock protein HSP70', 84, NULL, NULL, 195820),
(195821, '3.30.565.10-FF-000256', NULL, 'Signal transduction histidine kinase', 141, NULL, NULL, 195821),
(195822, '3.30.200.20-FF-002037', NULL, 'Misshapen like kinase 1', 90, NULL, NULL, 195822),
(195823, '3.30.360.10-FF-000067', NULL, 'Dihydrodipicolinate reductase', 116, NULL, NULL, 195823),
(195824, '3.30.300.210-FF-000004', NULL, 'Spore germination protein, gerC', 149, NULL, NULL, 195824),
(195825, '2.60.450.10-FF-000003', NULL, 'LPS-assembly protein LptD', 159, NULL, NULL, 195825),
(195826, '3.40.50.300-FF-008200', NULL, 'Uncharacterized protein', 74, NULL, NULL, 195826),
(195827, '2.60.40.10-FF-005075', NULL, NULL, 100, NULL, NULL, 195827),
(195828, '1.10.472.80-FF-000163', NULL, NULL, 144, NULL, NULL, 195828),
(195829, '1.10.1040.50-FF-000009', NULL, 'Trifunctional enzyme alpha subunit, mitochondrial-like protein', 216, NULL, NULL, 195829),
(195830, '2.40.320.10-FF-000004', NULL, 'Mediator of RNA polymerase II transcription subunit 18', 190, NULL, NULL, 195830),
(195831, '1.25.40.10-FF-004899', NULL, 'Uncharacterized protein', 87, NULL, NULL, 195831),
(195832, '1.20.1050.90-FF-000003', NULL, 'DNA replication and repair protein RecF', 179, NULL, NULL, 195832),
(195833, '1.10.150.20-FF-000307', NULL, 'DNAJ domain containing protein', 58, NULL, NULL, 195833),
(195834, '1.10.1060.10-FF-000010', NULL, 'Fumarate reductase iron-sulfur subunit', 137, NULL, NULL, 195834),
(195835, '1.20.120.1320-FF-000008', NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase', 94, NULL, NULL, 195835),
(195836, '1.10.10.10-FF-000384', NULL, 'ArsR-family transcriptional regulator', 99, NULL, NULL, 195836),
(195837, '3.90.640.10-FF-000024', NULL, 'Molecular chaperone HscC', 71, NULL, NULL, 195837),
(195838, '2.60.40.10-FF-003950', NULL, NULL, 105, NULL, NULL, 195838),
(195839, '3.40.462.40-FF-000001', NULL, NULL, 271, NULL, NULL, 195839),
(195840, '3.30.260.10-FF-000008', NULL, 'T-complex protein 1 subunit theta', 107, NULL, NULL, 195840),
(195841, '3.20.20.80-FF-000321', NULL, 'Os11g0701600 protein', 133, NULL, NULL, 195841),
(195842, '1.25.40.10-FF-002769', NULL, 'Uncharacterized protein', 171, NULL, NULL, 195842),
(195843, '1.10.287.630-FF-000010', NULL, 'Uncharacterized protein', 50, NULL, NULL, 195843),
(195844, '3.30.390.30-FF-000007', NULL, 'Putative apoptosis-inducing factor 1, mitochondrial', 133, NULL, NULL, 195844),
(195845, '3.30.70.20-FF-000087', NULL, 'NAD-dependent dihydropyrimidine dehydrogenase subunit PreA', 104, NULL, NULL, 195845),
(195846, '3.75.10.10-FF-000029', NULL, NULL, 153, NULL, NULL, 195846),
(195847, '2.30.30.40-FF-000481', NULL, 'YALI0F27643p', 74, NULL, NULL, 195847),
(195848, '3.40.50.1820-FF-001578', NULL, 'Uncharacterized protein', 101, NULL, NULL, 195848),
(195849, '4.10.400.10-FF-000116', NULL, 'Low-density lipoprotein receptor', 39, NULL, NULL, 195849),
(195850, '2.30.42.10-FF-000494', NULL, NULL, 68, NULL, NULL, 195850),
(195851, '3.40.50.970-FF-000048', NULL, 'IlvB (bacterial acetolactate synthase)-like', 181, NULL, NULL, 195851),
(195852, '3.10.10.10-FF-000036', NULL, NULL, 80, NULL, NULL, 195852),
(195853, '2.60.40.150-FF-000766', NULL, 'Predicted protein', 125, NULL, NULL, 195853),
(195854, '3.30.390.10-FF-000001', NULL, 'Enolase', 129, NULL, NULL, 195854),
(195855, '2.60.120.590-FF-000082', NULL, 'Uncharacterized protein', 205, NULL, NULL, 195855),
(195856, '3.30.470.30-FF-000047', NULL, 'mRNA-capping enzyme', 225, NULL, NULL, 195856),
(195857, '2.60.40.10-FF-003618', NULL, NULL, 104, NULL, NULL, 195857),
(195858, '2.60.40.10-FF-004456', NULL, NULL, 107, NULL, NULL, 195858),
(195859, '1.25.40.20-FF-001249', NULL, 'Uncharacterized protein', 236, NULL, NULL, 195859),
(195860, '3.30.1010.10-FF-000074', NULL, 'PIKK family atypical protein kinase', 166, NULL, NULL, 195860),
(195861, '3.10.260.10-FF-000002', NULL, 'APSES transcription factor, putative', 131, NULL, NULL, 195861);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(195862, '1.20.1440.180-FF-000008', NULL, 'Probable serine/threonine-protein kinase irlF', 157, NULL, NULL, 195862),
(195863, '1.10.510.10-FF-000400', NULL, 'MDIS1-interacting receptor like kinase 1', 210, NULL, NULL, 195863),
(195864, '3.40.50.1760-FF-000026', NULL, NULL, 100, NULL, NULL, 195864),
(195865, '1.10.287.130-FF-000186', NULL, 'Bacteriophytochrome', 74, NULL, NULL, 195865),
(195866, '2.130.10.10-FF-002293', NULL, 'DDB1- and CUL4-associated factor 4', 193, NULL, NULL, 195866),
(195867, '2.40.50.140-FF-001203', NULL, NULL, 92, NULL, NULL, 195867),
(195868, '3.30.420.40-FF-001065', NULL, 'Uncharacterized protein', 170, NULL, NULL, 195868),
(195869, '3.30.870.10-FF-000038', NULL, 'Probable tyrosyl-DNA phosphodiesterase', 202, NULL, NULL, 195869),
(195870, '3.30.160.60-FF-004669', NULL, NULL, 32, NULL, NULL, 195870),
(195871, '2.130.10.10-FF-005041', NULL, 'Uncharacterized protein', 288, NULL, NULL, 195871),
(195872, '1.10.472.10-FF-000288', NULL, 'Cyclin-C', 126, NULL, NULL, 195872),
(195873, '3.40.50.620-FF-000545', NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', 401, NULL, NULL, 195873),
(195874, '3.30.160.60-FF-001235', NULL, 'Si:ch211-119o8.6', 28, NULL, NULL, 195874),
(195875, '3.30.40.10-FF-000493', NULL, 'E3 ubiquitin-protein ligase', 48, NULL, NULL, 195875),
(195876, '3.40.50.300-FF-006963', NULL, 'Uncharacterized protein', 221, NULL, NULL, 195876),
(195877, '2.10.220.10-FF-000099', NULL, 'Receptor protein-tyrosine kinase', 95, NULL, NULL, 195877),
(195878, '3.30.230.10-FF-000405', NULL, 'Uncharacterized protein', 88, NULL, NULL, 195878),
(195879, '1.25.40.10-FF-002084', NULL, 'Putative pentatricopeptide repeat-containing protein', 108, NULL, NULL, 195879),
(195880, '2.30.29.30-FF-000300', NULL, 'pleckstrin homology domain-containing family J member 1', 124, NULL, NULL, 195880),
(195881, '3.80.10.10-FF-000005', NULL, 'leucine-rich repeat transmembrane neuronal protein 4', 328, NULL, NULL, 195881),
(195882, '2.60.470.10-FF-000016', NULL, 'Sodium channel protein Nach', 187, NULL, NULL, 195882),
(195883, '3.40.50.1820-FF-001691', NULL, 'Predicted protein', 201, NULL, NULL, 195883),
(195884, '1.20.1250.20-FF-001857', NULL, 'Uncharacterized protein', 129, NULL, NULL, 195884),
(195885, '3.40.50.620-FF-000652', NULL, 'Isoleucyl-tRNA synthetase', 108, NULL, NULL, 195885),
(195886, '3.30.160.60-FF-003490', NULL, NULL, 28, NULL, NULL, 195886),
(195887, '3.10.130.10-FF-000009', NULL, 'Uncharacterized protein', 122, NULL, NULL, 195887),
(195888, '1.20.5.170-FF-000202', NULL, 'Transcription factor AP-1', 68, NULL, NULL, 195888),
(195889, '3.10.580.10-FF-000037', NULL, 'Transmembrane CBS domain transporter', 141, NULL, NULL, 195889),
(195890, '3.80.10.10-FF-003883', NULL, 'Uncharacterized protein', 159, NULL, NULL, 195890),
(195891, '2.170.270.10-FF-000093', NULL, 'Histone-lysine N-methyltransferase', 162, NULL, NULL, 195891),
(195892, '3.90.1150.10-FF-000435', NULL, 'Uncharacterized protein', 25, NULL, NULL, 195892),
(195893, '1.25.10.10-FF-001637', NULL, 'Tubulin folding cofactor D', 450, NULL, NULL, 195893),
(195894, '2.60.40.2840-FF-000003', NULL, 'Phosphatidylinositol 4,5-bisphosphate 5-phosphatase A', 110, NULL, NULL, 195894),
(195895, '3.90.660.20-FF-000028', NULL, 'Protoporphyrinogen oxidase', 47, NULL, NULL, 195895),
(195896, '1.25.40.20-FF-000052', NULL, 'Ankyrin repeat domain-containing protein 12', 139, NULL, NULL, 195896),
(195897, '3.90.190.10-FF-000169', NULL, 'Phosphotyrosine protein phosphatase PtpB', 242, NULL, NULL, 195897),
(195898, '3.40.630.10-FF-000451', NULL, 'Uncharacterized protein', 171, NULL, NULL, 195898),
(195899, '2.30.30.30-FF-000152', NULL, '60S ribosomal protein L26-1', 64, NULL, NULL, 195899),
(195900, '3.80.10.10-FF-001753', NULL, 'Putative disease resistance protein At3g14460', 170, NULL, NULL, 195900),
(195901, '3.30.160.60-FF-005524', NULL, NULL, 22, NULL, NULL, 195901),
(195902, '3.30.160.60-FF-003383', NULL, NULL, 28, NULL, NULL, 195902),
(195903, '1.10.10.2330-FF-000014', NULL, NULL, 54, NULL, NULL, 195903),
(195904, '2.60.40.2860-FF-000009', NULL, 'Transmission-blocking target antigen S230', 158, NULL, NULL, 195904); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(195905, '3.40.50.300-FF-002692', NULL, 'Zinc finger, NFX1-type-containing 1', 201, NULL, NULL, 195905),
(195906, '3.20.20.70-FF-000223', NULL, 'Triosephosphate isomerase', 222, NULL, NULL, 195906),
(195907, '3.80.10.10-FF-003990', NULL, 'Toll-like protein', 156, NULL, NULL, 195907),
(195908, '3.30.60.60-FF-000019', NULL, 'Histone acetyltransferase', 59, NULL, NULL, 195908),
(195909, '3.40.430.10-FF-000008', NULL, 'Dihydrofolate reductase', 172, NULL, NULL, 195909),
(195910, '3.40.50.800-FF-000043', NULL, 'Histidine--tRNA ligase', 85, NULL, NULL, 195910),
(195911, '2.60.40.10-FF-001477', NULL, 'Titin b', 103, NULL, NULL, 195911),
(195912, '3.30.300.30-FF-000064', NULL, 'Possible fatty-acid-CoA ligase fadD10', 116, NULL, NULL, 195912),
(195913, '3.40.532.10-FF-000009', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 235, NULL, NULL, 195913),
(195914, '1.10.10.1200-FF-000012', NULL, 'Non-structural maintenance of chromosome element 3', 80, NULL, NULL, 195914),
(195915, '2.130.10.110-FF-000001', NULL, 'Clathrin heavy chain', 364, NULL, NULL, 195915),
(195916, '3.30.2460.20-FF-000009', NULL, 'Protein Wnt-3a', 40, NULL, NULL, 195916),
(195917, '3.40.33.10-FF-000037', NULL, 'Uncharacterized protein', 149, NULL, NULL, 195917),
(195918, '2.120.10.30-FF-000348', NULL, 'NHL repeat-containing protein 2', 123, NULL, NULL, 195918),
(195919, '2.60.120.200-FF-000009', NULL, 'Thrombospondin 1', 215, NULL, NULL, 195919),
(195920, '3.10.450.50-FF-000034', NULL, 'Unplaced genomic scaffold supercont2.5, whole genome shotgun sequence', 148, NULL, NULL, 195920),
(195921, '2.130.10.10-FF-001674', NULL, 'Utp13 specific WD40 associated domain containing protein', 246, NULL, NULL, 195921),
(195922, '3.30.420.40-FF-000446', NULL, 'STCH (Truncated HSP) family', 202, NULL, NULL, 195922),
(195923, '1.20.1070.10-FF-001981', NULL, 'Uncharacterized protein', 167, NULL, NULL, 195923),
(195924, '3.30.1520.10-FF-000051', NULL, 'Phospholipase', 140, NULL, NULL, 195924),
(195925, '2.60.34.10-FF-000131', NULL, 'Uncharacterized protein', 92, NULL, NULL, 195925),
(195926, '2.30.42.10-FF-000263', NULL, 'Multiple PDZ domain protein', 106, NULL, NULL, 195926),
(195927, '3.90.70.10-FF-000374', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 345, NULL, NULL, 195927),
(195928, '3.40.50.300-FF-000331', NULL, 'Arginine ABC transporter ATP-binding protein ArtP', 241, NULL, NULL, 195928),
(195929, '3.30.160.60-FF-005288', NULL, NULL, 57, NULL, NULL, 195929),
(195930, '2.30.29.30-FF-001025', NULL, 'Villidin', 132, NULL, NULL, 195930),
(195931, '1.20.120.220-FF-000014', NULL, 'ATP synthase F1F0 subunit 6', 169, NULL, NULL, 195931),
(195932, '1.20.1560.10-FF-000900', NULL, 'Uncharacterized protein', 210, NULL, NULL, 195932),
(195933, '3.40.50.1820-FF-000853', NULL, 'Serine peptidase, putative', 307, NULL, NULL, 195933),
(195934, '1.25.40.20-FF-000962', NULL, 'Uncharacterized protein', 142, NULL, NULL, 195934),
(195935, '3.40.190.10-FF-000422', NULL, 'LysR family transcriptional regulator', 106, NULL, NULL, 195935),
(195936, '3.40.800.10-FF-000043', NULL, NULL, 274, NULL, NULL, 195936),
(195937, '2.130.10.10-FF-002186', NULL, 'WD repeat domain 34', 259, NULL, NULL, 195937),
(195938, '3.40.50.720-FF-000120', NULL, 'D-amino-acid oxidase', 182, NULL, NULL, 195938),
(195939, '1.10.1200.30-FF-000005', NULL, 'Uncharacterized protein', 87, NULL, NULL, 195939),
(195940, '3.40.850.10-FF-000445', NULL, 'Uncharacterized protein', 110, NULL, NULL, 195940),
(195941, '3.30.70.330-FF-002381', NULL, NULL, 100, NULL, NULL, 195941),
(195942, '1.20.1260.10-FF-000063', NULL, 'Ferritin', 134, NULL, NULL, 195942),
(195943, '3.30.160.60-FF-005400', NULL, NULL, 21, NULL, NULL, 195943),
(195944, '3.40.50.720-FF-002149', NULL, 'Uncharacterized protein', 88, NULL, NULL, 195944),
(195945, '1.10.510.10-FF-003273', NULL, NULL, 104, NULL, NULL, 195945),
(195946, '3.30.70.1440-FF-000017', NULL, NULL, 102, NULL, NULL, 195946),
(195947, '1.20.1250.20-FF-000571', NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', 206, NULL, NULL, 195947),
(195948, '3.40.1380.10-FF-000003', NULL, 'ATP synthase subunit gamma', 203, NULL, NULL, 195948);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(195949, '3.20.20.60-FF-000107', NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', 262, NULL, NULL, 195949),
(195950, '3.40.50.300-FF-007475', NULL, 'Structural maintenance of chromosomes protein 5', 237, NULL, NULL, 195950),
(195951, '1.10.510.10-FF-002654', NULL, NULL, 55, NULL, NULL, 195951),
(195952, '1.10.287.70-FF-000662', NULL, 'Uncharacterized protein', 128, NULL, NULL, 195952),
(195953, '3.30.1640.10-FF-000099', NULL, 'Uncharacterized protein', 66, NULL, NULL, 195953),
(195954, '1.20.1160.20-FF-000013', NULL, 'PDZ domain containing 7', 71, NULL, NULL, 195954),
(195955, '3.40.50.300-FF-006856', NULL, 'Chromosome 1, whole genome shotgun sequence', 333, NULL, NULL, 195955),
(195956, '1.20.5.170-FF-000096', NULL, 'BZIP transcription factor bZIP46', 57, NULL, NULL, 195956),
(195957, '1.20.1070.10-FF-000233', NULL, 'CLUMA_CG012980, isoform A', 121, NULL, NULL, 195957),
(195958, '2.60.40.10-FF-003731', NULL, NULL, 106, NULL, NULL, 195958),
(195959, '3.30.160.60-FF-000510', NULL, 'Zinc finger protein', 28, NULL, NULL, 195959),
(195960, '1.20.58.60-FF-000064', NULL, 'Short stop, isoform K', 119, NULL, NULL, 195960),
(195961, '3.20.20.240-FF-000002', NULL, 'Methylmalonyl-CoA mutase, mitochondrial', 569, NULL, NULL, 195961),
(195962, '2.60.40.60-FF-000626', NULL, 'Protocadherin 12', 129, NULL, NULL, 195962),
(195963, '3.30.160.60-FF-002539', NULL, 'GD10244', 25, NULL, NULL, 195963),
(195964, '1.20.910.10-FF-000007', NULL, 'Bifunctional TENA-E protein', 218, NULL, NULL, 195964),
(195965, '3.40.50.300-FF-003080', NULL, 'Small GTPase EhRabX10, putative', 186, NULL, NULL, 195965),
(195966, '3.90.176.10-FF-000001', NULL, 'NAD(P)(+)--arginine ADP-ribosyltransferase', 233, NULL, NULL, 195966),
(195967, '2.30.30.40-FF-000374', NULL, 'Putative purine-binding chemotaxis protein Chew', 58, NULL, NULL, 195967),
(195968, '1.20.1250.20-FF-000239', NULL, 'Probable L-galactonate transporter', 199, NULL, NULL, 195968),
(195969, '3.40.1170.60-FF-000053', NULL, NULL, 57, NULL, NULL, 195969),
(195970, '1.10.520.10-FF-000007', NULL, 'L-ascorbate peroxidase S chloroplastic/mitochondrial', 130, NULL, NULL, 195970),
(195971, '3.40.1110.10-FF-000068', NULL, 'Phospholipid-transporting ATPase', 157, NULL, NULL, 195971),
(195972, '1.10.246.90-FF-000017', NULL, 'Exocyst complex component SEC5A', 90, NULL, NULL, 195972),
(195973, '2.60.40.1450-FF-000007', NULL, 'Uncharacterized protein', 110, NULL, NULL, 195973),
(195974, '3.40.50.10330-FF-000011', NULL, 'Diacylglycerol kinase', 145, NULL, NULL, 195974),
(195975, '3.30.230.10-FF-000187', NULL, 'Os02g0543300 protein', 184, NULL, NULL, 195975),
(195976, '2.30.30.210-FF-000008', NULL, 'Ribonuclease P protein subunit p29', 95, NULL, NULL, 195976),
(195977, '3.40.50.10050-FF-000016', NULL, 'Uncharacterized protein', 111, NULL, NULL, 195977),
(195978, '2.60.40.10-FF-002202', NULL, 'CD48 antigen', 81, NULL, NULL, 195978),
(195979, '2.20.110.10-FF-000055', NULL, NULL, 49, NULL, NULL, 195979),
(195980, '3.40.50.200-FF-000071', NULL, 'Peptidase S8', 387, NULL, NULL, 195980),
(195981, '1.20.1250.10-FF-000112', NULL, NULL, 176, NULL, NULL, 195981),
(195982, '1.25.40.10-FF-003606', NULL, 'Uncharacterized protein', 128, NULL, NULL, 195982),
(195983, '1.20.920.10-FF-000053', NULL, 'Blast:E3 ubiquitin-protein ligase TRIM33', 126, NULL, NULL, 195983),
(195984, '3.40.50.1010-FF-000144', NULL, 'WGS project CABT00000000 data, contig 2.11', 204, NULL, NULL, 195984),
(195985, '2.130.10.10-FF-002747', NULL, 'Uncharacterized protein', 385, NULL, NULL, 195985),
(195986, '3.90.1600.10-FF-000072', NULL, 'Uncharacterized protein', 182, NULL, NULL, 195986),
(195987, '3.60.110.10-FF-000093', NULL, NULL, 82, NULL, NULL, 195987),
(195988, '3.30.342.10-FF-000014', NULL, 'DNA polymerase', 167, NULL, NULL, 195988),
(195989, '1.20.58.60-FF-000188', NULL, 'Uncharacterized protein, isoform D', 283, NULL, NULL, 195989),
(195990, '1.20.1070.10-FF-001762', NULL, 'Uncharacterized protein', 70, NULL, NULL, 195990),
(195991, '3.30.1360.10-FF-000061', NULL, 'RNA polymerase Rpb3/Rpb11 dimerisation domain containing protein', 100, NULL, NULL, 195991);
INSERT INTO "PUBLIC"."MODEL" VALUES
(195992, '3.30.160.60-FF-002871', NULL, 'Zinc finger protein 142', 88, NULL, NULL, 195992),
(195993, '3.40.1360.10-FF-000002', NULL, 'DNA primase', 127, NULL, NULL, 195993),
(195994, '1.10.510.10-FF-004346', NULL, NULL, 122, NULL, NULL, 195994),
(195995, '3.30.70.1230-FF-000162', NULL, 'Predicted protein', 210, NULL, NULL, 195995),
(195996, '3.80.10.10-FF-000117', NULL, 'leucine-rich repeat-containing protein 17', 167, NULL, NULL, 195996),
(195997, '3.30.420.10-FF-000342', NULL, 'Uncharacterized protein', 183, NULL, NULL, 195997),
(195998, '1.25.40.20-FF-001581', NULL, 'Uncharacterized protein', 149, NULL, NULL, 195998),
(195999, '1.25.10.10-FF-000912', NULL, 'Adaptin N terminal region family protein', 583, NULL, NULL, 195999),
(196000, '2.40.30.170-FF-000022', NULL, 'Efflux transporter periplasmic adaptor subunit', 78, NULL, NULL, 196000),
(196001, '3.80.30.20-FF-000009', NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase', 233, NULL, NULL, 196001),
(196002, '2.60.120.650-FF-000122', NULL, 'GM16352', 245, NULL, NULL, 196002),
(196003, '2.40.70.10-FF-000182', NULL, 'Beta-secretase 1', 252, NULL, NULL, 196003),
(196004, '1.25.10.10-FF-002256', NULL, 'Condensin complex subunit 1', 360, NULL, NULL, 196004),
(196005, '2.60.120.10-FF-000136', NULL, 'Mannose-6-phosphate isomerase', 110, NULL, NULL, 196005),
(196006, '3.30.200.20-FF-000912', NULL, 'Uncharacterized protein', 77, NULL, NULL, 196006),
(196007, '2.20.70.10-FF-000238', NULL, 'Peptidyl-prolyl cis-trans isomerase', 44, NULL, NULL, 196007),
(196008, '3.40.50.11850-FF-000011', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', 115, NULL, NULL, 196008),
(196009, '3.60.10.10-FF-000287', NULL, 'Predicted protein', 215, NULL, NULL, 196009),
(196010, '2.60.40.10-FF-000965', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', 89, NULL, NULL, 196010),
(196011, '2.40.50.40-FF-000066', NULL, 'Protein CHROMATIN REMODELING 4', 79, NULL, NULL, 196011),
(196012, '3.10.450.240-FF-000033', NULL, 'Uncharacterized protein', 74, NULL, NULL, 196012),
(196013, '1.10.490.60-FF-000002', NULL, NULL, 93, NULL, NULL, 196013),
(196014, '3.40.50.300-FF-001056', NULL, 'RAB1A, member RAS oncogene family', 61, NULL, NULL, 196014),
(196015, '2.60.120.260-FF-000674', NULL, 'Beta-galactosidase precursor, putative', 77, NULL, NULL, 196015),
(196016, '2.30.29.30-FF-000188', NULL, 'Myotubularin related protein 12', 116, NULL, NULL, 196016),
(196017, '3.30.160.60-FF-004905', NULL, NULL, 22, NULL, NULL, 196017),
(196018, '3.30.200.20-FF-001312', NULL, 'Serine/threonine protein kinase', 87, NULL, NULL, 196018),
(196019, '1.25.40.660-FF-000008', NULL, 'Vacuolar protein sorting protein 35-2, putative', 275, NULL, NULL, 196019),
(196020, '2.120.10.30-FF-000129', NULL, 'CRE-LIN-41 protein', 140, NULL, NULL, 196020),
(196021, '3.40.50.1820-FF-000055', NULL, 'Carboxypeptidase', 427, NULL, NULL, 196021),
(196022, '2.30.30.40-FF-000593', NULL, 'Tyrosine-protein kinase', 61, NULL, NULL, 196022),
(196023, '1.10.3430.10-FF-000067', NULL, 'Predicted protein', 52, NULL, NULL, 196023),
(196024, '3.20.100.10-FF-000011', NULL, 'mRNA-capping enzyme subunit beta', 311, NULL, NULL, 196024),
(196025, '2.130.10.10-FF-003366', NULL, 'Rho guanine nucleotide exchange factor 10-like', 311, NULL, NULL, 196025),
(196026, '3.30.70.3490-FF-000047', NULL, NULL, 71, NULL, NULL, 196026),
(196027, '1.20.1070.10-FF-000014', NULL, 'Kappa-type opioid receptor 1', 285, NULL, NULL, 196027),
(196028, '1.10.8.60-FF-000515', NULL, 'ATPase, AAA family protein', 54, NULL, NULL, 196028),
(196029, '3.40.50.720-FF-002481', NULL, 'Malate oxidoreductase, NAD-dependent', 210, NULL, NULL, 196029),
(196030, '1.20.1050.10-FF-000249', NULL, 'Uncharacterized protein', 40, NULL, NULL, 196030),
(196031, '3.40.50.300-FF-001635', NULL, 'Disease resistance protein Pik-2', 156, NULL, NULL, 196031),
(196032, '3.40.10.10-FF-000001', NULL, 'DNA-3-methyladenine glycosylase 2', 74, NULL, NULL, 196032),
(196033, '1.10.630.10-FF-000235', NULL, 'Cytochrome P450 family 93 subfamily D polypeptide 1', 164, NULL, NULL, 196033);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(196034, '3.40.50.2000-FF-000795', NULL, 'Alpha,alpha-trehalose-phosphate synthase [UDP-forming] B', 205, NULL, NULL, 196034),
(196035, '4.10.280.10-FF-000235', NULL, 'Transcription factor bHLH130', 65, NULL, NULL, 196035),
(196036, '1.20.1250.20-FF-001751', NULL, 'Proton:peptide symporter POT family', 268, NULL, NULL, 196036),
(196037, '2.130.10.10-FF-003708', NULL, 'Uncharacterized protein', 267, NULL, NULL, 196037),
(196038, '3.20.20.70-FF-000442', NULL, 'tRNA-dihydrouridine synthase', 236, NULL, NULL, 196038),
(196039, '3.40.30.10-FF-000014', NULL, 'Tau class glutathione S-transferase', 87, NULL, NULL, 196039),
(196040, '3.40.50.300-FF-005906', NULL, 'DNA replication and repair protein RecF', 145, NULL, NULL, 196040),
(196041, '1.25.10.10-FF-001531', NULL, 'Uncharacterized protein', 128, NULL, NULL, 196041),
(196042, '3.30.160.60-FF-001814', NULL, 'Zinc finger protein 572', 30, NULL, NULL, 196042),
(196043, '1.20.1160.11-FF-000005', NULL, 'SIN3 transcription regulator family member B', 85, NULL, NULL, 196043),
(196044, '3.20.140.10-FF-000007', NULL, 'Nicotinate phosphoribosyltransferase', 197, NULL, NULL, 196044),
(196045, '2.60.40.10-FF-004675', NULL, NULL, 91, NULL, NULL, 196045),
(196046, '2.10.25.10-FF-001652', NULL, 'Uncharacterized protein', 74, NULL, NULL, 196046),
(196047, '3.40.640.10-FF-000165', NULL, 'Protein CBG17192', 258, NULL, NULL, 196047),
(196048, '1.25.40.10-FF-002645', NULL, 'Protein CTR9-like protein', 240, NULL, NULL, 196048),
(196049, '3.40.1160.10-FF-000021', NULL, 'Glutamate 5-kinase', 62, NULL, NULL, 196049),
(196050, '3.30.60.190-FF-000010', NULL, 'Zinc finger, HIT-type-containing 3', 45, NULL, NULL, 196050),
(196051, '1.20.200.10-FF-000032', NULL, 'Uncharacterized protein', 176, NULL, NULL, 196051),
(196052, '2.10.25.10-FF-000359', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', 35, NULL, NULL, 196052),
(196053, '3.90.55.10-FF-000001', NULL, 'Biotin sulfoxide reductase 2', 76, NULL, NULL, 196053),
(196054, '3.10.20.870-FF-000025', NULL, NULL, 71, NULL, NULL, 196054),
(196055, '3.30.420.390-FF-000005', NULL, 'Related to MIP1-DNA-directed DNA polymerase gamma catalytic subunit, mitochondrial', 224, NULL, NULL, 196055),
(196056, '1.20.120.1080-FF-000015', NULL, 'Putative ATP-dependent RNA helicase DHX33', 108, NULL, NULL, 196056),
(196057, '3.10.350.10-FF-000104', NULL, 'Membrane-bound lytic murein transglycosylase D', 57, NULL, NULL, 196057),
(196058, '3.50.50.60-FF-001210', NULL, 'Uncharacterized protein', 475, NULL, NULL, 196058),
(196059, '2.60.40.10-FF-000061', NULL, 'Dyslexia-associated protein KIAA0319 homolog', 96, NULL, NULL, 196059),
(196060, '3.40.50.880-FF-000027', NULL, 'Anthranilate synthase beta subunit 1', 194, NULL, NULL, 196060),
(196061, '1.10.510.10-FF-001018', NULL, 'Related to CBK1-Serine/threonine protein kinase involved in cell wall biosynthesis', 99, NULL, NULL, 196061),
(196062, '3.80.10.10-FF-002933', NULL, 'Leucine-rich repeat receptor-like protein kinase PEPR1', 113, NULL, NULL, 196062),
(196063, '3.40.50.300-FF-003765', NULL, 'ATP-binding cassette sub-family A member 3-like Protein', 90, NULL, NULL, 196063),
(196064, '3.90.550.10-FF-000596', NULL, 'Uncharacterized protein', 230, NULL, NULL, 196064),
(196065, '2.60.40.10-FF-003057', NULL, 'AAEL000536-PA', 80, NULL, NULL, 196065),
(196066, '3.40.190.120-FF-000003', NULL, 'Glycine betaine/L-proline ABC transporter, periplasmic substrate-binding protein', 112, NULL, NULL, 196066),
(196067, '1.10.1200.60-FF-000003', NULL, '50S ribosomal protein L19e', 60, NULL, NULL, 196067),
(196068, '3.40.50.150-FF-000140', NULL, 'Calmodulin-lysine N-methyltransferase', 264, NULL, NULL, 196068),
(196069, '1.10.1070.11-FF-000068', NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', 190, NULL, NULL, 196069),
(196070, '2.60.120.20-FF-000015', NULL, 'Genome polyprotein', 222, NULL, NULL, 196070),
(196071, '3.40.50.300-FF-004041', NULL, 'ATP-dependent RNA helicase A', 172, NULL, NULL, 196071),
(196072, '2.130.10.10-FF-001236', NULL, 'Cilia- and flagella-associated protein 251', 318, NULL, NULL, 196072);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(196073, '1.20.120.1370-FF-000001', NULL, 'Regulator of sigma D', 151, NULL, NULL, 196073),
(196074, '3.40.50.2000-FF-001071', NULL, 'Protein CBG08858', 62, NULL, NULL, 196074),
(196075, '1.10.287.600-FF-000012', NULL, 'Tubulin beta chain', 69, NULL, NULL, 196075),
(196076, '3.30.160.20-FF-000072', NULL, 'Dicer-like 105', 78, NULL, NULL, 196076),
(196077, '1.25.40.20-FF-000849', NULL, 'Kinase, NEK', 308, NULL, NULL, 196077),
(196078, '3.30.720.210-FF-000020', NULL, 'ATP-dependent zinc metalloprotease FtsH', 75, NULL, NULL, 196078),
(196079, '3.30.60.90-FF-000017', NULL, 'E3 ubiquitin-protein ligase KCMF1', 56, NULL, NULL, 196079),
(196080, '3.30.70.330-FF-002049', NULL, NULL, 96, NULL, NULL, 196080),
(196081, '3.30.40.10-FF-002179', NULL, 'Ubiquitin carboxyl-terminal hydrolase 20', 81, NULL, NULL, 196081),
(196082, '1.10.10.350-FF-000009', NULL, 'Glutamate--tRNA ligase', 103, NULL, NULL, 196082),
(196083, '2.40.50.140-FF-000697', NULL, 'Predicted protein', 92, NULL, NULL, 196083),
(196084, '2.10.25.10-FF-000016', NULL, 'Teneurin transmembrane protein 2', 33, NULL, NULL, 196084),
(196085, '2.60.40.200-FF-000023', NULL, 'Superoxide dismutase [Cu-Zn]', 161, NULL, NULL, 196085),
(196086, '3.30.160.60-FF-000853', NULL, 'zinc finger protein 205 isoform X1', 28, NULL, NULL, 196086),
(196087, '3.20.20.100-FF-000101', NULL, 'Probable oxidoreductase', 321, NULL, NULL, 196087),
(196088, '2.130.10.10-FF-004327', NULL, 'UTP18 small subunit processome component', 103, NULL, NULL, 196088),
(196089, '2.60.260.20-FF-000177', NULL, 'DnaJ-like protein', 62, NULL, NULL, 196089),
(196090, '3.40.1450.10-FF-000009', NULL, 'Predicted protein', 51, NULL, NULL, 196090),
(196091, '3.15.20.10-FF-000021', NULL, 'Uncharacterized protein', 133, NULL, NULL, 196091),
(196092, '1.20.1070.10-FF-002049', NULL, 'Uncharacterized protein', 103, NULL, NULL, 196092),
(196093, '1.25.40.10-FF-001122', NULL, 'Putative TPR repeat family protein', 131, NULL, NULL, 196093),
(196094, '1.25.40.90-FF-000033', NULL, 'putative clathrin assembly protein At1g33340', 150, NULL, NULL, 196094),
(196095, '2.130.10.10-FF-005620', NULL, 'Uncharacterized protein', 184, NULL, NULL, 196095),
(196096, '1.10.390.10-FF-000070', NULL, 'Uncharacterized protein', 253, NULL, NULL, 196096),
(196097, '2.60.40.10-FF-001022', NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein', 100, NULL, NULL, 196097),
(196098, '3.30.450.40-FF-000274', NULL, 'Histidine kinase', 163, NULL, NULL, 196098),
(196099, '3.40.50.300-FF-004726', NULL, 'Uncharacterized protein', 127, NULL, NULL, 196099),
(196100, '3.10.50.10-FF-000033', NULL, 'Chitinase 12', 69, NULL, NULL, 196100),
(196101, '3.50.50.60-FF-000934', NULL, 'Dihydrolipoamide dehydrogenase, putative', 124, NULL, NULL, 196101),
(196102, '3.30.750.24-FF-000088', NULL, 'Sulfate/bicarbonate/oxalate exchanger SAT-1, putative', 60, NULL, NULL, 196102),
(196103, '3.40.50.720-FF-000569', NULL, 'Glyoxylate reductase', 198, NULL, NULL, 196103),
(196104, '1.20.1250.20-FF-002257', NULL, 'Uncharacterized protein', 105, NULL, NULL, 196104),
(196105, '2.60.120.200-FF-000684', NULL, 'Uncharacterized protein', 212, NULL, NULL, 196105),
(196106, '2.70.150.10-FF-000147', NULL, 'Phospholipid transporting ATPase-like protein, putative', 128, NULL, NULL, 196106),
(196107, '1.10.150.20-FF-000089', NULL, 'DNA repair protein', 53, NULL, NULL, 196107),
(196108, '3.30.70.330-FF-001212', NULL, 'Uncharacterized protein, isoform A', 112, NULL, NULL, 196108),
(196109, '1.10.10.10-FF-001800', NULL, 'Selenocysteine-specific translation elongation factor', 63, NULL, NULL, 196109),
(196110, '2.40.50.1020-FF-000024', NULL, 'Sensory transduction protein LytT', 113, NULL, NULL, 196110),
(196111, '3.40.30.10-FF-001183', NULL, 'Uncharacterized protein', 80, NULL, NULL, 196111),
(196112, '1.10.510.10-FF-001693', NULL, 'Serine/threonine protein kinase, variant', 89, NULL, NULL, 196112),
(196113, '1.10.10.790-FF-000012', NULL, 'G patch domain-containing protein TGH', 91, NULL, NULL, 196113),
(196114, '3.30.540.10-FF-000053', NULL, 'Si:ch211-160o17.2', 75, NULL, NULL, 196114);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(196115, '3.30.420.40-FF-000103', NULL, 'Heat shock 70 kDa protein 13', 13, NULL, NULL, 196115),
(196116, '3.40.50.300-FF-005002', NULL, 'Predicted protein', 144, NULL, NULL, 196116),
(196117, '1.10.10.10-FF-002076', NULL, 'Uncharacterized protein', 72, NULL, NULL, 196117),
(196118, '3.40.50.1100-FF-000295', NULL, 'Uncharacterized protein', 73, NULL, NULL, 196118),
(196119, '3.40.50.450-FF-000016', NULL, 'Transient receptor potential cation channel subfamily M member 2', 183, NULL, NULL, 196119),
(196120, '1.20.1560.10-FF-000664', NULL, 'Uncharacterized protein', 58, NULL, NULL, 196120),
(196121, '3.30.70.330-FF-000936', NULL, 'Nucleolin', 87, NULL, NULL, 196121),
(196122, '1.10.472.10-FF-000182', NULL, 'Cyclin-like protein', 111, NULL, NULL, 196122),
(196123, '2.30.40.10-FF-000107', NULL, 'Phosphonate metabolism protein', 119, NULL, NULL, 196123),
(196124, '3.40.50.720-FF-001862', NULL, 'Malic enzyme', 137, NULL, NULL, 196124),
(196125, '1.10.150.50-FF-000182', NULL, 'Predicted protein', 79, NULL, NULL, 196125),
(196126, '3.40.50.1820-FF-001359', NULL, 'Probable 2-oxo-3-(5-oxofuran-2-ylidene)propanoate lactonase', 236, NULL, NULL, 196126),
(196127, '1.10.555.10-FF-000262', NULL, NULL, 96, NULL, NULL, 196127),
(196128, '3.30.1370.10-FF-000123', NULL, 'KH domain-containing, RNA-binding, signal transduction-associated protein 3 isoform X5', 132, NULL, NULL, 196128),
(196129, '1.10.287.1150-FF-000021', NULL, '2-oxoglutarate dehydrogenase, putative', 99, NULL, NULL, 196129),
(196130, '3.40.190.10-FF-000528', NULL, 'ABC transporter, periplasmic substrate-binding protein', 142, NULL, NULL, 196130),
(196131, '3.50.50.60-FF-000355', NULL, 'Sarcosine oxidase, alpha subunit', 130, NULL, NULL, 196131),
(196132, '2.60.40.60-FF-001008', NULL, 'Uncharacterized protein', 103, NULL, NULL, 196132),
(196133, '3.40.190.10-FF-000186', NULL, 'Phosphate-binding protein PstS 3', 166, NULL, NULL, 196133),
(196134, '3.50.50.60-FF-000479', NULL, 'Predicted protein', 136, NULL, NULL, 196134),
(196135, '4.10.900.10-FF-000031', NULL, 'Cadherin 20', 68, NULL, NULL, 196135),
(196136, '3.40.47.10-FF-000215', NULL, NULL, 148, NULL, NULL, 196136),
(196137, '1.20.80.10-FF-000028', NULL, 'Focal adhesion kinase, isoform D', 124, NULL, NULL, 196137),
(196138, '3.30.200.20-FF-000457', NULL, 'Microtubule-associated serine/threonine-protein kinase', 97, NULL, NULL, 196138),
(196139, '1.20.58.390-FF-000268', NULL, 'Predicted protein', 86, NULL, NULL, 196139),
(196140, '3.90.190.10-FF-000405', NULL, 'Probable serine/threonine-protein kinase DDB_G0277071', 163, NULL, NULL, 196140),
(196141, '2.30.30.380-FF-000020', NULL, 'Secretory 24AB, isoform A', 67, NULL, NULL, 196141),
(196142, '1.25.10.10-FF-001076', NULL, 'Os06g0286351 protein', 147, NULL, NULL, 196142),
(196143, '3.30.230.70-FF-000053', NULL, '3 exoribonuclease family protein', 212, NULL, NULL, 196143),
(196144, '1.25.40.10-FF-001465', NULL, 'Pentatricopeptide repeat-containing protein', 176, NULL, NULL, 196144),
(196145, '2.60.40.2160-FF-000007', NULL, 'Uncharacterized protein', 168, NULL, NULL, 196145),
(196146, '2.60.40.10-FF-003495', NULL, NULL, 92, NULL, NULL, 196146),
(196147, '3.20.20.60-FF-000001', NULL, 'Pyruvate kinase', 233, NULL, NULL, 196147),
(196148, '2.10.25.10-FF-000691', NULL, 'Scavenger receptor class F, member 1', 70, NULL, NULL, 196148),
(196149, '1.10.486.10-FF-000028', NULL, 'ATP-dependent helicase/nuclease subunit A', 146, NULL, NULL, 196149),
(196150, '2.130.10.10-FF-001910', NULL, 'Intraflagellar transport protein 172-like protein', 251, NULL, NULL, 196150),
(196151, '3.30.565.10-FF-000475', NULL, 'Uncharacterized protein', 110, NULL, NULL, 196151),
(196152, '3.30.70.360-FF-000012', NULL, 'Putative ureidoglycolate hydrolase', 117, NULL, NULL, 196152),
(196153, '3.60.40.10-FF-000126', NULL, 'Related to PTC5-putative 2C protein phosphatase (PP2Cs)', 452, NULL, NULL, 196153),
(196154, '3.40.50.1480-FF-000032', NULL, NULL, 114, NULL, NULL, 196154),
(196155, '3.90.550.20-FF-000037', NULL, 'Predicted protein', 167, NULL, NULL, 196155),
(196156, '3.40.1110.10-FF-000304', NULL, NULL, 196, NULL, NULL, 196156);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(196157, '1.10.10.60-FF-001225', NULL, NULL, 82, NULL, NULL, 196157),
(196158, '2.40.10.10-FF-000526', NULL, NULL, 102, NULL, NULL, 196158),
(196159, '3.30.2160.10-FF-000079', NULL, 'Ubiquitin-protein ligase, putative', 82, NULL, NULL, 196159),
(196160, '1.10.472.10-FF-000524', NULL, 'Cyclin, N-terminal domain containing protein', 93, NULL, NULL, 196160),
(196161, '1.25.10.10-FF-000676', NULL, 'Kinesin-like protein', 106, NULL, NULL, 196161),
(196162, '1.20.1250.20-FF-001296', NULL, 'Sialin, putative', 171, NULL, NULL, 196162),
(196163, '3.40.50.300-FF-004384', NULL, 'Dephospho-CoA kinase', 206, NULL, NULL, 196163),
(196164, '1.10.10.60-FF-000949', NULL, NULL, 70, NULL, NULL, 196164),
(196165, '1.10.400.10-FF-000066', NULL, 'G-protein subunit alpha 3', 98, NULL, NULL, 196165),
(196166, '1.20.5.520-FF-000009', NULL, 'Uncharacterized protein', 24, NULL, NULL, 196166),
(196167, '2.130.10.10-FF-000617', NULL, 'U3 small nucleolar RNA-associated protein 4 homolog', 170, NULL, NULL, 196167),
(196168, '3.40.50.2000-FF-000452', NULL, 'Lipopolysaccharide core biosynthesis protein rfaG', 166, NULL, NULL, 196168),
(196169, '3.30.40.10-FF-001779', NULL, 'Uncharacterized protein', 113, NULL, NULL, 196169),
(196170, '1.10.10.60-FF-000606', NULL, 'Resolvase TnpR', 45, NULL, NULL, 196170),
(196171, '3.30.70.260-FF-000095', NULL, 'Aspartate kinase, putative', 70, NULL, NULL, 196171),
(196172, '1.20.5.1430-FF-000005', NULL, 'Eb1, isoform E', 84, NULL, NULL, 196172),
(196173, '3.30.70.600-FF-000023', NULL, 'Uncharacterized protein', 74, NULL, NULL, 196173),
(196174, '2.60.40.2140-FF-000001', NULL, 'Beta-1,3-glucan-binding protein', 105, NULL, NULL, 196174),
(196175, '1.10.510.10-FF-000979', NULL, 'Os07g0493200 protein', 194, NULL, NULL, 196175),
(196176, '1.20.58.760-FF-000053', NULL, 'Bll8085 protein', 188, NULL, NULL, 196176),
(196177, '2.40.70.10-FF-000288', NULL, 'Uncharacterized protein', 251, NULL, NULL, 196177),
(196178, '3.40.50.10130-FF-000052', NULL, 'Uncharacterized protein', 153, NULL, NULL, 196178),
(196179, '3.40.720.10-FF-000222', NULL, 'N-acetylgalactosamine-6-sulfatase', 358, NULL, NULL, 196179),
(196180, '3.40.50.150-FF-001101', NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', 312, NULL, NULL, 196180),
(196181, '3.40.50.300-FF-000674', NULL, 'Sulfotransferase', 272, NULL, NULL, 196181),
(196182, '3.40.50.1240-FF-000196', NULL, NULL, 122, NULL, NULL, 196182),
(196183, '1.10.510.10-FF-001350', NULL, 'Serine/threonine protein kinase', 294, NULL, NULL, 196183),
(196184, '2.160.20.10-FF-000302', NULL, 'F-box protein dre-1', 295, NULL, NULL, 196184),
(196185, '3.30.40.10-FF-002055', NULL, 'Uncharacterized protein', 90, NULL, NULL, 196185),
(196186, '3.30.200.20-FF-001418', NULL, NULL, 80, NULL, NULL, 196186),
(196187, '2.60.300.12-FF-000006', NULL, 'Iron-sulfur cluster assembly 2 mitochondrial', 106, NULL, NULL, 196187),
(196188, '3.80.10.10-FF-002372', NULL, 'Uncharacterized protein', 208, NULL, NULL, 196188),
(196189, '3.40.462.20-FF-000006', NULL, 'Aspergillus niger contig An11c0010, genomic contig', 125, NULL, NULL, 196189),
(196190, '1.25.40.10-FF-002426', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 107, NULL, NULL, 196190),
(196191, '3.30.70.330-FF-000251', NULL, 'ras GTPase-activating protein-binding protein 2 isoform X2', 117, NULL, NULL, 196191),
(196192, '2.60.40.10-FF-001820', NULL, 'Basement membrane proteoglycan', 95, NULL, NULL, 196192),
(196193, '3.30.70.100-FF-000199', NULL, NULL, 119, NULL, NULL, 196193),
(196194, '2.30.29.30-FF-000643', NULL, 'Protein kinase domain containing protein', 111, NULL, NULL, 196194),
(196195, '3.60.40.10-FF-000002', NULL, 'Serine/threonine phosphatase stp', 245, NULL, NULL, 196195),
(196196, '3.80.10.10-FF-001972', NULL, 'Leucine-rich repeat protein (LRRP), putative', 304, NULL, NULL, 196196),
(196197, '3.40.50.150-FF-000825', NULL, 'S-adenosylmethionine-dependent methyltransferase, putative', 225, NULL, NULL, 196197),
(196198, '1.10.260.100-FF-000040', NULL, 'Uncharacterized protein', 59, NULL, NULL, 196198),
(196199, '1.20.1080.10-FF-000077', NULL, 'Predicted protein', 138, NULL, NULL, 196199);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(196200, '1.10.760.10-FF-000115', NULL, 'Diheme cytochrome c-type', 155, NULL, NULL, 196200),
(196201, '2.40.50.90-FF-000165', NULL, 'Staphylococcal nuclease domain-containing protein 1', 151, NULL, NULL, 196201),
(196202, '3.90.15.10-FF-000004', NULL, 'DNA topoisomerase I', 150, NULL, NULL, 196202),
(196203, '1.10.132.30-FF-000027', NULL, 'RNA polymerase Rpb1, domain 2 family protein', 128, NULL, NULL, 196203),
(196204, '3.40.50.300-FF-005345', NULL, 'Uncharacterized protein', 102, NULL, NULL, 196204),
(196205, '2.40.50.90-FF-000041', NULL, 'Tudor staphylococcal nuclease', 122, NULL, NULL, 196205),
(196206, '3.40.50.80-FF-000103', NULL, 'Ferredoxin--NADP reductase', 159, NULL, NULL, 196206),
(196207, '3.40.50.300-FF-004945', NULL, 'Developmental protein DG1120', 159, NULL, NULL, 196207),
(196208, '3.30.450.20-FF-000515', NULL, 'Slr1385 protein', 106, NULL, NULL, 196208),
(196209, '3.40.190.290-FF-000026', NULL, 'Transcriptional regulator MvfR', 216, NULL, NULL, 196209),
(196210, '3.30.2310.20-FF-000010', NULL, 'Addiction module toxin, Txe/YoeB family', 87, NULL, NULL, 196210),
(196211, '1.10.532.10-FF-000018', NULL, 'Novel protein', 42, NULL, NULL, 196211),
(196212, '1.10.630.10-FF-000111', NULL, 'Flavonoid 3'',5''-hydroxylase 2', 470, NULL, NULL, 196212),
(196213, '3.20.20.140-FF-000321', NULL, 'Predicted protein', 266, NULL, NULL, 196213),
(196214, '2.40.100.10-FF-000128', NULL, 'Peptidyl-prolyl cis-trans isomerase', 185, NULL, NULL, 196214),
(196215, '3.60.20.10-FF-000113', NULL, 'Asparagine synthase (Glutamine-hydrolysing)', 195, NULL, NULL, 196215),
(196216, '3.30.450.30-FF-000052', NULL, 'Uncharacterized protein MJ1340', 114, NULL, NULL, 196216),
(196217, '1.20.1050.130-FF-000046', NULL, 'Predicted protein', 106, NULL, NULL, 196217),
(196218, '1.10.8.60-FF-000173', NULL, 'Cell division cycle protein 48', 95, NULL, NULL, 196218),
(196219, '3.40.50.720-FF-000226', NULL, 'Dipicolinic acid synthetase subunit A', 141, NULL, NULL, 196219),
(196220, '1.20.1560.10-FF-000321', NULL, 'ABC transporter ATP-binding protein', 313, NULL, NULL, 196220),
(196221, '3.40.50.410-FF-000252', NULL, 'Cutl-23', 181, NULL, NULL, 196221),
(196222, '3.40.50.2300-FF-000328', NULL, 'Two-component system response regulator', 138, NULL, NULL, 196222),
(196223, '3.40.50.1820-FF-000353', NULL, 'Alpha/beta hydrolase', 275, NULL, NULL, 196223),
(196224, '3.50.50.60-FF-000277', NULL, 'Glutathione reductase', 183, NULL, NULL, 196224),
(196225, '3.40.50.2300-FF-000424', NULL, 'Metabotropic GLutamate receptor family', 279, NULL, NULL, 196225),
(196226, '2.30.42.10-FF-000409', NULL, NULL, 84, NULL, NULL, 196226),
(196227, '3.40.50.300-FF-007402', NULL, 'Uncharacterized protein', 54, NULL, NULL, 196227),
(196228, '3.40.50.2300-FF-000896', NULL, NULL, 202, NULL, NULL, 196228),
(196229, '1.20.1070.10-FF-000368', NULL, 'Predicted protein', 291, NULL, NULL, 196229),
(196230, '3.90.1180.10-FF-000027', NULL, NULL, 154, NULL, NULL, 196230),
(196231, '3.40.50.150-FF-001062', NULL, 'Sterol 24-C-methyltransferase', 257, NULL, NULL, 196231),
(196232, '3.10.129.10-FF-000287', NULL, 'Uncharacterized protein', 264, NULL, NULL, 196232),
(196233, '3.40.50.720-FF-002121', NULL, 'Os10g0553450 protein', 112, NULL, NULL, 196233),
(196234, '2.130.10.10-FF-001062', NULL, 'Intraflagellar transport 122', 107, NULL, NULL, 196234),
(196235, '3.30.1370.120-FF-000012', NULL, 'Secretin GspD', 72, NULL, NULL, 196235),
(196236, '1.20.58.1590-FF-000008', NULL, 'Tethering factor for nuclear proteasome STS1', 210, NULL, NULL, 196236),
(196237, '1.10.150.320-FF-000002', NULL, 'Competence protein ComE', 76, NULL, NULL, 196237),
(196238, '2.60.40.10-FF-003175', NULL, 'hydrocephalus-inducing protein homolog', 116, NULL, NULL, 196238),
(196239, '1.10.2000.10-FF-000080', NULL, NULL, 79, NULL, NULL, 196239),
(196240, '3.90.550.10-FF-000669', NULL, 'Uncharacterized protein', 109, NULL, NULL, 196240),
(196241, '2.130.10.10-FF-004288', NULL, 'Uncharacterized protein', 126, NULL, NULL, 196241),
(196242, '3.30.300.130-FF-000042', NULL, NULL, 113, NULL, NULL, 196242);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(196243, '3.30.9.10-FF-000122', NULL, 'Amino acid dehydrogenase', 153, NULL, NULL, 196243),
(196244, '1.20.900.10-FF-000063', NULL, 'Rho guanine nucleotide exchange factor (GEF) 37', 224, NULL, NULL, 196244),
(196245, '1.10.238.10-FF-001127', NULL, 'Uncharacterized protein', 170, NULL, NULL, 196245),
(196246, '1.10.10.10-FF-001822', NULL, 'Ras guanine nucleotide exchange factor Q', 109, NULL, NULL, 196246),
(196247, '1.10.630.10-FF-000105', NULL, 'Cytochrome P450 daf-9', 466, NULL, NULL, 196247),
(196248, '3.40.50.300-FF-005311', NULL, 'Uncharacterized protein', 168, NULL, NULL, 196248),
(196249, '2.130.10.10-FF-003832', NULL, 'Uncharacterized protein', 298, NULL, NULL, 196249),
(196250, '3.40.190.10-FF-000765', NULL, 'Predicted protein', 161, NULL, NULL, 196250),
(196251, '2.60.120.260-FF-000376', NULL, 'Uncharacterized protein', 82, NULL, NULL, 196251),
(196252, '3.40.850.10-FF-000473', NULL, 'Kinesin, putative', 402, NULL, NULL, 196252),
(196253, '3.40.50.20-FF-000080', NULL, 'Carbamoyl phosphate synthase', 122, NULL, NULL, 196253),
(196254, '1.10.510.10-FF-001086', NULL, 'Probable serine/threonine-protein kinase KKQ8', 313, NULL, NULL, 196254),
(196255, '2.60.40.60-FF-000969', NULL, 'Uncharacterized protein', 119, NULL, NULL, 196255),
(196256, '3.30.750.24-FF-000059', NULL, 'Anti-sigma factor antagonist', 121, NULL, NULL, 196256),
(196257, '3.30.2130.30-FF-000010', NULL, 'tRNA sulfurtransferase', 176, NULL, NULL, 196257),
(196258, '1.10.940.10-FF-000028', NULL, 'Probable ribosomal RNA small subunit methyltransferase B', 141, NULL, NULL, 196258),
(196259, '3.40.50.12780-FF-000223', NULL, 'Hydroxamate-type ferrichrome siderophore peptide synthetase', 381, NULL, NULL, 196259),
(196260, '3.30.160.60-FF-001207', NULL, 'zinc finger protein 837 isoform X2', 28, NULL, NULL, 196260),
(196261, '3.40.50.10980-FF-000003', NULL, 'Nibrin', 106, NULL, NULL, 196261),
(196262, '1.50.10.20-FF-000071', NULL, 'Mannan endo-1,6-alpha-mannosidase', 318, NULL, NULL, 196262),
(196263, '3.40.50.1820-FF-001016', NULL, 'Uncharacterized protein', 206, NULL, NULL, 196263),
(196264, '3.30.540.10-FF-000036', NULL, 'Fructose-1,6-bisphosphatase class 1', 157, NULL, NULL, 196264),
(196265, '3.90.1150.10-FF-000525', NULL, 'Predicted protein', 51, NULL, NULL, 196265),
(196266, '1.20.58.60-FF-000249', NULL, 'VAB-10B protein', 97, NULL, NULL, 196266),
(196267, '3.10.450.40-FF-000003', NULL, 'Amine oxidase', 135, NULL, NULL, 196267),
(196268, '3.90.360.10-FF-000014', NULL, 'Histone acetyltransferase type B catalytic subunit', 92, NULL, NULL, 196268),
(196269, '1.25.40.20-FF-001479', NULL, 'Uncharacterized protein', 96, NULL, NULL, 196269),
(196270, '1.20.1730.10-FF-000043', NULL, 'Uncharacterized protein', 538, NULL, NULL, 196270),
(196271, '3.40.50.10990-FF-000006', NULL, '3,4-dihydroxy-2-butanone 4-phosphate synthase', 165, NULL, NULL, 196271),
(196272, '3.30.230.70-FF-000137', NULL, 'Exosome complex component RRP45B', 160, NULL, NULL, 196272),
(196273, '1.10.510.10-FF-003177', NULL, NULL, 161, NULL, NULL, 196273),
(196274, '3.30.40.10-FF-000447', NULL, 'Histone-lysine N-methyltransferase MLL3', 121, NULL, NULL, 196274),
(196275, '3.30.40.10-FF-001875', NULL, 'Uncharacterized protein', 115, NULL, NULL, 196275),
(196276, '2.130.10.10-FF-003153', NULL, 'Vacuolar protein sorting-associated protein 41', 303, NULL, NULL, 196276),
(196277, '3.30.160.60-FF-001533', NULL, 'zinc finger protein 275', 27, NULL, NULL, 196277),
(196278, '1.10.287.70-FF-000302', NULL, 'Uncharacterized protein', 158, NULL, NULL, 196278),
(196279, '3.40.50.300-FF-006885', NULL, 'Unclassified ABC-type transport system, ATPase component', 245, NULL, NULL, 196279),
(196280, '3.90.550.50-FF-000248', NULL, 'Uncharacterized protein', 182, NULL, NULL, 196280),
(196281, '1.10.472.10-FF-000378', NULL, 'Putative cyclin-H', 101, NULL, NULL, 196281),
(196282, '4.10.240.30-FF-000008', NULL, 'Uncharacterized protein', 31, NULL, NULL, 196282),
(196283, '1.10.10.2270-FF-000001', NULL, 'Protein transport protein TIP20', 67, NULL, NULL, 196283),
(196284, '3.40.50.2300-FF-001413', NULL, NULL, 72, NULL, NULL, 196284);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(196285, '1.25.40.10-FF-002578', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 92, NULL, NULL, 196285),
(196286, '3.10.100.10-FF-000058', NULL, 'Sushi domain-containing protein 5', 98, NULL, NULL, 196286),
(196287, '1.25.10.10-FF-002930', NULL, 'Predicted protein', 94, NULL, NULL, 196287),
(196288, '1.20.1250.20-FF-000469', NULL, 'Nodulin family protein', 200, NULL, NULL, 196288),
(196289, '3.40.50.410-FF-000201', NULL, 'Predicted protein', 88, NULL, NULL, 196289),
(196290, '1.20.1740.10-FF-000015', NULL, 'B(0,+)-type amino acid transporter 1', 440, NULL, NULL, 196290),
(196291, '2.60.40.10-FF-001730', NULL, 'Uncharacterized protein, isoform B', 113, NULL, NULL, 196291),
(196292, '3.40.50.10190-FF-000305', NULL, 'Uncharacterized protein', 101, NULL, NULL, 196292),
(196293, '3.30.559.10-FF-000180', NULL, 'Uncharacterized protein', 218, NULL, NULL, 196293),
(196294, '3.60.40.10-FF-000143', NULL, 'Uncharacterized protein', 299, NULL, NULL, 196294),
(196295, '1.25.10.10-FF-000985', NULL, 'HEAT repeat domain containing protein', 207, NULL, NULL, 196295),
(196296, '1.20.1250.20-FF-002240', NULL, 'Uncharacterized protein', 117, NULL, NULL, 196296),
(196297, '3.60.110.10-FF-000070', NULL, NULL, 126, NULL, NULL, 196297),
(196298, '3.40.50.1360-FF-000018', NULL, 'Deoxyribonucleoside regulator', 260, NULL, NULL, 196298),
(196299, '3.60.21.10-FF-000397', NULL, 'Uncharacterized protein', 320, NULL, NULL, 196299),
(196300, '1.20.142.10-FF-000014', NULL, 'Poly [ADP-ribose] polymerase', 149, NULL, NULL, 196300),
(196301, '2.60.120.650-FF-000077', NULL, 'Multicopy suppressor of chk1 protein 1', 291, NULL, NULL, 196301),
(196302, '3.30.70.330-FF-002572', NULL, NULL, 143, NULL, NULL, 196302),
(196303, '1.10.510.10-FF-001732', NULL, 'Non-specific serine/threonine protein kinase', 323, NULL, NULL, 196303),
(196304, '3.30.710.10-FF-000162', NULL, 'Centrosome-associated zinc finger protein CP190', 126, NULL, NULL, 196304),
(196305, '1.25.10.10-FF-001502', NULL, 'Uncharacterized protein', 153, NULL, NULL, 196305),
(196306, '2.60.110.10-FF-000017', NULL, 'Osmotin-like protein', 137, NULL, NULL, 196306),
(196307, '2.60.200.30-FF-000002', NULL, 'NAD kinase', 139, NULL, NULL, 196307),
(196308, '1.25.40.20-FF-001007', NULL, 'ankyrin repeat domain-containing protein 2', 77, NULL, NULL, 196308),
(196309, '3.40.50.300-FF-002877', NULL, 'Uncharacterized protein', 185, NULL, NULL, 196309),
(196310, '3.40.50.1220-FF-000061', NULL, 'NAD-dependent protein deacetylase', 120, NULL, NULL, 196310),
(196311, '2.30.29.30-FF-000542', NULL, 'Inner membrane complex sub-compartment protein 3', 142, NULL, NULL, 196311),
(196312, '3.40.1110.10-FF-000102', NULL, 'Copper-transporting ATPase HMA5', 55, NULL, NULL, 196312),
(196313, '3.40.50.2000-FF-000924', NULL, 'Glycosyltransferase', 158, NULL, NULL, 196313),
(196314, '2.60.40.1170-FF-000019', NULL, 'AP-4 complex subunit mu-1 isoform X1', 147, NULL, NULL, 196314),
(196315, '3.40.50.300-FF-001449', NULL, 'DNA repair and recombination protein RAD54', 170, NULL, NULL, 196315),
(196316, '3.40.850.10-FF-000147', NULL, 'kinesin-like protein CG14535', 340, NULL, NULL, 196316),
(196317, '1.25.40.10-FF-001004', NULL, 'Protein PTCD3 homolog, mitochondrial', 201, NULL, NULL, 196317),
(196318, '1.20.140.150-FF-000059', NULL, 'Transmembrane protein 114', 121, NULL, NULL, 196318),
(196319, '1.10.418.10-FF-000236', NULL, 'Uncharacterized protein', 67, NULL, NULL, 196319),
(196320, '2.40.30.30-FF-000033', NULL, 'Bifunctional riboflavin kinase/FMN adenylyltransferase', 123, NULL, NULL, 196320),
(196321, '2.60.200.40-FF-000005', NULL, 'Diacylglycerol kinase', 168, NULL, NULL, 196321),
(196322, '3.40.50.300-FF-004794', NULL, 'Guanylate kinase, putative', 155, NULL, NULL, 196322),
(196323, '3.80.10.10-FF-001287', NULL, 'Nuclear RNA export factor 2', 145, NULL, NULL, 196323),
(196324, '3.40.50.1240-FF-000067', NULL, 'Probable conserved lipoprotein LpqD', 202, NULL, NULL, 196324),
(196325, '1.20.1050.10-FF-000159', NULL, 'Glutathione S-transferase', 111, NULL, NULL, 196325),
(196326, '2.60.40.150-FF-000738', NULL, 'Type III restriction enzyme, res subunit family protein', 104, NULL, NULL, 196326);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(196327, '3.90.25.10-FF-000005', NULL, 'GDP-mannose 4,6 dehydratase', 99, NULL, NULL, 196327),
(196328, '3.30.2350.10-FF-000009', NULL, 'Pseudouridine synthase', 181, NULL, NULL, 196328),
(196329, '3.30.310.80-FF-000028', NULL, 'Non-specific serine/threonine protein kinase', 76, NULL, NULL, 196329),
(196330, '1.20.58.1030-FF-000009', NULL, 'DNA replication complex GINS protein SLD5', 167, NULL, NULL, 196330),
(196331, '3.40.50.620-FF-000146', NULL, 'Valine--tRNA ligase', 225, NULL, NULL, 196331),
(196332, '3.30.450.20-FF-000066', NULL, 'Period circadian protein', 166, NULL, NULL, 196332),
(196333, '3.40.50.11350-FF-000013', NULL, 'L-Fucosyltransferase', 149, NULL, NULL, 196333),
(196334, '3.30.70.2850-FF-000013', NULL, 'DNA-directed RNA polymerase I subunit 1', 163, NULL, NULL, 196334),
(196335, '1.25.40.90-FF-000112', NULL, 'Uncharacterized protein', 62, NULL, NULL, 196335),
(196336, '3.10.430.100-FF-000004', NULL, '50S ribosomal protein L9', 87, NULL, NULL, 196336),
(196337, '3.30.70.1390-FF-000013', NULL, 'Uncharacterized protein', 92, NULL, NULL, 196337),
(196338, '3.40.47.10-FF-000283', NULL, NULL, 90, NULL, NULL, 196338),
(196339, '2.40.50.140-FF-001006', NULL, NULL, 80, NULL, NULL, 196339),
(196340, '3.40.50.300-FF-007109', NULL, 'Uncharacterized protein', 186, NULL, NULL, 196340),
(196341, '3.40.50.2300-FF-000750', NULL, 'Uncharacterized protein', 151, NULL, NULL, 196341),
(196342, '1.20.1560.10-FF-000243', NULL, 'ABC transporter (MsbA subfamily)', 323, NULL, NULL, 196342),
(196343, '3.40.50.1820-FF-000027', NULL, 'Esterase YqiA', 192, NULL, NULL, 196343),
(196344, '1.10.510.10-FF-003031', NULL, NULL, 224, NULL, NULL, 196344),
(196345, '1.10.510.10-FF-002867', NULL, 'Chromosomal serine/threonine-protein kinase JIL-1', 208, NULL, NULL, 196345),
(196346, '1.20.58.60-FF-000542', NULL, 'Calponin homology domain-containing protein', 126, NULL, NULL, 196346),
(196347, '3.40.50.720-FF-002267', NULL, 'Uncharacterized protein', 46, NULL, NULL, 196347),
(196348, '3.40.50.11340-FF-000010', NULL, 'Probable fucosyltransferase 5', 44, NULL, NULL, 196348),
(196349, '1.10.260.30-FF-000010', NULL, 'BnaCnng10600D protein', 125, NULL, NULL, 196349),
(196350, '3.30.160.60-FF-002961', NULL, 'Zinc finger domain-containing protein', 29, NULL, NULL, 196350),
(196351, '3.10.50.10-FF-000022', NULL, 'AGAP001863-PA', 67, NULL, NULL, 196351),
(196352, '2.40.50.120-FF-000011', NULL, 'Secreted frizzled-related sequence protein 4', 124, NULL, NULL, 196352),
(196353, '3.30.160.60-FF-003450', NULL, NULL, 36, NULL, NULL, 196353),
(196354, '3.40.50.200-FF-000110', NULL, 'Uncharacterized protein', 93, NULL, NULL, 196354),
(196355, '1.10.405.20-FF-000001', NULL, 'Amine oxidase', 126, NULL, NULL, 196355),
(196356, '3.10.350.10-FF-000043', NULL, 'Lipoprotein NlpD', 57, NULL, NULL, 196356),
(196357, '1.10.10.60-FF-001051', NULL, NULL, 60, NULL, NULL, 196357),
(196358, '2.20.70.10-FF-000216', NULL, 'Uncharacterized protein', 58, NULL, NULL, 196358),
(196359, '3.40.50.960-FF-000017', NULL, '6,7-dimethyl-8-ribityllumazine synthase', 133, NULL, NULL, 196359),
(196360, '1.10.12.10-FF-000023', NULL, 'Enoyl-CoA hydratase', 57, NULL, NULL, 196360),
(196361, '1.20.1510.10-FF-000032', NULL, 'Zinc transporter, putative', 170, NULL, NULL, 196361),
(196362, '1.20.5.1190-FF-000012', NULL, 'Sodium channel protein', 43, NULL, NULL, 196362),
(196363, '1.20.1250.20-FF-001897', NULL, 'Uncharacterized protein', 68, NULL, NULL, 196363),
(196364, '1.20.5.170-FF-000034', NULL, 'Nucleoporin P54, putative', 46, NULL, NULL, 196364),
(196365, '3.40.50.1820-FF-001781', NULL, 'Carboxylic ester hydrolase', 359, NULL, NULL, 196365),
(196366, '3.40.50.2000-FF-000278', NULL, 'Glycogen synthase', 186, NULL, NULL, 196366),
(196367, '1.20.120.1750-FF-000093', NULL, 'Uncharacterized protein', 79, NULL, NULL, 196367),
(196368, '1.20.1070.10-FF-001211', NULL, 'Uncharacterized protein', 131, NULL, NULL, 196368),
(196369, '2.60.40.10-FF-004956', NULL, NULL, 95, NULL, NULL, 196369),
(196370, '1.10.260.40-FF-000013', NULL, 'POU domain protein', 79, NULL, NULL, 196370);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(196371, '3.30.160.60-FF-005541', NULL, NULL, 40, NULL, NULL, 196371),
(196372, '1.20.1070.10-FF-001796', NULL, 'Predicted protein', 319, NULL, NULL, 196372),
(196373, '2.40.50.90-FF-000120', NULL, 'Endonuclease domain protein', 153, NULL, NULL, 196373),
(196374, '3.90.190.10-FF-000540', NULL, 'Uncharacterized protein', 161, NULL, NULL, 196374),
(196375, '3.50.50.60-FF-000956', NULL, 'FAD dependent oxidoreductase', 203, NULL, NULL, 196375),
(196376, '1.20.1440.180-FF-000003', NULL, 'Ribonuclease L', 136, NULL, NULL, 196376),
(196377, '1.10.10.650-FF-000021', NULL, 'Uncharacterized protein', 112, NULL, NULL, 196377),
(196378, '3.80.10.10-FF-000831', NULL, 'Leucine-rich repeat protein kinase family protein', 259, NULL, NULL, 196378),
(196379, '3.40.50.150-FF-001415', NULL, NULL, 158, NULL, NULL, 196379),
(196380, '1.10.10.60-FF-000887', NULL, NULL, 58, NULL, NULL, 196380),
(196381, '2.60.220.50-FF-000190', NULL, 'Uncharacterized protein', 193, NULL, NULL, 196381),
(196382, '1.10.630.10-FF-000370', NULL, 'Uncharacterized protein', 445, NULL, NULL, 196382),
(196383, '3.40.50.10890-FF-000009', NULL, 'Cleavage and polyadenylation specificity factor, 73 kDa subunit', 202, NULL, NULL, 196383),
(196384, '3.40.50.150-FF-000926', NULL, 'Putative trna and rrna cytosine-c5-methylase nucleolar protein nol1/nop2', 354, NULL, NULL, 196384),
(196385, '2.60.40.10-FF-002865', NULL, 'HERV-H LTR-associating 2b, tandem duplicate 2', 119, NULL, NULL, 196385),
(196386, '2.170.130.10-FF-000015', NULL, 'Ligand-gated channel protein', 128, NULL, NULL, 196386),
(196387, '1.10.510.10-FF-002188', NULL, NULL, 115, NULL, NULL, 196387),
(196388, '3.40.50.1000-FF-000607', NULL, NULL, 215, NULL, NULL, 196388),
(196389, '1.20.910.10-FF-000035', NULL, 'Uncharacterized protein', 217, NULL, NULL, 196389),
(196390, '2.40.50.140-FF-000517', NULL, 'Cold-shock protein, putative', 69, NULL, NULL, 196390),
(196391, '1.10.510.10-FF-001406', NULL, 'CAMK family protein kinase', 299, NULL, NULL, 196391),
(196392, '1.25.10.10-FF-000659', NULL, 'PDS5p Cohesion maintenance factor', 250, NULL, NULL, 196392),
(196393, '3.90.190.10-FF-000040', NULL, 'mRNA-capping enzyme', 208, NULL, NULL, 196393),
(196394, '3.30.70.330-FF-000329', NULL, 'splicing factor U2AF-associated protein 2', 86, NULL, NULL, 196394),
(196395, '1.25.40.20-FF-001333', NULL, 'Ankyrin repeat-containing protein C105.02c', 126, NULL, NULL, 196395),
(196396, '2.120.10.80-FF-000335', NULL, 'Uncharacterized protein', 126, NULL, NULL, 196396),
(196397, '2.130.10.10-FF-002989', NULL, 'Dynein axonemal intermediate chain 2', 199, NULL, NULL, 196397),
(196398, '3.30.559.10-FF-000028', NULL, 'Yat2p', 166, NULL, NULL, 196398),
(196399, '1.20.1250.20-FF-001397', NULL, 'Uncharacterized protein', 260, NULL, NULL, 196399),
(196400, '3.40.50.11660-FF-000016', NULL, '4-galactosyl-N-acetylglucosaminide 3-alpha-L-fucosyltransferase', 244, NULL, NULL, 196400),
(196401, '1.25.10.10-FF-003240', NULL, 'Protein CELLULOSE SYNTHASE INTERACTIVE 3', 243, NULL, NULL, 196401),
(196402, '3.30.40.10-FF-001549', NULL, 'Uncharacterized protein', 54, NULL, NULL, 196402),
(196403, '3.40.50.300-FF-004468', NULL, 'Putative disease resistance protein At3g14460', 173, NULL, NULL, 196403),
(196404, '1.25.40.10-FF-001330', NULL, 'Pentatricopeptide repeat-containing protein At3g50420', 144, NULL, NULL, 196404),
(196405, '2.130.10.10-FF-002843', NULL, 'actin-related protein 2/3 complex subunit 1A', 354, NULL, NULL, 196405),
(196406, '3.40.1380.20-FF-000040', NULL, 'Pyruvate kinase', 122, NULL, NULL, 196406),
(196407, '3.30.70.2120-FF-000002', NULL, 'Flagellar hook protein FlgE', 106, NULL, NULL, 196407),
(196408, '3.40.190.290-FF-000133', NULL, 'Transcriptional regulator LysR family', 199, NULL, NULL, 196408),
(196409, '2.10.50.10-FF-000002', NULL, 'signal peptide, CUB and EGF-like domain-containing protein 2 isoform X1', 56, NULL, NULL, 196409),
(196410, '3.30.450.20-FF-000127', NULL, 'C4-dicarboxylate transport sensor protein', 78, NULL, NULL, 196410),
(196411, '3.40.50.720-FF-002328', NULL, 'Uncharacterized protein', 120, NULL, NULL, 196411); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(196412, '2.20.110.10-FF-000077', NULL, NULL, 84, NULL, NULL, 196412),
(196413, '3.80.10.10-FF-000359', NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', 167, NULL, NULL, 196413),
(196414, '1.20.1560.10-FF-000922', NULL, 'Uncharacterized protein', 92, NULL, NULL, 196414),
(196415, '3.40.1280.10-FF-000086', NULL, 'tRNA (Cytidine/uridine-2''-O-)-methyltransferase', 179, NULL, NULL, 196415),
(196416, '2.60.40.10-FF-001084', NULL, 'obscurin-like isoform X3', 95, NULL, NULL, 196416),
(196417, '3.10.129.10-FF-000141', NULL, '4-hydroxybenzoyl-CoA thioesterase', 135, NULL, NULL, 196417),
(196418, '2.40.70.10-FF-000406', NULL, NULL, 155, NULL, NULL, 196418),
(196419, '3.40.50.300-FF-000140', NULL, 'Lipid A export ATP-binding/permease protein MsbA', 251, NULL, NULL, 196419),
(196420, '1.20.58.60-FF-000042', NULL, 'Short stop, isoform N', 218, NULL, NULL, 196420),
(196421, '1.25.40.10-FF-003421', NULL, 'Sll1384 protein', 87, NULL, NULL, 196421),
(196422, '3.30.190.20-FF-000028', NULL, 'Ribosomal L1 domain-containing protein 1', 70, NULL, NULL, 196422),
(196423, '3.30.160.60-FF-003950', NULL, NULL, 35, NULL, NULL, 196423),
(196424, '1.20.58.1310-FF-000003', NULL, 'Rop guanine nucleotide exchange factor 7', 129, NULL, NULL, 196424),
(196425, '3.40.50.720-FF-000176', NULL, 'Probable ion channel POLLUX', 143, NULL, NULL, 196425),
(196426, '3.30.230.10-FF-000226', NULL, 'DNA mismatch repair protein, putative', 126, NULL, NULL, 196426),
(196427, '3.10.100.10-FF-000384', NULL, NULL, 130, NULL, NULL, 196427),
(196428, '2.130.10.10-FF-004934', NULL, 'Chromosome 10, whole genome shotgun sequence', 104, NULL, NULL, 196428),
(196429, '2.60.40.10-FF-001404', NULL, 'Erythrocyte membrane protein band 4.2', 145, NULL, NULL, 196429),
(196430, '1.20.58.1020-FF-000006', NULL, 'DNA replication complex GINS protein PSF2', 114, NULL, NULL, 196430),
(196431, '3.30.200.20-FF-000727', NULL, 'Cysteine-rich RLK (RECEPTOR-like protein kinase) 23', 113, NULL, NULL, 196431),
(196432, '3.30.200.20-FF-002498', NULL, 'Non-specific serine/threonine protein kinase', 13, NULL, NULL, 196432),
(196433, '3.30.470.10-FF-000007', NULL, 'Aminodeoxychorismate lyase', 111, NULL, NULL, 196433),
(196434, '2.60.120.200-FF-000465', NULL, 'Uncharacterized protein', 166, NULL, NULL, 196434),
(196435, '3.40.850.10-FF-000208', NULL, 'kinesin-like protein KIF21B isoform X1', 314, NULL, NULL, 196435),
(196436, '3.30.160.60-FF-001180', NULL, 'Zinc finger protein 366', 31, NULL, NULL, 196436),
(196437, '3.80.10.10-FF-003439', NULL, 'Uncharacterized protein', 58, NULL, NULL, 196437),
(196438, '2.30.29.30-FF-000249', NULL, 'Capping protein regulator and myosin 1 linker 2', 114, NULL, NULL, 196438),
(196439, '3.30.160.60-FF-003124', NULL, 'zinc finger protein 622', 62, NULL, NULL, 196439),
(196440, '1.25.40.10-FF-000987', NULL, 'Pentatricopeptide repeat-containing protein At3g14330', 105, NULL, NULL, 196440),
(196441, '3.40.50.300-FF-006946', NULL, 'Uncharacterized protein', 226, NULL, NULL, 196441),
(196442, '1.25.40.180-FF-000241', NULL, NULL, 162, NULL, NULL, 196442),
(196443, '3.80.10.10-FF-004193', NULL, 'Uncharacterized protein', 92, NULL, NULL, 196443),
(196444, '1.10.10.2570-FF-000001', NULL, 'Autophagy-related protein 29', 84, NULL, NULL, 196444),
(196445, '3.40.50.620-FF-000472', NULL, 'Queuosine synthesis-like protein', 189, NULL, NULL, 196445),
(196446, '3.30.1520.10-FF-000135', NULL, 'Putative nischarin modulator of integrin alpha5 subunit action', 112, NULL, NULL, 196446),
(196447, '2.60.40.10-FF-002539', NULL, 'Zwei Ig domain protein zig-8', 108, NULL, NULL, 196447),
(196448, '3.40.390.10-FF-000128', NULL, 'Metalloendopeptidase', 227, NULL, NULL, 196448),
(196449, '3.30.70.330-FF-000981', NULL, 'NPL3p RNA-binding protein', 77, NULL, NULL, 196449),
(196450, '1.25.40.10-FF-000807', NULL, 'Os03g0735200 protein', 184, NULL, NULL, 196450),
(196451, '3.40.50.150-FF-000898', NULL, 'RNA methyltransferase', 202, NULL, NULL, 196451),
(196452, '2.30.39.10-FF-000036', NULL, 'Putative non-inhibitory serpin-10', 139, NULL, NULL, 196452),
(196453, '1.10.8.10-FF-000321', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 54, NULL, NULL, 196453);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(196454, '1.10.1370.10-FF-000039', NULL, 'Uncharacterized protein', 159, NULL, NULL, 196454),
(196455, '2.60.40.2030-FF-000053', NULL, 'Adhesion G-protein coupled receptor V1', 153, NULL, NULL, 196455),
(196456, '1.10.40.30-FF-000021', NULL, 'Fumarate hydratase class II', 58, NULL, NULL, 196456),
(196457, '3.30.2010.10-FF-000018', NULL, 'Peptidase family M48', 93, NULL, NULL, 196457),
(196458, '2.60.120.200-FF-000818', NULL, 'Uncharacterized protein', 69, NULL, NULL, 196458),
(196459, '3.40.50.720-FF-000204', NULL, 'Inositol-3-phosphate synthase 1-B', 131, NULL, NULL, 196459),
(196460, '2.60.40.820-FF-000046', NULL, 'Uncharacterized protein', 126, NULL, NULL, 196460),
(196461, '1.20.58.1280-FF-000005', NULL, 'DNA repair protein REV1', 92, NULL, NULL, 196461),
(196462, '1.10.472.90-FF-000003', NULL, 'Pyruvate carboxylase', 53, NULL, NULL, 196462),
(196463, '3.30.160.60-FF-004698', NULL, NULL, 33, NULL, NULL, 196463),
(196464, '2.60.120.650-FF-000105', NULL, 'JmjC domain-containing histone demethylase, putative', 314, NULL, NULL, 196464),
(196465, '3.60.40.10-FF-000204', NULL, 'Protein phosphatase, Mg2+/Mn2+-dependent, 1J', 337, NULL, NULL, 196465),
(196466, '2.30.30.100-FF-000043', NULL, 'U6 snRNA-associated Sm-like protein LSm7', 98, NULL, NULL, 196466),
(196467, '3.40.50.80-FF-000165', NULL, 'Ferric-chelate reductase, putative', 110, NULL, NULL, 196467),
(196468, '3.40.50.300-FF-001921', NULL, 'AAA ATPase domain-containing protein', 189, NULL, NULL, 196468),
(196469, '2.60.120.10-FF-000254', NULL, 'Cysteine dioxygenase', 203, NULL, NULL, 196469),
(196470, '2.30.230.10-FF-000033', NULL, 'Predicted protein', 218, NULL, NULL, 196470),
(196471, '2.60.200.20-FF-000258', NULL, 'Uncharacterized protein', 82, NULL, NULL, 196471),
(196472, '2.40.50.140-FF-000843', NULL, NULL, 65, NULL, NULL, 196472),
(196473, '1.10.510.10-FF-002688', NULL, NULL, 201, NULL, NULL, 196473),
(196474, '3.40.50.300-FF-001096', NULL, 'Zinc finger NFX1-type containing 1', 209, NULL, NULL, 196474),
(196475, '3.40.50.720-FF-001957', NULL, 'Uncharacterized protein', 258, NULL, NULL, 196475),
(196476, '2.130.10.10-FF-000898', NULL, 'Predicted protein', 308, NULL, NULL, 196476),
(196477, '2.20.100.10-FF-000133', NULL, 'Complement factor properdin', 73, NULL, NULL, 196477),
(196478, '3.90.190.20-FF-000043', NULL, 'Folylpolyglutamate synthase', 196, NULL, NULL, 196478),
(196479, '1.20.1070.10-FF-000194', NULL, 'Vomeronasal type-1 receptor', 298, NULL, NULL, 196479),
(196480, '3.40.1110.10-FF-000309', NULL, NULL, 238, NULL, NULL, 196480),
(196481, '3.90.830.10-FF-000005', NULL, 'Sec1 family superfamily', 120, NULL, NULL, 196481),
(196482, '4.10.1060.10-FF-000002', NULL, 'RNA-binding protein EWS isoform 1', 38, NULL, NULL, 196482),
(196483, '2.60.40.10-FF-004338', NULL, NULL, 53, NULL, NULL, 196483),
(196484, '3.50.50.60-FF-001092', NULL, 'Flavin-containing monooxygenase', 269, NULL, NULL, 196484),
(196485, '3.30.200.20-FF-001250', NULL, 'Probable myosin light chain kinase DDB_G0275057', 97, NULL, NULL, 196485),
(196486, '2.60.40.2440-FF-000001', NULL, 'Protein phosphatase 1 regulatory subunit 3C', 127, NULL, NULL, 196486),
(196487, '1.10.510.10-FF-001586', NULL, 'Aurora kinase B', 89, NULL, NULL, 196487),
(196488, '1.10.150.60-FF-000016', NULL, 'Putative Lysine-specific demethylase 5B', 132, NULL, NULL, 196488),
(196489, '3.40.50.720-FF-000822', NULL, 'BnaA06g02810D protein', 158, NULL, NULL, 196489),
(196490, '1.10.150.50-FF-000013', NULL, 'Protein Smaug homolog 1 isoform 2', 62, NULL, NULL, 196490),
(196491, '3.30.200.20-FF-001542', NULL, NULL, 79, NULL, NULL, 196491),
(196492, '1.10.287.70-FF-000448', NULL, 'Predicted protein', 53, NULL, NULL, 196492),
(196493, '3.30.70.330-FF-002600', NULL, NULL, 133, NULL, NULL, 196493),
(196494, '1.20.1560.10-FF-000422', NULL, 'Uncharacterized protein', 16, NULL, NULL, 196494),
(196495, '2.130.10.10-FF-001915', NULL, 'Sema domain, immunoglobulin domain (Ig), short basic domain, secreted, (Semaphorin) 3F', 492, NULL, NULL, 196495),
(196496, '3.90.170.10-FF-000005', NULL, 'Adenylosuccinate synthetase', 49, NULL, NULL, 196496);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(196497, '3.20.20.100-FF-000051', NULL, 'Putative pyridoxal reductase (AKR8)', 321, NULL, NULL, 196497),
(196498, '1.20.58.760-FF-000031', NULL, 'FtsH-like AAA+ protein', 238, NULL, NULL, 196498),
(196499, '1.10.10.350-FF-000021', NULL, 'Glutamate--tRNA ligase', 97, NULL, NULL, 196499),
(196500, '1.20.1070.10-FF-000840', NULL, 'tachykinin receptor isoform X2', 338, NULL, NULL, 196500),
(196501, '1.25.40.10-FF-005012', NULL, 'Uncharacterized protein', 115, NULL, NULL, 196501),
(196502, '3.80.10.10-FF-001202', NULL, 'Gastrulation-defective protein 3', 271, NULL, NULL, 196502),
(196503, '3.30.160.20-FF-000026', NULL, 'ATP-dependent RNA helicase A', 87, NULL, NULL, 196503),
(196504, '3.30.420.40-FF-000957', NULL, 'Actin-related protein 8', 36, NULL, NULL, 196504),
(196505, '2.60.40.60-FF-000469', NULL, 'Cadherin-related family member 5', 105, NULL, NULL, 196505),
(196506, '3.40.1110.10-FF-000074', NULL, 'Phospholipid-transporting ATPase', 22, NULL, NULL, 196506),
(196507, '3.40.50.410-FF-000055', NULL, 'X-ray repair cross-complementing protein 5', 240, NULL, NULL, 196507),
(196508, '3.90.1150.10-FF-000464', NULL, 'Glutamine--scyllo-inositol transaminase', 136, NULL, NULL, 196508),
(196509, '2.60.120.260-FF-000437', NULL, 'Beta-galactosidase BoGH2A', 161, NULL, NULL, 196509),
(196510, '1.25.40.470-FF-000030', NULL, 'Intraflagellar transport protein osm-1', 143, NULL, NULL, 196510),
(196511, '3.40.50.1820-FF-000292', NULL, 'Carboxylic ester hydrolase', 538, NULL, NULL, 196511),
(196512, '3.30.50.10-FF-000066', NULL, 'Hormone receptor 83', 103, NULL, NULL, 196512),
(196513, '3.40.50.300-FF-003074', NULL, 'GTP-binding protein TEM1', 186, NULL, NULL, 196513),
(196514, '3.40.50.10490-FF-000070', NULL, 'MurR/RpiR family transcriptional regulator', 180, NULL, NULL, 196514),
(196515, '1.20.1530.20-FF-000098', NULL, 'Putative sodium/metabolite cotransporter BASS4 chloroplastic', 199, NULL, NULL, 196515),
(196516, '3.30.830.10-FF-000255', NULL, 'Uncharacterized protein', 126, NULL, NULL, 196516),
(196517, '2.60.40.10-FF-000302', NULL, 'Down syndrome cell adhesion molecule, isoform D', 81, NULL, NULL, 196517),
(196518, '1.20.1550.10-FF-000006', NULL, 'Disulfide bond formation protein B', 173, NULL, NULL, 196518),
(196519, '2.30.42.10-FF-000089', NULL, 'multiple PDZ domain protein isoform X1', 116, NULL, NULL, 196519),
(196520, '1.25.40.10-FF-004495', NULL, 'Uncharacterized protein', 96, NULL, NULL, 196520),
(196521, '3.40.50.300-FF-005457', NULL, 'ABC multidrug transporter (Eurofung)', 234, NULL, NULL, 196521),
(196522, '3.40.50.2300-FF-000924', NULL, NULL, 231, NULL, NULL, 196522),
(196523, '3.40.50.1820-FF-001808', NULL, 'Predicted protein', 125, NULL, NULL, 196523),
(196524, '1.10.10.750-FF-000051', NULL, 'AAR091Wp', 49, NULL, NULL, 196524),
(196525, '3.10.390.10-FF-000017', NULL, 'Uncharacterized protein', 60, NULL, NULL, 196525),
(196526, '3.40.50.300-FF-004968', NULL, 'Uncharacterized protein', 96, NULL, NULL, 196526),
(196527, '3.40.50.150-FF-001562', NULL, NULL, 74, NULL, NULL, 196527),
(196528, '1.10.10.2590-FF-000007', NULL, 'Uncharacterized protein', 112, NULL, NULL, 196528),
(196529, '3.40.50.720-FF-000530', NULL, 'D-amino acid oxidase, putative', 169, NULL, NULL, 196529),
(196530, '3.40.50.2000-FF-000750', NULL, 'Capsular polysaccharide biosynthesis protein', 149, NULL, NULL, 196530),
(196531, '3.30.70.330-FF-000655', NULL, 'serine/arginine-rich splicing factor RS41 isoform X2', 129, NULL, NULL, 196531),
(196532, '3.40.50.10090-FF-000040', NULL, 'Porphyrin biosynthesis protein [includes: uroporphyrin-III C-methyltransferase and uroporphyrinogen-III synthase', 106, NULL, NULL, 196532),
(196533, '3.30.450.20-FF-000453', NULL, 'Calcium voltage-gated channel auxiliary subunit alpha2delta 1', 66, NULL, NULL, 196533),
(196534, '2.60.40.420-FF-000196', NULL, 'Cytochrome B', 98, NULL, NULL, 196534),
(196535, '3.30.40.10-FF-000094', NULL, 'E3 ubiquitin-protein ligase MIB2 isoform X1', 64, NULL, NULL, 196535),
(196536, '3.30.505.10-FF-000258', NULL, NULL, 99, NULL, NULL, 196536),
(196537, '1.10.238.10-FF-000817', NULL, 'EF hand family protein', 79, NULL, NULL, 196537);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(196538, '1.20.1250.20-FF-000262', NULL, 'Efflux MFS transporter YdeE', 384, NULL, NULL, 196538),
(196539, '1.25.40.10-FF-003067', NULL, 'Pentatricopeptide repeat-containing protein At3g62890', 205, NULL, NULL, 196539),
(196540, '3.90.1150.10-FF-000172', NULL, 'Kynureninase', 152, NULL, NULL, 196540),
(196541, '3.30.70.330-FF-000801', NULL, 'U4/U6 snRNA-associated-splicing factor,putative', 98, NULL, NULL, 196541),
(196542, '3.40.50.300-FF-007609', NULL, 'Uncharacterized protein', 158, NULL, NULL, 196542),
(196543, '1.25.40.470-FF-000058', NULL, 'Uncharacterized protein', 211, NULL, NULL, 196543),
(196544, '3.30.40.10-FF-000240', NULL, 'Nitric oxide synthase-interacting protein', 58, NULL, NULL, 196544),
(196545, '1.20.140.10-FF-000032', NULL, 'Thermophilic desulfurizing enzyme family protein', 184, NULL, NULL, 196545),
(196546, '3.40.190.10-FF-000826', NULL, 'Uncharacterized protein', 116, NULL, NULL, 196546),
(196547, '3.30.710.10-FF-000336', NULL, 'Zinc finger and BTB domain-containing 41', 142, NULL, NULL, 196547),
(196548, '1.25.40.10-FF-000515', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 169, NULL, NULL, 196548),
(196549, '2.70.220.10-FF-000001', NULL, 'GM2 ganglioside activator protein', 164, NULL, NULL, 196549),
(196550, '3.40.50.12780-FF-000195', NULL, 'Uncharacterized protein', 68, NULL, NULL, 196550),
(196551, '2.60.40.10-FF-005153', NULL, NULL, 95, NULL, NULL, 196551),
(196552, '3.30.230.10-FF-000198', NULL, 'DNA topoisomerase 2', 123, NULL, NULL, 196552),
(196553, '3.30.420.40-FF-000396', NULL, 'Actin, alpha 2, smooth muscle, aorta', 27, NULL, NULL, 196553),
(196554, '3.30.200.20-FF-000699', NULL, 'Serine/threonine-protein kinase RAD53', 85, NULL, NULL, 196554),
(196555, '1.10.238.10-FF-000790', NULL, 'Uncharacterized protein', 80, NULL, NULL, 196555),
(196556, '1.20.1270.60-FF-000224', NULL, 'Uncharacterized protein', 247, NULL, NULL, 196556),
(196557, '3.40.640.10-FF-000373', NULL, 'Uncharacterized protein', 207, NULL, NULL, 196557),
(196558, '2.60.120.830-FF-000007', NULL, 'Uncharacterized protein, isoform A', 140, NULL, NULL, 196558),
(196559, '3.90.20.20-FF-000019', NULL, 'Protein GrpE', 121, NULL, NULL, 196559),
(196560, '3.30.70.3490-FF-000025', NULL, 'Oxysterol binding protein 5, putative', 91, NULL, NULL, 196560),
(196561, '1.20.970.10-FF-000011', NULL, 'Thymidine phosphorylase', 67, NULL, NULL, 196561),
(196562, '3.30.70.270-FF-000204', NULL, NULL, 176, NULL, NULL, 196562),
(196563, '1.10.287.70-FF-000241', NULL, 'Predicted protein', 106, NULL, NULL, 196563),
(196564, '1.10.630.10-FF-000605', NULL, 'Uncharacterized protein', 264, NULL, NULL, 196564),
(196565, '1.25.40.10-FF-004169', NULL, 'Uncharacterized protein', 100, NULL, NULL, 196565),
(196566, '1.10.10.10-FF-001204', NULL, 'LysR family transcriptional regulator', 87, NULL, NULL, 196566),
(196567, '1.10.510.10-FF-003205', NULL, NULL, 145, NULL, NULL, 196567),
(196568, '3.30.300.30-FF-000035', NULL, 'L-2-aminoadipate reductase large subunit', 134, NULL, NULL, 196568),
(196569, '3.40.390.10-FF-000280', NULL, NULL, 117, NULL, NULL, 196569),
(196570, '1.20.1070.10-FF-000222', NULL, 'Adhesion G protein-coupled receptor G3', 281, NULL, NULL, 196570),
(196571, '1.10.510.10-FF-000743', NULL, 'Predicted protein', 190, NULL, NULL, 196571),
(196572, '3.40.50.360-FF-000051', NULL, 'FMN-dependent NADPH-azoreductase', 184, NULL, NULL, 196572),
(196573, '2.130.10.10-FF-005070', NULL, 'Uncharacterized protein', 270, NULL, NULL, 196573),
(196574, '3.80.10.10-FF-000185', NULL, 'Podocan', 97, NULL, NULL, 196574),
(196575, '3.40.718.10-FF-000020', NULL, 'Isocitrate dehydrogenase', 364, NULL, NULL, 196575),
(196576, '3.30.70.330-FF-001111', NULL, '31 kDa ribonucleoprotein, chloroplastic', 120, NULL, NULL, 196576),
(196577, '1.25.40.120-FF-000004', NULL, 'Protein farnesyltransferase/geranylgeranyltransferase type-1 subunit alpha', 329, NULL, NULL, 196577),
(196578, '3.30.710.10-FF-000515', NULL, 'Protein CBG12958', 62, NULL, NULL, 196578),
(196579, '4.10.240.10-FF-000002', NULL, 'Zn cluster transcription factor Rds2', 31, NULL, NULL, 196579);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(196580, '2.40.180.10-FF-000009', NULL, 'Lipoxygenase homology domain-containing protein 1', 128, NULL, NULL, 196580),
(196581, '3.30.70.330-FF-002246', NULL, NULL, 92, NULL, NULL, 196581),
(196582, '3.40.50.300-FF-006385', NULL, 'Uncharacterized protein', 135, NULL, NULL, 196582),
(196583, '2.10.25.10-FF-000522', NULL, 'Notch receptor 3', 41, NULL, NULL, 196583),
(196584, '2.120.10.30-FF-000427', NULL, 'Uncharacterized protein', 145, NULL, NULL, 196584),
(196585, '2.60.40.10-FF-000948', NULL, 'Roundabout 1', 98, NULL, NULL, 196585),
(196586, '2.30.30.40-FF-000031', NULL, 'SH3 and PX domain-containing protein 2A', 66, NULL, NULL, 196586),
(196587, '3.30.260.10-FF-000054', NULL, 'T-complex protein 1 subunit zeta', 106, NULL, NULL, 196587),
(196588, '1.20.1720.10-FF-000132', NULL, NULL, 107, NULL, NULL, 196588),
(196589, '3.30.430.20-FF-000036', NULL, 'Cysteine-rich receptor-like protein kinase 25', 106, NULL, NULL, 196589),
(196590, '3.30.40.10-FF-000801', NULL, 'PIB2p protein', 93, NULL, NULL, 196590),
(196591, '1.25.10.10-FF-002458', NULL, 'Uncharacterized protein', 222, NULL, NULL, 196591),
(196592, '1.10.510.10-FF-004020', NULL, NULL, 121, NULL, NULL, 196592),
(196593, '1.10.400.10-FF-000089', NULL, 'G protein subunit alpha 14', 16, NULL, NULL, 196593),
(196594, '3.80.10.10-FF-002130', NULL, 'Uncharacterized protein', 157, NULL, NULL, 196594),
(196595, '2.40.128.110-FF-000003', NULL, 'Conserved hypothetical secreted protein', 164, NULL, NULL, 196595),
(196596, '1.10.510.10-FF-001232', NULL, 'Predicted protein', 211, NULL, NULL, 196596),
(196597, '3.20.20.480-FF-000001', NULL, 'Trimethylamine methyltransferase', 483, NULL, NULL, 196597),
(196598, '2.60.440.10-FF-000003', NULL, NULL, 80, NULL, NULL, 196598),
(196599, '2.10.25.10-FF-000168', NULL, 'FAT atypical cadherin 4', 37, NULL, NULL, 196599),
(196600, '3.40.50.300-FF-005811', NULL, 'Uncharacterized protein', 251, NULL, NULL, 196600),
(196601, '3.40.50.300-FF-008537', NULL, 'Uncharacterized protein', 60, NULL, NULL, 196601),
(196602, '2.40.50.140-FF-000489', NULL, 'Putative RNA polymerase-like protein', 94, NULL, NULL, 196602),
(196603, '2.60.120.200-FF-000611', NULL, 'Predicted protein', 150, NULL, NULL, 196603),
(196604, '3.40.50.150-FF-000691', NULL, 'Bifunctional 3-demethylubiquinone-9 3-methyltransferase/ 2-octaprenyl-6-hydroxy phenol methylase', 155, NULL, NULL, 196604),
(196605, '1.25.40.20-FF-001187', NULL, 'Uncharacterized protein', 175, NULL, NULL, 196605),
(196606, '2.130.10.10-FF-004760', NULL, 'Uncharacterized protein', 157, NULL, NULL, 196606),
(196607, '2.60.40.3180-FF-000010', NULL, 'Uncharacterized protein', 149, NULL, NULL, 196607),
(196608, '3.30.1370.10-FF-000218', NULL, 'Vigilin 1', 88, NULL, NULL, 196608),
(196609, '3.30.450.280-FF-000001', NULL, 'Two component sensor kinase', 135, NULL, NULL, 196609),
(196610, '1.10.630.10-FF-000044', NULL, 'Cytochrome P450', 487, NULL, NULL, 196610),
(196611, '1.10.287.70-FF-000802', NULL, 'Predicted protein', 92, NULL, NULL, 196611),
(196612, '3.90.1310.10-FF-000027', NULL, 'Cell division protein ftsI', 35, NULL, NULL, 196612),
(196613, '1.20.1160.20-FF-000024', NULL, 'Uncharacterized protein', 53, NULL, NULL, 196613),
(196614, '1.10.1380.10-FF-000012', NULL, 'membrane metallo-endopeptidase-like 1', 331, NULL, NULL, 196614),
(196615, '1.10.10.10-FF-000979', NULL, 'Cullin-1, putative', 87, NULL, NULL, 196615),
(196616, '3.40.50.2000-FF-000424', NULL, '3-deoxy-D-manno-octulosonic acid transferase', 188, NULL, NULL, 196616),
(196617, '2.60.40.420-FF-000016', NULL, 'Monocopper oxidase-like protein', 199, NULL, NULL, 196617),
(196618, '3.90.190.10-FF-000214', NULL, 'Probable tyrosine-protein phosphatase F54C8.4', 212, NULL, NULL, 196618),
(196619, '3.30.740.10-FF-000017', NULL, 'Dynein light chain', 96, NULL, NULL, 196619),
(196620, '2.130.10.10-FF-004788', NULL, 'Novel protein-containing four WD domain, G-beta repeats', 150, NULL, NULL, 196620),
(196621, '2.60.40.10-FF-001258', NULL, 'Down syndrome cell adhesion molecule 4, isoform D', 107, NULL, NULL, 196621),
(196622, '1.25.10.10-FF-001323', NULL, 'Uncharacterized protein', 1034, NULL, NULL, 196622);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(196623, '3.30.420.10-FF-000235', NULL, 'DNA polymerase I', 193, NULL, NULL, 196623),
(196624, '1.10.238.10-FF-000997', NULL, 'Calcium-binding protein CML42', 36, NULL, NULL, 196624),
(196625, '1.10.287.1130-FF-000009', NULL, 'Cytochrome c oxidase copper chaperone', 42, NULL, NULL, 196625),
(196626, '3.40.50.300-FF-006300', NULL, 'DNA helicase', 127, NULL, NULL, 196626),
(196627, '3.90.110.10-FF-000029', NULL, NULL, 175, NULL, NULL, 196627),
(196628, '3.40.109.10-FF-000009', NULL, 'Coenzyme F420:L-glutamate ligase', 200, NULL, NULL, 196628),
(196629, '3.40.1190.20-FF-000031', NULL, '5-dehydro-2-deoxygluconokinase', 248, NULL, NULL, 196629),
(196630, '2.60.40.10-FF-004664', NULL, NULL, 101, NULL, NULL, 196630),
(196631, '2.40.128.130-FF-000009', NULL, 'Extracellular serine protease', 285, NULL, NULL, 196631),
(196632, '2.10.220.10-FF-000104', NULL, 'Receptor protein-tyrosine kinase', 120, NULL, NULL, 196632),
(196633, '1.10.489.10-FF-000001', NULL, 'Aromatic peroxygenase', 328, NULL, NULL, 196633),
(196634, '2.130.10.10-FF-003506', NULL, 'Uncharacterized protein', 240, NULL, NULL, 196634),
(196635, '2.130.10.10-FF-005277', NULL, 'Uncharacterized protein', 240, NULL, NULL, 196635),
(196636, '2.60.40.10-FF-001230', NULL, 'Immunoglobulin kappa variable 8-16', 107, NULL, NULL, 196636),
(196637, '3.10.110.10-FF-000295', NULL, 'Uncharacterized protein', 106, NULL, NULL, 196637),
(196638, '3.40.1090.10-FF-000077', NULL, 'Cytosolic phospholipase A2 gamma', 282, NULL, NULL, 196638),
(196639, '2.60.120.820-FF-000004', NULL, 'BTB/POZ domain-containing protein 2', 166, NULL, NULL, 196639),
(196640, '3.30.200.20-FF-002559', NULL, 'Uncharacterized protein', 64, NULL, NULL, 196640),
(196641, '4.10.860.10-FF-000027', NULL, NULL, 58, NULL, NULL, 196641),
(196642, '3.30.200.20-FF-000435', NULL, 'MO15-related protein kinase', 80, NULL, NULL, 196642),
(196643, '1.20.1070.10-FF-000076', NULL, 'Endothelin receptor type B', 335, NULL, NULL, 196643),
(196644, '3.40.718.10-FF-000019', NULL, 'Homoisocitrate dehydrogenase', 335, NULL, NULL, 196644),
(196645, '2.40.50.140-FF-001040', NULL, NULL, 133, NULL, NULL, 196645),
(196646, '1.10.1520.10-FF-000102', NULL, 'Uncharacterized protein', 139, NULL, NULL, 196646),
(196647, '1.10.357.10-FF-000066', NULL, 'TetR/AcrR family transcriptional regulator', 151, NULL, NULL, 196647),
(196648, '3.40.50.300-FF-004940', NULL, 'Uncharacterized protein', 160, NULL, NULL, 196648),
(196649, '3.30.160.60-FF-000836', NULL, 'E3 SUMO-protein ligase ZNF451 isoform X1', 79, NULL, NULL, 196649),
(196650, '1.20.58.250-FF-000001', NULL, 'DNA polymerase III, theta subunit', 76, NULL, NULL, 196650),
(196651, '3.30.70.330-FF-000094', NULL, 'SR-related CTD associated factor 8', 195, NULL, NULL, 196651),
(196652, '2.60.40.1940-FF-000003', NULL, 'CD109 isoform 1', 118, NULL, NULL, 196652),
(196653, '3.60.15.10-FF-000276', NULL, 'Predicted protein', 169, NULL, NULL, 196653),
(196654, '1.25.40.10-FF-001151', NULL, 'Pre-mRNA-splicing factor SYF1', 163, NULL, NULL, 196654),
(196655, '3.30.200.110-FF-000002', NULL, 'Inositol-pentakisphosphate 2-kinase', 157, NULL, NULL, 196655),
(196656, '2.130.10.10-FF-003006', NULL, 'Dynein intermediate chain 1, axonemal', 183, NULL, NULL, 196656),
(196657, '3.40.50.720-FF-002413', NULL, 'Predicted protein', 167, NULL, NULL, 196657),
(196658, '2.130.10.10-FF-001354', NULL, 'Flagellar outer dynein arm intermediate chain 2', 182, NULL, NULL, 196658),
(196659, '1.20.58.1030-FF-000043', NULL, 'Predicted protein', 84, NULL, NULL, 196659),
(196660, '1.10.357.50-FF-000027', NULL, 'Uncharacterized protein', 121, NULL, NULL, 196660),
(196661, '3.80.10.10-FF-000331', NULL, 'Dynein assembly factor 1, axonemal homolog', 103, NULL, NULL, 196661),
(196662, '1.20.58.1610-FF-000003', NULL, 'NADH-quinone oxidoreductase subunit A', 126, NULL, NULL, 196662),
(196663, '3.40.570.10-FF-000018', NULL, 'endonuclease G, mitochondrial-like', 239, NULL, NULL, 196663),
(196664, '3.40.50.1820-FF-000645', NULL, 'Lipase, putative', 78, NULL, NULL, 196664),
(196665, '1.10.490.160-FF-000007', NULL, NULL, 52, NULL, NULL, 196665);
INSERT INTO "PUBLIC"."MODEL" VALUES
(196666, '3.40.390.10-FF-000246', NULL, NULL, 15, NULL, NULL, 196666),
(196667, '2.60.120.260-FF-000084', NULL, 'CLUMA_CG013997, isoform A', 152, NULL, NULL, 196667),
(196668, '2.60.120.200-FF-000173', NULL, 'Cadherin EGF LAG seven-pass G-type receptor', 192, NULL, NULL, 196668),
(196669, '2.60.40.10-FF-005653', NULL, NULL, 90, NULL, NULL, 196669),
(196670, '3.80.10.10-FF-004075', NULL, 'Predicted protein', 299, NULL, NULL, 196670),
(196671, '2.90.10.30-FF-000002', NULL, 'Serine/threonine-protein kinase', 112, NULL, NULL, 196671),
(196672, '1.25.40.10-FF-004377', NULL, 'TPR Domain containing protein', 147, NULL, NULL, 196672),
(196673, '2.60.120.430-FF-000011', NULL, 'Os01g0140400 protein', 156, NULL, NULL, 196673),
(196674, '2.30.29.170-FF-000022', NULL, NULL, 137, NULL, NULL, 196674),
(196675, '2.40.50.90-FF-000092', NULL, 'Staphylococcal_nuclease_homologue /Tudor_domain_containing_protein_-_putative', 143, NULL, NULL, 196675),
(196676, '1.10.400.10-FF-000061', NULL, 'Uncharacterized protein', 26, NULL, NULL, 196676),
(196677, '2.60.410.10-FF-000001', NULL, 'D-alanyl-D-alanine carboxypeptidase dacA', 92, NULL, NULL, 196677),
(196678, '1.20.1050.130-FF-000017', NULL, 'Multisynthetase complex auxiliary component p43', 111, NULL, NULL, 196678),
(196679, '3.40.462.20-FF-000001', NULL, 'Berberine bridge enzyme-like 15', 186, NULL, NULL, 196679),
(196680, '1.10.287.10-FF-000037', NULL, 'Methionine-tRNA ligase', 47, NULL, NULL, 196680),
(196681, '3.30.720.50-FF-000005', NULL, 'Probable E3 ubiquitin-protein ligase DTX2', 87, NULL, NULL, 196681),
(196682, '1.10.340.70-FF-000028', NULL, 'Uncharacterized protein', 66, NULL, NULL, 196682),
(196683, '2.60.40.10-FF-004990', NULL, NULL, 108, NULL, NULL, 196683),
(196684, '2.60.40.420-FF-000224', NULL, 'Copper resistance protein A', 196, NULL, NULL, 196684),
(196685, '3.40.190.10-FF-000473', NULL, 'ABC transporter substrate-binding protein', 125, NULL, NULL, 196685),
(196686, '3.30.160.60-FF-005041', NULL, NULL, 27, NULL, NULL, 196686),
(196687, '2.40.10.10-FF-000695', NULL, NULL, 166, NULL, NULL, 196687),
(196688, '1.25.40.420-FF-000004', NULL, 'BTB/POZ domain-containing protein 2', 104, NULL, NULL, 196688),
(196689, '3.90.1150.10-FF-000290', NULL, 'Probable acetylornithine aminotransferase', 115, NULL, NULL, 196689),
(196690, '1.10.1040.10-FF-000054', NULL, 'Altronate oxidoreductase', 204, NULL, NULL, 196690),
(196691, '1.25.40.10-FF-004848', NULL, 'Uncharacterized protein', 135, NULL, NULL, 196691),
(196692, '3.30.930.10-FF-000234', NULL, 'Lysine--tRNA ligase', 349, NULL, NULL, 196692),
(196693, '3.30.1010.10-FF-000136', NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', 140, NULL, NULL, 196693),
(196694, '2.10.50.10-FF-000120', NULL, 'Uncharacterized protein', 66, NULL, NULL, 196694),
(196695, '2.30.30.140-FF-000122', NULL, 'Unplaced genomic scaffold supercont2.16, whole genome shotgun sequence', 51, NULL, NULL, 196695),
(196696, '3.40.50.720-FF-000794', NULL, 'Probable polyketide synthase 33', 259, NULL, NULL, 196696),
(196697, '2.30.42.10-FF-000117', NULL, 'partitioning defective 3 homolog B isoform X2', 115, NULL, NULL, 196697),
(196698, '3.40.50.10190-FF-000013', NULL, 'BRCA1 associated RING domain 1', 104, NULL, NULL, 196698),
(196699, '1.10.510.10-FF-003531', NULL, NULL, 240, NULL, NULL, 196699),
(196700, '2.60.40.1730-FF-000120', NULL, NULL, 57, NULL, NULL, 196700),
(196701, '1.25.10.10-FF-000598', NULL, 'Importin beta-4 subunit, putative', 645, NULL, NULL, 196701),
(196702, '1.20.1080.10-FF-000048', NULL, 'Putative uncharacterized protein YLL053C', 146, NULL, NULL, 196702),
(196703, '1.25.40.410-FF-000001', NULL, 'dedicator of cytokinesis protein 9 isoform X2', 149, NULL, NULL, 196703),
(196704, '1.25.40.10-FF-001622', NULL, 'Trafficking protein particle complex 12', 84, NULL, NULL, 196704),
(196705, '3.40.50.300-FF-007048', NULL, 'Uncharacterized protein', 199, NULL, NULL, 196705),
(196706, '1.25.10.10-FF-003301', NULL, 'Serine/threonine-protein kinase TOR', 485, NULL, NULL, 196706),
(196707, '2.60.40.2300-FF-000010', NULL, 'Neutral ceramidase', 135, NULL, NULL, 196707);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(196708, '2.60.40.550-FF-000004', NULL, 'Ecotin-like protein 2', 145, NULL, NULL, 196708),
(196709, '3.40.50.1000-FF-000787', NULL, NULL, 55, NULL, NULL, 196709),
(196710, '3.20.110.10-FF-000039', NULL, 'Alpha-mannosidase', 197, NULL, NULL, 196710),
(196711, '3.10.580.20-FF-000001', NULL, 'Chloride channel protein', 87, NULL, NULL, 196711),
(196712, '2.160.10.10-FF-000094', NULL, 'Serine acetyltransferase', 109, NULL, NULL, 196712),
(196713, '3.60.15.10-FF-000219', NULL, 'Uncharacterized protein', 184, NULL, NULL, 196713),
(196714, '3.40.50.300-FF-003248', NULL, 'Pre-mRNA-splicing helicase BRR2', 201, NULL, NULL, 196714),
(196715, '2.130.10.10-FF-002489', NULL, 'WD repeat domain 66', 185, NULL, NULL, 196715),
(196716, '3.40.50.2000-FF-000306', NULL, 'Glycosyltransferase', 240, NULL, NULL, 196716),
(196717, '1.10.630.10-FF-000252', NULL, 'Cytochrome P450, putative', 303, NULL, NULL, 196717),
(196718, '1.25.40.20-FF-001625', NULL, 'Kinase, NEK', 97, NULL, NULL, 196718),
(196719, '3.30.200.20-FF-002144', NULL, 'Uncharacterized protein', 69, NULL, NULL, 196719),
(196720, '3.30.70.330-FF-002864', NULL, NULL, 77, NULL, NULL, 196720),
(196721, '2.40.128.680-FF-000005', NULL, 'Uncharacterized protein', 150, NULL, NULL, 196721),
(196722, '1.25.40.10-FF-002286', NULL, 'UTP6 small subunit processome component', 137, NULL, NULL, 196722),
(196723, '3.30.900.10-FF-000053', NULL, 'Uncharacterized protein', 250, NULL, NULL, 196723),
(196724, '3.30.450.330-FF-000005', NULL, 'Cell division protein FtsI [Peptidoglycan synthetase]', 124, NULL, NULL, 196724),
(196725, '1.10.890.20-FF-000004', NULL, NULL, 49, NULL, NULL, 196725),
(196726, '3.30.160.60-FF-001387', NULL, 'Zinc finger protein 354B', 27, NULL, NULL, 196726),
(196727, '3.90.230.10-FF-000010', NULL, 'Methionine aminopeptidase', 300, NULL, NULL, 196727),
(196728, '2.30.30.100-FF-000161', NULL, 'Small nuclear ribonucleoprotein G', 104, NULL, NULL, 196728),
(196729, '3.40.50.11060-FF-000016', NULL, 'Predicted protein', 130, NULL, NULL, 196729),
(196730, '1.25.40.430-FF-000007', NULL, 'Mitotic checkpoint serine/threonine-protein kinase BUB1', 150, NULL, NULL, 196730),
(196731, '2.10.25.10-FF-000376', NULL, 'usherin', 53, NULL, NULL, 196731),
(196732, '3.30.200.20-FF-000906', NULL, 'CRE-MNK-1 protein', 81, NULL, NULL, 196732),
(196733, '3.30.70.330-FF-000773', NULL, 'Polyadenylate-binding protein', 133, NULL, NULL, 196733),
(196734, '1.25.10.10-FF-001115', NULL, 'STE-group protein kinase', 206, NULL, NULL, 196734),
(196735, '4.10.400.10-FF-000122', NULL, 'Suppressor of tumorigenicity 14 protein homolog', 40, NULL, NULL, 196735),
(196736, '2.60.40.10-FF-000387', NULL, 'Neuroplastin b', 102, NULL, NULL, 196736),
(196737, '3.30.390.30-FF-000013', NULL, 'Monodehydroascorbate reductase 3', 89, NULL, NULL, 196737),
(196738, '1.10.10.10-FF-000479', NULL, 'Predicted protein', 101, NULL, NULL, 196738),
(196739, '3.30.70.330-FF-000829', NULL, 'Putative U2 auxiliary factor small subunit, Nucleotide-binding alpha-beta plait domain protein', 105, NULL, NULL, 196739),
(196740, '1.20.120.220-FF-000008', NULL, 'ATP synthase subunit a', 158, NULL, NULL, 196740),
(196741, '2.30.29.30-FF-000250', NULL, 'Sesquipedalian-1 isoform A', 104, NULL, NULL, 196741),
(196742, '3.80.10.10-FF-002630', NULL, 'Tubulin-specific chaperone E', 164, NULL, NULL, 196742),
(196743, '3.90.1010.10-FF-000015', NULL, 'SufE-like protein, chloroplastic', 141, NULL, NULL, 196743),
(196744, '3.30.70.330-FF-002807', NULL, NULL, 94, NULL, NULL, 196744),
(196745, '1.10.890.10-FF-000001', NULL, 'Acid stress chaperone HdeA', 89, NULL, NULL, 196745),
(196746, '2.130.10.10-FF-004434', NULL, 'WD-repeat protein, putative', 357, NULL, NULL, 196746),
(196747, '3.40.50.300-FF-005283', NULL, 'Ras-like small GTPase, putative', 177, NULL, NULL, 196747),
(196748, '1.20.120.1320-FF-000020', NULL, NULL, 95, NULL, NULL, 196748),
(196749, '3.90.320.10-FF-000040', NULL, 'Yeast DNA helicase/endonuclease family', 184, NULL, NULL, 196749),
(196750, '2.40.10.10-FF-000369', NULL, NULL, 108, NULL, NULL, 196750),
(196751, '3.30.450.20-FF-000627', NULL, 'Sensory transduction histidine kinase', 122, NULL, NULL, 196751); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(196752, '3.40.50.300-FF-005603', NULL, 'Dicer-1, putative', 171, NULL, NULL, 196752),
(196753, '1.10.10.1500-FF-000001', NULL, 'ribosomal oxygenase 1 isoform X1', 63, NULL, NULL, 196753),
(196754, '3.30.70.360-FF-000052', NULL, 'Peptidase T', 112, NULL, NULL, 196754),
(196755, '3.40.630.30-FF-000030', NULL, 'NATD1 isoform 1', 94, NULL, NULL, 196755),
(196756, '3.40.50.11040-FF-000010', NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', 208, NULL, NULL, 196756),
(196757, '3.30.200.20-FF-001424', NULL, 'Cyclin-dependent kinase 15', 47, NULL, NULL, 196757),
(196758, '2.30.29.30-FF-001031', NULL, 'FERM, ARH/RhoGEF and pleckstrin domain protein 2', 110, NULL, NULL, 196758),
(196759, '1.10.287.130-FF-000236', NULL, 'Sensor histidine kinase, PAS and GAF domain-containing', 101, NULL, NULL, 196759),
(196760, '2.30.30.40-FF-000677', NULL, 'Uncharacterized protein', 66, NULL, NULL, 196760),
(196761, '3.30.70.330-FF-001026', NULL, 'Sporulation-specific protein 2', 110, NULL, NULL, 196761),
(196762, '3.30.40.10-FF-000386', NULL, 'E3 ubiquitin-protein ligase TRIM13', 84, NULL, NULL, 196762),
(196763, '1.10.8.10-FF-000113', NULL, 'Ubiquitin-associated and SH3 domain-containing protein A', 45, NULL, NULL, 196763),
(196764, '3.40.50.2300-FF-001498', NULL, NULL, 117, NULL, NULL, 196764),
(196765, '2.130.10.10-FF-003214', NULL, 'Elongator acetyltransferase complex subunit 2', 52, NULL, NULL, 196765),
(196766, '2.10.110.10-FF-000276', NULL, 'ABL207Wp', 78, NULL, NULL, 196766),
(196767, '3.20.20.20-FF-000028', NULL, 'Dihydropteroate synthase', 276, NULL, NULL, 196767),
(196768, '1.10.10.60-FF-000680', NULL, 'Cone-rod homeobox, opposite strand', 60, NULL, NULL, 196768),
(196769, '3.30.40.10-FF-002038', NULL, 'Uncharacterized protein', 97, NULL, NULL, 196769),
(196770, '3.10.180.10-FF-000097', NULL, 'Biphenyl-2,3-diol 1,2-dioxygenase III', 138, NULL, NULL, 196770),
(196771, '3.80.20.20-FF-000099', NULL, 'Receptor protein-tyrosine kinase', 212, NULL, NULL, 196771),
(196772, '2.60.15.10-FF-000025', NULL, 'ATP synthase epsilon chain', 129, NULL, NULL, 196772),
(196773, '3.30.479.20-FF-000064', NULL, 'Elongation factor Ts, mitochondrial', 122, NULL, NULL, 196773),
(196774, '1.20.1050.10-FF-000277', NULL, 'Os02g0319300 protein', 77, NULL, NULL, 196774),
(196775, '3.30.200.20-FF-000761', NULL, 'Non-specific serine/threonine protein kinase', 142, NULL, NULL, 196775),
(196776, '4.10.280.10-FF-000033', NULL, 'Transcription factor HES-5', 64, NULL, NULL, 196776),
(196777, '3.20.20.10-FF-000025', NULL, 'Diaminopimelate decarboxylase, putative', 244, NULL, NULL, 196777),
(196778, '1.10.510.10-FF-002749', NULL, NULL, 153, NULL, NULL, 196778),
(196779, '3.40.30.10-FF-000160', NULL, 'Peroxiredoxin family protein/glutaredoxin', 159, NULL, NULL, 196779),
(196780, '2.60.40.10-FF-002101', NULL, 'Cytotoxic T-lymphocyte protein 4', 133, NULL, NULL, 196780),
(196781, '2.130.10.10-FF-001680', NULL, 'Small nucleolar ribonucleoprotein complex subunit (Pwp2), putative', 202, NULL, NULL, 196781),
(196782, '1.25.40.10-FF-000841', NULL, 'RNA polymerase-associated protein CTR9 homolog', 191, NULL, NULL, 196782),
(196783, '3.40.50.10680-FF-000003', NULL, '2-phospho-L-lactate transferase', 31, NULL, NULL, 196783),
(196784, '2.60.40.10-FF-005445', NULL, NULL, 102, NULL, NULL, 196784),
(196785, '3.40.50.300-FF-006738', NULL, 'Tight junction protein 1a', 69, NULL, NULL, 196785),
(196786, '2.60.120.380-FF-000035', NULL, 'Putative calpain', 141, NULL, NULL, 196786),
(196787, '1.50.10.20-FF-000132', NULL, 'Protein farnesyltransferase subunit beta', 399, NULL, NULL, 196787),
(196788, '1.10.3430.10-FF-000039', NULL, 'Ammonium transporter family', 369, NULL, NULL, 196788),
(196789, '2.40.50.40-FF-000127', NULL, 'C.Elegans Chromodomain protein', 93, NULL, NULL, 196789),
(196790, '3.40.50.300-FF-004676', NULL, 'Type II secretion system protein E', 275, NULL, NULL, 196790),
(196791, '3.40.190.10-FF-000944', NULL, 'Predicted protein', 22, NULL, NULL, 196791),
(196792, '2.30.30.100-FF-000009', NULL, 'U6 snRNA-associated Sm-like protein LSm2', 95, NULL, NULL, 196792);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(196793, '3.30.300.110-FF-000002', NULL, 'tRNA wybutosine-synthesizing protein 2 homolog', 71, NULL, NULL, 196793),
(196794, '2.130.10.10-FF-005305', NULL, 'Predicted protein', 213, NULL, NULL, 196794),
(196795, '3.40.50.300-FF-002995', NULL, 'BRCA1-interacting protein C-terminal helicase 1', 60, NULL, NULL, 196795),
(196796, '3.90.226.10-FF-000225', NULL, 'Ethylmalonyl-CoA decarboxylase', 250, NULL, NULL, 196796),
(196797, '3.30.160.60-FF-003332', NULL, 'GM26116', 26, NULL, NULL, 196797),
(196798, '1.10.20.140-FF-000022', NULL, NULL, 66, NULL, NULL, 196798),
(196799, '1.25.40.20-FF-000844', NULL, 'Glycerophosphocholine phosphodiesterase GDE1', 210, NULL, NULL, 196799),
(196800, '1.20.1560.10-FF-000361', NULL, 'Uncharacterized protein', 258, NULL, NULL, 196800),
(196801, '1.20.1270.60-FF-000050', NULL, 'RhoGAP and Fes/CIP4 domain protein', 126, NULL, NULL, 196801),
(196802, '1.10.510.10-FF-001614', NULL, 'Nerve growth factor receptor TRKA, putative', 242, NULL, NULL, 196802),
(196803, '3.40.50.720-FF-000058', NULL, 'Putative oxidoreductase GLYR1 homolog', 165, NULL, NULL, 196803),
(196804, '3.80.10.10-FF-000477', NULL, 'Mimecan', 81, NULL, NULL, 196804),
(196805, '3.40.30.10-FF-000042', NULL, 'protein disulfide-isomerase A2', 101, NULL, NULL, 196805),
(196806, '3.80.10.10-FF-003765', NULL, 'Uncharacterized protein', 114, NULL, NULL, 196806),
(196807, '3.40.47.10-FF-000165', NULL, 'Fatty acid synthase, putative (JCVI)', 253, NULL, NULL, 196807),
(196808, '1.20.1560.10-FF-000304', NULL, 'ABC transporter B family member 15', 86, NULL, NULL, 196808),
(196809, '1.20.1250.10-FF-000141', NULL, NULL, 45, NULL, NULL, 196809),
(196810, '1.20.58.1120-FF-000036', NULL, 'Dynein heavy chain', 181, NULL, NULL, 196810),
(196811, '1.20.1250.20-FF-000615', NULL, 'MFS transporter', 189, NULL, NULL, 196811),
(196812, '2.40.50.140-FF-000635', NULL, 'MoRTal germline', 153, NULL, NULL, 196812),
(196813, '3.40.50.1950-FF-000015', NULL, 'Mersacidin decarboxylase', 194, NULL, NULL, 196813),
(196814, '1.10.4160.10-FF-000029', NULL, 'Probable conserved integral membrane protein', 343, NULL, NULL, 196814),
(196815, '2.30.29.70-FF-000003', NULL, 'Regulatory particle non-ATPase', 94, NULL, NULL, 196815),
(196816, '3.90.810.10-FF-000004', NULL, 'CDC42 small effector protein 2', 46, NULL, NULL, 196816),
(196817, '3.40.50.1010-FF-000262', NULL, NULL, 178, NULL, NULL, 196817),
(196818, '2.120.10.30-FF-000399', NULL, 'Tyrosine-protein kinase receptor', 228, NULL, NULL, 196818),
(196819, '3.90.1530.10-FF-000010', NULL, 'Sulfiredoxin', 101, NULL, NULL, 196819),
(196820, '3.20.180.20-FF-000047', NULL, 'Uncharacterized protein', 51, NULL, NULL, 196820),
(196821, '1.20.1250.20-FF-001279', NULL, 'Uncharacterized protein', 486, NULL, NULL, 196821),
(196822, '2.40.30.10-FF-000168', NULL, 'Elongation factor 1-alpha 2', 88, NULL, NULL, 196822),
(196823, '1.10.472.10-FF-000496', NULL, 'Retinoblastoma protein', 189, NULL, NULL, 196823),
(196824, '2.130.10.10-FF-003271', NULL, 'Putative histone H3 lys4 methyltransferase complex and rna cleavage factor ii complex', 174, NULL, NULL, 196824),
(196825, '3.90.190.10-FF-000068', NULL, 'receptor-type tyrosine-protein phosphatase zeta', 295, NULL, NULL, 196825),
(196826, '2.160.20.10-FF-000274', NULL, 'Uncharacterized protein', 251, NULL, NULL, 196826),
(196827, '2.30.29.230-FF-000001', NULL, 'Small G protein signaling modulator 2', 179, NULL, NULL, 196827),
(196828, '3.30.200.20-FF-002352', NULL, 'Mitogen-activated protein kinase kinase kinase 4', 47, NULL, NULL, 196828),
(196829, '2.30.29.30-FF-000721', NULL, 'Basic proline-rich protein, putative', 139, NULL, NULL, 196829),
(196830, '3.40.30.10-FF-001177', NULL, 'Glutathione S-transferase family protein', 122, NULL, NULL, 196830),
(196831, '2.40.240.20-FF-000017', NULL, NULL, 61, NULL, NULL, 196831),
(196832, '3.30.420.40-FF-000749', NULL, 'Uncharacterized protein', 171, NULL, NULL, 196832),
(196833, '2.30.30.100-FF-000217', NULL, 'Uncharacterized protein', 78, NULL, NULL, 196833),
(196834, '3.80.10.10-FF-002422', NULL, 'Uncharacterized protein', 121, NULL, NULL, 196834);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(196835, '2.130.10.10-FF-005423', NULL, 'Uncharacterized protein', 255, NULL, NULL, 196835),
(196836, '3.40.1190.20-FF-000205', NULL, NULL, 145, NULL, NULL, 196836),
(196837, '3.30.710.10-FF-000128', NULL, 'galectin-3-binding protein precursor', 151, NULL, NULL, 196837),
(196838, '2.60.40.60-FF-000677', NULL, 'Uncharacterized protein', 90, NULL, NULL, 196838),
(196839, '3.40.367.20-FF-000021', NULL, 'Phosphotransferase', 263, NULL, NULL, 196839),
(196840, '3.40.50.300-FF-001860', NULL, 'ATP-dependent RNA helicase A, putative', 176, NULL, NULL, 196840),
(196841, '1.20.1250.20-FF-002206', NULL, 'Predicted protein', 143, NULL, NULL, 196841),
(196842, '1.25.40.10-FF-002932', NULL, 'Adenylate kinase isoenzyme 1', 97, NULL, NULL, 196842),
(196843, '3.40.50.2300-FF-000278', NULL, 'Glutamate receptor 1', 172, NULL, NULL, 196843),
(196844, '2.30.29.30-FF-000042', NULL, 'pleckstrin homology domain-containing family A member 1 isoform X2', 102, NULL, NULL, 196844),
(196845, '2.60.40.10-FF-003236', NULL, 'Interferon gamma receptor 2', 94, NULL, NULL, 196845),
(196846, '1.20.58.60-FF-000721', NULL, 'Uncharacterized protein', 108, NULL, NULL, 196846),
(196847, '1.10.1200.240-FF-000005', NULL, 'Uncharacterized protein', 115, NULL, NULL, 196847),
(196848, '1.10.620.20-FF-000018', NULL, 'Ribonucleoside-diphosphate reductase small chain', 316, NULL, NULL, 196848),
(196849, '3.80.10.10-FF-000213', NULL, 'Tyrosine-sulfated glycopeptide receptor 1', 336, NULL, NULL, 196849),
(196850, '1.25.40.10-FF-001358', NULL, 'Pentatricopeptide repeat-containing protein isoform A', 93, NULL, NULL, 196850),
(196851, '1.20.1070.10-FF-001975', NULL, 'Uncharacterized protein', 177, NULL, NULL, 196851),
(196852, '3.40.50.300-FF-001803', NULL, 'Helicase with zinc finger 2', 335, NULL, NULL, 196852),
(196853, '1.10.540.10-FF-000014', NULL, 'Acyl-coenzyme A oxidase 4, peroxisomal', 134, NULL, NULL, 196853),
(196854, '2.60.40.10-FF-004838', NULL, NULL, 64, NULL, NULL, 196854),
(196855, '2.130.10.10-FF-000691', NULL, 'Telomerase protein component 1', 174, NULL, NULL, 196855),
(196856, '3.50.50.60-FF-000338', NULL, 'D-amino acid dehydrogenase', 151, NULL, NULL, 196856),
(196857, '3.30.200.20-FF-001216', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 1-like Protein', 121, NULL, NULL, 196857),
(196858, '3.40.50.10380-FF-000003', NULL, 'NADP-dependent malic enzyme', 160, NULL, NULL, 196858),
(196859, '3.30.420.10-FF-000061', NULL, 'PARN like, ribonuclease domain containing 1', 234, NULL, NULL, 196859),
(196860, '2.10.109.10-FF-000059', NULL, 'Uncharacterized protein', 114, NULL, NULL, 196860),
(196861, '1.10.4190.10-FF-000003', NULL, 'Uncharacterized urease accessory protein UreF-like', 206, NULL, NULL, 196861),
(196862, '1.25.40.10-FF-005192', NULL, 'Tonsoku-like protein', 225, NULL, NULL, 196862),
(196863, '3.20.20.80-FF-000473', NULL, 'Putative exo-beta-1,3-glucanase (GH5-family) member of the ScExg1-family (Eurofung)', 341, NULL, NULL, 196863),
(196864, '1.25.40.180-FF-000095', NULL, 'Nuclear cap binding protein subunit 1', 215, NULL, NULL, 196864),
(196865, '1.10.10.10-FF-000687', NULL, 'LysR family transcriptional regulator', 84, NULL, NULL, 196865),
(196866, '3.80.10.10-FF-001495', NULL, 'Protein CBR-DMA-1', 126, NULL, NULL, 196866),
(196867, '1.20.5.360-FF-000001', NULL, 'Pulmonary surfactant-associated protein D', 39, NULL, NULL, 196867),
(196868, '3.10.20.90-FF-000937', NULL, 'Rho GTPase-activating protein gacG', 79, NULL, NULL, 196868),
(196869, '1.20.140.40-FF-000075', NULL, NULL, 131, NULL, NULL, 196869),
(196870, '1.10.510.10-FF-000597', NULL, 'serine/threonine-protein kinase Nek6 isoform X2', 189, NULL, NULL, 196870),
(196871, '1.10.10.10-FF-001704', NULL, 'Transcriptional regulator lysR family', 83, NULL, NULL, 196871),
(196872, '3.30.230.130-FF-000087', NULL, 'LD29662p', 137, NULL, NULL, 196872),
(196873, '1.25.40.10-FF-002639', NULL, 'Peroxisomal biogenesis factor 5', 88, NULL, NULL, 196873),
(196874, '1.10.3380.20-FF-000015', NULL, NULL, 111, NULL, NULL, 196874),
(196875, '3.30.200.20-FF-000553', NULL, 'Mitogen-activated protein kinase', 84, NULL, NULL, 196875);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(196876, '1.10.3380.10-FF-000012', NULL, 'DEAD/DEAH box DNA helicase', 151, NULL, NULL, 196876),
(196877, '1.20.1050.10-FF-000013', NULL, 'Glutathione S-transferase GstB', 118, NULL, NULL, 196877),
(196878, '1.25.40.90-FF-000084', NULL, 'zinc finger protein 55 isoform X1', 124, NULL, NULL, 196878),
(196879, '1.10.510.10-FF-001171', NULL, 'CMGC family protein kinase', 258, NULL, NULL, 196879),
(196880, '2.30.42.10-FF-000235', NULL, 'Tyrosine-protein phosphatase', 103, NULL, NULL, 196880),
(196881, '3.30.70.1470-FF-000003', NULL, 'Caspase-1', 88, NULL, NULL, 196881),
(196882, '1.25.40.20-FF-000170', NULL, 'Ankyrin repeat protein', 193, NULL, NULL, 196882),
(196883, '3.40.50.2000-FF-001121', NULL, 'Uncharacterized protein', 191, NULL, NULL, 196883),
(196884, '1.20.58.1120-FF-000070', NULL, NULL, 147, NULL, NULL, 196884),
(196885, '3.40.50.800-FF-000048', NULL, 'Uncharacterized protein, isoform B', 116, NULL, NULL, 196885),
(196886, '3.40.1180.10-FF-000022', NULL, 'Isoprenyl transferase', 237, NULL, NULL, 196886),
(196887, '1.10.510.10-FF-003059', NULL, NULL, 252, NULL, NULL, 196887),
(196888, '1.20.5.190-FF-000074', NULL, 'Sperm surface protein Sp17', 45, NULL, NULL, 196888),
(196889, '1.20.5.370-FF-000004', NULL, 'tropomyosin alpha-1 chain isoform X1', 47, NULL, NULL, 196889),
(196890, '3.40.1390.30-FF-000015', NULL, 'Nif3-like dinuclear metal center hexameric protein', 115, NULL, NULL, 196890),
(196891, '3.40.50.360-FF-000017', NULL, 'Protoporphyrinogen oxidase (PPO)', 173, NULL, NULL, 196891),
(196892, '2.60.40.10-FF-000887', NULL, 'leucine-rich repeat neuronal protein 2', 92, NULL, NULL, 196892),
(196893, '1.10.8.60-FF-000521', NULL, 'Cell division control protein 48 homolog D', 37, NULL, NULL, 196893),
(196894, '4.10.280.10-FF-000241', NULL, 'Predicted protein', 61, NULL, NULL, 196894),
(196895, '3.90.1720.30-FF-000002', NULL, 'Desumoylating isopeptidase 1', 168, NULL, NULL, 196895),
(196896, '1.10.10.1800-FF-000001', NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', 91, NULL, NULL, 196896),
(196897, '1.20.1560.10-FF-000804', NULL, 'Uncharacterized protein', 189, NULL, NULL, 196897),
(196898, '1.10.510.10-FF-000951', NULL, 'EKC/KEOPS complex subunit BUD32', 118, NULL, NULL, 196898),
(196899, '3.30.70.330-FF-002454', NULL, NULL, 85, NULL, NULL, 196899),
(196900, '1.20.1250.20-FF-001689', NULL, 'Solute carrier family 16 member 12a', 135, NULL, NULL, 196900),
(196901, '3.40.1110.10-FF-000220', NULL, 'Phospholipid-transporting ATPase', 150, NULL, NULL, 196901),
(196902, '3.60.130.10-FF-000009', NULL, 'Putative Taurine catabolism dioxygenase TauD', 298, NULL, NULL, 196902),
(196903, '3.30.2290.10-FF-000010', NULL, 'Metalloprotease TldD', 216, NULL, NULL, 196903),
(196904, '2.30.29.30-FF-000603', NULL, 'Unconventional myosin heavy chain 6', 109, NULL, NULL, 196904),
(196905, '3.30.565.10-FF-000559', NULL, 'Uncharacterized protein', 175, NULL, NULL, 196905),
(196906, '3.30.230.10-FF-000344', NULL, '40S ribosomal protein S2, putative', 38, NULL, NULL, 196906),
(196907, '1.10.1240.100-FF-000005', NULL, 'Polyketide synthase RzxE', 102, NULL, NULL, 196907),
(196908, '3.40.50.1460-FF-000110', NULL, 'Uncharacterized protein', 109, NULL, NULL, 196908),
(196909, '1.10.3380.30-FF-000018', NULL, 'DEAD/DEAH box helicase, putative', 228, NULL, NULL, 196909),
(196910, '2.60.40.1840-FF-000006', NULL, 'Uncharacterized protein', 77, NULL, NULL, 196910),
(196911, '1.20.1070.10-FF-001003', NULL, 'Protein CBG16999', 346, NULL, NULL, 196911),
(196912, '2.40.30.10-FF-000286', NULL, 'Ribosome-releasing factor 2, mitochondrial', 117, NULL, NULL, 196912),
(196913, '3.30.413.10-FF-000005', NULL, '4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase (flavodoxin)', 101, NULL, NULL, 196913),
(196914, '2.60.40.60-FF-000795', NULL, 'Uncharacterized protein', 102, NULL, NULL, 196914),
(196915, '3.80.10.10-FF-000685', NULL, 'Leucine-rich repeat receptor-like protein kinase', 77, NULL, NULL, 196915),
(196916, '3.30.70.141-FF-000021', NULL, 'Nucleoside diphosphate kinase A', 122, NULL, NULL, 196916),
(196917, '3.40.50.1820-FF-000527', NULL, 'Uncharacterized protein', 214, NULL, NULL, 196917); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(196918, '3.90.190.10-FF-000186', NULL, 'Dual specificity phosphatase 12', 156, NULL, NULL, 196918),
(196919, '3.20.100.10-FF-000005', NULL, 'Ctl1p', 305, NULL, NULL, 196919),
(196920, '3.40.50.300-FF-008419', NULL, 'RNA helicase aquarius', 125, NULL, NULL, 196920),
(196921, '2.130.10.30-FF-000084', NULL, 'E3 ubiquitin-protein ligase rpm-1', 214, NULL, NULL, 196921),
(196922, '2.130.10.10-FF-005069', NULL, 'Uncharacterized protein', 271, NULL, NULL, 196922),
(196923, '2.60.300.12-FF-000012', NULL, 'Iron-sulfur assembly protein', 136, NULL, NULL, 196923),
(196924, '3.30.470.20-FF-000218', NULL, 'Uncharacterized protein', 120, NULL, NULL, 196924),
(196925, '3.40.50.300-FF-001242', NULL, 'Protein-tyrosine sulfotransferase', 242, NULL, NULL, 196925),
(196926, '3.30.160.60-FF-004113', NULL, NULL, 30, NULL, NULL, 196926),
(196927, '3.30.559.30-FF-000068', NULL, 'L-2-aminoadipate reductase', 249, NULL, NULL, 196927),
(196928, '2.70.50.40-FF-000002', NULL, 'Retinal rod rhodopsin-sensitive cGMP 3'',5''-cyclic phosphodiesterase subunit delta', 150, NULL, NULL, 196928),
(196929, '3.30.160.60-FF-001707', NULL, 'Zinc finger protein 142', 92, NULL, NULL, 196929),
(196930, '3.40.50.150-FF-001623', NULL, NULL, 245, NULL, NULL, 196930),
(196931, '3.30.559.10-FF-000062', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 243, NULL, NULL, 196931),
(196932, '3.90.190.10-FF-000332', NULL, 'Uncharacterized protein', 326, NULL, NULL, 196932),
(196933, '3.80.10.10-FF-001966', NULL, 'PH domain and leucine rich repeat protein phosphatase 1', 161, NULL, NULL, 196933),
(196934, '1.10.575.10-FF-000010', NULL, 'Uncharacterized protein', 254, NULL, NULL, 196934),
(196935, '3.30.160.60-FF-001651', NULL, 'Zinc finger protein 311', 29, NULL, NULL, 196935),
(196936, '3.30.420.40-FF-001093', NULL, 'Uncharacterized protein', 82, NULL, NULL, 196936),
(196937, '1.10.510.10-FF-001114', NULL, 'Receptor-type guanylate cyclase gcy-4', 269, NULL, NULL, 196937),
(196938, '2.70.50.50-FF-000005', NULL, 'Uncharacterized protein', 214, NULL, NULL, 196938),
(196939, '3.50.50.60-FF-000838', NULL, 'Uncharacterized protein', 86, NULL, NULL, 196939),
(196940, '3.40.50.300-FF-000668', NULL, 'Chromosomal replication initiator protein DnaA', 168, NULL, NULL, 196940),
(196941, '3.30.40.10-FF-000329', NULL, 'Histone-lysine N-methyltransferase 2D', 49, NULL, NULL, 196941),
(196942, '1.10.510.10-FF-002396', NULL, 'Serine/threonine protein kinase-36', 232, NULL, NULL, 196942),
(196943, '1.25.40.10-FF-004641', NULL, 'Pentatricopeptide repeat-containing protein', 125, NULL, NULL, 196943),
(196944, '1.25.10.10-FF-002958', NULL, 'Predicted protein', 446, NULL, NULL, 196944),
(196945, '3.30.40.10-FF-002185', NULL, 'Predicted protein', 80, NULL, NULL, 196945),
(196946, '3.30.40.10-FF-000947', NULL, 'Zinc finger protein, putative', 60, NULL, NULL, 196946),
(196947, '1.10.20.10-FF-000098', NULL, 'Apoptosis-inducing TAF9-like domain 1 family protein, putative', 89, NULL, NULL, 196947),
(196948, '3.40.50.300-FF-003658', NULL, 'BnaA08g24620D protein', 273, NULL, NULL, 196948),
(196949, '1.10.3460.10-FF-000013', NULL, 'Chlorophyll a-b binding protein 3A, chloroplastic', 111, NULL, NULL, 196949),
(196950, '1.20.1410.10-FF-000030', NULL, 'Uncharacterized protein', 170, NULL, NULL, 196950),
(196951, '1.20.1070.10-FF-002021', NULL, 'Uncharacterized protein', 127, NULL, NULL, 196951),
(196952, '1.25.40.10-FF-005304', NULL, 'Uncharacterized protein', 127, NULL, NULL, 196952),
(196953, '3.40.190.10-FF-000591', NULL, 'p-protein', 87, NULL, NULL, 196953),
(196954, '3.90.1640.30-FF-000001', NULL, 'Single-stranded-DNA-specific exonuclease RecJ', 277, NULL, NULL, 196954),
(196955, '3.30.160.60-FF-005602', NULL, NULL, 28, NULL, NULL, 196955),
(196956, '1.20.1560.10-FF-000714', NULL, 'Uncharacterized protein', 282, NULL, NULL, 196956),
(196957, '2.60.40.10-FF-001292', NULL, 'PKHD1 like 1', 83, NULL, NULL, 196957),
(196958, '2.60.40.1090-FF-000001', NULL, 'Type-1 fimbrial major subunit', 150, NULL, NULL, 196958),
(196959, '2.130.10.10-FF-002809', NULL, 'Uncharacterized protein', 164, NULL, NULL, 196959);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(196960, '3.30.200.20-FF-000199', NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', 95, NULL, NULL, 196960),
(196961, '2.40.50.140-FF-000017', NULL, '30S ribosomal protein S1', 84, NULL, NULL, 196961),
(196962, '3.30.750.24-FF-000060', NULL, 'STAS domain protein', 112, NULL, NULL, 196962),
(196963, '1.25.40.180-FF-000207', NULL, NULL, 202, NULL, NULL, 196963),
(196964, '3.30.1330.90-FF-000015', NULL, 'D-3-phosphoglycerate dehydrogenase', 134, NULL, NULL, 196964),
(196965, '1.10.3210.30-FF-000006', NULL, 'Putative CRISPR-associated nuclease/helicase Cas3', 146, NULL, NULL, 196965),
(196966, '1.10.287.70-FF-000156', NULL, 'Voltage-gated sodium channel Nav2.1', 150, NULL, NULL, 196966),
(196967, '2.30.30.490-FF-000030', NULL, 'DNA (cytosine-5)-methyltransferase', 151, NULL, NULL, 196967),
(196968, '3.30.1330.80-FF-000012', NULL, 'Alpha-acetolactate decarboxylase', 94, NULL, NULL, 196968),
(196969, '2.60.40.10-FF-000010', NULL, 'receptor-type tyrosine-protein phosphatase delta isoform X1', 90, NULL, NULL, 196969),
(196970, '1.10.3370.10-FF-000040', NULL, 'Uncharacterized protein', 208, NULL, NULL, 196970),
(196971, '2.130.10.10-FF-003714', NULL, 'Uncharacterized protein', 297, NULL, NULL, 196971),
(196972, '1.10.45.10-FF-000003', NULL, 'Glycolate oxidase subunit GlcD', 40, NULL, NULL, 196972),
(196973, '2.70.240.10-FF-000002', NULL, 'Alpha hemolysin', 289, NULL, NULL, 196973),
(196974, '3.10.280.10-FF-000014', NULL, 'Mitochondrial glycoprotein, putative', 213, NULL, NULL, 196974),
(196975, '3.90.70.10-FF-000666', NULL, 'Uncharacterized protein', 303, NULL, NULL, 196975),
(196976, '3.40.50.2300-FF-000688', NULL, 'Guanylate cyclase', 174, NULL, NULL, 196976),
(196977, '3.60.10.10-FF-000315', NULL, 'Uncharacterized protein', 284, NULL, NULL, 196977),
(196978, '1.10.533.10-FF-000279', NULL, 'Predicted protein', 122, NULL, NULL, 196978),
(196979, '2.60.40.60-FF-000941', NULL, 'Uncharacterized protein', 117, NULL, NULL, 196979),
(196980, '1.20.1250.20-FF-002094', NULL, 'Uncharacterized protein', 253, NULL, NULL, 196980),
(196981, '2.60.120.200-FF-000139', NULL, 'FAT atypical cadherin 2', 164, NULL, NULL, 196981),
(196982, '2.30.29.30-FF-000457', NULL, 'Insulin receptor substrate 1', 111, NULL, NULL, 196982),
(196983, '1.20.5.320-FF-000006', NULL, 'Protein FAM132A', 45, NULL, NULL, 196983),
(196984, '3.30.160.60-FF-003096', NULL, 'ZFP57 zinc finger protein', 31, NULL, NULL, 196984),
(196985, '2.40.50.90-FF-000035', NULL, 'Probable endonuclease LCL3', 152, NULL, NULL, 196985),
(196986, '3.30.60.20-FF-000098', NULL, 'Diacylglycerol kinase', 64, NULL, NULL, 196986),
(196987, '2.60.40.10-FF-005035', NULL, NULL, 130, NULL, NULL, 196987),
(196988, '1.25.40.10-FF-000487', NULL, 'Pentatricopeptide repeat-containing protein', 88, NULL, NULL, 196988),
(196989, '3.40.50.300-FF-007082', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', 191, NULL, NULL, 196989),
(196990, '2.10.25.10-FF-000640', NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', 38, NULL, NULL, 196990),
(196991, '1.20.1070.10-FF-000694', NULL, 'Chemokine (C-X-C motif) receptor 2', 311, NULL, NULL, 196991),
(196992, '1.10.238.10-FF-001161', NULL, 'Uncharacterized protein', 108, NULL, NULL, 196992),
(196993, '1.10.510.10-FF-003323', NULL, NULL, 66, NULL, NULL, 196993),
(196994, '1.25.10.10-FF-003155', NULL, 'PIKK family atypical protein kinase', 645, NULL, NULL, 196994),
(196995, '1.20.1070.10-FF-000340', NULL, 'Uncharacterized protein', 324, NULL, NULL, 196995),
(196996, '2.130.10.10-FF-003624', NULL, 'Eukaryotic translation initiation factor 2A', 153, NULL, NULL, 196996),
(196997, '3.60.110.10-FF-000098', NULL, NULL, 270, NULL, NULL, 196997),
(196998, '1.10.10.10-FF-001143', NULL, 'DEAD/DEAH box helicase family protein', 91, NULL, NULL, 196998),
(196999, '3.40.50.150-FF-001680', NULL, NULL, 142, NULL, NULL, 196999),
(197000, '1.25.40.10-FF-002696', NULL, 'TPR repeat/Tetratricopeptide repeat, putative', 132, NULL, NULL, 197000),
(197001, '2.60.40.10-FF-004782', NULL, NULL, 80, NULL, NULL, 197001);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(197002, '3.40.50.10190-FF-000070', NULL, 'Transcription coactivator', 59, NULL, NULL, 197002),
(197003, '3.30.40.10-FF-000239', NULL, 'probable BOI-related E3 ubiquitin-protein ligase 2', 67, NULL, NULL, 197003),
(197004, '3.40.50.620-FF-000438', NULL, 'Leucine--tRNA ligase', 194, NULL, NULL, 197004),
(197005, '3.40.50.12780-FF-000077', NULL, 'Putative long-chain-fatty-acid--CoA ligase', 417, NULL, NULL, 197005),
(197006, '3.30.590.10-FF-000039', NULL, 'Uncharacterized protein', 205, NULL, NULL, 197006),
(197007, '2.170.180.11-FF-000002', NULL, 'Methuselah-like 15, isoform C', 120, NULL, NULL, 197007),
(197008, '3.40.50.720-FF-000940', NULL, 'Prephenate dehydrogenase', 166, NULL, NULL, 197008),
(197009, '1.25.40.10-FF-001504', NULL, 'Tetratricopeptide repeat protein 21B', 145, NULL, NULL, 197009),
(197010, '1.10.555.10-FF-000211', NULL, NULL, 72, NULL, NULL, 197010),
(197011, '1.10.10.10-FF-000833', NULL, 'DNA-binding response regulator', 99, NULL, NULL, 197011),
(197012, '3.30.160.380-FF-000010', NULL, NULL, 98, NULL, NULL, 197012),
(197013, '3.80.10.10-FF-002012', NULL, 'Leucine-rich repeat protein (LRRP), putative', 121, NULL, NULL, 197013),
(197014, '3.30.497.10-FF-000159', NULL, 'Serpin peptidase inhibitor 22', 59, NULL, NULL, 197014),
(197015, '3.80.10.10-FF-002276', NULL, 'Fgr51p', 260, NULL, NULL, 197015),
(197016, '2.170.140.10-FF-000044', NULL, 'Mucin related 89F, isoform C', 64, NULL, NULL, 197016),
(197017, '1.10.510.10-FF-001378', NULL, 'Serine/threonine kinase 3, putative', 278, NULL, NULL, 197017),
(197018, '2.130.10.10-FF-002697', NULL, 'G-protein beta subunit', 325, NULL, NULL, 197018),
(197019, '1.20.120.310-FF-000002', NULL, 'Sulfhydryl oxidase', 117, NULL, NULL, 197019),
(197020, '1.10.760.10-FF-000109', NULL, 'Cytochrome c family protein', 135, NULL, NULL, 197020),
(197021, '3.30.460.10-FF-000035', NULL, 'Poly(A) polymerase I', 162, NULL, NULL, 197021),
(197022, '2.120.10.80-FF-000189', NULL, 'Uncharacterized protein', 213, NULL, NULL, 197022),
(197023, '1.20.1260.10-FF-000023', NULL, 'Rubrerythrin', 146, NULL, NULL, 197023),
(197024, '2.130.10.10-FF-001415', NULL, 'aladin isoform X2', 156, NULL, NULL, 197024),
(197025, '2.20.70.10-FF-000188', NULL, 'Peptidyl-prolyl cis-trans isomerase', 24, NULL, NULL, 197025),
(197026, '3.80.10.10-FF-004428', NULL, 'Predicted protein', 238, NULL, NULL, 197026),
(197027, '3.40.20.10-FF-000070', NULL, 'Protein transport protein SEC23', 105, NULL, NULL, 197027),
(197028, '1.10.150.50-FF-000221', NULL, 'Uncharacterized protein', 96, NULL, NULL, 197028),
(197029, '2.60.40.10-FF-005092', NULL, NULL, 99, NULL, NULL, 197029),
(197030, '1.25.40.20-FF-001507', NULL, 'Uncharacterized protein', 283, NULL, NULL, 197030),
(197031, '2.130.10.10-FF-004849', NULL, 'Uncharacterized protein', 129, NULL, NULL, 197031),
(197032, '3.40.50.300-FF-005491', NULL, 'GM26572', 191, NULL, NULL, 197032),
(197033, '3.30.40.10-FF-000740', NULL, 'Specific transcriptional repressor, putative', 162, NULL, NULL, 197033),
(197034, '1.20.5.110-FF-000123', NULL, 'Vesicle transport through interaction with t-snares 1a', 81, NULL, NULL, 197034),
(197035, '2.30.30.30-FF-000079', NULL, 'Transcription elongation factor SPT5', 76, NULL, NULL, 197035),
(197036, '1.20.1070.10-FF-000430', NULL, 'Serpentine Receptor, class V', 290, NULL, NULL, 197036),
(197037, '1.20.900.10-FF-000124', NULL, 'Uncharacterized protein', 110, NULL, NULL, 197037),
(197038, '3.30.70.660-FF-000018', NULL, 'Pseudouridylate synthase 3', 185, NULL, NULL, 197038),
(197039, '3.30.70.330-FF-002364', NULL, NULL, 104, NULL, NULL, 197039),
(197040, '1.10.357.140-FF-000048', NULL, 'Uncharacterized protein', 81, NULL, NULL, 197040),
(197041, '2.40.100.10-FF-000089', NULL, 'Uncharacterized protein', 189, NULL, NULL, 197041),
(197042, '3.80.10.10-FF-000067', NULL, 'Leucine-rich repeat and calponin homology domain-containing protein 4 isoform 1', 122, NULL, NULL, 197042),
(197043, '2.130.10.10-FF-004642', NULL, 'Cilia and flagella associated protein 44', 193, NULL, NULL, 197043),
(197044, '3.90.640.10-FF-000176', NULL, 'Uncharacterized protein', 123, NULL, NULL, 197044);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(197045, '1.10.10.1410-FF-000007', NULL, NULL, 38, NULL, NULL, 197045),
(197046, '3.20.190.10-FF-000016', NULL, 'Uncharacterized protein', 133, NULL, NULL, 197046),
(197047, '3.60.21.10-FF-000189', NULL, 'Lmo2106 protein', 207, NULL, NULL, 197047),
(197048, '3.80.10.10-FF-004221', NULL, 'Tyrosine-protein kinase receptor', 83, NULL, NULL, 197048),
(197049, '1.25.40.90-FF-000027', NULL, 'Putative clathrin assembly protein', 147, NULL, NULL, 197049),
(197050, '2.60.120.200-FF-000291', NULL, 'NeuReXin related', 201, NULL, NULL, 197050),
(197051, '3.40.50.1000-FF-000579', NULL, NULL, 118, NULL, NULL, 197051),
(197052, '1.25.40.10-FF-002078', NULL, 'Uncharacterized protein, isoform A', 135, NULL, NULL, 197052),
(197053, '2.120.10.30-FF-000545', NULL, 'uncharacterized protein LOC100186233 isoform X1', 66, NULL, NULL, 197053),
(197054, '6.20.50.160-FF-000006', NULL, 'MHC-linked complement C4', 61, NULL, NULL, 197054),
(197055, '1.25.40.10-FF-002786', NULL, 'Uncharacterized protein', 123, NULL, NULL, 197055),
(197056, '4.10.270.10-FF-000004', NULL, 'unconventional myosin-XVIIIa isoform X1', 60, NULL, NULL, 197056),
(197057, '3.40.50.620-FF-000590', NULL, 'Cytoplasmic tRNA 2-thiolation protein 1', 220, NULL, NULL, 197057),
(197058, '3.20.20.190-FF-000004', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', 180, NULL, NULL, 197058),
(197059, '2.40.10.10-FF-000577', NULL, NULL, 55, NULL, NULL, 197059),
(197060, '3.30.450.20-FF-000419', NULL, 'Sensory transduction histidine kinase', 113, NULL, NULL, 197060),
(197061, '3.40.50.720-FF-000322', NULL, 'Putative malate dehydrogenase 1B', 152, NULL, NULL, 197061),
(197062, '3.40.1110.10-FF-000310', NULL, NULL, 159, NULL, NULL, 197062),
(197063, '1.25.40.10-FF-000869', NULL, 'Pentatricopeptide repeat-containing protein At3g53700, chloroplastic', 72, NULL, NULL, 197063),
(197064, '3.30.1520.10-FF-000017', NULL, 'ribosomal protein S6 kinase delta-1 isoform X1', 123, NULL, NULL, 197064),
(197065, '3.30.160.60-FF-003186', NULL, 'RT01028p', 27, NULL, NULL, 197065),
(197066, '1.10.510.10-FF-000479', NULL, 'Leucine-rich repeat receptor-like protein kinase', 210, NULL, NULL, 197066),
(197067, '1.25.40.10-FF-000925', NULL, 'Uncharacterized protein, isoform B', 191, NULL, NULL, 197067),
(197068, '3.90.70.10-FF-000874', NULL, 'Uncharacterized protein', 60, NULL, NULL, 197068),
(197069, '1.20.1250.20-FF-002178', NULL, 'Putative inorganic phosphate cotransporter-like protein', 171, NULL, NULL, 197069),
(197070, '1.20.1250.10-FF-000051', NULL, 'Type I interferon', 165, NULL, NULL, 197070),
(197071, '3.30.70.330-FF-002038', NULL, NULL, 92, NULL, NULL, 197071),
(197072, '3.40.50.300-FF-005249', NULL, 'ras-related protein RABA2b-like', 190, NULL, NULL, 197072),
(197073, '3.30.70.330-FF-000386', NULL, 'Zinc finger protein 638', 107, NULL, NULL, 197073),
(197074, '3.40.50.300-FF-006828', NULL, 'Uncharacterized protein', 273, NULL, NULL, 197074),
(197075, '3.40.50.10190-FF-000160', NULL, 'DNA damage response protein RcaA', 111, NULL, NULL, 197075),
(197076, '3.30.160.60-FF-001590', NULL, 'zinc finger protein 189 isoform X3', 27, NULL, NULL, 197076),
(197077, '3.90.340.10-FF-000013', NULL, 'Nitric oxide synthase, inducible', 60, NULL, NULL, 197077),
(197078, '2.20.25.30-FF-000005', NULL, 'Ribosomal protein L37', 73, NULL, NULL, 197078),
(197079, '2.10.220.10-FF-000020', NULL, 'Furin-like protease 2', 52, NULL, NULL, 197079),
(197080, '3.40.50.2000-FF-001003', NULL, 'Uncharacterized protein', 258, NULL, NULL, 197080),
(197081, '1.25.40.20-FF-000928', NULL, 'Protein 21.1', 207, NULL, NULL, 197081),
(197082, '3.40.50.620-FF-000354', NULL, 'Unplaced genomic scaffold supercont1.25, whole genome shotgun sequence', 229, NULL, NULL, 197082),
(197083, '3.30.710.10-FF-000307', NULL, 'ZBTB49 isoform 4', 125, NULL, NULL, 197083),
(197084, '3.30.160.60-FF-003242', NULL, 'Testis-specific zinc finger protein topi', 29, NULL, NULL, 197084),
(197085, '2.40.50.40-FF-000037', NULL, 'Heterochromatin protein 1B', 67, NULL, NULL, 197085),
(197086, '3.90.226.10-FF-000079', NULL, 'Enoyl-CoA hydratase/isomerase family protein', 201, NULL, NULL, 197086);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(197087, '1.10.8.60-FF-000111', NULL, 'Two component Fis family sigma54 specific transcriptional regulator', 81, NULL, NULL, 197087),
(197088, '2.20.25.20-FF-000002', NULL, 'Casein kinase II subunit beta', 75, NULL, NULL, 197088),
(197089, '3.80.10.10-FF-003849', NULL, 'Uncharacterized protein', 121, NULL, NULL, 197089),
(197090, '3.60.10.10-FF-000107', NULL, 'Calcium-binding endonuclease/exonuclease/phosphatase family', 346, NULL, NULL, 197090),
(197091, '1.20.1270.50-FF-000013', NULL, 'Uncharacterized protein', 55, NULL, NULL, 197091),
(197092, '3.40.50.620-FF-000410', NULL, 'Valine--tRNA ligase', 213, NULL, NULL, 197092),
(197093, '3.30.420.10-FF-000353', NULL, NULL, 104, NULL, NULL, 197093),
(197094, '1.20.920.10-FF-000064', NULL, 'Polybromo 1', 142, NULL, NULL, 197094),
(197095, '3.30.70.870-FF-000053', NULL, 'Uncharacterized protein', 48, NULL, NULL, 197095),
(197096, '1.20.58.60-FF-000160', NULL, 'Periplakin', 106, NULL, NULL, 197096),
(197097, '1.10.1450.10-FF-000158', NULL, 'Tetraspanin', 80, NULL, NULL, 197097),
(197098, '3.30.565.10-FF-000498', NULL, 'Uncharacterized protein', 135, NULL, NULL, 197098),
(197099, '3.60.20.10-FF-000142', NULL, 'Glucosamine-fructose-6-phosphate aminotransferase, putative', 294, NULL, NULL, 197099),
(197100, '2.10.25.10-FF-000730', NULL, 'Crumbs family member 1, photoreceptor morphogenesis associated', 38, NULL, NULL, 197100),
(197101, '2.60.40.3180-FF-000009', NULL, 'EBF2', 119, NULL, NULL, 197101),
(197102, '1.20.272.40-FF-000010', NULL, 'Putative RNA helicase', 90, NULL, NULL, 197102),
(197103, '2.20.70.10-FF-000008', NULL, 'E3 ubiquitin-protein ligase NEDD4-like protein', 52, NULL, NULL, 197103),
(197104, '1.20.1270.60-FF-000016', NULL, 'FCH domain only protein 2', 271, NULL, NULL, 197104),
(197105, '1.10.8.430-FF-000013', NULL, 'Disease resistance protein RPM1', 89, NULL, NULL, 197105),
(197106, '3.30.160.60-FF-005333', NULL, NULL, 29, NULL, NULL, 197106),
(197107, '2.60.120.260-FF-000319', NULL, 'Beta-galactosidase, putative', 96, NULL, NULL, 197107),
(197108, '1.25.40.20-FF-001390', NULL, 'DNA-binding protein RFXANK', 57, NULL, NULL, 197108),
(197109, '1.10.8.10-FF-000085', NULL, 'protein NBR1 homolog', 42, NULL, NULL, 197109),
(197110, '3.40.50.300-FF-007290', NULL, 'Uncharacterized protein', 152, NULL, NULL, 197110),
(197111, '1.10.600.10-FF-000132', NULL, 'Uncharacterized protein', 81, NULL, NULL, 197111),
(197112, '3.30.160.20-FF-000111', NULL, 'Peptide chain release factor 1', 91, NULL, NULL, 197112),
(197113, '3.30.200.20-FF-000671', NULL, 'Phosphoenolpyruvate carboxylase kinase 2', 90, NULL, NULL, 197113),
(197114, '1.10.8.270-FF-000089', NULL, 'Rab GTPase activating protein, putative', 106, NULL, NULL, 197114),
(197115, '3.40.50.150-FF-000983', NULL, 'Leucine carboxyl methyltransferase 1', 305, NULL, NULL, 197115),
(197116, '1.20.920.20-FF-000067', NULL, 'Dynein heavy chain', 229, NULL, NULL, 197116),
(197117, '2.40.270.10-FF-000016', NULL, 'DNA-directed RNA polymerase subunit beta', 185, NULL, NULL, 197117),
(197118, '3.40.50.300-FF-001360', NULL, 'ABC transporter I family member 10', 231, NULL, NULL, 197118),
(197119, '2.10.25.10-FF-000084', NULL, 'Laminin subunit alpha 3', 52, NULL, NULL, 197119),
(197120, '2.60.40.4100-FF-000027', NULL, 'Zona pellucida protein C', 83, NULL, NULL, 197120),
(197121, '3.40.30.10-FF-001059', NULL, 'AER330Wp', 171, NULL, NULL, 197121),
(197122, '3.30.2350.10-FF-000066', NULL, 'Ribosomal large subunit pseudouridine synthase D', 233, NULL, NULL, 197122),
(197123, '3.30.300.30-FF-000092', NULL, 'Flagellar M-ring protein', 101, NULL, NULL, 197123),
(197124, '2.170.120.40-FF-000001', NULL, 'YbbR-like domain-containing protein ybbR', 85, NULL, NULL, 197124),
(197125, '3.30.420.40-FF-000839', NULL, 'Uncharacterized protein', 120, NULL, NULL, 197125),
(197126, '3.40.50.1000-FF-000815', NULL, NULL, 113, NULL, NULL, 197126),
(197127, '3.40.50.460-FF-000047', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit alpha 2', 26, NULL, NULL, 197127),
(197128, '3.80.10.10-FF-002068', NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', 96, NULL, NULL, 197128);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(197129, '2.60.260.20-FF-000059', NULL, 'DnaJ homolog dnj-10', 51, NULL, NULL, 197129),
(197130, '1.20.930.10-FF-000036', NULL, 'Predicted protein', 147, NULL, NULL, 197130),
(197131, '3.60.21.10-FF-000020', NULL, 'NT5E isoform 4', 306, NULL, NULL, 197131),
(197132, '2.130.10.10-FF-001207', NULL, 'Periodic tryptophan protein 2', 129, NULL, NULL, 197132),
(197133, '3.90.1150.10-FF-000087', NULL, 'Putative methionine gamma-lyase', 140, NULL, NULL, 197133),
(197134, '3.30.2350.20-FF-000069', NULL, NULL, 49, NULL, NULL, 197134),
(197135, '3.100.10.10-FF-000047', NULL, NULL, 99, NULL, NULL, 197135),
(197136, '1.10.8.270-FF-000145', NULL, 'MGC16169 protein, putative', 130, NULL, NULL, 197136),
(197137, '3.40.50.300-FF-005575', NULL, 'Dynein, axonemal, heavy chain 14', 186, NULL, NULL, 197137),
(197138, '3.80.10.10-FF-001995', NULL, 'Probable leucine-rich repeat receptor-like protein kinase At2g33170', 79, NULL, NULL, 197138),
(197139, '2.60.120.10-FF-000170', NULL, 'AGC protein kinase', 129, NULL, NULL, 197139),
(197140, '3.40.1190.20-FF-000115', NULL, 'PfkB domain protein', 275, NULL, NULL, 197140),
(197141, '3.40.309.10-FF-000081', NULL, 'Aldehyde dehydrogenase', 188, NULL, NULL, 197141),
(197142, '3.30.160.60-FF-004967', NULL, NULL, 22, NULL, NULL, 197142),
(197143, '2.40.50.140-FF-000725', NULL, NULL, 86, NULL, NULL, 197143),
(197144, '1.25.40.10-FF-005130', NULL, 'Uncharacterized protein', 104, NULL, NULL, 197144),
(197145, '2.60.120.480-FF-000003', NULL, 'Ureidoglycolate hydrolase', 194, NULL, NULL, 197145),
(197146, '3.30.420.10-FF-000027', NULL, 'Putative CCR4-associated factor 1 7', 268, NULL, NULL, 197146),
(197147, '2.60.40.10-FF-005361', NULL, NULL, 65, NULL, NULL, 197147),
(197148, '2.60.120.200-FF-000257', NULL, 'Galectin', 133, NULL, NULL, 197148),
(197149, '2.10.25.10-FF-000404', NULL, 'Weary, isoform B', 37, NULL, NULL, 197149),
(197150, '3.30.428.10-FF-000056', NULL, 'Si:ch211-256m1.8', 150, NULL, NULL, 197150),
(197151, '3.40.50.720-FF-001396', NULL, 'Uncharacterized protein', 157, NULL, NULL, 197151),
(197152, '3.90.470.40-FF-000003', NULL, 'Charybde, isoform E', 134, NULL, NULL, 197152),
(197153, '1.10.460.10-FF-000036', NULL, 'DNA topoisomerase', 98, NULL, NULL, 197153),
(197154, '3.90.1140.10-FF-000019', NULL, 'RNA 2'',3''-cyclic phosphodiesterase', 179, NULL, NULL, 197154),
(197155, '1.25.40.10-FF-001061', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 128, NULL, NULL, 197155),
(197156, '2.60.40.10-FF-005209', NULL, NULL, 91, NULL, NULL, 197156),
(197157, '3.90.1750.20-FF-000001', NULL, 'Resolvase family site-specific recombinase', 151, NULL, NULL, 197157),
(197158, '3.30.470.20-FF-000067', NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', 156, NULL, NULL, 197158),
(197159, '3.30.160.60-FF-003388', NULL, 'Zinc finger and BTB domain-containing protein 7A', 54, NULL, NULL, 197159),
(197160, '2.130.10.10-FF-001270', NULL, 'WD repeat-containing protein 44 isoform A', 133, NULL, NULL, 197160),
(197161, '3.40.605.10-FF-000100', NULL, 'Aldehyde dehydrogenase family protein', 233, NULL, NULL, 197161),
(197162, '2.30.29.30-FF-000165', NULL, 'TBC1 domain family member 1 isoform X1', 153, NULL, NULL, 197162),
(197163, '3.80.10.10-FF-003001', NULL, 'Uncharacterized protein', 84, NULL, NULL, 197163),
(197164, '3.30.1490.80-FF-000023', NULL, 'Glutathione synthetase', 78, NULL, NULL, 197164),
(197165, '3.20.20.70-FF-000228', NULL, 'FMN-dependent dehydrogenase family protein', 356, NULL, NULL, 197165),
(197166, '1.25.40.20-FF-001064', NULL, 'Protein lin-12', 295, NULL, NULL, 197166),
(197167, '3.30.200.20-FF-000519', NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', 90, NULL, NULL, 197167),
(197168, '2.170.120.12-FF-000028', NULL, 'DNA-directed RNA polymerase', 139, NULL, NULL, 197168),
(197169, '4.10.410.10-FF-000010', NULL, 'Alpha1-microglobulin/bikunin (AMBP)', 123, NULL, NULL, 197169),
(197170, '2.30.30.40-FF-000559', NULL, 'Si:dkey-40c11.2', 60, NULL, NULL, 197170),
(197171, '3.40.850.10-FF-000416', NULL, 'Kinesin-like protein', 221, NULL, NULL, 197171);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(197172, '3.40.50.2300-FF-000806', NULL, NULL, 80, NULL, NULL, 197172),
(197173, '2.30.30.140-FF-000206', NULL, 'Transcription elongation factor s-II', 106, NULL, NULL, 197173),
(197174, '3.30.450.20-FF-000184', NULL, 'Hybrid sensor histidine kinase/response regulator', 117, NULL, NULL, 197174),
(197175, '3.40.50.300-FF-005047', NULL, 'Carbohydrate sulfotransferase', 309, NULL, NULL, 197175),
(197176, '2.170.300.10-FF-000023', NULL, 'Platelet endothelial aggregation receptor 1', 62, NULL, NULL, 197176),
(197177, '1.10.10.10-FF-001614', NULL, 'ELK1, ETS transcription factor', 143, NULL, NULL, 197177),
(197178, '2.60.120.290-FF-000008', NULL, 'Attractin like 1', 119, NULL, NULL, 197178),
(197179, '3.10.129.10-FF-000023', NULL, 'Acyl-coenzyme A thioesterase 9, mitochondrial', 158, NULL, NULL, 197179),
(197180, '3.40.710.10-FF-000081', NULL, 'Penicillin-binding protein 1A', 367, NULL, NULL, 197180),
(197181, '3.40.50.720-FF-000294', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', 220, NULL, NULL, 197181),
(197182, '3.10.129.10-FF-000079', NULL, 'Uncharacterized protein', 140, NULL, NULL, 197182),
(197183, '3.40.50.300-FF-003451', NULL, 'Multidrug resistance protein putative', 269, NULL, NULL, 197183),
(197184, '4.10.1000.10-FF-000083', NULL, 'Zinc finger C-x8-C-x5-C-x3-H type family protein', 77, NULL, NULL, 197184),
(197185, '1.20.144.10-FF-000058', NULL, 'Phospholipid phosphatase 3', 200, NULL, NULL, 197185),
(197186, '3.30.1330.40-FF-000023', NULL, 'Cytoplasmic protein, variant', 102, NULL, NULL, 197186),
(197187, '3.30.420.10-FF-000151', NULL, 'DNA polymerase', 219, NULL, NULL, 197187),
(197188, '2.130.10.10-FF-002961', NULL, 'Pre-rRNA-processing protein IPI3', 234, NULL, NULL, 197188),
(197189, '1.25.40.10-FF-004764', NULL, 'Uncharacterized protein', 47, NULL, NULL, 197189),
(197190, '3.40.50.300-FF-003804', NULL, 'DNA repair protein RAD50 isoform X1', 255, NULL, NULL, 197190),
(197191, '2.60.120.260-FF-000645', NULL, 'Uncharacterized protein', 99, NULL, NULL, 197191),
(197192, '3.30.465.10-FF-000142', NULL, 'Uncharacterized protein', 218, NULL, NULL, 197192),
(197193, '3.30.1890.10-FF-000005', NULL, 'Chain length determinant protein', 113, NULL, NULL, 197193),
(197194, '3.30.1330.30-FF-000020', NULL, '50S ribosomal protein L7Ae', 123, NULL, NULL, 197194),
(197195, '1.10.10.10-FF-000569', NULL, 'Histone acetyltransferase', 88, NULL, NULL, 197195),
(197196, '2.130.10.10-FF-005541', NULL, 'Uncharacterized protein', 224, NULL, NULL, 197196),
(197197, '3.90.960.10-FF-000009', NULL, 'Proline--tRNA ligase', 140, NULL, NULL, 197197),
(197198, '3.90.1150.10-FF-000317', NULL, 'Serine hydroxymethyltransferase', 169, NULL, NULL, 197198),
(197199, '1.20.58.1220-FF-000010', NULL, 'Uncharacterized protein', 102, NULL, NULL, 197199),
(197200, '2.10.25.10-FF-001388', NULL, 'C-type lectin domain family 14 member A', 53, NULL, NULL, 197200),
(197201, '3.40.50.1220-FF-000117', NULL, 'Predicted protein', 45, NULL, NULL, 197201),
(197202, '3.40.50.10470-FF-000030', NULL, 'Translation initiation factor eIF2B subunit-like protein, putative', 197, NULL, NULL, 197202),
(197203, '1.20.990.10-FF-000012', NULL, 'NADPH-dependent diflavin oxidoreductase 1', 63, NULL, NULL, 197203),
(197204, '3.30.70.1730-FF-000014', NULL, 'Ribosome biogenesis protein MRT4', 97, NULL, NULL, 197204),
(197205, '2.120.10.30-FF-000489', NULL, 'Uncharacterized protein', 271, NULL, NULL, 197205),
(197206, '3.40.720.10-FF-000227', NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase putative', 76, NULL, NULL, 197206),
(197207, '2.40.50.140-FF-001124', NULL, NULL, 92, NULL, NULL, 197207),
(197208, '3.40.50.300-FF-007610', NULL, 'Zinc finger GRF-type containing 1', 156, NULL, NULL, 197208),
(197209, '1.10.510.10-FF-002896', NULL, 'CK1 family protein kinase', 320, NULL, NULL, 197209),
(197210, '3.40.50.10240-FF-000017', NULL, 'Thiamin pyrophosphokinase', 271, NULL, NULL, 197210),
(197211, '3.40.50.1240-FF-000185', NULL, NULL, 128, NULL, NULL, 197211),
(197212, '1.25.10.10-FF-001087', NULL, 'Cytoskeleton-associated protein', 242, NULL, NULL, 197212);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(197213, '3.30.40.10-FF-002156', NULL, 'Structure-specific endonuclease subunit slx1', 73, NULL, NULL, 197213),
(197214, '1.10.150.240-FF-000068', NULL, 'HAD hydrolase, family IA, variant 3, putative', 70, NULL, NULL, 197214),
(197215, '4.10.60.10-FF-000189', NULL, 'Peptidyl-prolyl cis-trans isomerase', 47, NULL, NULL, 197215),
(197216, '3.40.50.1820-FF-000084', NULL, 'Isoprenylcysteine alpha-carbonyl methylesterase ICME', 253, NULL, NULL, 197216),
(197217, '3.80.10.10-FF-000270', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 86, NULL, NULL, 197217),
(197218, '3.40.50.10490-FF-000036', NULL, 'Glutamine-fructose-6-phosphate transaminase (Isomerizing), variant', 215, NULL, NULL, 197218),
(197219, '3.40.50.920-FF-000028', NULL, 'Ferredoxin oxidoreductase subunit alpha', 108, NULL, NULL, 197219),
(197220, '3.10.100.10-FF-000266', NULL, NULL, 145, NULL, NULL, 197220),
(197221, '3.40.50.920-FF-000056', NULL, 'Putative branched-chain alpha-keto acid dehydrogenase subunit e1-beta', 143, NULL, NULL, 197221),
(197222, '3.30.470.20-FF-000128', NULL, 'Tubulin--tyrosine ligase-like protein 12', 189, NULL, NULL, 197222),
(197223, '3.30.390.80-FF-000005', NULL, 'DNA repair protein RAD59', 143, NULL, NULL, 197223),
(197224, '4.10.240.10-FF-000210', NULL, 'Uncharacterized protein', 67, NULL, NULL, 197224),
(197225, '3.40.50.300-FF-000994', NULL, 'DNA helicase', 76, NULL, NULL, 197225),
(197226, '3.40.1110.10-FF-000192', NULL, 'Cation-transporting ATPase', 191, NULL, NULL, 197226),
(197227, '1.25.10.10-FF-000777', NULL, 'AGAP004782-PA-like protein', 285, NULL, NULL, 197227),
(197228, '1.25.40.10-FF-005074', NULL, 'Rapsynoid, putative', 96, NULL, NULL, 197228),
(197229, '1.10.3860.10-FF-000032', NULL, 'Amino acid transporter', 165, NULL, NULL, 197229),
(197230, '1.10.1750.10-FF-000001', NULL, 'Chromosomal replication initiator protein DnaA', 94, NULL, NULL, 197230),
(197231, '2.40.10.10-FF-000285', NULL, 'Granzyme-like I', 254, NULL, NULL, 197231),
(197232, '3.40.50.410-FF-000263', NULL, 'Calcium voltage-gated channel auxiliary subunit alpha2delta 4', 72, NULL, NULL, 197232),
(197233, '3.30.420.40-FF-000991', NULL, 'LL-diaminopimelate aminotransferase chloroplastic', 88, NULL, NULL, 197233),
(197234, '4.10.80.40-FF-000002', NULL, 'Succinate dehydrogenase [ubiquinone] flavoprotein subunit, mitochondrial', 51, NULL, NULL, 197234),
(197235, '2.60.40.10-FF-001522', NULL, 'immunoglobulin superfamily member 22', 90, NULL, NULL, 197235),
(197236, '2.60.40.10-FF-003118', NULL, 'Penicillin-binding proteins 1A and 1B', 94, NULL, NULL, 197236),
(197237, '3.40.1280.10-FF-000029', NULL, 'Ribosomal RNA small subunit methyltransferase E', 224, NULL, NULL, 197237),
(197238, '3.40.50.720-FF-000614', NULL, '3-oxoacyl-ACP reductase FabG', 179, NULL, NULL, 197238),
(197239, '1.20.1740.10-FF-000223', NULL, 'Predicted protein', 489, NULL, NULL, 197239),
(197240, '1.10.472.10-FF-000586', NULL, 'Cyclin, N-terminal domain containing protein', 37, NULL, NULL, 197240),
(197241, '1.10.1420.10-FF-000010', NULL, 'DNA mismatch repair protein', 176, NULL, NULL, 197241),
(197242, '3.30.342.10-FF-000042', NULL, 'DNA polymerase', 141, NULL, NULL, 197242),
(197243, '1.20.58.2130-FF-000002', NULL, 'DNA replication regulator SLD3', 197, NULL, NULL, 197243),
(197244, '3.40.50.620-FF-000882', NULL, 'Uncharacterized protein', 110, NULL, NULL, 197244),
(197245, '3.10.20.90-FF-001016', NULL, 'Predicted protein', 60, NULL, NULL, 197245),
(197246, '3.40.920.10-FF-000001', NULL, 'Pyruvate:ferredoxin (Flavodoxin) oxidoreductase', 211, NULL, NULL, 197246),
(197247, '3.40.50.360-FF-000107', NULL, 'Potassium/proton antiporter ancillary protein', 178, NULL, NULL, 197247),
(197248, '1.20.58.2140-FF-000005', NULL, 'Translin', 198, NULL, NULL, 197248),
(197249, '1.20.1530.20-FF-000036', NULL, 'Kha1p', 411, NULL, NULL, 197249),
(197250, '1.20.1070.10-FF-000604', NULL, 'G protein-coupled receptor, putative', 153, NULL, NULL, 197250),
(197251, '3.40.50.720-FF-002385', NULL, 'Oxidoreductase, putative', 147, NULL, NULL, 197251),
(197252, '2.40.37.10-FF-000060', NULL, NULL, 122, NULL, NULL, 197252);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(197253, '2.30.40.10-FF-000045', NULL, 'Imidazolonepropionase', 90, NULL, NULL, 197253),
(197254, '3.80.10.10-FF-003647', NULL, 'Disease resistance protein SUMM2', 95, NULL, NULL, 197254),
(197255, '3.40.50.800-FF-000020', NULL, 'Probable proline--tRNA ligase, mitochondrial', 116, NULL, NULL, 197255),
(197256, '3.40.50.300-FF-006677', NULL, 'Predicted protein', 83, NULL, NULL, 197256),
(197257, '3.30.1330.10-FF-000008', NULL, 'Thiamine-monophosphate kinase', 143, NULL, NULL, 197257),
(197258, '2.40.50.90-FF-000119', NULL, 'Thermococcal nuclease homolog', 152, NULL, NULL, 197258),
(197259, '2.130.10.10-FF-001500', NULL, 'WD domain, G-beta repeat-containing protein', 294, NULL, NULL, 197259),
(197260, '3.30.420.40-FF-000688', NULL, '(R)-2-hydroxyacyl-CoA dehydratase-radicalizing ATPase', 101, NULL, NULL, 197260),
(197261, '1.10.287.70-FF-000510', NULL, 'Predicted protein', 299, NULL, NULL, 197261),
(197262, '1.25.10.10-FF-002868', NULL, 'Predicted protein', 157, NULL, NULL, 197262),
(197263, '3.40.366.10-FF-000055', NULL, 'Uncharacterized protein', 236, NULL, NULL, 197263),
(197264, '3.30.160.60-FF-002899', NULL, 'Zgc:162972 protein', 28, NULL, NULL, 197264),
(197265, '3.30.710.10-FF-000370', NULL, 'BTB/POZ domain-containing protein', 144, NULL, NULL, 197265),
(197266, '2.30.42.10-FF-000027', NULL, 'Signal-induced proliferation-associated 1-like protein 1 isoform 2', 75, NULL, NULL, 197266),
(197267, '2.10.25.10-FF-000932', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1a', 39, NULL, NULL, 197267),
(197268, '3.40.50.620-FF-000028', NULL, 'Bifunctional protein HldE', 157, NULL, NULL, 197268),
(197269, '1.25.40.10-FF-000723', NULL, 'Pentatricopeptide repeat-containing protein', 71, NULL, NULL, 197269),
(197270, '1.20.1250.20-FF-000054', NULL, 'Fosmidomycin resistance protein', 187, NULL, NULL, 197270),
(197271, '4.10.410.20-FF-000013', NULL, 'Uncharacterized protein', 52, NULL, NULL, 197271),
(197272, '3.40.50.11210-FF-000022', NULL, NULL, 196, NULL, NULL, 197272),
(197273, '1.25.10.10-FF-001031', NULL, 'Protein required for meiosis', 218, NULL, NULL, 197273),
(197274, '3.30.160.60-FF-000898', NULL, 'zinc finger RNA-binding protein 2', 40, NULL, NULL, 197274),
(197275, '1.25.40.20-FF-000698', NULL, 'Uncharacterized protein, isoform B', 134, NULL, NULL, 197275),
(197276, '3.40.50.2300-FF-000542', NULL, 'Penicillin-binding protein activator LpoA', 181, NULL, NULL, 197276),
(197277, '1.20.1270.60-FF-000140', NULL, 'Variant sh3 domain containing protein', 220, NULL, NULL, 197277),
(197278, '3.30.9.10-FF-000004', NULL, 'D-amino-acid oxidase', 137, NULL, NULL, 197278),
(197279, '1.20.1110.10-FF-000102', NULL, 'Calcium-transporting ATPase', 273, NULL, NULL, 197279),
(197280, '3.40.50.2300-FF-000486', NULL, 'PTS system, fructose-specific IIB component', 97, NULL, NULL, 197280),
(197281, '2.60.120.290-FF-000160', NULL, 'Cubilin homolog', 124, NULL, NULL, 197281),
(197282, '3.30.540.10-FF-000098', NULL, 'Uncharacterized protein', 114, NULL, NULL, 197282),
(197283, '3.10.129.10-FF-000169', NULL, 'Thioesterase family protein', 117, NULL, NULL, 197283),
(197284, '1.10.510.10-FF-003115', NULL, NULL, 191, NULL, NULL, 197284),
(197285, '3.40.50.620-FF-000180', NULL, 'Cytidyltransferase isoform 1', 177, NULL, NULL, 197285),
(197286, '3.40.50.720-FF-000092', NULL, 'Siroheme synthase', 112, NULL, NULL, 197286),
(197287, '3.30.40.10-FF-000532', NULL, 'Origin recognition complex subunit 1', 53, NULL, NULL, 197287),
(197288, '1.25.40.720-FF-000004', NULL, 'WGS project CABT00000000 data, contig 2.6', 139, NULL, NULL, 197288),
(197289, '3.90.180.10-FF-000157', NULL, 'Os11g0210600 protein', 147, NULL, NULL, 197289),
(197290, '3.40.640.10-FF-000463', NULL, 'Uncharacterized protein', 172, NULL, NULL, 197290),
(197291, '1.20.80.10-FF-000056', NULL, 'band 4.1-like protein 4 isoform X1', 106, NULL, NULL, 197291),
(197292, '1.10.15.30-FF-000007', NULL, 'Uncharacterized protein', 63, NULL, NULL, 197292),
(197293, '2.130.10.10-FF-003068', NULL, 'WD_domain_-_G-beta_repeat_-_putative', 128, NULL, NULL, 197293),
(197294, '3.30.160.60-FF-000954', NULL, 'Zinc finger and BTB domain containing 40', 78, NULL, NULL, 197294);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(197295, '2.130.10.10-FF-003124', NULL, 'Transducin family protein / WD-40 repeat family protein', 261, NULL, NULL, 197295),
(197296, '2.130.10.10-FF-000718', NULL, 'cilia- and flagella-associated protein 52 isoform X2', 127, NULL, NULL, 197296),
(197297, '3.30.230.40-FF-000010', NULL, 'Imidazoleglycerol-phosphate dehydratase', 60, NULL, NULL, 197297),
(197298, '1.25.40.10-FF-000695', NULL, 'Pentatricopeptide repeat-containing protein At5g03800', 126, NULL, NULL, 197298),
(197299, '1.25.40.710-FF-000001', NULL, 'Tripeptidyl peptidase 2', 235, NULL, NULL, 197299),
(197300, '3.90.1150.10-FF-000407', NULL, 'Serine hydroxymethyltransferase', 102, NULL, NULL, 197300),
(197301, '2.60.40.10-FF-002011', NULL, 'B-cell receptor CD22', 86, NULL, NULL, 197301),
(197302, '2.30.40.10-FF-000135', NULL, 'Guanine deaminase', 117, NULL, NULL, 197302),
(197303, '1.20.1560.10-FF-000035', NULL, 'Multidrug ABC transporter ATP-binding protein', 329, NULL, NULL, 197303),
(197304, '3.60.40.10-FF-000025', NULL, 'Protein phosphatase 2C 16', 331, NULL, NULL, 197304),
(197305, '1.10.490.10-FF-000038', NULL, 'Globin-like protein 26', 149, NULL, NULL, 197305),
(197306, '1.10.10.10-FF-000597', NULL, 'DNA helicase', 86, NULL, NULL, 197306),
(197307, '3.30.70.330-FF-003151', NULL, NULL, 188, NULL, NULL, 197307),
(197308, '1.20.1070.10-FF-001588', NULL, 'Odorant receptor 10', 156, NULL, NULL, 197308),
(197309, '3.40.50.800-FF-000110', NULL, 'Proline--tRNA ligase', 123, NULL, NULL, 197309),
(197310, '3.40.50.300-FF-005373', NULL, 'mRNA cleavage and polyadenylation factor complex II subunit', 234, NULL, NULL, 197310),
(197311, '1.10.100.10-FF-000015', NULL, 'Insulin-like peptide 6', 68, NULL, NULL, 197311),
(197312, '2.130.10.10-FF-004698', NULL, 'Uncharacterized protein', 174, NULL, NULL, 197312),
(197313, '2.10.25.10-FF-000606', NULL, 'Complement component C1q receptor', 37, NULL, NULL, 197313),
(197314, '3.40.50.720-FF-000440', NULL, 'Short chain dehydrogenase', 245, NULL, NULL, 197314),
(197315, '1.25.10.10-FF-001233', NULL, 'Armadillo/beta-catenin-like_repeat_-_putative', 326, NULL, NULL, 197315),
(197316, '3.40.190.10-FF-000736', NULL, 'Transcriptional regulatory protein', 86, NULL, NULL, 197316),
(197317, '3.40.50.1820-FF-001573', NULL, 'Uncharacterized protein', 108, NULL, NULL, 197317),
(197318, '1.25.40.10-FF-003505', NULL, 'Predicted protein', 119, NULL, NULL, 197318),
(197319, '1.20.58.610-FF-000008', NULL, 'Uncharacterized protein', 82, NULL, NULL, 197319),
(197320, '3.40.220.10-FF-000032', NULL, 'Appr-1-p processing enzyme family protein', 240, NULL, NULL, 197320),
(197321, '3.30.710.10-FF-000280', NULL, 'Growth/cell cycle/stress response regulation protein, putative', 74, NULL, NULL, 197321),
(197322, '3.40.50.150-FF-001472', NULL, NULL, 131, NULL, NULL, 197322),
(197323, '3.40.50.10190-FF-000221', NULL, 'DNA repair protein XRCC1-like', 102, NULL, NULL, 197323),
(197324, '1.20.1560.10-FF-000512', NULL, 'ABC transporter, multidrug resistance associated protein', 324, NULL, NULL, 197324),
(197325, '1.10.287.370-FF-000050', NULL, 'Coiled-coil protein, putative', 139, NULL, NULL, 197325),
(197326, '3.30.70.1450-FF-000054', NULL, 'Trk system potassium uptake protein TrkA (K(+)-uptake protein trkA)', 88, NULL, NULL, 197326),
(197327, '2.60.40.10-FF-001612', NULL, 'titin isoform X1', 99, NULL, NULL, 197327),
(197328, '1.10.1200.10-FF-000027', NULL, 'Nonribosomal siderophore peptide synthase SidC', 78, NULL, NULL, 197328),
(197329, '3.80.10.10-FF-002214', NULL, 'Uncharacterized protein', 206, NULL, NULL, 197329),
(197330, '2.60.40.10-FF-002596', NULL, 'Uncharacterized protein, isoform B', 97, NULL, NULL, 197330),
(197331, '1.25.10.10-FF-002812', NULL, 'Uncharacterized protein', 200, NULL, NULL, 197331),
(197332, '2.60.40.10-FF-003736', NULL, NULL, 87, NULL, NULL, 197332),
(197333, '4.10.60.10-FF-000099', NULL, 'Cellular nucleic acid-binding protein', 49, NULL, NULL, 197333),
(197334, '2.10.25.10-FF-000258', NULL, 'Integrin beta', 48, NULL, NULL, 197334),
(197335, '3.10.400.20-FF-000022', NULL, 'Uncharacterized protein', 201, NULL, NULL, 197335);
INSERT INTO "PUBLIC"."MODEL" VALUES
(197336, '2.130.10.10-FF-000483', NULL, 'U3 snoRNP-associated protein-like EMB2271', 361, NULL, NULL, 197336),
(197337, '1.20.58.60-FF-000811', NULL, 'Spectrin repeat containing nuclear envelope protein 2', 194, NULL, NULL, 197337),
(197338, '1.20.1070.10-FF-000930', NULL, 'Olfactory receptor 1457', 149, NULL, NULL, 197338),
(197339, '3.30.1250.10-FF-000002', NULL, 'YHR087W-like protein', 111, NULL, NULL, 197339),
(197340, '2.60.40.10-FF-001320', NULL, 'Putative Defective proboscis extension response', 91, NULL, NULL, 197340),
(197341, '1.10.4090.10-FF-000001', NULL, 'Capsid protein', 154, NULL, NULL, 197341),
(197342, '1.25.40.10-FF-001712', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 148, NULL, NULL, 197342),
(197343, '1.10.287.70-FF-000420', NULL, 'Predicted protein', 124, NULL, NULL, 197343),
(197344, '3.40.50.300-FF-005721', NULL, 'Dynein heavy chain domain 1', 163, NULL, NULL, 197344),
(197345, '6.10.140.2220-FF-000032', NULL, 'GM24661', 48, NULL, NULL, 197345),
(197346, '2.10.25.10-FF-000230', NULL, 'Delta-like protein', 38, NULL, NULL, 197346),
(197347, '3.90.1600.10-FF-000038', NULL, 'DNA polymerase', 151, NULL, NULL, 197347),
(197348, '1.20.120.550-FF-000023', NULL, 'Microsomal glutathione S-transferase 1-like Protein', 109, NULL, NULL, 197348),
(197349, '2.60.120.590-FF-000036', NULL, 'AlkB homolog 3, alpha-ketoglutarate-dependent dioxygenase', 74, NULL, NULL, 197349),
(197350, '3.40.50.12780-FF-000138', NULL, 'Uncharacterized protein', 95, NULL, NULL, 197350),
(197351, '3.30.160.20-FF-000116', NULL, 'Mitochondrial ribosomal protein L44', 81, NULL, NULL, 197351),
(197352, '1.10.630.10-FF-000134', NULL, 'Cytochrome P450 family 2 subfamily S member 1', 131, NULL, NULL, 197352),
(197353, '3.40.50.300-FF-001534', NULL, 'Interferon induced protein 44 like', 195, NULL, NULL, 197353),
(197354, '1.25.40.20-FF-001715', NULL, 'Predicted protein', 48, NULL, NULL, 197354),
(197355, '2.130.10.10-FF-004850', NULL, 'Cytoplasmic dynein intermediate chain-like protein', 129, NULL, NULL, 197355),
(197356, '2.40.70.10-FF-000496', NULL, NULL, 124, NULL, NULL, 197356),
(197357, '3.40.50.11660-FF-000050', NULL, NULL, 96, NULL, NULL, 197357),
(197358, '1.20.5.220-FF-000009', NULL, 'Ubiquinol-Cytochrome c oxidoReductase complex', 48, NULL, NULL, 197358),
(197359, '1.10.510.10-FF-001850', NULL, 'Protein kinase domain containing protein', 346, NULL, NULL, 197359),
(197360, '3.30.200.20-FF-002560', NULL, NULL, 56, NULL, NULL, 197360),
(197361, '3.30.1550.10-FF-000019', NULL, '60S ribosomal protein L11, mitochondrial', 85, NULL, NULL, 197361),
(197362, '1.25.40.630-FF-000005', NULL, 'Chromosome 7, whole genome shotgun sequence', 83, NULL, NULL, 197362),
(197363, '3.20.20.80-FF-000350', NULL, 'Endo-1,4-beta-xylanase Y', 361, NULL, NULL, 197363),
(197364, '4.10.520.10-FF-000013', NULL, 'Probable DNA binding protein', 92, NULL, NULL, 197364),
(197365, '1.25.10.10-FF-000867', NULL, 'Ecm29p', 398, NULL, NULL, 197365),
(197366, '3.90.550.10-FF-000259', NULL, 'Bifunctional enzyme IspD/IspF', 208, NULL, NULL, 197366),
(197367, '3.30.200.20-FF-001008', NULL, 'Serine/threonine-protein kinase cek1', 118, NULL, NULL, 197367),
(197368, '1.20.58.60-FF-000250', NULL, 'Blast:Spectrin beta chain, non-erythrocytic 5', 204, NULL, NULL, 197368),
(197369, '4.10.400.10-FF-000240', NULL, 'Terribly reduced optic lobes, isoform AH', 42, NULL, NULL, 197369),
(197370, '2.30.36.70-FF-000025', NULL, 'Uncharacterized protein', 38, NULL, NULL, 197370),
(197371, '3.40.50.720-FF-000384', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(P)+]', 186, NULL, NULL, 197371),
(197372, '1.10.10.60-FF-000472', NULL, 'HTH-type transcriptional regulator AppY', 104, NULL, NULL, 197372),
(197373, '1.20.1250.20-FF-002122', NULL, 'Uncharacterized protein', 217, NULL, NULL, 197373),
(197374, '3.30.700.10-FF-000009', NULL, 'Type IV pilin subunit protein', 133, NULL, NULL, 197374),
(197375, '3.90.650.10-FF-000025', NULL, 'Phosphoribosylamine-glycine ligase', 178, NULL, NULL, 197375),
(197376, '3.80.10.10-FF-004013', NULL, 'Uncharacterized protein', 148, NULL, NULL, 197376);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(197377, '3.40.50.2300-FF-000632', NULL, 'Sensor histidine kinase/response regulator, putative', 133, NULL, NULL, 197377),
(197378, '2.20.100.10-FF-000043', NULL, 'R-spondin 3', 49, NULL, NULL, 197378),
(197379, '2.30.29.30-FF-000339', NULL, 'Rho guanine nucleotide exchange factor 39', 128, NULL, NULL, 197379),
(197380, '1.25.40.10-FF-004438', NULL, 'Os03g0168400 protein', 119, NULL, NULL, 197380),
(197381, '2.60.40.10-FF-005535', NULL, NULL, 51, NULL, NULL, 197381),
(197382, '3.90.1530.10-FF-000009', NULL, 'Chromosome partitioning protein ParB', 101, NULL, NULL, 197382),
(197383, '1.25.40.620-FF-000002', NULL, 'GUN4 mutant', 136, NULL, NULL, 197383),
(197384, '3.40.1280.10-FF-000024', NULL, 'Ribosomal RNA small subunit methyltransferase E', 183, NULL, NULL, 197384),
(197385, '3.40.190.10-FF-000883', NULL, 'Glutamate receptor ionotropic, delta-1-like Protein', 91, NULL, NULL, 197385),
(197386, '1.25.40.730-FF-000007', NULL, 'Clathrin heavy chain', 97, NULL, NULL, 197386),
(197387, '1.10.238.10-FF-000874', NULL, 'Cell adhesion molecule, putative', 82, NULL, NULL, 197387),
(197388, '3.50.50.60-FF-000546', NULL, 'Geranylgeranyl hydrogenase, putative', 456, NULL, NULL, 197388),
(197389, '3.60.10.10-FF-000079', NULL, 'DNA-(apurinic or apyrimidinic site) lyase', 323, NULL, NULL, 197389),
(197390, '1.10.4160.10-FF-000030', NULL, 'Uracil transporter, putative (Eurofung)', 477, NULL, NULL, 197390),
(197391, '2.130.10.10-FF-000808', NULL, 'Alternative splicing regulator', 311, NULL, NULL, 197391),
(197392, '3.10.260.10-FF-000013', NULL, NULL, 166, NULL, NULL, 197392),
(197393, '2.130.10.10-FF-000988', NULL, 'Protein HIRA', 240, NULL, NULL, 197393),
(197394, '3.90.70.10-FF-000784', NULL, 'Uncharacterized protein', 348, NULL, NULL, 197394),
(197395, '3.30.1120.30-FF-000004', NULL, 'Serine/threonine-protein kinase', 26, NULL, NULL, 197395),
(197396, '3.80.10.10-FF-001579', NULL, 'LRR receptor-like serine/threonine-protein kinase GSO2', 226, NULL, NULL, 197396),
(197397, '3.80.10.10-FF-002719', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase isoform B', 92, NULL, NULL, 197397),
(197398, '1.20.1420.10-FF-000002', NULL, 'Talin 2', 170, NULL, NULL, 197398),
(197399, '1.10.10.2520-FF-000003', NULL, 'Cell Wall hydrolase', 84, NULL, NULL, 197399),
(197400, '3.60.15.10-FF-000192', NULL, 'Uncharacterized protein', 284, NULL, NULL, 197400),
(197401, '3.10.450.50-FF-000096', NULL, 'Nuclear transport factor, putative', 97, NULL, NULL, 197401),
(197402, '2.60.120.290-FF-000244', NULL, 'Uncharacterized protein', 77, NULL, NULL, 197402),
(197403, '3.40.50.300-FF-008594', NULL, 'ATP-dependent Clp-type protease, putative', 102, NULL, NULL, 197403),
(197404, '3.40.50.620-FF-000556', NULL, 'Uncharacterized protein', 244, NULL, NULL, 197404),
(197405, '1.10.238.230-FF-000004', NULL, 'Protein CBG16342', 99, NULL, NULL, 197405),
(197406, '1.10.510.10-FF-000389', NULL, 'Uncharacterized protein, isoform E', 312, NULL, NULL, 197406),
(197407, '3.20.20.190-FF-000122', NULL, 'Phosphate system positive regulatory protein, putative', 307, NULL, NULL, 197407),
(197408, '1.20.1420.30-FF-000008', NULL, 'Vacuolar cation/proton exchanger', 157, NULL, NULL, 197408),
(197409, '2.30.30.140-FF-000032', NULL, 'MBT domain-containing protein 1 isoform X1', 110, NULL, NULL, 197409),
(197410, '2.60.40.150-FF-000210', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit gamma, putative', 167, NULL, NULL, 197410),
(197411, '3.40.50.2000-FF-000481', NULL, 'Glycosyltransferase', 241, NULL, NULL, 197411),
(197412, '3.40.50.10810-FF-000267', NULL, 'Uncharacterized protein', 268, NULL, NULL, 197412),
(197413, '2.60.60.20-FF-000014', NULL, 'Endothelial lipase', 144, NULL, NULL, 197413),
(197414, '1.20.900.10-FF-000006', NULL, 'Rho guanine nucleotide exchange factor (GEF) 11', 233, NULL, NULL, 197414),
(197415, '1.10.1070.11-FF-000063', NULL, 'GTOR', 162, NULL, NULL, 197415),
(197416, '1.10.2000.10-FF-000046', NULL, NULL, 123, NULL, NULL, 197416),
(197417, '3.50.50.60-FF-000069', NULL, 'Glutathione reductase', 213, NULL, NULL, 197417);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(197418, '3.40.50.300-FF-005103', NULL, 'Sulfotransferase', 340, NULL, NULL, 197418),
(197419, '2.60.40.10-FF-000679', NULL, 'Macrophage stimulating 1 receptor', 95, NULL, NULL, 197419),
(197420, '3.90.1150.10-FF-000082', NULL, 'Tyrosine phenol-lyase', 194, NULL, NULL, 197420),
(197421, '3.30.930.10-FF-000111', NULL, 'ATP phosphoribosyltransferase regulatory subunit', 319, NULL, NULL, 197421),
(197422, '3.30.1240.10-FF-000035', NULL, 'Sugar-phosphatase', 107, NULL, NULL, 197422),
(197423, '1.10.472.30-FF-000002', NULL, 'Death-inducer obliterator 1', 116, NULL, NULL, 197423),
(197424, '1.10.10.60-FF-000707', NULL, 'Dlx', 78, NULL, NULL, 197424),
(197425, '3.30.230.90-FF-000002', NULL, NULL, 128, NULL, NULL, 197425),
(197426, '2.130.10.10-FF-005013', NULL, 'Uncharacterized protein', 28, NULL, NULL, 197426),
(197427, '1.20.1070.10-FF-002077', NULL, 'Predicted protein', 53, NULL, NULL, 197427),
(197428, '3.30.160.60-FF-005187', NULL, NULL, 34, NULL, NULL, 197428),
(197429, '3.40.350.10-FF-000036', NULL, 'X-Pro dipeptidase', 168, NULL, NULL, 197429),
(197430, '1.10.8.60-FF-000021', NULL, 'Replication factor C subunit 1', 72, NULL, NULL, 197430),
(197431, '3.30.780.10-FF-000025', NULL, 'Eukaryotic translation initiation factor 1B', 66, NULL, NULL, 197431),
(197432, '3.90.550.10-FF-000585', NULL, 'ACR246Wp', 238, NULL, NULL, 197432),
(197433, '2.60.120.10-FF-000400', NULL, 'Os12g0529300 protein', 83, NULL, NULL, 197433),
(197434, '3.40.20.10-FF-000131', NULL, 'Uncharacterized protein', 146, NULL, NULL, 197434),
(197435, '3.40.50.300-FF-001450', NULL, 'ATP-dependent DNA helicase', 198, NULL, NULL, 197435),
(197436, '2.60.40.10-FF-003091', NULL, 'Protein sidekick homolog', 100, NULL, NULL, 197436),
(197437, '3.30.160.60-FF-001264', NULL, 'Zinc finger protein 219', 32, NULL, NULL, 197437),
(197438, '1.25.40.180-FF-000151', NULL, 'Initiation factor eIF-4 gamma MA3', 150, NULL, NULL, 197438),
(197439, '3.90.70.80-FF-000052', NULL, 'Uncharacterized protein', 152, NULL, NULL, 197439),
(197440, '1.20.5.620-FF-000006', NULL, NULL, 47, NULL, NULL, 197440),
(197441, '1.20.5.110-FF-000241', NULL, 'WASH complex subunit 3-like', 55, NULL, NULL, 197441),
(197442, '1.10.220.150-FF-000029', NULL, 'Centaurin, alpha 1, isoform CRA_b', 56, NULL, NULL, 197442),
(197443, '2.40.128.630-FF-000007', NULL, 'Beta-alanine-activating enzyme', 63, NULL, NULL, 197443),
(197444, '3.30.1360.40-FF-000030', NULL, 'DNA topoisomerase 2', 99, NULL, NULL, 197444),
(197445, '1.10.510.10-FF-001322', NULL, 'Kinase, AGC AKT', 210, NULL, NULL, 197445),
(197446, '2.40.128.620-FF-000004', NULL, 'Putative GH16255p', 68, NULL, NULL, 197446),
(197447, '3.40.50.2000-FF-000514', NULL, 'Alpha-1,4 glucan phosphorylase', 79, NULL, NULL, 197447),
(197448, '1.10.287.2620-FF-000001', NULL, 'Cytoplasmic dynein heavy chain 1', 66, NULL, NULL, 197448),
(197449, '3.30.160.60-FF-005810', NULL, NULL, 34, NULL, NULL, 197449),
(197450, '3.50.50.60-FF-001002', NULL, 'Uncharacterized protein', 114, NULL, NULL, 197450),
(197451, '1.10.287.70-FF-000364', NULL, 'Ion transport protein-like protein', 115, NULL, NULL, 197451),
(197452, '2.10.25.10-FF-001186', NULL, 'Integrin beta', 57, NULL, NULL, 197452),
(197453, '3.30.160.60-FF-005007', NULL, NULL, 24, NULL, NULL, 197453),
(197454, '3.40.190.10-FF-000181', NULL, 'ATP phosphoribosyltransferase', 125, NULL, NULL, 197454),
(197455, '1.20.1720.10-FF-000042', NULL, 'Drug transporter, putative', 371, NULL, NULL, 197455),
(197456, '3.40.50.1000-FF-000697', NULL, NULL, 126, NULL, NULL, 197456),
(197457, '3.80.10.10-FF-002158', NULL, 'Leucine rich immune protein (Coil-less)', 256, NULL, NULL, 197457),
(197458, '1.10.10.10-FF-000715', NULL, 'HTH-type transcriptional regulator rot', 123, NULL, NULL, 197458),
(197459, '3.50.50.60-FF-000872', NULL, 'Predicted protein', 387, NULL, NULL, 197459),
(197460, '3.40.190.10-FF-000557', NULL, 'HTH-type transcriptional regulator PhcA', 107, NULL, NULL, 197460),
(197461, '3.30.160.60-FF-004877', NULL, NULL, 28, NULL, NULL, 197461),
(197462, '3.20.20.150-FF-000043', NULL, 'Xylose isomerase domain protein TIM barrel', 275, NULL, NULL, 197462);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(197463, '3.30.40.10-FF-001993', NULL, 'Predicted protein', 54, NULL, NULL, 197463),
(197464, '1.10.287.110-FF-000399', NULL, 'Uncharacterized protein', 119, NULL, NULL, 197464),
(197465, '3.60.20.10-FF-000052', NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing] 2', 295, NULL, NULL, 197465),
(197466, '1.25.40.10-FF-002640', NULL, 'Uncharacterized protein', 182, NULL, NULL, 197466),
(197467, '2.60.40.60-FF-000385', NULL, 'Protocadherin-23', 105, NULL, NULL, 197467),
(197468, '3.40.50.720-FF-000468', NULL, 'Short-chain dehydrogenase, putative', 253, NULL, NULL, 197468),
(197469, '3.20.20.140-FF-000040', NULL, 'Putative tatD related deoxyribonuclease', 306, NULL, NULL, 197469),
(197470, '1.10.510.10-FF-001940', NULL, 'Predicted protein', 194, NULL, NULL, 197470),
(197471, '3.40.50.12470-FF-000017', NULL, NULL, 226, NULL, NULL, 197471),
(197472, '1.10.486.10-FF-000056', NULL, 'ATP-dependent DNA helicase', 36, NULL, NULL, 197472),
(197473, '3.30.450.20-FF-000330', NULL, 'Sensory transduction histidine kinase', 115, NULL, NULL, 197473),
(197474, '1.20.1700.10-FF-000007', NULL, 'Pantothenate kinase', 90, NULL, NULL, 197474),
(197475, '1.10.510.10-FF-002952', NULL, NULL, 116, NULL, NULL, 197475),
(197476, '2.10.25.10-FF-001101', NULL, 'AGAP005526-PA', 39, NULL, NULL, 197476),
(197477, '3.40.50.300-FF-003158', NULL, 'ATP/GTP-binding protein, putative', 222, NULL, NULL, 197477),
(197478, '3.60.140.10-FF-000015', NULL, 'Polyphenol oxidase', 221, NULL, NULL, 197478),
(197479, '3.30.420.110-FF-000068', NULL, 'DNA mismatch repair protein', 156, NULL, NULL, 197479),
(197480, '1.10.238.220-FF-000001', NULL, 'Serine/threonine-protein phosphatase 2A regulatory subunit B'''' subunit alpha', 88, NULL, NULL, 197480),
(197481, '3.30.460.10-FF-000153', NULL, 'Poly polymerase central domain containing protein', 156, NULL, NULL, 197481),
(197482, '3.10.450.700-FF-000008', NULL, 'Transcriptional activator protein Pur-alpha', 75, NULL, NULL, 197482),
(197483, '1.25.70.10-FF-000079', NULL, NULL, 225, NULL, NULL, 197483),
(197484, '1.25.40.10-FF-003275', NULL, 'Pentatricopeptide repeat-containing protein At5g19020, mitochondrial', 139, NULL, NULL, 197484),
(197485, '3.90.1800.10-FF-000025', NULL, 'DNA-directed RNA polymerase subunit beta', 133, NULL, NULL, 197485),
(197486, '3.30.160.60-FF-003006', NULL, 'Uncharacterized protein', 33, NULL, NULL, 197486),
(197487, '1.25.40.90-FF-000022', NULL, 'huntingtin-interacting protein 1 isoform X1', 130, NULL, NULL, 197487),
(197488, '3.90.70.10-FF-000582', NULL, 'Predicted protein', 377, NULL, NULL, 197488),
(197489, '3.30.1760.10-FF-000001', NULL, 'Siderophore biosynthesis protein SbnI', 121, NULL, NULL, 197489),
(197490, '1.25.40.820-FF-000034', NULL, 'Predicted protein', 137, NULL, NULL, 197490),
(197491, '1.10.8.60-FF-000291', NULL, 'Stage V sporulation protein K', 84, NULL, NULL, 197491),
(197492, '2.60.40.10-FF-002955', NULL, 'High Incidence of Males (Increased X chromosome loss)', 76, NULL, NULL, 197492),
(197493, '3.40.640.10-FF-000047', NULL, 'serine palmitoyltransferase 2 isoform X1', 252, NULL, NULL, 197493),
(197494, '3.30.40.10-FF-002246', NULL, 'Zinc finger protein, putative', 60, NULL, NULL, 197494),
(197495, '3.10.20.90-FF-000999', NULL, 'Predicted protein', 132, NULL, NULL, 197495),
(197496, '1.50.40.10-FF-000007', NULL, 'Mitochondrial tricarboxylate transport protein-like', 282, NULL, NULL, 197496),
(197497, '2.30.30.40-FF-000469', NULL, 'SH3 and F-BAR domain-containing protein DDB_G0271676', 82, NULL, NULL, 197497),
(197498, '3.30.710.10-FF-000454', NULL, 'Uncharacterized protein', 136, NULL, NULL, 197498),
(197499, '3.40.720.10-FF-000143', NULL, 'N-acetylgalactosamine-6-sulfate sulfatase', 378, NULL, NULL, 197499),
(197500, '1.20.58.60-FF-000452', NULL, 'Spectrin, beta, non-erythrocytic 5', 105, NULL, NULL, 197500),
(197501, '2.30.42.10-FF-000651', NULL, NULL, 105, NULL, NULL, 197501),
(197502, '3.40.50.2300-FF-000716', NULL, 'Ribose ABC transporter periplasmic binding protein', 136, NULL, NULL, 197502),
(197503, '3.30.470.20-FF-000213', NULL, 'Pyruvate carboxylase, gene 2', 121, NULL, NULL, 197503);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(197504, '3.30.1740.20-FF-000003', NULL, '40S ribosomal protein S26', 107, NULL, NULL, 197504),
(197505, '3.40.50.300-FF-002793', NULL, 'ATP-dependent DNA helicase DinG', 274, NULL, NULL, 197505),
(197506, '3.40.50.300-FF-004878', NULL, 'Uncharacterized protein', 175, NULL, NULL, 197506),
(197507, '3.20.20.140-FF-000130', NULL, 'Sodium/hydrogen exchanger 2', 107, NULL, NULL, 197507),
(197508, '1.20.1250.20-FF-001958', NULL, 'Uncharacterized protein', 426, NULL, NULL, 197508),
(197509, '2.40.420.20-FF-000054', NULL, 'RND superfamily resistance-nodulation-cell division antiporter', 66, NULL, NULL, 197509),
(197510, '3.80.10.10-FF-000269', NULL, 'Piriformospora indica-insensitive protein 2', 169, NULL, NULL, 197510),
(197511, '2.60.120.650-FF-000167', NULL, 'Os02g0109400 protein', 190, NULL, NULL, 197511),
(197512, '1.10.220.20-FF-000004', NULL, 'Golgi-specific brefeldin A-resistance guanine nucleotide exchange factor 1', 86, NULL, NULL, 197512),
(197513, '1.20.5.5270-FF-000005', NULL, 'Lon protease', 48, NULL, NULL, 197513),
(197514, '3.30.70.330-FF-000571', NULL, 'Glycine-rich RNA-binding protein 3 mitochondrial', 118, NULL, NULL, 197514),
(197515, '1.10.150.20-FF-000263', NULL, 'UvrABC system protein C', 57, NULL, NULL, 197515),
(197516, '3.40.50.300-FF-004884', NULL, 'ATP-binding protein', 248, NULL, NULL, 197516),
(197517, '3.20.20.450-FF-000009', NULL, 'Cyclic diguanylate phosphodiesterase', 247, NULL, NULL, 197517),
(197518, '1.10.10.60-FF-001017', NULL, NULL, 75, NULL, NULL, 197518),
(197519, '4.10.1000.10-FF-000111', NULL, 'Predicted protein', 57, NULL, NULL, 197519),
(197520, '2.40.50.120-FF-000039', NULL, 'GD20727', 84, NULL, NULL, 197520),
(197521, '1.20.5.5260-FF-000002', NULL, 'Two-component-system connector protein YcgZ', 56, NULL, NULL, 197521),
(197522, '3.40.50.300-FF-000230', NULL, 'Lipoprotein-releasing system ATP-binding protein LolD', 229, NULL, NULL, 197522),
(197523, '1.10.472.80-FF-000062', NULL, 'Uncharacterized protein, isoform C', 135, NULL, NULL, 197523),
(197524, '2.60.260.20-FF-000149', NULL, 'Uncharacterized protein', 27, NULL, NULL, 197524),
(197525, '3.30.365.10-FF-000050', NULL, 'Uncharacterized protein', 123, NULL, NULL, 197525),
(197526, '1.10.220.30-FF-000007', NULL, 'Flagellar motor switch protein FliG', 85, NULL, NULL, 197526),
(197527, '2.10.25.10-FF-001534', NULL, 'Integrin subunit beta-like 1', 84, NULL, NULL, 197527),
(197528, '1.20.1000.10-FF-000038', NULL, NULL, 238, NULL, NULL, 197528),
(197529, '3.80.10.10-FF-001848', NULL, 'AGAP011186-PA', 181, NULL, NULL, 197529),
(197530, '1.25.40.10-FF-003331', NULL, 'Uncharacterized protein', 99, NULL, NULL, 197530),
(197531, '2.120.10.80-FF-000419', NULL, 'Predicted protein', 244, NULL, NULL, 197531),
(197532, '1.25.10.10-FF-000013', NULL, 'Importin subunit alpha', 429, NULL, NULL, 197532),
(197533, '3.30.497.10-FF-000075', NULL, 'Uncharacterized protein', 55, NULL, NULL, 197533),
(197534, '2.30.130.110-FF-000003', NULL, 'D-galactarate dehydratase', 86, NULL, NULL, 197534),
(197535, '3.40.710.10-FF-000114', NULL, 'D-alanyl-D-alanine carboxypeptidase', 208, NULL, NULL, 197535),
(197536, '3.40.250.10-FF-000034', NULL, 'Dual specificity phosphatase 2', 138, NULL, NULL, 197536),
(197537, '1.20.1250.20-FF-000177', NULL, 'proton myo-inositol cotransporter isoform X1', 356, NULL, NULL, 197537),
(197538, '3.40.50.720-FF-000704', NULL, 'Oxidoreductase, short-chain dehydrogenase/reductase family', 245, NULL, NULL, 197538),
(197539, '1.25.10.20-FF-000016', NULL, 'Vitellogenin', 316, NULL, NULL, 197539),
(197540, '3.40.50.300-FF-006593', NULL, 'ATP synthase subunit beta chloroplastic', 98, NULL, NULL, 197540),
(197541, '3.30.420.40-FF-000547', NULL, 'Cell growth defect factor 2', 56, NULL, NULL, 197541),
(197542, '1.10.10.10-FF-000917', NULL, 'Cullin-1, putative', 83, NULL, NULL, 197542),
(197543, '2.40.50.140-FF-000433', NULL, 'Sugar ABC transporter ATP-binding protein', 51, NULL, NULL, 197543),
(197544, '3.40.50.2300-FF-001121', NULL, NULL, 197, NULL, NULL, 197544),
(197545, '3.30.450.20-FF-000037', NULL, 'Cell wall metabolism sensor histidine kinase', 97, NULL, NULL, 197545);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(197546, '2.60.220.50-FF-000043', NULL, 'Adhesion G protein-coupled receptor L3', 165, NULL, NULL, 197546),
(197547, '3.30.70.260-FF-000050', NULL, 'D-3-phosphoglycerate dehydrogenase', 74, NULL, NULL, 197547),
(197548, '3.40.1690.20-FF-000024', NULL, 'Uncharacterized protein', 97, NULL, NULL, 197548),
(197549, '3.90.20.20-FF-000020', NULL, 'Protein GrpE', 116, NULL, NULL, 197549),
(197550, '3.40.50.720-FF-001688', NULL, 'Bifunctional dTDP-4-dehydrorhamnose 3,5-epimerase/dTDP-4-dehydrorhamnose reductase', 70, NULL, NULL, 197550),
(197551, '3.20.20.140-FF-000219', NULL, 'Lmo1231 protein', 244, NULL, NULL, 197551),
(197552, '3.30.70.270-FF-000053', NULL, 'DNA polymerase IV', 56, NULL, NULL, 197552),
(197553, '1.25.40.10-FF-002724', NULL, 'Uncharacterized protein', 404, NULL, NULL, 197553),
(197554, '1.20.1160.11-FF-000028', NULL, NULL, 69, NULL, NULL, 197554),
(197555, '3.40.30.10-FF-000896', NULL, 'Uncharacterized protein', 99, NULL, NULL, 197555),
(197556, '2.30.30.490-FF-000058', NULL, 'Arginine-glutamic acid dipeptide (RE) repeats a', 67, NULL, NULL, 197556),
(197557, '3.40.50.11610-FF-000018', NULL, 'Probable 2-oxoglutarate dehydrogenase E1 component DHKTD1 homolog, mitochondrial', 164, NULL, NULL, 197557),
(197558, '3.30.2130.30-FF-000038', NULL, 'THUMP domain-containing 2', 124, NULL, NULL, 197558),
(197559, '3.40.630.30-FF-000119', NULL, 'Putative acetyltransferase', 157, NULL, NULL, 197559),
(197560, '3.30.450.50-FF-000052', NULL, 'SNARE-like superfamily protein', 160, NULL, NULL, 197560),
(197561, '3.40.50.2000-FF-000188', NULL, 'Phosphatidylinositol N-acetylglucosaminyltransferase gpi3 subunit', 169, NULL, NULL, 197561),
(197562, '2.60.40.10-FF-003028', NULL, 'Cytokine receptor-like factor 2', 99, NULL, NULL, 197562),
(197563, '3.40.50.1820-FF-000971', NULL, 'Lipase (Class 3), putative', 272, NULL, NULL, 197563),
(197564, '3.40.50.300-FF-001157', NULL, 'Uncharacterized protein, isoform G', 266, NULL, NULL, 197564),
(197565, '3.30.450.60-FF-000055', NULL, 'TSET complex member tstD', 152, NULL, NULL, 197565),
(197566, '1.20.1250.20-FF-001487', NULL, 'Uncharacterized protein', 224, NULL, NULL, 197566),
(197567, '3.30.1460.20-FF-000021', NULL, 'Uncharacterized protein', 101, NULL, NULL, 197567),
(197568, '1.10.238.10-FF-001306', NULL, 'CDPK-related kinase 1', 41, NULL, NULL, 197568),
(197569, '1.10.287.1490-FF-000095', NULL, 'Uncharacterized protein', 187, NULL, NULL, 197569),
(197570, '1.10.287.470-FF-000080', NULL, 'Sensory rhodopsin II transducer', 51, NULL, NULL, 197570),
(197571, '3.40.50.720-FF-001311', NULL, 'Phosphoglycerate dehydrogenase', 206, NULL, NULL, 197571),
(197572, '3.40.710.10-FF-000171', NULL, 'Peptidoglycan transpeptidase', 369, NULL, NULL, 197572),
(197573, '2.130.10.10-FF-003540', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', 319, NULL, NULL, 197573),
(197574, '1.20.1250.20-FF-002268', NULL, 'Uncharacterized protein', 99, NULL, NULL, 197574),
(197575, '2.130.10.10-FF-005631', NULL, 'Apoptotic protease-activating factor, putative', 178, NULL, NULL, 197575),
(197576, '2.60.40.10-FF-005030', NULL, NULL, 104, NULL, NULL, 197576),
(197577, '1.10.472.10-FF-000406', NULL, 'Mitotic cyclin', 107, NULL, NULL, 197577),
(197578, '2.60.120.650-FF-000223', NULL, 'Uncharacterized protein', 183, NULL, NULL, 197578),
(197579, '3.90.1200.10-FF-000024', NULL, 'Acyl-CoA dehydrogenase FadE36', 236, NULL, NULL, 197579),
(197580, '4.10.240.10-FF-000031', NULL, 'C6 transcription factor, putative', 60, NULL, NULL, 197580),
(197581, '1.20.1070.10-FF-002167', NULL, 'Smoothend-like protein protein', 131, NULL, NULL, 197581),
(197582, '3.40.50.1820-FF-000263', NULL, 'Carboxylic ester hydrolase', 525, NULL, NULL, 197582),
(197583, '2.60.40.10-FF-005119', NULL, NULL, 97, NULL, NULL, 197583),
(197584, '1.25.40.20-FF-001480', NULL, 'Uncharacterized protein', 224, NULL, NULL, 197584),
(197585, '2.60.120.260-FF-000466', NULL, 'Ephrin type-B receptor 1-B', 116, NULL, NULL, 197585),
(197586, '3.40.1690.10-FF-000021', NULL, 'Uncharacterized protein', 89, NULL, NULL, 197586);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(197587, '3.90.190.10-FF-000130', NULL, 'Dual specificity protein phosphatase, putative', 156, NULL, NULL, 197587),
(197588, '3.30.160.60-FF-001825', NULL, 'ZNF141 isoform 4', 27, NULL, NULL, 197588),
(197589, '3.30.565.10-FF-000357', NULL, 'Heat shock protein HSP 90-beta', 220, NULL, NULL, 197589),
(197590, '3.30.70.330-FF-000239', NULL, 'Polyadenylate-binding protein', 96, NULL, NULL, 197590),
(197591, '1.10.8.10-FF-000231', NULL, 'Elongation factor 1-alpha 2-like Protein', 57, NULL, NULL, 197591),
(197592, '3.40.50.620-FF-000264', NULL, 'Diphthine--ammonia ligase', 157, NULL, NULL, 197592),
(197593, '1.20.1070.10-FF-000278', NULL, 'Trace amine-associated receptor 1', 323, NULL, NULL, 197593),
(197594, '1.10.510.10-FF-002103', NULL, NULL, 142, NULL, NULL, 197594),
(197595, '1.20.1270.10-FF-000024', NULL, 'Heat shock protein 70', 105, NULL, NULL, 197595),
(197596, '2.60.40.2660-FF-000005', NULL, NULL, 159, NULL, NULL, 197596),
(197597, '3.30.1370.10-FF-000191', NULL, 'Protein CBG10565', 154, NULL, NULL, 197597),
(197598, '2.60.40.770-FF-000014', NULL, 'GM12130', 83, NULL, NULL, 197598),
(197599, '3.40.50.2300-FF-000396', NULL, 'Hybrid sensor histidine kinase/response regulator', 124, NULL, NULL, 197599),
(197600, '1.20.1730.10-FF-000104', NULL, 'Uncharacterized protein', 205, NULL, NULL, 197600),
(197601, '3.40.50.150-FF-001146', NULL, NULL, 220, NULL, NULL, 197601),
(197602, '3.40.50.300-FF-007374', NULL, 'Un-named sa911', 67, NULL, NULL, 197602),
(197603, '2.60.40.10-FF-003085', NULL, 'Fibronectin type III domain-containing protein 1', 119, NULL, NULL, 197603),
(197604, '3.30.160.20-FF-000083', NULL, 'Ribonuclease 3', 67, NULL, NULL, 197604),
(197605, '3.90.550.50-FF-000187', NULL, 'Uncharacterized protein', 211, NULL, NULL, 197605),
(197606, '1.20.1070.10-FF-001857', NULL, 'Uncharacterized protein', 349, NULL, NULL, 197606),
(197607, '3.40.1110.10-FF-000225', NULL, 'Copper transporter', 126, NULL, NULL, 197607),
(197608, '2.130.10.30-FF-000056', NULL, 'RCC1 domain containing 1', 125, NULL, NULL, 197608),
(197609, '3.30.160.60-FF-005423', NULL, NULL, 37, NULL, NULL, 197609),
(197610, '1.10.10.10-FF-001266', NULL, 'Histone acetyltransferase', 61, NULL, NULL, 197610),
(197611, '3.30.160.60-FF-006030', NULL, NULL, 25, NULL, NULL, 197611),
(197612, '2.130.10.10-FF-000050', NULL, 'breast carcinoma-amplified sequence 3 isoform X2', 152, NULL, NULL, 197612),
(197613, '3.20.20.140-FF-000332', NULL, 'L-rhamnono-gamma-lactonase', 333, NULL, NULL, 197613),
(197614, '2.130.10.10-FF-001028', NULL, 'Antiviral protein SKI8', 397, NULL, NULL, 197614),
(197615, '3.40.50.80-FF-000081', NULL, 'Probable metalloreductase AIM14', 168, NULL, NULL, 197615),
(197616, '3.40.50.2000-FF-000840', NULL, 'Uncharacterized protein', 58, NULL, NULL, 197616),
(197617, '1.25.40.10-FF-004579', NULL, 'Uncharacterized protein', 282, NULL, NULL, 197617),
(197618, '3.40.50.620-FF-000500', NULL, 'Uncharacterized protein', 101, NULL, NULL, 197618),
(197619, '3.50.50.60-FF-000833', NULL, 'AGR055Cp', 110, NULL, NULL, 197619),
(197620, '1.25.10.10-FF-003447', NULL, 'Uncharacterized protein', 230, NULL, NULL, 197620),
(197621, '2.60.120.260-FF-000522', NULL, 'Uncharacterized protein', 126, NULL, NULL, 197621),
(197622, '1.25.40.10-FF-001999', NULL, 'Os11g0213500 protein', 141, NULL, NULL, 197622),
(197623, '3.10.20.310-FF-000020', NULL, 'Outer membrane protein assembly factor BamA', 83, NULL, NULL, 197623),
(197624, '3.30.50.10-FF-000184', NULL, 'Uncharacterized protein', 45, NULL, NULL, 197624),
(197625, '1.10.640.10-FF-000073', NULL, 'Peroxidase, putative', 95, NULL, NULL, 197625),
(197626, '2.130.10.10-FF-004844', NULL, 'Uncharacterized protein', 130, NULL, NULL, 197626),
(197627, '1.10.510.10-FF-004189', NULL, NULL, 112, NULL, NULL, 197627),
(197628, '2.60.40.60-FF-001076', NULL, 'Predicted protein', 112, NULL, NULL, 197628),
(197629, '3.30.559.10-FF-000264', NULL, 'BAHD acyltransferase BIA1', 218, NULL, NULL, 197629),
(197630, '3.60.10.10-FF-000023', NULL, 'Type IV inositol polyphosphate 5-phosphatase 7', 107, NULL, NULL, 197630);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(197631, '1.10.287.660-FF-000013', NULL, 'AGAP002538-PA', 81, NULL, NULL, 197631),
(197632, '1.10.1670.10-FF-000028', NULL, 'A/G-specific adenine glycosylase', 89, NULL, NULL, 197632),
(197633, '1.25.40.10-FF-000779', NULL, 'Pentatricopeptide repeat-containing protein', 178, NULL, NULL, 197633),
(197634, '1.20.1070.10-FF-000514', NULL, 'G protein coupled receptor', 260, NULL, NULL, 197634),
(197635, '1.20.920.10-FF-000210', NULL, 'Uncharacterized protein', 149, NULL, NULL, 197635),
(197636, '1.20.1250.20-FF-002324', NULL, 'Uncharacterized protein', 227, NULL, NULL, 197636),
(197637, '3.40.190.10-FF-000265', NULL, 'ABC transporter substrate-binding protein', 76, NULL, NULL, 197637),
(197638, '3.40.1480.10-FF-000011', NULL, 'Uncharacterized protein', 171, NULL, NULL, 197638),
(197639, '2.120.10.80-FF-000217', NULL, 'Host cell factor-like Protein', 171, NULL, NULL, 197639),
(197640, '3.90.1720.10-FF-000024', NULL, 'Probable endopeptidase MT2245', 145, NULL, NULL, 197640),
(197641, '3.40.50.410-FF-000173', NULL, 'Collagen, type VI, alpha 1', 122, NULL, NULL, 197641),
(197642, '1.10.287.3240-FF-000035', NULL, 'Uncharacterized protein', 196, NULL, NULL, 197642),
(197643, '3.90.810.10-FF-000032', NULL, NULL, 31, NULL, NULL, 197643),
(197644, '3.80.10.10-FF-002304', NULL, 'Leucine Rich Repeat, putative', 198, NULL, NULL, 197644),
(197645, '1.25.40.10-FF-002494', NULL, 'Pentatricopeptide repeat-containing protein At1g09900', 72, NULL, NULL, 197645),
(197646, '3.50.50.60-FF-000456', NULL, 'Glycerol-3-phosphate dehydrogenase', 197, NULL, NULL, 197646),
(197647, '2.130.10.10-FF-001831', NULL, 'WD repeat-containing protein 37-like Protein', 116, NULL, NULL, 197647),
(197648, '2.60.40.60-FF-001109', NULL, 'Predicted protein', 86, NULL, NULL, 197648),
(197649, '3.40.850.10-FF-000237', NULL, 'Kinesin-like protein', 178, NULL, NULL, 197649),
(197650, '3.40.50.2000-FF-000368', NULL, 'BnaA06g10670D protein', 132, NULL, NULL, 197650),
(197651, '1.10.287.70-FF-000072', NULL, 'Cyclic nucleotide gated channel beta 3', 227, NULL, NULL, 197651),
(197652, '2.40.50.140-FF-000197', NULL, 'DNA ligase', 162, NULL, NULL, 197652),
(197653, '2.120.10.30-FF-000343', NULL, 'Predicted protein', 195, NULL, NULL, 197653),
(197654, '1.10.510.10-FF-001176', NULL, 'Cell division control protein 2 like', 213, NULL, NULL, 197654),
(197655, '2.60.40.10-FF-004866', NULL, NULL, 68, NULL, NULL, 197655),
(197656, '3.30.70.330-FF-000419', NULL, 'CLUMA_CG006354, isoform A', 102, NULL, NULL, 197656),
(197657, '1.20.59.10-FF-000012', NULL, 'Isochorismate pyruvate lyase', 101, NULL, NULL, 197657),
(197658, '1.10.287.130-FF-000028', NULL, 'Hybrid signal transduction histidine kinase', 90, NULL, NULL, 197658),
(197659, '3.30.160.60-FF-002753', NULL, 'AGAP011403-PA', 30, NULL, NULL, 197659),
(197660, '3.40.50.1220-FF-000027', NULL, 'Unplaced genomic scaffold supercont1.13, whole genome shotgun sequence', 237, NULL, NULL, 197660),
(197661, '3.30.70.330-FF-002656', NULL, NULL, 171, NULL, NULL, 197661),
(197662, '3.30.200.20-FF-002470', NULL, 'Uncharacterized protein', 49, NULL, NULL, 197662),
(197663, '2.40.50.90-FF-000030', NULL, 'Transcription factor (Snd1/p100), putative', 159, NULL, NULL, 197663),
(197664, '3.30.420.40-FF-000660', NULL, 'Actin, putative', 51, NULL, NULL, 197664),
(197665, '3.40.50.300-FF-003574', NULL, 'Ras family protein', 225, NULL, NULL, 197665),
(197666, '1.10.287.130-FF-000085', NULL, 'Signal transduction histidine-protein kinase atoS', 79, NULL, NULL, 197666),
(197667, '1.10.510.10-FF-003121', NULL, NULL, 189, NULL, NULL, 197667),
(197668, '2.130.10.10-FF-001180', NULL, 'YBR246W-like protein', 367, NULL, NULL, 197668),
(197669, '2.60.40.10-FF-000595', NULL, 'Immunoglobulin superfamily member 11', 120, NULL, NULL, 197669),
(197670, '2.10.25.10-FF-001478', NULL, 'Hemicentin 2', 40, NULL, NULL, 197670),
(197671, '1.10.640.10-FF-000016', NULL, 'Protein CBG02940', 557, NULL, NULL, 197671),
(197672, '3.20.20.80-FF-000147', NULL, 'Maltooligosyl trehalose synthase', 266, NULL, NULL, 197672),
(197673, '2.30.42.10-FF-000471', NULL, NULL, 107, NULL, NULL, 197673);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(197674, '2.60.40.1290-FF-000004', NULL, 'Sialidase (Neuraminidase)', 166, NULL, NULL, 197674),
(197675, '3.40.50.300-FF-007520', NULL, 'ATP-dependent DNA helicase', 211, NULL, NULL, 197675),
(197676, '3.40.50.150-FF-001236', NULL, NULL, 127, NULL, NULL, 197676),
(197677, '2.10.110.10-FF-000192', NULL, 'Wilms tumor protein 1-interacting protein-like protein', 40, NULL, NULL, 197677),
(197678, '1.20.1730.10-FF-000014', NULL, 'Cation acetate symporter', 465, NULL, NULL, 197678),
(197679, '3.40.50.300-FF-001865', NULL, 'GTP-binding protein', 233, NULL, NULL, 197679),
(197680, '2.40.50.140-FF-001214', NULL, NULL, 77, NULL, NULL, 197680),
(197681, '2.70.160.11-FF-000036', NULL, 'Protein arginine N-methyltransferase', 200, NULL, NULL, 197681),
(197682, '3.30.420.140-FF-000026', NULL, 'Putative pre-16S rRNA nuclease', 143, NULL, NULL, 197682),
(197683, '1.10.533.10-FF-000195', NULL, 'MC160', 85, NULL, NULL, 197683),
(197684, '3.20.20.70-FF-000144', NULL, 'sialic acid synthase', 268, NULL, NULL, 197684),
(197685, '3.40.50.300-FF-002141', NULL, 'Dynein heavy chain', 165, NULL, NULL, 197685),
(197686, '1.20.1050.10-FF-000193', NULL, 'AGAP012839-PA', 107, NULL, NULL, 197686),
(197687, '3.30.230.10-FF-000052', NULL, 'Mitochondrial ribosomal protein S5, putative', 88, NULL, NULL, 197687),
(197688, '3.40.30.10-FF-000244', NULL, 'Sulfhydryl oxidase', 168, NULL, NULL, 197688),
(197689, '4.10.1040.10-FF-000001', NULL, 'doublesex- and mab-3-related transcription factor 1', 50, NULL, NULL, 197689),
(197690, '1.10.10.10-FF-001412', NULL, 'Cadmium resistance transcriptional regulator CadC', 110, NULL, NULL, 197690),
(197691, '1.20.1070.10-FF-001296', NULL, 'Uncharacterized protein', 187, NULL, NULL, 197691),
(197692, '3.80.10.10-FF-000505', NULL, 'Outer arm dynein light chain 1 protein', 114, NULL, NULL, 197692),
(197693, '3.40.50.1460-FF-000048', NULL, 'Uncharacterized protein', 240, NULL, NULL, 197693),
(197694, '3.40.50.970-FF-000077', NULL, 'Pyruvate dehydrogenase E1 component subunit beta', 190, NULL, NULL, 197694),
(197695, '3.30.760.10-FF-000081', NULL, 'Uncharacterized protein', 153, NULL, NULL, 197695),
(197696, '1.20.1250.20-FF-000941', NULL, 'Uncharacterized protein', 180, NULL, NULL, 197696),
(197697, '1.10.238.10-FF-000582', NULL, 'RCG62658, isoform CRA_a', 105, NULL, NULL, 197697),
(197698, '1.10.287.70-FF-000033', NULL, 'Mucolipin 1', 128, NULL, NULL, 197698),
(197699, '3.30.300.110-FF-000007', NULL, 'tRNA (guanine(37)-N1)-methyltransferase', 61, NULL, NULL, 197699),
(197700, '2.60.120.920-FF-000124', NULL, 'Neuralized-like protein 4', 169, NULL, NULL, 197700),
(197701, '1.20.120.1240-FF-000063', NULL, 'Dynamin-related GTPase', 199, NULL, NULL, 197701),
(197702, '2.120.10.10-FF-000005', NULL, 'Neuraminidase 4', 310, NULL, NULL, 197702),
(197703, '2.60.120.200-FF-000526', NULL, 'Galectin-1', 150, NULL, NULL, 197703),
(197704, '2.10.25.10-FF-000371', NULL, 'Hemicentin 1', 41, NULL, NULL, 197704),
(197705, '3.90.226.10-FF-000309', NULL, 'ATP-dependent Clp protease proteolytic subunit', 104, NULL, NULL, 197705),
(197706, '3.60.60.10-FF-000026', NULL, 'Bile salt hydrolase', 159, NULL, NULL, 197706),
(197707, '3.10.129.10-FF-000225', NULL, 'Uncharacterized protein', 170, NULL, NULL, 197707),
(197708, '2.60.120.200-FF-000583', NULL, 'Uncharacterized protein', 166, NULL, NULL, 197708),
(197709, '3.30.310.130-FF-000021', NULL, 'Uncharacterized protein', 128, NULL, NULL, 197709),
(197710, '3.30.890.10-FF-000028', NULL, 'Uncharacterized protein', 109, NULL, NULL, 197710),
(197711, '3.90.228.10-FF-000010', NULL, 'Poly [ADP-ribose] polymerase', 217, NULL, NULL, 197711),
(197712, '1.10.10.1770-FF-000003', NULL, 'Slr1958 protein', 85, NULL, NULL, 197712),
(197713, '3.30.200.20-FF-000845', NULL, 'LRR receptor-like serine/threonine-protein kinase', 88, NULL, NULL, 197713),
(197714, '4.10.60.10-FF-000245', NULL, 'Uncharacterized protein', 32, NULL, NULL, 197714),
(197715, '3.90.640.10-FF-000092', NULL, 'Actin-related protein 8', 101, NULL, NULL, 197715),
(197716, '2.10.25.10-FF-000314', NULL, 'Low-density lipoprotein receptor-related protein', 34, NULL, NULL, 197716);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(197717, '2.60.120.200-FF-000055', NULL, 'Crumbs cell polarity complex component 1', 162, NULL, NULL, 197717),
(197718, '1.25.10.10-FF-002666', NULL, 'Uncharacterized protein', 96, NULL, NULL, 197718),
(197719, '1.10.101.10-FF-000040', NULL, 'Uncharacterized protein', 92, NULL, NULL, 197719),
(197720, '2.60.220.50-FF-000133', NULL, 'Uncharacterized protein', 169, NULL, NULL, 197720),
(197721, '1.10.196.10-FF-000011', NULL, 'Axin, isoform B', 42, NULL, NULL, 197721),
(197722, '3.90.228.20-FF-000013', NULL, NULL, 170, NULL, NULL, 197722),
(197723, '3.30.830.10-FF-000199', NULL, 'Metalloprotease, insulinase family', 246, NULL, NULL, 197723),
(197724, '3.60.10.10-FF-000080', NULL, 'Carbon catabolite repressor protein 4 homolog 3', 344, NULL, NULL, 197724),
(197725, '3.40.50.720-FF-002183', NULL, 'Ubiquitin-like modifier-activating enzyme 1', 56, NULL, NULL, 197725),
(197726, '1.10.150.60-FF-000050', NULL, NULL, 74, NULL, NULL, 197726),
(197727, '1.20.1560.10-FF-000366', NULL, 'Uncharacterized protein', 345, NULL, NULL, 197727),
(197728, '3.40.50.150-FF-001707', NULL, NULL, 62, NULL, NULL, 197728),
(197729, '3.90.640.10-FF-000053', NULL, 'Chaperone DnaK', 85, NULL, NULL, 197729),
(197730, '2.130.10.10-FF-002517', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', 288, NULL, NULL, 197730),
(197731, '3.90.850.10-FF-000006', NULL, '2-keto-4-pentenoate hydratase', 269, NULL, NULL, 197731),
(197732, '1.20.90.10-FF-000028', NULL, NULL, 140, NULL, NULL, 197732),
(197733, '3.30.1490.100-FF-000044', NULL, 'Predicted protein', 117, NULL, NULL, 197733),
(197734, '1.25.40.10-FF-001420', NULL, 'MSHA biogenesis protein MshN', 109, NULL, NULL, 197734),
(197735, '1.20.1740.10-FF-000133', NULL, 'Uncharacterized protein', 499, NULL, NULL, 197735),
(197736, '1.20.1510.10-FF-000088', NULL, NULL, 59, NULL, NULL, 197736),
(197737, '3.30.70.330-FF-002746', NULL, NULL, 92, NULL, NULL, 197737),
(197738, '2.60.40.1690-FF-000001', NULL, 'Fusion glycoprotein F0', 57, NULL, NULL, 197738),
(197739, '1.10.287.130-FF-000118', NULL, 'Hybrid sensor histidine kinase/response regulator', 99, NULL, NULL, 197739),
(197740, '3.40.50.10380-FF-000008', NULL, 'Malic enzyme', 255, NULL, NULL, 197740),
(197741, '1.10.565.10-FF-000004', NULL, 'Androgen receptor variant', 258, NULL, NULL, 197741),
(197742, '3.40.50.620-FF-000915', NULL, 'Uncharacterized protein', 14, NULL, NULL, 197742),
(197743, '1.25.10.10-FF-003032', NULL, 'Proteasome component ecm29', 312, NULL, NULL, 197743),
(197744, '1.20.1250.20-FF-000323', NULL, 'protein NRT1/ PTR FAMILY 6.1', 540, NULL, NULL, 197744),
(197745, '3.30.70.330-FF-000947', NULL, 'Probable splicing factor, arginine/serine-rich 4', 115, NULL, NULL, 197745),
(197746, '1.10.730.10-FF-000046', NULL, 'Leucine--tRNA ligase', 149, NULL, NULL, 197746),
(197747, '2.60.120.200-FF-000111', NULL, 'Usherin', 172, NULL, NULL, 197747),
(197748, '3.40.50.300-FF-007317', NULL, 'Gll2992 protein', 146, NULL, NULL, 197748),
(197749, '2.60.200.20-FF-000174', NULL, 'Uncharacterized protein', 74, NULL, NULL, 197749),
(197750, '3.80.10.10-FF-004305', NULL, 'Uncharacterized protein', 217, NULL, NULL, 197750),
(197751, '1.10.8.10-FF-000118', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 58, NULL, NULL, 197751),
(197752, '1.10.510.10-FF-003407', NULL, NULL, 298, NULL, NULL, 197752),
(197753, '2.10.70.10-FF-000003', NULL, 'Versican core protein', 61, NULL, NULL, 197753),
(197754, '3.40.225.10-FF-000015', NULL, 'Phosphomethylpyrimidine kinase (Hmp-phosphate kinase)', 181, NULL, NULL, 197754),
(197755, '3.30.200.20-FF-000227', NULL, 'Cyclin-dependent kinase 9', 107, NULL, NULL, 197755),
(197756, '3.40.50.1580-FF-000028', NULL, 'Phosphorylase', 255, NULL, NULL, 197756),
(197757, '3.80.10.10-FF-004344', NULL, 'AGAP011394-PA', 188, NULL, NULL, 197757),
(197758, '3.30.200.20-FF-000935', NULL, 'Ygk3p', 90, NULL, NULL, 197758),
(197759, '1.25.40.20-FF-001423', NULL, 'Uncharacterized protein', 184, NULL, NULL, 197759),
(197760, '2.130.10.30-FF-000112', NULL, NULL, 141, NULL, NULL, 197760);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(197761, '1.20.1270.60-FF-000342', NULL, 'Uncharacterized protein', 113, NULL, NULL, 197761),
(197762, '3.60.20.40-FF-000010', NULL, 'Protein-glutamine gamma-glutamyltransferase, putative', 201, NULL, NULL, 197762),
(197763, '3.30.9.10-FF-000206', NULL, 'D-aspartate oxidase', 143, NULL, NULL, 197763),
(197764, '1.10.287.130-FF-000231', NULL, 'ATP-binding region ATPase domain protein', 81, NULL, NULL, 197764),
(197765, '1.10.600.10-FF-000042', NULL, 'Probable terpene synthase 3, chloroplastic', 314, NULL, NULL, 197765),
(197766, '3.30.1140.40-FF-000008', NULL, 'Dynein light chain (Eurofung)', 128, NULL, NULL, 197766),
(197767, '2.60.40.10-FF-003321', NULL, NULL, 99, NULL, NULL, 197767),
(197768, '3.40.630.30-FF-000232', NULL, 'GG16894', 169, NULL, NULL, 197768),
(197769, '3.20.20.80-FF-000057', NULL, 'Di-N-acetylchitobiase', 168, NULL, NULL, 197769),
(197770, '1.25.40.660-FF-000020', NULL, 'Vacuolar protein sorting-associated protein 35', 301, NULL, NULL, 197770),
(197771, '2.40.50.140-FF-000904', NULL, NULL, 80, NULL, NULL, 197771),
(197772, '3.80.10.10-FF-000415', NULL, 'Inactive LRR receptor-like serine/threonine-protein kinase BIR2', 190, NULL, NULL, 197772),
(197773, '3.30.230.10-FF-000142', NULL, 'Ribonuclease P protein component', 109, NULL, NULL, 197773),
(197774, '3.40.50.20-FF-000046', NULL, 'Phosphoribosylamine--glycine ligase-like protein', 124, NULL, NULL, 197774),
(197775, '3.90.70.200-FF-000007', NULL, 'Plus-3 domain/Zinc finger', 143, NULL, NULL, 197775),
(197776, '2.60.120.260-FF-000286', NULL, 'Protein CBG09205', 161, NULL, NULL, 197776),
(197777, '2.30.42.10-FF-000319', NULL, 'Proteasome regulatory subunit, putative', 99, NULL, NULL, 197777),
(197778, '3.30.70.560-FF-000016', NULL, 'Uncharacterized protein', 162, NULL, NULL, 197778),
(197779, '1.20.58.60-FF-000339', NULL, 'Envoplakin like', 100, NULL, NULL, 197779),
(197780, '3.40.50.1820-FF-000443', NULL, 'Putative serine esterase Mb1866c', 247, NULL, NULL, 197780),
(197781, '1.20.5.270-FF-000002', NULL, 'Cytochrome b-c1 complex subunit Rieske, mitochondrial', 54, NULL, NULL, 197781),
(197782, '2.30.42.10-FF-000561', NULL, NULL, 50, NULL, NULL, 197782),
(197783, '1.20.1250.20-FF-000380', NULL, 'Transmembrane protein 180', 218, NULL, NULL, 197783),
(197784, '3.90.800.10-FF-000003', NULL, 'Glutamate--tRNA ligase', 120, NULL, NULL, 197784),
(197785, '3.30.70.330-FF-002128', NULL, NULL, 104, NULL, NULL, 197785),
(197786, '1.25.40.10-FF-005220', NULL, 'Uncharacterized protein', 194, NULL, NULL, 197786),
(197787, '3.90.79.20-FF-000020', NULL, 'DNA mismatch repair protein MutT', 133, NULL, NULL, 197787),
(197788, '3.10.20.90-FF-000853', NULL, 'Microtubule-associated proteins 1A/1B light chain, putative', 79, NULL, NULL, 197788),
(197789, '1.20.5.170-FF-000270', NULL, 'Uncharacterized protein', 116, NULL, NULL, 197789),
(197790, '3.40.30.10-FF-001262', NULL, 'Predicted protein', 105, NULL, NULL, 197790),
(197791, '3.10.20.90-FF-000201', NULL, 'Ubiquitin carboxyl-terminal hydrolase 26', 95, NULL, NULL, 197791),
(197792, '3.40.50.300-FF-003810', NULL, 'Ribosome-binding ATPase YchF', 161, NULL, NULL, 197792),
(197793, '3.30.720.210-FF-000008', NULL, 'ATP-dependent zinc metalloprotease FTSH 7, chloroplastic', 99, NULL, NULL, 197793),
(197794, '3.80.10.10-FF-003939', NULL, 'Uncharacterized protein', 84, NULL, NULL, 197794),
(197795, '2.40.20.10-FF-000021', NULL, 'Tyrosine-protein kinase receptor', 90, NULL, NULL, 197795),
(197796, '3.30.160.60-FF-003624', NULL, 'Yin-yang1', 55, NULL, NULL, 197796),
(197797, '1.20.920.10-FF-000007', NULL, 'Bromodomain-containing protein 1', 135, NULL, NULL, 197797),
(197798, '2.60.120.340-FF-000012', NULL, 'Peptidylprolyl isomerase', 98, NULL, NULL, 197798),
(197799, '3.30.40.10-FF-000863', NULL, 'U-box domain-containing protein kinase family protein', 72, NULL, NULL, 197799),
(197800, '3.30.559.70-FF-000057', NULL, 'Uncharacterized protein', 99, NULL, NULL, 197800),
(197801, '3.40.390.10-FF-000162', NULL, 'AGAP011870-PA', 170, NULL, NULL, 197801),
(197802, '3.40.50.300-FF-003630', NULL, 'ATP-dependent DNA helicase', 66, NULL, NULL, 197802);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(197803, '1.20.5.960-FF-000001', NULL, 'Baseplate wedge tail fiber connector', 35, NULL, NULL, 197803),
(197804, '1.25.40.10-FF-004293', NULL, 'GH10889p', 199, NULL, NULL, 197804),
(197805, '3.30.720.200-FF-000005', NULL, 'Glycyl-tRNA synthetase', 72, NULL, NULL, 197805),
(197806, '2.40.50.140-FF-000343', NULL, 'Asparagine-tRNA ligase', 117, NULL, NULL, 197806),
(197807, '2.120.10.30-FF-000197', NULL, 'tripartite motif-containing protein 3-like', 83, NULL, NULL, 197807),
(197808, '3.40.850.10-FF-000057', NULL, 'kinesin-like protein KIN-14R', 380, NULL, NULL, 197808),
(197809, '1.20.120.230-FF-000006', NULL, 'Catenin alpha 1', 132, NULL, NULL, 197809),
(197810, '1.20.120.220-FF-000003', NULL, 'ATP synthase subunit a', 170, NULL, NULL, 197810),
(197811, '3.30.1440.10-FF-000016', NULL, 'Uncharacterized protein', 61, NULL, NULL, 197811),
(197812, '2.10.10.10-FF-000027', NULL, 'Uncharacterized protein', 33, NULL, NULL, 197812),
(197813, '1.10.357.140-FF-000020', NULL, 'Protoheme ix farnesyltransferase', 150, NULL, NULL, 197813),
(197814, '3.30.160.60-FF-002697', NULL, 'Transcription factor grauzone', 65, NULL, NULL, 197814),
(197815, '3.30.1520.10-FF-000074', NULL, 'Sorting nexin', 130, NULL, NULL, 197815),
(197816, '1.20.120.910-FF-000002', NULL, 'DksA/TraR family C4-type zinc finger protein', 68, NULL, NULL, 197816),
(197817, '3.60.15.10-FF-000247', NULL, 'Uncharacterized protein', 352, NULL, NULL, 197817),
(197818, '1.10.8.480-FF-000005', NULL, 'rRNA adenine N(6)-methyltransferase', 99, NULL, NULL, 197818),
(197819, '3.30.70.260-FF-000140', NULL, 'D-3-phosphoglycerate dehydrogenase', 74, NULL, NULL, 197819),
(197820, '2.40.50.140-FF-000719', NULL, NULL, 76, NULL, NULL, 197820),
(197821, '3.80.10.10-FF-003288', NULL, 'Toll-like receptor 2', 101, NULL, NULL, 197821),
(197822, '3.40.1170.10-FF-000021', NULL, 'MSH (MutS Homolog) family', 107, NULL, NULL, 197822),
(197823, '3.30.760.10-FF-000024', NULL, 'Eukaryotic translation initiation factor 4E,putative', 212, NULL, NULL, 197823),
(197824, '3.30.70.330-FF-002802', NULL, NULL, 148, NULL, NULL, 197824),
(197825, '1.25.10.10-FF-002576', NULL, 'Uncharacterized protein', 163, NULL, NULL, 197825),
(197826, '1.20.1250.20-FF-000470', NULL, 'Cyanate transporter family protein', 184, NULL, NULL, 197826),
(197827, '3.40.50.10090-FF-000045', NULL, 'Uroporphyrinogen decarboxylase', 141, NULL, NULL, 197827),
(197828, '2.40.50.140-FF-000961', NULL, NULL, 127, NULL, NULL, 197828),
(197829, '3.40.50.300-FF-003720', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 241, NULL, NULL, 197829),
(197830, '2.60.40.10-FF-001376', NULL, 'Protein tyrosine phosphatase, receptor type B', 86, NULL, NULL, 197830),
(197831, '1.20.5.170-FF-000118', NULL, 'Adhesin', 43, NULL, NULL, 197831),
(197832, '2.60.40.10-FF-001319', NULL, 'Thy-1 membrane glycoprotein', 110, NULL, NULL, 197832),
(197833, '2.30.30.100-FF-000099', NULL, 'Small nuclear ribonucleoprotein G', 77, NULL, NULL, 197833),
(197834, '1.10.300.10-FF-000002', NULL, 'Adenylosuccinate synthetase, chloroplastic', 99, NULL, NULL, 197834),
(197835, '1.20.1250.20-FF-000413', NULL, 'Karmoisin, isoform B', 196, NULL, NULL, 197835),
(197836, '3.30.70.270-FF-000143', NULL, NULL, 28, NULL, NULL, 197836),
(197837, '1.10.10.160-FF-000031', NULL, 'ATP-dependent DNA helicase', 108, NULL, NULL, 197837),
(197838, '2.30.30.40-FF-000672', NULL, 'Protein CBG04143', 62, NULL, NULL, 197838),
(197839, '3.40.50.720-FF-002093', NULL, 'Uncharacterized protein', 134, NULL, NULL, 197839),
(197840, '3.30.70.330-FF-001875', NULL, NULL, 100, NULL, NULL, 197840),
(197841, '3.60.21.10-FF-000104', NULL, 'Serine/threonine-protein phosphatase', 303, NULL, NULL, 197841),
(197842, '1.20.5.400-FF-000002', NULL, 'Tropomyosin 2', 62, NULL, NULL, 197842),
(197843, '1.10.10.10-FF-001322', NULL, 'Two-component response regulator', 100, NULL, NULL, 197843),
(197844, '3.30.870.10-FF-000139', NULL, 'Uncharacterized protein', 108, NULL, NULL, 197844),
(197845, '1.25.40.1040-FF-000013', NULL, 'Rna14p', 556, NULL, NULL, 197845),
(197846, '1.25.40.1030-FF-000010', NULL, 'Protein transport protein SEC31', 324, NULL, NULL, 197846);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(197847, '3.30.160.60-FF-003534', NULL, 'Zgc:174234 protein', 28, NULL, NULL, 197847),
(197848, '3.30.1640.10-FF-000077', NULL, 'DNA replication licensing factor mcm7', 115, NULL, NULL, 197848),
(197849, '1.25.40.10-FF-004079', NULL, 'Putative pentatricopeptide repeat-containing protein', 157, NULL, NULL, 197849),
(197850, '3.90.70.10-FF-000868', NULL, 'Uncharacterized protein', 74, NULL, NULL, 197850),
(197851, '3.40.50.620-FF-000348', NULL, 'Phosphoadenosine phosphosulfate reductase-like protein', 211, NULL, NULL, 197851),
(197852, '3.40.50.1910-FF-000026', NULL, 'Sec1 family transport protein, putative', 216, NULL, NULL, 197852),
(197853, '2.130.10.10-FF-001590', NULL, 'WD repeat-containing protein 68', 389, NULL, NULL, 197853),
(197854, '1.10.8.10-FF-000091', NULL, 'Cbl long isoform', 50, NULL, NULL, 197854),
(197855, '2.130.10.30-FF-000022', NULL, 'RCC2 isoform 1', 230, NULL, NULL, 197855),
(197856, '3.90.1170.40-FF-000007', NULL, 'Molybdenum cofactor biosynthesis protein MoaE', 150, NULL, NULL, 197856),
(197857, '1.20.920.20-FF-000073', NULL, 'Uncharacterized protein', 131, NULL, NULL, 197857),
(197858, '1.10.565.10-FF-000009', NULL, 'estrogen-related receptor gamma isoform X1', 226, NULL, NULL, 197858),
(197859, '3.40.50.970-FF-000195', NULL, 'Pyruvate decarboxylase 2', 141, NULL, NULL, 197859),
(197860, '3.30.160.60-FF-000488', NULL, 'Insulinoma-associated protein 2', 63, NULL, NULL, 197860),
(197861, '3.50.50.60-FF-000333', NULL, 'Glutathione reductase', 222, NULL, NULL, 197861),
(197862, '3.10.110.10-FF-000093', NULL, 'Ubiquitin conjugating enzyme (UbcF), putative', 183, NULL, NULL, 197862),
(197863, '3.30.530.20-FF-000010', NULL, 'rho GTPase-activating protein 7 isoform X1', 186, NULL, NULL, 197863),
(197864, '1.20.1270.60-FF-000022', NULL, 'Sorting nexin 3 protein', 223, NULL, NULL, 197864),
(197865, '3.40.50.300-FF-005255', NULL, 'Cytochrome c biogenesis ATP-binding export protein CcmA', 188, NULL, NULL, 197865),
(197866, '1.20.920.10-FF-000070', NULL, 'Related to transcription regulator SPT7', 134, NULL, NULL, 197866),
(197867, '1.25.40.10-FF-003623', NULL, 'Uncharacterized protein', 103, NULL, NULL, 197867),
(197868, '3.40.47.10-FF-000081', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 2', 423, NULL, NULL, 197868),
(197869, '1.20.1250.20-FF-001627', NULL, 'Myo-inositol transporter 1', 114, NULL, NULL, 197869),
(197870, '3.80.10.10-FF-004423', NULL, 'F-box family protein', 129, NULL, NULL, 197870),
(197871, '1.10.10.60-FF-001253', NULL, NULL, 70, NULL, NULL, 197871),
(197872, '2.20.25.30-FF-000011', NULL, 'Ribosomal protein L37', 51, NULL, NULL, 197872),
(197873, '3.40.50.2000-FF-000429', NULL, 'Glycosyltransferase', 243, NULL, NULL, 197873),
(197874, '2.60.40.10-FF-000100', NULL, 'Neuronal cell adhesion molecule a', 81, NULL, NULL, 197874),
(197875, '3.40.190.10-FF-000916', NULL, 'Putative bifunctional protein [include methyl-accepting chemotaxis protein and an extracellular solute-binding protein]', 92, NULL, NULL, 197875),
(197876, '2.60.40.60-FF-001110', NULL, 'Protocadherin X-linked 11', 65, NULL, NULL, 197876),
(197877, '3.80.10.10-FF-003760', NULL, 'Uncharacterized protein', 118, NULL, NULL, 197877),
(197878, '3.40.50.300-FF-004592', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 165, NULL, NULL, 197878),
(197879, '3.40.50.410-FF-000050', NULL, 'Collagen, type VI, alpha 1', 217, NULL, NULL, 197879),
(197880, '3.90.380.10-FF-000021', NULL, NULL, 186, NULL, NULL, 197880),
(197881, '1.25.10.10-FF-001446', NULL, 'Chromosome 1, whole genome shotgun sequence', 307, NULL, NULL, 197881),
(197882, '1.10.10.820-FF-000038', NULL, 'Uncharacterized protein', 60, NULL, NULL, 197882),
(197883, '3.30.160.60-FF-001056', NULL, 'Zinc finger protein 358', 28, NULL, NULL, 197883),
(197884, '2.60.40.60-FF-000379', NULL, 'CaDHerin family', 98, NULL, NULL, 197884),
(197885, '3.30.40.10-FF-000296', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 48, NULL, NULL, 197885),
(197886, '2.60.40.2030-FF-000058', NULL, 'Na/Ca-exchange protein, isoform I', 109, NULL, NULL, 197886);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(197887, '3.40.190.290-FF-000009', NULL, 'LysR family transcriptional regulator', 200, NULL, NULL, 197887),
(197888, '1.10.287.70-FF-000246', NULL, 'Inward rectifier potassium channel irk-1', 131, NULL, NULL, 197888),
(197889, '3.90.1170.30-FF-000004', NULL, 'AMP phosphorylase', 80, NULL, NULL, 197889),
(197890, '3.40.50.2300-FF-000368', NULL, 'Diguanylate cyclase', 119, NULL, NULL, 197890),
(197891, '3.10.28.10-FF-000072', NULL, 'ATP-dependent DNA helicase Hel308', 183, NULL, NULL, 197891),
(197892, '3.60.15.10-FF-000135', NULL, 'Ribonuclease Z', 244, NULL, NULL, 197892),
(197893, '3.40.50.1000-FF-000809', NULL, NULL, 215, NULL, NULL, 197893),
(197894, '2.40.50.1040-FF-000002', NULL, NULL, 239, NULL, NULL, 197894),
(197895, '2.40.128.160-FF-000001', NULL, 'Outer surface protein A', 111, NULL, NULL, 197895),
(197896, '1.10.287.70-FF-000572', NULL, 'Predicted protein', 121, NULL, NULL, 197896),
(197897, '3.40.50.2020-FF-000020', NULL, 'Bifunctional protein PyrR', 179, NULL, NULL, 197897),
(197898, '3.30.1010.10-FF-000046', NULL, 'Phosphatidylinositol 3-kinase, putative', 118, NULL, NULL, 197898),
(197899, '1.25.40.20-FF-001277', NULL, 'Uncharacterized protein', 179, NULL, NULL, 197899),
(197900, '1.10.630.10-FF-000600', NULL, 'AhbB', 533, NULL, NULL, 197900),
(197901, '1.20.1250.20-FF-000525', NULL, 'MFS drug transporter, putative', 192, NULL, NULL, 197901),
(197902, '1.20.1070.10-FF-001852', NULL, 'Uncharacterized protein', 298, NULL, NULL, 197902),
(197903, '3.40.50.300-FF-003164', NULL, 'Origin recognition complex subunit 1', 197, NULL, NULL, 197903),
(197904, '3.40.190.10-FF-000175', NULL, 'Glutamate receptor', 108, NULL, NULL, 197904),
(197905, '2.130.10.10-FF-002787', NULL, 'Coatomer subunit beta''-1', 211, NULL, NULL, 197905),
(197906, '1.10.510.10-FF-000102', NULL, 'cyclin-dependent kinase 12 isoform X1', 243, NULL, NULL, 197906),
(197907, '2.60.200.10-FF-000053', NULL, 'Uncharacterized protein', 125, NULL, NULL, 197907),
(197908, '1.25.40.10-FF-001274', NULL, 'ERAD-associated E3 ubiquitin-protein ligase component HRD3', 203, NULL, NULL, 197908),
(197909, '3.40.50.300-FF-003490', NULL, 'Predicted protein', 221, NULL, NULL, 197909),
(197910, '2.40.128.180-FF-000007', NULL, NULL, 74, NULL, NULL, 197910),
(197911, '2.20.70.10-FF-000098', NULL, 'RNA-binding protein, putative', 37, NULL, NULL, 197911),
(197912, '3.40.50.300-FF-000988', NULL, 'peroxisome biogenesis factor 6', 161, NULL, NULL, 197912),
(197913, '1.20.1720.10-FF-000008', NULL, 'Multidrug transporter MdfA', 379, NULL, NULL, 197913),
(197914, '3.30.70.330-FF-002370', NULL, NULL, 103, NULL, NULL, 197914),
(197915, '3.30.1520.10-FF-000130', NULL, 'YALI0E07601p', 120, NULL, NULL, 197915),
(197916, '2.40.50.140-FF-000287', NULL, 'Methionine-tRNA ligase, beta subunit', 167, NULL, NULL, 197916),
(197917, '3.10.330.10-FF-000036', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 109, NULL, NULL, 197917),
(197918, '3.80.10.10-FF-003855', NULL, 'PH domain and leucine rich repeat protein phosphatase 1', 74, NULL, NULL, 197918),
(197919, '3.90.226.10-FF-000192', NULL, 'Predicted protein', 126, NULL, NULL, 197919),
(197920, '3.40.1180.10-FF-000027', NULL, 'Isoprenyl transferase', 233, NULL, NULL, 197920),
(197921, '2.30.30.140-FF-000212', NULL, 'Chromatin modification-related protein EAF3', 104, NULL, NULL, 197921),
(197922, '1.10.10.60-FF-000685', NULL, 'Earthbound 2, isoform A', 52, NULL, NULL, 197922),
(197923, '2.60.120.200-FF-000616', NULL, 'Uncharacterized protein', 146, NULL, NULL, 197923),
(197924, '3.40.30.10-FF-001172', NULL, 'Glutathione s-transferase', 160, NULL, NULL, 197924),
(197925, '2.60.40.10-FF-005322', NULL, NULL, 77, NULL, NULL, 197925),
(197926, '2.60.40.60-FF-000593', NULL, 'Cadherin 1', 62, NULL, NULL, 197926),
(197927, '2.60.40.150-FF-000002', NULL, 'Protein unc-13 homolog B', 147, NULL, NULL, 197927),
(197928, '1.20.1070.10-FF-000424', NULL, 'D(3) dopamine receptor', 131, NULL, NULL, 197928),
(197929, '3.30.70.330-FF-003033', NULL, NULL, 46, NULL, NULL, 197929),
(197930, '3.30.450.20-FF-000190', NULL, 'Histidine kinase sensor protein', 150, NULL, NULL, 197930);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(197931, '3.90.180.10-FF-000073', NULL, 'Enoyl-[acyl-carrier-protein] reductase 1, mitochondrial', 179, NULL, NULL, 197931),
(197932, '1.10.510.10-FF-003233', NULL, NULL, 125, NULL, NULL, 197932),
(197933, '2.70.98.10-FF-000019', NULL, 'Aldose 1-epimerase', 335, NULL, NULL, 197933),
(197934, '3.40.50.10490-FF-000042', NULL, 'MurR/RpiR family transcriptional regulator', 173, NULL, NULL, 197934),
(197935, '1.25.40.10-FF-000931', NULL, 'Os07g0239600 protein', 126, NULL, NULL, 197935),
(197936, '3.30.260.10-FF-000110', NULL, NULL, 27, NULL, NULL, 197936),
(197937, '3.40.390.10-FF-000156', NULL, 'Endothelin-converting enzyme (AFU_orthologue AFUA_3G12420)', 312, NULL, NULL, 197937),
(197938, '1.20.1280.20-FF-000027', NULL, 'Uncharacterized protein', 66, NULL, NULL, 197938),
(197939, '1.20.58.60-FF-000047', NULL, 'Short stop, isoform N', 109, NULL, NULL, 197939),
(197940, '3.90.640.10-FF-000171', NULL, 'Hsp70 protein-domain-containing protein', 89, NULL, NULL, 197940),
(197941, '2.10.25.10-FF-000724', NULL, 'Crumbs cell polarity complex component 2b', 38, NULL, NULL, 197941),
(197942, '3.20.20.70-FF-000234', NULL, 'DUS1p Dihydrouridine synthase', 240, NULL, NULL, 197942),
(197943, '3.40.50.1820-FF-000151', NULL, 'Carboxymuconolactone decarboxylase', 209, NULL, NULL, 197943),
(197944, '1.20.1090.10-FF-000049', NULL, '3-dehydroquinate synthase', 198, NULL, NULL, 197944),
(197945, '1.10.1520.10-FF-000080', NULL, 'RNase3 domain containing protein', 162, NULL, NULL, 197945),
(197946, '3.40.50.10810-FF-000149', NULL, 'Snf2-related CREBBP activator protein', 91, NULL, NULL, 197946),
(197947, '3.20.20.80-FF-000349', NULL, 'Maltooligosyltrehalose synthase', 92, NULL, NULL, 197947),
(197948, '3.30.470.20-FF-000185', NULL, 'Uncharacterized protein', 146, NULL, NULL, 197948),
(197949, '4.10.760.10-FF-000002', NULL, 'Agouti-signaling protein', 53, NULL, NULL, 197949),
(197950, '1.10.1520.10-FF-000012', NULL, 'Ribonuclease 3', 133, NULL, NULL, 197950),
(197951, '3.10.129.10-FF-000017', NULL, 'Fatty acid synthase beta subunit dehydratase', 185, NULL, NULL, 197951),
(197952, '2.10.25.10-FF-000045', NULL, 'Slit guidance ligand 2', 39, NULL, NULL, 197952),
(197953, '2.60.40.10-FF-005097', NULL, NULL, 126, NULL, NULL, 197953),
(197954, '1.10.150.240-FF-000074', NULL, 'Putative phosphoglycolate phosphatase', 66, NULL, NULL, 197954),
(197955, '1.25.40.10-FF-000717', NULL, 'Cilia- and flagella-associated protein 70', 234, NULL, NULL, 197955),
(197956, '3.40.190.10-FF-000596', NULL, 'glutamate receptor 2-like isoform X1', 80, NULL, NULL, 197956),
(197957, '1.20.1250.20-FF-001953', NULL, 'Zgc:171489', 435, NULL, NULL, 197957),
(197958, '2.130.10.30-FF-000168', NULL, NULL, 359, NULL, NULL, 197958),
(197959, '3.40.50.620-FF-000674', NULL, 'Uncharacterized protein', 288, NULL, NULL, 197959),
(197960, '3.80.10.10-FF-003529', NULL, 'Uncharacterized protein', 167, NULL, NULL, 197960),
(197961, '3.20.20.80-FF-000237', NULL, 'Malto-oligosyltrehalose trehalohydrolase', 370, NULL, NULL, 197961),
(197962, '3.30.1370.50-FF-000034', NULL, 'Uncharacterized protein', 70, NULL, NULL, 197962),
(197963, '3.30.930.10-FF-000150', NULL, 'Proline--tRNA ligase', 277, NULL, NULL, 197963),
(197964, '3.40.350.10-FF-000098', NULL, 'Uncharacterized protein', 180, NULL, NULL, 197964),
(197965, '3.30.710.10-FF-000364', NULL, 'Uncharacterized protein', 93, NULL, NULL, 197965),
(197966, '1.20.1070.10-FF-000166', NULL, 'Bombesin receptor subtype-3', 344, NULL, NULL, 197966),
(197967, '2.130.10.110-FF-000029', NULL, 'Uncharacterized protein', 79, NULL, NULL, 197967),
(197968, '2.40.50.40-FF-000094', NULL, 'Cbx3 protein', 51, NULL, NULL, 197968),
(197969, '3.40.720.10-FF-000233', NULL, 'Predicted protein', 136, NULL, NULL, 197969),
(197970, '1.10.1870.10-FF-000010', NULL, 'Uncharacterized protein', 112, NULL, NULL, 197970),
(197971, '3.30.160.60-FF-003394', NULL, 'CG18262-like protein', 28, NULL, NULL, 197971),
(197972, '1.10.40.30-FF-000026', NULL, 'Adenylosuccinate lyase (PurB)', 56, NULL, NULL, 197972),
(197973, '1.20.1410.10-FF-000024', NULL, 'Transmembrane protein 98', 158, NULL, NULL, 197973);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(197974, '3.30.160.780-FF-000001', NULL, 'Plectin a', 114, NULL, NULL, 197974),
(197975, '3.40.50.10890-FF-000004', NULL, 'Cleavage and polyadenylation specifity factor', 212, NULL, NULL, 197975),
(197976, '3.30.50.10-FF-000061', NULL, 'GATA transcription factor 14', 51, NULL, NULL, 197976),
(197977, '3.30.420.10-FF-000033', NULL, 'Exodeoxyribonuclease I', 193, NULL, NULL, 197977),
(197978, '1.25.40.10-FF-001206', NULL, 'Pentatricopeptide repeat protein (AFU_orthologue AFUA_5G10660)', 211, NULL, NULL, 197978),
(197979, '3.100.10.10-FF-000008', NULL, '50S ribosomal protein L15', 70, NULL, NULL, 197979),
(197980, '3.40.50.300-FF-001247', NULL, 'Erythrocyte membrane-associated antigen', 293, NULL, NULL, 197980),
(197981, '3.30.70.330-FF-002095', NULL, NULL, 166, NULL, NULL, 197981),
(197982, '4.10.800.30-FF-000001', NULL, 'crossover junction endonuclease EME1 isoform X1', 103, NULL, NULL, 197982),
(197983, '2.60.120.260-FF-000527', NULL, 'Predicted protein', 21, NULL, NULL, 197983),
(197984, '3.90.660.10-FF-000115', NULL, NULL, 141, NULL, NULL, 197984),
(197985, '2.30.40.10-FF-000051', NULL, 'Adenine deaminase', 95, NULL, NULL, 197985),
(197986, '1.20.150.20-FF-000002', NULL, 'ATP synthase subunit alpha 1', 129, NULL, NULL, 197986),
(197987, '3.40.30.10-FF-001267', NULL, 'Predicted protein', 80, NULL, NULL, 197987),
(197988, '3.30.470.20-FF-000073', NULL, 'Carbamoyl-phosphate synthase, large subunit', 202, NULL, NULL, 197988),
(197989, '3.40.50.720-FF-002391', NULL, 'Putative oxidoreductase', 121, NULL, NULL, 197989),
(197990, '3.40.50.970-FF-000144', NULL, '1-deoxy-D-xylulose-5-phosphate synthase', 175, NULL, NULL, 197990),
(197991, '3.40.50.10880-FF-000001', NULL, 'Pantothenate kinase 4', 172, NULL, NULL, 197991),
(197992, '1.25.40.10-FF-002808', NULL, 'Uncharacterized protein', 118, NULL, NULL, 197992),
(197993, '2.160.20.10-FF-000038', NULL, 'F-box only protein 11', 131, NULL, NULL, 197993),
(197994, '3.40.50.2300-FF-001211', NULL, NULL, 26, NULL, NULL, 197994),
(197995, '2.170.150.10-FF-000022', NULL, 'Uncharacterized protein', 171, NULL, NULL, 197995),
(197996, '2.10.60.10-FF-000070', NULL, 'Prostate and testis expressed protein 4', 75, NULL, NULL, 197996),
(197997, '3.10.450.490-FF-000001', NULL, 'Bacillolysin', 91, NULL, NULL, 197997),
(197998, '3.30.470.20-FF-000134', NULL, 'Putative tubulin tyrosine ligase', 193, NULL, NULL, 197998),
(197999, '1.20.1250.20-FF-000267', NULL, 'AT3g60070/T2O9_50', 427, NULL, NULL, 197999),
(198000, '2.60.40.150-FF-000587', NULL, 'Phosphoinositide phospholipase C', 76, NULL, NULL, 198000),
(198001, '3.30.700.10-FF-000015', NULL, 'Geopilin domain 1 protein', 61, NULL, NULL, 198001),
(198002, '2.40.10.10-FF-000279', NULL, 'Uncharacterized protein, isoform C', 108, NULL, NULL, 198002),
(198003, '3.30.70.1050-FF-000018', NULL, 'Trigger factor', 125, NULL, NULL, 198003),
(198004, '3.30.300.30-FF-000030', NULL, 'Mutant e4 ebony', 109, NULL, NULL, 198004),
(198005, '3.90.190.10-FF-000416', NULL, 'DEP-1b', 99, NULL, NULL, 198005),
(198006, '2.40.50.140-FF-000545', NULL, '26S protease regulatory subunit 7', 107, NULL, NULL, 198006),
(198007, '3.30.200.20-FF-002228', NULL, 'Uncharacterized protein', 38, NULL, NULL, 198007),
(198008, '3.80.10.10-FF-002332', NULL, 'Predicted protein', 202, NULL, NULL, 198008),
(198009, '3.30.160.20-FF-000150', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 2', 79, NULL, NULL, 198009),
(198010, '3.40.50.2000-FF-000222', NULL, 'Alpha-1,3-mannosyltransferase ALG2', 199, NULL, NULL, 198010),
(198011, '1.20.58.60-FF-000098', NULL, 'dystonin isoform X3', 119, NULL, NULL, 198011),
(198012, '3.30.2350.10-FF-000004', NULL, 'Pseudouridine synthase', 215, NULL, NULL, 198012),
(198013, '2.60.200.20-FF-000168', NULL, 'Serine/threonine-protein kinase RAD53', 164, NULL, NULL, 198013),
(198014, '3.30.420.10-FF-000712', NULL, NULL, 92, NULL, NULL, 198014),
(198015, '1.20.5.170-FF-000062', NULL, 'Sodium/potassium-transporting ATPase subunit beta', 61, NULL, NULL, 198015),
(198016, '2.130.10.10-FF-005075', NULL, 'Uncharacterized protein', 268, NULL, NULL, 198016);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(198017, '1.20.120.1630-FF-000028', NULL, 'Protein-S-isoprenylcysteine O-methyltransferase', 199, NULL, NULL, 198017),
(198018, '2.130.10.10-FF-002899', NULL, 'Uncharacterized protein', 331, NULL, NULL, 198018),
(198019, '3.40.47.10-FF-000288', NULL, NULL, 55, NULL, NULL, 198019),
(198020, '3.30.200.20-FF-001340', NULL, 'Kinase, CMGC SRPK', 100, NULL, NULL, 198020),
(198021, '1.25.10.70-FF-000008', NULL, 'Uncharacterized protein', 257, NULL, NULL, 198021),
(198022, '1.10.287.130-FF-000152', NULL, 'Sensor histidine kinase', 78, NULL, NULL, 198022),
(198023, '3.30.70.330-FF-000099', NULL, 'insulin-like growth factor 2 mRNA-binding protein 3 isoform X1', 74, NULL, NULL, 198023),
(198024, '3.90.1150.10-FF-000469', NULL, 'Aminotransferase, DegT/DnrJ/EryC1/StrS family', 121, NULL, NULL, 198024),
(198025, '2.60.120.260-FF-000578', NULL, 'Uncharacterized protein', 282, NULL, NULL, 198025),
(198026, '2.40.50.90-FF-000176', NULL, 'Qin', 109, NULL, NULL, 198026),
(198027, '3.30.70.1450-FF-000048', NULL, 'SLC13 family permease', 72, NULL, NULL, 198027),
(198028, '3.30.710.10-FF-000459', NULL, 'Uncharacterized protein', 126, NULL, NULL, 198028),
(198029, '3.40.50.300-FF-007284', NULL, 'Uncharacterized protein', 154, NULL, NULL, 198029),
(198030, '3.90.1150.160-FF-000002', NULL, 'Glutamate decarboxylase', 104, NULL, NULL, 198030),
(198031, '3.20.110.10-FF-000034', NULL, 'Alpha-mannosidase 2c1, putative', 63, NULL, NULL, 198031),
(198032, '3.20.20.80-FF-000142', NULL, 'Alpha-xylosidase A', 373, NULL, NULL, 198032),
(198033, '3.40.630.10-FF-000485', NULL, 'Glutaminylpeptide cyclotransferase, putative', 95, NULL, NULL, 198033),
(198034, '2.130.10.30-FF-000117', NULL, NULL, 222, NULL, NULL, 198034),
(198035, '3.30.160.60-FF-001005', NULL, 'Zinc finger protein 75A', 28, NULL, NULL, 198035),
(198036, '1.10.8.60-FF-000105', NULL, 'PeRoXisome assembly factor', 80, NULL, NULL, 198036),
(198037, '1.25.40.10-FF-002960', NULL, 'Putative pentatricopeptide repeat family protein', 127, NULL, NULL, 198037),
(198038, '1.10.268.20-FF-000007', NULL, NULL, 36, NULL, NULL, 198038),
(198039, '1.50.10.20-FF-000008', NULL, 'Complement C3', 307, NULL, NULL, 198039),
(198040, '1.50.10.10-FF-000005', NULL, 'Glycosyl hydrolase, glucoamylase', 371, NULL, NULL, 198040),
(198041, '3.40.50.300-FF-001152', NULL, 'tRNA-splicing endonuclease, putative', 389, NULL, NULL, 198041),
(198042, '1.10.760.10-FF-000087', NULL, 'Hydrazine synthase subunit B', 156, NULL, NULL, 198042),
(198043, '2.30.42.10-FF-000084', NULL, 'Tyrosine-protein phosphatase non-receptor type 13', 119, NULL, NULL, 198043),
(198044, '3.40.50.620-FF-000174', NULL, 'ATPase, PP-loop superfamily', 309, NULL, NULL, 198044),
(198045, '3.40.50.720-FF-000827', NULL, 'Glycerate dehydrogenase', 107, NULL, NULL, 198045),
(198046, '2.60.120.590-FF-000042', NULL, 'ALKylated DNA repair protein AlkB homolog', 210, NULL, NULL, 198046),
(198047, '3.40.390.10-FF-000218', NULL, NULL, 179, NULL, NULL, 198047),
(198048, '2.30.29.30-FF-000373', NULL, 'Protein still life, isoform SIF type', 117, NULL, NULL, 198048),
(198049, '3.60.110.10-FF-000008', NULL, 'Beta-alanine synthase', 385, NULL, NULL, 198049),
(198050, '1.20.272.40-FF-000004', NULL, 'ATP-dependent RNA helicase SUV3', 63, NULL, NULL, 198050),
(198051, '3.30.160.60-FF-002320', NULL, 'ras-responsive element-binding protein 1 isoform X1', 28, NULL, NULL, 198051),
(198052, '3.40.50.410-FF-000206', NULL, 'DNA binding protein', 216, NULL, NULL, 198052),
(198053, '3.40.50.720-FF-000086', NULL, 'Quinate/shikimate dehydrogenase', 143, NULL, NULL, 198053),
(198054, '3.30.40.10-FF-000184', NULL, 'Baculoviral IAP repeat containing 2', 66, NULL, NULL, 198054),
(198055, '1.10.630.10-FF-000521', NULL, '5-methyl-1-naphthoate 3-hydroxylase', 398, NULL, NULL, 198055),
(198056, '1.10.10.720-FF-000008', NULL, 'Leucine--tRNA ligase', 66, NULL, NULL, 198056),
(198057, '3.40.50.620-FF-000236', NULL, 'Valine-tRNA ligase', 241, NULL, NULL, 198057),
(198058, '3.30.1520.10-FF-000079', NULL, 'PX domain protein (AFU_orthologue AFUA_3G08020)', 125, NULL, NULL, 198058);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(198059, '3.80.10.10-FF-001489', NULL, 'GD12868', 140, NULL, NULL, 198059),
(198060, '1.10.260.40-FF-000041', NULL, 'Asc operon transcriptional repressor', 58, NULL, NULL, 198060),
(198061, '3.40.50.300-FF-004799', NULL, 'YALI0F20724p', 195, NULL, NULL, 198061),
(198062, '2.40.30.270-FF-000018', NULL, 'AaceriACL098Cp', 107, NULL, NULL, 198062),
(198063, '1.20.1270.60-FF-000134', NULL, 'Glucosamine 6-phosphate N-acetyltransferase, putative', 181, NULL, NULL, 198063),
(198064, '1.20.910.10-FF-000030', NULL, 'Heme oxygenase', 230, NULL, NULL, 198064),
(198065, '3.40.50.300-FF-005367', NULL, 'DNA helicase', 144, NULL, NULL, 198065),
(198066, '3.40.50.300-FF-005081', NULL, 'Uncharacterized protein', 82, NULL, NULL, 198066),
(198067, '1.20.142.10-FF-000019', NULL, 'Poly [ADP-ribose] polymerase', 143, NULL, NULL, 198067),
(198068, '3.40.50.720-FF-000148', NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', 207, NULL, NULL, 198068),
(198069, '1.25.40.10-FF-004972', NULL, 'Pentatricopeptide repeat-containing protein At1g71420', 152, NULL, NULL, 198069),
(198070, '1.20.920.10-FF-000182', NULL, 'Bromodomain-containing protein', 130, NULL, NULL, 198070),
(198071, '2.160.10.10-FF-000099', NULL, 'Uncharacterized protein', 38, NULL, NULL, 198071),
(198072, '1.25.40.10-FF-003511', NULL, 'stress-induced-phosphoprotein 1-like isoform X2', 134, NULL, NULL, 198072),
(198073, '3.40.50.1460-FF-000104', NULL, 'Uncharacterized protein', 144, NULL, NULL, 198073),
(198074, '1.20.58.60-FF-000373', NULL, 'Spectrin beta chain', 102, NULL, NULL, 198074),
(198075, '2.10.90.10-FF-000004', NULL, 'Transforming growth factor beta', 111, NULL, NULL, 198075),
(198076, '2.10.25.10-FF-001747', NULL, 'Laminin, alpha 4', 56, NULL, NULL, 198076),
(198077, '3.30.70.330-FF-000745', NULL, 'Polyadenylate-binding protein', 84, NULL, NULL, 198077),
(198078, '2.30.29.30-FF-000452', NULL, 'Rho GTPase activator (Bem3)', 127, NULL, NULL, 198078),
(198079, '3.30.160.60-FF-005546', NULL, NULL, 34, NULL, NULL, 198079),
(198080, '3.40.30.10-FF-000778', NULL, 'Uncharacterized protein', 143, NULL, NULL, 198080),
(198081, '1.20.140.10-FF-000122', NULL, 'Uncharacterized protein', 126, NULL, NULL, 198081),
(198082, '3.30.420.10-FF-000471', NULL, NULL, 197, NULL, NULL, 198082),
(198083, '3.90.1260.10-FF-000005', NULL, 'Argininosuccinate synthase 1', 192, NULL, NULL, 198083),
(198084, '2.60.120.740-FF-000008', NULL, 'Polycystic kidney disease 1-like 2a', 100, NULL, NULL, 198084),
(198085, '2.30.40.10-FF-000129', NULL, '5-methylthioadenosine/S-adenosylhomocysteine deaminase', 80, NULL, NULL, 198085),
(198086, '2.40.50.140-FF-000219', NULL, 'Ribonuclease R', 71, NULL, NULL, 198086),
(198087, '1.10.472.10-FF-000373', NULL, 'Uncharacterized protein', 66, NULL, NULL, 198087),
(198088, '3.40.50.720-FF-000378', NULL, 'Phosphoglycerate dehydrogenase, putative; 33424-31403', 73, NULL, NULL, 198088),
(198089, '3.40.50.300-FF-001770', NULL, 'Nodulation protein H', 232, NULL, NULL, 198089),
(198090, '1.10.10.10-FF-000709', NULL, 'ArsR family transcriptional regulator', 97, NULL, NULL, 198090),
(198091, '3.40.50.300-FF-002675', NULL, 'ATP-dependent RNA helicase, putative', 213, NULL, NULL, 198091),
(198092, '3.40.50.2300-FF-000194', NULL, 'Two-component system KDP operon response regulator KdpE', 126, NULL, NULL, 198092),
(198093, '1.20.1250.20-FF-002116', NULL, 'Solute carrier organic anion transporter family member', 221, NULL, NULL, 198093),
(198094, '3.40.50.300-FF-005316', NULL, 'Septin', 283, NULL, NULL, 198094),
(198095, '1.50.40.10-FF-000125', NULL, 'YMR166C-like protein', 182, NULL, NULL, 198095),
(198096, '2.30.42.10-FF-000179', NULL, 'Uncharacterized protein, isoform G', 63, NULL, NULL, 198096),
(198097, '3.40.50.11260-FF-000014', NULL, '90 kDa heat shock protein putative', 88, NULL, NULL, 198097),
(198098, '3.30.70.1990-FF-000007', NULL, NULL, 101, NULL, NULL, 198098),
(198099, '1.20.5.190-FF-000068', NULL, 'Tubulin glycylase 3E', 47, NULL, NULL, 198099),
(198100, '2.30.42.10-FF-000533', NULL, NULL, 109, NULL, NULL, 198100),
(198101, '3.40.720.10-FF-000019', NULL, 'Phosphoethanolamine transferase ybiP', 300, NULL, NULL, 198101);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(198102, '1.10.150.110-FF-000001', NULL, 'Putative Crossover junction endonuclease MUS81', 73, NULL, NULL, 198102),
(198103, '3.90.1150.10-FF-000520', NULL, 'Kynureninase', 66, NULL, NULL, 198103),
(198104, '3.40.50.1950-FF-000010', NULL, 'Coenzyme A biosynthesis protein 3', 213, NULL, NULL, 198104),
(198105, '3.30.160.60-FF-005097', NULL, NULL, 71, NULL, NULL, 198105),
(198106, '1.20.1560.10-FF-000074', NULL, 'ABC transporter ATP-binding protein', 327, NULL, NULL, 198106),
(198107, '1.10.1760.20-FF-000010', NULL, 'Thiamine precursor transporter HmpT', 155, NULL, NULL, 198107),
(198108, '3.40.50.1820-FF-001140', NULL, 'Lipase', 186, NULL, NULL, 198108),
(198109, '3.30.2140.20-FF-000002', NULL, 'Arylamine N-acetyltransferase', 262, NULL, NULL, 198109),
(198110, '2.30.29.30-FF-000098', NULL, 'Fact complex subunit ssrp1', 110, NULL, NULL, 198110),
(198111, '3.40.50.11660-FF-000044', NULL, NULL, 126, NULL, NULL, 198111),
(198112, '3.80.10.10-FF-002220', NULL, 'Predicted protein', 180, NULL, NULL, 198112),
(198113, '3.30.160.60-FF-001623', NULL, 'Zinc finger protein 169', 27, NULL, NULL, 198113),
(198114, '1.10.555.10-FF-000003', NULL, 'Putative rho GTPase-activating protein 12', 213, NULL, NULL, 198114),
(198115, '3.90.660.10-FF-000054', NULL, NULL, 88, NULL, NULL, 198115),
(198116, '3.30.70.330-FF-000453', NULL, 'Protein MEI2-like 1', 89, NULL, NULL, 198116),
(198117, '3.30.420.10-FF-000145', NULL, 'Endogenous retrovirus group K member 18 Pol protein', 160, NULL, NULL, 198117),
(198118, '1.25.40.20-FF-001209', NULL, 'Uncharacterized protein', 193, NULL, NULL, 198118),
(198119, '1.25.10.10-FF-002806', NULL, 'Uncharacterized protein', 201, NULL, NULL, 198119),
(198120, '1.10.510.10-FF-001608', NULL, 'Uncharacterized protein', 182, NULL, NULL, 198120),
(198121, '3.10.620.30-FF-000002', NULL, 'kyphoscoliosis peptidase', 164, NULL, NULL, 198121),
(198122, '3.90.580.10-FF-000002', NULL, 'Mitochondrial helicase twinkle', 79, NULL, NULL, 198122),
(198123, '3.30.70.2850-FF-000018', NULL, 'Putative rna polymerase iii large subunit', 223, NULL, NULL, 198123),
(198124, '3.40.50.150-FF-001067', NULL, 'Uncharacterized protein', 243, NULL, NULL, 198124),
(198125, '3.10.100.10-FF-000148', NULL, 'Lymphocyte antigen 75', 134, NULL, NULL, 198125),
(198126, '3.40.50.300-FF-003338', NULL, 'Ras family protein', 170, NULL, NULL, 198126),
(198127, '2.60.120.620-FF-000040', NULL, 'Phytanoyl-CoA dioxygenase, putative', 253, NULL, NULL, 198127),
(198128, '3.10.50.40-FF-000042', NULL, 'Foldase protein PrsA', 138, NULL, NULL, 198128),
(198129, '1.20.120.1080-FF-000144', NULL, 'Predicted protein', 90, NULL, NULL, 198129),
(198130, '1.25.40.990-FF-000068', NULL, 'Uncharacterized protein', 113, NULL, NULL, 198130),
(198131, '3.40.50.740-FF-000013', NULL, 'NADH-ubiquinone oxidoreductase 78 kDa subunit, mitochondrial', 139, NULL, NULL, 198131),
(198132, '3.30.56.10-FF-000023', NULL, 'Phenylalanyl-tRNA synthetase, beta subunit', 77, NULL, NULL, 198132),
(198133, '1.20.1070.10-FF-000492', NULL, 'Protein CBR-MOM-5', 374, NULL, NULL, 198133),
(198134, '2.10.109.10-FF-000054', NULL, 'Signal peptidase I', 96, NULL, NULL, 198134),
(198135, '1.10.10.1100-FF-000010', NULL, 'Glycerol-3-phosphate dehydrogenase, putative', 75, NULL, NULL, 198135),
(198136, '2.60.120.650-FF-000049', NULL, 'JmjC domain protein, putative', 309, NULL, NULL, 198136),
(198137, '2.60.60.20-FF-000020', NULL, 'Lipid-associated family protein', 121, NULL, NULL, 198137),
(198138, '2.30.30.100-FF-000133', NULL, 'Small nuclear ribonucleoprotein F', 86, NULL, NULL, 198138),
(198139, '1.10.10.2480-FF-000002', NULL, 'Translation initiation factor IF-2', 71, NULL, NULL, 198139),
(198140, '2.70.170.10-FF-000289', NULL, 'Uncharacterized protein', 210, NULL, NULL, 198140),
(198141, '3.30.160.60-FF-004754', NULL, NULL, 51, NULL, NULL, 198141),
(198142, '2.115.10.10-FF-000001', NULL, 'Repeat domain-containing protein', 153, NULL, NULL, 198142),
(198143, '3.40.50.2000-FF-000508', NULL, 'Glycosyltransferase', 248, NULL, NULL, 198143),
(198144, '1.10.150.120-FF-000004', NULL, 'Selenate reductase subunit YgfN', 112, NULL, NULL, 198144); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(198145, '2.120.10.30-FF-000337', NULL, 'Peptidase S9 family protein', 160, NULL, NULL, 198145),
(198146, '3.40.630.30-FF-000350', NULL, 'Predicted protein', 51, NULL, NULL, 198146),
(198147, '3.30.160.60-FF-003422', NULL, 'Transcription factor IIIA', 25, NULL, NULL, 198147),
(198148, '2.30.29.30-FF-000047', NULL, 'vasodilator-stimulated phosphoprotein isoform X2', 116, NULL, NULL, 198148),
(198149, '1.25.40.180-FF-000331', NULL, NULL, 191, NULL, NULL, 198149),
(198150, '1.10.437.10-FF-000010', NULL, 'BH3-interacting domain death agonist', 196, NULL, NULL, 198150),
(198151, '3.20.20.20-FF-000034', NULL, 'Dihydropteroate synthase', 280, NULL, NULL, 198151),
(198152, '1.25.40.10-FF-003123', NULL, 'Developmental protein', 138, NULL, NULL, 198152),
(198153, '3.20.20.10-FF-000031', NULL, 'Ornithine decarboxylase', 232, NULL, NULL, 198153),
(198154, '3.90.640.10-FF-000120', NULL, 'Heat shock protein 70, putative', 80, NULL, NULL, 198154),
(198155, '1.20.1540.10-FF-000062', NULL, 'GlpG peptidase', 192, NULL, NULL, 198155),
(198156, '3.30.70.330-FF-000178', NULL, 'Histone-lysine N-methyltransferase', 110, NULL, NULL, 198156),
(198157, '4.10.1000.10-FF-000021', NULL, 'Zinc finger CCCH domain-containing protein 17', 64, NULL, NULL, 198157),
(198158, '2.130.10.10-FF-003158', NULL, 'AGAP006092-PA', 316, NULL, NULL, 198158),
(198159, '1.25.40.10-FF-005309', NULL, 'Clathrin heavy chain 2', 125, NULL, NULL, 198159),
(198160, '3.40.50.1820-FF-000325', NULL, 'Haloalkane dehalogenase', 299, NULL, NULL, 198160),
(198161, '3.10.450.700-FF-000014', NULL, 'Predicted protein', 41, NULL, NULL, 198161),
(198162, '1.20.120.670-FF-000003', NULL, 'Alpha-N-acetylglucosaminidase', 283, NULL, NULL, 198162),
(198163, '2.130.10.10-FF-000696', NULL, 'Type II inositol polyphosphate 5-phosphatase 15', 244, NULL, NULL, 198163),
(198164, '3.90.70.10-FF-000790', NULL, 'Uncharacterized protein', 330, NULL, NULL, 198164),
(198165, '3.90.660.10-FF-000003', NULL, 'spermine oxidase isoform X2', 115, NULL, NULL, 198165),
(198166, '3.60.10.10-FF-000085', NULL, 'Inositol-phosphate phosphatase', 312, NULL, NULL, 198166),
(198167, '3.20.20.30-FF-000037', NULL, '4-(gamma-L-glutamylamino)butanoyl-[BtrI acyl-carrier protein] monooxygenase BtrO', 318, NULL, NULL, 198167),
(198168, '2.60.40.10-FF-005501', NULL, NULL, 93, NULL, NULL, 198168),
(198169, '2.60.120.10-FF-000052', NULL, 'Rap guanine nucleotide exchange factor 4', 155, NULL, NULL, 198169),
(198170, '3.30.160.60-FF-000988', NULL, 'tripartite motif-containing protein 44', 76, NULL, NULL, 198170),
(198171, '3.30.2310.10-FF-000007', NULL, 'tRNA-thr(GGU) m(6)t(6)A37 methyltransferase', 106, NULL, NULL, 198171),
(198172, '2.20.100.10-FF-000256', NULL, 'Uncharacterized protein', 31, NULL, NULL, 198172),
(198173, '1.20.1460.10-FF-000010', NULL, 'V-type proton ATPase subunit C', 183, NULL, NULL, 198173),
(198174, '3.40.50.620-FF-000562', NULL, 'YALI0E17919p', 338, NULL, NULL, 198174),
(198175, '1.10.10.1760-FF-000005', NULL, '60S ribosomal protein L36 putative', 98, NULL, NULL, 198175),
(198176, '3.90.660.20-FF-000006', NULL, 'Protoporphyrinogen oxidase', 62, NULL, NULL, 198176),
(198177, '1.25.40.770-FF-000002', NULL, 'TAF6-like RNA polymerase II p300/CBP-associated factor-associated factor 65 kDa subunit 6L', 199, NULL, NULL, 198177),
(198178, '1.10.730.10-FF-000198', NULL, 'Arginine--tRNA ligase', 135, NULL, NULL, 198178),
(198179, '2.130.10.10-FF-001264', NULL, 'Striatin, calmodulin-binding protein 4', 56, NULL, NULL, 198179),
(198180, '2.60.120.200-FF-000263', NULL, 'Cadherin-related tumor suppressor', 160, NULL, NULL, 198180),
(198181, '2.30.110.10-FF-000030', NULL, 'Possible oxidoreductase', 162, NULL, NULL, 198181),
(198182, '3.40.190.10-FF-000793', NULL, 'Peptide ABC transporter substrate-binding protein', 115, NULL, NULL, 198182),
(198183, '1.10.4160.10-FF-000024', NULL, 'Purine-cytosine permease FCY21', 449, NULL, NULL, 198183),
(198184, '3.30.300.130-FF-000047', NULL, NULL, 74, NULL, NULL, 198184),
(198185, '2.170.260.40-FF-000005', NULL, '5''-3'' exoribonuclease 1', 160, NULL, NULL, 198185);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(198186, '1.25.40.420-FF-000032', NULL, 'LP10161p', 75, NULL, NULL, 198186),
(198187, '3.30.70.270-FF-000171', NULL, NULL, 164, NULL, NULL, 198187),
(198188, '2.170.300.10-FF-000017', NULL, 'Multiple epidermal growth factor-like domains protein 11', 128, NULL, NULL, 198188),
(198189, '1.20.940.10-FF-000014', NULL, 'Protein transport protein SEC31', 107, NULL, NULL, 198189),
(198190, '1.10.10.60-FF-000359', NULL, 'Tigger transposable element derived 6', 51, NULL, NULL, 198190),
(198191, '2.70.170.10-FF-000238', NULL, 'Uncharacterized protein', 61, NULL, NULL, 198191),
(198192, '3.65.10.20-FF-000021', NULL, 'Uncharacterized protein', 222, NULL, NULL, 198192),
(198193, '1.25.40.10-FF-002634', NULL, 'DNA/RNA-binding protein, putative', 94, NULL, NULL, 198193),
(198194, '3.40.50.1820-FF-001786', NULL, 'Predicted protein', 170, NULL, NULL, 198194),
(198195, '1.10.220.30-FF-000041', NULL, 'Flagellar motor switch protein FliG', 106, NULL, NULL, 198195),
(198196, '3.30.160.60-FF-003629', NULL, 'GG11973', 29, NULL, NULL, 198196),
(198197, '3.40.50.720-FF-000474', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', 162, NULL, NULL, 198197),
(198198, '3.80.10.10-FF-002506', NULL, 'Uncharacterized protein', 101, NULL, NULL, 198198),
(198199, '3.30.70.330-FF-000127', NULL, 'RNA-binding protein EWS isoform 1', 85, NULL, NULL, 198199),
(198200, '3.30.70.250-FF-000013', NULL, 'Malonyl CoA-acyl carrier protein transacylase, mitochondrial', 74, NULL, NULL, 198200),
(198201, '3.90.70.40-FF-000006', NULL, 'ataxin-3 isoform X5', 43, NULL, NULL, 198201),
(198202, '3.30.420.40-FF-000429', NULL, 'N-acetyl-D-glucosamine kinase', 198, NULL, NULL, 198202),
(198203, '1.25.40.10-FF-000482', NULL, 'CesD/SycD/LcrH family type III secretion system chaperone', 147, NULL, NULL, 198203),
(198204, '3.40.50.300-FF-001444', NULL, 'ABC transporter ATP-binding protein', 234, NULL, NULL, 198204),
(198205, '3.40.50.2000-FF-000660', NULL, 'UDP-glycosyltransferase 89C1', 233, NULL, NULL, 198205),
(198206, '3.40.50.1010-FF-000060', NULL, 'DNA repair protein RAD2', 192, NULL, NULL, 198206),
(198207, '3.90.1280.10-FF-000001', NULL, '33 kDa chaperonin', 60, NULL, NULL, 198207),
(198208, '3.30.70.260-FF-000016', NULL, 'Aspartokinase', 76, NULL, NULL, 198208),
(198209, '3.30.160.60-FF-001443', NULL, 'Zinc finger protein 668', 28, NULL, NULL, 198209),
(198210, '3.30.200.20-FF-002296', NULL, NULL, 23, NULL, NULL, 198210),
(198211, '3.30.70.240-FF-000010', NULL, 'Elongation factor 2', 111, NULL, NULL, 198211),
(198212, '3.90.70.30-FF-000003', NULL, 'Uncharacterized protein', 138, NULL, NULL, 198212),
(198213, '2.60.40.150-FF-000295', NULL, 'Phosphatidylserine decarboxylase proenzyme 2', 128, NULL, NULL, 198213),
(198214, '3.30.2230.10-FF-000006', NULL, 'Ubiquitin carboxyl-terminal hydrolase 26', 126, NULL, NULL, 198214),
(198215, '3.40.250.10-FF-000146', NULL, 'Putative 3-mercaptopyruvate sulfurtransferase', 119, NULL, NULL, 198215),
(198216, '3.30.70.330-FF-001021', NULL, 'Novel protein similar to human heterogeneous nuclear ribonucleoprotein C (C1/C2) (HNRPC)', 80, NULL, NULL, 198216),
(198217, '2.60.120.260-FF-000606', NULL, 'Glr0080 protein', 143, NULL, NULL, 198217),
(198218, '3.30.450.20-FF-000543', NULL, 'Hybrid signal transduction histidine kinase E', 119, NULL, NULL, 198218),
(198219, '3.30.70.270-FF-000019', NULL, 'DNA repair protein REV1', 106, NULL, NULL, 198219),
(198220, '1.25.10.10-FF-000980', NULL, 'Hypothetical_protein_-_conserved', 247, NULL, NULL, 198220),
(198221, '2.60.120.290-FF-000121', NULL, 'Cubilin homolog', 123, NULL, NULL, 198221),
(198222, '1.10.1200.10-FF-000033', NULL, 'Ss-alanyl conjugating enzyme', 82, NULL, NULL, 198222),
(198223, '2.40.10.190-FF-000001', NULL, '60S ribosomal protein L35a', 108, NULL, NULL, 198223),
(198224, '3.30.1360.10-FF-000044', NULL, 'Uncharacterized protein', 141, NULL, NULL, 198224),
(198225, '1.20.58.60-FF-000547', NULL, 'Predicted protein', 110, NULL, NULL, 198225),
(198226, '1.10.150.20-FF-000173', NULL, 'DNA transformation protein TfoX1', 82, NULL, NULL, 198226),
(198227, '1.20.920.10-FF-000131', NULL, 'MBD9', 121, NULL, NULL, 198227);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(198228, '3.30.420.10-FF-000420', NULL, NULL, 156, NULL, NULL, 198228),
(198229, '1.20.5.170-FF-000236', NULL, 'AP-1-like transcription factor YAP7', 67, NULL, NULL, 198229),
(198230, '2.10.25.10-FF-001798', NULL, 'Uncharacterized protein', 27, NULL, NULL, 198230),
(198231, '3.90.1150.10-FF-000295', NULL, 'Glycine cleavage system P protein', 37, NULL, NULL, 198231),
(198232, '3.20.20.100-FF-000174', NULL, 'Oxidoreductase, aldo/keto reductase family protein', 167, NULL, NULL, 198232),
(198233, '1.20.1070.10-FF-001498', NULL, 'Uncharacterized protein', 199, NULL, NULL, 198233),
(198234, '2.130.10.10-FF-004518', NULL, 'Uncharacterized protein', 232, NULL, NULL, 198234),
(198235, '3.80.10.10-FF-003967', NULL, 'Uncharacterized protein', 132, NULL, NULL, 198235),
(198236, '1.10.10.1800-FF-000006', NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG 1', 99, NULL, NULL, 198236),
(198237, '3.40.50.10190-FF-000300', NULL, 'Replication factor C subunit 1', 107, NULL, NULL, 198237),
(198238, '1.10.1820.10-FF-000024', NULL, 'Casein kinase II subunit beta', 117, NULL, NULL, 198238),
(198239, '2.40.40.20-FF-000025', NULL, 'N-ethylmaleimide-sensitive fusion protein', 83, NULL, NULL, 198239),
(198240, '1.20.5.700-FF-000002', NULL, 'Cytochrome b6-f complex iron-sulfur subunit', 44, NULL, NULL, 198240),
(198241, '3.40.50.720-FF-002065', NULL, 'Uncharacterized protein', 157, NULL, NULL, 198241),
(198242, '2.60.40.60-FF-000997', NULL, 'Uncharacterized protein', 56, NULL, NULL, 198242),
(198243, '3.40.50.300-FF-008189', NULL, 'Uncharacterized protein', 78, NULL, NULL, 198243),
(198244, '3.40.390.10-FF-000044', NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif, 13', 208, NULL, NULL, 198244),
(198245, '3.30.710.10-FF-000167', NULL, 'Transcription factor Ken', 160, NULL, NULL, 198245),
(198246, '3.60.40.10-FF-000148', NULL, 'Protein phosphatase 2C-2', 282, NULL, NULL, 198246),
(198247, '2.40.30.10-FF-000488', NULL, 'Uncharacterized protein', 36, NULL, NULL, 198247),
(198248, '3.30.160.60-FF-003068', NULL, 'GM23957', 29, NULL, NULL, 198248),
(198249, '3.60.15.10-FF-000186', NULL, 'Uncharacterized protein', 201, NULL, NULL, 198249),
(198250, '1.25.40.20-FF-001535', NULL, 'Ankyrin repeat domain 31', 135, NULL, NULL, 198250),
(198251, '2.10.25.10-FF-000612', NULL, 'Crumbs 2, cell polarity complex component', 39, NULL, NULL, 198251),
(198252, '3.40.50.620-FF-000062', NULL, 'Arginine--tRNA ligase', 309, NULL, NULL, 198252),
(198253, '3.30.1520.10-FF-000197', NULL, 'Uncharacterized protein', 155, NULL, NULL, 198253),
(198254, '3.30.420.40-FF-000598', NULL, 'WGS project CABT00000000 data, contig 2.85', 158, NULL, NULL, 198254),
(198255, '1.25.10.10-FF-001154', NULL, 'Related to nuclear protein SA-1', 303, NULL, NULL, 198255),
(198256, '1.10.287.130-FF-000091', NULL, 'Autoinducer 2 sensor kinase/phosphatase LuxQ', 75, NULL, NULL, 198256),
(198257, '3.50.50.60-FF-001125', NULL, 'Uncharacterized protein', 128, NULL, NULL, 198257),
(198258, '3.30.710.10-FF-000460', NULL, 'Uncharacterized protein', 125, NULL, NULL, 198258),
(198259, '3.30.780.10-FF-000020', NULL, '60S ribosomal protein IMG2, mitochondrial', 106, NULL, NULL, 198259),
(198260, '3.40.50.300-FF-002787', NULL, 'DNA helicase', 192, NULL, NULL, 198260),
(198261, '3.30.740.10-FF-000012', NULL, 'Dynein light chain', 99, NULL, NULL, 198261),
(198262, '2.40.128.20-FF-000032', NULL, 'Outer membrane lipoprotein Blc', 169, NULL, NULL, 198262),
(198263, '3.30.200.20-FF-000379', NULL, 'eIF-2-alpha kinase GCN2', 110, NULL, NULL, 198263),
(198264, '1.20.1440.130-FF-000005', NULL, 'Vitamin K epoxide reductase family, putative', 154, NULL, NULL, 198264),
(198265, '3.30.70.2890-FF-000002', NULL, 'XS domain-containing protein / XS zinc finger domain-containing protein-like protein', 177, NULL, NULL, 198265),
(198266, '3.90.180.10-FF-000039', NULL, 'Ast1p', 27, NULL, NULL, 198266),
(198267, '3.10.110.10-FF-000379', NULL, 'Uncharacterized protein', 59, NULL, NULL, 198267),
(198268, '3.90.70.10-FF-000576', NULL, 'Predicted protein', 345, NULL, NULL, 198268);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(198269, '3.10.20.230-FF-000024', NULL, 'Predicted protein', 86, NULL, NULL, 198269),
(198270, '3.40.50.1820-FF-000701', NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', 377, NULL, NULL, 198270),
(198271, '1.10.441.10-FF-000003', NULL, 'Mannose-6-phosphate isomerase', 121, NULL, NULL, 198271),
(198272, '2.40.50.90-FF-000204', NULL, 'Uncharacterized protein', 113, NULL, NULL, 198272),
(198273, '3.30.450.60-FF-000061', NULL, 'Uncharacterized protein', 136, NULL, NULL, 198273),
(198274, '3.80.10.10-FF-004131', NULL, 'Leucine-rich repeat family protein /protein kinase family protein-like', 111, NULL, NULL, 198274),
(198275, '1.20.5.710-FF-000005', NULL, '50S ribosomal protein L7/L12', 53, NULL, NULL, 198275),
(198276, '1.20.140.10-FF-000004', NULL, 'Acyl-CoA dehydrogenase FadE25', 146, NULL, NULL, 198276),
(198277, '3.60.21.10-FF-000110', NULL, 'Unplaced genomic scaffold supercont2.9, whole genome shotgun sequence', 196, NULL, NULL, 198277),
(198278, '2.130.10.10-FF-004586', NULL, 'Uncharacterized protein', 207, NULL, NULL, 198278),
(198279, '2.30.39.10-FF-000160', NULL, 'Serpin, putative', 94, NULL, NULL, 198279),
(198280, '1.50.40.10-FF-000013', NULL, 'Mitochondrial 2-oxoglutarate/malate carrier protein-like protein', 291, NULL, NULL, 198280),
(198281, '1.25.10.10-FF-002778', NULL, 'Serine/threonine-protein kinase RUNKEL', 601, NULL, NULL, 198281),
(198282, '3.30.160.60-FF-001831', NULL, 'Zinc finger protein Gfi-1b', 27, NULL, NULL, 198282),
(198283, '1.10.510.10-FF-002862', NULL, NULL, 230, NULL, NULL, 198283),
(198284, '3.30.160.60-FF-002966', NULL, 'LD24322p', 80, NULL, NULL, 198284),
(198285, '3.60.20.10-FF-000265', NULL, NULL, 265, NULL, NULL, 198285),
(198286, '3.40.570.10-FF-000024', NULL, 'Testis EndoG-Like 3', 132, NULL, NULL, 198286),
(198287, '3.20.20.140-FF-000124', NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', 318, NULL, NULL, 198287),
(198288, '3.40.50.2000-FF-000194', NULL, 'UDP glucuronosyltransferase 2 family polypeptide a4 short isoform', 187, NULL, NULL, 198288),
(198289, '3.40.190.10-FF-000624', NULL, 'Putative chorismate mutase/prephenate dehydratase', 85, NULL, NULL, 198289),
(198290, '1.20.140.20-FF-000007', NULL, 'Pyruvate dehydrogenase (Lipoamide) kinase, putative', 176, NULL, NULL, 198290),
(198291, '1.10.1200.10-FF-000151', NULL, 'Polyketide synthase', 80, NULL, NULL, 198291),
(198292, '3.50.7.10-FF-000068', NULL, NULL, 161, NULL, NULL, 198292),
(198293, '2.60.40.10-FF-001382', NULL, 'titin isoform X1', 95, NULL, NULL, 198293),
(198294, '3.40.50.150-FF-001360', NULL, NULL, 186, NULL, NULL, 198294),
(198295, '1.10.10.10-FF-001474', NULL, 'Histone H1', 45, NULL, NULL, 198295),
(198296, '1.20.5.100-FF-000030', NULL, 'Uncharacterized protein', 75, NULL, NULL, 198296),
(198297, '1.10.238.10-FF-000907', NULL, 'Uncharacterized protein', 101, NULL, NULL, 198297),
(198298, '2.170.300.10-FF-000051', NULL, 'LAMinin related. See also lmb', 76, NULL, NULL, 198298),
(198299, '3.30.70.1350-FF-000018', NULL, 'Mitochondrial protein with role in iron accumulation', 89, NULL, NULL, 198299),
(198300, '3.90.20.20-FF-000014', NULL, 'Protein GrpE', 116, NULL, NULL, 198300),
(198301, '1.20.1440.120-FF-000002', NULL, 'DNA repair protein RecO', 166, NULL, NULL, 198301),
(198302, '3.40.50.720-FF-000266', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', 159, NULL, NULL, 198302),
(198303, '3.30.1780.10-FF-000002', NULL, 'Ornithine cyclodeaminase', 141, NULL, NULL, 198303),
(198304, '1.10.238.10-FF-000795', NULL, 'Phosphoinositide phospholipase C', 58, NULL, NULL, 198304),
(198305, '1.20.5.110-FF-000033', NULL, 'bet1-like SNARE 1-1', 65, NULL, NULL, 198305),
(198306, '2.30.42.10-FF-000645', NULL, NULL, 43, NULL, NULL, 198306),
(198307, '1.25.40.90-FF-000117', NULL, 'Predicted protein', 134, NULL, NULL, 198307),
(198308, '2.120.10.80-FF-000425', NULL, 'Protein ral2', 235, NULL, NULL, 198308),
(198309, '3.30.200.20-FF-000429', NULL, 'Calcium/calmodulin-dependent protein kinase kinase', 107, NULL, NULL, 198309),
(198310, '2.60.40.10-FF-003523', NULL, NULL, 83, NULL, NULL, 198310);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(198311, '3.40.50.720-FF-000209', NULL, 'Polyketide synthase Pks12', 144, NULL, NULL, 198311),
(198312, '1.10.510.10-FF-001434', NULL, 'Si:ch211-171h4.3', 269, NULL, NULL, 198312),
(198313, '1.20.1560.10-FF-000248', NULL, 'ABC transporter ATP-binding protein', 268, NULL, NULL, 198313),
(198314, '3.90.1280.20-FF-000004', NULL, 'Chloride channel protein', 77, NULL, NULL, 198314),
(198315, '3.40.50.300-FF-000758', NULL, 'Mov10 RISC complex RNA helicase', 230, NULL, NULL, 198315),
(198316, '3.60.120.10-FF-000014', NULL, 'Isochorismate synthase MenF', 427, NULL, NULL, 198316),
(198317, '1.10.287.70-FF-000280', NULL, 'Uncharacterized protein', 146, NULL, NULL, 198317),
(198318, '2.130.10.10-FF-004001', NULL, 'WD repeat domain, phosphoinositide-interacting 1', 228, NULL, NULL, 198318),
(198319, '3.20.140.10-FF-000036', NULL, 'Uncharacterized protein', 166, NULL, NULL, 198319),
(198320, '3.30.70.3270-FF-000015', NULL, 'NADH-quinone oxidoreductase subunit I 1', 108, NULL, NULL, 198320),
(198321, '2.130.10.10-FF-003063', NULL, 'WD40-repeat-containing domain protein', 134, NULL, NULL, 198321),
(198322, '3.40.50.300-FF-001652', NULL, 'Type VII secretion protein EccC', 304, NULL, NULL, 198322),
(198323, '2.10.25.10-FF-000432', NULL, 'Delta-like 3 (Drosophila), isoform CRA_b', 38, NULL, NULL, 198323),
(198324, '2.130.10.10-FF-005193', NULL, 'Spliceosome associated factor 3b, subunit 3; 130kD spliceosome associated protein', 336, NULL, NULL, 198324),
(198325, '1.10.10.60-FF-000977', NULL, NULL, 95, NULL, NULL, 198325),
(198326, '1.10.3170.10-FF-000002', NULL, 'RecBCD enzyme subunit RecB', 201, NULL, NULL, 198326),
(198327, '3.90.1210.10-FF-000002', NULL, 'Sialic acid synthase', 70, NULL, NULL, 198327),
(198328, '3.30.70.940-FF-000006', NULL, 'Transcription termination/antitermination protein NusG', 113, NULL, NULL, 198328),
(198329, '2.30.30.100-FF-000048', NULL, 'U6 snRNA-associated Sm-like protein LSm4', 83, NULL, NULL, 198329),
(198330, '2.10.25.10-FF-000112', NULL, 'Netrin G1', 33, NULL, NULL, 198330),
(198331, '3.50.50.60-FF-000951', NULL, 'Uncharacterized protein', 236, NULL, NULL, 198331),
(198332, '3.40.50.300-FF-007733', NULL, 'Uncharacterized protein', 85, NULL, NULL, 198332),
(198333, '2.60.120.200-FF-000324', NULL, 'Vesicular integral membrane protein VIP36, putative', 226, NULL, NULL, 198333),
(198334, '2.40.50.140-FF-001001', NULL, NULL, 44, NULL, NULL, 198334),
(198335, '2.60.40.10-FF-004658', NULL, NULL, 105, NULL, NULL, 198335),
(198336, '1.10.10.10-FF-000923', NULL, 'Probable two-component response regulator', 95, NULL, NULL, 198336),
(198337, '1.20.1250.20-FF-002055', NULL, 'CLN3 protein', 307, NULL, NULL, 198337),
(198338, '1.10.10.390-FF-000010', NULL, 'Histone acetyltransferase type B catalytic subunit', 54, NULL, NULL, 198338),
(198339, '2.10.70.10-FF-000121', NULL, 'Sushi domain-containing protein 4', 71, NULL, NULL, 198339),
(198340, '3.90.550.10-FF-000579', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 256, NULL, NULL, 198340),
(198341, '1.25.10.10-FF-003245', NULL, 'Unc-45 myosin chaperone B', 234, NULL, NULL, 198341),
(198342, '3.80.10.10-FF-002950', NULL, 'Uncharacterized protein', 71, NULL, NULL, 198342),
(198343, '1.25.10.10-FF-000654', NULL, 'Cullin-associated NEDD8-dissociated protein 1', 1171, NULL, NULL, 198343),
(198344, '1.20.1070.10-FF-000716', NULL, 'Adrenoceptor alpha 2C', 267, NULL, NULL, 198344),
(198345, '1.10.510.10-FF-002957', NULL, NULL, 68, NULL, NULL, 198345),
(198346, '1.10.1040.10-FF-000110', NULL, 'Predicted protein', 129, NULL, NULL, 198346),
(198347, '3.40.50.300-FF-003782', NULL, 'Predicted protein', 243, NULL, NULL, 198347),
(198348, '2.10.50.10-FF-000007', NULL, 'TNF receptor superfamily member 14', 59, NULL, NULL, 198348),
(198349, '1.20.1250.20-FF-000817', NULL, 'Autophagy-related protein 22', 290, NULL, NULL, 198349),
(198350, '2.60.40.60-FF-000828', NULL, 'E-cadherin-like protein', 119, NULL, NULL, 198350),
(198351, '1.10.287.110-FF-000287', NULL, 'DnaJ domain containing protein', 111, NULL, NULL, 198351),
(198352, '2.60.40.60-FF-001082', NULL, 'Uncharacterized protein', 109, NULL, NULL, 198352);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(198353, '1.10.472.10-FF-000676', NULL, 'Uncharacterized protein', 206, NULL, NULL, 198353),
(198354, '3.90.1380.10-FF-000003', NULL, 'THR4p Threonine synthase', 87, NULL, NULL, 198354),
(198355, '1.10.510.10-FF-000827', NULL, 'Uncharacterized protein, isoform B', 195, NULL, NULL, 198355),
(198356, '1.20.5.2210-FF-000003', NULL, 'ATP synthase subunit B', 105, NULL, NULL, 198356),
(198357, '2.40.30.10-FF-000376', NULL, 'Predicted protein', 105, NULL, NULL, 198357),
(198358, '3.40.50.880-FF-000229', NULL, 'Carbamoyl-phosphate synthase small chain', 212, NULL, NULL, 198358),
(198359, '3.30.70.660-FF-000080', NULL, 'Pseudouridylate synthase I, putative', 266, NULL, NULL, 198359),
(198360, '1.10.260.170-FF-000004', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', 145, NULL, NULL, 198360),
(198361, '3.40.50.300-FF-007104', NULL, 'Uncharacterized protein', 187, NULL, NULL, 198361),
(198362, '3.40.50.620-FF-000382', NULL, 'Valine--tRNA ligase', 167, NULL, NULL, 198362),
(198363, '3.40.1110.10-FF-000107', NULL, 'Phospholipid-transporting ATPase', 175, NULL, NULL, 198363),
(198364, '2.60.40.420-FF-000055', NULL, 'Cytochrome c oxidase subunit II', 148, NULL, NULL, 198364),
(198365, '1.10.8.60-FF-000201', NULL, 'AAA family ATPase, putative', 69, NULL, NULL, 198365),
(198366, '1.25.40.10-FF-003073', NULL, 'Uncharacterized protein', 196, NULL, NULL, 198366),
(198367, '1.20.58.760-FF-000036', NULL, 'Uncharacterized protein', 135, NULL, NULL, 198367),
(198368, '1.10.1420.10-FF-000095', NULL, 'DNA mismatch repair protein', 213, NULL, NULL, 198368),
(198369, '2.60.40.10-FF-002629', NULL, 'MSP_(Major_sperm_protein )_domain_containing_protein_-__putative', 129, NULL, NULL, 198369),
(198370, '1.10.2000.10-FF-000052', NULL, NULL, 114, NULL, NULL, 198370),
(198371, '1.10.150.380-FF-000003', NULL, 'Aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase subunit B', 54, NULL, NULL, 198371),
(198372, '3.40.50.300-FF-007380', NULL, 'Uncharacterized protein', 366, NULL, NULL, 198372),
(198373, '3.30.160.60-FF-002112', NULL, 'ZNF415 isoform 2', 27, NULL, NULL, 198373),
(198374, '1.10.3470.10-FF-000047', NULL, 'Metal ABC transporter permease', 263, NULL, NULL, 198374),
(198375, '3.30.160.60-FF-001090', NULL, 'zinc finger protein 629 isoform X2', 29, NULL, NULL, 198375),
(198376, '3.10.100.10-FF-000199', NULL, 'Mannose binding lectin 2', 116, NULL, NULL, 198376),
(198377, '1.10.3090.10-FF-000001', NULL, 'Multifunctional CCA protein', 226, NULL, NULL, 198377),
(198378, '4.10.280.10-FF-000151', NULL, 'Transcription factor HES-1-B', 27, NULL, NULL, 198378),
(198379, '3.80.10.10-FF-000707', NULL, 'NACHT, LRR and PYD domains-containing protein 12', 173, NULL, NULL, 198379),
(198380, '3.30.710.10-FF-000252', NULL, 'SKP1-like protein 1A', 161, NULL, NULL, 198380),
(198381, '3.90.640.10-FF-000232', NULL, 'Actin-related protein 4', 48, NULL, NULL, 198381),
(198382, '3.90.550.10-FF-000759', NULL, 'Galactosylgalactosylxylosylprotein 3-beta-glucuronosyltransferase', 115, NULL, NULL, 198382),
(198383, '3.30.70.2510-FF-000001', NULL, 'tRNA pseudouridine synthase Pus10', 125, NULL, NULL, 198383),
(198384, '2.130.10.10-FF-001152', NULL, 'Cleavage and Polyadenylation Factor', 168, NULL, NULL, 198384),
(198385, '3.30.230.10-FF-000254', NULL, 'Type 2 DNA topoisomerase 6 subunit B', 213, NULL, NULL, 198385),
(198386, '3.40.50.150-FF-000578', NULL, 'SAM-dependent methyltransferase', 188, NULL, NULL, 198386),
(198387, '1.25.40.1030-FF-000015', NULL, 'Protein transport protein sec16', 432, NULL, NULL, 198387),
(198388, '1.10.10.2670-FF-000003', NULL, 'E3 ubiquitin-protein ligase PRT6', 95, NULL, NULL, 198388),
(198389, '3.20.20.70-FF-000700', NULL, NULL, 159, NULL, NULL, 198389),
(198390, '3.30.479.30-FF-000011', NULL, 'stomatin-like protein 1 isoform X1', 123, NULL, NULL, 198390),
(198391, '3.30.160.60-FF-003860', NULL, NULL, 32, NULL, NULL, 198391),
(198392, '3.30.450.40-FF-000257', NULL, 'Transcriptional regulator', 176, NULL, NULL, 198392),
(198393, '2.60.40.10-FF-001174', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', 86, NULL, NULL, 198393);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(198394, '3.90.180.10-FF-000152', NULL, 'Uncharacterized protein', 163, NULL, NULL, 198394),
(198395, '1.25.40.10-FF-004697', NULL, 'Uncharacterized protein', 100, NULL, NULL, 198395),
(198396, '1.25.40.10-FF-004585', NULL, 'Uncharacterized protein', 174, NULL, NULL, 198396),
(198397, '1.20.1250.20-FF-000610', NULL, 'monocarboxylate transporter 12-like', 188, NULL, NULL, 198397),
(198398, '3.20.20.80-FF-000703', NULL, 'Os02g0528200 protein', 75, NULL, NULL, 198398),
(198399, '3.40.50.10240-FF-000012', NULL, 'Thiamine pyrophosphokinase', 153, NULL, NULL, 198399),
(198400, '1.10.287.130-FF-000034', NULL, 'Two-component system sensor histidine kinase/response regulator', 93, NULL, NULL, 198400),
(198401, '3.30.1330.30-FF-000132', NULL, 'Uncharacterized protein', 111, NULL, NULL, 198401),
(198402, '1.10.510.10-FF-003851', NULL, NULL, 103, NULL, NULL, 198402),
(198403, '2.60.40.10-FF-001117', NULL, 'Down syndrome cell adhesion molecule 4, isoform D', 92, NULL, NULL, 198403),
(198404, '3.30.1120.30-FF-000043', NULL, 'Serine/threonine-protein kinase', 102, NULL, NULL, 198404),
(198405, '1.20.58.60-FF-000873', NULL, 'Spectrin beta chain', 107, NULL, NULL, 198405),
(198406, '2.70.98.50-FF-000003', NULL, 'Large secreted protein, putative, expressed', 277, NULL, NULL, 198406),
(198407, '3.30.450.20-FF-000251', NULL, 'Sensory box sensor histidine kinase/response regulator VieS', 126, NULL, NULL, 198407),
(198408, '1.20.900.10-FF-000068', NULL, 'FUS2p Cell fusion regulator', 213, NULL, NULL, 198408),
(198409, '1.10.1370.10-FF-000034', NULL, 'Predicted protein', 319, NULL, NULL, 198409),
(198410, '2.130.10.10-FF-002719', NULL, 'AEL226Wp', 311, NULL, NULL, 198410),
(198411, '1.10.1300.10-FF-000029', NULL, 'Phosphodiesterase', 346, NULL, NULL, 198411),
(198412, '3.40.50.300-FF-000876', NULL, 'Mitochondrial GTPase 1', 180, NULL, NULL, 198412),
(198413, '3.30.160.60-FF-001617', NULL, 'zinc finger protein 420 isoform X2', 28, NULL, NULL, 198413),
(198414, '3.40.50.150-FF-001567', NULL, NULL, 70, NULL, NULL, 198414),
(198415, '3.30.40.10-FF-002095', NULL, 'Uncharacterized protein', 81, NULL, NULL, 198415),
(198416, '3.30.470.20-FF-000252', NULL, 'Uncharacterized protein', 15, NULL, NULL, 198416),
(198417, '3.30.559.10-FF-000270', NULL, 'Uncharacterized protein', 157, NULL, NULL, 198417),
(198418, '3.40.50.720-FF-002452', NULL, 'Uncharacterized protein', 151, NULL, NULL, 198418),
(198419, '1.25.40.20-FF-001827', NULL, 'MIB (MIndBomb) ubiquitin ligase homolog', 152, NULL, NULL, 198419),
(198420, '1.10.1090.10-FF-000001', NULL, 'Cytochrome b-c1 complex subunit 7', 115, NULL, NULL, 198420),
(198421, '1.10.10.10-FF-000659', NULL, 'Putative serine/threonine protein kinase IREH1', 78, NULL, NULL, 198421),
(198422, '2.130.10.10-FF-004962', NULL, 'Plexin, putative', 89, NULL, NULL, 198422),
(198423, '3.30.980.10-FF-000001', NULL, 'Threonine--tRNA ligase', 97, NULL, NULL, 198423),
(198424, '3.10.400.20-FF-000016', NULL, 'YALI0D12727p', 196, NULL, NULL, 198424),
(198425, '1.25.40.10-FF-004528', NULL, 'Uncharacterized protein', 68, NULL, NULL, 198425),
(198426, '3.30.70.330-FF-000565', NULL, 'RNA-binding protein 15B', 122, NULL, NULL, 198426),
(198427, '3.40.50.2000-FF-000834', NULL, 'O-linked GlcNAc transferase', 96, NULL, NULL, 198427),
(198428, '1.10.10.60-FF-001141', NULL, NULL, 59, NULL, NULL, 198428),
(198429, '2.130.10.10-FF-001713', NULL, 'Cell surface protein', 190, NULL, NULL, 198429),
(198430, '3.30.40.10-FF-000419', NULL, 'RING finger protein 24', 72, NULL, NULL, 198430),
(198431, '1.10.1670.10-FF-000079', NULL, NULL, 52, NULL, NULL, 198431),
(198432, '2.10.25.10-FF-000320', NULL, 'Proepiregulin', 61, NULL, NULL, 198432),
(198433, '3.30.43.10-FF-000044', NULL, 'Fad-linked oxidase', 96, NULL, NULL, 198433),
(198434, '3.80.10.10-FF-004018', NULL, 'Si:dkey-286j17.4', 147, NULL, NULL, 198434),
(198435, '2.10.70.10-FF-000008', NULL, 'Complement receptor type 1', 64, NULL, NULL, 198435),
(198436, '3.30.465.10-FF-000052', NULL, 'Decaprenylphosphoryl-beta-D-ribose oxidase', 119, NULL, NULL, 198436),
(198437, '1.25.40.10-FF-004433', NULL, 'Uncharacterized protein', 122, NULL, NULL, 198437); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(198438, '1.20.1250.20-FF-000705', NULL, 'Organic cation transporter 1', 419, NULL, NULL, 198438),
(198439, '3.40.1690.20-FF-000018', NULL, 'Peptidase family M41-domain-containing protein', 92, NULL, NULL, 198439),
(198440, '3.40.50.720-FF-001103', NULL, 'Glyoxylate/hydroxypyruvate reductase A', 108, NULL, NULL, 198440),
(198441, '1.20.1250.20-FF-002330', NULL, 'Uncharacterized protein', 167, NULL, NULL, 198441),
(198442, '3.40.50.300-FF-000016', NULL, 'Oligopeptide ABC transporter ATP-binding component', 323, NULL, NULL, 198442),
(198443, '1.25.40.20-FF-000203', NULL, 'caseinolytic peptidase B protein homolog isoform X1', 91, NULL, NULL, 198443),
(198444, '1.25.10.20-FF-000022', NULL, 'Hemelipoglyco-carrier protein', 144, NULL, NULL, 198444),
(198445, '1.10.560.10-FF-000021', NULL, 'Chaperonin containing TCP1, subunit 5 (epsilon)', 159, NULL, NULL, 198445),
(198446, '1.10.510.10-FF-001058', NULL, 'Tau tubulin kinase 2', 239, NULL, NULL, 198446),
(198447, '3.40.50.80-FF-000075', NULL, 'BnaA08g31310D protein', 127, NULL, NULL, 198447),
(198448, '3.30.420.40-FF-000873', NULL, 'Uncharacterized protein', 53, NULL, NULL, 198448),
(198449, '4.10.240.10-FF-000143', NULL, 'Expressed protein', 80, NULL, NULL, 198449),
(198450, '2.60.40.10-FF-001735', NULL, 'CD244 molecule A', 87, NULL, NULL, 198450),
(198451, '3.40.50.10490-FF-000154', NULL, NULL, 118, NULL, NULL, 198451),
(198452, '2.30.30.140-FF-000324', NULL, 'KIN17-like protein KLP', 37, NULL, NULL, 198452),
(198453, '3.30.160.20-FF-000032', NULL, 'endoribonuclease Dicer homolog 1', 70, NULL, NULL, 198453),
(198454, '3.30.390.150-FF-000009', NULL, 'Uncharacterized protein', 101, NULL, NULL, 198454),
(198455, '3.40.50.2300-FF-000929', NULL, NULL, 73, NULL, NULL, 198455),
(198456, '3.40.50.620-FF-000270', NULL, 'Leucine-tRNA ligase', 197, NULL, NULL, 198456),
(198457, '2.130.10.10-FF-001472', NULL, 'WD_domain_-_G-beta_repeat_-_putative', 195, NULL, NULL, 198457),
(198458, '2.60.40.2070-FF-000008', NULL, 'Probable fimbrial usher protein', 94, NULL, NULL, 198458),
(198459, '3.30.420.140-FF-000032', NULL, 'Transcription elongation factor Spt6', 170, NULL, NULL, 198459),
(198460, '3.40.50.1980-FF-000058', NULL, 'Iron (III) ABC transporter, periplasmic iron-bindin gprotein', 166, NULL, NULL, 198460),
(198461, '3.40.50.2000-FF-000273', NULL, 'UDP-glucuronate:glycolipid 2-beta-glucuronosyltransferase', 156, NULL, NULL, 198461),
(198462, '3.30.760.10-FF-000075', NULL, 'Uncharacterized protein', 186, NULL, NULL, 198462),
(198463, '3.40.50.1970-FF-000055', NULL, NULL, 165, NULL, NULL, 198463),
(198464, '2.60.40.10-FF-000943', NULL, 'Classical MHC class I molecule, alpha-chain', 102, NULL, NULL, 198464),
(198465, '2.60.120.200-FF-000049', NULL, 'collagen alpha-2(XI) chain isoform X2', 206, NULL, NULL, 198465),
(198466, '1.10.287.370-FF-000044', NULL, 'Prefoldin subunit, putative', 177, NULL, NULL, 198466),
(198467, '3.30.70.330-FF-001116', NULL, 'UBP1-associated protein 2C', 99, NULL, NULL, 198467),
(198468, '1.10.630.10-FF-000813', NULL, 'Uncharacterized protein', 284, NULL, NULL, 198468),
(198469, '3.40.50.1460-FF-000054', NULL, 'Uncharacterized protein', 89, NULL, NULL, 198469),
(198470, '3.40.50.10140-FF-000072', NULL, 'Uncharacterized protein', 94, NULL, NULL, 198470),
(198471, '2.10.110.10-FF-000186', NULL, 'Actin binding LIM protein family member 2', 48, NULL, NULL, 198471),
(198472, '3.50.30.30-FF-000002', NULL, 'N-acetylated-alpha-linked acidic dipeptidase 2', 225, NULL, NULL, 198472),
(198473, '1.10.533.10-FF-000189', NULL, 'Predicted protein', 106, NULL, NULL, 198473),
(198474, '3.40.50.300-FF-003243', NULL, 'ATP-dependent RNA helicase DDX3Y', 102, NULL, NULL, 198474),
(198475, '3.30.40.10-FF-002370', NULL, 'Uncharacterized protein', 128, NULL, NULL, 198475),
(198476, '3.40.50.300-FF-007172', NULL, 'Uncharacterized protein', 173, NULL, NULL, 198476),
(198477, '1.20.960.10-FF-000010', NULL, 'Predicted protein', 70, NULL, NULL, 198477),
(198478, '3.30.200.20-FF-000497', NULL, 'Serine/threonine-protein kinase Nek6', 78, NULL, NULL, 198478),
(198479, '2.30.230.10-FF-000027', NULL, 'Vitellogenin 5', 105, NULL, NULL, 198479);
INSERT INTO "PUBLIC"."MODEL" VALUES
(198480, '2.70.160.11-FF-000042', NULL, 'GM25898', 165, NULL, NULL, 198480),
(198481, '3.30.420.40-FF-000188', NULL, 'Actin like 6B', 177, NULL, NULL, 198481),
(198482, '1.10.510.10-FF-000895', NULL, 'SRSF protein kinase 1', 165, NULL, NULL, 198482),
(198483, '1.10.10.60-FF-000567', NULL, 'Transcriptional regulator CmeR', 64, NULL, NULL, 198483),
(198484, '3.60.20.10-FF-000254', NULL, NULL, 95, NULL, NULL, 198484),
(198485, '1.25.40.10-FF-002842', NULL, 'Chs4p', 126, NULL, NULL, 198485),
(198486, '2.40.50.90-FF-000125', NULL, 'Uncharacterized protein', 112, NULL, NULL, 198486),
(198487, '1.10.472.10-FF-000665', NULL, 'Predicted protein', 80, NULL, NULL, 198487),
(198488, '3.80.10.10-FF-000157', NULL, 'Class II major histocompatibility complex transactivator', 182, NULL, NULL, 198488),
(198489, '3.10.129.10-FF-000231', NULL, 'Fatty acid synthase beta subunit aflB', 304, NULL, NULL, 198489),
(198490, '3.40.50.300-FF-002967', NULL, 'Transport ATP-binding protein CydD', 251, NULL, NULL, 198490),
(198491, '1.20.1270.10-FF-000029', NULL, 'Heat shock 70 kDa protein cognate', 76, NULL, NULL, 198491),
(198492, '3.30.420.40-FF-001036', NULL, 'Uncharacterized protein', 26, NULL, NULL, 198492),
(198493, '3.50.50.60-FF-000451', NULL, 'FAD-dependent oxidoreductase', 159, NULL, NULL, 198493),
(198494, '3.40.50.1820-FF-000712', NULL, 'Carboxylic ester hydrolase', 123, NULL, NULL, 198494),
(198495, '3.40.630.10-FF-000434', NULL, 'Uncharacterized protein', 250, NULL, NULL, 198495),
(198496, '3.30.70.330-FF-002982', NULL, NULL, 88, NULL, NULL, 198496),
(198497, '3.30.559.10-FF-000118', NULL, 'Carnitine O-palmitoyltransferase 1, muscle isoform', 186, NULL, NULL, 198497),
(198498, '1.20.120.720-FF-000029', NULL, 'Myosin E', 133, NULL, NULL, 198498),
(198499, '2.60.40.420-FF-000044', NULL, 'L-ascorbate oxidase', 189, NULL, NULL, 198499),
(198500, '3.30.44.10-FF-000001', NULL, 'Salt-mediated killer protoxin 1', 77, NULL, NULL, 198500),
(198501, '3.40.30.10-FF-000250', NULL, 'Thioredoxin F-type, chloroplastic', 120, NULL, NULL, 198501),
(198502, '3.10.580.10-FF-000054', NULL, 'Magnesium transporter MgtE', 129, NULL, NULL, 198502),
(198503, '1.25.40.10-FF-002168', NULL, 'Pentatricopeptide repeat-containing protein At3g50420', 100, NULL, NULL, 198503),
(198504, '1.20.58.60-FF-000665', NULL, 'Uncharacterized protein', 133, NULL, NULL, 198504),
(198505, '1.10.1300.10-FF-000086', NULL, 'Uncharacterized protein', 231, NULL, NULL, 198505),
(198506, '1.25.40.10-FF-004197', NULL, 'Mitochondrial outer membrane 72K protein', 72, NULL, NULL, 198506),
(198507, '3.40.50.150-FF-000567', NULL, 'tRNA (Cytosine-5-)-methyltransferase, putative', 320, NULL, NULL, 198507),
(198508, '1.10.150.60-FF-000044', NULL, NULL, 108, NULL, NULL, 198508),
(198509, '3.30.160.60-FF-001331', NULL, 'zinc finger and BTB domain-containing protein 38', 76, NULL, NULL, 198509),
(198510, '2.40.128.20-FF-000043', NULL, 'Extracellular fatty acid-binding protein', 157, NULL, NULL, 198510),
(198511, '3.30.40.10-FF-000571', NULL, 'Zinc finger, C3HC4 type', 83, NULL, NULL, 198511),
(198512, '2.30.42.10-FF-000292', NULL, 'Protein CBG16414', 94, NULL, NULL, 198512),
(198513, '1.10.20.10-FF-000188', NULL, 'DNA polymerase epsilon subunit C, putative', 117, NULL, NULL, 198513),
(198514, '2.30.29.30-FF-000901', NULL, 'Docking protein 2', 62, NULL, NULL, 198514),
(198515, '3.20.20.70-FF-000021', NULL, 'Fructose-bisphosphate aldolase', 363, NULL, NULL, 198515),
(198516, '3.40.50.970-FF-000026', NULL, 'Glyoxylate carboligase', 224, NULL, NULL, 198516),
(198517, '4.10.1000.10-FF-000116', NULL, 'CCCH-type zinc finger-containing protein', 71, NULL, NULL, 198517),
(198518, '3.50.50.60-FF-001114', NULL, 'Uncharacterized protein', 155, NULL, NULL, 198518),
(198519, '1.10.12.10-FF-000028', NULL, '4-chlorobenzoyl coenzyme A dehalogenase', 66, NULL, NULL, 198519),
(198520, '3.40.850.10-FF-000349', NULL, 'Kinesin-like protein', 376, NULL, NULL, 198520),
(198521, '3.30.1140.32-FF-000024', NULL, '30S ribosomal protein S3', 143, NULL, NULL, 198521),
(198522, '1.10.472.10-FF-000608', NULL, 'Predicted protein', 140, NULL, NULL, 198522);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(198523, '3.30.70.330-FF-002544', NULL, NULL, 41, NULL, NULL, 198523),
(198524, '3.40.50.2000-FF-000216', NULL, 'Chitobiosyldiphosphodolichol beta-mannosyltransferase', 189, NULL, NULL, 198524),
(198525, '1.25.10.10-FF-001093', NULL, 'Vac14, PIKFYVE complex component', 209, NULL, NULL, 198525),
(198526, '3.30.565.10-FF-000239', NULL, 'Sensory box sensor histidine kinase/response regulator VieS', 161, NULL, NULL, 198526),
(198527, '2.60.40.150-FF-000795', NULL, 'E3 ubiquitin-protein ligase NEDD4', 73, NULL, NULL, 198527),
(198528, '1.10.472.80-FF-000202', NULL, NULL, 145, NULL, NULL, 198528),
(198529, '2.130.10.10-FF-002169', NULL, 'Putative serine/threonine-protein kinase vps15', 265, NULL, NULL, 198529),
(198530, '3.40.5.120-FF-000002', NULL, 'chromodomain-helicase-DNA-binding protein 9 isoform X1', 48, NULL, NULL, 198530),
(198531, '1.10.533.10-FF-000110', NULL, 'astrocytic phosphoprotein PEA-15 isoform X2', 73, NULL, NULL, 198531),
(198532, '2.130.10.10-FF-001359', NULL, 'DYnein Chain, light Intermediate', 188, NULL, NULL, 198532),
(198533, '3.40.50.410-FF-000111', NULL, 'Uncharacterized protein', 176, NULL, NULL, 198533),
(198534, '1.20.1070.10-FF-000727', NULL, 'Protein CBR-GAR-1', 120, NULL, NULL, 198534),
(198535, '3.40.50.12470-FF-000012', NULL, 'Oxoglutarate dehydrogenase (Succinyl-transferring), E1 component', 234, NULL, NULL, 198535),
(198536, '2.60.120.200-FF-000381', NULL, 'Uncharacterized protein', 179, NULL, NULL, 198536),
(198537, '3.40.1190.20-FF-000093', NULL, 'Fructokinase, putative', 290, NULL, NULL, 198537),
(198538, '2.20.110.10-FF-000015', NULL, 'Phosphatidylinositol 4-phosphate 5-kinase', 45, NULL, NULL, 198538),
(198539, '3.40.190.10-FF-000349', NULL, 'Probable transcriptional regulator', 92, NULL, NULL, 198539),
(198540, '3.20.20.80-FF-000681', NULL, 'Heparanase, putative', 326, NULL, NULL, 198540),
(198541, '2.60.120.260-FF-000292', NULL, 'Anaphase promoting complex subunit', 222, NULL, NULL, 198541),
(198542, '2.60.40.10-FF-004872', NULL, NULL, 118, NULL, NULL, 198542),
(198543, '3.40.50.720-FF-002177', NULL, 'Uncharacterized protein', 61, NULL, NULL, 198543),
(198544, '3.30.1380.20-FF-000048', NULL, 'Predicted protein', 114, NULL, NULL, 198544),
(198545, '3.10.20.230-FF-000035', NULL, 'Predicted protein', 86, NULL, NULL, 198545),
(198546, '3.40.366.10-FF-000050', NULL, 'Uncharacterized protein', 35, NULL, NULL, 198546),
(198547, '3.40.50.300-FF-007115', NULL, 'Uncharacterized protein', 185, NULL, NULL, 198547),
(198548, '1.10.150.20-FF-000061', NULL, 'DNA polymerase IV', 68, NULL, NULL, 198548),
(198549, '1.20.5.170-FF-000124', NULL, 'Alcohol dehydrogenase 3', 58, NULL, NULL, 198549),
(198550, '3.20.20.150-FF-000009', NULL, 'Xylose isomerase', 387, NULL, NULL, 198550),
(198551, '1.25.10.10-FF-003234', NULL, 'Uncharacterized protein', 250, NULL, NULL, 198551),
(198552, '3.30.260.10-FF-000082', NULL, NULL, 67, NULL, NULL, 198552),
(198553, '3.10.10.10-FF-000019', NULL, NULL, 67, NULL, NULL, 198553),
(198554, '3.20.20.140-FF-000006', NULL, 'Dihydroorotase', 344, NULL, NULL, 198554),
(198555, '2.60.120.590-FF-000008', NULL, 'Alpha-ketoglutarate-dependent dioxygenase alkB homolog 4', 182, NULL, NULL, 198555),
(198556, '3.40.50.150-FF-001359', NULL, NULL, 186, NULL, NULL, 198556),
(198557, '1.20.120.610-FF-000007', NULL, 'V-type proton ATPase proteolipid subunit', 122, NULL, NULL, 198557),
(198558, '1.20.1250.90-FF-000001', NULL, 'Thymic stromal lymphopoietin', 132, NULL, NULL, 198558),
(198559, '3.20.20.150-FF-000048', NULL, '5-keto-L-gluconate epimerase', 270, NULL, NULL, 198559),
(198560, '1.20.1250.20-FF-000593', NULL, 'MFS general substrate transporter', 509, NULL, NULL, 198560),
(198561, '1.10.10.60-FF-000909', NULL, NULL, 88, NULL, NULL, 198561),
(198562, '3.10.450.40-FF-000059', NULL, NULL, 59, NULL, NULL, 198562),
(198563, '3.90.660.10-FF-000121', NULL, NULL, 120, NULL, NULL, 198563),
(198564, '2.30.130.10-FF-000031', NULL, 'Pseudouridine synthase, putative', 129, NULL, NULL, 198564),
(198565, '3.80.10.10-FF-000421', NULL, 'Si:dkey-16p6.1', 209, NULL, NULL, 198565);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(198566, '1.50.10.100-FF-000004', NULL, 'Chondroitin sulfate ABC lyase', 381, NULL, NULL, 198566),
(198567, '2.60.40.630-FF-000017', NULL, 'Uncharacterized protein', 88, NULL, NULL, 198567),
(198568, '1.10.472.130-FF-000069', NULL, 'Dynein heavy chain 3', 100, NULL, NULL, 198568),
(198569, '1.10.8.60-FF-000431', NULL, 'Cell division cycle protein', 80, NULL, NULL, 198569),
(198570, '3.40.50.1820-FF-000437', NULL, 'Probable peptidase', 276, NULL, NULL, 198570),
(198571, '2.10.60.10-FF-000002', NULL, 'Serine/threonine-protein kinase receptor', 99, NULL, NULL, 198571),
(198572, '1.25.40.10-FF-002729', NULL, 'Uncharacterized protein', 279, NULL, NULL, 198572),
(198573, '3.20.20.80-FF-000063', NULL, 'Beta-hexosaminidase', 394, NULL, NULL, 198573),
(198574, '1.10.10.350-FF-000026', NULL, NULL, 92, NULL, NULL, 198574),
(198575, '3.20.20.70-FF-000060', NULL, 'IMP dehydrogenase subunit', 354, NULL, NULL, 198575),
(198576, '1.10.510.10-FF-000619', NULL, 'non-receptor tyrosine-protein kinase TNK1 isoform X1', 183, NULL, NULL, 198576),
(198577, '3.60.15.10-FF-000068', NULL, 'Ribonuclease Z, mitochondrial', 142, NULL, NULL, 198577),
(198578, '3.30.40.10-FF-002218', NULL, '60S ribosomal protein L13', 69, NULL, NULL, 198578),
(198579, '3.40.50.720-FF-002441', NULL, 'Uncharacterized protein', 154, NULL, NULL, 198579),
(198580, '3.10.20.90-FF-000847', NULL, 'Ubiquitin, putative', 83, NULL, NULL, 198580),
(198581, '1.50.10.10-FF-000073', NULL, 'Glycogen debranching enzyme, hypothetical (TreX-like)', 335, NULL, NULL, 198581),
(198582, '2.60.40.60-FF-000885', NULL, 'Si:dkey-30k22.7', 106, NULL, NULL, 198582),
(198583, '3.40.50.300-FF-001539', NULL, 'ATP-dependent RNA helicase DDX51', 273, NULL, NULL, 198583),
(198584, '3.30.465.10-FF-000063', NULL, 'L-gulono-1,4-lactone dehydrogenase', 124, NULL, NULL, 198584),
(198585, '4.10.400.10-FF-000032', NULL, 'Low density lipoprotein receptor-related protein 1', 29, NULL, NULL, 198585),
(198586, '1.25.40.10-FF-003005', NULL, 'Pentatricopeptide repeat-containing protein', 124, NULL, NULL, 198586),
(198587, '2.40.128.330-FF-000007', NULL, 'Putative magnesium transporter MRS2-D', 66, NULL, NULL, 198587),
(198588, '1.25.40.10-FF-004938', NULL, 'Uncharacterized protein', 201, NULL, NULL, 198588),
(198589, '1.20.58.200-FF-000003', NULL, 'Translin family protein', 97, NULL, NULL, 198589),
(198590, '1.50.10.20-FF-000076', NULL, 'Prenyltransferase domain containing protein', 392, NULL, NULL, 198590),
(198591, '2.20.110.10-FF-000072', NULL, NULL, 85, NULL, NULL, 198591),
(198592, '2.10.25.10-FF-001394', NULL, 'Fibrillin 1', 40, NULL, NULL, 198592),
(198593, '3.40.50.720-FF-000586', NULL, 'Mannitol-1-phosphate 5-dehydrogenase', 207, NULL, NULL, 198593),
(198594, '1.25.10.10-FF-001654', NULL, 'Uncharacterized protein', 375, NULL, NULL, 198594),
(198595, '1.20.58.220-FF-000009', NULL, 'Phosphate-specific transport system accessory protein PhoU', 102, NULL, NULL, 198595),
(198596, '3.30.160.60-FF-002955', NULL, NULL, 28, NULL, NULL, 198596),
(198597, '3.75.10.10-FF-000001', NULL, 'Eukaryotic translation initiation factor 6', 225, NULL, NULL, 198597),
(198598, '3.40.50.620-FF-000680', NULL, 'Predicted protein', 188, NULL, NULL, 198598),
(198599, '2.20.70.10-FF-000278', NULL, 'WW domain protein', 24, NULL, NULL, 198599),
(198600, '3.40.190.10-FF-000681', NULL, 'Uncharacterized protein', 162, NULL, NULL, 198600),
(198601, '1.25.40.10-FF-005214', NULL, 'Uncharacterized protein', 199, NULL, NULL, 198601),
(198602, '1.10.565.10-FF-000010', NULL, 'Estrogen receptor', 253, NULL, NULL, 198602),
(198603, '2.60.40.10-FF-001106', NULL, 'MYCBP associated protein', 97, NULL, NULL, 198603),
(198604, '3.10.20.770-FF-000012', NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', 306, NULL, NULL, 198604),
(198605, '2.130.10.10-FF-000578', NULL, 'Nucleoporin seh1', 313, NULL, NULL, 198605),
(198606, '2.60.40.10-FF-004597', NULL, NULL, 95, NULL, NULL, 198606),
(198607, '3.30.9.10-FF-000212', NULL, 'Uncharacterized protein', 148, NULL, NULL, 198607),
(198608, '2.40.10.10-FF-000487', NULL, NULL, 207, NULL, NULL, 198608);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(198609, '3.30.760.10-FF-000018', NULL, 'Eukaryotic initiation factor 4E, putative', 174, NULL, NULL, 198609),
(198610, '3.40.50.620-FF-000623', NULL, 'Transport protein (Probable substrate cationic amino acids)', 134, NULL, NULL, 198610),
(198611, '1.20.58.900-FF-000005', NULL, 'RUN domain-containing protein 3A isoform X1', 178, NULL, NULL, 198611),
(198612, '2.130.10.10-FF-005125', NULL, 'Syntaxin-binding protein 5-like', 101, NULL, NULL, 198612),
(198613, '3.40.50.300-FF-005581', NULL, 'Dynein axonemal heavy chain 14', 70, NULL, NULL, 198613),
(198614, '3.30.420.40-FF-000929', NULL, 'Uncharacterized protein', 115, NULL, NULL, 198614),
(198615, '1.10.8.480-FF-000011', NULL, 'rRNA adenine N(6)-methyltransferase', 98, NULL, NULL, 198615),
(198616, '3.40.640.10-FF-000249', NULL, 'Aminotransferase class-III', 258, NULL, NULL, 198616),
(198617, '3.30.70.330-FF-000953', NULL, 'Putative Serine/arginine-rich splicing factor', 120, NULL, NULL, 198617),
(198618, '3.30.710.10-FF-000072', NULL, 'Potassium voltage-gated channel subfamily F member 1', 124, NULL, NULL, 198618),
(198619, '1.10.150.20-FF-000268', NULL, 'FA core complex-associated protein 24', 60, NULL, NULL, 198619),
(198620, '3.40.50.300-FF-003282', NULL, 'ATP-binding cassette, sub-family G (WHITE), member 3-like 1', 231, NULL, NULL, 198620),
(198621, '3.30.230.10-FF-000265', NULL, 'Putative phosphomevalonate kinase protein', 277, NULL, NULL, 198621),
(198622, '1.20.1250.20-FF-000317', NULL, 'Equilibrative Nucleoside Transporter (ENT) Family', 228, NULL, NULL, 198622),
(198623, '1.20.970.10-FF-000016', NULL, 'Anthranilate phosphoribosyltransferase, putative', 80, NULL, NULL, 198623),
(198624, '3.90.190.10-FF-000242', NULL, 'Protein CBG23275', 300, NULL, NULL, 198624),
(198625, '3.40.33.10-FF-000054', NULL, 'PR-1-like protein', 177, NULL, NULL, 198625),
(198626, '2.60.40.10-FF-003534', NULL, NULL, 108, NULL, NULL, 198626),
(198627, '3.40.50.300-FF-006941', NULL, 'Branched-chain amino acid ABC transporter, ATP-binding protein', 228, NULL, NULL, 198627),
(198628, '3.30.1740.20-FF-000008', NULL, '40S ribosomal protein S26', 107, NULL, NULL, 198628),
(198629, '2.60.34.10-FF-000058', NULL, 'ER-type hsp70', 153, NULL, NULL, 198629),
(198630, '3.30.160.60-FF-001595', NULL, 'Zinc finger protein 142', 30, NULL, NULL, 198630),
(198631, '3.30.160.60-FF-003129', NULL, 'FI23536p1', 25, NULL, NULL, 198631),
(198632, '1.20.58.2190-FF-000008', NULL, 'Ubiquitin-conjugating enzyme E2', 99, NULL, NULL, 198632),
(198633, '3.30.497.10-FF-000069', NULL, 'Serpin 28Db', 206, NULL, NULL, 198633),
(198634, '1.25.40.330-FF-000011', NULL, 'Adenylyl cyclase-associated protein', 65, NULL, NULL, 198634),
(198635, '1.20.1250.20-FF-001599', NULL, 'Uncharacterized protein', 255, NULL, NULL, 198635),
(198636, '1.25.40.10-FF-003062', NULL, 'Uncharacterized protein', 222, NULL, NULL, 198636),
(198637, '2.40.70.10-FF-000384', NULL, NULL, 190, NULL, NULL, 198637),
(198638, '3.40.850.10-FF-000063', NULL, 'Kinesin-like protein', 375, NULL, NULL, 198638),
(198639, '1.20.1260.10-FF-000080', NULL, 'Uncharacterized protein', 259, NULL, NULL, 198639),
(198640, '3.90.1150.10-FF-000519', NULL, 'Sphingosine 1 phosphate lyase putative', 68, NULL, NULL, 198640),
(198641, '1.10.630.10-FF-000072', NULL, '3-hydroxyphenylacetate 6 hydroxylase', 473, NULL, NULL, 198641),
(198642, '1.10.510.10-FF-003413', NULL, NULL, 295, NULL, NULL, 198642),
(198643, '3.50.30.50-FF-000008', NULL, 'Uncharacterized protein', 157, NULL, NULL, 198643),
(198644, '2.30.29.30-FF-000547', NULL, 'TIAM (Mammalian Tumor Invasion And Metastasis factor) homolog', 135, NULL, NULL, 198644),
(198645, '3.40.190.10-FF-000888', NULL, 'Uncharacterized protein', 99, NULL, NULL, 198645),
(198646, '2.60.40.1390-FF-000006', NULL, 'Meiosis-specific transcription factor NDT80', 256, NULL, NULL, 198646),
(198647, '3.90.1150.10-FF-000177', NULL, '4-aminobutyrate aminotransferase', 145, NULL, NULL, 198647),
(198648, '3.80.10.10-FF-002219', NULL, 'Uncharacterized protein', 99, NULL, NULL, 198648),
(198649, '4.10.240.10-FF-000154', NULL, 'Zcf39p', 71, NULL, NULL, 198649);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(198650, '1.10.287.1060-FF-000022', NULL, 'Predicted protein', 62, NULL, NULL, 198650),
(198651, '2.30.30.140-FF-000004', NULL, 'Histone-lysine N-methyltransferase', 103, NULL, NULL, 198651),
(198652, '3.30.70.100-FF-000114', NULL, NULL, 56, NULL, NULL, 198652),
(198653, '2.30.38.10-FF-000017', NULL, '4-chlorobenzoate--CoA ligase', 80, NULL, NULL, 198653),
(198654, '3.40.50.1110-FF-000090', NULL, 'Predicted protein', 104, NULL, NULL, 198654),
(198655, '1.10.238.10-FF-001251', NULL, 'Uncharacterized protein', 72, NULL, NULL, 198655),
(198656, '3.80.10.10-FF-000718', NULL, 'F-box and leucine-rich repeat protein 4', 93, NULL, NULL, 198656),
(198657, '2.30.30.130-FF-000001', NULL, 'DDE-recombinase A', 68, NULL, NULL, 198657),
(198658, '3.90.640.10-FF-000002', NULL, 'Heat shock 70 kDa', 84, NULL, NULL, 198658),
(198659, '3.40.50.2300-FF-000481', NULL, 'Glutamate receptor 1', 224, NULL, NULL, 198659),
(198660, '3.30.1740.10-FF-000005', NULL, 'Poly [ADP-ribose] polymerase', 108, NULL, NULL, 198660),
(198661, '3.90.1170.40-FF-000013', NULL, 'Molybdopterin (MPT) converting factor, subunit2', 138, NULL, NULL, 198661),
(198662, '1.10.510.10-FF-001619', NULL, 'Kinase-like domain-containing protein', 355, NULL, NULL, 198662),
(198663, '3.30.720.210-FF-000003', NULL, 'ATP-dependent zinc metalloprotease FTSH, chloroplastic', 72, NULL, NULL, 198663),
(198664, '1.10.20.140-FF-000027', NULL, NULL, 54, NULL, NULL, 198664),
(198665, '3.90.380.10-FF-000015', NULL, 'Terminal oxygenase component of carbazole', 267, NULL, NULL, 198665),
(198666, '3.40.50.1100-FF-000278', NULL, 'Uncharacterized protein', 73, NULL, NULL, 198666),
(198667, '3.30.1370.120-FF-000006', NULL, 'Type III secretion system outer membrane pore InvG', 75, NULL, NULL, 198667),
(198668, '3.30.1370.110-FF-000003', NULL, 'NEDD4-binding protein 2 isoform X2', 105, NULL, NULL, 198668),
(198669, '1.20.5.220-FF-000004', NULL, 'Cytochrome b-c1 complex subunit 10', 56, NULL, NULL, 198669),
(198670, '3.90.1170.30-FF-000010', NULL, 'Pyrimidine-nucleoside phosphorylase', 92, NULL, NULL, 198670),
(198671, '3.90.1150.10-FF-000531', NULL, 'Aspartate aminotransferase, putative', 74, NULL, NULL, 198671),
(198672, '3.20.20.80-FF-000029', NULL, 'Beta-glucuronidase', 303, NULL, NULL, 198672),
(198673, '2.60.120.1000-FF-000002', NULL, 'Collagen XI alpha 1 chain', 231, NULL, NULL, 198673),
(198674, '3.40.50.2300-FF-000418', NULL, 'Diguanylate phosphodiesterase', 139, NULL, NULL, 198674),
(198675, '1.10.640.10-FF-000078', NULL, 'Uncharacterized protein', 347, NULL, NULL, 198675),
(198676, '2.30.42.10-FF-000297', NULL, 'Serine protease PepA', 87, NULL, NULL, 198676),
(198677, '1.20.5.210-FF-000001', NULL, 'Cytochrome b-c1 complex subunit 8', 82, NULL, NULL, 198677),
(198678, '2.60.40.10-FF-001617', NULL, 'Uncharacterized protein, isoform B', 94, NULL, NULL, 198678),
(198679, '2.60.40.60-FF-001048', NULL, 'Protocadherin-16, putative', 92, NULL, NULL, 198679),
(198680, '1.10.510.10-FF-003183', NULL, NULL, 154, NULL, NULL, 198680),
(198681, '2.60.34.10-FF-000097', NULL, 'Uncharacterized protein', 147, NULL, NULL, 198681),
(198682, '2.60.40.60-FF-001104', NULL, 'Protocadherin 10', 105, NULL, NULL, 198682),
(198683, '3.40.50.720-FF-002115', NULL, 'Uncharacterized protein', 116, NULL, NULL, 198683),
(198684, '1.10.472.10-FF-000491', NULL, 'Uncharacterized protein', 111, NULL, NULL, 198684),
(198685, '3.40.50.12780-FF-000217', NULL, 'Putative long-chain-fatty-acid-CoA ligase', 165, NULL, NULL, 198685),
(198686, '3.20.20.70-FF-000026', NULL, 'Biotin synthase', 307, NULL, NULL, 198686),
(198687, '3.30.160.60-FF-004765', NULL, NULL, 33, NULL, NULL, 198687),
(198688, '2.30.42.10-FF-000353', NULL, NULL, 83, NULL, NULL, 198688),
(198689, '3.30.559.70-FF-000052', NULL, 'Uncharacterized protein', 140, NULL, NULL, 198689),
(198690, '3.40.50.20-FF-000041', NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', 114, NULL, NULL, 198690),
(198691, '3.10.129.10-FF-000293', NULL, 'Fatty acid synthase subunit beta', 196, NULL, NULL, 198691),
(198692, '3.30.160.60-FF-001095', NULL, 'zinc finger and BTB domain-containing protein 24 isoform X1', 32, NULL, NULL, 198692);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(198693, '1.10.238.10-FF-001071', NULL, 'Uncharacterized protein', 75, NULL, NULL, 198693),
(198694, '1.10.10.60-FF-000679', NULL, 'Homeobox protein aristaless', 60, NULL, NULL, 198694),
(198695, '3.40.1410.10-FF-000029', NULL, 'GntR family transcriptional regulator', 163, NULL, NULL, 198695),
(198696, '3.40.50.300-FF-005305', NULL, 'Origin recognition complex subunit 5 C-terminus-domain-containing protein', 170, NULL, NULL, 198696),
(198697, '3.40.50.300-FF-001034', NULL, 'probable ATP-dependent RNA helicase DDX59', 188, NULL, NULL, 198697),
(198698, '3.40.50.12670-FF-000010', NULL, 'Carboxypeptidase', 132, NULL, NULL, 198698),
(198699, '3.30.160.60-FF-004872', NULL, NULL, 23, NULL, NULL, 198699),
(198700, '2.60.120.1020-FF-000008', NULL, 'peptide-N(4)-(N-acetyl-beta- glucosaminyl)asparagine amidase', 173, NULL, NULL, 198700),
(198701, '3.40.50.300-FF-007441', NULL, 'Uncharacterized protein', 252, NULL, NULL, 198701),
(198702, '3.60.20.10-FF-000080', NULL, 'Gamma-glutamyl-hercynylcysteine sulfoxide hydrolase', 231, NULL, NULL, 198702),
(198703, '1.20.5.170-FF-000242', NULL, 'Transcription factor MafG, putative', 105, NULL, NULL, 198703),
(198704, '1.25.40.10-FF-004085', NULL, 'Rap phosphatase', 156, NULL, NULL, 198704),
(198705, '3.30.40.10-FF-000453', NULL, 'Uncharacterized protein, isoform D', 141, NULL, NULL, 198705),
(198706, '3.30.40.10-FF-001021', NULL, 'Uncharacterized protein', 69, NULL, NULL, 198706),
(198707, '3.30.559.10-FF-000236', NULL, 'Uncharacterized protein', 158, NULL, NULL, 198707),
(198708, '3.30.160.60-FF-001213', NULL, 'Transcriptional repressor GATA binding 1', 96, NULL, NULL, 198708),
(198709, '1.20.1250.20-FF-000149', NULL, 'MFS transporter, SP family, general alpha glucoside:H+ symporter', 469, NULL, NULL, 198709),
(198710, '1.25.40.10-FF-000774', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 116, NULL, NULL, 198710),
(198711, '1.10.472.10-FF-000384', NULL, 'Uncharacterized protein', 132, NULL, NULL, 198711),
(198712, '2.40.290.10-FF-000023', NULL, 'ATP-dependent DNA helicase II subunit 2', 199, NULL, NULL, 198712),
(198713, '3.90.190.10-FF-000208', NULL, 'Vh5 dual specificity phosphatase, putative', 152, NULL, NULL, 198713),
(198714, '3.40.50.2000-FF-000486', NULL, 'UDP-N-acetylglucosamine 2-epimerase', 196, NULL, NULL, 198714),
(198715, '1.20.1250.20-FF-000205', NULL, 'Solute carrier family 15 oligopeptide transporter member 1', 137, NULL, NULL, 198715),
(198716, '2.60.200.10-FF-000047', NULL, 'Uncharacterized protein', 215, NULL, NULL, 198716),
(198717, '2.120.10.30-FF-000219', NULL, 'Gluconolactonase', 296, NULL, NULL, 198717),
(198718, '1.20.910.10-FF-000029', NULL, 'Si:ch1073-67j19.1', 216, NULL, NULL, 198718),
(198719, '3.20.20.300-FF-000077', NULL, NULL, 261, NULL, NULL, 198719),
(198720, '3.90.190.10-FF-000422', NULL, 'Uncharacterized protein', 84, NULL, NULL, 198720),
(198721, '4.10.910.10-FF-000003', NULL, 'Ribosomal protein S13', 40, NULL, NULL, 198721),
(198722, '3.40.1280.10-FF-000092', NULL, 'Putative methyltransferase', 198, NULL, NULL, 198722),
(198723, '1.25.40.20-FF-001541', NULL, 'Ankyrin repeat family protein', 127, NULL, NULL, 198723),
(198724, '2.130.10.10-FF-002837', NULL, 'Uncharacterized protein', 360, NULL, NULL, 198724),
(198725, '3.40.630.10-FF-000198', NULL, 'Uncharacterized protein', 182, NULL, NULL, 198725),
(198726, '3.80.10.10-FF-003698', NULL, 'Uncharacterized protein', 170, NULL, NULL, 198726),
(198727, '1.20.1250.10-FF-000146', NULL, NULL, 68, NULL, NULL, 198727),
(198728, '2.130.10.10-FF-004928', NULL, 'Predicted protein', 105, NULL, NULL, 198728),
(198729, '1.20.1050.10-FF-000272', NULL, 'Uncharacterized protein', 116, NULL, NULL, 198729),
(198730, '1.20.1250.20-FF-000475', NULL, 'MFS multidrug transporter, putative', 406, NULL, NULL, 198730),
(198731, '1.25.10.10-FF-000946', NULL, 'AP-3 complex subunit delta', 574, NULL, NULL, 198731),
(198732, '1.25.10.10-FF-003060', NULL, 'Uncharacterized protein', 267, NULL, NULL, 198732),
(198733, '3.10.110.10-FF-000087', NULL, 'Ubiquitin-conjugating enzyme E2 N', 105, NULL, NULL, 198733);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(198734, '1.25.10.10-FF-000839', NULL, 'Uncharacterized protein', 349, NULL, NULL, 198734),
(198735, '1.10.238.10-FF-000458', NULL, 'Probable calcium-binding protein CML30', 104, NULL, NULL, 198735),
(198736, '1.20.1250.20-FF-001779', NULL, 'Resistance protein, conjectural', 183, NULL, NULL, 198736),
(198737, '3.40.50.720-FF-002059', NULL, 'Uncharacterized protein', 167, NULL, NULL, 198737),
(198738, '2.40.30.270-FF-000029', NULL, 'Uncharacterized protein', 106, NULL, NULL, 198738),
(198739, '3.20.20.80-FF-000411', NULL, 'Brain chitinase, putative', 58, NULL, NULL, 198739),
(198740, '3.30.160.60-FF-005428', NULL, NULL, 36, NULL, NULL, 198740),
(198741, '1.10.274.10-FF-000002', NULL, 'Phosphoenolpyruvate-protein phosphotransferase PtsP', 124, NULL, NULL, 198741),
(198742, '3.40.850.10-FF-000467', NULL, 'Kinesin-like protein 1', 405, NULL, NULL, 198742),
(198743, '3.30.70.330-FF-000335', NULL, 'RNA-binding protein with multiple splicing 2', 91, NULL, NULL, 198743),
(198744, '1.25.40.10-FF-002898', NULL, 'Os11g0131400 protein', 206, NULL, NULL, 198744),
(198745, '3.90.1170.50-FF-000016', NULL, 'xanthine dehydrogenase/oxidase-like', 97, NULL, NULL, 198745),
(198746, '3.40.50.1820-FF-001449', NULL, 'Serine protease F56F10.1-related protein', 185, NULL, NULL, 198746),
(198747, '3.30.465.10-FF-000018', NULL, 'UDP-N-acetylenolpyruvoylglucosamine reductase', 150, NULL, NULL, 198747),
(198748, '3.40.1110.10-FF-000141', NULL, 'Probable cation-transporting ATPase G', 113, NULL, NULL, 198748),
(198749, '1.10.510.10-FF-001092', NULL, 'NAK/MPSK protein kinase', 293, NULL, NULL, 198749),
(198750, '1.25.40.20-FF-001327', NULL, 'Uncharacterized protein', 134, NULL, NULL, 198750),
(198751, '2.60.40.10-FF-003860', NULL, NULL, 92, NULL, NULL, 198751),
(198752, '1.50.10.20-FF-000014', NULL, 'Protein farnesyltransferase subunit beta', 450, NULL, NULL, 198752),
(198753, '3.40.50.300-FF-001713', NULL, 'ATP-dependent RNA helicase DHX8', 203, NULL, NULL, 198753),
(198754, '1.10.1870.10-FF-000004', NULL, 'AminoAdipate-Semialdehyde Synthase homolog', 98, NULL, NULL, 198754),
(198755, '3.80.10.10-FF-000825', NULL, 'MDIS1-interacting receptor like kinase 1', 107, NULL, NULL, 198755),
(198756, '1.20.58.1020-FF-000012', NULL, 'Uncharacterized protein', 130, NULL, NULL, 198756),
(198757, '2.60.120.290-FF-000132', NULL, 'Complement component 1, r subcomponent', 123, NULL, NULL, 198757),
(198758, '1.20.1070.10-FF-000048', NULL, 'Adhesion G protein-coupled receptor B1', 269, NULL, NULL, 198758),
(198759, '1.10.8.60-FF-000313', NULL, 'AAA ATPase, central domain protein', 100, NULL, NULL, 198759),
(198760, '3.40.50.150-FF-000808', NULL, 'Protein CBG20781', 199, NULL, NULL, 198760),
(198761, '3.40.50.200-FF-000104', NULL, 'Serine protease AprX', 316, NULL, NULL, 198761),
(198762, '3.40.50.2300-FF-000744', NULL, 'Vomeronasal 2 receptor, a20', 272, NULL, NULL, 198762),
(198763, '3.30.230.10-FF-000372', NULL, 'Uncharacterized protein', 71, NULL, NULL, 198763),
(198764, '1.25.10.10-FF-000098', NULL, 'HEAT repeat-containing protein 5A isoform X2', 350, NULL, NULL, 198764),
(198765, '1.10.220.30-FF-000002', NULL, 'Flagellar motor switch protein FliG', 103, NULL, NULL, 198765),
(198766, '1.20.1050.10-FF-000165', NULL, 'Slr0236 protein', 102, NULL, NULL, 198766),
(198767, '2.130.10.30-FF-000174', NULL, NULL, 279, NULL, NULL, 198767),
(198768, '3.40.50.1820-FF-000145', NULL, 'Pigment biosynthesis protein', 381, NULL, NULL, 198768),
(198769, '1.25.40.180-FF-000325', NULL, NULL, 234, NULL, NULL, 198769),
(198770, '2.60.40.200-FF-000040', NULL, 'Copper chaperone for superoxide dismutase', 79, NULL, NULL, 198770),
(198771, '3.40.190.290-FF-000099', NULL, 'Transcriptional regulator', 209, NULL, NULL, 198771),
(198772, '3.30.200.20-FF-000873', NULL, 'Protein kinase, putative', 92, NULL, NULL, 198772),
(198773, '2.60.40.150-FF-000744', NULL, 'Phosphoinositide phospholipase C', 96, NULL, NULL, 198773),
(198774, '3.40.50.1820-FF-000033', NULL, 'Pancreatic triacylglycerol lipase', 338, NULL, NULL, 198774),
(198775, '2.60.40.10-FF-003023', NULL, 'Protein tyrosine phosphatase, receptor type, s, a', 98, NULL, NULL, 198775);
INSERT INTO "PUBLIC"."MODEL" VALUES
(198776, '2.60.40.2700-FF-000006', NULL, NULL, 88, NULL, NULL, 198776),
(198777, '1.10.10.10-FF-000474', NULL, 'Putative transcriptional regulator, Crp/Fnr family', 73, NULL, NULL, 198777),
(198778, '3.20.20.80-FF-000355', NULL, 'Uncharacterized protein', 341, NULL, NULL, 198778),
(198779, '3.30.470.20-FF-000191', NULL, 'Succinate--CoA ligase [GDP-forming] subunit beta, mitochondrial', 75, NULL, NULL, 198779),
(198780, '1.25.40.10-FF-003303', NULL, 'Predicted protein', 180, NULL, NULL, 198780),
(198781, '1.10.1520.10-FF-000074', NULL, 'Ribonuclease 3', 153, NULL, NULL, 198781),
(198782, '3.60.140.10-FF-000010', NULL, 'Polyphenol oxidase', 232, NULL, NULL, 198782),
(198783, '1.50.10.10-FF-000011', NULL, 'Alkaline/neutral invertase A, mitochondrial', 233, NULL, NULL, 198783),
(198784, '1.10.10.650-FF-000015', NULL, 'Transcription elongation factor spt6', 146, NULL, NULL, 198784),
(198785, '3.40.50.1820-FF-001775', NULL, 'Carboxypeptidase', 191, NULL, NULL, 198785),
(198786, '3.10.20.120-FF-000002', NULL, 'Enterotoxin-like toxin X', 130, NULL, NULL, 198786),
(198787, '1.10.150.20-FF-000229', NULL, 'Uncharacterized protein', 59, NULL, NULL, 198787),
(198788, '1.10.565.10-FF-000122', NULL, 'Hepatocyte nuclear factor 4', 239, NULL, NULL, 198788),
(198789, '2.60.40.60-FF-000587', NULL, 'Protocadherin 1 gamma 32', 105, NULL, NULL, 198789),
(198790, '2.10.10.10-FF-000022', NULL, 'Uncharacterized protein', 50, NULL, NULL, 198790),
(198791, '3.40.50.1220-FF-000055', NULL, 'Thi3p', 164, NULL, NULL, 198791),
(198792, '2.60.120.740-FF-000019', NULL, 'Uncharacterized protein', 62, NULL, NULL, 198792),
(198793, '3.40.50.720-FF-000709', NULL, 'Putative ion channel POLLUX-like 2', 151, NULL, NULL, 198793),
(198794, '1.20.1740.10-FF-000009', NULL, 'Low affinity cationic amino acid transporter 2', 413, NULL, NULL, 198794),
(198795, '2.40.50.90-FF-000182', NULL, 'Uncharacterized protein', 84, NULL, NULL, 198795),
(198796, '1.20.1050.10-FF-000221', NULL, 'Glutathione S-transferase, putative', 108, NULL, NULL, 198796),
(198797, '3.40.50.360-FF-000012', NULL, 'Anaerobic nitric oxide reductase flavorubredoxin', 151, NULL, NULL, 198797),
(198798, '2.60.120.260-FF-000584', NULL, 'Predicted protein', 163, NULL, NULL, 198798),
(198799, '1.20.1070.10-FF-001739', NULL, 'Olfactory receptor 1262', 88, NULL, NULL, 198799),
(198800, '2.30.30.100-FF-000127', NULL, 'Scd6-like Sm domain containing protein, putative', 85, NULL, NULL, 198800),
(198801, '2.30.29.30-FF-000660', NULL, 'Uncharacterized protein', 124, NULL, NULL, 198801),
(198802, '1.20.1250.20-FF-001835', NULL, 'Uncharacterized protein', 141, NULL, NULL, 198802),
(198803, '1.10.630.10-FF-000313', NULL, 'Uncharacterized protein', 122, NULL, NULL, 198803),
(198804, '2.60.40.10-FF-002399', NULL, 'Cytochrome c oxidase accessory protein CcoG', 117, NULL, NULL, 198804),
(198805, '2.60.120.10-FF-000046', NULL, 'Cyclic nucleotide-gated cation channel alpha-4', 142, NULL, NULL, 198805),
(198806, '3.20.20.70-FF-000352', NULL, 'Metallo cofactor biosynthesis protein', 288, NULL, NULL, 198806),
(198807, '1.10.357.90-FF-000011', NULL, NULL, 179, NULL, NULL, 198807),
(198808, '2.40.320.10-FF-000038', NULL, 'Predicted protein', 172, NULL, NULL, 198808),
(198809, '1.20.58.670-FF-000009', NULL, 'RAD50-interacting protein 1', 133, NULL, NULL, 198809),
(198810, '1.10.472.10-FF-000165', NULL, 'Uncharacterized protein', 116, NULL, NULL, 198810),
(198811, '3.30.900.10-FF-000058', NULL, 'AER420Cp', 217, NULL, NULL, 198811),
(198812, '1.20.80.10-FF-000051', NULL, 'Acyl CoA binding protein family (AFU_orthologue AFUA_2G11060)', 99, NULL, NULL, 198812),
(198813, '1.25.10.10-FF-000991', NULL, 'DAF-15', 238, NULL, NULL, 198813),
(198814, '3.40.50.10140-FF-000015', NULL, 'Toll/interleukin-1 receptor domain-containing adapter protein', 146, NULL, NULL, 198814),
(198815, '3.80.10.10-FF-004136', NULL, 'Predicted protein', 110, NULL, NULL, 198815),
(198816, '1.25.40.20-FF-001215', NULL, 'Uncharacterized protein', 287, NULL, NULL, 198816),
(198817, '3.90.199.10-FF-000003', NULL, 'DNA topoisomerase 2', 183, NULL, NULL, 198817);
INSERT INTO "PUBLIC"."MODEL" VALUES
(198818, '3.40.50.2300-FF-001205', NULL, NULL, 99, NULL, NULL, 198818),
(198819, '2.60.40.1730-FF-000030', NULL, 'Aminopeptidase', 217, NULL, NULL, 198819),
(198820, '1.25.40.20-FF-001485', NULL, 'Uncharacterized protein', 93, NULL, NULL, 198820),
(198821, '3.30.160.60-FF-002629', NULL, 'Zinc finger protein 985', 28, NULL, NULL, 198821),
(198822, '3.30.200.20-FF-001334', NULL, 'Protein kinase, putative', 94, NULL, NULL, 198822),
(198823, '3.40.190.10-FF-000383', NULL, 'Choline ABC transporter substrate-binding protein', 149, NULL, NULL, 198823),
(198824, '1.10.630.10-FF-000364', NULL, 'Cytochrome P450', 512, NULL, NULL, 198824),
(198825, '3.40.33.10-FF-000110', NULL, 'Protein CBG01197', 82, NULL, NULL, 198825),
(198826, '3.30.70.330-FF-003027', NULL, NULL, 133, NULL, NULL, 198826),
(198827, '2.60.40.10-FF-005114', NULL, NULL, 98, NULL, NULL, 198827),
(198828, '2.30.29.30-FF-000160', NULL, 'DCC-interacting protein 13-beta isoform X2', 146, NULL, NULL, 198828),
(198829, '3.90.190.10-FF-000534', NULL, 'Uncharacterized protein', 182, NULL, NULL, 198829),
(198830, '2.170.150.20-FF-000019', NULL, 'Protein cereblon', 60, NULL, NULL, 198830),
(198831, '2.40.50.140-FF-000663', NULL, NULL, 91, NULL, NULL, 198831),
(198832, '3.90.1150.10-FF-000256', NULL, 'Gamma-aminobutyrate transaminase 1, mitochondrial', 28, NULL, NULL, 198832),
(198833, '2.50.20.10-FF-000021', NULL, 'Uncharacterized protein aq_1483', 186, NULL, NULL, 198833),
(198834, '1.25.40.10-FF-001482', NULL, 'Vacuolar protein sorting-associated protein 41', 199, NULL, NULL, 198834),
(198835, '3.30.420.40-FF-001031', NULL, 'Uncharacterized protein', 33, NULL, NULL, 198835),
(198836, '2.10.70.60-FF-000001', NULL, 'Phospholipase B-like', 53, NULL, NULL, 198836),
(198837, '2.170.150.10-FF-000016', NULL, 'Uncharacterized protein', 128, NULL, NULL, 198837),
(198838, '3.40.50.300-FF-007166', NULL, 'Uncharacterized protein', 174, NULL, NULL, 198838),
(198839, '1.10.238.10-FF-000677', NULL, 'Acidocalcisomal pyrophosphatase', 63, NULL, NULL, 198839),
(198840, '1.10.10.750-FF-000045', NULL, 'TBC domain containing protein', 42, NULL, NULL, 198840),
(198841, '2.160.20.10-FF-000156', NULL, 'Pectinesterase', 124, NULL, NULL, 198841),
(198842, '3.40.50.300-FF-003400', NULL, 'Replication factor C subunit 2', 47, NULL, NULL, 198842),
(198843, '3.40.50.150-FF-001702', NULL, NULL, 78, NULL, NULL, 198843),
(198844, '1.25.40.20-FF-000996', NULL, 'Phosphate system positive regulatory protein PHO81', 131, NULL, NULL, 198844),
(198845, '1.25.10.10-FF-001710', NULL, 'Predicted protein', 238, NULL, NULL, 198845),
(198846, '1.10.287.320-FF-000001', NULL, 'Phosphoprotein', 63, NULL, NULL, 198846),
(198847, '3.10.10.10-FF-000014', NULL, 'Uncharacterized protein', 110, NULL, NULL, 198847),
(198848, '3.40.50.1970-FF-000050', NULL, NULL, 213, NULL, NULL, 198848),
(198849, '3.40.50.970-FF-000138', NULL, 'NADH-dependent phenylglyoxylate dehydrogenase subunit beta', 220, NULL, NULL, 198849),
(198850, '3.20.20.100-FF-000135', NULL, 'Uncharacterized protein', 341, NULL, NULL, 198850),
(198851, '3.40.47.10-FF-000075', NULL, 'Acetyl-CoA acetyltransferase', 204, NULL, NULL, 198851),
(198852, '1.25.40.10-FF-001212', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 116, NULL, NULL, 198852),
(198853, '1.10.238.10-FF-001301', NULL, 'Uncharacterized protein', 63, NULL, NULL, 198853),
(198854, '3.40.50.300-FF-008178', NULL, 'Predicted protein', 83, NULL, NULL, 198854),
(198855, '3.30.160.60-FF-005209', NULL, NULL, 27, NULL, NULL, 198855),
(198856, '2.130.10.10-FF-003001', NULL, 'Uncharacterized protein', 189, NULL, NULL, 198856),
(198857, '3.80.10.10-FF-002450', NULL, 'Uncharacterized protein', 88, NULL, NULL, 198857),
(198858, '3.40.50.300-FF-004586', NULL, 'GTPase HflX', 178, NULL, NULL, 198858),
(198859, '3.40.50.2000-FF-000716', NULL, 'PslH', 158, NULL, NULL, 198859),
(198860, '1.20.1510.10-FF-000026', NULL, 'Zinc/cadmium resistance protein-like protein', 159, NULL, NULL, 198860),
(198861, '3.40.850.10-FF-000355', NULL, 'Kinesin-like protein', 115, NULL, NULL, 198861);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(198862, '3.50.50.60-FF-000395', NULL, 'Predicted protein', 458, NULL, NULL, 198862),
(198863, '3.40.50.11350-FF-000007', NULL, 'Alpha-(1,6)-fucosyltransferase', 160, NULL, NULL, 198863),
(198864, '2.40.30.270-FF-000024', NULL, 'Uncharacterized protein', 124, NULL, NULL, 198864),
(198865, '2.40.10.10-FF-000200', NULL, 'Serine protease nudel', 93, NULL, NULL, 198865),
(198866, '3.40.720.10-FF-000020', NULL, 'Phosphatidylinositol glycan anchor biosynthesis class N', 241, NULL, NULL, 198866),
(198867, '3.40.50.10890-FF-000010', NULL, 'Integrator complex subunit 11', 43, NULL, NULL, 198867),
(198868, '3.80.10.10-FF-004187', NULL, 'NLR family CARD domain containing 3', 94, NULL, NULL, 198868),
(198869, '3.40.140.100-FF-000004', NULL, 'Atg7p', 120, NULL, NULL, 198869),
(198870, '2.10.110.10-FF-000248', NULL, 'Uncharacterized protein', 67, NULL, NULL, 198870),
(198871, '3.40.50.11260-FF-000020', NULL, 'Heat shock HSP 90-alpha-like protein', 30, NULL, NULL, 198871),
(198872, '3.30.2080.10-FF-000005', NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', 162, NULL, NULL, 198872),
(198873, '1.25.40.20-FF-001266', NULL, 'Uncharacterized protein', 196, NULL, NULL, 198873),
(198874, '1.10.555.10-FF-000060', NULL, 'Rho-GTPase-activating protein RGD2', 227, NULL, NULL, 198874),
(198875, '3.90.190.10-FF-000427', NULL, 'Protein tyrosine phosphatase 4A1', 79, NULL, NULL, 198875),
(198876, '3.40.50.1820-FF-000471', NULL, 'Alpha/beta hydrolase', 244, NULL, NULL, 198876),
(198877, '3.40.190.10-FF-000388', NULL, 'Probable transcriptional regulator', 99, NULL, NULL, 198877),
(198878, '3.90.70.10-FF-000806', NULL, 'Putative ubiquitin carboxyl-terminal hydrolase superfamily protein', 316, NULL, NULL, 198878),
(198879, '3.40.50.300-FF-002669', NULL, 'Chromosome transmission fidelity protein 1', 250, NULL, NULL, 198879),
(198880, '3.30.40.10-FF-000234', NULL, 'Ubiquitinyl hydrolase 1', 122, NULL, NULL, 198880),
(198881, '2.60.40.10-FF-003293', NULL, '1,4-alpha-glucan branching enzyme', 123, NULL, NULL, 198881),
(198882, '4.10.1080.10-FF-000003', NULL, 'Thrombospondin 2', 71, NULL, NULL, 198882),
(198883, '1.25.40.10-FF-001263', NULL, 'TeTratriCopeptide repeat domain protein related', 167, NULL, NULL, 198883),
(198884, '3.30.70.270-FF-000058', NULL, 'Protein P', 120, NULL, NULL, 198884),
(198885, '3.40.50.2300-FF-000306', NULL, 'Response regulator SaeR', 80, NULL, NULL, 198885),
(198886, '2.30.42.10-FF-000527', NULL, NULL, 57, NULL, NULL, 198886),
(198887, '1.10.287.950-FF-000010', NULL, 'Two-component osmosensing histidine kinase', 108, NULL, NULL, 198887),
(198888, '3.10.110.10-FF-000317', NULL, 'Uncharacterized protein', 57, NULL, NULL, 198888),
(198889, '3.40.50.1820-FF-000763', NULL, 'Carboxylesterase 4A', 542, NULL, NULL, 198889),
(198890, '3.30.160.60-FF-002848', NULL, NULL, 29, NULL, NULL, 198890),
(198891, '3.30.40.10-FF-000178', NULL, 'PML isoform 6', 56, NULL, NULL, 198891),
(198892, '3.30.160.60-FF-003130', NULL, 'Zinc finger protein 672', 29, NULL, NULL, 198892),
(198893, '1.20.1070.10-FF-000486', NULL, 'Dopamine receptor 3', 234, NULL, NULL, 198893),
(198894, '3.30.160.60-FF-003416', NULL, 'LD12075p', 31, NULL, NULL, 198894),
(198895, '1.10.510.10-FF-003351', NULL, NULL, 236, NULL, NULL, 198895),
(198896, '1.20.1070.10-FF-000542', NULL, 'SERotonin/octopamine receptor family', 328, NULL, NULL, 198896),
(198897, '2.60.40.10-FF-004097', NULL, NULL, 118, NULL, NULL, 198897),
(198898, '2.30.30.1190-FF-000009', NULL, 'Zinc finger CCCH domain-containing protein 33', 71, NULL, NULL, 198898),
(198899, '2.60.120.740-FF-000014', NULL, 'D-galactoside/L-rhamnose binding SUEL lectin protein', 87, NULL, NULL, 198899),
(198900, '3.40.50.150-FF-001180', NULL, NULL, 144, NULL, NULL, 198900),
(198901, '3.30.2160.10-FF-000057', NULL, 'Uncharacterized protein', 109, NULL, NULL, 198901),
(198902, '3.40.50.2300-FF-000188', NULL, 'Glutamate receptor', 162, NULL, NULL, 198902),
(198903, '2.60.40.3170-FF-000001', NULL, 'Tripeptidyl peptidase 2', 127, NULL, NULL, 198903),
(198904, '3.40.50.300-FF-006598', NULL, 'Uncharacterized protein', 97, NULL, NULL, 198904); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(198905, '3.60.150.10-FF-000016', NULL, 'Chorismate synthase', 396, NULL, NULL, 198905),
(198906, '3.80.10.10-FF-003973', NULL, 'Tubulin-specific chaperone E', 161, NULL, NULL, 198906),
(198907, '3.60.40.10-FF-000261', NULL, 'Protein phosphatase, putative (AFU_orthologue AFUA_5G13740)', 317, NULL, NULL, 198907),
(198908, '1.10.1670.10-FF-000023', NULL, 'Endonuclease III homolog', 102, NULL, NULL, 198908),
(198909, '2.60.120.260-FF-000314', NULL, 'Beta-mannosidase A', 131, NULL, NULL, 198909),
(198910, '3.60.10.10-FF-000028', NULL, 'Type IV inositol polyphosphate 5-phosphatase 7', 97, NULL, NULL, 198910),
(198911, '1.25.10.10-FF-003127', NULL, 'Exportin 5', 205, NULL, NULL, 198911),
(198912, '1.20.1070.10-FF-000834', NULL, 'Relaxin family peptide/INSL5 receptor 4', 300, NULL, NULL, 198912),
(198913, '3.80.10.10-FF-000207', NULL, 'Relaxin family peptide receptor 2', 158, NULL, NULL, 198913),
(198914, '3.40.50.300-FF-001039', NULL, 'ATP-dependent RNA helicase DDX60', 204, NULL, NULL, 198914),
(198915, '3.40.50.300-FF-007222', NULL, 'Uncharacterized protein', 163, NULL, NULL, 198915),
(198916, '1.10.3470.10-FF-000042', NULL, 'Putative ABC transporter, permease protein', 229, NULL, NULL, 198916),
(198917, '1.20.1740.10-FF-000228', NULL, 'Amino acid permease homolog ykbA', 436, NULL, NULL, 198917),
(198918, '3.10.129.10-FF-000074', NULL, 'Acyl-CoA thioesterase II', 115, NULL, NULL, 198918),
(198919, '1.20.58.60-FF-000334', NULL, 'SMAll', 104, NULL, NULL, 198919),
(198920, '1.10.720.30-FF-000023', NULL, 'Poly [ADP-ribose] polymerase', 45, NULL, NULL, 198920),
(198921, '3.40.30.10-FF-001054', NULL, 'Uncharacterized protein', 177, NULL, NULL, 198921),
(198922, '3.30.70.580-FF-000056', NULL, 'tRNA pseudouridine synthase', 118, NULL, NULL, 198922),
(198923, '2.40.50.510-FF-000004', NULL, 'RecQ-mediated genome instability protein 1', 101, NULL, NULL, 198923),
(198924, '3.40.50.10490-FF-000160', NULL, NULL, 245, NULL, NULL, 198924),
(198925, '3.30.1520.10-FF-000141', NULL, 'Predicted protein', 55, NULL, NULL, 198925),
(198926, '3.30.56.10-FF-000017', NULL, 'Putative phenylalanyl-tRNA synthetase', 97, NULL, NULL, 198926),
(198927, '3.40.50.1010-FF-000003', NULL, 'Flap endonuclease 1', 216, NULL, NULL, 198927),
(198928, '3.30.70.260-FF-000022', NULL, 'Chorismate mutase/prephenate dehydratase', 93, NULL, NULL, 198928),
(198929, '3.40.50.720-FF-002334', NULL, 'Acetyl-CoA synthetase, putative', 137, NULL, NULL, 198929),
(198930, '2.40.50.140-FF-000169', NULL, 'AAA ATPase forming ring-shaped complexes', 91, NULL, NULL, 198930),
(198931, '2.60.40.10-FF-001494', NULL, 'Immunoglobulin superfamily DCC subclass member 3', 101, NULL, NULL, 198931),
(198932, '3.80.10.10-FF-002394', NULL, 'Uncharacterized protein', 92, NULL, NULL, 198932),
(198933, '2.40.37.10-FF-000065', NULL, NULL, 124, NULL, NULL, 198933),
(198934, '3.90.660.10-FF-000060', NULL, 'Amine oxidase', 226, NULL, NULL, 198934),
(198935, '2.30.30.40-FF-000464', NULL, 'Cytokinesis and cell polarization-associated protein, putative', 58, NULL, NULL, 198935),
(198936, '3.40.850.10-FF-000029', NULL, 'Kinesin-like protein KIF17', 351, NULL, NULL, 198936),
(198937, '2.60.34.10-FF-000092', NULL, 'Uncharacterized protein', 154, NULL, NULL, 198937),
(198938, '3.40.250.10-FF-000152', NULL, 'Putative thiosulfate sulfurtransferase', 146, NULL, NULL, 198938),
(198939, '3.30.420.40-FF-000867', NULL, 'Uncharacterized protein', 79, NULL, NULL, 198939),
(198940, '2.170.16.10-FF-000022', NULL, 'Ribonucleoside-diphosphate reductase', 128, NULL, NULL, 198940),
(198941, '1.25.40.10-FF-004933', NULL, 'Uncharacterized protein', 207, NULL, NULL, 198941),
(198942, '2.60.40.2950-FF-000002', NULL, 'CD109 isoform 3', 101, NULL, NULL, 198942),
(198943, '3.40.50.2000-FF-000430', NULL, 'Glycosyltransferase', 158, NULL, NULL, 198943),
(198944, '1.10.10.10-FF-000693', NULL, 'GntR family transcriptional regulator', 77, NULL, NULL, 198944),
(198945, '1.10.472.80-FF-000180', NULL, NULL, 139, NULL, NULL, 198945),
(198946, '1.10.287.70-FF-000128', NULL, 'Two-pore potassium channel 1', 109, NULL, NULL, 198946);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(198947, '2.40.50.140-FF-000551', NULL, 'Single-stranded DNA-binding protein', 125, NULL, NULL, 198947),
(198948, '2.60.40.3180-FF-000004', NULL, 'Transcription factor COE1', 243, NULL, NULL, 198948),
(198949, '3.30.40.10-FF-002033', NULL, 'Uncharacterized protein', 98, NULL, NULL, 198949),
(198950, '3.40.800.10-FF-000026', NULL, 'N(1)-aminopropylagmatine ureohydrolase', 279, NULL, NULL, 198950),
(198951, '3.30.160.60-FF-002399', NULL, 'Predicted protein', 69, NULL, NULL, 198951),
(198952, '1.50.40.10-FF-000131', NULL, 'Mitochondrial phosphate carrier protein 2', 205, NULL, NULL, 198952),
(198953, '3.30.160.60-FF-003742', NULL, NULL, 22, NULL, NULL, 198953),
(198954, '3.30.1370.50-FF-000028', NULL, 'Predicted protein', 75, NULL, NULL, 198954),
(198955, '1.25.40.1040-FF-000018', NULL, 'N-alpha-acetyltransferase 16, NatA auxiliary subunit isoform X2', 304, NULL, NULL, 198955),
(198956, '3.90.180.10-FF-000034', NULL, 'L-idonate 5-dehydrogenase', 167, NULL, NULL, 198956),
(198957, '1.10.630.10-FF-000038', NULL, 'Cytochrome P450 84A1', 483, NULL, NULL, 198957),
(198958, '2.60.120.650-FF-000195', NULL, 'Uncharacterized protein', 55, NULL, NULL, 198958),
(198959, '3.30.70.330-FF-002252', NULL, NULL, 109, NULL, NULL, 198959),
(198960, '2.160.20.10-FF-000268', NULL, 'Uncharacterized protein', 56, NULL, NULL, 198960),
(198961, '3.40.720.10-FF-000025', NULL, 'GPI ethanolamine phosphate transferase 3 isoform X1', 204, NULL, NULL, 198961),
(198962, '2.30.39.10-FF-000042', NULL, 'leukocyte elastase inhibitor-like isoform X1', 148, NULL, NULL, 198962),
(198963, '3.40.367.20-FF-000015', NULL, 'Phosphotransferase', 111, NULL, NULL, 198963),
(198964, '3.30.40.10-FF-001757', NULL, 'Ubiquitinyl hydrolase 1', 106, NULL, NULL, 198964),
(198965, '1.25.40.10-FF-000369', NULL, 'Signal recognition particle subunit SRP72', 110, NULL, NULL, 198965),
(198966, '3.80.10.10-FF-002512', NULL, 'Predicted protein', 146, NULL, NULL, 198966),
(198967, '1.20.1720.10-FF-000126', NULL, NULL, 216, NULL, NULL, 198967),
(198968, '3.10.560.10-FF-000002', NULL, 'Sugar ABC transporter substrate-binding protein', 84, NULL, NULL, 198968),
(198969, '3.30.1360.10-FF-000038', NULL, 'Putative DNA-directed RNA polymerase,alpha subunit', 144, NULL, NULL, 198969),
(198970, '3.90.640.10-FF-000114', NULL, 'Chaperone protein HscA homolog', 78, NULL, NULL, 198970),
(198971, '3.40.50.1010-FF-000054', NULL, 'Flap endonuclease GEN', 202, NULL, NULL, 198971),
(198972, '2.10.90.10-FF-000010', NULL, 'Platelet derived growth factor C', 166, NULL, NULL, 198972),
(198973, '3.40.190.10-FF-000506', NULL, 'Porphobilinogen deaminase', 98, NULL, NULL, 198973),
(198974, '1.20.1070.10-FF-000435', NULL, 'Olfactory receptor 6C2', 193, NULL, NULL, 198974),
(198975, '1.20.1610.10-FF-000011', NULL, 'Glycoside hydrolase family 92 protein', 178, NULL, NULL, 198975),
(198976, '1.10.40.30-FF-000015', NULL, 'Adenylosuccinate lyase', 73, NULL, NULL, 198976),
(198977, '2.30.110.10-FF-000024', NULL, 'Phenazine biosynthesis protein', 214, NULL, NULL, 198977),
(198978, '3.90.70.10-FF-000458', NULL, 'Uncharacterized protein', 91, NULL, NULL, 198978),
(198979, '1.10.287.3240-FF-000030', NULL, 'V-type proton ATPase subunit D', 196, NULL, NULL, 198979),
(198980, '2.60.120.330-FF-000161', NULL, 'Predicted protein', 332, NULL, NULL, 198980),
(198981, '1.25.10.10-FF-002571', NULL, 'Uncharacterized protein', 165, NULL, NULL, 198981),
(198982, '3.30.710.10-FF-000521', NULL, 'Uncharacterized protein', 100, NULL, NULL, 198982),
(198983, '1.10.287.130-FF-000113', NULL, 'PAS/PAC sensor hybrid histidine kinase', 78, NULL, NULL, 198983),
(198984, '2.70.160.11-FF-000008', NULL, 'Protein arginine N-methyltransferase 6', 205, NULL, NULL, 198984),
(198985, '3.40.30.10-FF-000036', NULL, 'anterior gradient protein 2 homolog', 141, NULL, NULL, 198985),
(198986, '2.40.50.140-FF-000276', NULL, 'aspartate--tRNA ligase, mitochondrial isoform X1', 104, NULL, NULL, 198986),
(198987, '3.40.640.10-FF-000367', NULL, 'Serine--pyruvate aminotransferase', 208, NULL, NULL, 198987),
(198988, '3.30.200.20-FF-002239', NULL, 'Predicted protein', 33, NULL, NULL, 198988);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(198989, '1.10.10.10-FF-000766', NULL, 'MarR family transcriptional regulator', 150, NULL, NULL, 198989),
(198990, '1.20.1250.20-FF-000256', NULL, 'Protein NRT1/ PTR FAMILY 8.3', 512, NULL, NULL, 198990),
(198991, '3.10.310.10-FF-000068', NULL, 'Diaminopimelate epimerase chloroplastic', 73, NULL, NULL, 198991),
(198992, '1.20.1070.10-FF-000216', NULL, 'Relaxin family peptide receptor 3', 311, NULL, NULL, 198992),
(198993, '1.25.40.10-FF-002847', NULL, 'Pentatricopeptide repeat-containing protein', 118, NULL, NULL, 198993),
(198994, '3.40.50.300-FF-007492', NULL, 'DNA helicase', 227, NULL, NULL, 198994),
(198995, '3.40.50.150-FF-001028', NULL, NULL, 177, NULL, NULL, 198995),
(198996, '2.60.120.200-FF-000083', NULL, 'FAT atypical cadherin 4', 149, NULL, NULL, 198996),
(198997, '3.90.110.10-FF-000035', NULL, NULL, 117, NULL, NULL, 198997),
(198998, '3.40.50.1000-FF-000866', NULL, NULL, 21, NULL, NULL, 198998),
(198999, '3.90.1030.10-FF-000016', NULL, '50S ribosomal protein L17', 124, NULL, NULL, 198999),
(199000, '3.40.50.2300-FF-001200', NULL, NULL, 107, NULL, NULL, 199000),
(199001, '1.25.40.820-FF-000006', NULL, 'Putative RNA polymerase II subunit B1 CTD phosphatase RPAP2 homolog', 135, NULL, NULL, 199001),
(199002, '3.20.20.80-FF-000181', NULL, 'Beta-galactosidase', 319, NULL, NULL, 199002),
(199003, '2.60.40.10-FF-001168', NULL, 'Usherin', 91, NULL, NULL, 199003),
(199004, '1.10.8.720-FF-000010', NULL, 'Dynein heavy chain, putative', 166, NULL, NULL, 199004),
(199005, '3.40.390.10-FF-000038', NULL, 'Metalloendopeptidase', 198, NULL, NULL, 199005),
(199006, '3.90.1150.80-FF-000001', NULL, 'Chromosome segregation protein (Pcs1)', 110, NULL, NULL, 199006),
(199007, '1.10.287.2720-FF-000003', NULL, 'Oxysterol binding protein', 71, NULL, NULL, 199007),
(199008, '1.25.40.10-FF-005102', NULL, 'Serine/threonine-protein kinase TOR', 298, NULL, NULL, 199008),
(199009, '3.40.50.300-FF-006379', NULL, 'RAS related protein, putative', 136, NULL, NULL, 199009),
(199010, '2.60.40.10-FF-001224', NULL, 'Immunoglobulin superfamily member 10', 97, NULL, NULL, 199010),
(199011, '1.10.287.1490-FF-000010', NULL, 'Ribosome binding protein 1', 184, NULL, NULL, 199011),
(199012, '2.130.10.10-FF-003512', NULL, 'Probable U3 small nucleolar RNA-associated protein 13', 150, NULL, NULL, 199012),
(199013, '1.20.120.1880-FF-000013', NULL, 'Uncharacterized protein', 282, NULL, NULL, 199013),
(199014, '2.40.30.10-FF-000494', NULL, 'Uncharacterized protein', 115, NULL, NULL, 199014),
(199015, '2.60.120.200-FF-000206', NULL, 'MAM and LDL-receptor class A domain-containing protein 1', 166, NULL, NULL, 199015),
(199016, '3.80.10.10-FF-000191', NULL, 'Leucine rich repeats and guanylate kinase domain containing', 120, NULL, NULL, 199016),
(199017, '2.40.70.10-FF-000266', NULL, 'Aspartyl protease family protein', 172, NULL, NULL, 199017),
(199018, '3.30.40.10-FF-000127', NULL, 'E3 ubiquitin-protein ligase RNF181', 84, NULL, NULL, 199018),
(199019, '3.40.190.10-FF-000905', NULL, 'Predicted protein', 248, NULL, NULL, 199019),
(199020, '2.10.280.10-FF-000001', NULL, 'Gp12 Short tail fibers', 41, NULL, NULL, 199020),
(199021, '3.10.20.90-FF-000729', NULL, 'Uncharacterized protein', 72, NULL, NULL, 199021),
(199022, '2.60.40.420-FF-000229', NULL, 'Uncharacterized protein', 181, NULL, NULL, 199022),
(199023, '1.20.142.10-FF-000008', NULL, 'Poly [ADP-ribose] polymerase', 127, NULL, NULL, 199023),
(199024, '3.90.640.10-FF-000058', NULL, 'Heat shock 70 kDa protein', 76, NULL, NULL, 199024),
(199025, '2.40.40.20-FF-000031', NULL, 'Arginine N-succinyltransferase', 65, NULL, NULL, 199025),
(199026, '3.40.50.1820-FF-000319', NULL, 'Serine hydrolase (FSH1)', 216, NULL, NULL, 199026),
(199027, '1.10.10.10-FF-000985', NULL, 'U5 small nuclear ribonucleoprotein helicase, putative', 91, NULL, NULL, 199027),
(199028, '3.30.40.10-FF-000739', NULL, 'P-loop containing nucleoside triphosphate hydrolases superfamily protein', 157, NULL, NULL, 199028),
(199029, '1.25.40.660-FF-000025', NULL, 'Uncharacterized protein', 78, NULL, NULL, 199029),
(199030, '2.40.50.140-FF-000225', NULL, 'tyrosine--tRNA ligase, cytoplasmic', 169, NULL, NULL, 199030);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(199031, '1.20.990.10-FF-000017', NULL, 'NADPH--cytochrome P450 reductase', 140, NULL, NULL, 199031),
(199032, '1.10.150.50-FF-000103', NULL, 'Bicaudal C, isoform B', 69, NULL, NULL, 199032),
(199033, '3.40.50.300-FF-007615', NULL, 'DEAD-box helicase 3 X-linked b', 152, NULL, NULL, 199033),
(199034, '3.40.50.1910-FF-000015', NULL, 'Syntaxin binding protein, putative', 79, NULL, NULL, 199034),
(199035, '2.40.240.130-FF-000008', NULL, 'Axin-like protein pry-1', 82, NULL, NULL, 199035),
(199036, '1.10.600.10-FF-000137', NULL, 'Uncharacterized protein', 126, NULL, NULL, 199036),
(199037, '1.25.10.10-FF-002790', NULL, 'Phospholipase A-2-activating protein-like Protein', 265, NULL, NULL, 199037),
(199038, '2.130.10.10-FF-002669', NULL, 'Uncharacterized protein', 293, NULL, NULL, 199038),
(199039, '3.30.1520.10-FF-000192', NULL, 'Phopholipase D, putative', 61, NULL, NULL, 199039),
(199040, '3.30.70.940-FF-000012', NULL, 'Transcription elongation factor SPT5', 100, NULL, NULL, 199040),
(199041, '2.60.40.420-FF-000162', NULL, 'Blue (Type 1) copper domain protein', 44, NULL, NULL, 199041),
(199042, '2.60.9.10-FF-000001', NULL, 'oxytocin-neurophysin 1', 88, NULL, NULL, 199042),
(199043, '3.30.70.330-FF-000739', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 100, NULL, NULL, 199043),
(199044, '3.30.1010.10-FF-000052', NULL, 'ATR serine/threonine kinase', 103, NULL, NULL, 199044),
(199045, '3.30.450.20-FF-000537', NULL, 'Uncharacterized protein', 90, NULL, NULL, 199045),
(199046, '3.40.50.620-FF-000505', NULL, 'Deoxyribodipyrimidine photolyase, type II', 149, NULL, NULL, 199046),
(199047, '1.20.1250.20-FF-000531', NULL, 'Major Facilitator Superfamily protein', 416, NULL, NULL, 199047),
(199048, '3.40.1280.10-FF-000108', NULL, 'Os01g0742000 protein', 128, NULL, NULL, 199048),
(199049, '2.40.50.140-FF-000495', NULL, 'Single-stranded TG1-3 telomere G-tails binding protein', 199, NULL, NULL, 199049),
(199050, '1.10.10.10-FF-001261', NULL, 'DNA helicase', 87, NULL, NULL, 199050),
(199051, '3.30.70.990-FF-000004', NULL, 'UPF0234 protein CbuK_1936', 85, NULL, NULL, 199051),
(199052, '1.10.510.10-FF-000310', NULL, 'Serine/threonine-protein kinase HT1', 186, NULL, NULL, 199052),
(199053, '1.20.140.10-FF-000116', NULL, 'Acyl-coenzyme A oxidase', 131, NULL, NULL, 199053),
(199054, '3.30.260.10-FF-000048', NULL, 'Chaperonin HSP60/CNP60, putative', 92, NULL, NULL, 199054),
(199055, '2.30.29.30-FF-000665', NULL, 'FACT complex subunit SSRP1', 93, NULL, NULL, 199055),
(199056, '3.80.10.10-FF-000039', NULL, 'slit homolog 2 protein isoform X2', 117, NULL, NULL, 199056),
(199057, '1.10.10.10-FF-000367', NULL, 'Heat stress transcription factor A-8', 97, NULL, NULL, 199057),
(199058, '2.60.120.260-FF-000258', NULL, 'Glycine-, glutamate-, thienylcyclohexylpiperidine-binding protein', 152, NULL, NULL, 199058),
(199059, '2.60.40.60-FF-000300', NULL, 'Cadherin related family member 4', 105, NULL, NULL, 199059),
(199060, '3.40.50.720-FF-002008', NULL, 'Tetraketide alpha-pyrone reductase 1', 223, NULL, NULL, 199060),
(199061, '2.60.40.10-FF-001443', NULL, 'Interleukin-7 receptor subunit alpha', 110, NULL, NULL, 199061),
(199062, '2.40.50.90-FF-000187', NULL, 'Uncharacterized protein', 70, NULL, NULL, 199062),
(199063, '3.90.360.10-FF-000020', NULL, 'Histone acetyltransferase 1', 84, NULL, NULL, 199063),
(199064, '3.30.710.10-FF-000302', NULL, 'Zinc finger and BTB domain containing 48', 142, NULL, NULL, 199064),
(199065, '3.20.20.60-FF-000023', NULL, 'CitE, Citrate lyase beta subunit', 304, NULL, NULL, 199065),
(199066, '3.40.630.10-FF-000193', NULL, 'Putative glutaminyl cyclase', 117, NULL, NULL, 199066),
(199067, '2.10.220.10-FF-000189', NULL, 'Uncharacterized protein', 63, NULL, NULL, 199067),
(199068, '3.60.15.10-FF-000129', NULL, 'N-acyl-phosphatidylethanolamine-hydrolyzing phospholipase D', 324, NULL, NULL, 199068),
(199069, '3.90.1280.20-FF-000010', NULL, NULL, 65, NULL, NULL, 199069),
(199070, '3.40.850.10-FF-000181', NULL, 'Kinesin family member 20Ba', 118, NULL, NULL, 199070),
(199071, '3.30.1540.20-FF-000027', NULL, NULL, 80, NULL, NULL, 199071);
INSERT INTO "PUBLIC"."MODEL" VALUES
(199072, '2.40.50.140-FF-000837', NULL, NULL, 77, NULL, NULL, 199072),
(199073, '3.40.50.620-FF-000910', NULL, 'Arginyl-tRNA synthetase', 44, NULL, NULL, 199073),
(199074, '3.40.50.300-FF-001657', NULL, 'ADP-ribosylation factor-like protein 5A isoform X2', 173, NULL, NULL, 199074),
(199075, '2.70.70.10-FF-000017', NULL, 'Peptidase, M23 family', 142, NULL, NULL, 199075),
(199076, '3.60.10.10-FF-000433', NULL, 'Uncharacterized protein', 38, NULL, NULL, 199076),
(199077, '3.40.50.790-FF-000011', NULL, 'Unplaced genomic scaffold supercont1.18, whole genome shotgun sequence', 100, NULL, NULL, 199077),
(199078, '2.70.70.10-FF-000074', NULL, 'EppA', 134, NULL, NULL, 199078),
(199079, '3.80.10.10-FF-000533', NULL, 'Leucine rich repeats and death domain containing 1', 113, NULL, NULL, 199079),
(199080, '1.10.630.10-FF-000257', NULL, 'Os02g0503850 protein', 124, NULL, NULL, 199080),
(199081, '3.30.1460.20-FF-000026', NULL, 'Uncharacterized protein', 69, NULL, NULL, 199081),
(199082, '1.10.1410.40-FF-000018', NULL, 'Predicted protein', 68, NULL, NULL, 199082),
(199083, '3.90.25.10-FF-000033', NULL, 'NmrA family transcriptional regulator, putative', 97, NULL, NULL, 199083),
(199084, '3.30.760.10-FF-000013', NULL, 'eukaryotic translation initiation factor 4E type 3', 118, NULL, NULL, 199084),
(199085, '1.25.40.20-FF-001092', NULL, 'Fibronectin type III and ankyrin repeat domains 1', 91, NULL, NULL, 199085),
(199086, '1.20.120.610-FF-000002', NULL, 'V-type proton ATPase proteolipid subunit', 161, NULL, NULL, 199086),
(199087, '2.60.120.260-FF-000078', NULL, 'DAL2p Allantoicase', 180, NULL, NULL, 199087),
(199088, '1.10.390.10-FF-000103', NULL, 'cDNA FLJ51269, highly similar to Aminopeptidase N', 63, NULL, NULL, 199088),
(199089, '3.40.50.150-FF-001410', NULL, NULL, 162, NULL, NULL, 199089),
(199090, '3.30.200.20-FF-002565', NULL, NULL, 32, NULL, NULL, 199090),
(199091, '3.10.20.230-FF-000030', NULL, 'AT13713p', 104, NULL, NULL, 199091),
(199092, '4.10.1060.10-FF-000064', NULL, 'Uncharacterized protein', 40, NULL, NULL, 199092),
(199093, '3.40.50.720-FF-001839', NULL, 'D-3-phosphoglycerate dehydrogenase 2 chloroplastic', 91, NULL, NULL, 199093),
(199094, '3.30.310.10-FF-000030', NULL, 'Coatomer subunit gamma', 117, NULL, NULL, 199094),
(199095, '3.30.1330.40-FF-000028', NULL, 'ATP binding L-PSP endoribonuclease family protein', 107, NULL, NULL, 199095),
(199096, '1.20.1440.80-FF-000007', NULL, 'Gap junction delta-4 protein', 205, NULL, NULL, 199096),
(199097, '3.40.50.150-FF-001354', NULL, NULL, 190, NULL, NULL, 199097),
(199098, '1.20.120.620-FF-000005', NULL, 'Sensor histidine kinase KdpD', 103, NULL, NULL, 199098),
(199099, '3.40.50.300-FF-007110', NULL, 'Rab_C89 protein', 186, NULL, NULL, 199099),
(199100, '1.20.58.1070-FF-000004', NULL, 'Gem-associated protein 2', 187, NULL, NULL, 199100),
(199101, '1.10.510.10-FF-001327', NULL, 'Serine/threonine-protein kinase ELM1', 312, NULL, NULL, 199101),
(199102, '1.10.10.2430-FF-000004', NULL, 'Uncharacterized protein', 94, NULL, NULL, 199102),
(199103, '3.90.650.10-FF-000053', NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase chloroplastic', 91, NULL, NULL, 199103),
(199104, '3.40.1110.10-FF-000433', NULL, NULL, 108, NULL, NULL, 199104),
(199105, '3.40.630.40-FF-000027', NULL, 'Gll1363 protein', 215, NULL, NULL, 199105),
(199106, '3.30.450.20-FF-000206', NULL, 'PAS domain-containing serine/threonine-protein kinase', 111, NULL, NULL, 199106),
(199107, '3.90.79.10-FF-000219', NULL, 'Uncharacterized protein', 162, NULL, NULL, 199107),
(199108, '3.40.50.620-FF-000056', NULL, 'Leucine--tRNA ligase', 203, NULL, NULL, 199108),
(199109, '3.40.630.30-FF-000024', NULL, '[Citrate [pro-3S]-lyase] ligase', 121, NULL, NULL, 199109),
(199110, '3.30.700.40-FF-000001', NULL, 'Methylcrotonoyl-CoA carboxylase subunit alpha, mitochondrial', 138, NULL, NULL, 199110),
(199111, '2.10.110.10-FF-000074', NULL, 'Rho-type GTPase-activating protein 1', 40, NULL, NULL, 199111),
(199112, '2.30.30.190-FF-000030', NULL, 'Uncharacterized protein', 80, NULL, NULL, 199112),
(199113, '3.30.200.20-FF-001003', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 99, NULL, NULL, 199113);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(199114, '1.20.58.1060-FF-000001', NULL, 'dystonin isoform X2', 151, NULL, NULL, 199114),
(199115, '3.40.50.2300-FF-000076', NULL, 'Regulator of RpoS', 130, NULL, NULL, 199115),
(199116, '3.30.1330.30-FF-000025', NULL, 'rRNA methyltransferase 1, mitochondrial', 89, NULL, NULL, 199116),
(199117, '3.40.630.20-FF-000021', NULL, 'Uncharacterized protein', 221, NULL, NULL, 199117),
(199118, '3.30.70.360-FF-000046', NULL, 'Clan MH, family M20, peptidase T-like metallopeptidase', 115, NULL, NULL, 199118),
(199119, '3.90.105.20-FF-000003', NULL, 'Ribosome assembly factor mrt4', 84, NULL, NULL, 199119),
(199120, '1.20.1250.20-FF-000823', NULL, 'Inorganic phosphate transporter PHO84', 442, NULL, NULL, 199120),
(199121, '3.90.550.20-FF-000003', NULL, 'Lactosylceramide 4-alpha-galactosyltransferase', 194, NULL, NULL, 199121),
(199122, '2.30.40.10-FF-000017', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 79, NULL, NULL, 199122),
(199123, '2.70.70.10-FF-000068', NULL, 'Cell wall hydrolase', 133, NULL, NULL, 199123),
(199124, '3.30.43.10-FF-000038', NULL, 'Uncharacterized protein', 87, NULL, NULL, 199124),
(199125, '3.50.50.60-FF-000625', NULL, 'Nitrate reductase, NADH oxidase subunit', 151, NULL, NULL, 199125),
(199126, '3.30.70.960-FF-000018', NULL, 'Mucin 16', 67, NULL, NULL, 199126),
(199127, '2.60.40.10-FF-002860', NULL, 'Sialoadhesin', 100, NULL, NULL, 199127),
(199128, '3.40.50.720-FF-000316', NULL, 'Mannitol-1-phosphate 5-dehydrogenase', 206, NULL, NULL, 199128),
(199129, '2.10.110.10-FF-000068', NULL, 'Insulin gene enhancer protein ISL-2', 64, NULL, NULL, 199129),
(199130, '1.20.58.60-FF-000603', NULL, 'Microtubule actin crosslinking factor 1a', 136, NULL, NULL, 199130),
(199131, '2.10.25.10-FF-000382', NULL, 'Adhesion G protein-coupled receptor E2', 38, NULL, NULL, 199131),
(199132, '3.40.718.10-FF-000025', NULL, 'Isocitrate dehydrogenase [NADP]', 414, NULL, NULL, 199132),
(199133, '1.20.1250.20-FF-002004', NULL, 'Sugar transporter, putative', 378, NULL, NULL, 199133),
(199134, '2.30.30.790-FF-000002', NULL, '39S ribosomal protein L19, mitochondrial', 122, NULL, NULL, 199134),
(199135, '3.30.70.330-FF-002813', NULL, NULL, 146, NULL, NULL, 199135),
(199136, '1.20.1070.10-FF-000722', NULL, 'Uncharacterized protein', 97, NULL, NULL, 199136),
(199137, '1.20.58.1970-FF-000004', NULL, 'Exocyst complex component SEC10a', 161, NULL, NULL, 199137),
(199138, '2.130.10.10-FF-004636', NULL, 'Uncharacterized protein', 195, NULL, NULL, 199138),
(199139, '3.30.70.330-FF-001234', NULL, 'RNA recognition motif domain containing protein', 100, NULL, NULL, 199139),
(199140, '2.10.25.10-FF-000106', NULL, 'Heparan sulfate proteoglycan 2', 77, NULL, NULL, 199140),
(199141, '3.30.70.330-FF-002920', NULL, NULL, 168, NULL, NULL, 199141),
(199142, '3.30.420.60-FF-000019', NULL, 'Protein pelota homolog', 109, NULL, NULL, 199142),
(199143, '2.60.120.830-FF-000002', NULL, 'ADAMTS like 1', 130, NULL, NULL, 199143),
(199144, '3.40.50.1700-FF-000053', NULL, 'Beta-glucosidase BoGH3A', 271, NULL, NULL, 199144),
(199145, '1.10.150.50-FF-000215', NULL, 'Uncharacterized protein', 82, NULL, NULL, 199145),
(199146, '1.10.510.10-FF-001384', NULL, 'C-type lectin', 203, NULL, NULL, 199146),
(199147, '3.90.25.10-FF-000090', NULL, 'Uncharacterized protein', 84, NULL, NULL, 199147),
(199148, '1.25.50.20-FF-000024', NULL, 'Aminopeptidase', 326, NULL, NULL, 199148),
(199149, '2.60.120.200-FF-000318', NULL, 'Protein S', 199, NULL, NULL, 199149),
(199150, '3.30.450.20-FF-000189', NULL, 'AGAP000773-PA', 143, NULL, NULL, 199150),
(199151, '1.25.10.10-FF-002784', NULL, 'CAMK family protein kinase', 306, NULL, NULL, 199151),
(199152, '1.20.120.1750-FF-000098', NULL, 'RBR-type E3 ubiquitin transferase', 85, NULL, NULL, 199152),
(199153, '1.10.510.10-FF-001440', NULL, 'Protein kinase, putative', 143, NULL, NULL, 199153),
(199154, '3.40.190.10-FF-000950', NULL, 'Dipeptide binding protein', 285, NULL, NULL, 199154),
(199155, '1.25.10.10-FF-003352', NULL, 'Uncharacterized protein', 206, NULL, NULL, 199155),
(199156, '2.60.120.780-FF-000003', NULL, 'MIZ zinc finger protein, variant', 144, NULL, NULL, 199156);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(199157, '4.10.60.10-FF-000127', NULL, 'Glycine-rich RNA-binding protein RZ1B', 65, NULL, NULL, 199157),
(199158, '1.25.10.10-FF-001261', NULL, 'Uncharacterized protein', 271, NULL, NULL, 199158),
(199159, '3.50.50.60-FF-000664', NULL, 'Flavin-containing monooxygenase, Fmo', 347, NULL, NULL, 199159),
(199160, '1.10.340.70-FF-000034', NULL, 'Uncharacterized protein', 80, NULL, NULL, 199160),
(199161, '1.10.357.30-FF-000015', NULL, NULL, 85, NULL, NULL, 199161),
(199162, '3.40.850.10-FF-000175', NULL, 'Myosin heavy chain 9', 193, NULL, NULL, 199162),
(199163, '2.60.120.200-FF-000605', NULL, 'Uncharacterized protein', 154, NULL, NULL, 199163),
(199164, '3.40.390.10-FF-000095', NULL, 'Metalloendopeptidase', 170, NULL, NULL, 199164),
(199165, '3.90.1030.10-FF-000022', NULL, 'Ribosomal protein L17', 121, NULL, NULL, 199165),
(199166, '2.20.25.100-FF-000001', NULL, '40S ribosomal protein S27', 84, NULL, NULL, 199166),
(199167, '3.30.460.10-FF-000030', NULL, 'Putative GTP diphosphokinase RSH2 chloroplastic', 136, NULL, NULL, 199167),
(199168, '1.10.510.10-FF-003525', NULL, NULL, 244, NULL, NULL, 199168),
(199169, '1.10.238.10-FF-000789', NULL, 'Calpain 13', 168, NULL, NULL, 199169),
(199170, '2.10.25.10-FF-001629', NULL, 'Uncharacterized protein', 80, NULL, NULL, 199170),
(199171, '3.30.70.330-FF-000627', NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', 165, NULL, NULL, 199171),
(199172, '3.40.50.80-FF-000137', NULL, 'Probable metalloreductase AIM14', 177, NULL, NULL, 199172),
(199173, '1.20.58.2190-FF-000003', NULL, 'UBX domain-containing protein 6 isoform 1', 107, NULL, NULL, 199173),
(199174, '2.60.40.1850-FF-000004', NULL, 'Sortase B protein-sorting domain-containing protein', 144, NULL, NULL, 199174),
(199175, '1.25.40.180-FF-000033', NULL, 'Regulator of nonsense transcripts UPF2', 309, NULL, NULL, 199175),
(199176, '3.40.50.1820-FF-000651', NULL, 'Clan SC, family S28, unassigned serine peptidase', 285, NULL, NULL, 199176),
(199177, '6.10.140.2220-FF-000004', NULL, 'ubiquitin carboxyl-terminal hydrolase 19 isoform X9', 56, NULL, NULL, 199177),
(199178, '3.40.50.300-FF-007054', NULL, 'N-deacetylase/N-sulfotransferase (heparan glucosaminyl) 3', 198, NULL, NULL, 199178),
(199179, '3.80.10.10-FF-004081', NULL, 'Protein lap1', 297, NULL, NULL, 199179),
(199180, '3.30.230.10-FF-000260', NULL, 'Ribosomal protein S9/S16', 127, NULL, NULL, 199180),
(199181, '1.25.10.10-FF-000547', NULL, 'Dynein assembly factor 5, axonemal', 200, NULL, NULL, 199181),
(199182, '1.20.58.1120-FF-000042', NULL, NULL, 155, NULL, NULL, 199182),
(199183, '3.40.50.300-FF-003512', NULL, '6-phosphofructo-2-kinase/fructose-2, 6-biphosphatase, putative', 200, NULL, NULL, 199183),
(199184, '1.10.8.10-FF-000107', NULL, 'Vacuolar protein sorting 13 homolog D', 40, NULL, NULL, 199184),
(199185, '1.10.3430.10-FF-000045', NULL, 'Ammonium transporter, putative', 175, NULL, NULL, 199185),
(199186, '1.10.510.10-FF-003418', NULL, NULL, 292, NULL, NULL, 199186),
(199187, '3.50.7.10-FF-000017', NULL, 'Bardet-Biedl syndrome 10 protein', 156, NULL, NULL, 199187),
(199188, '3.40.225.10-FF-000026', NULL, 'Ribulose-5-phosphate 4-epimerase and related epimerase and aldolase', 188, NULL, NULL, 199188),
(199189, '3.30.40.10-FF-000745', NULL, 'Chromatin modification-related protein', 59, NULL, NULL, 199189),
(199190, '2.60.40.1390-FF-000001', NULL, 'Myelin gene regulatory factor', 81, NULL, NULL, 199190),
(199191, '1.20.1070.10-FF-000609', NULL, 'Si:dkey-6n21.13', 334, NULL, NULL, 199191),
(199192, '2.10.25.10-FF-001686', NULL, 'Uncharacterized protein', 44, NULL, NULL, 199192),
(199193, '2.130.10.10-FF-005311', NULL, 'DmX-like protein 2', 207, NULL, NULL, 199193),
(199194, '3.40.50.1000-FF-000467', NULL, 'Phosphoserine phosphatase (SerB)', 207, NULL, NULL, 199194),
(199195, '1.10.10.10-FF-001530', NULL, 'Uncharacterized protein', 93, NULL, NULL, 199195),
(199196, '1.20.58.1080-FF-000007', NULL, 'RNA helicase like protein, putative', 142, NULL, NULL, 199196),
(199197, '3.30.160.60-FF-001505', NULL, 'Zinc finger protein 540', 27, NULL, NULL, 199197);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(199198, '6.10.140.2210-FF-000001', NULL, 'Putative e3 ubiquitin-protein ligase hakai', 42, NULL, NULL, 199198),
(199199, '3.80.10.10-FF-002843', NULL, 'Leucine Rich Repeat family protein', 176, NULL, NULL, 199199),
(199200, '3.10.350.10-FF-000071', NULL, 'Predicted protein', 47, NULL, NULL, 199200),
(199201, '1.20.1250.20-FF-000082', NULL, 'MFS multidrug transporter, putative', 429, NULL, NULL, 199201),
(199202, '3.40.50.460-FF-000042', NULL, 'Uncharacterized protein', 62, NULL, NULL, 199202),
(199203, '3.40.525.10-FF-000066', NULL, 'Clavesin 1', 130, NULL, NULL, 199203),
(199204, '2.60.40.10-FF-002747', NULL, 'Ig kappa chain V region GOM', 113, NULL, NULL, 199204),
(199205, '3.80.10.10-FF-003299', NULL, 'Uncharacterized protein', 166, NULL, NULL, 199205),
(199206, '3.60.10.10-FF-000141', NULL, 'Endonuclease/Exonuclease/phosphatase family, putative', 352, NULL, NULL, 199206),
(199207, '3.40.50.10190-FF-000064', NULL, 'Protein BREAST CANCER SUSCEPTIBILITY 1 like', 108, NULL, NULL, 199207),
(199208, '3.40.640.10-FF-000255', NULL, 'DegT/DnrJ/EryC1/StrS family aminotransferase', 257, NULL, NULL, 199208),
(199209, '2.60.120.380-FF-000041', NULL, 'Calpain-like protease palB/RIM13', 144, NULL, NULL, 199209),
(199210, '1.20.58.60-FF-000660', NULL, 'Uncharacterized protein', 102, NULL, NULL, 199210),
(199211, '3.40.850.10-FF-000068', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', 357, NULL, NULL, 199211),
(199212, '3.40.640.10-FF-000199', NULL, 'Glycine dehydrogenase [decarboxylating], mitochondrial', 72, NULL, NULL, 199212),
(199213, '3.40.50.300-FF-007840', NULL, 'Uncharacterized protein', 233, NULL, NULL, 199213),
(199214, '3.40.50.10490-FF-000103', NULL, 'Uncharacterized protein', 301, NULL, NULL, 199214),
(199215, '2.130.10.10-FF-003332', NULL, 'Uncharacterized protein', 293, NULL, NULL, 199215),
(199216, '3.80.10.10-FF-000483', NULL, 'NLR family, CARD domain-containing 3', 111, NULL, NULL, 199216),
(199217, '3.40.50.1000-FF-000574', NULL, NULL, 132, NULL, NULL, 199217),
(199218, '3.40.720.10-FF-000351', NULL, 'Predicted protein', 264, NULL, NULL, 199218),
(199219, '2.115.10.20-FF-000004', NULL, 'Glucosamine inositolphosphorylceramide transferase 1', 158, NULL, NULL, 199219),
(199220, '1.50.10.20-FF-000126', NULL, 'Uncharacterized protein', 65, NULL, NULL, 199220),
(199221, '2.60.40.60-FF-000935', NULL, 'Uncharacterized protein', 109, NULL, NULL, 199221),
(199222, '1.10.286.10-FF-000007', NULL, 'GTP cyclohydrolase 1', 51, NULL, NULL, 199222),
(199223, '1.10.486.10-FF-000051', NULL, 'DNA helicase', 144, NULL, NULL, 199223),
(199224, '2.130.10.10-FF-003220', NULL, 'Periodic tryptophan protein 2-like protein', 315, NULL, NULL, 199224),
(199225, '1.10.510.10-FF-003800', NULL, NULL, 124, NULL, NULL, 199225),
(199226, '2.60.15.10-FF-000019', NULL, 'ATP synthase epsilon chain', 129, NULL, NULL, 199226),
(199227, '2.20.25.80-FF-000003', NULL, 'WRKY transcription factor 57', 75, NULL, NULL, 199227),
(199228, '3.30.40.10-FF-000852', NULL, 'Histone-lysine N-methyltransferase 2C', 111, NULL, NULL, 199228),
(199229, '3.80.10.10-FF-000713', NULL, 'Receptor-like protein 48', 174, NULL, NULL, 199229),
(199230, '3.40.50.300-FF-005816', NULL, 'Helicase, putative', 243, NULL, NULL, 199230),
(199231, '3.40.50.300-FF-001365', NULL, 'Regulator of telomere elongation helicase 1 homolog', 241, NULL, NULL, 199231),
(199232, '3.30.479.20-FF-000002', NULL, 'Elongation factor Ts', 70, NULL, NULL, 199232),
(199233, '1.25.40.10-FF-000375', NULL, 'Sperm associated antigen 1', 155, NULL, NULL, 199233),
(199234, '3.30.920.20-FF-000006', NULL, NULL, 46, NULL, NULL, 199234),
(199235, '3.40.50.300-FF-000022', NULL, 'Signal recognition particle 54 kDa subunit', 195, NULL, NULL, 199235),
(199236, '2.60.40.1840-FF-000001', NULL, 'Aminopeptidase N', 102, NULL, NULL, 199236),
(199237, '1.20.1070.10-FF-002072', NULL, 'G-protein coupled receptor, putative', 66, NULL, NULL, 199237),
(199238, '1.25.40.20-FF-001833', NULL, 'Uncharacterized protein', 148, NULL, NULL, 199238),
(199239, '3.30.920.10-FF-000003', NULL, 'Frataxin, mitochondrial', 119, NULL, NULL, 199239);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(199240, '3.40.50.10090-FF-000034', NULL, 'Uroporphyrinogen III synthase HEM4', 120, NULL, NULL, 199240),
(199241, '3.20.20.140-FF-000450', NULL, 'Chromosome 7, whole genome shotgun sequence', 30, NULL, NULL, 199241),
(199242, '2.40.128.630-FF-000002', NULL, 'Cell surface protein', 125, NULL, NULL, 199242),
(199243, '3.30.479.30-FF-000005', NULL, 'Protease modulator HflC', 138, NULL, NULL, 199243),
(199244, '2.40.70.10-FF-000558', NULL, NULL, 185, NULL, NULL, 199244),
(199245, '2.20.25.90-FF-000006', NULL, 'Formate dehydrogenase alpha subunit', 63, NULL, NULL, 199245),
(199246, '2.60.120.200-FF-000375', NULL, 'Lys-gingipain', 163, NULL, NULL, 199246),
(199247, '1.20.58.1510-FF-000001', NULL, 'ATPase RavA', 95, NULL, NULL, 199247),
(199248, '2.30.30.140-FF-000330', NULL, 'Bromodomain and PHD finger-containing, 3', 50, NULL, NULL, 199248),
(199249, '3.30.710.10-FF-000246', NULL, 'T0060006 isoform 1', 61, NULL, NULL, 199249),
(199250, '3.30.160.60-FF-003181', NULL, 'Zinc finger protein 529', 26, NULL, NULL, 199250),
(199251, '1.25.40.10-FF-001830', NULL, 'Os01g0913400 protein', 71, NULL, NULL, 199251),
(199252, '3.30.420.40-FF-000755', NULL, 'Uncharacterized protein', 96, NULL, NULL, 199252),
(199253, '1.10.275.10-FF-000021', NULL, 'Aspartate ammonium lyase', 138, NULL, NULL, 199253),
(199254, '2.60.40.10-FF-003242', NULL, 'Class II cytokine receptor crfb8', 110, NULL, NULL, 199254),
(199255, '1.20.1070.10-FF-002015', NULL, 'Uncharacterized protein', 134, NULL, NULL, 199255),
(199256, '2.10.109.10-FF-000003', NULL, 'Signal peptidase complex catalytic subunit SEC11', 105, NULL, NULL, 199256),
(199257, '3.40.190.10-FF-000731', NULL, 'Predicted protein', 110, NULL, NULL, 199257),
(199258, '3.90.1010.10-FF-000021', NULL, 'Nitrogen fixation protein NifU', 127, NULL, NULL, 199258),
(199259, '2.130.10.10-FF-002495', NULL, 'Peptidyl-prolyl cis-trans isomerase, putative (AFU_orthologue AFUA_1G01750)', 150, NULL, NULL, 199259),
(199260, '2.10.25.10-FF-000163', NULL, 'laminin subunit gamma-1', 50, NULL, NULL, 199260),
(199261, '1.20.58.1520-FF-000004', NULL, 'Spindle midzone component', 132, NULL, NULL, 199261),
(199262, '3.40.50.2300-FF-000930', NULL, NULL, 206, NULL, NULL, 199262),
(199263, '3.10.20.770-FF-000017', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', 285, NULL, NULL, 199263),
(199264, '3.30.70.330-FF-002870', NULL, NULL, 74, NULL, NULL, 199264),
(199265, '3.40.50.720-FF-001896', NULL, 'Uncharacterized protein', 182, NULL, NULL, 199265),
(199266, '1.25.10.10-FF-002964', NULL, 'Uncharacterized protein', 427, NULL, NULL, 199266),
(199267, '3.30.450.20-FF-000245', NULL, 'C4-dicarboxylate transport sensor protein', 116, NULL, NULL, 199267),
(199268, '3.90.190.10-FF-000192', NULL, 'MAP kinase phosphatase 6', 176, NULL, NULL, 199268),
(199269, '3.90.1530.10-FF-000004', NULL, 'Chromosome partitioning protein ParB', 108, NULL, NULL, 199269),
(199270, '1.50.10.10-FF-000180', NULL, 'Reducing-end xylose-releasing exo-oligoxylanase Rex8A', 373, NULL, NULL, 199270),
(199271, '2.130.10.10-FF-001707', NULL, 'DIGIT', 290, NULL, NULL, 199271),
(199272, '1.10.8.10-FF-000326', NULL, 'Uncharacterized protein', 49, NULL, NULL, 199272),
(199273, '3.40.50.300-FF-003456', NULL, 'Helicase, putative', 227, NULL, NULL, 199273),
(199274, '2.10.110.10-FF-000181', NULL, 'Rho-type GTPase-activating protein 1', 117, NULL, NULL, 199274),
(199275, '1.10.20.70-FF-000003', NULL, 'Polyadenylation factor subunit CstF64, putative', 46, NULL, NULL, 199275),
(199276, '3.40.50.410-FF-000049', NULL, 'von Willebrand factor A domain containing 8', 189, NULL, NULL, 199276),
(199277, '3.30.1370.10-FF-000196', NULL, 'LOC553525 protein', 40, NULL, NULL, 199277),
(199278, '1.20.1560.10-FF-000574', NULL, 'Uncharacterized protein', 569, NULL, NULL, 199278),
(199279, '1.10.3370.10-FF-000045', NULL, 'Uncharacterized protein', 156, NULL, NULL, 199279),
(199280, '1.25.10.10-FF-003239', NULL, 'Uncharacterized protein', 245, NULL, NULL, 199280),
(199281, '3.40.50.1860-FF-000016', NULL, 'Aspartate racemase', 108, NULL, NULL, 199281);
INSERT INTO "PUBLIC"."MODEL" VALUES
(199282, '1.10.10.10-FF-001148', NULL, 'Ribosomal protein', 101, NULL, NULL, 199282),
(199283, '2.40.70.10-FF-000491', NULL, NULL, 132, NULL, NULL, 199283),
(199284, '1.10.510.10-FF-001620', NULL, 'Protein CBG03054', 330, NULL, NULL, 199284),
(199285, '3.40.630.10-FF-000428', NULL, 'Bacterial leucyl aminopeptidase', 280, NULL, NULL, 199285),
(199286, '2.60.40.10-FF-001056', NULL, 'Striated muscle preferentially expressed protein kinase', 92, NULL, NULL, 199286),
(199287, '3.30.70.330-FF-002538', NULL, NULL, 46, NULL, NULL, 199287),
(199288, '2.60.40.10-FF-004984', NULL, NULL, 108, NULL, NULL, 199288),
(199289, '3.80.10.10-FF-000426', NULL, 'Follicle-stimulating hormone receptor-like Protein', 317, NULL, NULL, 199289),
(199290, '2.130.10.10-FF-002725', NULL, 'YALI0E01276p', 392, NULL, NULL, 199290),
(199291, '2.20.100.10-FF-000251', NULL, 'Uncharacterized protein', 47, NULL, NULL, 199291),
(199292, '3.30.300.320-FF-000003', NULL, 'Pappalysin 1', 116, NULL, NULL, 199292),
(199293, '2.60.40.1110-FF-000018', NULL, 'Uncharacterized protein', 16, NULL, NULL, 199293),
(199294, '1.20.5.4010-FF-000004', NULL, 'Held out wings-like protein', 64, NULL, NULL, 199294),
(199295, '1.25.40.20-FF-001272', NULL, 'Uncharacterized protein', 191, NULL, NULL, 199295),
(199296, '2.30.30.40-FF-000683', NULL, 'Predicted protein', 44, NULL, NULL, 199296),
(199297, '1.25.40.10-FF-004646', NULL, 'Uncharacterized protein', 123, NULL, NULL, 199297),
(199298, '3.30.70.330-FF-000447', NULL, 'Activator of basal transcription 1', 143, NULL, NULL, 199298),
(199299, '3.50.50.60-FF-000900', NULL, 'Flavin-containing monooxygenase', 98, NULL, NULL, 199299),
(199300, '2.60.40.10-FF-005327', NULL, NULL, 76, NULL, NULL, 199300),
(199301, '2.60.40.10-FF-001550', NULL, 'immunoglobulin superfamily member 22', 99, NULL, NULL, 199301),
(199302, '3.40.50.300-FF-005075', NULL, 'Blr1666 protein', 106, NULL, NULL, 199302),
(199303, '2.60.120.260-FF-000297', NULL, 'Ephrin receptor 1', 188, NULL, NULL, 199303),
(199304, '2.60.120.200-FF-000650', NULL, 'Novel protein similar to human EGF LAG seven-pass G-type receptor 1 cadherin (CELSR1)', 99, NULL, NULL, 199304),
(199305, '3.40.50.1820-FF-000432', NULL, 'Probable lignin peroxidase lipJ', 270, NULL, NULL, 199305),
(199306, '1.10.1040.10-FF-000048', NULL, 'Putative 2-hydroxy-3-oxopropionate reductase', 130, NULL, NULL, 199306),
(199307, '3.30.70.1730-FF-000019', NULL, '50S ribosomal protein L10', 135, NULL, NULL, 199307),
(199308, '3.80.10.10-FF-002063', NULL, 'Disease resistance protein RGA4', 341, NULL, NULL, 199308),
(199309, '3.40.47.10-FF-000305', NULL, 'Polyketide synthase', 542, NULL, NULL, 199309),
(199310, '2.130.10.10-FF-005018', NULL, 'Uncharacterized protein', 313, NULL, NULL, 199310),
(199311, '1.10.510.10-FF-001165', NULL, 'Protein kinase domain containing protein', 208, NULL, NULL, 199311),
(199312, '3.30.70.1990-FF-000013', NULL, NULL, 106, NULL, NULL, 199312),
(199313, '3.10.450.50-FF-000068', NULL, 'Ras-Gtpase-activating protein SH3 (Three) domain-Binding Protein', 124, NULL, NULL, 199313),
(199314, '1.20.120.1630-FF-000023', NULL, 'Phosphatidylethanolaminen-methyltransferase-lik e protein', 194, NULL, NULL, 199314),
(199315, '2.60.40.840-FF-000001', NULL, 'beta-arrestin-1 isoform X1', 175, NULL, NULL, 199315),
(199316, '3.50.50.60-FF-000389', NULL, '2-octaprenyl-6-methoxyphenyl hydroxylase', 154, NULL, NULL, 199316),
(199317, '2.10.110.10-FF-000304', NULL, 'Predicted protein', 44, NULL, NULL, 199317),
(199318, '3.30.430.20-FF-000031', NULL, 'Putative serine/threonine-specific protein kinase', 100, NULL, NULL, 199318),
(199319, '3.30.1370.10-FF-000213', NULL, 'AGAP004351-PA', 108, NULL, NULL, 199319),
(199320, '3.30.70.260-FF-000061', NULL, 'ACT domain repeat 1', 75, NULL, NULL, 199320),
(199321, '3.30.200.20-FF-000547', NULL, 'Serine/threonine-protein kinase prk-2', 99, NULL, NULL, 199321),
(199322, '3.90.226.10-FF-000197', NULL, 'Enoyl-CoA hydratase', 246, NULL, NULL, 199322),
(199323, '3.30.1370.10-FF-000157', NULL, 'KH homology domain-containing protein 1C', 97, NULL, NULL, 199323); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(199324, '1.10.760.10-FF-000082', NULL, 'L-cysteine S-thiosulfotransferase subunit SoxA', 119, NULL, NULL, 199324),
(199325, '1.10.8.100-FF-000004', NULL, 'rRNA adenine N(6)-methyltransferase', 90, NULL, NULL, 199325),
(199326, '1.10.510.10-FF-000889', NULL, 'Calmodulin-dependent protein kinase', 331, NULL, NULL, 199326),
(199327, '3.30.160.60-FF-005254', NULL, NULL, 28, NULL, NULL, 199327),
(199328, '1.25.40.10-FF-000993', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 62, NULL, NULL, 199328),
(199329, '2.60.40.10-FF-003641', NULL, NULL, 110, NULL, NULL, 199329),
(199330, '1.20.920.60-FF-000005', NULL, 'Predicted protein', 62, NULL, NULL, 199330),
(199331, '3.40.47.10-FF-000249', NULL, 'Uncharacterized protein', 419, NULL, NULL, 199331),
(199332, '2.70.98.40-FF-000005', NULL, 'Cellobiose phosphorylase', 302, NULL, NULL, 199332),
(199333, '3.80.10.10-FF-001787', NULL, 'Leucine-rich HEV glycoprotein', 133, NULL, NULL, 199333),
(199334, '1.10.510.10-FF-003295', NULL, NULL, 89, NULL, NULL, 199334),
(199335, '3.50.50.60-FF-001007', NULL, 'Rab proteins geranylgeranyltransferase component A, putative', 75, NULL, NULL, 199335),
(199336, '2.40.30.170-FF-000056', NULL, NULL, 21, NULL, NULL, 199336),
(199337, '1.20.1540.10-FF-000028', NULL, 'Peptidase, S54 family', 196, NULL, NULL, 199337),
(199338, '1.10.540.10-FF-000099', NULL, 'Acyl-CoA dehydrogenase', 121, NULL, NULL, 199338),
(199339, '3.30.930.10-FF-000116', NULL, 'Proline--tRNA ligase', 283, NULL, NULL, 199339),
(199340, '2.30.42.10-FF-000241', NULL, '26S proteasome non-ATPase regulatory subunit 9', 114, NULL, NULL, 199340),
(199341, '1.10.10.10-FF-001710', NULL, 'RNA polymerase sigma factor', 90, NULL, NULL, 199341),
(199342, '1.10.238.10-FF-001245', NULL, 'CPK5 (Calmodulin-domain protein kinase 5)', 86, NULL, NULL, 199342),
(199343, '3.30.70.330-FF-000560', NULL, 'RNA-binding protein Musashi homolog 2', 54, NULL, NULL, 199343),
(199344, '3.40.850.10-FF-000411', NULL, 'Kinesin-like protein', 251, NULL, NULL, 199344),
(199345, '2.60.40.10-FF-005440', NULL, NULL, 118, NULL, NULL, 199345),
(199346, '3.30.160.60-FF-005215', NULL, NULL, 31, NULL, NULL, 199346),
(199347, '1.25.40.10-FF-002792', NULL, 'Uncharacterized protein', 195, NULL, NULL, 199347),
(199348, '2.10.50.10-FF-000125', NULL, 'signal peptide, CUB and EGF-like domain-containing protein 2 isoform X1', 56, NULL, NULL, 199348),
(199349, '3.30.750.24-FF-000054', NULL, 'Anti-sigma F factor antagonist', 94, NULL, NULL, 199349),
(199350, '1.20.1080.10-FF-000043', NULL, 'Aquaporin SIP1-1', 241, NULL, NULL, 199350),
(199351, '3.30.160.60-FF-001269', NULL, 'Zinc finger protein', 27, NULL, NULL, 199351),
(199352, '3.40.50.300-FF-004816', NULL, 'Uncharacterized protein', 170, NULL, NULL, 199352),
(199353, '3.75.10.10-FF-000052', NULL, NULL, 56, NULL, NULL, 199353),
(199354, '1.10.220.150-FF-000024', NULL, 'Uncharacterized protein', 109, NULL, NULL, 199354),
(199355, '3.80.10.10-FF-001843', NULL, 'Leucine rich repeat containing 8 VRAC subunit E', 62, NULL, NULL, 199355),
(199356, '1.10.510.10-FF-000945', NULL, 'Uncharacterized protein', 335, NULL, NULL, 199356),
(199357, '3.20.20.140-FF-000012', NULL, 'PHP domain protein', 173, NULL, NULL, 199357),
(199358, '3.40.50.1970-FF-000049', NULL, NULL, 137, NULL, NULL, 199358),
(199359, '3.30.70.270-FF-000064', NULL, 'Diguanylate cyclase', 174, NULL, NULL, 199359),
(199360, '2.20.110.10-FF-000021', NULL, 'Histone H3 K4-specific methyltransferase SET7/9 family protein', 68, NULL, NULL, 199360),
(199361, '3.90.1280.20-FF-000009', NULL, NULL, 60, NULL, NULL, 199361),
(199362, '1.10.472.10-FF-000558', NULL, 'Meiosis-specific cyclin crs1', 67, NULL, NULL, 199362),
(199363, '2.40.100.10-FF-000095', NULL, 'Peptidyl-prolyl cis-trans isomerase', 114, NULL, NULL, 199363),
(199364, '1.10.238.10-FF-000969', NULL, 'Uncharacterized protein', 165, NULL, NULL, 199364),
(199365, '3.40.1390.30-FF-000021', NULL, 'GTP cyclohydrolase 1 type 2 homolog', 129, NULL, NULL, 199365),
(199366, '3.30.40.10-FF-002325', NULL, 'E3 ubiquitin-protein ligase SHPRH-like Protein', 99, NULL, NULL, 199366);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(199367, '3.40.140.100-FF-000010', NULL, 'Autophagy-related protein 7', 144, NULL, NULL, 199367),
(199368, '3.30.420.40-FF-000536', NULL, 'Os01g0604600 protein', 34, NULL, NULL, 199368),
(199369, '3.30.559.10-FF-000056', NULL, 'Vibriobactin synthetase, amide synthase subunit VibH', 160, NULL, NULL, 199369),
(199370, '2.20.25.350-FF-000003', NULL, 'Eukaryotic translation initiation factor 5, putative', 40, NULL, NULL, 199370),
(199371, '3.30.40.10-FF-002364', NULL, 'Probable ubiquitin carboxyl-terminal hydrolase 8', 110, NULL, NULL, 199371),
(199372, '3.30.1330.90-FF-000021', NULL, 'D-3-phosphoglycerate dehydrogenase', 133, NULL, NULL, 199372),
(199373, '3.30.200.20-FF-002346', NULL, 'AGAP011988-PA', 55, NULL, NULL, 199373),
(199374, '3.40.190.10-FF-000057', NULL, 'Phosphate-binding protein PstS', 132, NULL, NULL, 199374),
(199375, '2.20.100.10-FF-000071', NULL, 'ADAMTS like 4', 61, NULL, NULL, 199375),
(199376, '3.40.50.1010-FF-000110', NULL, 'Phoh', 143, NULL, NULL, 199376),
(199377, '3.30.2350.10-FF-000094', NULL, 'Uncharacterized protein', 207, NULL, NULL, 199377),
(199378, '3.30.720.10-FF-000016', NULL, 'Uncharacterized protein', 144, NULL, NULL, 199378),
(199379, '3.90.360.10-FF-000019', NULL, 'Histone acetyltransferase type B catalytic subunit', 98, NULL, NULL, 199379),
(199380, '1.25.40.180-FF-000090', NULL, 'eIF5-mimic protein', 171, NULL, NULL, 199380),
(199381, '2.60.120.260-FF-000640', NULL, 'CUB domaincontaining protein', 104, NULL, NULL, 199381),
(199382, '1.10.268.20-FF-000002', NULL, 'Sarcalumenin', 155, NULL, NULL, 199382),
(199383, '2.120.10.80-FF-000195', NULL, 'Kelch domain-containing protein', 168, NULL, NULL, 199383),
(199384, '3.30.200.20-FF-001222', NULL, 'Mitogen-activated protein kinase kinase kinase 1', 93, NULL, NULL, 199384),
(199385, '3.60.20.10-FF-000147', NULL, NULL, 104, NULL, NULL, 199385),
(199386, '3.30.160.60-FF-001943', NULL, 'Zinc finger protein 23', 30, NULL, NULL, 199386),
(199387, '3.30.450.20-FF-000425', NULL, 'Sensor histidine kinase', 132, NULL, NULL, 199387),
(199388, '1.10.1300.10-FF-000092', NULL, 'Phosphodiesterase', 117, NULL, NULL, 199388),
(199389, '3.50.50.60-FF-001120', NULL, 'Uncharacterized protein', 141, NULL, NULL, 199389),
(199390, '1.20.1540.10-FF-000067', NULL, 'Predicted protein', 203, NULL, NULL, 199390),
(199391, '3.30.70.330-FF-002690', NULL, NULL, 71, NULL, NULL, 199391),
(199392, '2.130.10.10-FF-005417', NULL, 'Probable serine/threonine-protein kinase ireA', 226, NULL, NULL, 199392),
(199393, '1.20.1050.130-FF-000012', NULL, 'Glutathione S-transferase gliG', 211, NULL, NULL, 199393),
(199394, '2.60.40.420-FF-000050', NULL, 'coagulation factor V isoform X1', 126, NULL, NULL, 199394),
(199395, '1.10.10.60-FF-000859', NULL, NULL, 95, NULL, NULL, 199395),
(199396, '3.40.50.150-FF-000859', NULL, 'tRNA/rRNA cytosine-C5-methylase', 337, NULL, NULL, 199396),
(199397, '3.40.50.2000-FF-000722', NULL, 'Glycosyl transferase group 1', 143, NULL, NULL, 199397),
(199398, '3.60.20.10-FF-000260', NULL, NULL, 31, NULL, NULL, 199398),
(199399, '2.40.10.10-FF-000493', NULL, NULL, 151, NULL, NULL, 199399),
(199400, '3.60.20.10-FF-000203', NULL, NULL, 209, NULL, NULL, 199400),
(199401, '3.30.420.40-FF-001087', NULL, 'Glycerol kinase, putative', 110, NULL, NULL, 199401),
(199402, '3.30.450.60-FF-000066', NULL, 'Uncharacterized protein', 128, NULL, NULL, 199402),
(199403, '1.10.287.470-FF-000012', NULL, 'Efflux transporter, RND family, MFP subunit', 74, NULL, NULL, 199403),
(199404, '1.10.490.160-FF-000002', NULL, 'Ryanodine receptor 1 (skeletal)', 166, NULL, NULL, 199404),
(199405, '3.40.50.80-FF-000070', NULL, 'NADH-cytochrome b5 reductase', 167, NULL, NULL, 199405),
(199406, '3.30.2230.10-FF-000001', NULL, 'Ubiquitinyl hydrolase 1', 103, NULL, NULL, 199406),
(199407, '1.25.40.330-FF-000005', NULL, 'Adenylyl cyclase-associated protein', 113, NULL, NULL, 199407),
(199408, '1.10.10.60-FF-001135', NULL, NULL, 61, NULL, NULL, 199408),
(199409, '3.20.110.10-FF-000040', NULL, 'Mannosidase, alpha, class 2B, member 1', 191, NULL, NULL, 199409),
(199410, '3.30.70.20-FF-000065', NULL, 'Reductive dehalogenase, putative', 67, NULL, NULL, 199410); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(199411, '3.40.50.1820-FF-000089', NULL, 'Alpha/beta hydrolase', 310, NULL, NULL, 199411),
(199412, '3.90.70.10-FF-000789', NULL, 'Uncharacterized protein', 331, NULL, NULL, 199412),
(199413, '3.30.160.60-FF-004939', NULL, NULL, 67, NULL, NULL, 199413),
(199414, '2.60.120.290-FF-000126', NULL, 'Predicted protein', 115, NULL, NULL, 199414),
(199415, '1.10.287.110-FF-000394', NULL, 'Uncharacterized protein', 58, NULL, NULL, 199415),
(199416, '2.130.10.10-FF-001146', NULL, 'Dmx like 1', 138, NULL, NULL, 199416),
(199417, '2.40.37.10-FF-000026', NULL, 'Alanine racemase', 137, NULL, NULL, 199417),
(199418, '3.60.10.10-FF-000321', NULL, 'Uncharacterized protein', 276, NULL, NULL, 199418),
(199419, '1.20.1070.10-FF-000104', NULL, 'Opsin 5', 309, NULL, NULL, 199419),
(199420, '2.40.50.40-FF-000032', NULL, 'protein CHROMATIN REMODELING 5 isoform X2', 53, NULL, NULL, 199420),
(199421, '1.25.10.10-FF-001328', NULL, 'Coatomer beta subunit', 533, NULL, NULL, 199421),
(199422, '1.20.1560.10-FF-000810', NULL, 'ABC transporter, putative', 153, NULL, NULL, 199422),
(199423, '2.60.120.10-FF-000102', NULL, 'Cupin, RmlC-type', 127, NULL, NULL, 199423),
(199424, '3.40.50.10140-FF-000021', NULL, 'Toll receptor 13', 147, NULL, NULL, 199424),
(199425, '3.10.280.10-FF-000020', NULL, 'Mitochondrial matrix acidic protein, putative', 214, NULL, NULL, 199425),
(199426, '1.20.5.460-FF-000003', NULL, 'Death-associated protein kinase 1', 28, NULL, NULL, 199426),
(199427, '3.60.15.10-FF-000017', NULL, 'Lactamase beta 2', 204, NULL, NULL, 199427),
(199428, '1.25.40.340-FF-000008', NULL, NULL, 191, NULL, NULL, 199428),
(199429, '1.10.510.10-FF-002744', NULL, NULL, 220, NULL, NULL, 199429),
(199430, '3.30.390.140-FF-000001', NULL, 'Ribosomal protein PSRP-3/Ycf65', 83, NULL, NULL, 199430),
(199431, '3.30.160.60-FF-001382', NULL, 'Transcriptional repressor', 28, NULL, NULL, 199431),
(199432, '2.130.10.10-FF-003276', NULL, 'Protein HIRA', 160, NULL, NULL, 199432),
(199433, '1.25.40.10-FF-003011', NULL, 'Pentatricopeptide repeat-containing protein', 117, NULL, NULL, 199433),
(199434, '1.10.1300.10-FF-000035', NULL, 'Phosphodiesterase', 329, NULL, NULL, 199434),
(199435, '1.10.10.60-FF-000972', NULL, NULL, 46, NULL, NULL, 199435),
(199436, '3.30.160.60-FF-004198', NULL, NULL, 55, NULL, NULL, 199436),
(199437, '2.130.10.10-FF-001202', NULL, 'CTF4p Chromatin-associated protein', 151, NULL, NULL, 199437),
(199438, '2.40.128.330-FF-000013', NULL, 'Predicted protein', 78, NULL, NULL, 199438),
(199439, '2.60.40.10-FF-005041', NULL, NULL, 103, NULL, NULL, 199439),
(199440, '3.30.465.10-FF-000057', NULL, 'Hemolysin C', 91, NULL, NULL, 199440),
(199441, '2.20.100.10-FF-000138', NULL, 'No long nerve cord, isoform A', 60, NULL, NULL, 199441),
(199442, '1.25.40.180-FF-000213', NULL, NULL, 189, NULL, NULL, 199442),
(199443, '3.40.50.150-FF-000050', NULL, 'Hnrnp arginine n-methyltransferase', 151, NULL, NULL, 199443),
(199444, '1.20.1560.10-FF-000355', NULL, 'Putative ATP-binding cassette protein subfamily B,member 1', 197, NULL, NULL, 199444),
(199445, '1.10.287.10-FF-000032', NULL, 'CTD phosphatase-related (Eurofung)', 42, NULL, NULL, 199445),
(199446, '2.60.40.60-FF-000879', NULL, 'Uncharacterized protein', 111, NULL, NULL, 199446),
(199447, '3.40.50.2300-FF-000694', NULL, 'Development and carotenogenesis control-1 protein', 184, NULL, NULL, 199447),
(199448, '2.130.10.10-FF-000926', NULL, 'U3 small nucleolar RNA-associated protein 15', 194, NULL, NULL, 199448),
(199449, '1.25.40.320-FF-000002', NULL, 'Leukotriene A(4) hydrolase', 149, NULL, NULL, 199449),
(199450, '1.20.1050.10-FF-000215', NULL, 'Uncharacterized protein', 113, NULL, NULL, 199450),
(199451, '2.120.10.30-FF-000551', NULL, 'Predicted protein', 85, NULL, NULL, 199451),
(199452, '3.10.450.40-FF-000008', NULL, 'Protein DCL, chloroplastic', 93, NULL, NULL, 199452),
(199453, '1.25.10.10-FF-001441', NULL, 'Serine/threonine-protein kinase TOR', 113, NULL, NULL, 199453),
(199454, '3.50.50.60-FF-000844', NULL, 'Protein containing FAD dependent oxidoreductase domain', 93, NULL, NULL, 199454);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(199455, '3.30.160.60-FF-005653', NULL, NULL, 29, NULL, NULL, 199455),
(199456, '1.20.900.10-FF-000130', NULL, 'Rho GTPase regulating protein, putative', 60, NULL, NULL, 199456),
(199457, '2.170.130.10-FF-000077', NULL, NULL, 149, NULL, NULL, 199457),
(199458, '2.90.10.30-FF-000007', NULL, 'Serine/threonine-protein kinase', 154, NULL, NULL, 199458),
(199459, '2.130.10.10-FF-004855', NULL, 'Uncharacterized protein', 127, NULL, NULL, 199459),
(199460, '3.50.30.30-FF-000053', NULL, 'LOC100135083 protein', 116, NULL, NULL, 199460),
(199461, '3.30.70.330-FF-002358', NULL, NULL, 105, NULL, NULL, 199461),
(199462, '3.80.20.20-FF-000037', NULL, 'Receptor protein-tyrosine kinase', 64, NULL, NULL, 199462),
(199463, '1.10.510.10-FF-001726', NULL, 'Uncharacterized protein', 125, NULL, NULL, 199463),
(199464, '1.25.40.20-FF-001159', NULL, 'E3 ubiquitin-protein ligase mib1', 135, NULL, NULL, 199464),
(199465, '2.10.25.10-FF-001742', NULL, 'Uncharacterized protein', 38, NULL, NULL, 199465),
(199466, '1.25.40.10-FF-001156', NULL, 'Pentatricopeptide repeat-containing protein At5g61800', 101, NULL, NULL, 199466),
(199467, '3.40.50.300-FF-001601', NULL, 'ABC multidrug transporter', 244, NULL, NULL, 199467),
(199468, '1.10.8.60-FF-000083', NULL, 'ATP-dependent zinc metalloprotease FtsH', 75, NULL, NULL, 199468),
(199469, '1.20.58.1220-FF-000015', NULL, 'Exocyst complex component EXO84', 102, NULL, NULL, 199469),
(199470, '2.60.40.10-FF-000836', NULL, 'Neuronal cell adhesion molecule', 93, NULL, NULL, 199470),
(199471, '3.40.50.10930-FF-000005', NULL, 'RecBCD enzyme subunit RecC', 157, NULL, NULL, 199471),
(199472, '3.80.10.10-FF-002282', NULL, 'Leucine-rich repeat-containing protein 43', 75, NULL, NULL, 199472),
(199473, '2.130.10.10-FF-004693', NULL, 'Uncharacterized protein', 176, NULL, NULL, 199473),
(199474, '2.30.40.10-FF-000130', NULL, 'N-acetylglucosamine-6-phosphate deacetylase (GlcNAc 6-P deacetylase)', 79, NULL, NULL, 199474),
(199475, '3.40.50.2000-FF-000542', NULL, 'Sucrose synthase', 43, NULL, NULL, 199475),
(199476, '2.130.10.10-FF-001421', NULL, 'Transducin family protein / WD-40 repeat family protein', 171, NULL, NULL, 199476),
(199477, '2.40.70.10-FF-000378', NULL, NULL, 197, NULL, NULL, 199477),
(199478, '3.40.50.300-FF-001326', NULL, 'Putative ATP-dependent RNA helicase DHX35', 212, NULL, NULL, 199478),
(199479, '1.10.10.1320-FF-000008', NULL, 'Anti-sigma factor', 73, NULL, NULL, 199479),
(199480, '2.60.40.10-FF-003528', NULL, NULL, 79, NULL, NULL, 199480),
(199481, '1.25.10.10-FF-001109', NULL, 'TATA-binding protein-associated factor', 202, NULL, NULL, 199481),
(199482, '3.40.50.720-FF-001952', NULL, 'Uncharacterized protein', 261, NULL, NULL, 199482),
(199483, '1.20.1720.10-FF-000014', NULL, 'MFS drug transporter, putative', 216, NULL, NULL, 199483),
(199484, '3.80.10.10-FF-002006', NULL, 'Uncharacterized protein', 81, NULL, NULL, 199484),
(199485, '3.30.40.10-FF-001869', NULL, 'RING finger protein 141-like Protein', 78, NULL, NULL, 199485),
(199486, '3.30.200.20-FF-001042', NULL, 'Myosin heavy chain kinase B', 51, NULL, NULL, 199486),
(199487, '2.60.40.10-FF-004546', NULL, NULL, 83, NULL, NULL, 199487),
(199488, '3.80.10.10-FF-002624', NULL, 'Protein CBG02386', 178, NULL, NULL, 199488),
(199489, '3.30.160.60-FF-001325', NULL, 'zinc finger protein 200', 28, NULL, NULL, 199489),
(199490, '3.10.580.10-FF-000060', NULL, 'mRNA, clone: RTFL01-01-J02', 163, NULL, NULL, 199490),
(199491, '3.40.50.720-FF-000934', NULL, 'Short chain dehydrogenase', 243, NULL, NULL, 199491),
(199492, '2.60.40.10-FF-001112', NULL, 'probable beta-D-xylosidase 7', 109, NULL, NULL, 199492),
(199493, '1.10.150.20-FF-000055', NULL, 'Mating-type switch/DNA repair protein Swi10/Rad10', 89, NULL, NULL, 199493),
(199494, '3.40.50.2300-FF-000637', NULL, 'Glutamate receptor IIC', 143, NULL, NULL, 199494),
(199495, '3.40.1800.30-FF-000003', NULL, 'Uncharacterized protein', 63, NULL, NULL, 199495),
(199496, '3.30.70.3270-FF-000021', NULL, 'NADH:ubiquinone oxidoreductase core subunit S8', 95, NULL, NULL, 199496),
(199497, '2.130.10.10-FF-005131', NULL, 'Intraflagellar transport protein 122 homolog', 340, NULL, NULL, 199497);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(199498, '3.30.460.10-FF-000029', NULL, 'DNA polymerase', 123, NULL, NULL, 199498),
(199499, '1.10.10.60-FF-000915', NULL, NULL, 34, NULL, NULL, 199499),
(199500, '2.130.10.10-FF-000983', NULL, 'rRNA processing protein Pwp1, putative', 237, NULL, NULL, 199500),
(199501, '1.20.1260.60-FF-000015', NULL, 'IST1 homolog', 105, NULL, NULL, 199501),
(199502, '1.25.40.10-FF-002516', NULL, 'Two-component signal transduction', 188, NULL, NULL, 199502),
(199503, '1.10.287.130-FF-000096', NULL, 'Two-component sensor histidine kinase', 74, NULL, NULL, 199503),
(199504, '3.10.20.90-FF-000499', NULL, 'WGS project CABT00000000 data, contig 2.1', 99, NULL, NULL, 199504),
(199505, '3.90.660.10-FF-000059', NULL, 'SWIRM domain protein', 172, NULL, NULL, 199505),
(199506, '2.30.29.30-FF-000334', NULL, 'Uncharacterized protein, isoform C', 142, NULL, NULL, 199506),
(199507, '3.10.580.10-FF-000003', NULL, 'Protein kinase AMP-activated non-catalytic subunit gamma 1', 145, NULL, NULL, 199507),
(199508, '3.40.50.720-FF-000535', NULL, 'Hydroxy-delta-5-steroid dehydrogenase, 3 beta- and steroid delta-isomerase 7', 190, NULL, NULL, 199508),
(199509, '3.40.190.10-FF-000675', NULL, 'Uncharacterized solute-binding protein VNG_1595C', 61, NULL, NULL, 199509),
(199510, '1.20.120.720-FF-000035', NULL, 'Unconventional myosin-XIX', 114, NULL, NULL, 199510),
(199511, '3.30.160.60-FF-004759', NULL, NULL, 40, NULL, NULL, 199511),
(199512, '3.40.50.720-FF-000592', NULL, 'Similar to saccharopine dehydrogenase', 177, NULL, NULL, 199512),
(199513, '1.20.1560.10-FF-000630', NULL, 'Uncharacterized protein', 244, NULL, NULL, 199513),
(199514, '3.90.550.10-FF-000467', NULL, 'Sugar transferase-putative a glycosyl transferase', 222, NULL, NULL, 199514),
(199515, '2.10.90.10-FF-000122', NULL, 'Prepro-neurotrophin', 124, NULL, NULL, 199515),
(199516, '3.90.79.10-FF-000096', NULL, 'Isopentenyl-diphosphate Delta-isomerase', 240, NULL, NULL, 199516),
(199517, '2.130.10.10-FF-004294', NULL, 'Uncharacterized protein', 123, NULL, NULL, 199517),
(199518, '3.20.20.300-FF-000083', NULL, NULL, 153, NULL, NULL, 199518),
(199519, '3.40.50.1820-FF-001668', NULL, 'Carboxypeptidase', 268, NULL, NULL, 199519),
(199520, '3.30.1490.190-FF-000025', NULL, 'Fe2+/Zn2+ uptake regulation proteins', 52, NULL, NULL, 199520),
(199521, '1.10.287.2920-FF-000001', NULL, 'RNA polymerase II holoenzyme complex component', 81, NULL, NULL, 199521),
(199522, '3.30.310.80-FF-000023', NULL, 'Non-specific serine/threonine protein kinase', 87, NULL, NULL, 199522),
(199523, '1.10.510.10-FF-001108', NULL, 'Protein kinase, putative', 198, NULL, NULL, 199523),
(199524, '3.20.20.300-FF-000026', NULL, 'Glycosyl hydrolase', 327, NULL, NULL, 199524),
(199525, '3.40.1110.10-FF-000214', NULL, 'Copper resistance-associated P-type ATPase', 140, NULL, NULL, 199525),
(199526, '3.40.190.10-FF-000618', NULL, 'Sll0540 protein', 102, NULL, NULL, 199526),
(199527, '3.10.580.20-FF-000006', NULL, 'Chloride channel protein', 93, NULL, NULL, 199527),
(199528, '3.10.180.10-FF-000035', NULL, 'Glyoxalase I', 134, NULL, NULL, 199528),
(199529, '2.130.10.10-FF-001820', NULL, 'Yeast SEC homolog', 330, NULL, NULL, 199529),
(199530, '3.60.120.10-FF-000008', NULL, 'Anthranilate synthase component 1', 511, NULL, NULL, 199530),
(199531, '3.30.160.60-FF-005035', NULL, NULL, 65, NULL, NULL, 199531),
(199532, '3.30.60.90-FF-000040', NULL, 'Ring finger domain containing protein', 45, NULL, NULL, 199532),
(199533, '3.30.565.10-FF-000565', NULL, 'Uncharacterized protein', 90, NULL, NULL, 199533),
(199534, '3.30.200.20-FF-000766', NULL, 'AGC/NDR protein kinase', 104, NULL, NULL, 199534),
(199535, '1.10.472.10-FF-000614', NULL, 'D-type cyclin', 134, NULL, NULL, 199535),
(199536, '1.20.58.60-FF-000800', NULL, 'Uncharacterized protein', 207, NULL, NULL, 199536),
(199537, '3.20.20.70-FF-000032', NULL, 'Homocitrate synthase, mitochondrial', 276, NULL, NULL, 199537),
(199538, '1.25.40.10-FF-000919', NULL, 'HAT1-interacting factor 1', 197, NULL, NULL, 199538),
(199539, '3.40.50.300-FF-006834', NULL, 'Predicted protein', 268, NULL, NULL, 199539);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(199540, '1.25.40.20-FF-001384', NULL, 'Uncharacterized protein', 66, NULL, NULL, 199540),
(199541, '1.25.10.10-FF-002981', NULL, 'Uncharacterized protein', 385, NULL, NULL, 199541),
(199542, '1.25.40.10-FF-001381', NULL, 'Pentatricopeptide repeat-containing protein At1g50270', 116, NULL, NULL, 199542),
(199543, '3.80.10.10-FF-002181', NULL, 'Uncharacterized protein', 72, NULL, NULL, 199543),
(199544, '3.30.70.100-FF-000120', NULL, NULL, 71, NULL, NULL, 199544),
(199545, '3.30.160.60-FF-003192', NULL, 'ZNF101 isoform 2', 43, NULL, NULL, 199545),
(199546, '1.25.40.20-FF-001428', NULL, 'Predicted protein', 174, NULL, NULL, 199546),
(199547, '3.90.1600.10-FF-000049', NULL, 'DNA polymerase Pol2', 151, NULL, NULL, 199547),
(199548, '2.70.98.10-FF-000126', NULL, 'Predicted protein', 337, NULL, NULL, 199548),
(199549, '2.20.100.10-FF-000054', NULL, 'ADAMTS-like protein 2', 59, NULL, NULL, 199549),
(199550, '3.30.160.20-FF-000105', NULL, 'YOL114C-like protein', 143, NULL, NULL, 199550),
(199551, '3.30.1520.10-FF-000023', NULL, 'Neutrophil cytosol factor 1', 141, NULL, NULL, 199551),
(199552, '3.40.50.1000-FF-000658', NULL, NULL, 78, NULL, NULL, 199552),
(199553, '1.20.1250.20-FF-000048', NULL, 'High affinity nitrate transporter', 198, NULL, NULL, 199553),
(199554, '3.80.10.10-FF-000617', NULL, 'Leucine-rich repeat and calponin homology domain-containing protein 3', 94, NULL, NULL, 199554),
(199555, '1.25.40.10-FF-002483', NULL, 'Os07g0635800 protein', 123, NULL, NULL, 199555),
(199556, '1.10.472.30-FF-000013', NULL, NULL, 105, NULL, NULL, 199556),
(199557, '3.40.50.10190-FF-000210', NULL, 'YALI0D12364p', 91, NULL, NULL, 199557),
(199558, '1.10.238.10-FF-001065', NULL, 'Calcium-binding protein CML38', 79, NULL, NULL, 199558),
(199559, '1.10.3470.10-FF-000019', NULL, 'Iron-compound ABC transporter, permease protein', 329, NULL, NULL, 199559),
(199560, '3.30.1490.100-FF-000049', NULL, 'DNA repair protein REV1', 99, NULL, NULL, 199560),
(199561, '3.20.20.80-FF-000035', NULL, 'Mannosidase beta', 366, NULL, NULL, 199561),
(199562, '3.30.160.60-FF-001628', NULL, 'Uncharacterized protein', 28, NULL, NULL, 199562),
(199563, '1.10.640.10-FF-000084', NULL, 'Oxidase/peroxidase, putative', 189, NULL, NULL, 199563),
(199564, '3.30.160.100-FF-000005', NULL, 'Ribosomal subunit interface protein', 103, NULL, NULL, 199564),
(199565, '2.60.120.200-FF-000414', NULL, 'cadherin EGF LAG seven-pass G-type receptor 2 isoform X2', 157, NULL, NULL, 199565),
(199566, '1.25.40.10-FF-004618', NULL, 'Uncharacterized protein', 159, NULL, NULL, 199566),
(199567, '3.40.50.80-FF-000053', NULL, 'NADH-cytochrome b5 reductase', 137, NULL, NULL, 199567),
(199568, '3.30.160.60-FF-000010', NULL, 'Zinc finger protein 34', 28, NULL, NULL, 199568),
(199569, '1.20.1560.10-FF-000501', NULL, 'Uncharacterized protein', 319, NULL, NULL, 199569),
(199570, '3.40.47.10-FF-000069', NULL, 'Acetyl-CoA C-acetyltransferase, putative', 178, NULL, NULL, 199570),
(199571, '3.30.710.10-FF-000257', NULL, 'Uncharacterized protein', 126, NULL, NULL, 199571),
(199572, '4.10.240.10-FF-000053', NULL, 'C6 transcription factor, putative', 69, NULL, NULL, 199572),
(199573, '3.100.10.10-FF-000053', NULL, NULL, 89, NULL, NULL, 199573),
(199574, '3.40.50.150-FF-001157', NULL, NULL, 109, NULL, NULL, 199574),
(199575, '2.40.70.10-FF-000474', NULL, NULL, 158, NULL, NULL, 199575),
(199576, '3.90.226.10-FF-000085', NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', 357, NULL, NULL, 199576),
(199577, '3.40.50.620-FF-000360', NULL, 'Isoleucyl-tRNA synthetase, mitochondrial', 159, NULL, NULL, 199577),
(199578, '1.20.1250.10-FF-000045', NULL, 'Interferon C', 159, NULL, NULL, 199578),
(199579, '1.20.90.10-FF-000017', NULL, 'Phospholipase A(2)', 84, NULL, NULL, 199579),
(199580, '3.40.50.2300-FF-000519', NULL, 'Vomeronasal 2 receptor, a18', 170, NULL, NULL, 199580),
(199581, '3.30.420.10-FF-000510', NULL, NULL, 131, NULL, NULL, 199581),
(199582, '3.40.850.10-FF-000052', NULL, 'Kinesin-like protein KIN-12F', 380, NULL, NULL, 199582),
(199583, '3.40.50.300-FF-005732', NULL, 'Disease resistance protein CHS1', 154, NULL, NULL, 199583);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(199584, '3.80.10.10-FF-002225', NULL, 'Uncharacterized protein', 247, NULL, NULL, 199584),
(199585, '1.10.10.10-FF-001401', NULL, 'Uncharacterized protein', 78, NULL, NULL, 199585),
(199586, '1.20.1200.10-FF-000008', NULL, 'ATP-cobalamin adenosyltransferase', 164, NULL, NULL, 199586),
(199587, '3.40.50.2300-FF-000475', NULL, 'Olfactory receptor C family, g2', 136, NULL, NULL, 199587),
(199588, '3.30.450.20-FF-000015', NULL, 'Hypoxia-inducible factor 1-alpha isoform 1', 140, NULL, NULL, 199588),
(199589, '3.40.50.150-FF-001483', NULL, NULL, 124, NULL, NULL, 199589),
(199590, '1.10.510.10-FF-001518', NULL, 'Serine/threonine protein kinase', 208, NULL, NULL, 199590),
(199591, '1.10.10.500-FF-000004', NULL, 'Lissencephaly-1 homolog', 135, NULL, NULL, 199591),
(199592, '1.10.510.10-FF-003126', NULL, NULL, 186, NULL, NULL, 199592),
(199593, '1.10.8.10-FF-000242', NULL, 'Ubiquitin conjugating enzyme', 41, NULL, NULL, 199593),
(199594, '3.30.40.10-FF-002117', NULL, 'Uncharacterized protein', 104, NULL, NULL, 199594),
(199595, '1.20.1260.10-FF-000017', NULL, 'Ferritin', 189, NULL, NULL, 199595),
(199596, '2.130.10.10-FF-002585', NULL, 'WD repeat-containing protein 44 isoform A', 51, NULL, NULL, 199596),
(199597, '2.130.10.10-FF-003091', NULL, 'Uncharacterized WD repeat-containing protein sll1491', 83, NULL, NULL, 199597),
(199598, '1.25.40.10-FF-003000', NULL, 'Activator of C kinase protein 1', 126, NULL, NULL, 199598),
(199599, '3.40.50.1970-FF-000044', NULL, NULL, 163, NULL, NULL, 199599),
(199600, '1.10.1300.10-FF-000024', NULL, 'Phosphodiesterase', 333, NULL, NULL, 199600),
(199601, '2.60.40.10-FF-003124', NULL, 'Uncharacterized protein', 106, NULL, NULL, 199601),
(199602, '3.80.10.10-FF-004316', NULL, 'Uncharacterized protein', 207, NULL, NULL, 199602),
(199603, '1.10.238.10-FF-000885', NULL, 'Proline dehydrogenase', 54, NULL, NULL, 199603),
(199604, '3.40.50.150-FF-000977', NULL, NULL, 220, NULL, NULL, 199604),
(199605, '1.20.920.10-FF-000221', NULL, 'Bromodomain and WD repeat domain-containing 3', 71, NULL, NULL, 199605),
(199606, '2.40.50.140-FF-000085', NULL, 'DNA ligase', 145, NULL, NULL, 199606),
(199607, '3.40.80.10-FF-000011', NULL, 'N-acetylmuramoyl-L-alanine amidase', 203, NULL, NULL, 199607),
(199608, '1.20.120.1900-FF-000059', NULL, 'Gamma-tubulin complex component', 275, NULL, NULL, 199608),
(199609, '3.10.10.10-FF-000008', NULL, 'Protein CBG24470', 113, NULL, NULL, 199609),
(199610, '3.40.50.2300-FF-000845', NULL, NULL, 136, NULL, NULL, 199610),
(199611, '1.20.1070.10-FF-000317', NULL, 'Neuropeptide FF receptor', 354, NULL, NULL, 199611),
(199612, '2.120.10.80-FF-000077', NULL, 'Serine/threonine-protein phosphatase', 104, NULL, NULL, 199612),
(199613, '3.40.50.2000-FF-000536', NULL, 'Alphaalpha-trehalose-phosphate synthase [UDP-forming] 5', 145, NULL, NULL, 199613),
(199614, '2.60.40.420-FF-000128', NULL, 'Extracellular dihydrogeodin oxidase/laccase, putative', 198, NULL, NULL, 199614),
(199615, '3.40.50.1980-FF-000047', NULL, 'ABC transporter, periplasmic substrate-binding protein', 201, NULL, NULL, 199615),
(199616, '3.40.50.300-FF-008279', NULL, 'Uncharacterized protein', 36, NULL, NULL, 199616),
(199617, '3.10.129.10-FF-000192', NULL, 'Uncharacterized protein', 156, NULL, NULL, 199617),
(199618, '3.40.50.720-FF-000608', NULL, 'SUMO1 activating enzyme subunit 1', 71, NULL, NULL, 199618),
(199619, '3.90.180.10-FF-000180', NULL, 'Uncharacterized protein', 69, NULL, NULL, 199619),
(199620, '1.20.1060.10-FF-000019', NULL, 'DNA polymerase theta', 104, NULL, NULL, 199620),
(199621, '1.20.900.10-FF-000012', NULL, 'T cell lymphoma invasion and metastasis 1', 203, NULL, NULL, 199621),
(199622, '1.10.630.10-FF-000156', NULL, 'Os06g0294600 protein', 485, NULL, NULL, 199622),
(199623, '1.20.1250.20-FF-001829', NULL, 'Uncharacterized protein', 145, NULL, NULL, 199623),
(199624, '3.40.50.10240-FF-000023', NULL, 'Uncharacterized protein', 100, NULL, NULL, 199624),
(199625, '2.60.40.60-FF-001054', NULL, 'Uncharacterized protein', 80, NULL, NULL, 199625),
(199626, '2.60.40.10-FF-004861', NULL, NULL, 56, NULL, NULL, 199626);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(199627, '1.20.58.1880-FF-000039', NULL, 'REST corepressor 2', 49, NULL, NULL, 199627),
(199628, '3.40.50.720-FF-002216', NULL, 'Uncharacterized protein', 115, NULL, NULL, 199628),
(199629, '2.130.10.10-FF-001157', NULL, 'Leucine-rich repeat and WD repeat-containing protein KIAA1239', 133, NULL, NULL, 199629),
(199630, '1.10.10.60-FF-001146', NULL, NULL, 56, NULL, NULL, 199630),
(199631, '2.10.109.10-FF-000082', NULL, 'Mitochondrial inner membrane protease subunit', 137, NULL, NULL, 199631),
(199632, '3.30.160.20-FF-000094', NULL, 'ATP-dependent RNA helicase A, putative', 88, NULL, NULL, 199632),
(199633, '3.40.50.10810-FF-000256', NULL, 'Uncharacterized protein', 62, NULL, NULL, 199633),
(199634, '1.20.1560.10-FF-000490', NULL, 'ABC-type transporter, ATPase component and permease component', 295, NULL, NULL, 199634),
(199635, '1.10.10.10-FF-000575', NULL, 'GntR family transcriptional regulator', 73, NULL, NULL, 199635),
(199636, '1.10.10.60-FF-000792', NULL, 'Extraembryonic, spermatogenesis, homeobox 1', 78, NULL, NULL, 199636),
(199637, '1.10.3450.40-FF-000021', NULL, NULL, 83, NULL, NULL, 199637),
(199638, '2.70.160.11-FF-000031', NULL, 'Protein arginine N-methyltransferase 1, putative', 171, NULL, NULL, 199638),
(199639, '2.60.40.10-FF-001516', NULL, 'Signaling lymphocytic activation molecule', 113, NULL, NULL, 199639),
(199640, '2.60.120.260-FF-000281', NULL, 'Uncharacterized protein', 47, NULL, NULL, 199640),
(199641, '2.40.50.140-FF-000764', NULL, NULL, 43, NULL, NULL, 199641),
(199642, '3.40.50.1820-FF-000448', NULL, 'Protein CBG16920', 297, NULL, NULL, 199642),
(199643, '3.20.20.80-FF-000361', NULL, 'Putative chitinase 2-like Protein', 262, NULL, NULL, 199643),
(199644, '1.20.1250.20-FF-000418', NULL, 'Folate-biopterin transporter 1, chloroplastic isoform A', 186, NULL, NULL, 199644),
(199645, '3.50.50.60-FF-001041', NULL, 'Guanosine nucleotide diphosphate dissociation inhibitor', 40, NULL, NULL, 199645),
(199646, '2.120.10.80-FF-000386', NULL, 'Uncharacterized protein', 226, NULL, NULL, 199646),
(199647, '1.10.287.70-FF-000353', NULL, 'Predicted protein', 209, NULL, NULL, 199647),
(199648, '3.40.50.11210-FF-000016', NULL, NULL, 101, NULL, NULL, 199648),
(199649, '3.30.200.20-FF-000295', NULL, 'probable LRR receptor-like serine/threonine-protein kinase IRK', 83, NULL, NULL, 199649),
(199650, '3.60.140.10-FF-000004', NULL, 'Polyphenol oxidase', 266, NULL, NULL, 199650),
(199651, '2.60.120.200-FF-000740', NULL, 'Uncharacterized protein', 160, NULL, NULL, 199651),
(199652, '3.40.50.360-FF-000130', NULL, 'Uncharacterized NAD(P)H oxidoreductase HI_1544', 196, NULL, NULL, 199652),
(199653, '3.90.640.10-FF-000064', NULL, 'Actin-like protein, putative', 64, NULL, NULL, 199653),
(199654, '1.25.40.170-FF-000007', NULL, 'Uncharacterized protein', 131, NULL, NULL, 199654),
(199655, '1.10.510.10-FF-001311', NULL, 'Uncharacterized protein, isoform A', 248, NULL, NULL, 199655),
(199656, '1.10.10.10-FF-001390', NULL, '40S ribosomal protein S19', 145, NULL, NULL, 199656),
(199657, '2.130.10.10-FF-002938', NULL, 'Predicted protein', 139, NULL, NULL, 199657),
(199658, '2.10.25.10-FF-000617', NULL, 'Fibulin 5', 35, NULL, NULL, 199658),
(199659, '1.20.5.110-FF-000044', NULL, 'Golgi SNAP receptor complex member 2', 71, NULL, NULL, 199659),
(199660, '1.25.10.10-FF-001244', NULL, 'RING-type E3 ubiquitin transferase', 252, NULL, NULL, 199660),
(199661, '1.10.150.110-FF-000006', NULL, 'DNA polymerase', 88, NULL, NULL, 199661),
(199662, '3.40.50.2000-FF-000183', NULL, 'UDP-glycosyltransferase 83A1', 12, NULL, NULL, 199662),
(199663, '3.40.50.12780-FF-000009', NULL, 'Bifunctional protein Aas', 391, NULL, NULL, 199663),
(199664, '2.30.30.40-FF-000565', NULL, 'C-terminal Src kinase', 38, NULL, NULL, 199664),
(199665, '1.20.120.20-FF-000040', NULL, 'Apolipoprotein A-Ib', 78, NULL, NULL, 199665),
(199666, '1.10.150.120-FF-000009', NULL, 'Aldehyde oxidase 6', 127, NULL, NULL, 199666),
(199667, '3.80.10.10-FF-003962', NULL, 'LRR receptor-like serine/threonine-protein kinase RCH1', 191, NULL, NULL, 199667),
(199668, '1.25.40.20-FF-001058', NULL, 'Mitogen activated protein kinase kinase kinase 3, MAPKKK3, MEKK3, putative', 106, NULL, NULL, 199668);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(199669, '1.25.10.10-FF-002655', NULL, 'Uncharacterized protein', 106, NULL, NULL, 199669),
(199670, '2.10.25.10-FF-000410', NULL, 'Stabilin 2', 43, NULL, NULL, 199670),
(199671, '1.25.10.10-FF-001553', NULL, 'Uncharacterized protein', 333, NULL, NULL, 199671),
(199672, '3.40.50.300-FF-002782', NULL, 'Si:dkey-110g7.8', 247, NULL, NULL, 199672),
(199673, '3.40.50.300-FF-004889', NULL, 'Ras family protein', 185, NULL, NULL, 199673),
(199674, '1.25.40.10-FF-001055', NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', 151, NULL, NULL, 199674),
(199675, '3.20.20.150-FF-000054', NULL, 'Hydroxypyruvate isomerase (putative)', 199, NULL, NULL, 199675),
(199676, '3.60.20.10-FF-000181', NULL, NULL, 194, NULL, NULL, 199676),
(199677, '3.30.40.10-FF-000189', NULL, 'TNF receptor-associated factor', 137, NULL, NULL, 199677),
(199678, '1.10.472.10-FF-000592', NULL, 'Cyclin G2', 27, NULL, NULL, 199678),
(199679, '3.30.300.30-FF-000086', NULL, 'Peptide synthetase', 100, NULL, NULL, 199679),
(199680, '3.40.50.880-FF-000196', NULL, 'Predicted protein', 191, NULL, NULL, 199680),
(199681, '1.10.287.3490-FF-000003', NULL, 'Mediator of RNA polymerase II transcription subunit 11', 86, NULL, NULL, 199681),
(199682, '3.90.640.10-FF-000108', NULL, 'Actin-related protein 8', 84, NULL, NULL, 199682),
(199683, '3.40.50.300-FF-005053', NULL, 'Os03g0121901 protein', 91, NULL, NULL, 199683),
(199684, '3.40.220.10-FF-000021', NULL, 'RNase III inhibitor', 147, NULL, NULL, 199684),
(199685, '2.10.25.10-FF-000101', NULL, 'Laminin subunit beta 1', 56, NULL, NULL, 199685),
(199686, '2.60.40.10-FF-001179', NULL, 'Sallimus, isoform Q', 110, NULL, NULL, 199686),
(199687, '1.20.1280.170-FF-000013', NULL, 'Uncharacterized protein', 270, NULL, NULL, 199687),
(199688, '2.70.150.10-FF-000299', NULL, 'Uncharacterized protein', 91, NULL, NULL, 199688),
(199689, '3.40.50.720-FF-000081', NULL, '2-deoxy-D-gluconate 3-dehydrogenase', 253, NULL, NULL, 199689),
(199690, '3.40.50.300-FF-003271', NULL, 'Origin recognition complex subunit 4', 112, NULL, NULL, 199690),
(199691, '1.20.1070.10-FF-000626', NULL, 'Uncharacterized protein', 311, NULL, NULL, 199691),
(199692, '2.130.10.30-FF-000180', NULL, NULL, 236, NULL, NULL, 199692),
(199693, '3.40.190.10-FF-000377', NULL, 'Amino acid ABC transporter substrate-binding protein', 127, NULL, NULL, 199693),
(199694, '3.40.850.10-FF-000259', NULL, 'Kinesin-like protein', 393, NULL, NULL, 199694),
(199695, '3.40.50.2000-FF-000492', NULL, 'Lipopolysaccharide heptosyltransferase II', 181, NULL, NULL, 199695),
(199696, '2.60.40.10-FF-003080', NULL, 'GM26564', 94, NULL, NULL, 199696),
(199697, '3.30.160.60-FF-000595', NULL, 'Krueppel-like factor 14', 32, NULL, NULL, 199697),
(199698, '3.30.1050.10-FF-000048', NULL, 'Putative secreted protein', 121, NULL, NULL, 199698),
(199699, '2.60.120.590-FF-000014', NULL, 'Oxidoreductase, 2OG-Fe(II) oxygenase family family', 197, NULL, NULL, 199699),
(199700, '1.25.40.10-FF-000566', NULL, 'Pentatricopeptide repeat-containing protein', 209, NULL, NULL, 199700),
(199701, '1.25.40.10-FF-004298', NULL, 'Uncharacterized protein', 194, NULL, NULL, 199701),
(199702, '2.60.40.10-FF-003450', NULL, NULL, 102, NULL, NULL, 199702),
(199703, '3.40.50.720-FF-002542', NULL, 'Ubiquitin-like modifier-activating enzyme 1', 72, NULL, NULL, 199703),
(199704, '3.30.559.10-FF-000242', NULL, 'Uncharacterized protein', 115, NULL, NULL, 199704),
(199705, '2.130.10.10-FF-001483', NULL, 'Tex1p', 188, NULL, NULL, 199705),
(199706, '3.30.420.40-FF-001025', NULL, 'Actin-related protein 8', 182, NULL, NULL, 199706),
(199707, '2.10.25.10-FF-000090', NULL, 'laminin subunit alpha', 52, NULL, NULL, 199707),
(199708, '3.30.530.20-FF-000179', NULL, 'Os03g0287100 protein', 106, NULL, NULL, 199708),
(199709, '3.30.470.20-FF-000224', NULL, 'Uncharacterized protein', 153, NULL, NULL, 199709),
(199710, '3.60.15.10-FF-000079', NULL, 'Metallo-hydrolase/oxidoreductase, putative', 283, NULL, NULL, 199710),
(199711, '3.50.50.60-FF-000552', NULL, 'Anaerobic glycerol-3-phosphate dehydrogenase subunit B', 75, NULL, NULL, 199711);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(199712, '3.20.20.140-FF-000051', NULL, 'Dihydroorotase protein', 266, NULL, NULL, 199712),
(199713, '3.30.40.10-FF-000661', NULL, 'Rco1p', 65, NULL, NULL, 199713),
(199714, '3.30.160.60-FF-001275', NULL, 'Zinc finger protein 425', 27, NULL, NULL, 199714),
(199715, '3.40.1190.20-FF-000109', NULL, 'Ribokinase', 302, NULL, NULL, 199715),
(199716, '3.90.45.10-FF-000017', NULL, 'Peptide deformylase', 178, NULL, NULL, 199716),
(199717, '3.40.1410.10-FF-000035', NULL, 'GntR family transcriptional regulator', 156, NULL, NULL, 199717),
(199718, '3.30.160.60-FF-003545', NULL, NULL, 24, NULL, NULL, 199718),
(199719, '1.20.1050.10-FF-000064', NULL, 'tRNA-aminoacylation cofactor ARC1', 124, NULL, NULL, 199719),
(199720, '1.10.150.770-FF-000002', NULL, 'Probable peptidoglycan D,D-transpeptidase PenA', 70, NULL, NULL, 199720),
(199721, '1.25.40.10-FF-002836', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 136, NULL, NULL, 199721),
(199722, '3.30.420.40-FF-000845', NULL, 'Actin-related protein 2', 76, NULL, NULL, 199722),
(199723, '2.130.10.10-FF-005209', NULL, 'Predicted protein', 92, NULL, NULL, 199723),
(199724, '3.90.79.10-FF-000298', NULL, 'Uncharacterized protein', 43, NULL, NULL, 199724),
(199725, '2.60.40.770-FF-000019', NULL, 'Uncharacterized protein', 122, NULL, NULL, 199725),
(199726, '3.30.160.60-FF-005327', NULL, NULL, 74, NULL, NULL, 199726),
(199727, '2.60.120.10-FF-000203', NULL, 'cAMP-dependent protein kinase regulatory subunit, putative', 140, NULL, NULL, 199727),
(199728, '3.90.550.10-FF-000574', NULL, 'Uncharacterized protein', 299, NULL, NULL, 199728),
(199729, '3.40.50.300-FF-001028', NULL, 'Class II major histocompatibility complex transactivator', 220, NULL, NULL, 199729),
(199730, '3.50.50.60-FF-000861', NULL, 'Uncharacterized protein', 302, NULL, NULL, 199730),
(199731, '1.20.1250.20-FF-002291', NULL, 'Uncharacterized protein', 70, NULL, NULL, 199731),
(199732, '1.10.238.10-FF-000559', NULL, 'Calcium-binding EF-hand domain-containing protein', 74, NULL, NULL, 199732),
(199733, '2.30.26.10-FF-000006', NULL, 'Dihydroorotate dehydrogenase family protein', 27, NULL, NULL, 199733),
(199734, '3.40.50.12760-FF-000003', NULL, 'Cap methyltransferase 2', 158, NULL, NULL, 199734),
(199735, '3.40.50.150-FF-001820', NULL, NULL, 91, NULL, NULL, 199735),
(199736, '3.30.70.330-FF-000543', NULL, 'Pabp2, isoform B', 85, NULL, NULL, 199736),
(199737, '3.30.450.20-FF-000650', NULL, 'Sensory box sensor histidine kinase', 118, NULL, NULL, 199737),
(199738, '1.20.1070.10-FF-002190', NULL, 'Predicted protein', 71, NULL, NULL, 199738),
(199739, '1.10.510.10-FF-003452', NULL, NULL, 276, NULL, NULL, 199739),
(199740, '1.10.510.10-FF-003082', NULL, NULL, 201, NULL, NULL, 199740),
(199741, '3.40.50.300-FF-001337', NULL, 'Dynein heavy chain, putative', 172, NULL, NULL, 199741),
(199742, '3.30.1330.40-FF-000045', NULL, 'Uncharacterized protein', 131, NULL, NULL, 199742),
(199743, '1.20.5.170-FF-000129', NULL, 'Heme-responsive zinc finger transcription factor HAP1', 37, NULL, NULL, 199743),
(199744, '1.10.287.70-FF-000044', NULL, 'Voltage-dependent N-type calcium channel subunit alpha', 114, NULL, NULL, 199744),
(199745, '3.40.50.12470-FF-000006', NULL, '2-oxoglutarate dehydrogenase, mitochondrial isoform X5', 226, NULL, NULL, 199745),
(199746, '3.30.450.20-FF-000341', NULL, 'Nuclear receptor coactivator 3', 133, NULL, NULL, 199746),
(199747, '1.10.287.130-FF-000124', NULL, 'Two-component system, OmpR family, sensor histidine kinase KdpD', 81, NULL, NULL, 199747),
(199748, '3.10.20.90-FF-000488', NULL, 'Predicted NADPH oxidase activator 1', 84, NULL, NULL, 199748),
(199749, '1.20.1720.10-FF-000053', NULL, 'Bcr/CflA family efflux transporter', 379, NULL, NULL, 199749),
(199750, '3.80.10.10-FF-001719', NULL, 'AGAP011930-PA', 182, NULL, NULL, 199750),
(199751, '3.40.20.10-FF-000002', NULL, 'Gelsolin', 126, NULL, NULL, 199751),
(199752, '1.20.1510.10-FF-000083', NULL, NULL, 154, NULL, NULL, 199752),
(199753, '3.30.2060.10-FF-000004', NULL, 'Transcription-repair-coupling factor', 88, NULL, NULL, 199753);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(199754, '1.10.510.10-FF-003109', NULL, NULL, 193, NULL, NULL, 199754),
(199755, '3.40.50.150-FF-000668', NULL, 'Uncharacterized protein', 275, NULL, NULL, 199755),
(199756, '3.90.190.10-FF-000091', NULL, 'Phosphatase domain containing paladin 1', 212, NULL, NULL, 199756),
(199757, '3.40.50.2300-FF-000492', NULL, 'Sugar ABC transporter substrate-binding protein', 123, NULL, NULL, 199757),
(199758, '3.90.640.10-FF-000210', NULL, 'Uncharacterized protein', 32, NULL, NULL, 199758),
(199759, '1.25.40.720-FF-000010', NULL, 'Telomere length regulation protein, putative', 88, NULL, NULL, 199759),
(199760, '3.80.10.10-FF-004007', NULL, 'Predicted protein', 150, NULL, NULL, 199760),
(199761, '1.20.80.10-FF-000062', NULL, 'Uncharacterized protein', 73, NULL, NULL, 199761),
(199762, '3.40.50.2300-FF-000828', NULL, NULL, 127, NULL, NULL, 199762),
(199763, '2.130.10.10-FF-003074', NULL, 'Ribosome biogenesis protein NSA1', 121, NULL, NULL, 199763),
(199764, '3.30.70.330-FF-002651', NULL, NULL, 120, NULL, NULL, 199764),
(199765, '1.25.40.10-FF-003207', NULL, 'XPA binding protein 2', 82, NULL, NULL, 199765),
(199766, '2.30.40.10-FF-000141', NULL, 'Alpha-D-ribose 1-methylphosphonate 5-triphosphate diphosphatase', 46, NULL, NULL, 199766),
(199767, '2.30.29.30-FF-000800', NULL, 'Guanine nucleotide exchange factor Cdc24 homologue, putative', 177, NULL, NULL, 199767),
(199768, '3.40.50.1820-FF-000241', NULL, 'LipY', 226, NULL, NULL, 199768),
(199769, '1.20.1560.10-FF-000029', NULL, 'ABC transporter B family member 1', 339, NULL, NULL, 199769),
(199770, '3.30.40.10-FF-000526', NULL, 'PHD and ring finger domains 1', 81, NULL, NULL, 199770),
(199771, '3.30.40.10-FF-001032', NULL, 'RBR-type E3 ubiquitin transferase', 84, NULL, NULL, 199771),
(199772, '3.40.1110.10-FF-000023', NULL, 'Copper-transporting ATPase 1, putative', 182, NULL, NULL, 199772),
(199773, '3.60.15.10-FF-000096', NULL, 'Metallo-beta-lactamase type 2', 228, NULL, NULL, 199773),
(199774, '3.40.50.150-FF-001466', NULL, NULL, 133, NULL, NULL, 199774),
(199775, '2.160.20.10-FF-000145', NULL, 'Pectinesterase', 373, NULL, NULL, 199775),
(199776, '3.40.710.10-FF-000103', NULL, 'Membrane carboxypeptidase/penicillin-binding protein', 411, NULL, NULL, 199776),
(199777, '2.20.28.30-FF-000006', NULL, 'DNA-directed RNA polymerasese, putative', 47, NULL, NULL, 199777),
(199778, '1.10.400.10-FF-000038', NULL, 'Guanine nucleotide binding protein (G protein), alpha 13b', 92, NULL, NULL, 199778),
(199779, '1.10.510.10-FF-001209', NULL, 'Kinase like protein', 69, NULL, NULL, 199779),
(199780, '3.40.720.10-FF-000031', NULL, 'arylsulfatase G isoform X1', 368, NULL, NULL, 199780),
(199781, '3.90.190.10-FF-000135', NULL, 'Dual specificity protein phosphatase, putative', 161, NULL, NULL, 199781),
(199782, '2.60.40.420-FF-000145', NULL, 'Auracyanin-A', 123, NULL, NULL, 199782),
(199783, '2.20.28.20-FF-000003', NULL, 'Methionyl-tRNA synthetase', 34, NULL, NULL, 199783),
(199784, '3.40.1410.10-FF-000052', NULL, 'Lmo2004 protein', 149, NULL, NULL, 199784),
(199785, '1.10.630.10-FF-000173', NULL, 'Cytochrome P450', 404, NULL, NULL, 199785),
(199786, '3.40.190.10-FF-000686', NULL, 'Mutant transferrin', 97, NULL, NULL, 199786),
(199787, '3.40.30.10-FF-001048', NULL, 'Glr3964 protein', 182, NULL, NULL, 199787),
(199788, '3.40.850.10-FF-000361', NULL, 'Chitin synthase', 272, NULL, NULL, 199788),
(199789, '2.70.170.10-FF-000199', NULL, 'Uncharacterized protein', 174, NULL, NULL, 199789),
(199790, '2.10.70.10-FF-000132', NULL, 'Uncharacterized protein', 55, NULL, NULL, 199790),
(199791, '2.130.10.10-FF-001174', NULL, 'Mtc5p', 311, NULL, NULL, 199791),
(199792, '3.30.930.10-FF-000122', NULL, 'Histidine--tRNA ligase', 329, NULL, NULL, 199792),
(199793, '3.30.420.40-FF-000828', NULL, 'Actin-related protein 6', 125, NULL, NULL, 199793),
(199794, '2.60.120.260-FF-000488', NULL, 'Putative galactosidae', 114, NULL, NULL, 199794),
(199795, '1.10.238.10-FF-000868', NULL, 'Uncharacterized protein', 98, NULL, NULL, 199795),
(199796, '3.40.50.10240-FF-000040', NULL, 'Uncharacterized protein', 98, NULL, NULL, 199796);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(199797, '3.30.342.10-FF-000036', NULL, 'DNA polymerase', 172, NULL, NULL, 199797),
(199798, '3.30.365.10-FF-000061', NULL, 'Uncharacterized protein', 60, NULL, NULL, 199798),
(199799, '2.60.34.10-FF-000086', NULL, 'YALI0B12474p', 140, NULL, NULL, 199799),
(199800, '3.30.450.20-FF-000324', NULL, 'Two-component sensor histidine kinase', 140, NULL, NULL, 199800),
(199801, '2.40.128.330-FF-000002', NULL, 'Inner membrane magnesium transporter mrs2', 90, NULL, NULL, 199801),
(199802, '2.60.40.10-FF-003107', NULL, 'Predicted protein', 98, NULL, NULL, 199802),
(199803, '4.10.60.10-FF-000195', NULL, 'Uncharacterized protein', 35, NULL, NULL, 199803),
(199804, '3.90.920.10-FF-000029', NULL, 'Os05g0358200 protein', 104, NULL, NULL, 199804),
(199805, '2.60.40.380-FF-000009', NULL, 'Alkaline phosphatase, putative', 104, NULL, NULL, 199805),
(199806, '1.10.510.10-FF-000794', NULL, 'Serine/threonine protein kinase', 339, NULL, NULL, 199806),
(199807, '2.30.18.10-FF-000016', NULL, 'Transcription factor IIA, alpha/beta subunit-domain-containing protein', 58, NULL, NULL, 199807),
(199808, '3.90.1150.10-FF-000413', NULL, 'Uncharacterized protein', 57, NULL, NULL, 199808),
(199809, '1.20.5.1500-FF-000004', NULL, 'Nucleosome assembly protein Nap1', 60, NULL, NULL, 199809),
(199810, '3.40.630.10-FF-000187', NULL, 'Nicastrin', 274, NULL, NULL, 199810),
(199811, '1.10.486.10-FF-000062', NULL, 'Predicted protein', 177, NULL, NULL, 199811),
(199812, '3.40.50.300-FF-003815', NULL, 'ATPase of the AAA+ class Posttranslational modification protein', 179, NULL, NULL, 199812),
(199813, '3.90.180.10-FF-000163', NULL, 'Zinc-type alcohol dehydrogenase-like protein C2E1P3.01', 137, NULL, NULL, 199813),
(199814, '3.80.10.10-FF-000308', NULL, 'tsukushin isoform X3', 163, NULL, NULL, 199814),
(199815, '3.40.50.1820-FF-001859', NULL, 'Uncharacterized protein', 52, NULL, NULL, 199815),
(199816, '2.60.40.10-FF-004389', NULL, NULL, 136, NULL, NULL, 199816),
(199817, '1.20.1720.10-FF-000036', NULL, 'Multidrug transporter', 266, NULL, NULL, 199817),
(199818, '1.10.1030.10-FF-000014', NULL, 'Carbamoyl-phosphate synthase large chain', 146, NULL, NULL, 199818),
(199819, '3.30.160.20-FF-000122', NULL, 'Glycosyl hydrolase family protein', 69, NULL, NULL, 199819),
(199820, '1.10.8.60-FF-000100', NULL, 'Chaperone protein ClpB1', 99, NULL, NULL, 199820),
(199821, '2.10.110.10-FF-000147', NULL, 'LIM/homeobox protein Awh-like protein', 55, NULL, NULL, 199821),
(199822, '3.80.10.10-FF-000410', NULL, 'Leucine-rich repeat receptor-like protein kinase PXL1', 102, NULL, NULL, 199822),
(199823, '3.40.250.10-FF-000202', NULL, 'Dual specificity protein phosphatase', 142, NULL, NULL, 199823),
(199824, '1.50.40.10-FF-000018', NULL, 'S-adenosylmethionine mitochondrial carrier protein-like', 263, NULL, NULL, 199824),
(199825, '3.40.50.300-FF-006817', NULL, 'Uncharacterized protein', 41, NULL, NULL, 199825),
(199826, '3.90.650.10-FF-000036', NULL, 'AIR synthase related protein', 171, NULL, NULL, 199826),
(199827, '3.40.50.300-FF-001680', NULL, 'BRCA1 interacting protein C-terminal helicase 1', 75, NULL, NULL, 199827),
(199828, '3.90.380.10-FF-000026', NULL, NULL, 278, NULL, NULL, 199828),
(199829, '3.40.630.30-FF-000243', NULL, 'GNAT family N-acetyltransferase', 159, NULL, NULL, 199829),
(199830, '3.50.50.60-FF-000198', NULL, 'Lysine-specific histone demethylase', 52, NULL, NULL, 199830),
(199831, '3.60.40.10-FF-000064', NULL, 'Protein phosphatase 2C 1', 297, NULL, NULL, 199831),
(199832, '3.80.10.10-FF-000264', NULL, 'NLR family CARD domain containing 5', 257, NULL, NULL, 199832),
(199833, '3.40.50.2000-FF-000166', NULL, 'Trehalose-phosphatase, variant 2', 201, NULL, NULL, 199833),
(199834, '1.10.1670.10-FF-000017', NULL, 'Related to 8-oxoguanine DNA-glycosylase', 49, NULL, NULL, 199834),
(199835, '1.10.274.100-FF-000027', NULL, 'DNA-directed RNA polymerase subunit', 154, NULL, NULL, 199835),
(199836, '2.170.120.12-FF-000039', NULL, 'Uncharacterized protein', 68, NULL, NULL, 199836),
(199837, '3.90.810.10-FF-000010', NULL, 'Related to Neural Wiskott-Aldrich syndrome protein', 60, NULL, NULL, 199837);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(199838, '1.50.10.20-FF-000003', NULL, 'Terpene cyclase/mutase family member', 349, NULL, NULL, 199838),
(199839, '1.10.287.1260-FF-000003', NULL, 'MscS Mechanosensitive ion channel', 120, NULL, NULL, 199839),
(199840, '1.10.287.70-FF-000370', NULL, 'Sodium channel protein 60E', 154, NULL, NULL, 199840),
(199841, '2.60.120.260-FF-000590', NULL, 'Uncharacterized protein', 156, NULL, NULL, 199841),
(199842, '3.40.50.300-FF-003580', NULL, 'ATP-dependent DNA helicase', 214, NULL, NULL, 199842),
(199843, '3.20.20.80-FF-000052', NULL, 'Putative alpha-L-fucosidase 1', 320, NULL, NULL, 199843),
(199844, '2.60.120.10-FF-000788', NULL, 'Predicted protein', 144, NULL, NULL, 199844),
(199845, '3.30.70.1350-FF-000029', NULL, NULL, 86, NULL, NULL, 199845),
(199846, '3.30.750.24-FF-000138', NULL, 'AGAP013218-PA', 101, NULL, NULL, 199846),
(199847, '1.20.120.850-FF-000012', NULL, 'protein PHOTOPERIOD-INDEPENDENT EARLY FLOWERING 1 isoform X3', 61, NULL, NULL, 199847),
(199848, '3.40.1280.10-FF-000035', NULL, 'Putative pseudouridine methyltransferase', 205, NULL, NULL, 199848),
(199849, '3.30.160.60-FF-004647', NULL, NULL, 36, NULL, NULL, 199849),
(199850, '3.10.20.90-FF-000212', NULL, 'Par-3 family cell polarity regulator', 43, NULL, NULL, 199850),
(199851, '2.60.40.10-FF-001207', NULL, 'Sallimus, isoform P', 99, NULL, NULL, 199851),
(199852, '1.10.510.10-FF-002929', NULL, NULL, 196, NULL, NULL, 199852),
(199853, '2.60.40.1170-FF-000087', NULL, NULL, 110, NULL, NULL, 199853),
(199854, '1.20.920.10-FF-000204', NULL, 'Uncharacterized protein', 122, NULL, NULL, 199854),
(199855, '3.40.50.1860-FF-000011', NULL, 'Aspartate-glutamate racemase family', 122, NULL, NULL, 199855),
(199856, '3.80.10.10-FF-004333', NULL, 'Zyg-11-related, cell cycle regulator', 195, NULL, NULL, 199856),
(199857, '3.20.20.150-FF-000037', NULL, 'Expressed protein', 277, NULL, NULL, 199857),
(199858, '3.30.70.270-FF-000255', NULL, NULL, 130, NULL, NULL, 199858),
(199859, '2.130.10.10-FF-002894', NULL, 'Uncharacterized protein', 149, NULL, NULL, 199859),
(199860, '1.20.58.60-FF-000463', NULL, 'Uncharacterized protein', 86, NULL, NULL, 199860),
(199861, '1.10.8.60-FF-000324', NULL, 'Lon protease homolog', 94, NULL, NULL, 199861),
(199862, '3.40.50.150-FF-001174', NULL, NULL, 163, NULL, NULL, 199862),
(199863, '2.60.40.10-FF-002944', NULL, 'Cell adhesion molecule, putative', 93, NULL, NULL, 199863),
(199864, '3.40.50.11610-FF-000029', NULL, NULL, 35, NULL, NULL, 199864),
(199865, '3.60.10.10-FF-000118', NULL, 'Uncharacterized protein', 219, NULL, NULL, 199865),
(199866, '3.30.200.20-FF-000974', NULL, 'Uncharacterized protein', 45, NULL, NULL, 199866),
(199867, '2.40.240.10-FF-000020', NULL, 'Glutamine--tRNA ligase', 87, NULL, NULL, 199867),
(199868, '2.60.40.10-FF-003433', NULL, NULL, 105, NULL, NULL, 199868),
(199869, '2.10.110.10-FF-000164', NULL, 'Prickle planar cell polarity protein 4', 101, NULL, NULL, 199869),
(199870, '1.25.40.20-FF-000310', NULL, 'Ankyrin repeat and SOCS box containing 15', 68, NULL, NULL, 199870),
(199871, '3.30.43.10-FF-000033', NULL, 'Actin interacting protein-like protein', 101, NULL, NULL, 199871),
(199872, '2.60.120.200-FF-000077', NULL, 'vitamin K-dependent protein S', 167, NULL, NULL, 199872),
(199873, '3.20.20.190-FF-000116', NULL, NULL, 180, NULL, NULL, 199873),
(199874, '3.40.50.300-FF-001663', NULL, 'Superfamily I DNA helicase', 209, NULL, NULL, 199874),
(199875, '3.90.850.10-FF-000001', NULL, '2-oxo-hepta-3-ene-1,7-dioic acid hydratase', 267, NULL, NULL, 199875),
(199876, '2.20.110.10-FF-000010', NULL, 'Radial spoke head 1 homolog', 62, NULL, NULL, 199876),
(199877, '3.40.50.300-FF-000865', NULL, 'ATP-dependent RNA helicase DDX54', 232, NULL, NULL, 199877),
(199878, '3.90.650.10-FF-000019', NULL, 'Trifunctional purine biosynthetic protein adenosine-3', 193, NULL, NULL, 199878),
(199879, '3.30.420.40-FF-001008', NULL, 'Predicted protein', 63, NULL, NULL, 199879),
(199880, '1.10.510.10-FF-001535', NULL, 'Mitogen-activated protein kinase 9', 285, NULL, NULL, 199880),
(199881, '1.20.1250.20-FF-002318', NULL, 'Organic cation/carnitine transporter 7', 83, NULL, NULL, 199881);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(199882, '1.10.472.10-FF-000457', NULL, 'Uncharacterized protein', 141, NULL, NULL, 199882),
(199883, '3.40.50.10330-FF-000050', NULL, 'Sphingosine kinase 1', 144, NULL, NULL, 199883),
(199884, '1.25.40.10-FF-002499', NULL, 'SMG-7', 209, NULL, NULL, 199884),
(199885, '1.25.40.20-FF-001412', NULL, 'Exodeoxyribonuclease V', 163, NULL, NULL, 199885),
(199886, '3.40.50.150-FF-000994', NULL, NULL, 211, NULL, NULL, 199886),
(199887, '3.30.160.60-FF-004973', NULL, NULL, 95, NULL, NULL, 199887),
(199888, '3.40.50.1820-FF-000139', NULL, 'lysophospholipase-like protein 1', 237, NULL, NULL, 199888),
(199889, '1.10.8.10-FF-000225', NULL, 'UV excision repair RAD23 protein, putative', 46, NULL, NULL, 199889),
(199890, '2.40.50.140-FF-000438', NULL, 'DNA repair protein BRCA2, putative', 115, NULL, NULL, 199890),
(199891, '3.10.20.90-FF-001005', NULL, 'Ptk2.1 protein', 27, NULL, NULL, 199891),
(199892, '2.130.10.10-FF-005226', NULL, 'Uncharacterized protein', 62, NULL, NULL, 199892),
(199893, '3.20.20.140-FF-000034', NULL, 'putative deoxyribonuclease TATDN1 isoform X1', 296, NULL, NULL, 199893),
(199894, '3.30.1490.190-FF-000003', NULL, 'Fur family transcriptional regulator', 55, NULL, NULL, 199894),
(199895, '3.40.1280.10-FF-000018', NULL, 'uncharacterized protein LOC106771328 isoform X2', 246, NULL, NULL, 199895),
(199896, '1.25.10.10-FF-000738', NULL, 'VAC14p Enzyme regulator', 221, NULL, NULL, 199896),
(199897, '2.130.10.10-FF-004737', NULL, 'Uncharacterized protein', 163, NULL, NULL, 199897),
(199898, '1.20.58.1070-FF-000009', NULL, 'Gem-associated protein 2', 172, NULL, NULL, 199898),
(199899, '3.30.70.330-FF-000526', NULL, 'MKI67 (FHA domain) interacting nucleolar phosphoprotein', 118, NULL, NULL, 199899),
(199900, '3.40.50.720-FF-002188', NULL, 'Malate dehydrogenase 1Aa, NAD (soluble)', 43, NULL, NULL, 199900),
(199901, '1.20.58.60-FF-000480', NULL, 'Spectrin repeat containing, nuclear envelope 1a', 242, NULL, NULL, 199901),
(199902, '1.10.510.10-FF-002946', NULL, NULL, 35, NULL, NULL, 199902),
(199903, '2.20.70.10-FF-000093', NULL, 'NEDD4-like E3 ubiquitin-protein ligase WWP1', 45, NULL, NULL, 199903),
(199904, '3.40.50.720-FF-001699', NULL, 'D-glycerate dehydrogenase', 192, NULL, NULL, 199904),
(199905, '3.40.1000.30-FF-000010', NULL, 'F-box protein 7', 156, NULL, NULL, 199905),
(199906, '3.60.20.10-FF-000046', NULL, 'Proteasome subunit beta', 265, NULL, NULL, 199906),
(199907, '2.60.40.10-FF-001533', NULL, 'Immunoglobulin heavy variable 2-26', 114, NULL, NULL, 199907),
(199908, '3.40.30.10-FF-000885', NULL, 'Uncharacterized protein (Fragment)', 82, NULL, NULL, 199908),
(199909, '1.20.1560.10-FF-000473', NULL, 'ABC transporter ATP-binding protein', 319, NULL, NULL, 199909),
(199910, '3.40.50.12470-FF-000023', NULL, NULL, 120, NULL, NULL, 199910),
(199911, '3.40.50.300-FF-001354', NULL, 'ATP-binding cassette (ABC) transporter, putative', 257, NULL, NULL, 199911),
(199912, '1.10.510.10-FF-003435', NULL, NULL, 284, NULL, NULL, 199912),
(199913, '2.60.120.200-FF-000386', NULL, 'Pentaxin', 207, NULL, NULL, 199913),
(199914, '1.20.5.170-FF-000146', NULL, 'Atg16p', 75, NULL, NULL, 199914),
(199915, '2.70.160.11-FF-000014', NULL, 'Protein arginine N-methyltransferase 7', 187, NULL, NULL, 199915),
(199916, '1.10.287.70-FF-000061', NULL, 'Sodium leak channel non-selective protein', 130, NULL, NULL, 199916),
(199917, '2.40.50.140-FF-000747', NULL, NULL, 148, NULL, NULL, 199917),
(199918, '3.20.20.140-FF-000343', NULL, 'Uncharacterized protein', 344, NULL, NULL, 199918),
(199919, '3.40.50.300-FF-008588', NULL, 'Predicted protein', 162, NULL, NULL, 199919),
(199920, '3.40.50.10540-FF-000006', NULL, 'GG15379', 114, NULL, NULL, 199920),
(199921, '3.30.450.20-FF-000195', NULL, 'Cell wall metabolism sensor histidine kinase WalK', 151, NULL, NULL, 199921),
(199922, '2.60.40.10-FF-001842', NULL, 'Uncharacterized protein, isoform B', 87, NULL, NULL, 199922),
(199923, '3.40.50.12780-FF-000144', NULL, 'NRPS-like enzyme, putative (AFU_orthologue AFUA_8G01222)', 184, NULL, NULL, 199923),
(199924, '1.20.1560.10-FF-000164', NULL, 'ABC transporter ATP-binding protein', 320, NULL, NULL, 199924); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(199925, '2.30.42.10-FF-000656', NULL, NULL, 50, NULL, NULL, 199925),
(199926, '2.160.10.10-FF-000088', NULL, 'L-fucose kinase-like', 126, NULL, NULL, 199926),
(199927, '3.60.15.10-FF-000225', NULL, 'Uncharacterized protein', 92, NULL, NULL, 199927),
(199928, '2.30.30.40-FF-000548', NULL, 'Predicted protein', 137, NULL, NULL, 199928),
(199929, '3.30.70.330-FF-000397', NULL, 'RNA binding protein Nrd1', 88, NULL, NULL, 199929),
(199930, '3.30.200.20-FF-000648', NULL, 'Non-specific serine/threonine protein kinase', 23, NULL, NULL, 199930),
(199931, '3.30.40.10-FF-000217', NULL, 'E3 ubiquitin-protein ligase At1g12760', 66, NULL, NULL, 199931),
(199932, '1.20.990.10-FF-000023', NULL, 'NADPH-cytochrome P450 reductase, putative', 122, NULL, NULL, 199932),
(199933, '2.60.120.970-FF-000021', NULL, 'Growth differentiation factor 6', 166, NULL, NULL, 199933),
(199934, '2.60.120.290-FF-000031', NULL, 'Low-density lipoprotein receptor-related protein 3', 115, NULL, NULL, 199934),
(199935, '3.90.640.10-FF-000081', NULL, 'Actin-related protein RO7, putative', 115, NULL, NULL, 199935),
(199936, '3.30.230.10-FF-000147', NULL, 'Elongation factor 2, putative', 152, NULL, NULL, 199936),
(199937, '1.10.3470.10-FF-000036', NULL, 'Iron chelate uptake ABC transporter, FeCT family, permease protein', 338, NULL, NULL, 199937),
(199938, '3.40.50.410-FF-000313', NULL, 'Phospholipase A(2)', 128, NULL, NULL, 199938),
(199939, '3.40.50.300-FF-004917', NULL, 'Uncharacterized protein, isoform B', 192, NULL, NULL, 199939),
(199940, '3.40.50.300-FF-003506', NULL, 'Predicted protein', 82, NULL, NULL, 199940),
(199941, '3.30.70.3320-FF-000002', NULL, NULL, 93, NULL, NULL, 199941),
(199942, '3.60.10.10-FF-000220', NULL, 'Putative inositol polyphosphate phosphatase (Synaptogenin-like) family protein', 382, NULL, NULL, 199942),
(199943, '1.25.10.10-FF-001227', NULL, 'Serine/threonine-protein kinase TOR', 175, NULL, NULL, 199943),
(199944, '3.40.50.1000-FF-000793', NULL, NULL, 170, NULL, NULL, 199944),
(199945, '1.20.120.20-FF-000023', NULL, 'Apolipoprotein E', 107, NULL, NULL, 199945),
(199946, '3.30.160.60-FF-005462', NULL, NULL, 31, NULL, NULL, 199946),
(199947, '1.25.40.470-FF-000081', NULL, 'Coatomer subunit beta''-3', 65, NULL, NULL, 199947),
(199948, '3.40.50.300-FF-005715', NULL, 'Si:dkey-11m19.5', 165, NULL, NULL, 199948),
(199949, '1.20.120.1080-FF-000060', NULL, 'Helicase, putative', 102, NULL, NULL, 199949),
(199950, '3.40.50.300-FF-006688', NULL, 'Uncharacterized protein', 81, NULL, NULL, 199950),
(199951, '3.40.50.80-FF-000036', NULL, 'Ferric reduction oxidase 6', 122, NULL, NULL, 199951),
(199952, '1.10.340.30-FF-000078', NULL, 'Uncharacterized protein', 93, NULL, NULL, 199952),
(199953, '3.90.70.80-FF-000046', NULL, 'Uncharacterized protein', 79, NULL, NULL, 199953),
(199954, '1.20.1080.10-FF-000099', NULL, 'Entomoglyceroporin 1', 225, NULL, NULL, 199954),
(199955, '3.40.50.300-FF-005406', NULL, 'Uncharacterized protein', 123, NULL, NULL, 199955),
(199956, '1.25.40.10-FF-004753', NULL, 'Uncharacterized protein', 65, NULL, NULL, 199956),
(199957, '2.30.42.10-FF-000347', NULL, 'Membrane associated guanylate kinase, WW and PDZ domain containing 3', 68, NULL, NULL, 199957),
(199958, '3.40.50.970-FF-000088', NULL, 'Putative acetolactate synthase IlvG', 179, NULL, NULL, 199958),
(199959, '1.20.1070.10-FF-000273', NULL, 'Relaxin family peptide/INSL5 receptor 4', 295, NULL, NULL, 199959),
(199960, '3.90.1800.10-FF-000014', NULL, 'DNA-directed RNA polymerase subunit beta', 63, NULL, NULL, 199960),
(199961, '2.80.10.70-FF-000008', NULL, 'Uncharacterized protein', 73, NULL, NULL, 199961),
(199962, '3.40.50.300-FF-007177', NULL, 'Uncharacterized protein', 172, NULL, NULL, 199962),
(199963, '3.40.50.300-FF-003254', NULL, 'Helicase domain-containing protein', 270, NULL, NULL, 199963),
(199964, '3.10.20.70-FF-000038', NULL, 'Glutamine synthetase, type I', 109, NULL, NULL, 199964),
(199965, '2.60.120.590-FF-000031', NULL, 'AlkB, isoform A', 187, NULL, NULL, 199965),
(199966, '3.80.10.10-FF-001899', NULL, 'Tubulin folding cofactor E', 146, NULL, NULL, 199966);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(199967, '4.10.1000.10-FF-000105', NULL, 'Uncharacterized protein', 92, NULL, NULL, 199967),
(199968, '3.30.470.30-FF-000098', NULL, 'Uncharacterized protein', 212, NULL, NULL, 199968),
(199969, '3.80.10.10-FF-002517', NULL, 'Toll-like receptor 4b, duplicate b', 63, NULL, NULL, 199969),
(199970, '3.30.70.330-FF-000088', NULL, 'msx2-interacting protein-like isoform X1', 77, NULL, NULL, 199970),
(199971, '3.30.470.20-FF-000095', NULL, 'SyNapsiN', 117, NULL, NULL, 199971),
(199972, '1.25.40.570-FF-000021', NULL, 'Putative proteasome regulatory particle subunit', 288, NULL, NULL, 199972),
(199973, '3.30.420.270-FF-000020', NULL, 'Biopolymer transport protein exbD', 68, NULL, NULL, 199973),
(199974, '3.40.50.300-FF-007632', NULL, 'Uncharacterized protein', 143, NULL, NULL, 199974),
(199975, '3.30.470.20-FF-000207', NULL, 'Predicted protein', 264, NULL, NULL, 199975),
(199976, '3.30.160.60-FF-003528', NULL, 'Meiotic P26, isoform C', 50, NULL, NULL, 199976),
(199977, '2.60.40.420-FF-000263', NULL, 'Uncharacterized protein', 63, NULL, NULL, 199977),
(199978, '1.10.472.80-FF-000213', NULL, NULL, 167, NULL, NULL, 199978),
(199979, '1.25.40.20-FF-000102', NULL, 'ankyrin repeat and KH domain-containing protein 1 isoform X2', 203, NULL, NULL, 199979),
(199980, '3.40.366.10-FF-000027', NULL, 'Malonyl CoA-acyl carrier protein transacylase', 213, NULL, NULL, 199980),
(199981, '2.60.40.10-FF-001281', NULL, 'Interferon gamma receptor 2', 108, NULL, NULL, 199981),
(199982, '3.30.160.390-FF-000002', NULL, 'Site-specific recombinase, phage integrase family', 63, NULL, NULL, 199982),
(199983, '1.25.40.10-FF-002819', NULL, 'Uncharacterized protein', 155, NULL, NULL, 199983),
(199984, '1.20.1050.10-FF-000081', NULL, 'Methionyl-tRNA synthetase', 94, NULL, NULL, 199984),
(199985, '2.60.120.650-FF-000173', NULL, 'Uncharacterized protein', 145, NULL, NULL, 199985),
(199986, '3.40.50.300-FF-001219', NULL, 'Adenylyl-sulfate kinase', 194, NULL, NULL, 199986),
(199987, '3.30.870.10-FF-000089', NULL, 'Phospholipase D', 172, NULL, NULL, 199987),
(199988, '2.30.29.30-FF-000137', NULL, 'Low density lipoprotein receptor adapter protein 1', 136, NULL, NULL, 199988),
(199989, '3.40.630.10-FF-000069', NULL, 'Acetylornithine deacetylase', 241, NULL, NULL, 199989),
(199990, '3.30.390.30-FF-000052', NULL, 'Predicted protein', 47, NULL, NULL, 199990),
(199991, '1.20.58.1070-FF-000010', NULL, 'Uncharacterized protein', 219, NULL, NULL, 199991),
(199992, '1.20.120.20-FF-000039', NULL, 'LOC100135198 protein', 164, NULL, NULL, 199992),
(199993, '2.30.40.10-FF-000023', NULL, 'Imidazolonepropionase-like amidohydrolase', 66, NULL, NULL, 199993),
(199994, '3.40.50.150-FF-000786', NULL, 'Predicted protein', 188, NULL, NULL, 199994),
(199995, '1.20.58.60-FF-000446', NULL, 'Dystrophin-1', 176, NULL, NULL, 199995),
(199996, '3.40.228.10-FF-000016', NULL, 'Probable oxidoreductase YyaE', 235, NULL, NULL, 199996),
(199997, '3.40.5.10-FF-000024', NULL, 'Uncharacterized protein', 55, NULL, NULL, 199997),
(199998, '3.40.630.10-FF-000496', NULL, 'Aspartyl aminopeptidase', 109, NULL, NULL, 199998),
(199999, '3.40.50.720-FF-002396', NULL, 'Uncharacterized protein', 65, NULL, NULL, 199999),
(200000, '1.10.3380.30-FF-000041', NULL, 'ATP-dependent DNA helicase Hel308', 219, NULL, NULL, 200000),
(200001, '1.10.10.60-FF-000348', NULL, 'Transcription factor MYB26', 70, NULL, NULL, 200001),
(200002, '1.10.150.20-FF-000257', NULL, 'Flap endonuclease 1', 68, NULL, NULL, 200002),
(200003, '2.30.29.30-FF-000671', NULL, 'Hypothetical_protein_-_conserved', 131, NULL, NULL, 200003),
(200004, '1.20.1460.20-FF-000002', NULL, 'V-type ATP synthase subunit I', 154, NULL, NULL, 200004),
(200005, '3.40.50.1820-FF-000550', NULL, 'LIPaSe related', 261, NULL, NULL, 200005),
(200006, '3.60.40.10-FF-000272', NULL, 'Uncharacterized protein', 374, NULL, NULL, 200006),
(200007, '1.20.1070.10-FF-001599', NULL, 'Uncharacterized protein', 152, NULL, NULL, 200007),
(200008, '2.40.420.20-FF-000003', NULL, 'Cation efflux system protein cusB', 88, NULL, NULL, 200008),
(200009, '3.20.20.100-FF-000163', NULL, 'Oxidoreductase, aldo/keto reductase family protein', 208, NULL, NULL, 200009);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(200010, '2.130.10.10-FF-000359', NULL, 'Eukaryotic translation initiation factor 2A', 192, NULL, NULL, 200010),
(200011, '3.40.50.720-FF-002407', NULL, 'Uncharacterized protein', 217, NULL, NULL, 200011),
(200012, '3.40.50.360-FF-000028', NULL, 'NAD(P)H-dependent FMN reductase', 174, NULL, NULL, 200012),
(200013, '3.30.40.10-FF-002252', NULL, 'Histone-lysine N-methyltransferase', 57, NULL, NULL, 200013),
(200014, '2.60.120.740-FF-000003', NULL, 'Protein eva-1 homolog C', 103, NULL, NULL, 200014),
(200015, '3.90.1800.10-FF-000031', NULL, 'Predicted protein', 41, NULL, NULL, 200015),
(200016, '1.10.472.80-FF-000112', NULL, 'Rab GTPase activating protein putative', 119, NULL, NULL, 200016),
(200017, '2.40.50.140-FF-000955', NULL, NULL, 59, NULL, NULL, 200017),
(200018, '1.25.40.10-FF-003180', NULL, 'Pentatricopeptide repeat-containing protein At4g19191, mitochondrial', 221, NULL, NULL, 200018),
(200019, '2.60.40.10-FF-002961', NULL, 'Uncharacterized protein', 78, NULL, NULL, 200019),
(200020, '3.40.640.10-FF-000098', NULL, 'Glutamic-oxaloacetic transaminase 1 like 1', 240, NULL, NULL, 200020),
(200021, '2.130.10.10-FF-000786', NULL, 'Ribosome biogenesis protein BOP1 homolog', 290, NULL, NULL, 200021),
(200022, '2.60.40.10-FF-001325', NULL, 'Leucine rich repeat containing 24', 113, NULL, NULL, 200022),
(200023, '3.30.420.10-FF-000156', NULL, 'DNA polymerase', 283, NULL, NULL, 200023),
(200024, '2.60.220.50-FF-000094', NULL, 'Pkd1l2, putative', 78, NULL, NULL, 200024),
(200025, '1.20.1250.20-FF-000183', NULL, 'sodium-dependent lysophosphatidylcholine symporter 1 isoform X2', 215, NULL, NULL, 200025),
(200026, '2.10.25.10-FF-000056', NULL, 'Latent-transforming growth factor beta-binding protein 3 isoform 2', 42, NULL, NULL, 200026),
(200027, '1.25.40.10-FF-003224', NULL, 'Uncharacterized protein', 61, NULL, NULL, 200027),
(200028, '3.30.230.10-FF-000355', NULL, '30S ribosomal protein S9', 132, NULL, NULL, 200028),
(200029, '3.40.640.10-FF-000468', NULL, 'Uncharacterized protein', 114, NULL, NULL, 200029),
(200030, '3.30.200.160-FF-000005', NULL, 'TFC1-like protein', 142, NULL, NULL, 200030),
(200031, '3.30.70.330-FF-000189', NULL, 'RNA-binding protein 42 isoform X2', 135, NULL, NULL, 200031),
(200032, '3.30.470.20-FF-000196', NULL, 'Uncharacterized protein', 20, NULL, NULL, 200032),
(200033, '1.25.40.10-FF-004961', NULL, 'Intraflagellar transport protein', 162, NULL, NULL, 200033),
(200034, '3.60.10.10-FF-000236', NULL, 'Serpentine receptor class gamma', 343, NULL, NULL, 200034),
(200035, '3.30.428.10-FF-000067', NULL, 'Uncharacterized protein', 169, NULL, NULL, 200035),
(200036, '3.30.710.10-FF-000403', NULL, 'Predicted protein', 136, NULL, NULL, 200036),
(200037, '3.30.160.60-FF-004956', NULL, NULL, 85, NULL, NULL, 200037),
(200038, '3.30.300.30-FF-000114', NULL, 'Nonribosomal peptide synthetase, discrete adenylation domain', 103, NULL, NULL, 200038),
(200039, '1.25.50.20-FF-000030', NULL, 'GM24727', 320, NULL, NULL, 200039),
(200040, '3.30.40.10-FF-000009', NULL, 'E3 ubiquitin-protein ligase RNF130', 89, NULL, NULL, 200040),
(200041, '3.20.20.140-FF-000017', NULL, 'Adenosine deaminase 2', 485, NULL, NULL, 200041),
(200042, '1.10.10.10-FF-001373', NULL, 'Ferric uptake regulator, Fur family', 84, NULL, NULL, 200042),
(200043, '2.60.120.200-FF-000268', NULL, 'Sialidase B', 192, NULL, NULL, 200043),
(200044, '1.10.800.10-FF-000001', NULL, 'tryptophan 5-hydroxylase 1', 436, NULL, NULL, 200044),
(200045, '3.20.20.330-FF-000001', NULL, 'Methionine synthase', 337, NULL, NULL, 200045),
(200046, '3.50.50.60-FF-001024', NULL, 'FAD/NAD(P)-binding domain-containing protein', 130, NULL, NULL, 200046),
(200047, '3.40.50.11500-FF-000013', NULL, 'Uncharacterized protein', 185, NULL, NULL, 200047),
(200048, '3.50.50.60-FF-000518', NULL, 'Steroid monooxygenase, putative', 104, NULL, NULL, 200048),
(200049, '1.20.1720.10-FF-000019', NULL, 'DHA2 family efflux MFS transporter permease subunit', 238, NULL, NULL, 200049),
(200050, '2.60.260.20-FF-000155', NULL, 'Uncharacterized protein', 98, NULL, NULL, 200050),
(200051, '2.60.120.260-FF-000516', NULL, 'Beta-galactosidase', 32, NULL, NULL, 200051);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(200052, '3.90.1150.10-FF-000385', NULL, 'Uncharacterized protein', 34, NULL, NULL, 200052),
(200053, '1.20.58.1780-FF-000026', NULL, 'Nuclear pore protein', 118, NULL, NULL, 200053),
(200054, '2.10.25.10-FF-001736', NULL, 'Adhesion G protein-coupled receptor E1', 38, NULL, NULL, 200054),
(200055, '1.20.1270.60-FF-000145', NULL, 'Uncharacterized protein', 251, NULL, NULL, 200055),
(200056, '3.30.70.330-FF-001240', NULL, 'Uncharacterized protein', 122, NULL, NULL, 200056),
(200057, '1.25.40.20-FF-001530', NULL, 'Kinase, NEK', 61, NULL, NULL, 200057),
(200058, '3.30.160.60-FF-005670', NULL, NULL, 28, NULL, NULL, 200058),
(200059, '3.10.450.350-FF-000015', NULL, 'Murein DD-endopeptidase MepM and murein hydrolase activator NlpD, contain LysM domain', 115, NULL, NULL, 200059),
(200060, '3.30.70.660-FF-000041', NULL, 'tRNA pseudouridine synthase', 159, NULL, NULL, 200060),
(200061, '3.40.1310.20-FF-000007', NULL, 'Protein Rep68', 210, NULL, NULL, 200061),
(200062, '3.40.50.300-FF-003462', NULL, 'Mu phage large terminase subunit GpE', 190, NULL, NULL, 200062),
(200063, '3.30.40.10-FF-000318', NULL, 'E3 ubiquitin-protein ligase MARCH4', 69, NULL, NULL, 200063),
(200064, '2.40.50.140-FF-000540', NULL, 'Replication protein A 70 kDa DNA-binding subunit', 121, NULL, NULL, 200064),
(200065, '3.30.160.20-FF-000240', NULL, 'Uncharacterized protein', 62, NULL, NULL, 200065),
(200066, '1.10.10.800-FF-000004', NULL, 'DltD N-terminal domain protein', 79, NULL, NULL, 200066),
(200067, '2.120.10.80-FF-000268', NULL, 'Predicted protein', 302, NULL, NULL, 200067),
(200068, '2.170.140.10-FF-000055', NULL, 'Cht-1', 64, NULL, NULL, 200068),
(200069, '3.30.559.10-FF-000051', NULL, 'Nonribosomal peptide synthetase sidC', 181, NULL, NULL, 200069),
(200070, '3.90.190.10-FF-000343', NULL, 'Protein-tyrosine phosphatase', 171, NULL, NULL, 200070),
(200071, '3.40.50.300-FF-003153', NULL, 'ATP binding cassette subfamily C member 3', 111, NULL, NULL, 200071),
(200072, '3.60.15.10-FF-000124', NULL, 'DNA repair metallo-beta-lactamase, putative', 169, NULL, NULL, 200072),
(200073, '2.60.40.10-FF-005333', NULL, NULL, 75, NULL, NULL, 200073),
(200074, '1.20.1070.10-FF-000508', NULL, 'Vomeronasal type-1 receptor', 258, NULL, NULL, 200074),
(200075, '1.10.150.50-FF-000108', NULL, 'Uncharacterized protein, isoform A', 82, NULL, NULL, 200075),
(200076, '3.40.50.150-FF-001612', NULL, NULL, 252, NULL, NULL, 200076),
(200077, '3.80.10.10-FF-004451', NULL, 'LRR receptor-like serine/threonine-protein kinase EFR', 105, NULL, NULL, 200077),
(200078, '1.10.287.2620-FF-000006', NULL, 'Axonemal dynein heavy chain', 65, NULL, NULL, 200078),
(200079, '3.90.70.10-FF-000896', NULL, 'Ubiquitinyl hydrolase 1', 252, NULL, NULL, 200079),
(200080, '3.40.50.720-FF-000951', NULL, 'Probable 2-hydroxyacid dehydrogenase', 185, NULL, NULL, 200080),
(200081, '1.20.1280.290-FF-000049', NULL, 'Lysosomal amino acid transporter 1', 100, NULL, NULL, 200081),
(200082, '3.40.50.1260-FF-000011', NULL, 'Phosphoglycerate kinase', 177, NULL, NULL, 200082),
(200083, '1.20.120.1080-FF-000043', NULL, 'PRP2p RNA-dependent DExD/H-box ATPase', 150, NULL, NULL, 200083),
(200084, '1.20.58.60-FF-000345', NULL, 'SMAll', 118, NULL, NULL, 200084),
(200085, '3.30.160.60-FF-005361', NULL, NULL, 59, NULL, NULL, 200085),
(200086, '1.25.40.180-FF-000128', NULL, 'MA3_domain_containing_protein_-_putative', 306, NULL, NULL, 200086),
(200087, '3.40.50.1820-FF-000920', NULL, 'Predicted protein', 326, NULL, NULL, 200087),
(200088, '1.20.1250.20-FF-002173', NULL, 'Major facilitator superfamily transporter', 177, NULL, NULL, 200088),
(200089, '3.30.40.10-FF-000970', NULL, 'Ring finger protein 43', 67, NULL, NULL, 200089),
(200090, '1.20.1250.20-FF-002111', NULL, 'Uncharacterized protein', 231, NULL, NULL, 200090),
(200091, '1.10.10.60-FF-001163', NULL, NULL, 98, NULL, NULL, 200091),
(200092, '2.40.50.40-FF-000015', NULL, 'Histone-lysine N-methyltransferase', 63, NULL, NULL, 200092),
(200093, '3.80.10.10-FF-004350', NULL, 'Uncharacterized protein', 183, NULL, NULL, 200093),
(200094, '3.30.70.330-FF-002443', NULL, NULL, 86, NULL, NULL, 200094);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(200095, '3.40.1110.10-FF-000231', NULL, 'Phospholipid-transporting ATPase', 162, NULL, NULL, 200095),
(200096, '3.60.10.10-FF-000135', NULL, 'Sphingomyelin phosphodiesterase', 295, NULL, NULL, 200096),
(200097, '1.10.10.60-FF-000775', NULL, 'Muscle segment homeobox 2a', 103, NULL, NULL, 200097),
(200098, '3.10.20.770-FF-000023', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', 129, NULL, NULL, 200098),
(200099, '3.30.70.3490-FF-000019', NULL, 'Oxysterol binding protein (Osh3), putative', 70, NULL, NULL, 200099),
(200100, '3.20.20.190-FF-000133', NULL, NULL, 95, NULL, NULL, 200100),
(200101, '1.20.5.320-FF-000017', NULL, 'Collagen alpha-1(IX) chain', 52, NULL, NULL, 200101),
(200102, '3.90.70.10-FF-000907', NULL, 'Ubiquitinyl hydrolase 1', 236, NULL, NULL, 200102),
(200103, '3.40.190.10-FF-000259', NULL, 'ABC transporter substrate-binding protein-phosphate transport', 34, NULL, NULL, 200103),
(200104, '1.10.510.10-FF-001182', NULL, 'OSJNBa0061C06.4 protein', 217, NULL, NULL, 200104),
(200105, '2.60.40.10-FF-005024', NULL, NULL, 132, NULL, NULL, 200105),
(200106, '3.40.50.970-FF-000234', NULL, '2-oxoglutarate dehydrogenase E1 component', 362, NULL, NULL, 200106),
(200107, '1.20.58.400-FF-000041', NULL, 'Predicted protein', 89, NULL, NULL, 200107),
(200108, '2.40.50.960-FF-000004', NULL, 'Telomere replication protein EST3', 170, NULL, NULL, 200108),
(200109, '2.60.120.260-FF-000179', NULL, 'Possible hydrolase', 199, NULL, NULL, 200109),
(200110, '3.40.50.300-FF-000966', NULL, 'Peroxisomal biogenesis factor 1', 165, NULL, NULL, 200110),
(200111, '1.10.600.10-FF-000093', NULL, 'Farnesyl pyrophosphate synthase 2', 69, NULL, NULL, 200111),
(200112, '3.40.50.2300-FF-000183', NULL, 'Sugar ABC transporter substrate-binding protein', 128, NULL, NULL, 200112),
(200113, '3.30.160.60-FF-003427', NULL, NULL, 28, NULL, NULL, 200113),
(200114, '3.40.50.620-FF-000359', NULL, 'Probable arginine--tRNA ligase, cytoplasmic', 340, NULL, NULL, 200114),
(200115, '1.25.40.10-FF-002718', NULL, 'Uncharacterized protein', 300, NULL, NULL, 200115),
(200116, '1.10.150.170-FF-000002', NULL, 'Probable methyltransferase-like protein 15', 116, NULL, NULL, 200116),
(200117, '3.40.710.10-FF-000120', NULL, 'Penicillin-binding protein', 335, NULL, NULL, 200117),
(200118, '3.40.1190.20-FF-000110', NULL, 'Fructokinase', 323, NULL, NULL, 200118),
(200119, '3.30.70.330-FF-000852', NULL, 'Ribosomal protein L23', 111, NULL, NULL, 200119),
(200120, '1.10.238.10-FF-001048', NULL, 'Uncharacterized protein', 29, NULL, NULL, 200120),
(200121, '2.10.90.10-FF-000015', NULL, 'Glial cell line-derived neurotrophic factor', 101, NULL, NULL, 200121),
(200122, '3.50.50.60-FF-001232', NULL, 'Uncharacterized protein', 223, NULL, NULL, 200122),
(200123, '1.20.1740.10-FF-000127', NULL, 'Uncharacterized protein', 461, NULL, NULL, 200123),
(200124, '3.20.10.10-FF-000002', NULL, 'D-alanine aminotransferase', 163, NULL, NULL, 200124),
(200125, '3.40.309.10-FF-000058', NULL, 'Succinate-semialdehyde dehydrogenase', 190, NULL, NULL, 200125),
(200126, '3.40.50.720-FF-000390', NULL, 'GDH/6PGL endoplasmic bifunctional protein', 180, NULL, NULL, 200126),
(200127, '2.60.220.50-FF-000105', NULL, 'Adhesion G protein-coupled receptor E5', 201, NULL, NULL, 200127),
(200128, '1.20.5.300-FF-000011', NULL, 'Uncharacterized protein', 54, NULL, NULL, 200128),
(200129, '3.80.10.10-FF-000056', NULL, 'Leucine-rich repeat neuronal protein 1', 176, NULL, NULL, 200129),
(200130, '1.20.5.1200-FF-000004', NULL, 'Retinaldehyde binding protein 1b', 25, NULL, NULL, 200130),
(200131, '2.60.40.10-FF-003079', NULL, 'Sialic-acid binding protein-4', 86, NULL, NULL, 200131),
(200132, '1.20.1250.20-FF-000520', NULL, 'Major facilitator superfamily protein', 392, NULL, NULL, 200132),
(200133, '1.25.10.10-FF-003144', NULL, 'Uncharacterized protein', 95, NULL, NULL, 200133),
(200134, '2.130.10.10-FF-004838', NULL, 'WD-repeat containing protein', 132, NULL, NULL, 200134),
(200135, '3.40.50.300-FF-007205', NULL, 'Predicted protein', 167, NULL, NULL, 200135),
(200136, '1.20.1440.360-FF-000001', NULL, 'PATJ, crumbs cell polarity complex component', 81, NULL, NULL, 200136);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(200137, '1.20.1730.10-FF-000110', NULL, 'Uncharacterized protein', 172, NULL, NULL, 200137),
(200138, '1.20.58.2050-FF-000006', NULL, 'At1g19080', 165, NULL, NULL, 200138),
(200139, '3.40.1160.10-FF-000043', NULL, 'Aspartate kinase', 311, NULL, NULL, 200139),
(200140, '3.40.50.1820-FF-000802', NULL, 'AGAP006956-PA-like protein', 570, NULL, NULL, 200140),
(200141, '1.25.10.10-FF-000873', NULL, 'Heat repeat domain containing protein', 234, NULL, NULL, 200141),
(200142, '3.40.50.620-FF-000921', NULL, 'Tyrosine--tRNA ligase', 153, NULL, NULL, 200142),
(200143, '3.40.50.300-FF-007323', NULL, 'Uncharacterized protein', 145, NULL, NULL, 200143),
(200144, '1.25.10.10-FF-003026', NULL, 'Uncharacterized protein', 321, NULL, NULL, 200144),
(200145, '3.40.190.10-FF-000568', NULL, 'Glutamate receptor', 109, NULL, NULL, 200145),
(200146, '2.60.34.10-FF-000069', NULL, 'Uncharacterized protein', 198, NULL, NULL, 200146),
(200147, '1.10.10.10-FF-001272', NULL, 'RNA polymerase sigma-38 factor, stationary phase', 77, NULL, NULL, 200147),
(200148, '3.80.10.10-FF-002208', NULL, 'Si:dkey-261p22.1', 114, NULL, NULL, 200148),
(200149, '3.10.580.10-FF-000110', NULL, 'Os03g0674300 protein', 51, NULL, NULL, 200149),
(200150, '3.40.50.880-FF-000078', NULL, 'GMP synthase', 206, NULL, NULL, 200150),
(200151, '3.40.50.300-FF-005171', NULL, 'rab-like protein 3', 222, NULL, NULL, 200151),
(200152, '3.40.50.720-FF-000642', NULL, 'Short-chain dehydrogenase/reductase SDR', 265, NULL, NULL, 200152),
(200153, '3.60.20.10-FF-000063', NULL, 'Proteasome subunit alpha type', 232, NULL, NULL, 200153),
(200154, '1.20.90.10-FF-000034', NULL, NULL, 90, NULL, NULL, 200154),
(200155, '2.60.40.10-FF-000819', NULL, 'Usherin', 117, NULL, NULL, 200155),
(200156, '1.25.10.10-FF-001036', NULL, 'Putative CAS/CSE/importin domain protein', 958, NULL, NULL, 200156),
(200157, '3.60.90.10-FF-000011', NULL, 'S-adenosylmethionine decarboxylase proenzyme', 376, NULL, NULL, 200157),
(200158, '1.10.760.10-FF-000076', NULL, 'Probable cytochrome c', 117, NULL, NULL, 200158),
(200159, '3.40.50.2020-FF-000031', NULL, 'Probable PRS4-ribose-phosphate pyrophosphokinase 3', 139, NULL, NULL, 200159),
(200160, '3.30.70.850-FF-000024', NULL, 'Neuroendocrine convertase, putative', 51, NULL, NULL, 200160),
(200161, '2.40.50.140-FF-000646', NULL, 'Single-stranded DNA-binding protein', 151, NULL, NULL, 200161),
(200162, '3.20.20.70-FF-000150', NULL, 'Pyridoxine 5''-phosphate synthase', 238, NULL, NULL, 200162),
(200163, '3.30.200.20-FF-000839', NULL, 'Serine/threonine-protein kinase RIO3', 109, NULL, NULL, 200163),
(200164, '2.130.10.10-FF-000668', NULL, 'WD repeat-containing protein 13 isoform X3', 182, NULL, NULL, 200164),
(200165, '2.130.10.10-FF-002568', NULL, 'Syntaxin-binding protein 5 isoform A', 160, NULL, NULL, 200165),
(200166, '3.30.160.60-FF-003118', NULL, 'Zinc finger and AT-hook domain-containing', 20, NULL, NULL, 200166),
(200167, '3.30.420.10-FF-000038', NULL, 'IS30-like element IS30 family transposase', 148, NULL, NULL, 200167),
(200168, '1.25.40.430-FF-000030', NULL, 'Uncharacterized protein', 191, NULL, NULL, 200168),
(200169, '1.20.930.10-FF-000031', NULL, 'Uncharacterized protein', 146, NULL, NULL, 200169),
(200170, '3.30.70.3030-FF-000005', NULL, 'Nucleolar protein 6', 157, NULL, NULL, 200170),
(200171, '2.10.25.10-FF-000409', NULL, 'Pro-epidermal growth factor', 33, NULL, NULL, 200171),
(200172, '3.90.70.80-FF-000080', NULL, 'Uncharacterized protein', 121, NULL, NULL, 200172),
(200173, '2.40.50.40-FF-000116', NULL, 'Chromobox homolog 6b', 40, NULL, NULL, 200173),
(200174, '2.10.50.10-FF-000131', NULL, 'Tumor necrosis factor receptor superfamily, member 1a', 36, NULL, NULL, 200174),
(200175, '3.30.710.10-FF-000139', NULL, 'Leucine-zipper transcriptional regulator 1', 183, NULL, NULL, 200175),
(200176, '3.10.310.10-FF-000046', NULL, 'trans-L-3-hydroxyproline dehydratase-like', 175, NULL, NULL, 200176),
(200177, '3.30.70.3040-FF-000008', NULL, 'Cell division protein FtsX', 108, NULL, NULL, 200177),
(200178, '3.90.1280.20-FF-000015', NULL, NULL, 65, NULL, NULL, 200178);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(200179, '2.60.40.1250-FF-000004', NULL, 'Thiol:disulfide interchange protein DsbD', 124, NULL, NULL, 200179),
(200180, '1.10.510.10-FF-003643', NULL, NULL, 187, NULL, NULL, 200180),
(200181, '2.40.30.110-FF-000004', NULL, 'Pyruvate dehydrogenase phosphatase regulatory subunit, mitochondrial', 90, NULL, NULL, 200181),
(200182, '1.20.1080.10-FF-000037', NULL, 'Formate/nitrite transporter, putative', 262, NULL, NULL, 200182),
(200183, '2.60.40.60-FF-001071', NULL, 'Fat1 protein', 43, NULL, NULL, 200183),
(200184, '1.20.5.110-FF-000252', NULL, 'Syntaxin-7A', 113, NULL, NULL, 200184),
(200185, '3.90.180.10-FF-000062', NULL, 'Related to ADH2-Alcohol dehydrogenase II', 186, NULL, NULL, 200185),
(200186, '1.20.920.10-FF-000103', NULL, 'Uncharacterized protein', 115, NULL, NULL, 200186),
(200187, '1.10.510.10-FF-002738', NULL, NULL, 79, NULL, NULL, 200187),
(200188, '3.30.300.110-FF-000013', NULL, 'Methyltransferase', 75, NULL, NULL, 200188),
(200189, '1.20.58.1480-FF-000026', NULL, 'protein cereblon isoform X1', 66, NULL, NULL, 200189),
(200190, '1.10.340.70-FF-000039', NULL, 'Uncharacterized protein', 89, NULL, NULL, 200190),
(200191, '3.40.50.720-FF-000047', NULL, 'NADP-dependent L-serine/L-allo-threonine dehydrogenase', 246, NULL, NULL, 200191),
(200192, '3.20.20.20-FF-000039', NULL, 'Dihydropteroate synthase', 290, NULL, NULL, 200192),
(200193, '3.30.950.10-FF-000022', NULL, 'Uroporphyrin-III C-methyltransferase', 122, NULL, NULL, 200193),
(200194, '1.20.58.60-FF-000137', NULL, 'nesprin-1 isoform X2', 112, NULL, NULL, 200194),
(200195, '3.40.225.10-FF-000009', NULL, 'Class II aldolase/adducin N-terminal', 257, NULL, NULL, 200195),
(200196, '1.10.287.70-FF-000027', NULL, 'Small conductance calcium-activated potassium channel, isoform O', 260, NULL, NULL, 200196),
(200197, '3.50.50.60-FF-000097', NULL, 'Fructosyl amino acid oxidase', 213, NULL, NULL, 200197),
(200198, '1.25.40.10-FF-004309', NULL, 'Uncharacterized protein', 185, NULL, NULL, 200198),
(200199, '1.10.10.10-FF-000558', NULL, 'ETS variant 7', 107, NULL, NULL, 200199),
(200200, '2.40.30.100-FF-000001', NULL, 'Chaperonin involved in protein secretion (CsaA protein)', 78, NULL, NULL, 200200),
(200201, '3.40.50.300-FF-007514', NULL, 'Uncharacterized protein', 214, NULL, NULL, 200201),
(200202, '1.25.40.180-FF-000336', NULL, NULL, 157, NULL, NULL, 200202),
(200203, '3.30.160.60-FF-001319', NULL, 'Spalt like transcription factor 4', 24, NULL, NULL, 200203),
(200204, '3.30.160.60-FF-005018', NULL, NULL, 88, NULL, NULL, 200204),
(200205, '1.10.8.10-FF-000124', NULL, 'Defective in cullin neddylation protein 1', 48, NULL, NULL, 200205),
(200206, '3.50.50.60-FF-000209', NULL, 'Rab GDP dissociation inhibitor', 182, NULL, NULL, 200206),
(200207, '3.40.50.2000-FF-000845', NULL, 'Predicted protein', 245, NULL, NULL, 200207),
(200208, '1.10.420.10-FF-000039', NULL, 'Uncharacterized protein', 135, NULL, NULL, 200208),
(200209, '2.10.25.10-FF-000308', NULL, 'Sushi, nidogen and EGF like domains 1', 42, NULL, NULL, 200209),
(200210, '2.10.10.100-FF-000009', NULL, NULL, 65, NULL, NULL, 200210),
(200211, '3.90.660.10-FF-000110', NULL, NULL, 192, NULL, NULL, 200211),
(200212, '3.40.50.620-FF-000567', NULL, 'Uncharacterized protein', 183, NULL, NULL, 200212),
(200213, '3.30.160.60-FF-003219', NULL, 'Zinc finger protein', 26, NULL, NULL, 200213),
(200214, '3.30.160.60-FF-005119', NULL, NULL, 35, NULL, NULL, 200214),
(200215, '3.40.50.620-FF-000051', NULL, 'Leucine--tRNA ligase', 179, NULL, NULL, 200215),
(200216, '3.30.450.20-FF-000133', NULL, 'Methyl-accepting chemotaxis protein signaling domain protein', 135, NULL, NULL, 200216),
(200217, '2.60.40.10-FF-001634', NULL, 'Beat-IIIc, isoform B', 102, NULL, NULL, 200217),
(200218, '1.20.58.60-FF-000036', NULL, 'Plectin a', 120, NULL, NULL, 200218),
(200219, '3.40.50.2300-FF-000149', NULL, 'Ribose operon repressor', 130, NULL, NULL, 200219),
(200220, '2.60.40.10-FF-003006', NULL, 'Ephrin type-A receptor 2', 56, NULL, NULL, 200220),
(200221, '1.25.40.10-FF-000358', NULL, 'Intraflagellar transport protein 88 homolog', 110, NULL, NULL, 200221);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(200222, '1.25.40.20-FF-001075', NULL, 'Ankyrin repeat, SAM and basic leucine zipper domain containing 1', 66, NULL, NULL, 200222),
(200223, '1.25.40.10-FF-001072', NULL, 'Vacuolar protein sorting-associated protein 41 homolog', 274, NULL, NULL, 200223),
(200224, '1.10.10.60-FF-000657', NULL, 'Uncharacterized protein', 85, NULL, NULL, 200224),
(200225, '3.30.160.60-FF-001067', NULL, 'C2H2 transcription factor (Egr2)', 26, NULL, NULL, 200225),
(200226, '2.60.40.150-FF-000497', NULL, 'Synaptotagmin 1', 141, NULL, NULL, 200226),
(200227, '1.20.1560.10-FF-000372', NULL, 'Related to multidrug resistance protein 4', 335, NULL, NULL, 200227),
(200228, '2.60.40.1090-FF-000040', NULL, 'Type 1 fimbrial protein', 151, NULL, NULL, 200228),
(200229, '2.40.160.110-FF-000046', NULL, 'Uncharacterized protein', 89, NULL, NULL, 200229),
(200230, '1.10.10.10-FF-001064', NULL, 'Histone acetyltransferase', 91, NULL, NULL, 200230),
(200231, '1.20.58.70-FF-000039', NULL, 'Syntaxin VAM3', 97, NULL, NULL, 200231),
(200232, '3.40.50.620-FF-000713', NULL, 'Nicotinamide-nucleotide adenylyltransferase', 220, NULL, NULL, 200232),
(200233, '3.40.190.90-FF-000002', NULL, 'Fructose-1,6-bisphosphatase', 158, NULL, NULL, 200233),
(200234, '3.40.50.300-FF-005614', NULL, 'Uncharacterized protein', 114, NULL, NULL, 200234),
(200235, '3.40.50.12160-FF-000020', NULL, 'tRNA methylthiotransferase YqeV', 127, NULL, NULL, 200235),
(200236, '3.40.50.300-FF-008397', NULL, 'Uncharacterized protein', 180, NULL, NULL, 200236),
(200237, '2.60.120.200-FF-000723', NULL, 'Uncharacterized protein', 241, NULL, NULL, 200237),
(200238, '3.40.50.150-FF-001039', NULL, NULL, 151, NULL, NULL, 200238),
(200239, '3.90.215.10-FF-000020', NULL, 'Uncharacterized protein', 213, NULL, NULL, 200239),
(200240, '1.20.1070.10-FF-000065', NULL, 'G-protein coupled receptor 4', 299, NULL, NULL, 200240),
(200241, '3.90.870.10-FF-000002', NULL, '3,4-dihydroxy-2-butanone 4-phosphate synthase', 215, NULL, NULL, 200241),
(200242, '3.30.40.10-FF-000560', NULL, 'Putative PHD finger domain protein', 82, NULL, NULL, 200242),
(200243, '2.30.29.30-FF-000019', NULL, 'Amyloid beta (A4) precursor protein-binding, family B, member 1 (Fe65)', 144, NULL, NULL, 200243),
(200244, '2.150.10.10-FF-000021', NULL, NULL, 123, NULL, NULL, 200244),
(200245, '3.40.50.11660-FF-000022', NULL, 'Uncharacterized protein', 218, NULL, NULL, 200245),
(200246, '3.40.50.1370-FF-000061', NULL, NULL, 90, NULL, NULL, 200246),
(200247, '3.10.180.10-FF-000029', NULL, 'Lactoylglutathione lyase', 167, NULL, NULL, 200247),
(200248, '3.40.1440.60-FF-000006', NULL, 'Primosomal protein N''', 110, NULL, NULL, 200248),
(200249, '3.40.50.10490-FF-000165', NULL, NULL, 125, NULL, NULL, 200249),
(200250, '1.20.1050.10-FF-000209', NULL, 'Predicted protein', 143, NULL, NULL, 200250),
(200251, '1.20.1560.10-FF-000063', NULL, 'Multidrug resistance protein ABC transporter', 334, NULL, NULL, 200251),
(200252, '2.60.40.10-FF-003315', NULL, 'Contactin rig-6', 84, NULL, NULL, 200252),
(200253, '2.40.50.140-FF-000394', NULL, 'rRNA biogenesis protein RRP5', 85, NULL, NULL, 200253),
(200254, '3.90.1860.10-FF-000006', NULL, 'tRNA-splicing_ligase_RtcB_-_putative', 351, NULL, NULL, 200254),
(200255, '3.30.2350.10-FF-000077', NULL, 'Predicted protein', 174, NULL, NULL, 200255),
(200256, '1.10.287.130-FF-000225', NULL, 'Two-component hybrid sensor and regulator', 105, NULL, NULL, 200256),
(200257, '2.60.40.10-FF-004759', NULL, NULL, 98, NULL, NULL, 200257),
(200258, '3.40.50.1110-FF-000123', NULL, 'Membrane-bound dehydrogenase domain protein', 206, NULL, NULL, 200258),
(200259, '3.30.1010.10-FF-000147', NULL, 'Uncharacterized protein', 110, NULL, NULL, 200259),
(200260, '3.40.50.300-FF-001781', NULL, 'septin-12 isoform X2', 146, NULL, NULL, 200260),
(200261, '4.10.520.10-FF-000018', NULL, 'DNA binding protein HU', 92, NULL, NULL, 200261),
(200262, '3.30.710.10-FF-000049', NULL, 'leucine-zipper-like transcriptional regulator 1 isoform X1', 186, NULL, NULL, 200262),
(200263, '2.30.42.10-FF-000555', NULL, NULL, 65, NULL, NULL, 200263);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(200264, '2.130.10.10-FF-002000', NULL, 'Protein HIRA', 151, NULL, NULL, 200264),
(200265, '3.40.1190.20-FF-000126', NULL, 'Fructokinase', 308, NULL, NULL, 200265),
(200266, '3.20.20.80-FF-000405', NULL, 'Glucosylceramidase', 102, NULL, NULL, 200266),
(200267, '3.60.20.10-FF-000164', NULL, NULL, 226, NULL, NULL, 200267),
(200268, '3.40.50.620-FF-000258', NULL, 'YdcF family protein', 134, NULL, NULL, 200268),
(200269, '3.40.50.300-FF-007059', NULL, 'Uncharacterized protein', 196, NULL, NULL, 200269),
(200270, '3.80.10.10-FF-002551', NULL, 'Protein zer-1', 150, NULL, NULL, 200270),
(200271, '3.40.30.10-FF-001256', NULL, 'Uncharacterized protein', 114, NULL, NULL, 200271),
(200272, '3.15.10.30-FF-000015', NULL, NULL, 171, NULL, NULL, 200272),
(200273, '3.30.420.40-FF-000862', NULL, 'Uncharacterized protein', 103, NULL, NULL, 200273),
(200274, '1.25.10.10-FF-002879', NULL, 'Uncharacterized protein', 149, NULL, NULL, 200274),
(200275, '3.90.226.10-FF-000293', NULL, 'Uncharacterized protein', 175, NULL, NULL, 200275),
(200276, '3.30.56.10-FF-000012', NULL, 'Phenylalanine-tRNA ligase, beta subunit', 72, NULL, NULL, 200276),
(200277, '1.10.510.10-FF-002828', NULL, 'Receptor tyrosine-protein kinase erbB-2', 205, NULL, NULL, 200277),
(200278, '3.100.10.10-FF-000019', NULL, '50S ribosomal protein L15', 73, NULL, NULL, 200278),
(200279, '3.30.420.10-FF-000302', NULL, 'Poly(A)-specific ribonuclease PARN', 175, NULL, NULL, 200279),
(200280, '1.20.920.10-FF-000013', NULL, 'Protein polybromo-1 isoform 1', 115, NULL, NULL, 200280),
(200281, '3.40.50.12230-FF-000002', NULL, 'Bifunctional polymyxin resistance protein ArnA', 304, NULL, NULL, 200281),
(200282, '3.90.1150.10-FF-000267', NULL, 'UDP-4-amino-4,6-dideoxy-N-acetyl-beta-L-altrosamine transaminase', 130, NULL, NULL, 200282),
(200283, '3.90.640.10-FF-000209', NULL, 'Cell division protein FtsA', 65, NULL, NULL, 200283),
(200284, '1.25.40.720-FF-000009', NULL, 'Putative Clathrin interactor', 81, NULL, NULL, 200284),
(200285, '2.60.40.1930-FF-000011', NULL, 'Complement C5', 100, NULL, NULL, 200285),
(200286, '3.60.130.10-FF-000032', NULL, 'Os01g0190000 protein', 57, NULL, NULL, 200286),
(200287, '3.80.10.10-FF-000409', NULL, 'NLR family CARD domain containing 4', 455, NULL, NULL, 200287),
(200288, '1.20.1270.60-FF-000027', NULL, 'dynamin-binding protein isoform X1', 221, NULL, NULL, 200288),
(200289, '3.20.20.80-FF-000714', NULL, 'Uncharacterized protein', 182, NULL, NULL, 200289),
(200290, '6.10.140.2220-FF-000021', NULL, 'Putative ubiquitin carboxyl-terminal hydrolase superfamily protein', 52, NULL, NULL, 200290),
(200291, '3.40.920.10-FF-000012', NULL, 'Oxoglutarate--ferredoxin oxidoreductase alpha subunit', 176, NULL, NULL, 200291),
(200292, '1.10.10.460-FF-000003', NULL, 'Ribonuclease', 37, NULL, NULL, 200292),
(200293, '3.10.100.10-FF-000255', NULL, NULL, 119, NULL, NULL, 200293),
(200294, '2.10.50.30-FF-000047', NULL, 'Uncharacterized protein', 64, NULL, NULL, 200294),
(200295, '3.30.200.20-FF-000278', NULL, 'Calcium/calmodulin-dependent protein kinase II', 90, NULL, NULL, 200295),
(200296, '2.60.40.10-FF-006098', NULL, NULL, 90, NULL, NULL, 200296),
(200297, '3.40.50.720-FF-002087', NULL, 'Sepiapterin reductase', 137, NULL, NULL, 200297),
(200298, '3.30.160.60-FF-001730', NULL, 'zinc finger protein 660', 36, NULL, NULL, 200298),
(200299, '1.25.40.10-FF-000667', NULL, 'Transcription factor TFIIIC subunit', 109, NULL, NULL, 200299),
(200300, '3.90.660.10-FF-000065', NULL, NULL, 207, NULL, NULL, 200300),
(200301, '3.40.50.1820-FF-000095', NULL, 'Triglyceride lipase-cholesterol esterase', 365, NULL, NULL, 200301),
(200302, '2.60.120.260-FF-000634', NULL, 'Uncharacterized protein', 111, NULL, NULL, 200302),
(200303, '3.40.50.300-FF-005524', NULL, 'Putative helicase of the dead superfamily protein', 114, NULL, NULL, 200303),
(200304, '1.20.1250.20-FF-000065', NULL, 'Putative MFS pantothenate transporter', 201, NULL, NULL, 200304),
(200305, '1.20.58.1120-FF-000047', NULL, NULL, 188, NULL, NULL, 200305),
(200306, '1.10.472.10-FF-000266', NULL, 'WGS project CABT00000000 data, contig 2.12', 123, NULL, NULL, 200306);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(200307, '1.10.220.30-FF-000013', NULL, 'Flagellar motor switch protein FliG', 94, NULL, NULL, 200307),
(200308, '3.30.70.260-FF-000044', NULL, 'Aspartokinase', 69, NULL, NULL, 200308),
(200309, '2.60.40.10-FF-004198', NULL, NULL, 82, NULL, NULL, 200309),
(200310, '3.40.50.300-FF-001472', NULL, 'SNF2 family N-terminal domain-domain-containing protein', 266, NULL, NULL, 200310),
(200311, '1.10.150.20-FF-000049', NULL, 'Plastid replication-repair enzyme', 138, NULL, NULL, 200311),
(200312, '1.20.1560.10-FF-000282', NULL, 'ATP-binding cassette transporter', 316, NULL, NULL, 200312),
(200313, '3.90.1070.20-FF-000005', NULL, 'DNA-directed RNA polymerase subunit beta', 94, NULL, NULL, 200313),
(200314, '1.20.1250.20-FF-002217', NULL, 'Uncharacterized protein', 136, NULL, NULL, 200314),
(200315, '2.60.40.60-FF-000918', NULL, 'Uncharacterized protein', 94, NULL, NULL, 200315),
(200316, '1.25.40.10-FF-005124', NULL, 'Predicted protein', 111, NULL, NULL, 200316),
(200317, '1.25.10.10-FF-002672', NULL, 'Predicted protein', 87, NULL, NULL, 200317),
(200318, '1.10.220.20-FF-000010', NULL, 'ArfGEF', 94, NULL, NULL, 200318),
(200319, '2.170.130.10-FF-000083', NULL, NULL, 123, NULL, NULL, 200319),
(200320, '3.80.10.10-FF-003945', NULL, 'Uncharacterized protein', 74, NULL, NULL, 200320),
(200321, '3.30.160.60-FF-003321', NULL, NULL, 28, NULL, NULL, 200321),
(200322, '3.30.160.60-FF-001421', NULL, 'Zinc finger protein 646', 33, NULL, NULL, 200322),
(200323, '3.40.50.1820-FF-000140', NULL, 'Esterase/lipase/thioesterase family protein', 273, NULL, NULL, 200323),
(200324, '1.10.101.10-FF-000034', NULL, 'Uncharacterized protein', 71, NULL, NULL, 200324),
(200325, '2.60.120.260-FF-000589', NULL, 'Uncharacterized protein', 157, NULL, NULL, 200325),
(200326, '2.30.30.830-FF-000003', NULL, 'General secretion pathway protein C', 67, NULL, NULL, 200326),
(200327, '3.40.630.10-FF-000378', NULL, 'Glutamate carboxypeptidase, putative', 90, NULL, NULL, 200327),
(200328, '2.30.29.30-FF-000480', NULL, 'Oxysterol-binding protein-related protein 2A', 127, NULL, NULL, 200328),
(200329, '3.30.40.210-FF-000006', NULL, 'Transcription elongation factor SPT4', 97, NULL, NULL, 200329),
(200330, '2.10.50.10-FF-000041', NULL, 'Tumor necrosis factor receptor superfamily member 5', 84, NULL, NULL, 200330),
(200331, '1.25.40.180-FF-000027', NULL, 'Eukaryotic translation initiation factor isoform 4G-2', 236, NULL, NULL, 200331),
(200332, '1.50.10.160-FF-000005', NULL, 'Terpene synthase family protein', 211, NULL, NULL, 200332),
(200333, '1.50.10.150-FF-000002', NULL, 'Tellurite resistance protein TehA', 316, NULL, NULL, 200333),
(200334, '2.30.30.100-FF-000138', NULL, 'Small nuclear ribonucleoprotein (LSM7), putative', 93, NULL, NULL, 200334),
(200335, '3.80.10.10-FF-003636', NULL, 'Leucine rich repeat, Ig-like and transmembrane domains 1', 97, NULL, NULL, 200335),
(200336, '3.40.220.10-FF-000004', NULL, 'chromodomain-helicase-DNA-binding protein 1-like isoform X1', 171, NULL, NULL, 200336),
(200337, '3.30.300.130-FF-000019', NULL, 'Nucleotide-binding protein', 100, NULL, NULL, 200337),
(200338, '1.20.920.20-FF-000016', NULL, 'Axonemal dynein heavy chain', 353, NULL, NULL, 200338),
(200339, '3.90.1070.10-FF-000002', NULL, 'Probable sucrose-phosphatase 1', 71, NULL, NULL, 200339),
(200340, '3.40.850.10-FF-000405', NULL, 'Uncharacterized protein', 261, NULL, NULL, 200340),
(200341, '3.30.160.60-FF-004855', NULL, NULL, 82, NULL, NULL, 200341),
(200342, '1.10.8.10-FF-000034', NULL, 'Sequestosome 1', 51, NULL, NULL, 200342),
(200343, '1.20.920.30-FF-000019', NULL, 'Dynein heavy chain at 89D, isoform B', 199, NULL, NULL, 200343),
(200344, '3.30.470.20-FF-000241', NULL, 'GTP-specific succinyl-CoA synthetase, beta subunit, putative', 63, NULL, NULL, 200344),
(200345, '2.60.40.1730-FF-000041', NULL, 'Protein CBG19917', 195, NULL, NULL, 200345),
(200346, '3.20.20.80-FF-000153', NULL, 'Chitinase A1', 317, NULL, NULL, 200346),
(200347, '1.20.1250.10-FF-000062', NULL, 'Uncharacterized protein', 157, NULL, NULL, 200347),
(200348, '2.130.10.30-FF-000106', NULL, NULL, 200, NULL, NULL, 200348);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(200349, '3.30.70.270-FF-000047', NULL, 'Diguanylate cyclase (GGDEF) domain protein', 156, NULL, NULL, 200349),
(200350, '1.20.1250.20-FF-000374', NULL, 'Uncharacterized protein', 191, NULL, NULL, 200350),
(200351, '2.60.40.10-FF-003225', NULL, 'Uncharacterized protein', 126, NULL, NULL, 200351),
(200352, '1.10.472.10-FF-000575', NULL, 'Uncharacterized protein', 52, NULL, NULL, 200352),
(200353, '2.130.10.10-FF-003282', NULL, 'Predicted protein', 356, NULL, NULL, 200353),
(200354, '3.90.70.200-FF-000013', NULL, 'RNA polymerase-associated protein RTF1 homolog', 131, NULL, NULL, 200354),
(200355, '2.160.20.10-FF-000263', NULL, 'Pectinesterase', 100, NULL, NULL, 200355),
(200356, '3.40.50.1820-FF-000656', NULL, 'Lipase', 392, NULL, NULL, 200356),
(200357, '3.40.367.20-FF-000010', NULL, 'Phosphotransferase', 257, NULL, NULL, 200357),
(200358, '3.40.190.10-FF-000714', NULL, 'Arginine-binding protein', 99, NULL, NULL, 200358),
(200359, '3.10.129.10-FF-000219', NULL, 'Thioesterase superfamily protein', 80, NULL, NULL, 200359),
(200360, '3.30.70.3020-FF-000002', NULL, 'U3 small nucleolar RNA-associated protein 22', 35, NULL, NULL, 200360),
(200361, '2.60.120.260-FF-000073', NULL, 'Laminin subunit beta 3', 239, NULL, NULL, 200361),
(200362, '3.40.50.2300-FF-000374', NULL, 'Type 4 fimbriae expression regulatory protein pilR', 135, NULL, NULL, 200362),
(200363, '3.40.50.2000-FF-000391', NULL, '2-deoxystreptamine N-acetyl-D-glucosaminyltransferase', 184, NULL, NULL, 200363),
(200364, '3.50.50.60-FF-000327', NULL, 'PROBABLE MONOXYGENASE', 248, NULL, NULL, 200364),
(200365, '3.40.1440.10-FF-000008', NULL, 'Structure-specific endonuclease subunit SLX1 homolog', 108, NULL, NULL, 200365),
(200366, '1.20.1070.10-FF-001953', NULL, 'Uncharacterized protein', 207, NULL, NULL, 200366),
(200367, '2.40.15.10-FF-000003', NULL, 'T cell leukemia/lymphoma 1B', 127, NULL, NULL, 200367),
(200368, '1.10.510.10-FF-001103', NULL, 'Tyrosine-protein kinase', 227, NULL, NULL, 200368),
(200369, '1.10.10.10-FF-001300', NULL, 'MarR family transcriptional regulator', 167, NULL, NULL, 200369),
(200370, '3.40.50.10490-FF-000081', NULL, 'Glucose-6-phosphate isomerase 2', 195, NULL, NULL, 200370),
(200371, '3.40.50.1910-FF-000032', NULL, 'Vacuolar protein sorting-associated protein 33B', 88, NULL, NULL, 200371),
(200372, '3.30.559.10-FF-000141', NULL, 'Probable alcohol acetyltransferase crmB', 165, NULL, NULL, 200372),
(200373, '3.90.1150.210-FF-000023', NULL, 'F-actin-capping protein subunit beta', 120, NULL, NULL, 200373),
(200374, '1.10.510.10-FF-003227', NULL, NULL, 127, NULL, NULL, 200374),
(200375, '3.40.50.300-FF-000949', NULL, 'RecBCD enzyme subunit RecB', 234, NULL, NULL, 200375),
(200376, '1.10.150.60-FF-000027', NULL, 'Putative arid bright dna binding domain containing protein', 126, NULL, NULL, 200376),
(200377, '1.10.268.10-FF-000010', NULL, 'DNA topoisomerase 2', 135, NULL, NULL, 200377),
(200378, '3.30.200.20-FF-001227', NULL, 'Uncharacterized protein', 16, NULL, NULL, 200378),
(200379, '3.40.20.10-FF-000103', NULL, 'Gelsolin, isoform J', 121, NULL, NULL, 200379),
(200380, '1.20.1270.10-FF-000046', NULL, 'Chaperone protein HscA homolog', 97, NULL, NULL, 200380),
(200381, '3.90.810.10-FF-000009', NULL, 'Wiskott-Aldrich syndrome (eczema-thrombocytopenia) a', 71, NULL, NULL, 200381),
(200382, '2.10.25.10-FF-000191', NULL, 'Multiple epidermal growth factor-like domains 8', 52, NULL, NULL, 200382),
(200383, '2.30.29.30-FF-000906', NULL, 'pleckstrin-2 isoform X2', 124, NULL, NULL, 200383),
(200384, '2.20.70.10-FF-000059', NULL, 'pleckstrin homology domain-containing family A member 7', 48, NULL, NULL, 200384),
(200385, '1.10.287.70-FF-000145', NULL, 'Eag-like K[+] channel, isoform B', 240, NULL, NULL, 200385),
(200386, '2.40.50.70-FF-000001', NULL, 'Shiga toxin 1 subunit B', 69, NULL, NULL, 200386),
(200387, '3.40.50.1820-FF-000347', NULL, 'EF-hand calcium-binding domain protein, putative (AFU_orthologue AFUA_2G01310)', 214, NULL, NULL, 200387),
(200388, '1.25.10.10-FF-001452', NULL, 'Formin, involved in spindle orientation, putative', 254, NULL, NULL, 200388);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(200389, '3.30.1120.30-FF-000032', NULL, 'CAMK family protein kinase', 101, NULL, NULL, 200389),
(200390, '1.10.950.10-FF-000006', NULL, 'Villin-2', 77, NULL, NULL, 200390),
(200391, '3.30.70.330-FF-002566', NULL, NULL, 145, NULL, NULL, 200391),
(200392, '2.60.40.10-FF-001090', NULL, 'T cell receptor beta constant 1', 129, NULL, NULL, 200392),
(200393, '1.25.10.10-FF-002447', NULL, 'Uncharacterized protein', 229, NULL, NULL, 200393),
(200394, '3.40.50.10380-FF-000031', NULL, 'Malic enzyme', 241, NULL, NULL, 200394),
(200395, '1.10.10.10-FF-001182', NULL, 'Uncharacterized protein', 98, NULL, NULL, 200395),
(200396, '3.30.300.130-FF-000036', NULL, NULL, 77, NULL, NULL, 200396),
(200397, '3.30.565.10-FF-000447', NULL, 'Histidine kinase', 104, NULL, NULL, 200397),
(200398, '3.30.70.330-FF-002459', NULL, NULL, 83, NULL, NULL, 200398),
(200399, '3.20.20.80-FF-000506', NULL, 'Uncharacterized protein', 116, NULL, NULL, 200399),
(200400, '3.90.190.10-FF-000220', NULL, 'Putative dual-specificity protein phosphatase, putative', 174, NULL, NULL, 200400),
(200401, '3.40.50.300-FF-005154', NULL, 'Uncharacterized protein', 229, NULL, NULL, 200401),
(200402, '3.30.2290.10-FF-000021', NULL, 'Microcin-processing peptidase 2 (TldD)', 218, NULL, NULL, 200402),
(200403, '3.30.70.260-FF-000134', NULL, 'ACT domain-containing protein ACR11', 65, NULL, NULL, 200403),
(200404, '1.50.10.20-FF-000121', NULL, 'Uncharacterized protein', 106, NULL, NULL, 200404),
(200405, '3.40.50.880-FF-000095', NULL, 'Putative glutamine amidotransferase', 220, NULL, NULL, 200405),
(200406, '3.40.50.150-FF-001056', NULL, '23S rRNA (Guanine(748)-N(1))-methyltransferase Erm(32)', 271, NULL, NULL, 200406),
(200407, '2.10.25.10-FF-000202', NULL, 'Multiple epidermal growth factor-like domains 8', 49, NULL, NULL, 200407),
(200408, '3.40.50.720-FF-001598', NULL, 'YALI0C11451p', 174, NULL, NULL, 200408),
(200409, '3.40.50.300-FF-002990', NULL, 'ATPase family AAA domain-containing protein 3', 201, NULL, NULL, 200409),
(200410, '1.20.1070.10-FF-000418', NULL, 'Predicted protein', 313, NULL, NULL, 200410),
(200411, '2.30.30.40-FF-000666', NULL, 'Predicted protein', 93, NULL, NULL, 200411),
(200412, '3.30.70.270-FF-000137', NULL, 'Pol polyprotein', 106, NULL, NULL, 200412),
(200413, '1.20.1560.10-FF-000400', NULL, 'ABC transporter PGP-2', 647, NULL, NULL, 200413),
(200414, '3.40.50.620-FF-000831', NULL, 'Uncharacterized protein', 249, NULL, NULL, 200414),
(200415, '1.10.150.50-FF-000024', NULL, 'Putative sam and sh3 domain-containing protein 1', 77, NULL, NULL, 200415),
(200416, '1.10.287.70-FF-000252', NULL, 'Uncharacterized protein', 139, NULL, NULL, 200416),
(200417, '3.40.50.300-FF-006935', NULL, 'Spr28p', 317, NULL, NULL, 200417),
(200418, '3.30.470.20-FF-000016', NULL, 'Ribosomal protein S6--L-glutamate ligase', 120, NULL, NULL, 200418),
(200419, '1.25.40.10-FF-000818', NULL, 'Sperm-associated antigen 1A', 125, NULL, NULL, 200419),
(200420, '1.10.1740.100-FF-000006', NULL, 'Histone-lysine N-methyltransferase', 111, NULL, NULL, 200420),
(200421, '3.40.50.1000-FF-000759', NULL, NULL, 139, NULL, NULL, 200421),
(200422, '1.10.10.410-FF-000011', NULL, 'Aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase subunit B', 61, NULL, NULL, 200422),
(200423, '1.20.910.10-FF-000041', NULL, 'Uncharacterized protein', 121, NULL, NULL, 200423),
(200424, '3.10.28.10-FF-000066', NULL, 'Probable translation initiation factor IF-2', 200, NULL, NULL, 200424),
(200425, '3.90.320.10-FF-000051', NULL, 'CRISPR-associated exonuclease Cas4', 213, NULL, NULL, 200425),
(200426, '3.40.390.10-FF-000117', NULL, 'Metalloendopeptidase', 194, NULL, NULL, 200426),
(200427, '1.50.10.20-FF-000109', NULL, 'Uncharacterized protein', 254, NULL, NULL, 200427),
(200428, '2.10.110.10-FF-000265', NULL, 'transcription factor protein', 60, NULL, NULL, 200428),
(200429, '2.30.42.10-FF-000448', NULL, NULL, 119, NULL, NULL, 200429),
(200430, '3.30.470.10-FF-000013', NULL, 'Branched-chain-amino-acid aminotransferase', 162, NULL, NULL, 200430),
(200431, '1.20.58.60-FF-000581', NULL, 'Plectin', 312, NULL, NULL, 200431);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(200432, '1.25.40.180-FF-000218', NULL, NULL, 134, NULL, NULL, 200432),
(200433, '1.10.1320.10-FF-000025', NULL, 'DNA-directed RNA polymerase', 65, NULL, NULL, 200433),
(200434, '3.30.2230.10-FF-000012', NULL, 'Ubiquitin-specific protease 5', 153, NULL, NULL, 200434),
(200435, '3.30.160.60-FF-003337', NULL, NULL, 25, NULL, NULL, 200435),
(200436, '1.50.10.10-FF-000106', NULL, 'Alpha-L-fucosidase', 423, NULL, NULL, 200436),
(200437, '1.25.40.10-FF-005332', NULL, 'Uncharacterized protein', 176, NULL, NULL, 200437),
(200438, '3.40.50.800-FF-000071', NULL, 'Threonine--tRNA ligase', 114, NULL, NULL, 200438),
(200439, '3.50.50.60-FF-000962', NULL, 'Thiamine biosynthesis oxidoreductase', 168, NULL, NULL, 200439),
(200440, '1.25.40.10-FF-004719', NULL, 'Pentatricopeptide repeat-containing protein', 89, NULL, NULL, 200440),
(200441, '3.40.50.10090-FF-000051', NULL, 'Uncharacterized protein', 113, NULL, NULL, 200441),
(200442, '1.20.1070.10-FF-000172', NULL, 'G protein-coupled receptor 50', 298, NULL, NULL, 200442),
(200443, '3.30.70.330-FF-000442', NULL, 'Multiple RNA-binding domain-containing protein 1', 103, NULL, NULL, 200443),
(200444, '3.60.110.10-FF-000031', NULL, 'Unplaced genomic scaffold supercont1.137, whole genome shotgun sequence', 309, NULL, NULL, 200444),
(200445, '3.50.50.60-FF-000653', NULL, 'D-amino acid dehydrogenase subunit', 138, NULL, NULL, 200445),
(200446, '3.40.190.10-FF-000922', NULL, 'Predicted protein', 75, NULL, NULL, 200446),
(200447, '3.90.550.10-FF-000675', NULL, 'Uncharacterized protein', 95, NULL, NULL, 200447),
(200448, '2.40.50.90-FF-000007', NULL, 'tudor domain-containing protein 5', 107, NULL, NULL, 200448),
(200449, '1.20.1540.10-FF-000056', NULL, 'Peptidase, S54 family', 191, NULL, NULL, 200449),
(200450, '3.30.460.10-FF-000041', NULL, 'PAP/25A associated domain containing protein', 110, NULL, NULL, 200450),
(200451, '1.20.120.1750-FF-000087', NULL, 'RBR-type E3 ubiquitin transferase', 63, NULL, NULL, 200451),
(200452, '1.25.40.10-FF-005023', NULL, 'Diguanylate cyclase', 150, NULL, NULL, 200452),
(200453, '3.30.420.40-FF-000946', NULL, 'Actin-like protein 3', 199, NULL, NULL, 200453),
(200454, '3.60.120.10-FF-000003', NULL, 'Anthranilate synthase component 1', 539, NULL, NULL, 200454),
(200455, '3.30.70.260-FF-000027', NULL, '(P)ppGpp synthetase II', 80, NULL, NULL, 200455),
(200456, '3.40.50.10190-FF-000002', NULL, 'Pescadillo homolog', 77, NULL, NULL, 200456),
(200457, '2.40.50.140-FF-001012', NULL, NULL, 36, NULL, NULL, 200457),
(200458, '3.30.160.60-FF-000696', NULL, 'Zinc finger and BTB domain containing 40', 29, NULL, NULL, 200458),
(200459, '3.40.50.150-FF-001382', NULL, NULL, 174, NULL, NULL, 200459),
(200460, '1.10.10.60-FF-000904', NULL, NULL, 64, NULL, NULL, 200460),
(200461, '1.10.10.10-FF-001502', NULL, 'Transcriptional regulator, Crp/Fnr family', 82, NULL, NULL, 200461),
(200462, '1.10.260.30-FF-000004', NULL, 'Signal recognition particle 54 kDa protein', 141, NULL, NULL, 200462),
(200463, '1.25.40.10-FF-002275', NULL, 'YALI0D16225p', 173, NULL, NULL, 200463),
(200464, '2.30.30.10-FF-000005', NULL, NULL, 56, NULL, NULL, 200464),
(200465, '3.30.70.250-FF-000024', NULL, NULL, 85, NULL, NULL, 200465),
(200466, '1.10.1410.40-FF-000013', NULL, 'ILF3 isoform 19', 38, NULL, NULL, 200466),
(200467, '3.60.70.12-FF-000012', NULL, 'Uncharacterized protein', 299, NULL, NULL, 200467),
(200468, '3.40.50.620-FF-000152', NULL, 'Isoleucine--tRNA ligase', 247, NULL, NULL, 200468),
(200469, '1.25.10.10-FF-002773', NULL, 'Exportin-T', 1085, NULL, NULL, 200469),
(200470, '1.25.40.10-FF-004399', NULL, 'Uncharacterized protein', 137, NULL, NULL, 200470),
(200471, '3.40.50.720-FF-000833', NULL, 'Phosphoglycerate dehydrogenase', 107, NULL, NULL, 200471),
(200472, '1.25.40.530-FF-000026', NULL, NULL, 199, NULL, NULL, 200472),
(200473, '3.10.20.90-FF-000004', NULL, 'Polyubiquitin Ubiquitin', 76, NULL, NULL, 200473),
(200474, '3.40.50.150-FF-001258', NULL, NULL, 285, NULL, NULL, 200474),
(200475, '3.30.70.330-FF-001150', NULL, 'RNP-1 like RNA-binding protein', 92, NULL, NULL, 200475);
INSERT INTO "PUBLIC"."MODEL" VALUES
(200476, '2.60.120.200-FF-000622', NULL, 'Uncharacterized protein', 139, NULL, NULL, 200476),
(200477, '3.30.2090.10-FF-000023', NULL, 'Transporter, AcrB/D/F family', 93, NULL, NULL, 200477),
(200478, '4.10.740.10-FF-000001', NULL, 'vitamin K-dependent protein S', 46, NULL, NULL, 200478),
(200479, '1.25.40.10-FF-003415', NULL, 'TPR repeat, putative', 115, NULL, NULL, 200479),
(200480, '3.30.310.80-FF-000034', NULL, 'Non-specific serine/threonine protein kinase', 129, NULL, NULL, 200480),
(200481, '2.60.40.1090-FF-000023', NULL, 'Fimbrial protein YfcV', 144, NULL, NULL, 200481),
(200482, '3.40.50.720-FF-000182', NULL, 'NAD-dependent malic enzyme', 295, NULL, NULL, 200482),
(200483, '3.30.70.330-FF-000661', NULL, 'Os08g0504600 protein', 119, NULL, NULL, 200483),
(200484, '2.60.120.200-FF-000162', NULL, 'Glycosidase', 253, NULL, NULL, 200484),
(200485, '2.60.120.200-FF-000313', NULL, 'L-type lectin-domain containing receptor kinase S.6', 252, NULL, NULL, 200485),
(200486, '3.40.850.10-FF-000260', NULL, 'Uncharacterized protein', 389, NULL, NULL, 200486),
(200487, '2.130.10.10-FF-005120', NULL, 'Uncharacterized protein', 104, NULL, NULL, 200487),
(200488, '3.40.570.10-FF-000013', NULL, 'Serine protease', 235, NULL, NULL, 200488),
(200489, '2.40.70.10-FF-000373', NULL, NULL, 200, NULL, NULL, 200489),
(200490, '3.40.1190.20-FF-000020', NULL, 'ADP-dependent glucokinase isoform X1', 344, NULL, NULL, 200490),
(200491, '3.40.50.300-FF-007071', NULL, 'Uncharacterized protein', 194, NULL, NULL, 200491),
(200492, '3.40.50.300-FF-005631', NULL, 'MutS protein homolog him-14', 296, NULL, NULL, 200492),
(200493, '3.40.50.620-FF-000612', NULL, 'Leucyl-tRNA synthetase 2, mitochondrial', 117, NULL, NULL, 200493),
(200494, '1.20.120.720-FF-000024', NULL, 'unconventional myosin-XV isoform X1', 160, NULL, NULL, 200494),
(200495, '3.60.40.10-FF-000300', NULL, 'Uncharacterized protein', 100, NULL, NULL, 200495),
(200496, '2.10.50.10-FF-000024', NULL, 'signal peptide, CUB and EGF-like domain-containing protein 1', 49, NULL, NULL, 200496),
(200497, '1.25.40.10-FF-002584', NULL, 'Pentatricopeptide repeat-containing protein', 79, NULL, NULL, 200497),
(200498, '2.60.40.10-FF-000898', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', 89, NULL, NULL, 200498),
(200499, '3.10.620.30-FF-000013', NULL, 'DNA helicase', 95, NULL, NULL, 200499),
(200500, '3.40.50.1980-FF-000148', NULL, 'Putative iron ABC transporter, periplasmic iron-binding protein', 157, NULL, NULL, 200500),
(200501, '3.90.226.10-FF-000186', NULL, 'Enoyl-CoA_hydratase/isomerase_family/2-enoyl-CoA_Hydratase_C-terminal_region_containing_protein', 196, NULL, NULL, 200501),
(200502, '3.40.50.300-FF-005940', NULL, 'AGAP008081-PA', 197, NULL, NULL, 200502),
(200503, '3.40.50.620-FF-000461', NULL, 'Glutamine-dependent NAD(+) synthetase', 278, NULL, NULL, 200503),
(200504, '3.70.10.10-FF-000011', NULL, 'Damaged DNA binding protein', 287, NULL, NULL, 200504),
(200505, '1.20.1090.10-FF-000055', NULL, '3-dehydroquinate synthase', 186, NULL, NULL, 200505),
(200506, '2.40.50.140-FF-000539', NULL, 'Replication protein A 70 kDa DNA-binding subunit', 181, NULL, NULL, 200506),
(200507, '3.30.470.30-FF-000019', NULL, 'Mitochondrial RNA ligase 1', 155, NULL, NULL, 200507),
(200508, '2.10.110.10-FF-000063', NULL, 'LIM domain-binding protein 2 isoform X2', 105, NULL, NULL, 200508),
(200509, '2.130.10.10-FF-002377', NULL, 'Os01g0551900 protein', 102, NULL, NULL, 200509),
(200510, '1.20.5.460-FF-000008', NULL, 'Listeriolysin transcriptional regulator PrfA', 27, NULL, NULL, 200510),
(200511, '3.30.160.20-FF-000004', NULL, 'Peptide chain release factor 1', 96, NULL, NULL, 200511),
(200512, '1.10.375.10-FF-000006', NULL, 'Gag polyprotein', 138, NULL, NULL, 200512),
(200513, '2.60.40.10-FF-005142', NULL, NULL, 96, NULL, NULL, 200513),
(200514, '3.40.50.1110-FF-000022', NULL, 'Isoamyl acetate-hydrolyzing esterase', 236, NULL, NULL, 200514),
(200515, '3.40.50.1460-FF-000071', NULL, 'Uncharacterized protein', 151, NULL, NULL, 200515),
(200516, '3.80.10.10-FF-004108', NULL, 'Uncharacterized protein', 119, NULL, NULL, 200516);
INSERT INTO "PUBLIC"."MODEL" VALUES
(200517, '3.40.50.150-FF-001691', NULL, NULL, 95, NULL, NULL, 200517),
(200518, '1.20.120.1630-FF-000034', NULL, 'Uncharacterized protein C7D4.09c', 167, NULL, NULL, 200518),
(200519, '2.40.50.140-FF-000293', NULL, '26S protease regulatory subunit 6B homolog', 119, NULL, NULL, 200519),
(200520, '3.60.10.10-FF-000326', NULL, 'Deoxyribonuclease', 256, NULL, NULL, 200520),
(200521, '1.10.1520.10-FF-000113', NULL, 'Endoribonuclease Dicer homolog 2', 62, NULL, NULL, 200521),
(200522, '1.10.10.60-FF-000893', NULL, NULL, 83, NULL, NULL, 200522),
(200523, '1.10.238.10-FF-001166', NULL, 'Uncharacterized protein', 102, NULL, NULL, 200523),
(200524, '3.30.565.10-FF-000554', NULL, 'Predicted protein', 39, NULL, NULL, 200524),
(200525, '2.70.70.10-FF-000006', NULL, 'M23 family peptidase', 151, NULL, NULL, 200525),
(200526, '3.60.15.10-FF-000197', NULL, 'Uncharacterized protein', 170, NULL, NULL, 200526),
(200527, '3.90.110.10-FF-000018', NULL, 'Malate dehydrogenase', 174, NULL, NULL, 200527),
(200528, '1.10.287.130-FF-000006', NULL, 'Osmolarity two-component histidine kinase EnvZ', 111, NULL, NULL, 200528),
(200529, '3.30.1490.20-FF-000005', NULL, 'Probable alpha-L-glutamate ligase 1', 66, NULL, NULL, 200529),
(200530, '3.20.20.80-FF-000260', NULL, '4-alpha-glucanotransferase DPE2', 333, NULL, NULL, 200530),
(200531, '2.60.40.1240-FF-000001', NULL, 'Immunogenic protein MPT63', 131, NULL, NULL, 200531),
(200532, '3.80.10.10-FF-002326', NULL, 'Leucine-rich repeat protein (LRRP), putative', 126, NULL, NULL, 200532),
(200533, '3.40.630.150-FF-000001', NULL, 'Malonyl-CoA decarboxylase, mitochondrial', 299, NULL, NULL, 200533),
(200534, '3.30.200.20-FF-000194', NULL, 'protein-tyrosine kinase 2-beta isoform X1', 91, NULL, NULL, 200534),
(200535, '2.130.10.10-FF-003517', NULL, 'Uncharacterized protein', 128, NULL, NULL, 200535),
(200536, '2.60.40.820-FF-000057', NULL, 'Uncharacterized protein', 40, NULL, NULL, 200536),
(200537, '1.10.510.10-FF-003334', NULL, NULL, 52, NULL, NULL, 200537),
(200538, '3.40.50.80-FF-000171', NULL, 'Uncharacterized protein', 133, NULL, NULL, 200538),
(200539, '1.25.40.20-FF-001620', NULL, 'Uncharacterized protein', 99, NULL, NULL, 200539),
(200540, '2.60.210.10-FF-000087', NULL, NULL, 172, NULL, NULL, 200540),
(200541, '2.170.270.10-FF-000177', NULL, 'Myeloid/lymphoid or mixed-lineage leukemia', 96, NULL, NULL, 200541),
(200542, '1.10.510.10-FF-002845', NULL, 'Receptor-like histidine kinase BpdS', 270, NULL, NULL, 200542),
(200543, '2.60.120.650-FF-000083', NULL, 'Protein CBG17151', 343, NULL, NULL, 200543),
(200544, '1.20.940.10-FF-000003', NULL, 'Protein transport protein SEC31 homolog B', 115, NULL, NULL, 200544),
(200545, '3.80.10.10-FF-004541', NULL, 'Os08g0196200 protein', 130, NULL, NULL, 200545),
(200546, '2.170.130.10-FF-000009', NULL, 'SusC/RagA family TonB-linked outer membrane protein', 130, NULL, NULL, 200546),
(200547, '2.40.128.180-FF-000013', NULL, NULL, 82, NULL, NULL, 200547),
(200548, '3.40.850.10-FF-000170', NULL, 'Kinesin-like protein', 403, NULL, NULL, 200548),
(200549, '1.20.58.60-FF-000255', NULL, 'VAB-10B protein', 118, NULL, NULL, 200549),
(200550, '3.30.70.360-FF-000057', NULL, 'Uncharacterized protein', 119, NULL, NULL, 200550),
(200551, '1.20.920.10-FF-000120', NULL, 'Uncharacterized protein', 76, NULL, NULL, 200551),
(200552, '3.40.30.10-FF-000969', NULL, 'Diacylglycerol O-acyltransferase 3', 97, NULL, NULL, 200552),
(200553, '3.90.740.10-FF-000049', NULL, 'Os01g0120300 protein', 136, NULL, NULL, 200553),
(200554, '3.40.630.30-FF-000035', NULL, 'GNAT family N-acetyltransferase', 149, NULL, NULL, 200554),
(200555, '3.30.70.1390-FF-000007', NULL, 'Predicted protein', 60, NULL, NULL, 200555),
(200556, '1.25.40.90-FF-000095', NULL, 'Uncharacterized protein', 139, NULL, NULL, 200556),
(200557, '3.40.50.10280-FF-000001', NULL, 'Putative methylene tetrahydromethanopterin dehydrogenase/methylenetetrahydrofolate dehydrogenase', 132, NULL, NULL, 200557),
(200558, '3.40.50.10190-FF-000311', NULL, 'Predicted protein', 97, NULL, NULL, 200558),
(200559, '3.30.70.330-FF-000970', NULL, 'Flowering time control protein FCA isoform A', 97, NULL, NULL, 200559);
INSERT INTO "PUBLIC"."MODEL" VALUES
(200560, '2.130.10.10-FF-002686', NULL, 'YALI0C18117p', 337, NULL, NULL, 200560),
(200561, '2.130.10.10-FF-000915', NULL, 'TLE family member 7', 315, NULL, NULL, 200561),
(200562, '3.30.1370.10-FF-000168', NULL, 'Exosome non-catalytic core subunit', 83, NULL, NULL, 200562),
(200563, '3.10.350.10-FF-000037', NULL, 'Class V chitinase Chi100', 48, NULL, NULL, 200563),
(200564, '3.30.1520.10-FF-000124', NULL, 'Uncharacterized protein', 174, NULL, NULL, 200564),
(200565, '1.20.1050.10-FF-000316', NULL, 'Methionine--tRNA ligase, cytoplasmic-like Protein', 102, NULL, NULL, 200565),
(200566, '3.40.50.2300-FF-000065', NULL, 'DNA-binding response regulator', 80, NULL, NULL, 200566),
(200567, '3.40.630.170-FF-000007', NULL, 'Glycylpeptide N-tetradecanoyltransferase', 136, NULL, NULL, 200567),
(200568, '1.10.8.10-FF-000141', NULL, 'Release factor glutamine methyltransferase', 76, NULL, NULL, 200568),
(200569, '1.10.287.70-FF-000471', NULL, 'Predicted protein', 289, NULL, NULL, 200569),
(200570, '1.20.5.370-FF-000009', NULL, 'Myosin heavy chain, isoform G', 54, NULL, NULL, 200570),
(200571, '3.50.50.60-FF-000434', NULL, 'Os04g0560500 protein', 51, NULL, NULL, 200571),
(200572, '3.60.15.10-FF-000208', NULL, 'Uncharacterized protein', 41, NULL, NULL, 200572),
(200573, '3.30.160.20-FF-000223', NULL, 'Uncharacterized protein', 93, NULL, NULL, 200573),
(200574, '3.40.50.970-FF-000133', NULL, '1-deoxy-D-xylulose-5-phosphate synthase', 170, NULL, NULL, 200574),
(200575, '2.60.40.10-FF-005007', NULL, NULL, 106, NULL, NULL, 200575),
(200576, '1.25.10.10-FF-002863', NULL, 'Uncharacterized protein', 163, NULL, NULL, 200576),
(200577, '2.60.40.10-FF-000937', NULL, 'phosphatidylinositol phosphatase PTPRQ isoform X1', 102, NULL, NULL, 200577),
(200578, '1.10.20.10-FF-000295', NULL, NULL, 63, NULL, NULL, 200578),
(200579, '1.10.3380.20-FF-000009', NULL, 'DNA double-strand break repair Rad50 ATPase, putative', 162, NULL, NULL, 200579),
(200580, '1.10.472.10-FF-000367', NULL, 'Uncharacterized protein', 108, NULL, NULL, 200580),
(200581, '3.30.160.60-FF-001174', NULL, 'zinc finger protein 527 isoform X1', 29, NULL, NULL, 200581),
(200582, '1.10.640.10-FF-000022', NULL, 'Peroxinectin, putative', 104, NULL, NULL, 200582),
(200583, '1.10.3120.10-FF-000027', NULL, NULL, 197, NULL, NULL, 200583),
(200584, '3.80.10.10-FF-002107', NULL, 'EIN3-binding F-box protein 1', 234, NULL, NULL, 200584),
(200585, '3.80.10.10-FF-002287', NULL, 'F-box/LRR-repeat protein 20', 239, NULL, NULL, 200585),
(200586, '3.30.70.2760-FF-000008', NULL, NULL, 127, NULL, NULL, 200586),
(200587, '1.25.40.10-FF-004489', NULL, 'Uncharacterized protein', 98, NULL, NULL, 200587),
(200588, '3.90.1010.10-FF-000010', NULL, 'Quinolinate synthase, chloroplastic', 141, NULL, NULL, 200588),
(200589, '3.30.70.330-FF-002875', NULL, NULL, 71, NULL, NULL, 200589),
(200590, '1.20.59.10-FF-000006', NULL, 'Chorismate mutase', 153, NULL, NULL, 200590),
(200591, '2.60.40.2910-FF-000002', NULL, 'Major fimbrial subunit of aggregative adherence fimbria II', 125, NULL, NULL, 200591),
(200592, '3.50.7.10-FF-000079', NULL, NULL, 38, NULL, NULL, 200592),
(200593, '3.30.300.30-FF-000131', NULL, 'Nonribosomal peptide synthase 2', 159, NULL, NULL, 200593),
(200594, '3.30.1520.10-FF-000129', NULL, 'Uncharacterized protein', 120, NULL, NULL, 200594),
(200595, '2.60.40.2030-FF-000047', NULL, 'Adhesion G-protein coupled receptor V1', 107, NULL, NULL, 200595),
(200596, '1.20.120.1130-FF-000007', NULL, 'Vacuolar protein sorting-associated protein 28 homolog', 100, NULL, NULL, 200596),
(200597, '3.80.10.10-FF-003737', NULL, 'Uncharacterized protein', 132, NULL, NULL, 200597),
(200598, '3.50.50.60-FF-000743', NULL, 'Uncharacterized protein', 92, NULL, NULL, 200598),
(200599, '3.40.50.620-FF-000466', NULL, 'Adenine nucleotide alpha hydrolases-like superfamily protein', 248, NULL, NULL, 200599),
(200600, '3.30.160.60-FF-004748', NULL, NULL, 71, NULL, NULL, 200600),
(200601, '2.60.40.10-FF-000589', NULL, 'cell adhesion molecule 4', 88, NULL, NULL, 200601),
(200602, '3.30.420.40-FF-000963', NULL, 'Uncharacterized protein', 104, NULL, NULL, 200602);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(200603, '2.60.120.200-FF-000532', NULL, 'Lectin family integral membrane protein, putative', 106, NULL, NULL, 200603),
(200604, '2.170.300.10-FF-000028', NULL, 'Uncharacterized protein', 123, NULL, NULL, 200604),
(200605, '3.30.40.10-FF-001864', NULL, 'Uncharacterized RING finger protein C23A1.07', 79, NULL, NULL, 200605),
(200606, '1.20.58.60-FF-000564', NULL, 'SEC14 domain and spectrin repeat-containing protein 1-like Protein', 290, NULL, NULL, 200606),
(200607, '1.20.5.190-FF-000169', NULL, NULL, 47, NULL, NULL, 200607),
(200608, '3.30.160.60-FF-005445', NULL, NULL, 40, NULL, NULL, 200608),
(200609, '1.25.40.10-FF-001307', NULL, 'Pentatricopeptide repeat-containing protein At4g14050, mitochondrial', 126, NULL, NULL, 200609),
(200610, '3.90.550.10-FF-000658', NULL, 'Predicted protein', 125, NULL, NULL, 200610),
(200611, '3.90.1150.10-FF-000059', NULL, 'Glycine dehydrogenase (decarboxylating)', 141, NULL, NULL, 200611),
(200612, '1.10.555.10-FF-000104', NULL, 'RhoGAP domain containing protein', 256, NULL, NULL, 200612),
(200613, '1.10.472.10-FF-000709', NULL, 'Transcription factor IIIB 90 kDa subunit-like Protein', 59, NULL, NULL, 200613),
(200614, '3.40.50.2000-FF-000418', NULL, 'Glucuronosyltransferase', 175, NULL, NULL, 200614),
(200615, '3.50.50.60-FF-000636', NULL, 'Anaerobic glycerol-3-phosphate dehydrogenase subunit A', 204, NULL, NULL, 200615),
(200616, '1.20.1250.20-FF-002066', NULL, 'Uncharacterized protein', 285, NULL, NULL, 200616),
(200617, '3.30.1370.210-FF-000033', NULL, 'Uncharacterized protein', 51, NULL, NULL, 200617),
(200618, '1.10.630.10-FF-000050', NULL, 'Cytochrome P450 monooxygenase', 486, NULL, NULL, 200618),
(200619, '1.10.287.10-FF-000060', NULL, 'Uncharacterized protein', 26, NULL, NULL, 200619),
(200620, '2.20.100.10-FF-000172', NULL, 'Putative reeler', 55, NULL, NULL, 200620),
(200621, '1.10.10.60-FF-001040', NULL, NULL, 80, NULL, NULL, 200621),
(200622, '4.10.280.10-FF-000044', NULL, 'Basic helix-loop-helix transcription factor', 63, NULL, NULL, 200622),
(200623, '2.130.10.10-FF-001051', NULL, 'dynein assembly factor with WDR repeat domains 1', 85, NULL, NULL, 200623),
(200624, '3.30.160.60-FF-005900', NULL, NULL, 19, NULL, NULL, 200624),
(200625, '3.20.110.10-FF-000028', NULL, 'Lysosomal alpha-mannosidase, putative', 138, NULL, NULL, 200625),
(200626, '1.10.10.1320-FF-000003', NULL, 'Transcriptional activator, putative', 112, NULL, NULL, 200626),
(200627, '3.30.1140.32-FF-000002', NULL, '30S ribosomal protein S3', 105, NULL, NULL, 200627),
(200628, '3.90.1180.10-FF-000016', NULL, '50S ribosomal protein L13', 142, NULL, NULL, 200628),
(200629, '3.40.50.10490-FF-000064', NULL, 'SIS domain-containing protein', 146, NULL, NULL, 200629),
(200630, '3.90.20.20-FF-000042', NULL, 'Protein GrpE', 117, NULL, NULL, 200630),
(200631, '3.40.50.410-FF-000061', NULL, 'von Willebrand factor', 214, NULL, NULL, 200631),
(200632, '3.40.50.720-FF-002290', NULL, 'Uncharacterized protein', 195, NULL, NULL, 200632),
(200633, '3.30.70.60-FF-000037', NULL, '30S ribosomal protein S6', 100, NULL, NULL, 200633),
(200634, '3.90.1150.10-FF-000514', NULL, 'Predicted protein', 109, NULL, NULL, 200634),
(200635, '1.20.1250.20-FF-000273', NULL, 'MFS transporter', 189, NULL, NULL, 200635),
(200636, '1.10.10.1420-FF-000005', NULL, 'DNA replication factor Cdt1, putative', 134, NULL, NULL, 200636),
(200637, '3.40.50.2000-FF-000082', NULL, 'Glycosyltransferase', 241, NULL, NULL, 200637),
(200638, '1.20.1270.10-FF-000063', NULL, 'Heat shock protein70, hsp70A2, putative', 73, NULL, NULL, 200638),
(200639, '1.20.140.150-FF-000048', NULL, 'LD29359p', 190, NULL, NULL, 200639),
(200640, '2.30.30.490-FF-000002', NULL, 'protein polybromo-1 isoform X3', 204, NULL, NULL, 200640),
(200641, '3.30.390.30-FF-000035', NULL, 'Worm AIF (Apoptosis inducing factor) Homolog', 95, NULL, NULL, 200641),
(200642, '3.10.129.10-FF-000118', NULL, 'Unplaced genomic scaffold supercont1.38, whole genome shotgun sequence', 180, NULL, NULL, 200642),
(200643, '1.20.1530.20-FF-000087', NULL, 'Predicted protein', 318, NULL, NULL, 200643);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(200644, '3.60.40.10-FF-000154', NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', 254, NULL, NULL, 200644),
(200645, '3.30.160.60-FF-005552', NULL, NULL, 78, NULL, NULL, 200645),
(200646, '3.40.50.720-FF-000726', NULL, 'C-terminal binding protein 1', 26, NULL, NULL, 200646),
(200647, '3.30.930.10-FF-000021', NULL, 'Probable histidine--tRNA ligase, mitochondrial', 362, NULL, NULL, 200647),
(200648, '1.20.58.150-FF-000022', NULL, NULL, 95, NULL, NULL, 200648),
(200649, '1.10.510.10-FF-001064', NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 196', 172, NULL, NULL, 200649),
(200650, '1.10.1370.10-FF-000045', NULL, 'Uncharacterized protein', 128, NULL, NULL, 200650),
(200651, '1.10.10.1410-FF-000002', NULL, '60S acidic ribosomal protein P2', 60, NULL, NULL, 200651),
(200652, '2.40.10.240-FF-000005', NULL, 'S-adenosylmethionine:tRNA ribosyltransferase-isomerase', 107, NULL, NULL, 200652),
(200653, '2.30.29.30-FF-000581', NULL, 'Myosin 28B1, isoform B', 93, NULL, NULL, 200653),
(200654, '3.40.630.10-FF-000277', NULL, 'Uncharacterized protein', 113, NULL, NULL, 200654),
(200655, '3.30.50.10-FF-000162', NULL, 'Protein CBG01262', 95, NULL, NULL, 200655),
(200656, '3.30.70.2740-FF-000002', NULL, 'D-2-hydroxyglutarate dehydrogenase mitochondrial', 80, NULL, NULL, 200656),
(200657, '2.40.30.30-FF-000022', NULL, 'Protein CBG08376', 133, NULL, NULL, 200657),
(200658, '3.30.1490.190-FF-000020', NULL, 'Ferric uptake regulation protein', 61, NULL, NULL, 200658),
(200659, '2.60.200.40-FF-000016', NULL, 'Ceramide kinase like', 217, NULL, NULL, 200659),
(200660, '3.40.190.10-FF-000613', NULL, 'ABC transporter substrate-binding protein', 120, NULL, NULL, 200660),
(200661, '2.60.40.3770-FF-000001', NULL, 'Envelopment polyprotein', 95, NULL, NULL, 200661),
(200662, '2.40.10.230-FF-000002', NULL, 'H/ACA ribonucleoprotein complex non-core subunit NAF1', 108, NULL, NULL, 200662),
(200663, '3.90.79.10-FF-000197', NULL, 'Isopentenyl-diphosphate delta-isomerase 1', 232, NULL, NULL, 200663),
(200664, '3.40.850.10-FF-000506', NULL, 'Uncharacterized protein', 174, NULL, NULL, 200664),
(200665, '3.30.70.2750-FF-000005', NULL, 'V-type ATP synthase subunit I', 74, NULL, NULL, 200665),
(200666, '1.20.5.170-FF-000163', NULL, 'Uncharacterized protein', 76, NULL, NULL, 200666),
(200667, '1.20.1260.60-FF-000010', NULL, 'Uncharacterized protein', 161, NULL, NULL, 200667),
(200668, '1.10.238.10-FF-001150', NULL, 'Uncharacterized protein', 125, NULL, NULL, 200668),
(200669, '3.30.70.330-FF-000751', NULL, 'Polyadenylate-binding protein 1', 134, NULL, NULL, 200669),
(200670, '1.10.510.10-FF-001412', NULL, 'Serine/threonine-protein kinase atg1', 324, NULL, NULL, 200670),
(200671, '2.60.40.820-FF-000052', NULL, 'Protein CBG03975', 137, NULL, NULL, 200671),
(200672, '2.60.40.60-FF-000817', NULL, 'Uncharacterized protein', 101, NULL, NULL, 200672),
(200673, '1.20.58.1030-FF-000032', NULL, 'Uncharacterized protein', 225, NULL, NULL, 200673),
(200674, '3.30.50.10-FF-000055', NULL, 'GATA transcription factor 21', 83, NULL, NULL, 200674),
(200675, '1.25.40.10-FF-003106', NULL, 'Pentatricopeptide repeat-containing protein At5g46460, mitochondrial', 110, NULL, NULL, 200675),
(200676, '2.130.10.10-FF-001612', NULL, 'Uncharacterized protein', 249, NULL, NULL, 200676),
(200677, '3.40.50.720-FF-000491', NULL, 'Enoyl-[acyl-carrier-protein] reductase FabL', 250, NULL, NULL, 200677),
(200678, '3.30.160.60-FF-001320', NULL, 'Zinc finger and SCAN domain containing 9', 28, NULL, NULL, 200678),
(200679, '3.40.50.2300-FF-000593', NULL, 'Penicillin-binding protein activator', 182, NULL, NULL, 200679),
(200680, '1.20.1250.20-FF-001594', NULL, 'Solute carrier organic anion transporter family member', 273, NULL, NULL, 200680),
(200681, '2.120.10.30-FF-000394', NULL, 'Uncharacterized protein', 265, NULL, NULL, 200681),
(200682, '1.25.10.10-FF-001143', NULL, 'Uncharacterized protein', 575, NULL, NULL, 200682),
(200683, '2.10.25.10-FF-000207', NULL, 'Multiple epidermal growth factor-like domains 8', 47, NULL, NULL, 200683);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(200684, '3.30.420.130-FF-000001', NULL, 'Nitrogenase cofactor biosynthesis protein', 119, NULL, NULL, 200684),
(200685, '3.40.50.970-FF-000217', NULL, 'Uncharacterized protein', 86, NULL, NULL, 200685),
(200686, '1.10.630.10-FF-000611', NULL, 'Cytochrome P450, putative', 257, NULL, NULL, 200686),
(200687, '3.80.10.10-FF-002433', NULL, 'Leucine-rich repeat protein (LRRP)', 186, NULL, NULL, 200687),
(200688, '3.30.1370.10-FF-000185', NULL, 'KRR1 small subunit processome component', 94, NULL, NULL, 200688),
(200689, '3.30.470.20-FF-000123', NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', 183, NULL, NULL, 200689),
(200690, '2.60.120.820-FF-000010', NULL, 'BTB/POZ domain-containing protein', 155, NULL, NULL, 200690),
(200691, '1.20.1250.20-FF-000492', NULL, 'Probable inorganic phosphate transporter 1-5', 237, NULL, NULL, 200691),
(200692, '1.10.238.10-FF-000784', NULL, 'Uncharacterized protein', 85, NULL, NULL, 200692),
(200693, '1.25.40.120-FF-000010', NULL, 'Geranylgeranyl transferase type-2 subunit alpha', 330, NULL, NULL, 200693),
(200694, '3.10.580.10-FF-000211', NULL, 'Chloride channel protein 7', 53, NULL, NULL, 200694),
(200695, '2.10.25.10-FF-001618', NULL, 'Delta-like protein', 52, NULL, NULL, 200695),
(200696, '3.30.450.20-FF-000240', NULL, 'Sensory box/GGDEF family protein', 92, NULL, NULL, 200696),
(200697, '3.90.1150.10-FF-000368', NULL, 'Aminotransferase class I/II-fold pyridoxal phosphate-dependent enzyme', 104, NULL, NULL, 200697),
(200698, '1.10.238.10-FF-001273', NULL, 'Uncharacterized protein', 85, NULL, NULL, 200698),
(200699, '2.60.40.10-FF-005810', NULL, NULL, 66, NULL, NULL, 200699),
(200700, '3.40.50.300-FF-004788', NULL, 'Uncharacterized protein', 48, NULL, NULL, 200700),
(200701, '1.20.1410.10-FF-000035', NULL, 'Uncharacterized protein', 103, NULL, NULL, 200701),
(200702, '3.30.420.40-FF-000744', NULL, 'Actin related protein', 102, NULL, NULL, 200702),
(200703, '1.20.1070.10-FF-002116', NULL, 'Uncharacterized protein', 276, NULL, NULL, 200703),
(200704, '3.40.190.10-FF-000832', NULL, 'Sulfonate ABC transporter, periplasmic sulfonate-binding protein', 186, NULL, NULL, 200704),
(200705, '1.10.40.30-FF-000032', NULL, 'Uncharacterized protein', 50, NULL, NULL, 200705),
(200706, '3.40.718.10-FF-000014', NULL, 'Isocitrate dehydrogenase (NAD(+))', 333, NULL, NULL, 200706),
(200707, '1.25.40.10-FF-002691', NULL, 'Fis1 C-terminal tetratricopeptide repeat, putative', 147, NULL, NULL, 200707),
(200708, '3.30.559.10-FF-000157', NULL, 'Nonribosomal peptide synthase 2', 189, NULL, NULL, 200708),
(200709, '3.40.20.10-FF-000108', NULL, 'Villin-1', 125, NULL, NULL, 200709),
(200710, '3.40.47.10-FF-000277', NULL, NULL, 68, NULL, NULL, 200710),
(200711, '3.40.1190.20-FF-000025', NULL, 'Putative sugar kinase slr0537', 324, NULL, NULL, 200711),
(200712, '1.20.1540.10-FF-000039', NULL, 'Derlin', 193, NULL, NULL, 200712),
(200713, '1.20.1510.10-FF-000009', NULL, 'zinc transporter 6 isoform X1', 223, NULL, NULL, 200713),
(200714, '1.10.1740.30-FF-000001', NULL, 'Type III secretion system effector SifA', 81, NULL, NULL, 200714),
(200715, '1.20.120.1240-FF-000024', NULL, 'Dynamin central region family protein', 252, NULL, NULL, 200715),
(200716, '3.50.50.60-FF-000417', NULL, 'Ubiquinone biosynthesis hydroxylase', 205, NULL, NULL, 200716),
(200717, '3.80.10.10-FF-001944', NULL, 'Receptor-like protein kinase', 278, NULL, NULL, 200717),
(200718, '3.40.50.720-FF-000417', NULL, 'Glucose 1-dehydrogenase, putative', 259, NULL, NULL, 200718),
(200719, '3.40.50.2000-FF-000637', NULL, 'Alpha-1,4 glucan phosphorylase', 142, NULL, NULL, 200719),
(200720, '3.30.160.60-FF-005226', NULL, NULL, 51, NULL, NULL, 200720),
(200721, '3.30.750.24-FF-000155', NULL, 'Uncharacterized protein', 116, NULL, NULL, 200721),
(200722, '2.60.40.790-FF-000099', NULL, 'Chaperone binding protein, putative', 88, NULL, NULL, 200722),
(200723, '2.60.220.50-FF-000021', NULL, 'Adhesion G protein-coupled receptor F5', 159, NULL, NULL, 200723),
(200724, '3.30.1520.10-FF-000096', NULL, 'PX domain containing protein', 117, NULL, NULL, 200724);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(200725, '2.10.25.10-FF-000174', NULL, 'Laminin subunit gamma-1', 56, NULL, NULL, 200725),
(200726, '3.40.50.10140-FF-000083', NULL, 'Uncharacterized protein', 137, NULL, NULL, 200726),
(200727, '3.40.50.720-FF-001828', NULL, 'Polyketide synthase, putative (JCVI)', 410, NULL, NULL, 200727),
(200728, '3.30.160.60-FF-000679', NULL, 'Zinc finger protein 341', 29, NULL, NULL, 200728),
(200729, '2.130.10.10-FF-000769', NULL, 'Apoptotic protease-activating factor 1', 51, NULL, NULL, 200729),
(200730, '3.50.50.60-FF-000288', NULL, 'Lysine-specific histone demethylase 1 homolog 3', 144, NULL, NULL, 200730),
(200731, '1.20.1740.10-FF-000021', NULL, 'Cation-chloride cotransporter 1', 472, NULL, NULL, 200731),
(200732, '3.30.200.20-FF-000396', NULL, 'Cdc2-related kinase 2, putative', 84, NULL, NULL, 200732),
(200733, '1.20.1560.10-FF-000254', NULL, 'ABC transporter ATP-binding protein/permease', 306, NULL, NULL, 200733),
(200734, '1.25.40.20-FF-001193', NULL, 'Ion channel NompC', 185, NULL, NULL, 200734),
(200735, '1.25.40.10-FF-001280', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform A', 92, NULL, NULL, 200735),
(200736, '3.30.450.70-FF-000007', NULL, 'Putative sybindin-like family protein', 134, NULL, NULL, 200736),
(200737, '1.10.8.10-FF-000006', NULL, 'Putative nascent polypeptide-associated complex subunit alpha', 38, NULL, NULL, 200737),
(200738, '3.90.1170.40-FF-000018', NULL, 'Uncharacterized protein', 136, NULL, NULL, 200738),
(200739, '3.40.50.2300-FF-000267', NULL, 'Virulence factors transcription regulator', 205, NULL, NULL, 200739),
(200740, '2.40.50.140-FF-001017', NULL, NULL, 57, NULL, NULL, 200740),
(200741, '3.80.10.10-FF-002742', NULL, 'Uncharacterized protein', 335, NULL, NULL, 200741),
(200742, '3.30.310.80-FF-000051', NULL, 'Non-specific serine/threonine protein kinase', 102, NULL, NULL, 200742),
(200743, '1.10.8.20-FF-000009', NULL, 'Blast:Clavesin-1', 70, NULL, NULL, 200743),
(200744, '1.10.10.2670-FF-000020', NULL, 'Uncharacterized protein', 92, NULL, NULL, 200744),
(200745, '3.30.450.60-FF-000004', NULL, 'AP complex subunit sigma', 142, NULL, NULL, 200745),
(200746, '1.20.58.760-FF-000025', NULL, 'ATP-dependent metallopeptidase Hfl', 72, NULL, NULL, 200746),
(200747, '3.40.50.720-FF-000165', NULL, '3-ketodihydrosphingosine reductase', 268, NULL, NULL, 200747),
(200748, '1.25.40.20-FF-001283', NULL, 'Uncharacterized protein', 176, NULL, NULL, 200748),
(200749, '3.30.70.270-FF-000165', NULL, 'Response regulator ActA', 164, NULL, NULL, 200749),
(200750, '3.30.200.20-FF-000738', NULL, 'CMGC/CDK protein kinase', 102, NULL, NULL, 200750),
(200751, '3.40.50.720-FF-000507', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', 162, NULL, NULL, 200751),
(200752, '1.20.1560.10-FF-000602', NULL, 'Uncharacterized protein', 484, NULL, NULL, 200752),
(200753, '2.60.40.1120-FF-000089', NULL, 'Carboxypeptidase D, b', 78, NULL, NULL, 200753),
(200754, '3.30.450.50-FF-000001', NULL, 'AP-3 complex subunit delta-1, putative', 84, NULL, NULL, 200754),
(200755, '2.30.29.30-FF-000362', NULL, 'Uncharacterized protein, isoform B', 140, NULL, NULL, 200755),
(200756, '2.130.10.10-FF-005103', NULL, 'Uncharacterized protein', 249, NULL, NULL, 200756),
(200757, '1.20.120.1910-FF-000011', NULL, 'Cysteine--tRNA ligase', 160, NULL, NULL, 200757),
(200758, '3.90.470.10-FF-000039', NULL, 'Uncharacterized protein', 155, NULL, NULL, 200758),
(200759, '3.30.200.20-FF-000087', NULL, 'Dual specificity tyrosine-phosphorylation-regulated kinase 1A', 112, NULL, NULL, 200759),
(200760, '3.90.1150.10-FF-000149', NULL, 'O-succinylhomoserine sulfhydrylase', 135, NULL, NULL, 200760),
(200761, '3.90.226.10-FF-000169', NULL, 'Periplasmic protease', 254, NULL, NULL, 200761),
(200762, '1.10.150.50-FF-000007', NULL, 'Liprin-beta-1 isoform 1', 100, NULL, NULL, 200762),
(200763, '2.10.25.10-FF-000516', NULL, 'Notch receptor 3', 34, NULL, NULL, 200763),
(200764, '3.30.70.330-FF-002549', NULL, NULL, 37, NULL, NULL, 200764),
(200765, '1.10.10.60-FF-000758', NULL, 'Hybrid sensor histidine kinase/response regulator', 55, NULL, NULL, 200765);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(200766, '1.10.510.10-FF-001283', NULL, 'Probable inactive receptor kinase At5g53320', 201, NULL, NULL, 200766),
(200767, '3.40.50.2000-FF-000727', NULL, 'OSJNBb0012E24.10 protein', 117, NULL, NULL, 200767),
(200768, '3.30.450.20-FF-000094', NULL, 'Single-minded, isoform C', 167, NULL, NULL, 200768),
(200769, '3.30.720.10-FF-000005', NULL, 'Signal recognition particle 9', 24, NULL, NULL, 200769),
(200770, '1.25.40.10-FF-000583', NULL, 'Tetratricopeptide-like helical', 91, NULL, NULL, 200770),
(200771, '3.40.390.10-FF-000252', NULL, NULL, 243, NULL, NULL, 200771),
(200772, '3.40.850.10-FF-000276', NULL, 'Kinesin-like protein', 428, NULL, NULL, 200772),
(200773, '3.40.50.300-FF-003355', NULL, 'Uncharacterized protein, isoform C', 360, NULL, NULL, 200773),
(200774, '3.40.50.11950-FF-000007', NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', 52, NULL, NULL, 200774),
(200775, '1.10.287.130-FF-000141', NULL, 'Sensor histidine kinase, KdpD', 77, NULL, NULL, 200775),
(200776, '3.30.740.10-FF-000006', NULL, 'Dynein light chain', 88, NULL, NULL, 200776),
(200777, '3.30.420.580-FF-000006', NULL, 'Actin-related protein 8', 76, NULL, NULL, 200777),
(200778, '3.30.710.10-FF-000510', NULL, 'Voltage-gated potassium channel, putative', 66, NULL, NULL, 200778),
(200779, '2.60.40.1910-FF-000039', NULL, NULL, 91, NULL, NULL, 200779),
(200780, '2.30.30.140-FF-000116', NULL, 'Os04g0326000 protein', 59, NULL, NULL, 200780),
(200781, '3.30.450.380-FF-000008', NULL, NULL, 239, NULL, NULL, 200781),
(200782, '3.80.10.10-FF-004125', NULL, 'Uncharacterized protein', 113, NULL, NULL, 200782),
(200783, '3.30.200.20-FF-000957', NULL, 'TP53-regulating kinase, putative', 71, NULL, NULL, 200783),
(200784, '3.50.50.60-FF-001131', NULL, 'Flavin-containing monooxygenase', 118, NULL, NULL, 200784),
(200785, '2.130.10.10-FF-001410', NULL, 'Rabconnectin-3B, isoform A', 107, NULL, NULL, 200785),
(200786, '3.20.20.190-FF-000032', NULL, 'Glycerophosphoryl diester phosphodiesterase, putative', 308, NULL, NULL, 200786),
(200787, '3.40.50.11660-FF-000027', NULL, NULL, 145, NULL, NULL, 200787),
(200788, '3.30.40.10-FF-000116', NULL, 'Transcription factor 20 (AR1)', 104, NULL, NULL, 200788),
(200789, '3.30.160.60-FF-005136', NULL, NULL, 90, NULL, NULL, 200789),
(200790, '1.25.40.20-FF-001204', NULL, 'Poly [ADP-ribose] polymerase tankyrase', 196, NULL, NULL, 200790),
(200791, '1.20.120.310-FF-000007', NULL, 'Sulfhydryl oxidase', 132, NULL, NULL, 200791),
(200792, '1.20.1250.20-FF-000290', NULL, 'Unc-93 homolog A', 182, NULL, NULL, 200792),
(200793, '1.25.10.10-FF-000648', NULL, 'CLIP-associated protein', 225, NULL, NULL, 200793),
(200794, '1.20.1250.20-FF-001919', NULL, 'Uncharacterized protein', 223, NULL, NULL, 200794),
(200795, '3.40.50.720-FF-000743', NULL, 'D-amino acid oxidase', 41, NULL, NULL, 200795),
(200796, '1.25.40.120-FF-000009', NULL, 'CAAX geranylgeranyltransferase alpha subunit', 314, NULL, NULL, 200796),
(200797, '3.30.160.60-FF-001404', NULL, 'vascular endothelial zinc finger 1-like isoform X1', 36, NULL, NULL, 200797),
(200798, '1.20.1560.10-FF-000147', NULL, 'ABC transporter B family member 9', 23, NULL, NULL, 200798),
(200799, '1.10.10.60-FF-000449', NULL, 'MYB-related transcription factor', 55, NULL, NULL, 200799),
(200800, '1.25.40.10-FF-001201', NULL, 'Pentatricopeptide repeat-containing protein OGR1, mitochondrial', 165, NULL, NULL, 200800),
(200801, '3.40.50.10140-FF-000010', NULL, 'phosphoinositide 3-kinase adapter protein 1', 138, NULL, NULL, 200801),
(200802, '3.30.40.10-FF-000644', NULL, 'DNA repair protein rhp16', 109, NULL, NULL, 200802),
(200803, '2.30.30.100-FF-000155', NULL, 'Small nuclear ribonucleoprotein family protein', 66, NULL, NULL, 200803),
(200804, '2.30.29.30-FF-000564', NULL, 'Actin-binding protein anillin-like Protein', 114, NULL, NULL, 200804),
(200805, '3.10.20.230-FF-000018', NULL, 'Echinoderm microtubule-associated protein-like CG42247', 106, NULL, NULL, 200805),
(200806, '2.130.10.10-FF-004485', NULL, 'Predicted protein', 85, NULL, NULL, 200806),
(200807, '3.40.190.290-FF-000094', NULL, 'Probable transcriptional regulator', 211, NULL, NULL, 200807);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(200808, '3.30.50.10-FF-000145', NULL, 'Retinoic acid receptor gamma, putative', 74, NULL, NULL, 200808),
(200809, '1.10.10.10-FF-001047', NULL, 'Putative type IIB DNA topoisomerase', 88, NULL, NULL, 200809),
(200810, '1.20.1480.30-FF-000006', NULL, 'Uncharacterized protein', 92, NULL, NULL, 200810),
(200811, '3.10.310.10-FF-000063', NULL, 'Uncharacterized protein', 21, NULL, NULL, 200811),
(200812, '3.40.50.12760-FF-000020', NULL, 'Cap-specific mRNA (Nucleoside-2''-O-)-methyltransferase 2-like Protein', 298, NULL, NULL, 200812),
(200813, '2.40.50.90-FF-000086', NULL, 'Nuclease domain containing protein, putative', 144, NULL, NULL, 200813),
(200814, '1.25.40.10-FF-005001', NULL, 'Uncharacterized protein', 126, NULL, NULL, 200814),
(200815, '1.25.10.10-FF-003251', NULL, 'Unc-45 myosin chaperone A', 227, NULL, NULL, 200815),
(200816, '3.40.1110.10-FF-000332', NULL, NULL, 135, NULL, NULL, 200816),
(200817, '3.80.10.10-FF-001000', NULL, 'probable inactive leucine-rich repeat receptor-like protein kinase At3g03770', 94, NULL, NULL, 200817),
(200818, '1.25.40.10-FF-001190', NULL, 'Kinetoplast_polyadenylation/uridylation_factor_1', 141, NULL, NULL, 200818),
(200819, '3.20.20.80-FF-000170', NULL, 'Unplaced genomic scaffold supercont1.36, whole genome shotgun sequence', 257, NULL, NULL, 200819),
(200820, '3.30.1370.10-FF-000078', NULL, 'Uncharacterized protein, isoform A', 68, NULL, NULL, 200820),
(200821, '2.10.25.10-FF-000533', NULL, 'Laminin subunit gamma 2', 73, NULL, NULL, 200821),
(200822, '2.30.29.30-FF-000036', NULL, 'SHC-transforming protein 1 isoform 3', 167, NULL, NULL, 200822),
(200823, '1.25.40.860-FF-000001', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 77, NULL, NULL, 200823),
(200824, '3.40.50.12710-FF-000011', NULL, 'S-adenosyl-L-methionine-dependent methyltransferase family protein', 379, NULL, NULL, 200824),
(200825, '3.30.160.60-FF-002011', NULL, 'Paternally-expressed gene 3 protein', 39, NULL, NULL, 200825),
(200826, '3.90.190.10-FF-000017', NULL, 'receptor-type tyrosine-protein phosphatase-like N isoform X2', 301, NULL, NULL, 200826),
(200827, '3.20.20.100-FF-000056', NULL, 'Aldo-keto reductase-like protein', 320, NULL, NULL, 200827),
(200828, '4.10.410.10-FF-000100', NULL, 'Ankyrin repeat-containing protein', 60, NULL, NULL, 200828),
(200829, '1.10.10.60-FF-000983', NULL, NULL, 91, NULL, NULL, 200829),
(200830, '1.20.1070.10-FF-000082', NULL, 'Olfactory receptor 1A1', 292, NULL, NULL, 200830),
(200831, '3.80.10.10-FF-002416', NULL, 'Si:ch211-42i6.2', 181, NULL, NULL, 200831),
(200832, '1.25.40.20-FF-001619', NULL, 'E3 ubiquitin-protein ligase mind-bomb-like Protein', 99, NULL, NULL, 200832),
(200833, '2.40.50.140-FF-000629', NULL, 'Lysine--tRNA ligase', 154, NULL, NULL, 200833),
(200834, '3.40.1110.10-FF-000006', NULL, 'Calcium-transporting ATPase', 190, NULL, NULL, 200834),
(200835, '3.40.30.150-FF-000001', NULL, 'Orf1a polyprotein', 67, NULL, NULL, 200835),
(200836, '2.30.30.140-FF-000009', NULL, 'AT-rich interactive domain-containing protein 4B', 118, NULL, NULL, 200836),
(200837, '1.10.390.10-FF-000002', NULL, 'Aminopeptidase N', 164, NULL, NULL, 200837),
(200838, '2.130.10.10-FF-000685', NULL, 'Autophagy-related protein 18c', 291, NULL, NULL, 200838),
(200839, '3.40.50.1820-FF-000224', NULL, 'Alpha/beta hydrolase', 269, NULL, NULL, 200839),
(200840, '2.30.42.10-FF-000538', NULL, NULL, 127, NULL, NULL, 200840),
(200841, '1.10.820.10-FF-000002', NULL, 'Genome polyprotein', 113, NULL, NULL, 200841),
(200842, '1.10.555.10-FF-000071', NULL, 'Rho GTPase activating protein 27', 213, NULL, NULL, 200842),
(200843, '1.25.40.10-FF-000998', NULL, 'Clathrin heavy chain', 141, NULL, NULL, 200843),
(200844, '1.10.1580.10-FF-000004', NULL, 'Mitochondrial GTPase 1', 99, NULL, NULL, 200844),
(200845, '3.30.40.10-FF-002353', NULL, 'AFL108Cp', 87, NULL, NULL, 200845),
(200846, '3.90.45.10-FF-000001', NULL, 'Peptide deformylase', 168, NULL, NULL, 200846),
(200847, '3.30.465.10-FF-000046', NULL, 'Integral membrane protein, TerC family', 76, NULL, NULL, 200847),
(200848, '3.30.70.330-FF-001133', NULL, 'Uncharacterized protein', 96, NULL, NULL, 200848);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(200849, '1.10.238.10-FF-001256', NULL, 'Uncharacterized protein', 64, NULL, NULL, 200849),
(200850, '1.10.1040.10-FF-000060', NULL, '2-dehydropantoate 2-reductase', 123, NULL, NULL, 200850),
(200851, '2.130.10.10-FF-001303', NULL, 'Telomerase protein component 1', 145, NULL, NULL, 200851),
(200852, '2.60.120.290-FF-000137', NULL, 'Cubilin homolog', 116, NULL, NULL, 200852),
(200853, '3.40.50.1220-FF-000050', NULL, 'NAD-dependent deacetylase, Sir2 family protein', 58, NULL, NULL, 200853),
(200854, '3.30.230.10-FF-000029', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 159, NULL, NULL, 200854),
(200855, '3.10.20.510-FF-000001', NULL, 'Bacterial RNA polymerase inhibitor', 64, NULL, NULL, 200855),
(200856, '1.10.630.10-FF-000302', NULL, 'Cytochrome P450', 441, NULL, NULL, 200856),
(200857, '3.60.20.10-FF-000271', NULL, NULL, 30, NULL, NULL, 200857),
(200858, '3.40.50.1220-FF-000139', NULL, 'Uncharacterized protein', 41, NULL, NULL, 200858),
(200859, '2.20.70.10-FF-000194', NULL, 'Uncharacterized protein', 35, NULL, NULL, 200859),
(200860, '1.25.40.10-FF-002926', NULL, 'Tetratricopeptide repeat protein 19, mitochondrial', 164, NULL, NULL, 200860),
(200861, '3.40.50.880-FF-000179', NULL, 'Imidazole glycerol phosphate synthase subunit HisH', 200, NULL, NULL, 200861),
(200862, '3.30.1370.50-FF-000039', NULL, 'Uncharacterized protein', 34, NULL, NULL, 200862),
(200863, '2.170.300.10-FF-000045', NULL, 'Uncharacterized protein', 108, NULL, NULL, 200863),
(200864, '3.40.50.300-FF-005070', NULL, 'Ras-related protein RABC1', 113, NULL, NULL, 200864),
(200865, '3.90.180.10-FF-000045', NULL, 'NADP-dependent alcohol dehydrogenase', 184, NULL, NULL, 200865),
(200866, '3.40.50.300-FF-001118', NULL, 'ATP-dependent zinc metalloprotease FTSH 12, chloroplastic', 186, NULL, NULL, 200866),
(200867, '1.10.287.10-FF-000043', NULL, 'Predicted protein', 56, NULL, NULL, 200867),
(200868, '3.40.190.10-FF-000467', NULL, 'SgrR family transcriptional regulator', 229, NULL, NULL, 200868),
(200869, '1.20.1270.60-FF-000252', NULL, 'Uncharacterized protein', 229, NULL, NULL, 200869),
(200870, '3.90.70.10-FF-000778', NULL, 'Philibertain g 1', 23, NULL, NULL, 200870),
(200871, '3.80.10.10-FF-000382', NULL, 'Leucine rich repeats and transmembrane domains 1', 108, NULL, NULL, 200871),
(200872, '1.25.40.10-FF-002617', NULL, 'Uncharacterized protein', 100, NULL, NULL, 200872),
(200873, '1.20.120.1190-FF-000003', NULL, NULL, 167, NULL, NULL, 200873),
(200874, '3.30.160.60-FF-005243', NULL, NULL, 64, NULL, NULL, 200874),
(200875, '1.10.490.160-FF-000013', NULL, NULL, 110, NULL, NULL, 200875),
(200876, '1.25.40.10-FF-004854', NULL, 'Uncharacterized protein', 130, NULL, NULL, 200876),
(200877, '1.25.10.10-FF-000974', NULL, 'WD repeats protein kinase', 267, NULL, NULL, 200877),
(200878, '1.25.40.990-FF-000057', NULL, 'Predicted protein', 221, NULL, NULL, 200878),
(200879, '1.10.10.160-FF-000008', NULL, 'DNA helicase', 84, NULL, NULL, 200879),
(200880, '2.60.120.290-FF-000250', NULL, 'Uncharacterized protein', 130, NULL, NULL, 200880),
(200881, '1.10.472.80-FF-000005', NULL, 'TBC1 domain family member 15', 130, NULL, NULL, 200881),
(200882, '1.10.418.10-FF-000096', NULL, 'Parvin beta', 87, NULL, NULL, 200882),
(200883, '3.30.230.10-FF-000248', NULL, 'Tetracycline resistance protein TetM', 120, NULL, NULL, 200883),
(200884, '3.30.200.20-FF-000755', NULL, 'Proline-rich receptor-like protein kinase PERK3', 100, NULL, NULL, 200884),
(200885, '2.20.130.20-FF-000014', NULL, 'Thiolester containing protein I', 90, NULL, NULL, 200885),
(200886, '2.60.220.50-FF-000004', NULL, 'Adhesion G protein-coupled receptor B3', 178, NULL, NULL, 200886),
(200887, '3.30.70.120-FF-000036', NULL, NULL, 102, NULL, NULL, 200887),
(200888, '6.10.250.3410-FF-000001', NULL, 'Protein DBF4 homolog A', 42, NULL, NULL, 200888),
(200889, '1.25.10.10-FF-001008', NULL, 'GD25408', 380, NULL, NULL, 200889),
(200890, '3.40.1090.10-FF-000088', NULL, 'Uncharacterized protein', 408, NULL, NULL, 200890),
(200891, '3.60.40.10-FF-000047', NULL, 'Protein phosphatase 2C 70', 271, NULL, NULL, 200891);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(200892, '3.40.50.1010-FF-000211', NULL, NULL, 257, NULL, NULL, 200892),
(200893, '2.10.25.10-FF-000281', NULL, 'Nidogen 1', 46, NULL, NULL, 200893),
(200894, '3.30.70.100-FF-000030', NULL, 'Copper-exporting P-type ATPase', 66, NULL, NULL, 200894),
(200895, '3.30.70.141-FF-000026', NULL, 'Nucleoside diphosphate kinase', 151, NULL, NULL, 200895),
(200896, '3.10.20.90-FF-000797', NULL, 'UBX domain-containing protein 2', 150, NULL, NULL, 200896),
(200897, '2.30.29.30-FF-000345', NULL, 'unconventional myosin-XV isoform X1', 113, NULL, NULL, 200897),
(200898, '3.40.50.2300-FF-000284', NULL, 'Vomeronasal 2, receptor 73', 158, NULL, NULL, 200898),
(200899, '2.40.50.140-FF-000848', NULL, NULL, 109, NULL, NULL, 200899),
(200900, '3.40.1110.10-FF-000113', NULL, 'Cation-transporting ATPase', 119, NULL, NULL, 200900),
(200901, '1.10.10.60-FF-000674', NULL, '3-methyladenine DNA glycosylase', 58, NULL, NULL, 200901),
(200902, '3.30.160.60-FF-001084', NULL, 'Zinc finger and BTB domain-containing 41', 24, NULL, NULL, 200902),
(200903, '1.10.8.60-FF-000015', NULL, 'vacuolar protein sorting-associated protein 4A', 116, NULL, NULL, 200903),
(200904, '3.30.60.290-FF-000006', NULL, 'AGR162Cp', 47, NULL, NULL, 200904),
(200905, '2.10.109.10-FF-000065', NULL, 'LexA repressor', 126, NULL, NULL, 200905),
(200906, '2.60.120.200-FF-000493', NULL, 'L-type lectin-domain containing receptor kinase VIII.1', 238, NULL, NULL, 200906),
(200907, '3.30.70.270-FF-000272', NULL, NULL, 133, NULL, NULL, 200907),
(200908, '2.130.10.10-FF-004956', NULL, 'Uncharacterized protein', 92, NULL, NULL, 200908),
(200909, '3.40.630.10-FF-000294', NULL, 'Uncharacterized protein', 60, NULL, NULL, 200909),
(200910, '3.30.70.1230-FF-000010', NULL, 'Adenylate cyclase 2', 198, NULL, NULL, 200910),
(200911, '1.20.1080.10-FF-000009', NULL, 'aquaporin-4 isoform X1', 236, NULL, NULL, 200911),
(200912, '2.60.40.10-FF-005451', NULL, NULL, 49, NULL, NULL, 200912),
(200913, '3.40.50.720-FF-000524', NULL, '3-ketosteroid reductase', 342, NULL, NULL, 200913),
(200914, '1.25.40.470-FF-000007', NULL, 'Intraflagellar transport 80 homolog (Chlamydomonas)', 147, NULL, NULL, 200914),
(200915, '3.90.470.10-FF-000056', NULL, 'Uncharacterized protein', 159, NULL, NULL, 200915),
(200916, '2.60.40.820-FF-000035', NULL, 'Protein CBG17250', 91, NULL, NULL, 200916),
(200917, '1.20.5.170-FF-000247', NULL, 'Uncharacterized protein', 60, NULL, NULL, 200917),
(200918, '2.60.40.10-FF-005232', NULL, NULL, 89, NULL, NULL, 200918),
(200919, '1.20.1050.10-FF-000283', NULL, 'Uncharacterized protein', 138, NULL, NULL, 200919),
(200920, '3.40.50.150-FF-001511', NULL, NULL, 110, NULL, NULL, 200920),
(200921, '2.130.10.10-FF-000994', NULL, 'Os05g0519500 protein', 198, NULL, NULL, 200921),
(200922, '3.40.50.150-FF-001730', NULL, NULL, 157, NULL, NULL, 200922),
(200923, '1.10.8.1070-FF-000001', NULL, 'Ribulose bisphosphate carboxylase/oxygenase activase, chloroplastic', 113, NULL, NULL, 200923),
(200924, '3.40.50.300-FF-005300', NULL, 'Helicase domain protein', 172, NULL, NULL, 200924),
(200925, '3.30.200.20-FF-002195', NULL, NULL, 52, NULL, NULL, 200925),
(200926, '2.130.10.10-FF-003208', NULL, 'WD repeat-containing protein 44 isoform A', 77, NULL, NULL, 200926),
(200927, '3.40.50.300-FF-003607', NULL, 'Uncharacterized protein', 170, NULL, NULL, 200927),
(200928, '1.20.1250.20-FF-002212', NULL, 'GM06782p', 137, NULL, NULL, 200928),
(200929, '1.10.150.20-FF-000156', NULL, 'FA core complex associated protein 24', 69, NULL, NULL, 200929),
(200930, '2.60.40.2310-FF-000007', NULL, 'Subtilisin-like protease SBT2.4', 126, NULL, NULL, 200930),
(200931, '3.40.50.1370-FF-000044', NULL, 'Ornithine carbamoyltransferase', 157, NULL, NULL, 200931),
(200932, '3.40.50.620-FF-000483', NULL, 'Tryptophan--tRNA ligase, cytoplasmic', 137, NULL, NULL, 200932),
(200933, '2.20.100.10-FF-000037', NULL, 'Spondin 2', 50, NULL, NULL, 200933),
(200934, '3.40.390.10-FF-000033', NULL, 'A disintegrin and metallopeptidase domain 18', 202, NULL, NULL, 200934),
(200935, '1.25.40.180-FF-000112', NULL, 'Eukaryotic translation initiation factor 4E-binding protein Mextli homolog', 107, NULL, NULL, 200935);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(200936, '3.90.830.10-FF-000011', NULL, 'SNARE docking complex subunit', 122, NULL, NULL, 200936),
(200937, '3.80.10.10-FF-001798', NULL, 'tsukushin', 114, NULL, NULL, 200937),
(200938, '4.10.1000.10-FF-000004', NULL, 'roquin-1 isoform X2', 39, NULL, NULL, 200938),
(200939, '2.130.10.10-FF-003175', NULL, 'Elongator complex protein 2', 242, NULL, NULL, 200939),
(200940, '3.50.50.60-FF-000092', NULL, 'tRNA 5-methylaminomethyl-2-thiouridine biosynthesis bifunctional protein MnmC', 244, NULL, NULL, 200940),
(200941, '1.20.1250.20-FF-000609', NULL, 'Multidrug resistance membrane efflux protein emrB', 195, NULL, NULL, 200941),
(200942, '3.40.50.720-FF-002306', NULL, 'Uncharacterized protein', 143, NULL, NULL, 200942),
(200943, '2.60.40.710-FF-000002', NULL, NULL, 155, NULL, NULL, 200943),
(200944, '2.60.40.10-FF-001432', NULL, 'Sidekick, isoform B', 104, NULL, NULL, 200944),
(200945, '2.30.42.10-FF-000432', NULL, NULL, 110, NULL, NULL, 200945),
(200946, '1.10.8.1080-FF-000004', NULL, 'Predicted protein', 111, NULL, NULL, 200946),
(200947, '3.30.160.60-FF-004838', NULL, NULL, 73, NULL, NULL, 200947),
(200948, '1.20.1730.10-FF-000071', NULL, 'Sodium/solute symporter, GAF and PP2C family protein serine/threonine phosphatase domain protein', 518, NULL, NULL, 200948),
(200949, '1.20.1480.20-FF-000003', NULL, 'Serine/threonine protein kinase, putative', 88, NULL, NULL, 200949),
(200950, '2.30.36.70-FF-000019', NULL, 'Actin, putative', 49, NULL, NULL, 200950),
(200951, '1.10.287.70-FF-000162', NULL, 'Voltage-gated Ca2+ channel, alpha subunit', 149, NULL, NULL, 200951),
(200952, '2.130.10.10-FF-005210', NULL, 'Chromatin modification-related protein rik1', 330, NULL, NULL, 200952),
(200953, '2.40.50.40-FF-000133', NULL, 'Eukaryotic translation initiation factor 2 subunit 3-like Protein', 56, NULL, NULL, 200953),
(200954, '3.90.470.20-FF-000059', NULL, 'Uncharacterized protein', 157, NULL, NULL, 200954),
(200955, '3.40.50.300-FF-004991', NULL, 'Uncharacterized protein', 259, NULL, NULL, 200955),
(200956, '1.25.10.10-FF-000755', NULL, 'Coatomer subunit gamma', 288, NULL, NULL, 200956),
(200957, '1.20.120.1530-FF-000004', NULL, 'Methyl-accepting chemotaxis protein', 93, NULL, NULL, 200957),
(200958, '1.10.472.10-FF-000682', NULL, 'Uncharacterized protein', 239, NULL, NULL, 200958),
(200959, '2.30.250.10-FF-000012', NULL, 'Uncharacterized protein', 56, NULL, NULL, 200959),
(200960, '3.30.40.10-FF-000099', NULL, 'E3 ubiquitin-protein ligase RNF167', 86, NULL, NULL, 200960),
(200961, '3.90.226.10-FF-000276', NULL, 'Zgc:158138 protein', 271, NULL, NULL, 200961),
(200962, '3.30.710.10-FF-000274', NULL, 'Predicted protein', 78, NULL, NULL, 200962),
(200963, '3.30.930.10-FF-000240', NULL, 'ATP phosphoribosyltransferase, predicted regulatory subunit', 268, NULL, NULL, 200963),
(200964, '1.20.120.1520-FF-000001', NULL, 'Multifunctional virulence effector protein DrrA', 183, NULL, NULL, 200964),
(200965, '1.10.10.250-FF-000013', NULL, 'LSU ribosomal protein L11P', 87, NULL, NULL, 200965),
(200966, '1.20.1280.20-FF-000022', NULL, 'Uncharacterized protein', 87, NULL, NULL, 200966),
(200967, '3.40.50.720-FF-000272', NULL, 'UDP-glucuronic acid decarboxylase 1', 230, NULL, NULL, 200967),
(200968, '1.25.10.10-FF-001362', NULL, 'Sister chromatid cohesion protein, putative', 206, NULL, NULL, 200968),
(200969, '3.40.50.150-FF-000893', NULL, NULL, 53, NULL, NULL, 200969),
(200970, '2.60.40.10-FF-001180', NULL, 'Down syndrome cell adhesion molecule-like protein Dscam2', 104, NULL, NULL, 200970),
(200971, '1.10.3380.10-FF-000006', NULL, 'probable ATP-dependent DNA helicase HFM1 isoform X1', 142, NULL, NULL, 200971),
(200972, '2.60.40.2300-FF-000004', NULL, 'Neutral/alkaline nonlysosomal ceramidase, putative', 141, NULL, NULL, 200972),
(200973, '3.40.50.1360-FF-000041', NULL, '6-phosphogluconolactonase', 224, NULL, NULL, 200973),
(200974, '3.40.30.10-FF-001149', NULL, 'Predicted protein', 41, NULL, NULL, 200974),
(200975, '1.10.840.10-FF-000003', NULL, 'Ras guanyl-releasing protein 3 isoform 1', 270, NULL, NULL, 200975),
(200976, '2.40.50.360-FF-000004', NULL, 'RuvB-like helicase', 61, NULL, NULL, 200976);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(200977, '3.40.50.300-FF-002989', NULL, 'Uncharacterized protein, isoform B', 246, NULL, NULL, 200977),
(200978, '3.30.160.60-FF-001393', NULL, 'zinc finger protein 133 isoform X1', 25, NULL, NULL, 200978),
(200979, '3.30.470.20-FF-000106', NULL, 'Multifunctional urea amidolyase', 243, NULL, NULL, 200979),
(200980, '3.80.10.10-FF-002635', NULL, 'Leucine-rich repeat protein (LRRP), putative', 145, NULL, NULL, 200980),
(200981, '3.90.1150.10-FF-000284', NULL, 'GntR family transcriptional regulator', 134, NULL, NULL, 200981),
(200982, '1.10.220.30-FF-000030', NULL, 'Flagellar motor switch protein FliG', 102, NULL, NULL, 200982),
(200983, '3.30.200.20-FF-001121', NULL, 'Tyrosine-protein kinase receptor', 101, NULL, NULL, 200983),
(200984, '1.10.1380.10-FF-000017', NULL, 'Endothelin-converting enzyme (AFU_orthologue AFUA_3G12420)', 353, NULL, NULL, 200984),
(200985, '2.60.40.10-FF-001741', NULL, 'Basal cell adhesion molecule', 115, NULL, NULL, 200985),
(200986, '1.20.970.10-FF-000033', NULL, 'Anthranilate phosphoribosyltransferase', 92, NULL, NULL, 200986),
(200987, '2.120.10.80-FF-000296', NULL, 'Predicted protein', 209, NULL, NULL, 200987),
(200988, '1.10.10.10-FF-000794', NULL, 'Transcriptional regulator, putative', 100, NULL, NULL, 200988),
(200989, '3.40.50.720-FF-002525', NULL, 'Uncharacterized protein', 101, NULL, NULL, 200989),
(200990, '2.30.30.490-FF-000081', NULL, 'Origin recognition complex subunit 1', 297, NULL, NULL, 200990),
(200991, '3.30.40.10-FF-002134', NULL, 'Uncharacterized protein', 91, NULL, NULL, 200991),
(200992, '2.40.50.140-FF-000068', NULL, '26S protease regulatory subunit 8', 112, NULL, NULL, 200992),
(200993, '2.30.29.30-FF-000255', NULL, 'niban-like protein 1 isoform X1', 136, NULL, NULL, 200993),
(200994, '3.30.9.10-FF-000010', NULL, 'FAD-binding oxidoreductase', 152, NULL, NULL, 200994),
(200995, '3.10.100.10-FF-000339', NULL, NULL, 61, NULL, NULL, 200995),
(200996, '3.20.20.140-FF-000242', NULL, 'Amidohydrolase', 289, NULL, NULL, 200996),
(200997, '3.40.50.11260-FF-000008', NULL, 'Chaperone protein HtpG', 89, NULL, NULL, 200997),
(200998, '3.30.200.20-FF-002447', NULL, 'Predicted protein', 61, NULL, NULL, 200998),
(200999, '1.10.565.10-FF-000133', NULL, 'Nuclear receptor', 126, NULL, NULL, 200999),
(201000, '3.60.10.10-FF-000219', NULL, 'Endonuclease/Exonuclease/phosphatase family protein', 293, NULL, NULL, 201000),
(201001, '1.25.40.10-FF-005107', NULL, 'SET domain-containing protein', 119, NULL, NULL, 201001),
(201002, '2.40.50.120-FF-000062', NULL, 'Uncharacterized protein', 97, NULL, NULL, 201002),
(201003, '3.40.50.12370-FF-000010', NULL, 'Cation/H(+) antiporter 15', 288, NULL, NULL, 201003),
(201004, '3.40.50.360-FF-000023', NULL, 'NADPH--cytochrome P450 reductase', 189, NULL, NULL, 201004),
(201005, '2.30.30.140-FF-000010', NULL, 'MBT domain-containing protein 1 isoform X1', 108, NULL, NULL, 201005),
(201006, '3.80.10.10-FF-004434', NULL, 'MDIS1-interacting receptor like kinase 2', 170, NULL, NULL, 201006),
(201007, '3.40.30.10-FF-000300', NULL, 'Blast:Protein disulfide-isomerase TMX3', 118, NULL, NULL, 201007),
(201008, '1.25.40.20-FF-001513', NULL, 'Ankyrin repeat domain 17', 96, NULL, NULL, 201008),
(201009, '1.10.510.10-FF-003536', NULL, NULL, 237, NULL, NULL, 201009),
(201010, '1.20.1070.10-FF-000733', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1', 250, NULL, NULL, 201010),
(201011, '1.25.10.10-FF-003470', NULL, 'Importin subunit alpha-2', 113, NULL, NULL, 201011),
(201012, '1.10.287.2720-FF-000008', NULL, 'Oxysterol binding protein', 71, NULL, NULL, 201012),
(201013, '3.40.50.2000-FF-000621', NULL, 'Slr0907 protein', 174, NULL, NULL, 201013),
(201014, '2.60.40.10-FF-003208', NULL, NULL, 80, NULL, NULL, 201014),
(201015, '3.30.1430.10-FF-000010', NULL, 'Uncharacterized protein', 26, NULL, NULL, 201015),
(201016, '2.40.160.10-FF-000059', NULL, 'Uncharacterized protein', 284, NULL, NULL, 201016),
(201017, '1.25.40.90-FF-000078', NULL, 'Uncharacterized protein', 138, NULL, NULL, 201017),
(201018, '2.30.42.10-FF-000229', NULL, 'Uncharacterized protein', 95, NULL, NULL, 201018);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(201019, '3.30.1490.80-FF-000001', NULL, 'Glutathione synthetase', 75, NULL, NULL, 201019),
(201020, '1.20.1740.10-FF-000043', NULL, 'Inner membrane transporter YcaM', 473, NULL, NULL, 201020),
(201021, '3.30.40.10-FF-000335', NULL, 'RING-type E3 ubiquitin transferase', 76, NULL, NULL, 201021),
(201022, '1.25.40.10-FF-001510', NULL, 'Os07g0213300 protein', 107, NULL, NULL, 201022),
(201023, '3.30.230.70-FF-000098', NULL, 'Ribosomal RNA processing protein 41B', 251, NULL, NULL, 201023),
(201024, '1.10.600.10-FF-000109', NULL, 'Uncharacterized protein', 290, NULL, NULL, 201024),
(201025, '3.40.50.300-FF-005176', NULL, 'Thymidylate kinase', 220, NULL, NULL, 201025),
(201026, '2.120.10.30-FF-000287', NULL, 'Ten-1', 97, NULL, NULL, 201026),
(201027, '2.60.40.150-FF-000699', NULL, 'Uncharacterized protein', 150, NULL, NULL, 201027),
(201028, '3.90.1860.10-FF-000023', NULL, 'Uncharacterized protein', 258, NULL, NULL, 201028),
(201029, '3.40.50.1110-FF-000106', NULL, 'Membrane protein containing Lipase, GDSL domain', 183, NULL, NULL, 201029),
(201030, '3.30.40.10-FF-000425', NULL, 'PHD finger protein 11', 124, NULL, NULL, 201030),
(201031, '1.25.40.10-FF-003308', NULL, 'Uncharacterized protein', 95, NULL, NULL, 201031),
(201032, '1.10.287.70-FF-000504', NULL, 'Uncharacterized protein', 144, NULL, NULL, 201032),
(201033, '1.20.5.170-FF-000028', NULL, 'CCAAT/enhancer-binding protein beta', 77, NULL, NULL, 201033),
(201034, '3.80.10.10-FF-000634', NULL, 'Partner of Paired', 88, NULL, NULL, 201034),
(201035, '3.40.30.10-FF-001239', NULL, 'Uncharacterized protein', 87, NULL, NULL, 201035),
(201036, '1.20.1070.10-FF-001728', NULL, 'Uncharacterized protein', 95, NULL, NULL, 201036),
(201037, '1.10.10.820-FF-000027', NULL, 'Uncharacterized protein', 41, NULL, NULL, 201037),
(201038, '1.10.12.10-FF-000034', NULL, 'Enoyl-CoA hydratase', 57, NULL, NULL, 201038),
(201039, '3.30.1300.30-FF-000012', NULL, 'Necessary for collagen adhesion A1', 93, NULL, NULL, 201039),
(201040, '2.40.37.10-FF-000037', NULL, 'Ornithine decarboxylase', 146, NULL, NULL, 201040),
(201041, '3.90.190.10-FF-000326', NULL, 'Uncharacterized protein', 101, NULL, NULL, 201041),
(201042, '3.30.420.40-FF-000637', NULL, 'Decarbamoylnovobiocin carbamoyltransferase', 112, NULL, NULL, 201042),
(201043, '3.30.40.10-FF-000083', NULL, 'E3 ubiquitin-protein ligase MIB1 isoform X1', 69, NULL, NULL, 201043),
(201044, '2.60.40.1390-FF-000012', NULL, 'Myelin gene regulatory factor-like A', 202, NULL, NULL, 201044),
(201045, '2.60.40.10-FF-001409', NULL, 'Muscle M-line assembly protein unc-89', 101, NULL, NULL, 201045),
(201046, '1.10.3810.10-FF-000006', NULL, 'Penicillin-binding protein 1C', 195, NULL, NULL, 201046),
(201047, '2.40.30.10-FF-000483', NULL, 'Uncharacterized protein', 43, NULL, NULL, 201047),
(201048, '1.20.960.10-FF-000004', NULL, 'Mitochondrial import receptor subunit TOM20 homolog', 94, NULL, NULL, 201048),
(201049, '1.20.140.10-FF-000021', NULL, 'Acyl-coenzyme A oxidase 4, peroxisomal', 160, NULL, NULL, 201049),
(201050, '2.40.70.10-FF-000457', NULL, NULL, 114, NULL, NULL, 201050),
(201051, '3.30.519.10-FF-000048', NULL, NULL, 46, NULL, NULL, 201051),
(201052, '3.30.160.60-FF-003753', NULL, NULL, 59, NULL, NULL, 201052),
(201053, '1.25.40.20-FF-000895', NULL, 'Uncharacterized protein', 140, NULL, NULL, 201053),
(201054, '4.10.240.10-FF-000070', NULL, 'Aspergillus niger contig An11c0010, genomic contig', 61, NULL, NULL, 201054),
(201055, '3.40.50.300-FF-006789', NULL, 'Uncharacterized protein', 57, NULL, NULL, 201055),
(201056, '3.90.1030.20-FF-000014', NULL, NULL, 114, NULL, NULL, 201056),
(201057, '1.25.40.10-FF-000892', NULL, 'SNAP protein, putative', 288, NULL, NULL, 201057),
(201058, '2.60.40.10-FF-003540', NULL, NULL, 109, NULL, NULL, 201058),
(201059, '1.25.10.10-FF-002756', NULL, 'Coatomer subunit beta', 631, NULL, NULL, 201059),
(201060, '2.60.120.260-FF-000409', NULL, 'Uncharacterized protein', 151, NULL, NULL, 201060),
(201061, '3.30.70.330-FF-000296', NULL, 'RNA binding motif protein 19', 119, NULL, NULL, 201061),
(201062, '3.90.1030.10-FF-000011', NULL, 'Ribosomal protein L17', 122, NULL, NULL, 201062);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(201063, '3.40.50.300-FF-003046', NULL, 'Sulfotransferase', 328, NULL, NULL, 201063),
(201064, '3.90.110.10-FF-000024', NULL, NULL, 188, NULL, NULL, 201064),
(201065, '3.30.230.10-FF-000338', NULL, 'Uncharacterized protein', 57, NULL, NULL, 201065),
(201066, '1.20.5.700-FF-000007', NULL, 'Cytochrome b6-f complex iron-sulfur subunit', 42, NULL, NULL, 201066),
(201067, '2.30.30.40-FF-000649', NULL, 'Uncharacterized protein', 147, NULL, NULL, 201067),
(201068, '3.30.2290.10-FF-000004', NULL, 'Metalloprotease TldD', 218, NULL, NULL, 201068),
(201069, '1.20.58.2190-FF-000014', NULL, 'Uncharacterized protein', 88, NULL, NULL, 201069),
(201070, '1.10.10.10-FF-000884', NULL, 'Crp/Fnr family transcriptional regulator', 72, NULL, NULL, 201070),
(201071, '1.20.58.400-FF-000024', NULL, 'AaceriAFL168Wp', 96, NULL, NULL, 201071),
(201072, '1.10.260.40-FF-000007', NULL, 'POU domain protein', 94, NULL, NULL, 201072),
(201073, '3.90.320.10-FF-000034', NULL, 'Mitochondrial genome maintenance exonuclease 1', 231, NULL, NULL, 201073),
(201074, '3.10.20.620-FF-000012', NULL, NULL, 78, NULL, NULL, 201074),
(201075, '2.130.10.10-FF-003102', NULL, 'Uncharacterized protein', 300, NULL, NULL, 201075),
(201076, '3.30.1520.10-FF-000107', NULL, 'Phosphoinositide-binding protein, putative', 139, NULL, NULL, 201076),
(201077, '2.10.110.10-FF-000282', NULL, 'Uncharacterized protein', 38, NULL, NULL, 201077),
(201078, '1.10.4150.10-FF-000001', NULL, 'Invasin ipaA', 214, NULL, NULL, 201078),
(201079, '1.50.10.20-FF-000082', NULL, 'Cycloartenol synthase 2', 371, NULL, NULL, 201079),
(201080, '1.10.1090.10-FF-000006', NULL, 'Cytochrome b-c1 complex subunit 7', 84, NULL, NULL, 201080),
(201081, '3.30.160.60-FF-003444', NULL, 'Zinc finger protein 142', 60, NULL, NULL, 201081),
(201082, '1.10.510.10-FF-002699', NULL, NULL, 136, NULL, NULL, 201082),
(201083, '1.20.5.1940-FF-000006', NULL, 'Signal transducing adapter molecule 1', 77, NULL, NULL, 201083),
(201084, '3.90.1010.10-FF-000009', NULL, 'FeS cluster assembly scaffold protein NifU', 133, NULL, NULL, 201084),
(201085, '1.10.510.10-FF-003317', NULL, NULL, 71, NULL, NULL, 201085),
(201086, '2.60.40.10-FF-001651', NULL, 'titin isoform X1', 89, NULL, NULL, 201086),
(201087, '3.90.640.10-FF-000182', NULL, 'Actin-related protein 10', 105, NULL, NULL, 201087),
(201088, '2.130.10.10-FF-002484', NULL, 'DNA damage-binding protein 1 isoform X3', 204, NULL, NULL, 201088),
(201089, '2.60.120.200-FF-000307', NULL, 'Predicted protein', 215, NULL, NULL, 201089),
(201090, '2.20.70.10-FF-000284', NULL, 'Predicted protein', 38, NULL, NULL, 201090),
(201091, '3.20.20.190-FF-000010', NULL, 'Phosphoinositide phospholipase C', 307, NULL, NULL, 201091),
(201092, '3.40.50.300-FF-007430', NULL, 'P-loop containing nucleoside triphosphate hydrolases superfamily protein', 261, NULL, NULL, 201092),
(201093, '2.130.10.10-FF-003630', NULL, 'Uncharacterized protein', 116, NULL, NULL, 201093),
(201094, '3.40.50.720-FF-002435', NULL, 'Probable 2-dehydropantoate 2-reductase', 184, NULL, NULL, 201094),
(201095, '1.25.10.10-FF-003161', NULL, 'Uncharacterized protein', 370, NULL, NULL, 201095),
(201096, '3.20.190.10-FF-000022', NULL, 'LOC100135209 protein', 121, NULL, NULL, 201096),
(201097, '3.30.465.10-FF-000136', NULL, 'Uncharacterized protein', 98, NULL, NULL, 201097),
(201098, '3.20.70.20-FF-000014', NULL, 'Ribonucleoside-diphosphate reductase', 671, NULL, NULL, 201098),
(201099, '3.80.10.10-FF-000073', NULL, 'Lumican', 138, NULL, NULL, 201099),
(201100, '2.60.40.10-FF-001286', NULL, 'Oncostatin-M-specific receptor subunit beta', 125, NULL, NULL, 201100),
(201101, '3.30.420.10-FF-000263', NULL, 'Pro-Pol polyprotein', 163, NULL, NULL, 201101),
(201102, '2.130.10.10-FF-003411', NULL, 'GTPase activator protein', 188, NULL, NULL, 201102),
(201103, '3.40.50.300-FF-007407', NULL, 'DNA polymerase theta (Helicase domain only), putative', 180, NULL, NULL, 201103),
(201104, '3.40.50.300-FF-002883', NULL, 'Kurz, isoform B', 102, NULL, NULL, 201104),
(201105, '1.20.142.10-FF-000003', NULL, 'Poly [ADP-ribose] polymerase', 145, NULL, NULL, 201105);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(201106, '3.40.30.10-FF-000986', NULL, 'Glutaredoxin, CGFS type', 89, NULL, NULL, 201106),
(201107, '1.25.40.10-FF-004944', NULL, 'Intraflagellar transport protein', 322, NULL, NULL, 201107),
(201108, '3.80.10.10-FF-004215', NULL, 'MAP kinase phosphatase with leucine-rich repeats protein 3', 86, NULL, NULL, 201108),
(201109, '2.60.40.10-FF-005029', NULL, NULL, 104, NULL, NULL, 201109),
(201110, '1.10.10.60-FF-001056', NULL, NULL, 52, NULL, NULL, 201110),
(201111, '3.30.160.380-FF-000004', NULL, 'Dicer-like protein 1', 97, NULL, NULL, 201111),
(201112, '2.120.10.30-FF-000539', NULL, 'Uncharacterized protein', 104, NULL, NULL, 201112),
(201113, '3.30.1330.40-FF-000062', NULL, 'Uncharacterized protein', 157, NULL, NULL, 201113),
(201114, '3.40.390.10-FF-000139', NULL, 'Metalloendopeptidase', 177, NULL, NULL, 201114),
(201115, '3.40.50.11660-FF-000005', NULL, 'Glycoprotein 3-alpha-L-fucosyltransferase A', 193, NULL, NULL, 201115),
(201116, '2.130.10.10-FF-001067', NULL, 'Regulatory-associated protein of mTOR isoform 1', 83, NULL, NULL, 201116),
(201117, '1.10.1520.10-FF-000006', NULL, 'Endoribonuclease Dicer isoform 1', 163, NULL, NULL, 201117),
(201118, '2.170.140.10-FF-000038', NULL, 'Probable chitinase 10', 66, NULL, NULL, 201118),
(201119, '1.20.1250.20-FF-000503', NULL, 'Drug resistance transporter, EmrB/QacA subfamily', 205, NULL, NULL, 201119),
(201120, '3.40.50.300-FF-003136', NULL, 'Uncharacterized protein', 110, NULL, NULL, 201120),
(201121, '1.10.510.10-FF-003008', NULL, NULL, 288, NULL, NULL, 201121),
(201122, '2.60.40.10-FF-005338', NULL, NULL, 74, NULL, NULL, 201122),
(201123, '3.40.50.1400-FF-000002', NULL, 'Ferrochelatase', 139, NULL, NULL, 201123),
(201124, '3.40.50.1000-FF-000675', NULL, NULL, 175, NULL, NULL, 201124),
(201125, '3.40.50.12780-FF-000026', NULL, 'Uncharacterized protein, isoform B', 490, NULL, NULL, 201125),
(201126, '3.40.50.150-FF-001365', NULL, NULL, 184, NULL, NULL, 201126),
(201127, '3.40.525.10-FF-000055', NULL, 'Tyrosine-protein phosphatase non-receptor type 9', 270, NULL, NULL, 201127),
(201128, '3.30.497.10-FF-000165', NULL, 'Uncharacterized protein', 46, NULL, NULL, 201128),
(201129, '3.30.70.1990-FF-000002', NULL, 'FAD-dependent oxidoreductase', 89, NULL, NULL, 201129),
(201130, '2.60.40.420-FF-000038', NULL, 'Extracellular dihydrogeodin oxidase/laccase', 189, NULL, NULL, 201130),
(201131, '3.40.50.620-FF-000135', NULL, 'Phosphoadenosine phosphosulfate reductase family protein', 231, NULL, NULL, 201131),
(201132, '2.60.120.650-FF-000190', NULL, 'Uncharacterized protein', 76, NULL, NULL, 201132),
(201133, '1.20.58.60-FF-000671', NULL, 'Uncharacterized protein', 200, NULL, NULL, 201133),
(201134, '3.40.50.150-FF-001275', NULL, NULL, 225, NULL, NULL, 201134),
(201135, '1.20.1280.290-FF-000066', NULL, 'Sugar_efflux_transporter_for_intercellular_exchange_-_putative', 88, NULL, NULL, 201135),
(201136, '1.20.1420.30-FF-000087', NULL, 'Uncharacterized protein', 118, NULL, NULL, 201136),
(201137, '1.10.10.1070-FF-000001', NULL, 'zinc finger protein 618 isoform X2', 64, NULL, NULL, 201137),
(201138, '3.40.1710.10-FF-000007', NULL, 'ABC transporter, permease protein, putative', 142, NULL, NULL, 201138),
(201139, '1.20.1070.10-FF-000391', NULL, 'Parapinopsin b', 315, NULL, NULL, 201139),
(201140, '2.60.110.10-FF-000012', NULL, 'TOND1', 31, NULL, NULL, 201140),
(201141, '1.25.40.10-FF-004635', NULL, 'Uncharacterized protein', 63, NULL, NULL, 201141),
(201142, '3.30.870.10-FF-000196', NULL, 'Uncharacterized protein', 178, NULL, NULL, 201142),
(201143, '3.10.20.90-FF-000111', NULL, 'Histidine ammonia-lyase', 86, NULL, NULL, 201143),
(201144, '3.40.1190.20-FF-000003', NULL, 'Phosphomethylpyrimidine kinase ThiD', 264, NULL, NULL, 201144),
(201145, '3.30.260.10-FF-000076', NULL, NULL, 104, NULL, NULL, 201145),
(201146, '3.30.300.70-FF-000002', NULL, 'Ribosome maturation factor RimP', 81, NULL, NULL, 201146),
(201147, '2.130.10.10-FF-002793', NULL, 'Integrin alpha chain protein, putative', 203, NULL, NULL, 201147),
(201148, '1.20.58.60-FF-000362', NULL, 'Spectrin repeat containing nuclear envelope protein 1', 135, NULL, NULL, 201148);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(201149, '2.20.110.10-FF-000009', NULL, 'alsin isoform X1', 52, NULL, NULL, 201149),
(201150, '3.20.20.100-FF-000146', NULL, 'Uncharacterized protein', 273, NULL, NULL, 201150),
(201151, '1.25.40.120-FF-000032', NULL, 'Putative farnesyl protein transferase', 120, NULL, NULL, 201151),
(201152, '3.40.1440.10-FF-000014', NULL, 'Putative bifunctional exonuclease/endonuclease protein Rv2191', 97, NULL, NULL, 201152),
(201153, '3.30.160.60-FF-002949', NULL, 'Uncharacterized protein, isoform A', 24, NULL, NULL, 201153),
(201154, '3.30.70.330-FF-002460', NULL, NULL, 83, NULL, NULL, 201154),
(201155, '3.40.630.30-FF-000142', NULL, 'Alpha-tubulin N-acetyltransferase 1', 179, NULL, NULL, 201155),
(201156, '3.30.1120.30-FF-000026', NULL, 'Serine/threonine-protein kinase', 40, NULL, NULL, 201156),
(201157, '3.30.160.60-FF-000100', NULL, 'Zinc finger 45-like', 29, NULL, NULL, 201157),
(201158, '2.130.10.10-FF-003321', NULL, 'YALI0C23386p', 141, NULL, NULL, 201158),
(201159, '3.80.10.10-FF-000163', NULL, 'Tyrosine-protein kinase receptor', 152, NULL, NULL, 201159),
(201160, '3.60.110.10-FF-000047', NULL, 'N-carbamoyl-D-amino acid hydrolase', 303, NULL, NULL, 201160),
(201161, '3.30.300.90-FF-000008', NULL, 'Transcriptional regulator', 90, NULL, NULL, 201161),
(201162, '3.10.590.10-FF-000021', NULL, 'Uncharacterized protein', 129, NULL, NULL, 201162),
(201163, '1.20.1070.10-FF-000643', NULL, 'Methuselah-like 1, isoform B', 299, NULL, NULL, 201163),
(201164, '2.60.40.10-FF-002736', NULL, 'Chitin biosynthesis protein CHS5', 89, NULL, NULL, 201164),
(201165, '1.10.600.10-FF-000019', NULL, '2-methylisoborneol synthase', 325, NULL, NULL, 201165),
(201166, '3.30.559.10-FF-000135', NULL, 'Nonribosomal peptide synthetase 9', 120, NULL, NULL, 201166),
(201167, '2.40.50.140-FF-000192', NULL, 'Mitochondrial ribosomal protein S12', 131, NULL, NULL, 201167),
(201168, '3.60.10.10-FF-000113', NULL, 'CRE-UNC-26 protein', 354, NULL, NULL, 201168),
(201169, '3.40.50.300-FF-001461', NULL, 'GTP-binding protein ryh1', 174, NULL, NULL, 201169),
(201170, '1.10.287.70-FF-000151', NULL, 'TWiK family of potassium channels', 303, NULL, NULL, 201170),
(201171, '2.60.40.10-FF-003231', NULL, 'Cell surface glycoprotein CD200 receptor 1-A', 112, NULL, NULL, 201171),
(201172, '3.90.550.50-FF-000097', NULL, 'Glycosyltransferase family 31 protein', 165, NULL, NULL, 201172),
(201173, '1.10.10.10-FF-000682', NULL, 'MarR family transcriptional regulator', 140, NULL, NULL, 201173),
(201174, '3.40.1000.30-FF-000015', NULL, 'Uncharacterized protein', 153, NULL, NULL, 201174),
(201175, '1.10.238.10-FF-000992', NULL, 'Phosphoinositide phospholipase C', 52, NULL, NULL, 201175),
(201176, '1.10.600.10-FF-000126', NULL, 'Quemao protein', 73, NULL, NULL, 201176),
(201177, '2.120.10.80-FF-000184', NULL, 'GM15889', 275, NULL, NULL, 201177),
(201178, '3.40.50.300-FF-008386', NULL, 'Regulator of nonsense transcripts putative', 200, NULL, NULL, 201178),
(201179, '1.10.10.850-FF-000002', NULL, 'Isocitrate lyase', 93, NULL, NULL, 201179),
(201180, '2.60.40.10-FF-004849', NULL, NULL, 122, NULL, NULL, 201180),
(201181, '2.10.25.10-FF-001826', NULL, 'AGAP001015-PA', 45, NULL, NULL, 201181),
(201182, '3.30.70.330-FF-000436', NULL, '50S ribosomal protein L23', 127, NULL, NULL, 201182),
(201183, '1.20.1070.10-FF-001947', NULL, 'Uncharacterized protein', 335, NULL, NULL, 201183),
(201184, '3.40.190.10-FF-000821', NULL, 'Glutamate receptor', 65, NULL, NULL, 201184),
(201185, '3.40.50.150-FF-001590', NULL, NULL, 279, NULL, NULL, 201185),
(201186, '2.40.37.10-FF-000054', NULL, NULL, 135, NULL, NULL, 201186),
(201187, '2.130.10.10-FF-002692', NULL, 'Ribosome biogenesis protein WDR12 homolog', 329, NULL, NULL, 201187),
(201188, '2.60.60.30-FF-000006', NULL, 'Putative Tellurium resistance protein', 143, NULL, NULL, 201188),
(201189, '1.20.1250.20-FF-002184', NULL, 'Uncharacterized protein', 166, NULL, NULL, 201189),
(201190, '2.10.25.10-FF-000303', NULL, 'latent-transforming growth factor beta-binding protein 3 isoform X2', 42, NULL, NULL, 201190),
(201191, '3.30.70.330-FF-001959', NULL, NULL, 206, NULL, NULL, 201191);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(201192, '1.20.1270.230-FF-000001', NULL, 'Primer terminal protein', 95, NULL, NULL, 201192),
(201193, '3.30.420.10-FF-000403', NULL, NULL, 193, NULL, NULL, 201193),
(201194, '2.60.60.20-FF-000003', NULL, 'Triacylglycerol lipase', 113, NULL, NULL, 201194),
(201195, '1.20.920.10-FF-000114', NULL, 'SWI/SNF class chromatin remodeling complex protein', 115, NULL, NULL, 201195),
(201196, '3.40.140.10-FF-000189', NULL, 'Uncharacterized protein', 141, NULL, NULL, 201196),
(201197, '3.30.565.10-FF-000548', NULL, 'Cytokinin receptor AtCKI2-like protein', 118, NULL, NULL, 201197),
(201198, '3.90.470.10-FF-000045', NULL, 'Predicted protein', 112, NULL, NULL, 201198),
(201199, '3.90.1150.10-FF-000048', NULL, 'Serine hydroxymethyltransferase, mitochondrial', 25, NULL, NULL, 201199),
(201200, '2.130.10.10-FF-005333', NULL, 'Predicted protein', 187, NULL, NULL, 201200),
(201201, '3.30.420.40-FF-000952', NULL, 'Actin-related protein 8', 67, NULL, NULL, 201201),
(201202, '1.25.40.180-FF-000117', NULL, 'eIF4-gamma/eIF5/eIF2b-epsilon initiation factor, C-terminal domain', 171, NULL, NULL, 201202),
(201203, '1.10.10.410-FF-000005', NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit B, mitochondrial', 64, NULL, NULL, 201203),
(201204, '2.10.110.10-FF-000271', NULL, 'Four and a half LIM domains protein 2', 50, NULL, NULL, 201204),
(201205, '3.30.1470.10-FF-000001', NULL, 'Centrosomal protein of 164 kDa', 119, NULL, NULL, 201205),
(201206, '2.130.10.10-FF-003304', NULL, 'Predicted protein', 137, NULL, NULL, 201206),
(201207, '1.20.1270.250-FF-000007', NULL, NULL, 136, NULL, NULL, 201207),
(201208, '1.25.40.10-FF-004725', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 85, NULL, NULL, 201208),
(201209, '3.40.50.620-FF-000253', NULL, 'NH(3)-dependent NAD(+) synthetase', 275, NULL, NULL, 201209),
(201210, '1.20.1270.10-FF-000052', NULL, 'Lumenal Hsp70 protein', 112, NULL, NULL, 201210),
(201211, '3.30.2350.10-FF-000072', NULL, 'Uncharacterized protein', 212, NULL, NULL, 201211),
(201212, '3.30.70.330-FF-000857', NULL, 'Peptidyl-prolyl cis-trans isomerase', 166, NULL, NULL, 201212),
(201213, '2.60.120.200-FF-000521', NULL, 'YALI0E06347p', 220, NULL, NULL, 201213),
(201214, '3.40.1190.20-FF-000121', NULL, 'Adenosine kinase-like Protein', 254, NULL, NULL, 201214),
(201215, '1.25.40.10-FF-002376', NULL, 'Os11g0114800 protein', 94, NULL, NULL, 201215),
(201216, '2.40.70.10-FF-000581', NULL, NULL, 146, NULL, NULL, 201216),
(201217, '3.50.50.60-FF-000428', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 149, NULL, NULL, 201217),
(201218, '3.30.70.120-FF-000019', NULL, NULL, 124, NULL, NULL, 201218),
(201219, '3.40.50.2300-FF-000273', NULL, 'Two-component system response regulator RpfG', 145, NULL, NULL, 201219),
(201220, '2.20.25.10-FF-000100', NULL, 'Uncharacterized protein', 123, NULL, NULL, 201220),
(201221, '3.40.220.10-FF-000009', NULL, 'Poly [ADP-ribose] polymerase', 182, NULL, NULL, 201221),
(201222, '1.25.10.10-FF-001025', NULL, 'Uncharacterized protein', 298, NULL, NULL, 201222),
(201223, '1.25.10.10-FF-002874', NULL, 'Predicted protein', 154, NULL, NULL, 201223),
(201224, '3.40.50.300-FF-001556', NULL, 'ABC transporter G family member 6', 238, NULL, NULL, 201224),
(201225, '3.30.67.10-FF-000003', NULL, 'Genome polyprotein', 89, NULL, NULL, 201225),
(201226, '2.60.220.50-FF-000015', NULL, 'Adhesion G protein-coupled receptor F4', 150, NULL, NULL, 201226),
(201227, '3.30.450.20-FF-000329', NULL, 'Sensory box histidine kinase/response regulator', 126, NULL, NULL, 201227),
(201228, '3.30.9.10-FF-000015', NULL, 'FAD-dependent oxidoreductase domain containing 1', 167, NULL, NULL, 201228),
(201229, '1.10.10.10-FF-000777', NULL, 'Probable ATP dependent RNA helicase', 97, NULL, NULL, 201229),
(201230, '3.40.50.10190-FF-000103', NULL, 'Pescadillo homolog', 82, NULL, NULL, 201230),
(201231, '3.40.50.1260-FF-000016', NULL, 'Phosphoglycerate kinase', 72, NULL, NULL, 201231),
(201232, '3.30.70.100-FF-000013', NULL, 'L-rhamnose mutarotase', 97, NULL, NULL, 201232),
(201233, '2.40.50.140-FF-000871', NULL, NULL, 85, NULL, NULL, 201233);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(201234, '1.20.58.60-FF-000356', NULL, 'VAB-10B protein', 109, NULL, NULL, 201234),
(201235, '1.20.5.170-FF-000141', NULL, 'C6 transcription factor (Gal4), putative', 43, NULL, NULL, 201235),
(201236, '1.10.510.10-FF-001530', NULL, 'Kinase, AGC MAST', 79, NULL, NULL, 201236),
(201237, '2.60.40.10-FF-003326', NULL, NULL, 71, NULL, NULL, 201237),
(201238, '2.60.40.10-FF-004754', NULL, NULL, 102, NULL, NULL, 201238),
(201239, '2.20.100.10-FF-000161', NULL, 'F-spondin', 50, NULL, NULL, 201239),
(201240, '3.30.430.20-FF-000008', NULL, 'cysteine-rich repeat secretory protein 3', 98, NULL, NULL, 201240),
(201241, '3.40.50.300-FF-002984', NULL, 'DNA mismatch repair protein MutS 1', 287, NULL, NULL, 201241),
(201242, '2.30.40.10-FF-000146', NULL, 'Predicted protein', 47, NULL, NULL, 201242),
(201243, '2.60.120.260-FF-000174', NULL, 'Beta-glucosidase', 168, NULL, NULL, 201243),
(201244, '3.30.70.330-FF-000762', NULL, 'Zinc finger CCCH domain-containing protein 27', 95, NULL, NULL, 201244),
(201245, '2.60.40.3170-FF-000012', NULL, 'Predicted protein', 114, NULL, NULL, 201245),
(201246, '1.50.40.10-FF-000142', NULL, 'Solute carrier family 25 member 26', 150, NULL, NULL, 201246),
(201247, '3.10.450.350-FF-000004', NULL, 'Glycyl-glycine endopeptidase ALE-1', 115, NULL, NULL, 201247),
(201248, '3.30.160.60-FF-002837', NULL, 'Zinc finger protein 232', 34, NULL, NULL, 201248),
(201249, '1.20.1080.10-FF-000026', NULL, 'Big brain', 256, NULL, NULL, 201249),
(201250, '3.40.50.2300-FF-000952', NULL, NULL, 130, NULL, NULL, 201250),
(201251, '1.25.40.180-FF-000022', NULL, 'Translation initiation factor eIF-2B epsilon subunit', 178, NULL, NULL, 201251),
(201252, '3.30.160.60-FF-001640', NULL, 'Zinc finger and BTB domain containing 40', 93, NULL, NULL, 201252),
(201253, '1.25.40.10-FF-003202', NULL, 'Pentatricopeptide repeat-containing protein At4g21065', 88, NULL, NULL, 201253),
(201254, '3.40.50.720-FF-000395', NULL, 'ubiquitin-like modifier-activating enzyme ATG7', 351, NULL, NULL, 201254),
(201255, '3.30.70.1230-FF-000100', NULL, '7TM diverse intracellular signaling', 185, NULL, NULL, 201255),
(201256, '3.30.1360.230-FF-000003', NULL, 'Suppressor of fused homolog', 136, NULL, NULL, 201256),
(201257, '3.30.200.20-FF-000188', NULL, 'Hepatocyte growth factor receptor', 126, NULL, NULL, 201257),
(201258, '3.30.710.10-FF-000055', NULL, 'BTB/POZ domain-containing protein 7', 195, NULL, NULL, 201258),
(201259, '3.40.50.150-FF-001601', NULL, NULL, 350, NULL, NULL, 201259),
(201260, '2.30.29.30-FF-000805', NULL, 'AGAP003924-PA', 171, NULL, NULL, 201260),
(201261, '2.40.510.10-FF-000002', NULL, 'Capsid protein', 173, NULL, NULL, 201261),
(201262, '1.10.630.10-FF-000049', NULL, 'steroid 21-hydroxylase isoform X1', 468, NULL, NULL, 201262),
(201263, '1.10.10.60-FF-001039', NULL, NULL, 82, NULL, NULL, 201263),
(201264, '3.40.50.2300-FF-000626', NULL, 'Glutamate ionotropic receptor NMDA type subunit 2D', 88, NULL, NULL, 201264),
(201265, '1.10.10.10-FF-001620', NULL, 'Uncharacterized protein', 101, NULL, NULL, 201265),
(201266, '1.10.150.50-FF-000232', NULL, 'Uncharacterized protein', 76, NULL, NULL, 201266),
(201267, '2.60.420.10-FF-000013', NULL, 'Uncharacterized protein', 105, NULL, NULL, 201267),
(201268, '2.40.50.140-FF-001130', NULL, NULL, 117, NULL, NULL, 201268),
(201269, '3.40.50.1820-FF-000555', NULL, 'Uncharacterized protein, isoform C', 294, NULL, NULL, 201269),
(201270, '1.25.40.20-FF-001182', NULL, 'Uncharacterized protein', 70, NULL, NULL, 201270),
(201271, '3.30.1230.20-FF-000009', NULL, 'Tubulin folding cofactor E', 48, NULL, NULL, 201271),
(201272, '3.80.10.10-FF-002427', NULL, 'LRR receptor-like serine/threonine-protein kinase RCH1', 116, NULL, NULL, 201272),
(201273, '4.10.410.20-FF-000007', NULL, 'Poly(U)-specific endoribonuclease', 52, NULL, NULL, 201273),
(201274, '1.10.555.10-FF-000200', NULL, NULL, 122, NULL, NULL, 201274),
(201275, '3.90.45.10-FF-000012', NULL, 'Peptide deformylase', 161, NULL, NULL, 201275),
(201276, '3.90.190.10-FF-000107', NULL, 'Dual specificity phosphatase 28', 150, NULL, NULL, 201276); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(201277, '3.80.10.10-FF-000303', NULL, 'Zyg-11 family member A, cell cycle regulator', 163, NULL, NULL, 201277),
(201278, '3.30.160.60-FF-001314', NULL, 'Zinc finger protein 879', 27, NULL, NULL, 201278),
(201279, '3.30.70.260-FF-000033', NULL, 'Aspartokinase', 83, NULL, NULL, 201279),
(201280, '3.30.497.10-FF-000148', NULL, 'Uncharacterized protein', 97, NULL, NULL, 201280),
(201281, '1.25.40.10-FF-005017', NULL, 'Uncharacterized protein', 195, NULL, NULL, 201281),
(201282, '2.40.70.10-FF-000367', NULL, NULL, 246, NULL, NULL, 201282),
(201283, '3.40.50.300-FF-003259', NULL, 'U5 small nuclear ribonucleoprotein component, putative', 219, NULL, NULL, 201283),
(201284, '2.30.29.170-FF-000011', NULL, 'Putative DUF1126 protein/EF-hand domain pair, putative', 115, NULL, NULL, 201284),
(201285, '3.30.1360.10-FF-000027', NULL, 'RNA polymerases II subunit, putative', 109, NULL, NULL, 201285),
(201286, '1.10.510.10-FF-000687', NULL, 'MAP kinase kinase MKK1/SSP32', 193, NULL, NULL, 201286),
(201287, '3.30.470.20-FF-000229', NULL, 'Uncharacterized protein', 104, NULL, NULL, 201287),
(201288, '3.40.1170.10-FF-000004', NULL, 'DNA mismatch repair protein', 132, NULL, NULL, 201288),
(201289, '2.120.10.30-FF-000534', NULL, 'Uncharacterized protein', 133, NULL, NULL, 201289),
(201290, '3.30.70.270-FF-000036', NULL, 'Diguanylate cyclase domain-containing protein', 167, NULL, NULL, 201290),
(201291, '3.40.50.720-FF-001929', NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 9, mitochondrial', 289, NULL, NULL, 201291),
(201292, '1.25.40.10-FF-003191', NULL, 'Uncharacterized protein', 95, NULL, NULL, 201292),
(201293, '3.40.50.300-FF-003922', NULL, 'Protein CBG13237', 299, NULL, NULL, 201293),
(201294, '3.40.50.720-FF-000406', NULL, 'Acyl-CoA synthetase FdrA', 135, NULL, NULL, 201294),
(201295, '1.20.58.1220-FF-000004', NULL, 'Exocyst complex component Exo84, putative', 100, NULL, NULL, 201295),
(201296, '2.60.40.1940-FF-000008', NULL, 'C3 and PZP-like alpha-2-macroglobulin domain-containing protein 8', 109, NULL, NULL, 201296),
(201297, '3.90.650.10-FF-000031', NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase', 148, NULL, NULL, 201297),
(201298, '3.30.70.660-FF-000063', NULL, 'tRNA pseudouridine synthase', 306, NULL, NULL, 201298),
(201299, '2.60.40.1930-FF-000005', NULL, 'complement C4-A isoform X3', 100, NULL, NULL, 201299),
(201300, '3.90.79.10-FF-000079', NULL, 'mRNA decapping complex subunit 2', 133, NULL, NULL, 201300),
(201301, '3.40.50.300-FF-005513', NULL, 'Uncharacterized protein', 151, NULL, NULL, 201301),
(201302, '4.10.1000.10-FF-000100', NULL, 'Uncharacterized protein', 34, NULL, NULL, 201302),
(201303, '3.40.1390.30-FF-000010', NULL, 'Putative GTP cyclohydrolase 1 type 2, NIF3 family', 91, NULL, NULL, 201303),
(201304, '3.30.428.10-FF-000062', NULL, 'AGAP004084-PA', 130, NULL, NULL, 201304),
(201305, '3.90.1150.10-FF-000374', NULL, 'PLP-dependent transferase', 48, NULL, NULL, 201305),
(201306, '3.30.310.80-FF-000040', NULL, 'Uncharacterized protein', 130, NULL, NULL, 201306),
(201307, '1.20.58.1070-FF-000021', NULL, 'Putative SNARE complex subunit Vam7 (Eurofung)', 155, NULL, NULL, 201307),
(201308, '3.30.200.100-FF-000004', NULL, 'Sigma-E factor regulatory protein RseB', 96, NULL, NULL, 201308),
(201309, '3.30.200.20-FF-001126', NULL, 'Cell Division Cycle related', 85, NULL, NULL, 201309),
(201310, '3.40.50.150-FF-000775', NULL, 'Sterol 24-C-methyltransferase', 257, NULL, NULL, 201310),
(201311, '3.80.10.10-FF-000292', NULL, 'Dynein regulatory complex subunit 3', 172, NULL, NULL, 201311),
(201312, '3.60.70.12-FF-000006', NULL, 'Arginine biosynthesis bifunctional protein ArgJ, mitochondrial', 221, NULL, NULL, 201312),
(201313, '3.40.50.150-FF-001264', NULL, NULL, 242, NULL, NULL, 201313),
(201314, '3.80.10.10-FF-002074', NULL, 'Uncharacterized protein', 217, NULL, NULL, 201314),
(201315, '3.40.50.1000-FF-000877', NULL, NULL, 32, NULL, NULL, 201315),
(201316, '3.20.70.20-FF-000003', NULL, 'Formate acetyltransferase', 758, NULL, NULL, 201316),
(201317, '3.30.160.60-FF-003085', NULL, 'Transcriptional repressor CTCF', 29, NULL, NULL, 201317);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(201318, '3.40.50.2000-FF-000059', NULL, 'Phosphatidylinositol glycan anchor biosynthesis class A', 162, NULL, NULL, 201318),
(201319, '3.30.70.250-FF-000030', NULL, NULL, 69, NULL, NULL, 201319),
(201320, '3.30.70.330-FF-002774', NULL, NULL, 73, NULL, NULL, 201320),
(201321, '3.30.390.30-FF-000041', NULL, 'Nitrate reductase, NADH oxidase subunit', 80, NULL, NULL, 201321),
(201322, '2.30.30.100-FF-000150', NULL, 'AGAP003131-PA', 65, NULL, NULL, 201322),
(201323, '3.30.760.10-FF-000092', NULL, 'Uncharacterized protein', 105, NULL, NULL, 201323),
(201324, '3.30.60.20-FF-000087', NULL, 'Ras association domain family member 1', 70, NULL, NULL, 201324),
(201325, '3.40.50.720-FF-000620', NULL, '3-oxoacyl-(Acyl carrier protein) reductase', 263, NULL, NULL, 201325),
(201326, '3.90.70.10-FF-000773', NULL, 'Uncharacterized protein', 59, NULL, NULL, 201326),
(201327, '2.70.160.11-FF-000019', NULL, 'Protein arginine N-methyltransferase 7', 171, NULL, NULL, 201327),
(201328, '1.10.510.10-FF-003328', NULL, NULL, 60, NULL, NULL, 201328),
(201329, '1.10.8.60-FF-000010', NULL, 'RuvB-like helicase', 90, NULL, NULL, 201329),
(201330, '3.40.50.300-FF-002658', NULL, 'Dephospho-CoA kinase', 200, NULL, NULL, 201330),
(201331, '3.30.160.60-FF-001735', NULL, 'zinc finger CCCH domain-containing protein 7A', 47, NULL, NULL, 201331),
(201332, '3.30.450.20-FF-000217', NULL, 'Sensor histidine kinase', 172, NULL, NULL, 201332),
(201333, '3.30.60.90-FF-000051', NULL, 'Uncharacterized protein', 58, NULL, NULL, 201333),
(201334, '2.60.120.260-FF-000269', NULL, 'Uncharacterized protein', 117, NULL, NULL, 201334),
(201335, '1.25.40.860-FF-000012', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 117, NULL, NULL, 201335),
(201336, '3.80.10.10-FF-004114', NULL, 'Uncharacterized protein', 117, NULL, NULL, 201336),
(201337, '3.90.70.10-FF-000559', NULL, 'Predicted protein', 185, NULL, NULL, 201337),
(201338, '1.10.1520.10-FF-000107', NULL, 'Uncharacterized protein', 174, NULL, NULL, 201338),
(201339, '2.10.110.10-FF-000057', NULL, 'Zyxin', 75, NULL, NULL, 201339),
(201340, '1.10.486.10-FF-000067', NULL, 'DNA helicase', 149, NULL, NULL, 201340),
(201341, '1.10.420.10-FF-000028', NULL, 'Ascorbate peroxidase', 139, NULL, NULL, 201341),
(201342, '1.20.1070.10-FF-000071', NULL, '5-hydroxytryptamine (serotonin) receptor 7a', 347, NULL, NULL, 201342),
(201343, '3.20.20.80-FF-000821', NULL, 'Protein CBG10890', 66, NULL, NULL, 201343),
(201344, '2.10.50.30-FF-000036', NULL, 'Vomeronasal 2, receptor27', 71, NULL, NULL, 201344),
(201345, '3.40.50.300-FF-005608', NULL, 'Cell division control protein 48 homolog D', 68, NULL, NULL, 201345),
(201346, '3.30.200.110-FF-000007', NULL, NULL, 94, NULL, NULL, 201346),
(201347, '3.40.50.1820-FF-000460', NULL, 'Acetyl-hydrolase LipR', 284, NULL, NULL, 201347),
(201348, '3.90.320.10-FF-000045', NULL, 'ATP-dependent nuclease subunit A', 183, NULL, NULL, 201348),
(201349, '1.50.40.10-FF-000030', NULL, 'Mitochondrial uncoupling protein 5', 314, NULL, NULL, 201349),
(201350, '3.10.250.10-FF-000001', NULL, 'Lysyl oxidase 4 isoform X1', 110, NULL, NULL, 201350),
(201351, '2.40.10.10-FF-000684', NULL, NULL, 55, NULL, NULL, 201351),
(201352, '1.25.40.10-FF-005231', NULL, 'Uncharacterized protein', 179, NULL, NULL, 201352),
(201353, '3.20.20.100-FF-000039', NULL, 'Putative oxidoreductase', 316, NULL, NULL, 201353),
(201354, '3.40.50.1820-FF-001657', NULL, 'Carboxypeptidase', 220, NULL, NULL, 201354),
(201355, '3.40.570.10-FF-000007', NULL, 'Alkaline nuclease', 239, NULL, NULL, 201355),
(201356, '3.20.20.300-FF-000015', NULL, 'Glycoside hydrolase, putative', 322, NULL, NULL, 201356),
(201357, '1.20.1070.10-FF-000750', NULL, 'Predicted protein', 295, NULL, NULL, 201357),
(201358, '3.40.190.10-FF-000607', NULL, 'ABC-type transporter, periplasmic component', 190, NULL, NULL, 201358),
(201359, '1.20.58.1210-FF-000001', NULL, 'exocyst complex component 8', 121, NULL, NULL, 201359),
(201360, '2.60.220.50-FF-000127', NULL, 'Uncharacterized protein', 184, NULL, NULL, 201360),
(201361, '3.30.50.10-FF-000156', NULL, 'AGAP009890-PA', 61, NULL, NULL, 201361);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(201362, '3.30.200.20-FF-002537', NULL, 'Uncharacterized protein', 72, NULL, NULL, 201362),
(201363, '2.60.120.200-FF-000184', NULL, 'Botulinum neurotoxin type A', 229, NULL, NULL, 201363),
(201364, '2.30.30.490-FF-000103', NULL, 'Uncharacterized protein', 174, NULL, NULL, 201364),
(201365, '3.40.50.1000-FF-000782', NULL, NULL, 66, NULL, NULL, 201365),
(201366, '3.30.200.20-FF-001031', NULL, 'Protein kinase domain containing protein', 84, NULL, NULL, 201366),
(201367, '2.10.50.10-FF-000030', NULL, 'Tumor necrosis factor receptor superfamily member 11B', 86, NULL, NULL, 201367),
(201368, '1.25.40.1040-FF-000052', NULL, 'Tetratricopeptide repeat (TPR)-containing protein', 41, NULL, NULL, 201368),
(201369, '1.10.220.30-FF-000024', NULL, 'FliG C-terminal domain protein', 131, NULL, NULL, 201369),
(201370, '1.10.3810.10-FF-000001', NULL, 'Penicillin-binding protein 1A', 197, NULL, NULL, 201370),
(201371, '3.10.580.10-FF-000071', NULL, 'Hypoxic response protein 1', 127, NULL, NULL, 201371),
(201372, '4.10.80.390-FF-000001', NULL, 'ORF1a polyprotein', 51, NULL, NULL, 201372),
(201373, '1.10.167.20-FF-000003', NULL, 'Nucleoporin NUP170, putative', 80, NULL, NULL, 201373),
(201374, '2.130.10.10-FF-003416', NULL, 'Sensor histidine kinase/response regulator', 183, NULL, NULL, 201374),
(201375, '3.40.640.10-FF-000457', NULL, 'Uncharacterized protein', 219, NULL, NULL, 201375),
(201376, '1.20.1250.20-FF-000508', NULL, 'Sodium-dependent glucose transporter 1', 188, NULL, NULL, 201376),
(201377, '3.30.160.60-FF-001752', NULL, 'Transcriptional factor SWI5', 46, NULL, NULL, 201377),
(201378, '3.40.50.970-FF-000127', NULL, 'Phosphonopyruvate decarboxylase-like protein', 207, NULL, NULL, 201378),
(201379, '1.10.10.60-FF-000764', NULL, NULL, 50, NULL, NULL, 201379),
(201380, '3.90.79.10-FF-000293', NULL, 'Adenine DNA glycosylase', 132, NULL, NULL, 201380),
(201381, '3.50.7.10-FF-000085', NULL, NULL, 18, NULL, NULL, 201381),
(201382, '3.40.50.300-FF-003473', NULL, 'Dynamin GTPase', 314, NULL, NULL, 201382),
(201383, '3.30.70.2760-FF-000014', NULL, NULL, 77, NULL, NULL, 201383),
(201384, '3.30.465.10-FF-000029', NULL, 'FAD binding domain in molybdopterin dehydrogenase', 75, NULL, NULL, 201384),
(201385, '1.20.920.20-FF-000005', NULL, 'Dynein cytoplasmic 1 heavy chain 1', 45, NULL, NULL, 201385),
(201386, '1.10.150.170-FF-000007', NULL, 'S-adenosyl-methyltransferase Mraw', 112, NULL, NULL, 201386),
(201387, '3.40.50.800-FF-000104', NULL, 'YALI0D15620p', 77, NULL, NULL, 201387),
(201388, '3.40.50.10240-FF-000028', NULL, 'Chromosome 9, whole genome shotgun sequence', 150, NULL, NULL, 201388),
(201389, '1.10.8.10-FF-000023', NULL, 'Putative ubiquitin carboxyl-terminal hydrolase 25', 73, NULL, NULL, 201389),
(201390, '3.40.50.1220-FF-000033', NULL, 'Electron transfer flavoprotein subunit alpha', 129, NULL, NULL, 201390),
(201391, '1.10.10.60-FF-000994', NULL, NULL, 76, NULL, NULL, 201391),
(201392, '1.10.600.10-FF-000014', NULL, 'Heptaprenyl diphosphate synthase component II', 320, NULL, NULL, 201392),
(201393, '1.20.1250.20-FF-000172', NULL, 'MFS multidrug resistance transporter', 417, NULL, NULL, 201393),
(201394, '3.30.450.20-FF-000560', NULL, 'Nitrogen-responsive two component signal transduction system histidine kinase with PAS sensory domain GlnL', 107, NULL, NULL, 201394),
(201395, '3.40.50.300-FF-001573', NULL, 'Carbon monoxide dehydrogenase accessory protein CooC', 255, NULL, NULL, 201395),
(201396, '2.60.40.10-FF-004737', NULL, NULL, 88, NULL, NULL, 201396),
(201397, '3.40.220.10-FF-000026', NULL, 'Probable ADP-ribose 1''''-phosphate phosphatase YML087W', 284, NULL, NULL, 201397),
(201398, '2.60.40.10-FF-005243', NULL, NULL, 114, NULL, NULL, 201398),
(201399, '2.60.40.10-FF-002837', NULL, 'Natural cytotoxicity triggering receptor 3 ligand 1', 104, NULL, NULL, 201399),
(201400, '3.30.230.10-FF-000350', NULL, 'Type 2 DNA topoisomerase 6 subunit B', 203, NULL, NULL, 201400),
(201401, '1.20.1250.20-FF-002072', NULL, 'Uncharacterized protein', 280, NULL, NULL, 201401),
(201402, '3.30.200.20-FF-000851', NULL, 'Protein CBG21256', 105, NULL, NULL, 201402);
INSERT INTO "PUBLIC"."MODEL" VALUES
(201403, '3.40.1280.10-FF-000125', NULL, 'Protein CBR-EXOS-8', 54, NULL, NULL, 201403),
(201404, '1.25.40.20-FF-001844', NULL, 'Ankyrin repeat and SAM domain-containing protein 6', 142, NULL, NULL, 201404),
(201405, '1.25.40.10-FF-002943', NULL, 'Tetratricopeptide repeat protein 17-like Protein', 167, NULL, NULL, 201405),
(201406, '1.25.40.170-FF-000002', NULL, 'Protein Smaug homolog 1 isoform 2', 53, NULL, NULL, 201406),
(201407, '1.25.40.410-FF-000012', NULL, 'Dedicator of cytokinesis protein 5', 78, NULL, NULL, 201407),
(201408, '3.30.230.40-FF-000004', NULL, 'Imidazoleglycerol-phosphate dehydratase', 96, NULL, NULL, 201408),
(201409, '3.40.50.620-FF-000820', NULL, 'Uncharacterized protein', 321, NULL, NULL, 201409),
(201410, '1.25.40.10-FF-004837', NULL, 'Os01g0263600 protein', 142, NULL, NULL, 201410),
(201411, '1.25.10.10-FF-000957', NULL, 'rap1 GTPase-GDP dissociation stimulator 1 isoform X5', 158, NULL, NULL, 201411),
(201412, '3.30.70.1350-FF-000041', NULL, NULL, 79, NULL, NULL, 201412),
(201413, '3.30.160.60-FF-003652', NULL, NULL, 28, NULL, NULL, 201413),
(201414, '3.30.300.30-FF-000125', NULL, 'Acyl-CoA synthetase', 124, NULL, NULL, 201414),
(201415, '1.25.10.10-FF-003363', NULL, 'Uncharacterized protein', 182, NULL, NULL, 201415),
(201416, '1.10.10.10-FF-000889', NULL, 'Os05g0586600 protein', 53, NULL, NULL, 201416),
(201417, '3.30.750.200-FF-000006', NULL, NULL, 116, NULL, NULL, 201417),
(201418, '3.30.160.60-FF-006199', NULL, NULL, 44, NULL, NULL, 201418),
(201419, '3.40.50.1440-FF-000099', NULL, 'Tubulin alpha chain', 46, NULL, NULL, 201419),
(201420, '2.20.70.10-FF-000177', NULL, 'PQBP1 (Polyglutamine tract-binding neurodegeneration protein) homolog', 45, NULL, NULL, 201420),
(201421, '3.40.50.720-FF-000732', NULL, 'Unplaced genomic scaffold supercont1.13, whole genome shotgun sequence', 158, NULL, NULL, 201421),
(201422, '1.25.40.10-FF-000459', NULL, 'Pentatricopeptide repeat-containing protein', 152, NULL, NULL, 201422),
(201423, '1.10.150.20-FF-000252', NULL, 'DNA polymerase IV', 62, NULL, NULL, 201423),
(201424, '3.30.710.10-FF-000038', NULL, 'BTB/POZ domain-containing protein KCTD3 isoform X1', 104, NULL, NULL, 201424),
(201425, '1.25.40.180-FF-000005', NULL, 'Ccr4-not transcription complex subunit 1 isoform', 257, NULL, NULL, 201425),
(201426, '1.10.1040.10-FF-000065', NULL, 'Uncharacterized protein', 154, NULL, NULL, 201426),
(201427, '3.40.50.1370-FF-000050', NULL, NULL, 79, NULL, NULL, 201427),
(201428, '1.10.510.10-FF-002839', NULL, NULL, 32, NULL, NULL, 201428),
(201429, '1.20.920.10-FF-000002', NULL, 'Bromodomain-containing protein 4', 130, NULL, NULL, 201429),
(201430, '3.40.30.10-FF-000053', NULL, 'Thiol:disulfide interchange protein', 88, NULL, NULL, 201430),
(201431, '1.10.418.10-FF-000197', NULL, 'Protein Hook homolog 3', 165, NULL, NULL, 201431),
(201432, '3.40.50.12780-FF-000228', NULL, 'Uncharacterized protein', 215, NULL, NULL, 201432),
(201433, '2.130.10.10-FF-000775', NULL, 'BnaA09g28200D protein', 86, NULL, NULL, 201433),
(201434, '1.20.58.1380-FF-000007', NULL, 'Nucleoporin, putative', 82, NULL, NULL, 201434),
(201435, '2.130.10.30-FF-000101', NULL, NULL, 189, NULL, NULL, 201435),
(201436, '2.30.26.10-FF-000001', NULL, 'Dihydroorotate dehydrogenase (fumarate)', 44, NULL, NULL, 201436),
(201437, '3.80.10.10-FF-001938', NULL, 'Leucine-rich repeat protein kinase family protein', 223, NULL, NULL, 201437),
(201438, '1.10.630.10-FF-000280', NULL, 'Uncharacterized protein', 132, NULL, NULL, 201438),
(201439, '3.30.559.70-FF-000029', NULL, 'Choline O-acetyltransferase-like Protein', 310, NULL, NULL, 201439),
(201440, '1.25.40.570-FF-000032', NULL, 'GD12156', 375, NULL, NULL, 201440),
(201441, '3.40.50.2000-FF-000952', NULL, 'Glycosyl transferase group 1', 112, NULL, NULL, 201441),
(201442, '1.20.1250.20-FF-001936', NULL, 'Uncharacterized protein', 469, NULL, NULL, 201442),
(201443, '3.40.630.30-FF-000041', NULL, 'Histone acetyltransferase MCC1 isoform A', 182, NULL, NULL, 201443),
(201444, '3.30.413.10-FF-000033', NULL, '4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase (flavodoxin)', 100, NULL, NULL, 201444); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(201445, '2.60.40.10-FF-001314', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', 103, NULL, NULL, 201445),
(201446, '3.10.110.10-FF-000076', NULL, 'Ubiquitin-conjugating enzyme E2 W', 145, NULL, NULL, 201446),
(201447, '3.40.850.10-FF-000271', NULL, 'Chitin synthase-domain-containing protein', 66, NULL, NULL, 201447),
(201448, '3.20.20.190-FF-000009', NULL, 'Glycerophosphodiester phosphodiesterase, periplasmic', 328, NULL, NULL, 201448),
(201449, '3.90.640.10-FF-000103', NULL, 'Actin, putative', 74, NULL, NULL, 201449),
(201450, '2.130.10.10-FF-001281', NULL, 'DDB1- and CUL4-associated factor 11 isoform X2', 99, NULL, NULL, 201450),
(201451, '2.130.10.10-FF-003181', NULL, 'Uncharacterized protein', 489, NULL, NULL, 201451),
(201452, '1.20.58.60-FF-000805', NULL, 'Uncharacterized protein', 202, NULL, NULL, 201452),
(201453, '3.40.1440.60-FF-000001', NULL, 'Primosomal protein N', 110, NULL, NULL, 201453),
(201454, '3.90.1010.10-FF-000004', NULL, 'Cysteine desulfuration protein SufE', 138, NULL, NULL, 201454),
(201455, '3.20.20.80-FF-000400', NULL, 'Glucan endo-1,3-beta-glucosidase 8', 249, NULL, NULL, 201455),
(201456, '3.10.20.90-FF-000010', NULL, 'Autophagy-related protein', 117, NULL, NULL, 201456),
(201457, '1.25.40.420-FF-000015', NULL, 'Kelch-like family member 31', 102, NULL, NULL, 201457),
(201458, '3.40.50.300-FF-006469', NULL, 'Os04g0680700 protein', 119, NULL, NULL, 201458),
(201459, '1.20.1410.10-FF-000041', NULL, 'Uncharacterized protein', 186, NULL, NULL, 201459),
(201460, '3.50.50.60-FF-000642', NULL, 'Uncharacterized protein', 51, NULL, NULL, 201460),
(201461, '3.30.750.24-FF-000149', NULL, 'Uncharacterized protein', 138, NULL, NULL, 201461),
(201462, '3.30.60.220-FF-000002', NULL, 'DEAD-box ATP-dependent RNA helicase 41', 58, NULL, NULL, 201462),
(201463, '1.10.10.60-FF-001270', NULL, NULL, 83, NULL, NULL, 201463),
(201464, '1.25.40.10-FF-000689', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 110, NULL, NULL, 201464),
(201465, '3.80.10.10-FF-000062', NULL, 'protein STRUBBELIG-RECEPTOR FAMILY 3', 228, NULL, NULL, 201465),
(201466, '1.10.10.10-FF-001171', NULL, 'ETS translocation variant 3 isoform X1', 74, NULL, NULL, 201466),
(201467, '2.30.29.30-FF-000126', NULL, '3-phosphoinositide dependent protein kinase 1', 148, NULL, NULL, 201467),
(201468, '1.20.58.1370-FF-000004', NULL, 'Lysine (K)-specific demethylase 6A', 49, NULL, NULL, 201468),
(201469, '2.10.25.10-FF-000180', NULL, 'Netrin G2', 48, NULL, NULL, 201469),
(201470, '1.20.58.60-FF-000570', NULL, 'Spectrin beta chain', 106, NULL, NULL, 201470),
(201471, '2.170.300.10-FF-000034', NULL, 'Multiple epidermal growth factor-like domains protein 10', 68, NULL, NULL, 201471),
(201472, '1.25.40.430-FF-000018', NULL, 'Uncharacterized protein', 189, NULL, NULL, 201472),
(201473, '1.20.120.1240-FF-000041', NULL, 'Dynamin-related protein 1D', 248, NULL, NULL, 201473),
(201474, '1.25.40.10-FF-004388', NULL, 'Uncharacterized protein', 141, NULL, NULL, 201474),
(201475, '3.30.70.60-FF-000026', NULL, 'Uncharacterized protein', 70, NULL, NULL, 201475),
(201476, '1.25.40.20-FF-000788', NULL, 'Ankyrin repeat family protein', 144, NULL, NULL, 201476),
(201477, '1.20.58.1360-FF-000001', NULL, 'Histone lysine demethylase PHF8', 86, NULL, NULL, 201477),
(201478, '2.60.20.10-FF-000003', NULL, 'Crystallin gamma S', 90, NULL, NULL, 201478),
(201479, '1.10.510.10-FF-001316', NULL, 'Protein kinase, putative', 221, NULL, NULL, 201479),
(201480, '3.30.559.10-FF-000247', NULL, 'Uncharacterized protein', 76, NULL, NULL, 201480),
(201481, '3.90.20.20-FF-000031', NULL, 'Protein GrpE', 116, NULL, NULL, 201481),
(201482, '1.10.238.10-FF-000778', NULL, 'CALUmenin (Calcium-binding protein) homolog', 80, NULL, NULL, 201482),
(201483, '3.40.718.10-FF-000008', NULL, 'Phosphate acyltransferase', 341, NULL, NULL, 201483),
(201484, '1.25.40.10-FF-000785', NULL, 'DNA-directed RNA polymerase', 161, NULL, NULL, 201484),
(201485, '2.40.330.10-FF-000016', NULL, NULL, 108, NULL, NULL, 201485),
(201486, '3.30.470.20-FF-000117', NULL, 'Glutathione synthetase', 112, NULL, NULL, 201486); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(201487, '3.30.160.60-FF-003326', NULL, 'tRNA dimethylallyltransferase', 42, NULL, NULL, 201487),
(201488, '3.30.1010.10-FF-000029', NULL, 'Serine/threonine-protein kinase SMG1', 134, NULL, NULL, 201488),
(201489, '3.80.10.10-FF-002091', NULL, 'Predicted protein', 253, NULL, NULL, 201489),
(201490, '3.30.160.20-FF-000133', NULL, '40S ribosomal protein S2', 106, NULL, NULL, 201490),
(201491, '3.30.450.20-FF-000234', NULL, 'PAS domain S-box protein', 124, NULL, NULL, 201491),
(201492, '3.90.1530.10-FF-000015', NULL, 'Sulfiredoxin chloroplastic/mitochondrial', 50, NULL, NULL, 201492),
(201493, '1.10.510.10-FF-003087', NULL, NULL, 199, NULL, NULL, 201493),
(201494, '1.20.1250.20-FF-001110', NULL, 'MFS general substrate transporter', 382, NULL, NULL, 201494),
(201495, '3.90.1150.10-FF-000391', NULL, 'Uncharacterized aminotransferase C27F1.05c', 155, NULL, NULL, 201495),
(201496, '1.10.720.30-FF-000034', NULL, 'Altered inheritance of mitochondria protein 34, mitochondrial', 46, NULL, NULL, 201496),
(201497, '2.60.200.10-FF-000036', NULL, 'Smad protein', 198, NULL, NULL, 201497),
(201498, '2.10.25.10-FF-001489', NULL, 'Eater', 36, NULL, NULL, 201498),
(201499, '1.10.510.10-FF-001193', NULL, 'Si:dkey-192d15.1', 259, NULL, NULL, 201499),
(201500, '3.30.1370.10-FF-000179', NULL, 'Uncharacterized protein', 118, NULL, NULL, 201500),
(201501, '3.30.40.10-FF-002336', NULL, 'Uncharacterized protein', 139, NULL, NULL, 201501),
(201502, '4.10.60.10-FF-000088', NULL, 'Cleavage and polyadenylation specificity factor subunit 4-like Protein', 27, NULL, NULL, 201502),
(201503, '3.40.50.720-FF-002323', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 121, NULL, NULL, 201503),
(201504, '1.10.10.60-FF-000668', NULL, 'Adenosinetriphosphatase', 83, NULL, NULL, 201504),
(201505, '1.20.58.60-FF-000244', NULL, 'Spectrin beta chain', 130, NULL, NULL, 201505),
(201506, '1.25.40.1040-FF-000035', NULL, 'mRNA 3''-end-processing protein RNA14', 239, NULL, NULL, 201506),
(201507, '3.30.70.870-FF-000019', NULL, 'Translation elongation factor G', 77, NULL, NULL, 201507),
(201508, '2.60.40.60-FF-000688', NULL, 'Cadherin-4', 104, NULL, NULL, 201508),
(201509, '1.20.1250.20-FF-000834', NULL, 'EmrB/QacA family drug resistance transporter', 365, NULL, NULL, 201509),
(201510, '1.10.238.10-FF-001037', NULL, 'Calmodulin 5', 54, NULL, NULL, 201510),
(201511, '3.40.190.10-FF-000484', NULL, 'Sensory box sensor histidine kinase/response regulator VieS', 91, NULL, NULL, 201511),
(201512, '3.40.50.12620-FF-000001', NULL, 'Glucokinase regulatory protein', 129, NULL, NULL, 201512),
(201513, '3.10.129.10-FF-000085', NULL, 'Acyl-CoA thioesterase', 152, NULL, NULL, 201513),
(201514, '2.30.29.30-FF-000356', NULL, 'Non-specific serine/threonine protein kinase', 120, NULL, NULL, 201514),
(201515, '3.40.50.300-FF-001135', NULL, 'ABC transporter F family member 3', 309, NULL, NULL, 201515),
(201516, '3.30.200.20-FF-002554', NULL, 'Protein kinase-like protein', 79, NULL, NULL, 201516),
(201517, '3.30.200.20-FF-001014', NULL, 'Serine/threonine-protein kinase-like protein', 99, NULL, NULL, 201517),
(201518, '2.60.40.420-FF-000252', NULL, 'Uncharacterized protein', 105, NULL, NULL, 201518),
(201519, '2.40.10.240-FF-000011', NULL, NULL, 106, NULL, NULL, 201519),
(201520, '3.30.420.40-FF-001020', NULL, 'Predicted protein', 50, NULL, NULL, 201520),
(201521, '2.30.42.10-FF-000437', NULL, NULL, 109, NULL, NULL, 201521),
(201522, '1.20.58.1610-FF-000014', NULL, NULL, 124, NULL, NULL, 201522),
(201523, '1.10.150.120-FF-000021', NULL, NULL, 137, NULL, NULL, 201523),
(201524, '1.10.3380.10-FF-000023', NULL, 'Putative DEAD/DEAH box helicase-like protein', 149, NULL, NULL, 201524),
(201525, '3.40.50.300-FF-005058', NULL, 'Uncharacterized protein', 145, NULL, NULL, 201525),
(201526, '3.40.50.2300-FF-000609', NULL, 'Sensory box sensor histidine kinase/response regulator', 120, NULL, NULL, 201526),
(201527, '3.30.200.160-FF-000011', NULL, 'RNA polymerase III transcription factor subunit, putative (AFU_orthologue AFUA_5G02550)', 159, NULL, NULL, 201527),
(201528, '1.20.58.760-FF-000019', NULL, 'ATP-dependent zinc metalloprotease', 106, NULL, NULL, 201528);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(201529, '1.10.640.10-FF-000005', NULL, 'Fatty acid oxygenase', 553, NULL, NULL, 201529),
(201530, '1.20.1070.10-FF-000519', NULL, 'CNMamide receptor', 333, NULL, NULL, 201530),
(201531, '1.20.1560.10-FF-000506', NULL, 'Uncharacterized protein', 303, NULL, NULL, 201531),
(201532, '3.90.1750.20-FF-000012', NULL, 'Site-specific recombinase / invertase', 111, NULL, NULL, 201532),
(201533, '3.30.70.850-FF-000013', NULL, 'Neuroendocrine convertase 2-like', 93, NULL, NULL, 201533),
(201534, '3.30.160.60-FF-001191', NULL, 'POZ-, AT hook-, and zinc finger-containing protein 1 isoform X1', 29, NULL, NULL, 201534),
(201535, '2.130.10.10-FF-005007', NULL, 'Uncharacterized protein', 51, NULL, NULL, 201535),
(201536, '1.10.1370.10-FF-000051', NULL, 'Im:6903007 protein', 91, NULL, NULL, 201536),
(201537, '3.40.140.100-FF-000021', NULL, 'Autophagy related 7', 69, NULL, NULL, 201537),
(201538, '2.120.10.30-FF-000079', NULL, 'S9 family peptidase', 179, NULL, NULL, 201538),
(201539, '3.60.10.10-FF-000130', NULL, 'DNA-(apurinic or apyrimidinic site) lyase', 267, NULL, NULL, 201539),
(201540, '3.90.190.10-FF-000124', NULL, 'Paladin', 371, NULL, NULL, 201540),
(201541, '1.25.10.10-FF-001137', NULL, 'Predicted protein', 266, NULL, NULL, 201541),
(201542, '1.20.1090.10-FF-000066', NULL, 'Predicted protein', 126, NULL, NULL, 201542),
(201543, '2.60.40.60-FF-000784', NULL, 'Cadherin 15', 113, NULL, NULL, 201543),
(201544, '2.40.50.140-FF-000399', NULL, 'Ribonuclease E', 90, NULL, NULL, 201544),
(201545, '1.10.8.500-FF-000006', NULL, 'Methyl-accepting chemotaxis protein', 52, NULL, NULL, 201545),
(201546, '1.20.900.10-FF-000102', NULL, 'MKIAA0380 protein', 73, NULL, NULL, 201546),
(201547, '3.40.50.11210-FF-000011', NULL, 'Uncharacterized protein', 168, NULL, NULL, 201547),
(201548, '3.40.50.300-FF-000033', NULL, '26S protease regulatory subunit 6B', 181, NULL, NULL, 201548),
(201549, '3.40.50.300-FF-007525', NULL, 'Uncharacterized protein', 209, NULL, NULL, 201549),
(201550, '1.10.3380.30-FF-000029', NULL, 'ATP-dependent DNA helicase Hel308', 228, NULL, NULL, 201550),
(201551, '1.20.1070.10-FF-002083', NULL, 'Calcitonin gene-related peptide type 1 receptor-like Protein', 298, NULL, NULL, 201551),
(201552, '3.40.50.720-FF-000069', NULL, 'Inositol-3-phosphate synthase 1', 354, NULL, NULL, 201552),
(201553, '2.60.120.10-FF-000310', NULL, 'Mannose-6-phosphate isomerase', 218, NULL, NULL, 201553),
(201554, '3.40.50.880-FF-000089', NULL, 'Catalase', 149, NULL, NULL, 201554),
(201555, '3.40.50.300-FF-005160', NULL, 'ABC transporter, ATP-binding protein', 225, NULL, NULL, 201555),
(201556, '3.30.70.660-FF-000046', NULL, 'tRNA pseudouridine synthase A', 166, NULL, NULL, 201556),
(201557, '3.30.30.30-FF-000020', NULL, 'Ssz1p', 54, NULL, NULL, 201557),
(201558, '2.130.10.10-FF-004827', NULL, 'Predicted protein', 136, NULL, NULL, 201558),
(201559, '2.60.40.10-FF-001191', NULL, 'Uncharacterized protein, isoform B', 96, NULL, NULL, 201559),
(201560, '1.25.10.10-FF-002548', NULL, 'Uncharacterized protein', 178, NULL, NULL, 201560),
(201561, '1.10.287.130-FF-000017', NULL, 'Two-component sensor histidine kinase', 81, NULL, NULL, 201561),
(201562, '1.20.1070.10-FF-000312', NULL, 'protein trapped in endoderm-1', 316, NULL, NULL, 201562),
(201563, '1.20.5.110-FF-000151', NULL, 'Ehsyntaxin B, putative', 105, NULL, NULL, 201563),
(201564, '3.40.50.300-FF-008498', NULL, 'Uncharacterized protein', 295, NULL, NULL, 201564),
(201565, '3.40.50.1820-FF-000229', NULL, 'Lactonizing lipase', 283, NULL, NULL, 201565),
(201566, '3.40.50.450-FF-000050', NULL, 'ATP-dependent 6-phosphofructokinase', 61, NULL, NULL, 201566),
(201567, '3.30.420.40-FF-000738', NULL, 'Uncharacterized protein', 109, NULL, NULL, 201567),
(201568, '3.30.565.10-FF-000099', NULL, 'Sensory transduction histidine kinase', 168, NULL, NULL, 201568),
(201569, '1.20.58.90-FF-000011', NULL, 'Tubulin-specific chaperone A', 108, NULL, NULL, 201569),
(201570, '3.40.50.300-FF-007312', NULL, 'GTPase, putative', 147, NULL, NULL, 201570),
(201571, '3.30.450.380-FF-000003', NULL, 'Pilus assembly protein CpaF', 174, NULL, NULL, 201571);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(201572, '1.25.10.10-FF-003037', NULL, 'Plakophilin 1', 300, NULL, NULL, 201572),
(201573, '1.20.120.80-FF-000018', NULL, 'Cytochrome c oxidase, coo3-type, subunit III', 194, NULL, NULL, 201573),
(201574, '3.40.366.10-FF-000016', NULL, 'Fatty acid synthase subunit beta', 215, NULL, NULL, 201574),
(201575, '2.60.40.10-FF-003652', NULL, 'Protein CBR-UNC-40', 98, NULL, NULL, 201575),
(201576, '3.90.220.20-FF-000001', NULL, 'Type I restriction-modification system restriction endonuclease DNA specificity subunit HsdS', 152, NULL, NULL, 201576),
(201577, '3.40.50.2000-FF-000076', NULL, 'GDP-Man:Man(3)GlcNAc(2)-PP-Dol alpha-1,2-mannosyltransferase', 186, NULL, NULL, 201577),
(201578, '2.60.120.650-FF-000072', NULL, 'Lysine-specific demethylase 3', 348, NULL, NULL, 201578),
(201579, '2.170.16.10-FF-000033', NULL, 'XK-related protein', 165, NULL, NULL, 201579),
(201580, '2.60.40.10-FF-002949', NULL, 'Hyaluronan proteoglycan link protein 1', 109, NULL, NULL, 201580),
(201581, '3.40.50.10130-FF-000001', NULL, 'DNA excision repair protein ERCC-1', 116, NULL, NULL, 201581),
(201582, '1.20.1250.20-FF-000284', NULL, 'Siderophore iron transporter mirB', 270, NULL, NULL, 201582),
(201583, '2.60.40.150-FF-000828', NULL, 'Uncharacterized protein', 47, NULL, NULL, 201583),
(201584, '3.40.50.1820-FF-000117', NULL, 'Monoglyceride lipase, putative', 280, NULL, NULL, 201584),
(201585, '1.25.40.820-FF-000028', NULL, 'RNA polymerase II subunit B1 CTD phosphatase', 160, NULL, NULL, 201585),
(201586, '3.40.50.10140-FF-000004', NULL, 'X-linked interleukin-1 receptor accessory protein-like 1', 159, NULL, NULL, 201586),
(201587, '3.40.50.1170-FF-000006', NULL, 'Asparaginase-like protein', 202, NULL, NULL, 201587),
(201588, '1.20.1560.10-FF-000153', NULL, 'multidrug resistance protein homolog 65', 621, NULL, NULL, 201588),
(201589, '1.10.630.10-FF-000403', NULL, 'Cytochrome P450', 487, NULL, NULL, 201589),
(201590, '3.90.1800.10-FF-000019', NULL, 'DNA-directed RNA polymerase subunit beta', 108, NULL, NULL, 201590),
(201591, '2.60.40.10-FF-005125', NULL, NULL, 97, NULL, NULL, 201591),
(201592, '3.30.300.30-FF-000013', NULL, 'Long-chain fatty acid--CoA ligase', 107, NULL, NULL, 201592),
(201593, '1.25.40.10-FF-000577', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 60, NULL, NULL, 201593),
(201594, '3.40.50.200-FF-000020', NULL, 'Minor extracellular protease', 307, NULL, NULL, 201594),
(201595, '3.40.50.300-FF-003361', NULL, 'Uncharacterized protein, isoform B', 242, NULL, NULL, 201595),
(201596, '1.10.287.130-FF-000135', NULL, 'Sensor histidine kinase', 106, NULL, NULL, 201596),
(201597, '1.20.5.170-FF-000045', NULL, 'nuclear pore glycoprotein p62', 64, NULL, NULL, 201597),
(201598, '2.130.10.10-FF-005092', NULL, 'Uncharacterized protein', 256, NULL, NULL, 201598),
(201599, '1.10.10.60-FF-000876', NULL, NULL, 67, NULL, NULL, 201599),
(201600, '3.30.420.580-FF-000012', NULL, 'Actin-related protein 8', 180, NULL, NULL, 201600),
(201601, '2.60.120.290-FF-000042', NULL, 'AGAP005526-PA', 114, NULL, NULL, 201601),
(201602, '3.40.50.960-FF-000012', NULL, '6,7-dimethyl-8-ribityllumazine synthase', 151, NULL, NULL, 201602),
(201603, '2.60.120.260-FF-000623', NULL, 'Exo-beta-D-glucosaminidase', 127, NULL, NULL, 201603),
(201604, '3.30.70.2850-FF-000035', NULL, 'Uncharacterized protein', 126, NULL, NULL, 201604),
(201605, '3.30.1360.40-FF-000007', NULL, 'ribosome-recycling factor, mitochondrial isoform X1', 76, NULL, NULL, 201605),
(201606, '2.30.29.30-FF-000570', NULL, 'Uncharacterized protein, isoform B', 169, NULL, NULL, 201606),
(201607, '3.90.190.10-FF-000551', NULL, 'Uncharacterized protein', 123, NULL, NULL, 201607),
(201608, '3.30.300.20-FF-000010', NULL, 'OsmC family peroxiredoxin', 143, NULL, NULL, 201608),
(201609, '3.30.200.20-FF-000963', NULL, 'Mitogen-activated protein kinase kinase kinase 13', 92, NULL, NULL, 201609),
(201610, '1.10.12.10-FF-000051', NULL, 'Methylthioacryloyl-CoA hydratase', 59, NULL, NULL, 201610),
(201611, '1.25.40.120-FF-000015', NULL, 'Protein prenyltransferase alpha subunit repeat-containing protein 1-B isoform D', 306, NULL, NULL, 201611);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(201612, '3.90.70.80-FF-000057', NULL, 'OTU-like cysteine protease, putative', 167, NULL, NULL, 201612),
(201613, '3.30.70.330-FF-002235', NULL, NULL, 107, NULL, NULL, 201613),
(201614, '3.40.50.360-FF-000135', NULL, 'Tryptophan repressor binding protein', 191, NULL, NULL, 201614),
(201615, '3.30.160.60-FF-003540', NULL, NULL, 23, NULL, NULL, 201615),
(201616, '2.60.40.10-FF-001426', NULL, 'Intercellular adhesion molecule 4', 102, NULL, NULL, 201616),
(201617, '1.25.40.10-FF-004949', NULL, 'TPR Domain containing protein', 174, NULL, NULL, 201617),
(201618, '3.30.40.10-FF-000650', NULL, 'Homeobox protein HAT3.1', 74, NULL, NULL, 201618),
(201619, '3.90.1150.10-FF-000278', NULL, 'Aminotransferase PigE', 106, NULL, NULL, 201619),
(201620, '3.40.50.11900-FF-000004', NULL, 'R-phenyllactate dehydratase medium subunit', 144, NULL, NULL, 201620),
(201621, '3.40.190.10-FF-000580', NULL, 'Oligopeptide transport system binding protein', 214, NULL, NULL, 201621),
(201622, '1.25.40.10-FF-002831', NULL, 'Uncharacterized protein', 139, NULL, NULL, 201622),
(201623, '3.40.50.150-FF-001831', NULL, NULL, 67, NULL, NULL, 201623),
(201624, '2.20.70.10-FF-000289', NULL, 'Pre-mRNA-processing protein 40A', 55, NULL, NULL, 201624),
(201625, '3.20.20.80-FF-000271', NULL, 'Alkali-sensitive linkage protein 1', 179, NULL, NULL, 201625),
(201626, '1.25.10.10-FF-001800', NULL, 'Uncharacterized protein', 221, NULL, NULL, 201626),
(201627, '3.30.710.10-FF-000504', NULL, 'Uncharacterized protein', 126, NULL, NULL, 201627),
(201628, '1.25.10.10-FF-002099', NULL, 'Uncharacterized protein', 427, NULL, NULL, 201628),
(201629, '3.30.50.10-FF-000038', NULL, 'GATA transcription factor 14', 75, NULL, NULL, 201629),
(201630, '2.60.120.200-FF-000167', NULL, 'Laminin subunit alpha-3', 153, NULL, NULL, 201630),
(201631, '3.40.50.2300-FF-000722', NULL, 'Guanylate cyclase', 172, NULL, NULL, 201631),
(201632, '3.30.420.40-FF-000497', NULL, 'Hydantoinase/oxoprolinase family protein', 93, NULL, NULL, 201632),
(201633, '3.40.50.720-FF-002295', NULL, 'Uncharacterized protein', 182, NULL, NULL, 201633),
(201634, '1.20.1050.10-FF-000075', NULL, 'Methionyl-tRNA synthetase', 100, NULL, NULL, 201634),
(201635, '2.30.42.10-FF-000224', NULL, 'Arc, isoform A', 122, NULL, NULL, 201635),
(201636, '1.20.1540.10-FF-000045', NULL, 'Putative membrane protein', 182, NULL, NULL, 201636),
(201637, '3.40.50.2000-FF-000626', NULL, 'Sucrose synthase', 247, NULL, NULL, 201637),
(201638, '3.40.50.150-FF-000887', NULL, 'Non-ribosomal peptide synthase', 207, NULL, NULL, 201638),
(201639, '2.130.10.10-FF-001505', NULL, 'Striatin', 173, NULL, NULL, 201639),
(201640, '3.40.50.150-FF-001505', NULL, NULL, 111, NULL, NULL, 201640),
(201641, '1.10.260.40-FF-000024', NULL, 'Transcriptional regulator SinR', 107, NULL, NULL, 201641),
(201642, '1.10.630.10-FF-000504', NULL, 'Cytochrome P450 family 87 subfamily A polypeptide 6', 439, NULL, NULL, 201642),
(201643, '2.60.40.150-FF-000727', NULL, 'C2 domain containing protein', 115, NULL, NULL, 201643),
(201644, '3.40.50.720-FF-000850', NULL, '2-dehydropantoate 2-reductase', 186, NULL, NULL, 201644),
(201645, '1.25.40.10-FF-000690', NULL, 'Pentatricopeptide repeat-containing protein', 241, NULL, NULL, 201645),
(201646, '3.30.200.20-FF-002088', NULL, 'Non-specific serine/threonine protein kinase', 116, NULL, NULL, 201646),
(201647, '2.130.10.10-FF-000679', NULL, 'Elongator acetyltransferase complex subunit 2', 123, NULL, NULL, 201647),
(201648, '2.40.160.10-FF-000076', NULL, 'Putative mitochondrial outer membrane protein porin 5', 132, NULL, NULL, 201648),
(201649, '2.10.109.10-FF-000071', NULL, 'Uncharacterized protein', 178, NULL, NULL, 201649),
(201650, '3.20.20.80-FF-000372', NULL, '1,3-beta-glucanosyltransferase', 238, NULL, NULL, 201650),
(201651, '3.40.50.300-FF-006587', NULL, 'P-loop nucleoside triphosphate hydrolase superfamily protein', 99, NULL, NULL, 201651),
(201652, '2.40.30.170-FF-000073', NULL, NULL, 53, NULL, NULL, 201652),
(201653, '1.10.10.10-FF-001053', NULL, 'GM24041', 103, NULL, NULL, 201653),
(201654, '3.30.420.140-FF-000021', NULL, 'Transcription elongation factor spt6, putative', 148, NULL, NULL, 201654);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(201655, '3.40.50.620-FF-000691', NULL, 'Uncharacterized protein', 285, NULL, NULL, 201655),
(201656, '3.30.160.60-FF-003113', NULL, 'GD17411', 70, NULL, NULL, 201656),
(201657, '3.40.720.10-FF-000036', NULL, 'Membrane-associated phospholipase C', 242, NULL, NULL, 201657),
(201658, '3.40.50.300-FF-005390', NULL, 'Uncharacterized protein', 256, NULL, NULL, 201658),
(201659, '1.10.460.10-FF-000025', NULL, 'DNA topoisomerase', 157, NULL, NULL, 201659),
(201660, '3.40.50.620-FF-000702', NULL, 'Uncharacterized protein', 245, NULL, NULL, 201660),
(201661, '1.20.1420.30-FF-000093', NULL, 'Ca2+/Na+ antiporter', 239, NULL, NULL, 201661),
(201662, '3.60.40.10-FF-000171', NULL, 'Predicted protein', 312, NULL, NULL, 201662),
(201663, '3.60.110.10-FF-000042', NULL, 'Carbon-nitrogen hydrolase', 297, NULL, NULL, 201663),
(201664, '3.40.50.720-FF-000171', NULL, 'inositol-3-phosphate synthase 1', 131, NULL, NULL, 201664),
(201665, '2.130.10.10-FF-002933', NULL, 'Predicted protein', 216, NULL, NULL, 201665),
(201666, '2.60.120.590-FF-000019', NULL, 'DNA N6-methyl adenine demethylase', 183, NULL, NULL, 201666),
(201667, '1.20.1070.10-FF-000520', NULL, '5-hydroxytryptamine (Serotonin) receptor 2B, isoform E', 232, NULL, NULL, 201667),
(201668, '3.80.10.10-FF-000275', NULL, 'Leucine-rich repeat receptor-like protein kinase', 160, NULL, NULL, 201668),
(201669, '3.40.50.2300-FF-000497', NULL, 'Transcriptional regulator LacI family', 90, NULL, NULL, 201669),
(201670, '3.40.50.670-FF-000026', NULL, 'DNA gyrase subunit B', 143, NULL, NULL, 201670),
(201671, '3.90.190.10-FF-000219', NULL, 'Uncharacterized protein', 186, NULL, NULL, 201671),
(201672, '3.30.930.10-FF-000032', NULL, 'Phenylalanine--tRNA ligase beta subunit', 199, NULL, NULL, 201672),
(201673, '3.10.310.10-FF-000057', NULL, 'Uncharacterized protein', 130, NULL, NULL, 201673),
(201674, '3.90.190.10-FF-000450', NULL, 'Uncharacterized protein', 243, NULL, NULL, 201674),
(201675, '3.30.160.60-FF-001185', NULL, 'myoneurin isoform X1', 46, NULL, NULL, 201675),
(201676, '2.20.110.10-FF-000004', NULL, 'Histone-lysine N-methyltransferase SETD7', 49, NULL, NULL, 201676),
(201677, '3.30.70.270-FF-000266', NULL, NULL, 172, NULL, NULL, 201677),
(201678, '3.40.190.80-FF-000010', NULL, 'Histidinol phosphatase', 114, NULL, NULL, 201678),
(201679, '1.20.1280.290-FF-000061', NULL, 'Uncharacterized protein', 91, NULL, NULL, 201679),
(201680, '3.90.640.10-FF-000075', NULL, 'Heat shock 70 kDa protein', 98, NULL, NULL, 201680),
(201681, '2.60.120.200-FF-000072', NULL, 'basement membrane-specific heparan sulfate proteoglycan core protein-like', 179, NULL, NULL, 201681),
(201682, '2.60.120.920-FF-000040', NULL, 'Ret finger protein-like 4A', 189, NULL, NULL, 201682),
(201683, '1.20.1740.10-FF-000026', NULL, 'Amino-acid permease BAT1', 480, NULL, NULL, 201683),
(201684, '3.30.160.60-FF-003208', NULL, NULL, 28, NULL, NULL, 201684),
(201685, '3.10.360.10-FF-000004', NULL, 'OvoDB1', 40, NULL, NULL, 201685),
(201686, '1.25.40.20-FF-001518', NULL, 'Uncharacterized protein', 102, NULL, NULL, 201686),
(201687, '1.10.510.10-FF-001081', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 186, NULL, NULL, 201687),
(201688, '3.30.1370.170-FF-000004', NULL, 'Erythronate-4-phosphate dehydrogenase', 78, NULL, NULL, 201688),
(201689, '1.25.40.10-FF-001403', NULL, 'Mitochondrial ribonuclease P protein 3-like Protein', 222, NULL, NULL, 201689),
(201690, '3.40.50.2000-FF-000525', NULL, 'Trehalose-6-phosphate synthase', 131, NULL, NULL, 201690),
(201691, '3.30.230.10-FF-000136', NULL, 'GD14641', 202, NULL, NULL, 201691),
(201692, '3.30.519.10-FF-000043', NULL, NULL, 110, NULL, NULL, 201692),
(201693, '1.25.40.20-FF-001294', NULL, 'Uncharacterized protein', 164, NULL, NULL, 201693),
(201694, '3.30.200.20-FF-000749', NULL, 'Putative L-type lectin-domain containing receptor kinase S.5', 116, NULL, NULL, 201694),
(201695, '1.25.40.10-FF-000897', NULL, 'Pentatricopeptide repeat-containing protein PNM1, mitochondrial', 143, NULL, NULL, 201695),
(201696, '2.60.40.10-FF-004299', NULL, NULL, 107, NULL, NULL, 201696);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(201697, '3.10.129.10-FF-000197', NULL, 'Probable 4-hydroxybenzoyl-CoA thioesterase', 145, NULL, NULL, 201697),
(201698, '2.40.240.20-FF-000012', NULL, NULL, 70, NULL, NULL, 201698),
(201699, '3.30.40.10-FF-000442', NULL, 'RING-type E3 ubiquitin transferase', 73, NULL, NULL, 201699),
(201700, '3.50.50.60-FF-000187', NULL, 'Thioredoxin reductase GliT', 175, NULL, NULL, 201700),
(201701, '1.25.40.10-FF-001515', NULL, 'Clustered mitochondria protein homolog', 133, NULL, NULL, 201701),
(201702, '1.20.1720.10-FF-000031', NULL, 'Drug resistance transporter, EmrB/QacA subfamily', 186, NULL, NULL, 201702),
(201703, '3.30.70.260-FF-000145', NULL, 'Aspartokinase', 71, NULL, NULL, 201703),
(201704, '1.20.1070.10-FF-000284', NULL, 'C3a anaphylatoxin chemotactic receptor', 183, NULL, NULL, 201704),
(201705, '2.40.50.140-FF-000854', NULL, NULL, 66, NULL, NULL, 201705),
(201706, '2.40.10.10-FF-000588', NULL, NULL, 41, NULL, NULL, 201706),
(201707, '1.10.1200.10-FF-000050', NULL, 'Vibriobactin-specific isochorismatase', 77, NULL, NULL, 201707),
(201708, '2.40.30.20-FF-000002', NULL, 'V-type proton ATPase catalytic subunit A', 70, NULL, NULL, 201708),
(201709, '3.30.70.270-FF-000148', NULL, NULL, 80, NULL, NULL, 201709),
(201710, '1.10.150.20-FF-000038', NULL, 'DNA repair endonuclease UVH1', 73, NULL, NULL, 201710),
(201711, '3.10.196.10-FF-000009', NULL, 'Methionine synthase', 126, NULL, NULL, 201711),
(201712, '2.40.30.30-FF-000005', NULL, 'Haloacid dehalogenase-like hydrolase domain-containing protein 1A', 161, NULL, NULL, 201712),
(201713, '3.40.50.720-FF-000518', NULL, 'hydroxysteroid dehydrogenase-like protein 2 isoform X2', 110, NULL, NULL, 201713),
(201714, '2.40.10.10-FF-000476', NULL, NULL, 223, NULL, NULL, 201714),
(201715, '3.100.10.10-FF-000031', NULL, 'Uncharacterized protein', 62, NULL, NULL, 201715),
(201716, '3.30.1370.160-FF-000001', NULL, 'At1g53120', 67, NULL, NULL, 201716),
(201717, '1.20.5.170-FF-000253', NULL, 'Uncharacterized protein', 56, NULL, NULL, 201717),
(201718, '2.10.25.10-FF-000741', NULL, 'Low density lipoprotein receptor-related protein 1Bb', 45, NULL, NULL, 201718),
(201719, '3.30.70.330-FF-003050', NULL, NULL, 113, NULL, NULL, 201719),
(201720, '1.20.120.420-FF-000024', NULL, 'Uncharacterized protein', 44, NULL, NULL, 201720),
(201721, '3.40.50.20-FF-000052', NULL, 'Alpha-L-glutamate ligase', 95, NULL, NULL, 201721),
(201722, '1.10.10.60-FF-000556', NULL, 'SIX homeobox 9', 58, NULL, NULL, 201722),
(201723, '1.10.287.70-FF-000600', NULL, 'Uncharacterized protein', 183, NULL, NULL, 201723),
(201724, '1.20.120.1240-FF-000035', NULL, 'Dynamin GTPase', 252, NULL, NULL, 201724),
(201725, '2.130.10.10-FF-004378', NULL, 'Uncharacterized protein', 78, NULL, NULL, 201725),
(201726, '3.30.300.160-FF-000011', NULL, 'Type IV-A pilus assembly ATPase PilB', 81, NULL, NULL, 201726),
(201727, '2.130.10.10-FF-004277', NULL, 'AGAP010685-PA', 129, NULL, NULL, 201727),
(201728, '3.30.2230.10-FF-000023', NULL, 'Ubiquitinyl hydrolase 1', 122, NULL, NULL, 201728),
(201729, '3.40.390.10-FF-000027', NULL, 'Matrix metallopeptidase 19', 244, NULL, NULL, 201729),
(201730, '3.20.20.70-FF-000037', NULL, 'Tryptophan synthase alpha chain', 261, NULL, NULL, 201730),
(201731, '3.40.1110.10-FF-000012', NULL, 'Phospholipid-transporting ATPase', 158, NULL, NULL, 201731),
(201732, '3.80.10.10-FF-000180', NULL, 'Oligodendrocyte myelin glycoprotein', 70, NULL, NULL, 201732),
(201733, '3.80.10.10-FF-004327', NULL, 'Uncharacterized protein', 201, NULL, NULL, 201733),
(201734, '1.10.150.50-FF-000120', NULL, 'Adenylate cyclase, class 3', 57, NULL, NULL, 201734),
(201735, '1.25.40.20-FF-001406', NULL, 'Uncharacterized protein', 260, NULL, NULL, 201735),
(201736, '1.25.10.10-FF-000749', NULL, 'Predicted protein', 230, NULL, NULL, 201736),
(201737, '3.30.160.60-FF-003197', NULL, 'zinc finger protein 248 isoform X2', 72, NULL, NULL, 201737),
(201738, '3.30.160.20-FF-000127', NULL, 'Putative trna-specific adenosine deaminase 1', 74, NULL, NULL, 201738),
(201739, '1.25.40.10-FF-002488', NULL, 'Pentatricopeptide repeat-containing protein At4g21300', 107, NULL, NULL, 201739);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(201740, '2.30.250.10-FF-000006', NULL, 'Probable M18 family aminopeptidase 1', 138, NULL, NULL, 201740),
(201741, '3.40.50.300-FF-003029', NULL, 'Midasin', 154, NULL, NULL, 201741),
(201742, '3.30.70.330-FF-002662', NULL, NULL, 118, NULL, NULL, 201742),
(201743, '3.30.559.10-FF-000152', NULL, 'Chromosome 19, whole genome shotgun sequence', 167, NULL, NULL, 201743),
(201744, '3.40.50.150-FF-001051', NULL, NULL, 87, NULL, NULL, 201744),
(201745, '3.10.450.50-FF-000085', NULL, 'Uncharacterized protein', 149, NULL, NULL, 201745),
(201746, '3.30.40.10-FF-000537', NULL, 'RING finger protein', 97, NULL, NULL, 201746),
(201747, '2.40.50.140-FF-000427', NULL, 'DNA replication licensing factor MCM7', 108, NULL, NULL, 201747),
(201748, '2.130.10.10-FF-000567', NULL, 'POC1 centriolar protein homolog A', 126, NULL, NULL, 201748),
(201749, '3.30.1490.190-FF-000008', NULL, 'Ferric uptake regulator, Fur family', 56, NULL, NULL, 201749),
(201750, '3.40.50.2000-FF-001020', NULL, 'Uncharacterized protein', 178, NULL, NULL, 201750),
(201751, '1.20.1250.20-FF-000385', NULL, 'Major facilitator superfamily domain-containing protein 4A', 424, NULL, NULL, 201751),
(201752, '1.20.80.10-FF-000073', NULL, 'FERM domain-containing 4Ba', 88, NULL, NULL, 201752),
(201753, '3.40.850.10-FF-000383', NULL, 'Uncharacterized protein', 316, NULL, NULL, 201753),
(201754, '1.10.340.30-FF-000067', NULL, '8-oxoguanine DNA glycosylase', 78, NULL, NULL, 201754),
(201755, '3.40.710.10-FF-000002', NULL, 'glutaminase kidney isoform, mitochondrial', 330, NULL, NULL, 201755),
(201756, '4.10.520.10-FF-000007', NULL, 'Integration host factor subunit beta', 91, NULL, NULL, 201756),
(201757, '1.10.510.10-FF-001642', NULL, 'Serine/threonine protein kinase', 252, NULL, NULL, 201757),
(201758, '3.30.160.60-FF-005237', NULL, NULL, 76, NULL, NULL, 201758),
(201759, '3.30.1050.10-FF-000026', NULL, 'UNC-24', 109, NULL, NULL, 201759),
(201760, '3.10.129.10-FF-000208', NULL, '4-hydroxybenzoyl-CoA thioesterase family protein', 131, NULL, NULL, 201760),
(201761, '3.10.100.10-FF-000356', NULL, NULL, 87, NULL, NULL, 201761),
(201762, '2.30.42.10-FF-000336', NULL, NULL, 89, NULL, NULL, 201762),
(201763, '3.40.33.10-FF-000200', NULL, 'Predicted protein', 61, NULL, NULL, 201763),
(201764, '2.30.30.140-FF-000015', NULL, 'MBT domain-containing protein 1 isoform X1', 146, NULL, NULL, 201764),
(201765, '3.30.260.10-FF-000059', NULL, 'Uncharacterized protein', 116, NULL, NULL, 201765),
(201766, '3.40.50.300-FF-006795', NULL, 'Predicted protein', 56, NULL, NULL, 201766),
(201767, '3.60.130.10-FF-000043', NULL, 'Uncharacterized protein', 272, NULL, NULL, 201767),
(201768, '3.10.110.10-FF-000284', NULL, 'Predicted protein', 117, NULL, NULL, 201768),
(201769, '3.30.1490.180-FF-000005', NULL, 'DNA-directed RNA polymerase subunit', 62, NULL, NULL, 201769),
(201770, '1.25.10.10-FF-002992', NULL, 'Uncharacterized protein', 368, NULL, NULL, 201770),
(201771, '2.60.40.10-FF-003214', NULL, NULL, 119, NULL, NULL, 201771),
(201772, '3.40.50.11610-FF-000024', NULL, NULL, 63, NULL, NULL, 201772),
(201773, '3.30.1340.30-FF-000003', NULL, 'Putative secreted lipoprotein', 66, NULL, NULL, 201773),
(201774, '3.20.190.10-FF-000005', NULL, 'Nei like DNA glycosylase 3', 146, NULL, NULL, 201774),
(201775, '2.60.120.200-FF-000280', NULL, 'L-type lectin-domain containing receptor kinase IX.1', 247, NULL, NULL, 201775),
(201776, '3.30.70.330-FF-000874', NULL, 'RNA-binding protein, putative', 73, NULL, NULL, 201776),
(201777, '3.40.50.360-FF-000040', NULL, 'NADPH-dependent FMN reductase', 182, NULL, NULL, 201777),
(201778, '3.40.630.10-FF-000389', NULL, 'Uncharacterized protein', 51, NULL, NULL, 201778),
(201779, '3.40.50.970-FF-000099', NULL, 'Probable acetohydroxyacid synthase ilvX', 171, NULL, NULL, 201779),
(201780, '2.30.38.10-FF-000006', NULL, 'Long-chain-fatty-acid--[acyl-carrier-protein] ligase AEE15, chloroplastic', 71, NULL, NULL, 201780),
(201781, '2.40.200.10-FF-000001', NULL, 'Telomere-binding protein subunit beta', 224, NULL, NULL, 201781),
(201782, '3.60.10.10-FF-000017', NULL, 'Type I inositol polyphosphate 5-phosphatase 5', 313, NULL, NULL, 201782);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(201783, '1.25.40.10-FF-004742', NULL, 'Uncharacterized protein', 74, NULL, NULL, 201783),
(201784, '3.50.30.30-FF-000070', NULL, 'Subtilisin-like protease SBT3.18', 136, NULL, NULL, 201784),
(201785, '3.80.10.10-FF-004232', NULL, 'Relaxin family peptide receptor 1', 79, NULL, NULL, 201785),
(201786, '1.25.40.10-FF-004276', NULL, 'Os06g0625800 protein', 210, NULL, NULL, 201786),
(201787, '1.20.1560.10-FF-000271', NULL, 'HAlF transporter (PGP related)', 252, NULL, NULL, 201787),
(201788, '3.40.50.12370-FF-000004', NULL, 'Os11g0109400 protein', 292, NULL, NULL, 201788),
(201789, '3.20.20.150-FF-000032', NULL, 'Xylose isomerase', 264, NULL, NULL, 201789),
(201790, '3.30.160.60-FF-005451', NULL, NULL, 20, NULL, NULL, 201790),
(201791, '3.40.50.12780-FF-000133', NULL, 'D-alanine--poly(Phosphoribitol) ligase', 410, NULL, NULL, 201791),
(201792, '1.25.40.10-FF-000908', NULL, 'YER077C-like protein', 208, NULL, NULL, 201792),
(201793, '4.10.91.10-FF-000002', NULL, 'Cytochrome c oxidase subunit 7A1, mitochondrial-like Protein', 53, NULL, NULL, 201793),
(201794, '1.20.1260.10-FF-000012', NULL, '1,2-phenylacetyl-CoA epoxidase, subunit C', 254, NULL, NULL, 201794),
(201795, '2.130.10.10-FF-001404', NULL, 'Binding protein', 275, NULL, NULL, 201795),
(201796, '3.40.50.720-FF-002531', NULL, 'Ubiquitin-activating enzyme E1 domain-containing protein 1', 93, NULL, NULL, 201796),
(201797, '3.80.10.10-FF-000741', NULL, 'Uncharacterized protein, isoform A', 270, NULL, NULL, 201797),
(201798, '3.30.40.10-FF-002128', NULL, 'General transcription factor IIH subunit', 75, NULL, NULL, 201798),
(201799, '3.60.10.10-FF-000225', NULL, 'Uncharacterized protein', 267, NULL, NULL, 201799),
(201800, '3.30.460.10-FF-000046', NULL, 'PAP/OAS1 substrate-binding domain superfamily', 112, NULL, NULL, 201800),
(201801, '2.40.50.140-FF-000416', NULL, 'Uncharacterized protein', 104, NULL, NULL, 201801),
(201802, '3.80.10.10-FF-000511', NULL, 'Putative inactive leucine-rich repeat receptor-like protein kinase', 127, NULL, NULL, 201802),
(201803, '3.40.50.300-FF-001343', NULL, 'ADP-ribosylation factor 4', 156, NULL, NULL, 201803),
(201804, '1.20.120.450-FF-000004', NULL, 'ClbS/DfsB family four-helix bundle protein', 169, NULL, NULL, 201804),
(201805, '1.20.120.160-FF-000030', NULL, 'Histidine phosphotransfer domain-containing protein', 110, NULL, NULL, 201805),
(201806, '3.10.180.10-FF-000119', NULL, 'ATP-dependent 6-phosphofructokinase', 155, NULL, NULL, 201806),
(201807, '1.10.245.10-FF-000002', NULL, 'E3 ubiquitin-protein ligase Mdm2', 112, NULL, NULL, 201807),
(201808, '3.90.1030.20-FF-000008', NULL, NULL, 125, NULL, NULL, 201808),
(201809, '1.10.1320.10-FF-000008', NULL, 'DNA-dependent RNA polymerase', 295, NULL, NULL, 201809),
(201810, '3.40.190.290-FF-000077', NULL, 'LysR family transcriptional regulator', 206, NULL, NULL, 201810),
(201811, '3.40.1280.10-FF-000119', NULL, 'Uncharacterized protein', 156, NULL, NULL, 201811),
(201812, '3.40.190.10-FF-000692', NULL, 'Periplasmic substrate binding protein family 1', 192, NULL, NULL, 201812),
(201813, '1.10.510.10-FF-003542', NULL, NULL, 234, NULL, NULL, 201813),
(201814, '2.10.25.10-FF-000421', NULL, 'Teratocarcinoma-derived growth factor', 40, NULL, NULL, 201814),
(201815, '1.10.10.10-FF-001406', NULL, 'MarR family transcriptional regulator', 138, NULL, NULL, 201815),
(201816, '3.40.50.300-FF-004996', NULL, 'Uncharacterized protein', 89, NULL, NULL, 201816),
(201817, '3.90.1030.10-FF-000005', NULL, 'Probable 50S ribosomal protein L17', 121, NULL, NULL, 201817),
(201818, '3.30.1120.30-FF-000009', NULL, 'Serine/threonine-protein kinase', 94, NULL, NULL, 201818),
(201819, '2.70.170.10-FF-000098', NULL, 'Neuronal acetylcholine receptor subunit alpha-9', 171, NULL, NULL, 201819),
(201820, '3.80.10.10-FF-002641', NULL, 'Leucine-rich repeat receptor protein kinase EMS1', 358, NULL, NULL, 201820),
(201821, '3.80.10.10-FF-002540', NULL, 'Uncharacterized protein', 205, NULL, NULL, 201821),
(201822, '3.30.1490.100-FF-000038', NULL, 'DNA polymerase IV', 109, NULL, NULL, 201822),
(201823, '3.40.50.1110-FF-000112', NULL, 'Putative O-antigen related protein', 191, NULL, NULL, 201823);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(201824, '3.100.10.10-FF-000042', NULL, NULL, 88, NULL, NULL, 201824),
(201825, '3.20.20.140-FF-000135', NULL, 'Inactive deaminase YJL070C', 146, NULL, NULL, 201825),
(201826, '3.30.200.20-FF-002099', NULL, NULL, 80, NULL, NULL, 201826),
(201827, '3.20.20.300-FF-000009', NULL, 'Exo-1,4-beta-xylosidase xlnD', 327, NULL, NULL, 201827),
(201828, '3.10.350.10-FF-000054', NULL, 'LysM domain protein', 57, NULL, NULL, 201828),
(201829, '1.20.1250.20-FF-000407', NULL, 'Solute carrier organic anion transporter family member', 93, NULL, NULL, 201829),
(201830, '2.60.120.200-FF-000633', NULL, 'Uncharacterized protein', 124, NULL, NULL, 201830),
(201831, '3.30.160.60-FF-003551', NULL, NULL, 33, NULL, NULL, 201831),
(201832, '3.30.420.40-FF-000289', NULL, 'Actin-related protein 4', 92, NULL, NULL, 201832),
(201833, '1.25.40.10-FF-001414', NULL, 'Small glutamine-rich tetratricopeptide repeat-containing protein', 166, NULL, NULL, 201833),
(201834, '1.20.1050.10-FF-000187', NULL, 'Glutathionyl-hydroquinone reductase YqjG', 150, NULL, NULL, 201834),
(201835, '3.40.390.10-FF-000235', NULL, NULL, 82, NULL, NULL, 201835),
(201836, '3.90.190.10-FF-000012', NULL, 'protein tyrosine phosphatase type IVA 1', 170, NULL, NULL, 201836),
(201837, '3.90.850.10-FF-000012', NULL, 'Putative 2-hydroxyhepta-2,4-diene-1,7-dioate isomerase', 214, NULL, NULL, 201837),
(201838, '3.90.70.10-FF-000885', NULL, 'Uncharacterized protein', 277, NULL, NULL, 201838),
(201839, '3.40.50.1000-FF-000669', NULL, NULL, 195, NULL, NULL, 201839),
(201840, '2.60.40.10-FF-003444', NULL, NULL, 103, NULL, NULL, 201840),
(201841, '2.30.120.10-FF-000002', NULL, 'Putative penicillin acylase (Penicillin amidase) (Penicillin amidohydrolase)', 72, NULL, NULL, 201841),
(201842, '2.30.30.140-FF-000133', NULL, 'Fmr1, isoform G', 85, NULL, NULL, 201842),
(201843, '3.55.50.30-FF-000027', NULL, 'Putative anti-sigma factor', 76, NULL, NULL, 201843),
(201844, '3.40.50.2300-FF-000391', NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase SSU72', 70, NULL, NULL, 201844),
(201845, '3.30.1370.120-FF-000017', NULL, 'Competence protein E', 96, NULL, NULL, 201845),
(201846, '2.60.120.200-FF-000178', NULL, 'Glycoside hydrolase family 16 protein', 345, NULL, NULL, 201846),
(201847, '3.90.228.20-FF-000007', NULL, 'Uncharacterized protein', 125, NULL, NULL, 201847),
(201848, '3.40.1480.10-FF-000005', NULL, 'Glycerate kinase, putative', 157, NULL, NULL, 201848),
(201849, '3.40.1110.10-FF-000130', NULL, 'Cation-transporting ATPase', 149, NULL, NULL, 201849),
(201850, '1.20.1070.10-FF-000407', NULL, 'Adhesion G protein-coupled receptor D1', 188, NULL, NULL, 201850),
(201851, '3.40.50.720-FF-000277', NULL, 'Succinate--CoA ligase [ADP-forming] subunit alpha', 120, NULL, NULL, 201851),
(201852, '3.40.50.620-FF-000371', NULL, 'Tryptophanyl-tRNA synthetase, cytoplasmic, putative', 268, NULL, NULL, 201852),
(201853, '3.40.50.300-FF-003714', NULL, 'Guanylate kinase', 116, NULL, NULL, 201853),
(201854, '2.60.40.60-FF-000896', NULL, 'Uncharacterized protein', 108, NULL, NULL, 201854),
(201855, '3.40.50.720-FF-002418', NULL, 'UDP-galactose-4-epimerase', 34, NULL, NULL, 201855),
(201856, '3.40.50.300-FF-005272', NULL, 'Ras family GTPase', 181, NULL, NULL, 201856),
(201857, '3.40.50.2300-FF-000059', NULL, 'Glutamate receptor, ionotropic, kainate 4', 158, NULL, NULL, 201857),
(201858, '1.25.40.20-FF-001395', NULL, 'Uncharacterized protein', 51, NULL, NULL, 201858),
(201859, '1.20.1070.10-FF-002195', NULL, 'Uncharacterized protein', 306, NULL, NULL, 201859),
(201860, '3.40.50.300-FF-007413', NULL, 'Uncharacterized protein', 74, NULL, NULL, 201860),
(201861, '3.30.300.180-FF-000017', NULL, 'Chromosomal replication initiator protein DnaA', 107, NULL, NULL, 201861),
(201862, '1.10.3500.10-FF-000011', NULL, 'Transcription elongation factor SPT6', 96, NULL, NULL, 201862),
(201863, '3.80.10.10-FF-004440', NULL, 'Uncharacterized protein', 127, NULL, NULL, 201863),
(201864, '3.20.20.450-FF-000026', NULL, 'Diguanylate phosphodiesterase', 241, NULL, NULL, 201864),
(201865, '2.130.10.10-FF-004939', NULL, 'WD repeat-containing protein 48 homolog', 102, NULL, NULL, 201865);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(201866, '1.20.120.20-FF-000028', NULL, 'Uncharacterized protein', 121, NULL, NULL, 201866),
(201867, '3.80.10.10-FF-000286', NULL, 'Scribbled planar cell polarity protein', 176, NULL, NULL, 201867),
(201868, '3.30.70.360-FF-000063', NULL, 'Succinyl-diaminopimelate desuccinylase', 96, NULL, NULL, 201868),
(201869, '3.30.420.10-FF-000280', NULL, 'Protein CBG19000', 238, NULL, NULL, 201869),
(201870, '2.130.10.10-FF-004619', NULL, 'Uncharacterized protein', 199, NULL, NULL, 201870),
(201871, '2.60.120.200-FF-000403', NULL, 'Cadherin 3', 113, NULL, NULL, 201871),
(201872, '3.90.1640.10-FF-000035', NULL, 'Uncharacterized protein', 131, NULL, NULL, 201872),
(201873, '3.40.50.720-FF-000619', NULL, 'Oxidoreductase, short chain dehydrogenase/reductase family', 262, NULL, NULL, 201873),
(201874, '3.40.50.300-FF-002866', NULL, 'DsDNA exonuclease SbcC', 242, NULL, NULL, 201874),
(201875, '3.40.190.10-FF-000933', NULL, 'Uncharacterized protein', 53, NULL, NULL, 201875),
(201876, '3.30.160.60-FF-001409', NULL, 'zinc finger protein 596 isoform X1', 28, NULL, NULL, 201876),
(201877, '3.40.50.1820-FF-000128', NULL, 'Carboxylic ester hydrolase', 544, NULL, NULL, 201877),
(201878, '1.10.510.10-FF-001743', NULL, 'Predicted protein', 136, NULL, NULL, 201878),
(201879, '3.30.450.20-FF-000122', NULL, 'PAS domain-containing sensor histidine kinase', 119, NULL, NULL, 201879),
(201880, '3.90.330.10-FF-000001', NULL, 'Cobalt-containing nitrile hydratase subunit alpha', 205, NULL, NULL, 201880),
(201881, '3.30.710.10-FF-000151', NULL, 'BTB/POZ domain-containing protein 17', 157, NULL, NULL, 201881),
(201882, '3.40.50.300-FF-007424', NULL, 'Uncharacterized protein', 165, NULL, NULL, 201882),
(201883, '2.130.10.10-FF-005215', NULL, 'Predicted protein', 85, NULL, NULL, 201883),
(201884, '1.20.1250.20-FF-002307', NULL, 'Multidrug resistance efflux pump, RND family, inner membrane protein EmrB', 176, NULL, NULL, 201884),
(201885, '3.90.25.10-FF-000016', NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', 106, NULL, NULL, 201885),
(201886, '1.10.1270.20-FF-000001', NULL, 'tRNA (guanine-N(1)-)-methyltransferase', 80, NULL, NULL, 201886),
(201887, '1.10.150.20-FF-000139', NULL, 'DNA ligase', 102, NULL, NULL, 201887),
(201888, '2.60.120.650-FF-000184', NULL, 'Putative lysine-specific demethylase ELF6', 98, NULL, NULL, 201888),
(201889, '2.30.30.190-FF-000002', NULL, 'CAP-Gly domain containing linker protein 1', 86, NULL, NULL, 201889),
(201890, '3.30.1370.110-FF-000014', NULL, 'DNA endonuclease SmrA', 133, NULL, NULL, 201890),
(201891, '3.40.50.1370-FF-000049', NULL, NULL, 140, NULL, NULL, 201891),
(201892, '3.40.50.300-FF-005159', NULL, 'Predicted protein', 229, NULL, NULL, 201892),
(201893, '2.30.42.10-FF-000325', NULL, 'Periplasmic serine peptidase DegS', 97, NULL, NULL, 201893),
(201894, '2.130.10.10-FF-002478', NULL, 'Plexin-2', 428, NULL, NULL, 201894),
(201895, '3.40.50.150-FF-001152', NULL, NULL, 211, NULL, NULL, 201895),
(201896, '2.60.40.770-FF-000008', NULL, 'GG16835', 135, NULL, NULL, 201896),
(201897, '3.30.160.20-FF-000021', NULL, 'Microprocessor complex subunit DGCR8', 110, NULL, NULL, 201897),
(201898, '3.40.50.300-FF-006918', NULL, 'Carbohydrate sulfotransferase', 234, NULL, NULL, 201898),
(201899, '3.30.1490.100-FF-000027', NULL, 'DNA polymerase Tau', 142, NULL, NULL, 201899),
(201900, '3.40.50.2300-FF-000514', NULL, 'Metabotropic glutamate receptor', 150, NULL, NULL, 201900),
(201901, '2.130.10.10-FF-001382', NULL, 'TOPLESS-related 3', 293, NULL, NULL, 201901),
(201902, '2.60.40.760-FF-000005', NULL, 'Extracellular cellulase CelA/allergen Asp F7-like, putative (AFU_orthologue AFUA_5G08030)', 90, NULL, NULL, 201902),
(201903, '3.40.50.150-FF-000876', NULL, NULL, 150, NULL, NULL, 201903),
(201904, '1.25.40.10-FF-004287', NULL, 'At5g53080', 203, NULL, NULL, 201904),
(201905, '3.90.1200.10-FF-000030', NULL, 'Bifunctional tRNA (Adenosine(37)-N6)-threonylcarbamoyltransferase complex ATPase subunit type 1 TsaE/phosphotransferase', 245, NULL, NULL, 201905),
(201906, '1.10.238.10-FF-001149', NULL, 'Uncharacterized protein', 125, NULL, NULL, 201906);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(201907, '1.10.10.10-FF-000890', NULL, 'Trehalose operon transcriptional repressor', 75, NULL, NULL, 201907),
(201908, '1.20.58.400-FF-000030', NULL, 'Vesicle transport v-SNARE protein', 97, NULL, NULL, 201908),
(201909, '2.160.10.10-FF-000083', NULL, 'Uncharacterized protein', 120, NULL, NULL, 201909),
(201910, '3.10.290.20-FF-000001', NULL, 'NEDD8-activating enzyme E1 catalytic subunit, variant', 96, NULL, NULL, 201910),
(201911, '1.10.630.10-FF-000381', NULL, 'Uncharacterized protein', 341, NULL, NULL, 201911),
(201912, '3.30.200.20-FF-000643', NULL, 'Tyrosine-protein kinase receptor', 110, NULL, NULL, 201912),
(201913, '3.30.70.330-FF-002673', NULL, NULL, 164, NULL, NULL, 201913),
(201914, '2.30.29.70-FF-000014', NULL, 'Proteasome complex subunit Rpn13 ubiquitin receptor-domain-containing protein', 126, NULL, NULL, 201914),
(201915, '3.30.40.10-FF-000548', NULL, 'Putative Histone-lysine N-methyltransferase MLL3', 66, NULL, NULL, 201915),
(201916, '3.30.70.330-FF-000644', NULL, 'Splicing factor 1', 101, NULL, NULL, 201916),
(201917, '2.60.34.10-FF-000081', NULL, 'Chaperone protein', 132, NULL, NULL, 201917),
(201918, '3.80.10.10-FF-002309', NULL, 'Uncharacterized protein', 401, NULL, NULL, 201918),
(201919, '2.60.40.10-FF-001073', NULL, 'ADAMTS like 1', 95, NULL, NULL, 201919),
(201920, '1.20.900.10-FF-000091', NULL, 'Phosphatidylinositol-3,4,5-trisphosphate dependent Rac exchange factor 2', 135, NULL, NULL, 201920),
(201921, '3.40.50.80-FF-000154', NULL, 'NADH-cytochrome b5 reductase', 155, NULL, NULL, 201921),
(201922, '3.40.190.10-FF-000372', NULL, 'Membrane-bound lytic murein transglycosylase F', 129, NULL, NULL, 201922),
(201923, '1.20.58.60-FF-000126', NULL, 'Spectrin repeat containing, nuclear envelope 1a', 323, NULL, NULL, 201923),
(201924, '3.40.630.10-FF-000288', NULL, 'Predicted protein', 291, NULL, NULL, 201924),
(201925, '3.30.420.10-FF-000611', NULL, NULL, 180, NULL, NULL, 201925),
(201926, '2.60.40.60-FF-000576', NULL, 'Uncharacterized protein', 115, NULL, NULL, 201926),
(201927, '3.90.1150.10-FF-000486', NULL, 'Uncharacterized protein', 42, NULL, NULL, 201927),
(201928, '3.40.850.10-FF-000153', NULL, 'Kinesin-like protein', 339, NULL, NULL, 201928),
(201929, '3.40.50.720-FF-000412', NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', 221, NULL, NULL, 201929),
(201930, '3.80.10.10-FF-002186', NULL, 'Probable disease resistance protein At5g04720', 79, NULL, NULL, 201930),
(201931, '2.60.40.10-FF-000797', NULL, 'Plexin C1', 99, NULL, NULL, 201931),
(201932, '3.30.160.60-FF-005338', NULL, NULL, 29, NULL, NULL, 201932),
(201933, '1.10.8.60-FF-000122', NULL, 'AAA ATPase forming ring-shaped complexes', 45, NULL, NULL, 201933),
(201934, '2.60.40.2610-FF-000002', NULL, 'Fimbrial biogenesis outer membrane usher protein', 93, NULL, NULL, 201934),
(201935, '3.40.50.410-FF-000066', NULL, 'von Willebrand factor, type A', 188, NULL, NULL, 201935),
(201936, '1.10.510.10-FF-003104', NULL, NULL, 195, NULL, NULL, 201936),
(201937, '3.40.850.10-FF-000372', NULL, 'Kinesin-like protein', 271, NULL, NULL, 201937),
(201938, '3.60.15.10-FF-000091', NULL, 'tRNA processing endoribonuclease Trz1, putative', 259, NULL, NULL, 201938),
(201939, '3.60.40.10-FF-000053', NULL, 'Protein phosphatase 2C 29', 406, NULL, NULL, 201939),
(201940, '1.10.510.10-FF-000586', NULL, 'Interleukin-1 receptor-associated kinase-like 2', 217, NULL, NULL, 201940),
(201941, '1.25.40.470-FF-000002', NULL, 'Coatomer subunit alpha', 174, NULL, NULL, 201941),
(201942, '1.25.40.10-FF-004629', NULL, 'Uncharacterized protein', 126, NULL, NULL, 201942),
(201943, '1.10.150.50-FF-000131', NULL, 'EPS8 like 2', 50, NULL, NULL, 201943),
(201944, '1.25.40.20-FF-001417', NULL, 'Ankyrin repeat and SOCS box-containing 5a', 167, NULL, NULL, 201944),
(201945, '2.130.10.10-FF-000887', NULL, 'CPSF (Cleavage and polyadenylation specific factor)', 177, NULL, NULL, 201945),
(201946, '1.20.1070.10-FF-000295', NULL, 'B1 bradykinin receptor', 311, NULL, NULL, 201946),
(201947, '3.40.525.10-FF-000049', NULL, 'CRAL-TRIO domain-containing protein C23B6.04c isoform A', 196, NULL, NULL, 201947);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(201948, '3.40.50.300-FF-003372', NULL, 'DEAD-box ATP-dependent RNA helicase 38', 238, NULL, NULL, 201948),
(201949, '2.120.10.80-FF-000279', NULL, 'Predicted protein', 278, NULL, NULL, 201949),
(201950, '3.40.190.10-FF-000579', NULL, 'ABC-type dipeptide transport system, periplasmic component', 247, NULL, NULL, 201950),
(201951, '2.30.29.30-FF-000238', NULL, 'Tyrosine-protein kinase', 153, NULL, NULL, 201951),
(201952, '2.60.40.10-FF-002388', NULL, 'Muscle M-line assembly protein unc-89', 96, NULL, NULL, 201952),
(201953, '1.10.510.10-FF-000928', NULL, 'Si:dkeyp-67e1.6', 277, NULL, NULL, 201953),
(201954, '3.30.70.141-FF-000009', NULL, 'Nucleoside diphosphate kinase', 137, NULL, NULL, 201954),
(201955, '1.25.40.480-FF-000005', NULL, 'SnoRNA-binding rRNA-processing protein', 261, NULL, NULL, 201955),
(201956, '3.40.50.620-FF-000039', NULL, 'Probable nicotinate-nucleotide adenylyltransferase', 198, NULL, NULL, 201956),
(201957, '3.30.930.10-FF-000133', NULL, 'Phenylalanyl-tRNA synthetase alpha chain,putative', 273, NULL, NULL, 201957),
(201958, '1.10.10.2830-FF-000006', NULL, 'ParB-like partition protein', 142, NULL, NULL, 201958),
(201959, '3.40.50.12780-FF-000122', NULL, 'Hydroxamate-type ferrichrome siderophore peptide synthetase', 399, NULL, NULL, 201959),
(201960, '1.10.150.240-FF-000057', NULL, 'Phosphoglycolate phosphatase, putative', 71, NULL, NULL, 201960),
(201961, '2.70.150.10-FF-000198', NULL, 'Cation-transporting ATPase', 151, NULL, NULL, 201961),
(201962, '2.60.120.260-FF-000382', NULL, 'Beta-galactosidase (Eurofung)', 46, NULL, NULL, 201962),
(201963, '3.30.40.10-FF-002241', NULL, 'Predicted protein', 62, NULL, NULL, 201963),
(201964, '3.30.710.10-FF-000381', NULL, 'Kelch like family member 14', 88, NULL, NULL, 201964),
(201965, '3.30.750.24-FF-000037', NULL, 'Anti-sigma factor antagonist', 112, NULL, NULL, 201965),
(201966, '3.30.160.60-FF-005131', NULL, NULL, 26, NULL, NULL, 201966),
(201967, '3.30.420.10-FF-000050', NULL, 'Transposon Ty2-DR3 Gag-Pol polyprotein', 171, NULL, NULL, 201967),
(201968, '3.40.20.10-FF-000013', NULL, 'supervillin isoform X1', 112, NULL, NULL, 201968),
(201969, '1.20.1510.10-FF-000094', NULL, NULL, 101, NULL, NULL, 201969),
(201970, '3.30.160.70-FF-000007', NULL, 'Methylated-DNA--protein-cysteine methyltransferase', 88, NULL, NULL, 201970),
(201971, '3.50.50.60-FF-000541', NULL, 'Dehydrogenase', 92, NULL, NULL, 201971),
(201972, '3.30.160.60-FF-001286', NULL, 'Zinc finger protein 485', 27, NULL, NULL, 201972),
(201973, '3.30.40.10-FF-001965', NULL, 'Uncharacterized protein', 64, NULL, NULL, 201973),
(201974, '2.60.40.10-FF-001415', NULL, 'Hemicentin 2', 94, NULL, NULL, 201974),
(201975, '3.30.70.330-FF-000863', NULL, 'Nucleolar protein', 144, NULL, NULL, 201975),
(201976, '2.60.40.420-FF-000134', NULL, 'Cupredoxin superfamily protein', 209, NULL, NULL, 201976),
(201977, '3.40.50.150-FF-001713', NULL, NULL, 222, NULL, NULL, 201977),
(201978, '3.40.309.10-FF-000047', NULL, 'NAD-dependent succinate-semialdehyde dehydrogenase', 190, NULL, NULL, 201978),
(201979, '1.25.10.10-FF-000862', NULL, 'Cell differentiation protein rcd1', 175, NULL, NULL, 201979),
(201980, '2.30.40.10-FF-000034', NULL, 'Guanine deaminase', 132, NULL, NULL, 201980),
(201981, '3.30.559.10-FF-000039', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 256, NULL, NULL, 201981),
(201982, '2.170.150.10-FF-000005', NULL, 'Guanine nucleotide exchange factor MSS4', 112, NULL, NULL, 201982),
(201983, '3.90.810.10-FF-000015', NULL, 'CDC42 small effector protein 1', 45, NULL, NULL, 201983),
(201984, '1.25.40.10-FF-003314', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 111, NULL, NULL, 201984),
(201985, '2.60.40.60-FF-001059', NULL, 'Uncharacterized protein', 71, NULL, NULL, 201985),
(201986, '1.10.510.10-FF-001204', NULL, 'Probable CMK1-Ca2+/calmodulin-dependent ser/thr protein kinase type', 336, NULL, NULL, 201986),
(201987, '1.10.238.10-FF-000666', NULL, 'Efhand domain-containing protein', 78, NULL, NULL, 201987),
(201988, '3.30.450.20-FF-000661', NULL, 'Uncharacterized protein', 113, NULL, NULL, 201988);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(201989, '1.10.1420.10-FF-000179', NULL, 'DNA Mismatch Repair (MMR) protein MutS, putative', 122, NULL, NULL, 201989),
(201990, '3.40.640.10-FF-000339', NULL, 'Cystathionine gamma-synthase', 319, NULL, NULL, 201990),
(201991, '2.130.10.10-FF-003192', NULL, 'Microtubule binding protein YTM1, putative', 117, NULL, NULL, 201991),
(201992, '2.40.37.10-FF-000048', NULL, 'Ornithine decarboxylase, putative', 146, NULL, NULL, 201992),
(201993, '3.30.200.20-FF-002329', NULL, 'Uncharacterized protein', 74, NULL, NULL, 201993),
(201994, '2.60.40.420-FF-000027', NULL, 'ephrin-B1', 145, NULL, NULL, 201994),
(201995, '1.25.40.10-FF-002477', NULL, 'Putative pentatricopeptide repeat-containing protein', 51, NULL, NULL, 201995),
(201996, '3.40.50.10190-FF-000204', NULL, 'DNA polymerase III subunit epsilon', 112, NULL, NULL, 201996),
(201997, '3.30.160.60-FF-001634', NULL, 'Zinc finger protein 224, isoform CRA_a', 28, NULL, NULL, 201997),
(201998, '2.120.10.80-FF-000178', NULL, 'Leucine carboxyl methyltransferase 2, variant', 316, NULL, NULL, 201998),
(201999, '3.80.10.10-FF-000623', NULL, 'Leucine-rich repeat-containing protein', 170, NULL, NULL, 201999),
(202000, '3.40.50.300-FF-001455', NULL, 'RuvB-like helicase', 129, NULL, NULL, 202000),
(202001, '3.40.1000.30-FF-000009', NULL, 'F-box only protein 7', 171, NULL, NULL, 202001),
(202002, '1.50.10.10-FF-000213', NULL, 'Uncharacterized protein', 154, NULL, NULL, 202002),
(202003, '3.90.810.10-FF-000021', NULL, 'AGAP001790-PA-like protein', 76, NULL, NULL, 202003),
(202004, '1.20.1730.10-FF-000082', NULL, 'Putative transmembrane transport protein', 487, NULL, NULL, 202004),
(202005, '3.40.50.80-FF-000047', NULL, 'Naphthalene 1,2-dioxygenase reductase component', 132, NULL, NULL, 202005),
(202006, '1.25.40.180-FF-000123', NULL, 'CaGCR3 protein', 265, NULL, NULL, 202006),
(202007, '1.25.40.10-FF-003101', NULL, 'Uncharacterized protein', 132, NULL, NULL, 202007),
(202008, '1.20.1250.20-FF-000626', NULL, 'Putative integral membrane protein', 193, NULL, NULL, 202008),
(202009, '1.10.1270.20-FF-000006', NULL, 'tRNA (guanine-N(1)-)-methyltransferase', 52, NULL, NULL, 202009),
(202010, '3.40.1000.30-FF-000021', NULL, 'Predicted protein', 205, NULL, NULL, 202010),
(202011, '3.90.830.10-FF-000016', NULL, 'Vacuolar protein sorting 33B', 127, NULL, NULL, 202011),
(202012, '1.10.10.10-FF-000676', NULL, 'Transcriptional regulator, MarR family', 64, NULL, NULL, 202012),
(202013, '2.130.10.10-FF-005434', NULL, 'SnoRNA-binding rRNA-processing protein', 218, NULL, NULL, 202013),
(202014, '3.40.850.10-FF-000046', NULL, 'Kinesin-like protein', 355, NULL, NULL, 202014),
(202015, '2.130.10.10-FF-003310', NULL, 'WD domain, G-beta repeat, putative', 200, NULL, NULL, 202015),
(202016, '3.40.50.720-FF-001120', NULL, 'Calcium-gated potassium channel protein, putative', 151, NULL, NULL, 202016),
(202017, '2.130.10.10-FF-004833', NULL, 'Uncharacterized protein', 134, NULL, NULL, 202017),
(202018, '3.20.20.80-FF-000613', NULL, 'Beta-galactosidase', 156, NULL, NULL, 202018),
(202019, '2.20.100.10-FF-000048', NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 8', 56, NULL, NULL, 202019),
(202020, '1.20.58.760-FF-000008', NULL, 'ATP-dependent zinc metalloprotease FTSH', 193, NULL, NULL, 202020),
(202021, '1.20.920.10-FF-000215', NULL, 'Uncharacterized protein', 89, NULL, NULL, 202021),
(202022, '3.30.1490.430-FF-000002', NULL, 'mRNA-capping enzyme subunit alpha', 65, NULL, NULL, 202022),
(202023, '3.50.50.60-FF-000760', NULL, 'Phytoene desaturase', 75, NULL, NULL, 202023),
(202024, '1.10.486.10-FF-000073', NULL, 'Blr8088 protein', 153, NULL, NULL, 202024),
(202025, '2.130.10.10-FF-001056', NULL, 'Cell surface protein', 251, NULL, NULL, 202025),
(202026, '2.60.40.10-FF-004855', NULL, NULL, 105, NULL, NULL, 202026),
(202027, '3.40.50.300-FF-003602', NULL, 'Cobinamide kinase / cobinamide phosphate guanyltransferase', 179, NULL, NULL, 202027),
(202028, '2.60.120.260-FF-000275', NULL, 'Beta-galactosidase', 130, NULL, NULL, 202028),
(202029, '1.10.630.10-FF-000055', NULL, 'Cytochrome P450 71A26', 486, NULL, NULL, 202029);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(202030, '2.130.10.10-FF-001163', NULL, 'Hypothetical_protein_-_conserved', 293, NULL, NULL, 202030),
(202031, '2.60.40.10-FF-004748', NULL, NULL, 109, NULL, NULL, 202031),
(202032, '3.10.20.620-FF-000017', NULL, NULL, 162, NULL, NULL, 202032),
(202033, '1.25.40.10-FF-005225', NULL, 'Uncharacterized protein', 484, NULL, NULL, 202033),
(202034, '1.25.10.10-FF-001345', NULL, 'Hym1p orthologue, putative', 332, NULL, NULL, 202034),
(202035, '1.10.510.10-FF-000001', NULL, 'Calcium/calmodulin-dependent protein kinase type II subunit delta', 189, NULL, NULL, 202035),
(202036, '2.60.40.10-FF-001078', NULL, 'Programmed cell death 1 ligand 2', 103, NULL, NULL, 202036),
(202037, '1.10.630.10-FF-000162', NULL, 'Os06g0641600 protein', 304, NULL, NULL, 202037),
(202038, '3.30.40.210-FF-000012', NULL, 'Transcription elongation factor SPT4', 95, NULL, NULL, 202038),
(202039, '1.10.472.30-FF-000007', NULL, 'PHD finger domain protein, putative', 127, NULL, NULL, 202039),
(202040, '1.10.10.60-FF-001152', NULL, NULL, 53, NULL, NULL, 202040),
(202041, '3.40.50.300-FF-001562', NULL, 'ABC transporter ATP-binding protein', 324, NULL, NULL, 202041),
(202042, '1.10.1300.10-FF-000018', NULL, 'Phosphodiesterase', 344, NULL, NULL, 202042),
(202043, '2.40.240.20-FF-000001', NULL, 'Ribosomal RNA small subunit methyltransferase E', 73, NULL, NULL, 202043),
(202044, '3.60.10.10-FF-000012', NULL, 'nocturnin isoform X2', 313, NULL, NULL, 202044),
(202045, '1.25.10.10-FF-001019', NULL, 'Hypothetical_protein_-_conserved', 970, NULL, NULL, 202045),
(202046, '1.10.418.10-FF-000079', NULL, 'Neuron navigator 3', 52, NULL, NULL, 202046),
(202047, '3.30.559.10-FF-000034', NULL, 'Nonribosomal peptide synthase sidD', 162, NULL, NULL, 202047),
(202048, '3.30.160.60-FF-003091', NULL, 'Uncharacterized protein', 25, NULL, NULL, 202048),
(202049, '3.50.50.60-FF-000748', NULL, 'Probable lysine-specific histone demethylase 1', 81, NULL, NULL, 202049),
(202050, '3.30.160.60-FF-001527', NULL, 'Zinc finger protein', 28, NULL, NULL, 202050),
(202051, '3.30.450.20-FF-000009', NULL, 'Potassium voltage-gated channel subfamily H member 1', 142, NULL, NULL, 202051),
(202052, '3.30.760.10-FF-000086', NULL, 'Eukaryotic translation initiation factor 4E family member 1B', 138, NULL, NULL, 202052),
(202053, '1.20.920.10-FF-000108', NULL, 'Transcription initiation factor TFIID subunit 1', 146, NULL, NULL, 202053),
(202054, '3.30.200.20-FF-001132', NULL, 'Si:ch211-285c6.3', 75, NULL, NULL, 202054),
(202055, '3.30.450.20-FF-000335', NULL, 'Transcriptional regulator, PpsR', 115, NULL, NULL, 202055),
(202056, '1.10.10.1020-FF-000003', NULL, 'RecBCD enzyme subunit RecD', 102, NULL, NULL, 202056),
(202057, '3.90.70.10-FF-000767', NULL, 'Uncharacterized protein', 75, NULL, NULL, 202057),
(202058, '3.30.1370.10-FF-000180', NULL, 'Uncharacterized protein', 114, NULL, NULL, 202058),
(202059, '2.60.40.10-FF-001185', NULL, 'Nectin cell adhesion molecule 3b', 95, NULL, NULL, 202059),
(202060, '1.25.10.10-FF-002880', NULL, 'Exportin, putative', 488, NULL, NULL, 202060),
(202061, '3.30.70.120-FF-000025', NULL, NULL, 101, NULL, NULL, 202061),
(202062, '1.10.220.70-FF-000002', NULL, 'Ethanolamine ammonia-lyase large subunit', 87, NULL, NULL, 202062),
(202063, '3.30.70.270-FF-000042', NULL, 'Sensor domain-containing diguanylate cyclase', 165, NULL, NULL, 202063),
(202064, '3.30.420.10-FF-000504', NULL, NULL, 202, NULL, NULL, 202064),
(202065, '1.20.1250.20-FF-002190', NULL, 'Uncharacterized protein', 158, NULL, NULL, 202065),
(202066, '2.40.70.10-FF-000575', NULL, NULL, 78, NULL, NULL, 202066),
(202067, '3.40.190.10-FF-000815', NULL, 'Transferrin-a', 55, NULL, NULL, 202067),
(202068, '1.10.510.10-FF-003660', NULL, NULL, 180, NULL, NULL, 202068),
(202069, '2.60.40.3470-FF-000001', NULL, 'Fimbrial assembly protein', 124, NULL, NULL, 202069),
(202070, '3.40.50.300-FF-001129', NULL, 'ras-related protein Rab-44 isoform X2', 191, NULL, NULL, 202070),
(202071, '1.10.8.50-FF-000001', NULL, '30S ribosomal protein S13', 72, NULL, NULL, 202071),
(202072, '3.30.40.10-FF-002342', NULL, 'Histone acetyltransferase', 91, NULL, NULL, 202072);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(202073, '3.20.20.80-FF-000720', NULL, 'Beta-glucosidase 47', 474, NULL, NULL, 202073),
(202074, '2.130.10.10-FF-004726', NULL, 'Predicted protein', 166, NULL, NULL, 202074),
(202075, '3.40.50.10540-FF-000012', NULL, 'Uncharacterized protein', 223, NULL, NULL, 202075),
(202076, '2.40.50.90-FF-000114', NULL, 'Ring finger protein 17', 98, NULL, NULL, 202076),
(202077, '3.30.160.60-FF-001960', NULL, 'zinc finger protein 629 isoform X1', 34, NULL, NULL, 202077),
(202078, '3.30.450.20-FF-000442', NULL, 'Sensor box histidine kinase', 109, NULL, NULL, 202078),
(202079, '2.60.40.150-FF-000379', NULL, 'Protein CBR-SNT-7', 141, NULL, NULL, 202079),
(202080, '3.30.200.20-FF-002436', NULL, 'AGC family protein kinase', 71, NULL, NULL, 202080),
(202081, '3.40.50.720-FF-002536', NULL, 'D-3-phosphoglycerate dehydrogenase', 79, NULL, NULL, 202081),
(202082, '2.60.210.10-FF-000082', NULL, NULL, 69, NULL, NULL, 202082),
(202083, '1.20.1250.20-FF-002083', NULL, 'Uncharacterized protein', 267, NULL, NULL, 202083),
(202084, '1.10.8.60-FF-000004', NULL, 'Cell division control 48', 92, NULL, NULL, 202084),
(202085, '2.60.120.330-FF-000200', NULL, 'Uncharacterized protein', 132, NULL, NULL, 202085),
(202086, '1.20.120.850-FF-000023', NULL, 'DNA repair and recombination protein RAD54, putative', 101, NULL, NULL, 202086),
(202087, '1.20.1070.10-FF-000851', NULL, 'Octopamine receptor beta-3R', 156, NULL, NULL, 202087),
(202088, '3.40.50.2000-FF-000284', NULL, 'Glycosyltransferase WbpY', 140, NULL, NULL, 202088),
(202089, '3.40.1190.20-FF-000008', NULL, 'Pyridoxal kinase PdxY', 287, NULL, NULL, 202089),
(202090, '2.40.70.10-FF-000468', NULL, NULL, 164, NULL, NULL, 202090),
(202091, '3.30.1370.10-FF-000073', NULL, 'Transcription or splicing factor-like protein', 122, NULL, NULL, 202091),
(202092, '3.90.1310.10-FF-000038', NULL, 'Penicillin-binding protein', 121, NULL, NULL, 202092),
(202093, '3.30.230.10-FF-000018', NULL, 'Diphosphomevalonate decarboxylase', 179, NULL, NULL, 202093),
(202094, '1.25.40.20-FF-001636', NULL, 'Uncharacterized protein', 95, NULL, NULL, 202094),
(202095, '1.25.40.90-FF-000106', NULL, 'Clathrin interactor 1a', 87, NULL, NULL, 202095),
(202096, '1.10.510.10-FF-001305', NULL, 'Serine/threonine-protein kinase RIO2', 128, NULL, NULL, 202096),
(202097, '1.25.10.10-FF-001238', NULL, 'TOG array regulator of axonemal microtubules protein 1', 230, NULL, NULL, 202097),
(202098, '3.90.190.10-FF-000113', NULL, 'Putative mitogen-activated protein kinase phosphatase 1', 141, NULL, NULL, 202098),
(202099, '3.50.50.60-FF-000529', NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', 307, NULL, NULL, 202099),
(202100, '2.130.10.10-FF-005108', NULL, 'Uncharacterized protein', 246, NULL, NULL, 202100),
(202101, '1.25.40.20-FF-001176', NULL, 'Transient receptor potential cation channel, subfamily A, member 1a', 127, NULL, NULL, 202101),
(202102, '2.60.420.10-FF-000007', NULL, 'Trehalose-6-phosphate phosphatase OtsB1', 80, NULL, NULL, 202102),
(202103, '2.160.10.10-FF-000077', NULL, 'Predicted protein', 175, NULL, NULL, 202103),
(202104, '3.10.20.10-FF-000037', NULL, 'Cell death-inducing DFFA-like effector b', 121, NULL, NULL, 202104),
(202105, '2.40.70.10-FF-000249', NULL, 'Uncharacterized protein', 146, NULL, NULL, 202105),
(202106, '3.40.50.12780-FF-000015', NULL, 'D-alanine--D-alanyl carrier protein ligase', 397, NULL, NULL, 202106),
(202107, '3.40.1190.10-FF-000005', NULL, 'Folylpolyglutamate synthase', 288, NULL, NULL, 202107),
(202108, '3.30.160.60-FF-001308', NULL, 'Zinc finger protein 408', 25, NULL, NULL, 202108),
(202109, '2.30.30.100-FF-000032', NULL, 'U7 snRNA-associated Sm-like protein LSm11', 92, NULL, NULL, 202109),
(202110, '3.40.50.2000-FF-000065', NULL, 'Glycosyltransferase', 261, NULL, NULL, 202110),
(202111, '3.90.25.10-FF-000011', NULL, 'dTDP-glucose 4,6-dehydratase', 72, NULL, NULL, 202111),
(202112, '2.60.40.10-FF-004962', NULL, NULL, 96, NULL, NULL, 202112),
(202113, '3.40.190.10-FF-000478', NULL, 'Uncharacterized protein', 151, NULL, NULL, 202113),
(202114, '3.30.70.330-FF-000756', NULL, 'Alternative splicing factor ASF-1, putative', 100, NULL, NULL, 202114);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(202115, '3.30.200.20-FF-002543', NULL, 'Uncharacterized protein', 12, NULL, NULL, 202115),
(202116, '2.130.10.10-FF-004496', NULL, 'Uncharacterized protein', 242, NULL, NULL, 202116),
(202117, '2.60.40.10-FF-003551', NULL, NULL, 113, NULL, NULL, 202117),
(202118, '3.30.200.20-FF-000289', NULL, 'Cyclin-dependent kinase D-1', 90, NULL, NULL, 202118),
(202119, '2.60.40.10-FF-004529', NULL, NULL, 82, NULL, NULL, 202119),
(202120, '2.10.70.10-FF-000031', NULL, 'gamma-aminobutyric acid type B receptor subunit 1', 68, NULL, NULL, 202120),
(202121, '1.25.10.10-FF-003262', NULL, 'Serine/threonine-protein kinase TOR', 211, NULL, NULL, 202121),
(202122, '2.60.40.1390-FF-000023', NULL, 'Uncharacterized protein', 76, NULL, NULL, 202122),
(202123, '1.10.287.70-FF-000038', NULL, 'Potassium voltage-gated channel subfamily KQT member', 98, NULL, NULL, 202123),
(202124, '1.25.40.860-FF-000006', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 143, NULL, NULL, 202124),
(202125, '3.30.200.20-FF-001025', NULL, 'Nucleotide exchange factor RasGEF P family protein', 104, NULL, NULL, 202125),
(202126, '1.25.40.180-FF-000016', NULL, 'polyadenylate-binding protein-interacting protein 1 isoform X1', 215, NULL, NULL, 202126),
(202127, '1.10.10.60-FF-001045', NULL, NULL, 66, NULL, NULL, 202127),
(202128, '2.40.30.170-FF-000078', NULL, NULL, 91, NULL, NULL, 202128),
(202129, '2.120.10.30-FF-000528', NULL, 'Uncharacterized protein', 146, NULL, NULL, 202129),
(202130, '2.60.120.650-FF-000178', NULL, 'Uncharacterized protein', 128, NULL, NULL, 202130),
(202131, '3.30.70.330-FF-000537', NULL, 'Ras GTPase-activating protein-binding protein 2', 154, NULL, NULL, 202131),
(202132, '3.80.10.10-FF-000516', NULL, 'Leucine-rich repeat family protein', 158, NULL, NULL, 202132),
(202133, '2.60.110.10-FF-000023', NULL, 'Uncharacterized protein', 162, NULL, NULL, 202133),
(202134, '2.40.30.10-FF-000359', NULL, 'Uncharacterized protein', 99, NULL, NULL, 202134),
(202135, '4.10.60.10-FF-000094', NULL, 'Zinc finger CCHC-type containing 13', 23, NULL, NULL, 202135),
(202136, '3.40.1170.10-FF-000010', NULL, 'DNA mismatch repair protein Msh1', 126, NULL, NULL, 202136),
(202137, '1.25.10.10-FF-001126', NULL, 'Importin subunit alpha', 433, NULL, NULL, 202137),
(202138, '1.20.120.20-FF-000034', NULL, 'Zgc:162608', 94, NULL, NULL, 202138),
(202139, '3.80.10.10-FF-000404', NULL, 'Predicted gene 7682', 231, NULL, NULL, 202139),
(202140, '3.40.50.150-FF-000769', NULL, 'Precorrin-6Y C(5,15)-methyltransferase [decarboxylating]', 175, NULL, NULL, 202140),
(202141, '2.70.160.11-FF-000025', NULL, 'Protein arginine N-methyltransferase', 168, NULL, NULL, 202141),
(202142, '2.60.40.10-FF-003332', NULL, 'Sensory AXon guidance', 93, NULL, NULL, 202142),
(202143, '1.10.10.10-FF-000783', NULL, 'Unplaced genomic scaffold supercont1.201, whole genome shotgun sequence', 84, NULL, NULL, 202143),
(202144, '1.25.40.180-FF-000230', NULL, NULL, 248, NULL, NULL, 202144),
(202145, '3.40.50.2000-FF-000744', NULL, 'GDP-Man:Man(3)GlcNAc(2)-PP-Dol alpha-1,2-mannosyltransferase', 189, NULL, NULL, 202145),
(202146, '3.30.40.10-FF-000655', NULL, 'E3 ubiquitin-protein ligase ATL41', 81, NULL, NULL, 202146),
(202147, '3.40.1390.20-FF-000001', NULL, 'Phosphate acetyltransferase', 141, NULL, NULL, 202147),
(202148, '3.30.70.330-FF-002780', NULL, NULL, 66, NULL, NULL, 202148),
(202149, '2.30.30.190-FF-000007', NULL, 'Putative ubiquitin carboxyl-terminal hydrolase CYLD', 99, NULL, NULL, 202149),
(202150, '2.20.100.10-FF-000155', NULL, 'Protein CBR-SPON-1', 63, NULL, NULL, 202150),
(202151, '1.20.120.1130-FF-000002', NULL, 'Vacuolar protein sorting-associated protein 28 homolog', 79, NULL, NULL, 202151),
(202152, '3.40.50.1820-FF-000454', NULL, 'Ab-hydrolase associated lipase region', 336, NULL, NULL, 202152),
(202153, '3.20.20.190-FF-000015', NULL, 'Glycerophosphocholine phosphodiesterase GPCPD1', 315, NULL, NULL, 202153),
(202154, '3.80.10.10-FF-002080', NULL, 'LRR F-box protein MAX2a', 100, NULL, NULL, 202154),
(202155, '2.30.29.30-FF-000811', NULL, 'Kinase, AGC MAST', 123, NULL, NULL, 202155);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(202156, '3.30.160.60-FF-001741', NULL, 'Uncharacterized protein', 29, NULL, NULL, 202156),
(202157, '3.30.450.20-FF-000223', NULL, 'neuronal PAS domain-containing protein 3 isoform X3', 113, NULL, NULL, 202157),
(202158, '1.10.287.110-FF-000478', NULL, 'Uncharacterized protein', 96, NULL, NULL, 202158),
(202159, '3.40.50.620-FF-000707', NULL, 'Nicotinamide-nucleotide adenylyltransferase', 231, NULL, NULL, 202159),
(202160, '2.60.220.50-FF-000009', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', 189, NULL, NULL, 202160),
(202161, '3.40.50.300-FF-008487', NULL, 'Multidrug resistance protein fer6', 275, NULL, NULL, 202161),
(202162, '3.30.710.10-FF-000156', NULL, 'Zinc finger protein chinmo', 118, NULL, NULL, 202162),
(202163, '1.25.40.10-FF-004394', NULL, 'Pre-mRNA-splicing factor prp1', 140, NULL, NULL, 202163),
(202164, '3.30.470.20-FF-000230', NULL, 'Carbamoyl phosphate synthase, large subunit', 103, NULL, NULL, 202164),
(202165, '1.25.40.820-FF-000023', NULL, 'Uncharacterized protein', 172, NULL, NULL, 202165),
(202166, '3.30.300.30-FF-000119', NULL, 'D-alanine--poly(Phosphoribitol) ligase', 103, NULL, NULL, 202166),
(202167, '1.20.1070.10-FF-000632', NULL, 'CG3856-like octopamine receptor', 283, NULL, NULL, 202167),
(202168, '2.60.40.10-FF-001308', NULL, 'Fc receptor like 4', 96, NULL, NULL, 202168),
(202169, '3.10.450.350-FF-000010', NULL, 'Membrane protein', 92, NULL, NULL, 202169),
(202170, '1.20.5.170-FF-000040', NULL, 'Nuclear pore glycoprotein p62', 61, NULL, NULL, 202170),
(202171, '3.40.50.300-FF-004895', NULL, 'Uncharacterized protein', 164, NULL, NULL, 202171),
(202172, '1.20.1250.20-FF-000733', NULL, 'Sugar efflux transporter B', 199, NULL, NULL, 202172),
(202173, '2.40.50.140-FF-000079', NULL, 'Exoribonuclease 2', 82, NULL, NULL, 202173),
(202174, '3.30.160.60-FF-002938', NULL, 'RAD18p E3 ubiquitin ligase', 32, NULL, NULL, 202174),
(202175, '3.30.70.660-FF-000057', NULL, 'tRNA pseudouridine synthase A', 159, NULL, NULL, 202175),
(202176, '3.30.160.60-FF-000111', NULL, 'GLI family zinc finger 4', 28, NULL, NULL, 202176),
(202177, '1.20.1080.10-FF-000127', NULL, 'Aquaglyceroporin, putative', 92, NULL, NULL, 202177),
(202178, '1.20.900.10-FF-000113', NULL, 'Chromosome 7, whole genome shotgun sequence', 67, NULL, NULL, 202178),
(202179, '3.40.50.410-FF-000302', NULL, 'ATP dependent DNA ligase 1', 161, NULL, NULL, 202179),
(202180, '3.40.1390.30-FF-000004', NULL, 'NIF3-like protein 1', 125, NULL, NULL, 202180),
(202181, '1.10.238.10-FF-000986', NULL, 'Mitochondrial Rho GTPase', 196, NULL, NULL, 202181),
(202182, '2.120.10.80-FF-000392', NULL, 'Uncharacterized protein', 186, NULL, NULL, 202182),
(202183, '3.40.220.10-FF-000015', NULL, 'Polyprotein P1234', 158, NULL, NULL, 202183),
(202184, '1.20.58.740-FF-000002', NULL, 'Dedicator of cytokinesis protein 7', 123, NULL, NULL, 202184),
(202185, '2.40.50.650-FF-000001', NULL, 'Anti-adapter protein IraM', 81, NULL, NULL, 202185),
(202186, '3.40.50.720-FF-002424', NULL, 'Uncharacterized protein', 83, NULL, NULL, 202186),
(202187, '1.20.1070.10-FF-002094', NULL, 'Uncharacterized protein', 216, NULL, NULL, 202187),
(202188, '1.10.510.10-FF-001524', NULL, 'U-box domain-containing protein kinase family protein', 197, NULL, NULL, 202188),
(202189, '2.40.50.140-FF-000972', NULL, NULL, 97, NULL, NULL, 202189),
(202190, '3.90.1150.10-FF-000380', NULL, 'Glycine dehydrogenase (decarboxylating)', 89, NULL, NULL, 202190),
(202191, '2.60.120.200-FF-000408', NULL, 'Bb-cadherin', 172, NULL, NULL, 202191),
(202192, '1.25.40.10-FF-001173', NULL, 'Vacuolar protein sorting-associated protein 41', 220, NULL, NULL, 202192),
(202193, '1.20.1070.10-FF-001829', NULL, 'Uncharacterized protein', 306, NULL, NULL, 202193),
(202194, '2.40.100.10-FF-000078', NULL, 'Allophanate hydrolase', 129, NULL, NULL, 202194),
(202195, '3.30.559.10-FF-000253', NULL, 'Uncharacterized protein', 42, NULL, NULL, 202195),
(202196, '1.50.10.10-FF-000101', NULL, 'Protein CBG10878', 312, NULL, NULL, 202196),
(202197, '3.40.850.10-FF-000158', NULL, 'Kinesin family member 16B', 277, NULL, NULL, 202197);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(202198, '3.50.7.10-FF-000091', NULL, NULL, 103, NULL, NULL, 202198),
(202199, '1.20.1250.20-FF-000166', NULL, 'Inner membrane protein YhjX', 193, NULL, NULL, 202199),
(202200, '1.10.600.10-FF-000008', NULL, 'Farnesyl pyrophosphate synthase', 346, NULL, NULL, 202200),
(202201, '2.130.10.10-FF-003080', NULL, 'Lethal(2) giant larvae protein-like Protein', 104, NULL, NULL, 202201),
(202202, '2.60.40.420-FF-000139', NULL, 'Protein CBG16448', 227, NULL, NULL, 202202),
(202203, '1.25.40.10-FF-002589', NULL, 'Pentatricopeptide repeat-containing protein', 107, NULL, NULL, 202203),
(202204, '1.10.150.170-FF-000013', NULL, NULL, 20, NULL, NULL, 202204),
(202205, '3.40.390.10-FF-000134', NULL, 'Protein CBG01792', 155, NULL, NULL, 202205),
(202206, '3.40.50.2300-FF-001110', NULL, 'Uncharacterized protein', 308, NULL, NULL, 202206),
(202207, '2.60.40.10-FF-003113', NULL, 'Fibronectin_type_III_domain_containing_protein_-_putative', 122, NULL, NULL, 202207),
(202208, '3.30.160.60-FF-001522', NULL, 'zinc finger protein 784', 73, NULL, NULL, 202208),
(202209, '3.90.640.10-FF-000204', NULL, 'Putative heat shock 70 kDa protein 14', 83, NULL, NULL, 202209),
(202210, '2.130.10.10-FF-002798', NULL, 'YALI0B10890p', 195, NULL, NULL, 202210),
(202211, '1.10.260.80-FF-000002', NULL, 'YOR131C-like protein', 54, NULL, NULL, 202211),
(202212, '1.25.40.10-FF-003213', NULL, 'Pentatricopeptide repeat-containing protein At3g09650, chloroplastic', 72, NULL, NULL, 202212),
(202213, '2.60.40.10-FF-005237', NULL, NULL, 114, NULL, NULL, 202213),
(202214, '3.30.450.20-FF-000554', NULL, 'Phosphate regulon sensor histidine kinase, putative', 114, NULL, NULL, 202214),
(202215, '3.10.28.10-FF-000049', NULL, 'Intron-encoded DNA endonuclease aI5 beta', 140, NULL, NULL, 202215),
(202216, '2.60.40.2610-FF-000007', NULL, 'Protein CsuD', 91, NULL, NULL, 202216),
(202217, '1.10.8.60-FF-000223', NULL, 'Recombination factor protein RarA', 71, NULL, NULL, 202217),
(202218, '1.25.10.10-FF-000963', NULL, 'Protein VAC14-like protein', 223, NULL, NULL, 202218),
(202219, '2.130.10.10-FF-003422', NULL, 'intraflagellar transport protein 140 homolog', 177, NULL, NULL, 202219),
(202220, '1.20.1250.20-FF-000514', NULL, 'SLC (SoLute Carrier) homolog', 196, NULL, NULL, 202220),
(202221, '1.20.990.10-FF-000040', NULL, 'Nitric oxide synthase, putative', 140, NULL, NULL, 202221),
(202222, '3.40.50.80-FF-000159', NULL, 'Iron import ATP-binding/permease protein IrtA', 122, NULL, NULL, 202222),
(202223, '3.20.190.10-FF-000011', NULL, 'Putative formamidopyrimidine-DNA glycosylase', 106, NULL, NULL, 202223),
(202224, '1.10.287.130-FF-000023', NULL, 'Sensor histidine kinase/response regulator, putative', 78, NULL, NULL, 202224),
(202225, '3.40.1110.10-FF-000017', NULL, 'Phospholipid-transporting ATPase', 196, NULL, NULL, 202225),
(202226, '3.40.50.1000-FF-000776', NULL, NULL, 93, NULL, NULL, 202226),
(202227, '3.30.70.270-FF-000261', NULL, NULL, 175, NULL, NULL, 202227),
(202228, '3.40.50.1820-FF-000235', NULL, 'Cutinase 1', 200, NULL, NULL, 202228),
(202229, '1.25.40.180-FF-000235', NULL, NULL, 223, NULL, NULL, 202229),
(202230, '1.10.510.10-FF-004397', NULL, NULL, 86, NULL, NULL, 202230),
(202231, '2.160.20.10-FF-000139', NULL, 'Putative pectinesterase 52', 261, NULL, NULL, 202231),
(202232, '3.90.1150.10-FF-000166', NULL, 'Kynurenine/alpha-aminoadipate aminotransferase, mitochondrial', 107, NULL, NULL, 202232),
(202233, '3.20.20.100-FF-000045', NULL, 'Aldo-keto reductase (AKR), putative', 295, NULL, NULL, 202233),
(202234, '3.30.2090.10-FF-000028', NULL, 'Efflux pump membrane transporter', 99, NULL, NULL, 202234),
(202235, '3.30.1410.10-FF-000003', NULL, 'Uncharacterized protein', 89, NULL, NULL, 202235),
(202236, '1.10.10.60-FF-000988', NULL, NULL, 111, NULL, NULL, 202236),
(202237, '2.60.120.260-FF-000387', NULL, 'Cellulose 1,4-beta-cellobiosidase', 184, NULL, NULL, 202237),
(202238, '1.10.220.30-FF-000018', NULL, 'Flagellar motor switch protein FliG', 102, NULL, NULL, 202238),
(202239, '1.25.40.10-FF-004736', NULL, 'Uncharacterized protein', 79, NULL, NULL, 202239); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(202240, '3.40.50.2300-FF-000834', NULL, NULL, 114, NULL, NULL, 202240),
(202241, '3.30.40.10-FF-000762', NULL, 'Zinc finger, C3HC4 type family protein', 77, NULL, NULL, 202241),
(202242, '1.20.1070.10-FF-000306', NULL, 'Adrenocorticotropic hormone receptor', 292, NULL, NULL, 202242),
(202243, '2.60.40.10-FF-004967', NULL, NULL, 50, NULL, NULL, 202243),
(202244, '3.40.250.10-FF-000062', NULL, 'Thiosulfate sulfurtransferase 16, chloroplastic', 124, NULL, NULL, 202244),
(202245, '1.10.3430.10-FF-000028', NULL, 'Ammonium Transporter Family protein', 372, NULL, NULL, 202245),
(202246, '3.10.330.10-FF-000047', NULL, 'Uncharacterized protein', 37, NULL, NULL, 202246),
(202247, '1.25.40.10-FF-005006', NULL, 'Tetratricopeptide repeat domain 21A', 123, NULL, NULL, 202247),
(202248, '2.130.10.10-FF-001275', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 224, NULL, NULL, 202248),
(202249, '1.25.40.420-FF-000009', NULL, 'Kelch-like protein 15', 103, NULL, NULL, 202249),
(202250, '3.40.228.10-FF-000027', NULL, 'NADH-quinone oxidoreductase', 191, NULL, NULL, 202250),
(202251, '3.30.465.10-FF-000035', NULL, 'L-gulonolactone oxidase', 126, NULL, NULL, 202251),
(202252, '1.10.10.60-FF-001264', NULL, NULL, 55, NULL, NULL, 202252),
(202253, '2.130.10.10-FF-001623', NULL, 'Protein NEDD1', 222, NULL, NULL, 202253),
(202254, '3.40.50.10190-FF-000081', NULL, 'BRCA1 C Terminus domain containing protein expressed', 113, NULL, NULL, 202254),
(202255, '3.90.870.10-FF-000013', NULL, 'Sua5/YciO/YrdC/YwlC family protein', 196, NULL, NULL, 202255),
(202256, '3.30.200.110-FF-000013', NULL, NULL, 137, NULL, NULL, 202256),
(202257, '3.10.580.10-FF-000200', NULL, 'Uncharacterized protein', 167, NULL, NULL, 202257),
(202258, '2.40.50.140-FF-000309', NULL, 'Exosome complex exonuclease DIS3', 90, NULL, NULL, 202258),
(202259, '3.40.50.1820-FF-000342', NULL, 'Carboxylic ester hydrolase', 533, NULL, NULL, 202259),
(202260, '2.60.40.10-FF-003220', NULL, NULL, 115, NULL, NULL, 202260),
(202261, '3.40.850.10-FF-000265', NULL, 'Kinesin-like protein', 140, NULL, NULL, 202261),
(202262, '1.10.287.130-FF-000130', NULL, 'Signal transduction histidine kinase', 66, NULL, NULL, 202262),
(202263, '2.40.50.140-FF-000753', NULL, NULL, 83, NULL, NULL, 202263),
(202264, '1.25.40.10-FF-004843', NULL, 'Predicted protein', 139, NULL, NULL, 202264),
(202265, '1.10.150.60-FF-000022', NULL, 'High mobility group B protein 15', 115, NULL, NULL, 202265),
(202266, '2.60.40.10-FF-000696', NULL, 'tyrosine-protein kinase receptor UFO isoform X1', 99, NULL, NULL, 202266),
(202267, '1.10.238.10-FF-000767', NULL, 'Centrin, putative', 149, NULL, NULL, 202267),
(202268, '3.80.10.10-FF-003496', NULL, 'Uncharacterized protein', 194, NULL, NULL, 202268),
(202269, '1.10.510.10-FF-003222', NULL, NULL, 134, NULL, NULL, 202269),
(202270, '3.40.50.12780-FF-000234', NULL, 'Uncharacterized protein', 136, NULL, NULL, 202270),
(202271, '1.20.58.400-FF-000035', NULL, 'Uncharacterized protein', 91, NULL, NULL, 202271),
(202272, '2.130.10.10-FF-000999', NULL, 'SH3KBP1-binding protein 1', 185, NULL, NULL, 202272),
(202273, '3.30.160.70-FF-000002', NULL, 'Bifunctional transcriptional activator/DNA repair enzyme Ada', 88, NULL, NULL, 202273),
(202274, '3.10.20.230-FF-000007', NULL, 'Oxygen-regulated protein 1', 90, NULL, NULL, 202274),
(202275, '2.120.10.80-FF-000397', NULL, 'Uncharacterized protein', 165, NULL, NULL, 202275),
(202276, '2.60.120.180-FF-000003', NULL, 'Probable cellulase celA2b', 151, NULL, NULL, 202276),
(202277, '3.30.70.660-FF-000052', NULL, 'tRNA pseudouridine synthase', 220, NULL, NULL, 202277),
(202278, '3.30.70.1230-FF-000111', NULL, 'Predicted protein', 191, NULL, NULL, 202278),
(202279, '2.60.120.260-FF-000494', NULL, 'Uncharacterized protein', 104, NULL, NULL, 202279),
(202280, '3.30.1330.40-FF-000051', NULL, 'YALI0F14553p', 106, NULL, NULL, 202280),
(202281, '1.10.472.10-FF-000474', NULL, 'Cyclin-D1-1', 131, NULL, NULL, 202281),
(202282, '1.20.1250.20-FF-000621', NULL, 'AmpG permease', 202, NULL, NULL, 202282),
(202283, '1.10.1040.10-FF-000071', NULL, 'ApbA-domain-containing protein', 132, NULL, NULL, 202283); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(202284, '3.10.250.10-FF-000102', NULL, NULL, 69, NULL, NULL, 202284),
(202285, '3.30.710.10-FF-000044', NULL, 'BTB/POZ domain-containing protein KCTD9 isoform X1', 106, NULL, NULL, 202285),
(202286, '1.10.238.10-FF-001043', NULL, 'Uncharacterized protein', 44, NULL, NULL, 202286),
(202287, '3.40.50.300-FF-003821', NULL, 'Sugar ABC transporter ATP-binding protein', 233, NULL, NULL, 202287),
(202288, '1.25.40.20-FF-001850', NULL, 'Uncharacterized protein', 138, NULL, NULL, 202288),
(202289, '6.20.50.160-FF-000001', NULL, 'Complement component 4', 62, NULL, NULL, 202289),
(202290, '2.60.120.200-FF-000392', NULL, 'Glycoside hydrolase family 16 protein', 300, NULL, NULL, 202290),
(202291, '3.80.10.10-FF-004120', NULL, 'Leucine-rich repeat protein (LRRP), putative', 114, NULL, NULL, 202291),
(202292, '1.10.4160.10-FF-000041', NULL, 'Uncharacterized protein', 461, NULL, NULL, 202292),
(202293, '2.20.70.10-FF-000076', NULL, 'Polyglutamine-binding protein 1', 56, NULL, NULL, 202293),
(202294, '3.80.10.10-FF-003844', NULL, 'PH domain and leucine-rich repeat protein phosphatase 1', 195, NULL, NULL, 202294),
(202295, '3.40.50.1820-FF-000903', NULL, 'Uncharacterized protein', 332, NULL, NULL, 202295),
(202296, '3.40.50.1820-FF-001865', NULL, 'Uncharacterized protein', 250, NULL, NULL, 202296),
(202297, '3.40.50.1000-FF-000883', NULL, NULL, 132, NULL, NULL, 202297),
(202298, '1.10.510.10-FF-002598', NULL, NULL, 182, NULL, NULL, 202298),
(202299, '3.80.10.10-FF-001927', NULL, 'Tubulin folding cofactor E', 169, NULL, NULL, 202299),
(202300, '3.30.710.10-FF-000482', NULL, 'Predicted protein', 91, NULL, NULL, 202300),
(202301, '1.10.225.10-FF-000001', NULL, 'Aspartic proteinase A1', 78, NULL, NULL, 202301),
(202302, '2.60.40.10-FF-002489', NULL, 'Conserved repeat domain containing protein', 110, NULL, NULL, 202302),
(202303, '2.60.40.420-FF-000246', NULL, 'Uncharacterized protein', 130, NULL, NULL, 202303),
(202304, '3.30.200.20-FF-000750', NULL, 'Protein kinase', 107, NULL, NULL, 202304),
(202305, '1.10.10.10-FF-000895', NULL, 'O-methyltransferase 9', 90, NULL, NULL, 202305),
(202306, '3.10.20.90-FF-000696', NULL, 'Uncharacterized protein (Fragment)', 51, NULL, NULL, 202306),
(202307, '2.20.70.10-FF-000183', NULL, 'E3 ubiquitin-protein ligase', 56, NULL, NULL, 202307),
(202308, '2.10.110.10-FF-000158', NULL, 'LIM/homeobox protein ttx-3', 71, NULL, NULL, 202308),
(202309, '3.80.10.10-FF-003389', NULL, 'Predicted protein', 101, NULL, NULL, 202309),
(202310, '1.10.565.10-FF-000032', NULL, 'Nuclear hormone receptor FTZ-F1', 242, NULL, NULL, 202310),
(202311, '1.25.40.10-FF-002937', NULL, 'Uncharacterized protein', 89, NULL, NULL, 202311),
(202312, '2.40.128.180-FF-000018', NULL, NULL, 32, NULL, NULL, 202312),
(202313, '2.30.30.100-FF-000037', NULL, 'U6 snRNA-associated Sm-like protein LSm6', 79, NULL, NULL, 202313),
(202314, '2.120.10.30-FF-000298', NULL, 'Uncharacterized protein', 185, NULL, NULL, 202314),
(202315, '3.30.420.40-FF-001014', NULL, 'Uncharacterized protein', 183, NULL, NULL, 202315),
(202316, '3.90.20.20-FF-000025', NULL, 'Protein GrpE', 117, NULL, NULL, 202316),
(202317, '3.40.50.300-FF-003035', NULL, 'ABC transporter AbcH.1', 248, NULL, NULL, 202317),
(202318, '3.30.1490.20-FF-000112', NULL, 'Uncharacterized protein', 35, NULL, NULL, 202318),
(202319, '3.30.40.10-FF-000436', NULL, 'Chromatin modification-related protein', 61, NULL, NULL, 202319),
(202320, '3.40.50.1110-FF-000005', NULL, 'Phospholipase B1', 271, NULL, NULL, 202320),
(202321, '3.40.50.1100-FF-000002', NULL, 'Cysteine synthase', 103, NULL, NULL, 202321),
(202322, '3.30.70.330-FF-002903', NULL, NULL, 46, NULL, NULL, 202322),
(202323, '3.30.450.20-FF-000228', NULL, 'Histidine kinase', 77, NULL, NULL, 202323),
(202324, '3.80.10.10-FF-002203', NULL, 'Toll-4', 158, NULL, NULL, 202324),
(202325, '3.40.50.150-FF-001270', NULL, NULL, 229, NULL, NULL, 202325),
(202326, '2.30.42.10-FF-000443', NULL, NULL, 98, NULL, NULL, 202326),
(202327, '1.20.5.190-FF-000158', NULL, NULL, 72, NULL, NULL, 202327),
(202328, '2.30.42.10-FF-000095', NULL, 'Zinc metalloprotease', 89, NULL, NULL, 202328);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(202329, '3.80.10.10-FF-002085', NULL, 'Uncharacterized protein', 186, NULL, NULL, 202329),
(202330, '1.25.40.1040-FF-000041', NULL, 'mRNA 3''-end-processing protein rna14', 553, NULL, NULL, 202330),
(202331, '1.25.40.10-FF-000791', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 104, NULL, NULL, 202331),
(202332, '3.40.50.300-FF-002759', NULL, 'GTPase, putative', 187, NULL, NULL, 202332),
(202333, '1.20.1740.10-FF-000144', NULL, 'Solute carrier family 38 member 3', 438, NULL, NULL, 202333),
(202334, '1.10.510.10-FF-003093', NULL, NULL, 247, NULL, NULL, 202334),
(202335, '1.50.40.10-FF-000041', NULL, 'Mitochondrial substrate carrier family protein', 275, NULL, NULL, 202335),
(202336, '2.60.120.200-FF-000734', NULL, 'L-type lectin-like domain-containing protein C4F6.05c', 204, NULL, NULL, 202336),
(202337, '1.10.3450.40-FF-000010', NULL, NULL, 90, NULL, NULL, 202337),
(202338, '2.60.120.650-FF-000066', NULL, 'lysine-specific demethylase 8-like', 236, NULL, NULL, 202338),
(202339, '1.25.10.10-FF-003043', NULL, 'Uncharacterized protein', 295, NULL, NULL, 202339),
(202340, '2.40.240.10-FF-000003', NULL, 'Glutamine--tRNA ligase', 85, NULL, NULL, 202340),
(202341, '3.40.50.11960-FF-000005', NULL, 'Uncharacterized protein', 191, NULL, NULL, 202341),
(202342, '3.10.110.10-FF-000289', NULL, 'Predicted protein', 113, NULL, NULL, 202342),
(202343, '3.40.50.1260-FF-000022', NULL, 'Phosphoglycerate kinase', 144, NULL, NULL, 202343),
(202344, '1.10.472.10-FF-000693', NULL, 'Uncharacterized protein', 117, NULL, NULL, 202344),
(202345, '3.40.30.10-FF-000401', NULL, 'Glutathione S-transferase theta 1', 81, NULL, NULL, 202345),
(202346, '3.30.2450.30-FF-000006', NULL, 'Uncharacterized protein', 85, NULL, NULL, 202346),
(202347, '3.30.40.10-FF-000088', NULL, 'E3 ubiquitin-protein ligase synoviolin', 75, NULL, NULL, 202347),
(202348, '3.40.50.300-FF-007306', NULL, 'Uncharacterized protein', 281, NULL, NULL, 202348),
(202349, '2.60.40.4100-FF-000022', NULL, 'Uncharacterized protein', 74, NULL, NULL, 202349),
(202350, '2.40.50.910-FF-000001', NULL, 'ESX-1 secretion system ATPase EccB1', 83, NULL, NULL, 202350),
(202351, '3.40.50.300-FF-007183', NULL, 'Uncharacterized protein', 171, NULL, NULL, 202351),
(202352, '1.20.58.60-FF-000238', NULL, 'Muscle-specific protein 300 kDa, isoform I', 312, NULL, NULL, 202352),
(202353, '3.40.50.11950-FF-000002', NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', 103, NULL, NULL, 202353),
(202354, '2.60.120.260-FF-000168', NULL, 'F-box only protein 6-like Protein', 176, NULL, NULL, 202354),
(202355, '1.10.287.70-FF-000712', NULL, 'Uncharacterized protein', 153, NULL, NULL, 202355),
(202356, '3.40.50.1820-FF-000561', NULL, 'Alpha/beta hydrolase', 260, NULL, NULL, 202356),
(202357, '2.40.240.20-FF-000006', NULL, 'Ribosomal RNA small subunit methyltransferase E', 69, NULL, NULL, 202357),
(202358, '3.40.50.300-FF-006694', NULL, 'Meiotic recombination protein DMC1-like protein', 80, NULL, NULL, 202358),
(202359, '1.10.510.10-FF-001187', NULL, 'Tyrosine-protein kinase ITK/TSK', 181, NULL, NULL, 202359),
(202360, '1.20.1560.10-FF-000158', NULL, 'Cysteine ABC transporter ATP-binding protein', 313, NULL, NULL, 202360),
(202361, '3.40.50.200-FF-000121', NULL, 'Predicted protein', 261, NULL, NULL, 202361),
(202362, '3.30.70.330-FF-000649', NULL, 'Polyadenylate-binding protein', 98, NULL, NULL, 202362),
(202363, '1.20.58.90-FF-000005', NULL, 'centrosomal protein CEP57L1 isoform X2', 79, NULL, NULL, 202363),
(202364, '1.20.58.60-FF-000457', NULL, 'AGAP009554-PA', 293, NULL, NULL, 202364),
(202365, '2.20.150.10-FF-000001', NULL, '5-dehydro-2-deoxygluconokinase', 44, NULL, NULL, 202365),
(202366, '3.90.550.50-FF-000086', NULL, 'Hexosyltransferase', 224, NULL, NULL, 202366),
(202367, '1.25.40.10-FF-004517', NULL, 'Uncharacterized protein', 85, NULL, NULL, 202367),
(202368, '3.90.45.10-FF-000006', NULL, 'Peptide deformylase', 193, NULL, NULL, 202368),
(202369, '3.40.850.10-FF-000484', NULL, 'Kinesin-like protein', 328, NULL, NULL, 202369),
(202370, '2.130.10.10-FF-002579', NULL, 'Sortilin', 181, NULL, NULL, 202370);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(202371, '1.25.40.10-FF-003090', NULL, 'Uncharacterized protein', 164, NULL, NULL, 202371),
(202372, '3.30.160.60-FF-003107', NULL, NULL, 23, NULL, NULL, 202372),
(202373, '1.10.274.100-FF-000033', NULL, 'DNA-directed RNA polymerase subunit', 89, NULL, NULL, 202373),
(202374, '3.30.200.20-FF-001020', NULL, 'Predicted protein', 102, NULL, NULL, 202374),
(202375, '1.20.1070.10-FF-000177', NULL, 'probable G-protein coupled receptor 52', 322, NULL, NULL, 202375),
(202376, '1.20.1050.10-FF-000288', NULL, 'Safener induced1', 68, NULL, NULL, 202376),
(202377, '3.30.2320.30-FF-000002', NULL, 'V-type proton ATPase subunit E3', 138, NULL, NULL, 202377),
(202378, '3.30.200.20-FF-002548', NULL, NULL, 14, NULL, NULL, 202378),
(202379, '1.20.1070.10-FF-001936', NULL, 'Predicted protein', 249, NULL, NULL, 202379),
(202380, '3.40.50.1820-FF-000016', NULL, 'Dipeptidyl peptidase 8-like isoform', 258, NULL, NULL, 202380),
(202381, '4.10.75.20-FF-000001', NULL, NULL, 33, NULL, NULL, 202381),
(202382, '1.20.960.20-FF-000002', NULL, 'Genome polyprotein', 67, NULL, NULL, 202382),
(202383, '2.130.10.10-FF-003203', NULL, 'Pre-mRNA-splicing factor RSE1', 330, NULL, NULL, 202383),
(202384, '2.30.40.10-FF-000152', NULL, 'Uncharacterized protein', 53, NULL, NULL, 202384),
(202385, '3.40.50.300-FF-002978', NULL, 'Putative multidrug resistance-associated protein lethal(2)03659-like Protein', 246, NULL, NULL, 202385),
(202386, '1.25.40.570-FF-000026', NULL, 'COP9 signalosome complex subunit 2 isoform X5', 321, NULL, NULL, 202386),
(202387, '1.25.40.20-FF-000001', NULL, 'Ankyrin-2 isoform 2', 117, NULL, NULL, 202387),
(202388, '3.90.190.10-FF-000118', NULL, 'Uncharacterized protein', 158, NULL, NULL, 202388),
(202389, '1.20.1070.10-FF-000525', NULL, 'AGAP002566-PA', 139, NULL, NULL, 202389),
(202390, '3.40.50.1820-FF-000780', NULL, 'Putative serine hydrolase', 251, NULL, NULL, 202390),
(202391, '1.10.1030.10-FF-000020', NULL, 'Carbamoyl-phosphate synthase large chain, C-terminal section', 70, NULL, NULL, 202391),
(202392, '1.10.640.10-FF-000011', NULL, 'Alpha-dioxygenase 1', 614, NULL, NULL, 202392),
(202393, '1.25.40.10-FF-003432', NULL, 'Pentatricopeptide repeat-containing protein At2g04860', 129, NULL, NULL, 202393),
(202394, '3.60.10.10-FF-000124', NULL, 'Endonuclease/exonuclease/phosphatase family protein', 307, NULL, NULL, 202394),
(202395, '3.40.50.300-FF-001348', NULL, 'Ras and EF-hand domain-containing protein', 198, NULL, NULL, 202395),
(202396, '3.30.230.10-FF-000237', NULL, 'AaceriAEL124Wp', 151, NULL, NULL, 202396),
(202397, '1.20.120.420-FF-000029', NULL, 'Uncharacterized protein', 53, NULL, NULL, 202397),
(202398, '1.20.1270.60-FF-000151', NULL, 'Uncharacterized protein', 268, NULL, NULL, 202398),
(202399, '2.170.300.10-FF-000040', NULL, 'Platelet endothelial aggregation receptor 1', 130, NULL, NULL, 202399),
(202400, '3.80.10.10-FF-000842', NULL, 'Receptor protein kinase CLAVATA1', 158, NULL, NULL, 202400),
(202401, '3.40.50.2000-FF-000289', NULL, 'UDP-N-acetylglucosamine transferase subunit ALG14', 182, NULL, NULL, 202401),
(202402, '3.30.70.330-FF-002336', NULL, NULL, 111, NULL, NULL, 202402),
(202403, '1.10.10.10-FF-001165', NULL, 'Carbohydrate kinase', 57, NULL, NULL, 202403),
(202404, '1.10.510.10-FF-003441', NULL, NULL, 281, NULL, NULL, 202404),
(202405, '3.30.360.20-FF-000002', NULL, 'RNA terminal phosphate cyclase-like 1', 100, NULL, NULL, 202405),
(202406, '1.20.90.10-FF-000023', NULL, NULL, 89, NULL, NULL, 202406),
(202407, '3.10.129.10-FF-000091', NULL, 'Esterase YdiI', 144, NULL, NULL, 202407),
(202408, '3.30.413.10-FF-000027', NULL, 'Sulfite reductase (NADPH)', 201, NULL, NULL, 202408),
(202409, '1.10.10.10-FF-001507', NULL, 'Crp/Fnr family transcriptional regulator', 71, NULL, NULL, 202409),
(202410, '3.40.50.720-FF-002317', NULL, 'Uncharacterized protein', 125, NULL, NULL, 202410),
(202411, '3.30.342.10-FF-000053', NULL, 'DNA polymerase epsilon catalytic subunit', 179, NULL, NULL, 202411),
(202412, '3.30.710.10-FF-000263', NULL, 'Rho related BTB domain containing 2', 89, NULL, NULL, 202412);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(202413, '1.10.10.160-FF-000003', NULL, 'RecBCD enzyme subunit RecC', 100, NULL, NULL, 202413),
(202414, '3.40.30.10-FF-001138', NULL, 'Uncharacterized protein', 65, NULL, NULL, 202414),
(202415, '2.60.120.200-FF-000515', NULL, 'Uncharacterized protein', 140, NULL, NULL, 202415),
(202416, '1.10.720.30-FF-000040', NULL, 'DNA-(apurinic or apyrimidinic site) lyase', 44, NULL, NULL, 202416),
(202417, '2.60.260.40-FF-000003', NULL, 'NADH dehydrogenase [ubiquinone] iron-sulfur protein 6, mitochondrial', 51, NULL, NULL, 202417),
(202418, '3.30.70.1350-FF-000035', NULL, NULL, 80, NULL, NULL, 202418),
(202419, '1.10.287.810-FF-000013', NULL, 'Mitochondrial GE17372', 86, NULL, NULL, 202419),
(202420, '1.25.40.20-FF-001631', NULL, 'Uncharacterized protein', 256, NULL, NULL, 202420),
(202421, '2.60.40.150-FF-000598', NULL, 'Ras GTPase-activating protein gap-2', 135, NULL, NULL, 202421),
(202422, '3.40.50.620-FF-000814', NULL, 'Tyrosyl-tRNA synthetase', 205, NULL, NULL, 202422),
(202423, '3.30.9.10-FF-000021', NULL, 'L-2-hydroxyglutarate dehydrogenase, mitochondrial', 165, NULL, NULL, 202423),
(202424, '1.20.1250.20-FF-000840', NULL, 'VBA4p protein', 274, NULL, NULL, 202424),
(202425, '2.40.50.140-FF-000186', NULL, 'ATP-dependent DNA helicase RecG', 104, NULL, NULL, 202425),
(202426, '1.10.472.10-FF-000249', NULL, 'Tumor suppressor p130, putative', 187, NULL, NULL, 202426),
(202427, '2.40.50.140-FF-000528', NULL, 'Putative asparaginyl-tRNA synthetase', 111, NULL, NULL, 202427),
(202428, '3.30.70.920-FF-000057', NULL, '74aa long hypothetical transcriptional regulator', 71, NULL, NULL, 202428),
(202429, '3.60.10.10-FF-000343', NULL, 'Uncharacterized protein', 209, NULL, NULL, 202429),
(202430, '3.40.50.2300-FF-001222', NULL, NULL, 150, NULL, NULL, 202430),
(202431, '1.10.10.60-FF-000882', NULL, NULL, 22, NULL, NULL, 202431),
(202432, '1.20.1050.10-FF-000069', NULL, 'Putative elongation factor 1-gamma', 123, NULL, NULL, 202432),
(202433, '1.20.5.170-FF-000039', NULL, 'Autophagy-related protein 16-1 isoform 1', 71, NULL, NULL, 202433),
(202434, '3.40.190.80-FF-000004', NULL, 'Inositol-1-monophosphatase', 127, NULL, NULL, 202434),
(202435, '2.60.40.10-FF-005131', NULL, NULL, 96, NULL, NULL, 202435),
(202436, '3.30.1140.32-FF-000007', NULL, '30S ribosomal protein S3', 135, NULL, NULL, 202436),
(202437, '1.10.1030.10-FF-000019', NULL, 'Carbamoyl-phosphate synthase large chain, N-terminal section', 78, NULL, NULL, 202437),
(202438, '2.40.50.140-FF-000534', NULL, 'Aspartyl-tRNA synthetase, cytoplasmic, putative', 128, NULL, NULL, 202438),
(202439, '3.90.150.10-FF-000009', NULL, 'Expression site-associated gene (ESAG) protein, putative', 181, NULL, NULL, 202439),
(202440, '1.20.58.1030-FF-000037', NULL, 'Uncharacterized protein', 117, NULL, NULL, 202440),
(202441, '3.30.160.60-FF-001292', NULL, 'zinc finger protein 181 isoform X2', 34, NULL, NULL, 202441),
(202442, '1.20.58.60-FF-000019', NULL, 'Spectrin beta chain', 304, NULL, NULL, 202442),
(202443, '3.80.10.10-FF-000281', NULL, 'Leucine-rich repeat protein soc-2', 110, NULL, NULL, 202443),
(202444, '1.10.510.10-FF-002379', NULL, NULL, 133, NULL, NULL, 202444),
(202445, '3.20.20.100-FF-000157', NULL, 'Uncharacterized protein', 253, NULL, NULL, 202445),
(202446, '3.90.228.20-FF-000002', NULL, 'phosphoenolpyruvate carboxykinase, cytosolic [GTP]', 266, NULL, NULL, 202446),
(202447, '1.20.1250.20-FF-000402', NULL, '3-(3-hydroxy-phenyl)propionate transporter MhpT', 192, NULL, NULL, 202447),
(202448, '3.30.43.40-FF-000002', NULL, 'U5 snRNA-associated splicing factor', 119, NULL, NULL, 202448),
(202449, '2.30.30.140-FF-000021', NULL, 'Tumor suppressor p53-binding protein 1', 58, NULL, NULL, 202449),
(202450, '3.40.50.970-FF-000009', NULL, 'Pyruvate dehydrogenase E1 component', 235, NULL, NULL, 202450),
(202451, '3.30.1300.30-FF-000001', NULL, 'Immunoglobulin-binding protein from prophage P-EibD', 96, NULL, NULL, 202451),
(202452, '2.40.30.270-FF-000007', NULL, 'DNA helicase, putative', 95, NULL, NULL, 202452),
(202453, '3.30.40.10-FF-000543', NULL, 'S-ribonuclease binding protein SBP1', 69, NULL, NULL, 202453);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(202454, '2.60.120.290-FF-000036', NULL, 'Suppressor of tumorigenicity 14 protein homolog', 112, NULL, NULL, 202454),
(202455, '3.40.50.960-FF-000006', NULL, '6,7-dimethyl-8-ribityllumazine synthase', 149, NULL, NULL, 202455),
(202456, '2.130.10.10-FF-002927', NULL, 'Uncharacterized protein', 359, NULL, NULL, 202456),
(202457, '2.60.120.590-FF-000025', NULL, 'Alpha-ketoglutarate-dependent dioxygenase AlkB', 205, NULL, NULL, 202457),
(202458, '3.30.420.140-FF-000015', NULL, 'Putative pre-16S rRNA nuclease', 138, NULL, NULL, 202458),
(202459, '3.30.300.30-FF-000120', NULL, 'Probable L-prolyl-AMP ligase PigI', 101, NULL, NULL, 202459),
(202460, '3.30.230.10-FF-000349', NULL, 'Predicted protein', 254, NULL, NULL, 202460),
(202461, '1.10.340.30-FF-000073', NULL, 'Endonuclease III', 117, NULL, NULL, 202461),
(202462, '1.25.40.10-FF-001302', NULL, 'Pentatricopeptide repeat-containing protein At3g53360, mitochondrial', 161, NULL, NULL, 202462),
(202463, '3.40.47.10-FF-000272', NULL, NULL, 112, NULL, NULL, 202463),
(202464, '1.20.1560.10-FF-000046', NULL, 'ATP-binding cassette subfamily B member 11', 311, NULL, NULL, 202464),
(202465, '3.30.70.850-FF-000007', NULL, 'Neuroendocrine convertase 2', 88, NULL, NULL, 202465),
(202466, '3.20.20.80-FF-000158', NULL, 'Exported alpha-L-fucosidase', 363, NULL, NULL, 202466),
(202467, '1.10.1380.10-FF-000006', NULL, 'Uncharacterized protein, isoform A', 366, NULL, NULL, 202467),
(202468, '1.10.150.120-FF-000026', NULL, NULL, 49, NULL, NULL, 202468),
(202469, '3.40.50.300-FF-007531', NULL, 'Uncharacterized protein', 206, NULL, NULL, 202469),
(202470, '3.30.200.20-FF-000856', NULL, 'Kinase, putative', 127, NULL, NULL, 202470),
(202471, '1.25.40.20-FF-001305', NULL, 'Uncharacterized protein', 150, NULL, NULL, 202471),
(202472, '3.30.310.80-FF-000039', NULL, 'Non-specific serine/threonine protein kinase', 123, NULL, NULL, 202472),
(202473, '1.10.260.30-FF-000015', NULL, 'Signal recognition particle 54 kDa protein', 132, NULL, NULL, 202473),
(202474, '3.30.160.60-FF-002489', NULL, 'Uncharacterized protein', 60, NULL, NULL, 202474),
(202475, '2.30.42.10-FF-000218', NULL, 'PDZ domain containing 2', 103, NULL, NULL, 202475),
(202476, '3.40.50.11260-FF-000003', NULL, 'Heat shock protein 90', 88, NULL, NULL, 202476),
(202477, '3.40.50.300-FF-003260', NULL, '3''-5'' exonuclease DinG', 265, NULL, NULL, 202477),
(202478, '1.20.1050.10-FF-000182', NULL, 'Uncharacterized protein', 119, NULL, NULL, 202478),
(202479, '3.40.50.300-FF-004783', NULL, 'Dynein heavy chain family protein', 158, NULL, NULL, 202479),
(202480, '3.10.450.50-FF-000091', NULL, 'Uncharacterized protein', 120, NULL, NULL, 202480),
(202481, '1.20.1070.10-FF-000183', NULL, 'Urotensin-2 receptor', 339, NULL, NULL, 202481),
(202482, '3.30.160.60-FF-003433', NULL, NULL, 28, NULL, NULL, 202482),
(202483, '3.30.420.10-FF-000055', NULL, 'RNA exonuclease 5 isoform X1', 174, NULL, NULL, 202483),
(202484, '3.40.50.2000-FF-000632', NULL, 'UDP-glucuronosyltransferase', 201, NULL, NULL, 202484),
(202485, '3.80.10.10-FF-004226', NULL, 'Uncharacterized protein', 81, NULL, NULL, 202485),
(202486, '4.10.270.10-FF-000010', NULL, 'Type II myosin heavy chain, putative', 61, NULL, NULL, 202486),
(202487, '1.10.150.710-FF-000001', NULL, 'Glutamate--cysteine ligase', 84, NULL, NULL, 202487),
(202488, '3.30.300.10-FF-000001', NULL, 'S-adenosylmethionine synthase', 141, NULL, NULL, 202488),
(202489, '3.40.50.2300-FF-000621', NULL, 'Vomeronasal 2, receptor 83', 75, NULL, NULL, 202489),
(202490, '3.40.50.360-FF-000034', NULL, 'NADPH-dependent diflavin oxidoreductase 1', 161, NULL, NULL, 202490),
(202491, '1.10.260.40-FF-000018', NULL, 'Multiprotein bridging factor 1', 74, NULL, NULL, 202491),
(202492, '3.90.1750.20-FF-000006', NULL, 'Site-specific recombinase', 141, NULL, NULL, 202492),
(202493, '3.10.129.10-FF-000214', NULL, 'Thioesterase superfamily, putative', 129, NULL, NULL, 202493),
(202494, '3.30.300.20-FF-000004', NULL, 'GTPase Der', 88, NULL, NULL, 202494),
(202495, '1.20.5.170-FF-000152', NULL, 'Yap3p', 67, NULL, NULL, 202495);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(202496, '2.10.25.10-FF-001377', NULL, 'Growth arrest-specific 6', 44, NULL, NULL, 202496),
(202497, '3.40.20.10-FF-000007', NULL, 'Twinfilin-1 isoform 1', 147, NULL, NULL, 202497),
(202498, '3.40.50.360-FF-000141', NULL, 'Uncharacterized protein', 171, NULL, NULL, 202498),
(202499, '3.30.420.10-FF-000162', NULL, 'Mitochondrial DNA polymerase I protein D, putative', 232, NULL, NULL, 202499),
(202500, '2.60.40.10-FF-001527', NULL, 'Hemicentin 1', 93, NULL, NULL, 202500),
(202501, '1.10.287.130-FF-000129', NULL, 'Two-component sensor, ParS', 69, NULL, NULL, 202501),
(202502, '2.40.10.10-FF-000689', NULL, NULL, 38, NULL, NULL, 202502),
(202503, '3.90.660.10-FF-000082', NULL, NULL, 83, NULL, NULL, 202503),
(202504, '1.25.40.20-FF-001288', NULL, 'Uncharacterized protein', 170, NULL, NULL, 202504),
(202505, '3.40.50.720-FF-000064', NULL, 'Pyrroline-5-carboxylate reductase 1', 166, NULL, NULL, 202505),
(202506, '2.30.29.170-FF-000016', NULL, 'Predicted protein', 137, NULL, NULL, 202506),
(202507, '1.20.1510.10-FF-000099', NULL, NULL, 82, NULL, NULL, 202507),
(202508, '3.30.300.30-FF-000007', NULL, '4-coumarate--CoA ligase 2', 103, NULL, NULL, 202508),
(202509, '3.20.20.80-FF-000265', NULL, 'Chitinase putative', 273, NULL, NULL, 202509),
(202510, '2.40.50.140-FF-000860', NULL, NULL, 142, NULL, NULL, 202510),
(202511, '1.20.1070.10-FF-001020', NULL, 'Uncharacterized protein', 180, NULL, NULL, 202511),
(202512, '3.10.129.10-FF-000107', NULL, 'Acyl-CoA thioesterase', 134, NULL, NULL, 202512),
(202513, '3.40.50.410-FF-000072', NULL, 'collagen alpha-1(VII) chain', 198, NULL, NULL, 202513),
(202514, '3.40.50.1970-FF-000027', NULL, 'Iron-containing alcohol dehydrogenase', 185, NULL, NULL, 202514),
(202515, '3.30.200.20-FF-000637', NULL, 'Serine/threonine protein kinase', 115, NULL, NULL, 202515),
(202516, '3.40.50.2000-FF-000413', NULL, 'UDP-N-acetylglucosamine transferase subunit ALG14', 164, NULL, NULL, 202516),
(202517, '3.30.2230.10-FF-000017', NULL, 'Putative ubiquitin-hydrolase domain protein', 103, NULL, NULL, 202517),
(202518, '3.30.40.10-FF-000324', NULL, 'E3 ubiquitin-protein ligase RNF125 isoform X2', 96, NULL, NULL, 202518),
(202519, '3.90.190.10-FF-000225', NULL, 'Tyrosine phosphatase family, putative', 89, NULL, NULL, 202519),
(202520, '1.25.40.10-FF-001521', NULL, 'Uncharacterized protein, isoform B', 180, NULL, NULL, 202520),
(202521, '2.60.34.10-FF-000075', NULL, 'Heat shock protein 70E', 169, NULL, NULL, 202521),
(202522, '3.30.70.330-FF-001032', NULL, 'Os05g0162600 protein', 84, NULL, NULL, 202522),
(202523, '3.40.50.300-FF-003147', NULL, '6-phosphofructo-2-kinase/fructose-2,6-biphosphata se-1-like protein', 209, NULL, NULL, 202523),
(202524, '3.40.50.150-FF-000988', NULL, NULL, 214, NULL, NULL, 202524),
(202525, '3.40.50.300-FF-005165', NULL, 'YALI0F10307p', 225, NULL, NULL, 202525),
(202526, '3.40.50.12780-FF-000127', NULL, 'Nonribosomal peptide synthase, putative', 403, NULL, NULL, 202526),
(202527, '3.40.50.150-FF-001606', NULL, NULL, 258, NULL, NULL, 202527),
(202528, '3.30.930.10-FF-000026', NULL, 'Seryl-tRNA synthetase, cytoplasmic', 333, NULL, NULL, 202528),
(202529, '3.30.519.10-FF-000037', NULL, NULL, 192, NULL, NULL, 202529),
(202530, '3.30.70.330-FF-002561', NULL, NULL, 191, NULL, NULL, 202530),
(202531, '1.20.1740.10-FF-000032', NULL, 'Tyrosine-specific transport system', 399, NULL, NULL, 202531),
(202532, '3.30.1010.10-FF-000035', NULL, 'Phosphatidylinositol 4-kinase PIK1a', 193, NULL, NULL, 202532),
(202533, '2.70.98.10-FF-000098', NULL, 'Galactose mutarotase-like superfamily protein', 151, NULL, NULL, 202533),
(202534, '3.90.1640.10-FF-000029', NULL, 'Uncharacterized protein', 205, NULL, NULL, 202534),
(202535, '1.25.40.20-FF-001524', NULL, 'Protein 21.1', 132, NULL, NULL, 202535),
(202536, '2.170.140.10-FF-000049', NULL, 'Uncharacterized protein', 67, NULL, NULL, 202536),
(202537, '2.130.10.10-FF-005002', NULL, 'Zinc finger CCCH domain-containing protein 63', 61, NULL, NULL, 202537),
(202538, '2.40.220.10-FF-000002', NULL, 'Sialidase B', 98, NULL, NULL, 202538),
(202539, '3.40.50.2300-FF-000508', NULL, 'Accessory gene regulator A', 138, NULL, NULL, 202539); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(202540, '1.10.3450.30-FF-000001', NULL, 'KICSTOR complex protein C12orf66 homolog', 203, NULL, NULL, 202540),
(202541, '2.60.40.4100-FF-000016', NULL, 'uncharacterized protein LOC100177824', 156, NULL, NULL, 202541),
(202542, '2.60.120.10-FF-000411', NULL, 'Uncharacterized protein', 87, NULL, NULL, 202542),
(202543, '3.30.160.60-FF-001179', NULL, 'zinc finger protein 621 isoform X3', 33, NULL, NULL, 202543),
(202544, '3.40.50.300-FF-007418', NULL, 'ATP binding cassette subfamily B member 4', 12, NULL, NULL, 202544),
(202545, '1.20.1070.10-FF-000413', NULL, 'Relaxin family peptide receptor 3.2b', 320, NULL, NULL, 202545),
(202546, '3.80.10.10-FF-003838', NULL, 'Si:ch211-191d15.2', 53, NULL, NULL, 202546),
(202547, '2.30.30.30-FF-000096', NULL, '40S ribosomal protein S4', 69, NULL, NULL, 202547),
(202548, '3.40.50.720-FF-002194', NULL, 'Uncharacterized protein', 332, NULL, NULL, 202548),
(202549, '1.10.10.2830-FF-000001', NULL, 'Chromosome partitioning protein ParB', 114, NULL, NULL, 202549),
(202550, '3.40.50.300-FF-005401', NULL, 'Uncharacterized protein', 220, NULL, NULL, 202550),
(202551, '1.20.1280.290-FF-000055', NULL, 'PQ loop repeat protein', 88, NULL, NULL, 202551),
(202552, '2.30.29.30-FF-000463', NULL, 'CCM2 like scaffold protein', 69, NULL, NULL, 202552),
(202553, '1.10.3450.40-FF-000004', NULL, 'Signal recognition particle subunit SRP68', 205, NULL, NULL, 202553),
(202554, '3.40.720.10-FF-000042', NULL, 'Alkaline-phosphatase-like family protein', 229, NULL, NULL, 202554),
(202555, '3.30.260.10-FF-000065', NULL, NULL, 104, NULL, NULL, 202555),
(202556, '3.80.10.10-FF-002079', NULL, 'Uncharacterized protein', 243, NULL, NULL, 202556),
(202557, '3.60.130.10-FF-000037', NULL, 'Putative gamma-butyrobetaine dioxygenase', 284, NULL, NULL, 202557),
(202558, '1.25.40.10-FF-000914', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 203, NULL, NULL, 202558),
(202559, '1.20.1250.20-FF-000391', NULL, 'Large neutral amino acids transporter small subunit 4', 465, NULL, NULL, 202559),
(202560, '1.25.10.10-FF-002986', NULL, 'Uncharacterized protein', 622, NULL, NULL, 202560),
(202561, '3.30.160.60-FF-002596', NULL, 'Transcriptional repressor CTCF', 32, NULL, NULL, 202561),
(202562, '1.10.510.10-FF-003216', NULL, NULL, 138, NULL, NULL, 202562),
(202563, '1.25.10.10-FF-003150', NULL, 'Predicted protein', 58, NULL, NULL, 202563),
(202564, '1.10.460.10-FF-000019', NULL, 'DNA topoisomerase', 66, NULL, NULL, 202564),
(202565, '1.20.1740.10-FF-000251', NULL, 'Uncharacterized protein', 293, NULL, NULL, 202565),
(202566, '3.90.1150.10-FF-000379', NULL, 'Ornithine aminotransferase', 90, NULL, NULL, 202566),
(202567, '1.20.1070.10-FF-000290', NULL, 'GG11888', 286, NULL, NULL, 202567),
(202568, '1.20.80.10-FF-000067', NULL, 'Fermitin 2', 78, NULL, NULL, 202568),
(202569, '3.40.50.20-FF-000057', NULL, 'Uncharacterized protein', 107, NULL, NULL, 202569),
(202570, '3.40.630.10-FF-000395', NULL, 'Uncharacterized protein', 23, NULL, NULL, 202570),
(202571, '3.40.50.2000-FF-001014', NULL, 'Uncharacterized protein', 186, NULL, NULL, 202571),
(202572, '3.30.420.150-FF-000018', NULL, 'Probable apyrase 6', 264, NULL, NULL, 202572),
(202573, '3.20.20.80-FF-000046', NULL, 'Glucosidase alpha, neutral C', 175, NULL, NULL, 202573),
(202574, '1.25.40.10-FF-000684', NULL, 'Pentatricopeptide repeat-containing protein At2g41720', 71, NULL, NULL, 202574),
(202575, '1.50.10.20-FF-000093', NULL, 'Terpene cyclase/mutase family member', 150, NULL, NULL, 202575),
(202576, '1.25.40.20-FF-000687', NULL, 'BRCA1-associated RING domain protein 1', 116, NULL, NULL, 202576),
(202577, '1.10.472.10-FF-000468', NULL, 'Cyclin family protein', 106, NULL, NULL, 202577),
(202578, '3.30.1520.10-FF-000006', NULL, 'Phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit alpha', 141, NULL, NULL, 202578),
(202579, '1.10.287.130-FF-000242', NULL, 'Sensor histidine kinase, PAS domain-containing', 83, NULL, NULL, 202579),
(202580, '3.40.50.150-FF-001045', NULL, NULL, 122, NULL, NULL, 202580),
(202581, '1.20.1540.10-FF-000051', NULL, 'Membrane associated serine protease, rhomboid family', 183, NULL, NULL, 202581);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(202582, '2.60.120.200-FF-000066', NULL, 'Laminin subunit alpha 4', 203, NULL, NULL, 202582),
(202583, '3.40.20.10-FF-000120', NULL, 'Gelsolin-related protein of 125 kDa', 129, NULL, NULL, 202583),
(202584, '3.30.70.1730-FF-000042', NULL, '50S ribosomal protein L10', 131, NULL, NULL, 202584),
(202585, '3.30.750.24-FF-000144', NULL, 'Anti-sigma factor antagonist', 103, NULL, NULL, 202585),
(202586, '3.30.559.10-FF-000146', NULL, 'Uncharacterized protein', 61, NULL, NULL, 202586),
(202587, '3.90.70.80-FF-000063', NULL, 'Uncharacterized protein', 117, NULL, NULL, 202587),
(202588, '3.40.50.10580-FF-000001', NULL, 'V-type proton ATPase subunit F', 115, NULL, NULL, 202588),
(202589, '3.40.50.720-FF-002082', NULL, 'Uncharacterized protein', 141, NULL, NULL, 202589),
(202590, '1.25.40.10-FF-004955', NULL, 'Uncharacterized protein', 165, NULL, NULL, 202590),
(202591, '3.30.70.330-FF-000195', NULL, 'RNA binding motif protein 15', 98, NULL, NULL, 202591),
(202592, '1.20.120.1240-FF-000029', NULL, 'Dynamin GTPase, variant', 142, NULL, NULL, 202592),
(202593, '2.60.40.10-FF-005018', NULL, NULL, 105, NULL, NULL, 202593),
(202594, '3.20.20.70-FF-000043', NULL, 'D-tagatose-1,6-bisphosphate aldolase subunit GatY', 284, NULL, NULL, 202594),
(202595, '3.30.1120.30-FF-000015', NULL, 'Serine/threonine-protein kinase PLK', 102, NULL, NULL, 202595),
(202596, '3.60.110.10-FF-000036', NULL, 'Hydrolase, carbon-nitrogen family protein', 256, NULL, NULL, 202596),
(202597, '1.10.760.10-FF-000059', NULL, 'Uncharacterized protein', 200, NULL, NULL, 202597),
(202598, '3.30.1540.10-FF-000007', NULL, 'Probable CoA-transferase Rv1866', 92, NULL, NULL, 202598),
(202599, '3.40.50.300-FF-005384', NULL, 'Uncharacterized protein', 267, NULL, NULL, 202599),
(202600, '1.20.1070.10-FF-002105', NULL, 'Predicted protein', 257, NULL, NULL, 202600),
(202601, '2.40.50.40-FF-000009', NULL, 'chromobox protein homolog 1', 78, NULL, NULL, 202601),
(202602, '3.30.70.270-FF-000154', NULL, 'Pol polyprotein', 107, NULL, NULL, 202602),
(202603, '1.10.10.60-FF-000769', NULL, NULL, 82, NULL, NULL, 202603),
(202604, '3.40.1440.10-FF-000003', NULL, 'Structure-specific endonuclease subunit SLX1', 102, NULL, NULL, 202604),
(202605, '2.30.230.10-FF-000005', NULL, 'Putative Copper-zinc cu-zn superoxide dismutase', 292, NULL, NULL, 202605),
(202606, '1.10.4160.10-FF-000035', NULL, NULL, 342, NULL, NULL, 202606),
(202607, '2.40.50.140-FF-000641', NULL, '''Cold-shock'' DNA-binding domain containing protein, putative', 94, NULL, NULL, 202607),
(202608, '1.20.1270.60-FF-000044', NULL, 'Sorting nexin 1', 220, NULL, NULL, 202608),
(202609, '3.80.10.10-FF-000174', NULL, 'E3 ubiquitin-protein ligase LRSAM1 isoform 1', 178, NULL, NULL, 202609),
(202610, '1.20.120.1820-FF-000001', NULL, 'Chaperone protein TorD', 118, NULL, NULL, 202610),
(202611, '3.40.50.2300-FF-000840', NULL, 'Uncharacterized protein', 266, NULL, NULL, 202611),
(202612, '1.20.58.60-FF-000351', NULL, 'Spectrin beta, non-erythrocytic 5', 205, NULL, NULL, 202612),
(202613, '2.30.42.10-FF-000550', NULL, NULL, 78, NULL, NULL, 202613),
(202614, '3.30.70.260-FF-000151', NULL, 'Probable phosphoserine phosphatase', 81, NULL, NULL, 202614),
(202615, '3.50.50.60-FF-000299', NULL, 'KsdD-like steroid dehydrogenase', 328, NULL, NULL, 202615),
(202616, '2.130.10.10-FF-003641', NULL, 'Uncharacterized protein', 241, NULL, NULL, 202616),
(202617, '1.25.40.120-FF-000021', NULL, 'Protein farnesyltransferase alpha subunit, putative', 297, NULL, NULL, 202617),
(202618, '3.30.70.330-FF-002229', NULL, NULL, 58, NULL, NULL, 202618),
(202619, '3.30.160.60-FF-003214', NULL, 'Zinc finger protein 1164', 25, NULL, NULL, 202619),
(202620, '2.120.10.30-FF-000186', NULL, 'Acylaminoacyl peptidase', 138, NULL, NULL, 202620),
(202621, '2.60.120.260-FF-000617', NULL, 'Predicted protein', 136, NULL, NULL, 202621),
(202622, '3.40.50.2000-FF-000396', NULL, 'Macrolide glycosyltransferase', 220, NULL, NULL, 202622),
(202623, '3.30.160.60-FF-004962', NULL, NULL, 30, NULL, NULL, 202623),
(202624, '1.50.10.20-FF-000104', NULL, 'Geranylgeranyl transferase type-2 subunit beta', 319, NULL, NULL, 202624);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(202625, '1.20.1560.10-FF-000265', NULL, 'p-GlycoProtein related', 604, NULL, NULL, 202625),
(202626, '3.30.200.20-FF-001351', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase RLK1', 36, NULL, NULL, 202626),
(202627, '1.20.5.1200-FF-000009', NULL, 'GD18460', 28, NULL, NULL, 202627),
(202628, '3.60.10.10-FF-000231', NULL, 'Uncharacterized protein', 379, NULL, NULL, 202628),
(202629, '1.20.120.160-FF-000024', NULL, 'Response regulator', 107, NULL, NULL, 202629),
(202630, '1.10.287.70-FF-000605', NULL, 'Predicted protein', 293, NULL, NULL, 202630),
(202631, '1.10.10.10-FF-000906', NULL, 'MarR family transcriptional regulator', 131, NULL, NULL, 202631),
(202632, '1.10.287.70-FF-000263', NULL, 'Uncharacterized protein', 151, NULL, NULL, 202632),
(202633, '1.20.1070.10-FF-002088', NULL, 'Gastric inhibitory polypeptide receptor', 303, NULL, NULL, 202633),
(202634, '3.40.1310.20-FF-000002', NULL, 'Master replication protein', 94, NULL, NULL, 202634),
(202635, '2.130.10.30-FF-000090', NULL, NULL, 159, NULL, NULL, 202635),
(202636, '3.10.350.10-FF-000048', NULL, 'Cell division suppressor protein YneA', 69, NULL, NULL, 202636),
(202637, '1.20.1420.30-FF-000098', NULL, 'Uncharacterized protein', 193, NULL, NULL, 202637),
(202638, '2.10.25.10-FF-000073', NULL, 'Pro-neuregulin-1, membrane-bound isoform A', 55, NULL, NULL, 202638),
(202639, '2.60.120.200-FF-000285', NULL, 'Sialidase A', 187, NULL, NULL, 202639),
(202640, '1.20.1260.10-FF-000006', NULL, 'Ferritin', 201, NULL, NULL, 202640),
(202641, '3.40.50.2000-FF-000851', NULL, 'Uncharacterized protein', 233, NULL, NULL, 202641),
(202642, '3.30.460.10-FF-000052', NULL, 'Ribosomal silencing factor RsfS', 114, NULL, NULL, 202642),
(202643, '3.10.20.90-FF-000589', NULL, 'Autophagy-related protein', 48, NULL, NULL, 202643),
(202644, '3.80.10.10-FF-001011', NULL, 'Toll-like receptor 21', 151, NULL, NULL, 202644),
(202645, '2.30.30.140-FF-000240', NULL, 'Putative serine/threonine-protein kinase pats1', 69, NULL, NULL, 202645),
(202646, '3.30.70.330-FF-002448', NULL, NULL, 86, NULL, NULL, 202646),
(202647, '1.20.1250.20-FF-001695', NULL, 'Uncharacterized protein', 213, NULL, NULL, 202647),
(202648, '3.60.90.10-FF-000005', NULL, 'Arginine decarboxylase proenzyme', 117, NULL, NULL, 202648),
(202649, '1.25.40.90-FF-000090', NULL, 'Os09g0472400 protein', 41, NULL, NULL, 202649),
(202650, '2.10.25.10-FF-000415', NULL, 'Laminin subunit gamma 1', 61, NULL, NULL, 202650),
(202651, '2.130.10.10-FF-004945', NULL, 'Predicted protein', 100, NULL, NULL, 202651),
(202652, '3.80.10.10-FF-000393', NULL, 'LRR receptor-like serine/threonine-protein kinase RCH1', 224, NULL, NULL, 202652),
(202653, '2.60.260.20-FF-000138', NULL, 'Uncharacterized protein', 81, NULL, NULL, 202653),
(202654, '2.10.25.10-FF-001596', NULL, 'Netrin g2b', 60, NULL, NULL, 202654),
(202655, '2.130.10.10-FF-005221', NULL, 'Uncharacterized protein', 75, NULL, NULL, 202655),
(202656, '3.40.50.720-FF-000625', NULL, 'Glutamyl-tRNA reductase', 153, NULL, NULL, 202656),
(202657, '1.20.1250.20-FF-002313', NULL, 'Uncharacterized protein', 255, NULL, NULL, 202657),
(202658, '1.10.150.20-FF-000145', NULL, 'DNA repair endonuclease xp-f, putative', 74, NULL, NULL, 202658),
(202659, '3.30.1240.10-FF-000063', NULL, 'Sll1524 protein', 112, NULL, NULL, 202659),
(202660, '1.10.8.10-FF-000017', NULL, 'OTU domain-containing protein 7A', 61, NULL, NULL, 202660),
(202661, '3.40.1160.10-FF-000060', NULL, 'Uridylate kinase protein', 244, NULL, NULL, 202661),
(202662, '1.10.10.10-FF-001058', NULL, 'IclR family transcriptional regulator', 82, NULL, NULL, 202662),
(202663, '2.60.40.10-FF-003096', NULL, 'Uncharacterized protein', 114, NULL, NULL, 202663),
(202664, '1.20.1070.10-FF-001487', NULL, 'Teleost multiple tissue opsin 3b', 204, NULL, NULL, 202664),
(202665, '3.40.50.300-FF-005620', NULL, 'Putative Unc104-like kinesin', 188, NULL, NULL, 202665),
(202666, '2.40.50.40-FF-000122', NULL, 'Chromodomain helicase DNA-binding protein 5', 95, NULL, NULL, 202666),
(202667, '3.40.190.10-FF-000585', NULL, 'Peptide transport periplasmic protein', 88, NULL, NULL, 202667);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(202668, '3.30.70.330-FF-000318', NULL, 'Zinc finger CCCH domain-containing protein 5', 100, NULL, NULL, 202668),
(202669, '2.160.20.10-FF-000246', NULL, 'ABC-type copper transport system substrate-binding component NosD', 118, NULL, NULL, 202669),
(202670, '1.10.287.3440-FF-000005', NULL, 'Arginine decarboxylase', 56, NULL, NULL, 202670),
(202671, '3.40.1190.20-FF-000233', NULL, NULL, 292, NULL, NULL, 202671),
(202672, '3.40.50.11350-FF-000024', NULL, 'Predicted protein', 166, NULL, NULL, 202672),
(202673, '3.40.50.620-FF-000365', NULL, 'Pantoate--beta-alanine ligase', 169, NULL, NULL, 202673),
(202674, '3.90.190.20-FF-000009', NULL, 'Folylpolyglutamate synthase', 174, NULL, NULL, 202674),
(202675, '3.40.1110.10-FF-000124', NULL, 'Probable copper-importing P-type ATPase A', 123, NULL, NULL, 202675),
(202676, '3.40.50.1010-FF-000200', NULL, NULL, 170, NULL, NULL, 202676),
(202677, '1.10.510.10-FF-001294', NULL, 'CDPK-related kinase 3', 173, NULL, NULL, 202677),
(202678, '3.60.20.10-FF-000057', NULL, 'ATP-dependent protease subunit ClpQ, putative', 174, NULL, NULL, 202678),
(202679, '1.25.40.180-FF-000342', NULL, NULL, 157, NULL, NULL, 202679),
(202680, '3.40.390.10-FF-000241', NULL, NULL, 55, NULL, NULL, 202680),
(202681, '2.60.40.10-FF-001640', NULL, 'Prostate-specific transglutaminase 4', 145, NULL, NULL, 202681),
(202682, '3.80.10.10-FF-002192', NULL, 'Toll-like receptor 21', 214, NULL, NULL, 202682),
(202683, '2.60.40.60-FF-001065', NULL, 'Uncharacterized protein', 59, NULL, NULL, 202683),
(202684, '3.90.79.10-FF-000186', NULL, 'Uncharacterized protein', 189, NULL, NULL, 202684),
(202685, '3.40.50.300-FF-001236', NULL, 'ATP-dependent helicase/nuclease subunit A', 178, NULL, NULL, 202685),
(202686, '3.90.180.10-FF-000056', NULL, 'NAD-dependent alcohol dehydrogenase', 335, NULL, NULL, 202686),
(202687, '3.40.50.12710-FF-000022', NULL, 'Uncharacterized protein', 381, NULL, NULL, 202687),
(202688, '3.30.160.60-FF-005125', NULL, NULL, 38, NULL, NULL, 202688),
(202689, '3.90.190.10-FF-000006', NULL, 'Dual specificity protein phosphatase CDC14B', 169, NULL, NULL, 202689),
(202690, '3.30.830.10-FF-000098', NULL, 'Zinc Metalloprotease (Insulinase family)', 229, NULL, NULL, 202690),
(202691, '3.40.50.300-FF-008599', NULL, 'Peroxisome biogenesis factor, putative', 33, NULL, NULL, 202691),
(202692, '1.25.40.10-FF-003320', NULL, 'Pentatricopeptide repeat-containing protein At2g27610', 106, NULL, NULL, 202692),
(202693, '1.20.1250.20-FF-000059', NULL, 'Solute carrier family 17 member 9', 190, NULL, NULL, 202693),
(202694, '3.40.50.1820-FF-001758', NULL, 'Cathepsin A', 238, NULL, NULL, 202694),
(202695, '3.30.40.10-FF-001959', NULL, 'CESA4 (CELLULOSE SYNTHASE A4)', 65, NULL, NULL, 202695),
(202696, '1.20.1250.10-FF-000056', NULL, 'Colony-stimulating factor 1b (macrophage)', 157, NULL, NULL, 202696),
(202697, '2.30.40.10-FF-000040', NULL, 'Guanine deaminase', 154, NULL, NULL, 202697),
(202698, '3.40.50.970-FF-000228', NULL, 'Gll1094 protein', 147, NULL, NULL, 202698),
(202699, '2.130.10.10-FF-003309', NULL, 'Uncharacterized protein', 215, NULL, NULL, 202699),
(202700, '3.80.10.10-FF-002534', NULL, 'Uncharacterized protein', 263, NULL, NULL, 202700),
(202701, '3.40.50.300-FF-007076', NULL, 'Uncharacterized protein', 193, NULL, NULL, 202701),
(202702, '3.90.1150.210-FF-000028', NULL, 'F-actin-capping protein subunit beta', 107, NULL, NULL, 202702),
(202703, '1.20.1080.10-FF-000133', NULL, 'Uncharacterized protein', 141, NULL, NULL, 202703),
(202704, '1.25.10.10-FF-001570', NULL, 'Uncharacterized protein', 240, NULL, NULL, 202704),
(202705, '3.30.710.10-FF-000375', NULL, 'Uncharacterized protein', 129, NULL, NULL, 202705),
(202706, '2.60.40.60-FF-000789', NULL, 'Cadherin related family member 3', 90, NULL, NULL, 202706),
(202707, '3.100.10.10-FF-000036', NULL, NULL, 83, NULL, NULL, 202707),
(202708, '1.20.5.110-FF-000050', NULL, 'Vesicle-associated membrane protein 4', 118, NULL, NULL, 202708),
(202709, '3.20.20.140-FF-000141', NULL, 'Histidinol-phosphatase HisJ', 275, NULL, NULL, 202709),
(202710, '2.30.30.100-FF-000144', NULL, 'U6 snRNA-associated Sm-like protein LSm6', 79, NULL, NULL, 202710);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(202711, '3.40.50.2000-FF-000177', NULL, 'Glycogen [starch] synthase', 150, NULL, NULL, 202711),
(202712, '2.60.40.10-FF-005350', NULL, NULL, 68, NULL, NULL, 202712),
(202713, '1.20.900.10-FF-000001', NULL, 'Guanine nucleotide exchange factor DBS', 190, NULL, NULL, 202713),
(202714, '2.60.120.200-FF-000627', NULL, 'Drosophila CRumBs homolog', 129, NULL, NULL, 202714),
(202715, '3.30.70.141-FF-000015', NULL, 'Nucleoside diphosphate kinase B', 151, NULL, NULL, 202715),
(202716, '2.80.10.70-FF-000003', NULL, 'spindlin-2B isoform X2', 82, NULL, NULL, 202716),
(202717, '1.25.40.20-FF-001743', NULL, 'Uncharacterized protein', 213, NULL, NULL, 202717),
(202718, '3.30.590.10-FF-000056', NULL, 'Uncharacterized protein', 97, NULL, NULL, 202718),
(202719, '3.90.226.10-FF-000068', NULL, 'S49 family peptidase', 161, NULL, NULL, 202719),
(202720, '3.40.50.720-FF-002205', NULL, 'Dehydrogenase, putative', 306, NULL, NULL, 202720),
(202721, '3.90.1150.10-FF-000492', NULL, 'Uncharacterized protein', 58, NULL, NULL, 202721),
(202722, '2.40.50.140-FF-000298', NULL, 'aspartate--tRNA ligase, mitochondrial isoform X2', 107, NULL, NULL, 202722),
(202723, '3.30.40.10-FF-002235', NULL, 'Histone acetyltransferase', 122, NULL, NULL, 202723),
(202724, '1.20.1560.10-FF-000607', NULL, 'Uncharacterized protein', 298, NULL, NULL, 202724),
(202725, '2.120.10.80-FF-000408', NULL, 'F-box only protein 13', 239, NULL, NULL, 202725),
(202726, '3.40.50.300-FF-005507', NULL, 'DEAD box protein 21E2', 166, NULL, NULL, 202726),
(202727, '3.40.50.300-FF-003366', NULL, 'Helicase required for RNAi-mediated heterochromatin assembly 1', 196, NULL, NULL, 202727),
(202728, '2.60.220.50-FF-000122', NULL, 'Predicted protein', 36, NULL, NULL, 202728),
(202729, '1.10.510.10-FF-000799', NULL, 'Cyclin-dependent kinase F-1', 198, NULL, NULL, 202729),
(202730, '3.80.10.10-FF-002315', NULL, 'Uncharacterized protein', 166, NULL, NULL, 202730),
(202731, '1.10.510.10-FF-001417', NULL, 'Casein kinase I isoform alpha', 153, NULL, NULL, 202731),
(202732, '3.30.300.160-FF-000005', NULL, 'Type II secretion system protein E', 88, NULL, NULL, 202732),
(202733, '3.50.50.60-FF-000193', NULL, 'Protoporphyrinogen oxidase', 493, NULL, NULL, 202733),
(202734, '3.80.10.10-FF-001697', NULL, 'F-box and leucine-rich repeat protein 6', 241, NULL, NULL, 202734),
(202735, '3.30.450.20-FF-000116', NULL, 'period circadian protein homolog 3 isoform X2', 123, NULL, NULL, 202735),
(202736, '3.40.50.1370-FF-000055', NULL, NULL, 159, NULL, NULL, 202736),
(202737, '3.30.470.10-FF-000002', NULL, 'Branched-chain-amino-acid aminotransferase', 177, NULL, NULL, 202737),
(202738, '3.40.50.2300-FF-000166', NULL, 'Galactitol-specific phosphotransferase enzyme IIB component', 93, NULL, NULL, 202738),
(202739, '3.40.50.2000-FF-000519', NULL, 'Lipid-A-disaccharide synthase', 123, NULL, NULL, 202739),
(202740, '3.50.50.60-FF-000535', NULL, 'FAD/NAD(P)-binding domain-containing protein', 129, NULL, NULL, 202740),
(202741, '3.90.1860.10-FF-000012', NULL, 'Uncharacterized protein', 87, NULL, NULL, 202741),
(202742, '3.40.190.10-FF-000366', NULL, 'Ovotransferrin', 156, NULL, NULL, 202742),
(202743, '3.10.196.10-FF-000015', NULL, 'Uncharacterized protein', 73, NULL, NULL, 202743),
(202744, '1.25.10.10-FF-001132', NULL, 'Serum amyloid A-like 1', 223, NULL, NULL, 202744),
(202745, '3.40.47.10-FF-000159', NULL, NULL, 169, NULL, NULL, 202745),
(202746, '2.130.10.10-FF-001730', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit', 253, NULL, NULL, 202746),
(202747, '3.90.1150.10-FF-000273', NULL, 'Class III aminotransferase', 53, NULL, NULL, 202747),
(202748, '1.20.210.10-FF-000038', NULL, 'Uncharacterized protein', 220, NULL, NULL, 202748),
(202749, '3.40.50.150-FF-000882', NULL, 'tRNA wybutosine-synthesizing protein 4', 346, NULL, NULL, 202749),
(202750, '1.20.1440.210-FF-000001', NULL, 'Intraflagellar transport 57', 114, NULL, NULL, 202750),
(202751, '2.60.210.10-FF-000076', NULL, NULL, 137, NULL, NULL, 202751),
(202752, '3.90.226.10-FF-000287', NULL, 'Predicted protein', 199, NULL, NULL, 202752);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(202753, '3.40.50.150-FF-001500', NULL, NULL, 114, NULL, NULL, 202753),
(202754, '3.30.470.20-FF-000005', NULL, 'Acetyl-CoA carboxylase 1', 248, NULL, NULL, 202754),
(202755, '1.20.910.10-FF-000046', NULL, 'Heme oxygenase 2', 113, NULL, NULL, 202755),
(202756, '1.10.390.10-FF-000013', NULL, 'Aminopeptidase N', 253, NULL, NULL, 202756),
(202757, '3.40.50.1360-FF-000052', NULL, 'Ribose-5-phosphate isomerase A', 131, NULL, NULL, 202757),
(202758, '3.30.1370.10-FF-000067', NULL, 'High density lipoprotein binding protein', 72, NULL, NULL, 202758),
(202759, '3.30.1180.20-FF-000010', NULL, 'Uncharacterized protein', 48, NULL, NULL, 202759),
(202760, '3.10.400.20-FF-000033', NULL, 'Eukaryotic translation initiation factor 2D', 110, NULL, NULL, 202760),
(202761, '1.10.3630.10-FF-000009', NULL, 'Golgi phosphoprotein 3-like', 79, NULL, NULL, 202761),
(202762, '3.30.200.20-FF-001019', NULL, 'Uncharacterized protein', 32, NULL, NULL, 202762),
(202763, '3.30.70.330-FF-002667', NULL, NULL, 120, NULL, NULL, 202763),
(202764, '1.10.472.10-FF-000581', NULL, 'Uncharacterized protein', 43, NULL, NULL, 202764),
(202765, '2.60.40.420-FF-000140', NULL, 'Multicopper oxidase', 198, NULL, NULL, 202765),
(202766, '2.10.25.10-FF-001719', NULL, 'Uncharacterized protein', 39, NULL, NULL, 202766),
(202767, '2.40.160.110-FF-000029', NULL, 'Lysosomal-associated membrane protein 2', 110, NULL, NULL, 202767),
(202768, '3.40.309.10-FF-000053', NULL, 'GM25448', 195, NULL, NULL, 202768),
(202769, '1.20.1560.10-FF-000720', NULL, 'ABC transporter', 250, NULL, NULL, 202769),
(202770, '3.10.110.10-FF-000177', NULL, 'RBR-type E3 ubiquitin transferase', 135, NULL, NULL, 202770),
(202771, '3.40.190.10-FF-000708', NULL, 'Sulfonate ABC transporter, periplasmic sulfonate-binding protein', 108, NULL, NULL, 202771),
(202772, '1.10.600.10-FF-000121', NULL, 'Uncharacterized protein', 120, NULL, NULL, 202772),
(202773, '1.20.1270.290-FF-000002', NULL, 'ENL/AF9-related, isoform A', 99, NULL, NULL, 202773),
(202774, '2.40.30.30-FF-000011', NULL, 'Putative riboflavin kinase', 147, NULL, NULL, 202774),
(202775, '1.25.10.10-FF-000856', NULL, 'HEAT repeat domain containing protein', 570, NULL, NULL, 202775),
(202776, '2.30.140.20-FF-000001', NULL, 'Penicillin-binding protein 4', 69, NULL, NULL, 202776),
(202777, '3.30.1490.30-FF-000003', NULL, NULL, 28, NULL, NULL, 202777),
(202778, '3.40.50.2300-FF-001003', NULL, NULL, 128, NULL, NULL, 202778),
(202779, '1.10.510.10-FF-001075', NULL, 'Protein kinase, putative (AFU_orthologue AFUA_2G16620)', 234, NULL, NULL, 202779),
(202780, '2.30.29.70-FF-000008', NULL, 'Uncharacterized protein', 73, NULL, NULL, 202780),
(202781, '3.10.20.10-FF-000043', NULL, '60S ribosomal protein L18a-2', 54, NULL, NULL, 202781),
(202782, '2.10.109.10-FF-000076', NULL, 'Uncharacterized protein', 97, NULL, NULL, 202782),
(202783, '2.60.40.10-FF-001421', NULL, 'Interleukin 9 receptor', 116, NULL, NULL, 202783),
(202784, '2.30.29.30-FF-000244', NULL, 'Tyrosine-protein kinase', 153, NULL, NULL, 202784),
(202785, '3.30.160.20-FF-000015', NULL, 'endoribonuclease Dicer', 67, NULL, NULL, 202785),
(202786, '3.30.160.60-FF-004849', NULL, NULL, 86, NULL, NULL, 202786),
(202787, '3.30.160.60-FF-000797', NULL, 'zinc finger protein 592 isoform X1', 68, NULL, NULL, 202787),
(202788, '3.90.550.50-FF-000198', NULL, 'Hexosyltransferase', 188, NULL, NULL, 202788),
(202789, '1.10.8.10-FF-000130', NULL, 'Elongation factor Ts', 55, NULL, NULL, 202789),
(202790, '3.60.70.12-FF-000001', NULL, 'Arginine biosynthesis bifunctional protein ArgJ, chloroplastic', 271, NULL, NULL, 202790),
(202791, '3.40.50.2000-FF-000290', NULL, 'Glycosyltransferase family 1 protein', 131, NULL, NULL, 202791),
(202792, '3.30.1370.110-FF-000020', NULL, 'Endonuclease MutS2', 83, NULL, NULL, 202792),
(202793, '3.30.160.60-FF-001415', NULL, 'zinc finger protein 282', 27, NULL, NULL, 202793),
(202794, '3.80.10.10-FF-001478', NULL, 'Predicted protein', 161, NULL, NULL, 202794),
(202795, '3.30.160.20-FF-000234', NULL, 'Uncharacterized protein', 89, NULL, NULL, 202795),
(202796, '2.130.10.10-FF-001511', NULL, 'WD repeat domain 11', 151, NULL, NULL, 202796);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(202797, '3.50.50.60-FF-001030', NULL, 'Flavin containing amine oxidase, putative (AFU_orthologue AFUA_8G01470)', 100, NULL, NULL, 202797),
(202798, '3.30.1360.40-FF-000002', NULL, 'DNA gyrase subunit A', 98, NULL, NULL, 202798),
(202799, '2.130.10.10-FF-000893', NULL, 'Dynein intermediate chain 1', 179, NULL, NULL, 202799),
(202800, '3.40.50.2300-FF-000727', NULL, 'Uncharacterized protein', 136, NULL, NULL, 202800),
(202801, '2.60.200.40-FF-000011', NULL, 'diacylglycerol kinase', 187, NULL, NULL, 202801),
(202802, '2.40.30.260-FF-000004', NULL, NULL, 77, NULL, NULL, 202802),
(202803, '3.20.110.10-FF-000017', NULL, 'Alpha-mannosidase D', 335, NULL, NULL, 202803),
(202804, '4.10.410.20-FF-000002', NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase family member 2', 59, NULL, NULL, 202804),
(202805, '1.10.287.370-FF-000061', NULL, 'Prefoldin alpha-like protein', 130, NULL, NULL, 202805),
(202806, '1.20.120.1530-FF-000015', NULL, NULL, 91, NULL, NULL, 202806),
(202807, '2.40.50.90-FF-000108', NULL, 'Uncharacterized protein', 167, NULL, NULL, 202807),
(202808, '3.40.50.300-FF-001910', NULL, 'GTP-binding protein, putative', 199, NULL, NULL, 202808),
(202809, '3.90.70.10-FF-000879', NULL, 'Uncharacterized protein', 303, NULL, NULL, 202809),
(202810, '3.40.50.1910-FF-000037', NULL, 'Vacuolar protein sorting-associated protein 33A', 119, NULL, NULL, 202810),
(202811, '1.10.630.10-FF-000510', NULL, 'Predicted protein', 426, NULL, NULL, 202811),
(202812, '2.120.10.80-FF-000285', NULL, 'Predicted protein', 234, NULL, NULL, 202812),
(202813, '3.20.20.80-FF-000501', NULL, 'Mp65 cell surface mannoprotein', 151, NULL, NULL, 202813),
(202814, '1.25.40.10-FF-001066', NULL, 'Clathrin heavy chain like 1', 55, NULL, NULL, 202814),
(202815, '3.60.20.10-FF-000170', NULL, NULL, 209, NULL, NULL, 202815),
(202816, '3.40.50.1220-FF-000038', NULL, 'NAD-dependent protein deacetylase sirtuin-6 isoform X2', 98, NULL, NULL, 202816),
(202817, '3.40.190.10-FF-000927', NULL, 'Uncharacterized protein', 67, NULL, NULL, 202817),
(202818, '1.10.238.10-FF-000879', NULL, 'Uncharacterized protein', 169, NULL, NULL, 202818),
(202819, '1.10.8.60-FF-000116', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', 62, NULL, NULL, 202819),
(202820, '3.40.50.720-FF-000283', NULL, 'Glyoxylate/hydroxypyruvate reductase HPR3', 106, NULL, NULL, 202820),
(202821, '1.25.10.10-FF-001351', NULL, 'ARM repeat superfamily protein', 277, NULL, NULL, 202821),
(202822, '3.30.160.60-FF-005344', NULL, NULL, 67, NULL, NULL, 202822),
(202823, '3.30.70.330-FF-000650', NULL, 'Polyadenylate-binding protein RBP45', 143, NULL, NULL, 202823),
(202824, '3.40.850.10-FF-000501', NULL, 'Predicted protein', 211, NULL, NULL, 202824),
(202825, '3.40.50.80-FF-000160', NULL, 'Ferredoxin:NADP oxidoreductase, beta subunit', 106, NULL, NULL, 202825),
(202826, '1.20.1050.10-FF-000305', NULL, 'Uncharacterized protein', 33, NULL, NULL, 202826),
(202827, '2.60.120.430-FF-000005', NULL, 'Putative receptor-like protein kinase', 149, NULL, NULL, 202827),
(202828, '3.30.160.60-FF-001073', NULL, 'zinc finger protein 182', 27, NULL, NULL, 202828),
(202829, '3.50.50.60-FF-000754', NULL, 'Uncharacterized protein', 125, NULL, NULL, 202829),
(202830, '1.25.40.20-FF-001069', NULL, 'Uncharacterized protein', 101, NULL, NULL, 202830),
(202831, '2.10.25.10-FF-000292', NULL, 'Matrilin 2', 38, NULL, NULL, 202831),
(202832, '1.20.1250.20-FF-000278', NULL, 'Putative MFS transporter', 210, NULL, NULL, 202832),
(202833, '1.10.238.10-FF-001155', NULL, 'Uncharacterized protein', 115, NULL, NULL, 202833),
(202834, '3.40.50.2300-FF-000385', NULL, 'Low molecular weight phosphotyrosine protein phosphatase, putative', 136, NULL, NULL, 202834),
(202835, '1.25.40.420-FF-000010', NULL, 'Kelch-like family member 14', 101, NULL, NULL, 202835),
(202836, '1.20.59.10-FF-000001', NULL, 'T-protein', 80, NULL, NULL, 202836),
(202837, '1.25.40.10-FF-002825', NULL, 'Bardet-Biedl syndrome 4 protein, putative', 146, NULL, NULL, 202837),
(202838, '3.40.50.720-FF-001615', NULL, 'Uncharacterized protein', 113, NULL, NULL, 202838); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(202839, '3.40.47.10-FF-000087', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 3', 327, NULL, NULL, 202839),
(202840, '1.10.8.10-FF-000097', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 54, NULL, NULL, 202840),
(202841, '1.50.10.10-FF-000225', NULL, 'Uncharacterized protein', 375, NULL, NULL, 202841),
(202842, '3.90.70.10-FF-000296', NULL, 'Putative calpain-like cysteine peptidase', 152, NULL, NULL, 202842),
(202843, '1.20.1250.10-FF-000063', NULL, 'Chorionic somatomammotropin hormone', 129, NULL, NULL, 202843),
(202844, '2.20.25.10-FF-000011', NULL, 'peptide-N(4)-(N-acetyl-beta- glucosaminyl)asparagine amidase', 49, NULL, NULL, 202844),
(202845, '1.20.1270.60-FF-000028', NULL, 'Bridging integrator 3 homolog', 210, NULL, NULL, 202845),
(202846, '2.10.260.10-FF-000001', NULL, 'Stage V sporulation protein T', 51, NULL, NULL, 202846),
(202847, '2.170.8.10-FF-000009', NULL, 'Phosphoenolpyruvate carboxykinase', 117, NULL, NULL, 202847),
(202848, '1.20.58.60-FF-000172', NULL, 'Spectrin beta chain', 121, NULL, NULL, 202848),
(202849, '3.10.110.10-FF-000099', NULL, 'Ubiquitin-conjugating enzyme E2 E3', 154, NULL, NULL, 202849),
(202850, '2.60.40.2240-FF-000009', NULL, 'Uncharacterized protein', 66, NULL, NULL, 202850),
(202851, '1.10.1300.10-FF-000075', NULL, 'Predicted protein', 50, NULL, NULL, 202851),
(202852, '3.90.1640.10-FF-000030', NULL, 'Uncharacterized protein', 189, NULL, NULL, 202852),
(202853, '3.40.50.2300-FF-000380', NULL, 'Uncharacterized protein', 265, NULL, NULL, 202853),
(202854, '1.25.40.1030-FF-000022', NULL, 'Protein transport protein SEC31 B', 361, NULL, NULL, 202854),
(202855, '3.80.10.10-FF-002726', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 320, NULL, NULL, 202855),
(202856, '2.40.70.10-FF-000536', NULL, NULL, 192, NULL, NULL, 202856),
(202857, '2.30.29.30-FF-001009', NULL, 'Peptidase', 121, NULL, NULL, 202857),
(202858, '3.90.226.10-FF-000147', NULL, 'Carbamoyl-phosphate synthase/carboxyl transferase', 273, NULL, NULL, 202858),
(202859, '3.30.70.330-FF-003039', NULL, NULL, 128, NULL, NULL, 202859),
(202860, '3.30.930.10-FF-000010', NULL, 'Glycyl-tRNA synthetase 1', 279, NULL, NULL, 202860),
(202861, '6.10.250.3410-FF-000002', NULL, 'DBF4 zinc finger', 29, NULL, NULL, 202861),
(202862, '3.30.160.60-FF-002591', NULL, NULL, 29, NULL, NULL, 202862),
(202863, '1.20.90.10-FF-000035', NULL, NULL, 86, NULL, NULL, 202863),
(202864, '1.25.40.10-FF-000937', NULL, 'Os08g0162200 protein', 101, NULL, NULL, 202864),
(202865, '3.40.50.300-FF-004126', NULL, 'DNA-dependent ATPase (MGS1), putative', 163, NULL, NULL, 202865),
(202866, '2.40.50.1070-FF-000023', NULL, NULL, 151, NULL, NULL, 202866),
(202867, '3.80.20.20-FF-000083', NULL, 'Predicted protein', 120, NULL, NULL, 202867),
(202868, '3.30.160.60-FF-005345', NULL, NULL, 67, NULL, NULL, 202868),
(202869, '3.90.190.10-FF-000170', NULL, 'Protein tyrosine phosphatase', 237, NULL, NULL, 202869),
(202870, '3.40.50.80-FF-000115', NULL, 'Ferric reductase transmembrane component, putative', 177, NULL, NULL, 202870),
(202871, '3.40.50.10490-FF-000048', NULL, 'Glucose-6-phosphate isomerase', 96, NULL, NULL, 202871),
(202872, '2.70.150.10-FF-000041', NULL, 'Calcium-transporting ATPase 1', 53, NULL, NULL, 202872),
(202873, '2.60.40.10-FF-000578', NULL, 'Leukemia inhibitory factor receptor', 81, NULL, NULL, 202873),
(202874, '3.30.710.10-FF-000319', NULL, 'AGAP001646-PA', 149, NULL, NULL, 202874),
(202875, '2.40.50.40-FF-000049', NULL, 'Uncharacterized protein', 57, NULL, NULL, 202875),
(202876, '1.25.10.10-FF-000317', NULL, 'RING-type E3 ubiquitin transferase', 299, NULL, NULL, 202876),
(202877, '1.25.40.10-FF-001926', NULL, 'RNA polymerase-associated protein CTR9', 345, NULL, NULL, 202877),
(202878, '3.90.550.10-FF-000153', NULL, 'Putative glycosyl transferase', 230, NULL, NULL, 202878),
(202879, '3.30.565.10-FF-000397', NULL, 'Histidine kinase', 138, NULL, NULL, 202879),
(202880, '3.60.10.10-FF-000119', NULL, 'Probable exported protein', 261, NULL, NULL, 202880),
(202881, '2.40.37.10-FF-000009', NULL, 'antizyme inhibitor 2 isoform X1', 145, NULL, NULL, 202881);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(202882, '3.40.50.620-FF-000422', NULL, 'Putative tyrosyl-tRNA synthetase', 48, NULL, NULL, 202882),
(202883, '1.10.287.130-FF-000012', NULL, 'Histidine kinase', 58, NULL, NULL, 202883),
(202884, '2.60.40.820-FF-000030', NULL, 'Uncharacterized protein', 46, NULL, NULL, 202884),
(202885, '3.40.50.10190-FF-000109', NULL, 'Regulator of Ty1 transposition', 131, NULL, NULL, 202885),
(202886, '3.30.160.60-FF-001163', NULL, 'zinc finger protein 182 isoform X1', 27, NULL, NULL, 202886),
(202887, '1.20.5.340-FF-000030', NULL, 'Putative transcriptional repressor TUP1', 79, NULL, NULL, 202887),
(202888, '3.20.190.20-FF-000003', NULL, 'Protease Do-like 2, chloroplastic', 150, NULL, NULL, 202888),
(202889, '1.25.40.10-FF-002062', NULL, 'Pentatricopeptide (PPR) repeat-containing protein', 67, NULL, NULL, 202889),
(202890, '1.10.225.10-FF-000030', NULL, 'Prosaposin (variant Gaucher disease and variant metachromatic leukodystrophy)', 81, NULL, NULL, 202890),
(202891, '3.30.200.20-FF-001346', NULL, 'Leucine-rich repeat receptor protein kinase MSP1', 105, NULL, NULL, 202891),
(202892, '2.60.120.310-FF-000010', NULL, 'tyramine beta-hydroxylase', 161, NULL, NULL, 202892),
(202893, '1.10.560.10-FF-000112', NULL, 'Uncharacterized protein', 68, NULL, NULL, 202893),
(202894, '3.30.70.330-FF-000285', NULL, 'Polyadenylate-binding protein', 74, NULL, NULL, 202894),
(202895, '3.40.50.1820-FF-000803', NULL, 'Steryl ester hydrolase, putative', 394, NULL, NULL, 202895),
(202896, '2.10.25.10-FF-000152', NULL, 'FAT atypical cadherin 1', 37, NULL, NULL, 202896),
(202897, '1.20.1270.10-FF-000007', NULL, 'Heat shock protein, mitochondrial', 90, NULL, NULL, 202897),
(202898, '3.40.50.1700-FF-000060', NULL, 'Uncharacterized protein', 268, NULL, NULL, 202898),
(202899, '3.20.20.140-FF-000226', NULL, 'Amidohydrolase family protein', 268, NULL, NULL, 202899),
(202900, '2.130.10.10-FF-003636', NULL, 'Uncharacterized protein', 156, NULL, NULL, 202900),
(202901, '2.60.40.10-FF-000106', NULL, 'Neogenin isoform 1', 100, NULL, NULL, 202901),
(202902, '1.25.10.10-FF-000789', NULL, 'AP complex subunit beta', 132, NULL, NULL, 202902),
(202903, '2.60.40.420-FF-000146', NULL, 'Quinol oxidase subunit 2', 117, NULL, NULL, 202903),
(202904, '3.40.50.800-FF-000032', NULL, 'Proline--tRNA ligase', 108, NULL, NULL, 202904),
(202905, '3.30.50.10-FF-000016', NULL, 'Nuclear receptor subfamily 2 group F member 1', 93, NULL, NULL, 202905),
(202906, '1.10.10.60-FF-000219', NULL, 'LIM/homeobox protein Lhx3', 64, NULL, NULL, 202906),
(202907, '1.10.150.20-FF-000128', NULL, 'DNA-directed RNA polymerase', 190, NULL, NULL, 202907),
(202908, '3.40.50.300-FF-004598', NULL, 'RNA helicase', 146, NULL, NULL, 202908),
(202909, '3.30.70.141-FF-000004', NULL, 'Nucleoside diphosphate kinase 7', 142, NULL, NULL, 202909),
(202910, '3.30.450.20-FF-000549', NULL, 'Putative nitrogen regulation protein NtrY', 123, NULL, NULL, 202910),
(202911, '3.30.420.40-FF-000907', NULL, 'Chromosome 10, whole genome shotgun sequence', 72, NULL, NULL, 202911),
(202912, '1.20.1420.30-FF-000082', NULL, 'Uncharacterized protein', 141, NULL, NULL, 202912),
(202913, '3.20.20.100-FF-000034', NULL, 'Chromosome 7, whole genome shotgun sequence', 317, NULL, NULL, 202913),
(202914, '1.10.510.10-FF-000873', NULL, 'Serine/threonine-protein kinase VHS1', 307, NULL, NULL, 202914),
(202915, '2.130.10.10-FF-001658', NULL, 'CPSF_A_subunit_region_containing_protein', 431, NULL, NULL, 202915),
(202916, '2.20.25.30-FF-000017', NULL, 'Uncharacterized protein', 50, NULL, NULL, 202916),
(202917, '3.40.50.150-FF-001658', NULL, NULL, 194, NULL, NULL, 202917),
(202918, '3.40.50.410-FF-000005', NULL, '26S proteasome non-ATPase regulatory subunit 4', 184, NULL, NULL, 202918),
(202919, '1.25.40.10-FF-003490', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 77, NULL, NULL, 202919),
(202920, '3.60.21.10-FF-000408', NULL, 'Serine/threonine-protein phosphatase', 412, NULL, NULL, 202920),
(202921, '2.170.150.10-FF-000028', NULL, 'Uncharacterized protein', 61, NULL, NULL, 202921),
(202922, '3.40.50.620-FF-000894', NULL, 'Isoleucine--tRNA ligase, cytoplasmic', 88, NULL, NULL, 202922);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(202923, '2.60.40.10-FF-001534', NULL, 'Signal regulatory protein beta 2', 116, NULL, NULL, 202923),
(202924, '1.50.40.10-FF-000053', NULL, 'Mitochondrial DNA replication protein', 179, NULL, NULL, 202924),
(202925, '1.20.58.1100-FF-000008', NULL, 'Unc-13 homolog A', 169, NULL, NULL, 202925),
(202926, '3.40.50.720-FF-000626', NULL, 'D3-phosphoglycerate dehydrogenase, putative', 105, NULL, NULL, 202926),
(202927, '3.90.70.80-FF-000064', NULL, 'Uncharacterized protein', 62, NULL, NULL, 202927),
(202928, '3.40.50.2300-FF-000228', NULL, 'Guanylate cyclase', 163, NULL, NULL, 202928),
(202929, '1.20.120.80-FF-000013', NULL, 'Cytochrome c oxidase subunit I+III', 184, NULL, NULL, 202929),
(202930, '1.25.10.10-FF-001745', NULL, 'AaceriAFR269Wp', 998, NULL, NULL, 202930),
(202931, '1.10.10.10-FF-001626', NULL, 'Target Of ERK kinase MPK-1', 98, NULL, NULL, 202931),
(202932, '2.10.25.10-FF-001580', NULL, 'Fibrillin 2', 28, NULL, NULL, 202932),
(202933, '2.60.40.150-FF-000222', NULL, 'SyNapTotagmin', 128, NULL, NULL, 202933),
(202934, '3.80.10.10-FF-000309', NULL, 'Leucine-rich repeat-containing protein 55', 118, NULL, NULL, 202934),
(202935, '3.30.1490.80-FF-000035', NULL, 'Os12g0528400 protein', 18, NULL, NULL, 202935),
(202936, '1.25.40.10-FF-004832', NULL, 'Crooked neck protein-related protein', 145, NULL, NULL, 202936),
(202937, '1.20.58.530-FF-000030', NULL, 'Probable chitin synthase 8', 22, NULL, NULL, 202937),
(202938, '1.10.3730.20-FF-000009', NULL, 'EamA family transporter', 141, NULL, NULL, 202938),
(202939, '2.130.10.10-FF-005553', NULL, 'Uncharacterized protein', 221, NULL, NULL, 202939),
(202940, '1.20.1070.10-FF-001807', NULL, 'Uncharacterized protein', 314, NULL, NULL, 202940),
(202941, '3.40.630.10-FF-000120', NULL, 'Peptidase M20 domain-containing protein 2', 224, NULL, NULL, 202941),
(202942, '3.40.50.150-FF-000410', NULL, 'S-adenosyl-L-methionine-dependent methyltransferase', 264, NULL, NULL, 202942),
(202943, '2.10.110.10-FF-000226', NULL, 'Uncharacterized protein', 72, NULL, NULL, 202943),
(202944, '1.20.1250.20-FF-001381', NULL, 'Putative metabolite transport protein HI_1104', 192, NULL, NULL, 202944),
(202945, '3.30.70.330-FF-000605', NULL, 'Splicing factor U2AF 65 kDa subunit', 125, NULL, NULL, 202945),
(202946, '3.40.720.10-FF-000239', NULL, 'Uncharacterized protein', 341, NULL, NULL, 202946),
(202947, '2.40.50.140-FF-001136', NULL, NULL, 110, NULL, NULL, 202947),
(202948, '3.30.460.10-FF-000165', NULL, 'DNA polymerase', 137, NULL, NULL, 202948),
(202949, '1.25.10.30-FF-000003', NULL, 'Protein CBR-ITR-1, isoform a', 171, NULL, NULL, 202949),
(202950, '3.30.40.10-FF-002168', NULL, 'AT Hook plus PHD finger transcription factor', 84, NULL, NULL, 202950),
(202951, '1.10.3120.10-FF-000005', NULL, 'Trigger factor', 213, NULL, NULL, 202951),
(202952, '2.40.50.770-FF-000015', NULL, 'RecQ mediated genome instability protein Rmi1', 166, NULL, NULL, 202952),
(202953, '3.40.50.300-FF-005115', NULL, 'Phosphonates import ATP-binding protein PhnC 2', 256, NULL, NULL, 202953),
(202954, '1.10.506.10-FF-000003', NULL, 'Plexin A2', 425, NULL, NULL, 202954),
(202955, '3.30.1370.210-FF-000017', NULL, 'Zinc finger C-x8-C-x5-C-x3-H type (And similar), putative', 75, NULL, NULL, 202955),
(202956, '1.10.1000.11-FF-000008', NULL, 'F-box only protein 8', 108, NULL, NULL, 202956),
(202957, '2.30.30.490-FF-000065', NULL, 'Origin recognition complex subunit 1', 161, NULL, NULL, 202957),
(202958, '2.30.29.30-FF-000233', NULL, 'rhotekin isoform X3', 112, NULL, NULL, 202958),
(202959, '3.90.650.10-FF-000037', NULL, 'Hydrogenase expression/formation protein hypE', 182, NULL, NULL, 202959),
(202960, '3.30.420.150-FF-000013', NULL, 'Exopolyphosphatase', 180, NULL, NULL, 202960),
(202961, '1.10.246.90-FF-000001', NULL, 'Nucleolar protein 56', 113, NULL, NULL, 202961),
(202962, '3.30.40.10-FF-001679', NULL, 'Uncharacterized protein', 74, NULL, NULL, 202962),
(202963, '2.40.30.10-FF-000270', NULL, 'Flavodoxin family protein', 74, NULL, NULL, 202963),
(202964, '2.120.10.30-FF-000557', NULL, 'Senescence marker protein-30, putative', 74, NULL, NULL, 202964);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(202965, '1.25.10.10-FF-001306', NULL, '26S proteasome regulatory subunit', 96, NULL, NULL, 202965),
(202966, '1.10.510.10-FF-000401', NULL, 'serine/threonine-protein kinase haspin', 187, NULL, NULL, 202966),
(202967, '2.30.30.140-FF-000044', NULL, 'AT-rich interactive domain-containing protein 4B isoform X1', 115, NULL, NULL, 202967),
(202968, '3.40.50.300-FF-006104', NULL, 'Mismatch repair ATPase Msh2', 305, NULL, NULL, 202968),
(202969, '2.60.40.10-FF-002995', NULL, 'Uncharacterized protein', 116, NULL, NULL, 202969),
(202970, '2.30.30.40-FF-000627', NULL, 'MAGUK p55 subfamily member 7', 14, NULL, NULL, 202970),
(202971, '3.80.10.10-FF-003715', NULL, 'Uncharacterized protein', 149, NULL, NULL, 202971),
(202972, '4.10.1000.10-FF-000095', NULL, 'C3H-type transcription factor', 65, NULL, NULL, 202972),
(202973, '4.10.410.10-FF-000045', NULL, 'Collagen type XXVIII alpha 1 a', 64, NULL, NULL, 202973),
(202974, '1.10.150.50-FF-000143', NULL, 'Predicted protein', 62, NULL, NULL, 202974),
(202975, '1.20.120.1750-FF-000104', NULL, 'Protein CBG09610', 103, NULL, NULL, 202975),
(202976, '2.130.10.10-FF-000882', NULL, 'Syntaxin-binding protein 5', 138, NULL, NULL, 202976),
(202977, '3.30.160.60-FF-000174', NULL, 'Transcriptional repressor protein YY1', 31, NULL, NULL, 202977),
(202978, '1.20.1070.10-FF-000818', NULL, 'AGAP011380-PA', 187, NULL, NULL, 202978),
(202979, '3.90.550.20-FF-000010', NULL, 'Unplaced genomic scaffold supercont2.19, whole genome shotgun sequence', 177, NULL, NULL, 202979),
(202980, '1.25.10.10-FF-002234', NULL, 'Uncharacterized protein', 384, NULL, NULL, 202980),
(202981, '1.10.10.60-FF-000871', NULL, NULL, 54, NULL, NULL, 202981),
(202982, '3.40.50.720-FF-001262', NULL, 'UDP-glucose 4-epimerase', 224, NULL, NULL, 202982),
(202983, '1.10.10.10-FF-000637', NULL, 'Histone H1.2', 81, NULL, NULL, 202983),
(202984, '3.90.1010.20-FF-000002', NULL, NULL, 95, NULL, NULL, 202984),
(202985, '3.40.50.2000-FF-000228', NULL, 'UDP-GlucuronosylTransferase', 216, NULL, NULL, 202985),
(202986, '3.90.190.10-FF-000018', NULL, 'Tyrosine-protein phosphatase non-receptor type', 308, NULL, NULL, 202986),
(202987, '3.30.420.40-FF-000115', NULL, 'Pantothenate kinase PanK', 190, NULL, NULL, 202987),
(202988, '3.30.160.60-FF-003900', NULL, 'HKR1, GLI-Kruppel zinc finger family member', 35, NULL, NULL, 202988),
(202989, '2.160.20.10-FF-000224', NULL, 'Os05g0578600 protein', 267, NULL, NULL, 202989),
(202990, '2.40.50.140-FF-000147', NULL, 'DNA helicase', 77, NULL, NULL, 202990),
(202991, '1.20.120.350-FF-000003', NULL, 'Voltage-dependent sodium channel', 127, NULL, NULL, 202991),
(202992, '3.90.70.10-FF-000649', NULL, 'Ubiquitinyl hydrolase 1', 88, NULL, NULL, 202992),
(202993, '3.30.160.20-FF-000010', NULL, 'Peptide chain release factor 2', 96, NULL, NULL, 202993),
(202994, '1.10.287.1490-FF-000022', NULL, 'Phosphatidylinositol 3-kinase regulatory subunit beta', 147, NULL, NULL, 202994),
(202995, '2.10.25.10-FF-000591', NULL, 'Protein eyes shut homolog', 42, NULL, NULL, 202995),
(202996, '2.60.120.290-FF-000195', NULL, 'AGAP005526-PA', 123, NULL, NULL, 202996),
(202997, '3.30.40.10-FF-001179', NULL, 'Uncharacterized protein', 66, NULL, NULL, 202997),
(202998, '1.10.555.10-FF-000223', NULL, NULL, 167, NULL, NULL, 202998),
(202999, '2.60.120.260-FF-000652', NULL, 'Uncharacterized protein', 92, NULL, NULL, 202999),
(203000, '3.40.630.40-FF-000016', NULL, 'N-acetylmuramoyl-L-alanine amidase', 188, NULL, NULL, 203000),
(203001, '3.40.50.1000-FF-000237', NULL, 'Putative nuclear LIM factor interactor-interacting protein hyphal form', 194, NULL, NULL, 203001),
(203002, '1.20.1070.10-FF-000970', NULL, 'Serotonin receptor 5-HT1a', 89, NULL, NULL, 203002),
(203003, '3.40.50.300-FF-001372', NULL, 'ATP-dependent DNA helicase chl1', 211, NULL, NULL, 203003),
(203004, '2.10.70.10-FF-000015', NULL, 'CYR61 isoform 1', 32, NULL, NULL, 203004),
(203005, '2.60.40.10-FF-003951', NULL, NULL, 105, NULL, NULL, 203005),
(203006, '3.90.1720.10-FF-000031', NULL, 'Gifsy-1 prophage VtaK', 135, NULL, NULL, 203006),
(203007, '3.30.428.10-FF-000068', NULL, 'Uncharacterized protein', 159, NULL, NULL, 203007);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(203008, '3.30.420.10-FF-000039', NULL, 'Target of EGR1 protein 1', 245, NULL, NULL, 203008),
(203009, '1.10.167.10-FF-000041', NULL, 'Regulator of G-protein signaling rgs-5', 138, NULL, NULL, 203009),
(203010, '1.10.287.600-FF-000024', NULL, 'Tubulin beta chain', 50, NULL, NULL, 203010),
(203011, '2.60.40.690-FF-000002', NULL, 'Complement C4 isoform-A', 131, NULL, NULL, 203011),
(203012, '2.60.40.10-FF-004440', NULL, NULL, 77, NULL, NULL, 203012),
(203013, '3.90.228.20-FF-000019', NULL, NULL, 55, NULL, NULL, 203013),
(203014, '1.25.40.10-FF-005288', NULL, 'SET and MYND domain containing 1b', 140, NULL, NULL, 203014),
(203015, '3.20.20.80-FF-000569', NULL, 'Glucosylceramidase', 203, NULL, NULL, 203015),
(203016, '3.30.160.60-FF-001955', NULL, 'Jim, isoform G', 37, NULL, NULL, 203016),
(203017, '2.80.10.50-FF-000020', NULL, 'Fibroblast growth factor 1', 144, NULL, NULL, 203017),
(203018, '3.20.20.70-FF-000420', NULL, 'Uncharacterized protein', 144, NULL, NULL, 203018),
(203019, '3.40.718.10-FF-000003', NULL, 'Isocitrate dehydrogenase [NAD] subunit, mitochondrial', 344, NULL, NULL, 203019),
(203020, '1.10.10.60-FF-001208', NULL, NULL, 82, NULL, NULL, 203020),
(203021, '3.10.100.10-FF-000334', NULL, NULL, 86, NULL, NULL, 203021),
(203022, '3.30.160.40-FF-000016', NULL, 'Porphobilinogen deaminase', 81, NULL, NULL, 203022),
(203023, '3.30.160.60-FF-003580', NULL, 'Zinc finger protein 813', 27, NULL, NULL, 203023),
(203024, '3.30.260.10-FF-000037', NULL, 'Chaperonin TCP20, putative', 106, NULL, NULL, 203024),
(203025, '3.40.366.10-FF-000062', NULL, 'Fatty acid synthase', 35, NULL, NULL, 203025),
(203026, '1.10.10.10-FF-001126', NULL, 'Two-component system response regulator MprA', 108, NULL, NULL, 203026),
(203027, '2.10.25.10-FF-001080', NULL, 'Neurogenic locus protein delta', 41, NULL, NULL, 203027),
(203028, '2.60.40.340-FF-000009', NULL, 'Nuclear factor of activated T-cells, cytoplasmic 3', 114, NULL, NULL, 203028),
(203029, '2.130.10.10-FF-004564', NULL, 'Predicted protein', 215, NULL, NULL, 203029),
(203030, '1.25.40.10-FF-003051', NULL, 'Pentatricopeptide repeat-containing protein At3g60960, mitochondrial', 79, NULL, NULL, 203030),
(203031, '1.10.555.10-FF-000162', NULL, 'Mental retardation GTPase activating protein homolog 1', 251, NULL, NULL, 203031),
(203032, '1.10.532.10-FF-000007', NULL, 'Signal transducer and activator of transcription', 128, NULL, NULL, 203032),
(203033, '2.40.50.150-FF-000004', NULL, 'DNA-directed RNA polymerase subunit beta', 125, NULL, NULL, 203033),
(203034, '2.60.120.330-FF-000049', NULL, 'Probable iron/ascorbate oxidoreductase', 333, NULL, NULL, 203034),
(203035, '1.25.40.10-FF-004799', NULL, 'Anaphase-promoting complex subunit 3', 170, NULL, NULL, 203035),
(203036, '2.60.40.60-FF-001116', NULL, 'Predicted protein', 32, NULL, NULL, 203036),
(203037, '1.20.1250.20-FF-000392', NULL, 'Solute carrier organic anion transporter family member', 217, NULL, NULL, 203037),
(203038, '3.30.200.20-FF-000357', NULL, 'serine/threonine-protein kinase-like protein CCR1', 109, NULL, NULL, 203038),
(203039, '3.10.50.30-FF-000012', NULL, 'Transcription elongation factor GreB', 79, NULL, NULL, 203039),
(203040, '2.130.10.10-FF-001219', NULL, 'Sortilin-related VPS10 domain-containing receptor 3', 143, NULL, NULL, 203040),
(203041, '1.10.510.10-FF-001862', NULL, 'Probable serine/threonine-protein kinase zyg-1', 292, NULL, NULL, 203041),
(203042, '3.20.100.10-FF-000017', NULL, 'Putative RNA triphosphatase', 226, NULL, NULL, 203042),
(203043, '2.130.10.30-FF-000096', NULL, NULL, 114, NULL, NULL, 203043),
(203044, '2.10.110.10-FF-000198', NULL, 'Uncharacterized protein', 55, NULL, NULL, 203044),
(203045, '3.30.160.60-FF-000202', NULL, 'Zinc finger protein 574', 29, NULL, NULL, 203045),
(203046, '3.40.390.10-FF-000084', NULL, 'Zinc metalloproteinase', 261, NULL, NULL, 203046),
(203047, '2.60.40.10-FF-004940', NULL, NULL, 62, NULL, NULL, 203047),
(203048, '1.10.10.1760-FF-000012', NULL, 'Uncharacterized protein', 105, NULL, NULL, 203048),
(203049, '3.30.420.10-FF-000539', NULL, NULL, 83, NULL, NULL, 203049);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(203050, '1.25.40.20-FF-000002', NULL, 'Ankyrin-2 isoform 2', 286, NULL, NULL, 203050),
(203051, '2.30.30.40-FF-000599', NULL, 'Uncharacterized protein', 58, NULL, NULL, 203051),
(203052, '2.30.42.10-FF-000191', NULL, 'Serine protease', 102, NULL, NULL, 203052),
(203053, '1.50.10.20-FF-000054', NULL, 'Os03g0193700 protein', 108, NULL, NULL, 203053),
(203054, '3.30.160.60-FF-003080', NULL, 'Uncharacterized protein', 31, NULL, NULL, 203054),
(203055, '1.25.40.20-FF-000474', NULL, 'Poly [ADP-ribose] polymerase', 55, NULL, NULL, 203055),
(203056, '3.40.850.10-FF-000423', NULL, 'Uncharacterized protein', 185, NULL, NULL, 203056),
(203057, '3.30.310.230-FF-000001', NULL, 'Sigma factor-binding protein Crl', 133, NULL, NULL, 203057),
(203058, '1.25.40.10-FF-005316', NULL, 'Pentatricopeptide repeat-containing protein At5g62370', 118, NULL, NULL, 203058),
(203059, '3.40.50.300-FF-007532', NULL, 'Uncharacterized protein', 301, NULL, NULL, 203059),
(203060, '1.25.40.10-FF-002854', NULL, 'Mitochondrial group I intron splicing factor CCM1', 108, NULL, NULL, 203060),
(203061, '3.80.10.10-FF-003215', NULL, 'DNA repair protein rhp7', 369, NULL, NULL, 203061),
(203062, '1.20.5.110-FF-000219', NULL, 'Syntaxin', 106, NULL, NULL, 203062),
(203063, '3.30.460.20-FF-000022', NULL, 'YALI0D00319p', 147, NULL, NULL, 203063),
(203064, '3.40.50.720-FF-002251', NULL, 'Uncharacterized protein', 257, NULL, NULL, 203064),
(203065, '1.25.40.20-FF-001755', NULL, 'Uncharacterized protein', 200, NULL, NULL, 203065),
(203066, '3.90.105.10-FF-000029', NULL, 'Molybdopterin molybdenumtransferase', 52, NULL, NULL, 203066),
(203067, '4.10.60.10-FF-000257', NULL, 'DNA topoisomerase', 33, NULL, NULL, 203067),
(203068, '1.20.1070.10-FF-001307', NULL, 'Uncharacterized protein', 185, NULL, NULL, 203068),
(203069, '3.30.200.20-FF-001846', NULL, 'Predicted protein', 96, NULL, NULL, 203069),
(203070, '3.30.70.370-FF-000038', NULL, NULL, 42, NULL, NULL, 203070),
(203071, '1.10.510.10-FF-003127', NULL, NULL, 186, NULL, NULL, 203071),
(203072, '3.40.50.1820-FF-001000', NULL, 'Putative serine esterase', 234, NULL, NULL, 203072),
(203073, '2.60.120.10-FF-000558', NULL, 'cAMP-dependent protein kinase type II-alpha regulatory subunit', 150, NULL, NULL, 203073),
(203074, '3.40.50.11530-FF-000012', NULL, 'Uncharacterized protein', 169, NULL, NULL, 203074),
(203075, '2.40.10.350-FF-000016', NULL, 'Uncharacterized protein', 75, NULL, NULL, 203075),
(203076, '3.40.50.150-FF-001719', NULL, NULL, 195, NULL, NULL, 203076),
(203077, '3.70.10.10-FF-000130', NULL, 'DNA repair protein rad9', 300, NULL, NULL, 203077),
(203078, '3.80.10.10-FF-000461', NULL, 'Uncharacterized protein, isoform B', 255, NULL, NULL, 203078),
(203079, '1.25.40.20-FF-001463', NULL, 'Uncharacterized protein', 116, NULL, NULL, 203079),
(203080, '1.10.287.110-FF-000265', NULL, 'WGS project CABT00000000 data, contig 2.17', 92, NULL, NULL, 203080),
(203081, '1.10.8.60-FF-000179', NULL, 'Ribosome biogenesis ATPase RIX7', 81, NULL, NULL, 203081),
(203082, '3.30.70.330-FF-002522', NULL, NULL, 60, NULL, NULL, 203082),
(203083, '3.40.50.140-FF-000020', NULL, 'DNA topoisomerase III', 105, NULL, NULL, 203083),
(203084, '3.100.10.10-FF-000054', NULL, NULL, 86, NULL, NULL, 203084),
(203085, '1.10.630.10-FF-000348', NULL, 'Predicted protein', 476, NULL, NULL, 203085),
(203086, '1.25.10.10-FF-002734', NULL, 'Uncharacterized protein', 845, NULL, NULL, 203086),
(203087, '2.60.120.590-FF-000048', NULL, 'YALI0D07546p', 226, NULL, NULL, 203087),
(203088, '1.20.1250.10-FF-000124', NULL, NULL, 132, NULL, NULL, 203088),
(203089, '2.130.10.10-FF-002147', NULL, 'Plexin A4', 59, NULL, NULL, 203089),
(203090, '2.20.110.10-FF-000061', NULL, NULL, 45, NULL, NULL, 203090),
(203091, '3.40.250.10-FF-000074', NULL, 'Thiosulfate sulfurtransferase like domain containing 1', 73, NULL, NULL, 203091),
(203092, '2.60.120.260-FF-000360', NULL, 'Cellulose synthase', 143, NULL, NULL, 203092),
(203093, '1.10.510.10-FF-001070', NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-like 1.5', 211, NULL, NULL, 203093);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(203094, '3.40.50.300-FF-006043', NULL, 'ATP-dependent DNA helicase', 257, NULL, NULL, 203094),
(203095, '3.10.290.10-FF-000055', NULL, 'Tyrosine--tRNA ligase', 68, NULL, NULL, 203095),
(203096, '1.10.238.10-FF-001257', NULL, 'Tubulin polymerization-promoting protein family member 3', 64, NULL, NULL, 203096),
(203097, '1.10.238.10-FF-000301', NULL, 'EF-hand calcium-binding protein', 74, NULL, NULL, 203097),
(203098, '1.10.10.750-FF-000029', NULL, 'TBC domain containing protein', 56, NULL, NULL, 203098),
(203099, '3.40.50.1000-FF-000737', NULL, NULL, 59, NULL, NULL, 203099),
(203100, '1.10.510.10-FF-001362', NULL, 'Serine/threonine protein kinase, putative', 335, NULL, NULL, 203100),
(203101, '1.10.472.10-FF-000328', NULL, 'Cdk activating kinase (CAK)/RNA polymerase II transcription initiation/nucleotide excision repair factor TFIIH/TFIIK, cyclin H subunit', 113, NULL, NULL, 203101),
(203102, '2.60.40.10-FF-003512', NULL, NULL, 85, NULL, NULL, 203102),
(203103, '3.90.1150.160-FF-000008', NULL, 'Glutamate decarboxylase', 87, NULL, NULL, 203103),
(203104, '2.60.120.200-FF-000741', NULL, 'Uncharacterized protein', 157, NULL, NULL, 203104),
(203105, '3.30.160.60-FF-005406', NULL, NULL, 44, NULL, NULL, 203105),
(203106, '1.10.10.10-FF-000137', NULL, 'Zinc uptake transcriptional repressor', 88, NULL, NULL, 203106),
(203107, '3.40.50.2000-FF-000728', NULL, 'Lipid-A-disaccharide synthase', 112, NULL, NULL, 203107),
(203108, '1.10.10.10-FF-001565', NULL, 'Two-component response regulator', 59, NULL, NULL, 203108),
(203109, '3.40.50.970-FF-000004', NULL, 'Transketolase', 332, NULL, NULL, 203109),
(203110, '3.50.50.60-FF-001216', NULL, 'Uncharacterized protein', 290, NULL, NULL, 203110),
(203111, '3.40.50.1820-FF-000775', NULL, 'AGAP000687-PA', 280, NULL, NULL, 203111),
(203112, '3.40.50.1980-FF-000126', NULL, 'ABC transporter substrate-binding protein', 156, NULL, NULL, 203112),
(203113, '1.20.120.1750-FF-000076', NULL, 'RBR-type E3 ubiquitin transferase', 55, NULL, NULL, 203113),
(203114, '1.10.510.10-FF-003599', NULL, NULL, 204, NULL, NULL, 203114),
(203115, '1.25.40.10-FF-001573', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 96, NULL, NULL, 203115),
(203116, '3.40.50.300-FF-004659', NULL, 'DNA replication and repair protein RecF', 154, NULL, NULL, 203116),
(203117, '1.25.40.10-FF-004299', NULL, 'Pentatricopeptide repeat-containing protein', 194, NULL, NULL, 203117),
(203118, '1.10.1420.10-FF-000022', NULL, 'DNA mismatch repair protein', 185, NULL, NULL, 203118),
(203119, '2.40.50.140-FF-001075', NULL, NULL, 88, NULL, NULL, 203119),
(203120, '3.40.50.2020-FF-000094', NULL, 'Phosphoribosyl transferase', 138, NULL, NULL, 203120),
(203121, '3.40.50.720-FF-002543', NULL, 'Uncharacterized protein', 71, NULL, NULL, 203121),
(203122, '3.60.10.10-FF-000271', NULL, 'Predicted protein', 150, NULL, NULL, 203122),
(203123, '4.10.1080.10-FF-000015', NULL, 'Uncharacterized protein', 88, NULL, NULL, 203123),
(203124, '3.40.50.300-FF-000736', NULL, 'Interferon-induced helicase C domain-containing protein 1', 153, NULL, NULL, 203124),
(203125, '2.10.25.10-FF-000091', NULL, 'Fibulin 5', 39, NULL, NULL, 203125),
(203126, '3.20.20.140-FF-000198', NULL, 'Rudimentary, isoform D', 356, NULL, NULL, 203126),
(203127, '3.40.50.740-FF-000020', NULL, 'DMSO reductase', 171, NULL, NULL, 203127),
(203128, '2.60.40.10-FF-002023', NULL, 'KETtiN (Drosophila actin-binding) homolog', 103, NULL, NULL, 203128),
(203129, '3.40.47.10-FF-000148', NULL, NULL, 32, NULL, NULL, 203129),
(203130, '3.30.420.10-FF-000691', NULL, NULL, 126, NULL, NULL, 203130),
(203131, '1.10.8.60-FF-000151', NULL, 'ATP dependent metalloprotease', 81, NULL, NULL, 203131),
(203132, '1.10.1520.10-FF-000086', NULL, 'RNAse THREE-like protein 3', 165, NULL, NULL, 203132),
(203133, '2.30.29.30-FF-000672', NULL, 'Protein kinase domain containing protein', 106, NULL, NULL, 203133),
(203134, '2.170.40.20-FF-000003', NULL, 'Envelope glycoprotein gp160', 365, NULL, NULL, 203134),
(203135, '3.90.79.20-FF-000026', NULL, 'Uncharacterized protein', 175, NULL, NULL, 203135);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(203136, '3.40.50.150-FF-001158', NULL, NULL, 97, NULL, NULL, 203136),
(203137, '3.10.20.90-FF-000567', NULL, 'Predicted protein', 89, NULL, NULL, 203137),
(203138, '3.30.160.60-FF-005845', NULL, NULL, 26, NULL, NULL, 203138),
(203139, '1.10.510.10-FF-002790', NULL, NULL, 198, NULL, NULL, 203139),
(203140, '1.10.8.950-FF-000001', NULL, 'Polymerase cofactor VP35', 77, NULL, NULL, 203140),
(203141, '1.10.8.270-FF-000011', NULL, 'TBC1 domain family member 5', 125, NULL, NULL, 203141),
(203142, '1.20.1250.20-FF-001673', NULL, 'Uncharacterized protein', 150, NULL, NULL, 203142),
(203143, '1.10.590.10-FF-000001', NULL, 'Chorismate mutase', 255, NULL, NULL, 203143),
(203144, '3.30.470.20-FF-000079', NULL, 'Glutathione synthetase', 68, NULL, NULL, 203144),
(203145, '2.40.30.170-FF-000034', NULL, 'Efflux transporter periplasmic adaptor subunit', 93, NULL, NULL, 203145),
(203146, '2.30.40.10-FF-000057', NULL, 'Imidazolonepropionase-like amidohydrolase', 82, NULL, NULL, 203146),
(203147, '1.25.10.10-FF-003223', NULL, 'Serine/threonine-protein kinase TOR', 262, NULL, NULL, 203147),
(203148, '3.30.200.20-FF-001285', NULL, 'Non-specific serine/threonine protein kinase', 91, NULL, NULL, 203148),
(203149, '2.60.40.60-FF-000599', NULL, 'Protocadherin 20', 118, NULL, NULL, 203149),
(203150, '2.30.42.10-FF-000039', NULL, 'Lin-7 homolog B', 111, NULL, NULL, 203150),
(203151, '2.60.40.60-FF-001088', NULL, 'Uncharacterized protein', 108, NULL, NULL, 203151),
(203152, '3.90.1200.10-FF-000036', NULL, 'N-acetylhexosamine 1-kinase', 155, NULL, NULL, 203152),
(203153, '3.40.950.10-FF-000015', NULL, 'Cytosolic Fe-S cluster assembly factor nar1', 15, NULL, NULL, 203153),
(203154, '3.10.350.10-FF-000026', NULL, 'Peptidoglycan endopeptidase', 52, NULL, NULL, 203154),
(203155, '1.20.990.10-FF-000024', NULL, 'NADPH-cytochrome p450 reductase-like protein', 135, NULL, NULL, 203155),
(203156, '1.20.1050.40-FF-000011', NULL, 'Thimet oligopeptidase 1', 79, NULL, NULL, 203156),
(203157, '3.40.50.1460-FF-000032', NULL, 'Caspase 1', 271, NULL, NULL, 203157),
(203158, '4.10.1240.10-FF-000017', NULL, 'Glucagon like peptide 2 receptor', 100, NULL, NULL, 203158),
(203159, '3.40.190.10-FF-000395', NULL, 'Oligopeptide ABC transporter, solute-binding protein', 201, NULL, NULL, 203159),
(203160, '3.30.70.330-FF-000313', NULL, 'Alkylated DNA repair protein alkB homolog 8', 97, NULL, NULL, 203160),
(203161, '2.60.40.10-FF-005749', NULL, NULL, 103, NULL, NULL, 203161),
(203162, '1.20.1250.20-FF-000745', NULL, 'MFS transporter', 179, NULL, NULL, 203162),
(203163, '3.30.50.10-FF-000196', NULL, 'Uncharacterized protein', 29, NULL, NULL, 203163),
(203164, '1.20.1110.10-FF-000053', NULL, 'Calcium-transporting ATPase', 304, NULL, NULL, 203164),
(203165, '3.40.190.290-FF-000055', NULL, 'Putative transcriptional regulator', 201, NULL, NULL, 203165),
(203166, '2.130.10.10-FF-004917', NULL, 'Uncharacterized protein', 108, NULL, NULL, 203166),
(203167, '3.40.50.2300-FF-001156', NULL, NULL, 172, NULL, NULL, 203167),
(203168, '3.30.70.330-FF-001241', NULL, 'Uncharacterized protein', 122, NULL, NULL, 203168),
(203169, '2.40.30.20-FF-000008', NULL, 'Riboflavin synthase, alpha subunit', 101, NULL, NULL, 203169),
(203170, '2.30.29.30-FF-000525', NULL, 'Ran GTPase-activating protein, putative', 153, NULL, NULL, 203170),
(203171, '3.30.160.60-FF-006334', NULL, NULL, 34, NULL, NULL, 203171),
(203172, '3.30.450.20-FF-000196', NULL, 'Predicted protein', 128, NULL, NULL, 203172),
(203173, '3.90.1150.10-FF-000155', NULL, 'Serine palmitoyltransferase component', 33, NULL, NULL, 203173),
(203174, '3.40.630.30-FF-000598', NULL, 'Histone acetyltransferase', 76, NULL, NULL, 203174),
(203175, '1.10.3260.10-FF-000015', NULL, 'DNA ligase', 204, NULL, NULL, 203175),
(203176, '2.40.50.1020-FF-000002', NULL, 'DNA-binding response regulator AlgR', 109, NULL, NULL, 203176),
(203177, '3.40.50.12120-FF-000003', NULL, NULL, 226, NULL, NULL, 203177),
(203178, '3.40.50.10470-FF-000042', NULL, 'Methylthioribose-1-phosphate isomerase', 206, NULL, NULL, 203178),
(203179, '3.30.450.20-FF-000049', NULL, 'Sensor histidine kinase DpiB', 129, NULL, NULL, 203179);
INSERT INTO "PUBLIC"."MODEL" VALUES
(203180, '3.40.20.10-FF-000166', NULL, 'Uncharacterized protein', 93, NULL, NULL, 203180),
(203181, '3.40.50.12470-FF-000024', NULL, NULL, 29, NULL, NULL, 203181),
(203182, '1.25.40.10-FF-001134', NULL, 'Uncharacterized protein, isoform B', 190, NULL, NULL, 203182),
(203183, '3.40.50.10140-FF-000027', NULL, 'Toll-6', 146, NULL, NULL, 203183),
(203184, '2.60.120.10-FF-000530', NULL, 'cGMP-dependent protein kinase', 121, NULL, NULL, 203184),
(203185, '3.40.50.300-FF-008021', NULL, 'Uncharacterized protein', 140, NULL, NULL, 203185),
(203186, '3.60.60.10-FF-000010', NULL, 'Acyl-coenzyme A:6-aminopenicillanic-acid-acyltransferase 40 kDa form', 253, NULL, NULL, 203186),
(203187, '1.10.10.10-FF-000929', NULL, 'DNA-binding response regulator', 102, NULL, NULL, 203187),
(203188, '1.10.20.10-FF-000082', NULL, 'Transcriptional activator, variant', 138, NULL, NULL, 203188),
(203189, '2.40.50.140-FF-000439', NULL, '23S rRNA (uracil(747)-C(5))-methyltransferase', 57, NULL, NULL, 203189),
(203190, '3.30.160.60-FF-004389', NULL, NULL, 31, NULL, NULL, 203190),
(203191, '2.160.20.10-FF-000196', NULL, 'tRNA nuclease CdiA-2', 294, NULL, NULL, 203191),
(203192, '1.20.58.2220-FF-000069', NULL, 'Uncharacterized protein', 117, NULL, NULL, 203192),
(203193, '1.20.1070.10-FF-001015', NULL, 'Si:ch211-119o8.4', 312, NULL, NULL, 203193),
(203194, '3.20.20.100-FF-000181', NULL, 'Uncharacterized protein', 137, NULL, NULL, 203194),
(203195, '2.130.10.10-FF-004272', NULL, 'Predicted protein', 130, NULL, NULL, 203195),
(203196, '3.40.50.2000-FF-000880', NULL, 'Putative colanic acid biosynthesis glycosyl transferase', 186, NULL, NULL, 203196),
(203197, '2.30.29.30-FF-001189', NULL, 'Ran-binding protein 1 homolog a', 98, NULL, NULL, 203197),
(203198, '1.25.40.60-FF-000019', NULL, NULL, 122, NULL, NULL, 203198),
(203199, '1.10.287.70-FF-000371', NULL, 'TWiK family of potassium channels', 333, NULL, NULL, 203199),
(203200, '2.60.120.620-FF-000131', NULL, 'Predicted gene, 28038', 38, NULL, NULL, 203200),
(203201, '3.50.50.60-FF-001396', NULL, 'Gll1923 protein', 191, NULL, NULL, 203201),
(203202, '3.30.40.10-FF-000370', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 49, NULL, NULL, 203202),
(203203, '3.40.50.300-FF-001664', NULL, 'MSHA biogenesis protein MshM', 158, NULL, NULL, 203203),
(203204, '3.90.1680.10-FF-000004', NULL, 'Uncharacterized protein', 72, NULL, NULL, 203204),
(203205, '3.30.830.10-FF-000093', NULL, 'Zinc protease, insulinase family', 187, NULL, NULL, 203205),
(203206, '1.20.58.1060-FF-000007', NULL, 'Wu:fi04e12', 109, NULL, NULL, 203206),
(203207, '1.20.1560.10-FF-000726', NULL, 'Predicted protein', 230, NULL, NULL, 203207),
(203208, '2.30.29.30-FF-001161', NULL, 'Predicted protein', 105, NULL, NULL, 203208),
(203209, '3.30.160.60-FF-001663', NULL, 'ZFP57 zinc finger protein', 22, NULL, NULL, 203209),
(203210, '1.10.486.10-FF-000006', NULL, 'RecBCD enzyme subunit RecB', 146, NULL, NULL, 203210),
(203211, '1.10.20.140-FF-000005', NULL, 'Putative tRNA delta(2)-isopentenylpyrophosphate transferase', 69, NULL, NULL, 203211),
(203212, '3.20.20.60-FF-000030', NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', 269, NULL, NULL, 203212),
(203213, '3.30.160.60-FF-003872', NULL, NULL, 58, NULL, NULL, 203213),
(203214, '3.40.50.300-FF-005587', NULL, 'ABC transporter, putative', 188, NULL, NULL, 203214),
(203215, '3.40.50.300-FF-003350', NULL, 'Structural maintenance of chromosomes protein 1', 273, NULL, NULL, 203215),
(203216, '2.60.40.1180-FF-000006', NULL, 'Putative family 31 glucosidase KIAA1161', 48, NULL, NULL, 203216),
(203217, '1.20.58.2220-FF-000041', NULL, 'Diaphanous protein, homolog 1, putative', 420, NULL, NULL, 203217),
(203218, '3.60.140.10-FF-000022', NULL, 'Polyphenol oxidase', 197, NULL, NULL, 203218),
(203219, '3.40.850.10-FF-000131', NULL, 'Kinesin family member 25', 425, NULL, NULL, 203219),
(203220, '3.40.50.300-FF-002861', NULL, 'Cell division control protein 48 homolog E', 74, NULL, NULL, 203220),
(203221, '2.60.40.150-FF-000694', NULL, 'Uncharacterized protein', 157, NULL, NULL, 203221),
(203222, '2.20.100.10-FF-000116', NULL, 'Thrombospondin protein-1', 55, NULL, NULL, 203222); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(203223, '3.40.50.720-FF-001795', NULL, 'Shikimate dehydrogenase (NADP(+))', 134, NULL, NULL, 203223),
(203224, '3.30.710.10-FF-000466', NULL, 'Uncharacterized protein', 116, NULL, NULL, 203224),
(203225, '2.60.120.650-FF-000235', NULL, 'Predicted protein', 123, NULL, NULL, 203225),
(203226, '3.10.10.10-FF-000060', NULL, NULL, 62, NULL, NULL, 203226),
(203227, '1.20.58.60-FF-000464', NULL, 'Protein CBR-SMA-1', 258, NULL, NULL, 203227),
(203228, '3.90.70.10-FF-000116', NULL, 'Ubiquitin carboxyl-terminal hydrolase 20', 314, NULL, NULL, 203228),
(203229, '4.10.410.10-FF-000106', NULL, 'Uncharacterized protein', 51, NULL, NULL, 203229),
(203230, '1.10.238.10-FF-000240', NULL, 'EF-hand calcium-binding domain-containing protein 6', 79, NULL, NULL, 203230),
(203231, '3.30.70.330-FF-001741', NULL, NULL, 78, NULL, NULL, 203231),
(203232, '1.25.40.10-FF-000645', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 112, NULL, NULL, 203232),
(203233, '1.20.1250.20-FF-001881', NULL, 'Major facilitator superfamily protein', 96, NULL, NULL, 203233),
(203234, '3.40.50.720-FF-001907', NULL, 'Short-chain dehydrogenase/reductase SDR', 283, NULL, NULL, 203234),
(203235, '2.130.10.10-FF-001366', NULL, 'WD repeat-containing protein 37', 161, NULL, NULL, 203235),
(203236, '3.40.50.300-FF-003850', NULL, 'Si:dkey-79f11.8', 194, NULL, NULL, 203236),
(203237, '1.20.1080.10-FF-000116', NULL, 'Uncharacterized protein', 103, NULL, NULL, 203237),
(203238, '1.25.40.90-FF-000034', NULL, 'Phosphatidylinositol-binding clathrin assembly protein-like', 102, NULL, NULL, 203238),
(203239, '3.20.20.80-FF-000277', NULL, '4-alpha-glucanotransferase, amylo-alpha-1,6-glucosidase', 108, NULL, NULL, 203239),
(203240, '3.90.79.10-FF-000169', NULL, 'Mutator MutT protein', 152, NULL, NULL, 203240),
(203241, '3.30.60.20-FF-000082', NULL, 'Diacylglycerol kinase', 60, NULL, NULL, 203241),
(203242, '1.10.441.10-FF-000009', NULL, 'Mannose-6-phosphate isomerase, class I', 132, NULL, NULL, 203242),
(203243, '3.40.630.30-FF-000570', NULL, 'Uncharacterized protein', 110, NULL, NULL, 203243),
(203244, '2.60.120.290-FF-000048', NULL, 'Uncharacterized protein, isoform A', 118, NULL, NULL, 203244),
(203245, '3.90.550.10-FF-000445', NULL, 'Exostosin-2 homolog', 278, NULL, NULL, 203245),
(203246, '3.40.50.620-FF-000130', NULL, 'Cysteine--tRNA ligase', 302, NULL, NULL, 203246),
(203247, '2.60.200.20-FF-000096', NULL, 'Microspherule protein 1', 118, NULL, NULL, 203247),
(203248, '1.10.510.10-FF-002290', NULL, NULL, 201, NULL, NULL, 203248),
(203249, '2.10.25.10-FF-000444', NULL, 'von Willebrand factor', 55, NULL, NULL, 203249),
(203250, '4.10.1000.10-FF-000123', NULL, 'Uncharacterized protein', 29, NULL, NULL, 203250),
(203251, '3.40.50.200-FF-000032', NULL, 'Cell wall-associated serine proteinase', 331, NULL, NULL, 203251),
(203252, '1.10.10.440-FF-000060', NULL, 'GH18144p', 57, NULL, NULL, 203252),
(203253, '3.30.780.10-FF-000032', NULL, 'Translation machinery-associated protein 22', 88, NULL, NULL, 203253),
(203254, '3.40.50.2300-FF-000672', NULL, 'Uncharacterized protein', 277, NULL, NULL, 203254),
(203255, '1.10.238.10-FF-001318', NULL, 'Solute carrier family 25 member 23b', 83, NULL, NULL, 203255),
(203256, '1.20.1560.10-FF-000165', NULL, 'Unplaced genomic scaffold supercont1.71, whole genome shotgun sequence', 331, NULL, NULL, 203256),
(203257, '3.30.470.20-FF-000112', NULL, 'Phosphoribosylaminoimidazole carboxylase', 198, NULL, NULL, 203257),
(203258, '1.10.630.10-FF-000320', NULL, 'Uncharacterized protein', 269, NULL, NULL, 203258),
(203259, '1.20.1250.20-FF-000245', NULL, 'MFS allantoate transporter', 197, NULL, NULL, 203259),
(203260, '3.30.450.50-FF-000064', NULL, 'Putative vesicle-associated membrane protein family protein', 99, NULL, NULL, 203260),
(203261, '1.20.1050.130-FF-000029', NULL, 'Glutathione S-transferase', 207, NULL, NULL, 203261),
(203262, '3.40.50.10810-FF-000127', NULL, 'Helicase SNF2', 232, NULL, NULL, 203262),
(203263, '1.10.150.20-FF-000275', NULL, 'DNA repair protein rad16', 73, NULL, NULL, 203263),
(203264, '2.60.120.260-FF-000152', NULL, 'Rhamnogalacturonate lyase', 195, NULL, NULL, 203264);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(203265, '3.40.50.150-FF-000910', NULL, NULL, 129, NULL, NULL, 203265),
(203266, '2.130.10.10-FF-005109', NULL, 'Uncharacterized protein', 246, NULL, NULL, 203266),
(203267, '3.30.160.60-FF-002411', NULL, NULL, 28, NULL, NULL, 203267),
(203268, '2.60.470.10-FF-000022', NULL, 'Pickpocket protein 19', 190, NULL, NULL, 203268),
(203269, '3.30.200.20-FF-000918', NULL, 'Myosin Light Chain Kinase related', 98, NULL, NULL, 203269),
(203270, '1.10.630.10-FF-000409', NULL, 'Cytochrome P450 oxidoreductase', 479, NULL, NULL, 203270),
(203271, '3.40.30.10-FF-000964', NULL, 'Uncharacterized protein', 99, NULL, NULL, 203271),
(203272, '2.40.100.10-FF-000073', NULL, 'Putative cyclosporin 16', 172, NULL, NULL, 203272),
(203273, '3.40.1280.10-FF-000070', NULL, 'AGAP005864-PA', 169, NULL, NULL, 203273),
(203274, '3.30.200.20-FF-001054', NULL, 'Serine/threonine-protein kinase WNK1', 97, NULL, NULL, 203274),
(203275, '2.20.25.630-FF-000003', NULL, 'Poly [ADP-ribose] polymerase', 59, NULL, NULL, 203275),
(203276, '2.60.40.10-FF-001242', NULL, 'Sialic acid binding Ig like lectin 11', 96, NULL, NULL, 203276),
(203277, '3.40.50.720-FF-002312', NULL, 'AGR227Wp', 132, NULL, NULL, 203277),
(203278, '3.40.50.300-FF-001080', NULL, 'Dynein, axonemal, heavy chain 5', 182, NULL, NULL, 203278),
(203279, '1.10.10.750-FF-000001', NULL, 'TBC1 domain family member 10A', 43, NULL, NULL, 203279),
(203280, '3.40.50.1100-FF-000149', NULL, 'Cysteine synthase', 185, NULL, NULL, 203280),
(203281, '3.30.160.60-FF-001455', NULL, 'myoneurin isoform X2', 22, NULL, NULL, 203281),
(203282, '3.30.450.20-FF-000257', NULL, 'Similar to serine threonine protein kinase', 97, NULL, NULL, 203282),
(203283, '1.20.1420.30-FF-000110', NULL, 'Potassium-dependent sodium-calcium exchanger, putative', 77, NULL, NULL, 203283),
(203284, '1.50.40.10-FF-000345', NULL, 'Solute carrier family 25 member 22b', 76, NULL, NULL, 203284),
(203285, '3.90.1150.10-FF-000094', NULL, 'GntR family transcriptional regulator', 141, NULL, NULL, 203285),
(203286, '3.30.60.30-FF-000028', NULL, 'Follistatin-related protein 3', 67, NULL, NULL, 203286),
(203287, '3.10.250.10-FF-000081', NULL, NULL, 110, NULL, NULL, 203287),
(203288, '3.30.559.10-FF-000012', NULL, 'Non-ribosomal peptide synthetase', 201, NULL, NULL, 203288),
(203289, '1.25.10.10-FF-000025', NULL, 'Calcium-binding protein 39', 333, NULL, NULL, 203289),
(203290, '3.40.50.1010-FF-000274', NULL, NULL, 118, NULL, NULL, 203290),
(203291, '2.10.90.10-FF-000078', NULL, 'Putative bursicon beta', 131, NULL, NULL, 203291),
(203292, '1.20.140.10-FF-000067', NULL, 'Oxidoreductase, mmfh', 165, NULL, NULL, 203292),
(203293, '1.10.1090.10-FF-000007', NULL, 'Uncharacterized protein', 72, NULL, NULL, 203293),
(203294, '2.30.39.10-FF-000020', NULL, 'Serpin family B member 8', 67, NULL, NULL, 203294),
(203295, '3.30.559.10-FF-000276', NULL, 'Choline oacetyltransferase, putative', 62, NULL, NULL, 203295),
(203296, '3.30.497.10-FF-000143', NULL, 'AT24862p', 51, NULL, NULL, 203296),
(203297, '3.10.250.10-FF-000137', NULL, NULL, 114, NULL, NULL, 203297),
(203298, '1.25.10.10-FF-003370', NULL, 'Uncharacterized protein', 165, NULL, NULL, 203298),
(203299, '1.25.10.10-FF-000497', NULL, 'Reticulocyte binding protein 2', 282, NULL, NULL, 203299),
(203300, '3.40.50.300-FF-005407', NULL, 'PDR-like ABC transporter', 298, NULL, NULL, 203300),
(203301, '1.10.101.10-FF-000018', NULL, 'PDZ-containing carboxyl-terminal proteaseprocessing protease', 78, NULL, NULL, 203301),
(203302, '1.25.40.10-FF-005108', NULL, 'Response regulator', 118, NULL, NULL, 203302),
(203303, '2.40.70.10-FF-000244', NULL, 'Uncharacterized protein', 233, NULL, NULL, 203303),
(203304, '2.10.220.10-FF-000116', NULL, 'Proprotein convertase subtilisin/kexin type 5', 100, NULL, NULL, 203304),
(203305, '3.40.50.1100-FF-000060', NULL, 'N-(2-amino-2-carboxyethyl)-L-glutamate synthase', 111, NULL, NULL, 203305),
(203306, '2.60.40.2030-FF-000036', NULL, 'Adhesion G protein-coupled receptor V1', 104, NULL, NULL, 203306),
(203307, '3.60.21.10-FF-000116', NULL, 'Serine/threonine-protein phosphatase', 67, NULL, NULL, 203307);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(203308, '3.40.50.80-FF-000087', NULL, 'Oxidoreductase', 126, NULL, NULL, 203308),
(203309, '3.30.70.330-FF-000577', NULL, 'Blast:RNA-binding protein 25', 82, NULL, NULL, 203309),
(203310, '3.40.1110.10-FF-000024', NULL, 'Phospholipid-transporting ATPase', 26, NULL, NULL, 203310),
(203311, '2.130.10.10-FF-005261', NULL, 'Uncharacterized protein', 267, NULL, NULL, 203311),
(203312, '2.60.40.10-FF-005457', NULL, NULL, 107, NULL, NULL, 203312),
(203313, '3.30.930.10-FF-000302', NULL, 'Prolyl-tRNA synthetase (AFU_orthologue AFUA_1G10750)', 110, NULL, NULL, 203313),
(203314, '3.30.360.10-FF-000129', NULL, 'Josephin domain containing 2', 58, NULL, NULL, 203314),
(203315, '2.30.180.10-FF-000102', NULL, NULL, 170, NULL, NULL, 203315),
(203316, '3.40.50.1110-FF-000006', NULL, 'O-acetyltransferase OatA', 153, NULL, NULL, 203316),
(203317, '1.10.40.30-FF-000004', NULL, 'Adenylosuccinate lyase', 64, NULL, NULL, 203317),
(203318, '3.40.250.10-FF-000102', NULL, 'Uncharacterized protein', 122, NULL, NULL, 203318),
(203319, '3.40.50.150-FF-001366', NULL, NULL, 182, NULL, NULL, 203319),
(203320, '3.30.160.60-FF-002883', NULL, 'Hunchback-like protein', 58, NULL, NULL, 203320),
(203321, '1.10.287.920-FF-000002', NULL, 'Mating-type alpha-pheromone receptor PreB', 81, NULL, NULL, 203321),
(203322, '2.40.50.90-FF-000103', NULL, 'Mitochondrial succinoglycan biosynthesis protein-related protein', 123, NULL, NULL, 203322),
(203323, '3.40.50.2300-FF-000728', NULL, 'Uncharacterized protein', 164, NULL, NULL, 203323),
(203324, '2.30.30.30-FF-000006', NULL, '60S ribosomal protein L8', 80, NULL, NULL, 203324),
(203325, '3.90.15.10-FF-000016', NULL, 'Uncharacterized protein', 90, NULL, NULL, 203325),
(203326, '3.80.10.10-FF-002434', NULL, 'MDIS1-interacting receptor like kinase 2', 166, NULL, NULL, 203326),
(203327, '3.40.50.300-FF-004570', NULL, 'Uncharacterized protein', 209, NULL, NULL, 203327),
(203328, '1.20.140.150-FF-000043', NULL, 'Clarin 3', 220, NULL, NULL, 203328),
(203329, '2.70.170.10-FF-000132', NULL, 'Uncharacterized protein', 128, NULL, NULL, 203329),
(203330, '2.130.10.10-FF-001158', NULL, 'Semaphorin-4E', 475, NULL, NULL, 203330),
(203331, '2.60.120.290-FF-000256', NULL, 'Cubilin-like Protein', 110, NULL, NULL, 203331),
(203332, '3.10.20.310-FF-000032', NULL, 'Outer membrane protein assembly factor BamA', 80, NULL, NULL, 203332),
(203333, '2.30.30.380-FF-000032', NULL, 'Protein transport protein SEC23', 60, NULL, NULL, 203333),
(203334, '3.40.630.10-FF-000412', NULL, 'Acetylornithine deacetylase-like protein', 29, NULL, NULL, 203334),
(203335, '1.10.10.10-FF-001334', NULL, 'Cullin-5', 87, NULL, NULL, 203335),
(203336, '3.30.70.330-FF-001533', NULL, 'Multiple RNA-binding domain-containing protein 1', 85, NULL, NULL, 203336),
(203337, '3.20.20.80-FF-000069', NULL, 'Beta-glucosidase 1', 485, NULL, NULL, 203337),
(203338, '1.10.8.270-FF-000191', NULL, 'Uncharacterized protein', 122, NULL, NULL, 203338),
(203339, '2.10.25.10-FF-001400', NULL, 'Uncharacterized protein', 52, NULL, NULL, 203339),
(203340, '2.30.29.30-FF-000964', NULL, 'Uncharacterized protein', 107, NULL, NULL, 203340),
(203341, '3.90.1150.10-FF-000447', NULL, '4-aminobutyrate aminotransferase', 150, NULL, NULL, 203341),
(203342, '1.20.120.350-FF-000150', NULL, NULL, 125, NULL, NULL, 203342),
(203343, '3.10.20.90-FF-000275', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 115, NULL, NULL, 203343),
(203344, '1.10.238.210-FF-000010', NULL, 'Glutaminase like', 76, NULL, NULL, 203344),
(203345, '3.40.630.30-FF-000418', NULL, 'Uncharacterized protein', 186, NULL, NULL, 203345),
(203346, '1.25.40.790-FF-000020', NULL, 'Uncharacterized protein', 159, NULL, NULL, 203346),
(203347, '3.30.9.10-FF-000218', NULL, 'Uncharacterized protein', 76, NULL, NULL, 203347),
(203348, '3.40.190.10-FF-000687', NULL, 'Uncharacterized protein', 103, NULL, NULL, 203348),
(203349, '3.30.1520.10-FF-000057', NULL, 'Snx4p', 143, NULL, NULL, 203349),
(203350, '2.60.120.330-FF-000021', NULL, 'Gibberellin 2-beta-dioxygenase 8', 290, NULL, NULL, 203350),
(203351, '3.80.10.10-FF-000489', NULL, 'Centrosomal protein of 72 kDa', 153, NULL, NULL, 203351);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(203352, '2.70.130.10-FF-000006', NULL, 'Insulin-like growth factor 2 receptor', 149, NULL, NULL, 203352),
(203353, '3.40.50.1820-FF-000275', NULL, 'Prolyl endopeptidase', 54, NULL, NULL, 203353),
(203354, '2.70.150.10-FF-000069', NULL, 'Phospholipid-transporting ATPase', 126, NULL, NULL, 203354),
(203355, '2.130.10.10-FF-000702', NULL, 'WD repeat-containing protein 18', 69, NULL, NULL, 203355),
(203356, '2.60.20.10-FF-000015', NULL, 'Uncharacterized protein', 82, NULL, NULL, 203356),
(203357, '3.90.176.10-FF-000002', NULL, 'NAD(P)(+)--arginine ADP-ribosyltransferase', 235, NULL, NULL, 203357),
(203358, '1.25.40.180-FF-000163', NULL, NULL, 236, NULL, NULL, 203358),
(203359, '1.10.8.60-FF-000207', NULL, 'Lon protease homolog 2, peroxisomal', 116, NULL, NULL, 203359),
(203360, '3.40.50.620-FF-000394', NULL, 'Bifunctional protein HldE', 153, NULL, NULL, 203360),
(203361, '3.40.50.300-FF-005295', NULL, 'Uncharacterized protein', 174, NULL, NULL, 203361),
(203362, '3.90.1110.10-FF-000029', NULL, NULL, 172, NULL, NULL, 203362),
(203363, '1.10.287.70-FF-000724', NULL, 'Uncharacterized protein', 131, NULL, NULL, 203363),
(203364, '1.10.275.10-FF-000033', NULL, NULL, 58, NULL, NULL, 203364),
(203365, '2.60.40.10-FF-003804', NULL, NULL, 88, NULL, NULL, 203365),
(203366, '1.10.640.10-FF-000085', NULL, 'Uncharacterized protein', 179, NULL, NULL, 203366),
(203367, '3.90.1030.10-FF-000028', NULL, 'Predicted protein', 103, NULL, NULL, 203367),
(203368, '3.40.1170.60-FF-000054', NULL, NULL, 54, NULL, NULL, 203368),
(203369, '1.20.272.10-FF-000002', NULL, 'Replication factor C subunit 3', 94, NULL, NULL, 203369),
(203370, '1.20.1250.20-FF-000453', NULL, 'MFS allantoate transporter, putative', 191, NULL, NULL, 203370),
(203371, '1.20.120.1530-FF-000010', NULL, NULL, 116, NULL, NULL, 203371),
(203372, '2.130.10.10-FF-003928', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit', 259, NULL, NULL, 203372),
(203373, '3.90.1180.10-FF-000011', NULL, 'Probable MRPL23-mitochondrial ribosomal protein, large subunit', 160, NULL, NULL, 203373),
(203374, '2.80.10.50-FF-000048', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 97, NULL, NULL, 203374),
(203375, '3.30.160.60-FF-003400', NULL, 'Schnurri, isoform D', 67, NULL, NULL, 203375),
(203376, '1.10.560.10-FF-000084', NULL, '60 kDa chaperonin', 245, NULL, NULL, 203376),
(203377, '3.90.1260.10-FF-000012', NULL, 'Os11g0303050 protein', 135, NULL, NULL, 203377),
(203378, '1.10.4160.10-FF-000036', NULL, NULL, 263, NULL, NULL, 203378),
(203379, '3.40.1170.10-FF-000033', NULL, 'YALI0B10197p', 117, NULL, NULL, 203379),
(203380, '1.10.150.20-FF-000067', NULL, 'DNA polymerase A', 110, NULL, NULL, 203380),
(203381, '2.60.60.20-FF-000026', NULL, 'Embryo-specific protein ATS3A', 109, NULL, NULL, 203381),
(203382, '3.80.10.10-FF-002698', NULL, 'MDIS1-interacting receptor like kinase 2 isoform A', 70, NULL, NULL, 203382),
(203383, '2.110.10.10-FF-000012', NULL, 'Matrix metallopeptidase 21', 132, NULL, NULL, 203383),
(203384, '2.20.140.10-FF-000001', NULL, 'Poly [ADP-ribose] polymerase', 73, NULL, NULL, 203384),
(203385, '3.30.420.40-FF-000379', NULL, 'Phosphotransferase', 192, NULL, NULL, 203385),
(203386, '3.90.850.10-FF-000018', NULL, 'Putative hydrolase', 215, NULL, NULL, 203386),
(203387, '1.10.287.3490-FF-000004', NULL, 'Mediator of RNA polymerase II transcription subunit 11', 86, NULL, NULL, 203387),
(203388, '1.10.3450.40-FF-000005', NULL, 'Signal recognition particle subunit SRP68', 213, NULL, NULL, 203388),
(203389, '1.20.120.1630-FF-000006', NULL, 'Putative 7-dehydrocholesterol reductase', 210, NULL, NULL, 203389),
(203390, '1.10.287.70-FF-000140', NULL, 'cation channel sperm-associated protein 1', 145, NULL, NULL, 203390),
(203391, '3.40.50.300-FF-008313', NULL, 'Uncharacterized protein', 254, NULL, NULL, 203391),
(203392, '2.60.40.10-FF-003304', NULL, 'Leukemia inhibitory factor receptor alpha b', 84, NULL, NULL, 203392),
(203393, '3.10.450.280-FF-000001', NULL, 'Beta-lactamase', 126, NULL, NULL, 203393),
(203394, '2.60.40.10-FF-002170', NULL, 'Immunoglobulin superfamily, member 3', 136, NULL, NULL, 203394);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(203395, '2.40.20.10-FF-000033', NULL, 'Uncharacterized protein', 84, NULL, NULL, 203395),
(203396, '2.10.70.10-FF-000279', NULL, 'Uncharacterized protein', 61, NULL, NULL, 203396),
(203397, '2.60.40.10-FF-001034', NULL, 'Uncharacterized protein, isoform F', 91, NULL, NULL, 203397),
(203398, '1.20.1070.10-FF-000998', NULL, 'Olfactory receptor 1260', 198, NULL, NULL, 203398),
(203399, '1.20.930.10-FF-000020', NULL, 'Transcription elongation factor A (SII), 3', 100, NULL, NULL, 203399),
(203400, '1.10.287.10-FF-000049', NULL, 'Uncharacterized protein', 58, NULL, NULL, 203400),
(203401, '1.10.150.60-FF-000028', NULL, 'Filamentous growth regulator', 146, NULL, NULL, 203401),
(203402, '1.10.287.1060-FF-000011', NULL, 'Vacuolar protein sorting-associated protein 32', 78, NULL, NULL, 203402),
(203403, '1.25.10.10-FF-000289', NULL, 'RING-type E3 ubiquitin transferase', 118, NULL, NULL, 203403),
(203404, '2.120.10.30-FF-000349', NULL, 'Uncharacterized protein', 195, NULL, NULL, 203404),
(203405, '1.10.10.60-FF-001147', NULL, NULL, 55, NULL, NULL, 203405),
(203406, '3.20.20.80-FF-000541', NULL, 'AGAP007182-PA', 251, NULL, NULL, 203406),
(203407, '2.40.160.20-FF-000023', NULL, 'Outer membrane protein', 185, NULL, NULL, 203407),
(203408, '1.10.132.110-FF-000004', NULL, 'Serum amyloid A protein', 80, NULL, NULL, 203408),
(203409, '1.25.10.10-FF-000609', NULL, 'Armadillo repeat protein', 288, NULL, NULL, 203409),
(203410, '1.10.472.10-FF-000536', NULL, 'Uncharacterized protein', 83, NULL, NULL, 203410),
(203411, '3.40.30.10-FF-001245', NULL, 'Uncharacterized protein', 57, NULL, NULL, 203411),
(203412, '2.40.50.140-FF-001283', NULL, NULL, 128, NULL, NULL, 203412),
(203413, '3.40.50.300-FF-003642', NULL, 'Cobalt ABC transporter ATP-binding protein', 235, NULL, NULL, 203413),
(203414, '2.130.10.10-FF-005053', NULL, 'Uncharacterized protein', 279, NULL, NULL, 203414),
(203415, '3.40.50.720-FF-000126', NULL, 'UDP-N-acetylmuramoylalanine--D-glutamate ligase', 92, NULL, NULL, 203415),
(203416, '2.10.109.10-FF-000009', NULL, 'Prophage repressor CI', 139, NULL, NULL, 203416),
(203417, '2.60.120.380-FF-000042', NULL, 'Uncharacterized protein', 133, NULL, NULL, 203417),
(203418, '3.30.1240.10-FF-000075', NULL, 'Cof-like hydrolase', 87, NULL, NULL, 203418),
(203419, '1.10.150.50-FF-000082', NULL, 'Polarized growth protein boi2', 85, NULL, NULL, 203419),
(203420, '3.90.730.10-FF-000010', NULL, 'Ribonuclease 1', 207, NULL, NULL, 203420),
(203421, '3.10.129.10-FF-000237', NULL, 'Acyl-[acyl-carrier-protein] hydrolase', 144, NULL, NULL, 203421),
(203422, '3.40.50.1820-FF-000983', NULL, 'Sn1-specific diacylglycerol lipase alpha', 254, NULL, NULL, 203422),
(203423, '1.10.540.10-FF-000021', NULL, 'Isovaleryl-CoA dehydrogenase IvdA', 119, NULL, NULL, 203423),
(203424, '3.40.350.10-FF-000019', NULL, 'Aminopeptidase YpdF', 124, NULL, NULL, 203424),
(203425, '2.60.40.640-FF-000009', NULL, 'Down syndrome critical region protein 3', 142, NULL, NULL, 203425),
(203426, '1.10.460.10-FF-000020', NULL, 'DNA topoisomerase 3-alpha', 102, NULL, NULL, 203426),
(203427, '3.30.70.260-FF-000005', NULL, 'Glycine cleavage system transcriptional repressor', 85, NULL, NULL, 203427),
(203428, '1.20.5.170-FF-000282', NULL, 'Uncharacterized protein', 101, NULL, NULL, 203428),
(203429, '1.20.58.830-FF-000030', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 142, NULL, NULL, 203429),
(203430, '2.130.10.30-FF-000124', NULL, NULL, 345, NULL, NULL, 203430),
(203431, '1.25.40.10-FF-001365', NULL, 'Pentatricopeptide repeat-containing protein At1g25360', 131, NULL, NULL, 203431),
(203432, '3.40.640.10-FF-000385', NULL, 'Aminotransferase (Class 5)', 234, NULL, NULL, 203432),
(203433, '2.60.40.10-FF-004468', NULL, NULL, 99, NULL, NULL, 203433),
(203434, '2.40.70.10-FF-000036', NULL, 'Vacuolar aspartic protease', 209, NULL, NULL, 203434),
(203435, '3.30.420.10-FF-000011', NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', 200, NULL, NULL, 203435),
(203436, '1.10.287.1080-FF-000017', NULL, 'Nucleoside triphosphate pyrophosphohydrolase', 125, NULL, NULL, 203436);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(203437, '3.30.70.270-FF-000065', NULL, 'Genome polyprotein', 55, NULL, NULL, 203437),
(203438, '1.10.287.70-FF-000663', NULL, 'Uncharacterized protein', 123, NULL, NULL, 203438),
(203439, '3.40.50.300-FF-001433', NULL, 'ABC transporter, putative', 256, NULL, NULL, 203439),
(203440, '3.30.428.10-FF-000040', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 162, NULL, NULL, 203440),
(203441, '2.130.10.10-FF-000438', NULL, 'TAF5-like RNA polymerase II p300/CBP-associated factor-associated factor 65 kDa subunit 5L', 183, NULL, NULL, 203441),
(203442, '2.30.30.40-FF-000127', NULL, 'neutrophil cytosol factor 1', 52, NULL, NULL, 203442),
(203443, '1.10.510.10-FF-000081', NULL, 'STE20-like serine/threonine-protein kinase', 211, NULL, NULL, 203443),
(203444, '1.20.1310.10-FF-000034', NULL, 'Related to Cullin-3', 139, NULL, NULL, 203444),
(203445, '2.60.40.10-FF-002787', NULL, 'Predicted protein', 98, NULL, NULL, 203445),
(203446, '3.40.50.1220-FF-000039', NULL, '2-succinyl-5-enolpyruvyl-6-hydroxy-3-cyclohexene-1-carboxylate synthase', 119, NULL, NULL, 203446),
(203447, '2.40.50.90-FF-000042', NULL, 'Tudor domain containing 6', 74, NULL, NULL, 203447),
(203448, '3.30.420.10-FF-000483', NULL, NULL, 173, NULL, NULL, 203448),
(203449, '2.60.40.10-FF-005249', NULL, NULL, 88, NULL, NULL, 203449),
(203450, '1.20.140.140-FF-000006', NULL, 'Uncharacterized protein', 187, NULL, NULL, 203450),
(203451, '3.90.20.20-FF-000003', NULL, 'GrpE protein homolog', 117, NULL, NULL, 203451),
(203452, '3.90.550.20-FF-000038', NULL, 'Predicted protein', 156, NULL, NULL, 203452),
(203453, '3.30.160.60-FF-000674', NULL, 'zinc finger transcription factor Trps1 isoform X2', 79, NULL, NULL, 203453),
(203454, '3.40.50.1820-FF-000483', NULL, 'Clan SC, family S33, methylesterase-like serine peptidase', 274, NULL, NULL, 203454),
(203455, '3.30.70.1230-FF-000174', NULL, 'Gcy-36', 189, NULL, NULL, 203455),
(203456, '3.40.630.30-FF-000098', NULL, 'N-terminal acetyltransferase A complex catalytic subunit Ard1', 157, NULL, NULL, 203456),
(203457, '2.130.10.10-FF-003428', NULL, 'Predicted protein', 167, NULL, NULL, 203457),
(203458, '2.30.29.30-FF-000464', NULL, 'Cell 12A endoglucanase', 122, NULL, NULL, 203458),
(203459, '3.30.160.60-FF-003136', NULL, 'Zinc finger protein 562', 45, NULL, NULL, 203459),
(203460, '2.60.175.20-FF-000002', NULL, 'Major capsid protein L1', 63, NULL, NULL, 203460),
(203461, '1.20.1110.10-FF-000114', NULL, NULL, 143, NULL, NULL, 203461),
(203462, '3.40.190.10-FF-000895', NULL, 'Uncharacterized protein', 92, NULL, NULL, 203462),
(203463, '3.30.70.330-FF-000813', NULL, 'RNA binding motif protein 19', 105, NULL, NULL, 203463),
(203464, '2.20.70.10-FF-000138', NULL, 'WW domain containing protein', 32, NULL, NULL, 203464),
(203465, '1.25.40.10-FF-005260', NULL, 'Uncharacterized protein', 157, NULL, NULL, 203465),
(203466, '3.30.70.590-FF-000020', NULL, 'Uncharacterized protein', 102, NULL, NULL, 203466),
(203467, '1.10.510.10-FF-004408', NULL, NULL, 80, NULL, NULL, 203467),
(203468, '2.60.40.150-FF-000722', NULL, 'Uncharacterized protein', 122, NULL, NULL, 203468),
(203469, '3.40.50.300-FF-005087', NULL, 'Os12g0503200 protein', 57, NULL, NULL, 203469),
(203470, '3.40.50.1820-FF-000011', NULL, 'Carboxylic ester hydrolase', 527, NULL, NULL, 203470),
(203471, '2.60.40.10-FF-005396', NULL, NULL, 48, NULL, NULL, 203471),
(203472, '3.10.20.90-FF-000067', NULL, 'E3 ubiquitin-protein ligase RING2', 111, NULL, NULL, 203472),
(203473, '3.30.70.330-FF-001033', NULL, 'splicing factor U2AF 26 kDa subunit isoform X2', 31, NULL, NULL, 203473),
(203474, '1.20.1110.10-FF-000261', NULL, NULL, 77, NULL, NULL, 203474),
(203475, '1.10.2010.10-FF-000002', NULL, 'Protein CBG14491', 69, NULL, NULL, 203475),
(203476, '3.30.70.270-FF-000126', NULL, 'GGDEF family protein', 182, NULL, NULL, 203476),
(203477, '3.20.20.30-FF-000015', NULL, 'Phthiodiolone/phenolphthiodiolone dimycocerosates ketoreductase', 351, NULL, NULL, 203477),
(203478, '3.80.10.10-FF-003507', NULL, 'Nyctalopin', 184, NULL, NULL, 203478),
(203479, '1.20.58.390-FF-000145', NULL, 'Predicted protein', 101, NULL, NULL, 203479);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(203480, '3.30.450.20-FF-000521', NULL, 'Uncharacterized protein', 151, NULL, NULL, 203480),
(203481, '3.30.160.60-FF-004417', NULL, NULL, 22, NULL, NULL, 203481),
(203482, '3.30.160.60-FF-006126', NULL, NULL, 35, NULL, NULL, 203482),
(203483, '3.30.1460.20-FF-000004', NULL, 'Arp2/3 complex 34 kDa subunit', 131, NULL, NULL, 203483),
(203484, '1.10.510.10-FF-001418', NULL, 'Serine/threonine protein kinase 15', 128, NULL, NULL, 203484),
(203485, '3.40.630.10-FF-000148', NULL, 'Aminopeptidase, putative', 294, NULL, NULL, 203485),
(203486, '3.50.50.60-FF-000940', NULL, 'Uncharacterized protein', 130, NULL, NULL, 203486),
(203487, '3.80.10.10-FF-000989', NULL, 'Leucine rich repeats and death domain containing 1', 89, NULL, NULL, 203487),
(203488, '3.30.40.10-FF-000431', NULL, 'E3 ubiquitin-protein ligase TRAIP', 77, NULL, NULL, 203488),
(203489, '3.40.50.10420-FF-000016', NULL, '5-formyltetrahydrofolate cyclo-ligase', 179, NULL, NULL, 203489),
(203490, '1.20.120.160-FF-000036', NULL, 'Aerobic respiration control sensor protein arcB', 119, NULL, NULL, 203490),
(203491, '1.25.10.10-FF-002442', NULL, 'Uncharacterized protein', 235, NULL, NULL, 203491),
(203492, '3.50.50.100-FF-000011', NULL, 'Membrane NADH dehydrogenase', 420, NULL, NULL, 203492),
(203493, '1.20.1250.20-FF-000953', NULL, 'Uncharacterized protein', 194, NULL, NULL, 203493),
(203494, '3.40.532.10-FF-000010', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 240, NULL, NULL, 203494),
(203495, '1.20.1070.10-FF-000498', NULL, 'Vomeronasal type-1 receptor', 294, NULL, NULL, 203495),
(203496, '1.20.920.10-FF-000194', NULL, 'Predicted protein', 137, NULL, NULL, 203496),
(203497, '2.30.30.100-FF-000111', NULL, 'U6 snrnaassociated Sm family LSm3 protein', 78, NULL, NULL, 203497),
(203498, '1.10.730.20-FF-000010', NULL, 'Isoleucine--tRNA ligase', 287, NULL, NULL, 203498),
(203499, '3.30.2410.10-FF-000049', NULL, 'Thyroid hormone receptor interactor 12', 60, NULL, NULL, 203499),
(203500, '3.90.470.20-FF-000037', NULL, 'Protein CBG08117', 113, NULL, NULL, 203500),
(203501, '3.30.420.40-FF-000587', NULL, 'Uncharacterized protein', 164, NULL, NULL, 203501),
(203502, '3.40.50.300-FF-000152', NULL, 'ATP-binding cassette, sub-family E, member 1', 332, NULL, NULL, 203502),
(203503, '3.30.390.60-FF-000011', NULL, 'Heat-inducible transcription repressor HrcA', 104, NULL, NULL, 203503),
(203504, '3.40.50.2300-FF-001509', NULL, NULL, 99, NULL, NULL, 203504),
(203505, '1.10.287.4070-FF-000021', NULL, 'SnoRNA binding domain containing protein', 111, NULL, NULL, 203505),
(203506, '1.10.12.10-FF-000035', NULL, 'Enoyl-CoA hydratase/isomerase family protein', 54, NULL, NULL, 203506),
(203507, '2.60.40.790-FF-000094', NULL, 'Heat shock protein Hsp-16.2', 130, NULL, NULL, 203507),
(203508, '2.130.10.10-FF-001719', NULL, 'Uncharacterized protein', 321, NULL, NULL, 203508),
(203509, '3.40.50.300-FF-008521', NULL, 'Uncharacterized protein', 212, NULL, NULL, 203509),
(203510, '3.40.50.2000-FF-000672', NULL, 'Uncharacterized protein', 206, NULL, NULL, 203510),
(203511, '1.10.520.10-FF-000019', NULL, 'Peroxidase', 21, NULL, NULL, 203511),
(203512, '2.10.25.10-FF-000383', NULL, 'Hemicentin 1', 38, NULL, NULL, 203512),
(203513, '1.25.40.10-FF-003551', NULL, 'Uncharacterized protein', 73, NULL, NULL, 203513),
(203514, '3.40.570.10-FF-000002', NULL, 'Endonuclease G, mitochondrial', 242, NULL, NULL, 203514),
(203515, '1.25.40.570-FF-000010', NULL, '26S proteasome regulatory subunit RPN6', 377, NULL, NULL, 203515),
(203516, '1.10.1040.10-FF-000004', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', 155, NULL, NULL, 203516),
(203517, '3.40.190.10-FF-000748', NULL, 'Predicted protein', 442, NULL, NULL, 203517),
(203518, '3.50.50.60-FF-000699', NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase', 236, NULL, NULL, 203518),
(203519, '2.30.180.10-FF-000041', NULL, 'Heme detoxification protein', 164, NULL, NULL, 203519),
(203520, '3.30.200.20-FF-000857', NULL, 'Pk17E, isoform A', 88, NULL, NULL, 203520),
(203521, '1.10.3720.10-FF-000034', NULL, 'Sugar ABC transporter permease', 266, NULL, NULL, 203521);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(203522, '2.130.10.10-FF-003575', NULL, 'Uncharacterized protein', 75, NULL, NULL, 203522),
(203523, '1.20.1560.10-FF-000518', NULL, 'YALI0A19580p', 312, NULL, NULL, 203523),
(203524, '3.80.10.10-FF-003979', NULL, 'AER145Wp', 159, NULL, NULL, 203524),
(203525, '3.30.479.30-FF-000017', NULL, 'SPFH domain/band 7 family protein', 133, NULL, NULL, 203525),
(203526, '1.10.10.10-FF-000429', NULL, 'Two-component system response regulator', 100, NULL, NULL, 203526),
(203527, '3.40.50.300-FF-006576', NULL, 'Uncharacterized protein', 100, NULL, NULL, 203527),
(203528, '3.30.479.10-FF-000011', NULL, '6-carboxy-5,6,7,8-tetrahydropterin synthase', 141, NULL, NULL, 203528),
(203529, '3.40.50.360-FF-000063', NULL, 'Probable NAD(P)H dehydrogenase', 193, NULL, NULL, 203529),
(203530, '3.20.20.150-FF-000055', NULL, 'AP endonuclease, family 2', 306, NULL, NULL, 203530),
(203531, '1.20.1730.10-FF-000026', NULL, 'Transporter, SSS family', 487, NULL, NULL, 203531),
(203532, '1.20.1070.10-FF-000026', NULL, 'C-C chemokine receptor type 5', 300, NULL, NULL, 203532),
(203533, '3.90.930.1-FF-000002', NULL, NULL, 111, NULL, NULL, 203533),
(203534, '1.20.140.10-FF-000128', NULL, 'Uncharacterized protein', 69, NULL, NULL, 203534),
(203535, '1.10.630.10-FF-000056', NULL, 'Red aleurone1', 481, NULL, NULL, 203535),
(203536, '3.40.640.10-FF-000177', NULL, 'Unplaced genomic scaffold supercont1.16, whole genome shotgun sequence', 429, NULL, NULL, 203536),
(203537, '1.10.472.10-FF-000036', NULL, 'cyclin-J isoform X1', 142, NULL, NULL, 203537),
(203538, '1.20.120.350-FF-000211', NULL, NULL, 115, NULL, NULL, 203538),
(203539, '3.40.220.10-FF-000038', NULL, 'DNA ligase 3', 166, NULL, NULL, 203539),
(203540, '2.60.120.260-FF-000505', NULL, 'Uncharacterized protein', 73, NULL, NULL, 203540),
(203541, '3.30.300.30-FF-000103', NULL, '2-succinylbenzoate--CoA ligase, chloroplastic/peroxisomal', 116, NULL, NULL, 203541),
(203542, '3.30.70.270-FF-000273', NULL, NULL, 228, NULL, NULL, 203542),
(203543, '3.40.710.10-FF-000093', NULL, 'D-alanyl-D-alanine carboxypeptidase/D-alanyl-D-alanine-endopeptidase', 235, NULL, NULL, 203543),
(203544, '3.30.160.60-FF-004889', NULL, NULL, 43, NULL, NULL, 203544),
(203545, '3.40.50.300-FF-003142', NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', 152, NULL, NULL, 203545),
(203546, '2.60.40.10-FF-003451', NULL, NULL, 102, NULL, NULL, 203546),
(203547, '2.60.120.200-FF-000802', NULL, 'Predicted protein', 148, NULL, NULL, 203547),
(203548, '1.25.40.10-FF-000437', NULL, 'Transmembrane and tetratricopeptide repeat containing 1', 69, NULL, NULL, 203548),
(203549, '3.90.550.10-FF-000653', NULL, 'Uncharacterized protein', 127, NULL, NULL, 203549),
(203550, '2.60.40.10-FF-005660', NULL, NULL, 89, NULL, NULL, 203550),
(203551, '1.25.40.800-FF-000006', NULL, 'Domain_of_uncharacterized_function_(DUF3819)/CCR4 -Not_complex_component_-_Not1_-_putative', 223, NULL, NULL, 203551),
(203552, '1.20.58.60-FF-000672', NULL, 'Uncharacterized protein', 155, NULL, NULL, 203552),
(203553, '3.20.20.60-FF-000119', NULL, 'Pyruvate kinase', 230, NULL, NULL, 203553),
(203554, '1.10.418.10-FF-000158', NULL, 'Parvin, beta', 47, NULL, NULL, 203554),
(203555, '2.20.70.10-FF-000290', NULL, 'Uncharacterized protein', 50, NULL, NULL, 203555),
(203556, '1.10.10.10-FF-001918', NULL, 'Uncharacterized protein', 99, NULL, NULL, 203556),
(203557, '3.80.10.10-FF-000017', NULL, 'leucine-rich repeat LGI family member 3', 188, NULL, NULL, 203557),
(203558, '2.60.40.10-FF-002523', NULL, 'Exo-beta-D-glucosaminidase', 124, NULL, NULL, 203558),
(203559, '3.80.10.10-FF-002934', NULL, 'Uncharacterized protein', 109, NULL, NULL, 203559),
(203560, '3.40.50.300-FF-002361', NULL, 'Predicted protein', 182, NULL, NULL, 203560),
(203561, '3.40.50.720-FF-001407', NULL, 'CipA protein', 173, NULL, NULL, 203561),
(203562, '2.10.25.10-FF-000944', NULL, 'protein eyes shut-like isoform X1', 38, NULL, NULL, 203562),
(203563, '2.60.120.10-FF-000058', NULL, 'Uncharacterized protein, isoform D', 137, NULL, NULL, 203563),
(203564, '2.30.110.10-FF-000036', NULL, 'F420-dependent enzyme', 144, NULL, NULL, 203564);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(203565, '3.40.50.1240-FF-000197', NULL, NULL, 119, NULL, NULL, 203565),
(203566, '3.10.28.10-FF-000027', NULL, 'DNA-directed RNA polymerase subunit beta', 123, NULL, NULL, 203566),
(203567, '2.60.40.1480-FF-000006', NULL, 'Coatomer subunit gamma', 147, NULL, NULL, 203567),
(203568, '2.80.10.50-FF-000251', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 137, NULL, NULL, 203568),
(203569, '3.30.1540.20-FF-000005', NULL, 'MutL homolog 3', 42, NULL, NULL, 203569),
(203570, '3.10.450.70-FF-000001', NULL, 'Thiol:disulfide interchange protein', 49, NULL, NULL, 203570),
(203571, '3.40.50.10190-FF-000020', NULL, 'DNA topoisomerase II binding protein 1', 97, NULL, NULL, 203571),
(203572, '2.60.40.1970-FF-000001', NULL, 'YEATS domain containing 2', 133, NULL, NULL, 203572),
(203573, '3.40.50.150-FF-001630', NULL, NULL, 238, NULL, NULL, 203573),
(203574, '1.10.630.10-FF-000820', NULL, 'Predicted protein', 243, NULL, NULL, 203574),
(203575, '3.40.50.1820-FF-001500', NULL, 'Putative serine carboxypeptidase-like 54', 160, NULL, NULL, 203575),
(203576, '3.30.200.20-FF-001638', NULL, NULL, 91, NULL, NULL, 203576),
(203577, '3.40.50.2300-FF-000880', NULL, NULL, 173, NULL, NULL, 203577),
(203578, '1.20.1280.290-FF-000067', NULL, 'Uncharacterized protein', 102, NULL, NULL, 203578),
(203579, '2.60.40.10-FF-004732', NULL, NULL, 111, NULL, NULL, 203579),
(203580, '1.20.58.1360-FF-000007', NULL, 'Lysine-specific demethylase 7 homolog', 111, NULL, NULL, 203580),
(203581, '3.30.930.10-FF-000038', NULL, 'Aspartate--tRNA ligase', 336, NULL, NULL, 203581),
(203582, '1.20.1070.10-FF-001515', NULL, 'Uncharacterized protein', 194, NULL, NULL, 203582),
(203583, '3.30.300.70-FF-000003', NULL, 'Ribosome maturation factor RimP', 83, NULL, NULL, 203583),
(203584, '1.25.40.10-FF-001718', NULL, 'Molecular chaperone DnaJ', 84, NULL, NULL, 203584),
(203585, '3.40.50.620-FF-000630', NULL, 'Electron transfer flavoprotein alpha subunit', 173, NULL, NULL, 203585),
(203586, '3.30.750.200-FF-000001', NULL, 'Coproporphyrinogen-III oxidase', 122, NULL, NULL, 203586),
(203587, '1.20.1560.10-FF-000665', NULL, 'Uncharacterized protein', 58, NULL, NULL, 203587),
(203588, '3.60.15.10-FF-000203', NULL, 'Predicted protein', 186, NULL, NULL, 203588),
(203589, '1.10.510.10-FF-003627', NULL, NULL, 193, NULL, NULL, 203589),
(203590, '1.25.40.20-FF-001255', NULL, 'Calcium transporter 1', 224, NULL, NULL, 203590),
(203591, '2.40.50.140-FF-000939', NULL, NULL, 168, NULL, NULL, 203591),
(203592, '3.40.50.300-FF-007032', NULL, 'Uncharacterized protein', 204, NULL, NULL, 203592),
(203593, '3.30.450.380-FF-000009', NULL, NULL, 177, NULL, NULL, 203593),
(203594, '3.40.50.150-FF-000702', NULL, 'Cell division protein ftsj', 125, NULL, NULL, 203594),
(203595, '3.30.420.40-FF-001043', NULL, 'Uncharacterized protein', 16, NULL, NULL, 203595),
(203596, '3.30.160.60-FF-005906', NULL, NULL, 57, NULL, NULL, 203596),
(203597, '3.30.30.40-FF-000001', NULL, 'CoA-transferase subunit alpha', 43, NULL, NULL, 203597),
(203598, '3.40.50.300-FF-005907', NULL, 'Uncharacterized protein', 276, NULL, NULL, 203598),
(203599, '3.40.120.10-FF-000121', NULL, 'Uncharacterized protein', 77, NULL, NULL, 203599),
(203600, '2.120.10.80-FF-000139', NULL, 'Serine/threonine-protein phosphatase', 201, NULL, NULL, 203600),
(203601, '1.25.10.10-FF-003162', NULL, 'Non-specific serine/threonine protein kinase', 369, NULL, NULL, 203601),
(203602, '1.10.340.70-FF-000012', NULL, 'Protein CBR-NOL-10', 85, NULL, NULL, 203602),
(203603, '1.10.10.160-FF-000066', NULL, 'DNA helicase', 61, NULL, NULL, 203603),
(203604, '1.10.238.10-FF-000801', NULL, 'Phosphoinositide phospholipase C', 63, NULL, NULL, 203604),
(203605, '3.40.50.1000-FF-000529', NULL, NULL, 147, NULL, NULL, 203605),
(203606, '3.40.50.1010-FF-000066', NULL, 'Flap endonuclease 1', 220, NULL, NULL, 203606),
(203607, '2.60.40.10-FF-005957', NULL, NULL, 88, NULL, NULL, 203607),
(203608, '3.30.70.330-FF-000105', NULL, 'HIV Tat-specific factor 1 homolog', 86, NULL, NULL, 203608),
(203609, '1.20.58.60-FF-000525', NULL, 'Uncharacterized protein', 264, NULL, NULL, 203609);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(203610, '2.70.98.20-FF-000034', NULL, 'Amine oxidase', 131, NULL, NULL, 203610),
(203611, '3.40.1160.10-FF-000004', NULL, 'Acetylglutamate kinase', 284, NULL, NULL, 203611),
(203612, '3.40.140.10-FF-000184', NULL, 'Predicted protein', 169, NULL, NULL, 203612),
(203613, '2.130.10.10-FF-004856', NULL, 'Uncharacterized protein', 126, NULL, NULL, 203613),
(203614, '1.20.1740.10-FF-000263', NULL, 'Uncharacterized protein', 106, NULL, NULL, 203614),
(203615, '3.90.640.10-FF-000183', NULL, 'Actin family', 122, NULL, NULL, 203615),
(203616, '3.40.50.1440-FF-000077', NULL, 'Tubulin alpha-1B chain', 91, NULL, NULL, 203616),
(203617, '3.40.50.150-FF-001219', NULL, NULL, 187, NULL, NULL, 203617),
(203618, '1.25.70.10-FF-000001', NULL, 'Mitochondrial transcription termination factor-like', 223, NULL, NULL, 203618),
(203619, '3.30.1330.30-FF-000060', NULL, '40S ribosomal protein S12', 118, NULL, NULL, 203619),
(203620, '1.10.510.10-FF-001570', NULL, 'Hypothetical_protein_-_conserved', 148, NULL, NULL, 203620),
(203621, '1.10.10.580-FF-000017', NULL, 'Meiotic recombination protein rec8', 76, NULL, NULL, 203621),
(203622, '1.20.1250.20-FF-001173', NULL, 'Solute carrier family 49 member 4 homolog', 189, NULL, NULL, 203622),
(203623, '1.10.10.350-FF-000033', NULL, NULL, 95, NULL, NULL, 203623),
(203624, '3.40.30.10-FF-000464', NULL, 'Thioredoxin', 103, NULL, NULL, 203624),
(203625, '3.30.2350.10-FF-000050', NULL, 'tRNA pseudouridine synthase B', 233, NULL, NULL, 203625),
(203626, '3.90.245.10-FF-000039', NULL, 'Putative uridine nucleosidase 2', 159, NULL, NULL, 203626),
(203627, '1.25.40.10-FF-002270', NULL, 'Transcription factor Tcc1p', 202, NULL, NULL, 203627),
(203628, '1.20.1070.10-FF-001779', NULL, 'Uncharacterized protein', 329, NULL, NULL, 203628),
(203629, '1.10.1200.10-FF-000011', NULL, 'Sterigmatocystin biosynthesis polyketide synthase', 70, NULL, NULL, 203629),
(203630, '1.10.10.60-FF-000427', NULL, 'Transcription factor MYB59', 45, NULL, NULL, 203630),
(203631, '3.30.40.10-FF-001207', NULL, 'GG11833', 80, NULL, NULL, 203631),
(203632, '2.60.120.200-FF-000241', NULL, 'L-type lectin-domain containing receptor kinase S.6-like', 247, NULL, NULL, 203632),
(203633, '3.30.70.100-FF-000121', NULL, NULL, 96, NULL, NULL, 203633),
(203634, '2.30.42.10-FF-000539', NULL, NULL, 102, NULL, NULL, 203634),
(203635, '3.80.10.10-FF-002226', NULL, 'Uncharacterized protein', 331, NULL, NULL, 203635),
(203636, '3.40.50.980-FF-000041', NULL, 'Acyl-CoA synthetase, AMP-forming', 175, NULL, NULL, 203636),
(203637, '3.30.750.44-FF-000021', NULL, NULL, 17, NULL, NULL, 203637),
(203638, '3.40.50.11340-FF-000022', NULL, 'Uncharacterized protein', 33, NULL, NULL, 203638),
(203639, '3.30.1360.120-FF-000078', NULL, 'tRNA modification GTPase MnmE', 122, NULL, NULL, 203639),
(203640, '2.60.40.10-FF-000314', NULL, 'Calmodulin-binding transcription activator 2', 97, NULL, NULL, 203640),
(203641, '4.10.800.20-FF-000010', NULL, 'AMP deaminase, putative', 95, NULL, NULL, 203641),
(203642, '3.30.1330.40-FF-000006', NULL, 'Reactive Intermediate Deaminase A, chloroplastic', 127, NULL, NULL, 203642),
(203643, '2.130.10.10-FF-002647', NULL, 'Uncharacterized protein', 281, NULL, NULL, 203643),
(203644, '3.60.10.10-FF-000063', NULL, 'Sphingomyelinase C', 306, NULL, NULL, 203644),
(203645, '3.10.20.90-FF-000303', NULL, 'E3 ubiquitin-protein ligase UPL5 isoform A', 96, NULL, NULL, 203645),
(203646, '2.60.40.150-FF-000486', NULL, 'Copine family member IX', 81, NULL, NULL, 203646),
(203647, '1.20.58.60-FF-000756', NULL, 'Envoplakin b', 50, NULL, NULL, 203647),
(203648, '1.20.1600.10-FF-000017', NULL, 'Agglutination protein', 404, NULL, NULL, 203648),
(203649, '2.60.40.10-FF-003187', NULL, 'Polycystic kidney disease 1-like 1', 83, NULL, NULL, 203649),
(203650, '3.10.20.90-FF-000775', NULL, 'Uncharacterized protein', 113, NULL, NULL, 203650),
(203651, '3.40.50.150-FF-001074', NULL, 'U6 small nuclear RNA (adenine-(43)-N(6))-methyltransferase', 240, NULL, NULL, 203651),
(203652, '1.10.238.270-FF-000005', NULL, 'Odorant-binding protein 46a', 167, NULL, NULL, 203652);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(203653, '1.10.730.10-FF-000176', NULL, 'DALR anticodon binding domain containing protein', 137, NULL, NULL, 203653),
(203654, '1.20.1640.10-FF-000019', NULL, 'Patched 2', 159, NULL, NULL, 203654),
(203655, '3.40.50.150-FF-001130', NULL, NULL, 195, NULL, NULL, 203655),
(203656, '1.10.630.10-FF-000117', NULL, 'Cytochrome P450', 385, NULL, NULL, 203656),
(203657, '1.10.287.70-FF-000163', NULL, 'Glutamate receptor', 126, NULL, NULL, 203657),
(203658, '2.40.160.110-FF-000024', NULL, 'Uncharacterized protein', 159, NULL, NULL, 203658),
(203659, '1.20.5.340-FF-000119', NULL, 'Uncharacterized protein', 85, NULL, NULL, 203659),
(203660, '2.30.30.220-FF-000001', NULL, 'ClpXP protease specificity-enhancing factor', 118, NULL, NULL, 203660),
(203661, '3.40.50.300-FF-003081', NULL, 'Ras family protein', 185, NULL, NULL, 203661),
(203662, '1.10.10.60-FF-000130', NULL, 'Homeobox protein Hox-D12', 79, NULL, NULL, 203662),
(203663, '3.30.750.24-FF-000127', NULL, 'Low affinity sulfate transporter', 117, NULL, NULL, 203663),
(203664, '3.30.70.330-FF-000869', NULL, 'Putative RNA-binding protein', 93, NULL, NULL, 203664),
(203665, '1.10.238.10-FF-000037', NULL, 'calcium-binding protein 1 isoform X2', 71, NULL, NULL, 203665),
(203666, '3.40.50.300-FF-001517', NULL, 'Putative ATP-dependent RNA helicase TDRD12', 242, NULL, NULL, 203666),
(203667, '2.60.40.10-FF-003720', NULL, NULL, 101, NULL, NULL, 203667),
(203668, '1.25.10.10-FF-002026', NULL, 'Uncharacterized protein', 256, NULL, NULL, 203668),
(203669, '3.80.10.10-FF-002670', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 139, NULL, NULL, 203669),
(203670, '1.25.10.10-FF-003015', NULL, 'Predicted protein', 331, NULL, NULL, 203670),
(203671, '1.20.1250.20-FF-000537', NULL, 'Peptide transporter family 2', 137, NULL, NULL, 203671),
(203672, '2.60.200.30-FF-000014', NULL, 'Mitochondrial NADH kinase', 152, NULL, NULL, 203672),
(203673, '2.30.31.10-FF-000019', NULL, 'Uncharacterized protein', 70, NULL, NULL, 203673),
(203674, '3.30.565.10-FF-000509', NULL, 'Sensor histidine kinase', 159, NULL, NULL, 203674),
(203675, '1.25.40.10-FF-003107', NULL, 'Pentatricopeptide repeat-containing protein', 157, NULL, NULL, 203675),
(203676, '2.30.30.140-FF-000275', NULL, 'SMN (Human Survival Motor Neuron gene) homolog', 64, NULL, NULL, 203676),
(203677, '3.60.110.10-FF-000082', NULL, NULL, 191, NULL, NULL, 203677),
(203678, '3.40.50.880-FF-000157', NULL, 'Anthranilate synthase component II', 209, NULL, NULL, 203678),
(203679, '3.30.70.260-FF-000152', NULL, 'GTP pyrophosphokinase', 80, NULL, NULL, 203679),
(203680, '3.30.9.10-FF-000134', NULL, 'D-amino acid oxidase', 12, NULL, NULL, 203680),
(203681, '2.60.40.60-FF-001060', NULL, 'Uncharacterized protein', 70, NULL, NULL, 203681),
(203682, '1.25.40.10-FF-003635', NULL, 'Tetratricopeptide repeat protein 21B', 208, NULL, NULL, 203682),
(203683, '3.30.1490.100-FF-000022', NULL, 'DNA polymerase eta', 121, NULL, NULL, 203683),
(203684, '1.25.10.10-FF-001953', NULL, 'Uncharacterized protein', 274, NULL, NULL, 203684),
(203685, '3.30.70.3020-FF-000003', NULL, 'U3 small nucleolar RNA-associated protein 22', 103, NULL, NULL, 203685),
(203686, '3.40.1410.10-FF-000041', NULL, 'Histidine utilization repressor', 135, NULL, NULL, 203686),
(203687, '1.20.5.650-FF-000004', NULL, 'Transcription factor TFIIIB subunit', 71, NULL, NULL, 203687),
(203688, '3.90.1150.10-FF-000386', NULL, '3,4-dihydroxyphenylacetaldehyde synthase', 105, NULL, NULL, 203688),
(203689, '3.80.10.10-FF-003923', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 100, NULL, NULL, 203689),
(203690, '3.60.40.10-FF-000211', NULL, 'Predicted protein', 294, NULL, NULL, 203690),
(203691, '2.60.120.260-FF-000444', NULL, 'Laminin subunit alpha 5', 164, NULL, NULL, 203691),
(203692, '3.40.50.300-FF-008549', NULL, 'Uncharacterized protein', 122, NULL, NULL, 203692),
(203693, '1.20.120.220-FF-000015', NULL, 'ATP synthase subunit a', 195, NULL, NULL, 203693),
(203694, '1.10.10.10-FF-000845', NULL, 'DeoR family transcriptional regulator', 62, NULL, NULL, 203694);
INSERT INTO "PUBLIC"."MODEL" VALUES
(203695, '2.10.70.10-FF-000223', NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing 1', 75, NULL, NULL, 203695),
(203696, '2.120.10.80-FF-000347', NULL, 'Uncharacterized protein', 84, NULL, NULL, 203696),
(203697, '3.80.10.10-FF-002142', NULL, 'Uncharacterized protein', 123, NULL, NULL, 203697),
(203698, '3.50.70.10-FF-000005', NULL, 'Chalcone-flavonone isomerase family protein', 145, NULL, NULL, 203698),
(203699, '2.60.120.260-FF-000388', NULL, 'Uncharacterized protein', 184, NULL, NULL, 203699),
(203700, '2.60.40.10-FF-004232', NULL, NULL, 59, NULL, NULL, 203700),
(203701, '3.30.450.190-FF-000014', NULL, 'GTP-binding protein, putative', 124, NULL, NULL, 203701),
(203702, '3.20.20.140-FF-000170', NULL, 'Histidinol phosphatase', 204, NULL, NULL, 203702),
(203703, '3.30.200.20-FF-000626', NULL, 'Related to MKK1-MAP kinase kinase', 115, NULL, NULL, 203703),
(203704, '2.40.50.690-FF-000025', NULL, 'DIS3-like exonuclease 2', 104, NULL, NULL, 203704),
(203705, '1.20.1250.20-FF-000009', NULL, 'Synaptic vesicle glycoprotein 2A', 155, NULL, NULL, 203705),
(203706, '3.90.550.50-FF-000114', NULL, 'Hexosyltransferase', 287, NULL, NULL, 203706),
(203707, '1.10.510.10-FF-001593', NULL, 'Serine/threonine protein kinase', 263, NULL, NULL, 203707),
(203708, '3.30.2080.10-FF-000006', NULL, 'Putative conserved exported protein', 153, NULL, NULL, 203708),
(203709, '3.50.50.60-FF-000671', NULL, 'Thioredoxin reductase 2, tandem duplicate 1', 56, NULL, NULL, 203709),
(203710, '2.130.10.10-FF-000141', NULL, 'Pleckstrin homology domain interacting protein', 161, NULL, NULL, 203710),
(203711, '3.30.230.10-FF-000125', NULL, 'Mevalonate kinase', 165, NULL, NULL, 203711),
(203712, '1.10.20.10-FF-000290', NULL, NULL, 70, NULL, NULL, 203712),
(203713, '1.25.40.20-FF-001547', NULL, 'Ankyrin repeat family protein', 116, NULL, NULL, 203713),
(203714, '3.80.10.10-FF-004379', NULL, 'Disease resistance RPP13-like protein 4', 170, NULL, NULL, 203714),
(203715, '3.30.1360.200-FF-000012', NULL, 'Multifunctional fusion protein', 137, NULL, NULL, 203715),
(203716, '2.130.10.10-FF-004356', NULL, 'Uncharacterized protein', 92, NULL, NULL, 203716),
(203717, '1.20.58.1210-FF-000013', NULL, 'Uncharacterized protein', 128, NULL, NULL, 203717),
(203718, '1.20.58.60-FF-000317', NULL, 'Muscle-specific protein 300 kDa, isoform H', 231, NULL, NULL, 203718),
(203719, '1.10.287.370-FF-000028', NULL, 'Prefoldin alpha subunit, putative', 136, NULL, NULL, 203719),
(203720, '3.10.129.10-FF-000153', NULL, 'Acyl-CoA thioesterase 7', 77, NULL, NULL, 203720),
(203721, '3.30.830.10-FF-000177', NULL, 'Uncharacterized protein', 210, NULL, NULL, 203721),
(203722, '2.170.270.10-FF-000239', NULL, 'SET and MYND domain containing 1b', 40, NULL, NULL, 203722),
(203723, '2.60.40.10-FF-004968', NULL, NULL, 194, NULL, NULL, 203723),
(203724, '1.20.1000.10-FF-000016', NULL, NULL, 133, NULL, NULL, 203724),
(203725, '3.90.180.10-FF-000141', NULL, 'Uncharacterized protein', 71, NULL, NULL, 203725),
(203726, '3.10.20.90-FF-000831', NULL, 'Small ubiquitin-related modifier', 96, NULL, NULL, 203726),
(203727, '1.20.920.10-FF-000019', NULL, 'Transcription initiation factor TFIID subunit', 157, NULL, NULL, 203727),
(203728, '3.30.160.60-FF-001747', NULL, NULL, 28, NULL, NULL, 203728),
(203729, '3.40.50.300-FF-007296', NULL, 'Ras-related protein RABD1', 151, NULL, NULL, 203729),
(203730, '1.10.510.10-FF-003571', NULL, NULL, 218, NULL, NULL, 203730),
(203731, '1.10.405.20-FF-000013', NULL, NULL, 86, NULL, NULL, 203731),
(203732, '2.40.50.140-FF-000355', NULL, 'Single-stranded DNA-binding protein', 140, NULL, NULL, 203732),
(203733, '3.30.60.30-FF-000231', NULL, 'Predicted protein', 78, NULL, NULL, 203733),
(203734, '4.10.1110.10-FF-000013', NULL, 'Uncharacterized protein', 70, NULL, NULL, 203734),
(203735, '2.40.100.10-FF-000101', NULL, 'Peptidyl-prolyl cis-trans isomerase', 160, NULL, NULL, 203735),
(203736, '3.80.10.10-FF-000197', NULL, 'F-box and leucine-rich repeat protein 16', 117, NULL, NULL, 203736),
(203737, '3.30.1370.110-FF-000021', NULL, 'YALI0D27280p', 105, NULL, NULL, 203737);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(203738, '3.20.20.80-FF-000041', NULL, 'Beta-glucosidase 7', 484, NULL, NULL, 203738),
(203739, '1.10.287.130-FF-000243', NULL, 'Histidine kinase', 115, NULL, NULL, 203739),
(203740, '3.30.420.110-FF-000052', NULL, 'DNA mismatch repair protein Msh3', 208, NULL, NULL, 203740),
(203741, '1.10.1750.10-FF-000007', NULL, 'Chromosomal replication initiator protein DnaA', 107, NULL, NULL, 203741),
(203742, '1.25.40.10-FF-003579', NULL, 'Cyclin-F', 174, NULL, NULL, 203742),
(203743, '3.30.565.10-FF-000133', NULL, 'Accessory gene regulator C', 152, NULL, NULL, 203743),
(203744, '1.25.40.10-FF-001342', NULL, 'Tonsoku like, DNA repair protein', 80, NULL, NULL, 203744),
(203745, '3.30.200.20-FF-000149', NULL, 'serine/threonine-protein kinase unc-51 isoform X1', 87, NULL, NULL, 203745),
(203746, '3.40.50.150-FF-000141', NULL, 'ATP synthase c subunit lysine N-methyltransferase', 149, NULL, NULL, 203746),
(203747, '1.20.120.1080-FF-000151', NULL, 'Predicted protein', 111, NULL, NULL, 203747),
(203748, '3.30.420.10-FF-000308', NULL, 'Uncharacterized protein C29A10.09c', 171, NULL, NULL, 203748),
(203749, '3.40.630.30-FF-000070', NULL, 'Acetylglutamate kinase', 181, NULL, NULL, 203749),
(203750, '3.30.160.60-FF-005553', NULL, NULL, 33, NULL, NULL, 203750),
(203751, '3.40.50.1820-FF-000039', NULL, 'Esterase ybfF', 256, NULL, NULL, 203751),
(203752, '2.30.30.180-FF-000005', NULL, 'Ribosome maturation factor RimP', 61, NULL, NULL, 203752),
(203753, '1.20.58.60-FF-000380', NULL, 'Uncharacterized protein', 244, NULL, NULL, 203753),
(203754, '1.10.274.30-FF-000020', NULL, 'Mortality factor 4-like protein 1', 85, NULL, NULL, 203754),
(203755, '1.20.5.440-FF-000003', NULL, 'ATP synthase subunit delta', 43, NULL, NULL, 203755),
(203756, '3.40.630.20-FF-000005', NULL, 'Pyrrolidone-carboxylate peptidase', 208, NULL, NULL, 203756),
(203757, '3.30.70.20-FF-000144', NULL, NULL, 92, NULL, NULL, 203757),
(203758, '3.40.47.10-FF-000295', NULL, NULL, 104, NULL, NULL, 203758),
(203759, '2.60.110.10-FF-000029', NULL, 'Os08g0388150 protein', 89, NULL, NULL, 203759),
(203760, '1.20.1440.170-FF-000012', NULL, NULL, 138, NULL, NULL, 203760),
(203761, '1.10.1050.10-FF-000010', NULL, '30S ribosomal protein S4', 14, NULL, NULL, 203761),
(203762, '3.40.50.11610-FF-000002', NULL, '2-oxoglutarate dehydrogenase E1 component', 155, NULL, NULL, 203762),
(203763, '3.90.70.10-FF-000560', NULL, 'Uncharacterized protein', 150, NULL, NULL, 203763),
(203764, '1.20.5.170-FF-000102', NULL, 'bZIP transcription factor hapX', 74, NULL, NULL, 203764),
(203765, '2.130.10.10-FF-003052', NULL, 'Polyadenylation factor subunit 2', 143, NULL, NULL, 203765),
(203766, '3.30.200.160-FF-000006', NULL, 'general transcription factor 3C polypeptide 5-like isoform X2', 113, NULL, NULL, 203766),
(203767, '1.10.10.1330-FF-000001', NULL, 'RNA polymerase sigma-54 factor', 73, NULL, NULL, 203767),
(203768, '1.10.287.110-FF-000181', NULL, 'Chaperone protein DNAj, putative', 91, NULL, NULL, 203768),
(203769, '2.70.170.10-FF-000188', NULL, 'AGAP009493-PA', 213, NULL, NULL, 203769),
(203770, '3.40.50.150-FF-000938', NULL, 'Uncharacterized protein', 299, NULL, NULL, 203770),
(203771, '3.40.850.10-FF-000215', NULL, 'Kinesin-like protein', 310, NULL, NULL, 203771),
(203772, '1.10.472.10-FF-000300', NULL, 'Cyclin-L1-1', 118, NULL, NULL, 203772),
(203773, '2.60.40.60-FF-000071', NULL, 'FAT atypical cadherin 1', 104, NULL, NULL, 203773),
(203774, '3.40.710.10-FF-000149', NULL, 'Cell division protein FtsI', 195, NULL, NULL, 203774),
(203775, '3.30.160.60-FF-000882', NULL, 'Predicted gene, 21060', 29, NULL, NULL, 203775),
(203776, '3.20.20.80-FF-000305', NULL, 'Alpha-glucosidase', 345, NULL, NULL, 203776),
(203777, '3.30.870.10-FF-000067', NULL, 'Cardiolipin synthase', 176, NULL, NULL, 203777),
(203778, '1.20.1160.11-FF-000006', NULL, 'GON-4-like protein isoform X1', 63, NULL, NULL, 203778),
(203779, '3.30.70.860-FF-000005', NULL, 'UPF0234 protein LEP1GSC123_2924', 66, NULL, NULL, 203779),
(203780, '1.20.5.170-FF-000046', NULL, 'cGMP-dependent protein kinase 1', 54, NULL, NULL, 203780);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(203781, '3.30.70.330-FF-002258', NULL, NULL, 127, NULL, NULL, 203781),
(203782, '3.30.70.330-FF-000021', NULL, 'Polyadenylate-binding protein', 91, NULL, NULL, 203782),
(203783, '1.20.5.460-FF-000009', NULL, 'Proline utilization trans-activator', 30, NULL, NULL, 203783),
(203784, '2.70.70.10-FF-000057', NULL, 'PTS glucose transporter subunit IIA', 160, NULL, NULL, 203784),
(203785, '3.60.10.10-FF-000327', NULL, 'Uncharacterized protein', 252, NULL, NULL, 203785),
(203786, '3.30.160.60-FF-004625', NULL, NULL, 82, NULL, NULL, 203786),
(203787, '1.20.1070.10-FF-001695', NULL, 'Predicted protein', 110, NULL, NULL, 203787),
(203788, '2.60.40.60-FF-000868', NULL, 'Cadherin domaincontaining protein', 103, NULL, NULL, 203788),
(203789, '2.60.260.20-FF-000133', NULL, 'Chaperone protein DnaJ 1', 105, NULL, NULL, 203789),
(203790, '3.40.50.10890-FF-000016', NULL, 'Uncharacterized protein', 103, NULL, NULL, 203790),
(203791, '3.90.25.10-FF-000017', NULL, 'GDP-L-fucose synthase', 29, NULL, NULL, 203791),
(203792, '1.10.510.10-FF-002935', NULL, NULL, 70, NULL, NULL, 203792),
(203793, '3.10.50.10-FF-000034', NULL, 'Chitinase, acidic.4', 66, NULL, NULL, 203793),
(203794, '3.10.280.10-FF-000026', NULL, 'Mitochondrial p32 family protein', 221, NULL, NULL, 203794),
(203795, '1.10.1130.10-FF-000011', NULL, 'Dissimilatory sulfite reductase MccA', 53, NULL, NULL, 203795),
(203796, '1.10.287.130-FF-000187', NULL, 'PAS domain-containing sensor histidine kinase', 81, NULL, NULL, 203796),
(203797, '1.10.287.110-FF-000057', NULL, 'dnaJ homolog subfamily C member 14', 91, NULL, NULL, 203797),
(203798, '3.30.160.60-FF-005114', NULL, NULL, 58, NULL, NULL, 203798),
(203799, '3.10.50.40-FF-000110', NULL, 'Peptidylprolyl isomerase', 118, NULL, NULL, 203799),
(203800, '3.40.50.300-FF-003406', NULL, 'DNA replication ATP-dependent helicase/nuclease DNA2', 183, NULL, NULL, 203800),
(203801, '3.40.50.10190-FF-000317', NULL, 'DNA repair protein crb2', 93, NULL, NULL, 203801),
(203802, '2.30.30.1160-FF-000001', NULL, 'Antiviral helicase SKI2', 133, NULL, NULL, 203802),
(203803, '3.30.70.330-FF-002758', NULL, NULL, 80, NULL, NULL, 203803),
(203804, '3.30.2130.30-FF-000022', NULL, 'Putative uncharacterized protein DDB_G0293380', 166, NULL, NULL, 203804),
(203805, '3.30.160.60-FF-001219', NULL, 'zinc finger protein 436 isoform X2', 38, NULL, NULL, 203805),
(203806, '3.40.50.880-FF-000213', NULL, 'Uncharacterized protein', 181, NULL, NULL, 203806),
(203807, '3.30.160.60-FF-001371', NULL, 'Zinc finger protein, FOG family member 2', 75, NULL, NULL, 203807),
(203808, '2.130.10.10-FF-003900', NULL, 'Quinoprotein amine dehydrogenase, beta chain-like RIC1-like guanyl-nucleotide exchange factor', 271, NULL, NULL, 203808),
(203809, '2.60.40.790-FF-000150', NULL, NULL, 93, NULL, NULL, 203809),
(203810, '2.60.120.590-FF-000020', NULL, 'Alpha-ketoglutarate-dependent dioxygenase alkB', 211, NULL, NULL, 203810),
(203811, '3.30.830.10-FF-000121', NULL, 'Uncharacterized protein', 210, NULL, NULL, 203811),
(203812, '1.10.510.10-FF-001154', NULL, 'eIF-2alpha kinase', 207, NULL, NULL, 203812),
(203813, '3.30.70.330-FF-000077', NULL, 'RNA-binding motif protein 24', 93, NULL, NULL, 203813),
(203814, '3.30.40.10-FF-001151', NULL, 'RING-H2 finger protein ATL3C', 64, NULL, NULL, 203814),
(203815, '1.10.3370.10-FF-000052', NULL, 'Protein translocase subunit SecY', 464, NULL, NULL, 203815),
(203816, '3.40.109.10-FF-000055', NULL, 'Nitroreductase', 166, NULL, NULL, 203816),
(203817, '1.20.1560.10-FF-000581', NULL, 'Uncharacterized protein', 332, NULL, NULL, 203817),
(203818, '3.30.40.10-FF-000515', NULL, 'Uncharacterized protein', 75, NULL, NULL, 203818),
(203819, '3.80.10.10-FF-001506', NULL, 'toll-like receptor 8', 104, NULL, NULL, 203819),
(203820, '2.60.40.10-FF-001298', NULL, 'Vesicle-associated membrane protein, putative', 121, NULL, NULL, 203820),
(203821, '3.20.20.140-FF-000434', NULL, 'Uncharacterized protein', 147, NULL, NULL, 203821),
(203822, '3.80.10.10-FF-002518', NULL, 'Uncharacterized protein', 184, NULL, NULL, 203822),
(203823, '3.40.30.10-FF-001184', NULL, 'Uncharacterized protein', 152, NULL, NULL, 203823);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(203824, '2.60.120.1540-FF-000002', NULL, 'PZP, alpha-2-macroglobulin like', 86, NULL, NULL, 203824),
(203825, '3.40.640.10-FF-000446', NULL, 'Predicted protein', 107, NULL, NULL, 203825),
(203826, '3.40.50.300-FF-007301', NULL, 'Uncharacterized protein', 151, NULL, NULL, 203826),
(203827, '3.40.50.2000-FF-000200', NULL, 'Phosphatidylinositol N-acetylglucosaminyltransferase subunit A', 187, NULL, NULL, 203827),
(203828, '1.10.390.10-FF-000104', NULL, 'Uncharacterized protein', 52, NULL, NULL, 203828),
(203829, '1.10.472.80-FF-000040', NULL, 'TBC1 domain family member 2A', 145, NULL, NULL, 203829),
(203830, '2.40.50.140-FF-000883', NULL, NULL, 87, NULL, NULL, 203830),
(203831, '3.40.50.300-FF-004070', NULL, 'MutS protein homolog 4', 285, NULL, NULL, 203831),
(203832, '3.90.228.10-FF-000045', NULL, 'Poly [ADP-ribose] polymerase', 95, NULL, NULL, 203832),
(203833, '1.10.510.10-FF-000665', NULL, 'Microtubule associated serine/threonine kinase-like', 83, NULL, NULL, 203833),
(203834, '3.30.200.20-FF-001554', NULL, 'Uncharacterized protein', 48, NULL, NULL, 203834),
(203835, '3.90.120.10-FF-000008', NULL, 'Methyltransferase 2, isoform C', 148, NULL, NULL, 203835),
(203836, '3.40.190.10-FF-000664', NULL, 'Prephenate dehydratase', 86, NULL, NULL, 203836),
(203837, '2.130.10.10-FF-003367', NULL, 'Probable serine/threonine-protein kinase vps15', 323, NULL, NULL, 203837),
(203838, '2.120.10.80-FF-000403', NULL, 'Uncharacterized protein', 70, NULL, NULL, 203838),
(203839, '3.40.50.2300-FF-001425', NULL, NULL, 35, NULL, NULL, 203839),
(203840, '3.30.420.280-FF-000001', NULL, 'Terminase large subunit', 170, NULL, NULL, 203840),
(203841, '3.30.70.1230-FF-000258', NULL, 'Predicted protein', 176, NULL, NULL, 203841),
(203842, '3.30.160.20-FF-000185', NULL, 'Uncharacterized protein', 85, NULL, NULL, 203842),
(203843, '2.60.120.200-FF-000038', NULL, 'thrombospondin-3 isoform X1', 182, NULL, NULL, 203843),
(203844, '3.40.1810.10-FF-000061', NULL, NULL, 85, NULL, NULL, 203844),
(203845, '2.60.40.10-FF-003243', NULL, 'Class II cytokine receptor crfb8', 109, NULL, NULL, 203845),
(203846, '3.40.50.720-FF-000834', NULL, 'Saccharopine dehydrogenase [NAD(+), L-lysine-forming]', 52, NULL, NULL, 203846),
(203847, '1.10.8.10-FF-000333', NULL, 'Predicted protein', 42, NULL, NULL, 203847),
(203848, '3.10.105.10-FF-000002', NULL, 'Dipeptide ABC transporter, substrate-binding protein', 219, NULL, NULL, 203848),
(203849, '3.30.70.890-FF-000020', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase, putative', 144, NULL, NULL, 203849),
(203850, '1.25.10.10-FF-002498', NULL, 'Uncharacterized protein', 202, NULL, NULL, 203850),
(203851, '2.10.110.10-FF-000018', NULL, 'Paxillin isoform 1', 58, NULL, NULL, 203851),
(203852, '2.60.40.10-FF-002315', NULL, 'Uncharacterized protein', 111, NULL, NULL, 203852),
(203853, '1.10.8.870-FF-000011', NULL, 'Glycerol-3-phosphate dehydrogenase', 137, NULL, NULL, 203853),
(203854, '2.30.29.30-FF-000756', NULL, 'Nuclear pore complex protein NUP50A', 143, NULL, NULL, 203854),
(203855, '2.30.42.10-FF-000011', NULL, 'partitioning defective 3 homolog isoform X1', 100, NULL, NULL, 203855),
(203856, '3.90.640.10-FF-000160', NULL, 'Heat shock protein70 mitochondrial putative', 84, NULL, NULL, 203856),
(203857, '3.40.50.2000-FF-001133', NULL, 'Uncharacterized protein', 69, NULL, NULL, 203857),
(203858, '1.20.940.10-FF-000021', NULL, 'Uncharacterized protein', 109, NULL, NULL, 203858),
(203859, '3.40.50.150-FF-000202', NULL, 'Electron transfer flavoprotein subunit beta lysine methyltransferase', 168, NULL, NULL, 203859),
(203860, '2.70.160.11-FF-000048', NULL, 'Protein arginine methyltransferase 1', 119, NULL, NULL, 203860),
(203861, '3.40.50.150-FF-000146', NULL, 'Acetylserotonin O-methyltransferase', 250, NULL, NULL, 203861),
(203862, '3.20.20.70-FF-000156', NULL, 'Glutamate synthase domain protein', 359, NULL, NULL, 203862),
(203863, '3.40.50.300-FF-002153', NULL, 'Regulator of nonsense transcripts 1 homolog', 216, NULL, NULL, 203863),
(203864, '3.30.70.330-FF-001797', NULL, NULL, 52, NULL, NULL, 203864);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(203865, '3.40.50.300-FF-002097', NULL, 'ATP-binding cassette sub-family A member', 259, NULL, NULL, 203865),
(203866, '1.25.40.120-FF-000044', NULL, 'Protein prenyltransferase alpha subunit repeat, putative', 226, NULL, NULL, 203866),
(203867, '3.40.1160.10-FF-000027', NULL, 'Aspartokinase', 188, NULL, NULL, 203867),
(203868, '3.20.20.70-FF-000212', NULL, 'Indole-3-glycerol phosphate synthase', 260, NULL, NULL, 203868),
(203869, '2.30.42.10-FF-000303', NULL, 'Protein CBG01035', 86, NULL, NULL, 203869),
(203870, '2.30.42.10-FF-000483', NULL, NULL, 104, NULL, NULL, 203870),
(203871, '1.10.418.10-FF-000074', NULL, 'protein sickie isoform X1', 120, NULL, NULL, 203871),
(203872, '2.10.25.10-FF-001372', NULL, 'Fibropellin-1', 66, NULL, NULL, 203872),
(203873, '1.25.40.10-FF-002707', NULL, 'Uncharacterized protein', 312, NULL, NULL, 203873),
(203874, '3.90.180.10-FF-000080', NULL, 'Alcohol dehydrogenase, zinc-binding', 163, NULL, NULL, 203874),
(203875, '3.20.20.70-FF-000651', NULL, NULL, 235, NULL, NULL, 203875),
(203876, '3.30.70.330-FF-001325', NULL, 'Putative U1A small nuclear ribonucleoprotein', 83, NULL, NULL, 203876),
(203877, '1.25.40.10-FF-000229', NULL, 'Eukaryotic elongation factor 2 kinase', 206, NULL, NULL, 203877),
(203878, '3.90.1410.10-FF-000013', NULL, 'N-lysine methyltransferase SETD6', 259, NULL, NULL, 203878),
(203879, '3.30.230.10-FF-000120', NULL, 'Mismatch repair endonuclease PMS2', 128, NULL, NULL, 203879),
(203880, '3.80.10.10-FF-003070', NULL, 'Uncharacterized protein', 135, NULL, NULL, 203880),
(203881, '2.60.40.4100-FF-000011', NULL, 'Zona pellucida glycoprotein 3', 60, NULL, NULL, 203881),
(203882, '1.20.1280.290-FF-000044', NULL, 'PQ loop repeat protein', 99, NULL, NULL, 203882),
(203883, '3.10.100.10-FF-000250', NULL, NULL, 154, NULL, NULL, 203883),
(203884, '2.40.30.10-FF-000354', NULL, 'Predicted protein', 72, NULL, NULL, 203884),
(203885, '3.30.1130.10-FF-000005', NULL, 'D-erythro-7,8-dihydroneopterin triphosphate epimerase', 120, NULL, NULL, 203885),
(203886, '3.80.10.10-FF-001978', NULL, 'Inactive disease susceptibility protein LOV1', 160, NULL, NULL, 203886),
(203887, '1.10.510.10-FF-003419', NULL, NULL, 292, NULL, NULL, 203887),
(203888, '1.10.8.60-FF-000382', NULL, 'Katanin p60 ATPase-containing subunit A-like 2', 97, NULL, NULL, 203888),
(203889, '1.25.10.10-FF-001537', NULL, 'V-type proton ATPase subunit H', 332, NULL, NULL, 203889),
(203890, '2.60.40.150-FF-000430', NULL, 'Synaptotagmin XIII', 138, NULL, NULL, 203890),
(203891, '3.40.30.10-FF-001189', NULL, 'Sulfhydryl oxidase 1-like Protein', 108, NULL, NULL, 203891),
(203892, '3.30.56.70-FF-000002', NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', 58, NULL, NULL, 203892),
(203893, '3.20.20.120-FF-000012', NULL, 'Dipeptide epimerase', 237, NULL, NULL, 203893),
(203894, '3.40.50.12780-FF-000061', NULL, 'Acyl-CoA synthetase', 219, NULL, NULL, 203894),
(203895, '2.40.30.10-FF-000062', NULL, 'methionine synthase reductase', 90, NULL, NULL, 203895),
(203896, '1.20.1560.10-FF-000873', NULL, 'Uncharacterized protein', 125, NULL, NULL, 203896),
(203897, '2.70.98.10-FF-000093', NULL, 'Uncharacterized protein', 258, NULL, NULL, 203897),
(203898, '3.30.160.380-FF-000016', NULL, NULL, 94, NULL, NULL, 203898),
(203899, '2.130.10.10-FF-001427', NULL, 'Breast carcinoma-amplified sequence 3', 227, NULL, NULL, 203899),
(203900, '3.40.395.10-FF-000016', NULL, 'Deubiquitinase and deneddylase Dub1', 153, NULL, NULL, 203900),
(203901, '3.30.920.10-FF-000004', NULL, 'Mitochondrial chaperone Frataxin', 124, NULL, NULL, 203901),
(203902, '2.160.20.10-FF-000308', NULL, 'Uncharacterized protein', 138, NULL, NULL, 203902),
(203903, '1.10.555.10-FF-000015', NULL, 'rho GTPase-activating protein 25 isoform X1', 206, NULL, NULL, 203903),
(203904, '1.10.3630.10-FF-000004', NULL, 'Probable VPS74-protein involved in protein-vacuolar targeting', 251, NULL, NULL, 203904),
(203905, '3.30.70.330-FF-001802', NULL, NULL, 113, NULL, NULL, 203905),
(203906, '1.10.533.10-FF-000206', NULL, 'Death-associated inhibitor of apoptosis 2', 34, NULL, NULL, 203906);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(203907, '2.30.29.30-FF-000941', NULL, 'Uncharacterized protein', 109, NULL, NULL, 203907),
(203908, '3.30.1370.10-FF-000056', NULL, 'Tudor and KH domain containing', 75, NULL, NULL, 203908),
(203909, '3.60.15.10-FF-000259', NULL, 'Uncharacterized protein', 390, NULL, NULL, 203909),
(203910, '3.30.160.20-FF-000038', NULL, 'Dicer-like 104', 80, NULL, NULL, 203910),
(203911, '1.25.40.10-FF-001218', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 146, NULL, NULL, 203911),
(203912, '3.30.1360.30-FF-000005', NULL, 'Aspartate--tRNA(Asp/Asn) ligase', 140, NULL, NULL, 203912),
(203913, '3.90.930.12-FF-000038', NULL, NULL, 50, NULL, NULL, 203913),
(203914, '2.160.20.10-FF-000016', NULL, 'Polygalacturonase 7', 374, NULL, NULL, 203914),
(203915, '3.80.10.10-FF-001686', NULL, 'Insulin-like growth factor-binding protein acid labile subunit', 116, NULL, NULL, 203915),
(203916, '2.60.40.10-FF-003248', NULL, 'Kinase insert domain receptor like', 90, NULL, NULL, 203916),
(203917, '3.40.50.720-FF-001054', NULL, 'UDP-glucose dehydrogenase Ugd1, putative', 242, NULL, NULL, 203917),
(203918, '2.30.30.100-FF-000083', NULL, 'Small nuclear ribonucleoprotein E', 85, NULL, NULL, 203918),
(203919, '3.30.160.60-FF-006418', NULL, NULL, 52, NULL, NULL, 203919),
(203920, '1.20.900.10-FF-000136', NULL, 'Predicted protein', 224, NULL, NULL, 203920),
(203921, '1.10.510.10-FF-002082', NULL, 'Kinase', 327, NULL, NULL, 203921),
(203922, '3.30.70.330-FF-001510', NULL, NULL, 78, NULL, NULL, 203922),
(203923, '1.20.1740.10-FF-000055', NULL, 'Amino acid permease 6', 441, NULL, NULL, 203923),
(203924, '2.60.40.1180-FF-000186', NULL, 'Alpha,alpha-phosphotrehalase', 74, NULL, NULL, 203924),
(203925, '2.130.10.10-FF-001135', NULL, 'Bromodomain and WD repeat domain containing 3', 156, NULL, NULL, 203925),
(203926, '3.10.580.10-FF-000066', NULL, 'Chloride channel protein', 149, NULL, NULL, 203926),
(203927, '3.90.190.10-FF-000254', NULL, 'Uncharacterized protein', 237, NULL, NULL, 203927),
(203928, '3.40.50.1440-FF-000021', NULL, 'Tubulin delta chain', 400, NULL, NULL, 203928),
(203929, '1.20.1300.10-FF-000005', NULL, 'Succinate dehydrogenase cytochrome b556 subunit', 128, NULL, NULL, 203929),
(203930, '3.90.190.20-FF-000055', NULL, 'Folylpolyglutamate synthase', 163, NULL, NULL, 203930),
(203931, '1.10.260.100-FF-000006', NULL, 'Ubiquitin-associated domain-containing protein 1', 59, NULL, NULL, 203931),
(203932, '3.30.70.330-FF-002786', NULL, NULL, 52, NULL, NULL, 203932),
(203933, '2.40.340.10-FF-000028', NULL, NULL, 70, NULL, NULL, 203933),
(203934, '3.90.870.10-FF-000020', NULL, '3,4-dihydroxy-2-butanone 4-phosphate synthase', 214, NULL, NULL, 203934),
(203935, '3.40.309.10-FF-000059', NULL, 'Aldehyde dehydrogenase 3 family, member B1', 80, NULL, NULL, 203935),
(203936, '2.30.30.140-FF-000336', NULL, 'Uncharacterized protein', 62, NULL, NULL, 203936),
(203937, '3.40.50.300-FF-001933', NULL, 'Heparan-sulfate 6-O-sulfotransferase', 93, NULL, NULL, 203937),
(203938, '3.20.20.70-FF-000504', NULL, 'Uncharacterized protein', 329, NULL, NULL, 203938),
(203939, '3.30.470.20-FF-000051', NULL, 'Carbamoyl phosphate synthetase II', 197, NULL, NULL, 203939),
(203940, '2.130.10.10-FF-001630', NULL, 'Coronin', 342, NULL, NULL, 203940),
(203941, '1.25.40.10-FF-004271', NULL, 'Uncharacterized protein', 215, NULL, NULL, 203941),
(203942, '1.25.10.10-FF-001161', NULL, 'Hsp70-binding protein 1', 265, NULL, NULL, 203942),
(203943, '1.10.287.1250-FF-000001', NULL, 'Phosphotransferase', 76, NULL, NULL, 203943),
(203944, '3.90.105.10-FF-000001', NULL, 'Molybdopterin molybdenumtransferase', 58, NULL, NULL, 203944),
(203945, '3.40.30.10-FF-000256', NULL, 'Glutathione S-transferase U11', 86, NULL, NULL, 203945),
(203946, '3.90.1480.20-FF-000060', NULL, 'Uncharacterized protein', 74, NULL, NULL, 203946),
(203947, '3.40.50.1460-FF-000116', NULL, 'GPI-anchor transamidase', 282, NULL, NULL, 203947),
(203948, '3.30.870.10-FF-000123', NULL, 'Cardiolipin synthase, putative', 145, NULL, NULL, 203948),
(203949, '2.130.10.10-FF-002439', NULL, 'Protein CBG02611', 165, NULL, NULL, 203949);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(203950, '3.30.230.10-FF-000064', NULL, 'Mevalonate kinase', 158, NULL, NULL, 203950),
(203951, '2.10.60.10-FF-000014', NULL, 'Serine/threonine-protein kinase receptor R3', 85, NULL, NULL, 203951),
(203952, '1.10.20.10-FF-000166', NULL, 'TAF (TBP-associated transcription factor) family', 65, NULL, NULL, 203952),
(203953, '2.60.120.370-FF-000005', NULL, 'Beta-galactosidase subunit beta', 150, NULL, NULL, 203953),
(203954, '3.30.70.330-FF-002814', NULL, NULL, 92, NULL, NULL, 203954),
(203955, '1.10.8.480-FF-000017', NULL, 'rRNA adenine N(6)-methyltransferase', 119, NULL, NULL, 203955),
(203956, '2.60.40.150-FF-000806', NULL, 'Predicted protein', 138, NULL, NULL, 203956),
(203957, '1.20.58.80-FF-000003', NULL, 'Katanin p60 ATPase-containing subunit A1', 77, NULL, NULL, 203957),
(203958, '3.80.10.10-FF-000517', NULL, 'Leucine rich repeat containing 15', 117, NULL, NULL, 203958),
(203959, '1.10.150.910-FF-000005', NULL, 'Cleavage and polyadenylation specific factor 1', 89, NULL, NULL, 203959),
(203960, '3.20.20.80-FF-000777', NULL, 'Chitinase, putative', 243, NULL, NULL, 203960),
(203961, '1.20.5.2210-FF-000010', NULL, 'Uncharacterized protein', 92, NULL, NULL, 203961),
(203962, '3.30.200.20-FF-002066', NULL, NULL, 86, NULL, NULL, 203962),
(203963, '3.10.110.10-FF-000368', NULL, 'RBR-type E3 ubiquitin transferase', 130, NULL, NULL, 203963),
(203964, '1.10.3710.10-FF-000005', NULL, 'AAA family ATPase, putative', 90, NULL, NULL, 203964),
(203965, '2.130.10.10-FF-005845', NULL, 'Uncharacterized protein', 343, NULL, NULL, 203965),
(203966, '3.30.70.3370-FF-000001', NULL, '40S ribosomal protein S24', 131, NULL, NULL, 203966),
(203967, '1.25.40.180-FF-000219', NULL, NULL, 141, NULL, NULL, 203967),
(203968, '2.60.40.150-FF-000458', NULL, 'RPGR-interacting protein 1', 197, NULL, NULL, 203968),
(203969, '1.20.1070.10-FF-001987', NULL, 'Uncharacterized protein', 158, NULL, NULL, 203969),
(203970, '3.90.70.10-FF-000032', NULL, 'Ubiquitin carboxyl-terminal hydrolase 14', 387, NULL, NULL, 203970),
(203971, '3.90.640.10-FF-000008', NULL, 'alpha-centractin isoform X1', 88, NULL, NULL, 203971),
(203972, '3.50.50.60-FF-000199', NULL, 'Flavin-containing monooxygenase', 193, NULL, NULL, 203972),
(203973, '2.40.30.30-FF-000040', NULL, 'Predicted protein', 126, NULL, NULL, 203973),
(203974, '1.10.730.20-FF-000033', NULL, 'Uncharacterized protein', 309, NULL, NULL, 203974),
(203975, '2.60.40.10-FF-001303', NULL, 'Cell surface glycoprotein MUC18', 87, NULL, NULL, 203975),
(203976, '1.10.1450.10-FF-000142', NULL, 'Tetraspanin', 123, NULL, NULL, 203976),
(203977, '1.10.1450.10-FF-000086', NULL, 'Tetraspanin', 82, NULL, NULL, 203977),
(203978, '2.60.40.150-FF-000514', NULL, 'Uncharacterized protein', 126, NULL, NULL, 203978),
(203979, '1.10.10.790-FF-000018', NULL, 'Splicing factor 3A subunit 1', 58, NULL, NULL, 203979),
(203980, '3.30.505.10-FF-000124', NULL, 'tensin', 102, NULL, NULL, 203980),
(203981, '3.30.230.130-FF-000071', NULL, 'Uncharacterized protein', 120, NULL, NULL, 203981),
(203982, '1.10.10.60-FF-001124', NULL, NULL, 63, NULL, NULL, 203982),
(203983, '3.80.10.10-FF-004412', NULL, 'Receptor like protein 21', 73, NULL, NULL, 203983),
(203984, '3.60.10.10-FF-000035', NULL, 'Deoxyribonuclease', 259, NULL, NULL, 203984),
(203985, '2.60.40.2840-FF-000009', NULL, 'inositol polyphosphate 5-phosphatase K', 129, NULL, NULL, 203985),
(203986, '2.40.50.700-FF-000006', NULL, 'Exosome complex exonuclease RRP44', 77, NULL, NULL, 203986),
(203987, '3.40.50.10490-FF-000020', NULL, 'Glucose-6-phosphate isomerase', 47, NULL, NULL, 203987),
(203988, '3.30.450.40-FF-000027', NULL, 'Sensor histidine kinase YpdA', 133, NULL, NULL, 203988),
(203989, '3.30.160.60-FF-002708', NULL, 'Zinc finger, C2H2 type', 27, NULL, NULL, 203989),
(203990, '3.20.20.210-FF-000011', NULL, 'Uroporphyrinogen decarboxylase', 358, NULL, NULL, 203990),
(203991, '3.40.50.1820-FF-000511', NULL, 'Epoxide hydrolase EphF', 292, NULL, NULL, 203991),
(203992, '3.30.40.10-FF-000931', NULL, 'GM11875', 77, NULL, NULL, 203992),
(203993, '1.50.40.10-FF-000109', NULL, 'Ornithine carrier protein AmcA/Ort1', 120, NULL, NULL, 203993);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(203994, '2.130.10.10-FF-001574', NULL, 'Similar to pre-mRNA splicing factor 3b', 338, NULL, NULL, 203994),
(203995, '1.10.10.10-FF-000901', NULL, 'ArsR family transcriptional regulator', 95, NULL, NULL, 203995),
(203996, '1.20.1250.20-FF-002162', NULL, 'Uncharacterized protein', 188, NULL, NULL, 203996),
(203997, '3.30.160.60-FF-003636', NULL, NULL, 26, NULL, NULL, 203997),
(203998, '1.25.10.10-FF-001014', NULL, 'Uncharacterized protein', 995, NULL, NULL, 203998),
(203999, '1.25.70.10-FF-000057', NULL, NULL, 182, NULL, NULL, 203999),
(204000, '1.10.10.10-FF-001481', NULL, 'DNA-directed RNA polymerase III subunit RPC3', 75, NULL, NULL, 204000),
(204001, '2.130.10.10-FF-005317', NULL, 'Uncharacterized protein', 202, NULL, NULL, 204001),
(204002, '1.10.238.10-FF-000032', NULL, 'Spectrin alpha chain, non-erythrocytic 1', 69, NULL, NULL, 204002),
(204003, '2.120.10.30-FF-000265', NULL, 'Uncharacterized protein', 181, NULL, NULL, 204003),
(204004, '3.20.20.80-FF-000833', NULL, 'Uncharacterized protein', 44, NULL, NULL, 204004),
(204005, '3.30.565.10-FF-000189', NULL, 'Two-component sensor histidine kinase', 151, NULL, NULL, 204005),
(204006, '1.20.920.20-FF-000051', NULL, 'Uncharacterized protein', 306, NULL, NULL, 204006),
(204007, '2.60.60.20-FF-000049', NULL, NULL, 104, NULL, NULL, 204007),
(204008, '2.40.50.140-FF-000411', NULL, '23S rRNA (Uracil-5-)-methyltransferase RumA', 58, NULL, NULL, 204008),
(204009, '3.40.1800.20-FF-000006', NULL, 'GD21383', 80, NULL, NULL, 204009),
(204010, '1.10.510.10-FF-002407', NULL, NULL, 209, NULL, NULL, 204010),
(204011, '1.10.340.30-FF-000079', NULL, 'Uncharacterized protein', 90, NULL, NULL, 204011),
(204012, '1.20.1560.10-FF-000018', NULL, 'ATP-binding cassette subfamily B member 11', 350, NULL, NULL, 204012),
(204013, '3.40.50.12550-FF-000014', NULL, 'Uncharacterized protein', 85, NULL, NULL, 204013),
(204014, '2.60.220.50-FF-000055', NULL, 'Predicted protein', 157, NULL, NULL, 204014),
(204015, '2.130.10.10-FF-002063', NULL, 'WD repeat domain 43', 142, NULL, NULL, 204015),
(204016, '2.40.100.10-FF-000157', NULL, 'Peptidyl-prolyl cis-trans isomerase', 127, NULL, NULL, 204016),
(204017, '3.30.200.20-FF-001138', NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-like 1.2 isoform A', 104, NULL, NULL, 204017),
(204018, '3.40.800.20-FF-000041', NULL, 'Histone deacetylase', 377, NULL, NULL, 204018),
(204019, '3.40.50.970-FF-000184', NULL, 'Uncharacterized protein', 93, NULL, NULL, 204019),
(204020, '1.25.40.10-FF-002146', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 102, NULL, NULL, 204020),
(204021, '1.10.287.470-FF-000092', NULL, 'Efflux pump, RND family, membrane fusion protein', 66, NULL, NULL, 204021),
(204022, '1.10.510.10-FF-001098', NULL, 'Unplaced genomic scaffold supercont1.188, whole genome shotgun sequence', 181, NULL, NULL, 204022),
(204023, '3.40.50.410-FF-000185', NULL, 'Uncharacterized protein', 191, NULL, NULL, 204023),
(204024, '2.130.10.10-FF-005284', NULL, 'Predicted protein', 229, NULL, NULL, 204024),
(204025, '3.60.40.10-FF-000155', NULL, 'Protein phosphatase 2C, putative', 392, NULL, NULL, 204025),
(204026, '3.40.50.1010-FF-000010', NULL, 'Exosome complex exonuclease DIS3', 208, NULL, NULL, 204026),
(204027, '1.10.390.10-FF-000076', NULL, 'Uncharacterized protein', 170, NULL, NULL, 204027),
(204028, '3.40.50.880-FF-000185', NULL, 'Carbamoyl-phosphate synthase small chain, chloroplastic', 122, NULL, NULL, 204028),
(204029, '2.60.40.10-FF-005188', NULL, NULL, 93, NULL, NULL, 204029),
(204030, '1.10.10.60-FF-001091', NULL, NULL, 106, NULL, NULL, 204030),
(204031, '2.60.40.10-FF-001450', NULL, 'Uncharacterized protein', 95, NULL, NULL, 204031),
(204032, '2.60.40.10-FF-004176', NULL, NULL, 86, NULL, NULL, 204032),
(204033, '2.170.150.80-FF-000004', NULL, 'NAC transcription factor', 147, NULL, NULL, 204033),
(204034, '3.40.850.10-FF-000159', NULL, 'Microtubule motor protein', 347, NULL, NULL, 204034),
(204035, '3.30.1920.40-FF-000001', NULL, 'Phage baseplate hub subunit', 66, NULL, NULL, 204035);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(204036, '3.40.50.2020-FF-000178', NULL, 'Uncharacterized protein', 11, NULL, NULL, 204036),
(204037, '1.20.1070.10-FF-000526', NULL, 'Olfactory receptor family 52 subfamily D member 1', 75, NULL, NULL, 204037),
(204038, '2.60.40.10-FF-005160', NULL, NULL, 95, NULL, NULL, 204038),
(204039, '3.30.160.60-FF-002675', NULL, 'Uncharacterized protein', 31, NULL, NULL, 204039),
(204040, '1.10.12.70-FF-000007', NULL, 'STE/STE20/YSK protein kinase', 71, NULL, NULL, 204040),
(204041, '1.20.1280.50-FF-000144', NULL, 'Uncharacterized protein, isoform C', 39, NULL, NULL, 204041),
(204042, '3.20.20.140-FF-000018', NULL, '3''-5'' ssDNA/RNA exonuclease TatD', 262, NULL, NULL, 204042),
(204043, '3.60.20.10-FF-000209', NULL, NULL, 186, NULL, NULL, 204043),
(204044, '3.30.70.330-FF-000493', NULL, 'Peptidyl-prolyl cis-trans isomerase E', 93, NULL, NULL, 204044),
(204045, '3.40.50.150-FF-001866', NULL, NULL, 175, NULL, NULL, 204045),
(204046, '1.10.510.10-FF-003043', NULL, NULL, 215, NULL, NULL, 204046),
(204047, '1.20.120.1240-FF-000075', NULL, 'Dynamin-related protein 3A', 121, NULL, NULL, 204047),
(204048, '1.10.8.350-FF-000001', NULL, 'Lytic murein transglycosylase B', 106, NULL, NULL, 204048),
(204049, '3.40.630.30-FF-000334', NULL, 'N-acetyltransferase', 163, NULL, NULL, 204049),
(204050, '3.80.10.10-FF-002962', NULL, 'Uncharacterized protein', 70, NULL, NULL, 204050),
(204051, '3.40.190.10-FF-000956', NULL, 'Oligopeptide transport periplasmic protein, putative', 218, NULL, NULL, 204051),
(204052, '3.30.70.2280-FF-000011', NULL, 'Uncharacterized protein', 49, NULL, NULL, 204052),
(204053, '1.10.472.10-FF-000244', NULL, 'Cyclin L1a', 116, NULL, NULL, 204053),
(204054, '3.40.190.10-FF-000248', NULL, 'LysR family transcriptional regulator', 91, NULL, NULL, 204054),
(204055, '3.40.50.2300-FF-001009', NULL, NULL, 176, NULL, NULL, 204055),
(204056, '3.30.530.20-FF-000022', NULL, 'StAR-related lipid transfer (START) domain-containing 9', 216, NULL, NULL, 204056),
(204057, '1.10.565.10-FF-000016', NULL, 'Nuclear receptor subfamily 1 group D member 2', 238, NULL, NULL, 204057),
(204058, '3.30.40.10-FF-002084', NULL, 'Uncharacterized protein', 122, NULL, NULL, 204058),
(204059, '1.50.40.10-FF-000261', NULL, 'Solute carrier family 25 member 5', 267, NULL, NULL, 204059),
(204060, '3.40.50.2000-FF-000172', NULL, 'DNA alpha-glucosyltransferase', 210, NULL, NULL, 204060),
(204061, '3.40.50.300-FF-006604', NULL, 'Uncharacterized protein', 96, NULL, NULL, 204061),
(204062, '1.10.10.1930-FF-000001', NULL, 'Transcriptional Regulator BldD', 91, NULL, NULL, 204062),
(204063, '3.40.50.300-FF-007588', NULL, 'ATP-dependent RNA helicase drs1', 175, NULL, NULL, 204063),
(204064, '3.40.720.10-FF-000211', NULL, 'Iduronate 2-sulfatase, putative', 99, NULL, NULL, 204064),
(204065, '2.130.10.110-FF-000007', NULL, 'Clathrin heavy chain', 403, NULL, NULL, 204065),
(204066, '3.40.50.720-FF-001323', NULL, 'Uncharacterized protein', 310, NULL, NULL, 204066),
(204067, '3.30.160.60-FF-005637', NULL, NULL, 26, NULL, NULL, 204067),
(204068, '3.40.1260.20-FF-000009', NULL, 'Ribonuclease E', 96, NULL, NULL, 204068),
(204069, '1.10.1520.10-FF-000114', NULL, 'Uncharacterized protein', 58, NULL, NULL, 204069),
(204070, '3.30.1330.40-FF-000001', NULL, 'L-PSP family endoribonuclease', 125, NULL, NULL, 204070),
(204071, '3.30.465.10-FF-000064', NULL, 'Putative cation efflux protein', 85, NULL, NULL, 204071),
(204072, '2.60.40.10-FF-003479', NULL, NULL, 98, NULL, NULL, 204072),
(204073, '3.30.9.10-FF-000281', NULL, 'Predicted protein', 59, NULL, NULL, 204073),
(204074, '1.20.1270.280-FF-000062', NULL, 'Dynein heavy chain family protein', 160, NULL, NULL, 204074),
(204075, '1.20.58.1610-FF-000009', NULL, 'NADH-ubiquinone oxidoreductase chain 3', 114, NULL, NULL, 204075),
(204076, '2.60.200.20-FF-000152', NULL, 'Uncharacterized protein', 126, NULL, NULL, 204076),
(204077, '3.30.160.60-FF-000258', NULL, 'zinc finger and SCAN domain-containing protein 29 isoform X2', 30, NULL, NULL, 204077),
(204078, '3.30.365.10-FF-000005', NULL, 'Carbon monoxide dehydrogenase large chain', 166, NULL, NULL, 204078);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(204079, '1.10.555.10-FF-000246', NULL, NULL, 171, NULL, NULL, 204079),
(204080, '1.25.40.10-FF-003343', NULL, 'Pre-mRNA-splicing factor CLF1', 91, NULL, NULL, 204080),
(204081, '2.60.40.10-FF-003535', NULL, NULL, 121, NULL, NULL, 204081),
(204082, '3.40.390.10-FF-000320', NULL, NULL, 260, NULL, NULL, 204082),
(204083, '2.130.10.10-FF-004064', NULL, 'Histone-binding protein RBBP4', 207, NULL, NULL, 204083),
(204084, '3.30.1780.10-FF-000014', NULL, 'Uncharacterized protein', 139, NULL, NULL, 204084),
(204085, '2.40.128.50-FF-000002', NULL, 'D-aminopeptidase domain C', 82, NULL, NULL, 204085),
(204086, '2.60.40.1930-FF-000012', NULL, 'Complement C5', 102, NULL, NULL, 204086),
(204087, '3.90.1150.10-FF-000239', NULL, 'DegT/DnrJ/EryC1/StrS aminotransferase family protein', 115, NULL, NULL, 204087),
(204088, '3.40.50.300-FF-007116', NULL, 'Uncharacterized protein', 185, NULL, NULL, 204088),
(204089, '2.80.10.50-FF-000256', NULL, 'Fascin', 127, NULL, NULL, 204089),
(204090, '1.10.230.10-FF-000003', NULL, 'Citrate synthase', 99, NULL, NULL, 204090),
(204091, '1.10.390.10-FF-000020', NULL, 'aminopeptidase O isoform X2', 107, NULL, NULL, 204091),
(204092, '3.40.50.2020-FF-000122', NULL, 'Uridine cytidine kinase I, putative', 73, NULL, NULL, 204092),
(204093, '6.10.140.2220-FF-000067', NULL, 'Uncharacterized protein', 52, NULL, NULL, 204093),
(204094, '3.50.30.30-FF-000037', NULL, 'Peptidase M20', 129, NULL, NULL, 204094),
(204095, '2.130.10.10-FF-002883', NULL, 'Uncharacterized protein', 227, NULL, NULL, 204095),
(204096, '3.40.33.10-FF-000206', NULL, 'Uncharacterized protein', 113, NULL, NULL, 204096),
(204097, '1.10.3720.10-FF-000118', NULL, 'Peptide ABC transporter, permease protein', 206, NULL, NULL, 204097),
(204098, '1.25.40.20-FF-001694', NULL, 'Uncharacterized protein', 72, NULL, NULL, 204098),
(204099, '3.30.70.940-FF-000018', NULL, 'AT3g09210/F3L24_8', 117, NULL, NULL, 204099),
(204100, '1.10.220.160-FF-000016', NULL, 'GD10841', 119, NULL, NULL, 204100),
(204101, '2.30.30.40-FF-000543', NULL, 'Predicted protein', 77, NULL, NULL, 204101),
(204102, '3.40.1280.10-FF-000007', NULL, 'Ribosomal RNA small subunit methyltransferase E', 170, NULL, NULL, 204102),
(204103, '3.50.50.60-FF-000524', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 156, NULL, NULL, 204103),
(204104, '3.30.40.10-FF-000662', NULL, 'Peptidyl-prolyl cis-trans isomerase (Cyclophilin)', 86, NULL, NULL, 204104),
(204105, '1.20.120.1080-FF-000004', NULL, 'ATP-dependent RNA helicase DHX30 isoform X1', 103, NULL, NULL, 204105),
(204106, '2.60.40.10-FF-005721', NULL, NULL, 34, NULL, NULL, 204106),
(204107, '1.10.10.10-FF-001065', NULL, 'Manganese ABC transporter membrane protein', 130, NULL, NULL, 204107),
(204108, '3.20.20.190-FF-000044', NULL, 'Phosphoinositide phospholipase C', 270, NULL, NULL, 204108),
(204109, '1.25.40.20-FF-000058', NULL, 'regulatory protein NPR5 isoform X2', 118, NULL, NULL, 204109),
(204110, '2.30.30.100-FF-000116', NULL, 'Small nuclear ribonucleoprotein Sm D1', 85, NULL, NULL, 204110),
(204111, '1.20.1070.10-FF-001190', NULL, 'Uncharacterized protein', 169, NULL, NULL, 204111),
(204112, '3.60.40.10-FF-000391', NULL, 'Uncharacterized protein', 103, NULL, NULL, 204112),
(204113, '3.80.10.10-FF-004087', NULL, 'Leucine rich repeat neuronal 3', 124, NULL, NULL, 204113),
(204114, '1.10.150.240-FF-000052', NULL, 'HAD family hydrolase', 62, NULL, NULL, 204114),
(204115, '2.60.40.1390-FF-000007', NULL, 'p53-like transcription factor', 112, NULL, NULL, 204115),
(204116, '3.30.200.20-FF-002010', NULL, 'Uncharacterized protein', 95, NULL, NULL, 204116),
(204117, '1.10.10.10-FF-000553', NULL, 'Transcriptional regulator, LuxR family', 82, NULL, NULL, 204117),
(204118, '1.25.10.10-FF-000992', NULL, 'Rotatin', 156, NULL, NULL, 204118),
(204119, '3.40.50.1580-FF-000006', NULL, 'Purine nucleoside phosphorylase', 275, NULL, NULL, 204119),
(204120, '1.25.10.10-FF-002650', NULL, 'Uncharacterized protein', 108, NULL, NULL, 204120),
(204121, '3.90.230.10-FF-000022', NULL, 'DNA-binding protein, 42 kDa', 271, NULL, NULL, 204121);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(204122, '1.20.5.1160-FF-000037', NULL, 'Keratin, type I cytoskeletal 13', 61, NULL, NULL, 204122),
(204123, '6.10.250.3370-FF-000001', NULL, 'Aerobactin siderophore biosynthesis protein iucC', 46, NULL, NULL, 204123),
(204124, '2.60.220.50-FF-000111', NULL, 'Uncharacterized protein', 111, NULL, NULL, 204124),
(204125, '3.10.20.90-FF-001000', NULL, 'Tubulin-specific chaperone E-like Protein', 86, NULL, NULL, 204125),
(204126, '2.10.50.10-FF-000132', NULL, 'signal peptide, CUB and EGF-like domain-containing protein 2 isoform X1', 66, NULL, NULL, 204126),
(204127, '1.10.287.1490-FF-000106', NULL, 'Uncharacterized protein', 162, NULL, NULL, 204127),
(204128, '3.50.50.60-FF-000468', NULL, 'Salicylate hydroxylase', 399, NULL, NULL, 204128),
(204129, '1.25.40.420-FF-000016', NULL, 'BTB/POZ domain-containing protein 7 isoform X1', 89, NULL, NULL, 204129),
(204130, '3.40.50.1000-FF-000001', NULL, 'Phospholipid-transporting ATPase IC', 13, NULL, NULL, 204130),
(204131, '3.30.70.1450-FF-000032', NULL, 'Trk system potassium uptake protein TrkA', 88, NULL, NULL, 204131),
(204132, '2.60.410.10-FF-000013', NULL, NULL, 89, NULL, NULL, 204132),
(204133, '1.10.8.1220-FF-000030', NULL, NULL, 62, NULL, NULL, 204133),
(204134, '2.170.300.10-FF-000006', NULL, 'Multiple epidermal growth factor-like domains protein 11', 127, NULL, NULL, 204134),
(204135, '3.30.160.60-FF-006042', NULL, NULL, 58, NULL, NULL, 204135),
(204136, '1.10.579.10-FF-000014', NULL, 'Cry4 protein', 135, NULL, NULL, 204136),
(204137, '3.90.1280.20-FF-000016', NULL, NULL, 63, NULL, NULL, 204137),
(204138, '3.60.40.10-FF-000008', NULL, 'Phosphatase 2C family protein', 330, NULL, NULL, 204138),
(204139, '1.25.10.10-FF-002318', NULL, 'Predicted protein', 311, NULL, NULL, 204139),
(204140, '3.90.920.10-FF-000018', NULL, 'DNA primase small subunit PriS', 304, NULL, NULL, 204140),
(204141, '3.40.50.720-FF-000918', NULL, 'Ornithine cyclodeaminase, putative', 178, NULL, NULL, 204141),
(204142, '3.20.80.10-FF-000013', NULL, 'Soul heme-binding family protein', 120, NULL, NULL, 204142),
(204143, '3.90.190.10-FF-000518', NULL, 'Uncharacterized protein', 123, NULL, NULL, 204143),
(204144, '3.40.50.720-FF-000598', NULL, 'Fatty acyl-CoA reductase', 354, NULL, NULL, 204144),
(204145, '1.10.510.10-FF-003863', NULL, NULL, 98, NULL, NULL, 204145),
(204146, '2.40.50.140-FF-000647', NULL, 'Protection of telomeres protein 1b', 144, NULL, NULL, 204146),
(204147, '1.25.40.10-FF-001634', NULL, 'Calcineurin-binding protein cabin-1', 231, NULL, NULL, 204147),
(204148, '2.130.10.10-FF-002411', NULL, 'Striatin', 123, NULL, NULL, 204148),
(204149, '2.60.40.10-FF-001826', NULL, 'Immunoglobulin kappa chain variable 4-91', 98, NULL, NULL, 204149),
(204150, '3.30.450.20-FF-000488', NULL, 'Sensor histidine kinase TodS', 127, NULL, NULL, 204150),
(204151, '3.40.50.1820-FF-001495', NULL, 'Uncharacterized protein', 163, NULL, NULL, 204151),
(204152, '3.40.50.300-FF-003373', NULL, 'RNA helicase', 229, NULL, NULL, 204152),
(204153, '3.30.1330.30-FF-000144', NULL, 'Uncharacterized protein', 56, NULL, NULL, 204153),
(204154, '1.10.472.80-FF-000276', NULL, NULL, 58, NULL, NULL, 204154),
(204155, '3.40.220.10-FF-000010', NULL, 'Poly [ADP-ribose] polymerase', 196, NULL, NULL, 204155),
(204156, '1.10.1370.40-FF-000004', NULL, 'DnaJ protein, putative', 288, NULL, NULL, 204156),
(204157, '1.10.630.10-FF-000792', NULL, 'Retinoic acid catabolizing enzyme', 105, NULL, NULL, 204157),
(204158, '3.30.1490.20-FF-000063', NULL, 'Zgc:123047', 47, NULL, NULL, 204158),
(204159, '3.30.200.20-FF-002482', NULL, 'Uncharacterized protein', 35, NULL, NULL, 204159),
(204160, '2.70.160.11-FF-000020', NULL, 'Protein arginine N-methyltransferase', 190, NULL, NULL, 204160),
(204161, '3.60.40.10-FF-000239', NULL, 'Uncharacterized protein', 244, NULL, NULL, 204161),
(204162, '3.30.420.40-FF-000615', NULL, 'Actin-related protein 7', 22, NULL, NULL, 204162),
(204163, '2.10.10.10-FF-000011', NULL, 'Uncharacterized protein', 57, NULL, NULL, 204163),
(204164, '1.20.58.60-FF-000609', NULL, 'Spectrin repeat-containing, nuclear envelope family member 3', 283, NULL, NULL, 204164);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(204165, '2.70.170.10-FF-000008', NULL, 'Cholinergic receptor nicotinic alpha 6 subunit', 218, NULL, NULL, 204165),
(204166, '3.80.10.10-FF-003631', NULL, 'Predicted protein', 182, NULL, NULL, 204166),
(204167, '1.25.40.800-FF-000001', NULL, 'CCR4-NOT transcription complex subunit 1', 218, NULL, NULL, 204167),
(204168, '1.25.40.20-FF-000710', NULL, 'Ankyrin repeat domain 27 (VPS9 domain)', 90, NULL, NULL, 204168),
(204169, '4.10.910.10-FF-000010', NULL, 'Ribosomal protein S13', 25, NULL, NULL, 204169),
(204170, '1.25.40.20-FF-000390', NULL, 'Ankyrin repeat-containing protein NPR4', 72, NULL, NULL, 204170),
(204171, '3.40.50.300-FF-001225', NULL, 'ATP-binding cassette sub-family G member', 238, NULL, NULL, 204171),
(204172, '2.60.120.380-FF-000047', NULL, 'Uncharacterized protein', 154, NULL, NULL, 204172),
(204173, '3.30.360.10-FF-000040', NULL, 'Inositol 1-phosphate synthase', 107, NULL, NULL, 204173),
(204174, '2.60.40.10-FF-002231', NULL, 'Titin, isoform CRA_a', 108, NULL, NULL, 204174),
(204175, '1.20.20.10-FF-000025', NULL, 'Os01g0899350 protein', 55, NULL, NULL, 204175),
(204176, '1.20.120.1200-FF-000018', NULL, 'NADH-ubiquinone oxidoreductase chain 6', 146, NULL, NULL, 204176),
(204177, '3.30.1490.10-FF-000003', NULL, '40S ribosomal protein S15a-5', 61, NULL, NULL, 204177),
(204178, '2.60.40.10-FF-005952', NULL, NULL, 91, NULL, NULL, 204178),
(204179, '4.10.280.10-FF-000219', NULL, 'Hairy-related 9', 35, NULL, NULL, 204179),
(204180, '1.20.120.850-FF-000030', NULL, 'Uncharacterized protein', 102, NULL, NULL, 204180),
(204181, '3.30.70.1230-FF-000202', NULL, 'Uncharacterized protein', 100, NULL, NULL, 204181),
(204182, '3.30.230.70-FF-000059', NULL, 'FI01414p', 222, NULL, NULL, 204182),
(204183, '2.130.10.10-FF-005789', NULL, 'Uncharacterized protein', 97, NULL, NULL, 204183),
(204184, '1.20.120.140-FF-000002', NULL, 'Signal recognition particle receptor FtsY', 95, NULL, NULL, 204184),
(204185, '3.30.420.10-FF-000511', NULL, NULL, 130, NULL, NULL, 204185),
(204186, '2.170.270.10-FF-000155', NULL, 'Uncharacterized protein', 151, NULL, NULL, 204186),
(204187, '1.10.510.10-FF-002115', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase pek-1', 191, NULL, NULL, 204187),
(204188, '2.60.120.200-FF-000510', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1', 180, NULL, NULL, 204188),
(204189, '3.30.200.20-FF-000593', NULL, 'Predicted protein', 89, NULL, NULL, 204189),
(204190, '3.30.70.330-FF-001038', NULL, 'BnaA10g11870D protein', 167, NULL, NULL, 204190),
(204191, '2.40.160.40-FF-000001', NULL, 'Porin OmpL', 206, NULL, NULL, 204191),
(204192, '3.30.390.120-FF-000001', NULL, 'Nitric oxide reductase FlRd-NAD(+) reductase', 63, NULL, NULL, 204192),
(204193, '3.90.550.10-FF-000237', NULL, 'WGS project CABT00000000 data, contig 2.1', 195, NULL, NULL, 204193),
(204194, '2.60.40.10-FF-000045', NULL, 'Ephrin type-A receptor 5', 101, NULL, NULL, 204194),
(204195, '3.40.50.2300-FF-001392', NULL, NULL, 71, NULL, NULL, 204195),
(204196, '1.10.3090.10-FF-000007', NULL, 'tRNA nucleotidyltransferase', 291, NULL, NULL, 204196),
(204197, '3.90.199.10-FF-000010', NULL, 'DNA gyrase subunit A', 92, NULL, NULL, 204197),
(204198, '2.40.50.140-FF-000703', NULL, NULL, 97, NULL, NULL, 204198),
(204199, '3.30.200.20-FF-000121', NULL, 'Ribosomal protein S6 kinase', 96, NULL, NULL, 204199),
(204200, '1.20.920.10-FF-000222', NULL, 'Uncharacterized protein', 69, NULL, NULL, 204200),
(204201, '3.30.1520.10-FF-000001', NULL, 'Sorting nexin', 162, NULL, NULL, 204201),
(204202, '3.30.40.10-FF-001948', NULL, 'E3 ubiquitin-protein ligase RHA2A', 67, NULL, NULL, 204202),
(204203, '3.40.1360.10-FF-000008', NULL, 'Mitochondrial helicase twinkle', 110, NULL, NULL, 204203),
(204204, '3.40.50.2000-FF-000964', NULL, 'Uncharacterized protein', 97, NULL, NULL, 204204),
(204205, '3.90.320.10-FF-000052', NULL, 'Gustatory receptor 125', 203, NULL, NULL, 204205),
(204206, '1.10.20.10-FF-000110', NULL, 'Nuclear factor Y, subunit B1', 100, NULL, NULL, 204206),
(204207, '1.10.10.10-FF-001773', NULL, 'Signal transduction response regulator, antiterminator', 58, NULL, NULL, 204207);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(204208, '1.25.40.10-FF-002938', NULL, 'Pentatricopeptide repeat-containing protein At4g39620, chloroplastic', 205, NULL, NULL, 204208),
(204209, '1.20.58.400-FF-000042', NULL, 'Uncharacterized protein', 88, NULL, NULL, 204209),
(204210, '1.10.510.10-FF-003335', NULL, NULL, 52, NULL, NULL, 204210),
(204211, '3.40.50.1820-FF-001023', NULL, 'KAT8 regulatory NSL complex subunit 3', 194, NULL, NULL, 204211),
(204212, '3.10.310.10-FF-000024', NULL, 'Yhi9p', 122, NULL, NULL, 204212),
(204213, '3.30.1600.10-FF-000002', NULL, 'NAD-dependent protein deacylase', 95, NULL, NULL, 204213),
(204214, '3.30.70.330-FF-002022', NULL, NULL, 104, NULL, NULL, 204214),
(204215, '3.40.30.10-FF-000172', NULL, 'Glutathione S-transferase GstA', 94, NULL, NULL, 204215),
(204216, '3.20.10.10-FF-000008', NULL, 'Branched-chain-amino-acid aminotransferase', 167, NULL, NULL, 204216),
(204217, '1.20.1560.10-FF-000434', NULL, 'ABC transporter, putative', 187, NULL, NULL, 204217),
(204218, '1.20.90.10-FF-000012', NULL, 'Phospholipase A2 group III', 114, NULL, NULL, 204218),
(204219, '1.10.238.10-FF-001049', NULL, 'Guanylate cyclase activator 1e', 18, NULL, NULL, 204219),
(204220, '1.20.1440.200-FF-000004', NULL, 'Vacuolar protein sorting-associated protein 28', 97, NULL, NULL, 204220),
(204221, '1.20.140.150-FF-000099', NULL, 'Voltage-dependent calcium channel gamma-2 subunit', 93, NULL, NULL, 204221),
(204222, '2.60.210.10-FF-000065', NULL, NULL, 141, NULL, NULL, 204222),
(204223, '1.20.1110.10-FF-000030', NULL, 'Sodium/potassium-transporting ATPase subunit alpha', 148, NULL, NULL, 204223),
(204224, '3.60.20.10-FF-000064', NULL, 'Proteasome subunit beta type-6', 202, NULL, NULL, 204224),
(204225, '3.40.50.2300-FF-000464', NULL, 'LuxR family transcriptional regulator', 125, NULL, NULL, 204225),
(204226, '1.10.1070.11-FF-000018', NULL, 'DNA-dependent protein kinase catalytic subunit', 182, NULL, NULL, 204226),
(204227, '3.30.160.60-FF-002203', NULL, 'Zinc finger protein 142-like Protein', 62, NULL, NULL, 204227),
(204228, '1.20.58.60-FF-000233', NULL, 'nesprin-1 isoform X9', 221, NULL, NULL, 204228),
(204229, '3.40.50.2000-FF-000436', NULL, 'UDP-glucuronosyltransferase', 177, NULL, NULL, 204229),
(204230, '1.50.40.10-FF-000553', NULL, 'Uncharacterized protein', 131, NULL, NULL, 204230),
(204231, '3.80.10.10-FF-002198', NULL, 'NACHT, LRR and PYD domains-containing protein 15', 113, NULL, NULL, 204231),
(204232, '3.10.490.20-FF-000040', NULL, 'Uncharacterized protein', 115, NULL, NULL, 204232),
(204233, '3.60.15.10-FF-000175', NULL, 'Slr2005 protein', 223, NULL, NULL, 204233),
(204234, '2.60.40.1730-FF-000008', NULL, 'aminopeptidase O isoform X1', 206, NULL, NULL, 204234),
(204235, '3.40.50.10330-FF-000017', NULL, 'NAD kinase', 98, NULL, NULL, 204235),
(204236, '1.10.10.60-FF-000719', NULL, 'Homeobox protein orthopedia-like Protein', 63, NULL, NULL, 204236),
(204237, '2.120.10.80-FF-000055', NULL, 'kelch domain-containing protein 3 isoform X1', 180, NULL, NULL, 204237),
(204238, '3.40.50.300-FF-005879', NULL, 'Uncharacterized protein', 165, NULL, NULL, 204238),
(204239, '3.30.160.60-FF-003928', NULL, NULL, 30, NULL, NULL, 204239),
(204240, '3.40.50.300-FF-004098', NULL, 'ABC transporter ATP-binding protein', 246, NULL, NULL, 204240),
(204241, '2.60.40.10-FF-000994', NULL, 'Sialic acid binding Ig like lectin 10', 90, NULL, NULL, 204241),
(204242, '1.25.10.10-FF-001806', NULL, 'Uncharacterized protein', 290, NULL, NULL, 204242),
(204243, '2.60.120.10-FF-000474', NULL, 'Cysteine dioxygenase', 203, NULL, NULL, 204243),
(204244, '2.130.10.10-FF-002355', NULL, 'Transducin', 177, NULL, NULL, 204244),
(204245, '3.40.50.150-FF-001635', NULL, NULL, 236, NULL, NULL, 204245),
(204246, '3.30.1390.20-FF-000004', NULL, '60S ribosomal protein L7', 97, NULL, NULL, 204246),
(204247, '1.10.3170.10-FF-000008', NULL, 'RecBCD enzyme subunit RecB', 208, NULL, NULL, 204247),
(204248, '2.60.40.10-FF-000606', NULL, 'Vascular endothelial growth factor receptor 1', 94, NULL, NULL, 204248),
(204249, '3.30.160.60-FF-001894', NULL, 'Zinc finger protein 768', 22, NULL, NULL, 204249); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(204250, '3.40.50.620-FF-000714', NULL, 'Uncharacterized protein', 219, NULL, NULL, 204250),
(204251, '3.40.50.10810-FF-000251', NULL, 'Uncharacterized protein', 128, NULL, NULL, 204251),
(204252, '3.30.70.330-FF-002730', NULL, NULL, 141, NULL, NULL, 204252),
(204253, '3.80.10.10-FF-004143', NULL, 'Uncharacterized protein', 109, NULL, NULL, 204253),
(204254, '1.25.40.10-FF-002562', NULL, 'Pentatricopeptide repeat-containing protein', 207, NULL, NULL, 204254),
(204255, '2.30.29.30-FF-000469', NULL, 'unconventional myosin-XV', 109, NULL, NULL, 204255),
(204256, '2.40.10.10-FF-000499', NULL, NULL, 107, NULL, NULL, 204256),
(204257, '3.30.499.10-FF-000041', NULL, NULL, 155, NULL, NULL, 204257),
(204258, '2.120.10.30-FF-000321', NULL, 'Uncharacterized protein', 83, NULL, NULL, 204258),
(204259, '3.40.50.410-FF-000241', NULL, 'Uncharacterized protein', 163, NULL, NULL, 204259),
(204260, '3.40.50.300-FF-007824', NULL, 'Uncharacterized protein', 342, NULL, NULL, 204260),
(204261, '1.10.10.2670-FF-000009', NULL, 'Putative com1 regulatory protein', 93, NULL, NULL, 204261),
(204262, '1.20.120.160-FF-000008', NULL, 'Chemotaxis sensor histidine kinase CheA', 133, NULL, NULL, 204262),
(204263, '3.40.190.10-FF-000479', NULL, 'Phosphate ABC transporter substrate-binding protein', 113, NULL, NULL, 204263),
(204264, '1.10.10.60-FF-000399', NULL, 'Homeobox protein B-H1', 91, NULL, NULL, 204264),
(204265, '3.10.180.10-FF-000081', NULL, 'Uncharacterized 4-hydroxyphenylpyruvate dioxygenase-like protein', 210, NULL, NULL, 204265),
(204266, '1.25.40.470-FF-000042', NULL, 'CRE-CHE-11 protein', 178, NULL, NULL, 204266),
(204267, '3.40.50.300-FF-002445', NULL, 'ATP-dependent RNA helicase prh1, putative', 200, NULL, NULL, 204267),
(204268, '1.10.168.20-FF-000006', NULL, '40S ribosomal protein S8', 53, NULL, NULL, 204268),
(204269, '2.30.29.30-FF-000380', NULL, 'Interferon-induced guanylate-binding protein 1-like', 136, NULL, NULL, 204269),
(204270, '3.40.50.300-FF-005790', NULL, 'Si:dkey-11m19.5', 270, NULL, NULL, 204270),
(204271, '1.20.120.1760-FF-000017', NULL, 'Phosphatidyl synthase', 198, NULL, NULL, 204271),
(204272, '1.20.5.340-FF-000086', NULL, 'Uncharacterized protein', 83, NULL, NULL, 204272),
(204273, '1.10.287.110-FF-000001', NULL, 'Import inner membrane translocase subunit tim14', 67, NULL, NULL, 204273),
(204274, '3.30.70.330-FF-000785', NULL, 'NONO (Conserved nuclear protein, aka PSF) homolog', 89, NULL, NULL, 204274),
(204275, '1.10.3520.10-FF-000030', NULL, 'Uncharacterized protein', 163, NULL, NULL, 204275),
(204276, '2.60.40.10-FF-005665', NULL, NULL, 87, NULL, NULL, 204276),
(204277, '1.10.510.40-FF-000005', NULL, 'IucA/IucC family siderophore biosynthesis protein', 199, NULL, NULL, 204277),
(204278, '2.30.42.10-FF-000247', NULL, 'DegP protease 7', 102, NULL, NULL, 204278),
(204279, '2.10.25.10-FF-000860', NULL, 'Attractin', 69, NULL, NULL, 204279),
(204280, '3.40.50.10800-FF-000006', NULL, 'Quinolinate synthase, chloroplastic', 97, NULL, NULL, 204280),
(204281, '3.40.50.620-FF-000006', NULL, 'bifunctional 3''-phosphoadenosine 5''-phosphosulfate synthase 1', 234, NULL, NULL, 204281),
(204282, '3.40.50.300-FF-002389', NULL, 'Related to ATP-binding cassette, sub-family G, member 2', 225, NULL, NULL, 204282),
(204283, '3.40.50.1780-FF-000010', NULL, 'Nuclear prelamin A recognition factor', 61, NULL, NULL, 204283),
(204284, '1.25.10.10-FF-003431', NULL, 'Uncharacterized protein', 160, NULL, NULL, 204284),
(204285, '3.40.50.10190-FF-000048', NULL, 'DNA repair protein Rtt107', 89, NULL, NULL, 204285),
(204286, '3.30.160.60-FF-004709', NULL, NULL, 34, NULL, NULL, 204286),
(204287, '1.20.140.40-FF-000087', NULL, NULL, 108, NULL, NULL, 204287),
(204288, '1.10.510.10-FF-000373', NULL, 'Receptor protein-tyrosine kinase', 204, NULL, NULL, 204288),
(204289, '3.40.630.10-FF-000384', NULL, 'Predicted protein', 75, NULL, NULL, 204289),
(204290, '1.10.132.70-FF-000017', NULL, 'Telomerase reverse transcriptase', 227, NULL, NULL, 204290),
(204291, '3.80.10.10-FF-003159', NULL, 'Os11g0685600 protein', 283, NULL, NULL, 204291); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(204292, '1.20.1070.10-FF-000262', NULL, 'Frizzled 2', 356, NULL, NULL, 204292),
(204293, '3.80.10.10-FF-000809', NULL, 'Uncharacterized protein', 179, NULL, NULL, 204293),
(204294, '2.60.40.2030-FF-000008', NULL, 'FRAS1-related extracellular matrix protein 2', 121, NULL, NULL, 204294),
(204295, '1.10.510.10-FF-004116', NULL, NULL, 108, NULL, NULL, 204295),
(204296, '3.80.10.10-FF-002703', NULL, 'Predicted protein', 117, NULL, NULL, 204296),
(204297, '1.20.200.10-FF-000038', NULL, 'Adenylosuccinate lyase', 55, NULL, NULL, 204297),
(204298, '2.130.10.10-FF-002916', NULL, 'Chromosome 8, whole genome shotgun sequence', 153, NULL, NULL, 204298),
(204299, '2.130.10.10-FF-003283', NULL, 'Uncharacterized protein', 147, NULL, NULL, 204299),
(204300, '3.30.160.20-FF-000241', NULL, 'Uncharacterized protein', 47, NULL, NULL, 204300),
(204301, '1.25.40.20-FF-000766', NULL, 'KN motif and ankyrin repeat domains 2', 242, NULL, NULL, 204301),
(204302, '3.30.200.20-FF-001610', NULL, 'Putative WAK-related receptor-like protein kinase family protein', 101, NULL, NULL, 204302),
(204303, '3.40.50.10310-FF-000011', NULL, 'Creatinine amidohydrolase', 233, NULL, NULL, 204303),
(204304, '1.20.5.110-FF-000163', NULL, 'Vesicle transport v-SNARE protein, putative', 60, NULL, NULL, 204304),
(204305, '1.10.418.10-FF-000130', NULL, 'Actinin alpha 1', 29, NULL, NULL, 204305),
(204306, '1.25.10.10-FF-001245', NULL, 'RING-type E3 ubiquitin transferase', 193, NULL, NULL, 204306),
(204307, '3.80.10.10-FF-003687', NULL, 'Uncharacterized protein', 305, NULL, NULL, 204307),
(204308, '1.10.150.50-FF-000166', NULL, 'Uncharacterized protein', 73, NULL, NULL, 204308),
(204309, '3.40.50.1820-FF-001528', NULL, 'Uncharacterized protein', 144, NULL, NULL, 204309),
(204310, '3.30.1120.120-FF-000002', NULL, 'Probable serine/threonine-protein kinase zyg-1', 114, NULL, NULL, 204310),
(204311, '1.20.58.760-FF-000037', NULL, 'Os01g0590700 protein', 115, NULL, NULL, 204311),
(204312, '2.10.25.10-FF-000675', NULL, 'Delta-like protein', 39, NULL, NULL, 204312),
(204313, '2.60.40.10-FF-002607', NULL, 'Chitodextrinase', 92, NULL, NULL, 204313),
(204314, '3.20.20.70-FF-000448', NULL, 'Thiamine-phosphate synthase', 205, NULL, NULL, 204314),
(204315, '4.10.400.10-FF-000196', NULL, 'RT10567p', 42, NULL, NULL, 204315),
(204316, '1.20.1250.20-FF-001465', NULL, 'MFS transporter', 222, NULL, NULL, 204316),
(204317, '3.40.50.1820-FF-000191', NULL, 'LIPaSe related', 294, NULL, NULL, 204317),
(204318, '1.10.150.530-FF-000015', NULL, 'Ribosomal RNA large subunit methyltransferase N', 58, NULL, NULL, 204318),
(204319, '3.40.1380.20-FF-000052', NULL, 'Pyruvate kinase', 155, NULL, NULL, 204319),
(204320, '3.40.50.720-FF-002487', NULL, 'ThiF family protein', 180, NULL, NULL, 204320),
(204321, '3.10.20.90-FF-000359', NULL, 'Replication stress response regulator SDE2', 85, NULL, NULL, 204321),
(204322, '3.40.140.10-FF-000004', NULL, '26S proteasome regulatory subunit rpn-8', 183, NULL, NULL, 204322),
(204323, '2.30.39.10-FF-000048', NULL, 'Serine protease inhibitor (serpin) 12', 150, NULL, NULL, 204323),
(204324, '2.130.10.10-FF-004300', NULL, 'Pre-mRNA-processing factor 19 homolog 2', 118, NULL, NULL, 204324),
(204325, '3.30.70.80-FF-000050', NULL, 'Uncharacterized protein', 81, NULL, NULL, 204325),
(204326, '1.10.287.10-FF-000021', NULL, 'Mrps28p', 84, NULL, NULL, 204326),
(204327, '3.40.250.10-FF-000158', NULL, 'Ubiquitin carboxyl-terminal hydrolase 4', 144, NULL, NULL, 204327),
(204328, '3.40.50.300-FF-000444', NULL, 'ATP-dependent DNA helicase', 211, NULL, NULL, 204328),
(204329, '4.10.1000.40-FF-000014', NULL, 'YALI0E13794p', 69, NULL, NULL, 204329),
(204330, '2.105.10.10-FF-000002', NULL, 'Adsorption protein P2', 63, NULL, NULL, 204330),
(204331, '2.130.10.10-FF-004772', NULL, 'WD repeat protein iqw1', 155, NULL, NULL, 204331),
(204332, '3.30.780.10-FF-000037', NULL, 'Uncharacterized protein', 134, NULL, NULL, 204332),
(204333, '1.20.120.350-FF-000239', NULL, NULL, 118, NULL, NULL, 204333),
(204334, '1.20.190.50-FF-000003', NULL, 'Nuclear pore complex protein', 229, NULL, NULL, 204334);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(204335, '1.20.5.500-FF-000010', NULL, NULL, 82, NULL, NULL, 204335),
(204336, '3.40.50.300-FF-005823', NULL, 'ATP-dependent DNA helicase RecQ', 187, NULL, NULL, 204336),
(204337, '2.60.260.50-FF-000001', NULL, 'Genome polyprotein', 82, NULL, NULL, 204337),
(204338, '2.40.40.20-FF-000037', NULL, 'Peroxisomal biogenesis factor 1', 93, NULL, NULL, 204338),
(204339, '1.10.238.10-FF-000981', NULL, 'Calcium-binding mitochondrial carrier protein', 151, NULL, NULL, 204339),
(204340, '1.10.8.60-FF-000090', NULL, 'Chromosomal replication initiator protein DnaA', 69, NULL, NULL, 204340),
(204341, '1.50.10.10-FF-000164', NULL, 'alpha-1,2-Mannosidase', 166, NULL, NULL, 204341),
(204342, '1.10.630.10-FF-000404', NULL, 'Uncharacterized protein', 485, NULL, NULL, 204342),
(204343, '3.10.120.10-FF-000009', NULL, 'Cytochrome b2, mitochondrial, putative', 90, NULL, NULL, 204343),
(204344, '1.25.40.10-FF-004563', NULL, 'Uncharacterized protein', 200, NULL, NULL, 204344),
(204345, '3.40.532.10-FF-000038', NULL, NULL, 221, NULL, NULL, 204345),
(204346, '2.60.120.260-FF-000157', NULL, 'Cytosolic endo-beta-N-acetylglucosaminidase 1', 193, NULL, NULL, 204346),
(204347, '2.40.30.10-FF-000298', NULL, 'Putative translation initiation factor EIF-2B gamma subunit', 115, NULL, NULL, 204347),
(204348, '3.40.1440.10-FF-000009', NULL, 'Excinuclease ABC subunit C', 89, NULL, NULL, 204348),
(204349, '3.90.190.10-FF-000198', NULL, 'Dual specificity protein phosphatase, putative', 164, NULL, NULL, 204349),
(204350, '1.25.50.20-FF-000031', NULL, 'Aminopeptidase', 286, NULL, NULL, 204350),
(204351, '1.25.40.20-FF-001171', NULL, 'Ankyrin repeat family protein', 49, NULL, NULL, 204351),
(204352, '3.30.230.10-FF-000356', NULL, 'Uncharacterized protein', 125, NULL, NULL, 204352),
(204353, '4.10.60.10-FF-000173', NULL, 'Zinc finger CCHC-type containing 7', 47, NULL, NULL, 204353),
(204354, '3.90.180.10-FF-000169', NULL, 'Uncharacterized protein', 76, NULL, NULL, 204354),
(204355, '2.10.25.10-FF-000528', NULL, 'Growth arrest-specific protein 6', 40, NULL, NULL, 204355),
(204356, '3.40.50.300-FF-003878', NULL, 'ADP ribosylation factor like GTPase 5B', 115, NULL, NULL, 204356),
(204357, '1.10.510.10-FF-002879', NULL, NULL, 220, NULL, NULL, 204357),
(204358, '1.25.40.10-FF-000853', NULL, 'Pentatricopeptide repeat-containing protein At2g13600', 158, NULL, NULL, 204358),
(204359, '3.30.160.60-FF-000966', NULL, 'ZFP90 zinc finger protein', 29, NULL, NULL, 204359),
(204360, '3.30.420.10-FF-000191', NULL, 'Transposase', 200, NULL, NULL, 204360),
(204361, '3.90.70.10-FF-000088', NULL, 'Ubl carboxyl-terminal hydrolase 18', 324, NULL, NULL, 204361),
(204362, '3.40.50.2300-FF-000700', NULL, 'Sporulation initiation phosphotransferase F', 139, NULL, NULL, 204362),
(204363, '3.40.50.1100-FF-000121', NULL, 'PLP-dependent cysteine synthase family protein', 189, NULL, NULL, 204363),
(204364, '1.20.1070.10-FF-001223', NULL, 'Beta-2 adrenergic receptor', 107, NULL, NULL, 204364),
(204365, '2.30.29.30-FF-001397', NULL, 'Uncharacterized protein', 94, NULL, NULL, 204365),
(204366, '3.40.30.10-FF-000548', NULL, 'Glutathione S-transferase theta-1', 94, NULL, NULL, 204366),
(204367, '3.30.160.60-FF-003372', NULL, 'LD46263p', 74, NULL, NULL, 204367),
(204368, '1.20.1540.10-FF-000074', NULL, 'Uncharacterized protein', 197, NULL, NULL, 204368),
(204369, '3.40.50.620-FF-000478', NULL, 'Leucyl Amino-acyl tRNA Synthetase', 182, NULL, NULL, 204369),
(204370, '3.30.70.330-FF-002494', NULL, NULL, 75, NULL, NULL, 204370),
(204371, '3.90.70.10-FF-000796', NULL, 'Predicted protein', 324, NULL, NULL, 204371),
(204372, '3.40.50.12780-FF-000206', NULL, 'Fatty acid transporter protein-like protein', 269, NULL, NULL, 204372),
(204373, '1.25.40.10-FF-000145', NULL, 'G-protein-signaling modulator 1 isoform X2', 74, NULL, NULL, 204373),
(204374, '3.30.40.10-FF-001387', NULL, 'Putative histone-lysine n-methyltransferase 2c-like isoform x5', 64, NULL, NULL, 204374),
(204375, '2.10.90.10-FF-000106', NULL, 'VEGF183 protein, putative', 124, NULL, NULL, 204375),
(204376, '3.40.50.300-FF-006992', NULL, 'Uncharacterized protein', 212, NULL, NULL, 204376);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(204377, '3.30.710.10-FF-000382', NULL, 'Uncharacterized protein', 106, NULL, NULL, 204377),
(204378, '3.20.20.10-FF-000037', NULL, 'Alanine racemase', 218, NULL, NULL, 204378),
(204379, '1.10.238.10-FF-000796', NULL, 'EF-hand superfamily Ca2+-modulated protein (AFU_orthologue AFUA_5G13630)', 78, NULL, NULL, 204379),
(204380, '3.40.50.1220-FF-000011', NULL, 'NAD-dependent deacetylase sirtuin-7', 181, NULL, NULL, 204380),
(204381, '1.50.10.10-FF-000017', NULL, 'alpha-1,2-Mannosidase', 467, NULL, NULL, 204381),
(204382, '1.10.287.110-FF-000473', NULL, 'Predicted protein', 116, NULL, NULL, 204382),
(204383, '1.25.40.10-FF-000673', NULL, 'TPR-repeat-containing chaperone protein DNAJ', 130, NULL, NULL, 204383),
(204384, '1.20.1310.10-FF-000118', NULL, NULL, 132, NULL, NULL, 204384),
(204385, '3.80.10.10-FF-001181', NULL, 'Leucine-rich repeat family protein', 235, NULL, NULL, 204385),
(204386, '3.30.1120.10-FF-000072', NULL, 'Predicted protein', 122, NULL, NULL, 204386),
(204387, '2.60.40.1500-FF-000001', NULL, 'Alpha-L-iduronidase', 145, NULL, NULL, 204387),
(204388, '3.40.1110.10-FF-000440', NULL, NULL, 148, NULL, NULL, 204388),
(204389, '1.50.10.160-FF-000006', NULL, 'Bifunctional diterpene synthase, chloroplastic', 214, NULL, NULL, 204389),
(204390, '1.10.510.10-FF-003099', NULL, NULL, 247, NULL, NULL, 204390),
(204391, '3.30.160.60-FF-005261', NULL, NULL, 31, NULL, NULL, 204391),
(204392, '2.30.30.140-FF-000191', NULL, 'T17B22.17 protein', 120, NULL, NULL, 204392),
(204393, '2.70.98.40-FF-000012', NULL, NULL, 239, NULL, NULL, 204393),
(204394, '1.20.1090.10-FF-000061', NULL, 'Uncharacterized protein', 126, NULL, NULL, 204394),
(204395, '3.30.200.20-FF-000065', NULL, 'SRSF protein kinase 2', 90, NULL, NULL, 204395),
(204396, '3.40.50.10490-FF-000109', NULL, NULL, 192, NULL, NULL, 204396),
(204397, '2.40.33.10-FF-000012', NULL, 'Pyruvate kinase', 95, NULL, NULL, 204397),
(204398, '3.40.20.10-FF-000143', NULL, 'Protein app1', 137, NULL, NULL, 204398),
(204399, '3.40.50.300-FF-004862', NULL, 'Uncharacterized protein', 163, NULL, NULL, 204399),
(204400, '1.10.8.50-FF-000030', NULL, 'Ribosomal protein S13', 65, NULL, NULL, 204400),
(204401, '3.30.565.10-FF-000425', NULL, 'Phosphatase', 141, NULL, NULL, 204401),
(204402, '1.25.40.10-FF-001073', NULL, 'Transcription factor EMB1444', 155, NULL, NULL, 204402),
(204403, '3.40.50.1370-FF-000005', NULL, 'CAD protein-like isoform X1', 137, NULL, NULL, 204403),
(204404, '2.40.30.70-FF-000001', NULL, 'tRNA (N6-threonylcarbamoyladenosine(37)-N6)-methyltransferase TrmO', 140, NULL, NULL, 204404),
(204405, '1.20.58.390-FF-000061', NULL, 'Ligand-Gated ion Channel', 139, NULL, NULL, 204405),
(204406, '1.10.400.10-FF-000016', NULL, 'Guanine nucleotide-binding protein alpha-7 subunit', 118, NULL, NULL, 204406),
(204407, '1.25.40.610-FF-000011', NULL, 'Adhesion G protein-coupled receptor B2', 131, NULL, NULL, 204407),
(204408, '2.40.70.10-FF-000328', NULL, NULL, 173, NULL, NULL, 204408),
(204409, '3.80.10.10-FF-000961', NULL, 'Protein phosphatase PP1 regulatory subunit sds22', 80, NULL, NULL, 204409),
(204410, '3.40.1190.20-FF-000037', NULL, 'Fructokinase', 309, NULL, NULL, 204410),
(204411, '3.30.160.60-FF-004333', NULL, NULL, 22, NULL, NULL, 204411),
(204412, '3.30.40.10-FF-001443', NULL, 'Ubiquitinyl hydrolase 1', 101, NULL, NULL, 204412),
(204413, '2.20.100.10-FF-000055', NULL, 'ADAMTS-like protein 4 isoform X1', 58, NULL, NULL, 204413),
(204414, '3.40.50.2300-FF-000644', NULL, 'Acid phosphatase 1, soluble, isoform CRA_d', 80, NULL, NULL, 204414),
(204415, '1.10.472.30-FF-000014', NULL, NULL, 134, NULL, NULL, 204415),
(204416, '3.40.50.1110-FF-000034', NULL, 'GDSL-motif lipase/hydrolase protein-like', 111, NULL, NULL, 204416),
(204417, '3.30.1010.10-FF-000058', NULL, 'Serine/threonine-protein kinase ATR', 172, NULL, NULL, 204417),
(204418, '3.90.280.10-FF-000025', NULL, NULL, 89, NULL, NULL, 204418),
(204419, '3.90.550.50-FF-000081', NULL, 'Hexosyltransferase', 219, NULL, NULL, 204419),
(204420, '3.30.40.10-FF-002371', NULL, 'Chromatin modification-related protein', 88, NULL, NULL, 204420);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(204421, '3.30.160.60-FF-000590', NULL, 'Zinc finger protein 319', 24, NULL, NULL, 204421),
(204422, '3.40.50.1980-FF-000098', NULL, 'ABC-type cobalamin/Fe3+-siderophores transport systems, periplasmic components', 119, NULL, NULL, 204422),
(204423, '3.40.1190.20-FF-000217', NULL, NULL, 272, NULL, NULL, 204423),
(204424, '3.40.50.300-FF-003934', NULL, 'ARL2', 185, NULL, NULL, 204424),
(204425, '2.60.40.60-FF-000363', NULL, 'Dachsous cadherin-related 1a', 114, NULL, NULL, 204425),
(204426, '3.40.1280.10-FF-000098', NULL, 'tRNA (cytidine(56)-2''-O)-methyltransferase', 176, NULL, NULL, 204426),
(204427, '3.30.230.10-FF-000209', NULL, 'Ribonuclease P protein component', 108, NULL, NULL, 204427),
(204428, '3.90.70.10-FF-000852', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 109, NULL, NULL, 204428),
(204429, '3.80.10.10-FF-000253', NULL, 'Leucine-rich repeat-containing protein 10', 111, NULL, NULL, 204429),
(204430, '1.10.287.280-FF-000006', NULL, 'DNA-directed RNA polymerase', 38, NULL, NULL, 204430),
(204431, '1.20.1270.60-FF-000180', NULL, 'Vacuolar protein sorting-associated protein 17', 226, NULL, NULL, 204431),
(204432, '1.10.220.150-FF-000070', NULL, 'ADP-ribosylation factor GTPase-activating protein AGD10', 96, NULL, NULL, 204432),
(204433, '3.80.10.10-FF-001214', NULL, 'Leucine rich repeat containing 26', 118, NULL, NULL, 204433),
(204434, '1.25.40.20-FF-001019', NULL, 'Uncharacterized protein', 118, NULL, NULL, 204434),
(204435, '3.40.50.720-FF-000542', NULL, 'Inositol-3-phosphate synthase 1', 355, NULL, NULL, 204435),
(204436, '3.90.660.10-FF-000066', NULL, NULL, 150, NULL, NULL, 204436),
(204437, '3.30.70.1170-FF-000015', NULL, 'Putative methyltransferase NSUN7', 80, NULL, NULL, 204437),
(204438, '1.10.357.10-FF-000049', NULL, 'Probable transcriptional regulatory protein (Probably tetR/acrR-family)', 186, NULL, NULL, 204438),
(204439, '3.40.50.1100-FF-000065', NULL, 'Putative D-cysteine desulfhydrase 2, mitochondrial', 16, NULL, NULL, 204439),
(204440, '1.20.1250.20-FF-000684', NULL, 'MFS transporter', 183, NULL, NULL, 204440),
(204441, '1.10.1200.10-FF-000039', NULL, 'Phenolpthiocerol synthesis type-I polyketide synthase PPSE', 87, NULL, NULL, 204441),
(204442, '2.60.40.3210-FF-000020', NULL, 'Matrix metallopeptidase 15a', 123, NULL, NULL, 204442),
(204443, '2.60.40.1120-FF-000067', NULL, 'Putative carboxypeptidase d', 80, NULL, NULL, 204443),
(204444, '1.20.1540.10-FF-000107', NULL, 'Predicted protein', 149, NULL, NULL, 204444),
(204445, '3.40.50.360-FF-000147', NULL, 'Uncharacterized protein', 113, NULL, NULL, 204445),
(204446, '3.30.1330.30-FF-000088', NULL, 'Uncharacterized protein', 94, NULL, NULL, 204446),
(204447, '3.30.710.10-FF-000235', NULL, 'OSJNBa0093O08.6-like protein', 153, NULL, NULL, 204447),
(204448, '3.40.50.300-FF-000500', NULL, 'ATP-dependent RNA helicase DHX29', 234, NULL, NULL, 204448),
(204449, '1.10.238.10-FF-000829', NULL, 'Uncharacterized protein', 202, NULL, NULL, 204449),
(204450, '3.40.50.460-FF-000031', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit alpha 2', 133, NULL, NULL, 204450),
(204451, '3.10.580.10-FF-000010', NULL, 'Chloride voltage-gated channel 6', 94, NULL, NULL, 204451),
(204452, '1.20.58.2190-FF-000009', NULL, 'Tamo, isoform B', 208, NULL, NULL, 204452),
(204453, '3.30.40.10-FF-000459', NULL, 'TFA1p TFIIE large subunit', 62, NULL, NULL, 204453),
(204454, '3.40.50.620-FF-000658', NULL, 'DALR anticodon binding domain containing protein', 341, NULL, NULL, 204454),
(204455, '3.30.200.20-FF-000773', NULL, 'L-type lectin-domain containing receptor kinase S.6-like', 113, NULL, NULL, 204455),
(204456, '3.40.50.1260-FF-000028', NULL, 'Phosphoglycerate kinase', 50, NULL, NULL, 204456),
(204457, '2.60.120.200-FF-000269', NULL, 'Laminin subunit alpha-3', 181, NULL, NULL, 204457),
(204458, '3.30.1360.120-FF-000050', NULL, 'Putative transferase caf17 homolog, mitochondrial', 278, NULL, NULL, 204458),
(204459, '1.25.40.10-FF-001781', NULL, 'Pentatricopeptide repeat-containing protein', 132, NULL, NULL, 204459),
(204460, '3.50.50.60-FF-000704', NULL, 'Flavin-containing monooxygenase', 117, NULL, NULL, 204460);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(204461, '1.10.8.720-FF-000073', NULL, 'Uncharacterized protein', 128, NULL, NULL, 204461),
(204462, '2.130.10.10-FF-003844', NULL, 'Uncharacterized protein', 291, NULL, NULL, 204462),
(204463, '1.10.287.70-FF-000432', NULL, 'TOK potassium channel', 136, NULL, NULL, 204463),
(204464, '1.20.1250.20-FF-000161', NULL, 'Solute carrier organic anion transporter family member', 367, NULL, NULL, 204464),
(204465, '3.30.2350.10-FF-000078', NULL, 'TruB pseudouridine (psi) synthase family member 1', 73, NULL, NULL, 204465),
(204466, '3.40.50.1820-FF-000567', NULL, 'Acyl-protein thioesterase 1', 166, NULL, NULL, 204466),
(204467, '3.40.50.300-FF-008605', NULL, 'ATPase, AAA family protein', 173, NULL, NULL, 204467),
(204468, '2.120.10.80-FF-000111', NULL, 'Serine/threonine-protein phosphatase', 242, NULL, NULL, 204468),
(204469, '3.60.120.10-FF-000015', NULL, 'Probable isochorismate synthase entC', 370, NULL, NULL, 204469),
(204470, '2.10.25.10-FF-000708', NULL, 'Stabilin 2', 55, NULL, NULL, 204470),
(204471, '3.30.450.70-FF-000042', NULL, NULL, 156, NULL, NULL, 204471),
(204472, '3.60.20.10-FF-000120', NULL, 'Proteasome subunit beta type 7-B, putative', 235, NULL, NULL, 204472),
(204473, '4.10.400.10-FF-000252', NULL, 'Suppressor of tumorigenicity 14 protein homolog', 38, NULL, NULL, 204473),
(204474, '3.40.1190.20-FF-000184', NULL, NULL, 297, NULL, NULL, 204474),
(204475, '2.40.50.140-FF-001052', NULL, NULL, 170, NULL, NULL, 204475),
(204476, '2.130.10.10-FF-000410', NULL, 'U3 small nucleolar RNA-associated protein 21', 328, NULL, NULL, 204476),
(204477, '2.130.10.10-FF-003136', NULL, 'Tricorn protease homolog 1', 367, NULL, NULL, 204477),
(204478, '1.10.8.60-FF-000123', NULL, 'Origin recognition complex subunit 1', 84, NULL, NULL, 204478),
(204479, '2.30.39.10-FF-000104', NULL, 'Uncharacterized protein', 48, NULL, NULL, 204479),
(204480, '1.20.1070.10-FF-002151', NULL, 'Uncharacterized protein', 171, NULL, NULL, 204480),
(204481, '1.20.58.2170-FF-000003', NULL, NULL, 82, NULL, NULL, 204481),
(204482, '3.30.559.10-FF-000192', NULL, 'Uncharacterized protein', 212, NULL, NULL, 204482),
(204483, '1.20.120.230-FF-000057', NULL, 'Predicted protein', 105, NULL, NULL, 204483),
(204484, '3.30.1370.100-FF-000012', NULL, 'DNA mismatch repair protein MutL', 71, NULL, NULL, 204484),
(204485, '3.90.70.10-FF-000352', NULL, 'Uncharacterized protein', 312, NULL, NULL, 204485),
(204486, '2.30.30.380-FF-000060', NULL, 'Protein transport protein SEC23', 59, NULL, NULL, 204486),
(204487, '3.40.350.10-FF-000014', NULL, 'Aminopeptidase P2', 146, NULL, NULL, 204487),
(204488, '3.40.50.300-FF-007408', NULL, 'Uncharacterized protein', 134, NULL, NULL, 204488),
(204489, '1.10.10.10-FF-001250', NULL, 'Transcriptional regulator', 62, NULL, NULL, 204489),
(204490, '3.20.20.60-FF-000035', NULL, 'Pyruvate kinase', 232, NULL, NULL, 204490),
(204491, '3.90.800.10-FF-000010', NULL, NULL, 30, NULL, NULL, 204491),
(204492, '3.40.47.10-FF-000143', NULL, 'Fatty acid synthase subunit beta', 190, NULL, NULL, 204492),
(204493, '1.10.1740.10-FF-000041', NULL, 'Putative sigma factor', 58, NULL, NULL, 204493),
(204494, '3.40.50.720-FF-001559', NULL, 'Probable oxidoreductase (Short-chain dehydrogenase family)', 250, NULL, NULL, 204494),
(204495, '3.30.160.60-FF-005401', NULL, NULL, 21, NULL, NULL, 204495),
(204496, '2.30.30.40-FF-000251', NULL, 'Chemotaxis protein CheW', 59, NULL, NULL, 204496),
(204497, '1.20.5.110-FF-000343', NULL, 'SNAP-25 (Synaptosome-associated protein) component of SNARE complex, putative', 64, NULL, NULL, 204497),
(204498, '2.60.120.1000-FF-000014', NULL, 'Uncharacterized protein', 100, NULL, NULL, 204498),
(204499, '3.40.50.300-FF-004654', NULL, 'DNA helicase', 166, NULL, NULL, 204499),
(204500, '1.20.5.170-FF-000254', NULL, 'Uncharacterized protein', 127, NULL, NULL, 204500),
(204501, '3.30.1370.120-FF-000018', NULL, 'Type II secretion system lipoprotein GspD, putative', 94, NULL, NULL, 204501),
(204502, '3.10.110.10-FF-000155', NULL, 'Ubiquitin-conjugating enzyme family protein', 187, NULL, NULL, 204502),
(204503, '3.40.1010.20-FF-000002', NULL, '4-hydroxy-3-methylbut-2-enyl diphosphate reductase', 92, NULL, NULL, 204503);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(204504, '2.40.30.20-FF-000003', NULL, 'Riboflavin synthase, alpha subunit', 88, NULL, NULL, 204504),
(204505, '3.30.70.100-FF-000126', NULL, NULL, 81, NULL, NULL, 204505),
(204506, '2.10.220.10-FF-000032', NULL, 'Proprotein convertase subtilisin/kexin type 5', 56, NULL, NULL, 204506),
(204507, '1.20.1250.20-FF-002246', NULL, 'Proton-dependent oligopeptide transport (POT) family protein', 112, NULL, NULL, 204507),
(204508, '3.30.1360.210-FF-000009', NULL, '60S ribosomal protein L22, putative', 116, NULL, NULL, 204508),
(204509, '1.10.3060.10-FF-000011', NULL, 'Protein translocase subunit SecA', 192, NULL, NULL, 204509),
(204510, '3.60.20.10-FF-000092', NULL, 'Class II glutamine amidotransferase', 252, NULL, NULL, 204510),
(204511, '3.30.70.270-FF-000149', NULL, 'Putative signal protein with GGDEF domain', 172, NULL, NULL, 204511),
(204512, '2.60.120.290-FF-000251', NULL, 'Cubilin-like Protein', 122, NULL, NULL, 204512),
(204513, '3.40.190.10-FF-000400', NULL, 'Predicted protein', 62, NULL, NULL, 204513),
(204514, '3.40.50.150-FF-001714', NULL, NULL, 209, NULL, NULL, 204514),
(204515, '1.20.1560.10-FF-000350', NULL, 'ABC transporter, putative', 202, NULL, NULL, 204515),
(204516, '3.40.1500.10-FF-000020', NULL, 'Coproporphyrinogen III oxidase, putative', 338, NULL, NULL, 204516),
(204517, '1.20.1070.10-FF-001010', NULL, 'Vomeronasal type-1 receptor', 297, NULL, NULL, 204517),
(204518, '3.60.20.10-FF-000041', NULL, 'Asparagine synthase (Glutamine-hydrolyzing)', 212, NULL, NULL, 204518),
(204519, '3.20.80.10-FF-000041', NULL, 'SOUL heme-binding family protein', 99, NULL, NULL, 204519),
(204520, '1.10.357.140-FF-000026', NULL, 'Phosphoribose diphosphate:decaprenyl-phosphate phosphoribosyltransferase', 147, NULL, NULL, 204520),
(204521, '1.25.10.10-FF-000845', NULL, 'Protein folding regulator, putative', 186, NULL, NULL, 204521),
(204522, '3.80.10.10-FF-000045', NULL, 'Leucine-rich repeat and fibronectin type III domain-containing 2', 130, NULL, NULL, 204522),
(204523, '1.50.40.10-FF-000317', NULL, 'Dicarboxylate carrier 4, isoform B', 139, NULL, NULL, 204523),
(204524, '3.30.160.60-FF-004833', NULL, NULL, 27, NULL, NULL, 204524),
(204525, '3.30.70.330-FF-001538', NULL, 'RNA binding protein, putative', 126, NULL, NULL, 204525),
(204526, '1.20.272.10-FF-000007', NULL, 'Replication factor C subunit 4', 94, NULL, NULL, 204526),
(204527, '2.60.40.10-FF-003827', NULL, NULL, 124, NULL, NULL, 204527),
(204528, '1.10.287.3440-FF-000006', NULL, 'Biosynthetic arginine decarboxylase 1', 62, NULL, NULL, 204528),
(204529, '3.30.40.10-FF-000307', NULL, 'LON peptidase N-terminal domain and RING finger protein 1', 100, NULL, NULL, 204529),
(204530, '3.30.70.100-FF-000177', NULL, NULL, 63, NULL, NULL, 204530),
(204531, '3.90.70.10-FF-000301', NULL, 'Uncharacterized protein', 365, NULL, NULL, 204531),
(204532, '1.10.10.60-FF-001271', NULL, NULL, 82, NULL, NULL, 204532),
(204533, '1.10.8.60-FF-000174', NULL, 'Uncharacterized protein, isoform A', 57, NULL, NULL, 204533),
(204534, '2.160.20.10-FF-000168', NULL, 'Uncharacterized protein', 235, NULL, NULL, 204534),
(204535, '2.60.120.780-FF-000010', NULL, 'AaceriAAR121Wp', 147, NULL, NULL, 204535),
(204536, '1.25.40.200-FF-000001', NULL, 'Ran GTPase-activating protein 1', 170, NULL, NULL, 204536),
(204537, '3.30.572.10-FF-000032', NULL, 'Probable thymidylate synthase', 307, NULL, NULL, 204537),
(204538, '2.60.40.60-FF-000604', NULL, 'CaDHerin family', 98, NULL, NULL, 204538),
(204539, '3.30.70.340-FF-000018', NULL, NULL, 87, NULL, NULL, 204539),
(204540, '1.50.10.20-FF-000077', NULL, 'Protein geranylgeranyltransferase type I subunit', 390, NULL, NULL, 204540),
(204541, '1.20.120.1910-FF-000023', NULL, 'Cysteine--tRNA ligase', 135, NULL, NULL, 204541),
(204542, '2.60.120.200-FF-000325', NULL, 'Vesicular mannose-binding lectin, putative', 218, NULL, NULL, 204542),
(204543, '2.60.40.10-FF-005805', NULL, NULL, 74, NULL, NULL, 204543),
(204544, '3.10.450.580-FF-000006', NULL, 'Mediator of RNA polymerase II transcription subunit 6', 144, NULL, NULL, 204544),
(204545, '1.10.132.30-FF-000028', NULL, 'DNA-directed RNA polymerase subunit', 55, NULL, NULL, 204545);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(204546, '2.60.120.200-FF-000797', NULL, 'Uncharacterized protein', 189, NULL, NULL, 204546),
(204547, '2.30.29.30-FF-000969', NULL, 'Uncharacterized protein', 105, NULL, NULL, 204547),
(204548, '1.20.5.4280-FF-000001', NULL, '60S ribosomal protein L16-A', 50, NULL, NULL, 204548),
(204549, '3.80.10.10-FF-003659', NULL, 'Uncharacterized protein', 92, NULL, NULL, 204549),
(204550, '3.40.50.300-FF-006099', NULL, 'Uncharacterized protein', 222, NULL, NULL, 204550),
(204551, '2.30.36.70-FF-000014', NULL, 'Actin, alpha 2, smooth muscle, aorta', 11, NULL, NULL, 204551),
(204552, '3.40.850.10-FF-000428', NULL, 'Predicted protein', 163, NULL, NULL, 204552),
(204553, '3.30.70.1730-FF-000026', NULL, '60S acidic ribosomal protein P0', 133, NULL, NULL, 204553),
(204554, '1.25.40.10-FF-002859', NULL, 'Pentatricopeptide repeat-containing protein', 101, NULL, NULL, 204554),
(204555, '3.30.300.160-FF-000012', NULL, 'Type IV-A pilus assembly ATPase PilB', 79, NULL, NULL, 204555),
(204556, '3.30.70.330-FF-001589', NULL, NULL, 109, NULL, NULL, 204556),
(204557, '3.30.160.60-FF-005289', NULL, NULL, 34, NULL, NULL, 204557),
(204558, '1.25.40.10-FF-004776', NULL, 'Uncharacterized protein', 194, NULL, NULL, 204558),
(204559, '3.30.70.330-FF-002106', NULL, NULL, 118, NULL, NULL, 204559),
(204560, '1.10.472.10-FF-000452', NULL, 'Cyclin domain-containing protein', 147, NULL, NULL, 204560),
(204561, '1.10.540.10-FF-000105', NULL, 'ActVA 5 protein', 114, NULL, NULL, 204561),
(204562, '1.20.1070.10-FF-000442', NULL, 'Melatonin receptor type 1A', 258, NULL, NULL, 204562),
(204563, '3.40.50.720-FF-002127', NULL, 'Os07g0229800 protein', 107, NULL, NULL, 204563),
(204564, '3.40.605.10-FF-000112', NULL, 'Uncharacterized protein', 149, NULL, NULL, 204564),
(204565, '3.90.1200.10-FF-000031', NULL, 'Spore coat protein YutH', 207, NULL, NULL, 204565),
(204566, '1.25.40.370-FF-000006', NULL, 'Apoptotic protease-activating factor 1', 140, NULL, NULL, 204566),
(204567, '1.10.510.10-FF-003251', NULL, NULL, 115, NULL, NULL, 204567),
(204568, '3.90.199.10-FF-000015', NULL, NULL, 183, NULL, NULL, 204568),
(204569, '2.10.25.10-FF-001405', NULL, 'Integrin beta', 56, NULL, NULL, 204569),
(204570, '3.40.430.10-FF-000015', NULL, 'Dihydrofolate reductase', 208, NULL, NULL, 204570),
(204571, '1.25.10.10-FF-001801', NULL, 'RING-type E3 ubiquitin transferase', 88, NULL, NULL, 204571),
(204572, '3.40.50.300-FF-005059', NULL, 'Muscle RAS oncogene homolog', 140, NULL, NULL, 204572),
(204573, '3.40.50.880-FF-000005', NULL, 'CTP synthase', 266, NULL, NULL, 204573),
(204574, '2.40.50.140-FF-000675', NULL, NULL, 90, NULL, NULL, 204574),
(204575, '3.90.226.10-FF-000203', NULL, '3-hydroxy-3-methylglutaryl-coenzyme A lyase/3-methylglutaconyl-coenzyme A hydratase', 271, NULL, NULL, 204575),
(204576, '3.40.50.1820-FF-001787', NULL, 'Uncharacterized protein', 169, NULL, NULL, 204576),
(204577, '2.60.40.10-FF-003035', NULL, 'Highly immunogenic outer capsid protein', 94, NULL, NULL, 204577),
(204578, '3.30.720.50-FF-000012', NULL, 'Poly [ADP-ribose] polymerase', 79, NULL, NULL, 204578),
(204579, '1.25.40.10-FF-000201', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 99, NULL, NULL, 204579),
(204580, '3.90.105.20-FF-000010', NULL, 'Ribosome assembly factor mrt4', 76, NULL, NULL, 204580),
(204581, '2.60.120.650-FF-000151', NULL, 'Uncharacterized protein', 317, NULL, NULL, 204581),
(204582, '3.10.20.90-FF-000623', NULL, 'XPC-binding domain-domain-containing protein', 87, NULL, NULL, 204582),
(204583, '3.10.450.320-FF-000007', NULL, 'Mitochondrial import inner membrane translocase subunit Tim21', 108, NULL, NULL, 204583),
(204584, '1.10.418.60-FF-000004', NULL, 'Nuf2p', 168, NULL, NULL, 204584),
(204585, '2.60.40.10-FF-002467', NULL, 'High Incidence of Males (Increased X chromosome loss)', 94, NULL, NULL, 204585),
(204586, '1.10.150.20-FF-000191', NULL, 'Flap structure-specific endonuclease', 62, NULL, NULL, 204586),
(204587, '2.130.10.10-FF-001282', NULL, 'ER membrane protein complex subunit 1', 297, NULL, NULL, 204587),
(204588, '3.40.50.300-FF-002237', NULL, 'Shikimate kinase', 165, NULL, NULL, 204588);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(204589, '3.30.160.60-FF-002416', NULL, 'Zinc finger protein 891', 26, NULL, NULL, 204589),
(204590, '1.10.10.160-FF-000043', NULL, 'RecBCD enzyme subunit RecC', 88, NULL, NULL, 204590),
(204591, '1.25.40.10-FF-000561', NULL, 'Uncharacterized protein', 138, NULL, NULL, 204591),
(204592, '1.20.120.330-FF-000020', NULL, 'Related to SPA2 protein', 115, NULL, NULL, 204592),
(204593, '2.60.40.60-FF-000655', NULL, 'AGAP003579-PA', 115, NULL, NULL, 204593),
(204594, '3.30.260.10-FF-000009', NULL, 'T-complex protein 1 subunit zeta', 104, NULL, NULL, 204594),
(204595, '1.10.260.40-FF-000019', NULL, 'Maltose regulon transcriptional regulator MalI', 61, NULL, NULL, 204595),
(204596, '3.30.160.60-FF-002967', NULL, 'Zinc finger protein 417', 85, NULL, NULL, 204596),
(204597, '3.80.10.10-FF-000433', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase isoform A', 68, NULL, NULL, 204597),
(204598, '1.10.840.10-FF-000038', NULL, 'Ras guanine nucleotide exchange factor N', 254, NULL, NULL, 204598),
(204599, '3.40.5.60-FF-000005', NULL, 'DNA replication complex GINS protein SLD5', 56, NULL, NULL, 204599),
(204600, '3.40.50.300-FF-001669', NULL, 'Dicer-like protein 1', 170, NULL, NULL, 204600),
(204601, '1.20.1440.160-FF-000003', NULL, 'Uncharacterized protein', 191, NULL, NULL, 204601),
(204602, '3.30.40.10-FF-002224', NULL, 'Uncharacterized protein', 67, NULL, NULL, 204602),
(204603, '3.30.160.60-FF-004092', NULL, NULL, 30, NULL, NULL, 204603),
(204604, '2.10.220.10-FF-000083', NULL, 'Proprotein convertase subtilisin/kexin type 5a', 81, NULL, NULL, 204604),
(204605, '2.40.70.10-FF-000160', NULL, 'ASpartyl Protease', 42, NULL, NULL, 204605),
(204606, '2.130.10.10-FF-000758', NULL, 'UTP4, small subunit processome component', 175, NULL, NULL, 204606),
(204607, '2.60.120.10-FF-000114', NULL, 'Patatin like phospholipase domain containing 6', 97, NULL, NULL, 204607),
(204608, '1.10.1900.10-FF-000008', NULL, 'Polyadenylate-binding protein', 90, NULL, NULL, 204608),
(204609, '3.30.450.20-FF-000201', NULL, 'Cyclic-di-AMP phosphodiesterase', 103, NULL, NULL, 204609),
(204610, '1.10.510.10-FF-001738', NULL, 'TRAF2 and NCK interacting kinase', 109, NULL, NULL, 204610),
(204611, '3.80.10.10-FF-001894', NULL, 'Toll-like receptor 13', 168, NULL, NULL, 204611),
(204612, '1.20.1250.20-FF-000268', NULL, 'MFS multidrug efflux transporter (Eurofung)', 363, NULL, NULL, 204612),
(204613, '2.60.120.290-FF-000200', NULL, 'Predicted protein', 59, NULL, NULL, 204613),
(204614, '3.40.50.200-FF-000116', NULL, 'Proprotein convertase subtilisin/kexin type 4', 79, NULL, NULL, 204614),
(204615, '3.30.200.20-FF-001402', NULL, 'Serine/threonine protein kinase', 124, NULL, NULL, 204615),
(204616, '3.30.160.60-FF-001927', NULL, 'Zinc finger protein 1184', 28, NULL, NULL, 204616),
(204617, '1.20.58.340-FF-000035', NULL, 'Putative CorA-like Mg2+ transporter protein', 182, NULL, NULL, 204617),
(204618, '3.30.50.10-FF-000191', NULL, 'Uncharacterized protein', 81, NULL, NULL, 204618),
(204619, '2.30.29.30-FF-000109', NULL, 'Arf-GAP with GTPase, ANK repeat and PH domain-containing protein 1', 104, NULL, NULL, 204619),
(204620, '3.40.50.300-FF-003294', NULL, 'ARL1 isoform 5', 52, NULL, NULL, 204620),
(204621, '3.40.50.300-FF-004603', NULL, 'Dynein_heavy_chain_-_N-terminal_region_2_-_putative', 118, NULL, NULL, 204621),
(204622, '3.30.420.10-FF-000163', NULL, 'Exosome complex exonuclease RRP6', 303, NULL, NULL, 204622),
(204623, '2.130.10.30-FF-000091', NULL, NULL, 188, NULL, NULL, 204623),
(204624, '3.30.559.10-FF-000248', NULL, 'Nonribosomal peptide synthetase asqK', 71, NULL, NULL, 204624),
(204625, '1.10.533.10-FF-000122', NULL, 'Caspase 8a', 86, NULL, NULL, 204625),
(204626, '3.20.20.80-FF-000193', NULL, '4-alpha-glucanotransferase, chloroplastic/amyloplastic', 498, NULL, NULL, 204626),
(204627, '3.10.110.10-FF-000104', NULL, 'RWD domain-containing protein, putative', 116, NULL, NULL, 204627),
(204628, '3.30.160.60-FF-003405', NULL, 'Zinc finger domain-containing protein/ double-stranded RNA-bindingprotein', 63, NULL, NULL, 204628);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(204629, '1.25.40.10-FF-003427', NULL, 'Pentatricopeptide repeat-containing protein', 98, NULL, NULL, 204629),
(204630, '2.10.25.10-FF-000467', NULL, 'Laminin subunit alpha 5', 48, NULL, NULL, 204630),
(204631, '1.20.140.50-FF-000005', NULL, 'Bro1p', 140, NULL, NULL, 204631),
(204632, '3.90.190.10-FF-000046', NULL, 'Cyclin-dependent kinase inhibitor 3', 190, NULL, NULL, 204632),
(204633, '2.60.120.200-FF-000685', NULL, 'Predicted protein', 208, NULL, NULL, 204633),
(204634, '1.25.40.20-FF-001339', NULL, 'Uncharacterized protein', 119, NULL, NULL, 204634),
(204635, '1.10.238.10-FF-000745', NULL, 'Uncharacterized protein', 170, NULL, NULL, 204635),
(204636, '2.10.90.10-FF-000022', NULL, 'Norrin', 112, NULL, NULL, 204636),
(204637, '3.30.1360.40-FF-000042', NULL, 'DNA topoisomerase 2', 103, NULL, NULL, 204637),
(204638, '3.40.50.300-FF-000208', NULL, 'Urease accessory protein UreG', 199, NULL, NULL, 204638),
(204639, '1.25.10.10-FF-003246', NULL, 'Uncharacterized protein', 232, NULL, NULL, 204639),
(204640, '1.10.10.10-FF-000261', NULL, 'Transcriptional regulator SlyA', 143, NULL, NULL, 204640),
(204641, '1.10.760.10-FF-000037', NULL, 'Cytochrome bc1 complex cytochrome c subunit', 94, NULL, NULL, 204641),
(204642, '3.20.20.80-FF-000693', NULL, 'Putative beta-glucosidase 2', 284, NULL, NULL, 204642),
(204643, '2.60.40.10-FF-004496', NULL, NULL, 95, NULL, NULL, 204643),
(204644, '1.20.1250.20-FF-000217', NULL, 'MFS lactose permease, putative', 470, NULL, NULL, 204644),
(204645, '1.10.10.60-FF-000747', NULL, NULL, 27, NULL, NULL, 204645),
(204646, '3.60.21.10-FF-000083', NULL, 'Sphingomyelin phosphodiesterase', 300, NULL, NULL, 204646),
(204647, '1.10.10.10-FF-001621', NULL, 'Putative ArsR-family transcriptional regulator', 101, NULL, NULL, 204647),
(204648, '2.20.20.110-FF-000013', NULL, 'DNA repair protein rhp42', 56, NULL, NULL, 204648),
(204649, '3.40.850.10-FF-000479', NULL, 'Uncharacterized protein', 400, NULL, NULL, 204649),
(204650, '3.30.457.50-FF-000006', NULL, NULL, 109, NULL, NULL, 204650),
(204651, '1.20.1250.20-FF-001678', NULL, 'Sugar transporter ERD6-like 6', 152, NULL, NULL, 204651),
(204652, '3.40.30.10-FF-000880', NULL, 'DNaJ domain (Prokaryotic heat shock protein)', 124, NULL, NULL, 204652),
(204653, '1.10.40.30-FF-000027', NULL, 'Aspartate ammonia-lyase', 46, NULL, NULL, 204653),
(204654, '2.40.50.120-FF-000017', NULL, 'UPF0450 protein C17orf58 homolog', 97, NULL, NULL, 204654),
(204655, '2.10.25.10-FF-000416', NULL, 'Heparan sulfate proteoglycan 2', 40, NULL, NULL, 204655),
(204656, '3.90.550.10-FF-000029', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 386, NULL, NULL, 204656),
(204657, '1.10.510.10-FF-003363', NULL, NULL, 84, NULL, NULL, 204657),
(204658, '3.30.70.330-FF-001185', NULL, 'POU domain, class 4, transcription factor', 66, NULL, NULL, 204658),
(204659, '1.10.150.870-FF-000004', NULL, 'Error-prone DNA polymerase', 92, NULL, NULL, 204659),
(204660, '3.30.160.60-FF-004041', NULL, NULL, 27, NULL, NULL, 204660),
(204661, '3.40.50.2300-FF-001212', NULL, NULL, 217, NULL, NULL, 204661),
(204662, '3.30.360.10-FF-000045', NULL, 'NAD-binding Rossmann fold oxidoreductase', 169, NULL, NULL, 204662),
(204663, '1.20.58.60-FF-000109', NULL, 'Periplakin', 230, NULL, NULL, 204663),
(204664, '2.40.50.40-FF-000105', NULL, 'Interleukin-8', 82, NULL, NULL, 204664),
(204665, '1.20.1440.180-FF-000009', NULL, 'Key regulator in ER unfolded protein response', 132, NULL, NULL, 204665),
(204666, '3.30.70.270-FF-000250', NULL, NULL, 185, NULL, NULL, 204666),
(204667, '1.20.120.790-FF-000023', NULL, 'Chaperone protein HtpG', 144, NULL, NULL, 204667),
(204668, '3.30.160.60-FF-006278', NULL, NULL, 52, NULL, NULL, 204668),
(204669, '3.30.43.40-FF-000003', NULL, 'Spliceosomal protein PrP8, U6-snRNA interacting domain', 88, NULL, NULL, 204669),
(204670, '3.40.190.10-FF-000451', NULL, 'LysR family transcriptional regulator', 97, NULL, NULL, 204670),
(204671, '1.10.3680.10-FF-000002', NULL, 'Inner membrane protein YebE', 138, NULL, NULL, 204671),
(204672, '3.40.50.620-FF-000366', NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', 363, NULL, NULL, 204672);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(204673, '3.40.630.30-FF-000654', NULL, 'Predicted protein', 160, NULL, NULL, 204673),
(204674, '3.30.565.10-FF-000341', NULL, 'Sensor protein', 134, NULL, NULL, 204674),
(204675, '3.90.70.80-FF-000092', NULL, 'Uncharacterized protein', 163, NULL, NULL, 204675),
(204676, '1.25.40.10-FF-001550', NULL, 'Empty pericarp7', 125, NULL, NULL, 204676),
(204677, '3.40.50.12780-FF-000229', NULL, 'Mutant e4 ebony', 201, NULL, NULL, 204677),
(204678, '1.25.40.10-FF-002359', NULL, 'Os01g0914600 protein', 112, NULL, NULL, 204678),
(204679, '1.20.120.1630-FF-000029', NULL, 'Predicted protein', 163, NULL, NULL, 204679),
(204680, '3.30.420.40-FF-001048', NULL, 'Phosphotransferase', 12, NULL, NULL, 204680),
(204681, '3.40.630.30-FF-000154', NULL, 'Probable acetyltransferase', 152, NULL, NULL, 204681),
(204682, '3.40.50.300-FF-007476', NULL, 'Predicted protein', 237, NULL, NULL, 204682),
(204683, '2.60.210.10-FF-000060', NULL, NULL, 100, NULL, NULL, 204683),
(204684, '1.20.210.10-FF-000016', NULL, 'Probable intron-encoded endonuclease aI7', 380, NULL, NULL, 204684),
(204685, '1.10.532.10-FF-000002', NULL, 'Signal transducer and activator of transcription', 128, NULL, NULL, 204685),
(204686, '3.30.160.60-FF-001186', NULL, 'Zinc finger and BTB domain containing 11', 62, NULL, NULL, 204686),
(204687, '3.40.140.100-FF-000016', NULL, 'Uncharacterized protein', 138, NULL, NULL, 204687),
(204688, '2.60.40.10-FF-004884', NULL, NULL, 99, NULL, NULL, 204688),
(204689, '3.30.200.20-FF-001902', NULL, 'Phosphoribosylamidoimidazole-succinocarboxamide synthase, putative', 20, NULL, NULL, 204689),
(204690, '3.80.30.30-FF-000002', NULL, 'Spore photoproduct lyase family protein', 219, NULL, NULL, 204690),
(204691, '1.20.1270.60-FF-000152', NULL, 'Formin 2,3 and collagen domain containing protein', 247, NULL, NULL, 204691),
(204692, '2.60.40.10-FF-002990', NULL, 'Uncharacterized protein, isoform A', 98, NULL, NULL, 204692),
(204693, '3.30.160.60-FF-000730', NULL, 'zinc finger protein 34 isoform X1', 28, NULL, NULL, 204693),
(204694, '1.25.40.10-FF-002910', NULL, 'Clustered mitochondria protein homolog', 191, NULL, NULL, 204694),
(204695, '1.25.10.10-FF-000441', NULL, 'NOP9 nucleolar protein', 153, NULL, NULL, 204695),
(204696, '3.40.50.300-FF-005143', NULL, 'ABC transporter G family member 22', 235, NULL, NULL, 204696),
(204697, '1.10.3380.10-FF-000018', NULL, 'Translocation protein sec63', 138, NULL, NULL, 204697),
(204698, '2.60.40.10-FF-005452', NULL, NULL, 109, NULL, NULL, 204698),
(204699, '3.10.20.90-FF-000123', NULL, 'plexin-B1 isoform X1', 151, NULL, NULL, 204699),
(204700, '2.40.10.10-FF-000212', NULL, 'Serine protease P53', 118, NULL, NULL, 204700),
(204701, '2.60.120.330-FF-000173', NULL, 'Protein DOWNY MILDEW RESISTANCE 6', 248, NULL, NULL, 204701),
(204702, '3.40.50.720-FF-002195', NULL, 'Uncharacterized protein', 328, NULL, NULL, 204702),
(204703, '3.30.530.20-FF-000202', NULL, 'Uncharacterized protein', 41, NULL, NULL, 204703),
(204704, '1.10.472.80-FF-000192', NULL, NULL, 125, NULL, NULL, 204704),
(204705, '3.50.50.60-FF-000463', NULL, 'Amine oxidase, variant 1', 95, NULL, NULL, 204705),
(204706, '3.50.30.30-FF-000014', NULL, 'E3 ubiquitin-protein ligase ZNRF3', 117, NULL, NULL, 204706),
(204707, '3.30.930.10-FF-000033', NULL, 'Phenylalanine--tRNA ligase alpha subunit', 272, NULL, NULL, 204707),
(204708, '4.10.60.10-FF-000021', NULL, 'zinc finger CCHC domain-containing protein 3', 47, NULL, NULL, 204708),
(204709, '3.30.2230.10-FF-000007', NULL, 'Ubiquitinyl hydrolase 1', 121, NULL, NULL, 204709),
(204710, '1.10.275.10-FF-000005', NULL, 'Histidine ammonia-lyase', 197, NULL, NULL, 204710),
(204711, '1.10.1080.10-FF-000006', NULL, 'Glutathione synthetase', 45, NULL, NULL, 204711),
(204712, '3.30.200.20-FF-000913', NULL, 'Serine/threonine kinase like domain containing 1', 82, NULL, NULL, 204712),
(204713, '1.10.510.10-FF-003604', NULL, NULL, 200, NULL, NULL, 204713),
(204714, '1.10.1820.10-FF-000007', NULL, 'Casein kinase II subunit beta', 124, NULL, NULL, 204714),
(204715, '2.120.10.80-FF-000263', NULL, 'Predicted protein', 281, NULL, NULL, 204715);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(204716, '2.30.30.490-FF-000093', NULL, '(Cytosine-5)-methyltransferase 1, putative', 56, NULL, NULL, 204716),
(204717, '1.10.510.10-FF-003312', NULL, NULL, 73, NULL, NULL, 204717),
(204718, '1.10.287.950-FF-000022', NULL, 'Methyl-accepting chemotaxis protein', 220, NULL, NULL, 204718),
(204719, '3.80.10.10-FF-004199', NULL, 'Uncharacterized protein', 90, NULL, NULL, 204719),
(204720, '1.25.40.550-FF-000004', NULL, 'AAR2 protein, putative', 183, NULL, NULL, 204720),
(204721, '1.10.760.10-FF-000088', NULL, 'Cytochrome C peroxidase', 147, NULL, NULL, 204721),
(204722, '1.25.40.20-FF-001278', NULL, 'Uncharacterized protein', 179, NULL, NULL, 204722),
(204723, '1.10.630.10-FF-000825', NULL, 'Premnaspirodiene oxygenase', 228, NULL, NULL, 204723),
(204724, '1.20.1270.10-FF-000002', NULL, 'Heat shock 70 kDa protein 4', 111, NULL, NULL, 204724),
(204725, '3.30.160.60-FF-005322', NULL, NULL, 76, NULL, NULL, 204725),
(204726, '3.40.850.10-FF-000075', NULL, 'Myosin XVI', 246, NULL, NULL, 204726),
(204727, '2.60.40.10-FF-001270', NULL, 'MPL proto-oncogene, thrombopoietin receptor', 97, NULL, NULL, 204727),
(204728, '3.20.20.140-FF-000254', NULL, 'Dihydropyrimidinase like 2', 373, NULL, NULL, 204728),
(204729, '3.30.760.10-FF-000093', NULL, 'Predicted protein', 66, NULL, NULL, 204729),
(204730, '2.40.40.20-FF-000009', NULL, 'Biotin sulfoxide reductase 2', 164, NULL, NULL, 204730),
(204731, '3.40.50.720-FF-001290', NULL, 'Os02g0811600 protein', 164, NULL, NULL, 204731),
(204732, '1.10.238.10-FF-001313', NULL, 'Uncharacterized protein', 51, NULL, NULL, 204732),
(204733, '1.10.10.60-FF-000635', NULL, '3-methyladenine DNA glycosylase', 42, NULL, NULL, 204733),
(204734, '3.40.50.300-FF-008465', NULL, 'Uncharacterized protein', 246, NULL, NULL, 204734),
(204735, '1.10.3460.10-FF-000019', NULL, 'Uncharacterized protein', 184, NULL, NULL, 204735),
(204736, '1.25.10.10-FF-001722', NULL, 'AGAP002970-PA', 1009, NULL, NULL, 204736),
(204737, '3.90.1560.10-FF-000001', NULL, 'Probable 2-phosphosulfolactate phosphatase', 236, NULL, NULL, 204737),
(204738, '3.40.50.300-FF-000388', NULL, 'Guanine nucleotide-binding protein G(s) subunit alpha', 211, NULL, NULL, 204738),
(204739, '3.40.50.300-FF-008369', NULL, 'Uncharacterized protein', 388, NULL, NULL, 204739),
(204740, '1.10.286.10-FF-000002', NULL, 'GTP cyclohydrolase 1', 85, NULL, NULL, 204740),
(204741, '3.90.226.10-FF-000271', NULL, 'Uncharacterized protein', 62, NULL, NULL, 204741),
(204742, '1.25.40.10-FF-001921', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 112, NULL, NULL, 204742),
(204743, '3.40.50.620-FF-000866', NULL, 'Guanine monophosphate synthase', 139, NULL, NULL, 204743),
(204744, '3.40.33.10-FF-000201', NULL, 'Uncharacterized protein', 52, NULL, NULL, 204744),
(204745, '3.80.10.10-FF-004148', NULL, 'Os06g0167500 protein', 107, NULL, NULL, 204745),
(204746, '3.40.50.670-FF-000009', NULL, 'DNA topoisomerase 2', 97, NULL, NULL, 204746),
(204747, '1.20.1250.20-FF-000329', NULL, 'monocarboxylate transporter 5 isoform X1', 185, NULL, NULL, 204747),
(204748, '3.10.290.70-FF-000022', NULL, NULL, 70, NULL, NULL, 204748),
(204749, '3.90.76.10-FF-000039', NULL, 'ABC transporter substrate-binding protein', 124, NULL, NULL, 204749),
(204750, '3.40.630.30-FF-000603', NULL, 'Uncharacterized protein', 67, NULL, NULL, 204750),
(204751, '1.25.40.20-FF-001227', NULL, 'Uncharacterized protein', 144, NULL, NULL, 204751),
(204752, '1.10.630.10-FF-000084', NULL, 'CYtochrome P450 family', 482, NULL, NULL, 204752),
(204753, '3.20.20.60-FF-000114', NULL, 'Homolog to citrate lyase beta subunit', 284, NULL, NULL, 204753),
(204754, '3.40.50.1000-FF-000361', NULL, 'NLI interacting factor-like phosphatase family protein', 176, NULL, NULL, 204754),
(204755, '3.10.620.30-FF-000020', NULL, 'Uncharacterized protein', 140, NULL, NULL, 204755),
(204756, '2.130.10.10-FF-005137', NULL, 'Uncharacterized protein', 110, NULL, NULL, 204756),
(204757, '1.10.1060.10-FF-000011', NULL, 'NAD(P)H-dependent glutamate synthase, putative', 133, NULL, NULL, 204757),
(204758, '1.10.10.60-FF-001203', NULL, NULL, 83, NULL, NULL, 204758);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(204759, '1.10.238.10-FF-000245', NULL, 'WD repeat domain 66', 129, NULL, NULL, 204759),
(204760, '3.50.50.60-FF-001401', NULL, 'Uncharacterized protein', 171, NULL, NULL, 204760),
(204761, '1.25.40.10-FF-002798', NULL, 'TPR Domain containing protein', 93, NULL, NULL, 204761),
(204762, '3.50.30.30-FF-000065', NULL, 'Zinc and ring finger 3', 49, NULL, NULL, 204762),
(204763, '2.30.30.140-FF-000016', NULL, 'polycomb protein SCMH1 isoform X1', 104, NULL, NULL, 204763),
(204764, '3.30.2020.30-FF-000008', NULL, 'Trimethyllysine hydroxylase, epsilon', 86, NULL, NULL, 204764),
(204765, '2.80.10.50-FF-000043', NULL, 'Interleukin-18', 157, NULL, NULL, 204765),
(204766, '2.70.98.40-FF-000017', NULL, NULL, 325, NULL, NULL, 204766),
(204767, '4.10.410.10-FF-000101', NULL, 'Uncharacterized protein', 49, NULL, NULL, 204767),
(204768, '3.30.200.20-FF-000885', NULL, 'Receptor-like cytosolic serine/threonine-protein kinase RBK2', 112, NULL, NULL, 204768),
(204769, '3.30.470.30-FF-000093', NULL, 'Predicted protein', 89, NULL, NULL, 204769),
(204770, '3.40.50.300-FF-001748', NULL, 'RAD3-like DNA-binding helicase protein', 213, NULL, NULL, 204770),
(204771, '2.60.40.10-FF-001118', NULL, 'Down syndrome cell adhesion molecule-like protein Dscam2', 97, NULL, NULL, 204771),
(204772, '3.30.230.10-FF-000384', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 164, NULL, NULL, 204772),
(204773, '1.25.10.10-FF-001189', NULL, 'DnaJ-like subfamily C member 13', 192, NULL, NULL, 204773),
(204774, '2.60.40.690-FF-000007', NULL, 'Complement C5', 145, NULL, NULL, 204774),
(204775, '3.30.160.60-FF-005901', NULL, NULL, 30, NULL, NULL, 204775),
(204776, '1.20.1050.10-FF-000019', NULL, 'Glutathione S-transferase, omega', 148, NULL, NULL, 204776),
(204777, '3.30.2350.10-FF-000055', NULL, 'tRNA pseudouridine synthase B', 245, NULL, NULL, 204777),
(204778, '2.10.110.10-FF-000254', NULL, 'Uncharacterized protein', 35, NULL, NULL, 204778),
(204779, '1.20.58.390-FF-000201', NULL, 'Gamma-aminobutyric acid type A receptor pi subunit', 162, NULL, NULL, 204779),
(204780, '3.20.20.80-FF-000272', NULL, 'CHiTinase', 249, NULL, NULL, 204780),
(204781, '2.40.10.10-FF-000504', NULL, NULL, 87, NULL, NULL, 204781),
(204782, '1.10.8.710-FF-000036', NULL, NULL, 119, NULL, NULL, 204782),
(204783, '3.80.10.10-FF-000837', NULL, 'Tubulin folding cofactor E-like a', 100, NULL, NULL, 204783),
(204784, '2.10.25.10-FF-000916', NULL, 'Adhesion G protein-coupled receptor E5b, duplicate 3', 43, NULL, NULL, 204784),
(204785, '3.90.550.10-FF-000529', NULL, 'Probable glycosyltransferase, type 2', 243, NULL, NULL, 204785),
(204786, '1.25.40.10-FF-003074', NULL, 'Uncharacterized protein', 194, NULL, NULL, 204786),
(204787, '2.60.40.10-FF-002579', NULL, 'Filamin 2, putative', 109, NULL, NULL, 204787),
(204788, '3.30.420.10-FF-000455', NULL, NULL, 163, NULL, NULL, 204788),
(204789, '2.40.50.90-FF-000194', NULL, 'Uncharacterized protein', 56, NULL, NULL, 204789),
(204790, '2.130.10.10-FF-001214', NULL, 'Sortilin-related VPS10 domain-containing receptor 2', 147, NULL, NULL, 204790),
(204791, '1.20.1250.10-FF-000091', NULL, NULL, 170, NULL, NULL, 204791),
(204792, '3.90.70.120-FF-000001', NULL, 'Large tegument protein', 226, NULL, NULL, 204792),
(204793, '1.10.20.10-FF-000379', NULL, NULL, 55, NULL, NULL, 204793),
(204794, '3.10.20.90-FF-000915', NULL, 'Uncharacterized protein', 83, NULL, NULL, 204794),
(204795, '2.120.10.30-FF-000613', NULL, 'Uncharacterized protein', 119, NULL, NULL, 204795),
(204796, '3.90.1750.20-FF-000013', NULL, 'Probable PhiRv1 integrase', 153, NULL, NULL, 204796),
(204797, '1.20.1070.10-FF-000054', NULL, 'Adhesion G protein-coupled receptor E3', 284, NULL, NULL, 204797),
(204798, '1.10.472.80-FF-000220', NULL, NULL, 146, NULL, NULL, 204798),
(204799, '1.20.58.2050-FF-000001', NULL, 'DNA replication complex GINS protein PSF3', 192, NULL, NULL, 204799),
(204800, '3.40.50.2300-FF-000756', NULL, 'Vomeronasal 2 receptor, h32', 183, NULL, NULL, 204800),
(204801, '2.40.50.140-FF-000624', NULL, 'Programmed cell death 11', 75, NULL, NULL, 204801);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(204802, '2.30.29.30-FF-000177', NULL, 'Tyrosine-protein kinase', 117, NULL, NULL, 204802),
(204803, '3.30.70.1560-FF-000014', NULL, 'Pseudouridine synthase', 78, NULL, NULL, 204803),
(204804, '3.30.450.50-FF-000036', NULL, 'Phytolongin Phyl1.1', 126, NULL, NULL, 204804),
(204805, '2.60.40.10-FF-003327', NULL, 'Interleukin-1 receptor type I', 115, NULL, NULL, 204805),
(204806, '2.60.40.2310-FF-000002', NULL, 'p69E protein-like', 131, NULL, NULL, 204806),
(204807, '3.40.50.1220-FF-000067', NULL, 'NAD-dependent histone deacetylase Sir2', 75, NULL, NULL, 204807),
(204808, '2.130.10.10-FF-000646', NULL, 'WD repeat containing antisense to TP53', 310, NULL, NULL, 204808),
(204809, '3.40.366.10-FF-000067', NULL, 'Putative sterigmatocystin biosynthesis fatty acid synthase subunit beta', 124, NULL, NULL, 204809),
(204810, '1.20.920.10-FF-000166', NULL, 'Pbrm-1', 115, NULL, NULL, 204810),
(204811, '1.20.58.1480-FF-000021', NULL, 'Lon protease homolog, mitochondrial', 129, NULL, NULL, 204811),
(204812, '2.10.25.10-FF-000175', NULL, 'Integrin subunit beta-like 1', 48, NULL, NULL, 204812),
(204813, '1.10.287.110-FF-000349', NULL, 'DnaJ-like protein', 121, NULL, NULL, 204813),
(204814, '3.30.450.30-FF-000030', NULL, 'Profilin', 125, NULL, NULL, 204814),
(204815, '2.30.30.140-FF-000067', NULL, 'Histone acetyltransferase', 120, NULL, NULL, 204815),
(204816, '3.80.10.10-FF-004227', NULL, 'Uncharacterized protein', 81, NULL, NULL, 204816),
(204817, '3.30.420.40-FF-000531', NULL, 'Actin', 114, NULL, NULL, 204817),
(204818, '3.40.33.10-FF-000122', NULL, 'Uncharacterized protein', 181, NULL, NULL, 204818),
(204819, '3.30.40.10-FF-001331', NULL, 'Putative RING-H2 finger protein ATL53', 87, NULL, NULL, 204819),
(204820, '3.40.50.2020-FF-000150', NULL, 'Uncharacterized protein', 153, NULL, NULL, 204820),
(204821, '2.130.10.10-FF-005497', NULL, 'Uncharacterized protein', 114, NULL, NULL, 204821),
(204822, '2.10.25.10-FF-000124', NULL, 'Signal peptide, CUB domain and EGF-like domain-containing 3', 43, NULL, NULL, 204822),
(204823, '3.40.50.1820-FF-001736', NULL, 'Uncharacterized protein', 86, NULL, NULL, 204823),
(204824, '2.40.10.10-FF-000555', NULL, NULL, 74, NULL, NULL, 204824),
(204825, '3.10.100.10-FF-000278', NULL, NULL, 148, NULL, NULL, 204825),
(204826, '3.30.2070.10-FF-000005', NULL, 'Molybdopterin oxidoreductase family protein', 67, NULL, NULL, 204826),
(204827, '2.60.120.260-FF-000657', NULL, 'Uncharacterized protein', 81, NULL, NULL, 204827),
(204828, '3.40.50.1000-FF-000653', NULL, NULL, 98, NULL, NULL, 204828),
(204829, '3.40.50.1010-FF-000190', NULL, NULL, 105, NULL, NULL, 204829),
(204830, '1.10.1300.10-FF-000047', NULL, 'cAMP-specific cyclic nucleotide phosphodiesterase, putative', 151, NULL, NULL, 204830),
(204831, '3.10.250.10-FF-000053', NULL, 'Uncharacterized protein', 98, NULL, NULL, 204831),
(204832, '2.20.25.420-FF-000002', NULL, 'Zinc finger protein ZPR1', 55, NULL, NULL, 204832),
(204833, '3.30.1360.120-FF-000022', NULL, 'Aminomethyltransferase, putative', 385, NULL, NULL, 204833),
(204834, '1.20.1050.10-FF-000171', NULL, 'Glutathione S-transferase, putative', 137, NULL, NULL, 204834),
(204835, '1.10.287.10-FF-000044', NULL, 'AGAP005226-PA', 20, NULL, NULL, 204835),
(204836, '2.60.120.920-FF-000007', NULL, 'SPRY domain-containing SOCS box protein 1', 167, NULL, NULL, 204836),
(204837, '2.60.120.200-FF-000393', NULL, 'Galectin', 146, NULL, NULL, 204837),
(204838, '3.30.70.330-FF-000841', NULL, 'Polyadenylate-binding protein, putative', 95, NULL, NULL, 204838),
(204839, '1.20.1410.10-FF-000042', NULL, 'Predicted protein', 183, NULL, NULL, 204839),
(204840, '3.40.50.1010-FF-000038', NULL, 'Exosome complex exonuclease RRP44', 184, NULL, NULL, 204840),
(204841, '1.20.1050.130-FF-000024', NULL, 'Methionine-tRNA ligase, beta subunit', 127, NULL, NULL, 204841),
(204842, '3.40.50.300-FF-005935', NULL, 'Uncharacterized protein', 184, NULL, NULL, 204842),
(204843, '3.30.420.40-FF-001099', NULL, 'Uncharacterized protein', 66, NULL, NULL, 204843),
(204844, '3.30.160.60-FF-004884', NULL, NULL, 33, NULL, NULL, 204844);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(204845, '3.40.1370.10-FF-000037', NULL, 'Uncharacterized protein', 79, NULL, NULL, 204845),
(204846, '1.20.1250.10-FF-000040', NULL, 'Interleukin 26', 136, NULL, NULL, 204846),
(204847, '2.60.40.10-FF-001478', NULL, 'Terribly reduced optic lobes, isoform AF', 91, NULL, NULL, 204847),
(204848, '3.20.20.140-FF-000350', NULL, 'Uncharacterized protein', 316, NULL, NULL, 204848),
(204849, '1.10.287.70-FF-000308', NULL, 'Ionotropic receptor 68b', 151, NULL, NULL, 204849),
(204850, '1.20.1230.10-FF-000005', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 239, NULL, NULL, 204850),
(204851, '2.130.10.10-FF-004980', NULL, 'Uncharacterized protein', 80, NULL, NULL, 204851),
(204852, '3.30.200.20-FF-001110', NULL, 'Serine/threonine protein kinase', 58, NULL, NULL, 204852),
(204853, '3.30.460.10-FF-000160', NULL, 'DNA polymerase', 169, NULL, NULL, 204853),
(204854, '1.10.630.10-FF-000264', NULL, 'Uncharacterized protein', 472, NULL, NULL, 204854),
(204855, '1.10.8.10-FF-000102', NULL, 'Non-specific serine/threonine protein kinase', 48, NULL, NULL, 204855),
(204856, '4.10.240.10-FF-000222', NULL, 'Uga3p', 86, NULL, NULL, 204856),
(204857, '3.40.50.1220-FF-000016', NULL, 'SIR2 family histone deacetylase', 155, NULL, NULL, 204857),
(204858, '3.30.160.60-FF-002063', NULL, 'RB associated KRAB zinc finger', 31, NULL, NULL, 204858),
(204859, '1.10.510.10-FF-003655', NULL, NULL, 183, NULL, NULL, 204859),
(204860, '3.50.50.60-FF-000384', NULL, 'FAD-containing monooxygenase MymA', 155, NULL, NULL, 204860),
(204861, '3.90.550.20-FF-000015', NULL, 'Glycoside transferase family 32', 216, NULL, NULL, 204861),
(204862, '3.30.230.10-FF-000333', NULL, 'Predicted protein', 72, NULL, NULL, 204862),
(204863, '4.10.400.10-FF-000224', NULL, 'Perlecan', 38, NULL, NULL, 204863),
(204864, '2.40.160.50-FF-000043', NULL, 'Uncharacterized protein', 185, NULL, NULL, 204864),
(204865, '3.40.50.10140-FF-000090', NULL, 'Uncharacterized protein', 83, NULL, NULL, 204865),
(204866, '3.30.200.20-FF-000834', NULL, 'Serine/threonine-protein kinase D6PKL2', 15, NULL, NULL, 204866),
(204867, '2.130.10.10-FF-002675', NULL, 'Uncharacterized protein', 330, NULL, NULL, 204867),
(204868, '1.25.40.10-FF-003815', NULL, 'Uncharacterized protein', 134, NULL, NULL, 204868),
(204869, '3.80.10.10-FF-002350', NULL, 'Predicted protein', 302, NULL, NULL, 204869),
(204870, '3.40.50.300-FF-006571', NULL, 'Uncharacterized protein', 101, NULL, NULL, 204870),
(204871, '3.30.450.20-FF-000544', NULL, 'Hybrid signal transduction histidine kinase H', 111, NULL, NULL, 204871),
(204872, '3.30.450.30-FF-000081', NULL, 'Ragulator complex protein LAMTOR4', 89, NULL, NULL, 204872),
(204873, '3.30.420.100-FF-000015', NULL, '60S ribosomal protein L5 isoform X2', 64, NULL, NULL, 204873),
(204874, '1.25.40.20-FF-000890', NULL, 'Uncharacterized protein', 210, NULL, NULL, 204874),
(204875, '1.25.40.10-FF-003719', NULL, 'Zinc finger, C3H1-type-containing', 187, NULL, NULL, 204875),
(204876, '3.30.40.10-FF-001595', NULL, 'PINEAPPLE EYE', 88, NULL, NULL, 204876),
(204877, '3.90.190.10-FF-000434', NULL, 'Uncharacterized protein', 72, NULL, NULL, 204877),
(204878, '1.10.238.10-FF-000296', NULL, 'Protein S100', 101, NULL, NULL, 204878),
(204879, '3.20.20.220-FF-000008', NULL, 'Proline dehydrogenase', 350, NULL, NULL, 204879),
(204880, '1.25.10.10-FF-000492', NULL, 'HEAT repeat containing 1', 319, NULL, NULL, 204880),
(204881, '2.10.25.10-FF-001585', NULL, 'Uncharacterized protein', 110, NULL, NULL, 204881),
(204882, '1.25.40.410-FF-000007', NULL, 'YLR422W-like protein', 145, NULL, NULL, 204882),
(204883, '2.60.120.10-FF-000182', NULL, 'Mannose-6-phosphate isomerase', 85, NULL, NULL, 204883),
(204884, '3.30.160.60-FF-005373', NULL, NULL, 50, NULL, NULL, 204884),
(204885, '3.50.50.80-FF-000002', NULL, 'SUMO-activating enzyme subunit 2', 111, NULL, NULL, 204885),
(204886, '2.40.50.90-FF-000098', NULL, 'Tudor domain-containing protein 1', 78, NULL, NULL, 204886),
(204887, '2.60.40.10-FF-004788', NULL, NULL, 100, NULL, NULL, 204887),
(204888, '1.10.472.80-FF-000271', NULL, NULL, 86, NULL, NULL, 204888);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(204889, '3.30.420.510-FF-000020', NULL, 'Pantothenate kinase PanK, putative', 159, NULL, NULL, 204889),
(204890, '1.10.510.10-FF-001446', NULL, 'Probable serine/threonine-protein kinase YabT', 219, NULL, NULL, 204890),
(204891, '2.10.25.10-FF-000388', NULL, 'Laminin subunit alpha', 53, NULL, NULL, 204891),
(204892, '3.40.50.720-FF-000603', NULL, '40S ribosomal protein S30', 190, NULL, NULL, 204892),
(204893, '3.40.50.460-FF-000003', NULL, 'ATP-dependent 6-phosphofructokinase', 147, NULL, NULL, 204893),
(204894, '1.25.40.820-FF-000012', NULL, 'Uncharacterized protein', 175, NULL, NULL, 204894),
(204895, '1.10.390.30-FF-000003', NULL, 'Immunomodulating metalloprotease', 200, NULL, NULL, 204895),
(204896, '1.10.150.20-FF-000123', NULL, 'DNA polymerase eta', 79, NULL, NULL, 204896),
(204897, '3.40.50.150-FF-000758', NULL, 'S-adenosyl-L-methionine-dependent methyltransferases superfamily protein', 194, NULL, NULL, 204897),
(204898, '2.20.25.80-FF-000015', NULL, 'Protein kinase family protein', 40, NULL, NULL, 204898),
(204899, '3.40.50.1370-FF-000033', NULL, 'CAD protein', 135, NULL, NULL, 204899),
(204900, '3.40.50.150-FF-000854', NULL, 'Nicotianamine synthase-like protein', 265, NULL, NULL, 204900),
(204901, '2.120.10.30-FF-000001', NULL, 'Low-density lipoprotein receptor-related protein 6', 291, NULL, NULL, 204901),
(204902, '3.30.70.330-FF-000280', NULL, 'RNA-binding domain-containing protein', 90, NULL, NULL, 204902),
(204903, '3.40.50.2300-FF-000705', NULL, 'Response regulator receiver', 129, NULL, NULL, 204903),
(204904, '2.40.50.150-FF-000009', NULL, 'DNA-directed RNA polymerase subunit beta', 117, NULL, NULL, 204904),
(204905, '3.40.50.12470-FF-000001', NULL, '2-oxoglutarate dehydrogenase, mitochondrial isoform X1', 264, NULL, NULL, 204905),
(204906, '3.40.630.30-FF-000042', NULL, 'Glycylpeptide N-tetradecanoyltransferase', 170, NULL, NULL, 204906),
(204907, '3.40.720.10-FF-000155', NULL, 'Iduronate-2-sulfatase', 468, NULL, NULL, 204907),
(204908, '3.10.290.10-FF-000050', NULL, 'Tyrosine--tRNA ligase', 89, NULL, NULL, 204908),
(204909, '1.20.1270.60-FF-000264', NULL, 'Uncharacterized protein', 145, NULL, NULL, 204909),
(204910, '3.30.420.40-FF-000082', NULL, 'ROK family transcriptional regulator', 123, NULL, NULL, 204910),
(204911, '2.30.40.10-FF-000029', NULL, 'Dihydropyrimidinase-related protein 5', 46, NULL, NULL, 204911),
(204912, '1.10.510.10-FF-002874', NULL, 'Probable serine/threonine-protein kinase ifkA', 257, NULL, NULL, 204912),
(204913, '3.30.420.10-FF-000663', NULL, NULL, 188, NULL, NULL, 204913),
(204914, '1.20.190.50-FF-000008', NULL, 'Nuclear pore complex protein', 255, NULL, NULL, 204914),
(204915, '3.30.70.20-FF-000060', NULL, 'Ferredoxin-like protein', 76, NULL, NULL, 204915),
(204916, '3.30.70.330-FF-002819', NULL, NULL, 144, NULL, NULL, 204916),
(204917, '3.90.70.10-FF-000060', NULL, 'Cathepsin Z', 274, NULL, NULL, 204917),
(204918, '1.20.58.1070-FF-000016', NULL, 'Gem-associated protein 2', 254, NULL, NULL, 204918),
(204919, '3.15.20.10-FF-000022', NULL, 'BPI fold-containing family C,-like', 97, NULL, NULL, 204919),
(204920, '3.40.50.300-FF-007060', NULL, 'AEL095Cp', 195, NULL, NULL, 204920),
(204921, '3.10.50.10-FF-000062', NULL, 'Calcium-binding protein, putative', 58, NULL, NULL, 204921),
(204922, '2.60.120.650-FF-000179', NULL, 'Uncharacterized protein', 124, NULL, NULL, 204922),
(204923, '3.30.760.10-FF-000025', NULL, 'Translation Initiation factor eIF-4e-like, putative', 196, NULL, NULL, 204923),
(204924, '1.20.5.110-FF-000051', NULL, 'synaptosomal-associated protein 29', 65, NULL, NULL, 204924),
(204925, '1.20.58.200-FF-000010', NULL, NULL, 82, NULL, NULL, 204925),
(204926, '3.80.10.10-FF-000337', NULL, 'Adhesion molecule with Ig-like domain 3', 242, NULL, NULL, 204926),
(204927, '1.25.40.850-FF-000004', NULL, 'Carnation, isoform B', 96, NULL, NULL, 204927),
(204928, '1.20.5.420-FF-000025', NULL, 'Ribonuclease P protein component 4', 59, NULL, NULL, 204928),
(204929, '1.10.390.10-FF-000109', NULL, 'Uncharacterized protein', 167, NULL, NULL, 204929),
(204930, '3.90.1410.10-FF-000069', NULL, 'Uncharacterized protein', 254, NULL, NULL, 204930);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(204931, '1.10.10.10-FF-001542', NULL, 'Panl-2', 85, NULL, NULL, 204931),
(204932, '1.10.290.10-FF-000012', NULL, 'DNA topoisomerase', 101, NULL, NULL, 204932),
(204933, '1.10.1200.120-FF-000009', NULL, 'Large conductance mechanosensitive channel protein', 137, NULL, NULL, 204933),
(204934, '3.10.20.90-FF-000011', NULL, 'Polyubiquitin Ubiquitin', 76, NULL, NULL, 204934),
(204935, '3.40.140.10-FF-000009', NULL, '26S proteasome non-ATPase regulatory subunit 7', 186, NULL, NULL, 204935),
(204936, '2.40.128.20-FF-000050', NULL, 'Uncharacterized protein', 169, NULL, NULL, 204936),
(204937, '3.30.930.10-FF-000246', NULL, 'Phenylalanyl-tRNA synthetase beta chain', 181, NULL, NULL, 204937),
(204938, '2.130.10.10-FF-001894', NULL, 'Pre-mRNA splicing factor, putative', 101, NULL, NULL, 204938),
(204939, '3.30.70.330-FF-000633', NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', 153, NULL, NULL, 204939),
(204940, '2.60.120.920-FF-000215', NULL, 'Ryanodine receptor 1', 85, NULL, NULL, 204940),
(204941, '1.20.1560.10-FF-000642', NULL, 'Protein CBG25498', 606, NULL, NULL, 204941),
(204942, '1.10.472.10-FF-000160', NULL, 'Cyclin-T2', 94, NULL, NULL, 204942),
(204943, '3.40.50.300-FF-003794', NULL, 'Midasin', 127, NULL, NULL, 204943),
(204944, '3.40.1110.10-FF-000288', NULL, NULL, 85, NULL, NULL, 204944),
(204945, '3.40.1350.10-FF-000042', NULL, 'Probable tRNA-splicing endonuclease subunit sen15', 128, NULL, NULL, 204945),
(204946, '3.40.50.300-FF-001720', NULL, 'NACHT and WD repeat domain containing 1', 168, NULL, NULL, 204946),
(204947, '3.40.50.150-FF-001422', NULL, NULL, 154, NULL, NULL, 204947),
(204948, '2.30.29.30-FF-001245', NULL, 'Predicted protein', 160, NULL, NULL, 204948),
(204949, '3.30.420.40-FF-000559', NULL, 'Actin-like protein, putative', 125, NULL, NULL, 204949),
(204950, '1.25.10.10-FF-002739', NULL, 'Uncharacterized protein', 814, NULL, NULL, 204950),
(204951, '3.20.20.140-FF-000142', NULL, 'TatD family Hydrolase', 255, NULL, NULL, 204951),
(204952, '3.40.50.300-FF-001169', NULL, 'Type VII secretion AAA-ATPase EccA', 197, NULL, NULL, 204952),
(204953, '1.10.238.10-FF-000857', NULL, 'Sodium channel protein', 120, NULL, NULL, 204953),
(204954, '2.60.40.10-FF-000781', NULL, 'Mannosidase beta', 113, NULL, NULL, 204954),
(204955, '3.90.650.10-FF-000065', NULL, 'Phosphoribosylformylglycinamidine synthase, putative', 157, NULL, NULL, 204955),
(204956, '3.30.460.10-FF-000081', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 243, NULL, NULL, 204956),
(204957, '3.40.50.300-FF-004946', NULL, 'Uncharacterized protein', 138, NULL, NULL, 204957),
(204958, '3.40.50.1000-FF-000861', NULL, NULL, 43, NULL, NULL, 204958),
(204959, '3.40.850.10-FF-000187', NULL, 'Kinesin-like protein', 382, NULL, NULL, 204959),
(204960, '3.20.20.80-FF-000721', NULL, 'Uncharacterized protein', 152, NULL, NULL, 204960),
(204961, '2.60.110.10-FF-000024', NULL, 'Os10g0524900 protein', 160, NULL, NULL, 204961),
(204962, '3.10.20.10-FF-000026', NULL, '60S ribosomal protein L18a', 74, NULL, NULL, 204962),
(204963, '3.40.50.2300-FF-000195', NULL, 'Glutamate receptor', 135, NULL, NULL, 204963),
(204964, '2.40.50.140-FF-000063', NULL, 'DNA helicase', 77, NULL, NULL, 204964),
(204965, '3.30.160.60-FF-001399', NULL, 'Zinc finger protein', 25, NULL, NULL, 204965),
(204966, '2.60.40.2300-FF-000016', NULL, 'Uncharacterized protein', 141, NULL, NULL, 204966),
(204967, '2.60.200.40-FF-000051', NULL, 'Uncharacterized protein', 166, NULL, NULL, 204967),
(204968, '1.20.990.10-FF-000029', NULL, 'Sulfite reductase [NADPH] flavoprotein alpha-component', 110, NULL, NULL, 204968),
(204969, '3.90.1150.10-FF-000150', NULL, 'Similar to cystathionine gamma-synthase', 84, NULL, NULL, 204969),
(204970, '1.10.220.20-FF-000016', NULL, 'Uncharacterized protein', 57, NULL, NULL, 204970),
(204971, '1.20.1250.20-FF-002342', NULL, 'Uncharacterized protein', 112, NULL, NULL, 204971),
(204972, '1.10.510.10-FF-001238', NULL, 'Nucleotide exchange factor RasGEF P family protein', 253, NULL, NULL, 204972);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(204973, '2.60.40.10-FF-001186', NULL, 'Interleukin 13 receptor subunit alpha 2', 102, NULL, NULL, 204973),
(204974, '1.25.40.10-FF-003927', NULL, 'Anaphase-promoting complex subunit, putative', 410, NULL, NULL, 204974),
(204975, '2.10.90.10-FF-000134', NULL, 'Vascular endothelial growth factor Bb', 111, NULL, NULL, 204975),
(204976, '3.30.1360.170-FF-000008', NULL, 'Flavin-dependent thymidylate synthase', 232, NULL, NULL, 204976),
(204977, '3.80.10.10-FF-001973', NULL, 'F-box/LRR-repeat protein 16-like Protein', 68, NULL, NULL, 204977),
(204978, '3.30.40.10-FF-002320', NULL, 'Histone-lysine N-methyltransferase', 101, NULL, NULL, 204978),
(204979, '1.20.1070.10-FF-000734', NULL, 'Methuselah-like 8, isoform B', 251, NULL, NULL, 204979),
(204980, '2.60.120.10-FF-000002', NULL, 'Cyclic nucleotide gated channel alpha 1a', 135, NULL, NULL, 204980),
(204981, '3.40.50.720-FF-000654', NULL, 'Voltage-gated Ion Channel (VIC) Superfamily', 139, NULL, NULL, 204981),
(204982, '3.80.10.10-FF-002911', NULL, 'Uncharacterized protein', 97, NULL, NULL, 204982),
(204983, '2.130.10.10-FF-004648', NULL, 'Uncharacterized protein', 192, NULL, NULL, 204983),
(204984, '3.40.50.300-FF-005031', NULL, 'Predicted protein', 202, NULL, NULL, 204984),
(204985, '2.40.50.140-FF-000383', NULL, 'Transcription elongation factor Spt6', 82, NULL, NULL, 204985),
(204986, '2.60.120.260-FF-000096', NULL, 'SUN domain protein1', 196, NULL, NULL, 204986),
(204987, '2.60.40.10-FF-004676', NULL, NULL, 91, NULL, NULL, 204987),
(204988, '3.40.462.20-FF-000007', NULL, 'Hexose oxidase', 258, NULL, NULL, 204988),
(204989, '2.60.120.560-FF-000028', NULL, 'Uncharacterized protein', 130, NULL, NULL, 204989),
(204990, '3.10.105.10-FF-000025', NULL, 'ABC transporter, substrate-binding protein', 213, NULL, NULL, 204990),
(204991, '3.40.50.300-FF-000028', NULL, 'UvrABC system protein A', 197, NULL, NULL, 204991),
(204992, '3.30.70.330-FF-001297', NULL, NULL, 71, NULL, NULL, 204992),
(204993, '1.10.418.10-FF-000282', NULL, 'Uncharacterized protein', 54, NULL, NULL, 204993),
(204994, '3.30.170.10-FF-000002', NULL, 'Cyclin-dependent kinases regulatory subunit', 110, NULL, NULL, 204994),
(204995, '1.10.1200.270-FF-000026', NULL, 'Uncharacterized protein', 120, NULL, NULL, 204995),
(204996, '2.60.40.60-FF-000312', NULL, 'FAT atypical cadherin 3a', 111, NULL, NULL, 204996),
(204997, '3.30.1330.220-FF-000001', NULL, 'ORF1a polyprotein', 131, NULL, NULL, 204997),
(204998, '2.60.40.10-FF-004996', NULL, NULL, 137, NULL, NULL, 204998),
(204999, '1.10.287.2720-FF-000009', NULL, 'Uncharacterized protein', 67, NULL, NULL, 204999),
(205000, '1.20.120.610-FF-000014', NULL, 'ATP synthase subunit c', 81, NULL, NULL, 205000),
(205001, '2.80.10.50-FF-000104', NULL, 'Pyramus', 127, NULL, NULL, 205001),
(205002, '3.30.70.330-FF-002078', NULL, NULL, 135, NULL, NULL, 205002),
(205003, '2.130.10.10-FF-003131', NULL, 'Uncharacterized protein', 243, NULL, NULL, 205003),
(205004, '3.40.50.150-FF-000646', NULL, '6-hydroxytryprostatin B O-methyltransferase', 227, NULL, NULL, 205004),
(205005, '2.160.20.10-FF-000229', NULL, 'Pectinesterase', 248, NULL, NULL, 205005),
(205006, '1.25.40.10-FF-002567', NULL, 'Pentatricopeptide repeat-containing protein', 63, NULL, NULL, 205006),
(205007, '3.40.50.300-FF-007801', NULL, 'Uncharacterized protein', 43, NULL, NULL, 205007),
(205008, '3.40.50.1820-FF-000455', NULL, 'Alpha/beta hydrolase', 309, NULL, NULL, 205008),
(205009, '3.30.160.60-FF-004384', NULL, NULL, 59, NULL, NULL, 205009),
(205010, '1.25.40.20-FF-001839', NULL, 'Uncharacterized protein', 145, NULL, NULL, 205010),
(205011, '1.10.220.10-FF-000070', NULL, 'Annexin A13,-like', 34, NULL, NULL, 205011),
(205012, '2.30.29.70-FF-000009', NULL, 'WGS project CABT00000000 data, contig 2.6', 120, NULL, NULL, 205012),
(205013, '2.10.25.10-FF-000500', NULL, 'Growth arrest specific 6', 38, NULL, NULL, 205013),
(205014, '1.25.10.10-FF-000941', NULL, 'HEAT repeat domain containing protein', 151, NULL, NULL, 205014),
(205015, '2.70.150.10-FF-000013', NULL, 'Phospholipid-transporting ATPase', 176, NULL, NULL, 205015);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(205016, '2.40.50.40-FF-000044', NULL, 'C.Elegans Chromodomain protein', 86, NULL, NULL, 205016),
(205017, '3.40.50.150-FF-000062', NULL, 'U6 small nuclear RNA (adenine-(43)-N(6))-methyltransferase', 254, NULL, NULL, 205017),
(205018, '2.60.40.3190-FF-000002', NULL, 'Envelope glycoprotein H', 136, NULL, NULL, 205018),
(205019, '3.30.710.10-FF-000090', NULL, 'GDNF inducible zinc finger protein 1', 149, NULL, NULL, 205019),
(205020, '2.60.120.310-FF-000015', NULL, 'peptidyl-glycine alpha-amidating monooxygenase A', 151, NULL, NULL, 205020),
(205021, '3.30.230.10-FF-000092', NULL, 'Lon protease homolog', 199, NULL, NULL, 205021),
(205022, '1.10.10.10-FF-001278', NULL, 'Predicted protein', 83, NULL, NULL, 205022),
(205023, '3.30.160.60-FF-000994', NULL, 'zinc finger protein 142', 66, NULL, NULL, 205023),
(205024, '1.25.40.10-FF-003023', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 109, NULL, NULL, 205024),
(205025, '3.40.1010.10-FF-000016', NULL, 'Uroporphyrin-III C-methyltransferase', 121, NULL, NULL, 205025),
(205026, '1.10.510.10-FF-002587', NULL, NULL, 213, NULL, NULL, 205026),
(205027, '2.70.150.10-FF-000125', NULL, 'Probable phospholipid-transporting ATPase IF', 89, NULL, NULL, 205027),
(205028, '1.10.8.60-FF-000095', NULL, 'Lon protease homolog 2, peroxisomal', 137, NULL, NULL, 205028),
(205029, '3.20.20.70-FF-000443', NULL, 'tRNA-dihydrouridine synthase', 234, NULL, NULL, 205029),
(205030, '2.70.170.10-FF-000076', NULL, 'Gamma-aminobutyric acid receptor subunit gamma-3', 62, NULL, NULL, 205030),
(205031, '3.30.40.10-FF-002112', NULL, 'Uncharacterized protein', 118, NULL, NULL, 205031),
(205032, '1.10.150.60-FF-000005', NULL, 'Jumonji, AT-rich interactive domain 2a', 121, NULL, NULL, 205032),
(205033, '3.30.70.260-FF-000180', NULL, 'Ribose-5-phosphate isomerase, putative', 38, NULL, NULL, 205033),
(205034, '3.80.10.10-FF-000545', NULL, 'Nodulation receptor kinase', 123, NULL, NULL, 205034),
(205035, '1.20.1440.340-FF-000001', NULL, 'N-acetylgalactosamine kinase isoform 2', 138, NULL, NULL, 205035),
(205036, '2.70.210.12-FF-000003', NULL, 'Obg family GTPase CgtA', 160, NULL, NULL, 205036),
(205037, '3.30.190.20-FF-000006', NULL, 'Ribosomal protein', 78, NULL, NULL, 205037),
(205038, '3.40.1190.10-FF-000040', NULL, NULL, 310, NULL, NULL, 205038),
(205039, '1.25.40.10-FF-005052', NULL, 'Uncharacterized protein', 114, NULL, NULL, 205039),
(205040, '2.40.50.140-FF-000916', NULL, NULL, 125, NULL, NULL, 205040),
(205041, '3.30.1050.10-FF-000004', NULL, 'Hydroxysteroid 17-beta dehydrogenase 4', 120, NULL, NULL, 205041),
(205042, '3.30.200.20-FF-001341', NULL, 'Uncharacterized protein', 80, NULL, NULL, 205042),
(205043, '3.20.10.10-FF-000059', NULL, 'Branched-chain-amino-acid aminotransferase', 119, NULL, NULL, 205043),
(205044, '1.25.40.1030-FF-000027', NULL, 'SEC16 homolog B, endoplasmic reticulum export factor', 402, NULL, NULL, 205044),
(205045, '2.130.10.10-FF-005429', NULL, 'Uncharacterized WD repeat-containing protein C1306.02', 228, NULL, NULL, 205045),
(205046, '2.60.40.10-FF-005513', NULL, NULL, 78, NULL, NULL, 205046),
(205047, '3.30.460.20-FF-000027', NULL, 'Mg2 transporter protein CorA family protein', 139, NULL, NULL, 205047),
(205048, '1.10.510.10-FF-001626', NULL, 'Death-associated protein kinase 2a', 213, NULL, NULL, 205048),
(205049, '3.30.450.20-FF-000313', NULL, 'Probable two-component sensor', 123, NULL, NULL, 205049),
(205050, '3.30.565.10-FF-000009', NULL, 'Molecular chaperone HtpG', 218, NULL, NULL, 205050),
(205051, '3.30.420.10-FF-000275', NULL, 'Ribonuclease H', 168, NULL, NULL, 205051),
(205052, '3.30.70.1170-FF-000010', NULL, 'YNL022C-like protein', 82, NULL, NULL, 205052),
(205053, '3.80.10.10-FF-002693', NULL, 'Leucine-rich repeat protein kinase family protein', 75, NULL, NULL, 205053),
(205054, '3.30.540.10-FF-000082', NULL, 'Inositol-1-monophosphatase', 117, NULL, NULL, 205054),
(205055, '1.25.40.10-FF-005232', NULL, 'UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase', 178, NULL, NULL, 205055),
(205056, '2.40.50.1020-FF-000025', NULL, 'CO-responsive transcriptional regulator RcoM', 101, NULL, NULL, 205056);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(205057, '1.20.5.340-FF-000035', NULL, 'Paramyosin, long form', 81, NULL, NULL, 205057),
(205058, '1.10.238.10-FF-000537', NULL, 'Zinc_finger_-_C3HC4_type_(RING_finger)/Ring_finger_domain/zinc-RING_finger_domain/EF-hand_domain_pair/EF-hand_domain/EF_hand/Secreted_protein_acidic_and_rich_in_cys teine_Ca_binding_region_containing_...', 73, NULL, NULL, 205058),
(205059, '3.20.20.140-FF-000462', NULL, 'RE32242p', 180, NULL, NULL, 205059),
(205060, '3.30.200.20-FF-002419', NULL, 'Non-specific serine/threonine protein kinase', 197, NULL, NULL, 205060),
(205061, '1.10.132.70-FF-000012', NULL, 'Telomerase reverse transcriptase', 224, NULL, NULL, 205061),
(205062, '2.60.40.10-FF-004092', NULL, NULL, 94, NULL, NULL, 205062),
(205063, '2.60.40.10-FF-001062', NULL, 'OX-2 membrane glycoprotein', 90, NULL, NULL, 205063),
(205064, '1.20.1280.50-FF-000200', NULL, 'Rho GTPase-activating protein gacFF', 89, NULL, NULL, 205064),
(205065, '3.30.1450.10-FF-000001', NULL, 'Outer membrane protein assembly factor BamE', 80, NULL, NULL, 205065),
(205066, '2.40.50.360-FF-000005', NULL, 'RuvB-like helicase', 74, NULL, NULL, 205066),
(205067, '1.20.950.20-FF-000024', NULL, 'Respiratory nitrate reductase', 73, NULL, NULL, 205067),
(205068, '1.10.630.10-FF-000617', NULL, 'Predicted protein', 251, NULL, NULL, 205068),
(205069, '3.50.50.60-FF-000963', NULL, 'Predicted protein', 165, NULL, NULL, 205069),
(205070, '3.40.50.300-FF-003518', NULL, 'ATP-dependent helicase fft1', 187, NULL, NULL, 205070),
(205071, '3.80.10.10-FF-002170', NULL, 'Outer membrane protein YopM', 353, NULL, NULL, 205071),
(205072, '3.40.50.11500-FF-000025', NULL, NULL, 174, NULL, NULL, 205072),
(205073, '2.40.50.140-FF-000175', NULL, 'Programmed cell death 11', 83, NULL, NULL, 205073),
(205074, '2.40.50.730-FF-000026', NULL, 'DNA polymerase', 67, NULL, NULL, 205074),
(205075, '3.40.50.300-FF-000360', NULL, 'RAB9B, member RAS oncogene family', 181, NULL, NULL, 205075),
(205076, '3.40.50.300-FF-008577', NULL, 'Thymidine kinase', 128, NULL, NULL, 205076),
(205077, '3.30.70.100-FF-000065', NULL, 'Antibiotic biosynthesis monooxygenase', 84, NULL, NULL, 205077),
(205078, '3.40.190.290-FF-000111', NULL, 'Probable transcriptional regulator', 207, NULL, NULL, 205078),
(205079, '3.30.65.10-FF-000005', NULL, 'Predicted DNA topoisomerase', 47, NULL, NULL, 205079),
(205080, '3.40.50.720-FF-001110', NULL, 'Formate dehydrogenase', 190, NULL, NULL, 205080),
(205081, '3.30.160.60-FF-000207', NULL, 'zinc finger protein SNAI2', 29, NULL, NULL, 205081),
(205082, '2.20.25.10-FF-000034', NULL, 'tRNA m2G10 methyltransferase subunit, putative', 125, NULL, NULL, 205082),
(205083, '1.10.246.130-FF-000021', NULL, NULL, 86, NULL, NULL, 205083),
(205084, '1.10.1420.10-FF-000106', NULL, 'YALI0B10197p', 155, NULL, NULL, 205084),
(205085, '3.30.497.10-FF-000087', NULL, 'Serpin 77Bb', 226, NULL, NULL, 205085),
(205086, '1.10.510.10-FF-004111', NULL, NULL, 118, NULL, NULL, 205086),
(205087, '3.40.50.920-FF-000006', NULL, 'Pyruvate dehydrogenase E1 component subunit beta', 133, NULL, NULL, 205087),
(205088, '1.10.287.70-FF-000016', NULL, 'Putative potassium voltage-gated channel subfamily KQT member 2', 225, NULL, NULL, 205088),
(205089, '3.40.50.80-FF-000143', NULL, 'Cytochrome p450 oxidoreductase', 33, NULL, NULL, 205089),
(205090, '3.50.4.10-FF-000045', NULL, NULL, 87, NULL, NULL, 205090),
(205091, '3.30.70.890-FF-000048', NULL, 'Uncharacterized protein', 133, NULL, NULL, 205091),
(205092, '3.30.2290.10-FF-000016', NULL, 'Peptidase U62 modulator of DNA gyrase', 189, NULL, NULL, 205092),
(205093, '1.25.10.10-FF-001273', NULL, 'Protein CBG21459', 232, NULL, NULL, 205093),
(205094, '3.30.1370.30-FF-000006', NULL, '40S ribosomal protein S8', 88, NULL, NULL, 205094),
(205095, '3.30.450.190-FF-000019', NULL, 'RAS-related GTP-binding protein, putative', 131, NULL, NULL, 205095),
(205096, '3.40.50.300-FF-004042', NULL, 'ATP-dependent DEAH-box RNA helicase, putative', 223, NULL, NULL, 205096),
(205097, '3.30.40.10-FF-000875', NULL, 'Os05g0163400 protein', 66, NULL, NULL, 205097),
(205098, '3.40.50.1820-FF-001444', NULL, 'Uncharacterized protein', 188, NULL, NULL, 205098);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(205099, '1.10.1670.10-FF-000029', NULL, 'Endonuclease III homolog', 104, NULL, NULL, 205099),
(205100, '2.60.40.200-FF-000024', NULL, 'Vitellogenin fused with superoxide dismutase', 154, NULL, NULL, 205100),
(205101, '2.60.40.60-FF-000104', NULL, 'cadherin-23 isoform X1', 108, NULL, NULL, 205101),
(205102, '3.30.420.40-FF-000823', NULL, 'Phosphotransferase', 63, NULL, NULL, 205102),
(205103, '2.60.40.420-FF-000123', NULL, 'Cytochrome c oxidase subunit 2', 153, NULL, NULL, 205103),
(205104, '3.50.50.60-FF-000676', NULL, 'Succinate dehydrogenase subunit A (SdhA)', 285, NULL, NULL, 205104),
(205105, '1.25.10.10-FF-001397', NULL, 'INTegrator complex Subunit homolog', 139, NULL, NULL, 205105),
(205106, '1.25.50.20-FF-000036', NULL, 'Aminopeptidase', 321, NULL, NULL, 205106),
(205107, '3.40.50.2300-FF-000936', NULL, NULL, 177, NULL, NULL, 205107),
(205108, '1.20.1070.10-FF-001459', NULL, 'Uncharacterized protein', 217, NULL, NULL, 205108),
(205109, '1.20.1250.20-FF-000829', NULL, 'Protein CBG21733', 388, NULL, NULL, 205109),
(205110, '1.10.287.580-FF-000001', NULL, 'Serine proteinase inhibitor 2', 55, NULL, NULL, 205110),
(205111, '1.20.200.10-FF-000010', NULL, 'Adenylosuccinate lyase', 226, NULL, NULL, 205111),
(205112, '1.10.472.10-FF-000564', NULL, 'Predicted protein', 64, NULL, NULL, 205112),
(205113, '3.10.490.10-FF-000031', NULL, 'Os09g0573150 protein', 145, NULL, NULL, 205113),
(205114, '1.20.58.530-FF-000002', NULL, 'Class V myosin', 150, NULL, NULL, 205114),
(205115, '3.40.50.80-FF-000082', NULL, 'Metalloreductase, putative', 122, NULL, NULL, 205115),
(205116, '3.30.70.330-FF-001089', NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', 155, NULL, NULL, 205116),
(205117, '1.20.1070.10-FF-001982', NULL, 'Uncharacterized protein', 166, NULL, NULL, 205117),
(205118, '3.30.160.60-FF-004592', NULL, NULL, 29, NULL, NULL, 205118),
(205119, '3.30.920.10-FF-000009', NULL, 'Iron-sulfur cluster assembly protein CyaY', 101, NULL, NULL, 205119),
(205120, '3.90.190.10-FF-000203', NULL, 'Dual specificity protein phosphatase CDC14A', 149, NULL, NULL, 205120),
(205121, '2.60.40.1940-FF-000009', NULL, 'Sb:cb37', 117, NULL, NULL, 205121),
(205122, '3.40.50.720-FF-002520', NULL, 'Uncharacterized protein', 108, NULL, NULL, 205122),
(205123, '2.30.30.40-FF-000594', NULL, 'Uncharacterized protein', 61, NULL, NULL, 205123),
(205124, '3.40.50.10810-FF-000279', NULL, 'Uncharacterized protein', 202, NULL, NULL, 205124),
(205125, '2.10.70.10-FF-000190', NULL, 'Furrowed, isoform A', 58, NULL, NULL, 205125),
(205126, '1.10.560.10-FF-000117', NULL, 'Mitochondrial chaperonin', 247, NULL, NULL, 205126),
(205127, '1.10.630.10-FF-000033', NULL, '14-alpha sterol demethylase', 478, NULL, NULL, 205127),
(205128, '3.40.50.150-FF-001186', NULL, NULL, 40, NULL, NULL, 205128),
(205129, '1.20.1110.10-FF-000058', NULL, 'Probable ENA2-Plasma membrane P-type ATPase', 52, NULL, NULL, 205129),
(205130, '3.40.50.620-FF-000186', NULL, 'Putative Cysteinyl-tRNA synthetase', 262, NULL, NULL, 205130),
(205131, '2.30.29.30-FF-000520', NULL, 'Muscle M-line assembly protein unc-89', 117, NULL, NULL, 205131),
(205132, '2.10.70.10-FF-000200', NULL, 'Kielin/chordin-like protein', 36, NULL, NULL, 205132),
(205133, '1.25.40.10-FF-004984', NULL, 'TPR Domain containing protein', 139, NULL, NULL, 205133),
(205134, '1.20.120.430-FF-000016', NULL, 'tRNA modification GTPase gtpbp3, mitochondrial', 167, NULL, NULL, 205134),
(205135, '3.90.70.10-FF-000240', NULL, 'General secretion pathway protein A', 117, NULL, NULL, 205135),
(205136, '3.30.200.20-FF-001077', NULL, 'Kinase, AGC NDR', 157, NULL, NULL, 205136),
(205137, '2.10.25.10-FF-000624', NULL, 'protein delta homolog 1 isoform X1', 37, NULL, NULL, 205137),
(205138, '1.20.144.10-FF-000036', NULL, 'Putative phosphatidate phosphatase', 256, NULL, NULL, 205138),
(205139, '2.20.28.10-FF-000012', NULL, 'DNA helicase', 53, NULL, NULL, 205139),
(205140, '3.40.50.11260-FF-000032', NULL, 'Chaperone protein HtpG', 110, NULL, NULL, 205140),
(205141, '2.40.50.770-FF-000010', NULL, 'Uncharacterized protein', 129, NULL, NULL, 205141);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(205142, '3.30.70.330-FF-000757', NULL, 'RNA and export factor binding protein, putative', 136, NULL, NULL, 205142),
(205143, '3.30.860.10-FF-000010', NULL, 'Uncharacterized protein', 63, NULL, NULL, 205143),
(205144, '1.10.1000.11-FF-000003', NULL, 'Brefeldin A-inhibited guanine nucleotide-exchange protein 1', 120, NULL, NULL, 205144),
(205145, '2.130.10.10-FF-003631', NULL, 'Semaphorin 7A, putative', 457, NULL, NULL, 205145),
(205146, '2.60.40.10-FF-001803', NULL, 'filamin-A isoform X10', 94, NULL, NULL, 205146),
(205147, '2.60.40.840-FF-000013', NULL, 'Uncharacterized protein', 131, NULL, NULL, 205147),
(205148, '3.40.50.2300-FF-000548', NULL, 'C4-dicarboxylate transport transcriptional regulatory protein', 134, NULL, NULL, 205148),
(205149, '2.60.40.10-FF-002259', NULL, 'Sidekick, isoform B', 100, NULL, NULL, 205149),
(205150, '3.40.850.10-FF-000367', NULL, 'Uncharacterized protein', 65, NULL, NULL, 205150),
(205151, '3.30.40.10-FF-001999', NULL, 'Uncharacterized protein', 53, NULL, NULL, 205151),
(205152, '3.40.50.300-FF-002737', NULL, 'NADH-ubiquinone oxidoreductase complex I subunit, putative', 86, NULL, NULL, 205152),
(205153, '4.10.1000.10-FF-000090', NULL, 'Zinc finger C-x8-C-x5-C-x3-H type family protein', 89, NULL, NULL, 205153),
(205154, '1.50.40.10-FF-000137', NULL, 'Mitochondrial carrier protein, putative', 117, NULL, NULL, 205154),
(205155, '2.130.10.10-FF-004709', NULL, 'Uncharacterized protein', 171, NULL, NULL, 205155),
(205156, '1.10.730.10-FF-000097', NULL, 'Arginine--tRNA ligase', 122, NULL, NULL, 205156),
(205157, '2.60.40.420-FF-000062', NULL, 'Laccase', 131, NULL, NULL, 205157),
(205158, '1.20.1250.20-FF-002134', NULL, 'Uncharacterized protein', 206, NULL, NULL, 205158),
(205159, '1.10.490.20-FF-000002', NULL, 'C-phycocyanin beta chain', 172, NULL, NULL, 205159),
(205160, '1.10.510.10-FF-002795', NULL, NULL, 193, NULL, NULL, 205160),
(205161, '3.30.160.60-FF-001899', NULL, 'Zinc finger protein 317', 29, NULL, NULL, 205161),
(205162, '3.50.50.60-FF-000412', NULL, 'Methylenetetrahydrofolate--tRNA-(uracil-5-)-methyltransferase TrmFO', 148, NULL, NULL, 205162),
(205163, '2.30.31.10-FF-000014', NULL, 'Predicted protein', 68, NULL, NULL, 205163),
(205164, '3.40.190.10-FF-000804', NULL, 'Oligopeptide ABC transporter, solute-binding protein', 231, NULL, NULL, 205164),
(205165, '1.10.510.10-FF-000721', NULL, 'Checkpoint serine/threonine-protein kinase BUB1', 311, NULL, NULL, 205165),
(205166, '1.25.10.10-FF-000733', NULL, 'Serine/threonine-protein kinase TOR', 430, NULL, NULL, 205166),
(205167, '3.20.20.100-FF-000186', NULL, 'Uncharacterized protein', 116, NULL, NULL, 205167),
(205168, '2.60.40.2840-FF-000004', NULL, 'Calcium-binding and coiled-coil domain-containing protein 1', 118, NULL, NULL, 205168),
(205169, '2.40.30.170-FF-000062', NULL, NULL, 96, NULL, NULL, 205169),
(205170, '1.10.730.10-FF-000209', NULL, 'Valine--tRNA ligase, mitochondrial', 229, NULL, NULL, 205170),
(205171, '1.10.238.10-FF-001021', NULL, 'Uncharacterized protein', 65, NULL, NULL, 205171),
(205172, '1.10.10.10-FF-000761', NULL, 'RpiR family transcriptional regulator', 78, NULL, NULL, 205172),
(205173, '3.30.450.90-FF-000020', NULL, 'Pilus assembly protein PilB', 133, NULL, NULL, 205173),
(205174, '2.70.98.110-FF-000009', NULL, 'Mannosyl_oligosaccharide_glucosidase_-_putative', 316, NULL, NULL, 205174),
(205175, '2.170.270.10-FF-000071', NULL, 'Down and out, isoform A', 109, NULL, NULL, 205175),
(205176, '3.30.160.60-FF-002916', NULL, 'zinc finger protein 772 isoform X1', 30, NULL, NULL, 205176),
(205177, '3.30.40.10-FF-000246', NULL, 'E3 ubiquitin-protein ligase TRIM33 isoform X2', 67, NULL, NULL, 205177),
(205178, '3.30.160.60-FF-004945', NULL, NULL, 30, NULL, NULL, 205178),
(205179, '3.30.300.20-FF-000005', NULL, 'Transcription termination/antitermination protein NusA', 69, NULL, NULL, 205179),
(205180, '3.30.360.10-FF-000096', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', 165, NULL, NULL, 205180),
(205181, '3.50.50.60-FF-000755', NULL, 'Lysine (K)-specific demethylase 1A', 119, NULL, NULL, 205181);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(205182, '1.10.630.10-FF-000376', NULL, 'Cytochrome P450 NovI', 406, NULL, NULL, 205182),
(205183, '2.20.110.10-FF-000033', NULL, 'MORN repeat, putative', 46, NULL, NULL, 205183),
(205184, '3.30.70.1390-FF-000002', NULL, 'Leucine-rich repeat serine/threonine-protein kinase 1', 79, NULL, NULL, 205184),
(205185, '3.40.140.10-FF-000240', NULL, 'Cytidine and deoxycytidylate deaminase zinc-binding region family protein', 161, NULL, NULL, 205185),
(205186, '3.90.70.80-FF-000041', NULL, 'Extracellular OTU-like cysteine protease, putative', 88, NULL, NULL, 205186),
(205187, '3.40.50.1010-FF-000122', NULL, 'DNA repair enzyme', 112, NULL, NULL, 205187),
(205188, '3.30.40.10-FF-001095', NULL, 'RBR-type E3 ubiquitin transferase', 87, NULL, NULL, 205188),
(205189, '3.30.70.240-FF-000022', NULL, 'U5 snRNP-specific protein', 121, NULL, NULL, 205189),
(205190, '3.20.70.20-FF-000049', NULL, 'Uncharacterized protein', 291, NULL, NULL, 205190),
(205191, '3.30.365.10-FF-000028', NULL, 'Xanthine dehydrogenase, molybdenum binding subunit', 159, NULL, NULL, 205191),
(205192, '1.10.300.10-FF-000003', NULL, 'Adenylosuccinate synthetase', 97, NULL, NULL, 205192),
(205193, '2.130.10.10-FF-004480', NULL, 'Regulatory-associated protein of mTOR-like Protein', 171, NULL, NULL, 205193),
(205194, '3.40.50.1820-FF-001236', NULL, 'Uncharacterized protein', 334, NULL, NULL, 205194),
(205195, '3.10.50.40-FF-000138', NULL, 'Peptidylprolyl isomerase', 89, NULL, NULL, 205195),
(205196, '3.60.21.10-FF-000291', NULL, 'Serine/threonine-protein phosphatase', 233, NULL, NULL, 205196),
(205197, '4.10.400.10-FF-000336', NULL, 'Uncharacterized protein', 38, NULL, NULL, 205197),
(205198, '1.10.150.50-FF-000115', NULL, 'Serine/threonine-protein kinase STE11', 68, NULL, NULL, 205198),
(205199, '3.40.50.300-FF-003586', NULL, 'Deoxyguanosine kinase', 204, NULL, NULL, 205199),
(205200, '1.25.40.10-FF-003607', NULL, 'Uncharacterized protein', 300, NULL, NULL, 205200),
(205201, '3.30.160.60-FF-002175', NULL, 'Zinc finger protein 234', 36, NULL, NULL, 205201),
(205202, '3.30.200.20-FF-002358', NULL, 'Uncharacterized protein', 34, NULL, NULL, 205202),
(205203, '2.60.40.10-FF-001562', NULL, 'Receptor protein-tyrosine kinase', 110, NULL, NULL, 205203),
(205204, '3.80.10.10-FF-002754', NULL, 'Uncharacterized protein', 160, NULL, NULL, 205204),
(205205, '2.120.10.30-FF-000405', NULL, 'Uncharacterized protein', 202, NULL, NULL, 205205),
(205206, '1.25.40.10-FF-003366', NULL, 'Uncharacterized protein', 67, NULL, NULL, 205206),
(205207, '4.10.110.10-FF-000005', NULL, 'Trefoil factor 2', 49, NULL, NULL, 205207),
(205208, '3.60.40.10-FF-000267', NULL, 'Protein phosphatase type 2C', 286, NULL, NULL, 205208),
(205209, '3.30.70.260-FF-000028', NULL, 'Arogenate dehydratase', 102, NULL, NULL, 205209),
(205210, '1.25.40.10-FF-004708', NULL, 'Uncharacterized protein', 96, NULL, NULL, 205210),
(205211, '3.40.50.300-FF-000096', NULL, 'KRAS proto-oncogene, GTPase', 171, NULL, NULL, 205211),
(205212, '3.40.50.300-FF-004250', NULL, 'Excision repair cross-complementation group 2', 207, NULL, NULL, 205212),
(205213, '3.10.20.90-FF-000511', NULL, 'Uncharacterized protein', 87, NULL, NULL, 205213),
(205214, '3.40.50.300-FF-001456', NULL, 'ATP-dependent DNA helicase', 127, NULL, NULL, 205214),
(205215, '1.10.1520.10-FF-000030', NULL, 'Dicer-like 105', 144, NULL, NULL, 205215),
(205216, '1.10.510.10-FF-000457', NULL, 'cyclin-dependent kinase 2 isoform X4', 97, NULL, NULL, 205216),
(205217, '2.30.30.140-FF-000308', NULL, 'Uncharacterized protein', 66, NULL, NULL, 205217),
(205218, '1.20.1560.10-FF-000721', NULL, 'HlyB/MsbA family ABC transporter', 248, NULL, NULL, 205218),
(205219, '3.30.70.600-FF-000006', NULL, '39S ribosomal protein L48, mitochondrial', 101, NULL, NULL, 205219),
(205220, '3.90.190.10-FF-000546', NULL, 'Protein tyrosine phosphatase, receptor type C', 135, NULL, NULL, 205220),
(205221, '3.30.930.10-FF-000185', NULL, 'Phenylalanine--tRNA ligase beta subunit', 194, NULL, NULL, 205221),
(205222, '2.40.70.10-FF-000564', NULL, NULL, 104, NULL, NULL, 205222),
(205223, '3.40.50.150-FF-000966', NULL, NULL, 232, NULL, NULL, 205223);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(205224, '3.40.50.620-FF-000574', NULL, 'Uncharacterized protein', 150, NULL, NULL, 205224),
(205225, '3.40.630.30-FF-000542', NULL, 'Uncharacterized protein', 199, NULL, NULL, 205225),
(205226, '1.25.40.20-FF-000030', NULL, 'Kinase D-interacting substrate of 220 kDa', 264, NULL, NULL, 205226),
(205227, '3.90.660.10-FF-000015', NULL, 'Lysine-specific histone demethylase', 46, NULL, NULL, 205227),
(205228, '1.20.120.350-FF-000026', NULL, 'Sodium channel protein', 128, NULL, NULL, 205228),
(205229, '2.40.160.120-FF-000061', NULL, 'Uncharacterized protein', 167, NULL, NULL, 205229),
(205230, '2.30.40.10-FF-000181', NULL, 'Uncharacterized protein', 67, NULL, NULL, 205230),
(205231, '1.10.510.10-FF-003812', NULL, NULL, 116, NULL, NULL, 205231),
(205232, '3.90.550.10-FF-000597', NULL, 'Uncharacterized protein', 228, NULL, NULL, 205232),
(205233, '3.10.20.90-FF-000331', NULL, 'NPL4-like protein 1', 99, NULL, NULL, 205233),
(205234, '3.40.720.10-FF-000363', NULL, 'Predicted protein', 172, NULL, NULL, 205234),
(205235, '3.40.50.300-FF-007560', NULL, 'DEAD_2 protein domain containing protein', 186, NULL, NULL, 205235),
(205236, '1.10.1070.11-FF-000069', NULL, 'Phosphoinositide-3-kinase, class 3', 192, NULL, NULL, 205236),
(205237, '3.80.10.10-FF-001001', NULL, 'Probable inactive leucine-rich repeat receptor-like protein kinase At3g03770', 126, NULL, NULL, 205237),
(205238, '2.60.40.10-FF-000281', NULL, 'Cytokine receptor like factor 1', 99, NULL, NULL, 205238),
(205239, '1.50.10.20-FF-000026', NULL, 'Squalene--hopene cyclase', 267, NULL, NULL, 205239),
(205240, '3.30.50.10-FF-000140', NULL, 'COUP-TF', 39, NULL, NULL, 205240),
(205241, '2.40.10.10-FF-000004', NULL, 'Tryptase gamma 1', 103, NULL, NULL, 205241),
(205242, '1.20.58.60-FF-000492', NULL, 'Microtubule actin crosslinking factor 1a', 192, NULL, NULL, 205242),
(205243, '3.20.20.70-FF-000364', NULL, 'Inosine-5''-monophosphate dehydrogenase 2', 467, NULL, NULL, 205243),
(205244, '3.20.20.190-FF-000128', NULL, NULL, 157, NULL, NULL, 205244),
(205245, '3.30.9.10-FF-000050', NULL, 'Glycine oxidase ThiO', 140, NULL, NULL, 205245),
(205246, '1.10.8.20-FF-000010', NULL, 'alpha-tocopherol transfer protein-like', 83, NULL, NULL, 205246),
(205247, '3.30.2130.10-FF-000011', NULL, 'Aspartate/glutamate/uridylate kinase', 91, NULL, NULL, 205247),
(205248, '1.10.220.10-FF-000002', NULL, 'Annexin', 86, NULL, NULL, 205248),
(205249, '3.40.50.620-FF-000450', NULL, 'Lysine--tRNA ligase', 72, NULL, NULL, 205249),
(205250, '1.10.437.10-FF-000022', NULL, 'Apoptosis regulator ced-9', 174, NULL, NULL, 205250),
(205251, '3.40.1110.10-FF-000001', NULL, 'Sodium/potassium-transporting ATPase subunit alpha', 211, NULL, NULL, 205251),
(205252, '3.40.630.30-FF-000362', NULL, 'Uncharacterized protein', 110, NULL, NULL, 205252),
(205253, '1.10.510.10-FF-004032', NULL, NULL, 101, NULL, NULL, 205253),
(205254, '2.60.120.620-FF-000007', NULL, 'Procollagen-lysine,2-oxoglutarate 5-dioxygenase 1', 172, NULL, NULL, 205254),
(205255, '1.10.238.20-FF-000006', NULL, 'Odorant binding protein 15', 121, NULL, NULL, 205255),
(205256, '3.40.640.10-FF-000441', NULL, 'Protein CBR-GOT-1.3', 187, NULL, NULL, 205256),
(205257, '3.10.450.10-FF-000034', NULL, 'Cathelicidin-related peptide Oh-Cath', 99, NULL, NULL, 205257),
(205258, '3.40.50.2300-FF-001280', NULL, NULL, 170, NULL, NULL, 205258),
(205259, '1.25.40.10-FF-002646', NULL, 'Soluble NSF attachment protein gamma isoform', 276, NULL, NULL, 205259),
(205260, '1.10.3260.10-FF-000010', NULL, 'DNA ligase', 306, NULL, NULL, 205260),
(205261, '3.40.50.2000-FF-000852', NULL, 'Uncharacterized protein', 232, NULL, NULL, 205261),
(205262, '3.30.565.10-FF-000077', NULL, 'BlpH histidine kinase TCS13', 152, NULL, NULL, 205262),
(205263, '3.40.50.200-FF-000004', NULL, 'Proprotein convertase type 2', 335, NULL, NULL, 205263),
(205264, '3.40.1090.10-FF-000055', NULL, 'Patatin', 349, NULL, NULL, 205264),
(205265, '3.10.350.10-FF-000049', NULL, 'Cell wall protein, putative', 48, NULL, NULL, 205265),
(205266, '3.30.505.10-FF-000236', NULL, NULL, 77, NULL, NULL, 205266); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(205267, '1.20.1050.20-FF-000005', NULL, 'Signal transducer and activator of transcription', 202, NULL, NULL, 205267),
(205268, '3.80.10.10-FF-003210', NULL, 'Protein AMN1 homolog', 221, NULL, NULL, 205268),
(205269, '2.10.110.10-FF-000193', NULL, 'LIM homeobox 4', 83, NULL, NULL, 205269),
(205270, '3.60.40.10-FF-000003', NULL, 'PH domain and leucine-rich repeat protein phosphatase 1', 251, NULL, NULL, 205270),
(205271, '3.40.50.300-FF-007740', NULL, 'Uncharacterized protein', 82, NULL, NULL, 205271),
(205272, '3.30.160.60-FF-001511', NULL, 'Zinc finger protein 496', 28, NULL, NULL, 205272),
(205273, '3.30.710.10-FF-000022', NULL, 'SKP1-like protein 21 isoform X1', 151, NULL, NULL, 205273),
(205274, '1.20.1560.10-FF-000142', NULL, 'ATP-binding Cassette (ABC) Superfamily', 340, NULL, NULL, 205274),
(205275, '1.10.30.10-FF-000195', NULL, 'FACT complex subunit SSRP1', 65, NULL, NULL, 205275),
(205276, '2.10.25.10-FF-000236', NULL, 'BMP-binding endothelial regulator protein-like', 57, NULL, NULL, 205276),
(205277, '2.60.120.200-FF-000617', NULL, 'Uncharacterized protein', 145, NULL, NULL, 205277),
(205278, '1.10.340.30-FF-000056', NULL, 'DNA-3-methyladenine glycosylase 2 family protein', 110, NULL, NULL, 205278),
(205279, '2.40.30.130-FF-000022', NULL, 'Alanine--tRNA ligase', 77, NULL, NULL, 205279),
(205280, '3.40.50.10130-FF-000053', NULL, 'Uncharacterized protein', 191, NULL, NULL, 205280),
(205281, '1.25.40.180-FF-000343', NULL, NULL, 153, NULL, NULL, 205281),
(205282, '3.40.50.10470-FF-000014', NULL, 'Translation initiation factor eIF-2B alpha subunit, putative', 232, NULL, NULL, 205282),
(205283, '1.10.8.720-FF-000022', NULL, 'Dynein heavy chain family protein', 164, NULL, NULL, 205283),
(205284, '3.40.50.300-FF-001377', NULL, 'Nucleolar protein 9', 229, NULL, NULL, 205284),
(205285, '3.30.300.30-FF-000047', NULL, 'Acetyl-coenzyme A synthetase', 126, NULL, NULL, 205285),
(205286, '3.10.580.10-FF-000038', NULL, 'CBS domain-containing protein CBSX2, chloroplastic', 161, NULL, NULL, 205286),
(205287, '2.130.10.10-FF-002271', NULL, 'Nuclear pore complex protein Nup160', 283, NULL, NULL, 205287),
(205288, '2.60.40.10-FF-001686', NULL, 'Terribly reduced optic lobes, isoform BA', 92, NULL, NULL, 205288),
(205289, '1.10.287.70-FF-000084', NULL, 'Potassium voltage-gated channel protein eag', 228, NULL, NULL, 205289),
(205290, '3.20.20.60-FF-000086', NULL, 'Malyl-CoA/beta-methylmalyl-CoA/citramalyl-CoA lyase', 348, NULL, NULL, 205290),
(205291, '1.10.630.10-FF-000112', NULL, 'Cytochrome P450 71B10', 487, NULL, NULL, 205291),
(205292, '1.25.40.120-FF-000067', NULL, 'Uncharacterized protein', 199, NULL, NULL, 205292),
(205293, '2.60.120.260-FF-000596', NULL, 'Alpha-N-arabinofuranosidase', 148, NULL, NULL, 205293),
(205294, '3.30.497.10-FF-000019', NULL, 'Plasminogen activator inhibitor 2, macrophage', 219, NULL, NULL, 205294),
(205295, '3.40.50.300-FF-008257', NULL, 'Dynein heavy chain 3', 50, NULL, NULL, 205295),
(205296, '3.40.190.10-FF-000928', NULL, 'Uncharacterized protein', 65, NULL, NULL, 205296),
(205297, '1.10.565.10-FF-000191', NULL, 'Uncharacterized protein', 108, NULL, NULL, 205297),
(205298, '3.30.70.330-FF-002314', NULL, NULL, 104, NULL, NULL, 205298),
(205299, '3.80.20.20-FF-000088', NULL, 'Predicted protein', 102, NULL, NULL, 205299),
(205300, '3.60.90.10-FF-000006', NULL, 'S-adenosylmethionine decarboxylase proenzyme isoform X3', 177, NULL, NULL, 205300),
(205301, '2.60.40.1180-FF-000130', NULL, 'Alpha-mannosidase', 123, NULL, NULL, 205301),
(205302, '1.10.287.370-FF-000005', NULL, 'Prefoldin subunit 4', 112, NULL, NULL, 205302),
(205303, '3.80.10.10-FF-004435', NULL, 'Uncharacterized protein', 168, NULL, NULL, 205303),
(205304, '3.30.60.30-FF-000236', NULL, 'Predicted protein', 49, NULL, NULL, 205304),
(205305, '3.30.1140.32-FF-000008', NULL, 'Ribosomal protein S3', 103, NULL, NULL, 205305),
(205306, '1.25.10.10-FF-002178', NULL, 'WAPL (Wings apart-like protein regulation of heterochromatin) protein', 473, NULL, NULL, 205306),
(205307, '3.40.50.1820-FF-001579', NULL, 'Uncharacterized protein', 101, NULL, NULL, 205307);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(205308, '3.40.50.300-FF-006048', NULL, 'DNA helicase INO80', 127, NULL, NULL, 205308),
(205309, '1.25.40.540-FF-000018', NULL, 'ABR072Wp', 221, NULL, NULL, 205309),
(205310, '3.30.160.60-FF-001635', NULL, 'Zinc finger protein 317', 27, NULL, NULL, 205310),
(205311, '1.10.510.10-FF-003071', NULL, NULL, 203, NULL, NULL, 205311),
(205312, '3.20.20.70-FF-000100', NULL, 'tRNA-dihydrouridine synthase', 232, NULL, NULL, 205312),
(205313, '3.40.50.11660-FF-000056', NULL, NULL, 62, NULL, NULL, 205313),
(205314, '2.30.30.140-FF-000128', NULL, 'NAD(P)H-quinone oxidoreductase subunit S, chloroplastic', 71, NULL, NULL, 205314),
(205315, '3.90.70.10-FF-000801', NULL, 'Uncharacterized protein', 322, NULL, NULL, 205315),
(205316, '3.40.630.10-FF-000204', NULL, 'Peptide hydrolase', 35, NULL, NULL, 205316),
(205317, '3.30.465.10-FF-000013', NULL, 'Aldehyde oxidase', 123, NULL, NULL, 205317),
(205318, '3.30.70.2060-FF-000001', NULL, NULL, 62, NULL, NULL, 205318),
(205319, '3.30.230.10-FF-000272', NULL, 'Mevalonate kinase', 164, NULL, NULL, 205319),
(205320, '1.10.400.10-FF-000067', NULL, 'Guanine nucleotide binding protein, alpha subunit', 76, NULL, NULL, 205320),
(205321, '2.40.170.20-FF-000052', NULL, 'Outer membrane receptor for ferrienterochelin and colicins', 636, NULL, NULL, 205321),
(205322, '2.60.270.50-FF-000002', NULL, 'Asp-hemolysin', 135, NULL, NULL, 205322),
(205323, '3.30.450.40-FF-000151', NULL, 'IclR family transcriptional regulator', 178, NULL, NULL, 205323),
(205324, '3.80.10.10-FF-002411', NULL, 'Uncharacterized protein', 152, NULL, NULL, 205324),
(205325, '4.10.240.10-FF-000161', NULL, 'YALI0E18656p', 91, NULL, NULL, 205325),
(205326, '1.50.10.10-FF-000080', NULL, 'Protein-glucosylgalactosylhydroxylysine glucosidase', 77, NULL, NULL, 205326),
(205327, '2.130.10.10-FF-004148', NULL, 'Uncharacterized protein', 177, NULL, NULL, 205327),
(205328, '1.20.58.390-FF-000089', NULL, 'Ligand-Gated ion Channel', 117, NULL, NULL, 205328),
(205329, '1.20.1250.20-FF-000897', NULL, 'Siderochrome-iron transporter (Sit1), putative', 239, NULL, NULL, 205329),
(205330, '3.40.50.1700-FF-000065', NULL, 'Predicted protein', 35, NULL, NULL, 205330),
(205331, '3.30.40.10-FF-000807', NULL, 'General transcription and DNA repair factor IIH', 80, NULL, NULL, 205331),
(205332, '1.10.510.10-FF-003594', NULL, NULL, 207, NULL, NULL, 205332),
(205333, '1.20.1070.10-FF-000554', NULL, 'Olfactory receptor', 292, NULL, NULL, 205333),
(205334, '2.40.50.140-FF-000563', NULL, '30S ribosomal protein S1', 86, NULL, NULL, 205334),
(205335, '3.80.10.10-FF-000725', NULL, 'LRR receptor-like serine/threonine-protein kinase GSO1', 97, NULL, NULL, 205335),
(205336, '3.30.200.20-FF-001970', NULL, 'Uncharacterized protein', 103, NULL, NULL, 205336),
(205337, '1.20.1720.10-FF-000121', NULL, NULL, 317, NULL, NULL, 205337),
(205338, '1.20.140.150-FF-000127', NULL, 'Uncharacterized protein', 48, NULL, NULL, 205338),
(205339, '1.20.1740.10-FF-000078', NULL, 'Cationic amino acid transporter 9', 437, NULL, NULL, 205339),
(205340, '3.40.50.300-FF-006784', NULL, 'Uncharacterized protein', 58, NULL, NULL, 205340),
(205341, '3.90.1180.10-FF-000039', NULL, NULL, 97, NULL, NULL, 205341),
(205342, '2.40.240.10-FF-000055', NULL, 'Uncharacterized protein', 97, NULL, NULL, 205342),
(205343, '3.30.230.70-FF-000087', NULL, 'Polyribonucleotide nucleotidyltransferase 1 chloroplastic', 135, NULL, NULL, 205343),
(205344, '2.60.40.150-FF-000014', NULL, 'protein unc-13 homolog B', 147, NULL, NULL, 205344),
(205345, '3.30.160.20-FF-000117', NULL, 'Related to Ribonuclease III', 93, NULL, NULL, 205345),
(205346, '3.40.50.1970-FF-000005', NULL, 'Glycerol dehydrogenase', 159, NULL, NULL, 205346),
(205347, '4.10.1240.50-FF-000006', NULL, 'Egg-laying defective protein 27', 110, NULL, NULL, 205347),
(205348, '3.40.50.2300-FF-000436', NULL, 'Gamma-aminobutyric acid type B receptor', 203, NULL, NULL, 205348),
(205349, '1.20.1260.10-FF-000041', NULL, 'Ferritin', 181, NULL, NULL, 205349),
(205350, '3.30.70.1130-FF-000003', NULL, 'Eukaryotic translation initiation factor 2 alpha subunit, putative', 142, NULL, NULL, 205350);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(205351, '3.90.190.10-FF-000277', NULL, 'Predicted protein', 141, NULL, NULL, 205351),
(205352, '3.30.160.60-FF-003248', NULL, 'Uncharacterized protein', 30, NULL, NULL, 205352),
(205353, '3.30.420.40-FF-000374', NULL, 'Heat shock 70 kDa protein', 191, NULL, NULL, 205353),
(205354, '1.20.1560.10-FF-000934', NULL, 'ABC transporter B family member 26 chloroplastic', 13, NULL, NULL, 205354),
(205355, '1.25.40.10-FF-001393', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 178, NULL, NULL, 205355),
(205356, '2.60.40.10-FF-002203', NULL, 'Titin, tandem duplicate 1', 102, NULL, NULL, 205356),
(205357, '1.25.40.10-FF-000881', NULL, 'Pentatricopeptide repeat-containing protein', 114, NULL, NULL, 205357),
(205358, '1.20.1250.20-FF-001061', NULL, 'Bypass of stop codon protein, putative', 196, NULL, NULL, 205358),
(205359, '3.40.50.2000-FF-001009', NULL, 'Uncharacterized protein', 191, NULL, NULL, 205359),
(205360, '3.30.40.10-FF-001943', NULL, 'Uncharacterized protein', 68, NULL, NULL, 205360),
(205361, '1.20.80.10-FF-000006', NULL, 'FERM domain-containing protein 5 isoform X1', 109, NULL, NULL, 205361),
(205362, '3.30.1050.10-FF-000009', NULL, 'Sterol carrier protein-2', 105, NULL, NULL, 205362),
(205363, '2.10.25.10-FF-000736', NULL, 'C-type lectin domain family 14 member A', 33, NULL, NULL, 205363),
(205364, '3.30.40.10-FF-001887', NULL, 'Uncharacterized protein', 113, NULL, NULL, 205364),
(205365, '3.30.500.10-FF-000040', NULL, NULL, 132, NULL, NULL, 205365),
(205366, '2.130.10.10-FF-004305', NULL, 'Wd-40 repeat-containing protein', 115, NULL, NULL, 205366),
(205367, '3.80.10.10-FF-001681', NULL, 'Predicted protein', 75, NULL, NULL, 205367),
(205368, '2.10.25.10-FF-001248', NULL, 'Netrin g2a', 54, NULL, NULL, 205368),
(205369, '3.40.50.720-FF-000042', NULL, 'Trk system potassium transporter TrkA', 134, NULL, NULL, 205369),
(205370, '1.10.238.10-FF-001026', NULL, 'Uncharacterized protein', 64, NULL, NULL, 205370),
(205371, '3.30.200.20-FF-002190', NULL, 'Serine/threonine-protein kinase receptor', 55, NULL, NULL, 205371),
(205372, '1.20.1070.10-FF-000285', NULL, 'Succinate receptor 1', 303, NULL, NULL, 205372),
(205373, '1.10.8.270-FF-000196', NULL, 'Uncharacterized protein', 133, NULL, NULL, 205373),
(205374, '3.40.309.10-FF-000087', NULL, 'Uncharacterized protein', 25, NULL, NULL, 205374),
(205375, '1.25.10.10-FF-001514', NULL, 'SNF2 superfamily chromatin remodeling protein', 269, NULL, NULL, 205375),
(205376, '1.20.1560.10-FF-000878', NULL, 'TAP1', 68, NULL, NULL, 205376),
(205377, '2.40.50.100-FF-000186', NULL, 'ABC-type transport system ATP-binding protein (Probable substrate thiamine)', 78, NULL, NULL, 205377),
(205378, '1.10.287.70-FF-000584', NULL, 'Os07g0522600 protein', 47, NULL, NULL, 205378),
(205379, '2.30.42.10-FF-000371', NULL, NULL, 87, NULL, NULL, 205379),
(205380, '3.30.1120.30-FF-000050', NULL, 'Uncharacterized protein', 63, NULL, NULL, 205380),
(205381, '1.10.630.10-FF-000612', NULL, 'Ent-kaurene oxidase-like protein 1', 256, NULL, NULL, 205381),
(205382, '3.30.300.150-FF-000003', NULL, 'DNA polymerase III subunit gamma/tau', 126, NULL, NULL, 205382),
(205383, '3.40.190.10-FF-000187', NULL, '4-amino-5-hydroxymethyl-2-methylpyrimidine phosphate synthase THI5', 111, NULL, NULL, 205383),
(205384, '3.30.1600.10-FF-000030', NULL, 'Uncharacterized protein', 30, NULL, NULL, 205384),
(205385, '2.40.20.10-FF-000117', NULL, 'Uncharacterized protein', 70, NULL, NULL, 205385),
(205386, '3.30.160.60-FF-006014', NULL, NULL, 85, NULL, NULL, 205386),
(205387, '2.60.40.3440-FF-000004', NULL, 'Uncharacterized protein', 114, NULL, NULL, 205387),
(205388, '3.40.50.300-FF-005323', NULL, 'Uncharacterized protein', 156, NULL, NULL, 205388),
(205389, '3.40.1170.60-FF-000031', NULL, NULL, 52, NULL, NULL, 205389),
(205390, '3.80.10.10-FF-002193', NULL, 'Toll-like receptor 5b', 127, NULL, NULL, 205390),
(205391, '3.30.70.330-FF-001010', NULL, 'CUGBP Elav-like family member 5', 45, NULL, NULL, 205391),
(205392, '1.10.10.10-FF-001778', NULL, 'ArsR family transcriptional regulator', 56, NULL, NULL, 205392);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(205393, '1.10.4160.10-FF-000013', NULL, 'Related to purine-cytosine permease', 435, NULL, NULL, 205393),
(205394, '3.30.559.70-FF-000007', NULL, 'Carnitine O-acetyltransferase, mitochondrial', 307, NULL, NULL, 205394),
(205395, '2.40.160.10-FF-000054', NULL, 'Outer membrane porin, OprD family', 459, NULL, NULL, 205395),
(205396, '1.20.5.1160-FF-000009', NULL, 'filensin isoform X2', 113, NULL, NULL, 205396),
(205397, '3.50.50.60-FF-000176', NULL, 'Pyridine nucleotide-disulfide oxidoreductase domain-containing protein 1', 102, NULL, NULL, 205397),
(205398, '2.60.40.1730-FF-000036', NULL, 'Leucyl aminopeptidase', 175, NULL, NULL, 205398),
(205399, '1.20.120.1240-FF-000070', NULL, 'Uncharacterized protein', 192, NULL, NULL, 205399),
(205400, '3.20.20.380-FF-000011', NULL, 'Predicted protein', 130, NULL, NULL, 205400),
(205401, '3.40.50.300-FF-003018', NULL, 'GTP-binding protein, putative', 177, NULL, NULL, 205401),
(205402, '3.40.50.720-FF-000946', NULL, 'D-3-phosphoglycerate dehydrogenase', 111, NULL, NULL, 205402),
(205403, '1.25.40.420-FF-000044', NULL, 'Ubiquitin-protein ligase', 122, NULL, NULL, 205403),
(205404, '3.30.420.40-FF-000267', NULL, 'Glycerol kinase', 247, NULL, NULL, 205404),
(205405, '3.10.580.10-FF-000190', NULL, 'Cysteine synthase, putative', 54, NULL, NULL, 205405),
(205406, '2.60.120.10-FF-000390', NULL, 'Putative transcriptional regulator, Crp/Fnr family', 194, NULL, NULL, 205406),
(205407, '2.60.120.970-FF-000033', NULL, 'Transforming growth factor beta', 252, NULL, NULL, 205407),
(205408, '3.30.870.10-FF-000191', NULL, 'Uncharacterized protein', 94, NULL, NULL, 205408),
(205409, '3.90.780.10-FF-000018', NULL, 'SA0881 protein', 188, NULL, NULL, 205409),
(205410, '3.40.630.150-FF-000007', NULL, 'Malonyl-CoA decarboxylase, mitochondrial', 294, NULL, NULL, 205410),
(205411, '3.30.160.20-FF-000162', NULL, 'Double-stranded RNA-binding protein Staufen homolog 2', 69, NULL, NULL, 205411),
(205412, '2.130.10.10-FF-001551', NULL, 'Elongator acetyltransferase complex subunit 2', 88, NULL, NULL, 205412),
(205413, '3.30.420.40-FF-000323', NULL, 'Actin-like protein, putative', 89, NULL, NULL, 205413),
(205414, '1.10.10.10-FF-001093', NULL, 'Heat shock transcription factor, putative', 100, NULL, NULL, 205414),
(205415, '3.30.70.1230-FF-000207', NULL, 'Predicted protein', 159, NULL, NULL, 205415),
(205416, '3.10.180.10-FF-000086', NULL, '4-hydroxyphenylpyruvate dioxygenase', 169, NULL, NULL, 205416),
(205417, '3.20.10.10-FF-000003', NULL, 'Branched-chain-amino-acid aminotransferase', 173, NULL, NULL, 205417),
(205418, '3.40.30.10-FF-000672', NULL, 'Insulin-degrading enzyme-like Protein', 119, NULL, NULL, 205418),
(205419, '3.40.50.1000-FF-000029', NULL, '3-deoxy-D-manno-octulosonate 8-phosphate phosphatase KdsC', 176, NULL, NULL, 205419),
(205420, '1.10.437.10-FF-000045', NULL, 'Uncharacterized protein', 145, NULL, NULL, 205420),
(205421, '1.20.1280.50-FF-000149', NULL, 'GM17963', 81, NULL, NULL, 205421),
(205422, '1.20.58.70-FF-000118', NULL, 'Uncharacterized protein', 117, NULL, NULL, 205422),
(205423, '1.10.510.10-FF-002531', NULL, 'Protein kinase, putative', 317, NULL, NULL, 205423),
(205424, '1.10.3380.20-FF-000004', NULL, 'DNA polymerase theta (Helicase domain only), putative', 185, NULL, NULL, 205424),
(205425, '2.30.29.30-FF-000385', NULL, 'insulin receptor substrate 1-like', 100, NULL, NULL, 205425),
(205426, '1.10.287.70-FF-000640', NULL, 'Potassium two pore domain channel subfamily K member 6', 185, NULL, NULL, 205426),
(205427, '1.10.510.10-FF-003094', NULL, NULL, 198, NULL, NULL, 205427),
(205428, '3.40.1110.10-FF-000052', NULL, 'Copper-translocating P-type ATPase', 124, NULL, NULL, 205428),
(205429, '1.10.287.110-FF-000006', NULL, 'Import inner membrane translocase subunit TIM16', 62, NULL, NULL, 205429),
(205430, '3.40.50.20-FF-000092', NULL, 'D-alanine--D-alanine ligase', 82, NULL, NULL, 205430),
(205431, '2.70.98.90-FF-000010', NULL, 'Membrane protein insertase YidC', 261, NULL, NULL, 205431),
(205432, '3.40.50.1820-FF-000270', NULL, 'Alpha/beta-Hydrolases superfamily protein', 306, NULL, NULL, 205432);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(205433, '3.90.190.10-FF-000226', NULL, 'Riok-3', 286, NULL, NULL, 205433),
(205434, '3.20.20.70-FF-000095', NULL, 'Lysine 2,3-aminomutase', 285, NULL, NULL, 205434),
(205435, '3.40.50.1010-FF-000246', NULL, NULL, 186, NULL, NULL, 205435),
(205436, '3.40.50.2000-FF-001072', NULL, 'Uncharacterized protein', 61, NULL, NULL, 205436),
(205437, '3.40.190.10-FF-000979', NULL, 'ADL180Cp', 99, NULL, NULL, 205437),
(205438, '1.10.220.30-FF-000008', NULL, 'Flagellar motor switch protein FliG', 104, NULL, NULL, 205438),
(205439, '2.130.10.10-FF-002855', NULL, 'Uncharacterized protein', 342, NULL, NULL, 205439),
(205440, '2.130.10.10-FF-000938', NULL, 'Probable periodic tryptophan protein PWP2', 202, NULL, NULL, 205440),
(205441, '3.40.50.360-FF-000142', NULL, 'Oxygen-independent protoporphyrinogen oxidase HemG', 170, NULL, NULL, 205441),
(205442, '1.10.510.10-FF-000165', NULL, 'Tyrosine-protein kinase RYK', 191, NULL, NULL, 205442),
(205443, '2.60.120.290-FF-000020', NULL, 'Neuropilin and tolloid-like protein 2 isoform 1', 122, NULL, NULL, 205443),
(205444, '3.40.390.10-FF-000224', NULL, NULL, 139, NULL, NULL, 205444),
(205445, '3.90.1750.10-FF-000004', NULL, 'E3 ubiquitin-protein ligase HECW2 isoform X1', 195, NULL, NULL, 205445),
(205446, '3.30.200.20-FF-002015', NULL, 'Uncharacterized protein', 93, NULL, NULL, 205446),
(205447, '1.10.1030.10-FF-000003', NULL, 'Carbamoyl-phosphate synthase, large subunit', 161, NULL, NULL, 205447),
(205448, '3.30.160.60-FF-005665', NULL, NULL, 76, NULL, NULL, 205448),
(205449, '2.130.10.10-FF-005609', NULL, 'Uncharacterized protein', 188, NULL, NULL, 205449),
(205450, '2.170.300.10-FF-000029', NULL, 'Platelet endothelial aggregation receptor 1', 124, NULL, NULL, 205450),
(205451, '3.40.1280.10-FF-000103', NULL, 'Predicted protein', 157, NULL, NULL, 205451),
(205452, '1.25.40.10-FF-000729', NULL, 'Pentatricopeptide repeat-containing protein At4g25270, chloroplastic', 145, NULL, NULL, 205452),
(205453, '1.20.1250.20-FF-001965', NULL, 'Uncharacterized transporter C460.05', 413, NULL, NULL, 205453),
(205454, '3.30.420.110-FF-000001', NULL, 'DNA mismatch repair protein MutS', 136, NULL, NULL, 205454),
(205455, '2.10.60.10-FF-000082', NULL, 'Serine/threonine-protein kinase receptor', 92, NULL, NULL, 205455),
(205456, '2.60.40.10-FF-005165', NULL, NULL, 118, NULL, NULL, 205456),
(205457, '3.40.50.10190-FF-000368', NULL, 'Uncharacterized protein', 101, NULL, NULL, 205457),
(205458, '3.10.430.100-FF-000016', NULL, '50S ribosomal protein L9', 87, NULL, NULL, 205458),
(205459, '1.10.260.100-FF-000029', NULL, 'Uncharacterized protein', 70, NULL, NULL, 205459),
(205460, '3.20.20.190-FF-000016', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', 176, NULL, NULL, 205460),
(205461, '3.40.50.10810-FF-000043', NULL, 'Transcription termination factor 2', 270, NULL, NULL, 205461),
(205462, '2.60.120.820-FF-000016', NULL, 'Predicted protein', 98, NULL, NULL, 205462),
(205463, '3.60.15.10-FF-000198', NULL, 'Predicted protein', 105, NULL, NULL, 205463),
(205464, '1.10.132.20-FF-000019', NULL, 'Predicted protein', 95, NULL, NULL, 205464),
(205465, '3.30.70.330-FF-002319', NULL, NULL, 170, NULL, NULL, 205465),
(205466, '3.30.450.40-FF-000095', NULL, 'Transcriptional regulator, IclR family', 176, NULL, NULL, 205466),
(205467, '1.25.40.20-FF-001671', NULL, 'Inhibitor of Bruton tyrosine kinase', 82, NULL, NULL, 205467),
(205468, '3.40.50.300-FF-001905', NULL, 'p-loop containing nucleoside triphosphate hydrolase, putative', 276, NULL, NULL, 205468),
(205469, '3.30.70.980-FF-000070', NULL, 'Probable transcriptional regulatory protein C8D2.12c', 87, NULL, NULL, 205469),
(205470, '2.70.50.40-FF-000014', NULL, 'Uncharacterized protein', 113, NULL, NULL, 205470),
(205471, '3.30.200.20-FF-001526', NULL, NULL, 95, NULL, NULL, 205471),
(205472, '2.130.10.10-FF-001506', NULL, 'Vacuolar assembly protein, putative', 168, NULL, NULL, 205472),
(205473, '3.30.1490.20-FF-000091', NULL, 'Ribosomal protein S6 modification protein', 75, NULL, NULL, 205473),
(205474, '1.20.142.10-FF-000026', NULL, 'Poly [ADP-ribose] polymerase', 90, NULL, NULL, 205474);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(205475, '3.30.160.60-FF-001394', NULL, 'Zinc finger protein 189', 29, NULL, NULL, 205475),
(205476, '3.10.660.10-FF-000016', NULL, 'DPH3 homolog', 38, NULL, NULL, 205476),
(205477, '2.130.10.10-FF-002911', NULL, 'Uncharacterized protein', 348, NULL, NULL, 205477),
(205478, '3.10.20.30-FF-000072', NULL, NULL, 111, NULL, NULL, 205478),
(205479, '3.90.550.10-FF-000361', NULL, 'Glycosyltransferases', 121, NULL, NULL, 205479),
(205480, '2.60.120.10-FF-000238', NULL, 'Cysteine dioxygenase', 161, NULL, NULL, 205480),
(205481, '3.40.50.620-FF-000742', NULL, 'Uncharacterized protein', 153, NULL, NULL, 205481),
(205482, '1.10.274.100-FF-000016', NULL, 'DNA-directed RNA polymerase subunit', 116, NULL, NULL, 205482),
(205483, '2.60.40.10-FF-001798', NULL, 'Hibris, isoform B', 107, NULL, NULL, 205483),
(205484, '3.30.930.10-FF-000241', NULL, 'Bifunctional ligase/repressor BirA', 208, NULL, NULL, 205484),
(205485, '1.10.510.10-FF-003835', NULL, NULL, 108, NULL, NULL, 205485),
(205486, '1.25.10.10-FF-002818', NULL, 'Predicted protein', 194, NULL, NULL, 205486),
(205487, '1.20.1540.10-FF-000079', NULL, 'Rhomboid family intramembrane serine protease', 192, NULL, NULL, 205487),
(205488, '1.20.1560.10-FF-000086', NULL, 'ABC multidrug transporter Mdr1', 604, NULL, NULL, 205488),
(205489, '3.40.50.300-FF-000596', NULL, 'ATP-dependent DNA helicase', 200, NULL, NULL, 205489),
(205490, '1.20.5.740-FF-000003', NULL, 'Colicin', 27, NULL, NULL, 205490),
(205491, '3.40.50.1820-FF-000955', NULL, 'Hydrolase, alpha/beta fold family, putative', 290, NULL, NULL, 205491),
(205492, '1.10.630.10-FF-000556', NULL, 'Uncharacterized protein', 334, NULL, NULL, 205492),
(205493, '1.10.287.470-FF-000024', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 74, NULL, NULL, 205493),
(205494, '3.30.70.330-FF-000572', NULL, 'U1 small nuclear ribonucleoprotein A', 92, NULL, NULL, 205494),
(205495, '3.30.160.60-FF-005614', NULL, NULL, 98, NULL, NULL, 205495),
(205496, '1.10.150.120-FF-000010', NULL, 'Oxidoreductase, iron-sulfur binding subunit', 94, NULL, NULL, 205496),
(205497, '3.40.50.300-FF-001220', NULL, 'ABC transporter ATP-binding subunit', 227, NULL, NULL, 205497),
(205498, '3.40.50.970-FF-000212', NULL, 'Pyruvate dehydrogenase E1 alpha 1 subunit b', 139, NULL, NULL, 205498),
(205499, '3.30.565.10-FF-000184', NULL, 'Heat shock protein 90, putative', 227, NULL, NULL, 205499),
(205500, '3.50.50.100-FF-000039', NULL, 'Sulfide:quinone oxidoreductase, mitochondrial', 396, NULL, NULL, 205500),
(205501, '3.40.50.1440-FF-000133', NULL, 'Uncharacterized protein', 140, NULL, NULL, 205501),
(205502, '3.55.50.30-FF-000005', NULL, 'Fec operon regulator FecR', 75, NULL, NULL, 205502),
(205503, '1.10.287.410-FF-000001', NULL, 'Carboxypeptidase Y', 72, NULL, NULL, 205503),
(205504, '2.30.29.30-FF-000441', NULL, 'Insulin receptor substrate 1', 105, NULL, NULL, 205504),
(205505, '3.30.210.10-FF-000006', NULL, 'DNA polymerase', 69, NULL, NULL, 205505),
(205506, '1.10.230.10-FF-000008', NULL, 'Citrate synthase', 119, NULL, NULL, 205506),
(205507, '2.130.10.10-FF-000197', NULL, 'Coronin', 358, NULL, NULL, 205507),
(205508, '3.30.1490.180-FF-000040', NULL, 'DNA-directed RNA polymerase subunit', 61, NULL, NULL, 205508),
(205509, '1.20.1070.10-FF-000234', NULL, 'adhesion G-protein coupled receptor G4', 283, NULL, NULL, 205509),
(205510, '3.30.40.10-FF-000690', NULL, 'Mind bomb', 63, NULL, NULL, 205510),
(205511, '1.10.1200.120-FF-000004', NULL, 'Ion channel, putative', 113, NULL, NULL, 205511),
(205512, '1.25.10.10-FF-001458', NULL, 'Receptor Mediated Endocytosis', 193, NULL, NULL, 205512),
(205513, '3.30.720.90-FF-000001', NULL, '60S ribosomal protein L38', 70, NULL, NULL, 205513),
(205514, '3.40.50.150-FF-000989', NULL, NULL, 213, NULL, NULL, 205514),
(205515, '3.40.50.2000-FF-000560', NULL, 'Trehalose-6-phosphate synthetase', 222, NULL, NULL, 205515),
(205516, '1.20.120.980-FF-000046', NULL, 'Protein CBG23655', 14, NULL, NULL, 205516),
(205517, '2.60.200.20-FF-000236', NULL, 'Uncharacterized protein', 133, NULL, NULL, 205517),
(205518, '3.40.309.10-FF-000036', NULL, 'Methylmalonate-semialdehyde dehydrogenase (Acylating)', 196, NULL, NULL, 205518);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(205519, '1.20.120.1240-FF-000007', NULL, 'Interferon-induced GTP-binding protein Mx1', 264, NULL, NULL, 205519),
(205520, '3.30.420.580-FF-000001', NULL, 'Actin-related protein 8', 106, NULL, NULL, 205520),
(205521, '1.10.238.10-FF-001077', NULL, 'Uncharacterized protein', 119, NULL, NULL, 205521),
(205522, '3.30.70.560-FF-000005', NULL, 'Folic acid synthesis protein fol1', 169, NULL, NULL, 205522),
(205523, '3.40.50.300-FF-001956', NULL, 'Dynein cytoplasmic 1 heavy chain 1', 166, NULL, NULL, 205523),
(205524, '1.25.40.20-FF-000210', NULL, 'Ankyrin repeat and FYVE domain containing 1', 82, NULL, NULL, 205524),
(205525, '3.30.1490.20-FF-000040', NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta mitochondrial', 85, NULL, NULL, 205525),
(205526, '3.15.10.30-FF-000004', NULL, 'AGAP013061-PA-like protein', 220, NULL, NULL, 205526),
(205527, '3.30.160.60-FF-001343', NULL, 'Zinc finger protein 568', 29, NULL, NULL, 205527),
(205528, '3.20.20.80-FF-000480', NULL, 'Uncharacterized protein', 207, NULL, NULL, 205528),
(205529, '3.80.10.10-FF-003131', NULL, 'Si:dkey-230i18.2', 76, NULL, NULL, 205529),
(205530, '1.25.10.10-FF-000997', NULL, 'Cell fusion protein fus1', 244, NULL, NULL, 205530),
(205531, '1.10.8.60-FF-000443', NULL, 'Replication factor C, subunit 1', 64, NULL, NULL, 205531),
(205532, '3.60.15.10-FF-000147', NULL, 'Metallo-beta-lactamase type 2', 227, NULL, NULL, 205532),
(205533, '3.40.50.300-FF-004867', NULL, 'NLR family member X1', 220, NULL, NULL, 205533),
(205534, '3.40.50.10810-FF-000094', NULL, 'DNA excision repair protein ERCC-6', 148, NULL, NULL, 205534),
(205535, '1.20.1050.10-FF-000227', NULL, 'Glutathione S-transferase Gst', 100, NULL, NULL, 205535),
(205536, '3.40.50.1460-FF-000139', NULL, 'Uncharacterized protein', 194, NULL, NULL, 205536),
(205537, '1.10.287.130-FF-000220', NULL, 'Sensor histidine kinase', 79, NULL, NULL, 205537),
(205538, '2.60.40.10-FF-001742', NULL, 'filamin-A isoform X7', 103, NULL, NULL, 205538),
(205539, '2.30.42.10-FF-000308', NULL, 'Rap guanine nucleotide exchange factor', 101, NULL, NULL, 205539),
(205540, '3.40.50.300-FF-005267', NULL, 'Cytidylate kinase', 183, NULL, NULL, 205540),
(205541, '3.50.50.60-FF-001076', NULL, 'Uncharacterized protein', 80, NULL, NULL, 205541),
(205542, '3.30.40.10-FF-001090', NULL, 'Histone-lysine N-methyltransferase ATXR6', 86, NULL, NULL, 205542),
(205543, '1.10.10.10-FF-001834', NULL, 'Cyclic GMP-binding protein C', 94, NULL, NULL, 205543),
(205544, '2.130.10.10-FF-005761', NULL, 'Uncharacterized protein', 113, NULL, NULL, 205544),
(205545, '2.60.40.10-FF-001747', NULL, 'Interference hedgehog', 94, NULL, NULL, 205545),
(205546, '1.20.1640.10-FF-000087', NULL, 'Bifunctional preprotein translocase subunit SecD/SecF', 200, NULL, NULL, 205546),
(205547, '1.10.287.70-FF-000039', NULL, 'ATP-sensitive inward rectifier potassium channel 12', 132, NULL, NULL, 205547),
(205548, '3.90.79.10-FF-000113', NULL, 'NUDIX hydrolase family protein', 173, NULL, NULL, 205548),
(205549, '3.80.10.10-FF-000225', NULL, 'volume-regulated anion channel subunit LRRC8B', 87, NULL, NULL, 205549),
(205550, '2.130.10.10-FF-000202', NULL, 'TAF5-like RNA polymerase II p300/CBP-associated factor-associated factor 65 kDa subunit 5L', 80, NULL, NULL, 205550),
(205551, '3.40.50.300-FF-007240', NULL, 'RE04047p', 160, NULL, NULL, 205551),
(205552, '3.30.559.10-FF-000017', NULL, 'Nonribosomal peptide synthase Pes1', 184, NULL, NULL, 205552),
(205553, '2.30.30.40-FF-000419', NULL, 'Chemotaxis protein CheV', 56, NULL, NULL, 205553),
(205554, '3.40.50.150-FF-001478', NULL, NULL, 128, NULL, NULL, 205554),
(205555, '3.80.10.10-FF-000169', NULL, 'TLR4 interactor with leucine rich repeats', 188, NULL, NULL, 205555),
(205556, '1.25.40.10-FF-001281', NULL, 'G-protein-signaling modulator 2', 99, NULL, NULL, 205556),
(205557, '1.10.238.10-FF-000588', NULL, 'Uncharacterized protein', 169, NULL, NULL, 205557),
(205558, '1.10.720.30-FF-000041', NULL, 'Uncharacterized protein', 41, NULL, NULL, 205558),
(205559, '3.30.750.24-FF-000015', NULL, 'Sulfate transporter', 176, NULL, NULL, 205559);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(205560, '1.10.1410.10-FF-000044', NULL, 'RNA polymerase I', 176, NULL, NULL, 205560),
(205561, '3.40.630.150-FF-000002', NULL, 'malonyl-CoA decarboxylase, mitochondrial', 311, NULL, NULL, 205561),
(205562, '1.10.510.10-FF-001177', NULL, 'eukaryotic translation initiation factor 2-alpha kinase 1-like', 190, NULL, NULL, 205562),
(205563, '1.20.1250.20-FF-000661', NULL, 'Synaptic vesicle glycoprotein 2C', 226, NULL, NULL, 205563),
(205564, '3.90.79.10-FF-000057', NULL, 'MutT/NUDIX family protein phosphohydrolase', 138, NULL, NULL, 205564),
(205565, '2.10.50.10-FF-000137', NULL, 'CD40 molecule, TNF receptor superfamily member 5', 80, NULL, NULL, 205565),
(205566, '3.30.160.60-FF-000090', NULL, 'Odd-skipped-related transciption factor 2', 30, NULL, NULL, 205566),
(205567, '3.30.70.120-FF-000008', NULL, 'Protein CutA 1, chloroplastic', 113, NULL, NULL, 205567),
(205568, '3.30.40.10-FF-002376', NULL, 'Tnf receptor associated factor, putative', 51, NULL, NULL, 205568),
(205569, '3.30.200.20-FF-000273', NULL, 'Casein kinase II alpha subunit', 77, NULL, NULL, 205569),
(205570, '1.20.1080.10-FF-000004', NULL, 'Glycerol facilitator', 259, NULL, NULL, 205570),
(205571, '1.10.3210.10-FF-000063', NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase-like protein', 229, NULL, NULL, 205571),
(205572, '3.20.20.10-FF-000009', NULL, 'Diaminopimelate decarboxylase', 247, NULL, NULL, 205572),
(205573, '2.40.100.10-FF-000106', NULL, 'Peptidyl-prolyl cis-trans isomerase', 128, NULL, NULL, 205573),
(205574, '3.40.1190.20-FF-000009', NULL, 'Pyridoxine/pyridoxal/pyridoxamine kinase', 283, NULL, NULL, 205574),
(205575, '2.60.120.200-FF-000117', NULL, 'Terribly reduced optic lobes, isoform AL', 182, NULL, NULL, 205575),
(205576, '1.10.510.10-FF-000906', NULL, 'Spectrin, beta, non-erythrocytic 1', 197, NULL, NULL, 205576),
(205577, '3.30.200.20-FF-000621', NULL, 'Putative L-type lectin-domain containing receptor kinase VII.2', 115, NULL, NULL, 205577),
(205578, '3.10.129.10-FF-000181', NULL, 'Acyl-CoA thioesterase', 130, NULL, NULL, 205578),
(205579, '1.10.10.60-FF-000186', NULL, 'Transcriptional regulator, TetR family', 62, NULL, NULL, 205579),
(205580, '2.130.10.10-FF-001490', NULL, 'Protein HIRA', 139, NULL, NULL, 205580),
(205581, '3.30.1330.30-FF-000116', NULL, 'Protein CBG18354', 85, NULL, NULL, 205581),
(205582, '1.10.260.50-FF-000005', NULL, NULL, 44, NULL, NULL, 205582),
(205583, '1.10.220.150-FF-000075', NULL, 'Uncharacterized protein', 82, NULL, NULL, 205583),
(205584, '3.30.56.10-FF-000035', NULL, 'Phenylalanine--tRNA ligase beta subunit', 63, NULL, NULL, 205584),
(205585, '2.20.100.10-FF-000083', NULL, 'ADAMTS like 3', 59, NULL, NULL, 205585),
(205586, '3.40.30.10-FF-001009', NULL, 'Uncharacterized protein', 62, NULL, NULL, 205586),
(205587, '3.60.130.10-FF-000021', NULL, 'Pyoverdine biosynthesis protein PvcB', 279, NULL, NULL, 205587),
(205588, '1.10.1670.10-FF-000074', NULL, NULL, 56, NULL, NULL, 205588),
(205589, '2.60.40.60-FF-000043', NULL, 'Protocadherin 1', 101, NULL, NULL, 205589),
(205590, '3.20.20.190-FF-000067', NULL, 'Glycerophosphoryl diester phosphodiesterase family, putative', 263, NULL, NULL, 205590),
(205591, '3.30.342.10-FF-000048', NULL, 'DNA polymerase', 145, NULL, NULL, 205591),
(205592, '3.30.2140.20-FF-000014', NULL, 'Arylamine N-acetyltransferase 3', 289, NULL, NULL, 205592),
(205593, '3.50.50.60-FF-000120', NULL, 'Putative oxidoreductase FixC', 392, NULL, NULL, 205593),
(205594, '2.60.120.620-FF-000052', NULL, 'Prolyl 4-hydroxylase alpha subunit, putative', 196, NULL, NULL, 205594),
(205595, '3.40.50.10130-FF-000030', NULL, 'Uncharacterized protein', 109, NULL, NULL, 205595),
(205596, '3.20.20.105-FF-000012', NULL, 'Queuine tRNA-ribosyltransferase', 374, NULL, NULL, 205596),
(205597, '3.10.580.10-FF-000015', NULL, 'DUF21 domain-containing protein', 136, NULL, NULL, 205597),
(205598, '1.20.120.720-FF-000047', NULL, 'Chitin synthase-domain-containing protein', 158, NULL, NULL, 205598),
(205599, '3.30.750.24-FF-000066', NULL, 'Solute carrier family 26, member 10', 142, NULL, NULL, 205599);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(205600, '1.10.8.50-FF-000002', NULL, '40S ribosomal protein S18', 80, NULL, NULL, 205600),
(205601, '1.10.533.10-FF-000257', NULL, 'Uncharacterized protein', 92, NULL, NULL, 205601),
(205602, '3.30.160.60-FF-000382', NULL, 'zinc finger protein 35 isoform X4', 27, NULL, NULL, 205602),
(205603, '1.10.287.130-FF-000164', NULL, 'Signal transduction histidine kinase', 114, NULL, NULL, 205603),
(205604, '3.80.10.10-FF-002018', NULL, 'Uncharacterized protein', 281, NULL, NULL, 205604),
(205605, '1.20.58.60-FF-000733', NULL, 'Uncharacterized protein', 267, NULL, NULL, 205605),
(205606, '3.80.10.10-FF-000276', NULL, 'F-box/LRR-repeat protein 3', 240, NULL, NULL, 205606),
(205607, '3.30.420.10-FF-000724', NULL, NULL, 71, NULL, NULL, 205607),
(205608, '1.10.10.60-FF-000927', NULL, NULL, 81, NULL, NULL, 205608),
(205609, '1.25.10.10-FF-000109', NULL, 'Diaphanous homolog 1 (Drosophila)', 238, NULL, NULL, 205609),
(205610, '1.20.1080.10-FF-000055', NULL, 'Related to channel protein', 269, NULL, NULL, 205610),
(205611, '2.60.40.10-FF-000786', NULL, 'hepatocyte cell adhesion molecule isoform X2', 115, NULL, NULL, 205611),
(205612, '1.20.58.740-FF-000003', NULL, 'dedicator of cytokinesis protein 4', 126, NULL, NULL, 205612),
(205613, '3.30.300.30-FF-000042', NULL, 'Fatty-acid-CoA ligase FadD22', 110, NULL, NULL, 205613),
(205614, '3.10.100.10-FF-000098', NULL, 'protein bark beetle', 106, NULL, NULL, 205614),
(205615, '3.90.70.10-FF-000857', NULL, 'Predicted protein', 100, NULL, NULL, 205615),
(205616, '3.40.50.300-FF-008201', NULL, 'Uncharacterized protein', 74, NULL, NULL, 205616),
(205617, '1.25.10.10-FF-002970', NULL, 'Uncharacterized protein', 411, NULL, NULL, 205617),
(205618, '1.20.5.190-FF-000029', NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', 50, NULL, NULL, 205618),
(205619, '2.60.40.1200-FF-000001', NULL, 'RTX toxin', 79, NULL, NULL, 205619),
(205620, '1.20.1080.10-FF-000111', NULL, 'Zgc:92747', 140, NULL, NULL, 205620),
(205621, '1.10.340.30-FF-000051', NULL, 'Methyl-CpG-binding domain protein 4', 157, NULL, NULL, 205621),
(205622, '3.40.50.150-FF-001427', NULL, NULL, 153, NULL, NULL, 205622),
(205623, '1.20.120.550-FF-000030', NULL, 'Microsomal glutathione S-transferase 2', 76, NULL, NULL, 205623),
(205624, '1.10.510.10-FF-000614', NULL, 'Serine/threonine protein kinase, putative', 230, NULL, NULL, 205624),
(205625, '2.40.50.140-FF-000799', NULL, NULL, 129, NULL, NULL, 205625),
(205626, '1.20.58.60-FF-000677', NULL, 'Nesprin-1', 297, NULL, NULL, 205626),
(205627, '3.20.20.80-FF-000485', NULL, 'Alpha-glucosidase', 147, NULL, NULL, 205627),
(205628, '3.30.9.10-FF-000073', NULL, 'FAD-dependent oxidoreductase', 150, NULL, NULL, 205628),
(205629, '3.30.160.60-FF-002759', NULL, 'Zinc finger protein 568', 22, NULL, NULL, 205629),
(205630, '1.20.5.170-FF-000074', NULL, 'Spindle assembly checkpoint component', 39, NULL, NULL, 205630),
(205631, '2.170.16.10-FF-000040', NULL, 'DNA polymerase III subunit', 142, NULL, NULL, 205631),
(205632, '3.30.230.70-FF-000031', NULL, 'Exosome complex exonuclease RRP41, putative', 239, NULL, NULL, 205632),
(205633, '1.20.1560.10-FF-000081', NULL, 'Protein CBG24505', 326, NULL, NULL, 205633),
(205634, '3.10.129.10-FF-000029', NULL, 'Acyl-CoA thioesterase 12', 147, NULL, NULL, 205634),
(205635, '1.25.40.20-FF-000614', NULL, 'Ankyrin-like protein', 143, NULL, NULL, 205635),
(205636, '3.30.465.10-FF-000125', NULL, 'Uncharacterized protein', 49, NULL, NULL, 205636),
(205637, '3.40.50.12280-FF-000006', NULL, 'NADH-ubiquinone oxidoreductase 20 kDa subunit,mitochondrial', 165, NULL, NULL, 205637),
(205638, '3.20.20.70-FF-000600', NULL, NULL, 207, NULL, NULL, 205638),
(205639, '3.30.70.890-FF-000043', NULL, 'GHMP kinase', 131, NULL, NULL, 205639),
(205640, '1.50.10.10-FF-000192', NULL, 'Uncharacterized protein', 267, NULL, NULL, 205640),
(205641, '3.90.1580.10-FF-000019', NULL, 'Uncharacterized protein', 292, NULL, NULL, 205641),
(205642, '3.10.20.870-FF-000003', NULL, 'Polyubiquitin binding (Doa1 Ufd3) protein', 82, NULL, NULL, 205642),
(205643, '1.10.8.60-FF-000331', NULL, 'Spermatogenesis associated 5-like 1', 78, NULL, NULL, 205643);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(205644, '3.40.309.10-FF-000031', NULL, 'Phenylacetic acid degradation protein MaoC', 206, NULL, NULL, 205644),
(205645, '3.30.200.20-FF-000565', NULL, 'LRR receptor-like serine/threonine-protein kinase RCH1', 98, NULL, NULL, 205645),
(205646, '1.20.58.60-FF-000385', NULL, 'Spectrin beta chain', 105, NULL, NULL, 205646),
(205647, '3.30.420.340-FF-000008', NULL, 'UvrABC system protein C', 166, NULL, NULL, 205647),
(205648, '4.10.400.10-FF-000044', NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein', 41, NULL, NULL, 205648),
(205649, '1.25.40.20-FF-001519', NULL, 'Predicted protein', 84, NULL, NULL, 205649),
(205650, '1.10.530.10-FF-000048', NULL, 'N-acetylmuramoyl-L-alanine amidase', 169, NULL, NULL, 205650),
(205651, '3.40.1190.20-FF-000161', NULL, 'ADP-dependent (S)-NAD(P)H-hydrate dehydratase', 283, NULL, NULL, 205651),
(205652, '3.90.1530.10-FF-000016', NULL, 'Sulfiredoxin', 82, NULL, NULL, 205652),
(205653, '2.60.40.60-FF-000947', NULL, 'Uncharacterized protein', 116, NULL, NULL, 205653),
(205654, '2.20.25.10-FF-000039', NULL, 'DNA-directed RNA polymerase subunit', 65, NULL, NULL, 205654),
(205655, '3.90.640.10-FF-000244', NULL, 'Actin-related protein 4', 113, NULL, NULL, 205655),
(205656, '3.90.660.10-FF-000127', NULL, NULL, 77, NULL, NULL, 205656),
(205657, '3.40.390.10-FF-000168', NULL, 'Metalloendopeptidase', 248, NULL, NULL, 205657),
(205658, '1.10.600.10-FF-000048', NULL, 'Probable polyprenyl-diphosphate synthase GrcC1 (Polyprenyl pyrophosphate synthetase)', 323, NULL, NULL, 205658),
(205659, '1.25.40.20-FF-000558', NULL, 'Ankyrin repeat-containing protein', 134, NULL, NULL, 205659),
(205660, '1.50.10.10-FF-000141', NULL, 'Non-lysosomal glucosylceramidase', 310, NULL, NULL, 205660),
(205661, '3.40.50.300-FF-007796', NULL, 'Ras like without CAAX 2', 45, NULL, NULL, 205661),
(205662, '4.10.280.10-FF-000051', NULL, 'Basic helix-loop-helix domain-containing protein KIAA2018', 75, NULL, NULL, 205662),
(205663, '3.80.10.10-FF-003479', NULL, 'Uncharacterized protein', 207, NULL, NULL, 205663),
(205664, '3.50.50.60-FF-000912', NULL, 'FAD-dependent oxidoreductase (Homolog to geranylgeranyl reductase)', 449, NULL, NULL, 205664),
(205665, '3.40.190.10-FF-000743', NULL, 'Glutamate receptor 3.3', 155, NULL, NULL, 205665),
(205666, '3.30.70.920-FF-000035', NULL, 'Transcriptional regulator', 92, NULL, NULL, 205666),
(205667, '1.25.10.10-FF-001453', NULL, 'Uncharacterized protein', 243, NULL, NULL, 205667),
(205668, '1.10.510.10-FF-000221', NULL, 'ribosomal protein S6 kinase delta-1 isoform X1', 168, NULL, NULL, 205668),
(205669, '1.10.357.10-FF-000044', NULL, 'TetR family transcriptional regulator', 114, NULL, NULL, 205669),
(205670, '1.10.565.10-FF-000196', NULL, 'Uncharacterized protein', 84, NULL, NULL, 205670),
(205671, '3.40.50.10810-FF-000099', NULL, 'Rad5p', 266, NULL, NULL, 205671),
(205672, '3.40.50.1820-FF-000163', NULL, 'Carboxypeptidase', 413, NULL, NULL, 205672),
(205673, '3.30.160.60-FF-006121', NULL, NULL, 37, NULL, NULL, 205673),
(205674, '1.20.5.170-FF-000023', NULL, 'ADP-ribosylation factor-binding protein GGA3 isoform X1', 43, NULL, NULL, 205674),
(205675, '2.60.40.1670-FF-000001', NULL, 'Protein transport protein SEC23', 157, NULL, NULL, 205675),
(205676, '3.50.50.60-FF-001132', NULL, 'FAD-dependent oxidoreductase domain containing 2', 117, NULL, NULL, 205676),
(205677, '1.10.287.380-FF-000042', NULL, 'Predicted protein', 48, NULL, NULL, 205677),
(205678, '3.40.50.2300-FF-001504', NULL, NULL, 107, NULL, NULL, 205678),
(205679, '1.20.1070.10-FF-002027', NULL, 'Uncharacterized protein', 122, NULL, NULL, 205679),
(205680, '3.40.50.620-FF-000635', NULL, 'Tyrosine--tRNA ligase', 213, NULL, NULL, 205680),
(205681, '3.50.50.60-FF-000732', NULL, 'FAD-dependent pyridine nucleotide-disulphide oxidoreductase', 94, NULL, NULL, 205681),
(205682, '2.20.70.10-FF-000166', NULL, 'WW domain containing protein, putative', 38, NULL, NULL, 205682),
(205683, '3.40.50.1100-FF-000273', NULL, 'Uncharacterized protein', 160, NULL, NULL, 205683),
(205684, '1.25.10.10-FF-003038', NULL, 'Uncharacterized protein', 300, NULL, NULL, 205684);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(205685, '3.30.160.60-FF-004209', NULL, NULL, 27, NULL, NULL, 205685),
(205686, '3.30.465.10-FF-000069', NULL, 'FAD binding domain protein', 131, NULL, NULL, 205686),
(205687, '1.10.10.440-FF-000088', NULL, 'Uncharacterized protein', 85, NULL, NULL, 205687),
(205688, '3.40.50.300-FF-004311', NULL, 'RAB30 isoform 8', 139, NULL, NULL, 205688),
(205689, '4.10.400.10-FF-000100', NULL, 'LDL receptor related protein 10', 53, NULL, NULL, 205689),
(205690, '3.40.50.2300-FF-000487', NULL, 'Phosphotyrosine protein phosphatase', 166, NULL, NULL, 205690),
(205691, '1.10.10.10-FF-001042', NULL, 'LysR family transcriptional regulator', 80, NULL, NULL, 205691),
(205692, '1.20.1740.10-FF-000139', NULL, 'Amino acid transporter, putative', 208, NULL, NULL, 205692),
(205693, '1.10.510.10-FF-001918', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase SD2-5', 126, NULL, NULL, 205693),
(205694, '1.10.3210.10-FF-000012', NULL, 'HD domain containing 3', 176, NULL, NULL, 205694),
(205695, '2.130.10.10-FF-003288', NULL, 'Kinesin-related protein 8', 101, NULL, NULL, 205695),
(205696, '3.30.200.20-FF-001633', NULL, 'Uncharacterized protein', 92, NULL, NULL, 205696),
(205697, '3.40.50.300-FF-007745', NULL, 'Uncharacterized protein', 79, NULL, NULL, 205697),
(205698, '1.20.1070.10-FF-000178', NULL, 'Adhesion G-protein coupled receptor V1', 266, NULL, NULL, 205698),
(205699, '2.130.10.10-FF-002799', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 3', 188, NULL, NULL, 205699),
(205700, '1.10.10.10-FF-001385', NULL, 'Transcriptional regulator, ArsR family', 78, NULL, NULL, 205700),
(205701, '3.30.1120.30-FF-000055', NULL, 'Uncharacterized protein', 31, NULL, NULL, 205701),
(205702, '3.90.79.10-FF-000164', NULL, 'YALI0C13310p', 138, NULL, NULL, 205702),
(205703, '1.20.1250.20-FF-000037', NULL, 'Protein NRT1/ PTR FAMILY 5.2', 533, NULL, NULL, 205703),
(205704, '3.30.559.10-FF-000068', NULL, 'Putrescine hydroxycinnamoyltransferase 2', 212, NULL, NULL, 205704),
(205705, '1.25.40.20-FF-001047', NULL, 'NePHronoPhthisis (Human kidney disease) homolog', 259, NULL, NULL, 205705),
(205706, '3.40.50.300-FF-003873', NULL, 'Cell cycle checkpoint protein RAD17-like Protein', 169, NULL, NULL, 205706),
(205707, '3.40.50.720-FF-001402', NULL, 'Glucose 1-dehydrogenase', 133, NULL, NULL, 205707),
(205708, '1.20.120.900-FF-000005', NULL, 'Blast:Peroxisomal biogenesis factor 19', 123, NULL, NULL, 205708),
(205709, '2.30.180.10-FF-000097', NULL, NULL, 141, NULL, NULL, 205709),
(205710, '3.30.70.600-FF-000001', NULL, '30S ribosomal protein S10', 102, NULL, NULL, 205710),
(205711, '1.10.340.70-FF-000040', NULL, 'Uncharacterized protein', 88, NULL, NULL, 205711),
(205712, '2.130.10.10-FF-003816', NULL, 'Uncharacterized protein', 306, NULL, NULL, 205712),
(205713, '2.130.10.10-FF-003075', NULL, 'Uncharacterized protein', 117, NULL, NULL, 205713),
(205714, '3.40.50.300-FF-000652', NULL, 'ATP-dependent RNA helicase DDX1', 167, NULL, NULL, 205714),
(205715, '3.40.50.1480-FF-000010', NULL, 'Adenosylhomocysteinase', 147, NULL, NULL, 205715),
(205716, '3.30.40.10-FF-000982', NULL, 'RING-H2 finger protein ATL2K', 74, NULL, NULL, 205716),
(205717, '1.10.150.50-FF-000227', NULL, 'EPH receptor A5', 62, NULL, NULL, 205717),
(205718, '2.10.230.10-FF-000033', NULL, 'Uncharacterized protein', 13, NULL, NULL, 205718),
(205719, '3.80.10.10-FF-000568', NULL, 'Disease resistance protein RPS4', 193, NULL, NULL, 205719),
(205720, '3.90.20.20-FF-000026', NULL, 'GrpE-like 2, mitochondrial', 110, NULL, NULL, 205720),
(205721, '3.40.50.1760-FF-000004', NULL, 'Glutathione synthetase', 45, NULL, NULL, 205721),
(205722, '1.20.1070.10-FF-001690', NULL, 'Parathyroid hormone receptor 2', 112, NULL, NULL, 205722),
(205723, '3.30.70.3190-FF-000003', NULL, NULL, 119, NULL, NULL, 205723),
(205724, '3.30.1370.130-FF-000004', NULL, NULL, 58, NULL, NULL, 205724),
(205725, '1.25.40.10-FF-001842', NULL, 'Putative pentatricopeptide repeat-containing protein isoform A', 103, NULL, NULL, 205725),
(205726, '1.20.1250.20-FF-000509', NULL, 'MFS general substrate transporter', 426, NULL, NULL, 205726);
INSERT INTO "PUBLIC"."MODEL" VALUES
(205727, '1.10.1040.10-FF-000009', NULL, 'Mannitol-1-phosphate 5-dehydrogenase', 176, NULL, NULL, 205727),
(205728, '3.40.50.620-FF-000686', NULL, 'Predicted protein', 322, NULL, NULL, 205728),
(205729, '3.40.50.300-FF-004362', NULL, '50S ribosome-binding GTPase, putative', 228, NULL, NULL, 205729),
(205730, '3.30.160.60-FF-001450', NULL, 'zinc finger protein 774', 27, NULL, NULL, 205730),
(205731, '3.75.10.10-FF-000007', NULL, 'N(G),N(G)-dimethylarginine dimethylaminohydrolase 1', 181, NULL, NULL, 205731),
(205732, '1.20.1280.290-FF-000095', NULL, 'Uncharacterized protein', 84, NULL, NULL, 205732),
(205733, '1.10.510.10-FF-000957', NULL, 'Uncharacterized protein', 193, NULL, NULL, 205733),
(205734, '3.90.180.10-FF-000164', NULL, 'Uncharacterized protein', 119, NULL, NULL, 205734),
(205735, '3.40.50.720-FF-001003', NULL, 'Oxidoreductase, short-chain dehydrogenase/reductase family', 224, NULL, NULL, 205735),
(205736, '2.30.30.390-FF-000001', NULL, 'F-box only protein 21 isoform X1', 101, NULL, NULL, 205736),
(205737, '3.30.70.80-FF-000055', NULL, 'Subtilisin-like protease SBT3.2', 65, NULL, NULL, 205737),
(205738, '3.30.1010.10-FF-000119', NULL, 'ATM protein', 73, NULL, NULL, 205738),
(205739, '1.25.10.10-FF-003190', NULL, 'Uncharacterized protein', 304, NULL, NULL, 205739),
(205740, '3.50.50.60-FF-000171', NULL, 'zeta-carotene-forming phytoene desaturase', 115, NULL, NULL, 205740),
(205741, '3.30.910.20-FF-000012', NULL, 'Outer membrane protein', 145, NULL, NULL, 205741),
(205742, '3.30.40.10-FF-000583', NULL, 'E3 ubiquitin-protein ligase TRIM69', 89, NULL, NULL, 205742),
(205743, '3.40.50.10190-FF-000076', NULL, 'DNA helicase, phage-associated', 90, NULL, NULL, 205743),
(205744, '2.60.120.820-FF-000011', NULL, 'Predicted protein', 119, NULL, NULL, 205744),
(205745, '3.40.50.300-FF-007184', NULL, 'Energy-coupling factor transporter ATP-binding protein EcfA2', 286, NULL, NULL, 205745),
(205746, '3.30.70.1450-FF-000037', NULL, 'Predicted protein', 79, NULL, NULL, 205746),
(205747, '2.40.70.10-FF-000452', NULL, NULL, 131, NULL, NULL, 205747),
(205748, '3.40.50.360-FF-000086', NULL, 'FMN reductase', 172, NULL, NULL, 205748),
(205749, '1.10.510.10-FF-004268', NULL, NULL, 186, NULL, NULL, 205749),
(205750, '3.90.70.10-FF-000588', NULL, 'Uncharacterized protein', 240, NULL, NULL, 205750),
(205751, '3.20.20.80-FF-000772', NULL, 'Uncharacterized protein', 320, NULL, NULL, 205751),
(205752, '3.30.200.20-FF-000385', NULL, 'Non-specific serine/threonine protein kinase', 134, NULL, NULL, 205752),
(205753, '2.60.40.150-FF-000306', NULL, 'Phosphoinositide phospholipase C', 160, NULL, NULL, 205753),
(205754, '3.40.50.720-FF-002419', NULL, 'Uncharacterized protein', 225, NULL, NULL, 205754),
(205755, '1.20.58.1360-FF-000002', NULL, 'Lysine (K)-specific demethylase 2B', 141, NULL, NULL, 205755),
(205756, '2.60.40.10-FF-001293', NULL, 'Protein tyrosine phosphatase, receptor type B', 87, NULL, NULL, 205756),
(205757, '3.90.1480.20-FF-000065', NULL, 'Uncharacterized protein', 159, NULL, NULL, 205757),
(205758, '3.40.50.300-FF-000091', NULL, 'Probable GTP-binding protein 1', 231, NULL, NULL, 205758),
(205759, '1.20.1530.20-FF-000082', NULL, 'Uncharacterized protein', 334, NULL, NULL, 205759),
(205760, '1.10.10.10-FF-002110', NULL, 'Forkhead box P3a', 50, NULL, NULL, 205760),
(205761, '1.20.5.490-FF-000001', NULL, 'Envelope glycoprotein gp160', 26, NULL, NULL, 205761),
(205762, '1.10.10.10-FF-002054', NULL, 'Helicase conserved C-terminal domain containing protein', 45, NULL, NULL, 205762),
(205763, '3.90.25.10-FF-000045', NULL, 'Uncharacterized protein', 75, NULL, NULL, 205763),
(205764, '3.30.310.10-FF-000042', NULL, 'AP 2 complex subunit beta 1 putative', 106, NULL, NULL, 205764),
(205765, '1.10.555.10-FF-000190', NULL, NULL, 205, NULL, NULL, 205765),
(205766, '3.30.1370.10-FF-000051', NULL, 'Putative kh domain-containing protein', 83, NULL, NULL, 205766),
(205767, '3.30.200.110-FF-000008', NULL, NULL, 127, NULL, NULL, 205767),
(205768, '2.10.50.30-FF-000019', NULL, 'Uncharacterized protein', 48, NULL, NULL, 205768);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(205769, '3.40.50.620-FF-000074', NULL, 'Nicotinamide-nucleotide adenylyltransferase', 234, NULL, NULL, 205769),
(205770, '2.30.180.10-FF-000046', NULL, 'Fasciclin-like arabinogalactan family protein', 134, NULL, NULL, 205770),
(205771, '2.60.120.200-FF-000662', NULL, 'Uncharacterized protein', 81, NULL, NULL, 205771),
(205772, '3.30.70.360-FF-000064', NULL, 'Peptidase M20 domain-containing protein 2', 78, NULL, NULL, 205772),
(205773, '2.70.70.10-FF-000029', NULL, 'Murein DD-endopeptidase MepM and murein hydrolase activator NlpD, contain LysM domain', 132, NULL, NULL, 205773),
(205774, '3.30.710.10-FF-000027', NULL, 'Kelch-like protein 4 isoform 1', 131, NULL, NULL, 205774),
(205775, '3.30.160.60-FF-004541', NULL, NULL, 23, NULL, NULL, 205775),
(205776, '3.30.70.330-FF-001246', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 86, NULL, NULL, 205776),
(205777, '2.160.10.10-FF-000111', NULL, 'Uncharacterized protein', 167, NULL, NULL, 205777),
(205778, '1.10.1200.10-FF-000163', NULL, 'Tryptophan N-acetyltransferase ivoA', 69, NULL, NULL, 205778),
(205779, '3.10.20.80-FF-000002', NULL, 'Mitochondrial translational initiation factor 3', 72, NULL, NULL, 205779),
(205780, '1.25.10.10-FF-001222', NULL, 'Uncharacterized protein', 273, NULL, NULL, 205780),
(205781, '1.10.300.10-FF-000008', NULL, 'Adenylosuccinate synthetase', 13, NULL, NULL, 205781),
(205782, '3.30.40.10-FF-002163', NULL, 'Structure-specific endonuclease subunit SLX1 homolog', 66, NULL, NULL, 205782),
(205783, '2.100.10.30-FF-000007', NULL, 'YIL108W-like protein', 136, NULL, NULL, 205783),
(205784, '3.40.50.1110-FF-000057', NULL, 'Acetylxylan esterase / glucomannan deacetylase', 219, NULL, NULL, 205784),
(205785, '1.25.40.530-FF-000021', NULL, 'Protein CBG15100', 172, NULL, NULL, 205785),
(205786, '3.40.50.1820-FF-001231', NULL, 'Uncharacterized protein', 344, NULL, NULL, 205786),
(205787, '2.60.40.420-FF-000174', NULL, 'Multicopper oxidase family protein', 154, NULL, NULL, 205787),
(205788, '3.10.50.40-FF-000133', NULL, 'Peptidylprolyl isomerase', 110, NULL, NULL, 205788),
(205789, '2.60.40.650-FF-000018', NULL, 'Uncharacterized protein', 105, NULL, NULL, 205789),
(205790, '3.30.470.20-FF-000219', NULL, 'Inositol-tetrakisphosphate 1-kinase', 71, NULL, NULL, 205790),
(205791, '2.60.40.630-FF-000012', NULL, 'Signal transducer and activator of transcription 3', 145, NULL, NULL, 205791),
(205792, '3.30.160.380-FF-000011', NULL, NULL, 100, NULL, NULL, 205792),
(205793, '2.60.40.60-FF-000155', NULL, 'cadherin-23 isoform X1', 108, NULL, NULL, 205793),
(205794, '1.25.40.10-FF-004439', NULL, 'Uncharacterized protein', 119, NULL, NULL, 205794),
(205795, '3.30.60.30-FF-000079', NULL, 'Enhancer of split M1 protein', 64, NULL, NULL, 205795),
(205796, '3.10.20.90-FF-000062', NULL, 'talin-2 isoform X1', 83, NULL, NULL, 205796),
(205797, '3.90.70.10-FF-000644', NULL, 'Ubiquitin carboxyl-terminal hydrolase 17', 97, NULL, NULL, 205797),
(205798, '3.40.30.10-FF-000380', NULL, 'UBX domain-containing protein 5', 116, NULL, NULL, 205798),
(205799, '3.55.10.10-FF-000002', NULL, 'Archease, putative', 139, NULL, NULL, 205799),
(205800, '2.30.29.30-FF-000733', NULL, 'Myosin XVB', 95, NULL, NULL, 205800),
(205801, '2.10.110.10-FF-000086', NULL, 'Filamin binding LIM protein 1', 75, NULL, NULL, 205801),
(205802, '2.30.30.190-FF-000042', NULL, NULL, 82, NULL, NULL, 205802),
(205803, '3.40.50.2300-FF-000144', NULL, 'DNA-binding response regulator', 83, NULL, NULL, 205803),
(205804, '3.10.250.10-FF-000030', NULL, 'T-cell surface glycoprotein CD5', 107, NULL, NULL, 205804),
(205805, '3.30.40.10-FF-001651', NULL, 'Development protein DG1106', 100, NULL, NULL, 205805),
(205806, '2.70.170.10-FF-000183', NULL, 'Predicted protein', 220, NULL, NULL, 205806),
(205807, '2.60.120.10-FF-000682', NULL, 'Uncharacterized protein', 87, NULL, NULL, 205807),
(205808, '1.20.1250.20-FF-000892', NULL, 'MFS transporter', 179, NULL, NULL, 205808),
(205809, '2.130.10.10-FF-005492', NULL, 'SnoRNA-binding rRNA-processing protein', 120, NULL, NULL, 205809),
(205810, '1.25.40.10-FF-001050', NULL, 'Pentatricopeptide repeat-containing protein At2g33760', 186, NULL, NULL, 205810);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(205811, '3.30.70.60-FF-000009', NULL, '30S ribosomal protein S6', 91, NULL, NULL, 205811),
(205812, '1.10.10.10-FF-000873', NULL, 'LysR family transcriptional regulator', 91, NULL, NULL, 205812),
(205813, '3.90.1410.10-FF-000018', NULL, 'N-lysine methyltransferase SETD6 isoform X2', 96, NULL, NULL, 205813),
(205814, '3.40.1120.10-FF-000002', NULL, '50S ribosomal protein L15e', 193, NULL, NULL, 205814),
(205815, '3.30.40.10-FF-001319', NULL, 'TFIIE alpha subunit', 62, NULL, NULL, 205815),
(205816, '3.30.2090.10-FF-000012', NULL, 'Probable RND efflux transporter', 93, NULL, NULL, 205816),
(205817, '1.20.58.390-FF-000140', NULL, 'Neuronal acetylcholine receptor subunit eat-2', 80, NULL, NULL, 205817),
(205818, '3.40.50.720-FF-000334', NULL, 'Inositol-3-phosphate synthase', 132, NULL, NULL, 205818),
(205819, '3.30.70.330-FF-002882', NULL, NULL, 63, NULL, NULL, 205819),
(205820, '3.40.50.11660-FF-000051', NULL, NULL, 95, NULL, NULL, 205820),
(205821, '3.30.720.50-FF-000017', NULL, NULL, 81, NULL, NULL, 205821),
(205822, '1.25.40.10-FF-005283', NULL, 'Uncharacterized protein', 142, NULL, NULL, 205822),
(205823, '2.60.40.1170-FF-000065', NULL, 'Mu-adaptin 1, putative', 113, NULL, NULL, 205823),
(205824, '3.40.50.10190-FF-000025', NULL, 'Breast cancer type 1 susceptibility protein homolog', 101, NULL, NULL, 205824),
(205825, '3.90.650.10-FF-000014', NULL, 'Phosphoribosylformylglycinamidine synthase', 171, NULL, NULL, 205825),
(205826, '1.10.150.170-FF-000008', NULL, 'Ribosomal RNA small subunit methyltransferase H', 100, NULL, NULL, 205826),
(205827, '2.130.10.10-FF-004704', NULL, 'AFR634Wp', 173, NULL, NULL, 205827),
(205828, '3.40.50.720-FF-000278', NULL, 'Fatty acyl-CoA reductase', 355, NULL, NULL, 205828),
(205829, '1.10.510.10-FF-003543', NULL, NULL, 234, NULL, NULL, 205829),
(205830, '2.130.10.10-FF-002563', NULL, 'Uncharacterized protein', 179, NULL, NULL, 205830),
(205831, '1.25.40.10-FF-004484', NULL, 'Pentatricopeptide repeat-containing protein At2g01510, mitochondrial', 102, NULL, NULL, 205831),
(205832, '2.40.50.140-FF-000967', NULL, NULL, 61, NULL, NULL, 205832),
(205833, '3.40.30.10-FF-000228', NULL, 'Protein disulfide-isomerase like 2-2', 118, NULL, NULL, 205833),
(205834, '3.40.50.10190-FF-000256', NULL, 'PIS (Pax-2, IA-1/6, Smad-2 interacting protein) homolog', 83, NULL, NULL, 205834),
(205835, '3.30.70.2510-FF-000007', NULL, NULL, 103, NULL, NULL, 205835),
(205836, '3.30.1490.80-FF-000030', NULL, 'Glutathione synthetase', 45, NULL, NULL, 205836),
(205837, '3.30.160.60-FF-001686', NULL, 'Zinc finger protein 571', 26, NULL, NULL, 205837),
(205838, '1.10.418.20-FF-000015', NULL, 'Ubiquitin-like protease 2', 107, NULL, NULL, 205838),
(205839, '1.25.40.10-FF-002354', NULL, 'Pentatricopeptide repeat-containing protein', 89, NULL, NULL, 205839),
(205840, '2.60.40.60-FF-000099', NULL, 'protocadherin-19 isoform X2', 108, NULL, NULL, 205840),
(205841, '2.130.10.10-FF-003344', NULL, 'Uncharacterized protein', 497, NULL, NULL, 205841),
(205842, '2.60.40.10-FF-002759', NULL, 'Protein-tyrosine-phosphatase', 99, NULL, NULL, 205842),
(205843, '2.30.39.10-FF-000127', NULL, 'Uncharacterized protein', 148, NULL, NULL, 205843),
(205844, '1.20.140.40-FF-000019', NULL, 'Pectinesterase', 154, NULL, NULL, 205844),
(205845, '2.30.29.30-FF-000677', NULL, 'p21-activated kinase, putative', 85, NULL, NULL, 205845),
(205846, '3.50.50.60-FF-001188', NULL, 'Flavin-containing monooxygenase', 70, NULL, NULL, 205846),
(205847, '3.80.10.10-FF-001006', NULL, 'F-box protein', 135, NULL, NULL, 205847),
(205848, '2.120.10.30-FF-000618', NULL, 'Uncharacterized protein', 61, NULL, NULL, 205848),
(205849, '2.60.40.150-FF-000582', NULL, 'Uncharacterized protein', 104, NULL, NULL, 205849),
(205850, '1.10.167.10-FF-000046', NULL, 'FI03282p', 136, NULL, NULL, 205850),
(205851, '1.25.40.10-FF-003079', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 182, NULL, NULL, 205851),
(205852, '1.20.58.60-FF-000784', NULL, 'Dystonin', 220, NULL, NULL, 205852),
(205853, '1.50.10.10-FF-000085', NULL, 'Glycosyl transferase, family 65', 367, NULL, NULL, 205853); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(205854, '3.40.390.10-FF-000056', NULL, 'Thrombospondin type 1 domain protein', 214, NULL, NULL, 205854),
(205855, '3.10.20.90-FF-000859', NULL, 'Uncharacterized protein', 76, NULL, NULL, 205855),
(205856, '3.30.1960.10-FF-000023', NULL, 'Uncharacterized protein', 63, NULL, NULL, 205856),
(205857, '1.50.10.20-FF-000138', NULL, 'Uncharacterized protein', 86, NULL, NULL, 205857),
(205858, '3.90.640.10-FF-000188', NULL, 'Uncharacterized protein', 85, NULL, NULL, 205858),
(205859, '3.10.450.580-FF-000001', NULL, 'Mediator of RNA polymerase II transcription subunit 6', 128, NULL, NULL, 205859),
(205860, '2.70.130.10-FF-000130', NULL, NULL, 119, NULL, NULL, 205860),
(205861, '1.10.730.10-FF-000092', NULL, 'GD12953', 226, NULL, NULL, 205861),
(205862, '1.10.555.10-FF-000038', NULL, 'DEP domain-containing protein 1A isoform X1', 133, NULL, NULL, 205862),
(205863, '1.20.1070.10-FF-001919', NULL, 'Urotensin-2 receptor-like', 282, NULL, NULL, 205863),
(205864, '1.25.40.20-FF-000322', NULL, 'GA-binding protein subunit beta-1 isoform X3', 107, NULL, NULL, 205864),
(205865, '3.30.710.10-FF-000314', NULL, 'Potassium channel', 100, NULL, NULL, 205865),
(205866, '4.10.280.10-FF-000163', NULL, 'Transcriptional regulator CBF1', 65, NULL, NULL, 205866),
(205867, '1.10.246.130-FF-000026', NULL, NULL, 109, NULL, NULL, 205867),
(205868, '1.25.40.20-FF-000266', NULL, 'Mindbomb E3 ubiquitin protein ligase 1', 55, NULL, NULL, 205868),
(205869, '3.30.710.10-FF-000258', NULL, 'Protein CBR-KVS-3', 124, NULL, NULL, 205869),
(205870, '3.40.850.10-FF-000136', NULL, 'Kinesin-like protein', 409, NULL, NULL, 205870),
(205871, '3.30.1120.10-FF-000004', NULL, 'Galactosamine (N-acetyl)-6-sulfatase', 87, NULL, NULL, 205871),
(205872, '1.25.10.10-FF-002021', NULL, 'Uncharacterized protein', 88, NULL, NULL, 205872),
(205873, '3.40.50.720-FF-002571', NULL, 'Predicted protein', 36, NULL, NULL, 205873),
(205874, '1.20.120.1510-FF-000004', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 111, NULL, NULL, 205874),
(205875, '3.50.50.60-FF-001424', NULL, 'Lysine-specific histone demethylase 2', 118, NULL, NULL, 205875),
(205876, '1.10.510.10-FF-000053', NULL, 'Epithelial discoidin domain-containing receptor 1', 201, NULL, NULL, 205876),
(205877, '2.20.100.10-FF-000032', NULL, 'ADAMTS-like protein 1', 59, NULL, NULL, 205877),
(205878, '2.60.120.260-FF-000365', NULL, 'Uncharacterized protein', 139, NULL, NULL, 205878),
(205879, '1.10.287.110-FF-000405', NULL, 'Uncharacterized protein', 108, NULL, NULL, 205879),
(205880, '1.25.40.180-FF-000051', NULL, 'MIF4G domain containing', 64, NULL, NULL, 205880),
(205881, '1.10.10.60-FF-000135', NULL, 'Myb/SANT-like DNA-binding domain containing 1', 63, NULL, NULL, 205881),
(205882, '3.40.50.261-FF-000040', NULL, 'Predicted protein', 78, NULL, NULL, 205882),
(205883, '2.130.10.10-FF-003400', NULL, 'Uncharacterized protein', 204, NULL, NULL, 205883),
(205884, '3.20.20.70-FF-000656', NULL, NULL, 231, NULL, NULL, 205884),
(205885, '1.10.1240.10-FF-000008', NULL, 'Dimethylamine corrinoid protein', 73, NULL, NULL, 205885),
(205886, '2.60.260.20-FF-000009', NULL, 'Putative Mitochondrial DnaJ chaperone', 72, NULL, NULL, 205886),
(205887, '1.25.40.10-FF-002410', NULL, 'Os03g0435200 protein', 131, NULL, NULL, 205887),
(205888, '3.30.160.60-FF-001742', NULL, 'Zinc finger protein 620', 29, NULL, NULL, 205888),
(205889, '1.20.1560.10-FF-000373', NULL, 'ATP binding cassette subfamily B member 10', 183, NULL, NULL, 205889),
(205890, '3.40.50.1820-FF-001848', NULL, 'Uncharacterized protein', 70, NULL, NULL, 205890),
(205891, '1.10.8.140-FF-000005', NULL, 'Unplaced genomic scaffold supercont2.21, whole genome shotgun sequence', 80, NULL, NULL, 205891),
(205892, '3.30.420.40-FF-000879', NULL, 'Uncharacterized protein', 41, NULL, NULL, 205892),
(205893, '2.60.40.10-FF-002815', NULL, 'AGAP003610-PA', 100, NULL, NULL, 205893),
(205894, '3.40.50.10190-FF-000312', NULL, 'Predicted protein', 121, NULL, NULL, 205894),
(205895, '3.80.10.10-FF-003367', NULL, 'Uncharacterized protein', 110, NULL, NULL, 205895);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(205896, '3.40.367.20-FF-000027', NULL, 'Phosphotransferase', 200, NULL, NULL, 205896),
(205897, '3.40.50.300-FF-007852', NULL, 'Predicted protein', 218, NULL, NULL, 205897),
(205898, '3.40.50.2300-FF-000779', NULL, NULL, 126, NULL, NULL, 205898),
(205899, '3.30.760.10-FF-000070', NULL, 'YALI0D24299p', 213, NULL, NULL, 205899),
(205900, '1.10.510.10-FF-004324', NULL, NULL, 144, NULL, NULL, 205900),
(205901, '3.10.330.10-FF-000031', NULL, 'Putative AAA family ATPase SEC18', 117, NULL, NULL, 205901),
(205902, '3.10.20.90-FF-000679', NULL, 'Ubiquitin family protein', 76, NULL, NULL, 205902),
(205903, '2.60.40.10-FF-005401', NULL, NULL, 44, NULL, NULL, 205903),
(205904, '1.10.287.70-FF-000191', NULL, 'Glutamate receptor ionotropic, NMDA 3A', 138, NULL, NULL, 205904),
(205905, '2.20.70.10-FF-000054', NULL, 'E3 ubiquitin-protein ligase SMURF1', 52, NULL, NULL, 205905),
(205906, '3.40.50.10330-FF-000045', NULL, 'Diacylglycerol kinase catalytic subunit', 127, NULL, NULL, 205906),
(205907, '3.40.630.30-FF-000093', NULL, 'Acetyltransferase, GNAT family', 138, NULL, NULL, 205907),
(205908, '2.40.70.10-FF-000396', NULL, NULL, 225, NULL, NULL, 205908),
(205909, '3.40.50.150-FF-001079', NULL, NULL, 237, NULL, NULL, 205909),
(205910, '1.25.40.10-FF-004771', NULL, 'Predicted protein', 202, NULL, NULL, 205910),
(205911, '3.30.750.24-FF-000122', NULL, 'Proton/sulfate symporter family protein', 139, NULL, NULL, 205911),
(205912, '3.30.559.10-FF-000124', NULL, 'Plipastatin synthase subunit A', 195, NULL, NULL, 205912),
(205913, '3.30.70.330-FF-002606', NULL, NULL, 132, NULL, NULL, 205913),
(205914, '3.40.50.300-FF-005615', NULL, 'Tudor domain-containing 9', 105, NULL, NULL, 205914),
(205915, '1.10.510.10-FF-001126', NULL, 'Uncharacterized protein', 200, NULL, NULL, 205915),
(205916, '2.60.40.10-FF-000730', NULL, 'Fibroblast growth factor receptor', 84, NULL, NULL, 205916),
(205917, '2.40.20.10-FF-000005', NULL, 'Plasminogen', 106, NULL, NULL, 205917),
(205918, '2.10.70.10-FF-000251', NULL, 'Mannan-binding lectin serine peptidase 2', 73, NULL, NULL, 205918),
(205919, '3.40.50.300-FF-007291', NULL, 'Small GTP-binding protein, putative', 151, NULL, NULL, 205919),
(205920, '1.25.10.10-FF-000784', NULL, 'Bm5671, isoform c', 214, NULL, NULL, 205920),
(205921, '3.10.20.620-FF-000001', NULL, 'Autophagy related 5', 102, NULL, NULL, 205921),
(205922, '1.10.287.80-FF-000025', NULL, 'Uncharacterized protein', 33, NULL, NULL, 205922),
(205923, '2.80.10.50-FF-000099', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 125, NULL, NULL, 205923),
(205924, '1.10.510.10-FF-003487', NULL, NULL, 263, NULL, NULL, 205924),
(205925, '1.20.1070.10-FF-000846', NULL, 'Oxoeicosanoid receptor 1', 289, NULL, NULL, 205925),
(205926, '2.30.29.30-FF-000913', NULL, 'Protein VASP homolog', 116, NULL, NULL, 205926),
(205927, '3.30.40.10-FF-000291', NULL, 'TNF receptor-associated factor', 60, NULL, NULL, 205927),
(205928, '2.40.10.240-FF-000006', NULL, 'S-adenosylmethionine:tRNA ribosyltransferase-isomerase', 117, NULL, NULL, 205928),
(205929, '3.30.70.330-FF-002994', NULL, NULL, 85, NULL, NULL, 205929),
(205930, '2.10.25.10-FF-000231', NULL, 'hedgehog-interacting protein-like isoform X1', 54, NULL, NULL, 205930),
(205931, '3.30.2300.10-FF-000007', NULL, 'Uncharacterized protein', 80, NULL, NULL, 205931),
(205932, '1.10.1040.10-FF-000116', NULL, 'Uncharacterized protein', 122, NULL, NULL, 205932),
(205933, '3.90.470.10-FF-000028', NULL, 'Ribosomal protein L17', 144, NULL, NULL, 205933),
(205934, '1.10.1200.10-FF-000118', NULL, 'Hydroxamate-type ferrichrome siderophore peptide synthetase', 96, NULL, NULL, 205934),
(205935, '3.30.930.10-FF-000297', NULL, 'Phenylalanine--tRNA ligase beta subunit', 202, NULL, NULL, 205935),
(205936, '3.30.110.20-FF-000007', NULL, 'DNA/RNA-binding protein Alba 3', 96, NULL, NULL, 205936),
(205937, '3.80.10.10-FF-003928', NULL, 'Uncharacterized protein', 96, NULL, NULL, 205937),
(205938, '1.10.150.20-FF-000016', NULL, 'DNA integrity scanning protein DisA', 63, NULL, NULL, 205938),
(205939, '2.60.120.780-FF-000015', NULL, 'Protein inhibitor of-activated STAT, 4b', 96, NULL, NULL, 205939);
INSERT INTO "PUBLIC"."MODEL" VALUES
(205940, '3.40.190.10-FF-000636', NULL, 'LysR family transcriptional regulator', 102, NULL, NULL, 205940),
(205941, '3.40.1110.10-FF-000232', NULL, 'Calcium-translocating P-type ATPase, PMCA-type', 182, NULL, NULL, 205941),
(205942, '1.20.1730.10-FF-000021', NULL, 'Sodium/glucose cotransporter 1', 521, NULL, NULL, 205942),
(205943, '3.30.160.60-FF-005053', NULL, NULL, 41, NULL, NULL, 205943),
(205944, '3.40.50.300-FF-003581', NULL, 'Probable ATP-binding component of ABC transporter', 216, NULL, NULL, 205944),
(205945, '1.25.10.10-FF-003307', NULL, 'Predicted protein', 166, NULL, NULL, 205945),
(205946, '1.20.120.230-FF-000052', NULL, 'Uncharacterized protein', 133, NULL, NULL, 205946),
(205947, '3.40.30.10-FF-000048', NULL, 'Arsenate reductase', 141, NULL, NULL, 205947),
(205948, '3.40.50.620-FF-000181', NULL, 'Nicotinamide/nicotinic acid mononucleotide adenylyltransferase 3', 233, NULL, NULL, 205948),
(205949, '3.80.10.10-FF-002642', NULL, 'Nephrocan', 73, NULL, NULL, 205949),
(205950, '1.10.20.10-FF-000374', NULL, NULL, 40, NULL, NULL, 205950),
(205951, '3.40.50.300-FF-000944', NULL, 'Macrolide ABC transporter ATP-binding protein', 275, NULL, NULL, 205951),
(205952, '3.40.50.2300-FF-000200', NULL, 'Guanylate cyclase', 167, NULL, NULL, 205952),
(205953, '3.40.605.10-FF-000135', NULL, 'ALdehyde deHydrogenase', 79, NULL, NULL, 205953),
(205954, '2.60.40.10-FF-001511', NULL, 'Beta-mannosidase A', 109, NULL, NULL, 205954),
(205955, '1.20.5.190-FF-000136', NULL, NULL, 67, NULL, NULL, 205955),
(205956, '2.60.110.10-FF-000001', NULL, 'THAUMATIN-LIKE PROTEIN 1', 220, NULL, NULL, 205956),
(205957, '2.130.10.10-FF-003923', NULL, 'Uncharacterized protein', 261, NULL, NULL, 205957),
(205958, '2.30.30.30-FF-000130', NULL, 'Uncharacterized protein', 107, NULL, NULL, 205958),
(205959, '2.170.140.10-FF-000027', NULL, 'mucin-2 isoform X2', 67, NULL, NULL, 205959),
(205960, '3.40.50.1010-FF-000015', NULL, 'Flap endonuclease 1', 213, NULL, NULL, 205960),
(205961, '2.130.10.10-FF-005997', NULL, 'Beta transducin Trp-Asp domain-containing protein, putative', 114, NULL, NULL, 205961),
(205962, '2.60.40.10-FF-001455', NULL, 'Bent, isoform C', 98, NULL, NULL, 205962),
(205963, '1.20.58.1780-FF-000009', NULL, 'Nuclear pore complex protein nup155, putative', 299, NULL, NULL, 205963),
(205964, '3.30.40.10-FF-000538', NULL, 'E3 ubiquitin-protein ligase MBR2 isoform A', 82, NULL, NULL, 205964),
(205965, '2.40.50.140-FF-000911', NULL, NULL, 131, NULL, NULL, 205965),
(205966, '3.40.50.1820-FF-001287', NULL, 'Clan SC, family S33, methylesterase-like serine peptidase', 286, NULL, NULL, 205966),
(205967, '2.40.50.140-FF-000855', NULL, NULL, 60, NULL, NULL, 205967),
(205968, '3.30.1490.120-FF-000005', NULL, 'DNA-directed RNA polymerase III subunit', 80, NULL, NULL, 205968),
(205969, '2.60.220.50-FF-000050', NULL, 'Latrophilin-like protein 1', 185, NULL, NULL, 205969),
(205970, '3.30.1150.10-FF-000012', NULL, 'Energy transducer TonB', 126, NULL, NULL, 205970),
(205971, '3.40.50.720-FF-000154', NULL, 'Bifunctional acetylglutamate kinase/N-acetyl-gamma-glutamyl-phosphate reductase', 148, NULL, NULL, 205971),
(205972, '3.40.1110.10-FF-000176', NULL, 'Phospholipid-transporting ATPase', 12, NULL, NULL, 205972),
(205973, '2.130.10.10-FF-001782', NULL, 'WD_domain_-_G-beta_repeat_-_putative', 173, NULL, NULL, 205973),
(205974, '3.30.160.60-FF-003428', NULL, NULL, 29, NULL, NULL, 205974),
(205975, '1.20.1070.10-FF-000503', NULL, 'Uncharacterized protein', 321, NULL, NULL, 205975),
(205976, '1.10.287.2480-FF-000004', NULL, 'Fusion glycoprotein F0', 160, NULL, NULL, 205976),
(205977, '3.40.50.11610-FF-000007', NULL, '2-oxoglutarate dehydrogenase, E1 component', 181, NULL, NULL, 205977),
(205978, '3.40.50.1820-FF-000831', NULL, 'Uncharacterized protein', 263, NULL, NULL, 205978),
(205979, '3.80.10.10-FF-004204', NULL, 'Uncharacterized protein', 88, NULL, NULL, 205979),
(205980, '3.40.33.10-FF-000145', NULL, 'Uncharacterized protein', 143, NULL, NULL, 205980),
(205981, '2.40.50.140-FF-001131', NULL, NULL, 76, NULL, NULL, 205981),
(205982, '3.30.830.10-FF-000025', NULL, 'Stromal processing peptidase chloroplastic', 212, NULL, NULL, 205982);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(205983, '2.30.29.30-FF-001133', NULL, 'Predicted protein', 120, NULL, NULL, 205983),
(205984, '2.130.10.10-FF-000146', NULL, 'protein RAE1 isoform X1', 338, NULL, NULL, 205984),
(205985, '2.40.10.10-FF-000055', NULL, 'Hepatocyte growth factor-like 1', 113, NULL, NULL, 205985),
(205986, '1.50.40.10-FF-000429', NULL, 'Uncharacterized protein', 180, NULL, NULL, 205986),
(205987, '1.20.5.170-FF-000130', NULL, 'Transcription factor VIP1 isoform A', 63, NULL, NULL, 205987),
(205988, '1.10.10.60-FF-000478', NULL, 'AraC family transcriptional regulator', 58, NULL, NULL, 205988),
(205989, '3.30.70.330-FF-000521', NULL, 'serine/arginine-rich splicing factor RSZ22-like', 98, NULL, NULL, 205989),
(205990, '3.90.1150.10-FF-000363', NULL, 'Pleiotropic regulatory protein', 118, NULL, NULL, 205990),
(205991, '3.30.70.330-FF-000864', NULL, 'Putative RNA-binding protein', 109, NULL, NULL, 205991),
(205992, '3.40.1800.20-FF-000029', NULL, NULL, 76, NULL, NULL, 205992),
(205993, '3.40.50.300-FF-005435', NULL, 'Predicted protein', 144, NULL, NULL, 205993),
(205994, '2.60.40.10-FF-005744', NULL, NULL, 125, NULL, NULL, 205994),
(205995, '3.30.505.10-FF-000129', NULL, 'Predicted protein', 109, NULL, NULL, 205995),
(205996, '2.130.10.10-FF-000489', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 234, NULL, NULL, 205996),
(205997, '3.40.50.410-FF-000180', NULL, 'Epithelial chloride channel protein', 171, NULL, NULL, 205997),
(205998, '3.40.50.2300-FF-000256', NULL, 'Response regulator receiver domain protein', 80, NULL, NULL, 205998),
(205999, '2.120.10.30-FF-000057', NULL, 'Low-density lipoprotein receptor-related protein 2', 316, NULL, NULL, 205999),
(206000, '3.60.21.10-FF-000240', NULL, 'AGAP005458-PA', 240, NULL, NULL, 206000),
(206001, '1.20.58.60-FF-000441', NULL, 'Muscle-specific protein 300 kDa, isoform D', 88, NULL, NULL, 206001),
(206002, '2.60.40.10-FF-004108', NULL, NULL, 93, NULL, NULL, 206002),
(206003, '1.10.10.10-FF-001273', NULL, 'Des-methyl DIF-1 methyltransferase A', 90, NULL, NULL, 206003),
(206004, '3.40.50.300-FF-001164', NULL, 'ATP-dependent helicase/nuclease subunit A', 207, NULL, NULL, 206004),
(206005, '2.60.40.60-FF-000992', NULL, 'Protein CBR-CDH-12', 104, NULL, NULL, 206005),
(206006, '3.30.980.10-FF-000013', NULL, 'alanine--tRNA ligase, mitochondrial', 166, NULL, NULL, 206006),
(206007, '1.20.5.420-FF-000020', NULL, 'Ribonuclease P protein component 4', 64, NULL, NULL, 206007),
(206008, '2.160.20.10-FF-000336', NULL, 'Cell surface protein', 313, NULL, NULL, 206008),
(206009, '3.40.50.620-FF-000922', NULL, 'Tyrosine--tRNA ligase', 52, NULL, NULL, 206009),
(206010, '3.30.160.60-FF-003760', NULL, 'AGAP012741-PA', 81, NULL, NULL, 206010),
(206011, '3.40.630.30-FF-000311', NULL, 'Protein CBG09255', 178, NULL, NULL, 206011),
(206012, '4.10.140.10-FF-000001', NULL, 'Prothrombin', 67, NULL, NULL, 206012),
(206013, '3.40.50.2300-FF-001217', NULL, NULL, 17, NULL, NULL, 206013),
(206014, '1.10.575.10-FF-000022', NULL, 'Uncharacterized protein', 136, NULL, NULL, 206014),
(206015, '3.90.810.10-FF-000016', NULL, 'Non-specific serine/threonine protein kinase', 101, NULL, NULL, 206015),
(206016, '2.10.70.10-FF-000195', NULL, 'Receptor tyrosine kinase', 47, NULL, NULL, 206016),
(206017, '1.10.630.10-FF-000668', NULL, 'Uncharacterized protein', 181, NULL, NULL, 206017),
(206018, '2.70.20.10-FF-000026', NULL, 'DNA topoisomerase 1', 127, NULL, NULL, 206018),
(206019, '3.40.50.80-FF-000031', NULL, 'Bifunctional cytochrome P450/NADPH--P450 reductase', 157, NULL, NULL, 206019),
(206020, '3.30.360.10-FF-000101', NULL, 'Uncharacterized protein', 210, NULL, NULL, 206020),
(206021, '1.20.920.10-FF-000143', NULL, 'Uncharacterized protein', 60, NULL, NULL, 206021),
(206022, '3.30.420.10-FF-000432', NULL, NULL, 107, NULL, NULL, 206022),
(206023, '3.30.40.10-FF-000870', NULL, 'RING-type E3 ubiquitin transferase', 86, NULL, NULL, 206023),
(206024, '1.50.10.130-FF-000019', NULL, NULL, 208, NULL, NULL, 206024),
(206025, '3.80.10.10-FF-002462', NULL, 'Uncharacterized protein', 123, NULL, NULL, 206025);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(206026, '1.10.30.10-FF-000144', NULL, 'High mobility group protein B1', 81, NULL, NULL, 206026),
(206027, '3.30.160.60-FF-004597', NULL, NULL, 63, NULL, NULL, 206027),
(206028, '3.30.428.10-FF-000045', NULL, 'Uncharacterized protein', 241, NULL, NULL, 206028),
(206029, '3.40.1170.10-FF-000005', NULL, 'DNA mismatch repair protein MSH1, mitochondrial', 107, NULL, NULL, 206029),
(206030, '3.30.420.40-FF-000935', NULL, 'Uncharacterized protein', 87, NULL, NULL, 206030),
(206031, '2.40.50.100-FF-000130', NULL, 'ABC transporter ATP-binding protein', 48, NULL, NULL, 206031),
(206032, '1.20.50.20-FF-000007', NULL, 'DNA primase', 54, NULL, NULL, 206032),
(206033, '3.90.850.10-FF-000013', NULL, '4-hydroxyphenylacetate degradation bifunctional isomerase/decarboxylase', 211, NULL, NULL, 206033),
(206034, '2.140.10.10-FF-000005', NULL, 'Glucose dehydrogenase', 226, NULL, NULL, 206034),
(206035, '1.10.287.370-FF-000056', NULL, 'Protein UXT homolog', 160, NULL, NULL, 206035),
(206036, '3.40.190.10-FF-000456', NULL, 'LysR family transcriptional regulator', 81, NULL, NULL, 206036),
(206037, '3.55.40.20-FF-000007', NULL, 'Superoxide dismutase', 120, NULL, NULL, 206037),
(206038, '1.20.58.1040-FF-000024', NULL, '1,3-beta-glucanosyltransferase', 112, NULL, NULL, 206038),
(206039, '3.40.1090.10-FF-000004', NULL, 'Phospholipase A2', 500, NULL, NULL, 206039),
(206040, '3.90.1170.10-FF-000033', NULL, 'Uncharacterized protein', 56, NULL, NULL, 206040),
(206041, '3.30.450.30-FF-000086', NULL, 'Uncharacterized protein', 67, NULL, NULL, 206041),
(206042, '3.40.720.10-FF-000150', NULL, 'N-sulfoglucosamine sulfohydrolase (sulfamidase)', 230, NULL, NULL, 206042),
(206043, '1.20.1310.20-FF-000043', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 175, NULL, NULL, 206043),
(206044, '3.30.450.20-FF-000044', NULL, 'Phosphate regulon sensor histidine kinase PhoR', 114, NULL, NULL, 206044),
(206045, '1.10.8.10-FF-000125', NULL, 'Ubiquitinyl hydrolase 1', 56, NULL, NULL, 206045),
(206046, '1.25.40.10-FF-003259', NULL, 'Putative pentatricopeptide repeat-containing protein At3g15200', 159, NULL, NULL, 206046),
(206047, '2.10.80.10-FF-000021', NULL, 'Dickkopf', 83, NULL, NULL, 206047),
(206048, '1.20.58.1150-FF-000001', NULL, 'Exocyst complex component EXO70', 97, NULL, NULL, 206048),
(206049, '3.40.50.2000-FF-000380', NULL, 'UDP-glucuronosyltransferase', 188, NULL, NULL, 206049),
(206050, '3.40.50.720-FF-001115', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 139, NULL, NULL, 206050),
(206051, '2.30.29.30-FF-000172', NULL, 'differentially expressed in FDCP 6 homolog', 107, NULL, NULL, 206051),
(206052, '2.30.230.10-FF-000039', NULL, 'Uncharacterized protein', 112, NULL, NULL, 206052),
(206053, '1.10.510.10-FF-001469', NULL, 'TKL family protein kinase', 314, NULL, NULL, 206053),
(206054, '1.10.1900.10-FF-000020', NULL, 'Predicted protein', 80, NULL, NULL, 206054),
(206055, '2.120.10.30-FF-000113', NULL, 'Low-density lipoprotein receptor-related protein', 348, NULL, NULL, 206055),
(206056, '2.60.40.10-FF-001854', NULL, 'Uncharacterized protein, isoform E', 109, NULL, NULL, 206056),
(206057, '3.40.50.300-FF-005379', NULL, 'ABC transporter NFT1', 262, NULL, NULL, 206057),
(206058, '3.40.50.150-FF-001135', NULL, NULL, 73, NULL, NULL, 206058),
(206059, '1.10.10.1630-FF-000001', NULL, 'SYmmetrical Sister cell hermaphrodite gonad defect', 68, NULL, NULL, 206059),
(206060, '3.30.160.60-FF-002467', NULL, 'Zinc finger protein 51', 27, NULL, NULL, 206060),
(206061, '2.130.10.10-FF-001107', NULL, 'Chromosome segregation protein (SepB)', 123, NULL, NULL, 206061),
(206062, '3.70.10.10-FF-000074', NULL, 'Uncharacterized protein', 261, NULL, NULL, 206062),
(206063, '3.40.50.670-FF-000004', NULL, 'DNA gyrase subunit B', 100, NULL, NULL, 206063),
(206064, '1.10.8.10-FF-000069', NULL, 'Non-specific serine/threonine protein kinase', 56, NULL, NULL, 206064),
(206065, '3.40.50.150-FF-000354', NULL, 'Ribosomal RNA large subunit methyltransferase E', 183, NULL, NULL, 206065),
(206066, '3.40.50.10090-FF-000052', NULL, 'Uroporphyrinogen-III synthase/uroporphyrin-III C-methyltransferase', 106, NULL, NULL, 206066);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(206067, '3.30.160.60-FF-005957', NULL, NULL, 42, NULL, NULL, 206067),
(206068, '2.60.120.260-FF-000601', NULL, 'Uncharacterized protein', 145, NULL, NULL, 206068),
(206069, '1.10.8.60-FF-000387', NULL, 'Orc1-type DNA replication protein', 85, NULL, NULL, 206069),
(206070, '3.90.640.10-FF-000132', NULL, 'Uncharacterized protein', 79, NULL, NULL, 206070),
(206071, '3.40.50.1440-FF-000026', NULL, 'Tubulin alpha chain', 203, NULL, NULL, 206071),
(206072, '1.25.40.120-FF-000016', NULL, 'Geranylgeranyltransferase type II alpha subunit', 328, NULL, NULL, 206072),
(206073, '3.40.1160.10-FF-000055', NULL, 'Acetylglutamate kinase', 257, NULL, NULL, 206073),
(206074, '3.30.160.60-FF-002124', NULL, 'ras-responsive element-binding protein 1 isoform X1', 27, NULL, NULL, 206074),
(206075, '3.30.70.1230-FF-000090', NULL, 'Guanylate cyclase', 194, NULL, NULL, 206075),
(206076, '3.40.50.300-FF-002001', NULL, 'Peptide ABC transporter ATP-binding protein', 210, NULL, NULL, 206076),
(206077, '3.40.50.300-FF-002125', NULL, 'ATP-dependent helicase HrpB', 179, NULL, NULL, 206077),
(206078, '3.20.20.140-FF-000193', NULL, 'Histidinol phosphatase and related hydrolases of the PHP family', 262, NULL, NULL, 206078),
(206079, '3.40.50.300-FF-001725', NULL, 'Peptide chain release factor 3', 197, NULL, NULL, 206079),
(206080, '3.40.50.720-FF-000839', NULL, 'FAD dependent oxidoreductase superfamily', 156, NULL, NULL, 206080),
(206081, '3.30.300.110-FF-000014', NULL, 'Class I SAM-dependent methyltransferase family protein', 65, NULL, NULL, 206081),
(206082, '1.25.40.10-FF-003135', NULL, 'Pentatricopeptide repeat-containing protein', 113, NULL, NULL, 206082),
(206083, '1.25.10.10-FF-001565', NULL, 'Uncharacterized protein', 672, NULL, NULL, 206083),
(206084, '3.90.730.10-FF-000015', NULL, 'Ribonuclease 2', 41, NULL, NULL, 206084),
(206085, '1.20.1250.20-FF-002185', NULL, 'Facilitated glucose transporter, putative', 165, NULL, NULL, 206085),
(206086, '3.40.640.10-FF-000093', NULL, 'L-tryptophan--pyruvate aminotransferase 1', 206, NULL, NULL, 206086),
(206087, '3.40.390.10-FF-000112', NULL, 'Zinc MetalloProtease', 181, NULL, NULL, 206087),
(206088, '1.10.565.10-FF-000140', NULL, 'Predicted protein', 226, NULL, NULL, 206088),
(206089, '3.60.15.10-FF-000254', NULL, 'Uncharacterized protein', 228, NULL, NULL, 206089),
(206090, '1.20.1510.10-FF-000038', NULL, 'Zinc transporter 4-like Protein', 156, NULL, NULL, 206090),
(206091, '3.40.50.11350-FF-000019', NULL, 'Putative N-acetyl-beta-D-glucosaminide alpha-1,6-fucosyltransferase', 183, NULL, NULL, 206091),
(206092, '1.10.630.10-FF-000325', NULL, 'Uncharacterized protein', 113, NULL, NULL, 206092),
(206093, '3.20.20.140-FF-000411', NULL, 'Uncharacterized protein', 87, NULL, NULL, 206093),
(206094, '1.10.220.20-FF-000011', NULL, 'IQ motif and SEC7 domain-containing protein 2 isoform X3', 90, NULL, NULL, 206094),
(206095, '3.10.450.10-FF-000085', NULL, 'Uncharacterized protein', 78, NULL, NULL, 206095),
(206096, '1.20.1610.10-FF-000023', NULL, 'Uncharacterized protein', 66, NULL, NULL, 206096),
(206097, '3.80.10.10-FF-002586', NULL, 'Hypothetical leucine-rich repeat protein 1 (LRRP1)', 101, NULL, NULL, 206097),
(206098, '3.40.50.720-FF-001059', NULL, 'Pyrroline-5-carboxylate reductase', 164, NULL, NULL, 206098),
(206099, '1.25.40.10-FF-003315', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial isoform A', 111, NULL, NULL, 206099),
(206100, '3.50.50.60-FF-000968', NULL, 'Uncharacterized protein', 63, NULL, NULL, 206100),
(206101, '2.60.120.1540-FF-000007', NULL, 'Alpha-2-macroglobulin like 1', 88, NULL, NULL, 206101),
(206102, '3.30.450.20-FF-000605', NULL, 'Predicted protein', 81, NULL, NULL, 206102),
(206103, '2.60.40.10-FF-005221', NULL, NULL, 90, NULL, NULL, 206103),
(206104, '3.40.30.10-FF-000104', NULL, 'Thioredoxin', 106, NULL, NULL, 206104),
(206105, '3.10.100.10-FF-000042', NULL, 'secretory phospholipase A2 receptor', 130, NULL, NULL, 206105),
(206106, '2.60.40.10-FF-004384', NULL, NULL, 99, NULL, NULL, 206106),
(206107, '3.30.479.20-FF-000020', NULL, 'Elongation factor Ts', 88, NULL, NULL, 206107);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(206108, '1.25.40.10-FF-002915', NULL, 'Tetratricopeptide repeat, putative', 179, NULL, NULL, 206108),
(206109, '2.60.40.10-FF-002310', NULL, 'Beta-mannosidase A', 126, NULL, NULL, 206109),
(206110, '3.30.2170.10-FF-000013', NULL, 'Uncharacterized protein', 273, NULL, NULL, 206110),
(206111, '3.40.50.300-FF-000888', NULL, 'GPN-loop GTPase 1', 259, NULL, NULL, 206111),
(206112, '2.60.120.10-FF-000007', NULL, 'Putative potassium/sodium hyperpolarization-activated cyclic nucleotide-gated channel 2', 137, NULL, NULL, 206112),
(206113, '3.30.200.20-FF-002307', NULL, 'Uncharacterized protein', 66, NULL, NULL, 206113),
(206114, '1.10.238.220-FF-000007', NULL, NULL, 87, NULL, NULL, 206114),
(206115, '3.30.160.60-FF-000887', NULL, 'Transcription factor E4F1 isoform 1', 29, NULL, NULL, 206115),
(206116, '3.50.50.60-FF-001244', NULL, 'Flavin-containing monooxygenase', 170, NULL, NULL, 206116),
(206117, '3.30.450.270-FF-000004', NULL, 'Bacteriophytochrome', 137, NULL, NULL, 206117),
(206118, '3.10.400.20-FF-000028', NULL, 'Uncharacterized protein', 194, NULL, NULL, 206118),
(206119, '3.40.50.720-FF-001790', NULL, 'Bifunctional protein FolD', 120, NULL, NULL, 206119),
(206120, '3.20.20.70-FF-000151', NULL, 'Tryptophan synthase', 267, NULL, NULL, 206120),
(206121, '3.40.228.10-FF-000011', NULL, 'Formate dehydrogenase-N subunit alpha', 148, NULL, NULL, 206121),
(206122, '4.10.270.10-FF-000005', NULL, 'myosin heavy chain, muscle isoform X44', 59, NULL, NULL, 206122),
(206123, '1.20.1740.10-FF-000027', NULL, 'cystine/glutamate transporter isoform X1', 445, NULL, NULL, 206123),
(206124, '1.20.58.2220-FF-000013', NULL, 'Cappuccino, isoform D', 398, NULL, NULL, 206124),
(206125, '3.30.420.10-FF-000270', NULL, 'DNA polymerase', 203, NULL, NULL, 206125),
(206126, '1.25.40.10-FF-002298', NULL, 'Putative pentatricopeptide repeat family protein', 235, NULL, NULL, 206126),
(206127, '1.20.1070.10-FF-001302', NULL, 'Uncharacterized protein', 199, NULL, NULL, 206127),
(206128, '3.30.420.40-FF-000031', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', 165, NULL, NULL, 206128),
(206129, '3.40.720.10-FF-000094', NULL, 'Iduronate 2-sulfatase', 446, NULL, NULL, 206129),
(206130, '2.120.10.80-FF-000375', NULL, 'Uncharacterized protein', 155, NULL, NULL, 206130),
(206131, '1.20.1110.10-FF-000165', NULL, 'Calcium-transporting ATPase', 389, NULL, NULL, 206131),
(206132, '2.30.30.100-FF-000139', NULL, 'Sm snRNP core protein Smb1', 87, NULL, NULL, 206132),
(206133, '3.40.50.300-FF-005559', NULL, 'Uncharacterized protein, isoform C', 286, NULL, NULL, 206133),
(206134, '3.30.540.10-FF-000087', NULL, 'Os12g0183300 protein', 60, NULL, NULL, 206134),
(206135, '2.10.25.10-FF-001809', NULL, 'Predicted protein', 62, NULL, NULL, 206135),
(206136, '3.30.300.30-FF-000098', NULL, 'Nonribosomal peptide synthase, putative', 140, NULL, NULL, 206136),
(206137, '3.40.50.2000-FF-000048', NULL, 'Starch synthase, chloroplastic/amyloplastic', 270, NULL, NULL, 206137),
(206138, '3.30.160.60-FF-005558', NULL, NULL, 31, NULL, NULL, 206138),
(206139, '3.40.50.150-FF-000697', NULL, '23S rRNA (Uracil-5-)-methyltransferase RumA', 202, NULL, NULL, 206139),
(206140, '3.40.50.970-FF-000156', NULL, 'Uncharacterized protein', 153, NULL, NULL, 206140),
(206141, '1.10.30.10-FF-000200', NULL, 'Uncharacterized protein', 86, NULL, NULL, 206141),
(206142, '1.20.58.90-FF-000040', NULL, NULL, 76, NULL, NULL, 206142),
(206143, '1.20.1280.50-FF-000205', NULL, 'F-box DNA helicase 1 isoform X3', 64, NULL, NULL, 206143),
(206144, '1.25.10.10-FF-002526', NULL, 'Uncharacterized protein', 190, NULL, NULL, 206144),
(206145, '3.30.70.330-FF-001302', NULL, 'RNA-binding protein, putative', 179, NULL, NULL, 206145),
(206146, '3.80.10.10-FF-003423', NULL, 'Predicted protein', 72, NULL, NULL, 206146),
(206147, '1.25.40.20-FF-000502', NULL, 'Uncharacterized protein', 195, NULL, NULL, 206147),
(206148, '3.10.105.10-FF-000070', NULL, 'Extracellular solute-binding protein family 5', 228, NULL, NULL, 206148),
(206149, '2.60.40.10-FF-004945', NULL, NULL, 48, NULL, NULL, 206149),
(206150, '3.60.40.10-FF-000216', NULL, 'Protein phosphatase, Mg2+/Mn2+ dependent 1G', 183, NULL, NULL, 206150);
INSERT INTO "PUBLIC"."MODEL" VALUES
(206151, '3.30.70.330-FF-000465', NULL, 'Polyadenylate-binding protein 2', 97, NULL, NULL, 206151),
(206152, '3.30.60.30-FF-000023', NULL, 'tomoregulin-1 isoform X1', 32, NULL, NULL, 206152),
(206153, '1.10.10.750-FF-000006', NULL, 'TBC1 domain family member 7', 59, NULL, NULL, 206153),
(206154, '1.10.10.60-FF-000079', NULL, 'MYB transcription factor', 43, NULL, NULL, 206154),
(206155, '1.10.10.440-FF-000032', NULL, 'Formin binding protein (FNB3)', 72, NULL, NULL, 206155),
(206156, '1.10.510.10-FF-002582', NULL, NULL, 227, NULL, NULL, 206156),
(206157, '3.90.245.10-FF-000011', NULL, 'Probable nucleoside hydrolase iunH', 303, NULL, NULL, 206157),
(206158, '2.10.110.10-FF-000142', NULL, 'Lrg1p', 69, NULL, NULL, 206158),
(206159, '1.20.1560.10-FF-000193', NULL, 'ABC transporter B family member 7', 314, NULL, NULL, 206159),
(206160, '3.40.50.300-FF-005036', NULL, 'Predicted protein', 86, NULL, NULL, 206160),
(206161, '2.20.70.10-FF-000110', NULL, 'CUGBP Elav-like family member 1', 38, NULL, NULL, 206161),
(206162, '2.60.120.10-FF-000406', NULL, 'Cyclic nucleotide-binding protein', 136, NULL, NULL, 206162),
(206163, '3.40.50.720-FF-000098', NULL, 'calcium-activated potassium channel subunit alpha-1 isoform X3', 135, NULL, NULL, 206163),
(206164, '1.25.10.10-FF-001166', NULL, 'Cofactor D', 231, NULL, NULL, 206164),
(206165, '1.10.533.10-FF-000201', NULL, 'Caspase', 95, NULL, NULL, 206165),
(206166, '2.10.60.10-FF-000037', NULL, 'Si:ch73-28h20.1', 78, NULL, NULL, 206166),
(206167, '3.20.20.70-FF-000712', NULL, NULL, 129, NULL, NULL, 206167),
(206168, '3.40.640.10-FF-000289', NULL, 'Aromatic amino acid aminotransferase DDB_G0272014', 435, NULL, NULL, 206168),
(206169, '3.40.50.1360-FF-000036', NULL, 'Glucosamine-6-phosphate deaminase', 242, NULL, NULL, 206169),
(206170, '2.130.10.30-FF-000028', NULL, 'PH, RCC1 and FYVE domains-containing protein 1', 250, NULL, NULL, 206170),
(206171, '3.30.70.1230-FF-000062', NULL, 'Predicted protein', 220, NULL, NULL, 206171),
(206172, '3.40.50.170-FF-000028', NULL, 'Phosphoribosylglycinamide formyltransferase', 193, NULL, NULL, 206172),
(206173, '3.40.50.11180-FF-000002', NULL, 'Transcription-repair-coupling factor', 195, NULL, NULL, 206173),
(206174, '3.40.50.460-FF-000008', NULL, 'ATP-dependent 6-phosphofructokinase', 144, NULL, NULL, 206174),
(206175, '3.30.160.20-FF-000061', NULL, 'Mitochondrial ribosomal protein S5,putative', 66, NULL, NULL, 206175),
(206176, '3.40.50.300-FF-003119', NULL, 'ABC ATPase, putative (AFU_orthologue AFUA_1G16440)', 202, NULL, NULL, 206176),
(206177, '1.10.472.170-FF-000008', NULL, 'Transcription initiation factor IIB protein', 199, NULL, NULL, 206177),
(206178, '1.25.40.20-FF-000406', NULL, 'protein TANC1 isoform X1', 111, NULL, NULL, 206178),
(206179, '3.40.50.10940-FF-000003', NULL, 'L-arabinose isomerase', 156, NULL, NULL, 206179),
(206180, '3.40.50.1820-FF-000854', NULL, 'Uncharacterized protein', 283, NULL, NULL, 206180),
(206181, '3.30.70.270-FF-000205', NULL, NULL, 172, NULL, NULL, 206181),
(206182, '3.40.50.1010-FF-000145', NULL, 'Crossover junction endodeoxyribonuclease', 189, NULL, NULL, 206182),
(206183, '3.40.50.410-FF-000056', NULL, 'Complement factor B', 223, NULL, NULL, 206183),
(206184, '1.10.600.10-FF-000088', NULL, 'FDPS isoform 20', 109, NULL, NULL, 206184),
(206185, '2.60.40.10-FF-002091', NULL, 'Uncharacterized protein, isoform D', 101, NULL, NULL, 206185),
(206186, '2.60.40.10-FF-001585', NULL, 'Hemicentin-2', 93, NULL, NULL, 206186),
(206187, '3.60.15.10-FF-000046', NULL, 'Cleavage and polyadenylation specificity factor subunit 3', 243, NULL, NULL, 206187),
(206188, '3.30.160.60-FF-006385', NULL, NULL, 79, NULL, NULL, 206188),
(206189, '1.25.10.10-FF-000368', NULL, 'Coatomer subunit gamma', 308, NULL, NULL, 206189),
(206190, '1.25.40.10-FF-001505', NULL, 'Pentatricopeptide repeat-containing protein', 188, NULL, NULL, 206190),
(206191, '3.30.559.30-FF-000102', NULL, 'Uncharacterized protein', 108, NULL, NULL, 206191),
(206192, '3.40.50.300-FF-004710', NULL, 'Uncharacterized protein', 297, NULL, NULL, 206192);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(206193, '2.60.120.380-FF-000019', NULL, 'Clan SB, family S8, subtilisin-like serine peptidase', 113, NULL, NULL, 206193),
(206194, '3.20.20.70-FF-000471', NULL, 'N-acetylneuraminic acid condensing enzyme', 266, NULL, NULL, 206194),
(206195, '2.40.50.140-FF-000731', NULL, NULL, 77, NULL, NULL, 206195),
(206196, '1.10.510.10-FF-003195', NULL, NULL, 149, NULL, NULL, 206196),
(206197, '2.10.25.10-FF-001349', NULL, 'Uncharacterized protein', 46, NULL, NULL, 206197),
(206198, '3.80.10.10-FF-004272', NULL, 'Uncharacterized protein', 54, NULL, NULL, 206198),
(206199, '2.60.40.10-FF-005328', NULL, NULL, 76, NULL, NULL, 206199),
(206200, '3.30.70.270-FF-000194', NULL, NULL, 177, NULL, NULL, 206200),
(206201, '2.60.40.60-FF-000548', NULL, 'Uncharacterized protein', 111, NULL, NULL, 206201),
(206202, '1.10.472.150-FF-000002', NULL, 'Mlc titration factor A', 123, NULL, NULL, 206202),
(206203, '1.20.120.530-FF-000001', NULL, 'Pyruvate dehydrogenase complex transcriptional repressor', 141, NULL, NULL, 206203),
(206204, '2.40.290.10-FF-000035', NULL, 'ATP-dependent DNA helicase', 133, NULL, NULL, 206204),
(206205, '3.90.1520.10-FF-000015', NULL, 'guanylate cyclase soluble subunit beta-1-like isoform X1', 187, NULL, NULL, 206205),
(206206, '2.60.200.10-FF-000008', NULL, 'Interferon regulatory factor 3', 241, NULL, NULL, 206206),
(206207, '3.40.50.1820-FF-000415', NULL, 'Putative class 3 lipase', 183, NULL, NULL, 206207),
(206208, '3.40.930.10-FF-000053', NULL, NULL, 98, NULL, NULL, 206208),
(206209, '2.60.120.200-FF-000370', NULL, 'Apical endosomal glycoprotein', 157, NULL, NULL, 206209),
(206210, '2.30.42.10-FF-000270', NULL, 'disks large homolog 2', 101, NULL, NULL, 206210),
(206211, '1.25.40.20-FF-000878', NULL, 'Ankyrin 2, isoform E', 93, NULL, NULL, 206211),
(206212, '2.130.10.10-FF-005502', NULL, 'Uncharacterized protein', 103, NULL, NULL, 206212),
(206213, '1.20.1250.20-FF-002139', NULL, 'Uncharacterized protein', 204, NULL, NULL, 206213),
(206214, '2.40.160.50-FF-000015', NULL, 'SAM complex subunit', 325, NULL, NULL, 206214),
(206215, '1.25.40.20-FF-001351', NULL, 'Protein vms-1-like Protein', 103, NULL, NULL, 206215),
(206216, '2.60.40.1450-FF-000014', NULL, 'Transcription factor cbf11', 138, NULL, NULL, 206216),
(206217, '1.20.1070.10-FF-000386', NULL, 'Methuselah-like 10, isoform D', 314, NULL, NULL, 206217),
(206218, '1.10.8.60-FF-000067', NULL, 'Peroxisomal biogenesis factor 1', 89, NULL, NULL, 206218),
(206219, '1.25.40.10-FF-001022', NULL, 'Skt5p', 258, NULL, NULL, 206219),
(206220, '3.90.290.10-FF-000003', NULL, 'Fibrillin 3', 63, NULL, NULL, 206220),
(206221, '2.60.40.10-FF-002102', NULL, 'V-set and immunoglobulin domain containing 4', 87, NULL, NULL, 206221),
(206222, '3.40.50.720-FF-001666', NULL, 'NEDD8-activating enzyme E1 regulatory subunit', 181, NULL, NULL, 206222),
(206223, '2.60.40.10-FF-000966', NULL, 'Sallimus, isoform P', 103, NULL, NULL, 206223),
(206224, '3.30.160.60-FF-005766', NULL, NULL, 33, NULL, NULL, 206224),
(206225, '3.40.50.40-FF-000002', NULL, 'L-asparaginase 2', 114, NULL, NULL, 206225),
(206226, '3.40.250.10-FF-000006', NULL, 'M-phase inducer phosphatase 2', 179, NULL, NULL, 206226),
(206227, '2.10.110.20-FF-000004', NULL, NULL, 62, NULL, NULL, 206227),
(206228, '1.10.287.70-FF-000803', NULL, 'Calcium voltage-gated channel subunit alpha1 I', 131, NULL, NULL, 206228),
(206229, '3.30.230.10-FF-000277', NULL, 'Predicted protein', 207, NULL, NULL, 206229),
(206230, '2.60.40.10-FF-002574', NULL, 'Plexin B, putative', 124, NULL, NULL, 206230),
(206231, '2.30.30.910-FF-000005', NULL, NULL, 37, NULL, NULL, 206231),
(206232, '3.30.160.20-FF-000218', NULL, 'Uncharacterized protein', 70, NULL, NULL, 206232),
(206233, '3.90.70.10-FF-000245', NULL, 'Ubiquitin hydrolase, putative', 353, NULL, NULL, 206233),
(206234, '3.30.420.40-FF-000003', NULL, 'heat shock 70 kDa protein-like', 144, NULL, NULL, 206234),
(206235, '3.30.70.2010-FF-000003', NULL, '2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-succinyltransferase', 130, NULL, NULL, 206235),
(206236, '3.20.20.80-FF-000148', NULL, 'Isoamylase 2, chloroplastic', 413, NULL, NULL, 206236); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(206237, '3.40.50.790-FF-000006', NULL, 'Electron transfer flavoprotein alpha-subunit', 101, NULL, NULL, 206237),
(206238, '3.90.700.10-FF-000002', NULL, 'L-aspartate oxidase', 114, NULL, NULL, 206238),
(206239, '1.20.120.1750-FF-000155', NULL, 'RBR-type E3 ubiquitin transferase', 75, NULL, NULL, 206239),
(206240, '1.10.10.60-FF-001259', NULL, NULL, 80, NULL, NULL, 206240),
(206241, '3.20.140.10-FF-000014', NULL, 'Nicotinate phosphoribosyltransferase', 301, NULL, NULL, 206241),
(206242, '3.10.310.10-FF-000029', NULL, 'Trans-3-hydroxy-L-proline dehydratase', 166, NULL, NULL, 206242),
(206243, '3.40.50.2020-FF-000026', NULL, 'Uracil phosphoribosyltransferase homolog', 209, NULL, NULL, 206243),
(206244, '1.10.150.220-FF-000006', NULL, 'Protein CBG23184', 91, NULL, NULL, 206244),
(206245, '3.40.50.1820-FF-001360', NULL, 'Esterase EstC, putative', 236, NULL, NULL, 206245),
(206246, '3.40.30.10-FF-000043', NULL, 'Alkyl hydroperoxide reductase C', 179, NULL, NULL, 206246),
(206247, '2.40.30.10-FF-000202', NULL, 'Fre7p', 88, NULL, NULL, 206247),
(206248, '3.40.50.300-FF-003558', NULL, 'Predicted protein', 67, NULL, NULL, 206248),
(206249, '1.10.287.660-FF-000014', NULL, 'rRNA biogenesis protein Nop5/Nop56', 74, NULL, NULL, 206249),
(206250, '3.10.590.10-FF-000016', NULL, 'YTH domain-containing protein mmi1', 173, NULL, NULL, 206250),
(206251, '3.90.80.10-FF-000010', NULL, 'Probable inorganic pyrophosphatase', 254, NULL, NULL, 206251),
(206252, '1.10.30.50-FF-000021', NULL, 'Vng6364h', 77, NULL, NULL, 206252),
(206253, '2.60.40.10-FF-001146', NULL, 'Matrix remodeling associated 5', 103, NULL, NULL, 206253),
(206254, '1.20.5.110-FF-000011', NULL, 'B-cell receptor-associated protein 29', 64, NULL, NULL, 206254),
(206255, '2.60.40.2100-FF-000001', NULL, 'Minor fimbrium anchoring subunit Mfa2', 170, NULL, NULL, 206255),
(206256, '1.10.287.70-FF-000320', NULL, 'Voltage-dependent calcium channel subunit, putative', 142, NULL, NULL, 206256),
(206257, '3.40.50.300-FF-007936', NULL, 'Uncharacterized protein', 172, NULL, NULL, 206257),
(206258, '3.30.200.20-FF-002386', NULL, 'Protein CBG24789', 103, NULL, NULL, 206258),
(206259, '1.25.40.180-FF-000079', NULL, 'Related to cap binding protein 80 (Cbp80)', 292, NULL, NULL, 206259),
(206260, '3.40.33.10-FF-000066', NULL, 'Uncharacterized protein', 180, NULL, NULL, 206260),
(206261, '3.30.160.60-FF-005396', NULL, NULL, 23, NULL, NULL, 206261),
(206262, '1.10.260.40-FF-000064', NULL, 'Transcriptional repressor RstR', 97, NULL, NULL, 206262),
(206263, '1.20.58.1480-FF-000009', NULL, 'Lon protease homolog, mitochondrial', 131, NULL, NULL, 206263),
(206264, '2.130.10.10-FF-004676', NULL, 'Chromosome 1, whole genome shotgun sequence', 403, NULL, NULL, 206264),
(206265, '1.20.1250.20-FF-001313', NULL, 'Uncharacterized protein', 222, NULL, NULL, 206265),
(206266, '3.20.20.60-FF-000142', NULL, 'Uncharacterized protein', 210, NULL, NULL, 206266),
(206267, '3.40.50.300-FF-001321', NULL, 'Uncharacterized protein, isoform B', 168, NULL, NULL, 206267),
(206268, '1.10.10.2230-FF-000001', NULL, 'DNA (cytosine-5)-methyltransferase', 97, NULL, NULL, 206268),
(206269, '1.25.40.10-FF-000988', NULL, 'Os01g0818200 protein', 69, NULL, NULL, 206269),
(206270, '3.40.50.720-FF-000677', NULL, 'NAD-dependent glutamate dehydrogenase', 269, NULL, NULL, 206270),
(206271, '3.40.50.1220-FF-000123', NULL, 'Transcriptional regulator', 148, NULL, NULL, 206271),
(206272, '3.40.50.1000-FF-000288', NULL, 'HAD family hydrolase', 110, NULL, NULL, 206272),
(206273, '3.30.40.10-FF-001128', NULL, 'Uncharacterized protein', 76, NULL, NULL, 206273),
(206274, '3.40.1350.10-FF-000047', NULL, 'Predicted protein', 86, NULL, NULL, 206274),
(206275, '1.10.287.130-FF-000063', NULL, 'Hybrid sensor histidine kinase/response regulator', 105, NULL, NULL, 206275),
(206276, '2.120.10.30-FF-000006', NULL, 'Teneurin transmembrane protein 4', 165, NULL, NULL, 206276),
(206277, '2.40.50.140-FF-000568', NULL, 'Uncharacterized protein', 167, NULL, NULL, 206277),
(206278, '2.60.450.10-FF-000010', NULL, 'Lipopolysaccharide export system protein LptC', 128, NULL, NULL, 206278);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(206279, '3.40.50.970-FF-000055', NULL, '2-oxoisovalerate dehydrogenase subunit alpha', 390, NULL, NULL, 206279),
(206280, '3.30.1330.60-FF-000035', NULL, 'Outer membrane insertion signal domain protein', 132, NULL, NULL, 206280),
(206281, '1.20.58.1310-FF-000004', NULL, NULL, 58, NULL, NULL, 206281),
(206282, '3.40.50.2300-FF-000588', NULL, 'Catabolite repressor-activator, DNA-binding transcriptional dual regulator', 176, NULL, NULL, 206282),
(206283, '2.60.40.10-FF-001955', NULL, 'SLAM family member 8', 90, NULL, NULL, 206283),
(206284, '3.20.20.150-FF-000004', NULL, 'Mannonate dehydratase', 222, NULL, NULL, 206284),
(206285, '3.50.50.60-FF-000709', NULL, 'Reductase/halogenase', 411, NULL, NULL, 206285),
(206286, '3.30.420.40-FF-001094', NULL, 'Predicted gene 28778', 80, NULL, NULL, 206286),
(206287, '2.70.40.10-FF-000016', NULL, 'Deoxyuridine 5-triphosphate nucleotidohydrolase domain containing protein', 142, NULL, NULL, 206287),
(206288, '2.130.10.10-FF-004985', NULL, 'Uncharacterized protein', 77, NULL, NULL, 206288),
(206289, '3.90.190.10-FF-000069', NULL, 'Phosphoglucan phosphatase DSP4, chloroplastic', 190, NULL, NULL, 206289),
(206290, '3.40.1690.20-FF-000025', NULL, 'Uncharacterized protein', 89, NULL, NULL, 206290),
(206291, '3.30.300.20-FF-000050', NULL, 'Transcription termination/antitermination protein NusA', 64, NULL, NULL, 206291),
(206292, '1.10.630.10-FF-000269', NULL, 'Cytochrome P450', 438, NULL, NULL, 206292),
(206293, '2.80.10.50-FF-000071', NULL, 'Doublecortin domain containing 1', 124, NULL, NULL, 206293),
(206294, '2.130.10.10-FF-004204', NULL, 'Protein CBG07523', 157, NULL, NULL, 206294),
(206295, '3.30.160.60-FF-001904', NULL, 'Zinc finger protein 677', 30, NULL, NULL, 206295),
(206296, '3.10.250.10-FF-000058', NULL, 'Uncharacterized protein', 56, NULL, NULL, 206296),
(206297, '2.60.120.260-FF-000129', NULL, 'Laminin subunit gamma 1', 171, NULL, NULL, 206297),
(206298, '2.60.40.150-FF-000773', NULL, 'Uncharacterized protein', 108, NULL, NULL, 206298),
(206299, '1.10.1440.10-FF-000001', NULL, 'Apolipoprotein C-II', 79, NULL, NULL, 206299),
(206300, '2.60.40.10-FF-003400', NULL, NULL, 145, NULL, NULL, 206300),
(206301, '2.60.120.10-FF-000137', NULL, '(S)-ureidoglycine aminohydrolase', 266, NULL, NULL, 206301),
(206302, '1.20.1250.20-FF-000341', NULL, 'Sialic acid transporter', 400, NULL, NULL, 206302),
(206303, '1.50.40.10-FF-000002', NULL, 'Putative ADP/ATP translocase 2-like', 296, NULL, NULL, 206303),
(206304, '1.25.50.20-FF-000008', NULL, 'aminopeptidase N isoform X1', 322, NULL, NULL, 206304),
(206305, '3.30.200.20-FF-000941', NULL, 'Ribosomal protein S6 kinase alpha-3', 66, NULL, NULL, 206305),
(206306, '3.30.930.10-FF-000218', NULL, 'ATP phosphoribosyltransferase regulatory subunit', 326, NULL, NULL, 206306),
(206307, '2.30.42.10-FF-000640', NULL, NULL, 61, NULL, NULL, 206307),
(206308, '3.40.50.300-FF-007144', NULL, 'Uncharacterized protein', 177, NULL, NULL, 206308),
(206309, '2.20.25.10-FF-000062', NULL, 'Alkylphosphonate utilization protein', 39, NULL, NULL, 206309),
(206310, '3.40.50.1820-FF-001843', NULL, 'Uncharacterized protein', 77, NULL, NULL, 206310),
(206311, '3.30.40.10-FF-000639', NULL, 'E3 ubiquitin-protein ligase PEP5', 81, NULL, NULL, 206311),
(206312, '3.30.160.60-FF-003951', NULL, 'Maternal gene required for meiosis, isoform H', 72, NULL, NULL, 206312),
(206313, '3.40.50.11260-FF-000037', NULL, 'Uncharacterized protein', 35, NULL, NULL, 206313),
(206314, '3.90.70.80-FF-000013', NULL, 'OTU domain-containing protein 4', 137, NULL, NULL, 206314),
(206315, '3.20.20.100-FF-000113', NULL, 'Aldo/keto reductase', 268, NULL, NULL, 206315),
(206316, '3.40.605.10-FF-000039', NULL, 'Succinate-semialdehyde dehydrogenase', 67, NULL, NULL, 206316),
(206317, '3.30.450.60-FF-000050', NULL, 'Coatomer zeta subunit', 132, NULL, NULL, 206317),
(206318, '3.30.60.20-FF-000059', NULL, 'Tensin 2', 64, NULL, NULL, 206318),
(206319, '1.20.120.610-FF-000019', NULL, 'Uncharacterized protein', 87, NULL, NULL, 206319),
(206320, '2.40.50.140-FF-001187', NULL, NULL, 140, NULL, NULL, 206320);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(206321, '1.25.40.20-FF-000053', NULL, 'caskin-2 isoform X1', 51, NULL, NULL, 206321),
(206322, '1.10.20.10-FF-000014', NULL, 'Histone H2B', 128, NULL, NULL, 206322),
(206323, '1.10.1600.10-FF-000019', NULL, 'DNA binding protein', 118, NULL, NULL, 206323),
(206324, '3.90.1150.10-FF-000234', NULL, 'Cystathionine gamma-synthase', 137, NULL, NULL, 206324),
(206325, '3.40.50.300-FF-000332', NULL, 'DNA repair and recombination protein RAD54-like', 199, NULL, NULL, 206325),
(206326, '1.25.40.10-FF-000196', NULL, 'Pentatricopeptide repeat-containing protein At4g14850', 101, NULL, NULL, 206326),
(206327, '3.90.79.10-FF-000248', NULL, 'Uncharacterized protein', 151, NULL, NULL, 206327),
(206328, '1.10.510.10-FF-001278', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase', 223, NULL, NULL, 206328),
(206329, '3.10.450.40-FF-000054', NULL, NULL, 108, NULL, NULL, 206329),
(206330, '3.30.160.60-FF-004940', NULL, NULL, 43, NULL, NULL, 206330),
(206331, '3.30.70.3290-FF-000016', NULL, 'Lovastatin nonaketide synthase, polyketide synthase component', 139, NULL, NULL, 206331),
(206332, '1.25.40.20-FF-001834', NULL, 'Predicted protein', 147, NULL, NULL, 206332),
(206333, '3.60.21.10-FF-000459', NULL, 'Serine/threonine-protein phosphatase', 166, NULL, NULL, 206333),
(206334, '3.20.20.70-FF-000780', NULL, NULL, 78, NULL, NULL, 206334),
(206335, '1.10.10.10-FF-000997', NULL, 'Transcriptional regulator, ArsR family', 97, NULL, NULL, 206335),
(206336, '3.30.1370.10-FF-000236', NULL, 'Uncharacterized protein', 62, NULL, NULL, 206336),
(206337, '3.40.50.720-FF-002172', NULL, 'Uncharacterized protein', 68, NULL, NULL, 206337),
(206338, '2.60.40.10-FF-005637', NULL, NULL, 95, NULL, NULL, 206338),
(206339, '1.10.287.110-FF-000214', NULL, 'DnaJ domain containing protein', 78, NULL, NULL, 206339),
(206340, '1.25.40.10-FF-004248', NULL, 'Pentatricopeptide repeat-containing protein At4g16470', 235, NULL, NULL, 206340),
(206341, '3.90.1410.10-FF-000142', NULL, 'Uncharacterized protein', 92, NULL, NULL, 206341),
(206342, '3.30.70.330-FF-002634', NULL, NULL, 124, NULL, NULL, 206342),
(206343, '1.10.10.10-FF-001677', NULL, 'ETS translocation variant 3', 128, NULL, NULL, 206343),
(206344, '3.30.160.60-FF-004468', NULL, NULL, 26, NULL, NULL, 206344),
(206345, '3.50.50.60-FF-001328', NULL, 'Predicted protein', 131, NULL, NULL, 206345),
(206346, '2.20.70.10-FF-000267', NULL, 'E3 ubiquitin-protein ligase HECW2-like Protein', 38, NULL, NULL, 206346),
(206347, '3.80.10.10-FF-002294', NULL, 'Mhp1p', 328, NULL, NULL, 206347),
(206348, '1.10.238.20-FF-000046', NULL, 'general odorant-binding protein 99a-like isoform X2', 114, NULL, NULL, 206348),
(206349, '1.20.58.400-FF-000019', NULL, 'Vesicle transport through interaction with t-SNAREs 1B', 95, NULL, NULL, 206349),
(206350, '3.30.160.60-FF-002540', NULL, 'Zinc finger protein Nv-ZicE', 85, NULL, NULL, 206350),
(206351, '2.30.29.30-FF-000284', NULL, 'pleckstrin homology domain-containing family H member 3 isoform X2', 102, NULL, NULL, 206351),
(206352, '3.40.50.2300-FF-000812', NULL, NULL, 133, NULL, NULL, 206352),
(206353, '3.30.70.3270-FF-000010', NULL, 'NADH-quinone oxidoreductase subunit I', 117, NULL, NULL, 206353),
(206354, '2.170.130.10-FF-000066', NULL, NULL, 157, NULL, NULL, 206354),
(206355, '3.10.20.30-FF-000105', NULL, NULL, 58, NULL, NULL, 206355),
(206356, '3.30.2130.10-FF-000016', NULL, 'Chromosome 1, whole genome shotgun sequence', 134, NULL, NULL, 206356),
(206357, '1.10.472.80-FF-000164', NULL, NULL, 140, NULL, NULL, 206357),
(206358, '3.40.50.2000-FF-000812', NULL, 'UDP-glycosyltransferase 73D1', 191, NULL, NULL, 206358),
(206359, '3.10.350.10-FF-000094', NULL, 'Predicted protein', 43, NULL, NULL, 206359),
(206360, '3.30.460.10-FF-000114', NULL, 'ATPase synthesis protein 25, mitochondrial', 128, NULL, NULL, 206360),
(206361, '3.30.70.340-FF-000030', NULL, NULL, 80, NULL, NULL, 206361),
(206362, '1.20.120.550-FF-000007', NULL, 'Leukotriene C4 synthase', 90, NULL, NULL, 206362),
(206363, '3.30.470.30-FF-000048', NULL, 'RNA guanylyltransferase, putative', 188, NULL, NULL, 206363);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(206364, '3.30.50.10-FF-000128', NULL, 'Peroxisome proliferator activated receptor delta', 75, NULL, NULL, 206364),
(206365, '2.130.10.10-FF-003524', NULL, 'Small nucleolar ribonucleoprotein complex subunit Dip2, putative', 144, NULL, NULL, 206365),
(206366, '3.40.50.150-FF-001450', NULL, NULL, 140, NULL, NULL, 206366),
(206367, '3.30.160.60-FF-002995', NULL, 'Zinc-finger protein at 72d', 39, NULL, NULL, 206367),
(206368, '3.30.70.330-FF-000173', NULL, 'polypyrimidine tract-binding protein 2 isoform X2', 108, NULL, NULL, 206368),
(206369, '3.30.420.40-FF-000475', NULL, 'EryA, erythritol kinase', 248, NULL, NULL, 206369),
(206370, '3.90.190.10-FF-000541', NULL, 'Uncharacterized protein', 159, NULL, NULL, 206370),
(206371, '3.40.50.1240-FF-000129', NULL, '6-phosphofructo-2-kinase/fructose-2, 6-biphosphatase, putative', 201, NULL, NULL, 206371),
(206372, '3.40.50.1820-FF-000062', NULL, 'Platelet-activating factor acetylhydrolase', 382, NULL, NULL, 206372),
(206373, '3.40.50.300-FF-008100', NULL, 'Uncharacterized protein', 110, NULL, NULL, 206373),
(206374, '1.10.1040.10-FF-000055', NULL, '2-dehydropantoate 2-reductase', 127, NULL, NULL, 206374),
(206375, '3.30.160.60-FF-004777', NULL, NULL, 60, NULL, NULL, 206375),
(206376, '3.40.140.100-FF-000011', NULL, 'Ubiquitin-like modifier-activating enzyme ATG7', 138, NULL, NULL, 206376),
(206377, '3.50.50.60-FF-000491', NULL, 'Pyruvate Dehydrogenase Phosphatase Regulatory subunit', 214, NULL, NULL, 206377),
(206378, '2.120.10.30-FF-000506', NULL, 'Uncharacterized protein', 208, NULL, NULL, 206378),
(206379, '3.40.250.10-FF-000023', NULL, 'Dual specificity protein phosphatase', 141, NULL, NULL, 206379),
(206380, '1.20.1270.60-FF-000096', NULL, 'Unplaced genomic scaffold supercont2.2, whole genome shotgun sequence', 225, NULL, NULL, 206380),
(206381, '3.40.50.2000-FF-000279', NULL, 'Lipopolysaccharide core biosynthesis protein', 178, NULL, NULL, 206381),
(206382, '3.30.46.10-FF-000006', NULL, 'Uncharacterized protein', 16, NULL, NULL, 206382),
(206383, '3.40.50.300-FF-000023', NULL, 'Voltage-dependent L-type calcium channel subunit beta-2', 198, NULL, NULL, 206383),
(206384, '3.40.47.10-FF-000199', NULL, NULL, 70, NULL, NULL, 206384),
(206385, '3.30.470.10-FF-000042', NULL, '4-amino-4-deoxychorismate lyase', 90, NULL, NULL, 206385),
(206386, '3.30.160.60-FF-005749', NULL, NULL, 36, NULL, NULL, 206386),
(206387, '2.60.120.200-FF-000792', NULL, 'Galectin', 73, NULL, NULL, 206387),
(206388, '3.40.50.300-FF-006964', NULL, 'Uncharacterized protein', 312, NULL, NULL, 206388),
(206389, '3.20.140.10-FF-000031', NULL, 'Nicotinate phosphoribosyltransferase 2', 42, NULL, NULL, 206389),
(206390, '3.40.50.300-FF-003249', NULL, 'Putative U5 small nuclear ribonucleoprotein 200 kDa helicase', 210, NULL, NULL, 206390),
(206391, '1.10.150.20-FF-000207', NULL, 'UvrABC system protein C', 58, NULL, NULL, 206391),
(206392, '3.90.1750.10-FF-000100', NULL, 'Uncharacterized protein', 85, NULL, NULL, 206392),
(206393, '1.10.238.10-FF-001206', NULL, 'Uncharacterized protein', 74, NULL, NULL, 206393),
(206394, '1.25.10.10-FF-002285', NULL, 'Pkp2 protein', 329, NULL, NULL, 206394),
(206395, '3.60.21.10-FF-000004', NULL, 'Serine/threonine-protein phosphatase', 306, NULL, NULL, 206395),
(206396, '1.25.40.10-FF-003422', NULL, 'Putative suppressor of g2 allele of skp1', 130, NULL, NULL, 206396),
(206397, '1.20.1300.20-FF-000014', NULL, 'Uncharacterized protein', 145, NULL, NULL, 206397),
(206398, '1.10.238.110-FF-000014', NULL, 'Diacylglycerol kinase', 35, NULL, NULL, 206398),
(206399, '3.40.630.30-FF-000210', NULL, 'Beta-N-acetylglucosaminidase, putative', 202, NULL, NULL, 206399),
(206400, '1.20.58.60-FF-000284', NULL, 'VAB-10A protein', 109, NULL, NULL, 206400),
(206401, '1.10.275.20-FF-000002', NULL, 'Peroxisomal carnitine O-octanoyltransferase', 99, NULL, NULL, 206401),
(206402, '2.60.120.10-FF-000507', NULL, 'cGMP-dependent protein kinase', 99, NULL, NULL, 206402),
(206403, '3.40.50.300-FF-000787', NULL, 'Protein translocase subunit SecA', 270, NULL, NULL, 206403),
(206404, '1.20.120.350-FF-000054', NULL, 'voltage-gated hydrogen channel 1', 128, NULL, NULL, 206404);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(206405, '2.170.120.12-FF-000006', NULL, 'DNA-directed RNA polymerase alpha chain, putative', 130, NULL, NULL, 206405),
(206406, '3.40.50.10810-FF-000195', NULL, 'E3 ubiquitin-protein ligase SHPRH-like Protein', 217, NULL, NULL, 206406),
(206407, '3.30.1680.10-FF-000029', NULL, 'Semaphorin 3B', 51, NULL, NULL, 206407),
(206408, '3.30.200.20-FF-002414', NULL, 'Predicted protein', 87, NULL, NULL, 206408),
(206409, '2.120.10.80-FF-000370', NULL, 'Tip elongation aberrant protein 3', 175, NULL, NULL, 206409),
(206410, '2.60.40.4370-FF-000002', NULL, 'Transcription factor TFIIIC, tau55-related protein', 122, NULL, NULL, 206410),
(206411, '3.40.50.1820-FF-001343', NULL, 'Probable thioesterase', 247, NULL, NULL, 206411),
(206412, '2.10.25.10-FF-000040', NULL, 'Stabilin 2', 43, NULL, NULL, 206412),
(206413, '3.40.50.410-FF-000365', NULL, 'Type IV pili system adhesin PilY', 212, NULL, NULL, 206413),
(206414, '2.30.30.940-FF-000003', NULL, 'DNA helicase B', 80, NULL, NULL, 206414),
(206415, '1.10.510.10-FF-001811', NULL, 'Cyclin-dependent kinase B1-1', 105, NULL, NULL, 206415),
(206416, '3.40.50.10320-FF-000008', NULL, 'N-acetylglucosaminyl-phosphatidylinositol de-N-acetylase', 247, NULL, NULL, 206416),
(206417, '3.30.470.20-FF-000180', NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', 138, NULL, NULL, 206417),
(206418, '2.40.110.10-FF-000079', NULL, 'Uncharacterized protein', 56, NULL, NULL, 206418),
(206419, '1.20.120.230-FF-000001', NULL, 'Breast cancer anti-estrogen resistance 1', 136, NULL, NULL, 206419),
(206420, '2.170.130.10-FF-000049', NULL, 'SusC/RagA family TonB-linked outer membrane protein', 141, NULL, NULL, 206420),
(206421, '3.40.50.720-FF-001975', NULL, 'Predicted protein', 250, NULL, NULL, 206421),
(206422, '1.25.40.660-FF-000009', NULL, 'Vacuolar protein sorting-associated protein 35', 312, NULL, NULL, 206422),
(206423, '3.20.20.80-FF-000209', NULL, 'Glycoside hydrolase family 25', 216, NULL, NULL, 206423),
(206424, '3.30.710.10-FF-000207', NULL, 'BTB/POZ domain-containing protein', 150, NULL, NULL, 206424),
(206425, '1.20.1280.50-FF-000065', NULL, 'F-box protein SKIP23', 43, NULL, NULL, 206425),
(206426, '3.30.450.20-FF-000628', NULL, 'Putative regulatory protein', 131, NULL, NULL, 206426),
(206427, '3.40.50.300-FF-001304', NULL, 'DNA helicase INO80', 241, NULL, NULL, 206427),
(206428, '1.20.58.100-FF-000019', NULL, NULL, 108, NULL, NULL, 206428),
(206429, '3.30.565.10-FF-000285', NULL, 'Sensor histidine kinase', 143, NULL, NULL, 206429),
(206430, '3.90.226.10-FF-000259', NULL, 'Predicted protein', 174, NULL, NULL, 206430),
(206431, '3.100.10.10-FF-000003', NULL, '50S ribosomal protein L15', 70, NULL, NULL, 206431),
(206432, '3.30.1600.10-FF-000007', NULL, 'NAD-dependent protein lipoamidase sirtuin-4, mitochondrial', 126, NULL, NULL, 206432),
(206433, '3.30.310.80-FF-000029', NULL, 'MAP/microtubule affinity-regulating kinase 2a', 76, NULL, NULL, 206433),
(206434, '1.20.1250.20-FF-001330', NULL, 'Oligopeptide transporter, kidney isoform', 214, NULL, NULL, 206434),
(206435, '1.10.275.40-FF-000008', NULL, 'DNA repair helicase rad3/xp-D, putative', 20, NULL, NULL, 206435),
(206436, '3.40.50.150-FF-001107', NULL, NULL, 167, NULL, NULL, 206436),
(206437, '3.40.50.720-FF-000694', NULL, 'Zinc-dependent alcohol dehydrogenase', 138, NULL, NULL, 206437),
(206438, '2.40.50.140-FF-000259', NULL, 'RNA polymerase Rpb7 N-terminal domain-containing protein', 114, NULL, NULL, 206438),
(206439, '1.10.10.10-FF-000749', NULL, 'DNA-binding response regulator', 96, NULL, NULL, 206439),
(206440, '1.10.150.240-FF-000029', NULL, 'Haloacid dehalogenase-like hydrolase family protein', 65, NULL, NULL, 206440),
(206441, '3.40.50.1820-FF-000871', NULL, 'Uncharacterized protein', 304, NULL, NULL, 206441),
(206442, '1.20.140.150-FF-000094', NULL, 'germ cell-specific gene 1-like protein', 69, NULL, NULL, 206442),
(206443, '3.20.20.220-FF-000020', NULL, 'Probable proline dehydrogenase', 293, NULL, NULL, 206443),
(206444, '3.40.30.10-FF-000352', NULL, 'Magnesium transporter protein 1', 171, NULL, NULL, 206444); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(206445, '3.40.430.10-FF-000043', NULL, 'Bifunctional dihydrofolate reductase-thymidylate synthase', 189, NULL, NULL, 206445),
(206446, '3.60.15.10-FF-000063', NULL, 'tRNA processing endoribonuclease Trz1, putative', 319, NULL, NULL, 206446),
(206447, '1.20.1600.10-FF-000040', NULL, 'Outer membrane efflux protein', 414, NULL, NULL, 206447),
(206448, '1.25.40.10-FF-004883', NULL, 'Uncharacterized protein', 102, NULL, NULL, 206448),
(206449, '1.20.5.110-FF-000348', NULL, 'Synaptosome-associated protein 29', 32, NULL, NULL, 206449),
(206450, '1.50.40.10-FF-000441', NULL, 'Predicted protein', 158, NULL, NULL, 206450),
(206451, '2.60.40.10-FF-000174', NULL, 'Nuclear factor of activated T-cells 5, tonicity-responsive', 108, NULL, NULL, 206451),
(206452, '1.10.287.130-FF-000080', NULL, 'Sensor histidine kinase/response regulator EvgS', 85, NULL, NULL, 206452),
(206453, '1.20.1250.20-FF-001622', NULL, 'Transporter, putative', 149, NULL, NULL, 206453),
(206454, '1.10.3160.10-FF-000002', NULL, 'P35 antigen', 201, NULL, NULL, 206454),
(206455, '3.30.70.940-FF-000013', NULL, 'Transcription elongation regulator-like protein', 110, NULL, NULL, 206455),
(206456, '3.10.129.110-FF-000005', NULL, 'Phenolpthiocerol synthesis type-I polyketide synthase ppsD', 287, NULL, NULL, 206456),
(206457, '1.10.30.10-FF-000088', NULL, 'Sex-determining region Y protein', 50, NULL, NULL, 206457),
(206458, '1.20.1250.20-FF-000796', NULL, 'Related to siderophore iron transporter mirc', 280, NULL, NULL, 206458),
(206459, '2.60.120.650-FF-000156', NULL, 'Uncharacterized protein', 285, NULL, NULL, 206459),
(206460, '2.60.40.2400-FF-000001', NULL, 'Structural polyprotein', 87, NULL, NULL, 206460),
(206461, '3.40.718.10-FF-000054', NULL, 'Isocitrate dehydrogenase 3 (NAD+) beta', 80, NULL, NULL, 206461),
(206462, '1.10.520.20-FF-000005', NULL, 'ATP synthase subunit delta, chloroplastic', 105, NULL, NULL, 206462),
(206463, '1.25.40.20-FF-001704', NULL, 'LOC100005699 protein', 237, NULL, NULL, 206463),
(206464, '3.30.160.60-FF-003849', NULL, NULL, 27, NULL, NULL, 206464),
(206465, '3.40.50.720-FF-000238', NULL, 'UDP-glucose 4-epimerase', 216, NULL, NULL, 206465),
(206466, '3.40.5.10-FF-000007', NULL, '50S ribosomal protein L9', 63, NULL, NULL, 206466),
(206467, '2.60.40.10-FF-004491', NULL, NULL, 99, NULL, NULL, 206467),
(206468, '3.40.50.200-FF-000111', NULL, 'Neuroendocrine convertase 1', 326, NULL, NULL, 206468),
(206469, '1.25.40.10-FF-002983', NULL, 'AGAP010587-PA', 147, NULL, NULL, 206469),
(206470, '1.20.58.2220-FF-000018', NULL, 'Formin 2', 169, NULL, NULL, 206470),
(206471, '2.30.42.10-FF-000623', NULL, NULL, 79, NULL, NULL, 206471),
(206472, '2.40.10.10-FF-000639', NULL, NULL, 186, NULL, NULL, 206472),
(206473, '3.30.428.10-FF-000017', NULL, 'Aprataxin-like protein', 212, NULL, NULL, 206473),
(206474, '1.25.10.10-FF-001666', NULL, 'YALI0D01199p', 327, NULL, NULL, 206474),
(206475, '1.10.10.60-FF-000287', NULL, 'TSL-kinase interacting protein 1', 62, NULL, NULL, 206475),
(206476, '1.10.8.770-FF-000003', NULL, 'Methylenetetrahydrofolate dehydrogenase (NADP+-dependent) 1a, methenyltetrahydrofolate cyclohydrolase, formyltetrahydrofolate synthetase', 62, NULL, NULL, 206476),
(206477, '3.40.850.10-FF-000474', NULL, 'Kinesin-like protein', 351, NULL, NULL, 206477),
(206478, '3.40.50.620-FF-000343', NULL, 'Glutamate--tRNA ligase', 357, NULL, NULL, 206478),
(206479, '3.40.50.10140-FF-000078', NULL, 'Interleukin 1 receptor accessory protein-like 2', 45, NULL, NULL, 206479),
(206480, '1.10.150.50-FF-000194', NULL, 'AFR092Wp', 92, NULL, NULL, 206480),
(206481, '3.30.70.330-FF-003118', NULL, NULL, 51, NULL, NULL, 206481),
(206482, '3.10.200.10-FF-000010', NULL, 'Carbonic anhydrase', 244, NULL, NULL, 206482),
(206483, '1.25.40.10-FF-004591', NULL, 'Uncharacterized protein', 172, NULL, NULL, 206483),
(206484, '2.60.120.340-FF-000018', NULL, 'Uncharacterized protein', 100, NULL, NULL, 206484),
(206485, '1.20.5.110-FF-000320', NULL, 'Protein CBG26242', 42, NULL, NULL, 206485),
(206486, '2.130.10.10-FF-000298', NULL, 'Intraflagellar transport 80 homolog (Chlamydomonas)', 169, NULL, NULL, 206486);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(206487, '3.40.50.300-FF-004047', NULL, 'Nuclear VCP-like', 105, NULL, NULL, 206487),
(206488, '3.40.50.1820-FF-001051', NULL, 'Carboxypeptidase', 426, NULL, NULL, 206488),
(206489, '1.20.58.60-FF-000104', NULL, 'Nesprin-1 isoform 1', 108, NULL, NULL, 206489),
(206490, '1.20.1250.20-FF-000824', NULL, 'Transporter, major facilitator family protein', 437, NULL, NULL, 206490),
(206491, '2.60.34.10-FF-000053', NULL, 'Hypoxia up-regulated 1', 158, NULL, NULL, 206491),
(206492, '3.75.10.10-FF-000030', NULL, NULL, 94, NULL, NULL, 206492),
(206493, '3.30.200.20-FF-000469', NULL, 'Spore coat protein YsxE', 92, NULL, NULL, 206493),
(206494, '3.30.200.20-FF-001897', NULL, 'CMGC family protein kinase', 99, NULL, NULL, 206494),
(206495, '2.130.10.10-FF-002759', NULL, 'WD repeat-containing protein 93', 253, NULL, NULL, 206495),
(206496, '2.30.30.140-FF-000123', NULL, 'Chromatin modification-related protein EAF3', 121, NULL, NULL, 206496),
(206497, '2.60.120.200-FF-000353', NULL, 'Vesicular integral membrane protein VIP36, putative', 229, NULL, NULL, 206497),
(206498, '2.10.25.10-FF-000832', NULL, 'Delta-like protein', 38, NULL, NULL, 206498),
(206499, '3.20.20.60-FF-000007', NULL, 'Phosphoenolpyruvate-protein phosphotransferase', 337, NULL, NULL, 206499),
(206500, '2.40.50.40-FF-000100', NULL, 'Chromodomain-helicase-DNA-binding protein 3', 58, NULL, NULL, 206500),
(206501, '1.20.1160.20-FF-000025', NULL, 'Uncharacterized protein', 50, NULL, NULL, 206501),
(206502, '1.25.40.280-FF-000007', NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', 363, NULL, NULL, 206502),
(206503, '2.60.120.40-FF-000022', NULL, 'Tumor necrosis factor ligand superfamily member 12', 154, NULL, NULL, 206503),
(206504, '3.40.630.30-FF-000238', NULL, 'Ribosomal-protein-alanine N-acetyltransferase', 163, NULL, NULL, 206504),
(206505, '3.90.70.10-FF-000728', NULL, 'Cysteine endopeptidase', 183, NULL, NULL, 206505),
(206506, '1.25.40.10-FF-000549', NULL, 'Uncharacterized protein, isoform B', 124, NULL, NULL, 206506),
(206507, '3.10.450.40-FF-000037', NULL, 'Amine oxidase', 112, NULL, NULL, 206507),
(206508, '1.10.287.70-FF-000011', NULL, 'Potassium channel, voltage-gated Shaw-related subfamily C, member 4', 117, NULL, NULL, 206508),
(206509, '1.10.486.10-FF-000057', NULL, 'ATP-dependent 3''-5'' DNA helicase', 161, NULL, NULL, 206509),
(206510, '2.130.10.10-FF-001450', NULL, 'RE05579p', 245, NULL, NULL, 206510),
(206511, '3.40.50.720-FF-002155', NULL, 'Uncharacterized protein', 81, NULL, NULL, 206511),
(206512, '2.30.29.30-FF-000312', NULL, 'Ran binding protein 1', 157, NULL, NULL, 206512),
(206513, '3.40.640.10-FF-000317', NULL, 'Kynureninase', 253, NULL, NULL, 206513),
(206514, '3.40.50.720-FF-001183', NULL, 'Ornithine cyclodeaminase', 163, NULL, NULL, 206514),
(206515, '3.30.160.60-FF-003288', NULL, 'Uncharacterized protein', 34, NULL, NULL, 206515),
(206516, '2.30.30.550-FF-000009', NULL, NULL, 50, NULL, NULL, 206516),
(206517, '3.30.160.60-FF-001612', NULL, 'MEP-1, isoform A', 91, NULL, NULL, 206517),
(206518, '3.50.50.60-FF-001345', NULL, 'Uncharacterized protein', 38, NULL, NULL, 206518),
(206519, '1.20.85.10-FF-000017', NULL, 'Uncharacterized protein', 55, NULL, NULL, 206519),
(206520, '1.10.238.20-FF-000029', NULL, 'AGAP008278-PA', 149, NULL, NULL, 206520),
(206521, '2.60.120.650-FF-000139', NULL, 'Protein Jumonji', 277, NULL, NULL, 206521),
(206522, '3.30.70.1730-FF-000003', NULL, '50S ribosomal protein L10', 125, NULL, NULL, 206522),
(206523, '1.20.920.30-FF-000048', NULL, 'Dynein heavy chain domain 1', 142, NULL, NULL, 206523),
(206524, '2.120.10.30-FF-000478', NULL, 'Uncharacterized protein', 323, NULL, NULL, 206524),
(206525, '2.60.40.10-FF-003872', NULL, NULL, 133, NULL, NULL, 206525),
(206526, '3.30.70.330-FF-000965', NULL, 'Peroxisome proliferator-activated receptor gamma, coactivator 1 beta', 91, NULL, NULL, 206526),
(206527, '1.10.10.10-FF-001694', NULL, 'Vacuolar membrane-associated protein IML1', 167, NULL, NULL, 206527),
(206528, '2.60.40.420-FF-000197', NULL, 'Early nodulin-like protein 2', 81, NULL, NULL, 206528);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(206529, '2.170.120.30-FF-000015', NULL, 'YbbR family protein', 113, NULL, NULL, 206529),
(206530, '3.40.50.720-FF-000255', NULL, 'Methylenetetrahydrofolate dehydrogenase', 152, NULL, NULL, 206530),
(206531, '3.30.60.30-FF-000051', NULL, 'LOW QUALITY PROTEIN: tomoregulin-1', 42, NULL, NULL, 206531),
(206532, '1.10.510.10-FF-002430', NULL, NULL, 153, NULL, NULL, 206532),
(206533, '3.60.40.10-FF-000368', NULL, 'Uncharacterized protein', 261, NULL, NULL, 206533),
(206534, '1.10.10.10-FF-000188', NULL, 'HTH-type transcriptional regulator LeuO', 87, NULL, NULL, 206534),
(206535, '1.10.472.80-FF-000208', NULL, NULL, 159, NULL, NULL, 206535),
(206536, '2.60.40.60-FF-001037', NULL, 'Uncharacterized protein', 115, NULL, NULL, 206536),
(206537, '2.60.40.180-FF-000006', NULL, 'Probable 5-hydroxyisourate hydrolase', 138, NULL, NULL, 206537),
(206538, '1.10.3080.10-FF-000029', NULL, 'Chloride channel protein', 498, NULL, NULL, 206538),
(206539, '3.40.718.10-FF-000071', NULL, 'Isocitrate dehydrogenase [NADP]', 99, NULL, NULL, 206539),
(206540, '3.30.160.60-FF-003512', NULL, NULL, 27, NULL, NULL, 206540),
(206541, '1.25.40.10-FF-002803', NULL, 'Tetratricopeptide repeat (TPR)-containing protein', 393, NULL, NULL, 206541),
(206542, '3.30.160.60-FF-003821', NULL, NULL, 28, NULL, NULL, 206542),
(206543, '2.60.40.420-FF-000067', NULL, 'Cupredoxin superfamily protein', 105, NULL, NULL, 206543),
(206544, '1.10.357.20-FF-000002', NULL, 'Solute carrier family 41, member 2', 189, NULL, NULL, 206544),
(206545, '3.40.50.720-FF-000385', NULL, 'Aspartate kinase /homoserine dehydrogenase', 178, NULL, NULL, 206545),
(206546, '2.160.10.10-FF-000038', NULL, 'mRNA, clone: RTFL01-10-C12', 123, NULL, NULL, 206546),
(206547, '3.90.1200.10-FF-000087', NULL, 'Phosphotransferase, PolIIIAc domain-containing, putative', 201, NULL, NULL, 206547),
(206548, '2.170.140.10-FF-000022', NULL, 'Chondroitin proteoglycan-2', 63, NULL, NULL, 206548),
(206549, '1.20.1560.10-FF-000777', NULL, 'Putative multidrug resistance-associated protein lethal(2)03659-like Protein', 291, NULL, NULL, 206549),
(206550, '1.10.287.1490-FF-000101', NULL, 'Uncharacterized protein', 173, NULL, NULL, 206550),
(206551, '3.30.70.1050-FF-000013', NULL, 'Trigger factor', 125, NULL, NULL, 206551),
(206552, '3.40.50.300-FF-005227', NULL, 'Guanylate kinase', 202, NULL, NULL, 206552),
(206553, '3.30.465.10-FF-000092', NULL, 'D-lactate dehydrogenase', 146, NULL, NULL, 206553),
(206554, '1.25.40.10-FF-001494', NULL, 'Pentatricopeptide repeat-containing protein', 118, NULL, NULL, 206554),
(206555, '1.10.238.200-FF-000024', NULL, 'Defective in cullin neddylation protein', 118, NULL, NULL, 206555),
(206556, '1.10.1520.10-FF-000035', NULL, 'Chromosome 7, whole genome shotgun sequence', 226, NULL, NULL, 206556),
(206557, '1.20.120.350-FF-000071', NULL, 'Potassium voltage-gated channel protein shk-1', 164, NULL, NULL, 206557),
(206558, '2.130.10.30-FF-000045', NULL, 'Ultraviolet-B receptor UVR8', 377, NULL, NULL, 206558),
(206559, '1.10.630.10-FF-000140', NULL, 'Putative cytochrome P450 126', 413, NULL, NULL, 206559),
(206560, '2.130.10.10-FF-005632', NULL, 'Uncharacterized protein', 177, NULL, NULL, 206560),
(206561, '1.10.510.10-FF-001941', NULL, NULL, 56, NULL, NULL, 206561),
(206562, '3.30.160.60-FF-001051', NULL, 'zinc finger protein 768', 28, NULL, NULL, 206562),
(206563, '3.90.1150.80-FF-000002', NULL, 'Monopolin complex subunit CSM1', 108, NULL, NULL, 206563),
(206564, '3.40.1690.10-FF-000005', NULL, 'Flagellar biosynthesis protein FlhB', 138, NULL, NULL, 206564),
(206565, '3.40.630.30-FF-000547', NULL, 'Uncharacterized protein', 139, NULL, NULL, 206565),
(206566, '1.25.40.10-FF-000858', NULL, 'Pentatricopeptide repeat-containing protein At4g33990', 142, NULL, NULL, 206566),
(206567, '3.30.2020.30-FF-000020', NULL, 'Uncharacterized protein', 93, NULL, NULL, 206567),
(206568, '2.30.40.10-FF-000006', NULL, 'D-phenylhydantoinase', 84, NULL, NULL, 206568),
(206569, '3.30.200.20-FF-001234', NULL, 'Predicted protein', 105, NULL, NULL, 206569),
(206570, '3.40.50.300-FF-007583', NULL, 'LD21880p', 177, NULL, NULL, 206570);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(206571, '2.30.30.30-FF-000057', NULL, 'Transcription elongation factor SPT5', 51, NULL, NULL, 206571),
(206572, '3.20.20.100-FF-000085', NULL, 'Uncharacterized protein', 273, NULL, NULL, 206572),
(206573, '1.20.1560.10-FF-000114', NULL, 'ABC multidrug transporter Mdr1', 23, NULL, NULL, 206573),
(206574, '2.130.10.10-FF-001607', NULL, 'Cilia- and flagella-associated protein 44', 315, NULL, NULL, 206574),
(206575, '3.90.190.10-FF-000086', NULL, 'Protein tyrosine phosphatase-like protein', 157, NULL, NULL, 206575),
(206576, '3.90.640.10-FF-000031', NULL, 'Actin-related protein 4', 99, NULL, NULL, 206576),
(206577, '3.10.20.90-FF-000516', NULL, 'Inactive tyrosine-protein kinase kin-32', 97, NULL, NULL, 206577),
(206578, '2.160.20.10-FF-000292', NULL, 'Uncharacterized protein', 216, NULL, NULL, 206578),
(206579, '3.90.1290.10-FF-000053', NULL, 'Uncharacterized protein', 103, NULL, NULL, 206579),
(206580, '3.30.505.10-FF-000028', NULL, 'Suppressor of cytokine signaling 5', 171, NULL, NULL, 206580),
(206581, '3.40.50.1820-FF-000724', NULL, 'Carboxylic ester hydrolase', 264, NULL, NULL, 206581),
(206582, '3.30.1640.10-FF-000100', NULL, 'DNA replication licensing factor', 61, NULL, NULL, 206582),
(206583, '2.60.40.150-FF-000790', NULL, 'Protein CBG04254', 80, NULL, NULL, 206583),
(206584, '1.50.10.20-FF-000150', NULL, 'Murinoglobulin-2', 143, NULL, NULL, 206584),
(206585, '2.10.25.10-FF-001012', NULL, 'Uncharacterized protein', 44, NULL, NULL, 206585),
(206586, '3.40.190.10-FF-000344', NULL, 'Glutamate receptor', 34, NULL, NULL, 206586),
(206587, '1.10.510.10-FF-003256', NULL, NULL, 112, NULL, NULL, 206587),
(206588, '3.60.40.10-FF-000031', NULL, 'PAS sensor protein', 237, NULL, NULL, 206588),
(206589, '1.20.58.190-FF-000006', NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', 140, NULL, NULL, 206589),
(206590, '3.40.50.300-FF-006172', NULL, 'Predicted protein', 182, NULL, NULL, 206590),
(206591, '2.130.10.10-FF-000961', NULL, 'WD repeat domain phosphoinositide-interacting protein', 265, NULL, NULL, 206591),
(206592, '2.40.128.680-FF-000006', NULL, 'Uncharacterized protein', 113, NULL, NULL, 206592),
(206593, '1.20.920.10-FF-000042', NULL, 'RSC complex member', 110, NULL, NULL, 206593),
(206594, '3.30.420.10-FF-000331', NULL, 'Uncharacterized protein', 199, NULL, NULL, 206594),
(206595, '3.40.50.2300-FF-001105', NULL, 'Metabotropic glutamate receptor 3', 279, NULL, NULL, 206595),
(206596, '1.10.10.60-FF-000950', NULL, NULL, 69, NULL, NULL, 206596),
(206597, '3.40.50.620-FF-000782', NULL, 'Uncharacterized protein', 88, NULL, NULL, 206597),
(206598, '3.40.930.10-FF-000036', NULL, 'Anion exchange protein', 307, NULL, NULL, 206598),
(206599, '1.20.1280.50-FF-000048', NULL, 'F-box family protein-like', 87, NULL, NULL, 206599),
(206600, '3.10.20.90-FF-000207', NULL, 'Rhea, isoform B', 86, NULL, NULL, 206600),
(206601, '2.130.10.10-FF-000270', NULL, 'plexin-B3 isoform X3', 427, NULL, NULL, 206601),
(206602, '1.10.340.30-FF-000028', NULL, 'Mitochondrial glycosylase/lyase (Eurofung)', 126, NULL, NULL, 206602),
(206603, '1.10.10.10-FF-001486', NULL, 'Eukaryotic translation initiation factor 3 subunit K', 102, NULL, NULL, 206603),
(206604, '2.60.40.3510-FF-000008', NULL, 'Delta-like protein', 160, NULL, NULL, 206604),
(206605, '2.60.120.200-FF-000718', NULL, 'Uncharacterized protein', 372, NULL, NULL, 206605),
(206606, '3.90.1150.10-FF-000251', NULL, 'Aminotransferase', 109, NULL, NULL, 206606),
(206607, '2.70.50.30-FF-000028', NULL, NULL, 77, NULL, NULL, 206607),
(206608, '1.10.287.470-FF-000047', NULL, 'Putative periplasmic linker protein', 60, NULL, NULL, 206608),
(206609, '1.10.10.10-FF-000396', NULL, 'LysR family transcriptional regulator', 85, NULL, NULL, 206609),
(206610, '3.30.310.50-FF-000003', NULL, 'Phosphoacetylglucosamine mutase', 86, NULL, NULL, 206610),
(206611, '3.50.50.60-FF-000047', NULL, 'Nitric oxide reductase FlRd-NAD(+) reductase', 138, NULL, NULL, 206611),
(206612, '4.10.60.10-FF-000178', NULL, 'Uncharacterized protein', 38, NULL, NULL, 206612),
(206613, '1.10.10.10-FF-001014', NULL, 'Iron (Metal) dependent repressor, DtxR family', 131, NULL, NULL, 206613);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(206614, '1.20.1270.60-FF-000320', NULL, 'AGAP001369-PA', 177, NULL, NULL, 206614),
(206615, '1.10.10.1940-FF-000010', NULL, 'Metalloendopeptidase', 44, NULL, NULL, 206615),
(206616, '2.60.120.260-FF-000573', NULL, 'EPH receptor B6', 196, NULL, NULL, 206616),
(206617, '2.40.128.20-FF-000038', NULL, 'AGAP002594-PA', 179, NULL, NULL, 206617),
(206618, '3.30.160.60-FF-004485', NULL, NULL, 26, NULL, NULL, 206618),
(206619, '3.30.1390.30-FF-000013', NULL, NULL, 72, NULL, NULL, 206619),
(206620, '1.20.1050.90-FF-000009', NULL, 'DNA replication and repair protein RecF', 184, NULL, NULL, 206620),
(206621, '3.90.640.90-FF-000009', NULL, 'B-cell translocation gene 4', 69, NULL, NULL, 206621),
(206622, '1.10.390.10-FF-000071', NULL, 'Predicted protein', 88, NULL, NULL, 206622),
(206623, '3.30.70.3500-FF-000001', NULL, 'Chromosome partition protein MukB', 113, NULL, NULL, 206623),
(206624, '2.130.10.130-FF-000013', NULL, 'Glycosylphosphatidylinositol specific phospholipase D1', 227, NULL, NULL, 206624),
(206625, '1.10.287.40-FF-000013', NULL, 'Seryl-tRNA synthetase', 110, NULL, NULL, 206625),
(206626, '2.160.10.10-FF-000010', NULL, 'Glucose-1-phosphate adenylyltransferase', 135, NULL, NULL, 206626),
(206627, '3.30.420.40-FF-000666', NULL, 'Actin-related protein ARP9', 92, NULL, NULL, 206627),
(206628, '1.20.1070.10-FF-001083', NULL, 'Neuropeptide FF receptor 2', 323, NULL, NULL, 206628),
(206629, '1.20.58.390-FF-000033', NULL, 'Gamma-aminobutyric acid receptor subunit beta', 141, NULL, NULL, 206629),
(206630, '3.30.40.10-FF-000611', NULL, 'Zinc finger family protein', 73, NULL, NULL, 206630),
(206631, '3.80.10.10-FF-003002', NULL, 'Uncharacterized protein', 80, NULL, NULL, 206631),
(206632, '1.25.10.10-FF-001649', NULL, 'Proteasome activator complex subunit 4A', 393, NULL, NULL, 206632),
(206633, '2.130.10.10-FF-003496', NULL, 'SH3KBP1-binding protein 1', 262, NULL, NULL, 206633),
(206634, '2.130.10.10-FF-003395', NULL, 'Uncharacterized protein', 210, NULL, NULL, 206634),
(206635, '3.30.70.330-FF-000734', NULL, 'U2 snRNP auxiliary factor large subunit', 102, NULL, NULL, 206635),
(206636, '3.40.50.12160-FF-000015', NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase', 129, NULL, NULL, 206636),
(206637, '2.130.10.10-FF-003507', NULL, 'Plexin-A2', 461, NULL, NULL, 206637),
(206638, '3.80.10.10-FF-003575', NULL, 'Uncharacterized protein', 284, NULL, NULL, 206638),
(206639, '2.130.10.10-FF-001787', NULL, 'Dynein, cytoplasmic 1, intermediate chain 1', 173, NULL, NULL, 206639),
(206640, '3.40.720.10-FF-000099', NULL, 'Arylsulphatase A', 372, NULL, NULL, 206640),
(206641, '1.25.40.10-FF-002303', NULL, 'Pentatricopeptide repeat (PPR) superfamily protein', 142, NULL, NULL, 206641),
(206642, '4.10.900.10-FF-000032', NULL, 'Uncharacterized protein', 66, NULL, NULL, 206642),
(206643, '3.90.180.10-FF-000113', NULL, 'Geraniol dehydrogenase GeoA', 213, NULL, NULL, 206643),
(206644, '3.90.180.10-FF-000012', NULL, 'Quinone oxidoreductase yhdH', 132, NULL, NULL, 206644),
(206645, '3.40.50.300-FF-005019', NULL, 'Arsenical pump-driving ATPase', 329, NULL, NULL, 206645),
(206646, '2.60.40.10-FF-003372', NULL, NULL, 87, NULL, NULL, 206646),
(206647, '1.10.1820.10-FF-000002', NULL, 'Casein kinase II subunit beta', 105, NULL, NULL, 206647),
(206648, '3.40.50.150-FF-000270', NULL, 'RNA methylase family protein', 220, NULL, NULL, 206648),
(206649, '1.10.510.10-FF-004004', NULL, NULL, 172, NULL, NULL, 206649),
(206650, '1.10.10.790-FF-000013', NULL, 'Splicing factor 3A subunit 1', 58, NULL, NULL, 206650),
(206651, '1.25.40.180-FF-000320', NULL, NULL, 90, NULL, NULL, 206651),
(206652, '2.60.40.3210-FF-000025', NULL, 'Si:ch211-14a17.7', 105, NULL, NULL, 206652),
(206653, '3.30.200.20-FF-000486', NULL, 'Leucine-rich repeat receptor-like protein kinase', 93, NULL, NULL, 206653),
(206654, '3.40.50.720-FF-002464', NULL, 'Uncharacterized protein', 115, NULL, NULL, 206654),
(206655, '3.50.50.60-FF-000148', NULL, 'NAD-dependent dihydropyrimidine dehydrogenase subunit PreT', 122, NULL, NULL, 206655),
(206656, '3.40.1380.20-FF-000024', NULL, 'Pyruvate kinase', 163, NULL, NULL, 206656);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(206657, '3.80.10.10-FF-002046', NULL, 'Predicted protein', 256, NULL, NULL, 206657),
(206658, '4.10.400.10-FF-000140', NULL, 'Terribly reduced optic lobes, isoform AF', 41, NULL, NULL, 206658),
(206659, '1.10.150.240-FF-000001', NULL, 'Haloacid dehalogenase-like hydrolase domain', 68, NULL, NULL, 206659),
(206660, '3.30.200.20-FF-000014', NULL, 'Mitogen-activated protein kinase', 104, NULL, NULL, 206660),
(206661, '1.10.10.10-FF-000497', NULL, 'IclR family transcriptional regulator', 72, NULL, NULL, 206661),
(206662, '2.60.98.40-FF-000001', NULL, 'Major S-layer protein', 130, NULL, NULL, 206662),
(206663, '1.10.8.10-FF-000338', NULL, 'Uncharacterized protein', 71, NULL, NULL, 206663),
(206664, '3.30.1010.10-FF-000086', NULL, 'Atr1', 169, NULL, NULL, 206664),
(206665, '3.40.50.2300-FF-000251', NULL, 'Autoinducer 2 ABC transporter substrate-binding protein', 153, NULL, NULL, 206665),
(206666, '2.170.270.10-FF-000104', NULL, 'PR/SET domain 16', 36, NULL, NULL, 206666),
(206667, '2.40.50.140-FF-001007', NULL, NULL, 122, NULL, NULL, 206667),
(206668, '3.40.50.10480-FF-000011', NULL, 'Uncharacterized protein', 193, NULL, NULL, 206668),
(206669, '3.10.110.10-FF-000020', NULL, 'Ubiquitin-conjugating enzyme E2 N', 150, NULL, NULL, 206669),
(206670, '1.10.418.40-FF-000021', NULL, 'Uncharacterized protein', 117, NULL, NULL, 206670),
(206671, '3.20.20.80-FF-000709', NULL, 'Amylo-alpha-1,6-glucosidase family protein', 189, NULL, NULL, 206671),
(206672, '1.20.1530.20-FF-000031', NULL, 'Glutathione-regulated potassium-efflux system protein KefB', 362, NULL, NULL, 206672),
(206673, '3.30.40.10-FF-001230', NULL, 'Uncharacterized protein', 129, NULL, NULL, 206673),
(206674, '2.40.110.10-FF-000051', NULL, 'Isovaleryl-CoA dehydrogenase', 111, NULL, NULL, 206674),
(206675, '3.30.40.10-FF-000510', NULL, 'Phosphatidylinositol 3,5-kinase', 94, NULL, NULL, 206675),
(206676, '1.10.287.610-FF-000010', NULL, 'DNA ligase', 65, NULL, NULL, 206676),
(206677, '3.30.200.20-FF-001442', NULL, NULL, 84, NULL, NULL, 206677),
(206678, '2.30.29.30-FF-001138', NULL, 'Uncharacterized protein', 117, NULL, NULL, 206678),
(206679, '3.40.50.2000-FF-000796', NULL, 'Uncharacterized protein', 66, NULL, NULL, 206679),
(206680, '1.25.40.10-FF-003394', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 137, NULL, NULL, 206680),
(206681, '2.60.40.2150-FF-000005', NULL, 'Interleukin 17 receptor A2', 53, NULL, NULL, 206681),
(206682, '3.80.10.10-FF-003474', NULL, 'Leucine-rich repeat transmembrane protein FLRT2-like Protein', 210, NULL, NULL, 206682),
(206683, '1.20.120.150-FF-000011', NULL, 'Uncharacterized protein', 32, NULL, NULL, 206683),
(206684, '3.40.50.80-FF-000244', NULL, 'Os08g0453700 protein', 109, NULL, NULL, 206684),
(206685, '3.30.160.60-FF-001843', NULL, 'Zinc finger 30C', 27, NULL, NULL, 206685),
(206686, '3.30.830.10-FF-000042', NULL, 'Zinc metalloprotease, putative', 231, NULL, NULL, 206686),
(206687, '1.20.1560.10-FF-000586', NULL, 'Uncharacterized protein', 188, NULL, NULL, 206687),
(206688, '3.30.365.10-FF-000056', NULL, 'Uncharacterized protein', 136, NULL, NULL, 206688),
(206689, '3.10.129.10-FF-000057', NULL, 'ATP-binding Cassette (ABC) superfamily', 166, NULL, NULL, 206689),
(206690, '2.10.25.10-FF-001220', NULL, 'Usher syndrome 2A (autosomal recessive, mild)', 53, NULL, NULL, 206690),
(206691, '1.20.1560.10-FF-000013', NULL, 'ABC transporter C family member 2', 337, NULL, NULL, 206691),
(206692, '3.30.1330.30-FF-000037', NULL, '40S ribosomal protein S12', 120, NULL, NULL, 206692),
(206693, '1.10.510.10-FF-000777', NULL, 'CAMK family protein kinase', 338, NULL, NULL, 206693),
(206694, '1.10.510.10-FF-004476', NULL, NULL, 260, NULL, NULL, 206694),
(206695, '2.130.10.10-FF-003024', NULL, 'PWP2, small subunit processome component', 163, NULL, NULL, 206695),
(206696, '3.90.70.10-FF-000700', NULL, 'Uncharacterized protein', 219, NULL, NULL, 206696),
(206697, '1.20.1070.10-FF-000577', NULL, 'Frizzled homolog', 354, NULL, NULL, 206697),
(206698, '2.120.10.60-FF-000004', NULL, 'Putative Tricorn-like protease C-terminal subunit', 100, NULL, NULL, 206698);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(206699, '3.30.450.20-FF-000645', NULL, 'Histidine kinase', 126, NULL, NULL, 206699),
(206700, '3.90.470.10-FF-000023', NULL, 'Putative 50S ribosomal protein L22, mitochondrial', 165, NULL, NULL, 206700),
(206701, '3.40.50.970-FF-000072', NULL, '3D-(3,5/4)-trihydroxycyclohexane-1,2-dione hydrolase', 228, NULL, NULL, 206701),
(206702, '1.10.510.10-FF-003048', NULL, NULL, 213, NULL, NULL, 206702),
(206703, '1.20.5.110-FF-000039', NULL, 'Syntaxin-81 like', 95, NULL, NULL, 206703),
(206704, '3.90.190.10-FF-000411', NULL, 'Predicted protein', 261, NULL, NULL, 206704),
(206705, '3.30.565.10-FF-000268', NULL, 'Uncharacterized protein', 144, NULL, NULL, 206705),
(206706, '3.40.190.80-FF-000067', NULL, 'Probable inositol-1(Or 4)-monophosphatase / fructose-1,6-bisphosphatase, archaeal-type', 122, NULL, NULL, 206706),
(206707, '1.25.40.10-FF-001477', NULL, 'RNA polymerase II transcription elongation factor (Ctr9), putative', 114, NULL, NULL, 206707),
(206708, '3.40.850.10-FF-000243', NULL, 'Kinesin-like protein', 157, NULL, NULL, 206708),
(206709, '1.10.510.10-FF-003386', NULL, NULL, 315, NULL, NULL, 206709),
(206710, '3.40.50.300-FF-007161', NULL, 'Uncharacterized protein', 174, NULL, NULL, 206710),
(206711, '2.10.25.10-FF-001804', NULL, 'Uncharacterized protein', 54, NULL, NULL, 206711),
(206712, '1.10.10.10-FF-001222', NULL, 'LysR family transcriptional regulator', 85, NULL, NULL, 206712),
(206713, '1.10.510.10-FF-003650', NULL, NULL, 185, NULL, NULL, 206713),
(206714, '2.30.29.30-FF-000784', NULL, 'Rho guanine nucleotide exchange factor 10-like Protein', 117, NULL, NULL, 206714),
(206715, '1.20.1270.10-FF-000030', NULL, 'Heat shock cognate 70 kDa protein-like', 75, NULL, NULL, 206715),
(206716, '1.20.1560.10-FF-000906', NULL, 'Uncharacterized protein', 166, NULL, NULL, 206716),
(206717, '1.10.2000.10-FF-000064', NULL, NULL, 133, NULL, NULL, 206717),
(206718, '2.30.29.30-FF-001402', NULL, 'Uncharacterized protein', 73, NULL, NULL, 206718),
(206719, '2.130.10.10-FF-002304', NULL, 'Predicted protein', 358, NULL, NULL, 206719),
(206720, '4.10.240.10-FF-000149', NULL, 'Zcf19p', 73, NULL, NULL, 206720),
(206721, '3.80.10.10-FF-002147', NULL, 'Uncharacterized protein', 79, NULL, NULL, 206721),
(206722, '3.40.50.10970-FF-000001', NULL, 'Sensor histidine kinase RcsC', 114, NULL, NULL, 206722),
(206723, '3.30.160.20-FF-000089', NULL, 'Dicer-2', 63, NULL, NULL, 206723),
(206724, '3.40.50.11780-FF-000002', NULL, 'Tail sheath monomer', 210, NULL, NULL, 206724),
(206725, '1.10.150.900-FF-000008', NULL, 'Uncharacterized protein', 61, NULL, NULL, 206725),
(206726, '3.30.1370.210-FF-000040', NULL, 'LD47649p', 43, NULL, NULL, 206726),
(206727, '3.30.70.1180-FF-000001', NULL, 'V-type proton ATPase subunit C', 67, NULL, NULL, 206727),
(206728, '3.80.10.10-FF-004300', NULL, 'Protein NLRC5', 225, NULL, NULL, 206728),
(206729, '3.40.50.300-FF-003530', NULL, 'Phosphate acetyltransferase', 193, NULL, NULL, 206729),
(206730, '2.60.40.10-FF-003271', NULL, 'Xyloglucan-specific endo-beta-1,4-glucanase BoGH5A', 91, NULL, NULL, 206730),
(206731, '3.30.505.10-FF-000045', NULL, 'Tyrosine-protein kinase', 109, NULL, NULL, 206731),
(206732, '2.10.109.10-FF-000032', NULL, 'Mitochondrial inner membrane protease subunit', 128, NULL, NULL, 206732),
(206733, '3.10.20.770-FF-000018', NULL, 'Predicted protein', 173, NULL, NULL, 206733),
(206734, '1.10.530.10-FF-000060', NULL, 'Predicted protein', 146, NULL, NULL, 206734),
(206735, '1.20.5.1430-FF-000017', NULL, 'Microtubule-associated protein, RP/EB family, member 1b', 61, NULL, NULL, 206735),
(206736, '3.40.50.300-FF-003221', NULL, 'Nucleosome remodeling complex ATPase subunit (Snf2h)', 292, NULL, NULL, 206736),
(206737, '3.80.10.10-FF-004194', NULL, 'Protein zer-1 homolog-like Protein', 266, NULL, NULL, 206737),
(206738, '3.30.590.50-FF-000006', NULL, 'Glutamate--cysteine ligase', 93, NULL, NULL, 206738),
(206739, '1.10.510.10-FF-001502', NULL, 'Serine/threonine-protein kinase HRK1', 95, NULL, NULL, 206739),
(206740, '4.10.1240.10-FF-000040', NULL, 'Hector, isoform A', 110, NULL, NULL, 206740);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(206741, '4.10.860.120-FF-000011', NULL, 'DNA-directed RNA polymerase subunit', 125, NULL, NULL, 206741),
(206742, '1.10.20.10-FF-000323', NULL, NULL, 124, NULL, NULL, 206742),
(206743, '3.40.1090.10-FF-000156', NULL, 'Uncharacterized protein', 144, NULL, NULL, 206743),
(206744, '3.40.50.300-FF-002602', NULL, 'GPN-loop GTPase 2', 270, NULL, NULL, 206744),
(206745, '1.10.10.2660-FF-000012', NULL, 'SUMO-activating enzyme subunit', 46, NULL, NULL, 206745),
(206746, '3.30.160.60-FF-004440', NULL, NULL, 27, NULL, NULL, 206746),
(206747, '2.30.30.30-FF-000158', NULL, 'Mitochondrial elongation factor P', 62, NULL, NULL, 206747),
(206748, '3.40.30.10-FF-000705', NULL, 'GLutaRedoXin', 61, NULL, NULL, 206748),
(206749, '3.30.342.10-FF-000020', NULL, 'DNA polymerase', 169, NULL, NULL, 206749),
(206750, '3.40.33.10-FF-000049', NULL, 'Gamete and mating-type specific protein A', 160, NULL, NULL, 206750),
(206751, '3.90.1170.30-FF-000011', NULL, 'Thymidine phosphorylase', 71, NULL, NULL, 206751),
(206752, '3.40.50.620-FF-000765', NULL, 'Uncharacterized protein', 119, NULL, NULL, 206752),
(206753, '3.40.50.1820-FF-000399', NULL, 'YDR444W-like protein', 199, NULL, NULL, 206753),
(206754, '1.10.20.10-FF-000222', NULL, NULL, 105, NULL, NULL, 206754),
(206755, '1.10.510.10-FF-000513', NULL, 'Protein NSP-INTERACTING KINASE 2', 191, NULL, NULL, 206755),
(206756, '3.40.250.10-FF-000254', NULL, 'Uncharacterized protein', 83, NULL, NULL, 206756),
(206757, '3.30.230.130-FF-000003', NULL, 'Cullin 2', 154, NULL, NULL, 206757),
(206758, '2.40.10.10-FF-000656', NULL, NULL, 100, NULL, NULL, 206758),
(206759, '1.25.40.10-FF-003731', NULL, 'Peptidylprolyl isomerase D', 84, NULL, NULL, 206759),
(206760, '2.130.10.10-FF-002776', NULL, 'Uncharacterized protein', 223, NULL, NULL, 206760),
(206761, '1.25.10.10-FF-001857', NULL, 'Uncharacterized protein', 187, NULL, NULL, 206761),
(206762, '3.40.50.300-FF-005828', NULL, 'Uncharacterized protein', 189, NULL, NULL, 206762),
(206763, '4.10.110.20-FF-000002', NULL, 'Variant surface glycoprotein (VSG), putative', 75, NULL, NULL, 206763),
(206764, '3.40.50.300-FF-006655', NULL, 'Uncharacterized protein', 87, NULL, NULL, 206764),
(206765, '3.40.50.720-FF-000710', NULL, 'Serine 3-dehydrogenase', 261, NULL, NULL, 206765),
(206766, '3.30.160.60-FF-003057', NULL, 'Zinc finger protein 473', 27, NULL, NULL, 206766),
(206767, '2.40.40.10-FF-000012', NULL, NULL, 110, NULL, NULL, 206767),
(206768, '3.40.50.2300-FF-001077', NULL, NULL, 148, NULL, NULL, 206768),
(206769, '3.30.420.10-FF-000562', NULL, NULL, 53, NULL, NULL, 206769),
(206770, '2.10.25.10-FF-000815', NULL, 'Laminin subunit alpha-3', 53, NULL, NULL, 206770),
(206771, '2.30.42.10-FF-000298', NULL, 'Protein lin-7 homolog A', 95, NULL, NULL, 206771),
(206772, '2.60.40.10-FF-003428', NULL, NULL, 106, NULL, NULL, 206772),
(206773, '3.90.70.10-FF-000745', NULL, 'Clan CA, family C1, cathepsin B-like cysteine peptidase', 135, NULL, NULL, 206773),
(206774, '1.25.40.10-FF-002202', NULL, 'Contig, possible fusion of chromosomes 20 and 34', 111, NULL, NULL, 206774),
(206775, '1.10.510.10-FF-004375', NULL, NULL, 100, NULL, NULL, 206775),
(206776, '2.30.110.10-FF-000115', NULL, 'Pyridoxamine 5''-phosphate oxidase C1952.08c homolog', 172, NULL, NULL, 206776),
(206777, '3.40.50.1000-FF-000849', NULL, NULL, 59, NULL, NULL, 206777),
(206778, '2.10.25.10-FF-000601', NULL, 'Neural-cadherin', 36, NULL, NULL, 206778),
(206779, '3.40.50.300-FF-001276', NULL, 'Uncharacterized protein, isoform A', 237, NULL, NULL, 206779),
(206780, '1.10.510.10-FF-003711', NULL, NULL, 160, NULL, NULL, 206780),
(206781, '1.25.40.10-FF-004809', NULL, 'Uncharacterized protein', 159, NULL, NULL, 206781),
(206782, '2.20.70.10-FF-000003', NULL, 'amyloid beta A4 precursor protein-binding family B member 2', 23, NULL, NULL, 206782),
(206783, '2.30.30.570-FF-000004', NULL, 'Major vault protein', 25, NULL, NULL, 206783),
(206784, '3.90.1150.50-FF-000004', NULL, 'Transcription-repair-coupling factor', 123, NULL, NULL, 206784),
(206785, '3.30.70.330-FF-000948', NULL, 'RNA-binding region (RNP1, RRM) containing 3', 103, NULL, NULL, 206785);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(206786, '1.20.920.30-FF-000065', NULL, 'Uncharacterized protein', 119, NULL, NULL, 206786),
(206787, '1.25.40.10-FF-005075', NULL, 'Uncharacterized protein', 95, NULL, NULL, 206787),
(206788, '3.20.20.140-FF-000338', NULL, 'Predicted protein', 63, NULL, NULL, 206788),
(206789, '3.40.50.1360-FF-000019', NULL, 'Sugar-binding transcriptional regulator', 267, NULL, NULL, 206789),
(206790, '1.20.1720.10-FF-000088', NULL, 'Bcr/CflA family efflux transporter', 380, NULL, NULL, 206790),
(206791, '3.80.10.10-FF-002855', NULL, 'Uncharacterized protein', 142, NULL, NULL, 206791),
(206792, '3.30.160.60-FF-002231', NULL, 'Hangover, isoform C', 72, NULL, NULL, 206792),
(206793, '2.30.40.10-FF-000080', NULL, 'dihydropyrimidinase-related protein 2', 97, NULL, NULL, 206793),
(206794, '2.60.120.330-FF-000145', NULL, 'Gibberellin 2-beta-dioxygenase 8', 86, NULL, NULL, 206794),
(206795, '3.40.50.300-FF-001984', NULL, 'Branched-chain amino acid ABC transporter, ATP-binding protein', 253, NULL, NULL, 206795),
(206796, '3.30.450.20-FF-000437', NULL, 'Photoactive yellow protein', 125, NULL, NULL, 206796),
(206797, '3.40.50.620-FF-000551', NULL, 'Uncharacterized protein', 256, NULL, NULL, 206797),
(206798, '2.40.50.140-FF-000698', NULL, 'Phenylalanine--tRNA ligase beta subunit', 115, NULL, NULL, 206798),
(206799, '3.40.309.10-FF-000008', NULL, 'Cytosolic 10-formyltetrahydrofolate dehydrogenase', 192, NULL, NULL, 206799),
(206800, '3.30.1370.250-FF-000001', NULL, '5''-3'' exoribonuclease 1', 130, NULL, NULL, 206800),
(206801, '3.30.9.10-FF-000106', NULL, 'Glycerol-3-phosphate dehydrogenase', 153, NULL, NULL, 206801),
(206802, '3.90.1290.10-FF-000036', NULL, 'AGAP011396-PA', 184, NULL, NULL, 206802),
(206803, '3.40.1110.10-FF-000445', NULL, NULL, 274, NULL, NULL, 206803),
(206804, '1.10.510.10-FF-001250', NULL, 'Protein kinase', 213, NULL, NULL, 206804),
(206805, '3.40.50.11350-FF-000014', NULL, 'Uncharacterized protein', 168, NULL, NULL, 206805),
(206806, '3.60.20.10-FF-000013', NULL, 'Proteasome subunit beta type-5', 236, NULL, NULL, 206806),
(206807, '1.25.10.10-FF-003083', NULL, 'Uncharacterized protein', 237, NULL, NULL, 206807),
(206808, '2.130.10.10-FF-004013', NULL, 'Uncharacterized protein', 224, NULL, NULL, 206808),
(206809, '1.50.10.130-FF-000014', NULL, NULL, 72, NULL, NULL, 206809),
(206810, '6.10.140.2220-FF-000016', NULL, 'zinc finger MYND domain-containing protein 12', 50, NULL, NULL, 206810),
(206811, '1.25.40.10-FF-002775', NULL, 'TPR Domain containing protein', 130, NULL, NULL, 206811),
(206812, '3.30.479.30-FF-000040', NULL, 'Uncharacterized protein', 136, NULL, NULL, 206812),
(206813, '1.20.1110.10-FF-000182', NULL, NULL, 199, NULL, NULL, 206813),
(206814, '3.30.450.40-FF-000286', NULL, 'Phosphodiesterase', 60, NULL, NULL, 206814),
(206815, '2.60.40.10-FF-000449', NULL, 'cell adhesion molecule 2 isoform X1', 93, NULL, NULL, 206815),
(206816, '3.40.50.10240-FF-000018', NULL, 'Uncharacterized protein', 178, NULL, NULL, 206816),
(206817, '1.20.1250.40-FF-000010', NULL, 'RNA Polymerase II (B) subunit', 135, NULL, NULL, 206817),
(206818, '3.30.40.10-FF-000302', NULL, 'E3 ubiquitin-protein ligase NRDP1', 51, NULL, NULL, 206818),
(206819, '1.10.730.10-FF-000041', NULL, 'Methionine--tRNA ligase', 143, NULL, NULL, 206819),
(206820, '3.40.50.1000-FF-000597', NULL, NULL, 135, NULL, NULL, 206820),
(206821, '1.20.1560.10-FF-000794', NULL, 'ABC transporter', 211, NULL, NULL, 206821),
(206822, '1.10.287.370-FF-000051', NULL, 'Prefoldin subunit family protein', 136, NULL, NULL, 206822),
(206823, '2.60.120.200-FF-000561', NULL, 'Os08g0123900 protein', 158, NULL, NULL, 206823),
(206824, '3.40.50.2000-FF-000588', NULL, 'Glycosyl transferase', 144, NULL, NULL, 206824),
(206825, '3.50.50.60-FF-000811', NULL, 'Methylenetetrahydrofolate--tRNA-(uracil-5-)-methyltransferase TrmFO', 191, NULL, NULL, 206825),
(206826, '3.20.20.140-FF-000086', NULL, 'Adenosine deaminase', 126, NULL, NULL, 206826),
(206827, '3.20.20.80-FF-000665', NULL, 'Uncharacterized protein', 454, NULL, NULL, 206827),
(206828, '2.60.40.10-FF-005980', NULL, NULL, 97, NULL, NULL, 206828);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(206829, '1.10.630.10-FF-000241', NULL, 'cytochrome P450 3A31-like', 87, NULL, NULL, 206829),
(206830, '1.20.1700.10-FF-000002', NULL, 'Pantothenate kinase 2', 87, NULL, NULL, 206830),
(206831, '1.20.58.60-FF-000868', NULL, 'Uncharacterized protein', 120, NULL, NULL, 206831),
(206832, '3.30.70.330-FF-002943', NULL, NULL, 159, NULL, NULL, 206832),
(206833, '3.40.50.720-FF-001211', NULL, 'Oxidoreductase', 244, NULL, NULL, 206833),
(206834, '2.60.40.10-FF-003063', NULL, 'Myotactin form B', 105, NULL, NULL, 206834),
(206835, '3.40.50.150-FF-001242', NULL, NULL, 77, NULL, NULL, 206835),
(206836, '1.25.40.10-FF-000757', NULL, 'Os10g0501300 protein', 182, NULL, NULL, 206836),
(206837, '2.130.10.10-FF-001242', NULL, 'WD repeat protein', 268, NULL, NULL, 206837),
(206838, '2.60.40.10-FF-000657', NULL, 'Leukemia inhibitory factor receptor', 95, NULL, NULL, 206838),
(206839, '2.40.320.10-FF-000033', NULL, 'Mediator of RNA polymerase II transcription subunit 18', 207, NULL, NULL, 206839),
(206840, '1.10.565.10-FF-000100', NULL, 'Steroid hormone receptor family member cnr14', 257, NULL, NULL, 206840),
(206841, '1.20.58.860-FF-000005', NULL, 'Ubiquitin carboxyl-terminal hydrolase BAP1', 73, NULL, NULL, 206841),
(206842, '3.40.50.300-FF-005930', NULL, 'Putative helicase 2', 253, NULL, NULL, 206842),
(206843, '3.40.1120.10-FF-000007', NULL, NULL, 144, NULL, NULL, 206843),
(206844, '3.60.10.10-FF-000187', NULL, 'Inositol-1,4,5-trisphosphate 5-phosphatase, putative', 364, NULL, NULL, 206844),
(206845, '3.40.50.1100-FF-000172', NULL, 'Cysteine synthase', 92, NULL, NULL, 206845),
(206846, '3.20.20.80-FF-000356', NULL, 'Predicted protein', 270, NULL, NULL, 206846),
(206847, '3.30.530.20-FF-000090', NULL, 'Phosphatidylinositol transfer protein, beta,-like', 196, NULL, NULL, 206847),
(206848, '3.30.450.20-FF-000280', NULL, 'Sensor histidine kinase KinD', 100, NULL, NULL, 206848),
(206849, '1.25.10.20-FF-000017', NULL, 'Apolipoprotein Bb, tandem duplicate 1', 311, NULL, NULL, 206849),
(206850, '3.40.50.1000-FF-000496', NULL, 'Alpha,alpha-trehalose-phosphate synthase', 164, NULL, NULL, 206850),
(206851, '3.40.50.2300-FF-000560', NULL, 'Clumsy, isoform B', 152, NULL, NULL, 206851),
(206852, '3.30.230.10-FF-000305', NULL, 'Uncharacterized protein', 218, NULL, NULL, 206852),
(206853, '3.30.70.60-FF-000004', NULL, 'Elongation factor 1-beta, putative', 89, NULL, NULL, 206853),
(206854, '3.40.50.300-FF-005328', NULL, 'Muscle-specific beta 1 integrin-binding protein', 150, NULL, NULL, 206854),
(206855, '1.10.510.10-FF-002222', NULL, NULL, 214, NULL, NULL, 206855),
(206856, '2.130.10.10-FF-005177', NULL, 'WD40-repeat protein', 126, NULL, NULL, 206856),
(206857, '1.20.1250.20-FF-002269', NULL, 'Uncharacterized protein', 98, NULL, NULL, 206857),
(206858, '3.60.110.10-FF-000014', NULL, 'Aliphatic amidase', 341, NULL, NULL, 206858),
(206859, '3.40.920.10-FF-000007', NULL, 'Related to MET10-sulfite reductase flavin-binding subunit', 191, NULL, NULL, 206859),
(206860, '2.30.180.10-FF-000170', NULL, NULL, 158, NULL, NULL, 206860),
(206861, '1.20.910.10-FF-000036', NULL, 'Conserved protein (TenA homolog)', 212, NULL, NULL, 206861),
(206862, '2.60.40.10-FF-001163', NULL, 'Sallimus, isoform Q', 95, NULL, NULL, 206862),
(206863, '1.20.1070.10-FF-000610', NULL, 'Olfactory receptor', 185, NULL, NULL, 206863),
(206864, '3.40.640.10-FF-000418', NULL, 'Serine--pyruvate aminotransferase', 56, NULL, NULL, 206864),
(206865, '3.30.160.60-FF-003720', NULL, 'Zinc finger protein 562', 27, NULL, NULL, 206865),
(206866, '3.30.930.10-FF-000426', NULL, 'Uncharacterized protein', 363, NULL, NULL, 206866),
(206867, '3.30.40.10-FF-001336', NULL, 'Histone-lysine N-methyltransferase', 68, NULL, NULL, 206867),
(206868, '1.20.1070.10-FF-000155', NULL, 'diuretic hormone receptor isoform X1', 292, NULL, NULL, 206868),
(206869, '3.80.10.10-FF-002355', NULL, 'Predicted protein', 231, NULL, NULL, 206869),
(206870, '1.25.10.10-FF-003139', NULL, 'SNF2 superfamily protein', 108, NULL, NULL, 206870),
(206871, '3.30.300.20-FF-000078', NULL, '40S ribosomal protein S3-1', 77, NULL, NULL, 206871);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(206872, '3.30.190.20-FF-000029', NULL, '60S ribosomal protein L10a', 62, NULL, NULL, 206872),
(206873, '3.20.20.140-FF-000439', NULL, 'Predicted protein', 105, NULL, NULL, 206873),
(206874, '3.40.1360.10-FF-000003', NULL, 'DNA topoisomerase 6 subunit A', 223, NULL, NULL, 206874),
(206875, '2.40.10.10-FF-000448', NULL, NULL, 118, NULL, NULL, 206875),
(206876, '1.10.132.60-FF-000020', NULL, 'DNA polymerase', 156, NULL, NULL, 206876),
(206877, '4.10.280.10-FF-000112', NULL, 'Hes family bHLH transcription factor 6', 60, NULL, NULL, 206877),
(206878, '3.40.50.10090-FF-000001', NULL, 'Bifunctional uroporphyrinogen-III C-methyltransferase/uroporphyrinogen-III synthase', 121, NULL, NULL, 206878),
(206879, '1.10.287.110-FF-000422', NULL, 'Predicted protein', 94, NULL, NULL, 206879),
(206880, '2.70.170.10-FF-000267', NULL, 'Gamma-aminobutyric acid (GABA) A receptor, rho 1', 131, NULL, NULL, 206880),
(206881, '1.20.1050.130-FF-000052', NULL, 'Uncharacterized protein', 172, NULL, NULL, 206881),
(206882, '3.30.559.10-FF-000208', NULL, 'N-(5-amino-5-carboxypentanoyl)-L-cysteinyl-D-valine synthase', 197, NULL, NULL, 206882),
(206883, '2.60.40.60-FF-000756', NULL, 'SET domain-containing protein', 107, NULL, NULL, 206883),
(206884, '2.10.25.10-FF-001793', NULL, 'Uncharacterized protein', 28, NULL, NULL, 206884),
(206885, '3.30.420.270-FF-000015', NULL, 'Biopolymer transporter ExbD', 72, NULL, NULL, 206885),
(206886, '3.40.630.30-FF-000339', NULL, 'Acetyltransferase, GNAT family family', 157, NULL, NULL, 206886),
(206887, '3.10.620.30-FF-000008', NULL, 'Blast:Peptide-N(4)-(N-acetyl-beta-glucosaminyl)asparagine amidase', 212, NULL, NULL, 206887),
(206888, '1.20.1080.10-FF-000083', NULL, 'lens fiber major intrinsic protein-like', 270, NULL, NULL, 206888),
(206889, '3.40.50.300-FF-007375', NULL, 'Uncharacterized protein', 315, NULL, NULL, 206889),
(206890, '2.40.50.90-FF-000171', NULL, 'Uncharacterized protein', 128, NULL, NULL, 206890),
(206891, '3.30.160.60-FF-001579', NULL, 'Crooked legs, isoform D', 28, NULL, NULL, 206891),
(206892, '4.10.1000.10-FF-000044', NULL, 'Probable E3 ubiquitin-protein ligase makorin-2', 53, NULL, NULL, 206892),
(206893, '1.20.5.990-FF-000016', NULL, 'IKK gamma', 85, NULL, NULL, 206893),
(206894, '3.10.20.90-FF-000308', NULL, 'bolA-like protein 2', 86, NULL, NULL, 206894),
(206895, '2.60.490.10-FF-000001', NULL, 'P2X purinoceptor', 284, NULL, NULL, 206895),
(206896, '1.20.120.1760-FF-000012', NULL, 'sn-1,2-diacylglycerol cholinephosphotransferase', 188, NULL, NULL, 206896),
(206897, '2.70.98.10-FF-000065', NULL, 'Uncharacterized protein', 243, NULL, NULL, 206897),
(206898, '3.80.10.10-FF-000040', NULL, 'Leucine rich repeats and immunoglobulin like domains 2', 317, NULL, NULL, 206898),
(206899, '2.30.30.140-FF-000095', NULL, 'tudor domain-containing protein 6 isoform X1', 70, NULL, NULL, 206899),
(206900, '3.30.70.330-FF-002842', NULL, NULL, 85, NULL, NULL, 206900),
(206901, '3.40.850.10-FF-000552', NULL, 'Uncharacterized protein', 164, NULL, NULL, 206901),
(206902, '2.60.40.640-FF-000032', NULL, 'Arrestin domain-containing protein 1', 139, NULL, NULL, 206902),
(206903, '2.60.120.20-FF-000027', NULL, NULL, 257, NULL, NULL, 206903),
(206904, '3.40.50.1110-FF-000074', NULL, 'GPI inositol deacylase', 258, NULL, NULL, 206904),
(206905, '3.30.160.60-FF-005165', NULL, NULL, 44, NULL, NULL, 206905),
(206906, '1.20.58.60-FF-000093', NULL, 'dystonin isoform X1', 112, NULL, NULL, 206906),
(206907, '1.10.238.10-FF-000060', NULL, 'Parvalbumin, thymic', 109, NULL, NULL, 206907),
(206908, '3.30.70.330-FF-000381', NULL, 'RNA-binding proteins (RRM domain)', 81, NULL, NULL, 206908),
(206909, '1.10.560.10-FF-000016', NULL, '60 kDa chaperonin', 243, NULL, NULL, 206909),
(206910, '3.40.30.10-FF-000121', NULL, 'protein disulfide-isomerase TMX3 isoform X1', 107, NULL, NULL, 206910),
(206911, '2.130.10.10-FF-002670', NULL, 'Predicted protein', 343, NULL, NULL, 206911),
(206912, '1.20.1250.20-FF-000369', NULL, 'MFS transporter', 380, NULL, NULL, 206912),
(206913, '1.25.40.10-FF-004456', NULL, 'OSM-5', 113, NULL, NULL, 206913);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(206914, '2.40.50.100-FF-000034', NULL, 'Spermidine/putrescine import ATP-binding protein PotA', 91, NULL, NULL, 206914),
(206915, '3.30.200.20-FF-000380', NULL, 'Eukaryotic translation initiation factor 2 alpha kinase 1', 127, NULL, NULL, 206915),
(206916, '3.40.190.10-FF-000552', NULL, 'Transcriptional regulatory protein', 93, NULL, NULL, 206916),
(206917, '3.40.50.2300-FF-001313', NULL, NULL, 114, NULL, NULL, 206917),
(206918, '3.40.50.300-FF-001776', NULL, 'MgsA AAA+ ATPase family protein', 146, NULL, NULL, 206918),
(206919, '4.10.860.10-FF-000005', NULL, 'UvrABC system protein B', 61, NULL, NULL, 206919),
(206920, '1.10.510.10-FF-003756', NULL, NULL, 142, NULL, NULL, 206920),
(206921, '1.10.1740.10-FF-000046', NULL, 'Predicted protein', 71, NULL, NULL, 206921),
(206922, '1.10.10.60-FF-001231', NULL, NULL, 101, NULL, NULL, 206922),
(206923, '3.40.50.300-FF-005475', NULL, 'ABC-type multidrug transport system, ATPase component', 304, NULL, NULL, 206923),
(206924, '2.40.100.10-FF-000005', NULL, 'Peptidyl-prolyl cis-trans isomerase G', 184, NULL, NULL, 206924),
(206925, '1.10.10.10-FF-001722', NULL, 'Iron (Metal) dependent repressor, DtxR family', 67, NULL, NULL, 206925),
(206926, '1.25.40.10-FF-004911', NULL, 'Uncharacterized protein', 72, NULL, NULL, 206926),
(206927, '1.25.40.10-FF-005176', NULL, 'U6 snRNP complex subunit', 267, NULL, NULL, 206927),
(206928, '1.25.10.10-FF-001296', NULL, 'Uncharacterized protein', 238, NULL, NULL, 206928),
(206929, '3.20.20.80-FF-000457', NULL, 'Putative beta-glucosidase 41', 92, NULL, NULL, 206929),
(206930, '2.40.30.10-FF-000511', NULL, 'Predicted protein', 70, NULL, NULL, 206930),
(206931, '1.10.150.20-FF-000196', NULL, 'DNA polymerase nu', 63, NULL, NULL, 206931),
(206932, '2.30.29.30-FF-000076', NULL, 'TBC1 domain family member 4 isoform X1', 135, NULL, NULL, 206932),
(206933, '1.10.510.10-FF-000322', NULL, 'Serine/threonine-protein kinase Kist isoform 1', 199, NULL, NULL, 206933),
(206934, '3.90.320.10-FF-000001', NULL, 'DNA replication helicase Dna2', 196, NULL, NULL, 206934),
(206935, '2.20.100.10-FF-000004', NULL, 'Adhesion G protein-coupled receptor B2', 54, NULL, NULL, 206935),
(206936, '3.90.215.10-FF-000015', NULL, 'Intelectin 2', 80, NULL, NULL, 206936),
(206937, '3.40.50.1820-FF-000207', NULL, 'Alpha/beta-Hydrolases superfamily protein', 197, NULL, NULL, 206937),
(206938, '3.40.630.10-FF-000480', NULL, 'Uncharacterized protein', 123, NULL, NULL, 206938),
(206939, '3.90.1750.10-FF-000072', NULL, 'Uncharacterized protein', 194, NULL, NULL, 206939),
(206940, '3.40.50.300-FF-006756', NULL, 'Uncharacterized protein', 65, NULL, NULL, 206940),
(206941, '3.10.580.10-FF-000061', NULL, 'Hemolysin-like protein containing CBS domains', 155, NULL, NULL, 206941),
(206942, '1.25.40.10-FF-003630', NULL, 'Pentatricopeptide repeat-containing protein', 144, NULL, NULL, 206942),
(206943, '3.20.180.10-FF-000005', NULL, 'Uncharacterized protein', 59, NULL, NULL, 206943),
(206944, '3.30.40.10-FF-002056', NULL, 'Uncharacterized protein', 90, NULL, NULL, 206944),
(206945, '3.40.1410.10-FF-000018', NULL, 'GntR family transcriptional regulator', 163, NULL, NULL, 206945),
(206946, '3.40.50.2000-FF-000487', NULL, 'N-acylglucosamine 2-epimerase', 195, NULL, NULL, 206946),
(206947, '1.20.5.170-FF-000214', NULL, 'Voltage-gated hydrogen channel 1', 50, NULL, NULL, 206947),
(206948, '3.40.50.2000-FF-001105', NULL, 'UDP-glycosyltransferase 73D1', 15, NULL, NULL, 206948),
(206949, '3.10.100.10-FF-000093', NULL, 'GM12442', 138, NULL, NULL, 206949),
(206950, '3.30.2350.10-FF-000027', NULL, 'Pseudouridine synthase', 217, NULL, NULL, 206950),
(206951, '1.25.10.10-FF-000929', NULL, 'Importin alpha subunit, putative', 398, NULL, NULL, 206951),
(206952, '1.20.1050.10-FF-000047', NULL, 'Glutathione S-transferase P', 108, NULL, NULL, 206952),
(206953, '2.40.180.10-FF-000044', NULL, 'Catalase', 162, NULL, NULL, 206953),
(206954, '3.80.10.10-FF-000601', NULL, 'DNA repair protein Rad7, protein', 301, NULL, NULL, 206954),
(206955, '3.30.70.330-FF-002281', NULL, NULL, 61, NULL, NULL, 206955);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(206956, '1.10.287.130-FF-000119', NULL, 'Unplaced genomic scaffold supercont1.240, whole genome shotgun sequence', 94, NULL, NULL, 206956),
(206957, '2.60.40.10-FF-001377', NULL, 'Matrix remodeling associated 5', 98, NULL, NULL, 206957),
(206958, '1.20.1560.10-FF-000322', NULL, 'ABC transporter ATP-binding protein', 313, NULL, NULL, 206958),
(206959, '1.20.58.1120-FF-000054', NULL, NULL, 151, NULL, NULL, 206959),
(206960, '3.40.1110.10-FF-000092', NULL, 'Calcium-transporting ATPase', 204, NULL, NULL, 206960),
(206961, '1.10.287.70-FF-000792', NULL, 'Uncharacterized protein', 155, NULL, NULL, 206961),
(206962, '1.10.287.3990-FF-000013', NULL, 'Uncharacterized protein', 119, NULL, NULL, 206962),
(206963, '1.10.540.10-FF-000150', NULL, 'Uncharacterized protein', 112, NULL, NULL, 206963),
(206964, '2.40.50.140-FF-001215', NULL, NULL, 75, NULL, NULL, 206964),
(206965, '1.10.8.470-FF-000003', NULL, 'GTP-binding protein', 73, NULL, NULL, 206965),
(206966, '2.30.39.10-FF-000155', NULL, 'Uncharacterized protein', 108, NULL, NULL, 206966),
(206967, '1.10.506.10-FF-000071', NULL, 'Uncharacterized protein', 111, NULL, NULL, 206967),
(206968, '3.30.70.330-FF-001353', NULL, 'Tar DNA-binding protein homolog 1', 87, NULL, NULL, 206968),
(206969, '3.40.50.300-FF-001512', NULL, 'Fused isobutyryl-CoA mutase', 210, NULL, NULL, 206969),
(206970, '1.10.1200.10-FF-000135', NULL, 'MFS transporter/NRPS-like enzyme, putative (JCVI)', 69, NULL, NULL, 206970),
(206971, '3.30.50.10-FF-000084', NULL, 'PPARA', 38, NULL, NULL, 206971),
(206972, '1.25.40.620-FF-000008', NULL, 'Glr3962 protein', 69, NULL, NULL, 206972),
(206973, '1.10.510.10-FF-001603', NULL, 'Serine/threonine protein kinase, putative', 174, NULL, NULL, 206973),
(206974, '3.30.60.90-FF-000018', NULL, 'Histone acetyltransferase HAC1', 52, NULL, NULL, 206974),
(206975, '3.80.10.10-FF-003783', NULL, 'Uncharacterized protein', 101, NULL, NULL, 206975),
(206976, '3.30.420.40-FF-000458', NULL, '105/110 kDa heat shock protein/ nucleotide-binding domain', 139, NULL, NULL, 206976),
(206977, '2.60.40.60-FF-000048', NULL, 'protocadherin-15 isoform X1', 121, NULL, NULL, 206977),
(206978, '1.10.490.10-FF-000033', NULL, 'Globin 2, isoform C', 166, NULL, NULL, 206978),
(206979, '3.30.10.20-FF-000011', NULL, 'Serine/threonine protein kinase', 68, NULL, NULL, 206979),
(206980, '1.10.3660.10-FF-000012', NULL, 'Prephenate dehydrogenase', 122, NULL, NULL, 206980),
(206981, '3.40.710.10-FF-000172', NULL, 'Peptidoglycan D,D-transpeptidase MrdA', 367, NULL, NULL, 206981),
(206982, '3.80.10.10-FF-002810', NULL, 'Predicted protein', 240, NULL, NULL, 206982),
(206983, '3.40.50.300-FF-006447', NULL, 'Uncharacterized protein', 123, NULL, NULL, 206983),
(206984, '3.30.450.60-FF-000033', NULL, 'Coatomer zeta subunit, putative', 157, NULL, NULL, 206984),
(206985, '3.30.420.10-FF-000140', NULL, 'Protein CBG03114', 136, NULL, NULL, 206985),
(206986, '2.60.40.10-FF-004709', NULL, NULL, 88, NULL, NULL, 206986),
(206987, '3.30.300.30-FF-000070', NULL, 'O-succinylbenzoic acid--CoA ligase', 102, NULL, NULL, 206987),
(206988, '1.10.287.1490-FF-000090', NULL, 'YALI0F02387p', 164, NULL, NULL, 206988),
(206989, '2.60.120.290-FF-000127', NULL, 'C-type LECtin', 114, NULL, NULL, 206989),
(206990, '2.40.50.140-FF-000962', NULL, NULL, 102, NULL, NULL, 206990),
(206991, '2.60.120.260-FF-000472', NULL, 'Uncharacterized protein', 220, NULL, NULL, 206991),
(206992, '2.60.120.920-FF-000035', NULL, 'SplA/ryanodine receptor domain and SOCS box containing 1', 168, NULL, NULL, 206992),
(206993, '3.40.470.10-FF-000017', NULL, 'Single-strand-selective monofunctional uracil-DNA glycosylase 1', 241, NULL, NULL, 206993),
(206994, '1.10.274.100-FF-000011', NULL, 'DNA-directed RNA polymerase subunit beta''''', 58, NULL, NULL, 206994),
(206995, '1.25.40.20-FF-001379', NULL, 'Uncharacterized protein', 78, NULL, NULL, 206995),
(206996, '3.30.750.24-FF-000094', NULL, 'Uncharacterized protein', 145, NULL, NULL, 206996),
(206997, '3.30.70.330-FF-001662', NULL, NULL, 118, NULL, NULL, 206997),
(206998, '2.30.30.40-FF-000150', NULL, 'Proline-serine-threonine phosphatase interacting protein 1', 61, NULL, NULL, 206998);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(206999, '3.40.50.720-FF-000446', NULL, 'Short chain dehydrogenase', 300, NULL, NULL, 206999),
(207000, '2.70.130.10-FF-000135', NULL, NULL, 158, NULL, NULL, 207000),
(207001, '2.10.110.10-FF-000355', NULL, 'Four and a half LIM domains 5', 50, NULL, NULL, 207001),
(207002, '2.60.40.10-FF-001938', NULL, 'Transmembrane and immunoglobulin domain-containing protein 1', 98, NULL, NULL, 207002),
(207003, '2.150.10.10-FF-000016', NULL, NULL, 76, NULL, NULL, 207003),
(207004, '1.20.1070.10-FF-000369', NULL, 'octopamine receptor Oamb isoform X1', 158, NULL, NULL, 207004),
(207005, '1.20.1070.10-FF-002055', NULL, 'Uncharacterized protein', 96, NULL, NULL, 207005),
(207006, '1.10.510.10-FF-000985', NULL, 'Serine/threonine-protein kinase MARK2', 228, NULL, NULL, 207006),
(207007, '3.30.1240.10-FF-000007', NULL, 'Cof-like hydrolase', 97, NULL, NULL, 207007),
(207008, '3.30.479.20-FF-000048', NULL, 'Elongation factor Ts, mitochondrial', 128, NULL, NULL, 207008),
(207009, '3.40.50.1820-FF-000663', NULL, 'Uncharacterized protein', 178, NULL, NULL, 207009),
(207010, '3.40.50.20-FF-000047', NULL, 'Probable alpha-L-glutamate ligase', 122, NULL, NULL, 207010),
(207011, '3.50.50.60-FF-000356', NULL, 'GDP dissociation inhibitor, putative', 201, NULL, NULL, 207011),
(207012, '3.40.190.10-FF-000771', NULL, 'Ionotropic receptor 7f', 144, NULL, NULL, 207012),
(207013, '1.10.150.20-FF-000308', NULL, 'Uncharacterized protein', 57, NULL, NULL, 207013),
(207014, '2.30.130.10-FF-000015', NULL, 'Glutamate 5-kinase', 98, NULL, NULL, 207014),
(207015, '1.20.5.510-FF-000007', NULL, 'Ubiquitin-like protein MDY2', 24, NULL, NULL, 207015),
(207016, '3.30.70.330-FF-002179', NULL, NULL, 79, NULL, NULL, 207016),
(207017, '3.30.565.10-FF-000476', NULL, 'Predicted protein', 107, NULL, NULL, 207017),
(207018, '1.25.40.10-FF-001685', NULL, 'Suppressor of RPS4-RLD 1', 123, NULL, NULL, 207018),
(207019, '3.30.200.20-FF-000677', NULL, 'Fibrillarin, putative', 53, NULL, NULL, 207019),
(207020, '1.20.1250.10-FF-000012', NULL, 'Growth hormone 1', 191, NULL, NULL, 207020),
(207021, '3.90.930.12-FF-000033', NULL, NULL, 50, NULL, NULL, 207021),
(207022, '1.25.10.10-FF-000677', NULL, 'DnaJ subfamily C member', 255, NULL, NULL, 207022),
(207023, '3.40.50.10860-FF-000069', NULL, 'C1-tetrahydrofolate synthase, putative', 132, NULL, NULL, 207023),
(207024, '3.30.200.20-FF-002178', NULL, 'Predicted protein', 59, NULL, NULL, 207024),
(207025, '3.80.10.10-FF-000910', NULL, 'MDIS1-interacting receptor like kinase 2', 196, NULL, NULL, 207025),
(207026, '3.60.20.40-FF-000011', NULL, 'Gamma-glutamyltransferase 5a', 179, NULL, NULL, 207026),
(207027, '3.30.40.10-FF-002308', NULL, 'Uncharacterized protein', 113, NULL, NULL, 207027),
(207028, '3.30.40.10-FF-000408', NULL, 'E3 ubiquitin-protein ligase RNF114', 102, NULL, NULL, 207028),
(207029, '2.60.120.10-FF-000401', NULL, 'Sulfate permease', 139, NULL, NULL, 207029),
(207030, '3.40.50.450-FF-000017', NULL, 'Raw, isoform D', 123, NULL, NULL, 207030),
(207031, '3.40.50.150-FF-000034', NULL, 'Protein arginine N-methyltransferase 3', 153, NULL, NULL, 207031),
(207032, '3.30.200.20-FF-001189', NULL, 'Predicted protein', 81, NULL, NULL, 207032),
(207033, '3.40.50.300-FF-007352', NULL, 'Uncharacterized protein', 53, NULL, NULL, 207033),
(207034, '4.10.240.10-FF-000121', NULL, 'Uncharacterized protein', 73, NULL, NULL, 207034),
(207035, '3.10.20.320-FF-000001', NULL, 'Muramidase-released protein', 81, NULL, NULL, 207035),
(207036, '2.30.29.30-FF-000868', NULL, 'Uncharacterized protein', 130, NULL, NULL, 207036),
(207037, '1.10.10.10-FF-000160', NULL, 'HTH-type transcriptional regulator UlaR', 56, NULL, NULL, 207037),
(207038, '1.10.1070.11-FF-000097', NULL, 'Ataxia telangiectasia mutated, putative', 188, NULL, NULL, 207038),
(207039, '3.30.420.10-FF-000371', NULL, NULL, 136, NULL, NULL, 207039),
(207040, '3.30.70.330-FF-000925', NULL, 'Nucleolar protein 12', 137, NULL, NULL, 207040),
(207041, '3.10.400.20-FF-000023', NULL, 'Uncharacterized protein', 77, NULL, NULL, 207041),
(207042, '3.40.50.720-FF-000469', NULL, 'SDR family oxidoreductase', 247, NULL, NULL, 207042);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(207043, '2.60.40.60-FF-000503', NULL, 'Predicted protein', 47, NULL, NULL, 207043),
(207044, '1.25.40.10-FF-002539', NULL, 'Embryo specific2', 111, NULL, NULL, 207044),
(207045, '1.50.40.10-FF-000210', NULL, 'Mitochondrial succinate-fumarate transporter 1', 181, NULL, NULL, 207045),
(207046, '1.25.40.10-FF-005092', NULL, 'Pentatricopeptide repeat-containing protein At1g15510, chloroplastic', 71, NULL, NULL, 207046),
(207047, '1.10.510.10-FF-001047', NULL, 'Serine/threonine protein kinase', 198, NULL, NULL, 207047),
(207048, '3.40.1190.20-FF-000077', NULL, 'Adenosine kinase b', 96, NULL, NULL, 207048),
(207049, '2.70.98.30-FF-000043', NULL, 'Uncharacterized protein', 53, NULL, NULL, 207049),
(207050, '3.30.70.270-FF-000093', NULL, 'Sensor domain-containing diguanylate cyclase', 173, NULL, NULL, 207050),
(207051, '2.40.50.140-FF-000832', NULL, NULL, 93, NULL, NULL, 207051),
(207052, '1.10.10.1100-FF-000005', NULL, 'Bacterioferritin', 54, NULL, NULL, 207052),
(207053, '4.10.640.10-FF-000011', NULL, '28S ribosomal protein S18a, mitochondrial', 65, NULL, NULL, 207053),
(207054, '1.20.1250.20-FF-000588', NULL, 'Major Facilitator Superfamily protein', 180, NULL, NULL, 207054),
(207055, '3.40.30.10-FF-001077', NULL, 'Uncharacterized protein', 148, NULL, NULL, 207055),
(207056, '3.30.70.330-FF-001437', NULL, NULL, 86, NULL, NULL, 207056),
(207057, '3.30.420.610-FF-000016', NULL, 'Tudor domain-containing protein 5', 73, NULL, NULL, 207057),
(207058, '1.20.1050.10-FF-000278', NULL, 'Uncharacterized protein', 72, NULL, NULL, 207058),
(207059, '3.10.20.340-FF-000007', NULL, 'Arginine biosynthesis bifunctional protein ArgJ', 129, NULL, NULL, 207059),
(207060, '3.40.50.1100-FF-000301', NULL, 'Uncharacterized protein', 51, NULL, NULL, 207060),
(207061, '1.25.40.10-FF-004147', NULL, 'Uncharacterized protein', 113, NULL, NULL, 207061),
(207062, '2.130.10.10-FF-000989', NULL, 'Ribosome biogenesis protein WDR12 homolog', 187, NULL, NULL, 207062),
(207063, '3.80.10.10-FF-000146', NULL, 'podocan isoform X2', 71, NULL, NULL, 207063),
(207064, '3.40.50.12780-FF-000173', NULL, 'Predicted protein', 357, NULL, NULL, 207064),
(207065, '3.90.1580.10-FF-000036', NULL, 'Predicted protein', 66, NULL, NULL, 207065),
(207066, '3.50.50.60-FF-001429', NULL, 'Probable lysine-specific histone demethylase 1', 116, NULL, NULL, 207066),
(207067, '2.20.50.20-FF-000016', NULL, 'Apolipophorins-like protein', 84, NULL, NULL, 207067),
(207068, '1.10.510.10-FF-000058', NULL, 'Receptor-like protein kinase FERONIA', 211, NULL, NULL, 207068),
(207069, '2.60.40.10-FF-004917', NULL, NULL, 83, NULL, NULL, 207069),
(207070, '2.10.25.10-FF-000259', NULL, 'Coagulation factor VII', 60, NULL, NULL, 207070),
(207071, '3.10.100.10-FF-000177', NULL, 'GD23470', 182, NULL, NULL, 207071),
(207072, '3.20.20.20-FF-000023', NULL, 'Dihydropteroate synthase', 284, NULL, NULL, 207072),
(207073, '1.20.920.10-FF-000082', NULL, 'Similar to Bromodomain containing protein', 111, NULL, NULL, 207073),
(207074, '2.130.10.10-FF-005840', NULL, 'Plexin D1', 352, NULL, NULL, 207074),
(207075, '2.60.120.260-FF-000337', NULL, 'Netrin G1', 193, NULL, NULL, 207075),
(207076, '3.30.40.10-FF-001027', NULL, 'E3 ubiquitin-protein ligase PRT1', 111, NULL, NULL, 207076),
(207077, '3.40.720.10-FF-000026', NULL, 'N-sulphoglucosamine sulphohydrolase', 459, NULL, NULL, 207077),
(207078, '3.40.50.300-FF-007509', NULL, 'ABC transporter related', 218, NULL, NULL, 207078),
(207079, '1.10.630.10-FF-000224', NULL, 'Cytochrome P450', 538, NULL, NULL, 207079),
(207080, '1.10.150.670-FF-000012', NULL, 'Probable crossover junction endonuclease mus81', 94, NULL, NULL, 207080),
(207081, '3.90.76.10-FF-000011', NULL, 'Extracellular solute-binding protein, family protein 5', 114, NULL, NULL, 207081),
(207082, '1.20.80.10-FF-000057', NULL, 'Band 4.1-like protein 5', 110, NULL, NULL, 207082),
(207083, '1.50.10.10-FF-000068', NULL, 'alpha-1,2-Mannosidase', 516, NULL, NULL, 207083),
(207084, '3.90.1150.10-FF-000442', NULL, 'Aminotransferase', 156, NULL, NULL, 207084),
(207085, '3.40.50.1000-FF-000041', NULL, 'Phosphoserine phosphatase SerB', 221, NULL, NULL, 207085);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(207086, '2.30.280.10-FF-000014', NULL, NULL, 42, NULL, NULL, 207086),
(207087, '3.30.710.10-FF-000123', NULL, 'Intracisternal A particle-promoted polypeptide', 128, NULL, NULL, 207087),
(207088, '3.40.50.1820-FF-000516', NULL, 'Probable oxidoreductase', 272, NULL, NULL, 207088),
(207089, '3.40.50.10330-FF-000129', NULL, 'Diacylglycerol kinase', 133, NULL, NULL, 207089),
(207090, '1.20.1070.10-FF-001330', NULL, 'Vomeronasal type-1 receptor', 228, NULL, NULL, 207090),
(207091, '3.30.160.60-FF-004676', NULL, NULL, 28, NULL, NULL, 207091),
(207092, '1.10.565.10-FF-000128', NULL, 'Nuclear receptor', 190, NULL, NULL, 207092),
(207093, '3.30.1010.10-FF-000114', NULL, 'Phosphatidylinositol 3-kinase-related protein kinase', 101, NULL, NULL, 207093),
(207094, '3.40.50.2300-FF-000913', NULL, NULL, 115, NULL, NULL, 207094),
(207095, '2.40.37.20-FF-000018', NULL, NULL, 42, NULL, NULL, 207095),
(207096, '3.20.20.190-FF-000084', NULL, NULL, 42, NULL, NULL, 207096),
(207097, '3.30.70.260-FF-000096', NULL, 'Mg2+ transport P-type ATPase MgtC', 94, NULL, NULL, 207097),
(207098, '2.60.260.20-FF-000077', NULL, 'DnaJ-like protein', 103, NULL, NULL, 207098),
(207099, '3.30.1520.10-FF-000080', NULL, 'Conserved fungal protein', 142, NULL, NULL, 207099),
(207100, '2.40.50.1060-FF-000014', NULL, 'Uncharacterized protein', 132, NULL, NULL, 207100),
(207101, '1.20.58.1120-FF-000014', NULL, 'Putative dynein heavy chain', 158, NULL, NULL, 207101),
(207102, '3.40.50.10190-FF-000071', NULL, 'Pescadillo homolog', 79, NULL, NULL, 207102),
(207103, '3.40.850.10-FF-000108', NULL, 'Myosin XIX', 173, NULL, NULL, 207103),
(207104, '1.20.1250.20-FF-000116', NULL, 'synaptic vesicular amine transporter isoform X2', 165, NULL, NULL, 207104),
(207105, '3.40.50.300-FF-003985', NULL, 'DNA repair protein rad-50', 255, NULL, NULL, 207105),
(207106, '3.40.50.300-FF-004755', NULL, 'DNA helicase bloom''s syndrome protein C', 69, NULL, NULL, 207106),
(207107, '3.40.50.2000-FF-000604', NULL, 'Uncharacterized protein', 95, NULL, NULL, 207107),
(207108, '1.25.70.10-FF-000006', NULL, 'Transcription termination factor MTERF9, chloroplastic', 236, NULL, NULL, 207108),
(207109, '3.30.900.10-FF-000025', NULL, 'Autophagy-related protein 13', 237, NULL, NULL, 207109),
(207110, '3.30.1010.10-FF-000007', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', 157, NULL, NULL, 207110),
(207111, '1.25.40.20-FF-000507', NULL, 'Anion exchange protein', 52, NULL, NULL, 207111),
(207112, '1.10.8.870-FF-000016', NULL, 'Glycerol-3-phosphate dehydrogenase', 123, NULL, NULL, 207112),
(207113, '1.10.10.350-FF-000038', NULL, NULL, 107, NULL, NULL, 207113),
(207114, '3.30.160.60-FF-002787', NULL, 'AGAP000058-PA-like protein', 67, NULL, NULL, 207114),
(207115, '3.80.10.10-FF-001102', NULL, 'Protein phosphatase 2C, putative', 110, NULL, NULL, 207115),
(207116, '3.40.47.10-FF-000244', NULL, NULL, 291, NULL, NULL, 207116),
(207117, '3.10.129.10-FF-000260', NULL, 'Os04g0553300 protein', 89, NULL, NULL, 207117),
(207118, '1.10.287.110-FF-000113', NULL, 'DnaJ (Hsp40) homolog, subfamily C, member 28', 98, NULL, NULL, 207118),
(207119, '2.60.120.200-FF-000584', NULL, 'Uncharacterized protein', 165, NULL, NULL, 207119),
(207120, '3.40.50.300-FF-007728', NULL, 'Predicted protein', 89, NULL, NULL, 207120),
(207121, '3.40.462.40-FF-000002', NULL, NULL, 129, NULL, NULL, 207121),
(207122, '2.60.120.590-FF-000071', NULL, 'AlkB homolog 3, alpha-ketoglutarate-dependent dioxygenase', 123, NULL, NULL, 207122),
(207123, '4.10.400.10-FF-000123', NULL, 'low-density lipoprotein receptor-related protein 1B', 40, NULL, NULL, 207123),
(207124, '1.10.238.180-FF-000006', NULL, 'Uncharacterized protein', 44, NULL, NULL, 207124),
(207125, '2.130.10.10-FF-005733', NULL, 'Uncharacterized protein', 131, NULL, NULL, 207125),
(207126, '3.40.250.10-FF-000231', NULL, 'Probable 3-mercaptopyruvate sulfurtransferase', 138, NULL, NULL, 207126),
(207127, '3.40.50.360-FF-000018', NULL, 'Sulfite reductase [NADPH] flavoprotein alpha-component', 166, NULL, NULL, 207127),
(207128, '1.10.472.10-FF-000660', NULL, 'Predicted protein', 88, NULL, NULL, 207128);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(207129, '3.40.50.300-FF-001085', NULL, 'RNA cytidine acetyltransferase', 154, NULL, NULL, 207129),
(207130, '3.40.50.1820-FF-001135', NULL, 'Uncharacterized protein', 117, NULL, NULL, 207130),
(207131, '1.10.510.10-FF-003520', NULL, NULL, 245, NULL, NULL, 207131),
(207132, '3.30.310.10-FF-000014', NULL, 'Beta-adaptin-like protein', 130, NULL, NULL, 207132),
(207133, '2.40.50.100-FF-000135', NULL, 'TOBE domain protein', 66, NULL, NULL, 207133),
(207134, '3.40.50.300-FF-004502', NULL, 'YALI0E16775p', 237, NULL, NULL, 207134),
(207135, '3.40.190.170-FF-000013', NULL, 'TRAP dicarboxylate transporter, DctP subunit, putative', 310, NULL, NULL, 207135),
(207136, '1.25.10.10-FF-000593', NULL, 'U-box domain-containing protein 4', 119, NULL, NULL, 207136),
(207137, '3.60.21.10-FF-000212', NULL, 'Serine/threonine-protein phosphatase', 252, NULL, NULL, 207137),
(207138, '3.40.50.10140-FF-000050', NULL, 'Uncharacterized protein', 89, NULL, NULL, 207138),
(207139, '1.10.8.60-FF-000319', NULL, 'ORC1-type DNA replication protein 3', 83, NULL, NULL, 207139),
(207140, '3.40.120.10-FF-000042', NULL, 'Phosphoglucomutase, putative', 83, NULL, NULL, 207140),
(207141, '3.50.7.10-FF-000063', NULL, NULL, 168, NULL, NULL, 207141),
(207142, '2.130.10.10-FF-003951', NULL, 'Tomosyn-like protein', 245, NULL, NULL, 207142),
(207143, '1.10.3430.10-FF-000074', NULL, 'Uncharacterized protein', 135, NULL, NULL, 207143),
(207144, '1.25.10.10-FF-000121', NULL, 'Protein MOR1', 263, NULL, NULL, 207144),
(207145, '1.10.238.150-FF-000003', NULL, 'Cytokinesis protein SepA', 99, NULL, NULL, 207145),
(207146, '3.30.70.330-FF-001218', NULL, 'Peptidyl-prolyl cis-trans isomerase', 144, NULL, NULL, 207146),
(207147, '1.10.1040.50-FF-000016', NULL, NULL, 187, NULL, NULL, 207147),
(207148, '3.30.870.10-FF-000179', NULL, 'Phospholipase D/Transphosphatidylase', 154, NULL, NULL, 207148),
(207149, '3.40.50.1820-FF-000623', NULL, 'Expressed protein', 233, NULL, NULL, 207149),
(207150, '2.60.300.12-FF-000030', NULL, NULL, 84, NULL, NULL, 207150),
(207151, '2.60.40.10-FF-001247', NULL, 'Receptor protein-tyrosine kinase', 83, NULL, NULL, 207151),
(207152, '1.10.220.150-FF-000047', NULL, 'arf-GAP domain and FG repeat-containing protein 1 isoform X6', 62, NULL, NULL, 207152),
(207153, '3.30.160.60-FF-001803', NULL, 'Zinc finger protein 667', 29, NULL, NULL, 207153),
(207154, '3.30.70.330-FF-000818', NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', 132, NULL, NULL, 207154),
(207155, '1.20.1250.20-FF-002050', NULL, 'Monocarboxylate transporter 12-B-like Protein', 310, NULL, NULL, 207155),
(207156, '3.40.390.10-FF-000180', NULL, NULL, 201, NULL, NULL, 207156),
(207157, '1.20.1540.10-FF-000023', NULL, 'Peptidase, S54 family', 199, NULL, NULL, 207157),
(207158, '1.10.1510.10-FF-000001', NULL, 'Glutamyl-tRNA amidotransferase', 92, NULL, NULL, 207158),
(207159, '1.20.140.10-FF-000095', NULL, 'Acyl-CoA dehydrogenase FadE32', 143, NULL, NULL, 207159),
(207160, '2.60.40.1180-FF-000135', NULL, 'Uncharacterized protein', 121, NULL, NULL, 207160),
(207161, '1.10.1040.30-FF-000010', NULL, 'Uncharacterized protein', 32, NULL, NULL, 207161),
(207162, '3.50.50.60-FF-000620', NULL, 'Dimethylaniline monooxygenase', 249, NULL, NULL, 207162),
(207163, '1.10.472.10-FF-000188', NULL, 'PCL5p Cyclin', 195, NULL, NULL, 207163),
(207164, '2.120.10.30-FF-000377', NULL, 'Uncharacterized protein', 320, NULL, NULL, 207164),
(207165, '3.30.342.10-FF-000043', NULL, 'DNA polymerase zeta catalytic subunit-like protein', 111, NULL, NULL, 207165),
(207166, '2.60.40.10-FF-003619', NULL, NULL, 106, NULL, NULL, 207166),
(207167, '3.10.50.40-FF-000037', NULL, 'Peptidylprolyl isomerase', 150, NULL, NULL, 207167),
(207168, '1.20.1280.50-FF-000273', NULL, 'ELM2 domaincontaining protein', 99, NULL, NULL, 207168),
(207169, '2.170.16.10-FF-000028', NULL, 'NAD(P)(+)--arginine ADP-ribosyltransferase', 137, NULL, NULL, 207169),
(207170, '3.30.230.10-FF-000069', NULL, 'Probable phosphomevalonate kinase', 280, NULL, NULL, 207170),
(207171, '3.40.50.12780-FF-000066', NULL, 'Probable fatty-acid-CoA ligase fadD6', 414, NULL, NULL, 207171);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(207172, '1.25.10.10-FF-001902', NULL, 'YALI0E28371p', 225, NULL, NULL, 207172),
(207173, '2.10.50.30-FF-000014', NULL, 'Vomeronasal 2, receptor 8', 52, NULL, NULL, 207173),
(207174, '3.30.420.390-FF-000006', NULL, 'DNA polymerase gamma, mitochondrial', 193, NULL, NULL, 207174),
(207175, '1.20.1310.20-FF-000048', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 211, NULL, NULL, 207175),
(207176, '3.10.20.90-FF-000090', NULL, 'Kinesin-like calmodulin-binding protein (ZWICHEL)', 104, NULL, NULL, 207176),
(207177, '1.10.3210.10-FF-000080', NULL, 'Uncharacterized protein', 427, NULL, NULL, 207177),
(207178, '3.90.25.10-FF-000068', NULL, 'Uncharacterized protein', 78, NULL, NULL, 207178),
(207179, '2.60.120.260-FF-000556', NULL, 'von Willebrand factor D and EGF domains', 49, NULL, NULL, 207179),
(207180, '1.25.40.10-FF-004675', NULL, 'Uncharacterized protein', 109, NULL, NULL, 207180),
(207181, '3.30.9.10-FF-000185', NULL, 'Uncharacterized protein', 94, NULL, NULL, 207181),
(207182, '1.20.1250.20-FF-001414', NULL, 'Slr0616 protein', 181, NULL, NULL, 207182),
(207183, '3.90.70.10-FF-000037', NULL, 'Tubulointerstitial nephritis antigen-like 1', 327, NULL, NULL, 207183),
(207184, '1.10.287.70-FF-000691', NULL, 'Uncharacterized protein', 69, NULL, NULL, 207184),
(207185, '3.40.850.10-FF-000327', NULL, 'Kinesin-like protein', 366, NULL, NULL, 207185),
(207186, '3.50.30.30-FF-000166', NULL, 'Glr3087 protein', 140, NULL, NULL, 207186),
(207187, '2.130.10.10-FF-002967', NULL, 'WD-40 repeat protein', 224, NULL, NULL, 207187),
(207188, '3.80.10.10-FF-003558', NULL, 'Uncharacterized protein', 149, NULL, NULL, 207188),
(207189, '3.10.50.40-FF-000161', NULL, 'Peptidylprolyl isomerase', 86, NULL, NULL, 207189),
(207190, '3.40.50.300-FF-003457', NULL, 'ATP-dependent RNA helicase', 173, NULL, NULL, 207190),
(207191, '2.60.40.640-FF-000133', NULL, 'Uncharacterized protein', 130, NULL, NULL, 207191),
(207192, '3.30.40.10-FF-002191', NULL, 'Uncharacterized protein (Fragment)', 77, NULL, NULL, 207192),
(207193, '3.90.550.50-FF-000165', NULL, 'Hexosyltransferase', 196, NULL, NULL, 207193),
(207194, '3.30.70.260-FF-000101', NULL, 'Prephenate dehydratase', 89, NULL, NULL, 207194),
(207195, '3.80.10.10-FF-001630', NULL, 'Si:ch73-286h23.4', 186, NULL, NULL, 207195),
(207196, '3.80.10.10-FF-001321', NULL, 'Leucine-rich repeat protein kinase family protein', 130, NULL, NULL, 207196),
(207197, '3.80.10.10-FF-004047', NULL, 'Leucine-rich repeat protein (LRRP), putative', 138, NULL, NULL, 207197),
(207198, '3.40.50.300-FF-003766', NULL, 'Predicted protein', 180, NULL, NULL, 207198),
(207199, '1.25.40.10-FF-001269', NULL, 'Pentatricopeptide repeat-containing protein At5g56310', 129, NULL, NULL, 207199),
(207200, '1.10.720.30-FF-000029', NULL, 'Neurofilament medium polypeptide, putative', 54, NULL, NULL, 207200),
(207201, '2.30.30.140-FF-000331', NULL, 'Uncharacterized protein', 47, NULL, NULL, 207201),
(207202, '1.20.1250.20-FF-001105', NULL, 'Uncharacterized protein', 403, NULL, NULL, 207202),
(207203, '1.20.5.110-FF-000112', NULL, 'Uncharacterized protein', 103, NULL, NULL, 207203),
(207204, '3.30.70.330-FF-002382', NULL, NULL, 100, NULL, NULL, 207204),
(207205, '1.10.238.10-FF-000161', NULL, 'EF-hand calcium-binding domain-containing protein 7 isoform X2', 99, NULL, NULL, 207205),
(207206, '2.40.128.20-FF-000010', NULL, 'Prostaglandin-H2 D-isomerase', 169, NULL, NULL, 207206),
(207207, '3.40.50.150-FF-000253', NULL, 'Cephalosporin hydroxylase', 164, NULL, NULL, 207207),
(207208, '3.60.40.10-FF-000262', NULL, 'Predicted protein', 316, NULL, NULL, 207208),
(207209, '1.25.40.20-FF-001126', NULL, 'Kinase, NEK', 188, NULL, NULL, 207209),
(207210, '1.20.80.60-FF-000009', NULL, 'Uncharacterized protein', 30, NULL, NULL, 207210),
(207211, '3.10.110.10-FF-000256', NULL, 'Ubiquitin carrier protein 7', 71, NULL, NULL, 207211),
(207212, '1.20.5.170-FF-000097', NULL, 'Beaded filament structural protein 2', 79, NULL, NULL, 207212),
(207213, '1.20.140.10-FF-000090', NULL, 'Short/branched chain specific acyl-CoA dehydrogenase, mitochondrial', 95, NULL, NULL, 207213);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(207214, '4.10.280.10-FF-000011', NULL, 'Aryl hydrocarbon receptor nuclear translocator 2', 66, NULL, NULL, 207214),
(207215, '1.10.630.10-FF-000477', NULL, 'Uncharacterized protein', 546, NULL, NULL, 207215),
(207216, '1.25.40.120-FF-000100', NULL, 'Predicted protein', 108, NULL, NULL, 207216),
(207217, '2.60.40.10-FF-003299', NULL, 'DLEC1, cilia and flagella associated protein', 108, NULL, NULL, 207217),
(207218, '2.60.40.150-FF-000082', NULL, 'E3 ubiquitin-protein ligase', 143, NULL, NULL, 207218),
(207219, '3.30.300.30-FF-000093', NULL, 'Non-ribosomal peptide synthetase', 111, NULL, NULL, 207219),
(207220, '3.30.710.10-FF-000342', NULL, 'BTB/POZ domain/Regulator of chromosome condensation (RCC1) repeat, putative', 71, NULL, NULL, 207220),
(207221, '1.20.1740.10-FF-000004', NULL, 'Sodium:alanine symporter family protein', 393, NULL, NULL, 207221),
(207222, '1.20.1250.20-FF-001993', NULL, 'Solute carrier organic anion transporter family member', 386, NULL, NULL, 207222),
(207223, '2.130.10.10-FF-001478', NULL, 'Cytoplasmic dynein 1 intermediate chain', 190, NULL, NULL, 207223),
(207224, '3.90.1260.10-FF-000017', NULL, 'Argininosuccinate synthase, putative', 139, NULL, NULL, 207224),
(207225, '2.60.40.10-FF-003647', NULL, NULL, 98, NULL, NULL, 207225),
(207226, '3.30.420.60-FF-000014', NULL, 'YALI0B20658p', 139, NULL, NULL, 207226),
(207227, '3.40.720.10-FF-000335', NULL, 'Iduronate-2-sulfatase', 472, NULL, NULL, 207227),
(207228, '2.40.30.10-FF-000410', NULL, 'NADPH-dependent diflavin oxidoreductase 1', 56, NULL, NULL, 207228),
(207229, '3.40.50.300-FF-001877', NULL, 'GTP:AMP phosphotransferase', 213, NULL, NULL, 207229),
(207230, '1.10.10.440-FF-000037', NULL, 'Pre-mRNA-processing factor 40', 67, NULL, NULL, 207230),
(207231, '3.40.1380.20-FF-000007', NULL, 'Pyruvate kinase', 135, NULL, NULL, 207231),
(207232, '3.30.70.330-FF-002073', NULL, NULL, 136, NULL, NULL, 207232),
(207233, '1.25.40.10-FF-000960', NULL, 'Protein adenylyltransferase fic-1', 105, NULL, NULL, 207233),
(207234, '3.40.50.2000-FF-000913', NULL, 'Uncharacterized protein', 163, NULL, NULL, 207234),
(207235, '2.130.10.10-FF-001681', NULL, 'Elongator acetyltransferase complex subunit 2', 251, NULL, NULL, 207235),
(207236, '2.60.120.260-FF-000028', NULL, 'Reelin', 161, NULL, NULL, 207236),
(207237, '3.80.10.10-FF-002069', NULL, 'Putative leucine-rich repeat receptor-like protein kinase', 96, NULL, NULL, 207237),
(207238, '3.30.200.20-FF-002515', NULL, 'Uncharacterized protein', 148, NULL, NULL, 207238),
(207239, '1.10.238.10-FF-001094', NULL, 'Uncharacterized protein', 69, NULL, NULL, 207239),
(207240, '3.30.70.2190-FF-000012', NULL, 'FAD dependent oxidoreductase', 124, NULL, NULL, 207240),
(207241, '3.50.30.30-FF-000149', NULL, 'Predicted protein', 131, NULL, NULL, 207241),
(207242, '1.25.40.10-FF-004220', NULL, 'Putative cargo-transport protein ypp1', 275, NULL, NULL, 207242),
(207243, '3.30.1520.10-FF-000052', NULL, 'Putative SNARE complex subunit (Vam7)', 115, NULL, NULL, 207243),
(207244, '3.30.160.60-FF-006019', NULL, NULL, 32, NULL, NULL, 207244),
(207245, '3.40.50.300-FF-002501', NULL, 'Rab-like protein 2A', 90, NULL, NULL, 207245),
(207246, '1.10.10.10-FF-001913', NULL, 'Heat shock factor protein-like Protein', 102, NULL, NULL, 207246),
(207247, '3.30.710.10-FF-000095', NULL, 'Kelch-like 11 (Drosophila) (Predicted)', 150, NULL, NULL, 207247),
(207248, '1.20.58.1120-FF-000031', NULL, 'Dynein heavy chain', 149, NULL, NULL, 207248),
(207249, '3.40.50.1700-FF-000037', NULL, 'Predicted protein', 248, NULL, NULL, 207249),
(207250, '3.40.50.720-FF-000339', NULL, 'Prephenate dehydrogenase [NADP(+)]', 174, NULL, NULL, 207250),
(207251, '2.60.40.10-FF-004592', NULL, NULL, 98, NULL, NULL, 207251),
(207252, '3.10.50.10-FF-000039', NULL, 'AGAP008562-PA', 77, NULL, NULL, 207252),
(207253, '2.30.29.30-FF-001032', NULL, 'Predicted protein', 193, NULL, NULL, 207253),
(207254, '3.30.870.10-FF-000174', NULL, 'Mitochondrial cardiolipin hydrolase', 217, NULL, NULL, 207254),
(207255, '3.40.30.10-FF-000604', NULL, 'Ubiquitin fusion degradation protein 2, putative', 108, NULL, NULL, 207255);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(207256, '3.40.50.300-FF-006863', NULL, 'Arsenical pump-driving ATPase', 332, NULL, NULL, 207256),
(207257, '1.10.150.110-FF-000013', NULL, 'Crossover junction endonuclease MUS81', 70, NULL, NULL, 207257),
(207258, '3.40.190.10-FF-000119', NULL, 'glutamate receptor ionotropic, NMDA 1 isoform X2', 45, NULL, NULL, 207258),
(207259, '3.40.50.1000-FF-000260', NULL, 'Hydrolase, haloacid dehalogenase-like family', 131, NULL, NULL, 207259),
(207260, '1.25.40.10-FF-003523', NULL, 'Uncharacterized protein', 127, NULL, NULL, 207260),
(207261, '1.10.510.10-FF-003947', NULL, NULL, 57, NULL, NULL, 207261),
(207262, '3.40.50.720-FF-002380', NULL, 'Uncharacterized protein', 156, NULL, NULL, 207262),
(207263, '3.50.7.10-FF-000046', NULL, NULL, 70, NULL, NULL, 207263),
(207264, '3.20.20.70-FF-000105', NULL, 'Glycerol uptake operon antiterminator regulatory protein', 186, NULL, NULL, 207264),
(207265, '2.130.10.10-FF-000859', NULL, 'Cytoplasmic dynein intermediate chain, putative', 327, NULL, NULL, 207265),
(207266, '1.20.120.1770-FF-000003', NULL, 'Ferric chelate reductase 1', 184, NULL, NULL, 207266),
(207267, '3.40.50.300-FF-002024', NULL, 'ESX-1 secretion system protein EccCb1', 306, NULL, NULL, 207267),
(207268, '2.60.120.10-FF-000362', NULL, 'cAMP-dependent protein kinase regulatory chain', 157, NULL, NULL, 207268),
(207269, '3.40.50.2000-FF-001004', NULL, 'UDP-glucuronosyltransferase', 257, NULL, NULL, 207269),
(207270, '1.25.10.10-FF-003010', NULL, 'Uncharacterized protein', 585, NULL, NULL, 207270),
(207271, '2.130.10.10-FF-003732', NULL, 'Uncharacterized protein', 335, NULL, NULL, 207271),
(207272, '2.30.29.210-FF-000001', NULL, 'FACT complex subunit spt16', 128, NULL, NULL, 207272),
(207273, '3.40.190.10-FF-000299', NULL, 'Molybdate ABC transporter periplasmic substrate-binding protein', 132, NULL, NULL, 207273),
(207274, '2.30.29.30-FF-000649', NULL, 'Non-specific serine/threonine protein kinase', 103, NULL, NULL, 207274),
(207275, '1.20.1250.20-FF-001886', NULL, 'Major facilitator superfamily protein', 89, NULL, NULL, 207275),
(207276, '3.30.70.360-FF-000041', NULL, 'Putative Peptidase M20/M25/M40 family', 171, NULL, NULL, 207276),
(207277, '2.60.120.10-FF-000710', NULL, 'Cyclic nucleotide-binding', 154, NULL, NULL, 207277),
(207278, '1.10.418.10-FF-000023', NULL, 'EH domain-binding protein 1 isoform X1', 110, NULL, NULL, 207278),
(207279, '3.20.20.70-FF-000027', NULL, 'Dihydropyrimidine dehydrogenase [NADP(+)]', 300, NULL, NULL, 207279),
(207280, '2.60.40.200-FF-000029', NULL, 'Copper/zinc superoxide dismutase', 146, NULL, NULL, 207280),
(207281, '3.80.10.10-FF-001074', NULL, 'Ubiquitin ligase complex F-box protein GRR1, putative', 78, NULL, NULL, 207281),
(207282, '3.30.70.330-FF-001454', NULL, 'RNA exonuclease 5', 118, NULL, NULL, 207282),
(207283, '3.30.720.210-FF-000026', NULL, 'ATP-dependent zinc metalloprotease FtsH', 71, NULL, NULL, 207283),
(207284, '3.30.40.10-FF-000403', NULL, 'RING finger protein 208', 87, NULL, NULL, 207284),
(207285, '3.40.50.150-FF-000489', NULL, 'Methyltransferase, putative', 195, NULL, NULL, 207285),
(207286, '2.60.40.10-FF-005901', NULL, NULL, 68, NULL, NULL, 207286),
(207287, '3.40.50.300-FF-002496', NULL, 'Uncharacterized protein, isoform A', 213, NULL, NULL, 207287),
(207288, '1.20.1740.10-FF-000111', NULL, 'Probable general amino acid permease', 475, NULL, NULL, 207288),
(207289, '3.30.450.40-FF-000078', NULL, 'Stage II sporulation protein E', 160, NULL, NULL, 207289),
(207290, '1.20.58.390-FF-000297', NULL, 'Uncharacterized protein', 96, NULL, NULL, 207290),
(207291, '3.80.10.10-FF-002939', NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', 76, NULL, NULL, 207291),
(207292, '3.40.50.1820-FF-000640', NULL, 'Putative carboxypeptidase 2', 143, NULL, NULL, 207292),
(207293, '1.10.600.10-FF-000060', NULL, 'Terpenoid synthase', 321, NULL, NULL, 207293),
(207294, '3.40.50.20-FF-000024', NULL, 'Phosphoribosylaminoimidazole carboxylase family protein / AIR carboxylase family protein', 112, NULL, NULL, 207294),
(207295, '3.40.50.300-FF-005244', NULL, 'DNA polymerase III delta prime subunit', 195, NULL, NULL, 207295);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(207296, '3.30.160.60-FF-004569', NULL, NULL, 39, NULL, NULL, 207296),
(207297, '3.10.100.10-FF-000194', NULL, NULL, 134, NULL, NULL, 207297),
(207298, '3.30.450.20-FF-000414', NULL, 'Sensory transduction histidine kinase', 130, NULL, NULL, 207298),
(207299, '1.20.1250.20-FF-002033', NULL, 'Predicted protein', 337, NULL, NULL, 207299),
(207300, '2.30.29.230-FF-000007', NULL, 'GTPase activating protein-like', 141, NULL, NULL, 207300),
(207301, '1.25.10.10-FF-000576', NULL, 'Binding', 402, NULL, NULL, 207301),
(207302, '3.30.70.330-FF-000509', NULL, 'Polyadenylate-binding protein RBP47C isoform A', 77, NULL, NULL, 207302),
(207303, '3.40.50.300-FF-002838', NULL, 'Uncharacterized ATPase YjoB', 171, NULL, NULL, 207303),
(207304, '1.10.510.10-FF-001839', NULL, 'Cell division control protein, putative', 110, NULL, NULL, 207304),
(207305, '3.90.830.10-FF-000006', NULL, 'Vacuolar protein sorting-associated protein 33A', 125, NULL, NULL, 207305),
(207306, '3.30.559.10-FF-000080', NULL, 'Carnitine acyltransferase, putative', 33, NULL, NULL, 207306),
(207307, '3.40.50.1010-FF-000061', NULL, 'Single-stranded DNA endonuclease (Eurofung)', 175, NULL, NULL, 207307),
(207308, '1.10.510.10-FF-002986', NULL, NULL, 173, NULL, NULL, 207308),
(207309, '3.80.10.10-FF-000702', NULL, 'Leucine-rich repeat protein', 83, NULL, NULL, 207309),
(207310, '3.40.640.10-FF-000497', NULL, 'Uncharacterized protein', 260, NULL, NULL, 207310),
(207311, '2.60.40.10-FF-005553', NULL, NULL, 114, NULL, NULL, 207311),
(207312, '3.30.160.60-FF-002332', NULL, 'Zinc finger 30C', 25, NULL, NULL, 207312),
(207313, '3.10.10.10-FF-000037', NULL, NULL, 72, NULL, NULL, 207313),
(207314, '1.20.1070.10-FF-000346', NULL, 'Adrenergic, alpha-2D-, receptor a', 319, NULL, NULL, 207314),
(207315, '3.90.1150.10-FF-000026', NULL, 'Pyridoxal phosphate-dependent aminotransferase', 123, NULL, NULL, 207315),
(207316, '1.10.10.10-FF-000952', NULL, '26S proteasome non-ATPase regulatory subunit', 82, NULL, NULL, 207316),
(207317, '3.40.50.2000-FF-000565', NULL, '1,2-diacylglycerol 3-glucosyltransferase', 209, NULL, NULL, 207317),
(207318, '3.20.10.10-FF-000071', NULL, 'Uncharacterized protein', 166, NULL, NULL, 207318),
(207319, '3.30.160.60-FF-005058', NULL, NULL, 77, NULL, NULL, 207319),
(207320, '2.60.40.1490-FF-000003', NULL, 'Anti-silencing function 1B histone chaperone', 25, NULL, NULL, 207320),
(207321, '1.20.58.150-FF-000017', NULL, NULL, 129, NULL, NULL, 207321),
(207322, '3.20.20.100-FF-000214', NULL, 'Uncharacterized protein', 85, NULL, NULL, 207322),
(207323, '3.80.10.10-FF-000141', NULL, 'Leucine-rich repeat-containing protein 59', 217, NULL, NULL, 207323),
(207324, '1.20.80.60-FF-000004', NULL, 'Sorting nexin-17 homolog', 61, NULL, NULL, 207324),
(207325, '2.40.160.10-FF-000037', NULL, 'Beta-galactosidase', 328, NULL, NULL, 207325),
(207326, '1.25.40.420-FF-000067', NULL, 'Uncharacterized protein', 120, NULL, NULL, 207326),
(207327, '2.60.40.10-FF-000865', NULL, 'AXL receptor tyrosine kinase', 107, NULL, NULL, 207327),
(207328, '1.20.1070.10-FF-000841', NULL, 'Olfactory receptor', 292, NULL, NULL, 207328),
(207329, '3.10.20.360-FF-000002', NULL, 'Patronin, isoform M', 119, NULL, NULL, 207329),
(207330, '1.10.10.60-FF-000848', NULL, NULL, 61, NULL, NULL, 207330),
(207331, '3.40.50.300-FF-005374', NULL, 'mRNA cleavage and polyadenylation factor CLP1', 231, NULL, NULL, 207331),
(207332, '1.10.8.10-FF-000193', NULL, 'Ubiquitinyl hydrolase 1', 40, NULL, NULL, 207332),
(207333, '2.40.50.90-FF-000070', NULL, 'Tudor domain-containing protein 1', 88, NULL, NULL, 207333),
(207334, '3.30.450.20-FF-000072', NULL, 'Period circadian protein', 135, NULL, NULL, 207334),
(207335, '3.40.50.410-FF-000134', NULL, 'Efk-1', 188, NULL, NULL, 207335),
(207336, '3.30.40.10-FF-001022', NULL, 'Structure-specific endonuclease subunit SLX1 homolog', 66, NULL, NULL, 207336),
(207337, '1.20.1070.10-FF-001111', NULL, 'Uncharacterized protein', 310, NULL, NULL, 207337),
(207338, '3.40.50.720-FF-001891', NULL, 'Uncharacterized protein', 184, NULL, NULL, 207338),
(207339, '3.30.160.60-FF-004221', NULL, NULL, 24, NULL, NULL, 207339);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(207340, '2.60.40.10-FF-005772', NULL, NULL, 76, NULL, NULL, 207340),
(207341, '3.30.70.980-FF-000002', NULL, 'Probable transcriptional regulatory protein YebC', 77, NULL, NULL, 207341),
(207342, '3.40.50.1440-FF-000150', NULL, 'At4g37190', 282, NULL, NULL, 207342),
(207343, '3.90.1150.10-FF-000335', NULL, 'Kynureninase', 126, NULL, NULL, 207343),
(207344, '3.40.50.300-FF-004974', NULL, 'AIG1 family protein putative', 197, NULL, NULL, 207344),
(207345, '1.10.10.60-FF-000978', NULL, NULL, 94, NULL, NULL, 207345),
(207346, '1.10.490.160-FF-000008', NULL, NULL, 88, NULL, NULL, 207346),
(207347, '1.20.1070.10-FF-000711', NULL, 'Uncharacterized protein', 351, NULL, NULL, 207347),
(207348, '1.10.443.10-FF-000019', NULL, 'Site-specific recombinase, phage integrase family', 186, NULL, NULL, 207348),
(207349, '3.20.20.70-FF-000555', NULL, NULL, 86, NULL, NULL, 207349),
(207350, '1.10.357.70-FF-000011', NULL, 'TNF alpha induced protein 2', 174, NULL, NULL, 207350),
(207351, '3.30.450.20-FF-000381', NULL, 'Histidine kinase', 123, NULL, NULL, 207351),
(207352, '3.40.50.410-FF-000281', NULL, 'Integrin beta', 47, NULL, NULL, 207352),
(207353, '2.60.40.10-FF-004608', NULL, NULL, 82, NULL, NULL, 207353),
(207354, '3.40.309.10-FF-000115', NULL, 'Long-chain acyl-protein thioester reductase', 57, NULL, NULL, 207354),
(207355, '3.40.50.150-FF-001815', NULL, NULL, 100, NULL, NULL, 207355),
(207356, '1.25.40.10-FF-002758', NULL, 'N-ethylmaleimide-sensitive factor attachment protei', 186, NULL, NULL, 207356),
(207357, '2.60.40.10-FF-005406', NULL, NULL, 42, NULL, NULL, 207357),
(207358, '1.10.472.10-FF-000295', NULL, 'Uncharacterized protein', 122, NULL, NULL, 207358),
(207359, '3.40.30.10-FF-000127', NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 2', 99, NULL, NULL, 207359),
(207360, '3.40.50.1820-FF-001388', NULL, 'GPI inositol-deacylase', 218, NULL, NULL, 207360),
(207361, '3.40.630.70-FF-000008', NULL, 'Leucyl/phenylalanyl-tRNA--protein transferase', 181, NULL, NULL, 207361),
(207362, '3.30.160.60-FF-002315', NULL, NULL, 31, NULL, NULL, 207362),
(207363, '1.25.40.90-FF-000062', NULL, 'I/LWEQ domain containing protein', 118, NULL, NULL, 207363),
(207364, '2.60.40.10-FF-006025', NULL, NULL, 89, NULL, NULL, 207364),
(207365, '3.10.110.10-FF-000239', NULL, 'NEDD8-conjugating enzyme Ubc12', 160, NULL, NULL, 207365),
(207366, '3.30.230.70-FF-000082', NULL, 'Predicted protein', 228, NULL, NULL, 207366),
(207367, '3.30.40.10-FF-000038', NULL, 'E3 ubiquitin-protein ligase listerin', 68, NULL, NULL, 207367),
(207368, '2.60.40.10-FF-005536', NULL, NULL, 50, NULL, NULL, 207368),
(207369, '3.30.70.270-FF-000121', NULL, 'AGAP001404-PA', 155, NULL, NULL, 207369),
(207370, '2.60.120.230-FF-000008', NULL, NULL, 90, NULL, NULL, 207370),
(207371, '3.40.50.300-FF-005683', NULL, 'Dynein heavy chain', 186, NULL, NULL, 207371),
(207372, '2.60.15.10-FF-000014', NULL, 'ATP synthase, epsilon chain, putative', 137, NULL, NULL, 207372),
(207373, '3.40.50.2300-FF-000357', NULL, 'DNA-binding response regulator', 84, NULL, NULL, 207373),
(207374, '1.20.140.10-FF-000123', NULL, 'Uncharacterized protein', 116, NULL, NULL, 207374),
(207375, '3.40.50.300-FF-001192', NULL, 'Phosphonate C-P lyase system protein PhnL', 224, NULL, NULL, 207375),
(207376, '1.25.40.10-FF-004703', NULL, 'Uncharacterized protein', 97, NULL, NULL, 207376),
(207377, '2.30.29.30-FF-000885', NULL, 'Rab_C103 protein', 172, NULL, NULL, 207377),
(207378, '3.90.550.10-FF-000496', NULL, 'Hexosyltransferase', 293, NULL, NULL, 207378),
(207379, '1.20.1050.10-FF-000148', NULL, 'hematopoietic prostaglandin D synthase', 107, NULL, NULL, 207379),
(207380, '1.20.120.810-FF-000006', NULL, 'Protein CBR-DEB-1, isoform b', 128, NULL, NULL, 207380),
(207381, '2.60.40.10-FF-001354', NULL, 'Sallimus, isoform Q', 99, NULL, NULL, 207381),
(207382, '3.30.1150.10-FF-000017', NULL, 'Energy transducer TonB', 95, NULL, NULL, 207382),
(207383, '1.10.472.10-FF-000643', NULL, 'Uncharacterized protein', 145, NULL, NULL, 207383),
(207384, '3.80.10.10-FF-002254', NULL, 'Leucine-rich repeat containing protein', 114, NULL, NULL, 207384);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(207385, '3.90.190.10-FF-000310', NULL, 'Uncharacterized protein', 273, NULL, NULL, 207385),
(207386, '3.20.20.80-FF-000092', NULL, 'Probable alpha-L-arabinofuranosidase A', 314, NULL, NULL, 207386),
(207387, '2.10.60.10-FF-000065', NULL, 'Receptor protein serine/threonine kinase', 99, NULL, NULL, 207387),
(207388, '1.10.238.180-FF-000001', NULL, 'Stromal interaction molecule 1', 75, NULL, NULL, 207388),
(207389, '1.25.40.10-FF-003158', NULL, 'Pentatricopeptide repeat-containing protein At3g48250, chloroplastic', 118, NULL, NULL, 207389),
(207390, '3.20.20.80-FF-000434', NULL, 'Chromosome 19, whole genome shotgun sequence', 272, NULL, NULL, 207390),
(207391, '2.40.30.10-FF-000438', NULL, 'Uncharacterized protein', 58, NULL, NULL, 207391),
(207392, '1.10.8.270-FF-000179', NULL, 'Uncharacterized protein', 98, NULL, NULL, 207392),
(207393, '3.40.850.10-FF-000344', NULL, 'Uncharacterized protein', 178, NULL, NULL, 207393),
(207394, '1.10.510.10-FF-002458', NULL, 'Uncharacterized protein', 280, NULL, NULL, 207394),
(207395, '2.10.10.20-FF-000008', NULL, 'Chitinase', 52, NULL, NULL, 207395),
(207396, '3.20.20.80-FF-000249', NULL, 'Counting factor 50', 211, NULL, NULL, 207396),
(207397, '3.30.70.20-FF-000088', NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase, mitochondrial', 96, NULL, NULL, 207397),
(207398, '3.30.160.60-FF-005188', NULL, NULL, 72, NULL, NULL, 207398),
(207399, '3.30.230.130-FF-000020', NULL, 'CULLIN 8', 150, NULL, NULL, 207399),
(207400, '1.10.400.10-FF-000095', NULL, 'Uncharacterized protein', 40, NULL, NULL, 207400),
(207401, '2.60.200.20-FF-000101', NULL, 'Serine/threonine protein kinase, putative', 104, NULL, NULL, 207401),
(207402, '3.40.50.2000-FF-000695', NULL, 'Glycosyl transferase family 9', 183, NULL, NULL, 207402),
(207403, '3.30.160.60-FF-003260', NULL, 'Transcriptional repressor CTCF', 28, NULL, NULL, 207403),
(207404, '3.40.1340.10-FF-000013', NULL, 'RNA polymerase Rpb5, N-terminal domain containing protein', 126, NULL, NULL, 207404),
(207405, '3.40.350.10-FF-000087', NULL, 'Protein CBG01440', 148, NULL, NULL, 207405),
(207406, '1.10.565.10-FF-000201', NULL, 'Uncharacterized protein', 222, NULL, NULL, 207406),
(207407, '3.40.1180.10-FF-000039', NULL, 'Predicted protein', 111, NULL, NULL, 207407),
(207408, '2.130.10.10-FF-004884', NULL, 'WD40 repeat protein', 118, NULL, NULL, 207408),
(207409, '1.10.30.10-FF-000043', NULL, 'Transcription factor A, mitochondrial', 69, NULL, NULL, 207409),
(207410, '1.10.510.10-FF-002767', NULL, NULL, 167, NULL, NULL, 207410),
(207411, '2.30.110.10-FF-000008', NULL, 'Flagellar brake protein YcgR', 107, NULL, NULL, 207411),
(207412, '3.30.420.40-FF-000930', NULL, 'Uncharacterized protein', 109, NULL, NULL, 207412),
(207413, '2.70.170.10-FF-000284', NULL, 'Predicted protein', 66, NULL, NULL, 207413),
(207414, '1.10.10.10-FF-000502', NULL, 'ORC1-type DNA replication protein', 101, NULL, NULL, 207414),
(207415, '3.30.160.60-FF-000314', NULL, 'Uncharacterized protein', 27, NULL, NULL, 207415),
(207416, '2.60.120.10-FF-000581', NULL, 'DNR protein', 141, NULL, NULL, 207416),
(207417, '3.40.30.10-FF-000913', NULL, 'Uba3-binding protein but1', 130, NULL, NULL, 207417),
(207418, '1.20.58.60-FF-000520', NULL, 'Uncharacterized protein', 299, NULL, NULL, 207418),
(207419, '2.70.20.40-FF-000001', NULL, 'Matrix protein', 142, NULL, NULL, 207419),
(207420, '3.20.20.100-FF-000130', NULL, 'NADP(+) coupled glycerol dehydrogenase (Eurofung)', 135, NULL, NULL, 207420),
(207421, '1.10.10.10-FF-000974', NULL, 'Two-component response regulator', 84, NULL, NULL, 207421),
(207422, '1.25.40.10-FF-002197', NULL, 'Membrane protein involved in organellar division, putative', 118, NULL, NULL, 207422),
(207423, '3.60.40.10-FF-000340', NULL, 'Auxin-responsive protein', 126, NULL, NULL, 207423),
(207424, '3.30.390.50-FF-000025', NULL, 'Uncharacterized protein', 91, NULL, NULL, 207424),
(207425, '2.30.30.40-FF-000487', NULL, 'Uncharacterized protein', 75, NULL, NULL, 207425),
(207426, '1.10.287.770-FF-000024', NULL, 'Pickpocket protein 19', 61, NULL, NULL, 207426);
INSERT INTO "PUBLIC"."MODEL" VALUES
(207427, '1.25.40.20-FF-001148', NULL, 'Caskin-1', 143, NULL, NULL, 207427),
(207428, '2.40.50.140-FF-000012', NULL, 'DNA ligase', 74, NULL, NULL, 207428),
(207429, '3.40.50.300-FF-007700', NULL, 'Uncharacterized protein', 103, NULL, NULL, 207429),
(207430, '1.20.120.20-FF-000006', NULL, 'Apolipoprotein A-V', 150, NULL, NULL, 207430),
(207431, '1.10.287.470-FF-000041', NULL, 'Multidrug resistance protein, putative', 63, NULL, NULL, 207431),
(207432, '3.40.50.300-FF-002810', NULL, 'Blast:Dynein heavy chain 6, axonemal', 190, NULL, NULL, 207432),
(207433, '3.40.50.10860-FF-000041', NULL, 'Pentafunctional AROM polypeptide, putative', 97, NULL, NULL, 207433),
(207434, '2.60.120.260-FF-000101', NULL, 'uncharacterized protein LOC108094628 isoform X2', 143, NULL, NULL, 207434),
(207435, '3.40.50.300-FF-008206', NULL, 'Uncharacterized protein', 73, NULL, NULL, 207435),
(207436, '3.30.465.10-FF-000120', NULL, 'FAD linked oxidase domain protein', 231, NULL, NULL, 207436),
(207437, '2.10.25.10-FF-000023', NULL, 'Fibrillin 2', 40, NULL, NULL, 207437),
(207438, '1.10.1520.10-FF-000058', NULL, 'Endoribonuclease Dicer-like protein 3', 184, NULL, NULL, 207438),
(207439, '3.40.50.720-FF-002363', NULL, 'S-adenosylhomocysteine hydrolase, putative', 160, NULL, NULL, 207439),
(207440, '1.10.10.750-FF-000052', NULL, 'Uncharacterized protein', 48, NULL, NULL, 207440),
(207441, '3.30.160.60-FF-001348', NULL, 'Zinc finger protein 646', 25, NULL, NULL, 207441),
(207442, '2.30.29.30-FF-000104', NULL, 'collagen type IV alpha-3-binding protein-like isoform X2', 103, NULL, NULL, 207442),
(207443, '1.20.1510.10-FF-000066', NULL, 'Cation efflux protein/ zinc transporter, putative', 223, NULL, NULL, 207443),
(207444, '2.130.10.10-FF-004120', NULL, 'Os02g0307200 protein', 189, NULL, NULL, 207444),
(207445, '1.20.1340.10-FF-000002', NULL, 'Tryptophan decarboxylase 1', 81, NULL, NULL, 207445),
(207446, '2.10.25.10-FF-001113', NULL, 'Uncharacterized protein', 41, NULL, NULL, 207446),
(207447, '3.80.10.10-FF-002485', NULL, 'Uncharacterized protein', 64, NULL, NULL, 207447),
(207448, '2.60.40.2700-FF-000001', NULL, 'Transmembrane protein', 82, NULL, NULL, 207448),
(207449, '2.40.70.10-FF-000295', NULL, NULL, 100, NULL, NULL, 207449),
(207450, '1.10.150.810-FF-000009', NULL, 'Uncharacterized protein', 84, NULL, NULL, 207450),
(207451, '3.20.20.70-FF-000336', NULL, 'Triosephosphate isomerase', 167, NULL, NULL, 207451),
(207452, '2.60.40.1080-FF-000015', NULL, 'Bacterial Ig-like domain (Group 2)', 92, NULL, NULL, 207452),
(207453, '2.40.50.100-FF-000051', NULL, '50S ribosomal protein L27', 111, NULL, NULL, 207453),
(207454, '3.40.190.10-FF-000535', NULL, 'ABC transporter, periplasmic substrate-binding protein', 167, NULL, NULL, 207454),
(207455, '1.10.12.10-FF-000012', NULL, 'Phenylacetate degradation enoyl-CoA hydratase PaaB', 58, NULL, NULL, 207455),
(207456, '3.30.70.270-FF-000014', NULL, 'DNA polymerase kappa subunit', 102, NULL, NULL, 207456),
(207457, '3.30.60.90-FF-000046', NULL, 'Transcriptional adapter', 54, NULL, NULL, 207457),
(207458, '3.80.10.10-FF-001866', NULL, 'Os06g0587900 protein', 74, NULL, NULL, 207458),
(207459, '3.30.450.30-FF-000058', NULL, 'Uncharacterized protein', 117, NULL, NULL, 207459),
(207460, '3.30.160.60-FF-003496', NULL, 'Zinc finger protein 19', 27, NULL, NULL, 207460),
(207461, '2.60.120.10-FF-000053', NULL, 'Homogentisate 1,2-dioxygenase', 137, NULL, NULL, 207461),
(207462, '2.40.50.120-FF-000057', NULL, 'Uncharacterized protein', 128, NULL, NULL, 207462),
(207463, '3.80.10.10-FF-002378', NULL, 'Protein CBR-EGG-6', 140, NULL, NULL, 207463),
(207464, '3.30.430.20-FF-000054', NULL, 'Putative cysteine-rich receptor-like protein kinase 43', 101, NULL, NULL, 207464),
(207465, '3.40.50.300-FF-005458', NULL, 'Uncharacterized protein', 233, NULL, NULL, 207465),
(207466, '2.40.50.90-FF-000154', NULL, 'Uncharacterized protein', 139, NULL, NULL, 207466),
(207467, '2.30.42.10-FF-000067', NULL, 'Golgi-associated PDZ and coiled-coil motif-containing protein-like', 87, NULL, NULL, 207467),
(207468, '2.120.10.30-FF-000580', NULL, 'Uncharacterized protein', 171, NULL, NULL, 207468);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(207469, '3.30.2010.30-FF-000002', NULL, 'Putative aminopeptidase N', 84, NULL, NULL, 207469),
(207470, '2.30.29.30-FF-000093', NULL, 'SET binding factor 2', 111, NULL, NULL, 207470),
(207471, '1.10.472.80-FF-000080', NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', 126, NULL, NULL, 207471),
(207472, '1.10.287.1150-FF-000010', NULL, 'Oxoglutarate dehydrogenase (Succinyl-transferring), E1 component', 94, NULL, NULL, 207472),
(207473, '3.60.150.10-FF-000005', NULL, 'Chorismate synthase', 196, NULL, NULL, 207473),
(207474, '1.20.1270.60-FF-000213', NULL, 'Chromosome 13 SCAF14555, whole genome shotgun sequence', 118, NULL, NULL, 207474),
(207475, '1.10.10.10-FF-001121', NULL, 'DNA-binding transcriptional activator', 98, NULL, NULL, 207475),
(207476, '2.30.40.10-FF-000136', NULL, 'Guanine deaminase', 130, NULL, NULL, 207476),
(207477, '3.30.460.90-FF-000003', NULL, 'MB21D2 isoform 1', 157, NULL, NULL, 207477),
(207478, '3.30.800.10-FF-000006', NULL, '1-phosphatidylinositol-3-phosphate 5-kinase FAB1B', 156, NULL, NULL, 207478),
(207479, '2.70.150.10-FF-000176', NULL, 'Uncharacterized protein', 133, NULL, NULL, 207479),
(207480, '1.25.40.530-FF-000009', NULL, 'Myosin XVA', 110, NULL, NULL, 207480),
(207481, '1.20.1070.10-FF-000239', NULL, 'G-protein-coupled receptor 65', 293, NULL, NULL, 207481),
(207482, '2.60.40.10-FF-000882', NULL, 'Tyrosine-protein kinase receptor', 102, NULL, NULL, 207482),
(207483, '3.40.50.2300-FF-001285', NULL, NULL, 163, NULL, NULL, 207483),
(207484, '3.40.50.10130-FF-000058', NULL, 'Uncharacterized protein', 67, NULL, NULL, 207484),
(207485, '2.10.70.10-FF-000127', NULL, 'Hig-anchoring scaffold protein, isoform A', 68, NULL, NULL, 207485),
(207486, '3.70.10.10-FF-000006', NULL, 'Checkpoint protein', 280, NULL, NULL, 207486),
(207487, '1.50.40.10-FF-000025', NULL, 'mitochondrial folate transporter/carrier', 286, NULL, NULL, 207487),
(207488, '3.20.20.150-FF-000083', NULL, 'Protein arginine N-methyltransferase 1.5', 112, NULL, NULL, 207488),
(207489, '3.40.50.2000-FF-000256', NULL, 'GDP-Man:Man(3)GlcNAc(2)-PP-Dol alpha-1,2-mannosyltransferase', 207, NULL, NULL, 207489),
(207490, '1.10.3730.20-FF-000004', NULL, 'QacE family quaternary ammonium compound efflux SMR transporter', 104, NULL, NULL, 207490),
(207491, '1.20.58.60-FF-000413', NULL, 'AGAP009554-PA', 310, NULL, NULL, 207491),
(207492, '3.40.50.10810-FF-000178', NULL, 'Helicase superfamily, c-terminal domain protein', 123, NULL, NULL, 207492),
(207493, '3.30.160.60-FF-001950', NULL, 'Zinc finger protein 518B', 57, NULL, NULL, 207493),
(207494, '1.20.1070.10-FF-000150', NULL, 'probable G-protein coupled receptor 34', 307, NULL, NULL, 207494),
(207495, '1.10.150.20-FF-000224', NULL, 'DNA polymerase I', 160, NULL, NULL, 207495),
(207496, '3.40.720.10-FF-000104', NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase-like', 80, NULL, NULL, 207496),
(207497, '1.20.1560.10-FF-000693', NULL, 'ATP-binding cassette transporter, subfamily C, member 10, group MRP protein PpABCC10', 334, NULL, NULL, 207497),
(207498, '2.130.10.10-FF-003501', NULL, 'Uncharacterized protein', 253, NULL, NULL, 207498),
(207499, '1.10.287.70-FF-000775', NULL, 'Uncharacterized protein', 113, NULL, NULL, 207499),
(207500, '1.10.10.60-FF-000034', NULL, 'HTH-type transcriptional repressor FabR', 52, NULL, NULL, 207500),
(207501, '1.10.510.10-FF-003279', NULL, NULL, 99, NULL, NULL, 207501),
(207502, '3.40.50.150-FF-001473', NULL, NULL, 130, NULL, NULL, 207502),
(207503, '4.10.400.10-FF-000229', NULL, 'Low-density lipoprotein receptor-related protein', 42, NULL, NULL, 207503),
(207504, '1.25.40.10-FF-002674', NULL, 'Uncharacterized protein', 99, NULL, NULL, 207504),
(207505, '3.90.245.10-FF-000034', NULL, 'Uncharacterized protein', 389, NULL, NULL, 207505),
(207506, '3.30.2350.20-FF-000047', NULL, NULL, 227, NULL, NULL, 207506),
(207507, '3.30.70.330-FF-000257', NULL, 'CCR4-NOT core complex subunit Not4', 84, NULL, NULL, 207507),
(207508, '3.40.50.2000-FF-000149', NULL, 'Glycogen phosphorylase, muscle form', 495, NULL, NULL, 207508);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(207509, '1.20.1250.20-FF-002286', NULL, 'Uncharacterized protein', 81, NULL, NULL, 207509),
(207510, '1.25.10.10-FF-001065', NULL, 'Pumilio homolog 23', 351, NULL, NULL, 207510),
(207511, '2.130.10.10-FF-000753', NULL, 'Coatomer alpha subunit, putative', 171, NULL, NULL, 207511),
(207512, '3.20.20.40-FF-000001', NULL, 'Glucanase', 363, NULL, NULL, 207512),
(207513, '3.30.930.10-FF-000089', NULL, 'Phenylalanine--tRNA ligase alpha subunit', 332, NULL, NULL, 207513),
(207514, '2.60.40.60-FF-000739', NULL, 'Predicted protein', 110, NULL, NULL, 207514),
(207515, '3.30.9.10-FF-000005', NULL, 'Sarcosine oxidase, beta subunit', 158, NULL, NULL, 207515),
(207516, '1.10.10.60-FF-000742', NULL, 'Transcription termination factor, RNA polymerase I', 37, NULL, NULL, 207516),
(207517, '3.30.450.60-FF-000073', NULL, 'AP complex subunit sigma', 146, NULL, NULL, 207517),
(207518, '3.10.180.10-FF-000058', NULL, 'tRNA (guanine-N(1)-)-methyltransferase', 104, NULL, NULL, 207518),
(207519, '2.102.10.10-FF-000013', NULL, 'Nitrite reductase [NAD(P)H], small subunit', 102, NULL, NULL, 207519),
(207520, '3.30.530.20-FF-000106', NULL, 'START domain containing 7 (Predicted)', 144, NULL, NULL, 207520),
(207521, '1.25.40.120-FF-000084', NULL, 'Uncharacterized protein', 300, NULL, NULL, 207521),
(207522, '1.10.490.10-FF-000016', NULL, 'cytoglobin', 106, NULL, NULL, 207522),
(207523, '3.40.20.10-FF-000087', NULL, 'Actin-binding protein, cofilin/tropomyosin family protein', 138, NULL, NULL, 207523),
(207524, '3.80.10.10-FF-002271', NULL, 'Leucine-rich repeat-containing protein 43', 96, NULL, NULL, 207524),
(207525, '3.40.470.10-FF-000034', NULL, NULL, 207, NULL, NULL, 207525),
(207526, '4.10.280.10-FF-000039', NULL, 'DNA-binding protein inhibitor ID-3', 62, NULL, NULL, 207526),
(207527, '2.60.40.10-FF-005300', NULL, NULL, 81, NULL, NULL, 207527),
(207528, '3.60.10.10-FF-000203', NULL, 'Uncharacterized protein', 159, NULL, NULL, 207528),
(207529, '3.30.565.10-FF-000369', NULL, 'Sensor histidine kinase, HAMP and PAS domain-containing', 193, NULL, NULL, 207529),
(207530, '1.10.10.10-FF-001806', NULL, 'Uncharacterized protein', 41, NULL, NULL, 207530),
(207531, '1.10.238.10-FF-000958', NULL, 'EG:114D9.1 protein', 209, NULL, NULL, 207531),
(207532, '2.70.98.10-FF-000048', NULL, 'Aldose 1-epimerase', 356, NULL, NULL, 207532),
(207533, '3.40.630.30-FF-000250', NULL, '[Citrate [pro-3S]-lyase] ligase', 135, NULL, NULL, 207533),
(207534, '3.30.70.330-FF-000364', NULL, 'heterogeneous nuclear ribonucleoprotein 1', 82, NULL, NULL, 207534),
(207535, '3.90.380.10-FF-000010', NULL, 'Vanillate O-demethylase, oxygenase subunit', 219, NULL, NULL, 207535),
(207536, '3.40.50.10490-FF-000132', NULL, NULL, 79, NULL, NULL, 207536),
(207537, '3.40.50.80-FF-000019', NULL, 'NADH-cytochrome b5 reductase', 143, NULL, NULL, 207537),
(207538, '1.20.1250.20-FF-000032', NULL, 'Protein TsgA', 186, NULL, NULL, 207538),
(207539, '3.30.160.60-FF-001618', NULL, 'Zinc finger protein 16', 28, NULL, NULL, 207539),
(207540, '3.60.40.10-FF-000115', NULL, 'Protein phosphatase 2C 38', 338, NULL, NULL, 207540),
(207541, '1.25.10.10-FF-001430', NULL, 'Serine/threonine-protein phosphatase 4 regulatory subunit 1', 204, NULL, NULL, 207541),
(207542, '1.20.930.20-FF-000017', NULL, 'Uncharacterized protein', 117, NULL, NULL, 207542),
(207543, '2.130.10.10-FF-003715', NULL, 'Semaphorin-4D', 275, NULL, NULL, 207543),
(207544, '1.25.40.10-FF-003978', NULL, 'Uncharacterized protein', 221, NULL, NULL, 207544),
(207545, '2.30.29.30-FF-000413', NULL, 'vacuolar protein-sorting-associated protein 36 isoform X2', 80, NULL, NULL, 207545),
(207546, '3.40.50.150-FF-001214', NULL, NULL, 85, NULL, NULL, 207546),
(207547, '2.60.40.1730-FF-000031', NULL, 'Uncharacterized protein, isoform B', 228, NULL, NULL, 207547),
(207548, '1.50.10.10-FF-000040', NULL, 'alpha-1,2-Mannosidase', 342, NULL, NULL, 207548),
(207549, '1.50.40.10-FF-000132', NULL, 'Solute carrier family 25, member 33/36', 194, NULL, NULL, 207549),
(207550, '3.30.980.10-FF-000036', NULL, 'Uncharacterized protein', 89, NULL, NULL, 207550);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(207551, '2.60.120.290-FF-000205', NULL, 'Uncharacterized protein', 123, NULL, NULL, 207551),
(207552, '3.80.10.10-FF-004519', NULL, 'Predicted protein', 240, NULL, NULL, 207552),
(207553, '3.90.176.10-FF-000007', NULL, 'Lethal factor', 189, NULL, NULL, 207553),
(207554, '2.60.40.10-FF-001394', NULL, 'Immunoglobulin alpha Fc receptor', 95, NULL, NULL, 207554),
(207555, '3.60.21.10-FF-000431', NULL, 'Serine/threonine-protein phosphatase', 246, NULL, NULL, 207555),
(207556, '3.20.20.80-FF-000018', NULL, 'Beta-galactosidase', 281, NULL, NULL, 207556),
(207557, '1.25.10.10-FF-002846', NULL, 'Protein penguin-like Protein', 172, NULL, NULL, 207557),
(207558, '1.10.268.10-FF-000005', NULL, 'DNA topoisomerase medium subunit', 161, NULL, NULL, 207558),
(207559, '1.25.10.10-FF-002594', NULL, 'Uncharacterized protein', 152, NULL, NULL, 207559),
(207560, '2.60.120.290-FF-000099', NULL, 'Scavenger receptor cysteine-rich protein type 5', 117, NULL, NULL, 207560),
(207561, '2.30.30.100-FF-000223', NULL, 'Small nuclear ribonucleoprotein E', 61, NULL, NULL, 207561),
(207562, '3.40.50.170-FF-000045', NULL, 'Aldehyde dehydrogenase 1 family, member L2', 122, NULL, NULL, 207562),
(207563, '3.40.50.300-FF-003805', NULL, 'DEAD/DEAH box helicase', 48, NULL, NULL, 207563),
(207564, '3.40.50.300-FF-004839', NULL, 'V-type ATP synthase alpha chain', 291, NULL, NULL, 207564),
(207565, '2.60.120.620-FF-000024', NULL, 'Prolyl 4-hydroxylase subunit alpha, putative', 191, NULL, NULL, 207565),
(207566, '1.25.40.20-FF-000423', NULL, 'Uncharacterized protein, isoform A', 98, NULL, NULL, 207566),
(207567, '1.10.510.10-FF-000878', NULL, 'Insulin receptor a', 64, NULL, NULL, 207567),
(207568, '3.40.50.300-FF-002046', NULL, 'DnaA regulatory inactivator Hda', 126, NULL, NULL, 207568),
(207569, '1.25.40.10-FF-001578', NULL, 'Uncharacterized protein', 151, NULL, NULL, 207569),
(207570, '3.30.505.10-FF-000253', NULL, NULL, 48, NULL, NULL, 207570),
(207571, '2.60.120.340-FF-000030', NULL, 'Uncharacterized protein', 61, NULL, NULL, 207571),
(207572, '3.30.420.10-FF-000224', NULL, 'RE72821p1', 247, NULL, NULL, 207572),
(207573, '3.40.50.720-FF-000486', NULL, 'UDP-glucose 6-dehydrogenase', 202, NULL, NULL, 207573),
(207574, '2.60.40.60-FF-001144', NULL, 'Cadherin 2', 116, NULL, NULL, 207574),
(207575, '2.40.50.140-FF-000271', NULL, 'Similar to ssDNA binding protein Ssb3', 111, NULL, NULL, 207575),
(207576, '1.20.1740.10-FF-000095', NULL, 'B(0,+)-type amino acid transporter 1-like', 212, NULL, NULL, 207576),
(207577, '2.10.25.10-FF-000495', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', 35, NULL, NULL, 207577),
(207578, '3.80.10.10-FF-000832', NULL, 'Toll-like receptor 11', 221, NULL, NULL, 207578),
(207579, '1.20.1260.10-FF-000069', NULL, 'Uncharacterized protein', 83, NULL, NULL, 207579),
(207580, '1.10.630.10-FF-000680', NULL, 'Uncharacterized protein', 159, NULL, NULL, 207580),
(207581, '3.30.830.10-FF-000289', NULL, 'Uncharacterized protein', 157, NULL, NULL, 207581),
(207582, '3.80.10.10-FF-003103', NULL, 'Uncharacterized protein', 109, NULL, NULL, 207582),
(207583, '1.20.120.830-FF-000001', NULL, 'BCAR1 scaffold protein, Cas family member', 171, NULL, NULL, 207583),
(207584, '1.10.520.10-FF-000014', NULL, 'Catalase/peroxidase HPI', 167, NULL, NULL, 207584),
(207585, '3.40.1110.10-FF-000075', NULL, 'Phospholipid-transporting ATPase', 21, NULL, NULL, 207585),
(207586, '2.40.40.50-FF-000001', NULL, 'Ubiquitin fusion degradation protein 1 homolog', 113, NULL, NULL, 207586),
(207587, '3.40.309.10-FF-000132', NULL, 'Uncharacterized protein', 84, NULL, NULL, 207587),
(207588, '3.40.50.150-FF-000961', NULL, NULL, 56, NULL, NULL, 207588),
(207589, '1.20.5.1300-FF-000006', NULL, 'Histidinol dehydrogenase', 59, NULL, NULL, 207589),
(207590, '3.30.60.20-FF-000031', NULL, 'Protein kinase C alpha', 58, NULL, NULL, 207590),
(207591, '1.20.140.10-FF-000016', NULL, 'Acyl-CoA dehydrogenase FadE5', 178, NULL, NULL, 207591),
(207592, '1.20.120.850-FF-000007', NULL, 'Protein CHROMATIN REMODELING 25', 107, NULL, NULL, 207592),
(207593, '3.30.470.20-FF-000163', NULL, 'RimK-like protein', 37, NULL, NULL, 207593);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(207594, '3.40.50.1820-FF-000770', NULL, 'Medium-chain fatty acid ethyl ester synthase/esterase', 287, NULL, NULL, 207594),
(207595, '1.10.630.10-FF-000371', NULL, 'Putative cytochrome P450 120', 444, NULL, NULL, 207595),
(207596, '3.20.20.140-FF-000310', NULL, 'AAA-4 family protein', 259, NULL, NULL, 207596),
(207597, '1.25.40.180-FF-000326', NULL, NULL, 198, NULL, NULL, 207597),
(207598, '1.20.1250.20-FF-001066', NULL, 'Monocarboxylate transporter', 191, NULL, NULL, 207598),
(207599, '3.80.10.10-FF-000124', NULL, 'Coronatine-insensitive protein 1', 532, NULL, NULL, 207599),
(207600, '3.10.20.90-FF-000887', NULL, 'FERM, RhoGEF and pleckstrin domain protein 2', 56, NULL, NULL, 207600),
(207601, '1.10.555.10-FF-000066', NULL, 'Rho GTPase activator (Bem3), putative', 223, NULL, NULL, 207601),
(207602, '2.10.25.10-FF-000129', NULL, 'Low-density lipoprotein receptor-related protein 1', 42, NULL, NULL, 207602),
(207603, '3.40.250.10-FF-000029', NULL, 'Dual specificity phosphatase 9', 144, NULL, NULL, 207603),
(207604, '3.40.50.2000-FF-001077', NULL, 'Starch synthase, chloroplastic/amyloplastic', 145, NULL, NULL, 207604),
(207605, '3.80.10.10-FF-002850', NULL, 'Uncharacterized protein', 89, NULL, NULL, 207605),
(207606, '3.50.80.20-FF-000003', NULL, 'D-alanyl-D-alanine carboxypeptidase/D-alanyl-D-alanine-endopeptidase', 71, NULL, NULL, 207606),
(207607, '1.10.2000.10-FF-000024', NULL, 'Transmembrane receptor LIN-17', 127, NULL, NULL, 207607),
(207608, '3.30.160.60-FF-001242', NULL, 'zinc finger protein 746 isoform X1', 31, NULL, NULL, 207608),
(207609, '3.30.160.60-FF-005513', NULL, NULL, 71, NULL, NULL, 207609),
(207610, '3.40.50.620-FF-000681', NULL, 'Uncharacterized protein', 169, NULL, NULL, 207610),
(207611, '3.30.40.10-FF-001100', NULL, 'TRIM28 isoform 4', 52, NULL, NULL, 207611),
(207612, '1.25.10.10-FF-001301', NULL, 'Uncharacterized protein', 152, NULL, NULL, 207612),
(207613, '1.25.40.10-FF-004692', NULL, 'Uncharacterized protein', 101, NULL, NULL, 207613),
(207614, '3.80.10.10-FF-001557', NULL, 'Leucine-rich repeat kinase', 125, NULL, NULL, 207614),
(207615, '3.30.710.10-FF-000106', NULL, 'BTB/POZ domain-containing protein POB1', 139, NULL, NULL, 207615),
(207616, '3.40.50.300-FF-003193', NULL, 'Flagella-related protein FlaI', 287, NULL, NULL, 207616),
(207617, '3.30.310.180-FF-000003', NULL, 'Mediator of RNA polymerase II transcription subunit 20', 116, NULL, NULL, 207617),
(207618, '3.30.160.60-FF-002568', NULL, NULL, 28, NULL, NULL, 207618),
(207619, '3.30.1360.120-FF-000027', NULL, 'tRNA modification GTPase', 129, NULL, NULL, 207619),
(207620, '2.130.10.10-FF-001006', NULL, 'Dynein intermediate chain 1, axonemal', 185, NULL, NULL, 207620),
(207621, '3.40.50.300-FF-001405', NULL, 'Multidrug resistance protein associated1', 265, NULL, NULL, 207621),
(207622, '1.10.287.380-FF-000014', NULL, 'Mitochondrial valyl-tRNA synthetase', 72, NULL, NULL, 207622),
(207623, '1.10.630.10-FF-000005', NULL, 'cytochrome P450 4F22 isoform X2', 471, NULL, NULL, 207623),
(207624, '1.25.40.20-FF-001042', NULL, 'NePHronoPhthisis (Human kidney disease) homolog', 82, NULL, NULL, 207624),
(207625, '3.30.70.1450-FF-000009', NULL, 'SLC13 family permease', 74, NULL, NULL, 207625),
(207626, '1.10.246.90-FF-000006', NULL, 'Pre-RNA processing ribonucleoprotein, putative', 112, NULL, NULL, 207626),
(207627, '6.20.240.60-FF-000002', NULL, 'Cell wall hydrolase', 33, NULL, NULL, 207627),
(207628, '1.25.40.20-FF-001570', NULL, 'Uncharacterized protein', 69, NULL, NULL, 207628),
(207629, '1.10.565.10-FF-000095', NULL, 'COUP transcription factor 2', 75, NULL, NULL, 207629),
(207630, '2.20.100.10-FF-000240', NULL, 'Uncharacterized protein', 70, NULL, NULL, 207630),
(207631, '3.30.200.20-FF-001425', NULL, 'Insulin receptor b', 40, NULL, NULL, 207631),
(207632, '3.40.190.80-FF-000084', NULL, 'Inositol monophosphatase', 112, NULL, NULL, 207632),
(207633, '3.40.1810.10-FF-000010', NULL, 'Agamous-like MADS-box protein AGL30', 83, NULL, NULL, 207633),
(207634, '1.10.1520.10-FF-000081', NULL, 'Uncharacterized protein', 77, NULL, NULL, 207634);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(207635, '1.20.272.10-FF-000030', NULL, 'Replication factor C subunit 1', 107, NULL, NULL, 207635),
(207636, '1.10.10.650-FF-000010', NULL, 'Transcription accessory protein (S1 RNA-binding domain)', 102, NULL, NULL, 207636),
(207637, '1.10.506.10-FF-000099', NULL, 'Uncharacterized protein', 77, NULL, NULL, 207637),
(207638, '3.30.70.660-FF-000024', NULL, 'tRNA pseudouridine synthase', 182, NULL, NULL, 207638),
(207639, '3.40.50.300-FF-007953', NULL, 'MutS domain III family protein', 292, NULL, NULL, 207639),
(207640, '1.10.510.10-FF-004459', NULL, NULL, 284, NULL, NULL, 207640),
(207641, '3.40.50.1820-FF-000438', NULL, 'Possible hydrolase', 219, NULL, NULL, 207641),
(207642, '3.90.1100.10-FF-000040', NULL, 'DNA-directed RNA polymerase subunit beta', 190, NULL, NULL, 207642),
(207643, '2.30.30.100-FF-000004', NULL, 'Small nuclear ribonucleoprotein-associated proteins', 91, NULL, NULL, 207643),
(207644, '1.10.357.140-FF-000049', NULL, 'Lmo2635 protein', 164, NULL, NULL, 207644),
(207645, '1.20.5.1430-FF-000012', NULL, 'FI16628p1', 87, NULL, NULL, 207645),
(207646, '3.40.47.10-FF-000019', NULL, 'Polyketide synthase type I', 452, NULL, NULL, 207646),
(207647, '3.40.50.300-FF-008572', NULL, 'Uncharacterized protein', 89, NULL, NULL, 207647),
(207648, '3.30.1010.10-FF-000081', NULL, 'Smg-1', 130, NULL, NULL, 207648),
(207649, '1.25.40.10-FF-001814', NULL, 'Pentatricopeptide repeat-containing protein At1g77170, mitochondrial', 166, NULL, NULL, 207649),
(207650, '3.90.550.10-FF-000041', NULL, 'UDP-glucose ceramide glucosyltransferase', 228, NULL, NULL, 207650),
(207651, '3.40.50.620-FF-000534', NULL, 'Predicted protein', 126, NULL, NULL, 207651),
(207652, '3.30.160.60-FF-005660', NULL, NULL, 78, NULL, NULL, 207652),
(207653, '3.30.200.20-FF-000806', NULL, 'Putative DUF26-domain protein kinase family protein', 104, NULL, NULL, 207653),
(207654, '1.20.5.2700-FF-000005', NULL, 'NADH-quinone oxidoreductase subunit L', 78, NULL, NULL, 207654),
(207655, '3.40.190.10-FF-000900', NULL, 'Probable sensor/response regulator hybrid', 127, NULL, NULL, 207655),
(207656, '2.60.40.3510-FF-000025', NULL, 'Delta-like protein', 145, NULL, NULL, 207656),
(207657, '1.20.58.530-FF-000007', NULL, 'Myosin IE', 184, NULL, NULL, 207657),
(207658, '2.10.25.10-FF-000731', NULL, 'Wall-associated receptor kinase 2', 37, NULL, NULL, 207658),
(207659, '3.80.10.10-FF-000596', NULL, 'peroxidasin homolog', 67, NULL, NULL, 207659),
(207660, '1.25.40.10-FF-004939', NULL, 'Developmental protein DG1091', 341, NULL, NULL, 207660),
(207661, '1.20.120.1240-FF-000002', NULL, 'Dynamin-1-like protein isoform 1', 205, NULL, NULL, 207661),
(207662, '3.40.50.620-FF-000079', NULL, 'Probable nicotinate-nucleotide adenylyltransferase', 188, NULL, NULL, 207662),
(207663, '2.130.10.10-FF-005424', NULL, 'Uncharacterized protein', 250, NULL, NULL, 207663),
(207664, '3.30.565.10-FF-000392', NULL, 'Sensor histidine kinase RegB', 172, NULL, NULL, 207664),
(207665, '1.20.1160.20-FF-000002', NULL, 'Whirlin a', 78, NULL, NULL, 207665),
(207666, '3.90.79.10-FF-000012', NULL, 'Isopentenyl-diphosphate Delta-isomerase 1', 235, NULL, NULL, 207666),
(207667, '1.20.1250.20-FF-000902', NULL, 'Solute carrier organic anion transporter family member 5A1', 350, NULL, NULL, 207667),
(207668, '3.30.70.250-FF-000019', NULL, NULL, 64, NULL, NULL, 207668),
(207669, '2.130.10.10-FF-000045', NULL, 'DDB1- and CUL4-associated factor 6 isoform X2', 93, NULL, NULL, 207669),
(207670, '3.40.630.10-FF-000255', NULL, 'Nicastrin', 179, NULL, NULL, 207670),
(207671, '1.20.5.170-FF-000231', NULL, 'Uncharacterized protein', 73, NULL, NULL, 207671),
(207672, '3.90.320.10-FF-000029', NULL, 'Mitochondrial genome maintenance exonuclease 1', 172, NULL, NULL, 207672),
(207673, '2.10.220.10-FF-000212', NULL, 'Uncharacterized protein', 51, NULL, NULL, 207673),
(207674, '3.40.50.150-FF-001579', NULL, NULL, 51, NULL, NULL, 207674),
(207675, '1.10.8.430-FF-000014', NULL, 'Disease resistance protein RGA4', 88, NULL, NULL, 207675),
(207676, '3.90.1170.40-FF-000002', NULL, 'Molybdopterin synthase catalytic subunit', 143, NULL, NULL, 207676);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(207677, '4.10.800.30-FF-000007', NULL, 'Uncharacterized protein', 83, NULL, NULL, 207677),
(207678, '2.30.170.20-FF-000009', NULL, 'Predicted protein', 44, NULL, NULL, 207678),
(207679, '1.10.238.10-FF-000397', NULL, 'Glycerol-3-phosphate dehydrogenase', 109, NULL, NULL, 207679),
(207680, '3.40.30.10-FF-000149', NULL, 'Thioredoxin-like protein CITRX, chloroplastic', 112, NULL, NULL, 207680),
(207681, '3.40.50.10190-FF-000177', NULL, 'DNA polymerase III subunit epsilon DnaQ', 81, NULL, NULL, 207681),
(207682, '3.40.1090.10-FF-000139', NULL, 'Predicted protein', 84, NULL, NULL, 207682),
(207683, '1.10.150.50-FF-000222', NULL, 'transcription factor protein', 95, NULL, NULL, 207683),
(207684, '3.40.50.1240-FF-000202', NULL, NULL, 67, NULL, NULL, 207684),
(207685, '2.40.50.140-FF-001232', NULL, NULL, 47, NULL, NULL, 207685),
(207686, '2.10.25.10-FF-000276', NULL, 'Wnt inhibitory factor 1', 92, NULL, NULL, 207686),
(207687, '1.10.238.20-FF-000023', NULL, 'Odorant-binding protein 57d', 113, NULL, NULL, 207687),
(207688, '1.10.287.2250-FF-000020', NULL, 'Predicted protein', 80, NULL, NULL, 207688),
(207689, '1.20.120.1750-FF-000048', NULL, 'RBR-type E3 ubiquitin transferase', 227, NULL, NULL, 207689),
(207690, '3.40.50.300-FF-004154', NULL, 'Uncharacterized protein', 183, NULL, NULL, 207690),
(207691, '3.30.420.40-FF-000110', NULL, 'heat shock 70 kDa protein 13 isoform X1', 50, NULL, NULL, 207691),
(207692, '1.10.45.10-FF-000004', NULL, 'L-gulonolactone oxidase', 35, NULL, NULL, 207692),
(207693, '2.20.100.10-FF-000111', NULL, 'ADAMTS-like protein 4 isoform X1', 73, NULL, NULL, 207693),
(207694, '1.10.510.10-FF-003155', NULL, NULL, 174, NULL, NULL, 207694),
(207695, '3.50.50.60-FF-000272', NULL, 'Dihydrolipoyl dehydrogenase', 122, NULL, NULL, 207695),
(207696, '1.20.1250.20-FF-000717', NULL, 'Uncharacterized transporter C460.03', 169, NULL, NULL, 207696),
(207697, '2.130.10.10-FF-003479', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 308, NULL, NULL, 207697),
(207698, '3.30.160.60-FF-003187', NULL, NULL, 33, NULL, NULL, 207698),
(207699, '3.30.40.10-FF-000482', NULL, 'SNF2 helicase, putative', 63, NULL, NULL, 207699),
(207700, '2.70.160.11-FF-000088', NULL, 'Protein arginine N-methyltransferase', 195, NULL, NULL, 207700),
(207701, '2.80.10.50-FF-000200', NULL, 'Inositol 1,4,5-trisphosphate receptor-like protein A', 207, NULL, NULL, 207701),
(207702, '3.10.350.10-FF-000021', NULL, 'Probable cell wall hydrolase LytN', 53, NULL, NULL, 207702),
(207703, '2.60.260.20-FF-000184', NULL, 'Chaperone protein dnaJ 3', 57, NULL, NULL, 207703),
(207704, '3.40.140.10-FF-000133', NULL, 'Riboflavin biosynthesis protein RibD', 134, NULL, NULL, 207704),
(207705, '3.40.109.10-FF-000004', NULL, 'Iodotyrosine deiodinase 1', 217, NULL, NULL, 207705),
(207706, '2.60.40.10-FF-002208', NULL, 'CD96 isoform 3', 122, NULL, NULL, 207706),
(207707, '3.20.20.20-FF-000006', NULL, 'Dihydropteroate synthase', 279, NULL, NULL, 207707),
(207708, '3.90.640.10-FF-000267', NULL, 'HSP70 domain-containing protein', 74, NULL, NULL, 207708),
(207709, '3.40.50.1910-FF-000010', NULL, 'Vacuolar protein sorting-associated protein 45', 113, NULL, NULL, 207709),
(207710, '3.40.630.30-FF-000446', NULL, 'Predicted protein', 193, NULL, NULL, 207710),
(207711, '3.10.20.90-FF-000415', NULL, 'Ubiquitin regulatory X', 98, NULL, NULL, 207711),
(207712, '3.90.120.10-FF-000031', NULL, 'Uncharacterized protein', 75, NULL, NULL, 207712),
(207713, '1.20.1070.10-FF-000947', NULL, 'Predicted protein', 338, NULL, NULL, 207713),
(207714, '1.10.110.10-FF-000005', NULL, 'Non-specific lipid-transfer protein C6', 81, NULL, NULL, 207714),
(207715, '1.20.1070.10-FF-001875', NULL, 'Vomeronasal type-1 receptor', 293, NULL, NULL, 207715),
(207716, '3.40.605.10-FF-000056', NULL, 'Aldehyde dehydrogenase', 262, NULL, NULL, 207716),
(207717, '2.170.300.10-FF-000097', NULL, 'Uncharacterized protein', 54, NULL, NULL, 207717),
(207718, '3.90.79.10-FF-000265', NULL, 'Uncharacterized protein', 114, NULL, NULL, 207718),
(207719, '3.80.10.10-FF-000377', NULL, 'Tonsoku like, DNA repair protein', 103, NULL, NULL, 207719);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(207720, '3.30.160.60-FF-000062', NULL, 'RB-associated KRAB zinc finger protein-like', 28, NULL, NULL, 207720),
(207721, '1.20.5.1000-FF-000001', NULL, 'C-Jun-amino-terminal kinase-interacting protein 3 isoform X2', 76, NULL, NULL, 207721),
(207722, '1.10.510.10-FF-001025', NULL, 'Novel gene similar to TRAF2 and NCK-interacting kinase', 286, NULL, NULL, 207722),
(207723, '1.10.238.10-FF-000852', NULL, 'Uncharacterized protein', 68, NULL, NULL, 207723),
(207724, '3.40.50.300-FF-007392', NULL, 'Primosomal protein N''', 231, NULL, NULL, 207724),
(207725, '3.30.559.10-FF-000225', NULL, 'Uncharacterized protein', 177, NULL, NULL, 207725),
(207726, '1.10.287.70-FF-000247', NULL, 'Inward Rectifying K (Potassium) channel family', 130, NULL, NULL, 207726),
(207727, '3.90.70.10-FF-000144', NULL, 'Ubiquitinyl hydrolase 1', 298, NULL, NULL, 207727),
(207728, '3.30.420.10-FF-000567', NULL, NULL, 43, NULL, NULL, 207728),
(207729, '3.40.50.740-FF-000025', NULL, 'NADH-quinone oxidoreductase', 210, NULL, NULL, 207729),
(207730, '3.30.160.460-FF-000001', NULL, 'Methylated-DNA--protein-cysteine methyltransferase', 76, NULL, NULL, 207730),
(207731, '1.10.132.60-FF-000048', NULL, 'DNA polymerase', 178, NULL, NULL, 207731),
(207732, '2.30.180.10-FF-000198', NULL, NULL, 187, NULL, NULL, 207732),
(207733, '1.10.510.10-FF-000749', NULL, 'Leucine-rich repeat kinase, isoform C', 315, NULL, NULL, 207733),
(207734, '1.10.1620.20-FF-000012', NULL, 'Predicted protein', 57, NULL, NULL, 207734),
(207735, '2.60.40.10-FF-000101', NULL, 'Neogenin isoform 1', 104, NULL, NULL, 207735),
(207736, '2.60.120.200-FF-000454', NULL, 'Uncharacterized protein', 225, NULL, NULL, 207736),
(207737, '3.30.200.20-FF-001211', NULL, 'OSJNBa0027H06.10-like protein', 119, NULL, NULL, 207737),
(207738, '1.20.120.350-FF-000262', NULL, NULL, 120, NULL, NULL, 207738),
(207739, '3.10.330.10-FF-000019', NULL, 'Peroxisome biogenesis factor 1', 81, NULL, NULL, 207739),
(207740, '3.10.110.10-FF-000003', NULL, 'Ubiquitin-conjugating enzyme E2 E3', 156, NULL, NULL, 207740),
(207741, '1.20.1250.20-FF-000138', NULL, 'Amino acid/peptide transporter', 223, NULL, NULL, 207741),
(207742, '1.10.287.660-FF-000031', NULL, 'Vacuolar protein sorting-associated protein 37A-like Protein', 77, NULL, NULL, 207742),
(207743, '1.10.1670.10-FF-000046', NULL, NULL, 97, NULL, NULL, 207743),
(207744, '1.10.560.10-FF-000033', NULL, '60 kDa chaperonin', 244, NULL, NULL, 207744),
(207745, '1.20.1110.10-FF-000210', NULL, NULL, 77, NULL, NULL, 207745),
(207746, '1.25.10.10-FF-000340', NULL, 'Vacuolar protein 8, variant', 84, NULL, NULL, 207746),
(207747, '1.10.238.10-FF-000144', NULL, 'Phosphoinositide phospholipase C', 85, NULL, NULL, 207747),
(207748, '3.40.710.10-FF-000042', NULL, 'Penicillin-binding protein 1A', 87, NULL, NULL, 207748),
(207749, '3.40.1380.20-FF-000029', NULL, 'Pyruvate kinase', 105, NULL, NULL, 207749),
(207750, '4.10.1060.10-FF-000048', NULL, 'AGAP000025-PA', 39, NULL, NULL, 207750),
(207751, '1.25.40.10-FF-000982', NULL, 'Pentatricopeptide repeat-containing protein', 132, NULL, NULL, 207751),
(207752, '1.10.8.60-FF-000522', NULL, 'Predicted protein', 28, NULL, NULL, 207752),
(207753, '2.60.40.10-FF-002883', NULL, 'Neurolin-like cell adhesion molecule', 107, NULL, NULL, 207753),
(207754, '2.170.270.10-FF-000099', NULL, 'Histone-lysine N-methyltransferase Su(var)3-9', 268, NULL, NULL, 207754),
(207755, '3.10.20.30-FF-000004', NULL, 'Succinate dehydrogenase iron-sulfur subunit', 106, NULL, NULL, 207755),
(207756, '3.10.129.10-FF-000282', NULL, 'Thioesterase-like protein', 54, NULL, NULL, 207756),
(207757, '3.30.160.60-FF-003748', NULL, NULL, 31, NULL, NULL, 207757),
(207758, '3.30.40.10-FF-000858', NULL, 'Zinc_finger_-_C3HC4_type_(RING_finger)/Ring_finger_domain/zinc-RING_finger_domain/EF-hand_domain_pair/EF-hand_domain/EF_hand/Secreted_protein_acidic_and_rich_in_cys teine_Ca_binding_region_containing_...', 96, NULL, NULL, 207758),
(207759, '1.20.58.390-FF-000038', NULL, 'Acetylcholine receptor subunit beta-like 1', 113, NULL, NULL, 207759),
(207760, '3.90.1720.10-FF-000019', NULL, 'CBN-EGL-26 protein', 143, NULL, NULL, 207760);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(207761, '2.10.50.10-FF-000109', NULL, 'Si:ch211-261n11.7', 37, NULL, NULL, 207761),
(207762, '1.10.510.10-FF-001733', NULL, 'Casein kinase 1 gamma 1', 199, NULL, NULL, 207762),
(207763, '1.20.930.40-FF-000012', NULL, 'Membrane protein', 157, NULL, NULL, 207763),
(207764, '1.25.40.10-FF-000089', NULL, 'CTR9 homolog, Paf1/RNA polymerase II complex component', 176, NULL, NULL, 207764),
(207765, '3.30.40.10-FF-001786', NULL, 'Uncharacterized protein', 65, NULL, NULL, 207765),
(207766, '1.10.10.10-FF-001593', NULL, 'Helix-turn-helix SAM-dependent methyltransferase', 80, NULL, NULL, 207766),
(207767, '2.130.10.10-FF-004805', NULL, 'Shk1 kinase-binding protein 15', 145, NULL, NULL, 207767),
(207768, '1.20.5.1190-FF-000001', NULL, 'Sodium channel protein', 38, NULL, NULL, 207768),
(207769, '1.20.1250.20-FF-000560', NULL, 'MFS hexose transporter, putative', 463, NULL, NULL, 207769),
(207770, '1.20.58.60-FF-000885', NULL, 'Uncharacterized protein', 109, NULL, NULL, 207770),
(207771, '2.130.10.10-FF-002299', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit TRM82', 144, NULL, NULL, 207771),
(207772, '2.60.40.10-FF-000410', NULL, 'Down syndrome cell adhesion molecule, isoform H', 85, NULL, NULL, 207772),
(207773, '2.30.42.10-FF-000376', NULL, NULL, 103, NULL, NULL, 207773),
(207774, '3.40.50.1820-FF-000168', NULL, 'Alpha/beta-Hydrolases superfamily protein', 291, NULL, NULL, 207774),
(207775, '3.90.70.10-FF-000829', NULL, 'Uncharacterized protein', 163, NULL, NULL, 207775),
(207776, '3.90.15.10-FF-000011', NULL, 'DNA topoisomerase I, mitochondrial', 53, NULL, NULL, 207776),
(207777, '1.20.1090.10-FF-000038', NULL, '3-dehydroquinate synthase', 191, NULL, NULL, 207777),
(207778, '2.30.30.40-FF-000178', NULL, 'SH3 and multiple ankyrin repeat domains protein', 61, NULL, NULL, 207778),
(207779, '3.40.50.300-FF-007245', NULL, 'Predicted protein', 160, NULL, NULL, 207779),
(207780, '3.80.10.10-FF-000938', NULL, 'Blast:Chaoptin', 139, NULL, NULL, 207780),
(207781, '2.30.230.10-FF-000051', NULL, 'Apolipophorins-like protein', 233, NULL, NULL, 207781),
(207782, '2.30.30.140-FF-000224', NULL, 'Tudor, isoform B', 94, NULL, NULL, 207782),
(207783, '3.50.30.30-FF-000060', NULL, 'Double-zinc aminopeptidase', 121, NULL, NULL, 207783),
(207784, '4.10.280.10-FF-000242', NULL, 'Uncharacterized protein', 60, NULL, NULL, 207784),
(207785, '3.40.50.300-FF-003226', NULL, 'Large subunit GTPase 1 homolog', 138, NULL, NULL, 207785),
(207786, '1.10.510.10-FF-000406', NULL, 'cyclin-dependent kinase 20 isoform X1', 219, NULL, NULL, 207786),
(207787, '3.40.120.10-FF-000025', NULL, 'Phosphomannomutase', 119, NULL, NULL, 207787),
(207788, '3.30.460.10-FF-000036', NULL, 'Ribosomal silencing factor RsfS', 111, NULL, NULL, 207788),
(207789, '1.25.40.20-FF-001603', NULL, 'Uncharacterized protein', 261, NULL, NULL, 207789),
(207790, '3.90.550.50-FF-000058', NULL, 'Hexosyltransferase', 240, NULL, NULL, 207790),
(207791, '1.20.1310.10-FF-000085', NULL, 'Cullin homolog 1-like Protein', 113, NULL, NULL, 207791),
(207792, '2.40.10.10-FF-000100', NULL, 'Kallikrein-4', 95, NULL, NULL, 207792),
(207793, '1.20.1050.80-FF-000023', NULL, 'UPF0507 protein C2_02840C_A', 156, NULL, NULL, 207793),
(207794, '3.20.20.190-FF-000100', NULL, NULL, 222, NULL, NULL, 207794),
(207795, '2.30.30.140-FF-000100', NULL, 'E3 ubiquitin-protein ligase UHRF2 isoform X2', 84, NULL, NULL, 207795),
(207796, '3.30.40.10-FF-001819', NULL, 'Predicted protein', 75, NULL, NULL, 207796),
(207797, '2.60.120.200-FF-000145', NULL, 'Galectin', 147, NULL, NULL, 207797),
(207798, '1.20.58.60-FF-000177', NULL, 'nesprin-1 isoform X5', 299, NULL, NULL, 207798),
(207799, '1.10.1220.10-FF-000018', NULL, 'Possible antitoxin vapb19', 56, NULL, NULL, 207799),
(207800, '2.60.40.10-FF-004120', NULL, NULL, 92, NULL, NULL, 207800),
(207801, '3.30.1640.30-FF-000010', NULL, NULL, 62, NULL, NULL, 207801),
(207802, '1.10.3720.10-FF-000085', NULL, 'Carbohydrate ABC transporter membrane protein 2, CUT1 family', 255, NULL, NULL, 207802),
(207803, '3.40.50.720-FF-000941', NULL, 'Prephenate dehydrogenase', 159, NULL, NULL, 207803);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(207804, '3.30.720.150-FF-000002', NULL, 'probable UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SEC', 11, NULL, NULL, 207804),
(207805, '1.10.1060.10-FF-000016', NULL, 'Dihydropyrimidine dehydrogenase [NADP(+)]', 106, NULL, NULL, 207805),
(207806, '1.20.5.110-FF-000034', NULL, 'syntaxin-61 isoform X1', 62, NULL, NULL, 207806),
(207807, '1.10.238.10-FF-001105', NULL, 'Aspartate/glutamate carrier protein, putative', 61, NULL, NULL, 207807),
(207808, '3.40.50.200-FF-000184', NULL, 'Gll1055 protein', 134, NULL, NULL, 207808),
(207809, '3.40.50.1820-FF-001152', NULL, 'Endothelial lipase, putative', 87, NULL, NULL, 207809),
(207810, '1.10.287.70-FF-000556', NULL, 'Glutamate receptor 2', 170, NULL, NULL, 207810),
(207811, '2.60.120.1030-FF-000006', NULL, 'Hypothetical_protein_-_conserved', 89, NULL, NULL, 207811),
(207812, '3.10.50.40-FF-000054', NULL, 'Peptidylprolyl isomerase', 143, NULL, NULL, 207812),
(207813, '3.30.230.10-FF-000176', NULL, 'Galactokinase, putative', 213, NULL, NULL, 207813),
(207814, '3.40.50.2300-FF-000335', NULL, 'Uncharacterized protein', 297, NULL, NULL, 207814),
(207815, '3.30.160.60-FF-000623', NULL, 'Zinc finger protein 234', 28, NULL, NULL, 207815),
(207816, '1.20.1250.20-FF-001521', NULL, 'AGAP008720-PA', 180, NULL, NULL, 207816),
(207817, '3.30.9.10-FF-000078', NULL, 'Possible oxidoreductase', 156, NULL, NULL, 207817),
(207818, '3.30.780.10-FF-000060', NULL, 'Eukaryotic Initiation Factor', 109, NULL, NULL, 207818),
(207819, '1.20.1070.10-FF-001566', NULL, 'C-X-C chemokine receptor type 4', 168, NULL, NULL, 207819),
(207820, '3.40.50.300-FF-000101', NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase', 175, NULL, NULL, 207820),
(207821, '3.30.190.20-FF-000046', NULL, 'Ribosomal protein L1p/L10e family', 57, NULL, NULL, 207821),
(207822, '3.30.70.1430-FF-000003', NULL, 'Cation efflux system protein CusA', 103, NULL, NULL, 207822),
(207823, '2.40.50.140-FF-000467', NULL, 'Unplaced genomic scaffold supercont1.15, whole genome shotgun sequence', 96, NULL, NULL, 207823),
(207824, '3.40.50.300-FF-003535', NULL, 'Digestive organ expansion factor homolog', 217, NULL, NULL, 207824),
(207825, '2.60.300.12-FF-000013', NULL, 'Iron-sulfur assembly protein 2', 112, NULL, NULL, 207825),
(207826, '2.60.120.1440-FF-000011', NULL, 'Amino acid ABC transporter substrate-binding protein', 130, NULL, NULL, 207826),
(207827, '2.10.10.70-FF-000001', NULL, 'Polymerase cofactor VP35', 52, NULL, NULL, 207827),
(207828, '1.25.40.20-FF-001727', NULL, 'Uncharacterized protein', 226, NULL, NULL, 207828),
(207829, '2.60.40.790-FF-000043', NULL, 'Hsp90 binding co-chaperone (Sba1)', 113, NULL, NULL, 207829),
(207830, '1.25.40.20-FF-001912', NULL, 'Ankyrin repeat protein, putative', 44, NULL, NULL, 207830),
(207831, '3.90.550.10-FF-000602', NULL, 'Probable N-acylneuraminate cytidylyltransferase', 222, NULL, NULL, 207831),
(207832, '1.10.510.10-FF-003734', NULL, NULL, 151, NULL, NULL, 207832),
(207833, '1.50.10.10-FF-000169', NULL, 'alpha-1,2-Mannosidase', 428, NULL, NULL, 207833),
(207834, '3.40.50.300-FF-008448', NULL, 'Uncharacterized protein', 62, NULL, NULL, 207834),
(207835, '3.30.160.60-FF-005873', NULL, NULL, 47, NULL, NULL, 207835),
(207836, '3.30.200.20-FF-002279', NULL, 'Non-specific serine/threonine protein kinase', 103, NULL, NULL, 207836),
(207837, '3.30.1550.10-FF-000020', NULL, 'Predicted protein', 68, NULL, NULL, 207837),
(207838, '3.20.20.140-FF-000333', NULL, 'Uncharacterized protein', 107, NULL, NULL, 207838),
(207839, '3.40.50.300-FF-005694', NULL, 'Uncharacterized protein', 180, NULL, NULL, 207839),
(207840, '4.10.280.10-FF-000135', NULL, 'Transcription factor MYC1', 75, NULL, NULL, 207840),
(207841, '1.20.1070.10-FF-001431', NULL, 'Vomeronasal type-1 receptor', 225, NULL, NULL, 207841),
(207842, '1.10.510.10-FF-004240', NULL, NULL, 201, NULL, NULL, 207842),
(207843, '2.120.10.80-FF-000246', NULL, 'tRNA wybutosine-synthesizing protein 4', 293, NULL, NULL, 207843),
(207844, '2.40.50.140-FF-000254', NULL, 'Ribosomal protein L2 mitochondrion', 84, NULL, NULL, 207844);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(207845, '1.10.10.2210-FF-000001', NULL, 'Telomerase reverse transcriptase', 31, NULL, NULL, 207845),
(207846, '1.10.10.2670-FF-000004', NULL, 'Ubiquitin-protein ligase E3 component (UBR1)', 101, NULL, NULL, 207846),
(207847, '3.90.320.10-FF-000012', NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', 217, NULL, NULL, 207847),
(207848, '3.30.559.10-FF-000091', NULL, 'Choline O-acetyltransferase', 272, NULL, NULL, 207848),
(207849, '3.40.50.10090-FF-000012', NULL, 'Uroporphyrinogen-III synthase', 125, NULL, NULL, 207849),
(207850, '3.30.450.150-FF-000002', NULL, 'UPF0303 protein BCAH820_3413', 157, NULL, NULL, 207850),
(207851, '1.10.10.60-FF-001220', NULL, NULL, 78, NULL, NULL, 207851),
(207852, '2.130.10.30-FF-000040', NULL, 'Guanidine nucleotide exchange factor', 81, NULL, NULL, 207852),
(207853, '1.20.1280.50-FF-000060', NULL, 'F-box only protein 13', 46, NULL, NULL, 207853),
(207854, '2.40.30.170-FF-000039', NULL, 'RND family efflux transporter, MFP subunit', 82, NULL, NULL, 207854),
(207855, '2.130.10.10-FF-001714', NULL, 'Periodic tryptophan protein 2 homolog', 195, NULL, NULL, 207855),
(207856, '3.40.50.10490-FF-000155', NULL, NULL, 111, NULL, NULL, 207856),
(207857, '3.40.50.80-FF-000008', NULL, 'Ferredoxin--NADP reductase, chloroplastic', 163, NULL, NULL, 207857),
(207858, '1.10.630.10-FF-000713', NULL, 'Uncharacterized protein', 114, NULL, NULL, 207858),
(207859, '2.60.40.10-FF-001039', NULL, 'laforin isoform X1', 112, NULL, NULL, 207859),
(207860, '3.30.559.30-FF-000097', NULL, 'Nonribosomal peptide synthase inpB', 248, NULL, NULL, 207860),
(207861, '2.60.40.10-FF-004816', NULL, NULL, 86, NULL, NULL, 207861),
(207862, '2.130.10.10-FF-003260', NULL, 'Wdr1p', 192, NULL, NULL, 207862),
(207863, '2.130.10.10-FF-006014', NULL, 'WD repeat domain 90', 175, NULL, NULL, 207863),
(207864, '3.40.50.620-FF-000315', NULL, 'Universal stress protein Rv2028c', 145, NULL, NULL, 207864),
(207865, '2.10.109.10-FF-000037', NULL, 'Putative repressor LexA', 123, NULL, NULL, 207865),
(207866, '2.10.110.10-FF-000333', NULL, 'Uncharacterized protein', 56, NULL, NULL, 207866),
(207867, '3.40.50.300-FF-004171', NULL, 'Predicted protein', 149, NULL, NULL, 207867),
(207868, '3.30.70.330-FF-002527', NULL, NULL, 58, NULL, NULL, 207868),
(207869, '3.30.160.60-FF-000067', NULL, 'Vascular endothelial zinc finger 1', 29, NULL, NULL, 207869),
(207870, '3.30.160.60-FF-001495', NULL, 'Datilografo, isoform B', 34, NULL, NULL, 207870),
(207871, '1.25.40.10-FF-002438', NULL, 'Pentatricopeptide repeat-containing protein At3g49710', 106, NULL, NULL, 207871),
(207872, '1.20.120.560-FF-000004', NULL, 'Blast:Programmed cell death 6-interacting protein', 148, NULL, NULL, 207872),
(207873, '2.60.40.150-FF-000115', NULL, 'Uncharacterized protein, isoform E', 188, NULL, NULL, 207873),
(207874, '3.90.640.10-FF-000284', NULL, 'Actin-related protein 3', 41, NULL, NULL, 207874),
(207875, '2.10.25.10-FF-000837', NULL, 'Notch 3', 35, NULL, NULL, 207875),
(207876, '3.80.10.10-FF-000484', NULL, 'Leucine-rich repeat kinase, isoform C', 163, NULL, NULL, 207876),
(207877, '3.50.50.60-FF-001340', NULL, 'Mercuric reductase', 201, NULL, NULL, 207877),
(207878, '2.70.130.10-FF-000034', NULL, 'Glucosidase II beta subunit', 103, NULL, NULL, 207878),
(207879, '3.40.1110.10-FF-000108', NULL, 'Cation transporting ATPase', 147, NULL, NULL, 207879),
(207880, '4.10.1240.10-FF-000045', NULL, 'Calcitonin gene-related peptide type 1 receptor-like Protein', 103, NULL, NULL, 207880),
(207881, '3.30.70.330-FF-002966', NULL, NULL, 99, NULL, NULL, 207881),
(207882, '1.25.10.10-FF-003116', NULL, 'Uncharacterized protein', 213, NULL, NULL, 207882),
(207883, '1.20.1290.10-FF-000014', NULL, 'Uncharacterized protein', 159, NULL, NULL, 207883),
(207884, '2.40.50.40-FF-000061', NULL, 'CBX7 isoform 3', 38, NULL, NULL, 207884),
(207885, '3.10.20.90-FF-000202', NULL, 'Small ubiquitin-related modifier I', 98, NULL, NULL, 207885),
(207886, '1.10.150.50-FF-000087', NULL, 'Sterile alpha motif domain containing 9', 80, NULL, NULL, 207886),
(207887, '3.30.160.60-FF-002107', NULL, 'Zinc finger protein 484', 27, NULL, NULL, 207887);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(207888, '1.25.40.180-FF-000186', NULL, 'Uncharacterized protein', 330, NULL, NULL, 207888),
(207889, '3.30.530.20-FF-000123', NULL, 'Uncharacterized protein', 137, NULL, NULL, 207889),
(207890, '1.20.272.10-FF-000058', NULL, NULL, 96, NULL, NULL, 207890),
(207891, '3.40.720.10-FF-000346', NULL, 'Uncharacterized protein', 71, NULL, NULL, 207891),
(207892, '3.80.10.10-FF-002833', NULL, 'Uncharacterized protein', 94, NULL, NULL, 207892),
(207893, '3.40.190.10-FF-000872', NULL, 'Uncharacterized protein', 36, NULL, NULL, 207893),
(207894, '2.60.120.620-FF-000136', NULL, 'Prolyl 4-hydroxylase subunit alpha', 238, NULL, NULL, 207894),
(207895, '3.40.630.30-FF-000233', NULL, 'Uncharacterized protein 9G6.260', 163, NULL, NULL, 207895),
(207896, '1.20.1070.10-FF-002050', NULL, 'Uncharacterized protein', 101, NULL, NULL, 207896),
(207897, '3.30.930.10-FF-000342', NULL, 'Class II aaRS and biotin synthetases superfamily protein', 77, NULL, NULL, 207897),
(207898, '2.130.10.10-FF-001231', NULL, 'PWP2, small subunit processome component', 118, NULL, NULL, 207898),
(207899, '3.30.70.330-FF-003146', NULL, NULL, 34, NULL, NULL, 207899),
(207900, '1.10.10.10-FF-001149', NULL, 'ATP-dependent DNA helicase', 106, NULL, NULL, 207900),
(207901, '1.25.40.690-FF-000001', NULL, 'Nuclear pore complex protein Nup98-Nup96', 91, NULL, NULL, 207901),
(207902, '1.10.1000.11-FF-000020', NULL, 'Guanyl nucleotide exchange factor, putative', 128, NULL, NULL, 207902),
(207903, '1.20.1270.60-FF-000135', NULL, 'GTPase activating protein, putative', 205, NULL, NULL, 207903),
(207904, '3.20.20.80-FF-000581', NULL, 'Heparanase-like protein 3', 265, NULL, NULL, 207904),
(207905, '3.40.50.300-FF-007829', NULL, 'Uncharacterized protein', 268, NULL, NULL, 207905),
(207906, '3.40.50.2000-FF-000352', NULL, 'Glycosyltransferase', 265, NULL, NULL, 207906),
(207907, '1.10.510.10-FF-002211', NULL, NULL, 110, NULL, NULL, 207907),
(207908, '1.25.40.10-FF-003383', NULL, 'Pentatricopeptide repeat-containing protein DOT4, chloroplastic', 148, NULL, NULL, 207908),
(207909, '1.20.1250.40-FF-000015', NULL, 'Uncharacterized protein', 127, NULL, NULL, 207909),
(207910, '3.40.50.2300-FF-001633', NULL, NULL, 268, NULL, NULL, 207910),
(207911, '3.50.50.60-FF-000816', NULL, 'Oxidoreductase', 166, NULL, NULL, 207911),
(207912, '3.40.50.620-FF-000787', NULL, 'Uncharacterized protein', 75, NULL, NULL, 207912),
(207913, '2.40.70.10-FF-000429', NULL, NULL, 194, NULL, NULL, 207913),
(207914, '3.30.479.30-FF-000045', NULL, 'Stomatin (EPB72)-like 3b', 46, NULL, NULL, 207914),
(207915, '1.20.1250.20-FF-000689', NULL, '3-phenylpropionic acid transporter', 180, NULL, NULL, 207915),
(207916, '3.40.50.1820-FF-000747', NULL, 'Triacylglycerol lipase, putative', 93, NULL, NULL, 207916),
(207917, '1.10.1200.10-FF-000034', NULL, 'Peptide synthetase mbtE', 88, NULL, NULL, 207917),
(207918, '1.10.472.140-FF-000005', NULL, 'Retinoblastoma family protein', 159, NULL, NULL, 207918),
(207919, '3.30.40.10-FF-002292', NULL, 'Uncharacterized protein', 36, NULL, NULL, 207919),
(207920, '1.20.1250.20-FF-001206', NULL, 'Nucleoside permease NupG', 180, NULL, NULL, 207920),
(207921, '3.80.10.10-FF-002619', NULL, 'PH domain leucine-rich repeat protein phosphatase, isoform B', 205, NULL, NULL, 207921),
(207922, '1.25.10.10-FF-001413', NULL, 'Uncharacterized protein', 115, NULL, NULL, 207922),
(207923, '3.30.30.10-FF-000009', NULL, 'Potassium channel toxin alpha-KTx 4.3', 37, NULL, NULL, 207923),
(207924, '3.20.20.10-FF-000032', NULL, 'Pyridoxal phosphate homeostasis protein', 256, NULL, NULL, 207924),
(207925, '3.40.50.300-FF-003665', NULL, 'ABC transporter, multidrug resistance associated protein', 262, NULL, NULL, 207925),
(207926, '1.10.3370.10-FF-000029', NULL, 'Protein translocase subunit SecY', 462, NULL, NULL, 207926),
(207927, '3.40.50.2000-FF-000835', NULL, 'Uncharacterized protein', 93, NULL, NULL, 207927),
(207928, '3.40.50.150-FF-001231', NULL, NULL, 70, NULL, NULL, 207928),
(207929, '3.90.1280.10-FF-000002', NULL, 'Hsp33_protein_-_putative', 57, NULL, NULL, 207929),
(207930, '2.130.10.10-FF-003159', NULL, 'DDB1 and CUL4-associated factor 11', 116, NULL, NULL, 207930);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(207931, '3.80.10.10-FF-004536', NULL, 'Predicted protein', 164, NULL, NULL, 207931),
(207932, '3.30.160.60-FF-003052', NULL, 'histone H4 transcription factor', 60, NULL, NULL, 207932),
(207933, '2.30.42.10-FF-000516', NULL, NULL, 77, NULL, NULL, 207933),
(207934, '3.10.20.90-FF-000191', NULL, 'FERM domain-containing protein 8', 107, NULL, NULL, 207934),
(207935, '3.40.50.170-FF-000040', NULL, 'Formyltransferase domain protein', 203, NULL, NULL, 207935),
(207936, '4.10.1000.10-FF-000151', NULL, 'Uncharacterized protein', 83, NULL, NULL, 207936),
(207937, '1.10.510.10-FF-000980', NULL, 'Predicted protein', 204, NULL, NULL, 207937),
(207938, '3.30.70.370-FF-000033', NULL, NULL, 155, NULL, NULL, 207938),
(207939, '3.30.365.10-FF-000051', NULL, 'Uncharacterized protein', 84, NULL, NULL, 207939),
(207940, '1.20.1560.10-FF-000119', NULL, 'ATP binding cassette subfamily C member 5', 238, NULL, NULL, 207940),
(207941, '3.30.430.20-FF-000059', NULL, 'Uncharacterized protein', 104, NULL, NULL, 207941),
(207942, '3.30.70.660-FF-000013', NULL, 'tRNA pseudouridine synthase', 141, NULL, NULL, 207942),
(207943, '3.40.50.150-FF-001326', NULL, NULL, 203, NULL, NULL, 207943),
(207944, '2.30.40.10-FF-000113', NULL, 'Urease', 127, NULL, NULL, 207944),
(207945, '2.30.40.10-FF-000001', NULL, 'Dihydropyrimidinase like 2', 97, NULL, NULL, 207945),
(207946, '2.70.20.10-FF-000009', NULL, 'DNA topoisomerase 3', 146, NULL, NULL, 207946),
(207947, '3.30.70.3250-FF-000010', NULL, NULL, 118, NULL, NULL, 207947),
(207948, '1.25.10.10-FF-002841', NULL, 'Protein phosphatase 2A regulatory subunit A, putative', 176, NULL, NULL, 207948),
(207949, '3.40.140.70-FF-000016', NULL, 'Autophagy related 7', 47, NULL, NULL, 207949),
(207950, '3.40.630.40-FF-000011', NULL, 'N-acetylmuramoyl-L-alanine amidase', 220, NULL, NULL, 207950),
(207951, '3.90.226.10-FF-000254', NULL, 'Uncharacterized protein', 272, NULL, NULL, 207951),
(207952, '3.40.50.300-FF-001309', NULL, 'RAB7A, member RAS oncogene family', 58, NULL, NULL, 207952),
(207953, '3.30.200.20-FF-000481', NULL, 'Wall-associated receptor kinase-like 14', 107, NULL, NULL, 207953),
(207954, '3.30.70.2850-FF-000019', NULL, 'RNA polymerase I largest subunit', 219, NULL, NULL, 207954),
(207955, '4.10.400.20-FF-000002', NULL, 'Uncharacterized protein', 47, NULL, NULL, 207955),
(207956, '3.40.50.1110-FF-000085', NULL, 'Uncharacterized protein', 147, NULL, NULL, 207956),
(207957, '1.50.40.10-FF-000008', NULL, 'Mitochondrial uncoupling protein 2', 295, NULL, NULL, 207957),
(207958, '1.25.40.10-FF-001241', NULL, 'Tetratricopeptide repeat protein, putative', 207, NULL, NULL, 207958),
(207959, '1.10.720.30-FF-000001', NULL, 'E3 SUMO-protein ligase PIAS2 isoform 1', 65, NULL, NULL, 207959),
(207960, '3.30.1490.20-FF-000068', NULL, 'D-alanyl-alanine synthetase A', 70, NULL, NULL, 207960),
(207961, '3.30.1330.30-FF-000015', NULL, 'H/ACA ribonucleoprotein complex subunit NHP2', 133, NULL, NULL, 207961),
(207962, '1.20.5.100-FF-000014', NULL, 'Cytochrome c1, heme protein', 35, NULL, NULL, 207962),
(207963, '3.20.20.140-FF-000119', NULL, 'Deoxyribonuclease Tat-D', 394, NULL, NULL, 207963),
(207964, '1.25.40.10-FF-004467', NULL, 'Pentatricopeptide repeat-containing protein At5g10690', 108, NULL, NULL, 207964),
(207965, '1.10.400.10-FF-000084', NULL, 'Uncharacterized protein', 17, NULL, NULL, 207965),
(207966, '1.25.40.10-FF-003736', NULL, 'Predicted protein', 243, NULL, NULL, 207966),
(207967, '3.40.30.10-FF-000357', NULL, 'Thioredoxin-like protein', 95, NULL, NULL, 207967),
(207968, '3.40.50.150-FF-000837', NULL, 'Protein-L-isoaspartate O-methyltransferase', 200, NULL, NULL, 207968),
(207969, '3.30.70.3270-FF-000016', NULL, 'F(420)H(2) dehydrogenase, subunit FpoI', 115, NULL, NULL, 207969),
(207970, '3.30.70.1470-FF-000010', NULL, 'Uncharacterized protein', 77, NULL, NULL, 207970),
(207971, '1.10.238.10-FF-001234', NULL, 'Putative calcium-binding protein CML15', 104, NULL, NULL, 207971),
(207972, '3.60.20.10-FF-000249', NULL, NULL, 219, NULL, NULL, 207972),
(207973, '2.20.28.200-FF-000011', NULL, 'Sir2-type regulatory transcription factor silent information regulator protein', 56, NULL, NULL, 207973);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(207974, '2.40.30.10-FF-000197', NULL, 'Nitrate reductase, putative', 115, NULL, NULL, 207974),
(207975, '3.10.20.90-FF-000983', NULL, 'Sorting nexin-17-like Protein', 95, NULL, NULL, 207975),
(207976, '1.25.40.250-FF-000004', NULL, 'Eukaryotic translation initiation factor 3 subunit K', 70, NULL, NULL, 207976),
(207977, '1.20.58.60-FF-000418', NULL, 'Spectrin beta chain', 101, NULL, NULL, 207977),
(207978, '1.10.510.10-FF-004009', NULL, NULL, 152, NULL, NULL, 207978),
(207979, '2.10.25.10-FF-001456', NULL, 'signal peptide, CUB and EGF-like domain-containing protein 2 isoform X1', 41, NULL, NULL, 207979),
(207980, '1.20.1560.10-FF-000249', NULL, 'HAlF transporter (PGP related)', 340, NULL, NULL, 207980),
(207981, '2.60.40.10-FF-003395', NULL, NULL, 63, NULL, NULL, 207981),
(207982, '2.30.39.10-FF-000144', NULL, 'Uncharacterized protein', 22, NULL, NULL, 207982),
(207983, '4.10.1060.10-FF-000059', NULL, 'Zinc finger Ran-binding domain-containing protein 2', 35, NULL, NULL, 207983),
(207984, '3.40.50.1700-FF-000048', NULL, 'Glycoside hydrolase family 3 domain protein', 109, NULL, NULL, 207984),
(207985, '3.50.50.60-FF-001109', NULL, 'Kynurenine 3-monooxygenase', 187, NULL, NULL, 207985),
(207986, '2.60.120.920-FF-000119', NULL, 'Si:dkey-261j11.3', 169, NULL, NULL, 207986),
(207987, '2.40.50.90-FF-000177', NULL, 'Uncharacterized protein', 105, NULL, NULL, 207987),
(207988, '3.30.1240.10-FF-000047', NULL, 'HAD family hydrolase', 105, NULL, NULL, 207988),
(207989, '2.170.120.30-FF-000010', NULL, 'Putative secreted protein associated with spyDAC', 99, NULL, NULL, 207989),
(207990, '2.170.210.10-FF-000011', NULL, 'Uncharacterized protein', 118, NULL, NULL, 207990),
(207991, '2.120.10.30-FF-000130', NULL, 'Type II transmembrane protein', 103, NULL, NULL, 207991),
(207992, '3.40.50.720-FF-000362', NULL, 'L-lactate dehydrogenase', 149, NULL, NULL, 207992),
(207993, '3.40.50.720-FF-000250', NULL, 'YciK family oxidoreductase', 250, NULL, NULL, 207993),
(207994, '3.40.50.12160-FF-000010', NULL, 'Ribosomal protein S12 methylthiotransferase RimO', 131, NULL, NULL, 207994),
(207995, '3.40.50.300-FF-004963', NULL, 'Nucleolar GTP-binding protein 2', 150, NULL, NULL, 207995),
(207996, '2.130.10.10-FF-001343', NULL, 'Pre-mRNA splicing factor, putative (AFU_orthologue AFUA_8G04590)', 72, NULL, NULL, 207996),
(207997, '2.130.10.10-FF-003029', NULL, 'Predicted protein', 160, NULL, NULL, 207997),
(207998, '3.40.50.1820-FF-000308', NULL, 'Lipase 2', 270, NULL, NULL, 207998),
(207999, '2.20.100.10-FF-000009', NULL, 'ADAMTS-like protein 3 isoform A', 61, NULL, NULL, 207999),
(208000, '1.10.287.110-FF-000080', NULL, 'NAD(P)H-quinone oxidoreductase subunit U chloroplastic', 92, NULL, NULL, 208000),
(208001, '3.40.720.10-FF-000234', NULL, 'FI08016p', 238, NULL, NULL, 208001),
(208002, '1.20.1260.100-FF-000012', NULL, NULL, 105, NULL, NULL, 208002),
(208003, '3.40.630.30-FF-000103', NULL, 'RNA cytidine acetyltransferase', 202, NULL, NULL, 208003),
(208004, '2.40.50.150-FF-000032', NULL, 'DNA-directed RNA polymerase subunit beta', 123, NULL, NULL, 208004),
(208005, '2.10.50.10-FF-000008', NULL, 'Signal peptide, CUB domain and EGF-like domain-containing 3', 49, NULL, NULL, 208005),
(208006, '1.25.40.10-FF-000510', NULL, 'Vacuolar assembly protein, putative', 179, NULL, NULL, 208006),
(208007, '3.30.420.10-FF-000584', NULL, NULL, 214, NULL, NULL, 208007),
(208008, '1.20.1510.10-FF-000055', NULL, 'Protein CBG10923', 191, NULL, NULL, 208008),
(208009, '2.30.30.490-FF-000042', NULL, 'Protein CBR-LIN-40', 73, NULL, NULL, 208009),
(208010, '2.30.130.10-FF-000026', NULL, 'tRNA pseudouridine synthase B', 88, NULL, NULL, 208010),
(208011, '3.30.565.10-FF-000032', NULL, 'Phosphate regulon sensor histidine kinase PhoR', 155, NULL, NULL, 208011),
(208012, '2.10.25.10-FF-001001', NULL, 'Predicted protein', 36, NULL, NULL, 208012),
(208013, '1.25.40.20-FF-001699', NULL, 'Death-associated protein kinase 1', 62, NULL, NULL, 208013),
(208014, '3.90.180.10-FF-000118', NULL, 'Uncharacterized protein', 172, NULL, NULL, 208014),
(208015, '3.30.160.60-FF-005081', NULL, NULL, 111, NULL, NULL, 208015); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(208016, '1.10.287.920-FF-000007', NULL, 'Fungal pheromone mating factor STE2 GPCR-domain-containing protein', 78, NULL, NULL, 208016),
(208017, '1.10.8.720-FF-000005', NULL, 'Dynein axonemal heavy chain 10', 174, NULL, NULL, 208017),
(208018, '2.20.100.10-FF-000223', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs adt-1 isoform X1', 58, NULL, NULL, 208018),
(208019, '1.10.1200.10-FF-000146', NULL, 'Polyketide synthase RzxE', 84, NULL, NULL, 208019),
(208020, '2.130.10.10-FF-002754', NULL, 'Uncharacterized protein', 257, NULL, NULL, 208020),
(208021, '2.160.20.10-FF-000089', NULL, 'Right_handed_beta_helix_region /Periplasmic_copper-binding_protein_(NosD)_-_putative', 191, NULL, NULL, 208021),
(208022, '3.30.450.20-FF-000622', NULL, 'Hypoxia-inducible factor 1 subunit alpha', 92, NULL, NULL, 208022),
(208023, '3.60.10.10-FF-000294', NULL, 'AGAP011401-PA', 347, NULL, NULL, 208023),
(208024, '3.30.760.10-FF-000042', NULL, 'Eukaryotic translation initiation factor 4E, putative', 164, NULL, NULL, 208024),
(208025, '1.10.510.10-FF-002778', NULL, NULL, 209, NULL, NULL, 208025),
(208026, '1.20.1730.10-FF-000049', NULL, 'Uncharacterized protein', 68, NULL, NULL, 208026),
(208027, '1.10.630.10-FF-000808', NULL, 'Uncharacterized protein', 312, NULL, NULL, 208027),
(208028, '2.60.120.200-FF-000376', NULL, 'Extracellular agarase', 282, NULL, NULL, 208028),
(208029, '4.10.800.30-FF-000002', NULL, 'Essential meiotic structure-specific endonuclease 1', 74, NULL, NULL, 208029),
(208030, '1.20.1250.20-FF-000801', NULL, 'Uncharacterized protein, isoform A', 191, NULL, NULL, 208030),
(208031, '3.30.1520.10-FF-000181', NULL, 'Non-specific serine/threonine protein kinase', 95, NULL, NULL, 208031),
(208032, '2.60.120.920-FF-000024', NULL, 'Ryanodine receptor 3', 233, NULL, NULL, 208032),
(208033, '3.10.129.10-FF-000052', NULL, 'PaaI family thioesterase', 132, NULL, NULL, 208033),
(208034, '1.10.287.70-FF-000325', NULL, 'GM10959', 134, NULL, NULL, 208034),
(208035, '3.30.40.10-FF-000263', NULL, 'TNF receptor-associated factor', 44, NULL, NULL, 208035),
(208036, '3.40.30.10-FF-000571', NULL, 'Glutathione S-transferase kappa 1', 99, NULL, NULL, 208036),
(208037, '2.60.40.10-FF-005761', NULL, NULL, 68, NULL, NULL, 208037),
(208038, '3.90.1150.10-FF-000099', NULL, 'phosphoserine aminotransferase isoform X2', 34, NULL, NULL, 208038),
(208039, '4.10.280.10-FF-000247', NULL, 'Uncharacterized protein', 102, NULL, NULL, 208039),
(208040, '3.40.50.300-FF-001299', NULL, 'Guanylate kinase', 113, NULL, NULL, 208040),
(208041, '1.10.287.110-FF-000321', NULL, 'LOC100124938 protein', 94, NULL, NULL, 208041),
(208042, '3.20.20.80-FF-000704', NULL, 'Glucosylceramidase, putative', 55, NULL, NULL, 208042),
(208043, '3.30.70.100-FF-000194', NULL, NULL, 114, NULL, NULL, 208043),
(208044, '3.20.140.10-FF-000019', NULL, 'Nicotinate phosphoribosyltransferase', 426, NULL, NULL, 208044),
(208045, '3.90.950.10-FF-000026', NULL, 'Septum formation protein MAF homologue, putative', 203, NULL, NULL, 208045),
(208046, '3.10.310.40-FF-000016', NULL, 'Alanine--tRNA ligase', 112, NULL, NULL, 208046),
(208047, '1.20.120.1920-FF-000009', NULL, 'Predicted protein', 115, NULL, NULL, 208047),
(208048, '1.10.357.140-FF-000043', NULL, 'Protoheme IX farnesyltransferase, mitochondrial', 148, NULL, NULL, 208048),
(208049, '3.30.310.130-FF-000033', NULL, 'Uncharacterized protein', 44, NULL, NULL, 208049),
(208050, '3.30.160.60-FF-001478', NULL, 'Zinc finger protein 134', 29, NULL, NULL, 208050),
(208051, '2.130.10.10-FF-004671', NULL, 'Uncharacterized protein', 184, NULL, NULL, 208051),
(208052, '3.30.70.330-FF-002415', NULL, NULL, 92, NULL, NULL, 208052),
(208053, '3.30.930.10-FF-000325', NULL, 'Uncharacterized protein', 178, NULL, NULL, 208053),
(208054, '1.10.1370.40-FF-000009', NULL, 'Zincin-like metalloproteases family protein', 383, NULL, NULL, 208054),
(208055, '2.60.40.10-FF-001169', NULL, 'Macrophage colony-stimulating factor 1 receptor', 99, NULL, NULL, 208055),
(208056, '1.20.1250.20-FF-001757', NULL, 'Chromosome 1, whole genome shotgun sequence', 262, NULL, NULL, 208056);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(208057, '3.30.160.60-FF-005761', NULL, NULL, 27, NULL, NULL, 208057),
(208058, '3.30.200.20-FF-002167', NULL, 'AGC family protein kinase', 63, NULL, NULL, 208058),
(208059, '1.10.8.60-FF-000191', NULL, 'C4-dicarboxylate transport transcriptional regulatory protein', 67, NULL, NULL, 208059),
(208060, '2.130.10.10-FF-002771', NULL, 'MAG2-interacting protein 2', 232, NULL, NULL, 208060),
(208061, '1.25.40.20-FF-001811', NULL, 'Uncharacterized protein', 161, NULL, NULL, 208061),
(208062, '1.10.8.60-FF-000527', NULL, 'Katanin p60 ATPase-containing subunit A-like 2', 98, NULL, NULL, 208062),
(208063, '1.25.10.10-FF-001773', NULL, 'Uncharacterized protein', 879, NULL, NULL, 208063),
(208064, '3.80.10.10-FF-003890', NULL, 'Flyers-cup, isoform F', 150, NULL, NULL, 208064),
(208065, '1.10.510.10-FF-002323', NULL, NULL, 210, NULL, NULL, 208065),
(208066, '2.130.10.30-FF-000152', NULL, NULL, 174, NULL, NULL, 208066),
(208067, '3.40.50.850-FF-000030', NULL, 'Uncharacterized protein', 56, NULL, NULL, 208067),
(208068, '3.40.710.10-FF-000065', NULL, 'Peptidoglycan D,D-transpeptidase FtsI', 182, NULL, NULL, 208068),
(208069, '1.10.150.510-FF-000009', NULL, 'Receptor activity modifying protein 3', 96, NULL, NULL, 208069),
(208070, '2.40.37.10-FF-000004', NULL, 'Ornithine decarboxylase', 115, NULL, NULL, 208070),
(208071, '3.50.50.60-FF-001452', NULL, 'Predicted protein', 79, NULL, NULL, 208071),
(208072, '3.40.630.10-FF-000013', NULL, 'carboxypeptidase N catalytic chain', 322, NULL, NULL, 208072),
(208073, '3.10.105.10-FF-000042', NULL, 'Oligopeptide ABC transporter substrate-binding protein', 239, NULL, NULL, 208073),
(208074, '3.40.50.300-FF-007037', NULL, 'Uncharacterized protein', 302, NULL, NULL, 208074),
(208075, '1.25.10.30-FF-000008', NULL, NULL, 73, NULL, NULL, 208075),
(208076, '1.25.10.10-FF-001290', NULL, 'Ctnnb2 protein', 322, NULL, NULL, 208076),
(208077, '3.40.50.720-FF-002048', NULL, 'Uncharacterized protein', 177, NULL, NULL, 208077),
(208078, '3.30.230.10-FF-000412', NULL, 'Mismatch repair endonuclease PMS2', 133, NULL, NULL, 208078),
(208079, '2.40.230.10-FF-000003', NULL, NULL, 255, NULL, NULL, 208079),
(208080, '3.30.40.10-FF-001235', NULL, 'Lysine-specific demethylase rbr-2 isoform A', 69, NULL, NULL, 208080),
(208081, '3.30.200.20-FF-001318', NULL, 'Citron rho-interacting serine/threonine kinase a', 145, NULL, NULL, 208081),
(208082, '3.30.505.10-FF-000040', NULL, 'Tyrosine-protein kinase', 120, NULL, NULL, 208082),
(208083, '1.20.1640.10-FF-000042', NULL, 'Export membrane protein', 200, NULL, NULL, 208083),
(208084, '1.25.40.990-FF-000001', NULL, '26S proteasome non-ATPase regulatory subunit', 230, NULL, NULL, 208084),
(208085, '3.40.1380.10-FF-000010', NULL, 'ATP synthase gamma chain', 232, NULL, NULL, 208085),
(208086, '3.30.540.10-FF-000059', NULL, 'Bisphosphate nucleotidase', 195, NULL, NULL, 208086),
(208087, '2.60.40.10-FF-001702', NULL, 'Lymphocyte function-associated antigen 3', 93, NULL, NULL, 208087),
(208088, '1.25.40.70-FF-000051', NULL, 'Uncharacterized protein', 189, NULL, NULL, 208088),
(208089, '3.30.160.60-FF-001135', NULL, 'Zinc finger protein 57', 27, NULL, NULL, 208089),
(208090, '1.20.5.190-FF-000001', NULL, 'unconventional myosin-Va', 49, NULL, NULL, 208090),
(208091, '3.30.70.1230-FF-000281', NULL, 'Guanylate cyclase', 42, NULL, NULL, 208091),
(208092, '3.30.450.60-FF-000056', NULL, 'AP complex subunit sigma', 86, NULL, NULL, 208092),
(208093, '2.60.40.10-FF-000522', NULL, 'Tyrosine-protein kinase receptor', 103, NULL, NULL, 208093),
(208094, '2.60.120.10-FF-000614', NULL, 'Uncharacterized protein', 162, NULL, NULL, 208094),
(208095, '2.170.130.10-FF-000061', NULL, NULL, 129, NULL, NULL, 208095),
(208096, '3.80.10.10-FF-000354', NULL, 'Melanoma antigen preferentially expressed in tumors', 256, NULL, NULL, 208096),
(208097, '2.30.110.10-FF-000031', NULL, 'YPR172W', 156, NULL, NULL, 208097),
(208098, '3.40.50.720-FF-002144', NULL, 'Uncharacterized protein', 91, NULL, NULL, 208098),
(208099, '3.30.710.10-FF-000443', NULL, 'Protein bric-a-brac 1-like Protein', 158, NULL, NULL, 208099);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(208100, '3.20.20.60-FF-000018', NULL, 'Methylisocitrate lyase', 302, NULL, NULL, 208100),
(208101, '3.10.170.10-FF-000001', NULL, 'Peptidase M4', 154, NULL, NULL, 208101),
(208102, '1.25.10.10-FF-000924', NULL, 'Uncharacterized protein', 471, NULL, NULL, 208102),
(208103, '1.25.40.90-FF-000039', NULL, 'Vacuolar protein sorting-associated protein 27', 157, NULL, NULL, 208103),
(208104, '3.30.160.60-FF-003956', NULL, 'Zinc finger protein 592', 87, NULL, NULL, 208104),
(208105, '2.40.50.140-FF-000607', NULL, 'DNA replication licensing factor MCM7', 76, NULL, NULL, 208105),
(208106, '3.40.50.300-FF-003114', NULL, 'mRNA cleavage and polyadenylation factor CLP1', 279, NULL, NULL, 208106),
(208107, '3.30.160.20-FF-000084', NULL, 'Ribonuclease 3', 90, NULL, NULL, 208107),
(208108, '3.30.450.40-FF-000050', NULL, 'Transcriptional regulator, IclR family', 162, NULL, NULL, 208108),
(208109, '3.30.160.60-FF-000859', NULL, 'myc-associated zinc finger protein isoform X2', 41, NULL, NULL, 208109),
(208110, '3.40.850.10-FF-000119', NULL, 'Kinesin-like protein', 366, NULL, NULL, 208110),
(208111, '3.40.50.150-FF-001782', NULL, NULL, 186, NULL, NULL, 208111),
(208112, '4.10.410.10-FF-000073', NULL, 'Kunitz-type protein bli-5', 58, NULL, NULL, 208112),
(208113, '1.10.3080.10-FF-000041', NULL, 'Os03g0695700 protein', 47, NULL, NULL, 208113),
(208114, '1.10.540.10-FF-000026', NULL, 'Acyl-CoA dehydrogenase medium chain', 126, NULL, NULL, 208114),
(208115, '3.40.390.10-FF-000191', NULL, NULL, 180, NULL, NULL, 208115),
(208116, '3.30.70.330-FF-001229', NULL, 'Os05g0376000 protein', 84, NULL, NULL, 208116),
(208117, '3.40.605.10-FF-000051', NULL, 'Carnitine dehydratase', 274, NULL, NULL, 208117),
(208118, '2.130.10.10-FF-003390', NULL, 'Uncharacterized protein', 224, NULL, NULL, 208118),
(208119, '1.20.5.170-FF-000237', NULL, 'Transcription factor MafB', 107, NULL, NULL, 208119),
(208120, '3.40.33.10-FF-000173', NULL, 'Uncharacterized protein', 92, NULL, NULL, 208120),
(208121, '1.20.1070.10-FF-000133', NULL, 'Glucagon receptor a', 313, NULL, NULL, 208121),
(208122, '2.10.110.10-FF-000350', NULL, 'AGAP008979-PA', 59, NULL, NULL, 208122),
(208123, '3.40.50.1820-FF-001719', NULL, 'Alanine aminotransferase 2 mitochondrial', 134, NULL, NULL, 208123),
(208124, '3.30.40.10-FF-002303', NULL, 'AGAP007095-PA', 115, NULL, NULL, 208124),
(208125, '3.30.200.20-FF-001762', NULL, 'Uncharacterized protein', 44, NULL, NULL, 208125),
(208126, '1.20.120.1900-FF-000003', NULL, 'Gamma-tubulin complex component', 289, NULL, NULL, 208126),
(208127, '2.130.10.10-FF-004569', NULL, 'Uncharacterized protein', 212, NULL, NULL, 208127),
(208128, '1.20.1090.10-FF-000033', NULL, 'NADH-dependent butanol dehydrogenase A', 211, NULL, NULL, 208128),
(208129, '2.40.290.10-FF-000030', NULL, 'ATP-dependent DNA helicase II subunit 1', 116, NULL, NULL, 208129),
(208130, '3.30.60.190-FF-000016', NULL, 'HIT zinc finger, putative', 51, NULL, NULL, 208130),
(208131, '1.20.1560.10-FF-000333', NULL, 'ATP-binding cassette transporter', 291, NULL, NULL, 208131),
(208132, '3.30.70.330-FF-002174', NULL, NULL, 83, NULL, NULL, 208132),
(208133, '1.10.4030.10-FF-000004', NULL, 'Peptidylprolyl isomerase', 150, NULL, NULL, 208133),
(208134, '2.60.120.200-FF-000246', NULL, 'L-type lectin-domain containing receptor kinase V.9', 248, NULL, NULL, 208134),
(208135, '1.50.40.10-FF-000238', NULL, 'Mitochondrial ornithine transporter 1-like protein', 225, NULL, NULL, 208135),
(208136, '3.40.640.10-FF-000284', NULL, 'Low specificity L-threonine aldolase', 245, NULL, NULL, 208136),
(208137, '1.10.287.70-FF-000668', NULL, 'Uncharacterized protein', 114, NULL, NULL, 208137),
(208138, '3.40.50.1000-FF-000602', NULL, NULL, 99, NULL, NULL, 208138),
(208139, '3.30.190.20-FF-000023', NULL, 'Ribosomal protein L1p/L10e family, putative', 60, NULL, NULL, 208139),
(208140, '2.60.490.10-FF-000012', NULL, 'P2X purinoceptor', 303, NULL, NULL, 208140),
(208141, '3.80.10.10-FF-001422', NULL, 'GD22564', 242, NULL, NULL, 208141),
(208142, '3.40.630.30-FF-000019', NULL, 'RNA cytidine acetyltransferase', 198, NULL, NULL, 208142);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(208143, '3.30.70.330-FF-001898', NULL, NULL, 81, NULL, NULL, 208143),
(208144, '3.40.1490.10-FF-000001', NULL, 'Peptidyl-tRNA hydrolase 2', 117, NULL, NULL, 208144),
(208145, '3.10.310.20-FF-000010', NULL, 'Manganese-dependent inorganic pyrophosphatase, putative', 132, NULL, NULL, 208145),
(208146, '3.20.20.220-FF-000031', NULL, 'Bifunctional protein PutA', 389, NULL, NULL, 208146),
(208147, '3.30.70.330-FF-000712', NULL, 'NONO (Conserved nuclear protein, aka PSF) homolog', 95, NULL, NULL, 208147),
(208148, '1.10.287.470-FF-000069', NULL, 'RND multidrug efflux membrane fusion protein MexE', 102, NULL, NULL, 208148),
(208149, '1.10.1040.10-FF-000032', NULL, '6-phosphogluconate dehydrogenase, decarboxylating', 252, NULL, NULL, 208149),
(208150, '3.30.160.60-FF-001039', NULL, 'zinc finger and BTB domain-containing protein 17 isoform X1', 28, NULL, NULL, 208150),
(208151, '2.60.120.920-FF-000136', NULL, 'E3 ubiquitin-protein ligase Midline-1', 94, NULL, NULL, 208151),
(208152, '2.10.70.10-FF-000122', NULL, 'Beta-2-glycoprotein 1', 59, NULL, NULL, 208152),
(208153, '2.30.30.100-FF-000212', NULL, 'U7 snRNA-associated Sm-like protein LSm11', 136, NULL, NULL, 208153),
(208154, '2.170.270.10-FF-000211', NULL, 'SET domain-containing protein', 148, NULL, NULL, 208154),
(208155, '3.40.50.300-FF-006520', NULL, 'Predicted protein', 111, NULL, NULL, 208155),
(208156, '1.25.40.20-FF-001356', NULL, 'Spatzle 5', 291, NULL, NULL, 208156),
(208157, '1.10.238.10-FF-000728', NULL, 'Uncharacterized protein', 99, NULL, NULL, 208157),
(208158, '2.10.90.10-FF-000005', NULL, 'Inhibin beta A chain', 115, NULL, NULL, 208158),
(208159, '3.20.20.80-FF-000125', NULL, 'CTS1p Endochitinase', 291, NULL, NULL, 208159),
(208160, '1.25.40.10-FF-001819', NULL, 'Spliceosome associated factor 3, U4/U6 recycling protein', 147, NULL, NULL, 208160),
(208161, '3.30.420.40-FF-000222', NULL, 'Putative glycerol kinase', 243, NULL, NULL, 208161),
(208162, '1.20.1070.10-FF-000493', NULL, 'Adhesion G protein-coupled receptor G1', 260, NULL, NULL, 208162),
(208163, '1.20.58.70-FF-000085', NULL, 'Putative snare protein pep12/vam3/syntaxin 7/syntaxin 17', 121, NULL, NULL, 208163),
(208164, '2.170.16.10-FF-000017', NULL, 'Uncharacterized protein', 141, NULL, NULL, 208164),
(208165, '3.20.20.80-FF-000564', NULL, 'Uncharacterized protein', 118, NULL, NULL, 208165),
(208166, '3.40.50.300-FF-000337', NULL, 'ABC transporter G family member 22', 230, NULL, NULL, 208166),
(208167, '2.60.40.420-FF-000202', NULL, 'Uncharacterized protein', 160, NULL, NULL, 208167),
(208168, '2.40.50.1070-FF-000028', NULL, NULL, 166, NULL, NULL, 208168),
(208169, '1.25.10.10-FF-002599', NULL, 'Protein CBG03609', 149, NULL, NULL, 208169),
(208170, '1.20.58.60-FF-000548', NULL, 'Predicted protein', 136, NULL, NULL, 208170),
(208171, '3.40.50.80-FF-000222', NULL, 'Uncharacterized protein', 88, NULL, NULL, 208171),
(208172, '3.30.420.10-FF-000016', NULL, 'Ribonuclease', 195, NULL, NULL, 208172),
(208173, '2.60.120.10-FF-000131', NULL, '3-hydroxyanthranilate 3,4-dioxygenase', 172, NULL, NULL, 208173),
(208174, '1.10.340.70-FF-000017', NULL, 'Uncharacterized protein', 84, NULL, NULL, 208174),
(208175, '3.30.110.110-FF-000010', NULL, 'Double-strand break repair protein', 106, NULL, NULL, 208175),
(208176, '3.30.160.60-FF-002888', NULL, 'Uncharacterized protein', 29, NULL, NULL, 208176),
(208177, '1.10.510.10-FF-001497', NULL, 'Myosin light chain kinase, putative', 274, NULL, NULL, 208177),
(208178, '2.40.50.90-FF-000047', NULL, 'Probable staphylococcal-like nuclease CAN3', 111, NULL, NULL, 208178),
(208179, '1.10.1300.10-FF-000070', NULL, 'Uncharacterized protein', 115, NULL, NULL, 208179),
(208180, '3.30.420.40-FF-000582', NULL, 'Actin-like protein ARP6', 131, NULL, NULL, 208180),
(208181, '3.90.550.10-FF-000046', NULL, 'Mannose-1-phosphate guanylyltransferase (GDP)', 346, NULL, NULL, 208181),
(208182, '1.10.10.10-FF-001019', NULL, 'LysR family transcriptional regulator', 81, NULL, NULL, 208182),
(208183, '1.20.1070.10-FF-000363', NULL, 'Glucagon receptor', 301, NULL, NULL, 208183);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(208184, '2.40.50.120-FF-000034', NULL, 'Netrin 4', 128, NULL, NULL, 208184),
(208185, '2.60.120.260-FF-000348', NULL, 'Putative glucuronoxylan glucuronosyltransferase F8H', 99, NULL, NULL, 208185),
(208186, '3.40.50.720-FF-000019', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(P)+]', 188, NULL, NULL, 208186),
(208187, '3.30.1400.10-FF-000003', NULL, 'Cell division protein ZipA', 139, NULL, NULL, 208187),
(208188, '3.40.50.300-FF-005008', NULL, 'Septin 9', 84, NULL, NULL, 208188),
(208189, '1.25.40.10-FF-004355', NULL, 'TPR Domain containing protein', 157, NULL, NULL, 208189),
(208190, '1.20.930.20-FF-000012', NULL, 'Mixed lineage kinase domain like pseudokinase', 117, NULL, NULL, 208190),
(208191, '3.30.40.10-FF-000746', NULL, 'E3 ubiquitin-protein ligase RHF2A', 104, NULL, NULL, 208191),
(208192, '3.40.50.360-FF-000119', NULL, 'Flavo-diiron protein FprA1', 143, NULL, NULL, 208192),
(208193, '3.40.630.10-FF-000356', NULL, 'Uncharacterized protein', 166, NULL, NULL, 208193),
(208194, '3.30.40.10-FF-000616', NULL, 'Asi3p', 71, NULL, NULL, 208194),
(208195, '1.10.533.10-FF-000010', NULL, 'Ankyrin 1', 109, NULL, NULL, 208195),
(208196, '3.65.10.10-FF-000013', NULL, 'UDP-N-acetylglucosamine 1-carboxyvinyltransferase', 197, NULL, NULL, 208196),
(208197, '2.60.40.10-FF-002888', NULL, 'Leptin receptor', 94, NULL, NULL, 208197),
(208198, '3.10.170.20-FF-000021', NULL, NULL, 160, NULL, NULL, 208198),
(208199, '3.30.420.270-FF-000010', NULL, 'Transport energizing protein, ExbD/TolR family', 69, NULL, NULL, 208199),
(208200, '3.30.70.2000-FF-000006', NULL, 'BTB/POZ domain-containing protein KCTD5', 57, NULL, NULL, 208200),
(208201, '1.20.1740.10-FF-000235', NULL, 'Uncharacterized protein', 394, NULL, NULL, 208201),
(208202, '2.120.10.10-FF-000023', NULL, 'Trans-sialidase, putative', 393, NULL, NULL, 208202),
(208203, '1.10.530.10-FF-000071', NULL, 'Basic endochitinase B', 93, NULL, NULL, 208203),
(208204, '2.70.170.10-FF-000031', NULL, 'AcetylCholine Receptor', 220, NULL, NULL, 208204),
(208205, '3.30.300.20-FF-000073', NULL, 'Uncharacterized protein', 144, NULL, NULL, 208205),
(208206, '3.40.1180.10-FF-000011', NULL, 'NUS1p putative prenyltransferase', 209, NULL, NULL, 208206),
(208207, '1.10.555.10-FF-000055', NULL, 'Similar to GTPase-activating protein testicular GAP1', 198, NULL, NULL, 208207),
(208208, '3.30.1330.80-FF-000018', NULL, 'AT-hook motif nuclear-localized protein 21', 131, NULL, NULL, 208208),
(208209, '1.10.418.60-FF-000021', NULL, 'Kinetochore protein nuf2', 162, NULL, NULL, 208209),
(208210, '3.30.310.10-FF-000025', NULL, 'AP complex subunit beta', 120, NULL, NULL, 208210),
(208211, '2.10.25.10-FF-000028', NULL, 'Signal peptide, CUB domain and EGF-like domain-containing 2', 37, NULL, NULL, 208211),
(208212, '2.70.170.10-FF-000059', NULL, 'Uncharacterized protein, isoform F', 62, NULL, NULL, 208212),
(208213, '2.40.270.10-FF-000028', NULL, NULL, 59, NULL, NULL, 208213),
(208214, '1.20.1270.60-FF-000005', NULL, 'Sphingolipid long chain base-responsive pil1', 217, NULL, NULL, 208214),
(208215, '2.40.430.10-FF-000002', NULL, 'Maltose/maltodextrin transport system permease protein MalF', 87, NULL, NULL, 208215),
(208216, '2.60.40.1090-FF-000007', NULL, 'Fimbrial-like protein FimF', 146, NULL, NULL, 208216),
(208217, '2.60.120.330-FF-000156', NULL, 'Os05g0514600 protein', 117, NULL, NULL, 208217),
(208218, '3.20.20.80-FF-000221', NULL, 'PLASMODESMATA CALLOSE-BINDING PROTEIN 5', 169, NULL, NULL, 208218),
(208219, '3.30.420.40-FF-001071', NULL, 'Uncharacterized protein', 172, NULL, NULL, 208219),
(208220, '1.10.510.10-FF-003751', NULL, NULL, 143, NULL, NULL, 208220),
(208221, '3.30.40.10-FF-002180', NULL, 'Uncharacterized protein', 81, NULL, NULL, 208221),
(208222, '2.60.40.10-FF-004575', NULL, NULL, 119, NULL, NULL, 208222),
(208223, '2.60.40.60-FF-000172', NULL, 'cadherin-23 isoform X1', 103, NULL, NULL, 208223),
(208224, '3.40.50.10190-FF-000172', NULL, 'DNA topoisomerase II binding protein 1', 87, NULL, NULL, 208224),
(208225, '3.20.20.140-FF-000203', NULL, 'Pyrimidine deaminase archaeal predicted', 276, NULL, NULL, 208225);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(208226, '3.30.70.260-FF-000112', NULL, 'D-3-phosphoglycerate dehydrogenase', 74, NULL, NULL, 208226),
(208227, '3.30.1330.30-FF-000032', NULL, 'Eukaryotic peptide chain release factor subunit 1', 153, NULL, NULL, 208227),
(208228, '3.80.10.10-FF-001765', NULL, 'Toll-9, isoform B', 156, NULL, NULL, 208228),
(208229, '1.25.40.20-FF-000530', NULL, 'SH3 and multiple ankyrin repeat domains protein', 99, NULL, NULL, 208229),
(208230, '3.40.50.300-FF-003777', NULL, 'ABC transporter, putative', 243, NULL, NULL, 208230),
(208231, '2.130.10.10-FF-005188', NULL, 'POC1 centriolar protein homolog', 117, NULL, NULL, 208231),
(208232, '3.30.420.10-FF-000146', NULL, 'Endogenous retrovirus group K member 6 Pol protein', 145, NULL, NULL, 208232),
(208233, '3.80.10.10-FF-002041', NULL, 'Protein artichoke', 179, NULL, NULL, 208233),
(208234, '3.30.160.60-FF-003164', NULL, 'Zinc finger and BTB domain-containing 17', 27, NULL, NULL, 208234),
(208235, '3.40.50.150-FF-001343', NULL, NULL, 194, NULL, NULL, 208235),
(208236, '3.60.15.10-FF-000282', NULL, 'Uncharacterized protein', 93, NULL, NULL, 208236),
(208237, '2.10.25.10-FF-000484', NULL, 'Crumbs 1, cell polarity complex component', 40, NULL, NULL, 208237),
(208238, '1.10.260.40-FF-000087', NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', 77, NULL, NULL, 208238),
(208239, '1.25.40.10-FF-003506', NULL, 'DnaJ homolog subfamily C member 7 homolog', 75, NULL, NULL, 208239),
(208240, '1.20.120.1780-FF-000012', NULL, '4-hydroxybenzoate solanesyltransferase', 121, NULL, NULL, 208240),
(208241, '2.60.40.10-FF-001141', NULL, 'Down syndrome cell adhesion molecule 4, isoform D', 108, NULL, NULL, 208241),
(208242, '2.10.220.10-FF-000111', NULL, 'Furin2, putative', 97, NULL, NULL, 208242),
(208243, '3.40.50.300-FF-006880', NULL, 'Uncharacterized protein', 246, NULL, NULL, 208243),
(208244, '2.60.120.290-FF-000104', NULL, 'Multiple EGF like domains 8', 137, NULL, NULL, 208244),
(208245, '1.25.40.10-FF-001157', NULL, 'Putative pentatricopeptide repeat-containing protein', 71, NULL, NULL, 208245),
(208246, '1.25.10.10-FF-001661', NULL, 'Uncharacterized protein', 337, NULL, NULL, 208246),
(208247, '1.10.150.20-FF-000331', NULL, 'DNA-directed RNA polymerase', 174, NULL, NULL, 208247),
(208248, '1.10.510.10-FF-003964', NULL, NULL, 43, NULL, NULL, 208248),
(208249, '2.90.10.30-FF-000008', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase SD3-1', 140, NULL, NULL, 208249),
(208250, '2.70.150.10-FF-000277', NULL, 'Cation-transporting ATPase', 229, NULL, NULL, 208250),
(208251, '3.30.1330.10-FF-000037', NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase (AIRS) (PurM)', 149, NULL, NULL, 208251),
(208252, '3.30.420.10-FF-000707', NULL, NULL, 102, NULL, NULL, 208252),
(208253, '3.10.20.30-FF-000100', NULL, NULL, 51, NULL, NULL, 208253),
(208254, '3.10.450.490-FF-000002', NULL, 'Neutral protease B', 91, NULL, NULL, 208254),
(208255, '2.20.70.10-FF-000262', NULL, 'Uncharacterized protein', 43, NULL, NULL, 208255),
(208256, '2.20.28.230-FF-000003', NULL, 'Interleukin-2 receptor subunit alpha', 36, NULL, NULL, 208256),
(208257, '1.25.40.10-FF-000061', NULL, 'Tetratricopeptide repeat domain 17', 204, NULL, NULL, 208257),
(208258, '3.90.640.10-FF-000036', NULL, 'Actin-like protein ARP6', 94, NULL, NULL, 208258),
(208259, '3.40.50.300-FF-006548', NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 10, mitochondrial', 106, NULL, NULL, 208259),
(208260, '1.20.1050.130-FF-000041', NULL, 'Glutathione S-transferase', 76, NULL, NULL, 208260),
(208261, '1.10.8.60-FF-000415', NULL, 'Differentiation specific element binding protein, putative', 59, NULL, NULL, 208261),
(208262, '1.10.472.80-FF-000169', NULL, NULL, 125, NULL, NULL, 208262),
(208263, '3.10.620.30-FF-000003', NULL, 'Centrosomal protein of 76 kDa', 145, NULL, NULL, 208263),
(208264, '1.25.40.10-FF-003287', NULL, 'TPR repeat, putative', 129, NULL, NULL, 208264),
(208265, '3.30.2020.30-FF-000031', NULL, 'Uncharacterized protein', 69, NULL, NULL, 208265),
(208266, '1.20.1250.20-FF-001869', NULL, 'LacY', 110, NULL, NULL, 208266);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(208267, '2.40.128.80-FF-000005', NULL, 'Dipeptidyl aminopeptidase 2', 143, NULL, NULL, 208267),
(208268, '4.10.1000.10-FF-000067', NULL, 'Zinc finger C-x8-C-x5-C-x3-H type family protein', 54, NULL, NULL, 208268),
(208269, '3.40.50.300-FF-003906', NULL, 'Macrolide export ATP-binding/permease protein MacB', 224, NULL, NULL, 208269),
(208270, '3.30.200.20-FF-000930', NULL, 'Protein CBG20555', 108, NULL, NULL, 208270),
(208271, '1.20.1070.10-FF-002179', NULL, 'Uncharacterized protein', 106, NULL, NULL, 208271),
(208272, '1.20.120.1750-FF-000020', NULL, 'ATP-dependent RNA helicase DEAH12 chloroplastic', 79, NULL, NULL, 208272),
(208273, '3.40.50.300-FF-000129', NULL, 'Replication factor C subunit 5', 168, NULL, NULL, 208273),
(208274, '3.90.550.10-FF-000389', NULL, 'UDP-glucose ceramide glucosyltransferase', 145, NULL, NULL, 208274),
(208275, '2.120.10.80-FF-000004', NULL, 'Ectoderm-neural cortex protein 1', 220, NULL, NULL, 208275),
(208276, '4.10.375.10-FF-000001', NULL, 'Lipoxygenase', 104, NULL, NULL, 208276),
(208277, '3.20.20.80-FF-000333', NULL, 'Glycogen debranching enzyme Gdb1, putative (AFU_orthologue AFUA_1G02140)', 164, NULL, NULL, 208277),
(208278, '3.10.280.10-FF-000021', NULL, 'Os01g0143700 protein', 216, NULL, NULL, 208278),
(208279, '3.30.428.10-FF-000028', NULL, 'Galactose-1-phosphate uridylyltransferase', 76, NULL, NULL, 208279),
(208280, '2.130.10.10-FF-003608', NULL, 'Sema domain, immunoglobulin domain (Ig), transmembrane domain (TM) and short cytoplasmic domain, (semaphorin) 4Aa', 460, NULL, NULL, 208280),
(208281, '3.30.50.10-FF-000095', NULL, 'Glucocorticoid receptor isoform 1', 80, NULL, NULL, 208281),
(208282, '3.40.50.1980-FF-000093', NULL, 'Nitrogenase molybdenum-iron protein beta chain', 105, NULL, NULL, 208282),
(208283, '3.40.50.300-FF-001765', NULL, 'ABC transporter B family member 6', 238, NULL, NULL, 208283),
(208284, '1.10.510.10-FF-003380', NULL, NULL, 322, NULL, NULL, 208284),
(208285, '3.30.450.20-FF-000061', NULL, 'Histidine kinase 5', 136, NULL, NULL, 208285),
(208286, '2.120.10.30-FF-000473', NULL, 'Uncharacterized protein', 60, NULL, NULL, 208286),
(208287, '1.10.3200.20-FF-000020', NULL, NULL, 78, NULL, NULL, 208287),
(208288, '2.170.270.10-FF-000003', NULL, 'Histone-lysine N-methyltransferase', 159, NULL, NULL, 208288),
(208289, '3.20.20.100-FF-000118', NULL, 'AKR1E2 isoform 12', 198, NULL, NULL, 208289),
(208290, '2.130.10.10-FF-005637', NULL, 'Coatomer subunit beta''-3', 176, NULL, NULL, 208290),
(208291, '2.60.40.10-FF-005081', NULL, NULL, 100, NULL, NULL, 208291),
(208292, '1.10.20.10-FF-000003', NULL, 'Histone H2B', 126, NULL, NULL, 208292),
(208293, '1.20.1050.10-FF-000036', NULL, 'Putative glutamyl-tRNA synthetase', 89, NULL, NULL, 208293),
(208294, '2.40.70.10-FF-000188', NULL, 'Sap99p', 162, NULL, NULL, 208294),
(208295, '2.10.60.10-FF-000054', NULL, 'Uncharacterized protein', 34, NULL, NULL, 208295),
(208296, '1.10.443.10-FF-000014', NULL, 'Site-specific recombinase, phage integrase family', 193, NULL, NULL, 208296),
(208297, '3.40.50.300-FF-007167', NULL, 'ADP-ribosylation factor, putative', 174, NULL, NULL, 208297),
(208298, '2.40.50.140-FF-000484', NULL, 'Putative activity regulator of membrane protease YbbK', 62, NULL, NULL, 208298),
(208299, '3.90.70.80-FF-000018', NULL, 'OTU domain-containing protein 5-B', 154, NULL, NULL, 208299),
(208300, '3.40.630.30-FF-000463', NULL, 'Sll1647 protein', 169, NULL, NULL, 208300),
(208301, '3.30.310.80-FF-000006', NULL, 'Non-specific serine/threonine protein kinase', 113, NULL, NULL, 208301),
(208302, '3.30.160.60-FF-003501', NULL, 'Zinc finger imprinted 2', 36, NULL, NULL, 208302),
(208303, '3.40.50.300-FF-006975', NULL, 'Uncharacterized protein', 218, NULL, NULL, 208303),
(208304, '3.30.70.250-FF-000014', NULL, NULL, 72, NULL, NULL, 208304),
(208305, '3.30.60.30-FF-000040', NULL, 'Agrin, putative', 68, NULL, NULL, 208305),
(208306, '3.30.160.60-FF-004120', NULL, NULL, 28, NULL, NULL, 208306),
(208307, '2.40.70.10-FF-000300', NULL, NULL, 200, NULL, NULL, 208307),
(208308, '3.60.10.10-FF-000304', NULL, 'Uncharacterized protein', 312, NULL, NULL, 208308);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(208309, '3.40.50.620-FF-000219', NULL, 'Valine--tRNA ligase', 131, NULL, NULL, 208309),
(208310, '3.40.50.10420-FF-000044', NULL, 'Protein CBG12218', 138, NULL, NULL, 208310),
(208311, '3.30.260.10-FF-000032', NULL, 'T-complex protein 1 subunit theta', 107, NULL, NULL, 208311),
(208312, '2.60.40.10-FF-003052', NULL, 'Interleukin 18 receptor accessory protein', 121, NULL, NULL, 208312),
(208313, '2.60.120.650-FF-000134', NULL, 'Predicted protein', 290, NULL, NULL, 208313),
(208314, '3.30.30.30-FF-000004', NULL, 'hypoxia up-regulated protein 1', 55, NULL, NULL, 208314),
(208315, '1.20.58.1030-FF-000004', NULL, 'DNA replication complex GINS protein PSF1', 134, NULL, NULL, 208315),
(208316, '3.20.20.100-FF-000219', NULL, 'Uncharacterized protein', 233, NULL, NULL, 208316),
(208317, '2.130.10.10-FF-005738', NULL, 'Uncharacterized protein', 126, NULL, NULL, 208317),
(208318, '3.40.50.300-FF-005351', NULL, 'RecBCD enzyme subunit RecC', 215, NULL, NULL, 208318),
(208319, '1.25.40.20-FF-001587', NULL, 'Uncharacterized protein', 118, NULL, NULL, 208319),
(208320, '3.40.50.300-FF-001068', NULL, 'RecBCD enzyme subunit RecC', 156, NULL, NULL, 208320),
(208321, '2.60.40.10-FF-003956', NULL, NULL, 104, NULL, NULL, 208321),
(208322, '1.20.5.170-FF-000006', NULL, 'fos-related antigen 2 isoform X1', 68, NULL, NULL, 208322),
(208323, '2.30.30.140-FF-000084', NULL, 'Tudor and KH domain-containing protein', 72, NULL, NULL, 208323),
(208324, '2.60.120.200-FF-000033', NULL, 'pikachurin isoform X1', 180, NULL, NULL, 208324),
(208325, '3.40.190.10-FF-000428', NULL, 'Transcriptional regulator, LysR family', 97, NULL, NULL, 208325),
(208326, '3.80.10.10-FF-000933', NULL, 'RNI-like superfamily protein', 81, NULL, NULL, 208326),
(208327, '1.20.1050.10-FF-000250', NULL, 'Glutathione S-transferase family protein', 35, NULL, NULL, 208327),
(208328, '1.10.10.350-FF-000010', NULL, 'Glutamate--tRNA ligase', 99, NULL, NULL, 208328),
(208329, '3.40.50.10140-FF-000067', NULL, 'Uncharacterized protein', 129, NULL, NULL, 208329),
(208330, '3.40.50.150-FF-001686', NULL, NULL, 117, NULL, NULL, 208330),
(208331, '3.20.20.190-FF-000095', NULL, 'Uncharacterized protein', 248, NULL, NULL, 208331),
(208332, '3.30.1330.90-FF-000004', NULL, 'L-serine dehydratase, iron-sulfur-dependent subunit beta', 125, NULL, NULL, 208332),
(208333, '1.10.8.270-FF-000067', NULL, 'TBC1 domain family member 25', 102, NULL, NULL, 208333),
(208334, '1.10.238.10-FF-001217', NULL, 'Uncharacterized protein', 151, NULL, NULL, 208334),
(208335, '1.10.560.10-FF-000140', NULL, 'Uncharacterized protein', 86, NULL, NULL, 208335),
(208336, '1.20.1420.30-FF-000054', NULL, 'Sodium/calcium exchanger membrane region', 144, NULL, NULL, 208336),
(208337, '2.60.40.10-FF-004367', NULL, NULL, 90, NULL, NULL, 208337),
(208338, '3.30.70.330-FF-002387', NULL, NULL, 98, NULL, NULL, 208338),
(208339, '2.40.50.40-FF-000089', NULL, 'Chemokine', 72, NULL, NULL, 208339),
(208340, '3.60.21.10-FF-000223', NULL, 'Uncharacterized protein', 289, NULL, NULL, 208340),
(208341, '6.20.10.30-FF-000002', NULL, 'DNA ligase', 38, NULL, NULL, 208341),
(208342, '1.20.1110.10-FF-000081', NULL, 'ATPase 7', 116, NULL, NULL, 208342),
(208343, '3.60.20.10-FF-000232', NULL, NULL, 102, NULL, NULL, 208343),
(208344, '3.90.1720.10-FF-000036', NULL, 'Palmitoyltransferase', 179, NULL, NULL, 208344),
(208345, '3.40.50.300-FF-006071', NULL, 'Uncharacterized protein', 243, NULL, NULL, 208345),
(208346, '1.10.287.70-FF-000117', NULL, 'Voltage-gated Ca2+ channel, alpha subunit', 169, NULL, NULL, 208346),
(208347, '2.90.10.10-FF-000002', NULL, 'Serine/threonine-protein kinase', 133, NULL, NULL, 208347),
(208348, '2.30.130.40-FF-000018', NULL, 'Cereblon', 130, NULL, NULL, 208348),
(208349, '3.40.50.720-FF-000811', NULL, 'AflH/ adhA/ short chain alcohol dehydrogenase', 271, NULL, NULL, 208349),
(208350, '1.20.1250.10-FF-000023', NULL, 'Cardiotrophin-2', 184, NULL, NULL, 208350),
(208351, '1.20.1600.10-FF-000045', NULL, 'Outer membrane efflux protein', 442, NULL, NULL, 208351),
(208352, '3.40.50.1010-FF-000167', NULL, NULL, 150, NULL, NULL, 208352);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(208353, '3.40.50.1000-FF-000052', NULL, 'Alpha,alpha-trehalose-phosphate synthase [UDP-forming] 6', 132, NULL, NULL, 208353),
(208354, '1.10.3460.10-FF-000036', NULL, 'Predicted protein', 105, NULL, NULL, 208354),
(208355, '2.60.120.10-FF-000261', NULL, 'At4g10300', 100, NULL, NULL, 208355),
(208356, '2.60.40.10-FF-001719', NULL, 'FiLamiN (Actin binding protein) homolog', 97, NULL, NULL, 208356),
(208357, '3.40.50.720-FF-001531', NULL, 'Uncharacterized protein', 283, NULL, NULL, 208357),
(208358, '3.40.50.790-FF-000001', NULL, '50S ribosomal protein L1', 92, NULL, NULL, 208358),
(208359, '3.50.50.60-FF-000255', NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme GidA', 174, NULL, NULL, 208359),
(208360, '3.80.10.10-FF-003682', NULL, 'Uncharacterized protein', 314, NULL, NULL, 208360),
(208361, '3.20.20.60-FF-000131', NULL, 'Pyruvate kinase', 56, NULL, NULL, 208361),
(208362, '3.50.50.60-FF-000367', NULL, 'Rab proteins geranylgeranyltransferase', 202, NULL, NULL, 208362),
(208363, '3.80.10.10-FF-003794', NULL, 'AGAP007463-PA', 94, NULL, NULL, 208363),
(208364, '3.40.30.10-FF-000599', NULL, 'Peroxiredoxin', 185, NULL, NULL, 208364),
(208365, '1.25.40.20-FF-000873', NULL, 'Glutaminase kidney isoform, mitochondrial', 91, NULL, NULL, 208365),
(208366, '2.60.34.10-FF-000137', NULL, 'Uncharacterized protein', 70, NULL, NULL, 208366),
(208367, '1.25.10.10-FF-001981', NULL, 'Aminopeptidase', 151, NULL, NULL, 208367),
(208368, '3.40.50.800-FF-000055', NULL, 'Histidine--tRNA ligase', 95, NULL, NULL, 208368),
(208369, '2.40.10.350-FF-000011', NULL, 'Rod shape-determining protein MreC', 79, NULL, NULL, 208369),
(208370, '1.20.1280.140-FF-000005', NULL, 'Uncharacterized protein', 83, NULL, NULL, 208370),
(208371, '1.20.1270.90-FF-000003', NULL, 'Zinc metalloprotease ZmpB', 66, NULL, NULL, 208371),
(208372, '3.30.230.10-FF-000204', NULL, 'mismatch repair endonuclease PMS2 isoform X2', 53, NULL, NULL, 208372),
(208373, '3.40.30.10-FF-001217', NULL, 'Uncharacterized protein', 131, NULL, NULL, 208373),
(208374, '3.90.190.10-FF-000417', NULL, 'Protein tyrosine phosphatase SH-PTP2', 94, NULL, NULL, 208374),
(208375, '3.90.190.10-FF-000193', NULL, 'Uncharacterized protein', 140, NULL, NULL, 208375),
(208376, '3.30.230.10-FF-000316', NULL, 'Uncharacterized protein', 149, NULL, NULL, 208376),
(208377, '2.120.10.30-FF-000372', NULL, 'Acylaminoacyl-peptide hydrolase', 279, NULL, NULL, 208377),
(208378, '2.30.29.30-FF-000418', NULL, 'PH domain protein', 114, NULL, NULL, 208378),
(208379, '3.40.50.1100-FF-000205', NULL, 'Pyridoxal-phosphate dependent protein', 24, NULL, NULL, 208379),
(208380, '1.25.40.10-FF-005209', NULL, 'Clustered mitochondria protein homolog', 202, NULL, NULL, 208380),
(208381, '3.40.50.1820-FF-000410', NULL, 'Lipase', 366, NULL, NULL, 208381),
(208382, '1.10.510.10-FF-003172', NULL, NULL, 163, NULL, NULL, 208382),
(208383, '1.10.287.280-FF-000001', NULL, 'DNA-directed RNA polymerase', 77, NULL, NULL, 208383),
(208384, '3.40.50.2300-FF-000352', NULL, 'LacI family transcriptional regulator', 131, NULL, NULL, 208384),
(208385, '1.25.10.10-FF-003459', NULL, 'Predicted protein', 236, NULL, NULL, 208385),
(208386, '3.30.2350.10-FF-000038', NULL, 'Ribosomal pseudouridine synthase', 244, NULL, NULL, 208386),
(208387, '1.10.238.10-FF-001122', NULL, 'Uncharacterized protein', 34, NULL, NULL, 208387),
(208388, '1.10.1280.10-FF-000022', NULL, 'Uncharacterized protein', 347, NULL, NULL, 208388),
(208389, '3.40.50.2020-FF-000015', NULL, 'Uridine kinase', 216, NULL, NULL, 208389),
(208390, '2.40.50.140-FF-000692', NULL, 'Asparagine--tRNA ligase', 103, NULL, NULL, 208390),
(208391, '1.25.40.10-FF-004012', NULL, 'TPR repeat-containing protein P27G11.02', 202, NULL, NULL, 208391),
(208392, '2.160.20.10-FF-000191', NULL, 'F-box protein 10', 164, NULL, NULL, 208392),
(208393, '3.10.20.90-FF-000432', NULL, 'Protein CBR-GCK-3', 99, NULL, NULL, 208393),
(208394, '3.40.50.880-FF-000022', NULL, 'protein deglycase DJ-1', 187, NULL, NULL, 208394),
(208395, '3.40.50.300-FF-003086', NULL, 'GTP-binding protein, Ras family protein', 181, NULL, NULL, 208395);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(208396, '3.60.10.10-FF-000198', NULL, 'Probable deoxyribonuclease I (DNase I)', 253, NULL, NULL, 208396),
(208397, '1.25.40.10-FF-000538', NULL, 'Pentatricopeptide repeat-containing protein', 159, NULL, NULL, 208397),
(208398, '2.60.40.10-FF-001618', NULL, 'Chitinase', 92, NULL, NULL, 208398),
(208399, '1.20.120.350-FF-000155', NULL, NULL, 92, NULL, NULL, 208399),
(208400, '2.130.10.10-FF-004912', NULL, 'Plexin, putative', 110, NULL, NULL, 208400),
(208401, '2.60.40.60-FF-000964', NULL, 'Predicted protein', 72, NULL, NULL, 208401),
(208402, '3.40.50.720-FF-002150', NULL, 'Uncharacterized protein', 88, NULL, NULL, 208402),
(208403, '3.30.160.60-FF-004816', NULL, NULL, 37, NULL, NULL, 208403),
(208404, '3.40.190.10-FF-000760', NULL, 'Glutamate receptor', 35, NULL, NULL, 208404),
(208405, '3.30.70.330-FF-000049', NULL, 'Polyadenylate-binding protein', 97, NULL, NULL, 208405),
(208406, '3.40.250.10-FF-000046', NULL, 'Serine/threonine/tyrosine interacting like 1', 134, NULL, NULL, 208406),
(208407, '1.20.1070.10-FF-000942', NULL, 'G protein-coupled receptor, putative', 227, NULL, NULL, 208407),
(208408, '3.90.70.10-FF-000161', NULL, 'Related to deubiquitinating enzyme ubh1', 315, NULL, NULL, 208408),
(208409, '2.40.340.10-FF-000023', NULL, NULL, 69, NULL, NULL, 208409),
(208410, '1.10.630.10-FF-000584', NULL, 'Uncharacterized protein', 299, NULL, NULL, 208410),
(208411, '3.30.70.1230-FF-000073', NULL, 'Soluble guanylate cyclase gcy-37', 191, NULL, NULL, 208411),
(208412, '3.30.70.330-FF-003034', NULL, NULL, 41, NULL, NULL, 208412),
(208413, '3.30.479.20-FF-000059', NULL, 'Elongation factor Ts, mitochondrial', 92, NULL, NULL, 208413),
(208414, '2.30.30.380-FF-000037', NULL, 'Protein transport protein Sec24C, putative', 73, NULL, NULL, 208414),
(208415, '3.40.50.620-FF-000427', NULL, 'Probable nicotinate-nucleotide adenylyltransferase', 209, NULL, NULL, 208415),
(208416, '3.40.50.740-FF-000008', NULL, 'Dimethyl sulfoxide reductase subunit A', 306, NULL, NULL, 208416),
(208417, '1.20.910.10-FF-000013', NULL, 'Heme oxygenase', 196, NULL, NULL, 208417),
(208418, '2.130.10.10-FF-002203', NULL, 'Probable elongator complex protein 2', 248, NULL, NULL, 208418),
(208419, '1.10.565.10-FF-000123', NULL, 'Nuclear Hormone Receptor family', 230, NULL, NULL, 208419),
(208420, '3.30.70.330-FF-000942', NULL, 'Multiple RNA-binding domain-containing protein 1', 115, NULL, NULL, 208420),
(208421, '1.20.58.60-FF-000205', NULL, 'Uncharacterized protein, isoform B', 255, NULL, NULL, 208421),
(208422, '3.30.160.60-FF-006250', NULL, NULL, 60, NULL, NULL, 208422),
(208423, '3.30.559.10-FF-000220', NULL, 'Uncharacterized protein', 186, NULL, NULL, 208423),
(208424, '1.25.10.10-FF-000233', NULL, 'Ecm29 proteasome adaptor and scaffold', 170, NULL, NULL, 208424),
(208425, '3.20.20.70-FF-000235', NULL, 'Orotidine 5''-phosphate decarboxylase', 232, NULL, NULL, 208425),
(208426, '3.40.50.2000-FF-000464', NULL, 'UDP-Glycosyltransferase superfamily protein', 194, NULL, NULL, 208426),
(208427, '3.30.390.30-FF-000019', NULL, 'Trypanothione reductase', 131, NULL, NULL, 208427),
(208428, '3.10.129.10-FF-000265', NULL, 'Uncharacterized protein C3A12.08', 198, NULL, NULL, 208428),
(208429, '1.20.58.60-FF-000099', NULL, 'Spectrin beta chain', 107, NULL, NULL, 208429),
(208430, '3.40.50.12780-FF-000201', NULL, 'Uncharacterized protein', 340, NULL, NULL, 208430),
(208431, '1.20.1560.10-FF-000221', NULL, 'Uncharacterized protein, isoform A', 53, NULL, NULL, 208431),
(208432, '3.40.50.150-FF-001574', NULL, NULL, 58, NULL, NULL, 208432),
(208433, '1.20.1610.10-FF-000006', NULL, 'Alpha-1,2-mannosidase, putative', 148, NULL, NULL, 208433),
(208434, '2.30.30.140-FF-000196', NULL, 'Predicted protein', 65, NULL, NULL, 208434),
(208435, '1.20.1250.20-FF-002263', NULL, 'Os10g0404500 protein', 102, NULL, NULL, 208435),
(208436, '3.40.50.1820-FF-000859', NULL, 'Carboxylic ester hydrolase', 288, NULL, NULL, 208436),
(208437, '3.90.640.90-FF-000021', NULL, 'Predicted protein', 119, NULL, NULL, 208437),
(208438, '1.10.150.20-FF-000095', NULL, 'Exonuclease I, putative', 80, NULL, NULL, 208438); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(208439, '3.40.30.10-FF-000020', NULL, 'Peroxiredoxin', 162, NULL, NULL, 208439),
(208440, '3.40.50.2300-FF-001521', NULL, NULL, 86, NULL, NULL, 208440),
(208441, '3.30.200.20-FF-002381', NULL, NULL, 58, NULL, NULL, 208441),
(208442, '1.20.1250.20-FF-000577', NULL, 'Mch4p', 191, NULL, NULL, 208442),
(208443, '2.30.42.10-FF-000404', NULL, NULL, 46, NULL, NULL, 208443),
(208444, '3.30.390.10-FF-000013', NULL, 'L-rhamnonate dehydratase', 137, NULL, NULL, 208444),
(208445, '3.40.50.720-FF-000699', NULL, 'Arg5,6p', 149, NULL, NULL, 208445),
(208446, '1.10.418.10-FF-000259', NULL, 'Spectrin beta, non-erythrocytic 4', 67, NULL, NULL, 208446),
(208447, '3.30.200.20-FF-001650', NULL, 'Putative pseudokinase domain of ste20-related kinase adapter protein', 88, NULL, NULL, 208447),
(208448, '1.25.40.10-FF-000965', NULL, 'Ethylene-overproduction protein 1', 247, NULL, NULL, 208448),
(208449, '3.40.850.10-FF-000451', NULL, 'Uncharacterized protein', 85, NULL, NULL, 208449),
(208450, '2.60.40.2170-FF-000005', NULL, 'tyrosine-protein kinase Drl', 144, NULL, NULL, 208450),
(208451, '2.30.29.30-FF-000099', NULL, 'Arf-GAP with dual PH domain-containing protein 1', 128, NULL, NULL, 208451),
(208452, '3.30.160.60-FF-001247', NULL, 'zinc finger protein 341 isoform X1', 27, NULL, NULL, 208452),
(208453, '3.30.40.10-FF-000167', NULL, 'PHD finger protein 6 X-linked', 128, NULL, NULL, 208453),
(208454, '2.40.33.40-FF-000004', NULL, NULL, 120, NULL, NULL, 208454),
(208455, '1.20.1410.10-FF-000025', NULL, 'Uncharacterized protein', 192, NULL, NULL, 208455),
(208456, '3.10.580.10-FF-000167', NULL, 'Chloride channel protein C', 56, NULL, NULL, 208456),
(208457, '1.10.8.270-FF-000168', NULL, 'Uncharacterized protein', 75, NULL, NULL, 208457),
(208458, '1.10.10.10-FF-001930', NULL, 'Regulatory protein MarR', 144, NULL, NULL, 208458),
(208459, '3.40.50.12780-FF-000190', NULL, 'Uncharacterized protein', 142, NULL, NULL, 208459),
(208460, '2.40.10.10-FF-000072', NULL, 'CLIP-domain serine protease', 250, NULL, NULL, 208460),
(208461, '3.40.50.300-FF-005452', NULL, 'ATP-binding cassette transporter, subfamily G, member 23, group PDR protein PpABCG23', 242, NULL, NULL, 208461),
(208462, '3.20.80.10-FF-000018', NULL, 'Heme-binding protein 2', 190, NULL, NULL, 208462),
(208463, '3.40.50.720-FF-000593', NULL, 'Dihydrofolate reductase', 189, NULL, NULL, 208463),
(208464, '1.25.40.10-FF-003950', NULL, 'Predicted protein', 363, NULL, NULL, 208464),
(208465, '2.60.40.10-FF-003405', NULL, NULL, 86, NULL, NULL, 208465),
(208466, '1.50.10.10-FF-000057', NULL, 'N-acylglucosamine 2-epimerase', 392, NULL, NULL, 208466),
(208467, '1.10.1370.10-FF-000012', NULL, 'Oligoendopeptidase F', 158, NULL, NULL, 208467),
(208468, '1.25.40.500-FF-000001', NULL, 'Transcription initiation factor TFIID subunit 5', 156, NULL, NULL, 208468),
(208469, '2.170.300.10-FF-000001', NULL, 'Laminin subunit beta-1', 116, NULL, NULL, 208469),
(208470, '1.10.287.1490-FF-000123', NULL, 'Putative DNA repair protein', 152, NULL, NULL, 208470),
(208471, '2.30.29.30-FF-000992', NULL, 'Predicted protein', 137, NULL, NULL, 208471),
(208472, '3.40.1380.20-FF-000001', NULL, 'Pyruvate kinase', 138, NULL, NULL, 208472),
(208473, '3.30.900.10-FF-000048', NULL, 'MAD (Yeast Mitosis arrest DeFicient) related', 115, NULL, NULL, 208473),
(208474, '2.60.40.10-FF-003850', NULL, NULL, 101, NULL, NULL, 208474),
(208475, '3.30.420.40-FF-000014', NULL, 'Rod shape-determining protein MreB', 154, NULL, NULL, 208475),
(208476, '2.60.40.150-FF-000666', NULL, 'Copine, putative', 84, NULL, NULL, 208476),
(208477, '2.130.10.10-FF-000966', NULL, 'Hsv2p', 327, NULL, NULL, 208477),
(208478, '1.20.120.1080-FF-000027', NULL, 'ATP-dependent RNA helicase dhx8', 153, NULL, NULL, 208478),
(208479, '2.30.30.140-FF-000207', NULL, 'Tudor/PWWP/MBT superfamily protein', 103, NULL, NULL, 208479),
(208480, '1.25.40.10-FF-001033', NULL, 'PPR repeat family, putative', 150, NULL, NULL, 208480),
(208481, '1.10.510.10-FF-001946', NULL, 'Microtubule-associated serine/threonine kinase 1a', 135, NULL, NULL, 208481),
(208482, '3.90.1150.10-FF-000127', NULL, 'Acetylornithine aminotransferase', 131, NULL, NULL, 208482);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(208483, '1.10.287.3240-FF-000002', NULL, 'Vacuolar atp synthase subunit d', 199, NULL, NULL, 208483),
(208484, '1.10.472.10-FF-000435', NULL, 'B type cyclin', 130, NULL, NULL, 208484),
(208485, '2.30.29.30-FF-000317', NULL, 'Amyloid beta A4 protein-binding family B member', 143, NULL, NULL, 208485),
(208486, '3.30.70.260-FF-000129', NULL, 'D-3-phosphoglycerate dehydrogenase', 91, NULL, NULL, 208486),
(208487, '3.20.20.300-FF-000066', NULL, NULL, 331, NULL, NULL, 208487),
(208488, '2.60.40.10-FF-005305', NULL, NULL, 80, NULL, NULL, 208488),
(208489, '3.40.50.2300-FF-000695', NULL, 'AGAP012447-PA', 217, NULL, NULL, 208489),
(208490, '1.10.10.60-FF-000051', NULL, 'POU domain protein', 64, NULL, NULL, 208490),
(208491, '2.60.40.10-FF-004928', NULL, NULL, 97, NULL, NULL, 208491),
(208492, '3.30.230.10-FF-000193', NULL, 'Eukaryotic translation elongation factor 2a, tandem duplicate 1', 42, NULL, NULL, 208492),
(208493, '2.30.29.110-FF-000005', NULL, 'Uncharacterized protein', 94, NULL, NULL, 208493),
(208494, '1.20.900.10-FF-000052', NULL, 'Cell division control protein 24', 204, NULL, NULL, 208494),
(208495, '2.30.30.550-FF-000004', NULL, 'Major vault protein-like protein', 58, NULL, NULL, 208495),
(208496, '3.30.70.1440-FF-000012', NULL, 'Putative multidrug resistance protein', 99, NULL, NULL, 208496),
(208497, '3.40.50.10490-FF-000025', NULL, 'Glucosamine--fructose-6-phosphate aminotransferase [isomerizing]', 15, NULL, NULL, 208497),
(208498, '2.60.120.260-FF-000449', NULL, 'Uncharacterized protein', 214, NULL, NULL, 208498),
(208499, '1.10.10.60-FF-000955', NULL, NULL, 64, NULL, NULL, 208499),
(208500, '3.40.1690.20-FF-000002', NULL, 'paraplegin isoform X1', 98, NULL, NULL, 208500),
(208501, '4.10.240.10-FF-000138', NULL, 'Oleate-activated transcription factor, putative', 43, NULL, NULL, 208501),
(208502, '1.20.58.1060-FF-000002', NULL, 'plectin isoform X4', 151, NULL, NULL, 208502),
(208503, '1.20.58.190-FF-000001', NULL, 'Translin', 134, NULL, NULL, 208503),
(208504, '3.30.70.100-FF-000109', NULL, NULL, 99, NULL, NULL, 208504),
(208505, '2.170.300.10-FF-000102', NULL, 'Uncharacterized protein', 150, NULL, NULL, 208505),
(208506, '1.10.287.130-FF-000086', NULL, 'Two-component system sensor histidine kinase/response regulator', 75, NULL, NULL, 208506),
(208507, '3.30.420.10-FF-000354', NULL, NULL, 76, NULL, NULL, 208507),
(208508, '3.90.25.10-FF-000062', NULL, 'Uncharacterized protein', 101, NULL, NULL, 208508),
(208509, '1.10.510.10-FF-001042', NULL, 'Ptk2p', 231, NULL, NULL, 208509),
(208510, '2.60.40.150-FF-000323', NULL, 'C2 calcium/lipid-binding plant phosphoribosyltransferase family protein', 128, NULL, NULL, 208510),
(208511, '3.30.160.60-FF-003265', NULL, 'Zinc finger protein 1012', 37, NULL, NULL, 208511),
(208512, '3.30.420.40-FF-000790', NULL, 'Uncharacterized protein', 120, NULL, NULL, 208512),
(208513, '3.40.50.1820-FF-000298', NULL, 'Bem46-like serine peptidase', 272, NULL, NULL, 208513),
(208514, '3.40.250.10-FF-000130', NULL, 'Putative thiosulfate sulfurtransferase', 125, NULL, NULL, 208514),
(208515, '1.10.510.10-FF-003503', NULL, NULL, 255, NULL, NULL, 208515),
(208516, '1.10.12.70-FF-000002', NULL, 'Serine/threonine kinase 24', 77, NULL, NULL, 208516),
(208517, '1.10.510.10-FF-002907', NULL, NULL, 148, NULL, NULL, 208517),
(208518, '3.70.10.10-FF-000102', NULL, 'Checkpoint protein', 267, NULL, NULL, 208518),
(208519, '2.60.40.60-FF-001032', NULL, 'AGAP006732-PA', 102, NULL, NULL, 208519),
(208520, '1.10.510.10-FF-000766', NULL, 'CAMK/CDPK protein kinase', 189, NULL, NULL, 208520),
(208521, '3.90.190.10-FF-000294', NULL, 'Tyrosine-protein phosphatase 2', 289, NULL, NULL, 208521),
(208522, '3.30.1370.50-FF-000017', NULL, 'YALI0D10285p', 73, NULL, NULL, 208522),
(208523, '4.10.400.10-FF-000016', NULL, 'Low-density lipoprotein receptor-related protein 6', 43, NULL, NULL, 208523),
(208524, '3.30.70.270-FF-000227', NULL, NULL, 163, NULL, NULL, 208524),
(208525, '2.60.120.330-FF-000044', NULL, '2-oxoglutarate (2OG) and Fe(II)-dependent oxygenase superfamily protein', 331, NULL, NULL, 208525);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(208526, '2.30.310.10-FF-000012', NULL, NULL, 167, NULL, NULL, 208526),
(208527, '2.60.40.10-FF-001950', NULL, 'Muscle M-line assembly protein unc-89', 97, NULL, NULL, 208527),
(208528, '3.40.367.20-FF-000044', NULL, 'Hexokinase', 52, NULL, NULL, 208528),
(208529, '1.10.510.10-FF-002666', NULL, NULL, 108, NULL, NULL, 208529),
(208530, '3.40.1500.10-FF-000003', NULL, 'oxygen-dependent coproporphyrinogen-III oxidase, chloroplastic', 342, NULL, NULL, 208530),
(208531, '3.60.40.10-FF-000132', NULL, 'Stage II sporulation protein E', 223, NULL, NULL, 208531),
(208532, '3.30.40.10-FF-000830', NULL, 'RING-H2 finger protein ATL28', 87, NULL, NULL, 208532),
(208533, '3.40.50.10190-FF-000284', NULL, 'DNA ligase', 115, NULL, NULL, 208533),
(208534, '1.10.20.140-FF-000028', NULL, NULL, 52, NULL, NULL, 208534),
(208535, '3.10.310.10-FF-000007', NULL, 'Trans-L-3-hydroxyproline dehydratase', 168, NULL, NULL, 208535),
(208536, '2.130.10.10-FF-005076', NULL, 'Uncharacterized protein', 268, NULL, NULL, 208536),
(208537, '3.40.50.11060-FF-000005', NULL, 'Protein CBG19372', 126, NULL, NULL, 208537),
(208538, '3.40.50.300-FF-001641', NULL, 'Mitochondrial Rho GTPase', 195, NULL, NULL, 208538),
(208539, '2.20.100.10-FF-000139', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs gon-1', 59, NULL, NULL, 208539),
(208540, '3.60.15.10-FF-000170', NULL, 'Metallo-beta-lactamase family protein', 195, NULL, NULL, 208540),
(208541, '1.20.920.10-FF-000065', NULL, 'Transcription regulatory protein SNF2', 130, NULL, NULL, 208541),
(208542, '3.80.10.10-FF-003108', NULL, 'Viral A-type inclusion protein, putative', 327, NULL, NULL, 208542),
(208543, '3.40.800.10-FF-000055', NULL, NULL, 79, NULL, NULL, 208543),
(208544, '3.30.40.10-FF-000375', NULL, 'tripartite motif-containing protein 47 isoform X1', 81, NULL, NULL, 208544),
(208545, '1.10.472.80-FF-000063', NULL, 'GTPase-activating protein, putative', 152, NULL, NULL, 208545),
(208546, '2.60.40.10-FF-000977', NULL, 'Myosin binding protein H like', 100, NULL, NULL, 208546),
(208547, '1.20.80.10-FF-000034', NULL, 'Blast:E3 ubiquitin-protein ligase MYLIP-A', 116, NULL, NULL, 208547),
(208548, '3.30.70.330-FF-002623', NULL, NULL, 127, NULL, NULL, 208548),
(208549, '3.40.50.300-FF-000231', NULL, 'Activating signal cointegrator 1 complex subunit 3', 205, NULL, NULL, 208549),
(208550, '2.130.10.30-FF-000068', NULL, 'Hect domain and RLD 3', 77, NULL, NULL, 208550),
(208551, '2.60.220.50-FF-000078', NULL, 'Uncharacterized protein', 116, NULL, NULL, 208551),
(208552, '2.30.42.10-FF-000163', NULL, 'rho GTPase-activating protein 100F isoform X1', 111, NULL, NULL, 208552),
(208553, '1.10.287.500-FF-000005', NULL, 'Chemotaxis protein CheZ', 62, NULL, NULL, 208553),
(208554, '3.10.110.10-FF-000363', NULL, 'Protein IMPACT homolog', 106, NULL, NULL, 208554),
(208555, '2.160.20.10-FF-000297', NULL, 'Uncharacterized protein', 153, NULL, NULL, 208555),
(208556, '3.60.21.10-FF-000324', NULL, 'Lmo2403 protein', 279, NULL, NULL, 208556),
(208557, '1.10.10.60-FF-000394', NULL, 'MYB transcription factor', 62, NULL, NULL, 208557),
(208558, '3.40.50.2000-FF-000705', NULL, 'ADP-heptose--lipopolysaccharide heptosyltransferase, putative', 176, NULL, NULL, 208558),
(208559, '1.10.630.10-FF-000685', NULL, 'Cytochrome P450 78A7', 154, NULL, NULL, 208559),
(208560, '1.10.10.60-FF-001012', NULL, NULL, 40, NULL, NULL, 208560),
(208561, '3.20.20.80-FF-000676', NULL, 'Uncharacterized protein', 345, NULL, NULL, 208561),
(208562, '2.130.10.10-FF-000062', NULL, 'Putative WD repeat-containing protein 48', 134, NULL, NULL, 208562),
(208563, '1.10.510.10-FF-001385', NULL, 'Tyrosine-protein kinase', 88, NULL, NULL, 208563),
(208564, '1.20.1250.20-FF-001549', NULL, 'Solute carrier family 15 member 4', 562, NULL, NULL, 208564),
(208565, '1.10.510.10-FF-002003', NULL, 'SNF1 family protein kinase, putative', 183, NULL, NULL, 208565),
(208566, '3.30.160.60-FF-004693', NULL, NULL, 31, NULL, NULL, 208566),
(208567, '1.25.40.10-FF-003495', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 71, NULL, NULL, 208567);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(208568, '3.30.160.60-FF-000410', NULL, 'Zinc finger protein 777', 29, NULL, NULL, 208568),
(208569, '3.30.200.20-FF-002487', NULL, 'Citron rho-interacting serine/threonine kinase', 27, NULL, NULL, 208569),
(208570, '3.30.70.1730-FF-000009', NULL, '50S ribosomal protein L10', 128, NULL, NULL, 208570),
(208571, '2.40.50.140-FF-000815', NULL, NULL, 121, NULL, NULL, 208571),
(208572, '2.30.29.30-FF-001037', NULL, 'Uncharacterized protein', 134, NULL, NULL, 208572),
(208573, '3.80.10.10-FF-002625', NULL, 'leucine-rich repeat neuronal protein 1-like', 175, NULL, NULL, 208573),
(208574, '1.10.3730.20-FF-000021', NULL, 'Probable 4-amino-4-deoxy-L-arabinose-phosphoundecaprenol flippase subunit ArnF', 125, NULL, NULL, 208574),
(208575, '3.40.630.10-FF-000468', NULL, 'Predicted protein', 75, NULL, NULL, 208575),
(208576, '3.80.10.10-FF-000692', NULL, 'Leucine rich repeat containing 15', 121, NULL, NULL, 208576),
(208577, '1.10.520.10-FF-000031', NULL, 'Os01g0327000 protein', 59, NULL, NULL, 208577),
(208578, '3.20.20.80-FF-000013', NULL, 'lactase-phlorizin hydrolase', 475, NULL, NULL, 208578),
(208579, '1.25.40.20-FF-000979', NULL, 'SH3 and multiple ankyrin repeat domains 2a', 156, NULL, NULL, 208579),
(208580, '1.25.10.10-FF-001329', NULL, 'Kinesin associated protein', 499, NULL, NULL, 208580),
(208581, '3.40.50.720-FF-002256', NULL, 'Predicted protein', 61, NULL, NULL, 208581),
(208582, '1.25.10.10-FF-003324', NULL, 'PIKK family atypical protein kinase', 138, NULL, NULL, 208582),
(208583, '2.130.10.10-FF-001686', NULL, 'Inositol polyphosphate phosphatase, putative', 167, NULL, NULL, 208583),
(208584, '2.40.128.20-FF-000027', NULL, 'Predicted protein', 162, NULL, NULL, 208584),
(208585, '3.30.70.1710-FF-000003', NULL, 'Ethanolamine utilization protein EutL', 101, NULL, NULL, 208585),
(208586, '4.10.240.10-FF-000014', NULL, 'HAP1p Zinc finger transcription factor', 43, NULL, NULL, 208586),
(208587, '1.25.40.20-FF-001598', NULL, 'Uncharacterized protein', 113, NULL, NULL, 208587),
(208588, '3.90.550.10-FF-000288', NULL, 'Lipopolysaccharide 1,2-glucosyltransferase', 270, NULL, NULL, 208588),
(208589, '1.10.439.10-FF-000004', NULL, 'Penicillin acylase II', 159, NULL, NULL, 208589),
(208590, '3.40.630.30-FF-000671', NULL, 'Glr3626 protein', 147, NULL, NULL, 208590),
(208591, '3.40.390.10-FF-000292', NULL, NULL, 81, NULL, NULL, 208591),
(208592, '3.10.20.90-FF-000640', NULL, 'Autophagy-related protein', 119, NULL, NULL, 208592),
(208593, '1.20.58.60-FF-000649', NULL, 'Uncharacterized protein', 192, NULL, NULL, 208593),
(208594, '3.40.430.10-FF-000032', NULL, 'Riboflavin biosynthesis protein RibD', 198, NULL, NULL, 208594),
(208595, '2.60.40.10-FF-005648', NULL, NULL, 91, NULL, NULL, 208595),
(208596, '1.10.2000.10-FF-000041', NULL, NULL, 128, NULL, NULL, 208596),
(208597, '2.60.120.10-FF-000502', NULL, 'cGMP-dependent 3'',5''-cGMP phosphodiesterase A', 130, NULL, NULL, 208597),
(208598, '1.10.10.10-FF-001357', NULL, 'Pleckstrin 2', 109, NULL, NULL, 208598),
(208599, '3.40.50.2000-FF-000144', NULL, 'UDP-glucuronosyltransferase', 217, NULL, NULL, 208599),
(208600, '3.30.710.10-FF-000331', NULL, 'Uncharacterized protein', 184, NULL, NULL, 208600),
(208601, '1.25.40.180-FF-000298', NULL, NULL, 98, NULL, NULL, 208601),
(208602, '3.40.50.720-FF-001430', NULL, 'PKS-NRPS hybrid synthetase psoA', 210, NULL, NULL, 208602),
(208603, '2.130.10.10-FF-003940', NULL, 'Uncharacterized protein', 250, NULL, NULL, 208603),
(208604, '3.30.160.60-FF-003844', NULL, NULL, 32, NULL, NULL, 208604),
(208605, '3.30.160.60-FF-005530', NULL, NULL, 31, NULL, NULL, 208605),
(208606, '2.60.40.2860-FF-000015', NULL, 'Transmission-blocking target antigen s230', 148, NULL, NULL, 208606),
(208607, '3.30.470.20-FF-000056', NULL, 'Inositol-tetrakisphosphate 1-kinase', 209, NULL, NULL, 208607),
(208608, '3.30.70.330-FF-000369', NULL, 'heterogeneous nuclear ribonucleoprotein D0 isoform X1', 125, NULL, NULL, 208608),
(208609, '1.10.10.10-FF-000957', NULL, 'Transcriptional regulator, LysR family', 86, NULL, NULL, 208609),
(208610, '3.40.50.1000-FF-000153', NULL, 'Phospholipid-transporting ATPase', 181, NULL, NULL, 208610);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(208611, '1.20.120.20-FF-000001', NULL, 'Apolipoprotein A-I', 139, NULL, NULL, 208611),
(208612, '3.90.79.20-FF-000021', NULL, 'NADH pyrophosphatase, MutT family hydrolase', 133, NULL, NULL, 208612),
(208613, '3.50.50.60-FF-001008', NULL, 'Flavin-containing monooxygenase', 108, NULL, NULL, 208613),
(208614, '3.10.20.310-FF-000009', NULL, 'Outer membrane protein, OMP85 family', 77, NULL, NULL, 208614),
(208615, '3.90.1300.10-FF-000044', NULL, 'Uncharacterized protein', 231, NULL, NULL, 208615),
(208616, '2.60.40.10-FF-004024', NULL, NULL, 98, NULL, NULL, 208616),
(208617, '2.40.128.270-FF-000001', NULL, 'Heat shock protein HslJ', 102, NULL, NULL, 208617),
(208618, '3.40.50.300-FF-003322', NULL, 'Hypothetical_protein_-_conserved', 188, NULL, NULL, 208618),
(208619, '2.130.10.10-FF-001023', NULL, 'Actin-related protein 2/3 complex subunit', 353, NULL, NULL, 208619),
(208620, '3.40.50.300-FF-007717', NULL, 'Uncharacterized protein', 96, NULL, NULL, 208620),
(208621, '1.20.1270.60-FF-000343', NULL, 'Uncharacterized protein', 309, NULL, NULL, 208621),
(208622, '3.30.200.20-FF-001661', NULL, 'Os12g0500400 protein', 85, NULL, NULL, 208622),
(208623, '1.10.486.10-FF-000034', NULL, 'DNA helicase II/ATP-dependent DNA helicase PcrA', 162, NULL, NULL, 208623),
(208624, '3.30.70.360-FF-000047', NULL, 'Peptidase M20 domain-containing protein 2', 117, NULL, NULL, 208624),
(208625, '2.60.40.2170-FF-000016', NULL, 'Uncharacterized protein', 83, NULL, NULL, 208625),
(208626, '3.60.20.10-FF-000024', NULL, 'Asparagine synthetase [glutamine-hydrolyzing]', 191, NULL, NULL, 208626),
(208627, '3.40.50.2300-FF-001532', NULL, NULL, 72, NULL, NULL, 208627),
(208628, '3.30.160.60-FF-001820', NULL, 'Zinc finger protein 473', 36, NULL, NULL, 208628),
(208629, '3.30.50.10-FF-000117', NULL, 'Uncharacterized protein', 91, NULL, NULL, 208629),
(208630, '3.40.1190.20-FF-000088', NULL, '2-dehydro-3-deoxygluconokinase', 311, NULL, NULL, 208630),
(208631, '2.60.40.420-FF-000191', NULL, 'Uncharacterized protein', 154, NULL, NULL, 208631),
(208632, '3.75.10.10-FF-000035', NULL, NULL, 169, NULL, NULL, 208632),
(208633, '3.30.160.60-FF-002220', NULL, 'Zinc finger protein 382', 90, NULL, NULL, 208633),
(208634, '2.130.10.10-FF-004457', NULL, 'Uncharacterized protein', 419, NULL, NULL, 208634),
(208635, '3.90.1310.10-FF-000005', NULL, 'Stage V sporulation protein D', 172, NULL, NULL, 208635),
(208636, '3.60.20.10-FF-000148', NULL, 'Putative glutamine--fructose-6-phosphate aminotransferase [isomerizing]', 239, NULL, NULL, 208636),
(208637, '3.40.33.10-FF-000061', NULL, 'Uncharacterized protein', 153, NULL, NULL, 208637),
(208638, '1.20.5.110-FF-000247', NULL, 'Syntaxin-18', 100, NULL, NULL, 208638),
(208639, '3.80.10.10-FF-001310', NULL, 'leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3 isoform X1', 103, NULL, NULL, 208639),
(208640, '2.60.40.1400-FF-000033', NULL, NULL, 114, NULL, NULL, 208640),
(208641, '3.50.50.60-FF-000608', NULL, 'Flavin-containing monooxygenase', 139, NULL, NULL, 208641),
(208642, '1.25.10.10-FF-001205', NULL, 'Uncharacterized protein', 357, NULL, NULL, 208642),
(208643, '3.40.950.10-FF-000043', NULL, NULL, 37, NULL, NULL, 208643),
(208644, '3.10.390.10-FF-000012', NULL, 'Nuclear autoantigen Sp-100', 43, NULL, NULL, 208644),
(208645, '3.30.70.680-FF-000002', NULL, NULL, 172, NULL, NULL, 208645),
(208646, '2.60.40.10-FF-003748', NULL, NULL, 112, NULL, NULL, 208646),
(208647, '1.50.40.10-FF-000446', NULL, 'Uncharacterized protein', 143, NULL, NULL, 208647),
(208648, '3.90.550.50-FF-000030', NULL, 'Fringe-related protein', 242, NULL, NULL, 208648),
(208649, '1.10.10.10-FF-001233', NULL, 'Two-component system response regulator', 100, NULL, NULL, 208649),
(208650, '1.10.533.10-FF-000105', NULL, 'Fas-associated death domain protein', 95, NULL, NULL, 208650),
(208651, '2.170.150.80-FF-000032', NULL, 'Uncharacterized protein', 57, NULL, NULL, 208651),
(208652, '3.40.50.300-FF-005800', NULL, 'Replicative DNA helicase', 52, NULL, NULL, 208652),
(208653, '3.10.20.310-FF-000004', NULL, 'Outer membrane protein assembly factor BamA', 82, NULL, NULL, 208653);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(208654, '1.10.10.10-FF-000738', NULL, 'Transcriptional regulator, ArsR family', 92, NULL, NULL, 208654),
(208655, '3.30.710.10-FF-000230', NULL, 'SKP1-like protein 7', 152, NULL, NULL, 208655),
(208656, '3.90.550.10-FF-000737', NULL, 'Predicted protein', 248, NULL, NULL, 208656),
(208657, '2.130.10.10-FF-001130', NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', 342, NULL, NULL, 208657),
(208658, '3.30.70.890-FF-000071', NULL, 'Mevalonate kinase', 116, NULL, NULL, 208658),
(208659, '1.10.8.10-FF-000209', NULL, 'UBA/TS-N domain containing protein', 80, NULL, NULL, 208659),
(208660, '1.25.40.10-FF-000297', NULL, 'tonsoku-like protein isoform X2', 283, NULL, NULL, 208660),
(208661, '3.90.320.10-FF-000006', NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', 219, NULL, NULL, 208661),
(208662, '3.40.50.300-FF-002029', NULL, 'Replicative DNA helicase', 278, NULL, NULL, 208662),
(208663, '2.30.29.30-FF-000880', NULL, 'uncharacterized protein LOC100181754', 116, NULL, NULL, 208663),
(208664, '3.40.50.300-FF-002041', NULL, 'ATP-dependent RNA helicase', 216, NULL, NULL, 208664),
(208665, '3.40.50.300-FF-006312', NULL, 'CTP synthase', 136, NULL, NULL, 208665),
(208666, '3.30.160.60-FF-002208', NULL, 'Zinc finger protein 787', 27, NULL, NULL, 208666),
(208667, '2.130.10.10-FF-005401', NULL, 'Uncharacterized protein', 145, NULL, NULL, 208667),
(208668, '3.10.400.10-FF-000008', NULL, 'Probable bifunctional SAT/APS kinase', 162, NULL, NULL, 208668),
(208669, '2.60.40.10-FF-002675', NULL, 'Leukemia inhibitory factor receptor alpha a', 97, NULL, NULL, 208669),
(208670, '3.40.50.720-FF-000463', NULL, 'Probable NADPH quinone oxidoreductase fadB4', 145, NULL, NULL, 208670),
(208671, '1.20.120.1080-FF-000139', NULL, 'Uncharacterized protein', 125, NULL, NULL, 208671),
(208672, '3.90.1110.10-FF-000001', NULL, 'DNA-directed RNA polymerase subunit beta', 176, NULL, NULL, 208672),
(208673, '3.30.499.10-FF-000046', NULL, NULL, 182, NULL, NULL, 208673),
(208674, '3.40.50.80-FF-000014', NULL, 'Na(+)-translocating NADH-quinone reductase subunit F', 119, NULL, NULL, 208674),
(208675, '3.40.1110.10-FF-000209', NULL, NULL, 14, NULL, NULL, 208675),
(208676, '2.130.10.10-FF-004777', NULL, 'Uncharacterized protein', 153, NULL, NULL, 208676),
(208677, '3.30.1550.10-FF-000014', NULL, 'Probable MRPL19-mitochondrial ribosomal protein, large subunit', 66, NULL, NULL, 208677),
(208678, '3.30.590.50-FF-000001', NULL, 'Glutamate-cysteine ligase Gcs1', 86, NULL, NULL, 208678),
(208679, '3.80.10.10-FF-000585', NULL, 'Leucine-rich repeat-containing protein', 203, NULL, NULL, 208679),
(208680, '3.40.50.300-FF-005688', NULL, 'Adenylate/guanylate cyclase domain-containing protein', 182, NULL, NULL, 208680),
(208681, '3.40.50.10390-FF-000001', NULL, 'Lys-gingipain 381', 116, NULL, NULL, 208681),
(208682, '2.60.40.60-FF-000975', NULL, 'Uncharacterized protein', 113, NULL, NULL, 208682),
(208683, '3.30.830.10-FF-000284', NULL, 'Clan ME, family M16, insulinase-like metallopeptidase', 178, NULL, NULL, 208683),
(208684, '3.40.50.620-FF-000321', NULL, 'Os05g0113300 protein', 168, NULL, NULL, 208684),
(208685, '1.20.1560.10-FF-000457', NULL, 'HlyB/MsbA family ABC transporter', 316, NULL, NULL, 208685),
(208686, '2.40.50.140-FF-000838', NULL, NULL, 77, NULL, NULL, 208686),
(208687, '2.130.10.10-FF-005289', NULL, 'At4g01860', 224, NULL, NULL, 208687),
(208688, '3.30.420.10-FF-000359', NULL, 'Transposon Ty3-I Gag-Pol polyprotein', 204, NULL, NULL, 208688),
(208689, '3.40.50.2000-FF-000936', NULL, 'At4g15260', 144, NULL, NULL, 208689),
(208690, '3.30.40.10-FF-000847', NULL, 'Unplaced genomic scaffold supercont1.9, whole genome shotgun sequence', 90, NULL, NULL, 208690),
(208691, '1.10.510.10-FF-002110', NULL, 'Kinase, CMGC CMGC-GL1', 218, NULL, NULL, 208691),
(208692, '1.10.510.10-FF-001486', NULL, 'AGC protein kinase', 158, NULL, NULL, 208692),
(208693, '3.40.30.70-FF-000004', NULL, 'tRNA synthetases class I, catalytic domain-domain-containing protein', 78, NULL, NULL, 208693),
(208694, '3.30.450.20-FF-000297', NULL, 'Diguanylate cyclase (GGDEF) domain protein', 111, NULL, NULL, 208694);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(208695, '2.60.40.10-FF-005429', NULL, NULL, 111, NULL, NULL, 208695),
(208696, '3.40.50.720-FF-001082', NULL, 'Cis-1,2-dihydroxycyclohexa-3,4-diene carboxylate dehydrogenase', 252, NULL, NULL, 208696),
(208697, '3.40.50.2300-FF-000919', NULL, NULL, 204, NULL, NULL, 208697),
(208698, '3.10.105.10-FF-000053', NULL, 'Oligopeptide ABC transporter, oligopeptide-binding protein', 238, NULL, NULL, 208698),
(208699, '3.30.40.10-FF-000954', NULL, 'Histone demethylase JHD2', 94, NULL, NULL, 208699),
(208700, '1.10.3090.10-FF-000002', NULL, 'CCA tRNA nucleotidyltransferase', 254, NULL, NULL, 208700),
(208701, '2.10.25.10-FF-001776', NULL, 'Hemicentin 1', 34, NULL, NULL, 208701),
(208702, '3.40.50.150-FF-001118', NULL, NULL, 212, NULL, NULL, 208702),
(208703, '3.40.50.720-FF-000570', NULL, 'Oxidoreductase HTATIP2', 94, NULL, NULL, 208703),
(208704, '3.30.160.60-FF-003743', NULL, 'Zinc finger protein 668', 31, NULL, NULL, 208704),
(208705, '1.25.40.1040-FF-000019', NULL, 'NMDA receptor-regulated protein, putative', 498, NULL, NULL, 208705),
(208706, '1.20.900.10-FF-000075', NULL, 'Rho guanine nucleotide exchange factor 38', 114, NULL, NULL, 208706),
(208707, '1.10.287.4070-FF-000026', NULL, 'Predicted protein', 51, NULL, NULL, 208707),
(208708, '3.65.10.20-FF-000005', NULL, 'RNA re-capping enzyme, cytoplasmic', 230, NULL, NULL, 208708),
(208709, '2.30.29.30-FF-000773', NULL, 'Uncharacterized protein', 85, NULL, NULL, 208709),
(208710, '1.25.40.10-FF-000302', NULL, 'Rolling pebbles, isoform B', 132, NULL, NULL, 208710),
(208711, '1.25.10.10-FF-003454', NULL, 'Uncharacterized protein', 383, NULL, NULL, 208711),
(208712, '3.30.200.20-FF-000256', NULL, 'cyclin-dependent kinase 10 isoform X2', 97, NULL, NULL, 208712),
(208713, '1.20.5.110-FF-000242', NULL, 'Synaptosomal-associated protein 47', 52, NULL, NULL, 208713),
(208714, '2.130.10.10-FF-000511', NULL, 'WD repeat domain 37', 148, NULL, NULL, 208714),
(208715, '1.10.238.10-FF-000953', NULL, 'HLH domain-containing protein', 61, NULL, NULL, 208715),
(208716, '3.30.200.20-FF-001094', NULL, 'cAMP-dependent protein kinase, putative', 142, NULL, NULL, 208716),
(208717, '3.40.50.300-FF-005795', NULL, 'Tudor domain containing 9', 64, NULL, NULL, 208717),
(208718, '4.10.280.10-FF-000034', NULL, 'MAX network transcriptional repressor', 79, NULL, NULL, 208718),
(208719, '1.10.150.20-FF-000090', NULL, 'U5 small nuclear ribonucleoprotein helicase', 62, NULL, NULL, 208719),
(208720, '3.10.310.30-FF-000002', NULL, 'Cyclic-di-AMP phosphodiesterase', 112, NULL, NULL, 208720),
(208721, '2.60.120.230-FF-000002', NULL, 'Peptidyl-glycine alpha-amidating monooxygenase B', 151, NULL, NULL, 208721),
(208722, '1.10.287.3240-FF-000019', NULL, 'Probable vacuolar ATP synthase subunit D', 206, NULL, NULL, 208722),
(208723, '3.40.1350.100-FF-000010', NULL, NULL, 97, NULL, NULL, 208723),
(208724, '3.40.91.20-FF-000001', NULL, 'BstYI', 203, NULL, NULL, 208724),
(208725, '1.10.1410.10-FF-000061', NULL, 'U3 small nucleolar RNA-associated protein 22', 170, NULL, NULL, 208725),
(208726, '2.60.120.200-FF-000477', NULL, 'MAM and LDL-receptor class A domain-containing protein 1', 122, NULL, NULL, 208726),
(208727, '1.10.455.10-FF-000002', NULL, '40S ribosomal protein S5', 203, NULL, NULL, 208727),
(208728, '2.60.40.10-FF-003294', NULL, NULL, 93, NULL, NULL, 208728),
(208729, '4.10.60.10-FF-000049', NULL, 'Zinc finger protein GIS2', 24, NULL, NULL, 208729),
(208730, '1.25.40.10-FF-003152', NULL, 'Pentatricopeptide repeat-containing protein At1g03540', 121, NULL, NULL, 208730),
(208731, '3.90.550.10-FF-000052', NULL, 'Colanic acid biosynthesis glycosyltransferase WcaA', 259, NULL, NULL, 208731),
(208732, '3.40.50.300-FF-002945', NULL, 'ATP-dependent RNA helicase MRH4, mitochondrial', 294, NULL, NULL, 208732),
(208733, '3.40.50.720-FF-001986', NULL, '3-oxoacyl-(Acyl-carrier-protein) reductase', 245, NULL, NULL, 208733),
(208734, '3.30.1680.30-FF-000001', NULL, 'Variant surface glycoprotein (VSG, atypical), putative', 41, NULL, NULL, 208734),
(208735, '3.30.160.60-FF-000073', NULL, 'IKAROS family zinc finger 1', 30, NULL, NULL, 208735);
INSERT INTO "PUBLIC"."MODEL" VALUES
(208736, '1.10.10.1540-FF-000002', NULL, 'costars family protein ABRACL', 81, NULL, NULL, 208736),
(208737, '1.20.58.80-FF-000071', NULL, 'Serine/threonine-protein kinase ULK3', 71, NULL, NULL, 208737),
(208738, '1.10.555.10-FF-000061', NULL, 'Rho GTPase activating protein 9', 139, NULL, NULL, 208738),
(208739, '3.20.20.70-FF-000572', NULL, 'Uncharacterized protein', 442, NULL, NULL, 208739),
(208740, '2.130.10.10-FF-001815', NULL, 'WD repeat protein', 101, NULL, NULL, 208740),
(208741, '1.25.40.10-FF-005187', NULL, 'Uncharacterized protein', 237, NULL, NULL, 208741),
(208742, '3.30.930.10-FF-000117', NULL, 'Aspartate--tRNA ligase, putative', 312, NULL, NULL, 208742),
(208743, '1.10.472.10-FF-000648', NULL, 'AGAP008191-PA', 110, NULL, NULL, 208743),
(208744, '2.130.10.10-FF-005396', NULL, 'DmX-like protein 2', 148, NULL, NULL, 208744),
(208745, '3.40.50.150-FF-001551', NULL, NULL, 82, NULL, NULL, 208745),
(208746, '1.10.1660.30-FF-000001', NULL, 'Plasmid partition protein A', 70, NULL, NULL, 208746),
(208747, '1.20.58.60-FF-000424', NULL, 'Quattro', 300, NULL, NULL, 208747),
(208748, '1.10.1370.10-FF-000017', NULL, 'Oligopeptidase A', 213, NULL, NULL, 208748),
(208749, '1.20.120.1630-FF-000001', NULL, 'delta(14)-sterol reductase isoform X1', 201, NULL, NULL, 208749),
(208750, '1.10.8.10-FF-000310', NULL, 'Ubiquitinyl hydrolase 1', 63, NULL, NULL, 208750),
(208751, '3.30.160.60-FF-006486', NULL, NULL, 75, NULL, NULL, 208751),
(208752, '1.25.10.10-FF-000469', NULL, 'Crm1p', 677, NULL, NULL, 208752),
(208753, '1.25.40.470-FF-000065', NULL, 'WD repeat protein, putative', 143, NULL, NULL, 208753),
(208754, '2.60.40.10-FF-004125', NULL, NULL, 92, NULL, NULL, 208754),
(208755, '2.60.40.10-FF-006042', NULL, NULL, 73, NULL, NULL, 208755),
(208756, '2.40.420.20-FF-000061', NULL, 'Thiophosphate efflux pump MFP component', 73, NULL, NULL, 208756),
(208757, '2.30.30.40-FF-000043', NULL, 'Chemotaxis protein CheW', 59, NULL, NULL, 208757),
(208758, '1.20.1250.20-FF-000925', NULL, 'Similar to MFS sugar transporter', 471, NULL, NULL, 208758),
(208759, '1.20.58.830-FF-000007', NULL, 'VAR2CSA', 120, NULL, NULL, 208759),
(208760, '2.60.40.10-FF-001371', NULL, 'Protein O-linked mannose N-acetylglucosaminyltransferase 2 (beta 1,4-)', 88, NULL, NULL, 208760),
(208761, '1.20.1270.60-FF-000236', NULL, 'Rho GTPase-activating protein gacP', 234, NULL, NULL, 208761),
(208762, '3.30.70.3250-FF-000004', NULL, 'Ribonuclease P/MRP protein subunit POP5', 132, NULL, NULL, 208762),
(208763, '3.40.50.300-FF-003890', NULL, 'ABC transporter ATP-binding protein', 257, NULL, NULL, 208763),
(208764, '1.10.10.60-FF-000500', NULL, 'Telomeric repeat-binding factor a', 62, NULL, NULL, 208764),
(208765, '3.30.420.270-FF-000004', NULL, 'Putative biopolymer transport protein exbD-like 2', 65, NULL, NULL, 208765),
(208766, '2.130.10.10-FF-002546', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One component system)', 321, NULL, NULL, 208766),
(208767, '3.80.10.10-FF-003007', NULL, 'Uncharacterized protein', 239, NULL, NULL, 208767),
(208768, '3.80.10.10-FF-004171', NULL, 'Uncharacterized protein', 99, NULL, NULL, 208768),
(208769, '6.20.10.30-FF-000007', NULL, 'DNA ligase', 39, NULL, NULL, 208769),
(208770, '1.10.510.10-FF-003526', NULL, NULL, 243, NULL, NULL, 208770),
(208771, '1.10.510.10-FF-004015', NULL, NULL, 127, NULL, NULL, 208771),
(208772, '2.60.40.420-FF-000090', NULL, 'NtEPc-like', 105, NULL, NULL, 208772),
(208773, '2.10.25.10-FF-001669', NULL, 'Uncharacterized protein', 68, NULL, NULL, 208773),
(208774, '1.25.40.10-FF-001825', NULL, 'pentatricopeptide repeat-containing protein At4g02750', 85, NULL, NULL, 208774),
(208775, '1.25.40.10-FF-001713', NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', 104, NULL, NULL, 208775),
(208776, '1.25.40.20-FF-001250', NULL, 'Os09g0341200 protein', 234, NULL, NULL, 208776),
(208777, '3.90.226.10-FF-000248', NULL, 'Uncharacterized protein', 256, NULL, NULL, 208777),
(208778, '2.80.10.50-FF-000172', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 82, NULL, NULL, 208778);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(208779, '1.25.10.10-FF-001082', NULL, 'ARM repeat superfamily protein', 120, NULL, NULL, 208779),
(208780, '1.10.1450.10-FF-000069', NULL, 'Tetraspanin', 118, NULL, NULL, 208780),
(208781, '1.25.40.20-FF-000631', NULL, 'Wide awake, isoform B', 118, NULL, NULL, 208781),
(208782, '3.40.50.1820-FF-000646', NULL, 'Carboxylic ester hydrolase', 465, NULL, NULL, 208782),
(208783, '1.20.1070.10-FF-000594', NULL, 'Predicted protein', 351, NULL, NULL, 208783),
(208784, '3.40.1630.10-FF-000001', NULL, 'Ribosomal RNA small subunit methyltransferase J', 56, NULL, NULL, 208784),
(208785, '1.20.5.1700-FF-000014', NULL, 'huntingtin-interacting protein 1 isoform X1', 112, NULL, NULL, 208785),
(208786, '1.10.30.10-FF-000060', NULL, 'Transcription factor protein', 85, NULL, NULL, 208786),
(208787, '2.10.110.10-FF-000125', NULL, 'Four and a half LIM domains 2', 64, NULL, NULL, 208787),
(208788, '3.40.50.410-FF-000269', NULL, 'Uncharacterized protein', 128, NULL, NULL, 208788),
(208789, '3.40.50.620-FF-000214', NULL, 'Choline-phosphate cytidylyltransferase', 282, NULL, NULL, 208789),
(208790, '3.40.50.2000-FF-000251', NULL, 'Glycosyl transferase', 170, NULL, NULL, 208790),
(208791, '2.130.10.10-FF-003491', NULL, 'Uncharacterized protein', 277, NULL, NULL, 208791),
(208792, '3.30.40.10-FF-002067', NULL, 'Uncharacterized protein', 89, NULL, NULL, 208792),
(208793, '1.10.10.10-FF-000053', NULL, 'Serine/threonine-protein kinase RIO2', 92, NULL, NULL, 208793),
(208794, '3.20.180.20-FF-000025', NULL, 'Si:dkey-11m19.5', 113, NULL, NULL, 208794),
(208795, '3.30.1680.10-FF-000001', NULL, 'Semaphorin 3F like', 67, NULL, NULL, 208795),
(208796, '3.30.2460.20-FF-000010', NULL, 'Protein Wnt', 57, NULL, NULL, 208796),
(208797, '1.10.10.1940-FF-000015', NULL, NULL, 45, NULL, NULL, 208797),
(208798, '2.60.40.10-FF-000758', NULL, 'tyrosine-protein kinase receptor Tie-1 isoform X2', 104, NULL, NULL, 208798),
(208799, '2.30.30.40-FF-000498', NULL, 'JNK-interacting protein 1', 60, NULL, NULL, 208799),
(208800, '2.30.39.10-FF-000150', NULL, 'Uncharacterized protein', 125, NULL, NULL, 208800),
(208801, '3.90.520.10-FF-000005', NULL, 'Mothers against decapentaplegic homolog', 127, NULL, NULL, 208801),
(208802, '2.60.120.10-FF-000822', NULL, 'Homogentisate 12-dioxygenase', 74, NULL, NULL, 208802),
(208803, '2.30.42.10-FF-000062', NULL, 'harmonin isoform X1', 111, NULL, NULL, 208803),
(208804, '3.40.640.10-FF-000076', NULL, 'N-succinyldiaminopimelate aminotransferase DapC', 242, NULL, NULL, 208804),
(208805, '3.30.160.60-FF-000303', NULL, 'Zinc finger protein 41', 28, NULL, NULL, 208805),
(208806, '3.30.160.60-FF-005974', NULL, NULL, 64, NULL, NULL, 208806),
(208807, '1.10.8.10-FF-000198', NULL, 'Myosin XXI', 37, NULL, NULL, 208807),
(208808, '1.20.1510.10-FF-000061', NULL, NULL, 88, NULL, NULL, 208808),
(208809, '3.80.30.20-FF-000010', NULL, 'tRNA (N(6)-L-threonylcarbamoyladenosine(37)-C(2))-methylthiotransferase MtaB', 231, NULL, NULL, 208809),
(208810, '2.170.120.40-FF-000007', NULL, 'YbbR-like domain-containing protein', 84, NULL, NULL, 208810),
(208811, '3.40.50.720-FF-001874', NULL, 'NADPH:adrenodoxin oxidoreductase, putative', 77, NULL, NULL, 208811),
(208812, '1.25.10.10-FF-002942', NULL, 'Predicted protein', 79, NULL, NULL, 208812),
(208813, '3.30.70.330-FF-001342', NULL, 'Poly(A)-specific ribonuclease', 57, NULL, NULL, 208813),
(208814, '1.10.287.70-FF-000112', NULL, 'Sodium channel protein', 149, NULL, NULL, 208814),
(208815, '2.60.210.10-FF-000037', NULL, NULL, 135, NULL, NULL, 208815),
(208816, '2.40.10.10-FF-000420', NULL, 'Uncharacterized protein', 244, NULL, NULL, 208816),
(208817, '1.10.730.10-FF-000069', NULL, 'Isoleucyl-tRNA synthetase, putative', 191, NULL, NULL, 208817),
(208818, '1.10.357.20-FF-000013', NULL, 'Protein CBG20346', 191, NULL, NULL, 208818),
(208819, '1.10.1040.50-FF-000010', NULL, 'Enoyl-CoA, hydratase/3-hydroxyacyl CoA dehydrogenase', 235, NULL, NULL, 208819),
(208820, '2.60.120.200-FF-000589', NULL, 'Uncharacterized protein', 162, NULL, NULL, 208820),
(208821, '3.60.15.10-FF-000271', NULL, 'Uncharacterized protein', 238, NULL, NULL, 208821);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(208822, '1.10.287.380-FF-000025', NULL, 'Uncharacterized protein', 72, NULL, NULL, 208822),
(208823, '3.40.30.10-FF-000144', NULL, 'Thioredoxin domain', 106, NULL, NULL, 208823),
(208824, '2.40.30.10-FF-000303', NULL, 'Eukaryotic translation initiation factor 2 subunit gamma B', 76, NULL, NULL, 208824),
(208825, '2.170.120.20-FF-000001', NULL, '50S ribosomal protein L25', 89, NULL, NULL, 208825),
(208826, '1.25.10.10-FF-000688', NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit', 162, NULL, NULL, 208826),
(208827, '2.60.260.20-FF-000189', NULL, 'Uncharacterized protein', 23, NULL, NULL, 208827),
(208828, '2.60.40.10-FF-002782', NULL, '(Glucose-repressible genes) transcriptional activator, putative', 90, NULL, NULL, 208828),
(208829, '3.50.50.60-FF-001115', NULL, 'Uncharacterized protein', 152, NULL, NULL, 208829),
(208830, '2.130.10.10-FF-001927', NULL, 'Bcrad28', 378, NULL, NULL, 208830),
(208831, '1.25.10.10-FF-001088', NULL, 'Importin subunit alpha-5', 86, NULL, NULL, 208831),
(208832, '1.10.1670.10-FF-000057', NULL, NULL, 66, NULL, NULL, 208832),
(208833, '2.10.25.10-FF-000253', NULL, 'Neurogenic locus notch protein 1', 39, NULL, NULL, 208833),
(208834, '1.10.10.60-FF-000495', NULL, 'Transcription factor MYB14', 75, NULL, NULL, 208834),
(208835, '3.20.20.20-FF-000029', NULL, 'Dihydropteroate synthase DHPS', 204, NULL, NULL, 208835),
(208836, '3.30.800.10-FF-000001', NULL, 'phosphatidylinositol 4-phosphate 5-kinase type-1 gamma', 168, NULL, NULL, 208836),
(208837, '3.40.50.1110-FF-000079', NULL, 'Uncharacterized protein', 212, NULL, NULL, 208837),
(208838, '3.30.160.60-FF-000758', NULL, 'C2H2 transcription factor, putative', 41, NULL, NULL, 208838),
(208839, '3.60.20.10-FF-000255', NULL, NULL, 307, NULL, NULL, 208839),
(208840, '3.40.50.300-FF-002260', NULL, 'Dynein beta chain, putative', 120, NULL, NULL, 208840),
(208841, '3.30.2130.30-FF-000045', NULL, 'Predicted protein', 272, NULL, NULL, 208841),
(208842, '1.50.40.10-FF-000340', NULL, 'Uncharacterized protein', 134, NULL, NULL, 208842),
(208843, '2.10.25.10-FF-001664', NULL, 'Uncharacterized protein', 69, NULL, NULL, 208843),
(208844, '1.10.20.10-FF-000115', NULL, 'Histone H4', 60, NULL, NULL, 208844),
(208845, '1.10.1170.10-FF-000036', NULL, 'Predicted protein', 93, NULL, NULL, 208845),
(208846, '2.40.50.40-FF-000072', NULL, 'Chemokine (C-C motif) ligand 34b, duplicate 3', 74, NULL, NULL, 208846),
(208847, '3.50.30.30-FF-000161', NULL, 'Uncharacterized protein', 162, NULL, NULL, 208847),
(208848, '1.25.40.20-FF-000182', NULL, 'Ankyrin repeat and MYND domain containing 2a', 141, NULL, NULL, 208848),
(208849, '3.30.70.330-FF-001561', NULL, NULL, 39, NULL, NULL, 208849),
(208850, '1.10.630.10-FF-000247', NULL, 'Uncharacterized protein', 245, NULL, NULL, 208850),
(208851, '2.60.40.10-FF-000421', NULL, 'LOW QUALITY PROTEIN: obscurin', 92, NULL, NULL, 208851),
(208852, '3.40.50.2300-FF-001072', NULL, NULL, 109, NULL, NULL, 208852),
(208853, '2.60.40.820-FF-000007', NULL, 'T-box transcription factor', 192, NULL, NULL, 208853),
(208854, '1.25.40.10-FF-003175', NULL, 'Os03g0775400 protein', 108, NULL, NULL, 208854),
(208855, '3.80.10.10-FF-001990', NULL, 'Nephrocan', 67, NULL, NULL, 208855),
(208856, '1.10.287.70-FF-000331', NULL, '2P domain K+ channel TWIK-2', 138, NULL, NULL, 208856),
(208857, '3.40.50.1820-FF-000539', NULL, 'Carboxypeptidase', 253, NULL, NULL, 208857),
(208858, '2.60.40.1170-FF-000048', NULL, 'AP-3 complex subunit mu', 106, NULL, NULL, 208858),
(208859, '3.80.10.10-FF-000697', NULL, 'Leucine-rich repeat-containing 8 VRAC subunit Aa', 96, NULL, NULL, 208859),
(208860, '1.10.3430.10-FF-000079', NULL, 'Predicted protein', 69, NULL, NULL, 208860),
(208861, '1.20.1050.10-FF-000255', NULL, 'Predicted protein', 142, NULL, NULL, 208861),
(208862, '1.10.238.100-FF-000005', NULL, 'BZIP transcription factor (Fcr3), putative', 74, NULL, NULL, 208862),
(208863, '2.60.40.60-FF-000863', NULL, 'Uncharacterized protein', 106, NULL, NULL, 208863),
(208864, '1.25.40.10-FF-004698', NULL, 'Uncharacterized protein', 100, NULL, NULL, 208864);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(208865, '3.30.460.10-FF-000013', NULL, 'terminal uridylyltransferase 4 isoform X1', 107, NULL, NULL, 208865),
(208866, '2.130.10.10-FF-003384', NULL, 'Uncharacterized protein', 244, NULL, NULL, 208866),
(208867, '3.80.10.10-FF-002602', NULL, 'Uncharacterized protein', 67, NULL, NULL, 208867),
(208868, '2.60.40.10-FF-000073', NULL, 'titin isoform X1', 101, NULL, NULL, 208868),
(208869, '3.30.40.10-FF-000959', NULL, 'E3 ubiquitin-protein ligase', 75, NULL, NULL, 208869),
(208870, '1.20.1250.20-FF-000476', NULL, 'Cysteine transporter', 206, NULL, NULL, 208870),
(208871, '3.30.160.60-FF-001826', NULL, 'Lethal (3) neo38, isoform A', 90, NULL, NULL, 208871),
(208872, '3.40.50.12780-FF-000196', NULL, 'AMP-binding protein', 483, NULL, NULL, 208872),
(208873, '1.10.3720.10-FF-000186', NULL, 'ABC transporter permease protein', 198, NULL, NULL, 208873),
(208874, '3.90.180.10-FF-000124', NULL, 'Uncharacterized protein', 132, NULL, NULL, 208874),
(208875, '3.30.160.60-FF-004125', NULL, NULL, 48, NULL, NULL, 208875),
(208876, '1.20.1250.20-FF-000133', NULL, 'Inner membrane protein YbjJ', 182, NULL, NULL, 208876),
(208877, '1.20.58.830-FF-000002', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 158, NULL, NULL, 208877),
(208878, '1.20.58.60-FF-000880', NULL, 'Uncharacterized protein', 127, NULL, NULL, 208878),
(208879, '1.10.3820.10-FF-000002', NULL, 'Cytochrome c nitrate reductase small subunit', 166, NULL, NULL, 208879),
(208880, '3.40.1280.10-FF-000075', NULL, 'Ribosomal RNA small subunit methyltransferase E', 243, NULL, NULL, 208880),
(208881, '2.40.50.140-FF-000708', NULL, NULL, 122, NULL, NULL, 208881),
(208882, '2.60.120.970-FF-000005', NULL, 'Bone morphogenetic protein 4', 251, NULL, NULL, 208882),
(208883, '2.60.40.150-FF-000565', NULL, 'Ca2+dependent plant phosphoribosyltransferase family protein', 134, NULL, NULL, 208883),
(208884, '1.25.40.120-FF-000095', NULL, 'Predicted protein', 169, NULL, NULL, 208884),
(208885, '2.60.40.2860-FF-000010', NULL, 'Transmission-blocking target antigen S230', 127, NULL, NULL, 208885),
(208886, '2.60.120.290-FF-000228', NULL, 'Uncharacterized protein', 96, NULL, NULL, 208886),
(208887, '3.30.900.10-FF-000042', NULL, 'Histone H4 transcription factor-like Protein', 196, NULL, NULL, 208887),
(208888, '1.10.510.10-FF-001710', NULL, 'Os07g0555700 protein', 121, NULL, NULL, 208888),
(208889, '1.20.1260.110-FF-000003', NULL, 'DNA integrity scanning protein DisA', 144, NULL, NULL, 208889),
(208890, '2.60.40.1080-FF-000010', NULL, 'S-layer protein', 81, NULL, NULL, 208890),
(208891, '3.30.160.60-FF-004232', NULL, NULL, 48, NULL, NULL, 208891),
(208892, '3.30.40.10-FF-001578', NULL, 'DUF602 domain-containing protein', 127, NULL, NULL, 208892),
(208893, '3.40.20.10-FF-000082', NULL, 'Coronin', 116, NULL, NULL, 208893),
(208894, '2.60.120.200-FF-000701', NULL, 'Uncharacterized protein', 187, NULL, NULL, 208894),
(208895, '3.40.50.2300-FF-000127', NULL, 'Response regulator (OmpR)', 79, NULL, NULL, 208895),
(208896, '3.30.40.10-FF-000055', NULL, 'Ubiquitin conjugation factor e4 a', 79, NULL, NULL, 208896),
(208897, '1.20.5.1300-FF-000001', NULL, 'Histidine biosynthesis trifunctional protein', 55, NULL, NULL, 208897),
(208898, '3.40.30.10-FF-000700', NULL, 'Uncharacterized protein', 80, NULL, NULL, 208898),
(208899, '3.40.1410.10-FF-000013', NULL, 'Mannosyl-D-glycerate transport/metabolism system repressor mngR', 162, NULL, NULL, 208899),
(208900, '3.10.440.10-FF-000005', NULL, '50S ribosomal protein L31e', 87, NULL, NULL, 208900),
(208901, '3.40.50.450-FF-000034', NULL, 'ATP-dependent 6-phosphofructokinase', 42, NULL, NULL, 208901),
(208902, '3.40.50.300-FF-000124', NULL, 'RuvB-like helicase', 188, NULL, NULL, 208902),
(208903, '3.60.10.10-FF-000086', NULL, 'Carbon catabolite repressor protein 4 homolog 6', 327, NULL, NULL, 208903),
(208904, '2.130.10.10-FF-003035', NULL, 'Uncharacterized WD repeat-containing protein slr1409', 154, NULL, NULL, 208904),
(208905, '1.10.287.70-FF-000224', NULL, 'Potassium voltage-gated channel subfamily C member 2', 80, NULL, NULL, 208905),
(208906, '3.40.50.1000-FF-000389', NULL, 'CTDNEP1 isoform 2', 79, NULL, NULL, 208906);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(208907, '3.30.590.10-FF-000017', NULL, 'Probable glutamine synthetase glnA3', 338, NULL, NULL, 208907),
(208908, '3.40.390.10-FF-000185', NULL, NULL, 182, NULL, NULL, 208908),
(208909, '2.60.300.12-FF-000018', NULL, 'Iron-sulfur cluster assembly accessory protein', 106, NULL, NULL, 208909),
(208910, '1.10.4140.10-FF-000001', NULL, 'SPI-1 type III secretion system effector HECT-type E3 ubiquitin transferase SopA', 193, NULL, NULL, 208910),
(208911, '3.30.1330.20-FF-000023', NULL, 'Tubulin alpha chain', 115, NULL, NULL, 208911),
(208912, '2.130.10.10-FF-001922', NULL, 'Uncharacterized protein', 220, NULL, NULL, 208912),
(208913, '2.60.40.10-FF-002894', NULL, 'SNF1-related protein kinase regulatory subunit beta, putative', 87, NULL, NULL, 208913),
(208914, '3.10.580.10-FF-000162', NULL, 'Uncharacterized protein', 83, NULL, NULL, 208914),
(208915, '2.70.160.11-FF-000099', NULL, 'Uncharacterized protein', 93, NULL, NULL, 208915),
(208916, '1.10.10.10-FF-001469', NULL, 'Putative U5 small nuclear ribonucleoprotein 200 kDa helicase-like protein', 93, NULL, NULL, 208916),
(208917, '1.10.600.10-FF-000071', NULL, 'Phytoene synthase', 264, NULL, NULL, 208917),
(208918, '3.40.50.300-FF-003434', NULL, 'Dynein heavy chain, putative', 328, NULL, NULL, 208918),
(208919, '2.60.40.10-FF-003743', NULL, NULL, 103, NULL, NULL, 208919),
(208920, '2.130.10.10-FF-000629', NULL, 'UV-damaged DNA binding protein', 358, NULL, NULL, 208920),
(208921, '3.40.50.410-FF-000264', NULL, 'Integrin beta', 82, NULL, NULL, 208921),
(208922, '3.60.20.10-FF-000125', NULL, 'Proteasome subunit alpha type', 249, NULL, NULL, 208922),
(208923, '1.20.1070.10-FF-002156', NULL, 'Uncharacterized protein', 151, NULL, NULL, 208923),
(208924, '3.40.1190.20-FF-000189', NULL, NULL, 337, NULL, NULL, 208924),
(208925, '3.40.50.2300-FF-000796', NULL, NULL, 139, NULL, NULL, 208925),
(208926, '1.10.10.650-FF-000016', NULL, 'Transcription elongation factor Spt6', 159, NULL, NULL, 208926),
(208927, '3.30.1330.100-FF-000004', NULL, 'GTP protein', 130, NULL, NULL, 208927),
(208928, '2.60.120.10-FF-000266', NULL, 'Phosphomannose isomerase type I, putative', 41, NULL, NULL, 208928),
(208929, '1.10.580.10-FF-000023', NULL, 'Citrate synthase', 226, NULL, NULL, 208929),
(208930, '3.30.1330.40-FF-000029', NULL, 'Unplaced genomic scaffold supercont2.28, whole genome shotgun sequence', 147, NULL, NULL, 208930),
(208931, '3.80.10.10-FF-000129', NULL, 'Leucine-rich repeat receptor-like kinase', 124, NULL, NULL, 208931),
(208932, '2.30.30.140-FF-000201', NULL, 'Putative ATP-dependent RNA helicase SoYb', 55, NULL, NULL, 208932),
(208933, '3.30.230.10-FF-000199', NULL, 'Protein CBR-TAG-96', 196, NULL, NULL, 208933),
(208934, '3.10.330.10-FF-000014', NULL, 'Blast:Peroxisome biogenesis factor 1', 81, NULL, NULL, 208934),
(208935, '1.10.1370.30-FF-000012', NULL, 'Angiotensin-converting enzyme', 295, NULL, NULL, 208935),
(208936, '1.20.1410.10-FF-000002', NULL, 'Huntingtin interacting protein 1', 204, NULL, NULL, 208936),
(208937, '2.60.40.60-FF-000970', NULL, 'Uncharacterized protein', 86, NULL, NULL, 208937),
(208938, '1.25.40.10-FF-002770', NULL, 'Probable inactive receptor-like kinase BSK12', 109, NULL, NULL, 208938),
(208939, '1.20.5.110-FF-000135', NULL, 'Sporulation-specific protein 20', 63, NULL, NULL, 208939),
(208940, '1.10.1060.10-FF-000039', NULL, NULL, 104, NULL, NULL, 208940),
(208941, '3.40.50.300-FF-007616', NULL, 'Uncharacterized protein', 152, NULL, NULL, 208941),
(208942, '3.40.50.300-FF-003327', NULL, 'Uncharacterized protein', 181, NULL, NULL, 208942),
(208943, '3.30.420.230-FF-000003', NULL, 'Pre-mRNA-processing-splicing factor 8', 153, NULL, NULL, 208943),
(208944, '3.40.50.2300-FF-001420', NULL, NULL, 43, NULL, NULL, 208944),
(208945, '3.50.50.60-FF-000603', NULL, 'Flavin-containing monooxygenase, putative', 110, NULL, NULL, 208945),
(208946, '3.40.30.10-FF-000363', NULL, 'Glutaredoxin', 110, NULL, NULL, 208946),
(208947, '1.25.10.10-FF-002386', NULL, 'LD19058p', 266, NULL, NULL, 208947),
(208948, '1.10.10.790-FF-000030', NULL, NULL, 70, NULL, NULL, 208948);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(208949, '3.30.310.10-FF-000019', NULL, 'Coatomer subunit gamma', 118, NULL, NULL, 208949),
(208950, '3.40.50.720-FF-000025', NULL, 'D-3-phosphoglycerate dehydrogenase', 111, NULL, NULL, 208950),
(208951, '3.40.50.300-FF-000343', NULL, 'Ras family gtpase', 173, NULL, NULL, 208951),
(208952, '3.40.47.10-FF-000227', NULL, NULL, 98, NULL, NULL, 208952),
(208953, '3.30.40.10-FF-000274', NULL, 'TNF receptor-associated factor', 107, NULL, NULL, 208953),
(208954, '1.20.1310.10-FF-000186', NULL, NULL, 112, NULL, NULL, 208954),
(208955, '2.10.70.20-FF-000001', NULL, 'General secretion pathway protein J', 49, NULL, NULL, 208955),
(208956, '1.10.287.80-FF-000008', NULL, 'ATP synthase F1 subunit gamma protein', 56, NULL, NULL, 208956),
(208957, '3.30.70.330-FF-002735', NULL, NULL, 95, NULL, NULL, 208957),
(208958, '1.25.10.10-FF-003347', NULL, 'Uncharacterized protein', 220, NULL, NULL, 208958),
(208959, '2.10.25.10-FF-000490', NULL, 'von Willebrand factor D and EGF domain-containing protein', 65, NULL, NULL, 208959),
(208960, '3.40.50.720-FF-001879', NULL, 'GH01674p', 84, NULL, NULL, 208960),
(208961, '1.20.58.900-FF-000034', NULL, 'Predicted protein', 76, NULL, NULL, 208961),
(208962, '4.10.240.10-FF-000037', NULL, 'Glucose starvation modulator protein 1', 28, NULL, NULL, 208962),
(208963, '1.20.1540.10-FF-000006', NULL, 'rhomboid-related protein 1 isoform X1', 208, NULL, NULL, 208963),
(208964, '2.30.39.10-FF-000043', NULL, 'Serpin 7 precursor, putative', 125, NULL, NULL, 208964),
(208965, '3.30.70.360-FF-000024', NULL, 'Beta-Ala-His dipeptidase', 162, NULL, NULL, 208965),
(208966, '3.90.25.10-FF-000085', NULL, 'Uncharacterized protein PB2B2.11', 83, NULL, NULL, 208966),
(208967, '3.30.70.330-FF-002865', NULL, NULL, 134, NULL, NULL, 208967),
(208968, '1.20.930.20-FF-000006', NULL, 'Armadillo repeat only 4', 120, NULL, NULL, 208968),
(208969, '1.10.10.60-FF-000618', NULL, 'FRIGIDA interacting protein 2', 68, NULL, NULL, 208969),
(208970, '3.10.130.10-FF-000010', NULL, 'RNase 3', 116, NULL, NULL, 208970),
(208971, '3.20.20.300-FF-000061', NULL, NULL, 60, NULL, NULL, 208971),
(208972, '3.40.50.12780-FF-000089', NULL, 'AMP dependent ligase/synthetase, putative', 409, NULL, NULL, 208972),
(208973, '3.30.160.60-FF-004917', NULL, NULL, 31, NULL, NULL, 208973),
(208974, '3.30.70.330-FF-003011', NULL, NULL, 136, NULL, NULL, 208974),
(208975, '2.10.25.10-FF-000360', NULL, 'Sushi, nidogen and EGF like domains 1', 39, NULL, NULL, 208975),
(208976, '3.40.50.300-FF-005014', NULL, 'Ribosome biogenesis protein BMS1 homolog-related protein', 112, NULL, NULL, 208976),
(208977, '3.30.310.80-FF-000001', NULL, 'Non-specific serine/threonine protein kinase', 114, NULL, NULL, 208977),
(208978, '3.80.10.10-FF-003788', NULL, 'RNI-like superfamily protein', 98, NULL, NULL, 208978),
(208979, '3.40.1110.10-FF-000316', NULL, NULL, 102, NULL, NULL, 208979),
(208980, '3.40.50.1390-FF-000011', NULL, 'Resolvase protein', 150, NULL, NULL, 208980),
(208981, '3.90.180.10-FF-000017', NULL, 'NADP-dependent alcohol dehydrogenase', 185, NULL, NULL, 208981),
(208982, '2.60.120.340-FF-000035', NULL, 'Uncharacterized protein', 94, NULL, NULL, 208982),
(208983, '1.10.640.10-FF-000062', NULL, 'Uncharacterized protein', 206, NULL, NULL, 208983),
(208984, '1.25.40.20-FF-000867', NULL, 'Ankyrin_repeats_(Many_copies)/Ankyrin_repeats_(3_ copies)/Ankyrin_repeat_-_putative', 193, NULL, NULL, 208984),
(208985, '3.80.10.10-FF-004064', NULL, 'F-box/leucine rich repeat protein, putative', 132, NULL, NULL, 208985),
(208986, '1.10.1000.11-FF-000031', NULL, 'Uncharacterized protein', 103, NULL, NULL, 208986),
(208987, '3.90.226.10-FF-000355', NULL, 'Uncharacterized protein', 203, NULL, NULL, 208987),
(208988, '1.25.40.20-FF-001143', NULL, 'UPF0507 protein YALI0E18612g', 150, NULL, NULL, 208988),
(208989, '1.10.10.10-FF-001817', NULL, 'Vacuolar protein-sorting protein, putative', 38, NULL, NULL, 208989),
(208990, '3.40.50.300-FF-004738', NULL, 'Multidrug resistance protein, putative', 147, NULL, NULL, 208990),
(208991, '3.40.50.620-FF-000326', NULL, 'Leucine--tRNA ligase, cytoplasmic', 145, NULL, NULL, 208991);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(208992, '3.10.20.90-FF-000882', NULL, 'GA-binding protein transcription factor subunit alpha', 59, NULL, NULL, 208992),
(208993, '3.40.50.2020-FF-000127', NULL, 'Orotate phosphoribosyltransferase', 199, NULL, NULL, 208993),
(208994, '3.30.730.10-FF-000006', NULL, 'ethylene-responsive transcription factor ERF014-like', 61, NULL, NULL, 208994),
(208995, '3.40.50.720-FF-002279', NULL, 'Os11g0229100 protein', 13, NULL, NULL, 208995),
(208996, '1.25.40.10-FF-001606', NULL, 'Anaphase-promoting complex subunit 6', 495, NULL, NULL, 208996),
(208997, '2.60.34.10-FF-000036', NULL, 'Heat shock 70 kDa protein', 174, NULL, NULL, 208997),
(208998, '2.10.70.10-FF-000116', NULL, 'Uncharacterized protein, isoform D', 58, NULL, NULL, 208998),
(208999, '3.30.1370.10-FF-000135', NULL, 'RE73736p', 77, NULL, NULL, 208999),
(209000, '1.25.10.10-FF-002947', NULL, 'Predicted protein', 56, NULL, NULL, 209000),
(209001, '1.10.275.60-FF-000003', NULL, 'Adenylosuccinate lyase', 48, NULL, NULL, 209001),
(209002, '3.30.70.330-FF-003135', NULL, NULL, 127, NULL, NULL, 209002),
(209003, '1.25.40.10-FF-001258', NULL, 'Soluble NSF attachment protein gamma isoform, putative', 274, NULL, NULL, 209003),
(209004, '1.20.1440.170-FF-000017', NULL, NULL, 45, NULL, NULL, 209004),
(209005, '1.10.2000.10-FF-000047', NULL, NULL, 121, NULL, NULL, 209005),
(209006, '3.90.640.10-FF-000059', NULL, 'Actin-like protein', 109, NULL, NULL, 209006),
(209007, '1.20.1270.60-FF-000129', NULL, 'Islet cell autoantigen', 201, NULL, NULL, 209007),
(209008, '3.40.50.1820-FF-001028', NULL, 'Lipid particle protein, putative', 168, NULL, NULL, 209008),
(209009, '3.30.160.60-FF-005536', NULL, NULL, 49, NULL, NULL, 209009),
(209010, '3.40.50.620-FF-000107', NULL, 'Tyrosine--tRNA ligase', 245, NULL, NULL, 209010),
(209011, '2.30.170.40-FF-000009', NULL, '50S ribosomal protein L28', 84, NULL, NULL, 209011),
(209012, '2.60.40.60-FF-000520', NULL, 'Uncharacterized protein', 114, NULL, NULL, 209012),
(209013, '2.30.170.20-FF-000003', NULL, '60S ribosomal protein L24', 62, NULL, NULL, 209013),
(209014, '1.10.287.950-FF-000005', NULL, 'Laminin subunit alpha 2', 166, NULL, NULL, 209014),
(209015, '2.60.40.10-FF-003164', NULL, 'Chitinase A', 123, NULL, NULL, 209015),
(209016, '3.40.50.1220-FF-000112', NULL, 'NAD-dependent protein deacetylase', 143, NULL, NULL, 209016),
(209017, '3.40.140.10-FF-000032', NULL, 'DNA repair protein RadC', 124, NULL, NULL, 209017),
(209018, '1.25.40.500-FF-000006', NULL, 'GD12864', 146, NULL, NULL, 209018),
(209019, '3.10.129.10-FF-000158', NULL, 'Uncharacterized protein', 148, NULL, NULL, 209019),
(209020, '2.10.25.10-FF-001321', NULL, 'Crumbs cell polarity complex component 1', 66, NULL, NULL, 209020),
(209021, '2.40.50.140-FF-000591', NULL, 'DNA replication, chromatin-associated protein, putative', 194, NULL, NULL, 209021),
(209022, '1.10.150.250-FF-000010', NULL, NULL, 46, NULL, NULL, 209022),
(209023, '4.10.400.10-FF-000128', NULL, 'Vermiform, isoform H', 40, NULL, NULL, 209023),
(209024, '1.10.510.10-FF-000182', NULL, 'MAP kinase kinase kinase mkh1', 290, NULL, NULL, 209024),
(209025, '1.10.720.30-FF-000018', NULL, 'Uncharacterized protein, isoform G', 62, NULL, NULL, 209025),
(209026, '1.25.40.10-FF-004568', NULL, 'Pre-mRNA-splicing factor CLF1', 195, NULL, NULL, 209026),
(209027, '3.30.540.10-FF-000065', NULL, 'Ammonium transporter', 152, NULL, NULL, 209027),
(209028, '1.10.510.10-FF-001609', NULL, 'Fused serine/threonine kinase-like protein', 258, NULL, NULL, 209028),
(209029, '1.20.5.120-FF-000008', NULL, NULL, 53, NULL, NULL, 209029),
(209030, '3.30.420.40-FF-000795', NULL, 'Heat shock protein 70 putative', 40, NULL, NULL, 209030),
(209031, '3.50.50.60-FF-000480', NULL, 'Flavin-containing monooxygenase', 275, NULL, NULL, 209031),
(209032, '1.25.10.20-FF-000011', NULL, 'AGAP008369-PA', 320, NULL, NULL, 209032),
(209033, '3.30.160.60-FF-000865', NULL, 'zinc finger protein 140 isoform X3', 27, NULL, NULL, 209033),
(209034, '1.10.4100.10-FF-000004', NULL, '2-methylcitrate dehydratase PrpD', 263, NULL, NULL, 209034),
(209035, '1.10.1080.10-FF-000023', NULL, 'Glutathione synthetase', 82, NULL, NULL, 209035);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(209036, '2.60.40.3510-FF-000020', NULL, 'Jagged canonical Notch ligand 2', 130, NULL, NULL, 209036),
(209037, '1.20.1160.11-FF-000023', NULL, NULL, 63, NULL, NULL, 209037),
(209038, '3.30.40.10-FF-000398', NULL, 'E3 ubiquitin-protein ligase TRIM71', 54, NULL, NULL, 209038),
(209039, '3.30.760.10-FF-000053', NULL, 'Eukaryotic translation initiation factor 4E family member 2', 71, NULL, NULL, 209039),
(209040, '3.10.450.50-FF-000046', NULL, 'Nuclear RNA export factor 2', 122, NULL, NULL, 209040),
(209041, '3.30.70.3490-FF-000059', NULL, NULL, 128, NULL, NULL, 209041),
(209042, '2.40.40.20-FF-000032', NULL, 'vesicle-fusing ATPase 2', 84, NULL, NULL, 209042),
(209043, '3.70.10.10-FF-000001', NULL, 'Proliferating cell nuclear antigen', 260, NULL, NULL, 209043),
(209044, '1.10.510.10-FF-000530', NULL, 'probable receptor-like protein kinase At5g59700', 210, NULL, NULL, 209044),
(209045, '3.90.260.10-FF-000069', NULL, 'Uncharacterized protein', 158, NULL, NULL, 209045),
(209046, '1.20.1420.30-FF-000059', NULL, 'Ca(2+)/H(+) antiporter', 167, NULL, NULL, 209046),
(209047, '3.40.50.2300-FF-000801', NULL, NULL, 113, NULL, NULL, 209047),
(209048, '2.60.120.620-FF-000035', NULL, 'prolyl 3-hydroxylase sudestada1 isoform X2', 224, NULL, NULL, 209048),
(209049, '3.30.1640.10-FF-000004', NULL, 'DNA helicase', 102, NULL, NULL, 209049),
(209050, '3.10.400.10-FF-000003', NULL, 'Sulfate adenylyltransferase', 188, NULL, NULL, 209050),
(209051, '1.10.472.80-FF-000175', NULL, NULL, 117, NULL, NULL, 209051),
(209052, '3.90.550.10-FF-000501', NULL, 'Exostosin-1', 269, NULL, NULL, 209052),
(209053, '3.60.10.10-FF-000299', NULL, 'Uncharacterized protein', 331, NULL, NULL, 209053),
(209054, '3.40.390.10-FF-000308', NULL, NULL, 197, NULL, NULL, 209054),
(209055, '2.60.40.3500-FF-000011', NULL, NULL, 120, NULL, NULL, 209055),
(209056, '1.50.40.10-FF-000452', NULL, 'Uncharacterized protein', 114, NULL, NULL, 209056),
(209057, '3.40.50.720-FF-000817', NULL, 'Short chain dehydrogenase', 247, NULL, NULL, 209057),
(209058, '3.30.1370.50-FF-000012', NULL, 'Transcription factor-like protein', 115, NULL, NULL, 209058),
(209059, '2.60.120.260-FF-000579', NULL, 'Uncharacterized protein', 174, NULL, NULL, 209059),
(209060, '3.70.10.10-FF-000107', NULL, 'Rad9', 262, NULL, NULL, 209060),
(209061, '2.60.40.2170-FF-000011', NULL, 'Uncharacterized protein', 131, NULL, NULL, 209061),
(209062, '1.25.40.10-FF-004916', NULL, 'Genomes uncoupled1', 70, NULL, NULL, 209062),
(209063, '1.25.10.10-FF-000126', NULL, 'TOG array regulator of axonemal microtubules 1', 210, NULL, NULL, 209063),
(209064, '3.90.660.10-FF-000043', NULL, 'Lysine-specific histone demethylase 1A', 116, NULL, NULL, 209064),
(209065, '1.20.1070.10-FF-001667', NULL, 'Predicted protein', 125, NULL, NULL, 209065),
(209066, '1.25.40.20-FF-000070', NULL, 'ankyrin repeat domain-containing protein 17 isoform X4', 98, NULL, NULL, 209066),
(209067, '1.20.1250.20-FF-000346', NULL, 'Transporter, major facilitator family', 188, NULL, NULL, 209067),
(209068, '1.10.510.10-FF-001834', NULL, 'Si:ch211-22d5.2', 342, NULL, NULL, 209068),
(209069, '3.30.70.330-FF-000156', NULL, 'Heterogeneous nuclear ribonucleoprotein d0 isoform', 119, NULL, NULL, 209069),
(209070, '3.30.70.250-FF-000008', NULL, 'Unplaced genomic scaffold supercont1.17, whole genome shotgun sequence', 49, NULL, NULL, 209070),
(209071, '3.40.50.2300-FF-001184', NULL, NULL, 59, NULL, NULL, 209071),
(209072, '3.40.710.10-FF-000177', NULL, 'Glutaminase a', 148, NULL, NULL, 209072),
(209073, '2.60.40.150-FF-000778', NULL, 'Uncharacterized protein', 103, NULL, NULL, 209073),
(209074, '3.40.50.1820-FF-000067', NULL, 'Bifunctional epoxide hydrolase 2', 324, NULL, NULL, 209074),
(209075, '3.90.70.80-FF-000024', NULL, 'OTU-like cysteine protease, putative', 142, NULL, NULL, 209075),
(209076, '2.60.40.2700-FF-000007', NULL, NULL, 81, NULL, NULL, 209076),
(209077, '1.10.60.10-FF-000005', NULL, 'Transcriptional regulator MntR protein', 55, NULL, NULL, 209077),
(209078, '2.130.10.10-FF-000854', NULL, 'Eukaryotic translation initiation factor 2A', 207, NULL, NULL, 209078);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(209079, '1.20.1050.10-FF-000143', NULL, 'Glutathione S-transferase, C-terminal domain-containing', 121, NULL, NULL, 209079),
(209080, '3.40.250.10-FF-000153', NULL, 'Putative thiosulfate sulfurtransferase', 122, NULL, NULL, 209080),
(209081, '3.10.10.10-FF-000048', NULL, NULL, 114, NULL, NULL, 209081),
(209082, '1.10.12.10-FF-000018', NULL, 'Probable enoyl-CoA hydratase echA10', 57, NULL, NULL, 209082),
(209083, '3.40.50.620-FF-000557', NULL, '7-cyano-7-deazaguanine synthase', 237, NULL, NULL, 209083),
(209084, '3.40.50.1820-FF-001596', NULL, 'Uncharacterized protein', 87, NULL, NULL, 209084),
(209085, '3.30.70.20-FF-000099', NULL, NULL, 111, NULL, NULL, 209085),
(209086, '1.20.5.170-FF-000107', NULL, 'Uncharacterized protein', 57, NULL, NULL, 209086),
(209087, '3.30.160.60-FF-004013', NULL, NULL, 44, NULL, NULL, 209087),
(209088, '3.30.505.10-FF-000152', NULL, NULL, 106, NULL, NULL, 209088),
(209089, '1.10.287.1040-FF-000005', NULL, 'Exodeoxyribonuclease 7 small subunit', 74, NULL, NULL, 209089),
(209090, '1.20.1250.20-FF-000352', NULL, 'Major Facilitator Superfamily protein', 187, NULL, NULL, 209090),
(209091, '3.30.1330.80-FF-000013', NULL, 'AT-hook motif nuclear-localized protein', 124, NULL, NULL, 209091),
(209092, '2.30.29.30-FF-000205', NULL, 'Rho guanine nucleotide exchange factor (GEF) 19', 116, NULL, NULL, 209092),
(209093, '3.40.50.150-FF-001787', NULL, NULL, 173, NULL, NULL, 209093),
(209094, '1.25.40.20-FF-001593', NULL, 'Protein CBG05582', 115, NULL, NULL, 209094),
(209095, '3.60.10.10-FF-000411', NULL, 'Uncharacterized protein', 283, NULL, NULL, 209095),
(209096, '3.30.40.10-FF-001123', NULL, 'Uncharacterized protein', 70, NULL, NULL, 209096),
(209097, '1.20.58.340-FF-000063', NULL, 'Metal ion transporter', 144, NULL, NULL, 209097),
(209098, '3.60.21.10-FF-000217', NULL, 'Serine/threonine protein phosphatase BSU1', 278, NULL, NULL, 209098),
(209099, '1.20.1410.10-FF-000019', NULL, 'Uncharacterized protein', 135, NULL, NULL, 209099),
(209100, '3.30.470.30-FF-000065', NULL, 'RNA guanylyltransferase', 204, NULL, NULL, 209100),
(209101, '2.120.10.10-FF-000028', NULL, 'Uncharacterized protein', 137, NULL, NULL, 209101),
(209102, '1.10.3660.10-FF-000017', NULL, 'Prephenate dehydratase', 105, NULL, NULL, 209102),
(209103, '2.30.30.140-FF-000090', NULL, 'Tudor domain-containing protein 6', 68, NULL, NULL, 209103),
(209104, '1.10.8.60-FF-000314', NULL, 'Chromosome 12, whole genome shotgun sequence', 70, NULL, NULL, 209104),
(209105, '3.40.630.70-FF-000003', NULL, 'Leucyl/phenylalanyl-tRNA--protein transferase', 163, NULL, NULL, 209105),
(209106, '1.20.1260.140-FF-000001', NULL, 'Ubiquinol oxidase', 245, NULL, NULL, 209106),
(209107, '1.10.287.1480-FF-000002', NULL, 'Probable 40S ribosomal protein S14, mitochondrial', 90, NULL, NULL, 209107),
(209108, '1.25.40.280-FF-000002', NULL, 'Tyrosine-protein phosphatase non-receptor type 23', 361, NULL, NULL, 209108),
(209109, '1.25.10.10-FF-000132', NULL, 'TATA-binding protein-associated factor 172 isoform X2', 224, NULL, NULL, 209109),
(209110, '1.10.510.10-FF-000305', NULL, 'phosphoinositide 3-kinase regulatory subunit 4', 209, NULL, NULL, 209110),
(209111, '3.30.230.10-FF-000417', NULL, 'ATPase, putative', 118, NULL, NULL, 209111),
(209112, '2.60.450.10-FF-000015', NULL, 'LPS ABC transporter substrate-binding protein LptA', 166, NULL, NULL, 209112),
(209113, '2.130.10.10-FF-002984', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit TRM82', 204, NULL, NULL, 209113),
(209114, '2.40.50.140-FF-001108', NULL, NULL, 58, NULL, NULL, 209114),
(209115, '2.30.130.30-FF-000009', NULL, NULL, 119, NULL, NULL, 209115),
(209116, '1.20.1070.10-FF-001774', NULL, 'Olfactory receptor 332', 33, NULL, NULL, 209116),
(209117, '3.30.160.60-FF-000415', NULL, 'Zinc finger protein 827', 70, NULL, NULL, 209117),
(209118, '1.10.10.10-FF-000401', NULL, 'GntR family transcriptional regulator', 68, NULL, NULL, 209118),
(209119, '2.130.10.10-FF-005744', NULL, 'DNA damage-binding protein 2', 123, NULL, NULL, 209119),
(209120, '2.160.20.10-FF-000084', NULL, 'Pectinesterase', 147, NULL, NULL, 209120);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(209121, '3.40.50.300-FF-008105', NULL, 'Uncharacterized protein', 109, NULL, NULL, 209121),
(209122, '3.90.132.10-FF-000013', NULL, 'Protein CBG03424', 133, NULL, NULL, 209122),
(209123, '2.130.10.30-FF-000175', NULL, NULL, 272, NULL, NULL, 209123),
(209124, '1.20.970.50-FF-000001', NULL, 'AMP phosphorylase', 145, NULL, NULL, 209124),
(209125, '2.10.25.10-FF-000607', NULL, 'Protein delta 2', 40, NULL, NULL, 209125),
(209126, '1.10.220.150-FF-000058', NULL, 'Uncharacterized protein', 91, NULL, NULL, 209126),
(209127, '1.25.40.10-FF-001264', NULL, 'High chlorophyll fluorescent 107', 210, NULL, NULL, 209127),
(209128, '3.30.70.270-FF-000334', NULL, NULL, 20, NULL, NULL, 209128),
(209129, '3.30.70.260-FF-000106', NULL, 'Acetolactate synthase small subunit', 88, NULL, NULL, 209129),
(209130, '3.40.920.10-FF-000002', NULL, '2-oxoglutarate oxidoreductase, alpha subunit', 202, NULL, NULL, 209130),
(209131, '1.20.1070.10-FF-000470', NULL, 'ETHR, isoform B', 364, NULL, NULL, 209131),
(209132, '3.40.50.720-FF-001424', NULL, 'PKS-NRPS hybrid synthetase psoA', 301, NULL, NULL, 209132),
(209133, '2.130.10.10-FF-001473', NULL, 'Protein HIRA', 103, NULL, NULL, 209133),
(209134, '2.30.42.10-FF-000168', NULL, 'FERM and PDZ domain-containing protein 1', 95, NULL, NULL, 209134),
(209135, '3.30.200.210-FF-000004', NULL, 'NADH-quinone oxidoreductase', 113, NULL, NULL, 209135),
(209136, '3.40.50.2300-FF-000565', NULL, 'Uncharacterized protein', 238, NULL, NULL, 209136),
(209137, '1.20.58.60-FF-000076', NULL, 'Plectin a', 115, NULL, NULL, 209137),
(209138, '2.130.10.10-FF-004221', NULL, 'Uncharacterized protein', 147, NULL, NULL, 209138),
(209139, '3.30.160.60-FF-002776', NULL, 'Zinc finger protein 639', 66, NULL, NULL, 209139),
(209140, '2.10.60.10-FF-000060', NULL, 'Receptor protein serine/threonine kinase', 82, NULL, NULL, 209140),
(209141, '3.10.100.10-FF-000418', NULL, NULL, 96, NULL, NULL, 209141),
(209142, '3.60.60.10-FF-000015', NULL, 'Bile salt hydrolase', 161, NULL, NULL, 209142),
(209143, '3.30.420.10-FF-000123', NULL, 'Poly(A)-specific ribonuclease PARN', 226, NULL, NULL, 209143),
(209144, '3.40.50.200-FF-000083', NULL, 'Uncharacterized protein', 245, NULL, NULL, 209144),
(209145, '3.40.50.2000-FF-000700', NULL, 'Glycosyltransferase', 179, NULL, NULL, 209145),
(209146, '1.10.287.70-FF-000455', NULL, 'ATP-sensitive inward rectifier potassium channel 12-like isoform X1', 135, NULL, NULL, 209146),
(209147, '2.60.40.10-FF-003636', NULL, NULL, 94, NULL, NULL, 209147),
(209148, '1.10.565.10-FF-000117', NULL, 'Uncharacterized protein', 225, NULL, NULL, 209148),
(209149, '3.40.50.300-FF-001872', NULL, 'PAXNEB protein superfamily', 343, NULL, NULL, 209149),
(209150, '1.10.540.10-FF-000133', NULL, 'Uncharacterized protein', 86, NULL, NULL, 209150),
(209151, '1.10.630.10-FF-000472', NULL, 'Uncharacterized protein', 323, NULL, NULL, 209151),
(209152, '3.20.20.80-FF-000226', NULL, 'Unplaced genomic scaffold supercont1.19, whole genome shotgun sequence', 101, NULL, NULL, 209152),
(209153, '2.120.10.80-FF-000010', NULL, 'kelch domain-containing protein 10', 113, NULL, NULL, 209153),
(209154, '2.170.230.10-FF-000001', NULL, 'Signal peptidase I', 109, NULL, NULL, 209154),
(209155, '1.10.287.70-FF-000348', NULL, 'Voltage-dependent T-type calcium channel subunit alpha', 125, NULL, NULL, 209155),
(209156, '2.30.30.40-FF-000386', NULL, 'N-acetylmuramoyl-L-alanine amidase', 59, NULL, NULL, 209156),
(209157, '3.10.260.20-FF-000005', NULL, 'Dachshund family transcription factor 1', 58, NULL, NULL, 209157),
(209158, '3.30.460.10-FF-000137', NULL, 'Uncharacterized protein L5213T.03', 122, NULL, NULL, 209158),
(209159, '2.60.40.10-FF-000202', NULL, 'Sidekick cell adhesion molecule 1', 100, NULL, NULL, 209159),
(209160, '2.10.220.10-FF-000223', NULL, 'Proprotein convertase subtilisin/kexin type 5a', 107, NULL, NULL, 209160),
(209161, '2.10.25.10-FF-000596', NULL, 'Nimrod C2, isoform B', 36, NULL, NULL, 209161),
(209162, '2.30.42.10-FF-000275', NULL, 'Inactivation-no-after-potential D protein', 106, NULL, NULL, 209162),
(209163, '1.20.1270.60-FF-000112', NULL, 'YKR078W-like protein', 311, NULL, NULL, 209163);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(209164, '3.60.20.40-FF-000016', NULL, 'Uncharacterized protein, isoform E', 193, NULL, NULL, 209164),
(209165, '3.30.160.60-FF-001034', NULL, 'zinc finger protein with KRAB and SCAN domains 5 isoform X1', 27, NULL, NULL, 209165),
(209166, '2.30.30.40-FF-000279', NULL, 'Spectrin beta chain, non-erythrocytic', 68, NULL, NULL, 209166),
(209167, '3.40.50.300-FF-006868', NULL, 'Sll5052 protein', 253, NULL, NULL, 209167),
(209168, '3.10.129.110-FF-000016', NULL, 'Lovastatin nonaketide synthase, polyketide synthase component', 326, NULL, NULL, 209168),
(209169, '2.60.40.150-FF-000110', NULL, 'Coiled-coil and C2 domain-containing protein 1A', 132, NULL, NULL, 209169),
(209170, '2.30.42.10-FF-000399', NULL, NULL, 102, NULL, NULL, 209170),
(209171, '1.20.120.230-FF-000029', NULL, 'Cas scaffold protein family member 4', 125, NULL, NULL, 209171),
(209172, '3.30.200.20-FF-001217', NULL, 'Protein kinase', 116, NULL, NULL, 209172),
(209173, '3.30.590.20-FF-000003', NULL, 'Glutamate--cysteine ligase', 449, NULL, NULL, 209173),
(209174, '2.60.40.10-FF-002107', NULL, 'Si:ch211-193k19.1', 81, NULL, NULL, 209174),
(209175, '3.40.50.1000-FF-000046', NULL, 'Phosphomannomutase', 135, NULL, NULL, 209175),
(209176, '1.25.10.10-FF-000817', NULL, 'Importin_1', 884, NULL, NULL, 209176),
(209177, '3.30.160.60-FF-005429', NULL, NULL, 35, NULL, NULL, 209177),
(209178, '1.25.40.20-FF-001362', NULL, 'Uncharacterized protein', 96, NULL, NULL, 209178),
(209179, '3.30.200.20-FF-000817', NULL, 'STE/STE20/YSK protein kinase', 103, NULL, NULL, 209179),
(209180, '2.10.110.10-FF-000338', NULL, 'Uncharacterized protein', 37, NULL, NULL, 209180),
(209181, '3.10.129.10-FF-000288', NULL, 'Methylthioribose-1-phosphate isomerase', 124, NULL, NULL, 209181),
(209182, '3.40.50.300-FF-007268', NULL, 'Uncharacterized protein', 156, NULL, NULL, 209182),
(209183, '1.20.1250.10-FF-000017', NULL, 'Interleukin 11', 177, NULL, NULL, 209183),
(209184, '2.60.120.650-FF-000027', NULL, 'Jumonji/arid domain-containing protein', 293, NULL, NULL, 209184),
(209185, '4.10.400.10-FF-000353', NULL, 'Low density lipoprotein receptor', 29, NULL, NULL, 209185),
(209186, '2.40.70.10-FF-000087', NULL, 'Gag-Pol polyprotein', 115, NULL, NULL, 209186),
(209187, '3.40.30.10-FF-001088', NULL, 'Uncharacterized protein', 105, NULL, NULL, 209187),
(209188, '3.30.160.60-FF-000522', NULL, 'zinc finger protein 285', 28, NULL, NULL, 209188),
(209189, '1.10.8.1180-FF-000001', NULL, 'Primosomal protein 1', 71, NULL, NULL, 209189),
(209190, '1.25.40.20-FF-001486', NULL, 'Ankyrin repeat-containing protein', 219, NULL, NULL, 209190),
(209191, '3.90.226.10-FF-000012', NULL, 'Chromodomain Y-like protein 2', 204, NULL, NULL, 209191),
(209192, '3.30.200.20-FF-000705', NULL, 'Non-specific serine/threonine protein kinase', 139, NULL, NULL, 209192),
(209193, '3.40.1380.10-FF-000015', NULL, 'F0F1 ATP synthase subunit gamma', 216, NULL, NULL, 209193),
(209194, '3.20.20.220-FF-000025', NULL, 'Proline dehydrogenase', 319, NULL, NULL, 209194),
(209195, '3.40.190.10-FF-000327', NULL, 'ABC transporter, periplasmic substrate-binding protein', 166, NULL, NULL, 209195),
(209196, '1.20.1250.20-FF-000583', NULL, 'Tartrate transporter, variant', 185, NULL, NULL, 209196),
(209197, '2.10.70.10-FF-000228', NULL, 'Uncharacterized protein', 65, NULL, NULL, 209197),
(209198, '1.10.510.10-FF-003739', NULL, NULL, 149, NULL, NULL, 209198),
(209199, '3.40.50.300-FF-002597', NULL, 'GTPase Der', 177, NULL, NULL, 209199),
(209200, '3.40.50.1380-FF-000019', NULL, 'Carbamyl phosphate synthetase', 133, NULL, NULL, 209200),
(209201, '3.80.10.10-FF-003895', NULL, 'AGAP011649-PA', 137, NULL, NULL, 209201),
(209202, '3.30.565.10-FF-000493', NULL, 'Uncharacterized protein', 143, NULL, NULL, 209202),
(209203, '1.25.40.20-FF-000974', NULL, 'Uncharacterized protein', 233, NULL, NULL, 209203),
(209204, '3.30.70.1230-FF-000067', NULL, 'Adenylate/guanylate cyclase catalytic domain protein', 207, NULL, NULL, 209204),
(209205, '3.90.1240.10-FF-000005', NULL, 'Botulinum neurotoxin type D', 80, NULL, NULL, 209205),
(209206, '2.40.100.10-FF-000022', NULL, 'Peptidyl-prolyl cis-trans isomerase CYP95', 182, NULL, NULL, 209206);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(209207, '3.40.367.20-FF-000050', NULL, 'Phosphotransferase', 97, NULL, NULL, 209207),
(209208, '3.80.10.10-FF-004295', NULL, 'Rab family protein', 441, NULL, NULL, 209208),
(209209, '2.130.10.10-FF-002198', NULL, 'Uncharacterized protein', 338, NULL, NULL, 209209),
(209210, '3.40.50.11310-FF-000002', NULL, 'Alkylphosphonate utilization protein PhnH', 184, NULL, NULL, 209210),
(209211, '2.170.8.10-FF-000004', NULL, 'Phosphoenolpyruvate carboxykinase homolog2', 60, NULL, NULL, 209211),
(209212, '2.130.10.10-FF-001579', NULL, 'Anaphase-promoting complex subunit 4', 186, NULL, NULL, 209212),
(209213, '3.90.1170.20-FF-000002', NULL, 'Nicotinate-nucleotide pyrophosphorylase [carboxylating]', 108, NULL, NULL, 209213),
(209214, '3.40.50.1360-FF-000013', NULL, 'Ribose 5-phosphate isomerase A', 136, NULL, NULL, 209214),
(209215, '3.90.640.10-FF-000261', NULL, 'Predicted protein', 88, NULL, NULL, 209215),
(209216, '1.10.600.10-FF-000065', NULL, 'Putative polyprenyl synthetase IdsB', 332, NULL, NULL, 209216),
(209217, '3.40.50.300-FF-000236', NULL, 'Cell division control protein 42', 187, NULL, NULL, 209217),
(209218, '3.30.70.100-FF-000093', NULL, 'Acylphosphatase', 88, NULL, NULL, 209218),
(209219, '3.90.360.10-FF-000003', NULL, 'Histone acetyltransferase, putative', 145, NULL, NULL, 209219),
(209220, '3.80.10.10-FF-001658', NULL, 'LOC523504 protein', 140, NULL, NULL, 209220),
(209221, '1.10.472.80-FF-000068', NULL, 'TBC domain containing protein', 133, NULL, NULL, 209221),
(209222, '1.25.10.10-FF-001436', NULL, 'Ubiquitin fusion degradation protein 3 homolog', 270, NULL, NULL, 209222),
(209223, '3.90.1170.40-FF-000008', NULL, 'Molybdopterin-converting factor chain 2', 140, NULL, NULL, 209223),
(209224, '3.30.70.270-FF-000222', NULL, NULL, 83, NULL, NULL, 209224),
(209225, '1.20.920.20-FF-000056', NULL, 'Uncharacterized protein', 343, NULL, NULL, 209225),
(209226, '1.25.40.10-FF-000752', NULL, 'Outer membrane protein assembly factor BamD', 241, NULL, NULL, 209226),
(209227, '1.10.10.10-FF-000289', NULL, 'HTH-type transcriptional regulator YidZ', 83, NULL, NULL, 209227),
(209228, '3.50.50.60-FF-000839', NULL, 'Squalene monooxygenase', 295, NULL, NULL, 209228),
(209229, '1.10.10.60-FF-000843', NULL, NULL, 67, NULL, NULL, 209229),
(209230, '1.20.1560.10-FF-000805', NULL, 'ABC transporter, putative', 187, NULL, NULL, 209230),
(209231, '1.10.1750.10-FF-000002', NULL, 'Chromosomal replication initiator protein DnaA', 99, NULL, NULL, 209231),
(209232, '1.20.58.1480-FF-000004', NULL, 'Cereblon, isoform CRA_c', 65, NULL, NULL, 209232),
(209233, '3.40.630.10-FF-000463', NULL, 'Uncharacterized protein', 109, NULL, NULL, 209233),
(209234, '2.40.10.340-FF-000002', NULL, 'Rod shape-determining protein MreC', 70, NULL, NULL, 209234),
(209235, '3.90.380.10-FF-000016', NULL, 'Dibenzofuran dioxygenase alpha subunit', 280, NULL, NULL, 209235),
(209236, '1.20.1250.20-FF-001190', NULL, 'Major facilitator superfamily MFS_1', 194, NULL, NULL, 209236),
(209237, '3.30.160.60-FF-003395', NULL, 'RH47711p', 21, NULL, NULL, 209237),
(209238, '3.30.70.330-FF-002286', NULL, NULL, 103, NULL, NULL, 209238),
(209239, '2.60.40.10-FF-003855', NULL, NULL, 70, NULL, NULL, 209239),
(209240, '3.40.50.2020-FF-000021', NULL, 'Adenine phosphoribosyltransferase', 176, NULL, NULL, 209240),
(209241, '1.10.510.10-FF-003178', NULL, NULL, 158, NULL, NULL, 209241),
(209242, '3.90.228.10-FF-000073', NULL, 'Poly [ADP-ribose] polymerase tankyrase', 208, NULL, NULL, 209242),
(209243, '3.40.50.10140-FF-000073', NULL, 'Uncharacterized protein', 73, NULL, NULL, 209243),
(209244, '3.30.160.60-FF-003271', NULL, 'PR domain-containing 2, with ZNF domain a', 60, NULL, NULL, 209244),
(209245, '1.10.443.10-FF-000008', NULL, 'Site-specific recombinase, phage integrase family', 183, NULL, NULL, 209245),
(209246, '1.10.3080.10-FF-000046', NULL, 'Chloride channel protein ClC family', 425, NULL, NULL, 209246),
(209247, '3.80.10.10-FF-004513', NULL, 'Os10g0155800 protein', 91, NULL, NULL, 209247),
(209248, '3.30.160.60-FF-005305', NULL, NULL, 29, NULL, NULL, 209248);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(209249, '3.30.70.2190-FF-000001', NULL, 'D-2-hydroxyglutarate dehydrogenase mitochondrial', 122, NULL, NULL, 209249),
(209250, '2.10.220.10-FF-000004', NULL, 'Receptor protein-tyrosine kinase', 146, NULL, NULL, 209250),
(209251, '2.40.320.10-FF-000016', NULL, 'Adenylate cyclase CyaB', 194, NULL, NULL, 209251),
(209252, '1.20.58.1120-FF-000037', NULL, 'GM10109', 164, NULL, NULL, 209252),
(209253, '2.60.120.200-FF-000134', NULL, 'Slit 2', 172, NULL, NULL, 209253),
(209254, '2.60.200.20-FF-000197', NULL, 'YALI0C09185p', 127, NULL, NULL, 209254),
(209255, '2.40.290.10-FF-000018', NULL, 'Putative KU80 protein', 193, NULL, NULL, 209255),
(209256, '3.60.40.10-FF-000020', NULL, 'Probable protein phosphatase 2C 42', 318, NULL, NULL, 209256),
(209257, '1.25.40.10-FF-001027', NULL, 'Pentatricopeptide repeat-containing protein At5g44230', 130, NULL, NULL, 209257),
(209258, '1.20.1070.10-FF-000138', NULL, 'histamine H3 receptor', 310, NULL, NULL, 209258),
(209259, '2.60.40.790-FF-000178', NULL, NULL, 124, NULL, NULL, 209259),
(209260, '1.10.287.70-FF-000567', NULL, 'Protein CBR-KVS-4', 51, NULL, NULL, 209260),
(209261, '1.10.287.660-FF-000019', NULL, 'Vacuolar protein sorting-associated protein 37', 72, NULL, NULL, 209261),
(209262, '1.20.1070.10-FF-001886', NULL, 'G-protein coupled receptor daf-37', 340, NULL, NULL, 209262),
(209263, '1.20.1050.80-FF-000012', NULL, 'Ras and Rab interactor like', 135, NULL, NULL, 209263),
(209264, '3.40.50.2060-FF-000004', NULL, 'vacuolar protein sorting-associated protein 33A isoform X2', 143, NULL, NULL, 209264),
(209265, '1.20.1250.20-FF-001201', NULL, 'Transmembrane transport protein', 184, NULL, NULL, 209265),
(209266, '1.25.40.1050-FF-000005', NULL, 'Putative exoribonuclease 2', 94, NULL, NULL, 209266),
(209267, '3.40.1180.10-FF-000034', NULL, 'Alkyl transferase', 235, NULL, NULL, 209267),
(209268, '3.40.250.10-FF-000259', NULL, 'Uncharacterized protein', 148, NULL, NULL, 209268),
(209269, '3.40.50.150-FF-001006', NULL, NULL, 201, NULL, NULL, 209269),
(209270, '3.40.50.300-FF-005582', NULL, 'Uncharacterized protein', 69, NULL, NULL, 209270),
(209271, '2.60.40.290-FF-000011', NULL, 'Putative secreted sugar hydrolase', 105, NULL, NULL, 209271),
(209272, '3.90.1200.10-FF-000008', NULL, 'Methylthioribose kinase', 277, NULL, NULL, 209272),
(209273, '1.10.472.10-FF-000087', NULL, 'Putative Cyclin dependent kinase binding protein', 151, NULL, NULL, 209273),
(209274, '3.30.200.90-FF-000001', NULL, 'Predicted protein', 85, NULL, NULL, 209274),
(209275, '2.130.10.10-FF-005525', NULL, 'Uncharacterized protein', 33, NULL, NULL, 209275),
(209276, '3.40.50.300-FF-006200', NULL, 'Uncharacterized protein', 137, NULL, NULL, 209276),
(209277, '1.25.40.10-FF-004804', NULL, 'TPR Domain containing protein', 368, NULL, NULL, 209277),
(209278, '3.20.20.100-FF-000006', NULL, 'Aldo-keto reductase family 1 member A1', 314, NULL, NULL, 209278),
(209279, '1.20.5.1160-FF-000032', NULL, 'KRT17 isoform 5', 42, NULL, NULL, 209279),
(209280, '1.25.40.970-FF-000001', NULL, 'Histone-lysine N-methyltransferase SMYD1 isoform 1', 75, NULL, NULL, 209280),
(209281, '3.30.70.340-FF-000035', NULL, NULL, 42, NULL, NULL, 209281),
(209282, '1.20.5.100-FF-000019', NULL, 'Tail spike protein', 30, NULL, NULL, 209282),
(209283, '3.10.180.10-FF-000069', NULL, 'Glyoxalase', 144, NULL, NULL, 209283),
(209284, '3.30.420.10-FF-000247', NULL, 'Si:ch1073-296i8.2', 186, NULL, NULL, 209284),
(209285, '1.10.1420.10-FF-000123', NULL, 'Putative MSH5 protein', 250, NULL, NULL, 209285),
(209286, '1.10.437.10-FF-000062', NULL, 'Predicted protein', 176, NULL, NULL, 209286),
(209287, '3.40.50.300-FF-001293', NULL, 'helicase POLQ-like isoform X5', 213, NULL, NULL, 209287),
(209288, '3.60.20.10-FF-000018', NULL, 'Proteasome subunit alpha type', 247, NULL, NULL, 209288),
(209289, '1.10.275.30-FF-000011', NULL, 'Rad3-related DNA helicase', 124, NULL, NULL, 209289),
(209290, '2.60.40.3110-FF-000001', NULL, 'Putative fimbrial outer membrane usher', 90, NULL, NULL, 209290),
(209291, '3.40.350.10-FF-000082', NULL, 'Prolidase family protein', 128, NULL, NULL, 209291);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(209292, '3.40.50.1240-FF-000101', NULL, '6-phosphofructo-2-kinase/fructose-2, 6-biphosphatase, putative', 190, NULL, NULL, 209292),
(209293, '2.120.10.30-FF-000585', NULL, 'Uncharacterized protein', 133, NULL, NULL, 209293),
(209294, '1.25.10.10-FF-000020', NULL, 'AP-2 complex subunit alpha', 618, NULL, NULL, 209294),
(209295, '3.30.60.30-FF-000152', NULL, 'Kazal type serine protease inhibitor 4', 56, NULL, NULL, 209295),
(209296, '3.40.640.10-FF-000525', NULL, 'Uncharacterized protein', 111, NULL, NULL, 209296),
(209297, '3.30.160.60-FF-003613', NULL, 'DNA-binding protein creA, variant', 50, NULL, NULL, 209297),
(209298, '2.60.120.10-FF-000030', NULL, 'Mannose-6-phosphate isomerase ManA', 175, NULL, NULL, 209298),
(209299, '3.40.50.80-FF-000227', NULL, 'Uncharacterized protein', 161, NULL, NULL, 209299),
(209300, '3.30.40.10-FF-000723', NULL, 'RING-H2 finger protein ATL46', 100, NULL, NULL, 209300),
(209301, '1.20.1250.20-FF-000240', NULL, 'Transporter, major facilitator family', 387, NULL, NULL, 209301),
(209302, '1.20.1280.50-FF-000172', NULL, 'Fbox domain-containing protein', 62, NULL, NULL, 209302),
(209303, '1.10.3860.10-FF-000016', NULL, 'Proton glutamate symport protein', 419, NULL, NULL, 209303),
(209304, '1.20.1560.10-FF-000569', NULL, 'Predicted protein', 175, NULL, NULL, 209304),
(209305, '1.10.357.20-FF-000007', NULL, 'Magnesium transporter MgtE', 177, NULL, NULL, 209305),
(209306, '3.30.160.60-FF-001719', NULL, 'C2H2 type zinc finger domain protein', 29, NULL, NULL, 209306),
(209307, '3.80.10.10-FF-003114', NULL, 'Dynein axonemal light chain 1', 97, NULL, NULL, 209307),
(209308, '3.80.10.10-FF-000708', NULL, 'Internalin A', 383, NULL, NULL, 209308),
(209309, '1.50.10.10-FF-000063', NULL, 'Endoglucanase', 362, NULL, NULL, 209309),
(209310, '3.30.450.20-FF-000173', NULL, 'Putative LOV domain-containing protein', 144, NULL, NULL, 209310),
(209311, '1.20.120.1380-FF-000004', NULL, 'Flagellar biosynthesis regulator FlhF', 54, NULL, NULL, 209311),
(209312, '1.20.1250.50-FF-000001', NULL, 'Interleukin-7', 154, NULL, NULL, 209312),
(209313, '3.30.200.20-FF-000694', NULL, 'Eukaryotic initiation factor 2alpha kinase 1', 111, NULL, NULL, 209313),
(209314, '1.25.50.20-FF-000019', NULL, 'Aminopeptidase', 311, NULL, NULL, 209314),
(209315, '1.10.510.10-FF-001598', NULL, 'Kinase, NEK', 210, NULL, NULL, 209315),
(209316, '3.30.160.60-FF-001472', NULL, 'Zinc finger protein 324', 31, NULL, NULL, 209316),
(209317, '4.10.240.10-FF-000144', NULL, 'Arg83p', 120, NULL, NULL, 209317),
(209318, '3.30.420.40-FF-000008', NULL, 'Glycerol kinase', 253, NULL, NULL, 209318),
(209319, '3.30.1240.10-FF-000024', NULL, 'Haloacid dehalogenase-like hydrolase', 107, NULL, NULL, 209319),
(209320, '3.40.50.1820-FF-000303', NULL, 'Alpha/beta hydrolase', 302, NULL, NULL, 209320),
(209321, '1.20.1270.340-FF-000001', NULL, 'Primosomal replication protein N', 98, NULL, NULL, 209321),
(209322, '3.20.20.80-FF-000120', NULL, 'Alpha-amylase A', 373, NULL, NULL, 209322),
(209323, '3.30.1370.10-FF-000028', NULL, 'protein quaking isoform X2', 142, NULL, NULL, 209323),
(209324, '1.10.940.10-FF-000006', NULL, '16S rRNA (Cytosine(967)-C(5))-methyltransferase RsmB', 138, NULL, NULL, 209324),
(209325, '2.10.10.20-FF-000003', NULL, 'Chitinase, putative', 70, NULL, NULL, 209325),
(209326, '3.40.50.1580-FF-000074', NULL, 'Inosine guanosine and xanthosine phosphorylase family protein', 200, NULL, NULL, 209326),
(209327, '1.25.10.10-FF-003330', NULL, 'Uncharacterized protein', 290, NULL, NULL, 209327),
(209328, '3.60.40.10-FF-000363', NULL, 'Uncharacterized protein', 286, NULL, NULL, 209328),
(209329, '3.40.50.720-FF-002386', NULL, 'Enoyl-[acyl-carrier-protein] reductase, mitochondrial', 180, NULL, NULL, 209329),
(209330, '2.10.110.10-FF-000119', NULL, 'LIM domain protein', 71, NULL, NULL, 209330),
(209331, '3.10.20.90-FF-000988', NULL, 'Autophagy protein 5', 91, NULL, NULL, 209331),
(209332, '1.20.1270.50-FF-000014', NULL, 'Uncharacterized protein', 52, NULL, NULL, 209332),
(209333, '3.40.50.300-FF-002254', NULL, 'Quinate pathway repressor protein QutR', 159, NULL, NULL, 209333);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(209334, '3.40.50.410-FF-000033', NULL, '60 kDa SS-A/Ro ribonucleoprotein', 194, NULL, NULL, 209334),
(209335, '3.40.50.150-FF-001349', NULL, NULL, 192, NULL, NULL, 209335),
(209336, '1.10.555.10-FF-000167', NULL, NULL, 173, NULL, NULL, 209336),
(209337, '1.25.40.90-FF-000051', NULL, 'Ent4p', 147, NULL, NULL, 209337),
(209338, '3.20.20.70-FF-000347', NULL, 'GTP 3'',8-cyclase', 337, NULL, NULL, 209338),
(209339, '3.90.640.90-FF-000026', NULL, 'Uncharacterized protein', 84, NULL, NULL, 209339),
(209340, '1.20.1560.10-FF-000226', NULL, 'Probable ATP-binding/permease fusion ABC transporter', 311, NULL, NULL, 209340),
(209341, '1.10.1070.11-FF-000086', NULL, 'Smilar to phosphatidylinositol 3-or 4-kinase', 202, NULL, NULL, 209341),
(209342, '3.40.50.10090-FF-000029', NULL, 'Uroporphyrinogen-III synthase', 159, NULL, NULL, 209342),
(209343, '1.10.8.60-FF-000078', NULL, '26S protease regulatory subunit 6B homolog', 80, NULL, NULL, 209343),
(209344, '1.10.8.270-FF-000174', NULL, 'Uncharacterized protein', 50, NULL, NULL, 209344),
(209345, '1.10.418.10-FF-000265', NULL, 'Transgelin', 153, NULL, NULL, 209345),
(209346, '3.40.1050.10-FF-000030', NULL, 'Putative integral membrane transport protein', 235, NULL, NULL, 209346),
(209347, '1.20.990.10-FF-000001', NULL, 'NADPH--cytochrome P450 reductase', 129, NULL, NULL, 209347),
(209348, '3.40.50.10380-FF-000015', NULL, 'Malic enzyme', 257, NULL, NULL, 209348),
(209349, '3.20.20.80-FF-000805', NULL, 'Alpha-L-iduronidase, putative', 124, NULL, NULL, 209349),
(209350, '1.20.1720.10-FF-000104', NULL, NULL, 63, NULL, NULL, 209350),
(209351, '3.30.420.40-FF-000683', NULL, 'Os07g0409200 protein', 136, NULL, NULL, 209351),
(209352, '3.40.50.1000-FF-000844', NULL, NULL, 68, NULL, NULL, 209352),
(209353, '3.30.60.90-FF-000035', NULL, 'Putative N6-adenosine-methyltransferase with ZZ-type zinc-binding domains', 62, NULL, NULL, 209353),
(209354, '2.40.128.20-FF-000033', NULL, 'PAEP isoform 1', 161, NULL, NULL, 209354),
(209355, '3.50.50.60-FF-000592', NULL, '2,4-dienoyl-coa reductase-like protein', 159, NULL, NULL, 209355),
(209356, '2.40.270.10-FF-000023', NULL, 'DNA-directed RNA polymerase III subunit 2', 99, NULL, NULL, 209356),
(209357, '3.30.200.20-FF-001655', NULL, 'Dual specificity protein kinase splB', 86, NULL, NULL, 209357),
(209358, '3.40.50.300-FF-007723', NULL, 'Uncharacterized protein', 93, NULL, NULL, 209358),
(209359, '2.60.40.420-FF-000207', NULL, 'Cytochrome c oxidase subunit 2', 120, NULL, NULL, 209359),
(209360, '3.30.310.40-FF-000017', NULL, 'Uncharacterized protein', 54, NULL, NULL, 209360),
(209361, '1.25.40.10-FF-002663', NULL, 'Uncharacterized protein', 116, NULL, NULL, 209361),
(209362, '3.40.140.10-FF-000268', NULL, 'Uncharacterized protein', 103, NULL, NULL, 209362),
(209363, '2.30.29.30-FF-001262', NULL, 'Uncharacterized protein', 104, NULL, NULL, 209363),
(209364, '1.20.1530.20-FF-000059', NULL, 'Uncharacterized protein', 365, NULL, NULL, 209364),
(209365, '3.40.50.300-FF-004289', NULL, 'RAS like estrogen regulated growth inhibitor', 102, NULL, NULL, 209365),
(209366, '3.40.50.150-FF-000045', NULL, 'Ribosomal RNA large subunit methyltransferase F', 260, NULL, NULL, 209366),
(209367, '1.10.510.10-FF-002559', NULL, 'Mitogen-activated protein kinase kinase kinase 4', 265, NULL, NULL, 209367),
(209368, '3.20.20.140-FF-000102', NULL, 'Amidohydrolase', 271, NULL, NULL, 209368),
(209369, '2.60.40.10-FF-005873', NULL, NULL, 128, NULL, NULL, 209369),
(209370, '1.25.40.180-FF-000303', NULL, NULL, 81, NULL, NULL, 209370),
(209371, '1.20.120.810-FF-000001', NULL, 'Vinculin a', 252, NULL, NULL, 209371),
(209372, '3.30.470.20-FF-000186', NULL, 'Carbamoyl phosphate synthase', 124, NULL, NULL, 209372),
(209373, '3.40.720.10-FF-000127', NULL, 'N-acetylgalactosamine-6-sulfatase (GALNS)', 148, NULL, NULL, 209373),
(209374, '3.40.50.300-FF-000579', NULL, 'GPN-loop GTPase', 273, NULL, NULL, 209374),
(209375, '1.20.1740.10-FF-000212', NULL, 'Predicted protein', 132, NULL, NULL, 209375),
(209376, '3.90.190.10-FF-000063', NULL, 'Dual specificity phosphatase 23', 148, NULL, NULL, 209376); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(209377, '2.60.120.10-FF-000715', NULL, 'Phosphoglycerate kinase', 146, NULL, NULL, 209377),
(209378, '3.40.630.30-FF-000002', NULL, 'Histone acetyltransferase', 132, NULL, NULL, 209378),
(209379, '3.40.630.30-FF-000126', NULL, 'Histone acetyltransferase, putative', 125, NULL, NULL, 209379),
(209380, '3.40.50.2000-FF-000357', NULL, 'Lipopolysaccharide biosynthesis protein RfbV', 195, NULL, NULL, 209380),
(209381, '1.20.120.520-FF-000015', NULL, 'Uncharacterized hemerythrin-like protein C869.06c', 145, NULL, NULL, 209381),
(209382, '1.10.3730.10-FF-000012', NULL, 'Pyrroline-5-carboxylate reductase', 101, NULL, NULL, 209382),
(209383, '1.25.10.10-FF-003111', NULL, 'Uncharacterized protein', 215, NULL, NULL, 209383),
(209384, '1.10.510.10-FF-001255', NULL, 'Glycogen synthase kinase-3 homolog YGK3', 211, NULL, NULL, 209384),
(209385, '3.20.20.70-FF-000004', NULL, 'Ribulose-phosphate 3-epimerase', 221, NULL, NULL, 209385),
(209386, '3.40.50.720-FF-001767', NULL, 'Agroclavine dehydrogenase', 162, NULL, NULL, 209386),
(209387, '3.20.20.70-FF-000128', NULL, 'Phospho-2-dehydro-3-deoxyheptonate aldolase', 253, NULL, NULL, 209387),
(209388, '1.25.10.10-FF-002493', NULL, 'Uncharacterized protein', 206, NULL, NULL, 209388),
(209389, '2.60.120.10-FF-000373', NULL, 'MerR family transcriptional regulator', 110, NULL, NULL, 209389),
(209390, '3.80.10.10-FF-002277', NULL, 'Predicted protein', 260, NULL, NULL, 209390),
(209391, '1.25.40.70-FF-000056', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', 200, NULL, NULL, 209391),
(209392, '1.10.472.100-FF-000004', NULL, 'Presenilin spe-4', 93, NULL, NULL, 209392),
(209393, '1.20.1070.10-FF-000717', NULL, 'Dopamine receptor 4', 263, NULL, NULL, 209393),
(209394, '3.80.10.10-FF-001877', NULL, 'TOLl (Drosophila) family', 217, NULL, NULL, 209394),
(209395, '3.30.40.10-FF-000162', NULL, 'E3 ubiquitin-protein ligase SHPRH isoform X1', 83, NULL, NULL, 209395),
(209396, '1.20.1250.20-FF-002038', NULL, 'Predicted protein', 329, NULL, NULL, 209396),
(209397, '1.20.1280.290-FF-000016', NULL, 'Cystinosin homolog', 103, NULL, NULL, 209397),
(209398, '2.30.29.30-FF-000424', NULL, 'Phospholipase DDHD1', 98, NULL, NULL, 209398),
(209399, '3.30.430.20-FF-000065', NULL, 'Uncharacterized protein', 79, NULL, NULL, 209399),
(209400, '3.40.50.720-FF-002043', NULL, 'Predicted protein', 179, NULL, NULL, 209400),
(209401, '1.20.140.10-FF-000100', NULL, 'Uncharacterized protein', 156, NULL, NULL, 209401),
(209402, '1.20.970.10-FF-000017', NULL, 'Anthranilate phosphoribosyltransferase', 67, NULL, NULL, 209402),
(209403, '3.40.50.410-FF-000376', NULL, 'Voltage-dependent calcium channel subunit alpha-2/delta-4-like Protein', 177, NULL, NULL, 209403),
(209404, '2.120.10.30-FF-000366', NULL, 'Uncharacterized protein', 146, NULL, NULL, 209404),
(209405, '1.20.81.30-FF-000003', NULL, 'Toxin co-regulated pilus biosynthesis protein E', 116, NULL, NULL, 209405),
(209406, '3.40.1110.10-FF-000428', NULL, NULL, 227, NULL, NULL, 209406),
(209407, '1.25.40.10-FF-003500', NULL, 'Uncharacterized protein', 334, NULL, NULL, 209407),
(209408, '3.40.50.1460-FF-000055', NULL, 'Uncharacterized protein', 208, NULL, NULL, 209408),
(209409, '3.30.160.60-FF-005182', NULL, NULL, 30, NULL, NULL, 209409),
(209410, '3.40.50.410-FF-000157', NULL, 'Uncharacterized protein', 180, NULL, NULL, 209410),
(209411, '1.25.40.10-FF-003843', NULL, 'Uncharacterized protein', 118, NULL, NULL, 209411),
(209412, '2.60.40.10-FF-001725', NULL, 'Exo-beta-D-glucosaminidase', 105, NULL, NULL, 209412),
(209413, '2.30.29.30-FF-000548', NULL, 'GD13075', 191, NULL, NULL, 209413),
(209414, '1.10.8.10-FF-000092', NULL, 'Putative E3 ubiquitin-protein ligase UPL1-like', 44, NULL, NULL, 209414),
(209415, '1.10.630.10-FF-000016', NULL, 'Cytochrome P450 78A5', 473, NULL, NULL, 209415),
(209416, '3.30.420.10-FF-000702', NULL, NULL, 109, NULL, NULL, 209416),
(209417, '2.10.25.10-FF-001557', NULL, 'Delta-like protein', 42, NULL, NULL, 209417),
(209418, '3.40.720.10-FF-000003', NULL, 'Extracellular sulfatase', 436, NULL, NULL, 209418),
(209419, '1.20.58.1880-FF-000017', NULL, 'RCOR (REST CO-Repressor) homolog', 129, NULL, NULL, 209419);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(209420, '2.40.50.730-FF-000009', NULL, 'DNA polymerase', 68, NULL, NULL, 209420),
(209421, '3.40.50.1100-FF-000200', NULL, 'Uncharacterized protein', 180, NULL, NULL, 209421),
(209422, '3.30.1370.10-FF-000247', NULL, 'EG:EG0003.2 protein (Fbgn0014870;psi protein)', 65, NULL, NULL, 209422),
(209423, '3.90.1410.10-FF-000041', NULL, 'Uncharacterized protein', 255, NULL, NULL, 209423),
(209424, '1.10.10.10-FF-001705', NULL, 'LysR family transcriptional regulator', 76, NULL, NULL, 209424),
(209425, '1.25.10.10-FF-002835', NULL, 'Uncharacterized protein', 184, NULL, NULL, 209425),
(209426, '1.10.357.50-FF-000005', NULL, 'protein unc-13 homolog D', 171, NULL, NULL, 209426),
(209427, '3.30.160.60-FF-002091', NULL, 'Zinc finger protein, FOG family member 1', 23, NULL, NULL, 209427),
(209428, '3.40.50.300-FF-001416', NULL, 'Tudor domain containing 12', 189, NULL, NULL, 209428),
(209429, '1.25.40.180-FF-000180', NULL, 'YALI0E24629p', 282, NULL, NULL, 209429),
(209430, '3.40.30.10-FF-000812', NULL, 'Slr0236 protein', 106, NULL, NULL, 209430),
(209431, '1.25.10.10-FF-001874', NULL, 'Cullin-associated NEDD8-dissociated protein 1', 131, NULL, NULL, 209431),
(209432, '2.60.120.970-FF-000117', NULL, 'Myostatin', 73, NULL, NULL, 209432),
(209433, '2.70.70.10-FF-000052', NULL, 'Peptidase M23B', 162, NULL, NULL, 209433),
(209434, '1.10.510.10-FF-002891', NULL, NULL, 260, NULL, NULL, 209434),
(209435, '1.10.287.470-FF-000064', NULL, 'Sodium:proton antiporter', 70, NULL, NULL, 209435),
(209436, '3.40.50.1010-FF-000162', NULL, NULL, 135, NULL, NULL, 209436),
(209437, '1.20.1250.20-FF-002370', NULL, 'Uncharacterized protein', 309, NULL, NULL, 209437),
(209438, '3.40.850.10-FF-000007', NULL, 'Myosin VIIA', 240, NULL, NULL, 209438),
(209439, '2.60.120.10-FF-000154', NULL, 'cGMP-dependent protein kinase 1-4', 154, NULL, NULL, 209439),
(209440, '2.60.120.260-FF-000236', NULL, 'Glycosyl transferase', 126, NULL, NULL, 209440),
(209441, '3.20.20.70-FF-000460', NULL, NULL, 109, NULL, NULL, 209441),
(209442, '1.50.40.10-FF-000233', NULL, 'Mitochondrial carrier', 164, NULL, NULL, 209442),
(209443, '2.30.30.940-FF-000008', NULL, 'Exodeoxyribonuclease V, alpha subunit', 80, NULL, NULL, 209443),
(209444, '3.30.420.40-FF-000806', NULL, 'Uncharacterized protein', 24, NULL, NULL, 209444),
(209445, '3.30.70.330-FF-001117', NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', 125, NULL, NULL, 209445),
(209446, '1.25.10.10-FF-002150', NULL, 'Uncharacterized protein', 534, NULL, NULL, 209446),
(209447, '2.60.40.1180-FF-000034', NULL, 'Alpha-xylosidase', 108, NULL, NULL, 209447),
(209448, '3.20.20.190-FF-000089', NULL, 'Phosphoinositide phospholipase C', 317, NULL, NULL, 209448),
(209449, '3.20.10.10-FF-000076', NULL, 'Branched-chain-amino-acid aminotransferase', 37, NULL, NULL, 209449),
(209450, '3.80.10.10-FF-002838', NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g29720', 132, NULL, NULL, 209450),
(209451, '2.60.120.920-FF-000131', NULL, 'Neuralized-like protein 2', 167, NULL, NULL, 209451),
(209452, '3.30.200.20-FF-001998', NULL, 'Uncharacterized protein', 96, NULL, NULL, 209452),
(209453, '3.30.70.330-FF-000717', NULL, 'regulator of nonsense transcripts 3B', 96, NULL, NULL, 209453),
(209454, '3.30.450.40-FF-000179', NULL, 'IclR family transcriptional regulator', 185, NULL, NULL, 209454),
(209455, '1.25.40.10-FF-003282', NULL, 'Pentatricopeptide repeat-containing protein isoform A', 134, NULL, NULL, 209455),
(209456, '2.60.40.10-FF-005530', NULL, NULL, 57, NULL, NULL, 209456),
(209457, '3.30.830.10-FF-000278', NULL, 'Metalloprotease, putative', 222, NULL, NULL, 209457),
(209458, '2.30.42.10-FF-000511', NULL, NULL, 83, NULL, NULL, 209458),
(209459, '3.30.160.60-FF-006143', NULL, NULL, 28, NULL, NULL, 209459),
(209460, '1.10.8.480-FF-000012', NULL, 'rRNA adenine N(6)-methyltransferase', 91, NULL, NULL, 209460),
(209461, '1.10.275.20-FF-000019', NULL, NULL, 46, NULL, NULL, 209461),
(209462, '1.20.5.170-FF-000001', NULL, 'Tropomyosin alpha-1 chain isoform 1', 143, NULL, NULL, 209462),
(209463, '1.10.150.670-FF-000017', NULL, 'Crossover junction endonuclease MUS81', 80, NULL, NULL, 209463);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(209464, '3.40.30.10-FF-000251', NULL, 'TXNL4A isoform 6', 56, NULL, NULL, 209464),
(209465, '1.10.10.10-FF-000744', NULL, 'HTH-type transcriptional regulator', 105, NULL, NULL, 209465),
(209466, '3.40.50.1000-FF-000501', NULL, 'Uncharacterized protein', 128, NULL, NULL, 209466),
(209467, '1.10.630.10-FF-000691', NULL, 'Uncharacterized protein', 146, NULL, NULL, 209467),
(209468, '3.30.200.20-FF-002274', NULL, 'Uncharacterized protein', 167, NULL, NULL, 209468),
(209469, '3.40.1360.10-FF-000020', NULL, 'DNA primase', 121, NULL, NULL, 209469),
(209470, '1.25.40.10-FF-002882', NULL, 'Chs6p', 383, NULL, NULL, 209470),
(209471, '3.60.21.10-FF-000111', NULL, 'Serine/threonine-protein phosphatase', 199, NULL, NULL, 209471),
(209472, '3.30.9.10-FF-000213', NULL, '3-hydroxybenzoate 4-monooxygenase', 125, NULL, NULL, 209472),
(209473, '1.20.58.60-FF-000312', NULL, 'Microtubule-actin crosslinking factor 1', 169, NULL, NULL, 209473),
(209474, '1.20.1630.10-FF-000002', NULL, 'Tetrathionate reductase subunit C', 296, NULL, NULL, 209474),
(209475, '1.10.472.10-FF-000429', NULL, 'Cyclin domain-containing protein', 57, NULL, NULL, 209475),
(209476, '3.40.50.150-FF-001681', NULL, NULL, 136, NULL, NULL, 209476),
(209477, '3.40.50.1010-FF-000083', NULL, 'Ribonuclease VapC', 125, NULL, NULL, 209477),
(209478, '1.20.1720.10-FF-000071', NULL, 'Membrane transport protein', 374, NULL, NULL, 209478),
(209479, '1.20.1250.10-FF-000107', NULL, NULL, 61, NULL, NULL, 209479),
(209480, '1.10.10.10-FF-001256', NULL, 'la-related protein 7', 92, NULL, NULL, 209480),
(209481, '2.60.120.200-FF-000432', NULL, 'Glycosidase', 228, NULL, NULL, 209481),
(209482, '2.60.40.10-FF-005912', NULL, NULL, 49, NULL, NULL, 209482),
(209483, '3.40.50.300-FF-005750', NULL, 'Uncharacterized protein', 135, NULL, NULL, 209483),
(209484, '3.30.160.880-FF-000003', NULL, 'Cell division protein ZapA', 42, NULL, NULL, 209484),
(209485, '1.25.40.10-FF-001443', NULL, 'Sel1 repeat family protein', 177, NULL, NULL, 209485),
(209486, '3.40.50.620-FF-000905', NULL, 'Predicted protein', 61, NULL, NULL, 209486),
(209487, '2.60.120.260-FF-000343', NULL, 'Predicted protein', 206, NULL, NULL, 209487),
(209488, '1.20.1740.10-FF-000128', NULL, 'Proline-specific permease, putative', 490, NULL, NULL, 209488),
(209489, '3.40.33.10-FF-000015', NULL, 'Golgi-associated plant pathogenesis-related protein 1', 154, NULL, NULL, 209489),
(209490, '3.30.160.60-FF-001646', NULL, 'Uncharacterized protein', 29, NULL, NULL, 209490),
(209491, '1.10.10.60-FF-001164', NULL, NULL, 49, NULL, NULL, 209491),
(209492, '3.30.40.10-FF-000853', NULL, 'PHD finger family protein', 60, NULL, NULL, 209492),
(209493, '3.40.50.2300-FF-001526', NULL, NULL, 83, NULL, NULL, 209493),
(209494, '3.90.190.10-FF-000327', NULL, 'Receptor-type tyrosine-protein phosphatase R', 82, NULL, NULL, 209494),
(209495, '3.20.20.70-FF-000050', NULL, 'Pyruvate formate-lyase-activating enzyme', 245, NULL, NULL, 209495),
(209496, '3.40.1490.10-FF-000006', NULL, 'Uncharacterized protein', 132, NULL, NULL, 209496),
(209497, '4.10.240.10-FF-000115', NULL, 'C6 transcription factor, putative', 79, NULL, NULL, 209497),
(209498, '3.40.50.300-FF-000899', NULL, 'Bifunctional coenzyme A synthase', 204, NULL, NULL, 209498),
(209499, '1.10.520.10-FF-000036', NULL, 'Peroxidase', 123, NULL, NULL, 209499),
(209500, '3.40.850.10-FF-000114', NULL, 'Kinesin-like protein', 341, NULL, NULL, 209500),
(209501, '1.25.40.10-FF-002545', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 166, NULL, NULL, 209501),
(209502, '3.40.50.300-FF-007841', NULL, 'Uncharacterized protein', 232, NULL, NULL, 209502),
(209503, '1.25.40.10-FF-003534', NULL, 'Uncharacterized RNA-binding protein C1861.04c', 213, NULL, NULL, 209503),
(209504, '3.40.50.1820-FF-000792', NULL, 'Protein EDS1', 221, NULL, NULL, 209504),
(209505, '3.30.900.10-FF-000019', NULL, 'Predicted HORMA domain protein', 264, NULL, NULL, 209505),
(209506, '3.10.129.10-FF-000254', NULL, 'Uncharacterized protein', 117, NULL, NULL, 209506),
(209507, '3.80.10.10-FF-000591', NULL, 'Leucine-rich repeat receptor protein kinase MSP1', 146, NULL, NULL, 209507);
INSERT INTO "PUBLIC"."MODEL" VALUES
(209508, '2.10.25.10-FF-000309', NULL, 'Uncharacterized protein, isoform A', 38, NULL, NULL, 209508),
(209509, '3.40.1110.10-FF-000215', NULL, 'Copper-exporting P-type ATPase A', 120, NULL, NULL, 209509),
(209510, '3.30.70.270-FF-000256', NULL, NULL, 43, NULL, NULL, 209510),
(209511, '3.80.10.10-FF-002243', NULL, 'Uncharacterized protein', 117, NULL, NULL, 209511),
(209512, '1.10.3500.10-FF-000040', NULL, 'Uncharacterized protein', 95, NULL, NULL, 209512),
(209513, '3.80.10.10-FF-004334', NULL, 'Roco6, ROCO family protein', 194, NULL, NULL, 209513),
(209514, '3.90.850.10-FF-000035', NULL, 'Uncharacterized protein', 267, NULL, NULL, 209514),
(209515, '3.60.40.10-FF-000110', NULL, 'Integrin-linked kinase-associated serine/threonine phosphatase 2C', 245, NULL, NULL, 209515),
(209516, '1.10.8.10-FF-000108', NULL, 'Ubiquitin domain-containing protein DSK2', 62, NULL, NULL, 209516),
(209517, '2.20.110.10-FF-000044', NULL, NULL, 53, NULL, NULL, 209517),
(209518, '3.40.50.720-FF-001132', NULL, 'NADH oxidoreductase', 188, NULL, NULL, 209518),
(209519, '3.40.50.720-FF-002560', NULL, 'Uncharacterized protein', 48, NULL, NULL, 209519),
(209520, '3.90.70.10-FF-000779', NULL, 'Ubiquitin-specific peptidase 20', 23, NULL, NULL, 209520),
(209521, '2.60.120.290-FF-000239', NULL, 'Platelet-derived growth factor C', 65, NULL, NULL, 209521),
(209522, '3.40.50.720-FF-002234', NULL, 'Glyoxylate/hydroxypyruvate reductase, putative', 94, NULL, NULL, 209522),
(209523, '2.130.10.10-FF-001175', NULL, 'Protein HIRA', 277, NULL, NULL, 209523),
(209524, '1.20.900.10-FF-000030', NULL, 'rho guanine nucleotide exchange factor 39', 197, NULL, NULL, 209524),
(209525, '3.60.90.10-FF-000028', NULL, '[Pyruvate dehydrogenase (Acetyl-transferring)] kinase mitochondrial', 133, NULL, NULL, 209525),
(209526, '4.10.280.10-FF-000180', NULL, 'Transcription factor BPE', 68, NULL, NULL, 209526),
(209527, '2.20.25.100-FF-000002', NULL, '30S ribosomal protein S27e', 54, NULL, NULL, 209527),
(209528, '3.40.50.1820-FF-000466', NULL, 'Tributyrin esterase', 259, NULL, NULL, 209528),
(209529, '3.50.30.30-FF-000172', NULL, 'Uncharacterized protein', 117, NULL, NULL, 209529),
(209530, '3.30.710.10-FF-000275', NULL, 'Uncharacterized protein', 128, NULL, NULL, 209530),
(209531, '1.25.40.20-FF-000311', NULL, 'Calmodulin-binding transcription activator 2', 148, NULL, NULL, 209531),
(209532, '1.10.10.10-FF-001935', NULL, 'Uncharacterized protein', 89, NULL, NULL, 209532),
(209533, '3.30.460.20-FF-000005', NULL, 'CorA Metal Ion Transporter (MIT) Family', 150, NULL, NULL, 209533),
(209534, '3.80.10.10-FF-003232', NULL, 'CD180 molecule', 196, NULL, NULL, 209534),
(209535, '2.130.10.30-FF-000079', NULL, 'Guanidine nucleotide exchange factor', 171, NULL, NULL, 209535),
(209536, '2.60.40.10-FF-003142', NULL, NULL, 97, NULL, NULL, 209536),
(209537, '3.30.30.170-FF-000004', NULL, 'Eukaryotic translation initiation factor eif-5, putative', 102, NULL, NULL, 209537),
(209538, '1.25.40.20-FF-001772', NULL, 'C2 domain containing protein', 188, NULL, NULL, 209538),
(209539, '3.40.50.1110-FF-000141', NULL, 'Predicted protein', 188, NULL, NULL, 209539),
(209540, '1.20.1070.10-FF-000335', NULL, 'Vomeronasal type-1 receptor', 279, NULL, NULL, 209540),
(209541, '1.20.58.390-FF-000162', NULL, 'Uncharacterized protein', 105, NULL, NULL, 209541),
(209542, '3.40.50.2300-FF-000863', NULL, 'Uncharacterized protein', 115, NULL, NULL, 209542),
(209543, '2.60.40.10-FF-003821', NULL, NULL, 97, NULL, NULL, 209543),
(209544, '3.90.1600.10-FF-000067', NULL, 'DNA-directed DNA polymerase', 71, NULL, NULL, 209544),
(209545, '1.25.40.10-FF-004669', NULL, 'Os06g0597500 protein', 111, NULL, NULL, 209545),
(209546, '2.20.100.10-FF-000072', NULL, 'SCO-spondin', 59, NULL, NULL, 209546),
(209547, '3.90.25.10-FF-000091', NULL, 'GDP-L-fucose synthase', 63, NULL, NULL, 209547),
(209548, '1.10.510.10-FF-003144', NULL, NULL, 180, NULL, NULL, 209548),
(209549, '3.10.20.90-FF-000084', NULL, 'nuclear protein localization protein 4 homolog', 80, NULL, NULL, 209549),
(209550, '1.10.630.10-FF-000511', NULL, 'Uncharacterized protein', 422, NULL, NULL, 209550);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(209551, '1.20.58.1420-FF-000003', NULL, 'Cytochrome P450', 91, NULL, NULL, 209551),
(209552, '1.20.1250.20-FF-000436', NULL, 'MFS transporter, putative', 190, NULL, NULL, 209552),
(209553, '3.30.460.10-FF-000002', NULL, 'Poly(A) polymerase alpha, putative', 156, NULL, NULL, 209553),
(209554, '3.30.50.10-FF-000179', NULL, 'Os05g0155400 protein', 60, NULL, NULL, 209554),
(209555, '3.40.30.10-FF-001083', NULL, 'NAD-reducing hydrogenase, alpha subunit', 88, NULL, NULL, 209555),
(209556, '1.50.10.10-FF-000181', NULL, 'LanC lantibiotic synthetase component C-like protein', 365, NULL, NULL, 209556),
(209557, '3.30.420.40-FF-000896', NULL, 'Putative Hsp70 family ATPase KAR2', 54, NULL, NULL, 209557),
(209558, '2.40.50.140-FF-000782', NULL, NULL, 90, NULL, NULL, 209558),
(209559, '1.20.5.2950-FF-000012', NULL, NULL, 116, NULL, NULL, 209559),
(209560, '2.130.10.10-FF-003945', NULL, 'Uncharacterized protein', 248, NULL, NULL, 209560),
(209561, '3.30.40.10-FF-001988', NULL, 'E3 ubiquitin-protein ligase', 56, NULL, NULL, 209561),
(209562, '1.10.8.10-FF-000260', NULL, 'Ubiquitin carboxyl-terminal hydrolase 13', 59, NULL, NULL, 209562),
(209563, '3.90.640.10-FF-000082', NULL, 'Actin 2 isoform 1', 103, NULL, NULL, 209563),
(209564, '2.10.25.10-FF-000635', NULL, 'Terribly reduced optic lobes, isoform AN', 56, NULL, NULL, 209564),
(209565, '3.30.70.1230-FF-000011', NULL, 'Adenylate cyclase', 236, NULL, NULL, 209565),
(209566, '3.40.390.10-FF-000067', NULL, 'Probable zinc metalloprotease', 306, NULL, NULL, 209566),
(209567, '3.60.20.10-FF-000047', NULL, 'Amidophosphoribosyltransferase', 307, NULL, NULL, 209567),
(209568, '2.60.120.10-FF-000721', NULL, 'Uncharacterized protein', 136, NULL, NULL, 209568),
(209569, '3.50.50.60-FF-000923', NULL, 'Uncharacterized protein', 214, NULL, NULL, 209569),
(209570, '2.60.60.20-FF-000009', NULL, 'Lipoxygenase homology domain-containing protein 1', 126, NULL, NULL, 209570),
(209571, '3.20.20.100-FF-000164', NULL, 'Predicted protein', 206, NULL, NULL, 209571),
(209572, '2.60.120.590-FF-000065', NULL, 'Uncharacterized protein', 164, NULL, NULL, 209572),
(209573, '3.40.50.10240-FF-000041', NULL, 'Uncharacterized protein', 81, NULL, NULL, 209573),
(209574, '2.40.128.20-FF-000004', NULL, 'Retinol-binding protein 4', 182, NULL, NULL, 209574),
(209575, '3.20.20.330-FF-000002', NULL, 'Homocysteine S-methyltransferase', 311, NULL, NULL, 209575),
(209576, '3.90.1150.10-FF-000285', NULL, 'Kynureninase', 133, NULL, NULL, 209576),
(209577, '1.10.800.10-FF-000018', NULL, 'Uncharacterized protein', 112, NULL, NULL, 209577),
(209578, '3.20.20.80-FF-000732', NULL, 'Uncharacterized protein', 93, NULL, NULL, 209578),
(209579, '3.30.160.310-FF-000001', NULL, 'RING finger protein Z', 35, NULL, NULL, 209579),
(209580, '2.60.40.2300-FF-000005', NULL, 'Hydrolase', 126, NULL, NULL, 209580),
(209581, '3.30.200.20-FF-001037', NULL, 'Putative G-type lectin S-receptor-like serine/threonine-protein kinase', 115, NULL, NULL, 209581),
(209582, '1.20.1070.10-FF-000661', NULL, 'KISS1 receptor b', 67, NULL, NULL, 209582),
(209583, '3.40.50.1000-FF-000400', NULL, 'GM14093', 130, NULL, NULL, 209583),
(209584, '2.40.50.140-FF-000456', NULL, 'Aspartyl-tRNA synthetase', 110, NULL, NULL, 209584),
(209585, '3.40.50.300-FF-005424', NULL, 'Predicted protein', 216, NULL, NULL, 209585),
(209586, '3.60.40.10-FF-000256', NULL, 'Integrin-linked kinase-associated serine/threonine phosphatase 2C', 107, NULL, NULL, 209586),
(209587, '3.30.380.10-FF-000001', NULL, 'Capsid protein', 129, NULL, NULL, 209587),
(209588, '1.20.1250.20-FF-002353', NULL, 'Uncharacterized protein', 145, NULL, NULL, 209588),
(209589, '1.10.10.10-FF-000946', NULL, 'ForKHead transcription factor family', 95, NULL, NULL, 209589),
(209590, '1.50.40.10-FF-000362', NULL, 'Predicted protein', 161, NULL, NULL, 209590),
(209591, '3.40.30.10-FF-000301', NULL, 'Glutathione peroxidase', 164, NULL, NULL, 209591),
(209592, '3.30.160.60-FF-004991', NULL, NULL, 66, NULL, NULL, 209592),
(209593, '3.10.290.10-FF-000072', NULL, '30S ribosomal protein S4', 92, NULL, NULL, 209593);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(209594, '1.10.357.70-FF-000005', NULL, 'Exocyst complex component Sec6', 171, NULL, NULL, 209594),
(209595, '1.10.20.60-FF-000001', NULL, 'Aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase subunit C', 46, NULL, NULL, 209595),
(209596, '1.25.40.10-FF-004962', NULL, 'Uncharacterized protein', 159, NULL, NULL, 209596),
(209597, '3.80.10.10-FF-002389', NULL, 'F-box and leucine rich repeat protein 13', 101, NULL, NULL, 209597),
(209598, '3.40.710.10-FF-000104', NULL, 'Penicillin-binding protein 2', 373, NULL, NULL, 209598),
(209599, '2.60.40.2310-FF-000008', NULL, 'Predicted protein', 128, NULL, NULL, 209599),
(209600, '3.40.50.720-FF-000317', NULL, 'Very-long-chain 3-oxoacyl-CoA reductase', 234, NULL, NULL, 209600),
(209601, '3.40.50.150-FF-001821', NULL, NULL, 87, NULL, NULL, 209601),
(209602, '1.10.8.1220-FF-000013', NULL, 'Dynein axonemal heavy chain 14', 92, NULL, NULL, 209602),
(209603, '2.20.28.20-FF-000004', NULL, 'Putative tRNA synthetase', 34, NULL, NULL, 209603),
(209604, '3.50.50.60-FF-001233', NULL, 'Flavin-containing monooxygenase', 214, NULL, NULL, 209604),
(209605, '3.30.70.330-FF-000594', NULL, 'RNA binding protein Rnp24', 108, NULL, NULL, 209605),
(209606, '3.40.50.300-FF-001681', NULL, 'DNA helicase', 157, NULL, NULL, 209606),
(209607, '2.30.39.10-FF-000149', NULL, 'Serine protease inhibitor, putative', 128, NULL, NULL, 209607),
(209608, '2.60.120.330-FF-000212', NULL, 'Uncharacterized protein', 101, NULL, NULL, 209608),
(209609, '1.20.1560.10-FF-000709', NULL, 'ABC transporter, putative', 314, NULL, NULL, 209609),
(209610, '2.30.29.150-FF-000011', NULL, 'Uncharacterized protein', 153, NULL, NULL, 209610),
(209611, '2.130.10.10-FF-005244', NULL, 'Damage-specific DNA binding protein, putative', 299, NULL, NULL, 209611),
(209612, '2.30.29.170-FF-000017', NULL, 'Protofilament ribbon protein of flagellar microtubules', 126, NULL, NULL, 209612),
(209613, '2.60.40.10-FF-004131', NULL, NULL, 96, NULL, NULL, 209613),
(209614, '3.30.160.60-FF-005980', NULL, NULL, 61, NULL, NULL, 209614),
(209615, '3.30.470.20-FF-000096', NULL, 'Tubulin tyrosine ligase protein, putative', 203, NULL, NULL, 209615),
(209616, '1.25.40.10-FF-003208', NULL, 'Os07g0172600 protein', 81, NULL, NULL, 209616),
(209617, '1.10.287.70-FF-000415', NULL, 'Uncharacterized protein', 167, NULL, NULL, 209617),
(209618, '1.25.40.20-FF-001093', NULL, 'Ankyrin repeat protein', 90, NULL, NULL, 209618),
(209619, '3.40.50.2300-FF-000537', NULL, 'Transcriptional regulator, LacI family', 118, NULL, NULL, 209619),
(209620, '3.40.50.1760-FF-000015', NULL, NULL, 124, NULL, NULL, 209620),
(209621, '1.10.20.70-FF-000004', NULL, 'Rna15p', 39, NULL, NULL, 209621),
(209622, '1.25.10.10-FF-001615', NULL, 'Uncharacterized protein', 1080, NULL, NULL, 209622),
(209623, '3.30.70.330-FF-002685', NULL, NULL, 162, NULL, NULL, 209623),
(209624, '2.60.40.10-FF-002040', NULL, 'Mesocentin', 103, NULL, NULL, 209624),
(209625, '3.40.50.11290-FF-000001', NULL, 'Hypothetical alanine and leucine rich protein', 98, NULL, NULL, 209625),
(209626, '3.40.50.150-FF-001175', NULL, NULL, 162, NULL, NULL, 209626),
(209627, '1.25.40.10-FF-001117', NULL, 'Est1-like bcy1 suppressor', 239, NULL, NULL, 209627),
(209628, '1.10.287.380-FF-000019', NULL, 'Valyl tRNA Synthetase', 72, NULL, NULL, 209628),
(209629, '3.30.470.30-FF-000099', NULL, 'Predicted protein', 188, NULL, NULL, 209629),
(209630, '3.30.1180.20-FF-000005', NULL, 'Dihydroxyacetone kinase 1-like protein', 152, NULL, NULL, 209630),
(209631, '1.25.40.180-FF-000354', NULL, NULL, 37, NULL, NULL, 209631),
(209632, '3.90.640.10-FF-000109', NULL, 'Actin-Related Proteins', 116, NULL, NULL, 209632),
(209633, '1.10.8.60-FF-000016', NULL, 'ATPase family AAA domain-containing protein 2B', 86, NULL, NULL, 209633),
(209634, '3.90.660.10-FF-000026', NULL, 'Flavin-containing monoamine oxidase', 164, NULL, NULL, 209634),
(209635, '3.20.20.70-FF-000257', NULL, 'Phosphatidylinositol 4-kinase type 2 alpha', 78, NULL, NULL, 209635),
(209636, '2.60.120.650-FF-000218', NULL, 'HSPB1 associated protein 1', 227, NULL, NULL, 209636);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(209637, '3.40.50.1450-FF-000012', NULL, 'Slr1876 protein', 149, NULL, NULL, 209637),
(209638, '3.10.10.10-FF-000043', NULL, NULL, 59, NULL, NULL, 209638),
(209639, '2.60.40.2550-FF-000001', NULL, 'GlcNAc-binding protein A', 96, NULL, NULL, 209639),
(209640, '3.40.50.300-FF-007515', NULL, 'Predicted protein', 214, NULL, NULL, 209640),
(209641, '3.40.50.300-FF-007195', NULL, 'DNA polymerase III subunit, putative', 169, NULL, NULL, 209641),
(209642, '3.40.50.1460-FF-000015', NULL, 'Caspase 14', 237, NULL, NULL, 209642),
(209643, '1.10.8.50-FF-000013', NULL, '40S ribosomal protein S18', 54, NULL, NULL, 209643),
(209644, '1.10.600.10-FF-000037', NULL, 'Phytoene synthase, putative', 251, NULL, NULL, 209644),
(209645, '1.25.40.10-FF-002871', NULL, 'Uncharacterized protein, isoform B', 36, NULL, NULL, 209645),
(209646, '2.60.40.10-FF-005266', NULL, NULL, 86, NULL, NULL, 209646),
(209647, '3.80.10.10-FF-000298', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 124, NULL, NULL, 209647),
(209648, '1.20.58.1070-FF-000027', NULL, 'Gem-associated protein 2', 158, NULL, NULL, 209648),
(209649, '3.10.129.30-FF-000001', NULL, 'Fatty acyl CoA thioesterase FcoT', 164, NULL, NULL, 209649),
(209650, '3.30.300.30-FF-000148', NULL, 'Putative acetyl-CoA synethetase', 134, NULL, NULL, 209650),
(209651, '3.40.1620.10-FF-000006', NULL, 'Antitoxin VapB35', 43, NULL, NULL, 209651),
(209652, '3.90.1200.10-FF-000019', NULL, 'Choline kinase', 324, NULL, NULL, 209652),
(209653, '4.10.1000.10-FF-000106', NULL, 'CCCH zinc finger protein (AFU_orthologue AFUA_8G04360)', 64, NULL, NULL, 209653),
(209654, '2.30.42.10-FF-000056', NULL, 'Golgi reassembly-stacking protein 2 isoform 1', 110, NULL, NULL, 209654),
(209655, '2.10.25.10-FF-000961', NULL, 'GD23942', 52, NULL, NULL, 209655),
(209656, '3.40.50.300-FF-001742', NULL, 'Pre-mRNA-splicing helicase BRR2, putative', 44, NULL, NULL, 209656),
(209657, '2.60.120.10-FF-000075', NULL, 'metal transporter CNNM2 isoform X2', 162, NULL, NULL, 209657),
(209658, '3.40.50.10190-FF-000065', NULL, 'Poly [ADP-ribose] polymerase', 96, NULL, NULL, 209658),
(209659, '2.60.200.20-FF-000079', NULL, 'Checkpoint kinase 2', 120, NULL, NULL, 209659),
(209660, '1.10.510.10-FF-001492', NULL, 'Related to Serine/threonine-protein kinase mph1', 330, NULL, NULL, 209660),
(209661, '1.25.40.10-FF-003360', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform A', 70, NULL, NULL, 209661),
(209662, '1.10.510.10-FF-004133', NULL, NULL, 79, NULL, NULL, 209662),
(209663, '3.30.420.10-FF-000409', NULL, NULL, 180, NULL, NULL, 209663),
(209664, '1.20.1560.10-FF-000182', NULL, 'Beta-(1-->2)glucan export ATP-binding/permease protein NdvA', 309, NULL, NULL, 209664),
(209665, '2.20.28.10-FF-000001', NULL, 'Rubredoxin', 54, NULL, NULL, 209665),
(209666, '3.90.55.10-FF-000007', NULL, NULL, 60, NULL, NULL, 209666),
(209667, '1.20.1250.20-FF-000762', NULL, 'organic cation transporter protein-like', 401, NULL, NULL, 209667),
(209668, '1.10.150.20-FF-000258', NULL, 'Flap endonuclease 1', 59, NULL, NULL, 209668),
(209669, '3.40.50.10140-FF-000044', NULL, 'Toll-like receptor adaptor molecule 1', 156, NULL, NULL, 209669),
(209670, '1.10.630.10-FF-000218', NULL, 'Uncharacterized protein', 292, NULL, NULL, 209670),
(209671, '1.10.565.10-FF-000151', NULL, 'Uncharacterized protein', 277, NULL, NULL, 209671),
(209672, '1.20.1280.290-FF-000084', NULL, 'Sugar transporter SWEET1', 90, NULL, NULL, 209672),
(209673, '2.30.30.100-FF-000156', NULL, 'Small nuclear ribonucleoprotein Sm D2', 120, NULL, NULL, 209673),
(209674, '3.30.420.40-FF-001060', NULL, 'Uncharacterized protein', 65, NULL, NULL, 209674),
(209675, '2.40.50.90-FF-000087', NULL, 'Protein CBG02810', 161, NULL, NULL, 209675),
(209676, '3.30.30.30-FF-000009', NULL, 'Heat shock protein Hsp70', 51, NULL, NULL, 209676),
(209677, '2.60.120.260-FF-000489', NULL, 'Uncharacterized protein', 111, NULL, NULL, 209677),
(209678, '3.40.50.620-FF-000085', NULL, 'Tyrosine--tRNA ligase 1 cytoplasmic', 161, NULL, NULL, 209678),
(209679, '3.30.300.30-FF-000087', NULL, 'Nonribosomal peptide synthase GliP', 94, NULL, NULL, 209679);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(209680, '3.40.80.10-FF-000012', NULL, 'N-acetyl-anhydromuranmyl-L-alanine amidase', 175, NULL, NULL, 209680),
(209681, '1.10.630.10-FF-000191', NULL, 'GD17061', 512, NULL, NULL, 209681),
(209682, '3.40.50.300-FF-001063', NULL, 'Guanylate-binding family protein', 269, NULL, NULL, 209682),
(209683, '3.40.50.720-FF-000643', NULL, 'Short chain dehydrogenase/reductase family oxidoreductase, putative', 266, NULL, NULL, 209683),
(209684, '3.30.70.330-FF-001903', NULL, NULL, 76, NULL, NULL, 209684),
(209685, '2.60.220.50-FF-000038', NULL, 'RE14222p', 161, NULL, NULL, 209685),
(209686, '1.10.3810.10-FF-000024', NULL, 'Penicillin-binding protein, 1A family', 195, NULL, NULL, 209686),
(209687, '3.40.50.300-FF-008330', NULL, 'Uncharacterized protein', 241, NULL, NULL, 209687),
(209688, '1.10.10.10-FF-001082', NULL, 'Uncharacterized protein', 82, NULL, NULL, 209688),
(209689, '3.40.50.2060-FF-000010', NULL, 'Vacuolar protein sorting-associated protein 45', 148, NULL, NULL, 209689),
(209690, '3.40.50.300-FF-001355', NULL, 'tRNA dimethylallyltransferase', 265, NULL, NULL, 209690),
(209691, '1.10.630.10-FF-000011', NULL, 'Cytochrome P450 83B1', 474, NULL, NULL, 209691),
(209692, '4.10.950.10-FF-000001', NULL, '50S ribosomal protein L2', 80, NULL, NULL, 209692),
(209693, '2.10.25.10-FF-000135', NULL, 'Laminin subunit beta 4', 50, NULL, NULL, 209693),
(209694, '3.40.50.620-FF-000731', NULL, 'Uncharacterized protein', 178, NULL, NULL, 209694),
(209695, '1.25.40.10-FF-001617', NULL, 'Stress-induced-phosphoprotein 1', 163, NULL, NULL, 209695),
(209696, '1.10.8.100-FF-000022', NULL, 'Ribosomal RNA small subunit methyltransferase A', 72, NULL, NULL, 209696),
(209697, '3.30.200.20-FF-001363', NULL, NULL, 104, NULL, NULL, 209697),
(209698, '1.10.510.10-FF-001519', NULL, 'Serine/threonine-protein kinase NEK', 308, NULL, NULL, 209698),
(209699, '3.40.50.410-FF-000168', NULL, 'ATP-dependent DNA helicase', 216, NULL, NULL, 209699),
(209700, '1.20.80.10-FF-000080', NULL, 'Protein tyrosine kinase 2 beta', 76, NULL, NULL, 209700),
(209701, '2.130.10.10-FF-003092', NULL, 'WD repeat-containing protein 20 homolog', 76, NULL, NULL, 209701),
(209702, '2.60.40.10-FF-001225', NULL, 'Cell surface glycoprotein MUC18', 115, NULL, NULL, 209702),
(209703, '1.20.1070.10-FF-000509', NULL, 'Uncharacterized protein', 273, NULL, NULL, 209703),
(209704, '3.80.10.10-FF-001315', NULL, 'Leucine-rich receptor-like protein kinase family protein', 58, NULL, NULL, 209704),
(209705, '2.130.10.10-FF-001528', NULL, 'U3 small nucleolar RNA-associated protein 12', 171, NULL, NULL, 209705),
(209706, '3.30.420.10-FF-000056', NULL, 'CCR4-NOT core complex subunit Caf1', 303, NULL, NULL, 209706),
(209707, '3.10.330.10-FF-000008', NULL, 'AAA family ATPase, CDC48 subfamily', 78, NULL, NULL, 209707),
(209708, '3.40.50.720-FF-000289', NULL, 'Hydroxysteroid 17-beta dehydrogenase 7', 322, NULL, NULL, 209708),
(209709, '3.80.10.10-FF-004160', NULL, 'Uncharacterized protein', 103, NULL, NULL, 209709),
(209710, '3.30.160.60-FF-003563', NULL, 'Zinc finger protein 460', 35, NULL, NULL, 209710),
(209711, '3.40.50.800-FF-000015', NULL, 'Histidyl-tRNA synthetase, mitochondrial', 109, NULL, NULL, 209711),
(209712, '2.60.40.10-FF-000123', NULL, 'Plexin A1', 138, NULL, NULL, 209712),
(209713, '3.40.50.1470-FF-000018', NULL, 'Peptidyl-tRNA hydrolase 1 homolog', 105, NULL, NULL, 209713),
(209714, '3.40.50.2000-FF-000863', NULL, 'Putative colanic acid biosynthesis glycosyl transferase', 200, NULL, NULL, 209714),
(209715, '3.10.250.10-FF-000007', NULL, 'Soluble scavenger receptor cysteine-rich domain-containing protein SSC5D', 105, NULL, NULL, 209715),
(209716, '2.60.40.420-FF-000163', NULL, 'AGAP008732-PA', 201, NULL, NULL, 209716),
(209717, '3.40.50.2000-FF-000571', NULL, 'D-inositol-3-phosphate glycosyltransferase', 179, NULL, NULL, 209717),
(209718, '3.30.200.20-FF-002465', NULL, 'Serine/threonine-protein kinase receptor', 52, NULL, NULL, 209718),
(209719, '2.130.10.10-FF-003327', NULL, 'Uncharacterized protein', 97, NULL, NULL, 209719),
(209720, '3.40.640.10-FF-000368', NULL, 'PLP-dependent transferase', 207, NULL, NULL, 209720);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(209721, '3.30.1640.10-FF-000021', NULL, 'DNA helicase', 100, NULL, NULL, 209721),
(209722, '2.40.10.10-FF-000105', NULL, 'Inactive serine protease 45', 129, NULL, NULL, 209722),
(209723, '2.60.120.330-FF-000066', NULL, 'Os06g0176500 protein', 283, NULL, NULL, 209723),
(209724, '3.40.50.300-FF-003833', NULL, 'DNA replication licensing factor MCM7', 343, NULL, NULL, 209724),
(209725, '3.40.50.450-FF-000040', NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase', 185, NULL, NULL, 209725),
(209726, '3.40.50.300-FF-000253', NULL, 'Peptide chain release factor 3', 60, NULL, NULL, 209726),
(209727, '3.40.190.10-FF-000939', NULL, 'Predicted protein', 348, NULL, NULL, 209727),
(209728, '3.60.140.10-FF-000005', NULL, 'Laccase domain protein YfiH', 236, NULL, NULL, 209728),
(209729, '3.30.70.270-FF-000082', NULL, 'DNA polymerase eta', 128, NULL, NULL, 209729),
(209730, '2.60.40.60-FF-001133', NULL, 'Uncharacterized protein', 83, NULL, NULL, 209730),
(209731, '3.80.10.10-FF-002417', NULL, 'Uncharacterized protein', 201, NULL, NULL, 209731),
(209732, '1.10.287.70-FF-000269', NULL, 'TWiK family of potassium channels', 275, NULL, NULL, 209732),
(209733, '1.20.1250.20-FF-002027', NULL, 'Solute carrier organic anion transporter family member', 352, NULL, NULL, 209733),
(209734, '2.60.40.10-FF-001517', NULL, 'Cytokine receptor common subunit beta', 100, NULL, NULL, 209734),
(209735, '1.50.40.10-FF-000036', NULL, 'Mitochondrial glycine transporter B', 276, NULL, NULL, 209735),
(209736, '3.20.20.190-FF-000117', NULL, NULL, 167, NULL, NULL, 209736),
(209737, '1.10.10.2420-FF-000002', NULL, 'Glutaminyl-tRNA synthetase, putative', 68, NULL, NULL, 209737),
(209738, '3.40.50.150-FF-000101', NULL, 'Thiopurine S-methyltransferase', 228, NULL, NULL, 209738),
(209739, '3.90.70.80-FF-000047', NULL, 'Uncharacterized protein', 169, NULL, NULL, 209739),
(209740, '1.20.1270.60-FF-000045', NULL, 'Cell division control protein', 272, NULL, NULL, 209740),
(209741, '1.10.1520.10-FF-000069', NULL, 'Uncharacterized protein', 163, NULL, NULL, 209741),
(209742, '1.25.40.10-FF-000628', NULL, 'protein CTR9 homolog', 144, NULL, NULL, 209742),
(209743, '3.90.640.10-FF-000289', NULL, 'DnaK protein', 84, NULL, NULL, 209743),
(209744, '3.10.20.90-FF-000230', NULL, 'Sorting nexin 31', 98, NULL, NULL, 209744),
(209745, '3.30.70.330-FF-000914', NULL, 'Eukaryotic translation initiation factor 3 subunit G', 142, NULL, NULL, 209745),
(209746, '1.10.3730.20-FF-000026', NULL, 'Solute carrier family 35, member G1', 131, NULL, NULL, 209746),
(209747, '3.30.420.10-FF-000202', NULL, 'Ribonuclease H1, putative', 175, NULL, NULL, 209747),
(209748, '2.130.10.10-FF-005862', NULL, 'Uncharacterized protein', 315, NULL, NULL, 209748),
(209749, '3.60.10.10-FF-000428', NULL, 'Putative inositol polyphosphate phosphatase (Synaptogenin-like) family protein', 94, NULL, NULL, 209749),
(209750, '1.20.920.10-FF-000093', NULL, 'Transcription factor GTE6', 157, NULL, NULL, 209750),
(209751, '3.80.10.10-FF-002743', NULL, 'Predicted protein', 326, NULL, NULL, 209751),
(209752, '3.30.70.80-FF-000010', NULL, 'Uncharacterized protein', 81, NULL, NULL, 209752),
(209753, '3.90.1140.10-FF-000048', NULL, 'Uncharacterized protein', 61, NULL, NULL, 209753),
(209754, '2.170.300.10-FF-000080', NULL, 'Uncharacterized protein', 120, NULL, NULL, 209754),
(209755, '2.60.120.290-FF-000065', NULL, 'Uncharacterized protein, isoform E', 154, NULL, NULL, 209755),
(209756, '1.10.10.2430-FF-000005', NULL, 'Uncharacterized protein', 61, NULL, NULL, 209756),
(209757, '3.30.160.20-FF-000140', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 2', 82, NULL, NULL, 209757),
(209758, '3.30.460.10-FF-000148', NULL, 'Uncharacterized protein', 86, NULL, NULL, 209758),
(209759, '1.25.40.10-FF-003181', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 103, NULL, NULL, 209759),
(209760, '3.40.50.410-FF-000314', NULL, 'Integrin beta', 119, NULL, NULL, 209760),
(209761, '1.20.90.10-FF-000018', NULL, 'Phospholipase A(2)', 118, NULL, NULL, 209761),
(209762, '2.30.39.10-FF-000003', NULL, 'alpha-1-antitrypsin isoform X1', 95, NULL, NULL, 209762);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(209763, '3.90.1290.10-FF-000002', NULL, 'Plectin a', 214, NULL, NULL, 209763),
(209764, '1.20.58.340-FF-000080', NULL, 'Uncharacterized protein', 112, NULL, NULL, 209764),
(209765, '2.30.30.60-FF-000004', NULL, 'Transporter, small conductance mechanosensitive ion channel family', 51, NULL, NULL, 209765),
(209766, '2.20.100.10-FF-000246', NULL, 'plasminogen-like', 60, NULL, NULL, 209766),
(209767, '3.40.20.10-FF-000036', NULL, 'Protein transport protein SEC23', 98, NULL, NULL, 209767),
(209768, '3.50.50.60-FF-000777', NULL, 'Flavin-containing monooxygenase', 116, NULL, NULL, 209768),
(209769, '2.40.50.140-FF-000810', NULL, NULL, 180, NULL, NULL, 209769),
(209770, '2.30.30.50-FF-000001', NULL, 'Photosystem I reaction center subunit IV, chloroplastic', 68, NULL, NULL, 209770),
(209771, '2.120.10.30-FF-000248', NULL, 'Uncharacterized protein', 273, NULL, NULL, 209771),
(209772, '3.40.190.120-FF-000009', NULL, 'Proline/glycine betaine ABC superfamily ATP binding cassette transporter, membrane protein', 104, NULL, NULL, 209772),
(209773, '1.10.630.10-FF-000483', NULL, 'Uncharacterized protein', 474, NULL, NULL, 209773),
(209774, '1.10.510.10-FF-001227', NULL, 'Tyrosine-protein kinase receptor', 195, NULL, NULL, 209774),
(209775, '3.40.630.30-FF-000261', NULL, 'N-alpha-acetyltransferase 10-like isoform X3', 116, NULL, NULL, 209775),
(209776, '3.40.50.2000-FF-000419', NULL, 'Putative glycosyltransferase', 176, NULL, NULL, 209776),
(209777, '3.60.40.10-FF-000317', NULL, 'Uncharacterized protein', 216, NULL, NULL, 209777),
(209778, '1.20.58.60-FF-000481', NULL, 'Spectrin repeat containing, nuclear envelope 1a', 313, NULL, NULL, 209778),
(209779, '3.30.160.60-FF-003237', NULL, 'Si:ch211-269m15.3', 28, NULL, NULL, 209779),
(209780, '3.40.50.2000-FF-000245', NULL, 'Lipid-A-disaccharide synthase', 202, NULL, NULL, 209780),
(209781, '3.30.760.10-FF-000047', NULL, 'Uncharacterized protein', 181, NULL, NULL, 209781),
(209782, '1.25.10.10-FF-000891', NULL, 'VAC14p Enzyme regulator', 100, NULL, NULL, 209782),
(209783, '1.25.10.10-FF-002717', NULL, 'Uncharacterized protein', 971, NULL, NULL, 209783),
(209784, '3.40.250.10-FF-000057', NULL, 'Cysteine synthase B, putative', 122, NULL, NULL, 209784),
(209785, '3.30.70.330-FF-003141', NULL, NULL, 80, NULL, NULL, 209785),
(209786, '1.10.150.50-FF-000008', NULL, 'Neurabin-1 isoform 1-like protein', 74, NULL, NULL, 209786),
(209787, '1.10.150.40-FF-000005', NULL, 'Barrier-to-autointegration factor 1', 88, NULL, NULL, 209787),
(209788, '3.90.190.10-FF-000299', NULL, 'Triacylglycerol lipase', 198, NULL, NULL, 209788),
(209789, '1.20.58.60-FF-000716', NULL, 'Dystonin', 109, NULL, NULL, 209789),
(209790, '3.30.40.10-FF-000268', NULL, 'E3 ubiquitin-protein ligase NRDP1', 76, NULL, NULL, 209790),
(209791, '3.40.50.10730-FF-000007', NULL, 'Uncharacterized protein', 164, NULL, NULL, 209791),
(209792, '1.20.120.350-FF-000020', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 140, NULL, NULL, 209792),
(209793, '1.20.1280.50-FF-000014', NULL, 'F-box only protein 8', 58, NULL, NULL, 209793),
(209794, '3.40.850.10-FF-000086', NULL, 'kinesin-like protein KIN-14F', 375, NULL, NULL, 209794),
(209795, '3.40.50.1820-FF-000820', NULL, 'Triacylglycerol lipase', 337, NULL, NULL, 209795),
(209796, '3.40.190.10-FF-000086', NULL, 'Probable porphobilinogen deaminase', 104, NULL, NULL, 209796),
(209797, '3.30.70.330-FF-002393', NULL, NULL, 97, NULL, NULL, 209797),
(209798, '2.60.40.10-FF-001843', NULL, 'KETtiN (Drosophila actin-binding) homolog', 114, NULL, NULL, 209798),
(209799, '1.20.58.150-FF-000023', NULL, NULL, 49, NULL, NULL, 209799),
(209800, '3.40.930.10-FF-000002', NULL, 'Anion exchange protein', 306, NULL, NULL, 209800),
(209801, '3.30.342.10-FF-000037', NULL, 'DNA polymerase', 168, NULL, NULL, 209801),
(209802, '3.40.50.11500-FF-000014', NULL, 'DENN (AEX-3) domain containing protein', 171, NULL, NULL, 209802),
(209803, '3.60.40.10-FF-000082', NULL, 'Protein phosphatase, Mg2+/Mn2+ dependent 1J', 248, NULL, NULL, 209803),
(209804, '2.60.40.350-FF-000001', NULL, 'Envelope glycoprotein', 109, NULL, NULL, 209804);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(209805, '3.30.920.10-FF-000021', NULL, 'Uncharacterized protein', 116, NULL, NULL, 209805),
(209806, '1.25.10.10-FF-003353', NULL, 'Uncharacterized protein', 206, NULL, NULL, 209806),
(209807, '2.60.40.10-FF-005412', NULL, NULL, 85, NULL, NULL, 209807),
(209808, '3.40.309.10-FF-000076', NULL, 'Aldehyde dehydrogenase', 196, NULL, NULL, 209808),
(209809, '2.60.98.20-FF-000012', NULL, 'Flagellar hook protein FlgE', 163, NULL, NULL, 209809),
(209810, '3.10.180.10-FF-000064', NULL, 'Lactoylglutathione lyase family protein', 148, NULL, NULL, 209810),
(209811, '3.40.630.60-FF-000011', NULL, NULL, 121, NULL, NULL, 209811),
(209812, '3.40.50.300-FF-003507', NULL, 'dCMP deaminase, putative', 189, NULL, NULL, 209812),
(209813, '2.130.10.10-FF-003653', NULL, 'Chromosome 1, whole genome shotgun sequence', 159, NULL, NULL, 209813),
(209814, '2.80.10.50-FF-000003', NULL, 'recombining binding protein suppressor of hairless', 158, NULL, NULL, 209814),
(209815, '3.30.1490.20-FF-000080', NULL, 'Predicted protein', 98, NULL, NULL, 209815),
(209816, '1.20.59.10-FF-000007', NULL, 'Secreted chorismate mutase', 166, NULL, NULL, 209816),
(209817, '3.80.10.10-FF-004188', NULL, 'Uncharacterized protein', 94, NULL, NULL, 209817),
(209818, '3.30.9.10-FF-000235', NULL, 'Predicted protein', 59, NULL, NULL, 209818),
(209819, '3.30.505.10-FF-000051', NULL, 'Tyrosine-protein kinase', 115, NULL, NULL, 209819),
(209820, '3.30.160.60-FF-001972', NULL, 'Zinc finger protein 574', 25, NULL, NULL, 209820),
(209821, '1.10.472.80-FF-000085', NULL, 'TBC domain containing protein', 145, NULL, NULL, 209821),
(209822, '3.40.50.300-FF-001916', NULL, 'Mitochondrial GTPase (Mss1), putative', 214, NULL, NULL, 209822),
(209823, '2.30.29.30-FF-000363', NULL, 'Putative E3 ubiquitin-protein ligase HERC1', 121, NULL, NULL, 209823),
(209824, '1.20.58.900-FF-000028', NULL, 'Uncharacterized protein', 177, NULL, NULL, 209824),
(209825, '2.130.10.10-FF-005536', NULL, 'Uncharacterized WD repeat-containing protein C1306.02', 267, NULL, NULL, 209825),
(209826, '3.40.50.300-FF-006998', NULL, 'Uncharacterized protein', 366, NULL, NULL, 209826),
(209827, '1.25.40.470-FF-000025', NULL, 'GL24573', 154, NULL, NULL, 209827),
(209828, '1.20.58.830-FF-000013', NULL, 'Erythrocyte binding antigen-140', 122, NULL, NULL, 209828),
(209829, '3.20.20.80-FF-000440', NULL, 'Acidic endochitinase', 270, NULL, NULL, 209829),
(209830, '3.50.50.60-FF-000570', NULL, 'Dimethylglycine dehydrogenase', 134, NULL, NULL, 209830),
(209831, '3.30.420.10-FF-000382', NULL, NULL, 134, NULL, NULL, 209831),
(209832, '1.10.287.70-FF-000680', NULL, 'Potassium voltage-gated channel subfamily H member 2', 90, NULL, NULL, 209832),
(209833, '3.30.40.10-FF-001016', NULL, 'SNF2 domain-containing protein', 98, NULL, NULL, 209833),
(209834, '1.10.510.10-FF-001845', NULL, 'Serine/threonine protein kinase, variant', 96, NULL, NULL, 209834),
(209835, '2.30.42.10-FF-000348', NULL, 'Rubredoxin family protein', 65, NULL, NULL, 209835),
(209836, '3.30.160.60-FF-005715', NULL, NULL, 40, NULL, NULL, 209836),
(209837, '1.20.1260.10-FF-000052', NULL, 'Putative ferritin heavy polypeptide-like 19', 159, NULL, NULL, 209837),
(209838, '1.10.238.10-FF-000610', NULL, 'EF-hand domain pair/EF-hand domain/EF hand, putative', 87, NULL, NULL, 209838),
(209839, '1.25.40.10-FF-003034', NULL, 'Pentatricopeptide repeat-containing protein At3g42630', 99, NULL, NULL, 209839),
(209840, '3.40.50.300-FF-007223', NULL, 'Uncharacterized protein', 163, NULL, NULL, 209840),
(209841, '3.30.2260.10-FF-000003', NULL, 'Enhancer of rudimentary homolog', 97, NULL, NULL, 209841),
(209842, '1.10.287.770-FF-000013', NULL, 'GL19333', 59, NULL, NULL, 209842),
(209843, '1.10.246.140-FF-000012', NULL, 'Transcription and mRNA export factor ENY2', 95, NULL, NULL, 209843),
(209844, '1.50.10.10-FF-000208', NULL, 'alpha-1,2-Mannosidase', 181, NULL, NULL, 209844),
(209845, '3.30.1490.80-FF-000018', NULL, 'Glutathione synthetase', 65, NULL, NULL, 209845),
(209846, '1.25.40.1040-FF-000042', NULL, 'Uncharacterized protein', 381, NULL, NULL, 209846),
(209847, '3.20.20.80-FF-000086', NULL, '1,3-beta-glucanosyltransferase', 367, NULL, NULL, 209847);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(209848, '2.10.60.10-FF-000059', NULL, 'Receptor protein serine/threonine kinase', 85, NULL, NULL, 209848),
(209849, '2.60.40.10-FF-004923', NULL, NULL, 86, NULL, NULL, 209849),
(209850, '1.10.10.2380-FF-000001', NULL, 'Cell division control protein 13', 65, NULL, NULL, 209850),
(209851, '2.70.160.11-FF-000065', NULL, 'Predicted protein', 180, NULL, NULL, 209851),
(209852, '1.20.58.60-FF-000155', NULL, 'nesprin-1 isoform X4', 312, NULL, NULL, 209852),
(209853, '3.10.20.90-FF-000876', NULL, 'Uncharacterized protein (Fragment)', 64, NULL, NULL, 209853),
(209854, '1.10.287.3240-FF-000025', NULL, 'Uncharacterized protein', 213, NULL, NULL, 209854),
(209855, '2.120.10.30-FF-000574', NULL, 'tripartite motif-containing protein 3-like', 198, NULL, NULL, 209855),
(209856, '2.40.70.10-FF-000519', NULL, NULL, 61, NULL, NULL, 209856),
(209857, '3.40.850.10-FF-000440', NULL, 'Uncharacterized protein', 134, NULL, NULL, 209857),
(209858, '3.30.70.360-FF-000018', NULL, 'N-acyl-L-amino acid amidohydrolase AmiA1', 115, NULL, NULL, 209858),
(209859, '1.25.40.10-FF-005007', NULL, 'Uncharacterized protein', 122, NULL, NULL, 209859),
(209860, '3.80.20.20-FF-000066', NULL, 'Predicted protein', 168, NULL, NULL, 209860),
(209861, '3.40.50.300-FF-005278', NULL, 'Septin-7', 290, NULL, NULL, 209861),
(209862, '1.10.3370.10-FF-000006', NULL, 'Sec61 translocon alpha 2 subunit', 143, NULL, NULL, 209862),
(209863, '3.40.1810.10-FF-000015', NULL, 'MADS-box transcription factor 32', 72, NULL, NULL, 209863),
(209864, '2.60.120.200-FF-000639', NULL, 'Uncharacterized protein', 114, NULL, NULL, 209864),
(209865, '1.20.5.170-FF-000147', NULL, 'fos-related antigen 2 isoform X1', 37, NULL, NULL, 209865),
(209866, '1.20.5.110-FF-000062', NULL, 'Cell division coordinator CpoB', 81, NULL, NULL, 209866),
(209867, '1.20.1560.10-FF-000417', NULL, 'SPbeta prophage-derived sublancin-168-processing and transport ATP-binding protein SunT', 308, NULL, NULL, 209867),
(209868, '2.60.120.10-FF-000221', NULL, 'Mannose-6-phosphate isomerase, class I', 198, NULL, NULL, 209868),
(209869, '3.40.50.10190-FF-000211', NULL, 'AGAP002760-PA', 98, NULL, NULL, 209869),
(209870, '2.160.10.10-FF-000089', NULL, 'Putative lipopolysaccharide biosynthesis O-acetyl transferase WbbJ', 171, NULL, NULL, 209870),
(209871, '1.25.40.10-FF-000954', NULL, 'LOW protein: PPR containing-like protein', 100, NULL, NULL, 209871),
(209872, '2.102.10.10-FF-000018', NULL, 'Putative biphenyl dioxygenase system ferredoxin component', 102, NULL, NULL, 209872),
(209873, '1.25.40.20-FF-001446', NULL, 'Uncharacterized protein', 138, NULL, NULL, 209873),
(209874, '1.10.150.50-FF-000160', NULL, 'stromal interaction molecule homolog isoform X3', 66, NULL, NULL, 209874),
(209875, '1.10.555.10-FF-000240', NULL, NULL, 257, NULL, NULL, 209875),
(209876, '1.20.120.1880-FF-000014', NULL, 'Chromosome 10, whole genome shotgun sequence', 245, NULL, NULL, 209876),
(209877, '1.10.287.70-FF-000062', NULL, 'Two pore calcium channel protein 1', 131, NULL, NULL, 209877),
(209878, '3.30.110.170-FF-000005', NULL, 'interleukin-1 receptor-associated kinase 1-binding protein 1-like', 103, NULL, NULL, 209878),
(209879, '3.60.15.10-FF-000097', NULL, 'MBL fold metallo-hydrolase', 190, NULL, NULL, 209879),
(209880, '3.30.420.390-FF-000017', NULL, NULL, 54, NULL, NULL, 209880),
(209881, '2.60.40.10-FF-002978', NULL, 'Thioester-containing protein 2, isoform D', 105, NULL, NULL, 209881),
(209882, '2.40.30.10-FF-000399', NULL, 'Pyruvate dehydrogenase [NADP(+)], mitochondrial', 91, NULL, NULL, 209882),
(209883, '1.20.1070.10-FF-001324', NULL, 'Predicted protein', 183, NULL, NULL, 209883),
(209884, '3.80.10.10-FF-003878', NULL, 'NLR family, CARD domain-containing 3', 177, NULL, NULL, 209884),
(209885, '1.25.40.20-FF-000957', NULL, 'Transient receptor potential cation channel subfamily V member 1', 108, NULL, NULL, 209885),
(209886, '3.30.1490.70-FF-000015', NULL, 'Uncharacterized protein', 60, NULL, NULL, 209886),
(209887, '1.10.150.20-FF-000084', NULL, 'ERCC1 nucleotide excision repair protein, putative', 81, NULL, NULL, 209887);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(209888, '1.10.569.10-FF-000002', NULL, 'Aldehyde ferredoxin oxidoreductase', 202, NULL, NULL, 209888),
(209889, '1.20.1070.10-FF-000835', NULL, 'Vomeronasal type-1 receptor', 300, NULL, NULL, 209889),
(209890, '3.70.10.10-FF-000113', NULL, 'Predicted protein', 248, NULL, NULL, 209890),
(209891, '3.40.50.12470-FF-000007', NULL, '2-oxoglutarate dehydrogenase e1 mitochondrial', 273, NULL, NULL, 209891),
(209892, '3.40.50.10130-FF-000007', NULL, 'Probable crossover junction endonuclease EME2', 191, NULL, NULL, 209892),
(209893, '1.20.1080.10-FF-000072', NULL, 'Aquaporin TIP4-1', 97, NULL, NULL, 209893),
(209894, '3.10.290.10-FF-000100', NULL, '37S ribosomal protein S4-like, mitochondrial', 59, NULL, NULL, 209894),
(209895, '1.20.1560.10-FF-000209', NULL, 'ATP-binding cassette sub-family B member 9 isoform X2', 40, NULL, NULL, 209895),
(209896, '1.10.510.10-FF-003970', NULL, NULL, 341, NULL, NULL, 209896),
(209897, '3.30.160.60-FF-001354', NULL, 'RB-associated KRAB zinc finger protein-like', 33, NULL, NULL, 209897),
(209898, '2.60.40.10-FF-001343', NULL, 'titin isoform X1', 99, NULL, NULL, 209898),
(209899, '2.10.90.10-FF-000033', NULL, 'Muellerian-inhibiting factor', 111, NULL, NULL, 209899),
(209900, '1.10.238.10-FF-001274', NULL, 'Uncharacterized calcium-binding protein C800.10c', 112, NULL, NULL, 209900),
(209901, '3.30.70.1070-FF-000002', NULL, 'Cell division protein FtsN', 81, NULL, NULL, 209901),
(209902, '1.10.150.20-FF-000319', NULL, 'DNA-directed RNA polymerase subunit alpha', 77, NULL, NULL, 209902),
(209903, '3.30.470.20-FF-000157', NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta, mitochondrial', 134, NULL, NULL, 209903),
(209904, '1.10.630.10-FF-000365', NULL, 'Probable lanosterol 14-alpha demethylase', 450, NULL, NULL, 209904),
(209905, '3.60.40.10-FF-000290', NULL, 'Uncharacterized protein', 95, NULL, NULL, 209905),
(209906, '2.40.420.20-FF-000021', NULL, 'AcrA/AcrE family protein', 81, NULL, NULL, 209906),
(209907, '3.40.50.300-FF-001181', NULL, 'DNA helicase', 94, NULL, NULL, 209907),
(209908, '2.40.50.90-FF-000148', NULL, 'Uncharacterized protein', 38, NULL, NULL, 209908),
(209909, '2.130.10.10-FF-005098', NULL, 'Katanin p80 WD40 repeat-containing subunit B1 homolog', 253, NULL, NULL, 209909),
(209910, '3.40.50.300-FF-005396', NULL, 'Uncharacterized protein', 244, NULL, NULL, 209910),
(209911, '1.10.3730.30-FF-000001', NULL, 'Toxin A', 100, NULL, NULL, 209911),
(209912, '3.40.30.10-FF-000273', NULL, 'Glutaredoxin family protein', 99, NULL, NULL, 209912),
(209913, '2.30.29.30-FF-000155', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', 126, NULL, NULL, 209913),
(209914, '3.40.50.1110-FF-000107', NULL, 'O-antigen acetylase', 181, NULL, NULL, 209914),
(209915, '3.30.230.10-FF-000373', NULL, 'Uncharacterized protein', 69, NULL, NULL, 209915),
(209916, '3.40.50.150-FF-001321', NULL, NULL, 205, NULL, NULL, 209916),
(209917, '3.40.366.10-FF-000045', NULL, 'Malonyl CoA-acyl carrier protein transacylase', 206, NULL, NULL, 209917),
(209918, '1.10.10.10-FF-001109', NULL, 'Transcriptional regulator, BadM/Rrf2 family', 131, NULL, NULL, 209918),
(209919, '3.30.420.10-FF-000117', NULL, 'DNA polymerase III polC-type', 173, NULL, NULL, 209919),
(209920, '3.30.420.10-FF-000174', NULL, 'Cation-transporting ATPase', 219, NULL, NULL, 209920),
(209921, '1.10.10.750-FF-000046', NULL, 'Predicted protein', 38, NULL, NULL, 209921),
(209922, '1.10.1060.10-FF-000022', NULL, 'CoB--CoM heterodisulfide reductase iron-sulfur subunit C', 101, NULL, NULL, 209922),
(209923, '2.60.40.10-FF-002006', NULL, 'Probable fimbrial chaperone YadV', 94, NULL, NULL, 209923),
(209924, '2.10.80.10-FF-000004', NULL, 'Prokineticin 1', 80, NULL, NULL, 209924),
(209925, '1.20.960.10-FF-000005', NULL, 'Uncharacterized protein', 93, NULL, NULL, 209925),
(209926, '2.10.25.10-FF-000017', NULL, 'latent-transforming growth factor beta-binding protein 4 isoform X1', 42, NULL, NULL, 209926),
(209927, '3.30.70.330-FF-002831', NULL, NULL, 140, NULL, NULL, 209927),
(209928, '3.10.20.90-FF-000112', NULL, 'TANK binding kinase TBK1', 77, NULL, NULL, 209928);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(209929, '2.130.10.10-FF-004547', NULL, 'Uncharacterized protein', 219, NULL, NULL, 209929),
(209930, '3.40.50.1100-FF-000104', NULL, 'Cysteate synthase', 237, NULL, NULL, 209930),
(209931, '2.10.25.10-FF-001006', NULL, 'Nimrod C2, isoform B', 32, NULL, NULL, 209931),
(209932, '3.40.50.2300-FF-001234', NULL, NULL, 114, NULL, NULL, 209932),
(209933, '2.60.120.10-FF-000103', NULL, 'Cyclic nucleotide-binding domain protein', 149, NULL, NULL, 209933),
(209934, '2.30.39.10-FF-000121', NULL, 'SERPINB5 protein', 77, NULL, NULL, 209934),
(209935, '1.25.40.10-FF-003242', NULL, 'Transcription factor TFIIIC subunit', 181, NULL, NULL, 209935),
(209936, '2.60.120.10-FF-000160', NULL, 'Cysteine dioxygenase type I', 178, NULL, NULL, 209936),
(209937, '3.90.105.20-FF-000021', NULL, 'Uncharacterized protein', 24, NULL, NULL, 209937),
(209938, '3.60.70.12-FF-000013', NULL, 'Uncharacterized protein', 73, NULL, NULL, 209938),
(209939, '3.40.190.170-FF-000002', NULL, 'TRAP transporter substrate-binding protein', 300, NULL, NULL, 209939),
(209940, '3.40.50.1820-FF-000174', NULL, 'Predicted protein', 298, NULL, NULL, 209940),
(209941, '1.20.1250.20-FF-001982', NULL, 'Uncharacterized protein', 393, NULL, NULL, 209941),
(209942, '3.90.1480.20-FF-000014', NULL, 'Alpha-N-acetylneuraminide alpha-2,8-sialyltransferase', 283, NULL, NULL, 209942),
(209943, '1.10.287.110-FF-000102', NULL, 'Molecular chaperone DnaJ', 87, NULL, NULL, 209943),
(209944, '3.40.50.300-FF-002170', NULL, 'Adenylate kinase', 180, NULL, NULL, 209944),
(209945, '1.20.58.60-FF-000363', NULL, 'Nesprin-2', 146, NULL, NULL, 209945),
(209946, '1.10.10.10-FF-001643', NULL, 'Uncharacterized protein', 83, NULL, NULL, 209946),
(209947, '3.40.720.10-FF-000110', NULL, 'Phosphatidylinositol glycan, class O', 211, NULL, NULL, 209947),
(209948, '3.40.630.30-FF-000143', NULL, '[Ribosomal protein S18]-alanine N-acetyltransferase', 139, NULL, NULL, 209948),
(209949, '1.25.40.90-FF-000079', NULL, 'Uncharacterized protein', 136, NULL, NULL, 209949),
(209950, '3.60.10.10-FF-000254', NULL, 'Uncharacterized protein', 378, NULL, NULL, 209950),
(209951, '1.25.40.70-FF-000073', NULL, 'Uncharacterized protein', 214, NULL, NULL, 209951),
(209952, '2.40.30.330-FF-000003', NULL, 'mRNA cleavage and polyadenylation factor CLP1', 103, NULL, NULL, 209952),
(209953, '2.60.120.290-FF-000211', NULL, 'Uncharacterized protein', 117, NULL, NULL, 209953),
(209954, '1.20.1070.10-FF-000189', NULL, 'Histamine H1 receptor', 239, NULL, NULL, 209954),
(209955, '3.80.10.10-FF-000826', NULL, 'Receptor-like protein kinase 2', 159, NULL, NULL, 209955),
(209956, '1.10.720.30-FF-000024', NULL, 'E3 ubiquitin-protein ligase RAD18 isoform X1', 68, NULL, NULL, 209956),
(209957, '3.40.50.300-FF-001708', NULL, 'DNA helicase', 148, NULL, NULL, 209957),
(209958, '2.130.10.10-FF-001321', NULL, '6-phosphogluconolactonase (Cycloisomerase 2 family)', 383, NULL, NULL, 209958),
(209959, '3.30.930.10-FF-000139', NULL, 'O-phosphoserine--tRNA(Cys) ligase', 315, NULL, NULL, 209959),
(209960, '1.25.40.10-FF-002837', NULL, 'Pentatricopeptide repeat-containing protein', 136, NULL, NULL, 209960),
(209961, '3.30.710.10-FF-000421', NULL, 'Protein CBG06295', 113, NULL, NULL, 209961),
(209962, '2.60.40.420-FF-000281', NULL, 'Uncharacterized protein', 46, NULL, NULL, 209962),
(209963, '3.40.640.10-FF-000486', NULL, 'Predicted protein', 51, NULL, NULL, 209963),
(209964, '1.20.80.10-FF-000079', NULL, 'Uncharacterized protein', 96, NULL, NULL, 209964),
(209965, '1.20.140.160-FF-000001', NULL, 'RNA polymerase sigma factor FliA', 154, NULL, NULL, 209965),
(209966, '2.60.40.10-FF-002332', NULL, 'Myotactin form A', 119, NULL, NULL, 209966),
(209967, '1.25.10.10-FF-001228', NULL, 'Hypothetical_protein_-_conserved', 212, NULL, NULL, 209967),
(209968, '3.40.190.10-FF-000378', NULL, 'Phosphonate ABC transporter substrate-binding protein', 124, NULL, NULL, 209968),
(209969, '1.10.510.10-FF-003436', NULL, NULL, 284, NULL, NULL, 209969),
(209970, '3.30.40.10-FF-000706', NULL, 'AGAP000533-PA', 111, NULL, NULL, 209970),
(209971, '2.60.40.10-FF-005766', NULL, NULL, 111, NULL, NULL, 209971);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(209972, '1.10.10.2740-FF-000008', NULL, 'Uncharacterized protein', 86, NULL, NULL, 209972),
(209973, '2.10.25.10-FF-000489', NULL, 'CD248 molecule', 41, NULL, NULL, 209973),
(209974, '1.25.10.10-FF-003206', NULL, 'Serine/threonine-protein kinase TOR', 280, NULL, NULL, 209974),
(209975, '1.25.40.10-FF-000746', NULL, 'Zgc:152670', 129, NULL, NULL, 209975),
(209976, '3.40.50.300-FF-003480', NULL, 'ATPase, AAA family protein', 190, NULL, NULL, 209976),
(209977, '2.60.120.970-FF-000022', NULL, 'Inhibin subunit beta C', 152, NULL, NULL, 209977),
(209978, '2.30.280.10-FF-000003', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-9 specific SUVH5', 182, NULL, NULL, 209978),
(209979, '2.60.40.2610-FF-000008', NULL, NULL, 89, NULL, NULL, 209979),
(209980, '2.30.30.140-FF-000027', NULL, 'putative oxidoreductase GLYR1 isoform X1', 101, NULL, NULL, 209980),
(209981, '3.30.160.60-FF-005154', NULL, NULL, 32, NULL, NULL, 209981),
(209982, '1.25.40.20-FF-000749', NULL, 'Uncharacterized protein', 307, NULL, NULL, 209982),
(209983, '3.40.50.150-FF-001736', NULL, NULL, 196, NULL, NULL, 209983),
(209984, '3.40.1160.10-FF-000105', NULL, 'Isopentenyl phosphate kinase', 260, NULL, NULL, 209984),
(209985, '3.40.50.2000-FF-000099', NULL, 'Alpha,alpha-trehalose phosphate synthase subunit, putative', 254, NULL, NULL, 209985),
(209986, '1.10.287.10-FF-000004', NULL, 'bifunctional glutamate/proline--tRNA ligase', 57, NULL, NULL, 209986),
(209987, '1.10.1670.10-FF-000052', NULL, NULL, 105, NULL, NULL, 209987),
(209988, '3.40.50.150-FF-001793', NULL, NULL, 160, NULL, NULL, 209988),
(209989, '1.20.1280.170-FF-000014', NULL, 'Exocyst subunit Exo70 family protein', 214, NULL, NULL, 209989),
(209990, '1.25.40.20-FF-001800', NULL, 'Predicted protein', 167, NULL, NULL, 209990),
(209991, '1.20.1270.60-FF-000163', NULL, 'AGAP009727-PA', 217, NULL, NULL, 209991),
(209992, '3.40.50.410-FF-000140', NULL, 'Uncharacterized protein (Fragment)', 204, NULL, NULL, 209992),
(209993, '3.30.980.10-FF-000030', NULL, 'Uncharacterized protein', 71, NULL, NULL, 209993),
(209994, '4.10.1220.10-FF-000004', NULL, 'Low density lipoprotein receptor-related protein 1Bb', 31, NULL, NULL, 209994),
(209995, '3.40.470.10-FF-000040', NULL, NULL, 92, NULL, NULL, 209995),
(209996, '3.30.519.10-FF-000049', NULL, NULL, 41, NULL, NULL, 209996),
(209997, '3.30.750.24-FF-000173', NULL, 'Uncharacterized protein', 79, NULL, NULL, 209997),
(209998, '1.25.10.10-FF-002897', NULL, 'Ipo7 protein', 138, NULL, NULL, 209998),
(209999, '1.20.1740.10-FF-000162', NULL, 'Uncharacterized protein', 433, NULL, NULL, 209999),
(210000, '2.60.40.3710-FF-000001', NULL, 'L,D-transpeptidase 2', 120, NULL, NULL, 210000),
(210001, '3.100.10.10-FF-000037', NULL, NULL, 25, NULL, NULL, 210001),
(210002, '3.40.50.10190-FF-000126', NULL, 'Epithelial cell-transforming 2', 100, NULL, NULL, 210002),
(210003, '1.10.10.10-FF-000828', NULL, 'LysR family transcriptional regulator', 86, NULL, NULL, 210003),
(210004, '2.130.10.10-FF-004755', NULL, 'Protein HIRA homolog-like Protein', 158, NULL, NULL, 210004),
(210005, '3.40.50.300-FF-008004', NULL, 'MutS homolog1', 148, NULL, NULL, 210005),
(210006, '3.40.50.10050-FF-000017', NULL, 'Translation initiation factor IF-2, mitochondrial-like Protein', 106, NULL, NULL, 210006),
(210007, '3.30.70.330-FF-002567', NULL, NULL, 190, NULL, NULL, 210007),
(210008, '3.20.20.140-FF-000361', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 272, NULL, NULL, 210008),
(210009, '1.10.10.60-FF-001310', NULL, NULL, 61, NULL, NULL, 210009),
(210010, '1.10.10.41-FF-000001', NULL, 'DNA topoisomerase I', 88, NULL, NULL, 210010),
(210011, '2.160.20.10-FF-000179', NULL, 'Uncharacterized protein', 131, NULL, NULL, 210011),
(210012, '3.20.20.140-FF-000243', NULL, 'Amidohydrolase', 281, NULL, NULL, 210012),
(210013, '3.80.10.10-FF-003906', NULL, 'Uncharacterized protein', 127, NULL, NULL, 210013),
(210014, '3.80.10.10-FF-001107', NULL, 'Leucine rich repeats and immunoglobulin like domains 1', 101, NULL, NULL, 210014),
(210015, '3.30.160.60-FF-001028', NULL, 'hypermethylated in cancer 2 protein-like', 27, NULL, NULL, 210015);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(210016, '1.10.1200.10-FF-000056', NULL, 'Membrane bound polyketide synthase Pks6', 84, NULL, NULL, 210016),
(210017, '2.60.40.10-FF-003760', NULL, NULL, 88, NULL, NULL, 210017),
(210018, '3.40.50.10380-FF-000032', NULL, 'Malic enzyme', 228, NULL, NULL, 210018),
(210019, '1.10.630.10-FF-000157', NULL, 'Uncharacterized protein', 263, NULL, NULL, 210019),
(210020, '3.30.1050.10-FF-000049', NULL, 'Alkyl sulfatase', 132, NULL, NULL, 210020),
(210021, '3.40.50.450-FF-000101', NULL, 'ATP-dependent 6-phosphofructokinase', 164, NULL, NULL, 210021),
(210022, '1.10.510.10-FF-001671', NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', 307, NULL, NULL, 210022),
(210023, '2.60.40.10-FF-003642', NULL, NULL, 110, NULL, NULL, 210023),
(210024, '2.60.40.420-FF-000129', NULL, 'GD21245', 194, NULL, NULL, 210024),
(210025, '2.60.40.10-FF-004777', NULL, NULL, 87, NULL, NULL, 210025),
(210026, '2.10.25.10-FF-000074', NULL, 'Laminin subunit alpha', 47, NULL, NULL, 210026),
(210027, '3.40.50.1820-FF-001601', NULL, 'Uncharacterized protein', 80, NULL, NULL, 210027),
(210028, '2.60.120.200-FF-000286', NULL, 'Basement membrane proteoglycan', 185, NULL, NULL, 210028),
(210029, '3.30.160.60-FF-000949', NULL, 'zinc finger homeobox protein 2', 27, NULL, NULL, 210029),
(210030, '1.25.40.10-FF-005097', NULL, 'Predicted protein', 266, NULL, NULL, 210030),
(210031, '3.20.20.80-FF-000378', NULL, 'Alpha-amylase', 173, NULL, NULL, 210031),
(210032, '3.50.50.60-FF-001351', NULL, 'Flavin-containing monooxygenase', 111, NULL, NULL, 210032),
(210033, '3.40.50.720-FF-000435', NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', 205, NULL, NULL, 210033),
(210034, '3.40.630.10-FF-000457', NULL, 'Uncharacterized protein', 146, NULL, NULL, 210034),
(210035, '1.20.1070.10-FF-002134', NULL, 'Uncharacterized protein', 257, NULL, NULL, 210035),
(210036, '1.25.10.10-FF-000918', NULL, 'Testis-expressed protein 10 homolog', 151, NULL, NULL, 210036),
(210037, '1.10.8.10-FF-000142', NULL, 'Tyrosyl-DNA phosphodiesterase 2', 85, NULL, NULL, 210037),
(210038, '3.30.200.20-FF-000548', NULL, 'Z-DNA binding protein kinase', 106, NULL, NULL, 210038),
(210039, '3.30.200.20-FF-002257', NULL, 'Protein kinase byr1', 115, NULL, NULL, 210039),
(210040, '3.40.50.720-FF-002526', NULL, 'Predicted protein', 98, NULL, NULL, 210040),
(210041, '2.60.40.10-FF-001551', NULL, 'Jitterbug, isoform M', 94, NULL, NULL, 210041),
(210042, '1.20.1740.10-FF-000100', NULL, 'Cationic amino acid transport integral membrane protein RocE', 445, NULL, NULL, 210042),
(210043, '3.40.1190.20-FF-000144', NULL, 'Ribokinase', 393, NULL, NULL, 210043),
(210044, '1.20.1250.20-FF-002235', NULL, 'Uncharacterized protein', 120, NULL, NULL, 210044),
(210045, '1.25.10.10-FF-003061', NULL, 'Uncharacterized protein', 267, NULL, NULL, 210045),
(210046, '1.20.1250.20-FF-002292', NULL, 'Uncharacterized protein', 69, NULL, NULL, 210046),
(210047, '3.30.559.10-FF-000175', NULL, 'Uncharacterized protein', 162, NULL, NULL, 210047),
(210048, '1.10.3080.10-FF-000052', NULL, 'Chloride channel protein', 400, NULL, NULL, 210048),
(210049, '3.20.20.10-FF-000054', NULL, 'Probable diaminopimelate decarboxylase', 244, NULL, NULL, 210049),
(210050, '3.40.190.10-FF-000850', NULL, 'Uncharacterized protein', 78, NULL, NULL, 210050),
(210051, '1.10.1270.10-FF-000004', NULL, 'Trp operon repressor homolog', 94, NULL, NULL, 210051),
(210052, '1.25.40.10-FF-001056', NULL, 'Anaphase-promoting complex subunit CDC27', 133, NULL, NULL, 210052),
(210053, '3.40.50.10090-FF-000035', NULL, 'Uroporphyrinogen III synthase HEM4', 118, NULL, NULL, 210053),
(210054, '1.50.10.10-FF-000034', NULL, 'Trehalase', 541, NULL, NULL, 210054),
(210055, '2.70.98.10-FF-000099', NULL, 'Uncharacterized protein', 97, NULL, NULL, 210055),
(210056, '2.130.10.10-FF-003119', NULL, 'WD domain, G-beta repeat, putative', 267, NULL, NULL, 210056),
(210057, '1.20.920.10-FF-000121', NULL, 'Bromodomain factor 2 protein, putative', 118, NULL, NULL, 210057),
(210058, '3.30.420.10-FF-000410', NULL, NULL, 180, NULL, NULL, 210058),
(210059, '1.50.10.20-FF-000037', NULL, 'Terpene synthase family protein', 275, NULL, NULL, 210059);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(210060, '1.10.3890.10-FF-000001', NULL, 'High frequency lysogenization protein HflD homolog', 213, NULL, NULL, 210060),
(210061, '3.30.710.10-FF-000157', NULL, 'Potassium channel', 100, NULL, NULL, 210061),
(210062, '1.20.1250.10-FF-000080', NULL, 'Interferon gamma', 119, NULL, NULL, 210062),
(210063, '3.40.50.10490-FF-000126', NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing] 1', 148, NULL, NULL, 210063),
(210064, '2.130.10.10-FF-005362', NULL, 'Uncharacterized protein', 172, NULL, NULL, 210064),
(210065, '3.30.1490.20-FF-000107', NULL, 'ATP-grasp enzyme-like protein', 85, NULL, NULL, 210065),
(210066, '1.10.287.70-FF-000354', NULL, 'Sodium channel protein', 132, NULL, NULL, 210066),
(210067, '1.20.1250.20-FF-000083', NULL, 'synaptic vesicular amine transporter isoform X1', 196, NULL, NULL, 210067),
(210068, '3.30.160.60-FF-005800', NULL, NULL, 55, NULL, NULL, 210068),
(210069, '3.30.200.20-FF-000666', NULL, 'Kinase family with leucine-rich repeat domain-containing protein', 98, NULL, NULL, 210069),
(210070, '2.60.40.4100-FF-000017', NULL, 'Uncharacterized protein', 162, NULL, NULL, 210070),
(210071, '1.25.10.10-FF-002043', NULL, 'Cytoskeleton-associated protein 5', 245, NULL, NULL, 210071),
(210072, '1.20.990.10-FF-000041', NULL, 'Uncharacterized protein', 118, NULL, NULL, 210072),
(210073, '2.40.30.30-FF-000028', NULL, 'Uncharacterized protein', 169, NULL, NULL, 210073),
(210074, '3.20.20.80-FF-000114', NULL, 'Cell wall alpha-1,3-glucan synthase ags1', 257, NULL, NULL, 210074),
(210075, '2.20.100.10-FF-000038', NULL, 'CYR61 isoform 1', 61, NULL, NULL, 210075),
(210076, '1.10.220.30-FF-000031', NULL, 'Flagellar motor switch protein FliG', 91, NULL, NULL, 210076),
(210077, '3.40.50.10190-FF-000183', NULL, 'Cleavage and polyadenylation factor 6-related protein', 90, NULL, NULL, 210077),
(210078, '2.40.30.20-FF-000025', NULL, 'Riboflavin synthase subunit alpha', 102, NULL, NULL, 210078),
(210079, '3.20.20.70-FF-000111', NULL, 'Fructose-1,6-bisphosphate aldolase', 332, NULL, NULL, 210079),
(210080, '3.40.50.300-FF-003951', NULL, 'Succinoglycan biosynthesis transport protein', 277, NULL, NULL, 210080),
(210081, '3.30.160.60-FF-002017', NULL, 'Zinc finger protein 599', 29, NULL, NULL, 210081),
(210082, '3.60.40.10-FF-000109', NULL, 'Protein phosphatase PPM9', 289, NULL, NULL, 210082),
(210083, '1.10.238.10-FF-001212', NULL, 'Uncharacterized protein', 158, NULL, NULL, 210083),
(210084, '3.80.10.10-FF-001872', NULL, 'NLR family CARD domain-containing 7', 165, NULL, NULL, 210084),
(210085, '2.60.40.10-FF-004895', NULL, NULL, 118, NULL, NULL, 210085),
(210086, '1.50.10.150-FF-000020', NULL, 'Uncharacterized protein', 136, NULL, NULL, 210086),
(210087, '2.30.29.30-FF-000508', NULL, 'Mitogen-activated protein kinase', 109, NULL, NULL, 210087),
(210088, '3.40.50.12370-FF-000011', NULL, 'Uncharacterized protein', 258, NULL, NULL, 210088),
(210089, '1.10.10.160-FF-000021', NULL, 'PROBABLE ATP-DEPENDENT DNA HELICASE', 92, NULL, NULL, 210089),
(210090, '2.60.120.200-FF-000550', NULL, 'Chromosome 9, whole genome shotgun sequence', 335, NULL, NULL, 210090),
(210091, '2.60.40.2860-FF-000004', NULL, 'Transmission-blocking target antigen S230', 128, NULL, NULL, 210091),
(210092, '1.10.238.110-FF-000020', NULL, 'Uncharacterized protein', 59, NULL, NULL, 210092),
(210093, '2.60.40.10-FF-003349', NULL, 'Beta-glucosidase (Gentiobiase)', 113, NULL, NULL, 210093),
(210094, '3.40.50.300-FF-003187', NULL, 'DEAD box helicase involved in nonsense mediated decay, putative', 199, NULL, NULL, 210094),
(210095, '1.25.10.10-FF-001823', NULL, 'Uncharacterized protein', 217, NULL, NULL, 210095),
(210096, '1.10.533.10-FF-000015', NULL, 'Caspase recruitment domain-containing protein 19', 101, NULL, NULL, 210096),
(210097, '3.40.50.1820-FF-001101', NULL, 'Predicted protein', 106, NULL, NULL, 210097),
(210098, '3.40.50.360-FF-000164', NULL, 'Methionine synthase reductase, mitochondrial-like protein', 153, NULL, NULL, 210098),
(210099, '3.10.50.40-FF-000003', NULL, 'Peptidylprolyl isomerase', 92, NULL, NULL, 210099);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(210100, '3.30.160.60-FF-001764', NULL, 'zinc finger protein 454 isoform X1', 32, NULL, NULL, 210100),
(210101, '3.30.70.2490-FF-000001', NULL, 'Fatty acid synthase subunit alpha', 64, NULL, NULL, 210101),
(210102, '3.20.80.10-FF-000030', NULL, 'Predicted protein', 176, NULL, NULL, 210102),
(210103, '3.30.70.270-FF-000317', NULL, NULL, 17, NULL, NULL, 210103),
(210104, '3.30.70.330-FF-002713', NULL, NULL, 104, NULL, NULL, 210104),
(210105, '1.25.40.20-FF-001564', NULL, 'Sex-determining protein fem-1', 80, NULL, NULL, 210105),
(210106, '2.60.40.10-FF-003703', NULL, NULL, 98, NULL, NULL, 210106),
(210107, '3.60.15.10-FF-000158', NULL, 'MBL fold metallo-hydrolase', 243, NULL, NULL, 210107),
(210108, '3.40.50.720-FF-000935', NULL, 'HesA/MoeB/ThiF family protein, putative', 237, NULL, NULL, 210108),
(210109, '3.40.50.1260-FF-000045', NULL, 'Phosphoglycerate kinase', 72, NULL, NULL, 210109),
(210110, '3.30.70.2740-FF-000008', NULL, 'Probable dehydrogenase', 74, NULL, NULL, 210110),
(210111, '1.20.1260.10-FF-000018', NULL, 'Ferritin', 145, NULL, NULL, 210111),
(210112, '3.10.129.10-FF-000136', NULL, 'Thioesterase superfamily, putative', 168, NULL, NULL, 210112),
(210113, '3.60.130.10-FF-000066', NULL, 'Uncharacterized protein', 212, NULL, NULL, 210113),
(210114, '3.30.160.60-FF-002989', NULL, 'GH20378p', 30, NULL, NULL, 210114),
(210115, '3.20.20.80-FF-000586', NULL, 'Uncharacterized protein', 248, NULL, NULL, 210115),
(210116, '3.40.570.10-FF-000047', NULL, 'Uncharacterized protein', 304, NULL, NULL, 210116),
(210117, '1.10.510.10-FF-000856', NULL, 'eIF-2-alpha kinase GCN2', 234, NULL, NULL, 210117),
(210118, '1.20.5.100-FF-000025', NULL, 'Integrin beta', 74, NULL, NULL, 210118),
(210119, '2.10.25.10-FF-000282', NULL, 'Crumbs cell polarity complex component 2', 38, NULL, NULL, 210119),
(210120, '3.20.20.140-FF-000304', NULL, 'Uncharacterized protein', 190, NULL, NULL, 210120),
(210121, '2.130.10.10-FF-003619', NULL, 'Uncharacterized WD repeat-containing protein C3D6.12', 202, NULL, NULL, 210121),
(210122, '3.40.50.1000-FF-000838', NULL, NULL, 76, NULL, NULL, 210122),
(210123, '3.30.450.20-FF-000566', NULL, 'Methyl-accepting chemotaxis protein', 128, NULL, NULL, 210123),
(210124, '1.10.3210.10-FF-000113', NULL, 'Uncharacterized protein', 135, NULL, NULL, 210124),
(210125, '3.40.50.300-FF-003541', NULL, 'RAB39A, member RAS oncogene family', 117, NULL, NULL, 210125),
(210126, '3.40.50.10220-FF-000001', NULL, 'DNA polymerase III subunit psi', 105, NULL, NULL, 210126),
(210127, '3.30.160.60-FF-005036', NULL, NULL, 54, NULL, NULL, 210127),
(210128, '3.30.40.10-FF-001050', NULL, 'Receptor homology region, transmembrane domain- and RING domain-containing protein 1', 72, NULL, NULL, 210128),
(210129, '3.10.100.10-FF-000289', NULL, NULL, 149, NULL, NULL, 210129),
(210130, '2.30.42.10-FF-000382', NULL, NULL, 87, NULL, NULL, 210130),
(210131, '3.30.160.60-FF-005507', NULL, NULL, 30, NULL, NULL, 210131),
(210132, '1.10.260.30-FF-000005', NULL, 'Signal recognition particle 54 kDa protein', 131, NULL, NULL, 210132),
(210133, '1.10.8.60-FF-000050', NULL, 'Psp operon transcriptional activator', 84, NULL, NULL, 210133),
(210134, '3.40.605.10-FF-000005', NULL, 'Succinate-semialdehyde dehydrogenase I', 258, NULL, NULL, 210134),
(210135, '1.25.10.10-FF-001880', NULL, 'Uncharacterized protein', 449, NULL, NULL, 210135),
(210136, '3.40.50.300-FF-002052', NULL, 'DNA repair protein RAD51 homolog', 241, NULL, NULL, 210136),
(210137, '1.20.1250.10-FF-000046', NULL, 'Interferon alpha', 164, NULL, NULL, 210137),
(210138, '2.130.10.10-FF-005570', NULL, 'Myosin heavy chain kinase D', 211, NULL, NULL, 210138),
(210139, '1.20.5.210-FF-000002', NULL, 'BnaA01g31400D protein', 70, NULL, NULL, 210139),
(210140, '2.60.40.10-FF-001904', NULL, 'Uncharacterized protein YeeJ', 105, NULL, NULL, 210140),
(210141, '1.25.40.860-FF-000018', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 134, NULL, NULL, 210141),
(210142, '2.130.10.10-FF-001057', NULL, 'Nuclear pore complex subunit Nup133, putative', 409, NULL, NULL, 210142);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(210143, '3.40.50.150-FF-001057', NULL, 'Methyltransferase', 270, NULL, NULL, 210143),
(210144, '2.10.220.10-FF-000010', NULL, 'Receptor protein-tyrosine kinase', 124, NULL, NULL, 210144),
(210145, '1.25.40.770-FF-000025', NULL, 'LD25013p', 90, NULL, NULL, 210145),
(210146, '1.20.5.170-FF-000181', NULL, 'C-type lectin domain family 4 member F', 48, NULL, NULL, 210146),
(210147, '1.20.1560.10-FF-000917', NULL, 'ABC transporter B family member 27', 108, NULL, NULL, 210147),
(210148, '1.20.5.110-FF-000270', NULL, 'Uncharacterized protein', 82, NULL, NULL, 210148),
(210149, '1.50.10.10-FF-000242', NULL, 'alpha-1,2-Mannosidase', 68, NULL, NULL, 210149),
(210150, '3.40.50.2300-FF-000419', NULL, 'Ethanolamine two-component response regulator', 132, NULL, NULL, 210150),
(210151, '1.10.630.10-FF-000718', NULL, 'Uncharacterized protein', 104, NULL, NULL, 210151),
(210152, '3.40.50.2000-FF-001026', NULL, 'UDP-GlucuronosylTransferase', 173, NULL, NULL, 210152),
(210153, '1.20.1050.10-FF-000126', NULL, 'Predicted protein', 109, NULL, NULL, 210153),
(210154, '3.40.50.300-FF-004204', NULL, 'Multidrug resistance protein, putative', 60, NULL, NULL, 210154),
(210155, '1.25.40.10-FF-001090', NULL, 'CTR9 homolog, Paf1/RNA polymerase II complex component', 73, NULL, NULL, 210155),
(210156, '2.130.10.10-FF-005418', NULL, 'IRE protein kinase', 301, NULL, NULL, 210156),
(210157, '3.30.40.10-FF-000645', NULL, 'Dual specificity phosphatase', 89, NULL, NULL, 210157),
(210158, '1.20.5.110-FF-000028', NULL, '25.3 kDa vesicle transport protein-like', 85, NULL, NULL, 210158),
(210159, '3.90.190.10-FF-000535', NULL, 'Predicted protein', 180, NULL, NULL, 210159),
(210160, '1.25.40.20-FF-001654', NULL, 'Predicted protein', 88, NULL, NULL, 210160),
(210161, '1.20.1250.20-FF-000554', NULL, 'YALI0D20064p', 405, NULL, NULL, 210161),
(210162, '3.40.50.620-FF-000585', NULL, 'Asparagine synthetase [glutamine-hydrolyzing] 1', 148, NULL, NULL, 210162),
(210163, '1.10.510.10-FF-003318', NULL, NULL, 71, NULL, NULL, 210163),
(210164, '3.30.1010.10-FF-000075', NULL, 'Uncharacterized protein', 176, NULL, NULL, 210164),
(210165, '3.10.100.10-FF-000379', NULL, NULL, 135, NULL, NULL, 210165),
(210166, '3.30.70.330-FF-002359', NULL, NULL, 105, NULL, NULL, 210166),
(210167, '1.10.390.10-FF-000003', NULL, 'Leukotriene A(4) hydrolase', 155, NULL, NULL, 210167),
(210168, '3.80.10.10-FF-000944', NULL, 'Leucine Rich Repeat family protein, expressed', 75, NULL, NULL, 210168),
(210169, '1.10.287.380-FF-000020', NULL, 'ATP-binding protein', 79, NULL, NULL, 210169),
(210170, '1.10.10.60-FF-001046', NULL, NULL, 65, NULL, NULL, 210170),
(210171, '2.30.29.30-FF-000716', NULL, 'Integrin beta-1-binding protein 1', 157, NULL, NULL, 210171),
(210172, '3.30.70.870-FF-000048', NULL, 'Elongation factor Tu GTP binding domain containing protein', 76, NULL, NULL, 210172),
(210173, '2.60.120.920-FF-000001', NULL, 'neuralized-like protein 4 isoform X1', 168, NULL, NULL, 210173),
(210174, '1.20.1070.10-FF-001116', NULL, 'Beta-2 adrenergic receptor', 355, NULL, NULL, 210174),
(210175, '3.50.30.30-FF-000054', NULL, 'Peptide hydrolase', 84, NULL, NULL, 210175),
(210176, '1.25.40.10-FF-003860', NULL, 'Pentatricopeptide repeat-containing protein', 106, NULL, NULL, 210176),
(210177, '1.20.1270.60-FF-000106', NULL, 'Atg20p', 101, NULL, NULL, 210177),
(210178, '1.10.8.280-FF-000002', NULL, 'UvrABC system protein A', 119, NULL, NULL, 210178),
(210179, '1.25.40.10-FF-001409', NULL, 'Kinesin light chain 2', 73, NULL, NULL, 210179),
(210180, '1.25.40.570-FF-000055', NULL, 'Uncharacterized protein', 326, NULL, NULL, 210180),
(210181, '1.20.58.60-FF-000834', NULL, 'Spectrin repeat containing nuclear envelope protein 2', 157, NULL, NULL, 210181),
(210182, '1.20.1070.10-FF-000953', NULL, 'Predicted protein', 104, NULL, NULL, 210182),
(210183, '3.30.70.330-FF-002977', NULL, NULL, 93, NULL, NULL, 210183),
(210184, '2.40.40.20-FF-000054', NULL, 'Molybdopterin oxidoreductase Fe4S4 region', 184, NULL, NULL, 210184),
(210185, '1.10.555.10-FF-000206', NULL, NULL, 94, NULL, NULL, 210185);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(210186, '2.60.120.200-FF-000640', NULL, 'Uncharacterized protein', 113, NULL, NULL, 210186),
(210187, '2.60.40.1730-FF-000025', NULL, 'Aminopeptidase', 212, NULL, NULL, 210187),
(210188, '1.25.10.10-FF-003471', NULL, 'Importin subunit alpha-6', 63, NULL, NULL, 210188),
(210189, '3.30.200.20-FF-001329', NULL, 'Os11g0691100 protein', 49, NULL, NULL, 210189),
(210190, '3.40.250.10-FF-000175', NULL, 'Rhodanese-like domain containing protein, putative', 111, NULL, NULL, 210190),
(210191, '3.40.50.300-FF-000461', NULL, 'Deoxycytidine kinase', 244, NULL, NULL, 210191),
(210192, '3.80.10.10-FF-000383', NULL, 'Leucine-rich repeat receptor protein kinase EMS1', 100, NULL, NULL, 210192),
(210193, '1.25.40.420-FF-000061', NULL, 'GCL (Drosophila Germ Cell-Less) homolog', 77, NULL, NULL, 210193),
(210194, '1.10.150.50-FF-000126', NULL, 'Zmp:0000000735', 89, NULL, NULL, 210194),
(210195, '3.30.70.660-FF-000075', NULL, 'tRNA pseudouridine synthase', 109, NULL, NULL, 210195),
(210196, '1.10.510.10-FF-003470', NULL, NULL, 271, NULL, NULL, 210196),
(210197, '3.40.50.1010-FF-000111', NULL, 'Exonuclease 1', 207, NULL, NULL, 210197),
(210198, '1.20.1070.10-FF-001881', NULL, 'Uncharacterized protein', 344, NULL, NULL, 210198),
(210199, '1.10.287.2620-FF-000024', NULL, 'Dynein heavy chain 9', 65, NULL, NULL, 210199),
(210200, '3.30.2230.10-FF-000029', NULL, 'Uncharacterized protein', 129, NULL, NULL, 210200),
(210201, '1.10.150.110-FF-000024', NULL, 'Mus-81', 72, NULL, NULL, 210201),
(210202, '3.40.50.20-FF-000013', NULL, 'D-alanine--D-alanine ligase', 85, NULL, NULL, 210202),
(210203, '1.25.40.10-FF-001651', NULL, 'Tetratricopeptide repeat-containing protein', 260, NULL, NULL, 210203),
(210204, '3.40.50.300-FF-007902', NULL, 'Uncharacterized protein', 189, NULL, NULL, 210204),
(210205, '2.60.120.260-FF-000197', NULL, 'Alpha-L-fucosidase', 146, NULL, NULL, 210205),
(210206, '3.90.650.10-FF-000054', NULL, 'NiFe hydrogenase accessory/formation protein HypE', 183, NULL, NULL, 210206),
(210207, '3.20.20.190-FF-000151', NULL, NULL, 246, NULL, NULL, 210207),
(210208, '1.20.900.10-FF-000029', NULL, 'Rho guanine nucleotide exchange factor 37', 225, NULL, NULL, 210208),
(210209, '3.30.160.60-FF-001854', NULL, 'Zinc finger protein', 28, NULL, NULL, 210209),
(210210, '3.80.10.10-FF-004126', NULL, 'Uncharacterized protein', 113, NULL, NULL, 210210),
(210211, '3.30.2290.10-FF-000005', NULL, 'Peptidase U62 modulator of DNA gyrase', 205, NULL, NULL, 210211),
(210212, '1.20.1540.10-FF-000091', NULL, 'Rhomboid protease GluP', 207, NULL, NULL, 210212),
(210213, '3.30.230.10-FF-000339', NULL, 'Uncharacterized protein', 57, NULL, NULL, 210213),
(210214, '1.10.418.80-FF-000004', NULL, NULL, 50, NULL, NULL, 210214),
(210215, '3.30.70.100-FF-000019', NULL, 'Protein NipSnap homolog 3A', 111, NULL, NULL, 210215),
(210216, '3.40.850.10-FF-000322', NULL, 'Kinesin, putative', 412, NULL, NULL, 210216),
(210217, '2.60.40.10-FF-005351', NULL, NULL, 112, NULL, NULL, 210217),
(210218, '1.50.40.10-FF-000070', NULL, 'Mitochondrial phosphate carrier protein 1, mitochondrial', 272, NULL, NULL, 210218),
(210219, '2.60.40.10-FF-001197', NULL, 'tyrosine-protein phosphatase Lar isoform X1', 94, NULL, NULL, 210219),
(210220, '3.40.50.720-FF-001340', NULL, '3-oxoacyl-[acyl-carrier protein] reductase', 246, NULL, NULL, 210220),
(210221, '3.30.60.90-FF-000041', NULL, 'E3 ubiquitin-protein ligase Zswim2', 55, NULL, NULL, 210221),
(210222, '3.10.590.10-FF-000022', NULL, 'Uncharacterized protein', 88, NULL, NULL, 210222),
(210223, '1.10.287.470-FF-000013', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 59, NULL, NULL, 210223),
(210224, '2.60.120.290-FF-000150', NULL, 'Metalloendopeptidase', 43, NULL, NULL, 210224),
(210225, '3.40.50.2000-FF-000829', NULL, 'Uncharacterized protein', 151, NULL, NULL, 210225),
(210226, '1.10.3500.10-FF-000006', NULL, 'Transcription elongation factor spt6', 253, NULL, NULL, 210226),
(210227, '3.30.70.330-FF-000768', NULL, 'Polyadenylate-binding protein RBP47C isoform A', 81, NULL, NULL, 210227),
(210228, '1.20.910.10-FF-000002', NULL, 'Aminopyrimidine aminohydrolase', 228, NULL, NULL, 210228);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(210229, '2.130.10.10-FF-001821', NULL, 'SEC31 homolog A, COPII coat complex component', 82, NULL, NULL, 210229),
(210230, '4.10.60.10-FF-000156', NULL, 'Replication protein A subunit', 46, NULL, NULL, 210230),
(210231, '1.10.10.10-FF-001609', NULL, 'Uncharacterized protein', 77, NULL, NULL, 210231),
(210232, '3.30.160.60-FF-005654', NULL, NULL, 35, NULL, NULL, 210232),
(210233, '4.10.280.10-FF-000146', NULL, 'Transcription factor bHLH162', 91, NULL, NULL, 210233),
(210234, '1.10.2000.10-FF-000075', NULL, NULL, 88, NULL, NULL, 210234),
(210235, '2.170.300.10-FF-000046', NULL, 'Uncharacterized protein', 79, NULL, NULL, 210235),
(210236, '1.10.3090.10-FF-000024', NULL, 'tRNA nucleotidyltransferase, mitochondrial, putative', 217, NULL, NULL, 210236),
(210237, '1.25.10.10-FF-003414', NULL, 'Ecm29p', 520, NULL, NULL, 210237),
(210238, '1.10.10.60-FF-000793', NULL, NULL, 78, NULL, NULL, 210238),
(210239, '3.80.10.10-FF-000326', NULL, 'Protein phosphatase 1 regulatory inhibitor subunit PPP1R7 homolog', 108, NULL, NULL, 210239),
(210240, '3.30.160.60-FF-000011', NULL, 'zinc finger protein 615 isoform X1', 28, NULL, NULL, 210240),
(210241, '3.30.930.10-FF-000140', NULL, 'Octanoyltransferase', 205, NULL, NULL, 210241),
(210242, '3.30.160.60-FF-001293', NULL, 'Zinc finger protein 292', 50, NULL, NULL, 210242),
(210243, '1.20.5.110-FF-000180', NULL, 'Putative QA-SNARE protein', 102, NULL, NULL, 210243),
(210244, '2.30.40.10-FF-000158', NULL, 'N-acetylglucosamine-6-phosphate deacetylase-like protein', 89, NULL, NULL, 210244),
(210245, '2.130.10.10-FF-002956', NULL, 'Uncharacterized protein', 243, NULL, NULL, 210245),
(210246, '3.30.460.10-FF-000182', NULL, 'Uncharacterized protein', 50, NULL, NULL, 210246),
(210247, '3.40.50.300-FF-007341', NULL, 'UvrD/REP helicase family protein', 104, NULL, NULL, 210247),
(210248, '3.30.160.60-FF-003445', NULL, NULL, 31, NULL, NULL, 210248),
(210249, '3.30.56.10-FF-000046', NULL, 'Uncharacterized protein', 44, NULL, NULL, 210249),
(210250, '1.20.1560.10-FF-000356', NULL, 'HAlF transporter (PGP related)', 98, NULL, NULL, 210250),
(210251, '3.30.930.10-FF-000347', NULL, 'Uncharacterized protein', 67, NULL, NULL, 210251),
(210252, '2.40.50.110-FF-000003', NULL, 'Subtilase SubB', 120, NULL, NULL, 210252),
(210253, '2.30.30.140-FF-000061', NULL, 'SAGA-associated factor 29 isoform X6', 74, NULL, NULL, 210253),
(210254, '1.20.58.120-FF-000008', NULL, 'BAG family molecular chaperone regulator 5', 91, NULL, NULL, 210254),
(210255, '1.10.238.10-FF-001066', NULL, 'Myosin, essential light chain', 78, NULL, NULL, 210255),
(210256, '1.20.5.170-FF-000029', NULL, 'Calcium-transporting ATPase', 57, NULL, NULL, 210256),
(210257, '3.80.10.10-FF-002535', NULL, 'Geranylgeranyl transferase type-2 subunit alpha 1', 150, NULL, NULL, 210257),
(210258, '1.10.472.10-FF-000699', NULL, 'Uncharacterized protein', 50, NULL, NULL, 210258),
(210259, '2.30.30.490-FF-000082', NULL, 'Uncharacterized protein', 169, NULL, NULL, 210259),
(210260, '4.10.81.10-FF-000002', NULL, 'cytochrome c oxidase subunit 8C, mitochondrial', 43, NULL, NULL, 210260),
(210261, '3.90.320.10-FF-000035', NULL, 'YALI0A09680p', 229, NULL, NULL, 210261),
(210262, '3.40.30.10-FF-000155', NULL, 'Thioredoxin', 110, NULL, NULL, 210262),
(210263, '3.40.190.80-FF-000033', NULL, 'Si:ch211-160o17.2', 149, NULL, NULL, 210263),
(210264, '1.25.10.10-FF-001262', NULL, 'HEAT repeat-containing protein 1-like Protein', 230, NULL, NULL, 210264),
(210265, '3.30.200.20-FF-000812', NULL, 'Scy1p', 117, NULL, NULL, 210265),
(210266, '3.60.20.10-FF-000081', NULL, 'Proteasome subunit beta', 195, NULL, NULL, 210266),
(210267, '1.20.90.10-FF-000052', NULL, NULL, 90, NULL, NULL, 210267),
(210268, '1.20.120.1650-FF-000001', NULL, 'Rif2p', 141, NULL, NULL, 210268),
(210269, '1.10.510.10-FF-001727', NULL, 'Tyrosine-protein kinase receptor svh-2', 279, NULL, NULL, 210269),
(210270, '1.10.287.130-FF-000142', NULL, 'Sensor histidine kinase', 75, NULL, NULL, 210270),
(210271, '2.60.40.10-FF-005558', NULL, NULL, 114, NULL, NULL, 210271),
(210272, '1.10.10.10-FF-001048', NULL, 'Glycerol-3-phosphate regulon repressor', 57, NULL, NULL, 210272);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(210273, '3.40.960.10-FF-000004', NULL, 'Cullin, a subunit of E3 ubiquitin ligase', 100, NULL, NULL, 210273),
(210274, '3.40.50.2000-FF-000453', NULL, 'Lipopolysaccharide heptosyltransferase I', 164, NULL, NULL, 210274),
(210275, '1.20.58.110-FF-000005', NULL, '30S ribosomal protein S20', 83, NULL, NULL, 210275),
(210276, '1.20.58.100-FF-000002', NULL, 'L-aspartate oxidase', 110, NULL, NULL, 210276),
(210277, '3.40.190.10-FF-000586', NULL, 'ABC transporter substrate-binding protein', 86, NULL, NULL, 210277),
(210278, '3.40.50.150-FF-001528', NULL, NULL, 100, NULL, NULL, 210278),
(210279, '2.40.50.120-FF-000006', NULL, 'Secreted frizzled-related protein 2', 128, NULL, NULL, 210279),
(210280, '1.10.10.10-FF-001290', NULL, 'Ribosomal protein', 60, NULL, NULL, 210280),
(210281, '2.40.50.120-FF-000063', NULL, 'Uncharacterized protein', 96, NULL, NULL, 210281),
(210282, '4.10.1000.10-FF-000078', NULL, 'Zinc finger protein family member, putative', 101, NULL, NULL, 210282),
(210283, '1.10.510.10-FF-001019', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase B120', 92, NULL, NULL, 210283),
(210284, '2.60.40.650-FF-000001', NULL, 'Nitrate reductase', 177, NULL, NULL, 210284),
(210285, '3.30.9.10-FF-000117', NULL, 'Chromosome 8, whole genome shotgun sequence', 168, NULL, NULL, 210285),
(210286, '1.20.1420.10-FF-000025', NULL, NULL, 155, NULL, NULL, 210286),
(210287, '2.30.29.30-FF-000924', NULL, 'RAB GTPase-activating protein, putative', 96, NULL, NULL, 210287),
(210288, '3.90.70.10-FF-000402', NULL, 'Ubiquitin carboxyl-terminal hydrolase 5', 250, NULL, NULL, 210288),
(210289, '3.40.50.10330-FF-000034', NULL, 'Mitochondrial NADH kinase', 174, NULL, NULL, 210289),
(210290, '2.60.40.3770-FF-000002', NULL, 'Envelopment polyprotein', 95, NULL, NULL, 210290),
(210291, '3.30.160.60-FF-004783', NULL, NULL, 23, NULL, NULL, 210291),
(210292, '3.90.810.10-FF-000027', NULL, 'Serine/threonine-protein kinase PAK 1', 51, NULL, NULL, 210292),
(210293, '3.40.50.720-FF-000525', NULL, '3-keto-steroid reductase', 295, NULL, NULL, 210293),
(210294, '1.20.1270.10-FF-000108', NULL, 'Uncharacterized protein', 73, NULL, NULL, 210294),
(210295, '1.20.1720.10-FF-000127', NULL, NULL, 205, NULL, NULL, 210295),
(210296, '3.30.200.20-FF-001245', NULL, 'Uncharacterized protein', 79, NULL, NULL, 210296),
(210297, '2.160.20.10-FF-000269', NULL, 'Uncharacterized protein', 339, NULL, NULL, 210297),
(210298, '3.40.20.10-FF-000121', NULL, 'Gelsolin-like protein 1', 109, NULL, NULL, 210298),
(210299, '2.130.10.10-FF-004839', NULL, 'THO complex 3 G protein beta subunit', 132, NULL, NULL, 210299),
(210300, '1.10.510.10-FF-001109', NULL, 'Protein CBG07147', 273, NULL, NULL, 210300),
(210301, '3.30.559.10-FF-000085', NULL, 'Transferase family protein', 219, NULL, NULL, 210301),
(210302, '1.10.150.50-FF-000042', NULL, 'GRB2-associated and regulator of MAPK protein 1', 60, NULL, NULL, 210302),
(210303, '2.30.30.240-FF-000001', NULL, 'Ribosome maturation factor RimM', 82, NULL, NULL, 210303),
(210304, '3.40.50.450-FF-000011', NULL, 'TIGR00730 family Rossman fold protein', 202, NULL, NULL, 210304),
(210305, '2.40.50.140-FF-000248', NULL, 'Meiosis specific with OB domains', 117, NULL, NULL, 210305),
(210306, '3.40.50.1360-FF-000042', NULL, 'Putative lactose phosphotransferase system transcriptional repressor', 150, NULL, NULL, 210306),
(210307, '1.10.287.70-FF-000207', NULL, 'Predicted protein', 125, NULL, NULL, 210307),
(210308, '3.40.50.1950-FF-000005', NULL, 'Phosphopantothenoylcysteine decarboxylase subunit VHS3', 204, NULL, NULL, 210308),
(210309, '3.30.2230.10-FF-000030', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 117, NULL, NULL, 210309),
(210310, '3.90.190.10-FF-000271', NULL, 'Protein tyrosine phosphatase, receptor-type, Z polypeptide 1a', 280, NULL, NULL, 210310),
(210311, '3.30.200.20-FF-001301', NULL, 'Cysteine-rich receptor-like protein kinase 40', 100, NULL, NULL, 210311),
(210312, '2.130.10.10-FF-001118', NULL, 'WD repeat-containing protein', 140, NULL, NULL, 210312),
(210313, '3.10.580.10-FF-000083', NULL, 'HlyC/CorC family transporter', 130, NULL, NULL, 210313);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(210314, '3.20.20.80-FF-000524', NULL, 'Uncharacterized protein', 248, NULL, NULL, 210314),
(210315, '3.30.450.20-FF-000448', NULL, 'Cyclic-di-AMP phosphodiesterase', 102, NULL, NULL, 210315),
(210316, '2.60.40.60-FF-001015', NULL, 'Uncharacterized protein', 48, NULL, NULL, 210316),
(210317, '3.30.2160.10-FF-000001', NULL, 'E3 ubiquitin-protein ligase NEDD4-like', 78, NULL, NULL, 210317),
(210318, '3.30.559.10-FF-000203', NULL, 'Carnitine O-palmitoyltransferase 2, mitochondrial-like Protein', 188, NULL, NULL, 210318),
(210319, '1.10.150.60-FF-000045', NULL, NULL, 105, NULL, NULL, 210319),
(210320, '3.40.50.460-FF-000014', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit alpha 2', 34, NULL, NULL, 210320),
(210321, '1.10.287.550-FF-000003', NULL, 'Uncharacterized protein', 60, NULL, NULL, 210321),
(210322, '3.20.20.70-FF-000521', NULL, NULL, 271, NULL, NULL, 210322),
(210323, '1.10.260.40-FF-000070', NULL, 'Addiction module antidote protein, HigA family', 95, NULL, NULL, 210323),
(210324, '3.90.870.10-FF-000003', NULL, 'Sua5/YciO/YrdC/YwlC family protein', 206, NULL, NULL, 210324),
(210325, '3.30.160.60-FF-003681', NULL, NULL, 30, NULL, NULL, 210325),
(210326, '1.20.120.1240-FF-000058', NULL, 'Dynamin-A', 146, NULL, NULL, 210326),
(210327, '3.30.710.10-FF-000218', NULL, 'Lolal-like protein', 153, NULL, NULL, 210327),
(210328, '3.40.50.300-FF-004699', NULL, 'Minichromosome maintenance complex component 5', 342, NULL, NULL, 210328),
(210329, '1.10.510.10-FF-000974', NULL, 'Tyrosine-protein kinase', 264, NULL, NULL, 210329),
(210330, '2.60.120.920-FF-000030', NULL, 'probable E3 ubiquitin-protein ligase HECTD4 isoform X2', 214, NULL, NULL, 210330),
(210331, '3.30.1370.10-FF-000242', NULL, 'Predicted protein', 34, NULL, NULL, 210331),
(210332, '3.40.367.20-FF-000016', NULL, 'Phosphotransferase', 266, NULL, NULL, 210332),
(210333, '2.150.10.10-FF-000022', NULL, NULL, 95, NULL, NULL, 210333),
(210334, '1.25.40.10-FF-000836', NULL, 'Unplaced genomic scaffold supercont1.19, whole genome shotgun sequence', 255, NULL, NULL, 210334),
(210335, '1.25.10.10-FF-001407', NULL, 'U3 small nucleolar RNA-associated protein 10', 159, NULL, NULL, 210335),
(210336, '3.30.160.60-FF-005772', NULL, NULL, 31, NULL, NULL, 210336),
(210337, '3.30.70.330-FF-002477', NULL, NULL, 79, NULL, NULL, 210337),
(210338, '3.40.50.2300-FF-000329', NULL, 'Hybrid sensor histidine kinase/response regulator', 138, NULL, NULL, 210338),
(210339, '1.25.40.180-FF-000236', NULL, NULL, 196, NULL, NULL, 210339),
(210340, '3.20.140.10-FF-000008', NULL, 'Nicotinate phosphoribosyltransferase', 391, NULL, NULL, 210340),
(210341, '3.90.640.10-FF-000227', NULL, 'Uncharacterized protein', 63, NULL, NULL, 210341),
(210342, '3.30.1410.10-FF-000004', NULL, 'Uncharacterized protein', 107, NULL, NULL, 210342),
(210343, '3.40.1160.10-FF-000044', NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase, putative', 192, NULL, NULL, 210343),
(210344, '3.40.47.10-FF-000188', NULL, NULL, 237, NULL, NULL, 210344),
(210345, '3.30.160.60-FF-005300', NULL, NULL, 32, NULL, NULL, 210345),
(210346, '3.60.10.10-FF-000018', NULL, '2'',5''-phosphodiesterase 12', 334, NULL, NULL, 210346),
(210347, '3.30.9.10-FF-000027', NULL, 'FAD-dependent oxidoreductase family protein', 159, NULL, NULL, 210347),
(210348, '1.20.5.190-FF-000097', NULL, NULL, 43, NULL, NULL, 210348),
(210349, '1.50.10.10-FF-000124', NULL, 'Uncharacterized protein', 441, NULL, NULL, 210349),
(210350, '4.10.75.10-FF-000004', NULL, 'WAP four-disulfide core domain 6A', 43, NULL, NULL, 210350),
(210351, '1.20.120.1080-FF-000044', NULL, 'Protein CBG08977', 157, NULL, NULL, 210351),
(210352, '1.25.10.10-FF-001470', NULL, 'AGAP006626-PA-like protein', 246, NULL, NULL, 210352),
(210353, '1.25.40.10-FF-003096', NULL, 'YALI0A10296p', 180, NULL, NULL, 210353),
(210354, '2.60.120.320-FF-000001', NULL, 'Thiamine pyrophosphokinase', 90, NULL, NULL, 210354),
(210355, '2.20.100.10-FF-000217', NULL, 'Uncharacterized protein', 59, NULL, NULL, 210355),
(210356, '2.30.42.10-FF-000466', NULL, NULL, 90, NULL, NULL, 210356);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(210357, '3.40.50.12780-FF-000128', NULL, 'Fatty acid transporter, putative', 237, NULL, NULL, 210357),
(210358, '3.40.50.300-FF-003715', NULL, 'GG12352', 180, NULL, NULL, 210358),
(210359, '2.30.42.10-FF-000264', NULL, 'Multiple PDZ domain protein', 96, NULL, NULL, 210359),
(210360, '3.80.10.10-FF-000208', NULL, 'F-box/LRR-repeat protein 12 isoform X1', 322, NULL, NULL, 210360),
(210361, '3.10.20.360-FF-000007', NULL, NULL, 65, NULL, NULL, 210361),
(210362, '2.60.120.330-FF-000004', NULL, 'aspartyl/asparaginyl beta-hydroxylase isoform X2', 196, NULL, NULL, 210362),
(210363, '1.10.10.60-FF-001107', NULL, NULL, 67, NULL, NULL, 210363),
(210364, '2.30.230.10-FF-000028', NULL, 'Putative vitellogenin 2', 271, NULL, NULL, 210364),
(210365, '3.20.20.80-FF-000468', NULL, 'Alpha-amylase', 356, NULL, NULL, 210365),
(210366, '3.40.850.10-FF-000378', NULL, 'Uncharacterized protein', 323, NULL, NULL, 210366),
(210367, '3.30.70.330-FF-001016', NULL, 'U11/U12 small nuclear ribonucleoprotein', 112, NULL, NULL, 210367),
(210368, '2.130.10.10-FF-002748', NULL, 'Autophagy-related protein 18e', 268, NULL, NULL, 210368),
(210369, '3.30.10.20-FF-000005', NULL, 'Bifunctional membrane-associatedpenicillin-binding protein 1A/1B', 64, NULL, NULL, 210369),
(210370, '1.25.40.10-FF-005041', NULL, 'Uncharacterized protein', 126, NULL, NULL, 210370),
(210371, '3.30.70.3490-FF-000054', NULL, NULL, 43, NULL, NULL, 210371),
(210372, '2.60.120.340-FF-000007', NULL, 'Nucleophosmin 1a', 120, NULL, NULL, 210372),
(210373, '3.20.20.70-FF-000465', NULL, NULL, 126, NULL, NULL, 210373),
(210374, '3.40.1360.10-FF-000025', NULL, 'DNA primase', 122, NULL, NULL, 210374),
(210375, '3.40.1380.10-FF-000032', NULL, 'Uncharacterized protein', 46, NULL, NULL, 210375),
(210376, '3.40.50.10490-FF-000003', NULL, 'Glucose-6-phosphate isomerase', 302, NULL, NULL, 210376),
(210377, '3.40.50.1820-FF-001040', NULL, 'Uncharacterized protein', 108, NULL, NULL, 210377),
(210378, '1.10.4160.10-FF-000019', NULL, 'Transmembrane transport protein', 443, NULL, NULL, 210378),
(210379, '2.40.50.90-FF-000025', NULL, 'Thermonuclease', 147, NULL, NULL, 210379),
(210380, '3.40.50.150-FF-000511', NULL, 'Ribosomal RNA small subunit methyltransferase G', 174, NULL, NULL, 210380),
(210381, '1.50.10.20-FF-000127', NULL, 'Uncharacterized protein', 57, NULL, NULL, 210381),
(210382, '2.130.10.10-FF-003209', NULL, 'WD repeat-containing protein 38', 74, NULL, NULL, 210382),
(210383, '3.40.605.10-FF-000062', NULL, 'Delta-1-pyrroline-5-carboxylate synthase', 120, NULL, NULL, 210383),
(210384, '3.30.70.1590-FF-000006', NULL, 'Myosin XI D', 64, NULL, NULL, 210384),
(210385, '1.10.40.60-FF-000002', NULL, 'Type II secretion system protein K', 110, NULL, NULL, 210385),
(210386, '3.30.1430.10-FF-000011', NULL, 'LRRGT00043', 19, NULL, NULL, 210386),
(210387, '3.40.1170.10-FF-000016', NULL, 'DNA mismatch repair protein MutS', 122, NULL, NULL, 210387),
(210388, '3.40.1380.20-FF-000035', NULL, 'Pyruvate kinase', 135, NULL, NULL, 210388),
(210389, '1.25.40.20-FF-001238', NULL, 'Os11g0182900 protein', 255, NULL, NULL, 210389),
(210390, '1.10.287.70-FF-000270', NULL, 'Uncharacterized protein', 100, NULL, NULL, 210390),
(210391, '3.50.50.60-FF-000980', NULL, 'Pyridine nucleotide-disulphide oxidoreductase, putative', 91, NULL, NULL, 210391),
(210392, '2.130.10.10-FF-004991', NULL, 'Uncharacterized protein', 73, NULL, NULL, 210392),
(210393, '1.10.510.10-FF-003880', NULL, NULL, 90, NULL, NULL, 210393),
(210394, '3.40.50.300-FF-008122', NULL, 'Uncharacterized protein', 106, NULL, NULL, 210394),
(210395, '3.80.10.10-FF-004542', NULL, 'Predicted protein', 112, NULL, NULL, 210395),
(210396, '3.30.420.40-FF-001088', NULL, 'Predicted protein', 101, NULL, NULL, 210396),
(210397, '2.60.450.20-FF-000007', NULL, 'Centromere protein J', 181, NULL, NULL, 210397),
(210398, '3.90.660.10-FF-000083', NULL, NULL, 21, NULL, NULL, 210398),
(210399, '2.130.10.10-FF-003058', NULL, 'WD domain, G-beta repeat, putative', 138, NULL, NULL, 210399),
(210400, '3.40.50.10180-FF-000005', NULL, 'Glycerate kinase', 202, NULL, NULL, 210400);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(210401, '3.30.160.60-FF-001438', NULL, 'Zinc finger and BTB domain-containing protein 1', 48, NULL, NULL, 210401),
(210402, '1.25.40.10-FF-001235', NULL, 'Empty pericarp7', 88, NULL, NULL, 210402),
(210403, '3.40.1690.20-FF-000019', NULL, 'Membrane AAA-metalloprotease', 113, NULL, NULL, 210403),
(210404, '3.40.190.10-FF-000973', NULL, 'ABC-type dipeptide transport system, periplasmic component', 94, NULL, NULL, 210404),
(210405, '3.40.1690.10-FF-000016', NULL, 'Type III secretion protein HrcU', 140, NULL, NULL, 210405),
(210406, '1.10.12.10-FF-000052', NULL, 'Uncharacterized protein', 59, NULL, NULL, 210406),
(210407, '1.10.390.10-FF-000093', NULL, 'Aminopeptidase', 259, NULL, NULL, 210407),
(210408, '3.30.420.10-FF-000617', NULL, NULL, 175, NULL, NULL, 210408),
(210409, '3.40.50.2000-FF-000655', NULL, 'Zeaxanthin glucosyltransferase', 237, NULL, NULL, 210409),
(210410, '3.40.50.300-FF-003395', NULL, 'Regulator of nonsense transcripts, putative', 338, NULL, NULL, 210410),
(210411, '3.30.50.10-FF-000090', NULL, 'Uncharacterized protein, isoform A', 115, NULL, NULL, 210411),
(210412, '3.30.200.40-FF-000003', NULL, 'm7GpppX diphosphatase', 104, NULL, NULL, 210412),
(210413, '1.10.150.50-FF-000244', NULL, 'Uncharacterized protein', 57, NULL, NULL, 210413),
(210414, '2.60.450.10-FF-000004', NULL, 'Lipopolysaccharide export system protein LptA', 150, NULL, NULL, 210414),
(210415, '2.40.50.140-FF-000574', NULL, 'Multiple sugar ABC transporter ATP-bindingprotein', 46, NULL, NULL, 210415),
(210416, '3.30.160.60-FF-004018', NULL, NULL, 28, NULL, NULL, 210416),
(210417, '1.10.287.470-FF-000075', NULL, 'HAE1 family effllux pump MFP component', 62, NULL, NULL, 210417),
(210418, '1.20.1560.10-FF-000620', NULL, 'Uncharacterized protein', 609, NULL, NULL, 210418),
(210419, '1.20.1300.10-FF-000022', NULL, 'YOR228C-like protein', 130, NULL, NULL, 210419),
(210420, '3.40.50.10190-FF-000008', NULL, 'X-ray repair cross complementing 1', 89, NULL, NULL, 210420),
(210421, '3.40.50.2000-FF-000127', NULL, 'Glycosyltransferase', 240, NULL, NULL, 210421),
(210422, '2.30.30.140-FF-000117', NULL, 'Glyoxylate reductase 1 homolog', 79, NULL, NULL, 210422),
(210423, '3.50.30.30-FF-000115', NULL, 'Carboxypeptidase Q', 95, NULL, NULL, 210423),
(210424, '3.80.10.10-FF-002451', NULL, 'Leucine-rich repeat protein (LRRP)', 88, NULL, NULL, 210424),
(210425, '3.60.10.10-FF-000400', NULL, 'Uncharacterized protein', 51, NULL, NULL, 210425),
(210426, '1.20.1070.10-FF-000599', NULL, 'SERotonin/octopamine receptor family', 283, NULL, NULL, 210426),
(210427, '3.40.50.2300-FF-000594', NULL, 'Penicillin-binding protein activator', 133, NULL, NULL, 210427),
(210428, '3.10.129.10-FF-000046', NULL, 'Acyl-coenzyme A thioesterase THEM4', 209, NULL, NULL, 210428),
(210429, '1.20.1250.20-FF-001010', NULL, 'Solute carrier organic anion transporter family member', 385, NULL, NULL, 210429),
(210430, '2.30.30.490-FF-000020', NULL, 'Origin recognition complex subunit 1', 194, NULL, NULL, 210430),
(210431, '1.10.1040.10-FF-000049', NULL, 'Related to 2-dehydropantoate 2-reductase', 127, NULL, NULL, 210431),
(210432, '1.20.5.170-FF-000091', NULL, 'CD207 isoform 1', 43, NULL, NULL, 210432),
(210433, '2.60.40.10-FF-004659', NULL, NULL, 103, NULL, NULL, 210433),
(210434, '3.40.50.80-FF-000216', NULL, 'NADH-cytochrome b5 reductase', 153, NULL, NULL, 210434),
(210435, '3.75.10.10-FF-000024', NULL, NULL, 217, NULL, NULL, 210435),
(210436, '3.30.70.330-FF-000706', NULL, 'Multiple RNA-binding domain-containing protein 1', 134, NULL, NULL, 210436),
(210437, '2.30.30.100-FF-000038', NULL, 'Gem-associated protein 6', 86, NULL, NULL, 210437),
(210438, '3.10.20.30-FF-000111', NULL, NULL, 67, NULL, NULL, 210438),
(210439, '1.25.40.10-FF-001179', NULL, 'Pentatricopeptide repeat-containing protein isoform A', 182, NULL, NULL, 210439),
(210440, '3.30.160.60-FF-005244', NULL, NULL, 56, NULL, NULL, 210440),
(210441, '3.40.50.300-FF-001624', NULL, 'Dynein heavy chain-like protein', 327, NULL, NULL, 210441),
(210442, '3.90.180.10-FF-000147', NULL, '2-haloacrylate reductase', 172, NULL, NULL, 210442);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(210443, '1.20.58.60-FF-000071', NULL, 'Spectrin alpha chain, non-erythrocytic 1', 104, NULL, NULL, 210443),
(210444, '3.40.50.1240-FF-000096', NULL, 'Uncharacterized protein', 238, NULL, NULL, 210444),
(210445, '3.50.30.30-FF-000110', NULL, 'Inactive zinc metalloprotease C354.09c', 223, NULL, NULL, 210445),
(210446, '2.130.10.10-FF-003361', NULL, 'CMGC family protein kinase', 328, NULL, NULL, 210446),
(210447, '3.40.50.1400-FF-000020', NULL, 'Ferrochelatase', 162, NULL, NULL, 210447),
(210448, '3.40.50.300-FF-000045', NULL, 'dynamin-1 isoform X2', 299, NULL, NULL, 210448),
(210449, '3.40.50.1820-FF-000584', NULL, '1-alkyl-2-acetylglycerophosphocholine esterase', 375, NULL, NULL, 210449),
(210450, '1.10.720.60-FF-000010', NULL, 'Enolase-phosphatase E1', 98, NULL, NULL, 210450),
(210451, '1.25.40.80-FF-000014', NULL, 'Deoxyribodipyrimidine photolyase, putative', 121, NULL, NULL, 210451),
(210452, '3.30.420.10-FF-000590', NULL, NULL, 205, NULL, NULL, 210452),
(210453, '3.40.50.300-FF-005481', NULL, 'ATP-dependent RNA helicase RhlE', 209, NULL, NULL, 210453),
(210454, '1.25.40.10-FF-004905', NULL, 'Predicted protein', 77, NULL, NULL, 210454),
(210455, '3.20.20.70-FF-000139', NULL, 'Phospho-2-dehydro-3-deoxyheptonate aldolase', 162, NULL, NULL, 210455),
(210456, '3.20.20.60-FF-000136', NULL, 'Isocitrate lyase', 244, NULL, NULL, 210456),
(210457, '2.60.220.50-FF-000095', NULL, 'Sperm receptor for egg jelly', 74, NULL, NULL, 210457),
(210458, '3.40.720.10-FF-000138', NULL, 'Acid phosphatase', 112, NULL, NULL, 210458),
(210459, '2.10.25.10-FF-000843', NULL, 'Integrin beta', 57, NULL, NULL, 210459),
(210460, '2.40.50.140-FF-001035', NULL, NULL, 140, NULL, NULL, 210460),
(210461, '1.20.58.60-FF-000447', NULL, 'Spectrin repeat containing nuclear envelope family member 3', 257, NULL, NULL, 210461),
(210462, '1.10.8.530-FF-000010', NULL, 'DNA polymerase alpha subunit B-like Protein', 74, NULL, NULL, 210462),
(210463, '3.60.10.10-FF-000170', NULL, 'Uncharacterized protein', 74, NULL, NULL, 210463),
(210464, '3.30.160.60-FF-003299', NULL, 'Uncharacterized protein', 27, NULL, NULL, 210464),
(210465, '1.20.1070.10-FF-000099', NULL, 'D(2) dopamine receptor', 113, NULL, NULL, 210465),
(210466, '2.20.70.10-FF-000245', NULL, 'Chromosome 9, whole genome shotgun sequence', 31, NULL, NULL, 210466),
(210467, '2.30.29.30-FF-000447', NULL, 'RanBP-type and C3HC4-type zinc finger-containing protein 1', 129, NULL, NULL, 210467),
(210468, '1.25.40.820-FF-000029', NULL, 'Uncharacterized protein', 159, NULL, NULL, 210468),
(210469, '3.80.10.10-FF-000736', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 142, NULL, NULL, 210469),
(210470, '3.40.50.300-FF-007077', NULL, 'Uncharacterized protein', 193, NULL, NULL, 210470),
(210471, '2.60.40.3980-FF-000003', NULL, NULL, 102, NULL, NULL, 210471),
(210472, '3.40.50.150-FF-001293', NULL, NULL, 303, NULL, NULL, 210472),
(210473, '3.20.20.100-FF-000107', NULL, 'Putative oxidoreductase-possibly Aldo/keto reductase', 301, NULL, NULL, 210473),
(210474, '3.30.465.10-FF-000081', NULL, 'Magnesium and cobalt efflux protein CorC', 89, NULL, NULL, 210474),
(210475, '1.20.1250.20-FF-000644', NULL, 'Solute carrier organic anion transporter family member', 385, NULL, NULL, 210475),
(210476, '3.30.710.10-FF-000067', NULL, 'Potassium voltage-gated channel subfamily V member 1', 130, NULL, NULL, 210476),
(210477, '3.30.160.60-FF-003153', NULL, 'Zinc finger and SCAN domain containing 20', 22, NULL, NULL, 210477),
(210478, '4.10.240.10-FF-000172', NULL, 'Fungal-specific transcription factor domain-domain-containing protein', 61, NULL, NULL, 210478),
(210479, '1.25.40.90-FF-000017', NULL, 'Phosphatidylinositol-binding clathrin assembly protein LAP', 155, NULL, NULL, 210479),
(210480, '3.30.450.20-FF-000504', NULL, 'Histidine kinase', 156, NULL, NULL, 210480),
(210481, '2.130.10.10-FF-003737', NULL, 'WD-repeat protein, putative', 333, NULL, NULL, 210481),
(210482, '2.60.40.10-FF-000207', NULL, 'Tenascin C', 67, NULL, NULL, 210482),
(210483, '3.30.200.60-FF-000009', NULL, 'Ubiquitin thioesterase otubain-like', 40, NULL, NULL, 210483);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(210484, '3.30.40.10-FF-001460', NULL, 'Uncharacterized protein', 88, NULL, NULL, 210484),
(210485, '3.40.50.1820-FF-000674', NULL, 'Expressed protein', 298, NULL, NULL, 210485),
(210486, '1.10.600.10-FF-000094', NULL, 'Selina-4(15),7(11)-diene synthase ((2E,6E)-farnesyl diphosphate cyclizing)', 348, NULL, NULL, 210486),
(210487, '3.40.50.150-FF-001613', NULL, NULL, 251, NULL, NULL, 210487),
(210488, '2.60.40.10-FF-003552', NULL, NULL, 103, NULL, NULL, 210488),
(210489, '3.30.230.10-FF-000283', NULL, 'Elongation factor G 1', 129, NULL, NULL, 210489),
(210490, '1.20.58.1120-FF-000065', NULL, NULL, 155, NULL, NULL, 210490),
(210491, '3.90.640.10-FF-000290', NULL, 'DnaK protein', 87, NULL, NULL, 210491),
(210492, '1.20.1070.10-FF-002044', NULL, 'Uncharacterized protein', 109, NULL, NULL, 210492),
(210493, '1.50.40.10-FF-000154', NULL, 'Unplaced genomic scaffold supercont2.19, whole genome shotgun sequence', 253, NULL, NULL, 210493),
(210494, '1.10.10.790-FF-000035', NULL, NULL, 104, NULL, NULL, 210494),
(210495, '2.30.29.30-FF-000071', NULL, 'Enah/Vasp-like, isoform CRA_a', 118, NULL, NULL, 210495),
(210496, '3.30.300.20-FF-000027', NULL, 'Small GTP-binding protein', 87, NULL, NULL, 210496),
(210497, '3.40.50.10090-FF-000006', NULL, 'uroporphyrinogen-III synthase isoform X1', 99, NULL, NULL, 210497),
(210498, '2.60.40.10-FF-003613', NULL, 'Vascular endothelial growth factor receptor 3', 99, NULL, NULL, 210498),
(210499, '2.10.110.20-FF-000010', NULL, NULL, 69, NULL, NULL, 210499),
(210500, '3.40.50.300-FF-007138', NULL, 'Uncharacterized protein', 179, NULL, NULL, 210500),
(210501, '3.40.50.620-FF-000793', NULL, 'Uncharacterized protein', 52, NULL, NULL, 210501),
(210502, '2.60.40.1390-FF-000024', NULL, 'Uncharacterized protein', 59, NULL, NULL, 210502),
(210503, '3.80.10.10-FF-002361', NULL, 'Cytoplasmic membrane protein', 72, NULL, NULL, 210503),
(210504, '1.10.238.10-FF-000200', NULL, 'Phosphatidylserine decarboxylase proenzyme 2', 82, NULL, NULL, 210504),
(210505, '3.30.930.10-FF-000055', NULL, 'Serine--tRNA ligase', 325, NULL, NULL, 210505),
(210506, '3.20.20.140-FF-000125', NULL, 'Male-specific IDGF', 478, NULL, NULL, 210506),
(210507, '2.60.40.3510-FF-000031', NULL, 'Delta-like protein', 94, NULL, NULL, 210507),
(210508, '1.25.40.70-FF-000011', NULL, 'Phosphatidylinositol 4-kinase alpha', 166, NULL, NULL, 210508),
(210509, '1.25.40.20-FF-000075', NULL, 'E3 ubiquitin-protein ligase MIB2 isoform X1', 91, NULL, NULL, 210509),
(210510, '3.30.160.20-FF-000224', NULL, 'Uncharacterized protein', 91, NULL, NULL, 210510),
(210511, '1.25.10.10-FF-003268', NULL, 'Kinesin-like protein', 206, NULL, NULL, 210511),
(210512, '3.30.750.24-FF-000083', NULL, 'Sulfate transporter-like protein', 155, NULL, NULL, 210512),
(210513, '2.60.40.10-FF-000972', NULL, 'Phosphoglucan phosphatase LSF1, chloroplastic', 98, NULL, NULL, 210513),
(210514, '3.40.50.300-FF-004497', NULL, 'IcmO', 235, NULL, NULL, 210514),
(210515, '2.20.28.200-FF-000005', NULL, 'Mono-ADP-ribosyltransferase sirtuin-6 protein', 60, NULL, NULL, 210515),
(210516, '3.40.50.2000-FF-000329', NULL, 'Lipopolysaccharide biosynthesis protein RfbV', 163, NULL, NULL, 210516),
(210517, '3.40.1800.20-FF-000023', NULL, 'GG16747', 74, NULL, NULL, 210517),
(210518, '3.30.70.890-FF-000003', NULL, 'Mevalonate kinase', 149, NULL, NULL, 210518),
(210519, '3.30.200.20-FF-001071', NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase', 86, NULL, NULL, 210519),
(210520, '1.20.120.1910-FF-000012', NULL, 'Cysteine--tRNA ligase', 144, NULL, NULL, 210520),
(210521, '3.30.420.40-FF-000981', NULL, 'Actin-related protein 8', 124, NULL, NULL, 210521),
(210522, '3.90.1150.10-FF-000369', NULL, 'Threonine aldolase', 91, NULL, NULL, 210522),
(210523, '3.60.21.10-FF-000010', NULL, 'Serine/threonine-protein phosphatase', 307, NULL, NULL, 210523),
(210524, '3.30.40.10-FF-000971', NULL, 'Putative RING zinc finger domain superfamily protein', 73, NULL, NULL, 210524),
(210525, '3.60.40.10-FF-000172', NULL, 'Unplaced genomic scaffold supercont2.16, whole genome shotgun sequence', 317, NULL, NULL, 210525);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(210526, '3.40.50.11540-FF-000003', NULL, 'NAD-dependent formate dehydrogenase flavoprotein subunit', 169, NULL, NULL, 210526),
(210527, '2.130.10.10-FF-004665', NULL, 'Uncharacterized protein', 185, NULL, NULL, 210527),
(210528, '2.60.200.30-FF-000031', NULL, 'Blr5515 protein', 85, NULL, NULL, 210528),
(210529, '1.10.8.1310-FF-000006', NULL, 'Rab GTPase activating protein, putative', 133, NULL, NULL, 210529),
(210530, '3.50.50.60-FF-000654', NULL, 'D-amino acid dehydrogenase subunit', 81, NULL, NULL, 210530),
(210531, '2.10.90.10-FF-000151', NULL, 'Invected', 158, NULL, NULL, 210531),
(210532, '1.20.1250.20-FF-002319', NULL, 'Uncharacterized protein', 79, NULL, NULL, 210532),
(210533, '2.60.200.40-FF-000034', NULL, 'Diacylglycerol kinase', 180, NULL, NULL, 210533),
(210534, '3.40.50.1820-FF-001045', NULL, 'Uncharacterized protein', 83, NULL, NULL, 210534),
(210535, '3.40.50.300-FF-002928', NULL, 'DEAD/DEAH box helicase, putative', 180, NULL, NULL, 210535),
(210536, '3.80.10.10-FF-002125', NULL, 'Uncharacterized protein', 170, NULL, NULL, 210536),
(210537, '1.10.510.10-FF-003262', NULL, NULL, 110, NULL, NULL, 210537),
(210538, '1.50.40.10-FF-000570', NULL, 'ADP/ATP carrier protein', 85, NULL, NULL, 210538),
(210539, '3.40.190.10-FF-000647', NULL, 'ABC transporter substrate-binding protein', 314, NULL, NULL, 210539),
(210540, '2.60.120.200-FF-000347', NULL, 'OSJNBa0027H06.9 protein', 153, NULL, NULL, 210540),
(210541, '1.25.40.10-FF-003416', NULL, 'Os03g0861900 protein', 113, NULL, NULL, 210541),
(210542, '3.40.50.200-FF-000105', NULL, 'Subtilisin-like protein', 314, NULL, NULL, 210542),
(210543, '3.40.850.10-FF-000468', NULL, 'Kinesin-like protein', 365, NULL, NULL, 210543),
(210544, '2.20.100.10-FF-000190', NULL, 'A disintegrin-like and metallopeptidase (reprolysin type) with thrombospondin type 1 motif, 17', 60, NULL, NULL, 210544),
(210545, '3.40.50.300-FF-003390', NULL, 'Uncharacterized protein', 58, NULL, NULL, 210545),
(210546, '1.10.510.10-FF-003026', NULL, NULL, 265, NULL, NULL, 210546),
(210547, '3.40.430.10-FF-000037', NULL, 'Dihydrofolate reductase', 168, NULL, NULL, 210547),
(210548, '3.40.50.800-FF-000072', NULL, 'Prolyl-tRNA synthetase', 128, NULL, NULL, 210548),
(210549, '3.40.50.1820-FF-000730', NULL, 'GPI inositol-deacylase', 211, NULL, NULL, 210549),
(210550, '2.60.120.430-FF-000034', NULL, 'Predicted protein', 173, NULL, NULL, 210550),
(210551, '2.40.128.20-FF-000061', NULL, 'Uncharacterized protein', 102, NULL, NULL, 210551),
(210552, '3.30.160.60-FF-003327', NULL, 'Uncharacterized protein', 75, NULL, NULL, 210552),
(210553, '2.60.40.10-FF-005502', NULL, NULL, 93, NULL, NULL, 210553),
(210554, '3.40.50.300-FF-006970', NULL, 'Uncharacterized protein', 311, NULL, NULL, 210554),
(210555, '1.10.510.10-FF-001463', NULL, 'Uncharacterized protein', 205, NULL, NULL, 210555),
(210556, '3.90.1150.10-FF-000077', NULL, 'Glycine cleavage system P protein', 70, NULL, NULL, 210556),
(210557, '3.30.450.20-FF-000274', NULL, 'Cyclic di-GMP phosphodiesterase Gmr', 138, NULL, NULL, 210557),
(210558, '1.20.1070.10-FF-000745', NULL, 'Olfactory receptor 1508', 127, NULL, NULL, 210558),
(210559, '3.30.160.60-FF-003855', NULL, NULL, 59, NULL, NULL, 210559),
(210560, '3.20.90.10-FF-000002', NULL, 'Tubby like protein 4', 168, NULL, NULL, 210560),
(210561, '3.90.190.10-FF-000209', NULL, 'Protein tyrosine phosphatase 1', 170, NULL, NULL, 210561),
(210562, '1.20.1560.10-FF-000327', NULL, 'ABC transporter, ATP binding protein', 342, NULL, NULL, 210562),
(210563, '3.40.50.150-FF-001383', NULL, NULL, 174, NULL, NULL, 210563),
(210564, '1.10.486.10-FF-000023', NULL, 'RecBCD enzyme subunit RecB', 145, NULL, NULL, 210564),
(210565, '1.20.58.60-FF-000626', NULL, 'Spectrin repeat-containing, nuclear envelope 1b', 110, NULL, NULL, 210565),
(210566, '1.20.1250.20-FF-002084', NULL, 'Uncharacterized protein', 267, NULL, NULL, 210566),
(210567, '3.30.420.40-FF-000778', NULL, 'Actin-related protein 7', 68, NULL, NULL, 210567),
(210568, '3.40.718.10-FF-000048', NULL, 'Isocitrate dehydrogenase [NAD] regulatory subunit 3 mitochondrial', 160, NULL, NULL, 210568);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(210569, '1.20.1070.10-FF-000217', NULL, 'neurotensin receptor type 1', 332, NULL, NULL, 210569),
(210570, '2.130.10.10-FF-002102', NULL, 'GD25262', 337, NULL, NULL, 210570),
(210571, '1.10.1390.10-FF-000007', NULL, NULL, 29, NULL, NULL, 210571),
(210572, '1.50.10.20-FF-000099', NULL, 'Uncharacterized protein', 213, NULL, NULL, 210572),
(210573, '3.40.50.1220-FF-000090', NULL, 'Thiamine diphosphate-binding protein', 167, NULL, NULL, 210573),
(210574, '3.40.50.1820-FF-000056', NULL, 'GPI inositol-deacylase', 242, NULL, NULL, 210574),
(210575, '1.10.630.10-FF-000426', NULL, 'Uncharacterized protein', 199, NULL, NULL, 210575),
(210576, '1.10.10.540-FF-000011', NULL, 'UV excision repair protein, putative', 67, NULL, NULL, 210576),
(210577, '3.40.50.300-FF-001478', NULL, 'Similar to late competence protein comGA', 235, NULL, NULL, 210577),
(210578, '3.30.70.1320-FF-000004', NULL, 'Efflux pump membrane transporter', 100, NULL, NULL, 210578),
(210579, '1.25.40.180-FF-000062', NULL, 'CCR4-not transcription complex, putative', 209, NULL, NULL, 210579),
(210580, '2.60.40.60-FF-000998', NULL, 'Uncharacterized protein', 119, NULL, NULL, 210580),
(210581, '1.20.1110.10-FF-000013', NULL, 'Calcium-transporting ATPase', 174, NULL, NULL, 210581),
(210582, '2.60.40.150-FF-000031', NULL, 'Protein unc-13 homolog B', 128, NULL, NULL, 210582),
(210583, '1.20.120.850-FF-000013', NULL, 'Rad54p', 99, NULL, NULL, 210583),
(210584, '2.30.130.30-FF-000004', NULL, 'Activating signal cointegrator 1', 116, NULL, NULL, 210584),
(210585, '3.30.160.60-FF-002225', NULL, 'Uncharacterized protein', 27, NULL, NULL, 210585),
(210586, '1.10.1520.10-FF-000041', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 198, NULL, NULL, 210586),
(210587, '3.90.370.10-FF-000015', NULL, 'Uncharacterized protein', 55, NULL, NULL, 210587),
(210588, '3.90.25.10-FF-000034', NULL, 'Unplaced genomic scaffold supercont1.17, whole genome shotgun sequence', 79, NULL, NULL, 210588),
(210589, '3.40.50.2300-FF-000099', NULL, 'Eg435916, gene 1', 162, NULL, NULL, 210589),
(210590, '3.80.10.10-FF-000118', NULL, 'Leucine rich repeat containing 7', 297, NULL, NULL, 210590),
(210591, '2.10.25.10-FF-000753', NULL, 'Laminin subunit alpha-3', 54, NULL, NULL, 210591),
(210592, '1.20.1250.20-FF-001100', NULL, 'MFS transporter, putative', 427, NULL, NULL, 210592),
(210593, '3.30.780.10-FF-000015', NULL, 'Translation initiation factor SUI1, putative', 120, NULL, NULL, 210593),
(210594, '2.10.220.10-FF-000009', NULL, 'Receptor protein-tyrosine kinase', 140, NULL, NULL, 210594),
(210595, '3.30.230.70-FF-000166', NULL, 'Uncharacterized protein', 151, NULL, NULL, 210595),
(210596, '1.20.58.60-FF-000773', NULL, 'Si:ch211-207i1.2', 236, NULL, NULL, 210596),
(210597, '1.25.40.180-FF-000146', NULL, 'Uncharacterized protein', 293, NULL, NULL, 210597),
(210598, '3.40.50.300-FF-007133', NULL, 'Small GTP-binding protein, putative', 181, NULL, NULL, 210598),
(210599, '2.10.25.10-FF-001771', NULL, 'Uncharacterized protein', 35, NULL, NULL, 210599),
(210600, '1.25.40.10-FF-003326', NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', 102, NULL, NULL, 210600),
(210601, '3.30.465.10-FF-000086', NULL, 'Uncharacterized protein', 137, NULL, NULL, 210601),
(210602, '2.40.50.140-FF-000664', NULL, NULL, 74, NULL, NULL, 210602),
(210603, '2.60.40.10-FF-001079', NULL, 'Interleukin 12 receptor subunit beta 2', 87, NULL, NULL, 210603),
(210604, '3.30.9.10-FF-000151', NULL, 'AGAP001098-PA', 140, NULL, NULL, 210604),
(210605, '1.20.1280.50-FF-000071', NULL, 'Secretion pathway protein Sls2/Rcy1, putative', 87, NULL, NULL, 210605),
(210606, '3.40.50.200-FF-000015', NULL, 'Tripeptidyl peptidase A', 379, NULL, NULL, 210606),
(210607, '1.25.40.10-FF-003124', NULL, 'Pentatricopeptide repeat-containing protein At4g21170', 104, NULL, NULL, 210607),
(210608, '3.40.50.10580-FF-000002', NULL, 'V-type proton ATPase subunit F', 117, NULL, NULL, 210608),
(210609, '1.10.472.130-FF-000013', NULL, 'Dynein heavy chain-like protein', 172, NULL, NULL, 210609),
(210610, '2.60.40.150-FF-000767', NULL, 'Uncharacterized protein', 125, NULL, NULL, 210610);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(210611, '3.40.50.300-FF-001826', NULL, 'Nickel import system ATP-binding protein NikD', 255, NULL, NULL, 210611),
(210612, '3.40.850.10-FF-000524', NULL, 'Predicted protein', 97, NULL, NULL, 210612),
(210613, '3.40.1110.10-FF-000333', NULL, NULL, 132, NULL, NULL, 210613),
(210614, '1.10.510.10-FF-001284', NULL, 'Guanylate cyclase', 238, NULL, NULL, 210614),
(210615, '2.60.120.10-FF-000159', NULL, 'Cyclic nucleotide-binding domain protein', 203, NULL, NULL, 210615),
(210616, '3.40.190.10-FF-000794', NULL, 'Prephenate dehydratase', 81, NULL, NULL, 210616),
(210617, '2.30.30.100-FF-000190', NULL, 'Small nuclear ribonucleoprotein E', 64, NULL, NULL, 210617),
(210618, '3.60.40.10-FF-000374', NULL, 'Uncharacterized protein', 248, NULL, NULL, 210618),
(210619, '3.40.50.300-FF-005340', NULL, 'Putative moxR protein', 201, NULL, NULL, 210619),
(210620, '1.10.510.10-FF-001137', NULL, 'Isr1p', 285, NULL, NULL, 210620),
(210621, '1.10.10.10-FF-001172', NULL, 'Predicted protein', 70, NULL, NULL, 210621),
(210622, '1.25.40.10-FF-004670', NULL, 'Uncharacterized protein', 111, NULL, NULL, 210622),
(210623, '3.40.50.2000-FF-000599', NULL, 'Chitobiosyldiphosphodolichol beta-mannosyltransferase', 175, NULL, NULL, 210623),
(210624, '1.50.40.10-FF-000300', NULL, 'Probable mitochondrial 2-oxoglutarate/malate carrier protein', 298, NULL, NULL, 210624),
(210625, '3.40.50.620-FF-000821', NULL, 'Uncharacterized protein', 348, NULL, NULL, 210625),
(210626, '4.10.10.10-FF-000001', NULL, 'Metallothionein', 61, NULL, NULL, 210626),
(210627, '2.60.40.10-FF-003557', NULL, NULL, 106, NULL, NULL, 210627),
(210628, '3.90.190.10-FF-000119', NULL, 'Tyrosine-protein phosphatase non-receptor type', 248, NULL, NULL, 210628),
(210629, '3.30.360.20-FF-000003', NULL, 'RNA 3''-terminal phosphate cyclase', 91, NULL, NULL, 210629),
(210630, '3.80.10.10-FF-002035', NULL, 'Uncharacterized protein', 168, NULL, NULL, 210630),
(210631, '2.60.120.260-FF-000427', NULL, 'Putative secreted ATP/GTP binding protein', 104, NULL, NULL, 210631),
(210632, '1.25.40.10-FF-003742', NULL, 'Embryo specific2', 141, NULL, NULL, 210632),
(210633, '2.60.40.10-FF-001135', NULL, 'Usherin', 90, NULL, NULL, 210633),
(210634, '3.30.450.20-FF-000358', NULL, 'Two-component hybrid sensor and regulator', 121, NULL, NULL, 210634),
(210635, '3.80.10.10-FF-004250', NULL, 'Uncharacterized protein', 70, NULL, NULL, 210635),
(210636, '3.90.1520.10-FF-000004', NULL, 'soluble guanylate cyclase 89Da', 181, NULL, NULL, 210636),
(210637, '2.30.29.30-FF-000834', NULL, 'amyloid beta A4 precursor protein-binding family B member 1-interacting protein-like isoform X3', 167, NULL, NULL, 210637),
(210638, '3.40.50.2300-FF-001318', NULL, NULL, 106, NULL, NULL, 210638),
(210639, '3.30.60.90-FF-000012', NULL, 'Sequestosome 1', 53, NULL, NULL, 210639),
(210640, '3.30.200.20-FF-001099', NULL, 'Fructosamine kinase family protein', 93, NULL, NULL, 210640),
(210641, '3.40.30.10-FF-000711', NULL, 'Elongation factor 1-gamma', 79, NULL, NULL, 210641),
(210642, '1.10.1670.40-FF-000004', NULL, 'Putative DNA-3-methyladenine glycosylase', 91, NULL, NULL, 210642),
(210643, '3.30.70.330-FF-002505', NULL, NULL, 71, NULL, NULL, 210643),
(210644, '2.60.40.420-FF-000073', NULL, 'Laccase 2, isoform E', 192, NULL, NULL, 210644),
(210645, '1.10.238.10-FF-001184', NULL, 'Uncharacterized protein', 87, NULL, NULL, 210645),
(210646, '3.30.310.80-FF-000052', NULL, 'Non-specific serine/threonine protein kinase', 89, NULL, NULL, 210646),
(210647, '3.30.200.20-FF-002549', NULL, 'Uncharacterized protein', 89, NULL, NULL, 210647),
(210648, '2.170.16.10-FF-000023', NULL, 'Replication factor C small subunit', 124, NULL, NULL, 210648),
(210649, '2.60.120.260-FF-000079', NULL, 'Anaphase-promoting complex subunit 10', 169, NULL, NULL, 210649),
(210650, '1.20.1050.10-FF-000244', NULL, 'Uncharacterized protein', 62, NULL, NULL, 210650),
(210651, '2.130.10.10-FF-002838', NULL, 'Uncharacterized protein', 360, NULL, NULL, 210651),
(210652, '2.40.50.140-FF-001030', NULL, NULL, 146, NULL, NULL, 210652),
(210653, '1.10.10.10-FF-001520', NULL, 'Uncharacterized protein', 84, NULL, NULL, 210653);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(210654, '3.90.190.10-FF-000092', NULL, 'Tyrosine-protein phosphatase 69D', 296, NULL, NULL, 210654),
(210655, '2.60.490.10-FF-000006', NULL, 'P2X receptor B', 173, NULL, NULL, 210655),
(210656, '2.30.29.30-FF-000306', NULL, 'Uncharacterized protein, isoform A', 142, NULL, NULL, 210656),
(210657, '2.70.180.20-FF-000001', NULL, 'Endonuclease NucS', 120, NULL, NULL, 210657),
(210658, '2.10.60.10-FF-000031', NULL, 'Lymphocyte antigen 6 family member K', 82, NULL, NULL, 210658),
(210659, '3.30.470.10-FF-000031', NULL, 'Branched-chain-amino-acid aminotransferase atnH', 153, NULL, NULL, 210659),
(210660, '1.10.10.60-FF-001248', NULL, NULL, 74, NULL, NULL, 210660),
(210661, '3.30.70.141-FF-000044', NULL, NULL, 133, NULL, NULL, 210661),
(210662, '3.30.1490.20-FF-000023', NULL, 'D-alanine--D-alanine ligase', 66, NULL, NULL, 210662),
(210663, '3.40.50.300-FF-005188', NULL, 'Zgc:136870', 215, NULL, NULL, 210663),
(210664, '2.10.25.10-FF-001799', NULL, 'Uncharacterized protein', 27, NULL, NULL, 210664),
(210665, '3.40.50.300-FF-006205', NULL, 'Peroxisomal biogenesis factor 1', 98, NULL, NULL, 210665),
(210666, '1.25.40.10-FF-003091', NULL, 'Activator of C kinase protein 1', 161, NULL, NULL, 210666),
(210667, '2.130.10.10-FF-000955', NULL, 'Putative CPSF (Cleavage and polyadenylation specific factor), subunit A', 378, NULL, NULL, 210667),
(210668, '3.30.470.20-FF-000034', NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', 185, NULL, NULL, 210668),
(210669, '2.60.120.10-FF-000311', NULL, 'AGAP002094-PA', 105, NULL, NULL, 210669),
(210670, '3.30.1370.10-FF-000096', NULL, 'KH domain-containing protein', 84, NULL, NULL, 210670),
(210671, '2.130.10.10-FF-001259', NULL, 'LD41558p', 259, NULL, NULL, 210671),
(210672, '2.130.10.10-FF-001444', NULL, 'Radiation sensitive protein', 308, NULL, NULL, 210672),
(210673, '1.10.3520.10-FF-000013', NULL, 'Uncharacterized protein', 60, NULL, NULL, 210673),
(210674, '1.25.40.470-FF-000082', NULL, 'Uncharacterized protein', 189, NULL, NULL, 210674),
(210675, '3.40.50.300-FF-005716', NULL, 'Disease resistance RPP13-like protein 4', 164, NULL, NULL, 210675),
(210676, '2.60.40.150-FF-000121', NULL, 'Synaptotagmin-like 4, isoform CRA_a', 161, NULL, NULL, 210676),
(210677, '3.40.630.30-FF-000025', NULL, 'Aminoglycoside acetyltransferase', 184, NULL, NULL, 210677),
(210678, '1.20.920.10-FF-000205', NULL, 'Uncharacterized protein', 118, NULL, NULL, 210678),
(210679, '3.40.50.720-FF-002318', NULL, 'Uncharacterized protein', 123, NULL, NULL, 210679),
(210680, '1.20.5.350-FF-000021', NULL, NULL, 151, NULL, NULL, 210680),
(210681, '2.30.40.10-FF-000102', NULL, 'LAF3/LAF3 ISF1/LAF3 ISF2', 69, NULL, NULL, 210681),
(210682, '3.30.710.10-FF-000213', NULL, 'Uncharacterized protein', 120, NULL, NULL, 210682),
(210683, '3.40.1380.20-FF-000030', NULL, 'Pyruvate kinase', 153, NULL, NULL, 210683),
(210684, '3.40.630.20-FF-000022', NULL, 'Uncharacterized protein', 251, NULL, NULL, 210684),
(210685, '1.20.120.1760-FF-000034', NULL, 'Phosphatidylcholine synthase', 165, NULL, NULL, 210685),
(210686, '3.40.47.10-FF-000278', NULL, NULL, 61, NULL, NULL, 210686),
(210687, '3.30.800.10-FF-000012', NULL, 'Phosphatidylinositol 5-phosphate 4-kinase, isoform A', 180, NULL, NULL, 210687),
(210688, '3.30.110.10-FF-000015', NULL, 'Translation initiation factor IF-3, C-terminal domain', 94, NULL, NULL, 210688),
(210689, '1.10.8.10-FF-000226', NULL, 'Non-specific serine/threonine protein kinase', 58, NULL, NULL, 210689),
(210690, '2.40.240.20-FF-000007', NULL, 'Ribosomal RNA small subunit methyltransferase E', 73, NULL, NULL, 210690),
(210691, '3.90.1440.10-FF-000003', NULL, 'Preprotein translocase SecA subunit', 121, NULL, NULL, 210691),
(210692, '3.40.50.300-FF-004789', NULL, 'Cell division control protein 48 homolog C', 86, NULL, NULL, 210692),
(210693, '3.30.1370.10-FF-000186', NULL, 'KH homology domain-containing protein 4-like', 93, NULL, NULL, 210693),
(210694, '1.10.840.10-FF-000021', NULL, 'Cell division cycle-related protein', 225, NULL, NULL, 210694),
(210695, '2.40.50.430-FF-000009', NULL, 'Probable DNA polymerase delta small subunit', 133, NULL, NULL, 210695);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(210696, '3.30.160.60-FF-004788', NULL, NULL, 22, NULL, NULL, 210696),
(210697, '3.40.50.150-FF-001467', NULL, NULL, 133, NULL, NULL, 210697),
(210698, '3.40.50.150-FF-001091', NULL, NULL, 210, NULL, NULL, 210698),
(210699, '3.40.50.720-FF-001216', NULL, '3-oxoacyl-[acyl-carrier-protein] reductase', 224, NULL, NULL, 210699),
(210700, '2.30.29.30-FF-000273', NULL, 'alsin isoform X3', 134, NULL, NULL, 210700),
(210701, '3.40.640.10-FF-000278', NULL, 'Glutamate decarboxylase 1', 175, NULL, NULL, 210701),
(210702, '3.30.390.30-FF-000036', NULL, 'Mercuric reductase', 125, NULL, NULL, 210702),
(210703, '1.25.10.10-FF-001380', NULL, 'AP-3 adaptor complex subunit, putative', 601, NULL, NULL, 210703),
(210704, '3.40.30.10-FF-000037', NULL, 'Co-chaperone YbbN', 112, NULL, NULL, 210704),
(210705, '3.40.390.10-FF-000303', NULL, NULL, 248, NULL, NULL, 210705),
(210706, '3.30.40.10-FF-002393', NULL, 'Predicted protein', 76, NULL, NULL, 210706),
(210707, '1.10.167.10-FF-000001', NULL, 'Putative regulator of g-protein signaling 12', 73, NULL, NULL, 210707),
(210708, '3.80.10.10-FF-002653', NULL, 'Uncharacterized protein', 218, NULL, NULL, 210708),
(210709, '1.20.120.550-FF-000018', NULL, 'Uncharacterized protein', 144, NULL, NULL, 210709),
(210710, '3.40.50.800-FF-000105', NULL, 'Threonine--tRNA ligase', 106, NULL, NULL, 210710),
(210711, '3.40.50.720-FF-001981', NULL, '3-hydroxybutyrate dehydrogenase type 2-like', 248, NULL, NULL, 210711),
(210712, '3.30.930.10-FF-000229', NULL, 'phenylalanine--tRNA ligase beta subunit isoform X2', 50, NULL, NULL, 210712),
(210713, '2.130.10.10-FF-005160', NULL, 'Uncharacterized protein', 138, NULL, NULL, 210713),
(210714, '3.40.50.720-FF-000379', NULL, 'Oxidoreductase, zinc-binding dehydrogenase family', 134, NULL, NULL, 210714),
(210715, '3.10.129.110-FF-000011', NULL, 'Polyketide synthase RzxE', 275, NULL, NULL, 210715),
(210716, '1.20.1560.10-FF-000474', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 319, NULL, NULL, 210716),
(210717, '1.20.1070.10-FF-000127', NULL, 'Parathyroid hormone 2 receptor', 309, NULL, NULL, 210717),
(210718, '1.10.510.10-FF-003352', NULL, NULL, 236, NULL, NULL, 210718),
(210719, '2.60.120.680-FF-000002', NULL, 'Putative Golgi resident protein GCP60', 163, NULL, NULL, 210719),
(210720, '2.10.110.10-FF-000327', NULL, 'Predicted protein', 67, NULL, NULL, 210720),
(210721, '2.60.260.40-FF-000010', NULL, 'NADH:ubiquinone oxidoreductase subunit S6', 37, NULL, NULL, 210721),
(210722, '3.30.200.20-FF-001447', NULL, 'Predicted protein', 80, NULL, NULL, 210722),
(210723, '1.10.1040.10-FF-000105', NULL, 'Uncharacterized protein', 93, NULL, NULL, 210723),
(210724, '3.40.710.10-FF-000020', NULL, 'Penicillin-binding protein 1A', 373, NULL, NULL, 210724),
(210725, '3.30.930.10-FF-000201', NULL, 'Related to lipoate--protein ligase B', 224, NULL, NULL, 210725),
(210726, '1.25.40.10-FF-003652', NULL, 'Uncharacterized protein', 184, NULL, NULL, 210726),
(210727, '3.30.110.20-FF-000018', NULL, 'Uncharacterized protein', 228, NULL, NULL, 210727),
(210728, '3.65.10.20-FF-000022', NULL, 'Predicted protein', 210, NULL, NULL, 210728),
(210729, '1.10.287.850-FF-000003', NULL, 'PE family protein PE25', 99, NULL, NULL, 210729),
(210730, '2.60.98.60-FF-000001', NULL, 'Protein CBR-EFF-1, isoform a', 129, NULL, NULL, 210730),
(210731, '2.40.37.10-FF-000049', NULL, 'Antizyme inhibitor 2', 145, NULL, NULL, 210731),
(210732, '3.60.10.10-FF-000344', NULL, 'Uncharacterized protein', 207, NULL, NULL, 210732),
(210733, '2.40.240.10-FF-000004', NULL, 'Glutamyl-tRNA synthetase, cytoplasmic', 82, NULL, NULL, 210733),
(210734, '1.20.1540.10-FF-000096', NULL, 'Uncharacterized protein', 224, NULL, NULL, 210734),
(210735, '1.25.40.10-FF-004872', NULL, 'Developmental protein DG1091', 230, NULL, NULL, 210735),
(210736, '3.30.1360.40-FF-000025', NULL, 'DNA topoisomerase 2', 108, NULL, NULL, 210736),
(210737, '2.30.30.490-FF-000019', NULL, 'Chromatin remodeling protein EBS', 139, NULL, NULL, 210737),
(210738, '3.40.50.300-FF-005514', NULL, 'DEAD-box helicase 3 X-linked b', 151, NULL, NULL, 210738);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(210739, '3.30.450.20-FF-000651', NULL, 'Sensory transduction histidine kinase', 117, NULL, NULL, 210739),
(210740, '3.90.190.10-FF-000035', NULL, 'Tyrosine phosphatase, putative', 151, NULL, NULL, 210740),
(210741, '3.20.20.100-FF-000074', NULL, 'Oxidoreductase, aldo/keto reductase family', 234, NULL, NULL, 210741),
(210742, '2.60.120.200-FF-000724', NULL, 'Uncharacterized protein', 239, NULL, NULL, 210742),
(210743, '2.30.29.30-FF-000632', NULL, 'Serine/threonine protein kinase', 105, NULL, NULL, 210743),
(210744, '3.40.250.10-FF-000091', NULL, 'Rhodanese-like domain-containing protein 11, chloroplastic', 172, NULL, NULL, 210744),
(210745, '3.40.50.720-FF-000761', NULL, 'SDR family oxidoreductase', 264, NULL, NULL, 210745),
(210746, '3.90.190.20-FF-000038', NULL, 'Bifunctional tetrahydrofolate synthase/dihydrofolate synthase', 136, NULL, NULL, 210746),
(210747, '3.30.50.10-FF-000089', NULL, 'Nuclear Hormone Receptor family', 107, NULL, NULL, 210747),
(210748, '4.10.400.10-FF-000033', NULL, 'Sortilin-related receptor isoform A', 41, NULL, NULL, 210748),
(210749, '1.10.1040.10-FF-000021', NULL, '2-hydroxy-3-oxopropionate reductase', 134, NULL, NULL, 210749),
(210750, '3.20.20.70-FF-000813', NULL, NULL, 23, NULL, NULL, 210750),
(210751, '3.40.50.2000-FF-000745', NULL, 'Chitobiosyldiphosphodolichol beta-mannosyltransferase', 194, NULL, NULL, 210751),
(210752, '3.30.420.40-FF-000132', NULL, 'Sedoheptulokinase', 257, NULL, NULL, 210752),
(210753, '3.40.50.300-FF-006498', NULL, 'Uncharacterized protein', 114, NULL, NULL, 210753),
(210754, '2.130.10.10-FF-005154', NULL, 'DmX-like protein 2', 141, NULL, NULL, 210754),
(210755, '2.60.40.10-FF-004569', NULL, NULL, 101, NULL, NULL, 210755),
(210756, '1.10.10.60-FF-000938', NULL, NULL, 63, NULL, NULL, 210756),
(210757, '3.90.70.10-FF-000110', NULL, 'ubiquitin carboxyl-terminal hydrolase 32 isoform X2', 143, NULL, NULL, 210757),
(210758, '3.90.180.10-FF-000006', NULL, 'Alcohol dehydrogenase 1', 213, NULL, NULL, 210758),
(210759, '1.20.120.720-FF-000058', NULL, 'Myosin IHb', 20, NULL, NULL, 210759),
(210760, '3.40.850.10-FF-000294', NULL, 'Kinesin-related protein 2', 406, NULL, NULL, 210760),
(210761, '1.20.190.20-FF-000005', NULL, 'Uncharacterized protein', 112, NULL, NULL, 210761),
(210762, '2.130.10.10-FF-003030', NULL, 'Uncharacterized protein', 399, NULL, NULL, 210762),
(210763, '3.20.20.140-FF-000035', NULL, 'Probable amp deaminase', 424, NULL, NULL, 210763),
(210764, '1.20.1560.10-FF-000743', NULL, 'Chromosome 7, whole genome shotgun sequence', 137, NULL, NULL, 210764),
(210765, '3.30.1520.10-FF-000164', NULL, 'Sorting nexin-12', 126, NULL, NULL, 210765),
(210766, '3.50.50.60-FF-001143', NULL, 'Flavin-containing monooxygenase', 84, NULL, NULL, 210766),
(210767, '2.30.180.10-FF-000001', NULL, 'periostin isoform X1', 122, NULL, NULL, 210767),
(210768, '3.40.50.300-FF-002698', NULL, 'Rab2b/ Small GTPase', 197, NULL, NULL, 210768),
(210769, '3.40.50.11660-FF-000039', NULL, NULL, 202, NULL, NULL, 210769),
(210770, '1.20.190.10-FF-000002', NULL, 'Pesticidal crystal protein Cry5Ba', 218, NULL, NULL, 210770),
(210771, '3.80.10.10-FF-003996', NULL, 'Adenylate cyclase', 153, NULL, NULL, 210771),
(210772, '3.40.50.11350-FF-000008', NULL, 'Alpha-(1,6)-fucosyltransferase', 158, NULL, NULL, 210772),
(210773, '2.30.42.10-FF-000556', NULL, NULL, 60, NULL, NULL, 210773),
(210774, '3.20.20.150-FF-000038', NULL, 'Protein arginine N-methyltransferase', 273, NULL, NULL, 210774),
(210775, '3.40.50.2300-FF-001083', NULL, 'Uncharacterized protein', 303, NULL, NULL, 210775),
(210776, '3.40.710.10-FF-000076', NULL, 'Penicillin-binding protein 2', 346, NULL, NULL, 210776),
(210777, '3.30.30.30-FF-000010', NULL, 'Heat shock 70 kDa protein 17', 57, NULL, NULL, 210777),
(210778, '3.10.290.70-FF-000011', NULL, '40S ribosomal protein S8', 89, NULL, NULL, 210778),
(210779, '3.30.160.60-FF-005098', NULL, NULL, 28, NULL, NULL, 210779),
(210780, '2.100.10.50-FF-000007', NULL, 'Multivesicular body subunit 12A', 63, NULL, NULL, 210780),
(210781, '3.90.190.10-FF-000563', NULL, 'Uncharacterized protein', 78, NULL, NULL, 210781);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(210782, '1.20.1070.10-FF-000571', NULL, 'Proctolin receptor, isoform A', 183, NULL, NULL, 210782),
(210783, '1.10.8.60-FF-000252', NULL, 'AAA family ATPase, putative', 70, NULL, NULL, 210783),
(210784, '3.90.640.10-FF-000143', NULL, 'Heat shock protein 70', 83, NULL, NULL, 210784),
(210785, '3.90.70.10-FF-000487', NULL, 'Uncharacterized protein', 189, NULL, NULL, 210785),
(210786, '2.10.109.10-FF-000083', NULL, 'Signal peptidase I', 134, NULL, NULL, 210786),
(210787, '3.30.160.60-FF-002990', NULL, 'Zinc finger protein 578', 29, NULL, NULL, 210787),
(210788, '1.20.5.120-FF-000003', NULL, 'Proteasome activator subunit 2', 46, NULL, NULL, 210788),
(210789, '4.10.410.10-FF-000005', NULL, 'Pancreatic trypsin inhibitor', 126, NULL, NULL, 210789),
(210790, '2.60.120.290-FF-000155', NULL, 'Metalloendopeptidase', 134, NULL, NULL, 210790),
(210791, '3.40.50.150-FF-000163', NULL, '23S rRNA methyltransferase A', 272, NULL, NULL, 210791),
(210792, '3.10.110.10-FF-000346', NULL, 'Protein CBR-UEV-3', 201, NULL, NULL, 210792),
(210793, '1.10.510.10-FF-002008', NULL, 'Calmodulin-binding receptor-like cytoplasmic kinase 3', 151, NULL, NULL, 210793),
(210794, '1.10.1580.10-FF-000016', NULL, 'Related to NUG1-Nuclear GTPase (Involved in Ribosome biogenesis)', 91, NULL, NULL, 210794),
(210795, '3.90.180.10-FF-000063', NULL, 'Probable alcohol dehydrogenase adhA', 183, NULL, NULL, 210795),
(210796, '1.25.40.120-FF-000027', NULL, 'Uncharacterized protein', 264, NULL, NULL, 210796),
(210797, '4.10.410.20-FF-000008', NULL, 'SR-CI', 64, NULL, NULL, 210797),
(210798, '2.130.10.10-FF-000949', NULL, 'Polyubiquitin binding protein, putative', 211, NULL, NULL, 210798),
(210799, '3.40.50.300-FF-006121', NULL, 'Putative ABC transporter ATP-binding protein MG187', 222, NULL, NULL, 210799),
(210800, '1.20.940.10-FF-000004', NULL, 'Pre-mRNA-splicing factor 18', 172, NULL, NULL, 210800),
(210801, '1.10.150.20-FF-000168', NULL, 'Mating-type switching protein swi10', 96, NULL, NULL, 210801),
(210802, '2.30.110.10-FF-000053', NULL, 'Protein CBG16488', 220, NULL, NULL, 210802),
(210803, '1.10.565.10-FF-000061', NULL, 'Protein CBR-NHR-14', 219, NULL, NULL, 210803),
(210804, '1.10.510.10-FF-002773', NULL, NULL, 223, NULL, NULL, 210804),
(210805, '3.40.1620.60-FF-000004', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 12', 87, NULL, NULL, 210805),
(210806, '3.40.980.10-FF-000005', NULL, 'Molybdopterin biosynthesis mog protein', 194, NULL, NULL, 210806),
(210807, '3.10.20.870-FF-000014', NULL, NULL, 77, NULL, NULL, 210807),
(210808, '3.40.50.620-FF-000169', NULL, 'Two-component system sensor histidine kinase KdbD', 134, NULL, NULL, 210808),
(210809, '1.10.472.10-FF-000637', NULL, 'Cyclin, N-terminal domain containing protein', 117, NULL, NULL, 210809),
(210810, '2.30.42.10-FF-000612', NULL, NULL, 93, NULL, NULL, 210810),
(210811, '1.10.238.110-FF-000019', NULL, 'Diacylglycerol kinase', 129, NULL, NULL, 210811),
(210812, '3.30.70.330-FF-001201', NULL, 'RNA recognition motif domain containing protein', 162, NULL, NULL, 210812),
(210813, '3.30.70.330-FF-001347', NULL, 'Zinc finger CCCH domain-containing protein 41', 89, NULL, NULL, 210813),
(210814, '3.30.1360.10-FF-000067', NULL, 'Uncharacterized protein', 47, NULL, NULL, 210814),
(210815, '3.90.190.10-FF-000361', NULL, 'Uncharacterized protein', 314, NULL, NULL, 210815),
(210816, '1.10.3520.10-FF-000007', NULL, 'Glycolipid transfer protein, putative', 211, NULL, NULL, 210816),
(210817, '3.40.390.10-FF-000270', NULL, NULL, 164, NULL, NULL, 210817),
(210818, '1.10.10.160-FF-000026', NULL, 'DNA helicase', 89, NULL, NULL, 210818),
(210819, '1.10.287.160-FF-000010', NULL, 'Transcriptional regulator', 68, NULL, NULL, 210819),
(210820, '2.60.120.10-FF-000305', NULL, 'Clavaminate synthase-like protein', 325, NULL, NULL, 210820),
(210821, '4.10.1000.10-FF-000016', NULL, 'Zinc finger CCCH domain-containing protein', 36, NULL, NULL, 210821),
(210822, '1.10.3860.10-FF-000027', NULL, 'Transporter, dicarboxylate/amino acid:cation Na+/H+ symporter family protein', 396, NULL, NULL, 210822);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(210823, '3.30.230.30-FF-000002', NULL, 'Protein IMPACT homolog', 122, NULL, NULL, 210823),
(210824, '3.40.50.300-FF-000135', NULL, 'DNA repair helicase RAD3, putative', 201, NULL, NULL, 210824),
(210825, '3.40.50.150-FF-000596', NULL, 'Caffeic acid O-methyltransferase', 247, NULL, NULL, 210825),
(210826, '1.10.472.10-FF-000694', NULL, 'Uncharacterized protein', 101, NULL, NULL, 210826),
(210827, '3.40.50.2000-FF-001111', NULL, 'UDP-glycosyltransferase 90A1', 12, NULL, NULL, 210827),
(210828, '3.20.20.300-FF-000049', NULL, 'Glycoside hydrolase superfamily', 357, NULL, NULL, 210828),
(210829, '3.20.20.80-FF-000816', NULL, 'Uncharacterized protein', 94, NULL, NULL, 210829),
(210830, '1.10.8.60-FF-000196', NULL, 'Chromosomal replication initiator protein DnaA', 69, NULL, NULL, 210830),
(210831, '3.30.1370.210-FF-000034', NULL, 'Uncharacterized protein', 80, NULL, NULL, 210831),
(210832, '1.10.10.10-FF-000070', NULL, '26S proteasome non-ATPase regulatory subunit 12', 80, NULL, NULL, 210832),
(210833, '3.30.230.40-FF-000005', NULL, 'Imidazoleglycerol-phosphate dehydratase', 116, NULL, NULL, 210833),
(210834, '3.30.760.10-FF-000076', NULL, 'Predicted protein', 184, NULL, NULL, 210834),
(210835, '3.40.50.1000-FF-000170', NULL, '4-nitrophenylphosphatase', 131, NULL, NULL, 210835),
(210836, '3.40.50.970-FF-000167', NULL, 'Uncharacterized protein', 55, NULL, NULL, 210836),
(210837, '3.30.200.20-FF-001155', NULL, 'Uncharacterized protein', 81, NULL, NULL, 210837),
(210838, '3.80.10.10-FF-000091', NULL, 'leucine-rich repeat serine/threonine-protein kinase 1', 89, NULL, NULL, 210838),
(210839, '2.60.40.10-FF-003265', NULL, 'Hypothetical_protein_-_conserved', 107, NULL, NULL, 210839),
(210840, '3.40.50.410-FF-000078', NULL, 'UPF0353 protein RN09_1826', 199, NULL, NULL, 210840),
(210841, '1.10.555.10-FF-000032', NULL, 'Uncharacterized protein, isoform E', 201, NULL, NULL, 210841),
(210842, '1.20.1720.10-FF-000037', NULL, 'WGS project CABT00000000 data, contig 2.4', 242, NULL, NULL, 210842),
(210843, '3.40.50.300-FF-001439', NULL, 'Cell division control protein 48 homolog B', 180, NULL, NULL, 210843),
(210844, '1.10.510.10-FF-003644', NULL, NULL, 187, NULL, NULL, 210844),
(210845, '1.10.10.10-FF-000300', NULL, 'Eukaryotic translation initiation factor 3 subunit C', 76, NULL, NULL, 210845),
(210846, '1.10.357.140-FF-000015', NULL, 'Chlorophyll synthase, chloroplastic', 159, NULL, NULL, 210846),
(210847, '3.10.580.10-FF-000173', NULL, 'Putative chloride channel', 140, NULL, NULL, 210847),
(210848, '3.40.630.30-FF-000412', NULL, 'Putative N-acetyltransferase YjaB', 180, NULL, NULL, 210848),
(210849, '2.130.10.10-FF-001736', NULL, 'Pre-rRNA-processing protein IPI3', 282, NULL, NULL, 210849),
(210850, '2.30.29.30-FF-000778', NULL, 'Chromosome undetermined SCAF14530, whole genome shotgun sequence', 65, NULL, NULL, 210850),
(210851, '3.40.50.410-FF-000022', NULL, 'Collagen type VI alpha 3 chain', 175, NULL, NULL, 210851),
(210852, '3.40.800.10-FF-000049', NULL, NULL, 124, NULL, NULL, 210852),
(210853, '3.20.20.80-FF-000614', NULL, 'Beta-galactosidase-like protein', 150, NULL, NULL, 210853),
(210854, '3.30.200.20-FF-002375', NULL, 'Serine/threonine-protein kinase phg2', 85, NULL, NULL, 210854),
(210855, '3.20.20.70-FF-000611', NULL, NULL, 118, NULL, NULL, 210855),
(210856, '3.20.70.20-FF-000032', NULL, 'Ribonucleoside-diphosphate reductase NrdEB subunit alpha', 306, NULL, NULL, 210856),
(210857, '2.60.40.3170-FF-000002', NULL, 'Tripeptidyl-peptidase 2', 132, NULL, NULL, 210857),
(210858, '1.20.1740.10-FF-000038', NULL, 'Putative sodium-coupled neutral amino acid transporter 7', 413, NULL, NULL, 210858),
(210859, '1.10.510.10-FF-001553', NULL, 'Serine/threonine-protein kinase zyg-8', 322, NULL, NULL, 210859),
(210860, '3.30.160.60-FF-003771', NULL, NULL, 27, NULL, NULL, 210860),
(210861, '3.30.70.330-FF-000476', NULL, 'Zinc finger CCCH domain-containing protein 4', 97, NULL, NULL, 210861),
(210862, '3.40.1390.20-FF-000002', NULL, 'HPr kinase/phosphorylase', 131, NULL, NULL, 210862),
(210863, '1.10.287.370-FF-000045', NULL, 'Tubulin-binding prefolding complex subunit', 112, NULL, NULL, 210863);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(210864, '3.30.70.330-FF-001403', NULL, 'Predicted protein', 91, NULL, NULL, 210864),
(210865, '3.30.160.60-FF-002658', NULL, 'C2H2 transcription factor, putative', 84, NULL, NULL, 210865),
(210866, '3.30.479.20-FF-000031', NULL, 'Elongation factor Ts', 48, NULL, NULL, 210866),
(210867, '3.60.20.10-FF-000226', NULL, NULL, 120, NULL, NULL, 210867),
(210868, '2.30.30.140-FF-000353', NULL, 'Uncharacterized protein', 59, NULL, NULL, 210868),
(210869, '3.40.1390.30-FF-000005', NULL, 'Nif3-like dinuclear metal center hexameric protein', 134, NULL, NULL, 210869),
(210870, '3.30.160.60-FF-001680', NULL, 'Uncharacterized protein', 29, NULL, NULL, 210870),
(210871, '1.10.10.60-FF-001074', NULL, NULL, 64, NULL, NULL, 210871),
(210872, '3.30.40.10-FF-000353', NULL, 'E3 ubiquitin-protein ligase KEG', 80, NULL, NULL, 210872),
(210873, '3.30.479.30-FF-000034', NULL, 'Stomatin family protein', 111, NULL, NULL, 210873),
(210874, '3.40.190.10-FF-000788', NULL, 'ABC-type transport system periplasmic substrate-binding protein (Probable substrate dipeptide/oligopeptide)', 85, NULL, NULL, 210874),
(210875, '3.40.30.10-FF-000481', NULL, 'Thiol:disulfide interchange protein DsbD', 121, NULL, NULL, 210875),
(210876, '3.30.230.10-FF-000047', NULL, 'DNA topoisomerase 4 subunit B', 173, NULL, NULL, 210876),
(210877, '1.20.272.40-FF-000005', NULL, 'ATP-dependent RNA helicase SUPV3L1', 80, NULL, NULL, 210877),
(210878, '1.50.40.10-FF-000244', NULL, 'Mitochondrial carrier protein (Rim2), putative', 68, NULL, NULL, 210878),
(210879, '2.60.120.650-FF-000128', NULL, 'Uncharacterized protein', 116, NULL, NULL, 210879),
(210880, '1.10.1670.40-FF-000010', NULL, 'AFR011Wp', 65, NULL, NULL, 210880),
(210881, '1.10.630.10-FF-000039', NULL, 'Cytochrome P450', 477, NULL, NULL, 210881),
(210882, '3.30.70.330-FF-001460', NULL, 'RNA-binding protein', 90, NULL, NULL, 210882),
(210883, '1.25.40.10-FF-002399', NULL, 'PPR repeat/Pentatricopeptide repeat domain containing protein, putative', 154, NULL, NULL, 210883),
(210884, '2.40.50.140-FF-000338', NULL, 'Replication protein A large subunit', 206, NULL, NULL, 210884),
(210885, '3.40.50.2300-FF-001026', NULL, NULL, 132, NULL, NULL, 210885),
(210886, '1.10.357.150-FF-000018', NULL, 'Centromere/kinetochore protein zw10-like protein', 117, NULL, NULL, 210886),
(210887, '1.20.1560.10-FF-000272', NULL, 'Lipid A export ATP-binding/permease protein MsbA', 355, NULL, NULL, 210887),
(210888, '3.80.10.10-FF-002209', NULL, 'Protein CBG00897', 316, NULL, NULL, 210888),
(210889, '3.40.50.300-FF-007425', NULL, 'Uncharacterized protein', 158, NULL, NULL, 210889),
(210890, '3.40.390.10-FF-000157', NULL, 'Disintegrin and metalloproteinase domain-containing protein 5', 198, NULL, NULL, 210890),
(210891, '1.20.1110.10-FF-000007', NULL, 'Calcium-transporting ATPase', 379, NULL, NULL, 210891),
(210892, '3.40.50.11340-FF-000005', NULL, 'Galactoside 2-alpha-L-fucosyltransferase', 52, NULL, NULL, 210892),
(210893, '1.20.80.10-FF-000017', NULL, 'Golgi resident protein GCP60', 109, NULL, NULL, 210893),
(210894, '1.20.900.10-FF-000114', NULL, 'Uncharacterized protein', 58, NULL, NULL, 210894),
(210895, '2.60.40.1130-FF-000002', NULL, 'Pullulanase 1, chloroplastic', 115, NULL, NULL, 210895),
(210896, '2.40.50.40-FF-000095', NULL, 'Chromo (CHRromatin Organisation MOdifier) domain-containing protein', 66, NULL, NULL, 210896),
(210897, '1.10.3380.10-FF-000041', NULL, 'YALI0B13904p', 143, NULL, NULL, 210897),
(210898, '1.25.10.10-FF-001554', NULL, 'Protein MOR1', 141, NULL, NULL, 210898),
(210899, '1.10.260.40-FF-000098', NULL, 'Uncharacterized protein', 82, NULL, NULL, 210899),
(210900, '3.40.720.10-FF-000048', NULL, 'ectonucleotide pyrophosphatase/phosphodiesterase family member 7', 270, NULL, NULL, 210900),
(210901, '3.40.50.12670-FF-000011', NULL, 'Uncharacterized protein', 106, NULL, NULL, 210901),
(210902, '3.30.160.60-FF-005480', NULL, NULL, 27, NULL, NULL, 210902),
(210903, '2.60.40.10-FF-005356', NULL, NULL, 66, NULL, NULL, 210903),
(210904, '3.40.50.2300-FF-000773', NULL, NULL, 119, NULL, NULL, 210904),
(210905, '3.30.70.1230-FF-000191', NULL, 'Predicted protein', 150, NULL, NULL, 210905);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(210906, '3.40.50.1820-FF-000404', NULL, 'Non-ribosomal peptide synthetase', 83, NULL, NULL, 210906),
(210907, '2.130.10.10-FF-003389', NULL, 'Uncharacterized protein', 91, NULL, NULL, 210907),
(210908, '1.10.8.10-FF-000024', NULL, 'Ubiquitin domain-containing protein DSK2', 46, NULL, NULL, 210908),
(210909, '1.10.1300.10-FF-000058', NULL, 'Phosphodiesterase', 244, NULL, NULL, 210909),
(210910, '3.30.70.330-FF-003056', NULL, NULL, 193, NULL, NULL, 210910),
(210911, '3.40.440.10-FF-000010', NULL, NULL, 103, NULL, NULL, 210911),
(210912, '1.20.1070.10-FF-000419', NULL, 'Neuropeptide FF receptor 2', 342, NULL, NULL, 210912),
(210913, '3.40.50.620-FF-000405', NULL, 'Putative icotinic acid mononucleotide adenylyltransferase', 169, NULL, NULL, 210913),
(210914, '3.40.50.300-FF-001771', NULL, 'RAB8B, member RAS oncogene family', 88, NULL, NULL, 210914),
(210915, '1.25.40.10-FF-002629', NULL, 'Pentatricopeptide repeat-containing protein At3g18110, chloroplastic', 74, NULL, NULL, 210915),
(210916, '3.40.50.720-FF-001014', NULL, 'Erythronate-4-phosphate dehydrogenase', 100, NULL, NULL, 210916),
(210917, '2.30.30.870-FF-000010', NULL, NULL, 71, NULL, NULL, 210917),
(210918, '3.30.40.10-FF-000914', NULL, 'RWD domain-containing protein', 104, NULL, NULL, 210918),
(210919, '1.20.1250.20-FF-002117', NULL, 'Solute carrier organic anion transporter family member', 220, NULL, NULL, 210919),
(210920, '2.130.10.10-FF-005334', NULL, 'WD-repeat protein, putative', 186, NULL, NULL, 210920),
(210921, '3.40.50.450-FF-000039', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase', 153, NULL, NULL, 210921),
(210922, '3.40.50.11890-FF-000001', NULL, 'Putative 2-hydroxyglutaryl-CoA dehydratase, D-component', 127, NULL, NULL, 210922),
(210923, '3.40.50.12780-FF-000044', NULL, 'Short-chain-fatty-acid--CoA ligase', 431, NULL, NULL, 210923),
(210924, '2.60.40.1150-FF-000008', NULL, 'AP complex subunit beta', 80, NULL, NULL, 210924),
(210925, '1.20.1050.10-FF-000188', NULL, 'Hematopoietic prostaglandin D synthase', 114, NULL, NULL, 210925),
(210926, '3.40.50.1010-FF-000173', NULL, NULL, 82, NULL, NULL, 210926),
(210927, '3.60.110.10-FF-000065', NULL, 'Nitrilase/amidohydrolase superfamily protein, class 8', 274, NULL, NULL, 210927),
(210928, '3.30.160.60-FF-001528', NULL, 'Zinc finger and SCAN domain containing 9', 28, NULL, NULL, 210928),
(210929, '1.20.58.1180-FF-000004', NULL, 'Phosphatidylethanolamine-binding protein', 130, NULL, NULL, 210929),
(210930, '1.10.510.10-FF-000210', NULL, 'Non-specific serine/threonine protein kinase', 195, NULL, NULL, 210930),
(210931, '1.10.150.170-FF-000019', NULL, NULL, 58, NULL, NULL, 210931),
(210932, '3.90.79.10-FF-000299', NULL, 'Transcriptional repressor of nicotinamide riboside utilization NrtR', 140, NULL, NULL, 210932),
(210933, '1.20.58.60-FF-000632', NULL, 'Spectrin repeat-containing, nuclear envelope 1b', 216, NULL, NULL, 210933),
(210934, '2.10.70.10-FF-000150', NULL, 'Complement factor H related 5', 61, NULL, NULL, 210934),
(210935, '1.10.287.130-FF-000265', NULL, 'Histidine kinase', 76, NULL, NULL, 210935),
(210936, '1.10.10.10-FF-001374', NULL, 'Ferric uptake regulator family protein', 81, NULL, NULL, 210936),
(210937, '3.40.50.10420-FF-000061', NULL, 'Uncharacterized protein', 160, NULL, NULL, 210937),
(210938, '1.10.1370.10-FF-000006', NULL, 'mitochondrial intermediate peptidase', 289, NULL, NULL, 210938),
(210939, '3.30.70.330-FF-002893', NULL, NULL, 57, NULL, NULL, 210939),
(210940, '3.40.50.2300-FF-001116', NULL, NULL, 17, NULL, NULL, 210940),
(210941, '1.25.40.20-FF-001328', NULL, 'Predicted protein', 133, NULL, NULL, 210941),
(210942, '1.20.1250.20-FF-000228', NULL, 'Battenin', 342, NULL, NULL, 210942),
(210943, '3.80.10.10-FF-004452', NULL, 'Uncharacterized protein', 103, NULL, NULL, 210943),
(210944, '3.80.10.10-FF-004249', NULL, 'Uncharacterized protein', 72, NULL, NULL, 210944),
(210945, '3.40.50.300-FF-003682', NULL, 'Caspase recruitment domain family, member 11', 192, NULL, NULL, 210945),
(210946, '1.25.10.10-FF-000683', NULL, 'ARM repeat superfamily protein', 118, NULL, NULL, 210946);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(210947, '3.30.559.10-FF-000259', NULL, 'Acyltransferase easC', 229, NULL, NULL, 210947),
(210948, '1.25.40.20-FF-001856', NULL, 'Mitogen activated protein kinase kinase kinase 3, MAPKKK3, MEKK3, putative', 135, NULL, NULL, 210948),
(210949, '2.60.120.200-FF-000016', NULL, 'Collagen XI alpha 1 chain', 216, NULL, NULL, 210949),
(210950, '3.40.1110.10-FF-000041', NULL, 'Magnesium-translocating P-type ATPase', 162, NULL, NULL, 210950),
(210951, '3.50.50.60-FF-000362', NULL, 'All-trans-retinol 13,14-reductase', 136, NULL, NULL, 210951),
(210952, '1.10.238.10-FF-000110', NULL, 'calumenin isoform X2', 60, NULL, NULL, 210952),
(210953, '3.20.20.80-FF-000294', NULL, 'Beta-glucosidase 11', 252, NULL, NULL, 210953),
(210954, '4.10.1250.10-FF-000006', NULL, 'Aminomethyltransferase', 50, NULL, NULL, 210954),
(210955, '1.25.40.10-FF-005125', NULL, 'Uncharacterized protein', 291, NULL, NULL, 210955),
(210956, '1.10.287.70-FF-000180', NULL, 'Ionotropic receptor 75a', 139, NULL, NULL, 210956),
(210957, '1.10.287.130-FF-000226', NULL, 'Two component system histidine kinase', 89, NULL, NULL, 210957),
(210958, '3.10.290.20-FF-000018', NULL, 'Uncharacterized protein', 114, NULL, NULL, 210958),
(210959, '3.40.50.300-FF-007279', NULL, 'Origin recognition complex subunit 5', 154, NULL, NULL, 210959),
(210960, '1.10.510.10-FF-003554', NULL, NULL, 228, NULL, NULL, 210960),
(210961, '3.40.50.300-FF-003479', NULL, 'Benign gonial cell neoplasm', 166, NULL, NULL, 210961),
(210962, '4.10.280.10-FF-000005', NULL, 'Myogenic factor', 68, NULL, NULL, 210962),
(210963, '1.10.555.10-FF-000122', NULL, 'Rho GTPase Activating protein', 243, NULL, NULL, 210963),
(210964, '1.20.1050.10-FF-000098', NULL, 'Protein Translation Elongation Factor 1B subunitbeta (EF-1Bb)/1-gamma', 135, NULL, NULL, 210964),
(210965, '1.25.40.10-FF-002961', NULL, 'Os04g0676200 protein', 148, NULL, NULL, 210965),
(210966, '2.60.40.3710-FF-000006', NULL, 'L,D-transpeptidase 1', 94, NULL, NULL, 210966),
(210967, '3.30.40.10-FF-000824', NULL, 'E3 ubiquitin-protein ligase RNF13', 83, NULL, NULL, 210967),
(210968, '2.130.10.30-FF-000107', NULL, NULL, 190, NULL, NULL, 210968),
(210969, '1.25.40.10-FF-001325', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 104, NULL, NULL, 210969),
(210970, '1.20.1250.20-FF-000375', NULL, 'Glycoside-Pentoside-Hexuronide (GPH):Cation Symporter Family', 277, NULL, NULL, 210970),
(210971, '2.60.110.10-FF-000007', NULL, 'Osmotin-like protein', 187, NULL, NULL, 210971),
(210972, '3.30.70.3400-FF-000010', NULL, 'Protein translocase subunit SecD', 78, NULL, NULL, 210972),
(210973, '1.20.1250.20-FF-001864', NULL, 'Uncharacterized protein', 119, NULL, NULL, 210973),
(210974, '2.10.110.10-FF-000097', NULL, 'Filamin-binding LIM protein 1', 66, NULL, NULL, 210974),
(210975, '1.10.287.110-FF-000220', NULL, 'DnaJ (Hsp40) homolog, subfamily A, member 4', 93, NULL, NULL, 210975),
(210976, '1.25.40.20-FF-000081', NULL, 'Kinase D-interacting substrate of 220 kDa', 65, NULL, NULL, 210976),
(210977, '2.40.50.140-FF-001029', NULL, NULL, 146, NULL, NULL, 210977),
(210978, '3.20.20.70-FF-000049', NULL, 'Thiazole synthase', 255, NULL, NULL, 210978),
(210979, '3.30.160.60-FF-000191', NULL, 'zinc finger protein 366', 27, NULL, NULL, 210979),
(210980, '4.10.280.10-FF-000062', NULL, 'Neuronal PAS domain-containing protein 3', 55, NULL, NULL, 210980),
(210981, '3.30.70.330-FF-002836', NULL, NULL, 86, NULL, NULL, 210981),
(210982, '2.60.120.920-FF-000029', NULL, 'E3 ubiquitin-protein ligase TRIM36', 188, NULL, NULL, 210982),
(210983, '1.10.150.20-FF-000314', NULL, 'Uncharacterized protein', 37, NULL, NULL, 210983),
(210984, '3.30.40.10-FF-000297', NULL, 'tripartite motif-containing protein 59', 93, NULL, NULL, 210984),
(210985, '1.10.8.60-FF-000342', NULL, 'Peroxisome assembly protein Pex1p', 110, NULL, NULL, 210985),
(210986, '3.30.160.60-FF-005570', NULL, NULL, 50, NULL, NULL, 210986),
(210987, '3.40.50.300-FF-003064', NULL, 'ATP-dependent dethiobiotin synthetase BioD', 208, NULL, NULL, 210987),
(210988, '3.40.50.11210-FF-000017', NULL, NULL, 181, NULL, NULL, 210988);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(210989, '1.10.238.10-FF-000487', NULL, 'Myosin, essential light chain', 65, NULL, NULL, 210989),
(210990, '2.60.120.1000-FF-000031', NULL, 'Collagen, type I, alpha 1a', 48, NULL, NULL, 210990),
(210991, '1.20.1150.12-FF-000001', NULL, 'Endoplasmic reticulum resident protein 29', 107, NULL, NULL, 210991),
(210992, '1.10.10.10-FF-001227', NULL, 'GntR family transcriptional regulator', 67, NULL, NULL, 210992),
(210993, '3.60.21.10-FF-000341', NULL, 'Serine/threonine-protein phosphatase', 309, NULL, NULL, 210993),
(210994, '3.40.50.1820-FF-000348', NULL, 'Uncharacterized protein, isoform C', 269, NULL, NULL, 210994),
(210995, '1.20.1270.10-FF-000081', NULL, 'Heat shock cognate protein, putative', 72, NULL, NULL, 210995),
(210996, '3.30.1370.100-FF-000001', NULL, 'Mismatch repair endonuclease pms1, putative', 101, NULL, NULL, 210996),
(210997, '1.10.10.10-FF-001317', NULL, 'Related to RPC82-RNA polymerase III subunit C82', 105, NULL, NULL, 210997),
(210998, '3.30.160.60-FF-003714', NULL, NULL, 28, NULL, NULL, 210998),
(210999, '1.25.40.10-FF-001943', NULL, 'Os08g0538800 protein', 104, NULL, NULL, 210999),
(211000, '3.55.40.20-FF-000018', NULL, 'Superoxide dismutase [Mn], mitochondrial', 78, NULL, NULL, 211000),
(211001, '3.30.160.60-FF-003529', NULL, 'Misexpression suppressor of ras 4, isoform A', 22, NULL, NULL, 211001),
(211002, '3.30.200.20-FF-000992', NULL, 'Non-specific serine/threonine protein kinase', 68, NULL, NULL, 211002),
(211003, '2.10.25.10-FF-000461', NULL, 'laminin subunit alpha-2 isoform X1', 57, NULL, NULL, 211003),
(211004, '3.40.50.300-FF-003569', NULL, 'Probable ATP-binding component of ABC transporter', 234, NULL, NULL, 211004),
(211005, '3.40.50.720-FF-002088', NULL, 'Glutamate dehydrogenase', 137, NULL, NULL, 211005),
(211006, '3.30.160.60-FF-005328', NULL, NULL, 29, NULL, NULL, 211006),
(211007, '4.10.970.10-FF-000002', NULL, 'Atp-dependent dna helicase 2', 63, NULL, NULL, 211007),
(211008, '1.10.472.80-FF-000113', NULL, 'TBC domain containing protein', 152, NULL, NULL, 211008),
(211009, '3.90.550.10-FF-000170', NULL, 'Dolichol-phosphate mannosyltransferase', 232, NULL, NULL, 211009),
(211010, '3.80.10.10-FF-000652', NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', 111, NULL, NULL, 211010),
(211011, '2.10.25.10-FF-000219', NULL, 'Pro-epidermal growth factor', 53, NULL, NULL, 211011),
(211012, '1.25.40.10-FF-005215', NULL, 'Uncharacterized protein', 199, NULL, NULL, 211012),
(211013, '3.40.1120.10-FF-000013', NULL, NULL, 99, NULL, NULL, 211013),
(211014, '2.10.70.10-FF-000060', NULL, 'Complement inhibitory factor H', 66, NULL, NULL, 211014),
(211015, '2.60.120.200-FF-000488', NULL, 'Laminin, alpha 3', 213, NULL, NULL, 211015),
(211016, '2.40.50.140-FF-000956', NULL, NULL, 53, NULL, NULL, 211016),
(211017, '2.60.470.10-FF-000005', NULL, 'Amiloride-sensitive sodium channel subunit gamma', 171, NULL, NULL, 211017),
(211018, '2.70.130.10-FF-000051', NULL, NULL, 119, NULL, NULL, 211018),
(211019, '3.30.70.260-FF-000135', NULL, 'Ribose 5-phosphate isomerase (RpiA)', 76, NULL, NULL, 211019),
(211020, '1.10.1240.10-FF-000002', NULL, 'Methionine synthase', 88, NULL, NULL, 211020),
(211021, '1.10.10.1210-FF-000004', NULL, 'Unplaced genomic scaffold supercont1.8, whole genome shotgun sequence', 132, NULL, NULL, 211021),
(211022, '1.10.10.2120-FF-000002', NULL, 'Acyl-coenzyme A:6-aminopenicillanic-acid-acyltransferase 40 kDa form', 74, NULL, NULL, 211022),
(211023, '2.10.70.10-FF-000240', NULL, 'Uncharacterized protein', 61, NULL, NULL, 211023),
(211024, '1.10.101.10-FF-000035', NULL, 'Predicted protein', 63, NULL, NULL, 211024),
(211025, '3.30.40.10-FF-001134', NULL, 'E3 ubiquitin-protein ligase Zswim2', 85, NULL, NULL, 211025),
(211026, '1.10.287.370-FF-000101', NULL, 'Uncharacterized protein', 60, NULL, NULL, 211026),
(211027, '3.80.10.10-FF-001956', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 159, NULL, NULL, 211027),
(211028, '1.25.40.10-FF-005035', NULL, 'LP07472p', 140, NULL, NULL, 211028),
(211029, '3.40.50.300-FF-003625', NULL, 'Helicase-like protein', 162, NULL, NULL, 211029);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(211030, '2.40.50.140-FF-000866', NULL, NULL, 134, NULL, NULL, 211030),
(211031, '3.40.50.1820-FF-000876', NULL, 'Uncharacterized protein', 299, NULL, NULL, 211031),
(211032, '1.20.5.170-FF-000208', NULL, 'Calcium-transporting ATPase', 58, NULL, NULL, 211032),
(211033, '2.130.10.10-FF-003535', NULL, 'F-box and WD repeat domain-containing 5', 148, NULL, NULL, 211033),
(211034, '1.20.1730.10-FF-000066', NULL, 'Sodium/glucose cotransporter 1', 527, NULL, NULL, 211034),
(211035, '3.40.50.1820-FF-000909', NULL, 'Alpha/beta-Hydrolases superfamily protein', 159, NULL, NULL, 211035),
(211036, '1.20.1250.20-FF-000846', NULL, 'Multidrug resistance protein VceB', 242, NULL, NULL, 211036),
(211037, '1.25.40.10-FF-004759', NULL, 'Uncharacterized protein', 59, NULL, NULL, 211037),
(211038, '3.60.21.10-FF-000009', NULL, 'Vacuolar protein sorting-associated protein 29', 182, NULL, NULL, 211038),
(211039, '3.40.1110.10-FF-000131', NULL, 'Calcium-transporting ATPase', 264, NULL, NULL, 211039),
(211040, '1.10.287.110-FF-000107', NULL, 'Related to DJP1-DnaJ-like protein', 91, NULL, NULL, 211040),
(211041, '3.30.40.10-FF-002062', NULL, 'Uncharacterized protein', 89, NULL, NULL, 211041),
(211042, '3.30.70.260-FF-000045', NULL, 'Homoserine dehydrogenase', 73, NULL, NULL, 211042),
(211043, '2.40.50.140-FF-000809', NULL, NULL, 136, NULL, NULL, 211043),
(211044, '1.25.40.20-FF-001385', NULL, 'Calmodulin-binding transcription activator 2', 62, NULL, NULL, 211044),
(211045, '3.30.1370.110-FF-000004', NULL, 'Endonuclease MutS2', 86, NULL, NULL, 211045),
(211046, '1.25.40.10-FF-001382', NULL, 'Pentatricopeptide repeat-containing protein', 106, NULL, NULL, 211046),
(211047, '2.40.340.10-FF-000006', NULL, 'Molybdopterin molybdenumtransferase', 76, NULL, NULL, 211047),
(211048, '1.20.1730.10-FF-000009', NULL, 'Cation acetate symporter', 502, NULL, NULL, 211048),
(211049, '2.60.260.40-FF-000009', NULL, 'Uncharacterized protein', 46, NULL, NULL, 211049),
(211050, '2.10.109.10-FF-000026', NULL, 'HTH-type transcriptional regulator', 123, NULL, NULL, 211050),
(211051, '1.20.140.10-FF-000145', NULL, 'Uncharacterized protein', 98, NULL, NULL, 211051),
(211052, '3.30.70.330-FF-003112', NULL, NULL, 73, NULL, NULL, 211052),
(211053, '3.40.710.10-FF-000019', NULL, 'Beta-lactamase', 246, NULL, NULL, 211053),
(211054, '3.40.50.360-FF-000080', NULL, 'NADPH-dependent fmn reductase', 181, NULL, NULL, 211054),
(211055, '3.40.190.120-FF-000010', NULL, 'Glycine betaine transport system permease protein', 104, NULL, NULL, 211055),
(211056, '3.40.50.2300-FF-000953', NULL, NULL, 130, NULL, NULL, 211056),
(211057, '1.10.472.80-FF-000023', NULL, 'TBC1 domain family member 8B', 155, NULL, NULL, 211057),
(211058, '3.30.70.270-FF-000290', NULL, NULL, 78, NULL, NULL, 211058),
(211059, '3.40.50.720-FF-000609', NULL, '2-dehydropantoate 2-reductase', 184, NULL, NULL, 211059),
(211060, '3.30.160.60-FF-004024', NULL, NULL, 28, NULL, NULL, 211060),
(211061, '1.20.5.170-FF-000265', NULL, 'Viral A-type inclusion protein, putative', 162, NULL, NULL, 211061),
(211062, '1.20.1250.20-FF-000318', NULL, 'MFS multidrug transporter, putative', 423, NULL, NULL, 211062),
(211063, '3.40.50.720-FF-000851', NULL, 'Probable 2-dehydropantoate 2-reductase', 151, NULL, NULL, 211063),
(211064, '3.40.50.620-FF-000349', NULL, 'Electron transfer flavoprotein beta subunit', 262, NULL, NULL, 211064),
(211065, '3.30.70.270-FF-000048', NULL, 'Gag-Pol polyprotein', 146, NULL, NULL, 211065),
(211066, '3.40.1000.70-FF-000005', NULL, 'Serine/threonine-protein kinase PknH', 193, NULL, NULL, 211066),
(211067, '2.60.40.10-FF-003226', NULL, 'Uncharacterized protein', 126, NULL, NULL, 211067),
(211068, '3.40.50.12710-FF-000006', NULL, 'Protein arginine methyltransferase NDUFAF7', 393, NULL, NULL, 211068),
(211069, '1.20.1270.60-FF-000247', NULL, 'Rho GTPase-activating protein 4', 162, NULL, NULL, 211069),
(211070, '2.40.50.140-FF-001119', NULL, NULL, 63, NULL, NULL, 211070),
(211071, '3.40.50.1820-FF-000258', NULL, 'WGS project CABT00000000 data, contig 2.27', 250, NULL, NULL, 211071),
(211072, '1.20.1600.10-FF-000062', NULL, 'Putative outer membrane protein TolC', 393, NULL, NULL, 211072);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(211073, '3.10.20.310-FF-000015', NULL, 'Outer membrane protein assembly factor BamA', 82, NULL, NULL, 211073),
(211074, '3.20.20.105-FF-000001', NULL, 'Queuine tRNA-ribosyltransferase', 371, NULL, NULL, 211074),
(211075, '3.90.1420.10-FF-000002', NULL, 'N-lysine methyltransferase SETD6', 174, NULL, NULL, 211075),
(211076, '3.40.50.300-FF-006969', NULL, 'Uncharacterized protein', 220, NULL, NULL, 211076),
(211077, '3.10.20.90-FF-000758', NULL, 'Wall-associated receptor kinase 1', 91, NULL, NULL, 211077),
(211078, '2.130.10.30-FF-000017', NULL, 'Serine/threonine-protein kinase Nek8', 138, NULL, NULL, 211078),
(211079, '3.40.50.620-FF-000259', NULL, 'Methionine--tRNA ligase', 367, NULL, NULL, 211079),
(211080, '2.130.10.10-FF-000011', NULL, 'Echinoderm microtubule-associated protein-like 2 isoform 1', 316, NULL, NULL, 211080),
(211081, '3.30.200.20-FF-000464', NULL, 'Cdc2-related protein kinase 5', 61, NULL, NULL, 211081),
(211082, '3.90.45.10-FF-000035', NULL, 'Peptide deformylase', 133, NULL, NULL, 211082),
(211083, '2.10.25.10-FF-000551', NULL, 'Protein delta homolog 1', 41, NULL, NULL, 211083),
(211084, '3.40.1190.20-FF-000060', NULL, 'Phosphomethylpyrimidine kinase', 259, NULL, NULL, 211084),
(211085, '1.25.10.10-FF-001700', NULL, 'Uncharacterized protein', 262, NULL, NULL, 211085),
(211086, '2.130.10.10-FF-003445', NULL, 'WD domain, G-beta repeat, putative', 139, NULL, NULL, 211086),
(211087, '3.80.10.10-FF-000562', NULL, 'Protein NSP-INTERACTING KINASE 2', 123, NULL, NULL, 211087),
(211088, '1.10.8.60-FF-000432', NULL, 'AAA family ATPase peroxin 1', 95, NULL, NULL, 211088),
(211089, '3.40.50.2000-FF-000801', NULL, 'Os03g0824600 protein', 97, NULL, NULL, 211089),
(211090, '2.130.10.10-FF-000101', NULL, 'WD repeat-containing protein 20 isoform X1', 389, NULL, NULL, 211090),
(211091, '1.10.196.10-FF-000006', NULL, 'regulator of G-protein signaling 10 isoform X1', 53, NULL, NULL, 211091),
(211092, '2.20.70.10-FF-000099', NULL, 'E3 ubiquitin-protein ligase NEDD4', 40, NULL, NULL, 211092),
(211093, '3.40.30.10-FF-001167', NULL, 'Uncharacterized protein', 88, NULL, NULL, 211093),
(211094, '1.25.10.10-FF-000250', NULL, 'Phospholipase A-2-activating protein isoform A', 272, NULL, NULL, 211094),
(211095, '1.10.238.20-FF-000057', NULL, 'Odorant binding protein C19', 106, NULL, NULL, 211095),
(211096, '3.30.70.330-FF-002275', NULL, NULL, 109, NULL, NULL, 211096),
(211097, '1.25.40.10-FF-004198', NULL, 'Uncharacterized protein', 72, NULL, NULL, 211097),
(211098, '1.10.238.10-FF-000054', NULL, 'Calbindin 2', 100, NULL, NULL, 211098),
(211099, '1.20.1250.20-FF-000285', NULL, 'MFS general substrate transporter', 274, NULL, NULL, 211099),
(211100, '1.10.287.70-FF-000741', NULL, 'Uncharacterized protein', 101, NULL, NULL, 211100),
(211101, '3.30.1300.30-FF-000007', NULL, 'Type II secretion system protein K', 79, NULL, NULL, 211101),
(211102, '1.10.510.10-FF-000007', NULL, 'Fibroblast growth factor receptor', 196, NULL, NULL, 211102),
(211103, '3.40.50.720-FF-000233', NULL, 'Glucose-fructose oxidoreductase domain-containing protein 2', 111, NULL, NULL, 211103),
(211104, '3.40.33.10-FF-000100', NULL, 'Predicted extracellular protein', 147, NULL, NULL, 211104),
(211105, '1.10.418.40-FF-000015', NULL, 'Uncharacterized protein', 33, NULL, NULL, 211105),
(211106, '3.40.50.10820-FF-000001', NULL, 'Inositol-tetrakisphosphate 1-kinase', 96, NULL, NULL, 211106),
(211107, '3.30.710.10-FF-000359', NULL, 'Potassium voltage-gated channel, putative', 108, NULL, NULL, 211107),
(211108, '3.30.420.270-FF-000009', NULL, 'Transport energizing protein, ExbD/TolR family', 76, NULL, NULL, 211108),
(211109, '3.30.540.30-FF-000014', NULL, 'Dipeptidyl peptidase 3', 91, NULL, NULL, 211109),
(211110, '1.20.1250.20-FF-000936', NULL, 'Uncharacterized protein', 192, NULL, NULL, 211110),
(211111, '3.30.40.10-FF-000768', NULL, 'PHD finger transcription factor', 62, NULL, NULL, 211111),
(211112, '3.10.50.10-FF-000017', NULL, 'Uncharacterized protein', 65, NULL, NULL, 211112),
(211113, '1.10.268.10-FF-000022', NULL, NULL, 89, NULL, NULL, 211113); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(211114, '1.25.40.10-FF-001387', NULL, 'Pentatricopeptide repeat-containing protein At2g39620', 92, NULL, NULL, 211114),
(211115, '3.30.160.60-FF-001118', NULL, 'zinc finger protein 197 isoform X1', 28, NULL, NULL, 211115),
(211116, '1.20.58.60-FF-000806', NULL, 'Uncharacterized protein', 202, NULL, NULL, 211116),
(211117, '3.20.20.240-FF-000003', NULL, 'Fused isobutyryl-CoA mutase', 598, NULL, NULL, 211117),
(211118, '3.90.1150.10-FF-000487', NULL, 'Ornithine aminotransferase', 36, NULL, NULL, 211118),
(211119, '3.40.50.1820-FF-000910', NULL, 'Alpha/beta hydrolase, putative', 246, NULL, NULL, 211119),
(211120, '3.40.50.2000-FF-000447', NULL, 'Phosphatidylinositol glycan, class A', 184, NULL, NULL, 211120),
(211121, '3.30.40.10-FF-000358', NULL, 'RBR-type E3 ubiquitin transferase', 85, NULL, NULL, 211121),
(211122, '3.30.70.330-FF-002483', NULL, NULL, 78, NULL, NULL, 211122),
(211123, '3.80.10.10-FF-002187', NULL, 'Uncharacterized protein', 330, NULL, NULL, 211123),
(211124, '3.40.50.12780-FF-000167', NULL, 'Meiotically up-regulated gene 62 protein', 267, NULL, NULL, 211124),
(211125, '1.20.1270.10-FF-000114', NULL, 'AGAP004581-PA', 102, NULL, NULL, 211125),
(211126, '2.130.10.10-FF-002220', NULL, 'EMAP-like 3', 47, NULL, NULL, 211126),
(211127, '3.40.50.720-FF-000519', NULL, 'NAD(P)(+) transhydrogenase (AB-specific), alpha subunit', 188, NULL, NULL, 211127),
(211128, '3.40.50.300-FF-005222', NULL, 'Uncharacterized protein', 205, NULL, NULL, 211128),
(211129, '2.130.10.10-FF-003743', NULL, 'Uncharacterized protein C3H8.05c', 331, NULL, NULL, 211129),
(211130, '2.60.40.10-FF-001641', NULL, 'Myoblast growth factor receptor egl-15', 103, NULL, NULL, 211130),
(211131, '1.20.1690.10-FF-000011', NULL, 'V-type proton ATPase subunit', 110, NULL, NULL, 211131),
(211132, '1.20.58.1120-FF-000008', NULL, 'Dynein heavy chain 10, axonemal', 147, NULL, NULL, 211132),
(211133, '3.40.50.10330-FF-000040', NULL, 'NAD kinase', 129, NULL, NULL, 211133),
(211134, '2.60.120.340-FF-000013', NULL, '39 kDa FK506-binding nuclear protein', 100, NULL, NULL, 211134),
(211135, '3.40.50.150-FF-001652', NULL, NULL, 220, NULL, NULL, 211135),
(211136, '3.40.50.1010-FF-000201', NULL, NULL, 133, NULL, NULL, 211136),
(211137, '3.30.70.330-FF-003051', NULL, NULL, 112, NULL, NULL, 211137),
(211138, '3.40.1110.10-FF-000097', NULL, 'Phospholipid-transporting ATPase', 137, NULL, NULL, 211138),
(211139, '1.10.540.10-FF-000043', NULL, 'Acyl-CoA dehydrogenase FadE6', 112, NULL, NULL, 211139),
(211140, '1.10.10.10-FF-000210', NULL, 'Winged-helix transcriptional response regulator KdpE', 101, NULL, NULL, 211140),
(211141, '4.10.240.10-FF-000059', NULL, 'C6 transcription factor, putative', 42, NULL, NULL, 211141),
(211142, '1.10.620.20-FF-000047', NULL, 'Acyl-[acyl-carrier-protein] desaturase', 260, NULL, NULL, 211142),
(211143, '2.30.29.30-FF-001003', NULL, 'Uncharacterized protein', 126, NULL, NULL, 211143),
(211144, '3.30.70.330-FF-000919', NULL, 'Nrp1p', 106, NULL, NULL, 211144),
(211145, '2.60.20.10-FF-000004', NULL, 'Crystallin beta A4', 95, NULL, NULL, 211145),
(211146, '1.20.120.1220-FF-000013', NULL, 'Peptidase A24A prepilin type IV', 132, NULL, NULL, 211146),
(211147, '2.130.10.10-FF-004878', NULL, 'Uncharacterized protein', 119, NULL, NULL, 211147),
(211148, '3.30.70.270-FF-000087', NULL, 'YALI0E34980p', 109, NULL, NULL, 211148),
(211149, '1.20.1070.10-FF-000279', NULL, 'Trace amine-associated receptor 16f', 309, NULL, NULL, 211149),
(211150, '2.60.40.10-FF-003765', NULL, NULL, 109, NULL, NULL, 211150),
(211151, '2.40.50.140-FF-001243', NULL, NULL, 132, NULL, NULL, 211151),
(211152, '3.60.20.10-FF-000103', NULL, 'ASparagiNe Synthetase', 193, NULL, NULL, 211152),
(211153, '3.30.920.10-FF-000026', NULL, 'Predicted protein', 52, NULL, NULL, 211153),
(211154, '3.40.50.2300-FF-000386', NULL, 'Glutamate receptor subunit', 208, NULL, NULL, 211154),
(211155, '3.40.50.1820-FF-000264', NULL, 'Retinoid-inducible serine carboxypeptidase', 84, NULL, NULL, 211155),
(211156, '2.30.29.30-FF-000918', NULL, 'Decapping mRNA 1A', 84, NULL, NULL, 211156);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(211157, '3.30.1510.10-FF-000006', NULL, 'Formate--tetrahydrofolate ligase', 105, NULL, NULL, 211157),
(211158, '1.10.510.10-FF-003088', NULL, NULL, 282, NULL, NULL, 211158),
(211159, '3.40.50.970-FF-000162', NULL, 'Benzaldehyde lyase, putative', 194, NULL, NULL, 211159),
(211160, '3.40.190.10-FF-000288', NULL, 'Transcriptional regulator, LysR family', 103, NULL, NULL, 211160),
(211161, '3.40.1110.10-FF-000046', NULL, 'Copper-transporting ATPase PAA2, chloroplastic', 134, NULL, NULL, 211161),
(211162, '1.20.1070.10-FF-001965', NULL, 'Uncharacterized protein', 187, NULL, NULL, 211162),
(211163, '2.130.10.10-FF-001652', NULL, 'WD repeat and SOF domain-containing protein 1', 264, NULL, NULL, 211163),
(211164, '3.40.50.11850-FF-000012', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase', 34, NULL, NULL, 211164),
(211165, '1.10.640.10-FF-000039', NULL, 'Peroxinectin, putative', 76, NULL, NULL, 211165),
(211166, '1.20.1280.50-FF-000104', NULL, 'GD11494', 42, NULL, NULL, 211166),
(211167, '3.40.50.12230-FF-000025', NULL, 'Uncharacterized protein', 259, NULL, NULL, 211167),
(211168, '3.50.50.60-FF-000867', NULL, 'Slr1998 protein', 420, NULL, NULL, 211168),
(211169, '1.25.10.10-FF-001464', NULL, 'E3 ubiquitin-protein ligase UPL1', 455, NULL, NULL, 211169),
(211170, '3.30.420.140-FF-000049', NULL, 'Si:ch211-117n7.8', 22, NULL, NULL, 211170),
(211171, '3.30.160.60-FF-005452', NULL, NULL, 17, NULL, NULL, 211171),
(211172, '1.25.10.10-FF-001790', NULL, 'Uncharacterized protein', 587, NULL, NULL, 211172),
(211173, '3.30.70.270-FF-000312', NULL, NULL, 33, NULL, NULL, 211173),
(211174, '3.40.20.10-FF-000160', NULL, 'Uncharacterized protein', 137, NULL, NULL, 211174),
(211175, '1.10.8.60-FF-000218', NULL, 'PEX1p AAA-peroxin', 138, NULL, NULL, 211175),
(211176, '1.10.246.190-FF-000010', NULL, NULL, 53, NULL, NULL, 211176),
(211177, '1.10.8.100-FF-000027', NULL, 'Ribosomal RNA small subunit methyltransferase A', 65, NULL, NULL, 211177),
(211178, '3.80.10.10-FF-003873', NULL, 'Adenylate cyclase, putative', 90, NULL, NULL, 211178),
(211179, '3.40.1180.10-FF-000045', NULL, 'Mevalonate kinase', 121, NULL, NULL, 211179),
(211180, '3.40.47.10-FF-000194', NULL, 'Polyketide synthase RzxE', 482, NULL, NULL, 211180),
(211181, '1.25.40.10-FF-001292', NULL, 'Tetratricopeptide repeat protein', 229, NULL, NULL, 211181),
(211182, '2.30.30.140-FF-000230', NULL, 'Ubiquitin like with PHD and ring finger domains 2', 83, NULL, NULL, 211182),
(211183, '1.10.10.2330-FF-000003', NULL, 'Phenylalanine--tRNA ligase alpha subunit cytoplasmic', 57, NULL, NULL, 211183),
(211184, '3.30.70.1230-FF-000213', NULL, 'Guanylate cyclase', 111, NULL, NULL, 211184),
(211185, '1.10.10.10-FF-001733', NULL, 'Two-component system response regulator', 100, NULL, NULL, 211185),
(211186, '3.40.50.300-FF-005273', NULL, 'Hpr(Ser) kinase', 180, NULL, NULL, 211186),
(211187, '3.40.50.300-FF-001911', NULL, 'ATP-dependent Clp protease ATP-binding subunit ClpX', 291, NULL, NULL, 211187),
(211188, '1.20.58.70-FF-000068', NULL, 'Uncharacterized protein', 259, NULL, NULL, 211188),
(211189, '1.25.40.10-FF-000398', NULL, 'pentatricopeptide repeat-containing protein PNM1, mitochondrial', 89, NULL, NULL, 211189),
(211190, '2.130.10.10-FF-004199', NULL, 'Uncharacterized protein', 157, NULL, NULL, 211190),
(211191, '1.10.8.60-FF-000544', NULL, 'Uncharacterized protein', 32, NULL, NULL, 211191),
(211192, '2.60.40.150-FF-000649', NULL, 'Plant synaptotagmin: integral membrane double C2 domain protein', 122, NULL, NULL, 211192),
(211193, '2.60.120.330-FF-000061', NULL, '2-oxoglutarate-dependent dioxygenase AOP3', 192, NULL, NULL, 211193),
(211194, '3.60.10.10-FF-000164', NULL, 'Phosphatidylinositol 4,5-bisphosphate 5-phosphatase, putative', 360, NULL, NULL, 211194),
(211195, '1.25.10.10-FF-001559', NULL, 'AGAP007299-PA', 523, NULL, NULL, 211195),
(211196, '3.30.2140.20-FF-000003', NULL, 'Arylamine N-acetyltransferase 1', 305, NULL, NULL, 211196),
(211197, '1.20.58.60-FF-000065', NULL, 'plectin isoform X1', 233, NULL, NULL, 211197),
(211198, '1.10.287.70-FF-000590', NULL, 'Glutamate receptor ionotropic, delta-1-like Protein', 137, NULL, NULL, 211198);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(211199, '1.20.120.890-FF-000002', NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', 134, NULL, NULL, 211199),
(211200, '1.10.510.10-FF-001643', NULL, 'Protein kinase domain containing protein', 242, NULL, NULL, 211200),
(211201, '2.130.10.10-FF-000888', NULL, 'CPSF (Cleavage and polyadenylation specific factor)', 22, NULL, NULL, 211201),
(211202, '1.10.196.10-FF-000012', NULL, 'Regulator of G-protein signaling egl-10', 37, NULL, NULL, 211202),
(211203, '1.25.10.10-FF-000896', NULL, 'Adaptin N terminal region family protein', 586, NULL, NULL, 211203),
(211204, '3.30.420.10-FF-000258', NULL, 'DNA polymerase', 299, NULL, NULL, 211204),
(211205, '3.30.40.10-FF-001252', NULL, 'Uncharacterized protein', 107, NULL, NULL, 211205),
(211206, '1.25.40.20-FF-001295', NULL, 'Kank, isoform E', 163, NULL, NULL, 211206),
(211207, '3.40.50.300-FF-007346', NULL, 'Uncharacterized protein', 124, NULL, NULL, 211207),
(211208, '3.60.40.10-FF-000054', NULL, 'Protein phosphatase type 2C', 282, NULL, NULL, 211208),
(211209, '3.40.50.2300-FF-001324', NULL, NULL, 97, NULL, NULL, 211209),
(211210, '3.30.710.10-FF-000073', NULL, 'Zinc finger and BTB domain-containing protein 2', 120, NULL, NULL, 211210),
(211211, '3.30.160.20-FF-000016', NULL, 'ATP-dependent RNA helicase DHX30 isoform X1', 92, NULL, NULL, 211211),
(211212, '3.60.130.10-FF-000038', NULL, 'Taurine catabolism dioxygenase TauD, TfdA family-domain-containing protein', 314, NULL, NULL, 211212),
(211213, '1.25.10.10-FF-002987', NULL, 'Beta-tubulin cofactor D, putative', 375, NULL, NULL, 211213),
(211214, '3.30.70.850-FF-000014', NULL, 'Uncharacterized protein', 87, NULL, NULL, 211214),
(211215, '3.30.200.20-FF-001239', NULL, 'Ribosomal protein S6 kinase', 48, NULL, NULL, 211215),
(211216, '3.90.180.10-FF-000091', NULL, 'Aspergillus niger contig An11c0010, genomic contig', 152, NULL, NULL, 211216),
(211217, '3.60.40.10-FF-000380', NULL, 'Uncharacterized protein', 244, NULL, NULL, 211217),
(211218, '3.40.50.300-FF-005952', NULL, 'DNA mismatch repair protein MutS', 251, NULL, NULL, 211218),
(211219, '3.90.1300.10-FF-000027', NULL, 'Uncharacterized protein', 233, NULL, NULL, 211219),
(211220, '1.10.287.70-FF-000359', NULL, 'TWiK family of potassium channels', 189, NULL, NULL, 211220),
(211221, '2.60.120.20-FF-000022', NULL, NULL, 225, NULL, NULL, 211221),
(211222, '3.40.50.360-FF-000136', NULL, 'Flavodoxin-like fold family protein', 240, NULL, NULL, 211222),
(211223, '3.40.1360.10-FF-000031', NULL, 'DNA primase', 122, NULL, NULL, 211223),
(211224, '3.30.450.20-FF-000561', NULL, 'Nitrogen regulation protein NtrB', 105, NULL, NULL, 211224),
(211225, '4.10.410.10-FF-000090', NULL, 'Colostrum trypsin inhibitor, putative', 57, NULL, NULL, 211225),
(211226, '2.60.40.10-FF-000213', NULL, 'Hepatocyte growth factor receptor', 89, NULL, NULL, 211226),
(211227, '3.40.50.2300-FF-001150', NULL, 'Uncharacterized protein', 309, NULL, NULL, 211227),
(211228, '3.40.250.10-FF-000113', NULL, 'WGS project CABT00000000 data, contig 2.33', 144, NULL, NULL, 211228),
(211229, '1.10.10.350-FF-000044', NULL, NULL, 66, NULL, NULL, 211229),
(211230, '3.30.40.10-FF-000684', NULL, 'Putative E3 ubiquitin-protein ligase', 65, NULL, NULL, 211230),
(211231, '3.90.660.10-FF-000021', NULL, 'Lysine-specific histone demethylase 1, putative', 200, NULL, NULL, 211231),
(211232, '1.10.472.10-FF-000289', NULL, 'G2/mitotic-specific cyclin-A1', 128, NULL, NULL, 211232),
(211233, '3.20.20.80-FF-000204', NULL, 'Probable 4-alpha-glucanotransferase / amylo-1,6-glucosidase (Glycogen-debranching enzyme)', 165, NULL, NULL, 211233),
(211234, '3.40.50.720-FF-000671', NULL, 'Voltage-gated Ion Channel (VIC) Superfamily', 130, NULL, NULL, 211234),
(211235, '3.40.718.10-FF-000009', NULL, 'Isocitrate dehydrogenase [NAD] regulatory subunit 1', 340, NULL, NULL, 211235),
(211236, '3.75.10.10-FF-000018', NULL, 'Eukaryotic translation initiation factor 6', 133, NULL, NULL, 211236),
(211237, '1.20.1250.20-FF-002297', NULL, 'Predicted protein', 511, NULL, NULL, 211237),
(211238, '3.30.160.60-FF-003361', NULL, 'GD23866', 56, NULL, NULL, 211238);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(211239, '3.30.200.20-FF-000790', NULL, 'CAMK/CAMKL protein kinase, variant 1', 130, NULL, NULL, 211239),
(211240, '3.20.20.70-FF-000201', NULL, 'Hydroxymethylglutaryl-CoA lyase', 299, NULL, NULL, 211240),
(211241, '1.20.1510.10-FF-000089', NULL, NULL, 222, NULL, NULL, 211241),
(211242, '3.40.50.620-FF-000641', NULL, 'Uncharacterized protein', 224, NULL, NULL, 211242),
(211243, '1.10.150.20-FF-000286', NULL, 'UvrABC system protein C', 57, NULL, NULL, 211243),
(211244, '3.40.33.10-FF-000190', NULL, 'Uncharacterized protein', 116, NULL, NULL, 211244),
(211245, '2.130.10.10-FF-001405', NULL, 'Serine/threonine-protein kinase VPS15', 272, NULL, NULL, 211245),
(211246, '3.40.20.10-FF-000008', NULL, 'gelsolin isoform X2', 118, NULL, NULL, 211246),
(211247, '3.60.15.10-FF-000153', NULL, 'Cleavage and polyadenylation specificity factor subunit 2', 217, NULL, NULL, 211247),
(211248, '3.30.70.330-FF-003000', NULL, NULL, 83, NULL, NULL, 211248),
(211249, '1.10.630.10-FF-000281', NULL, 'Os08g0152300 protein', 106, NULL, NULL, 211249),
(211250, '2.60.120.380-FF-000064', NULL, 'Flagellar associated protein', 141, NULL, NULL, 211250),
(211251, '3.40.50.12760-FF-000009', NULL, 'GD11317', 342, NULL, NULL, 211251),
(211252, '3.40.50.300-FF-003182', NULL, 'GTPase Era', 184, NULL, NULL, 211252),
(211253, '1.25.40.80-FF-000020', NULL, 'CPD photolyase type II', 180, NULL, NULL, 211253),
(211254, '1.20.58.1120-FF-000059', NULL, NULL, 146, NULL, NULL, 211254),
(211255, '1.10.10.60-FF-000798', NULL, 'Two-component system sensor histidine kinase/response regulator', 113, NULL, NULL, 211255),
(211256, '2.60.40.1510-FF-000049', NULL, 'Integrin beta', 110, NULL, NULL, 211256),
(211257, '3.40.50.300-FF-001618', NULL, 'ABC transporter', 240, NULL, NULL, 211257),
(211258, '1.20.120.1080-FF-000050', NULL, 'ATP dependent RNA helicase', 100, NULL, NULL, 211258),
(211259, '1.20.1270.60-FF-000073', NULL, 'RhoGAP and Fes/CIP4 domain protein', 187, NULL, NULL, 211259),
(211260, '3.40.50.1220-FF-000084', NULL, 'Related to NAD-dependent histone deacetylase', 74, NULL, NULL, 211260),
(211261, '2.130.10.10-FF-000303', NULL, 'Sortilin related receptor 1', 208, NULL, NULL, 211261),
(211262, '1.20.5.170-FF-000203', NULL, 'Basic leucine zipper transcriptional factor ATF-like', 37, NULL, NULL, 211262),
(211263, '3.90.640.10-FF-000233', NULL, 'Uncharacterized protein', 46, NULL, NULL, 211263),
(211264, '3.30.160.60-FF-003147', NULL, 'Transcription factor IIIA', 27, NULL, NULL, 211264),
(211265, '3.30.450.20-FF-000089', NULL, 'Trachealess, isoform E', 209, NULL, NULL, 211265),
(211266, '3.40.50.620-FF-000580', NULL, 'Uncharacterized protein', 80, NULL, NULL, 211266),
(211267, '3.30.160.60-FF-005390', NULL, NULL, 25, NULL, NULL, 211267),
(211268, '1.10.287.70-FF-000264', NULL, 'Potassium channel', 111, NULL, NULL, 211268),
(211269, '1.20.144.10-FF-000087', NULL, 'AFR693Cp', 197, NULL, NULL, 211269),
(211270, '3.40.50.300-FF-003923', NULL, 'GTP binding protein', 198, NULL, NULL, 211270),
(211271, '3.40.50.720-FF-002178', NULL, '(+)-neomenthol dehydrogenase', 58, NULL, NULL, 211271),
(211272, '1.25.10.10-FF-001060', NULL, 'Anaphase-promoting complex subunit 1', 150, NULL, NULL, 211272),
(211273, '1.10.10.60-FF-000377', NULL, 'DNA-binding E3 ubiquitin-protein ligase', 59, NULL, NULL, 211273),
(211274, '3.30.160.60-FF-005238', NULL, NULL, 72, NULL, NULL, 211274),
(211275, '3.30.70.3490-FF-000048', NULL, NULL, 86, NULL, NULL, 211275),
(211276, '1.10.472.80-FF-000203', NULL, NULL, 144, NULL, NULL, 211276),
(211277, '2.60.40.10-FF-003086', NULL, 'Polycystic kidney and hepatic disease 1 (autosomal recessive)-like 1', 72, NULL, NULL, 211277),
(211278, '2.30.29.30-FF-001054', NULL, 'UNC-112-Interacting Guanine nucleotide exchange factor', 88, NULL, NULL, 211278),
(211279, '1.10.565.10-FF-000027', NULL, 'nuclear receptor subfamily 0 group B member 1', 219, NULL, NULL, 211279),
(211280, '1.25.40.10-FF-002747', NULL, 'AaceriAFR112Wp', 207, NULL, NULL, 211280),
(211281, '3.10.129.10-FF-000198', NULL, '4-hydroxybenzoyl-CoA thioesterase family active site', 144, NULL, NULL, 211281);
INSERT INTO "PUBLIC"."MODEL" VALUES
(211282, '3.40.50.300-FF-003709', NULL, 'AAA_domain_containing_protein_-_putative', 211, NULL, NULL, 211282),
(211283, '2.60.120.260-FF-000219', NULL, 'Laminin subunit alpha', 143, NULL, NULL, 211283),
(211284, '2.30.42.10-FF-000646', NULL, NULL, 122, NULL, NULL, 211284),
(211285, '1.10.10.10-FF-001087', NULL, 'Heat shock transcription factor', 99, NULL, NULL, 211285),
(211286, '1.20.1110.10-FF-000221', NULL, NULL, 35, NULL, NULL, 211286),
(211287, '3.40.50.620-FF-000736', NULL, 'Uncharacterized protein', 159, NULL, NULL, 211287),
(211288, '3.40.50.1820-FF-000617', NULL, 'GM24588', 268, NULL, NULL, 211288),
(211289, '1.25.40.10-FF-001180', NULL, 'Pentatricopeptide repeat-containing protein At2g03380, mitochondrial', 130, NULL, NULL, 211289),
(211290, '1.10.357.10-FF-000089', NULL, 'Transcriptional repressor of RND efflux transporter TetR family', 134, NULL, NULL, 211290),
(211291, '2.60.40.60-FF-000200', NULL, 'Cadherin 24, type 2b', 115, NULL, NULL, 211291),
(211292, '1.20.1740.10-FF-000252', NULL, 'Uncharacterized protein', 291, NULL, NULL, 211292),
(211293, '1.10.3430.10-FF-000068', NULL, 'Uncharacterized protein', 294, NULL, NULL, 211293),
(211294, '3.40.1190.20-FF-000234', NULL, NULL, 283, NULL, NULL, 211294),
(211295, '1.10.510.10-FF-001901', NULL, 'Proto-oncogene tyrosine-protein kinase ROS', 121, NULL, NULL, 211295),
(211296, '3.40.1160.10-FF-000050', NULL, 'Glutamate 5-kinase', 64, NULL, NULL, 211296),
(211297, '3.30.2230.10-FF-000024', NULL, 'Ubiquitin carboxyl-terminal hydrolase 33', 105, NULL, NULL, 211297),
(211298, '1.20.1250.20-FF-000431', NULL, 'Predicted protein', 212, NULL, NULL, 211298),
(211299, '3.40.50.2000-FF-000773', NULL, 'UDP-N-acetylglucosamine transferase subunit ALG14', 168, NULL, NULL, 211299),
(211300, '2.30.29.30-FF-000565', NULL, 'Related to OSH3-Member of oxysterol-binding protein family', 94, NULL, NULL, 211300),
(211301, '2.120.10.10-FF-000006', NULL, 'Sialidase 4', 121, NULL, NULL, 211301),
(211302, '3.40.225.10-FF-000049', NULL, NULL, 176, NULL, NULL, 211302),
(211303, '1.25.40.10-FF-004838', NULL, 'Tetratricopeptide repeat domain 21A', 142, NULL, NULL, 211303),
(211304, '1.20.1560.10-FF-000833', NULL, 'Uncharacterized protein', 343, NULL, NULL, 211304),
(211305, '1.10.8.1070-FF-000002', NULL, 'BnaC06g43890D protein', 116, NULL, NULL, 211305),
(211306, '1.20.140.160-FF-000006', NULL, 'RNA polymerase sigma factor RpoH', 147, NULL, NULL, 211306),
(211307, '1.20.140.10-FF-000140', NULL, 'Uncharacterized protein', 128, NULL, NULL, 211307),
(211308, '3.80.10.10-FF-002299', NULL, 'Leucine-rich repeat protein (LRRP), putative', 205, NULL, NULL, 211308),
(211309, '1.25.40.10-FF-004990', NULL, 'Uncharacterized protein', 257, NULL, NULL, 211309),
(211310, '3.80.10.10-FF-000175', NULL, 'Si:dkey-16p6.1', 168, NULL, NULL, 211310),
(211311, '2.130.10.10-FF-000388', NULL, 'VPS10 domain-containing receptor SorCS3', 162, NULL, NULL, 211311),
(211312, '3.20.20.100-FF-000192', NULL, 'Uncharacterized protein', 101, NULL, NULL, 211312),
(211313, '3.40.50.300-FF-007190', NULL, 'Uncharacterized protein', 170, NULL, NULL, 211313),
(211314, '3.40.50.1000-FF-000310', NULL, 'Trehalose-6-phosphate phosphatase OtsB', 134, NULL, NULL, 211314),
(211315, '3.30.70.330-FF-000763', NULL, 'RNA-binding protein, putative', 128, NULL, NULL, 211315),
(211316, '2.30.30.100-FF-000184', NULL, 'U6 snRNA-associated Sm-like protein LSm6p', 76, NULL, NULL, 211316),
(211317, '2.60.40.10-FF-001753', NULL, 'Uncharacterized protein', 92, NULL, NULL, 211317),
(211318, '2.60.120.430-FF-000040', NULL, 'Beta-agarase A', 160, NULL, NULL, 211318),
(211319, '1.20.120.850-FF-000052', NULL, 'SWI/SNF chromatin remodeling complex component', 42, NULL, NULL, 211319),
(211320, '3.40.50.2000-FF-000335', NULL, 'Glycosyltransferase', 184, NULL, NULL, 211320),
(211321, '4.10.400.10-FF-000145', NULL, 'Low-density lipoprotein RecePtor related', 38, NULL, NULL, 211321),
(211322, '3.40.50.410-FF-000224', NULL, 'Integrin beta', 128, NULL, NULL, 211322),
(211323, '3.40.50.12280-FF-000012', NULL, 'Hydrogenase, HycG subunit', 150, NULL, NULL, 211323);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(211324, '3.30.70.100-FF-000014', NULL, 'Copper chaperone copZ', 68, NULL, NULL, 211324),
(211325, '1.20.1280.290-FF-000089', NULL, 'Sugar transporter SWEET', 89, NULL, NULL, 211325),
(211326, '3.30.1520.10-FF-000097', NULL, 'PX domain containing protein, putative', 114, NULL, NULL, 211326),
(211327, '3.20.20.105-FF-000006', NULL, 'Queuine tRNA-ribosyltransferase-like protein', 398, NULL, NULL, 211327),
(211328, '3.40.50.150-FF-001826', NULL, NULL, 77, NULL, NULL, 211328),
(211329, '2.60.40.10-FF-005390', NULL, NULL, 53, NULL, NULL, 211329),
(211330, '1.10.287.470-FF-000018', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 63, NULL, NULL, 211330),
(211331, '3.40.50.10810-FF-000200', NULL, 'Uncharacterized protein', 172, NULL, NULL, 211331),
(211332, '2.130.10.10-FF-001826', NULL, 'Transducin family protein / WD-40 repeat family protein', 271, NULL, NULL, 211332),
(211333, '3.40.50.1760-FF-000010', NULL, NULL, 131, NULL, NULL, 211333),
(211334, '3.40.50.300-FF-005334', NULL, 'Regulator of nonsense transcripts 1-like protein', 146, NULL, NULL, 211334),
(211335, '1.20.1250.20-FF-001223', NULL, 'Solute carrier family 22 member 22', 416, NULL, NULL, 211335),
(211336, '3.40.50.300-FF-001832', NULL, 'IstB-like ATP-binding protein', 185, NULL, NULL, 211336),
(211337, '3.40.50.2300-FF-001650', NULL, NULL, 216, NULL, NULL, 211337),
(211338, '3.40.50.80-FF-000076', NULL, 'Flavohemoprotein', 133, NULL, NULL, 211338),
(211339, '2.60.120.10-FF-000165', NULL, 'dTDP-4-dehydrorhamnose 3,5-epimerase', 202, NULL, NULL, 211339),
(211340, '3.90.640.10-FF-000019', NULL, 'ARP5 actin-related protein 5 homolog', 50, NULL, NULL, 211340),
(211341, '3.30.160.60-FF-003035', NULL, 'zinc finger protein ZFP69 isoform X2', 26, NULL, NULL, 211341),
(211342, '1.25.40.10-FF-000898', NULL, 'Pentatricopeptide repeat-containing protein', 220, NULL, NULL, 211342),
(211343, '1.20.1560.10-FF-000480', NULL, 'ABC superfamily ATP binding cassette transporter ABC/membrane protein', 313, NULL, NULL, 211343),
(211344, '2.10.50.10-FF-000143', NULL, 'Ectodysplasin A2 receptor', 58, NULL, NULL, 211344),
(211345, '3.30.60.20-FF-000149', NULL, 'Diacylglycerol kinase', 63, NULL, NULL, 211345),
(211346, '2.60.40.10-FF-005682', NULL, NULL, 81, NULL, NULL, 211346),
(211347, '1.10.10.2520-FF-000004', NULL, 'Ion channel', 84, NULL, NULL, 211347),
(211348, '3.10.450.50-FF-000029', NULL, 'Probable sucrose-phosphatase 2', 127, NULL, NULL, 211348),
(211349, '2.20.70.10-FF-000239', NULL, 'Peptidyl-prolyl cis-trans isomerase', 40, NULL, NULL, 211349),
(211350, '3.40.50.1820-FF-000376', NULL, 'Probable carboxylesterase 12', 309, NULL, NULL, 211350),
(211351, '2.10.70.10-FF-000301', NULL, 'Uncharacterized protein', 72, NULL, NULL, 211351),
(211352, '3.40.630.10-FF-000098', NULL, 'Gly-Xaa carboxypeptidase', 213, NULL, NULL, 211352),
(211353, '3.90.190.10-FF-000451', NULL, 'Protein-tyrosine phosphatase beta', 238, NULL, NULL, 211353),
(211354, '2.60.260.40-FF-000004', NULL, 'Lactobacillus shifted protein', 57, NULL, NULL, 211354),
(211355, '1.20.58.60-FF-000683', NULL, 'Spectrin beta chain, non-erythrocytic 5-like Protein', 114, NULL, NULL, 211355),
(211356, '1.10.150.240-FF-000119', NULL, 'CG5565 protein', 68, NULL, NULL, 211356),
(211357, '3.40.50.150-FF-001085', NULL, NULL, 232, NULL, NULL, 211357),
(211358, '2.30.29.30-FF-000891', NULL, 'YALI0B12452p', 96, NULL, NULL, 211358),
(211359, '1.10.287.810-FF-000008', NULL, 'Mitochondrial import inner membrane translocase subunit TIM9', 86, NULL, NULL, 211359),
(211360, '1.20.120.1760-FF-000040', NULL, 'CDP-diacylglycerol--inositol 3-phosphatidyltransferase', 185, NULL, NULL, 211360),
(211361, '3.40.50.150-FF-001377', NULL, NULL, 176, NULL, NULL, 211361),
(211362, '3.60.10.10-FF-000338', NULL, 'Predicted protein', 215, NULL, NULL, 211362),
(211363, '2.130.10.10-FF-001085', NULL, 'Chromatin assembly factor-I p60 subunit', 276, NULL, NULL, 211363),
(211364, '2.40.50.90-FF-000143', NULL, 'YALI0B03960p', 145, NULL, NULL, 211364),
(211365, '3.40.50.300-FF-006857', NULL, 'Uncharacterized protein', 257, NULL, NULL, 211365);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(211366, '2.10.25.10-FF-001765', NULL, 'Adhesion G protein-coupled receptor L4', 35, NULL, NULL, 211366),
(211367, '3.30.479.20-FF-000025', NULL, 'Elongation factor Ts, mitochondrial', 95, NULL, NULL, 211367),
(211368, '1.20.1560.10-FF-000092', NULL, 'ABC bile acid transporter', 335, NULL, NULL, 211368),
(211369, '2.30.42.10-FF-000584', NULL, NULL, 108, NULL, NULL, 211369),
(211370, '3.40.570.10-FF-000008', NULL, 'Probable NUC1-dna/rna non-specific nuclease, mitochondrial', 289, NULL, NULL, 211370),
(211371, '3.40.720.10-FF-000200', NULL, 'Choline sulfatase', 446, NULL, NULL, 211371),
(211372, '1.25.10.10-FF-003184', NULL, 'PIKK family atypical protein kinase', 314, NULL, NULL, 211372),
(211373, '1.10.8.10-FF-000232', NULL, 'Ubiquitin carboxyl-terminal hydrolase A', 66, NULL, NULL, 211373),
(211374, '3.30.70.1320-FF-000010', NULL, 'Multidrug efflux pump', 98, NULL, NULL, 211374),
(211375, '3.30.70.1730-FF-000043', NULL, 'Ribosome assembly factor mrt4', 14, NULL, NULL, 211375),
(211376, '2.10.10.90-FF-000001', NULL, 'Chitin oligosaccharide deacetylase', 95, NULL, NULL, 211376),
(211377, '3.30.420.10-FF-000112', NULL, 'DNA polymerase', 214, NULL, NULL, 211377),
(211378, '2.60.40.10-FF-003198', NULL, 'B-cell antigen receptor complex-associated protein alpha chain', 96, NULL, NULL, 211378),
(211379, '3.40.50.1820-FF-000668', NULL, 'Predicted protein', 244, NULL, NULL, 211379),
(211380, '3.40.50.300-FF-005194', NULL, 'ATP-binding cassette sub-family G member 2-like', 213, NULL, NULL, 211380),
(211381, '3.40.50.300-FF-001883', NULL, 'Pre-mRNA-processing ATP-dependent RNA helicase PRP5', 180, NULL, NULL, 211381),
(211382, '1.20.1250.20-FF-002229', NULL, 'Uncharacterized protein', 126, NULL, NULL, 211382),
(211383, '1.10.10.790-FF-000041', NULL, NULL, 60, NULL, NULL, 211383),
(211384, '2.40.50.120-FF-000068', NULL, 'Predicted protein', 71, NULL, NULL, 211384),
(211385, '2.130.10.10-FF-006031', NULL, 'Probable elongator complex protein 2', 97, NULL, NULL, 211385),
(211386, '2.60.120.330-FF-000122', NULL, 'Protein SRG1 isoform A', 210, NULL, NULL, 211386),
(211387, '1.10.472.80-FF-000141', NULL, 'Related to MDR1-Mac1p interacting protein', 147, NULL, NULL, 211387),
(211388, '3.40.50.720-FF-000199', NULL, 'Cinnamoyl-CoA reductase 1', 332, NULL, NULL, 211388),
(211389, '3.30.950.10-FF-000028', NULL, 'Precorrin-6A synthase [deacetylating]', 111, NULL, NULL, 211389),
(211390, '3.30.2410.10-FF-000010', NULL, 'E3 ubiquitin-protein ligase UPL1', 120, NULL, NULL, 211390),
(211391, '2.60.40.10-FF-001399', NULL, 'Titin a', 98, NULL, NULL, 211391),
(211392, '3.30.70.330-FF-000566', NULL, 'Uncharacterized protein', 107, NULL, NULL, 211392),
(211393, '1.10.3200.20-FF-000003', NULL, 'DNA polymerase', 198, NULL, NULL, 211393),
(211394, '2.40.30.70-FF-000023', NULL, 'Uncharacterized protein', 101, NULL, NULL, 211394),
(211395, '3.30.390.30-FF-000042', NULL, 'IP11909p', 83, NULL, NULL, 211395),
(211396, '1.20.1270.10-FF-000053', NULL, 'Heat shock 70 kDa protein 1B', 74, NULL, NULL, 211396),
(211397, '3.40.50.10380-FF-000026', NULL, 'NADP-dependent malic enzyme', 253, NULL, NULL, 211397),
(211398, '4.10.430.10-FF-000001', NULL, 'DNA-binding protein', 44, NULL, NULL, 211398),
(211399, '1.25.10.10-FF-003476', NULL, 'Uncharacterized protein', 142, NULL, NULL, 211399),
(211400, '3.30.200.20-FF-001161', NULL, 'Membrane-associated tyrosine- and threonine-specific cdc2-inhibitory kinase wee-1.1', 109, NULL, NULL, 211400),
(211401, '1.20.58.60-FF-000239', NULL, 'dystrophin isoform X2', 141, NULL, NULL, 211401),
(211402, '2.60.40.2500-FF-000003', NULL, 'Type IV secretion system protein PtlF', 101, NULL, NULL, 211402),
(211403, '1.10.287.370-FF-000106', NULL, 'Predicted protein', 75, NULL, NULL, 211403),
(211404, '3.40.309.10-FF-000109', NULL, 'Predicted protein', 136, NULL, NULL, 211404),
(211405, '2.60.40.420-FF-000253', NULL, 'Ephrin', 147, NULL, NULL, 211405),
(211406, '3.30.160.60-FF-005659', NULL, NULL, 30, NULL, NULL, 211406),
(211407, '3.40.50.2000-FF-000661', NULL, 'Glycosyltransferase', 232, NULL, NULL, 211407),
(211408, '3.30.56.10-FF-000041', NULL, 'Phenylalanine--tRNA ligase beta subunit', 73, NULL, NULL, 211408);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(211409, '3.30.450.20-FF-000364', NULL, 'Neuronal PAS domain-containing protein 4-like', 90, NULL, NULL, 211409),
(211410, '3.40.50.300-FF-001265', NULL, 'Dynein heavy chain, putative', 175, NULL, NULL, 211410),
(211411, '1.10.510.10-FF-003700', NULL, NULL, 164, NULL, NULL, 211411),
(211412, '1.10.287.70-FF-000185', NULL, 'TWiK family of potassium channels', 291, NULL, NULL, 211412),
(211413, '1.10.510.10-FF-000215', NULL, 'serine/threonine-protein kinase/endoribonuclease IRE1 isoform X1', 191, NULL, NULL, 211413),
(211414, '1.10.1040.10-FF-000111', NULL, '3-hydroxyisobutyrate dehydrogenase', 107, NULL, NULL, 211414),
(211415, '3.40.50.720-FF-000441', NULL, 'Oxidoreductase, short-chain dehydrogenase/reductase', 248, NULL, NULL, 211415),
(211416, '1.10.10.60-FF-001254', NULL, NULL, 67, NULL, NULL, 211416),
(211417, '3.40.50.720-FF-000733', NULL, 'Alcohol dehydrogenase, putative', 151, NULL, NULL, 211417),
(211418, '3.40.50.300-FF-005722', NULL, 'Si:dkey-11m19.5', 162, NULL, NULL, 211418),
(211419, '1.10.10.10-FF-001166', NULL, 'Histone acetyltransferase', 38, NULL, NULL, 211419),
(211420, '1.10.238.10-FF-001190', NULL, 'Uncharacterized protein', 82, NULL, NULL, 211420),
(211421, '3.30.160.60-FF-002012', NULL, 'Zinc finger protein 989', 26, NULL, NULL, 211421),
(211422, '3.30.710.10-FF-000426', NULL, 'Uncharacterized protein', 104, NULL, NULL, 211422),
(211423, '1.25.40.10-FF-004664', NULL, 'Pentatricopeptide repeat-containing protein At3g46610', 114, NULL, NULL, 211423),
(211424, '3.30.160.60-FF-001444', NULL, 'zinc finger protein 131 isoform X1', 81, NULL, NULL, 211424),
(211425, '3.40.50.300-FF-000989', NULL, 'von Willebrand factor A domain containing 8', 196, NULL, NULL, 211425),
(211426, '3.60.21.70-FF-000005', NULL, 'Probable secreted alkaline phosphatase', 331, NULL, NULL, 211426),
(211427, '1.10.2000.10-FF-000070', NULL, NULL, 111, NULL, NULL, 211427),
(211428, '1.10.580.10-FF-000040', NULL, 'Citrate synthase', 226, NULL, NULL, 211428),
(211429, '3.30.200.20-FF-001453', NULL, 'Uncharacterized protein', 79, NULL, NULL, 211429),
(211430, '3.60.21.60-FF-000002', NULL, 'DNA polymerase alpha subunit B', 163, NULL, NULL, 211430),
(211431, '1.10.630.10-FF-000213', NULL, 'Putative cytochrome P450 superfamily protein', 476, NULL, NULL, 211431),
(211432, '3.30.70.330-FF-002157', NULL, NULL, 89, NULL, NULL, 211432),
(211433, '3.20.20.80-FF-000255', NULL, 'Alpha-glucosidase/alpha-amylase, putative', 322, NULL, NULL, 211433),
(211434, '3.30.160.60-FF-003473', NULL, 'Zgc:162936', 105, NULL, NULL, 211434),
(211435, '3.20.20.70-FF-000252', NULL, 'Glycoside hydrolase family 27', 336, NULL, NULL, 211435),
(211436, '3.30.479.30-FF-000028', NULL, 'Vacuolin-A', 141, NULL, NULL, 211436),
(211437, '3.30.200.20-FF-000964', NULL, 'Predicted protein', 94, NULL, NULL, 211437),
(211438, '3.15.10.10-FF-000015', NULL, 'lipopolysaccharide-binding protein isoform X2', 104, NULL, NULL, 211438),
(211439, '2.40.50.140-FF-000754', NULL, NULL, 64, NULL, NULL, 211439),
(211440, '2.10.25.10-FF-000337', NULL, 'stabilin-1 isoform X1', 44, NULL, NULL, 211440),
(211441, '3.30.40.10-FF-001201', NULL, 'RING finger protein 219', 97, NULL, NULL, 211441),
(211442, '3.40.50.620-FF-000815', NULL, 'Uncharacterized protein', 181, NULL, NULL, 211442),
(211443, '1.25.10.10-FF-002369', NULL, 'Uncharacterized protein', 277, NULL, NULL, 211443),
(211444, '2.60.40.10-FF-001348', NULL, 'Hemicentin 2', 94, NULL, NULL, 211444),
(211445, '3.90.1520.10-FF-000010', NULL, 'GH18909', 198, NULL, NULL, 211445),
(211446, '1.20.1090.10-FF-000016', NULL, '3-dehydroquinate synthase', 188, NULL, NULL, 211446),
(211447, '1.10.12.10-FF-000046', NULL, 'Short chain enoyl-CoA hydratase', 61, NULL, NULL, 211447),
(211448, '2.60.40.10-FF-000859', NULL, 'Titin b', 99, NULL, NULL, 211448),
(211449, '2.60.120.200-FF-000729', NULL, 'L-type lectin-like domain-containing protein C126.08c', 221, NULL, NULL, 211449),
(211450, '3.30.70.1230-FF-000101', NULL, 'Adenylate cyclase', 126, NULL, NULL, 211450),
(211451, '3.30.160.60-FF-001169', NULL, 'zinc finger protein 574', 56, NULL, NULL, 211451);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(211452, '3.80.10.10-FF-002248', NULL, 'Centrosomal protein of 78 kDa', 121, NULL, NULL, 211452),
(211453, '1.10.10.2480-FF-000003', NULL, 'Translation initiation factor IF-2', 65, NULL, NULL, 211453),
(211454, '1.25.40.180-FF-000152', NULL, 'Uncharacterized protein', 186, NULL, NULL, 211454),
(211455, '1.10.287.130-FF-000018', NULL, 'Sensor histidine kinase RstB', 64, NULL, NULL, 211455),
(211456, '2.130.10.10-FF-001265', NULL, 'Small nucleolar ribonucleoprotein complex subunit', 199, NULL, NULL, 211456),
(211457, '1.20.1270.60-FF-000101', NULL, 'F-BAR and double SH3 domains protein 2 isoform X6', 279, NULL, NULL, 211457),
(211458, '3.40.980.10-FF-000011', NULL, 'Molybdopterin molybdenumtransferase', 160, NULL, NULL, 211458),
(211459, '3.40.50.620-FF-000287', NULL, 'Tyrosine--tRNA ligase', 222, NULL, NULL, 211459),
(211460, '2.30.42.10-FF-000258', NULL, 'Uncharacterized protein, isoform A', 109, NULL, NULL, 211460),
(211461, '1.20.58.60-FF-000391', NULL, 'SMAll', 109, NULL, NULL, 211461),
(211462, '3.40.850.10-FF-000530', NULL, 'Kinesin-like protein', 88, NULL, NULL, 211462),
(211463, '3.40.50.2000-FF-000386', NULL, 'Glycosyltransferase', 277, NULL, NULL, 211463),
(211464, '3.30.70.2740-FF-000003', NULL, 'Oxidoreductase, FAD-binding, putative', 81, NULL, NULL, 211464),
(211465, '3.40.50.720-FF-002470', NULL, 'Polyketide synthase RzxE', 306, NULL, NULL, 211465),
(211466, '2.60.120.590-FF-000060', NULL, 'Uncharacterized protein', 201, NULL, NULL, 211466),
(211467, '1.10.287.110-FF-000012', NULL, 'dnaJ protein homolog', 100, NULL, NULL, 211467),
(211468, '1.10.10.10-FF-001379', NULL, 'Toxin biosynthesis regulatory protein AflJ, putative', 87, NULL, NULL, 211468),
(211469, '3.30.160.60-FF-002984', NULL, NULL, 31, NULL, NULL, 211469),
(211470, '1.10.287.130-FF-000170', NULL, 'Volvoxopsin-5, sensory rhodopsin with histidine kinase domain', 84, NULL, NULL, 211470),
(211471, '2.40.30.110-FF-000016', NULL, 'Aminomethyltransferase', 85, NULL, NULL, 211471),
(211472, '1.10.10.10-FF-001115', NULL, 'GntR family transcriptional regulator', 87, NULL, NULL, 211472),
(211473, '3.40.50.300-FF-006211', NULL, 'Uncharacterized protein', 246, NULL, NULL, 211473),
(211474, '3.30.160.60-FF-005160', NULL, NULL, 85, NULL, NULL, 211474),
(211475, '3.30.420.10-FF-000730', NULL, NULL, 238, NULL, NULL, 211475),
(211476, '2.130.10.30-FF-000135', NULL, NULL, 267, NULL, NULL, 211476),
(211477, '2.60.40.790-FF-000200', NULL, NULL, 66, NULL, NULL, 211477),
(211478, '3.30.710.10-FF-000477', NULL, 'Uncharacterized protein', 97, NULL, NULL, 211478),
(211479, '3.80.10.10-FF-000096', NULL, 'F-box/LRR-repeat protein 19 isoform X1', 259, NULL, NULL, 211479),
(211480, '3.40.50.300-FF-007397', NULL, 'Obg-like ATPase 1', 31, NULL, NULL, 211480),
(211481, '1.20.1070.10-FF-000184', NULL, 'C-C chemokine receptor type 10', 300, NULL, NULL, 211481),
(211482, '3.30.930.10-FF-000016', NULL, 'Asparagine--tRNA ligase', 356, NULL, NULL, 211482),
(211483, '2.10.220.10-FF-000015', NULL, 'proprotein convertase subtilisin/kexin type 6', 78, NULL, NULL, 211483),
(211484, '3.40.190.80-FF-000005', NULL, '3''(2''),5''-bisphosphate nucleotidase CysQ', 101, NULL, NULL, 211484),
(211485, '6.10.140.2220-FF-000027', NULL, 'Eto/mtg8/nervy, putative', 54, NULL, NULL, 211485),
(211486, '1.10.287.70-FF-000713', NULL, 'Uncharacterized protein', 152, NULL, NULL, 211486),
(211487, '2.10.70.10-FF-000026', NULL, 'Complement inhibitory factor H', 59, NULL, NULL, 211487),
(211488, '3.30.40.10-FF-000437', NULL, 'RING-type E3 ubiquitin transferase', 84, NULL, NULL, 211488),
(211489, '3.40.50.2000-FF-000947', NULL, 'Predicted protein', 118, NULL, NULL, 211489),
(211490, '3.30.1520.10-FF-000046', NULL, 'sorting nexin-17 isoform X4', 67, NULL, NULL, 211490),
(211491, '3.40.720.10-FF-000251', NULL, 'Sulfatase', 93, NULL, NULL, 211491),
(211492, '3.30.420.40-FF-000891', NULL, 'Glycerol kinase', 228, NULL, NULL, 211492),
(211493, '1.25.40.180-FF-000056', NULL, 'Sto1p', 215, NULL, NULL, 211493),
(211494, '2.130.10.10-FF-004699', NULL, 'Predicted protein', 174, NULL, NULL, 211494);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(211495, '2.60.40.10-FF-005064', NULL, NULL, 101, NULL, NULL, 211495),
(211496, '3.20.20.80-FF-000530', NULL, 'O-Glycosyl hydrolase family 17 protein', 101, NULL, NULL, 211496),
(211497, '2.20.100.10-FF-000077', NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 12', 59, NULL, NULL, 211497),
(211498, '1.25.40.20-FF-000221', NULL, 'Transient receptor potential-gamma protein', 282, NULL, NULL, 211498),
(211499, '2.60.120.290-FF-000149', NULL, 'Uncharacterized protein', 76, NULL, NULL, 211499),
(211500, '2.60.40.10-FF-000090', NULL, 'Protein-glutamine gamma-glutamyltransferase 2', 97, NULL, NULL, 211500),
(211501, '3.30.2090.10-FF-000018', NULL, 'Transporter, AcrB/D/F family', 95, NULL, NULL, 211501),
(211502, '3.30.70.1820-FF-000002', NULL, 'LINE-1 retrotransposable element ORF1 protein', 98, NULL, NULL, 211502),
(211503, '2.130.10.10-FF-003417', NULL, 'VPS15 protein kinase', 183, NULL, NULL, 211503),
(211504, '3.40.5.90-FF-000003', NULL, 'CDGSH iron sulfur domain 3', 44, NULL, NULL, 211504),
(211505, '3.40.50.1580-FF-000057', NULL, 'Probable S-methyl-5''-thioinosine phosphorylase', 257, NULL, NULL, 211505),
(211506, '3.30.200.20-FF-001009', NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', 119, NULL, NULL, 211506),
(211507, '3.20.20.80-FF-000822', NULL, 'Uncharacterized protein', 60, NULL, NULL, 211507),
(211508, '3.30.413.10-FF-000028', NULL, 'Nitrite and sulphite reductase 4Fe-4S region', 201, NULL, NULL, 211508),
(211509, '2.30.30.60-FF-000009', NULL, 'Mechanosensitive ion channel protein', 51, NULL, NULL, 211509),
(211510, '1.10.555.10-FF-000184', NULL, NULL, 91, NULL, NULL, 211510),
(211511, '2.60.120.10-FF-000631', NULL, 'Uncharacterized protein', 42, NULL, NULL, 211511),
(211512, '3.40.50.300-FF-007638', NULL, 'Predicted protein', 140, NULL, NULL, 211512),
(211513, '3.20.20.100-FF-000080', NULL, 'Aldo-keto reductase family 4 member C8', 307, NULL, NULL, 211513),
(211514, '1.10.10.10-FF-002104', NULL, 'Uncharacterized protein', 81, NULL, NULL, 211514),
(211515, '1.20.58.60-FF-000514', NULL, 'Spectrin repeat containing, nuclear envelope 1a', 294, NULL, NULL, 211515),
(211516, '1.20.1070.10-FF-000633', NULL, 'Histamine receptor H1', 253, NULL, NULL, 211516),
(211517, '2.60.300.12-FF-000035', NULL, NULL, 109, NULL, NULL, 211517),
(211518, '3.30.160.60-FF-003973', NULL, NULL, 26, NULL, NULL, 211518),
(211519, '1.20.140.10-FF-000022', NULL, 'Acyl-CoA dehydrogenase FadE8', 166, NULL, NULL, 211519),
(211520, '2.60.40.10-FF-003473', NULL, NULL, 98, NULL, NULL, 211520),
(211521, '1.25.40.10-FF-001095', NULL, 'Pentatricopeptide repeat-containing protein At2g34400', 125, NULL, NULL, 211521),
(211522, '1.10.1900.40-FF-000006', NULL, 'Erythrocyte membrane protein 1', 62, NULL, NULL, 211522),
(211523, '2.60.40.10-FF-001287', NULL, 'MAM domain-containing glycosylphosphatidylinositol anchor protein 1', 100, NULL, NULL, 211523),
(211524, '3.40.50.720-FF-002357', NULL, 'D-aspartate oxidase 1', 107, NULL, NULL, 211524),
(211525, '1.25.10.10-FF-003263', NULL, 'E3 ubiquitin-protein ligase listerin', 211, NULL, NULL, 211525),
(211526, '2.10.50.10-FF-000025', NULL, 'Tumor necrosis factor receptor superfamily member 1A', 51, NULL, NULL, 211526),
(211527, '2.60.40.1090-FF-000024', NULL, 'Fimbrial subunit', 153, NULL, NULL, 211527),
(211528, '2.30.30.490-FF-000025', NULL, 'E3 ubiquitin-protein ligase SNT2', 163, NULL, NULL, 211528),
(211529, '2.30.30.100-FF-000066', NULL, 'Bifunctional ligase/repressor BirA', 47, NULL, NULL, 211529),
(211530, '2.30.29.30-FF-000626', NULL, 'Protein CBG14242', 134, NULL, NULL, 211530),
(211531, '2.10.110.10-FF-000092', NULL, 'LIM domain-containing protein', 62, NULL, NULL, 211531),
(211532, '3.50.50.60-FF-000575', NULL, 'Putative polyamine oxidase 5 isoform A', 114, NULL, NULL, 211532),
(211533, '3.30.70.330-FF-002769', NULL, NULL, 76, NULL, NULL, 211533),
(211534, '3.40.50.1700-FF-000020', NULL, 'Beta-glucosidase', 178, NULL, NULL, 211534),
(211535, '4.10.830.40-FF-000006', NULL, 'E3 ubiquitin-protein ligase TRIM47', 72, NULL, NULL, 211535),
(211536, '1.25.40.20-FF-001098', NULL, 'Ankyrin repeat-containing protein', 83, NULL, NULL, 211536);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(211537, '1.25.10.10-FF-002695', NULL, 'Uncharacterized protein', 68, NULL, NULL, 211537),
(211538, '2.60.220.50-FF-000162', NULL, 'Uncharacterized protein', 210, NULL, NULL, 211538),
(211539, '3.30.413.10-FF-000034', NULL, 'Nitrite/sulfite reductase domain protein', 157, NULL, NULL, 211539),
(211540, '1.10.418.40-FF-000009', NULL, 'Protein CBR-BEC-1', 201, NULL, NULL, 211540),
(211541, '1.25.10.10-FF-001172', NULL, 'ARM repeat superfamily protein', 176, NULL, NULL, 211541),
(211542, '1.25.40.10-FF-001741', NULL, 'Tetratricopeptide repeat-like superfamily protein', 100, NULL, NULL, 211542),
(211543, '3.20.20.150-FF-000077', NULL, 'Uncharacterized protein', 96, NULL, NULL, 211543),
(211544, '4.10.1000.10-FF-000022', NULL, 'Zinc finger CCCH domain-containing protein 7', 62, NULL, NULL, 211544),
(211545, '1.10.8.10-FF-000350', NULL, 'Putative peptidyl-tRNA hydrolase 2-like Protein', 69, NULL, NULL, 211545),
(211546, '2.60.40.1080-FF-000021', NULL, 'SbsB protein', 91, NULL, NULL, 211546),
(211547, '2.60.120.200-FF-000229', NULL, 'MAM domain-containing protein 2', 148, NULL, NULL, 211547),
(211548, '3.30.40.10-FF-001701', NULL, 'BRCA1-associated RING domain protein 1', 66, NULL, NULL, 211548),
(211549, '2.40.70.10-FF-000289', NULL, 'Uncharacterized protein', 162, NULL, NULL, 211549),
(211550, '3.30.70.330-FF-001252', NULL, 'RNA recognition motif domain containing protein', 108, NULL, NULL, 211550),
(211551, '2.60.40.10-FF-005614', NULL, NULL, 102, NULL, NULL, 211551),
(211552, '3.40.50.80-FF-000188', NULL, 'NADPH--cytochrome P450 reductase', 161, NULL, NULL, 211552),
(211553, '3.40.50.720-FF-000227', NULL, 'Dipicolinic acid synthetase subunit A', 138, NULL, NULL, 211553),
(211554, '3.40.1110.10-FF-000400', NULL, NULL, 88, NULL, NULL, 211554),
(211555, '1.10.510.10-FF-001351', NULL, 'Casein kinase, putative', 284, NULL, NULL, 211555),
(211556, '3.30.1490.80-FF-000024', NULL, 'Glutathione synthetase', 66, NULL, NULL, 211556),
(211557, '1.25.10.10-FF-003358', NULL, 'Uncharacterized protein', 193, NULL, NULL, 211557),
(211558, '2.60.120.920-FF-000153', NULL, 'Si:ch211-238e22.8', 181, NULL, NULL, 211558),
(211559, '3.40.50.300-FF-005508', NULL, 'ATP-dependent DEAD/H RNA helicase, putative', 165, NULL, NULL, 211559),
(211560, '1.20.58.60-FF-000891', NULL, 'Uncharacterized protein', 159, NULL, NULL, 211560),
(211561, '1.25.40.20-FF-000108', NULL, 'Ankyrin repeat domain-containing protein 54', 67, NULL, NULL, 211561),
(211562, '3.30.450.70-FF-000025', NULL, 'TRAPPC2 isoform 2', 74, NULL, NULL, 211562),
(211563, '1.10.1040.10-FF-000015', NULL, 'Ketol-acid reductoisomerase', 274, NULL, NULL, 211563),
(211564, '1.25.40.20-FF-001744', NULL, 'Uncharacterized protein', 211, NULL, NULL, 211564),
(211565, '1.10.287.770-FF-000018', NULL, 'Pickpocket 6', 62, NULL, NULL, 211565),
(211566, '1.10.418.30-FF-000006', NULL, 'Probable kinetochore protein NDC80', 122, NULL, NULL, 211566),
(211567, '2.70.160.11-FF-000071', NULL, 'protein arginine N-methyltransferase 9', 156, NULL, NULL, 211567),
(211568, '3.40.50.410-FF-000292', NULL, 'Collagen type VI alpha 3 chain', 189, NULL, NULL, 211568),
(211569, '3.40.190.10-FF-000642', NULL, 'LD22449p', 88, NULL, NULL, 211569),
(211570, '1.10.287.130-FF-000052', NULL, 'PAS domain-containing sensor histidine kinase', 56, NULL, NULL, 211570),
(211571, '3.90.70.10-FF-000689', NULL, 'Uncharacterized protein', 233, NULL, NULL, 211571),
(211572, '2.60.40.60-FF-000846', NULL, 'Uncharacterized protein', 60, NULL, NULL, 211572),
(211573, '1.25.10.10-FF-001560', NULL, 'Uncharacterized protein', 309, NULL, NULL, 211573),
(211574, '1.10.8.10-FF-000018', NULL, 'Nuclear RNA export factor 1', 58, NULL, NULL, 211574),
(211575, '3.30.710.10-FF-000365', NULL, 'Uncharacterized protein', 70, NULL, NULL, 211575),
(211576, '1.25.40.180-FF-000264', NULL, NULL, 217, NULL, NULL, 211576),
(211577, '2.130.10.10-FF-005542', NULL, 'Transducin family protein / WD-40 repeat family protein', 224, NULL, NULL, 211577),
(211578, '1.10.860.10-FF-000022', NULL, 'DNA primase', 131, NULL, NULL, 211578),
(211579, '1.10.510.10-FF-002975', NULL, NULL, 208, NULL, NULL, 211579);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(211580, '1.50.40.10-FF-000031', NULL, 'mitoferrin-2 isoform X1', 151, NULL, NULL, 211580),
(211581, '3.40.50.620-FF-000175', NULL, 'Isoleucine--tRNA ligase', 223, NULL, NULL, 211581),
(211582, '3.40.50.720-FF-001222', NULL, 'Glucose-fructose oxidoreductase domain containing 2', 84, NULL, NULL, 211582),
(211583, '3.30.70.360-FF-000013', NULL, 'Allantoate amidohydrolase', 115, NULL, NULL, 211583),
(211584, '1.10.150.20-FF-000174', NULL, 'ATP-dependent DNA helicase Hel308', 57, NULL, NULL, 211584),
(211585, '3.50.50.60-FF-001238', NULL, 'Uncharacterized protein', 192, NULL, NULL, 211585),
(211586, '3.40.50.850-FF-000007', NULL, 'isochorismatase domain-containing protein 2 isoform X2', 75, NULL, NULL, 211586),
(211587, '3.40.50.720-FF-000284', NULL, 'Lysine-ketoglutarate reductase/saccharopine dehydrogenase1', 155, NULL, NULL, 211587),
(211588, '2.60.40.420-FF-000168', NULL, 'L-ascorbate oxidase-like Protein', 152, NULL, NULL, 211588),
(211589, '1.20.140.10-FF-000061', NULL, 'Acyl-CoA dehydrogenase', 145, NULL, NULL, 211589),
(211590, '1.10.2020.20-FF-000023', NULL, NULL, 75, NULL, NULL, 211590),
(211591, '3.80.10.10-FF-000450', NULL, 'Leucine-rich repeat protein soc-2', 150, NULL, NULL, 211591),
(211592, '3.40.440.10-FF-000004', NULL, 'Adenylosuccinate synthetase', 157, NULL, NULL, 211592),
(211593, '3.40.50.300-FF-007751', NULL, 'Uncharacterized protein', 75, NULL, NULL, 211593),
(211594, '1.10.8.590-FF-000011', NULL, NULL, 57, NULL, NULL, 211594),
(211595, '1.20.1070.10-FF-001240', NULL, 'Putative transmembrane receptor', 347, NULL, NULL, 211595),
(211596, '3.30.70.141-FF-000050', NULL, NULL, 151, NULL, NULL, 211596),
(211597, '1.10.3370.10-FF-000012', NULL, 'Ssh1p', 479, NULL, NULL, 211597),
(211598, '1.10.1580.10-FF-000022', NULL, 'G protein nucleolar 3', 90, NULL, NULL, 211598),
(211599, '3.30.70.370-FF-000016', NULL, 'DNA polymerase 1, putative', 71, NULL, NULL, 211599),
(211600, '1.20.1730.10-FF-000015', NULL, 'Na+/galactose cotransporter', 521, NULL, NULL, 211600),
(211601, '2.130.10.10-FF-003451', NULL, 'Transcription initiation factor TFIID subunit 9', 118, NULL, NULL, 211601),
(211602, '1.25.40.10-FF-004338', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 164, NULL, NULL, 211602),
(211603, '3.40.50.300-FF-003423', NULL, 'Developmentally-regulated GTP-binding protein, putative', 104, NULL, NULL, 211603),
(211604, '4.10.950.10-FF-000006', NULL, NULL, 66, NULL, NULL, 211604),
(211605, '3.30.40.10-FF-000763', NULL, 'Uncharacterized protein, isoform A', 76, NULL, NULL, 211605),
(211606, '2.10.25.10-FF-000130', NULL, 'Laminin subunit beta 1', 52, NULL, NULL, 211606),
(211607, '3.40.710.10-FF-000082', NULL, 'Penicillin-binding protein 1A', 397, NULL, NULL, 211607),
(211608, '3.30.160.60-FF-001736', NULL, 'Fibronectin type III and SPRY domain containing 2', 33, NULL, NULL, 211608),
(211609, '3.40.50.620-FF-000080', NULL, 'Nicotinamide/nicotinic acid mononucleotide adenylyltransferase 2', 262, NULL, NULL, 211609),
(211610, '1.20.1560.10-FF-000266', NULL, 'Putative multidrug resistance-associated protein lethal(2)03659-like Protein', 330, NULL, NULL, 211610),
(211611, '2.170.150.10-FF-000039', NULL, 'Uncharacterized protein', 59, NULL, NULL, 211611),
(211612, '1.20.5.110-FF-000146', NULL, 'Ehsyntaxin K, putative', 77, NULL, NULL, 211612),
(211613, '1.10.3720.10-FF-000169', NULL, 'ABC transporter permease', 226, NULL, NULL, 211613),
(211614, '2.120.10.30-FF-000568', NULL, 'Uncharacterized protein', 45, NULL, NULL, 211614),
(211615, '2.40.128.620-FF-000005', NULL, 'SCO-spondin', 54, NULL, NULL, 211615),
(211616, '3.30.160.60-FF-003653', NULL, NULL, 28, NULL, NULL, 211616),
(211617, '1.25.40.80-FF-000019', NULL, 'Predicted protein', 63, NULL, NULL, 211617),
(211618, '3.40.50.2000-FF-000739', NULL, 'Uncharacterized protein', 254, NULL, NULL, 211618),
(211619, '1.20.58.2240-FF-000002', NULL, 'FGGY carbohydrate kinase domain-containing protein', 159, NULL, NULL, 211619),
(211620, '3.30.1520.10-FF-000158', NULL, 'Uncharacterized protein', 146, NULL, NULL, 211620),
(211621, '3.30.40.10-FF-002157', NULL, 'Structure-specific endonuclease subunit SLX1 homolog', 89, NULL, NULL, 211621); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(211622, '3.40.190.10-FF-000737', NULL, 'Nodulation protein D 1', 103, NULL, NULL, 211622),
(211623, '3.30.160.380-FF-000005', NULL, 'Dicer-like protein 2', 101, NULL, NULL, 211623),
(211624, '3.40.50.300-FF-005660', NULL, 'Adenylate/guanylate cyclase domain-containing protein', 204, NULL, NULL, 211624),
(211625, '2.40.128.630-FF-000008', NULL, 'Uncharacterized protein', 118, NULL, NULL, 211625),
(211626, '1.20.1070.10-FF-002078', NULL, 'Uncharacterized protein', 52, NULL, NULL, 211626),
(211627, '1.10.10.10-FF-001441', NULL, 'Paired box protein Pax-3', 26, NULL, NULL, 211627),
(211628, '3.30.70.1620-FF-000010', NULL, 'Structural maintenance of chromosomes protein 1', 79, NULL, NULL, 211628),
(211629, '1.10.10.250-FF-000014', NULL, '60S ribosomal protein L12, putative', 85, NULL, NULL, 211629),
(211630, '3.40.50.150-FF-001208', NULL, 'Protein-lysine N-methyltransferase rrg1', 230, NULL, NULL, 211630),
(211631, '3.40.20.10-FF-000093', NULL, 'Villin-like 1', 117, NULL, NULL, 211631),
(211632, '3.30.70.330-FF-000971', NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', 81, NULL, NULL, 211632),
(211633, '1.20.1250.20-FF-000088', NULL, 'MFS multidrug transporter, putative', 427, NULL, NULL, 211633),
(211634, '1.10.601.10-FF-000005', NULL, 'RNA polymerase sigma factor RpoH', 81, NULL, NULL, 211634),
(211635, '2.30.29.30-FF-000840', NULL, 'Predicted protein', 98, NULL, NULL, 211635),
(211636, '2.130.10.10-FF-001618', NULL, 'Transducin/WD40 repeat-like superfamily protein', 164, NULL, NULL, 211636),
(211637, '2.130.10.10-FF-000596', NULL, 'Eukaryotic translation initiation factor 2A', 232, NULL, NULL, 211637),
(211638, '3.40.50.10490-FF-000059', NULL, 'Glucose-6-phosphate isomerase', 201, NULL, NULL, 211638),
(211639, '3.30.70.330-FF-002449', NULL, NULL, 86, NULL, NULL, 211639),
(211640, '2.170.130.10-FF-000044', NULL, 'Hemin receptor', 134, NULL, NULL, 211640),
(211641, '1.10.8.140-FF-000011', NULL, 'Double-stranded DNA-binding domain containing protein', 80, NULL, NULL, 211641),
(211642, '3.40.390.10-FF-000062', NULL, 'Zinc metalloproteinase', 232, NULL, NULL, 211642),
(211643, '2.60.120.200-FF-000342', NULL, 'Apical endosomal glycoprotein', 175, NULL, NULL, 211643),
(211644, '3.40.50.300-FF-007846', NULL, 'Uncharacterized protein', 227, NULL, NULL, 211644),
(211645, '3.40.50.10190-FF-000250', NULL, 'YALI0B15576p', 104, NULL, NULL, 211645),
(211646, '1.50.10.10-FF-000203', NULL, 'alpha-1,2-Mannosidase', 202, NULL, NULL, 211646),
(211647, '3.30.160.60-FF-001556', NULL, 'Zinc finger protein 154', 29, NULL, NULL, 211647),
(211648, '3.40.50.300-FF-001557', NULL, 'Septin homolog spn3', 287, NULL, NULL, 211648),
(211649, '1.50.10.10-FF-000091', NULL, 'alpha-1,2-Mannosidase', 472, NULL, NULL, 211649),
(211650, '1.10.510.10-FF-003149', NULL, NULL, 175, NULL, NULL, 211650),
(211651, '2.20.25.100-FF-000007', NULL, '40S ribosomal protein S27', 63, NULL, NULL, 211651),
(211652, '1.20.120.1880-FF-000019', NULL, 'Uncharacterized protein', 245, NULL, NULL, 211652),
(211653, '3.40.50.450-FF-000045', NULL, 'Lysine decarboxylase', 237, NULL, NULL, 211653),
(211654, '1.10.1220.10-FF-000001', NULL, 'Nickel-responsive regulator', 47, NULL, NULL, 211654),
(211655, '3.20.20.80-FF-000081', NULL, 'Chitinase 1', 351, NULL, NULL, 211655),
(211656, '1.10.1200.10-FF-000112', NULL, 'Acyl carrier protein', 52, NULL, NULL, 211656),
(211657, '2.40.70.10-FF-000497', NULL, NULL, 124, NULL, NULL, 211657),
(211658, '2.30.30.140-FF-000229', NULL, 'Bromodomain and PHD finger-containing, 3', 84, NULL, NULL, 211658),
(211659, '1.50.10.20-FF-000094', NULL, 'Uncharacterized protein', 91, NULL, NULL, 211659),
(211660, '1.10.3330.10-FF-000004', NULL, 'Uric acid degradation bifunctional protein', 164, NULL, NULL, 211660),
(211661, '3.30.559.30-FF-000012', NULL, 'Nonribosomal peptide synthase SidE', 239, NULL, NULL, 211661),
(211662, '2.10.25.10-FF-000225', NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain containing 1', 31, NULL, NULL, 211662),
(211663, '3.30.930.10-FF-000403', NULL, 'Predicted protein', 110, NULL, NULL, 211663);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(211664, '2.130.10.10-FF-003176', NULL, 'Transducin/WD40 repeat-like superfamily protein', 107, NULL, NULL, 211664),
(211665, '1.20.1250.20-FF-000734', NULL, 'Sugar (Glycoside-Pentoside-Hexuronide) transporter', 198, NULL, NULL, 211665),
(211666, '1.10.510.10-FF-002014', NULL, NULL, 62, NULL, NULL, 211666),
(211667, '3.90.1580.10-FF-000013', NULL, 'GM14301', 280, NULL, NULL, 211667),
(211668, '1.20.120.1080-FF-000111', NULL, 'Uncharacterized protein', 101, NULL, NULL, 211668),
(211669, '1.20.1310.10-FF-000169', NULL, NULL, 159, NULL, NULL, 211669),
(211670, '2.40.50.140-FF-000804', NULL, NULL, 144, NULL, NULL, 211670),
(211671, '3.30.160.60-FF-006469', NULL, NULL, 52, NULL, NULL, 211671),
(211672, '3.40.50.170-FF-000023', NULL, 'Pyoverdine synthetase F', 208, NULL, NULL, 211672),
(211673, '3.80.10.10-FF-001231', NULL, 'Os02g0281150 protein', 162, NULL, NULL, 211673),
(211674, '3.40.1160.10-FF-000049', NULL, 'Aspartokinase', 307, NULL, NULL, 211674),
(211675, '3.30.9.10-FF-000230', NULL, 'Uncharacterized protein', 93, NULL, NULL, 211675),
(211676, '3.30.450.60-FF-000022', NULL, 'AP complex subunit sigma', 141, NULL, NULL, 211676),
(211677, '1.50.10.10-FF-000186', NULL, 'Predicted protein', 311, NULL, NULL, 211677),
(211678, '2.10.110.10-FF-000299', NULL, 'Uncharacterized protein', 64, NULL, NULL, 211678),
(211679, '1.10.530.10-FF-000003', NULL, 'Membrane-bound lytic murein transglycosylase F', 181, NULL, NULL, 211679),
(211680, '3.40.50.720-FF-000492', NULL, 'D3-phosphoglycerate dehydrogenase, putative', 175, NULL, NULL, 211680),
(211681, '1.20.58.900-FF-000023', NULL, 'Protein CBR-UNC-14', 153, NULL, NULL, 211681),
(211682, '2.130.10.10-FF-001091', NULL, 'G protein beta subunit', 391, NULL, NULL, 211682),
(211683, '1.10.8.60-FF-000106', NULL, 'Cell division control protein 48 homolog B', 83, NULL, NULL, 211683),
(211684, '2.30.29.30-FF-000683', NULL, 'Homer scaffold protein 1', 51, NULL, NULL, 211684),
(211685, '1.20.58.60-FF-000571', NULL, 'Spectrin beta chain', 100, NULL, NULL, 211685),
(211686, '3.90.640.10-FF-000137', NULL, 'Uncharacterized protein', 53, NULL, NULL, 211686),
(211687, '2.60.40.10-FF-002658', NULL, 'Myotactin form A', 107, NULL, NULL, 211687),
(211688, '3.30.1330.40-FF-000052', NULL, 'Uncharacterized protein', 131, NULL, NULL, 211688),
(211689, '3.40.50.10330-FF-000039', NULL, 'Diacylglycerol kinase', 136, NULL, NULL, 211689),
(211690, '1.10.8.10-FF-000170', NULL, 'Release factor glutamine methyltransferase', 80, NULL, NULL, 211690),
(211691, '1.20.970.10-FF-000034', NULL, 'Anthranilate phosphoribosyltransferase', 78, NULL, NULL, 211691),
(211692, '3.60.10.10-FF-000052', NULL, 'Retrovirus-related Pol polyprotein LINE-1', 243, NULL, NULL, 211692),
(211693, '2.60.120.200-FF-000437', NULL, 'EC1118_1J11_0133p', 192, NULL, NULL, 211693),
(211694, '1.25.10.10-FF-001059', NULL, 'Pumillio protein 8, putative', 151, NULL, NULL, 211694),
(211695, '3.90.840.10-FF-000001', NULL, 'Thiol-activated cytolysin', 172, NULL, NULL, 211695),
(211696, '1.10.3860.10-FF-000033', NULL, 'Amino acid transporter', 114, NULL, NULL, 211696),
(211697, '1.10.10.1010-FF-000001', NULL, 'DNA polymerase', 146, NULL, NULL, 211697),
(211698, '3.10.450.40-FF-000032', NULL, 'Required to maintain repression6', 95, NULL, NULL, 211698),
(211699, '3.30.750.44-FF-000010', NULL, 'Carboxyl-terminal-processing peptidase 1 chloroplastic', 15, NULL, NULL, 211699),
(211700, '3.40.50.11660-FF-000045', NULL, NULL, 113, NULL, NULL, 211700),
(211701, '3.40.50.1460-FF-000072', NULL, 'caspase-6-like isoform X1', 195, NULL, NULL, 211701),
(211702, '2.80.10.50-FF-000205', NULL, 'Ricin B-like lectin EULS3', 151, NULL, NULL, 211702),
(211703, '3.90.180.10-FF-000057', NULL, 'Putative alcohol dehydrogenase', 174, NULL, NULL, 211703),
(211704, '4.10.1060.10-FF-000031', NULL, 'FUS/TLS RNA binding protein homolog', 38, NULL, NULL, 211704),
(211705, '3.40.50.300-FF-004412', NULL, 'RabA', 182, NULL, NULL, 211705),
(211706, '2.20.100.10-FF-000105', NULL, 'Circumsporozoite-and TRAP-related protein', 94, NULL, NULL, 211706),
(211707, '3.40.190.10-FF-000849', NULL, 'Sugar ABC transporter, periplasmic sugar-binding protein', 167, NULL, NULL, 211707);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(211708, '3.40.50.1110-FF-000051', NULL, 'GDSL Lipase/Acylhydrolase', 255, NULL, NULL, 211708),
(211709, '2.20.100.10-FF-000162', NULL, 'Semaphorin 5C', 66, NULL, NULL, 211709),
(211710, '3.40.1280.10-FF-000058', NULL, 'rRNA methylase, SpoU family protein', 142, NULL, NULL, 211710),
(211711, '3.30.160.60-FF-003765', NULL, 'AGAP001555-PA', 73, NULL, NULL, 211711),
(211712, '2.60.220.30-FF-000004', NULL, 'tight junction protein ZO-1 isoform X1', 150, NULL, NULL, 211712),
(211713, '3.20.20.70-FF-000605', NULL, NULL, 222, NULL, NULL, 211713),
(211714, '3.20.20.20-FF-000001', NULL, '4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase (flavodoxin)', 259, NULL, NULL, 211714),
(211715, '3.40.850.10-FF-000081', NULL, 'Kinesin-13, putative', 333, NULL, NULL, 211715),
(211716, '2.130.10.10-FF-003243', NULL, 'Cilia- and flagella-associated protein 44', 224, NULL, NULL, 211716),
(211717, '3.40.50.150-FF-001265', NULL, NULL, 239, NULL, NULL, 211717),
(211718, '3.90.1150.10-FF-000195', NULL, 'Uncharacterized protein, isoform B', 150, NULL, NULL, 211718),
(211719, '1.10.400.20-FF-000002', NULL, 'Tagatose-bisphosphate aldolase noncatalytic subunit', 137, NULL, NULL, 211719),
(211720, '3.30.70.330-FF-000358', NULL, 'RNA exonuclease 5 isoform X1', 91, NULL, NULL, 211720),
(211721, '3.40.630.10-FF-000339', NULL, 'Uncharacterized protein', 285, NULL, NULL, 211721),
(211722, '1.20.58.60-FF-000778', NULL, 'Wu:fi04e12', 227, NULL, NULL, 211722),
(211723, '3.30.450.20-FF-000156', NULL, 'Two-component sensor histidine kinase', 111, NULL, NULL, 211723),
(211724, '2.60.40.10-FF-005238', NULL, NULL, 89, NULL, NULL, 211724),
(211725, '3.30.710.10-FF-000185', NULL, 'Btb/poz domain containing protein', 101, NULL, NULL, 211725),
(211726, '4.10.1240.10-FF-000062', NULL, 'Uncharacterized protein', 60, NULL, NULL, 211726),
(211727, '1.10.287.4070-FF-000009', NULL, 'Pre-mRNA processing ribonucleoprotein, binding domain protein', 157, NULL, NULL, 211727),
(211728, '1.25.40.10-FF-005327', NULL, 'Pentatricopeptide repeat-containing protein At1g52620', 103, NULL, NULL, 211728),
(211729, '3.20.20.80-FF-000608', NULL, 'Uncharacterized protein', 170, NULL, NULL, 211729),
(211730, '3.60.40.10-FF-000166', NULL, 'Protein phosphatase domain containing protein', 270, NULL, NULL, 211730),
(211731, '2.60.220.20-FF-000001', NULL, 'Beta-galactosidase, putative (AFU_orthologue AFUA_5G00670)', 100, NULL, NULL, 211731),
(211732, '3.90.25.10-FF-000096', NULL, 'Uncharacterized protein', 109, NULL, NULL, 211732),
(211733, '3.90.550.10-FF-000698', NULL, 'Uncharacterized protein', 292, NULL, NULL, 211733),
(211734, '1.10.10.60-FF-001080', NULL, NULL, 77, NULL, NULL, 211734),
(211735, '3.30.160.60-FF-001236', NULL, 'E3 ubiquitin-protein ligase ZNRF2', 24, NULL, NULL, 211735),
(211736, '1.25.10.10-FF-002919', NULL, 'Uncharacterized protein', 107, NULL, NULL, 211736),
(211737, '3.20.20.330-FF-000030', NULL, 'Uncharacterized protein C57A7.07c', 306, NULL, NULL, 211737),
(211738, '3.20.70.20-FF-000004', NULL, 'Ribonucleoside-diphosphate reductase', 470, NULL, NULL, 211738),
(211739, '2.30.29.30-FF-000806', NULL, 'Putative phosphatidylinositol-3-phosphate binding protein', 137, NULL, NULL, 211739),
(211740, '3.40.720.10-FF-000043', NULL, 'Acid phosphatase PHOa', 279, NULL, NULL, 211740),
(211741, '3.30.70.330-FF-002887', NULL, NULL, 59, NULL, NULL, 211741),
(211742, '4.10.260.10-FF-000004', NULL, 'guanine nucleotide-binding protein G(I)/G(S)/G(O) subunit gamma-13', 65, NULL, NULL, 211742),
(211743, '1.10.10.60-FF-001102', NULL, NULL, 68, NULL, NULL, 211743),
(211744, '1.10.238.10-FF-000936', NULL, 'EF-hand domain containing protein, putative', 157, NULL, NULL, 211744),
(211745, '2.130.10.10-FF-003861', NULL, 'Uncharacterized protein', 283, NULL, NULL, 211745),
(211746, '3.40.50.620-FF-000528', NULL, 'Os02g0183900 protein', 207, NULL, NULL, 211746),
(211747, '1.10.10.2030-FF-000003', NULL, 'Rts2p', 118, NULL, NULL, 211747),
(211748, '1.10.10.10-FF-001380', NULL, 'Caffeic acid 3-O-methyltransferase isoform A', 114, NULL, NULL, 211748),
(211749, '2.60.120.200-FF-000494', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 2', 194, NULL, NULL, 211749);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(211750, '1.20.1250.20-FF-000723', NULL, 'Putative multidrug resistance protein', 384, NULL, NULL, 211750),
(211751, '3.30.450.20-FF-000038', NULL, 'Sensor domain-containing diguanylate cyclase', 127, NULL, NULL, 211751),
(211752, '1.20.5.110-FF-000213', NULL, 'Synaptobrevin 1-2', 86, NULL, NULL, 211752),
(211753, '2.60.40.1180-FF-000051', NULL, 'Alpha-L-fucosidase', 91, NULL, NULL, 211753),
(211754, '3.30.40.10-FF-000476', NULL, 'E3 SUMO-protein ligase SIZ1', 69, NULL, NULL, 211754),
(211755, '3.60.20.10-FF-000171', NULL, NULL, 203, NULL, NULL, 211755),
(211756, '1.10.472.80-FF-000107', NULL, 'Rab GTPase activating protein, putative', 127, NULL, NULL, 211756),
(211757, '3.30.70.330-FF-002657', NULL, NULL, 119, NULL, NULL, 211757),
(211758, '3.90.80.10-FF-000021', NULL, 'Inorganic pyrophosphatase', 165, NULL, NULL, 211758),
(211759, '3.40.50.300-FF-007228', NULL, 'Uncharacterized protein', 162, NULL, NULL, 211759),
(211760, '1.10.10.60-FF-000826', NULL, NULL, 73, NULL, NULL, 211760),
(211761, '2.10.25.10-FF-001130', NULL, 'Uncharacterized protein, isoform B', 46, NULL, NULL, 211761),
(211762, '3.90.190.10-FF-000501', NULL, 'Uncharacterized protein', 294, NULL, NULL, 211762),
(211763, '3.30.70.330-FF-001134', NULL, 'Poly(A) binding protein', 93, NULL, NULL, 211763),
(211764, '2.70.160.11-FF-000060', NULL, 'Predicted protein', 207, NULL, NULL, 211764),
(211765, '1.20.58.390-FF-000010', NULL, 'Nicotinic acetylcholine receptor subunit epsilon', 109, NULL, NULL, 211765),
(211766, '3.50.50.60-FF-001031', NULL, 'Predicted protein', 93, NULL, NULL, 211766),
(211767, '3.40.30.10-FF-000211', NULL, 'TPR repeat-containing thioredoxin TTL4', 108, NULL, NULL, 211767),
(211768, '3.40.50.10730-FF-000002', NULL, 'Urocanate hydratase 1', 219, NULL, NULL, 211768),
(211769, '3.30.40.10-FF-002275', NULL, 'Uncharacterized protein', 51, NULL, NULL, 211769),
(211770, '2.40.30.10-FF-000112', NULL, 'TetQ GTPase', 94, NULL, NULL, 211770),
(211771, '1.10.287.70-FF-000472', NULL, 'Potassium channel, subfamily K, member 12-like', 106, NULL, NULL, 211771),
(211772, '3.30.160.190-FF-000004', NULL, 'Predicted protein', 71, NULL, NULL, 211772),
(211773, '2.130.10.10-FF-005328', NULL, 'Wd-repeat protein, putative', 192, NULL, NULL, 211773),
(211774, '1.25.10.10-FF-001352', NULL, 'Uncharacterized protein', 265, NULL, NULL, 211774),
(211775, '1.10.238.10-FF-000402', NULL, 'Calcium-binding protein SPEC 2D', 77, NULL, NULL, 211775),
(211776, '1.10.238.10-FF-001156', NULL, 'Kinesin-like protein', 113, NULL, NULL, 211776),
(211777, '3.30.70.330-FF-000471', NULL, 'Polyadenylate-binding RBP45B-like protein', 78, NULL, NULL, 211777),
(211778, '3.40.50.300-FF-001057', NULL, 'LPS export ABC transporter ATP-binding protein', 244, NULL, NULL, 211778),
(211779, '2.60.40.1230-FF-000004', NULL, 'AP-1 complex subunit gamma', 122, NULL, NULL, 211779),
(211780, '2.60.40.1220-FF-000001', NULL, 'CopC domain-containing protein YobA', 100, NULL, NULL, 211780),
(211781, '4.10.1000.10-FF-000134', NULL, 'AGL116Cp', 59, NULL, NULL, 211781),
(211782, '3.30.450.60-FF-000090', NULL, 'Uncharacterized protein', 119, NULL, NULL, 211782),
(211783, '2.30.42.10-FF-000197', NULL, 'Periplasmic serine endoprotease DegP-like', 90, NULL, NULL, 211783),
(211784, '3.40.50.1010-FF-000021', NULL, 'DIS3-like exonuclease 1 isoform X1', 187, NULL, NULL, 211784),
(211785, '3.30.160.60-FF-005564', NULL, NULL, 61, NULL, NULL, 211785),
(211786, '1.20.1250.20-FF-001858', NULL, 'MFS multidrug transporter, putative (AFU_orthologue AFUA_3G14560)', 124, NULL, NULL, 211786),
(211787, '3.30.160.60-FF-000101', NULL, 'zinc finger protein 436 isoform X1', 28, NULL, NULL, 211787),
(211788, '1.10.2000.10-FF-000018', NULL, 'Tyrosine-protein kinase receptor', 66, NULL, NULL, 211788),
(211789, '2.130.10.10-FF-005660', NULL, 'Uncharacterized protein', 166, NULL, NULL, 211789),
(211790, '2.60.120.290-FF-000037', NULL, 'Kremen protein 2', 111, NULL, NULL, 211790),
(211791, '1.20.20.10-FF-000008', NULL, 'ATPase subunit 9 homolog', 73, NULL, NULL, 211791),
(211792, '3.30.200.20-FF-000458', NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 196', 99, NULL, NULL, 211792);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(211793, '2.130.10.10-FF-001377', NULL, 'Uncharacterized protein, isoform A', 162, NULL, NULL, 211793),
(211794, '3.40.390.10-FF-000269', NULL, NULL, 165, NULL, NULL, 211794),
(211795, '3.30.540.30-FF-000020', NULL, 'Dipeptidyl peptidase III', 178, NULL, NULL, 211795),
(211796, '1.20.120.1530-FF-000016', NULL, NULL, 89, NULL, NULL, 211796),
(211797, '2.130.10.30-FF-000023', NULL, 'serine/threonine-protein kinase Nek9 isoform X2', 235, NULL, NULL, 211797),
(211798, '3.90.15.10-FF-000005', NULL, 'DNA topoisomerase I', 155, NULL, NULL, 211798),
(211799, '1.20.900.10-FF-000086', NULL, 'Uncharacterized protein', 228, NULL, NULL, 211799),
(211800, '3.30.460.10-FF-000204', NULL, '2''-5'' oligoadenylate synthetase 1E', 64, NULL, NULL, 211800),
(211801, '1.10.510.10-FF-002132', NULL, 'TBC Kinase homolog', 226, NULL, NULL, 211801),
(211802, '3.40.50.300-FF-007285', NULL, 'Uncharacterized protein', 154, NULL, NULL, 211802),
(211803, '3.30.160.60-FF-001910', NULL, 'zinc finger protein 420 isoform X3', 29, NULL, NULL, 211803),
(211804, '1.20.1730.10-FF-000072', NULL, 'Two-component sensor CbrA', 485, NULL, NULL, 211804),
(211805, '2.10.10.10-FF-000028', NULL, 'HGF activator', 65, NULL, NULL, 211805),
(211806, '3.30.1490.20-FF-000085', NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', 53, NULL, NULL, 211806),
(211807, '4.10.280.10-FF-000056', NULL, 'mesogenin-1', 69, NULL, NULL, 211807),
(211808, '3.30.450.20-FF-000656', NULL, 'Sensory transduction histidine kinase', 155, NULL, NULL, 211808),
(211809, '3.30.110.10-FF-000010', NULL, 'Predicted protein', 98, NULL, NULL, 211809),
(211810, '3.40.1190.20-FF-000054', NULL, 'ATP-dependent (S)-NAD(P)H-hydrate dehydratase', 228, NULL, NULL, 211810),
(211811, '3.40.50.2300-FF-000661', NULL, 'Two-component sensor histidine kinase', 93, NULL, NULL, 211811),
(211812, '3.30.420.140-FF-000050', NULL, 'Uncharacterized protein', 20, NULL, NULL, 211812),
(211813, '1.20.1250.20-FF-002179', NULL, 'Uncharacterized protein', 171, NULL, NULL, 211813),
(211814, '3.40.50.1820-FF-000825', NULL, 'Carboxylic ester hydrolase', 428, NULL, NULL, 211814),
(211815, '3.20.20.140-FF-000063', NULL, 'Phosphotriesterase homology protein', 290, NULL, NULL, 211815),
(211816, '3.40.50.720-FF-001008', NULL, 'Putative capsular polysaccharide biosynthesis glycosyltransferase', 122, NULL, NULL, 211816),
(211817, '2.30.29.30-FF-000065', NULL, 'T cell lymphoma invasion and metastasis 1', 129, NULL, NULL, 211817),
(211818, '3.10.20.30-FF-000021', NULL, 'Ubiquitin-related modifier 1', 101, NULL, NULL, 211818),
(211819, '3.20.20.80-FF-000322', NULL, 'Probable alpha-L-arabinofuranosidase A', 312, NULL, NULL, 211819),
(211820, '3.20.20.150-FF-000066', NULL, 'Putative hydroxypyruvate isomerase', 271, NULL, NULL, 211820),
(211821, '3.40.50.300-FF-006003', NULL, 'Uncharacterized protein', 150, NULL, NULL, 211821),
(211822, '3.80.10.10-FF-003030', NULL, 'F-box and leucine-rich repeat protein 6', 130, NULL, NULL, 211822),
(211823, '3.40.50.300-FF-005429', NULL, 'RAB34, member RAS oncogene family', 97, NULL, NULL, 211823),
(211824, '3.40.50.300-FF-003917', NULL, 'Uncharacterized protein', 207, NULL, NULL, 211824),
(211825, '2.40.50.170-FF-000004', NULL, NULL, 69, NULL, NULL, 211825),
(211826, '3.40.50.300-FF-005486', NULL, 'DNA helicase', 201, NULL, NULL, 211826),
(211827, '3.30.110.20-FF-000013', NULL, 'Uncharacterized protein', 179, NULL, NULL, 211827),
(211828, '2.40.50.140-FF-001125', NULL, NULL, 60, NULL, NULL, 211828),
(211829, '1.10.3370.10-FF-000001', NULL, 'Preprotein translocase subunit SecY', 425, NULL, NULL, 211829),
(211830, '1.20.120.610-FF-000025', NULL, 'ATPase, F0/V0 complex, subunit C protein', 108, NULL, NULL, 211830),
(211831, '3.30.70.330-FF-000858', NULL, 'Flowering time control protein FCA isoform B', 100, NULL, NULL, 211831),
(211832, '2.60.120.10-FF-000070', NULL, 'Mannose-6-phosphate isomerase', 224, NULL, NULL, 211832),
(211833, '3.20.20.80-FF-000642', NULL, 'Uncharacterized protein', 98, NULL, NULL, 211833),
(211834, '3.40.50.12710-FF-000012', NULL, 'Protein arginine methyltransferase NDUFAF7', 405, NULL, NULL, 211834);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(211835, '3.40.50.1820-FF-000882', NULL, 'Uncharacterized protein (Fragment)', 295, NULL, NULL, 211835),
(211836, '1.10.3130.10-FF-000017', NULL, 'Serine acetyl transferase', 80, NULL, NULL, 211836),
(211837, '2.60.120.590-FF-000026', NULL, '2OG-Fe(II) oxygenase superfamily, putative', 196, NULL, NULL, 211837),
(211838, '3.30.420.10-FF-000084', NULL, 'Tn7 transposase B', 239, NULL, NULL, 211838),
(211839, '2.130.10.10-FF-003529', NULL, 'Uncharacterized protein', 85, NULL, NULL, 211839),
(211840, '2.40.50.180-FF-000007', NULL, 'Purine-binding chemotaxis protein CheW', 69, NULL, NULL, 211840),
(211841, '3.30.40.210-FF-000013', NULL, 'Uncharacterized protein', 86, NULL, NULL, 211841),
(211842, '3.40.50.720-FF-000845', NULL, 'Zinc-binding dehydrogenase family protein', 134, NULL, NULL, 211842),
(211843, '1.25.40.20-FF-000316', NULL, 'BRCA1-associated RING domain protein 1', 168, NULL, NULL, 211843),
(211844, '1.25.10.10-FF-001913', NULL, 'Uncharacterized protein', 232, NULL, NULL, 211844),
(211845, '3.40.50.720-FF-002565', NULL, 'Glucose-6-phosphate 1-dehydrogenase', 44, NULL, NULL, 211845),
(211846, '3.40.50.740-FF-000031', NULL, 'Probable oxidoreductase YyaE', 162, NULL, NULL, 211846),
(211847, '2.60.40.10-FF-003439', NULL, NULL, 104, NULL, NULL, 211847),
(211848, '1.10.101.10-FF-000041', NULL, 'Peptidoglycan-binding protein', 83, NULL, NULL, 211848),
(211849, '3.70.10.10-FF-000023', NULL, 'Proliferating cell nuclear antigen', 212, NULL, NULL, 211849),
(211850, '3.40.50.1760-FF-000009', NULL, 'Glutathione synthetase', 156, NULL, NULL, 211850),
(211851, '1.10.10.1350-FF-000001', NULL, NULL, 116, NULL, NULL, 211851),
(211852, '3.60.15.10-FF-000248', NULL, 'Putative hydrolase C777.06c', 297, NULL, NULL, 211852),
(211853, '3.40.250.10-FF-000001', NULL, 'Sulfurtransferase', 132, NULL, NULL, 211853),
(211854, '3.30.710.10-FF-000308', NULL, 'Putative structure-specific endonuclease subunit slx4', 119, NULL, NULL, 211854),
(211855, '1.25.40.20-FF-001733', NULL, 'Uncharacterized protein', 223, NULL, NULL, 211855),
(211856, '1.25.40.10-FF-004546', NULL, 'Transcription factor IIIC-gamma subunit', 225, NULL, NULL, 211856),
(211857, '1.20.1250.20-FF-000498', NULL, 'Putative monocarboxylate transporter', 463, NULL, NULL, 211857),
(211858, '3.40.50.300-FF-005840', NULL, 'ABC transporter ATP-binding protein', 221, NULL, NULL, 211858),
(211859, '3.40.50.410-FF-000016', NULL, 'Collagen type VI alpha 3 chain', 191, NULL, NULL, 211859),
(211860, '3.90.55.10-FF-000002', NULL, 'Trimethylamine-N-oxide reductase TorA', 66, NULL, NULL, 211860),
(211861, '1.25.40.10-FF-001730', NULL, 'Pentatricopeptide repeat-containing protein isoform A', 105, NULL, NULL, 211861),
(211862, '1.20.1560.10-FF-000187', NULL, 'ATP binding cassette subfamily B member 1', 30, NULL, NULL, 211862),
(211863, '3.90.850.10-FF-000007', NULL, 'Fumarylacetoacetate hydrolase family protein', 220, NULL, NULL, 211863),
(211864, '3.30.900.10-FF-000014', NULL, 'Autophagy-related protein 13', 283, NULL, NULL, 211864),
(211865, '2.130.10.10-FF-005603', NULL, 'Uncharacterized protein', 191, NULL, NULL, 211865),
(211866, '3.30.70.330-FF-002269', NULL, NULL, 188, NULL, NULL, 211866),
(211867, '3.30.160.60-FF-003535', NULL, NULL, 36, NULL, NULL, 211867),
(211868, '3.30.160.60-FF-003355', NULL, 'Zinc finger protein 28 homolog', 35, NULL, NULL, 211868),
(211869, '3.40.50.2300-FF-001442', NULL, NULL, 72, NULL, NULL, 211869),
(211870, '3.40.50.150-FF-001860', NULL, NULL, 203, NULL, NULL, 211870),
(211871, '3.10.50.40-FF-000060', NULL, 'Peptidyl-prolyl cis-trans isomerase', 115, NULL, NULL, 211871),
(211872, '2.60.120.430-FF-000006', NULL, 'Malectin', 173, NULL, NULL, 211872),
(211873, '3.40.50.300-FF-003356', NULL, 'Putative ATP dependent DEAD-box helicase', 266, NULL, NULL, 211873),
(211874, '3.30.200.20-FF-001571', NULL, NULL, 90, NULL, NULL, 211874),
(211875, '1.20.120.160-FF-000025', NULL, 'Sensory transduction histidine kinase', 112, NULL, NULL, 211875),
(211876, '3.30.160.60-FF-002130', NULL, 'Zinc finger protein 136', 36, NULL, NULL, 211876),
(211877, '1.20.1250.10-FF-000102', NULL, NULL, 161, NULL, NULL, 211877);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(211878, '3.90.1150.10-FF-000436', NULL, 'Hercynylcysteine sulfoxide lyase', 22, NULL, NULL, 211878),
(211879, '2.60.40.10-FF-005890', NULL, NULL, 43, NULL, NULL, 211879),
(211880, '3.30.420.40-FF-000986', NULL, 'Stress-70 protein, mitochondrial', 106, NULL, NULL, 211880),
(211881, '2.30.30.40-FF-000060', NULL, 'FCH and double SH3 domains protein 2', 76, NULL, NULL, 211881),
(211882, '3.40.350.10-FF-000065', NULL, 'Uncharacterized protein', 157, NULL, NULL, 211882),
(211883, '1.10.8.60-FF-000336', NULL, 'Vacuolar transport protein 4A, putative', 134, NULL, NULL, 211883),
(211884, '3.40.1000.10-FF-000010', NULL, 'PsbP domain-containing protein 6, chloroplastic', 179, NULL, NULL, 211884),
(211885, '3.40.190.120-FF-000004', NULL, 'ABC transporter amino acid permease', 102, NULL, NULL, 211885),
(211886, '2.130.10.10-FF-001113', NULL, 'OSIGBa0103M18.5 protein', 133, NULL, NULL, 211886),
(211887, '1.20.1270.60-FF-000253', NULL, 'Chromosome 19, whole genome shotgun sequence', 220, NULL, NULL, 211887),
(211888, '3.40.50.150-FF-000303', NULL, 'Type III restriction-modification system StyLTI enzyme mod', 296, NULL, NULL, 211888),
(211889, '2.60.40.10-FF-001848', NULL, 'Complement component C5', 116, NULL, NULL, 211889),
(211890, '3.60.10.10-FF-000372', NULL, 'Uncharacterized protein', 102, NULL, NULL, 211890),
(211891, '2.40.50.90-FF-000109', NULL, 'Transcription factor (Snd1/p100), putative', 159, NULL, NULL, 211891),
(211892, '3.30.420.10-FF-000264', NULL, 'DNA polymerase I', 193, NULL, NULL, 211892),
(211893, '2.60.40.10-FF-002124', NULL, 'Uncharacterized protein', 70, NULL, NULL, 211893),
(211894, '2.130.10.10-FF-000837', NULL, 'Blast:Mitogen-activated protein kinase-binding protein 1', 115, NULL, NULL, 211894),
(211895, '1.25.40.10-FF-001112', NULL, 'wolframin', 157, NULL, NULL, 211895),
(211896, '1.20.1420.30-FF-000088', NULL, 'Uncharacterized protein', 108, NULL, NULL, 211896),
(211897, '1.20.1560.10-FF-000541', NULL, 'ATP binding cassette subfamily B19', 497, NULL, NULL, 211897),
(211898, '2.60.260.20-FF-000178', NULL, 'Uncharacterized protein', 111, NULL, NULL, 211898),
(211899, '2.130.10.10-FF-005042', NULL, 'Uncharacterized protein', 288, NULL, NULL, 211899),
(211900, '3.30.420.10-FF-000207', NULL, 'Putative transposase', 160, NULL, NULL, 211900),
(211901, '3.10.20.870-FF-000008', NULL, NULL, 61, NULL, NULL, 211901),
(211902, '2.60.120.330-FF-000010', NULL, '1-aminocyclopropane-1-carboxylate oxidase 1', 305, NULL, NULL, 211902),
(211903, '2.60.40.10-FF-000005', NULL, 'Neuronal cell adhesion molecule', 92, NULL, NULL, 211903),
(211904, '1.25.40.10-FF-005338', NULL, 'Uncharacterized protein', 70, NULL, NULL, 211904),
(211905, '2.30.39.10-FF-000065', NULL, 'Serpin family A member 5', 102, NULL, NULL, 211905),
(211906, '3.40.50.2300-FF-000947', NULL, NULL, 143, NULL, NULL, 211906),
(211907, '1.10.10.10-FF-001941', NULL, 'MarR family transcriptional regulatory protein', 143, NULL, NULL, 211907),
(211908, '1.10.287.90-FF-000011', NULL, 'Probable quinol oxidase subunit 2', 87, NULL, NULL, 211908),
(211909, '1.10.506.10-FF-000104', NULL, 'Plexin A1', 282, NULL, NULL, 211909),
(211910, '3.30.40.10-FF-001140', NULL, 'RING-H2 finger protein ATL52', 87, NULL, NULL, 211910),
(211911, '3.40.50.300-FF-000894', NULL, 'Discs large MAGUK scaffold protein 5', 192, NULL, NULL, 211911),
(211912, '1.20.58.760-FF-000054', NULL, 'Uncharacterized protein', 39, NULL, NULL, 211912),
(211913, '2.30.42.10-FF-000472', NULL, NULL, 118, NULL, NULL, 211913),
(211914, '3.40.190.80-FF-000090', NULL, 'Os12g0183200 protein', 94, NULL, NULL, 211914),
(211915, '3.80.10.10-FF-004036', NULL, 'Uncharacterized protein', 144, NULL, NULL, 211915),
(211916, '3.40.850.10-FF-000529', NULL, 'Uncharacterized protein', 89, NULL, NULL, 211916),
(211917, '2.60.40.3170-FF-000007', NULL, 'Tpp-2', 131, NULL, NULL, 211917),
(211918, '3.30.70.330-FF-000678', NULL, 'zinc finger CCCH domain-containing protein 53-like isoform X2', 72, NULL, NULL, 211918),
(211919, '2.130.10.10-FF-001731', NULL, 'CHromatin Assembly Factor', 265, NULL, NULL, 211919);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(211920, '2.60.40.60-FF-001009', NULL, 'Protein CBR-CDH-7', 102, NULL, NULL, 211920),
(211921, '3.40.1280.10-FF-000047', NULL, 'Ribosomal RNA small subunit methyltransferase E', 171, NULL, NULL, 211921),
(211922, '3.30.1240.10-FF-000064', NULL, 'Putative sugar phosphatase', 107, NULL, NULL, 211922),
(211923, '1.20.58.60-FF-000273', NULL, 'Zormin, isoform E', 263, NULL, NULL, 211923),
(211924, '3.40.1000.30-FF-000016', NULL, 'Proteasome inhibitor PI31 subunit', 152, NULL, NULL, 211924),
(211925, '3.20.20.190-FF-000061', NULL, 'Phosphoinositide phospholipase C', 298, NULL, NULL, 211925),
(211926, '3.40.50.150-FF-001585', NULL, NULL, 45, NULL, NULL, 211926),
(211927, '1.10.640.10-FF-000040', NULL, 'Uncharacterized protein', 242, NULL, NULL, 211927),
(211928, '1.25.40.10-FF-003186', NULL, 'Uncharacterized protein CaJ7.0066', 217, NULL, NULL, 211928),
(211929, '1.10.150.220-FF-000001', NULL, 'Phosphatase 1, regulatory (Inhibitor) subunit 14C', 87, NULL, NULL, 211929),
(211930, '3.40.50.300-FF-003631', NULL, 'DEAH (Asp-Glu-Ala-His) box polypeptide 37', 81, NULL, NULL, 211930),
(211931, '3.40.190.10-FF-000529', NULL, 'ABC transporter substrate-binding protein', 184, NULL, NULL, 211931),
(211932, '3.40.1110.10-FF-000125', NULL, 'Cation-transporting ATPase', 130, NULL, NULL, 211932),
(211933, '3.90.1750.10-FF-000105', NULL, 'Ubiquitin-protein ligase E3 C', 58, NULL, NULL, 211933),
(211934, '3.60.21.10-FF-000015', NULL, 'Vacuolar protein sorting-associated protein 29', 182, NULL, NULL, 211934),
(211935, '1.10.510.10-FF-001076', NULL, 'Altered disjunction', 196, NULL, NULL, 211935),
(211936, '1.20.5.170-FF-000260', NULL, 'Uncharacterized protein', 39, NULL, NULL, 211936),
(211937, '3.30.1370.110-FF-000009', NULL, 'Polyadenylate-binding protein-interacting protein 7', 112, NULL, NULL, 211937),
(211938, '3.30.559.70-FF-000058', NULL, 'Uncharacterized protein', 97, NULL, NULL, 211938),
(211939, '3.40.50.2000-FF-000397', NULL, 'D-inositol 3-phosphate glycosyltransferase', 212, NULL, NULL, 211939),
(211940, '3.30.720.210-FF-000009', NULL, 'ATP-dependent zinc metalloprotease FtsH', 72, NULL, NULL, 211940),
(211941, '1.20.1740.10-FF-000072', NULL, 'Cationic amino acid transport integral membraneprotein', 469, NULL, NULL, 211941),
(211942, '3.30.720.200-FF-000006', NULL, 'Glycyl-tRNA synthetase, putative', 68, NULL, NULL, 211942),
(211943, '1.20.5.510-FF-000002', NULL, 'Cytochrome b6-f complex subunit 4', 58, NULL, NULL, 211943),
(211944, '2.60.40.10-FF-001635', NULL, 'SLAM family member 8', 113, NULL, NULL, 211944),
(211945, '3.30.70.3160-FF-000005', NULL, 'Uncharacterized protein', 38, NULL, NULL, 211945),
(211946, '3.30.1370.100-FF-000006', NULL, 'DNA mismatch repair protein MutL', 94, NULL, NULL, 211946),
(211947, '3.10.580.10-FF-000201', NULL, 'UPF0053 protein MG146', 146, NULL, NULL, 211947),
(211948, '2.60.40.1450-FF-000008', NULL, 'Uncharacterized protein', 50, NULL, NULL, 211948),
(211949, '3.20.20.70-FF-000044', NULL, 'Deoxyribose-phosphate aldolase', 222, NULL, NULL, 211949),
(211950, '1.20.1070.10-FF-000341', NULL, 'Methuselah-like 5, isoform B', 260, NULL, NULL, 211950),
(211951, '3.60.40.10-FF-000104', NULL, 'Protein phosphatase 2C 32', 164, NULL, NULL, 211951),
(211952, '1.20.1720.10-FF-000065', NULL, 'Chromosome 7, whole genome shotgun sequence', 192, NULL, NULL, 211952),
(211953, '2.20.110.10-FF-000038', NULL, 'Protein kinase, putative', 64, NULL, NULL, 211953),
(211954, '2.30.30.380-FF-000054', NULL, 'EAP30/Vps36 family-domain-containing protein', 67, NULL, NULL, 211954),
(211955, '3.90.1150.210-FF-000029', NULL, 'F-actin-capping protein subunit beta', 83, NULL, NULL, 211955),
(211956, '1.20.1740.10-FF-000134', NULL, 'Uncharacterized amino-acid permease B0303.11', 441, NULL, NULL, 211956),
(211957, '2.60.120.10-FF-000283', NULL, 'Uncharacterized protein', 128, NULL, NULL, 211957),
(211958, '3.80.10.10-FF-002237', NULL, 'Uncharacterized protein', 170, NULL, NULL, 211958),
(211959, '3.20.20.60-FF-000041', NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', 269, NULL, NULL, 211959),
(211960, '3.40.50.150-FF-001708', NULL, NULL, 60, NULL, NULL, 211960);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(211961, '1.20.58.190-FF-000012', NULL, NULL, 143, NULL, NULL, 211961),
(211962, '1.10.510.10-FF-003150', NULL, NULL, 175, NULL, NULL, 211962),
(211963, '1.10.287.860-FF-000001', NULL, 'GTP pyrophosphokinase YjbM', 64, NULL, NULL, 211963),
(211964, '3.40.50.300-FF-001950', NULL, 'Early gene transcription factor VETF small subunit', 217, NULL, NULL, 211964),
(211965, '1.10.520.10-FF-000042', NULL, 'Peroxidase', 63, NULL, NULL, 211965),
(211966, '3.40.50.800-FF-000133', NULL, 'Uncharacterized protein', 66, NULL, NULL, 211966),
(211967, '2.10.25.10-FF-001299', NULL, 'Protein eyes shut homolog', 39, NULL, NULL, 211967),
(211968, '3.80.10.10-FF-004373', NULL, 'Uncharacterized protein', 173, NULL, NULL, 211968),
(211969, '2.130.10.10-FF-001613', NULL, 'Uncharacterized protein', 367, NULL, NULL, 211969),
(211970, '3.10.129.10-FF-000248', NULL, 'Acyl-CoA thioester hydrolase, YbgC/YbaW family', 131, NULL, NULL, 211970),
(211971, '1.25.40.20-FF-001452', NULL, 'Uncharacterized protein', 128, NULL, NULL, 211971),
(211972, '3.30.950.10-FF-000017', NULL, 'Uroporphyrinogen-III C-methyltransferase', 136, NULL, NULL, 211972),
(211973, '3.40.50.300-FF-005216', NULL, 'Predicted protein', 208, NULL, NULL, 211973),
(211974, '3.60.40.10-FF-000048', NULL, 'probable protein phosphatase 1N isoform X1', 284, NULL, NULL, 211974),
(211975, '1.25.40.10-FF-003528', NULL, 'Uncharacterized protein', 107, NULL, NULL, 211975),
(211976, '2.30.29.30-FF-000278', NULL, 'Oxysterol-binding protein', 107, NULL, NULL, 211976),
(211977, '3.40.33.10-FF-000021', NULL, 'Scl-5', 174, NULL, NULL, 211977),
(211978, '3.50.50.60-FF-000917', NULL, '5-(hydroxymethyl)furfural oxidase', 340, NULL, NULL, 211978),
(211979, '2.60.40.10-FF-005906', NULL, NULL, 64, NULL, NULL, 211979),
(211980, '3.40.50.1820-FF-000904', NULL, 'Carboxypeptidase', 175, NULL, NULL, 211980),
(211981, '3.40.50.1460-FF-000133', NULL, 'Uncharacterized protein', 44, NULL, NULL, 211981),
(211982, '1.10.565.10-FF-000033', NULL, 'Nuclear receptor subfamily 4 group A member 2', 152, NULL, NULL, 211982),
(211983, '3.30.750.24-FF-000178', NULL, 'Uncharacterized protein', 194, NULL, NULL, 211983),
(211984, '3.30.70.330-FF-000976', NULL, 'Heterogeneous nuclear ribonucleoprotein A2/B1', 48, NULL, NULL, 211984),
(211985, '2.60.40.60-FF-000498', NULL, 'Protocadherin19 isoform1', 63, NULL, NULL, 211985),
(211986, '3.20.20.80-FF-000047', NULL, 'Chitinase-3-like protein 1', 267, NULL, NULL, 211986),
(211987, '3.90.1150.10-FF-000493', NULL, 'Aminotransferase, conjectural', 38, NULL, NULL, 211987),
(211988, '2.40.30.110-FF-000027', NULL, NULL, 74, NULL, NULL, 211988),
(211989, '1.10.640.10-FF-000096', NULL, 'Uncharacterized protein', 292, NULL, NULL, 211989),
(211990, '1.10.600.10-FF-000043', NULL, 'Polyprenyl synthetase family protein', 332, NULL, NULL, 211990),
(211991, '1.10.510.10-FF-001637', NULL, 'Kinase, CMGC CMGC-GL1', 295, NULL, NULL, 211991),
(211992, '1.10.8.1310-FF-000001', NULL, 'TBC1 domain family, member 20', 153, NULL, NULL, 211992),
(211993, '3.30.2280.10-FF-000004', NULL, 'Protein CBG05668', 112, NULL, NULL, 211993),
(211994, '3.40.50.300-FF-006739', NULL, 'Thymidine kinase', 69, NULL, NULL, 211994),
(211995, '3.40.50.300-FF-007307', NULL, 'Ras-like protein Rac2', 148, NULL, NULL, 211995),
(211996, '1.10.3380.10-FF-000007', NULL, 'DnaJ protein ERDJ2A', 149, NULL, NULL, 211996),
(211997, '3.30.160.60-FF-005502', NULL, NULL, 81, NULL, NULL, 211997),
(211998, '3.30.1160.10-FF-000001', NULL, 'Cyanate hydratase', 68, NULL, NULL, 211998),
(211999, '3.30.30.170-FF-000010', NULL, NULL, 105, NULL, NULL, 211999),
(212000, '2.130.10.10-FF-001495', NULL, 'Hypothetical_protein', 120, NULL, NULL, 212000),
(212001, '3.90.1750.10-FF-000111', NULL, 'Predicted protein', 35, NULL, NULL, 212001),
(212002, '3.40.50.11850-FF-000006', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', 130, NULL, NULL, 212002),
(212003, '1.20.1070.10-FF-000392', NULL, 'Predicted protein', 297, NULL, NULL, 212003),
(212004, '1.10.630.10-FF-000550', NULL, 'Uncharacterized protein', 339, NULL, NULL, 212004);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(212005, '1.10.510.10-FF-001963', NULL, 'Serine/threonine protein kinase 21', 210, NULL, NULL, 212005),
(212006, '2.60.98.20-FF-000006', NULL, 'Flagellar hook protein FlgE', 161, NULL, NULL, 212006),
(212007, '1.10.640.10-FF-000045', NULL, 'Protein CBG06977', 130, NULL, NULL, 212007),
(212008, '3.30.160.60-FF-005446', NULL, NULL, 26, NULL, NULL, 212008),
(212009, '3.40.50.2300-FF-001111', NULL, NULL, 192, NULL, NULL, 212009),
(212010, '3.40.1190.20-FF-000228', NULL, NULL, 119, NULL, NULL, 212010),
(212011, '1.10.8.60-FF-000224', NULL, '26S protease regulatory subunit S10B, putative', 71, NULL, NULL, 212011),
(212012, '3.40.50.300-FF-001894', NULL, 'Dynein heavy chain, putative', 206, NULL, NULL, 212012),
(212013, '3.40.50.11860-FF-000009', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', 100, NULL, NULL, 212013),
(212014, '3.30.190.20-FF-000001', NULL, '50S ribosomal protein L1', 113, NULL, NULL, 212014),
(212015, '2.40.290.10-FF-000041', NULL, 'ATP dependent DNA ligase 1', 99, NULL, NULL, 212015),
(212016, '2.60.120.10-FF-000013', NULL, 'cAMP-dependent protein kinase type I regulatory subunit', 132, NULL, NULL, 212016),
(212017, '1.20.1250.20-FF-000223', NULL, 'Major facilitator superfamily domain-containing protein', 433, NULL, NULL, 212017),
(212018, '3.90.190.10-FF-000333', NULL, 'Kinetoplastid-specific dual specificity phosphatase, putative', 260, NULL, NULL, 212018),
(212019, '3.40.50.12670-FF-000016', NULL, 'Carboxypeptidase', 37, NULL, NULL, 212019),
(212020, '3.40.50.12660-FF-000013', NULL, NULL, 99, NULL, NULL, 212020),
(212021, '3.30.40.10-FF-000471', NULL, 'Histone-lysine N-methyltransferase trithorax', 66, NULL, NULL, 212021),
(212022, '3.40.920.10-FF-000024', NULL, NULL, 177, NULL, NULL, 212022),
(212023, '3.40.640.10-FF-000508', NULL, 'Uncharacterized protein', 63, NULL, NULL, 212023),
(212024, '3.40.50.620-FF-000467', NULL, 'Nicotinamide-nucleotide adenylyltransferase', 247, NULL, NULL, 212024),
(212025, '3.30.559.10-FF-000254', NULL, 'Choline O-acetyltransferase', 41, NULL, NULL, 212025),
(212026, '1.20.1250.20-FF-000493', NULL, 'proton-associated sugar transporter A', 208, NULL, NULL, 212026),
(212027, '1.20.58.400-FF-000025', NULL, 'Vesicle transport V-snare protein, putative', 93, NULL, NULL, 212027),
(212028, '1.10.10.60-FF-001309', NULL, NULL, 101, NULL, NULL, 212028),
(212029, '3.30.160.60-FF-004142', NULL, NULL, 32, NULL, NULL, 212029),
(212030, '3.40.50.2300-FF-000543', NULL, 'Penicillin-binding protein activator LpoA', 135, NULL, NULL, 212030),
(212031, '2.60.40.10-FF-001961', NULL, 'CD101 molecule', 110, NULL, NULL, 212031),
(212032, '1.25.40.10-FF-003540', NULL, 'Flagellar_Member_7', 108, NULL, NULL, 212032),
(212033, '1.10.287.70-FF-000533', NULL, 'Uncharacterized protein', 106, NULL, NULL, 212033),
(212034, '3.40.50.300-FF-006846', NULL, 'Uncharacterized protein', 262, NULL, NULL, 212034),
(212035, '2.60.98.10-FF-000003', NULL, 'Structural polyprotein', 78, NULL, NULL, 212035),
(212036, '3.40.50.1460-FF-000077', NULL, 'Caspase 10', 271, NULL, NULL, 212036),
(212037, '2.60.120.20-FF-000016', NULL, 'Genome polyprotein', 278, NULL, NULL, 212037),
(212038, '3.90.1520.10-FF-000009', NULL, 'Guanylate cyclase soluble subunit beta-2', 131, NULL, NULL, 212038),
(212039, '3.30.160.20-FF-000055', NULL, 'Ribosomal protein S24/S35', 120, NULL, NULL, 212039),
(212040, '3.40.50.11840-FF-000003', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', 84, NULL, NULL, 212040),
(212041, '2.60.40.10-FF-005272', NULL, NULL, 86, NULL, NULL, 212041),
(212042, '3.90.640.10-FF-000076', NULL, 'Cytosolic heat shock protein 70, putative', 84, NULL, NULL, 212042),
(212043, '1.10.630.10-FF-000275', NULL, 'Cytochrome P450', 509, NULL, NULL, 212043),
(212044, '3.40.50.970-FF-000049', NULL, '2-oxoglutarate ferredoxin oxidoreductase subunit beta', 158, NULL, NULL, 212044),
(212045, '2.60.120.260-FF-000551', NULL, 'Neuropilin 1b', 58, NULL, NULL, 212045),
(212046, '2.60.120.260-FF-000495', NULL, 'Protein CBG04402', 101, NULL, NULL, 212046),
(212047, '1.10.287.130-FF-000057', NULL, 'Type IV pilus sensor protein PilS', 72, NULL, NULL, 212047); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(212048, '3.30.1240.10-FF-000002', NULL, 'HMP-PP phosphatase', 104, NULL, NULL, 212048),
(212049, '3.40.50.300-FF-001271', NULL, 'Mitochondrial Rho GTPase', 102, NULL, NULL, 212049),
(212050, '3.40.50.300-FF-005542', NULL, 'Predicted protein', 35, NULL, NULL, 212050),
(212051, '1.25.10.10-FF-000042', NULL, 'exportin-7 isoform X1', 536, NULL, NULL, 212051),
(212052, '3.30.2090.10-FF-000029', NULL, 'Heavy metal efflux pump permease component CzcA family', 97, NULL, NULL, 212052),
(212053, '3.40.50.1010-FF-000291', NULL, NULL, 52, NULL, NULL, 212053),
(212054, '3.30.450.60-FF-000027', NULL, 'AP complex subunit sigma', 116, NULL, NULL, 212054),
(212055, '2.30.29.30-FF-001060', NULL, 'IQ motif and Sec7 domain 2', 78, NULL, NULL, 212055),
(212056, '3.30.40.10-FF-000701', NULL, 'Zinc finger FYVE-type containing 19', 72, NULL, NULL, 212056),
(212057, '3.40.50.1820-FF-001686', NULL, 'Uncharacterized protein', 221, NULL, NULL, 212057),
(212058, '3.30.30.30-FF-000015', NULL, 'Putative heat shock protein 110', 82, NULL, NULL, 212058),
(212059, '1.10.260.100-FF-000023', NULL, 'ST13, Hsp70 interacting protein', 55, NULL, NULL, 212059),
(212060, '2.160.20.10-FF-000067', NULL, 'Possible serine/threonine kinase', 122, NULL, NULL, 212060),
(212061, '1.25.10.10-FF-001621', NULL, 'Uncharacterized protein', 526, NULL, NULL, 212061),
(212062, '1.20.1280.290-FF-000090', NULL, 'Predicted protein', 97, NULL, NULL, 212062),
(212063, '2.60.40.420-FF-000247', NULL, 'Uncharacterized protein', 152, NULL, NULL, 212063),
(212064, '3.40.33.10-FF-000072', NULL, 'GLI pathogenesis-related 1b', 197, NULL, NULL, 212064),
(212065, '1.10.472.80-FF-000091', NULL, 'EVI5 protein', 138, NULL, NULL, 212065),
(212066, '2.10.25.10-FF-000629', NULL, 'Laminin subunit alpha 1', 53, NULL, NULL, 212066),
(212067, '1.20.1070.10-FF-002139', NULL, 'Uncharacterized protein', 223, NULL, NULL, 212067),
(212068, '3.40.50.620-FF-000523', NULL, 'Isoleucyl-tRNA synthetase', 135, NULL, NULL, 212068),
(212069, '3.10.290.70-FF-000016', NULL, NULL, 99, NULL, NULL, 212069),
(212070, '3.15.10.20-FF-000007', NULL, 'Aha1 domain-containing protein', 156, NULL, NULL, 212070),
(212071, '3.30.420.10-FF-000090', NULL, 'Ribonuclease H', 162, NULL, NULL, 212071),
(212072, '1.20.1560.10-FF-000827', NULL, 'Multidrug resistance protein 3', 21, NULL, NULL, 212072),
(212073, '3.20.20.80-FF-000266', NULL, 'Lactase-like a', 164, NULL, NULL, 212073),
(212074, '3.30.70.850-FF-000008', NULL, 'Furin-like protease 1, isoform 1-CRR', 57, NULL, NULL, 212074),
(212075, '2.60.40.10-FF-000331', NULL, '1,4-alpha-glucan branching enzyme GlgB', 101, NULL, NULL, 212075),
(212076, '3.30.2410.10-FF-000004', NULL, 'E3 ubiquitin-protein ligase HUWE1, variant', 120, NULL, NULL, 212076),
(212077, '3.40.50.300-FF-007633', NULL, 'ATPase family AAA domaincontaining protein 5-like, putative', 143, NULL, NULL, 212077),
(212078, '1.10.630.10-FF-000505', NULL, 'Cytochrome P450', 436, NULL, NULL, 212078),
(212079, '1.10.287.70-FF-000477', NULL, 'Predicted protein', 85, NULL, NULL, 212079),
(212080, '3.30.420.580-FF-000007', NULL, 'Actin-related protein 8', 67, NULL, NULL, 212080),
(212081, '1.25.10.10-FF-001672', NULL, 'Apr-1', 313, NULL, NULL, 212081),
(212082, '2.60.40.10-FF-001309', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', 90, NULL, NULL, 212082),
(212083, '2.60.120.200-FF-000224', NULL, 'SP2353, isoform A', 185, NULL, NULL, 212083),
(212084, '1.25.40.10-FF-002865', NULL, 'tetratricopeptide repeat protein 7A isoform X2', 81, NULL, NULL, 212084),
(212085, '1.10.10.10-FF-001104', NULL, 'MarR family transcriptional regulator', 139, NULL, NULL, 212085),
(212086, '1.10.3730.20-FF-000032', NULL, 'Transporter, EamA family', 98, NULL, NULL, 212086),
(212087, '3.20.20.70-FF-000263', NULL, 'Putative FMN-dependent dehydrogenase', 305, NULL, NULL, 212087),
(212088, '3.80.10.10-FF-004480', NULL, 'Leucine-rich repeat protein kinase family protein', 139, NULL, NULL, 212088),
(212089, '1.25.40.10-FF-002753', NULL, 'YALI0B19184p', 197, NULL, NULL, 212089),
(212090, '2.130.10.10-FF-003530', NULL, 'WD repeat-containing protein 90', 79, NULL, NULL, 212090);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(212091, '1.20.1110.10-FF-000215', NULL, NULL, 52, NULL, NULL, 212091),
(212092, '3.40.50.2000-FF-001116', NULL, 'Alpha-1,4 glucan phosphorylase', 156, NULL, NULL, 212092),
(212093, '1.10.3500.10-FF-000001', NULL, 'Transcription elongation factor spt6', 257, NULL, NULL, 212093),
(212094, '3.90.1200.10-FF-000025', NULL, 'Ethanolamine kinase', 266, NULL, NULL, 212094),
(212095, '3.30.300.30-FF-000154', NULL, 'Uncharacterized protein', 134, NULL, NULL, 212095),
(212096, '3.80.10.10-FF-003991', NULL, 'Predicted protein', 156, NULL, NULL, 212096),
(212097, '3.30.160.60-FF-003029', NULL, 'Zinc finger protein 766', 26, NULL, NULL, 212097),
(212098, '2.60.40.10-FF-000848', NULL, 'Hemicentin 1', 94, NULL, NULL, 212098),
(212099, '1.25.40.550-FF-000010', NULL, 'Uncharacterized protein', 187, NULL, NULL, 212099),
(212100, '3.40.50.720-FF-002296', NULL, 'Phosphoglycerate dehydrogenase', 180, NULL, NULL, 212100),
(212101, '1.20.920.20-FF-000034', NULL, 'Predicted protein', 359, NULL, NULL, 212101),
(212102, '1.20.920.10-FF-000031', NULL, 'Bromodomain adjacent to zinc finger domain, 1B', 110, NULL, NULL, 212102),
(212103, '2.130.10.30-FF-000085', NULL, 'BTB/POZ domain/Regulator of chromosome condensation (RCC1) repeat, putative', 234, NULL, NULL, 212103),
(212104, '3.30.40.10-FF-000145', NULL, 'RING finger protein 145', 74, NULL, NULL, 212104),
(212105, '3.30.1740.10-FF-000023', NULL, 'Poly [ADP-ribose] polymerase', 98, NULL, NULL, 212105),
(212106, '2.60.120.290-FF-000071', NULL, 'Zinc metalloproteinase', 112, NULL, NULL, 212106),
(212107, '3.55.40.20-FF-000013', NULL, 'Superoxide dismutase', 112, NULL, NULL, 212107),
(212108, '3.40.50.620-FF-000579', NULL, 'Predicted protein', 106, NULL, NULL, 212108),
(212109, '3.30.450.60-FF-000078', NULL, 'Uncharacterized protein', 81, NULL, NULL, 212109),
(212110, '3.30.365.10-FF-000022', NULL, 'Carbon monoxide dehydrogenase, large subunit', 113, NULL, NULL, 212110),
(212111, '1.20.58.1030-FF-000038', NULL, 'DNA replication complex GINS protein SLD5, putative', 100, NULL, NULL, 212111),
(212112, '1.25.40.570-FF-000016', NULL, '26S proteasome regulatory subunit', 378, NULL, NULL, 212112),
(212113, '1.20.1560.10-FF-000715', NULL, 'Uncharacterized protein', 271, NULL, NULL, 212113),
(212114, '3.60.110.10-FF-000037', NULL, 'Hydrolase, carbon-nitrogen family protein', 253, NULL, NULL, 212114),
(212115, '3.60.40.10-FF-000323', NULL, 'Predicted protein', 199, NULL, NULL, 212115),
(212116, '3.30.420.10-FF-000320', NULL, 'Uncharacterized protein', 181, NULL, NULL, 212116),
(212117, '3.20.20.300-FF-000044', NULL, 'Periplasmic beta-glucosidase', 354, NULL, NULL, 212117),
(212118, '1.25.40.720-FF-000027', NULL, 'Uncharacterized protein', 90, NULL, NULL, 212118),
(212119, '3.30.450.20-FF-000095', NULL, 'Sigma-54-dependent transcriptional regulator ygeV', 52, NULL, NULL, 212119),
(212120, '3.40.50.720-FF-002026', NULL, 'Dihydroflavonol-4-reductase', 204, NULL, NULL, 212120),
(212121, '3.40.605.10-FF-000011', NULL, 'ALD5p Mitochondrial aldehyde dehydrogenase', 275, NULL, NULL, 212121),
(212122, '3.30.70.141-FF-000049', NULL, NULL, 43, NULL, NULL, 212122),
(212123, '3.80.10.10-FF-004328', NULL, 'Uncharacterized protein', 199, NULL, NULL, 212123),
(212124, '3.40.190.10-FF-000294', NULL, 'Probable sugar-binding lipoprotein lpqY', 75, NULL, NULL, 212124),
(212125, '3.30.50.10-FF-000185', NULL, 'Uncharacterized protein', 40, NULL, NULL, 212125),
(212126, '3.40.850.10-FF-000266', NULL, 'Kinesin-like protein', 74, NULL, NULL, 212126),
(212127, '1.10.287.70-FF-000421', NULL, 'Voltage-gated Ca2+ channel, alpha subunit', 148, NULL, NULL, 212127),
(212128, '3.40.50.12230-FF-000019', NULL, 'Putative methionyl-tRNA formyltransferase', 326, NULL, NULL, 212128),
(212129, '3.40.1170.10-FF-000011', NULL, 'Msh1p', 141, NULL, NULL, 212129),
(212130, '3.40.50.410-FF-000174', NULL, 'Matrilin 1', 114, NULL, NULL, 212130),
(212131, '3.30.200.20-FF-000784', NULL, 'Serine/threonine-protein kinase STE7', 112, NULL, NULL, 212131),
(212132, '3.90.190.10-FF-000445', NULL, 'Uncharacterized protein', 269, NULL, NULL, 212132);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(212133, '3.40.50.800-FF-000077', NULL, 'Threonine--tRNA ligase', 110, NULL, NULL, 212133),
(212134, '2.60.40.10-FF-005053', NULL, NULL, 102, NULL, NULL, 212134),
(212135, '3.40.50.2300-FF-000655', NULL, 'CsgBAC operon transcriptional regulatory protein', 137, NULL, NULL, 212135),
(212136, '3.40.50.300-FF-001675', NULL, 'Bifunctional dethiobiotin synthetase/7,8-diamino-pelargonic acid aminotransferase, mitochondrial', 303, NULL, NULL, 212136),
(212137, '3.40.50.12160-FF-000032', NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase', 131, NULL, NULL, 212137),
(212138, '1.25.40.10-FF-001404', NULL, 'Putative pentatricopeptide repeat-containing protein', 178, NULL, NULL, 212138),
(212139, '3.40.50.2000-FF-000627', NULL, 'Alpha-1,4 glucan phosphorylase', 302, NULL, NULL, 212139),
(212140, '3.30.1370.10-FF-000118', NULL, 'Heterogeneous nuclear rnp K-like protein 2', 80, NULL, NULL, 212140),
(212141, '2.60.40.2300-FF-000011', NULL, 'Neutral ceramidase', 134, NULL, NULL, 212141),
(212142, '3.40.50.12760-FF-000010', NULL, 'CMTR1 isoform 3', 168, NULL, NULL, 212142),
(212143, '3.30.460.10-FF-000210', NULL, 'MUTator', 147, NULL, NULL, 212143),
(212144, '1.10.8.10-FF-000052', NULL, 'Huntingtin-interacting protein K (Predicted)', 38, NULL, NULL, 212144),
(212145, '3.40.390.10-FF-000275', NULL, NULL, 133, NULL, NULL, 212145),
(212146, '2.60.40.10-FF-001461', NULL, 'tyrosine-protein phosphatase 10D isoform X4', 97, NULL, NULL, 212146),
(212147, '3.40.50.12780-FF-000049', NULL, 'Putative acyl-activating enzyme 19', 411, NULL, NULL, 212147),
(212148, '3.40.630.30-FF-000204', NULL, 'N-acetyltransferase, putative, expressed', 167, NULL, NULL, 212148),
(212149, '2.60.40.10-FF-004890', NULL, NULL, 88, NULL, NULL, 212149),
(212150, '1.20.1560.10-FF-000822', NULL, 'ABC transporter B family member 14', 31, NULL, NULL, 212150),
(212151, '1.10.1410.10-FF-000100', NULL, 'Predicted protein', 15, NULL, NULL, 212151),
(212152, '2.60.120.10-FF-000513', NULL, 'Uncharacterized protein', 154, NULL, NULL, 212152),
(212153, '1.20.970.10-FF-000039', NULL, 'Pyrimidine-nucleoside phosphorylase', 67, NULL, NULL, 212153),
(212154, '3.60.20.10-FF-000221', NULL, NULL, 139, NULL, NULL, 212154),
(212155, '4.10.400.10-FF-000151', NULL, 'LDL receptor related protein 2', 42, NULL, NULL, 212155),
(212156, '3.40.50.300-FF-000601', NULL, 'Mg-protoporphyrin IX chelatase', 206, NULL, NULL, 212156),
(212157, '1.10.8.100-FF-000016', NULL, 'rRNA adenine N-6-methyltransferase (Erm/ksgA)', 40, NULL, NULL, 212157),
(212158, '3.30.1370.210-FF-000039', NULL, 'Uncharacterized protein', 52, NULL, NULL, 212158),
(212159, '2.40.170.20-FF-000102', NULL, 'Outer membrane receptor for Fe3+-dicitrate/TonB-dependent receptor', 591, NULL, NULL, 212159),
(212160, '1.20.930.10-FF-000037', NULL, 'Uncharacterized protein', 72, NULL, NULL, 212160),
(212161, '1.10.132.30-FF-000011', NULL, 'DNA-directed RNA polymerase subunit', 127, NULL, NULL, 212161),
(212162, '1.10.510.10-FF-001233', NULL, 'CAMK family protein kinase', 325, NULL, NULL, 212162),
(212163, '1.10.3810.10-FF-000030', NULL, 'Uncharacterized protein', 81, NULL, NULL, 212163),
(212164, '3.10.20.90-FF-000117', NULL, 'Ubiquitin-like protein ATG12', 91, NULL, NULL, 212164),
(212165, '1.10.510.10-FF-001525', NULL, 'MAPKK kinase', 185, NULL, NULL, 212165),
(212166, '3.40.50.720-FF-000109', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', 135, NULL, NULL, 212166),
(212167, '2.70.98.30-FF-000020', NULL, 'Alpha-mannosidase', 252, NULL, NULL, 212167),
(212168, '2.60.40.10-FF-002984', NULL, 'DNase I-like protein', 145, NULL, NULL, 212168),
(212169, '3.30.200.20-FF-000907', NULL, 'Probable serine/threonine-protein kinase gdt2', 87, NULL, NULL, 212169),
(212170, '1.20.1070.10-FF-000397', NULL, 'GG11470', 216, NULL, NULL, 212170),
(212171, '3.50.50.60-FF-000805', NULL, '2-octaprenyl-6-methoxyphenyl hydroxylase', 238, NULL, NULL, 212171),
(212172, '3.40.50.800-FF-000021', NULL, 'Histidine--tRNA ligase', 95, NULL, NULL, 212172),
(212173, '1.10.420.10-FF-000057', NULL, 'Peroxidase', 57, NULL, NULL, 212173);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(212174, '3.30.70.80-FF-000004', NULL, 'Proprotein convertase subtilisin/kexin type 9', 88, NULL, NULL, 212174),
(212175, '3.40.50.410-FF-000230', NULL, 'Uncharacterized protein', 206, NULL, NULL, 212175),
(212176, '3.30.70.1730-FF-000037', NULL, '50S ribosomal protein L10', 132, NULL, NULL, 212176),
(212177, '2.60.40.10-FF-003260', NULL, 'Interleukin 13 receptor, alpha 2', 94, NULL, NULL, 212177),
(212178, '1.25.40.10-FF-000948', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 96, NULL, NULL, 212178),
(212179, '1.10.287.660-FF-000036', NULL, 'Uncharacterized protein', 63, NULL, NULL, 212179),
(212180, '3.10.20.90-FF-000224', NULL, 'ras association domain-containing protein 3', 80, NULL, NULL, 212180),
(212181, '3.40.630.30-FF-000148', NULL, 'Lysine N-acyltransferase MbtK', 210, NULL, NULL, 212181),
(212182, '3.40.20.10-FF-000042', NULL, 'Actin depolymerizing protein', 142, NULL, NULL, 212182),
(212183, '2.102.10.10-FF-000024', NULL, 'Ubiquinol-cytochrome c reductase, iron-sulfur subunit', 117, NULL, NULL, 212183),
(212184, '2.60.40.10-FF-005058', NULL, NULL, 101, NULL, NULL, 212184),
(212185, '1.25.40.10-FF-003028', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 105, NULL, NULL, 212185),
(212186, '2.60.120.1560-FF-000002', NULL, 'Flocculation protein FLO10', 94, NULL, NULL, 212186),
(212187, '3.90.640.10-FF-000025', NULL, 'Chromatin remodeling complex subunit (Arp5)', 58, NULL, NULL, 212187),
(212188, '1.10.510.10-FF-000002', NULL, 'Non-specific serine/threonine protein kinase', 186, NULL, NULL, 212188),
(212189, '1.25.40.10-FF-001174', NULL, 'Pentatricopeptide repeat-containing protein At3g49740', 178, NULL, NULL, 212189),
(212190, '1.10.10.60-FF-000585', NULL, 'Chromodomain-helicase-DNA-binding protein 3', 97, NULL, NULL, 212190),
(212191, '2.170.300.10-FF-000074', NULL, 'Uncharacterized protein', 127, NULL, NULL, 212191),
(212192, '3.30.70.1390-FF-000008', NULL, 'Predicted protein', 46, NULL, NULL, 212192),
(212193, '3.30.710.10-FF-000191', NULL, 'YIL001W-like protein', 124, NULL, NULL, 212193),
(212194, '1.20.1070.10-FF-001976', NULL, 'Uncharacterized protein', 176, NULL, NULL, 212194),
(212195, '2.40.30.170-FF-000017', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 87, NULL, NULL, 212195),
(212196, '1.25.10.10-FF-001402', NULL, 'Arm repeat-containing protein-like protein', 93, NULL, NULL, 212196),
(212197, '3.80.10.10-FF-004098', NULL, 'Uncharacterized protein', 293, NULL, NULL, 212197),
(212198, '1.20.1270.10-FF-000103', NULL, 'Retrovirus-related Pol polyprotein LINE-1', 66, NULL, NULL, 212198),
(212199, '1.25.40.20-FF-001177', NULL, 'Transient receptor potential cation channel subfamily A member 1 homolog', 122, NULL, NULL, 212199),
(212200, '3.90.1150.10-FF-000318', NULL, 'Pyridoxal phosphate-dependent aminotransferase', 97, NULL, NULL, 212200),
(212201, '3.80.10.10-FF-000624', NULL, 'Leucine rich repeats and death domain containing 1', 94, NULL, NULL, 212201),
(212202, '1.10.287.70-FF-000146', NULL, 'Potassium channel, putative', 93, NULL, NULL, 212202),
(212203, '1.20.1560.10-FF-000148', NULL, 'ATP-binding cassette protein putative', 332, NULL, NULL, 212203),
(212204, '1.20.1270.60-FF-000039', NULL, 'FCH and double SH3 domains protein', 281, NULL, NULL, 212204),
(212205, '2.30.39.10-FF-000060', NULL, 'Serpin peptidase inhibitor 31', 62, NULL, NULL, 212205),
(212206, '3.40.140.20-FF-000001', NULL, 'Bifunctional purine biosynthesis protein PurH', 131, NULL, NULL, 212206),
(212207, '2.130.10.10-FF-003237', NULL, 'Uncharacterized protein', 247, NULL, NULL, 212207),
(212208, '1.25.10.10-FF-000778', NULL, 'Armadillo/beta-catenin repeat family protein', 207, NULL, NULL, 212208),
(212209, '3.30.420.10-FF-000376', NULL, NULL, 180, NULL, NULL, 212209),
(212210, '3.40.250.10-FF-000170', NULL, 'Ubiquitin-specific protease', 151, NULL, NULL, 212210),
(212211, '3.40.50.2000-FF-000953', NULL, 'Uncharacterized protein', 110, NULL, NULL, 212211),
(212212, '3.80.10.10-FF-004547', NULL, 'F-box protein At1g10780', 379, NULL, NULL, 212212),
(212213, '4.10.240.10-FF-000060', NULL, 'YNR063W-like protein', 41, NULL, NULL, 212213);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(212214, '3.30.230.10-FF-000171', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 158, NULL, NULL, 212214),
(212215, '1.10.630.10-FF-000831', NULL, 'Uncharacterized protein', 200, NULL, NULL, 212215),
(212216, '3.30.450.20-FF-000151', NULL, 'Sensor histidine kinase LuxQ', 127, NULL, NULL, 212216),
(212217, '3.30.200.20-FF-000672', NULL, 'Spectrin, beta, non-erythrocytic 1', 106, NULL, NULL, 212217),
(212218, '3.40.50.2300-FF-000981', NULL, NULL, 139, NULL, NULL, 212218),
(212219, '1.10.1300.10-FF-000053', NULL, 'Uncharacterized protein', 301, NULL, NULL, 212219),
(212220, '2.40.50.140-FF-000462', NULL, '30S ribosomal protein S17', 83, NULL, NULL, 212220),
(212221, '1.25.40.20-FF-001626', NULL, 'Uncharacterized protein', 97, NULL, NULL, 212221),
(212222, '1.10.510.10-FF-003649', NULL, NULL, 185, NULL, NULL, 212222),
(212223, '1.25.10.10-FF-001054', NULL, 'WAPL cohesin release factor a', 126, NULL, NULL, 212223),
(212224, '1.10.287.70-FF-000707', NULL, 'Uncharacterized protein', 173, NULL, NULL, 212224),
(212225, '1.25.40.10-FF-001623', NULL, 'Protein CBG09345', 179, NULL, NULL, 212225),
(212226, '2.60.120.330-FF-000072', NULL, 'Oxidoreductase', 339, NULL, NULL, 212226),
(212227, '1.20.5.4980-FF-000003', NULL, 'Centromere protein X', 20, NULL, NULL, 212227),
(212228, '1.20.1070.10-FF-000453', NULL, 'Olfactory receptor', 167, NULL, NULL, 212228),
(212229, '3.20.20.190-FF-000123', NULL, NULL, 105, NULL, NULL, 212229),
(212230, '3.30.1490.20-FF-000102', NULL, 'D-alanine--D-alanine ligase', 69, NULL, NULL, 212230),
(212231, '1.20.58.60-FF-000278', NULL, 'Uncharacterized protein, isoform D', 213, NULL, NULL, 212231),
(212232, '3.20.20.140-FF-000248', NULL, 'Dihydropyrimidinase', 332, NULL, NULL, 212232),
(212233, '3.40.710.10-FF-000143', NULL, 'D-alanyl-D-alanine carboxypeptidase', 260, NULL, NULL, 212233),
(212234, '1.20.1260.10-FF-000046', NULL, 'Ferritin', 123, NULL, NULL, 212234),
(212235, '3.30.70.100-FF-000020', NULL, 'Transporter, small conductance mechanosensitive ion channel family', 99, NULL, NULL, 212235),
(212236, '1.25.40.1030-FF-000033', NULL, 'Protein transport protein Sec31A', 389, NULL, NULL, 212236),
(212237, '2.30.42.10-FF-000438', NULL, NULL, 97, NULL, NULL, 212237),
(212238, '2.30.30.490-FF-000087', NULL, 'Cytosine-specific methyltransferase', 146, NULL, NULL, 212238),
(212239, '2.30.30.790-FF-000019', NULL, 'Ribosomal protein L19', 115, NULL, NULL, 212239),
(212240, '3.50.50.60-FF-000457', NULL, 'Long-chain-alcohol oxidase', 275, NULL, NULL, 212240),
(212241, '3.40.50.620-FF-000293', NULL, 'Integral membrane protein', 133, NULL, NULL, 212241),
(212242, '1.25.40.1040-FF-000036', NULL, 'Cleavage stimulation factor subunit 3', 201, NULL, NULL, 212242),
(212243, '1.20.120.1900-FF-000088', NULL, 'Uncharacterized protein', 138, NULL, NULL, 212243),
(212244, '2.60.40.4060-FF-000016', NULL, 'Uncharacterized protein', 40, NULL, NULL, 212244),
(212245, '3.30.200.20-FF-001801', NULL, 'Uncharacterized protein', 89, NULL, NULL, 212245),
(212246, '2.60.120.200-FF-000168', NULL, 'Sr-CI', 192, NULL, NULL, 212246),
(212247, '1.10.600.10-FF-000099', NULL, 'Predicted protein', 129, NULL, NULL, 212247),
(212248, '3.30.300.30-FF-000109', NULL, 'Non-ribosomal peptide synthetase', 91, NULL, NULL, 212248),
(212249, '3.40.50.720-FF-000727', NULL, 'UDP-N-acetyl-D-glucosamine dehydrogenase', 224, NULL, NULL, 212249),
(212250, '3.30.420.510-FF-000014', NULL, 'Pantothenate kinase 3', 175, NULL, NULL, 212250),
(212251, '3.30.2130.30-FF-000005', NULL, 'THUMP domain containing 2, isoform CRA_b', 150, NULL, NULL, 212251),
(212252, '3.30.160.60-FF-005721', NULL, NULL, 97, NULL, NULL, 212252),
(212253, '1.25.40.470-FF-000031', NULL, 'Uncharacterized protein TCIL3000_10_12370', 152, NULL, NULL, 212253),
(212254, '1.20.140.100-FF-000011', NULL, 'Dynein heavy chain-like protein', 151, NULL, NULL, 212254),
(212255, '3.90.870.10-FF-000008', NULL, 'Threonylcarbamoyl-AMP synthase', 212, NULL, NULL, 212255),
(212256, '2.40.20.10-FF-000050', NULL, 'Uncharacterized protein', 87, NULL, NULL, 212256),
(212257, '3.40.50.1000-FF-000698', NULL, NULL, 120, NULL, NULL, 212257);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(212258, '3.40.250.10-FF-000063', NULL, 'Unplaced genomic scaffold supercont1.113, whole genome shotgun sequence', 142, NULL, NULL, 212258),
(212259, '2.60.120.620-FF-000001', NULL, 'Prolyl 4-hydroxylase subunit alpha 2', 190, NULL, NULL, 212259),
(212260, '1.20.920.20-FF-000039', NULL, 'Dynein heavy chain', 345, NULL, NULL, 212260),
(212261, '1.20.120.350-FF-000200', NULL, NULL, 131, NULL, NULL, 212261),
(212262, '1.10.510.10-FF-001632', NULL, 'Uncharacterized protein', 283, NULL, NULL, 212262),
(212263, '3.50.50.60-FF-000856', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 110, NULL, NULL, 212263),
(212264, '3.90.190.10-FF-000440', NULL, 'Predicted protein', 282, NULL, NULL, 212264),
(212265, '2.60.120.200-FF-000516', NULL, 'Uncharacterized protein', 113, NULL, NULL, 212265),
(212266, '2.60.40.10-FF-002765', NULL, 'filamin-C isoform X1', 100, NULL, NULL, 212266),
(212267, '1.20.120.1960-FF-000004', NULL, 'Sulfhydryl oxidase', 115, NULL, NULL, 212267),
(212268, '3.40.50.300-FF-003474', NULL, 'Uncharacterized ATP-dependent helicase C05C10.2', 242, NULL, NULL, 212268),
(212269, '1.10.150.850-FF-000010', NULL, 'Uncharacterized protein', 78, NULL, NULL, 212269),
(212270, '3.40.1810.10-FF-000021', NULL, 'AGAMOUS-like 21', 75, NULL, NULL, 212270),
(212271, '3.30.420.10-FF-000325', NULL, NULL, 75, NULL, NULL, 212271),
(212272, '1.20.1560.10-FF-000204', NULL, 'Drugs-transport transmembrane ATP-binding protein ABC transporter', 304, NULL, NULL, 212272),
(212273, '3.20.20.100-FF-000079', NULL, 'glutamate--cysteine ligase regulatory subunit-like', 168, NULL, NULL, 212273),
(212274, '1.10.287.1390-FF-000003', NULL, NULL, 57, NULL, NULL, 212274),
(212275, '1.20.1560.10-FF-000423', NULL, 'ATP-binding cassette transporter, subfamily B, member 6, group TAP protein PpABCB6', 186, NULL, NULL, 212275),
(212276, '3.60.21.10-FF-000133', NULL, 'Protein CBR-PPH-1', 167, NULL, NULL, 212276),
(212277, '3.40.1110.10-FF-000007', NULL, 'Potassium-transporting ATPase ATP-binding subunit', 134, NULL, NULL, 212277),
(212278, '1.20.920.10-FF-000036', NULL, 'Tripartite motif-containing protein 66', 124, NULL, NULL, 212278),
(212279, '2.10.25.10-FF-000517', NULL, 'Crumbs 1, cell polarity complex component', 38, NULL, NULL, 212279),
(212280, '3.30.70.270-FF-000295', NULL, NULL, 67, NULL, NULL, 212280),
(212281, '3.10.590.10-FF-000027', NULL, 'Uncharacterized protein', 171, NULL, NULL, 212281),
(212282, '1.10.287.810-FF-000014', NULL, 'Tim10/DDP family zinc finger, putative', 69, NULL, NULL, 212282),
(212283, '1.20.1250.20-FF-000167', NULL, 'Transporter, major facilitator family', 200, NULL, NULL, 212283),
(212284, '3.30.460.10-FF-000154', NULL, 'Uncharacterized protein', 78, NULL, NULL, 212284),
(212285, '2.130.10.30-FF-000141', NULL, 'Uncharacterized protein', 380, NULL, NULL, 212285),
(212286, '1.20.1070.10-FF-001757', NULL, 'Predicted protein', 74, NULL, NULL, 212286),
(212287, '3.30.200.20-FF-001240', NULL, 'Non-specific serine/threonine protein kinase', 88, NULL, NULL, 212287),
(212288, '2.30.42.10-FF-000590', NULL, NULL, 106, NULL, NULL, 212288),
(212289, '3.40.50.300-FF-003687', NULL, 'Disease resistance protein Pik-1', 171, NULL, NULL, 212289),
(212290, '3.40.50.10190-FF-000205', NULL, 'DNA polymerase', 97, NULL, NULL, 212290),
(212291, '4.10.280.10-FF-000213', NULL, 'MAX-like-1 homolog', 52, NULL, NULL, 212291),
(212292, '3.80.10.10-FF-000444', NULL, 'Leucine rich repeat containing 7', 203, NULL, NULL, 212292),
(212293, '3.40.1410.10-FF-000047', NULL, 'GntR family transcriptional regulator', 151, NULL, NULL, 212293),
(212294, '3.30.40.10-FF-000089', NULL, 'Histone-lysine N-methyltransferase', 112, NULL, NULL, 212294),
(212295, '1.10.238.10-FF-000695', NULL, 'Calmodulin-like 4b', 149, NULL, NULL, 212295),
(212296, '3.90.950.10-FF-000009', NULL, 'Inosine triphosphate pyrophosphatase', 191, NULL, NULL, 212296),
(212297, '2.40.30.110-FF-000022', NULL, NULL, 95, NULL, NULL, 212297),
(212298, '3.30.40.10-FF-001994', NULL, 'Uncharacterized protein', 53, NULL, NULL, 212298),
(212299, '1.25.40.120-FF-000061', NULL, 'Protein prenyltransferase alpha subunit repeat containing 1', 221, NULL, NULL, 212299);
INSERT INTO "PUBLIC"."MODEL" VALUES
(212300, '3.30.70.330-FF-001139', NULL, 'EG:BACR42I17.12 protein', 95, NULL, NULL, 212300),
(212301, '1.10.10.10-FF-001727', NULL, 'Response regulator receiver', 109, NULL, NULL, 212301),
(212302, '3.60.20.40-FF-000033', NULL, 'Gamma-glutamyltransferase 5', 130, NULL, NULL, 212302),
(212303, '3.40.50.300-FF-000040', NULL, 'GTPase Der', 179, NULL, NULL, 212303),
(212304, '3.30.710.10-FF-000483', NULL, 'Mynn protein', 89, NULL, NULL, 212304),
(212305, '3.30.160.20-FF-000050', NULL, 'Peptidyl-tRNA hydrolase ICT1, mitochondrial', 139, NULL, NULL, 212305),
(212306, '3.50.50.60-FF-000238', NULL, 'Putative flavin dependent monooxygenase', 294, NULL, NULL, 212306),
(212307, '3.90.550.20-FF-000021', NULL, 'Toxin Afp18', 290, NULL, NULL, 212307),
(212308, '1.10.510.10-FF-001851', NULL, 'Kinase, STE STE20', 155, NULL, NULL, 212308),
(212309, '3.80.10.10-FF-004154', NULL, 'NLR family, pyrin domain containing 4G', 104, NULL, NULL, 212309),
(212310, '1.20.140.10-FF-000027', NULL, 'Acyl-CoA dehydrogenase', 172, NULL, NULL, 212310),
(212311, '3.90.70.10-FF-000695', NULL, 'Predicted protein', 225, NULL, NULL, 212311),
(212312, '1.20.1730.10-FF-000127', NULL, 'Uncharacterized protein', 277, NULL, NULL, 212312),
(212313, '1.20.1270.10-FF-000047', NULL, 'Heat Shock Protein', 105, NULL, NULL, 212313),
(212314, '3.40.50.2300-FF-000829', NULL, 'Guanylate cyclase', 190, NULL, NULL, 212314),
(212315, '1.25.40.10-FF-005153', NULL, 'Uncharacterized protein', 278, NULL, NULL, 212315),
(212316, '3.30.70.270-FF-000076', NULL, 'Diguanylate cyclase', 168, NULL, NULL, 212316),
(212317, '1.20.120.1950-FF-000001', NULL, 'Cerebral cavernous malformation 3', 205, NULL, NULL, 212317),
(212318, '3.30.200.20-FF-000958', NULL, 'Receptor protein serine/threonine kinase', 93, NULL, NULL, 212318),
(212319, '1.20.1250.20-FF-000442', NULL, 'Hexose transporter', 460, NULL, NULL, 212319),
(212320, '3.40.710.10-FF-000194', NULL, 'Uncharacterized protein', 173, NULL, NULL, 212320),
(212321, '2.40.50.140-FF-000748', NULL, NULL, 89, NULL, NULL, 212321),
(212322, '3.40.225.10-FF-000038', NULL, NULL, 204, NULL, NULL, 212322),
(212323, '1.10.8.60-FF-000550', NULL, 'Chromosomal replication initiator protein DnaA', 49, NULL, NULL, 212323),
(212324, '1.25.40.20-FF-001233', NULL, 'Uncharacterized protein', 266, NULL, NULL, 212324),
(212325, '3.40.50.1100-FF-000222', NULL, 'Predicted protein', 24, NULL, NULL, 212325),
(212326, '3.30.70.260-FF-000073', NULL, 'Ribose-5-phosphate isomerase A', 78, NULL, NULL, 212326),
(212327, '3.40.50.1820-FF-000382', NULL, 'Proline iminopeptidase', 312, NULL, NULL, 212327),
(212328, '3.90.45.10-FF-000007', NULL, 'Peptide deformylase', 182, NULL, NULL, 212328),
(212329, '1.10.150.50-FF-000014', NULL, 'Protein c-ets-1 isoform 1', 96, NULL, NULL, 212329),
(212330, '1.25.40.10-FF-001230', NULL, 'Os01g0880900 protein', 127, NULL, NULL, 212330),
(212331, '1.25.40.10-FF-004877', NULL, 'Uncharacterized protein', 105, NULL, NULL, 212331),
(212332, '2.40.50.140-FF-001237', NULL, NULL, 35, NULL, NULL, 212332),
(212333, '2.20.100.10-FF-000212', NULL, 'Thrombospondin type-1 domain-containing protein 7B', 49, NULL, NULL, 212333),
(212334, '3.40.50.300-FF-003069', NULL, 'Small GTPase EhRabX19, putative', 199, NULL, NULL, 212334),
(212335, '3.10.20.620-FF-000018', NULL, NULL, 101, NULL, NULL, 212335),
(212336, '3.30.70.330-FF-002825', NULL, NULL, 89, NULL, NULL, 212336),
(212337, '2.60.220.50-FF-000156', NULL, 'Uncharacterized protein', 171, NULL, NULL, 212337),
(212338, '3.30.70.1620-FF-000004', NULL, 'Structural maintenance of chromosomes flexible hinge domain containing 1', 98, NULL, NULL, 212338),
(212339, '2.10.50.10-FF-000031', NULL, 'Tumor necrosis factor receptor superfamily member 1B', 88, NULL, NULL, 212339),
(212340, '1.10.510.10-FF-001289', NULL, 'Serine/threonine-protein kinase dkf-1', 291, NULL, NULL, 212340),
(212341, '1.20.1270.60-FF-000314', NULL, 'Uncharacterized protein', 257, NULL, NULL, 212341),
(212342, '3.30.70.330-FF-002775', NULL, NULL, 72, NULL, NULL, 212342),
(212343, '3.40.50.12710-FF-000017', NULL, 'Protein arginine methyltransferase NDUFAF7 homolog, mitochondrial', 389, NULL, NULL, 212343); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(212344, '2.60.40.1090-FF-000030', NULL, 'Hypothetical fimbrial subunit', 157, NULL, NULL, 212344),
(212345, '2.30.30.100-FF-000072', NULL, 'RNA-binding protein Hfq', 77, NULL, NULL, 212345),
(212346, '1.10.10.10-FF-001492', NULL, 'Transcriptional regulator, IclR family', 74, NULL, NULL, 212346),
(212347, '3.30.497.10-FF-000188', NULL, 'Serpin, putative', 83, NULL, NULL, 212347),
(212348, '3.40.50.2300-FF-000094', NULL, 'PTS system fructose-like IIB component 2', 113, NULL, NULL, 212348),
(212349, '3.40.50.410-FF-000286', NULL, 'Integrin beta', 26, NULL, NULL, 212349),
(212350, '2.60.40.10-FF-005620', NULL, NULL, 99, NULL, NULL, 212350),
(212351, '3.30.70.940-FF-000030', NULL, 'Transcription antitermination protein RfaH', 161, NULL, NULL, 212351),
(212352, '6.10.140.2220-FF-000022', NULL, 'Leucine-rich repeat-containing protein', 50, NULL, NULL, 212352),
(212353, '1.10.510.10-FF-001345', NULL, 'HET-domain-containing protein', 203, NULL, NULL, 212353),
(212354, '3.40.225.10-FF-000044', NULL, NULL, 256, NULL, NULL, 212354),
(212355, '2.40.50.120-FF-000012', NULL, 'Metalloproteinase inhibitor 4', 95, NULL, NULL, 212355),
(212356, '3.40.50.300-FF-003417', NULL, 'Dynein heavy chain', 134, NULL, NULL, 212356),
(212357, '2.80.10.50-FF-000211', NULL, 'Uncharacterized protein', 100, NULL, NULL, 212357),
(212358, '2.60.40.10-FF-004041', NULL, NULL, 97, NULL, NULL, 212358),
(212359, '2.10.70.10-FF-000032', NULL, 'sushi repeat-containing protein SRPX isoform X1', 57, NULL, NULL, 212359),
(212360, '2.60.40.10-FF-005564', NULL, NULL, 110, NULL, NULL, 212360),
(212361, '1.20.58.60-FF-000508', NULL, 'Muscle-specific protein', 112, NULL, NULL, 212361),
(212362, '3.40.50.720-FF-001857', NULL, 'Alcohol dehydrogenase class 4 mu/sigma chain', 139, NULL, NULL, 212362),
(212363, '3.40.50.1820-FF-000612', NULL, 'Uncharacterized protein', 294, NULL, NULL, 212363),
(212364, '3.30.1330.20-FF-000040', NULL, 'Cell division protein FtsZ', 114, NULL, NULL, 212364),
(212365, '1.10.510.10-FF-002868', NULL, NULL, 202, NULL, NULL, 212365),
(212366, '3.80.10.10-FF-001967', NULL, 'F-box/LRR-repeat protein 12', 162, NULL, NULL, 212366),
(212367, '2.130.10.10-FF-001944', NULL, 'Predicted protein', 321, NULL, NULL, 212367),
(212368, '2.60.120.180-FF-000004', NULL, 'Endoglucanase A eglA', 223, NULL, NULL, 212368),
(212369, '1.25.50.20-FF-000042', NULL, 'Uncharacterized protein', 368, NULL, NULL, 212369),
(212370, '3.40.718.10-FF-000043', NULL, '3-isopropylmalate dehydrogenase (LeuB)', 365, NULL, NULL, 212370),
(212371, '3.30.1330.30-FF-000043', NULL, '23S rRNA methyltransferase TsnR', 93, NULL, NULL, 212371),
(212372, '3.40.50.410-FF-000342', NULL, 'Uncharacterized protein', 128, NULL, NULL, 212372),
(212373, '2.130.10.10-FF-005216', NULL, 'Uncharacterized protein', 83, NULL, NULL, 212373),
(212374, '4.10.1060.10-FF-000025', NULL, 'Zinc finger, RanBP2-type', 33, NULL, NULL, 212374),
(212375, '1.20.5.110-FF-000152', NULL, 'EhSyntaxin C, putative', 100, NULL, NULL, 212375),
(212376, '3.80.10.10-FF-002529', NULL, 'Uncharacterized protein', 150, NULL, NULL, 212376),
(212377, '3.40.50.1700-FF-000014', NULL, 'Glycoside hydrolase family 3', 228, NULL, NULL, 212377),
(212378, '1.25.10.10-FF-002689', NULL, 'Uncharacterized protein', 73, NULL, NULL, 212378),
(212379, '2.30.30.790-FF-000020', NULL, 'Predicted protein', 122, NULL, NULL, 212379),
(212380, '3.30.40.10-FF-002270', NULL, 'Predicted protein', 54, NULL, NULL, 212380),
(212381, '1.20.1560.10-FF-000592', NULL, 'MRP-like ABC transporter', 321, NULL, NULL, 212381),
(212382, '2.10.90.10-FF-000027', NULL, 'Glycoprotein hormone alpha 2', 100, NULL, NULL, 212382),
(212383, '1.20.1270.60-FF-000258', NULL, 'ArfGAP with SH3 domain, ankyrin repeat and PH domain 3', 187, NULL, NULL, 212383),
(212384, '2.60.40.10-FF-003434', NULL, NULL, 105, NULL, NULL, 212384),
(212385, '3.80.10.10-FF-000388', NULL, 'Blast:Lutropin-choriogonadotropic hormone receptor', 286, NULL, NULL, 212385),
(212386, '3.30.70.660-FF-000047', NULL, 'tRNA pseudouridine synthase', 151, NULL, NULL, 212386),
(212387, '3.30.1330.40-FF-000046', NULL, 'ATP binding L-PSP endoribonuclease', 146, NULL, NULL, 212387);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(212388, '3.40.50.920-FF-000057', NULL, 'Uncharacterized protein', 138, NULL, NULL, 212388),
(212389, '2.60.220.50-FF-000117', NULL, 'Uncharacterized protein', 50, NULL, NULL, 212389),
(212390, '2.30.40.10-FF-000035', NULL, 'Imidazolonepropionase', 79, NULL, NULL, 212390),
(212391, '3.30.1360.140-FF-000011', NULL, 'DNA-directed RNA polymerase subunit', 84, NULL, NULL, 212391),
(212392, '1.10.8.590-FF-000005', NULL, 'Uncharacterized tRNA/rRNA methyltransferase HI_0380', 71, NULL, NULL, 212392),
(212393, '1.25.10.10-FF-003420', NULL, 'U3 small nucleolar RNA-associated protein 10', 315, NULL, NULL, 212393),
(212394, '1.10.2000.10-FF-000013', NULL, 'atrial natriuretic peptide-converting enzyme', 130, NULL, NULL, 212394),
(212395, '3.40.50.300-FF-004997', NULL, 'RAB5A, member RAS oncogene family, b', 121, NULL, NULL, 212395),
(212396, '1.20.1070.10-FF-000740', NULL, 'muscarinic acetylcholine receptor M3-like', 235, NULL, NULL, 212396),
(212397, '1.10.150.240-FF-000097', NULL, 'Haloacid dehalogenase-like hydrolase family protein', 76, NULL, NULL, 212397),
(212398, '3.80.10.10-FF-000438', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase At4g26540 family', 84, NULL, NULL, 212398),
(212399, '3.40.1110.10-FF-000451', NULL, NULL, 140, NULL, NULL, 212399),
(212400, '2.30.30.40-FF-000588', NULL, 'CIN85 and CD2AP related, isoform E', 34, NULL, NULL, 212400),
(212401, '1.50.10.160-FF-000017', NULL, 'Ent-copalyl diphosphate synthase chloroplastic', 77, NULL, NULL, 212401),
(212402, '3.90.105.20-FF-000015', NULL, 'Ribosome assembly factor mrt4', 93, NULL, NULL, 212402),
(212403, '1.50.10.150-FF-000014', NULL, 'C4-dicarboxylate transporter/malic acid transport protein', 302, NULL, NULL, 212403),
(212404, '1.25.40.10-FF-005333', NULL, 'Pentatricopeptide repeat-containing protein At3g23020', 85, NULL, NULL, 212404),
(212405, '3.10.20.90-FF-000966', NULL, 'Uncharacterized protein', 30, NULL, NULL, 212405),
(212406, '3.30.70.330-FF-000684', NULL, 'Putative glycine-rich RNA-binding protein', 111, NULL, NULL, 212406),
(212407, '3.40.720.10-FF-000256', NULL, 'Uncharacterized protein', 66, NULL, NULL, 212407),
(212408, '3.40.50.150-FF-001259', NULL, NULL, 277, NULL, NULL, 212408),
(212409, '2.60.40.60-FF-000205', NULL, 'Proto-oncogene tyrosine-protein kinase receptor Ret', 123, NULL, NULL, 212409),
(212410, '3.80.10.10-FF-000770', NULL, 'Uncharacterized protein', 163, NULL, NULL, 212410),
(212411, '2.60.120.200-FF-000499', NULL, 'slit homolog 2 protein isoform X1', 188, NULL, NULL, 212411),
(212412, '3.80.10.10-FF-004042', NULL, 'Leucine-rich repeat family protein /protein kinase family protein-like', 141, NULL, NULL, 212412),
(212413, '3.30.40.10-FF-000976', NULL, 'Transcriptional repressor NOT4Hp, putative', 72, NULL, NULL, 212413),
(212414, '3.40.50.1100-FF-000110', NULL, 'Cysteine synthase', 28, NULL, NULL, 212414),
(212415, '1.20.1250.20-FF-000728', NULL, 'Uncharacterized protein', 181, NULL, NULL, 212415),
(212416, '2.40.50.90-FF-000199', NULL, 'Non-specific serine/threonine protein kinase', 38, NULL, NULL, 212416),
(212417, '3.30.420.10-FF-000269', NULL, 'Uncharacterized protein', 205, NULL, NULL, 212417),
(212418, '2.60.120.170-FF-000001', NULL, 'Intermediate capsid protein VP6', 170, NULL, NULL, 212418),
(212419, '3.40.50.300-FF-001563', NULL, 'Probable conserved membrane protein', 232, NULL, NULL, 212419),
(212420, '3.90.550.50-FF-000249', NULL, 'Uncharacterized protein', 163, NULL, NULL, 212420),
(212421, '3.40.50.300-FF-003693', NULL, 'Dicer-like 3', 162, NULL, NULL, 212421),
(212422, '3.40.50.2300-FF-000835', NULL, NULL, 88, NULL, NULL, 212422),
(212423, '1.20.970.10-FF-000040', NULL, 'Thymidine phosphorylase', 67, NULL, NULL, 212423),
(212424, '6.10.140.2220-FF-000061', NULL, 'MYND finger, putative', 59, NULL, NULL, 212424),
(212425, '1.20.1560.10-FF-000479', NULL, 'ABC transporter, ATP-binding/permease protein', 314, NULL, NULL, 212425),
(212426, '3.40.190.10-FF-000001', NULL, 'Glutamate receptor ionotropic, kainate 2', 125, NULL, NULL, 212426),
(212427, '3.80.10.10-FF-002861', NULL, 'Toll, putative', 136, NULL, NULL, 212427);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(212428, '2.10.25.10-FF-001647', NULL, 'Adhesion G protein-coupled receptor L4', 47, NULL, NULL, 212428),
(212429, '3.30.160.60-FF-003703', NULL, NULL, 30, NULL, NULL, 212429),
(212430, '3.30.70.330-FF-002718', NULL, NULL, 101, NULL, NULL, 212430),
(212431, '1.20.1070.10-FF-000627', NULL, 'Family A G protein-coupled receptor-like protein', 243, NULL, NULL, 212431),
(212432, '3.30.2290.10-FF-000011', NULL, 'Peptidase U62, modulator of DNA gyrase', 210, NULL, NULL, 212432),
(212433, '3.90.226.10-FF-000338', NULL, 'Carboxyl-terminal-processing peptidase 3 chloroplastic', 29, NULL, NULL, 212433),
(212434, '3.40.50.300-FF-007015', NULL, 'Chromosome 15, whole genome shotgun sequence', 207, NULL, NULL, 212434),
(212435, '1.20.90.10-FF-000057', NULL, NULL, 55, NULL, NULL, 212435),
(212436, '3.40.50.80-FF-000194', NULL, 'YALI0F01386p', 132, NULL, NULL, 212436),
(212437, '1.20.58.1070-FF-000022', NULL, 'Predicted protein', 194, NULL, NULL, 212437),
(212438, '3.40.50.1110-FF-000113', NULL, 'Isoamyl acetate-hydrolyzing esterase', 137, NULL, NULL, 212438),
(212439, '3.40.50.300-FF-003743', NULL, 'Uncharacterized protein', 334, NULL, NULL, 212439),
(212440, '1.20.58.1120-FF-000060', NULL, NULL, 136, NULL, NULL, 212440),
(212441, '3.80.10.10-FF-001113', NULL, 'Protein phosphatase 2C, putative', 85, NULL, NULL, 212441),
(212442, '1.25.40.10-FF-000387', NULL, 'Golgi to ER traffic protein 4', 311, NULL, NULL, 212442),
(212443, '1.25.40.10-FF-001005', NULL, 'Magnetosome protein MamA', 178, NULL, NULL, 212443),
(212444, '1.10.510.10-FF-003762', NULL, NULL, 140, NULL, NULL, 212444),
(212445, '2.60.200.40-FF-000006', NULL, 'Diacylglycerol kinase', 170, NULL, NULL, 212445),
(212446, '2.60.40.10-FF-003147', NULL, NULL, 88, NULL, NULL, 212446),
(212447, '3.30.920.10-FF-000015', NULL, 'Frataxin, putative', 109, NULL, NULL, 212447),
(212448, '4.10.1240.10-FF-000011', NULL, 'Calcitonin gene-related peptide type 1 receptor', 110, NULL, NULL, 212448),
(212449, '3.50.50.60-FF-000862', NULL, 'Gll1135 protein', 475, NULL, NULL, 212449),
(212450, '3.40.50.720-FF-000553', NULL, 'SUMO-activating enzyme subunit', 33, NULL, NULL, 212450),
(212451, '1.25.40.770-FF-000020', NULL, 'Uncharacterized protein', 192, NULL, NULL, 212451),
(212452, '1.10.630.10-FF-000163', NULL, 'Geraniol 8-hydroxylase', 254, NULL, NULL, 212452),
(212453, '1.10.470.10-FF-000009', NULL, 'Variant surface glycoprotein (VSG, atypical), putative', 157, NULL, NULL, 212453),
(212454, '3.65.10.20-FF-000027', NULL, 'RNA 3'' terminal cyclase, putative', 60, NULL, NULL, 212454),
(212455, '1.20.58.60-FF-000840', NULL, 'Uncharacterized protein', 150, NULL, NULL, 212455),
(212456, '3.40.190.10-FF-000855', NULL, 'NMDA class glutamate Receptor', 61, NULL, NULL, 212456),
(212457, '1.20.1250.20-FF-002241', NULL, 'Uncharacterized protein', 115, NULL, NULL, 212457),
(212458, '3.30.559.10-FF-000181', NULL, 'Predicted protein', 210, NULL, NULL, 212458),
(212459, '2.130.10.10-FF-003294', NULL, 'AGAP004176-PA', 260, NULL, NULL, 212459),
(212460, '2.130.10.10-FF-004873', NULL, 'Chromosome 15, whole genome shotgun sequence', 120, NULL, NULL, 212460),
(212461, '2.10.25.10-FF-000287', NULL, 'Integrin beta', 42, NULL, NULL, 212461),
(212462, '2.60.40.1400-FF-000016', NULL, NULL, 172, NULL, NULL, 212462),
(212463, '2.10.25.10-FF-000343', NULL, 'latent-transforming growth factor beta-binding protein 4 isoform X1', 41, NULL, NULL, 212463),
(212464, '1.20.1250.40-FF-000032', NULL, 'DNA-directed RNA polymerase II subunit', 148, NULL, NULL, 212464),
(212465, '3.50.50.60-FF-000682', NULL, '2-polyprenyl-6-methoxyphenol hydroxylase', 204, NULL, NULL, 212465),
(212466, '2.60.40.10-FF-004889', NULL, NULL, 120, NULL, NULL, 212466),
(212467, '1.20.120.1080-FF-000049', NULL, 'ATP-dependent RNA helicase A, putative', 107, NULL, NULL, 212467),
(212468, '3.30.160.60-FF-003647', NULL, NULL, 36, NULL, NULL, 212468),
(212469, '4.10.1240.30-FF-000017', NULL, NULL, 47, NULL, NULL, 212469),
(212470, '1.20.920.10-FF-000087', NULL, 'ATPase family AAA domain-containing protein 2B', 136, NULL, NULL, 212470);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(212471, '3.40.220.10-FF-000016', NULL, 'Putative helicase CHR10', 180, NULL, NULL, 212471),
(212472, '3.60.20.10-FF-000108', NULL, 'Proteasome subunit beta', 210, NULL, NULL, 212472),
(212473, '1.20.1730.10-FF-000077', NULL, 'Uncharacterized protein', 210, NULL, NULL, 212473),
(212474, '2.60.120.200-FF-000555', NULL, 'Uncharacterized protein', 203, NULL, NULL, 212474),
(212475, '3.40.50.1240-FF-000011', NULL, '2-phosphoxylose phosphatase 1', 405, NULL, NULL, 212475),
(212476, '1.25.40.620-FF-000003', NULL, 'Tetrapyrrole-binding protein', 94, NULL, NULL, 212476),
(212477, '1.20.990.10-FF-000035', NULL, 'Methionine synthase reductase, mitochondrial-like protein', 131, NULL, NULL, 212477),
(212478, '3.40.50.10190-FF-000132', NULL, 'DNA repair protein REV1', 63, NULL, NULL, 212478),
(212479, '3.30.450.20-FF-000443', NULL, 'Erg potassium channel', 139, NULL, NULL, 212479),
(212480, '2.60.200.30-FF-000003', NULL, 'NAD kinase b', 148, NULL, NULL, 212480),
(212481, '2.170.130.10-FF-000038', NULL, 'TonB-dependent heme receptor HasR', 129, NULL, NULL, 212481),
(212482, '1.10.2020.20-FF-000017', NULL, NULL, 120, NULL, NULL, 212482),
(212483, '1.10.238.10-FF-000987', NULL, 'Uncharacterized protein', 189, NULL, NULL, 212483),
(212484, '3.40.50.1360-FF-000047', NULL, '6-phosphogluconolactonase', 232, NULL, NULL, 212484),
(212485, '3.30.160.60-FF-000213', NULL, 'Zinc finger protein 624', 28, NULL, NULL, 212485),
(212486, '2.20.100.10-FF-000156', NULL, 'GD10853', 58, NULL, NULL, 212486),
(212487, '3.30.1060.10-FF-000016', NULL, NULL, 166, NULL, NULL, 212487),
(212488, '3.10.450.40-FF-000026', NULL, 'Amine oxidase', 118, NULL, NULL, 212488),
(212489, '4.10.240.10-FF-000054', NULL, 'C6 transcription factor GliZ-like, putative', 73, NULL, NULL, 212489),
(212490, '3.40.50.10480-FF-000005', NULL, 'Similar to RNA processing factor 1', 187, NULL, NULL, 212490),
(212491, '3.40.630.30-FF-000255', NULL, 'N-acetyltransferase, putative', 168, NULL, NULL, 212491),
(212492, '3.30.70.330-FF-001988', NULL, NULL, 143, NULL, NULL, 212492),
(212493, '3.60.10.10-FF-000046', NULL, 'DNA-(apurinic or apyrimidinic site) lyase', 338, NULL, NULL, 212493),
(212494, '3.30.70.330-FF-000920', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 100, NULL, NULL, 212494),
(212495, '3.80.10.10-FF-000618', NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3', 111, NULL, NULL, 212495),
(212496, '3.40.50.150-FF-000011', NULL, 'DNA methyltransferase 3 alpha', 61, NULL, NULL, 212496),
(212497, '2.60.60.20-FF-000004', NULL, 'Lipoxygenase homology domain-containing protein 1', 116, NULL, NULL, 212497),
(212498, '3.30.750.44-FF-000004', NULL, 'Tail-specific protease', 70, NULL, NULL, 212498),
(212499, '2.30.40.10-FF-000074', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 80, NULL, NULL, 212499),
(212500, '1.10.10.10-FF-001435', NULL, 'Transcriptional regulatory protein CusR', 101, NULL, NULL, 212500),
(212501, '3.40.50.170-FF-000017', NULL, 'dTDP-4-amino-4,6-dideoxyglucose formyltransferase', 173, NULL, NULL, 212501),
(212502, '1.10.730.10-FF-000159', NULL, 'Uncharacterized protein', 187, NULL, NULL, 212502),
(212503, '2.130.10.10-FF-003125', NULL, 'Transducin/WD40 repeat-like superfamily protein', 258, NULL, NULL, 212503),
(212504, '3.40.1190.20-FF-000116', NULL, 'ADP-dependent (S)-NAD(P)H-hydrate dehydratase', 273, NULL, NULL, 212504),
(212505, '3.30.1370.160-FF-000002', NULL, 'Sll1252 protein', 69, NULL, NULL, 212505),
(212506, '3.30.160.60-FF-003922', NULL, NULL, 54, NULL, NULL, 212506),
(212507, '3.40.50.12780-FF-000162', NULL, 'HC-toxin synthetase', 407, NULL, NULL, 212507),
(212508, '3.40.50.1820-FF-000556', NULL, 'Uncharacterized protein', 278, NULL, NULL, 212508),
(212509, '1.20.5.2440-FF-000011', NULL, 'LOC100135220 protein', 56, NULL, NULL, 212509),
(212510, '3.80.10.10-FF-001748', NULL, 'AGAP000471-PA', 203, NULL, NULL, 212510),
(212511, '3.40.50.850-FF-000013', NULL, 'Pyrazinamidase and NiCotinamidase', 220, NULL, NULL, 212511),
(212512, '3.40.50.1000-FF-000479', NULL, NULL, 112, NULL, NULL, 212512);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(212513, '3.40.570.10-FF-000042', NULL, 'Uncharacterized protein', 147, NULL, NULL, 212513),
(212514, '3.30.230.10-FF-000165', NULL, 'DNA gyrase subunit B', 170, NULL, NULL, 212514),
(212515, '1.20.58.60-FF-000565', NULL, 'Plectin', 285, NULL, NULL, 212515),
(212516, '3.50.50.60-FF-001300', NULL, 'Uncharacterized protein', 165, NULL, NULL, 212516),
(212517, '1.10.150.50-FF-000121', NULL, 'stromal interaction molecule 2', 28, NULL, NULL, 212517),
(212518, '2.130.10.10-FF-003182', NULL, 'Pre-mRNA-splicing factor RSE1', 350, NULL, NULL, 212518),
(212519, '1.25.40.20-FF-001738', NULL, 'Protein CBG15247', 215, NULL, NULL, 212519),
(212520, '2.40.10.10-FF-000111', NULL, 'Blast:Serine protease nudel', 242, NULL, NULL, 212520),
(212521, '1.20.1070.10-FF-000447', NULL, 'NeuroPeptide Receptor family', 343, NULL, NULL, 212521),
(212522, '1.20.120.610-FF-000020', NULL, 'V-type proton ATPase subunit c4', 87, NULL, NULL, 212522),
(212523, '1.20.58.390-FF-000302', NULL, 'Uncharacterized protein', 75, NULL, NULL, 212523),
(212524, '3.40.50.1260-FF-000017', NULL, 'Phosphoglycerate kinase', 24, NULL, NULL, 212524),
(212525, '3.60.130.10-FF-000072', NULL, 'Uncharacterized protein', 108, NULL, NULL, 212525),
(212526, '1.10.10.250-FF-000020', NULL, '50S ribosomal protein L11-like', 82, NULL, NULL, 212526),
(212527, '2.10.25.10-FF-000068', NULL, 'Latent transforming growth factor beta binding protein 3', 41, NULL, NULL, 212527),
(212528, '3.40.50.720-FF-002239', NULL, 'Uncharacterized protein', 88, NULL, NULL, 212528),
(212529, '1.25.40.10-FF-005046', NULL, 'Uncharacterized protein', 123, NULL, NULL, 212529),
(212530, '1.20.1250.20-FF-000616', NULL, 'Transporter major facilitator superfamily', 189, NULL, NULL, 212530),
(212531, '1.25.40.10-FF-001735', NULL, 'Os04g0218100 protein', 73, NULL, NULL, 212531),
(212532, '3.30.160.60-FF-003086', NULL, 'Zinc finger protein 772', 29, NULL, NULL, 212532),
(212533, '1.10.390.10-FF-000008', NULL, 'Thyrotropin-releasing hormone-degrading ectoenzyme', 253, NULL, NULL, 212533),
(212534, '3.40.50.10490-FF-000008', NULL, '30S ribosomal protein S2, chloroplastic', 177, NULL, NULL, 212534),
(212535, '1.10.10.10-FF-000598', NULL, 'forkhead box protein I1 isoform X2', 108, NULL, NULL, 212535),
(212536, '3.40.50.10490-FF-000065', NULL, 'Transcriptional regulator, RpiR family', 176, NULL, NULL, 212536),
(212537, '2.30.30.140-FF-000235', NULL, 'E3 ubiquitin-protein ligase UHRF2 isoform X2', 75, NULL, NULL, 212537),
(212538, '3.30.200.20-FF-001127', NULL, 'AGC family protein kinase', 101, NULL, NULL, 212538),
(212539, '1.10.555.10-FF-000201', NULL, NULL, 103, NULL, NULL, 212539),
(212540, '3.90.190.10-FF-000097', NULL, 'Tyrosine-protein phosphatase 99A', 268, NULL, NULL, 212540),
(212541, '1.10.8.370-FF-000001', NULL, 'Orf1a polyprotein', 86, NULL, NULL, 212541),
(212542, '1.25.10.10-FF-003201', NULL, 'Uncharacterized protein', 584, NULL, NULL, 212542),
(212543, '3.10.580.10-FF-000021', NULL, 'DUF21 domain-containing protein At4g14240-like', 138, NULL, NULL, 212543),
(212544, '1.10.10.980-FF-000002', NULL, 'CST complex subunit STN1', 94, NULL, NULL, 212544),
(212545, '2.60.40.10-FF-005800', NULL, NULL, 81, NULL, NULL, 212545),
(212546, '1.20.1740.10-FF-000246', NULL, 'Uncharacterized protein', 334, NULL, NULL, 212546),
(212547, '3.90.80.10-FF-000015', NULL, 'Sulfate adenylyltransferase', 238, NULL, NULL, 212547),
(212548, '2.10.25.10-FF-000630', NULL, 'Fibulin 2', 44, NULL, NULL, 212548),
(212549, '1.25.10.10-FF-002925', NULL, 'ARM repeat superfamily protein', 101, NULL, NULL, 212549),
(212550, '3.30.160.20-FF-000229', NULL, 'Predicted protein', 91, NULL, NULL, 212550),
(212551, '3.30.470.20-FF-000039', NULL, 'Pyruvate carboxylase', 255, NULL, NULL, 212551),
(212552, '1.25.10.10-FF-002869', NULL, 'Uncharacterized protein', 156, NULL, NULL, 212552),
(212553, '2.30.29.30-FF-000514', NULL, 'FACT complex subunit POB3', 104, NULL, NULL, 212553),
(212554, '3.50.50.60-FF-001025', NULL, 'Glycerol-3-phosphate dehydrogenase', 128, NULL, NULL, 212554),
(212555, '3.30.70.330-FF-002595', NULL, NULL, 135, NULL, NULL, 212555);
INSERT INTO "PUBLIC"."MODEL" VALUES
(212556, '3.40.30.10-FF-000503', NULL, 'Protein CBG12683', 118, NULL, NULL, 212556),
(212557, '3.30.1010.10-FF-000069', NULL, 'Phosphoinositide-3-kinase, class 3', 128, NULL, NULL, 212557),
(212558, '1.25.10.10-FF-003145', NULL, 'Uncharacterized protein', 95, NULL, NULL, 212558),
(212559, '3.90.190.10-FF-000439', NULL, 'Uncharacterized protein', 52, NULL, NULL, 212559),
(212560, '1.20.1280.290-FF-000106', NULL, 'SD10385p', 56, NULL, NULL, 212560),
(212561, '1.10.533.10-FF-000021', NULL, 'caspase-8 isoform X1', 91, NULL, NULL, 212561),
(212562, '3.40.50.790-FF-000023', NULL, 'Ribosomal protein L10a', 89, NULL, NULL, 212562),
(212563, '3.30.470.10-FF-000036', NULL, '4-amino-4-deoxychorismate lyase', 124, NULL, NULL, 212563),
(212564, '3.40.30.10-FF-000161', NULL, 'Thioredoxin reductase 3', 111, NULL, NULL, 212564),
(212565, '3.40.50.1460-FF-000021', NULL, 'GPI-anchor transamidase', 277, NULL, NULL, 212565),
(212566, '3.40.50.300-FF-003305', NULL, 'ATP-dependent dethiobiotin synthetase BioD', 220, NULL, NULL, 212566),
(212567, '4.10.1000.10-FF-000084', NULL, 'RING finger protein unkempt homolog', 69, NULL, NULL, 212567),
(212568, '2.130.10.10-FF-005036', NULL, 'Uncharacterized protein', 297, NULL, NULL, 212568),
(212569, '1.10.1200.10-FF-000051', NULL, 'Nonribosomal peptide synthetase 7', 75, NULL, NULL, 212569),
(212570, '1.25.40.770-FF-000019', NULL, 'Uncharacterized protein', 86, NULL, NULL, 212570),
(212571, '3.30.930.10-FF-000134', NULL, 'Glycine--tRNA ligase', 313, NULL, NULL, 212571),
(212572, '2.40.10.10-FF-000398', NULL, NULL, 118, NULL, NULL, 212572),
(212573, '1.20.1070.10-FF-001122', NULL, 'Relaxin receptor 2', 378, NULL, NULL, 212573),
(212574, '3.40.50.150-FF-001534', NULL, NULL, 97, NULL, NULL, 212574),
(212575, '3.30.70.330-FF-001140', NULL, 'RNA-binding protein BRN2', 102, NULL, NULL, 212575),
(212576, '1.10.630.10-FF-000724', NULL, 'Uncharacterized protein', 101, NULL, NULL, 212576),
(212577, '1.20.5.300-FF-000001', NULL, 'striatin isoform X1', 50, NULL, NULL, 212577),
(212578, '3.60.20.10-FF-000165', NULL, NULL, 216, NULL, NULL, 212578),
(212579, '3.30.160.60-FF-002866', NULL, 'Zinc finger protein 260', 25, NULL, NULL, 212579),
(212580, '3.60.21.60-FF-000007', NULL, 'DNA polymerase alpha subunit B', 112, NULL, NULL, 212580),
(212581, '3.30.365.10-FF-000073', NULL, 'Uncharacterized protein', 101, NULL, NULL, 212581),
(212582, '3.10.450.350-FF-000005', NULL, 'Peptidase M23', 119, NULL, NULL, 212582),
(212583, '1.10.10.250-FF-000019', NULL, 'Uncharacterized protein', 35, NULL, NULL, 212583),
(212584, '1.10.510.10-FF-003705', NULL, NULL, 164, NULL, NULL, 212584),
(212585, '1.10.8.60-FF-000044', NULL, 'ATPase family AAA domain-containing protein 1', 82, NULL, NULL, 212585),
(212586, '1.20.5.110-FF-000264', NULL, 'Culmination specific protein 37D', 59, NULL, NULL, 212586),
(212587, '1.10.10.990-FF-000005', NULL, 'RecBCD enzyme subunit RecC', 70, NULL, NULL, 212587),
(212588, '3.40.1000.10-FF-000004', NULL, 'Probable ran guanine nucleotide release factor', 181, NULL, NULL, 212588),
(212589, '3.80.10.10-FF-000950', NULL, 'Nyctalopin', 117, NULL, NULL, 212589),
(212590, '2.60.40.3470-FF-000002', NULL, NULL, 123, NULL, NULL, 212590),
(212591, '3.40.50.10330-FF-000101', NULL, 'Diacylglycerol kinase', 118, NULL, NULL, 212591),
(212592, '2.60.40.10-FF-002130', NULL, 'High Incidence of Males (Increased X chromosome loss)', 86, NULL, NULL, 212592),
(212593, '2.130.10.10-FF-005710', NULL, 'Uncharacterized protein', 143, NULL, NULL, 212593),
(212594, '2.30.29.30-FF-000571', NULL, 'Uncharacterized protein', 106, NULL, NULL, 212594),
(212595, '2.60.40.1190-FF-000003', NULL, 'Endo-1,4-beta-xylanase A', 187, NULL, NULL, 212595),
(212596, '1.10.10.60-FF-000877', NULL, 'CENP-B homolog protein 1', 74, NULL, NULL, 212596),
(212597, '3.30.450.60-FF-000084', NULL, 'AP-3 complex subunit mu', 140, NULL, NULL, 212597),
(212598, '3.30.160.60-FF-005890', NULL, NULL, 30, NULL, NULL, 212598),
(212599, '3.30.160.60-FF-004996', NULL, NULL, 56, NULL, NULL, 212599),
(212600, '1.10.630.10-FF-000106', NULL, 'Cytochrome P450-DIT2', 456, NULL, NULL, 212600);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(212601, '2.130.10.10-FF-002962', NULL, 'WD repeat domain 34', 234, NULL, NULL, 212601),
(212602, '2.30.42.10-FF-000146', NULL, 'Carboxyl-terminal-processing peptidase 1, chloroplastic', 93, NULL, NULL, 212602),
(212603, '1.10.10.10-FF-001615', NULL, 'Histone H1', 81, NULL, NULL, 212603),
(212604, '3.40.50.12760-FF-000004', NULL, 'FtsJ-like methyltransferase', 409, NULL, NULL, 212604),
(212605, '4.10.240.10-FF-000110', NULL, 'C6 transcription factor, putative', 62, NULL, NULL, 212605),
(212606, '3.30.70.2850-FF-000036', NULL, 'Uncharacterized protein', 119, NULL, NULL, 212606),
(212607, '1.10.10.1410-FF-000008', NULL, NULL, 33, NULL, NULL, 212607),
(212608, '2.20.25.20-FF-000025', NULL, NULL, 53, NULL, NULL, 212608),
(212609, '3.30.160.60-FF-005272', NULL, NULL, 57, NULL, NULL, 212609),
(212610, '1.10.10.10-FF-000379', NULL, 'ArsR family transcriptional regulator', 89, NULL, NULL, 212610),
(212611, '1.20.1540.10-FF-000085', NULL, 'Rhomboid-like protease', 181, NULL, NULL, 212611),
(212612, '2.40.50.90-FF-000093', NULL, 'Uncharacterized protein', 122, NULL, NULL, 212612),
(212613, '1.10.287.70-FF-000202', NULL, 'TWiK family of potassium channels', 314, NULL, NULL, 212613),
(212614, '3.40.50.300-FF-002400', NULL, 'ABC transporter 2', 238, NULL, NULL, 212614),
(212615, '1.20.140.50-FF-000011', NULL, 'Rim20p', 93, NULL, NULL, 212615),
(212616, '3.80.10.10-FF-002804', NULL, 'Leucine-rich repeat-containing G-protein coupled receptor 5-like Protein', 139, NULL, NULL, 212616),
(212617, '3.50.50.60-FF-000749', NULL, 'Amine oxidase family member 1', 212, NULL, NULL, 212617),
(212618, '1.20.58.1120-FF-000003', NULL, 'Cytoplasmic dynein heavy chain 1', 154, NULL, NULL, 212618),
(212619, '2.40.37.10-FF-000083', NULL, NULL, 74, NULL, NULL, 212619),
(212620, '4.10.1000.10-FF-000140', NULL, 'Cleavage and polyadenylation specificity factor subunit 4-like Protein', 61, NULL, NULL, 212620),
(212621, '1.25.10.10-FF-001346', NULL, 'Uncharacterized protein', 323, NULL, NULL, 212621),
(212622, '3.20.20.80-FF-000592', NULL, 'Predicted protein', 206, NULL, NULL, 212622),
(212623, '2.60.40.10-FF-004783', NULL, NULL, 80, NULL, NULL, 212623),
(212624, '3.30.160.60-FF-001562', NULL, 'Zinc finger protein 449', 26, NULL, NULL, 212624),
(212625, '3.40.50.300-FF-001506', NULL, 'Ras-related protein Rab-40C', 142, NULL, NULL, 212625),
(212626, '3.80.10.10-FF-000332', NULL, 'extracellular matrix protein 2 isoform X1', 94, NULL, NULL, 212626),
(212627, '1.10.150.20-FF-000292', NULL, 'DNA-directed RNA polymerase', 212, NULL, NULL, 212627),
(212628, '1.25.40.180-FF-000118', NULL, 'Uncharacterized protein', 297, NULL, NULL, 212628),
(212629, '1.10.10.60-FF-001192', NULL, NULL, 89, NULL, NULL, 212629),
(212630, '2.20.28.10-FF-000006', NULL, 'DNA helicase', 55, NULL, NULL, 212630),
(212631, '3.40.50.2300-FF-001094', NULL, NULL, 155, NULL, NULL, 212631),
(212632, '2.130.10.10-FF-001326', NULL, 'Similar to nuclear pore protein Seh1', 338, NULL, NULL, 212632),
(212633, '3.40.50.300-FF-005834', NULL, 'ABC transporter D family member 2, chloroplastic', 271, NULL, NULL, 212633),
(212634, '1.10.150.110-FF-000018', NULL, 'Probable crossover junction endonuclease mus81', 73, NULL, NULL, 212634),
(212635, '3.30.900.10-FF-000020', NULL, 'Mitotic spindle checkpoint component MAD2', 199, NULL, NULL, 212635),
(212636, '3.40.50.300-FF-001383', NULL, 'Peptide ABC transporter ATP-binding protein', 264, NULL, NULL, 212636),
(212637, '3.30.40.210-FF-000007', NULL, 'Transcription elongation factor SPT4 homolog', 103, NULL, NULL, 212637),
(212638, '3.90.215.10-FF-000021', NULL, 'Fibrinogen alpha chain', 240, NULL, NULL, 212638),
(212639, '3.40.80.10-FF-000040', NULL, 'Uncharacterized protein', 75, NULL, NULL, 212639),
(212640, '3.30.70.330-FF-001701', NULL, NULL, 91, NULL, NULL, 212640),
(212641, '1.10.287.4070-FF-000004', NULL, 'Nucleolar protein 56', 164, NULL, NULL, 212641),
(212642, '1.20.120.1220-FF-000018', NULL, NULL, 147, NULL, NULL, 212642),
(212643, '1.25.10.10-FF-001907', NULL, 'Uncharacterized protein', 208, NULL, NULL, 212643),
(212644, '1.20.120.1080-FF-000105', NULL, 'AGAP010872-PA-like protein', 161, NULL, NULL, 212644);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(212645, '2.60.40.10-FF-001017', NULL, 'Matrix remodeling associated 5', 96, NULL, NULL, 212645),
(212646, '4.10.1000.10-FF-000027', NULL, 'Zinc finger protein, putative', 35, NULL, NULL, 212646),
(212647, '3.30.420.40-FF-000773', NULL, 'Actin-related protein 8', 102, NULL, NULL, 212647),
(212648, '3.20.20.140-FF-000355', NULL, 'Putative deoxyribonuclease TATDN1-like Protein', 300, NULL, NULL, 212648),
(212649, '2.60.40.10-FF-005507', NULL, NULL, 84, NULL, NULL, 212649),
(212650, '3.30.67.10-FF-000004', NULL, 'Genome polyprotein', 71, NULL, NULL, 212650),
(212651, '1.20.120.850-FF-000018', NULL, 'DNA repair and recombination protein RAD54', 92, NULL, NULL, 212651),
(212652, '3.40.1280.10-FF-000053', NULL, 'SpoU rRNA Methylase family, putative', 195, NULL, NULL, 212652),
(212653, '2.30.29.30-FF-000239', NULL, 'arf-GAP with GTPase, ANK repeat and PH domain-containing protein 2 isoform X2', 98, NULL, NULL, 212653),
(212654, '1.10.150.20-FF-000179', NULL, 'DNA-directed DNA polymerase eta', 83, NULL, NULL, 212654),
(212655, '3.20.20.70-FF-000370', NULL, 'Dihydroorotate dehydrogenase (quinone), mitochondrial', 141, NULL, NULL, 212655),
(212656, '3.80.10.10-FF-000731', NULL, 'Leucine-rich repeat receptor-like protein kinase', 90, NULL, NULL, 212656),
(212657, '3.40.50.10490-FF-000121', NULL, NULL, 172, NULL, NULL, 212657),
(212658, '3.30.450.20-FF-000482', NULL, 'Two-component system sensor histidine kinase/response regulator', 132, NULL, NULL, 212658),
(212659, '3.30.9.10-FF-000123', NULL, 'D-amino acid dehydrogenase subunit', 146, NULL, NULL, 212659),
(212660, '2.130.10.10-FF-005093', NULL, 'Predicted protein', 256, NULL, NULL, 212660),
(212661, '1.10.287.310-FF-000010', NULL, '60S ribosomal protein L35, putative', 66, NULL, NULL, 212661),
(212662, '1.20.1560.10-FF-000535', NULL, 'Uncharacterized protein', 350, NULL, NULL, 212662),
(212663, '1.20.1250.20-FF-002347', NULL, 'Solute carrier organic anion transporter family member', 412, NULL, NULL, 212663),
(212664, '2.60.40.1090-FF-000029', NULL, 'Fimbrial family protein', 144, NULL, NULL, 212664),
(212665, '1.20.1420.30-FF-000037', NULL, 'Predicted protein', 63, NULL, NULL, 212665),
(212666, '3.80.10.10-FF-002748', NULL, 'Fbox domain-containing protein', 142, NULL, NULL, 212666),
(212667, '1.10.510.10-FF-002649', NULL, NULL, 88, NULL, NULL, 212667),
(212668, '1.20.1420.10-FF-000031', NULL, NULL, 152, NULL, NULL, 212668),
(212669, '3.30.1240.10-FF-000058', NULL, 'Putative phosphatase HI_0003', 103, NULL, NULL, 212669),
(212670, '1.10.472.10-FF-000519', NULL, 'Uncharacterized protein', 96, NULL, NULL, 212670),
(212671, '2.10.220.10-FF-000133', NULL, 'receptor tyrosine-protein kinase erbB-4-like', 118, NULL, NULL, 212671),
(212672, '3.20.20.70-FF-000313', NULL, 'Dihydroorotate reductase PyrE, putative', 64, NULL, NULL, 212672),
(212673, '3.40.50.150-FF-001591', NULL, NULL, 278, NULL, NULL, 212673),
(212674, '1.25.40.90-FF-000085', NULL, 'ENTH domain-containing protein', 135, NULL, NULL, 212674),
(212675, '1.20.1070.10-FF-000009', NULL, 'Olfactory receptor', 289, NULL, NULL, 212675),
(212676, '1.25.40.570-FF-000061', NULL, '26S proteasome regulatory subunit', 172, NULL, NULL, 212676),
(212677, '3.40.50.720-FF-000497', NULL, 'Trk system potassium transporter TrkA', 129, NULL, NULL, 212677),
(212678, '3.15.10.10-FF-000010', NULL, 'BPI fold containing family A member 2', 224, NULL, NULL, 212678),
(212679, '2.60.40.10-FF-001910', NULL, 'CD83 molecule', 122, NULL, NULL, 212679),
(212680, '2.60.120.260-FF-000545', NULL, 'Probable beta-glucosidase O', 65, NULL, NULL, 212680),
(212681, '1.20.120.1910-FF-000017', NULL, 'Cysteine--tRNA ligase', 163, NULL, NULL, 212681),
(212682, '3.30.930.10-FF-000353', NULL, 'Uncharacterized protein', 46, NULL, NULL, 212682),
(212683, '1.50.10.20-FF-000032', NULL, 'Putative geranylgeranyl transferase beta subunit', 422, NULL, NULL, 212683),
(212684, '3.20.20.150-FF-000072', NULL, 'Uncharacterized protein', 114, NULL, NULL, 212684),
(212685, '2.60.120.970-FF-000027', NULL, 'Growth differentiation factor 7', 231, NULL, NULL, 212685);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(212686, '3.30.70.590-FF-000003', NULL, 'Poly(A) polymerase', 176, NULL, NULL, 212686),
(212687, '1.25.40.10-FF-000100', NULL, 'Type III secretion system translocator chaperone SicA', 149, NULL, NULL, 212687),
(212688, '3.40.50.720-FF-002352', NULL, 'Predicted protein', 76, NULL, NULL, 212688),
(212689, '1.20.1070.10-FF-000902', NULL, 'Uncharacterized protein', 83, NULL, NULL, 212689),
(212690, '3.30.420.10-FF-000612', NULL, NULL, 179, NULL, NULL, 212690),
(212691, '3.30.160.60-FF-001287', NULL, 'E3 ubiquitin-protein ligase TRIM56', 109, NULL, NULL, 212691),
(212692, '2.160.20.10-FF-000174', NULL, 'Pectinesterase', 80, NULL, NULL, 212692),
(212693, '3.40.50.2300-FF-000599', NULL, 'DNA-binding response regulator', 145, NULL, NULL, 212693),
(212694, '1.25.40.180-FF-000270', NULL, NULL, 191, NULL, NULL, 212694),
(212695, '3.40.350.10-FF-000059', NULL, 'Prolidase family protein', 129, NULL, NULL, 212695),
(212696, '1.10.8.10-FF-000344', NULL, 'Predicted protein', 71, NULL, NULL, 212696),
(212697, '3.60.10.10-FF-000226', NULL, 'DNA-(apurinic or apyrimidinic site) lyase', 149, NULL, NULL, 212697),
(212698, '1.20.5.5160-FF-000001', NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', 42, NULL, NULL, 212698),
(212699, '2.60.120.380-FF-000002', NULL, 'calpain-3 isoform X1', 157, NULL, NULL, 212699),
(212700, '3.40.50.150-FF-001315', NULL, NULL, 209, NULL, NULL, 212700),
(212701, '2.130.10.10-FF-001383', NULL, 'Protein JINGUBANG', 118, NULL, NULL, 212701),
(212702, '3.40.1110.10-FF-000338', NULL, NULL, 157, NULL, NULL, 212702),
(212703, '1.20.120.20-FF-000029', NULL, 'Apolipoprotein A-I', 69, NULL, NULL, 212703),
(212704, '1.10.2000.10-FF-000069', NULL, NULL, 113, NULL, NULL, 212704),
(212705, '2.10.110.10-FF-000209', NULL, 'LIM homeobox 2b', 68, NULL, NULL, 212705),
(212706, '3.30.160.60-FF-005159', NULL, NULL, 60, NULL, NULL, 212706),
(212707, '3.20.20.80-FF-000373', NULL, 'Expressed protein', 153, NULL, NULL, 212707),
(212708, '3.80.10.10-FF-003024', NULL, 'Os11g0641200 protein', 139, NULL, NULL, 212708),
(212709, '3.40.720.10-FF-000312', NULL, 'Uncharacterized protein', 209, NULL, NULL, 212709),
(212710, '1.25.40.20-FF-000103', NULL, 'Nuclear factor NF-kappa-B p105 subunit isoform 1', 258, NULL, NULL, 212710),
(212711, '1.20.58.60-FF-000621', NULL, 'Spectrin repeat-containing, nuclear envelope 2, gene 2', 270, NULL, NULL, 212711),
(212712, '3.20.20.80-FF-000316', NULL, 'Xylanase', 275, NULL, NULL, 212712),
(212713, '1.10.510.10-FF-002981', NULL, NULL, 168, NULL, NULL, 212713),
(212714, '3.40.640.10-FF-000492', NULL, 'Aromatic amino acid aminotransferase DDB_G0287711-like Protein', 424, NULL, NULL, 212714),
(212715, '1.25.40.10-FF-002697', NULL, 'LD43276p', 130, NULL, NULL, 212715),
(212716, '2.60.40.10-FF-005345', NULL, NULL, 70, NULL, NULL, 212716),
(212717, '3.40.190.10-FF-000799', NULL, 'Uncharacterized protein', 53, NULL, NULL, 212717),
(212718, '3.40.850.10-FF-000316', NULL, 'Myosin', 33, NULL, NULL, 212718),
(212719, '2.40.128.30-FF-000002', NULL, 'Hoefavidin', 134, NULL, NULL, 212719),
(212720, '2.30.29.30-FF-000391', NULL, 'Sterol 3-beta-glucosyltransferase', 113, NULL, NULL, 212720),
(212721, '2.130.10.130-FF-000030', NULL, 'Phosphatidylinositol-glycan-specific phospholipase D', 246, NULL, NULL, 212721),
(212722, '3.30.470.20-FF-000152', NULL, 'Uncharacterized protein', 228, NULL, NULL, 212722),
(212723, '2.120.10.30-FF-000456', NULL, 'Predicted protein', 91, NULL, NULL, 212723),
(212724, '1.20.1050.10-FF-000177', NULL, 'Predicted protein', 155, NULL, NULL, 212724),
(212725, '2.170.270.10-FF-000020', NULL, 'Histone-lysine N-methyltransferase', 251, NULL, NULL, 212725),
(212726, '3.40.850.10-FF-000373', NULL, 'p-loop nucleoside triphosphate hydrolase superfamily protein with CH (Calponin Homology) domain', 82, NULL, NULL, 212726),
(212727, '4.10.830.40-FF-000012', NULL, NULL, 87, NULL, NULL, 212727),
(212728, '1.20.120.160-FF-000019', NULL, 'Sensory box sensor histidine kinase/response regulator VieS', 99, NULL, NULL, 212728),
(212729, '2.130.10.10-FF-005654', NULL, 'Uncharacterized protein', 168, NULL, NULL, 212729);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(212730, '3.50.50.60-FF-000569', NULL, 'Flavin-containing monooxygenase', 29, NULL, NULL, 212730),
(212731, '3.90.190.10-FF-000153', NULL, 'TEP1p protein', 192, NULL, NULL, 212731),
(212732, '3.30.160.60-FF-001848', NULL, 'Uncharacterized protein, isoform B', 27, NULL, NULL, 212732),
(212733, '3.30.40.10-FF-002269', NULL, 'Uncharacterized protein', 54, NULL, NULL, 212733),
(212734, '2.60.60.20-FF-000043', NULL, NULL, 142, NULL, NULL, 212734),
(212735, '3.40.50.200-FF-000010', NULL, 'Putative neuroendocrine convertase 1', 332, NULL, NULL, 212735),
(212736, '3.30.950.10-FF-000023', NULL, 'Predicted protein', 124, NULL, NULL, 212736),
(212737, '1.20.900.10-FF-000092', NULL, 'Son of sevenless homolog', 231, NULL, NULL, 212737),
(212738, '1.20.900.10-FF-000035', NULL, 'Rho guanyl nucleotide exchange factor', 232, NULL, NULL, 212738),
(212739, '1.10.10.10-FF-000688', NULL, 'Transcriptional regulator MvfR', 78, NULL, NULL, 212739),
(212740, '1.10.238.10-FF-000998', NULL, 'Centrin, putative', 78, NULL, NULL, 212740),
(212741, '3.30.710.10-FF-000180', NULL, 'Kelch repeat and BTB domain containing 13', 126, NULL, NULL, 212741),
(212742, '1.20.1560.10-FF-000940', NULL, 'Uncharacterized protein', 396, NULL, NULL, 212742),
(212743, '3.40.20.10-FF-000115', NULL, 'Twinfilin', 142, NULL, NULL, 212743),
(212744, '1.20.1270.10-FF-000058', NULL, 'Chaperone protein HscA homolog', 95, NULL, NULL, 212744),
(212745, '3.90.550.10-FF-000687', NULL, 'Os08g0434632 protein', 76, NULL, NULL, 212745),
(212746, '3.90.370.10-FF-000004', NULL, 'Uncharacterized protein', 85, NULL, NULL, 212746),
(212747, '2.60.40.10-FF-003237', NULL, NULL, 91, NULL, NULL, 212747),
(212748, '3.30.200.20-FF-000099', NULL, 'Serine/threonine-protein kinase BLUS1', 89, NULL, NULL, 212748),
(212749, '3.40.50.300-FF-001467', NULL, 'Nuclease SbcCD subunit C', 290, NULL, NULL, 212749),
(212750, '1.20.900.10-FF-000125', NULL, 'Uncharacterized protein', 103, NULL, NULL, 212750),
(212751, '1.20.1110.10-FF-000002', NULL, 'Calcium-transporting ATPase', 79, NULL, NULL, 212751),
(212752, '3.40.50.150-FF-001596', NULL, NULL, 351, NULL, NULL, 212752),
(212753, '1.10.575.10-FF-000011', NULL, 'Phospholipase C/P1 nuclease', 282, NULL, NULL, 212753),
(212754, '3.30.200.20-FF-001251', NULL, 'Protein kinase, putative', 101, NULL, NULL, 212754),
(212755, '3.40.50.620-FF-000843', NULL, 'Uncharacterized protein', 177, NULL, NULL, 212755),
(212756, '3.40.367.20-FF-000022', NULL, 'Hexokinase 2', 163, NULL, NULL, 212756),
(212757, '3.40.850.10-FF-000535', NULL, 'Kinesin-like protein', 338, NULL, NULL, 212757),
(212758, '3.40.1110.10-FF-000153', NULL, 'Phospholipid-transporting ATPase IC', 26, NULL, NULL, 212758),
(212759, '3.40.50.2300-FF-000958', NULL, NULL, 103, NULL, NULL, 212759),
(212760, '1.25.40.10-FF-002011', NULL, 'Predicted tetratricopeptide repeat protein', 190, NULL, NULL, 212760),
(212761, '3.20.200.10-FF-000002', NULL, 'Eukaryotic elongation factor 2 kinase', 108, NULL, NULL, 212761),
(212762, '2.30.29.30-FF-000930', NULL, 'Guanine exchange factor for Rac 30', 161, NULL, NULL, 212762),
(212763, '1.10.510.10-FF-000013', NULL, 'Mitogen-activated protein kinase', 234, NULL, NULL, 212763),
(212764, '2.160.20.10-FF-000275', NULL, 'Uncharacterized protein', 251, NULL, NULL, 212764),
(212765, '2.40.50.140-FF-000198', NULL, 'Exosome complex component CSL4', 133, NULL, NULL, 212765),
(212766, '2.130.10.10-FF-001080', NULL, 'NACHT and WD domain protein', 83, NULL, NULL, 212766),
(212767, '3.40.50.800-FF-000083', NULL, 'NAB3-like protein', 113, NULL, NULL, 212767),
(212768, '3.30.70.2350-FF-000004', NULL, 'Intramembrane protease rhomboid family GlpG', 69, NULL, NULL, 212768),
(212769, '1.20.1250.20-FF-002095', NULL, 'Uncharacterized protein', 251, NULL, NULL, 212769),
(212770, '3.30.1540.20-FF-000039', NULL, NULL, 59, NULL, NULL, 212770),
(212771, '1.25.40.10-FF-005237', NULL, 'Uncharacterized protein', 171, NULL, NULL, 212771),
(212772, '1.25.10.10-FF-001357', NULL, 'Protein maestro', 221, NULL, NULL, 212772),
(212773, '1.25.40.10-FF-002966', NULL, 'Pentatricopeptide repeat-containing protein At5g50390, chloroplastic', 266, NULL, NULL, 212773);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(212774, '2.130.10.10-FF-002698', NULL, 'Uncharacterized protein', 324, NULL, NULL, 212774),
(212775, '1.20.58.60-FF-000267', NULL, 'Spectrin repeat containing, nuclear envelope 1a', 141, NULL, NULL, 212775),
(212776, '1.50.10.20-FF-000133', NULL, 'Protein farnesyltransferase subunit beta', 398, NULL, NULL, 212776),
(212777, '3.40.50.1820-FF-000371', NULL, 'Similar to platelet-activating factor acetylhydrolase', 482, NULL, NULL, 212777),
(212778, '3.40.50.150-FF-001607', NULL, NULL, 347, NULL, NULL, 212778),
(212779, '2.130.10.10-FF-003215', NULL, 'Katanin p80 WD40 repeat-containing subunit B1 homolog', 51, NULL, NULL, 212779),
(212780, '3.80.10.10-FF-002664', NULL, 'LRR receptor-like serine/threonine-protein kinase RCH1', 176, NULL, NULL, 212780),
(212781, '1.10.472.10-FF-000396', NULL, 'Uncharacterized protein', 93, NULL, NULL, 212781),
(212782, '3.40.50.1460-FF-000083', NULL, 'Uncharacterized protein', 237, NULL, NULL, 212782),
(212783, '3.20.20.80-FF-000518', NULL, 'Glycoside hydrolase, putative', 85, NULL, NULL, 212783),
(212784, '1.10.10.10-FF-001840', NULL, 'MCM family protein', 86, NULL, NULL, 212784),
(212785, '3.90.190.10-FF-000232', NULL, 'Uncharacterized protein', 124, NULL, NULL, 212785),
(212786, '1.20.1730.10-FF-000105', NULL, 'High-affinity choline transporter, putative', 194, NULL, NULL, 212786),
(212787, '1.10.510.10-FF-003239', NULL, NULL, 120, NULL, NULL, 212787),
(212788, '3.30.450.20-FF-000454', NULL, 'Voltage-dependent calcium channel subunit alpha-2/delta-4', 155, NULL, NULL, 212788),
(212789, '3.30.565.10-FF-000459', NULL, 'Globin-coupled histidine kinase', 157, NULL, NULL, 212789),
(212790, '3.50.50.60-FF-000339', NULL, 'Amine oxidase', 186, NULL, NULL, 212790),
(212791, '3.30.70.1230-FF-000106', NULL, 'Guanylate cyclase', 223, NULL, NULL, 212791),
(212792, '3.40.850.10-FF-000491', NULL, 'Kinesin-like protein KIN-7N', 64, NULL, NULL, 212792),
(212793, '3.40.50.10140-FF-000095', NULL, 'Uncharacterized protein', 50, NULL, NULL, 212793),
(212794, '2.60.40.10-FF-000011', NULL, 'Titin b', 102, NULL, NULL, 212794),
(212795, '3.40.190.10-FF-000827', NULL, 'Putative nitrate transporter', 263, NULL, NULL, 212795),
(212796, '2.60.120.260-FF-000394', NULL, 'Endo-1,4-beta-xylanase Y', 166, NULL, NULL, 212796),
(212797, '3.40.630.150-FF-000013', NULL, 'Uncharacterized protein', 301, NULL, NULL, 212797),
(212798, '1.10.287.70-FF-000157', NULL, 'Calcium channel subunit Cch1', 134, NULL, NULL, 212798),
(212799, '2.60.200.40-FF-000023', NULL, 'Long-chain base (LCB) kinase 1', 179, NULL, NULL, 212799),
(212800, '3.30.70.330-FF-000982', NULL, 'Unplaced genomic scaffold supercont2.16, whole genome shotgun sequence', 117, NULL, NULL, 212800),
(212801, '1.10.1670.40-FF-000015', NULL, 'Slr0231 protein', 50, NULL, NULL, 212801),
(212802, '4.10.240.10-FF-000166', NULL, 'YALI0D02783p', 67, NULL, NULL, 212802),
(212803, '1.20.1740.10-FF-000033', NULL, 'Lysine histidine transporter 1', 411, NULL, NULL, 212803),
(212804, '1.20.920.20-FF-000028', NULL, 'Ciliary dynein heavy chain 11', 335, NULL, NULL, 212804),
(212805, '3.40.1800.20-FF-000012', NULL, 'FI04829p', 77, NULL, NULL, 212805),
(212806, '3.40.50.300-FF-003721', NULL, 'Thiol reductant ABC exporter subunit CydD', 244, NULL, NULL, 212806),
(212807, '3.30.160.60-FF-000123', NULL, 'transcriptional repressor CTCF isoform X1', 28, NULL, NULL, 212807),
(212808, '1.20.1250.20-FF-000650', NULL, 'Solute carrier organic anion transporter family member', 370, NULL, NULL, 212808),
(212809, '1.10.8.10-FF-000046', NULL, 'ubiquitin carboxyl-terminal hydrolase 28 isoform X2', 77, NULL, NULL, 212809),
(212810, '2.30.30.40-FF-000678', NULL, 'Uncharacterized protein', 75, NULL, NULL, 212810),
(212811, '4.10.280.110-FF-000022', NULL, NULL, 75, NULL, NULL, 212811),
(212812, '2.20.100.10-FF-000167', NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif A, isoform B', 63, NULL, NULL, 212812),
(212813, '1.25.40.180-FF-000242', NULL, NULL, 154, NULL, NULL, 212813),
(212814, '3.90.550.10-FF-000102', NULL, 'Alpha-1,2-mannosyltransferase (Kre5)', 332, NULL, NULL, 212814);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(212815, '3.40.50.300-FF-007453', NULL, 'Photoreactivation-associated protein PhrA', 246, NULL, NULL, 212815),
(212816, '3.40.50.2000-FF-001122', NULL, 'Uncharacterized protein', 153, NULL, NULL, 212816),
(212817, '3.30.200.20-FF-000778', NULL, 'Os07g0493200 protein', 85, NULL, NULL, 212817),
(212818, '1.10.510.10-FF-001441', NULL, 'Protein CBG00447', 220, NULL, NULL, 212818),
(212819, '3.30.9.10-FF-000140', NULL, 'Gamma-glutamylputrescine oxidoreductase', 153, NULL, NULL, 212819),
(212820, '3.30.40.10-FF-000791', NULL, 'Putative RNA binding protein', 68, NULL, NULL, 212820),
(212821, '1.10.150.60-FF-000051', NULL, NULL, 68, NULL, NULL, 212821),
(212822, '3.40.1390.30-FF-000016', NULL, 'Nif3-like dinuclear metal center hexameric protein', 126, NULL, NULL, 212822),
(212823, '1.25.40.10-FF-002596', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 109, NULL, NULL, 212823),
(212824, '3.40.50.10190-FF-000323', NULL, 'Uncharacterized protein', 88, NULL, NULL, 212824),
(212825, '1.10.238.10-FF-001178', NULL, 'Uncharacterized protein', 90, NULL, NULL, 212825),
(212826, '1.20.1560.10-FF-000305', NULL, 'Unplaced genomic scaffold supercont1.219, whole genome shotgun sequence', 115, NULL, NULL, 212826),
(212827, '3.40.50.300-FF-005166', NULL, 'DNA mismatch repair protein MutS domain protein', 224, NULL, NULL, 212827),
(212828, '1.25.40.10-FF-003113', NULL, 'Uncharacterized protein', 103, NULL, NULL, 212828),
(212829, '2.130.10.10-FF-005339', NULL, 'Uncharacterized protein', 183, NULL, NULL, 212829),
(212830, '3.20.70.20-FF-000009', NULL, 'Ribonucleoside-diphosphate reductase', 698, NULL, NULL, 212830),
(212831, '1.20.1730.10-FF-000094', NULL, 'Uncharacterized protein', 326, NULL, NULL, 212831),
(212832, '3.20.20.300-FF-000038', NULL, 'Beta-glucosidase', 328, NULL, NULL, 212832),
(212833, '3.30.40.10-FF-000802', NULL, 'Histone-lysine N-methyltransferase ATXR5', 117, NULL, NULL, 212833),
(212834, '1.20.1560.10-FF-000614', NULL, 'ABC transporter, multidrug resistance associated protein', 159, NULL, NULL, 212834),
(212835, '3.30.160.60-FF-001551', NULL, 'Uncharacterized protein', 28, NULL, NULL, 212835),
(212836, '3.40.850.10-FF-000165', NULL, 'Kinesin family member 3A (KIF3A)', 383, NULL, NULL, 212836),
(212837, '3.40.50.300-FF-002895', NULL, 'Si:dkeyp-52c3.7', 189, NULL, NULL, 212837),
(212838, '1.20.1560.10-FF-000294', NULL, 'Multidrug resistance protein 1, putative', 22, NULL, NULL, 212838),
(212839, '2.60.120.200-FF-000527', NULL, 'Galectin', 150, NULL, NULL, 212839),
(212840, '3.40.50.10190-FF-000014', NULL, 'RNA polymerase II C-terminal domain phosphatase-like 3', 89, NULL, NULL, 212840),
(212841, '3.30.70.260-FF-000039', NULL, 'Aspartokinase', 71, NULL, NULL, 212841),
(212842, '2.170.270.10-FF-000189', NULL, 'Histone-lysine N-methyltransferase', 190, NULL, NULL, 212842),
(212843, '3.80.10.10-FF-003766', NULL, 'Uncharacterized protein', 114, NULL, NULL, 212843),
(212844, '2.40.70.10-FF-000002', NULL, 'Vacuolar aspartic proteinase', 158, NULL, NULL, 212844),
(212845, '2.60.120.650-FF-000095', NULL, 'RIOX2 isoform 6', 108, NULL, NULL, 212845),
(212846, '3.40.50.300-FF-005845', NULL, 'ABC transporter, putative (Eurofung)', 113, NULL, NULL, 212846),
(212847, '3.40.50.620-FF-000517', NULL, 'GMP synthase [glutamine-hydrolyzing]', 193, NULL, NULL, 212847),
(212848, '3.40.50.10180-FF-000011', NULL, 'Predicted protein', 53, NULL, NULL, 212848),
(212849, '3.80.10.10-FF-002338', NULL, 'Predicted protein', 135, NULL, NULL, 212849),
(212850, '3.30.310.80-FF-000046', NULL, 'Protein kinase domain-containing protein ppk9', 115, NULL, NULL, 212850),
(212851, '2.60.200.30-FF-000020', NULL, 'NAD kinase', 127, NULL, NULL, 212851),
(212852, '3.30.70.330-FF-002590', NULL, NULL, 136, NULL, NULL, 212852),
(212853, '1.10.510.10-FF-001750', NULL, 'OSJNBa0016N04.12-like protein', 175, NULL, NULL, 212853),
(212854, '2.60.120.820-FF-000022', NULL, 'Uncharacterized protein', 88, NULL, NULL, 212854),
(212855, '3.30.800.10-FF-000023', NULL, NULL, 177, NULL, NULL, 212855),
(212856, '3.40.50.2000-FF-000649', NULL, 'Os06g0216100 protein', 49, NULL, NULL, 212856);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(212857, '1.10.10.10-FF-002020', NULL, 'Uncharacterized protein', 109, NULL, NULL, 212857),
(212858, '2.30.29.30-FF-000604', NULL, 'Serine/threonine protein kinase ppk21, putative', 102, NULL, NULL, 212858),
(212859, '1.25.40.410-FF-000002', NULL, 'Dedicator of cytokinesis protein 7', 157, NULL, NULL, 212859),
(212860, '1.20.58.60-FF-000604', NULL, 'Microtubule actin crosslinking factor 1a', 122, NULL, NULL, 212860),
(212861, '1.10.8.10-FF-000355', NULL, 'Uncharacterized protein', 41, NULL, NULL, 212861),
(212862, '1.20.140.10-FF-000050', NULL, 'Acyl-CoA dehydrogenase FadE28', 143, NULL, NULL, 212862),
(212863, '3.40.50.720-FF-002329', NULL, 'C-terminal-binding protein-like Protein', 119, NULL, NULL, 212863),
(212864, '1.25.10.10-FF-003291', NULL, 'Serine/threonine-protein kinase TOR', 184, NULL, NULL, 212864),
(212865, '1.25.10.10-FF-002785', NULL, 'Predicted protein', 400, NULL, NULL, 212865),
(212866, '3.30.420.10-FF-000623', NULL, NULL, 171, NULL, NULL, 212866),
(212867, '3.30.450.20-FF-000128', NULL, 'PAS domain S-box protein', 147, NULL, NULL, 212867),
(212868, '2.30.30.180-FF-000011', NULL, 'Ribosome maturation factor RimP', 73, NULL, NULL, 212868),
(212869, '3.30.700.40-FF-000002', NULL, 'Methylcrotonyl-CoA carboxylase, alpha-subunit (Biotin-containing)', 118, NULL, NULL, 212869),
(212870, '3.30.450.40-FF-000201', NULL, 'Histidine kinase', 170, NULL, NULL, 212870),
(212871, '3.40.630.30-FF-000064', NULL, 'GNAT family acetyltransferase', 164, NULL, NULL, 212871),
(212872, '2.60.120.290-FF-000144', NULL, 'GD12774', 112, NULL, NULL, 212872),
(212873, '2.30.30.190-FF-000014', NULL, 'Uncharacterized protein, isoform E', 81, NULL, NULL, 212873),
(212874, '1.20.1250.20-FF-001959', NULL, 'Uncharacterized protein', 424, NULL, NULL, 212874),
(212875, '3.90.640.10-FF-000014', NULL, 'Putative actin-related protein 6', 108, NULL, NULL, 212875),
(212876, '1.10.418.40-FF-000004', NULL, 'Beclin 1 protein', 177, NULL, NULL, 212876),
(212877, '1.10.1520.10-FF-000018', NULL, 'RNase III domain protein', 190, NULL, NULL, 212877),
(212878, '3.30.460.10-FF-000053', NULL, 'ILF3 isoform 21', 92, NULL, NULL, 212878),
(212879, '3.90.660.10-FF-000077', NULL, NULL, 64, NULL, NULL, 212879),
(212880, '3.40.50.300-FF-001804', NULL, 'ATP-dependent RNA helicase DDX47', 165, NULL, NULL, 212880),
(212881, '3.30.930.10-FF-000061', NULL, 'Histidine--tRNA ligase, cytoplasmic', 348, NULL, NULL, 212881),
(212882, '1.20.58.390-FF-000111', NULL, 'AcetylCholine Receptor', 106, NULL, NULL, 212882),
(212883, '2.60.40.1390-FF-000018', NULL, 'Predicted protein', 111, NULL, NULL, 212883),
(212884, '3.90.570.10-FF-000002', NULL, 'beta-amyloid-like protein isoform X5', 115, NULL, NULL, 212884),
(212885, '3.90.190.10-FF-000602', NULL, 'Uncharacterized protein', 187, NULL, NULL, 212885),
(212886, '1.20.58.1210-FF-000007', NULL, 'Exocyst complex component EXO84, variant', 118, NULL, NULL, 212886),
(212887, '2.10.50.10-FF-000036', NULL, 'Tumor necrosis factor receptor superfamily member 1B', 85, NULL, NULL, 212887),
(212888, '1.20.1070.10-FF-000756', NULL, 'Follicle stimulating hormone receptor, fshr, putative', 73, NULL, NULL, 212888),
(212889, '2.40.50.140-FF-000877', NULL, NULL, 123, NULL, NULL, 212889),
(212890, '1.20.1410.10-FF-000047', NULL, 'Uncharacterized protein', 108, NULL, NULL, 212890),
(212891, '3.30.420.10-FF-000314', NULL, 'Protein CBG03113', 173, NULL, NULL, 212891),
(212892, '1.10.418.30-FF-000001', NULL, 'Probable kinetochore protein ndc80', 121, NULL, NULL, 212892),
(212893, '1.10.555.10-FF-000111', NULL, 'RhoGAP domain containing protein', 202, NULL, NULL, 212893),
(212894, '3.30.160.60-FF-001860', NULL, 'Zinc finger protein 770', 48, NULL, NULL, 212894),
(212895, '1.10.10.2480-FF-000008', NULL, NULL, 75, NULL, NULL, 212895),
(212896, '3.90.20.20-FF-000037', NULL, 'GrpE protein homolog', 122, NULL, NULL, 212896),
(212897, '1.10.10.10-FF-001531', NULL, 'Transcriptional regulator', 93, NULL, NULL, 212897),
(212898, '1.20.920.10-FF-000025', NULL, 'Histone-lysine N-methyltransferase', 126, NULL, NULL, 212898),
(212899, '3.40.50.300-FF-001793', NULL, 'TATA-binding protein-associated factor', 310, NULL, NULL, 212899);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(212900, '1.10.30.20-FF-000006', NULL, 'ERCC2/XPD/Rad3-related DNA repair helicase', 77, NULL, NULL, 212900),
(212901, '3.40.50.2300-FF-000649', NULL, 'AGAP010272-PA-like protein', 125, NULL, NULL, 212901),
(212902, '3.90.25.10-FF-000040', NULL, 'Tar1', 89, NULL, NULL, 212902),
(212903, '2.10.25.10-FF-000540', NULL, 'Sushi, nidogen and EGF-like domain-containing protein 1', 40, NULL, NULL, 212903),
(212904, '3.10.100.10-FF-000385', NULL, NULL, 129, NULL, NULL, 212904),
(212905, '1.25.40.120-FF-000022', NULL, 'Farnesyl transferase alpha, isoform A', 326, NULL, NULL, 212905),
(212906, '1.10.1410.20-FF-000002', NULL, '2''-5''-oligoadenylate synthetase 3', 189, NULL, NULL, 212906),
(212907, '2.30.30.100-FF-000061', NULL, 'Small nuclear ribonucleoprotein G', 72, NULL, NULL, 212907),
(212908, '3.40.50.150-FF-001287', NULL, NULL, 307, NULL, NULL, 212908),
(212909, '2.60.120.10-FF-000300', NULL, 'Potassium channel, voltage-gated eag-related subfamily H, member 7', 108, NULL, NULL, 212909),
(212910, '3.40.30.10-FF-000998', NULL, 'Uncharacterized protein', 76, NULL, NULL, 212910),
(212911, '1.20.1070.10-FF-001858', NULL, 'Uncharacterized protein', 296, NULL, NULL, 212911),
(212912, '3.30.40.10-FF-000139', NULL, 'E3 ubiquitin-protein ligase RBBP6 isoform X1', 91, NULL, NULL, 212912),
(212913, '1.10.3520.10-FF-000002', NULL, 'Ceramide-1-phosphate transfer protein', 213, NULL, NULL, 212913),
(212914, '2.130.10.10-FF-002113', NULL, 'WD repeat-containing protein 16', 201, NULL, NULL, 212914),
(212915, '3.40.50.2300-FF-000279', NULL, 'Guanylate cyclase', 203, NULL, NULL, 212915),
(212916, '3.30.160.60-FF-001225', NULL, 'zinc finger protein 341 isoform X2', 65, NULL, NULL, 212916),
(212917, '1.10.630.10-FF-000432', NULL, 'Cytochrome P450', 160, NULL, NULL, 212917),
(212918, '3.30.70.330-FF-002264', NULL, NULL, 92, NULL, NULL, 212918),
(212919, '3.10.290.10-FF-000021', NULL, '40S ribosomal protein S9', 82, NULL, NULL, 212919),
(212920, '2.30.29.30-FF-000593', NULL, 'Adaptin ear-binding coat-associated protein 2 family protein', 122, NULL, NULL, 212920),
(212921, '1.10.2080.10-FF-000001', NULL, 'ejaculatory bulb-specific protein 3', 108, NULL, NULL, 212921),
(212922, '2.130.10.10-FF-001433', NULL, 'Lethal(2) giant larvae protein', 264, NULL, NULL, 212922),
(212923, '1.50.10.10-FF-000130', NULL, 'Uncharacterized protein', 101, NULL, NULL, 212923),
(212924, '1.20.5.170-FF-000068', NULL, 'Sodium/potassium-transporting ATPase subunit beta', 63, NULL, NULL, 212924),
(212925, '1.10.8.60-FF-000600', NULL, 'Lon protease homolog 2, peroxisomal', 93, NULL, NULL, 212925),
(212926, '3.40.50.620-FF-000490', NULL, 'U-box domain-containing protein 54', 146, NULL, NULL, 212926),
(212927, '3.40.50.300-FF-005519', NULL, 'Predicted protein', 128, NULL, NULL, 212927),
(212928, '1.20.1070.10-FF-000077', NULL, 'Melanocortin receptor 4', 283, NULL, NULL, 212928),
(212929, '1.10.560.10-FF-000050', NULL, 'Bardet-Biedl syndrome 10 protein', 134, NULL, NULL, 212929),
(212930, '3.10.290.20-FF-000024', NULL, 'SUMO-activating enzyme subunit 2', 103, NULL, NULL, 212930),
(212931, '4.10.75.10-FF-000010', NULL, 'Uncharacterized protein', 42, NULL, NULL, 212931),
(212932, '1.20.1270.60-FF-000303', NULL, 'Uncharacterized protein', 106, NULL, NULL, 212932),
(212933, '2.40.50.140-FF-001041', NULL, NULL, 128, NULL, NULL, 212933),
(212934, '1.20.1260.60-FF-000005', NULL, 'Regulator of Vps4 activity in the MVB pathway protein', 188, NULL, NULL, 212934),
(212935, '4.10.1060.10-FF-000003', NULL, 'E3 SUMO-protein ligase RanBP2', 40, NULL, NULL, 212935),
(212936, '3.30.50.10-FF-000067', NULL, 'GATA transcription factor (Ams2), putative', 114, NULL, NULL, 212936),
(212937, '1.20.120.310-FF-000020', NULL, NULL, 62, NULL, NULL, 212937),
(212938, '2.40.70.10-FF-000278', NULL, 'Aspartic peptidase domain-containing protein', 192, NULL, NULL, 212938),
(212939, '3.30.1520.10-FF-000153', NULL, 'Sorting nexin-41', 119, NULL, NULL, 212939),
(212940, '3.30.390.30-FF-000047', NULL, 'Uncharacterized protein', 100, NULL, NULL, 212940),
(212941, '3.20.20.190-FF-000022', NULL, 'Phosphoinositide phospholipase C', 326, NULL, NULL, 212941);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(212942, '3.40.190.10-FF-000518', NULL, 'Transferrin-a', 97, NULL, NULL, 212942),
(212943, '3.40.50.10880-FF-000007', NULL, 'DUF89 domain protein', 171, NULL, NULL, 212943),
(212944, '3.40.50.2300-FF-000751', NULL, NULL, 72, NULL, NULL, 212944),
(212945, '4.10.830.40-FF-000001', NULL, 'E3 ubiquitin-protein ligase TRIM9 isoform X1', 73, NULL, NULL, 212945),
(212946, '3.10.20.90-FF-000033', NULL, 'afadin isoform X1', 114, NULL, NULL, 212946),
(212947, '1.10.510.10-FF-003548', NULL, NULL, 231, NULL, NULL, 212947),
(212948, '1.10.8.60-FF-000230', NULL, 'DNA polymerase epsilon subunit', 70, NULL, NULL, 212948),
(212949, '2.30.230.10-FF-000034', NULL, 'Uncharacterized protein', 183, NULL, NULL, 212949),
(212950, '3.40.50.150-FF-001080', NULL, NULL, 237, NULL, NULL, 212950),
(212951, '2.10.110.10-FF-000277', NULL, 'Uncharacterized protein', 71, NULL, NULL, 212951),
(212952, '1.10.3380.10-FF-000013', NULL, 'DEAD/DEAH box helicase, putative', 124, NULL, NULL, 212952),
(212953, '1.20.120.1240-FF-000064', NULL, 'Dynamin-2A', 167, NULL, NULL, 212953),
(212954, '2.60.40.10-FF-005480', NULL, NULL, 127, NULL, NULL, 212954),
(212955, '1.20.58.60-FF-000593', NULL, 'Dystrophin', 196, NULL, NULL, 212955),
(212956, '3.60.40.10-FF-000205', NULL, 'AGAP002147-PA', 232, NULL, NULL, 212956),
(212957, '2.30.30.490-FF-000014', NULL, 'trinucleotide repeat-containing gene 18 protein-like', 203, NULL, NULL, 212957),
(212958, '3.40.50.720-FF-000738', NULL, 'Galactose/lactose metabolism regulatory protein GAL80', 186, NULL, NULL, 212958),
(212959, '2.60.40.10-FF-004991', NULL, NULL, 108, NULL, NULL, 212959),
(212960, '3.30.70.3030-FF-000017', NULL, 'Nucleolar protein 6', 130, NULL, NULL, 212960),
(212961, '2.130.10.10-FF-005811', NULL, 'Plexin B, putative', 81, NULL, NULL, 212961),
(212962, '1.10.880.10-FF-000006', NULL, 'Uncharacterized protein', 65, NULL, NULL, 212962),
(212963, '4.10.240.10-FF-000183', NULL, 'Zcf10p', 87, NULL, NULL, 212963),
(212964, '2.60.40.10-FF-000949', NULL, 'vascular endothelial growth factor receptor 3', 130, NULL, NULL, 212964),
(212965, '3.80.10.10-FF-000747', NULL, 'volume-regulated anion channel subunit LRRC8E', 172, NULL, NULL, 212965),
(212966, '2.60.200.40-FF-000040', NULL, 'Ceramide kinase-like isoform 29', 122, NULL, NULL, 212966),
(212967, '3.40.50.2020-FF-000043', NULL, 'Ribose-phosphate pyrophosphokinase 1', 91, NULL, NULL, 212967),
(212968, '3.80.10.10-FF-002647', NULL, 'Transforming growth factor beta activator LRRC33', 142, NULL, NULL, 212968),
(212969, '3.30.420.40-FF-000975', NULL, 'Actin-related protein 8', 144, NULL, NULL, 212969),
(212970, '3.30.70.2740-FF-000014', NULL, 'D-2-hydroxyglutarate dehydrogenase, mitochondrial', 80, NULL, NULL, 212970),
(212971, '3.20.20.70-FF-000162', NULL, 'tRNA-dihydrouridine(16/17) synthase [NAD(P)(+)]-like', 236, NULL, NULL, 212971),
(212972, '1.20.1250.20-FF-000178', NULL, 'Protein NRT1/ PTR FAMILY 4.4', 527, NULL, NULL, 212972),
(212973, '3.30.1370.10-FF-000219', NULL, 'RNA-binding protein rnc1', 90, NULL, NULL, 212973),
(212974, '1.10.3390.10-FF-000002', NULL, 'Tegument protein BLRF2', 100, NULL, NULL, 212974),
(212975, '1.25.40.10-FF-003130', NULL, 'Os03g0283500 protein', 153, NULL, NULL, 212975),
(212976, '2.30.29.30-FF-000267', NULL, 'PH and SEC7 domain-containing protein 4', 126, NULL, NULL, 212976),
(212977, '3.80.10.10-FF-004446', NULL, 'Predicted protein', 116, NULL, NULL, 212977),
(212978, '3.40.850.10-FF-000518', NULL, 'Kinesin-like protein', 115, NULL, NULL, 212978),
(212979, '3.20.20.140-FF-000147', NULL, 'AMP deaminase', 370, NULL, NULL, 212979),
(212980, '3.30.260.10-FF-000088', NULL, NULL, 104, NULL, NULL, 212980),
(212981, '2.20.70.10-FF-000088', NULL, 'WW domain-binding protein 4', 75, NULL, NULL, 212981),
(212982, '3.30.160.60-FF-001534', NULL, 'zinc finger protein 227 isoform X1', 30, NULL, NULL, 212982),
(212983, '2.120.10.30-FF-000299', NULL, 'Uncharacterized protein', 269, NULL, NULL, 212983),
(212984, '2.60.40.10-FF-005154', NULL, NULL, 95, NULL, NULL, 212984),
(212985, '3.40.850.10-FF-000182', NULL, 'Hypothetical_protein_-_conserved', 151, NULL, NULL, 212985);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(212986, '1.25.10.10-FF-002200', NULL, 'AGAP002597-PA', 440, NULL, NULL, 212986),
(212987, '3.80.10.10-FF-000523', NULL, 'F-box/LRR-repeat protein 7', 85, NULL, NULL, 212987),
(212988, '1.25.40.20-FF-001525', NULL, 'Kinase, NEK-frag', 107, NULL, NULL, 212988),
(212989, '3.40.50.10190-FF-000340', NULL, 'Pescadillo homolog', 37, NULL, NULL, 212989),
(212990, '3.30.160.60-FF-005457', NULL, NULL, 35, NULL, NULL, 212990),
(212991, '1.25.40.10-FF-004748', NULL, 'Uncharacterized protein', 68, NULL, NULL, 212991),
(212992, '2.60.40.10-FF-003546', NULL, NULL, 107, NULL, NULL, 212992),
(212993, '3.40.50.2300-FF-001122', NULL, NULL, 199, NULL, NULL, 212993),
(212994, '1.25.10.10-FF-001048', NULL, 'WGS project CABT00000000 data, contig 2.10', 197, NULL, NULL, 212994),
(212995, '1.10.260.40-FF-000047', NULL, 'One cut domain family member', 77, NULL, NULL, 212995),
(212996, '1.10.1580.10-FF-000011', NULL, 'Nucleolar GTP-binding protein 2', 90, NULL, NULL, 212996),
(212997, '1.10.3380.10-FF-000030', NULL, 'Pre-mRNA-splicing helicase BRR2', 141, NULL, NULL, 212997),
(212998, '2.40.50.140-FF-000861', NULL, NULL, 92, NULL, NULL, 212998),
(212999, '1.10.10.540-FF-000005', NULL, 'Related to RAD23-nucleotide excision repair protein (Ubiquitin-like protein)', 51, NULL, NULL, 212999),
(213000, '1.25.40.120-FF-000038', NULL, 'WGS project CABT00000000 data, contig 2.3', 111, NULL, NULL, 213000),
(213001, '3.40.33.10-FF-000083', NULL, 'Predicted protein', 157, NULL, NULL, 213001),
(213002, '3.40.1110.10-FF-000462', NULL, NULL, 180, NULL, NULL, 213002),
(213003, '3.40.50.1000-FF-000788', NULL, NULL, 54, NULL, NULL, 213003),
(213004, '3.40.50.720-FF-001020', NULL, 'Putative D-isomer specific 2-hydroxyacid dehydrogenase family', 187, NULL, NULL, 213004),
(213005, '3.80.10.10-FF-003749', NULL, 'Uncharacterized protein', 126, NULL, NULL, 213005),
(213006, '3.90.190.10-FF-000248', NULL, 'Uncharacterized protein', 156, NULL, NULL, 213006),
(213007, '1.25.10.10-FF-003302', NULL, 'Uncharacterized protein', 173, NULL, NULL, 213007),
(213008, '3.40.20.10-FF-000132', NULL, 'Uncharacterized protein', 162, NULL, NULL, 213008),
(213009, '2.30.29.30-FF-000621', NULL, 'NECAP endocytosis-associated 1', 69, NULL, NULL, 213009),
(213010, '3.30.160.20-FF-000044', NULL, 'Uncharacterized protein, isoform I', 83, NULL, NULL, 213010),
(213011, '3.40.50.12710-FF-000034', NULL, 'Protein arginine methyltransferase NDUFAF7', 182, NULL, NULL, 213011),
(213012, '3.30.1300.30-FF-000002', NULL, 'Type II secretion system protein GspI', 83, NULL, NULL, 213012),
(213013, '3.30.300.30-FF-000036', NULL, 'Acetyl-CoA synthetase, putative', 131, NULL, NULL, 213013),
(213014, '1.20.58.1610-FF-000004', NULL, 'NADH-quinone oxidoreductase subunit A', 118, NULL, NULL, 213014),
(213015, '3.40.50.300-FF-001484', NULL, 'ABC transporter ATP-binding protein', 252, NULL, NULL, 213015),
(213016, '3.40.50.1010-FF-000206', NULL, NULL, 120, NULL, NULL, 213016),
(213017, '3.30.1360.40-FF-000014', NULL, 'DNA gyrase subunit A', 103, NULL, NULL, 213017),
(213018, '3.30.300.20-FF-000033', NULL, 'GTPase Era, putative', 97, NULL, NULL, 213018),
(213019, '3.40.50.80-FF-000183', NULL, 'Ferric-chelate reductase, putative (AFU_orthologue AFUA_6G13750)', 218, NULL, NULL, 213019),
(213020, '3.30.460.10-FF-000070', NULL, 'Related to TRF4-topoisomerase I-related protein', 111, NULL, NULL, 213020),
(213021, '1.10.10.60-FF-000579', NULL, 'Homeodomain-like transcriptional regulator', 83, NULL, NULL, 213021),
(213022, '2.40.128.20-FF-000055', NULL, 'Nitrophorin-7', 184, NULL, NULL, 213022),
(213023, '1.10.8.60-FF-000128', NULL, 'Cell division control protein 48 homolog C', 84, NULL, NULL, 213023),
(213024, '1.25.10.10-FF-003274', NULL, 'Serine/threonine-protein kinase TOR', 201, NULL, NULL, 213024),
(213025, '3.30.1740.10-FF-000017', NULL, 'DNA repair protein rhp16, putative', 135, NULL, NULL, 213025),
(213026, '1.25.10.10-FF-001374', NULL, 'Uncharacterized protein', 938, NULL, NULL, 213026),
(213027, '1.10.3080.10-FF-000001', NULL, 'Chloride channel protein', 492, NULL, NULL, 213027),
(213028, '3.40.1190.20-FF-000239', NULL, NULL, 97, NULL, NULL, 213028);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(213029, '3.40.1190.10-FF-000012', NULL, 'Dihydrofolate synthetase', 306, NULL, NULL, 213029),
(213030, '3.20.20.80-FF-000165', NULL, 'Cell wall glucanase (Scw11)', 96, NULL, NULL, 213030),
(213031, '3.80.10.10-FF-001849', NULL, 'Receptor-like protein kinase 2 isoform A', 91, NULL, NULL, 213031),
(213032, '3.30.300.10-FF-000030', NULL, 'Methionine S-adenosyl transferase', 118, NULL, NULL, 213032),
(213033, '3.40.50.300-FF-003384', NULL, 'DNA ligase-associated DEXH box helicase', 148, NULL, NULL, 213033),
(213034, '3.50.30.30-FF-000104', NULL, 'Peptide hydrolase', 128, NULL, NULL, 213034),
(213035, '3.30.450.20-FF-000471', NULL, 'Two-component hybrid sensor and regulator', 132, NULL, NULL, 213035),
(213036, '1.20.900.10-FF-000097', NULL, 'MKIAA1209 protein', 139, NULL, NULL, 213036),
(213037, '3.20.20.80-FF-000827', NULL, 'Predicted protein', 53, NULL, NULL, 213037),
(213038, '1.10.238.10-FF-000689', NULL, 'Phosphoinositide phospholipase C', 77, NULL, NULL, 213038),
(213039, '3.30.70.330-FF-000673', NULL, 'Os07g0663300 protein', 96, NULL, NULL, 213039),
(213040, '1.25.40.10-FF-005030', NULL, 'Uncharacterized protein', 157, NULL, NULL, 213040),
(213041, '3.20.20.80-FF-000311', NULL, 'Chitinase', 200, NULL, NULL, 213041),
(213042, '3.40.1190.20-FF-000015', NULL, 'Hydroxyethylthiazole kinase', 265, NULL, NULL, 213042),
(213043, '2.10.50.10-FF-000053', NULL, 'Predicted protein', 60, NULL, NULL, 213043),
(213044, '3.40.50.20-FF-000081', NULL, 'Biotin carboxylase', 109, NULL, NULL, 213044),
(213045, '2.40.50.40-FF-000128', NULL, 'Histone-lysine N-methyltransferase SUV39H1-A', 59, NULL, NULL, 213045),
(213046, '2.60.40.200-FF-000001', NULL, 'Superoxide dismutase [Cu-Zn]', 154, NULL, NULL, 213046),
(213047, '3.30.40.10-FF-001145', NULL, 'E3 ubiquitin-protein ligase PEP5', 116, NULL, NULL, 213047),
(213048, '3.90.810.10-FF-000038', NULL, NULL, 76, NULL, NULL, 213048),
(213049, '3.30.70.330-FF-001162', NULL, 'RNA recognition motif domain containing protein', 126, NULL, NULL, 213049),
(213050, '3.40.440.10-FF-000015', NULL, NULL, 80, NULL, NULL, 213050),
(213051, '3.40.50.300-FF-007762', NULL, 'Uncharacterized protein', 70, NULL, NULL, 213051),
(213052, '2.10.60.10-FF-000008', NULL, 'Serine/threonine-protein kinase receptor', 87, NULL, NULL, 213052),
(213053, '3.20.20.80-FF-000620', NULL, 'Uncharacterized protein', 144, NULL, NULL, 213053),
(213054, '3.10.580.10-FF-000105', NULL, 'Inorganic pyrophosphatase', 112, NULL, NULL, 213054),
(213055, '1.10.287.130-FF-000237', NULL, 'Phytochrome-like protein cph1', 94, NULL, NULL, 213055),
(213056, '1.10.287.110-FF-000231', NULL, 'Molecular chaperone, putative', 62, NULL, NULL, 213056),
(213057, '1.25.40.20-FF-001188', NULL, 'Uncharacterized protein', 98, NULL, NULL, 213057),
(213058, '2.60.420.10-FF-000019', NULL, 'Uncharacterized protein', 74, NULL, NULL, 213058),
(213059, '1.10.20.10-FF-000031', NULL, 'transcription initiation factor TFIID subunit 8 isoform X2', 97, NULL, NULL, 213059),
(213060, '3.30.160.60-FF-000106', NULL, 'B-cell lymphoma/leukemia 11A isoform X2', 32, NULL, NULL, 213060),
(213061, '3.40.50.800-FF-000111', NULL, 'Threonyl-tRNA synthetase', 73, NULL, NULL, 213061),
(213062, '1.25.10.10-FF-001683', NULL, 'Pumilio/PUF RNA binding protein 9', 292, NULL, NULL, 213062),
(213063, '3.30.60.270-FF-000012', NULL, 'Sortilin', 69, NULL, NULL, 213063),
(213064, '2.40.50.140-FF-001024', NULL, NULL, 47, NULL, NULL, 213064),
(213065, '1.20.58.400-FF-000036', NULL, 'vesicle transport through interaction with t-SNAREs homolog 1B isoform X1', 91, NULL, NULL, 213065),
(213066, '1.25.40.20-FF-001851', NULL, 'Kinase, NEK', 138, NULL, NULL, 213066),
(213067, '3.40.50.300-FF-007436', NULL, 'Putative RNA helicase armi-like Protein', 256, NULL, NULL, 213067),
(213068, '3.40.50.300-FF-005536', NULL, 'Elongation factor G, chloroplastic', 63, NULL, NULL, 213068),
(213069, '3.40.50.11660-FF-000034', NULL, NULL, 48, NULL, NULL, 213069),
(213070, '1.20.1250.20-FF-001004', NULL, 'Drug resistance transporter, EmrB/QacA subfamily', 174, NULL, NULL, 213070),
(213071, '3.90.640.10-FF-000238', NULL, 'Uncharacterized protein', 35, NULL, NULL, 213071);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(213072, '3.40.50.300-FF-001613', NULL, 'DNA primase/helicase, helicase subunit', 281, NULL, NULL, 213072),
(213073, '3.10.290.20-FF-000007', NULL, 'SUMO-activating enzyme subunit 2', 51, NULL, NULL, 213073),
(213074, '3.40.50.80-FF-000166', NULL, 'Uncharacterized protein', 132, NULL, NULL, 213074),
(213075, '3.30.70.2640-FF-000001', NULL, 'RNA-directed RNA polymerase L', 85, NULL, NULL, 213075),
(213076, '1.25.40.10-FF-001185', NULL, 'H0315A08.2 protein', 99, NULL, NULL, 213076),
(213077, '3.90.870.10-FF-000014', NULL, 'Sua5 YciO YrdC YwlC family protein', 211, NULL, NULL, 213077),
(213078, '1.25.40.10-FF-000679', NULL, 'Pentatricopeptide repeat-containing protein At5g03800', 133, NULL, NULL, 213078),
(213079, '3.30.70.330-FF-001471', NULL, NULL, 90, NULL, NULL, 213079),
(213080, '1.20.1250.20-FF-000515', NULL, 'Uncharacterized protein, isoform B', 369, NULL, NULL, 213080),
(213081, '4.10.280.110-FF-000005', NULL, 'Pre-mRNA-splicing factor 18', 77, NULL, NULL, 213081),
(213082, '3.60.10.10-FF-000350', NULL, 'Protein CBG05397', 169, NULL, NULL, 213082),
(213083, '2.30.30.190-FF-000031', NULL, NULL, 89, NULL, NULL, 213083),
(213084, '2.60.40.10-FF-005463', NULL, NULL, 104, NULL, NULL, 213084),
(213085, '3.30.40.10-FF-002247', NULL, 'Predicted protein', 60, NULL, NULL, 213085),
(213086, '3.30.1520.10-FF-000136', NULL, 'Chromosome 19, whole genome shotgun sequence', 159, NULL, NULL, 213086),
(213087, '3.40.50.150-FF-001742', NULL, NULL, 250, NULL, NULL, 213087),
(213088, '1.10.10.10-FF-000103', NULL, 'Two-component system response regulator NarL', 87, NULL, NULL, 213088),
(213089, '2.30.230.10-FF-000017', NULL, 'Uncharacterized protein VTG4', 305, NULL, NULL, 213089),
(213090, '1.10.510.10-FF-003565', NULL, NULL, 222, NULL, NULL, 213090),
(213091, '3.90.830.10-FF-000023', NULL, 'Syntaxin-binding protein 2', 51, NULL, NULL, 213091),
(213092, '3.40.30.10-FF-000060', NULL, 'Glutaredoxin-like protein nrdH', 81, NULL, NULL, 213092),
(213093, '3.50.30.30-FF-000121', NULL, 'Uncharacterized protein', 56, NULL, NULL, 213093),
(213094, '3.30.70.360-FF-000069', NULL, 'Os07g0249900 protein', 56, NULL, NULL, 213094),
(213095, '1.10.150.170-FF-000014', NULL, NULL, 107, NULL, NULL, 213095),
(213096, '3.60.10.10-FF-000041', NULL, 'DNA-(apurinic or apyrimidinic site) lyase', 289, NULL, NULL, 213096),
(213097, '1.25.10.10-FF-000868', NULL, 'HEAT repeat-containing protein 5A', 387, NULL, NULL, 213097),
(213098, '3.40.1190.20-FF-000032', NULL, 'Pseudouridine kinase', 310, NULL, NULL, 213098),
(213099, '3.40.50.620-FF-000164', NULL, 'Envelope biogenesis factor ElyC', 135, NULL, NULL, 213099),
(213100, '2.10.110.10-FF-000294', NULL, 'Probable Rho-type GTPase-activating protein 4', 70, NULL, NULL, 213100),
(213101, '1.20.140.10-FF-000033', NULL, 'Acyl-coenzyme A oxidase', 166, NULL, NULL, 213101),
(213102, '2.30.29.30-FF-001110', NULL, 'Uncharacterized protein', 141, NULL, NULL, 213102),
(213103, '3.40.50.200-FF-000009', NULL, 'tripeptidyl-peptidase 2 isoform X1', 85, NULL, NULL, 213103),
(213104, '3.30.780.10-FF-000009', NULL, '39S ribosomal protein L49, mitochondrial', 134, NULL, NULL, 213104),
(213105, '2.60.40.10-FF-004974', NULL, NULL, 110, NULL, NULL, 213105),
(213106, '3.30.160.60-FF-001079', NULL, 'zinc finger protein ZFPM1 isoform X2', 59, NULL, NULL, 213106),
(213107, '3.30.70.330-FF-000656', NULL, 'Nuclear transport factor 2 family protein', 140, NULL, NULL, 213107),
(213108, '1.25.10.10-FF-002768', NULL, 'Exportin 6', 593, NULL, NULL, 213108),
(213109, '2.100.10.50-FF-000002', NULL, 'Multivesicular body subunit 12B', 152, NULL, NULL, 213109),
(213110, '3.30.420.10-FF-000640', NULL, NULL, 148, NULL, NULL, 213110),
(213111, '3.30.230.40-FF-000011', NULL, 'Imidazoleglycerol-phosphate dehydratase', 105, NULL, NULL, 213111),
(213112, '3.90.660.10-FF-000094', NULL, NULL, 140, NULL, NULL, 213112),
(213113, '3.30.70.330-FF-002808', NULL, NULL, 94, NULL, NULL, 213113),
(213114, '1.10.10.10-FF-001205', NULL, 'Transcriptional regulatory protein', 88, NULL, NULL, 213114),
(213115, '3.30.470.10-FF-000025', NULL, '4-amino-4-deoxychorismate lyase', 75, NULL, NULL, 213115);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(213116, '2.60.110.10-FF-000018', NULL, 'Uncharacterized protein', 109, NULL, NULL, 213116),
(213117, '3.30.160.60-FF-006300', NULL, NULL, 77, NULL, NULL, 213117),
(213118, '1.20.1070.10-FF-000532', NULL, 'Odorant receptor S3', 120, NULL, NULL, 213118),
(213119, '3.40.50.970-FF-000038', NULL, '2-hydroxyacyl-CoA lyase 1 isoform X1', 185, NULL, NULL, 213119),
(213120, '3.30.710.10-FF-000387', NULL, 'Uncharacterized protein', 66, NULL, NULL, 213120),
(213121, '3.30.470.20-FF-000028', NULL, 'Methylcrotonoyl-CoA carboxylase subunit alpha, mitochondrial', 456, NULL, NULL, 213121),
(213122, '4.10.1260.10-FF-000001', NULL, 'Internal scaffolding protein', 68, NULL, NULL, 213122),
(213123, '3.30.420.40-FF-000958', NULL, 'Uncharacterized protein', 32, NULL, NULL, 213123),
(213124, '2.60.40.10-FF-003254', NULL, 'Nectin-1', 111, NULL, NULL, 213124),
(213125, '3.30.70.330-FF-000347', NULL, 'Zinc finger CCCH domain-containing protein 40', 97, NULL, NULL, 213125),
(213126, '3.40.50.300-FF-006947', NULL, 'Predicted protein', 226, NULL, NULL, 213126),
(213127, '3.40.50.2000-FF-000296', NULL, 'Glucosyltransferase 3', 157, NULL, NULL, 213127),
(213128, '3.30.710.10-FF-000078', NULL, 'BTB/POZ domain-containing protein 2', 110, NULL, NULL, 213128),
(213129, '3.20.20.140-FF-000164', NULL, 'Amidohydrolase 2', 347, NULL, NULL, 213129),
(213130, '2.60.40.10-FF-005715', NULL, NULL, 44, NULL, NULL, 213130),
(213131, '1.20.1070.10-FF-000739', NULL, 'Growth hormone-releasing hormone receptor short isoform', 141, NULL, NULL, 213131),
(213132, '3.40.50.620-FF-000473', NULL, 'Cytidylyltransferase, putative', 149, NULL, NULL, 213132),
(213133, '2.10.25.10-FF-000214', NULL, 'Multiple epidermal growth factor-like domains 8', 49, NULL, NULL, 213133),
(213134, '3.30.70.141-FF-000038', NULL, NULL, 176, NULL, NULL, 213134),
(213135, '3.40.1640.10-FF-000002', NULL, 'DUF1445 domain protein', 133, NULL, NULL, 213135),
(213136, '1.25.40.320-FF-000008', NULL, 'Uncharacterized protein', 173, NULL, NULL, 213136),
(213137, '2.60.40.60-FF-000211', NULL, 'Dachsous cadherin-related 2', 108, NULL, NULL, 213137),
(213138, '3.80.10.10-FF-000540', NULL, 'Insulin-like growth factor-binding protein complex acid labile subunit', 257, NULL, NULL, 213138),
(213139, '3.20.20.80-FF-000491', NULL, 'Predicted protein', 19, NULL, NULL, 213139),
(213140, '1.10.132.30-FF-000005', NULL, 'DNA-directed RNA polymerase subunit', 164, NULL, NULL, 213140),
(213141, '3.30.450.20-FF-000145', NULL, 'AGAP009664-PA', 121, NULL, NULL, 213141),
(213142, '2.40.30.160-FF-000008', NULL, 'Aminomethyltransferase family protein', 112, NULL, NULL, 213142),
(213143, '1.10.287.810-FF-000020', NULL, NULL, 64, NULL, NULL, 213143),
(213144, '3.60.40.10-FF-000059', NULL, 'Protein phosphatase 2C 32', 406, NULL, NULL, 213144),
(213145, '2.10.25.10-FF-000523', NULL, 'Delta/notch like EGF repeat containing', 35, NULL, NULL, 213145),
(213146, '3.10.290.10-FF-000004', NULL, '40s ribosomal protein s9', 58, NULL, NULL, 213146),
(213147, '1.20.1740.10-FF-000049', NULL, 'Solute carrier family 12 (potassium/chloride transporter), member 4', 224, NULL, NULL, 213147),
(213148, '1.20.1080.10-FF-000049', NULL, 'Aquaporin-like protein 2', 111, NULL, NULL, 213148),
(213149, '1.10.10.10-FF-001514', NULL, 'DNA-binding response regulator', 94, NULL, NULL, 213149),
(213150, '1.10.10.10-FF-002003', NULL, 'Uncharacterized protein', 132, NULL, NULL, 213150),
(213151, '2.60.40.10-FF-003563', NULL, NULL, 66, NULL, NULL, 213151),
(213152, '3.30.420.40-FF-000649', NULL, 'Chromatin remodeling complex subunit (Arp5), putative (AFU_orthologue AFUA_4G03020)', 28, NULL, NULL, 213152),
(213153, '3.30.70.360-FF-000070', NULL, 'Uncharacterized protein', 36, NULL, NULL, 213153),
(213154, '3.60.10.10-FF-000349', NULL, 'Os01g0814200 protein', 170, NULL, NULL, 213154),
(213155, '3.90.25.10-FF-000039', NULL, 'UDP-glucose 4-epimerase GalE', 98, NULL, NULL, 213155),
(213156, '1.20.1250.20-FF-000841', NULL, 'Major facilitator superfamily domain-containing protein', 198, NULL, NULL, 213156),
(213157, '1.50.40.10-FF-000502', NULL, 'Uncharacterized protein', 259, NULL, NULL, 213157);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(213158, '1.10.510.10-FF-001339', NULL, 'CAMK family protein kinase', 343, NULL, NULL, 213158),
(213159, '3.20.20.190-FF-000038', NULL, 'Uncharacterized protein, isoform C', 296, NULL, NULL, 213159),
(213160, '3.40.50.360-FF-000052', NULL, 'NAD(P)H-dependent FMN reductase LOT6', 184, NULL, NULL, 213160),
(213161, '2.170.300.10-FF-000057', NULL, 'Uncharacterized protein', 72, NULL, NULL, 213161),
(213162, '3.30.1780.10-FF-000008', NULL, 'Ornithine cyclodeaminase', 106, NULL, NULL, 213162),
(213163, '1.10.510.10-FF-001295', NULL, 'Serine/threonine-protein kinase kin-29', 342, NULL, NULL, 213163),
(213164, '3.30.1360.40-FF-000031', NULL, 'Ribosome recycling factor', 82, NULL, NULL, 213164),
(213165, '3.30.160.60-FF-005575', NULL, NULL, 41, NULL, NULL, 213165),
(213166, '3.30.300.20-FF-000016', NULL, 'GTPase Era, mitochondrial isoform 1', 98, NULL, NULL, 213166),
(213167, '3.40.390.10-FF-000264', NULL, NULL, 269, NULL, NULL, 213167),
(213168, '3.50.50.60-FF-001137', NULL, 'Predicted protein', 107, NULL, NULL, 213168),
(213169, '3.40.50.1820-FF-000707', NULL, 'AGAP002090-PA-like protein', 177, NULL, NULL, 213169),
(213170, '1.20.1440.100-FF-000002', NULL, 'HAD hydrolase, family IF', 74, NULL, NULL, 213170),
(213171, '1.20.1070.10-FF-000094', NULL, 'Vasopressin V1a receptor', 346, NULL, NULL, 213171),
(213172, '3.40.50.960-FF-000018', NULL, '6,7-dimethyl-8-ribityllumazine synthase', 69, NULL, NULL, 213172),
(213173, '3.30.300.30-FF-000019', NULL, 'Phenylacetate-coenzyme A ligase', 106, NULL, NULL, 213173),
(213174, '1.25.40.20-FF-001643', NULL, 'E3 ubiquitin-protein ligase HOS1', 93, NULL, NULL, 213174),
(213175, '3.30.710.10-FF-000516', NULL, 'Uncharacterized protein', 54, NULL, NULL, 213175),
(213176, '1.25.40.10-FF-004866', NULL, 'Diguanylate cyclase', 276, NULL, NULL, 213176),
(213177, '2.60.120.260-FF-000629', NULL, 'Endo-1,4-beta-xylanase', 119, NULL, NULL, 213177),
(213178, '3.20.20.100-FF-000068', NULL, 'Aldo-keto reductase family 1 member B10', 316, NULL, NULL, 213178),
(213179, '3.40.50.620-FF-000708', NULL, 'ExsB family protein', 223, NULL, NULL, 213179),
(213180, '3.10.350.10-FF-000077', NULL, 'LysM peptidoglycan-binding domain-containing protein', 55, NULL, NULL, 213180),
(213181, '1.25.40.10-FF-001640', NULL, 'Pentatricopeptide repeat protein PPR986-12', 144, NULL, NULL, 213181),
(213182, '3.90.530.10-FF-000011', NULL, NULL, 80, NULL, NULL, 213182),
(213183, '3.40.718.10-FF-000037', NULL, 'CG3483 protein', 336, NULL, NULL, 213183),
(213184, '3.30.300.10-FF-000013', NULL, 'GMP synthase (Glutamine-hydrolyzing)', 129, NULL, NULL, 213184),
(213185, '1.10.1520.10-FF-000120', NULL, 'Uncharacterized protein', 103, NULL, NULL, 213185),
(213186, '3.30.465.10-FF-000058', NULL, 'Alkyldihydroxyacetonephosphate synthase', 230, NULL, NULL, 213186),
(213187, '4.10.410.20-FF-000014', NULL, 'Endoribonuclease-like protein', 41, NULL, NULL, 213187),
(213188, '3.30.70.660-FF-000086', NULL, 'tRNA pseudouridine synthase', 86, NULL, NULL, 213188),
(213189, '3.80.10.10-FF-004137', NULL, 'Tyrosine-protein kinase receptor', 109, NULL, NULL, 213189),
(213190, '3.40.50.2000-FF-000751', NULL, 'Protein CBR-UGT-2', 103, NULL, NULL, 213190),
(213191, '1.10.472.10-FF-000688', NULL, 'Os07g0504500 protein', 64, NULL, NULL, 213191),
(213192, '3.40.570.10-FF-000036', NULL, 'Uncharacterized protein', 186, NULL, NULL, 213192),
(213193, '1.25.10.10-FF-000559', NULL, 'Msn5p', 1135, NULL, NULL, 213193),
(213194, '4.10.410.10-FF-000011', NULL, 'Tissue factor pathway inhibitor', 60, NULL, NULL, 213194),
(213195, '1.20.5.110-FF-000202', NULL, 'Uncharacterized protein', 87, NULL, NULL, 213195),
(213196, '2.30.30.140-FF-000140', NULL, 'MRG (Mortality factor-Related Gene) related', 78, NULL, NULL, 213196),
(213197, '3.30.70.330-FF-002781', NULL, NULL, 65, NULL, NULL, 213197),
(213198, '2.60.260.20-FF-000167', NULL, 'Uncharacterized protein', 50, NULL, NULL, 213198),
(213199, '3.10.50.40-FF-000071', NULL, 'Peptidylprolyl isomerase', 120, NULL, NULL, 213199),
(213200, '3.40.50.300-FF-003367', NULL, 'ATP-dependent DNA helicase PIF1', 168, NULL, NULL, 213200);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(213201, '3.30.70.1730-FF-000048', NULL, '50S ribosomal protein L10', 128, NULL, NULL, 213201),
(213202, '3.30.70.330-FF-001145', NULL, 'AGAP009570-PA', 159, NULL, NULL, 213202),
(213203, '3.40.50.720-FF-000755', NULL, 'F420-dependent NADP reductase', 221, NULL, NULL, 213203),
(213204, '1.10.1040.10-FF-000072', NULL, '2-hydroxy-3-oxopropionate reductase', 128, NULL, NULL, 213204),
(213205, '3.40.50.1220-FF-000062', NULL, 'NAD-dependent deacetylase sir2E', 114, NULL, NULL, 213205),
(213206, '3.90.1750.20-FF-000018', NULL, NULL, 190, NULL, NULL, 213206),
(213207, '1.25.40.10-FF-001213', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 204, NULL, NULL, 213207),
(213208, '1.25.40.20-FF-000215', NULL, 'ankyrin repeat domain-containing protein 49', 136, NULL, NULL, 213208),
(213209, '1.25.10.10-FF-001812', NULL, 'DnaJ-like protein subfamily C member 13', 247, NULL, NULL, 213209),
(213210, '1.25.40.710-FF-000002', NULL, 'Tripeptidyl-peptidase 2', 239, NULL, NULL, 213210),
(213211, '3.40.50.300-FF-005621', NULL, 'YALI0A04279p', 150, NULL, NULL, 213211),
(213212, '3.30.160.60-FF-004968', NULL, NULL, 84, NULL, NULL, 213212),
(213213, '3.40.190.10-FF-000962', NULL, 'Glutamate receptor, ionotropic, delta 1a', 36, NULL, NULL, 213213),
(213214, '1.10.2000.10-FF-000007', NULL, 'Frizzled class receptor 10', 125, NULL, NULL, 213214),
(213215, '2.30.29.30-FF-001301', NULL, 'ESCRT-II subunit protein', 81, NULL, NULL, 213215),
(213216, '3.40.605.10-FF-000073', NULL, 'Uncharacterized protein', 62, NULL, NULL, 213216),
(213217, '1.20.58.90-FF-000034', NULL, NULL, 76, NULL, NULL, 213217),
(213218, '1.10.287.70-FF-000292', NULL, 'Calcium transporter 2', 134, NULL, NULL, 213218),
(213219, '3.40.50.1260-FF-000023', NULL, 'Phosphoglycerate kinase', 223, NULL, NULL, 213219),
(213220, '2.60.120.290-FF-000161', NULL, 'Cubilin homolog', 137, NULL, NULL, 213220),
(213221, '3.60.40.10-FF-000385', NULL, 'Uncharacterized protein', 143, NULL, NULL, 213221),
(213222, '3.40.50.150-FF-000899', NULL, 'tRNA (guanine(37)-N1)/4-demethylwyosine(37)-methyltransferase Taw22', 187, NULL, NULL, 213222),
(213223, '3.60.15.10-FF-000237', NULL, 'Uncharacterized protein', 167, NULL, NULL, 213223),
(213224, '2.60.40.10-FF-001972', NULL, 'Fibronectin type III domain containing 3Ba', 92, NULL, NULL, 213224),
(213225, '3.40.30.10-FF-000430', NULL, 'Disulfide oxidoreductase', 204, NULL, NULL, 213225),
(213226, '1.25.40.420-FF-000022', NULL, 'Calicin', 120, NULL, NULL, 213226),
(213227, '2.70.98.30-FF-000003', NULL, 'Alpha-mannosidase', 261, NULL, NULL, 213227),
(213228, '3.40.50.300-FF-003266', NULL, 'Guanylate kinase', 115, NULL, NULL, 213228),
(213229, '3.40.1110.10-FF-000344', NULL, NULL, 86, NULL, NULL, 213229),
(213230, '3.10.100.10-FF-000368', NULL, NULL, 143, NULL, NULL, 213230),
(213231, '1.10.720.30-FF-000063', NULL, 'Uncharacterized protein', 49, NULL, NULL, 213231),
(213232, '2.30.42.10-FF-000562', NULL, NULL, 47, NULL, NULL, 213232),
(213233, '3.30.40.10-FF-002264', NULL, 'Serine/threonine-protein phosphatase', 55, NULL, NULL, 213233),
(213234, '1.20.5.900-FF-000001', NULL, 'T-cell surface glycoprotein CD4', 69, NULL, NULL, 213234),
(213235, '2.60.40.10-FF-002866', NULL, 'Si:dkey-102c8.2', 88, NULL, NULL, 213235),
(213236, '3.30.40.10-FF-001600', NULL, 'Uncharacterized protein', 66, NULL, NULL, 213236),
(213237, '1.10.640.10-FF-000017', NULL, 'Double peroxidase', 183, NULL, NULL, 213237),
(213238, '3.30.1520.10-FF-000119', NULL, 'Probable serine/threonine-protein kinase DDB_G0272282', 115, NULL, NULL, 213238),
(213239, '3.40.50.1820-FF-000562', NULL, 'Surfactin synthase thioesterase subunit', 243, NULL, NULL, 213239),
(213240, '2.70.98.40-FF-000006', NULL, 'Cellobionic acid phosphorylase', 303, NULL, NULL, 213240),
(213241, '3.90.199.10-FF-000004', NULL, 'DNA topoisomerase II medium subunit', 178, NULL, NULL, 213241),
(213242, '1.20.120.1080-FF-000055', NULL, 'ATP-dependent helicase HrpB', 110, NULL, NULL, 213242),
(213243, '3.30.160.60-FF-005474', NULL, NULL, 57, NULL, NULL, 213243),
(213244, '1.25.40.10-FF-003337', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial isoform A', 93, NULL, NULL, 213244);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(213245, '1.10.196.10-FF-000001', NULL, 'Regulator of G-protein signaling 8', 43, NULL, NULL, 213245),
(213246, '1.25.40.10-FF-004765', NULL, 'Os12g0557800 protein', 41, NULL, NULL, 213246),
(213247, '3.90.190.10-FF-000041', NULL, 'phosphatidylinositol phosphatase PTPRQ isoform X1', 280, NULL, NULL, 213247),
(213248, '2.60.40.10-FF-001438', NULL, 'Immunoglobulin-like and fibronectin type III domain-containing protein 1', 99, NULL, NULL, 213248),
(213249, '3.30.40.10-FF-000656', NULL, 'Uncharacterized protein', 56, NULL, NULL, 213249),
(213250, '1.20.91.20-FF-000012', NULL, 'Complement component 4A (Rodgers blood group)', 82, NULL, NULL, 213250),
(213251, '2.130.10.10-FF-001950', NULL, 'Os01g0605400 protein', 319, NULL, NULL, 213251),
(213252, '3.40.50.2300-FF-000088', NULL, 'Ribose operon repressor', 123, NULL, NULL, 213252),
(213253, '1.20.5.170-FF-000170', NULL, 'GM14169p', 40, NULL, NULL, 213253),
(213254, '3.20.10.10-FF-000014', NULL, 'Branched-chain-amino-acid aminotransferase', 176, NULL, NULL, 213254),
(213255, '3.40.50.300-FF-001922', NULL, 'DEAH (Asp-Glu-Ala-His) box polypeptide 29', 123, NULL, NULL, 213255),
(213256, '3.40.390.10-FF-000163', NULL, NULL, 57, NULL, NULL, 213256),
(213257, '1.20.1270.280-FF-000011', NULL, 'Dynein heavy chain, putative', 176, NULL, NULL, 213257),
(213258, '3.30.70.100-FF-000042', NULL, 'Copper chaperone for superoxide dismutase', 78, NULL, NULL, 213258),
(213259, '1.10.8.10-FF-000237', NULL, 'Uncharacterized protein', 61, NULL, NULL, 213259),
(213260, '3.30.160.60-FF-005783', NULL, NULL, 44, NULL, NULL, 213260),
(213261, '3.90.640.10-FF-000194', NULL, 'Actin-related protein 4', 25, NULL, NULL, 213261),
(213262, '1.10.510.10-FF-001087', NULL, 'Uncharacterized protein', 364, NULL, NULL, 213262),
(213263, '1.20.920.10-FF-000216', NULL, 'Uncharacterized protein', 88, NULL, NULL, 213263),
(213264, '3.30.70.330-FF-000791', NULL, 'Peroxisome proliferator-activated receptor gamma coactivator 1-beta isoform 1', 163, NULL, NULL, 213264),
(213265, '2.30.30.140-FF-000241', NULL, 'AGAP001019-PA', 67, NULL, NULL, 213265),
(213266, '1.10.472.80-FF-000017', NULL, 'TBC1 domain family member 23', 128, NULL, NULL, 213266),
(213267, '3.40.50.300-FF-003619', NULL, 'OLA1 isoform 9', 75, NULL, NULL, 213267),
(213268, '1.25.40.10-FF-003085', NULL, 'Tetratricopeptide repeat domain 21A', 274, NULL, NULL, 213268),
(213269, '3.30.70.120-FF-000048', NULL, NULL, 50, NULL, NULL, 213269),
(213270, '2.70.160.11-FF-000026', NULL, 'Unplaced genomic scaffold supercont1.163, whole genome shotgun sequence', 182, NULL, NULL, 213270),
(213271, '3.30.420.10-FF-000505', NULL, NULL, 96, NULL, NULL, 213271),
(213272, '3.40.710.10-FF-000025', NULL, 'D-alanyl-D-alanine carboxypeptidase DacA', 279, NULL, NULL, 213272),
(213273, '3.30.1490.20-FF-000012', NULL, 'Biotin carboxylase', 68, NULL, NULL, 213273),
(213274, '1.20.59.10-FF-000013', NULL, 'Chorismate mutase I', 93, NULL, NULL, 213274),
(213275, '1.20.1420.30-FF-000099', NULL, 'Uncharacterized protein', 191, NULL, NULL, 213275),
(213276, '3.40.50.150-FF-001641', NULL, NULL, 232, NULL, NULL, 213276),
(213277, '3.40.50.10490-FF-000071', NULL, 'Glucose-6-phosphate isomerase', 219, NULL, NULL, 213277),
(213278, '1.20.1050.10-FF-000194', NULL, 'Uncharacterized protein', 88, NULL, NULL, 213278),
(213279, '3.60.40.10-FF-000076', NULL, 'Phosphatase', 224, NULL, NULL, 213279),
(213280, '1.20.1560.10-FF-000485', NULL, 'Lipid A export ATP-binding/permease protein MsbA', 306, NULL, NULL, 213280),
(213281, '3.40.50.300-FF-000995', NULL, 'RAB5B, member RAS oncogene family', 196, NULL, NULL, 213281),
(213282, '1.20.120.1810-FF-000004', NULL, 'RNA polymerase sigma-H factor SigH', 96, NULL, NULL, 213282),
(213283, '3.30.70.260-FF-000157', NULL, 'Prephenate dehydratase', 93, NULL, NULL, 213283),
(213284, '2.60.40.10-FF-005362', NULL, NULL, 65, NULL, NULL, 213284),
(213285, '2.30.29.30-FF-000475', NULL, 'AGC/RSK/RSKP90 protein kinase', 97, NULL, NULL, 213285),
(213286, '2.130.10.10-FF-004867', NULL, 'WD40-repeat protein', 122, NULL, NULL, 213286),
(213287, '1.25.10.10-FF-001503', NULL, 'Serine/threonine-protein kinase TOR', 171, NULL, NULL, 213287); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(213288, '3.30.40.10-FF-000920', NULL, 'Putative RING-H2 finger protein ATL12', 82, NULL, NULL, 213288),
(213289, '1.20.5.110-FF-000303', NULL, 'Uncharacterized protein', 64, NULL, NULL, 213289),
(213290, '3.20.70.20-FF-000026', NULL, 'Vitamin B12-dependent ribonucleotide reductase', 614, NULL, NULL, 213290),
(213291, '3.30.70.330-FF-003062', NULL, NULL, 105, NULL, NULL, 213291),
(213292, '3.30.70.1230-FF-000140', NULL, 'Ca(2+)/calmodulin-responsive adenylate cyclase-like Protein', 155, NULL, NULL, 213292),
(213293, '3.40.50.720-FF-000547', NULL, 'Ast1p', 138, NULL, NULL, 213293),
(213294, '1.25.40.770-FF-000014', NULL, 'Uncharacterized protein', 87, NULL, NULL, 213294),
(213295, '2.60.40.10-FF-003580', NULL, NULL, 100, NULL, NULL, 213295),
(213296, '1.10.287.1260-FF-000015', NULL, NULL, 93, NULL, NULL, 213296),
(213297, '2.30.30.870-FF-000004', NULL, 'Protein DOM34 homolog', 132, NULL, NULL, 213297),
(213298, '3.80.10.10-FF-001012', NULL, 'Uncharacterized protein', 116, NULL, NULL, 213298),
(213299, '1.25.10.10-FF-003482', NULL, 'RING-type E3 ubiquitin transferase', 210, NULL, NULL, 213299),
(213300, '3.40.50.300-FF-003058', NULL, 'ABC transporter ATP-binding protein', 223, NULL, NULL, 213300),
(213301, '3.80.10.10-FF-000394', NULL, 'Dynein assembly factor 1, axonemal', 72, NULL, NULL, 213301),
(213302, '3.40.1160.10-FF-000072', NULL, 'Folylpolyglutamate synthase', 77, NULL, NULL, 213302),
(213303, '3.40.50.720-FF-000856', NULL, 'Phthiocerol synthesis polyketide synthase type I PpsD', 481, NULL, NULL, 213303),
(213304, '3.40.720.10-FF-000262', NULL, 'Phosphonate monoester hydrolase, putative', 460, NULL, NULL, 213304),
(213305, '3.40.50.300-FF-007419', NULL, 'QUInine non-avoider', 170, NULL, NULL, 213305),
(213306, '3.40.50.410-FF-000117', NULL, 'Protein CBR-TAG-180', 190, NULL, NULL, 213306),
(213307, '3.30.230.10-FF-000159', NULL, 'Elongation factor 2-like protein', 158, NULL, NULL, 213307),
(213308, '1.10.510.10-FF-003341', NULL, NULL, 42, NULL, NULL, 213308),
(213309, '3.40.1110.10-FF-000136', NULL, 'Cation-transporting ATPase', 120, NULL, NULL, 213309),
(213310, '1.10.510.10-FF-001648', NULL, 'Protein kinase superfamily protein', 184, NULL, NULL, 213310),
(213311, '3.90.180.10-FF-000175', NULL, 'Uncharacterized protein', 31, NULL, NULL, 213311),
(213312, '1.25.40.10-FF-001522', NULL, 'Penicillin-binding protein activator', 125, NULL, NULL, 213312),
(213313, '1.10.10.10-FF-001059', NULL, 'IclR family transcriptional regulator', 76, NULL, NULL, 213313),
(213314, '3.30.930.10-FF-000027', NULL, 'Serine--tRNA ligase, cytoplasmic', 340, NULL, NULL, 213314),
(213315, '3.40.50.10580-FF-000007', NULL, 'VATPase', 96, NULL, NULL, 213315),
(213316, '3.30.450.20-FF-000600', NULL, 'Predicted protein', 153, NULL, NULL, 213316),
(213317, '3.60.15.10-FF-000029', NULL, 'Cyclic nucleotide-binding domain protein', 240, NULL, NULL, 213317),
(213318, '2.40.50.140-FF-000759', NULL, NULL, 60, NULL, NULL, 213318),
(213319, '2.30.30.790-FF-000014', NULL, 'Unplaced genomic scaffold supercont2.18, whole genome shotgun sequence', 132, NULL, NULL, 213319),
(213320, '3.30.160.60-FF-005266', NULL, NULL, 55, NULL, NULL, 213320),
(213321, '2.30.42.10-FF-000461', NULL, NULL, 122, NULL, NULL, 213321),
(213322, '1.20.1250.20-FF-002078', NULL, 'Uncharacterized protein', 275, NULL, NULL, 213322),
(213323, '2.130.10.10-FF-001742', NULL, 'SeMaPhorin related', 435, NULL, NULL, 213323),
(213324, '1.10.630.10-FF-000741', NULL, 'Cytochrome P450 monooxygenase', 85, NULL, NULL, 213324),
(213325, '3.40.50.2000-FF-000442', NULL, 'Dorothy, isoform A', 226, NULL, NULL, 213325),
(213326, '1.10.472.10-FF-000379', NULL, 'Uncharacterized protein', 105, NULL, NULL, 213326),
(213327, '1.10.472.80-FF-000225', NULL, NULL, 120, NULL, NULL, 213327),
(213328, '3.60.20.10-FF-000070', NULL, 'Proteasome subunit beta', 218, NULL, NULL, 213328),
(213329, '3.80.10.10-FF-000085', NULL, 'protein zer-1 homolog isoform X1', 142, NULL, NULL, 213329),
(213330, '3.30.300.160-FF-000017', NULL, 'Type II secretory pathway, ATPase PulE', 79, NULL, NULL, 213330);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(213331, '3.30.200.20-FF-000880', NULL, 'Predicted protein', 79, NULL, NULL, 213331),
(213332, '3.40.50.2000-FF-000958', NULL, 'Uncharacterized protein', 103, NULL, NULL, 213332),
(213333, '3.40.50.300-FF-007970', NULL, 'Dynein heavy chain family protein', 163, NULL, NULL, 213333),
(213334, '3.20.20.140-FF-000029', NULL, '2-amino-3-carboxymuconate-6-semialdehyde decarboxylase', 336, NULL, NULL, 213334),
(213335, '3.90.190.10-FF-000147', NULL, 'Protein-tyrosine-phosphatase', 293, NULL, NULL, 213335),
(213336, '1.10.510.10-FF-003902', NULL, NULL, 84, NULL, NULL, 213336),
(213337, '3.30.160.60-FF-002040', NULL, 'zinc finger protein 70', 58, NULL, NULL, 213337),
(213338, '3.30.160.60-FF-000140', NULL, 'Tripartite motif containing 55', 46, NULL, NULL, 213338),
(213339, '1.25.10.10-FF-002577', NULL, 'Uncharacterized protein', 163, NULL, NULL, 213339),
(213340, '1.10.8.10-FF-000029', NULL, 'Serine/threonine-protein kinase LATS1 isoform 1', 56, NULL, NULL, 213340),
(213341, '2.60.220.50-FF-000044', NULL, 'Predicted protein', 53, NULL, NULL, 213341),
(213342, '2.60.40.10-FF-003119', NULL, 'AGAP003610-PA', 107, NULL, NULL, 213342),
(213343, '1.10.287.130-FF-000029', NULL, 'Phytochrome', 82, NULL, NULL, 213343),
(213344, '2.10.70.10-FF-000144', NULL, 'Blast:Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', 63, NULL, NULL, 213344),
(213345, '3.30.200.20-FF-001133', NULL, 'Uncharacterized protein', 112, NULL, NULL, 213345),
(213346, '3.30.160.20-FF-000235', NULL, 'Uncharacterized protein', 75, NULL, NULL, 213346),
(213347, '1.25.40.10-FF-001331', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 152, NULL, NULL, 213347),
(213348, '1.50.10.10-FF-000113', NULL, 'Endoglucanase', 464, NULL, NULL, 213348),
(213349, '1.10.287.130-FF-000271', NULL, 'Sensor histidine kinase, PAS domain-containing', 117, NULL, NULL, 213349),
(213350, '1.20.1560.10-FF-000277', NULL, 'WGS project CABT00000000 data, contig 2.12', 319, NULL, NULL, 213350),
(213351, '2.60.40.10-FF-005019', NULL, NULL, 105, NULL, NULL, 213351),
(213352, '3.60.21.50-FF-000010', NULL, 'DNA polymerase epsilon subunit', 150, NULL, NULL, 213352),
(213353, '1.10.10.60-FF-001276', NULL, NULL, 72, NULL, NULL, 213353),
(213354, '1.50.10.20-FF-000116', NULL, 'Uncharacterized protein', 143, NULL, NULL, 213354),
(213355, '1.10.510.10-FF-003357', NULL, NULL, 231, NULL, NULL, 213355),
(213356, '3.90.245.10-FF-000005', NULL, 'Inosine-uridine preferring nucleoside hydrolase', 313, NULL, NULL, 213356),
(213357, '4.10.470.10-FF-000003', NULL, 'Ribosome-inactivating protein PMRIPt', 119, NULL, NULL, 213357),
(213358, '3.40.1170.60-FF-000020', NULL, 'DNA repair protein REV1', 54, NULL, NULL, 213358),
(213359, '4.10.400.10-FF-000201', NULL, 'Serine protease nudel', 37, NULL, NULL, 213359),
(213360, '1.25.40.10-FF-003231', NULL, 'Pentatricopeptide repeat-containing protein At4g21065', 206, NULL, NULL, 213360),
(213361, '3.30.450.20-FF-000336', NULL, 'Protein_kinase_-_putative', 111, NULL, NULL, 213361),
(213362, '1.20.5.110-FF-000157', NULL, 't-SNARE protein aex-4', 78, NULL, NULL, 213362),
(213363, '1.10.287.110-FF-000023', NULL, 'Sacsin molecular chaperone', 63, NULL, NULL, 213363),
(213364, '3.40.50.410-FF-000073', NULL, 'ATP-dependent DNA helicase II subunit 2', 218, NULL, NULL, 213364),
(213365, '2.40.50.140-FF-000905', NULL, NULL, 76, NULL, NULL, 213365),
(213366, '3.30.40.10-FF-000774', NULL, 'E3 ubiquitin-protein ligase SINAT3', 98, NULL, NULL, 213366),
(213367, '4.10.470.20-FF-000006', NULL, NULL, 163, NULL, NULL, 213367),
(213368, '4.10.1060.10-FF-000020', NULL, 'ranBP2-type zinc finger protein At1g67325-like', 40, NULL, NULL, 213368),
(213369, '2.30.29.30-FF-000166', NULL, 'GRB2-associated-binding protein 1 isoform X1', 126, NULL, NULL, 213369),
(213370, '3.40.1110.10-FF-000035', NULL, 'Phospholipid-transporting ATPase', 168, NULL, NULL, 213370),
(213371, '3.60.10.10-FF-000142', NULL, 'DNA-(apurinic or apyrimidinic site) lyase', 358, NULL, NULL, 213371),
(213372, '1.20.1560.10-FF-000631', NULL, 'Uncharacterized protein', 243, NULL, NULL, 213372);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(213373, '1.10.225.10-FF-000007', NULL, 'Canopy 2 homolog (Zebrafish)', 117, NULL, NULL, 213373),
(213374, '1.20.1560.10-FF-000176', NULL, 'ATP-binding cassette bilirubin transporter', 328, NULL, NULL, 213374),
(213375, '1.10.10.10-FF-001177', NULL, 'Uncharacterized protein', 102, NULL, NULL, 213375),
(213376, '3.30.360.20-FF-000008', NULL, 'RNA 3''-terminal phosphate cyclase, putative', 99, NULL, NULL, 213376),
(213377, '3.30.230.10-FF-000362', NULL, 'Uncharacterized protein', 115, NULL, NULL, 213377),
(213378, '1.10.10.10-FF-001323', NULL, 'Two-component response regulator', 99, NULL, NULL, 213378),
(213379, '2.160.20.10-FF-000258', NULL, 'Cell surface protein', 135, NULL, NULL, 213379),
(213380, '1.20.1270.10-FF-000075', NULL, 'Luminal binding protein', 74, NULL, NULL, 213380),
(213381, '3.40.50.2000-FF-000178', NULL, 'Glycosyltransferase', 267, NULL, NULL, 213381),
(213382, '3.40.50.1360-FF-000053', NULL, 'Glucosamine-6-phosphate isomerase, putative', 146, NULL, NULL, 213382),
(213383, '2.130.10.10-FF-003187', NULL, 'WD repeat-containing protein 38', 132, NULL, NULL, 213383),
(213384, '3.30.413.10-FF-000039', NULL, 'Sulfite reductase [NADPH] subunit beta', 137, NULL, NULL, 213384),
(213385, '3.30.30.30-FF-000032', NULL, 'Actin-like ATPase domain-containing protein', 60, NULL, NULL, 213385),
(213386, '3.40.50.300-FF-001158', NULL, 'Phage terminase large subunit', 197, NULL, NULL, 213386),
(213387, '3.60.110.10-FF-000071', NULL, NULL, 119, NULL, NULL, 213387),
(213388, '1.10.10.250-FF-000025', NULL, 'Uncharacterized protein', 42, NULL, NULL, 213388),
(213389, '3.80.10.10-FF-002456', NULL, 'Paraflagellar rod component, putative', 70, NULL, NULL, 213389),
(213390, '4.10.780.10-FF-000004', NULL, 'Pyruvate-flavoredoxin oxidoreductase', 27, NULL, NULL, 213390),
(213391, '3.40.50.2000-FF-000088', NULL, 'Glycosyltransferase', 259, NULL, NULL, 213391),
(213392, '1.25.40.70-FF-000005', NULL, 'Phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit beta', 181, NULL, NULL, 213392),
(213393, '3.40.50.300-FF-005727', NULL, 'Similar to type IV pilus assembly protein TapB', 160, NULL, NULL, 213393),
(213394, '3.30.980.10-FF-000007', NULL, 'alanyl-tRNA editing protein Aarsd1', 158, NULL, NULL, 213394),
(213395, '2.30.30.1020-FF-000004', NULL, 'probable NOT transcription complex subunit VIP2 isoform X1', 183, NULL, NULL, 213395),
(213396, '3.40.50.620-FF-000826', NULL, 'Tryptophan--tRNA ligase', 211, NULL, NULL, 213396),
(213397, '3.40.367.20-FF-000005', NULL, 'Phosphotransferase', 266, NULL, NULL, 213397),
(213398, '1.25.40.80-FF-000008', NULL, 'Cryptochrome-1', 134, NULL, NULL, 213398),
(213399, '2.10.25.10-FF-000006', NULL, 'Versican core protein-like isoform 1', 37, NULL, NULL, 213399),
(213400, '3.40.50.1110-FF-000028', NULL, 'GDSL family lipase', 189, NULL, NULL, 213400),
(213401, '2.130.10.10-FF-001641', NULL, 'Ribosome biogenesis protein WDR12 homolog', 122, NULL, NULL, 213401),
(213402, '3.60.21.60-FF-000013', NULL, 'DNA polymerase alpha/epsilon subunit B, putative', 163, NULL, NULL, 213402),
(213403, '3.40.50.300-FF-003928', NULL, 'Telomere length regulation protein, putative', 191, NULL, NULL, 213403),
(213404, '2.60.40.150-FF-000756', NULL, 'Uncharacterized protein', 144, NULL, NULL, 213404),
(213405, '3.30.470.20-FF-000236', NULL, 'Predicted protein', 77, NULL, NULL, 213405),
(213406, '3.40.50.300-FF-003412', NULL, 'Bifunctional helicase and thymine dioxygenase JBP2', 293, NULL, NULL, 213406),
(213407, '2.60.120.10-FF-000081', NULL, 'Pirin', 107, NULL, NULL, 213407),
(213408, '3.30.1490.120-FF-000011', NULL, 'DNA-directed RNA polymerase III subunit 22.9 kDa polypeptide', 79, NULL, NULL, 213408),
(213409, '2.60.120.200-FF-000218', NULL, 'Protein eyes shut homolog', 195, NULL, NULL, 213409),
(213410, '1.20.5.170-FF-000259', NULL, 'Mitotic spindle assembly checkpoint protein MAD1-like Protein', 40, NULL, NULL, 213410),
(213411, '2.30.42.10-FF-000253', NULL, 'Uncharacterized protein', 108, NULL, NULL, 213411),
(213412, '1.20.900.10-FF-000108', NULL, 'Uncharacterized protein', 161, NULL, NULL, 213412);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(213413, '3.30.930.10-FF-000370', NULL, 'Glycine--tRNA ligase', 286, NULL, NULL, 213413),
(213414, '3.40.50.12780-FF-000156', NULL, 'Nonribosomal peptide synthase nlsA', 194, NULL, NULL, 213414),
(213415, '2.40.160.180-FF-000005', NULL, 'Porin', 402, NULL, NULL, 213415),
(213416, '3.40.50.1370-FF-000056', NULL, NULL, 138, NULL, NULL, 213416),
(213417, '1.20.920.10-FF-000008', NULL, 'Bromodomain and WD repeat domain containing 3', 140, NULL, NULL, 213417),
(213418, '3.90.25.10-FF-000023', NULL, 'UDP-glucose 4-epimerase', 102, NULL, NULL, 213418),
(213419, '1.25.40.10-FF-005119', NULL, 'Chaperone protein DNAJ, putative', 112, NULL, NULL, 213419),
(213420, '1.25.10.10-FF-001239', NULL, 'CLIP-associated protein', 222, NULL, NULL, 213420),
(213421, '1.25.40.20-FF-001334', NULL, 'Uncharacterized protein', 126, NULL, NULL, 213421),
(213422, '3.40.50.2300-FF-000650', NULL, 'Two-component response regulator', 82, NULL, NULL, 213422),
(213423, '1.10.287.70-FF-000174', NULL, 'KCNN (Potassium K ChaNNel, calcium activated)-Like', 98, NULL, NULL, 213423),
(213424, '3.80.10.10-FF-004255', NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase At2g25790', 69, NULL, NULL, 213424),
(213425, '1.25.40.820-FF-000035', NULL, 'Predicted protein', 105, NULL, NULL, 213425),
(213426, '3.10.580.10-FF-000223', NULL, 'Uncharacterized protein', 105, NULL, NULL, 213426),
(213427, '1.25.40.10-FF-003129', NULL, 'Pentatricopeptide repeat-containing protein', 152, NULL, NULL, 213427),
(213428, '1.20.1310.20-FF-000003', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 189, NULL, NULL, 213428),
(213429, '3.40.50.10330-FF-000062', NULL, 'Diacylglycerol kinase', 135, NULL, NULL, 213429),
(213430, '3.40.50.1820-FF-000045', NULL, 'Pimeloyl-[acyl-carrier protein] methyl ester esterase', 255, NULL, NULL, 213430),
(213431, '1.25.40.10-FF-001067', NULL, 'Programmed cell death protein pre-rrna processing protein rrp5', 193, NULL, NULL, 213431),
(213432, '3.40.50.300-FF-007318', NULL, 'Chromosome 1, whole genome shotgun sequence', 281, NULL, NULL, 213432),
(213433, '1.10.1740.10-FF-000001', NULL, 'RNA polymerase sigma factor', 121, NULL, NULL, 213433),
(213434, '3.40.50.300-FF-001719', NULL, 'Torsin', 222, NULL, NULL, 213434),
(213435, '3.60.120.10-FF-000009', NULL, 'Para-aminobenzoate synthase PabaA', 547, NULL, NULL, 213435),
(213436, '1.20.58.2070-FF-000001', NULL, 'Spindle checkpoint complex subunit', 75, NULL, NULL, 213436),
(213437, '1.10.4080.10-FF-000001', NULL, 'ADP-ribose glycohydrolase ARH3', 344, NULL, NULL, 213437),
(213438, '2.130.10.10-FF-005441', NULL, 'Uncharacterized protein', 211, NULL, NULL, 213438),
(213439, '2.160.20.20-FF-000002', NULL, 'Tail spike protein', 557, NULL, NULL, 213439),
(213440, '1.10.3450.40-FF-000016', NULL, NULL, 197, NULL, NULL, 213440),
(213441, '3.40.50.1970-FF-000039', NULL, 'Phosphoribosylaminoimidazole carboxylase family protein / AIR carboxylase family protein', 102, NULL, NULL, 213441),
(213442, '3.50.50.60-FF-000974', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 155, NULL, NULL, 213442),
(213443, '2.30.30.140-FF-000038', NULL, 'Survival of motor neuron-related-splicing factor 30', 67, NULL, NULL, 213443),
(213444, '3.40.50.10190-FF-000194', NULL, 'Uncharacterized protein', 92, NULL, NULL, 213444),
(213445, '1.10.287.70-FF-000483', NULL, 'Two pore potassium channel protein sup-9', 282, NULL, NULL, 213445),
(213446, '1.20.5.170-FF-000052', NULL, 'GDP-mannose 6-dehydrogenase', 32, NULL, NULL, 213446),
(213447, '2.130.10.10-FF-003541', NULL, 'Uncharacterized protein', 161, NULL, NULL, 213447),
(213448, '2.60.120.330-FF-000100', NULL, 'Os09g0353400 protein', 178, NULL, NULL, 213448),
(213449, '3.30.200.20-FF-001043', NULL, 'Alpha-protein kinase vwkA', 138, NULL, NULL, 213449),
(213450, '1.25.40.370-FF-000001', NULL, 'Apoptotic protease-activating factor 1', 140, NULL, NULL, 213450),
(213451, '1.10.357.140-FF-000021', NULL, '1,4-dihydroxy-2-naphthoate octaprenyltransferase', 161, NULL, NULL, 213451),
(213452, '1.20.1540.10-FF-000068', NULL, 'Peptidase, S54 (Rhomboid) family', 191, NULL, NULL, 213452);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(213453, '1.10.1080.10-FF-000001', NULL, 'Glutathione synthetase', 80, NULL, NULL, 213453),
(213454, '1.20.1280.50-FF-000211', NULL, 'Cyclin-F', 41, NULL, NULL, 213454),
(213455, '1.10.510.10-FF-003447', NULL, NULL, 277, NULL, NULL, 213455),
(213456, '3.40.50.12600-FF-000001', NULL, 'Predicted protein', 112, NULL, NULL, 213456),
(213457, '3.30.420.40-FF-000767', NULL, 'Heat shock protein 70 (HSP70)-4, putative', 89, NULL, NULL, 213457),
(213458, '1.20.58.340-FF-000012', NULL, 'Magnesium transport protein CorA', 127, NULL, NULL, 213458),
(213459, '2.60.40.1530-FF-000021', NULL, 'Uncharacterized protein, isoform B', 183, NULL, NULL, 213459),
(213460, '2.60.40.10-FF-003681', NULL, NULL, 97, NULL, NULL, 213460),
(213461, '3.30.70.330-FF-001044', NULL, 'RNA binding protein Rnp24, putative', 148, NULL, NULL, 213461),
(213462, '3.40.50.1820-FF-000915', NULL, 'Prolylcarboxypeptidase, putative', 144, NULL, NULL, 213462),
(213463, '1.10.8.10-FF-000131', NULL, 'Predicted protein', 51, NULL, NULL, 213463),
(213464, '1.10.630.10-FF-000640', NULL, 'Uncharacterized protein', 217, NULL, NULL, 213464),
(213465, '3.40.50.300-FF-007009', NULL, 'Elongator complex protein 4', 209, NULL, NULL, 213465),
(213466, '2.40.50.140-FF-000653', NULL, NULL, 67, NULL, NULL, 213466),
(213467, '1.10.4160.10-FF-000047', NULL, NULL, 70, NULL, NULL, 213467),
(213468, '3.40.190.10-FF-000619', NULL, 'Uncharacterized protein', 102, NULL, NULL, 213468),
(213469, '2.130.10.10-FF-005132', NULL, 'WD repeat-containing protein 19-like Protein', 297, NULL, NULL, 213469),
(213470, '3.20.20.380-FF-000005', NULL, 'Uncharacterized protein, isoform B', 253, NULL, NULL, 213470),
(213471, '3.40.1620.60-FF-000010', NULL, 'Uncharacterized protein, isoform B', 92, NULL, NULL, 213471),
(213472, '1.25.40.10-FF-005029', NULL, 'Uncharacterized protein', 160, NULL, NULL, 213472),
(213473, '3.30.450.20-FF-000027', NULL, 'Nuclear receptor coactivator 3', 129, NULL, NULL, 213473),
(213474, '3.30.470.20-FF-000146', NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta, mitochondrial', 27, NULL, NULL, 213474),
(213475, '1.10.10.10-FF-001632', NULL, 'Transcriptional regulator, ArsR family', 92, NULL, NULL, 213475),
(213476, '2.60.120.650-FF-000078', NULL, 'Predicted protein', 204, NULL, NULL, 213476),
(213477, '1.20.120.850-FF-000024', NULL, 'Helicase ssl-1', 86, NULL, NULL, 213477),
(213478, '1.20.1250.20-FF-000633', NULL, 'Staphyloferrin B transporter', 187, NULL, NULL, 213478),
(213479, '3.30.40.10-FF-000465', NULL, 'Increased DNA methylation 1', 53, NULL, NULL, 213479),
(213480, '1.20.1250.20-FF-000279', NULL, 'Major facilitator superfamily protein', 216, NULL, NULL, 213480),
(213481, '3.10.270.10-FF-000003', NULL, 'Uricase', 307, NULL, NULL, 213481),
(213482, '3.40.50.720-FF-002094', NULL, 'Estradiol 17-beta-dehydrogenase 8', 134, NULL, NULL, 213482),
(213483, '3.30.300.110-FF-000020', NULL, 'Uncharacterized protein', 80, NULL, NULL, 213483),
(213484, '1.10.10.160-FF-000032', NULL, 'ATP-dependent DNA helicase, putative', 78, NULL, NULL, 213484),
(213485, '2.60.40.1280-FF-000002', NULL, 'Clumping factor A', 141, NULL, NULL, 213485),
(213486, '3.90.1150.10-FF-000526', NULL, 'Uncharacterized protein', 45, NULL, NULL, 213486),
(213487, '1.25.40.180-FF-000034', NULL, 'Eukaryotic translation initiation factor 4G', 193, NULL, NULL, 213487),
(213488, '1.20.5.1230-FF-000002', NULL, 'Apolipoprotein E', 94, NULL, NULL, 213488),
(213489, '1.25.40.10-FF-001286', NULL, 'Tetratricopeptide repeat protein', 129, NULL, NULL, 213489),
(213490, '3.40.50.720-FF-002346', NULL, 'Uncharacterized protein', 116, NULL, NULL, 213490),
(213491, '1.10.472.10-FF-000002', NULL, 'Transcription factor IIIB 90 kDa subunit', 93, NULL, NULL, 213491),
(213492, '1.20.140.10-FF-000151', NULL, 'Uncharacterized protein', 71, NULL, NULL, 213492),
(213493, '1.25.40.20-FF-001289', NULL, 'Uncharacterized protein', 170, NULL, NULL, 213493),
(213494, '1.25.10.10-FF-002886', NULL, 'HEAT repeat-containing protein 2-like Protein', 146, NULL, NULL, 213494),
(213495, '1.10.555.10-FF-000083', NULL, 'Rho GTPase Activating protein', 244, NULL, NULL, 213495);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(213496, '3.40.50.2300-FF-001223', NULL, NULL, 216, NULL, NULL, 213496),
(213497, '1.20.1250.20-FF-002224', NULL, 'Uncharacterized protein', 129, NULL, NULL, 213497),
(213498, '2.20.100.10-FF-000049', NULL, 'Thrombospondin type 1 domain containing 4', 59, NULL, NULL, 213498),
(213499, '3.30.420.140-FF-000027', NULL, 'Putative pre-16S rRNA nuclease', 139, NULL, NULL, 213499),
(213500, '2.40.37.10-FF-000077', NULL, NULL, 134, NULL, NULL, 213500),
(213501, '3.90.190.10-FF-000456', NULL, 'Predicted protein', 203, NULL, NULL, 213501),
(213502, '3.40.50.790-FF-000040', NULL, '60S ribosomal protein L10a-1', 59, NULL, NULL, 213502),
(213503, '3.40.50.10050-FF-000006', NULL, 'Uncharacterized protein, isoform B', 104, NULL, NULL, 213503),
(213504, '3.40.50.12610-FF-000004', NULL, 'Oligosaccharyl transferase STT3 subunit, putative', 179, NULL, NULL, 213504),
(213505, '3.30.70.850-FF-000019', NULL, 'Uncharacterized protein', 87, NULL, NULL, 213505),
(213506, '3.30.200.20-FF-000986', NULL, 'Related to serine/threonine protein kinase', 80, NULL, NULL, 213506),
(213507, '2.130.10.10-FF-001287', NULL, 'syntaxin-binding protein 5-like isoform X1', 115, NULL, NULL, 213507),
(213508, '3.30.2410.10-FF-000015', NULL, 'probable E3 ubiquitin-protein ligase HECTD4 isoform X1', 124, NULL, NULL, 213508),
(213509, '3.30.200.20-FF-001604', NULL, 'Traf2 and NCK-interacting protein kinase', 104, NULL, NULL, 213509),
(213510, '2.40.240.10-FF-000032', NULL, '50S ribosomal protein L25', 94, NULL, NULL, 213510),
(213511, '2.40.50.90-FF-000019', NULL, 'Transcription factor (Snd1/p100), putative', 152, NULL, NULL, 213511),
(213512, '1.10.630.10-FF-000286', NULL, 'Uncharacterized protein', 172, NULL, NULL, 213512),
(213513, '1.25.10.10-FF-000986', NULL, 'Armadillo repeat containing 8', 142, NULL, NULL, 213513),
(213514, '1.25.40.420-FF-000038', NULL, 'BTB and MATH domain containing', 87, NULL, NULL, 213514),
(213515, '3.30.1360.140-FF-000005', NULL, 'DNA-directed RNA polymerase subunit', 147, NULL, NULL, 213515),
(213516, '3.50.50.60-FF-000665', NULL, 'Flavin-containing monooxygenase', 179, NULL, NULL, 213516),
(213517, '1.20.1250.20-FF-000324', NULL, 'Transporter, MFS superfamily', 195, NULL, NULL, 213517),
(213518, '3.30.40.10-FF-002365', NULL, 'Uncharacterized protein', 130, NULL, NULL, 213518),
(213519, '3.60.40.10-FF-000177', NULL, 'WGS project CABT00000000 data, contig 2.1', 167, NULL, NULL, 213519),
(213520, '3.40.50.300-FF-001821', NULL, 'Putative gtp-binding protein', 231, NULL, NULL, 213520),
(213521, '2.130.10.10-FF-003232', NULL, 'WD-40 repeat protein', 258, NULL, NULL, 213521),
(213522, '3.90.226.10-FF-000198', NULL, 'Enoyl-CoA hydratase', 246, NULL, NULL, 213522),
(213523, '1.10.472.30-FF-000008', NULL, 'transcription elongation factor S-II', 115, NULL, NULL, 213523),
(213524, '1.10.8.840-FF-000002', NULL, 'Zuo1p', 88, NULL, NULL, 213524),
(213525, '1.25.40.10-FF-003321', NULL, 'Pentatricopeptide repeat-containing protein At3g49740', 225, NULL, NULL, 213525),
(213526, '2.60.40.420-FF-000258', NULL, 'Os02g0653200 protein', 84, NULL, NULL, 213526),
(213527, '3.40.50.1820-FF-000606', NULL, 'GD19073', 314, NULL, NULL, 213527),
(213528, '2.60.40.60-FF-001066', NULL, 'Uncharacterized protein', 59, NULL, NULL, 213528),
(213529, '3.40.50.1820-FF-000354', NULL, '(R)-3-hydroxydecanoyl-ACP:CoA transacylase PhaG', 270, NULL, NULL, 213529),
(213530, '1.10.3430.10-FF-000057', NULL, 'Uncharacterized protein', 186, NULL, NULL, 213530),
(213531, '3.40.50.10490-FF-000115', NULL, NULL, 103, NULL, NULL, 213531),
(213532, '3.30.70.60-FF-000049', NULL, 'Plastid ribosomal protein S6', 98, NULL, NULL, 213532),
(213533, '2.10.109.10-FF-000077', NULL, 'Signal peptidase I, fused to C-terminal uncharacterized domain', 95, NULL, NULL, 213533),
(213534, '1.20.1170.10-FF-000011', NULL, NULL, 235, NULL, NULL, 213534),
(213535, '3.30.559.10-FF-000046', NULL, 'Phenolic glucoside malonyltransferase 1', 223, NULL, NULL, 213535),
(213536, '3.90.660.10-FF-000105', NULL, NULL, 232, NULL, NULL, 213536),
(213537, '3.90.810.10-FF-000022', NULL, 'Uncharacterized protein', 85, NULL, NULL, 213537);
INSERT INTO "PUBLIC"."MODEL" VALUES
(213538, '2.60.40.4100-FF-000028', NULL, 'Betaglycan', 80, NULL, NULL, 213538),
(213539, '3.40.50.720-FF-000194', NULL, '3-oxoacyl-[acyl-carrier-protein] reductase, chloroplastic', 244, NULL, NULL, 213539),
(213540, '3.40.50.2300-FF-000296', NULL, 'Transcriptional regulator', 80, NULL, NULL, 213540),
(213541, '2.60.40.1090-FF-000035', NULL, 'Fimbrial-like adhesin protein', 166, NULL, NULL, 213541),
(213542, '1.20.1600.10-FF-000011', NULL, 'Outer membrane efflux protein', 413, NULL, NULL, 213542),
(213543, '3.80.10.10-FF-000629', NULL, 'U2 snRNP component', 145, NULL, NULL, 213543),
(213544, '1.20.1250.10-FF-000057', NULL, 'Interferon B', 162, NULL, NULL, 213544),
(213545, '1.20.1070.10-FF-001959', NULL, 'Uncharacterized protein', 200, NULL, NULL, 213545),
(213546, '2.30.42.10-FF-000359', NULL, 'Putative Golgi reassembly stacking protein (GRASP homologue)', 126, NULL, NULL, 213546),
(213547, '3.30.1120.30-FF-000038', NULL, 'Uncharacterized protein', 86, NULL, NULL, 213547),
(213548, '1.50.10.10-FF-000219', NULL, 'alpha-1,2-Mannosidase', 90, NULL, NULL, 213548),
(213549, '3.30.70.100-FF-000132', NULL, NULL, 69, NULL, NULL, 213549),
(213550, '4.10.240.10-FF-000065', NULL, 'Unplaced genomic scaffold supercont1.82, whole genome shotgun sequence', 66, NULL, NULL, 213550),
(213551, '3.100.10.10-FF-000065', NULL, NULL, 115, NULL, NULL, 213551),
(213552, '3.40.50.2300-FF-001004', NULL, NULL, 128, NULL, NULL, 213552),
(213553, '1.10.287.810-FF-000019', NULL, NULL, 86, NULL, NULL, 213553),
(213554, '3.40.30.10-FF-000621', NULL, 'Protein disulfide isomerase', 115, NULL, NULL, 213554),
(213555, '3.40.630.30-FF-000272', NULL, 'Acetyltransferase, GNAT family protein', 159, NULL, NULL, 213555),
(213556, '3.40.1190.20-FF-000133', NULL, 'Phosphomethylpyrimidine kinase (ThiD-1)', 269, NULL, NULL, 213556),
(213557, '1.20.58.60-FF-000812', NULL, 'Uncharacterized protein', 193, NULL, NULL, 213557),
(213558, '2.60.60.20-FF-000015', NULL, 'Lipoxygenase', 154, NULL, NULL, 213558),
(213559, '3.60.10.10-FF-000125', NULL, 'Inositol 5-phosphatase-like protein', 312, NULL, NULL, 213559),
(213560, '3.90.180.10-FF-000192', NULL, 'Uncharacterized protein', 33, NULL, NULL, 213560),
(213561, '3.90.800.10-FF-000004', NULL, 'Glutamate--tRNA ligase 2', 104, NULL, NULL, 213561),
(213562, '3.40.50.1910-FF-000038', NULL, 'Vacuolar protein sorting-associated protein 33', 99, NULL, NULL, 213562),
(213563, '3.90.850.10-FF-000041', NULL, '2-hydroxypenta-2,4-dienoate hydratase', 270, NULL, NULL, 213563),
(213564, '3.30.960.10-FF-000001', NULL, 'Eukaryotic peptide chain release factor subunit 1', 134, NULL, NULL, 213564),
(213565, '1.25.10.10-FF-002993', NULL, 'Uncharacterized protein', 367, NULL, NULL, 213565),
(213566, '2.130.10.10-FF-003316', NULL, 'Uncharacterized protein', 159, NULL, NULL, 213566),
(213567, '3.90.870.50-FF-000003', NULL, NULL, 254, NULL, NULL, 213567),
(213568, '1.10.472.10-FF-000497', NULL, 'Uncharacterized protein', 108, NULL, NULL, 213568),
(213569, '2.40.50.140-FF-000776', NULL, NULL, 63, NULL, NULL, 213569),
(213570, '3.30.2350.10-FF-000084', NULL, 'tRNA pseudouridine synthase B', 230, NULL, NULL, 213570),
(213571, '1.20.90.10-FF-000029', NULL, NULL, 97, NULL, NULL, 213571),
(213572, '3.30.160.60-FF-005351', NULL, NULL, 28, NULL, NULL, 213572),
(213573, '2.10.230.10-FF-000010', NULL, 'Heat shock protein DnaJ, putative', 69, NULL, NULL, 213573),
(213574, '3.30.559.10-FF-000147', NULL, 'Uncharacterized protein', 196, NULL, NULL, 213574),
(213575, '4.10.1240.30-FF-000006', NULL, 'Integrin beta', 83, NULL, NULL, 213575),
(213576, '2.20.25.20-FF-000020', NULL, NULL, 53, NULL, NULL, 213576),
(213577, '1.10.238.220-FF-000002', NULL, 'Serine/threonine-protein phosphatase 2A regulatory subunit B'''' subunit gamma', 114, NULL, NULL, 213577),
(213578, '2.60.40.60-FF-000020', NULL, 'Dachsous cadherin-related 1b', 112, NULL, NULL, 213578),
(213579, '1.25.40.10-FF-000943', NULL, 'Transcription factor tau 131 kDa subunit', 95, NULL, NULL, 213579),
(213580, '2.40.155.10-FF-000002', NULL, 'Hemicentin 1', 235, NULL, NULL, 213580);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(213581, '3.30.710.10-FF-000269', NULL, 'SKP1-like protein 14', 165, NULL, NULL, 213581),
(213582, '1.20.1260.10-FF-000029', NULL, 'DNA polymerase III subunit beta', 149, NULL, NULL, 213582),
(213583, '1.25.10.10-FF-003066', NULL, 'Uncharacterized protein', 264, NULL, NULL, 213583),
(213584, '3.90.550.10-FF-000203', NULL, 'Polypeptide N-acetylgalactosaminyltransferase 9', 279, NULL, NULL, 213584),
(213585, '3.40.50.620-FF-000372', NULL, 'Probable CDC60-leucine--tRNA ligase, cytosolic', 351, NULL, NULL, 213585),
(213586, '2.60.40.10-FF-001540', NULL, 'Immunoglobulin heavy constant gamma 1', 102, NULL, NULL, 213586),
(213587, '3.90.226.10-FF-000097', NULL, 'Probable enoyl-CoA hydratase echa16', 229, NULL, NULL, 213587),
(213588, '1.10.246.140-FF-000001', NULL, 'Transcription and mRNA export factor ENY2', 98, NULL, NULL, 213588),
(213589, '3.30.70.270-FF-000306', NULL, NULL, 45, NULL, NULL, 213589),
(213590, '3.40.50.10090-FF-000057', NULL, 'Uroporphyrinogen-III synthase', 87, NULL, NULL, 213590),
(213591, '3.40.50.150-FF-001495', NULL, NULL, 117, NULL, NULL, 213591),
(213592, '3.40.50.2000-FF-001021', NULL, 'Uncharacterized protein', 247, NULL, NULL, 213592),
(213593, '1.10.238.20-FF-000001', NULL, 'General odorant-binding protein lush', 117, NULL, NULL, 213593),
(213594, '1.10.510.10-FF-003138', NULL, NULL, 182, NULL, NULL, 213594),
(213595, '1.10.555.10-FF-000010', NULL, 'SLIT-ROBO Rho GTPase-activating protein 1 isoform 2', 277, NULL, NULL, 213595),
(213596, '1.20.1070.10-FF-000964', NULL, 'Uncharacterized protein', 198, NULL, NULL, 213596),
(213597, '1.20.1070.10-FF-000329', NULL, 'Tyramine receptor', 267, NULL, NULL, 213597),
(213598, '1.20.1250.20-FF-002196', NULL, 'Uncharacterized protein', 152, NULL, NULL, 213598),
(213599, '3.40.1190.20-FF-000240', NULL, NULL, 94, NULL, NULL, 213599),
(213600, '3.80.10.10-FF-002086', NULL, 'F-box domain containing protein, expressed', 172, NULL, NULL, 213600),
(213601, '3.40.50.450-FF-000062', NULL, 'ATP-dependent 6-phosphofructokinase', 163, NULL, NULL, 213601),
(213602, '3.30.70.330-FF-001600', NULL, 'Pre-rRNA-processing protein esf2', 153, NULL, NULL, 213602),
(213603, '2.30.29.30-FF-000503', NULL, 'Uncharacterized protein, isoform A', 115, NULL, NULL, 213603),
(213604, '3.30.420.40-FF-001037', NULL, 'Heat shock 70 kDa protein 14', 24, NULL, NULL, 213604),
(213605, '3.40.50.740-FF-000042', NULL, 'NADH:ubiquinone oxidoreductase 78 kDa subunit', 173, NULL, NULL, 213605),
(213606, '2.130.10.30-FF-000129', NULL, NULL, 126, NULL, NULL, 213606),
(213607, '1.10.510.10-FF-003773', NULL, NULL, 136, NULL, NULL, 213607),
(213608, '3.30.428.10-FF-000074', NULL, 'Uncharacterized HIT-like protein MG132', 138, NULL, NULL, 213608),
(213609, '1.10.10.10-FF-000789', NULL, 'Eukaryotic translation initiation factor 3 subunit K', 94, NULL, NULL, 213609),
(213610, '2.130.10.10-FF-005250', NULL, 'Uncharacterized protein', 282, NULL, NULL, 213610),
(213611, '3.50.50.60-FF-000873', NULL, 'Lycopene beta/epsilon cyclase protein', 379, NULL, NULL, 213611),
(213612, '3.40.50.2000-FF-000874', NULL, 'Lipopolysaccharide core biosynthesis mannosyltransferase', 190, NULL, NULL, 213612),
(213613, '2.60.40.10-FF-003664', NULL, NULL, 31, NULL, NULL, 213613),
(213614, '3.30.160.60-FF-004878', NULL, NULL, 50, NULL, NULL, 213614),
(213615, '3.40.50.150-FF-001181', NULL, NULL, 140, NULL, NULL, 213615),
(213616, '3.60.20.10-FF-000204', NULL, NULL, 209, NULL, NULL, 213616),
(213617, '3.40.50.620-FF-000265', NULL, 'Leucine--tRNA ligase', 187, NULL, NULL, 213617),
(213618, '1.20.1250.20-FF-000739', NULL, 'Vesicular NUcleotide Transporte', 192, NULL, NULL, 213618),
(213619, '1.25.40.1040-FF-000064', NULL, 'Uncharacterized protein', 79, NULL, NULL, 213619),
(213620, '3.40.190.10-FF-000389', NULL, 'Transcriptional regulator, LysR family', 99, NULL, NULL, 213620),
(213621, '3.40.20.10-FF-000014', NULL, 'Protein transport protein SEC23', 105, NULL, NULL, 213621),
(213622, '2.60.40.10-FF-003771', NULL, NULL, 87, NULL, NULL, 213622),
(213623, '3.60.15.30-FF-000001', NULL, 'Alkyl/aryl-sulfatase BDS1', 358, NULL, NULL, 213623);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(213624, '1.20.1280.50-FF-000110', NULL, 'Predicted protein', 41, NULL, NULL, 213624),
(213625, '2.40.70.10-FF-000379', NULL, NULL, 196, NULL, NULL, 213625),
(213626, '3.40.50.300-FF-007189', NULL, 'Uncharacterized protein', 170, NULL, NULL, 213626),
(213627, '3.60.20.10-FF-000086', NULL, 'Proteasome subunit beta type-1', 211, NULL, NULL, 213627),
(213628, '1.20.940.10-FF-000026', NULL, 'Splicing factor Prp18 family protein', 106, NULL, NULL, 213628),
(213629, '1.20.5.600-FF-000001', NULL, 'Potassium voltage-gated channel subfamily A member 4', 75, NULL, NULL, 213629),
(213630, '3.60.20.10-FF-000193', NULL, NULL, 230, NULL, NULL, 213630),
(213631, '1.10.150.110-FF-000030', NULL, 'DNA polymerase', 91, NULL, NULL, 213631),
(213632, '3.10.20.90-FF-000241', NULL, 'Phosphatidylinositol 3-kinase 2', 108, NULL, NULL, 213632),
(213633, '2.60.20.10-FF-000010', NULL, 'very large A-kinase anchor protein', 89, NULL, NULL, 213633),
(213634, '2.30.29.30-FF-000492', NULL, 'Mitogen-activated protein kinase', 114, NULL, NULL, 213634),
(213635, '1.10.287.2210-FF-000002', NULL, 'Proteasome activator subunit 4, putative (AFU_orthologue AFUA_4G11290)', 42, NULL, NULL, 213635),
(213636, '3.40.50.300-FF-002411', NULL, 'Adenylyl-sulfate kinase', 178, NULL, NULL, 213636),
(213637, '3.40.50.1010-FF-000100', NULL, 'Protein CBR-EXO-1', 207, NULL, NULL, 213637),
(213638, '2.10.25.10-FF-000315', NULL, 'Laminin subunit alpha 2', 48, NULL, NULL, 213638),
(213639, '3.30.160.100-FF-000017', NULL, 'Ribosome-associated factor Y', 96, NULL, NULL, 213639),
(213640, '3.30.160.60-FF-004985', NULL, NULL, 81, NULL, NULL, 213640),
(213641, '2.30.29.30-FF-000722', NULL, 'Integrin beta-1-binding protein 1', 40, NULL, NULL, 213641),
(213642, '3.40.720.10-FF-000071', NULL, 'Metalloenzyme domain protein', 179, NULL, NULL, 213642),
(213643, '3.30.70.330-FF-002909', NULL, NULL, 38, NULL, NULL, 213643),
(213644, '1.25.40.10-FF-004956', NULL, 'Uncharacterized protein', 165, NULL, NULL, 213644),
(213645, '3.40.250.10-FF-000107', NULL, 'Rodhanase family domain containing protein', 163, NULL, NULL, 213645),
(213646, '4.10.1000.10-FF-000089', NULL, 'Zinc finger CCCH domain-containing protein 37', 112, NULL, NULL, 213646),
(213647, '3.30.70.330-FF-002691', NULL, NULL, 111, NULL, NULL, 213647),
(213648, '1.20.1270.60-FF-000174', NULL, 'Meiotically up-regulated gene 137 protein', 223, NULL, NULL, 213648),
(213649, '3.90.70.10-FF-000200', NULL, 'Protein CBG05143', 329, NULL, NULL, 213649),
(213650, '3.90.70.80-FF-000070', NULL, 'OTU-like cysteine protease family protein', 147, NULL, NULL, 213650),
(213651, '3.20.20.100-FF-000158', NULL, 'Aldo-keto reductase, putative', 252, NULL, NULL, 213651),
(213652, '3.40.50.300-FF-005430', NULL, 'Uncharacterized protein', 133, NULL, NULL, 213652),
(213653, '2.130.10.10-FF-002012', NULL, 'Transcriptional corepressor LEUNIG_HOMOLOG', 149, NULL, NULL, 213653),
(213654, '3.90.550.20-FF-000004', NULL, 'Glycosyltransferase family 32 protein', 242, NULL, NULL, 213654),
(213655, '2.60.120.200-FF-000628', NULL, 'Uncharacterized protein', 129, NULL, NULL, 213655),
(213656, '2.10.25.10-FF-000422', NULL, 'Adhesion G protein-coupled receptor E2', 39, NULL, NULL, 213656),
(213657, '3.40.50.11500-FF-000020', NULL, 'DENN/MADD domain containing 1A', 79, NULL, NULL, 213657),
(213658, '2.120.10.80-FF-000398', NULL, 'Uncharacterized protein', 150, NULL, NULL, 213658),
(213659, '3.20.20.80-FF-000726', NULL, 'Uncharacterized protein', 130, NULL, NULL, 213659),
(213660, '3.80.10.10-FF-000955', NULL, 'Volume-regulated anion channel subunit LRRC8B', 244, NULL, NULL, 213660),
(213661, '3.40.50.620-FF-000618', NULL, 'DUF218 domain protein (AFU_orthologue AFUA_7G01750)', 169, NULL, NULL, 213661),
(213662, '1.20.1070.10-FF-000655', NULL, 'Uncharacterized protein', 224, NULL, NULL, 213662),
(213663, '3.40.50.720-FF-000093', NULL, 'Erythronate-4-phosphate dehydrogenase', 166, NULL, NULL, 213663),
(213664, '1.25.40.20-FF-000024', NULL, 'Poly [ADP-ribose] polymerase', 131, NULL, NULL, 213664),
(213665, '1.20.120.160-FF-000031', NULL, 'Two-component system sensor histidine kinase', 111, NULL, NULL, 213665);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(213666, '2.60.40.10-FF-003029', NULL, '2 (Zwei) IG domain protein', 101, NULL, NULL, 213666),
(213667, '3.15.10.10-FF-000021', NULL, 'Cholesteryl ester transfer protein', 20, NULL, NULL, 213667),
(213668, '3.90.180.10-FF-000085', NULL, 'Alcohol dehydrogenase', 179, NULL, NULL, 213668),
(213669, '1.10.8.1220-FF-000007', NULL, 'Cytoplasmic dynein heavy chain 2', 94, NULL, NULL, 213669),
(213670, '3.20.20.80-FF-000417', NULL, 'Alpha-L-fucosidase, putative', 143, NULL, NULL, 213670),
(213671, '3.30.470.20-FF-000253', NULL, 'Uncharacterized protein', 272, NULL, NULL, 213671),
(213672, '1.20.1280.290-FF-000078', NULL, 'PQ loop repeat family protein', 104, NULL, NULL, 213672),
(213673, '1.10.510.10-FF-001340', NULL, 'STE family protein kinase', 284, NULL, NULL, 213673),
(213674, '3.20.20.190-FF-000140', NULL, NULL, 218, NULL, NULL, 213674),
(213675, '2.60.120.330-FF-000206', NULL, 'Uncharacterized protein', 125, NULL, NULL, 213675),
(213676, '2.60.120.10-FF-000108', NULL, 'cAMP-dependent protein kinase type II regulatory subunit', 145, NULL, NULL, 213676),
(213677, '3.90.650.10-FF-000060', NULL, 'Phosphoribosylformylglycinamidine synthase', 167, NULL, NULL, 213677),
(213678, '1.10.8.50-FF-000007', NULL, 'endonuclease 8-like 1 isoform X1', 149, NULL, NULL, 213678),
(213679, '2.60.40.1930-FF-000034', NULL, 'Uncharacterized protein', 70, NULL, NULL, 213679),
(213680, '3.40.50.1970-FF-000056', NULL, NULL, 155, NULL, NULL, 213680),
(213681, '3.90.1860.10-FF-000018', NULL, 'Uncharacterized protein', 274, NULL, NULL, 213681),
(213682, '1.25.10.10-FF-003173', NULL, 'Serine/threonine-protein kinase TOR', 330, NULL, NULL, 213682),
(213683, '3.30.230.10-FF-000378', NULL, 'LIn-8 Domain containing', 140, NULL, NULL, 213683),
(213684, '3.30.40.10-FF-000566', NULL, 'Histone-lysine N-methyltransferase', 54, NULL, NULL, 213684),
(213685, '3.30.710.10-FF-000488', NULL, 'Uncharacterized protein', 79, NULL, NULL, 213685),
(213686, '2.30.140.10-FF-000021', NULL, 'Polyamine aminopropyltransferase', 49, NULL, NULL, 213686),
(213687, '3.30.200.20-FF-001503', NULL, 'Uncharacterized protein', 116, NULL, NULL, 213687),
(213688, '3.40.50.410-FF-000308', NULL, 'Uncharacterized protein', 143, NULL, NULL, 213688),
(213689, '3.30.497.10-FF-000177', NULL, 'Serpin family C member 1', 181, NULL, NULL, 213689),
(213690, '3.30.200.20-FF-000879', NULL, 'Kinase, NEK', 80, NULL, NULL, 213690),
(213691, '2.130.10.10-FF-005031', NULL, 'Transducin/WD40 repeat-like superfamily protein', 302, NULL, NULL, 213691),
(213692, '3.20.20.70-FF-000414', NULL, 'D-arabino 3-hexulose 6-phosphate aldehyde lyase', 209, NULL, NULL, 213692),
(213693, '2.130.10.10-FF-003007', NULL, 'WD40-repeat-containing domain protein', 183, NULL, NULL, 213693),
(213694, '2.60.120.200-FF-000089', NULL, 'growth arrest-specific protein 6', 170, NULL, NULL, 213694),
(213695, '3.30.160.60-FF-003574', NULL, 'Uncharacterized protein', 39, NULL, NULL, 213695),
(213696, '3.30.40.10-FF-002348', NULL, 'Uncharacterized protein', 89, NULL, NULL, 213696),
(213697, '2.130.10.10-FF-003642', NULL, 'Uncharacterized protein', 105, NULL, NULL, 213697),
(213698, '1.10.287.770-FF-000002', NULL, 'Amiloride-sensitive sodium channel subunit beta 1', 61, NULL, NULL, 213698),
(213699, '2.60.40.10-FF-003338', NULL, NULL, 44, NULL, NULL, 213699),
(213700, '1.20.1070.10-FF-002095', NULL, 'Uncharacterized protein', 74, NULL, NULL, 213700),
(213701, '1.10.510.10-FF-000114', NULL, 'Tyrosine-protein kinase JAK2', 197, NULL, NULL, 213701),
(213702, '2.40.50.140-FF-000299', NULL, 'Glycerol-3-phosphate ABC transporter ATP-binding protein', 58, NULL, NULL, 213702),
(213703, '2.120.10.80-FF-000089', NULL, 'Acyl-CoA-binding domain-containing protein 4', 119, NULL, NULL, 213703),
(213704, '3.20.20.150-FF-000061', NULL, 'Protein arginine N-methyltransferase', 144, NULL, NULL, 213704),
(213705, '3.30.160.60-FF-000331', NULL, 'E3 ubiquitin-protein ligase RAD18', 30, NULL, NULL, 213705),
(213706, '1.25.40.180-FF-000348', NULL, NULL, 91, NULL, NULL, 213706),
(213707, '3.40.50.10420-FF-000010', NULL, '5-formyltetrahydrofolate cyclo-ligase', 176, NULL, NULL, 213707);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(213708, '3.30.1340.30-FF-000010', NULL, 'Type III export protein PscD', 68, NULL, NULL, 213708),
(213709, '3.30.70.1620-FF-000015', NULL, 'Structural maintenance of chromosomes protein', 64, NULL, NULL, 213709),
(213710, '1.25.10.10-FF-003392', NULL, 'Uncharacterized protein', 136, NULL, NULL, 213710),
(213711, '4.10.1000.10-FF-000128', NULL, 'Uncharacterized protein', 32, NULL, NULL, 213711),
(213712, '2.60.120.290-FF-000043', NULL, 'Enteropeptidase', 112, NULL, NULL, 213712),
(213713, '2.40.50.140-FF-000669', NULL, NULL, 67, NULL, NULL, 213713),
(213714, '3.40.50.300-FF-003176', NULL, 'Dda DNA helicase', 127, NULL, NULL, 213714),
(213715, '3.80.10.10-FF-003867', NULL, 'Endonuclease/Exonuclease/phosphatase family protein', 115, NULL, NULL, 213715),
(213716, '3.40.50.300-FF-005391', NULL, 'Uncharacterized protein', 199, NULL, NULL, 213716),
(213717, '3.60.130.10-FF-000044', NULL, 'TauD/TfdA family dioxygenase', 249, NULL, NULL, 213717),
(213718, '3.90.1030.10-FF-000006', NULL, '50S ribosomal protein L17', 116, NULL, NULL, 213718),
(213719, '2.30.30.140-FF-000022', NULL, 'Hydrogenase assembly chaperone HybG', 77, NULL, NULL, 213719),
(213720, '3.40.50.300-FF-007661', NULL, 'Predicted protein', 128, NULL, NULL, 213720),
(213721, '1.20.900.10-FF-000024', NULL, 'FYVE, RhoGEF and PH domain-containing protein 6', 214, NULL, NULL, 213721),
(213722, '3.40.390.10-FF-000247', NULL, NULL, 12, NULL, NULL, 213722),
(213723, '2.60.120.260-FF-000646', NULL, 'Uncharacterized protein', 99, NULL, NULL, 213723),
(213724, '3.90.550.10-FF-000310', NULL, '2-phospho-L-lactate guanylyltransferase', 180, NULL, NULL, 213724),
(213725, '2.10.50.10-FF-000154', NULL, 'Uncharacterized protein', 61, NULL, NULL, 213725),
(213726, '1.25.40.10-FF-003214', NULL, 'Putative pentatricopeptide repeat-containing protein At1g09680', 72, NULL, NULL, 213726),
(213727, '3.40.50.300-FF-003827', NULL, 'Replication factor C, subunit 4', 159, NULL, NULL, 213727),
(213728, '3.40.50.1100-FF-000115', NULL, 'Cysteine synthase', 106, NULL, NULL, 213728),
(213729, '1.20.5.110-FF-000073', NULL, 't-SNARE domain containing 1', 103, NULL, NULL, 213729),
(213730, '3.30.420.10-FF-000185', NULL, 'Unplaced genomic scaffold supercont2.5, whole genome shotgun sequence', 334, NULL, NULL, 213730),
(213731, '2.10.70.10-FF-000037', NULL, 'BMP-binding endothelial regulator protein-like', 33, NULL, NULL, 213731),
(213732, '3.30.70.330-FF-001061', NULL, 'Mip6p', 130, NULL, NULL, 213732),
(213733, '2.60.120.200-FF-000319', NULL, 'Laminin subunit alpha', 161, NULL, NULL, 213733),
(213734, '3.30.1520.10-FF-000035', NULL, 'Sorting nexin-4 protein', 136, NULL, NULL, 213734),
(213735, '2.30.30.140-FF-000050', NULL, 'AT-rich interactive domain 4A (RBP1-like)', 113, NULL, NULL, 213735),
(213736, '2.60.120.380-FF-000070', NULL, 'Calpain 14', 142, NULL, NULL, 213736),
(213737, '3.40.50.1110-FF-000118', NULL, 'Pectinesterase', 248, NULL, NULL, 213737),
(213738, '1.10.1540.10-FF-000003', NULL, 'WD repeat-containing protein 81 isoform X1', 252, NULL, NULL, 213738),
(213739, '3.30.460.10-FF-000171', NULL, 'Uncharacterized protein', 94, NULL, NULL, 213739),
(213740, '3.30.160.60-FF-000022', NULL, 'zinc finger protein 383 isoform X1', 28, NULL, NULL, 213740),
(213741, '6.20.40.20-FF-000001', NULL, 'Hemolysin', 48, NULL, NULL, 213741),
(213742, '3.90.550.10-FF-000001', NULL, 'Cellulose synthase', 143, NULL, NULL, 213742),
(213743, '3.40.250.10-FF-000068', NULL, 'Metallo-beta-lactamase family protein', 84, NULL, NULL, 213743),
(213744, '3.40.30.10-FF-000514', NULL, 'Glutathione peroxidase', 69, NULL, NULL, 213744),
(213745, '1.10.287.70-FF-000382', NULL, 'Cyclic Nucleotide Gated channel', 216, NULL, NULL, 213745),
(213746, '1.10.225.10-FF-000024', NULL, 'GG11904', 82, NULL, NULL, 213746),
(213747, '3.90.1150.10-FF-000425', NULL, 'Uncharacterized protein', 76, NULL, NULL, 213747),
(213748, '1.20.5.50-FF-000012', NULL, 'Cell division protein ZapA', 50, NULL, NULL, 213748),
(213749, '3.40.50.300-FF-001349', NULL, 'NLR family pyrin domain containing 6', 224, NULL, NULL, 213749);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(213750, '4.10.900.10-FF-000003', NULL, 'Desmoglein 1', 88, NULL, NULL, 213750),
(213751, '2.60.40.1730-FF-000053', NULL, 'Peptidase M1 family protein', 203, NULL, NULL, 213751),
(213752, '4.10.1080.10-FF-000009', NULL, 'Uncharacterized protein', 91, NULL, NULL, 213752),
(213753, '2.130.10.10-FF-003086', NULL, 'Uncharacterized protein', 94, NULL, NULL, 213753),
(213754, '2.30.40.10-FF-000153', NULL, 'Uncharacterized protein', 37, NULL, NULL, 213754),
(213755, '2.130.10.10-FF-001534', NULL, 'WD domain, G-beta repeat/PFU (PLAA family ubiquitin binding), putative', 116, NULL, NULL, 213755),
(213756, '3.90.70.20-FF-000001', NULL, 'Protein adenylyltransferase and cysteine protease IbpA', 183, NULL, NULL, 213756),
(213757, '3.40.50.720-FF-002537', NULL, 'Dihydrodipicolinate reductase, C-terminus family protein, expressed', 78, NULL, NULL, 213757),
(213758, '1.10.8.60-FF-000229', NULL, 'Replication factor C subunit 3/5', 59, NULL, NULL, 213758),
(213759, '3.90.70.80-FF-000086', NULL, 'OTU deubiquitinase 3', 92, NULL, NULL, 213759),
(213760, '1.25.10.10-FF-001251', NULL, 'Predicted protein', 229, NULL, NULL, 213760),
(213761, '3.40.50.11850-FF-000001', NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', 114, NULL, NULL, 213761),
(213762, '1.20.900.10-FF-000007', NULL, 'rho guanine nucleotide exchange factor 19', 225, NULL, NULL, 213762),
(213763, '3.30.160.60-FF-004659', NULL, NULL, 28, NULL, NULL, 213763),
(213764, '1.50.40.10-FF-000042', NULL, 'Envelope ADP,ATP carrier protein', 279, NULL, NULL, 213764),
(213765, '1.10.10.10-FF-001430', NULL, 'Metallopeptidase_family_M24_-_putative', 63, NULL, NULL, 213765),
(213766, '3.30.2320.80-FF-000001', NULL, 'Hydrogenase maturation factor HypA', 113, NULL, NULL, 213766),
(213767, '3.30.70.1230-FF-000224', NULL, 'Uncharacterized protein', 55, NULL, NULL, 213767),
(213768, '1.10.630.10-FF-000533', NULL, 'Uncharacterized protein', 379, NULL, NULL, 213768),
(213769, '3.90.1030.10-FF-000023', NULL, 'Mitochondrial ribosomal protein L17', 118, NULL, NULL, 213769),
(213770, '3.40.50.2000-FF-000857', NULL, 'UDP-glucuronosyltransferase', 227, NULL, NULL, 213770),
(213771, '3.40.50.150-FF-001490', NULL, NULL, 120, NULL, NULL, 213771),
(213772, '3.30.9.10-FF-000022', NULL, 'Pipecolic acid and sarcosine oxidase', 198, NULL, NULL, 213772),
(213773, '1.10.565.10-FF-000145', NULL, 'Uncharacterized protein', 372, NULL, NULL, 213773),
(213774, '1.20.1070.10-FF-001021', NULL, 'Odor receptor 1I', 173, NULL, NULL, 213774),
(213775, '3.40.30.10-FF-000312', NULL, 'redox-regulatory protein FAM213A isoform X1', 178, NULL, NULL, 213775),
(213776, '3.30.420.10-FF-000062', NULL, 'ERI1 exoribonuclease 2 isoform X1', 248, NULL, NULL, 213776),
(213777, '1.25.40.20-FF-001749', NULL, 'Uncharacterized protein', 206, NULL, NULL, 213777),
(213778, '1.20.1250.20-FF-000425', NULL, 'MFS transporter, putative', 199, NULL, NULL, 213778),
(213779, '1.20.1560.10-FF-000530', NULL, 'YALI0A11473p', 23, NULL, NULL, 213779),
(213780, '1.10.3810.10-FF-000018', NULL, 'Putative membrane carboxypeptidase', 125, NULL, NULL, 213780),
(213781, '3.40.50.300-FF-003148', NULL, 'Protein translocase subunit SecA', 143, NULL, NULL, 213781),
(213782, '3.30.160.20-FF-000134', NULL, 'Predicted protein', 46, NULL, NULL, 213782),
(213783, '1.10.238.10-FF-001307', NULL, 'CDPK-related kinase 1', 22, NULL, NULL, 213783),
(213784, '2.60.120.200-FF-000409', NULL, 'Apical endosomal glycoprotein', 159, NULL, NULL, 213784),
(213785, '2.40.128.700-FF-000001', NULL, 'Fatty acid synthase subunit beta, fungi type', 112, NULL, NULL, 213785),
(213786, '3.30.160.60-FF-001657', NULL, 'Zinc finger protein 142', 69, NULL, NULL, 213786),
(213787, '3.40.190.290-FF-000089', NULL, 'Transcriptional regulatory protein', 198, NULL, NULL, 213787),
(213788, '3.40.50.300-FF-005284', NULL, 'Ferrous iron transport protein B', 177, NULL, NULL, 213788),
(213789, '3.40.80.10-FF-000006', NULL, 'N-acetylmuramoyl-L-alanine amidase', 150, NULL, NULL, 213789),
(213790, '2.40.280.10-FF-000001', NULL, 'SsrA-binding protein', 129, NULL, NULL, 213790);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(213791, '3.40.630.30-FF-000502', NULL, 'Spore associated protein, SapD', 120, NULL, NULL, 213791),
(213792, '2.60.120.10-FF-000215', NULL, 'Crp/Fnr family transcriptional regulator', 128, NULL, NULL, 213792),
(213793, '1.20.58.60-FF-000503', NULL, 'Dystrophin-1', 298, NULL, NULL, 213793),
(213794, '3.10.580.10-FF-000122', NULL, 'Cystathionine beta-synthase', 156, NULL, NULL, 213794),
(213795, '3.30.70.330-FF-002472', NULL, NULL, 81, NULL, NULL, 213795),
(213796, '3.40.50.300-FF-002102', NULL, 'Putative DEAD box helicase', 204, NULL, NULL, 213796),
(213797, '1.25.10.10-FF-002684', NULL, 'Importin 11', 77, NULL, NULL, 213797),
(213798, '2.30.40.10-FF-000046', NULL, 'Guanine aminohydrolase, putative', 131, NULL, NULL, 213798),
(213799, '1.25.40.20-FF-000131', NULL, 'ankyrin repeat domain-containing protein 17 isoform X1', 66, NULL, NULL, 213799),
(213800, '2.130.10.10-FF-005340', NULL, 'Transducin/WD40 repeat-like superfamily protein', 183, NULL, NULL, 213800),
(213801, '2.170.240.10-FF-000001', NULL, 'Collagen IV alpha 1 chain', 229, NULL, NULL, 213801),
(213802, '3.40.50.1460-FF-000009', NULL, 'Caspase 2', 167, NULL, NULL, 213802),
(213803, '3.30.70.330-FF-002696', NULL, NULL, 115, NULL, NULL, 213803),
(213804, '3.40.50.1000-FF-000687', NULL, NULL, 145, NULL, NULL, 213804),
(213805, '3.40.50.360-FF-000035', NULL, 'NADPH-dependent FMN reductase', 188, NULL, NULL, 213805),
(213806, '3.40.50.1820-FF-000146', NULL, 'Acylamino-acid-releasing enzyme', 259, NULL, NULL, 213806),
(213807, '1.20.5.790-FF-000001', NULL, 'Spike glycoprotein', 48, NULL, NULL, 213807),
(213808, '1.10.510.10-FF-003133', NULL, NULL, 185, NULL, NULL, 213808),
(213809, '2.60.120.590-FF-000054', NULL, 'Alkylated DNA repair protein alkB-like protein 8', 196, NULL, NULL, 213809),
(213810, '2.130.10.10-FF-003333', NULL, 'Uncharacterized protein', 175, NULL, NULL, 213810),
(213811, '3.30.70.330-FF-000908', NULL, 'probable RNA-binding protein ARP1 isoform X1', 89, NULL, NULL, 213811),
(213812, '1.20.1740.10-FF-000151', NULL, 'Predicted protein', 439, NULL, NULL, 213812),
(213813, '2.130.10.10-FF-001079', NULL, 'Cell division control protein 4', 368, NULL, NULL, 213813),
(213814, '2.30.29.30-FF-000705', NULL, 'PH domain leucine-rich repeat-containing protein phosphatase 1', 105, NULL, NULL, 213814),
(213815, '3.30.40.10-FF-000347', NULL, 'rab effector Noc2 isoform X1', 133, NULL, NULL, 213815),
(213816, '3.30.160.60-FF-005367', NULL, NULL, 56, NULL, NULL, 213816),
(213817, '1.25.40.10-FF-002848', NULL, 'Pentatricopeptide repeat-containing protein', 114, NULL, NULL, 213817),
(213818, '3.50.50.60-FF-000564', NULL, 'Putative transcriptional regulator', 164, NULL, NULL, 213818),
(213819, '3.40.50.150-FF-001725', NULL, NULL, 189, NULL, NULL, 213819),
(213820, '1.20.1420.10-FF-000020', NULL, 'Putative cyclin-d1-binding protein 1 log isoform 2', 106, NULL, NULL, 213820),
(213821, '3.30.1240.10-FF-000069', NULL, 'Uncharacterized hydrolase C25B8.12c', 115, NULL, NULL, 213821),
(213822, '3.30.200.20-FF-001812', NULL, 'Kinase, NEK', 82, NULL, NULL, 213822),
(213823, '3.50.50.60-FF-001362', NULL, 'Monooxygenase, putative', 75, NULL, NULL, 213823),
(213824, '3.90.650.10-FF-000043', NULL, 'Phosphoribosylformylglycinamide synthase', 188, NULL, NULL, 213824),
(213825, '3.40.850.10-FF-000417', NULL, 'Kinesin motor domain containing protein', 213, NULL, NULL, 213825),
(213826, '3.30.450.20-FF-000229', NULL, 'Methyl-accepting chemotaxis sensory transducer', 126, NULL, NULL, 213826),
(213827, '3.40.630.30-FF-000300', NULL, 'GNAT family N-acetyltransferase', 143, NULL, NULL, 213827),
(213828, '1.10.390.10-FF-000042', NULL, 'Aminopeptidase', 256, NULL, NULL, 213828),
(213829, '3.50.50.60-FF-001053', NULL, 'Uncharacterized protein', 119, NULL, NULL, 213829),
(213830, '3.30.430.20-FF-000037', NULL, 'Cysteine-rich receptor-like protein kinase 29', 97, NULL, NULL, 213830),
(213831, '1.25.10.10-FF-000885', NULL, 'GPI inositol-deacylase', 139, NULL, NULL, 213831),
(213832, '3.40.50.410-FF-000218', NULL, 'Uncharacterized protein', 184, NULL, NULL, 213832),
(213833, '3.30.70.2610-FF-000009', NULL, 'General transcription factor IIH subunit 4', 48, NULL, NULL, 213833);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(213834, '1.10.472.10-FF-000278', NULL, 'Putative cyclin-D7-1', 103, NULL, NULL, 213834),
(213835, '3.40.50.150-FF-001832', NULL, NULL, 66, NULL, NULL, 213835),
(213836, '6.10.140.2220-FF-000050', NULL, 'SET domain-containing protein SmydA-8, isoform B', 54, NULL, NULL, 213836),
(213837, '3.30.300.110-FF-000019', NULL, 'Uncharacterized protein', 64, NULL, NULL, 213837),
(213838, '3.30.160.60-FF-001096', NULL, 'zinc finger protein 32 isoform X1', 29, NULL, NULL, 213838),
(213839, '1.10.510.10-FF-000699', NULL, 'Probable serine/threonine-protein kinase iksA', 244, NULL, NULL, 213839),
(213840, '2.30.29.30-FF-000357', NULL, 'Kinesin family protein', 121, NULL, NULL, 213840),
(213841, '1.20.1250.10-FF-000085', NULL, 'Colony stimulating factor 2 (Granulocyte-macrophage)', 124, NULL, NULL, 213841),
(213842, '3.40.50.720-FF-002447', NULL, 'Uncharacterized protein', 96, NULL, NULL, 213842),
(213843, '3.40.190.10-FF-000698', NULL, 'Opine/polyamine ABC transporter, periplasmic substrate-binding protein', 183, NULL, NULL, 213843),
(213844, '2.130.10.10-FF-001388', NULL, 'PWP2 small subunit processome component', 205, NULL, NULL, 213844),
(213845, '1.20.1560.10-FF-000069', NULL, 'Multidrug ABC transporter ATP-binding protein', 323, NULL, NULL, 213845),
(213846, '1.20.5.300-FF-000006', NULL, 'Spike glycoprotein', 61, NULL, NULL, 213846),
(213847, '2.30.40.10-FF-000063', NULL, 'Uncharacterized protein', 54, NULL, NULL, 213847),
(213848, '2.130.10.10-FF-001208', NULL, 'Cft1p', 400, NULL, NULL, 213848),
(213849, '2.60.40.10-FF-001663', NULL, 'titin isoform X1', 97, NULL, NULL, 213849),
(213850, '2.130.10.10-FF-005901', NULL, 'DENN domain-containing protein 3', 283, NULL, NULL, 213850),
(213851, '3.40.50.1010-FF-000223', NULL, NULL, 106, NULL, NULL, 213851),
(213852, '1.10.630.10-FF-000207', NULL, 'Putative cytochrome P450 superfamily protein', 208, NULL, NULL, 213852),
(213853, '3.60.130.10-FF-000061', NULL, 'Uncharacterized protein', 329, NULL, NULL, 213853),
(213854, '3.40.50.2300-FF-001032', NULL, NULL, 111, NULL, NULL, 213854),
(213855, '2.10.25.10-FF-001748', NULL, 'Uncharacterized protein', 56, NULL, NULL, 213855),
(213856, '3.40.50.300-FF-003822', NULL, 'Chromatin-remodeling ATPase INO80', 174, NULL, NULL, 213856),
(213857, '3.40.50.300-FF-001259', NULL, 'Anion-transporting ATPase', 285, NULL, NULL, 213857),
(213858, '1.10.8.60-FF-000145', NULL, 'ATP-dependent protease La', 93, NULL, NULL, 213858),
(213859, '1.10.150.240-FF-000086', NULL, 'Phosphoglycolate phosphatase', 61, NULL, NULL, 213859),
(213860, '3.40.50.1860-FF-000006', NULL, 'Glutamate racemase', 98, NULL, NULL, 213860),
(213861, '3.90.1200.10-FF-000042', NULL, 'Aminoglycoside phosphotransferase', 225, NULL, NULL, 213861),
(213862, '3.60.140.10-FF-000016', NULL, 'Polyphenol oxidase', 212, NULL, NULL, 213862),
(213863, '2.30.140.10-FF-000004', NULL, 'Polyamine aminopropyltransferase', 53, NULL, NULL, 213863),
(213864, '1.25.40.20-FF-000440', NULL, 'Receptor interacting serine/threonine kinase 4', 156, NULL, NULL, 213864),
(213865, '3.40.50.150-FF-001164', NULL, 'tRNA wybutosine-synthesizing protein 4', 339, NULL, NULL, 213865),
(213866, '2.40.30.10-FF-000011', NULL, 'Eukaryotic translation initiation factor 2 subunit gamma', 100, NULL, NULL, 213866),
(213867, '3.40.50.12230-FF-000014', NULL, 'Methionyl-tRNA formyltransferase', 323, NULL, NULL, 213867),
(213868, '1.20.1280.50-FF-000020', NULL, 'F-box only protein 4 (Predicted)', 92, NULL, NULL, 213868),
(213869, '3.80.10.10-FF-002872', NULL, 'Uncharacterized protein', 78, NULL, NULL, 213869),
(213870, '3.90.1150.10-FF-000279', NULL, 'Bifunctional dethiobiotin synthetase/7,8-diamino-pelargonic acid aminotransferase', 106, NULL, NULL, 213870),
(213871, '3.40.309.10-FF-000082', NULL, 'Uncharacterized protein', 188, NULL, NULL, 213871),
(213872, '1.10.1760.20-FF-000011', NULL, 'Riboflavin transporter', 188, NULL, NULL, 213872),
(213873, '2.60.120.770-FF-000001', NULL, 'Spike protein P1', 89, NULL, NULL, 213873),
(213874, '3.30.70.1220-FF-000002', NULL, 'RNA polymerase II transcription factor B subunit 5', 70, NULL, NULL, 213874);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(213875, '1.10.10.60-FF-001068', NULL, NULL, 76, NULL, NULL, 213875),
(213876, '3.60.20.10-FF-000176', NULL, NULL, 143, NULL, NULL, 213876),
(213877, '3.30.9.10-FF-000241', NULL, 'FAD-dependent oxidoreductase family protein', 39, NULL, NULL, 213877),
(213878, '3.40.50.150-FF-001506', NULL, NULL, 111, NULL, NULL, 213878),
(213879, '1.10.630.10-FF-000078', NULL, 'Probable cytochrome P450 515A1', 465, NULL, NULL, 213879),
(213880, '2.130.10.10-FF-003114', NULL, 'Echinoderm microtubule-associated protein-like elp-1', 271, NULL, NULL, 213880),
(213881, '3.40.50.300-FF-003513', NULL, '6-phosphofructo-2-kinase/fructose-2, 6-bisphosphatase 1 isoform X1', 208, NULL, NULL, 213881),
(213882, '6.10.140.2220-FF-000033', NULL, 'Predicted protein', 58, NULL, NULL, 213882),
(213883, '2.130.10.10-FF-003423', NULL, 'Vacuolar protein sorting/targeting protein 10', 177, NULL, NULL, 213883),
(213884, '2.60.40.60-FF-001094', NULL, 'Uncharacterized protein', 105, NULL, NULL, 213884),
(213885, '3.40.50.300-FF-005065', NULL, 'Uncharacterized protein', 134, NULL, NULL, 213885),
(213886, '3.40.50.10240-FF-000035', NULL, 'Thiamine pyrophosphokinase', 228, NULL, NULL, 213886),
(213887, '1.50.10.10-FF-000214', NULL, 'Uncharacterized protein', 136, NULL, NULL, 213887),
(213888, '1.10.10.10-FF-000896', NULL, 'ETS domain-containing protein Elk-3', 111, NULL, NULL, 213888),
(213889, '2.60.220.50-FF-000151', NULL, 'Uncharacterized protein', 180, NULL, NULL, 213889),
(213890, '3.40.190.80-FF-000011', NULL, 'Fructose-1,6-bisphosphatase class 1', 141, NULL, NULL, 213890),
(213891, '3.80.10.10-FF-002563', NULL, 'SUMO-specific peptidase 7a', 129, NULL, NULL, 213891),
(213892, '3.30.960.10-FF-000006', NULL, 'Eukaryotic peptide chain release factor subunit 1-3', 30, NULL, NULL, 213892),
(213893, '3.40.50.720-FF-000963', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', 192, NULL, NULL, 213893),
(213894, '1.20.5.170-FF-000153', NULL, 'Trans-activator protein BZLF1', 63, NULL, NULL, 213894),
(213895, '1.20.5.110-FF-000056', NULL, 'Bet1-like protein At4g14600', 59, NULL, NULL, 213895),
(213896, '3.40.50.2000-FF-000548', NULL, 'Glycosyltransferase', 141, NULL, NULL, 213896),
(213897, '3.30.160.60-FF-003350', NULL, NULL, 28, NULL, NULL, 213897),
(213898, '2.60.120.330-FF-000201', NULL, 'Uncharacterized protein', 132, NULL, NULL, 213898),
(213899, '3.30.1370.110-FF-000026', NULL, 'Smr domain-containing protein C11H11.03c', 99, NULL, NULL, 213899),
(213900, '1.20.120.1080-FF-000100', NULL, 'Protein CBG12480', 195, NULL, NULL, 213900),
(213901, '1.10.10.10-FF-000587', NULL, 'Forkhead box P1', 112, NULL, NULL, 213901),
(213902, '1.50.40.10-FF-000603', NULL, 'Uncharacterized protein', 85, NULL, NULL, 213902),
(213903, '3.40.50.300-FF-001568', NULL, 'ATP-dependent Clp protease, putative', 267, NULL, NULL, 213903),
(213904, '3.30.60.220-FF-000003', NULL, NULL, 55, NULL, NULL, 213904),
(213905, '3.90.1480.20-FF-000020', NULL, 'Uncharacterized protein', 290, NULL, NULL, 213905),
(213906, '3.40.50.720-FF-002228', NULL, 'Uncharacterized protein', 102, NULL, NULL, 213906),
(213907, '2.130.10.10-FF-001169', NULL, 'Bardet-Biedl syndrome 7 protein homolog', 245, NULL, NULL, 213907),
(213908, '3.30.160.60-FF-005682', NULL, NULL, 72, NULL, NULL, 213908),
(213909, '2.60.120.10-FF-000524', NULL, 'Uncharacterized protein', 131, NULL, NULL, 213909),
(213910, '1.20.1560.10-FF-000378', NULL, 'ABC transporter HlyB/MsbA family', 337, NULL, NULL, 213910),
(213911, '1.10.287.770-FF-000007', NULL, 'Diadenylate cyclase', 69, NULL, NULL, 213911),
(213912, '3.20.20.80-FF-000743', NULL, 'Putative glucan endo-13-beta-glucosidase BG1', 76, NULL, NULL, 213912),
(213913, '3.30.1450.10-FF-000006', NULL, 'Outer membrane protein assembly factor BamE', 76, NULL, NULL, 213913),
(213914, '3.30.70.1230-FF-000005', NULL, 'Guanylate cyclase soluble subunit beta-1', 200, NULL, NULL, 213914),
(213915, '2.30.42.10-FF-000354', NULL, 'protein inturned isoform X2', 149, NULL, NULL, 213915),
(213916, '1.20.1050.130-FF-000018', NULL, 'tRNA-binding region domain-containing protein', 115, NULL, NULL, 213916);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(213917, '3.40.5.120-FF-000008', NULL, 'Protein partner of snf, isoform A', 51, NULL, NULL, 213917),
(213918, '3.50.50.60-FF-000783', NULL, 'Glycerol-3-phosphate dehydrogenase (FAD-dependent), putative', 196, NULL, NULL, 213918),
(213919, '1.20.920.10-FF-000109', NULL, 'GM15561', 118, NULL, NULL, 213919),
(213920, '2.60.120.780-FF-000004', NULL, 'Sumo ligase', 140, NULL, NULL, 213920),
(213921, '3.90.10.10-FF-000005', NULL, NULL, 108, NULL, NULL, 213921),
(213922, '3.30.930.10-FF-000162', NULL, 'Lysyl-tRNA synthetase', 57, NULL, NULL, 213922),
(213923, '1.10.287.160-FF-000004', NULL, 'Protein kinase C', 68, NULL, NULL, 213923),
(213924, '1.20.1050.10-FF-000295', NULL, 'Uncharacterized protein', 86, NULL, NULL, 213924),
(213925, '2.40.30.20-FF-000014', NULL, 'Riboflavin synthase, alpha subunit', 88, NULL, NULL, 213925),
(213926, '1.10.10.60-FF-001158', NULL, NULL, 98, NULL, NULL, 213926),
(213927, '2.30.30.100-FF-000167', NULL, 'Predicted protein', 92, NULL, NULL, 213927),
(213928, '1.10.510.10-FF-002031', NULL, NULL, 137, NULL, NULL, 213928),
(213929, '1.10.630.10-FF-000168', NULL, 'Cytochrome P450', 442, NULL, NULL, 213929),
(213930, '3.40.50.800-FF-000009', NULL, 'Eukaryotic translation initiation factor 2-alpha kinase', 100, NULL, NULL, 213930),
(213931, '2.40.50.90-FF-000137', NULL, 'Putative ATP-dependent RNA helicase SoYb', 90, NULL, NULL, 213931),
(213932, '1.10.10.60-FF-000669', NULL, 'Helicase, putative', 81, NULL, NULL, 213932),
(213933, '2.40.30.30-FF-000017', NULL, 'Uncharacterized protein B2G14.030', 178, NULL, NULL, 213933),
(213934, '3.60.90.10-FF-000034', NULL, 'Putative S-adenosylmethionine decarboxylase proenzyme-like', 82, NULL, NULL, 213934),
(213935, '3.30.200.20-FF-002459', NULL, NULL, 55, NULL, NULL, 213935),
(213936, '2.140.10.30-FF-000005', NULL, 'Dipeptidyl peptidase 9', 417, NULL, NULL, 213936),
(213937, '3.80.10.10-FF-003974', NULL, 'Uncharacterized protein', 161, NULL, NULL, 213937),
(213938, '3.90.190.10-FF-000338', NULL, 'Uncharacterized protein', 188, NULL, NULL, 213938),
(213939, '3.30.160.60-FF-003911', NULL, NULL, 76, NULL, NULL, 213939),
(213940, '1.10.150.20-FF-000281', NULL, 'Uncharacterized protein', 84, NULL, NULL, 213940),
(213941, '1.20.120.310-FF-000019', NULL, NULL, 86, NULL, NULL, 213941),
(213942, '1.25.40.20-FF-000114', NULL, 'ankyrin repeat and KH domain-containing protein 1 isoform X2', 117, NULL, NULL, 213942),
(213943, '1.20.58.60-FF-000470', NULL, 'AGAP011396-PA', 186, NULL, NULL, 213943),
(213944, '2.60.120.650-FF-000185', NULL, 'Uncharacterized protein', 93, NULL, NULL, 213944),
(213945, '3.30.740.10-FF-000018', NULL, 'Dynein light chain', 82, NULL, NULL, 213945),
(213946, '3.30.420.270-FF-000032', NULL, 'Glr1388 protein', 69, NULL, NULL, 213946),
(213947, '3.40.50.300-FF-007644', NULL, 'GTP-binding protein 1', 138, NULL, NULL, 213947),
(213948, '3.40.50.1820-FF-000129', NULL, 'Autophagy related lipase Atg15, putative', 256, NULL, NULL, 213948),
(213949, '3.80.10.10-FF-000287', NULL, 'adhesion G protein-coupled receptor A3', 197, NULL, NULL, 213949),
(213950, '1.25.40.570-FF-000027', NULL, 'COP9 signalosome complex subunit 1', 339, NULL, NULL, 213950),
(213951, '1.20.120.1030-FF-000001', NULL, 'Motility gene repressor MogR', 125, NULL, NULL, 213951),
(213952, '1.10.10.60-FF-000888', NULL, NULL, 76, NULL, NULL, 213952),
(213953, '3.40.50.300-FF-004896', NULL, 'P-loop containing nucleoside triphosphate hydrolases superfamily protein', 231, NULL, NULL, 213953),
(213954, '3.30.160.60-FF-001298', NULL, 'zinc finger protein 23 isoform X1', 30, NULL, NULL, 213954),
(213955, '1.25.40.550-FF-000021', NULL, 'AAR2-splicing factor', 64, NULL, NULL, 213955),
(213956, '2.60.40.10-FF-001337', NULL, 'T-cell surface glycoprotein CD3 gamma chain', 82, NULL, NULL, 213956),
(213957, '1.25.40.570-FF-000033', NULL, 'PCI domain containing protein', 361, NULL, NULL, 213957),
(213958, '2.30.29.30-FF-000576', NULL, 'Vacuolar sorting protein', 113, NULL, NULL, 213958),
(213959, '1.25.40.860-FF-000013', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 98, NULL, NULL, 213959);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(213960, '3.40.720.10-FF-000161', NULL, 'Putative arylsulfatase', 361, NULL, NULL, 213960),
(213961, '3.40.50.300-FF-003844', NULL, 'WHiTe (Drosophila) related ABC transporter', 174, NULL, NULL, 213961),
(213962, '3.40.50.1110-FF-000012', NULL, 'SPI-2 type III secretion system effector SseJ', 269, NULL, NULL, 213962),
(213963, '1.25.40.10-FF-000111', NULL, 'tetratricopeptide repeat protein 17 isoform X1', 138, NULL, NULL, 213963),
(213964, '3.90.190.10-FF-000029', NULL, 'Phosphatidylinositol 3,4,5-trisphosphate 3-phosphatase and dual-specificity protein phosphatase PTEN', 186, NULL, NULL, 213964),
(213965, '4.10.410.10-FF-000112', NULL, 'Uncharacterized protein', 76, NULL, NULL, 213965),
(213966, '3.30.420.10-FF-000168', NULL, 'Exonuclease', 199, NULL, NULL, 213966),
(213967, '3.90.228.10-FF-000005', NULL, 'Poly [ADP-ribose] polymerase', 177, NULL, NULL, 213967),
(213968, '3.20.20.80-FF-000182', NULL, 'Beta-glucosidase 1A', 460, NULL, NULL, 213968),
(213969, '2.60.120.330-FF-000190', NULL, 'Uncharacterized protein', 176, NULL, NULL, 213969),
(213970, '3.30.930.10-FF-000145', NULL, 'Holocarboxylase synthetase, isoform D', 201, NULL, NULL, 213970),
(213971, '3.40.50.2300-FF-000734', NULL, 'Two-component system sensor histidine kinase/response regulator', 145, NULL, NULL, 213971),
(213972, '3.40.50.410-FF-000191', NULL, 'Protein transport protein SEC23', 290, NULL, NULL, 213972),
(213973, '3.30.160.60-FF-003439', NULL, 'zinc finger and BTB domain-containing protein 47 isoform X1', 26, NULL, NULL, 213973),
(213974, '2.60.40.420-FF-000275', NULL, 'Uncharacterized protein', 46, NULL, NULL, 213974),
(213975, '3.90.1150.10-FF-000189', NULL, 'S phingosine-1-phosphate lyase 1, putative', 133, NULL, NULL, 213975),
(213976, '3.40.50.1460-FF-000010', NULL, 'putative GPI-anchor transamidase', 278, NULL, NULL, 213976),
(213977, '3.30.160.60-FF-005148', NULL, NULL, 28, NULL, NULL, 213977),
(213978, '3.60.40.10-FF-000284', NULL, 'protein phosphatase 1G', 144, NULL, NULL, 213978),
(213979, '3.30.559.10-FF-000282', NULL, 'Choline O-acetyltransferase', 130, NULL, NULL, 213979),
(213980, '2.40.420.20-FF-000015', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 78, NULL, NULL, 213980),
(213981, '2.30.39.10-FF-000071', NULL, 'Serpin B3', 114, NULL, NULL, 213981),
(213982, '1.20.1420.10-FF-000003', NULL, 'Talin 2', 170, NULL, NULL, 213982),
(213983, '1.10.510.10-FF-002969', NULL, NULL, 140, NULL, NULL, 213983),
(213984, '3.30.200.20-FF-001048', NULL, 'Px serine/threonine kinase (Pxk)', 19, NULL, NULL, 213984),
(213985, '2.130.10.10-FF-000697', NULL, 'WD repeat protein, variant', 329, NULL, NULL, 213985),
(213986, '3.30.450.210-FF-000003', NULL, 'Periplasmic stress-responsive two component signal transduction system histidine kinase CpxA', 109, NULL, NULL, 213986),
(213987, '3.50.50.60-FF-001036', NULL, 'Uncharacterized protein', 67, NULL, NULL, 213987),
(213988, '1.25.40.20-FF-001109', NULL, 'Ankyrin repeat protein', 41, NULL, NULL, 213988),
(213989, '1.10.238.10-FF-001268', NULL, 'Uncharacterized protein', 52, NULL, NULL, 213989),
(213990, '3.30.365.10-FF-000011', NULL, 'Carbon monoxide dehydrogenase, large subunit', 129, NULL, NULL, 213990),
(213991, '1.10.10.10-FF-000935', NULL, 'Osomolarity two-component system, response regulator SKN7', 123, NULL, NULL, 213991),
(213992, '3.40.50.720-FF-000177', NULL, 'Retinol dehydrogenase 10', 269, NULL, NULL, 213992),
(213993, '3.30.420.410-FF-000001', NULL, 'Nucleoprotein', 208, NULL, NULL, 213993),
(213994, '1.10.510.10-FF-003442', NULL, NULL, 281, NULL, NULL, 213994),
(213995, '3.40.50.150-FF-000798', NULL, NULL, 96, NULL, NULL, 213995),
(213996, '1.10.840.10-FF-000015', NULL, 'Uncharacterized protein, isoform A', 331, NULL, NULL, 213996),
(213997, '3.30.450.70-FF-000019', NULL, 'Sybindin-like family, putative', 148, NULL, NULL, 213997),
(213998, '2.60.40.10-FF-001192', NULL, 'Aggrecan core protein', 120, NULL, NULL, 213998),
(213999, '3.30.160.60-FF-002023', NULL, 'E3 ubiquitin-protein ligase TRIM68', 72, NULL, NULL, 213999),
(214000, '3.30.710.10-FF-000415', NULL, 'Uncharacterized protein', 130, NULL, NULL, 214000);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(214001, '3.30.160.60-FF-001309', NULL, 'Uncharacterized protein', 28, NULL, NULL, 214001),
(214002, '3.30.40.10-FF-000549', NULL, 'RING/FYVE/PHD-type zinc finger family protein', 48, NULL, NULL, 214002),
(214003, '1.25.40.20-FF-001750', NULL, 'Uncharacterized protein', 203, NULL, NULL, 214003),
(214004, '3.60.70.12-FF-000007', NULL, 'Arginine biosynthesis bifunctional protein ArgJ', 258, NULL, NULL, 214004),
(214005, '1.20.1740.10-FF-000257', NULL, 'Uncharacterized protein', 275, NULL, NULL, 214005),
(214006, '1.20.1250.20-FF-000195', NULL, 'monocarboxylate transporter 9 isoform X1', 192, NULL, NULL, 214006),
(214007, '3.90.1150.10-FF-000296', NULL, 'Transcriptional regulator, GntR family', 140, NULL, NULL, 214007),
(214008, '1.25.10.10-FF-003408', NULL, 'Uncharacterized protein', 57, NULL, NULL, 214008),
(214009, '1.20.58.60-FF-000357', NULL, 'SMAll', 105, NULL, NULL, 214009),
(214010, '3.30.470.20-FF-000118', NULL, 'Formate-dependent phosphoribosylglycinamide formyltransferase', 200, NULL, NULL, 214010),
(214011, '3.10.250.10-FF-000131', NULL, NULL, 127, NULL, NULL, 214011),
(214012, '2.130.10.10-FF-004968', NULL, 'F-box and WD domain protein, putative', 86, NULL, NULL, 214012),
(214013, '3.30.930.10-FF-000252', NULL, 'Uncharacterized protein', 159, NULL, NULL, 214013),
(214014, '2.10.110.10-FF-000187', NULL, 'LIM and Rho-GAP domain-containing protein', 71, NULL, NULL, 214014),
(214015, '2.30.29.30-FF-000048', NULL, 'Ras association (RalGDS/AF-6) and pleckstrin homology domains 1', 166, NULL, NULL, 214015),
(214016, '3.60.10.10-FF-000260', NULL, 'Endonuclease/exonuclease/phosphatase', 225, NULL, NULL, 214016),
(214017, '2.60.40.10-FF-002973', NULL, 'Tyrosine-protein phosphatase 4', 93, NULL, NULL, 214017),
(214018, '2.60.40.60-FF-000110', NULL, 'FAT atypical cadherin 4', 114, NULL, NULL, 214018),
(214019, '1.25.10.10-FF-001267', NULL, 'Putative transformation/transcription domain-associated protein', 291, NULL, NULL, 214019),
(214020, '1.10.10.60-FF-000995', NULL, NULL, 50, NULL, NULL, 214020),
(214021, '1.20.1250.20-FF-000408', NULL, 'Major facilitator superfamily domain containing 4B', 189, NULL, NULL, 214021),
(214022, '3.40.50.150-FF-001523', NULL, NULL, 105, NULL, NULL, 214022),
(214023, '3.40.710.10-FF-000132', NULL, 'Penicillin-binding protein 1B', 352, NULL, NULL, 214023),
(214024, '1.10.472.10-FF-000587', NULL, 'Os02g0627800 protein', 36, NULL, NULL, 214024),
(214025, '2.130.10.10-FF-005115', NULL, 'Striatin, calmodulin-binding protein 4', 176, NULL, NULL, 214025),
(214026, '3.80.10.10-FF-002541', NULL, 'Uncharacterized protein', 247, NULL, NULL, 214026),
(214027, '1.20.1070.10-FF-002128', NULL, 'RpkA', 277, NULL, NULL, 214027),
(214028, '1.10.10.2830-FF-000007', NULL, 'Partitioning protein', 112, NULL, NULL, 214028),
(214029, '3.30.450.50-FF-000013', NULL, 'Synaptobrevin homolog YKT6', 140, NULL, NULL, 214029),
(214030, '2.130.10.10-FF-001843', NULL, 'Putative serine threonine kinase irei protein', 193, NULL, NULL, 214030),
(214031, '2.60.40.10-FF-005137', NULL, NULL, 96, NULL, NULL, 214031),
(214032, '2.10.80.10-FF-000010', NULL, 'AmphiDkk3', 84, NULL, NULL, 214032),
(214033, '1.25.40.470-FF-000019', NULL, 'Transducin/WD40 repeat-like superfamily protein', 212, NULL, NULL, 214033),
(214034, '3.40.50.150-FF-001416', NULL, NULL, 158, NULL, NULL, 214034),
(214035, '3.90.70.80-FF-000069', NULL, 'Ubiquitin thioesterase otu2', 152, NULL, NULL, 214035),
(214036, '3.40.50.720-FF-001958', NULL, 'ABR076Cp', 258, NULL, NULL, 214036),
(214037, '1.25.20.10-FF-000003', NULL, 'Putative soluble lytic murein transglycosylase', 357, NULL, NULL, 214037),
(214038, '2.130.10.10-FF-000899', NULL, 'Chromosome 15, whole genome shotgun sequence', 371, NULL, NULL, 214038),
(214039, '3.30.160.20-FF-000151', NULL, 'Endoribonuclease Dicer homolog 2', 78, NULL, NULL, 214039),
(214040, '1.10.630.10-FF-000842', NULL, 'Uncharacterized protein', 188, NULL, NULL, 214040),
(214041, '3.30.450.60-FF-000016', NULL, 'Signal recognition particle receptor subunit alpha', 125, NULL, NULL, 214041),
(214042, '1.25.10.10-FF-003156', NULL, 'Serine/threonine-protein kinase TOR', 418, NULL, NULL, 214042);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(214043, '3.30.760.10-FF-000019', NULL, 'Eukaryotic translation initiation factor, putative', 208, NULL, NULL, 214043),
(214044, '3.40.1110.10-FF-000237', NULL, NULL, 94, NULL, NULL, 214044),
(214045, '1.10.510.10-FF-001188', NULL, 'Predicted protein', 181, NULL, NULL, 214045),
(214046, '1.20.1560.10-FF-000159', NULL, 'multidrug resistance-associated protein 7', 313, NULL, NULL, 214046),
(214047, '4.10.80.40-FF-000003', NULL, 'Fumarate reductase flavoprotein subunit', 35, NULL, NULL, 214047),
(214048, '3.30.470.10-FF-000008', NULL, 'D-amino-acid transaminase, chloroplastic', 139, NULL, NULL, 214048),
(214049, '3.60.10.10-FF-000147', NULL, 'Suppressor of actin, putative', 198, NULL, NULL, 214049),
(214050, '3.90.1150.10-FF-000509', NULL, 'Cysteine desulfurase', 99, NULL, NULL, 214050),
(214051, '3.30.479.10-FF-000005', NULL, '6-pyruvoyl tetrahydropterin synthase', 132, NULL, NULL, 214051),
(214052, '3.20.20.70-FF-000072', NULL, '4-hydroxy-2-oxovalerate aldolase', 267, NULL, NULL, 214052),
(214053, '3.40.50.620-FF-000388', NULL, 'Adenine nucleotide alpha hydrolases-like superfamily protein', 144, NULL, NULL, 214053),
(214054, '3.30.70.270-FF-000071', NULL, 'Sensor domain-containing diguanylate cyclase', 148, NULL, NULL, 214054),
(214055, '1.10.287.70-FF-000067', NULL, 'glutamate receptor 2 isoform X1', 159, NULL, NULL, 214055),
(214056, '3.30.70.1230-FF-000022', NULL, 'Receptor-type adenylate cyclase GRESAG 4, putative', 235, NULL, NULL, 214056),
(214057, '2.40.50.40-FF-000038', NULL, 'Chromo domain-containing protein 1', 121, NULL, NULL, 214057),
(214058, '2.30.42.10-FF-000337', NULL, NULL, 101, NULL, NULL, 214058),
(214059, '3.30.479.20-FF-000008', NULL, 'Elongation factor Ts, mitochondrial', 117, NULL, NULL, 214059),
(214060, '1.10.630.10-FF-000623', NULL, 'Uncharacterized protein', 234, NULL, NULL, 214060),
(214061, '4.10.240.10-FF-000211', NULL, 'Uncharacterized protein', 67, NULL, NULL, 214061),
(214062, '3.20.20.80-FF-000075', NULL, 'Sporulation-specific chitinase', 280, NULL, NULL, 214062),
(214063, '3.40.50.1820-FF-000932', NULL, 'Alpha/Beta hydrolase protein', 354, NULL, NULL, 214063),
(214064, '2.130.10.10-FF-001624', NULL, 'WD domain, G-beta repeat-containing protein', 227, NULL, NULL, 214064),
(214065, '3.90.70.200-FF-000025', NULL, 'Uncharacterized protein', 98, NULL, NULL, 214065),
(214066, '3.40.50.720-FF-000429', NULL, 'NAD-specific glutamate dehydrogenase', 270, NULL, NULL, 214066),
(214067, '2.60.120.920-FF-000052', NULL, 'CBN-UNC-68 protein', 169, NULL, NULL, 214067),
(214068, '2.40.30.20-FF-000031', NULL, 'Yellow fluorescent protein', 93, NULL, NULL, 214068),
(214069, '3.40.50.12360-FF-000002', NULL, 'HDA1 complex subunit 2', 201, NULL, NULL, 214069),
(214070, '2.60.120.200-FF-000398', NULL, 'Putative L-type lectin-domain containing receptor kinase S.7', 254, NULL, NULL, 214070),
(214071, '3.30.710.10-FF-000179', NULL, 'Rho-related BTB domain-containing protein 2', 87, NULL, NULL, 214071),
(214072, '3.30.1490.330-FF-000001', NULL, 'Bifunctional glutathionylspermidine synthetase/amidase', 82, NULL, NULL, 214072),
(214073, '2.60.40.10-FF-005244', NULL, NULL, 114, NULL, NULL, 214073),
(214074, '3.30.160.60-FF-003243', NULL, NULL, 30, NULL, NULL, 214074),
(214075, '3.40.50.1820-FF-000461', NULL, 'Alpha/beta fold hydrolase', 280, NULL, NULL, 214075),
(214076, '3.40.50.20-FF-000064', NULL, 'D-alanine--D-alanine ligase', 83, NULL, NULL, 214076),
(214077, '1.20.1250.20-FF-001499', NULL, 'Synaptic vesicle glycoprotein 2', 183, NULL, NULL, 214077),
(214078, '1.10.287.70-FF-000303', NULL, 'TWiK family of potassium channels', 327, NULL, NULL, 214078),
(214079, '1.10.287.70-FF-000612', NULL, 'Potassium channel, subfamily K, member 7', 258, NULL, NULL, 214079),
(214080, '3.40.50.720-FF-000648', NULL, 'YOR246C-like protein', 316, NULL, NULL, 214080),
(214081, '2.130.10.30-FF-000130', NULL, NULL, 301, NULL, NULL, 214081),
(214082, '3.40.50.12370-FF-000005', NULL, 'Cation/H(+) antiporter 20', 263, NULL, NULL, 214082),
(214083, '3.30.900.10-FF-000008', NULL, 'Autophagy-related protein 13b', 220, NULL, NULL, 214083);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(214084, '2.60.40.10-FF-001085', NULL, 'Usherin', 96, NULL, NULL, 214084),
(214085, '2.60.20.10-FF-000009', NULL, 'very large A-kinase anchor protein', 95, NULL, NULL, 214085),
(214086, '1.20.141.10-FF-000001', NULL, 'Chitosanase', 133, NULL, NULL, 214086),
(214087, '3.40.720.10-FF-000380', NULL, 'Uncharacterized protein', 70, NULL, NULL, 214087),
(214088, '1.10.220.30-FF-000025', NULL, 'Flagellar switch complex protein', 101, NULL, NULL, 214088),
(214089, '1.25.40.180-FF-000039', NULL, 'Uncharacterized protein, isoform B', 228, NULL, NULL, 214089),
(214090, '2.10.25.10-FF-000186', NULL, 'Slit homolog 2 (Drosophila)', 42, NULL, NULL, 214090),
(214091, '2.40.30.30-FF-000034', NULL, 'Riboflavin kinase/FAD synthetase', 170, NULL, NULL, 214091),
(214092, '1.20.58.190-FF-000023', NULL, NULL, 75, NULL, NULL, 214092),
(214093, '2.60.220.30-FF-000010', NULL, 'p53-induced death domain-containing protein 1 isoform X2', 135, NULL, NULL, 214093),
(214094, '1.10.287.2620-FF-000018', NULL, 'Dynein heavy chain 5', 63, NULL, NULL, 214094),
(214095, '3.80.10.10-FF-003957', NULL, 'Uncharacterized protein', 51, NULL, NULL, 214095),
(214096, '1.20.58.60-FF-000722', NULL, 'Uncharacterized protein', 273, NULL, NULL, 214096),
(214097, '3.30.559.10-FF-000063', NULL, 'Transferase family protein', 199, NULL, NULL, 214097),
(214098, '3.40.50.1000-FF-000203', NULL, 'Phospholipid-transporting ATPase', 193, NULL, NULL, 214098),
(214099, '3.30.420.40-FF-000874', NULL, 'Uncharacterized protein', 50, NULL, NULL, 214099),
(214100, '1.10.10.60-FF-000686', NULL, 'Os01g0127450 protein', 44, NULL, NULL, 214100),
(214101, '3.30.40.10-FF-000881', NULL, 'Os08g0162400 protein', 106, NULL, NULL, 214101),
(214102, '1.20.58.790-FF-000001', NULL, 'Surface layer (S-layer) glycoprotein', 98, NULL, NULL, 214102),
(214103, '2.60.40.10-FF-001646', NULL, 'Collagen, type VII, alpha 1', 93, NULL, NULL, 214103),
(214104, '2.60.34.10-FF-000098', NULL, 'EG:25E8.1 protein', 214, NULL, NULL, 214104),
(214105, '1.10.287.10-FF-000055', NULL, 'Predicted protein', 40, NULL, NULL, 214105),
(214106, '3.10.580.10-FF-000206', NULL, 'DUF21 domain-containing protein', 115, NULL, NULL, 214106),
(214107, '1.10.630.10-FF-000314', NULL, 'Os06g0671300 protein', 375, NULL, NULL, 214107),
(214108, '1.10.630.10-FF-000062', NULL, 'Ent-kaurene oxidase 2', 473, NULL, NULL, 214108),
(214109, '3.30.160.20-FF-000128', NULL, 'RNA HelicAse', 97, NULL, NULL, 214109),
(214110, '3.40.50.2300-FF-000189', NULL, 'SSU72p Phosphatase and transcription/RNA-processing factor', 162, NULL, NULL, 214110),
(214111, '1.20.1310.20-FF-000020', NULL, 'Merozoite surface protein duffy binding ligand 2', 178, NULL, NULL, 214111),
(214112, '3.40.50.11500-FF-000019', NULL, 'DENN_(AEX-3)_domain_containing_protein_-_putative', 178, NULL, NULL, 214112),
(214113, '1.25.40.10-FF-003236', NULL, 'AGR398Wp', 198, NULL, NULL, 214113),
(214114, '2.10.270.10-FF-000001', NULL, 'Toxin B', 122, NULL, NULL, 214114),
(214115, '2.60.60.20-FF-000032', NULL, 'Uncharacterized protein', 123, NULL, NULL, 214115),
(214116, '3.90.1150.10-FF-000498', NULL, 'Kynurenine aminotransferase, putative', 18, NULL, NULL, 214116),
(214117, '1.10.225.10-FF-000002', NULL, 'prosaposin isoform X2', 83, NULL, NULL, 214117),
(214118, '3.80.10.10-FF-002428', NULL, 'cDNA, clone cssl:d0334', 162, NULL, NULL, 214118),
(214119, '3.40.1110.10-FF-000018', NULL, 'Cation-transporting ATPase', 113, NULL, NULL, 214119),
(214120, '3.30.160.60-FF-003804', NULL, NULL, 57, NULL, NULL, 214120),
(214121, '1.10.10.60-FF-001293', NULL, NULL, 103, NULL, NULL, 214121),
(214122, '2.10.25.10-FF-000438', NULL, 'Hepatocyte growth factor activator', 40, NULL, NULL, 214122),
(214123, '1.10.4160.10-FF-000042', NULL, 'Uncharacterized protein', 461, NULL, NULL, 214123),
(214124, '3.40.30.10-FF-000205', NULL, 'Probable dolichyl-diphosphooligosaccharide--protein glycosyltransferase subunit 3', 161, NULL, NULL, 214124),
(214125, '3.40.1170.60-FF-000003', NULL, 'DNA polymerase eta', 68, NULL, NULL, 214125),
(214126, '1.10.486.10-FF-000074', NULL, 'DNA helicase', 133, NULL, NULL, 214126);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(214127, '3.90.190.10-FF-000142', NULL, 'Protein tyrosine phosphatase (Pyp1), putative', 320, NULL, NULL, 214127),
(214128, '1.20.1250.20-FF-000740', NULL, '3-phenylpropionic acid transporter', 190, NULL, NULL, 214128),
(214129, '3.20.20.80-FF-000384', NULL, 'Uncharacterized protein', 219, NULL, NULL, 214129),
(214130, '2.40.30.10-FF-000388', NULL, 'Probable translation initiation factor IF-2', 87, NULL, NULL, 214130),
(214131, '2.40.50.140-FF-000670', NULL, 'Uncharacterized protein', 135, NULL, NULL, 214131),
(214132, '3.20.20.70-FF-000381', NULL, 'Alpha-1,6-galactosidase', 207, NULL, NULL, 214132),
(214133, '3.40.50.300-FF-005082', NULL, 'Uncharacterized protein', 81, NULL, NULL, 214133),
(214134, '3.30.200.20-FF-000969', NULL, 'Protein kinase, putative', 104, NULL, NULL, 214134),
(214135, '3.30.160.60-FF-003552', NULL, NULL, 30, NULL, NULL, 214135),
(214136, '1.25.40.10-FF-003545', NULL, 'Uncharacterized protein', 91, NULL, NULL, 214136),
(214137, '2.60.40.1820-FF-000001', NULL, 'Desiccation protectant protein Lea14-like', 135, NULL, NULL, 214137),
(214138, '3.90.650.10-FF-000059', NULL, 'Predicted protein', 168, NULL, NULL, 214138),
(214139, '2.130.10.10-FF-004749', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit', 160, NULL, NULL, 214139),
(214140, '1.10.555.10-FF-000009', NULL, 'unconventional myosin-IXa isoform X1', 209, NULL, NULL, 214140),
(214141, '3.30.70.330-FF-001370', NULL, 'GM11803', 134, NULL, NULL, 214141),
(214142, '1.20.1270.60-FF-000051', NULL, 'ARF GTPase activator (Csx2)', 251, NULL, NULL, 214142),
(214143, '3.40.50.720-FF-000980', NULL, 'Fatty acyl-CoA reductase', 341, NULL, NULL, 214143),
(214144, '1.10.10.60-FF-001304', NULL, NULL, 49, NULL, NULL, 214144),
(214145, '2.130.10.10-FF-001315', NULL, 'WD repeat domain 27', 266, NULL, NULL, 214145),
(214146, '3.40.50.300-FF-001714', NULL, 'ATP-dependent DEAD/H RNA helicase, putative', 168, NULL, NULL, 214146),
(214147, '1.20.1720.10-FF-000060', NULL, 'Tetracycline resistance MFS efflux pump', 234, NULL, NULL, 214147),
(214148, '2.60.40.2950-FF-000003', NULL, 'Thioester-containing protein 6', 98, NULL, NULL, 214148),
(214149, '3.40.50.1010-FF-000116', NULL, 'Forkhead-associated (FHA) domain-containing protein', 175, NULL, NULL, 214149),
(214150, '1.20.58.900-FF-000006', NULL, 'RUN and SH3 domain containing 1', 195, NULL, NULL, 214150),
(214151, '3.30.750.44-FF-000015', NULL, 'Carboxy-terminal processing protease', 59, NULL, NULL, 214151),
(214152, '2.30.29.30-FF-000470', NULL, 'Phosphatidylinositol 3-kinase 2', 123, NULL, NULL, 214152),
(214153, '3.30.40.10-FF-001044', NULL, 'RBR-type E3 ubiquitin transferase', 97, NULL, NULL, 214153),
(214154, '3.40.50.360-FF-000170', NULL, 'Putative bifunctional protein', 204, NULL, NULL, 214154),
(214155, '1.25.40.180-FF-000017', NULL, 'Eukaryotic translation initiation factor 4 gamma 2', 192, NULL, NULL, 214155),
(214156, '3.40.50.1220-FF-000045', NULL, 'Electron transfer flavoprotein subunit alpha, mitochondrial', 69, NULL, NULL, 214156),
(214157, '3.40.50.1820-FF-000477', NULL, 'Prolyl Carboxy Peptidase like', 287, NULL, NULL, 214157),
(214158, '2.30.29.30-FF-000812', NULL, 'Vacuolar protein sorting protein, putative', 122, NULL, NULL, 214158),
(214159, '1.20.990.10-FF-000046', NULL, 'Putative nadp-dependent flavoprotein reductase', 132, NULL, NULL, 214159),
(214160, '3.30.70.330-FF-002707', NULL, NULL, 161, NULL, NULL, 214160),
(214161, '1.25.10.10-FF-003375', NULL, 'Uncharacterized protein', 152, NULL, NULL, 214161),
(214162, '3.50.50.60-FF-000890', NULL, 'Uncharacterized protein', 246, NULL, NULL, 214162),
(214163, '3.20.190.10-FF-000017', NULL, 'Formamidopyrimidine-DNA glycosylase', 131, NULL, NULL, 214163),
(214164, '3.30.420.140-FF-000044', NULL, 'Transcription elongation factor spt6', 108, NULL, NULL, 214164),
(214165, '1.25.10.10-FF-000969', NULL, 'GM12221', 397, NULL, NULL, 214165),
(214166, '3.40.50.10190-FF-000104', NULL, 'DNA ligase', 105, NULL, NULL, 214166),
(214167, '2.20.100.10-FF-000184', NULL, 'AGAP002424-PA', 55, NULL, NULL, 214167),
(214168, '1.20.1560.10-FF-000524', NULL, 'ABC transporter C family member 9', 226, NULL, NULL, 214168);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(214169, '3.30.160.60-FF-003658', NULL, 'GG12460', 29, NULL, NULL, 214169),
(214170, '6.20.50.160-FF-000007', NULL, 'Complement 4B (Chido blood group)', 59, NULL, NULL, 214170),
(214171, '1.10.510.10-FF-001424', NULL, 'Protein kinase superfamily protein', 73, NULL, NULL, 214171),
(214172, '1.20.58.60-FF-000048', NULL, 'microtubule-actin cross-linking factor 1 isoform X3', 109, NULL, NULL, 214172),
(214173, '1.10.472.80-FF-000242', NULL, NULL, 180, NULL, NULL, 214173),
(214174, '3.30.1330.40-FF-000057', NULL, 'Translation initiation inhibitor UK114/IBM1, putative', 87, NULL, NULL, 214174),
(214175, '3.40.630.10-FF-000199', NULL, 'Clan MH, family M20, peptidase T-like metallopeptidase', 236, NULL, NULL, 214175),
(214176, '3.10.310.10-FF-000058', NULL, 'Uncharacterized protein', 112, NULL, NULL, 214176),
(214177, '3.40.220.10-FF-000044', NULL, 'Uncharacterized protein', 197, NULL, NULL, 214177),
(214178, '3.30.70.270-FF-000267', NULL, NULL, 82, NULL, NULL, 214178),
(214179, '2.20.70.10-FF-000189', NULL, 'MIP25048p', 49, NULL, NULL, 214179),
(214180, '1.10.565.10-FF-000038', NULL, 'Dissatisfaction, isoform A', 227, NULL, NULL, 214180),
(214181, '3.50.50.60-FF-000648', NULL, 'NAD(FAD)-dependent dehydrogenase, putative', 136, NULL, NULL, 214181),
(214182, '3.30.450.40-FF-000100', NULL, 'GAF modulated transcriptional regulator, LuxR family', 133, NULL, NULL, 214182),
(214183, '1.20.1070.10-FF-000548', NULL, 'Uncharacterized protein', 306, NULL, NULL, 214183),
(214184, '1.10.640.10-FF-000034', NULL, 'Uncharacterized protein (Fragment)', 121, NULL, NULL, 214184),
(214185, '2.60.40.10-FF-003900', NULL, NULL, 117, NULL, NULL, 214185),
(214186, '3.10.129.10-FF-000243', NULL, 'Uncharacterized protein', 137, NULL, NULL, 214186),
(214187, '3.30.160.60-FF-000005', NULL, 'Zinc finger protein 14 homolog', 28, NULL, NULL, 214187),
(214188, '1.10.287.110-FF-000130', NULL, 'DnaJ chaperone (Caj1), putative', 127, NULL, NULL, 214188),
(214189, '3.90.660.10-FF-000122', NULL, NULL, 115, NULL, NULL, 214189),
(214190, '3.30.1330.30-FF-000054', NULL, 'Uncharacterized protein MT2704', 119, NULL, NULL, 214190),
(214191, '2.60.120.200-FF-000544', NULL, 'Os07g0133100 protein', 256, NULL, NULL, 214191),
(214192, '1.20.58.60-FF-000576', NULL, 'AGAP009554-PA', 246, NULL, NULL, 214192),
(214193, '3.20.10.10-FF-000031', NULL, 'Putative secreted protein', 153, NULL, NULL, 214193),
(214194, '3.40.50.1820-FF-000680', NULL, 'Alpha/beta hydrolase', 277, NULL, NULL, 214194),
(214195, '1.20.80.10-FF-000074', NULL, 'Predicted protein', 62, NULL, NULL, 214195),
(214196, '1.10.8.1310-FF-000012', NULL, 'Chromosome 16, whole genome shotgun sequence', 118, NULL, NULL, 214196),
(214197, '3.30.200.20-FF-000863', NULL, 'Serine/threonine-protein kinase ELM1', 64, NULL, NULL, 214197),
(214198, '3.30.300.30-FF-000143', NULL, 'Nonribosomal peptide synthase inpB', 119, NULL, NULL, 214198),
(214199, '2.10.25.10-FF-000332', NULL, 'Tenascin N', 30, NULL, NULL, 214199),
(214200, '3.30.1340.30-FF-000004', NULL, 'Predicted periplasmic or secreted lipoprotein', 68, NULL, NULL, 214200),
(214201, '3.30.420.10-FF-000533', NULL, NULL, 95, NULL, NULL, 214201),
(214202, '3.30.70.330-FF-002365', NULL, NULL, 104, NULL, NULL, 214202),
(214203, '1.10.510.10-FF-000030', NULL, 'Serine/threonine-protein kinase TAO2, putative', 213, NULL, NULL, 214203),
(214204, '3.30.200.20-FF-001026', NULL, 'Aurora kinase', 95, NULL, NULL, 214204),
(214205, '3.20.20.140-FF-000400', NULL, '2-amino-3-carboxylmuconate-6-semialdehyde decarboxylase, putative', 122, NULL, NULL, 214205),
(214206, '3.30.160.70-FF-000008', NULL, 'Methylated-DNA--protein-cysteine methyltransferase', 74, NULL, NULL, 214206),
(214207, '1.10.287.70-FF-000376', NULL, 'Calcium channel, voltage-dependent, L type, alpha 1D subunit, b', 57, NULL, NULL, 214207),
(214208, '3.40.50.300-FF-007335', NULL, 'Uncharacterized protein', 143, NULL, NULL, 214208),
(214209, '3.30.1360.220-FF-000001', NULL, 'Zinc finger, FYVE domain-containing 9a', 100, NULL, NULL, 214209),
(214210, '3.40.50.300-FF-007083', NULL, 'Probable GTP-binding protein EngB', 191, NULL, NULL, 214210);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(214211, '2.60.40.10-FF-001556', NULL, 'Plexin A, isoform B', 133, NULL, NULL, 214211),
(214212, '3.40.190.10-FF-000844', NULL, 'Gll3456 protein', 98, NULL, NULL, 214212),
(214213, '1.10.3090.10-FF-000030', NULL, 'AGR118Wp', 242, NULL, NULL, 214213),
(214214, '2.40.160.120-FF-000010', NULL, 'Oxysterol-binding protein homolog 4', 186, NULL, NULL, 214214),
(214215, '1.10.2000.10-FF-000081', NULL, NULL, 68, NULL, NULL, 214215),
(214216, '3.40.630.30-FF-000047', NULL, 'Acetyltransferase, GNAT family', 219, NULL, NULL, 214216),
(214217, '2.60.40.10-FF-000230', NULL, 'Down syndrome cell adhesion molecule, isoform D', 105, NULL, NULL, 214217),
(214218, '3.90.850.10-FF-000024', NULL, '2-keto-4-pentenoate hydratase', 264, NULL, NULL, 214218),
(214219, '3.20.20.10-FF-000060', NULL, 'Antizyme inhibitor 2', 233, NULL, NULL, 214219),
(214220, '3.40.1190.20-FF-000150', NULL, '2-dehydro-3-deoxygluconokinase', 305, NULL, NULL, 214220),
(214221, '1.10.287.130-FF-000136', NULL, 'Histidine kinase', 60, NULL, NULL, 214221),
(214222, '3.30.40.10-FF-002039', NULL, 'Suppressor of PAr-Two defect', 97, NULL, NULL, 214222),
(214223, '1.10.150.50-FF-000019', NULL, 'Connector enhancer of kinase suppressor of Ras 2', 88, NULL, NULL, 214223),
(214224, '1.20.1070.10-FF-000638', NULL, 'GH12381p', 135, NULL, NULL, 214224),
(214225, '3.30.160.60-FF-005912', NULL, NULL, 28, NULL, NULL, 214225),
(214226, '1.25.40.10-FF-005254', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 162, NULL, NULL, 214226),
(214227, '3.40.50.1820-FF-000590', NULL, 'Inactive pancreatic lipase-related protein 1', 324, NULL, NULL, 214227),
(214228, '3.30.70.270-FF-000177', NULL, NULL, 70, NULL, NULL, 214228),
(214229, '1.20.90.10-FF-000046', NULL, NULL, 131, NULL, NULL, 214229),
(214230, '2.70.50.40-FF-000003', NULL, 'UNC119 homologue, putative', 183, NULL, NULL, 214230),
(214231, '3.40.50.300-FF-002788', NULL, 'RecBCD enzyme subunit RecD', 188, NULL, NULL, 214231),
(214232, '2.60.40.1230-FF-000010', NULL, 'VHS domain protein', 120, NULL, NULL, 214232),
(214233, '1.20.1270.190-FF-000001', NULL, 'ExsD', 91, NULL, NULL, 214233),
(214234, '3.30.1490.190-FF-000009', NULL, 'Fur family transcriptional regulator', 54, NULL, NULL, 214234),
(214235, '3.30.1490.180-FF-000006', NULL, 'DNA-directed RNA polymerase subunit', 60, NULL, NULL, 214235),
(214236, '2.40.10.10-FF-000010', NULL, 'Kallikrein related peptidase 11', 146, NULL, NULL, 214236),
(214237, '1.10.287.410-FF-000006', NULL, 'Serine carboxypeptidase-like 33', 75, NULL, NULL, 214237),
(214238, '2.60.40.10-FF-003810', NULL, NULL, 119, NULL, NULL, 214238),
(214239, '1.25.40.1030-FF-000044', NULL, 'Protein transport protein sec16', 297, NULL, NULL, 214239),
(214240, '1.20.1730.10-FF-000122', NULL, 'Uncharacterized protein', 520, NULL, NULL, 214240),
(214241, '3.30.70.260-FF-000174', NULL, 'Uncharacterized protein MJ0241', 67, NULL, NULL, 214241),
(214242, '3.80.10.10-FF-004362', NULL, 'Uncharacterized protein', 371, NULL, NULL, 214242),
(214243, '1.10.510.10-FF-001334', NULL, 'Protein kinase', 393, NULL, NULL, 214243),
(214244, '1.25.40.20-FF-001441', NULL, 'Uncharacterized protein', 146, NULL, NULL, 214244),
(214245, '1.10.510.10-FF-003464', NULL, NULL, 273, NULL, NULL, 214245),
(214246, '3.40.50.620-FF-000624', NULL, 'Glutamyl-Q tRNA(Asp) synthetase', 115, NULL, NULL, 214246),
(214247, '3.40.50.2000-FF-000526', NULL, 'UDP-glycosyltransferase 83A1', 38, NULL, NULL, 214247),
(214248, '1.20.1070.10-FF-000296', NULL, 'C5a anaphylatoxin chemotactic receptor 2', 290, NULL, NULL, 214248),
(214249, '3.40.50.11500-FF-000003', NULL, 'DENN domain containing 4C', 161, NULL, NULL, 214249),
(214250, '3.10.290.10-FF-000105', NULL, 'Tyrosine--tRNA ligase', 53, NULL, NULL, 214250),
(214251, '2.130.10.10-FF-002389', NULL, 'Flagellar inner dynein arm I1 intermediate chain IC140', 247, NULL, NULL, 214251),
(214252, '1.20.1110.10-FF-000120', NULL, NULL, 90, NULL, NULL, 214252),
(214253, '2.60.40.3620-FF-000002', NULL, NULL, 114, NULL, NULL, 214253),
(214254, '3.40.50.1260-FF-000051', NULL, 'Phosphoglycerate kinase', 88, NULL, NULL, 214254);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(214255, '1.25.40.720-FF-000022', NULL, 'Uncharacterized protein', 157, NULL, NULL, 214255),
(214256, '3.40.50.300-FF-004929', NULL, 'Zgc:63587', 268, NULL, NULL, 214256),
(214257, '2.60.40.10-FF-003355', NULL, NULL, 91, NULL, NULL, 214257),
(214258, '2.30.29.170-FF-000023', NULL, NULL, 135, NULL, NULL, 214258),
(214259, '1.10.3470.10-FF-000048', NULL, 'FecCD transport family protein', 178, NULL, NULL, 214259),
(214260, '1.10.287.70-FF-000718', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 139, NULL, NULL, 214260),
(214261, '3.10.620.30-FF-000025', NULL, 'Uncharacterized protein', 143, NULL, NULL, 214261),
(214262, '3.40.50.300-FF-007554', NULL, 'Uncharacterized protein', 192, NULL, NULL, 214262),
(214263, '3.30.70.660-FF-000081', NULL, 'tRNA pseudouridine synthase', 206, NULL, NULL, 214263),
(214264, '3.30.1240.10-FF-000070', NULL, 'Putative hydrolase', 114, NULL, NULL, 214264),
(214265, '1.10.10.10-FF-001284', NULL, 'ArsR family transcriptional regulator', 90, NULL, NULL, 214265),
(214266, '1.10.3500.10-FF-000012', NULL, 'Transcription elongation factor spt6, putative', 279, NULL, NULL, 214266),
(214267, '3.80.10.10-FF-000539', NULL, 'LRR receptor-like serine/threonine-protein kinase EFR', 284, NULL, NULL, 214267),
(214268, '1.25.40.10-FF-001415', NULL, 'Mitochondrial group I intron splicing factor CCM1', 165, NULL, NULL, 214268),
(214269, '3.30.720.50-FF-000006', NULL, 'Poly [ADP-ribose] polymerase', 92, NULL, NULL, 214269),
(214270, '3.30.559.10-FF-000169', NULL, 'Nonribosomal peptide synthase 2', 169, NULL, NULL, 214270),
(214271, '1.10.437.10-FF-000016', NULL, 'bcl-2-like protein 1 isoform X2', 125, NULL, NULL, 214271),
(214272, '1.25.40.1040-FF-000047', NULL, 'Uncharacterized protein', 73, NULL, NULL, 214272),
(214273, '1.10.238.10-FF-001072', NULL, 'Uncharacterized protein', 74, NULL, NULL, 214273),
(214274, '2.60.40.10-FF-003445', NULL, NULL, 99, NULL, NULL, 214274),
(214275, '2.30.120.10-FF-000003', NULL, 'Acyl-homoserine lactone acylase PvdQ', 75, NULL, NULL, 214275),
(214276, '3.30.160.60-FF-000224', NULL, 'Zinc finger protein 329', 28, NULL, NULL, 214276),
(214277, '1.10.555.10-FF-000212', NULL, NULL, 69, NULL, NULL, 214277),
(214278, '3.40.50.12760-FF-000015', NULL, 'Predicted protein', 212, NULL, NULL, 214278),
(214279, '2.60.120.200-FF-000292', NULL, 'NeuReXin related', 182, NULL, NULL, 214279),
(214280, '1.20.58.60-FF-000486', NULL, 'Uncharacterized protein', 109, NULL, NULL, 214280),
(214281, '3.80.10.10-FF-004339', NULL, 'Si:dkey-28k24.2', 191, NULL, NULL, 214281),
(214282, '3.40.50.300-FF-003283', NULL, 'Predicted protein', 222, NULL, NULL, 214282),
(214283, '3.50.30.30-FF-000003', NULL, 'E3 ubiquitin-protein ligase RNF128', 154, NULL, NULL, 214283),
(214284, '2.40.40.20-FF-000060', NULL, 'DNA-directed RNA polymerase II subunit 1', 65, NULL, NULL, 214284),
(214285, '1.25.40.20-FF-001418', NULL, 'Uncharacterized protein', 163, NULL, NULL, 214285),
(214286, '1.10.150.50-FF-000132', NULL, 'Uncharacterized protein', 65, NULL, NULL, 214286),
(214287, '1.10.287.70-FF-000409', NULL, 'Predicted protein', 112, NULL, NULL, 214287),
(214288, '3.30.750.24-FF-000167', NULL, 'Uncharacterized protein', 157, NULL, NULL, 214288),
(214289, '3.40.50.620-FF-000282', NULL, 'Bifunctional protein HldE', 154, NULL, NULL, 214289),
(214290, '3.10.20.90-FF-000016', NULL, 'Polyubiquitin 3', 76, NULL, NULL, 214290),
(214291, '1.10.1200.10-FF-000062', NULL, 'Acyl carrier protein', 87, NULL, NULL, 214291),
(214292, '1.10.720.30-FF-000046', NULL, 'AaceriAAR121Wp', 60, NULL, NULL, 214292),
(214293, '3.40.33.10-FF-000010', NULL, 'Predicted protein', 145, NULL, NULL, 214293),
(214294, '1.20.1250.20-FF-001122', NULL, 'Multidrug transporter DTR1', 206, NULL, NULL, 214294),
(214295, '3.40.50.11350-FF-000031', NULL, 'Putative alpha 1-6-fucosyltransferase', 156, NULL, NULL, 214295),
(214296, '3.40.50.360-FF-000057', NULL, 'N-ribosyldihydronicotinamide:quinone reductase 2', 93, NULL, NULL, 214296),
(214297, '3.40.50.300-FF-004210', NULL, 'Small GTP-binding protein, putative', 189, NULL, NULL, 214297);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(214298, '3.80.10.10-FF-002232', NULL, 'Protein CBG08830', 152, NULL, NULL, 214298),
(214299, '2.130.10.10-FF-004030', NULL, 'Uncharacterized protein', 221, NULL, NULL, 214299),
(214300, '2.70.50.50-FF-000006', NULL, 'Putative secreted cellulose-binding protein', 186, NULL, NULL, 214300),
(214301, '2.40.50.200-FF-000002', NULL, 'TIGR00156 family protein', 110, NULL, NULL, 214301),
(214302, '3.10.129.10-FF-000097', NULL, 'DNA-binding protein', 178, NULL, NULL, 214302),
(214303, '1.10.8.240-FF-000002', NULL, '2-phospho-L-lactate transferase', 88, NULL, NULL, 214303),
(214304, '3.80.10.10-FF-000068', NULL, 'F-box/LRR-repeat protein 7 isoform X2', 224, NULL, NULL, 214304),
(214305, '1.25.40.10-FF-000797', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 127, NULL, NULL, 214305),
(214306, '3.30.1140.32-FF-000014', NULL, '30S ribosomal protein S3', 101, NULL, NULL, 214306),
(214307, '2.40.170.20-FF-000001', NULL, 'Vitamin B12 transporter BtuB', 464, NULL, NULL, 214307),
(214308, '3.40.250.10-FF-000181', NULL, 'Rhodanese-like domain-containing protein', 135, NULL, NULL, 214308),
(214309, '2.40.50.140-FF-001142', NULL, NULL, 50, NULL, NULL, 214309),
(214310, '3.40.50.620-FF-000591', NULL, 'Os08g0191800 protein', 206, NULL, NULL, 214310),
(214311, '3.30.160.60-FF-005603', NULL, NULL, 35, NULL, NULL, 214311),
(214312, '2.30.30.40-FF-000577', NULL, 'Protein ste6', 53, NULL, NULL, 214312),
(214313, '3.30.160.60-FF-001641', NULL, 'Zinc finger and BTB domain containing 4', 98, NULL, NULL, 214313),
(214314, '1.25.40.10-FF-005344', NULL, 'Uncharacterized protein', 165, NULL, NULL, 214314),
(214315, '3.20.20.330-FF-000013', NULL, 'Predicted protein', 188, NULL, NULL, 214315),
(214316, '3.30.1360.230-FF-000004', NULL, 'Suppressor of fused homolog', 131, NULL, NULL, 214316),
(214317, '1.25.40.10-FF-000488', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 104, NULL, NULL, 214317),
(214318, '2.60.40.10-FF-003136', NULL, NULL, 81, NULL, NULL, 214318),
(214319, '3.40.50.300-FF-000410', NULL, 'ATPase RavA', 221, NULL, NULL, 214319),
(214320, '3.30.70.330-FF-002674', NULL, NULL, 123, NULL, NULL, 214320),
(214321, '3.40.190.10-FF-000934', NULL, 'Predicted protein', 45, NULL, NULL, 214321),
(214322, '1.25.40.10-FF-001106', NULL, 'Pentatricopeptide repeat-containing protein', 110, NULL, NULL, 214322),
(214323, '1.10.287.130-FF-000046', NULL, 'Two-component sensor histidine kinase', 66, NULL, NULL, 214323),
(214324, '1.25.10.10-FF-001610', NULL, 'Uncharacterized protein', 420, NULL, NULL, 214324),
(214325, '2.130.10.10-FF-004862', NULL, 'Uncharacterized protein', 124, NULL, NULL, 214325),
(214326, '3.30.70.100-FF-000025', NULL, 'N-terminal EF-hand calcium-binding protein 1', 135, NULL, NULL, 214326),
(214327, '1.20.120.350-FF-000205', NULL, NULL, 145, NULL, NULL, 214327),
(214328, '1.10.238.10-FF-000919', NULL, 'EF-hand calcium-binding domain-containing protein 6-like', 79, NULL, NULL, 214328),
(214329, '2.60.120.200-FF-000763', NULL, 'Uncharacterized protein', 78, NULL, NULL, 214329),
(214330, '3.40.1160.10-FF-000100', NULL, 'Amino acid kinase family protein', 144, NULL, NULL, 214330),
(214331, '3.40.50.720-FF-000632', NULL, 'Fatty acid synthase', 321, NULL, NULL, 214331),
(214332, '1.20.1270.60-FF-000157', NULL, 'Uncharacterized protein', 298, NULL, NULL, 214332),
(214333, '3.40.1350.10-FF-000002', NULL, 'tRNA-splicing endonuclease subunit Sen34', 92, NULL, NULL, 214333),
(214334, '3.30.1430.10-FF-000005', NULL, '50S ribosomal protein L3', 108, NULL, NULL, 214334),
(214335, '3.10.580.10-FF-000100', NULL, 'Chloride channel protein', 170, NULL, NULL, 214335),
(214336, '3.40.50.10490-FF-000076', NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', 150, NULL, NULL, 214336),
(214337, '2.10.25.10-FF-000641', NULL, 'epigen isoform X4', 44, NULL, NULL, 214337),
(214338, '1.25.40.10-FF-004849', NULL, 'Uncharacterized protein', 134, NULL, NULL, 214338),
(214339, '2.160.20.80-FF-000020', NULL, NULL, 205, NULL, NULL, 214339),
(214340, '3.90.228.20-FF-000008', NULL, 'Phosphoenolpyruvate carboxykinase [GTP]', 251, NULL, NULL, 214340);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(214341, '3.90.640.10-FF-000087', NULL, 'Actin-like ATPase domain-containing protein', 28, NULL, NULL, 214341),
(214342, '3.40.1480.10-FF-000006', NULL, 'Glycerate kinase', 169, NULL, NULL, 214342),
(214343, '3.40.50.10190-FF-000233', NULL, 'FHA domain containing protein, putative', 85, NULL, NULL, 214343),
(214344, '3.30.160.60-FF-003097', NULL, 'Zinc finger and BTB domain-containing 40', 26, NULL, NULL, 214344),
(214345, '1.25.40.20-FF-001660', NULL, 'Predicted protein', 85, NULL, NULL, 214345),
(214346, '3.40.50.850-FF-000002', NULL, 'Vibriobactin-specific isochorismatase', 207, NULL, NULL, 214346),
(214347, '3.40.50.300-FF-003592', NULL, 'Thymidylate kinase', 194, NULL, NULL, 214347),
(214348, '1.20.58.200-FF-000004', NULL, 'Translin-associated factor TraX, putative', 103, NULL, NULL, 214348),
(214349, '2.40.10.230-FF-000014', NULL, 'Uncharacterized protein', 66, NULL, NULL, 214349),
(214350, '3.40.50.10130-FF-000002', NULL, 'DNA repair endonuclease XPF', 145, NULL, NULL, 214350),
(214351, '1.20.5.170-FF-000175', NULL, 'Basic-leucine zipper transcription factor B', 60, NULL, NULL, 214351),
(214352, '2.60.120.330-FF-000223', NULL, 'Putative 2-oxoglutarate-dependent dioxygenase DIN11', 251, NULL, NULL, 214352),
(214353, '1.10.10.10-FF-001194', NULL, 'Transcriptional regulator, Rrf2', 141, NULL, NULL, 214353),
(214354, '2.170.16.10-FF-000045', NULL, 'Gll3966 protein', 118, NULL, NULL, 214354),
(214355, '3.40.710.10-FF-000109', NULL, 'Glutaminase', 307, NULL, NULL, 214355),
(214356, '3.40.250.10-FF-000214', NULL, 'Uncharacterized protein', 114, NULL, NULL, 214356),
(214357, '3.40.50.300-FF-004120', NULL, 'tRNA modification GTPase', 238, NULL, NULL, 214357),
(214358, '1.20.58.1380-FF-000019', NULL, 'Predicted protein', 46, NULL, NULL, 214358),
(214359, '2.60.120.430-FF-000012', NULL, 'Putative receptor-like protein kinase', 163, NULL, NULL, 214359),
(214360, '3.40.50.10140-FF-000005', NULL, 'Myeloid differentiation primary response protein MyD88', 136, NULL, NULL, 214360),
(214361, '2.60.40.760-FF-000006', NULL, 'Expansin-like protein 3', 107, NULL, NULL, 214361),
(214362, '3.30.160.60-FF-003349', NULL, 'RB associated KRAB zinc finger', 29, NULL, NULL, 214362),
(214363, '3.30.70.330-FF-002926', NULL, NULL, 122, NULL, NULL, 214363),
(214364, '1.10.150.50-FF-000036', NULL, 'upstream-binding protein 1 isoform X1', 74, NULL, NULL, 214364),
(214365, '1.25.40.180-FF-000135', NULL, NULL, 50, NULL, NULL, 214365),
(214366, '2.60.60.20-FF-000021', NULL, 'Lipoxygenase', 160, NULL, NULL, 214366),
(214367, '3.40.50.150-FF-001068', NULL, 'Uncharacterized protein', 243, NULL, NULL, 214367),
(214368, '3.30.980.10-FF-000002', NULL, 'Alanine--tRNA ligase', 83, NULL, NULL, 214368),
(214369, '3.10.450.40-FF-000009', NULL, 'Amine oxidase', 138, NULL, NULL, 214369),
(214370, '3.30.300.130-FF-000048', NULL, NULL, 48, NULL, NULL, 214370),
(214371, '1.20.920.10-FF-000132', NULL, 'Histone-lysine N-methyltransferase', 116, NULL, NULL, 214371),
(214372, '1.10.150.60-FF-000039', NULL, NULL, 118, NULL, NULL, 214372),
(214373, '3.30.70.330-FF-000875', NULL, 'Glucose-repressible RNA binding protein', 115, NULL, NULL, 214373),
(214374, '3.90.810.10-FF-000033', NULL, NULL, 73, NULL, NULL, 214374),
(214375, '3.40.50.10490-FF-000093', NULL, 'Glucose-6-phosphate isomerase', 319, NULL, NULL, 214375),
(214376, '1.10.630.10-FF-000067', NULL, 'Cytochrome P450 - like protein', 472, NULL, NULL, 214376),
(214377, '1.25.40.320-FF-000003', NULL, 'Aminopeptidase O isoform 1', 148, NULL, NULL, 214377),
(214378, '3.30.540.30-FF-000003', NULL, 'Dipeptidyl peptidase 3', 94, NULL, NULL, 214378),
(214379, '2.60.40.420-FF-000039', NULL, 'Blue copper oxidase CueO', 152, NULL, NULL, 214379),
(214380, '1.50.40.10-FF-000160', NULL, 'Uncharacterized protein, isoform B', 195, NULL, NULL, 214380),
(214381, '1.10.510.10-FF-003672', NULL, NULL, 175, NULL, NULL, 214381),
(214382, '3.40.50.10190-FF-000216', NULL, 'Predicted protein', 108, NULL, NULL, 214382),
(214383, '3.30.160.60-FF-000016', NULL, 'zinc finger protein 37 homolog', 31, NULL, NULL, 214383);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(214384, '1.10.2000.10-FF-000086', NULL, NULL, 129, NULL, NULL, 214384),
(214385, '1.10.287.810-FF-000025', NULL, NULL, 82, NULL, NULL, 214385),
(214386, '1.10.8.10-FF-000153', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 37, NULL, NULL, 214386),
(214387, '1.10.555.10-FF-000004', NULL, 'active breakpoint cluster region-related protein-like', 208, NULL, NULL, 214387),
(214388, '3.30.1140.60-FF-000003', NULL, 'F-actin-capping protein subunit alpha', 112, NULL, NULL, 214388),
(214389, '1.20.1070.10-FF-000863', NULL, '5-hydroxytryptamine receptor 1A-beta', 244, NULL, NULL, 214389),
(214390, '1.10.530.10-FF-000020', NULL, 'Endochitinase CHI', 145, NULL, NULL, 214390),
(214391, '1.20.1560.10-FF-000412', NULL, 'Putative ABC transporter', 327, NULL, NULL, 214391),
(214392, '4.10.280.10-FF-000073', NULL, 'MAX dimerization protein 3', 80, NULL, NULL, 214392),
(214393, '3.90.180.10-FF-000186', NULL, 'Putative cinnamyl alcohol dehydrogenase 6', 98, NULL, NULL, 214393),
(214394, '3.20.20.70-FF-000622', NULL, NULL, 298, NULL, NULL, 214394),
(214395, '1.20.1560.10-FF-000507', NULL, 'Uncharacterized protein', 329, NULL, NULL, 214395),
(214396, '3.40.50.720-FF-001025', NULL, 'Oxidoreductase, Gfo/Idh/MocA family', 141, NULL, NULL, 214396),
(214397, '3.40.50.410-FF-000112', NULL, 'TFIIH basal transcription factor subunit', 212, NULL, NULL, 214397),
(214398, '2.130.10.10-FF-003322', NULL, 'Predicted protein', 121, NULL, NULL, 214398),
(214399, '1.10.600.10-FF-000144', NULL, 'Uncharacterized protein', 86, NULL, NULL, 214399),
(214400, '1.20.1250.20-FF-000638', NULL, 'Monocarboxylate permease', 249, NULL, NULL, 214400),
(214401, '3.30.499.10-FF-000001', NULL, 'Aconitate hydratase B', 128, NULL, NULL, 214401),
(214402, '2.60.120.260-FF-000287', NULL, 'Glycosyl hydrolase', 152, NULL, NULL, 214402),
(214403, '1.20.1270.10-FF-000070', NULL, 'Chaperone protein HscA', 95, NULL, NULL, 214403),
(214404, '1.25.10.10-FF-002892', NULL, 'Uncharacterized protein', 144, NULL, NULL, 214404),
(214405, '1.10.150.310-FF-000005', NULL, 'Si:ch211-117n7.8', 94, NULL, NULL, 214405),
(214406, '3.30.1520.10-FF-000029', NULL, 'sorting nexin-15 isoform X1', 135, NULL, NULL, 214406),
(214407, '2.60.120.330-FF-000105', NULL, 'Uncharacterized protein', 140, NULL, NULL, 214407),
(214408, '3.30.160.60-FF-003782', NULL, NULL, 30, NULL, NULL, 214408),
(214409, '1.10.10.10-FF-001312', NULL, 'ATP-dependent DNA helicase RecQ', 202, NULL, NULL, 214409),
(214410, '2.30.30.40-FF-000200', NULL, 'SH3 domain containing 19', 69, NULL, NULL, 214410),
(214411, '3.40.50.300-FF-003614', NULL, 'RecBCD enzyme subunit RecC', 139, NULL, NULL, 214411),
(214412, '3.30.710.10-FF-000168', NULL, 'BTB/POZ domain-containing protein At1g03010', 120, NULL, NULL, 214412),
(214413, '3.30.200.20-FF-001144', NULL, 'Calcium and calcium/calmodulin-dependent serine/threonine-protein kinase DMI-3', 123, NULL, NULL, 214413),
(214414, '3.30.450.20-FF-000347', NULL, 'PAS sensor protein', 127, NULL, NULL, 214414),
(214415, '1.10.150.300-FF-000002', NULL, 'Ribosome-binding ATPase YchF', 81, NULL, NULL, 214415),
(214416, '2.40.30.70-FF-000006', NULL, 'BnaA08g13900D protein', 170, NULL, NULL, 214416),
(214417, '3.80.10.10-FF-002771', NULL, 'Uncharacterized protein', 184, NULL, NULL, 214417),
(214418, '3.30.2320.80-FF-000012', NULL, 'Hydrogenase maturation factor HypA', 116, NULL, NULL, 214418),
(214419, '2.130.10.10-FF-005351', NULL, 'Transducin/WD-40 repeat protein family', 177, NULL, NULL, 214419),
(214420, '3.20.20.80-FF-000625', NULL, 'Predicted protein', 133, NULL, NULL, 214420),
(214421, '3.30.420.10-FF-000421', NULL, NULL, 154, NULL, NULL, 214421),
(214422, '3.30.1490.20-FF-000017', NULL, 'Pyruvate carboxylase', 71, NULL, NULL, 214422),
(214423, '2.30.29.30-FF-000823', NULL, 'Uncharacterized protein', 24, NULL, NULL, 214423),
(214424, '1.10.10.60-FF-000809', NULL, NULL, 50, NULL, NULL, 214424),
(214425, '2.30.40.10-FF-000164', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 79, NULL, NULL, 214425),
(214426, '3.80.10.10-FF-000528', NULL, 'F-box/LRR-repeat protein 17 isoform X1', 66, NULL, NULL, 214426);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(214427, '3.30.70.330-FF-000780', NULL, 'U2 small nuclear ribonucleoprotein B''''', 88, NULL, NULL, 214427),
(214428, '3.40.50.720-FF-000424', NULL, 'Meiotically up-regulated gene 72 protein', 189, NULL, NULL, 214428),
(214429, '1.20.58.1520-FF-000005', NULL, 'GM11282', 119, NULL, NULL, 214429),
(214430, '2.10.50.10-FF-000160', NULL, 'Predicted protein', 55, NULL, NULL, 214430),
(214431, '1.10.510.10-FF-000120', NULL, 'Casein kinase I isoform alpha', 334, NULL, NULL, 214431),
(214432, '2.40.240.10-FF-000010', NULL, '50S ribosomal protein L25', 93, NULL, NULL, 214432),
(214433, '3.30.70.890-FF-000014', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 119, NULL, NULL, 214433),
(214434, '3.30.160.60-FF-005822', NULL, NULL, 23, NULL, NULL, 214434),
(214435, '3.80.10.10-FF-002092', NULL, 'Leucine Rich Repeat family protein', 170, NULL, NULL, 214435),
(214436, '3.40.50.300-FF-001574', NULL, 'Uncharacterized protein, isoform C', 248, NULL, NULL, 214436),
(214437, '3.30.70.330-FF-001055', NULL, 'Uncharacterized protein', 85, NULL, NULL, 214437),
(214438, '1.25.40.10-FF-003006', NULL, 'Pentatricopeptide repeat-containing protein At5g13770, chloroplastic', 123, NULL, NULL, 214438),
(214439, '2.60.220.50-FF-000033', NULL, 'Polycystic kidney disease 1 like 2a', 66, NULL, NULL, 214439),
(214440, '2.60.40.10-FF-003344', NULL, NULL, 85, NULL, NULL, 214440),
(214441, '3.40.80.10-FF-000017', NULL, 'Uncharacterized protein', 180, NULL, NULL, 214441),
(214442, '3.40.30.10-FF-000520', NULL, 'Thioredoxin, putative', 115, NULL, NULL, 214442),
(214443, '3.10.105.10-FF-000103', NULL, 'Oligopeptide transport system binding protein', 213, NULL, NULL, 214443),
(214444, '3.30.70.100-FF-000031', NULL, 'copper-transporting ATPase 1', 79, NULL, NULL, 214444),
(214445, '3.20.90.10-FF-000013', NULL, NULL, 121, NULL, NULL, 214445),
(214446, '1.10.10.10-FF-000795', NULL, 'La protein 2', 101, NULL, NULL, 214446),
(214447, '3.90.1150.10-FF-000392', NULL, 'Serine--pyruvate aminotransferase', 108, NULL, NULL, 214447),
(214448, '3.30.9.10-FF-000033', NULL, 'Putative oxidoreductase C1F5.03c', 107, NULL, NULL, 214448),
(214449, '3.40.50.10190-FF-000121', NULL, 'Poly [ADP-ribose] polymerase', 109, NULL, NULL, 214449),
(214450, '3.40.50.410-FF-000207', NULL, 'Cku-70', 214, NULL, NULL, 214450),
(214451, '3.50.50.60-FF-000446', NULL, 'Glycerol-3-phosphate dehydrogenase, putative', 188, NULL, NULL, 214451),
(214452, '3.90.1210.10-FF-000003', NULL, 'Flagella basal body P-ring formation protein FlgA', 61, NULL, NULL, 214452),
(214453, '2.60.40.1530-FF-000010', NULL, 'Integrin subunit alpha 2', 182, NULL, NULL, 214453),
(214454, '3.40.50.80-FF-000059', NULL, 'Ferric reduction oxidase 4', 180, NULL, NULL, 214454),
(214455, '3.40.220.10-FF-000027', NULL, 'Uncharacterized protein, isoform A', 145, NULL, NULL, 214455),
(214456, '1.25.10.10-FF-003167', NULL, 'Uncharacterized protein', 344, NULL, NULL, 214456),
(214457, '1.10.720.30-FF-000052', NULL, 'Uncharacterized protein', 42, NULL, NULL, 214457),
(214458, '3.40.50.150-FF-000888', NULL, 'Non-ribosomal peptide synthetase', 203, NULL, NULL, 214458),
(214459, '1.10.880.10-FF-000001', NULL, 'Nuclear factor erythroid 2-related factor 2', 89, NULL, NULL, 214459),
(214460, '1.10.10.60-FF-001057', NULL, NULL, 52, NULL, NULL, 214460),
(214461, '2.40.37.10-FF-000072', NULL, NULL, 109, NULL, NULL, 214461),
(214462, '2.130.10.10-FF-001068', NULL, 'Regulatory-associated protein of TOR 1', 168, NULL, NULL, 214462),
(214463, '1.25.40.90-FF-000118', NULL, 'Predicted protein', 112, NULL, NULL, 214463),
(214464, '1.25.40.10-FF-002489', NULL, 'Pentatricopeptide repeat-containing protein At3g58590', 105, NULL, NULL, 214464),
(214465, '2.130.10.10-FF-005446', NULL, 'WD repeat-containing protein 3 homolog', 205, NULL, NULL, 214465),
(214466, '3.40.850.10-FF-000058', NULL, 'kinesin-like protein KIN-14B isoform X1', 369, NULL, NULL, 214466),
(214467, '3.40.50.2300-FF-000970', NULL, NULL, 143, NULL, NULL, 214467),
(214468, '1.20.5.110-FF-000281', NULL, 'R-SNARE protein, tomsyn-like family', 65, NULL, NULL, 214468); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(214469, '3.40.50.1820-FF-000359', NULL, 'Alpha/beta fold hydrolase', 241, NULL, NULL, 214469),
(214470, '1.10.472.10-FF-000598', NULL, 'Uncharacterized protein', 22, NULL, NULL, 214470),
(214471, '3.40.47.10-FF-000289', NULL, NULL, 55, NULL, NULL, 214471),
(214472, '3.30.43.10-FF-000039', NULL, 'Cytochrome P450', 75, NULL, NULL, 214472),
(214473, '1.20.1050.130-FF-000007', NULL, 'Bifunctional glutamate/proline--tRNA ligase', 173, NULL, NULL, 214473),
(214474, '2.60.120.200-FF-000634', NULL, 'Uncharacterized protein', 121, NULL, NULL, 214474),
(214475, '2.60.220.50-FF-000128', NULL, 'Uncharacterized protein', 212, NULL, NULL, 214475),
(214476, '1.10.630.10-FF-000393', NULL, 'Tafazzin family protein', 146, NULL, NULL, 214476),
(214477, '3.30.710.10-FF-000494', NULL, 'Uncharacterized protein', 50, NULL, NULL, 214477),
(214478, '2.60.40.10-FF-005710', NULL, NULL, 46, NULL, NULL, 214478),
(214479, '3.40.50.2000-FF-000189', NULL, 'UDP-glucuronosyltransferase 2B14-like Protein', 173, NULL, NULL, 214479),
(214480, '2.130.10.10-FF-001394', NULL, 'Damaged DNA binding protein', 40, NULL, NULL, 214480),
(214481, '3.40.50.720-FF-002341', NULL, 'Uncharacterized protein', 142, NULL, NULL, 214481),
(214482, '2.60.40.10-FF-001427', NULL, 'Immunoglobulin superfamily member 10', 100, NULL, NULL, 214482),
(214483, '2.40.50.90-FF-000126', NULL, 'Uncharacterized protein', 156, NULL, NULL, 214483),
(214484, '1.20.58.60-FF-000374', NULL, 'Blast:Spectrin beta chain, non-erythrocytic 5', 89, NULL, NULL, 214484),
(214485, '3.40.1190.10-FF-000017', NULL, 'Folylpolyglutamate synthase', 284, NULL, NULL, 214485),
(214486, '3.30.160.60-FF-005143', NULL, NULL, 31, NULL, NULL, 214486),
(214487, '3.30.1370.10-FF-000085', NULL, 'KH domain-containing, RNA-binding, signal transduction-associated protein 1 isoform X3', 77, NULL, NULL, 214487),
(214488, '1.20.1050.110-FF-000001', NULL, 'Methionine-tRNA ligase', 107, NULL, NULL, 214488),
(214489, '3.40.50.300-FF-000051', NULL, 'Guanine nucleotide-binding protein subunit alpha', 188, NULL, NULL, 214489),
(214490, '3.30.70.330-FF-002915', NULL, NULL, 130, NULL, NULL, 214490),
(214491, '1.20.1420.10-FF-000014', NULL, 'Os05g0554500 protein', 144, NULL, NULL, 214491),
(214492, '1.20.120.20-FF-000046', NULL, 'Apolipoprotein A-I', 48, NULL, NULL, 214492),
(214493, '3.30.450.20-FF-000673', NULL, 'Uncharacterized protein', 88, NULL, NULL, 214493),
(214494, '1.10.8.970-FF-000001', NULL, 'Genome polyprotein', 75, NULL, NULL, 214494),
(214495, '3.10.250.10-FF-000002', NULL, 'Scavenger receptor cysteine-rich type 1 protein M130', 104, NULL, NULL, 214495),
(214496, '3.30.450.220-FF-000001', NULL, 'Sensor histidine kinase LuxQ', 157, NULL, NULL, 214496),
(214497, '1.20.140.10-FF-000038', NULL, 'Nitroalkane oxidase', 177, NULL, NULL, 214497),
(214498, '3.30.70.330-FF-000549', NULL, 'Plastid-specific 30S ribosomal protein 2', 102, NULL, NULL, 214498),
(214499, '6.10.140.2220-FF-000044', NULL, 'GH11294p', 44, NULL, NULL, 214499),
(214500, '1.20.1070.10-FF-000537', NULL, '5-hydroxytryptamine (Serotonin) receptor 2A, isoform H', 285, NULL, NULL, 214500),
(214501, '3.30.470.20-FF-000135', NULL, 'Tubulin Tyrosine Ligase Like', 187, NULL, NULL, 214501),
(214502, '1.10.405.20-FF-000007', NULL, NULL, 115, NULL, NULL, 214502),
(214503, '3.80.10.10-FF-000854', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 108, NULL, NULL, 214503),
(214504, '2.10.70.10-FF-000043', NULL, 'Plasminogen activator', 46, NULL, NULL, 214504),
(214505, '2.60.40.420-FF-000270', NULL, 'Cytochrome c oxidase, subunit II', 135, NULL, NULL, 214505),
(214506, '3.40.50.300-FF-005643', NULL, 'Uncharacterized protein', 227, NULL, NULL, 214506),
(214507, '1.10.510.10-FF-001429', NULL, 'Cyclin-dependent kinase 14', 143, NULL, NULL, 214507),
(214508, '1.25.40.20-FF-001648', NULL, 'Predicted protein', 88, NULL, NULL, 214508),
(214509, '1.10.510.10-FF-001317', NULL, 'Protein kinase domain containing protein', 196, NULL, NULL, 214509),
(214510, '3.80.10.10-FF-000742', NULL, 'Pollen-specific leucine-rich repeat extensin-like protein 1', 300, NULL, NULL, 214510);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(214511, '1.20.900.10-FF-000018', NULL, 'Phosphatidylinositol-3,4, 5-trisphosphate-dependent Rac exchange factor 2, putative', 210, NULL, NULL, 214511),
(214512, '3.30.160.60-FF-001865', NULL, 'Zinc finger protein 404', 28, NULL, NULL, 214512),
(214513, '3.60.21.10-FF-000032', NULL, 'Tartrate-resistant acid phosphatase type 5', 337, NULL, NULL, 214513),
(214514, '1.10.2000.10-FF-000002', NULL, 'Inactive tyrosine-protein kinase transmembrane receptor ROR1', 133, NULL, NULL, 214514),
(214515, '2.120.10.80-FF-000297', NULL, 'Predicted protein', 207, NULL, NULL, 214515),
(214516, '3.90.660.10-FF-000116', NULL, NULL, 136, NULL, NULL, 214516),
(214517, '1.25.40.470-FF-000020', NULL, 'Intraflagellar transport protein 172', 171, NULL, NULL, 214517),
(214518, '3.40.50.2000-FF-000094', NULL, 'UDP-glucuronosyltransferase', 172, NULL, NULL, 214518),
(214519, '1.10.10.10-FF-001407', NULL, 'Transcriptional regulator MarR family', 137, NULL, NULL, 214519),
(214520, '3.40.50.300-FF-001248', NULL, 'ABC transporter, ATP-binding protein', 290, NULL, NULL, 214520),
(214521, '3.30.710.10-FF-000505', NULL, 'Uncharacterized protein', 121, NULL, NULL, 214521),
(214522, '3.40.50.720-FF-002548', NULL, 'Uncharacterized protein', 69, NULL, NULL, 214522),
(214523, '1.10.8.530-FF-000004', NULL, 'DNA polymerase alpha subunit B', 77, NULL, NULL, 214523),
(214524, '3.30.1120.100-FF-000002', NULL, 'Fatty acid synthase beta subunit aflB', 123, NULL, NULL, 214524),
(214525, '1.10.238.10-FF-000779', NULL, 'Calretinin', 67, NULL, NULL, 214525),
(214526, '2.60.40.10-FF-003456', NULL, NULL, 100, NULL, NULL, 214526),
(214527, '3.70.10.10-FF-000040', NULL, 'DNA polymerase sliding clamp', 248, NULL, NULL, 214527),
(214528, '3.40.50.10090-FF-000063', NULL, 'Uroporphyrin-III C-methyltransferase', 98, NULL, NULL, 214528),
(214529, '3.30.160.60-FF-005710', NULL, NULL, 53, NULL, NULL, 214529),
(214530, '3.10.50.40-FF-000104', NULL, 'Peptidylprolyl isomerase', 135, NULL, NULL, 214530),
(214531, '2.60.40.10-FF-004867', NULL, NULL, 93, NULL, NULL, 214531),
(214532, '2.10.25.10-FF-000096', NULL, 'Putative fibrillin 2', 40, NULL, NULL, 214532),
(214533, '3.40.50.620-FF-000057', NULL, 'tRNA-specific 2-thiouridylase MnmA', 217, NULL, NULL, 214533),
(214534, '3.90.70.80-FF-000103', NULL, 'Uncharacterized protein', 46, NULL, NULL, 214534),
(214535, '3.40.50.11350-FF-000036', NULL, 'Uncharacterized protein', 160, NULL, NULL, 214535),
(214536, '1.25.40.10-FF-005018', NULL, 'Uncharacterized protein', 130, NULL, NULL, 214536),
(214537, '3.40.850.10-FF-000384', NULL, 'Kinesin-like protein', 313, NULL, NULL, 214537),
(214538, '3.10.350.10-FF-000066', NULL, 'Lipoprotein', 67, NULL, NULL, 214538),
(214539, '1.20.120.850-FF-000035', NULL, 'DNA repair and recombination protein RAD54B', 117, NULL, NULL, 214539),
(214540, '1.20.58.60-FF-000469', NULL, 'Protein CBG15811', 194, NULL, NULL, 214540),
(214541, '3.50.50.60-FF-000558', NULL, 'Rab proteins geranylgeranyltransferase', 147, NULL, NULL, 214541),
(214542, '1.25.10.10-FF-001155', NULL, 'Condensin-2 complex subunit', 298, NULL, NULL, 214542),
(214543, '1.20.120.1750-FF-000099', NULL, 'RBR-type E3 ubiquitin transferase', 219, NULL, NULL, 214543),
(214544, '3.40.190.10-FF-000597', NULL, 'Ionotropic glutamate receptor, putative', 62, NULL, NULL, 214544),
(214545, '3.30.160.60-FF-001770', NULL, 'Zinc finger protein 526', 30, NULL, NULL, 214545),
(214546, '3.30.450.20-FF-000252', NULL, 'PAS sensor protein', 125, NULL, NULL, 214546),
(214547, '1.25.40.10-FF-003332', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform A', 220, NULL, NULL, 214547),
(214548, '2.60.40.10-FF-003670', NULL, NULL, 56, NULL, NULL, 214548),
(214549, '3.40.50.200-FF-000021', NULL, 'Proprotein convertase subtilisin/kexin type 5a', 329, NULL, NULL, 214549),
(214550, '2.130.10.10-FF-005025', NULL, 'Protein HIR', 305, NULL, NULL, 214550),
(214551, '3.40.50.10490-FF-000104', NULL, NULL, 152, NULL, NULL, 214551),
(214552, '3.30.160.60-FF-003456', NULL, NULL, 32, NULL, NULL, 214552),
(214553, '4.10.1080.10-FF-000010', NULL, 'Uncharacterized protein', 43, NULL, NULL, 214553);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(214554, '3.30.40.10-FF-002354', NULL, 'Nucleic acid binding protein, putative', 87, NULL, NULL, 214554),
(214555, '3.40.50.720-FF-000087', NULL, 'alpha-aminoadipic semialdehyde synthase, mitochondrial', 145, NULL, NULL, 214555),
(214556, '3.40.1110.10-FF-000260', NULL, NULL, 24, NULL, NULL, 214556),
(214557, '2.60.40.2660-FF-000006', NULL, NULL, 151, NULL, NULL, 214557),
(214558, '2.10.25.10-FF-000107', NULL, 'Fibrillin 2', 44, NULL, NULL, 214558),
(214559, '3.50.50.60-FF-000772', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 172, NULL, NULL, 214559),
(214560, '1.20.1050.120-FF-000004', NULL, NULL, 149, NULL, NULL, 214560),
(214561, '3.30.1490.80-FF-000007', NULL, 'Glutathione synthetase', 15, NULL, NULL, 214561),
(214562, '1.20.120.740-FF-000002', NULL, 'UPF0149 protein XC_0904', 174, NULL, NULL, 214562),
(214563, '3.30.70.660-FF-000064', NULL, 'tRNA pseudouridine synthase', 144, NULL, NULL, 214563),
(214564, '3.100.10.10-FF-000059', NULL, NULL, 72, NULL, NULL, 214564),
(214565, '4.10.320.30-FF-000004', NULL, 'Myelin transcription factor 1a', 25, NULL, NULL, 214565),
(214566, '2.30.40.10-FF-000052', NULL, 'Dihydroorotase', 82, NULL, NULL, 214566),
(214567, '1.10.287.130-FF-000035', NULL, 'Two-component sensor histidine kinase', 115, NULL, NULL, 214567),
(214568, '2.60.120.200-FF-000746', NULL, 'AGAP011278-PA', 140, NULL, NULL, 214568),
(214569, '3.90.1150.10-FF-000419', NULL, 'Uncharacterized protein', 102, NULL, NULL, 214569),
(214570, '3.40.50.300-FF-002203', NULL, 'ATP-dependent RNA helicase (Hrh1), putative', 257, NULL, NULL, 214570),
(214571, '3.20.20.140-FF-000271', NULL, 'Uncharacterized protein', 55, NULL, NULL, 214571),
(214572, '3.40.50.1820-FF-001202', NULL, 'Uncharacterized protein', 96, NULL, NULL, 214572),
(214573, '3.80.10.10-FF-002119', NULL, 'Uncharacterized protein', 170, NULL, NULL, 214573),
(214574, '3.30.160.60-FF-005805', NULL, NULL, 48, NULL, NULL, 214574),
(214575, '1.25.40.420-FF-000033', NULL, 'BTB/POZ domain-containing protein', 104, NULL, NULL, 214575),
(214576, '1.10.8.60-FF-000235', NULL, 'ATPase, AAA family protein', 85, NULL, NULL, 214576),
(214577, '3.30.70.1230-FF-000230', NULL, 'Uncharacterized protein', 183, NULL, NULL, 214577),
(214578, '3.30.450.60-FF-000005', NULL, 'AP complex subunit sigma', 158, NULL, NULL, 214578),
(214579, '1.25.10.10-FF-000975', NULL, 'Serine/threonine-protein kinase TOR', 242, NULL, NULL, 214579),
(214580, '1.10.10.10-FF-001424', NULL, 'LysR family transcriptional regulator', 82, NULL, NULL, 214580),
(214581, '1.10.840.10-FF-000004', NULL, 'ras-specific guanine nucleotide-releasing factor 2 isoform X1', 238, NULL, NULL, 214581),
(214582, '3.30.70.590-FF-000014', NULL, 'Uncharacterized protein', 134, NULL, NULL, 214582),
(214583, '2.60.120.290-FF-000172', NULL, 'Multiple epidermal growth factor-like domains protein 8', 118, NULL, NULL, 214583),
(214584, '3.40.50.300-FF-005290', NULL, 'Gluconokinase', 176, NULL, NULL, 214584),
(214585, '3.40.50.300-FF-005626', NULL, 'Predicted protein', 19, NULL, NULL, 214585),
(214586, '1.10.1040.10-FF-000083', NULL, 'Chromosome 1, whole genome shotgun sequence', 157, NULL, NULL, 214586),
(214587, '3.30.160.60-FF-003905', NULL, NULL, 31, NULL, NULL, 214587),
(214588, '3.30.450.50-FF-000002', NULL, 'Vesicle-associated membrane protein 722', 127, NULL, NULL, 214588),
(214589, '3.40.50.300-FF-001591', NULL, 'Primosomal protein N''', 195, NULL, NULL, 214589),
(214590, '1.10.287.70-FF-000281', NULL, 'Uncharacterized protein', 150, NULL, NULL, 214590),
(214591, '3.40.50.300-FF-001927', NULL, 'Nucleolar GTP-binding protein 1', 206, NULL, NULL, 214591),
(214592, '1.10.287.70-FF-000617', NULL, 'Uncharacterized protein', 242, NULL, NULL, 214592),
(214593, '2.10.25.10-FF-000079', NULL, 'Attractin like 1', 43, NULL, NULL, 214593),
(214594, '1.20.120.350-FF-000110', NULL, 'Sodium channel protein', 70, NULL, NULL, 214594),
(214595, '1.20.1070.10-FF-000751', NULL, 'Adhesion G protein-coupled receptor L3', 264, NULL, NULL, 214595),
(214596, '3.40.50.300-FF-003726', NULL, 'WGS project CABT00000000 data, contig 2.2', 159, NULL, NULL, 214596); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(214597, '1.20.59.10-FF-000018', NULL, 'Uncharacterized protein', 97, NULL, NULL, 214597),
(214598, '2.60.120.200-FF-000297', NULL, 'MAM and LDL-receptor class A domain-containing protein 1', 183, NULL, NULL, 214598),
(214599, '3.40.710.10-FF-000014', NULL, 'Glutaminase', 310, NULL, NULL, 214599),
(214600, '2.130.10.10-FF-003434', NULL, 'Uncharacterized protein', 156, NULL, NULL, 214600),
(214601, '3.60.110.10-FF-000059', NULL, NULL, 217, NULL, NULL, 214601),
(214602, '3.30.1050.10-FF-000038', NULL, 'Alkyl/aryl-sulfatase BDS1', 128, NULL, NULL, 214602),
(214603, '1.20.1250.20-FF-000190', NULL, 'Sugar transporter family protein', 212, NULL, NULL, 214603),
(214604, '3.40.50.620-FF-000383', NULL, 'LD26737p', 242, NULL, NULL, 214604),
(214605, '1.20.1250.20-FF-000526', NULL, 'Tetracycline resistance protein TetL', 190, NULL, NULL, 214605),
(214606, '3.40.50.620-FF-000719', NULL, '7-cyano-7-deazaguanine synthase', 213, NULL, NULL, 214606),
(214607, '1.20.5.2210-FF-000004', NULL, 'ATP Synthase B homolog', 86, NULL, NULL, 214607),
(214608, '3.20.20.70-FF-000510', NULL, 'Dihydroorotate dehydrogenase', 308, NULL, NULL, 214608),
(214609, '3.30.460.10-FF-000058', NULL, 'Interleukin enhancer-binding factor 2', 152, NULL, NULL, 214609),
(214610, '2.10.25.10-FF-000433', NULL, 'Laminin subunit gamma 3', 46, NULL, NULL, 214610),
(214611, '2.60.120.260-FF-000399', NULL, 'Predicted protein', 159, NULL, NULL, 214611),
(214612, '3.90.1030.10-FF-000017', NULL, '50S ribosomal protein L17', 116, NULL, NULL, 214612),
(214613, '3.30.200.20-FF-001711', NULL, 'Serine/threonine-protein kinase RIO2', 35, NULL, NULL, 214613),
(214614, '3.30.559.10-FF-000170', NULL, 'Uncharacterized protein', 166, NULL, NULL, 214614),
(214615, '3.20.20.80-FF-000513', NULL, 'Di-N-acetylchitobiase', 25, NULL, NULL, 214615),
(214616, '1.25.40.10-FF-001078', NULL, 'Pre-mRNA-splicing factor SYF1', 115, NULL, NULL, 214616),
(214617, '1.10.510.10-FF-002857', NULL, NULL, 88, NULL, NULL, 214617),
(214618, '2.40.50.140-FF-000658', NULL, 'Transcription elongation factor SPT6-like Protein', 69, NULL, NULL, 214618),
(214619, '3.90.180.10-FF-000074', NULL, 'Glucose 1-dehydrogenase', 173, NULL, NULL, 214619),
(214620, '3.40.50.800-FF-000122', NULL, 'Histidine--tRNA ligase', 87, NULL, NULL, 214620),
(214621, '3.30.450.20-FF-000235', NULL, 'Signal transduction histidine kinase', 122, NULL, NULL, 214621),
(214622, '1.20.58.90-FF-000012', NULL, 'SNARE domain protein', 110, NULL, NULL, 214622),
(214623, '2.130.10.10-FF-005463', NULL, 'Uncharacterized protein', 171, NULL, NULL, 214623),
(214624, '1.10.10.60-FF-000101', NULL, 'NK2 homeobox 8', 80, NULL, NULL, 214624),
(214625, '4.10.760.10-FF-000003', NULL, 'Agouti-related peptide 2', 52, NULL, NULL, 214625),
(214626, '2.140.10.30-FF-000011', NULL, 'Acylaminoacyl-peptidase', 97, NULL, NULL, 214626),
(214627, '2.60.120.200-FF-000651', NULL, 'Fat1 protein', 99, NULL, NULL, 214627),
(214628, '3.40.720.10-FF-000172', NULL, 'Alkaline-phosphatase-like family protein', 139, NULL, NULL, 214628),
(214629, '3.40.50.360-FF-000041', NULL, 'NAD(P)H-dependent FMN reductase', 185, NULL, NULL, 214629),
(214630, '1.10.30.20-FF-000001', NULL, 'DNA repair helicase rad15', 83, NULL, NULL, 214630),
(214631, '3.40.390.10-FF-000039', NULL, 'Peptidase M3', 99, NULL, NULL, 214631),
(214632, '3.40.50.2300-FF-001015', NULL, NULL, 115, NULL, NULL, 214632),
(214633, '3.10.580.10-FF-000212', NULL, 'Uncharacterized protein', 41, NULL, NULL, 214633),
(214634, '3.40.1280.30-FF-000002', NULL, 'tRNA methyltransferase 10 homolog B', 201, NULL, NULL, 214634),
(214635, '1.20.58.60-FF-000823', NULL, 'Spectrin repeat containing nuclear envelope protein 2', 179, NULL, NULL, 214635),
(214636, '1.20.920.10-FF-000115', NULL, 'Histone-lysine N-methyltransferase', 115, NULL, NULL, 214636),
(214637, '2.30.30.190-FF-000019', NULL, 'Associated kinase of Tb14-3-3', 83, NULL, NULL, 214637),
(214638, '3.30.70.330-FF-002792', NULL, NULL, 14, NULL, NULL, 214638),
(214639, '3.30.1370.110-FF-000032', NULL, 'Predicted protein', 107, NULL, NULL, 214639),
(214640, '3.10.580.10-FF-000116', NULL, 'Domain_of_uncharacterized_function_DUF21_-_putative', 181, NULL, NULL, 214640);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(214641, '2.40.30.30-FF-000023', NULL, 'Riboflavin kinase, FMN adenylyltransferase', 135, NULL, NULL, 214641),
(214642, '3.40.50.2300-FF-000739', NULL, 'Glutamate receptor', 94, NULL, NULL, 214642),
(214643, '3.30.40.10-FF-000667', NULL, 'Phosphatidylinositol kinase (PIK-D)', 72, NULL, NULL, 214643),
(214644, '3.40.50.1400-FF-000014', NULL, 'Ferrochelatase', 170, NULL, NULL, 214644),
(214645, '3.40.50.720-FF-000750', NULL, 'YGL159W-like protein', 206, NULL, NULL, 214645),
(214646, '3.30.160.60-FF-001427', NULL, 'Zinc finger 45-like', 29, NULL, NULL, 214646),
(214647, '3.30.70.330-FF-002466', NULL, NULL, 81, NULL, NULL, 214647),
(214648, '2.40.30.20-FF-000020', NULL, 'Vacuolar ATP synthase catalytic subunit A', 76, NULL, NULL, 214648),
(214649, '1.10.600.10-FF-000127', NULL, 'Uncharacterized protein', 67, NULL, NULL, 214649),
(214650, '1.25.10.10-FF-002678', NULL, 'Uncharacterized protein', 84, NULL, NULL, 214650),
(214651, '1.20.120.310-FF-000008', NULL, 'Sulfhydryl oxidase', 122, NULL, NULL, 214651),
(214652, '2.30.29.30-FF-000609', NULL, 'Protein kinase domain containing protein', 93, NULL, NULL, 214652),
(214653, '3.30.300.70-FF-000008', NULL, 'Ribosome maturation factor RimP', 72, NULL, NULL, 214653),
(214654, '2.40.50.140-FF-000984', NULL, NULL, 68, NULL, NULL, 214654),
(214655, '1.25.40.570-FF-000050', NULL, 'Uncharacterized protein', 395, NULL, NULL, 214655),
(214656, '3.40.50.300-FF-003491', NULL, 'RAB39A, member RAS oncogene family', 201, NULL, NULL, 214656),
(214657, '1.10.8.10-FF-000136', NULL, 'Ubiquitinyl hydrolase 1', 54, NULL, NULL, 214657),
(214658, '3.90.45.10-FF-000030', NULL, 'Peptide deformylase', 191, NULL, NULL, 214658),
(214659, '3.30.420.40-FF-000868', NULL, 'O-sialoglycoprotein endopeptidase, putative', 76, NULL, NULL, 214659),
(214660, '1.50.10.10-FF-000220', NULL, 'Uncharacterized protein', 89, NULL, NULL, 214660),
(214661, '2.20.25.230-FF-000001', NULL, 'protein zwilch homolog isoform X1', 78, NULL, NULL, 214661),
(214662, '3.30.200.20-FF-001470', NULL, 'Mitogen-activated protein kinase', 65, NULL, NULL, 214662),
(214663, '2.102.20.10-FF-000002', NULL, 'Putative secreted beta-galactosidase', 171, NULL, NULL, 214663),
(214664, '3.30.70.270-FF-000166', NULL, NULL, 164, NULL, NULL, 214664),
(214665, '2.40.50.140-FF-001260', NULL, NULL, 46, NULL, NULL, 214665),
(214666, '1.10.390.10-FF-000031', NULL, 'Cytosol alanyl aminopeptidase', 54, NULL, NULL, 214666),
(214667, '2.60.20.10-FF-000021', NULL, NULL, 93, NULL, NULL, 214667),
(214668, '1.20.810.10-FF-000011', NULL, 'Cytochrome b/b6 domain-containing protein', 200, NULL, NULL, 214668),
(214669, '1.20.940.10-FF-000015', NULL, 'Yeast SEC homolog', 105, NULL, NULL, 214669),
(214670, '3.20.20.190-FF-000027', NULL, 'Phosphoinositide phospholipase C', 325, NULL, NULL, 214670),
(214671, '3.40.50.1820-FF-000601', NULL, 'Carboxylic ester hydrolase', 551, NULL, NULL, 214671),
(214672, '2.20.25.240-FF-000004', NULL, 'Uncharacterized protein, isoform A', 90, NULL, NULL, 214672),
(214673, '1.20.1250.20-FF-002325', NULL, 'Uncharacterized protein', 218, NULL, NULL, 214673),
(214674, '3.40.30.10-FF-000306', NULL, 'Peroxiredoxin', 180, NULL, NULL, 214674),
(214675, '3.30.420.10-FF-000404', NULL, NULL, 192, NULL, NULL, 214675),
(214676, '1.10.1410.20-FF-000007', NULL, 'Uncharacterized protein', 169, NULL, NULL, 214676),
(214677, '3.40.50.1360-FF-000064', NULL, '6-phosphogluconolactonase', 102, NULL, NULL, 214677),
(214678, '2.130.10.10-FF-004957', NULL, 'Uncharacterized protein', 92, NULL, NULL, 214678),
(214679, '1.10.1760.20-FF-000005', NULL, 'Biotin transporter', 188, NULL, NULL, 214679),
(214680, '1.20.1720.10-FF-000043', NULL, 'MFS general substrate transporter', 227, NULL, NULL, 214680),
(214681, '3.90.70.200-FF-000019', NULL, 'RNA polymerase-associated protein RTF1-like protein', 131, NULL, NULL, 214681),
(214682, '4.10.410.10-FF-000022', NULL, 'WAP, Kazal, immunoglobulin, Kunitz and NTR domain-containing protein 1', 59, NULL, NULL, 214682),
(214683, '1.20.1270.60-FF-000056', NULL, 'brain-specific angiogenesis inhibitor 1-associated protein 2-like protein 2', 220, NULL, NULL, 214683); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(214684, '3.40.50.150-FF-001394', NULL, NULL, 168, NULL, NULL, 214684),
(214685, '2.30.42.10-FF-000567', NULL, NULL, 101, NULL, NULL, 214685),
(214686, '3.40.50.1370-FF-000067', NULL, NULL, 42, NULL, NULL, 214686),
(214687, '3.60.10.10-FF-000029', NULL, 'Inositol polyphosphate 5-phosphatase', 346, NULL, NULL, 214687),
(214688, '3.30.470.20-FF-000247', NULL, 'Uncharacterized protein', 51, NULL, NULL, 214688),
(214689, '3.90.190.10-FF-000125', NULL, 'Dual specificity protein phosphatase', 160, NULL, NULL, 214689),
(214690, '3.80.10.10-FF-003968', NULL, 'Uncharacterized protein', 61, NULL, NULL, 214690),
(214691, '3.40.570.10-FF-000025', NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase 1', 321, NULL, NULL, 214691),
(214692, '1.25.10.10-FF-001138', NULL, 'Chromosome 7, whole genome shotgun sequence', 560, NULL, NULL, 214692),
(214693, '1.10.1760.10-FF-000002', NULL, 'Actin-related protein 2/3 complex subunit 3', 176, NULL, NULL, 214693),
(214694, '3.40.50.1820-FF-000685', NULL, '3-oxoadipate enol-lactone hydrolase', 260, NULL, NULL, 214694),
(214695, '1.10.10.10-FF-001750', NULL, 'Endodeoxyribonuclease, putative', 142, NULL, NULL, 214695),
(214696, '2.130.10.10-FF-003108', NULL, 'Uncharacterized protein', 287, NULL, NULL, 214696),
(214697, '3.40.50.2000-FF-000970', NULL, 'Mannosyltransferase', 93, NULL, NULL, 214697),
(214698, '2.80.10.50-FF-000222', NULL, 'Uncharacterized protein', 107, NULL, NULL, 214698),
(214699, '1.10.510.10-FF-003346', NULL, NULL, 239, NULL, NULL, 214699),
(214700, '3.40.1110.10-FF-000243', NULL, 'Sarco/endoplasmic reticulum Ca2+ -ATPase', 246, NULL, NULL, 214700),
(214701, '2.40.37.10-FF-000055', NULL, NULL, 133, NULL, NULL, 214701),
(214702, '3.30.70.260-FF-000163', NULL, 'Amino acid-binding ACT domain regulatory protein', 86, NULL, NULL, 214702),
(214703, '2.60.40.60-FF-000121', NULL, 'Protocadherin 17', 112, NULL, NULL, 214703),
(214704, '3.30.230.10-FF-000154', NULL, 'MeValonate Kinase', 106, NULL, NULL, 214704),
(214705, '3.40.50.720-FF-002099', NULL, 'Hydroxysteroid 11-beta-dehydrogenase 1-like protein', 127, NULL, NULL, 214705),
(214706, '2.130.10.10-FF-005008', NULL, 'Uncharacterized protein', 47, NULL, NULL, 214706),
(214707, '3.30.200.20-FF-000655', NULL, 'AGC/AKT protein kinase', 109, NULL, NULL, 214707),
(214708, '2.30.29.30-FF-000486', NULL, 'Numb-related protein 1', 160, NULL, NULL, 214708),
(214709, '1.25.40.20-FF-001536', NULL, 'Uncharacterized protein', 133, NULL, NULL, 214709),
(214710, '1.25.40.10-FF-001320', NULL, 'Pentatricopeptide repeat-containing protein At5g39350', 103, NULL, NULL, 214710),
(214711, '1.10.260.40-FF-000036', NULL, 'LacI family transcriptional regulator', 58, NULL, NULL, 214711),
(214712, '3.40.50.2300-FF-001341', NULL, NULL, 72, NULL, NULL, 214712),
(214713, '3.80.10.10-FF-004457', NULL, 'Uncharacterized protein', 98, NULL, NULL, 214713),
(214714, '1.25.50.20-FF-000053', NULL, 'Protein CBG09901', 365, NULL, NULL, 214714),
(214715, '1.25.40.10-FF-001533', NULL, 'Cartilage associated protein', 86, NULL, NULL, 214715),
(214716, '2.30.180.10-FF-000012', NULL, 'Fasciclin-like arabinogalactan protein 7', 159, NULL, NULL, 214716),
(214717, '3.90.220.20-FF-000002', NULL, 'Type I restriction-modification system restriction endonuclease DNA specificity subunit HsdS', 187, NULL, NULL, 214717),
(214718, '3.30.200.160-FF-000012', NULL, 'RNA polymerase III transcription factor subunit, putative', 109, NULL, NULL, 214718),
(214719, '2.60.40.1930-FF-000023', NULL, 'MHC-linked complement C4', 121, NULL, NULL, 214719),
(214720, '2.130.10.10-FF-001517', NULL, 'WD domain, G-beta repeat, putative', 78, NULL, NULL, 214720),
(214721, '1.20.1250.10-FF-000068', NULL, 'Ciliary neurotrophic factor', 185, NULL, NULL, 214721),
(214722, '3.40.50.300-FF-008499', NULL, 'ABC transporter, putative', 263, NULL, NULL, 214722),
(214723, '3.40.1370.10-FF-000003', NULL, '50S ribosomal protein L4', 206, NULL, NULL, 214723),
(214724, '3.40.1110.10-FF-000030', NULL, 'Phospholipid-transporting ATPase', 176, NULL, NULL, 214724),
(214725, '3.30.160.60-FF-001753', NULL, 'Si:ch211-119o8.6', 28, NULL, NULL, 214725);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(214726, '3.40.850.10-FF-000507', NULL, 'Uncharacterized protein', 172, NULL, NULL, 214726),
(214727, '3.60.130.10-FF-000055', NULL, 'Butyrobetaine (gamma), 2-oxoglutarate dioxygenase (gamma-butyrobetaine hydroxylase) 1', 104, NULL, NULL, 214727),
(214728, '1.50.10.10-FF-000118', NULL, 'AGL (Amylo-1,6-GLucosidase, 4-alpha-glucanotransferase) glycogen debranching enzyme', 416, NULL, NULL, 214728),
(214729, '1.20.1560.10-FF-000384', NULL, 'Putative ABC transporter', 322, NULL, NULL, 214729),
(214730, '3.40.630.30-FF-000171', NULL, 'Acetyltransferase, GNAT family', 93, NULL, NULL, 214730),
(214731, '3.30.70.100-FF-000143', NULL, NULL, 94, NULL, NULL, 214731),
(214732, '3.10.560.10-FF-000003', NULL, NULL, 40, NULL, NULL, 214732),
(214733, '2.60.40.10-FF-001444', NULL, 'PKHD1, fibrocystin/polyductin', 101, NULL, NULL, 214733),
(214734, '2.60.40.10-FF-003018', NULL, 'T cell receptor alpha constant', 101, NULL, NULL, 214734),
(214735, '1.10.1520.10-FF-000125', NULL, 'Predicted protein', 162, NULL, NULL, 214735),
(214736, '2.60.40.1730-FF-000070', NULL, NULL, 218, NULL, NULL, 214736),
(214737, '2.30.29.30-FF-000711', NULL, 'PH and Rap-GAP domain-containing protein DDB_G0271806', 111, NULL, NULL, 214737),
(214738, '1.10.630.10-FF-000516', NULL, 'Chromosome 9, whole genome shotgun sequence', 414, NULL, NULL, 214738),
(214739, '3.10.20.90-FF-000140', NULL, 'RanBP-type and C3HC4-type zinc finger-containing protein 1', 86, NULL, NULL, 214739),
(214740, '1.10.510.10-FF-001194', NULL, 'Calcium/calmodulin-dependent protein kinase type 1D, putative', 295, NULL, NULL, 214740),
(214741, '3.30.70.330-FF-000892', NULL, 'AGAP002655-PA', 108, NULL, NULL, 214741),
(214742, '3.30.450.20-FF-000690', NULL, 'Sensory transduction histidine kinase', 145, NULL, NULL, 214742),
(214743, '1.10.340.30-FF-000085', NULL, '8-oxoguanine DNA glycosylase, putative', 124, NULL, NULL, 214743),
(214744, '2.60.40.10-FF-003911', NULL, NULL, 110, NULL, NULL, 214744),
(214745, '2.60.220.50-FF-000145', NULL, 'Uncharacterized protein (Fragment)', 201, NULL, NULL, 214745),
(214746, '3.90.370.10-FF-000009', NULL, 'metalloproteinase inhibitor 3-like', 73, NULL, NULL, 214746),
(214747, '3.90.25.10-FF-000028', NULL, 'UDP-glucose 4-epimerase GalE', 110, NULL, NULL, 214747),
(214748, '3.40.50.20-FF-000069', NULL, 'Bifunctional purine synthesis protein purC/E', 112, NULL, NULL, 214748),
(214749, '3.40.50.12780-FF-000151', NULL, 'Uncharacterized protein', 385, NULL, NULL, 214749),
(214750, '3.40.50.12230-FF-000008', NULL, 'Formyl transferase domain protein', 286, NULL, NULL, 214750),
(214751, '1.10.510.10-FF-001755', NULL, 'Serine/threonine protein kinase', 221, NULL, NULL, 214751),
(214752, '3.40.50.1170-FF-000007', NULL, 'Asparaginase homolog (S. cerevisiae)', 204, NULL, NULL, 214752),
(214753, '2.30.30.140-FF-000246', NULL, 'Uncharacterized protein', 57, NULL, NULL, 214753),
(214754, '2.60.40.10-FF-005373', NULL, NULL, 60, NULL, NULL, 214754),
(214755, '1.10.565.10-FF-000162', NULL, 'Uncharacterized protein', 208, NULL, NULL, 214755),
(214756, '1.10.238.10-FF-000211', NULL, 'Mitochondrial calcium uptake family member 3', 180, NULL, NULL, 214756),
(214757, '3.90.320.10-FF-000063', NULL, 'RecBCD enzyme subunit RecB', 306, NULL, NULL, 214757),
(214758, '3.30.56.10-FF-000018', NULL, 'Phenylalanine--tRNA ligase beta subunit', 74, NULL, NULL, 214758),
(214759, '3.40.50.620-FF-000512', NULL, 'Isoleucyl-tRNA synthetase family protein', 269, NULL, NULL, 214759),
(214760, '1.10.220.30-FF-000042', NULL, 'Flagellar motor switch protein FliG', 92, NULL, NULL, 214760),
(214761, '2.30.29.30-FF-001200', NULL, 'Mannosyltransferase', 59, NULL, NULL, 214761),
(214762, '3.40.50.300-FF-003165', NULL, 'E3 ubiquitin-protein ligase SHPRH, variant', 187, NULL, NULL, 214762),
(214763, '1.25.40.80-FF-000003', NULL, 'cryptochrome-1 isoform X1', 76, NULL, NULL, 214763),
(214764, '1.20.5.4130-FF-000001', NULL, 'NB-ARC domain containing protein, expressed', 116, NULL, NULL, 214764),
(214765, '3.40.50.300-FF-006599', NULL, 'Uncharacterized protein', 97, NULL, NULL, 214765);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(214766, '3.40.50.300-FF-007088', NULL, 'Predicted protein', 190, NULL, NULL, 214766),
(214767, '3.80.10.10-FF-000293', NULL, 'Protein phosphatase 1 regulatory subunit 42', 106, NULL, NULL, 214767),
(214768, '2.30.42.10-FF-000129', NULL, 'Tyrosine-protein phosphatase non-receptor type 13', 102, NULL, NULL, 214768),
(214769, '1.20.58.1610-FF-000015', NULL, NULL, 123, NULL, NULL, 214769),
(214770, '2.40.50.140-FF-001046', NULL, NULL, 118, NULL, NULL, 214770),
(214771, '3.30.1140.32-FF-000019', NULL, 'Putative ribosomal protein S3', 98, NULL, NULL, 214771),
(214772, '2.160.20.80-FF-000003', NULL, 'thylakoid lumenal 15 kDa protein 1, chloroplastic', 144, NULL, NULL, 214772),
(214773, '3.30.160.60-FF-003018', NULL, NULL, 27, NULL, NULL, 214773),
(214774, '3.30.1300.30-FF-000013', NULL, 'T2aSS secretion system pseudopilus protein GspI', 88, NULL, NULL, 214774),
(214775, '3.10.290.70-FF-000005', NULL, '40S ribosomal protein S8', 61, NULL, NULL, 214775),
(214776, '1.10.630.10-FF-000421', NULL, 'Kaurene oxidase2', 74, NULL, NULL, 214776),
(214777, '3.40.50.11610-FF-000036', NULL, NULL, 97, NULL, NULL, 214777),
(214778, '3.20.20.140-FF-000041', NULL, 'Dihydroorotase, variant', 351, NULL, NULL, 214778),
(214779, '1.10.287.70-FF-000393', NULL, 'Calcium channel, voltage-dependent, T type, alpha 1I subunit', 119, NULL, NULL, 214779),
(214780, '3.40.850.10-FF-000288', NULL, 'Kinesin motor domain containing protein', 320, NULL, NULL, 214780),
(214781, '1.10.287.130-FF-000153', NULL, 'Sensor histidine kinase', 64, NULL, NULL, 214781),
(214782, '1.10.287.70-FF-000505', NULL, 'Uncharacterized protein', 165, NULL, NULL, 214782),
(214783, '3.40.190.10-FF-000485', NULL, 'Sensory box sensor histidine kinase/response regulator VieS', 88, NULL, NULL, 214783),
(214784, '1.10.287.70-FF-000410', NULL, 'Uncharacterized protein', 138, NULL, NULL, 214784),
(214785, '2.60.120.590-FF-000037', NULL, 'DNA oxidative demethylase ALKBH2', 96, NULL, NULL, 214785),
(214786, '3.30.70.1730-FF-000060', NULL, 'Uncharacterized protein', 118, NULL, NULL, 214786),
(214787, '1.20.1560.10-FF-000171', NULL, 'ATP-binding cassette (ABC) transporter, putative', 363, NULL, NULL, 214787),
(214788, '3.40.50.10140-FF-000022', NULL, 'Myd88', 133, NULL, NULL, 214788),
(214789, '2.10.25.10-FF-000545', NULL, 'von Willebrand factor C and EGF domain-containing protein', 38, NULL, NULL, 214789),
(214790, '3.40.50.620-FF-000607', NULL, 'Arginine--tRNA ligase', 396, NULL, NULL, 214790),
(214791, '3.40.190.80-FF-000022', NULL, 'Inositol-1-monophosphatase', 124, NULL, NULL, 214791),
(214792, '2.60.40.10-FF-005143', NULL, NULL, 120, NULL, NULL, 214792),
(214793, '3.40.1620.10-FF-000001', NULL, 'Antitoxin', 40, NULL, NULL, 214793),
(214794, '3.30.505.10-FF-000202', NULL, NULL, 99, NULL, NULL, 214794),
(214795, '1.20.1460.10-FF-000011', NULL, 'V-type proton ATPase subunit C', 174, NULL, NULL, 214795),
(214796, '3.50.30.30-FF-000082', NULL, 'Probable M28 family peptidase (Homolog to aminopeptidase YwaD)', 134, NULL, NULL, 214796),
(214797, '3.30.1360.120-FF-000100', NULL, 'Predicted protein', 111, NULL, NULL, 214797),
(214798, '2.40.50.140-FF-000445', NULL, 'RNA Polymerase, Class III (C)', 114, NULL, NULL, 214798),
(214799, '1.10.287.70-FF-000404', NULL, 'Uncharacterized protein', 162, NULL, NULL, 214799),
(214800, '3.40.710.10-FF-000126', NULL, 'Penicillin-binding protein 1A (PBP-1A)', 408, NULL, NULL, 214800),
(214801, '3.40.50.620-FF-000596', NULL, 'tRNA-specific 2-thiouridylase MnmA protein', 126, NULL, NULL, 214801),
(214802, '3.30.200.20-FF-000868', NULL, 'Uncharacterized protein', 111, NULL, NULL, 214802),
(214803, '1.20.1050.10-FF-000093', NULL, 'Glutathione-S-transferase/glutaredoxin,putative', 162, NULL, NULL, 214803),
(214804, '2.170.16.10-FF-000051', NULL, 'DNA gyrase subunit A', 85, NULL, NULL, 214804),
(214805, '2.130.10.10-FF-002945', NULL, 'Cytoplasmic dynein 1 intermediate chain', 279, NULL, NULL, 214805),
(214806, '2.60.40.10-FF-001871', NULL, 'protein sidekick isoform X1', 103, NULL, NULL, 214806),
(214807, '3.40.50.800-FF-000010', NULL, 'Putative nuclear receptor coactivator 5', 116, NULL, NULL, 214807);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(214808, '1.20.1540.10-FF-000057', NULL, 'Peptidase, S54 family', 187, NULL, NULL, 214808),
(214809, '3.40.50.300-FF-007217', NULL, 'Uncharacterized protein', 164, NULL, NULL, 214809),
(214810, '3.40.50.620-FF-000495', NULL, 'Uncharacterized protein', 149, NULL, NULL, 214810),
(214811, '3.90.660.10-FF-000088', NULL, NULL, 70, NULL, NULL, 214811),
(214812, '3.90.70.80-FF-000075', NULL, 'Predicted protein', 139, NULL, NULL, 214812),
(214813, '1.10.10.60-FF-000894', NULL, NULL, 81, NULL, NULL, 214813),
(214814, '3.40.50.2000-FF-000644', NULL, 'Os11g0461200 protein', 76, NULL, NULL, 214814),
(214815, '3.30.1360.40-FF-000019', NULL, 'Multifunctional urea amidolyase', 100, NULL, NULL, 214815),
(214816, '3.60.10.10-FF-000361', NULL, 'DNA-(apurinic or apyrimidinic site) lyase', 130, NULL, NULL, 214816),
(214817, '2.60.120.200-FF-000185', NULL, 'EGF like domain multiple 6', 166, NULL, NULL, 214817),
(214818, '3.40.50.300-FF-001809', NULL, 'Si:ch1073-365p7.2', 203, NULL, NULL, 214818),
(214819, '1.10.10.10-FF-001071', NULL, 'Selenocysteine-specific elongation factor', 62, NULL, NULL, 214819),
(214820, '1.10.287.470-FF-000002', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 74, NULL, NULL, 214820),
(214821, '3.40.50.11260-FF-000009', NULL, 'Chaperone protein HtpG', 84, NULL, NULL, 214821),
(214822, '1.25.40.20-FF-001199', NULL, 'Poly [ADP-ribose] polymerase tankyrase', 151, NULL, NULL, 214822),
(214823, '1.25.40.120-FF-000033', NULL, 'Predicted protein', 296, NULL, NULL, 214823),
(214824, '1.20.5.4880-FF-000001', NULL, 'Guanine nucleotide exchange factor for Rab-3A', 84, NULL, NULL, 214824),
(214825, '3.40.50.12780-FF-000038', NULL, 'Ebony protein', 424, NULL, NULL, 214825),
(214826, '3.40.50.620-FF-000720', NULL, 'Uncharacterized protein', 211, NULL, NULL, 214826),
(214827, '3.20.20.330-FF-000007', NULL, 'Homocysteine S-methyltransferase (Eurofung)', 349, NULL, NULL, 214827),
(214828, '2.130.10.10-FF-001309', NULL, 'Probable cytosolic iron-sulfur protein assembly protein 1', 327, NULL, NULL, 214828),
(214829, '1.10.510.10-FF-003913', NULL, NULL, 78, NULL, NULL, 214829),
(214830, '3.40.720.10-FF-000054', NULL, 'non-specific phospholipase C6', 174, NULL, NULL, 214830),
(214831, '3.90.640.10-FF-000093', NULL, 'Hsp70 protein/TPR repeat/Tetratricopeptide repeat, putative', 87, NULL, NULL, 214831),
(214832, '3.20.20.70-FF-000173', NULL, 'Nicotinate phosphoribosyltransferase', 75, NULL, NULL, 214832),
(214833, '3.10.450.50-FF-000097', NULL, 'Uncharacterized protein', 94, NULL, NULL, 214833),
(214834, '3.30.40.100-FF-000002', NULL, 'Lysine-specific histone demethylase 1B', 58, NULL, NULL, 214834),
(214835, '3.30.70.270-FF-000284', NULL, NULL, 95, NULL, NULL, 214835),
(214836, '3.40.50.200-FF-000133', NULL, 'Predicted protein', 124, NULL, NULL, 214836),
(214837, '1.10.630.10-FF-000308', NULL, 'Uncharacterized protein', 339, NULL, NULL, 214837),
(214838, '1.10.238.10-FF-001167', NULL, 'Voltage-dependent N-type calcium channel subunit alpha', 100, NULL, NULL, 214838),
(214839, '1.20.5.320-FF-000029', NULL, 'Collagen alpha-1(XVII) chain', 46, NULL, NULL, 214839),
(214840, '1.50.40.10-FF-000401', NULL, 'Uncharacterized protein', 184, NULL, NULL, 214840),
(214841, '3.30.505.10-FF-000101', NULL, 'Tyrosine-protein kinase', 116, NULL, NULL, 214841),
(214842, '2.10.25.10-FF-000646', NULL, 'Agrin', 40, NULL, NULL, 214842),
(214843, '3.40.50.620-FF-000506', NULL, 'DNA photolyase (Eurofung)', 179, NULL, NULL, 214843),
(214844, '3.30.160.60-FF-003344', NULL, 'Zinc finger protein 343', 28, NULL, NULL, 214844),
(214845, '3.40.50.300-FF-006014', NULL, 'MutS domain V domaincontaining protein', 136, NULL, NULL, 214845),
(214846, '2.60.120.430-FF-000017', NULL, 'PA-I galactophilic lectin', 121, NULL, NULL, 214846),
(214847, '3.80.10.10-FF-004244', NULL, 'Leucine rich repeat containing G protein-coupled receptor 4', 73, NULL, NULL, 214847),
(214848, '3.40.50.1460-FF-000105', NULL, 'Uncharacterized protein', 134, NULL, NULL, 214848),
(214849, '3.30.930.10-FF-000050', NULL, 'Bifunctional ligase/repressor BirA', 206, NULL, NULL, 214849);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(214850, '2.40.240.10-FF-000009', NULL, '50S ribosomal protein L25', 86, NULL, NULL, 214850),
(214851, '3.40.50.1820-FF-000814', NULL, 'GPI inositol-deacylase', 218, NULL, NULL, 214851),
(214852, '1.20.5.170-FF-000063', NULL, 'G-box binding factor 3', 56, NULL, NULL, 214852),
(214853, '1.20.1250.20-FF-000397', NULL, 'Aminotriazole resistance protein', 261, NULL, NULL, 214853),
(214854, '3.40.33.10-FF-000105', NULL, 'Pathogenesis-related protein 1', 138, NULL, NULL, 214854),
(214855, '3.30.70.330-FF-002348', NULL, NULL, 107, NULL, NULL, 214855),
(214856, '2.130.10.10-FF-001523', NULL, 'Splicing factor 3b subunit 3, putative', 321, NULL, NULL, 214856),
(214857, '1.25.40.10-FF-002944', NULL, 'Pentatricopeptide repeat-containing protein At1g09220, mitochondrial', 118, NULL, NULL, 214857),
(214858, '2.60.40.60-FF-000689', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 2', 104, NULL, NULL, 214858),
(214859, '3.90.228.20-FF-000014', NULL, NULL, 168, NULL, NULL, 214859),
(214860, '1.25.10.10-FF-001705', NULL, 'Uncharacterized protein', 246, NULL, NULL, 214860),
(214861, '3.90.228.10-FF-000011', NULL, 'Poly(ADP-ribose) polymerase family member 9', 180, NULL, NULL, 214861),
(214862, '3.10.290.60-FF-000002', NULL, 'Ubiquitin-like modifier-activating enzyme 1', 96, NULL, NULL, 214862),
(214863, '3.20.20.80-FF-000176', NULL, 'Glycoside hydrolase family 128 protein', 202, NULL, NULL, 214863),
(214864, '1.10.287.10-FF-000061', NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase', 22, NULL, NULL, 214864),
(214865, '1.10.630.10-FF-000522', NULL, 'Uncharacterized protein', 398, NULL, NULL, 214865),
(214866, '1.20.1740.10-FF-000044', NULL, 'Amino acid permease', 411, NULL, NULL, 214866),
(214867, '4.10.240.10-FF-000205', NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', 71, NULL, NULL, 214867),
(214868, '3.40.20.10-FF-000031', NULL, 'protein flightless-1 homolog isoform X1', 108, NULL, NULL, 214868),
(214869, '1.25.40.1040-FF-000053', NULL, 'RNA processing protein', 307, NULL, NULL, 214869),
(214870, '3.40.850.10-FF-000513', NULL, 'Uncharacterized protein', 118, NULL, NULL, 214870),
(214871, '1.20.58.60-FF-000262', NULL, 'Uncharacterized protein, isoform J', 285, NULL, NULL, 214871),
(214872, '3.30.1370.10-FF-000197', NULL, 'KH domain-containing protein 3', 122, NULL, NULL, 214872),
(214873, '3.10.110.10-FF-000189', NULL, 'UBE2M isoform 3', 83, NULL, NULL, 214873),
(214874, '1.25.40.10-FF-001527', NULL, 'Pentatricopeptide repeat-containing protein', 234, NULL, NULL, 214874),
(214875, '4.10.280.110-FF-000011', NULL, 'Pre-mRNA splicing factor, putative', 72, NULL, NULL, 214875),
(214876, '3.30.470.10-FF-000014', NULL, 'Branched-chain amino acid aminotransferase', 156, NULL, NULL, 214876),
(214877, '3.30.559.10-FF-000057', NULL, 'Non-ribosomal peptide synthetase', 156, NULL, NULL, 214877),
(214878, '3.80.10.10-FF-002327', NULL, 'Antagonist of mitotic exit network protein 1', 125, NULL, NULL, 214878),
(214879, '3.20.20.80-FF-000390', NULL, 'Malto-oligosyltrehalose synthase', 115, NULL, NULL, 214879),
(214880, '2.60.40.10-FF-005822', NULL, NULL, 45, NULL, NULL, 214880),
(214881, '3.90.190.10-FF-000237', NULL, 'Protein-tyrosine phosphatase SHP-1', 191, NULL, NULL, 214881),
(214882, '2.30.29.30-FF-000256', NULL, 'Oxysterol-binding protein', 100, NULL, NULL, 214882),
(214883, '3.30.420.10-FF-000393', NULL, NULL, 69, NULL, NULL, 214883),
(214884, '3.30.40.10-FF-000908', NULL, 'Neuralized E3 ubiquitin protein ligase 1Ab', 60, NULL, NULL, 214884),
(214885, '1.20.5.170-FF-000158', NULL, 'BZIP transcription factor family', 61, NULL, NULL, 214885),
(214886, '1.25.40.10-FF-003450', NULL, 'Putative pentatricopeptide repeat-containing protein At1g13800', 135, NULL, NULL, 214886),
(214887, '3.30.70.330-FF-000779', NULL, 'Polyadenylate-binding protein', 93, NULL, NULL, 214887),
(214888, '1.20.1730.10-FF-000116', NULL, 'Uncharacterized protein', 91, NULL, NULL, 214888),
(214889, '3.30.60.270-FF-000006', NULL, 'Sortilin', 73, NULL, NULL, 214889),
(214890, '1.10.260.40-FF-000042', NULL, 'LacI family transcriptional regulator', 55, NULL, NULL, 214890);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(214891, '3.40.50.300-FF-005076', NULL, 'BMS1, ribosome biogenesis factor', 103, NULL, NULL, 214891),
(214892, '2.30.29.30-FF-000374', NULL, 'insulin receptor substrate 1-like', 114, NULL, NULL, 214892),
(214893, '3.30.1490.480-FF-000012', NULL, NULL, 75, NULL, NULL, 214893),
(214894, '2.60.40.770-FF-000026', NULL, 'Secreted protein, putative', 85, NULL, NULL, 214894),
(214895, '3.30.160.60-FF-005356', NULL, NULL, 60, NULL, NULL, 214895),
(214896, '2.60.40.10-FF-000016', NULL, 'Fibroblast growth factor receptor', 104, NULL, NULL, 214896),
(214897, '3.30.40.10-FF-000454', NULL, 'Histone-lysine N-methyltransferase', 62, NULL, NULL, 214897),
(214898, '3.60.20.10-FF-000069', NULL, 'Proteasome subunit beta 12', 201, NULL, NULL, 214898),
(214899, '3.30.70.330-FF-001504', NULL, 'Uncharacterized protein', 89, NULL, NULL, 214899),
(214900, '3.40.50.300-FF-005177', NULL, 'Cytidylate kinase', 220, NULL, NULL, 214900),
(214901, '3.60.40.10-FF-000071', NULL, 'Stage II sporulation protein E', 250, NULL, NULL, 214901),
(214902, '1.25.40.10-FF-004647', NULL, 'Predicted protein', 123, NULL, NULL, 214902),
(214903, '1.20.1250.20-FF-001015', NULL, 'Os01g0386600 protein', 52, NULL, NULL, 214903),
(214904, '2.60.120.10-FF-000423', NULL, 'Uncharacterized protein', 186, NULL, NULL, 214904),
(214905, '3.40.50.410-FF-000084', NULL, 'Transcription factor TFIIH subunit Tfb4, putative', 254, NULL, NULL, 214905),
(214906, '3.90.190.10-FF-000355', NULL, 'Protein-tyrosine phosphatase-like protein', 291, NULL, NULL, 214906),
(214907, '1.25.40.1030-FF-000050', NULL, 'Uncharacterized protein', 203, NULL, NULL, 214907),
(214908, '1.20.1070.10-FF-000425', NULL, 'Trissin receptor, isoform C', 272, NULL, NULL, 214908),
(214909, '1.10.10.60-FF-001175', NULL, NULL, 38, NULL, NULL, 214909),
(214910, '3.100.10.10-FF-000060', NULL, NULL, 70, NULL, NULL, 214910),
(214911, '3.40.50.10190-FF-000093', NULL, 'DNA-binding protein RAP1', 102, NULL, NULL, 214911),
(214912, '3.40.50.300-FF-007537', NULL, 'Uncharacterized protein', 300, NULL, NULL, 214912),
(214913, '1.10.287.130-FF-000248', NULL, 'Hybrid sensory kinase', 75, NULL, NULL, 214913),
(214914, '1.10.3380.10-FF-000035', NULL, 'YALI0F20724p', 137, NULL, NULL, 214914),
(214915, '1.10.150.110-FF-000035', NULL, 'Uncharacterized protein', 48, NULL, NULL, 214915),
(214916, '3.80.10.10-FF-000646', NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3', 111, NULL, NULL, 214916),
(214917, '3.30.300.30-FF-000126', NULL, '8-demethylnovobiocic acid synthase', 108, NULL, NULL, 214917),
(214918, '3.30.160.60-FF-002141', NULL, 'Zinc finger and SCAN domain-containing protein 22', 29, NULL, NULL, 214918),
(214919, '2.30.29.30-FF-000935', NULL, 'Rho GTPase-activating protein gacJJ', 111, NULL, NULL, 214919),
(214920, '3.30.160.20-FF-000246', NULL, 'RNA interference promoting factor', 97, NULL, NULL, 214920),
(214921, '1.20.1560.10-FF-000951', NULL, 'Uncharacterized protein', 84, NULL, NULL, 214921),
(214922, '4.10.240.10-FF-000082', NULL, 'Zn(II)2Cys6 transcription factor', 86, NULL, NULL, 214922),
(214923, '1.10.510.10-FF-003801', NULL, NULL, 124, NULL, NULL, 214923),
(214924, '3.40.50.150-FF-001517', NULL, NULL, 110, NULL, NULL, 214924),
(214925, '1.25.40.10-FF-001432', NULL, 'Si:ch211-166a6.5', 175, NULL, NULL, 214925),
(214926, '2.60.40.10-FF-001770', NULL, 'Uncharacterized protein, isoform B', 94, NULL, NULL, 214926),
(214927, '3.30.1490.190-FF-000015', NULL, 'Transcriptional regulator PerR', 57, NULL, NULL, 214927),
(214928, '3.40.309.10-FF-000065', NULL, 'Aldehyde dehydrogenase3', 190, NULL, NULL, 214928),
(214929, '1.25.40.20-FF-001435', NULL, 'Uncharacterized protein', 259, NULL, NULL, 214929),
(214930, '1.20.1560.10-FF-000058', NULL, 'ABC transporter B family member 25', 271, NULL, NULL, 214930),
(214931, '3.30.40.10-FF-001061', NULL, 'E3 ubiquitin-protein ligase CCNP1IP1', 84, NULL, NULL, 214931),
(214932, '1.25.40.10-FF-003118', NULL, 'Pentatricopeptide repeat-containing protein', 101, NULL, NULL, 214932),
(214933, '1.10.238.10-FF-001055', NULL, 'Uncharacterized protein', 90, NULL, NULL, 214933);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(214934, '3.40.20.10-FF-000126', NULL, 'Uncharacterized protein', 148, NULL, NULL, 214934),
(214935, '2.60.40.60-FF-001077', NULL, 'Uncharacterized protein', 134, NULL, NULL, 214935),
(214936, '2.10.25.10-FF-000192', NULL, 'FAT atypical cadherin 3', 36, NULL, NULL, 214936),
(214937, '1.20.1440.200-FF-000010', NULL, 'Vacuolar protein sorting-associated protein 28', 77, NULL, NULL, 214937),
(214938, '3.80.10.10-FF-004356', NULL, 'Si:ch73-286h23.4', 178, NULL, NULL, 214938),
(214939, '3.30.450.20-FF-000465', NULL, 'Neuronal PAS domain protein 4', 106, NULL, NULL, 214939),
(214940, '3.30.930.10-FF-000151', NULL, 'Lysine--tRNA ligase', 344, NULL, NULL, 214940),
(214941, '3.40.50.300-FF-003485', NULL, 'DNA helicase MCM9 isoform 2', 111, NULL, NULL, 214941),
(214942, '3.40.50.2300-FF-000627', NULL, 'GLutamate Receptor family (AMPA)', 180, NULL, NULL, 214942),
(214943, '3.30.1490.180-FF-000012', NULL, 'DNA-directed RNA polymerase subunit', 77, NULL, NULL, 214943),
(214944, '3.40.50.800-FF-000116', NULL, 'Prolyl Amino-acyl tRNA Synthetase', 82, NULL, NULL, 214944),
(214945, '3.30.70.1230-FF-000016', NULL, 'Adenylate/guanylate cyclase domain-containing protein', 202, NULL, NULL, 214945),
(214946, '1.25.40.20-FF-001862', NULL, 'Predicted protein', 131, NULL, NULL, 214946),
(214947, '2.130.10.10-FF-003552', NULL, 'Uncharacterized protein', 206, NULL, NULL, 214947),
(214948, '2.60.40.10-FF-002967', NULL, 'Protein tyrosine phosphatase receptor type Ja', 85, NULL, NULL, 214948),
(214949, '3.40.50.150-FF-001731', NULL, NULL, 138, NULL, NULL, 214949),
(214950, '3.30.70.141-FF-000027', NULL, 'GG17026', 143, NULL, NULL, 214950),
(214951, '3.30.710.10-FF-000409', NULL, 'Uncharacterized protein', 75, NULL, NULL, 214951),
(214952, '1.10.357.140-FF-000009', NULL, 'homogentisate solanesyltransferase, chloroplastic', 155, NULL, NULL, 214952),
(214953, '1.25.40.10-FF-000595', NULL, 'Serine/threonine-protein phosphatase', 151, NULL, NULL, 214953),
(214954, '2.60.40.10-FF-001219', NULL, 'tyrosine-protein phosphatase Lar isoform X1', 107, NULL, NULL, 214954),
(214955, '2.60.120.260-FF-000528', NULL, 'Uncharacterized protein', 141, NULL, NULL, 214955),
(214956, '3.40.50.300-FF-007330', NULL, 'Protein CBR-WHT-1', 143, NULL, NULL, 214956),
(214957, '3.90.870.10-FF-000025', NULL, '3,4-dihydroxy-2-butanone 4-phosphate synthase', 213, NULL, NULL, 214957),
(214958, '4.10.400.10-FF-000302', NULL, 'Megalin, isoform A', 36, NULL, NULL, 214958),
(214959, '2.60.200.40-FF-000028', NULL, 'Diacylglycerol kinase', 170, NULL, NULL, 214959),
(214960, '2.170.150.40-FF-000003', NULL, 'DUF427 domain-containing protein', 106, NULL, NULL, 214960),
(214961, '3.50.50.60-FF-001261', NULL, 'Flavin-containing monooxygenase', 103, NULL, NULL, 214961),
(214962, '1.20.920.10-FF-000020', NULL, 'Transcription initiation factor TFIID subunit', 134, NULL, NULL, 214962),
(214963, '1.10.555.10-FF-000116', NULL, 'EG:86E4.5 protein', 162, NULL, NULL, 214963),
(214964, '1.25.40.720-FF-000016', NULL, 'YALI0D22979p', 86, NULL, NULL, 214964),
(214965, '1.25.10.10-FF-003381', NULL, 'Uncharacterized protein', 374, NULL, NULL, 214965),
(214966, '1.20.58.60-FF-000582', NULL, 'SEC14 domain and spectrin repeat-containing protein 1-like Protein', 221, NULL, NULL, 214966),
(214967, '3.40.50.970-FF-000139', NULL, 'Pyruvate oxidase', 192, NULL, NULL, 214967),
(214968, '3.40.1170.60-FF-000008', NULL, 'DNA polymerase eta subunit', 95, NULL, NULL, 214968),
(214969, '1.10.510.10-FF-003560', NULL, NULL, 224, NULL, NULL, 214969),
(214970, '1.25.40.10-FF-003219', NULL, 'Uncharacterized protein', 68, NULL, NULL, 214970),
(214971, '1.25.40.10-FF-001319', NULL, 'Pentatricopeptide repeat-containing protein', 147, NULL, NULL, 214971),
(214972, '3.90.640.10-FF-000216', NULL, 'Uncharacterized protein', 83, NULL, NULL, 214972),
(214973, '1.20.58.1220-FF-000005', NULL, 'Os07g0568000 protein', 105, NULL, NULL, 214973),
(214974, '1.25.40.180-FF-000253', NULL, NULL, 67, NULL, NULL, 214974),
(214975, '3.30.300.30-FF-000137', NULL, 'Uncharacterized protein', 97, NULL, NULL, 214975),
(214976, '3.20.20.80-FF-000412', NULL, 'Uncharacterized protein', 352, NULL, NULL, 214976);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(214977, '3.30.1490.70-FF-000010', NULL, 'Ligase III, DNA, ATP-dependent', 33, NULL, NULL, 214977),
(214978, '1.10.8.10-FF-000041', NULL, 'ubiquitin-like protein 7', 46, NULL, NULL, 214978),
(214979, '3.60.10.10-FF-000243', NULL, 'Endonuclease/exonuclease/phosphatase family protein', 293, NULL, NULL, 214979),
(214980, '1.20.1560.10-FF-000619', NULL, 'Uncharacterized protein', 402, NULL, NULL, 214980),
(214981, '3.30.1490.80-FF-000013', NULL, 'Glutathione synthetase', 76, NULL, NULL, 214981),
(214982, '2.30.30.140-FF-000151', NULL, 'Tapas, isoform B', 73, NULL, NULL, 214982),
(214983, '1.20.58.1210-FF-000002', NULL, 'Exocyst complex component EXO84B', 124, NULL, NULL, 214983),
(214984, '1.10.565.10-FF-000044', NULL, 'Ecdysone-induced protein 78C, isoform D', 267, NULL, NULL, 214984),
(214985, '2.60.120.200-FF-000308', NULL, 'protein eyes shut', 218, NULL, NULL, 214985),
(214986, '3.40.190.10-FF-000951', NULL, 'Bifunctional periplasmic substrate binding protein/cytoplasmic diguanylate cyclase', 123, NULL, NULL, 214986),
(214987, '3.40.710.10-FF-000115', NULL, 'Penicillin-binding protein 2B', 369, NULL, NULL, 214987),
(214988, '2.60.120.200-FF-000196', NULL, 'SP2353, isoform A', 175, NULL, NULL, 214988),
(214989, '3.40.640.10-FF-000475', NULL, 'Uncharacterized protein', 89, NULL, NULL, 214989),
(214990, '3.30.56.50-FF-000002', NULL, 'Translation initiation factor IF-2', 49, NULL, NULL, 214990),
(214991, '2.60.120.470-FF-000001', NULL, 'Thioredoxin-like 1, isoform CRA_c', 169, NULL, NULL, 214991),
(214992, '1.20.5.1930-FF-000004', NULL, 'Sensor histidine kinase', 67, NULL, NULL, 214992),
(214993, '1.10.1040.10-FF-000077', NULL, 'AGAP012912-PA', 61, NULL, NULL, 214993),
(214994, '3.50.50.60-FF-001502', NULL, 'Uncharacterized protein', 28, NULL, NULL, 214994),
(214995, '3.40.1090.10-FF-000089', NULL, 'Uncharacterized protein', 211, NULL, NULL, 214995),
(214996, '1.20.1070.10-FF-000324', NULL, 'Uncharacterized protein', 291, NULL, NULL, 214996),
(214997, '1.10.10.160-FF-000009', NULL, 'ATP-dependent DNA helicase UvrD', 65, NULL, NULL, 214997),
(214998, '1.10.510.10-FF-001660', NULL, 'Predicted protein', 182, NULL, NULL, 214998),
(214999, '3.20.20.140-FF-000153', NULL, 'Uncharacterized protein MJ1295', 213, NULL, NULL, 214999),
(215000, '3.30.60.30-FF-000202', NULL, 'Uncharacterized protein', 56, NULL, NULL, 215000),
(215001, '3.40.50.620-FF-000484', NULL, 'Os03g0335600 protein', 113, NULL, NULL, 215001),
(215002, '3.30.200.20-FF-000756', NULL, 'Serine/threonine/tyrosine protein kinase', 100, NULL, NULL, 215002),
(215003, '1.10.287.2620-FF-000013', NULL, 'Putative dynein heavy chain', 64, NULL, NULL, 215003),
(215004, '3.30.70.330-FF-000987', NULL, 'Uncharacterized protein', 93, NULL, NULL, 215004),
(215005, '1.10.287.70-FF-000516', NULL, 'Predicted protein', 151, NULL, NULL, 215005),
(215006, '2.30.29.30-FF-000694', NULL, 'Vacuolar protein sorting-associated protein 13C', 106, NULL, NULL, 215006),
(215007, '3.30.710.10-FF-000056', NULL, 'BTB/POZ domain-containing protein 7', 121, NULL, NULL, 215007),
(215008, '3.30.200.20-FF-001032', NULL, 'Sks1p', 82, NULL, NULL, 215008),
(215009, '3.40.50.300-FF-004103', NULL, 'Zinc finger NFX1-type containing homolog', 325, NULL, NULL, 215009),
(215010, '1.10.10.10-FF-001851', NULL, 'Uncharacterized protein', 121, NULL, NULL, 215010),
(215011, '3.40.50.300-FF-007329', NULL, 'Uncharacterized protein', 143, NULL, NULL, 215011),
(215012, '1.10.287.410-FF-000012', NULL, 'Carboxypeptidase', 74, NULL, NULL, 215012),
(215013, '3.10.350.10-FF-000072', NULL, 'Peptidoglycan-binding LysM domain-containing protein', 67, NULL, NULL, 215013),
(215014, '3.40.50.1110-FF-000130', NULL, 'Uncharacterized protein', 229, NULL, NULL, 215014),
(215015, '1.10.8.60-FF-000140', NULL, 'AAA family ATPase, CDC48 subfamily', 101, NULL, NULL, 215015),
(215016, '1.10.1870.10-FF-000005', NULL, 'Chimeric spermidine synthase/saccharopine dehydrogenase', 100, NULL, NULL, 215016),
(215017, '2.60.120.480-FF-000004', NULL, 'Allantoicase, putative', 197, NULL, NULL, 215017),
(215018, '3.20.20.70-FF-000055', NULL, 'Ethanolamine ammonia-lyase heavy chain', 312, NULL, NULL, 215018);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(215019, '1.25.40.710-FF-000013', NULL, 'Uncharacterized protein', 234, NULL, NULL, 215019),
(215020, '1.20.58.340-FF-000001', NULL, 'Magnesium transport protein CorA', 77, NULL, NULL, 215020),
(215021, '3.40.250.10-FF-000208', NULL, 'Predicted protein', 79, NULL, NULL, 215021),
(215022, '2.160.20.80-FF-000014', NULL, NULL, 119, NULL, NULL, 215022),
(215023, '2.60.40.10-FF-001332', NULL, 'PKHD1 like 1', 91, NULL, NULL, 215023),
(215024, '3.80.10.10-FF-001130', NULL, 'Os04g0132500 protein', 205, NULL, NULL, 215024),
(215025, '2.130.10.10-FF-001629', NULL, 'WD-40 repeat protein', 205, NULL, NULL, 215025),
(215026, '3.40.50.720-FF-002436', NULL, 'Uncharacterized protein', 180, NULL, NULL, 215026),
(215027, '1.10.10.10-FF-001519', NULL, 'Probable serine/threonine-protein kinase roco4', 103, NULL, NULL, 215027),
(215028, '3.40.50.300-FF-007431', NULL, 'Uncharacterized protein', 259, NULL, NULL, 215028),
(215029, '2.30.30.100-FF-000055', NULL, 'Probable small nuclear ribonucleoprotein F', 77, NULL, NULL, 215029),
(215030, '2.60.40.10-FF-005923', NULL, NULL, 108, NULL, NULL, 215030),
(215031, '2.130.10.10-FF-003760', NULL, 'Uncharacterized protein', 324, NULL, NULL, 215031),
(215032, '2.60.40.10-FF-004985', NULL, NULL, 108, NULL, NULL, 215032),
(215033, '3.20.20.80-FF-000058', NULL, 'Alpha-amylase 1', 343, NULL, NULL, 215033),
(215034, '2.60.120.10-FF-000322', NULL, 'Cyclic nucleotide-binding domain containing protein, putative', 151, NULL, NULL, 215034),
(215035, '1.10.3520.10-FF-000024', NULL, 'Uncharacterized protein', 225, NULL, NULL, 215035),
(215036, '2.60.40.10-FF-003462', NULL, NULL, 101, NULL, NULL, 215036),
(215037, '4.10.280.10-FF-000202', NULL, 'Transcription factor hes-1, putative', 70, NULL, NULL, 215037),
(215038, '3.50.50.60-FF-001160', NULL, 'Uncharacterized protein', 45, NULL, NULL, 215038),
(215039, '2.60.40.10-FF-005581', NULL, NULL, 100, NULL, NULL, 215039),
(215040, '1.20.58.1610-FF-000026', NULL, NULL, 120, NULL, NULL, 215040),
(215041, '1.20.1250.20-FF-000852', NULL, 'Predicted arabinose efflux permease, MFS family', 182, NULL, NULL, 215041),
(215042, '3.40.50.12660-FF-000002', NULL, 'Metacaspase 1', 338, NULL, NULL, 215042),
(215043, '3.40.50.20-FF-000070', NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', 113, NULL, NULL, 215043),
(215044, '3.30.465.10-FF-000047', NULL, 'Conserved protein', 114, NULL, NULL, 215044),
(215045, '1.25.10.10-FF-003049', NULL, 'Uncharacterized protein', 563, NULL, NULL, 215045),
(215046, '1.10.10.1320-FF-000009', NULL, 'Putative transmembrane anti-sigma factor', 54, NULL, NULL, 215046),
(215047, '3.20.10.10-FF-000025', NULL, 'Branched-chain amino acid aminotransferase, putative', 162, NULL, NULL, 215047),
(215048, '1.20.5.1940-FF-000007', NULL, 'Vacuolar protein sorting-associated protein 27', 90, NULL, NULL, 215048),
(215049, '3.30.160.60-FF-003226', NULL, 'Zinc finger protein', 32, NULL, NULL, 215049),
(215050, '2.60.40.10-FF-005261', NULL, NULL, 87, NULL, NULL, 215050),
(215051, '2.60.40.60-FF-000003', NULL, 'Protocadherin alpha 2', 105, NULL, NULL, 215051),
(215052, '2.60.120.200-FF-000538', NULL, 'Galectin', 136, NULL, NULL, 215052),
(215053, '3.40.50.410-FF-000325', NULL, 'Integrin beta', 197, NULL, NULL, 215053),
(215054, '3.30.160.60-FF-003664', NULL, 'Broad complex isoform Z4', 55, NULL, NULL, 215054),
(215055, '3.40.50.12670-FF-000005', NULL, 'Carboxypeptidase', 154, NULL, NULL, 215055),
(215056, '2.30.30.190-FF-000020', NULL, 'Cylindromatosis, isoform D', 100, NULL, NULL, 215056),
(215057, '3.40.718.10-FF-000026', NULL, '3-isopropylmalate dehydrogenase', 336, NULL, NULL, 215057),
(215058, '1.25.40.10-FF-002955', NULL, 'Os09g0573000 protein', 150, NULL, NULL, 215058),
(215059, '3.30.710.10-FF-000286', NULL, 'CG12236', 161, NULL, NULL, 215059),
(215060, '3.90.228.10-FF-000022', NULL, 'Poly [ADP-ribose] polymerase', 152, NULL, NULL, 215060),
(215061, '3.30.40.10-FF-002146', NULL, 'Predicted protein', 62, NULL, NULL, 215061),
(215062, '1.10.510.10-FF-001547', NULL, 'NIMA-related kinase 10', 224, NULL, NULL, 215062),
(215063, '3.30.559.10-FF-000265', NULL, 'Pelargonidin 3-O-(6-caffeoylglucoside) 5-O-(6-O-malonylglucoside) 4''''''-malonyltransferase', 212, NULL, NULL, 215063);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(215064, '3.30.1920.20-FF-000001', NULL, 'ExeM/NucH family extracellular endonuclease', 71, NULL, NULL, 215064),
(215065, '1.25.40.10-FF-005361', NULL, 'Uncharacterized protein', 73, NULL, NULL, 215065),
(215066, '1.25.10.10-FF-001481', NULL, 'RING-type E3 ubiquitin transferase', 83, NULL, NULL, 215066),
(215067, '4.10.1060.10-FF-000008', NULL, 'TATA-binding protein-associated factor 2N isoform X1', 35, NULL, NULL, 215067),
(215068, '3.80.10.10-FF-002900', NULL, 'Protein CBG18939', 152, NULL, NULL, 215068),
(215069, '3.40.50.300-FF-003277', NULL, 'Molybdopterin guanine dinucleotide synthesis protein B, putative', 190, NULL, NULL, 215069),
(215070, '1.10.238.10-FF-001285', NULL, 'Nuclear receptor coactivator 5', 44, NULL, NULL, 215070),
(215071, '3.40.50.1110-FF-000017', NULL, 'Protein CBG05119', 304, NULL, NULL, 215071),
(215072, '3.40.50.1100-FF-000014', NULL, 'Threonine synthase', 217, NULL, NULL, 215072),
(215073, '1.20.1280.50-FF-000121', NULL, 'Putative scf ubiquitin ligase skp2 component', 45, NULL, NULL, 215073),
(215074, '2.20.100.10-FF-000061', NULL, 'adhesion G protein-coupled receptor B1', 55, NULL, NULL, 215074),
(215075, '3.50.50.60-FF-000884', NULL, 'Uncharacterized protein', 353, NULL, NULL, 215075),
(215076, '1.10.472.80-FF-000006', NULL, 'TBC1 domain family member 14', 146, NULL, NULL, 215076),
(215077, '3.40.50.11950-FF-000008', NULL, 'Uncharacterized protein', 77, NULL, NULL, 215077),
(215078, '3.30.230.10-FF-000249', NULL, 'Uncharacterized protein', 102, NULL, NULL, 215078),
(215079, '3.30.160.60-FF-000230', NULL, 'Zinc finger protein 148', 29, NULL, NULL, 215079),
(215080, '3.30.70.330-FF-000903', NULL, 'La protein homolog', 109, NULL, NULL, 215080),
(215081, '1.20.1110.10-FF-000024', NULL, 'Plasma membrane ATPase', 288, NULL, NULL, 215081),
(215082, '3.40.50.300-FF-001147', NULL, 'multidrug resistance-associated protein 6 isoform X1', 246, NULL, NULL, 215082),
(215083, '3.60.110.10-FF-000060', NULL, NULL, 238, NULL, NULL, 215083),
(215084, '3.30.160.20-FF-000145', NULL, 'Class I peptide chain release factor', 48, NULL, NULL, 215084),
(215085, '3.30.160.60-FF-004979', NULL, NULL, 27, NULL, NULL, 215085),
(215086, '2.60.40.10-FF-001539', NULL, 'Immunoglobulin superfamily member 22', 97, NULL, NULL, 215086),
(215087, '3.30.160.60-FF-001326', NULL, 'Zinc finger protein 432', 28, NULL, NULL, 215087),
(215088, '3.60.40.10-FF-000312', NULL, 'Uncharacterized protein', 235, NULL, NULL, 215088),
(215089, '3.40.910.10-FF-000001', NULL, 'Probable deoxyhypusine synthase', 338, NULL, NULL, 215089),
(215090, '3.40.50.2300-FF-000638', NULL, 'Clumsy, isoform B', 211, NULL, NULL, 215090),
(215091, '3.10.250.10-FF-000114', NULL, NULL, 77, NULL, NULL, 215091),
(215092, '1.20.5.5270-FF-000006', NULL, 'Lon protease homolog, mitochondrial', 46, NULL, NULL, 215092),
(215093, '3.40.1800.20-FF-000001', NULL, 'zinc finger protein 836', 73, NULL, NULL, 215093),
(215094, '3.80.10.10-FF-002445', NULL, 'Paraflagellar rod component, putative', 110, NULL, NULL, 215094),
(215095, '3.40.50.150-FF-001276', NULL, NULL, 225, NULL, NULL, 215095),
(215096, '3.30.160.60-FF-005255', NULL, NULL, 19, NULL, NULL, 215096),
(215097, '2.30.42.10-FF-000449', NULL, NULL, 118, NULL, NULL, 215097),
(215098, '1.20.1250.20-FF-000291', NULL, 'Solute carrier family 16 member 5', 194, NULL, NULL, 215098),
(215099, '1.20.120.1240-FF-000053', NULL, 'Dynamin GTPase, putative (AFU_orthologue AFUA_7G08580)', 290, NULL, NULL, 215099),
(215100, '1.25.10.10-FF-001043', NULL, 'Protein phosphatase 2A regulatory subunit,putative', 579, NULL, NULL, 215100),
(215101, '3.40.50.300-FF-003940', NULL, 'Ras family gtpase', 177, NULL, NULL, 215101),
(215102, '3.40.850.10-FF-000496', NULL, 'Kinesin-like protein KIN-7N', 50, NULL, NULL, 215102),
(215103, '3.40.1170.10-FF-000022', NULL, 'Mismatch repair ATPase', 122, NULL, NULL, 215103),
(215104, '3.40.190.10-FF-000496', NULL, 'NMDA class glutamate Receptor', 185, NULL, NULL, 215104),
(215105, '3.30.1490.180-FF-000023', NULL, 'DNA-directed RNA polymerase subunit', 66, NULL, NULL, 215105),
(215106, '3.40.50.1820-FF-000573', NULL, 'Carboxypeptidase', 276, NULL, NULL, 215106);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(215107, '1.50.40.10-FF-000047', NULL, 'peroxisomal membrane protein PMP34 isoform X2', 292, NULL, NULL, 215107),
(215108, '1.20.1260.60-FF-000016', NULL, 'Uncharacterized protein', 79, NULL, NULL, 215108),
(215109, '3.40.50.1260-FF-000034', NULL, 'Phosphoglycerate kinase', 30, NULL, NULL, 215109),
(215110, '1.10.1380.10-FF-000018', NULL, 'GD18423', 349, NULL, NULL, 215110),
(215111, '3.40.1440.10-FF-000015', NULL, 'Structure-specific endonuclease subunit SLX1', 106, NULL, NULL, 215111),
(215112, '3.40.50.2000-FF-000543', NULL, 'Alpha,alpha-trehalose-phosphate synthase', 247, NULL, NULL, 215112),
(215113, '1.25.40.90-FF-000124', NULL, 'Kinesin-like protein', 147, NULL, NULL, 215113),
(215114, '3.90.850.10-FF-000030', NULL, '2-dehydro-3-deoxy-D-arabinonate dehydratase', 223, NULL, NULL, 215114),
(215115, '3.80.10.10-FF-004345', NULL, 'Uncharacterized protein', 188, NULL, NULL, 215115),
(215116, '3.40.50.150-FF-001618', NULL, NULL, 248, NULL, NULL, 215116),
(215117, '3.30.260.10-FF-000077', NULL, NULL, 91, NULL, NULL, 215117),
(215118, '2.70.160.11-FF-000037', NULL, 'Protein arginine N-methyltransferase 7', 170, NULL, NULL, 215118),
(215119, '3.40.30.10-FF-000065', NULL, 'SH3 domain-binding glutamic acid-rich-like protein', 114, NULL, NULL, 215119),
(215120, '1.25.10.10-FF-000767', NULL, 'Mitotic spindle protein STU1', 268, NULL, NULL, 215120),
(215121, '1.20.1560.10-FF-000850', NULL, 'Predicted protein', 304, NULL, NULL, 215121),
(215122, '3.30.200.20-FF-000767', NULL, 'Serine/threonine-protein kinase CBK1', 63, NULL, NULL, 215122),
(215123, '1.10.8.1220-FF-000002', NULL, 'cytoplasmic dynein 1 heavy chain 1-like', 95, NULL, NULL, 215123),
(215124, '1.25.40.10-FF-001421', NULL, 'LRP2-binding protein', 300, NULL, NULL, 215124),
(215125, '3.30.1490.190-FF-000026', NULL, 'Probable transcription regulator FurR family', 63, NULL, NULL, 215125),
(215126, '3.30.1120.30-FF-000027', NULL, 'Serine/threonine-protein kinase PLK', 58, NULL, NULL, 215126),
(215127, '1.20.5.2650-FF-000001', NULL, '40S ribosomal protein S6', 109, NULL, NULL, 215127),
(215128, '3.10.580.20-FF-000007', NULL, 'Chloride channel protein', 80, NULL, NULL, 215128),
(215129, '3.90.45.10-FF-000029', NULL, 'Peptide deformylase', 89, NULL, NULL, 215129),
(215130, '2.20.25.690-FF-000004', NULL, 'Chromosome 1, whole genome shotgun sequence', 73, NULL, NULL, 215130),
(215131, '2.130.10.10-FF-003097', NULL, 'WD repeat-containing protein 1', 12, NULL, NULL, 215131),
(215132, '1.20.1250.20-FF-001948', NULL, 'Uncharacterized protein', 443, NULL, NULL, 215132),
(215133, '1.25.40.10-FF-004855', NULL, 'Splicing factor, component of the U4/U6-U5 snRNP complex', 130, NULL, NULL, 215133),
(215134, '1.20.1250.20-FF-000189', NULL, 'thiamine transporter 1 isoform X1', 392, NULL, NULL, 215134),
(215135, '3.20.20.60-FF-000052', NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', 262, NULL, NULL, 215135),
(215136, '3.40.50.300-FF-005531', NULL, 'Sulfotransferase', 83, NULL, NULL, 215136),
(215137, '1.10.1520.10-FF-000007', NULL, 'Endoribonuclease dicer-like protein', 194, NULL, NULL, 215137),
(215138, '1.20.5.170-FF-000271', NULL, 'Uncharacterized protein', 113, NULL, NULL, 215138),
(215139, '3.40.50.2300-FF-001133', NULL, NULL, 98, NULL, NULL, 215139),
(215140, '2.20.25.680-FF-000001', NULL, 'Terminal oxygenase component of carbazole', 58, NULL, NULL, 215140),
(215141, '3.40.50.360-FF-000153', NULL, '8-demethyl-8-aminoriboflavin-5''-phosphate synthase', 216, NULL, NULL, 215141),
(215142, '3.30.70.330-FF-002680', NULL, NULL, 84, NULL, NULL, 215142),
(215143, '3.30.200.20-FF-001262', NULL, 'Uncharacterized protein', 105, NULL, NULL, 215143),
(215144, '3.10.580.10-FF-000004', NULL, 'Protein kinase AMP-activated non-catalytic subunit gamma 2', 165, NULL, NULL, 215144),
(215145, '3.40.50.720-FF-000536', NULL, 'Sorbitol dehydrogenase', 256, NULL, NULL, 215145),
(215146, '1.25.40.10-FF-005131', NULL, 'Uncharacterized protein', 284, NULL, NULL, 215146),
(215147, '3.30.70.330-FF-002578', NULL, NULL, 186, NULL, NULL, 215147),
(215148, '1.25.40.860-FF-000030', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 117, NULL, NULL, 215148);
INSERT INTO "PUBLIC"."MODEL" VALUES
(215149, '3.40.50.300-FF-001686', NULL, 'KRAS proto-oncogene, GTPase', 43, NULL, NULL, 215149),
(215150, '3.30.40.10-FF-000555', NULL, 'Zinc finger (Ubiquitin-hydrolase) domain-containing protein', 106, NULL, NULL, 215150),
(215151, '3.90.1150.10-FF-000184', NULL, 'Uncharacterized protein', 91, NULL, NULL, 215151),
(215152, '1.20.58.390-FF-000100', NULL, 'Predicted protein', 117, NULL, NULL, 215152),
(215153, '3.30.70.260-FF-000051', NULL, 'Methionine import ATP-binding protein MetN', 104, NULL, NULL, 215153),
(215154, '3.80.10.10-FF-000416', NULL, 'Probable leucine-rich repeat receptor-like protein kinase At5g63930', 101, NULL, NULL, 215154),
(215155, '3.30.1120.10-FF-000021', NULL, 'Iduronate-sulfatase or arylsulfatase A', 96, NULL, NULL, 215155),
(215156, '1.20.920.50-FF-000003', NULL, 'Allergen dI chain C2D', 99, NULL, NULL, 215156),
(215157, '2.40.50.140-FF-000872', NULL, NULL, 84, NULL, NULL, 215157),
(215158, '3.40.190.10-FF-000838', NULL, 'Predicted protein', 113, NULL, NULL, 215158),
(215159, '1.25.40.20-FF-000007', NULL, 'Phosphatase 1 regulatory subunit 12A', 161, NULL, NULL, 215159),
(215160, '1.25.10.10-FF-001604', NULL, 'Putative countin receptor Cnr17', 1094, NULL, NULL, 215160),
(215161, '3.40.50.1470-FF-000007', NULL, 'Peptidyl-tRNA hydrolase 1 homolog', 132, NULL, NULL, 215161),
(215162, '3.20.20.80-FF-000619', NULL, 'Arabinogalactan endo-beta-1,4-galactanase', 144, NULL, NULL, 215162),
(215163, '3.90.1230.10-FF-000004', NULL, NULL, 45, NULL, NULL, 215163),
(215164, '3.30.70.330-FF-001263', NULL, 'Nucleic acid binding', 109, NULL, NULL, 215164),
(215165, '1.10.510.10-FF-003228', NULL, NULL, 127, NULL, NULL, 215165),
(215166, '3.40.33.10-FF-000004', NULL, 'CAP, cysteine-rich secretory protein, antigen 5', 138, NULL, NULL, 215166),
(215167, '4.10.520.10-FF-000025', NULL, NULL, 91, NULL, NULL, 215167),
(215168, '1.10.8.50-FF-000024', NULL, 'Formamidopyrimidine-DNA glycosylase', 138, NULL, NULL, 215168),
(215169, '1.20.920.60-FF-000006', NULL, 'Uncharacterized protein', 184, NULL, NULL, 215169),
(215170, '2.130.10.10-FF-001422', NULL, 'Putative rna polymerase ii elongator complex subunit elp2 wd repeat superfamily', 152, NULL, NULL, 215170),
(215171, '3.40.1390.30-FF-000022', NULL, 'Uncharacterized protein', 123, NULL, NULL, 215171),
(215172, '1.10.8.60-FF-000027', NULL, 'ATP-dependent protease ATPase subunit HslU', 106, NULL, NULL, 215172),
(215173, '1.20.920.10-FF-000227', NULL, 'AT Hook plus PHD finger transcription factor', 145, NULL, NULL, 215173),
(215174, '3.40.50.1450-FF-000001', NULL, 'Hydrogenase 2 maturation endopeptidase', 161, NULL, NULL, 215174),
(215175, '3.30.420.10-FF-000516', NULL, NULL, 124, NULL, NULL, 215175),
(215176, '3.30.1740.10-FF-000012', NULL, 'Poly(ADP-ribose) polymerase and DNA-Ligase Zn-finger region/Zinc-finger (CX5CX6HX5H) motif containing protein, putative', 101, NULL, NULL, 215176),
(215177, '2.60.120.290-FF-000060', NULL, 'Cubilin homolog', 116, NULL, NULL, 215177),
(215178, '3.40.20.10-FF-000137', NULL, 'Protein tyrosine kinase, putative', 147, NULL, NULL, 215178),
(215179, '3.20.20.100-FF-000057', NULL, 'Uncharacterized protein', 298, NULL, NULL, 215179),
(215180, '3.10.20.90-FF-000022', NULL, 'Small ubiquitin-related modifier', 93, NULL, NULL, 215180),
(215181, '3.40.50.410-FF-000106', NULL, 'Nitric oxide reductase D protein', 183, NULL, NULL, 215181),
(215182, '3.40.50.1460-FF-000004', NULL, 'Mucosa-associated lymphoid tissue lymphoma translocation protein 1', 244, NULL, NULL, 215182),
(215183, '1.20.990.10-FF-000052', NULL, 'Uncharacterized protein', 70, NULL, NULL, 215183),
(215184, '3.30.50.10-FF-000174', NULL, 'Uncharacterized protein', 70, NULL, NULL, 215184),
(215185, '3.40.630.30-FF-000053', NULL, 'Histone acetyltransferase', 134, NULL, NULL, 215185),
(215186, '3.10.20.230-FF-000019', NULL, 'Doublecortin domain-containing protein 1', 82, NULL, NULL, 215186),
(215187, '2.60.40.2030-FF-000059', NULL, 'Na+/Ca2+ exchanger NCX1 isoform', 83, NULL, NULL, 215187),
(215188, '2.20.25.10-FF-000005', NULL, 'DNA-directed RNA polymerase subunit', 53, NULL, NULL, 215188);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(215189, '2.130.10.10-FF-001074', NULL, 'Probable SOF1 protein', 97, NULL, NULL, 215189),
(215190, '1.20.900.10-FF-000131', NULL, 'Uncharacterized protein', 50, NULL, NULL, 215190),
(215191, '1.10.10.10-FF-001306', NULL, 'LysR family transcriptional regulator', 80, NULL, NULL, 215191),
(215192, '3.30.160.60-FF-005923', NULL, NULL, 23, NULL, NULL, 215192),
(215193, '1.10.8.10-FF-000147', NULL, 'Nuclear RNA export factor 2', 53, NULL, NULL, 215193),
(215194, '2.20.25.20-FF-000008', NULL, 'E3 ubiquitin-protein ligase parkin', 55, NULL, NULL, 215194),
(215195, '1.10.530.10-FF-000014', NULL, 'Alpha-lactalbumin', 123, NULL, NULL, 215195),
(215196, '1.10.10.60-FF-001170', NULL, NULL, 45, NULL, NULL, 215196),
(215197, '3.30.710.10-FF-000174', NULL, 'BTB/POZ and TAZ domain-containing protein 2', 111, NULL, NULL, 215197),
(215198, '1.25.40.180-FF-000141', NULL, 'AGAP002502-PA', 188, NULL, NULL, 215198),
(215199, '2.10.25.10-FF-000197', NULL, 'latent-transforming growth factor beta-binding protein 4 isoform X1', 41, NULL, NULL, 215199),
(215200, '1.10.575.10-FF-000005', NULL, 'Putative p1/s1 nuclease', 298, NULL, NULL, 215200),
(215201, '1.20.920.10-FF-000126', NULL, 'YALI0D20702p', 110, NULL, NULL, 215201),
(215202, '3.30.420.10-FF-000415', NULL, NULL, 174, NULL, NULL, 215202),
(215203, '3.40.50.300-FF-003620', NULL, 'Regulator of nonsense transcripts putative', 342, NULL, NULL, 215203),
(215204, '1.20.1560.10-FF-000395', NULL, 'Multidrug resistance protein, putative', 350, NULL, NULL, 215204),
(215205, '3.40.50.720-FF-001031', NULL, 'Uncharacterized protein', 131, NULL, NULL, 215205),
(215206, '1.25.10.10-FF-001363', NULL, 'Uncharacterized protein', 206, NULL, NULL, 215206),
(215207, '1.20.900.10-FF-000119', NULL, 'Uncharacterized protein', 204, NULL, NULL, 215207),
(215208, '1.20.58.60-FF-000694', NULL, 'Uncharacterized protein', 292, NULL, NULL, 215208),
(215209, '3.80.10.10-FF-000641', NULL, 'NLR family CARD domain containing 5', 176, NULL, NULL, 215209),
(215210, '3.40.50.300-FF-005744', NULL, 'Uncharacterized protein', 145, NULL, NULL, 215210),
(215211, '3.90.370.10-FF-000010', NULL, 'Predicted protein', 83, NULL, NULL, 215211),
(215212, '3.30.70.330-FF-000448', NULL, 'Negative elongation factor E', 86, NULL, NULL, 215212),
(215213, '1.25.40.10-FF-005136', NULL, 'Uncharacterized protein', 101, NULL, NULL, 215213),
(215214, '3.30.160.60-FF-001652', NULL, 'Zinc finger protein 772', 30, NULL, NULL, 215214),
(215215, '3.30.1490.120-FF-000022', NULL, 'RNA polymerase I subunit A43', 83, NULL, NULL, 215215),
(215216, '1.10.287.370-FF-000073', NULL, 'Predicted protein', 82, NULL, NULL, 215216),
(215217, '3.30.40.10-FF-000892', NULL, 'Probable E3 ubiquitin-protein ligase ARI15', 93, NULL, NULL, 215217),
(215218, '3.50.50.60-FF-000766', NULL, 'RIKEN cDNA 4930438A08 gene', 30, NULL, NULL, 215218),
(215219, '1.20.1250.20-FF-002089', NULL, 'Uncharacterized protein', 264, NULL, NULL, 215219),
(215220, '3.40.30.10-FF-000200', NULL, 'Glutathione S-transferase', 84, NULL, NULL, 215220),
(215221, '3.40.50.2300-FF-000964', NULL, NULL, 134, NULL, NULL, 215221),
(215222, '2.60.40.10-FF-005367', NULL, NULL, 62, NULL, NULL, 215222),
(215223, '3.30.160.60-FF-001545', NULL, 'Zinc finger protein 575', 28, NULL, NULL, 215223),
(215224, '3.40.50.300-FF-001473', NULL, 'ATP-binding cassette transporter', 221, NULL, NULL, 215224),
(215225, '3.40.50.80-FF-000065', NULL, 'Nitric oxide dioxygenase', 128, NULL, NULL, 215225),
(215226, '3.80.10.10-FF-000534', NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase At5g06940', 263, NULL, NULL, 215226),
(215227, '2.40.37.10-FF-000066', NULL, NULL, 102, NULL, NULL, 215227),
(215228, '3.40.50.2300-FF-000857', NULL, NULL, 137, NULL, NULL, 215228),
(215229, '1.10.630.10-FF-000073', NULL, 'Cytochrome P450 family 27 subfamily C member 1', 372, NULL, NULL, 215229),
(215230, '2.80.10.50-FF-000014', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 132, NULL, NULL, 215230),
(215231, '2.60.40.10-FF-004766', NULL, NULL, 124, NULL, NULL, 215231),
(215232, '1.10.8.60-FF-000022', NULL, 'Fidgetin like 1', 84, NULL, NULL, 215232); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(215233, '1.20.920.10-FF-000233', NULL, 'Uncharacterized protein', 137, NULL, NULL, 215233),
(215234, '3.30.420.10-FF-000522', NULL, NULL, 113, NULL, NULL, 215234),
(215235, '1.10.287.70-FF-000056', NULL, 'Potassium voltage-gated channel subfamily KQT member 1', 103, NULL, NULL, 215235),
(215236, '1.10.150.50-FF-000137', NULL, 'Sphingomyelin synthase-related 1', 78, NULL, NULL, 215236),
(215237, '1.20.1250.20-FF-000970', NULL, 'Sugar transporter', 221, NULL, NULL, 215237),
(215238, '1.10.630.10-FF-000180', NULL, 'Uncharacterized protein', 429, NULL, NULL, 215238),
(215239, '3.40.50.720-FF-002554', NULL, 'Uncharacterized protein', 60, NULL, NULL, 215239),
(215240, '3.30.60.270-FF-000001', NULL, 'Sortilin related VPS10 domain containing receptor 1', 74, NULL, NULL, 215240),
(215241, '3.20.20.80-FF-000631', NULL, 'Uncharacterized protein', 122, NULL, NULL, 215241),
(215242, '1.20.120.850-FF-000041', NULL, 'Helicase swr1', 93, NULL, NULL, 215242),
(215243, '1.10.10.10-FF-001295', NULL, 'Transcriptional regulator', 116, NULL, NULL, 215243),
(215244, '3.40.190.10-FF-000726', NULL, 'Predicted protein', 54, NULL, NULL, 215244),
(215245, '3.20.20.140-FF-000372', NULL, 'Uncharacterized protein', 218, NULL, NULL, 215245),
(215246, '1.20.1280.50-FF-000003', NULL, 'F-box only protein 11', 100, NULL, NULL, 215246),
(215247, '3.40.1390.20-FF-000007', NULL, 'Phosphate acetyltransferase', 144, NULL, NULL, 215247),
(215248, '1.25.40.10-FF-005243', NULL, 'SH3 domain and tetratricopeptide repeat-containing protein 2', 340, NULL, NULL, 215248),
(215249, '2.60.40.10-FF-001096', NULL, 'Interleukin 1 receptor like 2', 104, NULL, NULL, 215249),
(215250, '3.30.1610.10-FF-000002', NULL, 'nuclear pore complex protein NUP98A', 154, NULL, NULL, 215250),
(215251, '3.30.160.60-FF-005816', NULL, NULL, 91, NULL, NULL, 215251),
(215252, '3.30.470.10-FF-000019', NULL, 'Aminodeoxychorismate lyase', 71, NULL, NULL, 215252),
(215253, '4.10.1080.10-FF-000004', NULL, 'Cartilage oligomeric matrix protein', 118, NULL, NULL, 215253),
(215254, '1.10.510.10-FF-001216', NULL, 'Leucine-rich repeat kinase 2', 285, NULL, NULL, 215254),
(215255, '1.10.3810.10-FF-000013', NULL, 'Transglycosylase', 194, NULL, NULL, 215255),
(215256, '1.10.10.10-FF-001413', NULL, 'Transcriptional regulator, ArsR family', 104, NULL, NULL, 215256),
(215257, '3.30.479.20-FF-000003', NULL, 'Elongation factor Ts, mitochondrial', 94, NULL, NULL, 215257),
(215258, '3.40.50.300-FF-005418', NULL, 'Uncharacterized protein', 142, NULL, NULL, 215258),
(215259, '3.20.110.10-FF-000029', NULL, 'Alpha-mannosidase', 274, NULL, NULL, 215259),
(215260, '3.40.50.2000-FF-000981', NULL, 'Uncharacterized protein', 70, NULL, NULL, 215260),
(215261, '3.30.450.20-FF-000353', NULL, 'Uncharacterized protein', 75, NULL, NULL, 215261),
(215262, '2.40.30.70-FF-000012', NULL, 'Putative UPF0066 family protein', 162, NULL, NULL, 215262),
(215263, '2.10.25.10-FF-000208', NULL, 'Crumbs 2, cell polarity complex component', 58, NULL, NULL, 215263),
(215264, '2.60.40.1230-FF-000021', NULL, 'Uncharacterized protein', 119, NULL, NULL, 215264),
(215265, '3.30.70.330-FF-002679', NULL, NULL, 114, NULL, NULL, 215265),
(215266, '3.40.1190.20-FF-000026', NULL, 'Inositol 3-kinase', 291, NULL, NULL, 215266),
(215267, '2.130.10.10-FF-005019', NULL, 'Uncharacterized protein', 312, NULL, NULL, 215267),
(215268, '2.40.70.10-FF-000486', NULL, NULL, 140, NULL, NULL, 215268),
(215269, '3.30.200.20-FF-001150', NULL, 'Pregnancy up-regulated nonubiquitous CaM kinase', 93, NULL, NULL, 215269),
(215270, '1.10.600.10-FF-000138', NULL, 'Uncharacterized protein', 98, NULL, NULL, 215270),
(215271, '2.10.110.10-FF-000176', NULL, 'LIM domain-containing protein pin-2', 59, NULL, NULL, 215271),
(215272, '2.40.50.960-FF-000005', NULL, 'Telomere replication protein EST3', 160, NULL, NULL, 215272),
(215273, '3.30.450.20-FF-000460', NULL, 'Neuronal PAS domain-containing protein 4-like', 143, NULL, NULL, 215273),
(215274, '1.20.1070.10-FF-000762', NULL, 'Predicted protein', 287, NULL, NULL, 215274),
(215275, '3.40.50.620-FF-000158', NULL, 'Tyrosine--tRNA ligase', 259, NULL, NULL, 215275); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(215276, '3.30.420.40-FF-000857', NULL, 'Uncharacterized protein', 135, NULL, NULL, 215276),
(215277, '3.40.1190.10-FF-000023', NULL, 'UDP-N-acetylmuramoylalanine--D-glutamate ligase', 202, NULL, NULL, 215277),
(215278, '1.50.10.10-FF-000231', NULL, 'Glycogen debranching enzyme-related protein', 150, NULL, NULL, 215278),
(215279, '1.20.58.60-FF-000705', NULL, 'Uncharacterized protein', 284, NULL, NULL, 215279),
(215280, '2.102.10.10-FF-000041', NULL, 'Benzene 12-dioxygenase system ferredoxin subunit protein', 99, NULL, NULL, 215280),
(215281, '2.60.120.200-FF-000752', NULL, 'Uncharacterized protein', 122, NULL, NULL, 215281),
(215282, '2.30.30.100-FF-000162', NULL, 'Small nuclear ribonucleoprotein-associated protein, putative', 97, NULL, NULL, 215282),
(215283, '3.40.50.150-FF-001388', NULL, NULL, 172, NULL, NULL, 215283),
(215284, '3.30.420.10-FF-000741', NULL, NULL, 162, NULL, NULL, 215284),
(215285, '4.10.410.10-FF-000016', NULL, 'Collagen type XXVIII alpha 1 chain', 64, NULL, NULL, 215285),
(215286, '3.80.10.10-FF-000315', NULL, 'Si:dkey-16p6.1', 131, NULL, NULL, 215286),
(215287, '1.20.58.90-FF-000023', NULL, 'Uncharacterized protein', 104, NULL, NULL, 215287),
(215288, '1.20.58.80-FF-000020', NULL, 'AMSH-like ubiquitin thioesterase 3', 117, NULL, NULL, 215288),
(215289, '4.10.410.20-FF-000019', NULL, 'Uncharacterized protein', 41, NULL, NULL, 215289),
(215290, '1.20.1080.10-FF-000038', NULL, 'Glycerol uptake facilitator protein', 243, NULL, NULL, 215290),
(215291, '1.25.10.10-FF-003403', NULL, 'Uncharacterized protein', 107, NULL, NULL, 215291),
(215292, '1.20.1070.10-FF-000543', NULL, 'Uncharacterized protein', 305, NULL, NULL, 215292),
(215293, '2.60.40.1530-FF-000004', NULL, 'Integrin subunit alpha 3', 227, NULL, NULL, 215293),
(215294, '3.30.70.330-FF-002921', NULL, NULL, 126, NULL, NULL, 215294),
(215295, '3.30.450.20-FF-000246', NULL, 'Two-component sensor kinase citS', 136, NULL, NULL, 215295),
(215296, '3.40.50.1100-FF-000020', NULL, 'Cysteine synthase 2', 194, NULL, NULL, 215296),
(215297, '2.60.40.1520-FF-000001', NULL, 'Hemocyanin subunit 2', 259, NULL, NULL, 215297),
(215298, '2.60.40.420-FF-000152', NULL, 'fibrocystin-L-like isoform X1', 112, NULL, NULL, 215298),
(215299, '3.90.70.10-FF-000678', NULL, 'Bleomycin hydrolase, putative', 272, NULL, NULL, 215299),
(215300, '2.60.40.10-FF-001433', NULL, 'Matrix remodeling associated 5', 94, NULL, NULL, 215300),
(215301, '1.10.8.10-FF-000361', NULL, 'Predicted protein', 69, NULL, NULL, 215301),
(215302, '3.40.50.1260-FF-000040', NULL, 'Uncharacterized protein', 218, NULL, NULL, 215302),
(215303, '1.20.140.10-FF-000044', NULL, '4-hydroxyphenylacetate 3-monooxygenase oxygenase component', 217, NULL, NULL, 215303),
(215304, '3.90.20.20-FF-000043', NULL, 'Protein GrpE', 112, NULL, NULL, 215304),
(215305, '2.130.10.10-FF-001860', NULL, 'Type I inositol-1,4,5-trisphosphate 5-phosphatase 1', 166, NULL, NULL, 215305),
(215306, '2.120.10.30-FF-000439', NULL, 'Predicted protein', 125, NULL, NULL, 215306),
(215307, '3.40.50.1110-FF-000023', NULL, 'Poly C5 epimerase 3', 247, NULL, NULL, 215307),
(215308, '3.30.70.330-FF-000667', NULL, 'RNA-binding protein, putative', 86, NULL, NULL, 215308),
(215309, '1.10.287.160-FF-000021', NULL, 'Serine/threonine-protein kinase N2', 76, NULL, NULL, 215309),
(215310, '1.25.10.10-FF-001037', NULL, 'DNA double-strand break repair Rad50 ATPase, putative', 912, NULL, NULL, 215310),
(215311, '3.90.45.10-FF-000024', NULL, 'Peptide deformylase 1', 169, NULL, NULL, 215311),
(215312, '2.60.40.10-FF-005474', NULL, NULL, 102, NULL, NULL, 215312),
(215313, '3.40.50.11350-FF-000042', NULL, 'Uncharacterized protein', 136, NULL, NULL, 215313),
(215314, '3.40.50.300-FF-001580', NULL, 'E1A binding protein p400', 219, NULL, NULL, 215314),
(215315, '1.20.120.310-FF-000014', NULL, NULL, 72, NULL, NULL, 215315),
(215316, '2.60.120.480-FF-000009', NULL, 'Uncharacterized protein', 203, NULL, NULL, 215316),
(215317, '1.25.10.10-FF-001149', NULL, 'Protein serine/threonine phosphatase 4 regulatory subunit 1, putative', 469, NULL, NULL, 215317);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(215318, '3.90.190.10-FF-000024', NULL, 'probable tyrosine-protein phosphatase At1g05000', 151, NULL, NULL, 215318),
(215319, '2.130.10.10-FF-001181', NULL, 'Unplaced genomic scaffold supercont1.10, whole genome shotgun sequence', 359, NULL, NULL, 215319),
(215320, '2.60.120.260-FF-000186', NULL, 'Putative serine esterase Rv1835c', 219, NULL, NULL, 215320),
(215321, '2.130.10.10-FF-005671', NULL, 'Uncharacterized protein', 162, NULL, NULL, 215321),
(215322, '3.40.1110.10-FF-000254', NULL, NULL, 137, NULL, NULL, 215322),
(215323, '1.20.1420.10-FF-000008', NULL, 'Cyclin-D1-binding protein 1 homolog', 160, NULL, NULL, 215323),
(215324, '4.10.410.60-FF-000003', NULL, 'Large subunit ribosomal protein L35', 61, NULL, NULL, 215324),
(215325, '3.30.710.10-FF-000281', NULL, 'Elongin C paralog b', 36, NULL, NULL, 215325),
(215326, '3.30.360.20-FF-000020', NULL, NULL, 108, NULL, NULL, 215326),
(215327, '1.10.238.10-FF-000897', NULL, 'Uncharacterized protein', 143, NULL, NULL, 215327),
(215328, '3.30.160.60-FF-005704', NULL, NULL, 56, NULL, NULL, 215328),
(215329, '3.40.50.11990-FF-000003', NULL, 'Pol II transcription elongation factor subunit Cdc73', 184, NULL, NULL, 215329),
(215330, '1.25.40.20-FF-001087', NULL, 'SPRY domain/Ankyrin repeats (3 copies), putative', 257, NULL, NULL, 215330),
(215331, '1.25.40.10-FF-001084', NULL, 'Pentatricopeptide repeat-containing protein', 109, NULL, NULL, 215331),
(215332, '3.40.50.300-FF-001366', NULL, 'ATP binding protein, putative', 190, NULL, NULL, 215332),
(215333, '3.40.80.10-FF-000023', NULL, 'N-acetylmuramoyl-L-alanine amidase', 162, NULL, NULL, 215333),
(215334, '1.25.40.570-FF-000044', NULL, 'Csn-1', 349, NULL, NULL, 215334),
(215335, '3.40.850.10-FF-000390', NULL, 'Uncharacterized protein', 295, NULL, NULL, 215335),
(215336, '3.40.50.150-FF-001169', NULL, NULL, 207, NULL, NULL, 215336),
(215337, '2.30.40.10-FF-000170', NULL, 'Predicted protein', 44, NULL, NULL, 215337),
(215338, '3.40.50.300-FF-005851', NULL, 'Uncharacterized protein', 266, NULL, NULL, 215338),
(215339, '1.20.58.60-FF-000475', NULL, 'Spectrin beta chain', 107, NULL, NULL, 215339),
(215340, '1.25.10.10-FF-001582', NULL, 'Probable importin-5 homolog', 1064, NULL, NULL, 215340),
(215341, '1.50.10.10-FF-000012', NULL, 'LanC-like protein 3', 410, NULL, NULL, 215341),
(215342, '2.130.10.10-FF-005452', NULL, 'Uncharacterized protein', 197, NULL, NULL, 215342),
(215343, '1.25.40.470-FF-000014', NULL, 'Coatomer subunit alpha', 171, NULL, NULL, 215343),
(215344, '2.40.440.10-FF-000002', NULL, 'L,D-transpeptidase ErfK/SrfK', 135, NULL, NULL, 215344),
(215345, '2.30.29.30-FF-000817', NULL, 'Predicted protein', 121, NULL, NULL, 215345),
(215346, '2.10.70.10-FF-000161', NULL, 'Membrane cofactor protein', 61, NULL, NULL, 215346),
(215347, '2.60.120.200-FF-000533', NULL, 'LOC495391 protein', 150, NULL, NULL, 215347),
(215348, '2.30.29.30-FF-001211', NULL, 'Uncharacterized protein', 124, NULL, NULL, 215348),
(215349, '6.10.140.2220-FF-000038', NULL, 'GM14901', 55, NULL, NULL, 215349),
(215350, '1.10.10.10-FF-001525', NULL, 'Manganese ABC transporter, inner membrane permease protein SitC', 136, NULL, NULL, 215350),
(215351, '3.40.50.410-FF-000213', NULL, 'ATP-dependent DNA helicase', 191, NULL, NULL, 215351),
(215352, '1.20.1560.10-FF-000406', NULL, 'ABC multidrug transporter', 15, NULL, NULL, 215352),
(215353, '4.10.740.10-FF-000002', NULL, 'Proline rich and Gla domain 1', 40, NULL, NULL, 215353),
(215354, '3.40.50.10190-FF-000222', NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase', 100, NULL, NULL, 215354),
(215355, '3.30.60.30-FF-000101', NULL, 'Follistatin', 32, NULL, NULL, 215355),
(215356, '3.30.200.20-FF-002566', NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 156', 31, NULL, NULL, 215356),
(215357, '1.20.1280.50-FF-000222', NULL, 'Predicted protein', 52, NULL, NULL, 215357),
(215358, '1.10.510.10-FF-001435', NULL, 'Probable myosin light chain kinase DDB_G0275057', 219, NULL, NULL, 215358),
(215359, '2.60.40.1170-FF-000099', NULL, NULL, 150, NULL, NULL, 215359),
(215360, '3.50.50.60-FF-000985', NULL, 'Uncharacterized protein', 73, NULL, NULL, 215360);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(215361, '3.20.20.80-FF-000171', NULL, 'Malto-oligosyltrehalose synthase', 177, NULL, NULL, 215361),
(215362, '1.10.441.10-FF-000004', NULL, 'Mannose-6-phosphate isomerase, class I', 116, NULL, NULL, 215362),
(215363, '3.80.10.10-FF-000860', NULL, 'F-box/LRR-repeat protein 12 isoform X2', 174, NULL, NULL, 215363),
(215364, '2.20.100.10-FF-000066', NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 18', 60, NULL, NULL, 215364),
(215365, '2.130.10.10-FF-002597', NULL, 'DNA damage-binding protein 1', 365, NULL, NULL, 215365),
(215366, '2.60.220.50-FF-000134', NULL, 'Uncharacterized protein', 166, NULL, NULL, 215366),
(215367, '1.20.90.10-FF-000041', NULL, NULL, 77, NULL, NULL, 215367),
(215368, '2.10.90.10-FF-000044', NULL, 'Interleukin 17D', 118, NULL, NULL, 215368),
(215369, '3.40.50.300-FF-002996', NULL, 'Dynamin family GTPase, putative', 380, NULL, NULL, 215369),
(215370, '3.40.50.300-FF-005637', NULL, 'Uncharacterized protein', 236, NULL, NULL, 215370),
(215371, '1.25.10.10-FF-002779', NULL, 'Predicted protein', 219, NULL, NULL, 215371),
(215372, '1.10.10.1310-FF-000001', NULL, 'TCP pilus virulence regulatory protein ToxT', 47, NULL, NULL, 215372),
(215373, '3.30.1360.40-FF-000020', NULL, 'Similar to ribosome recycling factor', 81, NULL, NULL, 215373),
(215374, '2.60.40.10-FF-005704', NULL, NULL, 57, NULL, NULL, 215374),
(215375, '3.30.70.330-FF-000881', NULL, 'Polypyrimidine tract-binding protein 3', 98, NULL, NULL, 215375),
(215376, '1.10.840.10-FF-000010', NULL, 'ras-specific guanine nucleotide-releasing factor RalGPS1 isoform X1', 246, NULL, NULL, 215376),
(215377, '3.80.10.10-FF-002546', NULL, 'Cyclic nucleotide-binding domain containing protein, putative', 155, NULL, NULL, 215377),
(215378, '3.20.20.80-FF-000850', NULL, 'Uncharacterized protein', 125, NULL, NULL, 215378),
(215379, '3.40.1000.10-FF-000021', NULL, 'PsbP domain-containing protein 2, chloroplastic', 164, NULL, NULL, 215379),
(215380, '3.30.1370.10-FF-000079', NULL, 'developmental pluripotency-associated 5 protein-like', 105, NULL, NULL, 215380),
(215381, '2.130.10.10-FF-005238', NULL, 'WD-40 repeat protein', 316, NULL, NULL, 215381),
(215382, '3.40.50.720-FF-002335', NULL, 'Bll6448 protein', 172, NULL, NULL, 215382),
(215383, '1.10.510.10-FF-000131', NULL, 'cyclin-dependent kinase 14 isoform X1', 235, NULL, NULL, 215383),
(215384, '3.30.70.3320-FF-000003', NULL, NULL, 96, NULL, NULL, 215384),
(215385, '2.60.120.290-FF-000166', NULL, 'Cubilin homolog', 120, NULL, NULL, 215385),
(215386, '3.30.572.10-FF-000003', NULL, 'Thymidylate synthase', 283, NULL, NULL, 215386),
(215387, '1.10.167.10-FF-000012', NULL, 'Rho guanine nucleotide exchange factor 1', 212, NULL, NULL, 215387),
(215388, '3.30.450.60-FF-000011', NULL, 'AP complex subunit sigma', 143, NULL, NULL, 215388),
(215389, '2.130.10.10-FF-001186', NULL, 'UTP15p Nucleolar protein', 248, NULL, NULL, 215389),
(215390, '1.10.287.70-FF-000275', NULL, 'Potassium voltage-gated channel subfamily H member 8', 252, NULL, NULL, 215390),
(215391, '3.10.180.90-FF-000003', NULL, 'ATP-dependent 6-phosphofructokinase', 167, NULL, NULL, 215391),
(215392, '1.10.10.10-FF-001418', NULL, 'LysR family transcriptional regulator', 77, NULL, NULL, 215392),
(215393, '1.10.1200.240-FF-000006', NULL, 'Probable ribosomal protein', 109, NULL, NULL, 215393),
(215394, '2.130.10.10-FF-004963', NULL, 'Ribosomal RNA processing 9, U3 small nucleolar RNA binding protein', 89, NULL, NULL, 215394),
(215395, '1.10.630.10-FF-000303', NULL, 'Probable cytochrome P450 519D1', 489, NULL, NULL, 215395),
(215396, '1.20.5.350-FF-000004', NULL, 'WupA, isoform I', 162, NULL, NULL, 215396),
(215397, '1.20.120.350-FF-000104', NULL, 'Unplaced genomic scaffold supercont1.219, whole genome shotgun sequence', 144, NULL, NULL, 215397),
(215398, '3.80.10.10-FF-000753', NULL, 'Leucine rich repeat kinase 1', 199, NULL, NULL, 215398),
(215399, '3.10.20.90-FF-000949', NULL, 'UBA/TS-N domain containing protein', 69, NULL, NULL, 215399),
(215400, '2.130.10.10-FF-005233', NULL, 'Predicted protein', 37, NULL, NULL, 215400); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(215401, '3.40.50.720-FF-000637', NULL, 'Uncharacterized oxidoreductase C736.13', 325, NULL, NULL, 215401),
(215402, '1.10.10.1760-FF-000006', NULL, 'LSU ribosomal protein L36E', 89, NULL, NULL, 215402),
(215403, '1.10.8.60-FF-000241', NULL, 'GH08677p', 83, NULL, NULL, 215403),
(215404, '1.10.1580.10-FF-000005', NULL, 'Nucleolar GTP-binding protein 2', 93, NULL, NULL, 215404),
(215405, '1.10.287.130-FF-000041', NULL, 'Two-component sensor histidine kinase', 62, NULL, NULL, 215405),
(215406, '3.40.50.300-FF-005632', NULL, 'Uncharacterized protein', 202, NULL, NULL, 215406),
(215407, '1.10.10.10-FF-001076', NULL, '3-aminomethylindole N-methyltransferase', 104, NULL, NULL, 215407),
(215408, '1.25.40.10-FF-004754', NULL, 'Uncharacterized protein', 65, NULL, NULL, 215408),
(215409, '1.10.220.30-FF-000036', NULL, 'Flagellar motor switch protein FliG', 86, NULL, NULL, 215409),
(215410, '1.20.1050.10-FF-000199', NULL, 'Glutathione S-transferase', 24, NULL, NULL, 215410),
(215411, '1.20.5.340-FF-000001', NULL, 'Tropomyosin alpha-1 chain isoform 2', 81, NULL, NULL, 215411),
(215412, '3.90.190.10-FF-000350', NULL, 'Receptor-type tyrosine-protein phosphatase R', 298, NULL, NULL, 215412),
(215413, '1.20.58.60-FF-000149', NULL, 'Spectrin beta chain, non-erythrocytic', 112, NULL, NULL, 215413),
(215414, '1.10.287.70-FF-000623', NULL, 'Uncharacterized protein', 221, NULL, NULL, 215414),
(215415, '1.10.3500.10-FF-000017', NULL, 'Transcription elongation factor spt6', 47, NULL, NULL, 215415),
(215416, '3.40.50.80-FF-000177', NULL, 'FAD-binding domain-domain-containing protein', 191, NULL, NULL, 215416),
(215417, '3.30.40.10-FF-000673', NULL, 'RING finger domain protein, putative', 95, NULL, NULL, 215417),
(215418, '1.25.40.10-FF-005024', NULL, 'Diguanylate cyclase', 116, NULL, NULL, 215418),
(215419, '3.40.850.10-FF-000176', NULL, 'Kinesin-like protein', 330, NULL, NULL, 215419),
(215420, '1.20.120.1880-FF-000008', NULL, 'WGS project CABT00000000 data, contig 2.2', 247, NULL, NULL, 215420),
(215421, '3.40.50.2300-FF-000852', NULL, NULL, 63, NULL, NULL, 215421),
(215422, '3.40.50.1820-FF-000253', NULL, 'Carboxypeptidase', 445, NULL, NULL, 215422),
(215423, '1.20.940.10-FF-000009', NULL, 'Protein transport protein Sec31A', 109, NULL, NULL, 215423),
(215424, '3.40.50.300-FF-004002', NULL, 'Thiamine ABC transporter ATP-binding protein', 245, NULL, NULL, 215424),
(215425, '1.20.1050.10-FF-000317', NULL, 'Methionyl-tRNA synthetase', 100, NULL, NULL, 215425),
(215426, '2.10.25.10-FF-000085', NULL, 'Netrin G1', 81, NULL, NULL, 215426),
(215427, '1.10.437.10-FF-000011', NULL, 'BCL2 like 13', 187, NULL, NULL, 215427),
(215428, '1.25.40.420-FF-000027', NULL, 'galectin-3-binding protein isoform X2', 106, NULL, NULL, 215428),
(215429, '3.30.160.60-FF-005811', NULL, NULL, 33, NULL, NULL, 215429),
(215430, '2.30.30.140-FF-000252', NULL, 'Uncharacterized protein', 32, NULL, NULL, 215430),
(215431, '3.40.50.300-FF-001585', NULL, 'DNA replication helicase', 162, NULL, NULL, 215431),
(215432, '3.80.10.10-FF-001023', NULL, 'Uncharacterized protein', 209, NULL, NULL, 215432),
(215433, '3.30.160.60-FF-001433', NULL, 'Zinc finger protein 44', 26, NULL, NULL, 215433),
(215434, '2.60.40.10-FF-002849', NULL, 'AGAP003656-PC', 73, NULL, NULL, 215434),
(215435, '3.90.640.10-FF-000115', NULL, 'Uncharacterized protein', 70, NULL, NULL, 215435),
(215436, '1.10.245.10-FF-000014', NULL, 'E3 ubiquitin-protein ligase Mdm2', 57, NULL, NULL, 215436),
(215437, '1.10.630.10-FF-000185', NULL, 'Fatty-acid peroxygenase', 417, NULL, NULL, 215437),
(215438, '3.40.50.2300-FF-000745', NULL, 'Vomeronasal 2, receptor 8', 151, NULL, NULL, 215438),
(215439, '3.60.90.10-FF-000017', NULL, 'S-adenosylmethionine decarboxylase proenzyme', 428, NULL, NULL, 215439),
(215440, '2.30.33.40-FF-000010', NULL, '10 kDa chaperonin', 90, NULL, NULL, 215440),
(215441, '3.30.160.60-FF-001085', NULL, 'Zinc finger protein 184', 29, NULL, NULL, 215441),
(215442, '1.10.555.10-FF-000217', NULL, NULL, 284, NULL, NULL, 215442),
(215443, '1.25.10.10-FF-002998', NULL, 'Uncharacterized protein', 356, NULL, NULL, 215443);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(215444, '2.40.420.20-FF-000010', NULL, 'Efflux transporter periplasmic adaptor subunit', 66, NULL, NULL, 215444),
(215445, '1.25.10.10-FF-003280', NULL, 'Si:ch1073-82l19.1', 190, NULL, NULL, 215445),
(215446, '1.10.1520.10-FF-000119', NULL, 'Uncharacterized protein', 114, NULL, NULL, 215446),
(215447, '2.10.110.10-FF-000069', NULL, 'Uncharacterized protein, isoform Z', 62, NULL, NULL, 215447),
(215448, '1.20.1250.10-FF-000074', NULL, 'Interleukin-3', 130, NULL, NULL, 215448),
(215449, '3.90.1200.10-FF-000053', NULL, 'Spore coat protein, CotS family', 238, NULL, NULL, 215449),
(215450, '1.20.1270.60-FF-000281', NULL, 'Uncharacterized protein', 211, NULL, NULL, 215450),
(215451, '3.30.70.660-FF-000070', NULL, 'tRNA pseudouridine synthase', 155, NULL, NULL, 215451),
(215452, '2.60.220.50-FF-000139', NULL, 'Predicted protein', 152, NULL, NULL, 215452),
(215453, '3.30.70.1290-FF-000006', NULL, NULL, 44, NULL, NULL, 215453),
(215454, '3.40.50.2300-FF-001021', NULL, NULL, 177, NULL, NULL, 215454),
(215455, '1.20.1250.20-FF-000532', NULL, 'SLC (SoLute Carrier) homolog', 395, NULL, NULL, 215455),
(215456, '3.40.250.10-FF-000080', NULL, 'Ubiquitin-specific protease', 141, NULL, NULL, 215456),
(215457, '1.10.10.60-FF-000899', NULL, NULL, 37, NULL, NULL, 215457),
(215458, '2.60.40.10-FF-005148', NULL, NULL, 95, NULL, NULL, 215458),
(215459, '1.10.510.10-FF-001761', NULL, 'Pk34A', 196, NULL, NULL, 215459),
(215460, '3.40.50.12710-FF-000040', NULL, 'Protein arginine methyltransferase NDUFAF7', 154, NULL, NULL, 215460),
(215461, '3.90.870.10-FF-000031', NULL, 'Uncharacterized protein', 133, NULL, NULL, 215461),
(215462, '3.40.50.2300-FF-000397', NULL, 'DNA-binding response regulator', 120, NULL, NULL, 215462),
(215463, '2.60.120.200-FF-000645', NULL, 'Heparan sulfate proteoglycan 2 domain V/endorepellin', 109, NULL, NULL, 215463),
(215464, '1.20.5.1500-FF-000016', NULL, 'Breast cancer metastasis-suppressor 1-like protein-A', 49, NULL, NULL, 215464),
(215465, '3.40.710.10-FF-000008', NULL, 'Glutaminase, isoform E', 330, NULL, NULL, 215465),
(215466, '1.20.120.1810-FF-000010', NULL, NULL, 183, NULL, NULL, 215466),
(215467, '3.30.1490.480-FF-000006', NULL, 'Endolytic murein transglycosylase', 74, NULL, NULL, 215467),
(215468, '2.20.25.20-FF-000003', NULL, 'Casein kinase II subunit beta', 75, NULL, NULL, 215468),
(215469, '4.10.1000.10-FF-000005', NULL, 'cleavage and polyadenylation specificity factor subunit 4', 59, NULL, NULL, 215469),
(215470, '3.40.50.12370-FF-000016', NULL, 'Uncharacterized protein', 290, NULL, NULL, 215470),
(215471, '2.130.10.10-FF-003440', NULL, 'Pek-1', 145, NULL, NULL, 215471),
(215472, '3.40.50.720-FF-000295', NULL, '6-phospho-alpha-glucosidase', 166, NULL, NULL, 215472),
(215473, '3.30.70.330-FF-000886', NULL, 'Oligouridylate-binding protein 1C', 131, NULL, NULL, 215473),
(215474, '1.20.1250.20-FF-000184', NULL, 'Feline leukemia virus subgroup C receptor-related protein 1', 410, NULL, NULL, 215474),
(215475, '3.40.570.10-FF-000019', NULL, 'Putative endonuclease G', 317, NULL, NULL, 215475),
(215476, '1.20.1560.10-FF-000390', NULL, 'ABC transporter ATP-binding protein', 306, NULL, NULL, 215476),
(215477, '1.10.150.20-FF-000157', NULL, 'DNA-directed DNA polymerase, family X', 67, NULL, NULL, 215477),
(215478, '3.10.250.10-FF-000013', NULL, 'CD163 molecule like 1', 105, NULL, NULL, 215478),
(215479, '1.20.1250.20-FF-000077', NULL, 'Proton-coupled monocarboxylate transporter 3', 391, NULL, NULL, 215479),
(215480, '1.25.40.20-FF-001761', NULL, 'Kinase, NEK-frag', 192, NULL, NULL, 215480),
(215481, '2.40.150.20-FF-000011', NULL, '60S ribosomal protein L23', 138, NULL, NULL, 215481),
(215482, '2.40.50.140-FF-000771', NULL, NULL, 99, NULL, NULL, 215482),
(215483, '3.30.160.60-FF-003557', NULL, 'Zinc finger protein 846', 30, NULL, NULL, 215483),
(215484, '3.30.710.10-FF-000393', NULL, 'Uncharacterized protein', 91, NULL, NULL, 215484),
(215485, '2.60.40.420-FF-000157', NULL, 'Laccase', 207, NULL, NULL, 215485),
(215486, '3.40.50.10190-FF-000334', NULL, 'DNA ligase', 75, NULL, NULL, 215486);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(215487, '3.90.226.10-FF-000299', NULL, 'Uncharacterized protein', 137, NULL, NULL, 215487),
(215488, '3.40.50.2300-FF-000178', NULL, 'Transcriptional regulator FleQ', 135, NULL, NULL, 215488),
(215489, '1.20.1270.60-FF-000062', NULL, 'Arf-GAP with coiled-coil, ANK repeat and PH domain-containing protein 1', 255, NULL, NULL, 215489),
(215490, '3.40.50.11500-FF-000008', NULL, 'DENN domain containing 3', 187, NULL, NULL, 215490),
(215491, '3.10.290.20-FF-000013', NULL, 'SUMO-activating enzyme subunit 2', 135, NULL, NULL, 215491),
(215492, '2.10.110.10-FF-000288', NULL, 'Uncharacterized protein', 87, NULL, NULL, 215492),
(215493, '1.10.1410.20-FF-000013', NULL, 'Uncharacterized protein', 69, NULL, NULL, 215493),
(215494, '2.60.34.10-FF-000087', NULL, 'Uncharacterized protein', 115, NULL, NULL, 215494),
(215495, '1.25.40.10-FF-001191', NULL, 'ESX-2 secretion system protein EccA2', 298, NULL, NULL, 215495),
(215496, '3.40.50.300-FF-003159', NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', 218, NULL, NULL, 215496),
(215497, '3.20.10.10-FF-000020', NULL, 'Aminodeoxychorismate lyase', 153, NULL, NULL, 215497),
(215498, '1.20.1560.10-FF-000732', NULL, 'ABC transporter, putative', 203, NULL, NULL, 215498),
(215499, '1.25.40.20-FF-001194', NULL, 'Predicted protein', 102, NULL, NULL, 215499),
(215500, '1.10.1410.10-FF-000010', NULL, 'poly(A) RNA polymerase, mitochondrial', 187, NULL, NULL, 215500),
(215501, '3.40.50.300-FF-007094', NULL, 'Small GTP-binding protein, putative', 189, NULL, NULL, 215501),
(215502, '3.30.200.20-FF-000649', NULL, 'Uncharacterized protein', 102, NULL, NULL, 215502),
(215503, '3.30.230.10-FF-000148', NULL, '30S ribosomal protein S5', 88, NULL, NULL, 215503),
(215504, '2.20.25.240-FF-000010', NULL, 'AGAP004541-PA', 82, NULL, NULL, 215504),
(215505, '3.40.50.12780-FF-000145', NULL, 'NRPS-like enzyme, putative (AFU_orthologue AFUA_8G01222)', 161, NULL, NULL, 215505),
(215506, '3.30.160.20-FF-000027', NULL, 'Peptide chain release factor 1', 66, NULL, NULL, 215506),
(215507, '2.40.30.10-FF-000489', NULL, 'NADH-cytochrome b5 reductase', 33, NULL, NULL, 215507),
(215508, '3.40.50.1820-FF-000691', NULL, 'Putative esterase', 234, NULL, NULL, 215508),
(215509, '3.40.850.10-FF-000395', NULL, 'Kinesin-like protein', 290, NULL, NULL, 215509),
(215510, '3.40.50.20-FF-000075', NULL, 'D-alanine--D-alanine ligase', 116, NULL, NULL, 215510),
(215511, '2.60.40.10-FF-003905', NULL, NULL, 108, NULL, NULL, 215511),
(215512, '3.40.50.11660-FF-000028', NULL, NULL, 69, NULL, NULL, 215512),
(215513, '3.50.50.60-FF-000547', NULL, 'UDP-galactopyranose mutase', 422, NULL, NULL, 215513),
(215514, '3.40.50.720-FF-000076', NULL, 'CoA-binding domain protein', 137, NULL, NULL, 215514),
(215515, '1.25.10.10-FF-001144', NULL, 'Importin beta-like SAD2-like isoform A', 1036, NULL, NULL, 215515),
(215516, '3.30.160.60-FF-005137', NULL, NULL, 36, NULL, NULL, 215516),
(215517, '1.20.1730.10-FF-000004', NULL, 'sodium/glucose cotransporter 5 isoform X1', 520, NULL, NULL, 215517),
(215518, '2.40.15.10-FF-000004', NULL, 'Protein TCL1B4', 115, NULL, NULL, 215518),
(215519, '3.40.20.10-FF-000019', NULL, 'protein flightless-1 homolog isoform X1', 112, NULL, NULL, 215519),
(215520, '3.40.50.1110-FF-000135', NULL, 'Uncharacterized protein', 214, NULL, NULL, 215520),
(215521, '3.40.50.2300-FF-000526', NULL, 'Glutamate receptor 2.5', 97, NULL, NULL, 215521),
(215522, '1.10.8.60-FF-000460', NULL, 'Uncharacterized protein', 41, NULL, NULL, 215522),
(215523, '1.10.1410.40-FF-000019', NULL, 'Uncharacterized protein', 127, NULL, NULL, 215523),
(215524, '3.10.290.10-FF-000010', NULL, 'Pseudouridine synthase', 65, NULL, NULL, 215524),
(215525, '3.90.320.10-FF-000057', NULL, 'Predicted protein', 251, NULL, NULL, 215525),
(215526, '1.10.287.130-FF-000260', NULL, 'Two-component sensor histidine kinase', 76, NULL, NULL, 215526),
(215527, '3.90.79.10-FF-000198', NULL, 'Uncharacterized protein', 152, NULL, NULL, 215527),
(215528, '1.20.58.60-FF-000368', NULL, 'Spectrin beta, non-erythrocytic 5', 264, NULL, NULL, 215528),
(215529, '3.40.50.1820-FF-000472', NULL, 'Conserved protein', 230, NULL, NULL, 215529);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(215530, '1.10.390.10-FF-000025', NULL, 'Aminopeptidase', 261, NULL, NULL, 215530),
(215531, '4.10.400.10-FF-000061', NULL, 'Low-density lipoprotein receptor-related protein 1B', 40, NULL, NULL, 215531),
(215532, '3.80.10.10-FF-000192', NULL, 'Serine/threonine-protein kinase 11-interacting protein-like Protein', 163, NULL, NULL, 215532),
(215533, '3.60.10.10-FF-000248', NULL, 'Putative sphingomyelinase family protein', 267, NULL, NULL, 215533),
(215534, '1.10.800.10-FF-000007', NULL, 'Phenylalanine-4-hydroxylase, putative', 331, NULL, NULL, 215534),
(215535, '2.40.50.140-FF-000097', NULL, '23S rRNA (uracil(1939)-C(5))-methyltransferase RlmD', 83, NULL, NULL, 215535),
(215536, '2.40.50.510-FF-000005', NULL, 'Uncharacterized protein', 107, NULL, NULL, 215536),
(215537, '3.20.20.100-FF-000175', NULL, 'Oxidoreductase, aldo/keto reductase family protein', 165, NULL, NULL, 215537),
(215538, '3.40.50.300-FF-005413', NULL, 'Uncharacterized protein', 202, NULL, NULL, 215538),
(215539, '1.10.285.10-FF-000005', NULL, 'Glutamate dehydrogenase', 48, NULL, NULL, 215539),
(215540, '1.25.40.10-FF-004973', NULL, 'Putative pentatricopeptide repeat-containing protein At1g56570', 150, NULL, NULL, 215540),
(215541, '3.100.10.10-FF-000048', NULL, NULL, 92, NULL, NULL, 215541),
(215542, '3.40.50.2020-FF-000060', NULL, 'Ribose-phosphate pyrophosphokinase, putative', 100, NULL, NULL, 215542),
(215543, '3.40.50.620-FF-000377', NULL, 'Deoxyribodipyrimidine photolyase', 159, NULL, NULL, 215543),
(215544, '3.30.559.10-FF-000164', NULL, 'Uncharacterized protein', 173, NULL, NULL, 215544),
(215545, '1.10.4020.10-FF-000003', NULL, 'SCAN domain-containing protein 1', 76, NULL, NULL, 215545),
(215546, '3.30.70.270-FF-000172', NULL, 'Cyclic di-GMP phosphodiesterase Gmr', 179, NULL, NULL, 215546),
(215547, '1.20.1370.20-FF-000001', NULL, 'Catalase HPII', 98, NULL, NULL, 215547),
(215548, '3.10.310.10-FF-000069', NULL, 'Uncharacterized protein', 61, NULL, NULL, 215548),
(215549, '3.20.20.190-FF-000033', NULL, 'Glycerophosphodiester phosphodiesterase domain containing 3', 278, NULL, NULL, 215549),
(215550, '2.60.120.650-FF-000196', NULL, 'Uncharacterized protein', 42, NULL, NULL, 215550),
(215551, '3.40.50.300-FF-003378', NULL, 'Java no jive', 199, NULL, NULL, 215551),
(215552, '3.40.50.410-FF-000320', NULL, 'Integrin beta', 92, NULL, NULL, 215552),
(215553, '2.60.9.10-FF-000002', NULL, 'Vasopressin-neurophysin protein', 94, NULL, NULL, 215553),
(215554, '3.40.50.10440-FF-000005', NULL, 'YALI0F09273p', 165, NULL, NULL, 215554),
(215555, '2.20.100.10-FF-000173', NULL, 'Complement C7', 52, NULL, NULL, 215555),
(215556, '3.40.50.300-FF-001703', NULL, 'DExH-box helicase 30', 204, NULL, NULL, 215556),
(215557, '3.40.50.300-FF-002889', NULL, 'Origin recognition complex subunit 1', 184, NULL, NULL, 215557),
(215558, '3.40.50.620-FF-000725', NULL, 'Probable nicotinate-nucleotide adenylyltransferase', 200, NULL, NULL, 215558),
(215559, '1.10.510.10-FF-001542', NULL, 'CAMK family protein kinase', 221, NULL, NULL, 215559),
(215560, '3.30.460.10-FF-000064', NULL, 'DNA polymerase', 121, NULL, NULL, 215560),
(215561, '2.30.29.170-FF-000028', NULL, NULL, 124, NULL, NULL, 215561),
(215562, '2.60.40.10-FF-003350', NULL, 'Immunoglobulin light 3 variable 3', 101, NULL, NULL, 215562),
(215563, '2.60.40.1930-FF-000017', NULL, 'Thioester-containing protein 6', 95, NULL, NULL, 215563),
(215564, '1.25.40.20-FF-001542', NULL, 'Uncharacterized protein', 127, NULL, NULL, 215564),
(215565, '3.90.180.10-FF-000068', NULL, 'Phthioceranic/hydroxyphthioceranic acid synthase', 330, NULL, NULL, 215565),
(215566, '3.40.220.10-FF-000033', NULL, 'Predicted protein', 66, NULL, NULL, 215566),
(215567, '2.30.30.190-FF-000025', NULL, 'Uncharacterized protein', 87, NULL, NULL, 215567),
(215568, '3.40.50.10190-FF-000115', NULL, 'DNA polymerase POL4', 102, NULL, NULL, 215568),
(215569, '2.40.50.140-FF-000990', NULL, NULL, 175, NULL, NULL, 215569),
(215570, '2.60.120.200-FF-000426', NULL, 'Laminin subunit alpha 5', 178, NULL, NULL, 215570),
(215571, '1.10.472.80-FF-000118', NULL, 'Rab GTPase activating protein, putative', 150, NULL, NULL, 215571);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(215572, '3.40.50.720-FF-000418', NULL, 'UDP-glucose 4-epimerase 5', 263, NULL, NULL, 215572),
(215573, '3.30.230.90-FF-000003', NULL, NULL, 140, NULL, NULL, 215573),
(215574, '1.20.142.10-FF-000009', NULL, 'Poly [ADP-ribose] polymerase', 153, NULL, NULL, 215574),
(215575, '1.20.1070.10-FF-000088', NULL, 'Angiotensin II receptor type 1', 311, NULL, NULL, 215575),
(215576, '1.20.1250.20-FF-000751', NULL, 'Monocarboxylate transporter 12-B', 390, NULL, NULL, 215576),
(215577, '1.20.1560.10-FF-000513', NULL, 'YALI0D24189p', 323, NULL, NULL, 215577),
(215578, '3.40.50.10090-FF-000074', NULL, 'Uncharacterized protein', 22, NULL, NULL, 215578),
(215579, '3.30.420.10-FF-000292', NULL, 'Ribonuclease H', 150, NULL, NULL, 215579),
(215580, '3.80.10.10-FF-004463', NULL, 'Leucine-rich repeat protein kinase family protein', 83, NULL, NULL, 215580),
(215581, '2.10.25.10-FF-000427', NULL, 'epigen isoform X1', 44, NULL, NULL, 215581),
(215582, '2.60.120.260-FF-000635', NULL, 'Protein CBR-DDR-2', 109, NULL, NULL, 215582),
(215583, '1.25.40.10-FF-001207', NULL, 'Pentatricopeptide repeat-containing protein At3g18970', 178, NULL, NULL, 215583),
(215584, '1.10.287.130-FF-000147', NULL, 'Protein-histidine kinase, putative', 99, NULL, NULL, 215584),
(215585, '1.25.10.10-FF-001711', NULL, 'Uncharacterized protein', 237, NULL, NULL, 215585),
(215586, '1.10.238.10-FF-001280', NULL, 'Uncharacterized protein', 68, NULL, NULL, 215586),
(215587, '2.30.30.1020-FF-000021', NULL, 'Probable NOT transcription complex subunit VIP2', 180, NULL, NULL, 215587),
(215588, '3.30.1740.10-FF-000006', NULL, 'Poly [ADP-ribose] polymerase', 107, NULL, NULL, 215588),
(215589, '1.10.8.60-FF-000353', NULL, 'ORC1-type DNA replication protein 9', 84, NULL, NULL, 215589),
(215590, '2.60.120.290-FF-000054', NULL, 'Uncharacterized protein, isoform A', 114, NULL, NULL, 215590),
(215591, '3.30.160.60-FF-005581', NULL, NULL, 26, NULL, NULL, 215591),
(215592, '3.40.50.150-FF-000320', NULL, 'Ribosomal RNA-processing protein 8', 200, NULL, NULL, 215592),
(215593, '1.10.630.10-FF-000415', NULL, 'Cytochrome P450 family 87 subfamily A polypeptide 2', 140, NULL, NULL, 215593),
(215594, '1.20.58.1610-FF-000021', NULL, NULL, 117, NULL, NULL, 215594),
(215595, '3.30.300.30-FF-000025', NULL, 'Acetyl-coenzyme A synthetase', 134, NULL, NULL, 215595),
(215596, '1.25.40.10-FF-000589', NULL, 'Pentatricopeptide repeat-containing protein', 172, NULL, NULL, 215596),
(215597, '1.20.1050.10-FF-000087', NULL, 'Glutathione S-transferase', 123, NULL, NULL, 215597),
(215598, '3.40.50.10140-FF-000016', NULL, 'Disease resistance protein (TIR-NBS class)', 154, NULL, NULL, 215598),
(215599, '1.20.91.20-FF-000006', NULL, 'Complement C4', 81, NULL, NULL, 215599),
(215600, '3.40.50.2300-FF-001240', NULL, NULL, 83, NULL, NULL, 215600),
(215601, '3.30.1740.20-FF-000009', NULL, '40S ribosomal protein S26', 106, NULL, NULL, 215601),
(215602, '3.60.10.10-FF-000355', NULL, 'Uncharacterized protein', 149, NULL, NULL, 215602),
(215603, '3.30.160.60-FF-003451', NULL, NULL, 30, NULL, NULL, 215603),
(215604, '2.130.10.10-FF-001416', NULL, 'Transducin (beta)-like 3', 149, NULL, NULL, 215604),
(215605, '3.30.1140.32-FF-000025', NULL, 'Uncharacterized protein', 136, NULL, NULL, 215605),
(215606, '2.130.10.10-FF-002939', NULL, 'WD repeat-containing protein 78', 284, NULL, NULL, 215606),
(215607, '2.60.120.200-FF-000084', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', 171, NULL, NULL, 215607),
(215608, '2.130.10.10-FF-000798', NULL, 'Probable cytosolic iron-sulfur protein assembly protein CIAO1 homolog', 121, NULL, NULL, 215608),
(215609, '3.60.21.60-FF-000030', NULL, 'DNA polymerase alpha subunit B', 68, NULL, NULL, 215609),
(215610, '3.30.200.20-FF-000874', NULL, 'AGC protein kinase', 50, NULL, NULL, 215610),
(215611, '1.20.5.170-FF-000057', NULL, 'Basic leucine zipper 61', 74, NULL, NULL, 215611),
(215612, '1.10.12.10-FF-000057', NULL, 'Uncharacterized protein', 60, NULL, NULL, 215612),
(215613, '1.20.1250.20-FF-000307', NULL, 'Solute carrier family 15 member 3', 549, NULL, NULL, 215613);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(215614, '1.10.287.70-FF-000511', NULL, 'Protein CBR-TWK-44', 206, NULL, NULL, 215614),
(215615, '3.30.40.10-FF-000561', NULL, 'Bromo-adjacent homology (BAH) domain-containing protein', 72, NULL, NULL, 215615),
(215616, '3.90.190.10-FF-000462', NULL, 'Uncharacterized protein', 197, NULL, NULL, 215616),
(215617, '1.10.472.80-FF-000124', NULL, 'TBC/Rab GTPase activating domain containing protein', 125, NULL, NULL, 215617),
(215618, '3.40.50.300-FF-006020', NULL, 'AGAP009980-PA', 62, NULL, NULL, 215618),
(215619, '3.30.230.10-FF-000367', NULL, 'Uncharacterized protein', 92, NULL, NULL, 215619),
(215620, '1.10.8.540-FF-000002', NULL, 'Putative type III secretion system protein', 88, NULL, NULL, 215620),
(215621, '1.10.260.100-FF-000001', NULL, 'Ubiquilin 1', 59, NULL, NULL, 215621),
(215622, '3.80.10.10-FF-002440', NULL, 'Uncharacterized protein', 136, NULL, NULL, 215622),
(215623, '3.40.190.80-FF-000016', NULL, 'Inositol monophosphatase', 116, NULL, NULL, 215623),
(215624, '2.30.30.140-FF-000033', NULL, 'Binding protein', 53, NULL, NULL, 215624),
(215625, '2.60.120.200-FF-000078', NULL, 'Galectin', 153, NULL, NULL, 215625),
(215626, '1.10.1520.10-FF-000013', NULL, 'Endoribonuclease Dicer homolog 2', 156, NULL, NULL, 215626),
(215627, '2.60.120.590-FF-000043', NULL, 'Uncharacterized protein', 232, NULL, NULL, 215627),
(215628, '1.20.1560.10-FF-000064', NULL, 'ATP-binding cassette sub-family D member 4', 327, NULL, NULL, 215628),
(215629, '2.40.50.140-FF-000546', NULL, '26S protease regulatory subunit 7', 55, NULL, NULL, 215629),
(215630, '3.30.420.10-FF-000067', NULL, 'Putative CCR4-associated factor 1 11', 277, NULL, NULL, 215630),
(215631, '2.130.10.10-FF-003546', NULL, 'QUInine non-avoider', 193, NULL, NULL, 215631),
(215632, '3.40.720.10-FF-000060', NULL, 'Phosphatidylglycerol specific phospholipase C, putative', 185, NULL, NULL, 215632),
(215633, '1.25.40.10-FF-004967', NULL, 'Uncharacterized protein', 288, NULL, NULL, 215633),
(215634, '1.10.472.80-FF-000231', NULL, NULL, 50, NULL, NULL, 215634),
(215635, '3.40.50.360-FF-000046', NULL, 'NrdI protein, putative', 155, NULL, NULL, 215635),
(215636, '1.10.800.10-FF-000013', NULL, 'Aromatic amino acid hydroxlase, putative', 132, NULL, NULL, 215636),
(215637, '3.30.200.160-FF-000017', NULL, 'Uncharacterized protein', 66, NULL, NULL, 215637),
(215638, '1.10.285.10-FF-000011', NULL, 'Glutamate dehydrogenase', 45, NULL, NULL, 215638),
(215639, '1.25.40.20-FF-000013', NULL, 'ARF GTPase-activating protein GIT1 isoform 1', 110, NULL, NULL, 215639),
(215640, '3.30.70.1970-FF-000002', NULL, 'RNA polymerase I', 90, NULL, NULL, 215640),
(215641, '1.10.405.20-FF-000002', NULL, 'Amine oxidase, flavin-containing superfamily', 115, NULL, NULL, 215641),
(215642, '1.20.5.50-FF-000001', NULL, 'Cell division protein ZapA', 51, NULL, NULL, 215642),
(215643, '3.30.40.10-FF-000229', NULL, 'Cellulose synthase-like protein D3', 84, NULL, NULL, 215643),
(215644, '3.80.10.10-FF-000186', NULL, 'LRR receptor-like serine/threonine-protein kinase ERECTA', 94, NULL, NULL, 215644),
(215645, '1.10.287.130-FF-000254', NULL, 'Histidine kinase A domain protein', 77, NULL, NULL, 215645),
(215646, '1.10.10.1050-FF-000001', NULL, 'M7GpppN-mRNA hydrolase isoform 2', 84, NULL, NULL, 215646),
(215647, '3.30.300.30-FF-000132', NULL, 'Enniatin synthase', 116, NULL, NULL, 215647),
(215648, '1.25.40.10-FF-000696', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 90, NULL, NULL, 215648),
(215649, '3.30.160.60-FF-003119', NULL, NULL, 28, NULL, NULL, 215649),
(215650, '3.30.310.80-FF-000057', NULL, 'Non-specific serine/threonine protein kinase', 103, NULL, NULL, 215650),
(215651, '3.30.70.850-FF-000025', NULL, 'Prohormone convertase 2', 90, NULL, NULL, 215651),
(215652, '3.40.1170.10-FF-000027', NULL, 'DNA mismatch repair protein MutS', 149, NULL, NULL, 215652),
(215653, '3.30.40.10-FF-002359', NULL, 'Uncharacterized protein', 53, NULL, NULL, 215653),
(215654, '1.25.40.10-FF-001314', NULL, 'Os11g0213500 protein', 113, NULL, NULL, 215654),
(215655, '3.40.850.10-FF-000406', NULL, 'Kinesin-like protein KIN-6', 259, NULL, NULL, 215655);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(215656, '2.30.29.30-FF-000481', NULL, 'FACT complex subunit POB3', 102, NULL, NULL, 215656),
(215657, '3.90.1750.10-FF-000021', NULL, 'E3 ubiquitin-protein ligase HECTD1 isoform X1', 197, NULL, NULL, 215657),
(215658, '3.20.20.190-FF-000145', NULL, NULL, 86, NULL, NULL, 215658),
(215659, '1.20.1110.10-FF-000131', NULL, NULL, 142, NULL, NULL, 215659),
(215660, '1.20.1250.20-FF-001021', NULL, 'MFS sugar transporter, putative (AFU_orthologue AFUA_5G06720)', 246, NULL, NULL, 215660),
(215661, '2.40.50.140-FF-001153', NULL, NULL, 111, NULL, NULL, 215661),
(215662, '3.60.130.10-FF-000049', NULL, 'Uncharacterized protein', 275, NULL, NULL, 215662),
(215663, '3.20.20.80-FF-000283', NULL, 'Glycosyl hydrolase', 346, NULL, NULL, 215663),
(215664, '3.30.70.1730-FF-000054', NULL, 'Uncharacterized protein', 59, NULL, NULL, 215664),
(215665, '3.40.50.2000-FF-000650', NULL, 'Glycosyl transferase, group 1 family protein', 207, NULL, NULL, 215665),
(215666, '1.25.40.10-FF-003444', NULL, 'Putative pentatricopeptide repeat-containing protein isoform A', 149, NULL, NULL, 215666),
(215667, '3.40.50.300-FF-001815', NULL, 'ATP-dependent DNA helicase SRS2', 92, NULL, NULL, 215667),
(215668, '3.40.630.30-FF-000620', NULL, 'Predicted protein', 185, NULL, NULL, 215668),
(215669, '3.40.50.10880-FF-000002', NULL, 'Acidic residue methyltransferase 1', 153, NULL, NULL, 215669),
(215670, '3.30.200.20-FF-000981', NULL, 'Unplaced genomic scaffold supercont1.6, whole genome shotgun sequence', 97, NULL, NULL, 215670),
(215671, '3.40.850.10-FF-000389', NULL, 'Uncharacterized protein', 296, NULL, NULL, 215671),
(215672, '3.40.50.800-FF-000004', NULL, 'Glycine--tRNA ligase 2', 116, NULL, NULL, 215672),
(215673, '2.10.60.10-FF-000003', NULL, 'lymphocyte antigen 6E isoform X1', 79, NULL, NULL, 215673),
(215674, '3.40.50.410-FF-000090', NULL, 'Secretory 24AB, isoform A', 238, NULL, NULL, 215674),
(215675, '3.40.50.150-FF-001843', NULL, NULL, 49, NULL, NULL, 215675),
(215676, '3.30.420.10-FF-000180', NULL, 'CCR4-NOT transcription complex, subunit 7', 256, NULL, NULL, 215676),
(215677, '1.20.1460.10-FF-000005', NULL, 'V-type proton ATPase subunit C', 56, NULL, NULL, 215677),
(215678, '3.30.70.1990-FF-000008', NULL, NULL, 100, NULL, NULL, 215678),
(215679, '3.30.70.80-FF-000021', NULL, 'Uncharacterized protein', 77, NULL, NULL, 215679),
(215680, '3.30.750.24-FF-000049', NULL, 'Sulfate ABC transporter permease', 124, NULL, NULL, 215680),
(215681, '3.30.420.40-FF-001026', NULL, 'Uncharacterized protein', 39, NULL, NULL, 215681),
(215682, '3.20.20.100-FF-000169', NULL, 'Uncharacterized protein', 178, NULL, NULL, 215682),
(215683, '3.40.50.200-FF-000026', NULL, 'Subtilisin-like protease SBT4.12', 335, NULL, NULL, 215683),
(215684, '3.40.50.620-FF-000613', NULL, 'Tryptophanyl-tRNA synthetase, putative', 27, NULL, NULL, 215684),
(215685, '3.40.20.10-FF-000025', NULL, 'Actin-depolymerizing factor 2', 139, NULL, NULL, 215685),
(215686, '3.30.300.20-FF-000022', NULL, 'Ribosome-binding factor A', 112, NULL, NULL, 215686),
(215687, '2.60.120.740-FF-000009', NULL, 'DEAD (Asp-Glu-Ala-Asp) box polypeptide 41', 101, NULL, NULL, 215687),
(215688, '3.20.20.70-FF-000280', NULL, 'tRNA-dihydrouridine synthase', 266, NULL, NULL, 215688),
(215689, '3.40.30.10-FF-001268', NULL, 'Calsequestrin', 74, NULL, NULL, 215689),
(215690, '3.50.50.60-FF-000098', NULL, 'Dihydrolipoyl dehydrogenase', 123, NULL, NULL, 215690),
(215691, '3.40.366.10-FF-000039', NULL, 'Acyl transferase/acyl hydrolase/lysophospholipase', 212, NULL, NULL, 215691),
(215692, '1.25.40.10-FF-000010', NULL, 'Stress-induced phosphoprotein 1', 131, NULL, NULL, 215692),
(215693, '1.10.1380.10-FF-000024', NULL, 'Cell surface zinc endopeptidase PepO', 341, NULL, NULL, 215693),
(215694, '3.40.50.300-FF-007324', NULL, 'Uncharacterized protein', 145, NULL, NULL, 215694),
(215695, '3.30.70.330-FF-002573', NULL, NULL, 142, NULL, NULL, 215695),
(215696, '3.40.630.150-FF-000024', NULL, 'Uncharacterized protein', 108, NULL, NULL, 215696),
(215697, '2.70.9.10-FF-000002', NULL, 'Hexon protein', 184, NULL, NULL, 215697); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(215698, '2.130.10.30-FF-000118', NULL, NULL, 156, NULL, NULL, 215698),
(215699, '2.40.240.20-FF-000018', NULL, NULL, 73, NULL, NULL, 215699),
(215700, '1.20.1740.10-FF-000156', NULL, 'Amino acid transporter (Eurofung)', 493, NULL, NULL, 215700),
(215701, '1.10.10.10-FF-001744', NULL, 'Iron dependent repressor', 71, NULL, NULL, 215701),
(215702, '3.30.160.20-FF-000033', NULL, 'Adenosine deaminase domain-containing 1 (testis-specific)', 85, NULL, NULL, 215702),
(215703, '2.40.30.110-FF-000005', NULL, 'dimethylglycine dehydrogenase, mitochondrial', 79, NULL, NULL, 215703),
(215704, '3.30.160.60-FF-004867', NULL, NULL, 79, NULL, NULL, 215704),
(215705, '3.30.40.10-FF-001977', NULL, 'Predicted protein', 61, NULL, NULL, 215705),
(215706, '3.40.50.12780-FF-000139', NULL, 'AMP dependent CoA ligase, putative', 223, NULL, NULL, 215706),
(215707, '1.25.10.10-FF-003055', NULL, 'Predicted protein', 271, NULL, NULL, 215707),
(215708, '1.20.5.170-FF-000164', NULL, 'Protein Mabiki', 74, NULL, NULL, 215708),
(215709, '3.30.160.60-FF-003338', NULL, 'Si:ch73-221f6.3', 76, NULL, NULL, 215709),
(215710, '3.40.50.2000-FF-000537', NULL, 'UDP-glycosyltransferase 83A1', 58, NULL, NULL, 215710),
(215711, '2.130.10.30-FF-000006', NULL, 'E3 ubiquitin-protein ligase HERC2 isoform X1', 369, NULL, NULL, 215711),
(215712, '2.40.240.10-FF-000015', NULL, 'Glutaminyl-tRNA synthetase', 107, NULL, NULL, 215712),
(215713, '1.10.287.70-FF-000730', NULL, 'Uncharacterized protein', 119, NULL, NULL, 215713),
(215714, '3.80.10.10-FF-000079', NULL, 'PRAME family member 18', 260, NULL, NULL, 215714),
(215715, '3.40.47.10-FF-000177', NULL, '3-ketoacyl-CoA thiolase, putative', 427, NULL, NULL, 215715),
(215716, '3.30.470.10-FF-000020', NULL, '4-amino-4-deoxychorismate lyase', 111, NULL, NULL, 215716),
(215717, '1.20.1070.10-FF-001032', NULL, 'Predicted protein', 158, NULL, NULL, 215717),
(215718, '3.30.300.160-FF-000023', NULL, 'Type IV pilus assembly protein PilB', 79, NULL, NULL, 215718),
(215719, '2.40.50.140-FF-000765', NULL, NULL, 40, NULL, NULL, 215719),
(215720, '3.40.1110.10-FF-000142', NULL, 'Cation-transporting P-type ATPase B', 123, NULL, NULL, 215720),
(215721, '1.20.5.170-FF-000276', NULL, 'Uncharacterized protein', 66, NULL, NULL, 215721),
(215722, '1.10.150.60-FF-000034', NULL, 'ARID (AT-rich Interactive Domain-containing protein) homolog', 103, NULL, NULL, 215722),
(215723, '3.30.70.270-FF-000059', NULL, 'Diguanylate cyclase (GGDEF) domain-containing protein', 175, NULL, NULL, 215723),
(215724, '3.40.5.120-FF-000003', NULL, 'chromodomain-helicase-DNA-binding protein 9 isoform X1', 60, NULL, NULL, 215724),
(215725, '3.40.50.300-FF-005289', NULL, 'ADP-ribosylation factor-like protein 3', 176, NULL, NULL, 215725),
(215726, '2.30.42.10-FF-000455', NULL, NULL, 95, NULL, NULL, 215726),
(215727, '2.30.29.30-FF-000262', NULL, 'Disabled, isoform F', 154, NULL, NULL, 215727),
(215728, '3.40.50.300-FF-004688', NULL, 'Cell division control protein 48 homolog D', 84, NULL, NULL, 215728),
(215729, '1.25.40.20-FF-001429', NULL, 'Uncharacterized protein', 173, NULL, NULL, 215729),
(215730, '1.10.510.10-FF-001093', NULL, 'NIMA related kinase 10', 84, NULL, NULL, 215730),
(215731, '1.25.40.20-FF-001317', NULL, 'Charon', 139, NULL, NULL, 215731),
(215732, '1.10.150.50-FF-000031', NULL, 'Kinase suppressor of Ras 2', 71, NULL, NULL, 215732),
(215733, '3.30.70.260-FF-000056', NULL, 'D-3-phosphoglycerate dehydrogenase', 83, NULL, NULL, 215733),
(215734, '2.130.10.10-FF-000112', NULL, 'jouberin isoform X2', 324, NULL, NULL, 215734),
(215735, '3.10.580.10-FF-000111', NULL, 'Chloride channel protein', 73, NULL, NULL, 215735),
(215736, '3.80.10.10-FF-004238', NULL, 'Uncharacterized protein', 77, NULL, NULL, 215736),
(215737, '2.10.25.10-FF-000652', NULL, 'Blast:Protein eyes shut', 48, NULL, NULL, 215737),
(215738, '1.20.58.60-FF-000256', NULL, 'Spectrin beta chain', 235, NULL, NULL, 215738),
(215739, '3.40.50.1820-FF-000808', NULL, 'Carboxypeptidase', 274, NULL, NULL, 215739),
(215740, '3.90.228.20-FF-000020', NULL, NULL, 197, NULL, NULL, 215740);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(215741, '1.10.8.60-FF-000134', NULL, 'AAA family ATPase, putative', 90, NULL, NULL, 215741),
(215742, '1.25.40.10-FF-001426', NULL, 'Beta-lactamase HcpA', 226, NULL, NULL, 215742),
(215743, '3.40.50.720-FF-000862', NULL, 'Formate dehydrogenase chloroplastic/mitochondrial', 39, NULL, NULL, 215743),
(215744, '1.25.10.10-FF-001930', NULL, 'Uncharacterized protein', 291, NULL, NULL, 215744),
(215745, '1.10.287.70-FF-000168', NULL, 'Potassium sodium-activated channel subfamily T member 2', 165, NULL, NULL, 215745),
(215746, '1.10.10.10-FF-001183', NULL, 'ArsR family transcriptional regulator', 95, NULL, NULL, 215746),
(215747, '3.40.250.10-FF-000192', NULL, 'Adenylyltransferase and sulfurtransferase MOCS3 homolog', 100, NULL, NULL, 215747),
(215748, '3.40.50.300-FF-007543', NULL, 'Uncharacterized protein', 200, NULL, NULL, 215748),
(215749, '3.40.50.2000-FF-000318', NULL, 'Glycogen phosphorylase', 331, NULL, NULL, 215749),
(215750, '3.90.180.10-FF-000181', NULL, 'Zinc-type alcohol dehydrogenase-like protein C337.11', 317, NULL, NULL, 215750),
(215751, '2.60.40.10-FF-001764', NULL, 'Sallimus, isoform Q', 117, NULL, NULL, 215751),
(215752, '2.60.120.200-FF-000191', NULL, 'MAM and LDL receptor class A domain-containing 1', 160, NULL, NULL, 215752),
(215753, '3.40.50.1220-FF-000056', NULL, 'Pyruvate decarboxylase, putative', 159, NULL, NULL, 215753),
(215754, '3.40.50.11260-FF-000015', NULL, 'Heat shock protein 92', 88, NULL, NULL, 215754),
(215755, '2.60.40.820-FF-000058', NULL, 'Protein CBG21788', 172, NULL, NULL, 215755),
(215756, '2.60.120.430-FF-000023', NULL, 'Complex I intermediate-associated protein 30, mitochondrial', 176, NULL, NULL, 215756),
(215757, '3.90.70.10-FF-000897', NULL, 'Uncharacterized protein', 126, NULL, NULL, 215757),
(215758, '2.60.120.10-FF-000210', NULL, 'Crp/Fnr family transcriptional regulator', 137, NULL, NULL, 215758),
(215759, '1.10.437.10-FF-000005', NULL, 'bcl-2-related ovarian killer protein', 165, NULL, NULL, 215759),
(215760, '3.40.33.10-FF-000111', NULL, 'uncharacterized protein LOC100180010 isoform X2', 210, NULL, NULL, 215760),
(215761, '3.30.160.20-FF-000252', NULL, 'Adenosine deaminase, RNA specific B2 (inactive)', 51, NULL, NULL, 215761),
(215762, '2.60.40.10-FF-000022', NULL, 'Cardiac titin', 94, NULL, NULL, 215762),
(215763, '3.30.70.270-FF-000278', NULL, NULL, 112, NULL, NULL, 215763),
(215764, '3.30.410.40-FF-000002', NULL, 'BnaC06g23880D protein', 192, NULL, NULL, 215764),
(215765, '3.30.420.40-FF-000969', NULL, 'HSP70 domain-containing protein', 54, NULL, NULL, 215765),
(215766, '3.10.129.10-FF-000119', NULL, 'Fatty acid synthase', 281, NULL, NULL, 215766),
(215767, '3.40.50.300-FF-003272', NULL, 'G Protein, Alpha subunit', 220, NULL, NULL, 215767),
(215768, '3.40.1190.20-FF-000138', NULL, NULL, 134, NULL, NULL, 215768),
(215769, '3.40.50.1460-FF-000111', NULL, 'Uncharacterized protein', 106, NULL, NULL, 215769),
(215770, '3.80.10.10-FF-002333', NULL, 'Uncharacterized protein', 232, NULL, NULL, 215770),
(215771, '1.20.1070.10-FF-000195', NULL, 'probable G-protein coupled receptor 61', 330, NULL, NULL, 215771),
(215772, '1.10.10.60-FF-001169', NULL, NULL, 45, NULL, NULL, 215772),
(215773, '1.10.287.1260-FF-000009', NULL, 'Possible conserved transmembrane protein', 126, NULL, NULL, 215773),
(215774, '3.40.250.10-FF-000203', NULL, 'Dual specificity phosphatase', 142, NULL, NULL, 215774),
(215775, '3.40.50.620-FF-000832', NULL, 'Predicted protein', 218, NULL, NULL, 215775),
(215776, '1.10.3500.10-FF-000023', NULL, 'Transcription accessory protein', 104, NULL, NULL, 215776),
(215777, '3.40.50.10130-FF-000013', NULL, 'Crossover junction endonuclease EME1', 178, NULL, NULL, 215777),
(215778, '3.30.160.60-FF-005362', NULL, NULL, 28, NULL, NULL, 215778),
(215779, '3.40.50.300-FF-005306', NULL, 'Small GTP-binding protein', 170, NULL, NULL, 215779),
(215780, '3.30.40.10-FF-000448', NULL, 'Histone-lysine N-methyltransferase MLL3', 44, NULL, NULL, 215780),
(215781, '3.30.2350.10-FF-000089', NULL, 'Uncharacterized protein', 137, NULL, NULL, 215781),
(215782, '1.20.1250.20-FF-000296', NULL, 'MFS sugar transporter, putative', 468, NULL, NULL, 215782);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(215783, '1.10.238.10-FF-001173', NULL, 'EFHC2', 95, NULL, NULL, 215783),
(215784, '2.130.10.10-FF-005800', NULL, 'Uncharacterized protein', 401, NULL, NULL, 215784),
(215785, '1.20.5.370-FF-000016', NULL, NULL, 46, NULL, NULL, 215785),
(215786, '1.20.58.60-FF-000817', NULL, 'Uncharacterized protein', 184, NULL, NULL, 215786),
(215787, '1.25.40.10-FF-000819', NULL, 'Coatomer subunit epsilon', 304, NULL, NULL, 215787),
(215788, '3.40.50.1820-FF-000247', NULL, 'Phosphatidylcholine-sterol acyltransferase', 174, NULL, NULL, 215788),
(215789, '1.10.860.10-FF-000005', NULL, 'Replicative DNA helicase', 155, NULL, NULL, 215789),
(215790, '3.30.1490.70-FF-000004', NULL, 'DNA ligase', 54, NULL, NULL, 215790),
(215791, '1.10.8.10-FF-000035', NULL, 'baculoviral IAP repeat-containing protein 2', 66, NULL, NULL, 215791),
(215792, '1.10.225.10-FF-000013', NULL, 'Aspartic proteinase A1', 78, NULL, NULL, 215792),
(215793, '3.40.190.10-FF-000945', NULL, 'Gll0431 protein', 14, NULL, NULL, 215793),
(215794, '1.10.10.60-FF-001282', NULL, NULL, 64, NULL, NULL, 215794),
(215795, '2.60.120.480-FF-000010', NULL, 'Predicted protein', 121, NULL, NULL, 215795),
(215796, '3.80.10.10-FF-004019', NULL, 'Uncharacterized protein', 147, NULL, NULL, 215796),
(215797, '3.90.1010.10-FF-000016', NULL, 'Iron-sulfur cluster assembly protein', 140, NULL, NULL, 215797),
(215798, '2.60.120.970-FF-000050', NULL, 'Transforming growth factor beta-1', 169, NULL, NULL, 215798),
(215799, '3.60.90.10-FF-000023', NULL, 'S-adenosylmethionine decarboxylase proenzyme', 269, NULL, NULL, 215799),
(215800, '3.30.420.10-FF-000303', NULL, 'Uncharacterized protein', 166, NULL, NULL, 215800),
(215801, '3.90.640.10-FF-000222', NULL, 'Uncharacterized protein', 130, NULL, NULL, 215801),
(215802, '3.40.640.10-FF-000469', NULL, 'Uncharacterized protein', 113, NULL, NULL, 215802),
(215803, '1.20.5.350-FF-000010', NULL, 'Troponin T type 3b (skeletal, fast)', 51, NULL, NULL, 215803),
(215804, '1.20.920.10-FF-000014', NULL, 'Histone acetyltransferase KAT2B', 119, NULL, NULL, 215804),
(215805, '3.30.70.141-FF-000033', NULL, NULL, 99, NULL, NULL, 215805),
(215806, '1.25.40.20-FF-000232', NULL, 'DExH-box ATP-dependent RNA helicase DExH6', 115, NULL, NULL, 215806),
(215807, '3.30.50.10-FF-000168', NULL, 'Uncharacterized protein', 112, NULL, NULL, 215807),
(215808, '1.10.472.80-FF-000012', NULL, 'Small G protein signaling modulator 3', 140, NULL, NULL, 215808),
(215809, '3.80.10.10-FF-002552', NULL, 'AGAP002004-PA', 149, NULL, NULL, 215809),
(215810, '3.30.230.10-FF-000255', NULL, 'Uncharacterized protein', 74, NULL, NULL, 215810),
(215811, '1.20.1070.10-FF-000318', NULL, 'Trace amine associated receptor 15', 308, NULL, NULL, 215811),
(215812, '2.60.40.10-FF-004979', NULL, NULL, 109, NULL, NULL, 215812),
(215813, '2.60.120.10-FF-000316', NULL, 'S-adenosyl-L-homocysteine hydrolase', 117, NULL, NULL, 215813),
(215814, '3.30.559.10-FF-000271', NULL, 'ACL138Cp', 154, NULL, NULL, 215814),
(215815, '3.50.50.60-FF-000878', NULL, 'Squalene monooxygenase', 366, NULL, NULL, 215815),
(215816, '1.25.10.10-FF-001475', NULL, 'Uncharacterized protein', 306, NULL, NULL, 215816),
(215817, '1.20.1560.10-FF-000283', NULL, 'Related to YBT1-Vacuolar, full-size ABC protein transporting bile acids', 354, NULL, NULL, 215817),
(215818, '3.20.20.80-FF-000406', NULL, 'Chitinase', 128, NULL, NULL, 215818),
(215819, '2.30.30.140-FF-000145', NULL, 'Predicted protein', 47, NULL, NULL, 215819),
(215820, '3.30.160.60-FF-003670', NULL, NULL, 29, NULL, NULL, 215820),
(215821, '3.40.50.2000-FF-000756', NULL, 'Uncharacterized protein', 140, NULL, NULL, 215821),
(215822, '3.30.450.20-FF-000459', NULL, 'Histidine kinase', 102, NULL, NULL, 215822),
(215823, '3.90.1150.10-FF-000178', NULL, 'Probable aminotransferase', 142, NULL, NULL, 215823),
(215824, '2.60.40.60-FF-001083', NULL, 'Uncharacterized protein', 109, NULL, NULL, 215824),
(215825, '4.10.410.10-FF-000123', NULL, 'Uncharacterized protein', 56, NULL, NULL, 215825),
(215826, '1.20.120.1080-FF-000072', NULL, 'ATP-dependent RNA helicase DHX36', 107, NULL, NULL, 215826);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(215827, '1.25.40.180-FF-000247', NULL, NULL, 114, NULL, NULL, 215827),
(215828, '3.40.390.10-FF-000146', NULL, 'Metalloendopeptidase', 229, NULL, NULL, 215828),
(215829, '2.60.40.10-FF-005255', NULL, NULL, 113, NULL, NULL, 215829),
(215830, '4.10.520.10-FF-000019', NULL, 'DNA-binding protein HU', 90, NULL, NULL, 215830),
(215831, '3.30.470.20-FF-000242', NULL, 'Uncharacterized protein', 55, NULL, NULL, 215831),
(215832, '3.30.70.330-FF-001611', NULL, NULL, 100, NULL, NULL, 215832),
(215833, '1.50.10.10-FF-000006', NULL, 'Non-lysosomal glucosylceramidase', 312, NULL, NULL, 215833),
(215834, '3.30.200.20-FF-001256', NULL, 'AGC family protein kinase', 105, NULL, NULL, 215834),
(215835, '3.20.20.100-FF-000063', NULL, 'Aldo/keto reductase', 273, NULL, NULL, 215835),
(215836, '3.10.20.230-FF-000025', NULL, 'Rp1-like 1b', 100, NULL, NULL, 215836),
(215837, '1.25.40.570-FF-000038', NULL, 'GM15765', 341, NULL, NULL, 215837),
(215838, '1.10.357.140-FF-000004', NULL, 'Protoheme IX farnesyltransferase, mitochondrial', 152, NULL, NULL, 215838),
(215839, '3.40.50.300-FF-001254', NULL, 'Cell division protein ZapE', 161, NULL, NULL, 215839),
(215840, '1.25.40.10-FF-004861', NULL, 'Uncharacterized protein', 246, NULL, NULL, 215840),
(215841, '2.10.90.10-FF-000050', NULL, 'Nerve growth factor beta polypeptide', 80, NULL, NULL, 215841),
(215842, '1.10.287.2610-FF-000004', NULL, 'Dynein heavy chain, cytoplasmic', 164, NULL, NULL, 215842),
(215843, '3.40.50.2000-FF-001032', NULL, 'Uncharacterized protein', 170, NULL, NULL, 215843),
(215844, '1.50.10.20-FF-000009', NULL, 'Geranylgeranyl transferase type-2 subunit beta', 314, NULL, NULL, 215844),
(215845, '2.40.10.10-FF-000021', NULL, 'Kallikrein 1', 79, NULL, NULL, 215845),
(215846, '2.30.30.490-FF-000008', NULL, 'Histone-lysine N-methyltransferase', 266, NULL, NULL, 215846),
(215847, '1.20.1720.10-FF-000048', NULL, 'Uncharacterized MFS-type transporter YfiU', 210, NULL, NULL, 215847),
(215848, '1.10.287.2620-FF-000007', NULL, 'Dynein heavy chain, putative', 60, NULL, NULL, 215848),
(215849, '3.30.760.10-FF-000008', NULL, 'Eukaryotic translation initiation factor NCBP', 201, NULL, NULL, 215849),
(215850, '1.10.510.10-FF-003453', NULL, NULL, 276, NULL, NULL, 215850),
(215851, '3.30.360.20-FF-000014', NULL, NULL, 111, NULL, NULL, 215851),
(215852, '2.40.128.330-FF-000008', NULL, 'CorA Metal Ion Transporter (MIT) Family', 58, NULL, NULL, 215852),
(215853, '3.30.360.10-FF-000011', NULL, 'Glucose-6-phosphate 1-dehydrogenase', 280, NULL, NULL, 215853),
(215854, '3.50.50.60-FF-000991', NULL, 'Tryptophan 2-halogenase', 206, NULL, NULL, 215854),
(215855, '3.30.40.10-FF-000780', NULL, 'Rab-3-interacting molecule unc-10', 143, NULL, NULL, 215855),
(215856, '3.40.50.300-FF-005183', NULL, 'Uncharacterized protein', 217, NULL, NULL, 215856),
(215857, '3.40.710.10-FF-000121', NULL, 'D-alanyl-D-alanine carboxypeptidase', 284, NULL, NULL, 215857),
(215858, '1.20.1260.10-FF-000024', NULL, 'Ferritin heavy chain', 180, NULL, NULL, 215858),
(215859, '2.130.10.10-FF-005126', NULL, 'Tomosyn-like protein', 273, NULL, NULL, 215859),
(215860, '2.30.29.30-FF-000368', NULL, 'Uncharacterized protein, isoform B', 132, NULL, NULL, 215860),
(215861, '3.40.30.10-FF-000413', NULL, 'N-oligosaccharyltransferase complex 37kDa subunit', 175, NULL, NULL, 215861),
(215862, '1.20.120.160-FF-000042', NULL, 'Two-component phosphorelay mediator', 73, NULL, NULL, 215862),
(215863, '1.10.510.10-FF-001654', NULL, 'SRSF protein kinase 3', 165, NULL, NULL, 215863),
(215864, '1.10.506.10-FF-000020', NULL, 'Ras GTPase-activating protein 4 isoform 1', 237, NULL, NULL, 215864),
(215865, '1.20.1560.10-FF-000625', NULL, 'Uncharacterized protein', 274, NULL, NULL, 215865),
(215866, '2.60.40.420-FF-000264', NULL, 'Uncharacterized protein', 62, NULL, NULL, 215866),
(215867, '3.40.30.10-FF-000071', NULL, 'Glutathione S-transferase P', 83, NULL, NULL, 215867),
(215868, '3.30.160.60-FF-001871', NULL, 'Zinc finger protein 473', 28, NULL, NULL, 215868),
(215869, '3.40.50.150-FF-001405', NULL, NULL, 164, NULL, NULL, 215869);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(215870, '3.40.50.10190-FF-000003', NULL, 'Tumor suppressor p53-binding protein 1', 127, NULL, NULL, 215870),
(215871, '3.40.50.300-FF-000978', NULL, 'YLP motif-containing protein 1 isoform X3', 167, NULL, NULL, 215871),
(215872, '3.30.70.660-FF-000069', NULL, 'tRNA pseudouridine synthase A', 162, NULL, NULL, 215872),
(215873, '1.20.1250.20-FF-002218', NULL, 'Monocarboxylate transporter, putative', 135, NULL, NULL, 215873),
(215874, '3.40.605.10-FF-000101', NULL, 'Uncharacterized protein', 118, NULL, NULL, 215874),
(215875, '3.30.930.10-FF-000263', NULL, 'Lysyl-tRNA synthetase', 321, NULL, NULL, 215875),
(215876, '3.40.50.300-FF-005525', NULL, 'DEAD-box ATP-dependent RNA helicase 55', 109, NULL, NULL, 215876),
(215877, '3.80.10.10-FF-004351', NULL, 'Uncharacterized protein', 182, NULL, NULL, 215877),
(215878, '1.10.565.10-FF-000050', NULL, 'Nuclear hormone receptor family member daf-12', 245, NULL, NULL, 215878),
(215879, '3.30.1780.10-FF-000003', NULL, 'Protein SAR DEFICIENT 4', 111, NULL, NULL, 215879),
(215880, '1.10.10.160-FF-000015', NULL, 'Possible ATP-dependent DNA helicase', 101, NULL, NULL, 215880),
(215881, '3.30.2410.10-FF-000021', NULL, 'Putative ubiquitin-protein ligase', 122, NULL, NULL, 215881),
(215882, '2.170.300.10-FF-000052', NULL, 'Cell death abnormality protein 1', 124, NULL, NULL, 215882),
(215883, '3.60.10.10-FF-000136', NULL, 'Endonuclease/exonuclease/phosphatase family metal-dependent hydrolase', 252, NULL, NULL, 215883),
(215884, '3.30.70.330-FF-000993', NULL, 'NOP4p Nucleolar protein', 115, NULL, NULL, 215884),
(215885, '3.30.470.20-FF-000129', NULL, 'Glutathione synthetase', 59, NULL, NULL, 215885),
(215886, '3.40.50.1820-FF-000921', NULL, 'Predicted protein', 283, NULL, NULL, 215886),
(215887, '3.30.1490.180-FF-000017', NULL, 'DNA-directed RNA polymerase IV subunit 1', 53, NULL, NULL, 215887),
(215888, '3.40.50.2000-FF-000195', NULL, 'UDP-glucuronosyltransferase', 257, NULL, NULL, 215888),
(215889, '2.60.40.10-FF-001545', NULL, 'Echinoid, isoform C', 90, NULL, NULL, 215889),
(215890, '3.40.50.1010-FF-000105', NULL, 'Uncharacterized protein', 153, NULL, NULL, 215890),
(215891, '1.10.510.10-FF-001199', NULL, 'Cyclin-dependent kinase-activating kinase', 241, NULL, NULL, 215891),
(215892, '2.20.110.10-FF-000016', NULL, 'Radial spoke head 1 homolog', 46, NULL, NULL, 215892),
(215893, '3.40.50.1000-FF-000102', NULL, 'Enolase-phosphatase E1', 134, NULL, NULL, 215893),
(215894, '1.20.58.90-FF-000017', NULL, 'SPI-1 type III secretion system effector E3 ubiquitin transferase SlrP', 86, NULL, NULL, 215894),
(215895, '3.80.10.10-FF-002439', NULL, 'Uncharacterized protein', 141, NULL, NULL, 215895),
(215896, '1.20.120.1910-FF-000040', NULL, 'Uncharacterized protein', 187, NULL, NULL, 215896),
(215897, '1.10.510.10-FF-002958', NULL, 'TKL family protein kinase', 287, NULL, NULL, 215897),
(215898, '3.10.250.10-FF-000120', NULL, NULL, 64, NULL, NULL, 215898),
(215899, '3.60.110.10-FF-000054', NULL, 'Biotinidase', 286, NULL, NULL, 215899),
(215900, '3.60.40.10-FF-000306', NULL, 'Uncharacterized protein', 276, NULL, NULL, 215900),
(215901, '3.30.70.330-FF-000555', NULL, 'Polyadenylate-binding protein', 102, NULL, NULL, 215901),
(215902, '1.20.1560.10-FF-000844', NULL, 'AGL346Wp', 333, NULL, NULL, 215902),
(215903, '1.10.10.10-FF-000002', NULL, 'RNA polymerase sigma factor SigA', 77, NULL, NULL, 215903),
(215904, '3.30.260.10-FF-000083', NULL, NULL, 14, NULL, NULL, 215904),
(215905, '3.30.930.10-FF-000044', NULL, 'Lysine--tRNA ligase', 370, NULL, NULL, 215905),
(215906, '3.30.160.20-FF-000139', NULL, 'Interferon-induced, double-stranded RNA-activated protein kinase', 83, NULL, NULL, 215906),
(215907, '3.60.20.10-FF-000075', NULL, 'Asparagine synthase (Glutamine-hydrolyzing)', 201, NULL, NULL, 215907),
(215908, '2.80.10.50-FF-000121', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 126, NULL, NULL, 215908),
(215909, '1.10.238.10-FF-001279', NULL, 'Uncharacterized protein', 71, NULL, NULL, 215909),
(215910, '3.40.50.720-FF-000188', NULL, 'NAD(P) transhydrogenase alpha subunit 1', 185, NULL, NULL, 215910);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(215911, '1.25.10.10-FF-001256', NULL, 'Armadillo repeat-containing protein', 380, NULL, NULL, 215911),
(215912, '3.40.1110.10-FF-000361', NULL, NULL, 125, NULL, NULL, 215912),
(215913, '3.30.160.60-FF-005249', NULL, NULL, 81, NULL, NULL, 215913),
(215914, '3.40.1390.20-FF-000013', NULL, 'HPr kinase/phosphorylase', 131, NULL, NULL, 215914),
(215915, '3.40.50.300-FF-001692', NULL, 'Unplaced genomic scaffold supercont2.18, whole genome shotgun sequence', 194, NULL, NULL, 215915),
(215916, '3.40.50.150-FF-001282', NULL, NULL, 221, NULL, NULL, 215916),
(215917, '3.20.20.150-FF-000049', NULL, 'Sugar phosphate isomerase/epimerase', 268, NULL, NULL, 215917),
(215918, '3.90.1150.10-FF-000397', NULL, 'Uncharacterized protein', 26, NULL, NULL, 215918),
(215919, '1.20.120.1240-FF-000047', NULL, 'Dynamin', 244, NULL, NULL, 215919),
(215920, '1.10.10.60-FF-001063', NULL, NULL, 101, NULL, NULL, 215920),
(215921, '1.10.30.10-FF-000110', NULL, 'Polybromo 1', 73, NULL, NULL, 215921),
(215922, '3.40.1390.10-FF-000010', NULL, 'UDP-3-O-acylglucosamine N-acyltransferase', 98, NULL, NULL, 215922),
(215923, '3.50.50.60-FF-000659', NULL, 'Rab proteins geranylgeranyltransferase component A', 81, NULL, NULL, 215923),
(215924, '3.90.190.10-FF-000243', NULL, 'Uncharacterized protein', 144, NULL, NULL, 215924),
(215925, '1.20.1740.10-FF-000050', NULL, 'MGC157082 protein', 419, NULL, NULL, 215925),
(215926, '1.10.730.20-FF-000004', NULL, 'Isoleucyl-tRNA synthetase, putative', 301, NULL, NULL, 215926),
(215927, '3.60.40.10-FF-000183', NULL, 'Adenylate cyclase', 287, NULL, NULL, 215927),
(215928, '1.10.510.10-FF-003234', NULL, NULL, 124, NULL, NULL, 215928),
(215929, '3.40.850.10-FF-000283', NULL, 'Putative inactive kinesin-like protein KIN-7B', 161, NULL, NULL, 215929),
(215930, '1.10.3450.40-FF-000022', NULL, NULL, 50, NULL, NULL, 215930),
(215931, '3.80.10.10-FF-002097', NULL, 'Predicted protein', 262, NULL, NULL, 215931),
(215932, '3.20.20.140-FF-000046', NULL, 'Glutamate-ammonia ligase', 382, NULL, NULL, 215932),
(215933, '1.10.630.10-FF-000292', NULL, 'Cytochrome P450 family 2 subfamily U member 1', 301, NULL, NULL, 215933),
(215934, '3.20.70.20-FF-000021', NULL, 'Ribonucleoside-diphosphate reductase large subunit', 660, NULL, NULL, 215934),
(215935, '1.25.40.860-FF-000024', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 79, NULL, NULL, 215935),
(215936, '3.90.70.80-FF-000081', NULL, 'Uncharacterized protein', 111, NULL, NULL, 215936),
(215937, '3.40.50.2300-FF-001127', NULL, NULL, 63, NULL, NULL, 215937),
(215938, '2.130.10.10-FF-001293', NULL, 'UTP4, small subunit processome component', 89, NULL, NULL, 215938),
(215939, '3.30.160.60-FF-001539', NULL, 'Zinc finger protein 521', 71, NULL, NULL, 215939),
(215940, '1.10.10.60-FF-000787', NULL, NULL, 63, NULL, NULL, 215940),
(215941, '1.20.1070.10-FF-000650', NULL, 'uncharacterized protein LOC104265789', 145, NULL, NULL, 215941),
(215942, '3.30.160.60-FF-001197', NULL, 'Uncharacterized protein', 29, NULL, NULL, 215942),
(215943, '2.60.40.10-FF-001326', NULL, 'Interleukin 1 receptor type 2', 106, NULL, NULL, 215943),
(215944, '1.10.8.10-FF-000254', NULL, 'baculoviral IAP repeat-containing protein 3', 64, NULL, NULL, 215944),
(215945, '2.40.50.40-FF-000027', NULL, 'DNA-binding response regulator', 70, NULL, NULL, 215945),
(215946, '1.25.40.180-FF-000028', NULL, 'ARM repeat superfamily protein', 169, NULL, NULL, 215946),
(215947, '2.60.220.50-FF-000027', NULL, 'Adhesion G protein-coupled receptor B3', 46, NULL, NULL, 215947),
(215948, '2.60.40.10-FF-005036', NULL, NULL, 103, NULL, NULL, 215948),
(215949, '3.40.50.300-FF-002310', NULL, 'Origin of replication complex subunit 5', 182, NULL, NULL, 215949),
(215950, '3.30.1120.30-FF-000033', NULL, 'Serine/threonine-protein kinase PLK', 131, NULL, NULL, 215950),
(215951, '2.60.220.30-FF-000021', NULL, 'Netrin receptor unc-5', 137, NULL, NULL, 215951),
(215952, '3.30.70.330-FF-000774', NULL, 'Polyadenylate-binding protein', 87, NULL, NULL, 215952),
(215953, '3.40.50.720-FF-002442', NULL, 'Putative 2-dehydropantoate 2-reductase', 147, NULL, NULL, 215953); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(215954, '1.20.58.60-FF-000711', NULL, 'Uncharacterized protein', 109, NULL, NULL, 215954),
(215955, '3.50.50.60-FF-001154', NULL, 'Uncharacterized protein', 66, NULL, NULL, 215955),
(215956, '1.20.1280.50-FF-000115', NULL, 'F-box protein At4g02760-like', 78, NULL, NULL, 215956),
(215957, '2.20.25.10-FF-000112', NULL, 'DNA-directed RNA polymerase subunit', 55, NULL, NULL, 215957),
(215958, '3.40.630.30-FF-000401', NULL, 'Histone acetyltransferase, type b catalytic subunit', 109, NULL, NULL, 215958),
(215959, '2.30.30.100-FF-000049', NULL, 'Small nuclear ribonucleoprotein-associated protein B', 84, NULL, NULL, 215959),
(215960, '1.20.1280.290-FF-000073', NULL, 'Bidirectional sugar transporter SWEET', 90, NULL, NULL, 215960),
(215961, '3.40.50.410-FF-000319', NULL, 'Collagen, type XIV, alpha 1a', 98, NULL, NULL, 215961),
(215962, '3.20.20.70-FF-000403', NULL, 'Glycolate oxidase, putative', 244, NULL, NULL, 215962),
(215963, '1.25.40.10-FF-002388', NULL, 'Os01g0959600 protein', 299, NULL, NULL, 215963),
(215964, '1.25.40.700-FF-000004', NULL, 'Uncharacterized protein', 132, NULL, NULL, 215964),
(215965, '1.25.40.10-FF-002949', NULL, 'Uncharacterized protein', 143, NULL, NULL, 215965),
(215966, '1.10.472.10-FF-000486', NULL, 'Uncharacterized protein', 148, NULL, NULL, 215966),
(215967, '3.30.428.10-FF-000079', NULL, 'Uncharacterized protein', 82, NULL, NULL, 215967),
(215968, '2.60.40.420-FF-000045', NULL, 'Laccase 2', 187, NULL, NULL, 215968),
(215969, '2.70.160.11-FF-000043', NULL, 'Uncharacterized protein', 32, NULL, NULL, 215969),
(215970, '1.10.150.20-FF-000269', NULL, 'Uncharacterized protein', 56, NULL, NULL, 215970),
(215971, '2.30.29.30-FF-000149', NULL, 'Tyrosine-protein phosphatase non-receptor type', 91, NULL, NULL, 215971),
(215972, '2.130.10.10-FF-005345', NULL, 'U3 small nucleolar RNA-associated protein 4 homolog', 181, NULL, NULL, 215972),
(215973, '3.40.1440.60-FF-000007', NULL, 'Primosomal protein N''', 93, NULL, NULL, 215973),
(215974, '3.90.650.10-FF-000048', NULL, 'Os01g0888500 protein', 96, NULL, NULL, 215974),
(215975, '3.40.50.1820-FF-000702', NULL, 'Carboxylic ester hydrolase', 556, NULL, NULL, 215975),
(215976, '1.10.287.470-FF-000007', NULL, 'HlyD family efflux transporter periplasmic adaptor subunit', 75, NULL, NULL, 215976),
(215977, '1.25.40.710-FF-000007', NULL, 'Tripeptidyl-peptidase 2', 303, NULL, NULL, 215977),
(215978, '3.20.20.70-FF-000061', NULL, 'Glutamate synthase large subunit', 415, NULL, NULL, 215978),
(215979, '3.30.70.1230-FF-000123', NULL, 'Adenylate cyclase (ATP pyrophosphate-lyase) (Adenylyl cyclase)', 199, NULL, NULL, 215979),
(215980, '3.40.1170.60-FF-000014', NULL, 'Related to DNA polymerase kappa', 51, NULL, NULL, 215980),
(215981, '2.130.10.10-FF-001635', NULL, 'Activating molecule in BECN1-regulated autophagy protein 1', 171, NULL, NULL, 215981),
(215982, '3.30.40.10-FF-000903', NULL, 'E3 ubiquitin-protein ligase SNT2', 83, NULL, NULL, 215982),
(215983, '3.40.50.11550-FF-000001', NULL, 'Protein RETICULATA-RELATED 6, chloroplastic', 209, NULL, NULL, 215983),
(215984, '1.25.40.10-FF-003225', NULL, 'Pentatricopeptide repeat-containing protein', 59, NULL, NULL, 215984),
(215985, '4.10.1000.10-FF-000117', NULL, 'Predicted protein', 69, NULL, NULL, 215985),
(215986, '1.10.600.10-FF-000026', NULL, 'NADH dehydrogenase (Ubiquinone) complex I, assembly factor 6', 278, NULL, NULL, 215986),
(215987, '1.20.5.1930-FF-000010', NULL, 'Sensor histidine kinase', 86, NULL, NULL, 215987),
(215988, '3.30.450.20-FF-000572', NULL, 'Uncharacterized protein', 100, NULL, NULL, 215988),
(215989, '3.40.1110.10-FF-000029', NULL, 'Phospholipid-transporting ATPase', 156, NULL, NULL, 215989),
(215990, '3.40.50.150-FF-001624', NULL, NULL, 244, NULL, NULL, 215990),
(215991, '3.30.70.330-FF-001050', NULL, 'Putative RNA-binding protein', 122, NULL, NULL, 215991),
(215992, '1.10.287.460-FF-000004', NULL, 'Peptidyl-prolyl cis-trans isomerase', 116, NULL, NULL, 215992),
(215993, '1.10.630.10-FF-000634', NULL, 'Uncharacterized protein', 226, NULL, NULL, 215993),
(215994, '4.10.240.10-FF-000200', NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', 74, NULL, NULL, 215994);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(215995, '3.20.20.80-FF-000064', NULL, 'Oligo-1,6-glucosidase', 399, NULL, NULL, 215995),
(215996, '3.40.50.300-FF-002035', NULL, 'DEAD/DEAH box ATP-dependent RNA helicase, putative', 154, NULL, NULL, 215996),
(215997, '2.130.10.10-FF-000556', NULL, 'Syntaxin binding protein 5', 188, NULL, NULL, 215997),
(215998, '1.20.1310.10-FF-000208', NULL, NULL, 173, NULL, NULL, 215998),
(215999, '2.60.40.10-FF-002669', NULL, 'Sensory AXon guidance', 95, NULL, NULL, 215999),
(216000, '4.10.240.10-FF-000071', NULL, 'Uncharacterized protein', 48, NULL, NULL, 216000),
(216001, '3.40.50.150-FF-000556', NULL, 'Probable protein-L-isoaspartate O-methyltransferase', 225, NULL, NULL, 216001),
(216002, '3.30.200.20-FF-000211', NULL, 'Putative cyclin-dependent kinase 20', 84, NULL, NULL, 216002),
(216003, '3.30.70.330-FF-000931', NULL, 'Serine/arginine-rich-splicing factor SR34', 72, NULL, NULL, 216003),
(216004, '3.80.10.10-FF-000635', NULL, 'F-box/LRR-repeat protein 17 isoform X1', 82, NULL, NULL, 216004),
(216005, '1.10.287.110-FF-000439', NULL, 'Chaperone DnaJ-domain superfamily protein', 72, NULL, NULL, 216005),
(216006, '2.40.240.10-FF-000049', NULL, '50S ribosomal protein L25', 92, NULL, NULL, 216006),
(216007, '3.30.230.130-FF-000037', NULL, 'Protein CBR-CUL-4', 166, NULL, NULL, 216007),
(216008, '1.20.920.10-FF-000076', NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', 119, NULL, NULL, 216008),
(216009, '1.10.8.270-FF-000157', NULL, 'Predicted protein', 133, NULL, NULL, 216009),
(216010, '2.102.10.10-FF-000035', NULL, 'Chlorophyllide a oxygenase, chloroplastic', 123, NULL, NULL, 216010),
(216011, '1.20.120.1080-FF-000089', NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase, putative', 101, NULL, NULL, 216011),
(216012, '3.30.230.70-FF-000093', NULL, 'Uncharacterized protein', 272, NULL, NULL, 216012),
(216013, '2.60.40.60-FF-000453', NULL, 'Protocadherin 7', 55, NULL, NULL, 216013),
(216014, '1.10.418.10-FF-000192', NULL, 'Uncharacterized protein', 101, NULL, NULL, 216014),
(216015, '3.30.230.10-FF-000182', NULL, 'DNA mismatch repair protein MLH3', 152, NULL, NULL, 216015),
(216016, '3.30.200.20-FF-000683', NULL, 'Uncharacterized protein', 91, NULL, NULL, 216016),
(216017, '1.20.120.1240-FF-000013', NULL, 'Dynamin-related protein 3A', 211, NULL, NULL, 216017),
(216018, '2.40.50.1060-FF-000020', NULL, 'Uncharacterized protein', 132, NULL, NULL, 216018),
(216019, '3.30.420.40-FF-000380', NULL, 'Putative chromatin remodeling complex subunit (Arp5)', 28, NULL, NULL, 216019),
(216020, '2.60.220.30-FF-000015', NULL, 'Unc-5, isoform B', 158, NULL, NULL, 216020),
(216021, '3.30.70.330-FF-001387', NULL, 'Multiple RNA-binding domain-containing protein 1', 201, NULL, NULL, 216021),
(216022, '1.20.58.390-FF-000319', NULL, 'Uncharacterized protein', 70, NULL, NULL, 216022),
(216023, '3.30.160.60-FF-004243', NULL, NULL, 39, NULL, NULL, 216023),
(216024, '3.30.200.20-FF-001672', NULL, 'AGAP007598-PA', 81, NULL, NULL, 216024),
(216025, '3.40.30.10-FF-001127', NULL, 'Uncharacterized protein', 77, NULL, NULL, 216025),
(216026, '3.80.10.10-FF-001624', NULL, 'Uncharacterized protein', 184, NULL, NULL, 216026),
(216027, '3.40.30.10-FF-000138', NULL, 'Thioredoxin family protein', 81, NULL, NULL, 216027),
(216028, '3.10.450.220-FF-000005', NULL, 'Uncharacterized protein', 45, NULL, NULL, 216028),
(216029, '1.10.510.10-FF-000547', NULL, 'serine/threonine-protein kinase Nek3 isoform X2', 191, NULL, NULL, 216029),
(216030, '3.40.50.450-FF-000056', NULL, '6-phosphofructokinase', 179, NULL, NULL, 216030),
(216031, '2.60.40.10-FF-003658', NULL, NULL, 90, NULL, NULL, 216031),
(216032, '1.10.238.10-FF-001083', NULL, 'Defective in cullin neddylation protein 1', 99, NULL, NULL, 216032),
(216033, '2.60.120.10-FF-000384', NULL, 'Lysophospholipase NTE1', 112, NULL, NULL, 216033),
(216034, '3.30.160.60-FF-003254', NULL, 'Zinc finger protein 561', 28, NULL, NULL, 216034),
(216035, '1.10.1650.10-FF-000005', NULL, 'Uncharacterized protein', 39, NULL, NULL, 216035),
(216036, '1.20.58.1120-FF-000020', NULL, 'Putative dynein heavy chain', 158, NULL, NULL, 216036);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(216037, '3.30.70.330-FF-001920', NULL, NULL, 150, NULL, NULL, 216037),
(216038, '1.10.287.70-FF-000106', NULL, 'Potassium channel subfamily K member 4', 291, NULL, NULL, 216038),
(216039, '2.130.10.10-FF-004890', NULL, 'Uncharacterized protein', 116, NULL, NULL, 216039),
(216040, '3.60.20.10-FF-000210', NULL, NULL, 184, NULL, NULL, 216040),
(216041, '3.30.160.60-FF-004682', NULL, NULL, 32, NULL, NULL, 216041),
(216042, '1.10.630.10-FF-000174', NULL, 'Similar to cytochrome P450 monooxygenase', 491, NULL, NULL, 216042),
(216043, '1.25.10.10-FF-002560', NULL, 'Uncharacterized protein', 171, NULL, NULL, 216043),
(216044, '1.20.1540.10-FF-000017', NULL, 'RHOMBOID-like protein 9, chloroplastic', 189, NULL, NULL, 216044),
(216045, '3.40.50.300-FF-003024', NULL, 'Activator 1 40 kDa subunit, putative', 162, NULL, NULL, 216045),
(216046, '1.10.3810.10-FF-000007', NULL, 'Penicillin-binding protein 1A', 202, NULL, NULL, 216046),
(216047, '2.40.160.10-FF-000048', NULL, 'Zinc-regulated TonB-dependent zinc receptor', 352, NULL, NULL, 216047),
(216048, '1.10.1370.30-FF-000029', NULL, 'Angiotensin-converting enzyme', 297, NULL, NULL, 216048),
(216049, '2.60.40.1730-FF-000042', NULL, 'Aminopeptidase', 216, NULL, NULL, 216049),
(216050, '3.40.50.300-FF-004805', NULL, '6-phosphofructo-2-kinase/fructose-2, 6-bisphosphatase', 209, NULL, NULL, 216050),
(216051, '3.40.50.2000-FF-000554', NULL, 'Glycosyltransferase', 242, NULL, NULL, 216051),
(216052, '3.40.50.10330-FF-000079', NULL, 'Ceramide kinase-like isoform 5', 116, NULL, NULL, 216052),
(216053, '1.20.1070.10-FF-001280', NULL, 'Uncharacterized protein', 258, NULL, NULL, 216053),
(216054, '3.30.70.330-FF-002376', NULL, NULL, 102, NULL, NULL, 216054),
(216055, '1.10.510.10-FF-000108', NULL, 'L-type lectin-domain containing receptor kinase S.4', 208, NULL, NULL, 216055),
(216056, '1.10.510.10-FF-001536', NULL, 'Uncharacterized protein', 188, NULL, NULL, 216056),
(216057, '3.90.550.50-FF-000171', NULL, 'Uncharacterized protein', 264, NULL, NULL, 216057),
(216058, '1.25.40.10-FF-004153', NULL, 'Uncharacterized protein', 110, NULL, NULL, 216058),
(216059, '3.30.450.20-FF-000403', NULL, 'Diguanylate cyclase', 106, NULL, NULL, 216059),
(216060, '1.20.1250.20-FF-002044', NULL, 'Uncharacterized protein', 317, NULL, NULL, 216060),
(216061, '1.20.1070.10-FF-002089', NULL, 'Uncharacterized protein', 303, NULL, NULL, 216061),
(216062, '1.50.40.10-FF-000199', NULL, 'Predicted protein', 149, NULL, NULL, 216062),
(216063, '2.120.10.30-FF-000383', NULL, 'Uncharacterized protein', 311, NULL, NULL, 216063),
(216064, '3.20.20.190-FF-000134', NULL, NULL, 95, NULL, NULL, 216064),
(216065, '3.40.50.1820-FF-000949', NULL, 'Uncharacterized protein', 299, NULL, NULL, 216065),
(216066, '3.10.180.10-FF-000047', NULL, 'Glyoxalase/bleomycin resistance protein/dioxygenase', 120, NULL, NULL, 216066),
(216067, '1.20.1260.10-FF-000035', NULL, 'Reverse rubrerythrin-2', 126, NULL, NULL, 216067),
(216068, '3.30.1370.10-FF-000141', NULL, 'KRR1 small subunit processome component', 88, NULL, NULL, 216068),
(216069, '3.20.180.20-FF-000031', NULL, 'Dynein heavy chain domain 1', 107, NULL, NULL, 216069),
(216070, '3.30.40.10-FF-002022', NULL, 'Uncharacterized protein', 37, NULL, NULL, 216070),
(216071, '1.10.1410.10-FF-000111', NULL, 'Uncharacterized protein', 110, NULL, NULL, 216071),
(216072, '3.30.420.10-FF-000365', NULL, 'Uncharacterized protein', 269, NULL, NULL, 216072),
(216073, '3.40.50.1000-FF-000563', NULL, NULL, 115, NULL, NULL, 216073),
(216074, '1.10.3720.10-FF-000208', NULL, 'Sugar ABC transporter permease', 271, NULL, NULL, 216074),
(216075, '1.25.40.470-FF-000008', NULL, 'Intraflagellar transport protein 172 homolog', 176, NULL, NULL, 216075),
(216076, '3.40.50.300-FF-000270', NULL, 'Eukaryotic peptide chain release factor GTP-binding subunit ERF3A', 231, NULL, NULL, 216076),
(216077, '3.40.630.10-FF-000266', NULL, 'Peptide hydrolase', 293, NULL, NULL, 216077),
(216078, '3.30.200.20-FF-002009', NULL, 'Uncharacterized protein', 95, NULL, NULL, 216078),
(216079, '2.20.25.20-FF-000014', NULL, 'RBR-type E3 ubiquitin transferase', 51, NULL, NULL, 216079);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(216080, '3.30.200.20-FF-001200', NULL, 'Bifunctional tRNA (Adenosine(37)-N6)-threonylcarbamoyltransferase complex ATPase subunit type 1 TsaE/phosphotransferase', 106, NULL, NULL, 216080),
(216081, '2.180.10.10-FF-000003', NULL, 'Teneurin-1 isoform 1', 556, NULL, NULL, 216081),
(216082, '1.10.510.10-FF-002964', NULL, 'Tyrosine-protein kinase', 255, NULL, NULL, 216082),
(216083, '3.90.1480.20-FF-000031', NULL, 'GalNAc alpha 2,6-sialyltransferase', 321, NULL, NULL, 216083),
(216084, '3.80.10.10-FF-003069', NULL, 'F-box and leucine-rich repeat protein 17', 135, NULL, NULL, 216084),
(216085, '2.10.60.10-FF-000076', NULL, 'Receptor protein serine/threonine kinase', 65, NULL, NULL, 216085),
(216086, '1.25.40.20-FF-000148', NULL, 'cyclin-dependent kinase 4 inhibitor C', 168, NULL, NULL, 216086),
(216087, '1.25.40.10-FF-003197', NULL, 'Pentatricopeptide repeat-containing protein At1g74900, mitochondrial', 93, NULL, NULL, 216087),
(216088, '1.20.1250.20-FF-001847', NULL, 'Monocarboxylate transporter, putative', 134, NULL, NULL, 216088),
(216089, '3.30.160.60-FF-005671', NULL, NULL, 27, NULL, NULL, 216089),
(216090, '1.10.8.60-FF-000325', NULL, 'ATP-dependent zinc metallopeptidase, putative', 74, NULL, NULL, 216090),
(216091, '3.30.40.10-FF-000044', NULL, 'Regulating synaptic membrane exocytosis protein 2', 149, NULL, NULL, 216091),
(216092, '6.20.10.30-FF-000013', NULL, 'DNA ligase', 39, NULL, NULL, 216092),
(216093, '3.90.132.10-FF-000030', NULL, 'Uncharacterized protein', 122, NULL, NULL, 216093),
(216094, '3.40.50.1820-FF-000157', NULL, 'Triacylglycerol lipase', 337, NULL, NULL, 216094),
(216095, '3.10.20.30-FF-000010', NULL, 'Molybdopterin synthase sulfur carrier subunit', 80, NULL, NULL, 216095),
(216096, '1.10.1870.10-FF-000016', NULL, 'Uncharacterized protein', 87, NULL, NULL, 216096),
(216097, '2.20.70.10-FF-000172', NULL, 'HECT, C2 and WW domain containing E3 ubiquitin protein ligase 2', 26, NULL, NULL, 216097),
(216098, '1.20.1050.10-FF-000109', NULL, 'Glutathione S-transferase, putative', 131, NULL, NULL, 216098),
(216099, '2.130.10.10-FF-002973', NULL, 'Chromatin assembly factor 1 subunit FAS2', 217, NULL, NULL, 216099),
(216100, '1.20.5.300-FF-000012', NULL, 'Spike glycoprotein', 96, NULL, NULL, 216100),
(216101, '1.10.510.10-FF-004442', NULL, NULL, 48, NULL, NULL, 216101),
(216102, '2.40.50.100-FF-000129', NULL, 'ABC transporter related protein', 50, NULL, NULL, 216102),
(216103, '3.90.45.10-FF-000018', NULL, 'Peptide deformylase', 184, NULL, NULL, 216103),
(216104, '1.25.40.450-FF-000002', NULL, 'Putative non-repetitive nucleoporin', 162, NULL, NULL, 216104),
(216105, '1.10.441.10-FF-000010', NULL, 'Mannose-6-phosphate isomerase, class I', 103, NULL, NULL, 216105),
(216106, '1.20.144.10-FF-000126', NULL, 'Uncharacterized protein', 184, NULL, NULL, 216106),
(216107, '3.40.120.10-FF-000036', NULL, 'Phosphoacetylglucosamine mutase, putative', 184, NULL, NULL, 216107),
(216108, '3.40.1110.10-FF-000378', NULL, NULL, 152, NULL, NULL, 216108),
(216109, '2.130.10.130-FF-000047', NULL, NULL, 210, NULL, NULL, 216109),
(216110, '2.60.40.10-FF-005575', NULL, NULL, 37, NULL, NULL, 216110),
(216111, '3.40.50.410-FF-000331', NULL, 'Uncharacterized protein', 170, NULL, NULL, 216111),
(216112, '4.10.860.10-FF-000011', NULL, 'Chaperone protein ClpC1, chloroplastic', 65, NULL, NULL, 216112),
(216113, '1.20.1250.20-FF-001408', NULL, 'Transporter, MFS superfamily protein', 185, NULL, NULL, 216113),
(216114, '3.30.9.10-FF-000191', NULL, 'Uncharacterized protein', 189, NULL, NULL, 216114),
(216115, '1.10.238.10-FF-000094', NULL, 'ninein isoform X7', 72, NULL, NULL, 216115),
(216116, '3.30.2060.10-FF-000005', NULL, 'Transcription-repair-coupling factor', 86, NULL, NULL, 216116),
(216117, '2.60.40.10-FF-001860', NULL, 'Sucrose nonfermenting 4-like protein', 87, NULL, NULL, 216117),
(216118, '1.10.720.10-FF-000001', NULL, 'Transcription termination factor Rho', 47, NULL, NULL, 216118),
(216119, '2.40.10.10-FF-000414', NULL, NULL, 44, NULL, NULL, 216119),
(216120, '3.30.565.10-FF-000251', NULL, 'Sensor histide kinase', 150, NULL, NULL, 216120);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(216121, '3.90.1150.10-FF-000329', NULL, 'Predicted protein', 133, NULL, NULL, 216121),
(216122, '3.40.50.10810-FF-000161', NULL, 'SNF2 family N-terminal domain-domain-containing protein', 268, NULL, NULL, 216122),
(216123, '3.90.550.10-FF-000299', NULL, 'Translation initiation factor eIF-2B epsilon subunit, putative', 261, NULL, NULL, 216123),
(216124, '2.60.220.50-FF-000140', NULL, 'Uncharacterized protein', 199, NULL, NULL, 216124),
(216125, '3.30.420.10-FF-000718', NULL, NULL, 80, NULL, NULL, 216125),
(216126, '2.70.150.10-FF-000187', NULL, 'Calcium-transporting ATPase', 158, NULL, NULL, 216126),
(216127, '3.30.160.60-FF-002265', NULL, 'Specific RNA polymerase II transcription factor', 32, NULL, NULL, 216127),
(216128, '1.20.1250.20-FF-000919', NULL, 'Uncharacterized protein, isoform A', 381, NULL, NULL, 216128),
(216129, '2.60.200.20-FF-000242', NULL, 'FHA domain-containing protein DDL', 204, NULL, NULL, 216129),
(216130, '3.30.420.140-FF-000010', NULL, 'Putative pre-16S rRNA nuclease', 142, NULL, NULL, 216130),
(216131, '3.10.20.90-FF-000393', NULL, 'Autophagy protein 5', 133, NULL, NULL, 216131),
(216132, '2.10.25.10-FF-001607', NULL, 'Uncharacterized protein', 43, NULL, NULL, 216132),
(216133, '3.40.50.720-FF-001941', NULL, 'Uncharacterized protein', 271, NULL, NULL, 216133),
(216134, '1.10.472.10-FF-000654', NULL, 'Uncharacterized protein', 102, NULL, NULL, 216134),
(216135, '1.10.3730.10-FF-000006', NULL, 'Pyrroline-5-carboxylate reductase', 113, NULL, NULL, 216135),
(216136, '3.90.70.10-FF-000503', NULL, 'Uncharacterized protein', 396, NULL, NULL, 216136),
(216137, '1.10.150.670-FF-000006', NULL, 'Crossover junction endonuclease mus81', 79, NULL, NULL, 216137),
(216138, '1.10.510.10-FF-003953', NULL, NULL, 54, NULL, NULL, 216138),
(216139, '1.10.10.60-FF-001001', NULL, NULL, 65, NULL, NULL, 216139),
(216140, '1.20.1250.20-FF-001908', NULL, 'Uncharacterized protein', 237, NULL, NULL, 216140),
(216141, '3.30.70.980-FF-000013', NULL, 'Probable transcriptional regulatory protein SAMN02910431_03073', 74, NULL, NULL, 216141),
(216142, '3.30.160.60-FF-006160', NULL, NULL, 77, NULL, NULL, 216142),
(216143, '1.25.10.10-FF-000143', NULL, 'ADP-ribosylation factor guanine nucleotide-exchange factor 2 (brefeldin A-inhibited)', 331, NULL, NULL, 216143),
(216144, '2.60.300.12-FF-000024', NULL, NULL, 107, NULL, NULL, 216144),
(216145, '3.40.50.720-FF-000952', NULL, 'Oxidoreductase/ transcriptional repressor', 151, NULL, NULL, 216145),
(216146, '1.10.10.2360-FF-000006', NULL, 'F2K11.11', 38, NULL, NULL, 216146),
(216147, '2.60.40.10-FF-004586', NULL, NULL, 116, NULL, NULL, 216147),
(216148, '3.40.1280.10-FF-000036', NULL, 'MRM1p Ribose methyltransferase', 173, NULL, NULL, 216148),
(216149, '3.30.870.10-FF-000185', NULL, 'Tyrosyl-DNA phosphodiesterase 1', 131, NULL, NULL, 216149),
(216150, '3.40.1810.10-FF-000032', NULL, 'MADS transcription factor', 86, NULL, NULL, 216150),
(216151, '1.20.5.1700-FF-000008', NULL, 'transforming acidic coiled-coil-containing protein 2 isoform X2', 31, NULL, NULL, 216151),
(216152, '3.30.160.60-FF-006008', NULL, NULL, 36, NULL, NULL, 216152),
(216153, '1.10.150.110-FF-000007', NULL, 'CCAAT-box DNA binding protein subunit B', 72, NULL, NULL, 216153),
(216154, '3.40.30.10-FF-000290', NULL, 'Redoxin', 152, NULL, NULL, 216154),
(216155, '3.40.50.2300-FF-001482', NULL, NULL, 136, NULL, NULL, 216155),
(216156, '1.10.10.10-FF-001891', NULL, 'Transcriptional regulator (FurR family)', 91, NULL, NULL, 216156),
(216157, '2.60.120.200-FF-000095', NULL, 'Lectin family integral membrane protein', 231, NULL, NULL, 216157),
(216158, '4.10.60.10-FF-000111', NULL, 'AAEL017419-PA', 25, NULL, NULL, 216158),
(216159, '3.40.309.10-FF-000093', NULL, 'Uncharacterized protein', 145, NULL, NULL, 216159),
(216160, '1.25.40.10-FF-005142', NULL, 'ABC transporter, membrane protein', 98, NULL, NULL, 216160),
(216161, '3.20.20.80-FF-000423', NULL, 'Glycoprotein endo-alpha-1,2-mannosidase, putative', 340, NULL, NULL, 216161),
(216162, '2.130.10.10-FF-001984', NULL, '3-carboxy-cis,cis-mucoante lactonizing enzyme', 375, NULL, NULL, 216162);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(216163, '2.60.120.260-FF-000034', NULL, 'furin isoform X2', 132, NULL, NULL, 216163),
(216164, '3.20.20.70-FF-000566', NULL, 'Delta-aminolevulinic acid dehydratase', 328, NULL, NULL, 216164),
(216165, '3.30.200.20-FF-002509', NULL, 'Uncharacterized protein', 114, NULL, NULL, 216165),
(216166, '1.10.30.10-FF-000054', NULL, 'Swi snf-related matrix-associated actin-dependent regulator of', 80, NULL, NULL, 216166),
(216167, '2.130.10.10-FF-002473', NULL, 'Transducin family protein / WD-40 repeat family protein', 174, NULL, NULL, 216167),
(216168, '3.30.9.10-FF-000252', NULL, 'Uncharacterized protein', 165, NULL, NULL, 216168),
(216169, '2.40.50.140-FF-000001', NULL, '30S ribosomal protein S12', 124, NULL, NULL, 216169),
(216170, '2.80.10.50-FF-000166', NULL, 'Protein O-mannosyl-transferase 2', 196, NULL, NULL, 216170),
(216171, '2.40.10.10-FF-000353', NULL, NULL, 106, NULL, NULL, 216171),
(216172, '3.30.40.10-FF-001033', NULL, 'MBD9', 82, NULL, NULL, 216172),
(216173, '2.30.29.30-FF-001335', NULL, 'BcDNA.GH04637', 48, NULL, NULL, 216173),
(216174, '2.40.50.100-FF-000068', NULL, 'V-type ATP synthase alpha chain', 73, NULL, NULL, 216174),
(216175, '3.30.2160.10-FF-000069', NULL, 'Uncharacterized protein', 38, NULL, NULL, 216175),
(216176, '2.30.42.10-FF-000365', NULL, 'Discs large 5, isoform C', 109, NULL, NULL, 216176),
(216177, '2.70.150.10-FF-000215', NULL, 'Putative cation-transporting ATPase', 158, NULL, NULL, 216177),
(216178, '1.10.20.10-FF-000109', NULL, 'Nuclear factor Y subunit C10', 117, NULL, NULL, 216178),
(216179, '2.130.10.10-FF-001012', NULL, 'Actin cross-linking, putative', 352, NULL, NULL, 216179),
(216180, '1.10.1410.10-FF-000050', NULL, 'Chromosome 8, whole genome shotgun sequence', 173, NULL, NULL, 216180),
(216181, '1.10.510.10-FF-002025', NULL, NULL, 141, NULL, NULL, 216181),
(216182, '3.90.550.10-FF-000619', NULL, 'UDP-N-acetyl-alpha-D-galactosamine: polypeptide N-acetylgalactosaminyltransferase 7', 207, NULL, NULL, 216182),
(216183, '1.10.1170.10-FF-000042', NULL, 'Protein bir1', 118, NULL, NULL, 216183),
(216184, '1.10.533.10-FF-000263', NULL, 'Uncharacterized protein', 64, NULL, NULL, 216184),
(216185, '2.60.40.150-FF-000368', NULL, 'SEC63 homolog, protein translocation regulator', 48, NULL, NULL, 216185),
(216186, '3.50.30.30-FF-000155', NULL, 'Os01g0740650 protein', 137, NULL, NULL, 216186),
(216187, '3.30.160.60-FF-002326', NULL, 'B-cell CLL/lymphoma 6 member B protein', 27, NULL, NULL, 216187),
(216188, '1.25.40.10-FF-000471', NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', 95, NULL, NULL, 216188),
(216189, '3.40.50.150-FF-001484', NULL, NULL, 124, NULL, NULL, 216189),
(216190, '3.10.20.90-FF-000893', NULL, 'Uncharacterized protein', 47, NULL, NULL, 216190),
(216191, '2.130.10.10-FF-001192', NULL, 'Protein SLOW WALKER 1', 175, NULL, NULL, 216191),
(216192, '3.40.50.720-FF-001441', NULL, 'Pyrrolysine synthetase', 94, NULL, NULL, 216192),
(216193, '2.30.29.230-FF-000013', NULL, 'Uncharacterized protein', 89, NULL, NULL, 216193),
(216194, '1.25.40.10-FF-003697', NULL, 'Pentatricopeptide repeat-containing protein At3g02330, mitochondrial', 121, NULL, NULL, 216194),
(216195, '3.40.50.2300-FF-000846', NULL, 'Probable metabotropic glutamate receptor mgl-1', 298, NULL, NULL, 216195),
(216196, '3.80.10.10-FF-004025', NULL, 'Uncharacterized protein', 146, NULL, NULL, 216196),
(216197, '3.30.750.24-FF-000009', NULL, 'Anti-sigma factor antagonist', 97, NULL, NULL, 216197),
(216198, '1.10.510.10-FF-002172', NULL, 'Uncharacterized protein', 189, NULL, NULL, 216198),
(216199, '3.90.550.50-FF-000232', NULL, 'Uncharacterized protein', 98, NULL, NULL, 216199),
(216200, '3.30.160.60-FF-002765', NULL, 'Si:dkey-77f5.8', 29, NULL, NULL, 216200),
(216201, '1.25.40.10-FF-003989', NULL, 'Uncharacterized protein', 215, NULL, NULL, 216201),
(216202, '1.25.40.10-FF-001752', NULL, 'WGS project CABT00000000 data, contig 2.24', 188, NULL, NULL, 216202),
(216203, '1.10.10.10-FF-001952', NULL, 'Predicted protein', 80, NULL, NULL, 216203),
(216204, '3.90.190.10-FF-000344', NULL, 'Kinetoplastid-specific dual specificity phosphatase, putative', 171, NULL, NULL, 216204);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(216205, '2.60.40.10-FF-006059', NULL, NULL, 102, NULL, NULL, 216205),
(216206, '3.40.50.300-FF-007178', NULL, 'Uncharacterized protein', 172, NULL, NULL, 216206),
(216207, '3.30.160.60-FF-004182', NULL, NULL, 46, NULL, NULL, 216207),
(216208, '2.40.70.10-FF-000362', NULL, NULL, 127, NULL, NULL, 216208),
(216209, '3.40.30.10-FF-001066', NULL, 'Glutathione peroxidase', 161, NULL, NULL, 216209),
(216210, '1.10.238.10-FF-000155', NULL, 'Glycerol-3-phosphate dehydrogenase', 115, NULL, NULL, 216210),
(216211, '3.10.100.10-FF-000008', NULL, 'collagen alpha-1(XVIII) chain isoform X1', 183, NULL, NULL, 216211),
(216212, '1.10.730.10-FF-000058', NULL, 'Leucine-tRNA ligase, putative', 171, NULL, NULL, 216212),
(216213, '2.60.40.150-FF-000076', NULL, 'multiple C2 and transmembrane domain-containing protein 2 isoform X1', 127, NULL, NULL, 216213),
(216214, '3.40.50.300-FF-000118', NULL, 'Rho-related GTP-binding protein RhoG', 182, NULL, NULL, 216214),
(216215, '3.30.70.120-FF-000014', NULL, 'DUF190 domain-containing protein', 125, NULL, NULL, 216215),
(216216, '2.130.10.10-FF-003962', NULL, 'Uncharacterized protein', 240, NULL, NULL, 216216),
(216217, '1.10.1670.10-FF-000035', NULL, 'Endonuclease III homolog', 82, NULL, NULL, 216217),
(216218, '1.10.510.10-FF-002464', NULL, 'Uncharacterized protein', 334, NULL, NULL, 216218),
(216219, '2.60.40.640-FF-000127', NULL, 'Arrestin-C', 91, NULL, NULL, 216219),
(216220, '1.20.1250.20-FF-000599', NULL, 'Sugar transporter, putative', 464, NULL, NULL, 216220),
(216221, '2.60.120.10-FF-000704', NULL, 'Predicted protein', 100, NULL, NULL, 216221),
(216222, '2.60.40.10-FF-001360', NULL, 'neurofascin isoform X1', 114, NULL, NULL, 216222),
(216223, '2.10.230.10-FF-000027', NULL, 'Uncharacterized protein', 76, NULL, NULL, 216223),
(216224, '3.30.559.10-FF-000158', NULL, 'HC-toxin synthetase', 184, NULL, NULL, 216224),
(216225, '3.30.160.60-FF-001337', NULL, 'Zinc finger protein 286A', 27, NULL, NULL, 216225),
(216226, '3.30.559.70-FF-000069', NULL, 'Carnitine palmitoyltransferase I, putative', 314, NULL, NULL, 216226),
(216227, '3.40.50.960-FF-000001', NULL, '6,7-dimethyl-8-ribityllumazine synthase', 155, NULL, NULL, 216227),
(216228, '3.30.559.10-FF-000130', NULL, 'Nonribosomal peptide synthase, putative', 177, NULL, NULL, 216228),
(216229, '1.25.40.10-FF-002236', NULL, 'Chaperone protein dnaJ', 279, NULL, NULL, 216229),
(216230, '3.30.342.10-FF-000054', NULL, 'DNA polymerase', 148, NULL, NULL, 216230),
(216231, '3.40.50.980-FF-000007', NULL, 'Acyl-CoA synthetase family member 2', 175, NULL, NULL, 216231),
(216232, '3.40.190.10-FF-000069', NULL, 'HTH-type transcriptional regulator lrhA', 94, NULL, NULL, 216232),
(216233, '3.10.129.10-FF-000271', NULL, 'Uncharacterized protein', 149, NULL, NULL, 216233),
(216234, '1.10.10.60-FF-001181', NULL, NULL, 34, NULL, NULL, 216234),
(216235, '3.30.40.10-FF-000869', NULL, 'Cellulose synthase-like protein D3', 79, NULL, NULL, 216235),
(216236, '3.40.1210.10-FF-000003', NULL, 'Survival protein SurE-like phosphatase/nucleotidase', 293, NULL, NULL, 216236),
(216237, '2.40.420.20-FF-000004', NULL, 'Macrolide transporter subunit MacA', 68, NULL, NULL, 216237),
(216238, '1.20.1250.20-FF-000419', NULL, 'Monosaccharide transporter, putative', 457, NULL, NULL, 216238),
(216239, '3.40.50.1100-FF-000267', NULL, 'Uncharacterized protein', 102, NULL, NULL, 216239),
(216240, '2.60.40.60-FF-000806', NULL, 'Uncharacterized protein (Fragment)', 56, NULL, NULL, 216240),
(216241, '1.20.1050.10-FF-000261', NULL, 'Ganglioside-induced differentiation-associated protein 1-like Protein', 133, NULL, NULL, 216241),
(216242, '3.40.190.10-FF-000310', NULL, 'Iron(III) ABC transporter substrate-binding protein', 159, NULL, NULL, 216242),
(216243, '2.40.128.250-FF-000001', NULL, 'Transferrin binding protein B', 139, NULL, NULL, 216243),
(216244, '3.30.200.20-FF-000711', NULL, 'Receptor-like protein kinase HSL1', 102, NULL, NULL, 216244),
(216245, '3.30.160.60-FF-000820', NULL, 'Zinc finger protein 512B', 93, NULL, NULL, 216245),
(216246, '1.25.40.10-FF-004214', NULL, 'Uncharacterized protein', 55, NULL, NULL, 216246);
INSERT INTO "PUBLIC"."MODEL" VALUES
(216247, '2.40.70.10-FF-000070', NULL, 'Aspartyl protease family protein', 179, NULL, NULL, 216247),
(216248, '3.50.50.60-FF-000553', NULL, 'Glutamate synthase beta subunit putative', 70, NULL, NULL, 216248),
(216249, '3.80.10.10-FF-004497', NULL, 'Os01g0821900 protein', 60, NULL, NULL, 216249),
(216250, '3.80.10.10-FF-002260', NULL, 'CD14 antigen', 105, NULL, NULL, 216250),
(216251, '1.20.1050.10-FF-000289', NULL, 'Uncharacterized protein', 58, NULL, NULL, 216251),
(216252, '2.60.40.10-FF-003597', NULL, NULL, 89, NULL, NULL, 216252),
(216253, '3.40.50.10750-FF-000002', NULL, 'NADP-dependent malic enzyme', 156, NULL, NULL, 216253),
(216254, '2.130.10.10-FF-001484', NULL, 'Os03g0145600 protein', 181, NULL, NULL, 216254),
(216255, '1.20.120.1760-FF-000079', NULL, NULL, 165, NULL, NULL, 216255),
(216256, '3.90.79.10-FF-000023', NULL, 'Peroxisomal NADH pyrophosphatase NUDT12', 141, NULL, NULL, 216256),
(216257, '1.20.1250.20-FF-000127', NULL, 'Monocarboxylate transporter 9 isoform X2', 193, NULL, NULL, 216257),
(216258, '3.40.50.300-FF-006430', NULL, 'Uncharacterized protein', 127, NULL, NULL, 216258),
(216259, '3.30.230.10-FF-000210', NULL, 'Uncharacterized protein', 137, NULL, NULL, 216259),
(216260, '3.30.420.40-FF-000441', NULL, 'Phosphotransferase', 162, NULL, NULL, 216260),
(216261, '3.20.20.100-FF-000208', NULL, 'Uncharacterized protein', 152, NULL, NULL, 216261),
(216262, '3.40.190.10-FF-000602', NULL, 'Chorismate mutase/prephenate dehydratase', 87, NULL, NULL, 216262),
(216263, '1.25.40.10-FF-002528', NULL, 'SGS domain-domain-containing protein', 129, NULL, NULL, 216263),
(216264, '1.10.8.960-FF-000004', NULL, 'Glutamate--cysteine ligase', 66, NULL, NULL, 216264),
(216265, '1.10.390.10-FF-000019', NULL, 'Aminopeptidase', 254, NULL, NULL, 216265),
(216266, '3.30.70.2460-FF-000003', NULL, 'DNA-repair protein, putative', 77, NULL, NULL, 216266),
(216267, '3.30.200.20-FF-000183', NULL, 'Probable multifunctional protein ADE2', 79, NULL, NULL, 216267),
(216268, '3.30.470.160-FF-000009', NULL, 'Kinase', 220, NULL, NULL, 216268),
(216269, '2.70.170.10-FF-000250', NULL, 'Nicotinic acetylcholine receptor subunit', 226, NULL, NULL, 216269),
(216270, '2.10.25.10-FF-001754', NULL, 'Predicted protein', 56, NULL, NULL, 216270),
(216271, '3.10.110.10-FF-000245', NULL, 'Uncharacterized protein', 126, NULL, NULL, 216271),
(216272, '3.90.1100.10-FF-000057', NULL, 'DNA-directed RNA polymerase subunit beta', 187, NULL, NULL, 216272),
(216273, '3.30.565.10-FF-000543', NULL, 'Two-component response regulator, sigma factor PP2C-like phosphatase', 129, NULL, NULL, 216273),
(216274, '3.80.10.10-FF-003980', NULL, 'Protein phosphatase 2C, putative', 159, NULL, NULL, 216274),
(216275, '3.30.60.60-FF-000009', NULL, 'Histone acetyltransferase', 53, NULL, NULL, 216275),
(216276, '1.20.1530.20-FF-000048', NULL, 'Solute carrier family 10, member 4', 94, NULL, NULL, 216276),
(216277, '3.40.50.1820-FF-000449', NULL, 'GPI inositol-deacylase', 209, NULL, NULL, 216277),
(216278, '2.60.40.60-FF-000953', NULL, 'Predicted protein', 104, NULL, NULL, 216278),
(216279, '2.60.120.1190-FF-000003', NULL, 'Discoidin domain-containing receptor 2', 182, NULL, NULL, 216279),
(216280, '3.40.50.2300-FF-000054', NULL, 'RbsB (Ribose ABC transporter)', 114, NULL, NULL, 216280),
(216281, '3.40.50.1820-FF-001085', NULL, 'Serine peptidase, family S28, putative (AFU_orthologue AFUA_4G03790)', 191, NULL, NULL, 216281),
(216282, '3.40.640.10-FF-000031', NULL, 'Kynureninase', 273, NULL, NULL, 216282),
(216283, '3.40.390.10-FF-000230', NULL, NULL, 105, NULL, NULL, 216283),
(216284, '3.40.50.150-FF-000056', NULL, 'Polyamine aminopropyltransferase', 221, NULL, NULL, 216284),
(216285, '3.40.50.300-FF-004452', NULL, 'ABC transporter, putative', 151, NULL, NULL, 216285),
(216286, '3.40.50.10190-FF-000082', NULL, 'Os11g0191300 protein', 82, NULL, NULL, 216286),
(216287, '1.10.600.10-FF-000054', NULL, 'NADH dehydrogenase (ubiquinone) complex I, assembly factor 6 homolog', 258, NULL, NULL, 216287),
(216288, '2.60.40.10-FF-000871', NULL, 'PKHD1, fibrocystin/polyductin', 69, NULL, NULL, 216288);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(216289, '2.40.30.10-FF-000444', NULL, 'Chromosome 9, whole genome shotgun sequence', 121, NULL, NULL, 216289),
(216290, '3.80.10.10-FF-000135', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 168, NULL, NULL, 216290),
(216291, '3.40.50.300-FF-003996', NULL, 'Secretion-associated RAS super family 2 isoform 1', 92, NULL, NULL, 216291),
(216292, '2.30.140.10-FF-000010', NULL, 'Spermine synthase', 53, NULL, NULL, 216292),
(216293, '1.20.1070.10-FF-001633', NULL, 'Thromboxane A2 receptor', 140, NULL, NULL, 216293),
(216294, '1.20.58.60-FF-000790', NULL, 'Uncharacterized protein', 214, NULL, NULL, 216294),
(216295, '2.60.40.1230-FF-000015', NULL, 'AP-2 complex subunit alpha', 128, NULL, NULL, 216295),
(216296, '2.10.25.10-FF-001315', NULL, 'Uncharacterized protein', 44, NULL, NULL, 216296),
(216297, '3.40.1340.10-FF-000007', NULL, 'RNA polymerase II subunit Rpb5a', 146, NULL, NULL, 216297),
(216298, '3.50.50.60-FF-000261', NULL, 'N-methyl-L-tryptophan oxidase', 168, NULL, NULL, 216298),
(216299, '3.30.230.70-FF-000121', NULL, 'Uncharacterized protein', 235, NULL, NULL, 216299),
(216300, '1.25.40.20-FF-000620', NULL, 'Receptor-interacting serine/threonine-protein kinase 4', 79, NULL, NULL, 216300),
(216301, '3.30.70.920-FF-000041', NULL, 'Transcriptional regulator, AsnC family', 90, NULL, NULL, 216301),
(216302, '1.10.510.10-FF-004150', NULL, NULL, 276, NULL, NULL, 216302),
(216303, '3.30.200.20-FF-002156', NULL, 'Uncharacterized protein', 66, NULL, NULL, 216303),
(216304, '1.10.3210.10-FF-000097', NULL, 'Metal dependent phosphohydrolase', 263, NULL, NULL, 216304),
(216305, '3.90.226.10-FF-000001', NULL, 'ATP-dependent Clp protease proteolytic subunit', 193, NULL, NULL, 216305),
(216306, '1.25.10.10-FF-000582', NULL, 'Serine/threonine-protein kinase TOR', 427, NULL, NULL, 216306),
(216307, '1.25.10.10-FF-002408', NULL, 'Uncharacterized protein', 253, NULL, NULL, 216307),
(216308, '2.30.29.30-FF-000879', NULL, 'YALI0D12540p', 116, NULL, NULL, 216308),
(216309, '1.50.10.10-FF-000079', NULL, 'Putative glycosyl hydrolase', 368, NULL, NULL, 216309),
(216310, '2.10.25.10-FF-000298', NULL, 'basement membrane-specific heparan sulfate proteoglycan core protein', 57, NULL, NULL, 216310),
(216311, '3.30.559.70-FF-000041', NULL, 'Carnitine O-palmitoyltransferase, putative', 333, NULL, NULL, 216311),
(216312, '2.40.30.10-FF-000005', NULL, 'Elongation factor 1-alpha', 108, NULL, NULL, 216312),
(216313, '3.80.10.10-FF-003541', NULL, 'Os10g0148800 protein', 160, NULL, NULL, 216313),
(216314, '2.60.40.60-FF-000514', NULL, 'GD20623', 82, NULL, NULL, 216314),
(216315, '1.20.1740.10-FF-000145', NULL, 'Solute carrier family 7 member 5', 326, NULL, NULL, 216315),
(216316, '3.10.580.10-FF-000156', NULL, 'Uncharacterized protein', 151, NULL, NULL, 216316),
(216317, '1.10.238.10-FF-000947', NULL, 'Ninein, putative', 96, NULL, NULL, 216317),
(216318, '1.25.40.20-FF-001137', NULL, 'Uncharacterized protein', 157, NULL, NULL, 216318),
(216319, '3.40.50.300-FF-007739', NULL, 'Uncharacterized protein', 83, NULL, NULL, 216319),
(216320, '3.40.50.300-FF-001046', NULL, 'Probable ATP-dependent RNA helicase ddx56', 182, NULL, NULL, 216320),
(216321, '1.20.1070.10-FF-001780', NULL, 'Uncharacterized protein', 327, NULL, NULL, 216321),
(216322, '3.40.50.280-FF-000011', NULL, 'Possible methyltransferase (Methylase)', 119, NULL, NULL, 216322),
(216323, '3.30.1330.10-FF-000048', NULL, 'Trifunctional purine biosynthetic protein adenosine-3', 33, NULL, NULL, 216323),
(216324, '1.25.10.10-FF-001099', NULL, 'Uncharacterized protein', 341, NULL, NULL, 216324),
(216325, '1.10.10.60-FF-000545', NULL, 'Unplaced genomic scaffold supercont1.28, whole genome shotgun sequence', 53, NULL, NULL, 216325),
(216326, '3.10.100.10-FF-000188', NULL, 'Uncharacterized protein', 147, NULL, NULL, 216326),
(216327, '3.40.50.360-FF-000001', NULL, 'NAD(P)H dehydrogenase (Quinone) FQR1-like', 201, NULL, NULL, 216327),
(216328, '2.60.120.200-FF-000123', NULL, 'Thrombospondin 4', 169, NULL, NULL, 216328),
(216329, '3.40.309.10-FF-000121', NULL, 'Uncharacterized protein', 81, NULL, NULL, 216329);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(216330, '3.90.79.10-FF-000170', NULL, 'Bifunctional NMN adenylyltransferase/Nudix hydrolase', 145, NULL, NULL, 216330),
(216331, '2.60.40.10-FF-000432', NULL, 'Protein tyrosine kinase 7 (inactive)', 92, NULL, NULL, 216331),
(216332, '1.10.520.10-FF-000053', NULL, 'Peroxidase', 157, NULL, NULL, 216332),
(216333, '3.30.420.610-FF-000022', NULL, 'Emb|CAB71880.1', 78, NULL, NULL, 216333),
(216334, '3.30.160.60-FF-000409', NULL, 'zinc finger protein 644 isoform X1', 30, NULL, NULL, 216334),
(216335, '1.10.287.70-FF-000578', NULL, 'Uncharacterized protein', 131, NULL, NULL, 216335),
(216336, '3.90.180.10-FF-000107', NULL, 'Alcohol dehydrogenase', 171, NULL, NULL, 216336),
(216337, '3.10.100.10-FF-000160', NULL, 'Uncharacterized protein', 136, NULL, NULL, 216337),
(216338, '2.130.10.10-FF-005227', NULL, 'Ribosome biogenesis protein WDR12 homolog', 62, NULL, NULL, 216338),
(216339, '1.10.357.10-FF-000078', NULL, 'TetR/AcrR family transcriptional regulator', 149, NULL, NULL, 216339),
(216340, '3.40.50.1240-FF-000051', NULL, 'Phosphoglycerate mutase', 215, NULL, NULL, 216340),
(216341, '1.10.357.10-FF-000050', NULL, 'TetR family transcriptional regulator', 171, NULL, NULL, 216341),
(216342, '3.30.70.330-FF-001448', NULL, 'RNA-binding protein', 124, NULL, NULL, 216342),
(216343, '2.130.10.10-FF-002501', NULL, 'Protein kinase', 111, NULL, NULL, 216343),
(216344, '1.20.1250.20-FF-001055', NULL, 'Nitrate transporter 2.2', 205, NULL, NULL, 216344),
(216345, '2.60.40.1170-FF-000003', NULL, 'Putative AP-2 complex subunit mu', 109, NULL, NULL, 216345),
(216346, '2.50.20.10-FF-000010', NULL, 'Outer-membrane lipoprotein carrier protein', 182, NULL, NULL, 216346),
(216347, '1.10.1740.140-FF-000002', NULL, 'ATP-dependent RNA helicase SUV3 homolog, mitochondrial', 122, NULL, NULL, 216347),
(216348, '3.30.160.60-FF-002618', NULL, 'Bmp-induced factor', 27, NULL, NULL, 216348),
(216349, '3.40.50.300-FF-003816', NULL, 'Si:dkey-96f10.1', 121, NULL, NULL, 216349),
(216350, '1.10.10.10-FF-000463', NULL, 'Rrf2 family transcriptional regulator', 137, NULL, NULL, 216350),
(216351, '3.40.50.360-FF-000029', NULL, 'NAD(P)H dehydrogenase [quinone] 1', 273, NULL, NULL, 216351),
(216352, '3.40.50.300-FF-004305', NULL, 'Small GTP-binding protein, putative', 172, NULL, NULL, 216352),
(216353, '2.60.40.10-FF-004614', NULL, NULL, 109, NULL, NULL, 216353),
(216354, '3.50.50.60-FF-000114', NULL, 'spermine oxidase isoform X2', 100, NULL, NULL, 216354),
(216355, '1.10.1200.10-FF-000157', NULL, 'Polyketide synthase RzxE', 96, NULL, NULL, 216355),
(216356, '2.60.40.10-FF-005103', NULL, NULL, 99, NULL, NULL, 216356),
(216357, '1.20.144.10-FF-000098', NULL, 'Diacylglycerol pyrophosphate (DGPP) phosphatase, putative', 250, NULL, NULL, 216357),
(216358, '3.40.390.10-FF-000258', NULL, NULL, 198, NULL, NULL, 216358),
(216359, '1.10.287.130-FF-000097', NULL, 'Sensor histidine kinase', 74, NULL, NULL, 216359),
(216360, '2.10.50.30-FF-000025', NULL, 'Vomeronasal 2, receptor 73', 54, NULL, NULL, 216360),
(216361, '2.30.42.10-FF-000073', NULL, 'Interacting with PRKCA', 112, NULL, NULL, 216361),
(216362, '1.10.287.770-FF-000030', NULL, 'Cyclic di-AMP synthase CdaS', 70, NULL, NULL, 216362),
(216363, '2.60.40.60-FF-000745', NULL, 'Fat-like cadherin-related tumor suppressor homolog', 108, NULL, NULL, 216363),
(216364, '3.30.310.10-FF-000036', NULL, 'Coatomer subunit gamma', 110, NULL, NULL, 216364),
(216365, '2.170.16.10-FF-000039', NULL, 'Transcription initiation factor IIB', 180, NULL, NULL, 216365),
(216366, '2.60.40.10-FF-002377', NULL, 'Muscle M-line assembly protein unc-89', 103, NULL, NULL, 216366),
(216367, '3.90.1150.10-FF-000301', NULL, 'Putative acetylornithine/succinylornithine aminotransferase family protein', 69, NULL, NULL, 216367),
(216368, '3.30.450.60-FF-000067', NULL, 'Signal sequence receptor alpha subunit', 112, NULL, NULL, 216368),
(216369, '2.30.30.40-FF-000009', NULL, 'Breast cancer anti-estrogen resistance 1', 63, NULL, NULL, 216369),
(216370, '3.40.50.10860-FF-000035', NULL, 'Shikimate dehydrogenase (NADP(+))', 117, NULL, NULL, 216370);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(216371, '2.70.170.10-FF-000278', NULL, 'Uncharacterized protein', 89, NULL, NULL, 216371),
(216372, '2.130.10.10-FF-000848', NULL, 'SNARE-dependent exocytosis protein (Sro7), putative', 296, NULL, NULL, 216372),
(216373, '3.90.1480.20-FF-000059', NULL, 'Uncharacterized protein', 97, NULL, NULL, 216373),
(216374, '3.30.160.60-FF-000320', NULL, 'Zinc finger protein 777', 29, NULL, NULL, 216374),
(216375, '1.10.287.110-FF-000147', NULL, 'JJJ2p protein', 89, NULL, NULL, 216375),
(216376, '1.10.189.10-FF-000001', NULL, 'Pyruvate, phosphate dikinase', 61, NULL, NULL, 216376),
(216377, '3.80.10.10-FF-003041', NULL, 'Leucine Rich Repeat family protein', 162, NULL, NULL, 216377),
(216378, '1.25.40.20-FF-000592', NULL, 'Water witch, isoform D', 106, NULL, NULL, 216378),
(216379, '3.20.20.70-FF-000274', NULL, 'Triosephosphate isomerase', 260, NULL, NULL, 216379),
(216380, '1.20.140.40-FF-000025', NULL, 'Pectinesterase', 147, NULL, NULL, 216380),
(216381, '3.40.190.10-FF-000541', NULL, 'Predicted protein', 95, NULL, NULL, 216381),
(216382, '3.80.10.10-FF-003569', NULL, 'Proteophosphoglycan ppg1', 146, NULL, NULL, 216382),
(216383, '3.30.40.140-FF-000008', NULL, 'Predicted protein', 64, NULL, NULL, 216383),
(216384, '1.25.40.20-FF-000648', NULL, 'Calcium-independent phospholipase A2 VIA, isoform B', 151, NULL, NULL, 216384),
(216385, '3.30.50.10-FF-000050', NULL, 'Nuclear Hormone Receptor family', 113, NULL, NULL, 216385),
(216386, '2.30.42.10-FF-000657', NULL, NULL, 116, NULL, NULL, 216386),
(216387, '3.40.50.300-FF-002327', NULL, 'DEAD-box ATP-dependent RNA helicase 26', 225, NULL, NULL, 216387),
(216388, '1.25.40.20-FF-000120', NULL, 'krev interaction trapped protein 1 isoform X1', 148, NULL, NULL, 216388),
(216389, '3.30.200.20-FF-000975', NULL, 'Protein CBG00445', 131, NULL, NULL, 216389),
(216390, '1.20.58.70-FF-000028', NULL, 'Syntaxin, Qa-SNARE family', 124, NULL, NULL, 216390),
(216391, '3.40.50.1820-FF-001646', NULL, 'Uncharacterized protein', 561, NULL, NULL, 216391),
(216392, '3.30.930.10-FF-000095', NULL, 'Phenylalanine--tRNA ligase alpha subunit', 302, NULL, NULL, 216392),
(216393, '1.25.10.10-FF-001071', NULL, 'U3 small nucleolar RNA-associated protein 10', 235, NULL, NULL, 216393),
(216394, '3.20.20.300-FF-000004', NULL, 'probable beta-D-xylosidase 7', 316, NULL, NULL, 216394),
(216395, '1.25.40.10-FF-002680', NULL, 'protein HGV2-like', 163, NULL, NULL, 216395),
(216396, '1.10.472.80-FF-000130', NULL, 'TBC domain containing protein', 128, NULL, NULL, 216396),
(216397, '2.60.40.10-FF-005042', NULL, NULL, 102, NULL, NULL, 216397),
(216398, '3.90.260.10-FF-000052', NULL, 'Predicted protein', 109, NULL, NULL, 216398),
(216399, '1.25.10.10-FF-000082', NULL, 'RING-type E3 ubiquitin transferase', 296, NULL, NULL, 216399),
(216400, '1.20.1070.10-FF-000144', NULL, 'G protein-coupled receptor 143', 284, NULL, NULL, 216400),
(216401, '2.30.30.40-FF-000392', NULL, 'SMAll', 66, NULL, NULL, 216401),
(216402, '3.40.50.2300-FF-001190', NULL, NULL, 205, NULL, NULL, 216402),
(216403, '3.30.450.40-FF-000061', NULL, 'Adenylate/guanylate cyclase catalytic domain protein', 169, NULL, NULL, 216403),
(216404, '2.40.30.10-FF-000236', NULL, 'Translation initiation factor IF-2, putative', 126, NULL, NULL, 216404),
(216405, '3.40.140.10-FF-000066', NULL, 'Chromosome 10, whole genome shotgun sequence', 171, NULL, NULL, 216405),
(216406, '2.30.29.30-FF-000054', NULL, 'PH and SEC7 domain-containing protein 3', 125, NULL, NULL, 216406),
(216407, '2.10.25.10-FF-001107', NULL, 'Uncharacterized protein', 41, NULL, NULL, 216407),
(216408, '1.10.10.790-FF-000052', NULL, NULL, 32, NULL, NULL, 216408),
(216409, '1.10.10.10-FF-000019', NULL, 'Crp/Fnr family transcriptional regulator', 78, NULL, NULL, 216409),
(216410, '2.130.10.10-FF-001837', NULL, 'THO complex subunit 3', 93, NULL, NULL, 216410),
(216411, '2.30.30.1020-FF-000015', NULL, 'Unplaced genomic scaffold supercont1.35, whole genome shotgun sequence', 205, NULL, NULL, 216411),
(216412, '1.10.287.110-FF-000091', NULL, 'Chaperone protein DNAJ, putative', 84, NULL, NULL, 216412);
INSERT INTO "PUBLIC"."MODEL" VALUES
(216413, '2.40.50.140-FF-000973', NULL, NULL, 167, NULL, NULL, 216413),
(216414, '1.25.10.20-FF-000028', NULL, 'Uncharacterized protein', 108, NULL, NULL, 216414),
(216415, '2.40.370.10-FF-000002', NULL, 'Kievitone hydratase', 161, NULL, NULL, 216415),
(216416, '3.30.70.330-FF-002404', NULL, NULL, 94, NULL, NULL, 216416),
(216417, '2.40.320.10-FF-000022', NULL, 'Putative mediator of RNA polymerase II transcription subunit 18', 161, NULL, NULL, 216417),
(216418, '2.130.10.10-FF-002029', NULL, 'Katanin p80 WD40 repeat-containing subunit B1 homolog', 197, NULL, NULL, 216418),
(216419, '1.20.5.1300-FF-000012', NULL, 'Histidinol dehydrogenase', 55, NULL, NULL, 216419),
(216420, '3.40.50.1000-FF-000271', NULL, 'Haloacid dehalogenase-like hydrolase', 156, NULL, NULL, 216420),
(216421, '3.30.2300.10-FF-000013', NULL, 'Uncharacterized protein', 83, NULL, NULL, 216421),
(216422, '3.30.70.660-FF-000002', NULL, 'tRNA pseudouridine synthase', 209, NULL, NULL, 216422),
(216423, '1.20.1070.10-FF-001572', NULL, 'Olfactory receptor', 163, NULL, NULL, 216423),
(216424, '3.30.60.20-FF-000025', NULL, 'Chimaerin', 67, NULL, NULL, 216424),
(216425, '2.60.40.10-FF-000724', NULL, 'ephrin type-A receptor 2', 91, NULL, NULL, 216425),
(216426, '3.40.50.300-FF-000562', NULL, 'Structural maintenance of chromosomes protein', 280, NULL, NULL, 216426),
(216427, '1.25.10.10-FF-002908', NULL, 'Uncharacterized protein', 122, NULL, NULL, 216427),
(216428, '1.10.10.10-FF-001391', NULL, 'Uncharacterized protein', 101, NULL, NULL, 216428),
(216429, '1.20.58.60-FF-000879', NULL, 'Spectrin repeat-containing, nuclear envelope family member 3', 174, NULL, NULL, 216429),
(216430, '3.40.47.10-FF-000002', NULL, 'Acetyl-CoA acetyltransferase', 182, NULL, NULL, 216430),
(216431, '3.40.50.2000-FF-000262', NULL, 'Trehalose-6-phosphate synthase', 235, NULL, NULL, 216431),
(216432, '3.30.2010.10-FF-000002', NULL, 'CAAX prenyl protease', 83, NULL, NULL, 216432),
(216433, '3.40.50.1100-FF-000003', NULL, 'Cystathionine beta-synthase', 114, NULL, NULL, 216433),
(216434, '3.60.21.10-FF-000173', NULL, 'Serine/threonine-protein phosphatase', 301, NULL, NULL, 216434),
(216435, '2.20.25.10-FF-000096', NULL, 'DNA-directed RNA polymerase subunit', 56, NULL, NULL, 216435),
(216436, '1.10.8.100-FF-000005', NULL, 'Ribosomal RNA small subunit methyltransferase A', 73, NULL, NULL, 216436),
(216437, '1.10.20.10-FF-000048', NULL, 'Chromatin accessibility complex subunit 1', 92, NULL, NULL, 216437),
(216438, '1.10.540.10-FF-000083', NULL, 'Acyl-CoA dehydrogenase, short-chain specific', 117, NULL, NULL, 216438),
(216439, '3.40.50.300-FF-000618', NULL, 'ATP-binding cassette (ABC) transporter, putative', 267, NULL, NULL, 216439),
(216440, '3.30.450.20-FF-000111', NULL, 'Potassium voltage-gated channel subfamily H member 5', 86, NULL, NULL, 216440),
(216441, '3.30.70.60-FF-000015', NULL, 'Pilus assembly protein PilO', 113, NULL, NULL, 216441),
(216442, '3.30.430.20-FF-000048', NULL, 'Os01g0366300 protein', 106, NULL, NULL, 216442),
(216443, '3.80.10.10-FF-001916', NULL, 'Brassinosteroid-insensitive 1', 76, NULL, NULL, 216443),
(216444, '3.30.160.60-FF-003546', NULL, NULL, 31, NULL, NULL, 216444),
(216445, '3.30.160.60-FF-002826', NULL, 'Zinc finger protein 473', 23, NULL, NULL, 216445),
(216446, '3.30.420.10-FF-000073', NULL, 'DNA polymerase epsilon catalytic subunit A', 231, NULL, NULL, 216446),
(216447, '3.30.60.30-FF-000085', NULL, 'Serine protease inhibitor Kazal-type 13', 65, NULL, NULL, 216447),
(216448, '1.10.510.10-FF-001828', NULL, 'BRSK2 isoform 14', 130, NULL, NULL, 216448),
(216449, '2.40.50.180-FF-000018', NULL, 'Purine-binding chemotaxis protein CheW', 67, NULL, NULL, 216449),
(216450, '3.10.330.10-FF-000025', NULL, 'AAA family ATPase', 111, NULL, NULL, 216450),
(216451, '3.90.70.10-FF-000650', NULL, 'HlyB/MsbA family ABC transporter', 87, NULL, NULL, 216451),
(216452, '3.60.21.60-FF-000024', NULL, 'DNA polymerase alpha subunit B', 99, NULL, NULL, 216452),
(216453, '3.50.50.60-FF-001042', NULL, 'Expressed protein', 38, NULL, NULL, 216453),
(216454, '2.160.10.10-FF-000105', NULL, 'Translation initiation factor eIF-2B subunit epsilon-like Protein', 111, NULL, NULL, 216454);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(216455, '2.10.220.10-FF-000173', NULL, 'Uncharacterized protein', 80, NULL, NULL, 216455),
(216456, '3.10.180.10-FF-000108', NULL, '4-hydroxyphenylpyruvate dioxygenase', 138, NULL, NULL, 216456),
(216457, '2.60.120.330-FF-000083', NULL, 'Predicted protein', 59, NULL, NULL, 216457),
(216458, '3.40.1370.10-FF-000043', NULL, 'Uncharacterized protein', 147, NULL, NULL, 216458),
(216459, '3.60.20.10-FF-000182', NULL, NULL, 181, NULL, NULL, 216459),
(216460, '1.25.40.10-FF-004445', NULL, 'Uncharacterized protein', 115, NULL, NULL, 216460),
(216461, '3.30.70.330-FF-002668', NULL, NULL, 141, NULL, NULL, 216461),
(216462, '2.60.40.10-FF-001388', NULL, 'ephrin type-A receptor 3-like', 84, NULL, NULL, 216462),
(216463, '3.30.160.60-FF-000792', NULL, 'Zinc finger and BTB domain-containing protein 16', 30, NULL, NULL, 216463),
(216464, '3.30.200.20-FF-000391', NULL, 'Large tumor suppressor kinase 1', 111, NULL, NULL, 216464),
(216465, '3.90.550.10-FF-000771', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 133, NULL, NULL, 216465),
(216466, '2.100.10.30-FF-000013', NULL, 'Agglutinin alpha chain', 133, NULL, NULL, 216466),
(216467, '3.30.450.40-FF-000117', NULL, 'Diguanylate cyclase-related enzyme', 151, NULL, NULL, 216467),
(216468, '1.25.10.10-FF-002852', NULL, 'Uncharacterized protein', 169, NULL, NULL, 216468),
(216469, '2.60.40.1080-FF-000009', NULL, 'Putative invasin', 88, NULL, NULL, 216469),
(216470, '3.40.50.300-FF-004513', NULL, 'DNA repair helicase TFIIH P90', 213, NULL, NULL, 216470),
(216471, '3.40.50.300-FF-005941', NULL, 'RNA helicase, putative', 193, NULL, NULL, 216471),
(216472, '2.30.30.30-FF-000063', NULL, 'Transcription elongation factor SPT5', 62, NULL, NULL, 216472),
(216473, '1.20.1640.10-FF-000053', NULL, 'PaTched Related family', 221, NULL, NULL, 216473),
(216474, '1.20.1070.10-FF-001925', NULL, 'Uncharacterized protein', 281, NULL, NULL, 216474),
(216475, '1.10.1620.20-FF-000006', NULL, 'Mitochondrial ATP synthase F1, epsilon subunit, putative', 56, NULL, NULL, 216475),
(216476, '3.30.200.20-FF-000239', NULL, 'Calcium/calmodulin-dependent protein kinase type II subunit beta', 71, NULL, NULL, 216476),
(216477, '2.110.10.10-FF-000074', NULL, 'Uncharacterized protein', 98, NULL, NULL, 216477),
(216478, '4.10.280.10-FF-000045', NULL, 'upstream stimulatory factor 2 isoform X1', 60, NULL, NULL, 216478),
(216479, '2.40.240.10-FF-000021', NULL, 'Glutamate--tRNA ligase, cytoplasmic', 98, NULL, NULL, 216479),
(216480, '3.30.1120.10-FF-000010', NULL, 'Arylsulfatase atsA', 88, NULL, NULL, 216480),
(216481, '2.70.130.10-FF-000124', NULL, NULL, 158, NULL, NULL, 216481),
(216482, '1.25.40.10-FF-000319', NULL, '26S proteasome non-ATPase regulatory subunit 3', 185, NULL, NULL, 216482),
(216483, '3.40.50.300-FF-007386', NULL, 'Atl2 protein', 62, NULL, NULL, 216483),
(216484, '2.60.120.920-FF-000046', NULL, 'tripartite motif-containing protein 16', 191, NULL, NULL, 216484),
(216485, '3.10.390.10-FF-000001', NULL, 'SKI family transcriptional corepressor 1', 99, NULL, NULL, 216485),
(216486, '1.25.40.180-FF-000045', NULL, 'snRNA cap binding complex subunit (Gcr3), putative', 254, NULL, NULL, 216486),
(216487, '1.10.510.10-FF-000047', NULL, 'Rho-associated protein kinase 1', 201, NULL, NULL, 216487),
(216488, '3.40.50.300-FF-006930', NULL, 'Uncharacterized protein', 231, NULL, NULL, 216488),
(216489, '1.10.510.10-FF-001980', NULL, 'Receptor-like protein kinase THESEUS 1', 221, NULL, NULL, 216489),
(216490, '3.30.420.40-FF-000941', NULL, 'Uncharacterized protein', 63, NULL, NULL, 216490),
(216491, '3.40.50.1910-FF-000004', NULL, 'Vacuolar protein sorting-associated protein 45', 172, NULL, NULL, 216491),
(216492, '3.30.160.60-FF-000056', NULL, 'Zinc finger and SCAN domain-containing 20', 28, NULL, NULL, 216492),
(216493, '4.10.170.10-FF-000008', NULL, 'Cellular tumor antigen p53', 37, NULL, NULL, 216493),
(216494, '1.10.238.220-FF-000013', NULL, NULL, 47, NULL, NULL, 216494),
(216495, '1.10.490.10-FF-000022', NULL, 'Heme-based aerotactic transducer HemAT', 158, NULL, NULL, 216495),
(216496, '2.60.40.150-FF-000104', NULL, 'coiled-coil and C2 domain-containing protein 1B', 156, NULL, NULL, 216496);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(216497, '3.30.70.330-FF-001887', NULL, NULL, 89, NULL, NULL, 216497),
(216498, '3.40.50.700-FF-000002', NULL, 'Hydrogenase-1 small chain', 181, NULL, NULL, 216498),
(216499, '2.60.120.340-FF-000024', NULL, 'Peptidyl-prolyl cis-trans isomerase FKBP53', 103, NULL, NULL, 216499),
(216500, '2.60.220.10-FF-000004', NULL, 'Xanthan lyase', 118, NULL, NULL, 216500),
(216501, '3.40.50.720-FF-000008', NULL, 'calcium-activated potassium channel subunit alpha-1 isoform X5', 143, NULL, NULL, 216501),
(216502, '3.30.160.60-FF-005199', NULL, NULL, 27, NULL, NULL, 216502),
(216503, '3.80.20.20-FF-000049', NULL, 'Predicted protein', 103, NULL, NULL, 216503),
(216504, '2.60.120.260-FF-000298', NULL, 'CUB domaincontaining protein', 86, NULL, NULL, 216504),
(216505, '3.40.50.300-FF-004160', NULL, 'ABC transporter (Glutamine transport ATP-binding protein)', 221, NULL, NULL, 216505),
(216506, '3.30.870.10-FF-000005', NULL, 'Phospholipase', 167, NULL, NULL, 216506),
(216507, '1.10.530.40-FF-000006', NULL, 'Internal virion protein', 139, NULL, NULL, 216507),
(216508, '1.10.560.10-FF-000027', NULL, 'T-complex protein 1 subunit gamma', 230, NULL, NULL, 216508),
(216509, '1.10.510.10-FF-002233', NULL, 'CMGC family protein kinase', 264, NULL, NULL, 216509),
(216510, '2.130.10.10-FF-004446', NULL, 'Os07g0203700 protein', 349, NULL, NULL, 216510),
(216511, '1.25.10.10-FF-002588', NULL, 'Importin-beta N-terminal domain containing protein', 156, NULL, NULL, 216511),
(216512, '3.40.50.620-FF-000276', NULL, 'Electron transfer flavoprotein subunit alpha', 165, NULL, NULL, 216512),
(216513, '2.40.50.140-FF-001254', NULL, NULL, 58, NULL, NULL, 216513),
(216514, '2.10.110.10-FF-000344', NULL, 'Uncharacterized protein', 69, NULL, NULL, 216514),
(216515, '3.50.50.60-FF-000906', NULL, 'Predicted protein', 79, NULL, NULL, 216515),
(216516, '3.30.590.10-FF-000023', NULL, 'Probable glutamine synthetase', 342, NULL, NULL, 216516),
(216517, '3.30.540.10-FF-000020', NULL, 'PAP-specific phosphatase HAL2-like', 231, NULL, NULL, 216517),
(216518, '1.10.630.10-FF-000466', NULL, 'Os07g0291750 protein', 114, NULL, NULL, 216518),
(216519, '3.10.100.10-FF-000216', NULL, 'Mannose receptor, C type 2', 141, NULL, NULL, 216519),
(216520, '3.10.20.740-FF-000009', NULL, '64kDa iron hydrogenase, putative', 124, NULL, NULL, 216520),
(216521, '2.30.30.40-FF-000161', NULL, 'Actin polymerization protein Bzz1', 61, NULL, NULL, 216521),
(216522, '3.70.10.10-FF-000012', NULL, 'cell cycle checkpoint control protein RAD9A', 282, NULL, NULL, 216522),
(216523, '1.25.40.10-FF-001308', NULL, 'pentatricopeptide repeat-containing protein At5g46460, mitochondrial', 234, NULL, NULL, 216523),
(216524, '2.60.120.620-FF-000046', NULL, 'Predicted protein', 132, NULL, NULL, 216524),
(216525, '1.20.1070.10-FF-000852', NULL, 'Olfactory receptor', 185, NULL, NULL, 216525),
(216526, '1.10.10.60-FF-000837', NULL, NULL, 72, NULL, NULL, 216526),
(216527, '3.40.30.10-FF-000610', NULL, 'Glutathione Stransferase EC 25118', 84, NULL, NULL, 216527),
(216528, '3.30.70.380-FF-000013', NULL, NULL, 105, NULL, NULL, 216528),
(216529, '1.10.3450.30-FF-000002', NULL, 'Uncharacterized protein', 68, NULL, NULL, 216529),
(216530, '1.10.150.50-FF-000025', NULL, 'Ankyrin repeat and sterile alpha motif domain-containing 6', 68, NULL, NULL, 216530),
(216531, '3.90.190.10-FF-000136', NULL, 'Tyrosine-protein phosphatase non-receptor type 61F', 297, NULL, NULL, 216531),
(216532, '1.10.472.130-FF-000058', NULL, 'Dynein heavy chain, putative', 85, NULL, NULL, 216532),
(216533, '3.30.420.40-FF-000880', NULL, 'Actin-related protein 8', 41, NULL, NULL, 216533),
(216534, '2.160.20.10-FF-000342', NULL, 'Uncharacterized protein', 270, NULL, NULL, 216534),
(216535, '2.40.50.140-FF-000265', NULL, '30S ribosomal protein S17, chloroplastic', 97, NULL, NULL, 216535),
(216536, '1.10.1040.10-FF-000122', NULL, 'Uncharacterized protein', 53, NULL, NULL, 216536),
(216537, '2.30.29.30-FF-000907', NULL, 'FACT complex subunit SSRP1', 94, NULL, NULL, 216537),
(216538, '2.40.160.10-FF-000020', NULL, 'Voltage-dependent anion-selective channel protein, putative', 285, NULL, NULL, 216538);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(216539, '3.30.70.330-FF-002876', NULL, NULL, 132, NULL, NULL, 216539),
(216540, '1.10.510.10-FF-000608', NULL, 'Serine/threonine protein kinase, putative', 191, NULL, NULL, 216540),
(216541, '3.40.30.10-FF-001274', NULL, 'Calsequestrin', 37, NULL, NULL, 216541),
(216542, '3.30.110.30-FF-000010', NULL, 'Proline--tRNA ligase', 91, NULL, NULL, 216542),
(216543, '1.10.10.10-FF-000171', NULL, 'DEP domain-containing protein 5 isoform X2', 132, NULL, NULL, 216543),
(216544, '1.10.20.10-FF-000256', NULL, NULL, 65, NULL, NULL, 216544),
(216545, '1.10.238.10-FF-000655', NULL, 'Uncharacterized protein', 109, NULL, NULL, 216545),
(216546, '2.60.120.10-FF-000204', NULL, 'Probable transcriptional regulator', 91, NULL, NULL, 216546),
(216547, '1.10.269.10-FF-000002', NULL, 'DNA-binding protein', 28, NULL, NULL, 216547),
(216548, '1.25.10.10-FF-001924', NULL, 'Non-specific serine/threonine protein kinase', 357, NULL, NULL, 216548),
(216549, '3.40.50.2300-FF-001543', NULL, NULL, 44, NULL, NULL, 216549),
(216550, '1.10.268.10-FF-000011', NULL, 'DNA topoisomerase (ATP-hydrolyzing)', 98, NULL, NULL, 216550),
(216551, '1.25.10.10-FF-000290', NULL, 'importin-11 isoform X2', 973, NULL, NULL, 216551),
(216552, '2.60.120.970-FF-000067', NULL, 'Nodal homolog 6', 144, NULL, NULL, 216552),
(216553, '2.60.40.640-FF-000066', NULL, 'Vacuolar sorting protein 26, putative', 142, NULL, NULL, 216553),
(216554, '1.25.40.10-FF-003517', NULL, 'SART-3/p110 homolog', 227, NULL, NULL, 216554),
(216555, '3.30.70.260-FF-000062', NULL, 'Homoserine dehydrogenase', 71, NULL, NULL, 216555),
(216556, '2.60.260.20-FF-000043', NULL, 'Related to DnaJ homolog subfamily A member 2', 83, NULL, NULL, 216556),
(216557, '1.20.930.20-FF-000023', NULL, 'Os11g0669200 protein', 95, NULL, NULL, 216557),
(216558, '3.40.50.20-FF-000058', NULL, 'D-alanine--D-alanine ligase', 128, NULL, NULL, 216558),
(216559, '2.60.40.10-FF-004322', NULL, NULL, 94, NULL, NULL, 216559),
(216560, '3.80.10.10-FF-001563', NULL, 'Protein kinase family protein', 114, NULL, NULL, 216560),
(216561, '1.10.510.10-FF-002817', NULL, NULL, 145, NULL, NULL, 216561),
(216562, '3.80.10.10-FF-004289', NULL, 'Uncharacterized protein', 240, NULL, NULL, 216562),
(216563, '3.40.1190.20-FF-000099', NULL, 'Pyridoxal kinase putative', 278, NULL, NULL, 216563),
(216564, '3.30.160.60-FF-004535', NULL, NULL, 64, NULL, NULL, 216564),
(216565, '2.60.40.420-FF-000180', NULL, 'Laccase-15', 126, NULL, NULL, 216565),
(216566, '1.25.50.20-FF-000093', NULL, 'Uncharacterized protein', 251, NULL, NULL, 216566),
(216567, '1.10.760.10-FF-000094', NULL, 'Uncharacterized protein', 32, NULL, NULL, 216567),
(216568, '3.40.50.1010-FF-000212', NULL, NULL, 149, NULL, NULL, 216568),
(216569, '3.90.1140.10-FF-000003', NULL, 'RNA 2'',3''-cyclic phosphodiesterase', 176, NULL, NULL, 216569),
(216570, '3.40.50.150-FF-000495', NULL, 'Nucleolar RNA methyltransferase (Nop2), putative', 363, NULL, NULL, 216570),
(216571, '1.20.930.40-FF-000029', NULL, 'Uncharacterized protein', 170, NULL, NULL, 216571),
(216572, '3.30.70.1950-FF-000002', NULL, 'Adapter protein MecA', 99, NULL, NULL, 216572),
(216573, '2.130.10.10-FF-005519', NULL, 'Uncharacterized protein', 60, NULL, NULL, 216573),
(216574, '2.60.40.630-FF-000006', NULL, 'Signal transducer and activator of transcription b', 147, NULL, NULL, 216574),
(216575, '2.10.70.10-FF-000133', NULL, 'Uncharacterized protein, isoform B', 62, NULL, NULL, 216575),
(216576, '2.60.40.60-FF-000161', NULL, 'FAT atypical cadherin 1', 98, NULL, NULL, 216576),
(216577, '3.30.420.40-FF-000233', NULL, 'Probable butyrate kinase', 196, NULL, NULL, 216577),
(216578, '3.30.710.10-FF-000320', NULL, 'Uncharacterized protein', 154, NULL, NULL, 216578),
(216579, '3.40.50.300-FF-006222', NULL, 'Uncharacterized protein', 201, NULL, NULL, 216579),
(216580, '3.40.50.300-FF-001490', NULL, 'DNA replication helicase', 214, NULL, NULL, 216580),
(216581, '3.30.70.270-FF-000008', NULL, 'Genome polyprotein', 100, NULL, NULL, 216581),
(216582, '1.10.287.70-FF-000606', NULL, 'Uncharacterized protein', 282, NULL, NULL, 216582);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(216583, '3.40.720.10-FF-000273', NULL, 'Uncharacterized protein', 362, NULL, NULL, 216583),
(216584, '3.40.50.300-FF-006722', NULL, 'Predicted protein', 72, NULL, NULL, 216584),
(216585, '3.30.70.360-FF-000002', NULL, 'Peptidase T', 111, NULL, NULL, 216585),
(216586, '3.10.20.90-FF-000421', NULL, 'Plexin A', 119, NULL, NULL, 216586),
(216587, '1.20.1310.20-FF-000037', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 190, NULL, NULL, 216587),
(216588, '1.10.10.60-FF-000484', NULL, 'Chromatin modification-related protein EAF1', 62, NULL, NULL, 216588),
(216589, '3.40.350.10-FF-000076', NULL, 'Putative aminopeptidase P, cytoplasmic', 159, NULL, NULL, 216589),
(216590, '3.40.50.2300-FF-000262', NULL, 'Asc operon transcriptional repressor', 131, NULL, NULL, 216590),
(216591, '1.20.5.190-FF-000142', NULL, NULL, 34, NULL, NULL, 216591),
(216592, '1.20.140.150-FF-000009', NULL, 'Claudin domain-containing protein 1', 250, NULL, NULL, 216592),
(216593, '1.10.860.10-FF-000011', NULL, 'DnaB-like helicase N terminal domain-containing protein', 141, NULL, NULL, 216593),
(216594, '1.10.1820.10-FF-000013', NULL, 'Casein kinase II subunit beta', 106, NULL, NULL, 216594),
(216595, '3.40.980.10-FF-000022', NULL, 'Molybdenum cofactor biosynthesis protein B', 171, NULL, NULL, 216595),
(216596, '1.10.640.10-FF-000028', NULL, 'Dual oxidase 2 variant', 172, NULL, NULL, 216596),
(216597, '3.40.190.80-FF-000078', NULL, 'Inositol-1-monophosphatase', 121, NULL, NULL, 216597),
(216598, '3.20.20.20-FF-000012', NULL, 'Dihydropteroate synthase', 314, NULL, NULL, 216598),
(216599, '3.40.1090.10-FF-000145', NULL, 'Uncharacterized protein', 111, NULL, NULL, 216599),
(216600, '3.40.50.150-FF-001012', NULL, NULL, 197, NULL, NULL, 216600),
(216601, '2.30.30.30-FF-000124', NULL, 'YALI0A20526p', 105, NULL, NULL, 216601),
(216602, '2.130.10.10-FF-001776', NULL, 'Ddb1 and cul4-associated factor 11', 106, NULL, NULL, 216602),
(216603, '2.30.22.10-FF-000010', NULL, 'Protein GrpE', 59, NULL, NULL, 216603),
(216604, '1.10.2000.10-FF-000030', NULL, 'Uncharacterized protein', 139, NULL, NULL, 216604),
(216605, '1.25.10.10-FF-003369', NULL, 'Uncharacterized protein', 390, NULL, NULL, 216605),
(216606, '1.25.40.170-FF-000008', NULL, 'protein Smaug homolog 2', 122, NULL, NULL, 216606),
(216607, '1.10.510.10-FF-002756', NULL, NULL, 150, NULL, NULL, 216607),
(216608, '1.20.58.1780-FF-000015', NULL, 'Uncharacterized protein', 276, NULL, NULL, 216608),
(216609, '3.30.450.20-FF-000050', NULL, 'PAS domain-containing sensor histidine kinase', 114, NULL, NULL, 216609),
(216610, '3.30.565.10-FF-000043', NULL, 'DNA mismatch repair protein MLH1', 214, NULL, NULL, 216610),
(216611, '3.30.160.60-FF-002473', NULL, 'Uncharacterized protein', 30, NULL, NULL, 216611),
(216612, '2.130.10.10-FF-004238', NULL, 'Uncharacterized protein', 142, NULL, NULL, 216612),
(216613, '3.40.140.10-FF-000127', NULL, 'Eukaryotic translation initiation factor 3 subunit F-2', 181, NULL, NULL, 216613),
(216614, '1.10.1320.10-FF-000020', NULL, 'Uncharacterized protein', 353, NULL, NULL, 216614),
(216615, '1.10.3470.10-FF-000054', NULL, 'Iron (III) dicitrate transport system, permease protein, putative', 304, NULL, NULL, 216615),
(216616, '1.25.10.10-FF-002088', NULL, 'Radial spoke head 14 homolog', 157, NULL, NULL, 216616),
(216617, '3.20.20.370-FF-000036', NULL, 'Predicted protein', 138, NULL, NULL, 216617),
(216618, '3.20.20.80-FF-000070', NULL, 'GDB1p Glycogen debranching enzyme', 132, NULL, NULL, 216618),
(216619, '2.60.40.10-FF-000224', NULL, 'Leucine rich repeats and immunoglobulin like domains 3', 107, NULL, NULL, 216619),
(216620, '2.10.25.10-FF-000798', NULL, 'Crumbs, isoform D', 47, NULL, NULL, 216620),
(216621, '3.40.630.30-FF-000452', NULL, 'Acyl-homoserine-lactone synthase', 184, NULL, NULL, 216621),
(216622, '3.40.225.10-FF-000027', NULL, 'Adducin 3 (gamma) b', 254, NULL, NULL, 216622),
(216623, '3.30.40.10-FF-001825', NULL, 'AAL030Cp', 112, NULL, NULL, 216623),
(216624, '3.30.160.60-FF-004474', NULL, NULL, 39, NULL, NULL, 216624),
(216625, '3.40.250.10-FF-000220', NULL, 'Uncharacterized protein', 132, NULL, NULL, 216625);
INSERT INTO "PUBLIC"."MODEL" VALUES
(216626, '1.10.940.10-FF-000012', NULL, 'Transcription antitermination protein NusB', 142, NULL, NULL, 216626),
(216627, '3.80.10.10-FF-002844', NULL, 'Leucine Rich Repeat family protein', 122, NULL, NULL, 216627),
(216628, '2.10.25.10-FF-001815', NULL, 'Uncharacterized protein', 49, NULL, NULL, 216628),
(216629, '3.30.160.60-FF-005699', NULL, NULL, 61, NULL, NULL, 216629),
(216630, '1.10.630.10-FF-000674', NULL, 'Uncharacterized protein', 170, NULL, NULL, 216630),
(216631, '1.25.40.150-FF-000002', NULL, 'V-type proton ATPase subunit H', 106, NULL, NULL, 216631),
(216632, '1.20.58.900-FF-000012', NULL, 'RUN domain-containing protein 1', 236, NULL, NULL, 216632),
(216633, '1.10.238.10-FF-000594', NULL, 'Suppressor of LIneage defect', 89, NULL, NULL, 216633),
(216634, '1.25.10.10-FF-000790', NULL, 'SNF2 family protein', 298, NULL, NULL, 216634),
(216635, '3.10.50.40-FF-000048', NULL, 'Peptidylprolyl isomerase', 119, NULL, NULL, 216635),
(216636, '3.30.900.10-FF-000003', NULL, 'Mitotic spindle assembly checkpoint protein MAD2B', 203, NULL, NULL, 216636),
(216637, '3.30.1640.10-FF-000066', NULL, 'DNA helicase', 94, NULL, NULL, 216637),
(216638, '3.30.1590.10-FF-000005', NULL, 'Probable glycosyl hydrolase', 57, NULL, NULL, 216638),
(216639, '2.60.120.200-FF-000595', NULL, 'Uncharacterized protein', 158, NULL, NULL, 216639),
(216640, '3.40.50.1440-FF-000167', NULL, 'Uncharacterized protein', 81, NULL, NULL, 216640),
(216641, '1.20.1720.10-FF-000054', NULL, 'Multidrug resistance efflux pump', 340, NULL, NULL, 216641),
(216642, '2.60.40.3510-FF-000019', NULL, 'Delta-like protein', 154, NULL, NULL, 216642),
(216643, '2.60.40.10-FF-001652', NULL, 'Uncharacterized protein', 92, NULL, NULL, 216643),
(216644, '2.60.40.10-FF-004114', NULL, NULL, 117, NULL, NULL, 216644),
(216645, '3.30.740.10-FF-000001', NULL, 'Dynein light chain', 89, NULL, NULL, 216645),
(216646, '1.10.287.470-FF-000058', NULL, 'Efflux transporter, RND family, MFP subunit', 75, NULL, NULL, 216646),
(216647, '1.20.1530.20-FF-000109', NULL, 'Uncharacterized protein', 423, NULL, NULL, 216647),
(216648, '2.60.40.10-FF-005603', NULL, NULL, 47, NULL, NULL, 216648),
(216649, '3.30.160.60-FF-006216', NULL, NULL, 26, NULL, NULL, 216649),
(216650, '2.30.30.100-FF-000201', NULL, 'Sm protein', 94, NULL, NULL, 216650),
(216651, '1.10.238.10-FF-001111', NULL, 'Phosphoinositide phospholipase C', 50, NULL, NULL, 216651),
(216652, '2.60.120.10-FF-000412', NULL, 'Uncharacterized protein', 195, NULL, NULL, 216652),
(216653, '3.30.70.330-FF-000459', NULL, 'Multiple RNA-binding domain-containing protein 1', 104, NULL, NULL, 216653),
(216654, '3.90.70.10-FF-000711', NULL, 'Uncharacterized protein', 204, NULL, NULL, 216654),
(216655, '1.25.40.10-FF-002180', NULL, 'Pentatricopeptide repeat-containing protein', 161, NULL, NULL, 216655),
(216656, '3.90.470.10-FF-000034', NULL, '39S ribosomal protein L22, mitochondrial', 152, NULL, NULL, 216656),
(216657, '1.10.10.60-FF-000337', NULL, 'Chitin synthase 8', 64, NULL, NULL, 216657),
(216658, '3.40.30.10-FF-000110', NULL, 'Protein disulfide-isomerase', 101, NULL, NULL, 216658),
(216659, '3.90.1150.10-FF-000240', NULL, 'Putative cystathionine beta-lyase', 85, NULL, NULL, 216659),
(216660, '3.90.1150.10-FF-000037', NULL, 'Putative Kynurenine aminotransferase', 151, NULL, NULL, 216660),
(216661, '3.30.420.40-FF-000733', NULL, 'Actin7-1 (Actin-related protein)', 114, NULL, NULL, 216661),
(216662, '3.40.50.1820-FF-001293', NULL, 'Uncharacterized protein', 279, NULL, NULL, 216662),
(216663, '2.30.29.30-FF-000407', NULL, 'C2 domain-containing protein-like', 127, NULL, NULL, 216663),
(216664, '3.40.50.300-FF-002827', NULL, 'ABC transporter, ATP-binding protein', 74, NULL, NULL, 216664),
(216665, '2.130.10.10-FF-003518', NULL, 'Elongator complex protein 2', 119, NULL, NULL, 216665),
(216666, '2.10.25.10-FF-000326', NULL, 'Multiple EGF like domains 6', 37, NULL, NULL, 216666),
(216667, '1.25.40.10-FF-001808', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 81, NULL, NULL, 216667),
(216668, '1.25.10.10-FF-000643', NULL, 'Serine/threonine-protein kinase TOR', 178, NULL, NULL, 216668);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(216669, '1.10.287.40-FF-000002', NULL, 'Serine--tRNA ligase, cytoplasmic', 137, NULL, NULL, 216669),
(216670, '3.60.21.10-FF-000234', NULL, 'Metallophosphoesterase', 206, NULL, NULL, 216670),
(216671, '3.90.550.10-FF-000035', NULL, 'Putative Exostosin-2', 256, NULL, NULL, 216671),
(216672, '1.10.357.70-FF-000022', NULL, 'Tumor necrosis factor, alpha-induced protein 2a', 178, NULL, NULL, 216672),
(216673, '3.20.20.140-FF-000052', NULL, 'Catalytic/ hydrolase', 292, NULL, NULL, 216673),
(216674, '1.10.238.10-FF-000447', NULL, 'Protein kinase, putative', 78, NULL, NULL, 216674),
(216675, '2.60.40.10-FF-002169', NULL, 'KETtiN (Drosophila actin-binding) homolog', 100, NULL, NULL, 216675),
(216676, '3.30.60.30-FF-000146', NULL, 'Uncharacterized protein', 60, NULL, NULL, 216676),
(216677, '1.20.58.60-FF-000054', NULL, 'Short stop, isoform K', 209, NULL, NULL, 216677),
(216678, '3.40.50.720-FF-000160', NULL, '2,3-dihydro-2,3-dihydroxybenzoate dehydrogenase', 259, NULL, NULL, 216678),
(216679, '3.40.50.920-FF-000040', NULL, '1-deoxy-D-xylulose 5-phosphate synthase 1', 104, NULL, NULL, 216679),
(216680, '3.40.50.80-FF-000233', NULL, 'Uncharacterized protein', 109, NULL, NULL, 216680),
(216681, '3.30.830.10-FF-000031', NULL, 'Putative zinc metalloprotease', 226, NULL, NULL, 216681),
(216682, '3.30.565.10-FF-000190', NULL, 'Two-component sensor, ParS', 150, NULL, NULL, 216682),
(216683, '1.50.40.10-FF-000227', NULL, 'Predicted protein', 291, NULL, NULL, 216683),
(216684, '3.30.70.330-FF-001948', NULL, NULL, 118, NULL, NULL, 216684),
(216685, '1.10.630.10-FF-000202', NULL, 'Cytochrome P450 family protein', 340, NULL, NULL, 216685),
(216686, '3.60.15.10-FF-000113', NULL, 'Hydroxyacylglutathione hydrolase', 252, NULL, NULL, 216686),
(216687, '2.60.40.290-FF-000005', NULL, 'Beta-N-acetylhexosaminidase', 143, NULL, NULL, 216687),
(216688, '3.30.710.10-FF-000112', NULL, 'Zinc finger and BTB domain-containing protein 8B', 153, NULL, NULL, 216688),
(216689, '3.30.479.20-FF-000014', NULL, 'Elongation factor Ts, mitochondrial', 97, NULL, NULL, 216689),
(216690, '2.30.29.30-FF-001127', NULL, 'Uncharacterized protein', 123, NULL, NULL, 216690),
(216691, '1.10.10.10-FF-000671', NULL, 'Bifunctional ligase/repressor BirA', 65, NULL, NULL, 216691),
(216692, '3.40.50.1400-FF-000003', NULL, 'Ferrochelatase', 181, NULL, NULL, 216692),
(216693, '1.10.472.10-FF-000093', NULL, 'Predicted protein', 115, NULL, NULL, 216693),
(216694, '3.50.50.60-FF-000322', NULL, 'Protein CBG01975', 118, NULL, NULL, 216694),
(216695, '2.130.10.10-FF-005727', NULL, 'Uncharacterized protein', 136, NULL, NULL, 216695),
(216696, '3.40.1160.10-FF-000061', NULL, 'Molybdenum storage protein subunit beta', 269, NULL, NULL, 216696),
(216697, '3.40.50.12760-FF-000021', NULL, 'Uncharacterized protein', 222, NULL, NULL, 216697),
(216698, '3.10.20.90-FF-000685', NULL, 'Uncharacterized protein', 85, NULL, NULL, 216698),
(216699, '3.90.70.10-FF-000150', NULL, 'Uncharacterized protein', 295, NULL, NULL, 216699),
(216700, '3.90.640.10-FF-000126', NULL, 'Heat shock protein 70, putative', 118, NULL, NULL, 216700),
(216701, '2.60.40.10-FF-003097', NULL, 'Uncharacterized protein', 103, NULL, NULL, 216701),
(216702, '3.30.160.60-FF-003046', NULL, 'Zinc finger protein 715', 29, NULL, NULL, 216702),
(216703, '3.50.7.10-FF-000057', NULL, NULL, 168, NULL, NULL, 216703),
(216704, '3.80.10.10-FF-000899', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', 135, NULL, NULL, 216704),
(216705, '2.60.40.150-FF-000576', NULL, 'Regulating synaptic membrane exocytosis protein 2', 148, NULL, NULL, 216705),
(216706, '1.25.10.10-FF-001571', NULL, 'Protein VAC14-like protein', 88, NULL, NULL, 216706),
(216707, '3.10.10.10-FF-000026', NULL, NULL, 60, NULL, NULL, 216707),
(216708, '2.20.28.290-FF-000004', NULL, 'Leucine--tRNA ligase', 44, NULL, NULL, 216708),
(216709, '2.60.40.1470-FF-000003', NULL, 'F-box protein SKIP16', 143, NULL, NULL, 216709),
(216710, '1.20.1250.20-FF-001116', NULL, 'Related to Polyamine transport protein', 234, NULL, NULL, 216710),
(216711, '2.20.70.10-FF-000228', NULL, 'Pre-mRNA-processing protein 40A', 29, NULL, NULL, 216711);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(216712, '3.30.2350.20-FF-000053', NULL, NULL, 73, NULL, NULL, 216712),
(216713, '1.10.357.50-FF-000011', NULL, 'YOR296Wp-like protein', 159, NULL, NULL, 216713),
(216714, '3.30.70.330-FF-000723', NULL, 'Chromosome 16, whole genome shotgun sequence', 94, NULL, NULL, 216714),
(216715, '2.170.8.10-FF-000010', NULL, 'Phosphoenolypyruvate CarboxyKinase', 84, NULL, NULL, 216715),
(216716, '3.10.450.80-FF-000004', NULL, 'Predicted protein', 49, NULL, NULL, 216716),
(216717, '1.10.1450.10-FF-000024', NULL, 'Tetraspanin', 76, NULL, NULL, 216717),
(216718, '3.40.50.12430-FF-000006', NULL, 'folliculin-like', 135, NULL, NULL, 216718),
(216719, '1.25.10.10-FF-003105', NULL, 'Os07g0693400 protein', 544, NULL, NULL, 216719),
(216720, '2.130.10.10-FF-000348', NULL, 'Katanin p80 WD40 repeat-containing subunit B1', 139, NULL, NULL, 216720),
(216721, '3.20.20.70-FF-000797', NULL, NULL, 291, NULL, NULL, 216721),
(216722, '3.10.105.10-FF-000064', NULL, 'Oligopeptide ABC transporter, periplasmic oligopeptide-binding protein', 128, NULL, NULL, 216722),
(216723, '2.40.290.30-FF-000007', NULL, 'Putative transcription factor', 167, NULL, NULL, 216723),
(216724, '1.10.3430.10-FF-000080', NULL, 'Predicted protein', 60, NULL, NULL, 216724),
(216725, '3.30.160.60-FF-002118', NULL, 'Zinc finger protein 382', 32, NULL, NULL, 216725),
(216726, '3.80.10.10-FF-001299', NULL, 'Uncharacterized protein', 190, NULL, NULL, 216726),
(216727, '1.10.10.440-FF-000026', NULL, 'Pre-mRNA-processing protein 40A', 74, NULL, NULL, 216727),
(216728, '2.30.30.140-FF-000218', NULL, 'Enhanced RNAI (RNA interference)', 71, NULL, NULL, 216728),
(216729, '1.20.1560.10-FF-000608', NULL, 'Uncharacterized protein', 110, NULL, NULL, 216729),
(216730, '1.10.4200.10-FF-000006', NULL, 'Probable 2-(5''''-triphosphoribosyl)-3''-dephosphocoenzyme-A synthase', 240, NULL, NULL, 216730),
(216731, '3.40.50.1970-FF-000062', NULL, NULL, 153, NULL, NULL, 216731),
(216732, '1.25.40.10-FF-001960', NULL, 'Tetratricopeptide repeat domain 21A', 352, NULL, NULL, 216732),
(216733, '3.30.70.3490-FF-000037', NULL, NULL, 40, NULL, NULL, 216733),
(216734, '3.60.15.10-FF-000260', NULL, 'Chromosome 7, whole genome shotgun sequence', 206, NULL, NULL, 216734),
(216735, '1.10.510.10-FF-003161', NULL, NULL, 170, NULL, NULL, 216735),
(216736, '3.30.200.20-FF-001880', NULL, 'Protein kinase superfamily protein', 45, NULL, NULL, 216736),
(216737, '2.60.40.10-FF-005867', NULL, NULL, 93, NULL, NULL, 216737),
(216738, '3.30.1540.10-FF-000002', NULL, 'Formyl-CoA:oxalate CoA-transferase', 97, NULL, NULL, 216738),
(216739, '3.40.50.300-FF-003232', NULL, 'Structural maintenance of chromosomes 6, gene 1', 182, NULL, NULL, 216739),
(216740, '1.10.565.10-FF-000134', NULL, 'Uncharacterized protein', 94, NULL, NULL, 216740),
(216741, '2.40.50.140-FF-000473', NULL, 'Lysine--tRNA ligase', 149, NULL, NULL, 216741),
(216742, '3.40.50.200-FF-000178', NULL, 'Predicted protein', 329, NULL, NULL, 216742),
(216743, '1.20.1070.10-FF-000644', NULL, 'Olfactory receptor 716', 176, NULL, NULL, 216743),
(216744, '3.30.1010.10-FF-000120', NULL, 'Uncharacterized protein', 72, NULL, NULL, 216744),
(216745, '3.60.10.10-FF-000153', NULL, 'Type II inositol-1,4,5-trisphosphate 5-phosphatase', 334, NULL, NULL, 216745),
(216746, '3.40.50.10490-FF-000082', NULL, 'Glucose-6-phosphate isomerase', 194, NULL, NULL, 216746),
(216747, '3.40.50.1820-FF-001146', NULL, 'Alpha/beta hydrolase', 265, NULL, NULL, 216747),
(216748, '3.40.50.740-FF-000019', NULL, 'Formate dehydrogenase subunit alpha FdhF', 241, NULL, NULL, 216748),
(216749, '3.60.110.10-FF-000048', NULL, 'Glutamine-dependent NAD(+) synthetase', 261, NULL, NULL, 216749),
(216750, '2.20.28.10-FF-000046', NULL, 'Predicted protein', 58, NULL, NULL, 216750),
(216751, '2.40.10.230-FF-000008', NULL, 'H/ACA ribonucleoprotein complex non-core subunit NAF1', 74, NULL, NULL, 216751),
(216752, '2.60.40.10-FF-000932', NULL, 'Immunoglobulin superfamily member 3', 121, NULL, NULL, 216752),
(216753, '1.25.40.10-FF-002028', NULL, 'Kinetoplast polyadenylation/uridylation factor 1', 156, NULL, NULL, 216753);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(216754, '3.60.21.10-FF-000381', NULL, 'Uncharacterized protein', 81, NULL, NULL, 216754),
(216755, '3.30.70.2760-FF-000003', NULL, 'HD superfamily phosphohydrolase protein', 120, NULL, NULL, 216755),
(216756, '2.130.10.10-FF-002181', NULL, 'WD repeat-containing protein JIP5', 249, NULL, NULL, 216756),
(216757, '2.130.10.10-FF-000495', NULL, 'Transcriptional corepressor LEUNIG', 158, NULL, NULL, 216757),
(216758, '3.40.50.1580-FF-000068', NULL, 'Purine nucleoside phosphorylase 6', 124, NULL, NULL, 216758),
(216759, '3.30.519.10-FF-000004', NULL, 'Rab proteins geranylgeranyltransferase component A', 182, NULL, NULL, 216759),
(216760, '3.10.110.10-FF-000306', NULL, 'Uncharacterized protein', 86, NULL, NULL, 216760),
(216761, '2.40.100.10-FF-000039', NULL, 'Peptidyl-prolyl cis-trans isomerase', 175, NULL, NULL, 216761),
(216762, '2.70.98.10-FF-000031', NULL, 'Putative sugar hydrolase', 320, NULL, NULL, 216762),
(216763, '3.40.50.2000-FF-000054', NULL, 'Glycosyltransferase', 238, NULL, NULL, 216763),
(216764, '1.10.1370.10-FF-000023', NULL, 'Mitochondrial intermediate peptidase', 324, NULL, NULL, 216764),
(216765, '3.40.50.300-FF-000770', NULL, 'Caspase recruitment domain family, member 11', 194, NULL, NULL, 216765),
(216766, '3.40.50.880-FF-000067', NULL, '4-methyl-5(B-hydroxyethyl)-thiazol monophosphate biosynthesis enzyme', 188, NULL, NULL, 216766),
(216767, '3.30.160.60-FF-003754', NULL, NULL, 28, NULL, NULL, 216767),
(216768, '3.10.450.10-FF-000091', NULL, 'Alpha-2-HS-glycoprotein 1', 110, NULL, NULL, 216768),
(216769, '3.40.50.300-FF-005441', NULL, 'Uncharacterized protein', 258, NULL, NULL, 216769),
(216770, '3.40.50.150-FF-001837', NULL, NULL, 59, NULL, NULL, 216770),
(216771, '1.20.1110.10-FF-000171', NULL, NULL, 171, NULL, NULL, 216771),
(216772, '1.10.287.4290-FF-000002', NULL, 'Peroxisomal multifunctional enzyme type 2', 55, NULL, NULL, 216772),
(216773, '1.10.10.570-FF-000014', NULL, 'Uncharacterized protein', 119, NULL, NULL, 216773),
(216774, '3.20.70.20-FF-000015', NULL, 'Vitamin B12-dependent ribonucleotide reductase', 403, NULL, NULL, 216774),
(216775, '3.40.50.1000-FF-000063', NULL, 'Nuclear elongation and deformation protein', 115, NULL, NULL, 216775),
(216776, '3.30.300.160-FF-000006', NULL, 'General secretion pathway protein E', 93, NULL, NULL, 216776),
(216777, '2.60.120.10-FF-000676', NULL, 'Uncharacterized protein', 96, NULL, NULL, 216777),
(216778, '1.10.510.10-FF-001328', NULL, 'NEK protein kinase', 263, NULL, NULL, 216778),
(216779, '3.40.190.10-FF-000277', NULL, 'glutamate receptor 2', 121, NULL, NULL, 216779),
(216780, '3.40.50.300-FF-008167', NULL, 'Uncharacterized protein', 86, NULL, NULL, 216780),
(216781, '2.30.110.10-FF-000093', NULL, 'Uncharacterized protein', 186, NULL, NULL, 216781),
(216782, '3.40.50.2000-FF-000762', NULL, 'UDP-N-acetylglucosamine transferase subunit ALG14', 175, NULL, NULL, 216782),
(216783, '2.40.10.10-FF-000061', NULL, 'Hepatocyte growth factor activator', 245, NULL, NULL, 216783),
(216784, '3.50.50.60-FF-001250', NULL, 'Predicted protein', 139, NULL, NULL, 216784),
(216785, '2.60.40.10-FF-002580', NULL, 'Gamete expressed 2', 138, NULL, NULL, 216785),
(216786, '2.70.98.30-FF-000037', NULL, 'Predicted protein', 248, NULL, NULL, 216786),
(216787, '2.130.10.10-FF-004390', NULL, 'Uncharacterized protein', 64, NULL, NULL, 216787),
(216788, '3.30.200.20-FF-000503', NULL, 'Putative prolin-rich extensin-like receptor protein kinase family protein', 106, NULL, NULL, 216788),
(216789, '3.40.50.620-FF-000540', NULL, 'Glutamyl-Q tRNA(Asp) synthetase', 308, NULL, NULL, 216789),
(216790, '1.10.730.10-FF-000119', NULL, 'Valyl tRNA synthetase putative', 239, NULL, NULL, 216790),
(216791, '3.30.1330.50-FF-000009', NULL, '2-C-methyl-D-erythritol 2,4-cyclodiphosphate synthase', 159, NULL, NULL, 216791),
(216792, '3.40.850.10-FF-000277', NULL, 'Uncharacterized protein', 253, NULL, NULL, 216792),
(216793, '3.90.1410.10-FF-000159', NULL, 'Uncharacterized protein', 54, NULL, NULL, 216793),
(216794, '3.40.50.1000-FF-000771', NULL, NULL, 109, NULL, NULL, 216794);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(216795, '1.20.58.80-FF-000065', NULL, 'serine/threonine-protein kinase ULK3', 76, NULL, NULL, 216795),
(216796, '1.20.1510.10-FF-000044', NULL, 'Uncharacterized protein', 218, NULL, NULL, 216796),
(216797, '3.40.50.11350-FF-000025', NULL, 'Uncharacterized protein', 152, NULL, NULL, 216797),
(216798, '2.160.20.10-FF-000078', NULL, 'Coagulation factor 5/8 type domain-containing protein', 241, NULL, NULL, 216798),
(216799, '3.30.450.20-FF-000611', NULL, 'Uncharacterized protein', 136, NULL, NULL, 216799),
(216800, '3.30.160.60-FF-005963', NULL, NULL, 60, NULL, NULL, 216800),
(216801, '1.10.220.10-FF-000036', NULL, 'Annexin', 84, NULL, NULL, 216801),
(216802, '1.50.10.130-FF-000025', NULL, NULL, 144, NULL, NULL, 216802),
(216803, '2.10.25.10-FF-001254', NULL, 'Uncharacterized protein', 41, NULL, NULL, 216803),
(216804, '3.30.1330.40-FF-000063', NULL, 'Chromosome 15, whole genome shotgun sequence', 152, NULL, NULL, 216804),
(216805, '2.30.30.790-FF-000003', NULL, '50S ribosomal protein L19, chloroplastic', 119, NULL, NULL, 216805),
(216806, '3.40.640.10-FF-000531', NULL, 'Serine--pyruvate aminotransferase', 81, NULL, NULL, 216806),
(216807, '1.25.40.10-FF-002736', NULL, 'U5 snRNP-associated 102 kDa protein, putative', 349, NULL, NULL, 216807),
(216808, '3.30.420.10-FF-000573', NULL, NULL, 240, NULL, NULL, 216808),
(216809, '2.60.40.10-FF-000371', NULL, 'Kirre like nephrin family adhesion molecule 3', 82, NULL, NULL, 216809),
(216810, '3.40.50.12350-FF-000016', NULL, 'Eyes absent homolog', 34, NULL, NULL, 216810),
(216811, '3.40.50.300-FF-007650', NULL, 'Helicase', 133, NULL, NULL, 216811),
(216812, '3.30.160.60-FF-006391', NULL, NULL, 130, NULL, NULL, 216812),
(216813, '4.10.280.10-FF-000129', NULL, 'HLH DNA binding protein (Penr2), putative', 66, NULL, NULL, 216813),
(216814, '1.20.1170.10-FF-000005', NULL, 'Nematocidal crystal protein 6A', 333, NULL, NULL, 216814),
(216815, '3.30.70.1230-FF-000112', NULL, 'Putative adenylate cyclase 3', 180, NULL, NULL, 216815),
(216816, '1.10.287.110-FF-000383', NULL, 'Putative chaperone protein DNAj', 89, NULL, NULL, 216816),
(216817, '2.60.40.10-FF-002141', NULL, 'Beta-mannosidase A', 90, NULL, NULL, 216817),
(216818, '2.130.10.30-FF-000034', NULL, 'HECT and RLD domain containing E3 ubiquitin protein ligase 4', 203, NULL, NULL, 216818),
(216819, '3.90.1170.40-FF-000019', NULL, 'Uncharacterized protein MJ0717', 115, NULL, NULL, 216819),
(216820, '3.40.50.300-FF-004660', NULL, 'Chromosome 1, whole genome shotgun sequence', 275, NULL, NULL, 216820),
(216821, '3.30.70.270-FF-000211', NULL, NULL, 95, NULL, NULL, 216821),
(216822, '3.90.1170.20-FF-000013', NULL, 'Quinolinate phosphoribosyltransferase [decarboxylating]', 116, NULL, NULL, 216822),
(216823, '1.10.8.60-FF-000117', NULL, 'Sigma-54-dependent phenylalanine hydroxylase transcriptional regulator PhhR', 75, NULL, NULL, 216823),
(216824, '3.40.350.10-FF-000020', NULL, 'Probable aminopeptidase P, cytoplasmic', 153, NULL, NULL, 216824),
(216825, '1.20.120.560-FF-000010', NULL, 'Rim20p', 92, NULL, NULL, 216825),
(216826, '1.20.1250.20-FF-001639', NULL, 'Monocarboxylate transporter, putative', 76, NULL, NULL, 216826),
(216827, '3.40.50.1820-FF-000365', NULL, 'Prolyl oligopeptidase family protein', 284, NULL, NULL, 216827),
(216828, '3.30.70.1230-FF-000056', NULL, 'Putative adenylate cyclase', 189, NULL, NULL, 216828),
(216829, '2.60.40.10-FF-002085', NULL, 'Iduronidase, alpha-L-', 97, NULL, NULL, 216829),
(216830, '3.30.1640.10-FF-000089', NULL, 'DNA helicase', 128, NULL, NULL, 216830),
(216831, '1.20.1730.10-FF-000088', NULL, 'Uncharacterized protein', 455, NULL, NULL, 216831),
(216832, '1.25.40.180-FF-000129', NULL, 'Putative eukaryotic initiation factor 4a', 264, NULL, NULL, 216832),
(216833, '2.30.29.30-FF-000290', NULL, 'SH2 domain-containing protein 5', 128, NULL, NULL, 216833),
(216834, '3.40.50.10490-FF-000110', NULL, NULL, 186, NULL, NULL, 216834),
(216835, '1.20.1070.10-FF-001425', NULL, '5-hydroxytryptamine receptor 1D', 227, NULL, NULL, 216835),
(216836, '3.10.450.40-FF-000015', NULL, 'Amine oxidase', 107, NULL, NULL, 216836);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(216837, '1.20.1270.10-FF-000064', NULL, 'CBN-HSP-1 protein', 101, NULL, NULL, 216837),
(216838, '3.30.230.70-FF-000149', NULL, 'Uncharacterized protein', 97, NULL, NULL, 216838),
(216839, '1.25.10.10-FF-000851', NULL, 'Exportin 1 family protein', 880, NULL, NULL, 216839),
(216840, '1.10.472.170-FF-000014', NULL, 'Transcription initiation factor IIB 1', 187, NULL, NULL, 216840),
(216841, '1.20.1250.40-FF-000021', NULL, 'DNA-directed RNA polymerase III subunit, putative', 139, NULL, NULL, 216841),
(216842, '1.10.510.10-FF-003189', NULL, NULL, 152, NULL, NULL, 216842),
(216843, '2.60.200.20-FF-000011', NULL, 'Serine/threonine-protein kinase Chk2', 119, NULL, NULL, 216843),
(216844, '1.10.510.10-FF-003245', NULL, NULL, 117, NULL, NULL, 216844),
(216845, '1.20.1070.10-FF-001369', NULL, 'Predicted protein', 259, NULL, NULL, 216845),
(216846, '1.25.10.10-FF-000374', NULL, 'Protein wings apart-like', 517, NULL, NULL, 216846),
(216847, '1.20.120.850-FF-000029', NULL, 'RAD54B DNA helicase splice variant', 122, NULL, NULL, 216847),
(216848, '1.10.3020.10-FF-000003', NULL, NULL, 23, NULL, NULL, 216848),
(216849, '2.40.30.10-FF-000528', NULL, 'Uncharacterized protein', 52, NULL, NULL, 216849),
(216850, '3.10.20.90-FF-000185', NULL, 'UBX domain-containing protein 6', 86, NULL, NULL, 216850),
(216851, '2.60.40.150-FF-000604', NULL, 'Phosphoinositide phospholipase C', 136, NULL, NULL, 216851),
(216852, '1.20.1280.50-FF-000054', NULL, 'Coronatine-insensitive protein 1', 51, NULL, NULL, 216852),
(216853, '3.80.20.20-FF-000026', NULL, 'Receptor protein-tyrosine kinase', 252, NULL, NULL, 216853),
(216854, '1.25.40.20-FF-001401', NULL, 'Uncharacterized protein', 162, NULL, NULL, 216854),
(216855, '1.20.1070.10-FF-000436', NULL, 'Olfactory receptor OR6-8', 168, NULL, NULL, 216855),
(216856, '3.90.1600.10-FF-000022', NULL, 'DNA polymerase', 88, NULL, NULL, 216856),
(216857, '1.20.5.110-FF-000337', NULL, 'Predicted protein', 91, NULL, NULL, 216857),
(216858, '3.40.50.300-FF-008403', NULL, 'Predicted protein', 172, NULL, NULL, 216858),
(216859, '3.20.20.60-FF-000029', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 253, NULL, NULL, 216859),
(216860, '3.40.50.790-FF-000012', NULL, 'Ribosomal protein L1p/L10e family', 92, NULL, NULL, 216860),
(216861, '3.30.70.330-FF-003096', NULL, NULL, 151, NULL, NULL, 216861),
(216862, '3.40.190.10-FF-000338', NULL, 'Iron(III) ABC transporter substrate-binding protein', 133, NULL, NULL, 216862),
(216863, '2.120.10.80-FF-000201', NULL, 'F-box only protein 13', 296, NULL, NULL, 216863),
(216864, '3.40.50.261-FF-000006', NULL, 'Succinate--CoA ligase [ADP-forming] subunit alpha', 171, NULL, NULL, 216864),
(216865, '3.30.160.60-FF-000117', NULL, 'Zinc finger E-box-binding homeobox 2 isoform 1', 68, NULL, NULL, 216865),
(216866, '3.30.40.10-FF-001297', NULL, 'RING/U-box superfamily protein', 83, NULL, NULL, 216866),
(216867, '3.40.50.1820-FF-001354', NULL, 'Uncharacterized protein', 238, NULL, NULL, 216867),
(216868, '1.25.40.10-FF-001983', NULL, 'TPR domain protein', 116, NULL, NULL, 216868),
(216869, '1.20.120.1750-FF-000161', NULL, 'RBR-type E3 ubiquitin transferase', 62, NULL, NULL, 216869),
(216870, '1.25.40.10-FF-001488', NULL, 'pentatricopeptide repeat-containing protein At2g13600-like', 187, NULL, NULL, 216870),
(216871, '1.10.357.140-FF-000032', NULL, 'Predicted protein', 82, NULL, NULL, 216871),
(216872, '1.20.1250.10-FF-000006', NULL, 'Interleukin-6', 189, NULL, NULL, 216872),
(216873, '3.60.21.10-FF-000465', NULL, 'Uncharacterized protein', 130, NULL, NULL, 216873),
(216874, '3.80.10.10-FF-002288', NULL, 'Expressed protein', 238, NULL, NULL, 216874),
(216875, '1.20.120.1110-FF-000002', NULL, 'Transcription initiation factor TFIID subunit 4B', 112, NULL, NULL, 216875),
(216876, '2.130.10.10-FF-002265', NULL, 'Lethal giant larvae like, C-terminal-domain-containing protein', 309, NULL, NULL, 216876),
(216877, '1.10.486.10-FF-000040', NULL, 'DNA helicase', 172, NULL, NULL, 216877),
(216878, '2.40.50.40-FF-000111', NULL, 'Interleukin-8', 62, NULL, NULL, 216878);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(216879, '3.30.70.330-FF-002640', NULL, NULL, 121, NULL, NULL, 216879),
(216880, '3.40.1500.10-FF-000014', NULL, 'Coproporphyrinogen III oxidase', 330, NULL, NULL, 216880),
(216881, '1.25.40.20-FF-001345', NULL, 'Uncharacterized protein', 111, NULL, NULL, 216881),
(216882, '2.60.120.920-FF-000069', NULL, 'Ryanodine receptor 44F', 164, NULL, NULL, 216882),
(216883, '1.10.510.10-FF-002733', NULL, 'Probable inactive serine/threonine-protein kinase DDB_G0274613', 283, NULL, NULL, 216883),
(216884, '2.60.120.1440-FF-000005', NULL, 'Sigma factor regulatory protein, FecR/PupR family', 134, NULL, NULL, 216884),
(216885, '1.20.910.10-FF-000047', NULL, 'Uncharacterized protein', 108, NULL, NULL, 216885),
(216886, '1.10.275.40-FF-000019', NULL, 'DNA helicase RepD', 23, NULL, NULL, 216886),
(216887, '3.30.2350.20-FF-000030', NULL, 'tRNA pseudouridine synthase D', 190, NULL, NULL, 216887),
(216888, '3.30.420.40-FF-000469', NULL, 'Putative nodulation protein nolNO', 202, NULL, NULL, 216888),
(216889, '3.40.1090.10-FF-000122', NULL, 'Uncharacterized protein', 201, NULL, NULL, 216889),
(216890, '2.40.50.140-FF-001193', NULL, NULL, 114, NULL, NULL, 216890),
(216891, '3.40.50.1820-FF-000893', NULL, 'Uncharacterized protein', 251, NULL, NULL, 216891),
(216892, '2.60.120.330-FF-000111', NULL, 'Steroid 16alpha-hydroxylase', 326, NULL, NULL, 216892),
(216893, '2.40.30.10-FF-000152', NULL, 'Probable translation initiation factor IF-2', 90, NULL, NULL, 216893),
(216894, '3.20.20.220-FF-000042', NULL, 'Methylenetetrahydrofolate reductase', 266, NULL, NULL, 216894),
(216895, '3.40.50.1820-FF-001410', NULL, 'Predicted protein', 207, NULL, NULL, 216895),
(216896, '1.10.540.10-FF-000144', NULL, 'Acyl-coenzyme A oxidase', 100, NULL, NULL, 216896),
(216897, '1.10.10.520-FF-000016', NULL, 'Uncharacterized protein', 66, NULL, NULL, 216897),
(216898, '2.130.10.10-FF-004210', NULL, 'Coronin', 152, NULL, NULL, 216898),
(216899, '1.20.930.40-FF-000006', NULL, 'Glutamate carboxypeptidase Tre2, putative', 176, NULL, NULL, 216899),
(216900, '3.40.50.300-FF-006953', NULL, 'DNA mismatch repair MutS protein', 224, NULL, NULL, 216900),
(216901, '1.20.1250.20-FF-001263', NULL, 'Putative integral membrane transport protein', 381, NULL, NULL, 216901),
(216902, '3.40.430.10-FF-000054', NULL, 'Uncharacterized hydrolase C22A12.06c', 167, NULL, NULL, 216902),
(216903, '3.40.50.300-FF-003608', NULL, 'Cell division protein ZapE', 169, NULL, NULL, 216903),
(216904, '1.20.5.100-FF-000008', NULL, 'Integrin beta', 75, NULL, NULL, 216904),
(216905, '3.30.1360.210-FF-000015', NULL, 'Ribosomal protein L22-like 1', 35, NULL, NULL, 216905),
(216906, '1.25.40.10-FF-003433', NULL, 'Os01g0357800 protein', 141, NULL, NULL, 216906),
(216907, '2.10.109.10-FF-000043', NULL, 'Mitochondrial inner membrane protease subunit 2', 116, NULL, NULL, 216907),
(216908, '1.20.120.230-FF-000018', NULL, 'Mesoderm development candidate 1', 133, NULL, NULL, 216908),
(216909, '1.20.58.1220-FF-000016', NULL, 'Predicted protein', 103, NULL, NULL, 216909),
(216910, '3.80.10.10-FF-000051', NULL, 'F-box and leucine-rich repeat protein 14', 255, NULL, NULL, 216910),
(216911, '2.40.70.10-FF-000098', NULL, 'Chloroplast nucleoid DNA-binding protein-like', 199, NULL, NULL, 216911),
(216912, '1.20.120.350-FF-000065', NULL, 'Sodium channel protein', 123, NULL, NULL, 216912),
(216913, '2.60.120.650-FF-000145', NULL, 'Uncharacterized protein', 67, NULL, NULL, 216913),
(216914, '3.40.50.300-FF-001787', NULL, 'Putative DEAD/DEAH box helicase', 90, NULL, NULL, 216914),
(216915, '1.20.5.170-FF-000248', NULL, 'Uncharacterized protein', 79, NULL, NULL, 216915),
(216916, '1.10.620.20-FF-000002', NULL, 'Stearoyl-[acyl-carrier-protein] 9-desaturase, chloroplastic', 347, NULL, NULL, 216916),
(216917, '1.10.10.10-FF-001683', NULL, 'Heat shock factor (HSF)-type DNA-binding domain-containing protein', 117, NULL, NULL, 216917),
(216918, '3.20.20.70-FF-000358', NULL, 'Enoyl-(Acyl-carrier-protein) reductase II', 331, NULL, NULL, 216918),
(216919, '2.40.160.120-FF-000027', NULL, 'Oxysterol-binding protein/PH domain-containing protein', 122, NULL, NULL, 216919); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(216920, '2.10.25.10-FF-001462', NULL, 'Integrin beta', 60, NULL, NULL, 216920),
(216921, '2.60.40.1510-FF-000004', NULL, 'Integrin beta', 141, NULL, NULL, 216921),
(216922, '2.60.40.10-FF-004822', NULL, NULL, 91, NULL, NULL, 216922),
(216923, '3.30.160.60-FF-003838', NULL, NULL, 27, NULL, NULL, 216923),
(216924, '3.30.160.60-FF-001601', NULL, 'Uncharacterized protein, isoform A', 29, NULL, NULL, 216924),
(216925, '1.10.10.1340-FF-000004', NULL, 'Mediator of RNA polymerase II transcription subunit 31', 94, NULL, NULL, 216925),
(216926, '2.60.11.10-FF-000011', NULL, 'Cytochrome c oxidase subunit 5B, mitochondrial', 94, NULL, NULL, 216926),
(216927, '3.40.50.300-FF-001315', NULL, 'SNF2 family helicase/ATPase PasG', 292, NULL, NULL, 216927),
(216928, '3.10.20.90-FF-000505', NULL, 'SEP domain containing protein, putative', 136, NULL, NULL, 216928),
(216929, '2.40.50.90-FF-000132', NULL, 'Ring finger protein 17', 108, NULL, NULL, 216929),
(216930, '3.80.10.10-FF-000427', NULL, 'Osteomodulin', 98, NULL, NULL, 216930),
(216931, '2.60.40.10-FF-003389', NULL, NULL, 102, NULL, NULL, 216931),
(216932, '2.30.42.10-FF-000157', NULL, 'General receptor for phosphoinositides 1-associated scaffold protein', 96, NULL, NULL, 216932),
(216933, '2.60.40.150-FF-000284', NULL, 'Uncharacterized protein', 129, NULL, NULL, 216933),
(216934, '2.30.30.170-FF-000002', NULL, 'Bifunctional autolysin', 71, NULL, NULL, 216934),
(216935, '1.20.1510.10-FF-000100', NULL, NULL, 133, NULL, NULL, 216935),
(216936, '2.60.40.10-FF-001949', NULL, 'Hemicentin 2', 79, NULL, NULL, 216936),
(216937, '3.40.50.1000-FF-000294', NULL, 'CRE-FCP-1 protein', 168, NULL, NULL, 216937),
(216938, '1.10.1520.10-FF-000024', NULL, 'Dicer-2', 123, NULL, NULL, 216938),
(216939, '2.60.40.150-FF-000340', NULL, 'Extended SYnapTotagmin homolog', 147, NULL, NULL, 216939),
(216940, '1.25.40.10-FF-005350', NULL, 'Pentatricopeptide repeat-containing protein At5g64320, mitochondrial', 131, NULL, NULL, 216940),
(216941, '2.60.40.10-FF-002877', NULL, 'GM25453', 111, NULL, NULL, 216941),
(216942, '3.40.630.30-FF-000536', NULL, 'Histone acetyltransferase', 57, NULL, NULL, 216942),
(216943, '3.90.1800.10-FF-000003', NULL, 'DNA-directed RNA polymerase subunit beta', 102, NULL, NULL, 216943),
(216944, '1.25.40.280-FF-000013', NULL, 'Endosomal targeting BRO1-like domain-containing protein', 363, NULL, NULL, 216944),
(216945, '3.30.160.60-FF-002534', NULL, 'Uncharacterized protein, isoform B', 28, NULL, NULL, 216945),
(216946, '3.40.50.720-FF-001233', NULL, 'SUMO1 activating enzyme subunit 1', 214, NULL, NULL, 216946),
(216947, '1.20.58.670-FF-000021', NULL, NULL, 132, NULL, NULL, 216947),
(216948, '3.30.470.20-FF-000197', NULL, 'Predicted protein', 19, NULL, NULL, 216948),
(216949, '1.20.140.80-FF-000014', NULL, 'Transcription factor, E2F and DP-related', 90, NULL, NULL, 216949),
(216950, '2.30.29.30-FF-000610', NULL, 'Uncharacterized protein', 131, NULL, NULL, 216950),
(216951, '3.80.10.10-FF-001355', NULL, 'Tubulin folding COfactor E-Like protein', 136, NULL, NULL, 216951),
(216952, '2.60.40.10-FF-002933', NULL, 'Deleted in lung and esophageal cancer protein 1', 115, NULL, NULL, 216952),
(216953, '3.40.50.300-FF-006458', NULL, 'Protein CBR-RAB-35', 120, NULL, NULL, 216953),
(216954, '3.40.525.10-FF-000016', NULL, 'Uncharacterized protein, isoform B', 140, NULL, NULL, 216954),
(216955, '3.30.70.870-FF-000008', NULL, 'Elongation factor G, mitochondrial', 51, NULL, NULL, 216955),
(216956, '1.10.510.10-FF-000755', NULL, 'Homoserine kinase', 145, NULL, NULL, 216956),
(216957, '2.60.40.60-FF-000222', NULL, 'neural-cadherin isoform X3', 97, NULL, NULL, 216957),
(216958, '1.20.58.340-FF-000029', NULL, 'Magnesium transport protein CorA', 114, NULL, NULL, 216958),
(216959, '3.30.360.10-FF-000039', NULL, 'Glucose-6-phosphate dehydrogenase', 281, NULL, NULL, 216959),
(216960, '3.40.50.10880-FF-000013', NULL, NULL, 77, NULL, NULL, 216960),
(216961, '2.40.110.10-FF-000068', NULL, 'Acyl-coenzyme A oxidase', 139, NULL, NULL, 216961),
(216962, '3.30.470.20-FF-000141', NULL, 'Glutathione synthetase', 79, NULL, NULL, 216962);
INSERT INTO "PUBLIC"."MODEL" VALUES
(216963, '3.30.40.10-FF-001617', NULL, 'Probable E3 ubiquitin-protein ligase ARI12', 97, NULL, NULL, 216963),
(216964, '3.20.20.70-FF-000302', NULL, 'Imidazole glycerol phosphate synthase hisHF', 332, NULL, NULL, 216964),
(216965, '1.20.1440.180-FF-000015', NULL, 'Protein CBG25496', 100, NULL, NULL, 216965),
(216966, '3.10.450.350-FF-000016', NULL, 'Peptidoglycan-specific endopeptidase, M23 family', 86, NULL, NULL, 216966),
(216967, '2.60.120.650-FF-000089', NULL, 'Lysine-specific demethylase 4', 355, NULL, NULL, 216967),
(216968, '3.30.70.330-FF-001179', NULL, 'RNA_recognition_motif._(A.k.a._RRM_-_RBD_-_or_RNP_domain)/RNA_recognition_motif_(A.k.a._RRM_-_RBD_-_or_RNP_domain)_-_putative', 104, NULL, NULL, 216968),
(216969, '2.40.70.10-FF-000154', NULL, 'Aspartic proteinase nepenthesin-2', 185, NULL, NULL, 216969),
(216970, '3.40.718.10-FF-000032', NULL, 'GM20069', 332, NULL, NULL, 216970),
(216971, '3.30.200.20-FF-001464', NULL, 'U-box domain-containing protein kinase family protein', 94, NULL, NULL, 216971),
(216972, '2.30.42.10-FF-000101', NULL, 'LIM domain kinase 1', 111, NULL, NULL, 216972),
(216973, '2.30.30.190-FF-000008', NULL, 'Tubulin-specific chaperone E', 80, NULL, NULL, 216973),
(216974, '1.20.58.60-FF-000610', NULL, 'Spectrin beta chain', 214, NULL, NULL, 216974),
(216975, '4.10.910.10-FF-000009', NULL, 'Mitochondrial ribosomal protein S13', 48, NULL, NULL, 216975),
(216976, '1.20.1560.10-FF-000311', NULL, 'ABC transporter ATP-binding protein', 336, NULL, NULL, 216976),
(216977, '3.40.250.10-FF-000012', NULL, 'Centrosomal protein of 41 kDa', 93, NULL, NULL, 216977),
(216978, '3.30.70.1350-FF-000002', NULL, 'Ferrous-iron efflux pump FieF', 85, NULL, NULL, 216978),
(216979, '3.30.710.10-FF-000376', NULL, 'SCF ubiquitin ligase complex protein SKP1b', 79, NULL, NULL, 216979),
(216980, '3.30.70.340-FF-000024', NULL, NULL, 90, NULL, NULL, 216980),
(216981, '3.30.160.60-FF-003462', NULL, NULL, 25, NULL, NULL, 216981),
(216982, '2.40.50.120-FF-000023', NULL, 'Complement C5', 151, NULL, NULL, 216982),
(216983, '3.40.630.10-FF-000002', NULL, 'Peptidase T', 287, NULL, NULL, 216983),
(216984, '1.10.1600.10-FF-000025', NULL, 'Uncharacterized protein', 94, NULL, NULL, 216984),
(216985, '3.40.50.2000-FF-000346', NULL, 'Glycosyltransferase', 196, NULL, NULL, 216985),
(216986, '1.10.533.10-FF-000116', NULL, 'Caspase-15', 94, NULL, NULL, 216986),
(216987, '3.80.10.10-FF-001416', NULL, 'Leucine-rich repeat containing protein', 137, NULL, NULL, 216987),
(216988, '3.40.30.10-FF-000874', NULL, 'Phospholipid hydroperoxide glutathione peroxidase', 79, NULL, NULL, 216988),
(216989, '1.10.238.10-FF-001291', NULL, 'Protein kinase, putative', 79, NULL, NULL, 216989),
(216990, '1.50.40.10-FF-000463', NULL, 'Uncharacterized protein', 308, NULL, NULL, 216990),
(216991, '3.90.80.10-FF-000004', NULL, 'Inorganic pyrophosphatase', 288, NULL, NULL, 216991),
(216992, '2.10.90.10-FF-000016', NULL, 'Neuroblastoma suppressor of tumorigenicity 1', 116, NULL, NULL, 216992),
(216993, '3.90.1520.10-FF-000021', NULL, 'Uncharacterized protein', 190, NULL, NULL, 216993),
(216994, '3.30.70.330-FF-002112', NULL, NULL, 113, NULL, NULL, 216994),
(216995, '3.30.70.330-FF-001712', NULL, NULL, 127, NULL, NULL, 216995),
(216996, '1.10.472.80-FF-000186', NULL, NULL, 134, NULL, NULL, 216996),
(216997, '1.10.274.10-FF-000008', NULL, 'GAF domain phosphoenolpyruvate--protein phosphotransferase PtsP', 124, NULL, NULL, 216997),
(216998, '2.130.10.10-FF-004682', NULL, 'Uncharacterized protein', 181, NULL, NULL, 216998),
(216999, '2.60.40.4070-FF-000013', NULL, 'Glr0823 protein', 94, NULL, NULL, 216999),
(217000, '1.10.287.890-FF-000004', NULL, 'Uncharacterized protein', 103, NULL, NULL, 217000),
(217001, '2.160.20.10-FF-000106', NULL, 'Uncharacterized protein', 252, NULL, NULL, 217001),
(217002, '2.40.50.140-FF-000029', NULL, '50S ribosomal protein L2, chloroplastic', 110, NULL, NULL, 217002),
(217003, '3.30.40.10-FF-002230', NULL, 'Uncharacterized protein', 65, NULL, NULL, 217003),
(217004, '3.10.20.120-FF-000003', NULL, 'Toxic shock syndrome toxin-1', 123, NULL, NULL, 217004);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(217005, '3.60.21.10-FF-000026', NULL, 'Serine/threonine-protein phosphatase', 308, NULL, NULL, 217005),
(217006, '3.50.50.60-FF-000345', NULL, 'Protoporphyrinogen oxidase', 137, NULL, NULL, 217006),
(217007, '2.10.25.10-FF-000534', NULL, 'Neurogenic locus notch homolog protein 3', 40, NULL, NULL, 217007),
(217008, '3.90.1720.30-FF-000008', NULL, NULL, 165, NULL, NULL, 217008),
(217009, '2.10.25.10-FF-001023', NULL, 'Os09g0373800 protein', 46, NULL, NULL, 217009),
(217010, '3.40.640.10-FF-000300', NULL, 'Pyridoxal phosphate-dependent transferase', 246, NULL, NULL, 217010),
(217011, '1.20.58.390-FF-000263', NULL, 'Glycine receptor alpha 1 variant, putative', 92, NULL, NULL, 217011),
(217012, '3.40.720.10-FF-000301', NULL, 'Uncharacterized protein', 478, NULL, NULL, 217012),
(217013, '1.10.418.60-FF-000010', NULL, 'Uncharacterized protein', 163, NULL, NULL, 217013),
(217014, '3.40.710.10-FF-000059', NULL, 'Penicillin-binding protein 2', 327, NULL, NULL, 217014),
(217015, '1.10.1080.10-FF-000012', NULL, 'Glutathione synthetase', 80, NULL, NULL, 217015),
(217016, '3.40.50.300-FF-004536', NULL, 'ATP-binding cassette sub-family F member 2', 265, NULL, NULL, 217016),
(217017, '3.10.20.70-FF-000027', NULL, 'Glutamate-ammonia ligase', 92, NULL, NULL, 217017),
(217018, '1.20.1250.20-FF-000335', NULL, 'Siderochrome iron transporter 2', 174, NULL, NULL, 217018),
(217019, '1.10.555.10-FF-000105', NULL, 'Mental retardation GTPase activating protein homolog 2', 252, NULL, NULL, 217019),
(217020, '3.40.50.150-FF-001304', NULL, NULL, 213, NULL, NULL, 217020),
(217021, '2.130.10.10-FF-006008', NULL, 'Uncharacterized protein', 363, NULL, NULL, 217021),
(217022, '3.40.630.10-FF-000058', NULL, 'Aminopeptidase ypdE', 237, NULL, NULL, 217022),
(217023, '2.40.20.10-FF-000090', NULL, 'Hepatocyte growth factor', 90, NULL, NULL, 217023),
(217024, '2.60.40.840-FF-000007', NULL, 'Phosrestin ii arrestin a arrestin-like protein', 55, NULL, NULL, 217024),
(217025, '3.20.20.60-FF-000153', NULL, 'Uncharacterized protein', 286, NULL, NULL, 217025),
(217026, '2.60.34.10-FF-000047', NULL, '97 kDa heat shock protein', 151, NULL, NULL, 217026),
(217027, '3.40.50.10260-FF-000007', NULL, 'YjeF N-terminal domain-like protein', 291, NULL, NULL, 217027),
(217028, '2.60.40.3130-FF-000001', NULL, 'Spike glycoprotein', 136, NULL, NULL, 217028),
(217029, '3.40.47.10-FF-000025', NULL, 'Chalcone synthase 2', 236, NULL, NULL, 217029),
(217030, '1.20.1530.20-FF-000020', NULL, 'Arsenical-resistance membrane protein', 335, NULL, NULL, 217030),
(217031, '3.30.200.70-FF-000001', NULL, 'Stress response kinase A', 69, NULL, NULL, 217031),
(217032, '3.40.630.30-FF-000160', NULL, 'Gcn5-related N-acetyltransferase', 114, NULL, NULL, 217032),
(217033, '1.10.3380.10-FF-000024', NULL, 'U5 snRNP-specific protein-like', 31, NULL, NULL, 217033),
(217034, '3.30.420.140-FF-000038', NULL, 'Predicted protein', 161, NULL, NULL, 217034),
(217035, '1.25.40.90-FF-000096', NULL, 'Target of Myb protein 1', 145, NULL, NULL, 217035),
(217036, '3.30.70.2740-FF-000020', NULL, 'D-lactate dehydrogenase (Cytochrome)', 73, NULL, NULL, 217036),
(217037, '1.20.120.350-FF-000060', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 73, NULL, NULL, 217037),
(217038, '1.25.40.70-FF-000090', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', 190, NULL, NULL, 217038),
(217039, '2.40.10.10-FF-000645', NULL, NULL, 136, NULL, NULL, 217039),
(217040, '3.40.50.720-FF-002009', NULL, 'Short-chain dehydrogenase/reductase SDR', 222, NULL, NULL, 217040),
(217041, '3.80.10.10-FF-000399', NULL, 'F-box/LRR-repeat protein 14', 85, NULL, NULL, 217041),
(217042, '3.40.50.300-FF-003732', NULL, 'ATP-dependent RNA helicase, putative', 185, NULL, NULL, 217042),
(217043, '3.90.480.20-FF-000009', NULL, 'Sulfite reductase (NADPH) hemoprotein beta-component', 100, NULL, NULL, 217043),
(217044, '1.25.40.10-FF-000999', NULL, 'Anaphase-promoting complex subunit Apc5, putative', 280, NULL, NULL, 217044),
(217045, '1.10.472.10-FF-000570', NULL, 'Cyclin-D2-1', 59, NULL, NULL, 217045);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(217046, '2.10.110.10-FF-000260', NULL, 'Uncharacterized protein', 102, NULL, NULL, 217046),
(217047, '3.40.930.10-FF-000042', NULL, NULL, 116, NULL, NULL, 217047),
(217048, '3.30.160.60-FF-005463', NULL, NULL, 73, NULL, NULL, 217048),
(217049, '3.30.70.330-FF-002168', NULL, NULL, 87, NULL, NULL, 217049),
(217050, '3.40.50.150-FF-001776', NULL, NULL, 319, NULL, NULL, 217050),
(217051, '3.30.9.10-FF-000308', NULL, 'Amino acid deaminase, putative', 41, NULL, NULL, 217051),
(217052, '2.40.70.10-FF-000126', NULL, 'Gamma conglutin 1', 203, NULL, NULL, 217052),
(217053, '3.10.28.10-FF-000061', NULL, 'Large helicase-related protein', 215, NULL, NULL, 217053),
(217054, '1.20.1050.10-FF-000025', NULL, 'Glutathione S-transferase domain protein', 117, NULL, NULL, 217054),
(217055, '2.130.10.10-FF-002529', NULL, 'Uncharacterized protein', 313, NULL, NULL, 217055),
(217056, '2.60.40.1180-FF-000096', NULL, 'Probable glucan 1,3-alpha-glucosidase', 73, NULL, NULL, 217056),
(217057, '1.20.1300.20-FF-000008', NULL, 'Cysteine proteinase', 156, NULL, NULL, 217057),
(217058, '3.20.20.80-FF-000687', NULL, 'Hexosaminidase', 314, NULL, NULL, 217058),
(217059, '3.40.50.10140-FF-000084', NULL, 'Protein CBG03616', 136, NULL, NULL, 217059),
(217060, '1.25.40.10-FF-003809', NULL, 'Pentatricopeptide repeat-containing protein', 138, NULL, NULL, 217060),
(217061, '2.60.40.10-FF-000955', NULL, 'Terribly reduced optic lobes, isoform AF', 93, NULL, NULL, 217061),
(217062, '1.20.1070.10-FF-001364', NULL, 'Uncharacterized protein', 262, NULL, NULL, 217062),
(217063, '2.40.10.10-FF-000206', NULL, 'Serine protease Rv3671c', 107, NULL, NULL, 217063),
(217064, '3.20.20.80-FF-000159', NULL, 'Class V chitinase, putative', 267, NULL, NULL, 217064),
(217065, '2.60.40.10-FF-000516', NULL, 'Myosin light chain kinase, smooth muscle', 72, NULL, NULL, 217065),
(217066, '1.10.10.60-FF-000629', NULL, 'L-rhamnose operon transcriptional activator RhaR', 55, NULL, NULL, 217066),
(217067, '3.40.50.10240-FF-000001', NULL, 'Thiamine pyrophosphokinase', 143, NULL, NULL, 217067),
(217068, '3.90.76.10-FF-000045', NULL, 'Dipeptide ABC superfamily ATP binding cassette transporter, binding protein', 144, NULL, NULL, 217068),
(217069, '3.30.70.330-FF-000167', NULL, 'protein boule-like isoform X1', 92, NULL, NULL, 217069),
(217070, '2.60.40.10-FF-004878', NULL, NULL, 103, NULL, NULL, 217070),
(217071, '1.20.120.790-FF-000017', NULL, 'Lipophosphoglycan biosynthetic protein, putative', 150, NULL, NULL, 217071),
(217072, '1.20.58.90-FF-000006', NULL, 'Type III secretion system needle complex protein', 80, NULL, NULL, 217072),
(217073, '3.40.50.300-FF-008375', NULL, 'Uncharacterized protein', 278, NULL, NULL, 217073),
(217074, '3.40.50.720-FF-000744', NULL, 'Smt3 activating enzyme 1', 332, NULL, NULL, 217074),
(217075, '3.30.1360.40-FF-000008', NULL, 'DNA topoisomerase (ATP-hydrolyzing)', 98, NULL, NULL, 217075),
(217076, '3.40.50.300-FF-005969', NULL, 'Uncharacterized protein', 144, NULL, NULL, 217076),
(217077, '3.30.200.20-FF-001228', NULL, 'Probable serine/threonine-protein kinase DDB_G0290859', 89, NULL, NULL, 217077),
(217078, '3.30.920.20-FF-000007', NULL, NULL, 97, NULL, NULL, 217078),
(217079, '1.10.1020.10-FF-000003', NULL, 'Site-specific DNA-methyltransferase (adenine-specific)', 105, NULL, NULL, 217079),
(217080, '3.90.190.10-FF-000052', NULL, 'Dual specificity phosphatase 15', 158, NULL, NULL, 217080),
(217081, '3.20.20.100-FF-000091', NULL, 'NADPH-dependent aldo-keto reductase, chloroplastic isoform A', 299, NULL, NULL, 217081),
(217082, '3.40.50.150-FF-000287', NULL, 'Protein-lysine N-methyltransferase EFM4', 206, NULL, NULL, 217082),
(217083, '2.60.120.260-FF-000270', NULL, 'Beta-galactosidase', 86, NULL, NULL, 217083),
(217084, '3.80.10.10-FF-003833', NULL, 'Uncharacterized protein', 60, NULL, NULL, 217084),
(217085, '1.10.10.10-FF-000227', NULL, 'GntR family transcriptional regulator', 76, NULL, NULL, 217085),
(217086, '3.40.850.10-FF-000069', NULL, 'Kinesin-like motor protein', 376, NULL, NULL, 217086),
(217087, '1.25.40.20-FF-000912', NULL, 'Ankyrin repeat and KH domain-containing 1', 105, NULL, NULL, 217087);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(217088, '3.30.50.10-FF-000073', NULL, 'Nuclear hormone receptor family member nhr-121', 105, NULL, NULL, 217088),
(217089, '3.40.50.1700-FF-000003', NULL, 'Probable beta-glucosidase', 272, NULL, NULL, 217089),
(217090, '3.60.40.10-FF-000065', NULL, 'Protein phosphatase 2C 37', 301, NULL, NULL, 217090),
(217091, '3.30.10.20-FF-000022', NULL, NULL, 69, NULL, NULL, 217091),
(217092, '3.40.50.300-FF-000298', NULL, 'ATP-binding cassette sub-family A member 12', 242, NULL, NULL, 217092),
(217093, '2.30.30.230-FF-000009', NULL, 'Fumarylacetoacetase', 44, NULL, NULL, 217093),
(217094, '2.130.10.10-FF-002681', NULL, 'Seven WD repeats, AN11 family', 462, NULL, NULL, 217094),
(217095, '1.10.1280.10-FF-000016', NULL, 'Tyrosinase', 108, NULL, NULL, 217095),
(217096, '3.30.505.10-FF-000034', NULL, 'SH2 domain-containing protein 4A', 112, NULL, NULL, 217096),
(217097, '3.80.10.10-FF-003272', NULL, 'Uncharacterized protein', 204, NULL, NULL, 217097),
(217098, '1.10.472.10-FF-000385', NULL, 'Uncharacterized protein', 136, NULL, NULL, 217098),
(217099, '2.60.120.920-FF-000193', NULL, 'Uncharacterized protein', 62, NULL, NULL, 217099),
(217100, '3.30.565.10-FF-000279', NULL, 'Two-component system sensor histidine kinase', 146, NULL, NULL, 217100),
(217101, '3.40.50.150-FF-000820', NULL, 'Nicotinamide N-methyltransferase', 257, NULL, NULL, 217101),
(217102, '1.20.1250.20-FF-001324', NULL, 'Sodium/phosphate transporter, putative', 194, NULL, NULL, 217102),
(217103, '2.160.10.10-FF-000044', NULL, 'Transferase hexapeptide domain-containing protein', 109, NULL, NULL, 217103),
(217104, '3.20.20.80-FF-000507', NULL, 'Glucosylceramidase beta 3 (gene/pseudogene)', 67, NULL, NULL, 217104),
(217105, '3.30.470.30-FF-000054', NULL, 'Putative methyltransferase', 69, NULL, NULL, 217105),
(217106, '3.20.20.80-FF-000215', NULL, '1,3-beta-galactosyl-N-acetylhexosamine phosphorylase', 319, NULL, NULL, 217106),
(217107, '3.30.40.10-FF-001241', NULL, 'Ubiquitinyl hydrolase 1', 97, NULL, NULL, 217107),
(217108, '3.40.50.300-FF-000793', NULL, 'Structural maintenance of chromosomes protein 5', 253, NULL, NULL, 217108),
(217109, '1.20.1250.20-FF-001139', NULL, 'Chromosome 9, whole genome shotgun sequence', 206, NULL, NULL, 217109),
(217110, '3.20.20.70-FF-000774', NULL, NULL, 99, NULL, NULL, 217110),
(217111, '1.10.8.60-FF-000089', NULL, 'Peroxisomal biogenesis factor 1', 60, NULL, NULL, 217111),
(217112, '1.10.510.10-FF-002317', NULL, 'Uncharacterized protein', 259, NULL, NULL, 217112),
(217113, '3.20.20.140-FF-000344', NULL, 'Uncharacterized protein', 341, NULL, NULL, 217113),
(217114, '2.30.30.210-FF-000003', NULL, 'Ribonuclease P protein subunit p29, putative', 95, NULL, NULL, 217114),
(217115, '3.30.1360.20-FF-000002', NULL, 'Putative pterin-4-alpha-carbinolamine dehydratase', 101, NULL, NULL, 217115),
(217116, '1.20.59.10-FF-000024', NULL, 'Chorismate mutase/prephenate dehydratase', 85, NULL, NULL, 217116),
(217117, '3.90.1410.10-FF-000136', NULL, 'Uncharacterized protein C16C6.01c', 260, NULL, NULL, 217117),
(217118, '2.30.42.10-FF-000573', NULL, NULL, 128, NULL, NULL, 217118),
(217119, '1.25.40.10-FF-003017', NULL, 'Pentatricopeptide repeat-containing protein At5g46580, chloroplastic', 112, NULL, NULL, 217119),
(217120, '3.40.30.10-FF-000402', NULL, 'Protein disulfide isomerase PDI2', 134, NULL, NULL, 217120),
(217121, '3.40.390.30-FF-000005', NULL, 'Probable rRNA maturation factor YbeY, putative', 169, NULL, NULL, 217121),
(217122, '3.90.105.20-FF-000004', NULL, 'Ribosome assembly factor mrt4', 74, NULL, NULL, 217122),
(217123, '2.40.50.140-FF-001198', NULL, NULL, 101, NULL, NULL, 217123),
(217124, '3.40.570.10-FF-000031', NULL, 'Endonuclease G', 126, NULL, NULL, 217124),
(217125, '3.40.50.300-FF-007442', NULL, 'ABC transporter protein family', 252, NULL, NULL, 217125),
(217126, '1.20.58.70-FF-000091', NULL, 'AaceriACR092Cp', 131, NULL, NULL, 217126),
(217127, '3.30.70.1560-FF-000008', NULL, 'Pseudouridine synthase', 82, NULL, NULL, 217127),
(217128, '2.60.120.40-FF-000016', NULL, 'Tumor necrosis factor', 152, NULL, NULL, 217128);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(217129, '2.60.40.10-FF-002405', NULL, 'Colony stimulating factor 1 receptor, a', 94, NULL, NULL, 217129),
(217130, '1.10.10.60-FF-000692', NULL, 'AraC family transcriptional regulator', 110, NULL, NULL, 217130),
(217131, '3.40.630.30-FF-000244', NULL, 'GNAT family N-acetyltransferase', 153, NULL, NULL, 217131),
(217132, '3.10.20.90-FF-000213', NULL, 'Plexin A4, B', 113, NULL, NULL, 217132),
(217133, '3.40.50.300-FF-001607', NULL, 'Gluconokinase', 190, NULL, NULL, 217133),
(217134, '3.40.50.720-FF-002161', NULL, 'Uncharacterized protein', 77, NULL, NULL, 217134),
(217135, '2.10.110.10-FF-000108', NULL, 'LIM domain containing protein', 68, NULL, NULL, 217135),
(217136, '1.20.120.1080-FF-000061', NULL, 'ATP-dependent RNA helicase, putative', 100, NULL, NULL, 217136),
(217137, '3.30.530.20-FF-000112', NULL, 'Coenzyme Q-binding protein COQ10, mitochondrial', 147, NULL, NULL, 217137),
(217138, '1.25.10.10-FF-002791', NULL, 'Uncharacterized protein', 258, NULL, NULL, 217138),
(217139, '2.60.40.10-FF-004850', NULL, NULL, 113, NULL, NULL, 217139),
(217140, '3.40.50.1360-FF-000058', NULL, '6-phosphogluconolactonase', 203, NULL, NULL, 217140),
(217141, '2.20.25.80-FF-000009', NULL, 'WRKY transcription factor 53', 78, NULL, NULL, 217141),
(217142, '3.40.50.150-FF-001220', NULL, NULL, 203, NULL, NULL, 217142),
(217143, '3.30.160.60-FF-003170', NULL, 'Crooked legs, isoform D', 27, NULL, NULL, 217143),
(217144, '3.40.50.300-FF-006514', NULL, 'Uncharacterized protein', 112, NULL, NULL, 217144),
(217145, '2.60.40.10-FF-004794', NULL, NULL, 95, NULL, NULL, 217145),
(217146, '2.40.50.90-FF-000188', NULL, 'Serine/threonine kinase 31', 70, NULL, NULL, 217146),
(217147, '1.10.730.10-FF-000030', NULL, 'Methionine--tRNA ligase', 153, NULL, NULL, 217147),
(217148, '1.20.1640.10-FF-000109', NULL, NULL, 203, NULL, NULL, 217148),
(217149, '3.40.50.970-FF-000061', NULL, '2-oxoglutarate dehydrogenase E1 component', 366, NULL, NULL, 217149),
(217150, '3.40.50.300-FF-003171', NULL, 'ATP-dependent RNA helicase YTHDC2', 173, NULL, NULL, 217150),
(217151, '1.20.58.1480-FF-000015', NULL, 'Lon protease homolog, mitochondrial', 27, NULL, NULL, 217151),
(217152, '3.20.20.80-FF-000131', NULL, 'Glycoside hydrolase superfamily', 259, NULL, NULL, 217152),
(217153, '3.30.450.20-FF-000667', NULL, 'Sensory transduction histidine kinase', 107, NULL, NULL, 217153),
(217154, '3.30.200.20-FF-002392', NULL, 'Protein kinase domaincontaining protein', 134, NULL, NULL, 217154),
(217155, '3.20.20.220-FF-000014', NULL, 'Methylenetetrahydrofolate reductase', 281, NULL, NULL, 217155),
(217156, '2.60.40.10-FF-003866', NULL, NULL, 92, NULL, NULL, 217156),
(217157, '3.20.20.140-FF-000288', NULL, 'Histidinol-phosphatase', 252, NULL, NULL, 217157),
(217158, '2.60.120.260-FF-000118', NULL, 'Beta-mannosidase B', 192, NULL, NULL, 217158),
(217159, '3.40.50.150-FF-000764', NULL, 'RE45246p', 231, NULL, NULL, 217159),
(217160, '3.30.70.330-FF-000370', NULL, 'Dead end protein homolog 1', 102, NULL, NULL, 217160),
(217161, '2.60.120.260-FF-000303', NULL, 'Usherin', 232, NULL, NULL, 217161),
(217162, '3.90.190.10-FF-000428', NULL, 'Uncharacterized protein', 288, NULL, NULL, 217162),
(217163, '3.40.850.10-FF-000041', NULL, 'Kinesin-like calmodulin-binding protein', 380, NULL, NULL, 217163),
(217164, '3.40.50.300-FF-002771', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', 356, NULL, NULL, 217164),
(217165, '3.80.10.10-FF-002344', NULL, 'F-box/LRR-repeat protein 3', 140, NULL, NULL, 217165),
(217166, '1.10.418.10-FF-000276', NULL, 'Uncharacterized protein', 47, NULL, NULL, 217166),
(217167, '3.40.50.300-FF-002243', NULL, 'Regulator of telomere elongation helicase 1', 242, NULL, NULL, 217167),
(217168, '1.20.920.30-FF-000054', NULL, 'Dynein heavy chain family protein', 199, NULL, NULL, 217168),
(217169, '1.20.58.60-FF-000407', NULL, 'Spectrin beta chain, non-erythrocytic', 107, NULL, NULL, 217169),
(217170, '3.30.450.20-FF-000139', NULL, 'Cyclic-di-AMP phosphodiesterase', 105, NULL, NULL, 217170),
(217171, '3.40.50.2300-FF-001627', NULL, NULL, 276, NULL, NULL, 217171);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(217172, '3.10.20.90-FF-000921', NULL, 'Uncharacterized protein', 82, NULL, NULL, 217172),
(217173, '3.40.30.10-FF-000346', NULL, 'Calsequestrin', 146, NULL, NULL, 217173),
(217174, '1.10.238.200-FF-000030', NULL, 'Defective in cullin neddylation protein', 69, NULL, NULL, 217174),
(217175, '3.40.50.2300-FF-001279', NULL, NULL, 170, NULL, NULL, 217175),
(217176, '2.170.150.70-FF-000001', NULL, 'Centromere protein V', 115, NULL, NULL, 217176),
(217177, '3.30.160.60-FF-002057', NULL, 'IKAROS family zinc finger 3', 59, NULL, NULL, 217177),
(217178, '1.25.10.10-FF-002644', NULL, 'Uncharacterized protein', 116, NULL, NULL, 217178),
(217179, '1.20.1560.10-FF-000108', NULL, 'Multidrug resistance protein', 350, NULL, NULL, 217179),
(217180, '1.10.10.10-FF-001211', NULL, 'RecQ family helicase', 105, NULL, NULL, 217180),
(217181, '3.30.160.60-FF-001045', NULL, 'Uncharacterized protein', 29, NULL, NULL, 217181),
(217182, '3.40.50.720-FF-000688', NULL, 'Dehydrogenase, putative (AFU_orthologue AFUA_8G05760)', 204, NULL, NULL, 217182),
(217183, '3.40.50.2000-FF-000638', NULL, 'AGAP007588-PA', 204, NULL, NULL, 217183),
(217184, '3.30.40.10-FF-000313', NULL, 'Tripartite motif-containing protein 66', 70, NULL, NULL, 217184),
(217185, '1.20.1560.10-FF-000783', NULL, 'Predicted protein', 274, NULL, NULL, 217185),
(217186, '2.30.29.30-FF-000615', NULL, 'Uncharacterized protein', 92, NULL, NULL, 217186),
(217187, '1.10.510.10-FF-003661', NULL, NULL, 180, NULL, NULL, 217187),
(217188, '2.60.40.10-FF-005811', NULL, NULL, 66, NULL, NULL, 217188),
(217189, '6.10.300.40-FF-000004', NULL, '26S proteasome regulatory subunit N10', 41, NULL, NULL, 217189),
(217190, '1.25.40.10-FF-004361', NULL, 'Pentatricopeptide repeat-containing protein', 154, NULL, NULL, 217190),
(217191, '2.120.10.30-FF-000175', NULL, 'Calcium-dependent phosphotriesterase superfamily protein', 141, NULL, NULL, 217191),
(217192, '3.30.300.20-FF-000067', NULL, 'Uncharacterized protein', 107, NULL, NULL, 217192),
(217193, '1.10.8.1330-FF-000001', NULL, NULL, 53, NULL, NULL, 217193),
(217194, '3.20.20.70-FF-000830', NULL, NULL, 136, NULL, NULL, 217194),
(217195, '3.40.50.720-FF-001672', NULL, 'Uncharacterized protein', 108, NULL, NULL, 217195),
(217196, '3.20.20.140-FF-000260', NULL, 'Alpha-D-ribose 1-methylphosphonate 5-triphosphate diphosphatase', 25, NULL, NULL, 217196),
(217197, '2.120.10.10-FF-000017', NULL, 'Exo-alpha-sialidase', 331, NULL, NULL, 217197),
(217198, '3.30.300.10-FF-000007', NULL, 'S-adenosylmethionine synthase', 153, NULL, NULL, 217198),
(217199, '3.30.200.20-FF-001756', NULL, 'Aurora kinase A', 70, NULL, NULL, 217199),
(217200, '3.30.365.10-FF-000062', NULL, 'Uncharacterized protein', 58, NULL, NULL, 217200),
(217201, '3.40.50.12650-FF-000016', NULL, 'DNA repair metallo-beta-lactamase-domain-containing protein', 131, NULL, NULL, 217201),
(217202, '3.90.110.10-FF-000036', NULL, NULL, 109, NULL, NULL, 217202),
(217203, '3.30.450.30-FF-000024', NULL, 'Dynein light chain roadblock', 100, NULL, NULL, 217203),
(217204, '1.25.40.10-FF-003961', NULL, 'Uncharacterized protein', 250, NULL, NULL, 217204),
(217205, '2.60.120.10-FF-000620', NULL, 'Uncharacterized protein', 93, NULL, NULL, 217205),
(217206, '2.60.200.40-FF-000017', NULL, 'Sphingoid long chain base kinase', 203, NULL, NULL, 217206),
(217207, '3.30.420.40-FF-000525', NULL, 'Alpha-centractin', 108, NULL, NULL, 217207),
(217208, '1.10.3080.10-FF-000035', NULL, 'Chloride channel protein', 86, NULL, NULL, 217208),
(217209, '1.50.40.10-FF-000019', NULL, 'Mitochondrial uncoupling protein 1', 290, NULL, NULL, 217209),
(217210, '3.80.10.10-FF-003305', NULL, 'Uncharacterized protein', 256, NULL, NULL, 217210),
(217211, '2.90.10.10-FF-000064', NULL, 'Uncharacterized protein', 63, NULL, NULL, 217211),
(217212, '3.40.50.720-FF-001177', NULL, 'epidermal retinol dehydrogenase 2', 264, NULL, NULL, 217212),
(217213, '3.40.50.1820-FF-000421', NULL, 'Possible epoxide hydrolase ephE', 307, NULL, NULL, 217213),
(217214, '2.170.120.12-FF-000012', NULL, 'DNA-directed RNA polymerases I and III subunit RPAC1', 129, NULL, NULL, 217214);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(217215, '3.30.450.40-FF-000297', NULL, 'Sensor histidine kinase, PAS and GAF domain-containing', 184, NULL, NULL, 217215),
(217216, '3.30.559.30-FF-000052', NULL, 'Nonribosomal peptide synthase, putative', 246, NULL, NULL, 217216),
(217217, '1.10.420.10-FF-000017', NULL, 'Catalase/peroxidase HPI', 28, NULL, NULL, 217217),
(217218, '2.40.10.10-FF-000122', NULL, 'Chymotrypsin-like elastase family member 1', 101, NULL, NULL, 217218),
(217219, '1.20.1070.10-FF-000060', NULL, 'Somatostatin receptor type 1', 304, NULL, NULL, 217219),
(217220, '3.40.50.12710-FF-000028', NULL, 'Protein arginine methyltransferase NDUFAF7', 332, NULL, NULL, 217220),
(217221, '3.30.70.330-FF-000959', NULL, 'Mitochondrial escape protein 2', 90, NULL, NULL, 217221),
(217222, '1.20.1110.10-FF-000232', NULL, 'Calcium-transporting ATPase', 383, NULL, NULL, 217222),
(217223, '3.50.50.60-FF-001339', NULL, 'Uncharacterized protein', 68, NULL, NULL, 217223),
(217224, '1.10.630.10-FF-000819', NULL, 'Uncharacterized protein', 249, NULL, NULL, 217224),
(217225, '2.130.10.10-FF-005935', NULL, 'Peptidyl-prolyl cis-trans isomerase, cyclophilin-type family protein', 263, NULL, NULL, 217225),
(217226, '2.120.10.80-FF-000257', NULL, 'Uncharacterized protein', 178, NULL, NULL, 217226),
(217227, '3.40.50.300-FF-002619', NULL, 'ABC transporter ATP-binding protein', 249, NULL, NULL, 217227),
(217228, '3.30.1360.170-FF-000014', NULL, 'Thymidylate synthase complementing protein ThyX', 212, NULL, NULL, 217228),
(217229, '3.30.70.330-FF-000223', NULL, 'Polypyrimidine tract binding protein 3', 102, NULL, NULL, 217229),
(217230, '3.30.1520.10-FF-000142', NULL, 'PX domain-containing protein C1450.12', 137, NULL, NULL, 217230),
(217231, '1.20.1250.20-FF-002252', NULL, 'Predicted protein', 110, NULL, NULL, 217231),
(217232, '1.10.3460.10-FF-000025', NULL, 'Fucoxanthin chlorophyll a/c light-harvesting protein', 190, NULL, NULL, 217232),
(217233, '2.170.300.10-FF-000063', NULL, 'netrin-4', 122, NULL, NULL, 217233),
(217234, '3.90.79.10-FF-000231', NULL, 'Uncharacterized protein', 87, NULL, NULL, 217234),
(217235, '3.80.10.10-FF-000343', NULL, 'CCR4-NOT transcription complex subunit', 157, NULL, NULL, 217235),
(217236, '2.130.10.10-FF-000320', NULL, 'echinoderm microtubule-associated protein-like 6', 278, NULL, NULL, 217236),
(217237, '1.20.1110.10-FF-000176', NULL, NULL, 251, NULL, NULL, 217237),
(217238, '1.10.510.10-FF-002880', NULL, NULL, 198, NULL, NULL, 217238),
(217239, '1.10.10.1940-FF-000004', NULL, 'Metalloendopeptidase', 42, NULL, NULL, 217239),
(217240, '3.40.190.10-FF-000046', NULL, 'Glycerol-3-phosphate transporter periplasmic binding protein', 193, NULL, NULL, 217240),
(217241, '3.40.50.300-FF-004952', NULL, 'Uncharacterized protein', 119, NULL, NULL, 217241),
(217242, '3.40.640.10-FF-000115', NULL, 'GntR family transcriptional regulator', 220, NULL, NULL, 217242),
(217243, '1.10.8.60-FF-000409', NULL, 'AGAP011652-PA', 91, NULL, NULL, 217243),
(217244, '3.30.40.10-FF-000128', NULL, 'lysine-specific demethylase 5C isoform X3', 61, NULL, NULL, 217244),
(217245, '2.40.10.170-FF-000024', NULL, 'ATP synthase subunit beta', 82, NULL, NULL, 217245),
(217246, '3.40.640.10-FF-000059', NULL, 'Serine palmitoyl CoA transferase subunit LcbA', 242, NULL, NULL, 217246),
(217247, '3.40.190.10-FF-000102', NULL, 'Osmoprotectant ABC transporter, permease protein', 154, NULL, NULL, 217247),
(217248, '2.60.40.3210-FF-000019', NULL, 'Zona pellucida glycoprotein 3 (sperm receptor), gene 2', 115, NULL, NULL, 217248),
(217249, '3.50.50.60-FF-000053', NULL, 'Geranylgeranyl reductase family', 421, NULL, NULL, 217249),
(217250, '1.10.472.80-FF-000219', NULL, NULL, 81, NULL, NULL, 217250),
(217251, '1.20.1270.60-FF-000270', NULL, 'Uncharacterized protein', 98, NULL, NULL, 217251),
(217252, '3.30.740.10-FF-000024', NULL, NULL, 69, NULL, NULL, 217252),
(217253, '1.20.1510.10-FF-000072', NULL, NULL, 208, NULL, NULL, 217253),
(217254, '1.10.3730.20-FF-000043', NULL, 'Uncharacterized protein', 115, NULL, NULL, 217254),
(217255, '2.30.130.40-FF-000024', NULL, 'Lon protease homolog 2, peroxisomal', 130, NULL, NULL, 217255);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(217256, '1.25.40.10-FF-000055', NULL, 'Serine/threonine-protein phosphatase', 161, NULL, NULL, 217256),
(217257, '2.60.120.560-FF-000034', NULL, 'Uncharacterized protein', 202, NULL, NULL, 217257),
(217258, '3.30.1320.10-FF-000014', NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', 135, NULL, NULL, 217258),
(217259, '3.40.50.12160-FF-000021', NULL, 'Ribosomal protein S12 methylthiotransferase RimO', 136, NULL, NULL, 217259),
(217260, '3.30.1330.50-FF-000004', NULL, '2-C-methyl-D-erythritol 2,4-cyclodiphosphate synthase', 184, NULL, NULL, 217260),
(217261, '2.130.10.10-FF-005643', NULL, 'Plexin C1', 174, NULL, NULL, 217261),
(217262, '2.10.25.10-FF-001546', NULL, 'Carbohydrate sulfotransferase', 51, NULL, NULL, 217262),
(217263, '3.40.1260.10-FF-000006', NULL, 'Sulfur relay protein TusB/DsrH', 93, NULL, NULL, 217263),
(217264, '3.30.420.10-FF-000657', NULL, NULL, 195, NULL, NULL, 217264),
(217265, '1.10.238.10-FF-000178', NULL, 'Calmodulin-2 A', 148, NULL, NULL, 217265),
(217266, '1.25.40.10-FF-001691', NULL, 'Pentatricopeptide repeat-containing protein At1g20300, mitochondrial', 70, NULL, NULL, 217266),
(217267, '1.10.220.150-FF-000013', NULL, 'Putative Arf GTPase-activating protein', 143, NULL, NULL, 217267),
(217268, '1.20.1070.10-FF-001133', NULL, 'Substance-K receptor', 351, NULL, NULL, 217268),
(217269, '2.60.40.60-FF-000306', NULL, 'Cadherin 23', 113, NULL, NULL, 217269),
(217270, '2.30.130.10-FF-000009', NULL, 'H/ACA ribonucleoprotein complex subunit 4', 125, NULL, NULL, 217270),
(217271, '3.40.50.300-FF-003788', NULL, 'INO80 complex subunit', 110, NULL, NULL, 217271),
(217272, '3.30.1390.30-FF-000007', NULL, 'Penicillin-binding protein 2', 75, NULL, NULL, 217272),
(217273, '3.30.160.60-FF-006188', NULL, NULL, 57, NULL, NULL, 217273),
(217274, '3.40.50.1820-FF-000657', NULL, 'Proline iminopeptidase', 402, NULL, NULL, 217274),
(217275, '3.30.70.330-FF-001095', NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', 97, NULL, NULL, 217275),
(217276, '3.90.640.90-FF-000015', NULL, 'Uncharacterized protein', 127, NULL, NULL, 217276),
(217277, '3.30.40.10-FF-000605', NULL, 'E3 ubiquitin-protein ligase PRT1', 96, NULL, NULL, 217277),
(217278, '3.40.1110.10-FF-000439', NULL, NULL, 121, NULL, NULL, 217278),
(217279, '3.40.120.10-FF-000059', NULL, 'GlcNAc phosphomutase', 169, NULL, NULL, 217279),
(217280, '4.10.60.10-FF-000083', NULL, 'Protein CBG13587', 28, NULL, NULL, 217280),
(217281, '3.30.40.10-FF-002314', NULL, 'Lid2 complex component lid2', 106, NULL, NULL, 217281),
(217282, '1.25.40.20-FF-001637', NULL, 'Predicted protein', 95, NULL, NULL, 217282),
(217283, '1.20.120.1480-FF-000001', NULL, 'DNA-binding protein RAP1', 102, NULL, NULL, 217283),
(217284, '3.40.50.150-FF-000848', NULL, NULL, 146, NULL, NULL, 217284),
(217285, '1.10.565.10-FF-000218', NULL, 'Uncharacterized protein', 71, NULL, NULL, 217285),
(217286, '1.10.510.10-FF-001244', NULL, 'Putative casein kinase I', 301, NULL, NULL, 217286),
(217287, '1.10.1200.270-FF-000032', NULL, 'S-adenosyl-L-methionine-dependent methyltransferase superfamily protein', 139, NULL, NULL, 217287),
(217288, '3.40.50.1240-FF-000112', NULL, '6-phosphofructo-2-kinase/fructose-2, 6-biphosphatase 1 splice variant', 212, NULL, NULL, 217288),
(217289, '2.30.30.100-FF-000173', NULL, 'Small nuclear ribonucleoprotein (LSM1), putative (AFU_orthologue AFUA_2G11800)', 117, NULL, NULL, 217289),
(217290, '1.10.10.10-FF-001008', NULL, 'Transcriptional regulator', 73, NULL, NULL, 217290),
(217291, '2.30.29.30-FF-000582', NULL, 'Vacuolar sorting protein', 88, NULL, NULL, 217291),
(217292, '3.10.20.230-FF-000036', NULL, 'Predicted protein', 97, NULL, NULL, 217292),
(217293, '1.10.400.10-FF-000073', NULL, 'Uncharacterized protein', 128, NULL, NULL, 217293),
(217294, '3.40.1110.10-FF-000350', NULL, NULL, 59, NULL, NULL, 217294),
(217295, '1.20.120.610-FF-000008', NULL, 'Vacuolar ATP synthase 16 kDa proteolipid subunit', 162, NULL, NULL, 217295),
(217296, '3.10.20.30-FF-000038', NULL, 'Molybdopterin synthase sulfur carrier subunit', 93, NULL, NULL, 217296); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(217297, '3.90.70.10-FF-000739', NULL, 'Uncharacterized protein', 150, NULL, NULL, 217297),
(217298, '2.60.120.260-FF-000534', NULL, 'Predicted protein', 257, NULL, NULL, 217298),
(217299, '2.60.40.10-FF-004086', NULL, NULL, 119, NULL, NULL, 217299),
(217300, '1.10.533.10-FF-000032', NULL, 'Nucleotide-binding oligomerization domain-containing protein 2', 81, NULL, NULL, 217300),
(217301, '3.40.50.300-FF-001282', NULL, 'RAB17, member RAS oncogene family', 197, NULL, NULL, 217301),
(217302, '1.10.630.10-FF-000258', NULL, 'Uncharacterized protein', 98, NULL, NULL, 217302),
(217303, '3.40.50.10470-FF-000008', NULL, 'Translation initiation factor 2B, beta subunit', 206, NULL, NULL, 217303),
(217304, '3.30.70.3250-FF-000021', NULL, NULL, 109, NULL, NULL, 217304),
(217305, '1.25.40.990-FF-000018', NULL, '26S proteasome regulatory subunit', 230, NULL, NULL, 217305),
(217306, '3.90.550.50-FF-000024', NULL, 'Hexosyltransferase', 234, NULL, NULL, 217306),
(217307, '3.40.50.300-FF-006661', NULL, 'RAB20, member RAS oncogene family', 86, NULL, NULL, 217307),
(217308, '3.30.1370.10-FF-000202', NULL, 'Vigilin 1', 82, NULL, NULL, 217308),
(217309, '3.30.65.10-FF-000011', NULL, 'DNA topoisomerase', 48, NULL, NULL, 217309),
(217310, '3.30.1680.10-FF-000012', NULL, 'Integrin beta', 61, NULL, NULL, 217310),
(217311, '3.75.10.10-FF-000041', NULL, NULL, 92, NULL, NULL, 217311),
(217312, '3.30.160.60-FF-002349', NULL, 'Zinc finger and BTB domain-containing 40', 28, NULL, NULL, 217312),
(217313, '3.30.1240.10-FF-000013', NULL, 'Cof-type HAD-IIB family hydrolase', 101, NULL, NULL, 217313),
(217314, '1.10.472.10-FF-000154', NULL, 'Cyclin-B1-4', 113, NULL, NULL, 217314),
(217315, '2.130.10.10-FF-004007', NULL, 'Uncharacterized protein', 226, NULL, NULL, 217315),
(217316, '3.40.250.10-FF-000248', NULL, 'Uncharacterized protein', 120, NULL, NULL, 217316),
(217317, '3.40.50.1700-FF-000059', NULL, 'Uncharacterized protein', 76, NULL, NULL, 217317),
(217318, '2.30.29.30-FF-001251', NULL, 'BEACH domain-containing protein lvsB', 109, NULL, NULL, 217318),
(217319, '2.60.40.10-FF-003102', NULL, 'Ciliary neurotrophic factor receptor', 85, NULL, NULL, 217319),
(217320, '3.40.50.2300-FF-001335', NULL, NULL, 74, NULL, NULL, 217320),
(217321, '3.30.40.10-FF-000460', NULL, 'Anaphase promoting complex subunit 11', 85, NULL, NULL, 217321),
(217322, '1.25.40.410-FF-000013', NULL, 'CED-5', 146, NULL, NULL, 217322),
(217323, '1.20.1250.20-FF-002336', NULL, 'Protein CBG12921', 117, NULL, NULL, 217323),
(217324, '3.40.50.1820-FF-001062', NULL, 'NonRibosomal Peptide Synthetase', 219, NULL, NULL, 217324),
(217325, '3.30.465.10-FF-000007', NULL, 'TerC family inner membrane protein', 81, NULL, NULL, 217325),
(217326, '1.10.510.10-FF-002548', NULL, 'Uncharacterized protein', 290, NULL, NULL, 217326),
(217327, '3.30.70.330-FF-001151', NULL, 'RNA-binding protein PIN4', 138, NULL, NULL, 217327),
(217328, '2.30.30.140-FF-000134', NULL, 'C.Elegans Chromodomain protein', 84, NULL, NULL, 217328),
(217329, '2.60.120.200-FF-000179', NULL, 'Unplaced genomic scaffold supercont1.19, whole genome shotgun sequence', 302, NULL, NULL, 217329),
(217330, '2.60.40.10-FF-006031', NULL, NULL, 69, NULL, NULL, 217330),
(217331, '3.30.420.40-FF-000672', NULL, 'Predicted protein', 86, NULL, NULL, 217331),
(217332, '1.10.510.10-FF-004206', NULL, NULL, 218, NULL, NULL, 217332),
(217333, '1.10.1370.30-FF-000001', NULL, 'Angiotensin-converting enzyme', 533, NULL, NULL, 217333),
(217334, '3.30.200.20-FF-002425', NULL, 'Uncharacterized protein', 127, NULL, NULL, 217334),
(217335, '3.40.50.1000-FF-000855', NULL, NULL, 52, NULL, NULL, 217335),
(217336, '3.40.50.920-FF-000012', NULL, 'Transketolase, variant 1', 131, NULL, NULL, 217336),
(217337, '1.25.10.10-FF-002116', NULL, 'RING-type E3 ubiquitin transferase', 176, NULL, NULL, 217337),
(217338, '2.30.30.790-FF-000008', NULL, 'Mitochondrial ribosomal protein L19', 84, NULL, NULL, 217338),
(217339, '1.25.40.10-FF-003725', NULL, 'Transcription factor tau subunit sfc4', 268, NULL, NULL, 217339),
(217340, '2.40.128.20-FF-000044', NULL, 'LiPocalin-Related protein', 170, NULL, NULL, 217340);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(217341, '2.40.50.140-FF-000501', NULL, 'Cold shock protein', 85, NULL, NULL, 217341),
(217342, '3.40.50.300-FF-003316', NULL, 'Uncharacterized protein', 199, NULL, NULL, 217342),
(217343, '3.30.160.60-FF-006244', NULL, NULL, 66, NULL, NULL, 217343),
(217344, '1.25.10.10-FF-000227', NULL, 'AP-4 complex subunit epsilon', 586, NULL, NULL, 217344),
(217345, '2.170.120.30-FF-000009', NULL, 'Putative exported protein', 105, NULL, NULL, 217345),
(217346, '3.30.190.20-FF-000012', NULL, '50S ribosomal protein L1', 113, NULL, NULL, 217346),
(217347, '1.20.1070.10-FF-001077', NULL, 'Octopressin receptor', 363, NULL, NULL, 217347),
(217348, '1.20.1250.20-FF-001555', NULL, 'YALI0C00847p', 407, NULL, NULL, 217348),
(217349, '3.50.20.20-FF-000005', NULL, 'Uncharacterized protein', 129, NULL, NULL, 217349),
(217350, '3.40.50.11580-FF-000004', NULL, 'Polyprotein 1ab', 118, NULL, NULL, 217350),
(217351, '3.40.50.1010-FF-000004', NULL, 'rRNA-processing protein FCF1 homolog', 143, NULL, NULL, 217351),
(217352, '3.40.1350.10-FF-000036', NULL, 'tRNA-splicing endonuclease subunit Sen2', 92, NULL, NULL, 217352),
(217353, '3.40.1110.10-FF-000294', NULL, NULL, 27, NULL, NULL, 217353),
(217354, '3.30.70.20-FF-000054', NULL, 'NADP-reducing hydrogenase subunit HndC', 51, NULL, NULL, 217354),
(217355, '3.40.50.300-FF-006806', NULL, 'Uncharacterized protein', 50, NULL, NULL, 217355),
(217356, '3.40.720.10-FF-000357', NULL, 'Predicted protein', 361, NULL, NULL, 217356),
(217357, '3.40.350.10-FF-000048', NULL, 'Putative aminopeptidase P1', 146, NULL, NULL, 217357),
(217358, '3.40.50.150-FF-000472', NULL, '25S rRNA adenine-N(1) methyltransferase', 137, NULL, NULL, 217358),
(217359, '3.30.1490.20-FF-000006', NULL, 'phosphoribosylamine--glycine ligase, chloroplastic-like', 71, NULL, NULL, 217359),
(217360, '1.10.168.10-FF-000003', NULL, 'Phosducin', 48, NULL, NULL, 217360),
(217361, '3.30.1470.10-FF-000002', NULL, 'Photosystem I reaction center subunit II', 143, NULL, NULL, 217361),
(217362, '2.70.150.10-FF-000007', NULL, 'Phospholipid-transporting ATPase', 129, NULL, NULL, 217362),
(217363, '1.25.10.10-FF-001863', NULL, 'Uncharacterized protein', 170, NULL, NULL, 217363),
(217364, '1.10.8.60-FF-000561', NULL, 'Uncharacterized protein', 87, NULL, NULL, 217364),
(217365, '3.80.10.10-FF-002760', NULL, 'Uncharacterized protein', 72, NULL, NULL, 217365),
(217366, '1.10.630.10-FF-000735', NULL, 'Uncharacterized protein', 90, NULL, NULL, 217366),
(217367, '2.40.160.50-FF-000004', NULL, 'Protein TOC75-3 chloroplastic', 347, NULL, NULL, 217367),
(217368, '3.40.50.300-FF-001990', NULL, 'Ras family, other', 115, NULL, NULL, 217368),
(217369, '1.10.150.80-FF-000040', NULL, 'RecQ', 86, NULL, NULL, 217369),
(217370, '1.20.120.150-FF-000005', NULL, 'GTOR', 90, NULL, NULL, 217370),
(217371, '2.10.25.10-FF-001170', NULL, 'Predicted protein', 48, NULL, NULL, 217371),
(217372, '1.10.10.10-FF-000194', NULL, 'HTH-type transcriptional regulator Hpr', 167, NULL, NULL, 217372),
(217373, '2.60.120.310-FF-000009', NULL, 'Monooxygenase, DBH-like 1, like', 151, NULL, NULL, 217373),
(217374, '3.30.420.10-FF-000281', NULL, NULL, 38, NULL, NULL, 217374),
(217375, '3.40.50.1100-FF-000211', NULL, 'Uncharacterized protein', 185, NULL, NULL, 217375),
(217376, '3.30.420.40-FF-000817', NULL, 'Putative nodulation protein nolNO', 118, NULL, NULL, 217376),
(217377, '3.60.20.10-FF-000007', NULL, 'Proteasome subunit alpha type', 251, NULL, NULL, 217377),
(217378, '3.40.50.300-FF-002535', NULL, 'SMC5 protein', 197, NULL, NULL, 217378),
(217379, '1.25.10.10-FF-000879', NULL, 'Serine/threonine-protein kinase TOR', 337, NULL, NULL, 217379),
(217380, '3.20.10.10-FF-000065', NULL, 'Uncharacterized protein', 15, NULL, NULL, 217380),
(217381, '1.20.1560.10-FF-000491', NULL, 'Uncharacterized protein', 273, NULL, NULL, 217381),
(217382, '3.80.10.10-FF-002849', NULL, 'Predicted protein', 112, NULL, NULL, 217382),
(217383, '1.20.1070.10-FF-000352', NULL, 'Latrophilin-like protein 1', 283, NULL, NULL, 217383),
(217384, '1.10.1420.10-FF-000112', NULL, 'Muts domain V-domain-containing protein', 125, NULL, NULL, 217384); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(217385, '1.10.8.270-FF-000073', NULL, 'TBC1 domain family, member 22B', 104, NULL, NULL, 217385),
(217386, '3.30.890.10-FF-000012', NULL, 'Methyl-CpG-binding domain-containing protein 1', 100, NULL, NULL, 217386),
(217387, '1.10.8.10-FF-000243', NULL, 'YALI0E14927p', 70, NULL, NULL, 217387),
(217388, '3.10.310.20-FF-000027', NULL, NULL, 222, NULL, NULL, 217388),
(217389, '3.90.1290.10-FF-000042', NULL, 'Dystonin', 200, NULL, NULL, 217389),
(217390, '3.30.70.580-FF-000045', NULL, 'tRNA pseudouridine synthase', 122, NULL, NULL, 217390),
(217391, '2.60.40.150-FF-000099', NULL, 'Copine 3', 132, NULL, NULL, 217391),
(217392, '1.10.472.130-FF-000030', NULL, 'Dynein heavy chain family protein', 107, NULL, NULL, 217392),
(217393, '2.120.10.30-FF-000091', NULL, 'Aminopeptidase C', 197, NULL, NULL, 217393),
(217394, '2.80.10.50-FF-000110', NULL, 'Mannose receptor, C type 1a', 135, NULL, NULL, 217394),
(217395, '1.25.40.10-FF-002472', NULL, 'Pentatricopeptide repeat-containing protein At4g13650', 120, NULL, NULL, 217395),
(217396, '3.30.160.20-FF-000095', NULL, 'Uncharacterized protein', 67, NULL, NULL, 217396),
(217397, '3.10.196.10-FF-000004', NULL, 'Methionine synthase', 224, NULL, NULL, 217397),
(217398, '3.30.40.230-FF-000007', NULL, 'Glycine-tRNA ligase', 78, NULL, NULL, 217398),
(217399, '1.10.1070.11-FF-000075', NULL, 'Non-specific serine/threonine protein kinase', 187, NULL, NULL, 217399),
(217400, '2.20.25.10-FF-000101', NULL, 'DNA-directed RNA polymerase subunit', 68, NULL, NULL, 217400),
(217401, '3.50.40.10-FF-000003', NULL, 'Phenylalanine--tRNA ligase beta subunit', 197, NULL, NULL, 217401),
(217402, '1.20.1280.290-FF-000005', NULL, 'PQ-loop repeat-containing protein 1', 92, NULL, NULL, 217402),
(217403, '1.10.472.10-FF-000098', NULL, 'Cyclin N-terminal domain containing 2', 65, NULL, NULL, 217403),
(217404, '3.30.1550.10-FF-000003', NULL, '39S ribosomal protein L11, mitochondrial', 67, NULL, NULL, 217404),
(217405, '3.40.50.300-FF-005733', NULL, 'tRNA 2-selenouridine/geranyl-2-thiouridine synthase', 154, NULL, NULL, 217405),
(217406, '1.10.245.10-FF-000003', NULL, 'Zinc finger CCCH domain-containing protein 19', 96, NULL, NULL, 217406),
(217407, '3.40.50.720-FF-001380', NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase', 183, NULL, NULL, 217407),
(217408, '1.25.40.10-FF-004653', NULL, 'Uncharacterized protein', 121, NULL, NULL, 217408),
(217409, '1.10.268.10-FF-000039', NULL, NULL, 88, NULL, NULL, 217409),
(217410, '1.10.287.130-FF-000102', NULL, 'Two-component sensor histidine kinase', 73, NULL, NULL, 217410),
(217411, '3.80.10.10-FF-002052', NULL, 'Predicted protein', 189, NULL, NULL, 217411),
(217412, '3.30.160.60-FF-001129', NULL, 'zinc finger protein 181 isoform X1', 29, NULL, NULL, 217412),
(217413, '3.10.20.10-FF-000032', NULL, '60S ribosomal protein L18a', 64, NULL, NULL, 217413),
(217414, '1.20.120.350-FF-000149', NULL, NULL, 130, NULL, NULL, 217414),
(217415, '3.30.830.10-FF-000267', NULL, 'Clan ME, family M16, insulinase-like metallopeptidase', 251, NULL, NULL, 217415),
(217416, '3.80.10.10-FF-001068', NULL, 'Leucine-rich repeat containing protein', 139, NULL, NULL, 217416),
(217417, '3.40.30.10-FF-000638', NULL, 'Uncharacterized protein', 67, NULL, NULL, 217417),
(217418, '3.40.50.20-FF-000030', NULL, 'Phosphoribosylaminoimidazole carboxylase', 112, NULL, NULL, 217418),
(217419, '3.30.1390.10-FF-000001', NULL, '50S ribosomal protein L7/L12', 71, NULL, NULL, 217419),
(217420, '2.60.40.420-FF-000056', NULL, 'Coagulation factor V', 350, NULL, NULL, 217420),
(217421, '3.40.50.300-FF-000354', NULL, 'ATP-dependent RNA helicase SKI2', 210, NULL, NULL, 217421),
(217422, '3.40.50.300-FF-004188', NULL, 'Adenosinetriphosphatase', 80, NULL, NULL, 217422),
(217423, '3.40.50.1000-FF-000327', NULL, 'Probable sucrose-phosphate synthase 2', 95, NULL, NULL, 217423),
(217424, '1.10.10.10-FF-000755', NULL, 'Carbohydrate kinase, PfkB family', 57, NULL, NULL, 217424),
(217425, '3.30.160.60-FF-001837', NULL, 'Zgc:110821', 28, NULL, NULL, 217425),
(217426, '1.20.1420.30-FF-000048', NULL, 'Cation/calcium exchanger 5', 128, NULL, NULL, 217426);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(217427, '3.40.50.1820-FF-000713', NULL, 'YALI0E05907p', 355, NULL, NULL, 217427),
(217428, '1.20.5.340-FF-000029', NULL, 'Coiled-coil domain-containing protein 90-like', 101, NULL, NULL, 217428),
(217429, '1.25.40.10-FF-004130', NULL, 'Uncharacterized protein', 121, NULL, NULL, 217429),
(217430, '1.10.472.10-FF-000418', NULL, 'Cyclin domain-containing protein', 80, NULL, NULL, 217430),
(217431, '2.130.10.10-FF-000972', NULL, 'Tumor suppressing subtransferable candidate 1', 231, NULL, NULL, 217431),
(217432, '2.120.10.30-FF-000467', NULL, 'Uncharacterized protein', 67, NULL, NULL, 217432),
(217433, '3.40.50.150-FF-001692', NULL, NULL, 93, NULL, NULL, 217433),
(217434, '3.40.50.300-FF-005025', NULL, 'Uncharacterized protein', 169, NULL, NULL, 217434),
(217435, '3.90.1010.10-FF-000027', NULL, 'Uncharacterized protein', 91, NULL, NULL, 217435),
(217436, '2.30.29.30-FF-000323', NULL, 'Uncharacterized protein, isoform C', 123, NULL, NULL, 217436),
(217437, '3.30.310.80-FF-000012', NULL, 'Non-specific serine/threonine protein kinase', 100, NULL, NULL, 217437),
(217438, '1.20.1070.10-FF-000728', NULL, 'Uncharacterized protein', 303, NULL, NULL, 217438),
(217439, '3.30.40.10-FF-002258', NULL, 'Predicted protein', 56, NULL, NULL, 217439),
(217440, '3.40.850.10-FF-000305', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', 142, NULL, NULL, 217440),
(217441, '3.10.20.810-FF-000002', NULL, 'Histidine biosynthesis trifunctional protein', 97, NULL, NULL, 217441),
(217442, '1.10.10.2660-FF-000006', NULL, 'Ubiquitin modifier-activating enzyme 1', 244, NULL, NULL, 217442),
(217443, '3.30.590.50-FF-000012', NULL, 'Gamma-glutamylcysteine synthetase', 130, NULL, NULL, 217443),
(217444, '3.40.50.720-FF-001469', NULL, 'Hypothetical pyrroline-5-carboxylate reductase (Eurofung)', 182, NULL, NULL, 217444),
(217445, '2.130.10.10-FF-000264', NULL, 'WD repeat and SOCS box containing 2', 196, NULL, NULL, 217445),
(217446, '3.30.260.10-FF-000094', NULL, NULL, 91, NULL, NULL, 217446),
(217447, '3.30.160.60-FF-002821', NULL, 'Transcriptional regulator MET32', 43, NULL, NULL, 217447),
(217448, '1.25.40.10-FF-002505', NULL, 'Clustered mitochondria protein homolog', 111, NULL, NULL, 217448),
(217449, '1.20.120.1750-FF-000014', NULL, 'Cullin 9', 229, NULL, NULL, 217449),
(217450, '3.30.540.10-FF-000076', NULL, '3''(2''),5''-bisphosphate nucleotidase', 229, NULL, NULL, 217450),
(217451, '3.40.50.300-FF-008459', NULL, 'Uncharacterized protein', 318, NULL, NULL, 217451),
(217452, '1.10.10.60-FF-000253', NULL, 'Transcriptional regulator, AraC family', 107, NULL, NULL, 217452),
(217453, '1.10.2000.10-FF-000058', NULL, NULL, 132, NULL, NULL, 217453),
(217454, '2.20.110.10-FF-000027', NULL, 'Phosphatidylinositol 4-phosphate 5-kinase', 52, NULL, NULL, 217454),
(217455, '2.130.10.10-FF-003698', NULL, 'NACHT domain- and WD repeat-containing protein 1', 245, NULL, NULL, 217455),
(217456, '3.30.860.10-FF-000004', NULL, 'Predicted protein', 61, NULL, NULL, 217456),
(217457, '1.25.40.10-FF-000235', NULL, 'MAU2 sister chromatid cohesion factor', 163, NULL, NULL, 217457),
(217458, '1.20.120.430-FF-000022', NULL, 'tRNA modification GTPase MnmE', 168, NULL, NULL, 217458),
(217459, '1.50.10.10-FF-000107', NULL, 'Predicted protein', 416, NULL, NULL, 217459),
(217460, '1.25.40.210-FF-000009', NULL, 'Telomeric repeat-binding factor', 128, NULL, NULL, 217460),
(217461, '1.20.1070.10-FF-001841', NULL, 'Predicted protein', 301, NULL, NULL, 217461),
(217462, '3.40.50.11260-FF-000026', NULL, 'Predicted protein', 90, NULL, NULL, 217462),
(217463, '3.30.160.60-FF-004951', NULL, NULL, 63, NULL, NULL, 217463),
(217464, '1.20.58.860-FF-000011', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 62, NULL, NULL, 217464),
(217465, '1.10.455.10-FF-000013', NULL, 'Ribosomal protein', 56, NULL, NULL, 217465),
(217466, '3.60.10.10-FF-000237', NULL, '2'',5''-phosphodiesterase 12', 339, NULL, NULL, 217466),
(217467, '1.10.530.10-FF-000082', NULL, 'Chitinase family protein', 207, NULL, NULL, 217467),
(217468, '3.10.110.10-FF-000037', NULL, 'ubiquitin-conjugating enzyme E2 27', 152, NULL, NULL, 217468);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(217469, '1.10.510.10-FF-001952', NULL, 'Protein kinase-like protein', 172, NULL, NULL, 217469),
(217470, '3.90.550.10-FF-000327', NULL, 'Minor teichoic acid biosynthesis protein GgaB', 255, NULL, NULL, 217470),
(217471, '2.130.10.10-FF-000500', NULL, 'Neutral sphingomyelinase activation associated factor', 68, NULL, NULL, 217471),
(217472, '3.40.50.620-FF-000192', NULL, 'Valine--tRNA ligase', 203, NULL, NULL, 217472),
(217473, '3.40.50.10810-FF-000009', NULL, 'B-TFIID TATA-box-binding protein-associated factor 1', 267, NULL, NULL, 217473),
(217474, '1.10.132.60-FF-000014', NULL, 'DNA polymerase', 110, NULL, NULL, 217474),
(217475, '2.20.100.10-FF-000201', NULL, 'Thrombospondin type-1 domain-containing protein 7B', 57, NULL, NULL, 217475),
(217476, '1.10.10.10-FF-001716', NULL, 'Regulatory protein', 110, NULL, NULL, 217476),
(217477, '2.60.120.650-FF-000061', NULL, 'Glucosamine 6-phosphate N-acetyltransferase', 236, NULL, NULL, 217477),
(217478, '4.10.1060.10-FF-000014', NULL, 'Putative zinc finger, RanBP2-type', 39, NULL, NULL, 217478),
(217479, '3.30.710.10-FF-000292', NULL, 'Similar to TD and POZ domain-containing 2', 111, NULL, NULL, 217479),
(217480, '2.170.270.10-FF-000065', NULL, 'Histone-lysine N-methyltransferase ATXR3', 191, NULL, NULL, 217480),
(217481, '2.60.40.10-FF-000663', NULL, 'myelin-associated glycoprotein isoform X1', 120, NULL, NULL, 217481),
(217482, '2.130.10.10-FF-005699', NULL, 'Uncharacterized protein', 150, NULL, NULL, 217482),
(217483, '1.20.1260.140-FF-000012', NULL, NULL, 140, NULL, NULL, 217483),
(217484, '3.40.50.200-FF-000094', NULL, 'Serine protease (Putative secreted protein)', 309, NULL, NULL, 217484),
(217485, '3.40.50.300-FF-004244', NULL, 'RAD51 isoform 1', 89, NULL, NULL, 217485),
(217486, '1.20.1200.10-FF-000003', NULL, 'ATP:cob(I)alamin adenosyltransferase', 172, NULL, NULL, 217486),
(217487, '2.40.320.10-FF-000027', NULL, 'Mediator of RNA polymerase II transcription subunit 18', 175, NULL, NULL, 217487),
(217488, '1.10.1200.10-FF-000096', NULL, 'Anthracycline acyl carrier protein DauA', 82, NULL, NULL, 217488),
(217489, '3.40.50.2300-FF-000610', NULL, 'Guanylate cyclase', 55, NULL, NULL, 217489),
(217490, '1.25.40.10-FF-004506', NULL, 'Uncharacterized protein', 90, NULL, NULL, 217490),
(217491, '3.30.930.10-FF-000364', NULL, 'Uncharacterized protein', 54, NULL, NULL, 217491),
(217492, '3.40.50.1820-FF-001585', NULL, 'Uncharacterized protein', 92, NULL, NULL, 217492),
(217493, '2.10.25.10-FF-000618', NULL, 'Fibrillin 3', 37, NULL, NULL, 217493),
(217494, '1.20.1070.10-FF-002061', NULL, 'Predicted protein', 88, NULL, NULL, 217494),
(217495, '3.30.565.10-FF-000335', NULL, 'Two-component sensor histidine kinase', 152, NULL, NULL, 217495),
(217496, '1.25.40.10-FF-000763', NULL, 'Putative pentatricopeptide repeat-containing protein', 159, NULL, NULL, 217496),
(217497, '3.90.70.10-FF-000178', NULL, 'Ubiquitin carboxyl-terminal hydrolase cyk-3', 183, NULL, NULL, 217497),
(217498, '2.60.120.330-FF-000167', NULL, 'Uncharacterized protein', 324, NULL, NULL, 217498),
(217499, '3.40.50.11370-FF-000003', NULL, 'Inositol-tetrakisphosphate 1-kinase isoform a', 37, NULL, NULL, 217499),
(217500, '1.10.510.10-FF-004173', NULL, NULL, 152, NULL, NULL, 217500),
(217501, '1.25.40.20-FF-000709', NULL, 'Calcium transporter 2', 109, NULL, NULL, 217501),
(217502, '1.10.287.110-FF-000416', NULL, 'Heat shock protein, putative', 98, NULL, NULL, 217502),
(217503, '2.120.10.30-FF-000411', NULL, 'Uncharacterized protein', 187, NULL, NULL, 217503),
(217504, '3.40.50.1220-FF-000101', NULL, 'Uncharacterized protein', 87, NULL, NULL, 217504),
(217505, '1.20.58.60-FF-000290', NULL, 'Spectrin repeat containing nuclear envelope protein 1', 176, NULL, NULL, 217505),
(217506, '3.40.50.300-FF-006189', NULL, 'Predicted protein', 183, NULL, NULL, 217506),
(217507, '3.40.50.300-FF-008083', NULL, 'DNA helicase', 116, NULL, NULL, 217507),
(217508, '1.20.144.10-FF-000042', NULL, 'PAP2 domain protein', 284, NULL, NULL, 217508),
(217509, '3.30.160.60-FF-005171', NULL, NULL, 28, NULL, NULL, 217509);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(217510, '3.30.1120.130-FF-000005', NULL, 'AGAP012499-PA', 103, NULL, NULL, 217510),
(217511, '3.30.30.30-FF-000026', NULL, 'Protein CBG00051', 54, NULL, NULL, 217511),
(217512, '3.30.565.10-FF-000482', NULL, 'Uncharacterized protein', 72, NULL, NULL, 217512),
(217513, '3.90.870.10-FF-000019', NULL, 'Translation factor Sua5', 214, NULL, NULL, 217513),
(217514, '4.10.400.10-FF-000342', NULL, 'Uncharacterized protein', 36, NULL, NULL, 217514),
(217515, '1.20.1070.10-FF-001656', NULL, 'Uncharacterized protein', 130, NULL, NULL, 217515),
(217516, '3.30.70.100-FF-000059', NULL, 'protein NipSnap homolog 3A isoform X2', 63, NULL, NULL, 217516),
(217517, '1.10.246.130-FF-000015', NULL, 'Gamma-glutamyltransferase 5', 110, NULL, NULL, 217517),
(217518, '3.40.30.10-FF-000790', NULL, 'Glutathione S-transferase', 73, NULL, NULL, 217518),
(217519, '2.40.50.140-FF-000181', NULL, 'CST complex subunit STN1', 169, NULL, NULL, 217519),
(217520, '3.80.10.10-FF-001124', NULL, 'Os06g0692100 protein', 72, NULL, NULL, 217520),
(217521, '1.10.1420.10-FF-000168', NULL, 'Chromosome 1, whole genome shotgun sequence', 212, NULL, NULL, 217521),
(217522, '1.10.150.50-FF-000109', NULL, 'Ste50p', 80, NULL, NULL, 217522),
(217523, '2.60.60.30-FF-000001', NULL, 'Tellurium resistance protein TerD', 169, NULL, NULL, 217523),
(217524, '3.40.50.720-FF-000452', NULL, 'Malate dehydrogenase (NAD)', 148, NULL, NULL, 217524),
(217525, '2.30.30.1020-FF-000010', NULL, 'CCR4-NOT transcription complex subunit 3', 81, NULL, NULL, 217525),
(217526, '3.40.50.1820-FF-001641', NULL, 'Uncharacterized protein', 405, NULL, NULL, 217526),
(217527, '3.10.110.10-FF-000222', NULL, 'Uncharacterized protein', 145, NULL, NULL, 217527),
(217528, '2.40.50.140-FF-000557', NULL, '30S ribosomal protein S17', 101, NULL, NULL, 217528),
(217529, '2.60.40.1090-FF-000041', NULL, 'Fimbrial subunit CupA4', 180, NULL, NULL, 217529),
(217530, '3.30.70.660-FF-000058', NULL, 'tRNA pseudouridine synthase A', 136, NULL, NULL, 217530),
(217531, '1.10.287.550-FF-000020', NULL, 'Uncharacterized protein', 59, NULL, NULL, 217531),
(217532, '1.10.510.10-FF-000991', NULL, 'CAMK/CDPK protein kinase', 203, NULL, NULL, 217532),
(217533, '2.60.40.1400-FF-000027', NULL, NULL, 186, NULL, NULL, 217533),
(217534, '3.30.830.10-FF-000323', NULL, 'Presequence protease', 89, NULL, NULL, 217534),
(217535, '1.10.10.10-FF-000699', NULL, 'ArsR family transcriptional regulator', 100, NULL, NULL, 217535),
(217536, '3.40.50.10490-FF-000166', NULL, NULL, 123, NULL, NULL, 217536),
(217537, '3.80.10.10-FF-003777', NULL, 'Uncharacterized protein', 106, NULL, NULL, 217537),
(217538, '2.10.50.10-FF-000042', NULL, 'Signal peptide, CUB domain and EGF like domain containing 2', 58, NULL, NULL, 217538),
(217539, '1.10.287.70-FF-000522', NULL, 'Receptor for egg jelly 6', 123, NULL, NULL, 217539),
(217540, '3.40.50.1820-FF-001438', NULL, 'Lipase, putative', 191, NULL, NULL, 217540),
(217541, '3.10.490.20-FF-000039', NULL, 'Uncharacterized protein', 120, NULL, NULL, 217541),
(217542, '3.40.50.1110-FF-000124', NULL, 'Probable cytochrome c', 201, NULL, NULL, 217542),
(217543, '3.50.50.60-FF-000614', NULL, 'Salicylate hydroxylase', 376, NULL, NULL, 217543),
(217544, '3.30.40.10-FF-001533', NULL, 'Uncharacterized protein', 65, NULL, NULL, 217544),
(217545, '3.30.160.60-FF-004619', NULL, NULL, 44, NULL, NULL, 217545),
(217546, '3.90.1310.10-FF-000011', NULL, 'Penicillin-binding protein 2B', 64, NULL, NULL, 217546),
(217547, '1.25.40.20-FF-000856', NULL, 'Leucine-rich repeat serine/threonine-protein kinase 1', 141, NULL, NULL, 217547),
(217548, '4.10.640.10-FF-000028', NULL, 'ADL117Wp', 79, NULL, NULL, 217548),
(217549, '2.60.40.10-FF-004406', NULL, NULL, 103, NULL, NULL, 217549),
(217550, '3.30.70.330-FF-001656', NULL, NULL, 137, NULL, NULL, 217550),
(217551, '3.90.226.10-FF-000057', NULL, 'Protease 4', 100, NULL, NULL, 217551),
(217552, '2.40.70.10-FF-000418', NULL, NULL, 115, NULL, NULL, 217552),
(217553, '3.30.2290.10-FF-000022', NULL, 'Zinc protease PmbA, putative', 216, NULL, NULL, 217553),
(217554, '3.10.450.50-FF-000080', NULL, 'ECF RNA polymerase sigma factor SigJ', 127, NULL, NULL, 217554);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(217555, '3.40.50.300-FF-005205', NULL, 'Ras2p', 210, NULL, NULL, 217555),
(217556, '2.10.70.40-FF-000001', NULL, 'Flagellar assembly peptidoglycan hydrolase FlgJ', 52, NULL, NULL, 217556),
(217557, '3.40.920.10-FF-000013', NULL, 'Indolepyruvate oxidoreductase, IorB subunit, putative', 203, NULL, NULL, 217557),
(217558, '3.40.50.1000-FF-000147', NULL, 'H/K ATPase alpha subunit, putative', 173, NULL, NULL, 217558),
(217559, '1.10.238.10-FF-000739', NULL, 'Glycerol-3-phosphate dehydrogenase', 76, NULL, NULL, 217559),
(217560, '3.30.1360.70-FF-000023', NULL, NULL, 117, NULL, NULL, 217560),
(217561, '2.130.10.10-FF-004715', NULL, 'Uncharacterized protein', 169, NULL, NULL, 217561),
(217562, '3.30.160.60-FF-000909', NULL, 'zinc finger and BTB domain-containing protein 40', 25, NULL, NULL, 217562),
(217563, '1.25.10.10-FF-000935', NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit', 322, NULL, NULL, 217563),
(217564, '1.10.20.10-FF-000020', NULL, 'Histone H2A', 123, NULL, NULL, 217564),
(217565, '3.40.50.2300-FF-000554', NULL, 'Two-component response regulator', 150, NULL, NULL, 217565),
(217566, '3.90.70.10-FF-000234', NULL, 'Ubiquitin specific peptidase 26', 197, NULL, NULL, 217566),
(217567, '1.10.30.50-FF-000010', NULL, 'HNH endonuclease', 95, NULL, NULL, 217567),
(217568, '3.10.20.90-FF-000977', NULL, 'Uncharacterized protein', 100, NULL, NULL, 217568),
(217569, '3.40.50.1360-FF-000002', NULL, 'Glucosamine-6-phosphate deaminase', 267, NULL, NULL, 217569),
(217570, '2.60.40.380-FF-000004', NULL, 'Purple acid phosphatase', 117, NULL, NULL, 217570),
(217571, '4.10.240.10-FF-000155', NULL, 'SfgA', 92, NULL, NULL, 217571),
(217572, '3.40.50.300-FF-007678', NULL, 'Uncharacterized protein', 115, NULL, NULL, 217572),
(217573, '3.30.160.60-FF-000348', NULL, 'zinc finger protein 260', 28, NULL, NULL, 217573),
(217574, '1.20.1250.20-FF-001611', NULL, 'Uncharacterized protein P0668F02.8', 188, NULL, NULL, 217574),
(217575, '1.10.510.10-FF-000283', NULL, 'Mitogen-activated protein kinase', 92, NULL, NULL, 217575),
(217576, '2.60.40.60-FF-000829', NULL, 'Uncharacterized protein', 102, NULL, NULL, 217576),
(217577, '3.80.10.10-FF-000719', NULL, 'MDIS1-interacting receptor like kinase 2 isoform A', 103, NULL, NULL, 217577),
(217578, '3.40.350.10-FF-000104', NULL, 'Uncharacterized protein', 152, NULL, NULL, 217578),
(217579, '3.30.160.60-FF-000404', NULL, 'POZ-, AT hook-, and zinc finger-containing protein 1', 26, NULL, NULL, 217579),
(217580, '3.90.215.10-FF-000009', NULL, 'Fibrinogen alpha chain', 182, NULL, NULL, 217580),
(217581, '3.10.20.90-FF-000449', NULL, 'Fra2p', 110, NULL, NULL, 217581),
(217582, '1.10.8.60-FF-000033', NULL, 'paraplegin isoform X1', 77, NULL, NULL, 217582),
(217583, '3.40.50.720-FF-002397', NULL, 'Uncharacterized protein', 53, NULL, NULL, 217583),
(217584, '3.40.50.10330-FF-000056', NULL, 'Yef1p', 167, NULL, NULL, 217584),
(217585, '3.30.40.10-FF-001909', NULL, 'VPS8, CORVET complex subunit', 111, NULL, NULL, 217585),
(217586, '1.25.40.770-FF-000008', NULL, 'Uncharacterized protein', 199, NULL, NULL, 217586),
(217587, '1.20.58.1120-FF-000048', NULL, NULL, 142, NULL, NULL, 217587),
(217588, '3.30.200.20-FF-001700', NULL, 'Uncharacterized protein', 59, NULL, NULL, 217588),
(217589, '1.20.80.10-FF-000040', NULL, 'Acyl-CoA-binding domain-containing protein 2', 108, NULL, NULL, 217589),
(217590, '2.40.70.10-FF-000570', NULL, NULL, 41, NULL, NULL, 217590),
(217591, '1.10.3660.10-FF-000006', NULL, 'Prephenate dehydrogenase [NADP(+)]', 120, NULL, NULL, 217591),
(217592, '4.10.280.50-FF-000006', NULL, 'Glutamate decarboxylase', 43, NULL, NULL, 217592),
(217593, '4.10.240.10-FF-000099', NULL, 'Uncharacterized protein', 72, NULL, NULL, 217593),
(217594, '1.10.510.10-FF-000463', NULL, 'Serine/threonine-protein kinase/endoribonuclease IRE1a', 178, NULL, NULL, 217594),
(217595, '2.30.30.40-FF-000453', NULL, 'Tyrosine-protein kinase', 59, NULL, NULL, 217595),
(217596, '1.20.1250.20-FF-000627', NULL, 'GEX1p Proton:glutathione antiporter', 192, NULL, NULL, 217596),
(217597, '1.10.506.10-FF-000065', NULL, 'Uncharacterized protein', 177, NULL, NULL, 217597);
INSERT INTO "PUBLIC"."MODEL" VALUES
(217598, '2.30.30.40-FF-000397', NULL, 'Tyrosine-protein kinase', 63, NULL, NULL, 217598),
(217599, '1.20.5.110-FF-000253', NULL, 'Syntaxin 2a', 86, NULL, NULL, 217599),
(217600, '1.10.2020.20-FF-000006', NULL, 'Proteasomal ubiquitin receptor ADRM1', 118, NULL, NULL, 217600),
(217601, '2.130.10.10-FF-004154', NULL, 'Uncharacterized protein', 175, NULL, NULL, 217601),
(217602, '3.80.10.10-FF-001832', NULL, 'Uncharacterized protein', 129, NULL, NULL, 217602),
(217603, '3.60.21.10-FF-000318', NULL, 'Metallo-dependent phosphatase-like domain-containing protein', 197, NULL, NULL, 217603),
(217604, '3.40.30.10-FF-001043', NULL, 'Glutathione peroxidase', 191, NULL, NULL, 217604),
(217605, '3.10.250.10-FF-000108', NULL, NULL, 106, NULL, NULL, 217605),
(217606, '3.10.100.10-FF-000396', NULL, NULL, 121, NULL, NULL, 217606),
(217607, '3.40.50.620-FF-000568', NULL, 'Uncharacterized protein', 180, NULL, NULL, 217607),
(217608, '1.10.238.10-FF-000363', NULL, 'Endoplasmic reticulum-resident calcium binding protein', 67, NULL, NULL, 217608),
(217609, '1.10.150.20-FF-000005', NULL, 'UvrABC system protein C', 60, NULL, NULL, 217609),
(217610, '3.40.1010.10-FF-000022', NULL, NULL, 113, NULL, NULL, 217610),
(217611, '3.40.50.1380-FF-000008', NULL, 'Methylglyoxal synthase', 163, NULL, NULL, 217611),
(217612, '3.30.430.20-FF-000020', NULL, 'Cysteine-rich repeat secretory protein 60', 79, NULL, NULL, 217612),
(217613, '2.60.40.10-FF-004030', NULL, NULL, 98, NULL, NULL, 217613),
(217614, '2.130.10.10-FF-003226', NULL, 'Uncharacterized protein', 275, NULL, NULL, 217614),
(217615, '1.25.40.10-FF-003489', NULL, 'Uncharacterized protein', 79, NULL, NULL, 217615),
(217616, '1.20.1330.10-FF-000007', NULL, 'Flagellar hook-associated protein FlgL', 138, NULL, NULL, 217616),
(217617, '3.40.50.300-FF-000534', NULL, 'Heparan sulfate 2-O-sulfotransferase 1', 288, NULL, NULL, 217617),
(217618, '3.80.10.10-FF-001647', NULL, 'Uncharacterized protein', 182, NULL, NULL, 217618),
(217619, '3.30.230.10-FF-000266', NULL, 'Probable 40S ribosomal protein S9, mitochondrial', 144, NULL, NULL, 217619),
(217620, '3.90.1150.10-FF-000532', NULL, 'Uncharacterized protein', 56, NULL, NULL, 217620),
(217621, '2.130.10.10-FF-003754', NULL, 'Uncharacterized protein', 326, NULL, NULL, 217621),
(217622, '3.30.30.10-FF-000015', NULL, NULL, 50, NULL, NULL, 217622),
(217623, '1.50.10.150-FF-000003', NULL, 'S-type anion channel SLAH1', 327, NULL, NULL, 217623),
(217624, '1.20.272.10-FF-000064', NULL, NULL, 118, NULL, NULL, 217624),
(217625, '1.10.510.10-FF-000316', NULL, 'serine/threonine-protein kinase HT1', 194, NULL, NULL, 217625),
(217626, '2.40.100.10-FF-000011', NULL, 'Peptidyl-prolyl cis-trans isomerase A', 165, NULL, NULL, 217626),
(217627, '3.40.50.300-FF-003991', NULL, 'Predicted protein', 174, NULL, NULL, 217627),
(217628, '3.30.160.60-FF-004766', NULL, NULL, 32, NULL, NULL, 217628),
(217629, '1.20.58.60-FF-000795', NULL, 'Uncharacterized protein', 209, NULL, NULL, 217629),
(217630, '3.30.160.60-FF-003990', NULL, NULL, 59, NULL, NULL, 217630),
(217631, '3.30.70.330-FF-002584', NULL, NULL, 137, NULL, NULL, 217631),
(217632, '4.10.800.10-FF-000035', NULL, 'Uncharacterized protein', 74, NULL, NULL, 217632),
(217633, '1.10.3580.10-FF-000005', NULL, NULL, 100, NULL, NULL, 217633),
(217634, '3.10.450.50-FF-000113', NULL, 'Diguanylate cyclase', 133, NULL, NULL, 217634),
(217635, '3.90.1300.10-FF-000038', NULL, 'Uncharacterized protein', 109, NULL, NULL, 217635),
(217636, '3.40.50.1000-FF-000799', NULL, NULL, 156, NULL, NULL, 217636),
(217637, '2.40.70.10-FF-000385', NULL, NULL, 188, NULL, NULL, 217637),
(217638, '3.30.70.1180-FF-000018', NULL, 'V-type proton ATPase subunit C', 57, NULL, NULL, 217638),
(217639, '2.40.290.10-FF-000029', NULL, 'Uncharacterized protein', 216, NULL, NULL, 217639),
(217640, '3.30.160.60-FF-004390', NULL, NULL, 31, NULL, NULL, 217640),
(217641, '1.10.1200.10-FF-000129', NULL, 'Uncharacterized protein', 73, NULL, NULL, 217641),
(217642, '1.25.40.10-FF-001016', NULL, 'Selenium-binding protein-like', 168, NULL, NULL, 217642);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(217643, '3.40.50.1110-FF-000068', NULL, 'PAFAH1B2 isoform 6', 169, NULL, NULL, 217643),
(217644, '3.30.200.20-FF-000008', NULL, 'Non-specific serine/threonine protein kinase', 11, NULL, NULL, 217644),
(217645, '3.40.50.10190-FF-000290', NULL, 'DNA ligase 4', 95, NULL, NULL, 217645),
(217646, '2.60.40.2860-FF-000021', NULL, 'Transmission-blocking target antigen S230', 102, NULL, NULL, 217646),
(217647, '2.170.130.10-FF-000027', NULL, 'Heme receptor HutR', 141, NULL, NULL, 217647),
(217648, '1.25.10.10-FF-000407', NULL, 'Uncharacterized protein', 297, NULL, NULL, 217648),
(217649, '1.10.1070.11-FF-000131', NULL, 'Uncharacterized protein', 61, NULL, NULL, 217649),
(217650, '3.10.129.10-FF-000063', NULL, 'Acyl-CoA thioester hydrolase, YbgC/YbaW family', 137, NULL, NULL, 217650),
(217651, '1.10.510.10-FF-000839', NULL, 'Spire type actin nucleation factor 1', 38, NULL, NULL, 217651),
(217652, '2.10.25.10-FF-000242', NULL, 'Laminin subunit alpha 1', 49, NULL, NULL, 217652),
(217653, '1.10.418.10-FF-000220', NULL, 'Uncharacterized protein', 129, NULL, NULL, 217653),
(217654, '1.10.8.720-FF-000016', NULL, 'Putative dynein heavy chain', 173, NULL, NULL, 217654),
(217655, '1.10.510.10-FF-004026', NULL, NULL, 109, NULL, NULL, 217655),
(217656, '3.40.1190.20-FF-000127', NULL, 'Sugar kinase', 302, NULL, NULL, 217656),
(217657, '3.40.50.2020-FF-000032', NULL, 'ribose-phosphate pyrophosphokinase 4', 160, NULL, NULL, 217657),
(217658, '3.30.2130.10-FF-000005', NULL, 'Aspartokinase', 154, NULL, NULL, 217658),
(217659, '3.90.226.10-FF-000237', NULL, 'Amino acid adenylation domain protein', 178, NULL, NULL, 217659),
(217660, '1.25.40.20-FF-000676', NULL, 'Uncharacterized protein', 194, NULL, NULL, 217660),
(217661, '3.40.190.10-FF-000625', NULL, 'Glutamate receptor 2.8', 83, NULL, NULL, 217661),
(217662, '2.30.180.10-FF-000164', NULL, NULL, 161, NULL, NULL, 217662),
(217663, '1.10.3210.10-FF-000130', NULL, 'Uncharacterized protein', 170, NULL, NULL, 217663),
(217664, '3.80.10.10-FF-001271', NULL, 'Chitin binding protein', 176, NULL, NULL, 217664),
(217665, '1.25.40.10-FF-002000', NULL, 'Suppressor of RPS4-RLD 1', 135, NULL, NULL, 217665),
(217666, '3.90.660.10-FF-000009', NULL, 'Amine oxidase', 167, NULL, NULL, 217666),
(217667, '3.40.630.10-FF-000474', NULL, 'Glutaminyl-peptide cyclotransferase', 39, NULL, NULL, 217667),
(217668, '3.30.2300.10-FF-000018', NULL, 'tRNA(cytosine(8)) deaminase', 85, NULL, NULL, 217668),
(217669, '3.90.1750.10-FF-000066', NULL, 'E3 ubiquitin-protein ligase UBR5 isoform X1', 119, NULL, NULL, 217669),
(217670, '3.40.50.170-FF-000006', NULL, 'Trifunctional purine biosynthetic protein adenosine-3', 210, NULL, NULL, 217670),
(217671, '1.10.510.10-FF-001300', NULL, 'Serine/threonine-protein kinase csk1', 209, NULL, NULL, 217671),
(217672, '3.40.190.10-FF-000810', NULL, 'Predicted protein', 117, NULL, NULL, 217672),
(217673, '2.40.30.180-FF-000014', NULL, 'Ube1l', 40, NULL, NULL, 217673),
(217674, '3.40.50.300-FF-002299', NULL, 'Rab family GTPase', 200, NULL, NULL, 217674),
(217675, '2.130.10.10-FF-003193', NULL, 'Uncharacterized protein', 116, NULL, NULL, 217675),
(217676, '4.10.320.10-FF-000009', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 48, NULL, NULL, 217676),
(217677, '2.30.39.10-FF-000161', NULL, 'Serine protease inhibitor, putative', 93, NULL, NULL, 217677),
(217678, '3.40.50.2000-FF-001015', NULL, 'Uncharacterized protein', 185, NULL, NULL, 217678),
(217679, '2.60.40.150-FF-000020', NULL, 'C2 calcium dependent domain containing 5', 129, NULL, NULL, 217679),
(217680, '3.40.630.30-FF-000328', NULL, 'Phosphinothricin acetyltransferase', 176, NULL, NULL, 217680),
(217681, '4.10.1240.50-FF-000012', NULL, 'Uncharacterized protein', 81, NULL, NULL, 217681),
(217682, '2.40.30.130-FF-000039', NULL, 'Uncharacterized protein', 95, NULL, NULL, 217682),
(217683, '3.40.50.1000-FF-000086', NULL, 'LD24878p', 186, NULL, NULL, 217683),
(217684, '3.30.1370.110-FF-000015', NULL, 'CUE2p protein', 93, NULL, NULL, 217684),
(217685, '2.30.29.30-FF-000402', NULL, 'Uncharacterized protein, isoform B', 123, NULL, NULL, 217685);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(217686, '1.25.10.10-FF-000907', NULL, 'Coatomer subunit gamma', 295, NULL, NULL, 217686),
(217687, '1.10.10.10-FF-001828', NULL, 'Helicase', 98, NULL, NULL, 217687),
(217688, '2.10.25.10-FF-000742', NULL, 'Crumbs cell polarity complex component 1', 34, NULL, NULL, 217688),
(217689, '3.30.200.20-FF-000155', NULL, 'CaM kinase-like vesicle-associated, like', 96, NULL, NULL, 217689),
(217690, '3.30.590.10-FF-000028', NULL, 'Putative glutamine synthetase', 332, NULL, NULL, 217690),
(217691, '1.10.10.1100-FF-000011', NULL, 'Sarcosine oxidase, alpha subunit', 57, NULL, NULL, 217691),
(217692, '3.30.9.10-FF-000128', NULL, 'D-amino-acid oxidase', 135, NULL, NULL, 217692),
(217693, '2.60.40.60-FF-000397', NULL, 'Fat-like cadherin-related tumor suppressor homolog', 106, NULL, NULL, 217693),
(217694, '1.25.40.10-FF-004097', NULL, 'Uncharacterized protein', 149, NULL, NULL, 217694),
(217695, '3.30.70.330-FF-000403', NULL, 'Bruno-3, isoform O', 73, NULL, NULL, 217695),
(217696, '3.40.30.10-FF-000615', NULL, 'AT3g27570/MMJ24_12', 94, NULL, NULL, 217696),
(217697, '2.130.10.10-FF-000028', NULL, 'semaphorin-6A isoform X1', 497, NULL, NULL, 217697),
(217698, '3.30.910.20-FF-000006', NULL, 'OmpH family outer membrane protein', 148, NULL, NULL, 217698),
(217699, '2.10.25.10-FF-001198', NULL, 'Fibulin 2', 31, NULL, NULL, 217699),
(217700, '2.60.200.30-FF-000008', NULL, 'Putative NAD+ kinase', 142, NULL, NULL, 217700),
(217701, '1.10.1750.10-FF-000013', NULL, NULL, 98, NULL, NULL, 217701),
(217702, '2.40.50.100-FF-000192', NULL, 'Probable membrane-fusion protein', 35, NULL, NULL, 217702),
(217703, '1.50.40.10-FF-000255', NULL, 'Putative inner membrane solute transporter MRS4', 193, NULL, NULL, 217703),
(217704, '3.30.1360.200-FF-000006', NULL, 'Protein translocase subunit SecD', 110, NULL, NULL, 217704),
(217705, '2.130.10.10-FF-004362', NULL, 'Uncharacterized protein', 89, NULL, NULL, 217705),
(217706, '1.20.1250.20-FF-001111', NULL, 'MFS general substrate transporter', 374, NULL, NULL, 217706),
(217707, '3.90.1530.30-FF-000005', NULL, 'Plasmid partitioning protein, parb2', 75, NULL, NULL, 217707),
(217708, '3.30.160.60-FF-002742', NULL, 'Zinc finger protein Pegasus', 82, NULL, NULL, 217708),
(217709, '3.30.559.70-FF-000064', NULL, 'Uncharacterized protein', 75, NULL, NULL, 217709),
(217710, '3.30.720.210-FF-000015', NULL, 'ATP-dependent zinc metalloprotease FtsH', 82, NULL, NULL, 217710),
(217711, '1.10.1070.11-FF-000052', NULL, 'Serine/threonine-protein kinase Tel1', 208, NULL, NULL, 217711),
(217712, '3.40.1080.20-FF-000001', NULL, 'Acetyl-CoA hydrolase Ach1', 142, NULL, NULL, 217712),
(217713, '3.40.50.300-FF-002563', NULL, 'Unplaced genomic scaffold supercont1.20, whole genome shotgun sequence', 251, NULL, NULL, 217713),
(217714, '1.10.238.10-FF-000571', NULL, 'Phosphoinositide phospholipase C', 53, NULL, NULL, 217714),
(217715, '3.90.550.10-FF-000304', NULL, 'PGL/p-HBAD biosynthesis glycosyltransferase', 240, NULL, NULL, 217715),
(217716, '1.20.140.150-FF-000133', NULL, 'Voltage-dependent calcium channel gamma-2 subunit', 102, NULL, NULL, 217716),
(217717, '3.40.630.10-FF-000322', NULL, 'Uncharacterized protein', 136, NULL, NULL, 217717),
(217718, '3.40.30.10-FF-000666', NULL, 'AhpC/TSA family protein', 145, NULL, NULL, 217718),
(217719, '3.80.10.10-FF-000107', NULL, 'LRR receptor-like serine/threonine-protein kinase ERL1', 111, NULL, NULL, 217719),
(217720, '1.20.1560.10-FF-000928', NULL, 'Uncharacterized protein', 77, NULL, NULL, 217720),
(217721, '1.20.930.80-FF-000018', NULL, 'Predicted protein', 249, NULL, NULL, 217721),
(217722, '2.30.42.10-FF-000421', NULL, NULL, 114, NULL, NULL, 217722),
(217723, '2.10.25.10-FF-001310', NULL, 'Hemolectin, isoform B', 34, NULL, NULL, 217723),
(217724, '2.40.160.110-FF-000018', NULL, 'Si:ch211-212k18.7', 164, NULL, NULL, 217724),
(217725, '3.40.50.150-FF-000028', NULL, 'Ubiquinone biosynthesis O-methyltransferase', 225, NULL, NULL, 217725),
(217726, '1.10.1670.10-FF-000012', NULL, '8-oxoguanine DNA glycosylase', 26, NULL, NULL, 217726),
(217727, '3.30.1110.10-FF-000009', NULL, 'Uncharacterized protein', 63, NULL, NULL, 217727);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(217728, '3.40.50.1100-FF-000239', NULL, 'Uncharacterized protein, isoform A', 49, NULL, NULL, 217728),
(217729, '3.40.50.720-FF-001464', NULL, 'Predicted protein', 217, NULL, NULL, 217729),
(217730, '3.30.1460.30-FF-000002', NULL, 'Putative DNA transformation protein TfoX', 105, NULL, NULL, 217730),
(217731, '1.10.1130.10-FF-000005', NULL, 'Cytochrome c-554', 156, NULL, NULL, 217731),
(217732, '3.30.450.190-FF-000020', NULL, 'Uncharacterized protein', 138, NULL, NULL, 217732),
(217733, '3.30.420.40-FF-000317', NULL, 'Luminal-binding protein 2', 94, NULL, NULL, 217733),
(217734, '3.80.10.10-FF-002136', NULL, 'Nuclear export factor 4', 143, NULL, NULL, 217734),
(217735, '3.40.50.720-FF-000896', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(P)+]', 187, NULL, NULL, 217735),
(217736, '3.40.50.300-FF-008291', NULL, 'tRNA modification GTPase trmE', 29, NULL, NULL, 217736),
(217737, '2.60.40.10-FF-001736', NULL, 'T-cell surface antigen CD2', 79, NULL, NULL, 217737),
(217738, '3.40.50.150-FF-001017', NULL, NULL, 194, NULL, NULL, 217738),
(217739, '3.40.50.2000-FF-000498', NULL, 'Glycosyl transferase family 1', 167, NULL, NULL, 217739),
(217740, '1.10.510.10-FF-001160', NULL, 'Protein kinase C', 206, NULL, NULL, 217740),
(217741, '3.30.200.20-FF-002184', NULL, 'Uncharacterized protein', 56, NULL, NULL, 217741),
(217742, '4.10.400.10-FF-000162', NULL, 'LDL receptor related protein 8', 39, NULL, NULL, 217742),
(217743, '2.60.40.2580-FF-000004', NULL, 'Major fimbrium subunit FimC', 147, NULL, NULL, 217743),
(217744, '1.10.132.20-FF-000025', NULL, 'Sugar transporter ERD6-like 6', 19, NULL, NULL, 217744),
(217745, '1.50.10.10-FF-000074', NULL, 'Glucanase', 357, NULL, NULL, 217745),
(217746, '1.20.120.1900-FF-000020', NULL, 'Spindle pole body component', 304, NULL, NULL, 217746),
(217747, '3.90.1750.10-FF-000061', NULL, 'E3 ubiquitin-protein ligase hecw-1', 173, NULL, NULL, 217747),
(217748, '2.10.70.10-FF-000217', NULL, 'Protein lev-9', 54, NULL, NULL, 217748),
(217749, '2.40.20.10-FF-000123', NULL, 'Metalloendopeptidase', 59, NULL, NULL, 217749),
(217750, '3.30.1010.10-FF-000064', NULL, 'Serine/threonine-protein kinase ATR', 178, NULL, NULL, 217750),
(217751, '3.40.50.300-FF-004328', NULL, 'DNA translocase coupling ATPase', 260, NULL, NULL, 217751),
(217752, '3.30.70.260-FF-000146', NULL, 'Aspartokinase', 51, NULL, NULL, 217752),
(217753, '2.60.260.20-FF-000127', NULL, 'dnaJ homolog subfamily A member 2', 59, NULL, NULL, 217753),
(217754, '3.40.50.720-FF-000036', NULL, 'Glutathione-regulated potassium-efflux system protein KefB', 163, NULL, NULL, 217754),
(217755, '3.30.40.10-FF-000521', NULL, 'RING/U-box superfamily protein', 91, NULL, NULL, 217755),
(217756, '2.70.130.10-FF-000129', NULL, NULL, 137, NULL, NULL, 217756),
(217757, '3.80.10.10-FF-002928', NULL, 'Uncharacterized protein', 155, NULL, NULL, 217757),
(217758, '2.60.40.10-FF-000376', NULL, 'CLUMA_CG000981, isoform A', 100, NULL, NULL, 217758),
(217759, '1.10.238.10-FF-000419', NULL, 'Calmodulin-like protein 10', 86, NULL, NULL, 217759),
(217760, '1.10.565.10-FF-000078', NULL, 'Peroxisome proliferator-activated receptor gamma', 257, NULL, NULL, 217760),
(217761, '2.40.30.160-FF-000003', NULL, 'Ccr4 associated factor', 90, NULL, NULL, 217761),
(217762, '3.90.550.10-FF-000355', NULL, 'Glycosyltransferase', 245, NULL, NULL, 217762),
(217763, '1.25.10.10-FF-003021', NULL, 'Uncharacterized protein', 325, NULL, NULL, 217763),
(217764, '3.30.160.60-FF-003198', NULL, 'Zinc finger protein 891', 31, NULL, NULL, 217764),
(217765, '1.20.1560.10-FF-000024', NULL, 'ABC transporter C family member 2', 322, NULL, NULL, 217765),
(217766, '3.30.70.330-FF-000015', NULL, 'CUGBP Elav-like family member 1 isoform 2', 94, NULL, NULL, 217766),
(217767, '3.80.10.10-FF-001568', NULL, 'Adhesion G protein-coupled receptor A2', 81, NULL, NULL, 217767),
(217768, '1.20.1250.20-FF-000543', NULL, 'Vacuolar basic amino acid transporter', 193, NULL, NULL, 217768),
(217769, '1.20.1640.10-FF-000025', NULL, 'Protein-export membrane protein SecF', 217, NULL, NULL, 217769),
(217770, '3.40.190.10-FF-000193', NULL, 'Two-component system sensor histidine kinase EvgS', 132, NULL, NULL, 217770);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(217771, '1.20.1250.20-FF-001971', NULL, 'Uncharacterized protein', 405, NULL, NULL, 217771),
(217772, '2.20.28.30-FF-000001', NULL, 'DNA-directed RNA polymerases I, II, and III subunit RPABC4', 58, NULL, NULL, 217772),
(217773, '3.50.50.60-FF-000137', NULL, 'FAD dependent oxidoreductase', 205, NULL, NULL, 217773),
(217774, '3.20.20.70-FF-000038', NULL, 'Hydroxymethylglutaryl-CoA lyase, mitochondrial', 299, NULL, NULL, 217774),
(217775, '3.30.300.30-FF-000160', NULL, 'Chondramide synthase cmdD', 93, NULL, NULL, 217775),
(217776, '1.20.1530.20-FF-000104', NULL, 'Os09g0474501 protein', 124, NULL, NULL, 217776),
(217777, '3.40.50.720-FF-001413', NULL, 'Uncharacterized protein', 179, NULL, NULL, 217777),
(217778, '3.40.50.150-FF-000180', NULL, 'Cytosine-specific methyltransferase', 226, NULL, NULL, 217778),
(217779, '3.30.70.1230-FF-000264', NULL, 'Predicted protein', 143, NULL, NULL, 217779),
(217780, '2.70.70.10-FF-000063', NULL, 'SPbeta prophage-derived uncharacterized transglycosylase YomI', 132, NULL, NULL, 217780),
(217781, '3.30.310.10-FF-000008', NULL, 'Coatomer subunit gamma', 116, NULL, NULL, 217781),
(217782, '1.10.418.50-FF-000001', NULL, 'TRAF3-interacting protein 1 isoform X1', 131, NULL, NULL, 217782),
(217783, '1.10.274.100-FF-000022', NULL, 'DNA-directed RNA polymerase subunit', 151, NULL, NULL, 217783),
(217784, '3.40.50.720-FF-002453', NULL, 'Uncharacterized protein', 46, NULL, NULL, 217784),
(217785, '3.30.160.60-FF-006183', NULL, NULL, 60, NULL, NULL, 217785),
(217786, '1.20.1440.170-FF-000006', NULL, 'WGS project CABT00000000 data, contig 2.35', 117, NULL, NULL, 217786),
(217787, '3.40.50.1820-FF-000213', NULL, 'Carboxylic ester hydrolase', 541, NULL, NULL, 217787),
(217788, '2.160.20.10-FF-000073', NULL, 'F-box domain containing protein, putative', 259, NULL, NULL, 217788),
(217789, '3.40.50.300-FF-007734', NULL, 'Predicted protein', 85, NULL, NULL, 217789),
(217790, '3.40.50.10700-FF-000004', NULL, 'D-aminoacyl-tRNA deacylase', 84, NULL, NULL, 217790),
(217791, '3.30.70.20-FF-000026', NULL, 'Nitrate reductase subunit beta', 55, NULL, NULL, 217791),
(217792, '3.30.200.20-FF-002133', NULL, 'Predicted protein', 72, NULL, NULL, 217792),
(217793, '1.20.1070.10-FF-000228', NULL, 'Olfactory receptor', 291, NULL, NULL, 217793),
(217794, '1.10.10.2010-FF-000008', NULL, NULL, 70, NULL, NULL, 217794),
(217795, '1.10.418.70-FF-000007', NULL, 'Uncharacterized protein', 131, NULL, NULL, 217795),
(217796, '3.30.160.60-FF-004507', NULL, NULL, 26, NULL, NULL, 217796),
(217797, '3.40.50.10130-FF-000047', NULL, 'Essential meiotic structure-specific endonuclease 1', 83, NULL, NULL, 217797),
(217798, '1.10.260.30-FF-000016', NULL, 'Signal recognition particle 54 kDa protein', 52, NULL, NULL, 217798),
(217799, '3.60.10.10-FF-000389', NULL, 'Uncharacterized protein', 139, NULL, NULL, 217799),
(217800, '3.10.50.10-FF-000028', NULL, 'Uncharacterized protein', 52, NULL, NULL, 217800),
(217801, '1.25.40.10-FF-002652', NULL, 'CCR4-NOT transcription complex subunit 10', 232, NULL, NULL, 217801),
(217802, '2.10.220.10-FF-000178', NULL, 'Extracellular matrix protein FRAS1', 72, NULL, NULL, 217802),
(217803, '1.20.1250.20-FF-001903', NULL, 'Uncharacterized protein', 46, NULL, NULL, 217803),
(217804, '3.90.180.10-FF-000102', NULL, 'Uncharacterized protein', 55, NULL, NULL, 217804),
(217805, '3.30.70.20-FF-000138', NULL, NULL, 75, NULL, NULL, 217805),
(217806, '2.60.120.200-FF-000100', NULL, 'Axotactin, isoform B', 179, NULL, NULL, 217806),
(217807, '2.60.200.20-FF-000118', NULL, 'SMAD/FHA domain-containing protein', 109, NULL, NULL, 217807),
(217808, '3.30.40.10-FF-000572', NULL, 'CDK-activating kinase assembly factor MAT1', 65, NULL, NULL, 217808),
(217809, '1.20.1070.10-FF-001577', NULL, 'Olfactory receptor 753, pseudogene 1', 161, NULL, NULL, 217809),
(217810, '2.30.180.10-FF-000080', NULL, 'Predicted protein', 138, NULL, NULL, 217810),
(217811, '3.30.2080.10-FF-000012', NULL, 'Uncharacterized protein', 133, NULL, NULL, 217811),
(217812, '3.55.50.30-FF-000011', NULL, 'Putative anti-sigma factor', 77, NULL, NULL, 217812);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(217813, '3.40.50.12160-FF-000026', NULL, 'MiaB-like tRNA modifying enzyme', 115, NULL, NULL, 217813),
(217814, '1.20.1540.10-FF-000080', NULL, 'Uncharacterized protein', 191, NULL, NULL, 217814),
(217815, '1.10.3210.10-FF-000074', NULL, 'Metal dependent phosphohydrolase', 290, NULL, NULL, 217815),
(217816, '2.60.40.10-FF-004558', NULL, NULL, 125, NULL, NULL, 217816),
(217817, '3.30.565.10-FF-000127', NULL, 'Hybrid sensor histidine kinase/response regulator', 142, NULL, NULL, 217817),
(217818, '1.10.10.60-FF-000017', NULL, 'Homeobox protein antennapedia', 82, NULL, NULL, 217818),
(217819, '3.40.50.1000-FF-000827', NULL, NULL, 88, NULL, NULL, 217819),
(217820, '3.30.505.10-FF-000186', NULL, NULL, 60, NULL, NULL, 217820),
(217821, '3.30.930.10-FF-000179', NULL, 'Glycine--tRNA ligase', 204, NULL, NULL, 217821),
(217822, '1.20.1070.10-FF-000116', NULL, 'probable G-protein coupled receptor 22', 234, NULL, NULL, 217822),
(217823, '3.40.50.1820-FF-001562', NULL, 'Uncharacterized protein', 117, NULL, NULL, 217823),
(217824, '2.60.40.790-FF-000088', NULL, '18.8 kDa class V heat shock protein', 140, NULL, NULL, 217824),
(217825, '2.130.10.10-FF-002445', NULL, 'POC1 centriolar protein homolog', 151, NULL, NULL, 217825),
(217826, '2.10.60.10-FF-000020', NULL, 'LY6/PLAUR domain containing 5', 89, NULL, NULL, 217826),
(217827, '1.25.10.10-FF-000166', NULL, 'Coatomer subunit beta', 521, NULL, NULL, 217827),
(217828, '3.30.200.20-FF-001987', NULL, NULL, 98, NULL, NULL, 217828),
(217829, '1.20.1050.10-FF-000233', NULL, 'Glutathione transferase', 87, NULL, NULL, 217829),
(217830, '2.130.10.10-FF-002849', NULL, 'Uncharacterized protein', 423, NULL, NULL, 217830),
(217831, '3.30.70.330-FF-002820', NULL, NULL, 92, NULL, NULL, 217831),
(217832, '1.10.510.10-FF-002469', NULL, 'Uncharacterized protein', 264, NULL, NULL, 217832),
(217833, '2.60.40.150-FF-000812', NULL, 'Uncharacterized protein', 131, NULL, NULL, 217833),
(217834, '1.25.40.10-FF-003692', NULL, 'Pentatricopeptide repeat-containing protein', 212, NULL, NULL, 217834),
(217835, '3.40.50.20-FF-000002', NULL, 'Carbamoyl-phosphate synthase large chain', 109, NULL, NULL, 217835),
(217836, '1.20.5.470-FF-000012', NULL, 'Argininosuccinate synthase', 38, NULL, NULL, 217836),
(217837, '1.10.287.3610-FF-000001', NULL, 'Diacylglycerol kinase', 122, NULL, NULL, 217837),
(217838, '3.20.20.190-FF-000078', NULL, 'GM14906', 301, NULL, NULL, 217838),
(217839, '3.80.10.10-FF-003125', NULL, 'Fbxl7, putative', 81, NULL, NULL, 217839),
(217840, '2.60.40.10-FF-005047', NULL, NULL, 128, NULL, NULL, 217840),
(217841, '1.25.40.20-FF-000204', NULL, 'Diacylglycerol kinase', 137, NULL, NULL, 217841),
(217842, '3.30.160.60-FF-000325', NULL, 'ZFP90 zinc finger protein', 27, NULL, NULL, 217842),
(217843, '1.20.58.860-FF-000016', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 70, NULL, NULL, 217843),
(217844, '3.30.70.920-FF-000046', NULL, 'DNA-binding transcriptional regulator, Lrp family', 89, NULL, NULL, 217844),
(217845, '3.10.129.10-FF-000147', NULL, 'Acyl-CoA thioesterase', 147, NULL, NULL, 217845),
(217846, '1.10.510.10-FF-003981', NULL, NULL, 328, NULL, NULL, 217846),
(217847, '1.10.418.10-FF-000017', NULL, 'Microtubule-actin cross-linking factor 1', 125, NULL, NULL, 217847),
(217848, '3.30.457.60-FF-000009', NULL, 'GM14169p', 79, NULL, NULL, 217848),
(217849, '2.60.40.60-FF-000930', NULL, 'Uncharacterized protein', 44, NULL, NULL, 217849),
(217850, '2.40.290.30-FF-000002', NULL, 'Mediator of RNA polymerase II transcription subunit', 165, NULL, NULL, 217850),
(217851, '1.10.510.10-FF-001008', NULL, 'NAK/MPSK protein kinase', 315, NULL, NULL, 217851),
(217852, '3.40.50.720-FF-002402', NULL, 'Uncharacterized protein', 116, NULL, NULL, 217852),
(217853, '2.130.10.10-FF-001489', NULL, 'U3 small nucleolar RNA-associated protein 4', 147, NULL, NULL, 217853),
(217854, '1.25.40.420-FF-000050', NULL, 'Uncharacterized protein', 53, NULL, NULL, 217854),
(217855, '3.90.190.20-FF-000049', NULL, 'Uncharacterized protein', 125, NULL, NULL, 217855),
(217856, '3.20.20.100-FF-000203', NULL, 'Galactose dehydrogenase', 79, NULL, NULL, 217856);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(217857, '3.40.50.970-FF-000206', NULL, 'Predicted protein', 302, NULL, NULL, 217857),
(217858, '3.40.50.300-FF-001102', NULL, 'Nuclear GTPase, germinal center-associated', 113, NULL, NULL, 217858),
(217859, '1.10.340.30-FF-000017', NULL, 'N-glycosylase/DNA lyase, putative', 137, NULL, NULL, 217859),
(217860, '1.10.150.530-FF-000021', NULL, 'Probable dual-specificity RNA methyltransferase RlmN', 61, NULL, NULL, 217860),
(217861, '3.40.50.300-FF-006745', NULL, 'Abcg4 protein', 68, NULL, NULL, 217861),
(217862, '2.60.40.150-FF-000071', NULL, 'Copine 8', 130, NULL, NULL, 217862),
(217863, '1.25.40.10-FF-003641', NULL, 'Tetratricopeptide repeat protein 21B', 147, NULL, NULL, 217863),
(217864, '3.30.160.60-FF-000825', NULL, 'E3 ubiquitin-protein ligase TRIM39', 37, NULL, NULL, 217864),
(217865, '1.20.58.60-FF-000323', NULL, 'SMAll', 105, NULL, NULL, 217865),
(217866, '3.90.1410.10-FF-000052', NULL, 'Uncharacterized protein', 289, NULL, NULL, 217866),
(217867, '3.20.20.140-FF-000428', NULL, 'Carbamoyl-phosphate synthetase 2, aspartate transcarbamylase, and dihydroorotase', 220, NULL, NULL, 217867),
(217868, '1.10.510.10-FF-003829', NULL, NULL, 111, NULL, NULL, 217868),
(217869, '3.30.420.40-FF-000205', NULL, 'Actin, alpha skeletal muscle', 108, NULL, NULL, 217869),
(217870, '2.30.30.40-FF-000476', NULL, 'Chemotaxis signal transduction system adaptor protein CheW', 59, NULL, NULL, 217870),
(217871, '3.80.10.10-FF-003985', NULL, 'Leucine Rich Repeat family protein', 158, NULL, NULL, 217871),
(217872, '4.10.400.10-FF-000050', NULL, 'low-density lipoprotein receptor-related protein 10', 40, NULL, NULL, 217872),
(217873, '3.30.70.330-FF-001864', NULL, NULL, 106, NULL, NULL, 217873),
(217874, '3.40.30.10-FF-000262', NULL, 'Thioredoxin domain containing 8', 127, NULL, NULL, 217874),
(217875, '3.40.50.300-FF-002512', NULL, 'Thymidylate kinase', 214, NULL, NULL, 217875),
(217876, '3.30.160.60-FF-003310', NULL, 'Zinc finger protein 607', 26, NULL, NULL, 217876),
(217877, '2.30.30.70-FF-000001', NULL, '60S ribosomal protein L21', 98, NULL, NULL, 217877),
(217878, '3.10.20.30-FF-000066', NULL, 'Adrenodoxin-like protein 1, mitochondrial', 125, NULL, NULL, 217878),
(217879, '1.25.40.20-FF-001553', NULL, 'Uncharacterized protein', 107, NULL, NULL, 217879),
(217880, '1.10.12.10-FF-000029', NULL, '3-hydroxybutyryl-CoA dehydratase', 59, NULL, NULL, 217880),
(217881, '3.30.70.60-FF-000010', NULL, '30S ribosomal protein S6', 122, NULL, NULL, 217881),
(217882, '2.30.30.30-FF-000068', NULL, 'Putative ribosomal protein L2', 74, NULL, NULL, 217882),
(217883, '3.40.50.150-FF-000680', NULL, 'Ubiquinone/menaquinone biosynthesis methyltransferase ubiE', 206, NULL, NULL, 217883),
(217884, '2.170.16.10-FF-000034', NULL, 'Hedgehog protein', 165, NULL, NULL, 217884),
(217885, '3.30.40.10-FF-001769', NULL, 'Conserved zinc-finger protein', 75, NULL, NULL, 217885),
(217886, '1.10.287.110-FF-000175', NULL, 'GM22099', 118, NULL, NULL, 217886),
(217887, '3.40.50.1820-FF-000101', NULL, 'Hepatic triacylglycerol lipase', 323, NULL, NULL, 217887),
(217888, '2.30.30.90-FF-000007', NULL, 'Iron-dependent transcriptional regulator', 76, NULL, NULL, 217888),
(217889, '1.20.120.450-FF-000005', NULL, NULL, 187, NULL, NULL, 217889),
(217890, '3.30.70.20-FF-000077', NULL, 'Indolepyruvate oxidoreductase subunit IorA', 38, NULL, NULL, 217890),
(217891, '1.20.140.40-FF-000053', NULL, NULL, 156, NULL, NULL, 217891),
(217892, '3.30.160.60-FF-006132', NULL, NULL, 31, NULL, NULL, 217892),
(217893, '1.25.10.10-FF-000115', NULL, 'Splicing factor 3B subunit 1', 210, NULL, NULL, 217893),
(217894, '3.40.50.10810-FF-000037', NULL, 'chromodomain-helicase-DNA-binding protein 1-like isoform X1', 229, NULL, NULL, 217894),
(217895, '3.40.250.10-FF-000164', NULL, 'Tbck-1', 121, NULL, NULL, 217895),
(217896, '1.10.510.10-FF-000171', NULL, 'Serine/threonine-protein kinase', 205, NULL, NULL, 217896),
(217897, '1.20.5.650-FF-000010', NULL, NULL, 60, NULL, NULL, 217897),
(217898, '3.30.1120.30-FF-000044', NULL, 'Serine/threonine-protein kinase PLK', 101, NULL, NULL, 217898);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(217899, '2.70.160.11-FF-000054', NULL, 'Arginine methyltransferase, putative', 176, NULL, NULL, 217899),
(217900, '3.30.497.10-FF-000002', NULL, 'Serpin family B member 6', 213, NULL, NULL, 217900),
(217901, '1.20.5.190-FF-000086', NULL, 'IQ-domain 14', 53, NULL, NULL, 217901),
(217902, '3.10.110.10-FF-000329', NULL, 'Uncharacterized protein', 156, NULL, NULL, 217902),
(217903, '1.25.40.120-FF-000050', NULL, 'YALI0A02431p', 267, NULL, NULL, 217903),
(217904, '1.20.58.80-FF-000060', NULL, 'STAM-binding protein-like A', 141, NULL, NULL, 217904),
(217905, '2.60.40.150-FF-000424', NULL, 'Predicted protein', 135, NULL, NULL, 217905),
(217906, '3.30.870.10-FF-000180', NULL, 'Uncharacterized protein', 152, NULL, NULL, 217906),
(217907, '3.40.720.10-FF-000329', NULL, 'Predicted protein', 128, NULL, NULL, 217907),
(217908, '2.60.120.10-FF-000699', NULL, 'Uncharacterized protein', 221, NULL, NULL, 217908),
(217909, '3.40.50.2000-FF-001127', NULL, 'Glycogen [starch] synthase', 113, NULL, NULL, 217909),
(217910, '3.30.230.10-FF-000058', NULL, 'Elongation factor Tu family protein, putative, expressed', 169, NULL, NULL, 217910),
(217911, '3.30.160.60-FF-000376', NULL, 'Zinc finger protein 236', 27, NULL, NULL, 217911),
(217912, '3.40.50.2300-FF-000498', NULL, 'Guanylate cyclase', 110, NULL, NULL, 217912),
(217913, '3.60.10.10-FF-000001', NULL, 'Exodeoxyribonuclease III', 259, NULL, NULL, 217913),
(217914, '3.40.50.300-FF-004828', NULL, 'DNA helicase INO80', 113, NULL, NULL, 217914),
(217915, '3.30.200.20-FF-000559', NULL, 'Ribosomal protein S6 kinase', 44, NULL, NULL, 217915),
(217916, '2.10.110.10-FF-000024', NULL, 'actin-binding LIM protein 1 isoform X1', 66, NULL, NULL, 217916),
(217917, '3.40.50.12780-FF-000055', NULL, 'Fatty-acid-CoA ligase FadD22', 378, NULL, NULL, 217917),
(217918, '1.25.40.10-FF-001275', NULL, 'HemY protein', 182, NULL, NULL, 217918),
(217919, '3.90.1480.20-FF-000003', NULL, 'CMP-N-acetylneuraminate-beta-1,4-galactoside alpha-2,3-sialyltransferase isoform X1', 290, NULL, NULL, 217919),
(217920, '3.30.200.20-FF-000267', NULL, 'Serine/threonine protein kinase', 93, NULL, NULL, 217920),
(217921, '3.90.79.10-FF-000107', NULL, 'Adenine DNA glycosylase', 127, NULL, NULL, 217921),
(217922, '3.30.9.10-FF-000016', NULL, 'Fructosyl amine:oxygen oxidoreductase', 180, NULL, NULL, 217922),
(217923, '2.170.140.10-FF-000033', NULL, 'GD12214', 66, NULL, NULL, 217923),
(217924, '3.20.180.20-FF-000036', NULL, 'Uncharacterized protein', 97, NULL, NULL, 217924),
(217925, '3.90.132.10-FF-000002', NULL, 'Leishmanolysin like peptidase 2', 123, NULL, NULL, 217925),
(217926, '1.20.1250.20-FF-000947', NULL, 'Probable major facilitator superfamily (MFS) transporter', 205, NULL, NULL, 217926),
(217927, '1.10.472.10-FF-000626', NULL, 'Uncharacterized protein', 123, NULL, NULL, 217927),
(217928, '1.10.565.10-FF-000139', NULL, 'Nr1h3 protein', 154, NULL, NULL, 217928),
(217929, '3.30.1010.10-FF-000125', NULL, 'Uncharacterized protein', 54, NULL, NULL, 217929),
(217930, '2.130.10.10-FF-005755', NULL, 'Uncharacterized protein', 118, NULL, NULL, 217930),
(217931, '2.40.30.270-FF-000036', NULL, 'Predicted protein', 57, NULL, NULL, 217931),
(217932, '1.10.8.870-FF-000005', NULL, 'Glycerol-3-phosphate dehydrogenase', 152, NULL, NULL, 217932),
(217933, '3.30.70.330-FF-001364', NULL, 'Uncharacterized protein', 99, NULL, NULL, 217933),
(217934, '3.30.2140.20-FF-000020', NULL, 'Uncharacterized protein', 213, NULL, NULL, 217934),
(217935, '3.60.21.10-FF-000178', NULL, 'Serine/threonine-protein phosphatase', 329, NULL, NULL, 217935),
(217936, '1.10.220.150-FF-000036', NULL, 'CRE-GIT-1 protein', 113, NULL, NULL, 217936),
(217937, '3.40.50.720-FF-001093', NULL, 'Putative nucleoside-diphosphate sugar epimerase', 215, NULL, NULL, 217937),
(217938, '2.40.10.10-FF-000297', NULL, NULL, 101, NULL, NULL, 217938),
(217939, '2.40.110.10-FF-000040', NULL, 'Acyl-coenzyme A oxidase', 135, NULL, NULL, 217939),
(217940, '1.20.120.660-FF-000001', NULL, 'Cag pathogenicity island protein', 113, NULL, NULL, 217940),
(217941, '3.30.430.20-FF-000043', NULL, 'Os12g0606000 protein', 78, NULL, NULL, 217941);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(217942, '3.30.200.20-FF-002072', NULL, 'Uncharacterized protein', 85, NULL, NULL, 217942),
(217943, '3.40.109.10-FF-000049', NULL, 'Nitroreductase', 231, NULL, NULL, 217943),
(217944, '2.60.40.10-FF-003653', NULL, NULL, 92, NULL, NULL, 217944),
(217945, '3.40.50.1460-FF-000122', NULL, 'Caspase Dronc', 228, NULL, NULL, 217945),
(217946, '1.10.720.30-FF-000035', NULL, 'Nfi1p', 49, NULL, NULL, 217946),
(217947, '3.40.50.720-FF-000396', NULL, '(+)-neomenthol dehydrogenase', 303, NULL, NULL, 217947),
(217948, '1.10.274.60-FF-000001', NULL, 'Eggcase silk protein', 160, NULL, NULL, 217948),
(217949, '3.90.70.10-FF-000818', NULL, 'Uncharacterized protein', 197, NULL, NULL, 217949),
(217950, '3.80.10.10-FF-000219', NULL, 'LRR receptor-like serine/threonine-protein kinase ERL1', 275, NULL, NULL, 217950),
(217951, '1.20.5.170-FF-000080', NULL, 'Basic leucine zipper transcriptional factor ATF-like 2', 69, NULL, NULL, 217951),
(217952, '1.10.260.100-FF-000012', NULL, 'Hsc70-interacting protein', 55, NULL, NULL, 217952),
(217953, '1.20.1560.10-FF-000816', NULL, 'Uncharacterized protein', 128, NULL, NULL, 217953),
(217954, '1.10.510.10-FF-000963', NULL, 'Serine/threonine-protein kinase BUR1', 251, NULL, NULL, 217954),
(217955, '3.40.50.1820-FF-000152', NULL, 'Protein phosphatase methylesterase 1', 292, NULL, NULL, 217955),
(217956, '1.10.555.10-FF-000072', NULL, 'Protein RGD1', 200, NULL, NULL, 217956),
(217957, '3.40.50.300-FF-005677', NULL, 'ATP-dependent nuclease subunit A', 189, NULL, NULL, 217957),
(217958, '3.80.10.10-FF-002024', NULL, 'Protein CBG18939', 112, NULL, NULL, 217958),
(217959, '3.30.920.10-FF-000010', NULL, 'Frataxin-like protein', 117, NULL, NULL, 217959),
(217960, '3.40.50.12780-FF-000004', NULL, 'Disco interacting protein 2 homolog A', 458, NULL, NULL, 217960),
(217961, '2.130.10.10-FF-001540', NULL, 'Uncharacterized protein, isoform A', 90, NULL, NULL, 217961),
(217962, '2.60.40.1730-FF-000047', NULL, 'Aminopeptidase', 237, NULL, NULL, 217962),
(217963, '1.25.40.540-FF-000001', NULL, 'immunoglobulin-binding protein 1 isoform X1', 173, NULL, NULL, 217963),
(217964, '1.10.400.10-FF-000050', NULL, 'guanine nucleotide-binding protein G(S) subunit alpha-like', 117, NULL, NULL, 217964),
(217965, '1.20.1270.20-FF-000005', NULL, 'Hydroxylamine reductase, putative', 117, NULL, NULL, 217965),
(217966, '3.30.310.10-FF-000059', NULL, 'AP complex subunit beta', 73, NULL, NULL, 217966),
(217967, '2.30.40.10-FF-000147', NULL, 'Uncharacterized protein', 32, NULL, NULL, 217967),
(217968, '2.30.29.30-FF-001071', NULL, 'Uncharacterized protein', 71, NULL, NULL, 217968),
(217969, '2.60.40.60-FF-000329', NULL, 'Cadherin-related tumor suppressor', 105, NULL, NULL, 217969),
(217970, '3.60.20.10-FF-000215', NULL, NULL, 162, NULL, NULL, 217970),
(217971, '3.10.580.10-FF-000072', NULL, 'Putative zinc metalloprotease Rip3', 125, NULL, NULL, 217971),
(217972, '3.90.1150.10-FF-000324', NULL, 'Kynureninase', 155, NULL, NULL, 217972),
(217973, '1.25.10.10-FF-003100', NULL, 'Uncharacterized protein', 222, NULL, NULL, 217973),
(217974, '1.10.268.20-FF-000008', NULL, NULL, 51, NULL, NULL, 217974),
(217975, '3.30.200.20-FF-000508', NULL, 'Protein kinase domain containing protein', 97, NULL, NULL, 217975),
(217976, '3.50.50.60-FF-000058', NULL, 'apoptosis-inducing factor 3 isoform X1', 125, NULL, NULL, 217976),
(217977, '1.25.40.10-FF-001224', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 117, NULL, NULL, 217977),
(217978, '2.102.10.10-FF-000030', NULL, 'Possible dioxygenase', 121, NULL, NULL, 217978),
(217979, '1.10.472.10-FF-000238', NULL, 'Putative cyclin', 141, NULL, NULL, 217979),
(217980, '3.30.230.10-FF-000007', NULL, '40S ribosomal protein S16', 144, NULL, NULL, 217980),
(217981, '3.40.50.150-FF-000579', NULL, 'RNA methylase family UPF0020 protein', 183, NULL, NULL, 217981),
(217982, '1.20.1740.10-FF-000201', NULL, 'Uncharacterized protein', 171, NULL, NULL, 217982),
(217983, '1.20.1740.10-FF-000061', NULL, 'K+/Cl-Cotransporter', 473, NULL, NULL, 217983),
(217984, '3.15.10.30-FF-000010', NULL, 'AGAP009387-PA', 215, NULL, NULL, 217984);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(217985, '2.30.29.30-FF-000795', NULL, 'Phosphoinositide phospholipase C', 102, NULL, NULL, 217985),
(217986, '1.20.1280.50-FF-000267', NULL, 'F-box protein pof9', 50, NULL, NULL, 217986),
(217987, '3.40.50.300-FF-000938', NULL, 'Sulfotransferase', 348, NULL, NULL, 217987),
(217988, '3.40.1000.50-FF-000005', NULL, 'Repressor of RNA polymerase III transcription MAF1, putative', 168, NULL, NULL, 217988),
(217989, '1.25.10.10-FF-002824', NULL, 'Uncharacterized protein', 190, NULL, NULL, 217989),
(217990, '3.30.200.20-FF-000216', NULL, 'Putative serine/threonine-protein kinase dyrk2', 79, NULL, NULL, 217990),
(217991, '3.40.190.10-FF-000125', NULL, 'ATP phosphoribosyltransferase, chloroplastic', 122, NULL, NULL, 217991),
(217992, '2.60.40.10-FF-002372', NULL, NULL, 87, NULL, NULL, 217992),
(217993, '2.60.40.60-FF-000430', NULL, 'Cadherin 3', 97, NULL, NULL, 217993),
(217994, '1.10.510.10-FF-000671', NULL, 'Casein kinase I isoform alpha', 234, NULL, NULL, 217994),
(217995, '1.20.1080.10-FF-000061', NULL, 'Formate/nitrite transporter family protein', 261, NULL, NULL, 217995),
(217996, '1.10.555.10-FF-000021', NULL, 'rho GTPase-activating protein 5', 241, NULL, NULL, 217996),
(217997, '1.10.8.720-FF-000039', NULL, 'AT15593p', 169, NULL, NULL, 217997),
(217998, '1.10.600.10-FF-000110', NULL, 'Geranylfarnesyl diphosphate synthase', 286, NULL, NULL, 217998),
(217999, '2.30.42.10-FF-000360', NULL, 'Protein lap1', 124, NULL, NULL, 217999),
(218000, '3.30.2350.20-FF-000058', NULL, NULL, 245, NULL, NULL, 218000),
(218001, '2.10.25.10-FF-001231', NULL, 'Uncharacterized protein', 57, NULL, NULL, 218001),
(218002, '2.40.10.190-FF-000002', NULL, '60S ribosomal protein L35ae, putative', 106, NULL, NULL, 218002),
(218003, '2.120.10.30-FF-000355', NULL, 'Uncharacterized protein', 174, NULL, NULL, 218003),
(218004, '1.25.10.10-FF-001104', NULL, 'Uncharacterized protein', 211, NULL, NULL, 218004),
(218005, '2.10.60.10-FF-000071', NULL, 'Activin A receptor type 2Ba', 69, NULL, NULL, 218005),
(218006, '1.10.8.270-FF-000134', NULL, 'Uncharacterized protein', 69, NULL, NULL, 218006),
(218007, '3.30.160.60-FF-004558', NULL, NULL, 32, NULL, NULL, 218007),
(218008, '2.30.30.40-FF-000425', NULL, 'Fus1p', 72, NULL, NULL, 218008),
(218009, '3.30.420.40-FF-000256', NULL, 'Carbohydrate kinase', 241, NULL, NULL, 218009),
(218010, '3.30.160.60-FF-000084', NULL, 'Zinc finger E-box binding homeobox 2', 30, NULL, NULL, 218010),
(218011, '2.40.40.10-FF-000006', NULL, 'Expansin-like A2', 128, NULL, NULL, 218011),
(218012, '1.10.730.10-FF-000114', NULL, 'Valine--tRNA ligase', 167, NULL, NULL, 218012),
(218013, '1.25.40.20-FF-000564', NULL, 'Potassium channel SKOR', 78, NULL, NULL, 218013),
(218014, '1.10.238.10-FF-000650', NULL, 'Centrin-B', 68, NULL, NULL, 218014),
(218015, '3.30.519.10-FF-000009', NULL, 'Rab GDP dissociation inhibitor', 27, NULL, NULL, 218015),
(218016, '1.10.286.20-FF-000005', NULL, 'Elongation factor Ts', 44, NULL, NULL, 218016),
(218017, '3.80.10.10-FF-003485', NULL, 'Uncharacterized protein', 203, NULL, NULL, 218017),
(218018, '1.10.510.10-FF-002520', NULL, 'Protein mes-1', 225, NULL, NULL, 218018),
(218019, '3.30.160.60-FF-006475', NULL, NULL, 26, NULL, NULL, 218019),
(218020, '1.25.40.180-FF-000101', NULL, 'Pre-mRNA-splicing factor CWC22', 263, NULL, NULL, 218020),
(218021, '3.40.50.1440-FF-000144', NULL, 'Chromosome 15, whole genome shotgun sequence', 335, NULL, NULL, 218021),
(218022, '3.90.1750.10-FF-000010', NULL, 'probable E3 ubiquitin-protein ligase HERC4 isoform X1', 150, NULL, NULL, 218022),
(218023, '3.30.30.30-FF-000021', NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', 59, NULL, NULL, 218023),
(218024, '1.10.8.10-FF-000187', NULL, 'E3 ubiquitin-protein ligase HUWE1', 52, NULL, NULL, 218024),
(218025, '3.40.390.10-FF-000174', NULL, NULL, 183, NULL, NULL, 218025),
(218026, '2.60.40.10-FF-002293', NULL, 'Twitchin', 92, NULL, NULL, 218026),
(218027, '3.40.50.300-FF-004980', NULL, 'Ras homolog gene family, member Gd', 109, NULL, NULL, 218027),
(218028, '2.130.10.10-FF-000180', NULL, 'WD repeat-containing protein 76', 318, NULL, NULL, 218028);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(218029, '3.40.50.450-FF-000051', NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase', 189, NULL, NULL, 218029),
(218030, '1.10.8.60-FF-000269', NULL, 'ATP-dependent Clp protease ATP-binding subunit ClpX', 105, NULL, NULL, 218030),
(218031, '1.10.287.110-FF-000063', NULL, 'Translocation protein SEC63', 80, NULL, NULL, 218031),
(218032, '1.10.220.10-FF-000064', NULL, 'Annexin D8', 63, NULL, NULL, 218032),
(218033, '1.20.1070.10-FF-002033', NULL, 'Uncharacterized protein', 118, NULL, NULL, 218033),
(218034, '3.80.10.10-FF-003193', NULL, 'Leucine-Rich Repeat protein', 230, NULL, NULL, 218034),
(218035, '2.40.30.10-FF-000500', NULL, 'Uncharacterized protein', 128, NULL, NULL, 218035),
(218036, '2.10.25.10-FF-001810', NULL, 'Uncharacterized protein', 33, NULL, NULL, 218036),
(218037, '3.30.160.60-FF-002681', NULL, 'Zinc finger protein 568-like Protein', 27, NULL, NULL, 218037),
(218038, '3.30.450.40-FF-000033', NULL, 'Transcriptional regulator, IclR family', 177, NULL, NULL, 218038),
(218039, '2.60.40.1180-FF-000129', NULL, 'Alpha-L-fucosidase', 114, NULL, NULL, 218039),
(218040, '3.30.70.330-FF-001943', NULL, NULL, 127, NULL, NULL, 218040),
(218041, '1.25.40.10-FF-000735', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 125, NULL, NULL, 218041),
(218042, '1.25.40.20-FF-000272', NULL, 'Transient receptor potential cation channel subfamily A member 1', 147, NULL, NULL, 218042),
(218043, '2.10.25.10-FF-001282', NULL, 'Adhesion G protein-coupled receptor E1', 53, NULL, NULL, 218043),
(218044, '3.90.660.10-FF-000133', NULL, NULL, 39, NULL, NULL, 218044),
(218045, '3.40.50.300-FF-002063', NULL, 'DNA helicase related protein', 201, NULL, NULL, 218045),
(218046, '3.40.50.10240-FF-000029', NULL, 'Thiamine pyrophosphokinase', 183, NULL, NULL, 218046),
(218047, '1.20.1560.10-FF-000075', NULL, 'Multidrug resistance protein 1', 381, NULL, NULL, 218047),
(218048, '2.130.10.10-FF-001568', NULL, 'WD repeat domain 63', 231, NULL, NULL, 218048),
(218049, '3.30.1050.10-FF-000010', NULL, 'SDS hydrolase SdsA1', 133, NULL, NULL, 218049),
(218050, '1.10.510.10-FF-003037', NULL, NULL, 217, NULL, NULL, 218050),
(218051, '3.30.565.10-FF-000015', NULL, 'Two-component osmosensing histidine kinase', 168, NULL, NULL, 218051),
(218052, '3.50.50.60-FF-001486', NULL, 'Uncharacterized protein', 47, NULL, NULL, 218052),
(218053, '3.30.70.80-FF-000049', NULL, 'Uncharacterized protein', 102, NULL, NULL, 218053),
(218054, '3.40.50.620-FF-000692', NULL, 'Uncharacterized protein', 283, NULL, NULL, 218054),
(218055, '3.40.50.2000-FF-000610', NULL, 'UDP-glucuronosyltransferase', 160, NULL, NULL, 218055),
(218056, '3.40.50.300-FF-003468', NULL, 'ABC transporter', 262, NULL, NULL, 218056),
(218057, '3.30.450.40-FF-000084', NULL, 'IclR family transcriptional regulator', 185, NULL, NULL, 218057),
(218058, '2.20.100.10-FF-000206', NULL, 'Golgi apparatus membrane protein TVP23 homolog', 67, NULL, NULL, 218058),
(218059, '3.30.160.60-FF-004266', NULL, NULL, 22, NULL, NULL, 218059),
(218060, '2.40.70.10-FF-000446', NULL, NULL, 65, NULL, NULL, 218060),
(218061, '3.30.465.10-FF-000131', NULL, 'Glycolate oxidase, GlcE subunit', 186, NULL, NULL, 218061),
(218062, '2.70.130.10-FF-000068', NULL, NULL, 119, NULL, NULL, 218062),
(218063, '3.30.830.10-FF-000183', NULL, 'Peptidase', 194, NULL, NULL, 218063),
(218064, '1.20.1250.20-FF-000094', NULL, 'protein NRT1/ PTR FAMILY 7.3', 528, NULL, NULL, 218064),
(218065, '1.10.10.2100-FF-000002', NULL, 'cell growth-regulating nucleolar protein-like', 47, NULL, NULL, 218065),
(218066, '3.90.640.10-FF-000250', NULL, 'Actin-related protein 8', 102, NULL, NULL, 218066),
(218067, '3.60.21.10-FF-000206', NULL, 'Serine/threonine-protein phosphatase', 445, NULL, NULL, 218067),
(218068, '3.30.160.60-FF-002242', NULL, 'Zinc finger protein 473', 26, NULL, NULL, 218068),
(218069, '1.25.10.10-FF-002083', NULL, 'HEAT repeat-containing 3', 164, NULL, NULL, 218069),
(218070, '2.20.28.120-FF-000004', NULL, '50S ribosomal protein L33, chloroplastic', 65, NULL, NULL, 218070),
(218071, '1.10.10.60-FF-000309', NULL, 'HTH-type transcriptional activator RhaR', 54, NULL, NULL, 218071);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(218072, '2.130.10.10-FF-002006', NULL, 'Protein HIRA', 202, NULL, NULL, 218072),
(218073, '3.10.129.10-FF-000035', NULL, 'Thioesterase superfamily protein', 163, NULL, NULL, 218073),
(218074, '1.10.8.270-FF-000185', NULL, 'Uncharacterized protein', 105, NULL, NULL, 218074),
(218075, '3.40.50.300-FF-000646', NULL, 'U5 small nuclear ribonucleoprotein component', 200, NULL, NULL, 218075),
(218076, '1.10.10.10-FF-000839', NULL, 'IclR family transcriptional regulator', 74, NULL, NULL, 218076),
(218077, '2.60.40.1260-FF-000002', NULL, 'Lamin B1', 150, NULL, NULL, 218077),
(218078, '3.30.750.24-FF-000072', NULL, 'Probable Sulfate permease', 108, NULL, NULL, 218078),
(218079, '3.30.559.10-FF-000074', NULL, 'BAHD acyltransferase DCR-like', 217, NULL, NULL, 218079),
(218080, '1.25.10.10-FF-000087', NULL, 'Unc-45 myosin chaperone A', 429, NULL, NULL, 218080),
(218081, '2.40.50.140-FF-000349', NULL, 'Polyribonucleotide nucleotidyltransferase', 82, NULL, NULL, 218081),
(218082, '1.20.5.1160-FF-000043', NULL, 'Keratin, type II cytoskeletal 8', 68, NULL, NULL, 218082),
(218083, '1.20.1640.10-FF-000076', NULL, 'NPC intracellular cholesterol transporter 1 homolog 1', 202, NULL, NULL, 218083),
(218084, '2.60.40.1730-FF-000098', NULL, NULL, 120, NULL, NULL, 218084),
(218085, '2.30.30.140-FF-000342', NULL, 'Uncharacterized protein', 36, NULL, NULL, 218085),
(218086, '3.40.50.300-FF-000034', NULL, '26S protease regulatory subunit 10B', 181, NULL, NULL, 218086),
(218087, '1.20.1250.20-FF-000043', NULL, 'sugar transporter ERD6-like 6', 441, NULL, NULL, 218087),
(218088, '3.30.70.330-FF-002432', NULL, NULL, 88, NULL, NULL, 218088),
(218089, '3.90.1150.10-FF-000032', NULL, 'Ornithine decarboxylase SpeF', 180, NULL, NULL, 218089),
(218090, '3.60.20.10-FF-000266', NULL, NULL, 221, NULL, NULL, 218090),
(218091, '3.90.780.10-FF-000052', NULL, 'Uncharacterized protein', 102, NULL, NULL, 218091),
(218092, '2.130.10.10-FF-002057', NULL, 'CDT (S. pombe CDC10 Dependent Transcript) homolog', 154, NULL, NULL, 218092),
(218093, '2.30.30.30-FF-000147', NULL, '60S ribosomal protein L26-1', 86, NULL, NULL, 218093),
(218094, '2.40.100.10-FF-000163', NULL, 'Peptidyl-prolyl cis-trans isomerase', 79, NULL, NULL, 218094),
(218095, '2.10.25.10-FF-000793', NULL, 'Adhesion G protein-coupled receptor L4', 36, NULL, NULL, 218095),
(218096, '3.40.50.1820-FF-001270', NULL, 'Predicted protein', 301, NULL, NULL, 218096),
(218097, '3.10.180.10-FF-000103', NULL, 'Glr0001 protein', 124, NULL, NULL, 218097),
(218098, '2.20.25.90-FF-000018', NULL, NULL, 60, NULL, NULL, 218098),
(218099, '3.30.160.60-FF-004215', NULL, NULL, 44, NULL, NULL, 218099),
(218100, '3.30.160.60-FF-000904', NULL, 'Zinc finger protein 770', 31, NULL, NULL, 218100),
(218101, '1.20.1070.10-FF-001285', NULL, 'melatonin receptor type 1A-like isoform X2', 361, NULL, NULL, 218101),
(218102, '1.10.3210.10-FF-000006', NULL, 'Exopolyphosphatase', 146, NULL, NULL, 218102),
(218103, '3.40.50.300-FF-002804', NULL, 'DNA helicase 2', 180, NULL, NULL, 218103),
(218104, '3.40.920.10-FF-000018', NULL, NULL, 181, NULL, NULL, 218104),
(218105, '2.160.10.10-FF-000128', NULL, 'UTP--glucose-1-phosphate uridylyltransferase family protein', 53, NULL, NULL, 218105),
(218106, '2.60.40.10-FF-003602', NULL, 'Novel immune-type receptor 9', 120, NULL, NULL, 218106),
(218107, '2.60.40.150-FF-000520', NULL, 'Formin-A', 126, NULL, NULL, 218107),
(218108, '3.30.420.110-FF-000018', NULL, 'DNA mismatch repair protein', 159, NULL, NULL, 218108),
(218109, '3.40.50.300-FF-005317', NULL, 'Gluconokinase', 160, NULL, NULL, 218109),
(218110, '3.50.50.60-FF-001126', NULL, 'Senecionine N-oxygenase', 304, NULL, NULL, 218110),
(218111, '3.60.15.10-FF-000136', NULL, 'N-Acyl Phosphatidyl Ethanolamine specific phospholipase D (NAPE-PLD) homolog', 296, NULL, NULL, 218111),
(218112, '3.90.550.50-FF-000176', NULL, 'Hexosyltransferase', 254, NULL, NULL, 218112),
(218113, '3.20.20.210-FF-000005', NULL, 'Uroporphyrinogen decarboxylase', 344, NULL, NULL, 218113),
(218114, '3.40.630.30-FF-000480', NULL, 'Putative N-acetyltransferase san', 153, NULL, NULL, 218114);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(218115, '3.80.10.10-FF-004502', NULL, 'Predicted protein', 210, NULL, NULL, 218115),
(218116, '2.60.40.60-FF-000481', NULL, 'Uncharacterized protein', 107, NULL, NULL, 218116),
(218117, '3.90.1150.10-FF-000245', NULL, 'Pleiotropic regulatory protein', 120, NULL, NULL, 218117),
(218118, '3.60.21.10-FF-000257', NULL, 'Tyrosine-protein phosphatase RLPH2', 274, NULL, NULL, 218118),
(218119, '3.40.50.1380-FF-000036', NULL, 'Predicted protein', 54, NULL, NULL, 218119),
(218120, '3.90.70.10-FF-000026', NULL, 'Ubiquitin carboxyl-terminal hydrolase 15', 321, NULL, NULL, 218120),
(218121, '3.30.450.90-FF-000019', NULL, 'General secretion pathway protein E', 125, NULL, NULL, 218121),
(218122, '2.60.200.20-FF-000186', NULL, 'FHA domain-containing protein', 103, NULL, NULL, 218122),
(218123, '3.40.50.1000-FF-000035', NULL, 'RNA polymerase II C-terminal domain phosphatase-like 1', 201, NULL, NULL, 218123),
(218124, '2.60.120.10-FF-000648', NULL, 'Uncharacterized protein', 148, NULL, NULL, 218124),
(218125, '3.40.50.300-FF-008139', NULL, 'Tight junction protein 3', 98, NULL, NULL, 218125),
(218126, '1.25.10.10-FF-001447', NULL, 'Serine/threonine-protein kinase TOR', 272, NULL, NULL, 218126),
(218127, '1.10.10.10-FF-002060', NULL, 'ATP-dependent DNA helicase', 190, NULL, NULL, 218127),
(218128, '1.10.287.70-FF-000101', NULL, 'Voltage-gated potassium channel Kch', 102, NULL, NULL, 218128),
(218129, '3.30.160.60-FF-000264', NULL, 'Zinc finger protein 236', 30, NULL, NULL, 218129),
(218130, '3.40.50.300-FF-007122', NULL, 'Uncharacterized protein', 184, NULL, NULL, 218130),
(218131, '3.40.50.1000-FF-000378', NULL, 'Cation-transporting ATPase', 171, NULL, NULL, 218131),
(218132, '3.30.420.270-FF-000026', NULL, 'Biopolymer transport protein ExbD/TolR', 69, NULL, NULL, 218132),
(218133, '3.50.7.10-FF-000029', NULL, 'Uncharacterized protein', 68, NULL, NULL, 218133),
(218134, '1.25.40.860-FF-000007', NULL, 'Eukaryotic translation initiation factor 3 subunit A', 116, NULL, NULL, 218134),
(218135, '1.10.10.1390-FF-000002', NULL, NULL, 91, NULL, NULL, 218135),
(218136, '1.20.120.20-FF-000012', NULL, 'Skeleton-binding protein 1', 142, NULL, NULL, 218136),
(218137, '2.130.10.10-FF-003985', NULL, 'Uncharacterized protein', 233, NULL, NULL, 218137),
(218138, '3.40.50.2300-FF-000138', NULL, 'Two-component system sensor histidine kinase/response regulator', 143, NULL, NULL, 218138),
(218139, '2.10.110.10-FF-000136', NULL, 'LIM domain family', 67, NULL, NULL, 218139),
(218140, '3.30.200.20-FF-000447', NULL, 'Calcium/calmodulin dependent protein kinase', 84, NULL, NULL, 218140),
(218141, '1.10.1520.10-FF-000108', NULL, 'Uncharacterized protein', 168, NULL, NULL, 218141),
(218142, '3.30.465.10-FF-000070', NULL, 'Uncharacterized protein', 65, NULL, NULL, 218142),
(218143, '1.10.533.10-FF-000139', NULL, 'Ankyrin-2', 72, NULL, NULL, 218143),
(218144, '2.160.10.10-FF-000049', NULL, 'Glucose-1-phosphate adenylyltransferase', 124, NULL, NULL, 218144),
(218145, '3.30.70.980-FF-000036', NULL, 'Probable transcriptional regulatory protein BbuZS7_0025', 77, NULL, NULL, 218145),
(218146, '2.60.120.650-FF-000229', NULL, 'Uncharacterized protein', 164, NULL, NULL, 218146),
(218147, '3.90.25.10-FF-000051', NULL, 'UDP-glucose 4-epimerase', 71, NULL, NULL, 218147),
(218148, '1.20.190.40-FF-000005', NULL, 'Major DNA-binding protein', 134, NULL, NULL, 218148),
(218149, '2.60.40.150-FF-000312', NULL, 'Phosphoinositide phospholipase C', 169, NULL, NULL, 218149),
(218150, '3.40.50.300-FF-002271', NULL, 'Protein ROOT HAIR DEFECTIVE 3 homolog', 256, NULL, NULL, 218150),
(218151, '1.25.40.840-FF-000001', NULL, 'Ccr4-not transcription complex subunit 1 isoform', 180, NULL, NULL, 218151),
(218152, '1.25.10.10-FF-003313', NULL, 'Protein CELLULOSE SYNTHASE INTERACTIVE 3', 149, NULL, NULL, 218152),
(218153, '3.30.390.50-FF-000031', NULL, 'Lipoate-protein ligase A subunit 2', 90, NULL, NULL, 218153),
(218154, '2.40.50.140-FF-000006', NULL, 'Cold shock protein CspC', 67, NULL, NULL, 218154),
(218155, '3.40.50.12710-FF-000023', NULL, 'Uncharacterized protein', 380, NULL, NULL, 218155);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(218156, '3.10.350.10-FF-000083', NULL, 'Peptidase M23', 45, NULL, NULL, 218156),
(218157, '3.30.60.90-FF-000052', NULL, 'Transcriptional adapter', 57, NULL, NULL, 218157),
(218158, '3.40.50.300-FF-002855', NULL, 'Interferon-induced guanylate-binding protein', 276, NULL, NULL, 218158),
(218159, '1.50.10.150-FF-000008', NULL, 'Exfoliative toxin A', 304, NULL, NULL, 218159),
(218160, '2.20.100.10-FF-000257', NULL, 'Semaphorin-5c', 73, NULL, NULL, 218160),
(218161, '3.40.50.720-FF-000328', NULL, 'UDP-glucose 6-dehydrogenase', 88, NULL, NULL, 218161),
(218162, '3.40.120.10-FF-000008', NULL, 'Alpha-D-glucose phosphate-specific phosphoglucomutase', 124, NULL, NULL, 218162),
(218163, '3.30.160.60-FF-004479', NULL, NULL, 70, NULL, NULL, 218163),
(218164, '1.20.1250.20-FF-002016', NULL, 'Solute carrier organic anion transporter family member', 368, NULL, NULL, 218164),
(218165, '1.10.405.10-FF-000038', NULL, 'Amine oxidase', 60, NULL, NULL, 218165),
(218166, '3.30.200.20-FF-002476', NULL, NULL, 43, NULL, NULL, 218166),
(218167, '1.10.510.10-FF-000732', NULL, 'Protein serine-threonine kinase', 355, NULL, NULL, 218167),
(218168, '3.40.50.300-FF-005497', NULL, 'DNA replication and repair protein RecF', 185, NULL, NULL, 218168),
(218169, '3.10.25.10-FF-000015', NULL, 'Methionyl-tRNA formyltransferase', 105, NULL, NULL, 218169),
(218170, '3.30.160.60-FF-002450', NULL, 'Zinc finger protein 470', 28, NULL, NULL, 218170),
(218171, '2.40.10.10-FF-000229', NULL, 'Si:dkey-33m11.7', 112, NULL, NULL, 218171),
(218172, '3.40.50.11370-FF-000008', NULL, 'Inositol-tetrakisphosphate 1-kinase', 40, NULL, NULL, 218172),
(218173, '1.10.20.10-FF-000380', NULL, NULL, 30, NULL, NULL, 218173),
(218174, '3.40.50.2020-FF-000116', NULL, 'Phosphoribosyl pyrophosphate synthetase-associated protein 1', 142, NULL, NULL, 218174),
(218175, '2.60.40.640-FF-000122', NULL, 'Chromosome 16, whole genome shotgun sequence', 141, NULL, NULL, 218175),
(218176, '3.30.1780.10-FF-000020', NULL, 'Uncharacterized protein', 112, NULL, NULL, 218176),
(218177, '1.20.1530.20-FF-000076', NULL, 'Na+/H+ exchanger', 406, NULL, NULL, 218177),
(218178, '2.60.40.10-FF-005570', NULL, NULL, 48, NULL, NULL, 218178),
(218179, '3.40.720.10-FF-000149', NULL, 'PhosphatidylInositol Glycan anchor biosynthesis class G', 293, NULL, NULL, 218179),
(218180, '3.30.420.40-FF-000609', NULL, 'hexokinase-2 isoform X3', 106, NULL, NULL, 218180),
(218181, '2.10.70.10-FF-000077', NULL, 'Complement component C7', 57, NULL, NULL, 218181),
(218182, '3.40.50.1820-FF-001169', NULL, 'Uncharacterized protein', 228, NULL, NULL, 218182),
(218183, '3.90.70.10-FF-000594', NULL, 'Uncharacterized protein', 203, NULL, NULL, 218183),
(218184, '3.30.70.360-FF-000058', NULL, 'Predicted protein', 100, NULL, NULL, 218184),
(218185, '1.25.40.10-FF-004501', NULL, 'Uncharacterized protein', 92, NULL, NULL, 218185),
(218186, '1.10.287.470-FF-000086', NULL, 'Gll0875 protein', 88, NULL, NULL, 218186),
(218187, '3.40.50.2000-FF-000110', NULL, 'UDP-N-acetylglucosaminyltransferase protein', 170, NULL, NULL, 218187),
(218188, '1.10.220.30-FF-000019', NULL, 'Flagellar motor switch protein FliG', 91, NULL, NULL, 218188),
(218189, '1.10.1170.10-FF-000047', NULL, 'Uncharacterized protein', 62, NULL, NULL, 218189),
(218190, '2.10.25.160-FF-000005', NULL, 'Granulin a', 64, NULL, NULL, 218190),
(218191, '2.130.10.10-FF-004974', NULL, 'Uncharacterized protein', 84, NULL, NULL, 218191),
(218192, '2.60.120.10-FF-000732', NULL, 'cGMP-dependent protein kinase', 127, NULL, NULL, 218192),
(218193, '3.80.10.10-FF-001276', NULL, 'Uncharacterized protein', 181, NULL, NULL, 218193),
(218194, '2.170.120.12-FF-000017', NULL, 'DNA-directed RNA polymerase II subunit putative', 113, NULL, NULL, 218194),
(218195, '2.120.10.80-FF-000049', NULL, 'Cell polarity protein (Tea1)', 276, NULL, NULL, 218195),
(218196, '3.30.420.40-FF-000025', NULL, 'pantothenate kinase 2, mitochondrial', 175, NULL, NULL, 218196),
(218197, '3.20.80.10-FF-000007', NULL, 'Heme-binding protein 2', 170, NULL, NULL, 218197),
(218198, '2.60.40.10-FF-000404', NULL, 'Sortilin related receptor 1', 88, NULL, NULL, 218198);
INSERT INTO "PUBLIC"."MODEL" VALUES
(218199, '3.40.605.10-FF-000129', NULL, 'Uncharacterized protein', 140, NULL, NULL, 218199),
(218200, '3.30.70.330-FF-002932', NULL, NULL, 163, NULL, NULL, 218200),
(218201, '3.30.160.60-FF-002293', NULL, 'Zinc finger protein 836', 26, NULL, NULL, 218201),
(218202, '3.40.50.150-FF-001309', NULL, NULL, 211, NULL, NULL, 218202),
(218203, '1.50.40.10-FF-000547', NULL, 'Uncharacterized protein', 135, NULL, NULL, 218203),
(218204, '2.60.120.20-FF-000005', NULL, 'Genome polyprotein', 218, NULL, NULL, 218204),
(218205, '3.40.50.10540-FF-000001', NULL, 'L-carnitine CoA-transferase', 282, NULL, NULL, 218205),
(218206, '1.25.40.10-FF-000494', NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', 116, NULL, NULL, 218206),
(218207, '3.30.40.10-FF-001589', NULL, 'Histone-lysine N-methyltransferase', 59, NULL, NULL, 218207),
(218208, '1.10.390.10-FF-000014', NULL, 'aminopeptidase O isoform X1', 172, NULL, NULL, 218208),
(218209, '3.40.50.80-FF-000205', NULL, 'Ferric reductase-like transmembrane component', 230, NULL, NULL, 218209),
(218210, '1.10.472.10-FF-000210', NULL, 'Cyclin, putative', 117, NULL, NULL, 218210),
(218211, '2.60.120.10-FF-000468', NULL, 'Predicted protein', 232, NULL, NULL, 218211),
(218212, '1.10.10.10-FF-000547', NULL, 'Peroxisomal membrane protein PEX14', 63, NULL, NULL, 218212),
(218213, '2.70.150.10-FF-000182', NULL, 'Phospholipid-transporting ATPase', 162, NULL, NULL, 218213),
(218214, '3.30.300.110-FF-000008', NULL, 'tRNA(Phe) (4-demethylwyosine(37)-C(7)) aminocarboxypropyltransferase', 85, NULL, NULL, 218214),
(218215, '1.25.10.10-FF-000458', NULL, 'Juxtamembrane domain-associated catenin', 466, NULL, NULL, 218215),
(218216, '3.60.40.10-FF-000278', NULL, 'Stage II sporulation E family protein', 249, NULL, NULL, 218216),
(218217, '3.30.250.20-FF-000006', NULL, 'Uncharacterized protein', 67, NULL, NULL, 218217),
(218218, '1.10.238.10-FF-000127', NULL, 'Mitochondrial Rho GTPase', 199, NULL, NULL, 218218),
(218219, '3.40.30.10-FF-000374', NULL, 'Glutathione S-transferase', 92, NULL, NULL, 218219),
(218220, '3.40.50.2300-FF-001566', NULL, NULL, 163, NULL, NULL, 218220),
(218221, '3.30.70.940-FF-000024', NULL, 'Transcription elongation factor SPT5', 102, NULL, NULL, 218221),
(218222, '3.30.160.60-FF-005047', NULL, NULL, 59, NULL, NULL, 218222),
(218223, '4.10.800.10-FF-000030', NULL, 'Uncharacterized protein', 63, NULL, NULL, 218223),
(218224, '1.10.300.10-FF-000014', NULL, 'Adenylosuccinate synthetase', 97, NULL, NULL, 218224),
(218225, '3.40.50.1820-FF-000505', NULL, 'Uncharacterized protein', 554, NULL, NULL, 218225),
(218226, '1.25.40.10-FF-001836', NULL, 'Os03g0852700 protein', 113, NULL, NULL, 218226),
(218227, '2.60.40.10-FF-004619', NULL, NULL, 87, NULL, NULL, 218227),
(218228, '3.90.550.10-FF-000063', NULL, 'Beta-1,4-N-acetylgalactosaminyltransferase', 220, NULL, NULL, 218228),
(218229, '3.30.505.10-FF-000247', NULL, NULL, 57, NULL, NULL, 218229),
(218230, '1.20.1510.10-FF-000021', NULL, 'Solute carrier family 30 (Zinc transporter), member 1', 89, NULL, NULL, 218230),
(218231, '2.80.10.50-FF-000161', NULL, 'Lectin', 153, NULL, NULL, 218231),
(218232, '3.30.420.100-FF-000021', NULL, 'Uncharacterized protein', 144, NULL, NULL, 218232),
(218233, '1.10.220.10-FF-000013', NULL, 'Annexin', 89, NULL, NULL, 218233),
(218234, '2.60.120.260-FF-000039', NULL, 'Reelin', 155, NULL, NULL, 218234),
(218235, '1.10.220.160-FF-000022', NULL, NULL, 68, NULL, NULL, 218235),
(218236, '1.10.10.60-FF-000461', NULL, 'Sigma-54-dependent Fis family transcriptional regulator', 61, NULL, NULL, 218236),
(218237, '2.60.40.10-FF-000668', NULL, 'transmembrane protein 130 isoform X2', 63, NULL, NULL, 218237),
(218238, '3.40.50.300-FF-000085', NULL, 'Putative ras-related protein rab-11a', 210, NULL, NULL, 218238),
(218239, '3.40.50.410-FF-000179', NULL, 'von Willebrand factor type A domain protein', 281, NULL, NULL, 218239),
(218240, '1.10.510.10-FF-003329', NULL, NULL, 59, NULL, NULL, 218240),
(218241, '2.40.20.10-FF-000095', NULL, 'Uncharacterized protein', 101, NULL, NULL, 218241);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(218242, '2.60.120.40-FF-000011', NULL, 'Elastin microfibril interfacer 2', 151, NULL, NULL, 218242),
(218243, '3.40.30.10-FF-000907', NULL, 'Antioxidant protein, putative', 136, NULL, NULL, 218243),
(218244, '1.10.8.10-FF-000119', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 37, NULL, NULL, 218244),
(218245, '2.60.40.10-FF-003153', NULL, 'Titin homolog', 106, NULL, NULL, 218245),
(218246, '3.30.160.60-FF-000112', NULL, 'Mds1 and evi1 complex locus protein', 31, NULL, NULL, 218246),
(218247, '2.70.170.10-FF-000014', NULL, 'Glycine receptor subunit beta', 212, NULL, NULL, 218247),
(218248, '3.90.730.10-FF-000009', NULL, 'Ribonuclease 1', 206, NULL, NULL, 218248),
(218249, '3.65.10.10-FF-000030', NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', 194, NULL, NULL, 218249),
(218250, '3.90.550.10-FF-000243', NULL, 'Glycosyl transferase, group 2 family protein', 179, NULL, NULL, 218250),
(218251, '1.20.5.1150-FF-000001', NULL, '30S ribosomal protein S21', 39, NULL, NULL, 218251),
(218252, '2.130.10.10-FF-000472', NULL, 'Embryonic ectoderm development', 166, NULL, NULL, 218252),
(218253, '1.10.3090.10-FF-000013', NULL, 'PolyA polymerase family protein', 280, NULL, NULL, 218253),
(218254, '2.60.40.150-FF-000632', NULL, 'Synaptotagmin 2', 139, NULL, NULL, 218254),
(218255, '3.90.320.10-FF-000046', NULL, 'YALI0E33377p', 164, NULL, NULL, 218255),
(218256, '3.40.30.10-FF-000166', NULL, 'Thioredoxin-like protein AAED1, chloroplastic', 184, NULL, NULL, 218256),
(218257, '2.40.30.130-FF-000011', NULL, 'Alanine--tRNA ligase', 75, NULL, NULL, 218257),
(218258, '1.25.40.10-FF-000847', NULL, 'Signal recognition particle subunit SRP72', 119, NULL, NULL, 218258),
(218259, '3.40.50.10900-FF-000031', NULL, 'Uncharacterized protein', 126, NULL, NULL, 218259),
(218260, '1.10.10.60-FF-000129', NULL, 'Telomeric repeat-binding factor 2', 63, NULL, NULL, 218260),
(218261, '3.40.50.2300-FF-000470', NULL, 'Olfactory receptor family 2 subfamily G member 3', 261, NULL, NULL, 218261),
(218262, '1.20.120.1200-FF-000024', NULL, 'NADH-ubiquinone oxidoreductase chain 6', 188, NULL, NULL, 218262),
(218263, '3.40.50.150-FF-000528', NULL, 'DNA methyltransferase Dim-2', 257, NULL, NULL, 218263),
(218264, '3.10.20.90-FF-000741', NULL, 'Predicted protein', 106, NULL, NULL, 218264),
(218265, '3.90.70.10-FF-000318', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 104, NULL, NULL, 218265),
(218266, '3.40.30.10-FF-000054', NULL, 'Disulfide-isomerase A3', 112, NULL, NULL, 218266),
(218267, '3.30.1960.10-FF-000017', NULL, 'Reverse transcriptase, putative', 94, NULL, NULL, 218267),
(218268, '1.10.3550.20-FF-000001', NULL, 'T4 RNA ligase 1', 131, NULL, NULL, 218268),
(218269, '1.25.40.20-FF-000384', NULL, 'Os07g0515700 protein', 115, NULL, NULL, 218269),
(218270, '1.10.287.70-FF-000073', NULL, 'Potassium voltage-gated channel subfamily D member 2', 53, NULL, NULL, 218270),
(218271, '2.40.10.10-FF-000381', NULL, NULL, 100, NULL, NULL, 218271),
(218272, '1.10.1420.10-FF-000163', NULL, 'DNA mismatch repair protein', 176, NULL, NULL, 218272),
(218273, '1.20.140.180-FF-000001', NULL, 'RTX toxin RtxA', 133, NULL, NULL, 218273),
(218274, '3.40.50.720-FF-001964', NULL, 'Oxidoreductase, short chain dehydrogenase/reductase family protein', 256, NULL, NULL, 218274),
(218275, '3.40.1190.20-FF-000043', NULL, 'ATP-dependent (S)-NAD(P)H-hydrate dehydratase', 316, NULL, NULL, 218275),
(218276, '3.50.50.60-FF-001194', NULL, 'Uncharacterized protein', 427, NULL, NULL, 218276),
(218277, '2.60.98.20-FF-000001', NULL, 'Flagellar hook protein FlgE', 140, NULL, NULL, 218277),
(218278, '1.25.40.10-FF-003141', NULL, 'Putative pentatricopeptide repeat-containing protein', 142, NULL, NULL, 218278),
(218279, '3.30.450.20-FF-000370', NULL, 'Methyl-accepting chemotaxis protein', 129, NULL, NULL, 218279),
(218280, '3.30.565.10-FF-000066', NULL, 'Two-component sensor kinase MprB', 151, NULL, NULL, 218280),
(218281, '3.50.50.60-FF-001418', NULL, 'Uncharacterized protein', 128, NULL, NULL, 218281),
(218282, '3.80.10.10-FF-002636', NULL, 'Uncharacterized protein', 70, NULL, NULL, 218282);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(218283, '1.10.238.10-FF-000071', NULL, 'Phosphoinositide phospholipase C', 50, NULL, NULL, 218283),
(218284, '3.40.50.1390-FF-000022', NULL, 'Probable PhiRv1 integrase', 135, NULL, NULL, 218284),
(218285, '3.30.540.10-FF-000025', NULL, 'Inositol-1-monophosphatase', 144, NULL, NULL, 218285),
(218286, '3.30.70.270-FF-000183', NULL, 'PAS/PAC sensor-containing diguanylate cyclase/phosphodiesterase', 171, NULL, NULL, 218286),
(218287, '1.10.580.10-FF-000034', NULL, 'Uncharacterized protein', 167, NULL, NULL, 218287),
(218288, '3.40.640.10-FF-000267', NULL, 'L-seryl-tRNA(Sec) selenium transferase', 250, NULL, NULL, 218288),
(218289, '1.10.287.3240-FF-000036', NULL, 'Vacuolar H+-ATPase V1 sector, subunit D, putative', 177, NULL, NULL, 218289),
(218290, '1.10.533.10-FF-000291', NULL, 'Uncharacterized protein', 90, NULL, NULL, 218290),
(218291, '3.40.50.300-FF-004249', NULL, 'GTPase Der', 171, NULL, NULL, 218291),
(218292, '2.60.40.420-FF-000005', NULL, 'Ephrin A5', 138, NULL, NULL, 218292),
(218293, '3.30.1120.10-FF-000066', NULL, 'Arylsulphatase A', 88, NULL, NULL, 218293),
(218294, '2.60.120.620-FF-000018', NULL, '2-oxoglutarate (2OG) and Fe(II)-dependent oxygenase superfamily protein', 196, NULL, NULL, 218294),
(218295, '3.30.830.10-FF-000295', NULL, 'Uncharacterized protein', 71, NULL, NULL, 218295),
(218296, '4.10.280.10-FF-000101', NULL, 'Transcription factor PRE4', 68, NULL, NULL, 218296),
(218297, '1.10.10.10-FF-000727', NULL, 'Vacuolar sorting protein', 85, NULL, NULL, 218297),
(218298, '2.60.40.10-FF-001124', NULL, 'leukemia inhibitory factor receptor', 80, NULL, NULL, 218298),
(218299, '2.170.270.10-FF-000149', NULL, 'Myeloid/lymphoid or mixed-lineage leukemia', 183, NULL, NULL, 218299),
(218300, '3.30.499.10-FF-000035', NULL, NULL, 76, NULL, NULL, 218300),
(218301, '3.40.50.300-FF-005885', NULL, 'AAA domain containing protein, putative', 126, NULL, NULL, 218301),
(218302, '1.10.287.80-FF-000019', NULL, 'ATP synthase gamma chain', 44, NULL, NULL, 218302),
(218303, '3.30.40.10-FF-000021', NULL, 'Inhibitor of growth 2b', 57, NULL, NULL, 218303),
(218304, '3.30.70.330-FF-002724', NULL, NULL, 143, NULL, NULL, 218304),
(218305, '1.25.40.10-FF-000286', NULL, 'Tetratricopeptide repeat domain 28', 160, NULL, NULL, 218305),
(218306, '1.10.630.10-FF-000090', NULL, 'Cytochrome P450 monooxygenase', 474, NULL, NULL, 218306),
(218307, '1.10.10.60-FF-000989', NULL, NULL, 82, NULL, NULL, 218307),
(218308, '2.130.10.10-FF-002349', NULL, 'WD repeat domain 18', 203, NULL, NULL, 218308),
(218309, '3.30.160.60-FF-001101', NULL, 'Zinc finger protein 408', 28, NULL, NULL, 218309),
(218310, '3.40.640.10-FF-000328', NULL, 'Dethiobiotin synthase', 325, NULL, NULL, 218310),
(218311, '1.20.1740.10-FF-000089', NULL, 'Protein CBG13067', 440, NULL, NULL, 218311),
(218312, '1.20.1250.20-FF-000886', NULL, '3-phenylpropionic acid transporter', 186, NULL, NULL, 218312),
(218313, '3.30.1020.10-FF-000002', NULL, 'Peroxiredoxin', 72, NULL, NULL, 218313),
(218314, '1.10.20.10-FF-000104', NULL, 'Transcription initiation factor TFIID subunit 6', 66, NULL, NULL, 218314),
(218315, '3.30.160.20-FF-000100', NULL, 'Probable peptide chain release factor 1, mitochondrial', 91, NULL, NULL, 218315),
(218316, '1.25.10.10-FF-000666', NULL, 'Exportin 6, isoform A', 1012, NULL, NULL, 218316),
(218317, '3.40.50.300-FF-005609', NULL, 'Predicted protein', 76, NULL, NULL, 218317),
(218318, '2.60.120.10-FF-000356', NULL, 'Cyclic nucleotide-binding protein', 135, NULL, NULL, 218318),
(218319, '3.40.50.300-FF-000826', NULL, 'Replicative DNA helicase Mcm', 344, NULL, NULL, 218319),
(218320, '3.10.105.10-FF-000087', NULL, 'Bacterial extracellular solute-binding protein, family 5', 205, NULL, NULL, 218320),
(218321, '2.60.40.60-FF-000037', NULL, 'FAT atypical cadherin 1', 105, NULL, NULL, 218321),
(218322, '3.30.160.60-FF-003698', NULL, NULL, 43, NULL, NULL, 218322),
(218323, '2.60.40.10-FF-002821', NULL, 'Leucine-rich repeats and immunoglobulin-like domains protein sma-10', 112, NULL, NULL, 218323),
(218324, '3.40.630.30-FF-000249', NULL, 'Histone acetyltransferase', 132, NULL, NULL, 218324);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(218325, '3.10.490.20-FF-000034', NULL, 'Motor, putative', 126, NULL, NULL, 218325),
(218326, '2.40.40.20-FF-000043', NULL, 'NADH-quinone oxidoreductase', 104, NULL, NULL, 218326),
(218327, '2.130.10.10-FF-004070', NULL, 'DENN/MADD domain-containing 3b', 206, NULL, NULL, 218327),
(218328, '3.40.50.80-FF-000025', NULL, 'Nitrate reductase [NADH]', 152, NULL, NULL, 218328),
(218329, '3.30.70.330-FF-000515', NULL, 'RNA-binding motif protein 5', 139, NULL, NULL, 218329),
(218330, '3.20.20.190-FF-000050', NULL, 'Glycerophosphoryl diester phosphodiesterase', 327, NULL, NULL, 218330),
(218331, '1.20.58.760-FF-000043', NULL, 'Uncharacterized protein', 191, NULL, NULL, 218331),
(218332, '3.90.105.20-FF-000009', NULL, 'Uncharacterized protein', 51, NULL, NULL, 218332),
(218333, '1.20.5.110-FF-000258', NULL, 'Uncharacterized protein', 94, NULL, NULL, 218333),
(218334, '1.10.10.2750-FF-000005', NULL, NULL, 79, NULL, NULL, 218334),
(218335, '3.30.1070.10-FF-000005', NULL, 'Cell division topological specificity factor', 74, NULL, NULL, 218335),
(218336, '3.10.20.90-FF-000218', NULL, 'Ubiquitin carboxyl-terminal hydrolase 32', 86, NULL, NULL, 218336),
(218337, '3.30.40.10-FF-002045', NULL, 'Uncharacterized protein', 159, NULL, NULL, 218337),
(218338, '3.90.190.10-FF-000260', NULL, 'Dual specificity phosphatase 19a', 148, NULL, NULL, 218338),
(218339, '2.10.110.10-FF-000316', NULL, 'Uncharacterized protein', 118, NULL, NULL, 218339),
(218340, '2.30.29.30-FF-000110', NULL, 'Docking protein 4', 109, NULL, NULL, 218340),
(218341, '3.40.50.300-FF-008370', NULL, 'Adenylate kinase 9', 229, NULL, NULL, 218341),
(218342, '1.10.510.10-FF-004318', NULL, NULL, 146, NULL, NULL, 218342),
(218343, '3.10.20.90-FF-000865', NULL, 'Uncharacterized protein C17C9.11c', 71, NULL, NULL, 218343),
(218344, '2.60.40.1930-FF-000006', NULL, 'Complement C3', 101, NULL, NULL, 218344),
(218345, '3.90.1310.10-FF-000016', NULL, 'PASTA domain-containing protein', 197, NULL, NULL, 218345),
(218346, '2.10.25.10-FF-001759', NULL, 'Uncharacterized protein', 36, NULL, NULL, 218346),
(218347, '2.60.40.1400-FF-000022', NULL, NULL, 72, NULL, NULL, 218347),
(218348, '2.60.260.20-FF-000015', NULL, 'Heat shock protein 40', 80, NULL, NULL, 218348),
(218349, '1.10.10.10-FF-000143', NULL, 'DDRGK domain-containing protein 1', 58, NULL, NULL, 218349),
(218350, '2.60.40.150-FF-000132', NULL, 'Copine 7', 129, NULL, NULL, 218350),
(218351, '1.20.1560.10-FF-000367', NULL, 'Probable non-intrinsic ABC protein 5', 160, NULL, NULL, 218351),
(218352, '3.30.1150.10-FF-000006', NULL, 'Protein TonB', 102, NULL, NULL, 218352),
(218353, '2.30.30.40-FF-000537', NULL, 'Formin-binding protein', 67, NULL, NULL, 218353),
(218354, '1.25.40.120-FF-000078', NULL, 'Protein farnesyltransferase alpha subunit, putative', 384, NULL, NULL, 218354),
(218355, '3.30.70.330-FF-002371', NULL, NULL, 103, NULL, NULL, 218355),
(218356, '1.20.80.10-FF-000068', NULL, 'Enoyl-CoA delta isomerase 3, peroxisomal', 45, NULL, NULL, 218356),
(218357, '3.10.110.10-FF-000273', NULL, 'Ubiquitin-conjugating enzyme family protein', 133, NULL, NULL, 218357),
(218358, '1.10.287.950-FF-000016', NULL, 'Methyl-accepting chemotaxis protein', 318, NULL, NULL, 218358),
(218359, '3.90.70.10-FF-000470', NULL, 'Uncharacterized protein', 156, NULL, NULL, 218359),
(218360, '3.40.50.2300-FF-000318', NULL, 'Sugar ABC transporter substrate-binding protein', 177, NULL, NULL, 218360),
(218361, '3.30.40.10-FF-001038', NULL, 'Ubiquitinyl hydrolase 1', 120, NULL, NULL, 218361),
(218362, '3.30.160.60-FF-004715', NULL, NULL, 44, NULL, NULL, 218362),
(218363, '3.30.70.100-FF-000008', NULL, 'Copper transport protein ATOX1', 70, NULL, NULL, 218363),
(218364, '2.60.34.10-FF-000103', NULL, 'Uncharacterized protein', 159, NULL, NULL, 218364),
(218365, '3.30.70.870-FF-000003', NULL, 'GTP-binding protein TypA', 110, NULL, NULL, 218365),
(218366, '1.10.10.10-FF-001896', NULL, 'DNA-directed RNA polymerase III subunit rpc3', 100, NULL, NULL, 218366),
(218367, '1.10.10.60-FF-000540', NULL, 'HOP homeobox', 49, NULL, NULL, 218367),
(218368, '1.20.120.420-FF-000013', NULL, 'Methylthioribose-1-phosphate isomerase', 147, NULL, NULL, 218368);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(218369, '2.60.200.20-FF-000270', NULL, 'Uncharacterized protein', 150, NULL, NULL, 218369),
(218370, '3.40.50.720-FF-001385', NULL, 'Phosphoglycerate dehydrogenase', 120, NULL, NULL, 218370),
(218371, '1.10.420.10-FF-000012', NULL, 'Peroxidase', 156, NULL, NULL, 218371),
(218372, '1.10.3720.10-FF-000091', NULL, 'Phosphate transport system permease protein', 283, NULL, NULL, 218372),
(218373, '3.40.50.300-FF-006666', NULL, 'Uncharacterized protein', 85, NULL, NULL, 218373),
(218374, '3.30.420.40-FF-000548', NULL, 'Chaperone protein DnaK HSP70', 100, NULL, NULL, 218374),
(218375, '2.80.10.50-FF-000082', NULL, 'Beta/gamma crystallin domain-containing protein 3', 87, NULL, NULL, 218375),
(218376, '2.60.40.2830-FF-000001', NULL, 'Autophagy-related protein 19', 117, NULL, NULL, 218376),
(218377, '3.90.70.10-FF-000526', NULL, 'AGAP000884-PA', 86, NULL, NULL, 218377),
(218378, '2.20.25.10-FF-000073', NULL, 'Trm112p-like_protein_-_putative', 141, NULL, NULL, 218378),
(218379, '3.30.160.20-FF-000179', NULL, 'Ribonuclease III', 87, NULL, NULL, 218379),
(218380, '3.30.260.10-FF-000043', NULL, 'Chaperonin 1 60 kDa', 91, NULL, NULL, 218380),
(218381, '3.40.50.150-FF-001540', NULL, NULL, 93, NULL, NULL, 218381),
(218382, '3.40.50.790-FF-000017', NULL, 'Protein CBG11519', 95, NULL, NULL, 218382),
(218383, '1.10.287.380-FF-000008', NULL, 'ABC transporter ATP-binding protein', 78, NULL, NULL, 218383),
(218384, '1.10.620.20-FF-000030', NULL, 'Os06g0503800 protein', 214, NULL, NULL, 218384),
(218385, '3.40.50.300-FF-002451', NULL, 'Midasin', 212, NULL, NULL, 218385),
(218386, '2.130.10.10-FF-004423', NULL, 'Protein phosphatase PP2A regulatory subunit B', 359, NULL, NULL, 218386),
(218387, '2.30.230.10-FF-000045', NULL, 'Uncharacterized protein', 51, NULL, NULL, 218387),
(218388, '3.40.50.300-FF-004480', NULL, 'Protein CBR-RAB-21', 108, NULL, NULL, 218388),
(218389, '3.40.50.300-FF-005385', NULL, 'AGAP005926-PA', 358, NULL, NULL, 218389),
(218390, '2.40.30.10-FF-000213', NULL, 'Elongation factor 1-alpha, putative', 88, NULL, NULL, 218390),
(218391, '3.30.1680.10-FF-000035', NULL, 'Uncharacterized integrin beta-like protein C05D9.3', 57, NULL, NULL, 218391),
(218392, '3.30.300.10-FF-000002', NULL, 'GMP synthase [glutamine-hydrolyzing]', 115, NULL, NULL, 218392),
(218393, '2.60.40.10-FF-003361', NULL, NULL, 91, NULL, NULL, 218393),
(218394, '1.10.30.10-FF-000138', NULL, 'Isw-1', 70, NULL, NULL, 218394),
(218395, '2.130.10.10-FF-004766', NULL, 'UDP-galactose:fucoside alpha-3-galactosyltransferase', 156, NULL, NULL, 218395),
(218396, '3.40.30.10-FF-000554', NULL, 'Uncharacterized protein', 156, NULL, NULL, 218396),
(218397, '1.25.40.10-FF-004158', NULL, 'Uncharacterized protein', 106, NULL, NULL, 218397),
(218398, '3.40.50.720-FF-000216', NULL, 'Glycerate dehydrogenase HPR, peroxisomal', 125, NULL, NULL, 218398),
(218399, '2.10.220.10-FF-000206', NULL, 'Uncharacterized protein', 56, NULL, NULL, 218399),
(218400, '1.25.10.10-FF-002291', NULL, 'Os05g0555100 protein', 326, NULL, NULL, 218400),
(218401, '2.60.40.60-FF-000722', NULL, 'Cadherin-4', 98, NULL, NULL, 218401),
(218402, '2.10.70.10-FF-000189', NULL, 'Uncharacterized protein', 67, NULL, NULL, 218402),
(218403, '1.10.1200.10-FF-000101', NULL, '6-deoxyerythronolide-B synthase EryA1, modules 1 and 2', 76, NULL, NULL, 218403),
(218404, '2.40.50.100-FF-000124', NULL, 'Bll2173 protein', 82, NULL, NULL, 218404),
(218405, '1.20.1560.10-FF-000103', NULL, 'Lipid A export ATP-binding/permease protein MsbA', 330, NULL, NULL, 218405),
(218406, '1.10.418.10-FF-000068', NULL, 'Putative Filamin-A', 111, NULL, NULL, 218406),
(218407, '3.30.40.10-FF-000600', NULL, 'Phd zn-finger protein', 57, NULL, NULL, 218407),
(218408, '3.30.160.60-FF-000617', NULL, 'Zinc finger protein 777', 30, NULL, NULL, 218408),
(218409, '3.90.1100.10-FF-000034', NULL, 'DNA-directed RNA polymerase subunit 2', 207, NULL, NULL, 218409),
(218410, '3.30.70.890-FF-000082', NULL, 'Predicted protein', 54, NULL, NULL, 218410),
(218411, '1.25.10.10-FF-002532', NULL, 'Uncharacterized protein', 188, NULL, NULL, 218411);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(218412, '1.20.5.490-FF-000018', NULL, 'Uncharacterized protein', 25, NULL, NULL, 218412),
(218413, '1.20.144.10-FF-000093', NULL, 'Uncharacterized protein', 267, NULL, NULL, 218413),
(218414, '1.20.5.340-FF-000092', NULL, 'Uncharacterized protein', 96, NULL, NULL, 218414),
(218415, '3.90.1300.10-FF-000010', NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit A, mitochondrial', 463, NULL, NULL, 218415),
(218416, '3.40.50.880-FF-000123', NULL, 'Serine O-acetyltransferase', 268, NULL, NULL, 218416),
(218417, '1.10.10.10-FF-001003', NULL, 'Hms2p', 99, NULL, NULL, 218417),
(218418, '3.40.50.2000-FF-000234', NULL, 'Glycosyl transferase', 220, NULL, NULL, 218418),
(218419, '1.10.10.10-FF-001267', NULL, 'GntR family transcriptional regulator', 81, NULL, NULL, 218419),
(218420, '1.20.140.40-FF-000002', NULL, 'Putative invertase inhibitor', 157, NULL, NULL, 218420),
(218421, '2.60.40.10-FF-004058', NULL, NULL, 96, NULL, NULL, 218421),
(218422, '3.30.70.660-FF-000030', NULL, 'tRNA pseudouridine synthase A', 139, NULL, NULL, 218422),
(218423, '3.90.1580.10-FF-000002', NULL, 'sulfatase-modifying factor 2 isoform X1', 266, NULL, NULL, 218423),
(218424, '2.30.39.10-FF-000110', NULL, 'Uncharacterized protein', 148, NULL, NULL, 218424),
(218425, '3.40.50.620-FF-000916', NULL, 'Probable electron transfer flavoprotein subunit alpha, mitochondrial', 187, NULL, NULL, 218425),
(218426, '3.30.70.250-FF-000025', NULL, NULL, 75, NULL, NULL, 218426),
(218427, '3.40.1380.20-FF-000046', NULL, 'Pyruvate kinase 1', 131, NULL, NULL, 218427),
(218428, '2.130.10.10-FF-000551', NULL, 'UTP15p Nucleolar protein', 147, NULL, NULL, 218428),
(218429, '2.10.50.30-FF-000020', NULL, 'Uncharacterized protein', 67, NULL, NULL, 218429),
(218430, '1.10.287.110-FF-000124', NULL, 'SCJ1p protein', 111, NULL, NULL, 218430),
(218431, '3.30.160.60-FF-003810', NULL, NULL, 29, NULL, NULL, 218431),
(218432, '2.130.10.130-FF-000024', NULL, 'Predicted protein', 312, NULL, NULL, 218432),
(218433, '4.10.860.10-FF-000016', NULL, 'ClpC ATPase', 39, NULL, NULL, 218433),
(218434, '2.130.10.10-FF-003013', NULL, 'Uncharacterized protein', 173, NULL, NULL, 218434),
(218435, '3.40.50.2300-FF-001487', NULL, NULL, 198, NULL, NULL, 218435),
(218436, '1.20.1730.10-FF-000083', NULL, 'Predicted protein', 483, NULL, NULL, 218436),
(218437, '3.60.20.10-FF-000058', NULL, 'Proteasome subunit alpha type', 258, NULL, NULL, 218437),
(218438, '1.10.20.10-FF-000312', NULL, NULL, 32, NULL, NULL, 218438),
(218439, '2.20.70.10-FF-000048', NULL, 'HECT, C2 and WW domain-containing E3 ubiquitin protein ligase 1', 56, NULL, NULL, 218439),
(218440, '3.30.365.10-FF-000067', NULL, 'Aerobic-type carbon monoxide dehydrogenase, large subunit-like protein', 17, NULL, NULL, 218440),
(218441, '1.10.486.10-FF-000068', NULL, 'Uncharacterized protein', 146, NULL, NULL, 218441),
(218442, '2.120.10.30-FF-000063', NULL, 'NHL repeat containing 2', 164, NULL, NULL, 218442),
(218443, '2.40.50.140-FF-000849', NULL, NULL, 112, NULL, NULL, 218443),
(218444, '3.30.1520.10-FF-000147', NULL, 'Sorting nexin mvp1', 118, NULL, NULL, 218444),
(218445, '1.20.1420.30-FF-000043', NULL, 'Ecm27p', 342, NULL, NULL, 218445),
(218446, '3.40.50.620-FF-000012', NULL, 'Phosphopantetheine adenylyltransferase', 161, NULL, NULL, 218446),
(218447, '3.30.160.60-FF-004327', NULL, NULL, 29, NULL, NULL, 218447),
(218448, '3.30.930.10-FF-000128', NULL, 'Phenylalanine-tRNA ligase, alpha subunit', 266, NULL, NULL, 218448),
(218449, '2.115.10.20-FF-000016', NULL, 'Uncharacterized protein', 450, NULL, NULL, 218449),
(218450, '3.60.10.10-FF-000097', NULL, 'Sphingomyelin phosphodiesterase-like protein', 290, NULL, NULL, 218450),
(218451, '1.10.220.20-FF-000005', NULL, 'ARF guanine-nucleotide exchange factor GNOM', 83, NULL, NULL, 218451),
(218452, '3.40.50.300-FF-002119', NULL, 'DNA repair protein rhp16', 267, NULL, NULL, 218452),
(218453, '1.10.10.10-FF-000486', NULL, 'Transcriptional activator protein TraR', 63, NULL, NULL, 218453),
(218454, '3.40.640.10-FF-000087', NULL, 'L-threonine aldolase', 239, NULL, NULL, 218454),
(218455, '3.40.390.10-FF-000106', NULL, 'Metalloendopeptidase', 244, NULL, NULL, 218455);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(218456, '2.70.220.10-FF-000007', NULL, 'Phosphatidylglycerol/phosphatidylinositol transfer protein', 67, NULL, NULL, 218456),
(218457, '2.70.150.10-FF-000243', NULL, 'Uncharacterized protein', 99, NULL, NULL, 218457),
(218458, '1.10.510.10-FF-002177', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase CES101 isoform A', 201, NULL, NULL, 218458),
(218459, '3.40.50.10090-FF-000046', NULL, 'Uroporphyrinogen-III C-methyltransferase', 117, NULL, NULL, 218459),
(218460, '1.10.287.110-FF-000467', NULL, 'Uncharacterized protein', 154, NULL, NULL, 218460),
(218461, '1.20.900.10-FF-000041', NULL, 'Rho guanyl nucleotide exchange factor', 196, NULL, NULL, 218461),
(218462, '3.40.30.10-FF-000897', NULL, 'Protein disulfide isomerase 3, putative', 133, NULL, NULL, 218462),
(218463, '1.10.510.10-FF-000103', NULL, 'PTI1-like tyrosine-protein kinase 3', 210, NULL, NULL, 218463),
(218464, '3.40.50.670-FF-000010', NULL, 'DNA topoisomerase 2', 129, NULL, NULL, 218464),
(218465, '1.50.40.10-FF-000194', NULL, 'Mitochondrial substrate carrier family protein Y', 288, NULL, NULL, 218465),
(218466, '3.40.50.1820-FF-001854', NULL, 'Uncharacterized protein', 59, NULL, NULL, 218466),
(218467, '3.80.10.10-FF-003417', NULL, 'Uncharacterized protein', 81, NULL, NULL, 218467),
(218468, '3.40.50.720-FF-001121', NULL, 'Calcium-gated potassium channel protein putative', 110, NULL, NULL, 218468),
(218469, '3.10.620.30-FF-000019', NULL, 'Peptide-N(4)-(N-acetyl-beta-glucosaminyl)asparagine amidase', 189, NULL, NULL, 218469),
(218470, '3.40.50.300-FF-006402', NULL, 'Uncharacterized protein', 133, NULL, NULL, 218470),
(218471, '2.60.40.10-FF-005339', NULL, NULL, 73, NULL, NULL, 218471),
(218472, '3.90.1660.10-FF-000003', NULL, 'Coenzyme F420:L-glutamate ligase', 72, NULL, NULL, 218472),
(218473, '1.25.40.10-FF-003984', NULL, 'Uncharacterized protein', 218, NULL, NULL, 218473),
(218474, '1.20.1250.20-FF-001791', NULL, 'Chromosome 19, whole genome shotgun sequence', 178, NULL, NULL, 218474),
(218475, '1.10.730.10-FF-000086', NULL, 'Leucine--tRNA ligase', 27, NULL, NULL, 218475),
(218476, '2.60.40.790-FF-000037', NULL, 'NudC domain-containing protein 2', 87, NULL, NULL, 218476),
(218477, '2.10.25.10-FF-000293', NULL, 'FAT atypical cadherin 4', 64, NULL, NULL, 218477),
(218478, '1.25.40.10-FF-002360', NULL, 'Pentatricopeptide repeat-containing protein', 114, NULL, NULL, 218478),
(218479, '2.60.40.1170-FF-000059', NULL, 'F-BAR domain only protein 1', 103, NULL, NULL, 218479),
(218480, '3.20.20.80-FF-000367', NULL, 'Putative secreted protein', 293, NULL, NULL, 218480),
(218481, '3.30.160.60-FF-002793', NULL, 'Zinc finger protein 574', 54, NULL, NULL, 218481),
(218482, '2.170.270.10-FF-000014', NULL, 'PR domain-containing protein 11', 164, NULL, NULL, 218482),
(218483, '3.40.50.300-FF-001731', NULL, 'Nitric oxide reductase NorQ protein', 169, NULL, NULL, 218483),
(218484, '3.30.559.30-FF-000113', NULL, 'Uncharacterized protein', 224, NULL, NULL, 218484),
(218485, '3.60.120.10-FF-000021', NULL, 'Isochorismate synthase family protein', 396, NULL, NULL, 218485),
(218486, '3.40.50.300-FF-002794', NULL, 'ABC Transporter family', 263, NULL, NULL, 218486),
(218487, '2.40.70.10-FF-000334', NULL, NULL, 168, NULL, NULL, 218487),
(218488, '3.30.460.10-FF-000159', NULL, 'Uncharacterized protein', 81, NULL, NULL, 218488),
(218489, '1.20.1070.10-FF-002145', NULL, 'Uncharacterized protein', 195, NULL, NULL, 218489),
(218490, '3.40.50.12780-FF-000212', NULL, 'Putative long-chain-fatty-acid-CoA ligase', 198, NULL, NULL, 218490),
(218491, '2.60.120.200-FF-000151', NULL, 'Laminin subunit alpha 5', 198, NULL, NULL, 218491),
(218492, '1.10.510.10-FF-004386', NULL, NULL, 92, NULL, NULL, 218492),
(218493, '1.20.1610.10-FF-000017', NULL, 'Chromosome 1, whole genome shotgun sequence', 173, NULL, NULL, 218493),
(218494, '2.70.40.10-FF-000022', NULL, 'Deoxyuridine 5''-triphosphate nucleotidohydrolase', 146, NULL, NULL, 218494),
(218495, '1.10.3380.30-FF-000007', NULL, 'DExH-box ATP-dependent RNA helicase DExH15 chloroplastic', 211, NULL, NULL, 218495);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(218496, '2.130.10.10-FF-002737', NULL, 'Predicted protein', 282, NULL, NULL, 218496),
(218497, '3.30.70.1350-FF-000007', NULL, 'Cation efflux system', 76, NULL, NULL, 218497),
(218498, '3.30.200.20-FF-001695', NULL, NULL, 65, NULL, NULL, 218498),
(218499, '2.130.10.10-FF-002557', NULL, 'Syntaxin binding protein 5', 89, NULL, NULL, 218499),
(218500, '3.90.76.10-FF-000022', NULL, 'Peptide ABC transporter substrate-binding protein', 142, NULL, NULL, 218500),
(218501, '1.20.1050.10-FF-000002', NULL, 'Stringent starvation protein A', 105, NULL, NULL, 218501),
(218502, '1.10.472.10-FF-000126', NULL, 'Cyclin domain protein', 163, NULL, NULL, 218502),
(218503, '3.30.200.20-FF-000059', NULL, 'S-receptor-like serine/threonine-protein kinase', 106, NULL, NULL, 218503),
(218504, '3.30.70.330-FF-001572', NULL, NULL, 116, NULL, NULL, 218504),
(218505, '3.90.660.20-FF-000018', NULL, 'Protoporphyrinogen oxidase', 179, NULL, NULL, 218505),
(218506, '3.30.1330.30-FF-000150', NULL, 'Protein pelota homolog', 91, NULL, NULL, 218506),
(218507, '2.30.30.40-FF-000184', NULL, 'Protein kinase activator Bem1', 81, NULL, NULL, 218507),
(218508, '1.20.1070.10-FF-001869', NULL, 'Uncharacterized protein', 346, NULL, NULL, 218508),
(218509, '3.30.200.20-FF-001352', NULL, 'Uncharacterized protein', 90, NULL, NULL, 218509),
(218510, '3.40.50.300-FF-000438', NULL, 'Rho-related GTP-binding protein RhoJ', 181, NULL, NULL, 218510),
(218511, '2.60.40.10-FF-000747', NULL, 'obscurin isoform X6', 102, NULL, NULL, 218511),
(218512, '3.40.50.1100-FF-000059', NULL, 'N-(2-amino-2-carboxyethyl)-L-glutamate synthase', 167, NULL, NULL, 218512),
(218513, '4.10.240.10-FF-000104', NULL, 'PrnA protein', 100, NULL, NULL, 218513),
(218514, '3.40.50.11460-FF-000002', NULL, NULL, 213, NULL, NULL, 218514),
(218515, '1.25.10.10-FF-002796', NULL, 'Uncharacterized protein', 156, NULL, NULL, 218515),
(218516, '3.20.20.70-FF-000089', NULL, 'Sulfofructosephosphate aldolase', 292, NULL, NULL, 218516),
(218517, '2.60.40.3210-FF-000014', NULL, 'Uncharacterized protein', 117, NULL, NULL, 218517),
(218518, '3.40.50.2060-FF-000021', NULL, NULL, 126, NULL, NULL, 218518),
(218519, '3.10.400.20-FF-000034', NULL, 'Uncharacterized protein', 199, NULL, NULL, 218519),
(218520, '1.25.40.10-FF-001628', NULL, 'Tetratricopeptide repeat protein 7B-like Protein', 212, NULL, NULL, 218520),
(218521, '1.20.1310.10-FF-000091', NULL, 'Cullin family protein', 108, NULL, NULL, 218521),
(218522, '2.160.20.70-FF-000045', NULL, 'Uncharacterized protein', 174, NULL, NULL, 218522),
(218523, '3.40.630.10-FF-000261', NULL, 'Uncharacterized protein', 349, NULL, NULL, 218523),
(218524, '1.10.1420.10-FF-000084', NULL, 'MutS protein homolog 4', 182, NULL, NULL, 218524),
(218525, '1.20.58.60-FF-000615', NULL, 'Uncharacterized protein', 312, NULL, NULL, 218525),
(218526, '2.60.40.3850-FF-000003', NULL, 'Uncharacterized protein', 76, NULL, NULL, 218526),
(218527, '1.25.10.10-FF-003072', NULL, 'Uncharacterized protein', 248, NULL, NULL, 218527),
(218528, '3.30.559.70-FF-000013', NULL, 'Carnitine Palmitoyl Transferase', 319, NULL, NULL, 218528),
(218529, '2.120.10.80-FF-000229', NULL, 'Predicted protein', 260, NULL, NULL, 218529),
(218530, '3.30.70.1070-FF-000013', NULL, 'General secretion pathway protein D', 86, NULL, NULL, 218530),
(218531, '3.40.720.10-FF-000088', NULL, 'Phosphatidylinositol glycan anchor biosynthesis, class N', 232, NULL, NULL, 218531),
(218532, '2.120.10.80-FF-000381', NULL, 'Uncharacterized protein', 135, NULL, NULL, 218532),
(218533, '3.10.100.10-FF-000036', NULL, 'Lymphocyte antigen 75', 162, NULL, NULL, 218533),
(218534, '1.10.287.370-FF-000062', NULL, 'AGAP007637-PA', 124, NULL, NULL, 218534),
(218535, '3.20.20.80-FF-000103', NULL, 'N-acetylmuramoyl-L-alanine amidase', 189, NULL, NULL, 218535),
(218536, '3.40.50.1110-FF-000040', NULL, 'Putative platelet activating factor', 211, NULL, NULL, 218536),
(218537, '1.10.630.10-FF-000730', NULL, 'Uncharacterized protein', 93, NULL, NULL, 218537),
(218538, '2.70.98.90-FF-000004', NULL, 'Membrane protein insertase YidC', 270, NULL, NULL, 218538);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(218539, '1.20.5.960-FF-000002', NULL, 'Baseplate wedge protein gp10', 28, NULL, NULL, 218539),
(218540, '3.20.20.140-FF-000349', NULL, 'Predicted protein', 318, NULL, NULL, 218540),
(218541, '1.20.120.960-FF-000001', NULL, 'Sensor protein', 103, NULL, NULL, 218541),
(218542, '1.10.357.20-FF-000024', NULL, 'Solute carrier, putative', 128, NULL, NULL, 218542),
(218543, '3.30.565.10-FF-000419', NULL, 'Heat shock protein 75 kDa, mitochondrial-like Protein', 233, NULL, NULL, 218543),
(218544, '2.90.10.10-FF-000036', NULL, 'Serine/threonine-protein kinase', 128, NULL, NULL, 218544),
(218545, '3.40.228.10-FF-000005', NULL, 'Anaerobic dimethyl sulfoxide reductase, subunit A', 74, NULL, NULL, 218545),
(218546, '1.25.40.20-FF-000772', NULL, 'Ankyrin repeats (3 copies), putative', 162, NULL, NULL, 218546),
(218547, '2.30.30.140-FF-000185', NULL, 'RING finger protein 17', 80, NULL, NULL, 218547),
(218548, '3.30.230.10-FF-000215', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 157, NULL, NULL, 218548),
(218549, '2.60.120.260-FF-000539', NULL, 'Uncharacterized protein', 76, NULL, NULL, 218549),
(218550, '3.40.50.1000-FF-000586', NULL, NULL, 152, NULL, NULL, 218550),
(218551, '2.40.160.120-FF-000004', NULL, 'Oxysterol-binding protein', 184, NULL, NULL, 218551),
(218552, '2.40.50.140-FF-000506', NULL, '26S proteasome ATPase subunit S4, putative', 69, NULL, NULL, 218552),
(218553, '2.10.25.10-FF-000854', NULL, 'C-type lectin domain family 18 member B', 64, NULL, NULL, 218553),
(218554, '3.40.190.290-FF-000122', NULL, 'Transcriptional regulator lysR family', 199, NULL, NULL, 218554),
(218555, '3.40.50.300-FF-001170', NULL, 'DNA replication helicase Dna2', 266, NULL, NULL, 218555),
(218556, '3.30.70.1230-FF-000084', NULL, 'Adenylate cyclase', 231, NULL, NULL, 218556),
(218557, '1.10.510.10-FF-003537', NULL, NULL, 236, NULL, NULL, 218557),
(218558, '1.25.40.530-FF-000015', NULL, 'Myosin 28B1, isoform B', 233, NULL, NULL, 218558),
(218559, '3.40.47.10-FF-000093', NULL, '3-hydroxy-3-methylglutaryl coenzyme A synthase', 452, NULL, NULL, 218559),
(218560, '3.80.10.10-FF-003693', NULL, 'Receptor-like protein 52', 175, NULL, NULL, 218560),
(218561, '3.40.50.300-FF-001995', NULL, 'Elongation factor G, mitochondrial', 291, NULL, NULL, 218561),
(218562, '1.25.40.10-FF-004422', NULL, 'Uncharacterized protein', 248, NULL, NULL, 218562),
(218563, '3.30.40.10-FF-000864', NULL, 'PHD transcription factor Rum1', 63, NULL, NULL, 218563),
(218564, '1.50.10.10-FF-000023', NULL, 'Protein-glucosylgalactosylhydroxylysine glucosidase', 342, NULL, NULL, 218564),
(218565, '2.30.30.100-FF-000021', NULL, 'U6 snRNA-associated Sm-like protein LSm1', 126, NULL, NULL, 218565),
(218566, '3.40.50.720-FF-002133', NULL, 'Uncharacterized protein', 104, NULL, NULL, 218566),
(218567, '2.30.30.40-FF-000245', NULL, 'N-acetylmuramoyl-l-alanine amidase', 106, NULL, NULL, 218567),
(218568, '1.20.1310.10-FF-000152', NULL, NULL, 117, NULL, NULL, 218568),
(218569, '3.40.50.300-FF-000377', NULL, 'transcriptional regulator ATRX isoform X1', 269, NULL, NULL, 218569),
(218570, '1.10.3460.10-FF-000002', NULL, 'Chlorophyll a-b binding protein, chloroplastic', 186, NULL, NULL, 218570),
(218571, '3.10.110.10-FF-000161', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 118, NULL, NULL, 218571),
(218572, '3.80.10.10-FF-003772', NULL, 'Uncharacterized protein', 108, NULL, NULL, 218572),
(218573, '2.60.40.10-FF-004327', NULL, NULL, 86, NULL, NULL, 218573),
(218574, '1.20.58.1100-FF-000014', NULL, 'Uncharacterized protein C11E3.02c', 141, NULL, NULL, 218574),
(218575, '1.25.10.10-FF-001891', NULL, 'U3 small nucleolar RNA-associated protein 10', 298, NULL, NULL, 218575),
(218576, '3.30.70.330-FF-003101', NULL, NULL, 91, NULL, NULL, 218576),
(218577, '1.10.268.10-FF-000016', NULL, 'Uncharacterized protein', 131, NULL, NULL, 218577),
(218578, '1.25.40.10-FF-002005', NULL, 'Pentatricopeptide repeat-containing protein At2g27610', 95, NULL, NULL, 218578),
(218579, '3.30.160.60-FF-000556', NULL, 'sal-like protein 2 isoform X2', 24, NULL, NULL, 218579);
INSERT INTO "PUBLIC"."MODEL" VALUES
(218580, '3.60.21.10-FF-000414', NULL, 'Uncharacterized protein', 285, NULL, NULL, 218580),
(218581, '3.30.160.60-FF-004827', NULL, NULL, 32, NULL, NULL, 218581),
(218582, '3.40.20.10-FF-000109', NULL, 'Scinderin like a', 121, NULL, NULL, 218582),
(218583, '1.25.40.10-FF-002972', NULL, 'Pentatricopeptide repeat-containing protein', 90, NULL, NULL, 218583),
(218584, '3.30.40.10-FF-000364', NULL, 'Protease-associated PA domain protein', 70, NULL, NULL, 218584),
(218585, '2.130.10.10-FF-003693', NULL, 'Uncharacterized protein', 134, NULL, NULL, 218585),
(218586, '2.30.30.40-FF-000189', NULL, 'BAR adaptor protein RVS167', 73, NULL, NULL, 218586),
(218587, '3.90.1140.10-FF-000031', NULL, 'U6 snRNA phosphodiesterase', 201, NULL, NULL, 218587),
(218588, '1.25.40.20-FF-001396', NULL, 'Uncharacterized protein', 45, NULL, NULL, 218588),
(218589, '3.30.160.60-FF-001124', NULL, 'Zinc finger protein 445', 26, NULL, NULL, 218589),
(218590, '2.10.220.10-FF-000026', NULL, 'Fraser extracellular matrix complex subunit 1', 97, NULL, NULL, 218590),
(218591, '2.40.70.10-FF-000103', NULL, 'Aspartyl protease family', 163, NULL, NULL, 218591),
(218592, '1.10.418.10-FF-000248', NULL, 'Coiled-coil domain-containing 88Aa', 102, NULL, NULL, 218592),
(218593, '1.10.287.100-FF-000003', NULL, 'Hypothetical alanine and leucine rich protein', 43, NULL, NULL, 218593),
(218594, '1.10.1740.10-FF-000035', NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', 85, NULL, NULL, 218594),
(218595, '2.30.30.40-FF-000301', NULL, 'SH3 domain-containing protein', 64, NULL, NULL, 218595),
(218596, '2.40.50.140-FF-000681', NULL, NULL, 81, NULL, NULL, 218596),
(218597, '1.10.10.10-FF-000199', NULL, 'DNA-directed RNA polymerase III subunit RPC3', 90, NULL, NULL, 218597),
(218598, '1.20.58.2200-FF-000001', NULL, 'Motility protein FimV', 62, NULL, NULL, 218598),
(218599, '1.10.150.80-FF-000045', NULL, 'Predicted protein', 108, NULL, NULL, 218599),
(218600, '1.25.40.10-FF-003484', NULL, 'Pentatricopeptide repeat-containing protein', 88, NULL, NULL, 218600),
(218601, '3.40.50.200-FF-000173', NULL, 'Uncharacterized protein', 411, NULL, NULL, 218601),
(218602, '3.30.540.10-FF-000048', NULL, 'WGS project CABT00000000 data, contig 2.15', 232, NULL, NULL, 218602),
(218603, '1.25.40.20-FF-000940', NULL, 'Uncharacterized protein', 142, NULL, NULL, 218603),
(218604, '1.10.10.10-FF-000204', NULL, 'Apoptotic protease-activating factor 1', 74, NULL, NULL, 218604),
(218605, '3.40.50.300-FF-006902', NULL, 'ABC transporter related', 239, NULL, NULL, 218605),
(218606, '3.30.70.1820-FF-000019', NULL, NULL, 54, NULL, NULL, 218606),
(218607, '1.10.1420.10-FF-000140', NULL, 'DNA mismatch repair protein', 218, NULL, NULL, 218607),
(218608, '2.60.40.10-FF-000112', NULL, 'Titin a', 99, NULL, NULL, 218608),
(218609, '3.30.2230.10-FF-000018', NULL, 'Uncharacterized protein', 143, NULL, NULL, 218609),
(218610, '4.10.860.120-FF-000022', NULL, 'DNA-directed RNA polymerase subunit', 124, NULL, NULL, 218610),
(218611, '2.160.20.10-FF-000230', NULL, 'Predicted protein', 242, NULL, NULL, 218611),
(218612, '1.10.10.10-FF-000311', NULL, 'DNA-binding response regulator', 102, NULL, NULL, 218612),
(218613, '3.40.850.10-FF-000541', NULL, 'Uncharacterized protein', 288, NULL, NULL, 218613),
(218614, '1.20.1310.10-FF-000096', NULL, 'Cullin family protein', 112, NULL, NULL, 218614),
(218615, '1.10.472.10-FF-000446', NULL, 'AaceriADR384Wp', 117, NULL, NULL, 218615),
(218616, '2.60.120.1000-FF-000020', NULL, 'Uncharacterized protein', 105, NULL, NULL, 218616),
(218617, '3.40.50.410-FF-000011', NULL, 'Protein transport protein SEC23', 255, NULL, NULL, 218617),
(218618, '2.130.10.10-FF-002214', NULL, 'Predicted protein', 151, NULL, NULL, 218618),
(218619, '3.40.50.720-FF-001621', NULL, 'NAD-dependent malic enzyme 2, mitochondrial', 83, NULL, NULL, 218619),
(218620, '1.10.10.60-FF-000753', NULL, NULL, 51, NULL, NULL, 218620),
(218621, '1.20.920.30-FF-000031', NULL, 'Dynein heavy chain family protein', 182, NULL, NULL, 218621),
(218622, '3.20.20.60-FF-000092', NULL, 'Pyruvate kinase', 234, NULL, NULL, 218622); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(218623, '3.30.1640.10-FF-000038', NULL, 'Cell division control protein 21', 101, NULL, NULL, 218623),
(218624, '2.60.120.200-FF-000331', NULL, 'FAT atypical cadherin 2', 162, NULL, NULL, 218624),
(218625, '3.30.160.60-FF-006340', NULL, NULL, 61, NULL, NULL, 218625),
(218626, '1.10.510.10-FF-000440', NULL, 'Serine/threonine-protein kinase bur1', 248, NULL, NULL, 218626),
(218627, '3.30.70.1440-FF-000001', NULL, 'Multidrug efflux pump subunit AcrB', 103, NULL, NULL, 218627),
(218628, '2.60.40.10-FF-004434', NULL, NULL, 89, NULL, NULL, 218628),
(218629, '2.60.40.820-FF-000024', NULL, 'T BoX family', 192, NULL, NULL, 218629),
(218630, '2.40.10.10-FF-000622', NULL, NULL, 247, NULL, NULL, 218630),
(218631, '2.60.40.10-FF-004378', NULL, NULL, 103, NULL, NULL, 218631),
(218632, '1.20.272.40-FF-000016', NULL, 'Uncharacterized protein', 78, NULL, NULL, 218632),
(218633, '3.40.50.10140-FF-000089', NULL, 'Predicted protein', 111, NULL, NULL, 218633),
(218634, '1.10.760.10-FF-000099', NULL, 'Cytochrome c2', 105, NULL, NULL, 218634),
(218635, '2.60.40.3430-FF-000001', NULL, 'protocadherin-15 isoform X1', 115, NULL, NULL, 218635),
(218636, '1.10.630.10-FF-000494', NULL, 'Uncharacterized protein', 462, NULL, NULL, 218636),
(218637, '3.30.70.100-FF-000183', NULL, NULL, 101, NULL, NULL, 218637),
(218638, '3.40.50.200-FF-000122', NULL, 'Glr3087 protein', 250, NULL, NULL, 218638),
(218639, '1.20.58.60-FF-000115', NULL, 'nesprin-2 isoform X2', 142, NULL, NULL, 218639),
(218640, '1.10.472.10-FF-000502', NULL, 'Uncharacterized protein', 105, NULL, NULL, 218640),
(218641, '3.80.10.10-FF-003709', NULL, 'Os08g0446400 protein', 156, NULL, NULL, 218641),
(218642, '1.25.40.20-FF-000884', NULL, 'Zgc:77223 protein', 207, NULL, NULL, 218642),
(218643, '3.40.50.10810-FF-000217', NULL, 'Uncharacterized protein', 79, NULL, NULL, 218643),
(218644, '3.30.160.60-FF-005339', NULL, NULL, 29, NULL, NULL, 218644),
(218645, '3.30.70.330-FF-000246', NULL, 'TATA-binding protein-associated factor 2N isoform X1', 138, NULL, NULL, 218645),
(218646, '3.30.505.10-FF-000062', NULL, 'SH2 domain-containing protein 1A', 103, NULL, NULL, 218646),
(218647, '1.10.560.10-FF-000151', NULL, 'T-complex protein 1 subunit gamma', 156, NULL, NULL, 218647),
(218648, '3.40.50.1980-FF-000008', NULL, 'Ferrichrome ABC transporter substrate-binding protein', 120, NULL, NULL, 218648),
(218649, '3.40.850.10-FF-000485', NULL, 'Uncharacterized protein', 85, NULL, NULL, 218649),
(218650, '3.40.50.300-FF-005109', NULL, 'Energy-coupling factor transporter ATP-binding protein EcfA1', 259, NULL, NULL, 218650),
(218651, '4.10.400.10-FF-000218', NULL, 'low-density lipoprotein receptor-related protein 2 isoform X5', 35, NULL, NULL, 218651),
(218652, '3.30.1360.120-FF-000016', NULL, 'Aminomethyltransferase', 51, NULL, NULL, 218652),
(218653, '1.20.1070.10-FF-001920', NULL, 'Uncharacterized protein', 282, NULL, NULL, 218653),
(218654, '3.30.60.190-FF-000005', NULL, 'Putative HIT finger domain protein', 51, NULL, NULL, 218654),
(218655, '1.20.58.2220-FF-000007', NULL, 'formin-2', 406, NULL, NULL, 218655),
(218656, '1.10.287.1490-FF-000084', NULL, 'Putative adaptor for phosphoinositide 3-kinase', 153, NULL, NULL, 218656),
(218657, '3.40.50.150-FF-001697', NULL, NULL, 84, NULL, NULL, 218657),
(218658, '2.60.40.10-FF-000163', NULL, 'peroxidasin homolog', 92, NULL, NULL, 218658),
(218659, '3.40.50.2300-FF-001274', NULL, NULL, 182, NULL, NULL, 218659),
(218660, '1.20.58.940-FF-000001', NULL, 'COPII coat assembly protein SEC16', 70, NULL, NULL, 218660),
(218661, '1.10.10.10-FF-000255', NULL, '40S ribosomal protein S19', 144, NULL, NULL, 218661),
(218662, '1.20.1070.10-FF-001813', NULL, 'Predicted protein', 312, NULL, NULL, 218662),
(218663, '3.40.50.1000-FF-000243', NULL, 'Glycerol-3-phosphate 2-O-acyltransferase 6', 105, NULL, NULL, 218663),
(218664, '3.70.10.10-FF-000017', NULL, 'DNA damage checkpoint control protein RAD17', 273, NULL, NULL, 218664),
(218665, '3.40.50.880-FF-000062', NULL, 'ES1 protein, mitochondrial', 238, NULL, NULL, 218665),
(218666, '1.10.287.950-FF-000039', NULL, 'Sensory rhodopsin II transducer', 300, NULL, NULL, 218666);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(218667, '3.90.1300.10-FF-000033', NULL, 'Uncharacterized protein', 347, NULL, NULL, 218667),
(218668, '2.130.10.10-FF-001276', NULL, 'U3 small nucleolar RNA-associated protein 13,putative', 224, NULL, NULL, 218668),
(218669, '2.40.10.120-FF-000026', NULL, 'Cfb protein', 170, NULL, NULL, 218669),
(218670, '3.30.420.40-FF-000048', NULL, 'ARP5 actin-related protein 5 homolog', 67, NULL, NULL, 218670),
(218671, '2.60.40.60-FF-000661', NULL, 'Cadherin 16', 104, NULL, NULL, 218671),
(218672, '2.60.120.290-FF-000138', NULL, 'GD12774', 117, NULL, NULL, 218672),
(218673, '1.20.120.1750-FF-000110', NULL, 'RBR-type E3 ubiquitin transferase', 84, NULL, NULL, 218673),
(218674, '1.50.40.10-FF-000486', NULL, 'Predicted protein', 277, NULL, NULL, 218674),
(218675, '3.40.50.150-FF-000404', NULL, 'Ribosomal RNA small subunit methyltransferase H', 174, NULL, NULL, 218675),
(218676, '3.90.1750.20-FF-000007', NULL, 'Site-specific recombinase', 142, NULL, NULL, 218676),
(218677, '1.10.287.630-FF-000005', NULL, 'cyclic nucleotide-gated cation channel alpha-4', 61, NULL, NULL, 218677),
(218678, '2.60.40.60-FF-000773', NULL, 'Uncharacterized protein', 111, NULL, NULL, 218678),
(218679, '3.40.50.300-FF-005946', NULL, 'Putative deah-box rna helicase', 161, NULL, NULL, 218679),
(218680, '2.120.10.10-FF-000012', NULL, 'Sialidase [Precursor]', 328, NULL, NULL, 218680),
(218681, '3.90.70.80-FF-000058', NULL, 'YALI0F01540p', 165, NULL, NULL, 218681),
(218682, '2.130.10.10-FF-000764', NULL, 'Eukaryotic translation initiation factor 3 subunit B', 211, NULL, NULL, 218682),
(218683, '3.90.550.10-FF-000479', NULL, 'Molybdenum cofactor guanylyltransferase', 206, NULL, NULL, 218683),
(218684, '3.40.1370.10-FF-000048', NULL, '60S ribosomal protein L4', 77, NULL, NULL, 218684),
(218685, '1.20.120.1760-FF-000051', NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', 192, NULL, NULL, 218685),
(218686, '3.40.710.10-FF-000087', NULL, 'Penicillin-binding protein', 332, NULL, NULL, 218686),
(218687, '1.10.30.50-FF-000015', NULL, 'HNH endonuclease domain-containing protein', 90, NULL, NULL, 218687),
(218688, '3.80.10.10-FF-000787', NULL, 'Extracellular matrix protein 2, female organ and adipocyte-specific', 142, NULL, NULL, 218688),
(218689, '3.90.1420.10-FF-000013', NULL, 'Ribosomal lysine N-methyltransferase 4', 152, NULL, NULL, 218689),
(218690, '1.20.58.1780-FF-000010', NULL, 'Nuclear pore complex protein Nup155', 344, NULL, NULL, 218690),
(218691, '1.10.150.20-FF-000185', NULL, 'DNA repair endonuclease XPF', 73, NULL, NULL, 218691),
(218692, '1.25.40.10-FF-003309', NULL, 'Uncharacterized protein', 198, NULL, NULL, 218692),
(218693, '1.25.10.10-FF-001739', NULL, 'Tbcd-1', 180, NULL, NULL, 218693),
(218694, '2.130.10.10-FF-005547', NULL, 'Uncharacterized protein', 223, NULL, NULL, 218694),
(218695, '1.20.1110.10-FF-000092', NULL, 'Calcium-transporting ATPase, putative', 264, NULL, NULL, 218695),
(218696, '1.10.132.10-FF-000016', NULL, NULL, 84, NULL, NULL, 218696),
(218697, '1.20.120.80-FF-000007', NULL, 'Cytochrome c oxidase subunit 3', 194, NULL, NULL, 218697),
(218698, '3.40.630.30-FF-000660', NULL, 'Predicted protein', 154, NULL, NULL, 218698),
(218699, '3.30.460.10-FF-000047', NULL, 'Ribosomal silencing factor RsfS', 117, NULL, NULL, 218699),
(218700, '3.10.28.10-FF-000033', NULL, 'Probable intron-encoded endonuclease aI2', 128, NULL, NULL, 218700),
(218701, '1.10.510.10-FF-001856', NULL, 'Outer arm dynein light chain 1', 88, NULL, NULL, 218701),
(218702, '3.40.50.2300-FF-001330', NULL, NULL, 80, NULL, NULL, 218702),
(218703, '2.130.10.10-FF-005143', NULL, 'Vacuolar protein sorting-associated protein 41', 212, NULL, NULL, 218703),
(218704, '3.30.450.20-FF-000555', NULL, 'Alkaline phosphatase synthesis sensor protein PhoR', 114, NULL, NULL, 218704),
(218705, '3.30.450.30-FF-000092', NULL, 'Profilin', 130, NULL, NULL, 218705),
(218706, '1.20.1250.20-FF-000386', NULL, 'MFS general substrate transporter', 197, NULL, NULL, 218706),
(218707, '1.10.510.10-FF-002256', NULL, NULL, 172, NULL, NULL, 218707),
(218708, '1.10.510.10-FF-001795', NULL, 'Serine/threonine-protein kinase Nek1', 301, NULL, NULL, 218708);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(218709, '2.130.10.10-FF-000820', NULL, 'Uncharacterized protein', 268, NULL, NULL, 218709),
(218710, '4.10.1000.10-FF-000033', NULL, 'zinc finger CCCH domain-containing protein 37', 97, NULL, NULL, 218710),
(218711, '1.10.510.10-FF-001744', NULL, 'Uncharacterized protein', 237, NULL, NULL, 218711),
(218712, '1.10.1900.10-FF-000014', NULL, 'Polyadenylate-binding protein', 67, NULL, NULL, 218712),
(218713, '3.40.50.1240-FF-000135', NULL, 'Uncharacterized protein', 385, NULL, NULL, 218713),
(218714, '1.10.3720.10-FF-000040', NULL, 'Putrescine ABC transporter, permease protein PotI', 261, NULL, NULL, 218714),
(218715, '3.30.420.10-FF-000101', NULL, 'Uncharacterized protein', 150, NULL, NULL, 218715),
(218716, '3.40.50.150-FF-000348', NULL, 'S-adenosyl-methionine-sterol-C-methyltransferas (AFU_orthologue AFUA_4G09190)', 222, NULL, NULL, 218716),
(218717, '3.30.420.40-FF-000593', NULL, 'DnaK protein', 138, NULL, NULL, 218717),
(218718, '1.10.472.80-FF-000158', NULL, NULL, 124, NULL, NULL, 218718),
(218719, '3.30.160.60-FF-002973', NULL, NULL, 35, NULL, NULL, 218719),
(218720, '3.10.100.10-FF-000328', NULL, NULL, 115, NULL, NULL, 218720),
(218721, '2.30.230.10-FF-000040', NULL, 'Uncharacterized protein', 103, NULL, NULL, 218721),
(218722, '3.50.30.30-FF-000071', NULL, 'Uncharacterized protein', 107, NULL, NULL, 218722),
(218723, '2.170.270.10-FF-000037', NULL, 'Histone-lysine N-methyltransferase', 251, NULL, NULL, 218723),
(218724, '3.40.50.300-FF-000326', NULL, 'P-loop containing nucleoside triphosphate hydrolase', 207, NULL, NULL, 218724),
(218725, '3.30.50.10-FF-000134', NULL, 'Uncharacterized protein', 69, NULL, NULL, 218725),
(218726, '3.40.50.300-FF-005997', NULL, 'ATP-dependent Clp protease ATP-binding subunit clpX', 42, NULL, NULL, 218726),
(218727, '3.40.50.1000-FF-000355', NULL, 'Phospholipid-transporting ATPase', 168, NULL, NULL, 218727),
(218728, '3.40.1260.10-FF-000001', NULL, 'Sulfurtransferase TusD', 128, NULL, NULL, 218728),
(218729, '1.10.287.70-FF-000258', NULL, 'TWiK family of potassium channels', 330, NULL, NULL, 218729),
(218730, '2.60.40.10-FF-001528', NULL, 'Tyrosine-protein phosphatase 99A', 103, NULL, NULL, 218730),
(218731, '1.10.287.1490-FF-000140', NULL, 'Structural maintenance of chromosomes protein 6A', 178, NULL, NULL, 218731),
(218732, '1.20.1070.10-FF-001864', NULL, 'Gonadotropin-releasing hormone receptor 2; Uncharacterized protein', 374, NULL, NULL, 218732),
(218733, '3.10.250.10-FF-000103', NULL, NULL, 113, NULL, NULL, 218733),
(218734, '2.60.120.200-FF-000679', NULL, 'Calnexin homolog-related protein', 37, NULL, NULL, 218734),
(218735, '1.50.40.10-FF-000435', NULL, 'Predicted protein', 170, NULL, NULL, 218735),
(218736, '2.30.42.10-FF-000152', NULL, 'disks large homolog 5 isoform X1', 114, NULL, NULL, 218736),
(218737, '3.30.63.10-FF-000001', NULL, 'Disks large homolog 1 isoform 2', 61, NULL, NULL, 218737),
(218738, '3.10.100.10-FF-000391', NULL, NULL, 123, NULL, NULL, 218738),
(218739, '3.70.10.10-FF-000068', NULL, 'Checkpoint protein', 330, NULL, NULL, 218739),
(218740, '1.25.10.10-FF-002352', NULL, 'Uncharacterized protein', 285, NULL, NULL, 218740),
(218741, '1.10.405.10-FF-000033', NULL, 'Amine oxidase', 99, NULL, NULL, 218741),
(218742, '2.170.270.10-FF-000088', NULL, 'Predicted protein', 141, NULL, NULL, 218742),
(218743, '3.40.50.300-FF-006161', NULL, 'ABC transporter ATP-binding protein', 119, NULL, NULL, 218743),
(218744, '3.30.2410.10-FF-000055', NULL, 'Uncharacterized protein', 127, NULL, NULL, 218744),
(218745, '1.20.58.390-FF-000139', NULL, 'AcetylCholine Receptor', 119, NULL, NULL, 218745),
(218746, '3.40.50.410-FF-000359', NULL, 'Protein transport protein SEC23', 66, NULL, NULL, 218746),
(218747, '3.90.70.80-FF-000007', NULL, 'OTU domain-containing protein', 159, NULL, NULL, 218747),
(218748, '2.40.10.10-FF-000566', NULL, NULL, 68, NULL, NULL, 218748),
(218749, '1.10.150.780-FF-000011', NULL, 'Probable vacuolar protein sorting-associated protein 16 homolog', 99, NULL, NULL, 218749),
(218750, '3.40.366.10-FF-000005', NULL, 'Fatty acid synthase', 299, NULL, NULL, 218750);
INSERT INTO "PUBLIC"."MODEL" VALUES
(218751, '1.10.3720.10-FF-000096', NULL, 'Peptide ABC transporter, permease protein', 228, NULL, NULL, 218751),
(218752, '1.20.120.1780-FF-000001', NULL, '4-hydroxybenzoate octaprenyltransferase', 122, NULL, NULL, 218752),
(218753, '3.40.50.300-FF-003311', NULL, 'Glycolipid sulfotransferase BCG_1434', 304, NULL, NULL, 218753),
(218754, '3.40.50.300-FF-002687', NULL, 'Helicase, putative', 268, NULL, NULL, 218754),
(218755, '3.90.950.20-FF-000001', NULL, 'Competence/damage-inducible domain protein CinA', 161, NULL, NULL, 218755),
(218756, '3.30.70.330-FF-000291', NULL, 'CC1-like family splicing factor', 86, NULL, NULL, 218756),
(218757, '3.30.420.10-FF-000157', NULL, 'Cell death-related nuclease 4', 202, NULL, NULL, 218757),
(218758, '2.60.40.150-FF-000655', NULL, 'Copine Va', 108, NULL, NULL, 218758),
(218759, '3.40.5.10-FF-000013', NULL, 'Mitochondrial Ribosomal Protein, Large', 59, NULL, NULL, 218759),
(218760, '1.25.10.10-FF-000727', NULL, 'Putative HEAT repeat-containing protein 5A', 266, NULL, NULL, 218760),
(218761, '3.30.60.30-FF-000062', NULL, 'Serine protease inhibitor dipetalogastin', 60, NULL, NULL, 218761),
(218762, '3.30.160.60-FF-000612', NULL, 'Zinc finger matrin-type protein 3', 49, NULL, NULL, 218762),
(218763, '1.20.58.60-FF-000166', NULL, 'Spectrin alpha chain non-erythrocytic 1', 211, NULL, NULL, 218763),
(218764, '2.60.40.10-FF-000168', NULL, 'filamin-C isoform X2', 97, NULL, NULL, 218764),
(218765, '1.10.10.60-FF-001265', NULL, NULL, 93, NULL, NULL, 218765),
(218766, '2.10.25.10-FF-001574', NULL, 'Uncharacterized protein', 37, NULL, NULL, 218766),
(218767, '2.160.20.10-FF-000281', NULL, 'Uncharacterized protein', 199, NULL, NULL, 218767),
(218768, '2.120.10.30-FF-000563', NULL, 'Adipocyte plasma membrane-associated protein, putative', 67, NULL, NULL, 218768),
(218769, '3.80.10.10-FF-001911', NULL, 'TOLL-like receptor 9', 268, NULL, NULL, 218769),
(218770, '3.20.20.80-FF-000210', NULL, 'Putative hydrolase', 183, NULL, NULL, 218770),
(218771, '1.10.1060.10-FF-000005', NULL, 'Succinate dehydrogenase iron-sulfur subunit', 136, NULL, NULL, 218771),
(218772, '3.10.20.90-FF-000680', NULL, 'Protein CBG08550', 67, NULL, NULL, 218772),
(218773, '1.25.40.10-FF-000499', NULL, 'sorting nexin-21 isoform X1', 112, NULL, NULL, 218773),
(218774, '3.40.33.10-FF-000139', NULL, 'Uncharacterized protein', 154, NULL, NULL, 218774),
(218775, '3.10.620.30-FF-000014', NULL, 'DNA repair protein Rad4 family protein', 107, NULL, NULL, 218775),
(218776, '3.30.70.330-FF-001651', NULL, NULL, 93, NULL, NULL, 218776),
(218777, '1.20.1420.30-FF-000020', NULL, 'Vacuolar cation/proton exchanger', 146, NULL, NULL, 218777),
(218778, '3.30.470.20-FF-000202', NULL, 'Uncharacterized protein', 81, NULL, NULL, 218778),
(218779, '3.40.50.10860-FF-000030', NULL, 'Quinate 5-dehydrogenase QutB', 128, NULL, NULL, 218779),
(218780, '2.30.30.1150-FF-000021', NULL, 'Uncharacterized protein', 171, NULL, NULL, 218780),
(218781, '1.20.272.10-FF-000069', NULL, NULL, 112, NULL, NULL, 218781),
(218782, '1.20.1270.60-FF-000146', NULL, 'Glucosamine 6-phosphate N-acetyltransferase', 151, NULL, NULL, 218782),
(218783, '3.40.50.1000-FF-000304', NULL, 'Phosphatase MT3486', 206, NULL, NULL, 218783),
(218784, '3.40.50.300-FF-006958', NULL, 'Uncharacterized protein', 222, NULL, NULL, 218784),
(218785, '3.40.630.10-FF-000502', NULL, 'Uncharacterized protein', 272, NULL, NULL, 218785),
(218786, '3.40.50.300-FF-007526', NULL, 'Uncharacterized protein', 209, NULL, NULL, 218786),
(218787, '2.60.40.1510-FF-000032', NULL, 'Integrin beta', 107, NULL, NULL, 218787),
(218788, '3.40.50.2020-FF-000037', NULL, 'Phosphoribosylpyrophosphate synthetase', 149, NULL, NULL, 218788),
(218789, '3.40.50.720-FF-002245', NULL, 'Dihydropteridine reductase, putative', 81, NULL, NULL, 218789),
(218790, '1.25.40.10-FF-002860', NULL, 'Pentatricopeptide repeat-containing protein', 95, NULL, NULL, 218790),
(218791, '1.20.58.60-FF-000110', NULL, 'Short stop, isoform AA', 289, NULL, NULL, 218791),
(218792, '1.20.1250.10-FF-000001', NULL, 'Interferon alpha', 170, NULL, NULL, 218792);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(218793, '3.30.200.20-FF-001852', NULL, 'Uncharacterized protein', 52, NULL, NULL, 218793),
(218794, '3.30.760.10-FF-000087', NULL, 'Uncharacterized protein', 133, NULL, NULL, 218794),
(218795, '3.40.630.10-FF-000446', NULL, 'Uncharacterized protein', 180, NULL, NULL, 218795),
(218796, '3.40.50.720-FF-001969', NULL, 'Predicted protein', 254, NULL, NULL, 218796),
(218797, '1.10.510.10-FF-002812', NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', 297, NULL, NULL, 218797),
(218798, '3.80.10.10-FF-001804', NULL, 'Leucine-rich repeat containing protein', 95, NULL, NULL, 218798),
(218799, '3.40.366.10-FF-000056', NULL, 'Malonyl CoA-acyl carrier protein transacylase', 210, NULL, NULL, 218799),
(218800, '3.30.420.10-FF-000106', NULL, 'Fusilli, isoform G', 208, NULL, NULL, 218800),
(218801, '1.10.150.130-FF-000013', NULL, 'Putative integrase KpLE2 phage-like element', 111, NULL, NULL, 218801),
(218802, '3.80.10.10-FF-001855', NULL, 'Lap1, isoform B', 232, NULL, NULL, 218802),
(218803, '2.130.10.10-FF-001832', NULL, 'Putative WD-repeat family protein', 131, NULL, NULL, 218803),
(218804, '3.80.10.10-FF-004210', NULL, 'Probable inactive serine/threonine-protein kinase DDB_G0278909', 88, NULL, NULL, 218804),
(218805, '1.10.540.10-FF-000116', NULL, 'Acyl-coenzyme A oxidase', 141, NULL, NULL, 218805),
(218806, '1.20.1250.20-FF-001616', NULL, 'MFS multidrug transporter, putative (AFU_orthologue AFUA_1G05010)', 162, NULL, NULL, 218806),
(218807, '2.60.40.10-FF-002017', NULL, 'Uncharacterized protein', 94, NULL, NULL, 218807),
(218808, '3.30.40.230-FF-000002', NULL, 'Glycyl-tRNA synthetase 1', 92, NULL, NULL, 218808),
(218809, '3.40.1360.10-FF-000042', NULL, 'Type IIB DNA topoisomerase, putative', 212, NULL, NULL, 218809),
(218810, '2.40.70.10-FF-000177', NULL, 'Protein CBG08575', 42, NULL, NULL, 218810),
(218811, '1.25.10.10-FF-000379', NULL, 'MMS19 nucleotide excision repair protein homolog isoform X2', 601, NULL, NULL, 218811),
(218812, '1.25.40.10-FF-001567', NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', 84, NULL, NULL, 218812),
(218813, '1.50.40.10-FF-000379', NULL, 'Mitochondrial carrier', 107, NULL, NULL, 218813),
(218814, '1.10.506.10-FF-000060', NULL, 'Uncharacterized protein', 45, NULL, NULL, 218814),
(218815, '3.90.700.10-FF-000013', NULL, 'Succinate dehydrogenase [ubiquinone] flavoprotein subunit 1 mitochondrial', 64, NULL, NULL, 218815),
(218816, '2.130.10.10-FF-002237', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit wuho', 236, NULL, NULL, 218816),
(218817, '1.10.260.60-FF-000008', NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', 45, NULL, NULL, 218817),
(218818, '2.130.10.10-FF-004131', NULL, 'Uncharacterized protein', 184, NULL, NULL, 218818),
(218819, '3.40.1190.10-FF-000006', NULL, 'UDP-N-acetylmuramoyl-L-alanyl-D-glutamate--2,6-diaminopimelate ligase', 237, NULL, NULL, 218819),
(218820, '3.40.50.1000-FF-000299', NULL, 'Cation-transporting ATPase', 180, NULL, NULL, 218820),
(218821, '1.20.58.2010-FF-000006', NULL, 'Rop guanine nucleotide exchange factor 9', 115, NULL, NULL, 218821),
(218822, '2.60.40.10-FF-002080', NULL, 'Titin homolog', 104, NULL, NULL, 218822),
(218823, '2.160.20.10-FF-000286', NULL, 'Uncharacterized protein', 165, NULL, NULL, 218823),
(218824, '3.70.10.10-FF-000124', NULL, 'Uncharacterized protein', 115, NULL, NULL, 218824),
(218825, '3.30.70.330-FF-002612', NULL, NULL, 130, NULL, NULL, 218825),
(218826, '1.10.3660.10-FF-000001', NULL, 'T-protein', 126, NULL, NULL, 218826),
(218827, '1.20.1070.10-FF-001009', NULL, 'Uncharacterized protein', 187, NULL, NULL, 218827),
(218828, '3.30.70.330-FF-002988', NULL, NULL, 87, NULL, NULL, 218828),
(218829, '3.40.50.10330-FF-000051', NULL, 'Diacylglycerol kinase', 135, NULL, NULL, 218829),
(218830, '1.10.10.10-FF-001559', NULL, 'Pre-mRNA splicing helicase', 73, NULL, NULL, 218830),
(218831, '3.40.50.300-FF-002294', NULL, 'Elongation factor G (EF-G)', 279, NULL, NULL, 218831),
(218832, '3.90.226.10-FF-000321', NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', 355, NULL, NULL, 218832);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(218833, '3.30.160.60-FF-004035', NULL, NULL, 28, NULL, NULL, 218833),
(218834, '1.10.418.10-FF-000225', NULL, 'Uncharacterized protein', 109, NULL, NULL, 218834),
(218835, '2.60.210.10-FF-000003', NULL, 'Speckle-type POZ protein-like a', 138, NULL, NULL, 218835),
(218836, '3.40.50.261-FF-000034', NULL, 'Uncharacterized protein', 116, NULL, NULL, 218836),
(218837, '3.40.50.12470-FF-000018', NULL, NULL, 42, NULL, NULL, 218837),
(218838, '3.90.830.10-FF-000017', NULL, 'Putative syntaxin binding protein 1', 126, NULL, NULL, 218838),
(218839, '2.10.109.10-FF-000015', NULL, 'Mitochondrial inner membrane protease subunit 1', 139, NULL, NULL, 218839),
(218840, '2.60.40.1210-FF-000004', NULL, 'Cellobiose dehydrogenase', 204, NULL, NULL, 218840),
(218841, '2.90.10.10-FF-000013', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase LECRK1', 126, NULL, NULL, 218841),
(218842, '3.30.2350.10-FF-000016', NULL, 'Pseudouridine synthase', 218, NULL, NULL, 218842),
(218843, '3.30.720.220-FF-000001', NULL, 'Jumping translocation breakpoint', 54, NULL, NULL, 218843),
(218844, '3.40.1110.10-FF-000226', NULL, 'Cation transporting ATPase', 90, NULL, NULL, 218844),
(218845, '3.90.226.10-FF-000214', NULL, 'Predicted protein', 130, NULL, NULL, 218845),
(218846, '1.10.287.40-FF-000030', NULL, 'Uncharacterized protein', 109, NULL, NULL, 218846),
(218847, '3.40.640.10-FF-000323', NULL, 'Transcriptional regulatory protein', 206, NULL, NULL, 218847),
(218848, '3.30.230.80-FF-000034', NULL, 'LD43460p', 110, NULL, NULL, 218848),
(218849, '3.30.460.10-FF-000098', NULL, 'Uncharacterized protein', 194, NULL, NULL, 218849),
(218850, '2.60.40.10-FF-003945', NULL, NULL, 105, NULL, NULL, 218850),
(218851, '1.25.40.10-FF-005226', NULL, 'Uncharacterized protein', 187, NULL, NULL, 218851),
(218852, '1.10.260.40-FF-000053', NULL, 'Transcriptional regulator', 81, NULL, NULL, 218852),
(218853, '2.130.10.10-FF-004182', NULL, 'Uncharacterized protein', 163, NULL, NULL, 218853),
(218854, '3.40.367.20-FF-000033', NULL, 'Phosphotransferase', 193, NULL, NULL, 218854),
(218855, '1.25.50.20-FF-000098', NULL, 'Aminopeptidase A, putative', 196, NULL, NULL, 218855),
(218856, '3.30.565.10-FF-000307', NULL, 'Signal-transducing histidine kinase', 142, NULL, NULL, 218856),
(218857, '1.25.40.10-FF-000611', NULL, 'TPR repeat protein', 167, NULL, NULL, 218857),
(218858, '1.25.40.10-FF-001516', NULL, 'Tetratricopeptide repeat-like superfamily protein', 117, NULL, NULL, 218858),
(218859, '3.30.428.10-FF-000006', NULL, 'm7GpppX diphosphatase', 190, NULL, NULL, 218859),
(218860, '3.40.50.2000-FF-000341', NULL, 'Glycogen phosphorylase', 168, NULL, NULL, 218860),
(218861, '1.20.1050.130-FF-000030', NULL, 'Glutathione S-transferase 1', 204, NULL, NULL, 218861),
(218862, '1.50.10.20-FF-000088', NULL, 'Terpene cyclase/mutase family member', 87, NULL, NULL, 218862),
(218863, '3.30.810.10-FF-000024', NULL, 'Uncharacterized protein', 206, NULL, NULL, 218863),
(218864, '2.60.40.10-FF-002585', NULL, 'FiLamiN (Actin binding protein) homolog', 103, NULL, NULL, 218864),
(218865, '1.10.10.2660-FF-000029', NULL, 'Uncharacterized protein', 69, NULL, NULL, 218865),
(218866, '2.40.10.10-FF-000561', NULL, NULL, 71, NULL, NULL, 218866),
(218867, '3.80.10.10-FF-000894', NULL, 'Os08g0322500 protein', 139, NULL, NULL, 218867),
(218868, '3.40.190.10-FF-000417', NULL, 'Transcriptional regulator, LysR family', 88, NULL, NULL, 218868),
(218869, '3.80.10.10-FF-001063', NULL, 'AGAP012317-PA', 219, NULL, NULL, 218869),
(218870, '2.30.30.550-FF-000015', NULL, NULL, 55, NULL, NULL, 218870),
(218871, '3.90.550.10-FF-000535', NULL, 'Cellulose synthase catalytic subunit A [UDP-forming]', 100, NULL, NULL, 218871),
(218872, '1.10.20.10-FF-000025', NULL, 'Transcription initiation factor TFIID subunit 11', 89, NULL, NULL, 218872),
(218873, '1.10.10.10-FF-001508', NULL, 'Catabolite gene activator', 65, NULL, NULL, 218873),
(218874, '3.30.200.20-FF-000003', NULL, 'Non-specific serine/threonine protein kinase', 97, NULL, NULL, 218874),
(218875, '1.10.287.110-FF-000355', NULL, 'Chaperone protein DnaJ, putative', 108, NULL, NULL, 218875);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(218876, '3.40.50.1220-FF-000073', NULL, 'Nicotinamide nucleotide transhydrogenase', 58, NULL, NULL, 218876),
(218877, '1.25.40.10-FF-001011', NULL, 'Mitochondrial splicing system-related protein', 217, NULL, NULL, 218877),
(218878, '1.25.40.790-FF-000014', NULL, 'Uncharacterized protein', 76, NULL, NULL, 218878),
(218879, '1.10.287.110-FF-000411', NULL, 'Uncharacterized protein', 102, NULL, NULL, 218879),
(218880, '3.90.70.80-FF-000002', NULL, 'OTU domain-containing protein 5 isoform X2', 155, NULL, NULL, 218880),
(218881, '3.30.70.2970-FF-000004', NULL, 'Interleukin-1 receptor-associated kinase 1 binding protein 1', 101, NULL, NULL, 218881),
(218882, '2.120.10.80-FF-000206', NULL, 'Acyl-CoA-binding domain-containing protein 5', 156, NULL, NULL, 218882),
(218883, '1.10.510.10-FF-000339', NULL, 'Serine/threonine-protein kinase SRPK-like protein', 171, NULL, NULL, 218883),
(218884, '3.40.1060.10-FF-000002', NULL, 'Aconitate hydratase B', 172, NULL, NULL, 218884),
(218885, '1.20.120.350-FF-000144', NULL, NULL, 83, NULL, NULL, 218885),
(218886, '2.130.10.10-FF-004923', NULL, 'Uncharacterized protein, isoform A', 106, NULL, NULL, 218886),
(218887, '2.60.120.620-FF-000069', NULL, 'Phytanoyl-CoA dioxygenase family protein, putative', 299, NULL, NULL, 218887),
(218888, '3.80.10.10-FF-000495', NULL, 'Leucine-rich repeat protein', 124, NULL, NULL, 218888),
(218889, '2.40.50.140-FF-001018', NULL, NULL, 158, NULL, NULL, 218889),
(218890, '1.10.510.10-FF-001800', NULL, 'Lectin-domain containing receptor kinase A4.1', 153, NULL, NULL, 218890),
(218891, '3.30.420.10-FF-000449', NULL, 'DNA polymerase', 188, NULL, NULL, 218891),
(218892, '1.10.1520.10-FF-000092', NULL, 'Endoribonuclease Dicer-like', 156, NULL, NULL, 218892),
(218893, '2.40.30.330-FF-000020', NULL, 'Uncharacterized protein', 110, NULL, NULL, 218893),
(218894, '1.20.5.2950-FF-000001', NULL, 'V-type proton ATPase subunit G', 114, NULL, NULL, 218894),
(218895, '1.10.10.1200-FF-000007', NULL, 'Melanoma-associated antigen C2', 110, NULL, NULL, 218895),
(218896, '1.25.40.10-FF-004658', NULL, 'Pentatricopeptide repeat-containing protein', 115, NULL, NULL, 218896),
(218897, '1.20.144.10-FF-000070', NULL, 'Lipid phosphate phosphatase delta', 231, NULL, NULL, 218897),
(218898, '1.20.58.60-FF-000059', NULL, 'Spectrin beta chain', 302, NULL, NULL, 218898),
(218899, '3.10.20.90-FF-000573', NULL, 'Ubiquitin-like protein atg-12', 94, NULL, NULL, 218899),
(218900, '3.30.710.10-FF-000140', NULL, 'Zinc finger and BTB domain-containing protein 32', 117, NULL, NULL, 218900),
(218901, '3.30.710.10-FF-000084', NULL, 'regulatory protein NPR5 isoform X1', 194, NULL, NULL, 218901),
(218902, '3.40.50.300-FF-006166', NULL, 'Midasin, putative', 108, NULL, NULL, 218902),
(218903, '2.30.130.10-FF-000037', NULL, 'tRNA pseudouridine synthase B', 63, NULL, NULL, 218903),
(218904, '3.30.70.330-FF-002084', NULL, NULL, 76, NULL, NULL, 218904),
(218905, '3.30.420.40-FF-000885', NULL, 'Predicted protein', 23, NULL, NULL, 218905),
(218906, '1.10.510.10-FF-001452', NULL, 'Cell division protein kinase 2 putative', 203, NULL, NULL, 218906),
(218907, '2.60.120.10-FF-000176', NULL, 'Calcium-binding mitochondrial carrier protein SCaMC-1', 139, NULL, NULL, 218907),
(218908, '2.10.220.10-FF-000021', NULL, 'proprotein convertase subtilisin/kexin type 6', 111, NULL, NULL, 218908),
(218909, '3.20.20.70-FF-000482', NULL, NULL, 81, NULL, NULL, 218909),
(218910, '3.80.10.10-FF-000843', NULL, 'Leucine-rich repeat-containing protein 7', 94, NULL, NULL, 218910),
(218911, '1.25.40.20-FF-001845', NULL, 'Poly [ADP-ribose] polymerase', 142, NULL, NULL, 218911),
(218912, '2.60.120.620-FF-000125', NULL, 'Uncharacterized protein', 90, NULL, NULL, 218912),
(218913, '1.25.10.10-FF-002296', NULL, 'Uncharacterized protein', 324, NULL, NULL, 218913),
(218914, '3.30.2320.30-FF-000003', NULL, 'V-type proton ATPase subunit E', 136, NULL, NULL, 218914),
(218915, '2.60.40.10-FF-002641', NULL, 'Interleukin 4 receptor, tandem duplicate 1', 95, NULL, NULL, 218915),
(218916, '1.10.287.70-FF-000365', NULL, 'TWiK family of potassium channels', 298, NULL, NULL, 218916);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(218917, '2.70.40.10-FF-000027', NULL, 'Deoxyuridine 5''-triphosphate nucleotidohydrolase, mitochondrial', 104, NULL, NULL, 218917),
(218918, '3.30.565.10-FF-000358', NULL, 'Unplaced genomic scaffold supercont2.1, whole genome shotgun sequence', 211, NULL, NULL, 218918),
(218919, '3.40.50.1110-FF-000096', NULL, 'Putative isoamyl acetate hydrolytic enzyme', 229, NULL, NULL, 218919),
(218920, '2.60.40.10-FF-003041', NULL, 'Fms-related tyrosine kinase 4', 104, NULL, NULL, 218920),
(218921, '1.10.3720.10-FF-000152', NULL, 'Amino acid ABC transporter membrane protein 1 (PAAT family)', 217, NULL, NULL, 218921),
(218922, '1.10.1900.10-FF-000019', NULL, 'Polyadenylate-binding protein 1-B', 75, NULL, NULL, 218922),
(218923, '1.10.3380.30-FF-000002', NULL, 'superkiller viralicidic activity 2-like 2', 224, NULL, NULL, 218923),
(218924, '3.40.50.200-FF-000066', NULL, 'Predicted protein', 332, NULL, NULL, 218924),
(218925, '2.60.120.200-FF-000336', NULL, 'Uncharacterized protein', 299, NULL, NULL, 218925),
(218926, '1.25.40.10-FF-000555', NULL, 'Pentatricopeptide repeat-containing protein', 98, NULL, NULL, 218926),
(218927, '1.50.10.20-FF-000144', NULL, 'Terpene cyclase/mutase family member', 86, NULL, NULL, 218927),
(218928, '1.25.40.20-FF-000092', NULL, 'inversin isoform X1', 68, NULL, NULL, 218928),
(218929, '3.30.160.60-FF-004890', NULL, NULL, 27, NULL, NULL, 218929),
(218930, '3.30.70.330-FF-001595', NULL, NULL, 91, NULL, NULL, 218930),
(218931, '3.30.50.10-FF-000022', NULL, 'glucocorticoid receptor isoform X1', 105, NULL, NULL, 218931),
(218932, '3.40.50.1010-FF-000184', NULL, NULL, 211, NULL, NULL, 218932),
(218933, '1.10.533.10-FF-000184', NULL, 'Uncharacterized protein', 102, NULL, NULL, 218933),
(218934, '2.40.128.20-FF-000049', NULL, 'Lipocalin 8', 149, NULL, NULL, 218934),
(218935, '1.10.3260.10-FF-000009', NULL, 'Probable DNA ligase', 182, NULL, NULL, 218935),
(218936, '1.10.150.20-FF-000180', NULL, 'DNA repair enzyme', 48, NULL, NULL, 218936),
(218937, '2.60.120.200-FF-000735', NULL, 'Uncharacterized protein', 199, NULL, NULL, 218937),
(218938, '3.90.470.20-FF-000071', NULL, 'Uncharacterized protein', 116, NULL, NULL, 218938),
(218939, '3.40.50.720-FF-000660', NULL, 'Unplaced genomic scaffold supercont1.113, whole genome shotgun sequence', 191, NULL, NULL, 218939),
(218940, '2.130.10.10-FF-004710', NULL, 'Predicted protein', 170, NULL, NULL, 218940),
(218941, '3.40.50.880-FF-000011', NULL, 'Carbamoyl-phosphate synthase small chain', 228, NULL, NULL, 218941),
(218942, '3.90.740.10-FF-000010', NULL, 'Valine--tRNA ligase', 69, NULL, NULL, 218942),
(218943, '3.40.50.1820-FF-001793', NULL, 'Carboxypeptidase', 350, NULL, NULL, 218943),
(218944, '3.60.20.10-FF-000002', NULL, 'ATP-dependent protease subunit HslV', 173, NULL, NULL, 218944),
(218945, '3.40.50.300-FF-008015', NULL, 'Uncharacterized protein', 142, NULL, NULL, 218945),
(218946, '1.20.1410.10-FF-000036', NULL, 'Uncharacterized protein', 100, NULL, NULL, 218946),
(218947, '2.60.40.10-FF-000904', NULL, 'RIM-binding protein, isoform G', 84, NULL, NULL, 218947),
(218948, '1.20.120.910-FF-000008', NULL, 'Zinc finger transcriptional regulator, TraR/DksA family', 120, NULL, NULL, 218948),
(218949, '1.10.287.70-FF-000314', NULL, 'Voltage-gated Ca2+ channel, alpha subunit', 126, NULL, NULL, 218949),
(218950, '3.30.1330.20-FF-000057', NULL, 'Uncharacterized protein', 124, NULL, NULL, 218950),
(218951, '3.40.30.10-FF-000958', NULL, 'Uncharacterized protein', 104, NULL, NULL, 218951),
(218952, '3.40.50.1000-FF-000647', NULL, NULL, 192, NULL, NULL, 218952),
(218953, '2.170.150.10-FF-000034', NULL, 'Putative translationally-controlled tumor protein-like protein TPT1P8', 137, NULL, NULL, 218953),
(218954, '3.40.50.10140-FF-000033', NULL, 'Toll-4', 150, NULL, NULL, 218954),
(218955, '4.10.400.10-FF-000370', NULL, 'Serine protease nudel', 39, NULL, NULL, 218955),
(218956, '1.10.260.40-FF-000002', NULL, 'HTH-type transcriptional repressor PurR', 59, NULL, NULL, 218956),
(218957, '3.30.40.10-FF-001325', NULL, 'AER016Cp', 100, NULL, NULL, 218957),
(218958, '3.30.230.10-FF-000390', NULL, 'Predicted protein', 113, NULL, NULL, 218958);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(218959, '3.80.20.20-FF-000105', NULL, 'Receptor protein-tyrosine kinase', 172, NULL, NULL, 218959),
(218960, '3.80.10.10-FF-001332', NULL, 'Toll-like receptor 11', 148, NULL, NULL, 218960),
(218961, '1.20.1070.10-FF-001072', NULL, 'lysophosphatidic acid receptor 1-B-like', 329, NULL, NULL, 218961),
(218962, '2.10.25.10-FF-000118', NULL, 'protein delta homolog 2', 41, NULL, NULL, 218962),
(218963, '3.40.190.290-FF-000061', NULL, 'LysR family transcriptional regulator', 206, NULL, NULL, 218963),
(218964, '1.25.40.20-FF-000833', NULL, 'Poly [ADP-ribose] polymerase', 152, NULL, NULL, 218964),
(218965, '3.30.200.20-FF-000891', NULL, 'Probable peptidoglycan biosynthesis protein MviN', 93, NULL, NULL, 218965),
(218966, '3.40.50.1820-FF-000781', NULL, 'Fungal cellulose binding domain-containing protein', 246, NULL, NULL, 218966),
(218967, '3.10.120.10-FF-000043', NULL, 'Potential delta(6)-or delta(8)-desaturase, putative', 89, NULL, NULL, 218967),
(218968, '3.30.2020.30-FF-000014', NULL, 'Gamma Butyrobetaine Hydroxylase', 94, NULL, NULL, 218968),
(218969, '3.40.50.2300-FF-000762', NULL, 'Uncharacterized protein', 245, NULL, NULL, 218969),
(218970, '3.30.540.10-FF-000104', NULL, 'Uncharacterized protein', 57, NULL, NULL, 218970),
(218971, '3.10.20.90-FF-000972', NULL, 'Myosin-G heavy chain', 106, NULL, NULL, 218971),
(218972, '3.40.30.10-FF-000397', NULL, 'Protein disulfide-isomerase EUG1', 118, NULL, NULL, 218972),
(218973, '1.10.472.80-FF-000214', NULL, NULL, 134, NULL, NULL, 218973),
(218974, '3.30.70.330-FF-003045', NULL, NULL, 119, NULL, NULL, 218974),
(218975, '2.60.120.200-FF-000387', NULL, 'Galactan endo-beta-1,3-galactanase', 221, NULL, NULL, 218975),
(218976, '3.90.70.10-FF-000239', NULL, 'Calpain family cysteine protease', 134, NULL, NULL, 218976),
(218977, '1.10.238.10-FF-000239', NULL, 'N-terminal EF-hand calcium-binding protein 1', 44, NULL, NULL, 218977),
(218978, '3.30.1370.120-FF-000001', NULL, 'General secretion pathway protein D', 168, NULL, NULL, 218978),
(218979, '3.40.50.620-FF-000416', NULL, 'Arginine--tRNA ligase', 367, NULL, NULL, 218979),
(218980, '3.30.1370.10-FF-000225', NULL, 'Uncharacterized protein', 64, NULL, NULL, 218980),
(218981, '3.90.226.10-FF-000265', NULL, 'Nodulation protein NfeD', 222, NULL, NULL, 218981),
(218982, '3.20.20.220-FF-000065', NULL, 'Methylenetetrahydrofolate reductase', 204, NULL, NULL, 218982),
(218983, '3.10.250.10-FF-000047', NULL, 'Protein bark beetle', 116, NULL, NULL, 218983),
(218984, '1.10.1040.10-FF-000066', NULL, '3-hydroxyisobutyrate dehydrogenase', 86, NULL, NULL, 218984),
(218985, '1.10.340.40-FF-000003', NULL, 'Uncharacterized protein', 102, NULL, NULL, 218985),
(218986, '1.25.10.10-FF-000435', NULL, 'Ubiquitin ligase subunit', 212, NULL, NULL, 218986),
(218987, '3.30.460.10-FF-000103', NULL, 'Ribosomal silencing factor RsfS', 111, NULL, NULL, 218987),
(218988, '1.10.510.10-FF-000491', NULL, 'SRSF protein kinase 2 isoform X1', 158, NULL, NULL, 218988),
(218989, '3.40.50.1240-FF-000079', NULL, 'Phosphoglycerate mutase family protein', 215, NULL, NULL, 218989),
(218990, '2.60.34.10-FF-000126', NULL, 'Uncharacterized protein', 119, NULL, NULL, 218990),
(218991, '3.40.50.720-FF-002189', NULL, 'Hydroxysteroid (17-beta) dehydrogenase 8', 38, NULL, NULL, 218991),
(218992, '1.20.58.60-FF-000458', NULL, 'Uncharacterized protein', 108, NULL, NULL, 218992),
(218993, '4.10.170.10-FF-000003', NULL, 'Cellular tumor antigen p53', 42, NULL, NULL, 218993),
(218994, '3.30.497.10-FF-000137', NULL, 'Uncharacterized protein', 208, NULL, NULL, 218994),
(218995, '1.20.1070.10-FF-000796', NULL, 'Olfactory receptor', 225, NULL, NULL, 218995),
(218996, '3.30.2450.10-FF-000001', NULL, 'SPI-2 type III secretion system effector PipB', 119, NULL, NULL, 218996),
(218997, '3.30.40.10-FF-001538', NULL, 'CDK-activating kinase assembly factor MAT1', 63, NULL, NULL, 218997),
(218998, '3.40.50.620-FF-000068', NULL, 'Cysteine--tRNA ligase', 304, NULL, NULL, 218998),
(218999, '3.30.40.10-FF-000072', NULL, 'lysine-specific demethylase 5C isoform X2', 71, NULL, NULL, 218999);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(219000, '1.25.40.90-FF-000028', NULL, 'TOM1-like protein 2', 148, NULL, NULL, 219000),
(219001, '3.40.50.300-FF-000669', NULL, 'Ras-related protein Rab-23', 198, NULL, NULL, 219001),
(219002, '3.30.60.20-FF-000076', NULL, 'Diacylglycerol kinase', 53, NULL, NULL, 219002),
(219003, '2.10.55.10-FF-000002', NULL, 'leishmanolysin-like peptidase isoform X2', 60, NULL, NULL, 219003),
(219004, '3.30.200.100-FF-000005', NULL, 'Sigma E factor regulatory protein RseB', 97, NULL, NULL, 219004),
(219005, '1.25.10.10-FF-002801', NULL, 'Uncharacterized protein', 199, NULL, NULL, 219005),
(219006, '3.30.70.1320-FF-000015', NULL, 'AcrB/AcrD/AcrF family protein', 96, NULL, NULL, 219006),
(219007, '2.130.10.10-FF-003018', NULL, 'SAGA complex subunit', 167, NULL, NULL, 219007),
(219008, '1.20.1250.20-FF-000835', NULL, 'Organic anion transporting polypeptide 33Eb', 341, NULL, NULL, 219008),
(219009, '2.130.10.10-FF-002506', NULL, 'Beta-alanine-activating enzyme', 63, NULL, NULL, 219009),
(219010, '1.20.5.110-FF-000101', NULL, 'Serine--tRNA ligase', 79, NULL, NULL, 219010),
(219011, '1.25.10.10-FF-003257', NULL, 'phosphoinositide 3-kinase regulatory subunit 4', 215, NULL, NULL, 219011),
(219012, '3.80.10.10-FF-003480', NULL, 'Uncharacterized protein', 206, NULL, NULL, 219012),
(219013, '3.40.50.720-FF-001913', NULL, 'Os07g0602050 protein', 86, NULL, NULL, 219013),
(219014, '3.40.630.10-FF-000030', NULL, 'nicastrin', 274, NULL, NULL, 219014),
(219015, '1.10.510.10-FF-000783', NULL, 'Proline-rich receptor-like protein kinase PERK4', 207, NULL, NULL, 219015),
(219016, '2.30.30.490-FF-000031', NULL, 'Unplaced genomic scaffold supercont2.14, whole genome shotgun sequence', 248, NULL, NULL, 219016),
(219017, '2.60.40.640-FF-000015', NULL, 'Vacuolar protein sorting-associated protein 26', 143, NULL, NULL, 219017),
(219018, '2.60.40.10-FF-002872', NULL, 'MPL proto-oncogene, thrombopoietin receptor', 92, NULL, NULL, 219018),
(219019, '1.20.5.110-FF-000045', NULL, 'Syntaxin 4', 108, NULL, NULL, 219019),
(219020, '3.30.760.10-FF-000031', NULL, 'Eukaryotic translation initiation factor 4E, putative', 166, NULL, NULL, 219020),
(219021, '1.25.40.10-FF-003192', NULL, 'Pentatricopeptide repeat-containing protein', 215, NULL, NULL, 219021),
(219022, '1.10.730.10-FF-000035', NULL, 'Methionine--tRNA ligase', 175, NULL, NULL, 219022),
(219023, '3.10.20.90-FF-000005', NULL, 'Polyubiquitin 11', 76, NULL, NULL, 219023),
(219024, '3.30.200.20-FF-001964', NULL, NULL, 103, NULL, NULL, 219024),
(219025, '1.25.70.10-FF-000091', NULL, NULL, 110, NULL, NULL, 219025),
(219026, '2.40.10.10-FF-000274', NULL, NULL, 43, NULL, NULL, 219026),
(219027, '3.30.160.60-FF-000848', NULL, 'Zinc finger protein 35', 34, NULL, NULL, 219027),
(219028, '3.90.1410.10-FF-000075', NULL, 'Predicted protein', 229, NULL, NULL, 219028),
(219029, '2.60.40.200-FF-000018', NULL, 'Copper chaperone', 183, NULL, NULL, 219029),
(219030, '1.10.287.380-FF-000003', NULL, 'ABC transporter ATP-binding protein uup', 85, NULL, NULL, 219030),
(219031, '1.25.40.10-FF-003877', NULL, 'Tetratricopeptide repeat protein, putative', 90, NULL, NULL, 219031),
(219032, '1.20.1250.20-FF-001403', NULL, 'Uncharacterized protein', 187, NULL, NULL, 219032),
(219033, '3.30.2350.20-FF-000002', NULL, 'Pseudouridylate synthase 7 homolog', 215, NULL, NULL, 219033),
(219034, '2.10.90.10-FF-000084', NULL, 'Gonadal soma derived factor variant 2', 86, NULL, NULL, 219034),
(219035, '1.25.40.540-FF-000024', NULL, 'Uncharacterized protein', 237, NULL, NULL, 219035),
(219036, '1.10.150.50-FF-000177', NULL, 'Predicted protein', 66, NULL, NULL, 219036),
(219037, '3.40.50.1100-FF-000054', NULL, 'Phenylserine dehydratase', 199, NULL, NULL, 219037),
(219038, '2.40.50.140-FF-000057', NULL, 'Single-stranded DNA-binding protein', 120, NULL, NULL, 219038),
(219039, '3.40.630.30-FF-000036', NULL, 'Acetyltransferase, GNAT', 174, NULL, NULL, 219039),
(219040, '3.40.50.300-FF-008307', NULL, 'Uncharacterized protein', 260, NULL, NULL, 219040),
(219041, '3.10.170.20-FF-000032', NULL, NULL, 79, NULL, NULL, 219041),
(219042, '1.10.238.10-FF-000863', NULL, 'Uncharacterized protein', 150, NULL, NULL, 219042);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(219043, '1.25.40.20-FF-001053', NULL, 'CARD- and ANK-containing Inflammasome Adaptor Protein', 57, NULL, NULL, 219043),
(219044, '2.40.50.140-FF-000113', NULL, 'polyribonucleotide nucleotidyltransferase 1, mitochondrial', 85, NULL, NULL, 219044),
(219045, '3.90.1720.30-FF-000003', NULL, 'BnaCnng47550D protein', 159, NULL, NULL, 219045),
(219046, '3.50.4.10-FF-000051', NULL, NULL, 81, NULL, NULL, 219046),
(219047, '3.40.140.10-FF-000122', NULL, 'Putative inactive tRNA-specific adenosine deaminase-like protein 3', 167, NULL, NULL, 219047),
(219048, '2.130.10.10-FF-004654', NULL, 'Uncharacterized protein', 189, NULL, NULL, 219048),
(219049, '3.40.50.11500-FF-000031', NULL, NULL, 160, NULL, NULL, 219049),
(219050, '1.25.40.20-FF-000209', NULL, 'protein fem-1 homolog A', 76, NULL, NULL, 219050),
(219051, '1.10.486.10-FF-000012', NULL, 'DNA helicase', 169, NULL, NULL, 219051),
(219052, '2.60.40.1180-FF-000068', NULL, 'Glucuronoxylanase XynC', 102, NULL, NULL, 219052),
(219053, '3.40.50.1000-FF-000535', NULL, 'Uncharacterized protein', 267, NULL, NULL, 219053),
(219054, '3.30.420.40-FF-000992', NULL, 'Pantothenate kinase 4', 87, NULL, NULL, 219054),
(219055, '3.90.70.40-FF-000018', NULL, 'AGAP005226-PA', 14, NULL, NULL, 219055),
(219056, '3.60.21.10-FF-000021', NULL, 'Serine/threonine-protein phosphatase 5', 343, NULL, NULL, 219056),
(219057, '3.40.50.1820-FF-001118', NULL, 'Uncharacterized protein', 318, NULL, NULL, 219057),
(219058, '1.20.58.390-FF-000027', NULL, 'Histamine-gated chloride channel subunit', 133, NULL, NULL, 219058),
(219059, '3.30.160.60-FF-003866', NULL, NULL, 31, NULL, NULL, 219059),
(219060, '1.50.10.130-FF-000020', NULL, NULL, 157, NULL, NULL, 219060),
(219061, '1.20.1560.10-FF-000316', NULL, 'ABC transport protein', 325, NULL, NULL, 219061),
(219062, '3.30.40.10-FF-001269', NULL, 'Os12g0527800 protein', 55, NULL, NULL, 219062),
(219063, '1.20.58.830-FF-000024', NULL, 'Duffy receptor', 124, NULL, NULL, 219063),
(219064, '2.60.260.20-FF-000066', NULL, 'Xdj1p', 70, NULL, NULL, 219064),
(219065, '3.40.50.300-FF-004036', NULL, 'Replication protein E1', 207, NULL, NULL, 219065),
(219066, '3.50.30.80-FF-000001', NULL, 'Dihydroxy-acid dehydratase', 152, NULL, NULL, 219066),
(219067, '3.40.50.2300-FF-000998', NULL, NULL, 135, NULL, NULL, 219067),
(219068, '2.60.120.260-FF-000146', NULL, 'Glycosyl hydrolase family 10 protein', 161, NULL, NULL, 219068),
(219069, '2.60.40.10-FF-004726', NULL, NULL, 76, NULL, NULL, 219069),
(219070, '2.40.10.10-FF-000330', NULL, NULL, 80, NULL, NULL, 219070),
(219071, '3.40.850.10-FF-000193', NULL, 'Kinesin-like protein', 384, NULL, NULL, 219071),
(219072, '1.10.510.10-FF-004049', NULL, NULL, 54, NULL, NULL, 219072),
(219073, '3.90.650.10-FF-000071', NULL, 'Predicted protein', 132, NULL, NULL, 219073),
(219074, '4.10.970.10-FF-000013', NULL, 'Putative dna-binding subunit of a dna-dependent protein kinase ku70 autoantigen', 63, NULL, NULL, 219074),
(219075, '3.40.50.620-FF-000809', NULL, 'Uncharacterized protein', 37, NULL, NULL, 219075),
(219076, '3.40.50.2000-FF-000846', NULL, 'Uncharacterized protein', 242, NULL, NULL, 219076),
(219077, '3.30.1300.10-FF-000007', NULL, 'Pantothenate synthetase', 105, NULL, NULL, 219077),
(219078, '3.10.350.10-FF-000032', NULL, 'Putative lipoprotein NlpD', 49, NULL, NULL, 219078),
(219079, '3.40.50.300-FF-002799', NULL, 'Origin recognition complex subunit 1', 166, NULL, NULL, 219079),
(219080, '1.25.10.10-FF-000615', NULL, 'AP-2 complex subunit alpha', 671, NULL, NULL, 219080),
(219081, '2.10.25.10-FF-000450', NULL, 'Integrin subunit beta like 1', 48, NULL, NULL, 219081),
(219082, '2.60.120.10-FF-000625', NULL, 'Uncharacterized protein', 46, NULL, NULL, 219082),
(219083, '1.20.1280.50-FF-000082', NULL, 'F-box only protein 42', 37, NULL, NULL, 219083),
(219084, '2.60.120.920-FF-000097', NULL, 'B-box and SPRY domain containing', 177, NULL, NULL, 219084),
(219085, '2.60.40.1900-FF-000003', NULL, 'Si:ch1073-70f20.1', 91, NULL, NULL, 219085),
(219086, '1.10.150.50-FF-000233', NULL, 'Uncharacterized protein', 72, NULL, NULL, 219086);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(219087, '2.40.50.40-FF-000050', NULL, 'flap endonuclease GEN-like 2', 69, NULL, NULL, 219087),
(219088, '3.40.50.720-FF-001172', NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', 117, NULL, NULL, 219088),
(219089, '1.20.140.40-FF-000076', NULL, NULL, 151, NULL, NULL, 219089),
(219090, '1.10.418.10-FF-000012', NULL, 'Plastin-3 isoform 1', 117, NULL, NULL, 219090),
(219091, '3.30.780.10-FF-000026', NULL, 'Translation initiation factor, putative', 109, NULL, NULL, 219091),
(219092, '1.10.150.670-FF-000001', NULL, 'Crossover junction endonuclease MUS81', 83, NULL, NULL, 219092),
(219093, '2.130.10.10-FF-001040', NULL, 'Protein phosphatase PP2A regulatory subunit B', 372, NULL, NULL, 219093),
(219094, '3.10.20.90-FF-000281', NULL, 'Ubiquitin-like protein, putative', 109, NULL, NULL, 219094),
(219095, '2.70.150.10-FF-000131', NULL, 'Phospholipid-transporting ATPase', 140, NULL, NULL, 219095),
(219096, '3.40.640.10-FF-000379', NULL, 'Uncharacterized protein', 44, NULL, NULL, 219096),
(219097, '1.20.120.1500-FF-000001', NULL, 'Pre-hexon-linking protein IIIa', 134, NULL, NULL, 219097),
(219098, '3.90.550.10-FF-000647', NULL, 'Hexosyltransferase', 141, NULL, NULL, 219098),
(219099, '1.10.287.110-FF-000299', NULL, 'DnaJ heat shock protein family (Hsp40) member C18', 77, NULL, NULL, 219099),
(219100, '1.20.120.350-FF-000088', NULL, 'Protein CBG09661', 183, NULL, NULL, 219100),
(219101, '1.10.530.10-FF-000054', NULL, 'SPbeta prophage-derived uncharacterized transglycosylase YomI', 172, NULL, NULL, 219101),
(219102, '3.10.20.310-FF-000026', NULL, 'Patatin-like protein, PlpD', 74, NULL, NULL, 219102),
(219103, '1.10.3470.10-FF-000059', NULL, 'Putative cation ABC transporter, permease protein', 228, NULL, NULL, 219103),
(219104, '2.60.120.330-FF-000139', NULL, 'Protein DMR6-LIKE OXYGENASE 2', 178, NULL, NULL, 219104),
(219105, '1.25.40.20-FF-001901', NULL, 'Uncharacterized protein', 211, NULL, NULL, 219105),
(219106, '1.10.150.20-FF-000073', NULL, 'Translocation protein SEC63', 59, NULL, NULL, 219106),
(219107, '3.90.1110.10-FF-000035', NULL, NULL, 72, NULL, NULL, 219107),
(219108, '1.25.40.10-FF-000263', NULL, 'SEL1L, ERAD E3 ligase adaptor subunit', 244, NULL, NULL, 219108),
(219109, '2.60.40.10-FF-000455', NULL, 'Protogenin A', 102, NULL, NULL, 219109),
(219110, '1.20.1070.10-FF-001521', NULL, 'Atypical chemokine receptor 2', 191, NULL, NULL, 219110),
(219111, '2.60.40.10-FF-000511', NULL, 'Nectin cell adhesion molecule 3', 95, NULL, NULL, 219111),
(219112, '3.30.830.10-FF-000300', NULL, 'Clan ME, family M16, insulinase-like metallopeptidase', 260, NULL, NULL, 219112),
(219113, '1.25.40.10-FF-004714', NULL, 'Uncharacterized protein', 91, NULL, NULL, 219113),
(219114, '2.60.40.10-FF-004906', NULL, NULL, 106, NULL, NULL, 219114),
(219115, '2.30.110.10-FF-000098', NULL, 'Uncharacterized protein', 70, NULL, NULL, 219115),
(219116, '3.40.50.2000-FF-000902', NULL, 'WbcM protein', 168, NULL, NULL, 219116),
(219117, '1.10.287.70-FF-000657', NULL, 'Potassium channel, subfamily K, member 16', 140, NULL, NULL, 219117),
(219118, '3.30.160.60-FF-003759', NULL, NULL, 27, NULL, NULL, 219118),
(219119, '3.20.20.80-FF-000659', NULL, 'Uncharacterized protein', 59, NULL, NULL, 219119),
(219120, '3.20.20.80-FF-000479', NULL, 'Oligo-1,6-glucosidase', 281, NULL, NULL, 219120),
(219121, '1.10.238.20-FF-000012', NULL, 'AGAP001189-PA', 109, NULL, NULL, 219121),
(219122, '3.30.160.60-FF-006396', NULL, NULL, 91, NULL, NULL, 219122),
(219123, '3.30.40.10-FF-002106', NULL, 'Uncharacterized protein', 58, NULL, NULL, 219123),
(219124, '1.20.120.1750-FF-000166', NULL, 'RBR-type E3 ubiquitin transferase', 170, NULL, NULL, 219124),
(219125, '3.40.50.300-FF-006397', NULL, 'Uncharacterized protein', 133, NULL, NULL, 219125),
(219126, '1.10.10.1100-FF-000016', NULL, 'FAD-dependent pyridine nucleotide-disulfide oxidoreductase', 61, NULL, NULL, 219126),
(219127, '2.40.110.10-FF-000045', NULL, 'Oxidoreductase', 106, NULL, NULL, 219127),
(219128, '1.10.10.10-FF-001216', NULL, 'DNA-binding response regulator', 107, NULL, NULL, 219128);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(219129, '1.10.510.10-FF-004381', NULL, NULL, 96, NULL, NULL, 219129),
(219130, '1.25.40.10-FF-000443', NULL, 'Pentatricopeptide repeat-containing protein', 123, NULL, NULL, 219130),
(219131, '2.130.10.10-FF-001220', NULL, 'WD repeat-containing protein 65', 342, NULL, NULL, 219131),
(219132, '1.20.1070.10-FF-001341', NULL, 'Uncharacterized protein', 334, NULL, NULL, 219132),
(219133, '2.10.90.10-FF-000140', NULL, 'Uncharacterized protein', 114, NULL, NULL, 219133),
(219134, '1.10.287.70-FF-000022', NULL, 'Small conductance calcium-activated potassium channel, isoform O', 97, NULL, NULL, 219134),
(219135, '1.25.10.10-FF-003364', NULL, 'Predicted protein', 178, NULL, NULL, 219135),
(219136, '3.40.50.1950-FF-000016', NULL, 'Cypemycin cysteine dehydrogenase (decarboxylating)', 170, NULL, NULL, 219136),
(219137, '1.20.58.900-FF-000017', NULL, 'Uncharacterized protein, isoform C', 161, NULL, NULL, 219137),
(219138, '3.60.120.10-FF-000026', NULL, 'Isochorismate synthase', 426, NULL, NULL, 219138),
(219139, '3.30.70.580-FF-000068', NULL, 'tRNA pseudouridine synthase', 58, NULL, NULL, 219139),
(219140, '1.20.140.150-FF-000110', NULL, 'Uncharacterized protein', 157, NULL, NULL, 219140),
(219141, '1.10.533.10-FF-000240', NULL, 'Uncharacterized protein', 84, NULL, NULL, 219141),
(219142, '2.60.120.200-FF-000443', NULL, 'Os02g0299000 protein', 129, NULL, NULL, 219142),
(219143, '3.50.50.60-FF-000406', NULL, 'Possible oxygenase', 134, NULL, NULL, 219143),
(219144, '2.60.40.10-FF-003310', NULL, 'CAMTA (CAlModulin-binding Transcriptional activator)', 95, NULL, NULL, 219144),
(219145, '3.90.1150.210-FF-000012', NULL, 'F-actin-capping protein subunit beta', 221, NULL, NULL, 219145),
(219146, '1.10.455.10-FF-000036', NULL, 'Uncharacterized protein', 83, NULL, NULL, 219146),
(219147, '2.40.10.230-FF-000003', NULL, 'NAF1 domain containing protein', 94, NULL, NULL, 219147),
(219148, '3.40.50.300-FF-008583', NULL, 'DNA helicase', 253, NULL, NULL, 219148),
(219149, '2.60.40.790-FF-000032', NULL, 'NudC domain containing 1', 111, NULL, NULL, 219149),
(219150, '3.30.70.270-FF-000132', NULL, 'Diguanylate cyclase', 166, NULL, NULL, 219150),
(219151, '3.30.70.360-FF-000007', NULL, 'Peptidase, M20/M25/M40 family', 112, NULL, NULL, 219151),
(219152, '1.20.120.550-FF-000029', NULL, 'Predicted protein', 79, NULL, NULL, 219152),
(219153, '1.10.287.90-FF-000028', NULL, 'Cytochrome c oxidase subunit II', 77, NULL, NULL, 219153),
(219154, '3.30.200.20-FF-001060', NULL, 'CMGC family protein kinase', 82, NULL, NULL, 219154),
(219155, '2.60.40.60-FF-000374', NULL, 'Cadherin-related hmr-1', 112, NULL, NULL, 219155),
(219156, '3.40.50.300-FF-003524', NULL, 'ATP-dependent DNA helicase', 178, NULL, NULL, 219156),
(219157, '3.30.60.90-FF-000001', NULL, 'Dystrophin isoform 2', 61, NULL, NULL, 219157),
(219158, '1.50.40.10-FF-000087', NULL, 'SLC (SoLute Carrier) homolog', 91, NULL, NULL, 219158),
(219159, '1.25.40.10-FF-001859', NULL, 'Tetratricopeptide repeat domain 4', 128, NULL, NULL, 219159),
(219160, '3.30.40.10-FF-000757', NULL, 'San1p', 70, NULL, NULL, 219160),
(219161, '3.90.550.10-FF-000086', NULL, 'Putative ceramide glucosyltransferase', 231, NULL, NULL, 219161),
(219162, '1.10.510.10-FF-002020', NULL, 'Protein nipi-3', 290, NULL, NULL, 219162),
(219163, '1.10.1140.10-FF-000006', NULL, 'ATP synthase subunit beta', 109, NULL, NULL, 219163),
(219164, '2.40.30.10-FF-000449', NULL, 'Uncharacterized protein', 69, NULL, NULL, 219164),
(219165, '3.30.160.60-FF-004322', NULL, NULL, 30, NULL, NULL, 219165),
(219166, '1.20.1250.20-FF-001347', NULL, 'Uncharacterized protein', 205, NULL, NULL, 219166),
(219167, '1.10.510.10-FF-004094', NULL, NULL, 144, NULL, NULL, 219167),
(219168, '2.40.70.10-FF-000502', NULL, NULL, 109, NULL, NULL, 219168),
(219169, '3.30.9.10-FF-000067', NULL, 'Unplaced genomic scaffold supercont2.12, whole genome shotgun sequence', 208, NULL, NULL, 219169),
(219170, '2.60.40.2070-FF-000003', NULL, 'Putative fimbrial outer membrane usher', 75, NULL, NULL, 219170),
(219171, '3.40.710.10-FF-000031', NULL, 'Penicillin-binding protein, putative', 303, NULL, NULL, 219171);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(219172, '1.10.10.520-FF-000011', NULL, 'Ubiquitin-activating enzyme E1-like', 214, NULL, NULL, 219172),
(219173, '3.80.10.10-FF-000551', NULL, 'Si:dkey-286j17.4', 171, NULL, NULL, 219173),
(219174, '3.30.200.20-FF-002420', NULL, 'Uncharacterized protein', 86, NULL, NULL, 219174),
(219175, '3.40.50.620-FF-000124', NULL, 'Leucine--tRNA ligase', 314, NULL, NULL, 219175),
(219176, '2.130.10.10-FF-005199', NULL, 'Uncharacterized protein', 104, NULL, NULL, 219176),
(219177, '1.10.472.170-FF-000019', NULL, 'Cyclin/Brf1-like TBP-binding protein', 141, NULL, NULL, 219177),
(219178, '3.30.70.330-FF-002140', NULL, NULL, 135, NULL, NULL, 219178),
(219179, '4.10.60.10-FF-000139', NULL, 'Cold shock domain-containing protein 4', 31, NULL, NULL, 219179),
(219180, '3.30.2140.20-FF-000008', NULL, 'Arylamine N-acetyltransferase 1', 280, NULL, NULL, 219180),
(219181, '3.40.190.10-FF-000170', NULL, 'Glutamate receptor ionotropic, NMDA 2D', 148, NULL, NULL, 219181),
(219182, '1.10.20.10-FF-000317', NULL, NULL, 133, NULL, NULL, 219182),
(219183, '1.25.40.20-FF-000541', NULL, 'Arginine N-methyltransferase 2', 123, NULL, NULL, 219183),
(219184, '1.20.58.60-FF-000402', NULL, 'AGAP009554-PA', 299, NULL, NULL, 219184),
(219185, '1.20.1110.10-FF-000108', NULL, 'Uncharacterized protein', 189, NULL, NULL, 219185),
(219186, '1.20.1310.10-FF-000040', NULL, 'Putative cullin-1', 123, NULL, NULL, 219186),
(219187, '3.40.720.10-FF-000037', NULL, 'Nucleotide pyrophosphatase family protein', 269, NULL, NULL, 219187),
(219188, '3.40.50.300-FF-007234', NULL, 'Atlastin 3', 161, NULL, NULL, 219188),
(219189, '2.60.120.650-FF-000117', NULL, 'Uncharacterized protein', 99, NULL, NULL, 219189),
(219190, '2.130.10.10-FF-002288', NULL, 'WD_repeat_and_HMG-box_DNA-binding_protein_-_putative', 208, NULL, NULL, 219190),
(219191, '3.30.530.20-FF-000140', NULL, 'Uncharacterized protein', 215, NULL, NULL, 219191),
(219192, '1.20.140.10-FF-000134', NULL, 'Uncharacterized protein', 68, NULL, NULL, 219192),
(219193, '3.30.160.60-FF-000668', NULL, 'zinc finger protein 346 isoform X1', 43, NULL, NULL, 219193),
(219194, '3.30.530.20-FF-000084', NULL, 'Polyketide cyclase / dehydrase and lipid transport protein', 144, NULL, NULL, 219194),
(219195, '1.10.10.60-FF-000192', NULL, 'Homeobox-leucine zipper protein HAT22', 47, NULL, NULL, 219195),
(219196, '3.30.1490.110-FF-000002', NULL, 'Cell division protein FtsA', 74, NULL, NULL, 219196),
(219197, '3.30.110.10-FF-000004', NULL, 'Translation initiation factor IF-3, mitochondrial', 85, NULL, NULL, 219197),
(219198, '3.30.40.10-FF-000252', NULL, 'E3 ubiquitin-protein ligase LRSAM1 isoform 1', 58, NULL, NULL, 219198),
(219199, '3.40.50.300-FF-001107', NULL, 'Cell division control protein 48-B-like protein', 188, NULL, NULL, 219199),
(219200, '3.60.110.10-FF-000020', NULL, 'Glutamine-dependent NAD(+) synthetase', 323, NULL, NULL, 219200),
(219201, '2.40.50.90-FF-000036', NULL, 'Tudor domain-containing protein 12', 49, NULL, NULL, 219201),
(219202, '2.30.30.40-FF-000133', NULL, 'FYN-binding protein-like isoform X2', 74, NULL, NULL, 219202),
(219203, '1.25.10.10-FF-002583', NULL, 'Os01g0816500 protein', 158, NULL, NULL, 219203),
(219204, '3.30.200.20-FF-002364', NULL, 'Predicted protein', 128, NULL, NULL, 219204),
(219205, '3.30.160.60-FF-003142', NULL, 'Zinc finger protein 30', 27, NULL, NULL, 219205),
(219206, '1.20.1250.20-FF-002128', NULL, 'Solute carrier organic anion transporter family member', 213, NULL, NULL, 219206),
(219207, '2.60.120.920-FF-000041', NULL, 'E3 ubiquitin-protein ligase TRIM62', 185, NULL, NULL, 219207),
(219208, '3.30.56.10-FF-000029', NULL, 'Phenylalanine--tRNA ligase beta subunit', 70, NULL, NULL, 219208),
(219209, '3.10.20.30-FF-000015', NULL, 'Aldehyde oxidase 1', 91, NULL, NULL, 219209),
(219210, '1.25.40.20-FF-001340', NULL, 'Uncharacterized protein', 119, NULL, NULL, 219210),
(219211, '3.30.40.10-FF-002382', NULL, 'Uncharacterized protein', 63, NULL, NULL, 219211),
(219212, '3.40.50.150-FF-000972', NULL, NULL, 230, NULL, NULL, 219212),
(219213, '3.40.50.300-FF-002743', NULL, 'ABC transporter ATP-binding protein', 258, NULL, NULL, 219213);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(219214, '1.10.230.10-FF-000014', NULL, 'Citrate synthase 2', 96, NULL, NULL, 219214),
(219215, '3.40.140.10-FF-000178', NULL, 'Uncharacterized protein', 183, NULL, NULL, 219215),
(219216, '3.80.10.10-FF-004261', NULL, 'Uncharacterized protein', 65, NULL, NULL, 219216),
(219217, '2.130.10.10-FF-004474', NULL, 'Striatin 4', 80, NULL, NULL, 219217),
(219218, '2.60.40.10-FF-003889', NULL, NULL, 84, NULL, NULL, 219218),
(219219, '1.20.1280.220-FF-000001', NULL, 'AvrPtoB type III effector', 106, NULL, NULL, 219219),
(219220, '2.60.120.560-FF-000011', NULL, 'Glycoside hydrolase', 168, NULL, NULL, 219220),
(219221, '2.60.40.10-FF-005783', NULL, NULL, 118, NULL, NULL, 219221),
(219222, '2.40.30.10-FF-000505', NULL, 'Oxidoreductase NAD-binding domain-containing protein 1', 92, NULL, NULL, 219222),
(219223, '2.60.40.3170-FF-000013', NULL, 'Predicted protein', 80, NULL, NULL, 219223),
(219224, '3.30.70.330-FF-000807', NULL, 'Putative RRM RNA binding protein NSAP1', 84, NULL, NULL, 219224),
(219225, '3.30.160.60-FF-001961', NULL, 'Zinc finger protein 34', 52, NULL, NULL, 219225),
(219226, '1.10.1450.10-FF-000108', NULL, 'Tetraspanin', 103, NULL, NULL, 219226),
(219227, '3.40.630.10-FF-000210', NULL, 'N-alpha-acetyl-L-2,4-diaminobutyric acid deacetylase', 332, NULL, NULL, 219227),
(219228, '2.130.10.10-FF-001725', NULL, 'Receptor for activated C kinase 1', 226, NULL, NULL, 219228),
(219229, '3.40.50.410-FF-000123', NULL, 'Protein transport protein SEC23', 259, NULL, NULL, 219229),
(219230, '3.40.50.720-FF-001733', NULL, 'Homoserine dehydrogenase', 184, NULL, NULL, 219230),
(219231, '3.30.40.10-FF-001089', NULL, 'WGS project CABT00000000 data, contig 2.7', 85, NULL, NULL, 219231),
(219232, '1.10.555.10-FF-000257', NULL, NULL, 111, NULL, NULL, 219232),
(219233, '3.30.740.10-FF-000029', NULL, NULL, 56, NULL, NULL, 219233),
(219234, '3.30.1120.10-FF-000061', NULL, 'Arylsulfatase A', 59, NULL, NULL, 219234),
(219235, '3.30.70.330-FF-002320', NULL, NULL, 117, NULL, NULL, 219235),
(219236, '3.40.30.10-FF-000846', NULL, 'Uncharacterized protein', 114, NULL, NULL, 219236),
(219237, '3.40.50.980-FF-000035', NULL, 'Uncharacterized protein', 143, NULL, NULL, 219237),
(219238, '1.25.10.10-FF-002240', NULL, 'Uncharacterized protein', 381, NULL, NULL, 219238),
(219239, '1.10.1040.10-FF-000010', NULL, '3-hydroxybutyryl-CoA dehydrogenase', 102, NULL, NULL, 219239),
(219240, '2.40.30.130-FF-000016', NULL, 'YNL040W-like protein', 101, NULL, NULL, 219240),
(219241, '3.30.420.270-FF-000021', NULL, 'Tol-Pal system protein TolR', 74, NULL, NULL, 219241),
(219242, '3.40.30.10-FF-001122', NULL, 'Uncharacterized protein', 180, NULL, NULL, 219242),
(219243, '2.10.25.10-FF-001523', NULL, 'Uncharacterized protein', 49, NULL, NULL, 219243),
(219244, '3.30.160.60-FF-001629', NULL, 'Uncharacterized protein', 27, NULL, NULL, 219244),
(219245, '1.20.1250.20-FF-000330', NULL, 'monocarboxylate transporter 10', 182, NULL, NULL, 219245),
(219246, '2.40.50.140-FF-000237', NULL, 'Ribonuclease, Rne/Rng family domain protein', 115, NULL, NULL, 219246),
(219247, '2.130.10.10-FF-002001', NULL, 'Katanin p80 WD40 repeat-containing subunit B1', 197, NULL, NULL, 219247),
(219248, '1.20.1070.10-FF-000560', NULL, 'neuropeptides capa receptor isoform X1', 316, NULL, NULL, 219248),
(219249, '3.40.50.300-FF-000146', NULL, 'MAGUK p55 subfamily member 6 isoform X1', 201, NULL, NULL, 219249),
(219250, '3.30.450.40-FF-000089', NULL, 'Sigma-54-dependent Fis family transcriptional regulator', 185, NULL, NULL, 219250),
(219251, '3.40.50.1010-FF-000072', NULL, 'Ribonuclease VapC', 133, NULL, NULL, 219251),
(219252, '3.40.33.10-FF-000184', NULL, 'Uncharacterized protein', 68, NULL, NULL, 219252),
(219253, '2.30.42.10-FF-000601', NULL, NULL, 100, NULL, NULL, 219253),
(219254, '2.60.40.1170-FF-000008', NULL, 'AP-2 complex subunit mu isoform 2', 163, NULL, NULL, 219254),
(219255, '2.30.30.40-FF-000532', NULL, 'Protein kinase C and casein kinase substrate in neurons protein 2', 32, NULL, NULL, 219255),
(219256, '3.40.50.620-FF-000304', NULL, 'Tyrosine--tRNA ligase', 268, NULL, NULL, 219256);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(219257, '3.55.40.10-FF-000004', NULL, 'Putative type IV pilin', 138, NULL, NULL, 219257),
(219258, '3.30.450.30-FF-000047', NULL, 'Probable gliding protein (MglB)', 138, NULL, NULL, 219258),
(219259, '2.30.29.30-FF-000115', NULL, 'General transcription factor IIH subunit 1', 107, NULL, NULL, 219259),
(219260, '3.90.190.10-FF-000496', NULL, 'Probable dual specificity protein phosphatase DDB_G0283417', 152, NULL, NULL, 219260),
(219261, '1.25.40.10-FF-003753', NULL, 'Uncharacterized protein', 298, NULL, NULL, 219261),
(219262, '2.10.70.10-FF-000138', NULL, 'Uncharacterized protein, isoform C', 63, NULL, NULL, 219262),
(219263, '3.30.70.330-FF-001027', NULL, 'RNA-binding protein', 108, NULL, NULL, 219263),
(219264, '1.20.1250.20-FF-001167', NULL, 'Predicted protein', 203, NULL, NULL, 219264),
(219265, '3.30.70.330-FF-003157', NULL, NULL, 160, NULL, NULL, 219265),
(219266, '1.10.490.10-FF-000050', NULL, 'Uncharacterized protein', 108, NULL, NULL, 219266),
(219267, '1.10.510.10-FF-002705', NULL, NULL, 74, NULL, NULL, 219267),
(219268, '2.30.110.10-FF-000042', NULL, 'Uncharacterized protein, isoform A', 168, NULL, NULL, 219268),
(219269, '3.40.1090.10-FF-000061', NULL, 'Patatin', 389, NULL, NULL, 219269),
(219270, '3.40.1170.60-FF-000048', NULL, NULL, 22, NULL, NULL, 219270),
(219271, '2.60.120.10-FF-000120', NULL, 'cAMP-dependent protein kinase regulatory subunit', 136, NULL, NULL, 219271),
(219272, '3.30.497.10-FF-000025', NULL, 'Serine protease inhibitor, serpin', 68, NULL, NULL, 219272),
(219273, '1.20.1270.60-FF-000202', NULL, 'Uncharacterized protein', 296, NULL, NULL, 219273),
(219274, '1.10.3480.20-FF-000001', NULL, 'Uncharacterized protein', 45, NULL, NULL, 219274),
(219275, '1.10.3110.10-FF-000010', NULL, 'Amine oxidase', 86, NULL, NULL, 219275),
(219276, '2.60.200.20-FF-000163', NULL, 'Serine/threonine-protein kinase RAD53', 138, NULL, NULL, 219276),
(219277, '3.30.160.60-FF-000269', NULL, 'Zinc finger protein 287', 29, NULL, NULL, 219277),
(219278, '2.120.10.30-FF-000170', NULL, 'Uncharacterized protein', 134, NULL, NULL, 219278),
(219279, '1.10.287.470-FF-000030', NULL, 'Efflux transporter periplasmic adaptor subunit', 74, NULL, NULL, 219279),
(219280, '3.40.50.720-FF-001677', NULL, 'Phosphoglycerate dehydrogenase', 109, NULL, NULL, 219280),
(219281, '3.40.50.300-FF-006110', NULL, 'Putative multidrug resistance-associated protein lethal(2)03659-like Protein', 273, NULL, NULL, 219281),
(219282, '3.40.50.150-FF-001192', NULL, NULL, 214, NULL, NULL, 219282),
(219283, '3.30.1360.10-FF-000056', NULL, 'Uncharacterized protein', 50, NULL, NULL, 219283),
(219284, '2.70.150.10-FF-000075', NULL, 'Metal cation transporter P-type ATPase', 85, NULL, NULL, 219284),
(219285, '2.70.170.10-FF-000306', NULL, 'Protein CBG26995', 89, NULL, NULL, 219285),
(219286, '4.10.1240.10-FF-000079', NULL, 'Uncharacterized protein', 47, NULL, NULL, 219286),
(219287, '3.40.50.11340-FF-000016', NULL, 'Probable fucosyltransferase 8', 77, NULL, NULL, 219287),
(219288, '2.70.170.10-FF-000126', NULL, 'Predicted protein', 211, NULL, NULL, 219288),
(219289, '1.25.40.180-FF-000337', NULL, NULL, 149, NULL, NULL, 219289),
(219290, '3.40.1110.10-FF-000119', NULL, 'Phospholipid-transporting ATPase', 108, NULL, NULL, 219290),
(219291, '2.130.10.10-FF-005435', NULL, 'WD-40 repeat-containing protein', 218, NULL, NULL, 219291),
(219292, '2.60.40.10-FF-000399', NULL, 'myopalladin isoform X1', 107, NULL, NULL, 219292),
(219293, '2.40.160.120-FF-000055', NULL, 'Predicted protein', 173, NULL, NULL, 219293),
(219294, '3.30.830.10-FF-000244', NULL, 'Ubiquinol-cytochrome c reductase core protein 2b', 204, NULL, NULL, 219294),
(219295, '1.25.40.800-FF-000012', NULL, 'Os03g0102366 protein', 113, NULL, NULL, 219295),
(219296, '1.20.58.760-FF-000048', NULL, 'Uncharacterized protein', 117, NULL, NULL, 219296),
(219297, '1.20.58.1030-FF-000021', NULL, 'DNA replication complex GINS protein SLD5', 140, NULL, NULL, 219297),
(219298, '1.10.472.10-FF-000177', NULL, 'PHO85 cyclin-10', 191, NULL, NULL, 219298),
(219299, '2.130.10.10-FF-005379', NULL, 'Predicted protein', 362, NULL, NULL, 219299);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(219300, '3.30.40.10-FF-000813', NULL, 'E3 ubiquitin-protein ligase RNF213', 78, NULL, NULL, 219300),
(219301, '3.90.190.10-FF-000552', NULL, 'Uncharacterized protein', 112, NULL, NULL, 219301),
(219302, '3.30.450.40-FF-000145', NULL, 'Protein serine phosphatase with GAF(S) sensor(S)', 178, NULL, NULL, 219302),
(219303, '1.20.1280.50-FF-000262', NULL, 'Uncharacterized protein', 55, NULL, NULL, 219303),
(219304, '2.60.120.10-FF-000064', NULL, 'cGMP-dependent protein kinase, isozyme', 136, NULL, NULL, 219304),
(219305, '3.50.50.60-FF-001463', NULL, 'Glutathione reductase', 72, NULL, NULL, 219305),
(219306, '1.25.10.10-FF-002060', NULL, 'Nipped-B protein', 275, NULL, NULL, 219306),
(219307, '1.25.10.10-FF-001784', NULL, 'Exportin-6, putative', 609, NULL, NULL, 219307),
(219308, '2.60.40.10-FF-001236', NULL, 'Usherin', 96, NULL, NULL, 219308),
(219309, '3.80.10.10-FF-003148', NULL, 'Uncharacterized protein', 302, NULL, NULL, 219309),
(219310, '3.30.450.20-FF-000662', NULL, 'Sensor histidine kinase, HAMP and PAS domain-containing', 112, NULL, NULL, 219310),
(219311, '2.30.29.30-FF-000059', NULL, 'neurobeachin isoform X1', 105, NULL, NULL, 219311),
(219312, '3.30.479.30-FF-000023', NULL, 'Band 7 protein', 125, NULL, NULL, 219312),
(219313, '3.30.420.10-FF-000213', NULL, 'DNA polymerase I', 175, NULL, NULL, 219313),
(219314, '3.30.450.40-FF-000269', NULL, 'Histidine kinase dimerisation and phosphoacceptor region', 171, NULL, NULL, 219314),
(219315, '1.20.90.10-FF-000001', NULL, 'Basic phospholipase A2 homolog', 124, NULL, NULL, 219315),
(219316, '3.40.50.1000-FF-000411', NULL, '5''-nucleotidase', 156, NULL, NULL, 219316),
(219317, '3.30.1330.60-FF-000041', NULL, 'Peptidoglycan-associated protein', 124, NULL, NULL, 219317),
(219318, '3.40.50.300-FF-005492', NULL, 'ABC transporter ATP-binding protein', 191, NULL, NULL, 219318),
(219319, '2.30.29.30-FF-000790', NULL, 'Sorting nexin-31', 111, NULL, NULL, 219319),
(219320, '3.40.800.10-FF-000038', NULL, 'Agmatinase, putative', 305, NULL, NULL, 219320),
(219321, '3.40.50.300-FF-006453', NULL, 'Uncharacterized protein', 122, NULL, NULL, 219321),
(219322, '2.70.98.20-FF-000028', NULL, 'Amine oxidase', 313, NULL, NULL, 219322),
(219323, '1.10.10.10-FF-000435', NULL, 'HTH-type transcriptional regulator MurR', 74, NULL, NULL, 219323),
(219324, '2.130.10.10-FF-005778', NULL, 'Uncharacterized protein', 104, NULL, NULL, 219324),
(219325, '3.40.640.10-FF-000036', NULL, 'pyridoxal-dependent decarboxylase domain-containing protein 1 isoform X2', 223, NULL, NULL, 219325),
(219326, '2.160.20.10-FF-000050', NULL, 'F-box domain containing protein', 175, NULL, NULL, 219326),
(219327, '3.10.580.10-FF-000184', NULL, 'Chloride channel protein', 123, NULL, NULL, 219327),
(219328, '1.25.40.10-FF-003933', NULL, 'Uncharacterized protein', 287, NULL, NULL, 219328),
(219329, '3.40.50.1440-FF-000083', NULL, 'Uncharacterized protein', 75, NULL, NULL, 219329),
(219330, '3.40.30.10-FF-000902', NULL, 'Predicted protein', 140, NULL, NULL, 219330),
(219331, '2.60.40.150-FF-000363', NULL, 'Multiple C2 domains, transmembrane 2a', 128, NULL, NULL, 219331),
(219332, '2.60.40.10-FF-005963', NULL, NULL, 111, NULL, NULL, 219332),
(219333, '2.60.40.1180-FF-000124', NULL, 'neutral alpha-glucosidase AB', 78, NULL, NULL, 219333),
(219334, '3.20.20.80-FF-000715', NULL, 'Uncharacterized protein', 177, NULL, NULL, 219334),
(219335, '3.30.160.60-FF-006452', NULL, NULL, 34, NULL, NULL, 219335),
(219336, '1.50.40.10-FF-000143', NULL, 'Mitochondrial carrier protein, putative', 312, NULL, NULL, 219336),
(219337, '3.40.50.150-FF-000079', NULL, 'Ribosomal RNA small subunit methyltransferase F', 309, NULL, NULL, 219337),
(219338, '3.30.160.650-FF-000002', NULL, 'Alkylglycerone-phosphate synthase', 43, NULL, NULL, 219338),
(219339, '3.10.450.10-FF-000028', NULL, 'Cysteine proteinase inhibitor', 101, NULL, NULL, 219339),
(219340, '1.10.10.60-FF-000697', NULL, 'Myb transcription factor', 52, NULL, NULL, 219340),
(219341, '3.60.40.10-FF-000273', NULL, 'Protein phosphatase family protein, putative', 271, NULL, NULL, 219341);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(219342, '2.60.120.260-FF-000326', NULL, 'Beta-glucosidase', 169, NULL, NULL, 219342),
(219343, '3.30.450.20-FF-000263', NULL, 'Methyl-accepting chemotaxis protein', 140, NULL, NULL, 219343),
(219344, '1.10.555.10-FF-000077', NULL, 'GTPase activating protein', 226, NULL, NULL, 219344),
(219345, '3.30.70.1660-FF-000044', NULL, 'Uncharacterized protein', 78, NULL, NULL, 219345),
(219346, '3.40.50.1580-FF-000040', NULL, 'S-methyl-5''-thioadenosine phosphorylase', 274, NULL, NULL, 219346),
(219347, '3.40.50.300-FF-001782', NULL, 'ABC transporter, ATP-binding protein', 249, NULL, NULL, 219347),
(219348, '3.30.470.30-FF-000031', NULL, 'Multifunctional non-homologous end joining protein LigD', 110, NULL, NULL, 219348),
(219349, '3.40.50.2000-FF-001066', NULL, 'Uncharacterized protein', 83, NULL, NULL, 219349),
(219350, '1.10.630.10-FF-000382', NULL, 'Cytochrome P450 monooxygenase easK', 316, NULL, NULL, 219350),
(219351, '3.90.1410.10-FF-000131', NULL, 'Predicted protein', 272, NULL, NULL, 219351),
(219352, '3.40.50.140-FF-000019', NULL, 'Uncharacterized protein', 124, NULL, NULL, 219352),
(219353, '1.10.510.10-FF-002525', NULL, NULL, 253, NULL, NULL, 219353),
(219354, '3.40.50.300-FF-005093', NULL, 'Ras-like protein', 35, NULL, NULL, 219354),
(219355, '3.40.50.1970-FF-000011', NULL, 'NDMA-dependent methanol dehydrogenase', 186, NULL, NULL, 219355),
(219356, '1.10.510.10-FF-001688', NULL, 'Discoidin domain-containing receptor A', 169, NULL, NULL, 219356),
(219357, '2.10.25.10-FF-001467', NULL, 'Neurogenic locus notch homolog protein 1', 39, NULL, NULL, 219357),
(219358, '3.90.1150.10-FF-000088', NULL, 'Aminotransferase, putative', 149, NULL, NULL, 219358),
(219359, '3.30.230.10-FF-000002', NULL, '30S ribosomal protein S5', 92, NULL, NULL, 219359),
(219360, '1.20.1560.10-FF-000659', NULL, 'Uncharacterized protein', 77, NULL, NULL, 219360),
(219361, '3.30.60.20-FF-000020', NULL, 'Putative unconventional myosin-IXa', 71, NULL, NULL, 219361),
(219362, '2.30.29.30-FF-000458', NULL, 'Uncharacterized protein, isoform B', 128, NULL, NULL, 219362),
(219363, '2.120.10.30-FF-000332', NULL, 'Uncharacterized protein', 87, NULL, NULL, 219363),
(219364, '3.30.160.60-FF-002181', NULL, 'Zinc finger protein 215', 49, NULL, NULL, 219364),
(219365, '3.20.20.140-FF-000136', NULL, 'Predicted metal-dependent hydrolase of the TIM-barrel fold', 297, NULL, NULL, 219365),
(219366, '1.20.1050.10-FF-000053', NULL, 'Glutathione S-transferase P', 108, NULL, NULL, 219366),
(219367, '1.20.1530.20-FF-000025', NULL, 'Cation/H(+) antiporter 28', 407, NULL, NULL, 219367),
(219368, '1.20.5.2050-FF-000001', NULL, 'Transcription factor with AP2 domain(S)', 70, NULL, NULL, 219368),
(219369, '3.30.505.10-FF-000242', NULL, NULL, 70, NULL, NULL, 219369),
(219370, '2.60.120.10-FF-000463', NULL, 'Cupin-like_domain_containing_protein_-_putative', 119, NULL, NULL, 219370),
(219371, '3.30.50.10-FF-000078', NULL, 'Nuclear Hormone Receptor family', 96, NULL, NULL, 219371),
(219372, '1.10.442.10-FF-000006', NULL, NULL, 129, NULL, NULL, 219372),
(219373, '2.40.10.10-FF-000673', NULL, NULL, 251, NULL, NULL, 219373),
(219374, '3.40.50.410-FF-000067', NULL, 'Integrin alpha M', 153, NULL, NULL, 219374),
(219375, '3.40.50.12240-FF-000011', NULL, 'Uncharacterized protein', 203, NULL, NULL, 219375),
(219376, '1.25.40.10-FF-000403', NULL, 'General transcriptional repressor, putative', 238, NULL, NULL, 219376),
(219377, '1.20.58.1880-FF-000006', NULL, 'Protein ALWAYS EARLY 3 isoform A', 97, NULL, NULL, 219377),
(219378, '1.20.140.150-FF-000077', NULL, 'Germ cell-specific gene 1 protein', 191, NULL, NULL, 219378),
(219379, '2.130.10.10-FF-001124', NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', 334, NULL, NULL, 219379),
(219380, '3.40.50.150-FF-001124', NULL, NULL, 178, NULL, NULL, 219380),
(219381, '3.40.50.1000-FF-000142', NULL, 'Similar to FCP1-like phosphatase', 175, NULL, NULL, 219381),
(219382, '3.30.530.20-FF-000016', NULL, 'StAR-related lipid transfer protein 7, mitochondrial', 204, NULL, NULL, 219382),
(219383, '1.10.630.10-FF-000595', NULL, 'Os05g0200400 protein', 280, NULL, NULL, 219383); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(219384, '3.40.50.300-FF-003075', NULL, 'Toxin resistance protein, putative', 189, NULL, NULL, 219384),
(219385, '3.30.40.10-FF-001893', NULL, 'Uncharacterized protein', 74, NULL, NULL, 219385),
(219386, '3.30.830.10-FF-000290', NULL, 'Uncharacterized protein', 153, NULL, NULL, 219386),
(219387, '3.40.50.80-FF-000020', NULL, 'Dual oxidase 1', 182, NULL, NULL, 219387),
(219388, '1.10.510.10-FF-002093', NULL, NULL, 88, NULL, NULL, 219388),
(219389, '3.40.1410.10-FF-000002', NULL, 'Chorismate pyruvate-lyase', 164, NULL, NULL, 219389),
(219390, '1.10.630.10-FF-000123', NULL, 'Cytochrome P450, family 702, subfamily A, polypeptide 2', 442, NULL, NULL, 219390),
(219391, '1.10.10.60-FF-000596', NULL, 'Putative DNAj-like protein', 61, NULL, NULL, 219391),
(219392, '3.30.160.60-FF-002214', NULL, 'zinc finger protein 34 isoform X2', 34, NULL, NULL, 219392),
(219393, '2.30.29.30-FF-001386', NULL, 'BEACH domain-containing protein lvsE', 120, NULL, NULL, 219393),
(219394, '3.80.10.10-FF-001675', NULL, 'Uncharacterized protein', 291, NULL, NULL, 219394),
(219395, '3.80.10.10-FF-001203', NULL, 'Hypothetical_protein_-_conserved', 158, NULL, NULL, 219395),
(219396, '2.60.40.150-FF-000008', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 169, NULL, NULL, 219396),
(219397, '3.90.1290.10-FF-000070', NULL, 'Uncharacterized protein', 163, NULL, NULL, 219397),
(219398, '1.10.238.10-FF-000526', NULL, 'Uncharacterized protein', 75, NULL, NULL, 219398),
(219399, '3.30.40.10-FF-001454', NULL, 'Uncharacterized protein', 49, NULL, NULL, 219399),
(219400, '3.10.20.90-FF-000781', NULL, 'Predicted protein', 95, NULL, NULL, 219400),
(219401, '3.40.50.10610-FF-000005', NULL, 'Penicillin-binding protein activator LpoB', 149, NULL, NULL, 219401),
(219402, '1.10.238.10-FF-000043', NULL, 'Kv channel-interacting protein 1 isoform 2', 214, NULL, NULL, 219402),
(219403, '1.10.510.10-FF-002576', NULL, NULL, 236, NULL, NULL, 219403),
(219404, '1.20.120.540-FF-000004', NULL, 'Tetraspanin', 63, NULL, NULL, 219404),
(219405, '2.20.100.10-FF-000021', NULL, 'semaphorin-5B isoform X1', 56, NULL, NULL, 219405),
(219406, '3.40.30.10-FF-000559', NULL, 'DSBA oxidoreductase family protein', 212, NULL, NULL, 219406),
(219407, '1.10.510.10-FF-000968', NULL, 'Casein kinase I, putative', 415, NULL, NULL, 219407),
(219408, '3.30.110.20-FF-000024', NULL, 'Ribonucleases P/MRP protein subunit POP7', 93, NULL, NULL, 219408),
(219409, '3.30.40.10-FF-001937', NULL, 'Uncharacterized protein', 69, NULL, NULL, 219409),
(219410, '3.40.1190.20-FF-000178', NULL, 'Ribosomal protein L15', 349, NULL, NULL, 219410),
(219411, '3.40.30.10-FF-001178', NULL, 'Chromosome 1, whole genome shotgun sequence', 117, NULL, NULL, 219411),
(219412, '1.25.40.470-FF-000059', NULL, 'Intraflagellar transport protein 144', 179, NULL, NULL, 219412),
(219413, '2.10.25.10-FF-000686', NULL, 'Dumpy, isoform Z', 39, NULL, NULL, 219413),
(219414, '1.10.510.10-FF-001587', NULL, 'AGC family protein kinase', 198, NULL, NULL, 219414),
(219415, '3.30.750.24-FF-000077', NULL, 'Anti-sigma factor antagonist', 108, NULL, NULL, 219415),
(219416, '3.30.1130.10-FF-000016', NULL, '7,8-dihydroneopterin aldolase', 119, NULL, NULL, 219416),
(219417, '2.60.40.60-FF-001021', NULL, 'FAT atypical cadherin 2', 112, NULL, NULL, 219417),
(219418, '1.10.418.10-FF-000141', NULL, 'DNA (cytosine-5-)-methyltransferase 3 beta, duplicate b.2', 126, NULL, NULL, 219418),
(219419, '1.20.80.10-FF-000012', NULL, 'Myosin VIIA', 113, NULL, NULL, 219419),
(219420, '3.40.50.300-FF-004064', NULL, '5-methylcytosine-specific restriction enzyme B (EcoKMcrBC)', 180, NULL, NULL, 219420),
(219421, '1.25.40.10-FF-005193', NULL, 'Uncharacterized protein', 222, NULL, NULL, 219421),
(219422, '3.20.20.80-FF-000474', NULL, 'Arabinogalactan endo-beta-1,4-galactanase', 320, NULL, NULL, 219422),
(219423, '2.130.10.10-FF-003850', NULL, 'Uncharacterized protein', 289, NULL, NULL, 219423),
(219424, '2.160.20.10-FF-000319', NULL, 'Uncharacterized protein', 166, NULL, NULL, 219424),
(219425, '2.60.40.10-FF-001629', NULL, 'titin isoform X1', 100, NULL, NULL, 219425);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(219426, '1.20.1070.10-FF-002038', NULL, 'Novel 7 transmembrane receptor (Rhodopsin family)', 115, NULL, NULL, 219426),
(219427, '1.20.1250.20-FF-000487', NULL, 'monocarboxylate transporter 3', 224, NULL, NULL, 219427),
(219428, '1.25.40.10-FF-004574', NULL, 'Pentatricopeptide repeat-containing protein', 188, NULL, NULL, 219428),
(219429, '4.10.240.10-FF-000020', NULL, 'Maltose activator protein', 67, NULL, NULL, 219429),
(219430, '2.130.10.10-FF-000505', NULL, 'Blast:Protein LST8 homolog', 304, NULL, NULL, 219430),
(219431, '2.60.40.60-FF-000874', NULL, 'FAT atypical cadherin 3a', 70, NULL, NULL, 219431),
(219432, '1.20.20.10-FF-000036', NULL, 'Uncharacterized protein', 51, NULL, NULL, 219432),
(219433, '2.10.110.10-FF-000001', NULL, 'Cysteine and glycine-rich protein 1', 81, NULL, NULL, 219433),
(219434, '1.50.40.10-FF-000587', NULL, 'Uncharacterized protein', 208, NULL, NULL, 219434),
(219435, '3.30.70.330-FF-000510', NULL, 'protein elav isoform X1', 94, NULL, NULL, 219435),
(219436, '2.60.40.150-FF-000447', NULL, 'Type III restriction enzyme, res subunit family protein', 103, NULL, NULL, 219436),
(219437, '1.10.1200.80-FF-000004', NULL, 'tRNA-dihydrouridine synthase', 74, NULL, NULL, 219437),
(219438, '2.10.25.10-FF-001675', NULL, 'Uncharacterized protein', 44, NULL, NULL, 219438),
(219439, '3.40.190.10-FF-000670', NULL, 'Glutamate receptor ionotropic, kainate 1-like Protein', 75, NULL, NULL, 219439),
(219440, '3.20.20.70-FF-000145', NULL, 'tRNA-dihydrouridine(47) synthase [NAD(P)(+)]', 263, NULL, NULL, 219440),
(219441, '1.10.530.10-FF-000059', NULL, 'Uncharacterized protein', 121, NULL, NULL, 219441),
(219442, '3.30.200.60-FF-000015', NULL, 'Uncharacterized protein', 66, NULL, NULL, 219442),
(219443, '3.40.50.720-FF-001520', NULL, 'ThiF family protein', 265, NULL, NULL, 219443),
(219444, '2.60.120.260-FF-000438', NULL, 'Beta-galactosidase', 221, NULL, NULL, 219444),
(219445, '3.40.1160.10-FF-000038', NULL, 'Glutamate 5-kinase', 62, NULL, NULL, 219445),
(219446, '1.25.40.20-FF-001025', NULL, 'Kinase/ NEK', 142, NULL, NULL, 219446),
(219447, '1.25.10.10-FF-003448', NULL, 'Maestro heat-like repeat-containing protein family member 1', 230, NULL, NULL, 219447),
(219448, '3.40.50.2300-FF-000003', NULL, 'Glutamate receptor, ionotropic, AMPA 4', 208, NULL, NULL, 219448),
(219449, '3.10.100.10-FF-000076', NULL, 'C-type lectin domain family 19 member A', 148, NULL, NULL, 219449),
(219450, '1.20.1280.290-FF-000033', NULL, 'Bidirectional sugar transporter SWEET', 96, NULL, NULL, 219450),
(219451, '3.30.40.10-FF-000948', NULL, 'Uncharacterized protein, isoform C', 49, NULL, NULL, 219451),
(219452, '2.60.120.200-FF-000044', NULL, 'neural-cadherin isoform X1', 174, NULL, NULL, 219452),
(219453, '3.40.190.290-FF-000021', NULL, 'LysR family transcriptional regulator', 197, NULL, NULL, 219453),
(219454, '3.40.50.300-FF-001630', NULL, 'ATP synthase subunit beta', 270, NULL, NULL, 219454),
(219455, '3.90.550.10-FF-000248', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 256, NULL, NULL, 219455),
(219456, '3.80.10.10-FF-004429', NULL, 'Leucine-rich repeat receptor-like protein kinase PEPR1', 237, NULL, NULL, 219456),
(219457, '3.20.20.80-FF-000002', NULL, 'Glucan endo-1,3-beta-glucosidase 3', 322, NULL, NULL, 219457),
(219458, '3.40.50.2300-FF-001431', NULL, NULL, 137, NULL, NULL, 219458),
(219459, '3.40.50.1820-FF-001517', NULL, 'Abhydrolase domain-containing 15a', 150, NULL, NULL, 219459),
(219460, '3.30.200.20-FF-002240', NULL, NULL, 33, NULL, NULL, 219460),
(219461, '2.10.110.30-FF-000007', NULL, 'Uncharacterized protein', 44, NULL, NULL, 219461),
(219462, '1.25.40.10-FF-003629', NULL, 'Pentatricopeptide repeat-containing protein At5g62370', 157, NULL, NULL, 219462),
(219463, '2.130.10.10-FF-002905', NULL, 'Uncharacterized protein', 109, NULL, NULL, 219463),
(219464, '1.10.510.10-FF-002104', NULL, NULL, 146, NULL, NULL, 219464),
(219465, '3.30.160.60-FF-006059', NULL, NULL, 28, NULL, NULL, 219465),
(219466, '3.30.1550.10-FF-000008', NULL, 'Putative ribosomal protein L11', 72, NULL, NULL, 219466);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(219467, '2.40.33.10-FF-000029', NULL, 'Pyruvate kinase', 95, NULL, NULL, 219467),
(219468, '3.30.70.330-FF-001336', NULL, 'Ribosomal RNA-processing 7 homolog A', 113, NULL, NULL, 219468),
(219469, '1.10.20.10-FF-000340', NULL, NULL, 104, NULL, NULL, 219469),
(219470, '3.40.50.300-FF-008116', NULL, 'Uncharacterized protein', 107, NULL, NULL, 219470),
(219471, '2.70.150.10-FF-000136', NULL, 'Phospholipid-transporting ATPase', 47, NULL, NULL, 219471),
(219472, '3.40.30.10-FF-000722', NULL, 'Uncharacterized protein', 118, NULL, NULL, 219472),
(219473, '3.80.30.20-FF-000004', NULL, 'Radical SAM protein family', 194, NULL, NULL, 219473),
(219474, '1.10.1450.10-FF-000075', NULL, 'GM20924', 86, NULL, NULL, 219474),
(219475, '3.30.1600.10-FF-000024', NULL, 'DHS-like NAD/FAD-binding domain-containing protein', 152, NULL, NULL, 219475),
(219476, '1.25.10.10-FF-001520', NULL, 'Uncharacterized protein', 229, NULL, NULL, 219476),
(219477, '3.40.50.12550-FF-000008', NULL, 'Ubiquitin-conjugating enzyme E1', 231, NULL, NULL, 219477),
(219478, '3.30.160.60-FF-001697', NULL, 'zinc finger protein 623', 31, NULL, NULL, 219478),
(219479, '3.30.230.70-FF-000042', NULL, 'Putative exoribonuclease family protein', 302, NULL, NULL, 219479),
(219480, '2.60.450.20-FF-000013', NULL, 'T-complex protein 10c', 55, NULL, NULL, 219480),
(219481, '2.40.100.10-FF-000140', NULL, 'Uncharacterized protein', 215, NULL, NULL, 219481),
(219482, '1.10.8.60-FF-000437', NULL, 'ORC1-type DNA replication protein 7', 77, NULL, NULL, 219482),
(219483, '3.40.1380.20-FF-000041', NULL, 'Pyruvate kinase', 125, NULL, NULL, 219483),
(219484, '3.30.300.30-FF-000053', NULL, 'Putative siderophore biosysnthesis protein', 74, NULL, NULL, 219484),
(219485, '1.10.287.470-FF-000081', NULL, 'RND efflux system, membrane fusion protein CmeA', 67, NULL, NULL, 219485),
(219486, '3.40.50.300-FF-008246', NULL, 'Uncharacterized protein', 53, NULL, NULL, 219486),
(219487, '3.40.50.2000-FF-000133', NULL, 'UDP-glycosyltransferase 83A1', 254, NULL, NULL, 219487),
(219488, '1.10.390.10-FF-000087', NULL, 'Predicted protein', 136, NULL, NULL, 219488),
(219489, '2.40.50.140-FF-000052', NULL, 'DNA helicase', 85, NULL, NULL, 219489),
(219490, '2.40.420.20-FF-000055', NULL, 'Uncharacterized protein HI_0894', 110, NULL, NULL, 219490),
(219491, '3.40.50.720-FF-000901', NULL, '3-hydroxyacyl-CoA dehydrogenase', 189, NULL, NULL, 219491),
(219492, '3.40.50.300-FF-003884', NULL, 'Heparan SulphoTransferase', 275, NULL, NULL, 219492),
(219493, '1.10.150.550-FF-000004', NULL, NULL, 56, NULL, NULL, 219493),
(219494, '2.60.40.2440-FF-000002', NULL, 'Protein phosphatase 1 regulatory subunit 3E', 135, NULL, NULL, 219494),
(219495, '2.60.40.10-FF-005171', NULL, NULL, 94, NULL, NULL, 219495),
(219496, '3.80.10.10-FF-002029', NULL, 'Toll-like receptor 22', 101, NULL, NULL, 219496),
(219497, '3.10.100.10-FF-000429', NULL, NULL, 81, NULL, NULL, 219497),
(219498, '1.20.1560.10-FF-000131', NULL, 'Multidrug resistance protein', 280, NULL, NULL, 219498),
(219499, '3.10.280.10-FF-000032', NULL, 'Uncharacterized protein', 184, NULL, NULL, 219499),
(219500, '3.50.50.60-FF-000502', NULL, 'FAD dependent oxidoreductase', 199, NULL, NULL, 219500),
(219501, '3.40.50.300-FF-004373', NULL, 'Adenylyl-sulfate kinase', 208, NULL, NULL, 219501),
(219502, '3.40.50.1000-FF-000512', NULL, 'Calcium transporting rt-atpase', 182, NULL, NULL, 219502),
(219503, '1.10.510.10-FF-001957', NULL, 'Protein kinase, putative', 260, NULL, NULL, 219503),
(219504, '2.130.10.10-FF-000944', NULL, 'Ribosome assembly protein 4', 91, NULL, NULL, 219504),
(219505, '3.40.1810.10-FF-000083', NULL, NULL, 103, NULL, NULL, 219505),
(219506, '3.40.630.10-FF-000215', NULL, 'Succinyl-diaminopimelate desuccinylase', 117, NULL, NULL, 219506),
(219507, '1.25.40.20-FF-000732', NULL, 'GD22794', 69, NULL, NULL, 219507),
(219508, '2.40.70.10-FF-000311', NULL, 'Uncharacterized protein', 274, NULL, NULL, 219508),
(219509, '3.30.505.10-FF-000163', NULL, NULL, 105, NULL, NULL, 219509),
(219510, '2.40.10.10-FF-000302', NULL, NULL, 125, NULL, NULL, 219510);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(219511, '1.25.40.20-FF-000069', NULL, 'Glutaminase, isoform E', 93, NULL, NULL, 219511),
(219512, '1.20.1070.10-FF-000240', NULL, 'probable G-protein coupled receptor 88', 279, NULL, NULL, 219512),
(219513, '1.10.150.850-FF-000004', NULL, 'Transcription elongation factor SPT6', 93, NULL, NULL, 219513),
(219514, '2.40.50.140-FF-000361', NULL, '30S ribosomal protein S1', 81, NULL, NULL, 219514),
(219515, '3.40.50.980-FF-000058', NULL, 'Uncharacterized protein', 62, NULL, NULL, 219515),
(219516, '1.10.10.60-FF-000933', NULL, NULL, 70, NULL, NULL, 219516),
(219517, '3.30.200.20-FF-000262', NULL, 'cyclin-dependent kinase F-4-like', 83, NULL, NULL, 219517),
(219518, '1.10.10.60-FF-001113', NULL, NULL, 65, NULL, NULL, 219518),
(219519, '1.10.274.30-FF-000014', NULL, 'MORF4L2 isoform 4', 62, NULL, NULL, 219519),
(219520, '2.130.10.10-FF-002422', NULL, 'Paralyzed flagella protein 20', 71, NULL, NULL, 219520),
(219521, '1.10.240.10-FF-000003', NULL, 'Tryptophan--tRNA ligase, cytoplasmic', 118, NULL, NULL, 219521),
(219522, '1.10.10.10-FF-000542', NULL, 'MarR family transcriptional regulator', 157, NULL, NULL, 219522),
(219523, '2.130.10.10-FF-001933', NULL, 'WD repeat-containing protein 70', 326, NULL, NULL, 219523),
(219524, '1.10.10.900-FF-000001', NULL, 'SBDS, ribosome maturation factor', 73, NULL, NULL, 219524),
(219525, '1.10.10.790-FF-000029', NULL, 'Probable splicing factor 3A subunit 1', 68, NULL, NULL, 219525),
(219526, '2.60.120.10-FF-000816', NULL, 'Uncharacterized protein', 104, NULL, NULL, 219526),
(219527, '1.20.58.1300-FF-000001', NULL, '(3,5-dihydroxyphenyl)acetyl-CoA 1,2-dioxygenase', 144, NULL, NULL, 219527),
(219528, '1.25.10.10-FF-000694', NULL, 'Serine/threonine-protein kinase TOR', 368, NULL, NULL, 219528),
(219529, '4.10.80.160-FF-000006', NULL, 'Uncharacterized protein', 29, NULL, NULL, 219529),
(219530, '3.40.50.150-FF-000135', NULL, 'Arginine N-methyltransferase 2', 224, NULL, NULL, 219530),
(219531, '1.25.40.20-FF-000199', NULL, 'Espin like', 131, NULL, NULL, 219531),
(219532, '3.10.110.10-FF-000374', NULL, 'Histone acetyltransferase type B catalytic subunit', 110, NULL, NULL, 219532),
(219533, '1.20.120.720-FF-000053', NULL, 'Myosin-K heavy chain', 109, NULL, NULL, 219533),
(219534, '3.80.10.10-FF-001192', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 86, NULL, NULL, 219534),
(219535, '3.40.50.300-FF-000478', NULL, '3''-5'' DNA helicase', 186, NULL, NULL, 219535),
(219536, '1.10.510.10-FF-002913', NULL, NULL, 203, NULL, NULL, 219536),
(219537, '3.30.200.20-FF-001088', NULL, 'Kinase, CMGC CDK', 85, NULL, NULL, 219537),
(219538, '3.60.21.10-FF-000313', NULL, 'Calcineurin-like phosphoesterase family protein', 233, NULL, NULL, 219538),
(219539, '3.20.20.80-FF-000783', NULL, 'Uncharacterized protein', 204, NULL, NULL, 219539),
(219540, '2.60.40.10-FF-004226', NULL, NULL, 66, NULL, NULL, 219540),
(219541, '1.10.10.10-FF-001031', NULL, 'DNA-binding response regulator', 99, NULL, NULL, 219541),
(219542, '1.10.533.10-FF-000212', NULL, 'Predicted protein', 107, NULL, NULL, 219542),
(219543, '2.40.70.10-FF-000441', NULL, NULL, 96, NULL, NULL, 219543),
(219544, '1.10.10.1940-FF-000009', NULL, 'Metalloendopeptidase', 45, NULL, NULL, 219544),
(219545, '3.30.40.10-FF-002073', NULL, 'Uncharacterized protein', 87, NULL, NULL, 219545),
(219546, '3.40.50.2300-FF-000133', NULL, 'Glutamate ionotropic receptor NMDA type subunit 3A', 153, NULL, NULL, 219546),
(219547, '2.10.110.10-FF-000131', NULL, 'LIM domain-containing protein', 56, NULL, NULL, 219547),
(219548, '1.10.10.600-FF-000001', NULL, 'Fe-S assembly protein IscX', 66, NULL, NULL, 219548),
(219549, '1.10.10.10-FF-000851', NULL, 'MarR family transcriptional regulator', 137, NULL, NULL, 219549),
(219550, '3.40.50.150-FF-000505', NULL, 'Thiopurine S-methyltransferase', 217, NULL, NULL, 219550),
(219551, '3.40.720.10-FF-000144', NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase 2, short form', 180, NULL, NULL, 219551),
(219552, '3.10.450.50-FF-000057', NULL, 'Protein F17L21.10', 121, NULL, NULL, 219552);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(219553, '1.25.50.10-FF-000005', NULL, 'Aminopeptidase N', 330, NULL, NULL, 219553),
(219554, '1.25.40.10-FF-004102', NULL, 'Uncharacterized protein', 144, NULL, NULL, 219554),
(219555, '1.10.640.10-FF-000051', NULL, 'Peroxinectin, putative', 602, NULL, NULL, 219555),
(219556, '3.40.50.300-FF-002939', NULL, 'DBP6p protein', 203, NULL, NULL, 219556),
(219557, '2.30.31.10-FF-000025', NULL, 'Uncharacterized protein', 80, NULL, NULL, 219557),
(219558, '3.20.20.140-FF-000001', NULL, 'Dihydropyrimidinase like 3', 373, NULL, NULL, 219558),
(219559, '3.40.50.2300-FF-000442', NULL, 'Glutamate receptor', 102, NULL, NULL, 219559),
(219560, '3.30.160.60-FF-002686', NULL, 'Zinc finger protein 555', 30, NULL, NULL, 219560),
(219561, '1.20.950.20-FF-000002', NULL, 'Formate dehydrogenase cytochrome b556 subunit', 211, NULL, NULL, 219561),
(219562, '1.20.58.390-FF-000050', NULL, 'glycine receptor subunit alpha-4', 134, NULL, NULL, 219562),
(219563, '3.30.40.10-FF-001584', NULL, 'RING-H2 zinc finger, putative', 86, NULL, NULL, 219563),
(219564, '2.30.39.10-FF-000054', NULL, 'Serpin peptidase inhibitor, clade C (antithrombin), member 1', 149, NULL, NULL, 219564),
(219565, '3.40.850.10-FF-000209', NULL, 'kinesin-4-like', 375, NULL, NULL, 219565),
(219566, '2.10.25.10-FF-000377', NULL, 'Delta/notch like EGF repeat containing', 38, NULL, NULL, 219566),
(219567, '3.40.50.720-FF-001992', NULL, 'UPF0659 protein C216.03', 238, NULL, NULL, 219567),
(219568, '2.20.70.10-FF-000121', NULL, 'Transcription elongation regulator 1', 73, NULL, NULL, 219568),
(219569, '3.40.532.10-FF-000004', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 223, NULL, NULL, 219569),
(219570, '3.40.630.10-FF-000154', NULL, 'Peptidase M20A family', 235, NULL, NULL, 219570),
(219571, '2.170.140.10-FF-000005', NULL, 'Acidic mammalian chitinase', 72, NULL, NULL, 219571),
(219572, '3.40.50.300-FF-000702', NULL, 'ABC transporter (Adp1)', 238, NULL, NULL, 219572),
(219573, '3.40.50.300-FF-008555', NULL, 'Predicted protein', 206, NULL, NULL, 219573),
(219574, '1.25.40.10-FF-001831', NULL, 'Uncharacterized protein', 143, NULL, NULL, 219574),
(219575, '2.130.10.10-FF-005295', NULL, 'Uncharacterized protein', 220, NULL, NULL, 219575),
(219576, '2.60.40.150-FF-000317', NULL, 'Protein CBG14248', 123, NULL, NULL, 219576),
(219577, '3.40.1350.100-FF-000004', NULL, 'Apicoplast TIC22 protein', 114, NULL, NULL, 219577),
(219578, '3.50.50.60-FF-001019', NULL, 'Rab proteins geranylgeranyltransferase component A', 144, NULL, NULL, 219578),
(219579, '1.25.40.10-FF-002320', NULL, 'Uncharacterized protein', 94, NULL, NULL, 219579),
(219580, '2.60.40.60-FF-000065', NULL, 'FAT atypical cadherin 1', 107, NULL, NULL, 219580),
(219581, '1.10.510.10-FF-003402', NULL, NULL, 303, NULL, NULL, 219581),
(219582, '3.30.710.10-FF-000224', NULL, 'Glycoprotein FP21, putative', 158, NULL, NULL, 219582),
(219583, '3.20.20.120-FF-000006', NULL, 'o-succinylbenzoate synthase', 198, NULL, NULL, 219583),
(219584, '3.40.50.1440-FF-000060', NULL, 'Tubulin nucleotide-binding domain-like protein', 335, NULL, NULL, 219584),
(219585, '3.90.290.10-FF-000020', NULL, 'Fibrillin-1', 70, NULL, NULL, 219585),
(219586, '3.40.50.150-FF-000152', NULL, 'S-adenosyl-L-methionine-dependent methyltransferase', 308, NULL, NULL, 219586),
(219587, '1.20.1740.10-FF-000196', NULL, 'Uncharacterized protein', 198, NULL, NULL, 219587),
(219588, '1.20.1720.10-FF-000003', NULL, 'Multidrug resistance protein MdtL', 372, NULL, NULL, 219588),
(219589, '3.30.2130.30-FF-000039', NULL, 'Uncharacterized protein', 70, NULL, NULL, 219589),
(219590, '3.80.10.10-FF-000231', NULL, 'Leucine-rich repeat-containing protein 73 isoform X1', 137, NULL, NULL, 219590),
(219591, '2.60.40.60-FF-000857', NULL, 'Cadherin-2', 44, NULL, NULL, 219591),
(219592, '2.70.170.10-FF-000166', NULL, 'Protein CBR-DEG-3', 128, NULL, NULL, 219592),
(219593, '2.60.40.10-FF-002309', NULL, 'tyrosine-protein phosphatase 69D isoform X1', 110, NULL, NULL, 219593),
(219594, '3.30.160.60-FF-000432', NULL, 'zinc finger protein Gfi-1b isoform X1', 28, NULL, NULL, 219594);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(219595, '1.20.58.70-FF-000107', NULL, 'Syntaxin', 225, NULL, NULL, 219595),
(219596, '3.30.470.20-FF-000045', NULL, 'Biotin carboxylase', 248, NULL, NULL, 219596),
(219597, '3.30.70.2040-FF-000001', NULL, NULL, 78, NULL, NULL, 219597),
(219598, '3.40.190.10-FF-000653', NULL, 'Peptide ABC transporter, peptide-binding protein', 232, NULL, NULL, 219598),
(219599, '3.30.540.10-FF-000071', NULL, 'Inositol polyphosphate 1-phosphatase', 174, NULL, NULL, 219599),
(219600, '3.10.100.10-FF-000059', NULL, 'Regenerating islet-derived 1', 144, NULL, NULL, 219600),
(219601, '3.50.50.60-FF-000165', NULL, 'Pyridine nucleotide-disulfide oxidoreductase domain-containing protein 1', 106, NULL, NULL, 219601),
(219602, '1.10.400.10-FF-000005', NULL, 'Extra-large guanine nucleotide-binding protein 3', 151, NULL, NULL, 219602),
(219603, '3.30.40.10-FF-000965', NULL, 'RBR-type E3 ubiquitin transferase', 86, NULL, NULL, 219603),
(219604, '2.10.25.10-FF-001658', NULL, 'AGAP000117-PA', 46, NULL, NULL, 219604),
(219605, '4.10.240.10-FF-000003', NULL, 'C6 transcription factor (Leu3)', 70, NULL, NULL, 219605),
(219606, '3.90.230.10-FF-000011', NULL, 'Methionine aminopeptidase', 283, NULL, NULL, 219606),
(219607, '1.20.1160.11-FF-000017', NULL, NULL, 62, NULL, NULL, 219607),
(219608, '2.60.40.420-FF-000112', NULL, 'Laccase B', 189, NULL, NULL, 219608),
(219609, '3.30.230.10-FF-000070', NULL, 'mismatch repair endonuclease PMS2', 138, NULL, NULL, 219609),
(219610, '1.20.1300.10-FF-000011', NULL, 'Succinate dehydrogenase cytochrome b560 subunit', 139, NULL, NULL, 219610),
(219611, '3.90.190.20-FF-000061', NULL, 'Folylpolyglutamate synthase / 7,8-dihydropteroate reductase / dihydropteroate synthase', 134, NULL, NULL, 219611),
(219612, '3.40.309.10-FF-000025', NULL, 'Aldehyde dehydrogenase', 198, NULL, NULL, 219612),
(219613, '3.30.70.330-FF-001319', NULL, 'RNA recognition motif domain containing protein', 109, NULL, NULL, 219613),
(219614, '3.30.420.10-FF-000005', NULL, 'CCR4-NOT transcription complex subunit 7', 252, NULL, NULL, 219614),
(219615, '3.30.200.20-FF-000571', NULL, 'Methylthioribose kinase', 119, NULL, NULL, 219615),
(219616, '2.130.10.10-FF-004659', NULL, 'Katanin p80 WD40 repeat-containing subunit B1 homolog', 188, NULL, NULL, 219616),
(219617, '3.40.50.2300-FF-001414', NULL, NULL, 67, NULL, NULL, 219617),
(219618, '2.20.90.10-FF-000004', NULL, 'Vitellogenin A2', 170, NULL, NULL, 219618),
(219619, '3.30.160.60-FF-004131', NULL, NULL, 69, NULL, NULL, 219619),
(219620, '3.30.200.20-FF-001560', NULL, 'Uncharacterized protein', 98, NULL, NULL, 219620),
(219621, '1.20.930.80-FF-000013', NULL, 'DNA primase large subunit', 257, NULL, NULL, 219621),
(219622, '2.40.20.10-FF-000128', NULL, 'Uncharacterized protein', 44, NULL, NULL, 219622),
(219623, '3.30.40.10-FF-002090', NULL, 'Uncharacterized RING finger protein P8B7.15c', 84, NULL, NULL, 219623),
(219624, '3.40.1110.10-FF-000327', NULL, NULL, 160, NULL, NULL, 219624),
(219625, '1.10.510.10-FF-004358', NULL, NULL, 112, NULL, NULL, 219625),
(219626, '3.40.50.300-FF-002586', NULL, 'Putative abc transporter c family member', 102, NULL, NULL, 219626),
(219627, '3.40.710.10-FF-000188', NULL, 'D-alanyl-D-alanine carboxypeptidase', 301, NULL, NULL, 219627),
(219628, '2.130.10.10-FF-000635', NULL, 'Probable vacuolar protein sorting-associated protein 16 homolog', 220, NULL, NULL, 219628),
(219629, '2.60.40.1170-FF-000054', NULL, 'General transcription factor IIA, 1-like', 148, NULL, NULL, 219629),
(219630, '1.10.275.30-FF-000005', NULL, 'ATP-dependent DNA helicase', 112, NULL, NULL, 219630),
(219631, '3.40.30.10-FF-000689', NULL, 'Protein disulfide isomerase family A member 2', 115, NULL, NULL, 219631),
(219632, '2.60.120.10-FF-000272', NULL, 'Mannose-6-phosphate isomerase', 82, NULL, NULL, 219632),
(219633, '4.10.240.30-FF-000009', NULL, 'Uncharacterized protein', 31, NULL, NULL, 219633),
(219634, '1.20.1270.370-FF-000004', NULL, '(R)-phenyllactyl-CoA dehydratase beta subunit', 85, NULL, NULL, 219634),
(219635, '3.40.50.150-FF-001433', NULL, NULL, 149, NULL, NULL, 219635);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(219636, '3.40.50.1100-FF-000216', NULL, 'Uncharacterized protein', 64, NULL, NULL, 219636),
(219637, '3.90.228.10-FF-000067', NULL, 'Poly [ADP-ribose] polymerase', 81, NULL, NULL, 219637),
(219638, '1.20.120.1240-FF-000081', NULL, 'Dynamin-1-like protein, putative', 85, NULL, NULL, 219638),
(219639, '2.60.40.60-FF-000082', NULL, 'Protocadherin 7b', 120, NULL, NULL, 219639),
(219640, '2.30.30.40-FF-000369', NULL, 'Scaffold protein CheW associated with MCPs of classes 40H and 40+24H', 60, NULL, NULL, 219640),
(219641, '3.30.160.60-FF-000871', NULL, 'myoneurin isoform X1', 82, NULL, NULL, 219641),
(219642, '2.130.10.10-FF-005278', NULL, 'WD-repeat protein, putative', 236, NULL, NULL, 219642),
(219643, '3.40.50.300-FF-002147', NULL, 'Putative ATP-dependent RNA helicase', 95, NULL, NULL, 219643),
(219644, '2.130.10.10-FF-003041', NULL, 'Putative wd40 domain protein', 150, NULL, NULL, 219644),
(219645, '2.170.270.10-FF-000222', NULL, 'Uncharacterized protein', 107, NULL, NULL, 219645),
(219646, '3.40.640.10-FF-000082', NULL, 'Phosphoserine aminotransferase', 273, NULL, NULL, 219646),
(219647, '1.10.340.30-FF-000045', NULL, 'DNA-3-methyladenine glycosylase, putative', 116, NULL, NULL, 219647),
(219648, '1.25.40.10-FF-000050', NULL, 'Thioredoxin 2', 88, NULL, NULL, 219648),
(219649, '1.20.1110.10-FF-000209', NULL, NULL, 77, NULL, NULL, 219649),
(219650, '3.30.200.20-FF-000132', NULL, 'Ribosomal protein S6 kinase', 111, NULL, NULL, 219650),
(219651, '3.30.70.20-FF-000133', NULL, NULL, 49, NULL, NULL, 219651),
(219652, '3.90.70.10-FF-000419', NULL, 'Uncharacterized protein', 378, NULL, NULL, 219652),
(219653, '1.10.3260.10-FF-000049', NULL, 'Uncharacterized protein', 110, NULL, NULL, 219653),
(219654, '1.25.40.180-FF-000096', NULL, 'Pre-mRNA-splicing factor CWC22, putative', 290, NULL, NULL, 219654),
(219655, '3.30.2160.10-FF-000018', NULL, 'Ubiquitin-protein ligase, putative', 57, NULL, NULL, 219655),
(219656, '1.10.510.10-FF-002076', NULL, NULL, 75, NULL, NULL, 219656),
(219657, '3.30.310.50-FF-000020', NULL, 'Putative phosphomannomutase', 111, NULL, NULL, 219657),
(219658, '1.10.510.10-FF-000176', NULL, 'Muscle, skeletal receptor tyrosine protein kinase', 202, NULL, NULL, 219658),
(219659, '1.10.10.1180-FF-000001', NULL, 'inner nuclear membrane protein Man1', 98, NULL, NULL, 219659),
(219660, '3.40.50.300-FF-003092', NULL, 'GTP-binding protein, Ras family protein', 175, NULL, NULL, 219660),
(219661, '3.30.1330.20-FF-000017', NULL, 'Cell division protein FtsZ', 111, NULL, NULL, 219661),
(219662, '2.40.30.10-FF-000056', NULL, 'NADPH oxidase 5', 89, NULL, NULL, 219662),
(219663, '3.40.390.10-FF-000281', NULL, NULL, 114, NULL, NULL, 219663),
(219664, '2.130.10.10-FF-004530', NULL, 'Cilia- and flagella-associated protein 44', 228, NULL, NULL, 219664),
(219665, '1.25.40.470-FF-000076', NULL, 'Uncharacterized protein', 123, NULL, NULL, 219665),
(219666, '3.40.50.970-FF-000190', NULL, 'Uncharacterized protein', 62, NULL, NULL, 219666),
(219667, '3.30.160.60-FF-006368', NULL, NULL, 31, NULL, NULL, 219667),
(219668, '2.60.40.790-FF-000144', NULL, NULL, 121, NULL, NULL, 219668),
(219669, '3.30.2380.10-FF-000001', NULL, 'EKC/KEOPS complex subunit TPRKB', 175, NULL, NULL, 219669),
(219670, '1.20.1560.10-FF-000468', NULL, 'ABC transporter D family member 2', 321, NULL, NULL, 219670),
(219671, '1.25.40.10-FF-001168', NULL, 'Putative pentatricopeptide repeat-containing protein mitochondrial', 121, NULL, NULL, 219671),
(219672, '3.30.70.100-FF-000087', NULL, 'CTP synthase', 93, NULL, NULL, 219672),
(219673, '2.70.170.10-FF-000019', NULL, 'Putative acetylcholine receptor subunit alpha', 219, NULL, NULL, 219673),
(219674, '2.60.220.50-FF-000089', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 2', 213, NULL, NULL, 219674),
(219675, '3.80.10.10-FF-001984', NULL, 'Predicted protein', 95, NULL, NULL, 219675),
(219676, '2.40.50.140-FF-000714', NULL, NULL, 92, NULL, NULL, 219676),
(219677, '1.10.287.1700-FF-000001', NULL, 'Translocation protein in type III secretion', 154, NULL, NULL, 219677),
(219678, '2.30.110.50-FF-000003', NULL, 'Type VI secretion protein ImpA', 164, NULL, NULL, 219678);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(219679, '3.40.50.150-FF-000635', NULL, 'probable methyltransferase PMT24', 158, NULL, NULL, 219679),
(219680, '3.40.140.10-FF-000279', NULL, 'Uncharacterized protein', 60, NULL, NULL, 219680),
(219681, '1.25.40.10-FF-003938', NULL, 'Predicted protein', 278, NULL, NULL, 219681),
(219682, '3.30.930.10-FF-000235', NULL, 'Os02g0139600 protein', 198, NULL, NULL, 219682),
(219683, '3.30.870.10-FF-000134', NULL, 'Mitochondrial cardiolipin hydrolase', 171, NULL, NULL, 219683),
(219684, '3.40.50.1460-FF-000066', NULL, 'Uncharacterized protein', 282, NULL, NULL, 219684),
(219685, '3.30.200.20-FF-000615', NULL, 'Non-specific serine/threonine protein kinase', 18, NULL, NULL, 219685),
(219686, '3.40.50.300-FF-005020', NULL, 'Predicted protein', 100, NULL, NULL, 219686),
(219687, '3.90.180.10-FF-000130', NULL, 'Uncharacterized protein', 56, NULL, NULL, 219687),
(219688, '1.10.510.10-FF-004021', NULL, NULL, 121, NULL, NULL, 219688),
(219689, '3.40.50.1820-FF-001826', NULL, 'Uncharacterized protein', 94, NULL, NULL, 219689),
(219690, '3.60.20.40-FF-000027', NULL, 'Gamma-glutamyltransferase 5', 64, NULL, NULL, 219690),
(219691, '3.30.465.10-FF-000075', NULL, 'Magnesium and cobalt efflux protein', 87, NULL, NULL, 219691),
(219692, '1.20.1560.10-FF-000440', NULL, 'Uncharacterized protein', 108, NULL, NULL, 219692),
(219693, '2.10.70.10-FF-000245', NULL, 'Mannan-binding lectin serine peptidase 2', 74, NULL, NULL, 219693),
(219694, '3.30.559.10-FF-000107', NULL, 'Chat-3-HEXEN-1-OL ACETYLTRANSFERASE', 220, NULL, NULL, 219694),
(219695, '3.40.50.720-FF-001649', NULL, '3-beta hydroxysteroid dehydrogenase/isomerase family protein, putative (AFU_orthologue AFUA_1G06450)', 363, NULL, NULL, 219695),
(219696, '2.60.120.10-FF-000833', NULL, 'Putative AraC-family transcriptional regulator', 87, NULL, NULL, 219696),
(219697, '1.10.720.60-FF-000004', NULL, 'Enolase-phosphatase E1', 83, NULL, NULL, 219697),
(219698, '3.40.50.300-FF-006638', NULL, 'Iron (II) transporter (FeoB-2) part 2, conjectural, authentic frameshift', 90, NULL, NULL, 219698),
(219699, '1.20.142.10-FF-000032', NULL, 'Poly [ADP-ribose] polymerase', 158, NULL, NULL, 219699),
(219700, '1.20.58.60-FF-000430', NULL, 'Desmoplakin a', 225, NULL, NULL, 219700),
(219701, '1.10.510.10-FF-004330', NULL, NULL, 136, NULL, NULL, 219701),
(219702, '2.110.10.10-FF-000006', NULL, 'Proteoglycan 4', 212, NULL, NULL, 219702),
(219703, '3.30.750.24-FF-000105', NULL, 'Uncharacterized protein', 112, NULL, NULL, 219703),
(219704, '3.90.550.10-FF-000411', NULL, 'Putative xyloglucan 6-xylosyltransferase 5', 176, NULL, NULL, 219704),
(219705, '3.30.390.10-FF-000024', NULL, 'Chloromuconate cycloisomerase', 90, NULL, NULL, 219705),
(219706, '3.30.160.60-FF-004923', NULL, NULL, 97, NULL, NULL, 219706),
(219707, '1.10.10.10-FF-000412', NULL, 'Double-stranded RNA-specific adenosine deaminase', 81, NULL, NULL, 219707),
(219708, '1.20.1070.10-FF-001993', NULL, 'Uncharacterized protein', 152, NULL, NULL, 219708),
(219709, '1.20.920.20-FF-000045', NULL, 'Dynein heavy chain', 341, NULL, NULL, 219709),
(219710, '1.10.10.60-FF-001130', NULL, NULL, 63, NULL, NULL, 219710),
(219711, '2.60.40.790-FF-000161', NULL, NULL, 85, NULL, NULL, 219711),
(219712, '1.10.1070.11-FF-000007', NULL, 'Serine/threonine-protein kinase TOR', 180, NULL, NULL, 219712),
(219713, '2.120.10.80-FF-000044', NULL, 'Kelch-like family member 21', 292, NULL, NULL, 219713),
(219714, '1.10.3710.10-FF-000011', NULL, 'ATPase WRNIP1-like Protein', 67, NULL, NULL, 219714),
(219715, '2.130.10.10-FF-002861', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', 315, NULL, NULL, 219715),
(219716, '2.60.120.200-FF-000027', NULL, 'Transmembrane agrin', 182, NULL, NULL, 219716),
(219717, '3.90.70.10-FF-000262', NULL, 'Putative calpain-like cysteine peptidase', 125, NULL, NULL, 219717),
(219718, '3.90.180.10-FF-000158', NULL, 'Dehydrogenase orsE', 145, NULL, NULL, 219718),
(219719, '1.20.20.10-FF-000019', NULL, 'ATP synthase subunit c', 68, NULL, NULL, 219719),
(219720, '3.30.160.60-FF-001388', NULL, 'Zinc finger and AT-hook domain containing', 33, NULL, NULL, 219720);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(219721, '2.130.10.10-FF-003350', NULL, 'Cell surface protein', 181, NULL, NULL, 219721),
(219722, '3.20.20.300-FF-000055', NULL, NULL, 129, NULL, NULL, 219722),
(219723, '3.10.430.100-FF-000022', NULL, 'Predicted protein', 71, NULL, NULL, 219723),
(219724, '2.130.10.10-FF-002552', NULL, 'Leucine-rich repeat serine/threonine-protein kinase 2', 263, NULL, NULL, 219724),
(219725, '3.40.50.300-FF-001967', NULL, 'Protein translocase subunit SecA 2', 204, NULL, NULL, 219725),
(219726, '2.30.39.10-FF-000037', NULL, 'Os11g0224800 protein', 143, NULL, NULL, 219726),
(219727, '3.30.70.2280-FF-000005', NULL, 'Uncharacterized protein', 91, NULL, NULL, 219727),
(219728, '3.30.365.10-FF-000039', NULL, 'Aldehyde oxidase and xanthine dehydrogenase, molybdopterin binding', 129, NULL, NULL, 219728),
(219729, '2.60.40.2840-FF-000015', NULL, 'E3 ubiquitin-protein ligase HECW1', 105, NULL, NULL, 219729),
(219730, '3.30.70.20-FF-000003', NULL, 'Dimethyl sulfoxide reductase subunit B', 53, NULL, NULL, 219730),
(219731, '3.40.50.150-FF-000944', NULL, NULL, 214, NULL, NULL, 219731),
(219732, '3.30.160.60-FF-002669', NULL, 'Uncharacterized protein', 29, NULL, NULL, 219732),
(219733, '1.20.120.550-FF-000024', NULL, 'Uncharacterized protein', 108, NULL, NULL, 219733),
(219734, '4.10.400.10-FF-000038', NULL, 'Very low density lipoprotein receptor', 45, NULL, NULL, 219734),
(219735, '1.25.40.20-FF-001497', NULL, 'Predicted protein', 67, NULL, NULL, 219735),
(219736, '1.20.1300.10-FF-000039', NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', 95, NULL, NULL, 219736),
(219737, '1.10.12.70-FF-000013', NULL, NULL, 69, NULL, NULL, 219737),
(219738, '3.90.550.10-FF-000187', NULL, 'Glycosyltransferase YibD', 199, NULL, NULL, 219738),
(219739, '1.10.510.10-FF-002121', NULL, NULL, 114, NULL, NULL, 219739),
(219740, '4.10.400.10-FF-000347', NULL, 'Uncharacterized protein', 35, NULL, NULL, 219740),
(219741, '3.40.50.1820-FF-001034', NULL, 'Uncharacterized protein', 152, NULL, NULL, 219741),
(219742, '3.30.200.20-FF-002369', NULL, NULL, 79, NULL, NULL, 219742),
(219743, '3.75.10.10-FF-000013', NULL, 'N(G),N(G)-dimethylarginine dimethylaminohydrolase', 254, NULL, NULL, 219743),
(219744, '1.20.120.220-FF-000009', NULL, 'ATP synthase subunit a', 163, NULL, NULL, 219744),
(219745, '3.40.1360.10-FF-000019', NULL, 'Meiosis-specific protein SPO11', 226, NULL, NULL, 219745),
(219746, '3.30.160.60-FF-004794', NULL, NULL, 35, NULL, NULL, 219746),
(219747, '1.10.287.80-FF-000014', NULL, 'F0F1 ATP synthase subunit gamma', 59, NULL, NULL, 219747),
(219748, '1.20.120.1080-FF-000038', NULL, 'DEAH-box RNA helicase (Dhr1), putative', 183, NULL, NULL, 219748),
(219749, '2.130.10.10-FF-001141', NULL, 'Related to UTP7-nucleolar protein, component of the small subunit processome', 173, NULL, NULL, 219749),
(219750, '1.25.10.10-FF-001992', NULL, 'AEL006Wp', 529, NULL, NULL, 219750),
(219751, '2.130.10.10-FF-003069', NULL, 'Uncharacterized protein', 127, NULL, NULL, 219751),
(219752, '3.40.50.300-FF-006301', NULL, 'DNA helicase', 181, NULL, NULL, 219752),
(219753, '3.30.160.60-FF-000769', NULL, 'Early growth response 2b', 45, NULL, NULL, 219753),
(219754, '1.20.1250.20-FF-001976', NULL, 'Antibiotic efflux protein', 397, NULL, NULL, 219754),
(219755, '2.70.170.10-FF-000149', NULL, 'Nicotinic acetylcholine receptor subunit', 219, NULL, NULL, 219755),
(219756, '1.20.1070.10-FF-001684', NULL, 'Uncharacterized protein', 114, NULL, NULL, 219756),
(219757, '3.90.550.10-FF-000720', NULL, 'Uncharacterized protein', 383, NULL, NULL, 219757),
(219758, '1.20.58.60-FF-000767', NULL, 'Uncharacterized protein', 253, NULL, NULL, 219758),
(219759, '3.90.550.10-FF-000748', NULL, 'Uncharacterized protein', 56, NULL, NULL, 219759),
(219760, '1.20.1050.10-FF-000238', NULL, 'Uncharacterized protein', 75, NULL, NULL, 219760),
(219761, '1.10.630.10-FF-000606', NULL, 'Uncharacterized protein', 261, NULL, NULL, 219761),
(219762, '3.40.50.300-FF-006329', NULL, 'Spermatogenesis-associated protein 5-like protein 1', 93, NULL, NULL, 219762),
(219763, '3.90.950.10-FF-000015', NULL, '7-methyl-GTP pyrophosphatase', 191, NULL, NULL, 219763);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(219764, '3.40.50.1220-FF-000106', NULL, 'Putative pyruvate decarboxylase C3G9.11c', 161, NULL, NULL, 219764),
(219765, '3.40.50.300-FF-002456', NULL, 'Small GTP-binding protein, putative', 195, NULL, NULL, 219765),
(219766, '3.40.800.20-FF-000035', NULL, 'Histone deacetylase 17', 111, NULL, NULL, 219766),
(219767, '1.20.120.1760-FF-000028', NULL, 'Probable CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase pgsA2', 187, NULL, NULL, 219767),
(219768, '1.20.120.980-FF-000035', NULL, 'Clan SC, family S28, unassigned serine peptidase', 125, NULL, NULL, 219768),
(219769, '2.130.10.10-FF-001916', NULL, 'GG12447', 168, NULL, NULL, 219769),
(219770, '1.25.10.10-FF-000222', NULL, 'Importin subunit alpha', 440, NULL, NULL, 219770),
(219771, '3.40.30.10-FF-001195', NULL, 'Uncharacterized protein', 87, NULL, NULL, 219771),
(219772, '3.40.50.800-FF-000066', NULL, 'Predicted protein', 119, NULL, NULL, 219772),
(219773, '1.20.58.180-FF-000003', NULL, NULL, 80, NULL, NULL, 219773),
(219774, '1.10.238.10-FF-000026', NULL, 'Epidermal growth factor receptor pathway substrate 15-like 1', 99, NULL, NULL, 219774),
(219775, '2.120.10.30-FF-000271', NULL, 'Tyrosine-protein kinase receptor', 289, NULL, NULL, 219775),
(219776, '1.20.200.10-FF-000021', NULL, 'Histidine--tRNA ligase cytoplasmic', 179, NULL, NULL, 219776),
(219777, '1.10.10.10-FF-001823', NULL, 'Chromosome 1, whole genome shotgun sequence', 108, NULL, NULL, 219777),
(219778, '3.30.70.1230-FF-000269', NULL, 'Guanylyl cyclase 3', 127, NULL, NULL, 219778),
(219779, '2.170.120.20-FF-000012', NULL, '50S ribosomal protein L25', 92, NULL, NULL, 219779),
(219780, '3.40.50.1010-FF-000280', NULL, NULL, 49, NULL, NULL, 219780),
(219781, '3.30.230.70-FF-000172', NULL, 'Uncharacterized protein', 84, NULL, NULL, 219781),
(219782, '1.10.390.10-FF-000115', NULL, 'Uncharacterized protein', 142, NULL, NULL, 219782),
(219783, '3.30.70.330-FF-000038', NULL, 'Nucleolysin tiar isoform 1', 94, NULL, NULL, 219783),
(219784, '2.130.10.10-FF-002405', NULL, 'Katanin p80 WD40 repeat-containing subunit B1', 135, NULL, NULL, 219784),
(219785, '3.30.342.10-FF-000003', NULL, 'DNA polymerase', 166, NULL, NULL, 219785),
(219786, '2.130.10.10-FF-003378', NULL, 'Uncharacterized protein', 146, NULL, NULL, 219786),
(219787, '3.40.50.300-FF-007127', NULL, 'Guanylate-binding protein 4', 183, NULL, NULL, 219787),
(219788, '2.20.25.10-FF-000045', NULL, 'DNA-directed RNA polymerase subunit', 68, NULL, NULL, 219788),
(219789, '3.90.190.10-FF-000395', NULL, 'MAP kinase phosphatase 5', 154, NULL, NULL, 219789),
(219790, '3.30.2130.30-FF-000011', NULL, 'Probable tRNA sulfurtransferase', 174, NULL, NULL, 219790),
(219791, '2.30.30.40-FF-000032', NULL, 'Putative C-Jun-amino-terminal kinase-interacting protein 2', 61, NULL, NULL, 219791),
(219792, '2.120.10.80-FF-000353', NULL, 'Uncharacterized protein', 302, NULL, NULL, 219792),
(219793, '3.40.50.300-FF-004401', NULL, 'Uncharacterized protein', 296, NULL, NULL, 219793),
(219794, '2.130.10.10-FF-005839', NULL, 'Villidin', 359, NULL, NULL, 219794),
(219795, '3.40.50.10330-FF-000028', NULL, 'Diacylglycerol kinase', 81, NULL, NULL, 219795),
(219796, '2.70.150.10-FF-000266', NULL, 'Calcium-transporting ATPase', 160, NULL, NULL, 219796),
(219797, '1.10.274.30-FF-000031', NULL, 'Uncharacterized protein (Fragment)', 122, NULL, NULL, 219797),
(219798, '2.70.70.10-FF-000035', NULL, 'Peptidase, M23 family', 178, NULL, NULL, 219798),
(219799, '1.10.533.10-FF-000083', NULL, 'Leucine rich repeats and death domain containing 1', 96, NULL, NULL, 219799),
(219800, '2.60.40.1180-FF-000175', NULL, 'Alpha-mannosidase', 81, NULL, NULL, 219800),
(219801, '2.60.40.10-FF-004035', NULL, NULL, 143, NULL, NULL, 219801),
(219802, '3.40.50.300-FF-000141', NULL, 'ATP-dependent RNA helicase DOB1', 249, NULL, NULL, 219802),
(219803, '2.70.20.50-FF-000004', NULL, 'Matrix protein', 187, NULL, NULL, 219803),
(219804, '3.30.1330.20-FF-000034', NULL, 'Cell division protein FtsZ', 119, NULL, NULL, 219804),
(219805, '3.30.1370.10-FF-000045', NULL, 'KH domain-containing 4, pre-mRNA-splicing factor', 91, NULL, NULL, 219805);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(219806, '3.90.70.80-FF-000030', NULL, 'OTUBain deubiquitylating protease homolog', 171, NULL, NULL, 219806),
(219807, '3.90.640.80-FF-000006', NULL, 'Poly [ADP-ribose] polymerase', 127, NULL, NULL, 219807),
(219808, '1.10.287.70-FF-000449', NULL, 'Voltage-dependent calcium channel subunit, putative', 166, NULL, NULL, 219808),
(219809, '2.60.40.10-FF-000303', NULL, 'MAM domain containing glycosylphosphatidylinositol anchor 1', 96, NULL, NULL, 219809),
(219810, '3.40.532.10-FF-000021', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 245, NULL, NULL, 219810),
(219811, '1.10.760.10-FF-000026', NULL, 'Cytochrome C, membrane-bound', 138, NULL, NULL, 219811),
(219812, '1.10.10.60-FF-000416', NULL, 'Myb family transcription factor', 61, NULL, NULL, 219812),
(219813, '2.60.40.10-FF-000191', NULL, 'Immunoglobulin superfamily member 3', 124, NULL, NULL, 219813),
(219814, '1.25.40.10-FF-001729', NULL, 'Pentatricopeptide repeat-containing protein', 107, NULL, NULL, 219814),
(219815, '2.30.30.100-FF-000122', NULL, 'U7 snRNA-associated Sm-like protein LSm11', 122, NULL, NULL, 219815),
(219816, '3.90.226.10-FF-000344', NULL, 'Uncharacterized protein', 165, NULL, NULL, 219816),
(219817, '2.10.25.10-FF-000394', NULL, 'Epidermal growth factor-like protein 8', 68, NULL, NULL, 219817),
(219818, '3.20.20.70-FF-000807', NULL, NULL, 115, NULL, NULL, 219818),
(219819, '3.30.1390.20-FF-000010', NULL, 'Large subunit ribosomal protein L30', 86, NULL, NULL, 219819),
(219820, '1.10.3720.10-FF-000068', NULL, 'Oligopeptide transport system permease oppB', 223, NULL, NULL, 219820),
(219821, '4.10.60.10-FF-000240', NULL, 'Uncharacterized protein', 46, NULL, NULL, 219821),
(219822, '1.25.10.10-FF-002268', NULL, 'Uncharacterized protein', 341, NULL, NULL, 219822),
(219823, '1.25.40.10-FF-000550', NULL, 'Clathrin heavy chain', 119, NULL, NULL, 219823),
(219824, '1.10.472.10-FF-000311', NULL, 'Retinoblastoma-like protein homolog lin-35', 181, NULL, NULL, 219824),
(219825, '1.20.1050.80-FF-000006', NULL, 'ALS2 C-terminal-like protein', 164, NULL, NULL, 219825),
(219826, '3.40.50.720-FF-001418', NULL, 'Aminotransferase PigE', 144, NULL, NULL, 219826),
(219827, '3.30.160.60-FF-002978', NULL, NULL, 28, NULL, NULL, 219827),
(219828, '3.40.50.1820-FF-001697', NULL, 'Carboxypeptidase', 188, NULL, NULL, 219828),
(219829, '3.30.160.60-FF-001360', NULL, 'zinc finger protein 624', 27, NULL, NULL, 219829),
(219830, '3.30.1370.50-FF-000006', NULL, 'NF-X1 finger transcription factor', 80, NULL, NULL, 219830),
(219831, '1.10.630.10-FF-000786', NULL, 'Cytochrome P450, family 2, subfamily j, polypeptide 13', 117, NULL, NULL, 219831),
(219832, '2.30.42.10-FF-000606', NULL, NULL, 96, NULL, NULL, 219832),
(219833, '3.40.630.10-FF-000137', NULL, 'Succinyl-diaminopimelate desuccinylase', 179, NULL, NULL, 219833),
(219834, '3.30.70.330-FF-000690', NULL, 'Serine/arginine-rich splicing factor 4', 66, NULL, NULL, 219834),
(219835, '3.30.1490.20-FF-000057', NULL, 'D-alanine--D-alanine ligase', 65, NULL, NULL, 219835),
(219836, '2.60.40.10-FF-000292', NULL, 'Target of Nesh-SH3 isoform 1', 105, NULL, NULL, 219836),
(219837, '3.30.70.330-FF-001780', NULL, NULL, 68, NULL, NULL, 219837),
(219838, '1.25.40.10-FF-000651', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 156, NULL, NULL, 219838),
(219839, '2.130.10.120-FF-000010', NULL, 'Prolyl endopeptidase, putative', 57, NULL, NULL, 219839),
(219840, '3.50.50.60-FF-000474', NULL, 'Possible thiamine biosynthesis oxidoreductase thiO', 170, NULL, NULL, 219840),
(219841, '2.60.40.790-FF-000083', NULL, 'GM12013', 102, NULL, NULL, 219841),
(219842, '1.10.10.10-FF-000603', NULL, 'DNA-binding transcriptional regulator', 59, NULL, NULL, 219842),
(219843, '2.170.300.10-FF-000012', NULL, 'Heparan sulfate proteoglycan 2', 74, NULL, NULL, 219843),
(219844, '2.60.98.50-FF-000004', NULL, 'Envelopment polyprotein', 122, NULL, NULL, 219844),
(219845, '2.60.120.820-FF-000005', NULL, 'Highwire, isoform B', 168, NULL, NULL, 219845),
(219846, '2.40.100.10-FF-000123', NULL, 'Peptidyl-prolyl cis-trans isomerase', 149, NULL, NULL, 219846); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(219847, '3.40.50.2000-FF-001094', NULL, 'Protein CBR-UGT-32', 63, NULL, NULL, 219847),
(219848, '3.30.310.130-FF-000022', NULL, 'Sentrin-specific protease 2', 112, NULL, NULL, 219848),
(219849, '1.20.1250.20-FF-000942', NULL, 'Synaptic vesicle glycoprotein 2', 194, NULL, NULL, 219849),
(219850, '2.120.10.80-FF-000105', NULL, 'F-box/kelch-repeat protein At1g51550', 230, NULL, NULL, 219850),
(219851, '3.30.420.10-FF-000606', NULL, NULL, 183, NULL, NULL, 219851),
(219852, '3.30.720.50-FF-000023', NULL, NULL, 38, NULL, NULL, 219852),
(219853, '3.10.20.870-FF-000020', NULL, NULL, 78, NULL, NULL, 219853),
(219854, '1.10.510.10-FF-000204', NULL, 'Non-specific serine/threonine protein kinase', 340, NULL, NULL, 219854),
(219855, '1.10.1390.10-FF-000002', NULL, 'Glucose-6-phosphate isomerase', 45, NULL, NULL, 219855),
(219856, '3.40.50.1440-FF-000043', NULL, 'Protein dml1', 288, NULL, NULL, 219856),
(219857, '1.25.40.20-FF-000980', NULL, 'SH3 and multiple ankyrin repeat domains 2a', 101, NULL, NULL, 219857),
(219858, '3.90.70.10-FF-000493', NULL, 'Putative ubiquitin carboxyl-terminal hydrolase FAF-X', 84, NULL, NULL, 219858),
(219859, '2.60.40.10-FF-005671', NULL, NULL, 85, NULL, NULL, 219859),
(219860, '3.60.15.10-FF-000181', NULL, 'Metal-dependent hydrolase, beta-lactamase superfamily III', 295, NULL, NULL, 219860),
(219861, '1.20.5.100-FF-000036', NULL, 'Integrin beta', 39, NULL, NULL, 219861),
(219862, '3.40.50.1460-FF-000049', NULL, 'Uncharacterized protein', 245, NULL, NULL, 219862),
(219863, '3.10.450.700-FF-000003', NULL, 'transcription factor Pur-alpha 1', 72, NULL, NULL, 219863),
(219864, '2.40.50.90-FF-000053', NULL, 'Nuclease domain containing protein', 141, NULL, NULL, 219864),
(219865, '1.10.20.10-FF-000368', NULL, NULL, 88, NULL, NULL, 219865),
(219866, '1.20.58.2220-FF-000035', NULL, 'Uncharacterized protein', 185, NULL, NULL, 219866),
(219867, '3.40.1380.10-FF-000021', NULL, 'Alternate ATPase, F1 complex, subunit gamma', 233, NULL, NULL, 219867),
(219868, '3.40.50.10490-FF-000014', NULL, 'N-acetylmuramic acid 6-phosphate etherase', 218, NULL, NULL, 219868),
(219869, '1.25.10.10-FF-000722', NULL, 'UNC-45', 368, NULL, NULL, 219869),
(219870, '1.10.287.950-FF-000011', NULL, 'Laminin subunit gamma 1', 290, NULL, NULL, 219870),
(219871, '1.25.10.10-FF-001548', NULL, 'Transportin-1-like Protein', 857, NULL, NULL, 219871),
(219872, '1.20.120.350-FF-000037', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 95, NULL, NULL, 219872),
(219873, '1.10.357.10-FF-000027', NULL, 'HTH-type transcriptional regulator EthR', 149, NULL, NULL, 219873),
(219874, '1.20.5.190-FF-000119', NULL, NULL, 50, NULL, NULL, 219874),
(219875, '3.30.160.60-FF-006137', NULL, NULL, 71, NULL, NULL, 219875),
(219876, '1.20.1070.10-FF-001184', NULL, 'Predicted protein', 140, NULL, NULL, 219876),
(219877, '3.10.20.30-FF-000089', NULL, NULL, 97, NULL, NULL, 219877),
(219878, '3.40.50.1820-FF-001798', NULL, 'Uncharacterized protein', 147, NULL, NULL, 219878),
(219879, '3.30.1360.120-FF-000044', NULL, 'Aminomethyltransferase', 150, NULL, NULL, 219879),
(219880, '3.30.2020.30-FF-000019', NULL, 'uncharacterized protein LOC100185738', 100, NULL, NULL, 219880),
(219881, '1.20.1250.20-FF-000678', NULL, 'Beta-lactamase induction signal transducer AmpG', 200, NULL, NULL, 219881),
(219882, '1.20.1250.20-FF-001768', NULL, 'Monocarboxylate transporter, putative', 187, NULL, NULL, 219882),
(219883, '3.30.420.110-FF-000063', NULL, 'Uncharacterized protein', 175, NULL, NULL, 219883),
(219884, '2.60.40.2140-FF-000002', NULL, 'Gram-negative bacteria-binding protein 1', 102, NULL, NULL, 219884),
(219885, '3.40.50.10190-FF-000295', NULL, 'Uncharacterized protein', 94, NULL, NULL, 219885),
(219886, '1.20.58.60-FF-000559', NULL, 'Spectrin beta chain', 114, NULL, NULL, 219886),
(219887, '2.60.40.10-FF-003529', NULL, NULL, 79, NULL, NULL, 219887),
(219888, '1.10.150.250-FF-000004', NULL, 'Succinate dehydrogenase assembly factor 2, mitochondrial', 87, NULL, NULL, 219888),
(219889, '2.60.40.10-FF-002809', NULL, 'Tyrosine-protein kinase-like otk', 116, NULL, NULL, 219889);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(219890, '2.60.40.3500-FF-000005', NULL, 'N-acetylmuramoyl-L-alanine amidase', 117, NULL, NULL, 219890),
(219891, '1.20.1540.10-FF-000113', NULL, 'Predicted protein', 66, NULL, NULL, 219891),
(219892, '2.30.180.10-FF-000052', NULL, 'Vacuolar membrane protein, putative', 165, NULL, NULL, 219892),
(219893, '1.20.120.330-FF-000031', NULL, 'Bifunctional uridylyltransferase/uridylyl-removing enzyme', 145, NULL, NULL, 219893),
(219894, '3.40.630.20-FF-000027', NULL, 'Pyroglutamyl-peptidase I like', 133, NULL, NULL, 219894),
(219895, '1.20.5.170-FF-000113', NULL, 'Sth1p', 77, NULL, NULL, 219895),
(219896, '3.40.50.880-FF-000146', NULL, 'Class I glutamine amidotransferase-like protein', 223, NULL, NULL, 219896),
(219897, '3.40.50.300-FF-005784', NULL, 'Uridine kinase, putative (AFU_orthologue AFUA_2G05430)', 88, NULL, NULL, 219897),
(219898, '3.30.160.60-FF-002186', NULL, 'Zinc finger protein 507', 84, NULL, NULL, 219898),
(219899, '3.40.630.10-FF-000362', NULL, 'Predicted protein', 140, NULL, NULL, 219899),
(219900, '1.50.40.10-FF-000250', NULL, 'AT23463p', 272, NULL, NULL, 219900),
(219901, '3.40.50.10470-FF-000059', NULL, 'Translation initiation factor eIF-2B alpha subunit', 208, NULL, NULL, 219901),
(219902, '1.25.10.10-FF-000823', NULL, 'AP-2 complex subunit beta-1, putative', 539, NULL, NULL, 219902),
(219903, '3.30.200.20-FF-000115', NULL, 'Wee1-like kinase 2', 90, NULL, NULL, 219903),
(219904, '3.30.910.20-FF-000001', NULL, 'Molecular chaperone Skp', 143, NULL, NULL, 219904),
(219905, '1.10.472.10-FF-000103', NULL, 'Cyclin B1', 14, NULL, NULL, 219905),
(219906, '3.10.129.110-FF-000022', NULL, 'Polyketide synthase RzxE', 256, NULL, NULL, 219906),
(219907, '2.40.230.20-FF-000001', NULL, 'Nucleoside-specific channel-forming protein Tsx', 272, NULL, NULL, 219907),
(219908, '1.10.287.690-FF-000028', NULL, 'Uncharacterized protein', 39, NULL, NULL, 219908),
(219909, '2.60.120.780-FF-000021', NULL, 'E3 SUMO-protein ligase pli1', 154, NULL, NULL, 219909),
(219910, '2.20.110.10-FF-000078', NULL, NULL, 95, NULL, NULL, 219910),
(219911, '3.90.70.10-FF-000846', NULL, 'Uncharacterized protein', 116, NULL, NULL, 219911),
(219912, '3.40.190.10-FF-000198', NULL, 'Sensor histidine kinase/response regulator EvgS', 134, NULL, NULL, 219912),
(219913, '1.25.40.10-FF-004602', NULL, 'Predicted protein', 166, NULL, NULL, 219913),
(219914, '1.10.510.10-FF-000631', NULL, 'Polo like kinase 5', 81, NULL, NULL, 219914),
(219915, '1.20.1310.10-FF-000068', NULL, 'Cul3p', 122, NULL, NULL, 219915),
(219916, '3.40.800.20-FF-000052', NULL, 'Uncharacterized protein', 326, NULL, NULL, 219916),
(219917, '2.60.40.1120-FF-000050', NULL, 'Uncharacterized protein', 77, NULL, NULL, 219917),
(219918, '3.40.50.970-FF-000173', NULL, 'Uncharacterized protein', 204, NULL, NULL, 219918),
(219919, '3.30.160.60-FF-005311', NULL, NULL, 121, NULL, NULL, 219919),
(219920, '3.40.50.300-FF-003575', NULL, 'Homolog of X-ray repair cross complementing 2 (XRCC2)', 306, NULL, NULL, 219920),
(219921, '2.120.10.30-FF-000254', NULL, 'Uncharacterized protein', 190, NULL, NULL, 219921),
(219922, '3.40.640.10-FF-000290', NULL, 'Pyridoxal phosphate-dependent transferase', 525, NULL, NULL, 219922),
(219923, '1.20.120.180-FF-000008', NULL, 'Uncharacterized protein', 138, NULL, NULL, 219923),
(219924, '2.60.40.10-FF-001129', NULL, 'Immunoglobulin heavy constant gamma 1', 101, NULL, NULL, 219924),
(219925, '3.60.40.10-FF-000014', NULL, 'TGF-beta-activated kinase 1 and MAP3K7-binding protein 1-like', 367, NULL, NULL, 219925),
(219926, '1.20.1250.20-FF-001184', NULL, 'Uncharacterized protein', 200, NULL, NULL, 219926),
(219927, '3.40.50.720-FF-000031', NULL, 'Glutamyl-tRNA reductase', 153, NULL, NULL, 219927),
(219928, '3.40.50.1000-FF-000642', NULL, NULL, 186, NULL, NULL, 219928),
(219929, '3.30.70.330-FF-000482', NULL, 'SUPpressor', 95, NULL, NULL, 219929),
(219930, '3.40.50.720-FF-001109', NULL, 'WGS project CABT00000000 data, contig 2.10', 194, NULL, NULL, 219930),
(219931, '3.40.50.10190-FF-000031', NULL, 'DNA polymerase', 103, NULL, NULL, 219931),
(219932, '1.20.58.1480-FF-000010', NULL, 'ATP-dependent protease La', 124, NULL, NULL, 219932);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(219933, '3.30.160.60-FF-000640', NULL, 'PR domain zinc finger protein 15', 29, NULL, NULL, 219933),
(219934, '2.40.30.170-FF-000028', NULL, 'Membrane fusion protein mtrC', 81, NULL, NULL, 219934),
(219935, '3.90.132.10-FF-000007', NULL, 'GP63-like', 132, NULL, NULL, 219935),
(219936, '3.40.50.1220-FF-000005', NULL, 'NAD-dependent deacetylase sirtuin-2', 166, NULL, NULL, 219936),
(219937, '1.10.287.4070-FF-000010', NULL, 'U4/U6 small nuclear ribonucleoprotein Prp31, putative', 141, NULL, NULL, 219937),
(219938, '2.60.120.10-FF-000480', NULL, 'cAMP protein kinase regulatory chain', 151, NULL, NULL, 219938),
(219939, '3.30.160.60-FF-005884', NULL, NULL, 34, NULL, NULL, 219939),
(219940, '1.10.1450.10-FF-000092', NULL, 'Tetraspanin', 87, NULL, NULL, 219940),
(219941, '1.10.10.2670-FF-000015', NULL, 'Predicted protein', 102, NULL, NULL, 219941),
(219942, '3.20.20.60-FF-000108', NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', 260, NULL, NULL, 219942),
(219943, '1.20.920.20-FF-000062', NULL, 'Uncharacterized protein', 316, NULL, NULL, 219943),
(219944, '1.10.30.10-FF-000150', NULL, 'Mismatch-binding protein cmb1', 79, NULL, NULL, 219944),
(219945, '1.20.245.10-FF-000001', NULL, 'Arachidonate 5-lipoxygenase a', 417, NULL, NULL, 219945),
(219946, '1.25.10.10-FF-002476', NULL, 'Microtubule-associated protein TORTIFOLIA1', 213, NULL, NULL, 219946),
(219947, '3.40.50.720-FF-000340', NULL, 'Succinyl-CoA synthetase subunit alpha', 118, NULL, NULL, 219947),
(219948, '2.130.10.10-FF-000427', NULL, 'WD repeat domain 66', 293, NULL, NULL, 219948),
(219949, '3.20.20.220-FF-000019', NULL, 'Methylenetetrahydrofolate reductase', 294, NULL, NULL, 219949),
(219950, '3.40.50.11340-FF-000011', NULL, 'Fucosyltransferase 3', 59, NULL, NULL, 219950),
(219951, '3.30.420.40-FF-000357', NULL, 'L-fuculose kinase fucK', 235, NULL, NULL, 219951),
(219952, '3.30.70.1450-FF-000026', NULL, 'Sulfur deprivation response regulator', 73, NULL, NULL, 219952),
(219953, '2.30.30.560-FF-000001', NULL, 'major vault protein-like', 51, NULL, NULL, 219953),
(219954, '3.40.50.360-FF-000097', NULL, 'NADPH--cytochrome P450 reductase', 179, NULL, NULL, 219954),
(219955, '3.40.50.1000-FF-000703', NULL, NULL, 107, NULL, NULL, 219955),
(219956, '3.40.50.300-FF-000450', NULL, 'ABC transporter C family member 2', 248, NULL, NULL, 219956),
(219957, '3.30.1330.30-FF-000138', NULL, 'Uncharacterized protein', 71, NULL, NULL, 219957),
(219958, '2.40.170.20-FF-000063', NULL, 'Ferripyoverdine receptor', 562, NULL, NULL, 219958),
(219959, '1.25.40.10-FF-002348', NULL, 'Pre-mRNA processing factor 6', 148, NULL, NULL, 219959),
(219960, '1.20.58.1000-FF-000001', NULL, 'Transcriptional repressor RcnR', 90, NULL, NULL, 219960),
(219961, '3.40.1090.10-FF-000010', NULL, 'Lysophospholipase', 494, NULL, NULL, 219961),
(219962, '3.10.310.10-FF-000030', NULL, 'Diaminopimelate epimerase', 118, NULL, NULL, 219962),
(219963, '3.60.20.10-FF-000159', NULL, NULL, 69, NULL, NULL, 219963),
(219964, '2.20.70.10-FF-000149', NULL, 'Rho GTPase-activating protein 27', 51, NULL, NULL, 219964),
(219965, '3.30.200.20-FF-000823', NULL, 'Probable IPL1-ser/thr protein kinase', 97, NULL, NULL, 219965),
(219966, '3.40.50.10310-FF-000005', NULL, 'Creatininase', 232, NULL, NULL, 219966),
(219967, '3.50.50.60-FF-001446', NULL, 'Gll3362 protein', 233, NULL, NULL, 219967),
(219968, '1.10.472.80-FF-000282', NULL, NULL, 125, NULL, NULL, 219968),
(219969, '1.25.10.10-FF-002167', NULL, 'Uncharacterized protein', 497, NULL, NULL, 219969),
(219970, '3.90.226.10-FF-000130', NULL, 'Uncharacterized protein', 279, NULL, NULL, 219970),
(219971, '1.20.58.390-FF-000078', NULL, 'AcetylCholine Receptor', 110, NULL, NULL, 219971),
(219972, '3.20.20.70-FF-000662', NULL, NULL, 227, NULL, NULL, 219972),
(219973, '3.40.50.300-FF-002911', NULL, 'Dynein Light Intermediate chain', 192, NULL, NULL, 219973),
(219974, '2.130.10.10-FF-004322', NULL, 'Uncharacterized protein', 106, NULL, NULL, 219974),
(219975, '2.60.40.10-FF-003737', NULL, NULL, 86, NULL, NULL, 219975),
(219976, '1.10.510.10-FF-001396', NULL, 'Tyrosine-protein kinase receptor cam-1', 280, NULL, NULL, 219976);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(219977, '1.10.510.10-FF-003857', NULL, NULL, 100, NULL, NULL, 219977),
(219978, '2.120.10.30-FF-000040', NULL, 'Low-density lipoprotein receptor-related protein 2', 307, NULL, NULL, 219978),
(219979, '2.40.160.50-FF-000032', NULL, 'SAM complex subunit', 344, NULL, NULL, 219979),
(219980, '3.30.200.210-FF-000010', NULL, NULL, 113, NULL, NULL, 219980),
(219981, '3.40.190.10-FF-000209', NULL, 'Putative dipeptide/oligopeptide/nickel ABC-type transport system periplasmic component', 199, NULL, NULL, 219981),
(219982, '3.40.50.2300-FF-001386', NULL, NULL, 86, NULL, NULL, 219982),
(219983, '1.10.730.10-FF-000187', NULL, 'Leucine--tRNA ligase', 24, NULL, NULL, 219983),
(219984, '1.10.10.10-FF-001795', NULL, 'Uncharacterized protein', 79, NULL, NULL, 219984),
(219985, '3.90.1410.10-FF-000024', NULL, 'Rkm1p', 287, NULL, NULL, 219985),
(219986, '1.10.8.10-FF-000294', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 35, NULL, NULL, 219986),
(219987, '1.10.10.10-FF-001368', NULL, 'Predicted transcription regulator, ArsR family', 69, NULL, NULL, 219987),
(219988, '4.10.280.10-FF-000157', NULL, 'Uncharacterized protein', 73, NULL, NULL, 219988),
(219989, '1.25.40.10-FF-002096', NULL, 'Pentatricopeptide repeat-containing protein At1g62720', 69, NULL, NULL, 219989),
(219990, '1.25.40.10-FF-004557', NULL, 'Uncharacterized protein', 208, NULL, NULL, 219990),
(219991, '1.50.10.10-FF-000158', NULL, 'Uncharacterized protein', 166, NULL, NULL, 219991),
(219992, '3.40.50.1820-FF-001017', NULL, 'Lipase containing protein, putative', 205, NULL, NULL, 219992),
(219993, '1.20.58.340-FF-000057', NULL, 'Putative inactive magnesium transporter MRS2-8', 158, NULL, NULL, 219993),
(219994, '1.10.287.940-FF-000019', NULL, 'Uncharacterized protein', 16, NULL, NULL, 219994),
(219995, '3.90.80.10-FF-000009', NULL, 'Inorganic pyrophosphatase', 285, NULL, NULL, 219995),
(219996, '2.130.10.10-FF-000152', NULL, 'WD repeat-containing protein 37', 96, NULL, NULL, 219996),
(219997, '1.20.120.1380-FF-000010', NULL, 'Flagellar biosynthetic protein FlhF', 28, NULL, NULL, 219997),
(219998, '3.30.70.340-FF-000029', NULL, NULL, 92, NULL, NULL, 219998),
(219999, '1.20.58.870-FF-000008', NULL, NULL, 116, NULL, NULL, 219999),
(220000, '1.10.10.10-FF-000042', NULL, 'hepatocyte nuclear factor 3-beta', 108, NULL, NULL, 220000),
(220001, '1.20.1280.50-FF-000166', NULL, 'Putative F-box only protein 11', 78, NULL, NULL, 220001),
(220002, '2.60.120.10-FF-000171', NULL, 'Mannose-6-phosphate isomerase', 41, NULL, NULL, 220002),
(220003, '3.30.450.40-FF-000185', NULL, 'GGDEF domain-containing protein', 167, NULL, NULL, 220003),
(220004, '3.40.50.1820-FF-000972', NULL, 'Pancreatic triacylglycerol lipase-like Protein', 272, NULL, NULL, 220004),
(220005, '2.60.40.2030-FF-000014', NULL, 'Adhesion G-protein coupled receptor V1', 109, NULL, NULL, 220005),
(220006, '3.50.50.60-FF-000710', NULL, 'Protoporphyrinogen oxidase', 493, NULL, NULL, 220006),
(220007, '2.60.40.10-FF-002557', NULL, 'Uncharacterized protein', 109, NULL, NULL, 220007),
(220008, '2.60.40.10-FF-004457', NULL, NULL, 107, NULL, NULL, 220008),
(220009, '3.20.20.60-FF-000097', NULL, 'Isocitrate lyase', 157, NULL, NULL, 220009),
(220010, '1.10.287.110-FF-000068', NULL, 'HSP40, subfamily A, putative', 90, NULL, NULL, 220010),
(220011, '1.10.8.270-FF-000078', NULL, 'GTPase-activating protein GYP6', 115, NULL, NULL, 220011),
(220012, '2.60.40.10-FF-003838', NULL, NULL, 104, NULL, NULL, 220012),
(220013, '2.10.220.10-FF-000094', NULL, 'Proprotein convertase subtilisin/kexin type 5', 53, NULL, NULL, 220013),
(220014, '3.30.40.10-FF-002101', NULL, 'Uncharacterized protein', 75, NULL, NULL, 220014),
(220015, '3.10.100.10-FF-000300', NULL, NULL, 133, NULL, NULL, 220015),
(220016, '2.30.29.30-FF-001256', NULL, 'Chromosome 19, whole genome shotgun sequence', 106, NULL, NULL, 220016),
(220017, '3.40.50.300-FF-003676', NULL, 'ATP-dependent helicase family protein', 225, NULL, NULL, 220017),
(220018, '3.40.50.150-FF-000736', NULL, 'RNA Methyltransferase', 178, NULL, NULL, 220018),
(220019, '4.10.400.10-FF-000246', NULL, 'Low-density lipoprotein receptor-related protein', 45, NULL, NULL, 220019);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(220020, '1.10.10.10-FF-000087', NULL, 'Transcriptional adapter 2', 85, NULL, NULL, 220020),
(220021, '1.10.132.70-FF-000023', NULL, 'Telomerase reverse transcriptase', 150, NULL, NULL, 220021),
(220022, '1.10.418.10-FF-000271', NULL, 'Predicted protein', 95, NULL, NULL, 220022),
(220023, '3.60.21.10-FF-000105', NULL, 'Metallo-dependent phosphatase-like protein', 302, NULL, NULL, 220023),
(220024, '3.40.50.300-FF-004295', NULL, 'Branched-chain amino acid ABC transporter ATP-binding protein', 259, NULL, NULL, 220024),
(220025, '3.60.40.10-FF-000222', NULL, 'Sigma regulatory family protein-PP2C phosphatase', 252, NULL, NULL, 220025),
(220026, '3.30.70.1020-FF-000015', NULL, NULL, 76, NULL, NULL, 220026),
(220027, '3.30.780.10-FF-000043', NULL, 'Mitochondrial 54S ribosomal protein IMG2', 98, NULL, NULL, 220027),
(220028, '1.20.1070.10-FF-001549', NULL, 'Predicted protein', 175, NULL, NULL, 220028),
(220029, '3.30.9.10-FF-000095', NULL, 'FAD dependent oxidoreductase', 114, NULL, NULL, 220029),
(220030, '3.30.200.20-FF-001649', NULL, 'Uncharacterized protein', 88, NULL, NULL, 220030),
(220031, '4.10.240.10-FF-000048', NULL, 'YLR278C', 58, NULL, NULL, 220031),
(220032, '1.25.10.10-FF-002931', NULL, 'Uncharacterized protein', 92, NULL, NULL, 220032),
(220033, '2.40.50.140-FF-000130', NULL, 'DNA-directed RNA polymerase III subunit RPC8', 122, NULL, NULL, 220033),
(220034, '2.40.270.10-FF-000017', NULL, 'DNA-directed RNA polymerase subunit beta', 142, NULL, NULL, 220034),
(220035, '3.30.450.40-FF-000038', NULL, 'Two-component sensor histidine kinase KdpD', 145, NULL, NULL, 220035),
(220036, '1.25.40.10-FF-002657', NULL, 'Uncharacterized protein', 178, NULL, NULL, 220036),
(220037, '1.10.1420.10-FF-000117', NULL, 'Uncharacterized protein', 97, NULL, NULL, 220037),
(220038, '3.40.50.10420-FF-000055', NULL, '5-formyltetrahydrofolate cyclo-ligase', 186, NULL, NULL, 220038),
(220039, '1.10.510.10-FF-001132', NULL, 'Casein kinase I-like protein', 361, NULL, NULL, 220039),
(220040, '3.30.200.20-FF-000470', NULL, 'Serine/threonine-protein kinase RAD53', 87, NULL, NULL, 220040),
(220041, '3.10.100.10-FF-000401', NULL, NULL, 118, NULL, NULL, 220041),
(220042, '3.30.830.10-FF-000160', NULL, 'Metalloenzyme, LuxS/M16 peptidase-like protein', 177, NULL, NULL, 220042),
(220043, '1.20.5.420-FF-000014', NULL, 'SGT2p Glutamine-rich cytoplasmic cochaperone', 78, NULL, NULL, 220043),
(220044, '2.60.40.420-FF-000213', NULL, 'Uncharacterized protein', 86, NULL, NULL, 220044),
(220045, '3.30.160.60-FF-005620', NULL, NULL, 43, NULL, NULL, 220045),
(220046, '2.30.130.40-FF-000029', NULL, 'Lon protease homolog, mitochondrial', 109, NULL, NULL, 220046),
(220047, '3.10.20.90-FF-000550', NULL, 'Uncharacterized protein', 105, NULL, NULL, 220047),
(220048, '2.20.70.10-FF-000251', NULL, 'Uncharacterized protein', 50, NULL, NULL, 220048),
(220049, '1.10.8.270-FF-000180', NULL, 'Uncharacterized protein', 89, NULL, NULL, 220049),
(220050, '1.10.238.10-FF-000835', NULL, 'EF hand family protein', 81, NULL, NULL, 220050),
(220051, '1.10.418.10-FF-000169', NULL, 'Kinesin-like protein KIN-14G', 154, NULL, NULL, 220051),
(220052, '3.40.50.300-FF-002248', NULL, 'ATP-dependent DNA helicase RecQ', 215, NULL, NULL, 220052),
(220053, '3.30.420.40-FF-000149', NULL, 'Type IV pilus assembly protein PilM', 129, NULL, NULL, 220053),
(220054, '3.40.50.720-FF-001784', NULL, '2-dehydropantoate 2-reductase', 173, NULL, NULL, 220054),
(220055, '3.30.200.20-FF-002268', NULL, 'Predicted protein', 138, NULL, NULL, 220055),
(220056, '1.20.1070.10-FF-001892', NULL, 'Uncharacterized protein', 339, NULL, NULL, 220056),
(220057, '3.40.50.300-FF-007627', NULL, 'Uncharacterized protein', 147, NULL, NULL, 220057),
(220058, '2.60.120.650-FF-000010', NULL, 'bifunctional arginine demethylase and lysyl-hydroxylase JMJD6 isoform X2', 290, NULL, NULL, 220058),
(220059, '3.30.40.10-FF-001437', NULL, 'TNF receptor-associated factor 4', 59, NULL, NULL, 220059),
(220060, '3.30.70.330-FF-000139', NULL, 'Serine/arginine-rich splicing factor 3, putative', 84, NULL, NULL, 220060);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(220061, '3.10.20.90-FF-000764', NULL, 'Pat-6', 88, NULL, NULL, 220061),
(220062, '3.30.870.10-FF-000073', NULL, 'Phopholipase D-family protein', 189, NULL, NULL, 220062),
(220063, '1.10.4160.10-FF-000002', NULL, 'Purine-cytosine permease fcyB', 436, NULL, NULL, 220063),
(220064, '2.120.10.30-FF-000462', NULL, 'Low-density lipoprotein RecePtor related', 327, NULL, NULL, 220064),
(220065, '1.10.150.530-FF-000009', NULL, 'Putative dual-specificity RNA methyltransferase RlmN', 72, NULL, NULL, 220065),
(220066, '3.80.10.10-FF-001220', NULL, 'AGAP007471-PA', 143, NULL, NULL, 220066),
(220067, '1.10.1450.10-FF-000153', NULL, 'Tetraspanin', 85, NULL, NULL, 220067),
(220068, '1.20.120.230-FF-000046', NULL, 'Talin-1-like Protein', 138, NULL, NULL, 220068),
(220069, '3.60.20.10-FF-000114', NULL, 'Asparagine synthetase, glutamine-hydrolyzing', 214, NULL, NULL, 220069),
(220070, '2.10.25.10-FF-001074', NULL, 'Deleted in malignant brain tumors 1 protein', 39, NULL, NULL, 220070),
(220071, '1.20.1270.280-FF-000079', NULL, 'Uncharacterized protein', 48, NULL, NULL, 220071),
(220072, '3.30.465.10-FF-000103', NULL, 'Glycolate oxidase subunit GlcE', 216, NULL, NULL, 220072),
(220073, '1.10.8.480-FF-000006', NULL, 'rRNA adenine N(6)-methyltransferase', 59, NULL, NULL, 220073),
(220074, '3.15.10.10-FF-000004', NULL, 'BPI fold-containing family B member 3', 183, NULL, NULL, 220074),
(220075, '3.30.470.30-FF-000082', NULL, 'Uncharacterized protein', 48, NULL, NULL, 220075),
(220076, '3.20.20.70-FF-000454', NULL, 'Dihydroorotate dehydrogenase (quinone)', 362, NULL, NULL, 220076),
(220077, '1.20.5.4770-FF-000013', NULL, 'Zinc finger A20 and AN1 domain-containing stress-associated protein 5', 63, NULL, NULL, 220077),
(220078, '1.20.58.850-FF-000002', NULL, 'Chromosome partition protein MukB', 88, NULL, NULL, 220078),
(220079, '2.60.40.1770-FF-000008', NULL, 'Eph receptor A2 b', 52, NULL, NULL, 220079),
(220080, '2.130.10.10-FF-005087', NULL, 'Uncharacterized protein', 262, NULL, NULL, 220080),
(220081, '2.60.200.20-FF-000085', NULL, 'Factor arrest protein 10', 90, NULL, NULL, 220081),
(220082, '3.40.50.720-FF-001065', NULL, 'Os04g0630900 protein', 175, NULL, NULL, 220082),
(220083, '1.20.1250.40-FF-000026', NULL, 'Uncharacterized protein', 141, NULL, NULL, 220083),
(220084, '2.60.120.970-FF-000090', NULL, 'Uncharacterized protein', 192, NULL, NULL, 220084),
(220085, '3.40.50.300-FF-003103', NULL, 'cDNA FLJ50831, highly similar to Guanine nucleotide-binding protein G(q) subunit alpha', 145, NULL, NULL, 220085),
(220086, '1.20.58.70-FF-000096', NULL, 'Syntaxin 1A (brain)', 41, NULL, NULL, 220086),
(220087, '3.30.200.20-FF-001751', NULL, 'Serine/threonine-protein kinase OSR1', 93, NULL, NULL, 220087),
(220088, '1.20.1560.10-FF-000895', NULL, 'ATP-binding cassette permease', 302, NULL, NULL, 220088),
(220089, '1.25.10.10-FF-000014', NULL, 'Cell differentiation protein RCD1', 269, NULL, NULL, 220089),
(220090, '3.40.630.30-FF-000581', NULL, 'Acyl-CoA N-acyltransferases (NAT) superfamily protein', 95, NULL, NULL, 220090),
(220091, '3.80.10.10-FF-004401', NULL, 'Leucine-rich repeat protein (LRRP), putative', 104, NULL, NULL, 220091),
(220092, '2.70.150.10-FF-000058', NULL, 'Phospholipid-transporting ATPase', 142, NULL, NULL, 220092),
(220093, '3.40.50.1780-FF-000004', NULL, 'Cytosolic Fe-S cluster assembly factor nar1', 160, NULL, NULL, 220093),
(220094, '1.10.150.280-FF-000002', NULL, 'Kinesin-like protein', 80, NULL, NULL, 220094),
(220095, '3.40.50.1100-FF-000071', NULL, 'Diaminopropionate ammonia-lyase', 109, NULL, NULL, 220095),
(220096, '3.40.630.40-FF-000022', NULL, 'Putative N-acetylmuramoyl-L-alanine amidase', 213, NULL, NULL, 220096),
(220097, '3.40.30.10-FF-000498', NULL, 'glutathione S-transferase theta-1-like', 82, NULL, NULL, 220097),
(220098, '3.10.20.310-FF-000021', NULL, 'Cell division protein FtsQ', 68, NULL, NULL, 220098),
(220099, '1.10.10.60-FF-000141', NULL, 'TetR family transcriptional regulator', 52, NULL, NULL, 220099),
(220100, '1.10.1200.10-FF-000045', NULL, 'Nonribosomal peptide synthase side', 71, NULL, NULL, 220100); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(220101, '3.40.50.300-FF-008190', NULL, 'RAD3-like DNA-binding helicase protein', 77, NULL, NULL, 220101),
(220102, '3.30.40.10-FF-000156', NULL, 'RING-box protein 2 isoform X1', 97, NULL, NULL, 220102),
(220103, '3.90.470.20-FF-000026', NULL, 'YALI0E09306p', 128, NULL, NULL, 220103),
(220104, '2.40.160.20-FF-000034', NULL, '28kDa outer membrane protein gene 17', 183, NULL, NULL, 220104),
(220105, '3.30.70.1400-FF-000017', NULL, 'Aminomethyltransferase family protein', 85, NULL, NULL, 220105),
(220106, '3.40.190.10-FF-000861', NULL, 'Uncharacterized protein', 47, NULL, NULL, 220106),
(220107, '1.25.10.10-FF-002829', NULL, 'Uncharacterized protein', 523, NULL, NULL, 220107),
(220108, '1.10.630.10-FF-000331', NULL, 'Cytochrome P450, putative', 92, NULL, NULL, 220108),
(220109, '3.40.30.10-FF-000953', NULL, 'Iodothyronine deiodinase', 107, NULL, NULL, 220109),
(220110, '3.40.50.300-FF-001203', NULL, 'Terminase large subunit', 175, NULL, NULL, 220110),
(220111, '2.40.50.730-FF-000015', NULL, 'DNA polymerase', 51, NULL, NULL, 220111),
(220112, '2.60.40.10-FF-004243', NULL, NULL, 108, NULL, NULL, 220112),
(220113, '3.90.1150.10-FF-000217', NULL, 'PLP-dependent aminotransferase family protein', 132, NULL, NULL, 220113),
(220114, '3.30.450.70-FF-000036', NULL, NULL, 144, NULL, NULL, 220114),
(220115, '3.40.50.300-FF-004856', NULL, 'Uncharacterized protein', 211, NULL, NULL, 220115),
(220116, '3.30.160.60-FF-002905', NULL, 'Zinc finger protein 507 isoform X1', 25, NULL, NULL, 220116),
(220117, '2.60.120.380-FF-000053', NULL, 'Serine/threonine-protein kinase 4 homolog B', 133, NULL, NULL, 220117),
(220118, '3.40.50.300-FF-006290', NULL, 'Uncharacterized protein', 219, NULL, NULL, 220118),
(220119, '1.20.1520.10-FF-000005', NULL, 'Uncharacterized protein', 129, NULL, NULL, 220119),
(220120, '1.10.10.2270-FF-000002', NULL, 'ADL286Wp', 66, NULL, NULL, 220120),
(220121, '3.40.1110.10-FF-000299', NULL, NULL, 202, NULL, NULL, 220121),
(220122, '2.130.10.10-FF-006003', NULL, 'Uncharacterized protein', 63, NULL, NULL, 220122),
(220123, '1.10.8.60-FF-000393', NULL, 'cell cycle checkpoint protein RAD17', 70, NULL, NULL, 220123),
(220124, '3.30.30.30-FF-000077', NULL, 'Uncharacterized protein', 16, NULL, NULL, 220124),
(220125, '3.20.20.10-FF-000043', NULL, 'Alanine racemase', 221, NULL, NULL, 220125),
(220126, '3.40.50.620-FF-000208', NULL, 'GMP synthase [glutamine-hydrolyzing] subunit B', 189, NULL, NULL, 220126),
(220127, '1.10.472.130-FF-000081', NULL, 'Dynein heavy chain family protein', 77, NULL, NULL, 220127),
(220128, '3.40.50.300-FF-000803', NULL, 'Ras-related protein Rab-43', 193, NULL, NULL, 220128),
(220129, '1.20.120.520-FF-000009', NULL, 'Zinc finger protein BRUTUS', 202, NULL, NULL, 220129),
(220130, '3.30.420.240-FF-000001', NULL, 'Phage terminase, large subunit', 213, NULL, NULL, 220130),
(220131, '4.10.60.10-FF-000032', NULL, 'Glycine-rich RNA-binding protein 7', 32, NULL, NULL, 220131),
(220132, '1.10.10.750-FF-000012', NULL, 'Rab GTPase-activating protein 1', 45, NULL, NULL, 220132),
(220133, '2.30.42.10-FF-000505', NULL, NULL, 96, NULL, NULL, 220133),
(220134, '3.40.50.300-FF-002956', NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', 161, NULL, NULL, 220134),
(220135, '3.20.20.70-FF-000706', NULL, NULL, 143, NULL, NULL, 220135),
(220136, '3.80.10.10-FF-002501', NULL, 'Leucine Rich Repeat family protein', 132, NULL, NULL, 220136),
(220137, '1.20.58.390-FF-000179', NULL, 'Predicted protein', 134, NULL, NULL, 220137),
(220138, '3.40.50.10190-FF-000306', NULL, 'Uncharacterized protein', 101, NULL, NULL, 220138),
(220139, '2.130.10.10-FF-005648', NULL, 'Tetraspanin 39D-like protein', 171, NULL, NULL, 220139),
(220140, '3.40.50.2300-FF-001622', NULL, NULL, 287, NULL, NULL, 220140),
(220141, '1.25.40.10-FF-003276', NULL, 'Putative pentatricopeptide repeat-containing protein At1g09680', 138, NULL, NULL, 220141),
(220142, '3.40.50.1370-FF-000011', NULL, 'Aspartate carbamoyltransferase', 144, NULL, NULL, 220142),
(220143, '1.20.870.10-FF-000043', NULL, 'Ras guanine nucleotide exchange factor H', 165, NULL, NULL, 220143);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(220144, '2.70.130.10-FF-000045', NULL, 'Mannose 6-phosphate receptor domain-containing protein', 138, NULL, NULL, 220144),
(220145, '2.60.40.840-FF-000002', NULL, 'Arrestin 3', 172, NULL, NULL, 220145),
(220146, '3.30.1370.70-FF-000001', NULL, 'NifU-like protein 4, mitochondrial', 104, NULL, NULL, 220146),
(220147, '2.60.40.60-FF-000402', NULL, 'cadherin-89D', 116, NULL, NULL, 220147),
(220148, '3.40.430.10-FF-000009', NULL, 'Dihydrofolate reductase', 164, NULL, NULL, 220148),
(220149, '3.40.50.1820-FF-001489', NULL, 'Lipase, putative', 165, NULL, NULL, 220149),
(220150, '2.130.10.10-FF-000713', NULL, 'WD repeat-containing protein 82 isoform X2', 237, NULL, NULL, 220150),
(220151, '3.40.140.10-FF-000150', NULL, 'Uncharacterized protein', 195, NULL, NULL, 220151),
(220152, '3.40.50.720-FF-002037', NULL, 'Predicted gene 4450', 188, NULL, NULL, 220152),
(220153, '3.30.70.3490-FF-000060', NULL, NULL, 123, NULL, NULL, 220153),
(220154, '3.55.40.20-FF-000024', NULL, 'Superoxide dismutase', 62, NULL, NULL, 220154),
(220155, '1.50.40.10-FF-000356', NULL, 'Uncharacterized protein', 200, NULL, NULL, 220155),
(220156, '3.40.109.10-FF-000044', NULL, 'Nitroreductase Fd-NR2', 175, NULL, NULL, 220156),
(220157, '3.30.70.330-FF-001819', NULL, NULL, 87, NULL, NULL, 220157),
(220158, '3.30.710.10-FF-000241', NULL, 'Uncharacterized protein', 101, NULL, NULL, 220158),
(220159, '2.130.10.10-FF-001332', NULL, 'Hypothetical_protein_-_conserved', 316, NULL, NULL, 220159),
(220160, '4.10.410.10-FF-000084', NULL, 'Tissue factor pathway inhibitor', 78, NULL, NULL, 220160),
(220161, '2.30.240.10-FF-000006', NULL, 'T19F6.7 protein', 138, NULL, NULL, 220161),
(220162, '3.30.160.60-FF-000399', NULL, 'zinc finger protein 521', 26, NULL, NULL, 220162),
(220163, '3.30.160.60-FF-002085', NULL, 'Zinc finger protein 136', 28, NULL, NULL, 220163),
(220164, '1.10.8.60-FF-000084', NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', 92, NULL, NULL, 220164),
(220165, '3.80.10.10-FF-003018', NULL, 'Uncharacterized protein', 162, NULL, NULL, 220165),
(220166, '2.60.40.10-FF-002248', NULL, 'Muscle M-line assembly protein unc-89', 97, NULL, NULL, 220166),
(220167, '1.10.3930.10-FF-000005', NULL, 'Arginine deiminase', 83, NULL, NULL, 220167),
(220168, '2.130.10.10-FF-005750', NULL, 'Predicted protein', 120, NULL, NULL, 220168),
(220169, '3.70.10.10-FF-000080', NULL, 'DNA polymerase sliding clamp', 247, NULL, NULL, 220169),
(220170, '1.25.40.10-FF-001376', NULL, 'Os05g0305300 protein', 147, NULL, NULL, 220170),
(220171, '1.20.58.1880-FF-000023', NULL, 'Protein CBG11880', 138, NULL, NULL, 220171),
(220172, '3.30.420.40-FF-000812', NULL, 'Uncharacterized protein', 30, NULL, NULL, 220172),
(220173, '1.10.510.10-FF-002885', NULL, 'Protein kinase, putative', 292, NULL, NULL, 220173),
(220174, '1.10.150.50-FF-000093', NULL, 'Sterile alpha motif domain-containing 7', 73, NULL, NULL, 220174),
(220175, '3.40.50.300-FF-001422', NULL, 'Cobalt ABC transporter ATP-binding protein', 259, NULL, NULL, 220175),
(220176, '1.20.5.1160-FF-000015', NULL, 'phakinin isoform X1', 115, NULL, NULL, 220176),
(220177, '1.20.1600.10-FF-000056', NULL, 'Slr1270 protein', 452, NULL, NULL, 220177),
(220178, '3.80.10.10-FF-003120', NULL, 'Uncharacterized protein', 89, NULL, NULL, 220178),
(220179, '2.40.70.10-FF-000210', NULL, 'Os09g0428200 protein', 207, NULL, NULL, 220179),
(220180, '3.30.1520.10-FF-000170', NULL, 'Vacuolar morphogenesis protein 7 homolog', 115, NULL, NULL, 220180),
(220181, '1.10.3140.10-FF-000001', NULL, '4-hydroxyphenylacetate 3-monooxygenase oxygenase component', 139, NULL, NULL, 220181),
(220182, '1.10.220.150-FF-000064', NULL, 'Uncharacterized protein', 132, NULL, NULL, 220182),
(220183, '3.80.10.10-FF-001883', NULL, 'Uncharacterized protein', 78, NULL, NULL, 220183),
(220184, '1.25.50.20-FF-000025', NULL, 'Protein CBG08739', 318, NULL, NULL, 220184),
(220185, '3.90.730.10-FF-000021', NULL, 'RiboNucleaSe T homolog', 220, NULL, NULL, 220185),
(220186, '1.25.40.20-FF-001688', NULL, 'Glutaminase, putative', 73, NULL, NULL, 220186);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(220187, '1.10.510.10-FF-002312', NULL, NULL, 221, NULL, NULL, 220187),
(220188, '3.30.505.10-FF-000146', NULL, NULL, 118, NULL, NULL, 220188),
(220189, '3.30.450.190-FF-000008', NULL, 'GTP-binding protein GTR2', 138, NULL, NULL, 220189),
(220190, '3.30.565.10-FF-000167', NULL, 'Probable two-component sensor', 148, NULL, NULL, 220190),
(220191, '1.25.40.10-FF-003837', NULL, 'Uncharacterized protein', 121, NULL, NULL, 220191),
(220192, '3.40.30.10-FF-001206', NULL, 'Iodothyronine deiodinase', 57, NULL, NULL, 220192),
(220193, '3.30.430.20-FF-000071', NULL, 'Os01g0568800 protein', 73, NULL, NULL, 220193),
(220194, '3.30.160.60-FF-004030', NULL, NULL, 30, NULL, NULL, 220194),
(220195, '2.60.120.1540-FF-000013', NULL, 'Complement 4B (Chido blood group)', 73, NULL, NULL, 220195),
(220196, '3.90.550.10-FF-000378', NULL, 'Uncharacterized protein', 236, NULL, NULL, 220196),
(220197, '2.30.29.30-FF-000430', NULL, 'Uncharacterized protein, isoform C', 120, NULL, NULL, 220197),
(220198, '2.30.30.40-FF-000402', NULL, 'Protein CBG22463', 77, NULL, NULL, 220198),
(220199, '1.20.1250.20-FF-000015', NULL, 'Nucleoside permease NupG', 210, NULL, NULL, 220199),
(220200, '3.40.50.300-FF-002395', NULL, 'GPN-loop GTPase 2', 279, NULL, NULL, 220200),
(220201, '1.10.472.10-FF-000525', NULL, 'Uncharacterized protein', 92, NULL, NULL, 220201),
(220202, '2.130.10.10-FF-001596', NULL, 'WD domain containing protein', 267, NULL, NULL, 220202),
(220203, '2.40.50.150-FF-000043', NULL, 'Uncharacterized protein', 127, NULL, NULL, 220203),
(220204, '1.10.418.10-FF-000124', NULL, 'Cortexillin-2', 119, NULL, NULL, 220204),
(220205, '3.20.180.20-FF-000008', NULL, 'Dynein heavy chain-like protein', 97, NULL, NULL, 220205),
(220206, '3.40.50.720-FF-000137', NULL, 'Hydroxysteroid (17-beta) dehydrogenase 3', 223, NULL, NULL, 220206),
(220207, '3.80.10.10-FF-001175', NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', 277, NULL, NULL, 220207),
(220208, '1.20.120.350-FF-000172', NULL, NULL, 158, NULL, NULL, 220208),
(220209, '2.60.120.1000-FF-000008', NULL, 'collagen alpha-1(XXIV) chain isoform X1', 121, NULL, NULL, 220209),
(220210, '2.60.40.10-FF-005862', NULL, NULL, 80, NULL, NULL, 220210),
(220211, '2.40.20.10-FF-000022', NULL, 'Uncharacterized protein', 91, NULL, NULL, 220211),
(220212, '2.20.110.10-FF-000050', NULL, NULL, 52, NULL, NULL, 220212),
(220213, '1.20.1270.10-FF-000120', NULL, 'Stress-70 protein, mitochondrial', 54, NULL, NULL, 220213),
(220214, '3.30.200.20-FF-002285', NULL, 'Uncharacterized protein', 90, NULL, NULL, 220214),
(220215, '1.25.10.10-FF-000795', NULL, 'Armadillo repeat containing 8', 324, NULL, NULL, 220215),
(220216, '1.10.1450.10-FF-000176', NULL, 'TetraSPanin family', 119, NULL, NULL, 220216),
(220217, '3.80.10.10-FF-001091', NULL, 'AGAP009688-PA', 65, NULL, NULL, 220217),
(220218, '1.10.238.10-FF-000470', NULL, 'EF-hand calcium-binding domain-containing protein', 153, NULL, NULL, 220218),
(220219, '1.20.1250.10-FF-000113', NULL, NULL, 162, NULL, NULL, 220219),
(220220, '3.40.50.1820-FF-001461', NULL, 'Serine carboxypeptidase-like 19', 180, NULL, NULL, 220220),
(220221, '1.10.510.10-FF-002677', NULL, NULL, 120, NULL, NULL, 220221),
(220222, '1.10.580.10-FF-000006', NULL, 'ATP-citrate synthase', 90, NULL, NULL, 220222),
(220223, '1.10.150.20-FF-000078', NULL, 'DNA-directed RNA polymerase subunit alpha', 76, NULL, NULL, 220223),
(220224, '2.40.30.10-FF-000101', NULL, 'Translation elongation factor G', 116, NULL, NULL, 220224),
(220225, '3.50.50.60-FF-000401', NULL, 'Protein CBG06141', 219, NULL, NULL, 220225),
(220226, '1.10.3080.10-FF-000063', NULL, 'Uncharacterized protein', 246, NULL, NULL, 220226),
(220227, '2.120.10.30-FF-000231', NULL, 'Haloacid dehalogenase-like hydrolase family', 139, NULL, NULL, 220227),
(220228, '2.170.8.10-FF-000015', NULL, 'Phosphoenolpyruvate carboxykinase [GTP], mitochondrial', 81, NULL, NULL, 220228),
(220229, '1.10.1300.10-FF-000081', NULL, 'Phosphodiesterase', 348, NULL, NULL, 220229),
(220230, '1.25.10.10-FF-000267', NULL, 'Proteasome activator complex subunit 4', 199, NULL, NULL, 220230);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(220231, '2.60.120.330-FF-000055', NULL, 'Uncharacterized protein', 336, NULL, NULL, 220231),
(220232, '3.20.20.30-FF-000026', NULL, 'Alkanesulfonate monooxygenase', 315, NULL, NULL, 220232),
(220233, '3.10.350.10-FF-000004', NULL, 'Membrane-bound lytic murein transglycosylase D', 46, NULL, NULL, 220233),
(220234, '3.40.50.1000-FF-000726', NULL, NULL, 78, NULL, NULL, 220234),
(220235, '4.10.400.10-FF-000269', NULL, 'Suppressor of tumorigenicity 14 protein homolog', 41, NULL, NULL, 220235),
(220236, '1.10.10.60-FF-001214', NULL, NULL, 80, NULL, NULL, 220236),
(220237, '2.20.20.110-FF-000007', NULL, 'Uncharacterized protein', 53, NULL, NULL, 220237),
(220238, '3.90.1150.10-FF-000116', NULL, 'Probable glycine dehydrogenase (decarboxylating) subunit 1', 101, NULL, NULL, 220238),
(220239, '2.130.10.10-FF-005879', NULL, 'Uncharacterized protein', 302, NULL, NULL, 220239),
(220240, '3.90.550.10-FF-000642', NULL, 'Hexosyltransferase', 159, NULL, NULL, 220240),
(220241, '1.10.10.60-FF-000702', NULL, 'SWIB complex BAF60b domain-containing protein', 57, NULL, NULL, 220241),
(220242, '3.40.50.1000-FF-000187', NULL, 'Ubiquitin-like domain containing CTD phosphatase 1', 136, NULL, NULL, 220242),
(220243, '3.40.30.40-FF-000001', NULL, 'Thiol-activated cytolysin', 129, NULL, NULL, 220243),
(220244, '3.30.40.10-FF-000257', NULL, 'zinc finger protein RFP', 84, NULL, NULL, 220244),
(220245, '1.10.532.10-FF-000013', NULL, 'Uncharacterized protein', 157, NULL, NULL, 220245),
(220246, '3.40.640.10-FF-000188', NULL, 'Unplaced genomic scaffold supercont1.10, whole genome shotgun sequence', 245, NULL, NULL, 220246),
(220247, '1.20.120.140-FF-000019', NULL, 'Signal recognition particle receptor FtsY', 84, NULL, NULL, 220247),
(220248, '2.130.10.10-FF-001225', NULL, 'WD repeat domain 59', 129, NULL, NULL, 220248),
(220249, '2.170.150.20-FF-000031', NULL, 'Uncharacterized protein', 78, NULL, NULL, 220249),
(220250, '1.10.555.10-FF-000049', NULL, 'Related to BEM3-GTPase-activating protein', 197, NULL, NULL, 220250),
(220251, '1.10.1170.10-FF-000019', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 109, NULL, NULL, 220251),
(220252, '2.30.29.30-FF-000975', NULL, 'Jnk interacting protein, putative', 94, NULL, NULL, 220252),
(220253, '2.60.40.1120-FF-000073', NULL, 'A kinase (PRKA)-interacting protein 1', 70, NULL, NULL, 220253),
(220254, '1.25.40.10-FF-000504', NULL, 'Serine/threonine-protein phosphatase', 68, NULL, NULL, 220254),
(220255, '1.20.1250.20-FF-001740', NULL, 'Os04g0452600 protein', 285, NULL, NULL, 220255),
(220256, '3.30.70.1170-FF-000009', NULL, 'Nucleolar protein-like', 70, NULL, NULL, 220256),
(220257, '1.20.120.1200-FF-000001', NULL, 'NADH-quinone oxidoreductase subunit J', 159, NULL, NULL, 220257),
(220258, '3.20.80.10-FF-000035', NULL, 'Uncharacterized protein', 141, NULL, NULL, 220258),
(220259, '3.30.160.60-FF-001017', NULL, 'Zinc finger protein 236 variant', 23, NULL, NULL, 220259),
(220260, '2.130.10.10-FF-005986', NULL, 'Uncharacterized protein', 228, NULL, NULL, 220260),
(220261, '2.60.40.60-FF-001122', NULL, 'Predicted protein', 52, NULL, NULL, 220261),
(220262, '1.20.210.10-FF-000005', NULL, 'Cytochrome c oxidase, cbb3-type, subunit I', 470, NULL, NULL, 220262),
(220263, '1.10.8.60-FF-000538', NULL, 'Uncharacterized protein', 65, NULL, NULL, 220263),
(220264, '2.130.10.10-FF-002321', NULL, 'WD40-repeat-containing domain protein', 265, NULL, NULL, 220264),
(220265, '2.60.40.10-FF-005755', NULL, NULL, 70, NULL, NULL, 220265),
(220266, '1.20.1230.10-FF-000011', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 269, NULL, NULL, 220266),
(220267, '3.30.40.10-FF-001792', NULL, 'Non-structural maintenance of chromosomes element 1 homolog-like Protein', 53, NULL, NULL, 220267),
(220268, '3.30.710.10-FF-000325', NULL, 'BTB and MATH domain-containing protein 41', 170, NULL, NULL, 220268),
(220269, '2.10.25.10-FF-000585', NULL, 'Delta-like 3 (Drosophila), isoform CRA_b', 51, NULL, NULL, 220269),
(220270, '1.10.510.10-FF-003301', NULL, NULL, 84, NULL, NULL, 220270);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(220271, '1.25.40.10-FF-004473', NULL, 'Uncharacterized protein', 240, NULL, NULL, 220271),
(220272, '2.130.10.10-FF-001697', NULL, 'WGS project CABT00000000 data, contig 2.1', 114, NULL, NULL, 220272),
(220273, '3.40.50.2300-FF-000341', NULL, 'DNA-binding response regulator', 81, NULL, NULL, 220273),
(220274, '2.160.20.10-FF-000218', NULL, 'Os01g0637500 protein', 297, NULL, NULL, 220274),
(220275, '2.130.10.10-FF-005194', NULL, 'TOPLESS-related 3', 112, NULL, NULL, 220275),
(220276, '3.40.50.300-FF-005593', NULL, 'Probable inactive serine/threonine-protein kinase roco10', 106, NULL, NULL, 220276),
(220277, '3.30.70.330-FF-002056', NULL, NULL, 146, NULL, NULL, 220277),
(220278, '1.10.10.10-FF-000643', NULL, 'Two-component system response regulator', 109, NULL, NULL, 220278),
(220279, '1.10.510.10-FF-000070', NULL, 'Tyrosine-protein kinase', 187, NULL, NULL, 220279),
(220280, '2.130.10.10-FF-003586', NULL, 'Aladin/adracalin/aaas, putative', 232, NULL, NULL, 220280),
(220281, '2.40.50.1070-FF-000017', NULL, '23S rRNA (uracil(1939)-C(5))-methyltransferase RlmD', 146, NULL, NULL, 220281),
(220282, '2.30.29.30-FF-000183', NULL, 'Oligophrenin 1', 110, NULL, NULL, 220282),
(220283, '3.40.50.80-FF-000109', NULL, 'Ferredoxin reductase component of carbazole', 127, NULL, NULL, 220283),
(220284, '2.60.120.650-FF-000038', NULL, 'Transcriptional repressor', 362, NULL, NULL, 220284),
(220285, '2.120.10.80-FF-000252', NULL, 'Galactose oxidase, central domain containing protein, putative', 123, NULL, NULL, 220285),
(220286, '3.30.160.60-FF-002641', NULL, 'Fog: zn-finger', 32, NULL, NULL, 220286),
(220287, '1.20.120.1220-FF-000007', NULL, 'Type 4 prepilin-like proteins leader peptide-processing enzyme', 145, NULL, NULL, 220287),
(220288, '2.40.37.10-FF-000015', NULL, 'Alanine racemase', 148, NULL, NULL, 220288),
(220289, '3.90.226.10-FF-000153', NULL, 'Polyketide biosynthesis enoyl-CoA hydratase', 180, NULL, NULL, 220289),
(220290, '3.90.1720.10-FF-000025', NULL, 'Uncharacterized protein', 172, NULL, NULL, 220290),
(220291, '3.40.50.300-FF-007026', NULL, 'Uncharacterized protein', 205, NULL, NULL, 220291),
(220292, '1.20.1090.10-FF-000022', NULL, 'Iron-containing alcohol dehydrogenase', 152, NULL, NULL, 220292),
(220293, '3.30.70.330-FF-002163', NULL, NULL, 160, NULL, NULL, 220293),
(220294, '1.10.1070.11-FF-000108', NULL, 'Uncharacterized protein', 223, NULL, NULL, 220294),
(220295, '3.60.21.10-FF-000358', NULL, 'Uncharacterized protein', 147, NULL, NULL, 220295),
(220296, '2.120.10.80-FF-000145', NULL, 'acyl-CoA-binding domain-containing protein 4 isoform X1', 193, NULL, NULL, 220296),
(220297, '3.30.450.40-FF-000302', NULL, 'Two-component hybrid sensor and regulator', 175, NULL, NULL, 220297),
(220298, '2.40.30.170-FF-000045', NULL, NULL, 70, NULL, NULL, 220298),
(220299, '3.40.350.10-FF-000071', NULL, 'Predicted protein', 165, NULL, NULL, 220299),
(220300, '1.10.287.540-FF-000006', NULL, 'Pyrrolysyl-tRNA synthetase', 69, NULL, NULL, 220300),
(220301, '3.90.226.10-FF-000260', NULL, 'Uncharacterized protein', 160, NULL, NULL, 220301),
(220302, '3.90.230.10-FF-000039', NULL, 'Metallopeptidase_family_M24_-_putative', 290, NULL, NULL, 220302),
(220303, '1.25.40.10-FF-002112', NULL, 'Pentatricopeptide repeat-containing protein At5g46460, mitochondrial', 117, NULL, NULL, 220303),
(220304, '3.60.60.10-FF-000004', NULL, 'Bile salt hydrolase', 316, NULL, NULL, 220304),
(220305, '3.40.50.1980-FF-000115', NULL, 'ABC transporter substrate-binding protein', 111, NULL, NULL, 220305),
(220306, '3.30.70.330-FF-002533', NULL, NULL, 53, NULL, NULL, 220306),
(220307, '3.40.50.300-FF-008347', NULL, 'Uncharacterized protein', 150, NULL, NULL, 220307),
(220308, '2.40.270.10-FF-000034', NULL, NULL, 133, NULL, NULL, 220308),
(220309, '3.30.710.10-FF-000432', NULL, 'Uncharacterized protein', 75, NULL, NULL, 220309),
(220310, '2.40.50.740-FF-000006', NULL, '30S ribosomal protein S4e', 52, NULL, NULL, 220310),
(220311, '1.10.10.10-FF-001576', NULL, 'Ferric-uptake regulator', 72, NULL, NULL, 220311),
(220312, '2.60.34.10-FF-000019', NULL, 'Heat shock 70 kDa protein 8', 116, NULL, NULL, 220312);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(220313, '2.40.50.180-FF-000013', NULL, 'Putative purine-binding chemotaxis protein Chew', 68, NULL, NULL, 220313),
(220314, '2.60.40.10-FF-002349', NULL, 'CD4-2 molecule, tandem duplicate 2', 74, NULL, NULL, 220314),
(220315, '1.10.1420.10-FF-000039', NULL, 'DNA mismatch repair protein', 178, NULL, NULL, 220315),
(220316, '3.30.1360.170-FF-000019', NULL, 'Flavin-dependent thymidylate synthase', 149, NULL, NULL, 220316),
(220317, '1.20.58.2220-FF-000058', NULL, 'Predicted protein', 97, NULL, NULL, 220317),
(220318, '1.25.40.10-FF-001123', NULL, 'UTP6 small subunit processome component', 244, NULL, NULL, 220318),
(220319, '2.30.170.30-FF-000001', NULL, 'Ethanolamine ammonia-lyase heavy chain', 54, NULL, NULL, 220319),
(220320, '1.10.418.10-FF-000040', NULL, 'Calponin', 136, NULL, NULL, 220320),
(220321, '3.40.50.2300-FF-001206', NULL, NULL, 87, NULL, NULL, 220321),
(220322, '1.25.40.10-FF-000095', NULL, 'Clathrin heavy chain', 218, NULL, NULL, 220322),
(220323, '2.60.470.10-FF-000011', NULL, 'Pickpocket 23, isoform C', 158, NULL, NULL, 220323),
(220324, '3.30.160.60-FF-000168', NULL, 'zinc finger protein Eos isoform X1', 26, NULL, NULL, 220324),
(220325, '1.10.555.10-FF-000156', NULL, NULL, 100, NULL, NULL, 220325),
(220326, '2.30.29.30-FF-001178', NULL, 'AGC family protein kinase', 90, NULL, NULL, 220326),
(220327, '3.80.10.10-FF-001411', NULL, 'Uncharacterized protein', 284, NULL, NULL, 220327),
(220328, '3.30.40.10-FF-001246', NULL, 'Zinc finger protein, putative', 67, NULL, NULL, 220328),
(220329, '3.40.30.10-FF-000823', NULL, 'Iodothyronine deiodinase', 62, NULL, NULL, 220329),
(220330, '1.10.238.10-FF-001240', NULL, 'Uncharacterized protein', 91, NULL, NULL, 220330),
(220331, '1.10.510.10-FF-003296', NULL, NULL, 86, NULL, NULL, 220331),
(220332, '3.40.50.300-FF-002720', NULL, 'GTP-binding family protein', 189, NULL, NULL, 220332),
(220333, '3.40.190.10-FF-000445', NULL, 'Accessory colonization factor AcfC', 113, NULL, NULL, 220333),
(220334, '1.25.40.10-FF-004366', NULL, 'Uncharacterized protein', 363, NULL, NULL, 220334),
(220335, '3.30.160.60-FF-002422', NULL, NULL, 30, NULL, NULL, 220335),
(220336, '3.10.290.10-FF-000049', NULL, 'Pseudouridine synthase', 55, NULL, NULL, 220336),
(220337, '1.20.1050.10-FF-000132', NULL, 'Related to ECM4-protein involved in cell wall biogenesis and architecture', 143, NULL, NULL, 220337),
(220338, '2.60.40.10-FF-003973', NULL, NULL, 129, NULL, NULL, 220338),
(220339, '1.25.40.10-FF-003854', NULL, 'Uncharacterized protein', 112, NULL, NULL, 220339),
(220340, '3.40.225.10-FF-000055', NULL, NULL, 114, NULL, NULL, 220340),
(220341, '1.10.3120.10-FF-000011', NULL, 'Trigger factor', 214, NULL, NULL, 220341),
(220342, '2.30.29.30-FF-001048', NULL, 'Uncharacterized protein', 64, NULL, NULL, 220342),
(220343, '1.10.3720.10-FF-000045', NULL, 'Peptide ABC transporter permease', 216, NULL, NULL, 220343),
(220344, '1.25.40.10-FF-005294', NULL, 'Uncharacterized protein', 136, NULL, NULL, 220344),
(220345, '1.20.1110.10-FF-000103', NULL, 'Plasma membrane calcium-transporting ATPase 2', 408, NULL, NULL, 220345),
(220346, '3.30.1390.20-FF-000038', NULL, 'Ribosomal protein, putative', 44, NULL, NULL, 220346),
(220347, '1.10.760.10-FF-000104', NULL, 'Os07g0567400 protein', 44, NULL, NULL, 220347),
(220348, '1.10.340.70-FF-000023', NULL, 'Polyprotein of viral origin, putative', 57, NULL, NULL, 220348),
(220349, '1.10.238.10-FF-000251', NULL, 'Calmodulin-related protein 97A', 78, NULL, NULL, 220349),
(220350, '2.30.130.10-FF-000032', NULL, 'Probable tRNA pseudouridine synthase B', 84, NULL, NULL, 220350),
(220351, '3.40.50.300-FF-007498', NULL, 'ABC transporter protein', 223, NULL, NULL, 220351),
(220352, '1.10.101.10-FF-000029', NULL, 'Bll5205 protein', 61, NULL, NULL, 220352),
(220353, '2.60.40.60-FF-000649', NULL, 'Uncharacterized protein', 116, NULL, NULL, 220353),
(220354, '3.60.10.10-FF-000288', NULL, 'Inositol polyphosphate-5-phosphatase, 40kDa, gene 2', 149, NULL, NULL, 220354),
(220355, '3.40.50.300-FF-002355', NULL, 'Drugs ABC transporter ATP-binding protein', 251, NULL, NULL, 220355);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(220356, '3.30.260.10-FF-000015', NULL, 'T-complex protein 1 subunit gamma', 110, NULL, NULL, 220356),
(220357, '1.10.10.10-FF-001929', NULL, 'MarR family transcriptional regulatory protein', 144, NULL, NULL, 220357),
(220358, '3.30.160.60-FF-000663', NULL, 'Zinc finger protein 45', 29, NULL, NULL, 220358),
(220359, '3.30.2010.10-FF-000007', NULL, 'Peptidase M48 family protein', 89, NULL, NULL, 220359),
(220360, '1.20.58.530-FF-000024', NULL, 'Myosin heavy chain subunit', 44, NULL, NULL, 220360),
(220361, '3.30.420.10-FF-000680', NULL, NULL, 162, NULL, NULL, 220361),
(220362, '2.60.40.1510-FF-000055', NULL, 'Uncharacterized protein', 77, NULL, NULL, 220362),
(220363, '3.30.420.40-FF-000109', NULL, 'Heat shock 70 kDa protein-like', 90, NULL, NULL, 220363),
(220364, '1.10.238.10-FF-000627', NULL, 'Inorganic pyrophosphatase', 79, NULL, NULL, 220364),
(220365, '1.10.287.110-FF-000332', NULL, 'Uncharacterized protein', 84, NULL, NULL, 220365),
(220366, '3.40.50.150-FF-000399', NULL, 'S-adenosyl-L-methionine-dependent methyltransferase', 288, NULL, NULL, 220366),
(220367, '2.30.30.40-FF-000138', NULL, 'dynamin-binding protein isoform X1', 68, NULL, NULL, 220367),
(220368, '3.10.110.10-FF-000110', NULL, 'Ubiquitin-conjugating enzyme family protein', 149, NULL, NULL, 220368),
(220369, '3.40.50.1820-FF-001725', NULL, 'Putative isoprenylcysteine alpha-carbonyl methylesterase ICMEL2', 107, NULL, NULL, 220369),
(220370, '1.20.1310.10-FF-000045', NULL, 'Cullin-3', 103, NULL, NULL, 220370),
(220371, '3.30.70.960-FF-000007', NULL, 'Enteropeptidase', 97, NULL, NULL, 220371),
(220372, '3.10.600.10-FF-000001', NULL, 'Pyruvate carboxylase', 60, NULL, NULL, 220372),
(220373, '2.30.42.10-FF-000522', NULL, NULL, 68, NULL, NULL, 220373),
(220374, '3.40.50.1820-FF-000314', NULL, 'Protein CBG08019', 292, NULL, NULL, 220374),
(220375, '1.20.1250.20-FF-001870', NULL, 'Uncharacterized protein', 109, NULL, NULL, 220375),
(220376, '3.40.630.30-FF-000587', NULL, 'Uncharacterized protein', 91, NULL, NULL, 220376),
(220377, '3.50.30.30-FF-000020', NULL, 'Receptor homology region transmembrane domain-and RING domain-containing protein 2', 135, NULL, NULL, 220377),
(220378, '1.10.1520.10-FF-000075', NULL, 'RNAse III, putative (AFU_orthologue AFUA_3G03050)', 132, NULL, NULL, 220378),
(220379, '3.90.470.20-FF-000003', NULL, 'L-aminoadipate-semialdehyde dehydrogenase-phosphopantetheinyl transferase', 125, NULL, NULL, 220379),
(220380, '3.30.70.1470-FF-000004', NULL, 'Caspase, apoptotic cysteine protease, putative', 100, NULL, NULL, 220380),
(220381, '1.20.1530.20-FF-000071', NULL, 'Cation/H(+) antiporter 15', 143, NULL, NULL, 220381),
(220382, '3.10.20.90-FF-000556', NULL, 'Novel protein similar to KIAA1548', 61, NULL, NULL, 220382),
(220383, '3.30.420.380-FF-000003', NULL, 'MSHA biogenesis protein MshI', 149, NULL, NULL, 220383),
(220384, '1.20.5.540-FF-000005', NULL, 'Uncharacterized protein', 31, NULL, NULL, 220384),
(220385, '3.90.550.10-FF-000147', NULL, 'Galactosylgalactosylxylosylprotein 3-beta-glucuronosyltransferase', 241, NULL, NULL, 220385),
(220386, '1.20.1070.10-FF-001004', NULL, 'Uncharacterized protein', 323, NULL, NULL, 220386),
(220387, '3.40.50.1760-FF-000021', NULL, NULL, 153, NULL, NULL, 220387),
(220388, '1.20.1690.10-FF-000005', NULL, 'V-type proton ATPase subunit', 103, NULL, NULL, 220388),
(220389, '2.30.30.40-FF-000633', NULL, 'Predicted protein', 85, NULL, NULL, 220389),
(220390, '3.30.1360.120-FF-000067', NULL, 'Sarcosine dehydrogenase, mitochondrial', 207, NULL, NULL, 220390),
(220391, '1.10.510.10-FF-002205', NULL, 'Predicted protein', 236, NULL, NULL, 220391),
(220392, '2.70.130.10-FF-000028', NULL, 'Mannose-6-phosphate/insulin-like growth factor II receptor', 144, NULL, NULL, 220392),
(220393, '3.40.50.150-FF-000719', NULL, 'Cytosine-specific DNA methyltransferase', 187, NULL, NULL, 220393),
(220394, '3.40.50.300-FF-005121', NULL, 'Lipopolysaccharide export system ATP-binding protein', 250, NULL, NULL, 220394),
(220395, '3.80.10.10-FF-002400', NULL, 'F-box domain protein (AFU_orthologue AFUA_2G02860)', 54, NULL, NULL, 220395);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(220396, '3.40.50.1100-FF-000290', NULL, 'Predicted protein', 117, NULL, NULL, 220396),
(220397, '2.40.50.140-FF-000613', NULL, 'Protein Translation Initiation Factor 2 subunit alpha (IF-2a)', 88, NULL, NULL, 220397),
(220398, '1.10.1000.11-FF-000014', NULL, 'Uncharacterized protein', 118, NULL, NULL, 220398),
(220399, '3.40.50.1780-FF-000027', NULL, 'Uncharacterized protein', 137, NULL, NULL, 220399),
(220400, '3.30.70.270-FF-000104', NULL, 'Heme-regulated cyclic AMP phosphodiesterase (Direct oxygen sensor protein)', 172, NULL, NULL, 220400),
(220401, '3.30.160.60-FF-002113', NULL, 'Zinc finger protein 331', 32, NULL, NULL, 220401),
(220402, '3.30.70.330-FF-001128', NULL, 'CUGBP Elav-like family member 2', 79, NULL, NULL, 220402),
(220403, '1.25.40.10-FF-000634', NULL, 'Prolyl 3-hydroxylase 2', 63, NULL, NULL, 220403),
(220404, '2.130.10.10-FF-004098', NULL, 'Uncharacterized protein', 197, NULL, NULL, 220404),
(220405, '1.10.20.10-FF-000132', NULL, 'CBF/NF-Y family transcription factor, putative', 99, NULL, NULL, 220405),
(220406, '3.40.50.300-FF-006407', NULL, 'Uncharacterized protein', 132, NULL, NULL, 220406),
(220407, '3.90.70.10-FF-000627', NULL, 'Dipeptidyl peptidase 1', 131, NULL, NULL, 220407),
(220408, '3.30.70.330-FF-003152', NULL, NULL, 108, NULL, NULL, 220408),
(220409, '3.80.10.10-FF-001776', NULL, 'Uncharacterized protein', 179, NULL, NULL, 220409),
(220410, '3.30.70.660-FF-000007', NULL, 'tRNA pseudouridine synthase', 139, NULL, NULL, 220410),
(220411, '2.60.40.10-FF-002192', NULL, 'AGAP005471-PA', 112, NULL, NULL, 220411),
(220412, '3.40.50.620-FF-000309', NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', 278, NULL, NULL, 220412),
(220413, '3.40.50.720-FF-000795', NULL, 'Short chain dehydrogenase', 262, NULL, NULL, 220413),
(220414, '1.25.40.10-FF-002073', NULL, 'TTK protein kinase', 158, NULL, NULL, 220414),
(220415, '3.30.160.60-FF-005991', NULL, NULL, 47, NULL, NULL, 220415),
(220416, '3.30.1460.50-FF-000013', NULL, 'Autophagy-related protein Atg10 (JCVI)', 193, NULL, NULL, 220416),
(220417, '3.80.10.10-FF-003209', NULL, 'Uncharacterized protein', 222, NULL, NULL, 220417),
(220418, '3.30.70.100-FF-000188', NULL, NULL, 69, NULL, NULL, 220418),
(220419, '1.20.1070.10-FF-000801', NULL, 'Predicted protein', 332, NULL, NULL, 220419),
(220420, '2.40.50.140-FF-000136', NULL, 'cold shock domain-containing protein E1 isoform X1', 60, NULL, NULL, 220420),
(220421, '3.80.10.10-FF-003884', NULL, 'Leucine-rich repeat (LRR) family protein', 159, NULL, NULL, 220421),
(220422, '3.10.20.10-FF-000009', NULL, 'Uncharacterized protein, isoform A', 85, NULL, NULL, 220422),
(220423, '2.170.270.10-FF-000121', NULL, 'Histone-lysine N-methyltransferase', 278, NULL, NULL, 220423),
(220424, '3.40.1380.10-FF-000004', NULL, 'ATP synthase gamma chain, chloroplastic', 124, NULL, NULL, 220424),
(220425, '1.25.40.20-FF-000963', NULL, 'calmodulin-binding transcription activator 2-like isoform X2', 148, NULL, NULL, 220425),
(220426, '1.20.1420.30-FF-000071', NULL, 'Sodium-calcium exchanger', 227, NULL, NULL, 220426),
(220427, '3.80.10.10-FF-003704', NULL, 'Predicted protein', 162, NULL, NULL, 220427),
(220428, '3.30.420.40-FF-001054', NULL, 'Actin-related protein 8', 121, NULL, NULL, 220428),
(220429, '2.60.120.200-FF-000252', NULL, 'Crumbs 1, cell polarity complex component', 167, NULL, NULL, 220429),
(220430, '1.10.10.10-FF-000626', NULL, 'MarR family transcriptional regulator', 155, NULL, NULL, 220430),
(220431, '1.50.10.20-FF-000060', NULL, 'Terpentedienyl-diphosphate synthase', 217, NULL, NULL, 220431),
(220432, '1.25.40.10-FF-002421', NULL, 'Pentatricopeptide repeat-containing protein At1g09410, mitochondrial', 161, NULL, NULL, 220432),
(220433, '3.40.50.300-FF-006082', NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 8', 154, NULL, NULL, 220433),
(220434, '3.40.50.80-FF-000126', NULL, 'Probable oxidoreductase', 142, NULL, NULL, 220434),
(220435, '2.130.10.10-FF-002630', NULL, 'Autophagy-related protein 18b', 141, NULL, NULL, 220435),
(220436, '3.30.230.10-FF-000406', NULL, 'Ribosomal protein S5, putative', 74, NULL, NULL, 220436);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(220437, '2.130.10.120-FF-000033', NULL, 'Predicted protein', 32, NULL, NULL, 220437),
(220438, '3.80.10.10-FF-003356', NULL, 'Uncharacterized protein', 114, NULL, NULL, 220438),
(220439, '1.10.472.10-FF-000334', NULL, 'AGAP001730-PA', 103, NULL, NULL, 220439),
(220440, '3.30.870.10-FF-000033', NULL, 'Phospholipase', 69, NULL, NULL, 220440),
(220441, '1.25.10.10-FF-000486', NULL, 'SCY1 protein kinase', 271, NULL, NULL, 220441),
(220442, '3.30.930.10-FF-000319', NULL, 'Uncharacterized protein', 251, NULL, NULL, 220442),
(220443, '2.60.40.10-FF-000409', NULL, 'Muscle, skeletal receptor tyrosine protein kinase', 94, NULL, NULL, 220443),
(220444, '2.60.40.10-FF-004451', NULL, NULL, 110, NULL, NULL, 220444),
(220445, '3.40.850.10-FF-000125', NULL, 'Kinesin class 4 (Chromokinesin group)', 439, NULL, NULL, 220445),
(220446, '2.30.29.30-FF-000559', NULL, 'CDC-42 Guanine nucleotide Exchange Factor', 149, NULL, NULL, 220446),
(220447, '3.30.70.330-FF-000274', NULL, 'Heterogeneous nuclear ribonucleoprotein A3 2', 82, NULL, NULL, 220447),
(220448, '2.10.220.10-FF-000105', NULL, 'Tyrosine-protein kinase receptor', 73, NULL, NULL, 220448),
(220449, '3.30.390.30-FF-000002', NULL, 'Soluble pyridine nucleotide transhydrogenase', 121, NULL, NULL, 220449),
(220450, '2.60.120.920-FF-000142', NULL, 'Uncharacterized protein', 193, NULL, NULL, 220450),
(220451, '3.30.40.10-FF-002202', NULL, 'Uncharacterized protein', 73, NULL, NULL, 220451),
(220452, '3.40.50.1010-FF-000263', NULL, NULL, 164, NULL, NULL, 220452),
(220453, '2.130.10.10-FF-000736', NULL, 'Cleavage stimulation factor subunit 50', 331, NULL, NULL, 220453),
(220454, '3.90.1140.10-FF-000054', NULL, 'Predicted protein', 199, NULL, NULL, 220454),
(220455, '1.25.70.10-FF-000023', NULL, 'Os05g0403600 protein', 92, NULL, NULL, 220455),
(220456, '3.40.50.300-FF-007818', NULL, 'Uncharacterized protein', 279, NULL, NULL, 220456),
(220457, '3.40.50.1820-FF-000769', NULL, 'Protein phosphatase methylesterase 1', 287, NULL, NULL, 220457),
(220458, '1.20.1110.10-FF-000064', NULL, 'Cation transporting ATPase', 258, NULL, NULL, 220458),
(220459, '3.30.760.10-FF-000036', NULL, 'Protein Translation Initiation Factor 4E (IF-4E)', 167, NULL, NULL, 220459),
(220460, '2.120.10.80-FF-000128', NULL, 'tRNA wybutosine-synthesizing protein 2/3/4', 188, NULL, NULL, 220460),
(220461, '2.60.40.10-FF-001028', NULL, 'Roundabout guidance receptor 3', 108, NULL, NULL, 220461),
(220462, '3.40.50.2300-FF-001195', NULL, NULL, 148, NULL, NULL, 220462),
(220463, '3.20.20.60-FF-000024', NULL, 'Isocitrate lyase', 127, NULL, NULL, 220463),
(220464, '3.40.720.10-FF-000228', NULL, 'Uncharacterized protein', 278, NULL, NULL, 220464),
(220465, '3.30.420.40-FF-000093', NULL, 'Fructokinase', 121, NULL, NULL, 220465),
(220466, '4.10.1240.10-FF-000056', NULL, 'Putative g protein-coupled receptor', 58, NULL, NULL, 220466),
(220467, '2.70.170.10-FF-000065', NULL, 'Glutamate-gated chloride channel, putative', 161, NULL, NULL, 220467),
(220468, '1.10.357.50-FF-000016', NULL, 'protein unc-13 homolog D isoform X1', 178, NULL, NULL, 220468),
(220469, '2.130.10.10-FF-002097', NULL, 'Transducin family protein / WD-40 repeat family protein', 220, NULL, NULL, 220469),
(220470, '3.30.160.60-FF-004906', NULL, NULL, 71, NULL, NULL, 220470),
(220471, '2.40.160.210-FF-000009', NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 283, NULL, NULL, 220471),
(220472, '1.10.10.60-FF-000725', NULL, 'C. Elegans Homeobox', 81, NULL, NULL, 220472),
(220473, '3.30.390.50-FF-000008', NULL, 'Lipoate--protein ligase', 87, NULL, NULL, 220473),
(220474, '1.25.40.70-FF-000045', NULL, 'Phosphatidylinositol 3-kinase, putative', 209, NULL, NULL, 220474),
(220475, '1.10.287.600-FF-000018', NULL, 'Uncharacterized protein', 55, NULL, NULL, 220475),
(220476, '3.30.70.890-FF-000054', NULL, 'Mevalonate kinase', 124, NULL, NULL, 220476),
(220477, '3.40.47.10-FF-000098', NULL, 'Uncharacterized protein B0303.3', 429, NULL, NULL, 220477),
(220478, '3.60.40.10-FF-000121', NULL, 'Probable protein phosphatase 2C 51', 307, NULL, NULL, 220478),
(220479, '3.20.20.80-FF-000108', NULL, 'glycogen debranching enzyme', 199, NULL, NULL, 220479);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(220480, '3.40.50.300-FF-007043', NULL, 'Putative RAD51C', 200, NULL, NULL, 220480),
(220481, '1.10.418.20-FF-000026', NULL, 'Si:dkey-100n23.3', 28, NULL, NULL, 220481),
(220482, '1.20.120.1780-FF-000006', NULL, 'Digeranylgeranylglyceryl phosphate synthase', 126, NULL, NULL, 220482),
(220483, '3.40.50.720-FF-002138', NULL, 'Ubiquitin-like modifier-activating enzyme 7', 97, NULL, NULL, 220483),
(220484, '3.30.160.60-FF-003041', NULL, 'GG12054', 55, NULL, NULL, 220484),
(220485, '3.30.160.60-FF-001949', NULL, 'zinc finger protein 62 homolog isoform X2', 28, NULL, NULL, 220485),
(220486, '1.10.3380.10-FF-000075', NULL, 'Uncharacterized protein', 144, NULL, NULL, 220486),
(220487, '3.10.20.90-FF-000180', NULL, 'midnolin isoform X1', 82, NULL, NULL, 220487),
(220488, '2.60.40.10-FF-005446', NULL, NULL, 92, NULL, NULL, 220488),
(220489, '3.40.50.1980-FF-000076', NULL, 'Iron-dicitrate ABC transporter substrate-binding protein', 179, NULL, NULL, 220489),
(220490, '1.20.1510.10-FF-000049', NULL, 'Cation transporter', 205, NULL, NULL, 220490),
(220491, '2.120.10.30-FF-000607', NULL, 'Uncharacterized protein', 129, NULL, NULL, 220491),
(220492, '3.30.450.30-FF-000075', NULL, 'Profilin', 140, NULL, NULL, 220492),
(220493, '3.10.105.10-FF-000036', NULL, 'Peptide/nickel transport system substrate-binding protein', 223, NULL, NULL, 220493),
(220494, '1.10.3260.10-FF-000021', NULL, 'ATP-dependent DNA ligase', 182, NULL, NULL, 220494),
(220495, '3.30.160.60-FF-002894', NULL, 'AGAP010979-PA', 20, NULL, NULL, 220495),
(220496, '1.10.1300.10-FF-000064', NULL, 'Phosphodiesterase 4B, cAMP-specific a', 163, NULL, NULL, 220496),
(220497, '1.25.40.530-FF-000010', NULL, 'Myosin VIIA', 147, NULL, NULL, 220497),
(220498, '2.10.25.10-FF-000169', NULL, 'teneurin-1 isoform X1', 34, NULL, NULL, 220498),
(220499, '3.40.50.2020-FF-000144', NULL, 'Uncharacterized protein', 208, NULL, NULL, 220499),
(220500, '3.30.70.3220-FF-000001', NULL, 'Multifunctional fusion protein', 146, NULL, NULL, 220500),
(220501, '3.80.10.10-FF-002395', NULL, 'Protein phosphatase 1, regulatory subunit, putative', 90, NULL, NULL, 220501),
(220502, '1.20.5.340-FF-000052', NULL, 'Myosin heavy chain 6', 109, NULL, NULL, 220502),
(220503, '2.40.70.10-FF-000525', NULL, NULL, 24, NULL, NULL, 220503),
(220504, '1.10.510.10-FF-003610', NULL, NULL, 199, NULL, NULL, 220504),
(220505, '3.30.70.330-FF-001763', NULL, NULL, 17, NULL, NULL, 220505),
(220506, '2.30.29.220-FF-000004', NULL, 'FACT complex subunit SSRP1', 86, NULL, NULL, 220506),
(220507, '1.10.8.60-FF-000292', NULL, 'p60 katanin/ AAA family protein', 16, NULL, NULL, 220507),
(220508, '3.30.70.330-FF-000616', NULL, 'RNA binding (RRM/RBD/RNP motifs) family protein', 132, NULL, NULL, 220508),
(220509, '3.30.160.60-FF-002006', NULL, 'Zinc finger protein 668', 26, NULL, NULL, 220509),
(220510, '3.40.720.10-FF-000245', NULL, 'Uncharacterized protein', 211, NULL, NULL, 220510),
(220511, '2.60.120.260-FF-000663', NULL, 'Uncharacterized protein', 125, NULL, NULL, 220511),
(220512, '2.30.42.10-FF-000045', NULL, 'Tyrosine-protein phosphatase non-receptor type', 106, NULL, NULL, 220512),
(220513, '1.25.40.10-FF-002449', NULL, 'Uncharacterized protein', 75, NULL, NULL, 220513),
(220514, '2.30.30.380-FF-000026', NULL, 'Nei-like DNA glycosylase 3', 51, NULL, NULL, 220514),
(220515, '1.10.287.10-FF-000038', NULL, 'Uncharacterized protein', 37, NULL, NULL, 220515),
(220516, '3.40.1810.10-FF-000009', NULL, 'agamous-like MADS-box protein AGL11', 84, NULL, NULL, 220516),
(220517, '2.120.10.30-FF-000124', NULL, 'Uncharacterized protein, isoform B', 304, NULL, NULL, 220517),
(220518, '2.60.40.60-FF-000166', NULL, 'cadherin-23 isoform X1', 111, NULL, NULL, 220518),
(220519, '2.30.29.30-FF-000666', NULL, 'Oxysterol-binding protein', 94, NULL, NULL, 220519),
(220520, '3.20.20.370-FF-000031', NULL, 'Carbohydrate deacetylase', 264, NULL, NULL, 220520),
(220521, '2.40.160.210-FF-000026', NULL, 'Uncharacterized protein', 214, NULL, NULL, 220521),
(220522, '3.40.50.2000-FF-000239', NULL, 'Trehalose-phosphatase, variant', 191, NULL, NULL, 220522);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(220523, '3.30.2310.20-FF-000016', NULL, 'Toxin RelE3', 89, NULL, NULL, 220523),
(220524, '3.40.630.60-FF-000005', NULL, 'Ornithine decarboxylase antizyme, isoform B', 140, NULL, NULL, 220524),
(220525, '1.25.40.10-FF-004001', NULL, 'RNA polymerase II protein ral transcription factor BTF3, putative', 208, NULL, NULL, 220525),
(220526, '2.10.25.10-FF-001097', NULL, 'Low-density lipoprotein receptor-related protein', 41, NULL, NULL, 220526),
(220527, '2.10.25.10-FF-000478', NULL, 'Integrin beta', 31, NULL, NULL, 220527),
(220528, '1.20.58.340-FF-000074', NULL, 'Uncharacterized protein', 96, NULL, NULL, 220528),
(220529, '2.40.10.10-FF-000549', NULL, NULL, 134, NULL, NULL, 220529),
(220530, '2.40.30.10-FF-000320', NULL, 'tRNA-specific 2-thiouridylase MnmA', 94, NULL, NULL, 220530),
(220531, '3.10.100.10-FF-000284', NULL, NULL, 78, NULL, NULL, 220531),
(220532, '3.30.559.30-FF-000001', NULL, 'Non-ribosomal peptide synthetase', 225, NULL, NULL, 220532),
(220533, '1.25.10.10-FF-002245', NULL, 'Uncharacterized protein', 376, NULL, NULL, 220533),
(220534, '3.30.1370.210-FF-000028', NULL, 'Uncharacterized protein', 58, NULL, NULL, 220534),
(220535, '2.60.40.10-FF-005070', NULL, NULL, 100, NULL, NULL, 220535),
(220536, '1.10.238.10-FF-000599', NULL, 'Reticulocalbin-3', 85, NULL, NULL, 220536),
(220537, '1.25.40.10-FF-003377', NULL, 'Pentatricopeptide repeat-containing protein At3g04760, chloroplastic', 162, NULL, NULL, 220537),
(220538, '3.40.850.10-FF-000434', NULL, 'Uncharacterized protein', 149, NULL, NULL, 220538),
(220539, '1.20.120.290-FF-000002', NULL, 'Photosynthetic NDH subunit of lumenal location 2, chloroplastic', 143, NULL, NULL, 220539),
(220540, '1.10.150.20-FF-000117', NULL, 'Translocation protein SEC63', 57, NULL, NULL, 220540),
(220541, '3.40.30.10-FF-000003', NULL, 'Peroxiredoxin 1', 197, NULL, NULL, 220541),
(220542, '2.40.30.10-FF-000096', NULL, 'tRNA-specific 2-thiouridylase MnmA', 83, NULL, NULL, 220542),
(220543, '3.30.40.10-FF-002174', NULL, 'Uncharacterized protein', 83, NULL, NULL, 220543),
(220544, '2.70.20.10-FF-000015', NULL, 'DNA topoisomerase 1', 69, NULL, NULL, 220544),
(220545, '2.60.40.10-FF-000084', NULL, 'Myosin binding protein C, slow type', 99, NULL, NULL, 220545),
(220546, '3.10.100.10-FF-000323', NULL, NULL, 141, NULL, NULL, 220546),
(220547, '3.80.10.10-FF-001759', NULL, 'Toll-like receptor 19', 215, NULL, NULL, 220547),
(220548, '2.60.40.10-FF-004142', NULL, NULL, 115, NULL, NULL, 220548),
(220549, '2.60.200.20-FF-000219', NULL, 'Bromo and FHA domain-containing protein DDB_G0267958', 112, NULL, NULL, 220549),
(220550, '3.10.310.70-FF-000002', NULL, 'LAF3/LAF3 ISF1/LAF3 ISF2', 119, NULL, NULL, 220550),
(220551, '3.40.30.10-FF-000930', NULL, 'Uncharacterized protein', 120, NULL, NULL, 220551),
(220552, '3.40.390.10-FF-000207', NULL, 'Fra mauro, isoform F', 256, NULL, NULL, 220552),
(220553, '1.20.1270.60-FF-000011', NULL, 'Brain-specific angiogenesis inhibitor 1-associated protein 2', 249, NULL, NULL, 220553),
(220554, '1.10.730.10-FF-000081', NULL, 'Leucine--tRNA ligase', 165, NULL, NULL, 220554),
(220555, '2.60.40.150-FF-000239', NULL, 'Calcium-dependent secretion activator', 119, NULL, NULL, 220555),
(220556, '1.20.1070.10-FF-001420', NULL, 'Uncharacterized protein', 230, NULL, NULL, 220556),
(220557, '2.60.40.10-FF-000556', NULL, 'Immunoglobulin heavy variable 7-81 (non-functional)', 118, NULL, NULL, 220557),
(220558, '1.25.40.10-FF-003068', NULL, 'Pentatricopeptide repeat-containing protein', 200, NULL, NULL, 220558),
(220559, '2.60.40.1180-FF-000152', NULL, 'Predicted protein', 100, NULL, NULL, 220559),
(220560, '1.20.1280.170-FF-000008', NULL, 'Exocyst complex component 7', 535, NULL, NULL, 220560),
(220561, '1.10.8.100-FF-000033', NULL, 'Ribosomal RNA small subunit methyltransferase A', 65, NULL, NULL, 220561),
(220562, '3.30.200.20-FF-002032', NULL, 'Uncharacterized protein', 91, NULL, NULL, 220562),
(220563, '2.40.50.40-FF-000055', NULL, 'Chromatin-associated protein swi6', 67, NULL, NULL, 220563),
(220564, '2.60.40.150-FF-000211', NULL, 'synaptotagmin-5 isoform X1', 151, NULL, NULL, 220564);
INSERT INTO "PUBLIC"."MODEL" VALUES
(220565, '2.20.70.10-FF-000043', NULL, 'Pleckstrin homology domain-containing, family A member 5', 47, NULL, NULL, 220565),
(220566, '2.70.150.10-FF-000052', NULL, 'Phospholipid-transporting ATPase', 150, NULL, NULL, 220566),
(220567, '2.60.40.10-FF-004266', NULL, NULL, 95, NULL, NULL, 220567),
(220568, '3.30.310.10-FF-000031', NULL, 'AP-2 complex subunit alpha', 125, NULL, NULL, 220568),
(220569, '3.30.70.330-FF-001544', NULL, 'Serine/arginine-rich splicing factor SR45a', 93, NULL, NULL, 220569),
(220570, '3.40.50.300-FF-005929', NULL, '26S protease regulatory subunit 10B A', 181, NULL, NULL, 220570),
(220571, '3.50.30.30-FF-000059', NULL, 'Minor extracellular protease VPR', 117, NULL, NULL, 220571),
(220572, '3.90.70.10-FF-000599', NULL, 'Ubiquitin carboxylterminal hydrolase, putative', 192, NULL, NULL, 220572),
(220573, '1.20.120.1080-FF-000010', NULL, 'ATP-dependent RNA helicase DQX1 isoform X1', 156, NULL, NULL, 220573),
(220574, '4.10.910.10-FF-000004', NULL, 'Small subunit ribosomal protein S13', 42, NULL, NULL, 220574),
(220575, '3.30.60.30-FF-000141', NULL, 'Protein CBG17314', 61, NULL, NULL, 220575),
(220576, '1.25.10.10-FF-001756', NULL, 'Pre-rRNA-processing protein IPI1-1', 88, NULL, NULL, 220576),
(220577, '3.80.10.10-FF-003665', NULL, 'F-box/leucine rich repeat protein, putative', 72, NULL, NULL, 220577),
(220578, '3.30.160.60-FF-003602', NULL, NULL, 30, NULL, NULL, 220578),
(220579, '2.10.50.10-FF-000098', NULL, 'C-type LECtin', 64, NULL, NULL, 220579),
(220580, '2.60.40.10-FF-004827', NULL, NULL, 136, NULL, NULL, 220580),
(220581, '1.10.510.10-FF-002340', NULL, NULL, 201, NULL, NULL, 220581),
(220582, '2.60.40.60-FF-001127', NULL, 'Uncharacterized protein', 105, NULL, NULL, 220582),
(220583, '3.40.50.1000-FF-000743', NULL, NULL, 133, NULL, NULL, 220583),
(220584, '3.40.850.10-FF-000092', NULL, 'Myosin heavy chain', 250, NULL, NULL, 220584),
(220585, '3.40.366.10-FF-000073', NULL, 'Acyl transferase', 312, NULL, NULL, 220585),
(220586, '1.10.540.10-FF-000032', NULL, 'Acyl-CoA dehydrogenase fadE16', 116, NULL, NULL, 220586),
(220587, '2.60.34.20-FF-000011', NULL, NULL, 154, NULL, NULL, 220587),
(220588, '2.60.200.20-FF-000062', NULL, 'Serine/threonine-protein kinase RAD53', 164, NULL, NULL, 220588),
(220589, '2.60.410.10-FF-000007', NULL, 'Putative D-alanyl-D-alanine carboxypeptidase', 91, NULL, NULL, 220589),
(220590, '3.30.70.330-FF-001235', NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', 89, NULL, NULL, 220590),
(220591, '3.40.50.300-FF-003204', NULL, 'RNA helicase, putative', 187, NULL, NULL, 220591),
(220592, '3.20.20.80-FF-000558', NULL, 'Si:dkey-224e22.2', 166, NULL, NULL, 220592),
(220593, '3.40.50.80-FF-000093', NULL, 'Putative cytochrome P450 reductase', 162, NULL, NULL, 220593),
(220594, '2.130.10.10-FF-004575', NULL, 'Uncharacterized protein', 210, NULL, NULL, 220594),
(220595, '1.25.40.10-FF-003040', NULL, 'Pentatricopeptide repeat-containing protein', 92, NULL, NULL, 220595),
(220596, '3.10.110.10-FF-000149', NULL, 'Ubiquitin-conjugating enzyme family protein', 159, NULL, NULL, 220596),
(220597, '2.60.40.790-FF-000189', NULL, NULL, 105, NULL, NULL, 220597),
(220598, '3.30.420.10-FF-000022', NULL, 'Exosome component 10', 308, NULL, NULL, 220598),
(220599, '1.10.10.10-FF-000278', NULL, 'Forkhead box protein H1', 104, NULL, NULL, 220599),
(220600, '3.20.20.70-FF-000246', NULL, 'Orotidine 5''-phosphate decarboxylase', 285, NULL, NULL, 220600),
(220601, '2.170.270.10-FF-000205', NULL, 'Uncharacterized protein', 169, NULL, NULL, 220601),
(220602, '3.10.290.10-FF-000089', NULL, '40S ribosomal protein S4', 47, NULL, NULL, 220602),
(220603, '1.25.10.10-FF-002740', NULL, 'Importin 7', 801, NULL, NULL, 220603),
(220604, '2.60.120.260-FF-000354', NULL, 'Beta-galactosidase', 128, NULL, NULL, 220604),
(220605, '2.30.30.100-FF-000206', NULL, 'U6 snRNA-associated Sm-like protein LSm3', 90, NULL, NULL, 220605),
(220606, '2.60.40.150-FF-000548', NULL, 'VPS34-like PI-3-kinase', 90, NULL, NULL, 220606),
(220607, '1.20.1250.20-FF-001667', NULL, 'Predicted protein', 96, NULL, NULL, 220607);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(220608, '3.40.50.300-FF-000247', NULL, 'ADP-ribosylation factor-like GTPase 8A', 182, NULL, NULL, 220608),
(220609, '1.10.472.80-FF-000079', NULL, 'TBC1 domain family member 25', 61, NULL, NULL, 220609),
(220610, '2.60.40.10-FF-001045', NULL, 'Interleukin 6 receptor', 76, NULL, NULL, 220610),
(220611, '2.60.120.290-FF-000245', NULL, 'Uncharacterized protein', 168, NULL, NULL, 220611),
(220612, '3.40.50.300-FF-006554', NULL, 'Uncharacterized protein', 104, NULL, NULL, 220612),
(220613, '2.60.40.10-FF-000775', NULL, 'Uncharacterized protein, isoform F', 97, NULL, NULL, 220613),
(220614, '2.70.150.10-FF-000283', NULL, 'Phospholipid-transporting ATPase', 140, NULL, NULL, 220614),
(220615, '2.60.300.12-FF-000029', NULL, NULL, 93, NULL, NULL, 220615),
(220616, '1.20.5.190-FF-000018', NULL, 'Myosin XI D', 50, NULL, NULL, 220616),
(220617, '3.40.50.300-FF-001175', NULL, 'Phosphoseryl-tRNA kinase', 196, NULL, NULL, 220617),
(220618, '1.20.120.30-FF-000009', NULL, NULL, 127, NULL, NULL, 220618),
(220619, '1.10.3210.10-FF-000001', NULL, 'GTP pyrophosphokinase RelA', 190, NULL, NULL, 220619),
(220620, '3.50.50.100-FF-000028', NULL, 'Pyridine nucleotide-disulfide oxidoreductase', 219, NULL, NULL, 220620),
(220621, '3.60.21.10-FF-000122', NULL, 'UshA related metallophosphatase, N-terminal domain', 335, NULL, NULL, 220621),
(220622, '3.40.50.2000-FF-000689', NULL, 'Glycosyltransferase, group 1 family protein', 188, NULL, NULL, 220622),
(220623, '2.120.10.30-FF-000046', NULL, 'Blast:Protein yellow', 385, NULL, NULL, 220623),
(220624, '2.10.60.10-FF-000048', NULL, 'Receptor protein serine/threonine kinase', 78, NULL, NULL, 220624),
(220625, '3.90.70.10-FF-000054', NULL, 'Calpain 14', 141, NULL, NULL, 220625),
(220626, '1.25.40.10-FF-003832', NULL, 'Translocation protein sec72', 124, NULL, NULL, 220626),
(220627, '1.20.1050.130-FF-000035', NULL, 'Uncharacterized protein', 116, NULL, NULL, 220627),
(220628, '1.20.5.170-FF-000012', NULL, 'Putative transcription factor AP-1', 68, NULL, NULL, 220628),
(220629, '2.30.30.140-FF-000078', NULL, 'HypC/HybG/HupF family hydrogenase formation chaperone', 75, NULL, NULL, 220629),
(220630, '1.10.443.10-FF-000020', NULL, 'Predicted protein', 82, NULL, NULL, 220630),
(220631, '2.130.10.10-FF-004553', NULL, 'Chromosome 12, whole genome shotgun sequence', 217, NULL, NULL, 220631),
(220632, '3.30.420.10-FF-000713', NULL, NULL, 90, NULL, NULL, 220632),
(220633, '3.40.50.1580-FF-000063', NULL, 'Futalosine hydrolase', 196, NULL, NULL, 220633),
(220634, '3.30.70.260-FF-000011', NULL, 'Acetolactate synthase isozyme 1 small subunit', 96, NULL, NULL, 220634),
(220635, '2.40.50.150-FF-000015', NULL, 'DNA-directed RNA polymerase subunit beta', 116, NULL, NULL, 220635),
(220636, '2.60.40.1090-FF-000018', NULL, 'Fimbrial family protein', 171, NULL, NULL, 220636),
(220637, '3.30.1330.90-FF-000010', NULL, 'D-3-phosphoglycerate dehydrogenase', 134, NULL, NULL, 220637),
(220638, '1.20.1270.280-FF-000056', NULL, 'AGAP010790-PA', 137, NULL, NULL, 220638),
(220639, '3.40.50.300-FF-006065', NULL, 'Predicted protein', 106, NULL, NULL, 220639),
(220640, '2.60.120.200-FF-000235', NULL, 'Beta-1,3-glucan-binding protein', 317, NULL, NULL, 220640),
(220641, '3.40.33.10-FF-000156', NULL, 'Uncharacterized protein', 125, NULL, NULL, 220641),
(220642, '3.80.10.10-FF-002956', NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', 163, NULL, NULL, 220642),
(220643, '3.30.160.60-FF-002877', NULL, 'Zgc:110821', 29, NULL, NULL, 220643),
(220644, '2.10.90.10-FF-000128', NULL, 'Uncharacterized protein', 102, NULL, NULL, 220644),
(220645, '3.30.160.60-FF-004586', NULL, NULL, 30, NULL, NULL, 220645),
(220646, '3.30.428.10-FF-000034', NULL, 'Galactose-1-phosphate uridylyltransferase galTa', 134, NULL, NULL, 220646),
(220647, '3.30.450.20-FF-000162', NULL, 'Methyl-accepting chemotaxis protein', 107, NULL, NULL, 220647),
(220648, '1.25.10.10-FF-000031', NULL, 'CLIP-associating protein 1 isoform 2', 230, NULL, NULL, 220648),
(220649, '3.30.70.330-FF-000583', NULL, 'RNA-binding protein musashi, putative', 111, NULL, NULL, 220649);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(220650, '3.50.50.60-FF-000581', NULL, 'Rab GDP dissociation inhibitor, putative', 70, NULL, NULL, 220650),
(220651, '3.30.450.40-FF-000168', NULL, 'Histidine kinase', 168, NULL, NULL, 220651),
(220652, '1.20.1080.10-FF-000066', NULL, 'Uncharacterized protein', 261, NULL, NULL, 220652),
(220653, '3.40.50.300-FF-001658', NULL, 'Testicular tissue protein Li 168', 102, NULL, NULL, 220653),
(220654, '3.30.1330.10-FF-000043', NULL, 'Uncharacterized protein', 65, NULL, NULL, 220654),
(220655, '3.20.20.70-FF-000229', NULL, 'tRNA-dihydrouridine(20) synthase [NAD(P)+]-like', 81, NULL, NULL, 220655),
(220656, '3.40.50.720-FF-001756', NULL, 'Mrf1p', 178, NULL, NULL, 220656),
(220657, '3.40.1280.10-FF-000064', NULL, 'Ribosomal RNA small subunit methyltransferase E', 169, NULL, NULL, 220657),
(220658, '3.30.160.60-FF-003967', NULL, NULL, 29, NULL, NULL, 220658),
(220659, '3.50.50.60-FF-001093', NULL, 'Flavin-containing monooxygenase', 324, NULL, NULL, 220659),
(220660, '1.25.40.70-FF-000067', NULL, 'Uncharacterized protein', 139, NULL, NULL, 220660),
(220661, '3.90.105.10-FF-000018', NULL, 'Molybdopterin molybdenumtransferase', 57, NULL, NULL, 220661),
(220662, '3.90.930.12-FF-000016', NULL, NULL, 81, NULL, NULL, 220662),
(220663, '1.20.1560.10-FF-000215', NULL, 'ABC transporter B family member 4', 275, NULL, NULL, 220663),
(220664, '3.30.70.20-FF-000110', NULL, NULL, 64, NULL, NULL, 220664),
(220665, '3.30.40.10-FF-000712', NULL, 'RING-H2 finger protein ATL60', 52, NULL, NULL, 220665),
(220666, '3.30.70.330-FF-000055', NULL, 'Splicing factor U2AF 35 kDa subunit', 101, NULL, NULL, 220666),
(220667, '3.30.559.10-FF-000006', NULL, 'Dihydrolipoyllysine-residue succinyltransferase component of 2-oxoglutarate dehydrogenase complex, mitochondrial', 238, NULL, NULL, 220667),
(220668, '3.10.150.10-FF-000034', NULL, 'Uncharacterized protein', 96, NULL, NULL, 220668),
(220669, '1.10.510.10-FF-000098', NULL, 'Mitogen-activated protein kinase 1', 231, NULL, NULL, 220669),
(220670, '2.60.40.10-FF-002012', NULL, 'KETtiN (Drosophila actin-binding) homolog', 104, NULL, NULL, 220670),
(220671, '4.10.93.10-FF-000001', NULL, 'Cytochrome c oxidase subunit 6C', 73, NULL, NULL, 220671),
(220672, '1.50.40.10-FF-000351', NULL, 'Uncharacterized protein', 109, NULL, NULL, 220672),
(220673, '3.40.640.10-FF-000160', NULL, 'Class III pyridoxal phosphate-dependent aminotransferase', 239, NULL, NULL, 220673),
(220674, '3.30.40.10-FF-000173', NULL, 'E3 ubiquitin-protein ligase RNF4', 133, NULL, NULL, 220674),
(220675, '3.30.390.10-FF-000007', NULL, 'L-rhamnonate dehydratase', 147, NULL, NULL, 220675),
(220676, '1.10.3730.10-FF-000001', NULL, 'Pyrroline-5-carboxylate reductase', 105, NULL, NULL, 220676),
(220677, '2.40.10.10-FF-000173', NULL, 'GG16564', 130, NULL, NULL, 220677),
(220678, '1.10.287.110-FF-000198', NULL, 'UDP-glycosyltransferase TURAN', 77, NULL, NULL, 220678),
(220679, '3.10.20.90-FF-000106', NULL, 'Polycomb complex protein BMI-1', 115, NULL, NULL, 220679),
(220680, '2.60.40.10-FF-003046', NULL, 'Poliovirus receptor', 84, NULL, NULL, 220680),
(220681, '3.90.550.10-FF-000294', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 379, NULL, NULL, 220681),
(220682, '2.130.10.10-FF-003934', NULL, 'AER249Cp', 254, NULL, NULL, 220682),
(220683, '2.70.130.10-FF-000175', NULL, NULL, 156, NULL, NULL, 220683),
(220684, '3.30.420.40-FF-000565', NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', 180, NULL, NULL, 220684),
(220685, '3.40.50.620-FF-000225', NULL, 'Leucine--tRNA ligase, putative', 111, NULL, NULL, 220685),
(220686, '1.20.120.1630-FF-000012', NULL, 'Polyprenol reductase 1', 132, NULL, NULL, 220686),
(220687, '3.30.2350.10-FF-000044', NULL, 'Pseudouridine synthase', 231, NULL, NULL, 220687),
(220688, '3.30.450.20-FF-000055', NULL, 'neuronal PAS domain-containing protein 4', 124, NULL, NULL, 220688),
(220689, '1.20.1250.20-FF-000251', NULL, 'Inner membrane transporter YeaN', 377, NULL, NULL, 220689),
(220690, '3.40.50.1100-FF-000099', NULL, 'Cystathionine Beta-Synthase', 153, NULL, NULL, 220690);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(220691, '3.40.630.30-FF-000137', NULL, '[Citrate [pro-3S]-lyase] ligase', 119, NULL, NULL, 220691),
(220692, '3.30.450.20-FF-000538', NULL, 'Uncharacterized protein', 156, NULL, NULL, 220692),
(220693, '3.30.160.60-FF-004114', NULL, NULL, 30, NULL, NULL, 220693),
(220694, '3.40.190.290-FF-000049', NULL, 'LysR family transcriptional regulator', 198, NULL, NULL, 220694),
(220695, '3.20.20.140-FF-000237', NULL, 'Aminodeoxyfutalosine deaminase', 309, NULL, NULL, 220695),
(220696, '2.40.240.130-FF-000009', NULL, 'Dishevelled segment polarity protein 3', 39, NULL, NULL, 220696),
(220697, '1.25.40.90-FF-000040', NULL, 'ADP-ribosylation factor-binding protein GGA3 isoform X3', 91, NULL, NULL, 220697),
(220698, '3.30.497.10-FF-000093', NULL, 'AGAP003194-PA', 199, NULL, NULL, 220698),
(220699, '2.30.30.490-FF-000076', NULL, 'Predicted protein', 222, NULL, NULL, 220699),
(220700, '3.30.160.60-FF-005204', NULL, NULL, 47, NULL, NULL, 220700),
(220701, '3.60.10.10-FF-000310', NULL, 'Putative inositol polyphosphate phosphatase (Synaptogenin-like) family protein', 300, NULL, NULL, 220701),
(220702, '3.40.640.10-FF-000536', NULL, 'Uncharacterized protein', 51, NULL, NULL, 220702),
(220703, '3.30.300.10-FF-000058', NULL, 'S-adenosylmethionine synthase', 59, NULL, NULL, 220703),
(220704, '4.10.1290.10-FF-000003', NULL, 'Tumor necrosis factor receptor superfamily member 17', 50, NULL, NULL, 220704),
(220705, '2.60.220.50-FF-000061', NULL, 'Uncharacterized protein', 56, NULL, NULL, 220705),
(220706, '3.30.200.20-FF-001335', NULL, 'Calmodulin-binding receptor-like cytoplasmic kinase 2', 117, NULL, NULL, 220706),
(220707, '3.40.630.10-FF-000131', NULL, 'Uncharacterized protein', 258, NULL, NULL, 220707),
(220708, '2.60.120.650-FF-000241', NULL, 'Lysine (K)-specific demethylase 5A', 75, NULL, NULL, 220708),
(220709, '2.120.10.80-FF-000330', NULL, 'Predicted protein', 136, NULL, NULL, 220709),
(220710, '2.80.10.50-FF-000054', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 135, NULL, NULL, 220710),
(220711, '2.60.120.10-FF-000255', NULL, 'Cysteine dioxygenase', 145, NULL, NULL, 220711),
(220712, '1.10.238.10-FF-001324', NULL, 'Calpain 1', 129, NULL, NULL, 220712),
(220713, '2.170.130.10-FF-000050', NULL, 'M56 family peptidase', 166, NULL, NULL, 220713),
(220714, '1.10.10.10-FF-001340', NULL, 'Histone acetyltransferase', 97, NULL, NULL, 220714),
(220715, '1.20.58.60-FF-000666', NULL, 'Uncharacterized protein', 114, NULL, NULL, 220715),
(220716, '3.40.50.300-FF-008010', NULL, 'Uncharacterized protein', 144, NULL, NULL, 220716),
(220717, '3.90.780.10-FF-000007', NULL, 'Trifunctional nucleotide phosphoesterase protein YfkN', 191, NULL, NULL, 220717),
(220718, '1.10.630.10-FF-000679', NULL, 'Uncharacterized protein', 161, NULL, NULL, 220718),
(220719, '2.40.160.10-FF-000043', NULL, 'Voltage-dependent anion-selective channel 1', 262, NULL, NULL, 220719),
(220720, '2.60.120.970-FF-000016', NULL, 'Bone morphogenetic protein 6', 252, NULL, NULL, 220720),
(220721, '2.40.10.10-FF-000066', NULL, 'Complement factor I', 230, NULL, NULL, 220721),
(220722, '1.10.940.10-FF-000017', NULL, 'Transcription antitermination factor NusB', 132, NULL, NULL, 220722),
(220723, '3.30.70.330-FF-002511', NULL, NULL, 70, NULL, NULL, 220723),
(220724, '1.10.472.130-FF-000007', NULL, 'Dynein heavy chain, cytoplasmic', 178, NULL, NULL, 220724),
(220725, '2.160.20.10-FF-000185', NULL, 'Uncharacterized protein', 207, NULL, NULL, 220725),
(220726, '1.25.10.10-FF-001975', NULL, 'YALI0B05940p', 175, NULL, NULL, 220726),
(220727, '1.25.40.10-FF-001359', NULL, 'Pentatricopeptide repeat-containing protein At3g57430, chloroplastic', 112, NULL, NULL, 220727),
(220728, '3.80.10.10-FF-003249', NULL, 'Uncharacterized protein', 175, NULL, NULL, 220728),
(220729, '3.40.30.10-FF-001223', NULL, 'Protein disulfide-isomerase 2', 123, NULL, NULL, 220729),
(220730, '3.40.50.300-FF-002479', NULL, 'DEAD/DEAH box helicase', 171, NULL, NULL, 220730),
(220731, '2.60.40.150-FF-000464', NULL, 'C2 domain containing protein', 135, NULL, NULL, 220731),
(220732, '1.25.10.10-FF-002375', NULL, 'Predicted protein', 1025, NULL, NULL, 220732);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(220733, '1.10.150.390-FF-000012', NULL, NULL, 45, NULL, NULL, 220733),
(220734, '1.20.1600.10-FF-000039', NULL, 'Outer membrane efflux protein', 455, NULL, NULL, 220734),
(220735, '3.30.160.60-FF-002080', NULL, 'Zinc finger RNA-binding protein', 44, NULL, NULL, 220735),
(220736, '2.60.40.10-FF-004682', NULL, NULL, 87, NULL, NULL, 220736),
(220737, '1.10.150.50-FF-000076', NULL, 'Smg, isoform B', 62, NULL, NULL, 220737),
(220738, '3.40.50.1380-FF-000031', NULL, 'Carbamoyl-phosphate synthase large chain', 138, NULL, NULL, 220738),
(220739, '1.10.540.10-FF-000015', NULL, 'Acyl-coenzyme A oxidase', 116, NULL, NULL, 220739),
(220740, '3.40.640.10-FF-000391', NULL, 'RE16411p', 158, NULL, NULL, 220740),
(220741, '3.30.200.20-FF-001644', NULL, 'Tribbles-like protein 2', 89, NULL, NULL, 220741),
(220742, '2.60.40.10-FF-004373', NULL, NULL, 101, NULL, NULL, 220742),
(220743, '3.80.10.10-FF-002737', NULL, 'Predicted protein', 92, NULL, NULL, 220743),
(220744, '3.40.50.800-FF-000049', NULL, 'Threonine--tRNA ligase catalytic subunit', 113, NULL, NULL, 220744),
(220745, '4.10.1240.50-FF-000017', NULL, 'Arginine-glutamic acid dipeptide repeats', 51, NULL, NULL, 220745),
(220746, '3.40.50.300-FF-003120', NULL, 'ATP-binding cassette protein subfamily F, member 3', 280, NULL, NULL, 220746),
(220747, '3.40.50.20-FF-000007', NULL, 'Formate-dependent phosphoribosylglycinamide formyltransferase', 122, NULL, NULL, 220747),
(220748, '3.50.4.10-FF-000039', NULL, 'NOmpA Homolog (Drosophila nompA: no mechanoreceptor potential A)', 76, NULL, NULL, 220748),
(220749, '1.20.970.10-FF-000028', NULL, 'Predicted protein', 77, NULL, NULL, 220749),
(220750, '1.20.1610.10-FF-000012', NULL, 'Alpha-1,2-mannosidase, putative', 164, NULL, NULL, 220750),
(220751, '1.25.10.10-FF-003212', NULL, 'Serine/threonine-protein kinase tor1', 274, NULL, NULL, 220751),
(220752, '2.60.40.10-FF-002664', NULL, 'Immunoglobulin lambda variable 5-48 (non-functional)', 110, NULL, NULL, 220752),
(220753, '1.10.418.10-FF-000164', NULL, 'Uncharacterized protein', 156, NULL, NULL, 220753),
(220754, '3.40.50.2300-FF-001515', NULL, NULL, 184, NULL, NULL, 220754),
(220755, '3.40.850.10-FF-000018', NULL, 'unconventional myosin-VI isoform X1', 215, NULL, NULL, 220755),
(220756, '3.30.160.60-FF-001152', NULL, 'Zinc finger protein 691', 23, NULL, NULL, 220756),
(220757, '3.30.160.60-FF-005856', NULL, NULL, 65, NULL, NULL, 220757),
(220758, '3.30.1370.10-FF-000146', NULL, 'Heterogeneous nuclear rnp K-like protein 2', 75, NULL, NULL, 220758),
(220759, '1.25.40.10-FF-000420', NULL, 'Pentatricopeptide repeat domain-containing protein 3, mitochondrial', 221, NULL, NULL, 220759),
(220760, '1.25.10.10-FF-002700', NULL, 'Chromosome region maintenance protein 5/exportin, putative', 62, NULL, NULL, 220760),
(220761, '3.10.20.600-FF-000001', NULL, 'NADH dehydrogenase [ubiquinone] flavoprotein 1, mitochondrial', 97, NULL, NULL, 220761),
(220762, '1.25.40.180-FF-000202', NULL, NULL, 86, NULL, NULL, 220762),
(220763, '3.40.50.10420-FF-000038', NULL, '5-formyltetrahydrofolate cyclo-ligase', 185, NULL, NULL, 220763),
(220764, '2.60.40.10-FF-001500', NULL, 'Titin a', 96, NULL, NULL, 220764),
(220765, '3.30.750.24-FF-000004', NULL, 'Phospholipid ABC transporter-binding protein', 87, NULL, NULL, 220765),
(220766, '3.40.50.300-FF-006773', NULL, 'ATPase family, AAA domain-containing 5', 60, NULL, NULL, 220766),
(220767, '3.90.190.10-FF-000288', NULL, 'Dual specificity protein phosphatase CDC14A, putative', 147, NULL, NULL, 220767),
(220768, '2.30.29.30-FF-001363', NULL, 'Uncharacterized protein', 129, NULL, NULL, 220768),
(220769, '2.60.40.150-FF-000683', NULL, 'Phosphoinositide phospholipase C', 162, NULL, NULL, 220769),
(220770, '1.50.10.20-FF-000043', NULL, 'Thioester-containing protein 6', 322, NULL, NULL, 220770),
(220771, '2.10.220.10-FF-000122', NULL, 'Erb-b2 receptor tyrosine kinase 3a', 84, NULL, NULL, 220771),
(220772, '2.60.40.60-FF-000958', NULL, 'Predicted protein', 97, NULL, NULL, 220772),
(220773, '3.90.1150.10-FF-000352', NULL, 'DegT/DnrJ/EryC1/StrS family aminotransferase', 124, NULL, NULL, 220773);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(220774, '3.30.160.60-FF-001461', NULL, 'Zinc finger protein 142', 32, NULL, NULL, 220774),
(220775, '3.30.230.10-FF-000322', NULL, 'Diphosphomevalonate decarboxylase', 130, NULL, NULL, 220775),
(220776, '2.60.120.260-FF-000247', NULL, 'Uncharacterized protein', 157, NULL, NULL, 220776),
(220777, '3.30.200.20-FF-002263', NULL, 'G protein-coupled receptor kinase', 140, NULL, NULL, 220777),
(220778, '3.40.50.2300-FF-000897', NULL, NULL, 153, NULL, NULL, 220778),
(220779, '3.30.9.10-FF-000224', NULL, 'Glycerol-3-phosphate dehydrogenase, truncation', 162, NULL, NULL, 220779),
(220780, '2.30.42.10-FF-000500', NULL, NULL, 105, NULL, NULL, 220780),
(220781, '3.20.20.300-FF-000072', NULL, NULL, 123, NULL, NULL, 220781),
(220782, '3.20.20.140-FF-000456', NULL, 'Guanine deaminase', 311, NULL, NULL, 220782),
(220783, '3.50.50.60-FF-000957', NULL, 'Sll1025 protein', 191, NULL, NULL, 220783),
(220784, '2.40.50.140-FF-000922', NULL, NULL, 110, NULL, NULL, 220784),
(220785, '3.30.420.40-FF-000784', NULL, 'Ppx/GppA phosphatase family-domain-containing protein', 158, NULL, NULL, 220785),
(220786, '1.20.1280.50-FF-000183', NULL, 'Putative F-box/LRR-repeat protein 9', 52, NULL, NULL, 220786),
(220787, '3.40.390.10-FF-000101', NULL, 'Metalloendopeptidase', 180, NULL, NULL, 220787),
(220788, '3.30.60.30-FF-000034', NULL, 'Serine peptidase inhibitor, Kazal type 5', 55, NULL, NULL, 220788),
(220789, '1.25.40.10-FF-003293', NULL, 'Predicted ankyrin repeat family protein', 111, NULL, NULL, 220789),
(220790, '3.40.50.720-FF-002054', NULL, 'NAD-dependent epimerase/dehydratase', 173, NULL, NULL, 220790),
(220791, '3.80.10.10-FF-003092', NULL, 'Antagonist of mitotic exit network 1', 120, NULL, NULL, 220791),
(220792, '3.30.870.10-FF-000157', NULL, 'Uncharacterized protein', 125, NULL, NULL, 220792),
(220793, '4.10.240.30-FF-000003', NULL, 'Tumor necrosis factor alpha-induced protein 3', 30, NULL, NULL, 220793),
(220794, '1.25.40.20-FF-000171', NULL, 'Ankyrin repeat and SOCS box containing 3', 254, NULL, NULL, 220794),
(220795, '3.40.1030.10-FF-000017', NULL, 'Thymidine phosphorylase', 107, NULL, NULL, 220795),
(220796, '2.60.40.1180-FF-000045', NULL, '1,4-alpha-glucan-branching enzyme 3, chloroplastic/amyloplastic', 100, NULL, NULL, 220796),
(220797, '2.30.42.10-FF-000180', NULL, 'PDZ domain containing 2', 122, NULL, NULL, 220797),
(220798, '2.40.30.10-FF-000079', NULL, '60S ribosomal protein L3', 180, NULL, NULL, 220798),
(220799, '1.10.275.10-FF-000027', NULL, 'Adenylosuccinate lyase (PurB)', 94, NULL, NULL, 220799),
(220800, '3.40.50.10470-FF-000031', NULL, 'Probable translation initiation factor eIF-2B subunit alpha', 196, NULL, NULL, 220800),
(220801, '3.30.830.10-FF-000143', NULL, 'Metalloprotease, insulinase family', 250, NULL, NULL, 220801),
(220802, '3.50.50.60-FF-000249', NULL, 'Lysine-specific histone demethylase Aof2', 157, NULL, NULL, 220802),
(220803, '2.60.40.10-FF-004934', NULL, NULL, 89, NULL, NULL, 220803),
(220804, '1.10.20.10-FF-000093', NULL, 'Histone H2A', 130, NULL, NULL, 220804),
(220805, '1.10.101.10-FF-000001', NULL, 'Spore cortex-lytic enzyme', 79, NULL, NULL, 220805),
(220806, '2.60.120.200-FF-000600', NULL, 'Si:ch211-241e1.3', 156, NULL, NULL, 220806),
(220807, '3.40.50.2300-FF-000026', NULL, 'DNA-binding response OmpR family regulator', 86, NULL, NULL, 220807),
(220808, '3.30.1640.10-FF-000015', NULL, 'DNA helicase', 91, NULL, NULL, 220808),
(220809, '3.50.50.60-FF-001199', NULL, 'Zeta-carotene desaturase', 492, NULL, NULL, 220809),
(220810, '2.30.30.110-FF-000007', NULL, 'mRNA interferase', 114, NULL, NULL, 220810),
(220811, '3.30.2090.10-FF-000001', NULL, 'Efflux pump membrane transporter', 99, NULL, NULL, 220811),
(220812, '1.20.1290.10-FF-000003', NULL, 'sestrin-2 isoform X2', 117, NULL, NULL, 220812),
(220813, '3.30.160.60-FF-004895', NULL, NULL, 16, NULL, NULL, 220813),
(220814, '3.40.390.10-FF-000090', NULL, 'neprilysin', 308, NULL, NULL, 220814),
(220815, '3.40.950.10-FF-000037', NULL, NULL, 139, NULL, NULL, 220815),
(220816, '3.90.1150.10-FF-000133', NULL, 'Cystathionine beta-lyase', 156, NULL, NULL, 220816);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(220817, '3.30.70.270-FF-000323', NULL, NULL, 140, NULL, NULL, 220817),
(220818, '3.30.160.60-FF-003861', NULL, NULL, 54, NULL, NULL, 220818),
(220819, '3.30.200.20-FF-000031', NULL, 'Non-specific serine/threonine protein kinase', 100, NULL, NULL, 220819),
(220820, '1.10.238.10-FF-000942', NULL, 'Calcium-binding EF-hand family protein', 104, NULL, NULL, 220820),
(220821, '3.10.100.10-FF-000053', NULL, 'Killer cell lectin-like receptor 3', 137, NULL, NULL, 220821),
(220822, '1.20.1070.10-FF-001313', NULL, 'Predicted protein', 79, NULL, NULL, 220822),
(220823, '3.30.420.40-FF-000020', NULL, 'Chaperone protein HscA homolog', 87, NULL, NULL, 220823),
(220824, '1.10.510.10-FF-000862', NULL, 'Tyrosine-protein kinase', 190, NULL, NULL, 220824),
(220825, '3.30.70.600-FF-000012', NULL, 'SSU ribosomal protein S10P', 111, NULL, NULL, 220825),
(220826, '3.40.50.300-FF-004300', NULL, 'Sulfotransferase', 284, NULL, NULL, 220826),
(220827, '1.20.120.1750-FF-000138', NULL, 'RBR-type E3 ubiquitin transferase', 48, NULL, NULL, 220827),
(220828, '2.60.120.620-FF-000153', NULL, 'Uncharacterized protein', 211, NULL, NULL, 220828),
(220829, '1.20.1070.10-FF-001785', NULL, 'Uncharacterized protein', 326, NULL, NULL, 220829),
(220830, '1.10.486.10-FF-000017', NULL, 'DNA helicase', 161, NULL, NULL, 220830),
(220831, '4.10.260.10-FF-000010', NULL, 'Ste18p', 71, NULL, NULL, 220831),
(220832, '3.30.40.10-FF-002281', NULL, 'E3 ubiquitin-protein ligase CHIP', 47, NULL, NULL, 220832),
(220833, '1.20.1070.10-FF-000695', NULL, 'Predicted protein', 319, NULL, NULL, 220833),
(220834, '1.10.287.370-FF-000011', NULL, 'prefoldin subunit 5 isoform X2', 98, NULL, NULL, 220834),
(220835, '3.90.650.10-FF-000003', NULL, 'Selenide, water dikinase 1', 177, NULL, NULL, 220835),
(220836, '1.20.1730.10-FF-000032', NULL, 'Uncharacterized protein', 478, NULL, NULL, 220836),
(220837, '4.10.400.10-FF-000139', NULL, 'LDL receptor related protein 2', 41, NULL, NULL, 220837),
(220838, '3.30.160.60-FF-004367', NULL, NULL, 58, NULL, NULL, 220838),
(220839, '3.30.479.20-FF-000065', NULL, 'Elongation factor Ts, mitochondrial', 120, NULL, NULL, 220839),
(220840, '3.30.40.10-FF-001477', NULL, 'RING/U-box superfamily protein', 121, NULL, NULL, 220840),
(220841, '3.30.1480.10-FF-000008', NULL, 'Transcription termination/antitermination protein NusA', 127, NULL, NULL, 220841),
(220842, '2.40.50.770-FF-000004', NULL, 'RecQ-mediated instability protein (DUF1767)', 127, NULL, NULL, 220842),
(220843, '3.40.190.10-FF-000226', NULL, 'Peptide ABC transporter substrate-binding protein', 146, NULL, NULL, 220843),
(220844, '3.10.28.10-FF-000010', NULL, 'LAGLIDADG homing endonuclease I-LtrII', 149, NULL, NULL, 220844),
(220845, '1.10.560.10-FF-000123', NULL, '60 kDa chaperonin', 253, NULL, NULL, 220845),
(220846, '4.10.60.10-FF-000263', NULL, 'Uncharacterized protein', 58, NULL, NULL, 220846),
(220847, '3.30.70.1230-FF-000168', NULL, 'Adenylate cyclase, terminal-differentiation specific', 197, NULL, NULL, 220847),
(220848, '1.10.3180.10-FF-000003', NULL, 'Ethylene insensitive 3 family protein', 82, NULL, NULL, 220848),
(220849, '1.10.472.80-FF-000057', NULL, 'GTPase-activating protein', 186, NULL, NULL, 220849),
(220850, '3.20.20.70-FF-000690', NULL, NULL, 176, NULL, NULL, 220850),
(220851, '3.10.20.90-FF-000073', NULL, 'Polycomb group RING finger protein 3', 105, NULL, NULL, 220851),
(220852, '3.40.50.11060-FF-000011', NULL, 'HflX family GTPase', 95, NULL, NULL, 220852),
(220853, '3.40.50.1480-FF-000021', NULL, NULL, 70, NULL, NULL, 220853),
(220854, '3.10.50.40-FF-000144', NULL, 'Peptidylprolyl isomerase', 128, NULL, NULL, 220854),
(220855, '3.10.330.20-FF-000011', NULL, 'tRNA methyltransferase complex GCD14 subunit', 62, NULL, NULL, 220855),
(220856, '1.10.10.60-FF-000832', NULL, NULL, 71, NULL, NULL, 220856),
(220857, '1.10.510.10-FF-000659', NULL, 'Receptor protein serine/threonine kinase', 233, NULL, NULL, 220857),
(220858, '3.60.20.10-FF-000030', NULL, 'Proteasome subunit beta', 204, NULL, NULL, 220858),
(220859, '1.25.40.10-FF-002904', NULL, 'Tetratricopeptide repeat protein 17', 202, NULL, NULL, 220859);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(220860, '2.60.40.10-FF-002118', NULL, 'Neural cell adhesion molecule 3', 92, NULL, NULL, 220860),
(220861, '2.60.260.20-FF-000094', NULL, 'Chaperone protein DnaJ', 111, NULL, NULL, 220861),
(220862, '2.10.25.10-FF-001422', NULL, 'Uncharacterized protein', 52, NULL, NULL, 220862),
(220863, '3.40.190.10-FF-000754', NULL, 'Predicted protein', 188, NULL, NULL, 220863),
(220864, '3.40.50.1820-FF-001242', NULL, 'Carboxylic ester hydrolase', 322, NULL, NULL, 220864),
(220865, '4.10.530.10-FF-000003', NULL, 'Ficolin 3', 69, NULL, NULL, 220865),
(220866, '3.40.50.970-FF-000201', NULL, 'Probable 2-ketoarginine decarboxylase AruI', 174, NULL, NULL, 220866),
(220867, '2.70.150.10-FF-000030', NULL, 'Plasma membrane ATPase', 41, NULL, NULL, 220867),
(220868, '1.20.1260.100-FF-000006', NULL, NULL, 107, NULL, NULL, 220868),
(220869, '3.30.160.60-FF-004822', NULL, NULL, 24, NULL, NULL, 220869),
(220870, '3.30.70.100-FF-000115', NULL, NULL, 155, NULL, NULL, 220870),
(220871, '3.90.660.10-FF-000032', NULL, 'Amine oxidase', 179, NULL, NULL, 220871),
(220872, '3.30.160.60-FF-000533', NULL, 'Zinc finger protein', 31, NULL, NULL, 220872),
(220873, '1.10.287.4070-FF-000015', NULL, 'Putative nucleolar protein 5-1', 106, NULL, NULL, 220873),
(220874, '3.90.550.10-FF-000512', NULL, 'UDP-glucose:glycoprotein glucosyltransferase 1', 255, NULL, NULL, 220874),
(220875, '2.60.40.10-FF-000320', NULL, 'Plexin A1', 87, NULL, NULL, 220875),
(220876, '3.40.630.10-FF-000345', NULL, 'Uncharacterized protein', 227, NULL, NULL, 220876),
(220877, '2.170.150.80-FF-000026', NULL, 'NAC domain containing protein 49', 149, NULL, NULL, 220877),
(220878, '3.40.50.720-FF-000828', NULL, 'Nedd8-activating enzyme E1 regulatory subunit', 277, NULL, NULL, 220878),
(220879, '1.20.1310.10-FF-000175', NULL, NULL, 124, NULL, NULL, 220879),
(220880, '1.20.1560.10-FF-000923', NULL, 'Uncharacterized protein', 91, NULL, NULL, 220880),
(220881, '1.10.10.10-FF-002065', NULL, 'Predicted protein', 60, NULL, NULL, 220881),
(220882, '3.40.50.720-FF-001104', NULL, 'Oxidoreductase', 102, NULL, NULL, 220882),
(220883, '4.10.800.20-FF-000004', NULL, 'Probable amp deaminase', 90, NULL, NULL, 220883),
(220884, '2.60.40.1120-FF-000033', NULL, 'Rhamnogalacturonate lyase B', 100, NULL, NULL, 220884),
(220885, '1.20.58.340-FF-000052', NULL, 'Mg2 transporter protein CorA family protein', 117, NULL, NULL, 220885),
(220886, '3.40.50.150-FF-001669', NULL, NULL, 170, NULL, NULL, 220886),
(220887, '1.20.58.1100-FF-000019', NULL, 'protein unc-13 homolog B-like', 171, NULL, NULL, 220887),
(220888, '2.30.30.550-FF-000010', NULL, NULL, 69, NULL, NULL, 220888),
(220889, '4.10.280.10-FF-000152', NULL, 'Nuclear pore complex protein NUP155', 58, NULL, NULL, 220889),
(220890, '3.40.1190.20-FF-000094', NULL, 'ADP-dependent (S)-NAD(P)H-hydrate dehydratase', 277, NULL, NULL, 220890),
(220891, '1.10.472.10-FF-000441', NULL, 'Transcription initiation factor IIB', 121, NULL, NULL, 220891),
(220892, '2.120.10.80-FF-000021', NULL, 'kelch-like protein 1 isoform X2', 107, NULL, NULL, 220892),
(220893, '2.30.30.40-FF-000268', NULL, 'Uncharacterized protein', 87, NULL, NULL, 220893),
(220894, '1.10.238.10-FF-001015', NULL, 'Uncharacterized protein', 170, NULL, NULL, 220894),
(220895, '1.10.287.1490-FF-000016', NULL, 'Coiled-coil domain containing 68', 169, NULL, NULL, 220895),
(220896, '3.30.70.240-FF-000016', NULL, 'Elongation factor G, mitochondrial', 71, NULL, NULL, 220896),
(220897, '1.10.287.70-FF-000466', NULL, 'Uncharacterized protein', 263, NULL, NULL, 220897),
(220898, '2.60.40.60-FF-000273', NULL, 'Uncharacterized protein', 103, NULL, NULL, 220898),
(220899, '1.10.3210.10-FF-000107', NULL, 'Uncharacterized protein', 115, NULL, NULL, 220899),
(220900, '3.40.50.2030-FF-000001', NULL, 'Hydroxylamine reductase', 169, NULL, NULL, 220900),
(220901, '1.10.10.2360-FF-000001', NULL, 'Nuclear pore complex protein Nup98-Nup96', 57, NULL, NULL, 220901),
(220902, '3.30.710.10-FF-000016', NULL, 'Transcription elongation factor', 97, NULL, NULL, 220902),
(220903, '1.10.10.440-FF-000077', NULL, 'Uncharacterized protein', 56, NULL, NULL, 220903);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(220904, '2.60.40.60-FF-000088', NULL, 'protocadherin-19 isoform X2', 103, NULL, NULL, 220904),
(220905, '1.20.58.390-FF-000151', NULL, 'AcetylCholine Receptor', 79, NULL, NULL, 220905),
(220906, '1.10.1200.10-FF-000152', NULL, 'Uncharacterized protein', 80, NULL, NULL, 220906),
(220907, '3.60.110.10-FF-000099', NULL, NULL, 244, NULL, NULL, 220907),
(220908, '3.20.20.210-FF-000028', NULL, 'Uroporphyrinogen decarboxylase', 212, NULL, NULL, 220908),
(220909, '2.30.39.10-FF-000138', NULL, 'Uncharacterized protein', 109, NULL, NULL, 220909),
(220910, '3.90.1110.10-FF-000012', NULL, 'DNA-directed RNA polymerase subunit beta', 166, NULL, NULL, 220910),
(220911, '3.90.1170.50-FF-000005', NULL, 'Xanthine dehydrogenase yagR molybdenum-binding subunit', 131, NULL, NULL, 220911),
(220912, '3.40.50.2000-FF-000711', NULL, 'Glycosyl transferase group 1', 167, NULL, NULL, 220912),
(220913, '2.60.40.10-FF-003501', NULL, NULL, 90, NULL, NULL, 220913),
(220914, '1.10.340.70-FF-000006', NULL, 'Retrovirus-related Pol polyprotein from transposon 297-like Protein', 73, NULL, NULL, 220914),
(220915, '3.20.20.30-FF-000009', NULL, 'Luciferase-like monooxygenase family protein', 345, NULL, NULL, 220915),
(220916, '3.40.50.1820-FF-000281', NULL, 'LIPaSe related', 267, NULL, NULL, 220916),
(220917, '2.130.10.10-FF-003625', NULL, 'Uncharacterized protein', 151, NULL, NULL, 220917),
(220918, '3.90.79.20-FF-000015', NULL, 'NADH pyrophosphatase', 153, NULL, NULL, 220918),
(220919, '3.40.50.2000-FF-000003', NULL, 'Alpha-1,4 glucan phosphorylase', 330, NULL, NULL, 220919),
(220920, '1.20.1250.20-FF-002140', NULL, 'Uncharacterized protein', 203, NULL, NULL, 220920),
(220921, '3.10.450.10-FF-000040', NULL, 'Protein CBR-TAG-196', 105, NULL, NULL, 220921),
(220922, '3.10.50.10-FF-000040', NULL, 'AGAP007182-PA', 67, NULL, NULL, 220922),
(220923, '3.40.47.10-FF-000109', NULL, '2-heptyl-4(1H)-quinolone synthase subunit PqsB', 156, NULL, NULL, 220923),
(220924, '3.40.630.30-FF-000356', NULL, 'Histone acetyltransferase', 72, NULL, NULL, 220924),
(220925, '1.10.8.10-FF-000299', NULL, 'Uncharacterized protein', 49, NULL, NULL, 220925),
(220926, '2.10.25.10-FF-000950', NULL, 'Protein Z, vitamin K-dependent plasma glycoprotein a', 53, NULL, NULL, 220926),
(220927, '3.40.50.300-FF-000225', NULL, 'Thymidylate kinase', 205, NULL, NULL, 220927),
(220928, '3.30.1370.10-FF-000017', NULL, 'Fragile X mental retardation syndrome-related protein 1', 80, NULL, NULL, 220928),
(220929, '2.40.50.140-FF-001086', NULL, NULL, 77, NULL, NULL, 220929),
(220930, '1.10.10.250-FF-000008', NULL, '39S ribosomal protein L11, mitochondrial', 64, NULL, NULL, 220930),
(220931, '2.60.210.10-FF-000026', NULL, 'Protein maternal effect lethal 26', 127, NULL, NULL, 220931),
(220932, '1.10.287.90-FF-000005', NULL, 'Quinol oxidase subunit 2', 88, NULL, NULL, 220932),
(220933, '3.40.50.880-FF-000016', NULL, 'Carbamoyl-phosphate synthase arginine-specific small chain', 210, NULL, NULL, 220933),
(220934, '3.10.20.90-FF-000325', NULL, 'Phosphoinositide phospholipase C', 91, NULL, NULL, 220934),
(220935, '1.20.1250.20-FF-001431', NULL, 'Peptide transporter family 1-like Protein', 141, NULL, NULL, 220935),
(220936, '3.40.50.2020-FF-000009', NULL, 'Xanthine phosphoribosyltransferase', 152, NULL, NULL, 220936),
(220937, '3.30.70.330-FF-001999', NULL, NULL, 88, NULL, NULL, 220937),
(220938, '1.25.10.10-FF-001211', NULL, 'ARM repeat superfamily protein', 211, NULL, NULL, 220938),
(220939, '1.10.287.3510-FF-000010', NULL, 'NADH:ubiquinone oxidoreductase subunit 4L', 96, NULL, NULL, 220939),
(220940, '2.30.36.70-FF-000003', NULL, 'Actin-related protein 6', 31, NULL, NULL, 220940),
(220941, '1.25.10.10-FF-003465', NULL, 'Uncharacterized protein', 118, NULL, NULL, 220941),
(220942, '3.30.70.330-FF-002617', NULL, NULL, 128, NULL, NULL, 220942),
(220943, '2.60.40.790-FF-000167', NULL, NULL, 109, NULL, NULL, 220943),
(220944, '2.40.50.140-FF-000158', NULL, 'Polyribonucleotide nucleotidyltransferase 1, chloroplastic', 72, NULL, NULL, 220944),
(220945, '3.40.1380.10-FF-000026', NULL, 'ATP synthase gamma chain 1 chloroplastic', 126, NULL, NULL, 220945);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(220946, '1.25.40.20-FF-000985', NULL, 'Predicted protein', 162, NULL, NULL, 220946),
(220947, '2.130.10.10-FF-000843', NULL, 'WD repeat-containing protein 3 homolog', 204, NULL, NULL, 220947),
(220948, '2.60.40.10-FF-003754', NULL, NULL, 96, NULL, NULL, 220948),
(220949, '2.40.70.10-FF-000547', NULL, NULL, 183, NULL, NULL, 220949),
(220950, '3.30.40.10-FF-001662', NULL, 'Uncharacterized protein', 129, NULL, NULL, 220950),
(220951, '1.20.5.1700-FF-000003', NULL, 'Homer homolog 1 (Drosophila)', 72, NULL, NULL, 220951),
(220952, '2.10.25.10-FF-001203', NULL, 'Uncharacterized protein (Fragment)', 37, NULL, NULL, 220952),
(220953, '3.90.550.50-FF-000148', NULL, 'Hexosyltransferase', 152, NULL, NULL, 220953),
(220954, '3.40.50.10190-FF-000267', NULL, 'DNA topoisomerase II binding protein 1', 86, NULL, NULL, 220954),
(220955, '3.40.50.1110-FF-000091', NULL, 'Uncharacterized protein', 212, NULL, NULL, 220955),
(220956, '3.90.226.10-FF-000113', NULL, 'Enoyl-CoA hydratase/isomerase family protein (AFU_orthologue AFUA_2G14850)', 223, NULL, NULL, 220956),
(220957, '3.30.110.60-FF-000002', NULL, 'CRS2-associated factor 1, chloroplastic', 96, NULL, NULL, 220957),
(220958, '1.10.3720.10-FF-000175', NULL, 'Opine/polyamine ABC transporter, permease protein', 258, NULL, NULL, 220958),
(220959, '3.80.10.10-FF-001304', NULL, 'EIN3-binding F-box domain containing protein', 112, NULL, NULL, 220959),
(220960, '3.90.70.10-FF-000363', NULL, 'Apoptosis inhibitory protein', 237, NULL, NULL, 220960),
(220961, '1.25.40.10-FF-004782', NULL, 'Uncharacterized protein', 184, NULL, NULL, 220961),
(220962, '1.25.10.10-FF-000806', NULL, 'Uncharacterized protein', 254, NULL, NULL, 220962),
(220963, '3.30.70.330-FF-002308', NULL, NULL, 168, NULL, NULL, 220963),
(220964, '3.40.30.10-FF-000458', NULL, 'Thioredoxin', 121, NULL, NULL, 220964),
(220965, '2.60.120.310-FF-000032', NULL, 'Uncharacterized protein', 48, NULL, NULL, 220965),
(220966, '3.90.640.10-FF-000177', NULL, 'actin isoform X1', 86, NULL, NULL, 220966),
(220967, '2.110.10.10-FF-000029', NULL, 'Matrix metallopeptidase 28', 194, NULL, NULL, 220967),
(220968, '3.40.1160.10-FF-000010', NULL, 'Delta-1-pyrroline-5-carboxylate synthase', 299, NULL, NULL, 220968),
(220969, '3.10.450.580-FF-000012', NULL, 'Mediator of RNA polymerase II transcription subunit 6', 134, NULL, NULL, 220969),
(220970, '3.40.50.2300-FF-000211', NULL, 'Glutamate receptor ionotropic, NMDA 2B', 162, NULL, NULL, 220970),
(220971, '3.40.50.880-FF-000163', NULL, 'CPSase', 215, NULL, NULL, 220971),
(220972, '1.25.40.20-FF-000277', NULL, 'Ankyrin repeat domain-containing protein 6', 51, NULL, NULL, 220972),
(220973, '3.30.200.20-FF-000340', NULL, 'Calmodulin-binding receptor-like cytoplasmic kinase 3', 105, NULL, NULL, 220973),
(220974, '3.10.20.90-FF-000634', NULL, 'Uncharacterized protein', 81, NULL, NULL, 220974),
(220975, '3.40.50.2000-FF-000150', NULL, 'Trehalose-6-phosphate synthase', 244, NULL, NULL, 220975),
(220976, '3.30.1370.50-FF-000023', NULL, 'NFKB-repressing factor', 83, NULL, NULL, 220976),
(220977, '3.40.630.30-FF-000665', NULL, 'Putative acetyltransferase', 150, NULL, NULL, 220977),
(220978, '1.10.287.70-FF-000090', NULL, 'two pore potassium channel protein sup-9', 272, NULL, NULL, 220978),
(220979, '3.40.1090.10-FF-000049', NULL, 'Patatin-like phospholipase domain containing 2', 126, NULL, NULL, 220979),
(220980, '1.10.40.30-FF-000010', NULL, 'Adenylosuccinate lyase', 66, NULL, NULL, 220980),
(220981, '2.60.120.1020-FF-000003', NULL, 'PAW domain-containing protein Y50D4B.3', 157, NULL, NULL, 220981),
(220982, '1.10.20.10-FF-000363', NULL, NULL, 142, NULL, NULL, 220982),
(220983, '3.40.50.300-FF-000933', NULL, 'ABC transporter A family member 7', 254, NULL, NULL, 220983),
(220984, '3.40.50.300-FF-003659', NULL, 'GM21754', 269, NULL, NULL, 220984),
(220985, '1.20.1250.20-FF-001212', NULL, 'DUF895 domain membrane protein', 241, NULL, NULL, 220985),
(220986, '1.10.30.10-FF-000189', NULL, 'Predicted protein', 93, NULL, NULL, 220986),
(220987, '3.10.250.10-FF-000075', NULL, NULL, 107, NULL, NULL, 220987);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(220988, '1.20.920.10-FF-000188', NULL, 'Uncharacterized protein', 82, NULL, NULL, 220988),
(220989, '2.10.50.10-FF-000019', NULL, 'Tumor necrosis factor receptor superfamily member 11A', 80, NULL, NULL, 220989),
(220990, '1.25.40.10-FF-001724', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 102, NULL, NULL, 220990),
(220991, '2.60.120.330-FF-000038', NULL, 'Si:dkey-10o6.2', 311, NULL, NULL, 220991),
(220992, '1.25.40.20-FF-001261', NULL, 'Predicted protein', 206, NULL, NULL, 220992),
(220993, '3.30.70.1440-FF-000006', NULL, 'Transporter, AcrB/D/F family', 101, NULL, NULL, 220993),
(220994, '3.30.200.20-FF-000716', NULL, 'Mitogen-activated protein kinase kinase 1', 100, NULL, NULL, 220994),
(220995, '3.30.70.330-FF-002983', NULL, NULL, 88, NULL, NULL, 220995),
(220996, '1.10.533.10-FF-000009', NULL, 'tumor necrosis factor receptor superfamily member 21', 94, NULL, NULL, 220996),
(220997, '3.80.10.10-FF-000686', NULL, 'LRR receptor-like serine/threonine-protein kinase GHR1', 236, NULL, NULL, 220997),
(220998, '3.30.40.10-FF-001353', NULL, 'RBR-type E3 ubiquitin transferase', 93, NULL, NULL, 220998),
(220999, '1.25.40.10-FF-000179', NULL, 'Mitochondrial fission 1 protein', 140, NULL, NULL, 220999),
(221000, '3.30.420.10-FF-000477', NULL, NULL, 196, NULL, NULL, 221000),
(221001, '3.40.50.1820-FF-001618', NULL, 'Uncharacterized protein', 60, NULL, NULL, 221001),
(221002, '2.60.40.10-FF-002793', NULL, 'Ig-like and fibronectin type-III domain-containing protein 1', 98, NULL, NULL, 221002),
(221003, '2.60.120.1040-FF-000009', NULL, 'Zinc finger protein zpr1, putative', 139, NULL, NULL, 221003),
(221004, '3.40.50.1820-FF-001803', NULL, 'Uncharacterized protein', 139, NULL, NULL, 221004),
(221005, '1.20.5.100-FF-000031', NULL, 'Integrin beta', 73, NULL, NULL, 221005),
(221006, '3.90.79.10-FF-000046', NULL, 'Nudix/MutT family protein', 148, NULL, NULL, 221006),
(221007, '3.80.10.10-FF-000579', NULL, 'Protein phosphatase 1 regulatory subunit 7', 73, NULL, NULL, 221007),
(221008, '2.40.40.20-FF-000026', NULL, 'Transitional endoplasmic reticulum ATPase, variant', 104, NULL, NULL, 221008),
(221009, '1.10.730.10-FF-000182', NULL, 'Leucyl Amino-acyl tRNA Synthetase', 22, NULL, NULL, 221009),
(221010, '2.10.25.10-FF-001782', NULL, 'Uncharacterized protein', 33, NULL, NULL, 221010),
(221011, '3.30.70.890-FF-000065', NULL, 'Predicted protein', 127, NULL, NULL, 221011),
(221012, '1.25.10.10-FF-002515', NULL, 'Predicted protein', 194, NULL, NULL, 221012),
(221013, '3.10.400.20-FF-000017', NULL, 'Uncharacterized protein', 178, NULL, NULL, 221013),
(221014, '3.10.20.90-FF-000769', NULL, 'Inhibitor of nuclear factor kappa B kinase subunit beta', 85, NULL, NULL, 221014),
(221015, '3.40.1450.10-FF-000004', NULL, '23-bisphosphoglycerate-independent phosphoglycerate mutase 1', 133, NULL, NULL, 221015),
(221016, '1.20.120.1080-FF-000145', NULL, 'Uncharacterized protein', 43, NULL, NULL, 221016),
(221017, '2.60.40.60-FF-000981', NULL, 'Uncharacterized protein', 101, NULL, NULL, 221017),
(221018, '2.130.10.10-FF-004783', NULL, 'Predicted protein', 151, NULL, NULL, 221018),
(221019, '3.30.565.10-FF-000515', NULL, 'Uncharacterized protein', 218, NULL, NULL, 221019),
(221020, '2.130.10.10-FF-000612', NULL, 'SEC12-like protein 2', 313, NULL, NULL, 221020),
(221021, '1.10.238.270-FF-000011', NULL, NULL, 163, NULL, NULL, 221021),
(221022, '1.10.30.10-FF-000161', NULL, 'HMG box-containing protein C28F2.11', 101, NULL, NULL, 221022),
(221023, '1.10.510.10-FF-002099', NULL, NULL, 39, NULL, NULL, 221023),
(221024, '3.90.550.10-FF-000743', NULL, 'UTP--glucose-1-phosphate uridylyltransferase family protein', 224, NULL, NULL, 221024),
(221025, '1.20.1250.20-FF-002151', NULL, 'Uncharacterized protein', 198, NULL, NULL, 221025),
(221026, '3.30.200.20-FF-001195', NULL, 'Calcium-dependent protein kinase 13', 78, NULL, NULL, 221026),
(221027, '3.40.50.300-FF-006306', NULL, 'Uncharacterized protein', 211, NULL, NULL, 221027),
(221028, '2.60.15.10-FF-000003', NULL, 'ATP synthase subunit delta, mitochondrial', 99, NULL, NULL, 221028);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(221029, '1.10.20.10-FF-000233', NULL, NULL, 128, NULL, NULL, 221029),
(221030, '2.40.180.10-FF-000004', NULL, 'Lipoxygenase homology domain-containing protein 1', 132, NULL, NULL, 221030),
(221031, '2.30.29.30-FF-001380', NULL, 'Uncharacterized protein', 122, NULL, NULL, 221031),
(221032, '2.30.29.30-FF-000874', NULL, 'Nuclear pore complex protein Nup50', 118, NULL, NULL, 221032),
(221033, '1.10.287.3550-FF-000005', NULL, 'Uncharacterized protein', 66, NULL, NULL, 221033),
(221034, '1.25.40.10-FF-005086', NULL, 'Uncharacterized protein', 83, NULL, NULL, 221034),
(221035, '3.40.1090.10-FF-000021', NULL, 'Patatin-like phospholipase domain containing 2', 85, NULL, NULL, 221035),
(221036, '2.60.120.620-FF-000041', NULL, 'prolyl 4-hydroxylase subunit alpha-2 isoform X5', 81, NULL, NULL, 221036),
(221037, '3.40.640.10-FF-000407', NULL, 'Aminotransferase, class V', 242, NULL, NULL, 221037),
(221038, '1.20.1250.20-FF-000594', NULL, 'MFS alpha-glucoside transporter', 468, NULL, NULL, 221038),
(221039, '1.10.472.10-FF-000547', NULL, 'Uncharacterized protein', 77, NULL, NULL, 221039),
(221040, '1.10.287.70-FF-000685', NULL, 'Uncharacterized protein', 82, NULL, NULL, 221040),
(221041, '3.30.9.10-FF-000084', NULL, 'FAD dependent oxidoreductase', 176, NULL, NULL, 221041),
(221042, '2.30.30.140-FF-000325', NULL, 'PHD finger protein 19', 31, NULL, NULL, 221042),
(221043, '1.20.144.10-FF-000019', NULL, 'Lipid A 1-diphosphate synthase', 113, NULL, NULL, 221043),
(221044, '2.60.40.1170-FF-000031', NULL, 'Coatomer subunit delta', 96, NULL, NULL, 221044),
(221045, '3.40.50.460-FF-000020', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase 1', 109, NULL, NULL, 221045),
(221046, '1.20.5.340-FF-000069', NULL, 'Rho-associated protein kinase', 163, NULL, NULL, 221046),
(221047, '3.40.50.300-FF-001523', NULL, 'Helicase (DNA) B', 132, NULL, NULL, 221047),
(221048, '3.90.550.50-FF-000159', NULL, 'Uncharacterized protein', 158, NULL, NULL, 221048),
(221049, '3.40.50.300-FF-005789', NULL, 'Dynein heavy chain 5, axonemal', 71, NULL, NULL, 221049),
(221050, '3.30.559.10-FF-000102', NULL, 'Nonribosomal peptide synthetase 8', 177, NULL, NULL, 221050),
(221051, '2.40.160.20-FF-000012', NULL, 'Outer membrane protein', 201, NULL, NULL, 221051),
(221052, '3.30.1150.10-FF-000023', NULL, NULL, 101, NULL, NULL, 221052),
(221053, '3.40.50.2300-FF-001419', NULL, NULL, 43, NULL, NULL, 221053),
(221054, '3.40.1850.10-FF-000001', NULL, 'SPI-1 type III secretion system effector HECT-type E3 ubiquitin transferase SopA', 75, NULL, NULL, 221054),
(221055, '3.60.40.10-FF-000149', NULL, 'Protein phosphatase 2C 29', 352, NULL, NULL, 221055),
(221056, '2.40.10.10-FF-000521', NULL, NULL, 27, NULL, NULL, 221056),
(221057, '3.80.10.10-FF-001198', NULL, 'Leucine Rich Repeat family protein', 91, NULL, NULL, 221057),
(221058, '2.60.210.10-FF-000043', NULL, NULL, 129, NULL, NULL, 221058),
(221059, '3.30.420.390-FF-000012', NULL, NULL, 95, NULL, NULL, 221059),
(221060, '3.50.4.10-FF-000011', NULL, 'Plasminogen', 87, NULL, NULL, 221060),
(221061, '1.20.920.10-FF-000183', NULL, 'Uncharacterized protein', 129, NULL, NULL, 221061),
(221062, '3.30.160.60-FF-000393', NULL, 'Zinc finger protein', 29, NULL, NULL, 221062),
(221063, '3.30.420.10-FF-000472', NULL, NULL, 174, NULL, NULL, 221063),
(221064, '2.70.170.10-FF-000143', NULL, 'Gamma-aminobutyric-acid receptor subunit beta-1', 200, NULL, NULL, 221064),
(221065, '3.40.50.300-FF-002951', NULL, 'Putative ras-like small GTPases', 120, NULL, NULL, 221065),
(221066, '3.30.230.10-FF-000075', NULL, 'DNA topoisomerase 2', 123, NULL, NULL, 221066),
(221067, '3.30.70.1400-FF-000028', NULL, 'Uncharacterized protein', 26, NULL, NULL, 221067),
(221068, '3.40.50.2300-FF-000009', NULL, 'Glutamate receptor, metabotropic 4', 147, NULL, NULL, 221068),
(221069, '3.90.950.10-FF-000043', NULL, 'Uncharacterized protein', 184, NULL, NULL, 221069),
(221070, '3.30.200.20-FF-000576', NULL, 'CBN-SEK-1 protein', 97, NULL, NULL, 221070),
(221071, '2.130.10.10-FF-005300', NULL, 'Predicted protein', 218, NULL, NULL, 221071);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(221072, '1.10.630.10-FF-000230', NULL, 'Cytochrome P450', 170, NULL, NULL, 221072),
(221073, '1.10.10.60-FF-000489', NULL, 'Fis family transcriptional regulator', 60, NULL, NULL, 221073),
(221074, '1.10.287.380-FF-000031', NULL, 'Valine--tRNA ligase', 72, NULL, NULL, 221074),
(221075, '3.30.160.60-FF-005968', NULL, NULL, 73, NULL, NULL, 221075),
(221076, '2.130.10.10-FF-003838', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit TRM82', 295, NULL, NULL, 221076),
(221077, '3.40.50.720-FF-001076', NULL, 'Paratose synthase', 285, NULL, NULL, 221077),
(221078, '1.20.1070.10-FF-001105', NULL, 'Novel protein similar to vertebrate prostaglandin E receptor 2 (Subtype EP2), 53kDa (PTGER2)', 312, NULL, NULL, 221078),
(221079, '2.40.50.100-FF-000141', NULL, 'Sugar ABC transporter ATP-binding protein', 85, NULL, NULL, 221079),
(221080, '3.30.40.10-FF-001561', NULL, 'Ubiquitin-protein ligase peroxin 2', 161, NULL, NULL, 221080),
(221081, '2.60.120.260-FF-000011', NULL, 'E3 ubiquitin-protein ligase MYCBP2 isoform X1', 155, NULL, NULL, 221081),
(221082, '3.40.50.300-FF-005368', NULL, 'Atlastin-1', 315, NULL, NULL, 221082),
(221083, '1.10.1670.10-FF-000063', NULL, NULL, 14, NULL, NULL, 221083),
(221084, '1.25.40.10-FF-002343', NULL, 'GM12896', 129, NULL, NULL, 221084),
(221085, '3.10.450.10-FF-000051', NULL, 'Cystatin cpi-1', 105, NULL, NULL, 221085),
(221086, '1.10.10.2660-FF-000001', NULL, 'Ubiquitin-activating enzyme E1 1', 247, NULL, NULL, 221086),
(221087, '1.10.472.130-FF-000002', NULL, 'Cytoplasmic dynein heavy chain 1', 160, NULL, NULL, 221087),
(221088, '1.20.900.10-FF-000069', NULL, 'Uncharacterized protein', 237, NULL, NULL, 221088),
(221089, '3.30.450.20-FF-000510', NULL, 'Probable response regulatory protein', 111, NULL, NULL, 221089),
(221090, '1.10.275.10-FF-000022', NULL, NULL, 113, NULL, NULL, 221090),
(221091, '1.20.58.1000-FF-000006', NULL, 'Uncharacterized protein', 102, NULL, NULL, 221091),
(221092, '3.30.160.60-FF-002321', NULL, 'Putative transcriptional repressor ctcf', 29, NULL, NULL, 221092),
(221093, '3.10.100.10-FF-000183', NULL, 'C type lectin receptor A', 172, NULL, NULL, 221093),
(221094, '3.30.70.330-FF-001443', NULL, 'RNA-binding protein, putative', 147, NULL, NULL, 221094),
(221095, '1.20.58.160-FF-000003', NULL, 'VHS domain protein', 99, NULL, NULL, 221095),
(221096, '1.10.287.70-FF-000213', NULL, 'Voltage-dependent L-type calcium channel subunit alpha-1S', 133, NULL, NULL, 221096),
(221097, '1.20.950.20-FF-000007', NULL, 'Formate dehydrogenase, gamma subunit', 208, NULL, NULL, 221097),
(221098, '3.40.30.10-FF-001190', NULL, 'Thioredoxin-like protein', 100, NULL, NULL, 221098),
(221099, '1.10.418.10-FF-000147', NULL, 'EB1', 124, NULL, NULL, 221099),
(221100, '3.30.160.60-FF-004928', NULL, NULL, 30, NULL, NULL, 221100),
(221101, '3.90.70.10-FF-000835', NULL, 'Uncharacterized protein', 146, NULL, NULL, 221101),
(221102, '2.60.40.10-FF-001253', NULL, 'T-cell surface glycoprotein CD4', 99, NULL, NULL, 221102),
(221103, '2.60.40.10-FF-002681', NULL, NULL, 101, NULL, NULL, 221103),
(221104, '3.70.10.10-FF-000091', NULL, 'DNA repair protein rad9', 324, NULL, NULL, 221104),
(221105, '3.30.70.1020-FF-000010', NULL, 'Glycosyltransferase', 77, NULL, NULL, 221105),
(221106, '3.30.70.360-FF-000030', NULL, 'Probable hydrolase', 115, NULL, NULL, 221106),
(221107, '2.30.30.100-FF-000100', NULL, 'Small nuclear ribonucleoprotein D1', 38, NULL, NULL, 221107),
(221108, '3.40.50.980-FF-000052', NULL, 'Uncharacterized protein', 122, NULL, NULL, 221108),
(221109, '3.40.50.2300-FF-000110', NULL, 'Argonaute 10', 173, NULL, NULL, 221109),
(221110, '3.40.50.300-FF-000697', NULL, 'DnaJ homolog subfamily C member 27', 187, NULL, NULL, 221110),
(221111, '2.10.90.10-FF-000117', NULL, 'Uncharacterized protein', 103, NULL, NULL, 221111),
(221112, '3.30.160.60-FF-000876', NULL, 'Zinc finger protein 335', 60, NULL, NULL, 221112),
(221113, '1.25.40.20-FF-001244', NULL, 'Ankyrin repeat-containing protein BDA1', 241, NULL, NULL, 221113),
(221114, '1.10.720.40-FF-000004', NULL, 'Ankyrin repeat and LEM domain-containing protein 1 homolog', 42, NULL, NULL, 221114);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(221115, '3.40.50.1100-FF-000082', NULL, 'Cysteine synthase', 171, NULL, NULL, 221115),
(221116, '3.30.60.300-FF-000004', NULL, 'Uncharacterized protein', 31, NULL, NULL, 221116),
(221117, '3.40.50.1000-FF-000518', NULL, NULL, 60, NULL, NULL, 221117),
(221118, '3.40.50.1820-FF-001253', NULL, 'Carboxylic ester hydrolase', 313, NULL, NULL, 221118),
(221119, '1.25.10.70-FF-000009', NULL, 'Uncharacterized protein', 314, NULL, NULL, 221119),
(221120, '2.30.30.40-FF-000037', NULL, 'Rho guanine nucleotide exchange factor 9', 66, NULL, NULL, 221120),
(221121, '3.10.50.40-FF-000155', NULL, 'Peptidylprolyl isomerase', 62, NULL, NULL, 221121),
(221122, '1.10.10.10-FF-000418', NULL, 'BlaI/MecI/CopY family transcriptional regulator', 68, NULL, NULL, 221122),
(221123, '1.20.1160.11-FF-000012', NULL, 'Paired amphipathic helix protein Sin3-like 3', 71, NULL, NULL, 221123),
(221124, '2.40.100.10-FF-000146', NULL, 'Peptidyl-prolyl cis-trans isomerase', 178, NULL, NULL, 221124),
(221125, '3.30.420.80-FF-000009', NULL, '50S ribosomal protein L18', 133, NULL, NULL, 221125),
(221126, '1.25.40.240-FF-000001', NULL, 'X-ray repair cross-complementing protein 5', 151, NULL, NULL, 221126),
(221127, '2.40.50.140-FF-000580', NULL, 'DNA replication licensing factor MCM7', 27, NULL, NULL, 221127),
(221128, '3.40.190.10-FF-000546', NULL, 'Osmoprotection protein (ProWX)', 154, NULL, NULL, 221128),
(221129, '3.40.50.1820-FF-001141', NULL, 'Carboxypeptidase', 198, NULL, NULL, 221129),
(221130, '3.80.10.10-FF-004053', NULL, 'Uncharacterized protein', 136, NULL, NULL, 221130),
(221131, '3.80.10.10-FF-003434', NULL, 'Uncharacterized protein', 64, NULL, NULL, 221131),
(221132, '3.30.160.60-FF-000764', NULL, 'Zinc finger protein 335', 61, NULL, NULL, 221132),
(221133, '1.25.40.10-FF-001707', NULL, 'Pentatricopeptide repeat-containing protein At1g11290, chloroplastic', 101, NULL, NULL, 221133),
(221134, '3.90.1330.10-FF-000001', NULL, 'Xylan alpha-1,2-glucuronidase', 205, NULL, NULL, 221134),
(221135, '3.40.140.10-FF-000043', NULL, 'ComE operon protein 2', 145, NULL, NULL, 221135),
(221136, '1.25.40.20-FF-001132', NULL, 'Uncharacterized protein', 168, NULL, NULL, 221136),
(221137, '3.40.850.10-FF-000333', NULL, 'Kinesin-like protein', 339, NULL, NULL, 221137),
(221138, '3.50.30.30-FF-000048', NULL, 'Tre2p', 188, NULL, NULL, 221138),
(221139, '1.25.10.10-FF-000475', NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', 316, NULL, NULL, 221139),
(221140, '2.40.30.10-FF-000421', NULL, 'Uncharacterized protein', 74, NULL, NULL, 221140),
(221141, '3.20.20.120-FF-000001', NULL, 'Enolase', 306, NULL, NULL, 221141),
(221142, '3.50.50.60-FF-000721', NULL, 'Mercuric reductase', 189, NULL, NULL, 221142),
(221143, '3.40.50.1820-FF-000522', NULL, 'Alpha/beta fold hydrolase', 247, NULL, NULL, 221143),
(221144, '3.80.10.10-FF-003013', NULL, 'Predicted protein', 177, NULL, NULL, 221144),
(221145, '3.30.70.2820-FF-000010', NULL, NULL, 109, NULL, NULL, 221145),
(221146, '2.60.40.10-FF-002776', NULL, 'Protein tyrosine phosphatase, receptor type, s, a', 86, NULL, NULL, 221146),
(221147, '3.60.15.10-FF-000265', NULL, 'Chromosome 7, whole genome shotgun sequence', 148, NULL, NULL, 221147),
(221148, '3.80.10.10-FF-003564', NULL, 'Uncharacterized protein', 289, NULL, NULL, 221148),
(221149, '3.30.420.60-FF-000003', NULL, 'Peptide chain release factor subunit 1', 138, NULL, NULL, 221149),
(221150, '3.90.120.10-FF-000014', NULL, 'tRNA (cytosine(38)-C(5))-methyltransferase', 24, NULL, NULL, 221150),
(221151, '3.30.1330.20-FF-000012', NULL, 'Cell division protein FtsZ 1, chloroplastic', 138, NULL, NULL, 221151),
(221152, '3.90.70.10-FF-000498', NULL, 'AEL242Wp', 336, NULL, NULL, 221152),
(221153, '1.10.1410.10-FF-000055', NULL, 'PAP associated domain containing 5 (Predicted)', 15, NULL, NULL, 221153),
(221154, '3.30.420.40-FF-000705', NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', 186, NULL, NULL, 221154),
(221155, '1.10.287.3990-FF-000002', NULL, '26S proteasome non-ATPase regulatory subunit 4 homolog', 120, NULL, NULL, 221155);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(221156, '1.20.120.350-FF-000273', NULL, NULL, 86, NULL, NULL, 221156),
(221157, '3.30.900.10-FF-000031', NULL, 'Uncharacterized protein', 196, NULL, NULL, 221157),
(221158, '3.40.50.720-FF-001868', NULL, 'Pyrroline-5-carboxylate reductase', 165, NULL, NULL, 221158),
(221159, '1.25.10.10-FF-002936', NULL, 'Uncharacterized protein', 87, NULL, NULL, 221159),
(221160, '1.10.10.60-FF-000601', NULL, 'Repressor activator protein', 220, NULL, NULL, 221160),
(221161, '1.20.1070.10-FF-000700', NULL, 'GPCR class b orphan receptor 3', 190, NULL, NULL, 221161),
(221162, '2.10.110.10-FF-000007', NULL, 'actin-binding LIM protein 1 isoform X1', 68, NULL, NULL, 221162),
(221163, '3.30.460.30-FF-000002', NULL, 'Glutamyl-tRNA reductase', 149, NULL, NULL, 221163),
(221164, '1.25.40.10-FF-004681', NULL, 'Uncharacterized protein', 106, NULL, NULL, 221164),
(221165, '3.40.47.10-FF-000238', NULL, NULL, 55, NULL, NULL, 221165),
(221166, '3.30.160.60-FF-006492', NULL, NULL, 64, NULL, NULL, 221166),
(221167, '1.25.40.10-FF-001696', NULL, 'Flagellar associated protein', 141, NULL, NULL, 221167),
(221168, '3.50.50.60-FF-001098', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 241, NULL, NULL, 221168),
(221169, '1.10.10.60-FF-000961', NULL, NULL, 56, NULL, NULL, 221169),
(221170, '2.60.120.650-FF-000246', NULL, 'Predicted protein', 14, NULL, NULL, 221170),
(221171, '3.40.50.12780-FF-000072', NULL, 'Long-chain-fatty-acid-CoA ligase, putative', 429, NULL, NULL, 221171),
(221172, '1.20.120.220-FF-000021', NULL, 'ATP synthase subunit a', 166, NULL, NULL, 221172),
(221173, '2.60.40.10-FF-006036', NULL, NULL, 118, NULL, NULL, 221173),
(221174, '3.40.50.300-FF-002142', NULL, 'ATP-dependent DNA helicase', 265, NULL, NULL, 221174),
(221175, '2.130.10.10-FF-001809', NULL, 'Uncharacterized protein', 134, NULL, NULL, 221175),
(221176, '3.40.50.10860-FF-000058', NULL, 'Uncharacterized protein', 89, NULL, NULL, 221176),
(221177, '3.10.620.10-FF-000008', NULL, 'Uncharacterized protein', 71, NULL, NULL, 221177),
(221178, '1.20.1070.10-FF-002162', NULL, 'Uncharacterized protein', 143, NULL, NULL, 221178),
(221179, '3.20.180.20-FF-000019', NULL, 'Glutathione S-transferase class-mu 26 kDa isozyme', 83, NULL, NULL, 221179),
(221180, '3.30.40.10-FF-000049', NULL, 'Histone-lysine N-methyltransferase', 49, NULL, NULL, 221180),
(221181, '4.10.60.10-FF-000167', NULL, 'WGS project CABT00000000 data, contig 2.31', 70, NULL, NULL, 221181),
(221182, '3.30.60.90-FF-000029', NULL, 'Putative N6-adenosine-methyltransferase with ZZ-type zinc-binding domains', 58, NULL, NULL, 221182),
(221183, '1.25.70.10-FF-000012', NULL, 'transcription termination factor MTERF6, chloroplastic/mitochondrial', 234, NULL, NULL, 221183),
(221184, '2.60.40.150-FF-000441', NULL, 'Calcium-dependent protein kinase 1', 125, NULL, NULL, 221184),
(221185, '3.40.275.10-FF-000002', NULL, 'L-fucose isomerase, putative', 141, NULL, NULL, 221185),
(221186, '1.25.40.20-FF-000513', NULL, 'ADP-ribosylation factor GTPase-activating protein AGD1', 126, NULL, NULL, 221186),
(221187, '1.10.8.870-FF-000022', NULL, 'Glycerol-3-phosphate dehydrogenase', 127, NULL, NULL, 221187),
(221188, '3.90.730.10-FF-000032', NULL, 'Uncharacterized protein', 96, NULL, NULL, 221188),
(221189, '1.10.472.10-FF-000194', NULL, 'Putative cyclin-D2-3', 59, NULL, NULL, 221189),
(221190, '3.40.50.300-FF-004749', NULL, 'Inner dynein arm I1 heavy chain 1-ALPHA', 190, NULL, NULL, 221190),
(221191, '3.30.1010.10-FF-000108', NULL, 'Predicted protein', 149, NULL, NULL, 221191),
(221192, '2.60.40.1460-FF-000011', NULL, 'integrin alpha-PS2 isoform X2', 160, NULL, NULL, 221192),
(221193, '2.60.40.10-FF-005210', NULL, NULL, 91, NULL, NULL, 221193),
(221194, '2.130.10.10-FF-003485', NULL, 'Protein CBG02750', 294, NULL, NULL, 221194),
(221195, '3.40.50.620-FF-000220', NULL, 'Glutamine-dependent NAD(+) synthetase', 371, NULL, NULL, 221195),
(221196, '1.20.1250.20-FF-000122', NULL, 'D-xylose transporter XylE', 481, NULL, NULL, 221196),
(221197, '1.10.10.60-FF-000068', NULL, 'Orthodenticle homeobox 1', 68, NULL, NULL, 221197);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(221198, '1.20.1070.10-FF-001217', NULL, 'Predicted protein', 229, NULL, NULL, 221198),
(221199, '3.10.50.40-FF-000043', NULL, 'Peptidylprolyl isomerase', 122, NULL, NULL, 221199),
(221200, '3.30.160.60-FF-004350', NULL, NULL, 20, NULL, NULL, 221200),
(221201, '3.30.450.20-FF-000398', NULL, 'Aryl hydrocarbon receptor nuclear translocator-like 2', 157, NULL, NULL, 221201),
(221202, '1.10.8.710-FF-000002', NULL, 'dynein heavy chain 17, axonemal', 109, NULL, NULL, 221202),
(221203, '2.40.70.10-FF-000317', NULL, NULL, 220, NULL, NULL, 221203),
(221204, '1.10.10.10-FF-000047', NULL, 'Transcription factor', 94, NULL, NULL, 221204),
(221205, '1.20.1270.280-FF-000073', NULL, 'Uncharacterized protein', 104, NULL, NULL, 221205),
(221206, '1.20.1250.20-FF-001532', NULL, 'AaceriABR223Cp', 447, NULL, NULL, 221206),
(221207, '3.10.100.10-FF-000295', NULL, NULL, 138, NULL, NULL, 221207),
(221208, '3.30.70.330-FF-000824', NULL, 'U2 small nuclear ribonucleoprotein B', 89, NULL, NULL, 221208),
(221209, '2.130.10.10-FF-000079', NULL, 'striatin isoform X1', 163, NULL, NULL, 221209),
(221210, '3.90.76.10-FF-000005', NULL, 'Peptide ABC transporter substrate-binding protein SapA', 173, NULL, NULL, 221210),
(221211, '1.20.58.60-FF-000874', NULL, 'Spectrin beta chain', 76, NULL, NULL, 221211),
(221212, '1.10.220.150-FF-000053', NULL, 'Alpha-protein kinase 1', 127, NULL, NULL, 221212),
(221213, '2.60.120.970-FF-000095', NULL, 'Bone morphogenetic protein 8B-like protein', 169, NULL, NULL, 221213),
(221214, '3.30.160.60-FF-005547', NULL, NULL, 26, NULL, NULL, 221214),
(221215, '1.10.10.1800-FF-000007', NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', 97, NULL, NULL, 221215),
(221216, '1.10.10.10-FF-000856', NULL, 'PROBABLE TRANSCRIPTIONAL REPRESSOR PROTEIN', 144, NULL, NULL, 221216),
(221217, '3.10.20.90-FF-000657', NULL, 'Uncharacterized protein', 90, NULL, NULL, 221217),
(221218, '1.10.510.10-FF-002992', NULL, 'Uncharacterized protein', 278, NULL, NULL, 221218),
(221219, '1.50.40.10-FF-000334', NULL, 'Solute carrier family 25 member 36-A', 311, NULL, NULL, 221219),
(221220, '1.50.40.10-FF-000564', NULL, 'Mitochondrial substrate carrier family protein W', 116, NULL, NULL, 221220),
(221221, '1.10.1370.30-FF-000006', NULL, 'Angiotensin-converting enzyme', 341, NULL, NULL, 221221),
(221222, '1.20.120.1910-FF-000006', NULL, 'Cysteine--tRNA ligase', 158, NULL, NULL, 221222),
(221223, '3.20.20.70-FF-000701', NULL, NULL, 154, NULL, NULL, 221223),
(221224, '3.40.190.290-FF-000044', NULL, 'LysR family transcriptional regulator', 205, NULL, NULL, 221224),
(221225, '1.25.40.20-FF-000176', NULL, 'ankyrin repeat domain-containing protein 17 isoform X1', 139, NULL, NULL, 221225),
(221226, '2.40.50.140-FF-000366', NULL, 'Replication protein A1, large subunit', 137, NULL, NULL, 221226),
(221227, '3.10.330.10-FF-000020', NULL, 'PeRoXisome assembly factor', 80, NULL, NULL, 221227),
(221228, '1.10.20.10-FF-000121', NULL, 'DNA polymerase II third subunit', 93, NULL, NULL, 221228),
(221229, '3.30.505.10-FF-000270', NULL, NULL, 86, NULL, NULL, 221229),
(221230, '3.30.70.3490-FF-000065', NULL, NULL, 150, NULL, NULL, 221230),
(221231, '2.60.40.10-FF-005547', NULL, NULL, 119, NULL, NULL, 221231),
(221232, '3.40.50.300-FF-003440', NULL, 'Deletions Of G-rich DNA', 240, NULL, NULL, 221232),
(221233, '1.25.40.10-FF-005198', NULL, 'SH3 domain and tetratricopeptide repeat-containing protein 2', 214, NULL, NULL, 221233),
(221234, '1.20.1580.10-FF-000003', NULL, 'UvrABC system protein A', 110, NULL, NULL, 221234),
(221235, '1.10.3370.10-FF-000046', NULL, 'Uncharacterized protein', 118, NULL, NULL, 221235),
(221236, '3.40.50.300-FF-001411', NULL, 'Dynein heavy chain domain 1', 192, NULL, NULL, 221236),
(221237, '3.80.10.10-FF-002945', NULL, 'CLL4A clavata1-like receptor S/T protein kinase protein', 237, NULL, NULL, 221237),
(221238, '3.90.70.10-FF-000043', NULL, 'Ubiquitin carboxyl-terminal hydrolase 40', 313, NULL, NULL, 221238),
(221239, '1.10.287.70-FF-000230', NULL, 'Inward Rectifying K (Potassium) channel family', 130, NULL, NULL, 221239);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(221240, '3.30.9.10-FF-000196', NULL, 'Uncharacterized protein', 94, NULL, NULL, 221240),
(221241, '3.90.550.50-FF-000047', NULL, 'Hexosyltransferase', 260, NULL, NULL, 221241),
(221242, '3.50.7.10-FF-000052', NULL, NULL, 172, NULL, NULL, 221242),
(221243, '2.60.40.10-FF-002321', NULL, 'GG12177', 108, NULL, NULL, 221243),
(221244, '1.10.390.10-FF-000082', NULL, 'Os09g0410125 protein', 92, NULL, NULL, 221244),
(221245, '3.40.50.1000-FF-000395', NULL, 'HAD family hydrolase', 117, NULL, NULL, 221245),
(221246, '1.25.10.10-FF-003004', NULL, 'Uncharacterized protein', 345, NULL, NULL, 221246),
(221247, '3.65.10.20-FF-000016', NULL, 'WGS project CABT00000000 data, contig 2.4', 223, NULL, NULL, 221247),
(221248, '1.20.120.350-FF-000161', NULL, NULL, 120, NULL, NULL, 221248),
(221249, '1.10.10.620-FF-000001', NULL, 'Ribosome modulation factor', 55, NULL, NULL, 221249),
(221250, '3.30.450.50-FF-000053', NULL, 'Predicted protein', 125, NULL, NULL, 221250),
(221251, '3.10.440.10-FF-000011', NULL, '50S ribosomal protein L31e', 91, NULL, NULL, 221251),
(221252, '3.40.50.2300-FF-000447', NULL, 'Receptor-type guanylate cyclase gcy-19', 178, NULL, NULL, 221252),
(221253, '1.20.58.60-FF-000211', NULL, 'Spectrin repeat containing nuclear envelope protein 2', 224, NULL, NULL, 221253),
(221254, '2.120.10.30-FF-000259', NULL, 'NHL repeat-containing protein 2-like Protein', 152, NULL, NULL, 221254),
(221255, '1.10.510.10-FF-000524', NULL, 'Cell division protein kinase 2', 210, NULL, NULL, 221255),
(221256, '2.30.30.380-FF-000043', NULL, 'Protein transport protein SEC23', 59, NULL, NULL, 221256),
(221257, '1.20.1250.20-FF-001420', NULL, 'MFS tranporter, putative', 172, NULL, NULL, 221257),
(221258, '3.90.550.10-FF-000372', NULL, 'Uncharacterized protein', 415, NULL, NULL, 221258),
(221259, '2.30.180.10-FF-000063', NULL, 'Os06g0285100 protein', 125, NULL, NULL, 221259),
(221260, '1.10.760.10-FF-000003', NULL, 'Cbb3-type cytochrome c oxidase subunit II', 163, NULL, NULL, 221260),
(221261, '3.40.630.20-FF-000016', NULL, 'Pyroglutamyl-peptidase I-like', 208, NULL, NULL, 221261),
(221262, '2.60.40.10-FF-005098', NULL, NULL, 99, NULL, NULL, 221262),
(221263, '2.40.110.10-FF-000091', NULL, 'Uncharacterized protein', 103, NULL, NULL, 221263),
(221264, '2.160.20.10-FF-000314', NULL, 'Uncharacterized protein', 202, NULL, NULL, 221264),
(221265, '2.20.70.70-FF-000004', NULL, 'Penicillin-binding protein 2B', 22, NULL, NULL, 221265),
(221266, '3.40.30.10-FF-001200', NULL, 'Uncharacterized protein', 72, NULL, NULL, 221266),
(221267, '1.10.630.10-FF-000590', NULL, 'Protein CBG01396', 291, NULL, NULL, 221267),
(221268, '2.40.37.20-FF-000007', NULL, 'Uncharacterized protein', 173, NULL, NULL, 221268),
(221269, '3.90.180.10-FF-000023', NULL, 'Prostaglandin reductase 3 isoform 1', 152, NULL, NULL, 221269),
(221270, '3.40.50.1820-FF-001478', NULL, 'Uncharacterized protein', 171, NULL, NULL, 221270),
(221271, '3.30.230.130-FF-000014', NULL, 'CDC53p Cullin', 159, NULL, NULL, 221271),
(221272, '3.90.190.10-FF-000400', NULL, 'Predicted protein', 211, NULL, NULL, 221272),
(221273, '3.30.505.10-FF-000169', NULL, NULL, 115, NULL, NULL, 221273),
(221274, '3.30.565.10-FF-000144', NULL, 'Two-component sensor histidine kinase', 153, NULL, NULL, 221274),
(221275, '3.20.20.80-FF-000788', NULL, 'Uncharacterized protein', 190, NULL, NULL, 221275),
(221276, '1.10.10.60-FF-000152', NULL, 'Trihelix transcription factor ASIL2', 66, NULL, NULL, 221276),
(221277, '3.80.10.10-FF-004070', NULL, 'Putative mitogen-activated protein kinase kinase 3', 131, NULL, NULL, 221277),
(221278, '3.40.50.300-FF-004396', NULL, 'Protein CBG00332', 192, NULL, NULL, 221278),
(221279, '2.60.40.150-FF-000571', NULL, 'Uncharacterized protein', 139, NULL, NULL, 221279),
(221280, '1.10.510.10-FF-003397', NULL, NULL, 305, NULL, NULL, 221280),
(221281, '2.130.10.10-FF-004345', NULL, 'Uncharacterized protein', 97, NULL, NULL, 221281),
(221282, '2.60.40.10-FF-000067', NULL, 'basement membrane-specific heparan sulfate proteoglycan core protein', 88, NULL, NULL, 221282),
(221283, '3.40.50.1390-FF-000005', NULL, 'TnpR recombinase', 95, NULL, NULL, 221283); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(221284, '3.40.50.620-FF-000332', NULL, 'Phosphoadenosine phosphosulfate reductase', 231, NULL, NULL, 221284),
(221285, '3.40.50.150-FF-000500', NULL, 'mRNA capping methyltransferase, putative', 268, NULL, NULL, 221285),
(221286, '3.30.70.330-FF-003129', NULL, NULL, 159, NULL, NULL, 221286),
(221287, '3.40.50.2020-FF-000133', NULL, 'Adenine phosphoribosyltransferase 1, chloroplastic', 81, NULL, NULL, 221287),
(221288, '3.20.20.70-FF-000589', NULL, NULL, 62, NULL, NULL, 221288),
(221289, '3.40.630.30-FF-000688', NULL, 'Uncharacterized protein', 68, NULL, NULL, 221289),
(221290, '3.90.226.10-FF-000349', NULL, '3-hydroxyisobutyryl-CoA hydrolase 1', 140, NULL, NULL, 221290),
(221291, '3.40.140.10-FF-000026', NULL, '26S proteasome non-ATPase regulatory subunit 14', 221, NULL, NULL, 221291),
(221292, '2.130.10.10-FF-001591', NULL, 'Nucleolar protein 10 putative', 313, NULL, NULL, 221292),
(221293, '3.40.50.300-FF-002934', NULL, 'DBP6p protein', 255, NULL, NULL, 221293),
(221294, '2.40.50.1060-FF-000025', NULL, 'Uncharacterized protein', 174, NULL, NULL, 221294),
(221295, '2.60.40.2880-FF-000004', NULL, 'Probable conserved membrane protein mmpS1', 90, NULL, NULL, 221295),
(221296, '3.30.830.10-FF-000166', NULL, 'Putative mitochondrial-processing peptidase subunit beta mitochondrial', 63, NULL, NULL, 221296),
(221297, '3.40.1190.20-FF-000200', NULL, NULL, 198, NULL, NULL, 221297),
(221298, '3.30.70.2190-FF-000006', NULL, 'Predicted D-lactate dehydrogenase Fe-S protein FAD/FMN-containing', 117, NULL, NULL, 221298),
(221299, '1.25.40.10-FF-004029', NULL, 'Uncharacterized protein', 186, NULL, NULL, 221299),
(221300, '3.20.20.70-FF-000561', NULL, 'Dihydroorotate dehydrogenase (quinone)', 349, NULL, NULL, 221300),
(221301, '3.40.50.410-FF-000275', NULL, 'ATP-dependent DNA helicase II subunit 2', 71, NULL, NULL, 221301),
(221302, '3.40.50.720-FF-000345', NULL, 'Homoserine dehydrogenase', 175, NULL, NULL, 221302),
(221303, '2.60.40.10-FF-003170', NULL, 'Uncharacterized protein', 92, NULL, NULL, 221303),
(221304, '1.25.40.10-FF-000426', NULL, 'LON peptidase N-terminal domain and RING finger protein 1', 116, NULL, NULL, 221304),
(221305, '3.40.1280.10-FF-000081', NULL, 'rRNA methyltransferase 1, mitochondrial', 175, NULL, NULL, 221305),
(221306, '3.30.60.30-FF-000039', NULL, 'Agrin isoform B', 73, NULL, NULL, 221306),
(221307, '3.10.170.20-FF-000004', NULL, 'Leishmanolysin-like peptidase', 177, NULL, NULL, 221307),
(221308, '1.10.533.10-FF-000217', NULL, 'Fas cell surface death receptor', 97, NULL, NULL, 221308),
(221309, '3.10.250.10-FF-000070', NULL, NULL, 105, NULL, NULL, 221309),
(221310, '3.90.70.160-FF-000001', NULL, 'ORF1a polyprotein', 128, NULL, NULL, 221310),
(221311, '3.30.450.190-FF-000003', NULL, 'Small monomeric GTPase (Gtr1)', 134, NULL, NULL, 221311),
(221312, '1.10.150.530-FF-000004', NULL, 'Probable dual-specificity RNA methyltransferase RlmN', 58, NULL, NULL, 221312),
(221313, '3.90.70.10-FF-000386', NULL, 'Os09g0564200 protein', 207, NULL, NULL, 221313),
(221314, '3.80.30.20-FF-000027', NULL, 'MiaB-like tRNA modifying enzyme', 232, NULL, NULL, 221314),
(221315, '3.30.70.330-FF-002741', NULL, NULL, 135, NULL, NULL, 221315),
(221316, '2.60.40.10-FF-004119', NULL, NULL, 92, NULL, NULL, 221316),
(221317, '3.90.1150.10-FF-000341', NULL, 'Probable 8-amino-7-oxononanoate synthase (Eurofung)', 113, NULL, NULL, 221317),
(221318, '3.10.110.10-FF-000121', NULL, 'Protein crossbronx', 162, NULL, NULL, 221318),
(221319, '1.25.10.10-FF-002953', NULL, 'Uncharacterized protein', 465, NULL, NULL, 221319),
(221320, '1.20.58.80-FF-000088', NULL, 'Uncharacterized protein', 79, NULL, NULL, 221320),
(221321, '2.60.40.10-FF-004479', NULL, NULL, 105, NULL, NULL, 221321),
(221322, '3.30.1370.10-FF-000129', NULL, 'Pre-rRNA-processing protein PNO1', 97, NULL, NULL, 221322),
(221323, '2.40.100.10-FF-000016', NULL, 'Peptidyl-prolyl cis-trans isomerase', 172, NULL, NULL, 221323),
(221324, '3.40.50.300-FF-004620', NULL, 'Dynein heavy chain, putative', 263, NULL, NULL, 221324),
(221325, '2.60.260.20-FF-000083', NULL, 'Heat shock protein DNAJ, putative', 72, NULL, NULL, 221325);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(221326, '2.60.120.10-FF-000491', NULL, 'Centromere protein C', 88, NULL, NULL, 221326),
(221327, '1.10.510.10-FF-001143', NULL, 'Uncharacterized protein, isoform A', 92, NULL, NULL, 221327),
(221328, '3.20.20.100-FF-000220', NULL, 'Uncharacterized protein', 156, NULL, NULL, 221328),
(221329, '1.20.1540.10-FF-000012', NULL, 'Rhomboid family protein', 196, NULL, NULL, 221329),
(221330, '1.10.238.10-FF-000262', NULL, 'calbindin-32 isoform X2', 95, NULL, NULL, 221330),
(221331, '1.10.288.10-FF-000001', NULL, 'Methionine synthase', 87, NULL, NULL, 221331),
(221332, '1.10.1530.10-FF-000002', NULL, 'Malate/L-lactate dehydrogenase', 55, NULL, NULL, 221332),
(221333, '1.10.10.10-FF-000064', NULL, 'Lysine-specific histone demethylase 1A', 102, NULL, NULL, 221333),
(221334, '1.10.510.10-FF-000654', NULL, 'Protein kinase, putative', 346, NULL, NULL, 221334),
(221335, '1.10.10.790-FF-000024', NULL, 'Protein SWAP', 55, NULL, NULL, 221335),
(221336, '3.30.160.60-FF-005064', NULL, NULL, 71, NULL, NULL, 221336),
(221337, '4.10.60.10-FF-000055', NULL, 'RNA-binding protein lark', 31, NULL, NULL, 221337),
(221338, '1.25.40.10-FF-002764', NULL, 'Uncharacterized protein', 177, NULL, NULL, 221338),
(221339, '3.30.40.10-FF-001898', NULL, 'Uncharacterized protein', 168, NULL, NULL, 221339),
(221340, '1.20.5.110-FF-000129', NULL, 'Hemagglutinin-neuraminidase', 70, NULL, NULL, 221340),
(221341, '3.30.200.20-FF-002504', NULL, 'Predicted protein', 118, NULL, NULL, 221341),
(221342, '3.30.1640.10-FF-000010', NULL, 'DNA helicase', 107, NULL, NULL, 221342),
(221343, '3.10.450.50-FF-000052', NULL, 'Nuclear transport factor 2 (NTF2) domain containing protein, putative', 122, NULL, NULL, 221343),
(221344, '3.40.50.410-FF-000258', NULL, 'Voltage-dependent calcium channel subunit alpha-2/delta-4', 177, NULL, NULL, 221344),
(221345, '1.20.58.60-FF-000082', NULL, 'Short stop, isoform K', 133, NULL, NULL, 221345),
(221346, '3.40.850.10-FF-000221', NULL, 'Kinesin motor protein-like protein', 346, NULL, NULL, 221346),
(221347, '3.10.130.10-FF-000004', NULL, 'Epididymal secretory protein E3-alpha', 111, NULL, NULL, 221347),
(221348, '3.30.160.60-FF-004575', NULL, NULL, 27, NULL, NULL, 221348),
(221349, '3.30.40.10-FF-000280', NULL, 'E3 ubiquitin-protein ligase Hakai', 55, NULL, NULL, 221349),
(221350, '3.40.50.10810-FF-000054', NULL, 'Helicase, Snf2 family', 236, NULL, NULL, 221350),
(221351, '2.70.98.10-FF-000054', NULL, 'Beta-galactosidase', 288, NULL, NULL, 221351),
(221352, '2.30.30.40-FF-000408', NULL, 'Peroxin 13', 88, NULL, NULL, 221352),
(221353, '3.90.70.10-FF-000610', NULL, 'Uncharacterized protein', 170, NULL, NULL, 221353),
(221354, '2.30.29.30-FF-001279', NULL, 'PH domain containing protein', 96, NULL, NULL, 221354),
(221355, '3.90.25.10-FF-000079', NULL, 'dTDP-4-dehydrorhamnose reductase', 70, NULL, NULL, 221355),
(221356, '3.40.50.720-FF-001525', NULL, 'UDP-N-acetylenolpyruvoylglucosamine reductase', 290, NULL, NULL, 221356),
(221357, '3.40.190.10-FF-000434', NULL, 'Peptide/nickel transport system substrate-binding protein', 93, NULL, NULL, 221357),
(221358, '3.30.70.20-FF-000094', NULL, NULL, 72, NULL, NULL, 221358),
(221359, '1.10.287.130-FF-000198', NULL, 'Sensor histidine kinase', 113, NULL, NULL, 221359),
(221360, '3.30.160.60-FF-002219', NULL, 'Kruppel like factor 17', 40, NULL, NULL, 221360),
(221361, '3.40.50.2000-FF-000026', NULL, 'Phosphatidylinositol N-acetylglucosaminyltransferase subunit A', 194, NULL, NULL, 221361),
(221362, '1.25.10.10-FF-002392', NULL, 'Uncharacterized protein', 260, NULL, NULL, 221362),
(221363, '3.40.50.11040-FF-000016', NULL, 'Uncharacterized protein', 189, NULL, NULL, 221363),
(221364, '3.40.20.10-FF-000076', NULL, 'Villin-1', 115, NULL, NULL, 221364),
(221365, '3.40.50.880-FF-000039', NULL, 'Imidazole glycerol phosphate synthase hisHF', 227, NULL, NULL, 221365),
(221366, '1.10.10.10-FF-001475', NULL, 'SPO11 meiotic protein covalently-bound to DSB', 40, NULL, NULL, 221366),
(221367, '2.60.40.60-FF-000638', NULL, 'AGAP002828-PA', 107, NULL, NULL, 221367),
(221368, '2.10.22.10-FF-000005', NULL, NULL, 60, NULL, NULL, 221368);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(221369, '1.10.3210.10-FF-000102', NULL, 'Fusion HD-GYP domain and HD-hydrolase domain', 172, NULL, NULL, 221369),
(221370, '3.60.130.10-FF-000004', NULL, 'Glutarate 2-hydroxylase', 311, NULL, NULL, 221370),
(221371, '2.130.10.10-FF-003726', NULL, 'Coronin', 338, NULL, NULL, 221371),
(221372, '3.90.1110.10-FF-000018', NULL, 'DNA-directed RNA polymerase subunit beta', 163, NULL, NULL, 221372),
(221373, '3.40.50.450-FF-000028', NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase', 201, NULL, NULL, 221373),
(221374, '3.10.50.10-FF-000045', NULL, 'Chitinase Chia_Spl', 76, NULL, NULL, 221374),
(221375, '1.10.10.440-FF-000054', NULL, 'Transcription elongation regulator 1', 58, NULL, NULL, 221375),
(221376, '3.10.260.10-FF-000008', NULL, 'Transcriptional repressor', 87, NULL, NULL, 221376),
(221377, '3.40.50.300-FF-008111', NULL, 'Uncharacterized protein', 274, NULL, NULL, 221377),
(221378, '3.20.20.70-FF-000459', NULL, NULL, 158, NULL, NULL, 221378),
(221379, '3.10.20.30-FF-000083', NULL, NULL, 113, NULL, NULL, 221379),
(221380, '3.50.50.60-FF-001435', NULL, 'Uncharacterized protein', 109, NULL, NULL, 221380),
(221381, '2.60.40.1080-FF-000004', NULL, 'Putative adhesin', 86, NULL, NULL, 221381),
(221382, '2.60.40.10-FF-002804', NULL, 'lymphocyte activation gene 3 protein', 123, NULL, NULL, 221382),
(221383, '1.20.1560.10-FF-000687', NULL, 'Uncharacterized protein', 532, NULL, NULL, 221383),
(221384, '2.130.10.10-FF-004002', NULL, 'Uncharacterized protein', 227, NULL, NULL, 221384),
(221385, '3.40.50.150-FF-001809', NULL, NULL, 112, NULL, NULL, 221385),
(221386, '3.30.160.60-FF-001702', NULL, 'Zinc finger protein 224', 29, NULL, NULL, 221386),
(221387, '3.30.830.10-FF-000036', NULL, 'Putative zinc metalloprotease', 220, NULL, NULL, 221387),
(221388, '3.30.60.30-FF-000169', NULL, 'Agrin', 68, NULL, NULL, 221388),
(221389, '3.30.870.10-FF-000050', NULL, 'Phospholipase', 223, NULL, NULL, 221389),
(221390, '1.25.10.10-FF-002032', NULL, 'Cytoskeleton-associated protein 5', 236, NULL, NULL, 221390),
(221391, '2.10.25.10-FF-001439', NULL, 'Multiple epidermal growth factor-like domains protein 8', 47, NULL, NULL, 221391),
(221392, '1.10.580.10-FF-000017', NULL, 'Citrate synthase', 235, NULL, NULL, 221392),
(221393, '3.30.70.270-FF-000115', NULL, 'Polyprotein of retroviral origin, putative', 90, NULL, NULL, 221393),
(221394, '3.30.710.10-FF-000117', NULL, 'zinc finger and BTB domain-containing protein 4', 170, NULL, NULL, 221394),
(221395, '1.20.120.230-FF-000041', NULL, 'Vinculin', 129, NULL, NULL, 221395),
(221396, '4.10.640.10-FF-000005', NULL, '30S ribosomal protein S18', 75, NULL, NULL, 221396),
(221397, '1.10.1450.10-FF-000052', NULL, 'Tetraspanin', 88, NULL, NULL, 221397),
(221398, '4.10.1100.10-FF-000001', NULL, 'Squamosa promoter-binding-like protein 14', 71, NULL, NULL, 221398),
(221399, '4.10.800.10-FF-000007', NULL, 'Nidogen 2', 69, NULL, NULL, 221399),
(221400, '3.40.50.720-FF-001885', NULL, 'Dihydroflavonol-4-reductase', 189, NULL, NULL, 221400),
(221401, '1.10.287.1770-FF-000005', NULL, 'Ferrous iron transport protein B', 93, NULL, NULL, 221401),
(221402, '3.40.50.2300-FF-001066', NULL, NULL, 86, NULL, NULL, 221402),
(221403, '1.10.287.690-FF-000017', NULL, 'DNA polymerase', 47, NULL, NULL, 221403),
(221404, '3.80.10.10-FF-003917', NULL, 'Leucine-rich repeat protein (LRRP), putative', 106, NULL, NULL, 221404),
(221405, '3.30.160.60-FF-004119', NULL, NULL, 86, NULL, NULL, 221405),
(221406, '2.60.120.260-FF-000450', NULL, 'Uncharacterized protein', 93, NULL, NULL, 221406),
(221407, '1.25.40.20-FF-000064', NULL, 'SH3 and multiple ankyrin repeat domains protein 3', 156, NULL, NULL, 221407),
(221408, '1.25.40.10-FF-004922', NULL, 'Pentatricopeptide repeat-containing protein At2g15630, mitochondrial', 63, NULL, NULL, 221408),
(221409, '1.20.1070.10-FF-001673', NULL, 'Predicted protein', 124, NULL, NULL, 221409),
(221410, '1.20.120.1760-FF-000023', NULL, 'Putative CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', 190, NULL, NULL, 221410),
(221411, '3.40.50.2300-FF-001178', NULL, NULL, 83, NULL, NULL, 221411);
INSERT INTO "PUBLIC"."MODEL" VALUES
(221412, '2.60.40.10-FF-002433', NULL, 'Secreted alpha-amylase', 100, NULL, NULL, 221412),
(221413, '1.10.3260.10-FF-000026', NULL, 'DNA ligase', 239, NULL, NULL, 221413),
(221414, '3.30.70.330-FF-002303', NULL, NULL, 143, NULL, NULL, 221414),
(221415, '1.10.10.60-FF-000944', NULL, NULL, 71, NULL, NULL, 221415),
(221416, '1.20.120.720-FF-000064', NULL, 'Myosin XVB', 144, NULL, NULL, 221416),
(221417, '1.10.287.1010-FF-000002', NULL, 'Uncharacterized protein', 44, NULL, NULL, 221417),
(221418, '2.120.10.90-FF-000007', NULL, 'DNA gyrase subunit A', 333, NULL, NULL, 221418),
(221419, '3.40.50.1820-FF-000073', NULL, 'esterase OVCA2 isoform X6', 223, NULL, NULL, 221419),
(221420, '3.30.420.40-FF-000126', NULL, 'Xylulose kinase', 312, NULL, NULL, 221420),
(221421, '2.120.10.70-FF-000001', NULL, 'Fucose-specific lectin', 311, NULL, NULL, 221421),
(221422, '1.10.287.110-FF-000203', NULL, 'Diphthamide biosynthesis protein 4', 108, NULL, NULL, 221422),
(221423, '2.130.10.110-FF-000013', NULL, 'Clathrin heavy chain 2', 95, NULL, NULL, 221423),
(221424, '3.90.580.10-FF-000003', NULL, 'Zinc finger CHC2-family protein', 87, NULL, NULL, 221424),
(221425, '1.10.510.10-FF-000311', NULL, 'Serine/threonine-protein kinase PLK', 173, NULL, NULL, 221425),
(221426, '3.30.50.10-FF-000106', NULL, 'GATA transcription factor 15', 61, NULL, NULL, 221426),
(221427, '2.30.30.40-FF-000493', NULL, 'Predicted protein', 94, NULL, NULL, 221427),
(221428, '3.10.660.10-FF-000005', NULL, 'DnaJ protein, putative', 51, NULL, NULL, 221428),
(221429, '3.20.20.100-FF-000124', NULL, 'Aldo-keto reductase family 1, member C20', 184, NULL, NULL, 221429),
(221430, '1.10.510.10-FF-002441', NULL, 'Calcium-dependent protein kinase', 273, NULL, NULL, 221430),
(221431, '3.30.450.30-FF-000064', NULL, 'Late endosomal/lysosomal adaptor, MAPK and MTOR activator 2', 52, NULL, NULL, 221431),
(221432, '3.30.70.330-FF-000162', NULL, 'polypyrimidine tract-binding protein 1 isoform X2', 108, NULL, NULL, 221432),
(221433, '3.30.70.1050-FF-000002', NULL, 'Trigger factor', 116, NULL, NULL, 221433),
(221434, '4.10.400.10-FF-000027', NULL, 'Sortilin related receptor 1', 46, NULL, NULL, 221434),
(221435, '2.60.40.10-FF-005659', NULL, NULL, 89, NULL, NULL, 221435),
(221436, '1.20.1250.20-FF-001291', NULL, 'Uncharacterized protein', 189, NULL, NULL, 221436),
(221437, '1.20.58.1040-FF-000007', NULL, 'PLASMODESMATA CALLOSE-BINDING PROTEIN 2', 99, NULL, NULL, 221437),
(221438, '6.10.250.3390-FF-000001', NULL, 'DNA-directed RNA polymerase I subunit RPA14', 79, NULL, NULL, 221438),
(221439, '3.40.50.1240-FF-000219', NULL, NULL, 332, NULL, NULL, 221439),
(221440, '3.40.710.10-FF-000183', NULL, 'Uncharacterized protein', 143, NULL, NULL, 221440),
(221441, '2.60.40.150-FF-000784', NULL, 'Synaptotagmin-15, putative', 94, NULL, NULL, 221441),
(221442, '1.20.1050.10-FF-000137', NULL, 'Glutathione S-transferase', 120, NULL, NULL, 221442),
(221443, '1.10.287.110-FF-000192', NULL, 'Chaperone protein dnaJ 8 chloroplastic', 79, NULL, NULL, 221443),
(221444, '3.10.10.10-FF-000054', NULL, NULL, 50, NULL, NULL, 221444),
(221445, '3.30.70.240-FF-000011', NULL, 'Elongation factor 4', 110, NULL, NULL, 221445),
(221446, '3.30.70.330-FF-002292', NULL, NULL, 92, NULL, NULL, 221446),
(221447, '2.60.40.10-FF-004581', NULL, NULL, 119, NULL, NULL, 221447),
(221448, '3.10.100.10-FF-000424', NULL, NULL, 83, NULL, NULL, 221448),
(221449, '3.40.50.720-FF-001317', NULL, 'Uncharacterized protein', 246, NULL, NULL, 221449),
(221450, '3.30.40.10-FF-001802', NULL, 'Predicted protein', 77, NULL, NULL, 221450),
(221451, '2.60.120.200-FF-000128', NULL, 'enteropeptidase isoform X2', 173, NULL, NULL, 221451),
(221452, '3.40.50.300-FF-007594', NULL, 'GTP-binding protein', 167, NULL, NULL, 221452),
(221453, '3.40.50.300-FF-003895', NULL, 'Lipoprotein-releasing system ATP-binding protein LolD', 239, NULL, NULL, 221453),
(221454, '3.30.200.20-FF-002049', NULL, NULL, 89, NULL, NULL, 221454),
(221455, '3.30.160.60-FF-003389', NULL, 'LOC100006898 protein', 28, NULL, NULL, 221455),
(221456, '1.10.10.60-FF-000517', NULL, 'MYB-related transcription factor', 47, NULL, NULL, 221456);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(221457, '1.10.340.30-FF-000040', NULL, '8-oxoguanine glycosylase', 130, NULL, NULL, 221457),
(221458, '2.10.25.10-FF-000933', NULL, 'LDL receptor protein 1, isoform G', 35, NULL, NULL, 221458),
(221459, '1.10.287.1490-FF-000112', NULL, 'Uncharacterized protein', 149, NULL, NULL, 221459),
(221460, '2.160.20.10-FF-000090', NULL, 'AAA family ATPase', 189, NULL, NULL, 221460),
(221461, '1.10.238.10-FF-000711', NULL, 'Solute carrier family 25 member 24,-like', 75, NULL, NULL, 221461),
(221462, '2.60.40.10-FF-005991', NULL, NULL, 85, NULL, NULL, 221462),
(221463, '2.10.110.10-FF-000237', NULL, 'Uncharacterized protein', 72, NULL, NULL, 221463),
(221464, '1.20.58.1020-FF-000001', NULL, 'DNA replication complex GINS protein PSF2', 118, NULL, NULL, 221464),
(221465, '2.130.10.30-FF-000169', NULL, NULL, 358, NULL, NULL, 221465),
(221466, '1.10.10.10-FF-001587', NULL, 'Uncharacterized protein', 118, NULL, NULL, 221466),
(221467, '2.30.29.30-FF-000531', NULL, 'FERM domain containing 4A', 75, NULL, NULL, 221467),
(221468, '2.130.10.10-FF-000163', NULL, 'ER membrane protein complex subunit 1 isoform X2', 231, NULL, NULL, 221468),
(221469, '2.60.34.10-FF-000042', NULL, 'Putative heat shock protein', 174, NULL, NULL, 221469),
(221470, '1.20.140.10-FF-000117', NULL, 'Uncharacterized protein', 47, NULL, NULL, 221470),
(221471, '3.40.50.10130-FF-000064', NULL, 'Predicted protein', 102, NULL, NULL, 221471),
(221472, '1.20.1280.50-FF-000189', NULL, 'WD40-repeat-containing domain protein', 79, NULL, NULL, 221472),
(221473, '3.40.1360.10-FF-000014', NULL, 'DNA primase', 125, NULL, NULL, 221473),
(221474, '2.130.10.10-FF-003597', NULL, 'WD repeat-containing protein 5', 90, NULL, NULL, 221474),
(221475, '1.10.1000.11-FF-000019', NULL, 'Guanine_nucleotide_exchange_factor_in_Golgi_transport_N-terminal/Sec7_domain_containing_protein_-_putative', 118, NULL, NULL, 221475),
(221476, '2.60.40.790-FF-000184', NULL, NULL, 113, NULL, NULL, 221476),
(221477, '1.10.287.660-FF-000025', NULL, 'Uncharacterized protein', 82, NULL, NULL, 221477),
(221478, '3.40.50.300-FF-000242', NULL, 'Pantothenate kinase', 315, NULL, NULL, 221478),
(221479, '3.80.10.10-FF-001540', NULL, 'AGAP007237-PA', 112, NULL, NULL, 221479),
(221480, '1.20.1070.10-FF-000037', NULL, 'Olfactory receptor', 291, NULL, NULL, 221480),
(221481, '3.30.40.10-FF-001117', NULL, 'Non-SMC element 1, isoform B', 52, NULL, NULL, 221481),
(221482, '2.60.120.10-FF-000148', NULL, 'Protein kinase A regulatory subunit', 141, NULL, NULL, 221482),
(221483, '3.40.50.150-FF-000955', NULL, NULL, 230, NULL, NULL, 221483),
(221484, '3.40.50.300-FF-002703', NULL, 'Predicted protein', 188, NULL, NULL, 221484),
(221485, '1.20.120.980-FF-000012', NULL, 'Serine carboxypeptidase (S28) family protein', 141, NULL, NULL, 221485),
(221486, '2.40.30.10-FF-000180', NULL, 'Mitochondrial ribosomal protein L3', 101, NULL, NULL, 221486),
(221487, '3.10.310.10-FF-000018', NULL, '2-methylaconitate cis-trans isomerase', 187, NULL, NULL, 221487),
(221488, '1.10.472.80-FF-000074', NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', 148, NULL, NULL, 221488),
(221489, '2.130.10.10-FF-000860', NULL, 'Vacuolar protein sorting-associated protein 11 homolog', 285, NULL, NULL, 221489),
(221490, '3.30.200.20-FF-000604', NULL, 'Proline-rich receptor-like protein kinase PERK8', 114, NULL, NULL, 221490),
(221491, '1.10.287.1040-FF-000011', NULL, 'Exodeoxyribonuclease 7 small subunit', 78, NULL, NULL, 221491),
(221492, '1.10.1420.10-FF-000011', NULL, 'DNA mismatch repair protein MSH4', 135, NULL, NULL, 221492),
(221493, '2.60.40.60-FF-000060', NULL, 'Putative cadherin-23', 104, NULL, NULL, 221493),
(221494, '3.30.70.1230-FF-000185', NULL, 'Adenylate/guanylate cyclase domain-containing protein', 168, NULL, NULL, 221494),
(221495, '1.25.40.10-FF-001584', NULL, 'Pentatricopeptide repeat-containing protein At2g18940, chloroplastic', 147, NULL, NULL, 221495),
(221496, '2.70.20.20-FF-000001', NULL, 'Matrix protein VP40', 150, NULL, NULL, 221496),
(221497, '1.10.510.10-FF-001935', NULL, NULL, 60, NULL, NULL, 221497),
(221498, '3.30.420.10-FF-000230', NULL, 'Ribonuclease HIII', 213, NULL, NULL, 221498);
INSERT INTO "PUBLIC"."MODEL" VALUES
(221499, '2.30.29.30-FF-000211', NULL, 'Arf-GAP with GTPase, ANK repeat and PH domain-containing protein 2', 81, NULL, NULL, 221499),
(221500, '3.30.465.10-FF-000114', NULL, 'Uncharacterized protein', 32, NULL, NULL, 221500),
(221501, '2.130.10.10-FF-004114', NULL, 'Predicted protein', 190, NULL, NULL, 221501),
(221502, '2.40.50.100-FF-000045', NULL, 'Glycine cleavage system H protein', 138, NULL, NULL, 221502),
(221503, '2.60.200.20-FF-000202', NULL, 'Predicted protein', 105, NULL, NULL, 221503),
(221504, '3.30.160.60-FF-000308', NULL, 'zinc finger protein 236 isoform X1', 26, NULL, NULL, 221504),
(221505, '1.10.30.10-FF-000077', NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily E member 1-related', 88, NULL, NULL, 221505),
(221506, '2.40.50.90-FF-000160', NULL, 'Staphylococcal-like nuclease CAN1', 74, NULL, NULL, 221506),
(221507, '3.40.190.10-FF-000097', NULL, 'Putative glutamate receptor ionotropic NMDA 3A', 183, NULL, NULL, 221507),
(221508, '3.80.10.10-FF-000236', NULL, 'NLR family CARD domain containing 3', 108, NULL, NULL, 221508),
(221509, '3.40.50.300-FF-002372', NULL, 'Elongation factor G, mitochondrial', 66, NULL, NULL, 221509),
(221510, '3.30.160.60-FF-004007', NULL, NULL, 24, NULL, NULL, 221510),
(221511, '1.10.472.10-FF-000317', NULL, 'Uncharacterized protein', 65, NULL, NULL, 221511),
(221512, '3.30.160.60-FF-000516', NULL, 'zinc finger protein 771', 29, NULL, NULL, 221512),
(221513, '2.60.40.10-FF-001495', NULL, 'Si:dkey-234i14.13', 112, NULL, NULL, 221513),
(221514, '3.40.800.20-FF-000058', NULL, 'Histone deacetylase 19', 138, NULL, NULL, 221514),
(221515, '3.40.50.1010-FF-000055', NULL, 'Exodeoxyribonuclease IX', 174, NULL, NULL, 221515),
(221516, '1.10.510.10-FF-002109', NULL, 'Tyrosine-protein kinase hopscotch', 268, NULL, NULL, 221516),
(221517, '2.60.120.650-FF-000033', NULL, 'Transcription factor jumonji (JmjC) domain-containing protein', 186, NULL, NULL, 221517),
(221518, '2.130.10.10-FF-002080', NULL, 'U3 small nucleolar RNA-associated protein 21', 310, NULL, NULL, 221518),
(221519, '1.20.1310.10-FF-000192', NULL, NULL, 93, NULL, NULL, 221519),
(221520, '2.60.40.10-FF-002225', NULL, 'Gamete expressed 2', 97, NULL, NULL, 221520),
(221521, '2.60.40.10-FF-002113', NULL, 'KETtiN (Drosophila actin-binding) homolog', 102, NULL, NULL, 221521),
(221522, '3.30.565.10-FF-000375', NULL, 'Hybrid sensory kinase', 152, NULL, NULL, 221522),
(221523, '1.10.150.910-FF-000011', NULL, 'WGS project CABT00000000 data, contig 2.21', 91, NULL, NULL, 221523),
(221524, '2.60.40.10-FF-004249', NULL, NULL, 102, NULL, NULL, 221524),
(221525, '1.10.510.10-FF-001031', NULL, 'Serine/threonine-protein kinase Nek7', 185, NULL, NULL, 221525),
(221526, '3.60.20.40-FF-000022', NULL, 'Gamma-glutamyltranspeptidase 1, putative', 205, NULL, NULL, 221526),
(221527, '1.10.10.60-FF-000040', NULL, 'T-cell leukemia homeobox protein 3', 93, NULL, NULL, 221527),
(221528, '2.130.10.10-FF-005851', NULL, 'Uncharacterized protein', 328, NULL, NULL, 221528),
(221529, '2.130.10.10-FF-002658', NULL, 'Uncharacterized protein', 298, NULL, NULL, 221529),
(221530, '3.10.580.10-FF-000049', NULL, 'Nuclear protein SNF4', 140, NULL, NULL, 221530),
(221531, '2.30.30.40-FF-000285', NULL, 'Peptidase M24', 67, NULL, NULL, 221531),
(221532, '3.30.1130.10-FF-000027', NULL, 'Folic acid synthesis protein fol1', 119, NULL, NULL, 221532),
(221533, '2.60.40.60-FF-000413', NULL, 'Desmocollin 2 like', 102, NULL, NULL, 221533),
(221534, '3.40.50.1820-FF-000764', NULL, 'Carboxylic ester hydrolase', 533, NULL, NULL, 221534),
(221535, '3.40.50.300-FF-003209', NULL, 'Zinc finger NFX1-type-containing 1', 259, NULL, NULL, 221535),
(221536, '3.40.190.10-FF-000333', NULL, 'Nickel ABC transporter, periplasmic nickel-binding protein', 281, NULL, NULL, 221536),
(221537, '3.40.50.620-FF-000883', NULL, 'Isoleucyl-tRNA synthetase', 108, NULL, NULL, 221537),
(221538, '1.10.510.10-FF-003638', NULL, NULL, 189, NULL, NULL, 221538),
(221539, '1.20.1250.20-FF-000026', NULL, 'MFS quinate transporter QutD', 466, NULL, NULL, 221539);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(221540, '1.10.510.10-FF-003060', NULL, NULL, 207, NULL, NULL, 221540),
(221541, '3.40.309.10-FF-000126', NULL, 'Uncharacterized protein', 49, NULL, NULL, 221541),
(221542, '3.30.70.330-FF-000263', NULL, 'Splicing factor CC1-like', 101, NULL, NULL, 221542),
(221543, '3.30.420.40-FF-000918', NULL, 'Actin, actin related protein', 15, NULL, NULL, 221543),
(221544, '1.25.40.10-FF-000870', NULL, 'U1 snRNP protein', 182, NULL, NULL, 221544),
(221545, '3.40.50.10810-FF-000184', NULL, 'SWI/SNF family DNA-dependent ATPase, putative', 291, NULL, NULL, 221545),
(221546, '1.20.1280.130-FF-000002', NULL, 'Vacuolar protein sorting-associated protein 54', 95, NULL, NULL, 221546),
(221547, '1.10.287.70-FF-000781', NULL, 'Uncharacterized protein', 91, NULL, NULL, 221547),
(221548, '3.10.129.10-FF-000170', NULL, 'Thioesterase', 163, NULL, NULL, 221548),
(221549, '3.40.50.10380-FF-000009', NULL, 'NAD-dependent malic enzyme', 257, NULL, NULL, 221549),
(221550, '2.60.40.60-FF-000537', NULL, 'Protein CBR-CDH-12', 107, NULL, NULL, 221550),
(221551, '3.40.50.40-FF-000013', NULL, NULL, 126, NULL, NULL, 221551),
(221552, '3.40.50.1000-FF-000164', NULL, 'Heavy metal translocating P-type ATPase', 137, NULL, NULL, 221552),
(221553, '1.10.10.10-FF-000295', NULL, 'E2F transcription factor-like E2FE', 88, NULL, NULL, 221553),
(221554, '3.30.160.60-FF-000421', NULL, 'Sp2 transcription factor', 30, NULL, NULL, 221554),
(221555, '2.60.40.10-FF-003861', NULL, NULL, 105, NULL, NULL, 221555),
(221556, '3.60.60.10-FF-000021', NULL, 'Bile salt hydrolase', 160, NULL, NULL, 221556),
(221557, '3.40.109.10-FF-000021', NULL, 'Nitroreductase family protein', 168, NULL, NULL, 221557),
(221558, '1.10.20.120-FF-000011', NULL, 'Uncharacterized protein', 170, NULL, NULL, 221558),
(221559, '3.90.79.20-FF-000032', NULL, 'Uncharacterized protein', 44, NULL, NULL, 221559),
(221560, '3.40.470.10-FF-000028', NULL, 'Single-strand selective monofunctional uracil DNA glycosylase', 247, NULL, NULL, 221560),
(221561, '3.30.530.20-FF-000005', NULL, 'Type II toxin-antitoxin system toxin RatA', 143, NULL, NULL, 221561),
(221562, '3.40.50.300-FF-001866', NULL, 'Phosphoribulokinase / Uridine kinase family', 181, NULL, NULL, 221562),
(221563, '3.30.160.60-FF-001040', NULL, 'GDNF-inducible zinc finger protein 1 isoform X1', 25, NULL, NULL, 221563),
(221564, '3.90.550.10-FF-000400', NULL, 'Uncharacterized protein', 247, NULL, NULL, 221564),
(221565, '2.60.40.10-FF-000876', NULL, 'Uncharacterized protein, isoform H', 93, NULL, NULL, 221565),
(221566, '4.10.640.40-FF-000003', NULL, 'Cytoplasmic polyadenylation element-binding protein 2', 59, NULL, NULL, 221566),
(221567, '3.90.70.10-FF-000285', NULL, 'Ubiquitin carboxyl-terminal hydrolase 14', 493, NULL, NULL, 221567),
(221568, '3.40.50.300-FF-004845', NULL, 'DNA repair and recombination protein RadA', 256, NULL, NULL, 221568),
(221569, '1.25.40.20-FF-000417', NULL, 'Diego, isoform A', 51, NULL, NULL, 221569),
(221570, '3.40.50.150-FF-000371', NULL, 'Methyltransferase OMS1, mitochondrial', 197, NULL, NULL, 221570),
(221571, '3.90.79.10-FF-000124', NULL, 'mRNA decapping protein, putative', 134, NULL, NULL, 221571),
(221572, '3.30.420.510-FF-000003', NULL, 'Pantothenate kinase 2', 161, NULL, NULL, 221572),
(221573, '2.130.10.10-FF-000051', NULL, '6-phosphogluconolactonase', 331, NULL, NULL, 221573),
(221574, '3.30.40.10-FF-001926', NULL, 'Uncharacterized protein', 70, NULL, NULL, 221574),
(221575, '1.10.238.10-FF-000503', NULL, 'Calmodulin-like protein 5', 87, NULL, NULL, 221575),
(221576, '2.130.10.10-FF-001585', NULL, 'Protein CBG00600', 349, NULL, NULL, 221576),
(221577, '1.20.1070.10-FF-001768', NULL, '5-hydroxytryptamine receptor 2B', 60, NULL, NULL, 221577),
(221578, '2.10.25.10-FF-001208', NULL, 'Fibropellin-1', 35, NULL, NULL, 221578),
(221579, '1.10.510.10-FF-004257', NULL, NULL, 190, NULL, NULL, 221579),
(221580, '3.40.50.300-FF-008431', NULL, 'Uncharacterized protein', 90, NULL, NULL, 221580),
(221581, '3.40.47.10-FF-000210', NULL, NULL, 181, NULL, NULL, 221581),
(221582, '3.30.160.60-FF-002664', NULL, 'Si:ch73-138e16.6', 28, NULL, NULL, 221582);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(221583, '1.20.80.10-FF-000023', NULL, 'FERM domain containing 8', 135, NULL, NULL, 221583),
(221584, '3.30.450.40-FF-000162', NULL, 'Diguanylate cyclase/phosphodiesterase (GGDEF & EAL domains) with PAS/PAC sensor(S)', 199, NULL, NULL, 221584),
(221585, '3.90.226.10-FF-000006', NULL, 'ATP-dependent Clp protease proteolytic subunit', 190, NULL, NULL, 221585),
(221586, '3.40.1110.10-FF-000193', NULL, 'Calcium-transporting ATPase', 225, NULL, NULL, 221586),
(221587, '2.60.40.2160-FF-000002', NULL, 'Interleukin 17 receptor B', 166, NULL, NULL, 221587),
(221588, '2.20.160.10-FF-000002', NULL, 'Titin-cap (telethonin)', 84, NULL, NULL, 221588),
(221589, '2.40.70.10-FF-000093', NULL, 'Plasmepsin 5', 150, NULL, NULL, 221589),
(221590, '3.30.160.60-FF-006036', NULL, NULL, 23, NULL, NULL, 221590),
(221591, '3.40.30.10-FF-000475', NULL, 'Cell wall organization protein/glutathione transferase (Gto3), putative', 160, NULL, NULL, 221591),
(221592, '3.40.50.10900-FF-000008', NULL, 'Proteasome assembly chaperone 2', 199, NULL, NULL, 221592),
(221593, '2.60.120.10-FF-000047', NULL, 'Auxin-binding protein ABP19a', 192, NULL, NULL, 221593),
(221594, '1.25.40.20-FF-000968', NULL, 'SBF complex DNA-binding subunit', 264, NULL, NULL, 221594),
(221595, '3.30.430.20-FF-000060', NULL, 'Cysteine-rich receptor-like protein kinase 21', 106, NULL, NULL, 221595),
(221596, '3.40.1050.10-FF-000024', NULL, 'Carbonic anhydrase, beta-family, clade B', 200, NULL, NULL, 221596),
(221597, '6.20.200.30-FF-000002', NULL, 'GM24381', 39, NULL, NULL, 221597),
(221598, '2.60.120.1540-FF-000024', NULL, 'Murinoglobulin-2', 32, NULL, NULL, 221598),
(221599, '2.40.10.10-FF-000538', NULL, NULL, 93, NULL, NULL, 221599),
(221600, '3.30.565.10-FF-000487', NULL, 'Uncharacterized protein', 170, NULL, NULL, 221600),
(221601, '3.50.50.60-FF-000160', NULL, 'Glutamate synthase (NADPH)', 49, NULL, NULL, 221601),
(221602, '1.50.40.10-FF-000126', NULL, 'Transporter, putative', 237, NULL, NULL, 221602),
(221603, '3.30.70.330-FF-001100', NULL, 'RNA-binding protein, putative', 143, NULL, NULL, 221603),
(221604, '3.60.110.10-FF-000104', NULL, NULL, 273, NULL, NULL, 221604),
(221605, '3.40.50.150-FF-000157', NULL, 'Ribosomal RNA small subunit methyltransferase A', 191, NULL, NULL, 221605),
(221606, '3.10.110.10-FF-000352', NULL, 'Uncharacterized protein', 88, NULL, NULL, 221606),
(221607, '2.30.29.30-FF-001150', NULL, 'Uncharacterized protein', 111, NULL, NULL, 221607),
(221608, '3.30.465.10-FF-000002', NULL, 'HlyC/CorC family transporter', 81, NULL, NULL, 221608),
(221609, '3.40.390.10-FF-000314', NULL, NULL, 199, NULL, NULL, 221609),
(221610, '2.102.10.10-FF-000007', NULL, 'Cytochrome b6-f complex iron-sulfur subunit', 135, NULL, NULL, 221610),
(221611, '3.30.900.10-FF-000059', NULL, 'Uncharacterized protein', 282, NULL, NULL, 221611),
(221612, '3.40.50.300-FF-004721', NULL, 'Signal recognition particle 54 kDa protein putative', 151, NULL, NULL, 221612),
(221613, '3.60.21.10-FF-000335', NULL, 'Serine/threonine-protein phosphatase', 270, NULL, NULL, 221613),
(221614, '3.30.230.70-FF-000065', NULL, 'Uncharacterized protein', 221, NULL, NULL, 221614),
(221615, '3.40.1410.10-FF-000007', NULL, 'GntR family transcriptional regulator', 157, NULL, NULL, 221615),
(221616, '3.80.10.10-FF-000028', NULL, 'leucine-rich repeat-containing G-protein coupled receptor 4 isoform X1', 452, NULL, NULL, 221616),
(221617, '1.20.20.10-FF-000031', NULL, 'Uncharacterized protein', 74, NULL, NULL, 221617),
(221618, '3.40.1380.10-FF-000009', NULL, 'ATP synthase F1 subunit gamma protein', 215, NULL, NULL, 221618),
(221619, '1.10.3720.10-FF-000192', NULL, 'ABC transporter permease protein', 214, NULL, NULL, 221619),
(221620, '1.20.144.10-FF-000002', NULL, 'phospholipid phosphatase-related protein type 5', 233, NULL, NULL, 221620),
(221621, '2.10.50.10-FF-000126', NULL, 'Uncharacterized protein', 55, NULL, NULL, 221621),
(221622, '3.40.1810.10-FF-000004', NULL, 'MADS-box transcription factor 1', 72, NULL, NULL, 221622),
(221623, '1.20.58.2220-FF-000030', NULL, 'Formin 1', 82, NULL, NULL, 221623);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(221624, '3.40.50.1440-FF-000066', NULL, 'Tubulin A', 38, NULL, NULL, 221624),
(221625, '2.120.10.80-FF-000358', NULL, 'Protein kinase, putative', 273, NULL, NULL, 221625),
(221626, '3.30.420.210-FF-000003', NULL, 'UBX domain protein 11', 60, NULL, NULL, 221626),
(221627, '2.60.40.60-FF-000621', NULL, 'Uncharacterized protein', 95, NULL, NULL, 221627),
(221628, '3.30.70.1450-FF-000015', NULL, 'Trk system potassium uptake protein TrkA', 82, NULL, NULL, 221628),
(221629, '2.70.150.10-FF-000159', NULL, 'Phospholipid-transporting ATPase IA, putative', 119, NULL, NULL, 221629),
(221630, '1.10.437.10-FF-000056', NULL, 'Uncharacterized protein', 75, NULL, NULL, 221630),
(221631, '2.160.20.10-FF-000213', NULL, 'Uncharacterized protein', 330, NULL, NULL, 221631),
(221632, '3.40.50.300-FF-008566', NULL, 'Uncharacterized protein', 176, NULL, NULL, 221632),
(221633, '1.25.40.20-FF-001036', NULL, 'Ankyrin repeat family protein', 127, NULL, NULL, 221633),
(221634, '3.40.640.10-FF-000519', NULL, 'Uncharacterized protein', 144, NULL, NULL, 221634),
(221635, '3.30.1240.10-FF-000030', NULL, 'Cof family protein', 122, NULL, NULL, 221635),
(221636, '2.40.50.140-FF-001226', NULL, NULL, 58, NULL, NULL, 221636),
(221637, '1.10.8.10-FF-000327', NULL, 'Ubiquitin specific protease, putative', 48, NULL, NULL, 221637),
(221638, '2.40.50.100-FF-000169', NULL, 'YALI0E33121p', 66, NULL, NULL, 221638),
(221639, '1.10.510.10-FF-000423', NULL, 'Putative receptor-like serine/threonine-protein kinase', 213, NULL, NULL, 221639),
(221640, '2.130.10.10-FF-003142', NULL, 'Coatomer subunit alpha', 349, NULL, NULL, 221640),
(221641, '1.10.510.10-FF-003846', NULL, NULL, 105, NULL, NULL, 221641),
(221642, '1.25.40.10-FF-000527', NULL, 'Pentatricopeptide repeat-containing protein At5g04780, mitochondrial', 134, NULL, NULL, 221642),
(221643, '1.20.1250.20-FF-000234', NULL, 'Solute carrier family 2 member 10', 135, NULL, NULL, 221643),
(221644, '1.25.40.10-FF-004810', NULL, 'Uncharacterized protein', 159, NULL, NULL, 221644),
(221645, '3.40.50.620-FF-000675', NULL, 'Uncharacterized protein', 261, NULL, NULL, 221645),
(221646, '3.40.50.2000-FF-001083', NULL, 'Uncharacterized protein', 124, NULL, NULL, 221646),
(221647, '3.40.1180.10-FF-000028', NULL, 'Undecaprenyl pyrophosphate synthetase family protein', 132, NULL, NULL, 221647),
(221648, '3.20.20.100-FF-000012', NULL, 'Glutamate--cysteine ligase regulatory subunit', 197, NULL, NULL, 221648),
(221649, '3.20.20.140-FF-000451', NULL, 'AMP deaminase', 398, NULL, NULL, 221649),
(221650, '3.40.50.300-FF-005576', NULL, 'Regulator of telomere elongation helicase 1', 134, NULL, NULL, 221650),
(221651, '1.10.287.70-FF-000573', NULL, 'Uncharacterized protein', 137, NULL, NULL, 221651),
(221652, '3.30.160.60-FF-000972', NULL, 'Zinc finger protein 768', 26, NULL, NULL, 221652),
(221653, '3.10.350.10-FF-000015', NULL, 'LysM peptidoglycan-binding domain-containing protein', 59, NULL, NULL, 221653),
(221654, '2.30.30.40-FF-000616', NULL, 'Uncharacterized protein', 51, NULL, NULL, 221654),
(221655, '1.10.510.10-FF-002565', NULL, 'Protein kinase, putative', 261, NULL, NULL, 221655),
(221656, '1.10.246.90-FF-000012', NULL, 'Nucleolar protein NOP5', 110, NULL, NULL, 221656),
(221657, '3.30.9.10-FF-000207', NULL, 'D-amino acid oxidase, putative', 184, NULL, NULL, 221657),
(221658, '1.25.10.10-FF-000244', NULL, 'Nonsense-mediated mRNA decay protein', 1012, NULL, NULL, 221658),
(221659, '2.60.40.790-FF-000060', NULL, 'Nuclear movement protein, putative', 127, NULL, NULL, 221659),
(221660, '1.10.238.10-FF-000048', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 91, NULL, NULL, 221660),
(221661, '1.10.274.30-FF-000037', NULL, 'Uncharacterized protein', 149, NULL, NULL, 221661),
(221662, '2.10.25.10-FF-000725', NULL, 'Uncharacterized protein, isoform B', 38, NULL, NULL, 221662),
(221663, '3.30.70.1740-FF-000001', NULL, 'BofC domain protein', 77, NULL, NULL, 221663),
(221664, '3.10.180.10-FF-000075', NULL, 'Uncharacterized protein', 129, NULL, NULL, 221664),
(221665, '3.40.50.1010-FF-000156', NULL, 'RNA-binding protein NOB1', 130, NULL, NULL, 221665);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(221666, '1.10.150.50-FF-000216', NULL, 'Predicted protein', 97, NULL, NULL, 221666),
(221667, '3.30.160.60-FF-004900', NULL, NULL, 34, NULL, NULL, 221667),
(221668, '3.30.1310.10-FF-000013', NULL, 'Nucleoid-associated protein CO678_37690', 104, NULL, NULL, 221668),
(221669, '3.30.200.20-FF-000138', NULL, 'Phosphorylase b kinase gamma catalytic chain, liver/testis', 104, NULL, NULL, 221669),
(221670, '1.20.1250.20-FF-001662', NULL, 'MFS multidrug transporter, putative (AFU_orthologue AFUA_6G07320)', 230, NULL, NULL, 221670),
(221671, '3.40.50.300-FF-006537', NULL, 'Uncharacterized protein', 108, NULL, NULL, 221671),
(221672, '2.60.40.150-FF-000003', NULL, 'Regulating synaptic membrane exocytosis protein 2', 129, NULL, NULL, 221672),
(221673, '3.40.50.300-FF-005817', NULL, 'Pyridoxal phosphate-dependent transferase', 242, NULL, NULL, 221673),
(221674, '1.10.238.10-FF-000493', NULL, 'Signal transducer and activator of transcription', 123, NULL, NULL, 221674),
(221675, '2.130.10.10-FF-004570', NULL, 'Uncharacterized protein', 211, NULL, NULL, 221675),
(221676, '3.80.10.10-FF-000130', NULL, 'extracellular matrix protein 2 isoform X1', 220, NULL, NULL, 221676),
(221677, '3.80.10.10-FF-001208', NULL, 'U2 small nuclear ribonucleoprotein A', 170, NULL, NULL, 221677),
(221678, '1.10.167.10-FF-000063', NULL, 'Regulator of G-protein signaling 1', 142, NULL, NULL, 221678),
(221679, '1.10.8.10-FF-000086', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 72, NULL, NULL, 221679),
(221680, '3.40.47.10-FF-000126', NULL, 'Protein CBG20965', 236, NULL, NULL, 221680),
(221681, '3.40.1230.10-FF-000010', NULL, 'Uncharacterized protein', 118, NULL, NULL, 221681),
(221682, '1.25.40.20-FF-000625', NULL, 'Uncharacterized protein', 92, NULL, NULL, 221682),
(221683, '1.25.10.10-FF-001868', NULL, 'ARM repeat superfamily protein', 159, NULL, NULL, 221683),
(221684, '2.60.40.10-FF-005204', NULL, NULL, 116, NULL, NULL, 221684),
(221685, '3.30.1370.10-FF-000034', NULL, 'synaptic functional regulator FMR1 isoform X2', 58, NULL, NULL, 221685),
(221686, '3.30.565.10-FF-000386', NULL, 'DNA mismatch repair protein domain', 221, NULL, NULL, 221686),
(221687, '3.40.50.720-FF-000800', NULL, 'NmrA like redox sensor 1', 104, NULL, NULL, 221687),
(221688, '2.60.40.640-FF-000043', NULL, 'pH-response regulator protein palF/RIM8', 151, NULL, NULL, 221688),
(221689, '1.10.510.10-FF-004465', NULL, NULL, 278, NULL, NULL, 221689),
(221690, '3.40.50.2300-FF-000902', NULL, NULL, 132, NULL, NULL, 221690),
(221691, '1.10.150.20-FF-000320', NULL, 'DNA polymerase IV', 51, NULL, NULL, 221691),
(221692, '3.40.50.200-FF-000190', NULL, 'Predicted protein', 241, NULL, NULL, 221692),
(221693, '1.25.40.10-FF-002556', NULL, 'Kinetoplast_polyadenylation/uridylation_factor_1', 148, NULL, NULL, 221693),
(221694, '2.130.10.10-FF-004103', NULL, 'Uncharacterized protein', 194, NULL, NULL, 221694),
(221695, '3.40.50.300-FF-008223', NULL, 'Uncharacterized protein', 65, NULL, NULL, 221695),
(221696, '3.40.50.300-FF-004637', NULL, 'DNA helicase', 224, NULL, NULL, 221696),
(221697, '3.30.200.20-FF-001548', NULL, 'Uncharacterized protein', 105, NULL, NULL, 221697),
(221698, '2.130.10.10-FF-003277', NULL, 'DIGIT', 156, NULL, NULL, 221698),
(221699, '1.25.10.10-FF-002144', NULL, 'Uncharacterized protein', 546, NULL, NULL, 221699),
(221700, '1.25.40.10-FF-003618', NULL, 'Pentatricopeptide repeat-containing protein At1g74600, chloroplastic', 107, NULL, NULL, 221700),
(221701, '2.130.10.10-FF-002866', NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One component system)', 264, NULL, NULL, 221701),
(221702, '3.40.30.10-FF-001094', NULL, 'Uncharacterized protein', 82, NULL, NULL, 221702),
(221703, '3.10.450.10-FF-000068', NULL, 'Uncharacterized protein', 98, NULL, NULL, 221703),
(221704, '1.20.1560.10-FF-000575', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 626, NULL, NULL, 221704),
(221705, '4.10.1060.10-FF-000065', NULL, 'Predicted protein', 37, NULL, NULL, 221705),
(221706, '2.60.40.10-FF-004687', NULL, NULL, 112, NULL, NULL, 221706);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(221707, '1.20.1070.10-FF-000588', NULL, 'Go opsin', 328, NULL, NULL, 221707),
(221708, '2.130.10.10-FF-002428', NULL, 'AGAP010693-PA', 244, NULL, NULL, 221708),
(221709, '2.60.120.200-FF-000022', NULL, 'receptor-type tyrosine-protein phosphatase U isoform X2', 163, NULL, NULL, 221709),
(221710, '3.40.50.720-FF-001773', NULL, '2-dehydropantoate 2-reductase family protein, putative', 197, NULL, NULL, 221710),
(221711, '1.20.1280.290-FF-000022', NULL, 'Cystinosin homolog', 113, NULL, NULL, 221711),
(221712, '2.170.270.10-FF-000228', NULL, 'Uncharacterized protein', 92, NULL, NULL, 221712),
(221713, '1.20.58.390-FF-000055', NULL, 'Ligand-Gated ion Channel', 164, NULL, NULL, 221713),
(221714, '3.90.176.10-FF-000013', NULL, 'NAD(P)(+)--arginine ADP-ribosyltransferase', 205, NULL, NULL, 221714),
(221715, '3.40.1350.150-FF-000002', NULL, 'tRNA-splicing endonuclease', 150, NULL, NULL, 221715),
(221716, '3.40.50.300-FF-007947', NULL, 'Uncharacterized protein', 170, NULL, NULL, 221716),
(221717, '1.10.3710.10-FF-000016', NULL, 'Uncharacterized protein', 69, NULL, NULL, 221717),
(221718, '3.10.290.10-FF-000066', NULL, 'Pseudouridine synthase', 65, NULL, NULL, 221718),
(221719, '3.30.70.270-FF-000216', NULL, NULL, 103, NULL, NULL, 221719),
(221720, '3.40.30.10-FF-000683', NULL, 'Glutathione S-transferase zeta 1', 36, NULL, NULL, 221720),
(221721, '3.80.10.10-FF-003805', NULL, 'Predicted protein', 87, NULL, NULL, 221721),
(221722, '2.60.120.260-FF-000562', NULL, 'Uncharacterized protein', 45, NULL, NULL, 221722),
(221723, '3.80.10.10-FF-001664', NULL, 'Secreted protein, putative', 151, NULL, NULL, 221723),
(221724, '2.130.10.10-FF-000404', NULL, 'Mitochondrial division protein 1', 237, NULL, NULL, 221724),
(221725, '2.130.10.10-FF-000528', NULL, 'POC1 centriolar protein homolog B', 142, NULL, NULL, 221725),
(221726, '2.40.340.10-FF-000012', NULL, 'Molybdopterin molybdenumtransferase', 88, NULL, NULL, 221726),
(221727, '2.10.70.10-FF-000234', NULL, 'Uncharacterized protein', 63, NULL, NULL, 221727),
(221728, '3.30.420.40-FF-000334', NULL, 'Unplaced genomic scaffold supercont1.162, whole genome shotgun sequence', 42, NULL, NULL, 221728),
(221729, '1.25.40.10-FF-002213', NULL, 'AGAP011462-PA', 147, NULL, NULL, 221729),
(221730, '2.60.120.200-FF-000460', NULL, 'Uncharacterized protein', 210, NULL, NULL, 221730),
(221731, '3.30.60.20-FF-000048', NULL, 'Thymidine kinase', 44, NULL, NULL, 221731),
(221732, '3.40.309.10-FF-000020', NULL, 'Ethanolamine utilization aldehyde dehydrogenase', 187, NULL, NULL, 221732),
(221733, '3.90.1410.10-FF-000035', NULL, 'Uncharacterized protein', 271, NULL, NULL, 221733),
(221734, '3.40.50.300-FF-000585', NULL, 'Structural maintenance of chromosomes 4', 210, NULL, NULL, 221734),
(221735, '3.20.20.70-FF-000010', NULL, '2-isopropylmalate synthase', 279, NULL, NULL, 221735),
(221736, '2.60.120.10-FF-000709', NULL, 'Sensor histidine kinase', 93, NULL, NULL, 221736),
(221737, '2.40.170.20-FF-000086', NULL, 'Transporter, outer membrane receptor (OMR) family', 720, NULL, NULL, 221737),
(221738, '1.25.10.10-FF-002487', NULL, 'Uncharacterized protein', 209, NULL, NULL, 221738),
(221739, '1.10.238.10-FF-000150', NULL, 'Sodium channel protein', 121, NULL, NULL, 221739),
(221740, '1.25.40.10-FF-001937', NULL, 'TPR-containing protein DDB_G0280363', 130, NULL, NULL, 221740),
(221741, '1.20.1050.80-FF-000017', NULL, 'Vacuolar sorting protein 9 (VPS9) domain containing protein, putative', 172, NULL, NULL, 221741),
(221742, '3.90.79.10-FF-000259', NULL, 'Predicted protein', 133, NULL, NULL, 221742),
(221743, '2.30.30.490-FF-000059', NULL, 'AGAP001099-PA', 194, NULL, NULL, 221743),
(221744, '1.25.40.10-FF-001595', NULL, 'Pentatricopeptide repeat-containing protein 2, mitochondrial', 273, NULL, NULL, 221744),
(221745, '1.20.1110.10-FF-000204', NULL, NULL, 95, NULL, NULL, 221745),
(221746, '1.25.40.10-FF-004113', NULL, 'Predicted protein', 136, NULL, NULL, 221746),
(221747, '3.30.70.1020-FF-000004', NULL, 'Trehalose 6-phosphate phosphatase', 77, NULL, NULL, 221747),
(221748, '3.40.630.10-FF-000238', NULL, 'Cytosolic carboxypeptidase-like protein 5', 202, NULL, NULL, 221748);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(221749, '3.40.1110.10-FF-000434', NULL, NULL, 73, NULL, NULL, 221749),
(221750, '1.20.950.20-FF-000013', NULL, 'Thioredoxin reductase', 181, NULL, NULL, 221750),
(221751, '1.25.10.10-FF-000587', NULL, 'Kap120p', 1019, NULL, NULL, 221751),
(221752, '2.40.10.10-FF-000313', NULL, 'Serine protease easter-like Protein', 237, NULL, NULL, 221752),
(221753, '3.30.1490.200-FF-000001', NULL, 'Lipoprotein antigen Tp47', 77, NULL, NULL, 221753),
(221754, '2.40.10.10-FF-000437', NULL, NULL, 129, NULL, NULL, 221754),
(221755, '3.90.550.10-FF-000164', NULL, 'Beta-(1-3)-glucosyl transferase', 222, NULL, NULL, 221755),
(221756, '3.30.200.20-FF-002280', NULL, 'Non-specific serine/threonine protein kinase', 50, NULL, NULL, 221756),
(221757, '3.10.530.10-FF-000001', NULL, NULL, 66, NULL, NULL, 221757),
(221758, '2.170.120.20-FF-000018', NULL, '50S ribosomal protein L25', 92, NULL, NULL, 221758),
(221759, '3.40.30.10-FF-000245', NULL, 'Thioredoxin', 111, NULL, NULL, 221759),
(221760, '3.10.490.10-FF-000042', NULL, 'Gamma-L-glutamyl-butirosin B gamma-glutamyl cyclotransferase', 121, NULL, NULL, 221760),
(221761, '1.10.150.20-FF-000218', NULL, 'Uncharacterized protein', 45, NULL, NULL, 221761),
(221762, '1.20.58.60-FF-000183', NULL, 'dystrophin isoform X2', 107, NULL, NULL, 221762),
(221763, '1.20.1250.20-FF-001083', NULL, 'Protein CBG14518', 435, NULL, NULL, 221763),
(221764, '3.30.360.10-FF-000062', NULL, 'Uncharacterized oxidoreductase yrbe-like', 129, NULL, NULL, 221764),
(221765, '1.10.510.10-FF-000412', NULL, 'Probable receptor-like serine/threonine-protein kinase At5g57670', 206, NULL, NULL, 221765),
(221766, '1.20.58.60-FF-000306', NULL, 'Uncharacterized protein, isoform F', 203, NULL, NULL, 221766),
(221767, '1.10.287.370-FF-000039', NULL, 'Probable prefoldin subunit 5', 141, NULL, NULL, 221767),
(221768, '2.60.40.10-FF-000770', NULL, 'titin isoform X1', 90, NULL, NULL, 221768),
(221769, '3.30.1330.30-FF-000127', NULL, 'Ribosomal protein L7Ae, putative', 125, NULL, NULL, 221769),
(221770, '3.30.230.120-FF-000023', NULL, NULL, 150, NULL, NULL, 221770),
(221771, '3.30.70.1170-FF-000021', NULL, 'Uncharacterized protein', 32, NULL, NULL, 221771),
(221772, '1.20.1300.10-FF-000016', NULL, 'Succinate dehydrogenase membrane anchor subunit', 124, NULL, NULL, 221772),
(221773, '3.40.120.10-FF-000031', NULL, 'Phosphoglucomutase-like 5', 119, NULL, NULL, 221773),
(221774, '3.50.50.60-FF-000266', NULL, 'Baeyer-Villiger monooxygenase', 186, NULL, NULL, 221774),
(221775, '2.60.40.60-FF-000290', NULL, 'Dachsous, isoform B', 111, NULL, NULL, 221775),
(221776, '2.10.90.10-FF-000123', NULL, 'Interleukin 17 isoform A', 120, NULL, NULL, 221776),
(221777, '3.40.630.10-FF-000114', NULL, 'Nicalin', 285, NULL, NULL, 221777),
(221778, '2.60.40.2440-FF-000007', NULL, 'Glc7p regulatory subunit', 146, NULL, NULL, 221778),
(221779, '2.60.40.10-FF-001596', NULL, 'vesicle-associated protein 4-1-like', 130, NULL, NULL, 221779),
(221780, '3.30.420.210-FF-000014', NULL, 'Ubxn-2', 62, NULL, NULL, 221780),
(221781, '2.60.120.290-FF-000003', NULL, 'Neuropilin', 116, NULL, NULL, 221781),
(221782, '2.120.10.90-FF-000018', NULL, 'DNA topoisomerase IV subunit A', 212, NULL, NULL, 221782),
(221783, '3.30.70.330-FF-001786', NULL, NULL, 58, NULL, NULL, 221783),
(221784, '3.30.200.20-FF-000368', NULL, 'Interleukin-1 receptor-associated kinase 4', 105, NULL, NULL, 221784),
(221785, '3.30.160.740-FF-000001', NULL, 'Isopropylmalate/homocitrate/citramalate synthase', 58, NULL, NULL, 221785),
(221786, '3.40.140.10-FF-000274', NULL, 'Uncharacterized protein', 80, NULL, NULL, 221786),
(221787, '1.10.630.10-FF-000022', NULL, 'Taxadiene 5-alpha hydroxylase', 452, NULL, NULL, 221787),
(221788, '1.10.8.60-FF-000426', NULL, 'Replication factor C small subunit', 65, NULL, NULL, 221788),
(221789, '2.40.160.50-FF-000021', NULL, 'Outer membrane protein assembly factor BamA', 376, NULL, NULL, 221789),
(221790, '1.20.1720.10-FF-000110', NULL, NULL, 132, NULL, NULL, 221790),
(221791, '2.40.30.130-FF-000056', NULL, 'Alanine--tRNA ligase, mitochondrial', 91, NULL, NULL, 221791);
INSERT INTO "PUBLIC"."MODEL" VALUES
(221792, '3.40.640.10-FF-000396', NULL, 'Uncharacterized protein', 70, NULL, NULL, 221792),
(221793, '3.40.390.10-FF-000073', NULL, 'Zinc metalloproteinase', 242, NULL, NULL, 221793),
(221794, '3.40.50.300-FF-007251', NULL, 'Uncharacterized protein', 283, NULL, NULL, 221794),
(221795, '3.40.50.150-FF-000051', NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', 334, NULL, NULL, 221795),
(221796, '3.30.450.40-FF-000308', NULL, 'Phosphodiesterase', 121, NULL, NULL, 221796),
(221797, '3.40.30.10-FF-000806', NULL, 'Uncharacterized protein', 79, NULL, NULL, 221797),
(221798, '3.30.497.10-FF-000109', NULL, 'Serpin peptidase inhibitor, clade B (ovalbumin), member 1', 131, NULL, NULL, 221798),
(221799, '3.30.160.60-FF-000185', NULL, 'zinc finger protein 319', 28, NULL, NULL, 221799),
(221800, '3.30.1490.220-FF-000007', NULL, 'Inositol-tetrakisphosphate 1-kinase', 98, NULL, NULL, 221800),
(221801, '2.110.10.10-FF-000001', NULL, 'Matrix metallopeptidase 24', 195, NULL, NULL, 221801),
(221802, '3.10.310.50-FF-000002', NULL, 'TLP18.3, Psb32 and MOLO-1 founding proteins of phosphatase, putative', 136, NULL, NULL, 221802),
(221803, '2.80.10.50-FF-000059', NULL, 'Probable alpha-L-arabinofuranosidase B', 161, NULL, NULL, 221803),
(221804, '3.30.500.10-FF-000051', NULL, NULL, 78, NULL, NULL, 221804),
(221805, '2.70.70.10-FF-000046', NULL, 'Peptidase, M23 family', 146, NULL, NULL, 221805),
(221806, '1.20.1070.10-FF-000245', NULL, 'Alpha-2C adrenergic receptor', 258, NULL, NULL, 221806),
(221807, '3.30.420.40-FF-000677', NULL, 'Uncharacterized protein', 214, NULL, NULL, 221807),
(221808, '1.10.555.10-FF-000173', NULL, NULL, 186, NULL, NULL, 221808),
(221809, '3.30.70.20-FF-000009', NULL, 'Formate dehydrogenase iron-sulfur subunit', 89, NULL, NULL, 221809),
(221810, '1.25.40.10-FF-004237', NULL, 'Uncharacterized protein', 388, NULL, NULL, 221810),
(221811, '3.30.450.20-FF-000302', NULL, 'Sensory transduction histidine kinase', 103, NULL, NULL, 221811),
(221812, '3.30.559.30-FF-000080', NULL, 'Nonribosomal peptide synthase inpB', 223, NULL, NULL, 221812),
(221813, '3.20.20.70-FF-000673', NULL, 'Uncharacterized protein', 375, NULL, NULL, 221813),
(221814, '3.20.140.10-FF-000020', NULL, 'Nicotinate phosphoribosyltransferase', 291, NULL, NULL, 221814),
(221815, '3.30.160.60-FF-001944', NULL, 'Zinc finger protein 571', 28, NULL, NULL, 221815),
(221816, '3.30.1390.20-FF-000021', NULL, 'Uncharacterized protein', 70, NULL, NULL, 221816),
(221817, '1.10.510.10-FF-004122', NULL, NULL, 99, NULL, NULL, 221817),
(221818, '3.90.230.10-FF-000016', NULL, 'Putative curved dna-binding protein', 292, NULL, NULL, 221818),
(221819, '3.40.50.150-FF-000612', NULL, 'Protein-lysine methyltransferase METTL21B', 239, NULL, NULL, 221819),
(221820, '3.30.470.30-FF-000059', NULL, 'mRNA-capping enzyme subunit alpha, putative', 232, NULL, NULL, 221820),
(221821, '3.30.1330.120-FF-000004', NULL, '2-methylcitrate dehydratase 2', 139, NULL, NULL, 221821),
(221822, '2.40.33.10-FF-000006', NULL, 'Pyruvate kinase', 103, NULL, NULL, 221822),
(221823, '3.40.50.12650-FF-000044', NULL, 'Chromosome 1, whole genome shotgun sequence', 93, NULL, NULL, 221823),
(221824, '3.40.50.300-FF-002580', NULL, 'AGAP002836-PB', 159, NULL, NULL, 221824),
(221825, '3.40.50.2300-FF-000239', NULL, 'Trehalose operon repressor', 117, NULL, NULL, 221825),
(221826, '1.20.1560.10-FF-000232', NULL, 'Multidrug ABC transporter ATP-binding protein', 323, NULL, NULL, 221826),
(221827, '1.20.120.30-FF-000004', NULL, 'Diguanylate cyclase YdeH', 130, NULL, NULL, 221827),
(221828, '3.90.640.10-FF-000278', NULL, 'Predicted protein', 65, NULL, NULL, 221828),
(221829, '2.70.130.10-FF-000040', NULL, 'Endoplasmic reticulum lectin 1-like isoform 2', 71, NULL, NULL, 221829),
(221830, '2.40.180.10-FF-000010', NULL, 'lipoxygenase homology domain-containing protein 1', 130, NULL, NULL, 221830),
(221831, '2.40.70.10-FF-000542', NULL, NULL, 187, NULL, NULL, 221831),
(221832, '2.70.170.10-FF-000042', NULL, 'Blast:Glycine receptor subunit alpha-3', 230, NULL, NULL, 221832),
(221833, '3.40.140.10-FF-000251', NULL, 'Predicted protein', 144, NULL, NULL, 221833);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(221834, '2.60.40.10-FF-000533', NULL, 'Uncharacterized protein, isoform A', 90, NULL, NULL, 221834),
(221835, '4.10.1240.10-FF-000039', NULL, 'Corticotropin-releasing hormone receptor 2', 29, NULL, NULL, 221835),
(221836, '1.20.5.340-FF-000075', NULL, 'Chromosome undetermined SCAF14470, whole genome shotgun sequence', 76, NULL, NULL, 221836),
(221837, '3.65.10.10-FF-000002', NULL, 'UDP-N-acetylglucosamine 1-carboxyvinyltransferase', 199, NULL, NULL, 221837),
(221838, '4.10.1240.10-FF-000051', NULL, 'Glucagon receptor a', 91, NULL, NULL, 221838),
(221839, '3.40.50.300-FF-008454', NULL, 'Uncharacterized protein', 53, NULL, NULL, 221839),
(221840, '3.40.50.300-FF-004165', NULL, 'Rho-related BTB domain-containing protein 1', 204, NULL, NULL, 221840),
(221841, '2.60.120.920-FF-000018', NULL, 'SPRY domain-containing SOCS box protein 3 isoform X2', 162, NULL, NULL, 221841),
(221842, '3.40.50.170-FF-000034', NULL, 'Phosphoribosylglycinamide transformylase, putative', 254, NULL, NULL, 221842),
(221843, '3.40.50.11720-FF-000001', NULL, '3-deoxy-D-manno-octulosonic acid transferase', 177, NULL, NULL, 221843),
(221844, '3.50.50.60-FF-000822', NULL, 'FAD-dependent pyridine nucleotide-disulfide oxidoreductase family protein', 129, NULL, NULL, 221844),
(221845, '1.10.8.720-FF-000011', NULL, 'Dynein beta chain, putative', 167, NULL, NULL, 221845),
(221846, '3.40.640.10-FF-000295', NULL, 'Aspartate aminotransferase', 114, NULL, NULL, 221846),
(221847, '2.20.70.10-FF-000020', NULL, 'WW domain-containing adapter protein with coiled-coil isoform X1', 70, NULL, NULL, 221847),
(221848, '3.30.160.60-FF-001596', NULL, 'Zinc finger protein 1048', 32, NULL, NULL, 221848),
(221849, '1.25.10.10-FF-002509', NULL, 'Predicted protein', 199, NULL, NULL, 221849),
(221850, '3.40.50.1000-FF-000720', NULL, NULL, 94, NULL, NULL, 221850),
(221851, '3.40.50.300-FF-007942', NULL, 'Putative SNF2/RAD54 related DNA helicase', 171, NULL, NULL, 221851),
(221852, '2.30.30.140-FF-000319', NULL, 'Uncharacterized protein', 117, NULL, NULL, 221852),
(221853, '3.90.70.10-FF-000841', NULL, 'Chromosome 1, whole genome shotgun sequence', 129, NULL, NULL, 221853),
(221854, '3.40.50.620-FF-000888', NULL, 'Uncharacterized protein', 99, NULL, NULL, 221854),
(221855, '3.30.200.20-FF-001779', NULL, 'Non-specific serine/threonine protein kinase', 113, NULL, NULL, 221855),
(221856, '3.40.850.10-FF-000013', NULL, 'unconventional myosin-IXa isoform X1', 205, NULL, NULL, 221856),
(221857, '2.20.100.10-FF-000122', NULL, 'SCO-spondin', 54, NULL, NULL, 221857),
(221858, '3.90.1150.10-FF-000009', NULL, 'Succinylornithine transaminase', 130, NULL, NULL, 221858),
(221859, '3.10.390.10-FF-000006', NULL, 'Autoimmune regulator', 74, NULL, NULL, 221859),
(221860, '2.40.50.140-FF-000260', NULL, 'Uncharacterized protein, isoform A', 73, NULL, NULL, 221860),
(221861, '3.40.830.10-FF-000006', NULL, '3,4-dihydroxyphenylacetate 2,3-dioxygenase', 281, NULL, NULL, 221861),
(221862, '2.60.40.1180-FF-000028', NULL, 'Alpha-galactosidase', 93, NULL, NULL, 221862),
(221863, '1.10.10.10-FF-000750', NULL, 'Protein CBG08819', 111, NULL, NULL, 221863),
(221864, '2.130.10.10-FF-002653', NULL, 'Predicted protein', 323, NULL, NULL, 221864),
(221865, '3.60.15.10-FF-000052', NULL, 'tRNAse Z TRZ4, mitochondrial', 271, NULL, NULL, 221865),
(221866, '1.25.40.1030-FF-000016', NULL, 'WD domain containing protein', 377, NULL, NULL, 221866),
(221867, '3.20.20.80-FF-000575', NULL, 'Beta-galactosidase, putative', 114, NULL, NULL, 221867),
(221868, '2.30.30.940-FF-000014', NULL, 'Uncharacterized protein', 78, NULL, NULL, 221868),
(221869, '1.20.1310.20-FF-000060', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 192, NULL, NULL, 221869),
(221870, '3.40.30.60-FF-000001', NULL, 'Flagellar biosynthesis protein FlhA', 144, NULL, NULL, 221870),
(221871, '3.40.50.1000-FF-000619', NULL, NULL, 89, NULL, NULL, 221871),
(221872, '2.40.50.140-FF-000153', NULL, 'Elongation factor P', 62, NULL, NULL, 221872),
(221873, '3.90.1170.10-FF-000016', NULL, '50S ribosomal protein L16', 138, NULL, NULL, 221873),
(221874, '3.40.50.10190-FF-000166', NULL, 'PAX transcription activation domain interacting protein', 86, NULL, NULL, 221874); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(221875, '3.30.420.40-FF-000913', NULL, 'Uncharacterized protein', 44, NULL, NULL, 221875),
(221876, '1.50.10.10-FF-000175', NULL, 'Uncharacterized protein', 403, NULL, NULL, 221876),
(221877, '2.60.40.420-FF-000101', NULL, 'Multicopper oxidase, putative', 135, NULL, NULL, 221877),
(221878, '3.30.230.10-FF-000081', NULL, 'Ribosome biogenesis protein Ria1, putative', 183, NULL, NULL, 221878),
(221879, '1.10.1200.10-FF-000028', NULL, 'Nonribosomal peptide synthetase 13', 73, NULL, NULL, 221879),
(221880, '3.80.10.10-FF-003333', NULL, 'Uncharacterized protein', 123, NULL, NULL, 221880),
(221881, '2.60.40.10-FF-000539', NULL, 'striated muscle preferentially expressed protein kinase', 99, NULL, NULL, 221881),
(221882, '1.20.1250.40-FF-000009', NULL, 'Dna-directed rna polymerase ii subunit rpb4-like', 146, NULL, NULL, 221882),
(221883, '3.30.200.20-FF-000582', NULL, 'Os04g0370900 protein', 94, NULL, NULL, 221883),
(221884, '3.30.530.20-FF-000117', NULL, 'Predicted protein', 156, NULL, NULL, 221884),
(221885, '1.25.40.20-FF-000412', NULL, 'Ankyrin repeat-containing protein ITN1 isoform C', 173, NULL, NULL, 221885),
(221886, '3.30.160.60-FF-004344', NULL, NULL, 47, NULL, NULL, 221886),
(221887, '2.130.10.10-FF-002760', NULL, 'Uncharacterized protein', 253, NULL, NULL, 221887),
(221888, '3.80.10.10-FF-000478', NULL, 'Leucine-rich repeat protein', 155, NULL, NULL, 221888),
(221889, '2.60.40.10-FF-000640', NULL, 'semaphorin-7A isoform X2', 85, NULL, NULL, 221889),
(221890, '2.60.40.1180-FF-000040', NULL, 'Maltodextrin glucosidase', 78, NULL, NULL, 221890),
(221891, '1.20.1740.10-FF-000229', NULL, 'Gll1652 protein', 431, NULL, NULL, 221891),
(221892, '3.30.460.20-FF-000011', NULL, 'Manganese resistance', 141, NULL, NULL, 221892),
(221893, '3.30.70.330-FF-000830', NULL, 'Uncharacterized protein, isoform B', 107, NULL, NULL, 221893),
(221894, '1.10.533.10-FF-000004', NULL, 'Death effector domain-containing protein-like', 91, NULL, NULL, 221894),
(221895, '1.25.40.20-FF-000305', NULL, 'Death associated protein kinase 1', 71, NULL, NULL, 221895),
(221896, '1.20.1270.10-FF-000013', NULL, 'Hypoxia up-regulated protein 1', 111, NULL, NULL, 221896),
(221897, '3.40.50.10470-FF-000036', NULL, 'Translation initiation factor eIF-2B alpha subunit', 209, NULL, NULL, 221897),
(221898, '1.25.10.10-FF-000800', NULL, 'Disheveled-associated activator of morphogenesis', 306, NULL, NULL, 221898),
(221899, '3.80.10.10-FF-003226', NULL, 'Uncharacterized protein', 201, NULL, NULL, 221899),
(221900, '3.40.720.10-FF-000352', NULL, 'Uncharacterized protein', 146, NULL, NULL, 221900),
(221901, '2.130.10.10-FF-006020', NULL, 'Uncharacterized protein', 144, NULL, NULL, 221901),
(221902, '2.80.10.50-FF-000065', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 124, NULL, NULL, 221902),
(221903, '3.40.30.10-FF-000470', NULL, 'NADH-quinone oxidoreductase subunit F', 75, NULL, NULL, 221903),
(221904, '3.40.50.150-FF-000713', NULL, 'Bactin polyketide/non-ribosomal peptide synthetase', 333, NULL, NULL, 221904),
(221905, '1.10.287.70-FF-000786', NULL, 'Uncharacterized protein', 50, NULL, NULL, 221905),
(221906, '1.10.630.10-FF-000814', NULL, 'Uncharacterized protein', 280, NULL, NULL, 221906),
(221907, '3.50.50.60-FF-001441', NULL, 'Predicted protein', 100, NULL, NULL, 221907),
(221908, '3.30.9.10-FF-000090', NULL, 'Pyruvate Dehydrogenase Phosphatase Regulatory subunit', 165, NULL, NULL, 221908),
(221909, '2.40.160.50-FF-000009', NULL, 'Putative hemolysin activator protein', 378, NULL, NULL, 221909),
(221910, '3.50.50.60-FF-001334', NULL, 'Protein CBG18666', 63, NULL, NULL, 221910),
(221911, '1.10.10.60-FF-000169', NULL, 'DNA-binding protein SATB1', 69, NULL, NULL, 221911),
(221912, '1.25.40.20-FF-001828', NULL, 'Poly [ADP-ribose] polymerase tankyrase', 150, NULL, NULL, 221912),
(221913, '3.10.20.770-FF-000001', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit gamma isoform', 296, NULL, NULL, 221913),
(221914, '2.60.120.920-FF-000125', NULL, 'Zn-finger in Ran binding protein and others/SPRY domain/HECT-domain (Ubiquitin-transferase), putative', 140, NULL, NULL, 221914);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(221915, '3.40.50.300-FF-000910', NULL, 'probable ATP-dependent DNA helicase DDX11', 64, NULL, NULL, 221915),
(221916, '1.25.40.10-FF-001932', NULL, 'Tetratricopeptide repeat domain 17', 140, NULL, NULL, 221916),
(221917, '1.10.132.60-FF-000037', NULL, 'DNA polymerase', 183, NULL, NULL, 221917),
(221918, '3.30.160.60-FF-006379', NULL, NULL, 29, NULL, NULL, 221918),
(221919, '1.10.510.10-FF-004234', NULL, NULL, 203, NULL, NULL, 221919),
(221920, '1.25.40.1010-FF-000010', NULL, 'Peptide alpha-N-acetyltransferase complex A subunit', 218, NULL, NULL, 221920),
(221921, '3.30.160.60-FF-000977', NULL, 'Zinc finger protein 641', 31, NULL, NULL, 221921),
(221922, '1.20.990.10-FF-000018', NULL, 'Sulfite reductase [NADPH] flavoprotein alpha-component', 105, NULL, NULL, 221922),
(221923, '1.10.630.10-FF-000707', NULL, 'Uncharacterized protein', 119, NULL, NULL, 221923),
(221924, '3.40.1110.10-FF-000198', NULL, 'Phospholipid-transporting ATPase', 142, NULL, NULL, 221924),
(221925, '2.60.120.260-FF-000242', NULL, 'Alpha-L-arabinofuranosidase 1', 108, NULL, NULL, 221925),
(221926, '1.10.287.70-FF-000679', NULL, 'Uncharacterized protein', 93, NULL, NULL, 221926),
(221927, '1.10.10.60-FF-000276', NULL, 'Transcriptional regulator, AraC family', 110, NULL, NULL, 221927),
(221928, '3.50.50.60-FF-001227', NULL, 'Flavin-containing monooxygenase', 237, NULL, NULL, 221928),
(221929, '2.60.40.150-FF-000109', NULL, 'BAI1-associated protein 3 isoform X1', 141, NULL, NULL, 221929),
(221930, '2.30.180.10-FF-000187', NULL, NULL, 126, NULL, NULL, 221930),
(221931, '3.30.1330.30-FF-000133', NULL, 'Uncharacterized protein', 101, NULL, NULL, 221931),
(221932, '2.130.10.10-FF-001708', NULL, 'WD repeat-containing protein 35', 181, NULL, NULL, 221932),
(221933, '2.60.120.10-FF-000603', NULL, 'Pirin', 22, NULL, NULL, 221933),
(221934, '3.90.70.10-FF-000604', NULL, 'Predicted protein', 183, NULL, NULL, 221934),
(221935, '1.10.150.240-FF-000018', NULL, 'Hydrolase, haloacid dehalogenase-like family', 64, NULL, NULL, 221935),
(221936, '3.10.170.20-FF-000015', NULL, NULL, 96, NULL, NULL, 221936),
(221937, '3.90.79.10-FF-000147', NULL, 'Adenine DNA glycosylase', 125, NULL, NULL, 221937),
(221938, '3.40.50.1100-FF-000076', NULL, 'Threonine dehydratase', 98, NULL, NULL, 221938),
(221939, '1.25.40.70-FF-000062', NULL, 'Uncharacterized protein', 162, NULL, NULL, 221939),
(221940, '1.20.5.420-FF-000003', NULL, 'Immunoglobulin G-binding protein A', 58, NULL, NULL, 221940),
(221941, '3.30.200.20-FF-000475', NULL, 'Serine/threonine-protein kinase', 110, NULL, NULL, 221941),
(221942, '3.40.30.10-FF-000829', NULL, '2-hydroxychromene-2-carboxylate isomerase', 201, NULL, NULL, 221942),
(221943, '1.20.1540.10-FF-000118', NULL, 'Peptidase, S54 (rhomboid) family protein', 194, NULL, NULL, 221943),
(221944, '3.40.50.2300-FF-000234', NULL, 'Guanylate cyclase', 112, NULL, NULL, 221944),
(221945, '3.30.160.60-FF-000292', NULL, 'zinc finger protein 619', 28, NULL, NULL, 221945),
(221946, '3.10.250.10-FF-000064', NULL, NULL, 41, NULL, NULL, 221946),
(221947, '3.30.200.20-FF-000363', NULL, 'Serine/threonine-protein kinase', 94, NULL, NULL, 221947),
(221948, '2.30.30.40-FF-000509', NULL, 'Tyrosine-protein kinase', 52, NULL, NULL, 221948),
(221949, '3.30.70.330-FF-000611', NULL, 'serine/arginine-rich splicing factor RSZ22A isoform X1', 73, NULL, NULL, 221949),
(221950, '1.10.150.220-FF-000012', NULL, NULL, 58, NULL, NULL, 221950),
(221951, '1.10.510.10-FF-004127', NULL, NULL, 93, NULL, NULL, 221951),
(221952, '1.25.40.250-FF-000010', NULL, 'Eukaryotic translation initiation factor 3 subunit K', 92, NULL, NULL, 221952),
(221953, '3.90.190.20-FF-000072', NULL, 'Folylpolyglutamate synthase, mitochondrial-like Protein', 158, NULL, NULL, 221953),
(221954, '1.20.1560.10-FF-000676', NULL, 'Uncharacterized protein', 23, NULL, NULL, 221954),
(221955, '3.40.33.10-FF-000167', NULL, 'Predicted extracellular protein', 105, NULL, NULL, 221955),
(221956, '2.40.10.10-FF-000196', NULL, 'Putative low-density lipoprotein receptor', 132, NULL, NULL, 221956),
(221957, '3.40.1670.10-FF-000009', NULL, 'Uncharacterized protein', 96, NULL, NULL, 221957);
INSERT INTO "PUBLIC"."MODEL" VALUES
(221958, '3.40.50.150-FF-001332', NULL, NULL, 200, NULL, NULL, 221958),
(221959, '3.80.10.10-FF-003440', NULL, 'Uncharacterized protein', 58, NULL, NULL, 221959),
(221960, '2.40.10.10-FF-000201', NULL, 'RT07795p', 126, NULL, NULL, 221960),
(221961, '3.30.2350.10-FF-000033', NULL, 'Pseudouridine synthase', 214, NULL, NULL, 221961),
(221962, '1.10.400.10-FF-000078', NULL, 'Predicted protein', 115, NULL, NULL, 221962),
(221963, '2.40.10.10-FF-000190', NULL, 'Coagulation factor II (Thrombin)', 107, NULL, NULL, 221963),
(221964, '3.40.140.100-FF-000005', NULL, 'GM19894', 130, NULL, NULL, 221964),
(221965, '2.10.25.10-FF-000938', NULL, 'NIDogen (Basement membrane protein)', 50, NULL, NULL, 221965),
(221966, '3.30.559.10-FF-000001', NULL, 'Carnitine O-acetyltransferase', 265, NULL, NULL, 221966),
(221967, '2.130.10.10-FF-004558', NULL, 'Eukaryotic translation initiation factor 2A', 216, NULL, NULL, 221967),
(221968, '3.90.470.10-FF-000006', NULL, '50S ribosomal protein L22, chloroplastic', 140, NULL, NULL, 221968),
(221969, '3.60.40.10-FF-000357', NULL, 'Uncharacterized protein', 298, NULL, NULL, 221969),
(221970, '3.40.50.1780-FF-000021', NULL, 'Cytosolic Fe-S cluster assembly factor NAR1 homolog', 36, NULL, NULL, 221970),
(221971, '1.10.510.10-FF-002784', NULL, NULL, 204, NULL, NULL, 221971),
(221972, '3.10.20.10-FF-000004', NULL, 'cell death activator CIDE-3 isoform X1', 124, NULL, NULL, 221972),
(221973, '2.30.110.10-FF-000025', NULL, 'Puatative oxidoreductase', 228, NULL, NULL, 221973),
(221974, '1.10.8.270-FF-000050', NULL, 'TBC1 domain family protein 5', 101, NULL, NULL, 221974),
(221975, '2.60.40.10-FF-001837', NULL, 'Roughest, isoform B', 98, NULL, NULL, 221975),
(221976, '1.20.1250.20-FF-000695', NULL, 'Predicted protein', 365, NULL, NULL, 221976),
(221977, '1.10.287.110-FF-000208', NULL, 'DNAJ family-like protein', 112, NULL, NULL, 221977),
(221978, '2.60.120.10-FF-000592', NULL, 'Uncharacterized protein', 121, NULL, NULL, 221978),
(221979, '1.25.10.10-FF-002723', NULL, 'Uncharacterized protein', 934, NULL, NULL, 221979),
(221980, '2.20.25.10-FF-000056', NULL, 'Multifunctional methyltransferase subunit TRM112-like protein', 125, NULL, NULL, 221980),
(221981, '4.10.410.10-FF-000067', NULL, 'GM18125', 73, NULL, NULL, 221981),
(221982, '3.30.390.60-FF-000005', NULL, 'Heat-inducible transcription repressor HrcA', 101, NULL, NULL, 221982),
(221983, '3.30.160.60-FF-001489', NULL, 'Zinc finger protein interacting with ribonucleoprotein K', 26, NULL, NULL, 221983),
(221984, '1.10.1420.10-FF-000016', NULL, 'mutS protein homolog 4', 98, NULL, NULL, 221984),
(221985, '2.40.50.150-FF-000026', NULL, 'DNA-directed RNA polymerase subunit beta', 141, NULL, NULL, 221985),
(221986, '1.10.10.10-FF-000519', NULL, 'RNA polymerase sigma factor sigA', 80, NULL, NULL, 221986),
(221987, '3.40.50.10190-FF-000059', NULL, 'ATBRCA1', 97, NULL, NULL, 221987),
(221988, '3.40.50.80-FF-000121', NULL, 'Uncharacterized protein', 187, NULL, NULL, 221988),
(221989, '3.40.930.10-FF-000047', NULL, NULL, 231, NULL, NULL, 221989),
(221990, '3.30.420.10-FF-000466', NULL, NULL, 211, NULL, NULL, 221990),
(221991, '3.10.170.20-FF-000010', NULL, 'Uncharacterized protein', 145, NULL, NULL, 221991),
(221992, '1.10.12.10-FF-000001', NULL, 'Probable enoyl-CoA hydratase, mitochondrial', 60, NULL, NULL, 221992),
(221993, '3.90.1150.10-FF-000110', NULL, 'Acetylornithine aminotransferase', 107, NULL, NULL, 221993),
(221994, '3.40.850.10-FF-000120', NULL, 'Kinesin family protein', 163, NULL, NULL, 221994),
(221995, '2.60.40.10-FF-001152', NULL, 'Sallimus, isoform P', 102, NULL, NULL, 221995),
(221996, '3.40.50.1000-FF-000850', NULL, NULL, 59, NULL, NULL, 221996),
(221997, '3.30.710.10-FF-000011', NULL, 'Kelch-like family member 13', 161, NULL, NULL, 221997),
(221998, '3.20.20.10-FF-000026', NULL, 'D-threonine aldolase', 225, NULL, NULL, 221998),
(221999, '3.80.10.10-FF-002951', NULL, 'Uncharacterized protein', 228, NULL, NULL, 221999),
(222000, '1.25.40.10-FF-002444', NULL, 'Pentatricopeptide repeat-containing protein At5g65570', 99, NULL, NULL, 222000);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(222001, '1.10.20.10-FF-000008', NULL, 'Histone H2A', 131, NULL, NULL, 222001),
(222002, '2.60.40.60-FF-000189', NULL, 'FAT atypical cadherin 4', 103, NULL, NULL, 222002),
(222003, '3.40.50.300-FF-006531', NULL, 'GTP-binding nuclear protein Ran', 109, NULL, NULL, 222003),
(222004, '1.20.1250.20-FF-002145', NULL, 'Uncharacterized protein', 199, NULL, NULL, 222004),
(222005, '2.40.50.100-FF-000040', NULL, 'Efflux transporter periplasmic adaptor subunit', 69, NULL, NULL, 222005),
(222006, '3.50.50.60-FF-000715', NULL, 'Uncharacterized protein', 65, NULL, NULL, 222006),
(222007, '3.40.50.150-FF-000843', NULL, NULL, 181, NULL, NULL, 222007),
(222008, '2.30.30.280-FF-000007', NULL, 'Uncharacterized protein', 33, NULL, NULL, 222008),
(222009, '2.170.120.30-FF-000004', NULL, 'YbbR-like lipoprotein, putative', 107, NULL, NULL, 222009),
(222010, '3.40.50.720-FF-000244', NULL, 'quinone oxidoreductase', 168, NULL, NULL, 222010),
(222011, '3.10.450.10-FF-000045', NULL, 'Cysteine proteinase inhibitor', 96, NULL, NULL, 222011),
(222012, '2.160.10.10-FF-000021', NULL, 'dynactin subunit 6', 190, NULL, NULL, 222012),
(222013, '2.60.40.4370-FF-000013', NULL, NULL, 125, NULL, NULL, 222013),
(222014, '3.20.20.70-FF-000353', NULL, 'tRNA-dihydrouridine(20) synthase [NAD(P)+]-like', 108, NULL, NULL, 222014),
(222015, '1.10.357.30-FF-000016', NULL, NULL, 88, NULL, NULL, 222015),
(222016, '3.40.50.300-FF-002726', NULL, 'Cytosolic Fe-S cluster assembly factor NUBP1 homolog', 267, NULL, NULL, 222016),
(222017, '3.40.50.1700-FF-000054', NULL, 'Thermostable beta-glucosidase B', 89, NULL, NULL, 222017),
(222018, '2.60.120.620-FF-000142', NULL, 'Uncharacterized protein', 177, NULL, NULL, 222018),
(222019, '1.20.920.10-FF-000177', NULL, 'Uncharacterized protein', 152, NULL, NULL, 222019),
(222020, '1.10.472.10-FF-000070', NULL, 'CYCLIN D32', 90, NULL, NULL, 222020),
(222021, '2.70.150.10-FF-000035', NULL, 'Cation-transporting ATPase', 150, NULL, NULL, 222021),
(222022, '1.25.10.10-FF-001767', NULL, 'Importin-9', 926, NULL, NULL, 222022),
(222023, '2.30.30.30-FF-000040', NULL, 'Organellar elongation factor P', 69, NULL, NULL, 222023),
(222024, '1.10.287.980-FF-000003', NULL, 'ATP synthase subunit c, chloroplastic', 40, NULL, NULL, 222024),
(222025, '3.80.20.20-FF-000077', NULL, 'Predicted protein', 138, NULL, NULL, 222025),
(222026, '3.30.930.10-FF-000336', NULL, 'Uncharacterized protein', 110, NULL, NULL, 222026),
(222027, '1.25.10.10-FF-001312', NULL, 'HEAT_repeat_-_putative', 530, NULL, NULL, 222027),
(222028, '2.120.10.30-FF-000602', NULL, 'Subfamily S9C unassigned peptidase', 204, NULL, NULL, 222028),
(222029, '1.25.40.90-FF-000045', NULL, 'Ent5p', 170, NULL, NULL, 222029),
(222030, '3.30.160.60-FF-005755', NULL, NULL, 21, NULL, NULL, 222030),
(222031, '1.20.1250.20-FF-001763', NULL, 'Resistance protein, conjectural', 190, NULL, NULL, 222031),
(222032, '1.10.8.60-FF-000185', NULL, 'CBN-MAC-1 protein', 119, NULL, NULL, 222032),
(222033, '3.40.50.300-FF-008324', NULL, 'Uncharacterized protein', 245, NULL, NULL, 222033),
(222034, '3.20.140.10-FF-000025', NULL, 'Nicotinate phosphoribosyltransferase', 304, NULL, NULL, 222034),
(222035, '1.10.150.20-FF-000213', NULL, 'DNA repair protein', 80, NULL, NULL, 222035),
(222036, '3.30.70.1470-FF-000009', NULL, 'Uncharacterized protein', 116, NULL, NULL, 222036),
(222037, '3.30.70.3290-FF-000005', NULL, 'Phenolpthiocerol synthesis type-I polyketide synthase PPSE', 133, NULL, NULL, 222037),
(222038, '2.120.10.80-FF-000122', NULL, 'tRNA wybutosine-synthesizing protein 2/3/4', 151, NULL, NULL, 222038),
(222039, '3.80.10.10-FF-001309', NULL, 'Leucine-rich repeat family protein', 74, NULL, NULL, 222039),
(222040, '1.10.510.10-FF-000075', NULL, 'Serine/threonine-protein kinase 3', 278, NULL, NULL, 222040),
(222041, '3.40.50.300-FF-005918', NULL, 'YALI0A19580p', 200, NULL, NULL, 222041),
(222042, '1.20.5.1160-FF-000026', NULL, 'Protein CBR-IFB-2, isoform a', 94, NULL, NULL, 222042),
(222043, '1.10.287.110-FF-000315', NULL, 'Chaperone protein DNAj, putative', 110, NULL, NULL, 222043),
(222044, '3.30.160.60-FF-006031', NULL, NULL, 25, NULL, NULL, 222044);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(222045, '3.30.70.1170-FF-000026', NULL, 'Uncharacterized protein', 82, NULL, NULL, 222045),
(222046, '1.25.40.180-FF-000197', NULL, NULL, 191, NULL, NULL, 222046),
(222047, '3.30.70.920-FF-000001', NULL, 'Transcriptional regulator, AsnC family', 85, NULL, NULL, 222047),
(222048, '1.20.1090.10-FF-000027', NULL, 'Iron-containing alcohol dehydrogenase', 202, NULL, NULL, 222048),
(222049, '3.30.1600.10-FF-000013', NULL, 'NAD-dependent protein deacetylase sirtuin-1', 114, NULL, NULL, 222049),
(222050, '3.40.718.10-FF-000060', NULL, 'Uncharacterized protein', 254, NULL, NULL, 222050),
(222051, '3.40.50.720-FF-000351', NULL, 'Short chain dehydrogenase', 258, NULL, NULL, 222051),
(222052, '3.90.950.10-FF-000032', NULL, 'Maf-like protein', 127, NULL, NULL, 222052),
(222053, '1.20.58.1190-FF-000001', NULL, 'Toxin B', 86, NULL, NULL, 222053),
(222054, '1.10.10.10-FF-001132', NULL, 'Histone acetyltransferase', 81, NULL, NULL, 222054),
(222055, '3.40.50.300-FF-004053', NULL, 'Dicer-like 3', 208, NULL, NULL, 222055),
(222056, '3.30.70.330-FF-002409', NULL, NULL, 93, NULL, NULL, 222056),
(222057, '3.40.50.300-FF-000017', NULL, 'Disks large homolog 3 isoform 1', 121, NULL, NULL, 222057),
(222058, '2.120.10.30-FF-000591', NULL, 'Uncharacterized protein', 113, NULL, NULL, 222058),
(222059, '3.30.310.130-FF-000027', NULL, 'DDE superfamily endonuclease', 116, NULL, NULL, 222059),
(222060, '2.60.40.200-FF-000041', NULL, 'Uncharacterized protein', 71, NULL, NULL, 222060),
(222061, '3.30.70.940-FF-000007', NULL, 'Transcription elongation factor SPT5', 104, NULL, NULL, 222061),
(222062, '2.130.10.10-FF-002765', NULL, 'Uncharacterized protein', 240, NULL, NULL, 222062),
(222063, '3.80.10.10-FF-003221', NULL, 'Uncharacterized protein', 203, NULL, NULL, 222063),
(222064, '2.40.290.10-FF-000024', NULL, 'ATP-dependent DNA helicase II subunit 2', 207, NULL, NULL, 222064),
(222065, '3.40.50.620-FF-000669', NULL, 'Valine--tRNA ligase mitochondrial 1', 56, NULL, NULL, 222065),
(222066, '3.40.50.620-FF-000433', NULL, 'Electron transfer flavoprotein subunit beta', 263, NULL, NULL, 222066),
(222067, '2.10.70.10-FF-000009', NULL, 'Seizure related 6 homolog like', 62, NULL, NULL, 222067),
(222068, '3.10.310.20-FF-000004', NULL, 'PPX1p Exopolyphosphatase', 147, NULL, NULL, 222068),
(222069, '3.40.50.1820-FF-001484', NULL, 'Abhydrolase domain-containing 5b', 167, NULL, NULL, 222069),
(222070, '3.40.630.10-FF-000007', NULL, 'Carboxypeptidase X (M14 family), member 1', 330, NULL, NULL, 222070),
(222071, '3.40.50.620-FF-000776', NULL, 'Uncharacterized protein', 101, NULL, NULL, 222071),
(222072, '3.30.70.330-FF-003028', NULL, NULL, 56, NULL, NULL, 222072),
(222073, '3.30.460.20-FF-000016', NULL, 'Magnesium transport protein CorA', 126, NULL, NULL, 222073),
(222074, '1.25.40.10-FF-002899', NULL, 'Signal recognition particle subunit SRP72', 340, NULL, NULL, 222074),
(222075, '1.10.357.10-FF-000010', NULL, 'HTH-type transcriptional regulator RutR', 143, NULL, NULL, 222075),
(222076, '3.90.1290.10-FF-000047', NULL, 'Uncharacterized protein', 124, NULL, NULL, 222076),
(222077, '2.40.50.740-FF-000001', NULL, '40S ribosomal protein S4', 51, NULL, NULL, 222077),
(222078, '1.20.120.350-FF-000048', NULL, 'Potassium voltage-gated channel modifier subfamily G member 3', 162, NULL, NULL, 222078),
(222079, '3.40.50.300-FF-003783', NULL, 'Transitional endoplasmic reticulum ATPase TER94-like Protein', 169, NULL, NULL, 222079),
(222080, '3.40.50.10810-FF-000189', NULL, 'SNF2 superfamily protein', 246, NULL, NULL, 222080),
(222081, '1.25.40.20-FF-000524', NULL, 'Ankyrin repeat domain 6b', 70, NULL, NULL, 222081),
(222082, '2.60.120.10-FF-000608', NULL, 'Mannose-6-phosphate isomerase', 178, NULL, NULL, 222082),
(222083, '3.30.460.10-FF-000120', NULL, 'DNA nucleotidylexotransferase', 140, NULL, NULL, 222083),
(222084, '1.10.8.60-FF-000533', NULL, 'Uncharacterized protein', 64, NULL, NULL, 222084),
(222085, '3.30.70.330-FF-002180', NULL, NULL, 78, NULL, NULL, 222085),
(222086, '3.30.565.10-FF-000150', NULL, 'Putative heat shock protein HSP 90-beta 2', 42, NULL, NULL, 222086);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(222087, '2.40.50.140-FF-000372', NULL, 'Replication factor A protein 3, putative', 107, NULL, NULL, 222087),
(222088, '3.90.1150.10-FF-000228', NULL, 'Aminotransferase', 133, NULL, NULL, 222088),
(222089, '3.40.630.30-FF-000351', NULL, 'RNA cytidine acetyltransferase', 63, NULL, NULL, 222089),
(222090, '3.30.70.330-FF-002516', NULL, NULL, 64, NULL, NULL, 222090),
(222091, '2.130.10.10-FF-005856', NULL, 'Uncharacterized protein', 321, NULL, NULL, 222091),
(222092, '3.30.60.190-FF-000022', NULL, 'Uncharacterized protein', 56, NULL, NULL, 222092),
(222093, '2.60.40.10-FF-002456', NULL, 'Sensory AXon guidance', 106, NULL, NULL, 222093),
(222094, '3.10.20.90-FF-000320', NULL, 'Predicted protein', 90, NULL, NULL, 222094),
(222095, '3.60.15.10-FF-000057', NULL, 'Ribonuclease Z', 219, NULL, NULL, 222095),
(222096, '2.130.10.110-FF-000018', NULL, 'Clathrin heavy chain', 381, NULL, NULL, 222096),
(222097, '1.25.40.10-FF-001140', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 134, NULL, NULL, 222097),
(222098, '3.90.550.10-FF-000518', NULL, 'Probable UDP-glucose:glycoprotein glucosyltransferase A', 250, NULL, NULL, 222098),
(222099, '3.30.160.60-FF-003962', NULL, 'Uncharacterized protein, isoform A', 85, NULL, NULL, 222099),
(222100, '2.30.30.40-FF-000262', NULL, 'RUN and SH3 domain containing 1', 61, NULL, NULL, 222100),
(222101, '3.40.605.10-FF-000045', NULL, '1-pyrroline-5-carboxylate dehydrogenase 1', 312, NULL, NULL, 222101),
(222102, '3.10.50.10-FF-000051', NULL, 'Chitinase, putative', 61, NULL, NULL, 222102),
(222103, '1.10.510.10-FF-003745', NULL, NULL, 147, NULL, NULL, 222103),
(222104, '1.25.10.10-FF-002728', NULL, 'Uncharacterized protein', 899, NULL, NULL, 222104),
(222105, '3.30.160.60-FF-000539', NULL, 'Putative zinc finger protein 131', 34, NULL, NULL, 222105),
(222106, '3.30.1330.10-FF-000020', NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase', 163, NULL, NULL, 222106),
(222107, '3.40.50.150-FF-001113', NULL, NULL, 118, NULL, NULL, 222107),
(222108, '1.10.1660.10-FF-000006', NULL, 'Chaperone modulatory protein CbpM', 101, NULL, NULL, 222108),
(222109, '2.130.10.10-FF-000287', NULL, 'WD repeat-containing protein 74', 175, NULL, NULL, 222109),
(222110, '3.40.50.620-FF-000091', NULL, 'Trifunctional nicotinamide-nucleotide adenylyltransferase/ribosylnicotinamide kinase/transcriptional regulator NadR', 168, NULL, NULL, 222110),
(222111, '3.40.50.300-FF-001310', NULL, 'Dynein heavy chain, putative', 173, NULL, NULL, 222111),
(222112, '1.10.220.10-FF-000081', NULL, 'Annexin', 33, NULL, NULL, 222112),
(222113, '3.40.50.300-FF-004957', NULL, 'Os10g0163290 protein', 194, NULL, NULL, 222113),
(222114, '3.50.50.60-FF-000030', NULL, 'Glutathione reductase', 203, NULL, NULL, 222114),
(222115, '1.20.140.150-FF-000088', NULL, 'Claudin-13', 182, NULL, NULL, 222115),
(222116, '2.60.120.960-FF-000002', NULL, 'Spike glycoprotein', 293, NULL, NULL, 222116),
(222117, '2.40.20.10-FF-000027', NULL, 'Uncharacterized protein', 89, NULL, NULL, 222117),
(222118, '2.170.210.10-FF-000005', NULL, 'Uncharacterized protein', 137, NULL, NULL, 222118),
(222119, '3.65.10.10-FF-000007', NULL, 'Pentafunctional AROM polypeptide', 227, NULL, NULL, 222119),
(222120, '1.25.40.10-FF-000864', NULL, 'Formin 1', 261, NULL, NULL, 222120),
(222121, '1.25.40.10-FF-000078', NULL, 'Transcriptional corepressor Cyc8', 143, NULL, NULL, 222121),
(222122, '2.30.29.30-FF-001155', NULL, 'Uncharacterized protein', 109, NULL, NULL, 222122),
(222123, '2.40.33.10-FF-000001', NULL, 'Pyruvate kinase', 100, NULL, NULL, 222123),
(222124, '3.90.226.10-FF-000029', NULL, 'Peptidase, S41 family', 157, NULL, NULL, 222124),
(222125, '3.10.28.10-FF-000016', NULL, 'Pre-mRNA splicing factor (Prp8)', 182, NULL, NULL, 222125),
(222126, '3.40.50.10810-FF-000060', NULL, 'DNA repair protein RAD5', 134, NULL, NULL, 222126),
(222127, '3.30.420.10-FF-000578', NULL, NULL, 224, NULL, NULL, 222127),
(222128, '3.30.1330.30-FF-000026', NULL, 'H/ACA ribonucleoprotein complex subunit 2', 135, NULL, NULL, 222128),
(222129, '1.20.58.390-FF-000286', NULL, 'GABA-A receptor epsilon subunit', 50, NULL, NULL, 222129);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(222130, '3.40.190.290-FF-000038', NULL, 'LysR family transcriptional regulator', 205, NULL, NULL, 222130),
(222131, '3.40.50.300-FF-005233', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 200, NULL, NULL, 222131),
(222132, '1.10.238.110-FF-000008', NULL, 'Diacylglycerol kinase', 107, NULL, NULL, 222132),
(222133, '2.10.25.10-FF-000141', NULL, 'Fibrillin 2', 43, NULL, NULL, 222133),
(222134, '3.10.450.580-FF-000017', NULL, 'Mediator of RNA polymerase II transcription subunit 6', 131, NULL, NULL, 222134),
(222135, '2.10.25.10-FF-000034', NULL, 'Laminin subunit alpha 3', 45, NULL, NULL, 222135),
(222136, '3.30.1490.20-FF-000074', NULL, 'Trifunctional purine biosynthetic protein adenosine-3', 52, NULL, NULL, 222136),
(222137, '1.25.10.10-FF-001200', NULL, 'Uncharacterized conserved protein UCP005250', 103, NULL, NULL, 222137),
(222138, '3.30.420.40-FF-000576', NULL, 'Heat shock protein, putative', 141, NULL, NULL, 222138),
(222139, '3.40.50.300-FF-000686', NULL, 'Multidrug ABC transporter ATP-binding protein', 234, NULL, NULL, 222139),
(222140, '2.60.120.1000-FF-000003', NULL, 'Collagen alpha-1(XXVII) chain B', 81, NULL, NULL, 222140),
(222141, '2.130.10.30-FF-000051', NULL, 'Highwire, isoform B', 256, NULL, NULL, 222141),
(222142, '1.25.40.10-FF-004349', NULL, 'PPIC-type PPIASE domain containing protein', 278, NULL, NULL, 222142),
(222143, '2.30.30.40-FF-000610', NULL, 'Chemotaxis protein CheZ', 55, NULL, NULL, 222143),
(222144, '3.90.79.10-FF-000254', NULL, 'Zgc:103759', 142, NULL, NULL, 222144),
(222145, '3.30.420.10-FF-000685', NULL, NULL, 145, NULL, NULL, 222145),
(222146, '3.10.330.20-FF-000017', NULL, 'Putative trna methyltransferase complex gcd14 subunit', 70, NULL, NULL, 222146),
(222147, '3.90.1750.10-FF-000089', NULL, 'Predicted protein', 73, NULL, NULL, 222147),
(222148, '2.40.160.60-FF-000001', NULL, 'Long-chain fatty acid transporter FadL', 402, NULL, NULL, 222148),
(222149, '2.60.40.2130-FF-000010', NULL, 'Uncharacterized protein', 157, NULL, NULL, 222149),
(222150, '1.10.287.70-FF-000005', NULL, 'potassium voltage-gated channel subfamily G member 1', 110, NULL, NULL, 222150),
(222151, '2.40.30.170-FF-000040', NULL, 'Efflux transporter periplasmic adaptor subunit', 80, NULL, NULL, 222151),
(222152, '1.10.10.10-FF-001688', NULL, 'MarR family transcriptional regulator', 112, NULL, NULL, 222152),
(222153, '3.40.47.10-FF-000103', NULL, '3,5-dihydroxyphenylacetyl-CoA synthase', 199, NULL, NULL, 222153),
(222154, '1.20.1310.20-FF-000065', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 99, NULL, NULL, 222154),
(222155, '1.10.1510.30-FF-000001', NULL, 'Pseudouridine synthase 7 like', 91, NULL, NULL, 222155),
(222156, '1.10.1600.10-FF-000002', NULL, 'X-ray repair cross-complementing protein 5', 101, NULL, NULL, 222156),
(222157, '3.10.450.40-FF-000043', NULL, NULL, 93, NULL, NULL, 222157),
(222158, '3.40.50.300-FF-007150', NULL, 'Uncharacterized protein', 176, NULL, NULL, 222158),
(222159, '1.10.10.10-FF-002088', NULL, 'Uncharacterized protein', 95, NULL, NULL, 222159),
(222160, '3.40.50.1820-FF-001247', NULL, 'Uncharacterized protein', 592, NULL, NULL, 222160),
(222161, '1.10.287.3510-FF-000016', NULL, 'Uncharacterized protein', 68, NULL, NULL, 222161),
(222162, '1.10.533.10-FF-000223', NULL, 'Uncharacterized protein', 93, NULL, NULL, 222162),
(222163, '2.60.120.200-FF-000696', NULL, 'Protein S', 195, NULL, NULL, 222163),
(222164, '3.40.50.300-FF-006874', NULL, 'Uncharacterized protein', 249, NULL, NULL, 222164),
(222165, '1.10.238.10-FF-001010', NULL, 'Uncharacterized protein', 170, NULL, NULL, 222165),
(222166, '3.60.21.10-FF-000442', NULL, 'Chromosome 9, whole genome shotgun sequence', 211, NULL, NULL, 222166),
(222167, '2.10.25.10-FF-000826', NULL, 'Hemolectin', 60, NULL, NULL, 222167),
(222168, '3.30.160.60-FF-000180', NULL, 'Zinc finger protein 689', 30, NULL, NULL, 222168),
(222169, '1.20.930.10-FF-000003', NULL, 'Putative Transcription factor IWS1', 145, NULL, NULL, 222169),
(222170, '2.60.40.60-FF-000301', NULL, 'protocadherin-7 isoform X1', 63, NULL, NULL, 222170);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(222171, '3.40.50.300-FF-000809', NULL, 'ATP-dependent RNA helicase SUB2', 222, NULL, NULL, 222171),
(222172, '3.30.70.1050-FF-000007', NULL, 'Trigger factor', 117, NULL, NULL, 222172),
(222173, '1.20.1070.10-FF-000829', NULL, 'Melatonin receptor type 1A', 309, NULL, NULL, 222173),
(222174, '3.90.70.10-FF-000734', NULL, 'Predicted protein', 165, NULL, NULL, 222174),
(222175, '3.80.20.20-FF-000072', NULL, 'Receptor protein-tyrosine kinase', 143, NULL, NULL, 222175),
(222176, '3.10.180.10-FF-000070', NULL, 'Methylmalonyl-CoA epimerase', 139, NULL, NULL, 222176),
(222177, '3.30.60.30-FF-000045', NULL, 'Serine protease inhibitor dipetalogastin', 54, NULL, NULL, 222177),
(222178, '1.10.20.140-FF-000011', NULL, NULL, 58, NULL, NULL, 222178),
(222179, '3.40.50.300-FF-004614', NULL, 'Fanconi anemia group J protein homolog', 68, NULL, NULL, 222179),
(222180, '1.20.58.390-FF-000156', NULL, 'Uncharacterized protein', 120, NULL, NULL, 222180),
(222181, '2.30.42.10-FF-000281', NULL, 'Usher syndrome 1C', 113, NULL, NULL, 222181),
(222182, '3.30.160.60-FF-004581', NULL, NULL, 40, NULL, NULL, 222182),
(222183, '1.10.238.10-FF-000734', NULL, 'Uncharacterized protein', 72, NULL, NULL, 222183),
(222184, '1.10.1200.270-FF-000037', NULL, 'Uncharacterized protein', 36, NULL, NULL, 222184),
(222185, '1.10.287.1080-FF-000006', NULL, 'Hypothetical Cytosolic Protein', 89, NULL, NULL, 222185),
(222186, '1.10.560.10-FF-000134', NULL, 'Chaperonin Cpn60', 44, NULL, NULL, 222186),
(222187, '3.60.21.10-FF-000094', NULL, 'Acid phosphatase', 293, NULL, NULL, 222187),
(222188, '1.20.1070.10-FF-000487', NULL, 'EG:22E5.10 protein', 152, NULL, NULL, 222188),
(222189, '3.40.50.300-FF-004272', NULL, 'Rab_C99 protein', 180, NULL, NULL, 222189),
(222190, '2.130.10.10-FF-003939', NULL, 'Uncharacterized protein', 251, NULL, NULL, 222190),
(222191, '2.60.120.330-FF-000162', NULL, 'Uncharacterized protein', 332, NULL, NULL, 222191),
(222192, '2.30.330.10-FF-000002', NULL, 'Flagellar motor switch protein FliN', 94, NULL, NULL, 222192),
(222193, '3.10.20.90-FF-000078', NULL, 'Auxin-responsive protein', 113, NULL, NULL, 222193),
(222194, '2.60.120.10-FF-000485', NULL, 'Cyclic nucleotide-binding protein', 135, NULL, NULL, 222194),
(222195, '3.30.160.60-FF-004451', NULL, NULL, 31, NULL, NULL, 222195),
(222196, '3.30.40.10-FF-001685', NULL, 'RING zinc finger-containing protein', 72, NULL, NULL, 222196),
(222197, '1.10.510.10-FF-000648', NULL, 'Mitotic checkpoint serine/threonine-protein kinase BUB1', 303, NULL, NULL, 222197),
(222198, '3.40.50.1820-FF-000758', NULL, 'Alpha/beta hydrolase domain protein', 316, NULL, NULL, 222198),
(222199, '1.20.1070.10-FF-001318', NULL, 'C3a anaphylatoxin chemotactic receptor', 85, NULL, NULL, 222199),
(222200, '1.20.1250.20-FF-001307', NULL, 'Major facilitator superfamily protein', 210, NULL, NULL, 222200),
(222201, '1.20.120.230-FF-000035', NULL, 'Alpha-catenin-like protein hmp-1', 119, NULL, NULL, 222201),
(222202, '3.30.428.10-FF-000023', NULL, 'Adenylylsulfatase HINT3', 166, NULL, NULL, 222202),
(222203, '3.20.20.80-FF-000794', NULL, 'Secreted alpha-amylase', 171, NULL, NULL, 222203),
(222204, '1.10.238.10-FF-000386', NULL, 'Calmodulin-like protein', 68, NULL, NULL, 222204),
(222205, '3.30.70.370-FF-000027', NULL, NULL, 80, NULL, NULL, 222205),
(222206, '1.20.272.10-FF-000041', NULL, 'DNA polymerase III subunit gamma/tau', 120, NULL, NULL, 222206),
(222207, '2.10.25.10-FF-001445', NULL, 'Uncharacterized protein', 44, NULL, NULL, 222207),
(222208, '1.10.8.710-FF-000019', NULL, NULL, 106, NULL, NULL, 222208),
(222209, '2.20.230.10-FF-000002', NULL, 'Beta-galactosidase, putative', 76, NULL, NULL, 222209),
(222210, '2.10.25.10-FF-001102', NULL, 'Transmembrane cell adhesion receptor mua-3', 36, NULL, NULL, 222210),
(222211, '3.10.50.40-FF-000149', NULL, 'Peptidylprolyl isomerase', 119, NULL, NULL, 222211),
(222212, '2.130.10.10-FF-004339', NULL, 'Predicted protein', 99, NULL, NULL, 222212),
(222213, '4.10.60.10-FF-000268', NULL, 'Uncharacterized protein', 55, NULL, NULL, 222213),
(222214, '1.10.510.10-FF-000867', NULL, 'Protein kinase, putative', 280, NULL, NULL, 222214);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(222215, '1.25.40.510-FF-000009', NULL, 'Polyadenylated-RNA export factor', 282, NULL, NULL, 222215),
(222216, '3.40.50.720-FF-001312', NULL, 'UDP-glucose 4-epimerase', 308, NULL, NULL, 222216),
(222217, '3.40.50.720-FF-002498', NULL, 'Malic enzyme', 151, NULL, NULL, 222217),
(222218, '3.40.50.300-FF-003108', NULL, 'RecBCD enzyme subunit RecC', 169, NULL, NULL, 222218),
(222219, '2.60.40.1770-FF-000003', NULL, 'ephrin type-B receptor 4', 56, NULL, NULL, 222219),
(222220, '2.60.40.60-FF-000644', NULL, 'AGAP004166-PA', 127, NULL, NULL, 222220),
(222221, '3.10.290.10-FF-000061', NULL, 'Tyrosine--tRNA ligase', 104, NULL, NULL, 222221),
(222222, '1.20.1320.30-FF-000001', NULL, 'Interferon-induced with helicase C domain 1', 120, NULL, NULL, 222222),
(222223, '3.40.190.10-FF-000440', NULL, 'Uncharacterized solute-binding protein MA_0280', 170, NULL, NULL, 222223),
(222224, '3.40.50.2300-FF-000453', NULL, 'Pilus assembly protein', 126, NULL, NULL, 222224),
(222225, '1.10.238.10-FF-001223', NULL, 'Uncharacterized protein', 125, NULL, NULL, 222225),
(222226, '2.60.450.10-FF-000021', NULL, 'Lipopolysaccharide ABC transporter, periplasmic protein LptC', 126, NULL, NULL, 222226),
(222227, '1.20.1070.10-FF-001448', NULL, 'Predicted protein', 220, NULL, NULL, 222227),
(222228, '1.20.1250.20-FF-000818', NULL, 'Uncharacterized protein', 455, NULL, NULL, 222228),
(222229, '1.20.1250.10-FF-000130', NULL, NULL, 110, NULL, NULL, 222229),
(222230, '3.40.30.10-FF-000582', NULL, '2-hydroxychromene-2-carboxylate isomerase', 194, NULL, NULL, 222230),
(222231, '3.30.160.60-FF-001141', NULL, 'Zinc finger protein 473', 27, NULL, NULL, 222231),
(222232, '3.30.160.60-FF-005070', NULL, NULL, 29, NULL, NULL, 222232),
(222233, '3.40.50.300-FF-007493', NULL, 'ATP-dependent RNA helicase mss116, mitochondrial', 227, NULL, NULL, 222233),
(222234, '1.25.10.10-FF-000930', NULL, 'Heat repeat domain containing protein', 1053, NULL, NULL, 222234),
(222235, '2.130.10.10-FF-004215', NULL, 'LD21275p', 151, NULL, NULL, 222235),
(222236, '1.10.287.940-FF-000002', NULL, 'P2X purinoceptor', 16, NULL, NULL, 222236),
(222237, '3.30.40.10-FF-001229', NULL, 'Histone-lysine N-methyltransferase', 111, NULL, NULL, 222237),
(222238, '2.40.110.10-FF-000085', NULL, 'Uncharacterized protein', 87, NULL, NULL, 222238),
(222239, '3.30.200.20-FF-001543', NULL, 'Serine/threonine protein kinase, putative', 104, NULL, NULL, 222239),
(222240, '1.10.287.70-FF-000674', NULL, 'Uncharacterized protein', 111, NULL, NULL, 222240),
(222241, '3.40.190.10-FF-000092', NULL, 'HTH-type transcriptional regulator YidZ', 102, NULL, NULL, 222241),
(222242, '1.25.40.10-FF-002551', NULL, 'Pentatricopeptide (PPR) repeat-containing protein-like', 138, NULL, NULL, 222242),
(222243, '2.60.40.60-FF-000296', NULL, 'Cadherin 74A, isoform A', 107, NULL, NULL, 222243),
(222244, '1.25.40.660-FF-000026', NULL, 'Uncharacterized protein', 78, NULL, NULL, 222244),
(222245, '1.20.120.1750-FF-000149', NULL, 'RBR-type E3 ubiquitin transferase', 90, NULL, NULL, 222245),
(222246, '3.40.50.300-FF-007835', NULL, 'Uncharacterized protein', 217, NULL, NULL, 222246),
(222247, '3.40.50.1100-FF-000183', NULL, 'Related to L-serine dehydratase', 138, NULL, NULL, 222247),
(222248, '2.20.70.10-FF-000256', NULL, 'Predicted protein', 44, NULL, NULL, 222248),
(222249, '3.30.160.60-FF-005412', NULL, NULL, 41, NULL, NULL, 222249),
(222250, '2.170.130.10-FF-000055', NULL, NULL, 159, NULL, NULL, 222250),
(222251, '3.30.497.10-FF-000098', NULL, 'Serpin family B member 13', 162, NULL, NULL, 222251),
(222252, '1.20.5.1030-FF-000004', NULL, 'Protein translocase subunit SecE', 57, NULL, NULL, 222252),
(222253, '1.25.40.10-FF-000639', NULL, 'Pre-mRNA-splicing factor CLF1', 189, NULL, NULL, 222253),
(222254, '3.90.640.10-FF-000042', NULL, 'Heat shock 70 kDa protein 8', 82, NULL, NULL, 222254),
(222255, '1.10.287.1490-FF-000011', NULL, 'citron Rho-interacting kinase isoform X3', 181, NULL, NULL, 222255),
(222256, '1.10.10.10-FF-001020', NULL, 'LysR family transcriptional regulator', 92, NULL, NULL, 222256),
(222257, '3.30.1370.70-FF-000006', NULL, 'HIRA-interacting protein 5, putative', 104, NULL, NULL, 222257);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(222258, '1.10.510.10-FF-000199', NULL, 'Non-specific serine/threonine protein kinase', 125, NULL, NULL, 222258),
(222259, '3.40.50.150-FF-000264', NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', 335, NULL, NULL, 222259),
(222260, '3.10.20.90-FF-000533', NULL, 'Ubiquitin family', 84, NULL, NULL, 222260),
(222261, '3.30.70.240-FF-000005', NULL, 'Elongation factor 4', 111, NULL, NULL, 222261),
(222262, '2.130.10.10-FF-004108', NULL, 'Bardet-Biedl syndrome 2 protein homolog', 192, NULL, NULL, 222262),
(222263, '1.10.340.30-FF-000034', NULL, 'Endonuclease III homolog', 111, NULL, NULL, 222263),
(222264, '1.10.8.60-FF-000297', NULL, 'AAA family ATPase-like protein', 71, NULL, NULL, 222264),
(222265, '1.50.10.100-FF-000005', NULL, 'Heparin/heparan-sulfate lyase', 333, NULL, NULL, 222265),
(222266, '1.10.287.10-FF-000010', NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase', 27, NULL, NULL, 222266),
(222267, '3.90.550.10-FF-000395', NULL, 'Glycosyl transferase group 2 family protein', 256, NULL, NULL, 222267),
(222268, '3.40.250.10-FF-000147', NULL, 'Sulfurtransferase family protein', 147, NULL, NULL, 222268),
(222269, '2.60.40.3210-FF-000031', NULL, 'Uromodulin-like 1', 118, NULL, NULL, 222269),
(222270, '3.40.630.30-FF-000564', NULL, 'Elongator complex protein 3', 121, NULL, NULL, 222270),
(222271, '1.10.630.10-FF-000359', NULL, 'Predicted protein', 466, NULL, NULL, 222271),
(222272, '3.30.70.330-FF-001679', NULL, NULL, 90, NULL, NULL, 222272),
(222273, '3.40.50.300-FF-001759', NULL, 'Cytosolic Fe-S cluster assembly factor NUBP1 homolog', 258, NULL, NULL, 222273),
(222274, '3.30.200.20-FF-002055', NULL, 'Predicted protein', 87, NULL, NULL, 222274),
(222275, '3.40.50.1820-FF-001702', NULL, 'Uncharacterized protein', 179, NULL, NULL, 222275),
(222276, '1.10.510.10-FF-003958', NULL, NULL, 50, NULL, NULL, 222276),
(222277, '2.120.10.90-FF-000013', NULL, 'DNA gyrase subunit A', 308, NULL, NULL, 222277),
(222278, '2.130.10.130-FF-000007', NULL, 'Integrin subunit alpha 3', 433, NULL, NULL, 222278),
(222279, '3.40.50.1240-FF-000213', NULL, NULL, 289, NULL, NULL, 222279),
(222280, '3.30.870.10-FF-000056', NULL, 'Tyrosine-DNA phosphodiesterase', 190, NULL, NULL, 222280),
(222281, '3.30.450.20-FF-000639', NULL, 'PAS sensor protein', 133, NULL, NULL, 222281),
(222282, '3.40.50.12430-FF-000001', NULL, 'Folliculin', 132, NULL, NULL, 222282),
(222283, '2.60.40.10-FF-004474', NULL, NULL, 89, NULL, NULL, 222283),
(222284, '1.25.40.10-FF-001590', NULL, 'Rapsynoid, putative', 180, NULL, NULL, 222284),
(222285, '3.30.1010.10-FF-000092', NULL, 'Phosphatidylinositol 3-kinase, putative', 198, NULL, NULL, 222285),
(222286, '3.30.160.60-FF-001938', NULL, 'Zinc finger protein 300', 28, NULL, NULL, 222286),
(222287, '3.30.465.10-FF-000108', NULL, 'Oxidoreductase', 224, NULL, NULL, 222287),
(222288, '1.10.472.80-FF-000181', NULL, NULL, 161, NULL, NULL, 222288),
(222289, '3.80.10.10-FF-000927', NULL, 'Nucleotide excision NEF4 component', 78, NULL, NULL, 222289),
(222290, '3.40.50.10810-FF-000077', NULL, 'Putative DNA repair protein', 143, NULL, NULL, 222290),
(222291, '2.60.40.10-FF-003962', NULL, NULL, 104, NULL, NULL, 222291),
(222292, '1.10.238.10-FF-000279', NULL, 'Rhomboid, veinlet-like 3 (Drosophila)', 89, NULL, NULL, 222292),
(222293, '3.30.160.60-FF-000741', NULL, 'Zinc finger matrin-type protein 5', 51, NULL, NULL, 222293),
(222294, '4.10.400.10-FF-000134', NULL, 'Low-density lipoprotein RecePtor related', 41, NULL, NULL, 222294),
(222295, '2.60.450.20-FF-000018', NULL, 'Uncharacterized protein', 115, NULL, NULL, 222295),
(222296, '3.30.428.70-FF-000001', NULL, 'APA1p AP4A phosphorylase', 326, NULL, NULL, 222296),
(222297, '1.10.150.20-FF-000325', NULL, 'Predicted protein', 33, NULL, NULL, 222297),
(222298, '1.10.287.1490-FF-000005', NULL, 'nucleoprotein TPR isoform X2', 180, NULL, NULL, 222298),
(222299, '3.90.70.10-FF-000155', NULL, 'Ubiquitinyl hydrolase 1', 206, NULL, NULL, 222299),
(222300, '2.170.270.10-FF-000110', NULL, 'Histone-lysine N-methyltransferase', 248, NULL, NULL, 222300),
(222301, '2.60.40.3510-FF-000014', NULL, 'Uncharacterized protein', 151, NULL, NULL, 222301);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(222302, '1.20.1420.30-FF-000060', NULL, 'Na+/Ca+ antiporter, CaCA family', 163, NULL, NULL, 222302),
(222303, '3.80.10.10-FF-001439', NULL, 'Uncharacterized protein', 259, NULL, NULL, 222303),
(222304, '2.40.50.140-FF-001097', NULL, NULL, 120, NULL, NULL, 222304),
(222305, '3.90.79.10-FF-000130', NULL, 'Mitochondrial ribosomal protein L46', 130, NULL, NULL, 222305),
(222306, '3.40.630.30-FF-000457', NULL, 'N-alpha-acetyltransferase 60', 180, NULL, NULL, 222306),
(222307, '3.40.50.1010-FF-000268', NULL, NULL, 148, NULL, NULL, 222307),
(222308, '3.40.50.300-FF-004851', NULL, 'Translation elongation factor G-related protein', 275, NULL, NULL, 222308),
(222309, '3.30.160.60-FF-001253', NULL, 'Zinc finger protein 408', 30, NULL, NULL, 222309),
(222310, '3.40.50.720-FF-002262', NULL, 'Uncharacterized protein', 48, NULL, NULL, 222310),
(222311, '4.10.1030.10-FF-000001', NULL, 'Putative Cullin-1', 73, NULL, NULL, 222311),
(222312, '3.90.1260.10-FF-000006', NULL, 'Argininosuccinate synthase', 187, NULL, NULL, 222312),
(222313, '3.30.1660.10-FF-000005', NULL, 'Conserved protein', 69, NULL, NULL, 222313),
(222314, '2.60.40.10-FF-002326', NULL, 'GH03113p', 110, NULL, NULL, 222314),
(222315, '1.10.246.60-FF-000020', NULL, NULL, 76, NULL, NULL, 222315),
(222316, '2.60.120.200-FF-000819', NULL, 'Uncharacterized protein', 30, NULL, NULL, 222316),
(222317, '3.40.50.10420-FF-000050', NULL, 'Probable 5-formyltetrahydrofolate cyclo-ligase', 201, NULL, NULL, 222317),
(222318, '3.40.1740.10-FF-000004', NULL, 'Putative ACR, putative', 185, NULL, NULL, 222318),
(222319, '3.10.20.90-FF-000426', NULL, 'Ubiquitin and WLM domain-containing metalloprotease SPCC1442.07c', 86, NULL, NULL, 222319),
(222320, '3.40.50.720-FF-000132', NULL, 'NAD-binding Rossmann fold oxidoreductase', 189, NULL, NULL, 222320),
(222321, '3.40.50.300-FF-006981', NULL, 'Uncharacterized protein', 216, NULL, NULL, 222321),
(222322, '1.20.144.10-FF-000103', NULL, 'Uncharacterized protein', 241, NULL, NULL, 222322),
(222323, '3.40.50.300-FF-005126', NULL, 'Cobalt ABC transporter ATP-binding protein', 247, NULL, NULL, 222323),
(222324, '3.30.70.920-FF-000018', NULL, 'Transcriptional regulator, AsnC family', 84, NULL, NULL, 222324),
(222325, '2.40.50.100-FF-000152', NULL, 'Sugar ABC transporter ATP-binding protein', 95, NULL, NULL, 222325),
(222326, '2.40.340.10-FF-000017', NULL, NULL, 64, NULL, NULL, 222326),
(222327, '3.40.50.1980-FF-000087', NULL, 'Iron (III) ABC transporter, periplasmic iron-bindin gprotein', 136, NULL, NULL, 222327),
(222328, '3.30.930.10-FF-000100', NULL, 'Lysine--tRNA ligase', 358, NULL, NULL, 222328),
(222329, '1.10.418.60-FF-000015', NULL, 'Probable kinetochore protein NUF2', 182, NULL, NULL, 222329),
(222330, '3.30.470.20-FF-000062', NULL, 'Carbamoyl-phosphate synthetase 2, aspartate transcarbamylase, and dihydroorotase', 109, NULL, NULL, 222330),
(222331, '3.40.50.12160-FF-000009', NULL, 'threonylcarbamoyladenosine tRNA methylthiotransferase', 120, NULL, NULL, 222331),
(222332, '2.40.70.10-FF-000194', NULL, 'Uncharacterized protein', 135, NULL, NULL, 222332),
(222333, '3.10.129.10-FF-000164', NULL, 'Thioesterase superfamily protein', 134, NULL, NULL, 222333),
(222334, '3.30.200.20-FF-000924', NULL, 'Uncharacterized protein', 66, NULL, NULL, 222334),
(222335, '4.10.880.10-FF-000001', NULL, 'Genome polyprotein', 47, NULL, NULL, 222335),
(222336, '1.20.1560.10-FF-000120', NULL, 'ABC transporter B family member 6', 326, NULL, NULL, 222336),
(222337, '3.30.70.270-FF-000109', NULL, 'GGDEF family protein', 166, NULL, NULL, 222337),
(222338, '1.10.506.10-FF-000088', NULL, 'Uncharacterized protein', 103, NULL, NULL, 222338),
(222339, '3.80.10.10-FF-001771', NULL, 'Uncharacterized protein, isoform D', 96, NULL, NULL, 222339),
(222340, '3.40.50.300-FF-003889', NULL, 'GPN-loop GTPase 2', 258, NULL, NULL, 222340),
(222341, '3.40.1580.10-FF-000002', NULL, 'F-box only protein 3', 144, NULL, NULL, 222341),
(222342, '3.30.230.70-FF-000177', NULL, 'Uncharacterized protein', 43, NULL, NULL, 222342),
(222343, '3.40.532.10-FF-000027', NULL, NULL, 125, NULL, NULL, 222343);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(222344, '1.10.3260.10-FF-000032', NULL, 'Uncharacterized protein', 278, NULL, NULL, 222344),
(222345, '1.25.10.10-FF-001655', NULL, '19S/PA700 proteasome regulatory particle subunit Rpn1p/S1', 370, NULL, NULL, 222345),
(222346, '1.10.238.10-FF-001004', NULL, 'Defective in cullin neddylation protein', 89, NULL, NULL, 222346),
(222347, '1.20.1250.20-FF-001875', NULL, 'Predicted protein', 107, NULL, NULL, 222347),
(222348, '3.30.360.10-FF-000079', NULL, 'Gfo/Idh/MocA family oxidoreductase', 227, NULL, NULL, 222348),
(222349, '3.30.50.10-FF-000005', NULL, 'Retinoic acid receptor RXR-alpha', 86, NULL, NULL, 222349),
(222350, '3.40.50.360-FF-000102', NULL, 'Methionine synthase reductase', 175, NULL, NULL, 222350),
(222351, '3.30.420.210-FF-000008', NULL, 'Ubiquitin regulatory protein, putative', 73, NULL, NULL, 222351),
(222352, '1.10.10.60-FF-000624', NULL, 'Myb-related protein Myb4', 48, NULL, NULL, 222352),
(222353, '3.80.10.10-FF-003912', NULL, 'Receptor-like protein EIX2', 270, NULL, NULL, 222353),
(222354, '3.90.1140.10-FF-000059', NULL, 'Uncharacterized protein', 84, NULL, NULL, 222354),
(222355, '3.40.50.880-FF-000140', NULL, 'Predicted protein', 238, NULL, NULL, 222355),
(222356, '3.10.580.10-FF-000055', NULL, 'Arabinose 5-phosphate isomerase', 120, NULL, NULL, 222356),
(222357, '2.30.30.30-FF-000164', NULL, 'Uncharacterized protein', 82, NULL, NULL, 222357),
(222358, '3.90.1150.10-FF-000453', NULL, 'Aminotransferase', 138, NULL, NULL, 222358),
(222359, '3.40.50.1010-FF-000049', NULL, 'DNA repair endonuclease, putative', 148, NULL, NULL, 222359),
(222360, '3.40.50.300-FF-004744', NULL, 'Uncharacterized protein', 94, NULL, NULL, 222360),
(222361, '2.60.40.1120-FF-000056', NULL, 'Rhamnogalacturonate lyase', 85, NULL, NULL, 222361),
(222362, '3.40.50.2300-FF-000346', NULL, 'Diguanylate cyclase response regulator', 129, NULL, NULL, 222362),
(222363, '1.20.1230.10-FF-000016', NULL, 'Phosphoinositide phospholipase C', 140, NULL, NULL, 222363),
(222364, '1.20.1600.10-FF-000051', NULL, 'Protein CyaE', 407, NULL, NULL, 222364),
(222365, '3.40.430.10-FF-000026', NULL, 'Riboflavin biosynthesis protein RibD', 201, NULL, NULL, 222365),
(222366, '1.10.238.10-FF-000604', NULL, 'EF-hand domain pair/EF-hand domain/EF hand, putative', 116, NULL, NULL, 222366),
(222367, '3.40.47.10-FF-000233', NULL, NULL, 69, NULL, NULL, 222367),
(222368, '1.25.40.10-FF-002101', NULL, 'Pentatricopeptide repeat-containing protein At3g53700, chloroplastic', 101, NULL, NULL, 222368),
(222369, '2.40.30.10-FF-000073', NULL, 'NADPH--cytochrome P450 reductase', 130, NULL, NULL, 222369),
(222370, '1.25.40.10-FF-001483', NULL, 'Uncharacterized protein', 288, NULL, NULL, 222370),
(222371, '2.10.25.10-FF-001338', NULL, 'Fibulin 2', 39, NULL, NULL, 222371),
(222372, '3.60.20.30-FF-000013', NULL, NULL, 77, NULL, NULL, 222372),
(222373, '2.130.10.10-FF-002074', NULL, 'Os12g0178633 protein', 113, NULL, NULL, 222373),
(222374, '2.60.40.10-FF-001489', NULL, 'SPEG neighbor', 94, NULL, NULL, 222374),
(222375, '3.60.20.10-FF-000131', NULL, 'Proteasome subunit beta', 188, NULL, NULL, 222375),
(222376, '4.10.400.10-FF-000241', NULL, 'LDL receptor protein 1, isoform G', 39, NULL, NULL, 222376),
(222377, '3.30.40.10-FF-001797', NULL, 'Predicted protein', 58, NULL, NULL, 222377),
(222378, '3.40.50.1820-FF-000977', NULL, 'Alpha/beta hydrolase', 260, NULL, NULL, 222378),
(222379, '2.10.25.10-FF-001214', NULL, 'Predicted protein', 24, NULL, NULL, 222379),
(222380, '1.20.1560.10-FF-000788', NULL, 'Uncharacterized protein', 234, NULL, NULL, 222380),
(222381, '1.25.40.10-FF-000971', NULL, 'Pentatricopeptide repeat-containing protein', 92, NULL, NULL, 222381),
(222382, '2.60.40.60-FF-001026', NULL, 'Uncharacterized protein', 72, NULL, NULL, 222382),
(222383, '3.80.10.10-FF-003676', NULL, 'Probable disease resistance protein At5g45510', 207, NULL, NULL, 222383),
(222384, '3.40.50.1820-FF-001377', NULL, 'Chromosome 9, whole genome shotgun sequence', 222, NULL, NULL, 222384),
(222385, '3.90.226.10-FF-000136', NULL, 'Carbamoyl-phosphate synthase/carboxyl transferase', 240, NULL, NULL, 222385);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(222386, '3.90.340.10-FF-000002', NULL, 'Nitric oxide synthase', 170, NULL, NULL, 222386),
(222387, '3.50.50.60-FF-000373', NULL, 'Protoporphyrinogen oxidase', 278, NULL, NULL, 222387),
(222388, '2.60.40.60-FF-000407', NULL, 'Calsyntenin 3', 80, NULL, NULL, 222388),
(222389, '1.25.10.10-FF-000351', NULL, 'armadillo repeat-containing protein 4 isoform X1', 171, NULL, NULL, 222389),
(222390, '2.40.10.350-FF-000005', NULL, 'Rod shape-determining protein MreC', 76, NULL, NULL, 222390),
(222391, '3.30.1520.10-FF-000063', NULL, 'Unplaced genomic scaffold supercont1.141, whole genome shotgun sequence', 155, NULL, NULL, 222391),
(222392, '1.20.1250.90-FF-000002', NULL, 'Thymic stromal lymphopoietin', 130, NULL, NULL, 222392),
(222393, '1.20.58.70-FF-000079', NULL, 'Qa-SNARE, SYP2/Pep12p/Syntaxin 7-type', 116, NULL, NULL, 222393),
(222394, '1.10.10.10-FF-001924', NULL, 'Transcriptional regulator, ArsR family', 94, NULL, NULL, 222394),
(222395, '3.40.190.10-FF-000203', NULL, 'Dipeptide-binding ABC transporter, periplasmic substrate-binding component', 208, NULL, NULL, 222395),
(222396, '3.40.190.80-FF-000073', NULL, 'Inositol polyphosphate 1-phosphatase', 140, NULL, NULL, 222396),
(222397, '1.25.40.20-FF-000755', NULL, 'Protein accellerated cell death 6', 178, NULL, NULL, 222397),
(222398, '3.30.160.60-FF-004687', NULL, NULL, 22, NULL, NULL, 222398),
(222399, '3.40.1380.20-FF-000018', NULL, 'Pyruvate kinase 2', 124, NULL, NULL, 222399),
(222400, '2.40.10.10-FF-000544', NULL, NULL, 85, NULL, NULL, 222400),
(222401, '3.50.50.60-FF-000154', NULL, 'Fumarate reductase flavoprotein subunit', 291, NULL, NULL, 222401),
(222402, '1.25.40.10-FF-003388', NULL, 'Prp-6', 144, NULL, NULL, 222402),
(222403, '3.40.50.300-FF-002378', NULL, 'ATP-dependent helicase FUN30', 241, NULL, NULL, 222403),
(222404, '1.10.150.20-FF-000106', NULL, '5''-3'' exonuclease', 84, NULL, NULL, 222404),
(222405, '3.40.50.1820-FF-000865', NULL, 'Lipid droplet-associated hydrolase', 286, NULL, NULL, 222405),
(222406, '1.10.560.10-FF-000022', NULL, 'T-complex protein 1 subunit zeta', 230, NULL, NULL, 222406),
(222407, '3.40.309.10-FF-000014', NULL, 'NAD/NADP-dependent betaine aldehyde dehydrogenase', 194, NULL, NULL, 222407),
(222408, '1.20.1560.10-FF-000007', NULL, 'ATP-binding cassette subfamily C member 1', 331, NULL, NULL, 222408),
(222409, '1.10.238.10-FF-000498', NULL, 'Polcalcin Jun o 2', 76, NULL, NULL, 222409),
(222410, '1.10.1410.10-FF-000078', NULL, 'Poly A polymerase', 71, NULL, NULL, 222410),
(222411, '3.40.50.300-FF-001978', NULL, 'EC1118_1F29_0056p', 199, NULL, NULL, 222411),
(222412, '1.10.472.10-FF-000542', NULL, 'Uncharacterized protein', 79, NULL, NULL, 222412),
(222413, '3.20.20.210-FF-000022', NULL, 'Uroporphyrinogen decarboxylase', 350, NULL, NULL, 222413),
(222414, '3.40.50.150-FF-001568', NULL, NULL, 69, NULL, NULL, 222414),
(222415, '2.40.180.10-FF-000027', NULL, 'Catalase, putative', 48, NULL, NULL, 222415),
(222416, '2.40.160.20-FF-000017', NULL, 'Outer membrane protein', 155, NULL, NULL, 222416),
(222417, '1.10.510.10-FF-001036', NULL, 'Calcium-dependent protein kinase, putative', 272, NULL, NULL, 222417),
(222418, '1.25.10.10-FF-000019', NULL, 'Cytoskeleton-associated protein 5', 228, NULL, NULL, 222418),
(222419, '3.80.10.10-FF-000242', NULL, 'Adhesion G protein-coupled receptor A2', 212, NULL, NULL, 222419),
(222420, '3.90.1170.30-FF-000005', NULL, 'Thymidine phosphorylase', 93, NULL, NULL, 222420),
(222421, '1.20.920.30-FF-000059', NULL, 'Uncharacterized protein', 166, NULL, NULL, 222421),
(222422, '3.30.200.20-FF-000020', NULL, 'Protein kinase C, alpha', 113, NULL, NULL, 222422),
(222423, '1.20.1280.50-FF-000059', NULL, 'Partner of Paired', 50, NULL, NULL, 222423),
(222424, '3.40.50.1370-FF-000016', NULL, 'Ornithine carbamoyltransferase', 135, NULL, NULL, 222424),
(222425, '3.40.50.740-FF-000014', NULL, 'Tetrathionate reductase subunit A', 32, NULL, NULL, 222425),
(222426, '2.130.10.10-FF-004906', NULL, 'Uncharacterized protein', 110, NULL, NULL, 222426),
(222427, '3.10.20.90-FF-000314', NULL, 'Ste50p', 84, NULL, NULL, 222427);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(222428, '3.40.50.300-FF-006649', NULL, 'RuvB-like helicase', 88, NULL, NULL, 222428),
(222429, '3.40.50.11320-FF-000005', NULL, 'Carboxypeptidase', 100, NULL, NULL, 222429),
(222430, '1.25.40.10-FF-004006', NULL, 'Predicted protein', 205, NULL, NULL, 222430),
(222431, '2.60.40.150-FF-000559', NULL, 'Putative ca2+-dependent phospholipid-binding protein synaptotagmin required for synaptic vesicle', 148, NULL, NULL, 222431),
(222432, '1.20.1250.20-FF-001656', NULL, 'MFS multidrug transporter, putative', 185, NULL, NULL, 222432),
(222433, '1.25.40.1040-FF-000002', NULL, 'Cleavage stimulation factor subunit 3', 531, NULL, NULL, 222433),
(222434, '3.30.40.10-FF-000381', NULL, 'TNF receptor-associated factor', 52, NULL, NULL, 222434),
(222435, '3.40.50.1820-FF-000180', NULL, 'Putative lipase ROG1', 163, NULL, NULL, 222435),
(222436, '1.20.5.1430-FF-000023', NULL, 'Uncharacterized protein', 61, NULL, NULL, 222436),
(222437, '3.30.530.20-FF-000011', NULL, 'cytoplasmic phosphatidylinositol transfer protein 1 isoform X2', 259, NULL, NULL, 222437),
(222438, '3.10.110.10-FF-000138', NULL, 'Putative ubiquitin-conjugating enzyme e2', 169, NULL, NULL, 222438),
(222439, '1.10.510.10-FF-003054', NULL, NULL, 253, NULL, NULL, 222439),
(222440, '3.30.565.10-FF-000274', NULL, 'Two-component sensor histidine kinase', 150, NULL, NULL, 222440),
(222441, '3.90.70.10-FF-000279', NULL, 'Ubiquitin carboxyl-terminal hydrolase domain containing protein', 171, NULL, NULL, 222441),
(222442, '3.40.630.30-FF-000345', NULL, 'GM13211', 144, NULL, NULL, 222442),
(222443, '2.10.25.10-FF-000719', NULL, 'Uncharacterized protein, isoform B', 39, NULL, NULL, 222443),
(222444, '3.30.1510.10-FF-000017', NULL, 'Formate-tetrahydrofolate ligase', 91, NULL, NULL, 222444),
(222445, '2.30.310.10-FF-000006', NULL, 'Nuclear export mediator factor', 161, NULL, NULL, 222445),
(222446, '3.30.200.20-FF-001436', NULL, 'Probable ethanolamine kinase', 63, NULL, NULL, 222446),
(222447, '3.40.1090.10-FF-000038', NULL, 'Patatin-like phospholipase domain-containing protein', 109, NULL, NULL, 222447),
(222448, '1.10.238.10-FF-001116', NULL, 'Uncharacterized protein', 45, NULL, NULL, 222448),
(222449, '3.40.50.10130-FF-000070', NULL, 'DNA excision repair protein ERCC-1-like Protein', 54, NULL, NULL, 222449),
(222450, '3.10.350.10-FF-000009', NULL, 'Uncharacterized protein, isoform W', 72, NULL, NULL, 222450),
(222451, '2.60.40.1760-FF-000017', NULL, 'Acid Alpha Glucosidase Relate', 299, NULL, NULL, 222451),
(222452, '1.50.40.10-FF-000339', NULL, 'Uncharacterized protein', 108, NULL, NULL, 222452),
(222453, '1.20.58.1470-FF-000001', NULL, 'FTO, alpha-ketoglutarate dependent dioxygenase', 134, NULL, NULL, 222453),
(222454, '1.10.150.280-FF-000007', NULL, 'Kinesin-like protein Nod', 76, NULL, NULL, 222454),
(222455, '1.10.30.10-FF-000178', NULL, 'High mobility group protein', 79, NULL, NULL, 222455),
(222456, '3.40.1190.20-FF-000195', NULL, NULL, 252, NULL, NULL, 222456),
(222457, '1.10.640.10-FF-000079', NULL, 'Uncharacterized protein', 262, NULL, NULL, 222457),
(222458, '3.40.50.300-FF-003215', NULL, 'Si:dkey-187j14.8', 191, NULL, NULL, 222458),
(222459, '3.10.110.10-FF-000014', NULL, 'Baculoviral IAP repeat-containing protein 6', 300, NULL, NULL, 222459),
(222460, '2.130.10.10-FF-003833', NULL, 'Uncharacterized protein', 298, NULL, NULL, 222460),
(222461, '3.30.505.10-FF-000039', NULL, 'src-like-adapter isoform X1', 97, NULL, NULL, 222461),
(222462, '2.60.120.290-FF-000110', NULL, 'GD12774', 120, NULL, NULL, 222462),
(222463, '1.10.287.40-FF-000007', NULL, 'Seryl-tRNA synthetase, putative', 137, NULL, NULL, 222463),
(222464, '3.40.50.200-FF-000195', NULL, 'p-domain proprotein convertase, putative', 113, NULL, NULL, 222464),
(222465, '3.30.450.30-FF-000070', NULL, 'Uncharacterized protein', 141, NULL, NULL, 222465),
(222466, '4.10.860.120-FF-000005', NULL, 'DNA-directed RNA polymerase subunit', 122, NULL, NULL, 222466),
(222467, '1.20.5.110-FF-000354', NULL, 'Calpain-3', 43, NULL, NULL, 222467),
(222468, '2.40.37.10-FF-000010', NULL, 'Ornithine decarboxylase', 149, NULL, NULL, 222468);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(222469, '3.30.70.330-FF-001555', NULL, 'Uncharacterized protein', 137, NULL, NULL, 222469),
(222470, '2.60.40.10-FF-005199', NULL, NULL, 116, NULL, NULL, 222470),
(222471, '3.30.70.1230-FF-000180', NULL, 'Predicted protein', 178, NULL, NULL, 222471),
(222472, '2.160.20.10-FF-000207', NULL, 'Predicted protein', 370, NULL, NULL, 222472),
(222473, '3.40.50.720-FF-000929', NULL, 'Oxidoreductase, short-chain dehydrogenase/reductase family', 261, NULL, NULL, 222473),
(222474, '3.30.1370.240-FF-000003', NULL, 'Phenylalanyl-tRNA synthetase beta chain cytoplasmic', 88, NULL, NULL, 222474),
(222475, '2.10.25.10-FF-001670', NULL, 'Uncharacterized protein', 45, NULL, NULL, 222475),
(222476, '1.10.510.10-FF-003852', NULL, NULL, 103, NULL, NULL, 222476),
(222477, '1.10.10.10-FF-000620', NULL, 'Homeodomain-like/winged-helix DNA-binding family protein', 96, NULL, NULL, 222477),
(222478, '3.40.50.150-FF-000388', NULL, 'U6 small nuclear RNA (adenine-(43)-N(6))-methyltransferase', 260, NULL, NULL, 222478),
(222479, '3.30.70.1450-FF-000021', NULL, 'Probable sodium/sulfate cotransporter 3', 74, NULL, NULL, 222479),
(222480, '3.60.15.10-FF-000164', NULL, 'Uncharacterized protein', 29, NULL, NULL, 222480),
(222481, '1.10.275.40-FF-000014', NULL, 'Uncharacterized protein', 157, NULL, NULL, 222481),
(222482, '3.30.160.60-FF-006267', NULL, NULL, 22, NULL, NULL, 222482),
(222483, '1.25.40.690-FF-000018', NULL, 'Uncharacterized protein', 92, NULL, NULL, 222483),
(222484, '3.90.550.10-FF-000271', NULL, 'Hyaluronan synthase', 199, NULL, NULL, 222484),
(222485, '1.10.357.10-FF-000004', NULL, 'Ubiquinone biosynthesis protein COQ9, mitochondrial', 187, NULL, NULL, 222485),
(222486, '2.60.120.260-FF-000455', NULL, 'Predicted protein', 133, NULL, NULL, 222486),
(222487, '3.10.310.10-FF-000013', NULL, 'Phenazine biosynthesis-like domain-containing protein 1', 152, NULL, NULL, 222487),
(222488, '3.40.640.10-FF-000183', NULL, '2-aminoethylphosphonate--pyruvate transaminase', 246, NULL, NULL, 222488),
(222489, '3.50.4.10-FF-000028', NULL, 'Uncharacterized protein', 78, NULL, NULL, 222489),
(222490, '1.25.40.10-FF-005299', NULL, 'Uncharacterized protein', 132, NULL, NULL, 222490),
(222491, '2.70.130.10-FF-000152', NULL, NULL, 135, NULL, NULL, 222491),
(222492, '1.20.930.40-FF-000001', NULL, 'N-acetylated-alpha-linked acidic dipeptidase 2', 152, NULL, NULL, 222492),
(222493, '2.30.29.30-FF-000986', NULL, 'Tyrosine-protein kinase', 152, NULL, NULL, 222493),
(222494, '3.80.10.10-FF-003457', NULL, 'Uncharacterized protein', 239, NULL, NULL, 222494),
(222495, '1.20.1070.10-FF-000032', NULL, 'Vasoactive intestinal polypeptide receptor 1', 294, NULL, NULL, 222495),
(222496, '1.10.1200.80-FF-000009', NULL, 'tRNA-dihydrouridine synthase', 79, NULL, NULL, 222496),
(222497, '2.60.40.10-FF-004693', NULL, NULL, 74, NULL, NULL, 222497),
(222498, '2.60.40.10-FF-001944', NULL, 'Hemicentin 2', 98, NULL, NULL, 222498),
(222499, '3.40.50.300-FF-006088', NULL, 'ADP-ribosylation factor-like 3, like 2', 102, NULL, NULL, 222499),
(222500, '2.20.100.10-FF-000010', NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 9', 57, NULL, NULL, 222500),
(222501, '2.60.40.150-FF-000672', NULL, 'Uncharacterized protein', 57, NULL, NULL, 222501),
(222502, '3.40.50.2000-FF-000470', NULL, 'Alpha,alpha-trehalose-phosphate synthase [UDP-forming] B', 277, NULL, NULL, 222502),
(222503, '3.40.50.720-FF-001205', NULL, 'Probable short-chain type dehydrogenase/reductase VdlC', 253, NULL, NULL, 222503),
(222504, '3.30.379.10-FF-000009', NULL, 'Beta-N-acetylhexosaminidase', 126, NULL, NULL, 222504),
(222505, '1.25.40.10-FF-004462', NULL, 'Uncharacterized protein', 110, NULL, NULL, 222505),
(222506, '3.40.50.2300-FF-001307', NULL, NULL, 252, NULL, NULL, 222506),
(222507, '3.30.559.10-FF-000214', NULL, 'Uncharacterized protein', 194, NULL, NULL, 222507),
(222508, '3.40.190.10-FF-000889', NULL, 'Transcriptional regulator LysR family', 91, NULL, NULL, 222508),
(222509, '3.40.50.11040-FF-000011', NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', 209, NULL, NULL, 222509);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(222510, '3.40.50.10190-FF-000278', NULL, 'Uncharacterized protein', 91, NULL, NULL, 222510),
(222511, '3.30.70.330-FF-000032', NULL, 'Polypyrimidine tract-binding protein 2 isoform 1', 123, NULL, NULL, 222511),
(222512, '1.10.287.1490-FF-000117', NULL, 'Coiled-coil domain-containing protein 102A, putative', 108, NULL, NULL, 222512),
(222513, '1.25.40.10-FF-003169', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 112, NULL, NULL, 222513),
(222514, '3.40.850.10-FF-000226', NULL, 'Kinesin-like protein', 386, NULL, NULL, 222514),
(222515, '3.40.50.300-FF-005924', NULL, 'Uncharacterized protein', 283, NULL, NULL, 222515),
(222516, '1.20.1250.60-FF-000004', NULL, 'Interferon lambda-3', 158, NULL, NULL, 222516),
(222517, '2.60.120.230-FF-000019', NULL, NULL, 93, NULL, NULL, 222517),
(222518, '2.60.40.10-FF-004350', NULL, NULL, 202, NULL, NULL, 222518),
(222519, '1.10.1620.20-FF-000001', NULL, 'ATP synthase subunit epsilon, mitochondrial', 50, NULL, NULL, 222519),
(222520, '2.130.10.10-FF-002872', NULL, 'Predicted protein', 117, NULL, NULL, 222520),
(222521, '1.20.1110.10-FF-000199', NULL, NULL, 113, NULL, NULL, 222521),
(222522, '1.10.630.10-FF-000578', NULL, 'Cytochrome P450, putative', 307, NULL, NULL, 222522),
(222523, '2.70.150.10-FF-000260', NULL, 'Uncharacterized protein', 159, NULL, NULL, 222523),
(222524, '2.60.120.40-FF-000039', NULL, 'Tumor necrosis factor (Ligand) superfamily member 4', 152, NULL, NULL, 222524),
(222525, '1.20.1070.10-FF-000936', NULL, 'Predicted protein', 368, NULL, NULL, 222525),
(222526, '2.70.98.10-FF-000059', NULL, 'Putative alpha-1,2-mannosidase', 267, NULL, NULL, 222526),
(222527, '2.60.40.10-FF-001040', NULL, 'Microfibrillar-associated protein 3-like protein', 103, NULL, NULL, 222527),
(222528, '3.30.450.40-FF-000292', NULL, 'Phosphodiesterase', 22, NULL, NULL, 222528),
(222529, '2.30.130.40-FF-000001', NULL, 'Lon protease', 118, NULL, NULL, 222529),
(222530, '3.40.50.300-FF-007599', NULL, 'Protein-tyrosine sulfotransferase', 163, NULL, NULL, 222530),
(222531, '1.20.58.60-FF-000531', NULL, 'Uncharacterized protein', 184, NULL, NULL, 222531),
(222532, '3.20.20.70-FF-000802', NULL, NULL, 155, NULL, NULL, 222532),
(222533, '2.60.40.10-FF-004018', NULL, NULL, 98, NULL, NULL, 222533),
(222534, '1.10.10.10-FF-000963', NULL, 'Two-component response transcriptional regulator', 108, NULL, NULL, 222534),
(222535, '2.60.120.380-FF-000036', NULL, 'Calpain 3b', 156, NULL, NULL, 222535),
(222536, '3.30.160.60-FF-005648', NULL, NULL, 53, NULL, NULL, 222536),
(222537, '3.50.50.100-FF-000005', NULL, 'NADH-ubiquinone oxidoreductase 64 kDa subunit', 152, NULL, NULL, 222537),
(222538, '1.10.20.120-FF-000016', NULL, 'AAL125Wp', 103, NULL, NULL, 222538),
(222539, '1.25.10.10-FF-002037', NULL, 'Armadillo/beta-catenin-like repeat, putative', 124, NULL, NULL, 222539),
(222540, '2.30.30.100-FF-000105', NULL, 'Lsm10', 79, NULL, NULL, 222540),
(222541, '1.20.120.290-FF-000007', NULL, 'Peptidyl-prolyl cis-trans isomerase TLP38, chloroplast', 106, NULL, NULL, 222541),
(222542, '1.10.10.350-FF-000027', NULL, NULL, 94, NULL, NULL, 222542),
(222543, '2.60.40.10-FF-005311', NULL, NULL, 79, NULL, NULL, 222543),
(222544, '3.30.830.10-FF-000059', NULL, 'Mitochondrial-processing peptidase subunit alpha-1', 213, NULL, NULL, 222544),
(222545, '2.60.40.10-FF-002905', NULL, 'Tyrosine-protein kinase receptor', 101, NULL, NULL, 222545),
(222546, '3.30.200.20-FF-002493', NULL, 'Uncharacterized protein', 124, NULL, NULL, 222546),
(222547, '2.80.10.50-FF-000189', NULL, 'Uncharacterized protein', 125, NULL, NULL, 222547),
(222548, '3.40.1780.10-FF-000001', NULL, 'S-adenosylmethionine:tRNA ribosyltransferase-isomerase', 220, NULL, NULL, 222548),
(222549, '2.40.50.140-FF-000821', NULL, NULL, 109, NULL, NULL, 222549),
(222550, '2.30.29.240-FF-000010', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 218, NULL, NULL, 222550),
(222551, '4.10.60.10-FF-000162', NULL, 'Uncharacterized protein', 62, NULL, NULL, 222551),
(222552, '1.10.8.1190-FF-000004', NULL, 'Replicase polyprotein 1a', 123, NULL, NULL, 222552);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(222553, '3.40.50.10490-FF-000031', NULL, 'Glucose-6-phosphate isomerase', 213, NULL, NULL, 222553),
(222554, '3.30.710.10-FF-000005', NULL, 'Potassium channel tetramerization domain-containing 17', 70, NULL, NULL, 222554),
(222555, '3.40.50.720-FF-001880', NULL, 'Fatty acyl-CoA reductase', 344, NULL, NULL, 222555),
(222556, '1.20.120.1750-FF-000037', NULL, 'RBR-type E3 ubiquitin transferase', 219, NULL, NULL, 222556),
(222557, '1.10.3730.20-FF-000015', NULL, 'UDP-galactose transporter 1-like', 112, NULL, NULL, 222557),
(222558, '3.30.1460.20-FF-000010', NULL, 'Arp2/3 complex 34 kDa subunit', 132, NULL, NULL, 222558),
(222559, '3.30.420.40-FF-000121', NULL, 'Actin-related protein 8', 71, NULL, NULL, 222559),
(222560, '1.20.1070.10-FF-001212', NULL, 'Uncharacterized protein', 240, NULL, NULL, 222560),
(222561, '3.20.80.10-FF-000024', NULL, 'Heme-binding protein 2', 171, NULL, NULL, 222561),
(222562, '3.40.50.720-FF-000587', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', 206, NULL, NULL, 222562),
(222563, '3.40.50.2000-FF-000138', NULL, 'Glycosyltransferase', 182, NULL, NULL, 222563),
(222564, '3.40.390.10-FF-000202', NULL, NULL, 230, NULL, NULL, 222564),
(222565, '2.20.70.10-FF-000144', NULL, 'Pre-mRNA-processing factor 40 homolog A', 44, NULL, NULL, 222565),
(222566, '3.90.190.10-FF-000187', NULL, 'Tyrosine phosphatase family, putative', 178, NULL, NULL, 222566),
(222567, '1.20.1560.10-FF-000682', NULL, 'Uncharacterized protein', 12, NULL, NULL, 222567),
(222568, '3.80.10.10-FF-002153', NULL, 'Predicted protein', 277, NULL, NULL, 222568),
(222569, '1.10.10.60-FF-000045', NULL, 'RNA polymerase sigma-54 factor', 65, NULL, NULL, 222569),
(222570, '2.130.10.10-FF-000056', NULL, 'Polycomb protein eed', 368, NULL, NULL, 222570),
(222571, '3.40.50.300-FF-000455', NULL, 'Phosphate starvation-inducible ATPase PhoH', 209, NULL, NULL, 222571),
(222572, '2.60.40.10-FF-000764', NULL, 'CXADR like membrane protein', 115, NULL, NULL, 222572),
(222573, '1.10.472.80-FF-000287', NULL, NULL, 39, NULL, NULL, 222573),
(222574, '3.40.50.2300-FF-000689', NULL, 'Glutamate receptor', 152, NULL, NULL, 222574),
(222575, '1.20.5.190-FF-000102', NULL, NULL, 61, NULL, NULL, 222575),
(222576, '1.25.40.10-FF-001589', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform A', 167, NULL, NULL, 222576),
(222577, '3.90.930.12-FF-000027', NULL, NULL, 89, NULL, NULL, 222577),
(222578, '2.130.10.10-FF-005963', NULL, 'Predicted protein', 244, NULL, NULL, 222578),
(222579, '3.40.630.40-FF-000005', NULL, 'N-acetylmuramoyl-L-alanine amidase (AmiA)', 224, NULL, NULL, 222579),
(222580, '3.10.110.10-FF-000357', NULL, 'Si:ch1073-205c8.3', 46, NULL, NULL, 222580),
(222581, '3.80.10.10-FF-000023', NULL, 'Leucine rich repeats and immunoglobulin like domains 3', 124, NULL, NULL, 222581),
(222582, '3.10.150.10-FF-000011', NULL, 'Proliferating cell nuclear antigen', 163, NULL, NULL, 222582),
(222583, '1.20.5.170-FF-000220', NULL, 'Mitotic checkpoint protein MAD1', 39, NULL, NULL, 222583),
(222584, '3.60.21.10-FF-000330', NULL, 'Acid sphingomyelinase-like phosphodiesterase 3a', 269, NULL, NULL, 222584),
(222585, '3.30.70.960-FF-000002', NULL, 'Interphotoreceptor matrix proteoglycan 2', 98, NULL, NULL, 222585),
(222586, '1.10.357.40-FF-000002', NULL, 'FHA domain-containing protein', 178, NULL, NULL, 222586),
(222587, '3.10.460.10-FF-000001', NULL, 'Matrix protein', 182, NULL, NULL, 222587),
(222588, '1.20.120.530-FF-000018', NULL, 'Transcriptional regulator, GntR family', 143, NULL, NULL, 222588),
(222589, '1.10.533.10-FF-000111', NULL, 'astrocytic phosphoprotein PEA-15 isoform X2', 35, NULL, NULL, 222589),
(222590, '2.60.40.10-FF-005654', NULL, NULL, 90, NULL, NULL, 222590),
(222591, '2.30.29.230-FF-000018', NULL, 'Uncharacterized protein', 198, NULL, NULL, 222591),
(222592, '3.40.50.300-FF-006762', NULL, 'Uncharacterized protein, isoform I', 63, NULL, NULL, 222592),
(222593, '3.30.70.270-FF-000003', NULL, 'Transposon Ty3-G Gag-Pol polyprotein', 101, NULL, NULL, 222593),
(222594, '2.60.40.10-FF-000983', NULL, 'titin isoform X1', 98, NULL, NULL, 222594);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(222595, '3.30.420.40-FF-000340', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', 149, NULL, NULL, 222595),
(222596, '1.25.40.10-FF-003624', NULL, 'Pentatricopeptide repeat-containing protein', 98, NULL, NULL, 222596),
(222597, '2.60.40.10-FF-001601', NULL, 'Roundabout guidance receptor 2', 37, NULL, NULL, 222597),
(222598, '1.10.150.250-FF-000009', NULL, NULL, 86, NULL, NULL, 222598),
(222599, '2.60.40.150-FF-000216', NULL, 'Perforin-1 precursor', 126, NULL, NULL, 222599),
(222600, '2.60.40.1730-FF-000019', NULL, 'Aminopeptidase', 188, NULL, NULL, 222600),
(222601, '3.40.33.10-FF-000055', NULL, 'MIP16674p', 225, NULL, NULL, 222601),
(222602, '1.20.1500.20-FF-000001', NULL, 'DEAD/DEAH box RNA helicase', 85, NULL, NULL, 222602),
(222603, '1.10.275.10-FF-000016', NULL, 'Histidine ammonia-lyase', 224, NULL, NULL, 222603),
(222604, '2.30.29.30-FF-000082', NULL, 'Docking protein 5', 103, NULL, NULL, 222604),
(222605, '1.20.1070.10-FF-000251', NULL, 'Sphingosine 1-phosphate receptor 5', 312, NULL, NULL, 222605),
(222606, '2.10.25.10-FF-001091', NULL, 'Si:ch211-241f5.3', 43, NULL, NULL, 222606),
(222607, '2.10.110.10-FF-000232', NULL, 'LIM and PET domains protein', 60, NULL, NULL, 222607),
(222608, '1.10.10.60-FF-001006', NULL, NULL, 54, NULL, NULL, 222608),
(222609, '3.30.1330.40-FF-000012', NULL, 'diphthine--ammonia ligase isoform X1', 111, NULL, NULL, 222609),
(222610, '3.40.50.300-FF-005469', NULL, 'ABC Transporter family', 222, NULL, NULL, 222610),
(222611, '3.30.160.60-FF-002557', NULL, 'GH24059', 62, NULL, NULL, 222611),
(222612, '2.60.40.10-FF-000308', NULL, 'Down syndrome cell adhesion molecule, isoform D', 88, NULL, NULL, 222612),
(222613, '2.130.10.10-FF-001017', NULL, 'Dynein axonemal intermediate chain 2', 184, NULL, NULL, 222613),
(222614, '2.40.10.10-FF-000089', NULL, 'Mannan-binding lectin serine protease 2', 133, NULL, NULL, 222614),
(222615, '1.10.510.10-FF-001379', NULL, 'Myosin light chain kinase, putative', 240, NULL, NULL, 222615),
(222616, '3.90.190.10-FF-000529', NULL, 'Uncharacterized protein', 217, NULL, NULL, 222616),
(222617, '3.90.190.20-FF-000066', NULL, 'Uncharacterized protein', 106, NULL, NULL, 222617),
(222618, '3.40.50.150-FF-000949', NULL, 'Predicted protein', 273, NULL, NULL, 222618),
(222619, '2.130.10.10-FF-002310', NULL, 'Pre-mRNA-processing factor 19', 183, NULL, NULL, 222619),
(222620, '3.30.70.330-FF-000375', NULL, 'RNA binding fox-1 homolog 1', 104, NULL, NULL, 222620),
(222621, '1.20.58.120-FF-000014', NULL, NULL, 111, NULL, NULL, 222621),
(222622, '3.20.20.80-FF-000682', NULL, 'Uncharacterized protein', 326, NULL, NULL, 222622),
(222623, '3.30.40.10-FF-000504', NULL, 'E3 ubiquitin-protein ligase arkadia', 83, NULL, NULL, 222623),
(222624, '1.10.510.10-FF-002672', NULL, 'Cdc7 kinase, isoform A', 285, NULL, NULL, 222624),
(222625, '3.20.20.60-FF-000125', NULL, 'Isocitrate lyase', 156, NULL, NULL, 222625),
(222626, '3.30.1390.20-FF-000015', NULL, '60S ribosomal protein L7-1 isoform A', 56, NULL, NULL, 222626),
(222627, '1.25.10.10-FF-001998', NULL, 'Armadillo-type protein', 282, NULL, NULL, 222627),
(222628, '2.40.160.210-FF-000003', NULL, 'Acyl-CoA thioesterase II', 291, NULL, NULL, 222628),
(222629, '3.40.50.970-FF-000066', NULL, '2-succinyl-5-enolpyruvyl-6-hydroxy-3-cyclohexene-1-carboxylate synthase', 207, NULL, NULL, 222629),
(222630, '3.40.50.720-FF-001548', NULL, 'Short-chain dehydrogenase/reductase, putative', 257, NULL, NULL, 222630),
(222631, '1.25.10.10-FF-002616', NULL, 'Importin subunit beta-5', 987, NULL, NULL, 222631),
(222632, '3.40.50.300-FF-000798', NULL, 'Probable helicase senataxin', 390, NULL, NULL, 222632),
(222633, '3.30.980.10-FF-000047', NULL, 'Uncharacterized protein', 86, NULL, NULL, 222633),
(222634, '3.30.230.120-FF-000017', NULL, NULL, 81, NULL, NULL, 222634),
(222635, '1.10.490.10-FF-000027', NULL, 'Flavohemoprotein', 78, NULL, NULL, 222635),
(222636, '3.30.1330.60-FF-000018', NULL, 'Major outer membrane protein OmpA', 144, NULL, NULL, 222636),
(222637, '3.40.50.300-FF-001074', NULL, 'Nucleotide binding oligomerization domain containing 1', 218, NULL, NULL, 222637);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(222638, '3.40.50.150-FF-001225', NULL, NULL, 146, NULL, NULL, 222638),
(222639, '2.30.29.30-FF-000767', NULL, 'sprouty-related, EVH1 domain-containing protein 2-like', 119, NULL, NULL, 222639),
(222640, '2.120.10.30-FF-000023', NULL, 'Serum paraoxonase/arylesterase 2', 336, NULL, NULL, 222640),
(222641, '2.130.10.10-FF-000399', NULL, 'Ribosome biogenesis protein WDR12 homolog', 335, NULL, NULL, 222641),
(222642, '3.40.470.10-FF-000023', NULL, NULL, 126, NULL, NULL, 222642),
(222643, '2.40.10.10-FF-000307', NULL, 'Zgc:165423 protein', 211, NULL, NULL, 222643),
(222644, '3.30.70.2850-FF-000002', NULL, 'DNA-directed RNA polymerase subunit', 151, NULL, NULL, 222644),
(222645, '1.20.58.570-FF-000002', NULL, 'F-actin-capping protein subunit beta', 87, NULL, NULL, 222645),
(222646, '3.30.260.10-FF-000026', NULL, 'T-complex protein 1, zeta subunit', 108, NULL, NULL, 222646),
(222647, '3.90.120.10-FF-000019', NULL, 'Uncharacterized protein', 101, NULL, NULL, 222647),
(222648, '3.40.50.11030-FF-000019', NULL, NULL, 136, NULL, NULL, 222648),
(222649, '2.60.40.10-FF-002220', NULL, 'Cell surface protein', 101, NULL, NULL, 222649),
(222650, '3.20.20.30-FF-000021', NULL, 'Alkanesulfonate monooxygenase SsuD/methylene tetrahydromethanopterin reductase-like flavin-dependent oxidoreductase (Luciferase family)', 357, NULL, NULL, 222650),
(222651, '1.20.120.1200-FF-000007', NULL, 'NADH-quinone oxidoreductase subunit J', 160, NULL, NULL, 222651),
(222652, '2.30.29.30-FF-001043', NULL, 'Uncharacterized protein', 79, NULL, NULL, 222652),
(222653, '3.30.160.20-FF-000196', NULL, 'Uncharacterized protein', 66, NULL, NULL, 222653),
(222654, '3.40.395.10-FF-000050', NULL, 'Predicted protein', 205, NULL, NULL, 222654),
(222655, '3.30.460.80-FF-000006', NULL, 'NADH-quinone oxidoreductase subunit C', 147, NULL, NULL, 222655),
(222656, '2.60.120.650-FF-000140', NULL, 'tRNA wybutosine-synthesizing protein 5', 262, NULL, NULL, 222656),
(222657, '3.10.280.10-FF-000015', NULL, 'Hypothetical_protein_-_conserved', 191, NULL, NULL, 222657),
(222658, '1.20.1110.10-FF-000075', NULL, 'Calcium-transporting ATPase', 152, NULL, NULL, 222658),
(222659, '1.10.520.10-FF-000025', NULL, 'Ascorbate peroxidase', 130, NULL, NULL, 222659),
(222660, '1.10.10.60-FF-000388', NULL, 'Transcription factor RAX2', 67, NULL, NULL, 222660),
(222661, '2.130.10.10-FF-001692', NULL, 'Vps15p', 125, NULL, NULL, 222661),
(222662, '2.40.50.140-FF-000602', NULL, 'Unplaced genomic scaffold supercont2.11, whole genome shotgun sequence', 98, NULL, NULL, 222662),
(222663, '3.30.420.40-FF-000464', NULL, 'Actin-related protein 8', 115, NULL, NULL, 222663),
(222664, '3.30.450.50-FF-000058', NULL, 'Uncharacterized protein', 138, NULL, NULL, 222664),
(222665, '4.10.1000.10-FF-000050', NULL, 'AGAP008634-PA', 65, NULL, NULL, 222665),
(222666, '3.30.230.10-FF-000311', NULL, 'Uncharacterized protein', 155, NULL, NULL, 222666),
(222667, '2.170.180.11-FF-000003', NULL, 'GD11003', 120, NULL, NULL, 222667),
(222668, '1.10.1040.50-FF-000027', NULL, NULL, 206, NULL, NULL, 222668),
(222669, '3.80.10.10-FF-002496', NULL, 'Ras guanine nucleotide exchange factor V', 133, NULL, NULL, 222669),
(222670, '2.120.10.30-FF-000147', NULL, 'Unplaced genomic scaffold supercont1.9, whole genome shotgun sequence', 305, NULL, NULL, 222670),
(222671, '3.30.160.60-FF-002433', NULL, 'Zinc finger protein 1168', 27, NULL, NULL, 222671),
(222672, '3.20.20.140-FF-000445', NULL, 'Non-ATP-dependent L-selective hydantoinase, putative', 75, NULL, NULL, 222672),
(222673, '2.30.30.140-FF-000089', NULL, 'Male-specific lethal 3', 59, NULL, NULL, 222673),
(222674, '1.10.510.10-FF-002216', NULL, 'Uncharacterized protein', 193, NULL, NULL, 222674),
(222675, '3.40.1110.10-FF-000086', NULL, 'Phospholipid-transporting ATPase', 157, NULL, NULL, 222675),
(222676, '1.10.8.750-FF-000003', NULL, 'Probable phosphoribosylformylglycinamidine synthase', 77, NULL, NULL, 222676),
(222677, '3.30.160.60-FF-005867', NULL, NULL, 52, NULL, NULL, 222677),
(222678, '2.70.170.10-FF-000273', NULL, 'SD10415p', 109, NULL, NULL, 222678);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(222679, '3.20.20.80-FF-000007', NULL, 'Acidic mammalian chitinase', 274, NULL, NULL, 222679),
(222680, '2.40.30.130-FF-000033', NULL, 'Alanine--tRNA ligase', 79, NULL, NULL, 222680),
(222681, '3.40.50.300-FF-000427', NULL, 'Cytosolic Fe-S cluster assembly factor NUBP1', 264, NULL, NULL, 222681),
(222682, '1.10.510.10-FF-001053', NULL, 'Related to VPS15-ser/thr protein kinase', 216, NULL, NULL, 222682),
(222683, '1.10.472.10-FF-000019', NULL, 'transcription initiation factor IIB', 108, NULL, NULL, 222683),
(222684, '3.10.580.10-FF-000139', NULL, 'Uncharacterized protein', 129, NULL, NULL, 222684),
(222685, '3.10.450.50-FF-000006', NULL, 'NTF2-related export protein 2 isoform 1', 134, NULL, NULL, 222685),
(222686, '2.130.10.10-FF-002164', NULL, 'Telomerase protein component 1', 95, NULL, NULL, 222686),
(222687, '3.40.50.720-FF-001571', NULL, 'Uncharacterized protein', 242, NULL, NULL, 222687),
(222688, '3.40.50.880-FF-000112', NULL, 'Class I glutamine amidotransferase-like protein', 211, NULL, NULL, 222688),
(222689, '2.60.120.620-FF-000029', NULL, 'Probable prolyl 4-hydroxylase 12', 191, NULL, NULL, 222689),
(222690, '2.60.40.10-FF-001051', NULL, 'HERV-H LTR-associating 2', 91, NULL, NULL, 222690),
(222691, '3.40.50.1100-FF-000284', NULL, 'Uncharacterized protein', 32, NULL, NULL, 222691),
(222692, '3.40.50.300-FF-008504', NULL, 'UvrD/REP helicase domain protein, putative', 134, NULL, NULL, 222692),
(222693, '1.10.1420.10-FF-000185', NULL, 'MutS domain III family protein', 169, NULL, NULL, 222693),
(222694, '3.30.160.60-FF-003737', NULL, 'zinc finger protein 429-like isoform X1', 31, NULL, NULL, 222694),
(222695, '1.25.40.10-FF-001882', NULL, 'Uncharacterized protein', 59, NULL, NULL, 222695),
(222696, '2.40.50.140-FF-000310', NULL, 'Probable asparagine--tRNA ligase, mitochondrial', 101, NULL, NULL, 222696),
(222697, '1.10.510.10-FF-002155', NULL, 'Tyrosine kinase-like protein, putative', 282, NULL, NULL, 222697),
(222698, '2.40.10.10-FF-000044', NULL, 'polyserase-2 isoform X1', 228, NULL, NULL, 222698),
(222699, '3.90.1170.10-FF-000022', NULL, 'Uncharacterized protein', 134, NULL, NULL, 222699),
(222700, '3.40.50.1820-FF-001455', NULL, 'Uncharacterized protein', 183, NULL, NULL, 222700),
(222701, '3.40.50.12500-FF-000005', NULL, 'Hydantoin racemase', 214, NULL, NULL, 222701),
(222702, '3.60.21.10-FF-000364', NULL, 'Protein CBG18709', 137, NULL, NULL, 222702),
(222703, '1.25.10.10-FF-000273', NULL, 'Huntingtin', 334, NULL, NULL, 222703),
(222704, '1.10.10.10-FF-000154', NULL, 'DNA-binding transcriptional regulator ModE', 107, NULL, NULL, 222704),
(222705, '1.10.418.10-FF-000203', NULL, 'Uncharacterized protein', 117, NULL, NULL, 222705),
(222706, '2.120.10.80-FF-000302', NULL, 'Uncharacterized protein', 323, NULL, NULL, 222706),
(222707, '1.10.238.10-FF-000464', NULL, 'Ubiquitin carboxyl-terminal hydrolase cyk-3', 151, NULL, NULL, 222707),
(222708, '3.50.50.60-FF-001379', NULL, 'Uncharacterized protein', 74, NULL, NULL, 222708),
(222709, '2.40.70.10-FF-000053', NULL, 'Eukaryotic aspartyl protease family protein', 206, NULL, NULL, 222709),
(222710, '1.10.533.10-FF-000280', NULL, 'Uncharacterized protein', 95, NULL, NULL, 222710),
(222711, '3.30.40.10-FF-001516', NULL, 'Uncharacterized protein', 111, NULL, NULL, 222711),
(222712, '2.40.20.10-FF-000016', NULL, 'Coagulation factor XII', 87, NULL, NULL, 222712),
(222713, '3.30.497.10-FF-000008', NULL, 'antithrombin-III isoform X1', 223, NULL, NULL, 222713),
(222714, '3.40.50.300-FF-006413', NULL, 'Uncharacterized protein', 131, NULL, NULL, 222714),
(222715, '2.70.170.10-FF-000087', NULL, 'Gamma-aminobutyric acid type A receptor alpha6 subunit', 119, NULL, NULL, 222715),
(222716, '3.30.420.40-FF-000424', NULL, 'Chaperone protein dnaK, putative', 73, NULL, NULL, 222716),
(222717, '2.60.40.10-FF-004277', NULL, NULL, 102, NULL, NULL, 222717),
(222718, '3.30.160.60-FF-002635', NULL, 'Zinc finger protein 678', 42, NULL, NULL, 222718),
(222719, '1.10.10.10-FF-000800', NULL, 'Ubiquitin-protein ligase, putative', 88, NULL, NULL, 222719),
(222720, '3.30.160.60-FF-000983', NULL, 'zinc finger protein 385B isoform X1', 55, NULL, NULL, 222720);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(222721, '3.30.200.20-FF-002291', NULL, 'Non-specific serine/threonine protein kinase', 72, NULL, NULL, 222721),
(222722, '3.40.640.10-FF-000194', NULL, 'Predicted protein', 289, NULL, NULL, 222722),
(222723, '3.90.550.10-FF-000636', NULL, 'Uncharacterized protein', 181, NULL, NULL, 222723),
(222724, '3.10.20.90-FF-000404', NULL, 'Ubiquitin-like superfamily protein', 81, NULL, NULL, 222724),
(222725, '2.30.30.40-FF-000144', NULL, 'Disks large 1 isoform X3', 85, NULL, NULL, 222725),
(222726, '3.30.530.20-FF-000067', NULL, 'Aha1 domain-containing protein', 137, NULL, NULL, 222726),
(222727, '3.30.70.330-FF-001550', NULL, 'Putative splicing factor C222.18', 117, NULL, NULL, 222727),
(222728, '1.25.40.10-FF-000454', NULL, 'Pentatricopeptide repeat-containing protein At3g47530', 180, NULL, NULL, 222728),
(222729, '1.20.1250.20-FF-001690', NULL, 'Monocarboxylate transporter, putative', 126, NULL, NULL, 222729),
(222730, '3.40.50.1000-FF-000193', NULL, 'Plasma membrane calcium-transporting ATPase 2', 146, NULL, NULL, 222730),
(222731, '1.25.10.10-FF-000952', NULL, 'U-box domain-containing protein 4', 196, NULL, NULL, 222731),
(222732, '2.30.30.30-FF-000141', NULL, '60S ribosomal protein L14', 87, NULL, NULL, 222732),
(222733, '3.10.110.10-FF-000262', NULL, 'Ubiquitin protein ligase, putative', 128, NULL, NULL, 222733),
(222734, '1.20.1310.10-FF-000051', NULL, 'cullin homolog 1', 115, NULL, NULL, 222734),
(222735, '2.60.40.10-FF-003288', NULL, 'Uncharacterized protein', 83, NULL, NULL, 222735),
(222736, '3.30.565.10-FF-000560', NULL, 'Uncharacterized protein', 166, NULL, NULL, 222736),
(222737, '1.20.120.430-FF-000005', NULL, 'tRNA modification GTPase MnmE', 168, NULL, NULL, 222737),
(222738, '3.30.160.60-FF-004726', NULL, NULL, 66, NULL, NULL, 222738),
(222739, '3.40.630.30-FF-000435', NULL, 'Sll1552 protein', 108, NULL, NULL, 222739),
(222740, '1.25.40.790-FF-000003', NULL, 'CCR4-NOT transcription complex subunit 1', 288, NULL, NULL, 222740),
(222741, '1.10.510.10-FF-000390', NULL, 'Mitotic checkpoint serine/threonine-protein kinase BUB1', 303, NULL, NULL, 222741),
(222742, '3.30.70.1230-FF-000157', NULL, 'Uncharacterized protein', 121, NULL, NULL, 222742),
(222743, '3.30.450.40-FF-000252', NULL, 'Uncharacterized protein', 176, NULL, NULL, 222743),
(222744, '2.60.40.10-FF-002186', NULL, 'Sallimus, isoform P', 99, NULL, NULL, 222744),
(222745, '3.10.105.10-FF-000047', NULL, 'ABC transporter, substrate-binding protein, family 5', 227, NULL, NULL, 222745),
(222746, '3.80.10.10-FF-003378', NULL, 'Uncharacterized protein', 105, NULL, NULL, 222746),
(222747, '1.20.1280.50-FF-000099', NULL, 'F-box/kelch-repeat protein At1g51550', 90, NULL, NULL, 222747),
(222748, '1.25.40.20-FF-000457', NULL, 'Protein CBR-VAB-19', 248, NULL, NULL, 222748),
(222749, '3.30.160.60-FF-000657', NULL, 'GDNF inducible zinc finger protein 1', 29, NULL, NULL, 222749),
(222750, '1.10.110.10-FF-000016', NULL, 'Bifunctional inhibitor/lipid-transfer protein/seed storage 2S albumin superfamily protein', 74, NULL, NULL, 222750),
(222751, '1.20.1310.20-FF-000054', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 200, NULL, NULL, 222751),
(222752, '3.30.420.40-FF-000750', NULL, 'Patothenate kinase, fumble family protein', 170, NULL, NULL, 222752),
(222753, '1.20.1310.10-FF-000197', NULL, NULL, 83, NULL, NULL, 222753),
(222754, '3.30.160.60-FF-006290', NULL, NULL, 43, NULL, NULL, 222754),
(222755, '1.10.8.60-FF-000488', NULL, 'Uncharacterized protein', 91, NULL, NULL, 222755),
(222756, '3.40.1010.10-FF-000005', NULL, 'Ribosomal RNA small subunit methyltransferase I', 111, NULL, NULL, 222756),
(222757, '1.10.3720.10-FF-000197', NULL, 'ABC transporter permease protein', 205, NULL, NULL, 222757),
(222758, '3.30.200.20-FF-001829', NULL, 'Serine/threonine-protein kinase NEK', 30, NULL, NULL, 222758),
(222759, '1.25.10.10-FF-002397', NULL, 'Predicted protein', 259, NULL, NULL, 222759),
(222760, '3.90.1450.10-FF-000004', NULL, 'Uncharacterized protein', 86, NULL, NULL, 222760),
(222761, '1.25.40.10-FF-004523', NULL, 'Uncharacterized protein', 73, NULL, NULL, 222761);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(222762, '1.10.238.10-FF-000138', NULL, 'Calcium-binding mitochondrial carrier protein SCaMC-1', 76, NULL, NULL, 222762),
(222763, '3.40.50.300-FF-002518', NULL, 'Rhb1p', 186, NULL, NULL, 222763),
(222764, '3.30.9.90-FF-000006', NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase, mitochondrial', 30, NULL, NULL, 222764),
(222765, '1.10.760.10-FF-000110', NULL, 'Uncharacterized protein', 122, NULL, NULL, 222765),
(222766, '3.30.70.330-FF-002213', NULL, NULL, 100, NULL, NULL, 222766),
(222767, '1.10.10.720-FF-000003', NULL, 'Leucine--tRNA ligase', 54, NULL, NULL, 222767),
(222768, '2.120.10.30-FF-000074', NULL, 'Blast:Protein wech', 230, NULL, NULL, 222768),
(222769, '3.30.40.10-FF-000414', NULL, 'E3 ubiquitin protein ligase', 72, NULL, NULL, 222769),
(222770, '3.30.160.60-FF-000511', NULL, 'zinc finger protein 692 isoform X2', 23, NULL, NULL, 222770),
(222771, '3.30.40.10-FF-001842', NULL, 'Predicted protein', 85, NULL, NULL, 222771),
(222772, '2.60.40.150-FF-000059', NULL, 'Axin interactor, dorsalization-associated protein', 155, NULL, NULL, 222772),
(222773, '1.10.510.10-FF-002481', NULL, NULL, 142, NULL, NULL, 222773),
(222774, '1.10.730.10-FF-000075', NULL, 'Putative leucyl-tRNA synthetase', 166, NULL, NULL, 222774),
(222775, '1.10.630.10-FF-000657', NULL, 'Uncharacterized protein', 194, NULL, NULL, 222775),
(222776, '3.40.50.1820-FF-000320', NULL, 'Abhydrolase domain-containing protein abhd-5.2', 295, NULL, NULL, 222776),
(222777, '1.20.120.420-FF-000002', NULL, 'Methylthioribose-1-phosphate isomerase', 193, NULL, NULL, 222777),
(222778, '3.90.770.10-FF-000001', NULL, '3-hydroxy-3-methylglutaryl coenzyme A reductase', 212, NULL, NULL, 222778),
(222779, '3.30.540.10-FF-000003', NULL, 'Inositol-1-monophosphatase', 141, NULL, NULL, 222779),
(222780, '1.10.580.10-FF-000012', NULL, 'Citrate synthase', 218, NULL, NULL, 222780),
(222781, '3.40.50.150-FF-000186', NULL, 'Fatty acid synthase', 297, NULL, NULL, 222781),
(222782, '2.60.40.1180-FF-000141', NULL, 'Alpha-glucosidase 1', 156, NULL, NULL, 222782),
(222783, '1.10.10.10-FF-000480', NULL, 'Transcriptional regulator, AsnC family', 53, NULL, NULL, 222783),
(222784, '3.30.310.270-FF-000002', NULL, 'BicC family RNA binding protein 1', 133, NULL, NULL, 222784),
(222785, '3.40.50.2000-FF-000071', NULL, 'Glycosyltransferase', 266, NULL, NULL, 222785),
(222786, '3.30.1310.10-FF-000002', NULL, 'Nucleoid-associated protein IKC_06587', 107, NULL, NULL, 222786),
(222787, '3.90.79.10-FF-000153', NULL, 'Nudix hydrolase 7', 125, NULL, NULL, 222787),
(222788, '3.40.50.720-FF-000789', NULL, 'Sugar epimerase family protein', 249, NULL, NULL, 222788),
(222789, '3.40.720.10-FF-000195', NULL, 'Uncharacterized protein', 142, NULL, NULL, 222789),
(222790, '3.40.50.300-FF-006060', NULL, 'Uncharacterized protein', 66, NULL, NULL, 222790),
(222791, '3.10.170.20-FF-000009', NULL, 'Cell surface protease gp63, putative', 176, NULL, NULL, 222791),
(222792, '3.20.20.70-FF-000196', NULL, 'S-adenosyl-L-methionine-dependent tRNA 4-demethylwyosine synthase', 332, NULL, NULL, 222792),
(222793, '1.10.10.10-FF-001582', NULL, 'Transcriptional regulator', 67, NULL, NULL, 222793),
(222794, '2.30.180.10-FF-000086', NULL, 'FAS1 domain-containing protein', 187, NULL, NULL, 222794),
(222795, '3.30.70.330-FF-000122', NULL, 'Splicing factor U2AF small subunit', 101, NULL, NULL, 222795),
(222796, '1.20.58.1980-FF-000002', NULL, 'Kinesin-like_protein_-_putative', 122, NULL, NULL, 222796),
(222797, '1.10.510.10-FF-000710', NULL, 'Serine/threonine-protein kinase WAG1-like', 65, NULL, NULL, 222797),
(222798, '3.40.140.10-FF-000049', NULL, 'C->U-editing enzyme APOBEC-1 isoform X2', 174, NULL, NULL, 222798),
(222799, '1.20.1080.10-FF-000100', NULL, 'Uncharacterized protein', 184, NULL, NULL, 222799),
(222800, '3.30.160.60-FF-001500', NULL, 'Zinc finger protein 292', 33, NULL, NULL, 222800),
(222801, '1.10.472.80-FF-000259', NULL, NULL, 52, NULL, NULL, 222801),
(222802, '3.40.50.300-FF-008184', NULL, 'GTP-binding protein-related', 81, NULL, NULL, 222802),
(222803, '1.10.472.10-FF-000345', NULL, 'Cyclin-D2-1', 63, NULL, NULL, 222803);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(222804, '3.40.1700.10-FF-000007', NULL, 'Diadenylate cyclase', 150, NULL, NULL, 222804),
(222805, '3.80.10.10-FF-001933', NULL, 'Receptor-like protein kinase', 137, NULL, NULL, 222805),
(222806, '3.30.465.10-FF-000024', NULL, 'Oxidoreductase, FAD-binding protein', 202, NULL, NULL, 222806),
(222807, '3.30.830.10-FF-000076', NULL, 'Mitochondrial processing peptide beta subunit, putative', 224, NULL, NULL, 222807),
(222808, '3.40.50.1000-FF-000872', NULL, NULL, 60, NULL, NULL, 222808),
(222809, '3.90.940.10-FF-000008', NULL, 'DNA-directed RNA polymerase I, II, AND III, subunit 6', 99, NULL, NULL, 222809),
(222810, '3.40.50.1240-FF-000034', NULL, 'Transcription factor TFIIIC subunit', 268, NULL, NULL, 222810),
(222811, '1.10.510.10-FF-000917', NULL, 'Serine/threonine-protein kinase KIN3', 247, NULL, NULL, 222811),
(222812, '3.40.50.720-FF-001278', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', 199, NULL, NULL, 222812),
(222813, '3.90.70.10-FF-000633', NULL, 'General secretion pathway protein A', 118, NULL, NULL, 222813),
(222814, '3.90.1750.10-FF-000049', NULL, 'G2/M phase-specific E3 ubiquitin-protein ligase', 172, NULL, NULL, 222814),
(222815, '3.40.1650.10-FF-000008', NULL, 'Fucose-binding protein', 147, NULL, NULL, 222815),
(222816, '3.40.50.300-FF-000753', NULL, 'Polymerase (DNA directed), theta', 215, NULL, NULL, 222816),
(222817, '3.40.50.300-FF-003333', NULL, 'ATP-dependent DNA helicase', 178, NULL, NULL, 222817),
(222818, '3.30.70.20-FF-000071', NULL, 'Ferredoxin-type protein NapF', 37, NULL, NULL, 222818),
(222819, '3.40.50.300-FF-006559', NULL, 'Predicted protein', 104, NULL, NULL, 222819),
(222820, '3.30.450.30-FF-000069', NULL, 'Profilin', 126, NULL, NULL, 222820),
(222821, '2.40.50.140-FF-001092', NULL, NULL, 68, NULL, NULL, 222821),
(222822, '3.40.50.2020-FF-000077', NULL, 'Phosphoribosyl pyrophosphate synthetase 2', 33, NULL, NULL, 222822),
(222823, '3.80.10.10-FF-001254', NULL, 'GD14431', 122, NULL, NULL, 222823),
(222824, '3.50.50.60-FF-000131', NULL, '3-hydroxybenzoate 6-monooxygenase', 371, NULL, NULL, 222824),
(222825, '3.40.50.300-FF-002844', NULL, 'DNA mismatch repair protein', 307, NULL, NULL, 222825),
(222826, '2.60.40.10-FF-005120', NULL, NULL, 97, NULL, NULL, 222826),
(222827, '3.40.30.10-FF-000947', NULL, 'Uncharacterized protein', 108, NULL, NULL, 222827),
(222828, '3.30.505.10-FF-000225', NULL, NULL, 95, NULL, NULL, 222828),
(222829, '3.90.79.10-FF-000214', NULL, 'Nudix hydrolase 16 like 1', 74, NULL, NULL, 222829),
(222830, '1.10.10.10-FF-002071', NULL, 'Uncharacterized protein', 65, NULL, NULL, 222830),
(222831, '3.40.50.670-FF-000021', NULL, 'DNA gyrase subunit B', 34, NULL, NULL, 222831),
(222832, '1.10.510.10-FF-000238', NULL, 'Mitogen-activated protein kinase', 226, NULL, NULL, 222832),
(222833, '3.40.50.720-FF-001778', NULL, '2-dehydropantoate 2-reductase', 182, NULL, NULL, 222833),
(222834, '3.30.300.30-FF-000002', NULL, 'Long-chain fatty acid transport protein 1', 100, NULL, NULL, 222834),
(222835, '1.10.340.30-FF-000011', NULL, 'Adenine DNA glycosylase', 122, NULL, NULL, 222835),
(222836, '3.90.70.10-FF-000133', NULL, 'Ubiquitin specific peptidase 35', 361, NULL, NULL, 222836),
(222837, '1.20.1530.20-FF-000065', NULL, 'Cation/H(+) antiporter 20', 59, NULL, NULL, 222837),
(222838, '2.40.30.170-FF-000051', NULL, NULL, 70, NULL, NULL, 222838),
(222839, '3.90.230.10-FF-000062', NULL, NULL, 258, NULL, NULL, 222839),
(222840, '2.30.30.40-FF-000470', NULL, 'F-BAR and double SH3 domains protein 2 isoform X6', 74, NULL, NULL, 222840),
(222841, '3.30.1460.50-FF-000002', NULL, 'Autophagy related 10', 200, NULL, NULL, 222841),
(222842, '3.30.565.10-FF-000408', NULL, 'Uncharacterized protein', 124, NULL, NULL, 222842),
(222843, '1.20.5.110-FF-000236', NULL, 'Qc-SNARE protein, Bet1/mBET1 family', 64, NULL, NULL, 222843),
(222844, '3.40.50.150-FF-000865', NULL, 'Putative methyltransferase', 184, NULL, NULL, 222844),
(222845, '3.30.1340.10-FF-000004', NULL, 'HPr family phosphocarrier', 88, NULL, NULL, 222845),
(222846, '1.25.40.70-FF-000039', NULL, 'Protein CBG03566', 164, NULL, NULL, 222846);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(222847, '3.30.200.20-FF-001981', NULL, NULL, 124, NULL, NULL, 222847),
(222848, '3.40.50.300-FF-000692', NULL, 'Guanine nucleotide-binding protein subunit alpha', 207, NULL, NULL, 222848),
(222849, '3.80.10.10-FF-000152', NULL, 'F-box/LRR-repeat protein 4 isoform X1', 186, NULL, NULL, 222849),
(222850, '3.30.200.20-FF-000048', NULL, 'Non-specific serine/threonine protein kinase', 109, NULL, NULL, 222850),
(222851, '3.40.50.300-FF-003979', NULL, 'mRNA cleavage and polyadenylation factor CLP1', 248, NULL, NULL, 222851),
(222852, '3.10.300.10-FF-000006', NULL, 'DNA-3-methyladenine glycosylase family protein', 83, NULL, NULL, 222852),
(222853, '3.20.20.30-FF-000032', NULL, 'LLM class flavin-dependent oxidoreductase', 343, NULL, NULL, 222853),
(222854, '2.30.110.10-FF-000019', NULL, 'PNPO isoform 11', 123, NULL, NULL, 222854),
(222855, '1.25.40.530-FF-000004', NULL, 'Myosin VIIA', 173, NULL, NULL, 222855),
(222856, '2.130.10.10-FF-004255', NULL, 'Uncharacterized protein', 138, NULL, NULL, 222856),
(222857, '3.30.230.70-FF-000104', NULL, 'Uncharacterized protein', 283, NULL, NULL, 222857),
(222858, '3.40.50.12100-FF-000008', NULL, 'Uncharacterized protein', 72, NULL, NULL, 222858),
(222859, '1.25.40.20-FF-000783', NULL, 'Uncharacterized protein', 190, NULL, NULL, 222859),
(222860, '1.10.10.440-FF-000043', NULL, 'Unplaced genomic scaffold supercont1.18, whole genome shotgun sequence', 75, NULL, NULL, 222860),
(222861, '3.40.50.1820-FF-001629', NULL, 'Uncharacterized protein', 467, NULL, NULL, 222861),
(222862, '3.30.450.200-FF-000017', NULL, NULL, 181, NULL, NULL, 222862),
(222863, '1.10.510.10-FF-004279', NULL, NULL, 176, NULL, NULL, 222863),
(222864, '1.20.1270.280-FF-000045', NULL, 'Uncharacterized protein', 192, NULL, NULL, 222864),
(222865, '3.30.40.10-FF-000999', NULL, 'RING-H2_zinc_finger/Ring_finger_domain/Anaphase-promoting_complex_subunit_11_RING-H2_finger/Zinc_finger', 77, NULL, NULL, 222865),
(222866, '3.40.50.2300-FF-001173', NULL, NULL, 120, NULL, NULL, 222866),
(222867, '1.25.40.540-FF-000007', NULL, 'TAP42p protein', 234, NULL, NULL, 222867),
(222868, '3.40.190.290-FF-000072', NULL, 'LysR family transcriptional regulator', 214, NULL, NULL, 222868),
(222869, '4.10.400.10-FF-000117', NULL, 'Suppressor of tumorigenicity 14 protein homolog', 37, NULL, NULL, 222869),
(222870, '3.10.100.10-FF-000025', NULL, 'Mannose receptor C-type 1', 152, NULL, NULL, 222870),
(222871, '2.10.50.10-FF-000087', NULL, 'Tumor necrosis factor receptor superfamily member 23', 60, NULL, NULL, 222871),
(222872, '3.30.750.24-FF-000026', NULL, 'Sulfate transporter, putative', 95, NULL, NULL, 222872),
(222873, '2.60.40.2030-FF-000020', NULL, 'Adhesion G protein-coupled receptor V1', 135, NULL, NULL, 222873),
(222874, '2.60.40.10-FF-000915', NULL, 'Usherin', 102, NULL, NULL, 222874),
(222875, '1.25.40.10-FF-000780', NULL, 'Pentatricopeptide repeat-containing protein isoform A', 126, NULL, NULL, 222875),
(222876, '3.30.160.60-FF-006317', NULL, NULL, 30, NULL, NULL, 222876),
(222877, '3.30.160.60-FF-001000', NULL, 'Zinc finger and BTB domain-containing 40', 28, NULL, NULL, 222877),
(222878, '3.40.50.11040-FF-000005', NULL, 'RNA cytidine acetyltransferase', 213, NULL, NULL, 222878),
(222879, '2.30.30.30-FF-000080', NULL, 'Eukaryotic translation initiation factor 5A', 84, NULL, NULL, 222879),
(222880, '2.30.30.100-FF-000010', NULL, 'U6 snRNA-associated Sm-like protein LSm6', 78, NULL, NULL, 222880),
(222881, '3.40.50.1000-FF-000254', NULL, 'Phospholipid-transporting ATPase', 177, NULL, NULL, 222881),
(222882, '3.40.50.10470-FF-000025', NULL, '71 kDa subunit', 228, NULL, NULL, 222882),
(222883, '3.40.190.290-FF-000100', NULL, 'Transcriptional regulatory protein', 208, NULL, NULL, 222883),
(222884, '1.20.58.360-FF-000001', NULL, 'Probable E3 ubiquitin-protein ligase ipaH7.8', 134, NULL, NULL, 222884),
(222885, '2.60.40.10-FF-001697', NULL, 'Titin a', 103, NULL, NULL, 222885),
(222886, '3.30.830.10-FF-000222', NULL, 'Uncharacterized protein', 238, NULL, NULL, 222886),
(222887, '2.30.30.40-FF-000083', NULL, 'Tyrosine-protein kinase', 59, NULL, NULL, 222887);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(222888, '3.40.50.11030-FF-000002', NULL, 'Sua5/YciO/YrdC/YwlC family protein', 162, NULL, NULL, 222888),
(222889, '1.10.533.10-FF-000307', NULL, 'Interleukin 1 receptor associated kinase 1', 58, NULL, NULL, 222889),
(222890, '3.40.30.10-FF-000801', NULL, 'Predicted protein', 172, NULL, NULL, 222890),
(222891, '3.60.21.10-FF-000190', NULL, 'Ser/Thr protein phosphatase family protein', 179, NULL, NULL, 222891),
(222892, '1.25.40.20-FF-000518', NULL, 'Ankyrin repeat domain-containing protein 20A1', 164, NULL, NULL, 222892),
(222893, '3.50.30.10-FF-000014', NULL, NULL, 106, NULL, NULL, 222893),
(222894, '1.10.238.10-FF-000638', NULL, 'Putative cytosolic ca2+-dependent cysteine protease calpain', 171, NULL, NULL, 222894),
(222895, '2.60.40.10-FF-000415', NULL, 'receptor-type tyrosine-protein phosphatase O isoform X2', 99, NULL, NULL, 222895),
(222896, '1.10.10.60-FF-000528', NULL, 'DNA-binding protein RAP1', 131, NULL, NULL, 222896),
(222897, '3.30.70.330-FF-000268', NULL, '31 kDa ribonucleoprotein, chloroplastic', 95, NULL, NULL, 222897),
(222898, '1.10.246.60-FF-000003', NULL, 'Eukaryotic translation initiation factor 3 subunit J', 77, NULL, NULL, 222898),
(222899, '1.20.5.4570-FF-000004', NULL, NULL, 36, NULL, NULL, 222899),
(222900, '1.10.287.110-FF-000309', NULL, 'uncharacterized protein LOC100175116 isoform X2', 95, NULL, NULL, 222900),
(222901, '3.30.160.60-FF-006025', NULL, NULL, 82, NULL, NULL, 222901),
(222902, '3.40.50.1010-FF-000257', NULL, NULL, 90, NULL, NULL, 222902),
(222903, '3.10.20.10-FF-000015', NULL, 'DNAation factor-related protein 4', 98, NULL, NULL, 222903),
(222904, '1.20.140.10-FF-000084', NULL, 'Acyl-coenzyme A oxidase', 128, NULL, NULL, 222904),
(222905, '1.10.510.10-FF-004072', NULL, NULL, 245, NULL, NULL, 222905),
(222906, '3.30.870.10-FF-000168', NULL, 'Phospholipase D superfamily protein', 224, NULL, NULL, 222906),
(222907, '3.30.40.10-FF-001342', NULL, 'Uncharacterized protein (Fragment)', 75, NULL, NULL, 222907),
(222908, '1.10.20.10-FF-000065', NULL, 'Histone H3-like centromeric protein A', 132, NULL, NULL, 222908),
(222909, '2.20.28.120-FF-000015', NULL, 'Uncharacterized protein', 55, NULL, NULL, 222909),
(222910, '1.10.418.20-FF-000032', NULL, 'Chromosome 1, whole genome shotgun sequence', 47, NULL, NULL, 222910),
(222911, '1.10.30.10-FF-000037', NULL, 'High mobility group protein B2', 86, NULL, NULL, 222911),
(222912, '4.10.400.10-FF-000089', NULL, 'Low-density lipoprotein receptor-related protein 3', 42, NULL, NULL, 222912),
(222913, '3.30.1520.10-FF-000102', NULL, 'SNX6 isoform 6', 101, NULL, NULL, 222913),
(222914, '1.20.1420.30-FF-000065', NULL, 'Ca2+:Cation Antiporter (CaCA) protein', 192, NULL, NULL, 222914),
(222915, '1.10.10.60-FF-000236', NULL, 'Fis family transcriptional regulator', 86, NULL, NULL, 222915),
(222916, '1.20.5.340-FF-000046', NULL, 'Myosin-11 isoform x2', 112, NULL, NULL, 222916),
(222917, '3.30.505.10-FF-000079', NULL, 'Suppressor of cytokine signaling 7', 129, NULL, NULL, 222917),
(222918, '1.25.40.10-FF-002371', NULL, 'Os01g0197450 protein', 97, NULL, NULL, 222918),
(222919, '1.20.1250.20-FF-001038', NULL, 'Uncharacterized protein', 219, NULL, NULL, 222919),
(222920, '3.30.70.330-FF-000622', NULL, 'Uncharacterized protein, isoform B', 71, NULL, NULL, 222920),
(222921, '1.10.510.10-FF-001699', NULL, 'Inactive tyrosine-protein kinase kin-32', 245, NULL, NULL, 222921),
(222922, '2.130.10.10-FF-001967', NULL, 'WD domain containing protein', 257, NULL, NULL, 222922),
(222923, '2.130.10.10-FF-000247', NULL, 'WD repeat-containing protein 72', 232, NULL, NULL, 222923),
(222924, '2.60.34.20-FF-000005', NULL, NULL, 176, NULL, NULL, 222924),
(222925, '2.30.29.30-FF-001318', NULL, 'Chromosome 7, whole genome shotgun sequence', 69, NULL, NULL, 222925),
(222926, '2.60.40.790-FF-000195', NULL, NULL, 82, NULL, NULL, 222926),
(222927, '3.40.50.300-FF-006913', NULL, 'ATP-binding cassette sub-family E member 1, putative', 236, NULL, NULL, 222927),
(222928, '3.40.140.10-FF-000228', NULL, 'Uncharacterized protein', 172, NULL, NULL, 222928),
(222929, '2.40.70.10-FF-000227', NULL, 'Uncharacterized protein', 197, NULL, NULL, 222929);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(222930, '2.10.50.30-FF-000008', NULL, 'Metabotropic GLutamate receptor family', 73, NULL, NULL, 222930),
(222931, '3.30.160.60-FF-000718', NULL, 'Uncharacterized protein', 27, NULL, NULL, 222931),
(222932, '3.30.200.20-FF-002026', NULL, 'Predicted protein', 92, NULL, NULL, 222932),
(222933, '1.10.10.1420-FF-000011', NULL, NULL, 85, NULL, NULL, 222933),
(222934, '3.30.420.10-FF-000674', NULL, NULL, 170, NULL, NULL, 222934),
(222935, '1.20.140.20-FF-000002', NULL, '[3-methyl-2-oxobutanoate dehydrogenase [lipoamide]] kinase, mitochondrial', 154, NULL, NULL, 222935),
(222936, '3.40.50.2300-FF-000071', NULL, 'Two-component DNA-binding response regulator ColR', 125, NULL, NULL, 222936),
(222937, '1.20.144.10-FF-000143', NULL, 'Protein CBG02670', 117, NULL, NULL, 222937),
(222938, '2.60.40.10-FF-000562', NULL, 'Snf1 kinase complex beta-subunit Gal83', 85, NULL, NULL, 222938),
(222939, '3.80.10.10-FF-001080', NULL, 'Negative regulator of reactive oxygen species', 146, NULL, NULL, 222939),
(222940, '3.30.160.60-FF-000483', NULL, 'Zinc finger protein 423', 29, NULL, NULL, 222940),
(222941, '3.40.50.300-FF-002198', NULL, 'ATP-dependent DNA helicase RecQ', 199, NULL, NULL, 222941),
(222942, '2.70.170.10-FF-000115', NULL, 'Si:ch73-380n15.2', 170, NULL, NULL, 222942),
(222943, '1.20.140.30-FF-000005', NULL, 'Putative cell cycle associated protein MOB1', 211, NULL, NULL, 222943),
(222944, '2.30.30.40-FF-000318', NULL, 'Bud emergence protein 1', 58, NULL, NULL, 222944),
(222945, '2.130.10.10-FF-000539', NULL, 'Partner and localizer of BRCA2', 333, NULL, NULL, 222945),
(222946, '3.30.730.10-FF-000012', NULL, 'Putative AP2/EREBP transcription factor superfamily protein', 46, NULL, NULL, 222946),
(222947, '3.40.50.150-FF-000539', NULL, 'juvenile hormone acid O-methyltransferase', 251, NULL, NULL, 222947),
(222948, '3.40.50.1910-FF-000021', NULL, 'Putative syntaxin binding protein 1', 118, NULL, NULL, 222948),
(222949, '2.10.25.10-FF-000809', NULL, 'Complement component C1q receptor', 46, NULL, NULL, 222949),
(222950, '1.20.140.40-FF-000008', NULL, 'Invertase/pectin methylesterase inhibitor family protein', 151, NULL, NULL, 222950),
(222951, '3.40.630.10-FF-000103', NULL, 'Aminoacyl-histidine dipeptidase', 237, NULL, NULL, 222951),
(222952, '3.10.20.90-FF-000258', NULL, 'Ubiquitin carboxyl-terminal hydrolase 24', 73, NULL, NULL, 222952),
(222953, '3.90.1640.10-FF-000013', NULL, 'Prune', 238, NULL, NULL, 222953),
(222954, '1.20.1070.10-FF-001650', NULL, 'Uncharacterized protein', 132, NULL, NULL, 222954),
(222955, '2.40.170.10-FF-000004', NULL, 'Maltoporin', 390, NULL, NULL, 222955),
(222956, '1.10.30.10-FF-000184', NULL, 'Uncharacterized protein', 48, NULL, NULL, 222956),
(222957, '2.60.120.560-FF-000017', NULL, 'Levanase', 164, NULL, NULL, 222957),
(222958, '1.20.120.1240-FF-000030', NULL, 'Dynamin family protein', 250, NULL, NULL, 222958),
(222959, '3.40.630.30-FF-000289', NULL, 'Predicted protein', 192, NULL, NULL, 222959),
(222960, '3.30.230.130-FF-000054', NULL, 'anaphase-promoting complex subunit 2', 177, NULL, NULL, 222960),
(222961, '3.30.200.20-FF-002318', NULL, 'Receptor protein-tyrosine kinase CEPR2', 85, NULL, NULL, 222961),
(222962, '3.90.550.10-FF-000462', NULL, 'Dolichol-phosphate mannosyltransferase', 229, NULL, NULL, 222962),
(222963, '2.130.10.10-FF-004608', NULL, 'Uncharacterized protein', 202, NULL, NULL, 222963),
(222964, '3.40.50.300-FF-004143', NULL, 'DNA helicase', 175, NULL, NULL, 222964),
(222965, '1.25.40.10-FF-004136', NULL, 'Uncharacterized protein', 117, NULL, NULL, 222965),
(222966, '3.40.30.10-FF-001144', NULL, 'Uncharacterized protein', 51, NULL, NULL, 222966),
(222967, '1.10.8.710-FF-000025', NULL, NULL, 109, NULL, NULL, 222967),
(222968, '3.30.70.330-FF-002067', NULL, NULL, 86, NULL, NULL, 222968),
(222969, '1.10.540.10-FF-000066', NULL, 'Acyl-coenzyme A oxidase', 117, NULL, NULL, 222969),
(222970, '3.30.497.10-FF-000160', NULL, 'Serpin family B member 3', 54, NULL, NULL, 222970),
(222971, '1.10.510.10-FF-000564', NULL, 'Phosphoenolpyruvate carboxylase kinase 1', 183, NULL, NULL, 222971);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(222972, '2.20.70.10-FF-000037', NULL, 'E3 ubiquitin-protein ligase nedd-4', 42, NULL, NULL, 222972),
(222973, '1.20.1110.10-FF-000070', NULL, 'Cation transporting ATPase', 374, NULL, NULL, 222973),
(222974, '3.30.1490.40-FF-000001', NULL, 'GRB10-interacting GYF protein 2 isoform X1', 72, NULL, NULL, 222974),
(222975, '3.30.420.40-FF-000363', NULL, 'Heat shock protein 70 family protein', 45, NULL, NULL, 222975),
(222976, '2.120.10.30-FF-000220', NULL, 'Uncharacterized protein', 94, NULL, NULL, 222976),
(222977, '3.40.50.300-FF-004435', NULL, 'TWiNKle mtDNA helicase homolog', 281, NULL, NULL, 222977),
(222978, '1.20.920.30-FF-000071', NULL, 'Dynein axonemal heavy chain 14', 75, NULL, NULL, 222978),
(222979, '3.90.1410.10-FF-000058', NULL, 'Predicted protein', 282, NULL, NULL, 222979),
(222980, '1.25.10.10-FF-002251', NULL, 'Uncharacterized protein', 370, NULL, NULL, 222980),
(222981, '1.25.40.490-FF-000003', NULL, 'FA complementation group F', 196, NULL, NULL, 222981),
(222982, '3.30.160.60-FF-002282', NULL, 'Wu:fb97d07 protein', 29, NULL, NULL, 222982),
(222983, '3.20.20.70-FF-000696', NULL, NULL, 166, NULL, NULL, 222983),
(222984, '3.80.10.10-FF-000798', NULL, 'TropoMoDulin', 169, NULL, NULL, 222984),
(222985, '4.10.110.10-FF-000016', NULL, 'Uncharacterized protein', 54, NULL, NULL, 222985),
(222986, '2.30.39.10-FF-000088', NULL, 'AGAP009670-PA', 101, NULL, NULL, 222986),
(222987, '3.30.1490.50-FF-000004', NULL, 'Glutathione synthetase', 74, NULL, NULL, 222987),
(222988, '2.60.40.820-FF-000013', NULL, 'T-box transcription factor tbx-9', 190, NULL, NULL, 222988),
(222989, '1.20.1310.10-FF-000225', NULL, NULL, 135, NULL, NULL, 222989),
(222990, '2.60.40.10-FF-000741', NULL, 'Interleukin 5 receptor subunit alpha', 113, NULL, NULL, 222990),
(222991, '3.30.70.330-FF-002859', NULL, NULL, 135, NULL, NULL, 222991),
(222992, '3.30.2340.10-FF-000004', NULL, 'tRNA pseudouridine synthase D', 133, NULL, NULL, 222992),
(222993, '1.10.10.60-FF-000854', NULL, NULL, 58, NULL, NULL, 222993),
(222994, '3.40.50.300-FF-008358', NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 8', 113, NULL, NULL, 222994),
(222995, '2.60.40.10-FF-003203', NULL, NULL, 81, NULL, NULL, 222995),
(222996, '3.90.226.10-FF-000310', NULL, 'Uncharacterized protein', 95, NULL, NULL, 222996),
(222997, '3.30.40.10-FF-001196', NULL, 'Uncharacterized protein', 61, NULL, NULL, 222997),
(222998, '2.160.20.10-FF-000241', NULL, 'Os02g0196700 protein', 176, NULL, NULL, 222998),
(222999, '3.60.15.10-FF-000012', NULL, 'Hydroxyacylglutathione hydrolase', 251, NULL, NULL, 222999),
(223000, '1.10.472.10-FF-000171', NULL, 'Protein CBG05210', 104, NULL, NULL, 223000),
(223001, '1.10.560.10-FF-000128', NULL, 'TCP-1/cpn60 chaperonin family protein', 62, NULL, NULL, 223001),
(223002, '3.50.50.60-FF-000423', NULL, 'FAD/NAD(P)-binding oxidoreductase family protein', 93, NULL, NULL, 223002),
(223003, '2.10.70.10-FF-000296', NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing 1', 49, NULL, NULL, 223003),
(223004, '2.130.10.10-FF-004401', NULL, 'Uncharacterized protein', 55, NULL, NULL, 223004),
(223005, '3.40.50.300-FF-003041', NULL, 'Predicted protein', 178, NULL, NULL, 223005),
(223006, '3.40.50.300-FF-005896', NULL, 'General secretion pathway protein E', 283, NULL, NULL, 223006),
(223007, '2.60.210.10-FF-000020', NULL, 'Traf3, isoform B', 183, NULL, NULL, 223007),
(223008, '2.60.40.10-FF-004305', NULL, NULL, 102, NULL, NULL, 223008),
(223009, '2.60.40.60-FF-000823', NULL, 'Uncharacterized protein', 80, NULL, NULL, 223009),
(223010, '1.10.10.10-FF-000772', NULL, 'ECF RNA polymerase sigma factor SigM', 57, NULL, NULL, 223010),
(223011, '3.30.1370.10-FF-000011', NULL, 'KRR1 small subunit processome component', 103, NULL, NULL, 223011),
(223012, '3.80.10.10-FF-003850', NULL, 'Protein phosphatase 2C, putative', 120, NULL, NULL, 223012),
(223013, '2.60.120.10-FF-000249', NULL, 'Uncharacterized protein', 150, NULL, NULL, 223013),
(223014, '3.40.640.10-FF-000340', NULL, '3-amino-5-hydroxybenzoic acid synthase', 252, NULL, NULL, 223014);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(223015, '3.10.100.10-FF-000317', NULL, NULL, 151, NULL, NULL, 223015),
(223016, '3.40.50.300-FF-005250', NULL, 'AAA domain containing protein, putative', 189, NULL, NULL, 223016),
(223017, '1.10.510.10-FF-000890', NULL, 'Blast:Serine/threonine-protein kinase 16', 299, NULL, NULL, 223017),
(223018, '1.20.1250.20-FF-001364', NULL, 'Major facilitator superfamily MFS_1', 198, NULL, NULL, 223018),
(223019, '3.40.50.2300-FF-001465', NULL, NULL, 160, NULL, NULL, 223019),
(223020, '1.20.120.980-FF-000001', NULL, 'Dipeptidyl peptidase 7', 147, NULL, NULL, 223020),
(223021, '3.20.20.70-FF-000549', NULL, NULL, 206, NULL, NULL, 223021),
(223022, '3.40.50.1980-FF-000109', NULL, 'Vitamin B12 ABC transporter, B12-binding component BtuF', 133, NULL, NULL, 223022),
(223023, '3.30.70.330-FF-001757', NULL, NULL, 95, NULL, NULL, 223023),
(223024, '3.30.420.40-FF-000924', NULL, 'Uncharacterized protein', 176, NULL, NULL, 223024),
(223025, '3.30.70.890-FF-000060', NULL, 'Diphosphomevalonate decarboxylase', 50, NULL, NULL, 223025),
(223026, '3.40.50.1000-FF-000580', NULL, NULL, 112, NULL, NULL, 223026),
(223027, '3.30.450.20-FF-000420', NULL, 'Sensor histidine kinase of FgrL, PAS domain-containing', 108, NULL, NULL, 223027),
(223028, '1.20.1070.10-FF-001942', NULL, 'Uncharacterized protein', 306, NULL, NULL, 223028),
(223029, '1.10.10.10-FF-001874', NULL, 'Nitrite reductase heme biosynthesis D/L protein, putative', 53, NULL, NULL, 223029),
(223030, '3.90.1140.10-FF-000020', NULL, 'RNA 2'',3''-cyclic phosphodiesterase', 178, NULL, NULL, 223030),
(223031, '3.40.630.10-FF-000283', NULL, 'Glutaminyl cyclase, putative', 153, NULL, NULL, 223031),
(223032, '4.10.280.10-FF-000028', NULL, 'MLX interacting protein like', 92, NULL, NULL, 223032),
(223033, '2.130.10.10-FF-004581', NULL, 'Uncharacterized protein', 209, NULL, NULL, 223033),
(223034, '3.40.50.300-FF-004761', NULL, 'ABC transporter, putative', 140, NULL, NULL, 223034),
(223035, '3.30.160.60-FF-002309', NULL, 'Transcriptional regulator nrg2, putative', 38, NULL, NULL, 223035),
(223036, '1.10.8.60-FF-000308', NULL, 'AAA family ATPase', 97, NULL, NULL, 223036),
(223037, '2.110.10.10-FF-000057', NULL, 'Uncharacterized protein', 203, NULL, NULL, 223037),
(223038, '3.40.50.2300-FF-000363', NULL, 'Loc683510', 157, NULL, NULL, 223038),
(223039, '1.20.120.1750-FF-000121', NULL, 'RBR-type E3 ubiquitin transferase', 121, NULL, NULL, 223039),
(223040, '2.60.34.10-FF-000002', NULL, 'Heat shock 70 kDa', 155, NULL, NULL, 223040),
(223041, '2.40.50.100-FF-000146', NULL, 'sn-glycerol-3-phosphate import ATP-binding protein UgpC', 31, NULL, NULL, 223041),
(223042, '3.40.50.300-FF-007487', NULL, 'Predicted protein', 231, NULL, NULL, 223042),
(223043, '3.30.40.10-FF-000061', NULL, 'FYVE, RhoGEF and PH domain containing 1', 86, NULL, NULL, 223043),
(223044, '3.40.50.720-FF-001306', NULL, 'Malic enzyme', 297, NULL, NULL, 223044),
(223045, '2.130.10.10-FF-002810', NULL, 'Uncharacterized protein', 162, NULL, NULL, 223045),
(223046, '3.30.230.70-FF-000076', NULL, 'Putative ribosomal RNA processing protein', 256, NULL, NULL, 223046),
(223047, '3.40.47.10-FF-000250', NULL, '3-hydroxy-3-methylglutaryl coenzyme A synthase', 416, NULL, NULL, 223047),
(223048, '3.30.360.10-FF-000085', NULL, 'Uncharacterized protein', 212, NULL, NULL, 223048),
(223049, '1.10.418.10-FF-000057', NULL, 'Calmin', 117, NULL, NULL, 223049),
(223050, '1.25.40.120-FF-000089', NULL, 'Uncharacterized protein', 254, NULL, NULL, 223050),
(223051, '2.60.40.150-FF-000385', NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', 137, NULL, NULL, 223051),
(223052, '3.40.50.620-FF-000113', NULL, 'FAD synthase', 233, NULL, NULL, 223052),
(223053, '2.30.29.30-FF-000216', NULL, 'FERM domain-containing protein 8', 110, NULL, NULL, 223053),
(223054, '4.10.60.10-FF-000274', NULL, 'Uncharacterized protein', 51, NULL, NULL, 223054),
(223055, '3.40.50.1820-FF-001394', NULL, 'Alpha/beta hydrolase domain-containing protein, putative', 214, NULL, NULL, 223055),
(223056, '3.90.190.20-FF-000010', NULL, 'Dihydrofolate synthetase', 149, NULL, NULL, 223056);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(223057, '1.10.1000.11-FF-000025', NULL, 'Uncharacterized protein', 121, NULL, NULL, 223057),
(223058, '1.25.40.10-FF-001909', NULL, 'Uncharacterized protein', 169, NULL, NULL, 223058),
(223059, '3.30.565.10-FF-000234', NULL, 'Sensor histidine kinase', 144, NULL, NULL, 223059),
(223060, '3.40.50.10810-FF-000144', NULL, 'SNF2 family N-terminal domain-domain-containing protein', 287, NULL, NULL, 223060),
(223061, '3.30.930.10-FF-000286', NULL, 'Anticodon binding domain of tRNAs-domain-containing protein', 336, NULL, NULL, 223061),
(223062, '2.30.30.40-FF-000644', NULL, 'Predicted protein', 114, NULL, NULL, 223062),
(223063, '3.30.70.120-FF-000031', NULL, NULL, 109, NULL, NULL, 223063),
(223064, '2.60.40.200-FF-000035', NULL, 'Bursicon', 46, NULL, NULL, 223064),
(223065, '3.20.10.10-FF-000048', NULL, 'Aminotransferase class IV, putative', 158, NULL, NULL, 223065),
(223066, '2.60.200.20-FF-000225', NULL, 'Uncharacterized protein', 91, NULL, NULL, 223066),
(223067, '3.40.50.720-FF-001924', NULL, 'Ornithine cyclodeaminase', 169, NULL, NULL, 223067),
(223068, '2.10.25.10-FF-001624', NULL, 'Putative wall-associated receptor protein kinase family protein', 80, NULL, NULL, 223068),
(223069, '2.130.10.10-FF-000865', NULL, 'WD repeat domain 90', 87, NULL, NULL, 223069),
(223070, '2.30.29.30-FF-000981', NULL, 'Cyclin-B1-3', 80, NULL, NULL, 223070),
(223071, '1.20.120.140-FF-000042', NULL, 'SRP54-type protein, putative', 161, NULL, NULL, 223071),
(223072, '3.40.50.80-FF-000132', NULL, 'Nitric oxide synthase', 86, NULL, NULL, 223072),
(223073, '3.80.10.10-FF-001641', NULL, 'Uncharacterized protein', 268, NULL, NULL, 223073),
(223074, '2.130.10.120-FF-000027', NULL, 'Predicted protein', 235, NULL, NULL, 223074),
(223075, '2.40.110.10-FF-000028', NULL, 'Acyl-coenzyme A dehydrogenase', 120, NULL, NULL, 223075),
(223076, '1.10.510.10-FF-004307', NULL, NULL, 155, NULL, NULL, 223076),
(223077, '2.40.50.140-FF-000282', NULL, 'Protein BREAST CANCER SUSCEPTIBILITY 2 homolog B', 158, NULL, NULL, 223077),
(223078, '3.10.490.10-FF-000020', NULL, 'Gamma-glutamylcyclotransferase', 212, NULL, NULL, 223078),
(223079, '2.130.10.110-FF-000024', NULL, 'Uncharacterized protein', 176, NULL, NULL, 223079),
(223080, '3.90.550.10-FF-000136', NULL, 'Exostosin glycosyltransferase 2', 103, NULL, NULL, 223080),
(223081, '1.10.287.110-FF-000282', NULL, 'DPH4 homolog', 95, NULL, NULL, 223081),
(223082, '3.90.550.50-FF-000215', NULL, 'Uncharacterized protein', 148, NULL, NULL, 223082),
(223083, '1.20.58.220-FF-000010', NULL, NULL, 225, NULL, NULL, 223083),
(223084, '2.60.210.10-FF-000048', NULL, NULL, 168, NULL, NULL, 223084),
(223085, '3.30.590.10-FF-000040', NULL, 'Glutamate--isopropylamine ligase', 337, NULL, NULL, 223085),
(223086, '3.30.160.60-FF-000157', NULL, 'Immunodeficiency virus type I enhancer binding protein 1', 22, NULL, NULL, 223086),
(223087, '2.170.260.10-FF-000019', NULL, 'Endoribonuclease Dicer-like protein 3', 117, NULL, NULL, 223087),
(223088, '3.30.1330.60-FF-000001', NULL, 'Peptidoglycan-associated lipoprotein', 121, NULL, NULL, 223088),
(223089, '3.40.50.300-FF-008212', NULL, 'Uncharacterized protein', 69, NULL, NULL, 223089),
(223090, '3.40.50.1000-FF-000428', NULL, 'Aminophospholipid transporter, putative', 141, NULL, NULL, 223090),
(223091, '2.60.120.40-FF-000056', NULL, 'Si:ch1073-184j22.1', 100, NULL, NULL, 223091),
(223092, '3.30.40.10-FF-000122', NULL, 'polycomb group RING finger protein 1', 106, NULL, NULL, 223092),
(223093, '2.60.40.1960-FF-000009', NULL, 'Uncharacterized protein', 41, NULL, NULL, 223093),
(223094, '2.160.20.10-FF-000033', NULL, 'Pectinesterase', 309, NULL, NULL, 223094),
(223095, '1.20.1250.20-FF-001925', NULL, 'Uncharacterized protein', 219, NULL, NULL, 223095),
(223096, '1.25.40.990-FF-000063', NULL, 'Uncharacterized protein', 131, NULL, NULL, 223096),
(223097, '1.20.190.50-FF-000020', NULL, 'Nuclear pore complex protein', 126, NULL, NULL, 223097),
(223098, '1.20.120.790-FF-000034', NULL, 'TNF receptor associated protein 1', 87, NULL, NULL, 223098),
(223099, '1.10.238.10-FF-000756', NULL, 'Uncharacterized protein', 78, NULL, NULL, 223099); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(223100, '2.60.40.10-FF-000769', NULL, 'Cell surface glycoprotein CD200 receptor 1', 123, NULL, NULL, 223100),
(223101, '4.10.800.10-FF-000018', NULL, 'CRE-MLT-11 protein', 66, NULL, NULL, 223101),
(223102, '1.10.472.10-FF-000199', NULL, 'Putative cyclin-A3-1', 120, NULL, NULL, 223102),
(223103, '2.60.120.200-FF-000140', NULL, 'Beta-glucan synthesis-associated protein', 199, NULL, NULL, 223103),
(223104, '3.30.1330.80-FF-000007', NULL, 'AT-hook motif nuclear-localized protein', 138, NULL, NULL, 223104),
(223105, '1.20.58.1380-FF-000002', NULL, 'Nup133', 87, NULL, NULL, 223105),
(223106, '2.30.30.750-FF-000002', NULL, '5''-3'' exoribonuclease 1', 111, NULL, NULL, 223106),
(223107, '3.30.160.60-FF-004108', NULL, 'Zgc:173486', 95, NULL, NULL, 223107),
(223108, '3.55.50.30-FF-000022', NULL, 'Ferripyoverdine receptor', 93, NULL, NULL, 223108),
(223109, '3.30.470.30-FF-000071', NULL, 'Uncharacterized protein', 163, NULL, NULL, 223109),
(223110, '1.25.40.20-FF-001154', NULL, 'Putative leucine-rich repeat serine/threonine-protein kinase 1', 140, NULL, NULL, 223110),
(223111, '1.25.10.10-FF-002751', NULL, 'Uncharacterized protein', 676, NULL, NULL, 223111),
(223112, '2.120.10.10-FF-000034', NULL, 'Uncharacterized protein', 123, NULL, NULL, 223112),
(223113, '1.20.5.470-FF-000001', NULL, 'Argininosuccinate synthase', 27, NULL, NULL, 223113),
(223114, '3.10.290.10-FF-000038', NULL, 'Chromosome 15, whole genome shotgun sequence', 129, NULL, NULL, 223114),
(223115, '1.10.10.10-FF-000980', NULL, 'Crp/Fnr family transcriptional regulator', 80, NULL, NULL, 223115),
(223116, '3.30.160.60-FF-002927', NULL, 'Zinc finger transcription factor', 54, NULL, NULL, 223116),
(223117, '2.160.10.10-FF-000061', NULL, 'Eukaryotic initiation factor eIF2B epsilon subunit', 113, NULL, NULL, 223117),
(223118, '2.10.220.10-FF-000217', NULL, 'Extracellular matrix protein FRAS1', 49, NULL, NULL, 223118),
(223119, '2.10.25.10-FF-001063', NULL, 'Cell death abnormality protein 1', 66, NULL, NULL, 223119),
(223120, '3.20.20.80-FF-000232', NULL, 'Beta-glucosidase', 459, NULL, NULL, 223120),
(223121, '3.90.226.10-FF-000282', NULL, '3-hydroxyisobutyryl-CoA hydrolase IvdE', 369, NULL, NULL, 223121),
(223122, '3.40.50.2300-FF-000571', NULL, 'Two-component response regulator ORR2', 221, NULL, NULL, 223122),
(223123, '3.40.50.300-FF-006059', NULL, 'DNA replication licensing factor MCM5, putative', 135, NULL, NULL, 223123),
(223124, '3.30.830.10-FF-000137', NULL, 'Mitochondrial-processing peptidase (MPP) alpha subunit, mitochondrial, putative', 211, NULL, NULL, 223124),
(223125, '2.130.10.10-FF-002456', NULL, 'Transducin beta-like protein 3', 102, NULL, NULL, 223125),
(223126, '3.30.200.20-FF-001537', NULL, 'Uncharacterized protein', 92, NULL, NULL, 223126),
(223127, '2.80.10.50-FF-000149', NULL, 'Botulinum neurotoxin type D', 189, NULL, NULL, 223127),
(223128, '3.40.50.720-FF-001806', NULL, 'Uncharacterized protein', 118, NULL, NULL, 223128),
(223129, '2.60.40.10-FF-004631', NULL, NULL, 110, NULL, NULL, 223129),
(223130, '3.40.1280.10-FF-000114', NULL, 'Predicted protein', 282, NULL, NULL, 223130),
(223131, '2.130.10.10-FF-000747', NULL, 'Transducin/WD40 repeat-like superfamily protein', 160, NULL, NULL, 223131),
(223132, '3.30.530.20-FF-000213', NULL, 'Uncharacterized protein', 65, NULL, NULL, 223132),
(223133, '1.10.287.130-FF-000203', NULL, 'Hybrid sensor kinase RscS', 66, NULL, NULL, 223133),
(223134, '2.60.40.150-FF-000677', NULL, 'Protein kinase C-like 1', 179, NULL, NULL, 223134),
(223135, '1.25.40.10-FF-000162', NULL, 'CTR9 homolog, Paf1/RNA polymerase II complex component', 267, NULL, NULL, 223135),
(223136, '3.40.50.300-FF-000719', NULL, 'Zinc finger FYVE domain-containing protein 1', 174, NULL, NULL, 223136),
(223137, '3.30.450.20-FF-000212', NULL, 'Diguanylate cyclase', 122, NULL, NULL, 223137),
(223138, '2.40.10.10-FF-000336', NULL, NULL, 93, NULL, NULL, 223138),
(223139, '3.40.50.1000-FF-000372', NULL, 'Putative NipSnap protein K02D10.1', 137, NULL, NULL, 223139),
(223140, '1.25.40.20-FF-000165', NULL, 'calmodulin-binding transcription activator 1 isoform X2', 133, NULL, NULL, 223140);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(223141, '1.25.10.10-FF-001762', NULL, 'Uncharacterized protein', 966, NULL, NULL, 223141),
(223142, '3.30.160.60-FF-000365', NULL, 'zinc finger protein 197 isoform X1', 30, NULL, NULL, 223142),
(223143, '2.30.42.10-FF-000174', NULL, 'Tyrosine-protein phosphatase non-receptor type 13', 99, NULL, NULL, 223143),
(223144, '1.20.1070.10-FF-001824', NULL, 'G protein-coupled receptor 25', 307, NULL, NULL, 223144),
(223145, '3.40.50.300-FF-007695', NULL, 'Heparan sulfate 2-O-sulfotransferase, putative', 106, NULL, NULL, 223145),
(223146, '3.10.280.10-FF-000009', NULL, 'Mitochondrial glycoprotein', 196, NULL, NULL, 223146),
(223147, '2.130.10.10-FF-003884', NULL, 'Uncharacterized protein', 276, NULL, NULL, 223147),
(223148, '3.30.70.1660-FF-000022', NULL, 'Peptide chain release factor H', 97, NULL, NULL, 223148),
(223149, '3.30.70.330-FF-001842', NULL, NULL, 116, NULL, NULL, 223149),
(223150, '3.90.550.10-FF-000344', NULL, 'Uncharacterized protein', 247, NULL, NULL, 223150),
(223151, '2.70.150.10-FF-000232', NULL, 'Cation-transporting ATPase', 204, NULL, NULL, 223151),
(223152, '3.80.10.10-FF-003086', NULL, 'Predicted protein', 124, NULL, NULL, 223152),
(223153, '2.70.130.10-FF-000169', NULL, NULL, 74, NULL, NULL, 223153),
(223154, '2.60.40.10-FF-002478', NULL, 'Unplaced genomic scaffold supercont1.8, whole genome shotgun sequence', 94, NULL, NULL, 223154),
(223155, '2.130.10.10-FF-002990', NULL, 'WD repeat-containing protein 36-like', 343, NULL, NULL, 223155),
(223156, '3.30.60.70-FF-000001', NULL, '2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-succinyltransferase', 41, NULL, NULL, 223156),
(223157, '3.60.110.10-FF-000003', NULL, 'Glutamine-dependent NAD(+) synthetase', 313, NULL, NULL, 223157),
(223158, '3.40.640.10-FF-000014', NULL, 'Adenosylmethionine-8-amino-7-oxononanoate aminotransferase, probable', 282, NULL, NULL, 223158),
(223159, '1.20.120.1150-FF-000003', NULL, 'Serine/threonine-protein phosphatase 2A activator', 127, NULL, NULL, 223159),
(223160, '2.30.30.40-FF-000436', NULL, 'Uncharacterized protein', 62, NULL, NULL, 223160),
(223161, '1.25.40.190-FF-000003', NULL, 'Actin-related protein 2/3 complex subunit 5', 157, NULL, NULL, 223161),
(223162, '2.40.10.120-FF-000015', NULL, 'Genome polyprotein', 62, NULL, NULL, 223162),
(223163, '3.30.40.10-FF-001550', NULL, 'E3 ubiquitin-protein ligase At4g11680 family', 103, NULL, NULL, 223163),
(223164, '3.30.200.20-FF-000402', NULL, 'Serine/threonine-protein kinase', 113, NULL, NULL, 223164),
(223165, '3.30.40.10-FF-000499', NULL, 'RING-box protein 2 isoform X2', 40, NULL, NULL, 223165),
(223166, '3.40.50.300-FF-004261', NULL, 'Uncharacterized protein', 189, NULL, NULL, 223166),
(223167, '3.50.50.60-FF-000631', NULL, 'tRNA 5-methylaminomethyl-2-thiouridine biosynthesis bifunctional protein MnmC', 250, NULL, NULL, 223167),
(223168, '1.20.1090.10-FF-000044', NULL, 'NADH-dependent butanol dehydrogenase A', 195, NULL, NULL, 223168),
(223169, '1.20.1280.50-FF-000245', NULL, 'F-box/WD repeat-containing protein pof11', 83, NULL, NULL, 223169),
(223170, '3.30.70.330-FF-000061', NULL, 'cleavage stimulation factor subunit 2 isoform X1', 104, NULL, NULL, 223170),
(223171, '3.40.33.10-FF-000162', NULL, 'Uncharacterized protein', 122, NULL, NULL, 223171),
(223172, '2.60.40.10-FF-003849', NULL, NULL, 113, NULL, NULL, 223172),
(223173, '1.25.70.10-FF-000102', NULL, NULL, 151, NULL, NULL, 223173),
(223174, '1.10.287.110-FF-000248', NULL, 'DNAJ heat shock N-terminal domain-containing protein', 102, NULL, NULL, 223174),
(223175, '3.30.160.20-FF-000201', NULL, 'R3D1', 52, NULL, NULL, 223175),
(223176, '3.30.390.50-FF-000019', NULL, 'Lipoate--protein ligase', 87, NULL, NULL, 223176),
(223177, '3.10.20.90-FF-000376', NULL, 'myosin-VIIa isoform X1', 87, NULL, NULL, 223177),
(223178, '3.90.1150.10-FF-000346', NULL, 'Glutamine--scyllo-inositol transaminase', 116, NULL, NULL, 223178),
(223179, '3.30.70.330-FF-001578', NULL, NULL, 72, NULL, NULL, 223179),
(223180, '1.20.1080.10-FF-000015', NULL, 'Aquaporin 8', 248, NULL, NULL, 223180),
(223181, '2.60.120.10-FF-000575', NULL, 'Catabolite gene activator protein', 146, NULL, NULL, 223181);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(223182, '3.30.70.340-FF-000007', NULL, 'carboxypeptidase B-like', 89, NULL, NULL, 223182),
(223183, '3.30.50.10-FF-000151', NULL, 'Uncharacterized protein', 85, NULL, NULL, 223183),
(223184, '3.90.76.10-FF-000028', NULL, 'ABC transporter substrate-binding protein', 145, NULL, NULL, 223184),
(223185, '1.10.8.60-FF-000516', NULL, 'Uncharacterized protein', 52, NULL, NULL, 223185),
(223186, '1.10.238.10-FF-000964', NULL, 'Calcium-binding EF hand family protein', 82, NULL, NULL, 223186),
(223187, '2.60.40.1860-FF-000013', NULL, NULL, 41, NULL, NULL, 223187),
(223188, '1.10.286.20-FF-000016', NULL, NULL, 20, NULL, NULL, 223188),
(223189, '1.10.510.10-FF-004280', NULL, NULL, 176, NULL, NULL, 223189),
(223190, '1.10.286.10-FF-000013', NULL, NULL, 55, NULL, NULL, 223190),
(223191, '3.20.20.60-FF-000075', NULL, 'Putative citrate lyase', 283, NULL, NULL, 223191),
(223192, '3.30.300.130-FF-000008', NULL, 'Fe-S cluster assembly factor HCF101, chloroplastic', 93, NULL, NULL, 223192),
(223193, '3.30.470.30-FF-000014', NULL, 'DNA ligase', 224, NULL, NULL, 223193),
(223194, '1.25.10.10-FF-002543', NULL, 'AGAP011904-PA', 180, NULL, NULL, 223194),
(223195, '2.60.220.50-FF-000010', NULL, 'adhesion G protein-coupled receptor L4 isoform X1', 192, NULL, NULL, 223195),
(223196, '3.30.70.100-FF-000166', NULL, NULL, 72, NULL, NULL, 223196),
(223197, '1.20.1270.250-FF-000002', NULL, 'Putative inhibitor of nuclear factor kappa-B kinase subunit beta', 273, NULL, NULL, 223197),
(223198, '1.25.10.10-FF-000452', NULL, 'Maestro heat-like repeat-containing protein family member 7', 340, NULL, NULL, 223198),
(223199, '1.20.1250.20-FF-001072', NULL, 'Amino acid/peptide transporter', 224, NULL, NULL, 223199),
(223200, '1.10.10.820-FF-000033', NULL, 'Chitin synthase', 62, NULL, NULL, 223200),
(223201, '3.30.830.10-FF-000194', NULL, 'Clan ME, family M16, insulinase-like metallopeptidase', 226, NULL, NULL, 223201),
(223202, '3.40.1090.10-FF-000044', NULL, 'Patatin-like phospholipase family protein', 120, NULL, NULL, 223202),
(223203, '2.120.10.30-FF-000192', NULL, 'Uncharacterized protein', 132, NULL, NULL, 223203),
(223204, '1.10.510.10-FF-002542', NULL, 'Casein kinase I, putative', 366, NULL, NULL, 223204),
(223205, '3.40.1110.10-FF-000069', NULL, 'Calcium-transporting ATPase', 195, NULL, NULL, 223205),
(223206, '4.10.400.10-FF-000235', NULL, 'Low-density lipoprotein receptor-related protein', 37, NULL, NULL, 223206),
(223207, '3.90.79.10-FF-000006', NULL, 'ADP compounds hydrolase NudE', 178, NULL, NULL, 223207),
(223208, '3.30.470.20-FF-000011', NULL, 'Synapsin I', 119, NULL, NULL, 223208),
(223209, '3.50.80.10-FF-000017', NULL, 'Uncharacterized protein', 134, NULL, NULL, 223209),
(223210, '1.20.1250.20-FF-000144', NULL, 'Picot, isoform B', 204, NULL, NULL, 223210),
(223211, '1.10.3720.10-FF-000225', NULL, 'Oligopeptide transport system permease protein', 227, NULL, NULL, 223211),
(223212, '2.130.10.10-FF-001467', NULL, 'Flagellar outer dynein arm intermediate chain 1', 240, NULL, NULL, 223212),
(223213, '2.130.10.10-FF-003827', NULL, 'Quinoprotein amine dehydrogenase, beta chain-like RIC1-like guanyl-nucleotide exchange factor', 300, NULL, NULL, 223213),
(223214, '3.60.21.10-FF-000425', NULL, 'DNA repair exonuclease', 263, NULL, NULL, 223214),
(223215, '2.40.50.1000-FF-000007', NULL, '30S ribosomal protein S17', 107, NULL, NULL, 223215),
(223216, '3.40.50.2300-FF-001291', NULL, NULL, 143, NULL, NULL, 223216),
(223217, '2.30.180.10-FF-000147', NULL, NULL, 78, NULL, NULL, 223217),
(223218, '2.70.170.10-FF-000233', NULL, 'Uncharacterized protein', 79, NULL, NULL, 223218),
(223219, '1.10.287.110-FF-000456', NULL, 'Uncharacterized protein', 45, NULL, NULL, 223219),
(223220, '1.10.150.20-FF-000230', NULL, 'DNA polymerase', 61, NULL, NULL, 223220),
(223221, '3.40.50.300-FF-002018', NULL, 'Structural maintenance of chromosomes protein 1', 282, NULL, NULL, 223221),
(223222, '3.10.20.90-FF-000584', NULL, 'Autophagy-related protein', 86, NULL, NULL, 223222),
(223223, '2.10.110.10-FF-000035', NULL, 'prickle-like protein 2 isoform X1', 69, NULL, NULL, 223223);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(223224, '2.130.10.10-FF-005918', NULL, 'Uncharacterized protein', 274, NULL, NULL, 223224),
(223225, '3.90.79.20-FF-000009', NULL, 'NADH pyrophosphatase', 169, NULL, NULL, 223225),
(223226, '1.10.510.10-FF-000356', NULL, 'Serine/threonine-protein kinase Nek2', 201, NULL, NULL, 223226),
(223227, '2.60.40.10-FF-002686', NULL, 'Predicted protein', 103, NULL, NULL, 223227),
(223228, '2.30.29.90-FF-000009', NULL, 'Exocyst complex component', 110, NULL, NULL, 223228),
(223229, '3.40.50.150-FF-000747', NULL, 'Uncharacterized protein', 194, NULL, NULL, 223229),
(223230, '2.60.40.150-FF-000531', NULL, 'Uncharacterized protein', 179, NULL, NULL, 223230),
(223231, '3.40.50.200-FF-000077', NULL, 'Uncharacterized protein', 200, NULL, NULL, 223231),
(223232, '3.40.50.1370-FF-000022', NULL, 'Probable ornithine carbamoyltransferase', 134, NULL, NULL, 223232),
(223233, '3.30.160.60-FF-004844', NULL, NULL, 58, NULL, NULL, 223233),
(223234, '2.60.120.260-FF-000404', NULL, 'Uncharacterized protein', 157, NULL, NULL, 223234),
(223235, '3.40.50.150-FF-000039', NULL, 'Ribosomal RNA large subunit methyltransferase K/L', 219, NULL, NULL, 223235),
(223236, '2.60.40.10-FF-002068', NULL, 'fasciclin-2 isoform X3', 97, NULL, NULL, 223236),
(223237, '1.20.1070.10-FF-001616', NULL, 'Uncharacterized protein', 145, NULL, NULL, 223237),
(223238, '3.40.950.10-FF-000032', NULL, NULL, 180, NULL, NULL, 223238),
(223239, '3.40.50.150-FF-000601', NULL, 'Transcriptional regulator', 249, NULL, NULL, 223239),
(223240, '2.60.40.60-FF-000470', NULL, 'Cadherin 3', 100, NULL, NULL, 223240),
(223241, '3.40.50.300-FF-001124', NULL, 'ABC transporter F family member 4', 277, NULL, NULL, 223241),
(223242, '1.10.238.10-FF-000285', NULL, 'EF-hand calcium-binding domain-containing protein 6', 80, NULL, NULL, 223242),
(223243, '1.10.150.20-FF-000112', NULL, 'DNA ligase', 87, NULL, NULL, 223243),
(223244, '3.30.160.60-FF-004165', NULL, NULL, 21, NULL, NULL, 223244),
(223245, '2.40.70.10-FF-000345', NULL, NULL, 157, NULL, NULL, 223245),
(223246, '3.40.50.1390-FF-000028', NULL, 'Hypothetical immunity region protein 3', 71, NULL, NULL, 223246),
(223247, '2.30.29.240-FF-000004', NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', 219, NULL, NULL, 223247),
(223248, '3.80.10.10-FF-001815', NULL, 'Uncharacterized protein', 157, NULL, NULL, 223248),
(223249, '3.90.1150.10-FF-000138', NULL, 'Putative ornithine aminotransferase RocD2', 85, NULL, NULL, 223249),
(223250, '3.90.280.10-FF-000008', NULL, 'Probable lipoprotein lppC', 160, NULL, NULL, 223250),
(223251, '3.30.160.60-FF-004226', NULL, NULL, 24, NULL, NULL, 223251),
(223252, '1.10.1740.100-FF-000001', NULL, 'Histone-lysine N-methyltransferase', 112, NULL, NULL, 223252),
(223253, '3.40.50.1380-FF-000025', NULL, 'Carbamoyl-phosphate synthase large chain', 153, NULL, NULL, 223253),
(223254, '1.25.40.840-FF-000007', NULL, 'Domain_of_uncharacterized_function_(DUF3819)/CCR4 -Not_complex_component_-_Not1_-_putative', 173, NULL, NULL, 223254),
(223255, '3.30.160.60-FF-002782', NULL, 'B-box type zinc finger protein ncl-1', 50, NULL, NULL, 223255),
(223256, '3.30.70.920-FF-000024', NULL, 'Transcriptional regulator, AsnC family', 87, NULL, NULL, 223256),
(223257, '1.25.40.820-FF-000001', NULL, 'RNA polymerase II subunit B1 CTD phosphatase Rpap2', 173, NULL, NULL, 223257),
(223258, '3.90.70.10-FF-000812', NULL, 'Uncharacterized protein', 386, NULL, NULL, 223258),
(223259, '3.30.430.20-FF-000003', NULL, 'Cysteine-rich RLK (RECEPTOR-like protein kinase) 10', 106, NULL, NULL, 223259),
(223260, '1.25.40.10-FF-003826', NULL, 'Probable assembly chaperone of rpl4', 128, NULL, NULL, 223260),
(223261, '1.10.3210.10-FF-000052', NULL, 'Response regulator', 198, NULL, NULL, 223261),
(223262, '3.40.50.300-FF-006560', NULL, 'Uncharacterized protein', 103, NULL, NULL, 223262),
(223263, '2.60.40.150-FF-000470', NULL, 'Predicted protein', 129, NULL, NULL, 223263),
(223264, '3.40.50.720-FF-001750', NULL, 'Reticulon-4-interacting protein 1, mitochondrial', 184, NULL, NULL, 223264),
(223265, '3.40.50.720-FF-001099', NULL, 'Putative ketol-acid reductoisomerase 2', 182, NULL, NULL, 223265);
INSERT INTO "PUBLIC"."MODEL" VALUES
(223266, '3.40.140.10-FF-000021', NULL, 'Deoxycytidylate deaminase', 172, NULL, NULL, 223266),
(223267, '3.30.160.60-FF-002074', NULL, 'Zinc finger protein 841', 28, NULL, NULL, 223267),
(223268, '3.30.559.70-FF-000024', NULL, 'Carnitine acyltransferase, putative', 152, NULL, NULL, 223268),
(223269, '2.30.30.770-FF-000008', NULL, 'LSU ribosomal protein L27E', 132, NULL, NULL, 223269),
(223270, '2.60.40.150-FF-000413', NULL, 'Phosphatidylinositol 3 and 4-kinase-like protein', 164, NULL, NULL, 223270),
(223271, '3.10.150.10-FF-000028', NULL, 'Beta sliding clamp', 119, NULL, NULL, 223271),
(223272, '2.60.200.20-FF-000051', NULL, 'Nijmegen breakage syndrome 1 protein', 118, NULL, NULL, 223272),
(223273, '3.50.4.10-FF-000034', NULL, 'uncharacterized protein LOC108091652', 82, NULL, NULL, 223273),
(223274, '2.60.120.260-FF-000461', NULL, 'Uncharacterized protein', 159, NULL, NULL, 223274),
(223275, '2.60.40.1180-FF-000107', NULL, 'Acid Alpha Glucosidase Relate', 76, NULL, NULL, 223275),
(223276, '1.20.1540.10-FF-000034', NULL, 'Serine protease family S54, putative', 198, NULL, NULL, 223276),
(223277, '1.20.120.730-FF-000005', NULL, 'Protein transport protein SEC23', 141, NULL, NULL, 223277),
(223278, '3.30.450.80-FF-000005', NULL, 'Transcriptional activator protein LasR', 173, NULL, NULL, 223278),
(223279, '3.90.960.10-FF-000010', NULL, 'Proline-tRNA ligase, putative', 192, NULL, NULL, 223279),
(223280, '3.40.109.10-FF-000010', NULL, 'NAD(P)H nitroreductase', 212, NULL, NULL, 223280),
(223281, '2.60.40.1120-FF-000084', NULL, 'Uncharacterized protein', 76, NULL, NULL, 223281),
(223282, '1.10.150.670-FF-000023', NULL, 'Uncharacterized protein', 77, NULL, NULL, 223282),
(223283, '3.90.700.10-FF-000019', NULL, 'Uncharacterized protein', 58, NULL, NULL, 223283),
(223284, '1.10.10.10-FF-000328', NULL, 'Lactamase beta 2', 83, NULL, NULL, 223284),
(223285, '2.60.40.1170-FF-000104', NULL, NULL, 171, NULL, NULL, 223285),
(223286, '1.20.1070.10-FF-001263', NULL, 'Uncharacterized protein', 294, NULL, NULL, 223286),
(223287, '3.40.50.150-FF-000394', NULL, 'mRNA cap guanine-N7 methyltransferase', 283, NULL, NULL, 223287),
(223288, '3.30.160.60-FF-004373', NULL, NULL, 53, NULL, NULL, 223288),
(223289, '3.40.50.720-FF-002003', NULL, 'Uncharacterized protein', 228, NULL, NULL, 223289),
(223290, '1.10.510.10-FF-000709', NULL, 'CAMK/CAMK1 protein kinase, variant 2', 200, NULL, NULL, 223290),
(223291, '3.90.70.40-FF-000001', NULL, 'ataxin-3 isoform X1', 113, NULL, NULL, 223291),
(223292, '3.40.50.10330-FF-000096', NULL, 'Diacylglycerol kinase', 149, NULL, NULL, 223292),
(223293, '1.10.472.10-FF-000137', NULL, 'Alpha-latroinsectotoxin-Lt1a', 114, NULL, NULL, 223293),
(223294, '2.170.150.20-FF-000020', NULL, 'Predicted protein', 130, NULL, NULL, 223294),
(223295, '3.30.70.330-FF-001078', NULL, 'WGS project CABT00000000 data, contig 2.5', 156, NULL, NULL, 223295),
(223296, '1.25.40.10-FF-004170', NULL, 'Uncharacterized protein', 99, NULL, NULL, 223296),
(223297, '1.10.630.10-FF-000775', NULL, 'Uncharacterized protein', 168, NULL, NULL, 223297),
(223298, '3.30.450.90-FF-000008', NULL, 'Similar to late competence protein comGA', 106, NULL, NULL, 223298),
(223299, '3.30.565.10-FF-000088', NULL, 'DNA topoisomerase (ATP-hydrolyzing)', 230, NULL, NULL, 223299),
(223300, '2.30.29.30-FF-001026', NULL, 'Uncharacterized protein', 118, NULL, NULL, 223300),
(223301, '1.20.120.720-FF-000002', NULL, 'Myosin heavy chain 10', 109, NULL, NULL, 223301),
(223302, '2.130.10.10-FF-002338', NULL, 'Expressed protein', 214, NULL, NULL, 223302),
(223303, '3.40.50.300-FF-004822', NULL, 'SNF2 DNA repair protein, putative', 287, NULL, NULL, 223303),
(223304, '3.10.129.10-FF-000080', NULL, 'Thioesterase-like family protein', 131, NULL, NULL, 223304),
(223305, '1.20.1050.20-FF-000016', NULL, NULL, 176, NULL, NULL, 223305),
(223306, '3.40.50.150-FF-001675', NULL, NULL, 151, NULL, NULL, 223306),
(223307, '3.30.1360.120-FF-000033', NULL, 'N,N-dimethylglycine oxidase', 190, NULL, NULL, 223307),
(223308, '2.60.40.10-FF-006014', NULL, NULL, 100, NULL, NULL, 223308);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(223309, '3.60.21.10-FF-000279', NULL, 'Serine/threonine-protein phosphatase', 302, NULL, NULL, 223309),
(223310, '2.10.25.10-FF-000899', NULL, 'Thrombomodulin', 44, NULL, NULL, 223310),
(223311, '3.30.70.330-FF-001549', NULL, NULL, 99, NULL, NULL, 223311),
(223312, '3.40.630.10-FF-000249', NULL, 'Peptidase M20 domain-containing protein 2', 222, NULL, NULL, 223312),
(223313, '1.10.510.10-FF-002508', NULL, NULL, 94, NULL, NULL, 223313),
(223314, '2.130.10.10-FF-004081', NULL, 'Nuclear pore complex protein 20', 201, NULL, NULL, 223314),
(223315, '1.25.40.10-FF-003708', NULL, 'Patatin', 131, NULL, NULL, 223315),
(223316, '2.130.10.10-FF-001675', NULL, 'AGAP010693-PA', 209, NULL, NULL, 223316),
(223317, '3.30.1360.10-FF-000005', NULL, 'Dna-directed rna polymerases i and iii subunit', 144, NULL, NULL, 223317),
(223318, '2.40.170.20-FF-000097', NULL, 'TonB-dependent receptor-related protein', 496, NULL, NULL, 223318),
(223319, '3.30.1230.20-FF-000004', NULL, '40S ribosomal protein S21', 82, NULL, NULL, 223319),
(223320, '3.80.10.10-FF-003406', NULL, 'Predicted protein', 90, NULL, NULL, 223320),
(223321, '3.40.50.300-FF-008622', NULL, 'Predicted protein', 51, NULL, NULL, 223321),
(223322, '3.80.10.10-FF-003463', NULL, 'Fbxl16, putative', 224, NULL, NULL, 223322),
(223323, '2.60.120.380-FF-000087', NULL, 'Uncharacterized protein', 92, NULL, NULL, 223323),
(223324, '1.10.10.10-FF-000272', NULL, 'Transcriptional regulator, DeoR family', 59, NULL, NULL, 223324),
(223325, '3.40.50.1440-FF-000122', NULL, 'Uncharacterized protein', 108, NULL, NULL, 223325),
(223326, '1.20.1270.50-FF-000008', NULL, 'Alpha-mannosidase-like protein', 91, NULL, NULL, 223326),
(223327, '1.10.287.1490-FF-000067', NULL, 'Uncharacterized protein', 183, NULL, NULL, 223327),
(223328, '2.60.40.10-FF-002271', NULL, 'Myotactin form A', 113, NULL, NULL, 223328),
(223329, '1.10.20.10-FF-000357', NULL, NULL, 90, NULL, NULL, 223329),
(223330, '3.30.450.70-FF-000002', NULL, 'Trafficking protein particle complex subunit 4', 135, NULL, NULL, 223330),
(223331, '3.90.740.10-FF-000027', NULL, 'Isoleucyl-tRNA synthetase 2, mitochondrial', 156, NULL, NULL, 223331),
(223332, '1.10.3720.10-FF-000079', NULL, 'Oligopeptide ABC transporter, permease protein', 204, NULL, NULL, 223332),
(223333, '1.20.5.780-FF-000004', NULL, 'FXYD domain-containing ion transport regulator', 61, NULL, NULL, 223333),
(223334, '3.10.110.10-FF-000144', NULL, 'Ubiquitin-conjugating enzyme family protein', 159, NULL, NULL, 223334),
(223335, '1.25.40.20-FF-000283', NULL, 'Protein phosphatase 1 regulatory subunit', 93, NULL, NULL, 223335),
(223336, '3.30.200.20-FF-000082', NULL, 'Epithelial discoidin domain-containing receptor 1', 109, NULL, NULL, 223336),
(223337, '1.25.40.10-FF-000280', NULL, 'Pentatricopeptide repeat-containing protein', 146, NULL, NULL, 223337),
(223338, '3.40.50.720-FF-002060', NULL, 'Fatty acyl-CoA reductase', 164, NULL, NULL, 223338),
(223339, '3.40.50.150-FF-000247', NULL, 'tRNA (adenine(58)-N(1))-methyltransferase catalytic subunit TRM61', 226, NULL, NULL, 223339),
(223340, '1.10.533.10-FF-000072', NULL, 'Probable ATP-dependent RNA helicase DDX58', 103, NULL, NULL, 223340),
(223341, '1.20.1250.20-FF-001572', NULL, 'Uncharacterized protein', 381, NULL, NULL, 223341),
(223342, '1.10.730.10-FF-000221', NULL, 'Valyl-tRNA synthetase 2, mitochondrial', 218, NULL, NULL, 223342),
(223343, '4.10.60.10-FF-000009', NULL, 'Zinc finger CCHC-type and RNA-binding motif-containing protein 1', 46, NULL, NULL, 223343),
(223344, '2.40.240.10-FF-000066', NULL, 'Glutamine--tRNA ligase', 119, NULL, NULL, 223344),
(223345, '3.30.1010.10-FF-000018', NULL, 'phosphatidylinositol 4-kinase beta 1', 161, NULL, NULL, 223345),
(223346, '1.10.274.80-FF-000001', NULL, 'Toxin A', 100, NULL, NULL, 223346),
(223347, '2.60.40.150-FF-000177', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', 109, NULL, NULL, 223347),
(223348, '2.60.40.60-FF-000436', NULL, 'Uncharacterized protein', 109, NULL, NULL, 223348),
(223349, '1.20.1000.10-FF-000033', NULL, NULL, 293, NULL, NULL, 223349);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(223350, '2.40.70.10-FF-000553', NULL, NULL, 277, NULL, NULL, 223350),
(223351, '3.30.70.330-FF-001696', NULL, NULL, 97, NULL, NULL, 223351),
(223352, '1.10.506.10-FF-000048', NULL, 'Uncharacterized protein', 136, NULL, NULL, 223352),
(223353, '1.25.10.10-FF-002190', NULL, 'Uncharacterized protein', 451, NULL, NULL, 223353),
(223354, '3.30.565.10-FF-000442', NULL, 'Stage II sporulation E family protein', 139, NULL, NULL, 223354),
(223355, '3.50.50.60-FF-000070', NULL, 'Thiamine thiazole synthase, chloroplastic', 236, NULL, NULL, 223355),
(223356, '2.10.25.10-FF-001416', NULL, 'Predicted protein', 47, NULL, NULL, 223356),
(223357, '3.80.10.10-FF-002889', NULL, 'Nyctalopin', 197, NULL, NULL, 223357),
(223358, '3.30.40.10-FF-002331', NULL, 'Putative ras-like small GTPases', 96, NULL, NULL, 223358),
(223359, '3.30.160.60-FF-002574', NULL, 'Zinc finger protein 546', 35, NULL, NULL, 223359),
(223360, '3.40.50.1240-FF-000152', NULL, NULL, 101, NULL, NULL, 223360),
(223361, '3.30.1480.10-FF-000014', NULL, 'Transcription termination/antitermination protein NusA', 130, NULL, NULL, 223361),
(223362, '3.90.226.10-FF-000164', NULL, 'Trifunctional enzyme alpha subunit, mitochondrial-like protein', 299, NULL, NULL, 223362),
(223363, '3.40.850.10-FF-000232', NULL, 'Kinesin motor domain containing protein, putative', 447, NULL, NULL, 223363),
(223364, '3.40.190.10-FF-000232', NULL, 'Membrane-bound lytic murein transglycosylase F', 130, NULL, NULL, 223364),
(223365, '1.25.10.10-FF-000334', NULL, 'Cell differentiation protein-like protein', 268, NULL, NULL, 223365),
(223366, '1.10.565.10-FF-000089', NULL, 'Nuclear hormone receptor family member nhr-111', 102, NULL, NULL, 223366),
(223367, '1.25.10.10-FF-000391', NULL, 'ATP/GTP binding protein like 1', 266, NULL, NULL, 223367),
(223368, '2.30.310.10-FF-000001', NULL, 'Nuclear export mediator factor Nemf', 151, NULL, NULL, 223368),
(223369, '3.40.630.170-FF-000002', NULL, 'Glycylpeptide N-tetradecanoyltransferase', 395, NULL, NULL, 223369),
(223370, '3.40.120.10-FF-000019', NULL, 'Phosphoacetylglucosamine mutase', 84, NULL, NULL, 223370),
(223371, '2.60.260.20-FF-000088', NULL, 'GM14447', 127, NULL, NULL, 223371),
(223372, '3.30.200.20-FF-001947', NULL, 'TKL family protein kinase', 108, NULL, NULL, 223372),
(223373, '4.10.60.10-FF-000066', NULL, 'CCHC-type zinc finger, nucleic acid-binding protein a', 27, NULL, NULL, 223373),
(223374, '3.30.160.60-FF-002517', NULL, NULL, 27, NULL, NULL, 223374),
(223375, '1.10.1200.270-FF-000015', NULL, 'Os11g0260100 protein', 15, NULL, NULL, 223375),
(223376, '1.10.400.10-FF-000090', NULL, 'Uncharacterized protein', 83, NULL, NULL, 223376),
(223377, '3.30.420.40-FF-000071', NULL, 'Molecular chaperone DnaK', 175, NULL, NULL, 223377),
(223378, '1.20.1310.10-FF-000079', NULL, 'Cullin family protein', 114, NULL, NULL, 223378),
(223379, '3.40.1810.10-FF-000077', NULL, NULL, 68, NULL, NULL, 223379),
(223380, '2.40.160.10-FF-000065', NULL, 'Outer membrane protein, putative', 162, NULL, NULL, 223380),
(223381, '3.40.50.300-FF-000309', NULL, 'ABC transporter ATP-binding protein', 266, NULL, NULL, 223381),
(223382, '1.25.10.10-FF-000188', NULL, 'protein inscuteable homolog isoform X1', 398, NULL, NULL, 223382),
(223383, '3.80.10.10-FF-001607', NULL, 'Leucine-rich repeat receptor-like serine/threonine/tyrosine-protein kinase SOBIR1', 111, NULL, NULL, 223383),
(223384, '3.40.50.261-FF-000023', NULL, 'ATP-citrate synthase subunit alpha chain protein 1', 127, NULL, NULL, 223384),
(223385, '1.10.220.150-FF-000030', NULL, 'GTPase activating protein for Arf, putative', 133, NULL, NULL, 223385),
(223386, '3.40.50.300-FF-008476', NULL, 'Uncharacterized protein', 218, NULL, NULL, 223386),
(223387, '3.40.1060.10-FF-000008', NULL, 'Uncharacterized protein', 66, NULL, NULL, 223387),
(223388, '3.30.420.40-FF-000278', NULL, 'Actin-related protein 4', 152, NULL, NULL, 223388),
(223389, '3.40.50.2000-FF-000363', NULL, 'Lipopolysaccharide 1,6-galactosyltransferase', 169, NULL, NULL, 223389),
(223390, '3.30.210.10-FF-000017', NULL, 'DNA polymerase', 65, NULL, NULL, 223390);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(223391, '1.50.40.10-FF-000536', NULL, 'ADP/ATP carrier protein', 154, NULL, NULL, 223391),
(223392, '2.130.10.10-FF-000186', NULL, 'syntaxin-binding protein 5-like isoform X2', 180, NULL, NULL, 223392),
(223393, '1.10.510.10-FF-003936', NULL, NULL, 68, NULL, NULL, 223393),
(223394, '3.30.160.60-FF-001146', NULL, 'Zinc finger protein 555', 28, NULL, NULL, 223394),
(223395, '3.40.30.10-FF-000773', NULL, 'Peroxiredoxin, 1-Cys subfamily', 153, NULL, NULL, 223395),
(223396, '2.40.50.140-FF-000164', NULL, 'Exosome complex component CSL4', 163, NULL, NULL, 223396),
(223397, '1.10.10.60-FF-000736', NULL, 'Protein CBR-CEH-1', 92, NULL, NULL, 223397),
(223398, '2.10.70.10-FF-000178', NULL, 'Hig-anchoring scaffold protein, isoform C', 87, NULL, NULL, 223398),
(223399, '3.40.50.300-FF-000219', NULL, 'Dynein axonemal heavy chain 17', 150, NULL, NULL, 223399),
(223400, '1.10.287.70-FF-000769', NULL, 'Uncharacterized protein', 80, NULL, NULL, 223400),
(223401, '2.60.300.12-FF-000007', NULL, 'Iron-sulfur cluster assembly accessory protein', 109, NULL, NULL, 223401),
(223402, '3.40.640.10-FF-000429', NULL, 'Uncharacterized protein', 163, NULL, NULL, 223402),
(223403, '3.30.70.330-FF-001639', NULL, 'Uncharacterized protein', 165, NULL, NULL, 223403),
(223404, '2.40.70.10-FF-000199', NULL, 'WGS project CABT00000000 data, contig 2.21', 186, NULL, NULL, 223404),
(223405, '2.20.80.10-FF-000009', NULL, 'Uncharacterized protein', 254, NULL, NULL, 223405),
(223406, '2.60.40.10-FF-000623', NULL, 'obscurin-like protein 1 isoform X2', 107, NULL, NULL, 223406),
(223407, '2.10.25.10-FF-001506', NULL, 'Predicted protein', 37, NULL, NULL, 223407),
(223408, '3.30.310.50-FF-000037', NULL, 'Transcription factor Pcc1, putative', 87, NULL, NULL, 223408),
(223409, '3.90.120.10-FF-000025', NULL, 'tRNA (cytosine(38)-C(5))-methyltransferase', 126, NULL, NULL, 223409),
(223410, '3.30.70.330-FF-000414', NULL, 'Eukaryotic translation initiation factor 4H', 97, NULL, NULL, 223410),
(223411, '2.130.10.10-FF-000039', NULL, 'Guanine nucleotide-binding protein subunit beta-like protein', 308, NULL, NULL, 223411),
(223412, '2.40.50.690-FF-000008', NULL, 'Exosome complex exonuclease RRP44', 112, NULL, NULL, 223412),
(223413, '2.60.40.10-FF-000269', NULL, 'Growth hormone receptor', 101, NULL, NULL, 223413),
(223414, '3.40.50.300-FF-006267', NULL, 'Uncharacterized protein', 280, NULL, NULL, 223414),
(223415, '3.40.50.300-FF-002670', NULL, 'Os03g0282700 protein', 160, NULL, NULL, 223415),
(223416, '2.130.10.10-FF-002490', NULL, 'Syntaxin-binding protein 5-like', 437, NULL, NULL, 223416),
(223417, '2.60.40.10-FF-004423', NULL, NULL, 94, NULL, NULL, 223417),
(223418, '3.40.190.10-FF-000439', NULL, 'GLutamate Receptor family (AMPA)', 99, NULL, NULL, 223418),
(223419, '1.20.1070.10-FF-001206', NULL, 'Predicted protein', 138, NULL, NULL, 223419),
(223420, '1.25.40.10-FF-000128', NULL, 'General transcription factor IIIC, polypeptide 3, 102kDa', 316, NULL, NULL, 223420),
(223421, '1.25.40.10-FF-002337', NULL, 'Uncharacterized protein', 172, NULL, NULL, 223421),
(223422, '3.10.20.90-FF-000994', NULL, 'Uncharacterized protein', 87, NULL, NULL, 223422),
(223423, '3.10.490.10-FF-000019', NULL, 'Gamma-glutamylcyclotransferase', 239, NULL, NULL, 223423),
(223424, '2.40.10.10-FF-000370', NULL, NULL, 69, NULL, NULL, 223424),
(223425, '3.30.160.60-FF-002427', NULL, 'Zinc finger protein 552', 23, NULL, NULL, 223425),
(223426, '4.10.280.10-FF-000236', NULL, 'Os03g0279500 protein', 65, NULL, NULL, 223426),
(223427, '1.20.5.770-FF-000001', NULL, 'Period circadian protein', 34, NULL, NULL, 223427),
(223428, '3.20.20.220-FF-000087', NULL, 'Proline dehydrogenase', 57, NULL, NULL, 223428),
(223429, '3.40.50.970-FF-000105', NULL, '2-oxoglutarate dehydrogenase E1 component, putative', 374, NULL, NULL, 223429),
(223430, '3.30.497.10-FF-000042', NULL, 'GM21844', 227, NULL, NULL, 223430),
(223431, '3.40.50.300-FF-000927', NULL, 'Septum-promoting GTP-binding protein 1', 185, NULL, NULL, 223431),
(223432, '1.10.10.60-FF-000028', NULL, 'Paired box protein Pax-6', 57, NULL, NULL, 223432);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(223433, '1.10.540.10-FF-000127', NULL, 'Acyl-CoA dehydrogenase', 120, NULL, NULL, 223433),
(223434, '3.90.950.10-FF-000037', NULL, 'dTTP/UTP pyrophosphatase', 188, NULL, NULL, 223434),
(223435, '2.60.40.10-FF-002214', NULL, 'Kinase insert domain receptor (a type III receptor tyrosine kinase)', 88, NULL, NULL, 223435),
(223436, '3.90.290.10-FF-000037', NULL, 'Uncharacterized protein', 52, NULL, NULL, 223436),
(223437, '2.60.40.150-FF-000267', NULL, 'C2 domain-containing protein / GRAM domain-containing protein', 131, NULL, NULL, 223437),
(223438, '3.10.110.10-FF-000054', NULL, 'Ubiquitin-conjugating enzyme E2', 152, NULL, NULL, 223438),
(223439, '1.20.58.670-FF-000004', NULL, 'Exocyst complex component SEC15', 141, NULL, NULL, 223439),
(223440, '1.20.1110.10-FF-000069', NULL, 'Sodium/potassium-transporting ATPase subunit alpha', 94, NULL, NULL, 223440),
(223441, '2.70.150.10-FF-000024', NULL, 'Phospholipid-transporting ATPase', 129, NULL, NULL, 223441),
(223442, '3.90.110.10-FF-000030', NULL, NULL, 171, NULL, NULL, 223442),
(223443, '2.60.40.10-FF-003496', NULL, 'Uncharacterized protein, isoform A', 117, NULL, NULL, 223443),
(223444, '2.60.120.650-FF-000044', NULL, 'Ubiquitously transcribed tetratricopeptide repeat protein Y-linked transcript variant 21', 152, NULL, NULL, 223444),
(223445, '3.60.150.10-FF-000011', NULL, 'Chorismate synthase', 365, NULL, NULL, 223445),
(223446, '2.60.120.310-FF-000026', NULL, 'Uncharacterized protein', 116, NULL, NULL, 223446),
(223447, '3.30.565.10-FF-000352', NULL, 'Sensor histidine kinase/response regulator', 159, NULL, NULL, 223447),
(223448, '1.10.3120.10-FF-000022', NULL, NULL, 209, NULL, NULL, 223448),
(223449, '1.10.150.80-FF-000023', NULL, 'Unplaced genomic scaffold supercont1.38, whole genome shotgun sequence', 83, NULL, NULL, 223449),
(223450, '2.170.270.10-FF-000138', NULL, 'Predicted protein', 134, NULL, NULL, 223450),
(223451, '1.20.58.530-FF-000013', NULL, 'Unconventional myosin-XIX', 186, NULL, NULL, 223451),
(223452, '2.60.40.10-FF-000680', NULL, 'Beta-galactosidase', 110, NULL, NULL, 223452),
(223453, '3.30.450.40-FF-000218', NULL, 'Slr1385 protein', 202, NULL, NULL, 223453),
(223454, '2.10.25.10-FF-001563', NULL, 'Uncharacterized protein', 32, NULL, NULL, 223454),
(223455, '1.25.40.10-FF-004731', NULL, 'Protein CBR-PRP-6', 82, NULL, NULL, 223455),
(223456, '3.30.379.10-FF-000015', NULL, NULL, 141, NULL, NULL, 223456),
(223457, '1.10.510.10-FF-000502', NULL, 'Aurora kinase A', 178, NULL, NULL, 223457),
(223458, '2.60.40.10-FF-000062', NULL, 'Myosin-binding protein C, slow type', 104, NULL, NULL, 223458),
(223459, '3.40.50.10810-FF-000026', NULL, 'SWI/SNF related, matrix associated, actin dependent regulator of chromatin, subfamily a-like 1', 256, NULL, NULL, 223459),
(223460, '3.40.640.10-FF-000222', NULL, 'Uncharacterized protein', 291, NULL, NULL, 223460),
(223461, '3.40.50.10810-FF-000083', NULL, 'Helicase putative', 252, NULL, NULL, 223461),
(223462, '3.30.9.10-FF-000174', NULL, 'Aerobic glycerol-3-phosphate dehydrogenase GlpD', 158, NULL, NULL, 223462),
(223463, '1.20.120.1900-FF-000065', NULL, 'Gamma-tubulin complex component', 309, NULL, NULL, 223463),
(223464, '3.40.50.300-FF-005132', NULL, 'Uncharacterized protein', 242, NULL, NULL, 223464),
(223465, '3.20.20.140-FF-000097', NULL, 'Dal1p', 313, NULL, NULL, 223465),
(223466, '3.20.20.70-FF-000488', NULL, NULL, 112, NULL, NULL, 223466),
(223467, '2.60.40.10-FF-002832', NULL, 'Interleukin-3 receptor subunit alpha', 98, NULL, NULL, 223467),
(223468, '1.20.58.340-FF-000046', NULL, 'Magnesium transporter MRS2-2', 86, NULL, NULL, 223468),
(223469, '3.30.70.330-FF-002005', NULL, NULL, 83, NULL, NULL, 223469),
(223470, '1.25.40.20-FF-001300', NULL, 'DNA replication inhibitor plutonium', 156, NULL, NULL, 223470),
(223471, '3.90.1410.10-FF-000092', NULL, 'Predicted protein', 304, NULL, NULL, 223471),
(223472, '3.40.50.620-FF-000231', NULL, 'Multidrug MFS transporter', 130, NULL, NULL, 223472),
(223473, '1.10.238.10-FF-001009', NULL, 'Uncharacterized protein', 37, NULL, NULL, 223473),
(223474, '3.40.50.10900-FF-000019', NULL, 'Proteasome assembly chaperone 2', 143, NULL, NULL, 223474);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(223475, '1.20.120.330-FF-000008', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', 134, NULL, NULL, 223475),
(223476, '1.20.5.1430-FF-000006', NULL, 'Microtubule-associated protein RP/EB family member 1C', 79, NULL, NULL, 223476),
(223477, '1.10.10.60-FF-000175', NULL, 'Melibiose operon regulatory protein', 51, NULL, NULL, 223477),
(223478, '3.10.20.90-FF-000730', NULL, 'Regulator of G-protein signalling 14', 71, NULL, NULL, 223478),
(223479, '1.10.510.10-FF-001261', NULL, 'CAMK/CAMKL protein kinase, variant 1', 183, NULL, NULL, 223479),
(223480, '1.10.533.10-FF-000162', NULL, 'Myeloid differentiation primary response protein MyD88', 107, NULL, NULL, 223480),
(223481, '3.60.21.10-FF-000072', NULL, 'Ser/Thr protein phosphatase', 297, NULL, NULL, 223481),
(223482, '2.130.10.10-FF-000129', NULL, 'Notchless homolog 1 (Drosophila)', 387, NULL, NULL, 223482),
(223483, '1.20.1720.10-FF-000099', NULL, NULL, 213, NULL, NULL, 223483),
(223484, '3.30.70.890-FF-000059', NULL, 'Galactokinase', 165, NULL, NULL, 223484),
(223485, '3.30.70.330-FF-000504', NULL, 'Serine/arginine-rich splicing factor 2', 118, NULL, NULL, 223485),
(223486, '1.10.1070.11-FF-000092', NULL, 'Predicted protein', 68, NULL, NULL, 223486),
(223487, '1.20.1640.10-FF-000098', NULL, NULL, 179, NULL, NULL, 223487),
(223488, '3.10.20.30-FF-000055', NULL, 'Succinate dehydrogenase iron-sulfur subunit', 109, NULL, NULL, 223488),
(223489, '3.10.50.40-FF-000150', NULL, 'Peptidylprolyl isomerase', 133, NULL, NULL, 223489),
(223490, '2.20.70.10-FF-000071', NULL, 'FERM domain (Protein4.1-ezrin-radixin-moesin) family', 32, NULL, NULL, 223490),
(223491, '2.60.120.10-FF-000367', NULL, 'Crp/Fnr family transcriptional regulator', 144, NULL, NULL, 223491),
(223492, '1.20.1250.20-FF-001482', NULL, 'Uncharacterized protein', 411, NULL, NULL, 223492),
(223493, '1.20.58.60-FF-000216', NULL, 'Uncharacterized protein, isoform B', 209, NULL, NULL, 223493),
(223494, '3.90.1200.10-FF-000076', NULL, 'Uncharacterized protein', 198, NULL, NULL, 223494),
(223495, '2.40.160.10-FF-000003', NULL, 'Outer mitochondrial membrane protein porin', 275, NULL, NULL, 223495),
(223496, '1.20.1560.10-FF-000890', NULL, 'Uncharacterized protein', 98, NULL, NULL, 223496),
(223497, '3.30.70.100-FF-000076', NULL, 'Thiosulfate sulfurtransferase/rhodanese-like domain-containing protein 2', 106, NULL, NULL, 223497),
(223498, '3.90.1100.10-FF-000017', NULL, 'DNA-directed RNA polymerase subunit beta', 178, NULL, NULL, 223498),
(223499, '3.30.70.330-FF-001965', NULL, NULL, 104, NULL, NULL, 223499),
(223500, '3.10.110.10-FF-000205', NULL, 'Ubiquitin-conjugating enzyme, putative', 76, NULL, NULL, 223500),
(223501, '3.80.10.10-FF-001669', NULL, 'Predicted protein', 96, NULL, NULL, 223501),
(223502, '1.25.40.10-FF-004580', NULL, 'Uncharacterized protein', 181, NULL, NULL, 223502),
(223503, '1.10.510.10-FF-003728', NULL, NULL, 152, NULL, NULL, 223503),
(223504, '3.40.50.720-FF-000997', NULL, 'Molybdopterin biosynthesis protein MoeB', 245, NULL, NULL, 223504),
(223505, '2.160.20.10-FF-000325', NULL, 'Uncharacterized protein', 150, NULL, NULL, 223505),
(223506, '3.30.160.60-FF-001062', NULL, 'Zinc finger protein 142', 33, NULL, NULL, 223506),
(223507, '3.30.500.10-FF-000028', NULL, NULL, 44, NULL, NULL, 223507),
(223508, '2.40.50.40-FF-000004', NULL, 'C-X-C motif chemokine', 74, NULL, NULL, 223508),
(223509, '2.120.10.80-FF-000190', NULL, 'Os09g0555300 protein', 166, NULL, NULL, 223509),
(223510, '3.80.10.10-FF-001725', NULL, 'Dynein assembly factor 1, axonemal homolog', 159, NULL, NULL, 223510),
(223511, '2.40.160.20-FF-000006', NULL, 'p44/Msp2 family outer membrane protein', 181, NULL, NULL, 223511),
(223512, '2.40.10.500-FF-000005', NULL, NULL, 90, NULL, NULL, 223512),
(223513, '3.40.50.300-FF-008392', NULL, 'DNA helicase', 191, NULL, NULL, 223513),
(223514, '3.40.50.10490-FF-000149', NULL, NULL, 174, NULL, NULL, 223514),
(223515, '2.40.40.10-FF-000017', NULL, NULL, 125, NULL, NULL, 223515),
(223516, '3.30.54.20-FF-000005', NULL, 'Alanine--tRNA ligase', 56, NULL, NULL, 223516); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(223517, '1.10.135.10-FF-000006', NULL, 'GD11708', 87, NULL, NULL, 223517),
(223518, '3.30.560.10-FF-000004', NULL, 'Dehydrogenase FAD flavoprotein GMC oxidoreductase', 283, NULL, NULL, 223518),
(223519, '1.10.510.10-FF-002626', NULL, NULL, 82, NULL, NULL, 223519),
(223520, '1.10.3080.10-FF-000018', NULL, 'Chloride transporter, ClC family', 443, NULL, NULL, 223520),
(223521, '1.10.472.10-FF-000553', NULL, 'Cyclin, N-terminal domain containing protein', 72, NULL, NULL, 223521),
(223522, '1.20.1250.20-FF-001156', NULL, 'Uncharacterized protein', 216, NULL, NULL, 223522),
(223523, '1.10.30.10-FF-000099', NULL, 'Axial regulator YABBY 4', 105, NULL, NULL, 223523),
(223524, '3.40.30.10-FF-000565', NULL, 'Glutaredoxin/Glutathione_S-transferase_-_N-terminal_domain_containing_protein_-_putative', 102, NULL, NULL, 223524),
(223525, '3.30.70.330-FF-001488', NULL, 'RNA-binding protein, putative', 116, NULL, NULL, 223525),
(223526, '1.50.40.10-FF-000098', NULL, 'Mitochondrial substrate carrier family protein', 290, NULL, NULL, 223526),
(223527, '3.40.50.300-FF-002462', NULL, 'ATP-dependent helicase HrpB', 168, NULL, NULL, 223527),
(223528, '4.10.60.10-FF-000010', NULL, 'Zinc knuckle domain containing protein', 28, NULL, NULL, 223528),
(223529, '2.170.130.10-FF-000072', NULL, NULL, 151, NULL, NULL, 223529),
(223530, '3.30.2130.10-FF-000022', NULL, 'Aspartate kinase', 150, NULL, NULL, 223530),
(223531, '1.10.20.10-FF-000183', NULL, 'YALI0F17072p', 151, NULL, NULL, 223531),
(223532, '3.20.20.140-FF-000327', NULL, 'Error-prone DNA polymerase', 251, NULL, NULL, 223532),
(223533, '3.30.300.180-FF-000006', NULL, 'Chromosomal replication initiator protein DnaA', 99, NULL, NULL, 223533),
(223534, '1.20.120.230-FF-000012', NULL, 'Catenin alpha-2 isoform 1', 112, NULL, NULL, 223534),
(223535, '3.20.20.10-FF-000077', NULL, 'Predicted protein', 184, NULL, NULL, 223535),
(223536, '3.30.200.20-FF-002403', NULL, 'Probable inactive serine/threonine-protein kinase DDB_G0278909', 90, NULL, NULL, 223536),
(223537, '2.60.40.10-FF-002568', NULL, 'Uncharacterized protein', 90, NULL, NULL, 223537),
(223538, '1.20.120.1110-FF-000008', NULL, 'Uncharacterized protein', 109, NULL, NULL, 223538),
(223539, '1.10.287.690-FF-000023', NULL, 'DNA polymerase', 61, NULL, NULL, 223539),
(223540, '2.60.34.10-FF-000064', NULL, 'Heat shock protein 88', 158, NULL, NULL, 223540),
(223541, '3.90.70.10-FF-000251', NULL, 'Cysteine protease 16', 318, NULL, NULL, 223541),
(223542, '3.60.20.30-FF-000002', NULL, 'Taspase, threonine aspartase, 1', 164, NULL, NULL, 223542),
(223543, '3.80.10.10-FF-001046', NULL, 'Leucine Rich repeat, putative', 201, NULL, NULL, 223543),
(223544, '1.10.530.10-FF-000065', NULL, 'Membrane-bound lytic murein transglycosylase B', 176, NULL, NULL, 223544),
(223545, '3.90.780.10-FF-000030', NULL, 'UshA related metallophosphatase, N-terminal domain', 196, NULL, NULL, 223545),
(223546, '3.40.50.300-FF-000484', NULL, 'Cytidylate kinase', 222, NULL, NULL, 223546),
(223547, '3.60.20.40-FF-000005', NULL, 'gamma-glutamyltransferase 5 isoform X3', 187, NULL, NULL, 223547),
(223548, '3.90.70.10-FF-000397', NULL, 'Putative ubiquitin carboxy-terminal hydrolase', 243, NULL, NULL, 223548),
(223549, '3.40.47.10-FF-000042', NULL, 'Polyketide synthase Pks13', 472, NULL, NULL, 223549),
(223550, '2.40.20.10-FF-000073', NULL, 'Uncharacterized protein', 101, NULL, NULL, 223550),
(223551, '1.20.58.610-FF-000003', NULL, 'Cdc37p', 134, NULL, NULL, 223551),
(223552, '3.90.730.10-FF-000026', NULL, 'Uncharacterized protein', 203, NULL, NULL, 223552),
(223553, '2.70.150.10-FF-000086', NULL, 'Calcium-transporting ATPase', 60, NULL, NULL, 223553),
(223554, '3.40.630.30-FF-000699', NULL, 'RNA cytidine acetyltransferase', 221, NULL, NULL, 223554),
(223555, '2.60.34.10-FF-000120', NULL, 'Heat shock protein70, hsp70A2, putative', 81, NULL, NULL, 223555),
(223556, '2.30.42.10-FF-000320', NULL, 'PDZ and LIM domain 1', 69, NULL, NULL, 223556),
(223557, '2.60.40.150-FF-000593', NULL, 'Uncharacterized protein', 130, NULL, NULL, 223557),
(223558, '2.20.100.10-FF-000015', NULL, 'Thrombospondin, type I, domain containing 7A', 56, NULL, NULL, 223558);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(223559, '2.10.25.10-FF-001153', NULL, 'SCO-spondin', 57, NULL, NULL, 223559),
(223560, '3.20.20.70-FF-000667', NULL, NULL, 220, NULL, NULL, 223560),
(223561, '3.10.20.90-FF-000668', NULL, 'Small ubiquitin-related modifier', 79, NULL, NULL, 223561),
(223562, '3.50.4.10-FF-000005', NULL, 'Serine/threonine-protein kinase', 60, NULL, NULL, 223562),
(223563, '1.10.510.10-FF-000446', NULL, 'Microtubule associated serine/threonine kinase 2', 206, NULL, NULL, 223563),
(223564, '2.170.270.10-FF-000082', NULL, 'Histone-lysine N-methyltransferase', 266, NULL, NULL, 223564),
(223565, '1.20.1250.20-FF-000700', NULL, 'Solute carrier family 45, member 1/2/4', 385, NULL, NULL, 223565),
(223566, '2.60.40.1170-FF-000076', NULL, NULL, 100, NULL, NULL, 223566),
(223567, '3.10.100.10-FF-000233', NULL, NULL, 51, NULL, NULL, 223567),
(223568, '2.40.10.10-FF-000515', NULL, NULL, 55, NULL, NULL, 223568),
(223569, '1.10.10.10-FF-001790', NULL, 'Predicted protein', 85, NULL, NULL, 223569),
(223570, '3.30.160.60-FF-006109', NULL, NULL, 85, NULL, NULL, 223570),
(223571, '1.10.30.10-FF-000155', NULL, 'Uncharacterized protein', 74, NULL, NULL, 223571),
(223572, '3.40.1090.10-FF-000015', NULL, 'Patatin like phospholipase domain containing 7', 111, NULL, NULL, 223572),
(223573, '3.30.1050.10-FF-000021', NULL, 'Alkyl sulfatase, putative', 119, NULL, NULL, 223573),
(223574, '3.30.1680.10-FF-000052', NULL, 'Integrin beta', 54, NULL, NULL, 223574),
(223575, '2.60.40.10-FF-004715', NULL, NULL, 120, NULL, NULL, 223575),
(223576, '2.40.70.10-FF-000109', NULL, 'Eukaryotic aspartyl protease family protein', 207, NULL, NULL, 223576),
(223577, '3.30.1130.10-FF-000022', NULL, 'Related to multifunctional folic acid synthesis protein', 127, NULL, NULL, 223577),
(223578, '3.30.565.10-FF-000026', NULL, 'Serine-protein kinase RsbW', 148, NULL, NULL, 223578),
(223579, '3.40.30.10-FF-001026', NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 2', 51, NULL, NULL, 223579),
(223580, '3.40.50.1820-FF-001837', NULL, 'Carboxypeptidase', 316, NULL, NULL, 223580),
(223581, '3.40.525.10-FF-000061', NULL, 'CRAL-TRIO domain-containing protein C365.01', 286, NULL, NULL, 223581),
(223582, '3.40.50.300-FF-008066', NULL, 'Uncharacterized protein', 123, NULL, NULL, 223582),
(223583, '1.10.510.10-FF-004341', NULL, NULL, 131, NULL, NULL, 223583),
(223584, '2.60.60.20-FF-000066', NULL, NULL, 76, NULL, NULL, 223584),
(223585, '3.30.70.1010-FF-000001', NULL, 'Elongation factor 1-gamma 1', 158, NULL, NULL, 223585),
(223586, '1.20.1250.20-FF-001633', NULL, 'Protein NRT1/ PTR FAMILY 5.10', 101, NULL, NULL, 223586),
(223587, '3.90.70.10-FF-000195', NULL, 'Cathepsin L-like protease', 309, NULL, NULL, 223587),
(223588, '1.20.1070.10-FF-001532', NULL, 'Atypical chemokine receptor 3', 182, NULL, NULL, 223588),
(223589, '2.40.30.10-FF-000045', NULL, 'Dihydroorotate dehydrogenase B (NAD(+)), electron transfer subunit', 97, NULL, NULL, 223589),
(223590, '1.25.40.20-FF-000991', NULL, 'Protein phosphatase 1 regulatory inhibitor subunit 16B', 171, NULL, NULL, 223590),
(223591, '2.60.40.1180-FF-000079', NULL, 'Glucosylceramidase, putative', 62, NULL, NULL, 223591),
(223592, '3.90.550.50-FF-000007', NULL, 'Glycoprotein-N-acetylgalactosamine 3-beta-galactosyltransferase 1', 203, NULL, NULL, 223592),
(223593, '2.40.110.10-FF-000062', NULL, 'Acyl-CoA oxidase like', 47, NULL, NULL, 223593),
(223594, '1.20.144.10-FF-000025', NULL, 'Lipid phosphate phosphatase, putative', 118, NULL, NULL, 223594),
(223595, '2.10.25.10-FF-000692', NULL, 'Agrin', 68, NULL, NULL, 223595),
(223596, '2.60.40.10-FF-002624', NULL, 'Uncharacterized protein', 103, NULL, NULL, 223596),
(223597, '3.40.50.300-FF-006149', NULL, 'DNA helicase', 91, NULL, NULL, 223597),
(223598, '4.10.400.10-FF-000325', NULL, 'sortilin-related receptor-like', 47, NULL, NULL, 223598),
(223599, '4.10.860.120-FF-000028', NULL, 'RNA polymerase Rpb1, domain 1 family protein', 123, NULL, NULL, 223599),
(223600, '2.60.40.1360-FF-000009', NULL, 'Alpha-mannosidase', 119, NULL, NULL, 223600),
(223601, '1.10.10.390-FF-000005', NULL, 'Histone acetyltransferase type B catalytic subunit', 53, NULL, NULL, 223601);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(223602, '3.30.40.10-FF-000206', NULL, 'BRCA1-associated protein isoform X1', 48, NULL, NULL, 223602),
(223603, '2.160.20.70-FF-000034', NULL, 'Tubulin-specific chaperone C', 170, NULL, NULL, 223603),
(223604, '2.60.11.10-FF-000017', NULL, 'Predicted protein', 96, NULL, NULL, 223604),
(223605, '2.60.40.1730-FF-000087', NULL, NULL, 195, NULL, NULL, 223605),
(223606, '3.20.20.150-FF-000010', NULL, 'Mannonate dehydratase', 384, NULL, NULL, 223606),
(223607, '3.30.70.330-FF-002331', NULL, NULL, 167, NULL, NULL, 223607),
(223608, '1.20.1560.10-FF-000125', NULL, 'Hypothetical ABC transporter ATP-binding protein yddA', 343, NULL, NULL, 223608),
(223609, '3.40.50.11980-FF-000023', NULL, 'Uncharacterized protein', 204, NULL, NULL, 223609),
(223610, '3.30.1330.60-FF-000029', NULL, 'Outer membrane protein OmpA', 134, NULL, NULL, 223610),
(223611, '1.25.10.10-FF-000481', NULL, 'Transportin', 368, NULL, NULL, 223611),
(223612, '3.10.120.10-FF-000026', NULL, 'Protein vem-1', 105, NULL, NULL, 223612),
(223613, '3.60.21.10-FF-000156', NULL, 'Integral membrane protein', 226, NULL, NULL, 223613),
(223614, '2.120.10.30-FF-000012', NULL, 'Low density lipoprotein receptor-related protein 1', 295, NULL, NULL, 223614),
(223615, '3.30.365.10-FF-000045', NULL, 'Aldehyde oxidase and xanthine dehydrogenase, a/b hammerhead domain', 73, NULL, NULL, 223615),
(223616, '3.30.40.10-FF-001308', NULL, 'AGAP000928-PA', 75, NULL, NULL, 223616),
(223617, '1.20.1110.10-FF-000154', NULL, NULL, 235, NULL, NULL, 223617),
(223618, '1.25.40.10-FF-002163', NULL, 'Embryo specific2', 197, NULL, NULL, 223618),
(223619, '1.10.238.10-FF-000902', NULL, 'Calcium channel, putative', 108, NULL, NULL, 223619),
(223620, '3.50.50.60-FF-000013', NULL, 'Glycerol-3-phosphate dehydrogenase', 215, NULL, NULL, 223620),
(223621, '1.20.58.390-FF-000044', NULL, 'neuronal acetylcholine receptor subunit alpha-9', 67, NULL, NULL, 223621),
(223622, '1.10.238.10-FF-000846', NULL, 'Calmodulin, putative', 74, NULL, NULL, 223622),
(223623, '3.40.50.10190-FF-000273', NULL, 'Putative dna topoisomerase 2-binding protein 1 isoform x1', 97, NULL, NULL, 223623),
(223624, '1.10.420.10-FF-000034', NULL, 'Cationic peroxidase 2', 58, NULL, NULL, 223624),
(223625, '1.25.50.10-FF-000011', NULL, 'Membrane alanine aminopeptidase', 324, NULL, NULL, 223625),
(223626, '1.10.290.10-FF-000001', NULL, 'DNA topoisomerase', 127, NULL, NULL, 223626),
(223627, '3.30.160.60-FF-002843', NULL, NULL, 27, NULL, NULL, 223627),
(223628, '1.25.40.10-FF-004254', NULL, 'Rap phosphatase', 231, NULL, NULL, 223628),
(223629, '2.90.10.10-FF-000019', NULL, 'Serine/threonine-protein kinase', 132, NULL, NULL, 223629),
(223630, '1.10.238.10-FF-000256', NULL, 'probable calcium-binding protein CML20', 88, NULL, NULL, 223630),
(223631, '1.10.565.10-FF-000179', NULL, 'Hepatocyte nuclear factor 4, alpha', 156, NULL, NULL, 223631),
(223632, '1.20.1070.10-FF-001055', NULL, 'Zinc finger protein', 186, NULL, NULL, 223632),
(223633, '2.60.40.60-FF-000228', NULL, 'Cadherin 23', 101, NULL, NULL, 223633),
(223634, '1.25.40.20-FF-001710', NULL, 'CARD- and ANK-containing Inflammasome Adaptor Protein', 51, NULL, NULL, 223634),
(223635, '3.40.30.10-FF-000239', NULL, 'Iodothyronine deiodinase', 190, NULL, NULL, 223635),
(223636, '3.30.1360.70-FF-000006', NULL, 'Arginyl-tRNA synthetase', 134, NULL, NULL, 223636),
(223637, '3.10.450.50-FF-000063', NULL, 'Uncharacterized protein', 174, NULL, NULL, 223637),
(223638, '3.30.420.100-FF-000004', NULL, '50S ribosomal protein L18', 118, NULL, NULL, 223638),
(223639, '2.40.70.10-FF-000435', NULL, NULL, 104, NULL, NULL, 223639),
(223640, '3.30.70.330-FF-000240', NULL, 'RNA binding motif protein 19', 114, NULL, NULL, 223640),
(223641, '2.40.420.20-FF-000049', NULL, 'Multidrug resistance protein', 92, NULL, NULL, 223641),
(223642, '1.10.220.10-FF-000053', NULL, 'Uncharacterized protein', 70, NULL, NULL, 223642),
(223643, '1.10.8.270-FF-000112', NULL, 'Spindle protein, putative', 89, NULL, NULL, 223643),
(223644, '2.60.120.200-FF-000201', NULL, 'Uncharacterized protein, isoform A', 209, NULL, NULL, 223644);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(223645, '1.20.1070.10-FF-001734', NULL, 'Uncharacterized protein', 90, NULL, NULL, 223645),
(223646, '3.90.980.20-FF-000019', NULL, 'Cysteine-rich protein 2-binding protein, putative', 121, NULL, NULL, 223646),
(223647, '3.40.640.10-FF-000137', NULL, 'Cystathionine beta-lyase', 258, NULL, NULL, 223647),
(223648, '3.10.180.10-FF-000002', NULL, 'Lactoylglutathione lyase', 131, NULL, NULL, 223648),
(223649, '2.60.120.920-FF-000176', NULL, 'Uncharacterized protein', 58, NULL, NULL, 223649),
(223650, '3.90.79.10-FF-000271', NULL, 'Nudix hydrolase 15 mitochondrial', 100, NULL, NULL, 223650),
(223651, '3.30.450.40-FF-000134', NULL, 'Transcriptional regulatory protein', 162, NULL, NULL, 223651),
(223652, '1.20.1280.50-FF-000161', NULL, 'F-box and WD repeat domain containing 9', 88, NULL, NULL, 223652),
(223653, '3.50.7.10-FF-000012', NULL, 'Chaperonin CPN60, mitochondrial', 192, NULL, NULL, 223653),
(223654, '3.90.150.10-FF-000004', NULL, 'Variant surface glycoprotein (VSG, atypical), putative', 194, NULL, NULL, 223654),
(223655, '3.30.160.60-FF-004934', NULL, NULL, 36, NULL, NULL, 223655),
(223656, '3.30.530.20-FF-000185', NULL, 'Polyketide cyclase/dehydrase and lipid transport superfamily protein', 90, NULL, NULL, 223656),
(223657, '3.40.50.300-FF-002136', NULL, 'Small rab-related GTPase', 190, NULL, NULL, 223657),
(223658, '1.10.287.110-FF-000338', NULL, 'DnaJ-like protein', 75, NULL, NULL, 223658),
(223659, '2.10.110.10-FF-000153', NULL, 'Rho GTPase activator (Lrg11), putative', 78, NULL, NULL, 223659),
(223660, '3.10.20.90-FF-000466', NULL, 'Autophagy-related protein', 110, NULL, NULL, 223660),
(223661, '2.40.170.20-FF-000041', NULL, 'Hemin receptor', 510, NULL, NULL, 223661),
(223662, '2.30.180.10-FF-000029', NULL, 'Uncharacterized protein, isoform C', 176, NULL, NULL, 223662),
(223663, '3.30.70.3290-FF-000022', NULL, 'Polyketide synthase', 115, NULL, NULL, 223663),
(223664, '1.20.82.10-FF-000005', NULL, 'Predicted protein', 159, NULL, NULL, 223664),
(223665, '2.30.180.10-FF-000057', NULL, 'Fasciclin-like protein', 143, NULL, NULL, 223665),
(223666, '3.20.20.450-FF-000010', NULL, 'Cyclic diguanylate phosphodiesterase (EAL) domain protein', 256, NULL, NULL, 223666),
(223667, '3.40.630.30-FF-000227', NULL, 'Histone acetyltransferase type B catalytic subunit', 134, NULL, NULL, 223667),
(223668, '1.20.58.1080-FF-000002', NULL, 'DExH-box ATP-dependent RNA helicase DExH18 mitochondrial', 106, NULL, NULL, 223668),
(223669, '3.40.630.10-FF-000221', NULL, 'Clan MH, family M18, aspartyl aminopeptidase-like metallopeptidase', 267, NULL, NULL, 223669),
(223670, '3.30.1380.10-FF-000012', NULL, 'Hedgehog2', 165, NULL, NULL, 223670),
(223671, '1.25.10.10-FF-003122', NULL, 'Predicted protein', 208, NULL, NULL, 223671),
(223672, '3.40.50.12160-FF-000004', NULL, 'Threonylcarbamoyladenosine tRNA methylthiotransferase MtaB', 129, NULL, NULL, 223672),
(223673, '3.40.630.30-FF-000497', NULL, 'Uncharacterized protein', 135, NULL, NULL, 223673),
(223674, '3.40.630.10-FF-000367', NULL, 'Uncharacterized protein', 125, NULL, NULL, 223674),
(223675, '1.25.10.10-FF-002189', NULL, 'Uncharacterized protein', 451, NULL, NULL, 223675),
(223676, '3.40.225.10-FF-000021', NULL, 'Class II aldolase/adducin domain protein', 209, NULL, NULL, 223676),
(223677, '1.25.40.10-FF-001674', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', 124, NULL, NULL, 223677),
(223678, '1.20.58.1480-FF-000032', NULL, 'Protein cereblon homolog-like Protein', 60, NULL, NULL, 223678),
(223679, '3.40.190.290-FF-000015', NULL, 'LysR family transcriptional regulator', 211, NULL, NULL, 223679),
(223680, '3.40.50.300-FF-004227', NULL, 'Ribosome dissociation factor GTPase', 250, NULL, NULL, 223680),
(223681, '3.40.50.150-FF-001759', NULL, NULL, 237, NULL, NULL, 223681),
(223682, '1.10.238.10-FF-000346', NULL, 'Sarcoplasmic Calcium-Binding protein', 183, NULL, NULL, 223682),
(223683, '1.25.40.10-FF-002814', NULL, 'Signal recognition particle subunit SRP72', 160, NULL, NULL, 223683),
(223684, '1.20.1070.10-FF-000689', NULL, 'Uncharacterized protein', 225, NULL, NULL, 223684);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(223685, '3.40.50.300-FF-004351', NULL, 'ATP (GTP)-binding protein', 240, NULL, NULL, 223685),
(223686, '2.130.10.10-FF-004137', NULL, 'Angio-associated migratory cell protein', 182, NULL, NULL, 223686),
(223687, '3.30.450.40-FF-000044', NULL, 'Putative sensor histidine kinase/response regulator', 178, NULL, NULL, 223687),
(223688, '1.20.1280.290-FF-000027', NULL, 'MtN3-like protein', 89, NULL, NULL, 223688),
(223689, '1.10.1200.10-FF-000079', NULL, 'Acyl carrier protein', 76, NULL, NULL, 223689),
(223690, '1.10.510.10-FF-004190', NULL, NULL, 284, NULL, NULL, 223690),
(223691, '1.25.40.20-FF-000726', NULL, 'Intracelllar PhosphoLipase A family', 224, NULL, NULL, 223691),
(223692, '2.60.40.10-FF-004013', NULL, NULL, 99, NULL, NULL, 223692),
(223693, '3.40.50.12150-FF-000001', NULL, 'Proline reductase for pyrrolysine biosynthesis', 124, NULL, NULL, 223693),
(223694, '1.25.10.10-FF-000542', NULL, 'Phosphoinositide 3-kinase regulatory subunit 4', 149, NULL, NULL, 223694),
(223695, '3.80.10.10-FF-002827', NULL, 'Uncharacterized protein', 95, NULL, NULL, 223695),
(223696, '3.40.190.10-FF-000024', NULL, 'Glutamate receptor, ionotropic, delta 1', 120, NULL, NULL, 223696),
(223697, '1.10.1300.10-FF-000030', NULL, 'Phosphodiesterase', 367, NULL, NULL, 223697),
(223698, '1.20.272.10-FF-000081', NULL, NULL, 77, NULL, NULL, 223698),
(223699, '1.10.3720.10-FF-000135', NULL, 'Sugar-transport integral membrane protein ABC transporter SugA', 276, NULL, NULL, 223699),
(223700, '1.10.340.30-FF-000039', NULL, 'Endonuclease III homolog', 110, NULL, NULL, 223700),
(223701, '3.30.70.330-FF-002421', NULL, NULL, 91, NULL, NULL, 223701),
(223702, '1.10.3260.10-FF-000055', NULL, 'Uncharacterized protein', 44, NULL, NULL, 223702),
(223703, '3.30.30.30-FF-000066', NULL, 'Uncharacterized protein', 64, NULL, NULL, 223703),
(223704, '3.30.450.50-FF-000047', NULL, 'Vesicle-associated membrane protein 7', 131, NULL, NULL, 223704),
(223705, '2.130.10.10-FF-002046', NULL, 'Axonemal dynein intermediate chain', 191, NULL, NULL, 223705),
(223706, '3.60.21.10-FF-000482', NULL, '5''-nucleotidase ecto', 226, NULL, NULL, 223706),
(223707, '3.30.70.580-FF-000023', NULL, 'tRNA pseudouridine synthase A', 102, NULL, NULL, 223707),
(223708, '3.40.720.10-FF-000279', NULL, 'Predicted protein', 313, NULL, NULL, 223708),
(223709, '3.90.230.10-FF-000005', NULL, 'FACT complex subunit spt16', 260, NULL, NULL, 223709),
(223710, '3.90.980.20-FF-000014', NULL, 'Uncharacterized protein', 106, NULL, NULL, 223710),
(223711, '2.20.25.10-FF-000079', NULL, 'DNA-directed RNA polymerase subunit', 54, NULL, NULL, 223711),
(223712, '1.10.10.470-FF-000001', NULL, 'Malto-oligosyltrehalose synthase', 117, NULL, NULL, 223712),
(223713, '3.30.420.40-FF-000306', NULL, 'Tetratricopeptide repeat-like superfamily protein', 106, NULL, NULL, 223713),
(223714, '3.30.40.10-FF-000004', NULL, 'Jade family PHD finger 2', 61, NULL, NULL, 223714),
(223715, '2.30.40.10-FF-000097', NULL, 'Enamidase', 128, NULL, NULL, 223715),
(223716, '3.50.50.60-FF-000159', NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', 390, NULL, NULL, 223716),
(223717, '1.20.920.30-FF-000014', NULL, 'Dynein heavy chain', 143, NULL, NULL, 223717),
(223718, '3.80.10.10-FF-003940', NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', 232, NULL, NULL, 223718),
(223719, '3.30.230.70-FF-000019', NULL, '3 exoribonuclease family protein', 280, NULL, NULL, 223719),
(223720, '3.40.50.2300-FF-001408', NULL, NULL, 98, NULL, NULL, 223720),
(223721, '1.10.10.480-FF-000004', NULL, 'Probable ATP-dependent 6-phosphofructokinase', 61, NULL, NULL, 223721),
(223722, '1.20.58.400-FF-000002', NULL, 'Vesicle transport v-SNARE protein', 93, NULL, NULL, 223722),
(223723, '2.60.40.10-FF-004395', NULL, NULL, 98, NULL, NULL, 223723),
(223724, '1.50.40.10-FF-000328', NULL, 'ADP/ATP translocase 3-like', 293, NULL, NULL, 223724),
(223725, '2.120.10.30-FF-000158', NULL, 'Pro-epidermal growth factor', 302, NULL, NULL, 223725),
(223726, '1.25.10.10-FF-002335', NULL, 'Importin, putative', 295, NULL, NULL, 223726),
(223727, '3.40.190.10-FF-000703', NULL, 'Uncharacterized protein', 219, NULL, NULL, 223727);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(223728, '2.130.10.10-FF-002282', NULL, 'WD domain, G-beta repeat, putative', 229, NULL, NULL, 223728),
(223729, '3.80.20.20-FF-000009', NULL, 'Receptor protein-tyrosine kinase', 173, NULL, NULL, 223729),
(223730, '3.30.450.30-FF-000041', NULL, 'Roadblock/LC7 family protein', 121, NULL, NULL, 223730),
(223731, '2.70.170.10-FF-000172', NULL, 'Uncharacterized protein', 148, NULL, NULL, 223731),
(223732, '3.40.640.10-FF-000430', NULL, 'Uncharacterized protein', 148, NULL, NULL, 223732),
(223733, '2.10.90.10-FF-000095', NULL, 'Transforming growth factor beta-3', 64, NULL, NULL, 223733),
(223734, '3.30.200.20-FF-000609', NULL, 'CMGC/DYRK/PRP4 protein kinase, variant', 96, NULL, NULL, 223734),
(223735, '1.25.40.10-FF-003944', NULL, 'Uncharacterized protein', 373, NULL, NULL, 223735),
(223736, '1.10.3430.10-FF-000040', NULL, 'Uncharacterized protein', 313, NULL, NULL, 223736),
(223737, '3.20.20.300-FF-000021', NULL, 'Beta-glucosidase', 372, NULL, NULL, 223737),
(223738, '3.30.559.30-FF-000035', NULL, 'Hydroxamate-type ferrichrome siderophore peptide synthetase', 238, NULL, NULL, 223738),
(223739, '1.20.58.420-FF-000008', NULL, NULL, 84, NULL, NULL, 223739),
(223740, '1.20.1250.30-FF-000001', NULL, NULL, 97, NULL, NULL, 223740),
(223741, '2.20.20.110-FF-000002', NULL, 'DNA repair protein Rad4 family', 50, NULL, NULL, 223741),
(223742, '1.20.120.980-FF-000029', NULL, 'AGAP000994', 151, NULL, NULL, 223742),
(223743, '3.40.1110.10-FF-000277', NULL, NULL, 180, NULL, NULL, 223743),
(223744, '6.10.140.2190-FF-000001', NULL, 'BPP', 59, NULL, NULL, 223744),
(223745, '1.25.40.10-FF-003596', NULL, 'Adenylate/guanylate cyclase domain-containing protein', 145, NULL, NULL, 223745),
(223746, '1.20.930.80-FF-000007', NULL, 'DNA primase large subunit', 256, NULL, NULL, 223746),
(223747, '2.40.160.50-FF-000026', NULL, 'Sorting and assembly machinery component 50 homolog', 123, NULL, NULL, 223747),
(223748, '2.60.40.10-FF-005497', NULL, NULL, 95, NULL, NULL, 223748),
(223749, '2.10.220.10-FF-000156', NULL, 'Uncharacterized protein', 67, NULL, NULL, 223749),
(223750, '1.20.120.1350-FF-000001', NULL, 'Matrix M2-1', 179, NULL, NULL, 223750),
(223751, '3.80.10.10-FF-002597', NULL, 'NLR family CARD domain containing 3', 74, NULL, NULL, 223751),
(223752, '2.60.40.420-FF-000106', NULL, 'Laccase-like multicopper oxidase 2', 193, NULL, NULL, 223752),
(223753, '3.40.50.1980-FF-000025', NULL, 'Iron ABC transporter substrate-binding protein', 152, NULL, NULL, 223753),
(223754, '3.30.200.20-FF-002408', NULL, 'Serine/threonine protein kinase', 88, NULL, NULL, 223754),
(223755, '2.10.25.10-FF-001708', NULL, 'Uncharacterized protein', 41, NULL, NULL, 223755),
(223756, '3.40.309.10-FF-000019', NULL, '4-trimethylaminobutyraldehyde dehydrogenase isoform X1', 198, NULL, NULL, 223756),
(223757, '6.10.140.2230-FF-000002', NULL, 'RNA polymerase-associated protein RapA', 51, NULL, NULL, 223757),
(223758, '2.70.170.10-FF-000025', NULL, 'Gamma-aminobutyric acid type A receptor beta3 subunit', 162, NULL, NULL, 223758),
(223759, '2.60.40.10-FF-000180', NULL, 'Fibronectin type III domain containing 3A', 96, NULL, NULL, 223759),
(223760, '3.40.50.720-FF-001486', NULL, 'Putative UDP-galactopyranose mutase', 105, NULL, NULL, 223760),
(223761, '1.10.10.10-FF-000862', NULL, 'Putative transcriptional regulator', 143, NULL, NULL, 223761),
(223762, '1.10.10.60-FF-000293', NULL, 'Homeobox-leucine zipper protein ATHB-7', 73, NULL, NULL, 223762),
(223763, '3.40.50.2300-FF-001588', NULL, NULL, 133, NULL, NULL, 223763),
(223764, '3.30.1380.20-FF-000015', NULL, 'TRapp subunit', 205, NULL, NULL, 223764),
(223765, '3.30.70.20-FF-000037', NULL, 'Epoxyqueuosine reductase', 69, NULL, NULL, 223765),
(223766, '2.60.40.60-FF-000907', NULL, 'Uncharacterized protein', 106, NULL, NULL, 223766),
(223767, '3.40.50.150-FF-000629', NULL, 'Ribosomal methyltransferase Rsm22', 198, NULL, NULL, 223767),
(223768, '3.30.70.1230-FF-000275', NULL, 'Predicted protein', 91, NULL, NULL, 223768),
(223769, '3.40.50.300-FF-001208', NULL, 'DNA helicase B', 158, NULL, NULL, 223769),
(223770, '1.20.58.2220-FF-000024', NULL, 'Formin-like protein', 389, NULL, NULL, 223770);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(223771, '2.130.10.10-FF-005952', NULL, 'Uncharacterized protein', 250, NULL, NULL, 223771),
(223772, '3.40.50.300-FF-006767', NULL, 'Uncharacterized protein', 62, NULL, NULL, 223772),
(223773, '3.50.50.100-FF-000051', NULL, 'Uncharacterized protein', 228, NULL, NULL, 223773),
(223774, '1.20.1640.10-FF-000036', NULL, 'PaTched Related family', 224, NULL, NULL, 223774),
(223775, '3.80.10.10-FF-000360', NULL, 'NACHT, LRR and PYD domains-containing protein 3', 340, NULL, NULL, 223775),
(223776, '3.40.190.10-FF-000029', NULL, 'Chorismate mutase/Prephenate dehydratase', 87, NULL, NULL, 223776),
(223777, '1.20.1070.10-FF-001706', NULL, 'Uncharacterized protein', 106, NULL, NULL, 223777),
(223778, '2.60.40.10-FF-000270', NULL, 'Cell surface protein', 82, NULL, NULL, 223778),
(223779, '3.90.70.10-FF-000341', NULL, 'Ubiquitin-specific peptidase 47', 166, NULL, NULL, 223779),
(223780, '3.30.160.60-FF-005862', NULL, NULL, 63, NULL, NULL, 223780),
(223781, '3.10.20.90-FF-000494', NULL, 'AaceriAGL357Wp', 114, NULL, NULL, 223781),
(223782, '3.10.20.90-FF-000522', NULL, 'Suppressor 2 of zeste h29', 106, NULL, NULL, 223782),
(223783, '2.170.270.10-FF-000172', NULL, 'Si:dkeyp-41f9.4', 103, NULL, NULL, 223783),
(223784, '2.60.120.260-FF-000612', NULL, 'Uncharacterized protein', 139, NULL, NULL, 223784),
(223785, '2.70.50.30-FF-000017', NULL, NULL, 180, NULL, NULL, 223785),
(223786, '2.40.30.10-FF-000461', NULL, 'Chromosome 13 SCAF14769, whole genome shotgun sequence', 94, NULL, NULL, 223786),
(223787, '3.40.630.30-FF-000553', NULL, 'Uncharacterized protein', 131, NULL, NULL, 223787),
(223788, '3.40.50.1820-FF-000202', NULL, 'Lipase member H', 118, NULL, NULL, 223788),
(223789, '3.30.70.1230-FF-000039', NULL, 'Guanylate cyclase', 193, NULL, NULL, 223789),
(223790, '1.20.5.190-FF-000041', NULL, 'IQ motif containing N', 44, NULL, NULL, 223790),
(223791, '1.20.1250.40-FF-000004', NULL, 'Dna-directed rna polymerase ii subunit 4', 137, NULL, NULL, 223791),
(223792, '1.10.1740.10-FF-000018', NULL, 'RNA polymerase sigma-70 factor, ECF subfamily', 103, NULL, NULL, 223792),
(223793, '1.10.287.110-FF-000366', NULL, 'DnaJ domain containing protein', 94, NULL, NULL, 223793),
(223794, '3.30.505.10-FF-000141', NULL, 'RIN (Ras/Rab INteractor) homolog', 113, NULL, NULL, 223794),
(223795, '3.40.50.1820-FF-001663', NULL, 'Uncharacterized protein', 284, NULL, NULL, 223795),
(223796, '2.130.10.10-FF-004047', NULL, 'WD-repeat protein, putative', 217, NULL, NULL, 223796),
(223797, '1.10.460.10-FF-000008', NULL, 'DNA topoisomerase', 98, NULL, NULL, 223797),
(223798, '1.10.10.140-FF-000009', NULL, 'Cytochrome oxidase c subunit VIb-domain-containing protein', 95, NULL, NULL, 223798),
(223799, '2.60.40.10-FF-004541', NULL, NULL, 87, NULL, NULL, 223799),
(223800, '1.25.10.10-FF-002279', NULL, 'Calcium binding protein 39 like', 334, NULL, NULL, 223800),
(223801, '1.10.510.10-FF-004195', NULL, NULL, 227, NULL, NULL, 223801),
(223802, '1.10.510.10-FF-002424', NULL, NULL, 146, NULL, NULL, 223802),
(223803, '1.20.870.10-FF-000032', NULL, 'GM22469', 153, NULL, NULL, 223803),
(223804, '1.10.472.10-FF-000463', NULL, 'Uncharacterized protein', 92, NULL, NULL, 223804),
(223805, '2.40.30.10-FF-000219', NULL, 'Ferric reduction oxidase 4', 97, NULL, NULL, 223805),
(223806, '2.60.120.260-FF-000135', NULL, 'Allantoicase', 190, NULL, NULL, 223806),
(223807, '3.40.50.150-FF-000781', NULL, 'Steroid monooxygenase, putative', 300, NULL, NULL, 223807),
(223808, '3.30.200.20-FF-002173', NULL, 'Uncharacterized protein', 62, NULL, NULL, 223808),
(223809, '1.20.1160.20-FF-000019', NULL, 'Regulator of telomere elongation helicase 1', 93, NULL, NULL, 223809),
(223810, '3.40.140.10-FF-000083', NULL, 'Cytidine and deoxycytidylate deaminase,putative', 174, NULL, NULL, 223810),
(223811, '3.30.1490.110-FF-000008', NULL, 'Cell division protein FtsA', 88, NULL, NULL, 223811),
(223812, '3.30.110.110-FF-000004', NULL, 'Double-strand break repair protein', 102, NULL, NULL, 223812),
(223813, '2.40.50.120-FF-000040', NULL, 'Netrin precursor', 135, NULL, NULL, 223813),
(223814, '1.25.40.10-FF-001797', NULL, 'Pentatricopeptide repeat-containing protein At4g14050, mitochondrial', 134, NULL, NULL, 223814);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(223815, '1.20.58.60-FF-000008', NULL, 'microtubule-actin cross-linking factor 1', 110, NULL, NULL, 223815),
(223816, '1.20.1070.10-FF-001678', NULL, 'Extra-ocular rhodopsin', 117, NULL, NULL, 223816),
(223817, '1.20.930.60-FF-000001', NULL, 'protein-glutamate O-methyltransferase isoform X1', 124, NULL, NULL, 223817),
(223818, '1.10.10.10-FF-001025', NULL, 'Lactamase-like protein nscB', 96, NULL, NULL, 223818),
(223819, '1.25.10.10-FF-002009', NULL, 'Dynein assembly factor 5, axonemal', 205, NULL, NULL, 223819),
(223820, '3.30.1490.100-FF-000005', NULL, 'DNA polymerase kappa', 118, NULL, NULL, 223820),
(223821, '3.30.870.10-FF-000084', NULL, 'Cardiolipin synthase', 183, NULL, NULL, 223821),
(223822, '2.160.20.10-FF-000151', NULL, 'Predicted protein', 400, NULL, NULL, 223822),
(223823, '1.20.920.20-FF-000011', NULL, 'Dynein heavy chain domain 1', 339, NULL, NULL, 223823),
(223824, '2.40.50.140-FF-000046', NULL, '26S protease regulatory subunit 6B', 111, NULL, NULL, 223824),
(223825, '1.10.246.20-FF-000008', NULL, 'Uncharacterized protein', 47, NULL, NULL, 223825),
(223826, '1.20.58.310-FF-000003', NULL, 'Polyphosphate kinase', 110, NULL, NULL, 223826),
(223827, '3.40.50.720-FF-001363', NULL, 'Predicted protein', 68, NULL, NULL, 223827),
(223828, '1.10.10.10-FF-000536', NULL, 'Ferric uptake regulator family protein', 95, NULL, NULL, 223828),
(223829, '1.10.760.10-FF-000048', NULL, 'Cytochrome c oxidase subunit 2', 121, NULL, NULL, 223829),
(223830, '3.30.1330.10-FF-000003', NULL, 'Selenide, water dikinase', 161, NULL, NULL, 223830),
(223831, '1.10.555.10-FF-000268', NULL, NULL, 46, NULL, NULL, 223831),
(223832, '2.40.100.10-FF-000090', NULL, 'Peptidyl-prolyl cis-trans isomerase', 146, NULL, NULL, 223832),
(223833, '3.30.160.60-FF-003945', NULL, NULL, 27, NULL, NULL, 223833),
(223834, '1.10.246.10-FF-000005', NULL, 'Serum albumin', 90, NULL, NULL, 223834),
(223835, '1.50.40.10-FF-000418', NULL, 'Uncharacterized protein', 197, NULL, NULL, 223835),
(223836, '3.30.559.10-FF-000113', NULL, 'HXXXD-type acyl-transferase family protein', 211, NULL, NULL, 223836),
(223837, '2.120.10.80-FF-000038', NULL, 'leucine-zipper-like transcriptional regulator 1 isoform X1', 149, NULL, NULL, 223837),
(223838, '3.40.30.10-FF-000655', NULL, 'GM26512', 176, NULL, NULL, 223838),
(223839, '3.30.70.330-FF-000004', NULL, 'RNA binding fox-1 homolog 1', 103, NULL, NULL, 223839),
(223840, '1.10.230.10-FF-000025', NULL, 'Predicted protein', 75, NULL, NULL, 223840),
(223841, '3.10.110.10-FF-000115', NULL, 'RWD domain-containing protein', 126, NULL, NULL, 223841),
(223842, '3.30.1330.30-FF-000009', NULL, 'Eukaryotic peptide chain release factor subunit 1', 160, NULL, NULL, 223842),
(223843, '1.10.540.10-FF-000009', NULL, 'Probable acyl-CoA dehydrogenase', 118, NULL, NULL, 223843),
(223844, '3.30.1330.20-FF-000006', NULL, 'Tubulin alpha chain', 115, NULL, NULL, 223844),
(223845, '1.10.630.10-FF-000573', NULL, 'Uncharacterized protein', 314, NULL, NULL, 223845),
(223846, '2.130.10.10-FF-002372', NULL, 'Splicing factor 3B subunit 1', 130, NULL, NULL, 223846),
(223847, '2.30.29.30-FF-001234', NULL, 'Protein CARMIL', 114, NULL, NULL, 223847),
(223848, '3.70.10.10-FF-000085', NULL, 'Cell cycle checkpoint protein RAD1-like, putative', 219, NULL, NULL, 223848),
(223849, '3.30.160.60-FF-002366', NULL, 'zinc finger protein 484 isoform X2', 27, NULL, NULL, 223849),
(223850, '1.20.1110.10-FF-000098', NULL, NULL, 47, NULL, NULL, 223850),
(223851, '1.10.510.10-FF-002716', NULL, 'Probable inactive serine/threonine-protein kinase bub1', 321, NULL, NULL, 223851),
(223852, '3.30.750.24-FF-000111', NULL, 'Prestin', 156, NULL, NULL, 223852),
(223853, '3.10.110.10-FF-000059', NULL, 'Ubiquitin-conjugating enzyme E2 34', 177, NULL, NULL, 223853),
(223854, '1.10.150.50-FF-000188', NULL, 'Kinase suppressor of Ras 2', 70, NULL, NULL, 223854),
(223855, '2.40.50.140-FF-000102', NULL, '30S ribosomal protein S1', 97, NULL, NULL, 223855),
(223856, '3.40.50.10810-FF-000234', NULL, 'Uncharacterized protein', 227, NULL, NULL, 223856),
(223857, '3.30.200.20-FF-001594', NULL, 'Kinase-like domain-containing protein', 132, NULL, NULL, 223857);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(223858, '2.120.10.30-FF-000484', NULL, 'Predicted protein', 293, NULL, NULL, 223858),
(223859, '2.40.30.10-FF-000135', NULL, '1,2-phenylacetyl-CoA epoxidase subunit E', 99, NULL, NULL, 223859),
(223860, '2.60.40.150-FF-000823', NULL, 'Uncharacterized protein PYUK71.03c', 141, NULL, NULL, 223860),
(223861, '1.20.120.1900-FF-000037', NULL, 'Gamma-tubulin complex component', 72, NULL, NULL, 223861),
(223862, '2.80.10.50-FF-000060', NULL, 'Fibroblast growth factor', 163, NULL, NULL, 223862),
(223863, '2.130.10.130-FF-000002', NULL, 'integrin alpha-6 isoform X2', 446, NULL, NULL, 223863),
(223864, '3.40.50.300-FF-001973', NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', 108, NULL, NULL, 223864),
(223865, '2.60.40.10-FF-002714', NULL, 'CD45', 79, NULL, NULL, 223865),
(223866, '2.130.10.10-FF-001883', NULL, 'WD40-repeat-containing domain protein', 408, NULL, NULL, 223866),
(223867, '2.20.25.10-FF-000051', NULL, 'DNA-directed RNA polymerase subunit', 53, NULL, NULL, 223867),
(223868, '3.90.79.10-FF-000068', NULL, 'NUDIX family hydrolase, putative', 218, NULL, NULL, 223868),
(223869, '3.30.870.10-FF-000140', NULL, 'Cardiolipin synthase B', 99, NULL, NULL, 223869),
(223870, '1.25.10.10-FF-001969', NULL, 'Serine/threonine-protein kinase TOR', 196, NULL, NULL, 223870),
(223871, '3.30.200.20-FF-002083', NULL, 'Protein kinase superfamily protein', 82, NULL, NULL, 223871),
(223872, '1.20.190.50-FF-000019', NULL, 'Nuclear pore complex protein', 131, NULL, NULL, 223872),
(223873, '3.80.10.10-FF-003614', NULL, 'Uncharacterized protein', 152, NULL, NULL, 223873),
(223874, '3.30.70.330-FF-001634', NULL, NULL, 128, NULL, NULL, 223874),
(223875, '3.80.10.10-FF-004103', NULL, 'Uncharacterized protein', 119, NULL, NULL, 223875),
(223876, '2.60.40.10-FF-004485', NULL, NULL, 114, NULL, NULL, 223876),
(223877, '3.40.50.720-FF-002503', NULL, 'Uncharacterized protein', 143, NULL, NULL, 223877),
(223878, '3.40.50.80-FF-000042', NULL, 'Putative NADH-cytochrome b5 reductase', 150, NULL, NULL, 223878),
(223879, '3.30.420.40-FF-000216', NULL, 'Pantothenate kinase 1', 113, NULL, NULL, 223879),
(223880, '1.20.58.70-FF-000130', NULL, 'Uncharacterized protein', 63, NULL, NULL, 223880),
(223881, '1.10.840.10-FF-000049', NULL, 'Uncharacterized protein', 158, NULL, NULL, 223881),
(223882, '1.25.10.10-FF-001846', NULL, 'Condensin complex subunit 1', 268, NULL, NULL, 223882),
(223883, '2.30.40.10-FF-000012', NULL, 'N-acetylglucosamine-6-phosphate deacetylase', 82, NULL, NULL, 223883),
(223884, '3.30.160.20-FF-000078', NULL, 'Staufen, isoform C', 41, NULL, NULL, 223884),
(223885, '1.10.150.240-FF-000035', NULL, 'Protein tyrosine kinase transcriptional regulator PtkA', 65, NULL, NULL, 223885),
(223886, '3.40.50.150-FF-000455', NULL, 'rRNA adenine N(6)-methyltransferase', 187, NULL, NULL, 223886),
(223887, '2.170.140.10-FF-000016', NULL, 'Peritrophin-A', 53, NULL, NULL, 223887),
(223888, '2.10.25.10-FF-001681', NULL, 'Uromodulin-like 1', 44, NULL, NULL, 223888),
(223889, '3.30.160.60-FF-006082', NULL, NULL, 51, NULL, NULL, 223889),
(223890, '2.40.10.10-FF-000459', NULL, NULL, 130, NULL, NULL, 223890),
(223891, '2.130.10.10-FF-005626', NULL, 'Damage-specific DNA binding protein 1', 180, NULL, NULL, 223891),
(223892, '2.130.10.10-FF-000157', NULL, 'WD repeat domain 3', 197, NULL, NULL, 223892),
(223893, '2.40.50.140-FF-000720', NULL, NULL, 75, NULL, NULL, 223893),
(223894, '2.40.30.10-FF-000371', NULL, 'Siderophore-interacting protein', 127, NULL, NULL, 223894),
(223895, '3.40.50.300-FF-002552', NULL, 'ATP-dependent DNA helicase pcrA', 80, NULL, NULL, 223895),
(223896, '3.10.20.90-FF-000612', NULL, 'Protein PHOX4', 88, NULL, NULL, 223896),
(223897, '3.30.70.330-FF-000532', NULL, '50S ribosomal protein L23', 84, NULL, NULL, 223897),
(223898, '3.30.2130.10-FF-000027', NULL, 'Uncharacterized protein', 106, NULL, NULL, 223898),
(223899, '2.70.150.10-FF-000142', NULL, 'Na/K ATPase alpha 2 subunit', 61, NULL, NULL, 223899),
(223900, '3.30.420.40-FF-000834', NULL, 'Uncharacterized protein', 92, NULL, NULL, 223900),
(223901, '1.20.1440.80-FF-000002', NULL, 'Gap junction protein', 229, NULL, NULL, 223901); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(223902, '3.30.559.30-FF-000119', NULL, 'Nonribosomal peptide synthetase asqK', 165, NULL, NULL, 223902),
(223903, '3.40.630.30-FF-000643', NULL, 'Uncharacterized protein', 300, NULL, NULL, 223903),
(223904, '2.10.25.10-FF-000697', NULL, 'von Willebrand factor C and EGF domain-containing protein', 65, NULL, NULL, 223904),
(223905, '1.25.40.10-FF-004052', NULL, 'Uncharacterized protein', 170, NULL, NULL, 223905),
(223906, '1.10.10.60-FF-000146', NULL, 'WUSCHEL-related homeobox 4', 68, NULL, NULL, 223906),
(223907, '2.30.30.1150-FF-000009', NULL, 'Little imaginal discs, isoform C', 98, NULL, NULL, 223907),
(223908, '1.20.1440.90-FF-000005', NULL, 'Phosphoenolpyruvate carboxylase', 147, NULL, NULL, 223908),
(223909, '3.90.1600.10-FF-000005', NULL, 'DNA polymerase epsilon catalytic subunit', 138, NULL, NULL, 223909),
(223910, '2.80.10.50-FF-000088', NULL, 'Fibroblast growth factor', 157, NULL, NULL, 223910),
(223911, '3.30.40.10-FF-000622', NULL, 'histone-lysine N-methyltransferase 2C isoform X1', 51, NULL, NULL, 223911),
(223912, '3.30.70.20-FF-000127', NULL, NULL, 71, NULL, NULL, 223912),
(223913, '3.30.70.330-FF-000184', NULL, 'Peroxisome proliferator-activated receptor gamma coactivator 1-alpha', 129, NULL, NULL, 223913),
(223914, '3.40.30.10-FF-001021', NULL, 'Uncharacterized protein', 54, NULL, NULL, 223914),
(223915, '2.10.220.10-FF-000072', NULL, 'CXXC-rich protein', 113, NULL, NULL, 223915),
(223916, '3.40.50.1820-FF-000112', NULL, 'Poly(R)-hydroxyalkanoic acid synthase, class III, PhaC subunit', 314, NULL, NULL, 223916),
(223917, '1.10.150.20-FF-000027', NULL, 'DNA-directed RNA polymerase', 190, NULL, NULL, 223917),
(223918, '3.40.50.300-FF-006823', NULL, 'MCM homolog', 35, NULL, NULL, 223918),
(223919, '3.30.70.870-FF-000025', NULL, 'Elongation factor 2, putative', 77, NULL, NULL, 223919),
(223920, '2.10.90.10-FF-000179', NULL, 'Uncharacterized protein', 27, NULL, NULL, 223920),
(223921, '2.40.100.10-FF-000174', NULL, 'Peptidyl-prolyl cis-trans isomerase', 87, NULL, NULL, 223921),
(223922, '2.130.10.10-FF-005593', NULL, 'Leucine zipper transcription factor, putative', 196, NULL, NULL, 223922),
(223923, '2.60.40.10-FF-000825', NULL, 'Polycystin 1, transient receptor potential channel interacting', 80, NULL, NULL, 223923),
(223924, '2.60.40.1180-FF-000225', NULL, 'Glucosylceramidase', 93, NULL, NULL, 223924),
(223925, '1.10.510.10-FF-004482', NULL, NULL, 250, NULL, NULL, 223925),
(223926, '3.40.50.300-FF-005986', NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', 325, NULL, NULL, 223926),
(223927, '2.10.25.10-FF-000984', NULL, 'AGAP003656-PC', 59, NULL, NULL, 223927),
(223928, '3.90.1340.10-FF-000001', NULL, 'Short tail fiber protein gp12', 67, NULL, NULL, 223928),
(223929, '3.90.1410.10-FF-000119', NULL, 'Uncharacterized protein', 199, NULL, NULL, 223929),
(223930, '1.25.40.10-FF-004400', NULL, 'Pentatricopeptide repeat-containing protein At2g01510, mitochondrial', 137, NULL, NULL, 223930),
(223931, '3.40.50.1820-FF-001219', NULL, 'Uncharacterized protein', 359, NULL, NULL, 223931),
(223932, '2.60.40.790-FF-000133', NULL, NULL, 112, NULL, NULL, 223932),
(223933, '3.80.10.10-FF-001377', NULL, 'Uncharacterized protein', 164, NULL, NULL, 223933),
(223934, '3.40.30.10-FF-000857', NULL, 'Uncharacterized protein', 115, NULL, NULL, 223934),
(223935, '3.30.43.10-FF-000011', NULL, 'D-lactate dehydrogenase (Cytochrome)', 100, NULL, NULL, 223935),
(223936, '3.50.50.60-FF-001087', NULL, 'Uncharacterized protein', 101, NULL, NULL, 223936),
(223937, '2.60.40.1180-FF-000169', NULL, 'Alpha-mannosidase', 124, NULL, NULL, 223937),
(223938, '1.25.40.10-FF-002253', NULL, 'Uncharacterized protein', 141, NULL, NULL, 223938),
(223939, '1.10.1400.10-FF-000004', NULL, NULL, 136, NULL, NULL, 223939),
(223940, '3.40.50.970-FF-000021', NULL, 'Pyruvate decarboxylase 1', 188, NULL, NULL, 223940),
(223941, '2.10.70.80-FF-000002', NULL, 'Sortilin-related receptor isoform A', 52, NULL, NULL, 223941),
(223942, '3.30.505.10-FF-000197', NULL, NULL, 119, NULL, NULL, 223942),
(223943, '2.60.120.1540-FF-000018', NULL, 'Uncharacterized protein', 109, NULL, NULL, 223943);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(223944, '3.40.50.1820-FF-001747', NULL, 'Predicted protein', 54, NULL, NULL, 223944),
(223945, '1.10.357.10-FF-000033', NULL, 'TetR family transcriptional regulator', 149, NULL, NULL, 223945),
(223946, '3.20.20.70-FF-000757', NULL, NULL, 60, NULL, NULL, 223946),
(223947, '3.30.70.330-FF-002185', NULL, NULL, 66, NULL, NULL, 223947),
(223948, '3.30.160.60-FF-000803', NULL, 'zinc finger protein 142', 60, NULL, NULL, 223948),
(223949, '3.90.1410.10-FF-000030', NULL, 'N-lysine methyltransferase SETD6 isoform X3', 116, NULL, NULL, 223949),
(223950, '3.40.630.10-FF-000075', NULL, 'Nicastrin', 297, NULL, NULL, 223950),
(223951, '3.30.160.60-FF-002512', NULL, 'Pebbled, isoform A', 29, NULL, NULL, 223951),
(223952, '1.20.58.1040-FF-000013', NULL, 'Predicted protein', 102, NULL, NULL, 223952),
(223953, '1.20.58.1030-FF-000010', NULL, 'GD13488', 126, NULL, NULL, 223953),
(223954, '1.10.510.10-FF-000682', NULL, 'WNK lysine deficient protein kinase 4', 181, NULL, NULL, 223954),
(223955, '3.30.2020.30-FF-000025', NULL, 'Chromosome 16, whole genome shotgun sequence', 114, NULL, NULL, 223955),
(223956, '1.10.510.10-FF-002391', NULL, NULL, 236, NULL, NULL, 223956),
(223957, '2.30.29.30-FF-001144', NULL, 'Predicted protein', 113, NULL, NULL, 223957),
(223958, '2.40.50.150-FF-000021', NULL, 'Predicted protein', 112, NULL, NULL, 223958),
(223959, '3.30.40.10-FF-001224', NULL, 'Fcp-1', 83, NULL, NULL, 223959),
(223960, '1.20.1070.10-FF-000043', NULL, 'adhesion G-protein coupled receptor G2 isoform X1', 296, NULL, NULL, 223960),
(223961, '1.10.220.100-FF-000004', NULL, 'Predicted protein', 29, NULL, NULL, 223961),
(223962, '3.90.550.10-FF-000018', NULL, 'Hexosyltransferase', 253, NULL, NULL, 223962),
(223963, '2.60.120.260-FF-000051', NULL, 'BTB/POZ domain-containing protein 9', 132, NULL, NULL, 223963),
(223964, '3.40.50.980-FF-000024', NULL, 'Linear gramicidin synthase subunit B', 174, NULL, NULL, 223964),
(223965, '1.50.10.130-FF-000008', NULL, 'Inactive delta-guaiene synthase', 157, NULL, NULL, 223965),
(223966, '3.30.700.10-FF-000010', NULL, 'Type IV pilin, putative', 155, NULL, NULL, 223966),
(223967, '3.60.21.50-FF-000027', NULL, 'DNA polymerase delta small subunit-like Protein', 75, NULL, NULL, 223967),
(223968, '1.25.40.20-FF-000547', NULL, 'Uveal autoantigen with coiled-coil domains and ankyrin repeats', 242, NULL, NULL, 223968),
(223969, '3.30.310.130-FF-000016', NULL, 'SUMO specific peptidase 6', 50, NULL, NULL, 223969),
(223970, '3.30.1370.10-FF-000039', NULL, 'vigilin isoform X1', 69, NULL, NULL, 223970),
(223971, '1.10.472.10-FF-000261', NULL, 'Cyclin, N-terminal domain containing protein', 109, NULL, NULL, 223971),
(223972, '3.90.550.10-FF-000546', NULL, 'Galactosylgalactosylxylosylprotein 3-beta-glucuronosyltransferase', 255, NULL, NULL, 223972),
(223973, '2.60.40.10-FF-000354', NULL, 'Pro-neuregulin-2, membrane-bound isoform', 101, NULL, NULL, 223973),
(223974, '1.10.510.10-FF-000154', NULL, 'Serine/threonine-protein kinase SIK2', 343, NULL, NULL, 223974),
(223975, '3.80.10.10-FF-003468', NULL, 'Uncharacterized protein', 218, NULL, NULL, 223975),
(223976, '1.10.1420.10-FF-000005', NULL, 'DNA mismatch repair protein', 133, NULL, NULL, 223976),
(223977, '1.10.10.10-FF-000446', NULL, 'DNA-binding response regulator', 97, NULL, NULL, 223977),
(223978, '3.30.565.10-FF-000173', NULL, 'Histidine kinase', 169, NULL, NULL, 223978),
(223979, '3.30.200.20-FF-000284', NULL, 'Serine/threonine-protein kinase PLK', 89, NULL, NULL, 223979),
(223980, '2.60.40.150-FF-000205', NULL, 'Uncharacterized protein, isoform A', 131, NULL, NULL, 223980),
(223981, '3.40.50.300-FF-000192', NULL, 'Phospholipid ABC transporter ATP-binding protein MlaF', 245, NULL, NULL, 223981),
(223982, '3.40.350.10-FF-000093', NULL, 'Uncharacterized protein', 162, NULL, NULL, 223982),
(223983, '3.40.50.2300-FF-000245', NULL, 'Guanylate cyclase', 154, NULL, NULL, 223983),
(223984, '1.20.120.350-FF-000043', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 124, NULL, NULL, 223984),
(223985, '1.20.5.190-FF-000125', NULL, NULL, 92, NULL, NULL, 223985);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(223986, '1.10.1410.10-FF-000033', NULL, 'Non-canonical poly(A) RNA polymerase PAPD7', 194, NULL, NULL, 223986),
(223987, '2.40.170.20-FF-000125', NULL, 'TonB-dependent receptor', 542, NULL, NULL, 223987),
(223988, '3.30.160.60-FF-003063', NULL, 'CBN-BLMP-1 protein', 28, NULL, NULL, 223988),
(223989, '3.40.390.10-FF-000213', NULL, NULL, 280, NULL, NULL, 223989),
(223990, '1.10.8.60-FF-000398', NULL, 'Uncharacterized protein', 60, NULL, NULL, 223990),
(223991, '1.10.533.10-FF-000246', NULL, 'Uncharacterized protein', 97, NULL, NULL, 223991),
(223992, '3.40.50.2300-FF-000301', NULL, 'Response regulator receiver', 123, NULL, NULL, 223992),
(223993, '1.20.1250.20-FF-001302', NULL, 'Solute carrier family 2 member 1b', 110, NULL, NULL, 223993),
(223994, '3.60.130.10-FF-000010', NULL, 'TauD/TfdA family dioxygenase', 321, NULL, NULL, 223994),
(223995, '2.10.25.10-FF-000927', NULL, 'Thrombomodulin', 33, NULL, NULL, 223995),
(223996, '1.25.40.10-FF-000544', NULL, 'Prolyl 4-hydroxylase subunit alpha 2', 96, NULL, NULL, 223996),
(223997, '3.30.40.10-FF-001639', NULL, 'Uncharacterized protein', 96, NULL, NULL, 223997),
(223998, '2.60.40.10-FF-002916', NULL, 'Usherin', 76, NULL, NULL, 223998),
(223999, '3.10.28.10-FF-000044', NULL, 'mRNA splicing protein PRP8', 107, NULL, NULL, 223999),
(224000, '1.25.40.10-FF-000600', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform A', 139, NULL, NULL, 224000),
(224001, '1.25.40.10-FF-002781', NULL, 'Uncharacterized protein', 155, NULL, NULL, 224001),
(224002, '2.130.10.10-FF-001793', NULL, 'THO complex subunit 6', 218, NULL, NULL, 224002),
(224003, '2.20.70.10-FF-000155', NULL, 'WW domain-containing protein A', 54, NULL, NULL, 224003),
(224004, '2.10.110.10-FF-000243', NULL, 'Uncharacterized protein', 69, NULL, NULL, 224004),
(224005, '3.90.70.10-FF-000543', NULL, 'Os09g0565100 protein', 144, NULL, NULL, 224005),
(224006, '3.80.10.10-FF-003524', NULL, 'Uncharacterized protein', 171, NULL, NULL, 224006),
(224007, '3.30.40.10-FF-001696', NULL, 'Uncharacterized protein', 69, NULL, NULL, 224007),
(224008, '3.50.50.60-FF-001469', NULL, 'Predicted protein', 65, NULL, NULL, 224008),
(224009, '1.25.40.20-FF-000603', NULL, 'Predicted protein', 211, NULL, NULL, 224009),
(224010, '2.30.29.30-FF-001088', NULL, 'Predicted protein', 55, NULL, NULL, 224010),
(224011, '2.120.10.30-FF-000102', NULL, 'Uncharacterized protein, isoform B', 303, NULL, NULL, 224011),
(224012, '3.90.260.10-FF-000007', NULL, 'Rad4 family protein', 332, NULL, NULL, 224012),
(224013, '1.10.510.10-FF-004369', NULL, NULL, 105, NULL, NULL, 224013),
(224014, '3.30.160.60-FF-002456', NULL, 'Uncharacterized protein, isoform A', 27, NULL, NULL, 224014),
(224015, '3.40.850.10-FF-000350', NULL, 'Uncharacterized protein', 360, NULL, NULL, 224015),
(224016, '2.40.50.140-FF-000490', NULL, 'DNA ligase', 85, NULL, NULL, 224016),
(224017, '1.10.1320.10-FF-000003', NULL, 'DNA-directed RNA polymerase', 318, NULL, NULL, 224017),
(224018, '3.40.1110.10-FF-000187', NULL, 'Cation-transporting ATPase', 206, NULL, NULL, 224018),
(224019, '3.40.50.1820-FF-001332', NULL, 'Slr1827 protein', 254, NULL, NULL, 224019),
(224020, '3.80.10.10-FF-001490', NULL, 'Blast:Leucine-rich repeat-containing protein 15', 117, NULL, NULL, 224020),
(224021, '3.30.230.10-FF-000103', NULL, 'Tetracycline resistance protein, GTP-binding elongation family', 124, NULL, NULL, 224021),
(224022, '4.10.410.10-FF-000062', NULL, 'GM18133', 70, NULL, NULL, 224022),
(224023, '2.60.40.790-FF-000077', NULL, 'Heat shock protein', 141, NULL, NULL, 224023),
(224024, '3.80.10.10-FF-003581', NULL, 'Uncharacterized protein', 140, NULL, NULL, 224024),
(224025, '1.20.1070.10-FF-001347', NULL, 'Uncharacterized protein', 271, NULL, NULL, 224025),
(224026, '1.25.10.10-FF-002425', NULL, 'Protein phosphatase', 245, NULL, NULL, 224026),
(224027, '2.60.40.150-FF-000262', NULL, 'Non-specific serine/threonine protein kinase', 149, NULL, NULL, 224027),
(224028, '3.40.50.300-FF-002226', NULL, 'RAB3A, member RAS oncogene family', 116, NULL, NULL, 224028),
(224029, '1.25.40.10-FF-004815', NULL, 'Uncharacterized protein', 155, NULL, NULL, 224029);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(224030, '3.90.1860.10-FF-000001', NULL, 'tRNA-splicing ligase RtcB homolog', 497, NULL, NULL, 224030),
(224031, '1.10.510.10-FF-002239', NULL, NULL, 203, NULL, NULL, 224031),
(224032, '3.40.50.150-FF-000365', NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', 258, NULL, NULL, 224032),
(224033, '1.20.1440.130-FF-000011', NULL, 'Vitamin K epoxide reductase complex, subunit 1-like 1', 71, NULL, NULL, 224033),
(224034, '2.60.120.10-FF-000783', NULL, 'Uncharacterized protein', 155, NULL, NULL, 224034),
(224035, '3.40.50.1440-FF-000094', NULL, 'Protein DML1', 307, NULL, NULL, 224035),
(224036, '3.40.50.300-FF-006352', NULL, 'Predicted protein', 141, NULL, NULL, 224036),
(224037, '1.10.1660.10-FF-000017', NULL, 'Transcriptional regulator, MerR family', 130, NULL, NULL, 224037),
(224038, '2.60.40.1180-FF-000023', NULL, 'neutral alpha-glucosidase AB isoform X2', 100, NULL, NULL, 224038),
(224039, '3.30.1640.10-FF-000049', NULL, 'DNA helicase', 57, NULL, NULL, 224039),
(224040, '1.20.840.10-FF-000002', NULL, 'Methyl-coenzyme M reductase I subunit beta', 295, NULL, NULL, 224040),
(224041, '3.30.160.60-FF-006351', NULL, NULL, 90, NULL, NULL, 224041),
(224042, '1.20.58.1880-FF-000028', NULL, 'Snt1p', 107, NULL, NULL, 224042),
(224043, '3.30.420.40-FF-000508', NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', 42, NULL, NULL, 224043),
(224044, '2.60.40.10-FF-004900', NULL, NULL, 100, NULL, NULL, 224044),
(224045, '3.40.140.10-FF-000167', NULL, 'Uncharacterized protein', 138, NULL, NULL, 224045),
(224046, '3.40.50.720-FF-001071', NULL, 'Hypothetical_protein_-_conserved', 234, NULL, NULL, 224046),
(224047, '3.30.160.60-FF-002192', NULL, 'Os08g0485600 protein', 97, NULL, NULL, 224047),
(224048, '1.20.1250.20-FF-001717', NULL, 'Protein NRT1/ PTR FAMILY 8.3', 414, NULL, NULL, 224048),
(224049, '2.40.20.10-FF-000106', NULL, 'Uncharacterized protein', 126, NULL, NULL, 224049),
(224050, '2.40.10.10-FF-000605', NULL, NULL, 169, NULL, NULL, 224050),
(224051, '2.70.98.10-FF-000104', NULL, 'Aldose 1-epimerase', 342, NULL, NULL, 224051),
(224052, '3.30.200.20-FF-000610', NULL, 'Cysteine-rich receptor-like protein kinase 40', 101, NULL, NULL, 224052),
(224053, '2.60.40.10-FF-004193', NULL, NULL, 83, NULL, NULL, 224053),
(224054, '1.10.10.60-FF-000562', NULL, 'Myb-related protein 315', 78, NULL, NULL, 224054),
(224055, '2.30.38.10-FF-000012', NULL, 'Non-ribosomal peptide synthetase', 76, NULL, NULL, 224055),
(224056, '1.20.1560.10-FF-000889', NULL, 'Uncharacterized protein', 104, NULL, NULL, 224056),
(224057, '3.80.10.10-FF-003322', NULL, 'Si:ch211-191a16.5', 195, NULL, NULL, 224057),
(224058, '2.130.10.10-FF-002664', NULL, 'Protein DSE1', 267, NULL, NULL, 224058),
(224059, '2.30.42.10-FF-000410', NULL, NULL, 81, NULL, NULL, 224059),
(224060, '3.40.1090.10-FF-000105', NULL, 'Uncharacterized protein C1A6.05c', 103, NULL, NULL, 224060),
(224061, '1.10.730.10-FF-000136', NULL, 'Leucyl-tRNA synthetase 2, mitochondrial', 13, NULL, NULL, 224061),
(224062, '3.10.100.10-FF-000143', NULL, 'Uncharacterized protein', 67, NULL, NULL, 224062),
(224063, '3.40.50.10810-FF-000228', NULL, 'SNF2 DNA repair protein, putative', 343, NULL, NULL, 224063),
(224064, '2.30.30.40-FF-000291', NULL, 'Uncharacterized protein, isoform A', 63, NULL, NULL, 224064),
(224065, '3.30.160.110-FF-000003', NULL, 'Siroheme synthase component enzyme', 36, NULL, NULL, 224065),
(224066, '2.130.10.10-FF-002607', NULL, 'Uncharacterized protein', 248, NULL, NULL, 224066),
(224067, '2.120.10.80-FF-000274', NULL, 'Predicted protein', 316, NULL, NULL, 224067),
(224068, '2.60.40.1170-FF-000020', NULL, 'AP-4 complex subunit mu', 155, NULL, NULL, 224068),
(224069, '3.20.20.100-FF-000017', NULL, 'Aflatoxin B1 aldehyde reductase member 2', 326, NULL, NULL, 224069),
(224070, '3.40.390.10-FF-000011', NULL, 'Disintegrin and metalloproteinase domain-containing protein 10', 240, NULL, NULL, 224070),
(224071, '2.130.10.10-FF-004316', NULL, 'Uncharacterized protein', 108, NULL, NULL, 224071),
(224072, '1.10.3460.10-FF-000042', NULL, 'Uncharacterized protein', 184, NULL, NULL, 224072);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(224073, '2.40.160.120-FF-000044', NULL, 'Uncharacterized protein', 206, NULL, NULL, 224073),
(224074, '1.20.210.10-FF-000027', NULL, 'Cytochrome c oxidase subunit 1', 126, NULL, NULL, 224074),
(224075, '3.30.40.10-FF-001932', NULL, 'E3 ubiquitin-protein ligase hel2', 70, NULL, NULL, 224075),
(224076, '3.40.50.720-FF-001632', NULL, 'Aldehyde reductase II (AFU_orthologue AFUA_1G11360)', 330, NULL, NULL, 224076),
(224077, '3.40.50.450-FF-000096', NULL, 'Putative 2''-deoxynucleoside 5''-phosphate N-hydrolase 1', 97, NULL, NULL, 224077),
(224078, '2.130.10.10-FF-000573', NULL, 'Intraflagellar transport protein 122 homolog', 115, NULL, NULL, 224078),
(224079, '2.60.200.10-FF-000019', NULL, 'Interferon regulatory factor 9', 214, NULL, NULL, 224079),
(224080, '2.30.30.40-FF-000234', NULL, 'Tyrosine-protein kinase', 59, NULL, NULL, 224080),
(224081, '3.30.160.60-FF-005946', NULL, NULL, 67, NULL, NULL, 224081),
(224082, '2.40.160.110-FF-000041', NULL, 'Uncharacterized protein', 134, NULL, NULL, 224082),
(224083, '3.40.50.300-FF-001006', NULL, 'Molybdate ABC transporter ATP-binding protein ModF', 238, NULL, NULL, 224083),
(224084, '2.70.98.10-FF-000071', NULL, 'Uncharacterized protein', 429, NULL, NULL, 224084),
(224085, '3.40.50.1440-FF-000037', NULL, 'Tubulin beta chain', 262, NULL, NULL, 224085),
(224086, '2.60.40.10-FF-002540', NULL, 'Protein sidekick homolog', 102, NULL, NULL, 224086),
(224087, '2.20.90.10-FF-000010', NULL, 'Vitellogenin-1', 169, NULL, NULL, 224087),
(224088, '2.60.40.10-FF-005789', NULL, NULL, 87, NULL, NULL, 224088),
(224089, '4.10.1240.10-FF-000034', NULL, 'Diuretic hormone 31 receptor, isoform B', 98, NULL, NULL, 224089),
(224090, '2.40.10.10-FF-000662', NULL, NULL, 73, NULL, NULL, 224090),
(224091, '1.10.510.10-FF-002571', NULL, 'STE/STE11 protein kinase', 246, NULL, NULL, 224091),
(224092, '3.40.228.10-FF-000022', NULL, 'Twin-arginine translocation signal domain-containing protein', 239, NULL, NULL, 224092),
(224093, '1.20.1250.20-FF-001774', NULL, 'Major facilitator superfamily MFS_1', 187, NULL, NULL, 224093),
(224094, '3.40.50.10260-FF-000024', NULL, 'Enhancer of mRNA decapping 3', 150, NULL, NULL, 224094),
(224095, '1.10.287.110-FF-000310', NULL, 'Uncharacterized protein', 117, NULL, NULL, 224095),
(224096, '1.20.1310.10-FF-000141', NULL, NULL, 109, NULL, NULL, 224096),
(224097, '1.10.510.10-FF-001929', NULL, NULL, 56, NULL, NULL, 224097),
(224098, '3.40.50.1970-FF-000022', NULL, 'Alcohol dehydrogenase lateral transfer candidate', 181, NULL, NULL, 224098),
(224099, '3.30.2350.20-FF-000070', NULL, NULL, 181, NULL, NULL, 224099),
(224100, '3.40.630.10-FF-000311', NULL, 'Uncharacterized protein', 174, NULL, NULL, 224100),
(224101, '2.60.40.60-FF-000559', NULL, 'Cadherin-related hmr-1', 116, NULL, NULL, 224101),
(224102, '3.40.30.10-FF-000329', NULL, 'Merozoite capping protein-1', 146, NULL, NULL, 224102),
(224103, '3.40.50.300-FF-002754', NULL, 'Signal recognition particle (SRP) subunit', 218, NULL, NULL, 224103),
(224104, '1.20.1050.10-FF-000042', NULL, 'Glutathione S-transferase F9', 118, NULL, NULL, 224104),
(224105, '3.10.450.10-FF-000074', NULL, 'Cystatin E/M', 58, NULL, NULL, 224105),
(224106, '3.30.420.300-FF-000002', NULL, '2-dehydro-3-deoxygalactonate kinase', 90, NULL, NULL, 224106),
(224107, '3.30.70.1350-FF-000024', NULL, 'Cation-efflux pump FieF protein', 79, NULL, NULL, 224107),
(224108, '3.40.50.140-FF-000008', NULL, 'DNA topoisomerase 1A', 180, NULL, NULL, 224108),
(224109, '3.30.200.20-FF-001863', NULL, 'Uncharacterized protein', 33, NULL, NULL, 224109),
(224110, '3.40.190.10-FF-000355', NULL, 'LysR family transcriptional regulator', 97, NULL, NULL, 224110),
(224111, '3.20.110.10-FF-000006', NULL, 'Alpha-mannosidase MngB', 276, NULL, NULL, 224111),
(224112, '3.40.640.10-FF-000424', NULL, 'Glutamic--pyruvic transaminase', 12, NULL, NULL, 224112),
(224113, '3.10.450.10-FF-000017', NULL, 'CST9 isoform 1', 106, NULL, NULL, 224113),
(224114, '1.20.890.10-FF-000005', NULL, 'calcium-binding tyrosine phosphorylation-regulated protein isoform X1', 42, NULL, NULL, 224114);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(224115, '3.30.70.330-FF-000330', NULL, 'RNA-binding motif protein 26', 87, NULL, NULL, 224115),
(224116, '1.10.10.10-FF-002099', NULL, 'Uncharacterized protein', 42, NULL, NULL, 224116),
(224117, '3.90.660.20-FF-000001', NULL, 'Protoporphyrinogen oxidase', 205, NULL, NULL, 224117),
(224118, '1.10.472.10-FF-000109', NULL, 'Cyclin-J18-like', 124, NULL, NULL, 224118),
(224119, '2.60.40.10-FF-003698', NULL, NULL, 101, NULL, NULL, 224119),
(224120, '2.40.100.10-FF-000117', NULL, 'Peptidyl-prolyl cis-trans isomerase slr1251', 171, NULL, NULL, 224120),
(224121, '2.20.28.10-FF-000029', NULL, 'DNA helicase', 53, NULL, NULL, 224121),
(224122, '3.30.420.40-FF-001003', NULL, 'Protein CBG19481', 73, NULL, NULL, 224122),
(224123, '3.10.20.90-FF-000904', NULL, 'Uncharacterized protein', 53, NULL, NULL, 224123),
(224124, '3.40.50.300-FF-000663', NULL, 'von Willebrand factor A domain containing 8', 179, NULL, NULL, 224124),
(224125, '3.90.1600.10-FF-000044', NULL, 'Predicted protein', 98, NULL, NULL, 224125),
(224126, '3.40.50.1000-FF-000636', NULL, NULL, 29, NULL, NULL, 224126),
(224127, '3.40.50.1000-FF-000546', NULL, NULL, 198, NULL, NULL, 224127),
(224128, '1.20.120.180-FF-000003', NULL, 'Proteasome activator complex subunit 3', 90, NULL, NULL, 224128),
(224129, '3.50.50.60-FF-000215', NULL, 'FAD dependent oxidoreductase domain containing 2', 108, NULL, NULL, 224129),
(224130, '2.70.98.10-FF-000014', NULL, 'Aldose 1-epimerase, putative', 365, NULL, NULL, 224130),
(224131, '3.40.50.300-FF-003007', NULL, 'Deoxyuridine 5-triphosphate nucleotidohydrolase domain containing protein', 184, NULL, NULL, 224131),
(224132, '3.40.50.2000-FF-000037', NULL, 'Glycosyltransferase', 181, NULL, NULL, 224132),
(224133, '3.30.60.20-FF-000008', NULL, 'Protein kinase C theta', 70, NULL, NULL, 224133),
(224134, '2.40.50.140-FF-001176', NULL, NULL, 122, NULL, NULL, 224134),
(224135, '3.30.160.60-FF-006497', NULL, NULL, 58, NULL, NULL, 224135),
(224136, '1.10.3720.10-FF-000141', NULL, 'Amino acid ABC transporter permease', 228, NULL, NULL, 224136),
(224137, '2.60.120.970-FF-000106', NULL, 'Putative TGF-beta ligand Decapentaplegic protein', 266, NULL, NULL, 224137),
(224138, '2.60.40.10-FF-005974', NULL, NULL, 103, NULL, NULL, 224138),
(224139, '2.120.10.80-FF-000364', NULL, 'Predicted protein', 252, NULL, NULL, 224139),
(224140, '1.10.645.10-FF-000005', NULL, 'NADH-quinone oxidoreductase subunit D', 385, NULL, NULL, 224140),
(224141, '1.20.1250.20-FF-001807', NULL, 'Slc17a3 protein', 168, NULL, NULL, 224141),
(224142, '2.60.40.60-FF-000615', NULL, 'Cadherin-2', 88, NULL, NULL, 224142),
(224143, '1.10.287.940-FF-000025', NULL, 'Predicted protein', 14, NULL, NULL, 224143),
(224144, '1.25.40.10-FF-003888', NULL, 'Testis-expressed 11', 80, NULL, NULL, 224144),
(224145, '1.25.10.10-FF-000008', NULL, 'plakophilin-4 isoform X1', 482, NULL, NULL, 224145),
(224146, '2.60.120.10-FF-000693', NULL, 'Predicted protein', 63, NULL, NULL, 224146),
(224147, '3.40.50.300-FF-000843', NULL, 'Chromatin structure-remodeling complex subunit snf21', 297, NULL, NULL, 224147),
(224148, '3.30.2350.20-FF-000013', NULL, 'Putative tRNA pseudouridine synthase D', 154, NULL, NULL, 224148),
(224149, '3.40.120.10-FF-000082', NULL, 'Phosphomannomutase', 140, NULL, NULL, 224149),
(224150, '2.70.98.20-FF-000017', NULL, 'Amine oxidase', 312, NULL, NULL, 224150),
(224151, '3.30.497.10-FF-000126', NULL, 'Os05g0511800 protein', 164, NULL, NULL, 224151),
(224152, '3.40.190.10-FF-000411', NULL, 'Probable transcriptional regulator', 97, NULL, NULL, 224152),
(224153, '3.30.60.30-FF-000253', NULL, 'Uncharacterized protein', 72, NULL, NULL, 224153),
(224154, '2.120.10.80-FF-000420', NULL, 'Uncharacterized protein', 201, NULL, NULL, 224154),
(224155, '3.30.70.3000-FF-000008', NULL, 'Uncharacterized protein', 73, NULL, NULL, 224155),
(224156, '3.80.10.10-FF-004396', NULL, 'Uncharacterized protein', 164, NULL, NULL, 224156),
(224157, '3.30.9.10-FF-000258', NULL, 'L-2-hydroxyglutarate dehydrogenase, mitochondrial', 159, NULL, NULL, 224157),
(224158, '2.130.10.10-FF-004373', NULL, 'Uncharacterized protein', 83, NULL, NULL, 224158);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(224159, '2.60.40.10-FF-003788', NULL, NULL, 81, NULL, NULL, 224159),
(224160, '2.60.40.60-FF-000144', NULL, 'FAT atypical cadherin 4', 96, NULL, NULL, 224160),
(224161, '3.30.160.60-FF-004081', NULL, NULL, 33, NULL, NULL, 224161),
(224162, '1.25.10.10-FF-000536', NULL, 'GG11161', 266, NULL, NULL, 224162),
(224163, '2.60.40.640-FF-000083', NULL, 'Down syndrome critical region protein', 137, NULL, NULL, 224163),
(224164, '3.30.50.10-FF-000033', NULL, 'Nuclear receptor subfamily 1 group I member 2', 106, NULL, NULL, 224164),
(224165, '3.30.390.110-FF-000009', NULL, 'Uncharacterized protein', 145, NULL, NULL, 224165),
(224166, '3.40.50.1820-FF-000966', NULL, 'YALI0F16731p', 278, NULL, NULL, 224166),
(224167, '2.160.10.10-FF-000122', NULL, 'Dynactin subunit 6', 176, NULL, NULL, 224167),
(224168, '3.30.2350.10-FF-000010', NULL, 'RNA pseudouridine synthase domain-containing 2', 211, NULL, NULL, 224168),
(224169, '1.20.920.10-FF-000059', NULL, 'Polybromo 1,-like', 125, NULL, NULL, 224169),
(224170, '3.30.200.20-FF-000520', NULL, 'Calcium-dependent protein kinase 6', 99, NULL, NULL, 224170),
(224171, '3.30.70.3340-FF-000003', NULL, 'Dissimilatory sulfite reductase beta subunit', 124, NULL, NULL, 224171),
(224172, '2.40.50.100-FF-000231', NULL, 'ATPase H+-transporting V1 subunit A', 26, NULL, NULL, 224172),
(224173, '1.20.5.4770-FF-000007', NULL, 'Zinc finger A20 and AN1 domain-containing stress-associated protein 1', 59, NULL, NULL, 224173),
(224174, '2.60.40.10-FF-003411', NULL, NULL, 80, NULL, NULL, 224174),
(224175, '3.30.450.40-FF-000191', NULL, 'Bacteriophytochrome (Light-regulated signal transduction histidine kinase), PhyB2', 210, NULL, NULL, 224175),
(224176, '2.10.25.10-FF-001237', NULL, 'Slit (Drosophila) homolog 3', 43, NULL, NULL, 224176),
(224177, '3.30.70.2020-FF-000001', NULL, 'Phosphoserine phosphatase', 77, NULL, NULL, 224177),
(224178, '3.30.420.10-FF-000348', NULL, NULL, 154, NULL, NULL, 224178),
(224179, '3.30.200.20-FF-000317', NULL, 'Ephrin type-A receptor 1', 107, NULL, NULL, 224179),
(224180, '2.160.20.10-FF-000095', NULL, 'Plasmin and fibronectin-binding protein A', 451, NULL, NULL, 224180),
(224181, '1.10.10.10-FF-001789', NULL, 'Predicted protein', 86, NULL, NULL, 224181),
(224182, '3.40.50.2300-FF-000155', NULL, 'Vomeronasal 2, receptor 120', 266, NULL, NULL, 224182),
(224183, '3.40.50.10860-FF-000018', NULL, 'Shikimate 5-dehydrogenase AroE', 110, NULL, NULL, 224183),
(224184, '2.30.42.10-FF-000090', NULL, 'PDZ domain containing 7', 122, NULL, NULL, 224184),
(224185, '3.30.160.60-FF-000567', NULL, 'E3 ubiquitin-protein ligase TRIM36 isoform X1', 77, NULL, NULL, 224185),
(224186, '1.20.1270.60-FF-000337', NULL, 'Uncharacterized protein', 247, NULL, NULL, 224186),
(224187, '2.60.40.60-FF-000672', NULL, 'Predicted protein', 105, NULL, NULL, 224187),
(224188, '1.10.510.10-FF-004515', NULL, NULL, 189, NULL, NULL, 224188),
(224189, '1.10.730.10-FF-000193', NULL, 'Arginyl-tRNA synthetase, putative', 117, NULL, NULL, 224189),
(224190, '3.80.10.10-FF-000034', NULL, 'Ras suppressor protein 1', 115, NULL, NULL, 224190),
(224191, '3.30.9.10-FF-000297', NULL, 'Uncharacterized protein', 50, NULL, NULL, 224191),
(224192, '3.30.60.20-FF-000065', NULL, 'Tensin 1', 65, NULL, NULL, 224192),
(224193, '3.10.50.40-FF-000088', NULL, 'Peptidylprolyl isomerase', 118, NULL, NULL, 224193),
(224194, '3.10.20.90-FF-000814', NULL, 'Uncharacterized protein', 45, NULL, NULL, 224194),
(224195, '2.160.10.10-FF-000066', NULL, 'Acetyltransferase (Isoleucine patch superfamily)', 160, NULL, NULL, 224195),
(224196, '3.30.160.60-FF-002079', NULL, 'Uncharacterized protein', 28, NULL, NULL, 224196),
(224197, '3.30.50.10-FF-000123', NULL, 'Nuclear receptor subfamily 2 group F member 6', 57, NULL, NULL, 224197),
(224198, '1.20.5.690-FF-000005', NULL, 'Importin subunit alpha', 44, NULL, NULL, 224198),
(224199, '1.10.20.10-FF-000216', NULL, NULL, 72, NULL, NULL, 224199),
(224200, '1.10.167.10-FF-000057', NULL, 'GTPase-activating protein', 122, NULL, NULL, 224200),
(224201, '3.30.60.30-FF-000068', NULL, 'CRE-AGR-1 protein', 63, NULL, NULL, 224201);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(224202, '3.40.50.720-FF-000053', NULL, 'Quinone oxidoreductase 1', 145, NULL, NULL, 224202),
(224203, '1.10.1450.10-FF-000007', NULL, 'Tetraspanin', 115, NULL, NULL, 224203),
(224204, '1.20.1070.10-FF-001386', NULL, 'Uncharacterized protein', 247, NULL, NULL, 224204),
(224205, '1.10.10.10-FF-001992', NULL, 'Predicted protein', 43, NULL, NULL, 224205),
(224206, '1.10.132.10-FF-000005', NULL, 'DNA topoisomerase I', 107, NULL, NULL, 224206),
(224207, '3.30.1540.20-FF-000022', NULL, 'DNA mismatch repair protein (Mlh3), putative (AFU_orthologue AFUA_4G06490)', 81, NULL, NULL, 224207),
(224208, '1.10.132.20-FF-000008', NULL, 'Ribosome_recycling_factor_-_putative', 67, NULL, NULL, 224208),
(224209, '1.10.10.60-FF-000091', NULL, 'CDC5 cell division cycle 5-like', 62, NULL, NULL, 224209),
(224210, '2.60.120.920-FF-000086', NULL, 'Butyrophilin-like protein 1', 184, NULL, NULL, 224210),
(224211, '1.25.40.10-FF-005069', NULL, 'Uncharacterized protein', 98, NULL, NULL, 224211),
(224212, '3.40.50.1820-FF-001186', NULL, 'Uncharacterized protein', 119, NULL, NULL, 224212),
(224213, '3.40.50.740-FF-000059', NULL, 'Extracellular oxidoreductase molybdopterin-binding lipoprotein subunit', 73, NULL, NULL, 224213),
(224214, '3.10.100.10-FF-000087', NULL, 'Snaclec rhodocetin subunit delta', 130, NULL, NULL, 224214),
(224215, '1.25.40.10-FF-004107', NULL, 'Uncharacterized protein', 139, NULL, NULL, 224215),
(224216, '2.130.10.10-FF-002574', NULL, 'Protein will die slowly-like Protein', 95, NULL, NULL, 224216),
(224217, '2.60.40.10-FF-001989', NULL, 'Unc-89 protein', 107, NULL, NULL, 224217),
(224218, '3.40.50.300-FF-007897', NULL, 'Formate-tetrahydrofolate ligase', 190, NULL, NULL, 224218),
(224219, '1.10.287.110-FF-000074', NULL, 'Heat shock protein DNAJ, putative', 103, NULL, NULL, 224219),
(224220, '4.10.890.10-FF-000001', NULL, 'Protein Nef', 52, NULL, NULL, 224220),
(224221, '3.30.60.10-FF-000005', NULL, 'Endochitinase At2g43610', 47, NULL, NULL, 224221),
(224222, '2.60.420.10-FF-000002', NULL, 'Protein-glucosylgalactosylhydroxylysine glucosidase', 68, NULL, NULL, 224222),
(224223, '1.20.140.150-FF-000116', NULL, 'Claudin-10e', 124, NULL, NULL, 224223),
(224224, '3.40.50.150-FF-000742', NULL, 'Uncharacterized protein', 195, NULL, NULL, 224224),
(224225, '3.40.50.1820-FF-001129', NULL, 'Acylamino acid-releasing enzyme', 270, NULL, NULL, 224225),
(224226, '3.30.200.20-FF-000430', NULL, 'Non-specific serine/threonine protein kinase', 64, NULL, NULL, 224226),
(224227, '3.30.2160.10-FF-000029', NULL, 'Ubiquitin ligase (E3)', 84, NULL, NULL, 224227),
(224228, '3.30.70.980-FF-000058', NULL, 'Probable transcriptional regulatory protein MG332', 75, NULL, NULL, 224228),
(224229, '3.40.50.1000-FF-000456', NULL, 'UPF0655 protein C17G9.12c', 238, NULL, NULL, 224229),
(224230, '1.20.1250.20-FF-000993', NULL, 'MFS transporter, putative', 395, NULL, NULL, 224230),
(224231, '3.90.1410.10-FF-000029', NULL, 'Predicted protein', 259, NULL, NULL, 224231),
(224232, '1.10.20.120-FF-000005', NULL, 'Uncharacterized protein', 184, NULL, NULL, 224232),
(224233, '2.60.40.10-FF-001899', NULL, 'Immunoglobulin superfamily containing leucine rich repeat 2', 129, NULL, NULL, 224233),
(224234, '3.30.40.10-FF-001078', NULL, 'GM14196', 65, NULL, NULL, 224234),
(224235, '2.40.180.10-FF-000038', NULL, 'Catalase', 140, NULL, NULL, 224235),
(224236, '1.10.238.10-FF-000672', NULL, 'Uncharacterized protein', 180, NULL, NULL, 224236),
(224237, '1.10.287.70-FF-000123', NULL, 'Potassium channel KAT3', 236, NULL, NULL, 224237),
(224238, '3.30.2410.10-FF-000066', NULL, 'Predicted protein', 120, NULL, NULL, 224238),
(224239, '3.40.50.10860-FF-000075', NULL, 'Uncharacterized protein', 33, NULL, NULL, 224239),
(224240, '3.80.10.10-FF-001523', NULL, 'Leucine rich repeat protein GP150', 117, NULL, NULL, 224240),
(224241, '2.130.10.10-FF-004463', NULL, 'Uncharacterized protein', 261, NULL, NULL, 224241),
(224242, '3.40.109.10-FF-000038', NULL, 'Putative oxidoreductase', 221, NULL, NULL, 224242),
(224243, '1.10.10.1050-FF-000024', NULL, 'GM04208p', 28, NULL, NULL, 224243);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(224244, '4.10.1170.10-FF-000005', NULL, 'MAP kinase-activated protein kinase 3', 64, NULL, NULL, 224244),
(224245, '2.60.40.1910-FF-000017', NULL, 'Aminopeptidase', 89, NULL, NULL, 224245),
(224246, '3.90.470.10-FF-000017', NULL, '54S ribosomal protein L22, mitochondrial', 160, NULL, NULL, 224246),
(224247, '3.40.190.10-FF-000501', NULL, 'Oligopeptide ABC transporter, periplasmic oligopeptide-binding protein', 276, NULL, NULL, 224247),
(224248, '1.10.3720.10-FF-000051', NULL, 'Amino acid ABC transporter, permease protein', 213, NULL, NULL, 224248),
(224249, '3.90.226.10-FF-000080', NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', 363, NULL, NULL, 224249),
(224250, '1.10.20.10-FF-000273', NULL, NULL, 78, NULL, NULL, 224250),
(224251, '1.10.287.660-FF-000008', NULL, 'Pre-mRNA processing ribonucleoprotein, binding domain protein', 61, NULL, NULL, 224251),
(224252, '1.25.10.10-FF-000626', NULL, 'Adaptor related protein complex 5 subunit zeta 1', 231, NULL, NULL, 224252),
(224253, '1.20.1250.20-FF-001246', NULL, 'Peptide transporter PTR2-B', 542, NULL, NULL, 224253),
(224254, '2.40.70.10-FF-000261', NULL, 'Renin', 158, NULL, NULL, 224254),
(224255, '2.40.50.1000-FF-000002', NULL, '40S ribosomal protein S11', 158, NULL, NULL, 224255),
(224256, '2.60.260.20-FF-000060', NULL, 'Scj1p', 96, NULL, NULL, 224256),
(224257, '3.40.50.620-FF-000877', NULL, 'Uncharacterized protein', 122, NULL, NULL, 224257),
(224258, '3.80.10.10-FF-001670', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 100, NULL, NULL, 224258),
(224259, '3.40.50.720-FF-000143', NULL, 'Fatty acyl-CoA reductase', 344, NULL, NULL, 224259),
(224260, '2.60.40.640-FF-000026', NULL, 'Aly1p', 94, NULL, NULL, 224260),
(224261, '3.10.330.10-FF-000042', NULL, 'Uncharacterized protein', 113, NULL, NULL, 224261),
(224262, '2.130.10.10-FF-003592', NULL, 'HEAT repeatcontaining protein', 80, NULL, NULL, 224262),
(224263, '3.90.228.10-FF-000062', NULL, 'Zinc finger CCCH-type antiviral protein 1', 113, NULL, NULL, 224263),
(224264, '1.20.58.390-FF-000218', NULL, 'Uncharacterized protein', 104, NULL, NULL, 224264),
(224265, '3.40.50.1820-FF-001276', NULL, 'Uncharacterized protein', 298, NULL, NULL, 224265),
(224266, '3.50.50.60-FF-000305', NULL, 'Rab proteins geranylgeranyltransferase component A', 207, NULL, NULL, 224266),
(224267, '2.40.70.10-FF-000019', NULL, 'aspartyl protease family protein 2', 188, NULL, NULL, 224267),
(224268, '3.40.50.300-FF-004553', NULL, 'Uridine kinase, putative (AFU_orthologue AFUA_2G05430)', 80, NULL, NULL, 224268),
(224269, '3.30.40.10-FF-002005', NULL, 'Predicted protein', 51, NULL, NULL, 224269),
(224270, '1.20.58.1620-FF-000001', NULL, 'Thylakoid lumenal 29 kDa protein, chloroplastic', 65, NULL, NULL, 224270),
(224271, '1.10.510.10-FF-000625', NULL, 'Cysteine-rich receptor-like protein kinase 6', 204, NULL, NULL, 224271),
(224272, '3.40.50.300-FF-007987', NULL, 'Uncharacterized protein', 157, NULL, NULL, 224272),
(224273, '2.60.120.200-FF-000578', NULL, 'Uncharacterized protein', 173, NULL, NULL, 224273),
(224274, '3.30.160.60-FF-004552', NULL, NULL, 54, NULL, NULL, 224274),
(224275, '3.30.830.10-FF-000014', NULL, 'Mitochondrial-processing peptidase alpha subunit, mitochondrial', 222, NULL, NULL, 224275),
(224276, '2.40.50.100-FF-000028', NULL, 'Sugar ABC transporter, ATP-binding protein', 64, NULL, NULL, 224276),
(224277, '3.30.200.20-FF-000374', NULL, 'Serine/threonine protein kinase', 109, NULL, NULL, 224277),
(224278, '1.10.560.10-FF-000157', NULL, 'Uncharacterized protein', 117, NULL, NULL, 224278),
(224279, '2.170.120.12-FF-000034', NULL, 'Uncharacterized protein', 20, NULL, NULL, 224279),
(224280, '2.40.50.100-FF-000085', NULL, '50S ribosomal protein L27', 63, NULL, NULL, 224280),
(224281, '3.30.565.10-FF-000116', NULL, 'Sensor histidine kinase FleS', 141, NULL, NULL, 224281),
(224282, '3.40.1410.10-FF-000024', NULL, 'GntR family transcriptional regulator', 157, NULL, NULL, 224282),
(224283, '3.30.70.270-FF-000233', NULL, NULL, 188, NULL, NULL, 224283),
(224284, '2.60.40.60-FF-000762', NULL, 'Cadherin-4', 106, NULL, NULL, 224284);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(224285, '2.70.130.10-FF-000141', NULL, NULL, 98, NULL, NULL, 224285),
(224286, '1.10.510.10-FF-000064', NULL, 'BR serine/threonine-protein kinase 2', 345, NULL, NULL, 224286),
(224287, '1.20.140.150-FF-000026', NULL, 'Epithelial membrane protein 1', 160, NULL, NULL, 224287),
(224288, '1.20.1070.10-FF-001908', NULL, 'Uncharacterized protein', 336, NULL, NULL, 224288),
(224289, '1.10.274.100-FF-000005', NULL, 'DNA-directed RNA polymerase subunit', 172, NULL, NULL, 224289),
(224290, '3.30.160.60-FF-000281', NULL, 'Zinc finger protein 558 isoform X1', 30, NULL, NULL, 224290),
(224291, '1.25.40.20-FF-000367', NULL, 'Transcription factor', 218, NULL, NULL, 224291),
(224292, '1.25.40.10-FF-000364', NULL, 'Pentatricopeptide repeat (PPR-like) superfamily protein', 99, NULL, NULL, 224292),
(224293, '1.20.5.4820-FF-000006', NULL, 'Myosin XVI', 112, NULL, NULL, 224293),
(224294, '3.90.550.10-FF-000260', NULL, 'N-acylneuraminate cytidylyltransferase', 228, NULL, NULL, 224294),
(224295, '3.40.50.300-FF-004643', NULL, 'AGAP001537-PA', 80, NULL, NULL, 224295),
(224296, '2.130.10.10-FF-003968', NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', 238, NULL, NULL, 224296),
(224297, '2.60.40.10-FF-002394', NULL, 'Protein madd-4', 78, NULL, NULL, 224297),
(224298, '1.20.1060.20-FF-000017', NULL, 'Chromosome partition protein Smc', 78, NULL, NULL, 224298),
(224299, '3.40.50.300-FF-008353', NULL, 'ATP-binding cassette subfamily C member 9', 209, NULL, NULL, 224299),
(224300, '1.10.510.10-FF-004425', NULL, NULL, 62, NULL, NULL, 224300),
(224301, '3.30.160.60-FF-000039', NULL, 'Zinc finger protein ZIC 1', 27, NULL, NULL, 224301),
(224302, '1.25.10.10-FF-000065', NULL, 'Regulatory-associated protein of MTOR, complex 1', 253, NULL, NULL, 224302),
(224303, '2.40.50.140-FF-001209', NULL, NULL, 85, NULL, NULL, 224303),
(224304, '1.10.287.110-FF-000164', NULL, 'dnaJ homolog subfamily C member 22', 88, NULL, NULL, 224304),
(224305, '1.20.1250.20-FF-001920', NULL, 'Glr0912 protein', 222, NULL, NULL, 224305),
(224306, '3.30.40.10-FF-001752', NULL, 'Uncharacterized protein', 86, NULL, NULL, 224306),
(224307, '3.90.420.10-FF-000014', NULL, 'Uncharacterized protein', 127, NULL, NULL, 224307),
(224308, '3.80.10.10-FF-001338', NULL, 'F-box/leucine rich repeat protein, putative', 280, NULL, NULL, 224308),
(224309, '1.10.150.130-FF-000002', NULL, 'Tyrosine recombinase XerD', 98, NULL, NULL, 224309),
(224310, '3.80.10.10-FF-001580', NULL, 'F-box family protein', 105, NULL, NULL, 224310),
(224311, '3.10.20.90-FF-000292', NULL, 'Next to BRCA1 gene 1 protein', 83, NULL, NULL, 224311),
(224312, '1.20.1060.10-FF-000014', NULL, 'Polymerase (DNA directed) nu', 116, NULL, NULL, 224312),
(224313, '3.40.710.10-FF-000166', NULL, 'Peptidoglycan transglycosylase and transpeptidase MrcA', 377, NULL, NULL, 224313),
(224314, '3.30.360.10-FF-000056', NULL, 'Myo-inositol 2-dehydrogenase/D-chiro-inositol 1-dehydrogenase', 214, NULL, NULL, 224314),
(224315, '3.90.1150.220-FF-000004', NULL, 'Uncharacterized protein', 74, NULL, NULL, 224315),
(224316, '2.40.50.100-FF-000175', NULL, 'Uncharacterized protein', 93, NULL, NULL, 224316),
(224317, '1.25.40.10-FF-003798', NULL, 'Uncharacterized protein', 143, NULL, NULL, 224317),
(224318, '1.10.560.10-FF-000067', NULL, 'Chaperonin 60', 246, NULL, NULL, 224318),
(224319, '1.10.3470.10-FF-000014', NULL, 'Iron ABC transporter permease', 324, NULL, NULL, 224319),
(224320, '1.10.510.10-FF-000772', NULL, 'Predicted protein', 207, NULL, NULL, 224320),
(224321, '2.60.40.60-FF-000054', NULL, 'protocadherin-15 isoform X1', 98, NULL, NULL, 224321),
(224322, '2.40.70.10-FF-000171', NULL, 'Eukaryotic aspartyl protease family protein', 212, NULL, NULL, 224322),
(224323, '3.10.690.10-FF-000001', NULL, 'Bifunctional nuclease family protein', 139, NULL, NULL, 224323),
(224324, '1.20.5.420-FF-000008', NULL, 'Endo-1,3-beta-glucanase Engl1', 49, NULL, NULL, 224324),
(224325, '3.40.630.10-FF-000165', NULL, 'Glucan 1,4-alpha-glucosidase, putative', 313, NULL, NULL, 224325),
(224326, '3.40.47.10-FF-000132', NULL, NULL, 68, NULL, NULL, 224326);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(224327, '3.40.5.10-FF-000002', NULL, '50S ribosomal protein L9', 59, NULL, NULL, 224327),
(224328, '1.25.10.10-FF-000716', NULL, 'Nucleotide exchange factor', 297, NULL, NULL, 224328),
(224329, '2.60.40.60-FF-000705', NULL, 'Cdh-4', 102, NULL, NULL, 224329),
(224330, '3.30.160.60-FF-004642', NULL, NULL, 37, NULL, NULL, 224330),
(224331, '2.60.260.20-FF-000150', NULL, 'Chaperone protein dnaJ 3', 72, NULL, NULL, 224331),
(224332, '3.30.70.100-FF-000082', NULL, 'Putative NipSnap protein K02D10.1', 119, NULL, NULL, 224332),
(224333, '3.30.1370.10-FF-000040', NULL, 'KH domain-containing protein At2g38610', 202, NULL, NULL, 224333),
(224334, '1.20.58.390-FF-000185', NULL, 'Uncharacterized protein', 72, NULL, NULL, 224334),
(224335, '3.90.1150.210-FF-000001', NULL, 'F-actin-capping protein subunit beta', 182, NULL, NULL, 224335),
(224336, '2.60.40.10-FF-003844', NULL, 'Exo-beta-D-glucosaminidase', 102, NULL, NULL, 224336),
(224337, '3.40.50.300-FF-007369', NULL, 'Uncharacterized protein', 111, NULL, NULL, 224337),
(224338, '3.30.1120.10-FF-000049', NULL, 'Uncharacterized protein', 74, NULL, NULL, 224338),
(224339, '3.40.50.10190-FF-000357', NULL, 'Predicted protein', 79, NULL, NULL, 224339),
(224340, '1.10.510.10-FF-003498', NULL, NULL, 256, NULL, NULL, 224340),
(224341, '1.20.58.390-FF-000128', NULL, 'Neuronal acetylcholine receptor subunit eat-2', 151, NULL, NULL, 224341),
(224342, '3.90.1140.10-FF-000025', NULL, 'Uncharacterized protein', 209, NULL, NULL, 224342),
(224343, '1.20.920.30-FF-000076', NULL, 'Uncharacterized protein', 26, NULL, NULL, 224343),
(224344, '2.130.10.10-FF-005885', NULL, 'Probable inositol polyphosphate 5-phosphatase C9G1.10c', 297, NULL, NULL, 224344),
(224345, '3.40.50.880-FF-000056', NULL, 'Imidazole glycerol phosphate synthase subunit HisH', 206, NULL, NULL, 224345),
(224346, '1.10.10.60-FF-000652', NULL, 'Os01g0308000 protein', 67, NULL, NULL, 224346),
(224347, '3.40.800.20-FF-000030', NULL, 'Histone deacetylase 3, putative', 429, NULL, NULL, 224347),
(224348, '2.120.10.30-FF-000276', NULL, 'low-density lipoprotein receptor 1', 334, NULL, NULL, 224348),
(224349, '1.25.10.10-FF-002453', NULL, 'ARM repeat superfamily protein', 227, NULL, NULL, 224349),
(224350, '2.160.20.10-FF-000331', NULL, 'Uncharacterized protein', 90, NULL, NULL, 224350),
(224351, '3.10.100.10-FF-000227', NULL, 'Lymphocyte antigen 75', 147, NULL, NULL, 224351),
(224352, '1.20.1560.10-FF-000884', NULL, 'MDR-like ABC transporter', 168, NULL, NULL, 224352),
(224353, '3.40.50.300-FF-003131', NULL, 'ATP-dependent RNA helicase RhlE', 210, NULL, NULL, 224353),
(224354, '3.40.50.1820-FF-001399', NULL, 'Lipase, putative', 211, NULL, NULL, 224354),
(224355, '2.130.10.10-FF-004311', NULL, 'Uncharacterized protein', 113, NULL, NULL, 224355),
(224356, '3.60.21.10-FF-000420', NULL, 'Uncharacterized protein', 274, NULL, NULL, 224356),
(224357, '3.30.500.10-FF-000034', NULL, NULL, 170, NULL, NULL, 224357),
(224358, '3.30.1010.10-FF-000013', NULL, 'Protein kinase, DNA-activated, catalytic subunit', 154, NULL, NULL, 224358),
(224359, '2.40.30.10-FF-000051', NULL, 'NADPH-dependent diflavin oxidoreductase 1', 108, NULL, NULL, 224359),
(224360, '3.80.10.10-FF-001731', NULL, 'Hypothetical_protein_-_conserved', 142, NULL, NULL, 224360),
(224361, '1.25.40.20-FF-001502', NULL, 'Predicted protein', 47, NULL, NULL, 224361),
(224362, '1.10.1070.11-FF-000114', NULL, 'Uncharacterized protein', 192, NULL, NULL, 224362),
(224363, '2.60.40.10-FF-002630', NULL, 'transmembrane protein 131 homolog', 99, NULL, NULL, 224363),
(224364, '1.20.1070.10-FF-001526', NULL, 'Uncharacterized protein', 187, NULL, NULL, 224364),
(224365, '1.10.510.10-FF-003200', NULL, NULL, 147, NULL, NULL, 224365),
(224366, '3.40.50.200-FF-000167', NULL, 'Predicted protein', 103, NULL, NULL, 224366),
(224367, '3.40.1050.10-FF-000007', NULL, 'Carbonic anhydrase', 238, NULL, NULL, 224367),
(224368, '3.10.20.90-FF-000286', NULL, 'Unplaced genomic scaffold supercont2.15, whole genome shotgun sequence', 89, NULL, NULL, 224368),
(224369, '1.25.40.10-FF-004046', NULL, 'Uncharacterized protein', 175, NULL, NULL, 224369);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(224370, '1.10.510.10-FF-004335', NULL, NULL, 134, NULL, NULL, 224370),
(224371, '3.90.1640.10-FF-000018', NULL, 'Inorganic diphosphatase', 120, NULL, NULL, 224371),
(224372, '3.50.50.60-FF-000300', NULL, 'FAD-dependent oxidoreductase domain-containing 2', 140, NULL, NULL, 224372),
(224373, '2.120.10.80-FF-000151', NULL, 'Kelch repeat-containing protein 2', 171, NULL, NULL, 224373),
(224374, '3.60.130.10-FF-000089', NULL, 'Predicted protein', 190, NULL, NULL, 224374),
(224375, '1.20.120.1900-FF-000071', NULL, 'Gamma-tubulin complex component', 295, NULL, NULL, 224375),
(224376, '2.20.80.10-FF-000004', NULL, 'Vitellogenin-3', 229, NULL, NULL, 224376),
(224377, '2.60.40.10-FF-005856', NULL, NULL, 98, NULL, NULL, 224377),
(224378, '3.30.160.60-FF-002804', NULL, 'RE1-silencing transcription factor', 28, NULL, NULL, 224378),
(224379, '2.40.50.1060-FF-000008', NULL, 'Related to dna-dependent rna polymerase I subunit a43 (Rpa43)', 189, NULL, NULL, 224379),
(224380, '2.30.29.30-FF-000340', NULL, 'Arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 2', 126, NULL, NULL, 224380),
(224381, '3.80.10.10-FF-003822', NULL, 'Leucine-rich repeat family protein', 73, NULL, NULL, 224381),
(224382, '3.30.1640.10-FF-000044', NULL, 'DNA replication licensing factor MCM7', 122, NULL, NULL, 224382),
(224383, '3.30.420.40-FF-000273', NULL, 'Pantothenate kinase 2', 186, NULL, NULL, 224383),
(224384, '2.30.30.40-FF-000346', NULL, 'GTPase-activating protein rrc-1', 92, NULL, NULL, 224384),
(224385, '3.30.70.330-FF-001926', NULL, NULL, 145, NULL, NULL, 224385),
(224386, '1.10.238.10-FF-000633', NULL, 'Uncharacterized protein', 78, NULL, NULL, 224386),
(224387, '1.10.437.10-FF-000039', NULL, 'Uncharacterized protein', 130, NULL, NULL, 224387),
(224388, '2.130.10.10-FF-005834', NULL, 'Uncharacterized protein', 375, NULL, NULL, 224388),
(224389, '3.10.20.90-FF-000674', NULL, 'Ubx domain containing protein, putative', 79, NULL, NULL, 224389),
(224390, '3.40.630.30-FF-000379', NULL, 'Spermidine N(1)-acetyltransferase', 159, NULL, NULL, 224390),
(224391, '3.30.9.10-FF-000179', NULL, 'Sll1025 protein', 156, NULL, NULL, 224391),
(224392, '3.40.630.10-FF-000373', NULL, 'Uncharacterized protein', 113, NULL, NULL, 224392),
(224393, '3.10.20.90-FF-000348', NULL, 'DNA damage-inducible protein', 82, NULL, NULL, 224393),
(224394, '1.10.510.10-FF-002683', NULL, NULL, 198, NULL, NULL, 224394),
(224395, '2.40.10.10-FF-000572', NULL, NULL, 61, NULL, NULL, 224395),
(224396, '1.10.510.10-FF-002306', NULL, 'Serine/threonine-protein kinase CDG1', 223, NULL, NULL, 224396),
(224397, '3.60.21.10-FF-000195', NULL, 'Serine/threonine-protein phosphatase', 311, NULL, NULL, 224397),
(224398, '3.40.1810.10-FF-000038', NULL, 'MADS-box transcription factor 34', 57, NULL, NULL, 224398),
(224399, '1.10.10.10-FF-000098', NULL, 'Two-component system response regulator PhoP', 101, NULL, NULL, 224399),
(224400, '3.40.190.80-FF-000056', NULL, '3''(2''),5''-bisphosphate nucleotidase CysQ', 106, NULL, NULL, 224400),
(224401, '1.10.540.10-FF-000094', NULL, 'Uncharacterized protein', 142, NULL, NULL, 224401),
(224402, '1.25.40.20-FF-000934', NULL, 'Uncharacterized protein', 153, NULL, NULL, 224402),
(224403, '1.20.1050.20-FF-000011', NULL, NULL, 106, NULL, NULL, 224403),
(224404, '3.30.200.20-FF-001627', NULL, 'Serine/threonine-protein kinase TAO3', 96, NULL, NULL, 224404),
(224405, '2.40.128.130-FF-000004', NULL, 'Autotransporter domain-containing esterase', 308, NULL, NULL, 224405),
(224406, '3.40.630.10-FF-000159', NULL, 'Uncharacterized protein', 229, NULL, NULL, 224406),
(224407, '1.20.140.10-FF-000089', NULL, 'Pimeloyl-CoA dehydrogenase small subunit', 143, NULL, NULL, 224407),
(224408, '3.30.565.10-FF-000083', NULL, 'Two-component sensor histidine kinase', 152, NULL, NULL, 224408),
(224409, '2.60.200.20-FF-000056', NULL, 'Putative fork head domain protein', 160, NULL, NULL, 224409),
(224410, '3.90.550.50-FF-000064', NULL, 'Hexosyltransferase', 246, NULL, NULL, 224410),
(224411, '3.40.1030.10-FF-000012', NULL, 'Thymidine phosphorylase', 59, NULL, NULL, 224411);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(224412, '1.10.10.820-FF-000005', NULL, 'unconventional myosin-VI isoform X2', 57, NULL, NULL, 224412),
(224413, '2.60.40.2030-FF-000025', NULL, 'Adhesion G protein-coupled receptor V1', 124, NULL, NULL, 224413),
(224414, '3.40.50.200-FF-000072', NULL, 'Uncharacterized protein', 138, NULL, NULL, 224414),
(224415, '3.40.50.970-FF-000111', NULL, 'Uncharacterized protein', 110, NULL, NULL, 224415),
(224416, '3.20.20.140-FF-000479', NULL, 'Uncharacterized protein', 100, NULL, NULL, 224416),
(224417, '1.10.10.830-FF-000008', NULL, 'Isoleucine--tRNA ligase', 57, NULL, NULL, 224417),
(224418, '3.30.230.130-FF-000082', NULL, 'Anaphase-promoting complex subunit 2', 137, NULL, NULL, 224418),
(224419, '1.25.40.10-FF-004260', NULL, 'Uncharacterized protein', 225, NULL, NULL, 224419),
(224420, '1.10.150.20-FF-000235', NULL, 'Uncharacterized protein', 62, NULL, NULL, 224420),
(224421, '3.40.50.300-FF-001040', NULL, 'AFG1-like ATPase isoform C', 202, NULL, NULL, 224421),
(224422, '1.20.120.720-FF-000030', NULL, 'Myosin 1', 156, NULL, NULL, 224422),
(224423, '1.10.150.650-FF-000006', NULL, 'PHP domain-containing protein', 77, NULL, NULL, 224423),
(224424, '2.60.40.10-FF-002304', NULL, 'KALlmann syndrome homolog', 99, NULL, NULL, 224424),
(224425, '3.30.70.330-FF-000392', NULL, 'SRA stem-loop-interacting RNA-binding protein, mitochondrial', 79, NULL, NULL, 224425),
(224426, '1.10.560.10-FF-000005', NULL, 'T-complex protein 1 subunit alpha', 238, NULL, NULL, 224426),
(224427, '1.10.10.10-FF-001458', NULL, 'Uncharacterized protein', 93, NULL, NULL, 224427),
(224428, '3.40.50.1440-FF-000032', NULL, 'tubulin beta chain', 31, NULL, NULL, 224428),
(224429, '2.160.20.10-FF-000005', NULL, 'F-box only protein 11', 161, NULL, NULL, 224429),
(224430, '2.60.40.10-FF-004007', NULL, NULL, 99, NULL, NULL, 224430),
(224431, '1.25.40.430-FF-000002', NULL, 'mitotic checkpoint serine/threonine-protein kinase BUB1 beta', 185, NULL, NULL, 224431),
(224432, '3.30.160.60-FF-001270', NULL, 'zinc finger protein 583 isoform X1', 32, NULL, NULL, 224432),
(224433, '3.40.50.300-FF-002349', NULL, 'DNA mismatch repair protein MutS', 254, NULL, NULL, 224433),
(224434, '3.40.50.300-FF-001091', NULL, 'Probable disease resistance protein At1g61300', 169, NULL, NULL, 224434),
(224435, '1.25.40.10-FF-000605', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 112, NULL, NULL, 224435),
(224436, '1.20.1250.20-FF-001841', NULL, 'Uncharacterized protein', 137, NULL, NULL, 224436),
(224437, '3.50.50.60-FF-000007', NULL, 'Alkyl hydroperoxide reductase, F subunit', 124, NULL, NULL, 224437),
(224438, '3.90.740.10-FF-000055', NULL, 'Valyl Amino-acyl tRNA Synthetase', 121, NULL, NULL, 224438),
(224439, '2.60.40.60-FF-000767', NULL, 'Cadherin', 117, NULL, NULL, 224439),
(224440, '3.30.200.20-FF-002021', NULL, 'Predicted protein', 93, NULL, NULL, 224440),
(224441, '3.30.420.40-FF-000694', NULL, 'AGAP003464-PA', 282, NULL, NULL, 224441),
(224442, '2.60.40.10-FF-002355', NULL, '1,4-alpha-glucan branching enzyme, putative', 120, NULL, NULL, 224442),
(224443, '2.120.10.80-FF-000100', NULL, 'Kelch-like 11 (Drosophila), isoform CRA_a', 91, NULL, NULL, 224443),
(224444, '2.60.40.1360-FF-000015', NULL, 'Alpha-mannosidase E', 153, NULL, NULL, 224444),
(224445, '1.25.40.20-FF-000608', NULL, 'Os04g0574600 protein', 116, NULL, NULL, 224445),
(224446, '1.20.1050.10-FF-000103', NULL, 'Glutathione S-transferase F9', 145, NULL, NULL, 224446),
(224447, '1.20.58.1770-FF-000001', NULL, 'C-Jun-amino-terminal kinase-interacting protein 3 isoform X1', 79, NULL, NULL, 224447),
(224448, '3.80.10.10-FF-001782', NULL, 'Protein CBG08830', 113, NULL, NULL, 224448),
(224449, '1.10.3380.30-FF-000013', NULL, 'Putative ATP-dependent RNA helicase', 216, NULL, NULL, 224449),
(224450, '3.30.565.10-FF-000178', NULL, 'Sigma factor regulatory protein', 142, NULL, NULL, 224450),
(224451, '1.10.3380.20-FF-000010', NULL, NULL, 53, NULL, NULL, 224451),
(224452, '3.30.450.40-FF-000196', NULL, 'Histidine kinase dimerisation and phosphoacceptor region', 164, NULL, NULL, 224452),
(224453, '2.10.25.10-FF-001568', NULL, 'Uncharacterized protein', 73, NULL, NULL, 224453);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(224454, '1.10.510.10-FF-002357', NULL, NULL, 189, NULL, NULL, 224454),
(224455, '3.90.190.10-FF-000597', NULL, 'Uncharacterized protein', 292, NULL, NULL, 224455),
(224456, '3.30.160.60-FF-006227', NULL, NULL, 42, NULL, NULL, 224456),
(224457, '1.20.1560.10-FF-000558', NULL, 'Multidrug resistance protein 1', 222, NULL, NULL, 224457),
(224458, '3.10.10.10-FF-000020', NULL, NULL, 33, NULL, NULL, 224458),
(224459, '3.90.550.50-FF-000013', NULL, 'Hexosyltransferase', 165, NULL, NULL, 224459),
(224460, '1.10.357.10-FF-000038', NULL, 'TetR family transcriptional regulator', 186, NULL, NULL, 224460),
(224461, '3.30.470.30-FF-000076', NULL, 'Uncharacterized protein', 123, NULL, NULL, 224461),
(224462, '1.10.10.60-FF-000910', NULL, NULL, 66, NULL, NULL, 224462),
(224463, '1.20.58.1780-FF-000004', NULL, 'Nuclear pore complex protein Nup155', 278, NULL, NULL, 224463),
(224464, '1.20.1110.10-FF-000272', NULL, NULL, 117, NULL, NULL, 224464),
(224465, '3.30.2380.10-FF-000006', NULL, 'KEOPS complex subunit Cgi121', 136, NULL, NULL, 224465),
(224466, '3.80.10.10-FF-002979', NULL, 'Uncharacterized protein', 99, NULL, NULL, 224466),
(224467, '1.10.8.60-FF-000286', NULL, 'FI21292p1', 85, NULL, NULL, 224467),
(224468, '1.10.1040.30-FF-000004', NULL, 'ISWI chromatin-remodeling complex ATPase ISW2', 144, NULL, NULL, 224468),
(224469, '1.10.510.10-FF-000266', NULL, 'nuclear receptor-binding protein 2', 188, NULL, NULL, 224469),
(224470, '2.60.40.10-FF-002416', NULL, 'Protogenin', 98, NULL, NULL, 224470),
(224471, '2.60.40.60-FF-000560', NULL, 'Cadherin-related hmr-1', 107, NULL, NULL, 224471),
(224472, '3.90.550.10-FF-000434', NULL, 'Uncharacterized alpha-1,2-galactosyltransferase C1289.13c', 121, NULL, NULL, 224472),
(224473, '3.40.50.300-FF-002288', NULL, 'Probable thymidylate kinase', 220, NULL, NULL, 224473),
(224474, '1.25.40.10-FF-000656', NULL, 'Unplaced genomic scaffold supercont1.51, whole genome shotgun sequence', 285, NULL, NULL, 224474),
(224475, '2.20.28.10-FF-000057', NULL, 'DNA helicase', 51, NULL, NULL, 224475),
(224476, '2.70.170.10-FF-000205', NULL, 'Uncharacterized protein', 162, NULL, NULL, 224476),
(224477, '3.30.70.960-FF-000013', NULL, 'Mucin glycoprotein MUC3', 99, NULL, NULL, 224477),
(224478, '3.40.50.2300-FF-001049', NULL, NULL, 142, NULL, NULL, 224478),
(224479, '3.30.160.60-FF-000455', NULL, 'Transcription factor Sp2', 39, NULL, NULL, 224479),
(224480, '3.40.50.1820-FF-000090', NULL, 'Phosphatidylcholine-sterol acyltransferase', 69, NULL, NULL, 224480),
(224481, '2.60.120.10-FF-000570', NULL, 'Protein kinase, cAMP-dependent, regulatory, type I, beta', 72, NULL, NULL, 224481),
(224482, '2.10.25.10-FF-001361', NULL, 'Integrin beta', 37, NULL, NULL, 224482),
(224483, '2.70.130.10-FF-000085', NULL, NULL, 145, NULL, NULL, 224483),
(224484, '2.170.150.20-FF-000025', NULL, 'Peptide-methionine (R)-S-oxide reductase', 106, NULL, NULL, 224484),
(224485, '3.40.50.1440-FF-000127', NULL, 'Uncharacterized protein', 206, NULL, NULL, 224485),
(224486, '3.90.1150.10-FF-000262', NULL, 'Kynurenine aminotransferase, putative', 100, NULL, NULL, 224486),
(224487, '1.20.1070.10-FF-001740', NULL, 'Zg11', 87, NULL, NULL, 224487),
(224488, '3.40.190.10-FF-000237', NULL, 'Molybdate ABC transporter substrate-binding protein', 102, NULL, NULL, 224488),
(224489, '3.80.10.10-FF-000888', NULL, 'UBA/TS-N domain containing protein', 145, NULL, NULL, 224489),
(224490, '3.40.1280.10-FF-000030', NULL, 'RNA methyltransferase, TrmH family family', 171, NULL, NULL, 224490),
(224491, '3.30.70.980-FF-000019', NULL, 'Probable transcriptional regulatory protein LIC_12886', 73, NULL, NULL, 224491),
(224492, '2.130.10.10-FF-000663', NULL, 'Vacuolar import/degradation Vid27-related protein', 291, NULL, NULL, 224492),
(224493, '2.60.40.10-FF-004721', NULL, NULL, 102, NULL, NULL, 224493),
(224494, '3.30.1360.10-FF-000011', NULL, 'Related to DNA-directed RNA polymerase 13.3K chain', 117, NULL, NULL, 224494),
(224495, '1.10.510.10-FF-002418', NULL, 'Uncharacterized protein', 332, NULL, NULL, 224495),
(224496, '3.90.70.10-FF-000189', NULL, 'Ubiquitinyl hydrolase 1', 349, NULL, NULL, 224496);
INSERT INTO "PUBLIC"."MODEL" VALUES
(224497, '1.10.357.70-FF-000028', NULL, 'TNF alpha induced protein 2', 168, NULL, NULL, 224497),
(224498, '1.25.40.10-FF-003478', NULL, 'Pentatricopeptide repeat-containing protein', 93, NULL, NULL, 224498),
(224499, '3.40.1110.10-FF-000417', NULL, NULL, 37, NULL, NULL, 224499),
(224500, '2.60.120.650-FF-000100', NULL, 'JuMonJi (Transcription factor) Domain protein', 370, NULL, NULL, 224500),
(224501, '3.30.160.60-FF-004496', NULL, NULL, 70, NULL, NULL, 224501),
(224502, '4.10.60.10-FF-000072', NULL, 'Putative universal minicircle sequence binding protein', 35, NULL, NULL, 224502),
(224503, '3.10.120.10-FF-000032', NULL, 'Acyl-lipid (7-3)-desaturase', 80, NULL, NULL, 224503),
(224504, '3.80.10.10-FF-000793', NULL, 'Leucine rich melanocyte differentiation associated', 158, NULL, NULL, 224504),
(224505, '2.60.40.1670-FF-000018', NULL, 'Protein transport protein SEC23', 169, NULL, NULL, 224505),
(224506, '2.30.29.30-FF-000014', NULL, 'Homer homolog 1 (Drosophila)', 115, NULL, NULL, 224506),
(224507, '1.25.40.10-FF-004372', NULL, 'Uncharacterized protein', 150, NULL, NULL, 224507),
(224508, '1.25.40.150-FF-000008', NULL, NULL, 112, NULL, NULL, 224508),
(224509, '2.30.130.40-FF-000041', NULL, 'Uncharacterized protein', 73, NULL, NULL, 224509),
(224510, '1.20.1280.50-FF-000155', NULL, 'FBD-associated F-box protein At3g49020', 45, NULL, NULL, 224510),
(224511, '2.60.200.10-FF-000020', NULL, 'Interferon regulatory factor 4b', 223, NULL, NULL, 224511),
(224512, '2.10.25.10-FF-001147', NULL, 'Uncharacterized protein', 40, NULL, NULL, 224512),
(224513, '1.10.10.10-FF-000356', NULL, 'Bifunctional ligase/repressor BirA', 64, NULL, NULL, 224513),
(224514, '1.25.40.450-FF-000008', NULL, 'Nuclear pore complex protein Nup154', 171, NULL, NULL, 224514),
(224515, '2.60.40.10-FF-004507', NULL, NULL, 101, NULL, NULL, 224515),
(224516, '3.30.505.10-FF-000135', NULL, 'SHC-transforming protein homolog 1', 113, NULL, NULL, 224516),
(224517, '2.60.40.1660-FF-000015', NULL, 'Sodium/potassium-transporting ATPase subunit beta', 220, NULL, NULL, 224517),
(224518, '3.90.1150.170-FF-000005', NULL, 'Uncharacterized protein, isoform A', 211, NULL, NULL, 224518),
(224519, '2.120.10.30-FF-000225', NULL, 'Gluconolaconase', 291, NULL, NULL, 224519),
(224520, '3.30.300.10-FF-000053', NULL, 'Uncharacterized protein', 131, NULL, NULL, 224520),
(224521, '2.130.10.10-FF-003794', NULL, 'Uncharacterized protein', 464, NULL, NULL, 224521),
(224522, '1.25.40.10-FF-002281', NULL, 'SPbeta prophage-derived glycosyltransferase SunS', 162, NULL, NULL, 224522),
(224523, '3.40.50.300-FF-000197', NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 9', 252, NULL, NULL, 224523),
(224524, '2.10.70.10-FF-000094', NULL, 'Uncharacterized protein, isoform B', 69, NULL, NULL, 224524),
(224525, '3.40.20.10-FF-000059', NULL, 'Villin-like 1', 127, NULL, NULL, 224525),
(224526, '1.10.357.50-FF-000022', NULL, 'Exocyst complex component 3 like 4', 173, NULL, NULL, 224526),
(224527, '1.20.1250.20-FF-001162', NULL, 'Protein NRT1/ PTR FAMILY 3.1', 285, NULL, NULL, 224527),
(224528, '3.90.226.10-FF-000315', NULL, 'Predicted protein', 76, NULL, NULL, 224528),
(224529, '3.40.50.720-FF-001508', NULL, 'Uncharacterized protein', 359, NULL, NULL, 224529),
(224530, '1.10.510.10-FF-002632', NULL, 'Uncharacterized protein', 342, NULL, NULL, 224530),
(224531, '1.20.1080.10-FF-000010', NULL, 'Inner membrane protein', 238, NULL, NULL, 224531),
(224532, '3.40.50.2000-FF-000043', NULL, 'UDP-N-acetylglucosamine 2-epimerase', 195, NULL, NULL, 224532),
(224533, '3.90.70.10-FF-000464', NULL, 'Uncharacterized protein', 115, NULL, NULL, 224533),
(224534, '3.30.2160.10-FF-000063', NULL, 'Protein CBR-HECD-1', 105, NULL, NULL, 224534),
(224535, '1.25.10.10-FF-002341', NULL, 'Uncharacterized protein', 291, NULL, NULL, 224535),
(224536, '2.40.100.10-FF-000112', NULL, 'Peptidyl-prolyl cis-trans isomerase', 178, NULL, NULL, 224536),
(224537, '3.30.750.24-FF-000021', NULL, 'Sulfate Permease (SulP) Family', 138, NULL, NULL, 224537),
(224538, '3.40.30.10-FF-000745', NULL, 'Uncharacterized protein', 115, NULL, NULL, 224538);
INSERT INTO "PUBLIC"."MODEL" VALUES
(224539, '1.25.40.10-FF-002129', NULL, 'Putative pentatricopeptide repeat-containing protein At3g15130', 127, NULL, NULL, 224539),
(224540, '3.40.50.880-FF-000168', NULL, 'Putative amidotransferase', 242, NULL, NULL, 224540),
(224541, '3.30.497.10-FF-000070', NULL, 'Serpin peptidase inhibitor, clade A (alpha-1 antiproteinase, antitrypsin), member 10a', 209, NULL, NULL, 224541),
(224542, '3.20.110.10-FF-000001', NULL, 'Alpha-mannosidase', 282, NULL, NULL, 224542),
(224543, '1.10.260.50-FF-000011', NULL, NULL, 29, NULL, NULL, 224543),
(224544, '1.10.540.10-FF-000122', NULL, 'Uncharacterized protein', 59, NULL, NULL, 224544),
(224545, '1.10.510.10-FF-000912', NULL, 'obscurin isoform X1', 293, NULL, NULL, 224545),
(224546, '3.30.1490.100-FF-000011', NULL, 'DNA polymerase IV', 109, NULL, NULL, 224546),
(224547, '1.20.1640.10-FF-000093', NULL, 'Protein-export membrane protein SecF', 199, NULL, NULL, 224547),
(224548, '1.20.272.10-FF-000075', NULL, NULL, 106, NULL, NULL, 224548),
(224549, '1.20.58.60-FF-000340', NULL, 'Spectrin beta chain', 212, NULL, NULL, 224549),
(224550, '1.10.10.10-FF-001958', NULL, 'Uncharacterized protein', 73, NULL, NULL, 224550),
(224551, '3.30.559.30-FF-000029', NULL, 'Nonribosomal peptide synthetase DhbF', 238, NULL, NULL, 224551),
(224552, '3.30.70.380-FF-000002', NULL, 'phenylalanine--tRNA ligase, mitochondrial', 98, NULL, NULL, 224552),
(224553, '1.10.510.10-FF-000620', NULL, 'Putative serine/threonine-protein kinase', 241, NULL, NULL, 224553),
(224554, '2.40.50.690-FF-000036', NULL, 'DIS3 like exosome 3''-5'' exoribonuclease', 72, NULL, NULL, 224554),
(224555, '3.30.2410.10-FF-000061', NULL, 'Uncharacterized protein', 94, NULL, NULL, 224555),
(224556, '3.40.140.10-FF-000077', NULL, 'Proteasome regulatory non-ATPase subunit 8', 186, NULL, NULL, 224556),
(224557, '1.10.1410.10-FF-000089', NULL, 'Uncharacterized protein', 198, NULL, NULL, 224557),
(224558, '2.130.10.10-FF-000921', NULL, 'Protein HIR', 274, NULL, NULL, 224558),
(224559, '3.30.210.10-FF-000012', NULL, 'DNA-directed DNA/RNA polymerase mu', 30, NULL, NULL, 224559),
(224560, '3.30.810.10-FF-000018', NULL, 'Uncharacterized protein', 156, NULL, NULL, 224560),
(224561, '3.30.2350.20-FF-000007', NULL, 'PUS7p Pseudouridine synthase', 243, NULL, NULL, 224561),
(224562, '2.10.90.10-FF-000089', NULL, 'PDGF/VEGF growth factor related', 181, NULL, NULL, 224562),
(224563, '3.30.160.60-FF-002630', NULL, 'Zinc finger protein 1078', 25, NULL, NULL, 224563),
(224564, '1.25.40.10-FF-004613', NULL, 'Intraflagellar transport protein', 162, NULL, NULL, 224564),
(224565, '3.80.10.10-FF-003934', NULL, 'Uncharacterized protein', 91, NULL, NULL, 224565),
(224566, '1.20.1070.10-FF-001414', NULL, 'Adrenoceptor alpha 2A', 231, NULL, NULL, 224566),
(224567, '3.90.226.10-FF-000220', NULL, 'Uncharacterized protein', 51, NULL, NULL, 224567),
(224568, '3.10.20.90-FF-000174', NULL, 'Small ubiquitin-related modifier', 93, NULL, NULL, 224568),
(224569, '3.40.50.10810-FF-000088', NULL, 'Irc20p', 287, NULL, NULL, 224569),
(224570, '3.30.450.350-FF-000006', NULL, 'Sensory box sensor histidine kinase', 181, NULL, NULL, 224570),
(224571, '2.30.30.1150-FF-000015', NULL, 'PHD and RING finger domain-containing protein 1', 82, NULL, NULL, 224571),
(224572, '2.60.40.10-FF-005968', NULL, NULL, 106, NULL, NULL, 224572),
(224573, '3.40.1280.30-FF-000036', NULL, 'Uncharacterized protein', 123, NULL, NULL, 224573),
(224574, '1.25.10.10-FF-002627', NULL, 'Predicted protein', 129, NULL, NULL, 224574),
(224575, '1.20.1080.10-FF-000105', NULL, 'Uncharacterized protein', 162, NULL, NULL, 224575),
(224576, '3.40.50.1000-FF-000018', NULL, 'Calcium-transporting ATPase', 153, NULL, NULL, 224576),
(224577, '2.60.40.10-FF-003939', NULL, NULL, 106, NULL, NULL, 224577),
(224578, '2.40.30.10-FF-000455', NULL, 'Predicted protein', 105, NULL, NULL, 224578),
(224579, '3.40.50.300-FF-001214', NULL, 'DExH-box ATP-dependent RNA helicase', 233, NULL, NULL, 224579),
(224580, '3.30.30.30-FF-000072', NULL, 'Uncharacterized protein', 47, NULL, NULL, 224580),
(224581, '1.10.3380.10-FF-000069', NULL, 'Uncharacterized protein', 55, NULL, NULL, 224581);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(224582, '1.20.1250.20-FF-001892', NULL, 'Solute carrier family 2, facilitated glucose transporter member 2', 78, NULL, NULL, 224582),
(224583, '1.20.120.350-FF-000189', NULL, NULL, 111, NULL, NULL, 224583),
(224584, '2.60.15.10-FF-000020', NULL, 'F-type H-ATPase delta subunit', 100, NULL, NULL, 224584),
(224585, '3.40.50.1970-FF-000016', NULL, 'Putative oxidoreductase', 159, NULL, NULL, 224585),
(224586, '2.40.10.170-FF-000007', NULL, 'Transcription-repair-coupling factor', 59, NULL, NULL, 224586),
(224587, '3.30.200.20-FF-001178', NULL, 'Protein kinase, putative', 70, NULL, NULL, 224587),
(224588, '2.60.220.50-FF-000179', NULL, 'Uncharacterized protein', 63, NULL, NULL, 224588),
(224589, '2.60.40.150-FF-000475', NULL, 'E3 ubiquitin-protein ligase', 145, NULL, NULL, 224589),
(224590, '3.90.550.10-FF-000760', NULL, 'Predicted protein', 113, NULL, NULL, 224590),
(224591, '3.90.70.10-FF-000077', NULL, 'Ubiquitin carboxyl-terminal hydrolase 1', 277, NULL, NULL, 224591),
(224592, '3.30.40.10-FF-001870', NULL, 'Uncharacterized protein', 78, NULL, NULL, 224592),
(224593, '3.30.420.80-FF-000026', NULL, '30S ribosomal protein S11', 108, NULL, NULL, 224593),
(224594, '1.10.150.240-FF-000041', NULL, 'Haloacid dehalogenase-like hydrolase domain-containing protein', 72, NULL, NULL, 224594),
(224595, '1.10.510.10-FF-004223', NULL, NULL, 207, NULL, NULL, 224595),
(224596, '2.60.40.10-FF-004833', NULL, NULL, 80, NULL, NULL, 224596),
(224597, '3.90.1180.10-FF-000022', NULL, NULL, 146, NULL, NULL, 224597),
(224598, '1.10.1670.10-FF-000080', NULL, NULL, 51, NULL, NULL, 224598),
(224599, '3.40.50.720-FF-001834', NULL, 'CD38 molecule', 114, NULL, NULL, 224599),
(224600, '1.25.40.10-FF-004321', NULL, 'Uncharacterized protein', 174, NULL, NULL, 224600),
(224601, '6.10.140.2220-FF-000078', NULL, 'Hypoxia-inducible factor prolyl hydroxylase', 58, NULL, NULL, 224601),
(224602, '2.10.220.10-FF-000195', NULL, 'Proprotein convertase subtilisin/kexin type 5a', 62, NULL, NULL, 224602),
(224603, '3.30.40.10-FF-001718', NULL, 'Uncharacterized protein, isoform A', 56, NULL, NULL, 224603),
(224604, '4.10.640.10-FF-000039', NULL, 'Uncharacterized protein', 42, NULL, NULL, 224604),
(224605, '3.20.20.220-FF-000059', NULL, 'Proline dehydrogenase', 274, NULL, NULL, 224605),
(224606, '3.20.20.100-FF-000141', NULL, 'Uncharacterized oxidoreductase C215.11c', 288, NULL, NULL, 224606),
(224607, '1.10.3210.10-FF-000057', NULL, 'Exopolyphosphatase', 195, NULL, NULL, 224607),
(224608, '2.40.30.10-FF-000404', NULL, 'Uncharacterized protein', 61, NULL, NULL, 224608),
(224609, '1.20.1250.20-FF-001274', NULL, 'Uncharacterized protein', 205, NULL, NULL, 224609),
(224610, '1.10.472.130-FF-000070', NULL, 'Dynein-1-beta heavy chain, flagellar inner arm I1 complex', 171, NULL, NULL, 224610),
(224611, '2.30.30.140-FF-000297', NULL, 'DNA mismatch repair protein', 130, NULL, NULL, 224611),
(224612, '2.30.30.30-FF-000017', NULL, 'Transcription elongation factor SPT5', 71, NULL, NULL, 224612),
(224613, '3.30.420.60-FF-000020', NULL, 'Uncharacterized protein', 104, NULL, NULL, 224613),
(224614, '3.40.190.10-FF-000563', NULL, 'Transcriptional regulator, LysR family', 100, NULL, NULL, 224614),
(224615, '1.10.287.70-FF-000764', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 97, NULL, NULL, 224615),
(224616, '1.10.10.10-FF-001907', NULL, 'Phenazine-specific methyltransferase', 34, NULL, NULL, 224616),
(224617, '1.25.10.10-FF-000828', NULL, 'Importin subunit alpha-2, putative', 422, NULL, NULL, 224617),
(224618, '3.40.50.300-FF-002642', NULL, 'YDR061W-like protein', 253, NULL, NULL, 224618),
(224619, '3.90.940.10-FF-000003', NULL, 'DNA-directed RNA polymerases I, II, and III subunit RPABC2', 126, NULL, NULL, 224619),
(224620, '3.30.200.20-FF-002521', NULL, 'Predicted protein', 97, NULL, NULL, 224620),
(224621, '3.30.1380.20-FF-000009', NULL, 'Trafficking protein particle complex subunit 6A', 159, NULL, NULL, 224621),
(224622, '1.20.1250.20-FF-000998', NULL, 'AGAP010043-PA', 344, NULL, NULL, 224622),
(224623, '2.30.29.80-FF-000001', NULL, 'DUF1508 domain-containing protein', 110, NULL, NULL, 224623);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(224624, '3.90.1420.10-FF-000058', NULL, 'N-lysine methyltransferase', 72, NULL, NULL, 224624),
(224625, '3.30.160.60-FF-000781', NULL, 'zinc finger protein 205 isoform X1', 27, NULL, NULL, 224625),
(224626, '2.60.40.10-FF-000910', NULL, 'T-lymphocyte activation antigen CD80', 96, NULL, NULL, 224626),
(224627, '3.30.70.580-FF-000062', NULL, 'tRNA pseudouridine synthase A', 108, NULL, NULL, 224627),
(224628, '2.60.120.260-FF-000320', NULL, 'Predicted protein', 173, NULL, NULL, 224628),
(224629, '3.80.10.10-FF-001810', NULL, 'YALI0D21208p', 243, NULL, NULL, 224629),
(224630, '1.25.40.390-FF-000001', NULL, 'Starch-binding outer membrane lipoprotein SusD', 198, NULL, NULL, 224630),
(224631, '1.20.1050.10-FF-000154', NULL, 'Glutathione S-transferase U10', 68, NULL, NULL, 224631),
(224632, '3.50.50.60-FF-000507', NULL, 'Lysine-specific histone demethylase 1 homolog 3', 116, NULL, NULL, 224632),
(224633, '1.10.150.130-FF-000007', NULL, 'Tyrosine recombinase XerC', 95, NULL, NULL, 224633),
(224634, '2.120.10.30-FF-000490', NULL, 'Uncharacterized protein', 254, NULL, NULL, 224634),
(224635, '3.30.870.10-FF-000027', NULL, 'Phospholipase D', 230, NULL, NULL, 224635),
(224636, '2.130.10.10-FF-002720', NULL, 'Target of rapamycin complex subunit lst8', 307, NULL, NULL, 224636),
(224637, '1.10.510.10-FF-001789', NULL, 'Predicted protein', 311, NULL, NULL, 224637),
(224638, '2.30.29.90-FF-000004', NULL, 'Exocyst complex component 1 like', 103, NULL, NULL, 224638),
(224639, '3.90.79.10-FF-000158', NULL, 'ADP-ribose pyrophosphatase', 170, NULL, NULL, 224639),
(224640, '3.30.1380.10-FF-000006', NULL, 'D-alanyl-D-alanine dipeptidase', 189, NULL, NULL, 224640),
(224641, '3.30.559.10-FF-000023', NULL, 'Non-ribosomal peptide synthetase', 179, NULL, NULL, 224641),
(224642, '2.60.40.10-FF-004221', NULL, NULL, 72, NULL, NULL, 224642),
(224643, '3.40.50.1980-FF-000019', NULL, 'Histidinol dehydrogenase, chloroplastic', 219, NULL, NULL, 224643),
(224644, '3.30.70.920-FF-000029', NULL, 'ArsR family transcriptional regulator', 96, NULL, NULL, 224644),
(224645, '3.30.70.240-FF-000039', NULL, 'Uncharacterized protein', 134, NULL, NULL, 224645),
(224646, '2.70.170.10-FF-000082', NULL, 'Uncharacterized protein', 192, NULL, NULL, 224646),
(224647, '3.40.1080.10-FF-000009', NULL, 'Succinate CoA transferase', 175, NULL, NULL, 224647),
(224648, '3.40.50.150-FF-001034', NULL, NULL, 165, NULL, NULL, 224648),
(224649, '1.10.230.10-FF-000019', NULL, 'Citrate synthase', 104, NULL, NULL, 224649),
(224650, '2.30.42.10-FF-000207', NULL, 'Serine protease', 91, NULL, NULL, 224650),
(224651, '1.10.630.10-FF-000567', NULL, 'Cytochrome P450 2B4-like', 322, NULL, NULL, 224651),
(224652, '3.40.50.300-FF-008414', NULL, 'Uncharacterized protein', 139, NULL, NULL, 224652),
(224653, '3.40.50.10330-FF-000118', NULL, 'Putative diacylglycerol kinase', 116, NULL, NULL, 224653),
(224654, '1.10.246.20-FF-000014', NULL, 'Mediator of RNA polymerase II transcription subunit 15', 52, NULL, NULL, 224654),
(224655, '2.60.40.10-FF-006019', NULL, NULL, 125, NULL, NULL, 224655),
(224656, '3.80.10.10-FF-001405', NULL, 'Uncharacterized protein', 397, NULL, NULL, 224656),
(224657, '2.180.10.10-FF-000009', NULL, 'RHS element protein', 529, NULL, NULL, 224657),
(224658, '1.25.40.990-FF-000035', NULL, 'Uncharacterized protein', 241, NULL, NULL, 224658),
(224659, '2.40.30.10-FF-000129', NULL, 'U5 small nuclear ribonuclear protein, putative', 139, NULL, NULL, 224659),
(224660, '3.10.20.70-FF-000016', NULL, 'Glutamine synthetase, type I', 107, NULL, NULL, 224660),
(224661, '1.10.510.10-FF-002065', NULL, 'Protein_kinase_-_putative', 253, NULL, NULL, 224661),
(224662, '3.30.830.10-FF-000132', NULL, 'Protease of the insulinase family', 230, NULL, NULL, 224662),
(224663, '1.10.510.10-FF-004274', NULL, NULL, 179, NULL, NULL, 224663),
(224664, '3.30.160.60-FF-003939', NULL, NULL, 31, NULL, NULL, 224664),
(224665, '3.40.50.150-FF-000242', NULL, 'Protein-lysine N-methyltransferase EEF2KMT', 254, NULL, NULL, 224665),
(224666, '3.30.950.30-FF-000006', NULL, 'PHP domain-containing protein', 119, NULL, NULL, 224666);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(224667, '3.40.50.10990-FF-000001', NULL, 'Riboflavin biosynthesis protein RibBA', 171, NULL, NULL, 224667),
(224668, '3.90.180.10-FF-000040', NULL, 'Nuclear receptor binding factor-like protein', 125, NULL, NULL, 224668),
(224669, '3.30.230.70-FF-000109', NULL, 'Uncharacterized protein', 179, NULL, NULL, 224669),
(224670, '2.60.120.260-FF-000141', NULL, 'Beta-galactosidase, putative', 169, NULL, NULL, 224670),
(224671, '1.10.246.10-FF-000011', NULL, 'Vitamin D-binding protein', 61, NULL, NULL, 224671),
(224672, '3.30.160.60-FF-004428', NULL, NULL, 25, NULL, NULL, 224672),
(224673, '3.40.50.10420-FF-000027', NULL, '5-formyltetrahydrofolate cyclo-ligase', 194, NULL, NULL, 224673),
(224674, '3.30.540.10-FF-000031', NULL, 'Inositol-1-monophosphatase', 142, NULL, NULL, 224674),
(224675, '3.40.50.12780-FF-000100', NULL, 'Nonribosomal peptide synthase Pes1', 414, NULL, NULL, 224675),
(224676, '3.80.10.10-FF-002687', NULL, 'LRR receptor-like serine/threonine-protein kinase RCH1', 90, NULL, NULL, 224676),
(224677, '2.60.40.10-FF-004272', NULL, NULL, 132, NULL, NULL, 224677),
(224678, '2.130.10.10-FF-003468', NULL, 'Uncharacterized protein', 58, NULL, NULL, 224678),
(224679, '1.20.58.480-FF-000009', NULL, 'Uncharacterized protein', 274, NULL, NULL, 224679),
(224680, '2.60.40.4310-FF-000001', NULL, 'Structural polyprotein', 55, NULL, NULL, 224680),
(224681, '3.30.200.20-FF-001919', NULL, 'Os10g0112700 protein', 63, NULL, NULL, 224681),
(224682, '3.30.40.10-FF-001544', NULL, 'Putative BOI-related E3 ubiquitin-protein ligase 3 isoform A', 59, NULL, NULL, 224682),
(224683, '3.30.870.10-FF-000078', NULL, 'Uncharacterized protein', 166, NULL, NULL, 224683),
(224684, '2.60.40.10-FF-000393', NULL, 'Putative obscurin-like protein 1', 91, NULL, NULL, 224684),
(224685, '3.30.160.60-FF-006115', NULL, NULL, 43, NULL, NULL, 224685),
(224686, '3.30.160.60-FF-006295', NULL, NULL, 38, NULL, NULL, 224686),
(224687, '3.90.550.50-FF-000125', NULL, 'Predicted protein', 160, NULL, NULL, 224687),
(224688, '3.20.20.370-FF-000025', NULL, 'ChbG/HpnK family deacetylase', 283, NULL, NULL, 224688),
(224689, '3.40.50.300-FF-004087', NULL, 'GM12046', 257, NULL, NULL, 224689),
(224690, '2.60.40.150-FF-000149', NULL, 'Piccolo presynaptic cytomatrix protein', 143, NULL, NULL, 224690),
(224691, '3.10.105.10-FF-000019', NULL, 'Nickel ABC transporter, periplasmic nickel-binding protein', 225, NULL, NULL, 224691),
(224692, '1.20.140.40-FF-000070', NULL, NULL, 89, NULL, NULL, 224692),
(224693, '2.60.40.10-FF-004428', NULL, NULL, 92, NULL, NULL, 224693),
(224694, '3.30.519.10-FF-000026', NULL, NULL, 190, NULL, NULL, 224694),
(224695, '1.10.20.10-FF-000149', NULL, 'CBF/NF-Y transcription factor domain containing protein', 132, NULL, NULL, 224695),
(224696, '1.20.58.60-FF-000857', NULL, 'Si:ch211-207i1.2', 132, NULL, NULL, 224696),
(224697, '1.20.1440.90-FF-000011', NULL, 'Phosphoenolpyruvate carboxylase', 125, NULL, NULL, 224697),
(224698, '1.20.1600.10-FF-000028', NULL, 'Outer membrane efflux protein', 409, NULL, NULL, 224698),
(224699, '1.20.140.80-FF-000003', NULL, 'Transcription factor dp-1', 142, NULL, NULL, 224699),
(224700, '3.10.20.90-FF-000786', NULL, 'Polycomb group RING finger protein 3', 106, NULL, NULL, 224700),
(224701, '2.70.50.80-FF-000009', NULL, 'Uncharacterized protein', 86, NULL, NULL, 224701),
(224702, '1.20.5.190-FF-000035', NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', 47, NULL, NULL, 224702),
(224703, '3.40.50.720-FF-001576', NULL, 'Uncharacterized protein', 238, NULL, NULL, 224703),
(224704, '3.40.50.261-FF-000028', NULL, 'Succinate--CoA ligase [ADP-forming] subunit alpha, mitochondrial', 176, NULL, NULL, 224704),
(224705, '1.20.140.150-FF-000054', NULL, 'Protein CBG14510', 218, NULL, NULL, 224705),
(224706, '2.40.160.10-FF-000060', NULL, 'Uncharacterized protein', 279, NULL, NULL, 224706),
(224707, '1.20.120.1080-FF-000128', NULL, 'Helicase, putative', 100, NULL, NULL, 224707),
(224708, '3.40.50.300-FF-001540', NULL, 'Dynein heavy chain domain 1', 161, NULL, NULL, 224708),
(224709, '3.90.1490.10-FF-000006', NULL, 'ATP binding protein', 87, NULL, NULL, 224709);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(224710, '3.10.50.40-FF-000026', NULL, 'Peptidyl-prolyl cis-trans isomerase', 116, NULL, NULL, 224710),
(224711, '1.20.140.90-FF-000006', NULL, 'malonyl-CoA decarboxylase, mitochondrial', 158, NULL, NULL, 224711),
(224712, '1.20.58.390-FF-000252', NULL, 'Uncharacterized protein', 149, NULL, NULL, 224712),
(224713, '3.90.640.80-FF-000001', NULL, 'Poly [ADP-ribose] polymerase', 124, NULL, NULL, 224713),
(224714, '3.90.260.10-FF-000041', NULL, 'YALI0D08756p', 299, NULL, NULL, 224714),
(224715, '1.10.533.10-FF-000190', NULL, 'Predicted protein', 91, NULL, NULL, 224715),
(224716, '3.40.50.2300-FF-001375', NULL, NULL, 176, NULL, NULL, 224716),
(224717, '1.50.40.10-FF-000385', NULL, 'Solute carrier family 25 member 24,-like', 278, NULL, NULL, 224717),
(224718, '2.60.40.10-FF-002708', NULL, 'Hepatocyte growth factor receptor', 103, NULL, NULL, 224718),
(224719, '2.130.10.10-FF-002900', NULL, 'Protein CBR-RBC-1', 280, NULL, NULL, 224719),
(224720, '2.40.37.10-FF-000021', NULL, 'Ornithine decarboxylase, putative', 146, NULL, NULL, 224720),
(224721, '1.20.1070.10-FF-001139', NULL, 'Chemokine (C-C motif) receptor 1-like 1', 298, NULL, NULL, 224721),
(224722, '3.80.10.10-FF-003608', NULL, 'Uncharacterized protein', 313, NULL, NULL, 224722),
(224723, '2.130.10.10-FF-002462', NULL, 'U3 small nucleolar RNA-associated protein, putative', 177, NULL, NULL, 224723),
(224724, '1.10.1900.10-FF-000025', NULL, 'Chromosome 8, whole genome shotgun sequence', 80, NULL, NULL, 224724),
(224725, '2.40.290.10-FF-000007', NULL, 'RNA-binding protein 15B', 168, NULL, NULL, 224725),
(224726, '2.120.10.30-FF-000517', NULL, 'Uncharacterized protein', 185, NULL, NULL, 224726),
(224727, '3.40.630.10-FF-000047', NULL, 'Glycosylphosphatidylinositol anchor attachment 1 protein', 286, NULL, NULL, 224727),
(224728, '1.10.472.10-FF-000340', NULL, 'RNA polymerase II holoenzyme cyclin-like subunit, putative', 82, NULL, NULL, 224728),
(224729, '3.40.30.10-FF-001234', NULL, 'Protein disulfide-isomerase', 104, NULL, NULL, 224729),
(224730, '3.40.50.1820-FF-001124', NULL, 'Acetylcholinesterase', 253, NULL, NULL, 224730),
(224731, '2.80.10.50-FF-000273', NULL, 'Predicted protein', 97, NULL, NULL, 224731),
(224732, '1.10.10.10-FF-001784', NULL, 'Uncharacterized protein', 73, NULL, NULL, 224732),
(224733, '2.40.160.210-FF-000032', NULL, 'Uncharacterized protein', 128, NULL, NULL, 224733),
(224734, '1.10.510.10-FF-002806', NULL, 'Protein kinase', 299, NULL, NULL, 224734),
(224735, '1.10.150.80-FF-000051', NULL, 'Ribonuclease D, putative', 97, NULL, NULL, 224735),
(224736, '2.70.130.10-FF-000017', NULL, 'Insulin-like growth factor 2 receptor', 143, NULL, NULL, 224736),
(224737, '3.80.10.10-FF-001456', NULL, 'Leucine-rich repeat family protein', 102, NULL, NULL, 224737),
(224738, '1.25.40.10-FF-002455', NULL, 'Intraflagellar transport protein 139', 333, NULL, NULL, 224738),
(224739, '3.40.50.300-FF-002900', NULL, 'Capsular polysaccharide synthesis enzyme CpsD exopolysaccharide synthesis', 270, NULL, NULL, 224739),
(224740, '3.40.525.10-FF-000027', NULL, 'Phosphatidylinositol transfer protein', 284, NULL, NULL, 224740),
(224741, '3.10.310.10-FF-000041', NULL, 'Diaminopimelate epimerase', 134, NULL, NULL, 224741),
(224742, '1.20.120.350-FF-000138', NULL, 'Putative calcium channel protein', 118, NULL, NULL, 224742),
(224743, '3.40.640.10-FF-000250', NULL, 'Aminotransferase, class V', 245, NULL, NULL, 224743),
(224744, '1.25.40.790-FF-000008', NULL, 'CCR4-NOT transcription complex subunit 1,putative', 265, NULL, NULL, 224744),
(224745, '3.30.160.60-FF-002579', NULL, 'Datilografo, isoform B', 73, NULL, NULL, 224745),
(224746, '1.10.1410.10-FF-000038', NULL, 'PAP-associated domain containing protein', 155, NULL, NULL, 224746),
(224747, '3.30.43.10-FF-000005', NULL, 'Quinone-dependent D-lactate dehydrogenase', 102, NULL, NULL, 224747),
(224748, '3.40.50.620-FF-000118', NULL, 'Tryptophan--tRNA ligase, chloroplastic/mitochondrial', 224, NULL, NULL, 224748),
(224749, '1.10.238.10-FF-000812', NULL, 'EF hand family protein', 82, NULL, NULL, 224749),
(224750, '3.90.1480.20-FF-000071', NULL, 'Uncharacterized protein', 193, NULL, NULL, 224750);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(224751, '3.40.50.1100-FF-000048', NULL, '1-aminocyclopropane-1-carboxylate deaminase', 99, NULL, NULL, 224751),
(224752, '1.10.150.240-FF-000102', NULL, 'HAD superfamily hydrolase', 67, NULL, NULL, 224752),
(224753, '1.10.390.10-FF-000059', NULL, 'Aminopeptidase', 252, NULL, NULL, 224753),
(224754, '1.10.10.60-FF-000360', NULL, 'Gastrulation brain homeobox', 95, NULL, NULL, 224754),
(224755, '3.80.10.10-FF-002479', NULL, 'Uncharacterized protein', 206, NULL, NULL, 224755),
(224756, '1.25.40.20-FF-001210', NULL, 'Uncharacterized protein', 184, NULL, NULL, 224756),
(224757, '3.80.10.10-FF-003530', NULL, 'Uncharacterized protein', 167, NULL, NULL, 224757),
(224758, '3.30.60.20-FF-000132', NULL, 'Uncharacterized protein', 57, NULL, NULL, 224758),
(224759, '2.60.40.10-FF-000831', NULL, 'Uncharacterized protein, isoform F', 96, NULL, NULL, 224759),
(224760, '4.10.410.10-FF-000056', NULL, 'Uncharacterized protein', 72, NULL, NULL, 224760),
(224761, '3.30.40.10-FF-000066', NULL, 'E3 ubiquitin-protein ligase UHRF2 isoform X1', 115, NULL, NULL, 224761),
(224762, '3.30.720.10-FF-000011', NULL, 'Signal recognition particle 14 kDa protein', 111, NULL, NULL, 224762),
(224763, '3.90.245.10-FF-000028', NULL, 'Uncharacterized protein', 308, NULL, NULL, 224763),
(224764, '1.25.40.10-FF-002730', NULL, 'MAU2 sister chromatid cohesion factor', 374, NULL, NULL, 224764),
(224765, '2.60.40.10-FF-002922', NULL, 'Protein sidekick homolog', 97, NULL, NULL, 224765),
(224766, '3.40.50.150-FF-000803', NULL, 'RNA methylase, NOL1/NOP2/sun family', 209, NULL, NULL, 224766),
(224767, '4.10.60.10-FF-000190', NULL, 'Uncharacterized protein', 46, NULL, NULL, 224767),
(224768, '3.40.50.150-FF-000860', NULL, 'Multisite-specific tRNA m(5)C methyltransferase', 328, NULL, NULL, 224768),
(224769, '1.25.70.10-FF-000046', NULL, 'Mitochondrial transcription termination factor family protein', 179, NULL, NULL, 224769),
(224770, '1.20.58.390-FF-000134', NULL, 'Ligand-Gated ion Channel', 156, NULL, NULL, 224770),
(224771, '1.20.120.1750-FF-000065', NULL, 'RBR-type E3 ubiquitin transferase', 90, NULL, NULL, 224771),
(224772, '1.20.5.4770-FF-000002', NULL, 'rab5 GDP/GTP exchange factor isoform X1', 48, NULL, NULL, 224772),
(224773, '2.40.30.10-FF-000281', NULL, 'NADPH-dependent diflavin oxidoreductase 1', 55, NULL, NULL, 224773),
(224774, '3.30.70.330-FF-002191', NULL, NULL, 124, NULL, NULL, 224774),
(224775, '1.20.1250.20-FF-001392', NULL, 'Monocarboxylate transporter 5 isoform 1', 190, NULL, NULL, 224775),
(224776, '3.30.160.60-FF-005210', NULL, NULL, 34, NULL, NULL, 224776),
(224777, '1.20.1110.10-FF-000238', NULL, NULL, 241, NULL, NULL, 224777),
(224778, '4.10.60.10-FF-000133', NULL, 'AFR646Wp', 24, NULL, NULL, 224778),
(224779, '2.70.170.10-FF-000290', NULL, 'Uncharacterized protein', 199, NULL, NULL, 224779),
(224780, '2.60.40.1180-FF-000231', NULL, 'Alpha-galactosidase', 49, NULL, NULL, 224780),
(224781, '2.40.10.10-FF-000167', NULL, 'Coagulation factor II (thrombin)', 78, NULL, NULL, 224781),
(224782, '1.25.10.10-FF-000621', NULL, 'Exportin-T', 1077, NULL, NULL, 224782),
(224783, '3.40.1110.10-FF-000389', NULL, NULL, 123, NULL, NULL, 224783),
(224784, '3.40.50.2000-FF-000155', NULL, 'UDP-glucuronosyltransferase', 255, NULL, NULL, 224784),
(224785, '1.10.1450.10-FF-000035', NULL, 'Tetraspanin', 84, NULL, NULL, 224785),
(224786, '2.60.40.150-FF-000357', NULL, 'Protein kinase C theta', 94, NULL, NULL, 224786),
(224787, '3.40.50.300-FF-001332', NULL, 'Similar to ABC transporter', 234, NULL, NULL, 224787),
(224788, '3.20.20.120-FF-000029', NULL, 'Hydrophobic dipeptide epimerase', 233, NULL, NULL, 224788),
(224789, '2.130.10.10-FF-000219', NULL, 'Periodic tryptophan protein 2', 180, NULL, NULL, 224789),
(224790, '2.20.70.10-FF-000161', NULL, 'E3 ubiquitin-protein ligase hecw-1', 58, NULL, NULL, 224790),
(224791, '3.40.50.10260-FF-000018', NULL, 'Multifunctional fusion protein', 208, NULL, NULL, 224791),
(224792, '3.40.630.30-FF-000087', NULL, 'GNAT family N-acetyltransferase', 176, NULL, NULL, 224792),
(224793, '3.40.50.620-FF-000023', NULL, 'Isoleucyl-tRNA synthetase,cytoplasmic', 207, NULL, NULL, 224793);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(224794, '3.40.50.12100-FF-000003', NULL, 'Stimulator of interferon genes protein', 149, NULL, NULL, 224794),
(224795, '2.60.40.60-FF-000149', NULL, 'cadherin-16 isoform X1', 97, NULL, NULL, 224795),
(224796, '3.30.70.270-FF-000020', NULL, 'Transposon Tf2-6 polyprotein-like Protein', 90, NULL, NULL, 224796),
(224797, '3.30.40.10-FF-002207', NULL, 'Uncharacterized protein', 72, NULL, NULL, 224797),
(224798, '1.20.140.100-FF-000034', NULL, 'Dynein heavy chain, cytoplasmic', 150, NULL, NULL, 224798),
(224799, '1.10.287.1130-FF-000004', NULL, 'Cytochrome c oxidase copper chaperone', 67, NULL, NULL, 224799),
(224800, '2.40.70.10-FF-000401', NULL, NULL, 132, NULL, NULL, 224800),
(224801, '3.40.525.10-FF-000033', NULL, 'Retinol-binding protein pinta', 131, NULL, NULL, 224801),
(224802, '1.20.120.1760-FF-000068', NULL, NULL, 197, NULL, NULL, 224802),
(224803, '1.20.120.1750-FF-000115', NULL, 'RBR-type E3 ubiquitin transferase', 150, NULL, NULL, 224803),
(224804, '1.25.40.10-FF-002404', NULL, 'Os01g0197450 protein', 142, NULL, NULL, 224804),
(224805, '3.10.290.10-FF-000095', NULL, 'Pseudouridine synthase', 62, NULL, NULL, 224805),
(224806, '2.40.10.10-FF-000280', NULL, NULL, 116, NULL, NULL, 224806),
(224807, '3.30.930.10-FF-000196', NULL, 'Lysine--tRNA ligase', 354, NULL, NULL, 224807),
(224808, '2.40.30.10-FF-000337', NULL, 'elongation factor Tu, mitochondrial isoform X2', 101, NULL, NULL, 224808),
(224809, '3.30.40.10-FF-001494', NULL, 'Zinc finger family protein', 79, NULL, NULL, 224809),
(224810, '1.10.510.10-FF-000884', NULL, 'Protein CBG08984', 325, NULL, NULL, 224810),
(224811, '3.20.20.140-FF-000187', NULL, 'Ribonuclease P protein subunit p30-like Protein', 217, NULL, NULL, 224811),
(224812, '3.30.60.30-FF-000135', NULL, 'flocculation protein FLO11', 55, NULL, NULL, 224812),
(224813, '1.10.287.1120-FF-000001', NULL, NULL, 117, NULL, NULL, 224813),
(224814, '2.60.40.640-FF-000021', NULL, 'Vacuolar protein sorting-associated protein 26', 152, NULL, NULL, 224814),
(224815, '3.40.630.10-FF-000081', NULL, 'Peptide hydrolase', 334, NULL, NULL, 224815),
(224816, '1.10.150.50-FF-000183', NULL, 'Epidermal growth factor receptor kinase substrate 8', 86, NULL, NULL, 224816),
(224817, '1.20.1060.10-FF-000008', NULL, 'Mitochondrial DNA polymerase I protein A, putative', 117, NULL, NULL, 224817),
(224818, '1.20.1250.20-FF-001448', NULL, 'Solute carrier family 2, facilitated glucose transporter member 12', 51, NULL, NULL, 224818),
(224819, '2.70.230.10-FF-000002', NULL, 'Envelope glycoprotein D', 281, NULL, NULL, 224819),
(224820, '1.10.510.10-FF-002918', NULL, NULL, 204, NULL, NULL, 224820),
(224821, '3.30.1370.10-FF-000152', NULL, 'Vigilin 1', 75, NULL, NULL, 224821),
(224822, '3.20.20.100-FF-000023', NULL, 'aldose reductase', 314, NULL, NULL, 224822),
(224823, '1.20.1000.10-FF-000005', NULL, 'Uncharacterized protein', 79, NULL, NULL, 224823),
(224824, '3.30.2340.10-FF-000009', NULL, 'tRNA pseudouridine synthase D', 131, NULL, NULL, 224824),
(224825, '3.10.20.90-FF-000056', NULL, 'growth factor receptor-bound protein 10 isoform X1', 93, NULL, NULL, 224825),
(224826, '3.30.60.30-FF-000192', NULL, 'Uncharacterized protein', 52, NULL, NULL, 224826),
(224827, '3.30.420.40-FF-000722', NULL, 'Actin family protein', 87, NULL, NULL, 224827),
(224828, '1.25.40.10-FF-002247', NULL, 'Daf-16-Dependent Longevity (WT but not daf-16 lifespan increased)', 150, NULL, NULL, 224828),
(224829, '3.10.450.10-FF-000079', NULL, 'Uncharacterized protein', 112, NULL, NULL, 224829),
(224830, '3.80.20.20-FF-000004', NULL, 'Receptor protein-tyrosine kinase', 194, NULL, NULL, 224830),
(224831, '2.60.40.1910-FF-000045', NULL, NULL, 81, NULL, NULL, 224831),
(224832, '3.40.50.300-FF-008532', NULL, 'Uncharacterized protein (Fragment)', 150, NULL, NULL, 224832),
(224833, '3.40.50.1000-FF-000748', NULL, NULL, 127, NULL, NULL, 224833),
(224834, '1.10.510.10-FF-004156', NULL, NULL, 203, NULL, NULL, 224834),
(224835, '3.40.50.300-FF-006391', NULL, 'Predicted protein', 135, NULL, NULL, 224835),
(224836, '1.10.472.10-FF-000047', NULL, 'Cyclin J like', 128, NULL, NULL, 224836);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(224837, '1.20.58.1880-FF-000034', NULL, 'Uncharacterized protein', 134, NULL, NULL, 224837),
(224838, '1.10.150.390-FF-000006', NULL, 'DNA-directed RNA polymerase subunit', 46, NULL, NULL, 224838),
(224839, '3.40.1410.10-FF-000030', NULL, 'Trehalose operon transcriptional repressor', 162, NULL, NULL, 224839),
(224840, '2.20.28.120-FF-000010', NULL, 'Uncharacterized protein', 72, NULL, NULL, 224840),
(224841, '3.30.160.60-FF-006407', NULL, NULL, 44, NULL, NULL, 224841),
(224842, '1.20.1070.10-FF-000897', NULL, 'Uncharacterized protein', 202, NULL, NULL, 224842),
(224843, '2.130.10.10-FF-004811', NULL, 'WD repeat-containing protein 55 homolog', 142, NULL, NULL, 224843),
(224844, '2.60.40.10-FF-000567', NULL, 'Uncharacterized protein, isoform G', 95, NULL, NULL, 224844),
(224845, '2.130.10.10-FF-005385', NULL, 'Uncharacterized protein', 155, NULL, NULL, 224845),
(224846, '2.60.40.1180-FF-000017', NULL, 'Alpha-galactosidase A', 100, NULL, NULL, 224846),
(224847, '3.30.160.60-FF-006345', NULL, NULL, 24, NULL, NULL, 224847),
(224848, '3.30.830.10-FF-000306', NULL, 'Uncharacterized protein', 117, NULL, NULL, 224848),
(224849, '2.70.98.60-FF-000006', NULL, 'Alpha-galactosidase AgaA', 309, NULL, NULL, 224849),
(224850, '2.170.150.80-FF-000021', NULL, 'Uncharacterized protein', 151, NULL, NULL, 224850),
(224851, '1.10.1170.10-FF-000002', NULL, 'Baculoviral IAP repeat containing 7', 37, NULL, NULL, 224851),
(224852, '2.130.10.10-FF-003709', NULL, 'Uncharacterized protein', 190, NULL, NULL, 224852),
(224853, '1.25.40.10-FF-004490', NULL, 'Uncharacterized protein', 98, NULL, NULL, 224853),
(224854, '2.60.120.260-FF-000253', NULL, 'Beta-glucosidase', 165, NULL, NULL, 224854),
(224855, '3.40.395.10-FF-000033', NULL, 'Uncharacterized protein', 229, NULL, NULL, 224855),
(224856, '1.25.40.20-FF-001002', NULL, 'Predicted protein', 105, NULL, NULL, 224856),
(224857, '3.90.550.50-FF-000131', NULL, 'Hexosyltransferase', 259, NULL, NULL, 224857),
(224858, '3.40.50.12650-FF-000033', NULL, 'Uncharacterized protein', 14, NULL, NULL, 224858),
(224859, '1.10.3410.10-FF-000005', NULL, 'dGTP triphosphohydrolase', 98, NULL, NULL, 224859),
(224860, '3.80.10.10-FF-003255', NULL, 'Uncharacterized protein', 173, NULL, NULL, 224860),
(224861, '3.40.50.1000-FF-000541', NULL, NULL, 70, NULL, NULL, 224861),
(224862, '2.40.50.140-FF-000400', NULL, 'Ribonuclease R', 85, NULL, NULL, 224862),
(224863, '1.25.10.10-FF-002419', NULL, 'MO25-like protein 3', 250, NULL, NULL, 224863),
(224864, '1.25.10.10-FF-002015', NULL, 'Splicing factor 3B subunit 1, putative', 160, NULL, NULL, 224864),
(224865, '2.60.40.1120-FF-000027', NULL, 'CarboxyPeptidase D family', 79, NULL, NULL, 224865),
(224866, '3.90.1170.10-FF-000027', NULL, 'Uncharacterized protein', 40, NULL, NULL, 224866),
(224867, '2.60.120.260-FF-000371', NULL, 'Predicted protein', 167, NULL, NULL, 224867),
(224868, '3.20.20.80-FF-000024', NULL, 'Heparanase 2', 328, NULL, NULL, 224868),
(224869, '3.40.50.300-FF-006228', NULL, 'Predicted protein', 258, NULL, NULL, 224869),
(224870, '3.80.10.10-FF-000500', NULL, 'Protein TONSOKU', 375, NULL, NULL, 224870),
(224871, '3.40.50.300-FF-004137', NULL, 'ATPase family associated with various cellular activities (AAA), putative', 178, NULL, NULL, 224871),
(224872, '3.10.28.10-FF-000038', NULL, 'Intron-encoded DNA endonuclease aI5 beta', 109, NULL, NULL, 224872),
(224873, '3.20.20.70-FF-000544', NULL, NULL, 214, NULL, NULL, 224873),
(224874, '1.20.1250.20-FF-001723', NULL, 'Uncharacterized protein', 208, NULL, NULL, 224874),
(224875, '1.10.510.10-FF-002071', NULL, 'Uncharacterized protein', 196, NULL, NULL, 224875),
(224876, '3.40.140.10-FF-000285', NULL, 'Uncharacterized protein', 61, NULL, NULL, 224876),
(224877, '3.30.200.20-FF-001857', NULL, NULL, 106, NULL, NULL, 224877),
(224878, '3.40.140.10-FF-000173', NULL, 'Uncharacterized protein', 178, NULL, NULL, 224878),
(224879, '1.10.520.10-FF-000008', NULL, 'Peroxidase', 154, NULL, NULL, 224879),
(224880, '2.130.10.10-FF-005946', NULL, 'AGAP006158-PA', 252, NULL, NULL, 224880),
(224881, '3.40.50.300-FF-006503', NULL, 'Predicted protein', 114, NULL, NULL, 224881);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(224882, '3.30.300.180-FF-000001', NULL, 'Chromosomal replication initiator protein DnaA', 107, NULL, NULL, 224882),
(224883, '3.40.390.10-FF-000005', NULL, 'Matrix metallopeptidase 16', 266, NULL, NULL, 224883),
(224884, '1.10.287.110-FF-000304', NULL, 'J domain-containing protein DDB_G0295729', 107, NULL, NULL, 224884),
(224885, '1.25.40.10-FF-003883', NULL, 'Uncharacterized protein', 83, NULL, NULL, 224885),
(224886, '1.20.1250.20-FF-001780', NULL, 'Major facilitator superfamily protein', 182, NULL, NULL, 224886),
(224887, '3.80.10.10-FF-001164', NULL, 'GH01279p', 258, NULL, NULL, 224887),
(224888, '3.40.50.2300-FF-000043', NULL, 'Glutamate receptor, ionotropic, kainate 5', 188, NULL, NULL, 224888),
(224889, '3.40.50.11420-FF-000001', NULL, 'Hydrogenase maturation GTPase HydF', 109, NULL, NULL, 224889),
(224890, '3.40.50.720-FF-001626', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase 2, cytosolic', 51, NULL, NULL, 224890),
(224891, '1.10.240.10-FF-000026', NULL, 'Tyrosyl-tRNA synthetase, putative', 48, NULL, NULL, 224891),
(224892, '3.30.200.20-FF-000172', NULL, 'cyclin-dependent kinase G-2 isoform X1', 98, NULL, NULL, 224892),
(224893, '2.60.40.10-FF-002534', NULL, 'Interleukin 1 receptor-like 1 (ST2L)', 92, NULL, NULL, 224893),
(224894, '3.30.530.20-FF-000039', NULL, 'Bet v I allergen-like', 188, NULL, NULL, 224894),
(224895, '1.10.8.270-FF-000022', NULL, 'Ypt/Rab-GAP domain of gyp1p superfamily protein', 131, NULL, NULL, 224895),
(224896, '1.10.418.10-FF-000113', NULL, 'Ras GTPase-activating-like protein IQG1', 153, NULL, NULL, 224896),
(224897, '3.40.50.1240-FF-000062', NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', 322, NULL, NULL, 224897),
(224898, '1.20.1280.50-FF-000037', NULL, 'F-box protein SKIP19', 52, NULL, NULL, 224898),
(224899, '1.10.30.10-FF-000032', NULL, 'FACT complex subunit SSRP1', 77, NULL, NULL, 224899),
(224900, '1.10.1300.10-FF-000002', NULL, 'Phosphodiesterase', 334, NULL, NULL, 224900),
(224901, '3.40.930.10-FF-000025', NULL, 'PTS 2-O-a-mannosyl-D-glycerate transporter subunit IIABC', 159, NULL, NULL, 224901),
(224902, '3.80.10.10-FF-003373', NULL, 'Putative leucine-rich repeat protein', 107, NULL, NULL, 224902),
(224903, '3.40.30.10-FF-001060', NULL, 'Uncharacterized protein', 166, NULL, NULL, 224903),
(224904, '3.40.50.2300-FF-001667', NULL, NULL, 170, NULL, NULL, 224904),
(224905, '1.20.890.10-FF-000033', NULL, 'Set1 complex component sdc1', 51, NULL, NULL, 224905),
(224906, '3.90.1170.50-FF-000011', NULL, 'Xanthine DeHydrogenase homolog', 90, NULL, NULL, 224906),
(224907, '3.40.850.10-FF-000142', NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', 386, NULL, NULL, 224907),
(224908, '3.30.200.20-FF-001796', NULL, 'Tyrosine-protein kinase', 99, NULL, NULL, 224908),
(224909, '2.130.10.10-FF-002512', NULL, 'Sensor histidine kinase TodS', 297, NULL, NULL, 224909),
(224910, '1.10.418.10-FF-000170', NULL, 'Si:ch211-207i1.2', 115, NULL, NULL, 224910),
(224911, '3.40.850.10-FF-000024', NULL, 'Myosin heavy chain, isoform J', 264, NULL, NULL, 224911),
(224912, '2.60.40.1170-FF-000014', NULL, 'AP-5 complex subunit mu-1 isoform X1', 137, NULL, NULL, 224912),
(224913, '1.10.8.430-FF-000008', NULL, 'Uncharacterized protein', 86, NULL, NULL, 224913),
(224914, '3.30.200.20-FF-001739', NULL, 'Homoserine kinase', 99, NULL, NULL, 224914),
(224915, '3.30.70.2520-FF-000004', NULL, 'D-arabinono-1,4-lactone oxidase', 100, NULL, NULL, 224915),
(224916, '2.130.10.10-FF-004603', NULL, 'Putative katanin', 203, NULL, NULL, 224916),
(224917, '2.130.10.10-FF-001034', NULL, 'WD repeat protein', 172, NULL, NULL, 224917),
(224918, '3.30.60.30-FF-000247', NULL, 'Uncharacterized protein', 44, NULL, NULL, 224918),
(224919, '3.30.40.10-FF-001218', NULL, 'Tripartite motif containing 66', 89, NULL, NULL, 224919),
(224920, '2.60.40.10-FF-001927', NULL, 'KETtiN (Drosophila actin-binding) homolog', 90, NULL, NULL, 224920),
(224921, '1.20.272.10-FF-000024', NULL, 'Replication factor C subunit 4, putative', 94, NULL, NULL, 224921),
(224922, '3.30.530.20-FF-000157', NULL, 'Uncharacterized protein', 147, NULL, NULL, 224922);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(224923, '1.10.238.200-FF-000013', NULL, 'Defective in cullin neddylation protein', 107, NULL, NULL, 224923),
(224924, '1.10.10.60-FF-001023', NULL, NULL, 63, NULL, NULL, 224924),
(224925, '3.80.10.10-FF-003316', NULL, 'Uncharacterized protein', 174, NULL, NULL, 224925),
(224926, '3.40.1360.10-FF-000059', NULL, 'DNA topoisomerase VI, A subunit', 224, NULL, NULL, 224926),
(224927, '1.20.5.930-FF-000004', NULL, 'Integrin subunit alpha M', 46, NULL, NULL, 224927),
(224928, '1.20.1740.10-FF-000010', NULL, 'probable cationic amino acid transporter', 396, NULL, NULL, 224928),
(224929, '3.40.47.10-FF-000255', NULL, NULL, 351, NULL, NULL, 224929),
(224930, '3.90.79.10-FF-000063', NULL, 'mRNA cleavage factor-like protein, putative', 198, NULL, NULL, 224930),
(224931, '3.30.2320.60-FF-000001', NULL, 'FHA domain-containing protein FhaA', 132, NULL, NULL, 224931),
(224932, '3.90.70.10-FF-000756', NULL, 'Predicted protein', 101, NULL, NULL, 224932),
(224933, '1.20.1070.10-FF-001791', NULL, 'Predicted protein', 322, NULL, NULL, 224933),
(224934, '3.40.50.300-FF-006380', NULL, 'Stardust protein GUK1 isoform', 136, NULL, NULL, 224934),
(224935, '3.40.50.300-FF-003974', NULL, 'Uncharacterized protein', 103, NULL, NULL, 224935),
(224936, '3.40.470.10-FF-000006', NULL, 'Uracil-DNA glycosylase', 227, NULL, NULL, 224936),
(224937, '2.10.50.10-FF-000093', NULL, 'Nerve growth factor receptor', 29, NULL, NULL, 224937),
(224938, '1.10.490.10-FF-000044', NULL, 'Uncharacterized protein', 122, NULL, NULL, 224938),
(224939, '3.40.50.300-FF-000837', NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 10, mitochondrial', 221, NULL, NULL, 224939),
(224940, '3.40.50.970-FF-000083', NULL, 'Sulfite reductase (NADPH) hemoprotein, beta-component', 328, NULL, NULL, 224940),
(224941, '1.25.10.10-FF-002633', NULL, 'Adaptor-related protein complex 1 subunit beta 1', 124, NULL, NULL, 224941),
(224942, '3.30.200.20-FF-001419', NULL, NULL, 144, NULL, NULL, 224942),
(224943, '1.10.510.10-FF-002750', NULL, NULL, 212, NULL, NULL, 224943),
(224944, '2.60.120.10-FF-000811', NULL, 'Uncharacterized protein', 112, NULL, NULL, 224944),
(224945, '3.40.50.1000-FF-000198', NULL, 'Bifunctional polynucleotide phosphatase/kinase', 186, NULL, NULL, 224945),
(224946, '2.130.10.10-FF-003917', NULL, 'Uncharacterized protein', 262, NULL, NULL, 224946),
(224947, '3.50.50.60-FF-000221', NULL, 'Dihydrolipoyl dehydrogenase, mitochondrial', 222, NULL, NULL, 224947),
(224948, '3.40.980.10-FF-000028', NULL, 'Molybdopterin molybdenumtransferase', 165, NULL, NULL, 224948),
(224949, '3.90.920.10-FF-000002', NULL, 'DNA primase', 393, NULL, NULL, 224949),
(224950, '3.30.470.20-FF-000101', NULL, 'Pyruvate, water dikinase', 129, NULL, NULL, 224950),
(224951, '3.40.50.300-FF-004766', NULL, 'ATP synthase subunit alpha', 213, NULL, NULL, 224951),
(224952, '3.30.1370.10-FF-000163', NULL, 'KH domain-containing, RNA-binding, signal transduction-associated protein 3', 100, NULL, NULL, 224952),
(224953, '3.30.390.10-FF-000002', NULL, 'D-galactonate dehydratase family protein', 132, NULL, NULL, 224953),
(224954, '2.10.70.10-FF-000088', NULL, 'Uncharacterized protein, isoform B', 62, NULL, NULL, 224954),
(224955, '2.20.25.530-FF-000018', NULL, 'Uncharacterized protein', 41, NULL, NULL, 224955),
(224956, '3.40.50.150-FF-000921', NULL, 'Uncharacterized protein', 323, NULL, NULL, 224956),
(224957, '2.20.25.90-FF-000001', NULL, 'Formate dehydrogenase subunit alpha', 56, NULL, NULL, 224957),
(224958, '3.30.390.110-FF-000015', NULL, 'Os07g0271600 protein', 70, NULL, NULL, 224958),
(224959, '3.50.50.60-FF-001317', NULL, 'Uncharacterized protein', 59, NULL, NULL, 224959),
(224960, '3.10.100.10-FF-000115', NULL, 'C-type lectin domain family 4 member K', 136, NULL, NULL, 224960),
(224961, '3.80.10.10-FF-001905', NULL, 'leucine-rich repeats and immunoglobulin-like domains protein 3', 119, NULL, NULL, 224961),
(224962, '3.40.50.300-FF-005042', NULL, 'Predicted protein', 66, NULL, NULL, 224962),
(224963, '3.30.160.60-FF-005221', NULL, NULL, 21, NULL, NULL, 224963),
(224964, '1.20.1250.20-FF-001515', NULL, 'Uncharacterized protein', 355, NULL, NULL, 224964);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(224965, '2.120.10.30-FF-000164', NULL, 'Peptidylglycine alpha-amidating monooxygenase', 130, NULL, NULL, 224965),
(224966, '3.30.50.10-FF-000027', NULL, 'Progesterone receptor', 76, NULL, NULL, 224966),
(224967, '2.60.40.60-FF-000267', NULL, 'Dachsous cadherin-related 2', 121, NULL, NULL, 224967),
(224968, '4.10.60.10-FF-000122', NULL, 'Uncharacterized protein', 32, NULL, NULL, 224968),
(224969, '1.10.110.10-FF-000011', NULL, 'Lipid transfer-like protein VAS', 77, NULL, NULL, 224969),
(224970, '3.10.20.90-FF-000409', NULL, 'YAL046C-like protein', 91, NULL, NULL, 224970),
(224971, '3.40.50.300-FF-002350', NULL, 'ATP-dependent helicase/nuclease subunit A', 149, NULL, NULL, 224971),
(224972, '1.10.10.520-FF-000005', NULL, 'Ubiquitin-activating enzyme E1-like', 199, NULL, NULL, 224972),
(224973, '2.130.10.10-FF-000096', NULL, 'E3 ubiquitin-protein ligase TRAF7 isoform X2', 127, NULL, NULL, 224973),
(224974, '3.30.750.24-FF-000116', NULL, 'Testis anion transporter 1', 92, NULL, NULL, 224974),
(224975, '1.25.10.10-FF-001638', NULL, 'Uncharacterized protein', 448, NULL, NULL, 224975),
(224976, '3.80.10.10-FF-003294', NULL, 'Uncharacterized protein', 71, NULL, NULL, 224976),
(224977, '3.40.50.300-FF-003013', NULL, 'ATPase domain protein, putative', 209, NULL, NULL, 224977),
(224978, '3.30.2310.20-FF-000011', NULL, 'Endoribonuclease HigB', 92, NULL, NULL, 224978),
(224979, '3.40.30.10-FF-000099', NULL, 'thioredoxin domain-containing protein 12', 143, NULL, NULL, 224979),
(224980, '1.25.40.20-FF-000373', NULL, 'Protein CfxQ-like', 55, NULL, NULL, 224980),
(224981, '1.10.10.10-FF-001666', NULL, 'Putative flocculation suppression protein', 57, NULL, NULL, 224981),
(224982, '2.60.120.10-FF-000457', NULL, 'Lysophospholipase NTE1', 138, NULL, NULL, 224982),
(224983, '1.25.40.20-FF-000659', NULL, 'Uncharacterized protein', 204, NULL, NULL, 224983),
(224984, '1.10.510.10-FF-004509', NULL, NULL, 126, NULL, NULL, 224984),
(224985, '3.40.630.10-FF-000491', NULL, 'Probable M18 family aminopeptidase 2', 283, NULL, NULL, 224985),
(224986, '3.80.10.10-FF-004311', NULL, 'Cell surface protein', 212, NULL, NULL, 224986),
(224987, '3.40.30.10-FF-001116', NULL, 'Uncharacterized protein', 13, NULL, NULL, 224987),
(224988, '1.10.10.510-FF-000002', NULL, 'Large T antigen', 100, NULL, NULL, 224988),
(224989, '3.40.50.2300-FF-000032', NULL, 'DNA-binding transcriptional regulator CpxR', 83, NULL, NULL, 224989),
(224990, '1.20.1110.10-FF-000159', NULL, NULL, 189, NULL, NULL, 224990),
(224991, '3.30.565.10-FF-000532', NULL, 'Adenylate cyclase, terminal-differentiation specific', 179, NULL, NULL, 224991),
(224992, '3.40.50.980-FF-000029', NULL, '4-chlorobenzoate--CoA ligase', 143, NULL, NULL, 224992),
(224993, '3.30.70.330-FF-001752', NULL, 'RBD (RNA binding domain) protein', 162, NULL, NULL, 224993),
(224994, '1.25.40.10-FF-000370', NULL, 'E3 ubiquitin-protein ligase TTC3', 181, NULL, NULL, 224994),
(224995, '3.30.1370.100-FF-000029', NULL, 'DNA mismatch repair protein MutL', 94, NULL, NULL, 224995),
(224996, '1.20.58.1590-FF-000003', NULL, 'Tethering factor for nuclear proteasome STS1', 218, NULL, NULL, 224996),
(224997, '4.10.1240.10-FF-000028', NULL, 'FlaMIngo (Cadherin plus 7TM domain) homolog', 54, NULL, NULL, 224997),
(224998, '1.20.120.80-FF-000002', NULL, 'Cytochrome c oxidase subunit 3', 191, NULL, NULL, 224998),
(224999, '2.40.10.10-FF-000049', NULL, 'probable inactive serine protease 37', 109, NULL, NULL, 224999),
(225000, '3.30.1120.10-FF-000055', NULL, 'Arylsulfatase', 67, NULL, NULL, 225000),
(225001, '2.70.70.10-FF-000012', NULL, 'Peptidase, M23/M37 family', 147, NULL, NULL, 225001),
(225002, '2.70.160.11-FF-000003', NULL, 'Protein arginine N-methyltransferase 5', 171, NULL, NULL, 225002),
(225003, '1.10.150.20-FF-000022', NULL, 'translocation protein SEC63 homolog', 61, NULL, NULL, 225003),
(225004, '2.10.25.10-FF-001473', NULL, 'Uncharacterized protein', 58, NULL, NULL, 225004),
(225005, '1.25.40.10-FF-001466', NULL, 'Serine/threonine-protein phosphatase', 125, NULL, NULL, 225005),
(225006, '3.40.50.10860-FF-000024', NULL, 'Shikimate dehydrogenase (NADP(+))', 107, NULL, NULL, 225006);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(225007, '2.60.40.10-FF-002742', NULL, 'Putative Filamin-A', 82, NULL, NULL, 225007),
(225008, '1.25.40.10-FF-000038', NULL, 'Putative pre-mRNA-splicing factor SYF1', 121, NULL, NULL, 225008),
(225009, '3.40.33.10-FF-000038', NULL, 'Predicted protein', 152, NULL, NULL, 225009),
(225010, '3.40.50.2300-FF-001167', NULL, NULL, 162, NULL, NULL, 225010),
(225011, '2.60.40.10-FF-004513', NULL, NULL, 95, NULL, NULL, 225011),
(225012, '3.30.200.20-FF-000722', NULL, 'eIF-2-alpha kinase GCN2', 109, NULL, NULL, 225012),
(225013, '3.40.50.720-FF-000502', NULL, 'Diacylglycerol kinase', 105, NULL, NULL, 225013),
(225014, '3.30.160.60-FF-004316', NULL, NULL, 81, NULL, NULL, 225014),
(225015, '3.30.497.10-FF-000132', NULL, 'Protein CBG06349', 71, NULL, NULL, 225015),
(225016, '1.10.230.10-FF-000020', NULL, 'Citrate synthase', 102, NULL, NULL, 225016),
(225017, '3.80.20.20-FF-000043', NULL, 'GPI-anchored cell wall organization protein Ecm33 (AFU_orthologue AFUA_4G06820)', 147, NULL, NULL, 225017),
(225018, '3.50.50.60-FF-001295', NULL, 'Rab GDP dissociation inhibitor', 99, NULL, NULL, 225018),
(225019, '3.60.21.10-FF-000369', NULL, 'Similar to 2,3-bisphosphoglycerate-independent phosphoglycerate mutase', 123, NULL, NULL, 225019),
(225020, '1.10.555.10-FF-000263', NULL, NULL, 84, NULL, NULL, 225020),
(225021, '2.60.40.60-FF-000380', NULL, 'putative protocadherin beta-18', 110, NULL, NULL, 225021),
(225022, '1.10.238.10-FF-000195', NULL, '45 kDa calcium-binding protein', 68, NULL, NULL, 225022),
(225023, '2.60.40.10-FF-005738', NULL, NULL, 106, NULL, NULL, 225023),
(225024, '1.10.1740.160-FF-000002', NULL, 'Portal protein', 38, NULL, NULL, 225024),
(225025, '3.40.120.10-FF-000076', NULL, 'Phosphoglucomutase/phosphomannomutase alpha/beta/alpha domain I', 84, NULL, NULL, 225025),
(225026, '2.40.50.140-FF-000220', NULL, 'DNA ligase', 158, NULL, NULL, 225026),
(225027, '1.10.1420.10-FF-000207', NULL, 'DNA mismatch repair protein', 41, NULL, NULL, 225027),
(225028, '3.30.530.20-FF-000191', NULL, 'Uncharacterized protein', 59, NULL, NULL, 225028),
(225029, '3.10.250.10-FF-000148', NULL, NULL, 69, NULL, NULL, 225029),
(225030, '3.30.40.10-FF-001426', NULL, 'RING-type E3 ubiquitin transferase', 101, NULL, NULL, 225030),
(225031, '3.40.640.10-FF-000042', NULL, 'Cysteine desulfurase', 260, NULL, NULL, 225031),
(225032, '3.90.226.10-FF-000107', NULL, 'Unplaced genomic scaffold supercont2.5, whole genome shotgun sequence', 238, NULL, NULL, 225032),
(225033, '3.90.70.10-FF-000138', NULL, 'Cruzipain', 212, NULL, NULL, 225033),
(225034, '1.20.1070.10-FF-001173', NULL, 'C3a anaphylatoxin chemotactic receptor', 288, NULL, NULL, 225034),
(225035, '3.30.40.10-FF-001483', NULL, 'Uncharacterized protein', 83, NULL, NULL, 225035),
(225036, '3.40.50.300-FF-000551', NULL, 'Obg-like ATPase 1', 172, NULL, NULL, 225036),
(225037, '2.160.20.10-FF-000123', NULL, 'SPbeta prophage-derived uncharacterized protein YorA', 356, NULL, NULL, 225037),
(225038, '2.60.120.1040-FF-000015', NULL, NULL, 77, NULL, NULL, 225038),
(225039, '1.20.120.1760-FF-000057', NULL, NULL, 204, NULL, NULL, 225039),
(225040, '2.70.150.10-FF-000081', NULL, 'Guanylyl cyclase', 167, NULL, NULL, 225040),
(225041, '3.30.2320.10-FF-000003', NULL, NULL, 96, NULL, NULL, 225041),
(225042, '2.60.40.10-FF-002181', NULL, 'High Incidence of Males (Increased X chromosome loss)', 103, NULL, NULL, 225042),
(225043, '2.60.120.970-FF-000078', NULL, 'Uncharacterized protein', 236, NULL, NULL, 225043),
(225044, '1.10.10.10-FF-000648', NULL, 'Transcriptional regulator, Crp/Fnr family', 81, NULL, NULL, 225044),
(225045, '1.20.120.350-FF-000256', NULL, NULL, 159, NULL, NULL, 225045),
(225046, '3.80.10.10-FF-001517', NULL, 'Transforming growth factor beta activator LRRC33', 97, NULL, NULL, 225046),
(225047, '1.10.20.10-FF-000267', NULL, NULL, 134, NULL, NULL, 225047),
(225048, '3.40.50.1000-FF-000462', NULL, NULL, 120, NULL, NULL, 225048),
(225049, '3.30.830.10-FF-000250', NULL, 'Clan ME, family M16, insulinase-like metallopeptidase', 172, NULL, NULL, 225049),
(225050, '3.40.50.150-FF-000360', NULL, 'DNA (cytosine-5)-methyltransferase DRM2', 131, NULL, NULL, 225050);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(225051, '3.40.50.1820-FF-001624', NULL, 'Uncharacterized protein', 496, NULL, NULL, 225051),
(225052, '3.40.50.300-FF-008302', NULL, 'Uncharacterized protein', 263, NULL, NULL, 225052),
(225053, '2.30.29.30-FF-001346', NULL, 'Predicted protein', 141, NULL, NULL, 225053),
(225054, '1.10.10.1180-FF-000006', NULL, 'Uncharacterized protein', 64, NULL, NULL, 225054),
(225055, '2.40.50.100-FF-000079', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 81, NULL, NULL, 225055),
(225056, '3.30.2010.10-FF-000013', NULL, 'Zn-dependent protease with chaperone function', 94, NULL, NULL, 225056),
(225057, '3.80.10.10-FF-002799', NULL, 'Uncharacterized protein', 93, NULL, NULL, 225057),
(225058, '1.10.10.60-FF-000208', NULL, 'Zinc fingers and homeoboxes protein 3', 63, NULL, NULL, 225058),
(225059, '2.60.120.1030-FF-000012', NULL, 'Acdh-6', 83, NULL, NULL, 225059),
(225060, '1.10.940.10-FF-000023', NULL, 'Transcription antitermination protein NusB', 151, NULL, NULL, 225060),
(225061, '2.40.10.10-FF-000667', NULL, NULL, 56, NULL, NULL, 225061),
(225062, '3.90.228.10-FF-000056', NULL, 'UBA/TS-N domain containing protein', 190, NULL, NULL, 225062),
(225063, '3.40.50.1100-FF-000161', NULL, 'Uncharacterized protein', 43, NULL, NULL, 225063),
(225064, '2.130.10.10-FF-001995', NULL, 'Os03g0355200 protein', 76, NULL, NULL, 225064),
(225065, '2.10.25.10-FF-000579', NULL, 'Notch homolog 4, [Drosophila]', 38, NULL, NULL, 225065),
(225066, '1.25.40.10-FF-004080', NULL, 'Putative Gamma-soluble NSF attachment protein (SNAP-gamma) (N-ethylmaleimide-sensitive factor attachment protein, gamma)', 157, NULL, NULL, 225066),
(225067, '2.60.40.150-FF-000711', NULL, 'Regulator of G-protein signaling rgs-7', 138, NULL, NULL, 225067),
(225068, '3.30.540.10-FF-000093', NULL, 'Uncharacterized protein', 58, NULL, NULL, 225068),
(225069, '3.10.180.10-FF-000041', NULL, '4-hydroxymandelate synthase', 204, NULL, NULL, 225069),
(225070, '1.25.40.10-FF-002522', NULL, 'Chaperone protein dnaK', 157, NULL, NULL, 225070),
(225071, '3.40.50.10810-FF-000116', NULL, 'SNF2 family helicase, putative', 279, NULL, NULL, 225071),
(225072, '3.30.70.120-FF-000003', NULL, 'ATP phosphoribosyltransferase', 67, NULL, NULL, 225072),
(225073, '3.10.100.10-FF-000435', NULL, NULL, 65, NULL, NULL, 225073),
(225074, '2.60.40.10-FF-004951', NULL, NULL, 103, NULL, NULL, 225074),
(225075, '2.40.128.130-FF-000010', NULL, 'Adhesin/invasin TibA autotransporter', 311, NULL, NULL, 225075),
(225076, '1.25.10.10-FF-000278', NULL, 'MAP3K epsilon protein kinase 1', 209, NULL, NULL, 225076),
(225077, '2.40.10.10-FF-000128', NULL, 'S46 family peptidase', 87, NULL, NULL, 225077),
(225078, '2.60.120.330-FF-000089', NULL, 'Oxidoreductase', 331, NULL, NULL, 225078),
(225079, '1.20.120.1750-FF-000054', NULL, 'RBR-type E3 ubiquitin transferase', 77, NULL, NULL, 225079),
(225080, '1.10.287.2250-FF-000014', NULL, 'Uncharacterized protein', 91, NULL, NULL, 225080),
(225081, '1.10.510.10-FF-001694', NULL, 'Ribosomal protein S6 kinase delta-1 isoform a', 63, NULL, NULL, 225081),
(225082, '3.40.50.1240-FF-000073', NULL, 'Fructose-6-phosphate2-kinase/fructose-2,6-bisph os phatase-likeprotein', 219, NULL, NULL, 225082),
(225083, '2.130.10.10-FF-006048', NULL, 'F-box/WD repeat-containing protein pof1', 202, NULL, NULL, 225083),
(225084, '3.30.420.40-FF-000104', NULL, 'putative glycerol kinase 5', 244, NULL, NULL, 225084),
(225085, '3.30.60.20-FF-000071', NULL, 'Protein kinase C', 69, NULL, NULL, 225085),
(225086, '1.10.3470.10-FF-000008', NULL, 'Zinc ABC transporter, permease protein', 254, NULL, NULL, 225086),
(225087, '1.10.10.60-FF-000085', NULL, 'SIX homeobox 5', 64, NULL, NULL, 225087),
(225088, '2.130.10.10-FF-000371', NULL, 'dynein intermediate chain 2, axonemal', 161, NULL, NULL, 225088),
(225089, '2.10.90.10-FF-000090', NULL, 'transforming growth factor beta superfamily signaling ligand isoform X1', 116, NULL, NULL, 225089),
(225090, '3.30.200.20-FF-000104', NULL, 'G protein-coupled receptor kinase', 228, NULL, NULL, 225090),
(225091, '1.25.40.10-FF-004821', NULL, 'Enhanced entry protein enhC, tetratricopeptide repeat family', 150, NULL, NULL, 225091);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(225092, '1.10.510.10-FF-002711', NULL, 'Predicted protein', 243, NULL, NULL, 225092),
(225093, '1.10.10.10-FF-000441', NULL, 'AsnC family transcriptional regulator', 54, NULL, NULL, 225093),
(225094, '2.40.50.140-FF-000107', NULL, 'Polyribonucleotide nucleotidyltransferase', 75, NULL, NULL, 225094),
(225095, '3.30.160.60-FF-000275', NULL, 'zinc finger protein 90 homolog', 28, NULL, NULL, 225095),
(225096, '3.30.920.20-FF-000001', NULL, 'Microtubule-actin cross-linking factor 1', 93, NULL, NULL, 225096),
(225097, '3.40.50.300-FF-000276', NULL, 'Ras-related GTP-binding protein A', 182, NULL, NULL, 225097),
(225098, '3.40.190.10-FF-000063', NULL, 'Glutamine ABC transporter, periplasmic protein', 96, NULL, NULL, 225098),
(225099, '1.10.510.10-FF-004431', NULL, NULL, 58, NULL, NULL, 225099),
(225100, '2.70.150.10-FF-000288', NULL, 'Cation-transporting ATPase', 115, NULL, NULL, 225100),
(225101, '3.90.770.10-FF-000006', NULL, 'Uncharacterized protein', 201, NULL, NULL, 225101),
(225102, '3.90.550.10-FF-000254', NULL, 'N-acetylmuramate alpha-1-phosphate uridylyltransferase', 222, NULL, NULL, 225102),
(225103, '2.40.10.10-FF-000460', NULL, NULL, 135, NULL, NULL, 225103),
(225104, '3.40.1360.10-FF-000048', NULL, 'Meiotic recombination protein W68', 215, NULL, NULL, 225104),
(225105, '1.25.40.340-FF-000014', NULL, NULL, 129, NULL, NULL, 225105),
(225106, '2.30.30.40-FF-000526', NULL, 'LysM peptidoglycan-binding domain-containing protein', 67, NULL, NULL, 225106),
(225107, '1.20.1070.10-FF-001914', NULL, 'Uncharacterized protein', 335, NULL, NULL, 225107),
(225108, '1.10.274.30-FF-000003', NULL, 'Male-specific lethal 3 homolog', 156, NULL, NULL, 225108),
(225109, '3.40.50.300-FF-004148', NULL, 'Si:dkey-61p9.9', 157, NULL, NULL, 225109),
(225110, '1.10.472.10-FF-000401', NULL, 'Cyclin domain-containing protein', 109, NULL, NULL, 225110),
(225111, '3.30.200.20-FF-002313', NULL, 'Uncharacterized protein', 22, NULL, NULL, 225111),
(225112, '2.60.120.920-FF-000092', NULL, 'Ran-binding protein M homolog', 178, NULL, NULL, 225112),
(225113, '2.40.10.10-FF-000403', NULL, NULL, 107, NULL, NULL, 225113),
(225114, '1.10.287.600-FF-000013', NULL, 'Tubulin beta chain', 55, NULL, NULL, 225114),
(225115, '1.20.1250.20-FF-000200', NULL, 'Major facilitator superfamily domain-containing protein 4A', 190, NULL, NULL, 225115),
(225116, '2.60.40.820-FF-000018', NULL, 'Putative T-box protein 35', 190, NULL, NULL, 225116),
(225117, '3.30.160.60-FF-000893', NULL, 'Zinc finger protein 641', 33, NULL, NULL, 225117),
(225118, '3.30.559.10-FF-000231', NULL, 'Uncharacterized protein', 170, NULL, NULL, 225118),
(225119, '1.25.10.10-FF-001970', NULL, 'YALI0E33774p', 194, NULL, NULL, 225119),
(225120, '1.10.8.270-FF-000090', NULL, 'TBC domain containing protein', 104, NULL, NULL, 225120),
(225121, '2.70.170.10-FF-000177', NULL, 'Protein CBR-DEG-3', 99, NULL, NULL, 225121),
(225122, '3.20.130.10-FF-000002', NULL, 'L(+)-tartrate dehydratase subunit beta', 176, NULL, NULL, 225122),
(225123, '2.10.70.10-FF-000268', NULL, 'Predicted protein', 66, NULL, NULL, 225123),
(225124, '3.30.420.40-FF-000368', NULL, 'Phosphotransferase', 138, NULL, NULL, 225124),
(225125, '1.10.8.270-FF-000033', NULL, 'GTPase-activating protein, putative', 99, NULL, NULL, 225125),
(225126, '1.10.287.1490-FF-000157', NULL, 'Coiled-coil domain-containing 88C', 158, NULL, NULL, 225126),
(225127, '2.60.40.10-FF-004333', NULL, NULL, 69, NULL, NULL, 225127),
(225128, '1.10.418.10-FF-000181', NULL, 'Girdin homolog', 175, NULL, NULL, 225128),
(225129, '3.90.1290.10-FF-000025', NULL, 'Epiplakin 1', 251, NULL, NULL, 225129),
(225130, '1.25.40.10-FF-000218', NULL, 'Peroxisomal targeting signal receptor', 336, NULL, NULL, 225130),
(225131, '3.40.800.20-FF-000024', NULL, 'Histone deacetylase 3', 332, NULL, NULL, 225131),
(225132, '3.30.590.10-FF-000034', NULL, 'Glutamate-ammonia ligase', 178, NULL, NULL, 225132),
(225133, '1.10.238.260-FF-000008', NULL, 'Homocitrate synthase', 104, NULL, NULL, 225133),
(225134, '2.70.98.10-FF-000076', NULL, 'Uncharacterized protein', 305, NULL, NULL, 225134);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(225135, '3.40.50.300-FF-001001', NULL, 'Multidrug ABC transporter ATP-binding protein', 246, NULL, NULL, 225135),
(225136, '3.90.79.10-FF-000001', NULL, 'RNA pyrophosphohydrolase', 159, NULL, NULL, 225136),
(225137, '3.40.47.10-FF-000137', NULL, 'Protein CBG03789', 400, NULL, NULL, 225137),
(225138, '3.40.50.1010-FF-000139', NULL, NULL, 35, NULL, NULL, 225138),
(225139, '3.40.50.1000-FF-000136', NULL, 'Trehalose-6-phosphate phosphatase, putative', 125, NULL, NULL, 225139),
(225140, '2.30.42.10-FF-000415', NULL, NULL, 116, NULL, NULL, 225140),
(225141, '2.130.10.10-FF-000034', NULL, 'Pre-mRNA-processing factor 17, putative', 317, NULL, NULL, 225141),
(225142, '3.40.800.10-FF-000021', NULL, 'Arginase', 295, NULL, NULL, 225142),
(225143, '3.40.50.300-FF-000433', NULL, 'Estrogen sulfotransferase', 294, NULL, NULL, 225143),
(225144, '2.60.40.10-FF-001579', NULL, 'Titin a', 113, NULL, NULL, 225144),
(225145, '3.30.1640.10-FF-000083', NULL, 'DNA replication licensing factor MCM7', 86, NULL, NULL, 225145),
(225146, '1.20.1640.10-FF-000031', NULL, 'PaTChed family', 203, NULL, NULL, 225146),
(225147, '2.130.10.10-FF-002170', NULL, 'AGAP008095-PA', 247, NULL, NULL, 225147),
(225148, '1.20.58.60-FF-000222', NULL, 'Uncharacterized protein, isoform D', 302, NULL, NULL, 225148),
(225149, '3.30.160.60-FF-003304', NULL, 'Uncharacterized protein', 24, NULL, NULL, 225149),
(225150, '3.80.10.10-FF-003816', NULL, 'Receptor-like protein 18', 80, NULL, NULL, 225150),
(225151, '3.90.226.10-FF-000102', NULL, 'Crotonase/enoyl-CoA hydratase family protein', 231, NULL, NULL, 225151),
(225152, '3.40.350.10-FF-000008', NULL, 'xaa-Pro aminopeptidase 2', 161, NULL, NULL, 225152),
(225153, '3.30.230.70-FF-000143', NULL, 'Predicted protein', 118, NULL, NULL, 225153),
(225154, '3.30.40.10-FF-000420', NULL, 'Putative Zinc finger protein', 63, NULL, NULL, 225154),
(225155, '1.20.1070.10-FF-000919', NULL, 'Predicted protein', 301, NULL, NULL, 225155),
(225156, '2.60.40.10-FF-002147', NULL, 'Down syndrome cell adhesion molecule like 1', 106, NULL, NULL, 225156),
(225157, '3.40.1050.10-FF-000013', NULL, 'Probable transmembrane carbonic anhydrase', 234, NULL, NULL, 225157),
(225158, '2.40.70.10-FF-000047', NULL, 'Cathepsin D preproprotein', 242, NULL, NULL, 225158),
(225159, '3.90.226.10-FF-000046', NULL, 'Geranyl-CoA carboxylase beta subunit', 264, NULL, NULL, 225159),
(225160, '3.30.505.10-FF-000017', NULL, 'Phosphatidylinositol 3-kinase regulatory subunit gamma b', 110, NULL, NULL, 225160),
(225161, '1.10.640.10-FF-000101', NULL, 'Uncharacterized protein', 158, NULL, NULL, 225161),
(225162, '3.40.50.10810-FF-000262', NULL, 'Meiotic recombination protein rdh54', 262, NULL, NULL, 225162),
(225163, '3.90.550.50-FF-000070', NULL, 'Beta-1,3-glucosyltransferase-like Protein', 193, NULL, NULL, 225163),
(225164, '1.10.238.10-FF-001133', NULL, 'Dual oxidase 2', 157, NULL, NULL, 225164),
(225165, '3.40.50.1820-FF-000899', NULL, 'Carboxylic ester hydrolase', 291, NULL, NULL, 225165),
(225166, '3.40.50.300-FF-004704', NULL, 'Adenylate kinase 9', 105, NULL, NULL, 225166),
(225167, '3.30.200.20-FF-002234', NULL, 'Putative MAP kinase family protein', 35, NULL, NULL, 225167),
(225168, '1.10.8.60-FF-000494', NULL, 'Spastin-like Protein', 114, NULL, NULL, 225168),
(225169, '1.10.460.10-FF-000003', NULL, 'DNA topoisomerase', 162, NULL, NULL, 225169),
(225170, '2.60.40.180-FF-000017', NULL, 'Probable 5-hydroxyisourate hydrolase', 120, NULL, NULL, 225170),
(225171, '2.60.40.1120-FF-000022', NULL, 'Carbohydrate-binding-like fold', 75, NULL, NULL, 225171),
(225172, '3.40.50.300-FF-003125', NULL, 'Cobalt ABC transporter ATP-binding protein', 243, NULL, NULL, 225172),
(225173, '3.40.30.10-FF-001228', NULL, 'Uncharacterized protein', 135, NULL, NULL, 225173),
(225174, '3.30.160.60-FF-002692', NULL, 'Kruppel-like factor 15', 32, NULL, NULL, 225174),
(225175, '3.30.70.1230-FF-000163', NULL, 'Predicted protein', 209, NULL, NULL, 225175),
(225176, '2.130.10.10-FF-000657', NULL, 'U3 small nucleolar RNA associated protein', 145, NULL, NULL, 225176),
(225177, '3.40.50.720-FF-001514', NULL, 'Uncharacterized protein', 170, NULL, NULL, 225177);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(225178, '1.20.1310.10-FF-000107', NULL, 'Cullin-like protein', 126, NULL, NULL, 225178),
(225179, '1.10.8.60-FF-000168', NULL, 'ESX-5 type VII secretion system protein EccA', 110, NULL, NULL, 225179),
(225180, '3.30.300.130-FF-000003', NULL, 'NifU-like protein 3, chloroplastic', 83, NULL, NULL, 225180),
(225181, '3.30.565.10-FF-000414', NULL, 'Two-component sensor kinase', 153, NULL, NULL, 225181),
(225182, '3.30.160.60-FF-006284', NULL, NULL, 47, NULL, NULL, 225182),
(225183, '3.30.70.330-FF-001870', NULL, NULL, 103, NULL, NULL, 225183),
(225184, '2.170.270.10-FF-000200', NULL, 'Uncharacterized protein', 193, NULL, NULL, 225184),
(225185, '1.20.58.860-FF-000022', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 79, NULL, NULL, 225185),
(225186, '2.170.130.10-FF-000021', NULL, 'SusC/RagA family TonB-linked outer membrane protein', 129, NULL, NULL, 225186),
(225187, '2.30.29.30-FF-000008', NULL, 'GRAM domain containing 1B', 110, NULL, NULL, 225187),
(225188, '2.60.40.10-FF-005002', NULL, NULL, 106, NULL, NULL, 225188),
(225189, '2.10.25.10-FF-001355', NULL, 'Uncharacterized protein', 34, NULL, NULL, 225189),
(225190, '3.100.10.10-FF-000014', NULL, 'Ribosomal protein', 39, NULL, NULL, 225190),
(225191, '3.50.50.60-FF-000390', NULL, 'FAD/NAD(P)-binding oxidoreductase family protein', 118, NULL, NULL, 225191),
(225192, '1.10.150.190-FF-000003', NULL, 'Eukaryotic translation initiation factor 2 subunit alpha', 105, NULL, NULL, 225192),
(225193, '2.70.130.10-FF-000079', NULL, NULL, 136, NULL, NULL, 225193),
(225194, '3.40.190.10-FF-000350', NULL, 'LysR family transcriptional regulator', 89, NULL, NULL, 225194),
(225195, '1.50.40.10-FF-000593', NULL, 'Protein CBG24187', 188, NULL, NULL, 225195),
(225196, '3.40.50.1240-FF-000028', NULL, 'Putative 2-carboxy-D-arabinitol-1-phosphatase', 218, NULL, NULL, 225196),
(225197, '1.25.40.20-FF-000777', NULL, 'Ankyrin repeat family protein', 196, NULL, NULL, 225197),
(225198, '3.30.870.10-FF-000016', NULL, 'Cardiolipin synthase B', 191, NULL, NULL, 225198),
(225199, '2.60.40.10-FF-000056', NULL, 'twitchin isoform X4', 101, NULL, NULL, 225199),
(225200, '3.40.50.2300-FF-001381', NULL, NULL, 124, NULL, NULL, 225200),
(225201, '1.25.10.10-FF-002077', NULL, 'Uncharacterized protein', 247, NULL, NULL, 225201),
(225202, '3.90.920.10-FF-000007', NULL, 'Possible ATP dependant DNA ligase', 286, NULL, NULL, 225202),
(225203, '1.10.10.10-FF-000148', NULL, '6-O-methylguanine DNA methyltransferase', 100, NULL, NULL, 225203),
(225204, '3.30.420.40-FF-000430', NULL, 'GD23045', 326, NULL, NULL, 225204),
(225205, '3.40.50.300-FF-004648', NULL, 'Uncharacterized protein', 186, NULL, NULL, 225205),
(225206, '2.60.200.20-FF-000017', NULL, 'Nibrin', 108, NULL, NULL, 225206),
(225207, '2.60.200.10-FF-000014', NULL, 'Interferon regulatory factor 3', 219, NULL, NULL, 225207),
(225208, '3.90.550.10-FF-000198', NULL, '2-C-methyl-D-erythritol 4-phosphate cytidylyltransferase', 226, NULL, NULL, 225208),
(225209, '3.30.160.60-FF-003411', NULL, 'Uncharacterized protein, isoform A', 59, NULL, NULL, 225209),
(225210, '2.30.30.1190-FF-000004', NULL, 'Zinc finger CCCH domain-containing protein 37', 79, NULL, NULL, 225210),
(225211, '3.30.70.330-FF-002426', NULL, NULL, 90, NULL, NULL, 225211),
(225212, '2.10.220.10-FF-000077', NULL, 'High cysteine membrane protein TMK-like', 90, NULL, NULL, 225212),
(225213, '3.40.630.10-FF-000316', NULL, 'Predicted protein', 313, NULL, NULL, 225213),
(225214, '2.130.10.10-FF-004249', NULL, 'Uncharacterized protein', 140, NULL, NULL, 225214),
(225215, '1.10.274.30-FF-000008', NULL, 'MRG (Mortality factor-Related Gene) related', 203, NULL, NULL, 225215),
(225216, '1.25.40.10-FF-004203', NULL, 'Uncharacterized protein', 70, NULL, NULL, 225216),
(225217, '1.10.10.60-FF-000646', NULL, 'Sensor histidine kinase TodS', 112, NULL, NULL, 225217),
(225218, '3.10.20.90-FF-001011', NULL, 'Ubiquitin carboxyl-terminal hydrolase 21', 100, NULL, NULL, 225218),
(225219, '3.10.450.50-FF-000012', NULL, 'Mitogen-activated protein kinase kinase 3', 155, NULL, NULL, 225219),
(225220, '2.20.70.10-FF-000222', NULL, 'E3 ubiquitin-protein ligase', 54, NULL, NULL, 225220);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(225221, '3.50.50.60-FF-000283', NULL, 'Lipoamide dehydrogenase', 136, NULL, NULL, 225221),
(225222, '3.30.200.20-FF-000110', NULL, 'Death-associated kinase 3, isoform CRA_a', 97, NULL, NULL, 225222),
(225223, '3.30.450.20-FF-000499', NULL, 'Methyl-accepting chemotaxis protein', 120, NULL, NULL, 225223),
(225224, '1.20.5.990-FF-000005', NULL, 'TNFAIP3 interacting protein 2', 87, NULL, NULL, 225224),
(225225, '2.60.40.60-FF-000554', NULL, 'cadherin EGF LAG seven-pass G-type receptor 2 isoform X2', 103, NULL, NULL, 225225),
(225226, '3.40.50.1220-FF-000022', NULL, 'Electron transfer flavoprotein, alpha subunit', 132, NULL, NULL, 225226),
(225227, '3.30.200.20-FF-001296', NULL, 'Serine/threonine protein kinase, putative', 64, NULL, NULL, 225227),
(225228, '1.10.8.10-FF-000001', NULL, 'Elongation factor Ts', 56, NULL, NULL, 225228),
(225229, '3.30.70.330-FF-000116', NULL, 'Putative ribonucleoprotein PTB-binding 1', 101, NULL, NULL, 225229),
(225230, '1.20.58.1030-FF-000015', NULL, 'Probable DNA replication complex GINS protein PSF1', 125, NULL, NULL, 225230),
(225231, '3.50.30.50-FF-000003', NULL, 'Metal-dependent hydrolase', 208, NULL, NULL, 225231),
(225232, '2.30.30.90-FF-000013', NULL, 'SirR/DtxR family transcription regulator SirR', 78, NULL, NULL, 225232),
(225233, '2.60.40.10-FF-000909', NULL, 'Interferon alpha/beta receptor 2', 106, NULL, NULL, 225233),
(225234, '3.30.830.10-FF-000082', NULL, 'Axl1p', 257, NULL, NULL, 225234),
(225235, '1.25.40.990-FF-000029', NULL, 'Related to leucine permease transcriptional regulator SAC3', 336, NULL, NULL, 225235),
(225236, '3.40.50.300-FF-002850', NULL, 'Katanin p60 ATPase-containing subunit A-like 2', 117, NULL, NULL, 225236),
(225237, '3.30.160.60-FF-001798', NULL, 'Zinc finger protein 202', 32, NULL, NULL, 225237),
(225238, '1.25.10.10-FF-002133', NULL, 'Serine/threonine-protein kinase TOR', 358, NULL, NULL, 225238),
(225239, '1.10.10.10-FF-000362', NULL, 'DNA-directed RNA polymerase III subunit rpc3', 89, NULL, NULL, 225239),
(225240, '1.10.565.10-FF-000084', NULL, 'Nuclear receptor subfamily 1, group H, member 5', 136, NULL, NULL, 225240),
(225241, '2.130.10.10-FF-002451', NULL, 'Putative Serine/threonine-protein kinase/endoribonuclease IRE1', 355, NULL, NULL, 225241),
(225242, '1.10.3720.10-FF-000107', NULL, 'Nickel ABC transporter, permease protein', 215, NULL, NULL, 225242),
(225243, '1.10.287.110-FF-000169', NULL, 'DnaJ domain protein-like protein', 59, NULL, NULL, 225243),
(225244, '3.30.420.40-FF-000481', NULL, 'Cell division protein FtsA', 165, NULL, NULL, 225244),
(225245, '1.10.510.10-FF-002475', NULL, NULL, 73, NULL, NULL, 225245),
(225246, '3.30.70.330-FF-002207', NULL, NULL, 105, NULL, NULL, 225246),
(225247, '3.30.300.10-FF-000047', NULL, 'S-adenosylmethionine synthase', 144, NULL, NULL, 225247),
(225248, '3.30.565.10-FF-000296', NULL, 'Ethylene receptor', 185, NULL, NULL, 225248),
(225249, '3.40.190.290-FF-000066', NULL, 'LysR family transcriptional regulator', 194, NULL, NULL, 225249),
(225250, '3.30.450.40-FF-000139', NULL, 'Histidine kinase', 170, NULL, NULL, 225250),
(225251, '3.30.70.330-FF-000302', NULL, 'RNA-binding protein BRN1', 98, NULL, NULL, 225251),
(225252, '1.20.1560.10-FF-000030', NULL, 'ABC transporter B family member 15', 639, NULL, NULL, 225252),
(225253, '3.20.20.70-FF-000729', NULL, NULL, 95, NULL, NULL, 225253),
(225254, '3.40.50.720-FF-001840', NULL, 'Dihydrodipicolinate reductase, C-terminus family protein, expressed', 81, NULL, NULL, 225254),
(225255, '1.10.472.10-FF-000227', NULL, 'Cyclin protein', 92, NULL, NULL, 225255),
(225256, '1.20.58.1040-FF-000018', NULL, '1,3-beta-glucanosyltransferase', 116, NULL, NULL, 225256),
(225257, '2.20.70.10-FF-000273', NULL, 'Rho GTPase activating protein 27, like', 65, NULL, NULL, 225257),
(225258, '3.90.1420.10-FF-000064', NULL, 'Uncharacterized protein', 67, NULL, NULL, 225258),
(225259, '1.10.8.20-FF-000004', NULL, 'Retinaldehyde binding protein 1', 101, NULL, NULL, 225259),
(225260, '2.130.10.10-FF-005598', NULL, 'Uncharacterized protein', 193, NULL, NULL, 225260);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(225261, '2.60.40.2030-FF-000019', NULL, 'Adhesion G protein-coupled receptor V1', 122, NULL, NULL, 225261),
(225262, '2.10.25.10-FF-001029', NULL, 'InTestinal NeureXin-like', 44, NULL, NULL, 225262),
(225263, '3.30.200.20-FF-000054', NULL, 'Cyclin-dependent kinase 11B', 96, NULL, NULL, 225263),
(225264, '3.90.550.10-FF-000580', NULL, 'Uncharacterized protein', 255, NULL, NULL, 225264),
(225265, '3.30.160.60-FF-000449', NULL, 'Zinc finger protein MAGPIE', 28, NULL, NULL, 225265),
(225266, '2.130.10.10-FF-005828', NULL, 'Uncharacterized protein', 27, NULL, NULL, 225266),
(225267, '2.40.10.170-FF-000013', NULL, 'Transcriptional regulator, CarD family', 70, NULL, NULL, 225267),
(225268, '3.90.79.10-FF-000220', NULL, 'Mitogen-activated protein kinase', 207, NULL, NULL, 225268),
(225269, '3.50.50.60-FF-000064', NULL, 'Thioredoxin reductase', 127, NULL, NULL, 225269),
(225270, '1.20.5.730-FF-000006', NULL, 'Regulatory protein SIR4', 87, NULL, NULL, 225270),
(225271, '1.10.510.10-FF-000384', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', 207, NULL, NULL, 225271),
(225272, '3.90.1750.10-FF-000055', NULL, 'Uncharacterized protein, isoform A', 63, NULL, NULL, 225272),
(225273, '1.25.40.10-FF-000044', NULL, 'Tetratricopeptide repeat, ankyrin repeat and coiled-coil containing 1', 141, NULL, NULL, 225273),
(225274, '3.40.50.300-FF-006621', NULL, 'Uncharacterized protein', 93, NULL, NULL, 225274),
(225275, '2.120.10.30-FF-000107', NULL, 'Uncharacterized protein', 259, NULL, NULL, 225275),
(225276, '3.30.160.360-FF-000016', NULL, 'Uncharacterized protein', 156, NULL, NULL, 225276),
(225277, '1.25.40.10-FF-000662', NULL, 'prolyl 4-hydroxylase subunit alpha-2', 129, NULL, NULL, 225277),
(225278, '3.40.50.150-FF-000129', NULL, 'Mitochondrial rRNA methyltransferase 2', 192, NULL, NULL, 225278),
(225279, '3.90.550.10-FF-000428', NULL, 'Sll1528 protein', 259, NULL, NULL, 225279),
(225280, '3.30.1380.20-FF-000043', NULL, 'Trafficking protein particle complex subunit', 170, NULL, NULL, 225280),
(225281, '2.60.40.10-FF-000382', NULL, 'fibronectin isoform X1', 92, NULL, NULL, 225281),
(225282, '3.40.50.300-FF-006891', NULL, 'Uncharacterized protein', 244, NULL, NULL, 225282),
(225283, '3.10.110.10-FF-000380', NULL, 'RBR-type E3 ubiquitin transferase', 159, NULL, NULL, 225283),
(225284, '1.25.40.20-FF-000665', NULL, 'Uncharacterized protein', 271, NULL, NULL, 225284),
(225285, '1.10.238.10-FF-000751', NULL, 'Two pore calcium channel protein 1', 114, NULL, NULL, 225285),
(225286, '3.30.70.330-FF-001718', NULL, NULL, 102, NULL, NULL, 225286),
(225287, '3.60.21.10-FF-000307', NULL, 'Serine/threonine-protein phosphatase', 279, NULL, NULL, 225287),
(225288, '1.25.40.20-FF-000047', NULL, 'Kinase D-interacting substrate of 220 kDa B', 132, NULL, NULL, 225288),
(225289, '2.70.20.10-FF-000032', NULL, 'Uncharacterized protein', 15, NULL, NULL, 225289),
(225290, '1.10.220.160-FF-000027', NULL, NULL, 18, NULL, NULL, 225290),
(225291, '3.80.10.10-FF-003586', NULL, 'Uncharacterized protein', 136, NULL, NULL, 225291),
(225292, '2.30.30.360-FF-000003', NULL, 'Myosin heavy chain 95F', 48, NULL, NULL, 225292),
(225293, '3.40.50.1980-FF-000053', NULL, 'Histidinol dehydrogenase', 193, NULL, NULL, 225293),
(225294, '2.10.25.10-FF-001304', NULL, 'Hyaluronan-binding protein 2', 38, NULL, NULL, 225294),
(225295, '1.25.40.10-FF-004315', NULL, 'Uncharacterized protein', 178, NULL, NULL, 225295),
(225296, '3.30.505.10-FF-000192', NULL, NULL, 120, NULL, NULL, 225296),
(225297, '3.40.50.720-FF-001284', NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase 2, chloroplastic', 124, NULL, NULL, 225297),
(225298, '1.25.40.10-FF-002135', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 133, NULL, NULL, 225298),
(225299, '2.60.40.10-FF-002473', NULL, 'Jitterbug, isoform N', 95, NULL, NULL, 225299),
(225300, '2.30.30.380-FF-000009', NULL, 'Calpain 15', 48, NULL, NULL, 225300),
(225301, '2.30.30.40-FF-000352', NULL, 'Putative chemotaxis protein CheV', 56, NULL, NULL, 225301),
(225302, '2.10.70.80-FF-000007', NULL, 'Sortilin', 52, NULL, NULL, 225302);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(225303, '1.10.10.60-FF-000534', NULL, 'Chromosome 1, whole genome shotgun sequence', 75, NULL, NULL, 225303),
(225304, '2.120.10.30-FF-000282', NULL, 'E3 ubiquitin-protein ligase TRIM71', 121, NULL, NULL, 225304),
(225305, '3.40.50.150-FF-001023', NULL, NULL, 183, NULL, NULL, 225305),
(225306, '1.25.40.180-FF-000287', NULL, NULL, 136, NULL, NULL, 225306),
(225307, '2.130.10.10-FF-004468', NULL, 'Uncharacterized protein', 105, NULL, NULL, 225307),
(225308, '3.40.50.720-FF-001565', NULL, 'Sumo-1-activating enzyme E1a, putative', 244, NULL, NULL, 225308),
(225309, '3.30.519.10-FF-000015', NULL, 'Guanosine nucleotide diphosphate dissociation inhibitor', 91, NULL, NULL, 225309),
(225310, '2.60.120.200-FF-000786', NULL, 'Uncharacterized protein', 118, NULL, NULL, 225310),
(225311, '2.60.40.10-FF-004159', NULL, NULL, 89, NULL, NULL, 225311),
(225312, '2.30.30.40-FF-000077', NULL, 'spermatogenesis-associated protein 13 isoform X2', 80, NULL, NULL, 225312),
(225313, '3.40.630.10-FF-000160', NULL, 'Predicted aminopeptidases', 316, NULL, NULL, 225313),
(225314, '2.60.40.150-FF-000418', NULL, 'Uncharacterized protein', 158, NULL, NULL, 225314),
(225315, '2.60.210.10-FF-000054', NULL, NULL, 183, NULL, NULL, 225315),
(225316, '3.30.565.10-FF-000291', NULL, 'PAS domain-containing sensor histidine kinase', 149, NULL, NULL, 225316),
(225317, '1.10.238.10-FF-000700', NULL, 'Ef-hand protein 5, putative', 71, NULL, NULL, 225317),
(225318, '3.40.220.20-FF-000002', NULL, 'Polyprotein ORF1ab', 123, NULL, NULL, 225318),
(225319, '1.10.238.10-FF-000644', NULL, 'Defective in cullin neddylation protein', 89, NULL, NULL, 225319),
(225320, '3.40.50.10470-FF-000019', NULL, 'Ribose 1,5-bisphosphate isomerase', 193, NULL, NULL, 225320),
(225321, '2.60.40.10-FF-004215', NULL, NULL, 74, NULL, NULL, 225321),
(225322, '2.170.11.10-FF-000006', NULL, 'DNA topoisomerase 1', 21, NULL, NULL, 225322),
(225323, '3.40.30.10-FF-000453', NULL, 'Sulfhydryl oxidase', 107, NULL, NULL, 225323),
(225324, '3.10.250.10-FF-000098', NULL, NULL, 107, NULL, NULL, 225324),
(225325, '1.20.1560.10-FF-000766', NULL, 'Uncharacterized protein', 322, NULL, NULL, 225325),
(225326, '3.30.160.60-FF-000724', NULL, 'PR domain zinc finger protein 2', 80, NULL, NULL, 225326),
(225327, '1.10.730.10-FF-000108', NULL, 'Leucyl Amino-acyl tRNA Synthetase', 221, NULL, NULL, 225327),
(225328, '1.20.210.10-FF-000022', NULL, 'Cytochrome c oxidase subunit 1', 523, NULL, NULL, 225328),
(225329, '1.10.10.60-FF-000242', NULL, 'Homeobox-leucine zipper protein HOX13', 50, NULL, NULL, 225329),
(225330, '3.90.190.10-FF-000389', NULL, 'AaceriAFR601Cp', 264, NULL, NULL, 225330),
(225331, '3.30.420.40-FF-000486', NULL, 'Actin, putative', 115, NULL, NULL, 225331),
(225332, '2.30.30.30-FF-000074', NULL, 'Transcription elongation regulator-like protein', 49, NULL, NULL, 225332),
(225333, '3.40.50.1000-FF-000248', NULL, 'HAD family phosphatase', 71, NULL, NULL, 225333),
(225334, '1.20.58.80-FF-000054', NULL, 'Vacuolar protein sorting-associated protein', 43, NULL, NULL, 225334),
(225335, '3.30.230.10-FF-000108', NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', 161, NULL, NULL, 225335),
(225336, '3.30.450.200-FF-000023', NULL, NULL, 181, NULL, NULL, 225336),
(225337, '3.30.830.10-FF-000019', NULL, 'nardilysin isoform X1', 255, NULL, NULL, 225337),
(225338, '3.30.420.40-FF-000542', NULL, 'Heat shock cognate 71 kDa protein', 153, NULL, NULL, 225338),
(225339, '1.10.510.10-FF-004217', NULL, NULL, 211, NULL, NULL, 225339),
(225340, '3.30.160.40-FF-000005', NULL, 'Porphobilinogen deaminase', 90, NULL, NULL, 225340),
(225341, '1.20.1050.10-FF-000160', NULL, 'Glutathione S-transferase', 108, NULL, NULL, 225341),
(225342, '1.20.58.390-FF-000246', NULL, 'Uncharacterized protein', 119, NULL, NULL, 225342),
(225343, '3.30.450.20-FF-000100', NULL, 'Protein TWIN LOV 1', 123, NULL, NULL, 225343),
(225344, '3.50.50.60-FF-000513', NULL, 'Hydrogen cyanide synthase HcnC', 158, NULL, NULL, 225344),
(225345, '3.90.1640.10-FF-000007', NULL, 'Uncharacterized protein', 245, NULL, NULL, 225345);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(225346, '3.30.70.270-FF-000025', NULL, 'Retrovirus-related Pol polyprotein LINE-1', 140, NULL, NULL, 225346),
(225347, '1.25.40.10-FF-001915', NULL, 'Uncharacterized protein', 156, NULL, NULL, 225347),
(225348, '1.25.10.10-FF-001110', NULL, 'RING-type E3 ubiquitin transferase', 155, NULL, NULL, 225348),
(225349, '3.90.550.50-FF-000182', NULL, 'Hexosyltransferase', 230, NULL, NULL, 225349),
(225350, '3.40.50.10810-FF-000150', NULL, 'Helicase, putative', 134, NULL, NULL, 225350),
(225351, '3.30.420.40-FF-000604', NULL, 'Uncharacterized protein', 14, NULL, NULL, 225351),
(225352, '3.80.10.10-FF-001462', NULL, 'Related to Leucine Rich Repeat domain protein', 82, NULL, NULL, 225352),
(225353, '3.40.50.1240-FF-000180', NULL, NULL, 175, NULL, NULL, 225353),
(225354, '4.10.400.10-FF-000095', NULL, 'Low-density lipoprotein receptor-related protein', 41, NULL, NULL, 225354),
(225355, '3.90.1720.10-FF-000008', NULL, 'N-acetylmuramoyl-L-alanine amidase', 165, NULL, NULL, 225355),
(225356, '1.10.1450.10-FF-000097', NULL, 'Tetraspanin', 83, NULL, NULL, 225356),
(225357, '1.10.286.20-FF-000011', NULL, NULL, 24, NULL, NULL, 225357),
(225358, '1.10.150.390-FF-000001', NULL, 'DNA-directed RNA polymerase subunit', 45, NULL, NULL, 225358),
(225359, '2.40.10.10-FF-000162', NULL, 'Protease Do-like 7', 111, NULL, NULL, 225359),
(225360, '1.20.1250.20-FF-001280', NULL, 'Sucrose transporter GRMZM2G106741', 477, NULL, NULL, 225360),
(225361, '1.10.3080.10-FF-000086', NULL, 'Chloride channel protein', 227, NULL, NULL, 225361),
(225362, '1.25.10.10-FF-000093', NULL, 'rap1 GTPase-GDP dissociation stimulator 1 isoform X4', 318, NULL, NULL, 225362),
(225363, '1.20.120.350-FF-000251', NULL, NULL, 228, NULL, NULL, 225363),
(225364, '1.25.40.10-FF-004259', NULL, 'Uncharacterized protein', 225, NULL, NULL, 225364),
(225365, '1.20.58.70-FF-000051', NULL, 'Syntaxin PM family protein', 184, NULL, NULL, 225365),
(225366, '1.50.40.10-FF-000093', NULL, 'mitochondrial uncoupling protein 4-like', 289, NULL, NULL, 225366),
(225367, '3.40.30.10-FF-000739', NULL, 'Thioredoxin-1 protein', 124, NULL, NULL, 225367),
(225368, '1.10.30.10-FF-000094', NULL, 'High mobility group B protein 4', 103, NULL, NULL, 225368),
(225369, '3.40.50.1110-FF-000169', NULL, 'Uncharacterized protein', 157, NULL, NULL, 225369),
(225370, '3.40.50.1100-FF-000166', NULL, 'Diaminopropionate ammonia-lyase, putative', 146, NULL, NULL, 225370),
(225371, '3.40.50.880-FF-000230', NULL, 'Carbamoyl-phosphate synthase small chain', 207, NULL, NULL, 225371),
(225372, '3.90.550.10-FF-000754', NULL, 'Uncharacterized protein', 171, NULL, NULL, 225372),
(225373, '2.130.10.10-FF-004524', NULL, 'Uncharacterized protein', 229, NULL, NULL, 225373),
(225374, '2.10.109.10-FF-000060', NULL, 'Mitochondrial inner membrane protease subunit 1', 111, NULL, NULL, 225374),
(225375, '3.40.50.300-FF-002636', NULL, 'ABC transporter A family member 2', 251, NULL, NULL, 225375),
(225376, '2.60.40.150-FF-000469', NULL, 'Phospholipase A2', 79, NULL, NULL, 225376),
(225377, '3.90.1150.10-FF-000470', NULL, 'Uncharacterized protein', 114, NULL, NULL, 225377),
(225378, '1.20.272.10-FF-000018', NULL, 'Replication factor C subunit 1', 104, NULL, NULL, 225378),
(225379, '3.30.200.20-FF-000166', NULL, 'Mitogen-activated protein kinase', 84, NULL, NULL, 225379),
(225380, '3.40.47.10-FF-000070', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase, mitochondrial', 203, NULL, NULL, 225380),
(225381, '3.40.50.300-FF-006565', NULL, 'Uncharacterized protein', 102, NULL, NULL, 225381),
(225382, '3.30.499.10-FF-000029', NULL, '3-isopropylmalate dehydratase large subunit', 266, NULL, NULL, 225382),
(225383, '3.40.350.10-FF-000003', NULL, 'Xaa-pro aminopeptidase P', 149, NULL, NULL, 225383),
(225384, '2.60.120.650-FF-000162', NULL, 'Uncharacterized protein', 246, NULL, NULL, 225384),
(225385, '2.60.40.1660-FF-000009', NULL, 'Sodium/potassium-transporting ATPase subunit beta', 245, NULL, NULL, 225385),
(225386, '3.90.1150.210-FF-000006', NULL, 'F-actin-capping protein subunit beta', 179, NULL, NULL, 225386),
(225387, '1.10.510.10-FF-000272', NULL, 'Tyrosine-protein kinase', 178, NULL, NULL, 225387);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(225388, '2.60.40.10-FF-002422', NULL, 'Protein sidekick homolog', 103, NULL, NULL, 225388),
(225389, '3.40.50.300-FF-008145', NULL, 'Protein CBG12210', 272, NULL, NULL, 225389),
(225390, '3.30.420.80-FF-000032', NULL, 'Uncharacterized protein', 89, NULL, NULL, 225390),
(225391, '2.30.30.40-FF-000026', NULL, 'Putative tight junction protein ZO-1', 71, NULL, NULL, 225391),
(225392, '2.170.190.11-FF-000026', NULL, 'Molybdenum cofactor biosynthesis protein (MoaA)', 91, NULL, NULL, 225392),
(225393, '3.40.50.300-FF-007869', NULL, 'ABC transporter', 207, NULL, NULL, 225393),
(225394, '3.80.10.10-FF-001170', NULL, 'Predicted protein', 237, NULL, NULL, 225394),
(225395, '3.30.360.10-FF-000051', NULL, 'Oxidoreductase, Gfo/Idh/MocA family', 183, NULL, NULL, 225395),
(225396, '3.40.50.300-FF-008471', NULL, 'ATP-binding cassette transporter, subfamily C, member 15, group MRP protein PpABCC15', 233, NULL, NULL, 225396),
(225397, '3.30.565.10-FF-000240', NULL, 'Sensor histidine kinase', 153, NULL, NULL, 225397),
(225398, '3.90.550.10-FF-000142', NULL, 'Hyaluronan synthase 1', 188, NULL, NULL, 225398),
(225399, '3.30.2160.10-FF-000024', NULL, 'Uncharacterized protein', 80, NULL, NULL, 225399),
(225400, '1.10.238.200-FF-000018', NULL, 'Defective in cullin neddylation protein 1', 105, NULL, NULL, 225400),
(225401, '2.60.40.10-FF-002692', NULL, 'High Incidence of Males (Increased X chromosome loss)', 89, NULL, NULL, 225401),
(225402, '2.40.160.110-FF-000007', NULL, 'CD68 molecule', 166, NULL, NULL, 225402),
(225403, '3.40.50.300-FF-004581', NULL, 'Caspase recruitment domain family member 10', 189, NULL, NULL, 225403),
(225404, '3.40.50.970-FF-000100', NULL, 'Putative phosphonopyruvate decarboxylase', 171, NULL, NULL, 225404),
(225405, '2.80.10.50-FF-000267', NULL, 'Uncharacterized protein', 118, NULL, NULL, 225405),
(225406, '3.60.21.10-FF-000419', NULL, 'Sphingomyelin phosphodiesterase, acid-like 3B', 274, NULL, NULL, 225406),
(225407, '1.20.1070.10-FF-001408', NULL, 'Uncharacterized protein', 234, NULL, NULL, 225407),
(225408, '2.70.130.10-FF-000023', NULL, 'UPF0577 protein KIAA1324 homolog', 207, NULL, NULL, 225408),
(225409, '3.40.50.300-FF-006907', NULL, 'Uncharacterized protein', 238, NULL, NULL, 225409),
(225410, '3.30.40.10-FF-002000', NULL, 'Uncharacterized protein', 53, NULL, NULL, 225410),
(225411, '1.10.287.110-FF-000462', NULL, 'DnaJ homolog 1, mitochondrial', 120, NULL, NULL, 225411),
(225412, '2.130.10.10-FF-000871', NULL, 'Coronin', 142, NULL, NULL, 225412),
(225413, '2.60.40.60-FF-001043', NULL, 'Predicted protein', 96, NULL, NULL, 225413),
(225414, '3.20.180.20-FF-000042', NULL, 'Uncharacterized protein', 89, NULL, NULL, 225414),
(225415, '3.90.260.10-FF-000035', NULL, 'Protein-glutamine gamma-glutamyltransferase, putative', 138, NULL, NULL, 225415),
(225416, '1.20.58.930-FF-000009', NULL, 'Arginine decarboxylase', 86, NULL, NULL, 225416),
(225417, '1.10.510.10-FF-004487', NULL, NULL, 240, NULL, NULL, 225417),
(225418, '2.40.70.10-FF-000233', NULL, 'Acid protease', 164, NULL, NULL, 225418),
(225419, '2.30.29.30-FF-000222', NULL, 'amyloid beta A4 precursor protein-binding family A member 3', 149, NULL, NULL, 225419),
(225420, '3.40.800.20-FF-000029', NULL, 'Putative histone deacetylase', 348, NULL, NULL, 225420),
(225421, '1.10.510.10-FF-002694', NULL, NULL, 153, NULL, NULL, 225421),
(225422, '3.60.21.10-FF-000077', NULL, 'Sphingomyelin phosphodiesterase', 308, NULL, NULL, 225422),
(225423, '1.10.20.10-FF-000155', NULL, 'H2A histone family member Y', 71, NULL, NULL, 225423),
(225424, '3.30.40.10-FF-001376', NULL, 'Uncharacterized protein', 81, NULL, NULL, 225424),
(225425, '1.20.140.10-FF-000078', NULL, 'Acyl-CoA dehydrogenase', 149, NULL, NULL, 225425),
(225426, '1.10.533.10-FF-000313', NULL, 'Baculoviral IAP repeat containing 7', 37, NULL, NULL, 225426),
(225427, '2.60.220.50-FF-000100', NULL, 'Uncharacterized protein', 53, NULL, NULL, 225427),
(225428, '3.40.50.10190-FF-000149', NULL, 'DNA ligase', 103, NULL, NULL, 225428),
(225429, '1.20.120.1320-FF-000009', NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase', 102, NULL, NULL, 225429);
INSERT INTO "PUBLIC"."MODEL" VALUES
(225430, '3.30.360.10-FF-000118', NULL, 'Probable D-xylose 1-dehydrogenase (NADP(+))', 205, NULL, NULL, 225430),
(225431, '1.10.238.10-FF-000970', NULL, 'Uncharacterized protein', 103, NULL, NULL, 225431),
(225432, '3.40.190.290-FF-000010', NULL, 'LysR family transcriptional regulator', 184, NULL, NULL, 225432),
(225433, '3.10.20.90-FF-000792', NULL, 'F15I1.4 protein', 80, NULL, NULL, 225433),
(225434, '3.40.50.300-FF-000871', NULL, 'Chromatin structure-remodeling complex protein SYD', 223, NULL, NULL, 225434),
(225435, '3.60.21.10-FF-000184', NULL, 'Ser/thr protein phosphatase family protein', 262, NULL, NULL, 225435),
(225436, '3.40.50.720-FF-000210', NULL, 'Gluconate 5-dehydrogenase', 252, NULL, NULL, 225436),
(225437, '2.10.110.10-FF-000030', NULL, 'Four and a half LIM domains protein 2', 61, NULL, NULL, 225437),
(225438, '3.40.1080.10-FF-000015', NULL, 'GD17454', 177, NULL, NULL, 225438),
(225439, '3.90.1150.220-FF-000009', NULL, 'Embryo defective 1379', 106, NULL, NULL, 225439),
(225440, '3.40.50.300-FF-007577', NULL, 'Uncharacterized protein', 178, NULL, NULL, 225440),
(225441, '3.30.160.60-FF-004608', NULL, NULL, 27, NULL, NULL, 225441),
(225442, '3.30.160.60-FF-000831', NULL, 'Zinc finger and BTB domain-containing protein 17', 33, NULL, NULL, 225442),
(225443, '3.30.110.40-FF-000002', NULL, 'Sulfur carrier protein TusA', 81, NULL, NULL, 225443),
(225444, '2.70.130.10-FF-000074', NULL, NULL, 83, NULL, NULL, 225444),
(225445, '3.10.20.90-FF-000909', NULL, 'Ubiquitin family protein', 92, NULL, NULL, 225445),
(225446, '1.10.510.10-FF-003998', NULL, NULL, 113, NULL, NULL, 225446),
(225447, '2.10.25.10-FF-001630', NULL, 'Uncharacterized protein', 79, NULL, NULL, 225447),
(225448, '3.90.740.10-FF-000061', NULL, 'Isoleucine--tRNA ligase, mitochondrial', 159, NULL, NULL, 225448),
(225449, '3.40.30.10-FF-000891', NULL, 'Uncharacterized protein', 60, NULL, NULL, 225449),
(225450, '1.10.510.10-FF-000507', NULL, 'Guanylate cyclase', 254, NULL, NULL, 225450),
(225451, '2.60.40.10-FF-000505', NULL, 'Bent, isoform J', 95, NULL, NULL, 225451),
(225452, '3.40.50.10420-FF-000033', NULL, 'Probable COG0212-type thiamine metabolism protein', 204, NULL, NULL, 225452),
(225453, '1.20.1070.10-FF-001471', NULL, 'Vomeronasal type-1 receptor', 211, NULL, NULL, 225453),
(225454, '3.30.70.330-FF-001937', NULL, NULL, 137, NULL, NULL, 225454),
(225455, '2.60.120.590-FF-000003', NULL, 'alpha-ketoglutarate-dependent dioxygenase alkB homolog 3', 218, NULL, NULL, 225455),
(225456, '1.10.287.1490-FF-000039', NULL, 'DNA repair protein Rad50', 170, NULL, NULL, 225456),
(225457, '3.40.50.1820-FF-001742', NULL, 'Uncharacterized protein', 72, NULL, NULL, 225457),
(225458, '3.40.50.720-FF-000261', NULL, 'NADPH-dependent 1-acyldihydroxyacetone phosphate reductase', 254, NULL, NULL, 225458),
(225459, '1.10.10.60-FF-000860', NULL, 'Homeotic protein caudal', 111, NULL, NULL, 225459),
(225460, '3.30.890.10-FF-000023', NULL, 'Uncharacterized protein', 84, NULL, NULL, 225460),
(225461, '1.25.10.10-FF-000216', NULL, 'Vac14 homolog (S. cerevisiae)', 171, NULL, NULL, 225461),
(225462, '3.30.160.60-FF-006289', NULL, NULL, 44, NULL, NULL, 225462),
(225463, '1.10.3720.10-FF-000219', NULL, 'Glycine betaine/proline ABC transporter, permease protein', 198, NULL, NULL, 225463),
(225464, '2.60.40.790-FF-000138', NULL, NULL, 140, NULL, NULL, 225464),
(225465, '2.60.40.180-FF-000012', NULL, '5-hydroxyisourate hydrolase', 116, NULL, NULL, 225465),
(225466, '1.25.40.10-FF-002461', NULL, 'Kinetoplast_polyadenylation/uridylation_factor_1', 119, NULL, NULL, 225466),
(225467, '3.10.310.10-FF-000035', NULL, 'Uncharacterized protein', 168, NULL, NULL, 225467),
(225468, '1.20.1300.10-FF-000045', NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', 129, NULL, NULL, 225468),
(225469, '3.40.50.2300-FF-000711', NULL, 'Aliphatic amidase expression-regulating protein', 189, NULL, NULL, 225469),
(225470, '1.10.220.10-FF-000058', NULL, 'Annexin', 83, NULL, NULL, 225470),
(225471, '2.40.50.100-FF-000023', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 78, NULL, NULL, 225471);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(225472, '3.90.1490.10-FF-000012', NULL, 'YALI0F14553p', 92, NULL, NULL, 225472),
(225473, '3.30.160.60-FF-003597', NULL, NULL, 26, NULL, NULL, 225473),
(225474, '3.40.50.300-FF-007925', NULL, 'Uncharacterized protein', 175, NULL, NULL, 225474),
(225475, '3.30.200.20-FF-000840', NULL, 'Protein kinase', 87, NULL, NULL, 225475),
(225476, '1.10.560.10-FF-000095', NULL, 'Thermosome, alpha subunit', 233, NULL, NULL, 225476),
(225477, '1.10.10.60-FF-000023', NULL, 'protein REVEILLE 6 isoform X1', 49, NULL, NULL, 225477),
(225478, '2.60.120.200-FF-000050', NULL, 'Adhesion G protein-coupled receptor G6', 197, NULL, NULL, 225478),
(225479, '1.10.418.10-FF-000063', NULL, 'Calmin', 124, NULL, NULL, 225479),
(225480, '3.60.10.10-FF-000395', NULL, 'Predicted protein', 60, NULL, NULL, 225480),
(225481, '1.10.20.10-FF-000211', NULL, NULL, 64, NULL, NULL, 225481),
(225482, '1.10.472.80-FF-000265', NULL, NULL, 144, NULL, NULL, 225482),
(225483, '3.30.9.10-FF-000292', NULL, 'Sarcosine dehydrogenase', 162, NULL, NULL, 225483),
(225484, '1.20.1070.10-FF-001291', NULL, 'Dopamine receptor D4a', 107, NULL, NULL, 225484),
(225485, '2.30.30.30-FF-000023', NULL, '50S ribosomal protein L24', 70, NULL, NULL, 225485),
(225486, '3.30.160.60-FF-004086', NULL, NULL, 79, NULL, NULL, 225486),
(225487, '3.30.160.60-FF-000775', NULL, 'Zinc finger protein 768', 27, NULL, NULL, 225487),
(225488, '3.30.40.10-FF-001724', NULL, 'E3 ubiquitin-protein ligase PEP5', 118, NULL, NULL, 225488),
(225489, '1.50.40.10-FF-000598', NULL, 'Uncharacterized protein', 128, NULL, NULL, 225489),
(225490, '1.10.167.10-FF-000052', NULL, 'G protein-coupled receptor kinase', 74, NULL, NULL, 225490),
(225491, '2.130.10.10-FF-000601', NULL, 'Nucleolar protein 10', 116, NULL, NULL, 225491),
(225492, '3.30.420.10-FF-000668', NULL, NULL, 180, NULL, NULL, 225492),
(225493, '1.10.8.60-FF-000275', NULL, 'Origin of replication complex subunit 1', 15, NULL, NULL, 225493),
(225494, '1.10.287.4270-FF-000002', NULL, 'Serine/threonine-protein kinase 4', 62, NULL, NULL, 225494),
(225495, '1.25.40.20-FF-000339', NULL, 'caskin-2 isoform X2', 85, NULL, NULL, 225495),
(225496, '1.10.238.10-FF-000425', NULL, 'Myosin light chain 2', 85, NULL, NULL, 225496),
(225497, '1.20.140.150-FF-000060', NULL, 'voltage-dependent calcium channel gamma-7 subunit isoform X2', 139, NULL, NULL, 225497),
(225498, '2.10.25.10-FF-000051', NULL, 'Laminin subunit alpha 4', 53, NULL, NULL, 225498),
(225499, '2.60.40.10-FF-003996', NULL, NULL, 100, NULL, NULL, 225499),
(225500, '2.30.30.40-FF-000296', NULL, 'Actin polymerization protein Bzz1', 69, NULL, NULL, 225500),
(225501, '1.10.533.10-FF-000038', NULL, 'Caspase 10', 97, NULL, NULL, 225501),
(225502, '2.60.40.10-FF-002366', NULL, 'Uncharacterized protein, isoform E', 91, NULL, NULL, 225502),
(225503, '1.10.287.4280-FF-000005', NULL, 'Uncharacterized protein', 31, NULL, NULL, 225503),
(225504, '2.60.40.60-FF-000610', NULL, 'Uncharacterized protein', 113, NULL, NULL, 225504),
(225505, '1.25.40.10-FF-000336', NULL, 'Poly-beta-1,6 N-acetyl-D-glucosamine export porin PgaA', 96, NULL, NULL, 225505),
(225506, '3.90.70.10-FF-000425', NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', 326, NULL, NULL, 225506),
(225507, '3.30.200.20-FF-000222', NULL, 'Serine/threonine-protein kinase psk1', 105, NULL, NULL, 225507),
(225508, '1.10.10.60-FF-000641', NULL, 'myb protein', 51, NULL, NULL, 225508),
(225509, '3.30.160.60-FF-003996', NULL, 'Protein CBG16748', 88, NULL, NULL, 225509),
(225510, '2.70.170.10-FF-000295', NULL, 'Uncharacterized protein', 161, NULL, NULL, 225510),
(225511, '3.30.160.60-FF-004760', NULL, NULL, 41, NULL, NULL, 225511),
(225512, '1.20.1310.10-FF-000219', NULL, NULL, 71, NULL, NULL, 225512),
(225513, '1.20.1600.10-FF-000034', NULL, 'Outer membrane efflux protein', 434, NULL, NULL, 225513),
(225514, '3.30.200.20-FF-000492', NULL, 'probable receptor-like protein kinase At1g11050', 122, NULL, NULL, 225514),
(225515, '3.40.630.30-FF-000199', NULL, 'N-acetyltransferase catalytic subunit, putative', 148, NULL, NULL, 225515),
(225516, '1.20.1250.20-FF-001454', NULL, 'Uncharacterized protein', 231, NULL, NULL, 225516); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(225517, '2.10.25.10-FF-001411', NULL, 'Si:ch211-241e1.3', 74, NULL, NULL, 225517),
(225518, '1.10.10.10-FF-001997', NULL, 'Rrf2 family protein', 138, NULL, NULL, 225518),
(225519, '2.160.10.10-FF-000004', NULL, '2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-succinyltransferase', 169, NULL, NULL, 225519),
(225520, '3.30.160.60-FF-000505', NULL, 'zinc finger protein 32 isoform X1', 28, NULL, NULL, 225520),
(225521, '2.60.40.60-FF-000880', NULL, 'Uncharacterized protein', 111, NULL, NULL, 225521),
(225522, '3.40.50.720-FF-002588', NULL, 'Uncharacterized protein', 328, NULL, NULL, 225522),
(225523, '2.130.10.10-FF-000253', NULL, 'DDB1- and CUL4-associated factor 12', 184, NULL, NULL, 225523),
(225524, '3.40.1030.10-FF-000006', NULL, 'AMP phosphorylase', 165, NULL, NULL, 225524),
(225525, '1.10.510.10-FF-000558', NULL, 'cAMP-dependent protein kinase catalytic subunit beta', 129, NULL, NULL, 225525),
(225526, '1.25.10.10-FF-000834', NULL, 'Uncharacterized protein', 418, NULL, NULL, 225526),
(225527, '2.30.29.30-FF-000003', NULL, 'Radixin isoform 1', 96, NULL, NULL, 225527),
(225528, '3.30.70.3490-FF-000031', NULL, 'Oxysterol-binding protein', 152, NULL, NULL, 225528),
(225529, '3.40.50.300-FF-004429', NULL, 'Shikimate kinase I', 170, NULL, NULL, 225529),
(225530, '3.30.70.330-FF-002033', NULL, NULL, 129, NULL, NULL, 225530),
(225531, '3.10.20.90-FF-000168', NULL, 'Regulator of G-protein signaling 12', 75, NULL, NULL, 225531),
(225532, '2.60.40.10-FF-006076', NULL, NULL, 83, NULL, NULL, 225532),
(225533, '3.10.20.10-FF-000021', NULL, '60S ribosomal protein L20', 43, NULL, NULL, 225533),
(225534, '1.25.40.10-FF-005277', NULL, 'Phosphatidylinositol 3-kinase-like protein', 317, NULL, NULL, 225534),
(225535, '1.25.40.10-FF-004607', NULL, 'Uncharacterized protein', 164, NULL, NULL, 225535),
(225536, '2.130.10.10-FF-000652', NULL, 'Related to VPS15-ser/thr protein kinase', 122, NULL, NULL, 225536),
(225537, '3.30.70.330-FF-001196', NULL, 'SUPpressor', 86, NULL, NULL, 225537),
(225538, '1.25.40.20-FF-000491', NULL, 'ankyrin repeat and KH domain-containing protein 1-like isoform X4', 95, NULL, NULL, 225538),
(225539, '3.40.50.1820-FF-001337', NULL, 'Carboxypeptidase', 251, NULL, NULL, 225539),
(225540, '1.10.1410.10-FF-000095', NULL, 'Predicted protein', 52, NULL, NULL, 225540),
(225541, '3.30.565.10-FF-000021', NULL, 'Heat shock protein 75 kDa, mitochondrial', 216, NULL, NULL, 225541),
(225542, '1.20.144.10-FF-000137', NULL, 'Predicted protein', 73, NULL, NULL, 225542),
(225543, '1.25.40.10-FF-001966', NULL, 'Uncharacterized protein', 100, NULL, NULL, 225543),
(225544, '1.20.1250.20-FF-001802', NULL, 'Solute carrier organic anion transporter family member', 170, NULL, NULL, 225544),
(225545, '1.20.120.350-FF-000195', NULL, NULL, 71, NULL, NULL, 225545),
(225546, '3.90.550.10-FF-000193', NULL, 'Glycogenin glucosyltransferase, putative', 283, NULL, NULL, 225546),
(225547, '3.40.50.1820-FF-000848', NULL, 'Dipeptidyl-peptidase 7', 181, NULL, NULL, 225547),
(225548, '3.40.50.300-FF-008420', NULL, 'Uncharacterized protein', 124, NULL, NULL, 225548),
(225549, '1.20.190.50-FF-000014', NULL, 'Nuclear pore complex protein', 106, NULL, NULL, 225549),
(225550, '3.15.20.10-FF-000016', NULL, 'lipopolysaccharide-binding protein-like', 257, NULL, NULL, 225550),
(225551, '3.90.70.10-FF-000638', NULL, 'Ubiquitinyl hydrolase 1', 112, NULL, NULL, 225551),
(225552, '3.40.50.2000-FF-000161', NULL, 'UDP-N-acetylglucosamine transferase subunit alg13', 165, NULL, NULL, 225552),
(225553, '2.130.10.10-FF-000326', NULL, 'Intraflagellar transport protein 122 homolog', 140, NULL, NULL, 225553),
(225554, '1.10.3210.30-FF-000001', NULL, 'CRISPR-associated helicase Cas3', 191, NULL, NULL, 225554),
(225555, '1.25.40.10-FF-001679', NULL, 'Pentatricopeptide repeat-containing protein At5g61800', 162, NULL, NULL, 225555),
(225556, '3.10.290.10-FF-000044', NULL, '30S ribosomal protein S4e', 112, NULL, NULL, 225556),
(225557, '3.40.605.10-FF-000028', NULL, 'NAD-dependent succinate-semialdehyde dehydrogenase', 258, NULL, NULL, 225557),
(225558, '3.30.160.60-FF-004491', NULL, NULL, 87, NULL, NULL, 225558);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(225559, '1.25.10.10-FF-002745', NULL, 'Predicted protein', 759, NULL, NULL, 225559),
(225560, '1.20.58.220-FF-000004', NULL, 'Phosphate-specific transport system accessory protein PhoU', 213, NULL, NULL, 225560),
(225561, '3.40.50.11380-FF-000017', NULL, NULL, 91, NULL, NULL, 225561),
(225562, '3.30.1370.10-FF-000101', NULL, 'Activating signal cointegrator 1 complex subunit 1', 65, NULL, NULL, 225562),
(225563, '1.10.287.600-FF-000007', NULL, 'tubulin epsilon chain', 56, NULL, NULL, 225563),
(225564, '3.40.50.2300-FF-000150', NULL, 'Two component system response regulator', 206, NULL, NULL, 225564),
(225565, '2.60.120.40-FF-000062', NULL, 'Putative uncharacterized protein UNQ5830/PRO19650/PRO19816', 84, NULL, NULL, 225565),
(225566, '3.40.50.300-FF-002849', NULL, 'ATP-dependent DNA helicase', 232, NULL, NULL, 225566),
(225567, '3.40.140.10-FF-000015', NULL, 'Lys-63-specific deubiquitinase BRCC36 isoform 3', 190, NULL, NULL, 225567),
(225568, '3.40.50.2300-FF-001673', NULL, NULL, 124, NULL, NULL, 225568),
(225569, '2.130.10.10-FF-001888', NULL, 'Probable elongator complex protein 2', 107, NULL, NULL, 225569),
(225570, '3.30.200.20-FF-000441', NULL, 'CMGC/SRPK protein kinase', 92, NULL, NULL, 225570),
(225571, '2.170.260.10-FF-000025', NULL, 'Piwi-like protein ergo-1', 158, NULL, NULL, 225571),
(225572, '1.10.510.10-FF-001401', NULL, 'Serine/threonine-protein kinase PLK', 325, NULL, NULL, 225572),
(225573, '1.20.120.790-FF-000028', NULL, 'Uncharacterized protein', 106, NULL, NULL, 225573),
(225574, '3.40.1810.10-FF-000072', NULL, NULL, 78, NULL, NULL, 225574),
(225575, '3.40.50.11370-FF-000014', NULL, 'Uncharacterized protein', 89, NULL, NULL, 225575),
(225576, '4.10.60.10-FF-000184', NULL, 'SON DNA-binding protein, putative', 70, NULL, NULL, 225576),
(225577, '1.10.10.60-FF-000354', NULL, 'Double homeobox protein 4', 66, NULL, NULL, 225577),
(225578, '1.10.510.10-FF-002924', NULL, 'Probable inactive serine/threonine-protein kinase DDB_G0293184', 292, NULL, NULL, 225578),
(225579, '1.10.533.10-FF-000077', NULL, 'Interferon-induced helicase C domain-containing protein 1', 92, NULL, NULL, 225579),
(225580, '3.30.70.960-FF-000024', NULL, 'Mucin 13, cell surface associated', 104, NULL, NULL, 225580),
(225581, '1.20.120.1750-FF-000059', NULL, 'RBR-type E3 ubiquitin transferase', 55, NULL, NULL, 225581),
(225582, '1.10.1050.20-FF-000002', NULL, 'Telomere length regulator taz1', 39, NULL, NULL, 225582),
(225583, '3.30.160.60-FF-005103', NULL, NULL, 37, NULL, NULL, 225583),
(225584, '3.30.420.40-FF-000716', NULL, 'Uncharacterized protein', 78, NULL, NULL, 225584),
(225585, '1.20.120.620-FF-000011', NULL, 'Two-component hybrid sensor and regulator', 103, NULL, NULL, 225585),
(225586, '3.30.40.10-FF-002213', NULL, 'Chromatin remodeling factor mit1', 69, NULL, NULL, 225586),
(225587, '1.10.10.60-FF-000298', NULL, 'Homeobox protein cut-like', 65, NULL, NULL, 225587),
(225588, '1.10.510.10-FF-004105', NULL, NULL, 127, NULL, NULL, 225588),
(225589, '3.30.420.100-FF-000009', NULL, 'uncharacterized protein LOC106777373 isoform X2', 112, NULL, NULL, 225589),
(225590, '2.60.120.10-FF-000569', NULL, 'Vicilin-like seed storage protein At3g22640', 202, NULL, NULL, 225590),
(225591, '1.20.120.1070-FF-000007', NULL, 'Probable translation initiation factor eIF-2B subunit alpha', 107, NULL, NULL, 225591),
(225592, '1.20.1090.10-FF-000050', NULL, '3-dehydroquinate synthase', 197, NULL, NULL, 225592),
(225593, '3.90.1310.10-FF-000022', NULL, 'Cell division protein ftsI', 122, NULL, NULL, 225593),
(225594, '1.25.10.10-FF-000660', NULL, 'Temperature-sensitive Csg2 suppressor', 195, NULL, NULL, 225594),
(225595, '1.10.510.10-FF-000833', NULL, 'AGC family protein kinase', 192, NULL, NULL, 225595),
(225596, '1.10.290.10-FF-000006', NULL, 'DNA topoisomerase 1', 38, NULL, NULL, 225596),
(225597, '1.10.220.10-FF-000019', NULL, 'Annexin D4', 76, NULL, NULL, 225597),
(225598, '3.30.60.30-FF-000129', NULL, 'Agrin', 44, NULL, NULL, 225598),
(225599, '4.10.800.10-FF-000024', NULL, 'CD74 molecule, major histocompatibility complex, class II invariant chain a', 62, NULL, NULL, 225599);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(225600, '1.20.120.1050-FF-000001', NULL, 'Nucleoporin NUP170', 171, NULL, NULL, 225600),
(225601, '2.60.120.260-FF-000202', NULL, 'Beta-galactosidase', 158, NULL, NULL, 225601),
(225602, '2.160.20.70-FF-000039', NULL, 'Uncharacterized protein', 162, NULL, NULL, 225602),
(225603, '3.20.140.10-FF-000042', NULL, 'Nicotinate phosphoribosyltransferase', 101, NULL, NULL, 225603),
(225604, '1.25.40.20-FF-000485', NULL, 'Ankyrin repeat domain-containing protein, chloroplastic', 94, NULL, NULL, 225604),
(225605, '3.30.60.20-FF-000126', NULL, 'Protein kinase D4', 45, NULL, NULL, 225605),
(225606, '2.40.70.10-FF-000339', NULL, NULL, 163, NULL, NULL, 225606),
(225607, '3.30.160.60-FF-000270', NULL, 'Zinc finger protein 512', 89, NULL, NULL, 225607),
(225608, '2.40.30.10-FF-000343', NULL, 'Elongation factor 1-alpha 1', 51, NULL, NULL, 225608),
(225609, '2.10.25.10-FF-001703', NULL, 'Uncharacterized protein', 41, NULL, NULL, 225609),
(225610, '3.30.160.60-FF-000163', NULL, 'transcriptional repressor protein YY1', 32, NULL, NULL, 225610),
(225611, '3.30.160.60-FF-005738', NULL, NULL, 57, NULL, NULL, 225611),
(225612, '3.50.7.10-FF-000074', NULL, NULL, 30, NULL, NULL, 225612),
(225613, '3.90.79.10-FF-000276', NULL, 'Uncharacterized protein', 82, NULL, NULL, 225613),
(225614, '1.10.287.1130-FF-000010', NULL, 'Cytochrome c oxidase copper chaperone, putative', 64, NULL, NULL, 225614),
(225615, '2.30.42.10-FF-000022', NULL, 'Glutamate receptor interacting protein 1', 98, NULL, NULL, 225615),
(225616, '3.40.50.300-FF-005891', NULL, 'AAA domain containing protein, putative', 248, NULL, NULL, 225616),
(225617, '1.10.10.60-FF-000315', NULL, 'NK1 homeobox 2', 83, NULL, NULL, 225617),
(225618, '3.90.1150.10-FF-000144', NULL, 'Aspartate/methionine/tyrosine aminotransferase', 135, NULL, NULL, 225618),
(225619, '3.40.50.1820-FF-001068', NULL, 'Uncharacterized protein', 90, NULL, NULL, 225619),
(225620, '2.30.30.40-FF-000638', NULL, 'Tyrosine-protein kinase', 82, NULL, NULL, 225620),
(225621, '2.30.110.10-FF-000109', NULL, 'Pyridoxine-5''-phosphate oxidase', 202, NULL, NULL, 225621),
(225622, '3.30.70.330-FF-000740', NULL, 'RNA binding motif protein 19', 103, NULL, NULL, 225622),
(225623, '2.60.40.60-FF-000262', NULL, 'protocadherin-23 isoform X2', 100, NULL, NULL, 225623),
(225624, '3.90.1150.10-FF-000200', NULL, 'Glycine dehydrogenase (decarboxylating)', 55, NULL, NULL, 225624),
(225625, '1.10.8.10-FF-000288', NULL, 'Uncharacterized protein', 76, NULL, NULL, 225625),
(225626, '2.130.10.10-FF-000365', NULL, 'WD repeat domain 66', 299, NULL, NULL, 225626),
(225627, '1.25.40.20-FF-000159', NULL, 'probable ATP-dependent RNA helicase YTHDC2', 109, NULL, NULL, 225627),
(225628, '1.10.1070.20-FF-000003', NULL, 'Serine/threonine-protein kinase CtkA', 201, NULL, NULL, 225628),
(225629, '1.25.10.10-FF-000508', NULL, 'Probable helicase mot1', 222, NULL, NULL, 225629),
(225630, '1.10.238.10-FF-000077', NULL, 'Centrin 1', 82, NULL, NULL, 225630),
(225631, '3.40.50.300-FF-002905', NULL, 'ABC transporter, ATP-binding protein', 238, NULL, NULL, 225631),
(225632, '3.40.50.300-FF-000832', NULL, 'ADP-ribosylation factor 6', 180, NULL, NULL, 225632),
(225633, '3.40.50.150-FF-000753', NULL, 'Uncharacterized protein', 202, NULL, NULL, 225633),
(225634, '1.20.5.1180-FF-000004', NULL, 'geminin', 71, NULL, NULL, 225634),
(225635, '3.40.50.620-FF-000759', NULL, 'Uncharacterized protein', 129, NULL, NULL, 225635),
(225636, '3.20.20.370-FF-000019', NULL, 'ChbG/HpnK family deacetylase', 259, NULL, NULL, 225636),
(225637, '3.30.60.30-FF-000242', NULL, 'Uncharacterized protein', 46, NULL, NULL, 225637),
(225638, '3.30.1360.70-FF-000034', NULL, NULL, 109, NULL, NULL, 225638),
(225639, '3.30.160.60-FF-004434', NULL, NULL, 29, NULL, NULL, 225639),
(225640, '1.25.40.10-FF-000156', NULL, 'Cytochrome c-type biogenesis protein', 142, NULL, NULL, 225640),
(225641, '2.60.260.20-FF-000116', NULL, 'DnaJ heat shock protein family (Hsp40) member B13', 48, NULL, NULL, 225641),
(225642, '3.40.50.300-FF-000725', NULL, 'probable ATP-dependent RNA helicase DHX34', 206, NULL, NULL, 225642); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(225643, '2.60.40.1860-FF-000007', NULL, 'Peptidyl arginine deiminase, type II', 90, NULL, NULL, 225643),
(225644, '1.10.287.140-FF-000004', NULL, 'Glutamate dehydrogenase 1, mitochondrial', 23, NULL, NULL, 225644),
(225645, '3.40.640.10-FF-000216', NULL, 'Aspartate aminotransferase', 289, NULL, NULL, 225645),
(225646, '3.30.460.20-FF-000033', NULL, 'Cobalt/magnesium transport protein CorA', 131, NULL, NULL, 225646),
(225647, '1.20.1250.20-FF-000785', NULL, 'Solute carrier family 29 member 2', 288, NULL, NULL, 225647),
(225648, '1.25.40.20-FF-001160', NULL, 'Serine/threonine protein kinase', 133, NULL, NULL, 225648),
(225649, '2.160.10.10-FF-000055', NULL, 'Probable UDP-3-O-acylglucosamine N-acyltransferase 1, mitochondrial', 206, NULL, NULL, 225649),
(225650, '3.60.15.10-FF-000074', NULL, 'Hydroxyacylglutathione hydrolase', 259, NULL, NULL, 225650),
(225651, '3.30.505.50-FF-000006', NULL, 'Ribosome hibernation promoting factor', 48, NULL, NULL, 225651),
(225652, '3.80.10.10-FF-003204', NULL, 'Uncharacterized protein', 224, NULL, NULL, 225652),
(225653, '1.20.58.670-FF-000010', NULL, 'Exocyst complex component sec15, putative', 133, NULL, NULL, 225653),
(225654, '2.170.150.80-FF-000015', NULL, 'NAC domain-containing protein 8', 143, NULL, NULL, 225654),
(225655, '3.40.140.10-FF-000291', NULL, 'STAM-binding protein', 78, NULL, NULL, 225655),
(225656, '1.20.5.930-FF-000010', NULL, 'AT3g08600/F17O14_7', 45, NULL, NULL, 225656),
(225657, '3.10.20.90-FF-000735', NULL, 'Ras association domain-containing protein 3', 56, NULL, NULL, 225657),
(225658, '1.10.1370.10-FF-000040', NULL, 'Uncharacterized protein', 155, NULL, NULL, 225658),
(225659, '3.90.550.50-FF-000069', NULL, 'Fringe-related protein', 105, NULL, NULL, 225659),
(225660, '3.90.550.10-FF-000703', NULL, 'Uncharacterized protein', 287, NULL, NULL, 225660),
(225661, '1.10.287.130-FF-000001', NULL, 'Two-component sensor histidine kinase', 72, NULL, NULL, 225661),
(225662, '3.40.50.12550-FF-000003', NULL, 'Ubiquitin-activating enzyme E1', 213, NULL, NULL, 225662),
(225663, '3.30.160.60-FF-002068', NULL, 'LD31554p', 30, NULL, NULL, 225663),
(225664, '1.25.40.20-FF-000378', NULL, 'Ankyrin-like protein', 183, NULL, NULL, 225664),
(225665, '3.30.1490.150-FF-000003', NULL, 'Uncharacterized protein, PH0010 family/AmmeMemoRadiSam system protein A, putative', 53, NULL, NULL, 225665),
(225666, '2.120.10.80-FF-000212', NULL, 'Flagellar outer dynein arm heavy chain alpha', 129, NULL, NULL, 225666),
(225667, '1.10.1370.30-FF-000046', NULL, 'Angiotensin-converting enzyme', 346, NULL, NULL, 225667),
(225668, '1.25.10.10-FF-000328', NULL, 'Armadillo repeat containing 10', 162, NULL, NULL, 225668),
(225669, '3.40.50.300-FF-002962', NULL, 'ATP-dependent DEAD box helicase', 73, NULL, NULL, 225669),
(225670, '1.10.8.60-FF-000567', NULL, 'Uncharacterized protein', 78, NULL, NULL, 225670),
(225671, '1.25.40.20-FF-001795', NULL, 'Uncharacterized protein', 170, NULL, NULL, 225671),
(225672, '3.40.190.10-FF-000911', NULL, 'Putative lipoprotein', 97, NULL, NULL, 225672),
(225673, '1.10.1070.11-FF-000119', NULL, 'Uncharacterized protein', 189, NULL, NULL, 225673),
(225674, '2.120.10.80-FF-000156', NULL, 'Kelch domain-containing protein 10 homolog', 138, NULL, NULL, 225674),
(225675, '1.20.80.30-FF-000001', NULL, 'Pyruvate, phosphate dikinase', 85, NULL, NULL, 225675),
(225676, '2.70.170.10-FF-000020', NULL, 'glutamate-gated chloride channel isoform X12', 237, NULL, NULL, 225676),
(225677, '3.10.100.10-FF-000261', NULL, NULL, 143, NULL, NULL, 225677),
(225678, '1.10.100.10-FF-000010', NULL, 'GM24840', 97, NULL, NULL, 225678),
(225679, '3.30.420.610-FF-000005', NULL, 'Tudor domain-containing protein 5', 79, NULL, NULL, 225679),
(225680, '2.60.120.620-FF-000119', NULL, 'Uncharacterized protein', 143, NULL, NULL, 225680),
(225681, '1.20.1070.10-FF-001465', NULL, 'Predicted protein', 214, NULL, NULL, 225681),
(225682, '3.30.200.20-FF-001745', NULL, 'Uncharacterized protein', 23, NULL, NULL, 225682),
(225683, '3.40.50.2300-FF-001616', NULL, NULL, 26, NULL, NULL, 225683);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(225684, '3.30.559.30-FF-000063', NULL, 'Amino acid adenylation', 213, NULL, NULL, 225684),
(225685, '1.20.5.1170-FF-000001', NULL, 'HIT family protein', 27, NULL, NULL, 225685),
(225686, '3.30.710.10-FF-000134', NULL, 'Rho related BTB domain containing 2a', 113, NULL, NULL, 225686),
(225687, '3.30.160.60-FF-002304', NULL, 'Zinc finger protein 195', 28, NULL, NULL, 225687),
(225688, '3.40.50.1000-FF-000754', NULL, NULL, 127, NULL, NULL, 225688),
(225689, '1.10.3470.10-FF-000003', NULL, 'Iron ABC transporter permease SitD', 251, NULL, NULL, 225689),
(225690, '2.60.40.10-FF-005289', NULL, NULL, 83, NULL, NULL, 225690),
(225691, '3.30.60.30-FF-000186', NULL, 'Carrier of wingless, isoform E', 74, NULL, NULL, 225691),
(225692, '3.30.40.10-FF-001432', NULL, 'Uncharacterized protein', 101, NULL, NULL, 225692),
(225693, '3.30.160.60-FF-004378', NULL, NULL, 25, NULL, NULL, 225693),
(225694, '3.40.50.12650-FF-000027', NULL, 'Beta-lactamase superfamily domain/DNA repair metallo-beta-lactamase, putative', 39, NULL, NULL, 225694),
(225695, '3.40.950.10-FF-000026', NULL, NULL, 169, NULL, NULL, 225695),
(225696, '3.30.200.20-FF-000109', NULL, 'Non-specific serine/threonine protein kinase', 85, NULL, NULL, 225696),
(225697, '2.10.110.10-FF-000029', NULL, 'LIM and senescent cell antigen-like-containing domain protein', 61, NULL, NULL, 225697),
(225698, '3.40.50.1820-FF-001450', NULL, 'Uncharacterized protein', 184, NULL, NULL, 225698),
(225699, '3.30.420.10-FF-000556', NULL, NULL, 60, NULL, NULL, 225699),
(225700, '2.60.120.310-FF-000021', NULL, 'Uncharacterized protein', 133, NULL, NULL, 225700),
(225701, '3.40.50.300-FF-008364', NULL, 'Protein translocase subunit SecA', 225, NULL, NULL, 225701),
(225702, '3.30.160.60-FF-004159', NULL, NULL, 26, NULL, NULL, 225702),
(225703, '1.20.140.100-FF-000028', NULL, 'Uncharacterized protein', 171, NULL, NULL, 225703),
(225704, '1.10.15.30-FF-000002', NULL, '50S ribosomal protein L30', 55, NULL, NULL, 225704),
(225705, '3.30.160.60-FF-002287', NULL, 'Uncharacterized protein', 32, NULL, NULL, 225705),
(225706, '2.60.120.40-FF-000005', NULL, 'Collagen triple helix repeat', 138, NULL, NULL, 225706),
(225707, '6.10.10.140-FF-000001', NULL, NULL, 30, NULL, NULL, 225707),
(225708, '4.10.900.10-FF-000026', NULL, 'Uncharacterized protein', 74, NULL, NULL, 225708),
(225709, '1.10.1450.10-FF-000041', NULL, 'Tetraspanin', 95, NULL, NULL, 225709),
(225710, '3.80.10.10-FF-001282', NULL, 'Protein CBG15026', 139, NULL, NULL, 225710),
(225711, '3.40.50.2300-FF-000037', NULL, 'Putative metabotropic glutamate receptor 5', 274, NULL, NULL, 225711),
(225712, '2.60.40.10-FF-002074', NULL, 'Lymphocyte activating 3', 44, NULL, NULL, 225712),
(225713, '1.10.1170.10-FF-000053', NULL, 'Uncharacterized protein', 78, NULL, NULL, 225713),
(225714, '1.10.10.770-FF-000001', NULL, 'Lysine--tRNA ligase', 107, NULL, NULL, 225714),
(225715, '3.40.140.10-FF-000234', NULL, 'Guanine deaminase', 166, NULL, NULL, 225715),
(225716, '4.10.60.10-FF-000015', NULL, 'RNA-binding protein 4B isoform X1', 43, NULL, NULL, 225716),
(225717, '2.130.10.10-FF-004816', NULL, 'Splicing factor, component of the U4/U6-U5 snRNP complex', 139, NULL, NULL, 225717),
(225718, '2.170.120.12-FF-000023', NULL, 'DNA-directed RNA polymerases II IV and V subunit 3', 36, NULL, NULL, 225718),
(225719, '3.40.50.2000-FF-000104', NULL, 'Glycosyltransferase', 265, NULL, NULL, 225719),
(225720, '1.10.8.270-FF-000140', NULL, 'RabGAP/TBC domain-containing protein', 105, NULL, NULL, 225720),
(225721, '2.40.10.10-FF-000510', NULL, NULL, 74, NULL, NULL, 225721),
(225722, '3.90.226.10-FF-000158', NULL, '4-chlorobenzoyl CoA dehalogenase', 205, NULL, NULL, 225722),
(225723, '1.25.10.10-FF-001003', NULL, 'BRCA1-associated ATM activator 1', 383, NULL, NULL, 225723),
(225724, '3.90.70.10-FF-000751', NULL, 'Predicted protein', 128, NULL, NULL, 225724),
(225725, '3.50.30.30-FF-000138', NULL, 'Uncharacterized protein', 143, NULL, NULL, 225725),
(225726, '3.10.25.10-FF-000009', NULL, 'Methionyl-tRNA formyltransferase', 103, NULL, NULL, 225726),
(225727, '1.25.10.10-FF-000385', NULL, 'serine/threonine-protein kinase 36 isoform X1', 184, NULL, NULL, 225727);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(225728, '1.20.1250.20-FF-001510', NULL, 'Predicted protein', 342, NULL, NULL, 225728),
(225729, '1.10.238.10-FF-000133', NULL, 'Filaggrin', 116, NULL, NULL, 225729),
(225730, '1.10.132.70-FF-000006', NULL, 'Telomerase reverse transcriptase', 223, NULL, NULL, 225730),
(225731, '1.25.40.10-FF-001792', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 85, NULL, NULL, 225731),
(225732, '1.20.58.390-FF-000196', NULL, 'Uncharacterized protein', 129, NULL, NULL, 225732),
(225733, '2.30.29.30-FF-001239', NULL, 'Uncharacterized protein', 113, NULL, NULL, 225733),
(225734, '3.20.20.140-FF-000299', NULL, 'Dihydroorotase, mitochondrial', 55, NULL, NULL, 225734),
(225735, '1.10.420.10-FF-000006', NULL, 'Peroxidase', 138, NULL, NULL, 225735),
(225736, '1.20.1250.20-FF-000150', NULL, 'Solute carrier family 17 member 9', 204, NULL, NULL, 225736),
(225737, '3.40.50.300-FF-004255', NULL, 'ATP-dependent Zn protease', 77, NULL, NULL, 225737),
(225738, '2.30.180.10-FF-000153', NULL, NULL, 140, NULL, NULL, 225738),
(225739, '2.40.50.1020-FF-000019', NULL, 'DNA-binding response regulator', 92, NULL, NULL, 225739),
(225740, '1.10.10.790-FF-000007', NULL, 'Calcium homeostasis endoplasmic reticulum protein', 66, NULL, NULL, 225740),
(225741, '1.20.1070.10-FF-001178', NULL, 'Uncharacterized protein', 284, NULL, NULL, 225741),
(225742, '2.40.50.1000-FF-000013', NULL, '40S ribosomal protein S11-like Protein', 46, NULL, NULL, 225742),
(225743, '3.30.40.10-FF-001488', NULL, 'RING finger protein 24', 81, NULL, NULL, 225743),
(225744, '2.130.10.10-FF-002782', NULL, 'WD repeat and HMG-box DNA-binding protein, putative', 215, NULL, NULL, 225744),
(225745, '1.10.418.10-FF-000231', NULL, 'Uncharacterized protein', 91, NULL, NULL, 225745),
(225746, '3.40.120.10-FF-000014', NULL, 'Phosphomannomutase/phosphoglucomutase isoform B', 123, NULL, NULL, 225746),
(225747, '3.40.50.880-FF-000117', NULL, 'Related to Sno-type pyridoxine vitamin B6 biosynthetic protein SNO1', 176, NULL, NULL, 225747),
(225748, '2.130.10.10-FF-003979', NULL, 'Uncharacterized protein', 235, NULL, NULL, 225748),
(225749, '3.40.50.2020-FF-000167', NULL, 'Ribose phosphate pyrophosphokinase NadR', 127, NULL, NULL, 225749),
(225750, '2.30.29.30-FF-001296', NULL, 'Uncharacterized protein', 84, NULL, NULL, 225750),
(225751, '3.30.565.10-FF-000526', NULL, 'Uncharacterized protein', 144, NULL, NULL, 225751),
(225752, '1.10.132.60-FF-000003', NULL, 'DNA polymerase epsilon catalytic subunit', 125, NULL, NULL, 225752),
(225753, '2.130.10.10-FF-000545', NULL, 'Xyloglucanase Xgh74A', 305, NULL, NULL, 225753),
(225754, '1.10.472.130-FF-000036', NULL, 'Dynein heavy chain 1, cytosolic', 164, NULL, NULL, 225754),
(225755, '3.40.50.150-FF-000534', NULL, 'Protein-lysine N-methyltransferase EFM4', 225, NULL, NULL, 225755),
(225756, '2.60.40.1120-FF-000078', NULL, 'Predicted protein', 77, NULL, NULL, 225756),
(225757, '1.10.390.10-FF-000065', NULL, 'Uncharacterized protein', 91, NULL, NULL, 225757),
(225758, '3.40.50.300-FF-007689', NULL, 'Protein-tyrosine sulfotransferase', 108, NULL, NULL, 225758),
(225759, '3.40.50.880-FF-000174', NULL, 'Imidazole glycerol phosphate synthase subunit HisH', 209, NULL, NULL, 225759),
(225760, '2.30.30.140-FF-000292', NULL, 'Probable ATP-dependent RNA helicase spindle-E', 81, NULL, NULL, 225760),
(225761, '3.30.70.1170-FF-000004', NULL, 'probable 28S rRNA (Cytosine-C(5))-methyltransferase isoform X2', 85, NULL, NULL, 225761),
(225762, '3.30.420.40-FF-000194', NULL, 'Actin-related protein 5', 153, NULL, NULL, 225762),
(225763, '3.40.50.300-FF-000545', NULL, 'arf-GAP with GTPase, ANK repeat and PH domain-containing protein 2', 176, NULL, NULL, 225763),
(225764, '3.40.50.300-FF-006672', NULL, 'Uncharacterized protein', 84, NULL, NULL, 225764),
(225765, '3.10.110.10-FF-000323', NULL, 'Uncharacterized protein', 159, NULL, NULL, 225765),
(225766, '2.60.120.10-FF-000805', NULL, 'Uncharacterized protein', 122, NULL, NULL, 225766),
(225767, '2.60.40.10-FF-000893', NULL, 'Transmembrane glycoprotein NMB', 68, NULL, NULL, 225767),
(225768, '1.20.1060.20-FF-000006', NULL, 'Structural maintenance of chromosomes protein', 98, NULL, NULL, 225768); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(225769, '1.20.1060.10-FF-000003', NULL, 'Helicase and polymerase-containing protein TEBICHI', 113, NULL, NULL, 225769),
(225770, '2.60.120.10-FF-000749', NULL, 'Cyclic GMP-binding protein D', 172, NULL, NULL, 225770),
(225771, '2.40.30.270-FF-000030', NULL, 'DNA replication ATP-dependent helicase/nuclease DNA2-like Protein', 102, NULL, NULL, 225771),
(225772, '3.40.50.300-FF-000489', NULL, 'Primosome assembly protein PriA', 193, NULL, NULL, 225772),
(225773, '2.60.40.1730-FF-000109', NULL, NULL, 122, NULL, NULL, 225773),
(225774, '2.40.100.10-FF-000056', NULL, 'Peptidyl-prolyl cis-trans isomerase', 179, NULL, NULL, 225774),
(225775, '3.40.50.720-FF-001391', NULL, 'D-amino acid oxidase, putative', 149, NULL, NULL, 225775),
(225776, '3.30.1330.30-FF-000099', NULL, 'Uncharacterized protein', 77, NULL, NULL, 225776),
(225777, '1.10.418.10-FF-000118', NULL, 'Calponin homology (CH) domain containing protein, putative', 153, NULL, NULL, 225777),
(225778, '3.10.100.10-FF-000109', NULL, 'Uncharacterized protein', 134, NULL, NULL, 225778),
(225779, '1.20.58.80-FF-000048', NULL, 'Katanin p60 ATPase-containing subunit A1', 77, NULL, NULL, 225779),
(225780, '3.30.519.10-FF-000021', NULL, 'Rab proteins geranylgeranyltransferase', 194, NULL, NULL, 225780),
(225781, '3.10.110.10-FF-000267', NULL, 'Predicted protein', 147, NULL, NULL, 225781),
(225782, '2.30.31.10-FF-000008', NULL, 'AGAP012041-PA', 70, NULL, NULL, 225782),
(225783, '2.40.30.10-FF-000163', NULL, 'Ferric reductase transmembrane component 4, variant', 90, NULL, NULL, 225783),
(225784, '3.80.10.10-FF-003642', NULL, 'Uncharacterized protein', 118, NULL, NULL, 225784),
(225785, '2.40.170.20-FF-000046', NULL, 'Ferric siderophore receptor protein', 452, NULL, NULL, 225785),
(225786, '1.20.58.70-FF-000045', NULL, 'CRE-SYN-13 protein', 117, NULL, NULL, 225786),
(225787, '3.40.50.12780-FF-000105', NULL, 'Putative long-chain-fatty-acid-CoA ligase', 383, NULL, NULL, 225787),
(225788, '1.25.40.20-FF-000721', NULL, 'Uncharacterized protein, isoform D', 82, NULL, NULL, 225788),
(225789, '2.40.50.1060-FF-000003', NULL, 'DNA-directed RNA polymerase I subunit RPA43', 177, NULL, NULL, 225789),
(225790, '3.40.30.10-FF-000447', NULL, 'Protein disulfide-isomerase MPD1', 155, NULL, NULL, 225790),
(225791, '1.10.8.270-FF-000027', NULL, 'Growth hormone regulated TBC protein 1', 105, NULL, NULL, 225791),
(225792, '3.80.20.20-FF-000094', NULL, 'Predicted protein', 79, NULL, NULL, 225792),
(225793, '1.20.120.680-FF-000001', NULL, 'Formimidoyltransferase cyclodeaminase', 213, NULL, NULL, 225793),
(225794, '3.30.420.40-FF-000211', NULL, 'Phosphotransferase', 154, NULL, NULL, 225794),
(225795, '2.130.10.10-FF-002344', NULL, 'Uncharacterized protein', 210, NULL, NULL, 225795),
(225796, '2.20.28.120-FF-000009', NULL, '50S ribosomal protein L33', 52, NULL, NULL, 225796),
(225797, '2.120.10.30-FF-000512', NULL, 'Uncharacterized protein', 197, NULL, NULL, 225797),
(225798, '3.30.160.60-FF-002809', NULL, NULL, 29, NULL, NULL, 225798),
(225799, '3.30.450.190-FF-000025', NULL, 'Uncharacterized protein', 119, NULL, NULL, 225799),
(225800, '1.10.630.10-FF-000781', NULL, 'Uncharacterized protein', 136, NULL, NULL, 225800),
(225801, '2.60.40.10-FF-004165', NULL, NULL, 88, NULL, NULL, 225801),
(225802, '3.40.50.300-FF-004873', NULL, 'Vesicular-fusion protein SEC18, putative', 174, NULL, NULL, 225802),
(225803, '2.10.25.10-FF-001068', NULL, 'Uncharacterized protein', 48, NULL, NULL, 225803),
(225804, '2.70.150.10-FF-000018', NULL, 'Phospholipid-transporting ATPase', 153, NULL, NULL, 225804),
(225805, '3.90.960.10-FF-000004', NULL, 'Proline--tRNA ligase', 140, NULL, NULL, 225805),
(225806, '3.30.420.150-FF-000002', NULL, 'Ectonucleoside triphosphate diphosphohydrolase 1', 274, NULL, NULL, 225806),
(225807, '1.20.5.340-FF-000108', NULL, 'Atrial myosin heavy chain', 121, NULL, NULL, 225807),
(225808, '3.30.160.60-FF-002523', NULL, 'Zinc finger protein 484', 26, NULL, NULL, 225808),
(225809, '3.20.20.150-FF-000015', NULL, '2-keto-myo-inositol isomerase IolI2', 271, NULL, NULL, 225809);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(225810, '3.30.160.60-FF-004721', NULL, NULL, 24, NULL, NULL, 225810),
(225811, '1.20.1270.280-FF-000051', NULL, 'Uncharacterized protein', 166, NULL, NULL, 225811),
(225812, '3.30.70.330-FF-001426', NULL, NULL, 96, NULL, NULL, 225812),
(225813, '2.30.130.40-FF-000035', NULL, 'Lon protease homolog', 110, NULL, NULL, 225813),
(225814, '3.30.160.60-FF-002580', NULL, 'protein krueppel', 28, NULL, NULL, 225814),
(225815, '3.30.413.10-FF-000011', NULL, 'Anaerobic sulfite reductase subunit AsrC', 135, NULL, NULL, 225815),
(225816, '1.25.10.10-FF-001964', NULL, 'ARMADILLO BTB ARABIDOPSIS PROTEIN 1', 212, NULL, NULL, 225816),
(225817, '3.10.450.240-FF-000028', NULL, 'Uncharacterized protein', 163, NULL, NULL, 225817),
(225818, '3.30.160.60-FF-002922', NULL, 'Transcription factor', 28, NULL, NULL, 225818),
(225819, '2.60.40.150-FF-000183', NULL, 'Phosphoinositide phospholipase C', 153, NULL, NULL, 225819),
(225820, '3.40.50.300-FF-002344', NULL, 'ABC transporter, ATP-binding protein', 222, NULL, NULL, 225820),
(225821, '1.10.418.10-FF-000175', NULL, 'Kinesin-like protein KIN-14G isoform A', 146, NULL, NULL, 225821),
(225822, '3.40.50.300-FF-006273', NULL, 'Ras homolog family member T1', 134, NULL, NULL, 225822),
(225823, '1.10.8.270-FF-000084', NULL, 'Uncharacterized protein', 113, NULL, NULL, 225823),
(225824, '1.10.760.10-FF-000043', NULL, 'Probable c-type cytochrome', 86, NULL, NULL, 225824),
(225825, '1.10.510.10-FF-002363', NULL, NULL, 185, NULL, NULL, 225825),
(225826, '2.20.50.20-FF-000005', NULL, 'Vitellogenin 3', 84, NULL, NULL, 225826),
(225827, '1.20.1250.20-FF-001509', NULL, 'Uncharacterized protein', 336, NULL, NULL, 225827),
(225828, '1.20.1250.20-FF-001566', NULL, 'synaptic vesicular amine transporter-like', 388, NULL, NULL, 225828),
(225829, '1.20.5.470-FF-000006', NULL, 'Argininosuccinate synthase 1', 39, NULL, NULL, 225829),
(225830, '3.30.230.10-FF-000221', NULL, 'DNA topoisomerase (ATP-hydrolyzing)', 171, NULL, NULL, 225830),
(225831, '2.60.40.420-FF-000011', NULL, 'Coagulation factor VIII (Predicted)', 184, NULL, NULL, 225831),
(225832, '1.20.5.930-FF-000009', NULL, 'integrin alpha-PS2 isoform X2', 46, NULL, NULL, 225832),
(225833, '2.70.98.110-FF-000015', NULL, NULL, 303, NULL, NULL, 225833),
(225834, '3.10.490.10-FF-000025', NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase-like', 160, NULL, NULL, 225834),
(225835, '3.40.50.300-FF-004474', NULL, 'Uncharacterized protein', 200, NULL, NULL, 225835),
(225836, '1.25.50.20-FF-000109', NULL, 'Aminopeptidase A, putative', 83, NULL, NULL, 225836),
(225837, '2.10.25.10-FF-001181', NULL, 'Thyroid peroxidase', 46, NULL, NULL, 225837),
(225838, '1.10.520.10-FF-000059', NULL, 'Predicted protein', 110, NULL, NULL, 225838),
(225839, '3.30.2310.20-FF-000005', NULL, 'Addiction module toxin, Txe/YoeB family', 84, NULL, NULL, 225839),
(225840, '1.10.3430.10-FF-000006', NULL, 'Ammonium transporter', 461, NULL, NULL, 225840),
(225841, '2.130.10.10-FF-003799', NULL, 'Probable cytosolic iron-sulfur protein assembly protein CIAO1 homolog', 311, NULL, NULL, 225841),
(225842, '3.40.850.10-FF-000030', NULL, 'unconventional myosin-VI isoform X1', 79, NULL, NULL, 225842),
(225843, '1.20.1070.10-FF-000161', NULL, 'type-2 angiotensin II receptor', 310, NULL, NULL, 225843),
(225844, '3.30.2310.10-FF-000002', NULL, 'tRNA methyltransferase O', 102, NULL, NULL, 225844),
(225845, '2.130.10.10-FF-002400', NULL, 'Protein CBG10826', 222, NULL, NULL, 225845),
(225846, '1.20.120.1200-FF-000030', NULL, 'NADH-ubiquinone oxidoreductase chain 6', 80, NULL, NULL, 225846),
(225847, '2.40.10.10-FF-000454', NULL, NULL, 121, NULL, NULL, 225847),
(225848, '3.10.490.20-FF-000028', NULL, 'Uncharacterized protein', 82, NULL, NULL, 225848),
(225849, '2.30.29.30-FF-001077', NULL, 'Uncharacterized protein', 68, NULL, NULL, 225849),
(225850, '2.10.110.10-FF-000361', NULL, 'Uncharacterized protein', 104, NULL, NULL, 225850),
(225851, '3.20.20.80-FF-000030', NULL, 'Lysosomal acid glucosylceramidase', 373, NULL, NULL, 225851),
(225852, '3.30.930.10-FF-000078', NULL, 'Seryl-tRNA synthetase', 320, NULL, NULL, 225852);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(225853, '2.40.50.140-FF-000170', NULL, 'SPOUT domain containing methyltransferase 1', 71, NULL, NULL, 225853),
(225854, '1.10.1420.10-FF-000157', NULL, 'Uncharacterized protein', 82, NULL, NULL, 225854),
(225855, '2.20.28.10-FF-000063', NULL, 'Uncharacterized protein', 18, NULL, NULL, 225855),
(225856, '2.130.10.10-FF-004075', NULL, 'WD domain containing protein', 204, NULL, NULL, 225856),
(225857, '2.130.10.10-FF-001669', NULL, 'WD repeat domain 27', 88, NULL, NULL, 225857),
(225858, '1.10.10.10-FF-000710', NULL, 'Transcription factor E', 88, NULL, NULL, 225858),
(225859, '2.60.40.3210-FF-000008', NULL, 'Transforming growth factor beta receptor 3', 87, NULL, NULL, 225859),
(225860, '3.40.50.300-FF-006615', NULL, 'Predicted protein', 94, NULL, NULL, 225860),
(225861, '2.60.40.150-FF-000525', NULL, 'Translocation protein sec63', 137, NULL, NULL, 225861),
(225862, '2.40.70.10-FF-000340', NULL, NULL, 162, NULL, NULL, 225862),
(225863, '2.60.120.290-FF-000088', NULL, 'CBN-EAT-18 protein', 127, NULL, NULL, 225863),
(225864, '1.20.120.1750-FF-000060', NULL, 'RBR-type E3 ubiquitin transferase', 71, NULL, NULL, 225864),
(225865, '3.30.310.50-FF-000043', NULL, 'Phosphoglucomutase/phosphomannomutase family protein', 85, NULL, NULL, 225865),
(225866, '2.30.30.1020-FF-000055', NULL, NULL, 203, NULL, NULL, 225866),
(225867, '3.40.50.150-FF-000298', NULL, 'Methyltransferase-like protein', 198, NULL, NULL, 225867),
(225868, '1.10.10.10-FF-000654', NULL, 'Transcriptional regulator, LysR family', 84, NULL, NULL, 225868),
(225869, '3.40.395.10-FF-000027', NULL, 'SUMO-specific peptidase 6', 133, NULL, NULL, 225869),
(225870, '3.30.70.1230-FF-000270', NULL, 'Uncharacterized protein', 123, NULL, NULL, 225870),
(225871, '3.30.160.60-FF-002248', NULL, 'Zinc finger and BTB domain-containing 40', 25, NULL, NULL, 225871),
(225872, '3.40.50.300-FF-005778', NULL, 'monofunctional C1-tetrahydrofolate synthase, mitochondrial isoform X4', 100, NULL, NULL, 225872),
(225873, '1.10.287.2250-FF-000008', NULL, 'Uncharacterized protein', 80, NULL, NULL, 225873),
(225874, '1.10.472.130-FF-000075', NULL, 'Dynein heavy chain 8', 186, NULL, NULL, 225874),
(225875, '3.30.390.150-FF-000004', NULL, 'Gastrokine 2', 104, NULL, NULL, 225875),
(225876, '3.30.310.130-FF-000005', NULL, 'Uncharacterized protein, isoform C', 75, NULL, NULL, 225876),
(225877, '1.10.472.10-FF-000339', NULL, 'G1/S-specific cyclin CCN1', 86, NULL, NULL, 225877),
(225878, '2.70.150.10-FF-000237', NULL, 'Copper-transporting ATPase ccc2', 117, NULL, NULL, 225878),
(225879, '3.40.50.720-FF-001239', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase, putative', 160, NULL, NULL, 225879),
(225880, '3.80.10.10-FF-001169', NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', 73, NULL, NULL, 225880),
(225881, '2.60.120.970-FF-000084', NULL, 'Uncharacterized protein', 211, NULL, NULL, 225881),
(225882, '3.30.70.330-FF-000066', NULL, 'Splicing factor u2af 23 kDa subunit', 94, NULL, NULL, 225882),
(225883, '1.25.40.10-FF-002573', NULL, 'Tetratricopeptide repeat protein 30A2', 114, NULL, NULL, 225883),
(225884, '2.60.120.920-FF-000108', NULL, 'Tripartite motif-containing protein 5', 131, NULL, NULL, 225884),
(225885, '3.80.10.10-FF-003081', NULL, 'Uncharacterized protein', 127, NULL, NULL, 225885),
(225886, '3.30.160.60-FF-006233', NULL, NULL, 76, NULL, NULL, 225886),
(225887, '1.20.5.340-FF-000041', NULL, 'Moz represents a chromatin-associated acetyltransferase protein', 97, NULL, NULL, 225887),
(225888, '3.30.160.60-FF-006177', NULL, NULL, 64, NULL, NULL, 225888),
(225889, '3.30.9.20-FF-000002', NULL, 'Anthraniloyl-CoA monooxygenase', 153, NULL, NULL, 225889),
(225890, '3.30.70.1350-FF-000013', NULL, 'Cobalt-zinc-cadmium resistance protein', 82, NULL, NULL, 225890),
(225891, '1.25.10.10-FF-002127', NULL, 'Coatomer subunit gamma', 225, NULL, NULL, 225891),
(225892, '3.30.830.10-FF-000188', NULL, 'Uncharacterized protein', 262, NULL, NULL, 225892),
(225893, '2.40.50.140-FF-000512', NULL, 'Single-stranded DNA-binding protein', 120, NULL, NULL, 225893),
(225894, '1.20.1250.20-FF-002061', NULL, 'Uncharacterized protein', 296, NULL, NULL, 225894);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(225895, '1.10.1420.10-FF-000213', NULL, 'Uncharacterized protein', 137, NULL, NULL, 225895),
(225896, '4.10.860.10-FF-000022', NULL, NULL, 53, NULL, NULL, 225896),
(225897, '1.25.10.10-FF-002184', NULL, 'Uncharacterized protein', 462, NULL, NULL, 225897),
(225898, '2.30.30.100-FF-000015', NULL, 'Small nuclear ribonucleoprotein Sm D2', 97, NULL, NULL, 225898),
(225899, '3.20.20.70-FF-000437', NULL, 'Alpha-galactosidase', 289, NULL, NULL, 225899),
(225900, '2.60.40.10-FF-000617', NULL, 'Immunoglobulin-like and fibronectin type III domain-containing 1', 101, NULL, NULL, 225900),
(225901, '2.10.220.10-FF-000190', NULL, 'Uncharacterized protein', 63, NULL, NULL, 225901),
(225902, '1.25.10.10-FF-002307', NULL, 'Predicted protein', 318, NULL, NULL, 225902),
(225903, '1.20.1250.20-FF-001785', NULL, 'Predicted protein', 181, NULL, NULL, 225903),
(225904, '1.20.1020.10-FF-000006', NULL, 'Histone acetyltransferase of the CBP family 12', 108, NULL, NULL, 225904),
(225905, '3.60.15.10-FF-000130', NULL, 'Metallo-beta-lactamase superfamily protein', 226, NULL, NULL, 225905),
(225906, '3.40.50.300-FF-004199', NULL, 'ATP-dependent zinc metalloprotease FtsH homolog', 59, NULL, NULL, 225906),
(225907, '1.10.3120.10-FF-000016', NULL, 'Trigger factor', 210, NULL, NULL, 225907),
(225908, '3.40.50.300-FF-006054', NULL, 'Uncharacterized protein', 139, NULL, NULL, 225908),
(225909, '2.30.29.30-FF-001352', NULL, 'Uncharacterized protein', 135, NULL, NULL, 225909),
(225910, '1.10.510.10-FF-002183', NULL, 'Uncharacterized protein', 328, NULL, NULL, 225910),
(225911, '1.10.472.10-FF-000053', NULL, 'Cyclin-G1', 101, NULL, NULL, 225911),
(225912, '3.40.50.10900-FF-000025', NULL, 'Uncharacterized protein', 86, NULL, NULL, 225912),
(225913, '2.30.30.140-FF-000179', NULL, 'E3 ubiquitin-protein ligase UHRF1', 77, NULL, NULL, 225913),
(225914, '2.30.29.30-FF-000857', NULL, 'Uncharacterized protein', 220, NULL, NULL, 225914),
(225915, '2.60.40.10-FF-000674', NULL, 'Immunoglobulin superfamily member 3', 119, NULL, NULL, 225915),
(225916, '3.30.70.330-FF-000009', NULL, 'cytoplasmic polyadenylation element-binding protein 2 isoform X1', 89, NULL, NULL, 225916),
(225917, '3.40.30.10-FF-000560', NULL, 'Thiol-disulfide oxidoreductase LTO1', 106, NULL, NULL, 225917),
(225918, '2.40.50.580-FF-000003', NULL, 'Sugar fermentation stimulation protein homolog', 77, NULL, NULL, 225918),
(225919, '1.10.730.10-FF-000215', NULL, 'Uncharacterized protein', 149, NULL, NULL, 225919),
(225920, '3.60.10.10-FF-000102', NULL, 'Predicted protein', 333, NULL, NULL, 225920),
(225921, '2.170.270.10-FF-000144', NULL, 'Uncharacterized protein', 85, NULL, NULL, 225921),
(225922, '3.30.530.20-FF-000207', NULL, 'Uncharacterized protein', 245, NULL, NULL, 225922),
(225923, '3.40.50.720-FF-001458', NULL, 'UDP-glucose 4-epimerase isoform X2', 225, NULL, NULL, 225923),
(225924, '2.60.120.650-FF-000050', NULL, 'Putative jumonji-like transcription factor family protein', 344, NULL, NULL, 225924),
(225925, '1.20.120.1760-FF-000006', NULL, 'Putative ethanolaminephosphotransferase 1', 218, NULL, NULL, 225925),
(225926, '3.20.20.70-FF-000836', NULL, NULL, 110, NULL, NULL, 225926),
(225927, '1.20.58.70-FF-000006', NULL, 'Syntaxin 7', 123, NULL, NULL, 225927),
(225928, '1.25.40.10-FF-003591', NULL, 'Serine/threonine-protein kinase TOR', 333, NULL, NULL, 225928),
(225929, '2.130.10.10-FF-006054', NULL, 'Dactylin, putative', 151, NULL, NULL, 225929),
(225930, '2.30.42.10-FF-000202', NULL, 'Protease Do-like 1, chloroplastic', 105, NULL, NULL, 225930),
(225931, '3.30.420.40-FF-000155', NULL, 'Autoinducer-2 kinase', 263, NULL, NULL, 225931),
(225932, '3.30.200.20-FF-002526', NULL, 'Uncharacterized protein', 77, NULL, NULL, 225932),
(225933, '1.20.58.60-FF-000003', NULL, 'Actinin, alpha 1', 113, NULL, NULL, 225933),
(225934, '2.60.40.150-FF-000705', NULL, 'Non-specific serine/threonine protein kinase', 171, NULL, NULL, 225934),
(225935, '2.70.150.10-FF-000294', NULL, 'Uncharacterized protein', 131, NULL, NULL, 225935),
(225936, '1.20.120.1750-FF-000003', NULL, 'RBR-type E3 ubiquitin transferase', 262, NULL, NULL, 225936);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(225937, '3.40.50.1000-FF-000810', NULL, NULL, 129, NULL, NULL, 225937),
(225938, '2.40.128.180-FF-000002', NULL, 'Fas apoptotic inhibitory molecule 1', 83, NULL, NULL, 225938),
(225939, '2.80.10.50-FF-000155', NULL, 'Cysteine protease inhibitor WSCP', 183, NULL, NULL, 225939),
(225940, '2.60.40.420-FF-000230', NULL, 'Predicted protein', 167, NULL, NULL, 225940),
(225941, '3.90.190.10-FF-000619', NULL, 'Uncharacterized protein', 68, NULL, NULL, 225941),
(225942, '1.10.10.10-FF-000036', NULL, 'Fatty acid metabolism regulator protein', 79, NULL, NULL, 225942),
(225943, '3.40.1110.10-FF-000395', NULL, NULL, 105, NULL, NULL, 225943),
(225944, '3.10.180.10-FF-000092', NULL, 'Uncharacterized protein', 92, NULL, NULL, 225944),
(225945, '3.40.50.2300-FF-001493', NULL, NULL, 121, NULL, NULL, 225945),
(225946, '3.30.9.30-FF-000005', NULL, 'Predicted protein', 171, NULL, NULL, 225946),
(225947, '1.20.120.420-FF-000007', NULL, 'Methylthioribose-1-phosphate isomerase', 147, NULL, NULL, 225947),
(225948, '3.30.870.10-FF-000022', NULL, 'Phospholipase', 224, NULL, NULL, 225948),
(225949, '1.20.870.10-FF-000037', NULL, 'Cyclic GMP-binding protein D', 186, NULL, NULL, 225949),
(225950, '1.10.3730.20-FF-000049', NULL, 'Multidrug resistance protein', 121, NULL, NULL, 225950),
(225951, '3.10.100.10-FF-000441', NULL, NULL, 55, NULL, NULL, 225951),
(225952, '2.160.20.10-FF-000117', NULL, 'Tail spike protein', 371, NULL, NULL, 225952),
(225953, '3.30.70.330-FF-000408', NULL, 'Transcription initiation factor TFIID subunit 15-like', 84, NULL, NULL, 225953),
(225954, '3.40.640.10-FF-000435', NULL, 'Predicted protein', 246, NULL, NULL, 225954),
(225955, '3.20.80.10-FF-000058', NULL, 'Predicted protein', 120, NULL, NULL, 225955),
(225956, '3.30.60.60-FF-000003', NULL, 'Histone acetyltransferase', 59, NULL, NULL, 225956),
(225957, '1.10.10.10-FF-000093', NULL, 'Putative interferon regulatory factor 6', 112, NULL, NULL, 225957),
(225958, '3.40.50.150-FF-000573', NULL, 'Sphingolipid C9-methyltransferase', 289, NULL, NULL, 225958),
(225959, '1.10.472.10-FF-000671', NULL, 'Retinoblastoma-like 2 (p130)', 66, NULL, NULL, 225959),
(225960, '3.40.50.300-FF-001849', NULL, 'Helicase, putative', 223, NULL, NULL, 225960),
(225961, '3.30.200.20-FF-001689', NULL, NULL, 68, NULL, NULL, 225961),
(225962, '1.50.40.10-FF-000542', NULL, 'Probable mitochondrial 2-oxodicarboxylate carrier', 221, NULL, NULL, 225962),
(225963, '2.60.40.10-FF-000275', NULL, 'fibronectin isoform X1', 89, NULL, NULL, 225963),
(225964, '1.10.630.10-FF-000449', NULL, 'Cytochrome P-450 IIC5, putative', 194, NULL, NULL, 225964),
(225965, '2.30.30.40-FF-000195', NULL, 'epidermal growth factor receptor kinase substrate 8-like protein 3', 63, NULL, NULL, 225965),
(225966, '2.40.30.180-FF-000003', NULL, 'Ubiquitin-activating enzyme E1', 86, NULL, NULL, 225966),
(225967, '4.10.280.10-FF-000079', NULL, 'CLUMA_CG001539, isoform A', 65, NULL, NULL, 225967),
(225968, '3.30.70.330-FF-001971', NULL, NULL, 95, NULL, NULL, 225968),
(225969, '3.10.110.10-FF-000211', NULL, 'Uncharacterized protein', 139, NULL, NULL, 225969),
(225970, '2.40.160.120-FF-000033', NULL, 'Oxysterol-binding protein-related protein 3B', 167, NULL, NULL, 225970),
(225971, '3.30.1120.10-FF-000044', NULL, 'Arylsulfatase A', 97, NULL, NULL, 225971),
(225972, '2.40.160.110-FF-000030', NULL, 'ATPase H+ transporting accessory protein 1 like', 101, NULL, NULL, 225972),
(225973, '2.70.98.10-FF-000082', NULL, 'Glucans biosynthesis protein G 2', 372, NULL, NULL, 225973),
(225974, '3.40.50.300-FF-006790', NULL, 'Uncharacterized protein', 57, NULL, NULL, 225974),
(225975, '2.40.30.10-FF-000039', NULL, 'U32 family peptidase', 86, NULL, NULL, 225975),
(225976, '3.30.300.180-FF-000012', NULL, 'Chromosomal replication initiator protein DnaA 1', 76, NULL, NULL, 225976),
(225977, '1.10.510.10-FF-000485', NULL, 'testis-specific serine/threonine-protein kinase 3', 265, NULL, NULL, 225977),
(225978, '3.40.390.10-FF-000016', NULL, 'Matrix metallopeptidase 17', 262, NULL, NULL, 225978),
(225979, '1.25.40.340-FF-000003', NULL, 'Dihydroxyacetone kinase subunit DhaL', 210, NULL, NULL, 225979);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(225980, '1.20.120.350-FF-000228', NULL, NULL, 131, NULL, NULL, 225980),
(225981, '1.20.120.980-FF-000052', NULL, 'Uncharacterized protein', 105, NULL, NULL, 225981),
(225982, '3.40.800.20-FF-000018', NULL, 'Histone deacetylase', 374, NULL, NULL, 225982),
(225983, '3.40.50.2000-FF-000503', NULL, 'Lipopolysaccharide heptosyltransferase I', 158, NULL, NULL, 225983),
(225984, '2.60.40.1120-FF-000016', NULL, 'carboxypeptidase D isoform X2', 90, NULL, NULL, 225984),
(225985, '2.130.10.10-FF-005941', NULL, 'Uncharacterized protein', 257, NULL, NULL, 225985),
(225986, '2.60.40.2690-FF-000009', NULL, 'Splicing factor 3A subunit 2', 113, NULL, NULL, 225986),
(225987, '1.20.5.170-FF-000198', NULL, 'BZIP transcription factor', 84, NULL, NULL, 225987),
(225988, '3.30.1140.60-FF-000009', NULL, 'F-actin-capping protein subunit alpha', 112, NULL, NULL, 225988),
(225989, '1.10.238.10-FF-001032', NULL, 'Cardiac myosin light chain 2', 59, NULL, NULL, 225989),
(225990, '3.30.160.60-FF-000562', NULL, 'Zinc finger protein 786', 29, NULL, NULL, 225990),
(225991, '1.10.510.10-FF-004184', NULL, NULL, 72, NULL, NULL, 225991),
(225992, '3.90.470.20-FF-000060', NULL, 'L-aminoadipate-semialdehyde dehydrogenase-phosphopantetheinyl transferase', 98, NULL, NULL, 225992),
(225993, '3.90.70.10-FF-000880', NULL, 'Uncharacterized protein', 349, NULL, NULL, 225993),
(225994, '3.40.309.10-FF-000042', NULL, 'Aldehyde dehydrogenase', 206, NULL, NULL, 225994),
(225995, '1.10.20.10-FF-000177', NULL, 'Histone H3', 147, NULL, NULL, 225995),
(225996, '3.80.20.20-FF-000032', NULL, 'Predicted protein', 101, NULL, NULL, 225996),
(225997, '1.10.10.10-FF-000249', NULL, 'Transcriptional regulator, LysR family', 87, NULL, NULL, 225997),
(225998, '3.90.1600.10-FF-000016', NULL, 'DNA polymerase catalytic subunit', 197, NULL, NULL, 225998),
(225999, '3.30.160.60-FF-004294', NULL, NULL, 30, NULL, NULL, 225999),
(226000, '3.90.550.50-FF-000120', NULL, 'Uncharacterized protein', 198, NULL, NULL, 226000),
(226001, '3.40.50.12650-FF-000022', NULL, 'Pso2p', 160, NULL, NULL, 226001),
(226002, '3.30.160.60-FF-004305', NULL, NULL, 28, NULL, NULL, 226002),
(226003, '3.30.200.20-FF-001734', NULL, 'Uncharacterized protein', 72, NULL, NULL, 226003),
(226004, '1.20.1070.10-FF-001375', NULL, 'Predicted protein', 256, NULL, NULL, 226004),
(226005, '1.10.150.20-FF-000033', NULL, 'TfoX family protein', 91, NULL, NULL, 226005),
(226006, '3.80.10.10-FF-003283', NULL, 'Uncharacterized protein', 120, NULL, NULL, 226006),
(226007, '3.30.230.10-FF-000131', NULL, 'Uncharacterized protein, isoform A', 198, NULL, NULL, 226007),
(226008, '3.30.1050.10-FF-000015', NULL, 'Non-specific lipid-transfer protein-like 1', 112, NULL, NULL, 226008),
(226009, '1.25.40.20-FF-000362', NULL, 'Ankyrin repeat and SOCS box containing 6', 199, NULL, NULL, 226009),
(226010, '3.90.1170.50-FF-000022', NULL, 'Uncharacterized protein', 53, NULL, NULL, 226010),
(226011, '3.40.50.300-FF-006801', NULL, 'Origin recognition complex subunit 1', 54, NULL, NULL, 226011),
(226012, '1.25.40.10-FF-003585', NULL, 'histone demethylase UTY', 166, NULL, NULL, 226012),
(226013, '3.30.200.20-FF-000632', NULL, 'MSP', 94, NULL, NULL, 226013),
(226014, '3.30.830.10-FF-000334', NULL, 'Os01g0779100 protein', 141, NULL, NULL, 226014),
(226015, '1.20.5.110-FF-000287', NULL, 'Os06g0223000 protein', 63, NULL, NULL, 226015),
(226016, '1.10.1740.10-FF-000029', NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', 80, NULL, NULL, 226016),
(226017, '1.10.287.110-FF-000377', NULL, 'DNAJ heat shock N-terminal domain-containing protein', 118, NULL, NULL, 226017),
(226018, '2.60.34.10-FF-000070', NULL, 'Actin-like ATPase domain-containing protein', 150, NULL, NULL, 226018),
(226019, '2.30.30.40-FF-000239', NULL, 'NCK interacting protein with SH3 domain', 69, NULL, NULL, 226019),
(226020, '3.40.800.10-FF-000015', NULL, 'Formimidoylglutamase', 310, NULL, NULL, 226020),
(226021, '1.10.150.780-FF-000005', NULL, 'Vacuolar protein sorting complex subunit, putative', 76, NULL, NULL, 226021),
(226022, '2.40.50.690-FF-000031', NULL, 'Salivary protein Is3, putative', 41, NULL, NULL, 226022);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(226023, '1.20.1310.10-FF-000146', NULL, NULL, 120, NULL, NULL, 226023),
(226024, '3.30.160.60-FF-000606', NULL, 'C2H2 transcription factor, putative', 35, NULL, NULL, 226024),
(226025, '1.10.10.60-FF-000124', NULL, 'Orthopedia homeobox b', 67, NULL, NULL, 226025),
(226026, '3.30.1140.40-FF-000003', NULL, 'tctex1 domain-containing protein 2', 99, NULL, NULL, 226026),
(226027, '3.10.20.90-FF-000825', NULL, 'Ubiquitin family protein', 102, NULL, NULL, 226027),
(226028, '2.40.150.20-FF-000028', NULL, 'Uncharacterized protein', 86, NULL, NULL, 226028),
(226029, '2.120.10.30-FF-000169', NULL, 'tripartite motif-containing protein 2 isoform X1', 38, NULL, NULL, 226029),
(226030, '3.30.1490.100-FF-000016', NULL, 'DNA polymerase IV', 110, NULL, NULL, 226030),
(226031, '1.20.1740.10-FF-000179', NULL, 'Uncharacterized protein', 308, NULL, NULL, 226031),
(226032, '1.20.1720.10-FF-000020', NULL, 'Probable triacylglyceride transporter BCG_1471c', 211, NULL, NULL, 226032),
(226033, '1.10.10.60-FF-000803', NULL, NULL, 73, NULL, NULL, 226033),
(226034, '3.30.200.20-FF-000306', NULL, 'IKS protein kinase', 96, NULL, NULL, 226034),
(226035, '2.130.10.10-FF-000135', NULL, 'Apoptotic protease-activating factor 1', 312, NULL, NULL, 226035),
(226036, '3.40.50.880-FF-000207', NULL, 'Uncharacterized protein', 220, NULL, NULL, 226036),
(226037, '2.30.42.10-FF-000314', NULL, 'Carboxy-terminal processing protease', 99, NULL, NULL, 226037),
(226038, '3.30.420.40-FF-000519', NULL, 'Actin-related protein 6', 45, NULL, NULL, 226038),
(226039, '2.70.98.60-FF-000001', NULL, 'Alpha-galactosidase', 296, NULL, NULL, 226039),
(226040, '1.20.58.70-FF-000124', NULL, 'Syntaxin-22', 103, NULL, NULL, 226040),
(226041, '3.30.450.30-FF-000018', NULL, 'Mitogen-activated protein kinase kinase 1 interacting protein', 124, NULL, NULL, 226041),
(226042, '2.40.20.10-FF-000067', NULL, 'Uncharacterized protein', 122, NULL, NULL, 226042),
(226043, '2.60.40.10-FF-001000', NULL, 'tyrosine-protein phosphatase Lar isoform X3', 108, NULL, NULL, 226043),
(226044, '2.40.50.140-FF-000405', NULL, 'Maltose/maltodextrin import ATP-binding protein MalK', 53, NULL, NULL, 226044),
(226045, '4.10.400.10-FF-000168', NULL, 'LDL receptor related protein 2', 34, NULL, NULL, 226045),
(226046, '2.130.10.10-FF-000461', NULL, 'Chromatin assembly factor 1 subunit B', 232, NULL, NULL, 226046),
(226047, '3.40.30.10-FF-000189', NULL, 'Glutathione S-Transferase', 78, NULL, NULL, 226047),
(226048, '3.10.20.310-FF-000049', NULL, 'Hemolysin activator protein', 81, NULL, NULL, 226048),
(226049, '3.30.450.260-FF-000007', NULL, 'Soluble guanylate cyclase gcy-33', 152, NULL, NULL, 226049),
(226050, '1.10.1420.10-FF-000090', NULL, 'Predicted protein', 85, NULL, NULL, 226050),
(226051, '3.30.70.580-FF-000034', NULL, 'tRNA pseudouridine synthase', 142, NULL, NULL, 226051),
(226052, '2.40.50.290-FF-000001', NULL, 'Glycyl-glycine endopeptidase LytM', 62, NULL, NULL, 226052),
(226053, '2.130.10.10-FF-004160', NULL, 'Uncharacterized protein', 172, NULL, NULL, 226053),
(226054, '2.60.40.150-FF-000610', NULL, 'Predicted protein', 152, NULL, NULL, 226054),
(226055, '1.10.8.270-FF-000095', NULL, 'Rab GTPase activating protein putative', 117, NULL, NULL, 226055),
(226056, '3.50.50.60-FF-001284', NULL, 'Probable phytoene dehydrogenase', 452, NULL, NULL, 226056),
(226057, '2.40.10.10-FF-000465', NULL, NULL, 117, NULL, NULL, 226057),
(226058, '3.20.20.70-FF-000628', NULL, NULL, 278, NULL, NULL, 226058),
(226059, '2.60.40.1110-FF-000013', NULL, 'Type I pullulanase', 49, NULL, NULL, 226059),
(226060, '3.40.120.10-FF-000087', NULL, 'Phosphohexomutase (Phosphoglucomutase / phosphomannomutase)', 92, NULL, NULL, 226060),
(226061, '3.30.160.60-FF-003788', NULL, NULL, 22, NULL, NULL, 226061),
(226062, '1.10.8.270-FF-000106', NULL, 'Uncharacterized protein', 136, NULL, NULL, 226062),
(226063, '1.20.144.10-FF-000064', NULL, 'Succinate--CoA ligase [ADP/GDP-forming] subunit alpha, mitochondrial', 248, NULL, NULL, 226063),
(226064, '2.30.30.140-FF-000269', NULL, 'Protein CBG13694', 91, NULL, NULL, 226064);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(226065, '4.10.520.10-FF-000002', NULL, 'Integration host factor subunit alpha', 97, NULL, NULL, 226065),
(226066, '2.40.30.10-FF-000365', NULL, 'NADPH reductase TAH18', 57, NULL, NULL, 226066),
(226067, '3.40.50.150-FF-000461', NULL, 'Sarcosine/dimethylglycine N-methyltransferase', 259, NULL, NULL, 226067),
(226068, '3.10.110.10-FF-000048', NULL, 'Ubiquitin-conjugating enzyme E2 15', 166, NULL, NULL, 226068),
(226069, '2.60.40.10-FF-004182', NULL, NULL, 87, NULL, NULL, 226069),
(226070, '3.40.50.10260-FF-000029', NULL, 'AEL049Wp', 281, NULL, NULL, 226070),
(226071, '3.30.70.980-FF-000064', NULL, 'Predicted protein', 51, NULL, NULL, 226071),
(226072, '2.40.70.10-FF-000148', NULL, 'Uncharacterized protein', 128, NULL, NULL, 226072),
(226073, '3.90.1100.10-FF-000023', NULL, 'DNA-directed RNA polymerase subunit beta', 160, NULL, NULL, 226073),
(226074, '3.40.395.10-FF-000005', NULL, 'Ubiquitin-like-specific protease ESD4', 243, NULL, NULL, 226074),
(226075, '2.160.20.70-FF-000040', NULL, 'Tubulin-specific chaperone C', 141, NULL, NULL, 226075),
(226076, '3.10.129.10-FF-000203', NULL, 'Uncharacterized protein', 279, NULL, NULL, 226076),
(226077, '2.60.40.10-FF-000483', NULL, 'HEPACAM family member 2 isoform X1', 121, NULL, NULL, 226077),
(226078, '3.30.160.60-FF-006429', NULL, NULL, 44, NULL, NULL, 226078),
(226079, '1.10.420.10-FF-000040', NULL, 'Peroxisomal ascorbate peroxidase', 126, NULL, NULL, 226079),
(226080, '1.10.30.10-FF-000116', NULL, 'HMG box-containing protein 1', 45, NULL, NULL, 226080),
(226081, '3.80.10.10-FF-001349', NULL, 'NLR family CARD domain containing 3', 86, NULL, NULL, 226081),
(226082, '1.25.40.10-FF-002157', NULL, 'Pentatricopeptide repeat-containing protein At2g45350, chloroplastic', 109, NULL, NULL, 226082),
(226083, '3.40.50.2020-FF-000189', NULL, 'Os02g0517564 protein', 71, NULL, NULL, 226083),
(226084, '4.10.320.10-FF-000021', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 54, NULL, NULL, 226084),
(226085, '3.30.200.20-FF-002077', NULL, 'Uncharacterized protein', 83, NULL, NULL, 226085),
(226086, '3.40.50.620-FF-000034', NULL, 'Leucine--tRNA ligase, cytoplasmic', 432, NULL, NULL, 226086),
(226087, '3.90.70.10-FF-000554', NULL, 'Calcium-dependent cysteine protease, putative', 88, NULL, NULL, 226087),
(226088, '3.40.640.10-FF-000143', NULL, 'DegT/DnrJ/EryC1/StrS aminotransferase family protein', 253, NULL, NULL, 226088),
(226089, '3.40.50.2300-FF-001268', NULL, NULL, 204, NULL, NULL, 226089),
(226090, '1.20.1110.10-FF-000148', NULL, 'PMCA18 protein', 277, NULL, NULL, 226090),
(226091, '3.40.50.300-FF-006464', NULL, 'Predicted protein', 120, NULL, NULL, 226091),
(226092, '3.10.50.40-FF-000099', NULL, 'Peptidylprolyl isomerase', 101, NULL, NULL, 226092),
(226093, '3.40.50.1580-FF-000017', NULL, 'Probable bifunctional mta/sah nucleosidase mtn', 254, NULL, NULL, 226093),
(226094, '3.80.10.10-FF-003620', NULL, 'Relaxin receptor 1-like Protein', 97, NULL, NULL, 226094),
(226095, '3.30.420.40-FF-000166', NULL, 'Actin like 8', 154, NULL, NULL, 226095),
(226096, '1.10.340.30-FF-000062', NULL, 'Predicted protein', 108, NULL, NULL, 226096),
(226097, '3.40.190.10-FF-000018', NULL, 'Oligopeptide ABC transporter, oligopeptide-binding protein', 142, NULL, NULL, 226097),
(226098, '3.30.160.60-FF-004631', NULL, NULL, 21, NULL, NULL, 226098),
(226099, '3.30.70.330-FF-001645', NULL, NULL, 116, NULL, NULL, 226099),
(226100, '2.40.50.100-FF-000017', NULL, 'Spermidine/putrescine import ATP-binding protein PotA', 88, NULL, NULL, 226100),
(226101, '3.40.50.300-FF-000169', NULL, 'ABC transporter C family member 3', 253, NULL, NULL, 226101),
(226102, '3.30.40.10-FF-001084', NULL, 'RING-H2 finger protein ATL52-like', 51, NULL, NULL, 226102),
(226103, '2.60.40.1730-FF-000093', NULL, NULL, 34, NULL, NULL, 226103),
(226104, '1.25.40.10-FF-002820', NULL, 'Os01g0301700 protein', 154, NULL, NULL, 226104),
(226105, '2.130.10.10-FF-004513', NULL, 'EMC Endoplasmic Membrane protein Complex (Yeast EMC) homolog', 350, NULL, NULL, 226105),
(226106, '3.30.200.20-FF-001397', NULL, 'Serine/threonine-protein kinase STN8, chloroplastic', 121, NULL, NULL, 226106);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(226107, '3.30.870.10-FF-000090', NULL, 'Phospholipase D', 250, NULL, NULL, 226107),
(226108, '3.90.79.10-FF-000091', NULL, 'Nudix hydrolase family protein', 174, NULL, NULL, 226108),
(226109, '3.40.50.1820-FF-001197', NULL, 'Esterase PIR7B', 131, NULL, NULL, 226109),
(226110, '1.10.238.10-FF-000189', NULL, 'Centrin 3', 83, NULL, NULL, 226110),
(226111, '1.10.10.440-FF-000094', NULL, 'Uncharacterized protein', 62, NULL, NULL, 226111),
(226112, '2.30.30.1190-FF-000010', NULL, 'C3H-type transcription factor', 71, NULL, NULL, 226112),
(226113, '1.10.472.10-FF-000233', NULL, 'Cyclin A', 111, NULL, NULL, 226113),
(226114, '1.10.10.1340-FF-000010', NULL, 'Mediator of RNA polymerase II transcription subunit 31', 65, NULL, NULL, 226114),
(226115, '3.30.565.10-FF-000313', NULL, 'Putative postmeiotic segregation increased 2-like protein 1', 174, NULL, NULL, 226115),
(226116, '3.30.1320.10-FF-000025', NULL, 'Uncharacterized protein', 104, NULL, NULL, 226116),
(226117, '1.20.1420.30-FF-000014', NULL, 'Cation/H+ exchanger protein 2', 244, NULL, NULL, 226117),
(226118, '3.40.50.150-FF-000770', NULL, 'Ribosomal RNA small subunit methyltransferase A', 204, NULL, NULL, 226118),
(226119, '3.30.890.10-FF-000017', NULL, 'Methyl-CpG-binding domain-containing protein 11', 115, NULL, NULL, 226119),
(226120, '3.30.60.30-FF-000225', NULL, 'Agrin-like Protein', 54, NULL, NULL, 226120),
(226121, '3.30.780.20-FF-000001', NULL, 'DNA helicase 2', 87, NULL, NULL, 226121),
(226122, '3.40.50.300-FF-006155', NULL, 'DNA helicase II', 226, NULL, NULL, 226122),
(226123, '3.40.640.10-FF-000452', NULL, 'Uncharacterized protein', 242, NULL, NULL, 226123),
(226124, '3.40.50.510-FF-000001', NULL, 'PTS system mannose-specific transporter subunit IIAB', 135, NULL, NULL, 226124),
(226125, '3.40.50.2300-FF-001577', NULL, NULL, 149, NULL, NULL, 226125),
(226126, '1.10.8.800-FF-000001', NULL, 'DNA polymerase II small subunit', 66, NULL, NULL, 226126),
(226127, '2.60.40.10-FF-004535', NULL, NULL, 92, NULL, NULL, 226127),
(226128, '2.60.40.1910-FF-000023', NULL, NULL, 89, NULL, NULL, 226128),
(226129, '3.40.50.300-FF-000641', NULL, 'caseinolytic peptidase B protein homolog isoform X2', 258, NULL, NULL, 226129),
(226130, '4.10.60.10-FF-000206', NULL, 'Uncharacterized protein', 52, NULL, NULL, 226130),
(226131, '1.10.8.500-FF-000001', NULL, 'Cell wall metabolism sensor histidine kinase', 64, NULL, NULL, 226131),
(226132, '2.60.40.10-FF-000820', NULL, 'SLAM family member 7', 108, NULL, NULL, 226132),
(226133, '1.25.40.10-FF-001668', NULL, 'Crooked neck protein, putative', 165, NULL, NULL, 226133),
(226134, '1.20.140.80-FF-000008', NULL, 'Uncharacterized protein', 121, NULL, NULL, 226134),
(226135, '3.40.50.1820-FF-001208', NULL, 'Uncharacterized protein', 290, NULL, NULL, 226135),
(226136, '3.30.450.240-FF-000001', NULL, 'Predicted protein', 135, NULL, NULL, 226136),
(226137, '3.40.50.10810-FF-000223', NULL, 'Uncharacterized protein', 60, NULL, NULL, 226137),
(226138, '1.10.533.10-FF-000049', NULL, 'NLR family pyrin domain containing 1', 95, NULL, NULL, 226138),
(226139, '3.40.50.920-FF-000034', NULL, '1-deoxy-D-xylulose-5-phosphate synthase', 132, NULL, NULL, 226139),
(226140, '3.90.79.10-FF-000102', NULL, 'NUDIX domain-containing protein', 247, NULL, NULL, 226140),
(226141, '1.10.10.10-FF-001986', NULL, 'Uncharacterized protein', 50, NULL, NULL, 226141),
(226142, '3.90.190.10-FF-000378', NULL, 'receptor-type tyrosine-protein phosphatase alpha-like isoform X1', 298, NULL, NULL, 226142),
(226143, '1.10.510.10-FF-004493', NULL, NULL, 233, NULL, NULL, 226143),
(226144, '2.30.180.10-FF-000035', NULL, 'fasciclin-1 isoform X5', 156, NULL, NULL, 226144),
(226145, '1.25.10.10-FF-002346', NULL, 'Uncharacterized protein', 287, NULL, NULL, 226145),
(226146, '3.30.1360.100-FF-000004', NULL, 'Type II secretion system protein L', 86, NULL, NULL, 226146),
(226147, '1.25.40.20-FF-000569', NULL, 'AT09114p', 99, NULL, NULL, 226147),
(226148, '3.40.50.300-FF-000848', NULL, 'RuvB-like helicase', 192, NULL, NULL, 226148),
(226149, '2.130.10.10-FF-002259', NULL, 'WD domain, G-beta repeat, putative', 317, NULL, NULL, 226149);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(226150, '3.30.450.40-FF-000140', NULL, 'PelD', 164, NULL, NULL, 226150),
(226151, '1.20.1070.10-FF-001712', NULL, 'Uncharacterized protein', 103, NULL, NULL, 226151),
(226152, '2.60.120.10-FF-000446', NULL, 'Probable mannose-6-phosphate isomerase', 101, NULL, NULL, 226152),
(226153, '3.30.70.80-FF-000044', NULL, 'Uncharacterized protein', 75, NULL, NULL, 226153),
(226154, '2.70.150.10-FF-000092', NULL, 'Phospholipid-transporting ATPase', 161, NULL, NULL, 226154),
(226155, '3.40.50.300-FF-005975', NULL, 'Thymidine kinase', 138, NULL, NULL, 226155),
(226156, '3.30.160.60-FF-002377', NULL, 'Zinc finger protein 445', 48, NULL, NULL, 226156),
(226157, '3.90.980.20-FF-000025', NULL, NULL, 44, NULL, NULL, 226157),
(226158, '1.25.40.10-FF-004411', NULL, 'Pentatricopeptide repeat-containing protein At1g33350', 132, NULL, NULL, 226158),
(226159, '3.50.50.100-FF-000045', NULL, 'Type-II NADH dehydrogenase', 234, NULL, NULL, 226159),
(226160, '3.30.70.870-FF-000014', NULL, 'TetQ family GTPase, putative', 77, NULL, NULL, 226160),
(226161, '3.30.160.60-FF-000915', NULL, 'Zinc finger protein 622', 66, NULL, NULL, 226161),
(226162, '1.25.70.10-FF-000068', NULL, NULL, 168, NULL, NULL, 226162),
(226163, '2.40.10.10-FF-000139', NULL, 'Acrosin', 41, NULL, NULL, 226163),
(226164, '3.40.30.10-FF-001032', NULL, 'Transducin family protein / WD-40 repeat family protein', 46, NULL, NULL, 226164),
(226165, '3.50.50.60-FF-000182', NULL, 'FAD-dependent oxidoreductase family protein', 205, NULL, NULL, 226165),
(226166, '1.10.8.60-FF-000376', NULL, 'AAA-type ATPase (CDC48 subfamily)', 94, NULL, NULL, 226166),
(226167, '1.25.40.10-FF-001977', NULL, 'Pentatricopeptide repeat-containing protein At2g33760', 117, NULL, NULL, 226167),
(226168, '3.30.420.110-FF-000029', NULL, 'DNA mismatch repair protein MutS', 116, NULL, NULL, 226168),
(226169, '3.30.420.100-FF-000026', NULL, 'Uncharacterized protein', 236, NULL, NULL, 226169),
(226170, '1.10.510.10-FF-000822', NULL, 'Serine/threonine-protein kinase gcn2', 288, NULL, NULL, 226170),
(226171, '1.10.506.10-FF-000054', NULL, 'Plexin-A1', 142, NULL, NULL, 226171),
(226172, '1.10.472.10-FF-000603', NULL, 'Predicted protein', 15, NULL, NULL, 226172),
(226173, '1.10.150.300-FF-000008', NULL, NULL, 32, NULL, NULL, 226173),
(226174, '3.30.160.60-FF-005120', NULL, NULL, 33, NULL, NULL, 226174),
(226175, '1.20.1250.20-FF-002302', NULL, 'Uncharacterized protein', 543, NULL, NULL, 226175),
(226176, '2.170.270.10-FF-000059', NULL, 'Potential protein lysine methyltransferase SET5', 139, NULL, NULL, 226176),
(226177, '3.30.460.10-FF-000199', NULL, 'Uncharacterized protein', 96, NULL, NULL, 226177),
(226178, '3.30.1120.90-FF-000011', NULL, 'Suppressor of presenilin-2', 135, NULL, NULL, 226178),
(226179, '3.30.360.10-FF-000017', NULL, 'Oxidoreductase family NAD-binding Rossmann fold', 141, NULL, NULL, 226179),
(226180, '3.40.50.1000-FF-000451', NULL, 'Phospholipid-transporting ATPase', 182, NULL, NULL, 226180),
(226181, '1.10.630.10-FF-000769', NULL, 'Uncharacterized protein', 191, NULL, NULL, 226181),
(226182, '1.20.5.340-FF-000125', NULL, 'Uncharacterized protein', 47, NULL, NULL, 226182),
(226183, '3.30.70.330-FF-002325', NULL, NULL, 115, NULL, NULL, 226183),
(226184, '3.30.43.10-FF-000016', NULL, 'D-2-hydroxyglutarate dehydrogenase, mitochondrial', 99, NULL, NULL, 226184),
(226185, '3.40.30.10-FF-000852', NULL, 'Uncharacterized protein', 101, NULL, NULL, 226185),
(226186, '1.25.40.730-FF-000013', NULL, 'Clathrin heavy chain', 97, NULL, NULL, 226186),
(226187, '2.60.40.10-FF-004209', NULL, NULL, 75, NULL, NULL, 226187),
(226188, '1.20.140.100-FF-000039', NULL, 'Uncharacterized protein', 162, NULL, NULL, 226188),
(226189, '1.10.1600.10-FF-000036', NULL, 'KU70 protein', 112, NULL, NULL, 226189),
(226190, '2.30.42.10-FF-000005', NULL, 'Membrane associated guanylate kinase, WW and PDZ domain containing 1', 128, NULL, NULL, 226190),
(226191, '1.10.1300.10-FF-000007', NULL, 'Phosphodiesterase 10A', 331, NULL, NULL, 226191),
(226192, '1.20.58.2010-FF-000012', NULL, 'Uncharacterized protein', 94, NULL, NULL, 226192);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(226193, '2.60.40.1510-FF-000026', NULL, 'Integrin alpha pat-2', 148, NULL, NULL, 226193),
(226194, '3.40.50.880-FF-000224', NULL, 'Uncharacterized protein', 79, NULL, NULL, 226194),
(226195, '1.10.287.190-FF-000002', NULL, 'General transcription factor IIA subunit 2', 24, NULL, NULL, 226195),
(226196, '2.40.10.10-FF-000156', NULL, 'MIP06385p', 228, NULL, NULL, 226196),
(226197, '1.20.1280.290-FF-000050', NULL, 'Sugar transporter SWEET', 97, NULL, NULL, 226197),
(226198, '2.130.10.10-FF-004176', NULL, 'WD repeat-containing protein 21', 166, NULL, NULL, 226198),
(226199, '1.20.58.1250-FF-000008', NULL, 'Uncharacterized protein', 115, NULL, NULL, 226199),
(226200, '3.90.980.20-FF-000008', NULL, 'Uncharacterized protein', 148, NULL, NULL, 226200),
(226201, '3.40.50.300-FF-000539', NULL, 'Elongation factor G, mitochondrial', 293, NULL, NULL, 226201),
(226202, '2.40.20.10-FF-000084', NULL, 'Receptor tyrosine kinase-like orphan receptor', 88, NULL, NULL, 226202),
(226203, '2.60.40.60-FF-000565', NULL, 'Cadherin 24', 109, NULL, NULL, 226203),
(226204, '1.20.58.830-FF-000047', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 162, NULL, NULL, 226204),
(226205, '1.10.1420.10-FF-000073', NULL, 'Putative mismatch repair protein MSH8', 134, NULL, NULL, 226205),
(226206, '3.30.70.580-FF-000017', NULL, 'Related to DEG1-pseudouridine synthase', 125, NULL, NULL, 226206),
(226207, '3.40.50.300-FF-008616', NULL, 'Dynamin GTPase, switch/motor protein', 343, NULL, NULL, 226207),
(226208, '3.30.40.10-FF-000010', NULL, 'E3 ubiquitin-protein ligase RBX1', 100, NULL, NULL, 226208),
(226209, '1.20.1530.20-FF-000014', NULL, 'Solute carrier family 10 member 3', 296, NULL, NULL, 226209),
(226210, '3.40.50.300-FF-002439', NULL, 'ABC transporter, ATP-binding/permease protein', 255, NULL, NULL, 226210),
(226211, '3.60.21.10-FF-000476', NULL, 'Uncharacterized protein', 300, NULL, NULL, 226211),
(226212, '1.25.40.10-FF-004265', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 219, NULL, NULL, 226212),
(226213, '3.40.190.10-FF-000361', NULL, 'SgrR family transcriptional regulator', 241, NULL, NULL, 226213),
(226214, '3.30.70.560-FF-000011', NULL, 'Folic acid synthesis protein fol1', 196, NULL, NULL, 226214),
(226215, '1.20.1050.10-FF-000210', NULL, 'Os11g0125601 protein', 83, NULL, NULL, 226215),
(226216, '3.30.70.330-FF-001499', NULL, 'Putative RNA-binding protein', 91, NULL, NULL, 226216),
(226217, '1.25.10.10-FF-000205', NULL, 'Serine/threonine-protein phosphatase 4 regulatory subunit 1', 333, NULL, NULL, 226217),
(226218, '2.60.120.260-FF-000264', NULL, 'Cellulose synthase domain-containing protein', 134, NULL, NULL, 226218),
(226219, '3.40.30.10-FF-001015', NULL, 'Uncharacterized protein', 58, NULL, NULL, 226219),
(226220, '3.30.1360.200-FF-000001', NULL, 'Protein translocase subunit SecD', 154, NULL, NULL, 226220),
(226221, '3.20.20.70-FF-000645', NULL, NULL, 243, NULL, NULL, 226221),
(226222, '3.40.50.12780-FF-000111', NULL, 'Nonribosomal peptide synthase GliP2', 388, NULL, NULL, 226222),
(226223, '3.30.230.80-FF-000028', NULL, 'Chaperone protein HtpG', 169, NULL, NULL, 226223),
(226224, '3.30.420.40-FF-000492', NULL, 'Actin-like ATPase domain-containing protein', 50, NULL, NULL, 226224),
(226225, '2.40.30.10-FF-000348', NULL, 'Superoxide-generating NADPH oxidase heavy chain subunit C', 100, NULL, NULL, 226225),
(226226, '1.10.460.10-FF-000014', NULL, 'DNA topoisomerase', 162, NULL, NULL, 226226),
(226227, '3.30.40.10-FF-001628', NULL, 'non-structural maintenance of chromosomes element 1 homolog', 56, NULL, NULL, 226227),
(226228, '1.10.3720.10-FF-000129', NULL, 'ABC transporter permease protein', 225, NULL, NULL, 226228),
(226229, '3.90.420.10-FF-000003', NULL, 'Nitrate reductase', 250, NULL, NULL, 226229),
(226230, '2.60.40.10-FF-000466', NULL, 'Uncharacterized protein, isoform H', 94, NULL, NULL, 226230),
(226231, '1.20.920.30-FF-000020', NULL, 'Dynein heavy chain family protein', 208, NULL, NULL, 226231),
(226232, '3.20.20.450-FF-000004', NULL, 'Cyclic diguanylate phosphodiesterase', 255, NULL, NULL, 226232);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(226233, '1.10.238.10-FF-000352', NULL, 'Cell division control protein 31', 90, NULL, NULL, 226233),
(226234, '1.25.10.10-FF-000429', NULL, 'Transport and golgi organization 6 homolog', 370, NULL, NULL, 226234),
(226235, '3.90.1410.10-FF-000007', NULL, 'Ribosomal lysine N-methyltransferase 4', 270, NULL, NULL, 226235),
(226236, '3.30.230.70-FF-000025', NULL, 'Exosome complex component rrp43', 361, NULL, NULL, 226236),
(226237, '3.90.260.10-FF-000029', NULL, 'Prostate-specific transglutaminase, putative', 135, NULL, NULL, 226237),
(226238, '3.40.395.10-FF-000022', NULL, 'Uncharacterized protein', 211, NULL, NULL, 226238),
(226239, '3.80.10.10-FF-002794', NULL, 'Receptor like protein 45', 125, NULL, NULL, 226239),
(226240, '3.40.1050.10-FF-000002', NULL, 'Carbonic anhydrase', 220, NULL, NULL, 226240),
(226241, '3.30.160.60-FF-006076', NULL, NULL, 60, NULL, NULL, 226241),
(226242, '3.30.420.40-FF-000312', NULL, 'Actin-like protein, putative', 42, NULL, NULL, 226242),
(226243, '3.30.70.980-FF-000047', NULL, 'Probable transcriptional regulatory protein Chy400_1141', 72, NULL, NULL, 226243),
(226244, '3.80.10.10-FF-001512', NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', 284, NULL, NULL, 226244),
(226245, '2.60.40.10-FF-001894', NULL, 'Stretchin-Mlck, isoform V', 107, NULL, NULL, 226245),
(226246, '2.90.10.10-FF-000058', NULL, 'Uncharacterized protein', 106, NULL, NULL, 226246),
(226247, '2.160.20.70-FF-000023', NULL, 'Tubulin binding cofactor C, putative', 129, NULL, NULL, 226247),
(226248, '3.40.1170.20-FF-000002', NULL, 'tRNA-splicing endonuclease', 85, NULL, NULL, 226248),
(226249, '3.40.50.1000-FF-000125', NULL, 'RNA polymerase II C-terminal domain phosphatase-like 4', 233, NULL, NULL, 226249),
(226250, '3.40.50.1820-FF-000106', NULL, 'Galactolipase DONGLE, chloroplastic', 363, NULL, NULL, 226250),
(226251, '3.70.10.10-FF-000046', NULL, 'Cell cycle checkpoint protein', 112, NULL, NULL, 226251),
(226252, '3.40.50.10470-FF-000076', NULL, 'Uncharacterized protein', 142, NULL, NULL, 226252),
(226253, '2.10.70.80-FF-000013', NULL, 'Sortilin', 54, NULL, NULL, 226253),
(226254, '3.80.10.10-FF-001366', NULL, 'Receptor like protein 39', 57, NULL, NULL, 226254),
(226255, '3.40.50.720-FF-001492', NULL, 'Ornithine cyclodeaminase', 169, NULL, NULL, 226255),
(226256, '1.20.1070.10-FF-000886', NULL, 'Uncharacterized protein', 196, NULL, NULL, 226256),
(226257, '1.10.10.10-FF-000233', NULL, 'DNA-binding response regulator PrrA', 105, NULL, NULL, 226257),
(226258, '2.60.40.1180-FF-000192', NULL, 'Alpha-galactosidase', 90, NULL, NULL, 226258),
(226259, '1.20.120.1200-FF-000029', NULL, 'NADH-ubiquinone oxidoreductase chain 6', 153, NULL, NULL, 226259),
(226260, '4.10.320.10-FF-000004', NULL, 'Nucleoid-associated protein Lsr2', 35, NULL, NULL, 226260),
(226261, '1.20.140.150-FF-000138', NULL, 'Predicted protein', 171, NULL, NULL, 226261),
(226262, '2.40.160.110-FF-000013', NULL, 'Lysosomal-associated membrane protein 2', 165, NULL, NULL, 226262),
(226263, '3.30.70.330-FF-000217', NULL, 'Polyadenylate-binding protein', 106, NULL, NULL, 226263),
(226264, '1.10.510.10-FF-000468', NULL, 'PTI1-like tyrosine-protein kinase 3', 215, NULL, NULL, 226264),
(226265, '3.90.70.10-FF-000863', NULL, 'Uncharacterized protein', 83, NULL, NULL, 226265),
(226266, '2.60.40.150-FF-000817', NULL, 'Uncharacterized protein', 103, NULL, NULL, 226266),
(226267, '3.40.50.300-FF-007919', NULL, 'Uncharacterized protein', 177, NULL, NULL, 226267),
(226268, '3.90.550.50-FF-000092', NULL, 'Hexosyltransferase', 216, NULL, NULL, 226268),
(226269, '2.60.40.770-FF-000003', NULL, 'Lymphocyte antigen 96', 144, NULL, NULL, 226269),
(226270, '3.90.150.10-FF-000010', NULL, 'Variant surface glycoprotein (VSG, atypical), putative', 182, NULL, NULL, 226270),
(226271, '1.10.510.10-FF-003695', NULL, NULL, 166, NULL, NULL, 226271),
(226272, '1.10.150.50-FF-000059', NULL, 'E3 ubiquitin-protein ligase LRSAM1 isoform X1', 71, NULL, NULL, 226272),
(226273, '2.130.10.10-FF-002243', NULL, 'WD repeat domain 74', 247, NULL, NULL, 226273);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(226274, '3.80.10.10-FF-001692', NULL, 'SCF E3 ubiquitin ligase complex F-box protein grrA', 113, NULL, NULL, 226274),
(226275, '3.40.50.720-FF-001048', NULL, 'Predicted protein', 224, NULL, NULL, 226275),
(226276, '3.40.50.300-FF-001012', NULL, 'Septin 1', 284, NULL, NULL, 226276),
(226277, '3.40.50.300-FF-003867', NULL, 'Predicted protein', 217, NULL, NULL, 226277),
(226278, '2.60.40.10-FF-000792', NULL, 'titin isoform X1', 87, NULL, NULL, 226278),
(226279, '1.10.357.120-FF-000009', NULL, 'DNA-directed RNA polymerase I subunit rpa1', 119, NULL, NULL, 226279),
(226280, '2.40.50.590-FF-000001', NULL, 'DNA polymerase', 45, NULL, NULL, 226280),
(226281, '1.25.10.10-FF-002329', NULL, 'Predicted protein', 301, NULL, NULL, 226281),
(226282, '4.10.60.10-FF-000223', NULL, 'Uncharacterized protein', 53, NULL, NULL, 226282),
(226283, '3.80.20.20-FF-000015', NULL, 'Putative Insulin growth factor 1 receptor', 169, NULL, NULL, 226283),
(226284, '2.60.40.790-FF-000009', NULL, '17.6 kDa class I heat shock protein-like', 145, NULL, NULL, 226284),
(226285, '2.70.40.10-FF-000033', NULL, 'Uncharacterized protein', 106, NULL, NULL, 226285),
(226286, '3.10.100.10-FF-000446', NULL, NULL, 41, NULL, NULL, 226286),
(226287, '2.60.40.10-FF-002720', NULL, 'Type II inositol-1,4,5-trisphosphate 5-phosphatase, putative', 128, NULL, NULL, 226287),
(226288, '1.10.418.10-FF-000080', NULL, 'Fimbrin-2', 113, NULL, NULL, 226288),
(226289, '1.10.510.10-FF-001896', NULL, 'EPH receptor A2', 119, NULL, NULL, 226289),
(226290, '3.30.70.270-FF-000031', NULL, 'Genome polyprotein', 140, NULL, NULL, 226290),
(226291, '3.80.10.10-FF-003311', NULL, 'Toll-like receptor 21', 192, NULL, NULL, 226291),
(226292, '1.10.357.110-FF-000006', NULL, 'Vacuolar protein sorting-associated protein 53', 154, NULL, NULL, 226292),
(226293, '3.80.10.10-FF-003592', NULL, 'Uncharacterized protein', 131, NULL, NULL, 226293),
(226294, '1.20.1070.10-FF-001358', NULL, 'Uncharacterized protein', 333, NULL, NULL, 226294),
(226295, '1.10.510.10-FF-002413', NULL, 'Protein kinase family protein', 254, NULL, NULL, 226295),
(226296, '1.25.40.20-FF-000671', NULL, 'Serine/threonine-protein phosphatase 6 regulatory ankyrin repeat subunit A', 127, NULL, NULL, 226296),
(226297, '1.10.730.10-FF-000007', NULL, 'Valine--tRNA ligase', 240, NULL, NULL, 226297),
(226298, '1.10.150.20-FF-000050', NULL, 'DNA repair protein UVH3', 58, NULL, NULL, 226298),
(226299, '3.40.1000.50-FF-000016', NULL, 'Uncharacterized protein', 183, NULL, NULL, 226299),
(226300, '1.20.1070.10-FF-001066', NULL, 'G protein-coupled receptor', 330, NULL, NULL, 226300),
(226301, '3.40.50.2300-FF-001594', NULL, NULL, 115, NULL, NULL, 226301),
(226302, '3.20.20.140-FF-000294', NULL, 'Allantoinase, putative', 451, NULL, NULL, 226302),
(226303, '3.90.480.10-FF-000012', NULL, 'Probable oxidoreductase', 137, NULL, NULL, 226303),
(226304, '1.20.1310.10-FF-000129', NULL, NULL, 124, NULL, NULL, 226304),
(226305, '3.40.50.720-FF-001357', NULL, 'NAD-dependent epimerase', 311, NULL, NULL, 226305),
(226306, '3.10.100.10-FF-000137', NULL, 'Mannose receptor, C type 2', 146, NULL, NULL, 226306),
(226307, '3.30.230.10-FF-000114', NULL, 'Unplaced genomic scaffold supercont1.201, whole genome shotgun sequence', 153, NULL, NULL, 226307),
(226308, '3.40.30.10-FF-000868', NULL, 'Thioredoxin', 101, NULL, NULL, 226308),
(226309, '2.60.120.620-FF-000108', NULL, 'Uncharacterized protein', 176, NULL, NULL, 226309),
(226310, '3.10.20.90-FF-000842', NULL, 'Uncharacterized protein', 89, NULL, NULL, 226310),
(226311, '3.30.9.10-FF-000286', NULL, 'Uncharacterized protein', 176, NULL, NULL, 226311),
(226312, '1.20.120.770-FF-000005', NULL, NULL, 64, NULL, NULL, 226312),
(226313, '2.10.25.10-FF-001366', NULL, 'LIN-12 protein, putative', 42, NULL, NULL, 226313),
(226314, '1.10.20.10-FF-000205', NULL, NULL, 142, NULL, NULL, 226314),
(226315, '3.40.50.300-FF-008072', NULL, 'Vacuolar sorting protein, putative', 120, NULL, NULL, 226315),
(226316, '1.25.40.10-FF-000033', NULL, 'Lipopolysaccharide assembly protein B', 145, NULL, NULL, 226316),
(226317, '3.30.70.890-FF-000037', NULL, 'Galactokinase-like protein', 195, NULL, NULL, 226317);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(226318, '2.170.270.10-FF-000043', NULL, 'Histone-lysine N-methyltransferase', 237, NULL, NULL, 226318),
(226319, '3.80.10.10-FF-001057', NULL, 'Leucine-rich repeat containing protein', 115, NULL, NULL, 226319),
(226320, '1.10.510.10-FF-000159', NULL, 'Casein kinase I hhp1', 338, NULL, NULL, 226320),
(226321, '3.30.70.870-FF-000031', NULL, 'Elongation factor G, mitochondrial', 74, NULL, NULL, 226321),
(226322, '1.25.10.10-FF-000531', NULL, 'Negative regulator of mitosis', 141, NULL, NULL, 226322),
(226323, '1.20.120.1900-FF-000043', NULL, 'Gamma-tubulin complex component', 311, NULL, NULL, 226323),
(226324, '2.102.10.10-FF-000069', NULL, 'Putative dioxygenase, iron-sulfur subunit', 132, NULL, NULL, 226324),
(226325, '2.60.40.10-FF-002411', NULL, 'Synaptogenesis protein syg-1', 88, NULL, NULL, 226325),
(226326, '3.90.550.10-FF-000541', NULL, 'Slr1063 protein', 237, NULL, NULL, 226326),
(226327, '1.10.3730.20-FF-000077', NULL, 'Uncharacterized protein', 109, NULL, NULL, 226327),
(226328, '2.110.10.10-FF-000080', NULL, 'Hemopexin', 59, NULL, NULL, 226328),
(226329, '3.30.70.1450-FF-000043', NULL, 'Sulfur deprivation response regulator', 76, NULL, NULL, 226329),
(226330, '1.25.40.10-FF-000903', NULL, 'E3 ubiquitin-protein ligase PEP5', 175, NULL, NULL, 226330),
(226331, '1.10.135.10-FF-000017', NULL, 'Uncharacterized protein', 90, NULL, NULL, 226331),
(226332, '3.40.190.290-FF-000004', NULL, 'LysR family transcriptional regulator', 192, NULL, NULL, 226332),
(226333, '2.130.10.10-FF-000814', NULL, 'Embryo sac development arrest 7', 340, NULL, NULL, 226333),
(226334, '2.30.30.40-FF-000341', NULL, 'Nuclear fusion protein FUS1', 80, NULL, NULL, 226334),
(226335, '1.20.5.340-FF-000097', NULL, 'AaceriAGL235Cp', 82, NULL, NULL, 226335),
(226336, '4.10.400.10-FF-000185', NULL, 'Tyrosine-protein kinase receptor', 36, NULL, NULL, 226336),
(226337, '1.10.472.10-FF-000250', NULL, 'Retinoblastoma-like protein A', 232, NULL, NULL, 226337),
(226338, '2.40.10.10-FF-000482', NULL, NULL, 279, NULL, NULL, 226338),
(226339, '3.30.870.10-FF-000117', NULL, 'Phosphatidylcholine-hydrolyzing phospholipase D (PLD) family', 166, NULL, NULL, 226339),
(226340, '1.25.40.20-FF-000906', NULL, 'Uncharacterized protein', 423, NULL, NULL, 226340),
(226341, '2.60.40.10-FF-000157', NULL, 'filamin-C isoform X1', 94, NULL, NULL, 226341),
(226342, '1.20.144.10-FF-000047', NULL, 'GD15030', 282, NULL, NULL, 226342),
(226343, '1.20.1070.10-FF-001049', NULL, 'AGAP008702-PA', 222, NULL, NULL, 226343),
(226344, '3.80.10.10-FF-003827', NULL, 'Uncharacterized protein', 241, NULL, NULL, 226344),
(226345, '2.70.150.10-FF-000119', NULL, 'Cation-transporting ATPase', 233, NULL, NULL, 226345),
(226346, '3.30.70.330-FF-000190', NULL, 'serine/arginine-rich splicing factor 4 isoform X1', 110, NULL, NULL, 226346),
(226347, '1.25.10.10-FF-002122', NULL, 'STE/STE11/CDC15 protein kinase', 201, NULL, NULL, 226347),
(226348, '2.130.10.10-FF-003996', NULL, 'DNA damage-binding protein, putative', 229, NULL, NULL, 226348),
(226349, '2.60.40.10-FF-002927', NULL, NULL, 98, NULL, NULL, 226349),
(226350, '1.10.730.10-FF-000024', NULL, 'Methionine--tRNA ligase cytoplasmic', 171, NULL, NULL, 226350),
(226351, '2.40.50.100-FF-000197', NULL, 'Exosome complex component RRP4', 76, NULL, NULL, 226351),
(226352, '1.20.960.30-FF-000011', NULL, 'Uncharacterized protein', 64, NULL, NULL, 226352),
(226353, '1.10.30.10-FF-000133', NULL, 'Protein CBG16280', 86, NULL, NULL, 226353),
(226354, '1.20.58.60-FF-000121', NULL, 'dystonin isoform X1', 110, NULL, NULL, 226354),
(226355, '3.30.70.470-FF-000001', NULL, 'Methyl-coenzyme M reductase I subunit alpha', 175, NULL, NULL, 226355),
(226356, '1.10.730.20-FF-000027', NULL, 'Uncharacterized protein', 234, NULL, NULL, 226356),
(226357, '1.10.420.10-FF-000023', NULL, 'Peroxidase', 121, NULL, NULL, 226357),
(226358, '3.90.70.10-FF-000571', NULL, 'Uncharacterized protein', 350, NULL, NULL, 226358),
(226359, '3.90.1100.10-FF-000006', NULL, 'DNA-directed RNA polymerase subunit beta', 294, NULL, NULL, 226359),
(226360, '3.10.129.10-FF-000220', NULL, 'Uncharacterized protein', 158, NULL, NULL, 226360);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(226361, '3.40.50.620-FF-000017', NULL, '7-cyano-7-deazaguanine synthase', 219, NULL, NULL, 226361),
(226362, '1.20.1390.10-FF-000005', NULL, 'RNA binding (RRM/RBD/RNP motifs) family protein', 77, NULL, NULL, 226362),
(226363, '3.100.10.10-FF-000020', NULL, 'Ribosomal protein L15', 89, NULL, NULL, 226363),
(226364, '1.25.10.10-FF-000840', NULL, 'Importin beta-3 subunit, putative', 1048, NULL, NULL, 226364),
(226365, '3.30.565.10-FF-000330', NULL, 'Histidine kinase', 156, NULL, NULL, 226365),
(226366, '3.40.50.720-FF-002200', NULL, 'Uncharacterized protein', 316, NULL, NULL, 226366),
(226367, '3.30.420.40-FF-000183', NULL, 'Propionate kinase', 210, NULL, NULL, 226367),
(226368, '3.30.1370.10-FF-000062', NULL, 'vigilin isoform X1', 86, NULL, NULL, 226368),
(226369, '3.30.160.60-FF-004614', NULL, NULL, 48, NULL, NULL, 226369),
(226370, '4.10.960.10-FF-000007', NULL, 'Peroxisome biogenesis protein 6', 23, NULL, NULL, 226370),
(226371, '3.90.76.10-FF-000051', NULL, 'Oligopeptide ABC transporter, periplasmic oligopeptide-binding protein', 43, NULL, NULL, 226371),
(226372, '3.40.50.300-FF-006481', NULL, 'Pleiotropic drug resistance protein 2', 116, NULL, NULL, 226372),
(226373, '1.20.1270.420-FF-000008', NULL, 'Inhibitor of kappa light polypeptide gene enhancer in B-cells, kinase epsilon', 252, NULL, NULL, 226373),
(226374, '2.60.40.10-FF-002618', NULL, 'Beta-D-xylosidase 1', 114, NULL, NULL, 226374),
(226375, '2.10.70.10-FF-000083', NULL, 'Beta-2-glycoprotein 1', 83, NULL, NULL, 226375),
(226376, '1.10.3630.10-FF-000010', NULL, 'Golgi phosphoprotein 3 (coat-protein)', 79, NULL, NULL, 226376),
(226377, '2.40.420.20-FF-000038', NULL, 'Efflux RND transporter periplasmic adaptor subunit', 92, NULL, NULL, 226377),
(226378, '3.40.50.2000-FF-000520', NULL, 'Glycosyltransferase family 1 protein', 142, NULL, NULL, 226378),
(226379, '1.10.155.10-FF-000002', NULL, 'Chemotaxis protein methyltransferase', 80, NULL, NULL, 226379),
(226380, '3.40.190.10-FF-000035', NULL, 'Molybdate ABC transporter substrate-binding protein', 107, NULL, NULL, 226380),
(226381, '3.30.1680.10-FF-000046', NULL, 'Si:ch211-113g11.6', 47, NULL, NULL, 226381),
(226382, '1.20.870.10-FF-000009', NULL, 'RAS guanyl releasing protein 4', 130, NULL, NULL, 226382),
(226383, '3.30.70.330-FF-002090', NULL, NULL, 68, NULL, NULL, 226383),
(226384, '1.25.40.10-FF-000342', NULL, 'Tetratricopeptide repeat domain 21A', 229, NULL, NULL, 226384),
(226385, '1.20.1080.10-FF-000021', NULL, 'Probable aquaporin PIP2-8', 260, NULL, NULL, 226385),
(226386, '2.60.260.20-FF-000122', NULL, 'Heat shock protein', 72, NULL, NULL, 226386),
(226387, '3.90.79.10-FF-000074', NULL, 'Mutt/nudix family protein-like protein', 159, NULL, NULL, 226387),
(226388, '1.10.1450.10-FF-000119', NULL, 'Tetraspanin', 83, NULL, NULL, 226388),
(226389, '3.30.60.30-FF-000208', NULL, 'Uncharacterized protein', 66, NULL, NULL, 226389),
(226390, '1.10.10.2010-FF-000003', NULL, 'Nuclear valosin-containing protein-like', 73, NULL, NULL, 226390),
(226391, '3.40.50.300-FF-007892', NULL, 'Uncharacterized protein', 192, NULL, NULL, 226391),
(226392, '1.10.3720.10-FF-000146', NULL, 'Amino acid ABC transporter', 210, NULL, NULL, 226392),
(226393, '3.90.980.10-FF-000005', NULL, 'DNA primase', 130, NULL, NULL, 226393),
(226394, '1.25.10.10-FF-001020', NULL, 'Heat repeat domain containing protein', 542, NULL, NULL, 226394),
(226395, '3.30.70.330-FF-000010', NULL, 'CUGBP Elav-like family member 4 isoform 3', 94, NULL, NULL, 226395),
(226396, '3.10.450.10-FF-000006', NULL, 'latexin', 125, NULL, NULL, 226396),
(226397, '1.20.1260.10-FF-000001', NULL, 'Non-heme ferritin', 167, NULL, NULL, 226397),
(226398, '2.130.10.10-FF-003687', NULL, 'F-box and WD repeat domain-containing 11', 228, NULL, NULL, 226398),
(226399, '3.30.160.60-FF-002714', NULL, 'Uncharacterized protein', 28, NULL, NULL, 226399),
(226400, '3.80.10.10-FF-003266', NULL, 'Uncharacterized protein', 253, NULL, NULL, 226400),
(226401, '3.30.160.60-FF-003203', NULL, 'Zinc finger protein 715', 31, NULL, NULL, 226401),
(226402, '3.30.710.10-FF-000050', NULL, 'Rho related BTB domain containing 2', 108, NULL, NULL, 226402);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(226403, '2.60.40.60-FF-000239', NULL, 'Starry night, isoform B', 104, NULL, NULL, 226403),
(226404, '3.50.70.10-FF-000011', NULL, 'Chalcone--flavonone isomerase 1', 88, NULL, NULL, 226404),
(226405, '3.40.50.1100-FF-000037', NULL, 'Bifunctional D-cysteine desulfhydrase/1-aminocyclopropane-1-carboxylate deaminase, mitochondrial', 113, NULL, NULL, 226405),
(226406, '3.40.850.10-FF-000035', NULL, 'Kinesin-like protein KIF11', 353, NULL, NULL, 226406),
(226407, '3.40.225.10-FF-000010', NULL, 'Probable bifunctional methylthioribulose-1-phosphate dehydratase/enolase-phosphatase E1', 226, NULL, NULL, 226407),
(226408, '3.40.50.10810-FF-000240', NULL, 'Uncharacterized protein', 196, NULL, NULL, 226408),
(226409, '3.90.226.10-FF-000052', NULL, 'Peroxisomal bifunctional enzyme', 280, NULL, NULL, 226409),
(226410, '3.40.50.300-FF-008381', NULL, 'Uncharacterized protein', 230, NULL, NULL, 226410),
(226411, '3.30.70.1660-FF-000016', NULL, 'Peptide chain release factor 2', 38, NULL, NULL, 226411),
(226412, '2.60.40.10-FF-004518', NULL, NULL, 87, NULL, NULL, 226412),
(226413, '3.40.50.300-FF-002765', NULL, 'ATLastiN (Endoplasmic reticulum GTPase) related', 324, NULL, NULL, 226413),
(226414, '3.50.50.60-FF-000210', NULL, 'lysine-specific histone demethylase 1 homolog 3', 225, NULL, NULL, 226414),
(226415, '1.10.510.10-FF-002930', NULL, NULL, 116, NULL, NULL, 226415),
(226416, '2.60.40.150-FF-000256', NULL, 'Predicted protein', 128, NULL, NULL, 226416),
(226417, '2.180.10.10-FF-000037', NULL, 'Uncharacterized protein', 647, NULL, NULL, 226417),
(226418, '1.20.58.1080-FF-000013', NULL, 'ATP-dependent RNA helicase SUV3, mitochondrial', 118, NULL, NULL, 226418),
(226419, '3.40.50.2000-FF-000211', NULL, 'ADP-heptose:LPS heptosyltransferase II', 148, NULL, NULL, 226419),
(226420, '3.40.50.150-FF-000326', NULL, 'Carnosine N-methyltransferase', 197, NULL, NULL, 226420),
(226421, '1.10.418.10-FF-000006', NULL, 'Filamin-B isoform A', 126, NULL, NULL, 226421),
(226422, '2.160.20.60-FF-000003', NULL, 'Ferredoxin-dependent glutamate synthase, chloroplastic', 276, NULL, NULL, 226422),
(226423, '2.10.25.10-FF-000978', NULL, 'Transmembrane matrix receptor MUP-4', 49, NULL, NULL, 226423),
(226424, '2.60.120.560-FF-000040', NULL, 'Uncharacterized protein', 72, NULL, NULL, 226424),
(226425, '2.40.100.10-FF-000168', NULL, 'Uncharacterized protein', 46, NULL, NULL, 226425),
(226426, '2.60.120.920-FF-000198', NULL, 'Uncharacterized protein', 80, NULL, NULL, 226426),
(226427, '2.10.50.30-FF-000031', NULL, 'Extracellular calcium-sensing receptor', 75, NULL, NULL, 226427),
(226428, '3.40.1380.20-FF-000069', NULL, 'Pyruvate kinase', 138, NULL, NULL, 226428),
(226429, '1.10.150.240-FF-000046', NULL, 'Contig, possible fusion of chromosomes 20 and 34', 96, NULL, NULL, 226429),
(226430, '3.30.360.10-FF-000034', NULL, 'Aspartate-semialdehyde dehydrogenase', 195, NULL, NULL, 226430),
(226431, '1.25.40.10-FF-003776', NULL, 'Pentatricopeptide repeat-containing protein 2, mitochondrial', 155, NULL, NULL, 226431),
(226432, '1.10.10.10-FF-002048', NULL, 'Predicted protein', 55, NULL, NULL, 226432),
(226433, '3.10.20.30-FF-000044', NULL, '(2Fe-2S)-binding domain-containing protein', 85, NULL, NULL, 226433),
(226434, '3.20.20.80-FF-000766', NULL, 'Beta-glucosidase 32', 114, NULL, NULL, 226434),
(226435, '3.20.20.70-FF-000763', NULL, NULL, 49, NULL, NULL, 226435),
(226436, '4.10.830.10-FF-000003', NULL, '30S ribosomal protein S14', 89, NULL, NULL, 226436),
(226437, '1.10.510.10-FF-000261', NULL, 'cyclin-dependent kinase-like 2 isoform X2', 212, NULL, NULL, 226437),
(226438, '1.25.70.10-FF-000085', NULL, NULL, 145, NULL, NULL, 226438),
(226439, '3.40.50.300-FF-006610', NULL, 'Uncharacterized protein', 95, NULL, NULL, 226439),
(226440, '3.40.190.10-FF-000052', NULL, 'Amino acid ABC transporter substrate-binding protein', 96, NULL, NULL, 226440),
(226441, '2.60.40.1180-FF-000219', NULL, 'Alpha-xylosidase XylQ', 92, NULL, NULL, 226441),
(226442, '2.60.40.790-FF-000127', NULL, NULL, 104, NULL, NULL, 226442),
(226443, '1.25.40.540-FF-000030', NULL, 'Uncharacterized protein', 73, NULL, NULL, 226443);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(226444, '3.30.420.40-FF-000621', NULL, 'Cell division protein FtsA', 149, NULL, NULL, 226444),
(226445, '3.90.1420.10-FF-000053', NULL, 'Uncharacterized protein', 95, NULL, NULL, 226445),
(226446, '1.20.1250.20-FF-000779', NULL, 'Phthalate transporter, putative', 84, NULL, NULL, 226446),
(226447, '1.10.8.60-FF-000359', NULL, 'AAA ATPase central domain protein', 77, NULL, NULL, 226447),
(226448, '3.40.50.980-FF-000030', NULL, 'Chondramide synthase cmdD', 176, NULL, NULL, 226448),
(226449, '3.30.700.10-FF-000004', NULL, 'MSHA pilin protein MshC', 150, NULL, NULL, 226449),
(226450, '3.90.1410.10-FF-000125', NULL, 'Predicted protein', 286, NULL, NULL, 226450),
(226451, '3.30.1360.70-FF-000028', NULL, NULL, 110, NULL, NULL, 226451),
(226452, '3.40.640.10-FF-000109', NULL, 'Aminotransferase', 246, NULL, NULL, 226452),
(226453, '1.10.418.20-FF-000009', NULL, 'Sentrin-specific protease 6', 106, NULL, NULL, 226453),
(226454, '2.60.200.20-FF-000146', NULL, 'FHA domain-containing protein', 94, NULL, NULL, 226454),
(226455, '1.10.287.2250-FF-000003', NULL, 'Cathepsin L', 78, NULL, NULL, 226455),
(226456, '3.30.1360.10-FF-000016', NULL, 'DNA-directed RNA polymerases I and III subunit RPAC1', 141, NULL, NULL, 226456),
(226457, '1.10.506.10-FF-000037', NULL, 'GTPase-activating protein isoform X2', 224, NULL, NULL, 226457),
(226458, '3.40.50.1470-FF-000001', NULL, 'Peptidyl-tRNA hydrolase', 193, NULL, NULL, 226458),
(226459, '3.30.70.20-FF-000048', NULL, 'Ferredoxin', 106, NULL, NULL, 226459),
(226460, '2.60.40.60-FF-000256', NULL, 'Starry night, isoform B', 117, NULL, NULL, 226460),
(226461, '3.30.160.60-FF-001888', NULL, 'ras-responsive element-binding protein 1', 53, NULL, NULL, 226461),
(226462, '3.10.180.10-FF-000013', NULL, '4-hydroxyphenylpyruvate dioxygenase', 224, NULL, NULL, 226462),
(226463, '3.10.129.10-FF-000012', NULL, 'Acyl-coenzyme A thioesterase 9, mitochondrial', 148, NULL, NULL, 226463),
(226464, '3.30.200.20-FF-001958', NULL, 'Uncharacterized protein', 129, NULL, NULL, 226464),
(226465, '3.30.710.10-FF-000033', NULL, 'transcription regulator protein BACH2 isoform X1', 131, NULL, NULL, 226465),
(226466, '2.10.25.10-FF-001484', NULL, 'Uncharacterized protein', 38, NULL, NULL, 226466),
(226467, '2.120.10.30-FF-000624', NULL, 'Uncharacterized protein', 155, NULL, NULL, 226467),
(226468, '3.80.10.10-FF-003518', NULL, 'GH16156p', 176, NULL, NULL, 226468),
(226469, '1.20.5.710-FF-000011', NULL, '50S ribosomal protein L7/L12', 51, NULL, NULL, 226469),
(226470, '3.90.550.10-FF-000439', NULL, 'Uncharacterized protein', 203, NULL, NULL, 226470),
(226471, '1.20.1250.20-FF-001504', NULL, 'Putative ERD6-like transporter', 141, NULL, NULL, 226471),
(226472, '3.40.50.1000-FF-000333', NULL, 'Copper-transporting ATPase 2', 117, NULL, NULL, 226472),
(226473, '3.55.50.30-FF-000016', NULL, 'DUF4974 domain-containing protein', 76, NULL, NULL, 226473),
(226474, '3.40.50.10260-FF-000030', NULL, 'EDC3 isoform 7', 97, NULL, NULL, 226474),
(226475, '2.130.10.10-FF-004058', NULL, 'AGAP009027-PA', 211, NULL, NULL, 226475),
(226476, '2.30.29.30-FF-001094', NULL, 'Nos1ap protein', 46, NULL, NULL, 226476),
(226477, '3.30.160.60-FF-003012', NULL, 'Draculin-like 1', 30, NULL, NULL, 226477),
(226478, '2.20.25.530-FF-000007', NULL, 'Uncharacterized protein', 73, NULL, NULL, 226478),
(226479, '3.80.10.10-FF-002001', NULL, 'Predicted protein', 90, NULL, NULL, 226479),
(226480, '2.60.40.10-FF-006082', NULL, NULL, 50, NULL, NULL, 226480),
(226481, '3.40.140.10-FF-000116', NULL, 'Cytidine deaminase, putative', 105, NULL, NULL, 226481),
(226482, '3.40.50.300-FF-002748', NULL, 'Platinum sensitivity', 242, NULL, NULL, 226482),
(226483, '1.10.565.10-FF-000168', NULL, 'Protein CBG01262', 179, NULL, NULL, 226483),
(226484, '2.60.40.4070-FF-000002', NULL, 'Basal-body rod modification protein FlgD', 87, NULL, NULL, 226484),
(226485, '1.10.579.10-FF-000008', NULL, 'Deoxyribodipyrimidine photo-lyase', 88, NULL, NULL, 226485),
(226486, '1.10.10.10-FF-000351', NULL, 'GntR family transcriptional regulator', 69, NULL, NULL, 226486),
(226487, '3.90.70.10-FF-000537', NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', 206, NULL, NULL, 226487);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(226488, '3.40.50.300-FF-004901', NULL, 'RuvB-like helicase', 53, NULL, NULL, 226488),
(226489, '3.30.160.60-FF-001303', NULL, 'Uncharacterized protein', 27, NULL, NULL, 226489),
(226490, '3.90.79.10-FF-000282', NULL, 'Predicted protein', 66, NULL, NULL, 226490),
(226491, '1.20.1020.10-FF-000012', NULL, NULL, 97, NULL, NULL, 226491),
(226492, '3.40.50.720-FF-001374', NULL, 'D-3-phosphoglycerate dehydrogenase', 82, NULL, NULL, 226492),
(226493, '1.10.555.10-FF-000139', NULL, 'Probable inactive serine/threonine-protein kinase DDB_G0293184', 191, NULL, NULL, 226493),
(226494, '1.10.10.480-FF-000009', NULL, 'Probable ATP-dependent 6-phosphofructokinase', 61, NULL, NULL, 226494),
(226495, '2.60.40.10-FF-002282', NULL, 'Titin homolog', 107, NULL, NULL, 226495),
(226496, '2.60.210.10-FF-000071', NULL, NULL, 89, NULL, NULL, 226496),
(226497, '3.30.2330.20-FF-000001', NULL, 'Blood-group-substance endo-1,4-beta-galactosidase', 94, NULL, NULL, 226497),
(226498, '1.20.272.10-FF-000086', NULL, NULL, 51, NULL, NULL, 226498),
(226499, '1.50.40.10-FF-000295', NULL, 'Mitochondrial substrate carrier family protein M', 295, NULL, NULL, 226499),
(226500, '3.30.565.10-FF-000122', NULL, 'Sensor histidine kinase', 147, NULL, NULL, 226500),
(226501, '3.30.160.60-FF-006194', NULL, NULL, 51, NULL, NULL, 226501),
(226502, '3.30.160.60-FF-002495', NULL, 'Zinc finger protein 764', 29, NULL, NULL, 226502),
(226503, '1.25.10.10-FF-002638', NULL, 'Uncharacterized protein', 120, NULL, NULL, 226503),
(226504, '1.25.10.10-FF-000177', NULL, 'Importin beta-like SAD2', 1004, NULL, NULL, 226504),
(226505, '1.10.400.10-FF-000022', NULL, 'Guanine nucleotide-binding protein alpha-8 subunit', 124, NULL, NULL, 226505),
(226506, '2.60.40.60-FF-000902', NULL, 'Uncharacterized protein', 108, NULL, NULL, 226506),
(226507, '3.40.50.300-FF-004356', NULL, 'Oligopeptide/dipeptide ABC transporter, ATPase subunit', 320, NULL, NULL, 226507),
(226508, '1.25.40.10-FF-001786', NULL, 'Os11g0433100 protein', 180, NULL, NULL, 226508),
(226509, '1.10.287.1490-FF-000056', NULL, 'Uncharacterized protein', 140, NULL, NULL, 226509),
(226510, '2.30.29.30-FF-001195', NULL, 'Docking protein 2', 72, NULL, NULL, 226510),
(226511, '3.30.70.1350-FF-000030', NULL, NULL, 84, NULL, NULL, 226511),
(226512, '3.30.40.10-FF-001746', NULL, 'Predicted protein', 92, NULL, NULL, 226512),
(226513, '3.30.1330.30-FF-000094', NULL, 'Uncharacterized protein', 83, NULL, NULL, 226513),
(226514, '1.25.40.20-FF-001789', NULL, 'Uncharacterized protein', 176, NULL, NULL, 226514),
(226515, '3.30.160.60-FF-001989', NULL, 'PR domain zinc finger protein', 53, NULL, NULL, 226515),
(226516, '3.30.200.20-FF-002532', NULL, 'Uncharacterized protein', 37, NULL, NULL, 226516),
(226517, '2.40.30.230-FF-000007', NULL, 'Regulator of nonsense transcripts 1', 93, NULL, NULL, 226517),
(226518, '1.10.510.10-FF-004419', NULL, NULL, 69, NULL, NULL, 226518),
(226519, '3.30.160.60-FF-002506', NULL, 'Rme1p', 88, NULL, NULL, 226519),
(226520, '3.40.50.1480-FF-000004', NULL, 'Adenosylhomocysteinase', 144, NULL, NULL, 226520),
(226521, '3.10.50.40-FF-000127', NULL, 'Peptidylprolyl isomerase', 107, NULL, NULL, 226521),
(226522, '1.10.510.10-FF-002385', NULL, NULL, 92, NULL, NULL, 226522),
(226523, '3.40.50.1240-FF-000163', NULL, NULL, 76, NULL, NULL, 226523),
(226524, '2.130.10.10-FF-002613', NULL, 'Uncharacterized protein', 348, NULL, NULL, 226524),
(226525, '2.60.40.10-FF-000348', NULL, 'Interleukin 20 receptor subunit alpha', 103, NULL, NULL, 226525),
(226526, '3.40.1810.10-FF-000066', NULL, NULL, 63, NULL, NULL, 226526),
(226527, '2.130.10.10-FF-002361', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit TRM82', 160, NULL, NULL, 226527),
(226528, '2.60.40.1180-FF-000118', NULL, 'Alpha-glucosidase', 100, NULL, NULL, 226528),
(226529, '4.10.1240.10-FF-000085', NULL, 'Predicted protein', 63, NULL, NULL, 226529),
(226530, '3.30.70.330-FF-001628', NULL, 'GD17174', 193, NULL, NULL, 226530),
(226531, '2.10.25.10-FF-000877', NULL, 'Crumbs', 72, NULL, NULL, 226531),
(226532, '3.50.50.60-FF-000002', NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', 164, NULL, NULL, 226532);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(226533, '1.20.920.30-FF-000003', NULL, 'Dynein axonemal heavy chain 17', 197, NULL, NULL, 226533),
(226534, '3.30.56.30-FF-000018', NULL, 'Uncharacterized protein', 94, NULL, NULL, 226534),
(226535, '4.10.60.10-FF-000077', NULL, 'Zinc knuckle nucleic acid binding protein, putative', 49, NULL, NULL, 226535),
(226536, '3.30.310.50-FF-000048', NULL, 'Os02g0306250 protein', 56, NULL, NULL, 226536),
(226537, '3.30.200.20-FF-002105', NULL, 'Protein CBG15591', 79, NULL, NULL, 226537),
(226538, '3.40.50.300-FF-004890', NULL, 'GNAS complex locus', 81, NULL, NULL, 226538),
(226539, '3.40.50.1820-FF-001225', NULL, 'Uncharacterized protein', 353, NULL, NULL, 226539),
(226540, '3.80.10.10-FF-001383', NULL, 'Uncharacterized protein', 160, NULL, NULL, 226540),
(226541, '1.20.5.110-FF-000096', NULL, 'QA-SNARE protein putative', 104, NULL, NULL, 226541),
(226542, '2.60.40.150-FF-000508', NULL, 'Protein kinase C-like 1B', 148, NULL, NULL, 226542),
(226543, '1.10.10.10-FF-000704', NULL, 'O-methyltransferase GliM2', 94, NULL, NULL, 226543),
(226544, '2.130.10.10-FF-005795', NULL, 'Predicted protein', 95, NULL, NULL, 226544),
(226545, '3.30.565.10-FF-000431', NULL, 'Probable sensor/response regulator hybrid', 166, NULL, NULL, 226545),
(226546, '1.25.40.10-FF-004720', NULL, 'Superkiller protein 3', 88, NULL, NULL, 226546),
(226547, '3.40.50.300-FF-008408', NULL, 'Uncharacterized protein', 159, NULL, NULL, 226547),
(226548, '2.170.270.10-FF-000161', NULL, 'Uncharacterized protein', 131, NULL, NULL, 226548),
(226549, '3.90.400.10-FF-000018', NULL, 'Uncharacterized protein', 75, NULL, NULL, 226549),
(226550, '2.60.40.10-FF-005946', NULL, NULL, 95, NULL, NULL, 226550),
(226551, '3.40.50.720-FF-001475', NULL, 'Pyrroline-5-carboxylate reductase', 165, NULL, NULL, 226551),
(226552, '3.90.70.10-FF-000436', NULL, 'AGAP001209-PA', 232, NULL, NULL, 226552),
(226553, '1.10.238.10-FF-000560', NULL, 'Centrin, putative', 85, NULL, NULL, 226553),
(226554, '2.130.10.10-FF-000118', NULL, 'Cleavage and polyadenylation specificity factor subunit 1', 397, NULL, NULL, 226554),
(226555, '3.30.2160.10-FF-000035', NULL, 'E3 ubiquitin-protein ligase etc-1', 81, NULL, NULL, 226555),
(226556, '1.10.510.10-FF-002722', NULL, 'TBC domain-containing protein kinase-like protein', 293, NULL, NULL, 226556),
(226557, '2.40.10.10-FF-000611', NULL, NULL, 110, NULL, NULL, 226557),
(226558, '3.30.1680.10-FF-000063', NULL, 'Semaphorin 6ba', 30, NULL, NULL, 226558),
(226559, '1.20.1250.20-FF-001605', NULL, 'YALI0D15488p', 208, NULL, NULL, 226559),
(226560, '3.60.15.10-FF-000080', NULL, 'Ribonuclease Z, mitochondrial', 129, NULL, NULL, 226560),
(226561, '3.90.550.50-FF-000075', NULL, 'Hexosyltransferase', 214, NULL, NULL, 226561),
(226562, '1.25.40.10-FF-004057', NULL, 'Chromosome 10, whole genome shotgun sequence', 167, NULL, NULL, 226562),
(226563, '3.30.420.10-FF-000399', NULL, NULL, 204, NULL, NULL, 226563),
(226564, '1.10.10.10-FF-000660', NULL, 'Heat stress transcription factor A-6b', 98, NULL, NULL, 226564),
(226565, '2.20.70.10-FF-000060', NULL, 'E3 ubiquitin-protein ligase', 39, NULL, NULL, 226565),
(226566, '2.10.25.10-FF-001692', NULL, 'Uncharacterized protein', 43, NULL, NULL, 226566),
(226567, '1.10.600.10-FF-000104', NULL, 'Diterpene cyclase DtcycB', 336, NULL, NULL, 226567),
(226568, '3.60.21.10-FF-000268', NULL, 'Double-strand break repair protein', 202, NULL, NULL, 226568),
(226569, '2.60.40.770-FF-000020', NULL, 'Uncharacterized protein', 135, NULL, NULL, 226569),
(226570, '3.40.50.2000-FF-000897', NULL, 'Glycosyltransferase', 173, NULL, NULL, 226570),
(226571, '3.40.50.300-FF-006346', NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 13', 245, NULL, NULL, 226571),
(226572, '3.40.350.10-FF-000042', NULL, 'Xaa-Pro aminopeptidase 1', 149, NULL, NULL, 226572),
(226573, '3.30.70.330-FF-002016', NULL, NULL, 53, NULL, NULL, 226573),
(226574, '1.25.40.10-FF-002511', NULL, 'TPR_7 domain-containing protein/TPR_11 domain-containing protein/Glyco_transf_41 domain-containing protein', 34, NULL, NULL, 226574),
(226575, '3.30.70.330-FF-002134', NULL, NULL, 102, NULL, NULL, 226575);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(226576, '1.10.10.570-FF-000003', NULL, 'Vacuolar protein-sorting-associated protein 25', 98, NULL, NULL, 226576),
(226577, '3.30.40.10-FF-001393', NULL, 'DnaJ 2', 54, NULL, NULL, 226577),
(226578, '1.20.1070.10-FF-000301', NULL, 'G-protein coupled receptor 157', 298, NULL, NULL, 226578),
(226579, '1.10.238.10-FF-000009', NULL, 'Visinin-like protein 1', 188, NULL, NULL, 226579),
(226580, '2.130.10.10-FF-002260', NULL, 'GM16967', 317, NULL, NULL, 226580),
(226581, '3.40.50.1000-FF-000760', NULL, NULL, 133, NULL, NULL, 226581),
(226582, '1.10.10.60-FF-000096', NULL, 'Zinc finger homeobox protein 4', 65, NULL, NULL, 226582),
(226583, '2.40.37.10-FF-000032', NULL, 'Pyridoxal-dependent decarboxylase, pyridoxal binding domain containing protein', 131, NULL, NULL, 226583),
(226584, '2.120.10.30-FF-000315', NULL, 'Uncharacterized protein', 204, NULL, NULL, 226584),
(226585, '3.30.160.60-FF-003220', NULL, 'E3 ubiquitin-protein ligase TRIM39', 80, NULL, NULL, 226585),
(226586, '3.30.70.330-FF-000425', NULL, 'Transmembrane protein 63A, isoform CRA_a', 105, NULL, NULL, 226586),
(226587, '2.40.160.120-FF-000049', NULL, 'Oxysterol-binding protein 12', 216, NULL, NULL, 226587),
(226588, '1.10.10.580-FF-000006', NULL, 'Cohesin subunit rad21, putative', 68, NULL, NULL, 226588),
(226589, '2.30.30.140-FF-000286', NULL, 'Histone-lysine N-methyltransferase', 136, NULL, NULL, 226589),
(226590, '3.90.1600.10-FF-000050', NULL, 'DNA polymerase', 189, NULL, NULL, 226590),
(226591, '3.90.1490.10-FF-000001', NULL, 'Diphthine--ammonia ligase', 96, NULL, NULL, 226591),
(226592, '3.40.50.300-FF-000950', NULL, 'probable ATP-dependent DNA helicase HFM1', 218, NULL, NULL, 226592),
(226593, '3.40.50.720-FF-001166', NULL, 'Aspergillus niger contig An11c0010, genomic contig', 251, NULL, NULL, 226593),
(226594, '2.60.40.10-FF-002591', NULL, 'Uncharacterized protein, isoform G', 101, NULL, NULL, 226594),
(226595, '2.130.10.10-FF-005486', NULL, 'Uncharacterized protein', 129, NULL, NULL, 226595),
(226596, '3.10.110.10-FF-000065', NULL, 'Ubiquitin-conjugating enzyme E2 E1', 126, NULL, NULL, 226596),
(226597, '3.40.50.300-FF-000287', NULL, 'Multidrug ABC transporter ATP-binding protein', 251, NULL, NULL, 226597),
(226598, '3.40.50.1440-FF-000088', NULL, 'Tubulin gamma-2 chain', 137, NULL, NULL, 226598),
(226599, '3.40.30.10-FF-001150', NULL, 'Uncharacterized protein', 39, NULL, NULL, 226599),
(226600, '1.10.287.110-FF-000361', NULL, 'Zgc:122979', 116, NULL, NULL, 226600),
(226601, '2.60.40.790-FF-000026', NULL, 'Outer dense fiber protein 1', 119, NULL, NULL, 226601),
(226602, '1.10.510.10-FF-000940', NULL, 'Serine/threonine-protein kinase-like protein CCR1', 99, NULL, NULL, 226602),
(226603, '3.20.110.10-FF-000012', NULL, 'Alpha-mannosidase B', 353, NULL, NULL, 226603),
(226604, '3.10.450.10-FF-000023', NULL, 'cathelicidin antimicrobial peptide isoform X1', 112, NULL, NULL, 226604),
(226605, '1.10.3430.10-FF-000012', NULL, 'Rh type C glycoprotein', 439, NULL, NULL, 226605),
(226606, '2.10.25.10-FF-001383', NULL, 'Netrin G1', 84, NULL, NULL, 226606),
(226607, '3.80.10.10-FF-001720', NULL, 'F-box/LRR-repeat protein 12-like', 313, NULL, NULL, 226607),
(226608, '3.30.160.60-FF-005002', NULL, NULL, 37, NULL, NULL, 226608),
(226609, '3.80.10.10-FF-000669', NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', 157, NULL, NULL, 226609),
(226610, '3.40.50.970-FF-000116', NULL, 'Indolepyruvate oxidoreductase subunit IorA', 174, NULL, NULL, 226610),
(226611, '1.20.120.350-FF-000245', NULL, NULL, 123, NULL, NULL, 226611),
(226612, '2.60.40.10-FF-000612', NULL, 'palladin isoform X1', 100, NULL, NULL, 226612),
(226613, '2.70.98.10-FF-000109', NULL, 'Uncharacterized protein', 358, NULL, NULL, 226613),
(226614, '3.40.50.150-FF-001141', NULL, 'At1g33030', 249, NULL, NULL, 226614),
(226615, '2.40.160.120-FF-000050', NULL, 'Uncharacterized protein', 118, NULL, NULL, 226615),
(226616, '2.60.40.1170-FF-000071', NULL, NULL, 113, NULL, NULL, 226616),
(226617, '1.25.40.10-FF-002466', NULL, 'Pentatricopeptide repeat-containing protein At1g71420', 108, NULL, NULL, 226617);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(226618, '3.90.740.10-FF-000050', NULL, 'Uncharacterized protein', 77, NULL, NULL, 226618),
(226619, '2.170.270.10-FF-000060', NULL, 'SET domain containing protein', 110, NULL, NULL, 226619),
(226620, '2.120.10.80-FF-000061', NULL, 'N-acetylneuraminate epimerase', 162, NULL, NULL, 226620),
(226621, '1.20.1070.10-FF-001392', NULL, 'Predicted protein', 243, NULL, NULL, 226621),
(226622, '1.25.10.10-FF-000514', NULL, 'HEAT repeats/HEAT repeat, putative', 587, NULL, NULL, 226622),
(226623, '1.10.1070.11-FF-000024', NULL, 'Serine/threonine-protein kinase ATR', 163, NULL, NULL, 226623),
(226624, '1.10.1410.10-FF-000027', NULL, 'Topoisomerase-related function protein-like protein', 169, NULL, NULL, 226624),
(226625, '3.40.50.1820-FF-001326', NULL, 'Uncharacterized protein', 257, NULL, NULL, 226625),
(226626, '1.20.5.30-FF-000001', NULL, 'matrilin-2 isoform X2', 44, NULL, NULL, 226626),
(226627, '3.80.10.10-FF-000978', NULL, 'Relaxin family peptide receptor 1', 142, NULL, NULL, 226627),
(226628, '2.60.40.1180-FF-000074', NULL, 'Cytoplasmic protein', 105, NULL, NULL, 226628),
(226629, '3.20.20.70-FF-000499', NULL, NULL, 211, NULL, NULL, 226629),
(226630, '2.130.10.10-FF-004159', NULL, 'Uncharacterized protein', 172, NULL, NULL, 226630),
(226631, '3.90.1410.10-FF-000081', NULL, 'Protein-lysine N-methyltransferase', 281, NULL, NULL, 226631),
(226632, '3.30.40.10-FF-001645', NULL, 'Predicted protein', 74, NULL, NULL, 226632),
(226633, '3.40.50.300-FF-002541', NULL, 'DNA replication helicase DNA2', 211, NULL, NULL, 226633),
(226634, '1.10.10.60-FF-000107', NULL, 'MYB transcription factor', 64, NULL, NULL, 226634),
(226635, '1.20.1250.20-FF-001493', NULL, 'Uncharacterized protein', 232, NULL, NULL, 226635),
(226636, '3.30.40.10-FF-001275', NULL, 'Uncharacterized protein', 99, NULL, NULL, 226636),
(226637, '2.70.98.10-FF-000110', NULL, 'Chromosome 21, whole genome shotgun sequence', 306, NULL, NULL, 226637),
(226638, '3.30.505.50-FF-000001', NULL, 'Ribosome hibernation promoting factor', 47, NULL, NULL, 226638),
(226639, '1.10.150.190-FF-000008', NULL, 'Elongation initiation factor 2 alpha subunit,putative', 89, NULL, NULL, 226639),
(226640, '1.25.40.10-FF-000257', NULL, 'anaphase-promoting complex subunit 5 isoform X1', 238, NULL, NULL, 226640),
(226641, '3.30.40.10-FF-001954', NULL, 'Uncharacterized protein', 107, NULL, NULL, 226641),
(226642, '2.80.10.50-FF-000262', NULL, 'Transcription factor cbf12', 135, NULL, NULL, 226642),
(226643, '3.30.230.70-FF-000008', NULL, 'polyribonucleotide nucleotidyltransferase 1, mitochondrial', 226, NULL, NULL, 226643),
(226644, '1.25.40.10-FF-002039', NULL, 'Pentatricopeptide repeat-containing protein At4g13650', 142, NULL, NULL, 226644),
(226645, '3.30.160.60-FF-006093', NULL, NULL, 23, NULL, NULL, 226645),
(226646, '3.10.20.90-FF-000808', NULL, 'Os07g0493033 protein', 36, NULL, NULL, 226646),
(226647, '3.30.1010.10-FF-000041', NULL, 'Putative phosphatidylinositol kinase related protein', 89, NULL, NULL, 226647),
(226648, '3.40.50.300-FF-000495', NULL, 'Fidgetin like 2', 186, NULL, NULL, 226648),
(226649, '1.10.510.10-FF-000367', NULL, 'Serine/threonine protein kinase', 244, NULL, NULL, 226649),
(226650, '1.20.1250.20-FF-001813', NULL, 'Uncharacterized protein', 249, NULL, NULL, 226650),
(226651, '3.40.50.300-FF-001113', NULL, 'ATP-dependent RNA helicase TDRD9', 206, NULL, NULL, 226651),
(226652, '3.90.550.10-FF-000333', NULL, 'Glycosyltransferase', 239, NULL, NULL, 226652),
(226653, '2.60.120.10-FF-000755', NULL, 'Protein CBG00653', 85, NULL, NULL, 226653),
(226654, '3.10.20.90-FF-000707', NULL, 'Uncharacterized protein', 78, NULL, NULL, 226654),
(226655, '1.25.40.10-FF-000241', NULL, 'G-protein-signaling modulator 3 isoform X1', 84, NULL, NULL, 226655),
(226656, '3.40.50.880-FF-000180', NULL, 'Pyridoxal 5''-phosphate synthase subunit PdxT', 199, NULL, NULL, 226656),
(226657, '3.40.50.720-FF-001683', NULL, 'Phosphoglycerate dehydrogenase', 84, NULL, NULL, 226657),
(226658, '3.30.200.20-FF-000323', NULL, 'Mitogen-activated protein kinase', 25, NULL, NULL, 226658),
(226659, '2.130.10.10-FF-002052', NULL, 'general transcription factor 3C polypeptide 2', 170, NULL, NULL, 226659);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(226660, '3.30.60.10-FF-000011', NULL, NULL, 43, NULL, NULL, 226660),
(226661, '3.40.50.720-FF-002301', NULL, 'Uncharacterized protein', 158, NULL, NULL, 226661),
(226662, '1.25.40.10-FF-003894', NULL, 'Pentatricopeptide repeat (PPR) superfamily protein', 76, NULL, NULL, 226662),
(226663, '3.40.525.10-FF-000038', NULL, 'Phosphatidylinositol transfer protein SFH5', 299, NULL, NULL, 226663),
(226664, '3.40.50.720-FF-001727', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', 165, NULL, NULL, 226664),
(226665, '3.40.50.2300-FF-000604', NULL, 'Receptor-type adenylate cyclase GRESAG 4, putative', 146, NULL, NULL, 226665),
(226666, '3.90.70.10-FF-000228', NULL, 'Putative ubiquitin carboxy-terminal hydrolase', 212, NULL, NULL, 226666),
(226667, '3.30.300.330-FF-000001', NULL, 'Alkylglycerone-phosphate synthase', 108, NULL, NULL, 226667),
(226668, '1.10.287.730-FF-000001', NULL, 'Ribosomal RNA small subunit methyltransferase B', 27, NULL, NULL, 226668),
(226669, '1.10.150.20-FF-000151', NULL, 'Transcription termination/antitermination protein NusA', 59, NULL, NULL, 226669),
(226670, '3.30.428.10-FF-000051', NULL, 'HIT-like domain-containing protein', 192, NULL, NULL, 226670),
(226671, '2.120.10.80-FF-000414', NULL, 'Uncharacterized protein', 101, NULL, NULL, 226671),
(226672, '3.40.50.1980-FF-000031', NULL, 'High-affinity heme uptake system protein IsdE', 87, NULL, NULL, 226672),
(226673, '2.70.98.10-FF-000008', NULL, 'Aldose 1-epimerase', 344, NULL, NULL, 226673),
(226674, '3.30.160.60-FF-002815', NULL, 'Zinc finger protein 236 isoform A', 31, NULL, NULL, 226674),
(226675, '3.10.450.50-FF-000074', NULL, 'Uncharacterized protein', 135, NULL, NULL, 226675),
(226676, '3.40.50.1820-FF-001534', NULL, 'Predicted protein', 141, NULL, NULL, 226676),
(226677, '3.30.200.20-FF-002223', NULL, 'Uncharacterized protein', 40, NULL, NULL, 226677),
(226678, '3.40.50.300-FF-008038', NULL, 'Uncharacterized protein', 133, NULL, NULL, 226678),
(226679, '2.60.40.340-FF-000015', NULL, NULL, 185, NULL, NULL, 226679),
(226680, '3.40.50.300-FF-008280', NULL, 'Predicted protein', 35, NULL, NULL, 226680),
(226681, '2.130.10.10-FF-004721', NULL, 'Uncharacterized protein', 167, NULL, NULL, 226681),
(226682, '1.10.510.10-FF-002267', NULL, NULL, 56, NULL, NULL, 226682),
(226683, '1.10.510.10-FF-004066', NULL, NULL, 68, NULL, NULL, 226683),
(226684, '3.30.565.10-FF-000329', NULL, 'Hybrid sensory kinase', 159, NULL, NULL, 226684),
(226685, '3.30.497.10-FF-000031', NULL, 'Putative salivary serpin', 243, NULL, NULL, 226685),
(226686, '2.40.10.10-FF-000347', NULL, 'Uncharacterized protein', 273, NULL, NULL, 226686),
(226687, '1.25.40.10-FF-001994', NULL, 'Pentatricopeptide repeat-containing protein At3g46610', 84, NULL, NULL, 226687),
(226688, '1.10.132.10-FF-000011', NULL, 'DNA topoisomerase I', 193, NULL, NULL, 226688),
(226689, '2.10.25.10-FF-001175', NULL, 'Terribly reduced optic lobes, isoform B', 79, NULL, NULL, 226689),
(226690, '2.60.40.640-FF-000077', NULL, 'Vacuolar protein sorting 26', 153, NULL, NULL, 226690),
(226691, '1.10.30.50-FF-000004', NULL, 'HNH endonuclease', 102, NULL, NULL, 226691),
(226692, '3.30.60.30-FF-000017', NULL, 'Follistatin like 1', 57, NULL, NULL, 226692),
(226693, '3.40.50.300-FF-004238', NULL, 'RecBCD enzyme subunit RecB', 238, NULL, NULL, 226693),
(226694, '2.60.120.260-FF-000163', NULL, 'Predicted protein', 165, NULL, NULL, 226694),
(226695, '2.130.10.10-FF-002922', NULL, 'Protein DECREASED SIZE EXCLUSION LIMIT 1', 282, NULL, NULL, 226695),
(226696, '3.40.50.2300-FF-000503', NULL, 'Transcriptional regulator, LuxR family', 133, NULL, NULL, 226696),
(226697, '1.10.10.10-FF-000912', NULL, 'LysR family transcriptional regulator', 84, NULL, NULL, 226697),
(226698, '1.10.30.40-FF-000001', NULL, 'Ethanolamine ammonia-lyase light chain', 59, NULL, NULL, 226698),
(226699, '3.40.50.720-FF-000401', NULL, 'Related to MTD1-methylenetetrahydrofolate dehydrogenase (NAD+)', 159, NULL, NULL, 226699),
(226700, '2.160.10.10-FF-000072', NULL, 'DEAD-box ATP-dependent RNA helicase 7', 64, NULL, NULL, 226700),
(226701, '3.40.50.1820-FF-001635', NULL, 'Putative phospholipase A2', 427, NULL, NULL, 226701);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(226702, '1.10.238.10-FF-000217', NULL, 'RAS and EF-hand domain containing', 73, NULL, NULL, 226702),
(226703, '3.80.10.10-FF-001793', NULL, 'Os05g0256100 protein', 125, NULL, NULL, 226703),
(226704, '3.30.60.20-FF-000014', NULL, 'Protein kinase C', 69, NULL, NULL, 226704),
(226705, '1.20.1070.10-FF-000987', NULL, 'Uncharacterized protein', 331, NULL, NULL, 226705),
(226706, '1.10.405.10-FF-000027', NULL, 'Rab escort protein 1', 93, NULL, NULL, 226706),
(226707, '2.60.40.1260-FF-000007', NULL, 'Lamin tail domain-containing 2', 113, NULL, NULL, 226707),
(226708, '3.20.20.10-FF-000088', NULL, 'Predicted protein', 153, NULL, NULL, 226708),
(226709, '1.20.1250.20-FF-001914', NULL, 'Sugar transporter, putative', 229, NULL, NULL, 226709),
(226710, '1.10.287.110-FF-000170', NULL, 'Chaperone DnaJ-domain superfamily protein', 87, NULL, NULL, 226710),
(226711, '1.10.472.170-FF-000025', NULL, 'T12H20.13 protein', 171, NULL, NULL, 226711),
(226712, '2.130.10.10-FF-004822', NULL, 'WD40-repeat protein', 138, NULL, NULL, 226712),
(226713, '3.40.30.10-FF-000644', NULL, 'Thioredoxin', 105, NULL, NULL, 226713),
(226714, '3.40.1280.10-FF-000002', NULL, 'Peptidylprolyl isomerase', 154, NULL, NULL, 226714),
(226715, '1.25.10.10-FF-001958', NULL, 'Uncharacterized protein', 256, NULL, NULL, 226715),
(226716, '3.40.50.1000-FF-000349', NULL, 'Haloacid dehalogenase family hydrolase, putative', 163, NULL, NULL, 226716),
(226717, '3.40.50.1000-FF-000097', NULL, 'phosphoethanolamine/phosphocholine phosphatase isoform X2', 218, NULL, NULL, 226717),
(226718, '2.160.20.10-FF-000044', NULL, 'Pectate lyase E', 204, NULL, NULL, 226718),
(226719, '3.90.70.10-FF-000127', NULL, 'Ubiquitin C-terminal hydrolase Ubp8', 327, NULL, NULL, 226719),
(226720, '3.40.366.10-FF-000011', NULL, 'Polyketide synthetase PksP', 178, NULL, NULL, 226720),
(226721, '1.20.1070.10-FF-002010', NULL, 'Si:ch211-132e22.4', 139, NULL, NULL, 226721),
(226722, '2.130.10.10-FF-004367', NULL, 'Uncharacterized protein', 374, NULL, NULL, 226722),
(226723, '2.130.10.10-FF-002467', NULL, 'Small nucleolar ribonucleoprotein complex subunit Dip2, putative (AFU_orthologue AFUA_1G02680)', 288, NULL, NULL, 226723),
(226724, '3.90.190.10-FF-000102', NULL, 'Receptor-type tyrosine-protein phosphatase', 291, NULL, NULL, 226724),
(226725, '2.60.120.200-FF-000061', NULL, 'Laminin subunit alpha 2', 188, NULL, NULL, 226725),
(226726, '1.20.1250.20-FF-001459', NULL, 'Uncharacterized protein', 227, NULL, NULL, 226726),
(226727, '3.40.50.300-FF-006138', NULL, 'Predicted protein', 74, NULL, NULL, 226727),
(226728, '2.10.220.10-FF-000184', NULL, 'Uncharacterized protein', 65, NULL, NULL, 226728),
(226729, '3.50.50.60-FF-000311', NULL, 'Amine oxidase', 90, NULL, NULL, 226729),
(226730, '3.30.2170.10-FF-000007', NULL, 'Endonuclease V', 219, NULL, NULL, 226730),
(226731, '1.10.8.720-FF-000067', NULL, 'Dynein heavy chain family protein', 164, NULL, NULL, 226731),
(226732, '1.10.510.10-FF-004167', NULL, NULL, 181, NULL, NULL, 226732),
(226733, '3.30.1380.20-FF-000037', NULL, 'Transport protein particle (TRAPP) component', 164, NULL, NULL, 226733),
(226734, '3.30.60.20-FF-000104', NULL, 'Rho-associated protein kinase let-502', 59, NULL, NULL, 226734),
(226735, '3.30.530.20-FF-000180', NULL, 'Uncharacterized protein', 104, NULL, NULL, 226735),
(226736, '1.10.3210.10-FF-000029', NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase-like protein', 412, NULL, NULL, 226736),
(226737, '2.80.10.50-FF-000228', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 132, NULL, NULL, 226737),
(226738, '2.60.200.20-FF-000028', NULL, 'FHA domain-containing protein DDL', 135, NULL, NULL, 226738),
(226739, '1.10.10.1730-FF-000003', NULL, 'Folliculin', 46, NULL, NULL, 226739),
(226740, '3.30.40.10-FF-000201', NULL, 'Histone-lysine N-methyltransferase', 64, NULL, NULL, 226740),
(226741, '3.30.559.30-FF-000057', NULL, 'Nonribosomal peptide synthetase fmqA', 245, NULL, NULL, 226741),
(226742, '3.40.1090.10-FF-000111', NULL, 'Predicted protein', 75, NULL, NULL, 226742),
(226743, '2.60.40.10-FF-000803', NULL, 'Complement C4-A', 101, NULL, NULL, 226743);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(226744, '3.90.400.10-FF-000002', NULL, 'Sucrose isomerase', 70, NULL, NULL, 226744),
(226745, '3.10.110.10-FF-000183', NULL, 'Putative ubiquitin-conjugating enzyme E2 25', 194, NULL, NULL, 226745),
(226746, '3.80.10.10-FF-003165', NULL, 'Uncharacterized protein', 277, NULL, NULL, 226746),
(226747, '2.30.30.40-FF-000240', NULL, 'SH3 domain containing 19', 75, NULL, NULL, 226747),
(226748, '1.20.1280.50-FF-000256', NULL, 'Ribonucleoside-diphosphate reductase', 77, NULL, NULL, 226748),
(226749, '2.40.100.10-FF-000062', NULL, 'Peptidyl-prolyl isomerase CWC27', 173, NULL, NULL, 226749),
(226750, '3.30.70.330-FF-000072', NULL, 'heterogeneous nuclear ribonucleoprotein L isoform X1', 105, NULL, NULL, 226750),
(226751, '1.20.1070.10-FF-001493', NULL, 'Uncharacterized protein', 201, NULL, NULL, 226751),
(226752, '1.10.10.1740-FF-000006', NULL, 'Protein FATTY ACID EXPORT 3, chloroplastic', 123, NULL, NULL, 226752),
(226753, '2.60.200.10-FF-000025', NULL, 'Interferon regulatory factor 3', 101, NULL, NULL, 226753),
(226754, '2.10.90.10-FF-000067', NULL, 'Prothoracicotropic hormone, isoform F', 159, NULL, NULL, 226754),
(226755, '1.25.40.10-FF-000151', NULL, 'Aspartyl/asparaginyl beta-hydroxylase', 130, NULL, NULL, 226755),
(226756, '2.60.40.60-FF-000711', NULL, 'Cadherin-4', 100, NULL, NULL, 226756),
(226757, '1.25.40.20-FF-000154', NULL, 'Ankyrin repeat and SOCS box containing 10', 134, NULL, NULL, 226757),
(226758, '3.30.200.20-FF-000071', NULL, 'serine/threonine-protein kinase MAK isoform X1', 83, NULL, NULL, 226758),
(226759, '1.20.1330.10-FF-000013', NULL, 'Flagellar hook-associated protein FlgL', 206, NULL, NULL, 226759),
(226760, '3.40.50.150-FF-000118', NULL, 'Histamine N-methyltransferase', 288, NULL, NULL, 226760),
(226761, '2.170.150.80-FF-000009', NULL, 'NAC domain-containing protein 8', 156, NULL, NULL, 226761),
(226762, '3.30.70.20-FF-000032', NULL, 'Formate dehydrogenase, alpha subunit', 83, NULL, NULL, 226762),
(226763, '3.40.50.300-FF-007684', NULL, 'DNA replication and repair protein RecF', 111, NULL, NULL, 226763),
(226764, '1.10.8.270-FF-000123', NULL, 'RAB GTPase-activating protein, putative', 61, NULL, NULL, 226764),
(226765, '2.130.10.10-FF-003895', NULL, 'Uncharacterized protein', 272, NULL, NULL, 226765),
(226766, '1.20.1250.20-FF-000987', NULL, 'Protein CBG22168', 384, NULL, NULL, 226766),
(226767, '2.60.40.150-FF-000402', NULL, 'Uncharacterized protein', 137, NULL, NULL, 226767),
(226768, '3.40.50.300-FF-002647', NULL, 'ATP-dependent helicase', 149, NULL, NULL, 226768),
(226769, '2.60.40.1510-FF-000010', NULL, 'Integrin beta', 109, NULL, NULL, 226769),
(226770, '2.170.120.12-FF-000040', NULL, 'Uncharacterized protein', 56, NULL, NULL, 226770),
(226771, '1.10.3470.10-FF-000020', NULL, 'Manganese ABC transporter permease protein', 279, NULL, NULL, 226771),
(226772, '3.30.70.580-FF-000051', NULL, 'tRNA pseudouridine synthase A', 106, NULL, NULL, 226772),
(226773, '2.60.40.150-FF-000290', NULL, 'Domain_of_uncharacterized_function_(DUF3451)_-_pu tative', 139, NULL, NULL, 226773),
(226774, '1.10.150.20-FF-000241', NULL, 'DNA polymerase nu', 64, NULL, NULL, 226774),
(226775, '1.10.730.10-FF-000142', NULL, 'AGAP004708-PA', 133, NULL, NULL, 226775),
(226776, '1.10.10.60-FF-000450', NULL, 'Homeobox protein notochord', 67, NULL, NULL, 226776),
(226777, '2.30.29.30-FF-000121', NULL, 'T cell lymphoma invasion and metastasis 1', 161, NULL, NULL, 226777),
(226778, '2.20.70.10-FF-000104', NULL, 'Uncharacterized protein, isoform B', 74, NULL, NULL, 226778),
(226779, '1.20.1280.20-FF-000005', NULL, 'Co-chaperone protein HscB homolog', 93, NULL, NULL, 226779),
(226780, '3.40.50.12240-FF-000005', NULL, 'ATP synthase F1 subunit alpha', 73, NULL, NULL, 226780),
(226781, '2.60.40.10-FF-000039', NULL, 'Unc-5 netrin receptor C', 92, NULL, NULL, 226781),
(226782, '1.10.1070.11-FF-000125', NULL, 'Uncharacterized protein', 138, NULL, NULL, 226782),
(226783, '3.90.920.10-FF-000013', NULL, 'DNA primase', 400, NULL, NULL, 226783),
(226784, '3.30.160.60-FF-006446', NULL, NULL, 98, NULL, NULL, 226784),
(226785, '2.30.30.1020-FF-000049', NULL, NULL, 175, NULL, NULL, 226785);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(226786, '3.20.19.10-FF-000017', NULL, 'Aconitase 2, mitochondrial', 137, NULL, NULL, 226786),
(226787, '1.10.246.120-FF-000006', NULL, 'RAB eXchange factor', 109, NULL, NULL, 226787),
(226788, '2.40.30.10-FF-000247', NULL, 'Uncharacterized protein', 122, NULL, NULL, 226788),
(226789, '3.80.10.10-FF-003075', NULL, 'LD08815p', 132, NULL, NULL, 226789),
(226790, '2.120.10.80-FF-000162', NULL, 'Kelch domain-containing protein 10 homolog', 232, NULL, NULL, 226790),
(226791, '1.25.10.10-FF-000059', NULL, 'exportin-7 isoform X2', 408, NULL, NULL, 226791),
(226792, '1.20.810.10-FF-000017', NULL, 'Probable intron-encoded endonuclease bI1', 133, NULL, NULL, 226792),
(226793, '2.130.10.10-FF-000770', NULL, 'E3 ubiquitin ligase complex SCF subunit sconB', 231, NULL, NULL, 226793),
(226794, '3.40.50.1000-FF-000804', NULL, NULL, 139, NULL, NULL, 226794),
(226795, '3.40.630.30-FF-000429', NULL, 'GNAT family N-acetyltransferase', 134, NULL, NULL, 226795),
(226796, '1.10.510.10-FF-004212', NULL, NULL, 215, NULL, NULL, 226796),
(226797, '3.40.190.10-FF-000153', NULL, 'Ionotropic receptor 25a', 62, NULL, NULL, 226797),
(226798, '1.25.10.10-FF-000413', NULL, 'Condensin-2 complex subunit D3', 167, NULL, NULL, 226798),
(226799, '3.40.630.10-FF-000171', NULL, 'Leucine aminopeptidase', 309, NULL, NULL, 226799),
(226800, '3.90.780.10-FF-000024', NULL, 'Uncharacterized metallophosphoesterase YunD', 182, NULL, NULL, 226800),
(226801, '2.40.30.270-FF-000013', NULL, 'UvrD/REP helicase N-terminal domain protein', 96, NULL, NULL, 226801),
(226802, '3.40.50.300-FF-002338', NULL, 'Dynein heavy chain family protein', 147, NULL, NULL, 226802),
(226803, '3.40.50.300-FF-002086', NULL, 'Uncharacterized protein', 223, NULL, NULL, 226803),
(226804, '3.40.50.1580-FF-000034', NULL, '5-methylthioadenosine nucleosidase, S-adenosylhomocysteine nucleosidase', 262, NULL, NULL, 226804),
(226805, '4.10.800.10-FF-000029', NULL, 'Thyroglobulin', 62, NULL, NULL, 226805),
(226806, '1.20.5.190-FF-000063', NULL, 'Growth associated protein 43', 68, NULL, NULL, 226806),
(226807, '1.10.246.130-FF-000009', NULL, 'Gamma-glutamyltranspeptidase', 120, NULL, NULL, 226807),
(226808, '3.30.430.20-FF-000014', NULL, 'Cysteine-rich receptor-like protein kinase 2', 105, NULL, NULL, 226808),
(226809, '1.20.1060.10-FF-000020', NULL, 'Uncharacterized protein', 113, NULL, NULL, 226809),
(226810, '4.10.1000.40-FF-000008', NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', 67, NULL, NULL, 226810),
(226811, '2.30.42.10-FF-000106', NULL, 'Neuroblast differentiation-associated protein AHNAK', 90, NULL, NULL, 226811),
(226812, '3.40.50.150-FF-000427', NULL, 'S-adenosyl-L-methionine-dependent methyltransferase, putative', 350, NULL, NULL, 226812),
(226813, '3.20.20.150-FF-000021', NULL, 'Protein arginine N-methyltransferase', 265, NULL, NULL, 226813),
(226814, '1.25.40.10-FF-000712', NULL, 'Os07g0670000 protein', 108, NULL, NULL, 226814),
(226815, '1.20.1070.10-FF-000678', NULL, 'histamine H2 receptor', 356, NULL, NULL, 226815),
(226816, '1.10.510.10-FF-002621', NULL, NULL, 107, NULL, NULL, 226816),
(226817, '2.40.170.20-FF-000119', NULL, 'Putative ferric aerobactin receptor', 505, NULL, NULL, 226817),
(226818, '1.20.140.150-FF-000032', NULL, 'Claudin domain containing 2', 153, NULL, NULL, 226818),
(226819, '3.80.10.10-FF-001484', NULL, 'EIN3-binding F-box protein 1', 90, NULL, NULL, 226819),
(226820, '3.30.1490.100-FF-000050', NULL, 'DNA repair protein REV1', 76, NULL, NULL, 226820),
(226821, '3.50.7.10-FF-000080', NULL, NULL, 38, NULL, NULL, 226821),
(226822, '1.20.1060.20-FF-000023', NULL, NULL, 109, NULL, NULL, 226822),
(226823, '1.10.620.20-FF-000007', NULL, 'Ribonucleotide reductase small subunit,putative', 302, NULL, NULL, 226823),
(226824, '1.10.510.10-FF-004521', NULL, NULL, 206, NULL, NULL, 226824),
(226825, '3.40.50.300-FF-000186', NULL, 'ATP-binding cassette sub-family B member 7, mitochondrial', 258, NULL, NULL, 226825),
(226826, '2.60.40.150-FF-000609', NULL, 'Uncharacterized protein', 57, NULL, NULL, 226826),
(226827, '3.40.190.10-FF-000462', NULL, 'Probable lipoprotein LpqZ', 124, NULL, NULL, 226827);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(226828, '4.10.1000.30-FF-000005', NULL, 'AGAP004265-PA', 55, NULL, NULL, 226828),
(226829, '2.60.40.10-FF-004390', NULL, NULL, 113, NULL, NULL, 226829),
(226830, '1.25.40.10-FF-002612', NULL, 'Sterile alpha motif domain-containing 9-like', 135, NULL, NULL, 226830),
(226831, '3.30.830.10-FF-000008', NULL, 'Mitochondrial-processing peptidase subunit beta', 218, NULL, NULL, 226831),
(226832, '2.60.40.60-FF-000357', NULL, 'CaDHerin family', 106, NULL, NULL, 226832),
(226833, '1.10.560.10-FF-000106', NULL, 'Uncharacterized protein', 41, NULL, NULL, 226833),
(226834, '1.25.40.20-FF-000715', NULL, 'SH3 and multiple ankyrin repeat domains protein', 131, NULL, NULL, 226834),
(226835, '2.10.25.10-FF-000669', NULL, 'Eyes shut homolog', 44, NULL, NULL, 226835),
(226836, '3.40.50.11610-FF-000013', NULL, 'Uncharacterized protein, isoform B', 159, NULL, NULL, 226836),
(226837, '3.30.1320.10-FF-000008', NULL, '30S ribosomal protein S16', 85, NULL, NULL, 226837),
(226838, '3.30.830.10-FF-000317', NULL, 'Predicted protein', 83, NULL, NULL, 226838),
(226839, '3.40.50.300-FF-004547', NULL, 'Protein CBG05712', 153, NULL, NULL, 226839),
(226840, '3.40.50.1400-FF-000037', NULL, 'Predicted protein', 131, NULL, NULL, 226840),
(226841, '1.10.220.150-FF-000007', NULL, 'Arf-GAP with coiled-coil, ANK repeat and PH domain-containing protein 2', 138, NULL, NULL, 226841),
(226842, '3.90.650.10-FF-000020', NULL, 'Phosphoribosylformylglycinamidine synthase', 173, NULL, NULL, 226842),
(226843, '3.30.420.40-FF-000503', NULL, 'Cell division protein FtsA', 159, NULL, NULL, 226843),
(226844, '3.10.28.10-FF-000050', NULL, 'Orf294', 124, NULL, NULL, 226844),
(226845, '3.10.105.10-FF-000098', NULL, 'Glutathione-binding protein GsiB', 204, NULL, NULL, 226845),
(226846, '2.30.180.10-FF-000018', NULL, 'Stabilin 2', 128, NULL, NULL, 226846),
(226847, '3.90.1150.10-FF-000060', NULL, 'Serine hydroxymethyltransferase', 26, NULL, NULL, 226847),
(226848, '1.10.510.10-FF-000676', NULL, 'serine/threonine-protein kinase 32B isoform X2', 51, NULL, NULL, 226848),
(226849, '1.25.40.10-FF-002921', NULL, 'pre-mRNA-processing factor 39-like', 174, NULL, NULL, 226849),
(226850, '3.30.160.60-FF-002394', NULL, 'Uncharacterized protein', 28, NULL, NULL, 226850),
(226851, '2.40.30.10-FF-000157', NULL, 'Elongation factor G, mitochondrial', 121, NULL, NULL, 226851),
(226852, '2.60.40.380-FF-000010', NULL, 'Uncharacterized protein', 65, NULL, NULL, 226852),
(226853, '2.60.40.60-FF-000666', NULL, 'Cadherin 17', 87, NULL, NULL, 226853),
(226854, '2.10.110.10-FF-000046', NULL, 'LIM/homeobox protein Lhx1', 69, NULL, NULL, 226854),
(226855, '2.40.10.170-FF-000002', NULL, 'ATP synthase subunit beta, chloroplastic', 80, NULL, NULL, 226855),
(226856, '3.40.47.10-FF-000036', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase II chloroplastic', 435, NULL, NULL, 226856),
(226857, '3.40.50.920-FF-000017', NULL, '1-deoxy-D-xylulose-5-phosphate synthase', 134, NULL, NULL, 226857),
(226858, '3.30.200.20-FF-000205', NULL, 'Serine/threonine protein kinase', 153, NULL, NULL, 226858),
(226859, '3.40.1000.10-FF-000027', NULL, 'Uncharacterized protein', 159, NULL, NULL, 226859),
(226860, '3.40.630.30-FF-000278', NULL, 'Uncharacterized protein', 162, NULL, NULL, 226860),
(226861, '2.60.40.10-FF-002719', NULL, 'Type II inositol-1-1,4,5-trisphosphate 5-phosphatase rlated, putative', 128, NULL, NULL, 226861),
(226862, '1.10.418.10-FF-000186', NULL, 'Uncharacterized protein', 119, NULL, NULL, 226862),
(226863, '3.30.420.40-FF-000418', NULL, 'LD21269p', 94, NULL, NULL, 226863),
(226864, '2.40.50.140-FF-000304', NULL, 'Proteasome regulatory ATPase subunit 3', 110, NULL, NULL, 226864),
(226865, '2.10.25.10-FF-001260', NULL, 'FAT atypical cadherin 4', 36, NULL, NULL, 226865),
(226866, '2.110.10.10-FF-000046', NULL, 'Matrix metallopeptidase-21', 81, NULL, NULL, 226866),
(226867, '1.20.272.10-FF-000013', NULL, 'Replication factor C subunit 1', 110, NULL, NULL, 226867),
(226868, '1.20.58.390-FF-000325', NULL, 'Uncharacterized protein', 53, NULL, NULL, 226868),
(226869, '1.10.472.130-FF-000047', NULL, 'Dynein heavy chain family protein', 172, NULL, NULL, 226869); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(226870, '3.10.490.20-FF-000017', NULL, 'Dynein heavy chain, putative', 165, NULL, NULL, 226870),
(226871, '1.10.472.10-FF-000025', NULL, 'Cyclin-dependent kinase 5 activator', 149, NULL, NULL, 226871),
(226872, '3.40.50.720-FF-001609', NULL, 'NmrA-like family domain-containing protein 1', 197, NULL, NULL, 226872),
(226873, '3.40.630.10-FF-000272', NULL, 'Uncharacterized protein', 234, NULL, NULL, 226873),
(226874, '1.10.10.820-FF-000011', NULL, 'Myosin 10A, isoform C', 57, NULL, NULL, 226874),
(226875, '3.40.50.880-FF-000106', NULL, 'Carbamoyl-phosphate synthase, large subunit', 222, NULL, NULL, 226875),
(226876, '3.30.9.90-FF-000012', NULL, 'Uncharacterized protein', 106, NULL, NULL, 226876),
(226877, '1.20.120.230-FF-000063', NULL, 'Catenin alpha-1', 65, NULL, NULL, 226877),
(226878, '3.40.1090.10-FF-000066', NULL, 'Phospholipase A I', 343, NULL, NULL, 226878),
(226879, '1.10.1420.10-FF-000202', NULL, 'Uncharacterized protein', 85, NULL, NULL, 226879),
(226880, '2.40.110.10-FF-000017', NULL, 'Acyl-CoA dehydrogenase', 106, NULL, NULL, 226880),
(226881, '3.40.50.150-FF-000562', NULL, 'Protein-lysine N-methyltransferase EFM4', 233, NULL, NULL, 226881),
(226882, '1.10.110.10-FF-000022', NULL, 'Putative lipid-transfer protein DIR1', 77, NULL, NULL, 226882),
(226883, '3.30.160.60-FF-004193', NULL, NULL, 27, NULL, NULL, 226883),
(226884, '2.40.30.10-FF-000466', NULL, 'Uncharacterized protein', 80, NULL, NULL, 226884),
(226885, '1.20.1250.20-FF-001577', NULL, 'Uncharacterized protein', 360, NULL, NULL, 226885),
(226886, '3.30.230.10-FF-000232', NULL, '28S ribosomal protein S9, mitochondrial-like Protein', 80, NULL, NULL, 226886),
(226887, '3.80.10.10-FF-003182', NULL, 'Predicted protein', 244, NULL, NULL, 226887),
(226888, '3.30.160.60-FF-002585', NULL, 'Zinc finger protein 770', 29, NULL, NULL, 226888),
(226889, '3.10.490.10-FF-000014', NULL, 'Branched-chain alpha-keto acid dehydrogenase', 123, NULL, NULL, 226889),
(226890, '3.60.40.10-FF-000099', NULL, 'Uncharacterized protein', 310, NULL, NULL, 226890),
(226891, '1.20.5.170-FF-000299', NULL, 'Uncharacterized protein', 92, NULL, NULL, 226891),
(226892, '2.130.10.10-FF-003788', NULL, 'Transducin/WD40 repeat-like superfamily protein', 314, NULL, NULL, 226892),
(226893, '3.90.550.50-FF-000221', NULL, 'Hexosyltransferase', 133, NULL, NULL, 226893),
(226894, '3.30.200.20-FF-002341', NULL, NULL, 62, NULL, NULL, 226894),
(226895, '3.40.50.1820-FF-001416', NULL, 'Uncharacterized protein', 201, NULL, NULL, 226895),
(226896, '3.30.160.60-FF-004406', NULL, NULL, 64, NULL, NULL, 226896),
(226897, '3.80.10.10-FF-001574', NULL, 'Leucine-rich repeat and guanylate kinase domain-containing protein', 190, NULL, NULL, 226897),
(226898, '2.60.40.10-FF-001101', NULL, 'Macrophage colony-stimulating factor 1 receptor', 99, NULL, NULL, 226898),
(226899, '1.25.10.10-FF-002554', NULL, 'Uncharacterized protein', 1000, NULL, NULL, 226899),
(226900, '1.20.1250.20-FF-001684', NULL, 'Uncharacterized protein', 155, NULL, NULL, 226900),
(226901, '1.20.1250.20-FF-001049', NULL, 'Solute carrier family 16 member 14', 191, NULL, NULL, 226901),
(226902, '3.30.200.20-FF-000733', NULL, 'Phosphoenolpyruvate carboxylase kinase 1', 91, NULL, NULL, 226902),
(226903, '1.10.510.10-FF-002149', NULL, NULL, 135, NULL, NULL, 226903),
(226904, '2.10.25.10-FF-000787', NULL, 'Slit homolog 1b (Drosophila)', 37, NULL, NULL, 226904),
(226905, '2.130.10.10-FF-004261', NULL, 'Uncharacterized protein', 136, NULL, NULL, 226905),
(226906, '1.20.1070.10-FF-001476', NULL, 'Uncharacterized protein', 208, NULL, NULL, 226906),
(226907, '1.20.120.1080-FF-000095', NULL, 'Uncharacterized protein', 100, NULL, NULL, 226907),
(226908, '1.10.510.10-FF-004285', NULL, NULL, 169, NULL, NULL, 226908),
(226909, '3.10.20.90-FF-000247', NULL, 'Auxin-responsive protein', 97, NULL, NULL, 226909),
(226910, '2.130.10.10-FF-004412', NULL, 'Uncharacterized protein', 369, NULL, NULL, 226910),
(226911, '3.40.50.720-FF-002071', NULL, 'Uncharacterized protein', 151, NULL, NULL, 226911),
(226912, '2.60.120.290-FF-000189', NULL, 'AGAP005526-PA', 119, NULL, NULL, 226912);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(226913, '2.70.130.10-FF-000091', NULL, NULL, 141, NULL, NULL, 226913),
(226914, '3.80.10.10-FF-001248', NULL, 'DNA repair protein rhp7 isoform A', 143, NULL, NULL, 226914),
(226915, '2.130.10.10-FF-004940', NULL, 'Uncharacterized protein', 102, NULL, NULL, 226915),
(226916, '2.30.30.40-FF-000094', NULL, 'SH3 domain-containing kinase-binding protein 1', 88, NULL, NULL, 226916),
(226917, '2.30.29.30-FF-001341', NULL, 'Uncharacterized protein', 39, NULL, NULL, 226917),
(226918, '3.30.160.60-FF-004732', NULL, NULL, 37, NULL, NULL, 226918),
(226919, '3.40.50.300-FF-004811', NULL, 'Sulfate adenylyltransferase subunit 1', 212, NULL, NULL, 226919),
(226920, '1.10.940.10-FF-000034', NULL, 'Uncharacterized protein', 163, NULL, NULL, 226920),
(226921, '1.10.167.10-FF-000035', NULL, 'GD16870', 130, NULL, NULL, 226921),
(226922, '2.10.70.10-FF-000167', NULL, 'Neural EGFL like 2', 34, NULL, NULL, 226922),
(226923, '1.25.40.10-FF-000448', NULL, 'Tetratricopeptide repeat domain 21B', 241, NULL, NULL, 226923),
(226924, '3.40.50.2000-FF-000402', NULL, 'Glycosyltransferase family 4 protein', 183, NULL, NULL, 226924),
(226925, '3.40.640.10-FF-000244', NULL, 'L-cysteine desulfhydrase', 262, NULL, NULL, 226925),
(226926, '1.10.510.10-FF-001210', NULL, 'Serine/threonine protein kinase', 104, NULL, NULL, 226926),
(226927, '1.25.40.10-FF-002382', NULL, 'Pentatricopeptide repeat-containing protein At4g21065', 74, NULL, NULL, 226927),
(226928, '1.10.287.110-FF-000276', NULL, 'Molecular chaperone DnaJ family', 123, NULL, NULL, 226928),
(226929, '1.10.287.440-FF-000004', NULL, 'Bifunctional purine biosynthesis protein PURH', 43, NULL, NULL, 226929),
(226930, '3.40.50.300-FF-000540', NULL, 'probable ATP-dependent RNA helicase DHX34', 179, NULL, NULL, 226930),
(226931, '1.10.10.10-FF-001885', NULL, 'Uncharacterized protein', 32, NULL, NULL, 226931),
(226932, '3.40.30.10-FF-001240', NULL, 'AFR718Wp', 85, NULL, NULL, 226932),
(226933, '3.30.160.60-FF-000707', NULL, 'Putative Krueppel-like factor 1', 23, NULL, NULL, 226933),
(226934, '1.20.1070.10-FF-002100', NULL, 'Uncharacterized protein', 352, NULL, NULL, 226934),
(226935, '3.30.530.20-FF-000073', NULL, 'BnaC09g47310D protein', 160, NULL, NULL, 226935),
(226936, '2.30.30.30-FF-000091', NULL, '40S ribosomal protein S4, X isoform, putative', 71, NULL, NULL, 226936),
(226937, '3.40.50.300-FF-002664', NULL, 'PROBABLE ''COMPONENT LINKED WITH THE ASSEMBLY OF CYTOCHROME'' TRANSPORT TRANSMEMBRANE ATP-BINDING PROTEIN ABC TRANSPORTER CYDC', 218, NULL, NULL, 226937),
(226938, '3.30.260.10-FF-000060', NULL, 'AT04835p', 92, NULL, NULL, 226938),
(226939, '3.10.20.90-FF-000724', NULL, 'Neutrophil cytosolic factor 2', 80, NULL, NULL, 226939),
(226940, '3.40.630.10-FF-000423', NULL, 'Peptidase, M28 family', 291, NULL, NULL, 226940),
(226941, '3.90.1640.10-FF-000024', NULL, 'Inorganic pyrophosphatase', 68, NULL, NULL, 226941),
(226942, '3.40.50.300-FF-007993', NULL, 'Si:dkey-265e15.2', 154, NULL, NULL, 226942),
(226943, '2.60.40.10-FF-005699', NULL, NULL, 61, NULL, NULL, 226943),
(226944, '2.120.10.30-FF-000433', NULL, 'Uncharacterized protein', 134, NULL, NULL, 226944),
(226945, '1.10.472.10-FF-000132', NULL, 'Cyclin E1', 14, NULL, NULL, 226945),
(226946, '1.25.40.10-FF-002702', NULL, 'Predicted protein', 126, NULL, NULL, 226946),
(226947, '2.60.40.60-FF-000447', NULL, 'Cadherin-related tumor suppressor', 102, NULL, NULL, 226947),
(226948, '1.25.40.10-FF-003686', NULL, 'Tetratricopeptide repeat domain 21B', 113, NULL, NULL, 226948),
(226949, '3.40.50.1100-FF-000245', NULL, 'Uncharacterized protein', 32, NULL, NULL, 226949),
(226950, '2.40.50.770-FF-000021', NULL, 'Uncharacterized protein', 168, NULL, NULL, 226950),
(226951, '1.10.10.60-FF-000539', NULL, 'Uncharacterized protein, isoform A', 63, NULL, NULL, 226951),
(226952, '3.40.190.10-FF-000243', NULL, 'Phosphate-binding protein PstS', 119, NULL, NULL, 226952),
(226953, '2.40.50.100-FF-000091', NULL, 'Molybdenum import ATP-binding protein ModC', 74, NULL, NULL, 226953),
(226954, '1.25.10.10-FF-000323', NULL, 'E3 ubiquitin-protein ligase listerin', 195, NULL, NULL, 226954);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(226955, '3.40.190.10-FF-000136', NULL, 'ATP phosphoribosyltransferase', 88, NULL, NULL, 226955),
(226956, '1.25.40.10-FF-004310', NULL, 'Pentatricopeptide repeat-containing protein At4g01400, mitochondrial', 184, NULL, NULL, 226956),
(226957, '1.25.10.10-FF-000430', NULL, 'Coatomer subunit beta', 643, NULL, NULL, 226957),
(226958, '2.130.10.130-FF-000053', NULL, NULL, 142, NULL, NULL, 226958),
(226959, '3.40.50.300-FF-002557', NULL, 'Axonemal dynein heavy chain', 171, NULL, NULL, 226959),
(226960, '1.20.58.760-FF-000020', NULL, 'Mitochondrial ATP-dependent zinc metallopeptidase, putative', 193, NULL, NULL, 226960),
(226961, '1.10.238.10-FF-000088', NULL, 'Calcium uptake protein 1, mitochondrial', 147, NULL, NULL, 226961),
(226962, '3.40.30.10-FF-001133', NULL, 'Uncharacterized protein', 74, NULL, NULL, 226962),
(226963, '1.25.40.480-FF-000011', NULL, 'Fanconi anemia, complementation group E', 70, NULL, NULL, 226963),
(226964, '3.10.450.240-FF-000017', NULL, 'Mitochondrial import inner membrane translocase subunit TIM44', 192, NULL, NULL, 226964),
(226965, '2.130.10.10-FF-002158', NULL, 'Flagellar_Member_5', 195, NULL, NULL, 226965),
(226966, '2.30.30.40-FF-000447', NULL, 'neutrophil cytosolic factor 1 isoform X1', 66, NULL, NULL, 226966),
(226967, '2.120.10.30-FF-000068', NULL, 'NHL repeat-containing protein 2', 137, NULL, NULL, 226967),
(226968, '1.20.140.40-FF-000047', NULL, 'Pectinesterase', 160, NULL, NULL, 226968),
(226969, '2.30.30.30-FF-000102', NULL, 'Elongation factor P', 63, NULL, NULL, 226969),
(226970, '2.130.10.10-FF-000360', NULL, 'DENN domain and WD repeat-containing protein SCD1', 179, NULL, NULL, 226970),
(226971, '3.10.20.90-FF-000617', NULL, 'Ubiquitin carboxyl-terminal hydrolase, putative', 111, NULL, NULL, 226971),
(226972, '2.10.25.10-FF-000894', NULL, 'Predicted protein', 37, NULL, NULL, 226972),
(226973, '3.10.20.230-FF-000002', NULL, 'serine/threonine-protein kinase DCLK2 isoform X1', 91, NULL, NULL, 226973),
(226974, '1.20.1070.10-FF-001583', NULL, 'Uncharacterized protein', 158, NULL, NULL, 226974),
(226975, '3.40.630.30-FF-000648', NULL, 'Putative phosphinothricin acetyltransferase YwnH', 163, NULL, NULL, 226975),
(226976, '2.130.10.10-FF-004631', NULL, 'Protein HIRA', 196, NULL, NULL, 226976),
(226977, '3.40.50.1100-FF-000138', NULL, 'Tryptophan synthase beta chain', 174, NULL, NULL, 226977),
(226978, '3.30.465.10-FF-000030', NULL, 'probable D-lactate dehydrogenase, mitochondrial', 234, NULL, NULL, 226978),
(226979, '3.30.160.60-FF-003889', NULL, NULL, 28, NULL, NULL, 226979),
(226980, '3.10.100.10-FF-000340', NULL, NULL, 207, NULL, NULL, 226980),
(226981, '3.30.160.60-FF-002478', NULL, 'Zinc finger protein 985', 28, NULL, NULL, 226981),
(226982, '1.10.3260.10-FF-000004', NULL, 'DNA ligase', 278, NULL, NULL, 226982),
(226983, '2.60.40.10-FF-000921', NULL, 'sialoadhesin isoform X1', 85, NULL, NULL, 226983),
(226984, '3.30.160.60-FF-000354', NULL, 'C2H2 finger domain-containing protein', 70, NULL, NULL, 226984),
(226985, '3.80.10.10-FF-001467', NULL, 'F-box protein SKIP17', 174, NULL, NULL, 226985),
(226986, '1.20.120.730-FF-000027', NULL, 'Protein transport protein SEC23', 85, NULL, NULL, 226986),
(226987, '3.40.1790.10-FF-000001', NULL, 'Indigoidine synthase A family protein', 306, NULL, NULL, 226987),
(226988, '3.30.60.30-FF-000124', NULL, 'Follistatin-related protein 1', 64, NULL, NULL, 226988),
(226989, '1.25.40.540-FF-000029', NULL, 'Uncharacterized protein', 133, NULL, NULL, 226989),
(226990, '3.10.100.10-FF-000031', NULL, 'macrophage mannose receptor 1', 143, NULL, NULL, 226990),
(226991, '2.60.40.10-FF-003928', NULL, NULL, 107, NULL, NULL, 226991),
(226992, '2.60.40.1660-FF-000021', NULL, 'Sodium/potassium-transporting ATPase subunit beta', 85, NULL, NULL, 226992),
(226993, '1.25.40.20-FF-000570', NULL, 'Glycerophosphocholine phosphodiesterase Gde1, putative', 248, NULL, NULL, 226993),
(226994, '3.40.50.300-FF-004446', NULL, 'DDX6 isoform 2', 151, NULL, NULL, 226994),
(226995, '2.30.30.140-FF-000168', NULL, 'Qin', 72, NULL, NULL, 226995),
(226996, '1.25.40.10-FF-000139', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 115, NULL, NULL, 226996);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(226997, '1.10.238.10-FF-000318', NULL, 'GG16823', 182, NULL, NULL, 226997),
(226998, '3.30.40.10-FF-001836', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 117, NULL, NULL, 226998),
(226999, '3.80.10.10-FF-003491', NULL, 'Predicted protein', 200, NULL, NULL, 226999),
(227000, '3.40.1110.10-FF-000384', NULL, NULL, 224, NULL, NULL, 227000),
(227001, '3.30.60.20-FF-000121', NULL, 'Probable serine/threonine-protein kinase DDB_G0288147', 58, NULL, NULL, 227001),
(227002, '3.30.830.10-FF-000233', NULL, 'AGR251Cp', 264, NULL, NULL, 227002),
(227003, '3.40.47.10-FF-000300', NULL, NULL, 43, NULL, NULL, 227003),
(227004, '2.30.160.11-FF-000001', NULL, 'G-protein coupled receptor Mth', 63, NULL, NULL, 227004),
(227005, '3.30.70.330-FF-001746', NULL, NULL, 105, NULL, NULL, 227005),
(227006, '3.20.20.100-FF-000040', NULL, 'Putative aldo-keto reductase', 405, NULL, NULL, 227006),
(227007, '2.30.42.10-FF-000213', NULL, 'tax1-binding protein 3 isoform X2', 53, NULL, NULL, 227007),
(227008, '3.30.160.60-FF-004513', NULL, NULL, 35, NULL, NULL, 227008),
(227009, '2.30.29.30-FF-000020', NULL, 'Actin filament-associated protein 1-like 2 isoform 1', 105, NULL, NULL, 227009),
(227010, '3.40.640.10-FF-000025', NULL, 'Histidine decarboxylase', 298, NULL, NULL, 227010),
(227011, '2.40.50.140-FF-000523', NULL, 'DNA ligase', 83, NULL, NULL, 227011),
(227012, '2.130.10.10-FF-001990', NULL, 'Uncharacterized protein', 296, NULL, NULL, 227012),
(227013, '2.170.260.10-FF-000014', NULL, 'AGAP012289-PA', 121, NULL, NULL, 227013),
(227014, '3.30.572.10-FF-000026', NULL, 'Uncharacterized protein', 234, NULL, NULL, 227014),
(227015, '2.60.120.260-FF-000500', NULL, 'Highwire, putative', 84, NULL, NULL, 227015),
(227016, '1.20.1270.60-FF-000197', NULL, 'YALI0B15686p', 172, NULL, NULL, 227016),
(227017, '1.20.120.350-FF-000127', NULL, 'Voltage-dependent L-type calcium channel subunit alpha', 71, NULL, NULL, 227017),
(227018, '2.60.40.60-FF-000812', NULL, 'Putative protocadherin beta-18', 75, NULL, NULL, 227018),
(227019, '3.10.20.590-FF-000003', NULL, 'Leucine-tRNA ligase', 72, NULL, NULL, 227019),
(227020, '3.30.160.60-FF-002259', NULL, 'zinc finger protein 271', 29, NULL, NULL, 227020),
(227021, '2.40.50.140-FF-001069', NULL, NULL, 92, NULL, NULL, 227021),
(227022, '3.40.50.1820-FF-001096', NULL, 'Lipase', 149, NULL, NULL, 227022),
(227023, '3.10.20.90-FF-000926', NULL, 'Meiotically up-regulated gene 70 protein', 81, NULL, NULL, 227023),
(227024, '3.30.200.20-FF-000424', NULL, 'obscurin isoform X5', 84, NULL, NULL, 227024),
(227025, '3.40.140.10-FF-000206', NULL, 'Uncharacterized protein', 165, NULL, NULL, 227025),
(227026, '3.40.50.10990-FF-000012', NULL, '3,4-dihydroxy-2-butanone-4-phoshate synthase/GTP cyclohydrolase II', 152, NULL, NULL, 227026),
(227027, '3.30.70.920-FF-000052', NULL, 'Lrp/AsnC family transcriptional regulator', 71, NULL, NULL, 227027),
(227028, '3.30.200.20-FF-000514', NULL, 'Serine/threonine-protein kinase BUR1', 105, NULL, NULL, 227028),
(227029, '1.10.10.1340-FF-000009', NULL, 'Mediator of RNA polymerase II transcription subunit 31', 92, NULL, NULL, 227029),
(227030, '2.60.40.10-FF-000702', NULL, 'Myotilin', 106, NULL, NULL, 227030),
(227031, '2.30.36.70-FF-000020', NULL, 'Actin-like protein 6A', 49, NULL, NULL, 227031),
(227032, '3.80.10.10-FF-003721', NULL, 'Uncharacterized protein', 272, NULL, NULL, 227032),
(227033, '2.60.40.150-FF-000065', NULL, 'phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit beta', 161, NULL, NULL, 227033),
(227034, '3.20.20.370-FF-000014', NULL, 'Chitin binding Peritrophin-A', 238, NULL, NULL, 227034),
(227035, '4.10.410.10-FF-000039', NULL, 'Protein CBR-MLT-11', 62, NULL, NULL, 227035),
(227036, '3.90.70.10-FF-000655', NULL, 'Predicted protein', 81, NULL, NULL, 227036),
(227037, '3.30.230.10-FF-000013', NULL, 'DNA mismatch repair endonuclease MutL', 112, NULL, NULL, 227037),
(227038, '3.30.1230.20-FF-000010', NULL, '40S ribosomal protein S21', 56, NULL, NULL, 227038),
(227039, '1.10.472.10-FF-000351', NULL, 'Cyclin domain-containing protein, variant 1', 126, NULL, NULL, 227039); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(227040, '1.20.1250.20-FF-001375', NULL, 'Putative MFS-type transporter C09D4.1', 195, NULL, NULL, 227040),
(227041, '1.25.10.10-FF-002228', NULL, 'Uncharacterized protein', 399, NULL, NULL, 227041),
(227042, '2.60.200.20-FF-000264', NULL, 'SMAD/FHA domain protein', 51, NULL, NULL, 227042),
(227043, '1.10.1380.10-FF-000001', NULL, 'endothelin-converting enzyme 2 isoform X1', 355, NULL, NULL, 227043),
(227044, '3.30.1360.10-FF-000033', NULL, 'DNA-directed RNA polymerase II, putative', 122, NULL, NULL, 227044),
(227045, '2.40.30.10-FF-000264', NULL, 'GTP binding protein', 98, NULL, NULL, 227045),
(227046, '1.20.1070.10-FF-001274', NULL, 'Uncharacterized protein', 144, NULL, NULL, 227046),
(227047, '2.60.120.260-FF-000180', NULL, 'SUN domain-containing protein 5', 138, NULL, NULL, 227047),
(227048, '3.90.190.20-FF-000021', NULL, 'UDP-N-acetylmuramoyl-tripeptide--D-alanyl-D-alanine ligase', 141, NULL, NULL, 227048),
(227049, '2.60.40.10-FF-004283', NULL, NULL, 52, NULL, NULL, 227049),
(227050, '3.30.420.40-FF-000727', NULL, 'Uncharacterized protein', 122, NULL, NULL, 227050),
(227051, '1.20.58.920-FF-000001', NULL, 'Histidine kinase', 274, NULL, NULL, 227051),
(227052, '2.60.40.10-FF-002843', NULL, 'Chitinase', 93, NULL, NULL, 227052),
(227053, '1.10.150.20-FF-000134', NULL, 'ImpB/MucB/SamB family protein', 52, NULL, NULL, 227053),
(227054, '3.55.50.30-FF-000033', NULL, 'Putative anti-sigma factor', 77, NULL, NULL, 227054),
(227055, '3.90.550.10-FF-000456', NULL, 'Glycoside transferase family 2', 238, NULL, NULL, 227055),
(227056, '3.90.260.10-FF-000030', NULL, 'DNA repair protein Rad4 homologue, putative', 311, NULL, NULL, 227056),
(227057, '1.10.1420.10-FF-000191', NULL, 'Uncharacterized protein', 196, NULL, NULL, 227057),
(227058, '3.90.70.10-FF-000346', NULL, 'IgG-degrading protease', 143, NULL, NULL, 227058),
(227059, '3.30.70.1560-FF-000003', NULL, 'Pseudouridine synthase', 101, NULL, NULL, 227059),
(227060, '3.40.50.200-FF-000049', NULL, 'Subtilase cytotoxin subunit A', 325, NULL, NULL, 227060),
(227061, '3.40.50.300-FF-003030', NULL, 'Putative DNA replication licensing factor', 384, NULL, NULL, 227061),
(227062, '3.30.70.330-FF-001853', NULL, NULL, 111, NULL, NULL, 227062),
(227063, '2.60.40.150-FF-000374', NULL, 'Phosphatidylinositol-4,5-bisphosphate 3-kinase, putative', 139, NULL, NULL, 227063),
(227064, '3.30.160.60-FF-002276', NULL, 'zinc finger protein 263 isoform X1', 47, NULL, NULL, 227064),
(227065, '3.10.50.30-FF-000006', NULL, 'Nucleoside diphosphate kinase regulator', 76, NULL, NULL, 227065),
(227066, '3.30.40.10-FF-000190', NULL, 'B-cell CLL/lymphoma 9, isoform CRA_a', 46, NULL, NULL, 227066),
(227067, '3.40.640.10-FF-000227', NULL, 'Predicted protein', 215, NULL, NULL, 227067),
(227068, '3.40.50.620-FF-000242', NULL, 'Isoleucine--tRNA ligase', 233, NULL, NULL, 227068),
(227069, '1.20.5.340-FF-000007', NULL, 'Myosin heavy chain, non-muscle', 112, NULL, NULL, 227069),
(227070, '1.20.1250.20-FF-001268', NULL, 'Major facilitator superfamily domain containing 3', 284, NULL, NULL, 227070),
(227071, '1.25.40.10-FF-002365', NULL, 'PPR repeat/Pentatricopeptide repeat domain containing protein, putative', 108, NULL, NULL, 227071),
(227072, '1.25.40.20-FF-000816', NULL, 'Ankyrin repeat family protein', 105, NULL, NULL, 227072),
(227073, '2.120.10.30-FF-000214', NULL, 'Uncharacterized protein', 82, NULL, NULL, 227073),
(227074, '2.10.25.10-FF-000568', NULL, 'Fibulin 7', 37, NULL, NULL, 227074),
(227075, '2.40.10.10-FF-000701', NULL, NULL, 104, NULL, NULL, 227075),
(227076, '1.20.120.140-FF-000036', NULL, 'Signal recognition particle protein (Docking protein), probable', 89, NULL, NULL, 227076),
(227077, '3.30.470.30-FF-000003', NULL, 'DNA ligase', 120, NULL, NULL, 227077),
(227078, '3.40.50.150-FF-000871', NULL, 'Ribosomal RNA small subunit methyltransferase A', 194, NULL, NULL, 227078),
(227079, '3.30.2350.10-FF-000061', NULL, 'RNA pseudouridine synthase 2, chloroplastic isoform A', 50, NULL, NULL, 227079),
(227080, '3.30.70.420-FF-000003', NULL, 'L-ascorbate peroxidase 2 cytosolic', 87, NULL, NULL, 227080);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(227081, '2.40.50.100-FF-000225', NULL, 'Gll2840 protein', 67, NULL, NULL, 227081),
(227082, '3.30.160.60-FF-002624', NULL, 'ZNF230 isoform 1', 25, NULL, NULL, 227082),
(227083, '2.40.110.10-FF-000034', NULL, 'Acyl-CoA dehydrogenase FadE24', 106, NULL, NULL, 227083),
(227084, '3.40.50.10810-FF-000015', NULL, 'lymphoid-specific helicase isoform X1', 278, NULL, NULL, 227084),
(227085, '1.20.5.320-FF-000001', NULL, '6-phosphogluconate dehydrogenase, decarboxylating', 34, NULL, NULL, 227085),
(227086, '1.10.510.10-FF-000570', NULL, 'Non-specific serine/threonine protein kinase', 200, NULL, NULL, 227086),
(227087, '2.80.10.50-FF-000037', NULL, 'Fascin', 108, NULL, NULL, 227087),
(227088, '2.70.98.20-FF-000023', NULL, 'Amine oxidase', 99, NULL, NULL, 227088),
(227089, '3.30.2350.20-FF-000064', NULL, NULL, 232, NULL, NULL, 227089),
(227090, '2.80.10.50-FF-000144', NULL, 'Phospholipase A2 receptor 1', 126, NULL, NULL, 227090),
(227091, '3.40.50.300-FF-006239', NULL, 'Uncharacterized protein', 249, NULL, NULL, 227091),
(227092, '1.10.510.10-FF-002514', NULL, NULL, 51, NULL, NULL, 227092),
(227093, '2.30.30.40-FF-000431', NULL, 'Bud emergence protein, putative', 111, NULL, NULL, 227093),
(227094, '3.30.1010.10-FF-000131', NULL, 'Uncharacterized protein', 161, NULL, NULL, 227094),
(227095, '2.20.25.10-FF-000135', NULL, 'Methyltransferase type 11', 59, NULL, NULL, 227095),
(227096, '1.25.40.10-FF-000813', NULL, 'Pentatricopeptide repeat-containing protein', 102, NULL, NULL, 227096),
(227097, '2.70.98.10-FF-000020', NULL, 'Rhamnogalacturonate lyase A', 256, NULL, NULL, 227097),
(227098, '2.60.40.150-FF-000716', NULL, 'Phosphoinositide phospholipase C', 131, NULL, NULL, 227098),
(227099, '3.30.70.1660-FF-000033', NULL, 'Mitochondrial translational release factor 1-like', 76, NULL, NULL, 227099),
(227100, '1.10.8.10-FF-000277', NULL, 'UBA/TS-N domain protein (AFU_orthologue AFUA_5G09630)', 71, NULL, NULL, 227100),
(227101, '1.10.600.10-FF-000020', NULL, 'Phytoene synthase', 288, NULL, NULL, 227101),
(227102, '3.90.1310.10-FF-000033', NULL, 'Cell division protein FtsI [Peptidoglycan synthetase]', 166, NULL, NULL, 227102),
(227103, '3.40.50.10800-FF-000012', NULL, 'Quinolinate synthase A', 128, NULL, NULL, 227103),
(227104, '3.40.50.150-FF-000197', NULL, 'spermine synthase isoform X2', 191, NULL, NULL, 227104),
(227105, '3.40.50.720-FF-002110', NULL, 'Uncharacterized protein', 120, NULL, NULL, 227105),
(227106, '2.60.120.650-FF-000055', NULL, 'Jhd2p', 289, NULL, NULL, 227106),
(227107, '2.20.25.10-FF-000028', NULL, 'Transcription elongation factor A protein 1', 50, NULL, NULL, 227107),
(227108, '2.70.170.10-FF-000121', NULL, 'Predicted protein', 225, NULL, NULL, 227108),
(227109, '3.30.200.20-FF-002122', NULL, 'Uncharacterized protein', 74, NULL, NULL, 227109),
(227110, '1.10.287.70-FF-000758', NULL, 'Protein CBR-SHW-1', 52, NULL, NULL, 227110),
(227111, '1.10.10.10-FF-000334', NULL, 'Heat shock factor protein 2', 101, NULL, NULL, 227111),
(227112, '2.120.10.80-FF-000313', NULL, 'Uncharacterized protein', 175, NULL, NULL, 227112),
(227113, '3.40.50.1980-FF-000132', NULL, 'ABC-type transport system periplasmic substrate-binding protein', 170, NULL, NULL, 227113),
(227114, '3.40.50.300-FF-000394', NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 9', 293, NULL, NULL, 227114),
(227115, '2.60.40.10-FF-001410', NULL, 'Interleukin 18 receptor 1', 109, NULL, NULL, 227115),
(227116, '3.40.50.300-FF-005767', NULL, 'Uncharacterized protein', 110, NULL, NULL, 227116),
(227117, '3.40.50.720-FF-001918', NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', 23, NULL, NULL, 227117),
(227118, '3.50.50.60-FF-000108', NULL, 'Rab proteins geranylgeranyltransferase component A', 94, NULL, NULL, 227118),
(227119, '3.30.160.60-FF-004530', NULL, NULL, 23, NULL, NULL, 227119),
(227120, '3.90.110.10-FF-000002', NULL, 'Malate dehydrogenase', 177, NULL, NULL, 227120),
(227121, '3.30.200.20-FF-001498', NULL, 'Receptor protein-tyrosine kinase', 89, NULL, NULL, 227121),
(227122, '2.60.120.10-FF-000654', NULL, 'Cysteine dioxygenase', 136, NULL, NULL, 227122);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(227123, '3.30.40.140-FF-000003', NULL, 'RING/U-box superfamily protein', 95, NULL, NULL, 227123),
(227124, '2.30.180.10-FF-000119', NULL, NULL, 123, NULL, NULL, 227124),
(227125, '3.40.630.10-FF-000053', NULL, 'glutaminyl-peptide cyclotransferase-like protein', 312, NULL, NULL, 227125),
(227126, '3.40.50.140-FF-000014', NULL, 'DNA topoisomerase', 115, NULL, NULL, 227126),
(227127, '1.20.120.1900-FF-000060', NULL, 'Gamma-tubulin complex component', 229, NULL, NULL, 227127),
(227128, '3.40.50.670-FF-000015', NULL, 'DNA gyrase subunit B', 93, NULL, NULL, 227128),
(227129, '2.60.40.10-FF-005845', NULL, NULL, 104, NULL, NULL, 227129),
(227130, '3.40.50.12780-FF-000010', NULL, 'Long-chain-fatty-acid--CoA ligase 4 isoform X1', 457, NULL, NULL, 227130),
(227131, '1.10.510.10-FF-004313', NULL, NULL, 150, NULL, NULL, 227131),
(227132, '3.40.50.10810-FF-000138', NULL, 'Protein CHROMATIN REMODELING 35', 271, NULL, NULL, 227132),
(227133, '3.80.10.10-FF-002310', NULL, 'Uncharacterized protein', 171, NULL, NULL, 227133),
(227134, '3.40.640.10-FF-000334', NULL, 'Serine-pyruvate aminotransferase', 258, NULL, NULL, 227134),
(227135, '2.60.120.10-FF-000564', NULL, 'Uncharacterized protein', 136, NULL, NULL, 227135),
(227136, '3.10.180.10-FF-000030', NULL, 'Glyoxalase I', 122, NULL, NULL, 227136),
(227137, '1.20.1270.280-FF-000039', NULL, 'Dynein heavy chain 1, cytosolic', 179, NULL, NULL, 227137),
(227138, '2.10.220.10-FF-000049', NULL, 'Proprotein convertase subtilisin/kexin type 5', 71, NULL, NULL, 227138),
(227139, '2.120.10.30-FF-000540', NULL, 'Uncharacterized protein', 100, NULL, NULL, 227139),
(227140, '2.60.40.420-FF-000022', NULL, 'FET5p Multicopper oxidase', 133, NULL, NULL, 227140),
(227141, '3.40.190.10-FF-000271', NULL, 'Arogenate dehydratase/prephenate dehydratase 1', 91, NULL, NULL, 227141),
(227142, '2.40.440.10-FF-000008', NULL, 'L,D-transpeptidase 1', 128, NULL, NULL, 227142),
(227143, '3.10.20.70-FF-000022', NULL, 'Uncharacterized protein', 94, NULL, NULL, 227143),
(227144, '3.40.50.1000-FF-000350', NULL, 'Acyl-CoA dehydrogenase family member 10', 126, NULL, NULL, 227144),
(227145, '1.25.40.10-FF-001893', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 126, NULL, NULL, 227145),
(227146, '3.30.830.10-FF-000216', NULL, 'Uncharacterized protein', 243, NULL, NULL, 227146),
(227147, '1.25.40.10-FF-003995', NULL, 'Clathrin heavy chain 2', 212, NULL, NULL, 227147),
(227148, '3.30.70.1230-FF-000146', NULL, 'Atrial natriuretic peptide receptor, putative', 96, NULL, NULL, 227148),
(227149, '1.20.58.480-FF-000026', NULL, 'Uncharacterized protein', 110, NULL, NULL, 227149),
(227150, '3.40.50.300-FF-002187', NULL, 'AAA family ATPase', 190, NULL, NULL, 227150),
(227151, '1.25.40.20-FF-001896', NULL, 'Molting protein MLT-4', 138, NULL, NULL, 227151),
(227152, '3.40.50.2300-FF-001459', NULL, NULL, 137, NULL, NULL, 227152),
(227153, '3.30.2010.10-FF-000024', NULL, 'Uncharacterized protein', 83, NULL, NULL, 227153),
(227154, '3.40.50.150-FF-000236', NULL, 'S-adenosyl-L-methionine-dependent methyltransferases superfamily protein', 242, NULL, NULL, 227154),
(227155, '1.25.10.10-FF-002431', NULL, 'Predicted protein', 241, NULL, NULL, 227155),
(227156, '2.30.29.30-FF-000958', NULL, 'Putative sorting nexin-29', 111, NULL, NULL, 227156),
(227157, '3.60.15.10-FF-000006', NULL, 'MBL fold metallo-hydrolase', 210, NULL, NULL, 227157),
(227158, '1.10.10.10-FF-000250', NULL, 'transcription factor Spi-B isoform X1', 121, NULL, NULL, 227158),
(227159, '3.30.160.60-FF-005839', NULL, NULL, 38, NULL, NULL, 227159),
(227160, '1.20.1270.10-FF-000098', NULL, 'Heat shock protein 70 homolog lhs1', 120, NULL, NULL, 227160),
(227161, '2.70.150.10-FF-000193', NULL, 'Probable cadmium-transporting ATPase', 121, NULL, NULL, 227161),
(227162, '2.60.120.650-FF-000201', NULL, 'Uncharacterized protein', 209, NULL, NULL, 227162),
(227163, '1.10.510.10-FF-002059', NULL, 'RfeA', 289, NULL, NULL, 227163),
(227164, '2.60.40.150-FF-000172', NULL, 'C2 calcium-dependent domain-containing protein 4C', 121, NULL, NULL, 227164);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(227165, '3.40.720.10-FF-000189', NULL, 'Uncharacterized protein', 289, NULL, NULL, 227165),
(227166, '3.30.300.130-FF-000020', NULL, 'Iron-sulfur cluster carrier protein', 89, NULL, NULL, 227166),
(227167, '2.60.120.10-FF-000671', NULL, 'Cysteine dioxygenase', 104, NULL, NULL, 227167),
(227168, '3.30.530.20-FF-000056', NULL, 'Uncharacterized conserved protein', 153, NULL, NULL, 227168),
(227169, '3.40.50.1820-FF-001079', NULL, 'Hydrolase', 243, NULL, NULL, 227169),
(227170, '3.30.160.60-FF-005497', NULL, NULL, 33, NULL, NULL, 227170),
(227171, '2.130.10.10-FF-005677', NULL, 'Protein kinase, putative', 161, NULL, NULL, 227171),
(227172, '3.40.50.1820-FF-000331', NULL, 'Prolyl endopeptidase', 273, NULL, NULL, 227172),
(227173, '3.30.1640.10-FF-000055', NULL, 'DNA helicase', 100, NULL, NULL, 227173),
(227174, '3.40.50.300-FF-002529', NULL, 'Probable ATP-dependent RNA helicase DDX28', 265, NULL, NULL, 227174),
(227175, '1.20.1110.10-FF-000266', NULL, NULL, 113, NULL, NULL, 227175),
(227176, '3.40.50.300-FF-006700', NULL, 'Uncharacterized protein', 79, NULL, NULL, 227176),
(227177, '3.30.420.150-FF-000007', NULL, 'Retrograde regulation protein 2', 199, NULL, NULL, 227177),
(227178, '3.30.420.140-FF-000004', NULL, 'Transcription elongation factor spt6', 158, NULL, NULL, 227178),
(227179, '2.160.10.10-FF-000100', NULL, 'UDP-3-O-acylglucosamine N-acyltransferase', 208, NULL, NULL, 227179),
(227180, '1.10.3380.10-FF-000058', NULL, 'Helicase', 122, NULL, NULL, 227180),
(227181, '3.30.230.10-FF-000030', NULL, 'PMS1 homolog 1, mismatch repair system component', 130, NULL, NULL, 227181),
(227182, '3.30.565.10-FF-000537', NULL, 'Sensory histidine protein kinase', 158, NULL, NULL, 227182),
(227183, '3.90.550.10-FF-000349', NULL, 'Glycosyl transferase', 246, NULL, NULL, 227183),
(227184, '3.30.200.20-FF-000177', NULL, 'Cysteine-rich receptor-like protein kinase 2', 107, NULL, NULL, 227184),
(227185, '2.160.20.10-FF-000235', NULL, 'Cell surface protein', 223, NULL, NULL, 227185),
(227186, '2.40.50.140-FF-000630', NULL, 'Asparaginyl-tRNA synthetase, mitochondrial', 89, NULL, NULL, 227186),
(227187, '2.130.10.10-FF-002714', NULL, 'Uncharacterized protein', 312, NULL, NULL, 227187),
(227188, '1.20.1250.20-FF-001358', NULL, 'Membrane transporter', 201, NULL, NULL, 227188),
(227189, '3.30.830.10-FF-000126', NULL, 'Clan ME, family M16, insulinase-like metallopeptidase', 186, NULL, NULL, 227189),
(227190, '2.60.40.60-FF-000475', NULL, 'Uncharacterized protein', 116, NULL, NULL, 227190),
(227191, '2.20.70.10-FF-000205', NULL, 'Uncharacterized protein', 40, NULL, NULL, 227191),
(227192, '2.10.25.10-FF-001276', NULL, 'Uncharacterized protein', 46, NULL, NULL, 227192),
(227193, '2.130.10.10-FF-004266', NULL, 'Uncharacterized protein', 135, NULL, NULL, 227193),
(227194, '3.30.160.60-FF-002950', NULL, 'Zinc finger protein 705F', 26, NULL, NULL, 227194),
(227195, '3.40.50.2300-FF-000048', NULL, 'HTH-type transcriptional regulator GalR', 130, NULL, NULL, 227195),
(227196, '1.20.5.780-FF-000009', NULL, 'FXYD domain-containing ion transport regulator', 59, NULL, NULL, 227196),
(227197, '1.10.510.10-FF-002368', NULL, NULL, 175, NULL, NULL, 227197),
(227198, '3.90.190.20-FF-000004', NULL, 'Dihydrofolate synthase/folylpolyglutamate synthase', 140, NULL, NULL, 227198),
(227199, '3.90.190.10-FF-000001', NULL, 'Receptor-type tyrosine-protein phosphatase F isoform A', 293, NULL, NULL, 227199),
(227200, '3.40.50.300-FF-004665', NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', 275, NULL, NULL, 227200),
(227201, '3.40.50.150-FF-001040', NULL, NULL, 149, NULL, NULL, 227201),
(227202, '2.60.40.10-FF-005929', NULL, NULL, 104, NULL, NULL, 227202),
(227203, '3.30.565.10-FF-000228', NULL, 'Sensor histidine kinase', 145, NULL, NULL, 227203),
(227204, '3.30.450.40-FF-000246', NULL, 'Sensory transduction histidine kinase', 222, NULL, NULL, 227204),
(227205, '1.20.1070.10-FF-000402', NULL, 'Uncharacterized protein', 297, NULL, NULL, 227205),
(227206, '1.10.10.60-FF-000197', NULL, 'Homeobox-leucine zipper protein REVOLUTA', 56, NULL, NULL, 227206); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(227207, '2.30.30.40-FF-000650', NULL, 'Tyrosine-protein kinase', 72, NULL, NULL, 227207),
(227208, '3.40.1400.10-FF-000001', NULL, 'Ribose 5-phosphate isomerase B', 150, NULL, NULL, 227208),
(227209, '1.20.58.80-FF-000043', NULL, 'WGS project CABT00000000 data, contig 2.46', 136, NULL, NULL, 227209),
(227210, '1.10.8.1240-FF-000002', NULL, 'Uncharacterized protein, isoform B', 54, NULL, NULL, 227210),
(227211, '2.130.10.10-FF-005896', NULL, 'Uncharacterized protein', 288, NULL, NULL, 227211),
(227212, '3.40.640.10-FF-000008', NULL, 'Lysine decarboxylase, inducible', 310, NULL, NULL, 227212),
(227213, '1.10.472.10-FF-000148', NULL, 'Transcription initiation factor iib, putative', 100, NULL, NULL, 227213),
(227214, '3.40.47.10-FF-000154', NULL, NULL, 205, NULL, NULL, 227214),
(227215, '3.30.559.70-FF-000035', NULL, 'Carnitine acyltransferase, putative', 153, NULL, NULL, 227215),
(227216, '3.40.50.720-FF-000778', NULL, 'NAD binding Rossmann fold oxidoreductase, putative', 158, NULL, NULL, 227216),
(227217, '3.40.50.720-FF-001582', NULL, 'Uncharacterized protein', 239, NULL, NULL, 227217),
(227218, '1.25.40.10-FF-002056', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 121, NULL, NULL, 227218),
(227219, '1.10.20.10-FF-000076', NULL, 'Histone H4', 78, NULL, NULL, 227219),
(227220, '3.40.50.2300-FF-001369', NULL, NULL, 109, NULL, NULL, 227220),
(227221, '1.10.357.150-FF-000001', NULL, 'centromere/kinetochore protein zw10 homolog', 201, NULL, NULL, 227221),
(227222, '2.60.40.150-FF-000391', NULL, 'Phospholipase A2', 126, NULL, NULL, 227222),
(227223, '3.30.230.130-FF-000048', NULL, 'Cullin', 162, NULL, NULL, 227223),
(227224, '3.90.1140.10-FF-000014', NULL, 'U6 snRNA phosphodiesterase, putative', 205, NULL, NULL, 227224),
(227225, '2.60.40.1860-FF-000002', NULL, 'Peptidyl arginine deiminase 3', 119, NULL, NULL, 227225),
(227226, '3.30.519.10-FF-000032', NULL, NULL, 23, NULL, NULL, 227226),
(227227, '3.40.50.2020-FF-000088', NULL, 'Orotate phosphoribosyltransferase', 186, NULL, NULL, 227227),
(227228, '3.10.110.10-FF-000082', NULL, 'ubiquitin-conjugating enzyme E2 A', 118, NULL, NULL, 227228),
(227229, '2.60.40.150-FF-000481', NULL, 'Phosphoinositide-3-kinase, catalytic, alpha polypeptide', 168, NULL, NULL, 227229),
(227230, '1.10.1420.10-FF-000056', NULL, 'MutS homolog 4', 120, NULL, NULL, 227230),
(227231, '3.20.20.140-FF-000378', NULL, 'Ribonuclease P protein component 3', 205, NULL, NULL, 227231),
(227232, '3.40.50.150-FF-000545', NULL, 'Anamorsin homolog', 124, NULL, NULL, 227232),
(227233, '3.30.70.141-FF-000010', NULL, 'Nucleoside diphosphate kinase 7', 141, NULL, NULL, 227233),
(227234, '1.10.10.10-FF-000811', NULL, 'Homoprotocatechuate degradation operon regulator, HpaR', 137, NULL, NULL, 227234),
(227235, '2.130.10.10-FF-002153', NULL, 'Telomerase protein component 1', 216, NULL, NULL, 227235),
(227236, '1.10.530.40-FF-000001', NULL, 'Lysozyme', 165, NULL, NULL, 227236),
(227237, '3.30.160.60-FF-006328', NULL, NULL, 98, NULL, NULL, 227237),
(227238, '2.130.10.10-FF-002804', NULL, 'Uncharacterized protein', 377, NULL, NULL, 227238),
(227239, '3.90.550.50-FF-000002', NULL, 'Hexosyltransferase', 222, NULL, NULL, 227239),
(227240, '3.30.200.20-FF-002431', NULL, 'Uncharacterized protein', 126, NULL, NULL, 227240),
(227241, '3.30.505.10-FF-000085', NULL, 'Transcription elongation factor SPT6', 106, NULL, NULL, 227241),
(227242, '1.25.40.10-FF-003467', NULL, 'Os03g0844000 protein', 103, NULL, NULL, 227242),
(227243, '3.30.500.10-FF-000023', NULL, NULL, 119, NULL, NULL, 227243),
(227244, '2.60.200.20-FF-000129', NULL, 'Type VI secretion system-associated FHA domain protein TagH', 100, NULL, NULL, 227244),
(227245, '1.10.460.10-FF-000031', NULL, 'DNA topoisomerase', 32, NULL, NULL, 227245),
(227246, '3.30.160.60-FF-002405', NULL, 'tRNA dimethylallyltransferase', 44, NULL, NULL, 227246),
(227247, '1.20.120.720-FF-000007', NULL, 'unconventional myosin-XVIIIa isoform X2', 168, NULL, NULL, 227247),
(227248, '3.30.230.70-FF-000115', NULL, 'Uncharacterized protein', 251, NULL, NULL, 227248);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(227249, '2.60.40.10-FF-004760', NULL, NULL, 98, NULL, NULL, 227249),
(227250, '3.30.1610.10-FF-000008', NULL, 'Uncharacterized protein', 147, NULL, NULL, 227250),
(227251, '3.10.100.10-FF-000014', NULL, 'Macrophage mannose receptor 1', 145, NULL, NULL, 227251),
(227252, '3.40.980.10-FF-000039', NULL, 'FAD synthetase', 171, NULL, NULL, 227252),
(227253, '2.40.50.140-FF-000321', NULL, '30S ribosomal protein S1', 86, NULL, NULL, 227253),
(227254, '3.50.50.60-FF-001492', NULL, 'Predicted protein', 41, NULL, NULL, 227254),
(227255, '3.50.4.10-FF-000056', NULL, NULL, 78, NULL, NULL, 227255),
(227256, '3.30.40.10-FF-001499', NULL, 'YALI0B03300p', 77, NULL, NULL, 227256),
(227257, '4.10.320.60-FF-000002', NULL, 'Sulfhydryl oxidase', 43, NULL, NULL, 227257),
(227258, '2.30.42.10-FF-000230', NULL, 'Uncharacterized protein, isoform E', 91, NULL, NULL, 227258),
(227259, '3.30.1040.20-FF-000001', NULL, 'Thiol-activated cytolysin', 50, NULL, NULL, 227259),
(227260, '1.20.120.350-FF-000099', NULL, 'Cation channel sperm associated 4', 116, NULL, NULL, 227260),
(227261, '1.20.1110.10-FF-000047', NULL, 'Calcium-transporting ATPase', 202, NULL, NULL, 227261),
(227262, '1.25.40.990-FF-000041', NULL, 'SAC3/GANP family protein', 219, NULL, NULL, 227262),
(227263, '2.70.150.10-FF-000209', NULL, 'Magnesium-translocating P-type ATPase', 97, NULL, NULL, 227263),
(227264, '2.60.40.1960-FF-000004', NULL, 'Uncharacterized protein', 65, NULL, NULL, 227264),
(227265, '3.40.50.1820-FF-001298', NULL, 'Lipase/esterase', 276, NULL, NULL, 227265),
(227266, '1.10.238.10-FF-000762', NULL, 'Putative calcium-binding protein CML46', 69, NULL, NULL, 227266),
(227267, '2.10.25.10-FF-001602', NULL, 'Uncharacterized protein', 52, NULL, NULL, 227267),
(227268, '1.10.357.50-FF-000033', NULL, 'Predicted protein', 45, NULL, NULL, 227268),
(227269, '2.30.42.10-FF-000123', NULL, 'Na(+)/H(+) exchange regulatory cofactor NHE-RF4', 101, NULL, NULL, 227269),
(227270, '3.70.10.10-FF-000063', NULL, 'DNA polymerase sliding clamp 1', 244, NULL, NULL, 227270),
(227271, '2.30.30.40-FF-000015', NULL, 'Voltage-dependent L-type calcium channel subunit beta-2', 152, NULL, NULL, 227271),
(227272, '1.20.1080.10-FF-000122', NULL, 'Uncharacterized protein', 67, NULL, NULL, 227272),
(227273, '2.30.30.30-FF-000012', NULL, 'Eukaryotic translation initiation factor 5A', 85, NULL, NULL, 227273),
(227274, '1.25.40.20-FF-000586', NULL, 'Predicted protein', 95, NULL, NULL, 227274),
(227275, '3.30.63.20-FF-000009', NULL, 'Uncharacterized protein', 68, NULL, NULL, 227275),
(227276, '1.20.1440.100-FF-000008', NULL, 'Haloacid dehalogenase', 78, NULL, NULL, 227276),
(227277, '1.25.40.70-FF-000028', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit gamma, putative', 179, NULL, NULL, 227277),
(227278, '3.80.10.10-FF-003047', NULL, 'Putative F-box/LRR-repeat protein At4g00320', 333, NULL, NULL, 227278),
(227279, '3.40.1360.10-FF-000065', NULL, 'Meiotic recombination protein SPO11-like Protein', 199, NULL, NULL, 227279),
(227280, '3.40.50.300-FF-005992', NULL, 'DnaA-related protein', 166, NULL, NULL, 227280),
(227281, '3.30.160.60-FF-004058', NULL, NULL, 27, NULL, NULL, 227281),
(227282, '2.40.440.10-FF-000025', NULL, 'ErfK/YbiS/YcfS/YnhG family protein', 127, NULL, NULL, 227282),
(227283, '3.30.2450.30-FF-000001', NULL, 'Purine-rich element binding protein A', 160, NULL, NULL, 227283),
(227284, '2.70.50.70-FF-000001', NULL, 'Glycoside hydrolase family 61', 248, NULL, NULL, 227284),
(227285, '3.30.70.80-FF-000027', NULL, 'Subtilisin-like protease SBT1.6', 82, NULL, NULL, 227285),
(227286, '2.40.30.10-FF-000242', NULL, 'tRNA-specific 2-thiouridylase MnmA', 81, NULL, NULL, 227286),
(227287, '1.25.50.20-FF-000087', NULL, 'Aminopeptidase A, putative', 315, NULL, NULL, 227287),
(227288, '1.10.8.210-FF-000004', NULL, 'Trifunctional enzyme subunit', 60, NULL, NULL, 227288),
(227289, '3.30.160.60-FF-000786', NULL, NULL, 28, NULL, NULL, 227289),
(227290, '3.40.50.720-FF-001273', NULL, 'Glutamate dehydrogenase', 223, NULL, NULL, 227290),
(227291, '3.30.420.40-FF-000076', NULL, 'Actin-related protein 6', 118, NULL, NULL, 227291);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(227292, '1.10.1490.10-FF-000004', NULL, 'DNAation factor, 45kDa, alpha polypeptide, isoform CRA_b', 44, NULL, NULL, 227292),
(227293, '2.10.25.10-FF-001057', NULL, 'Nimrod C3', 42, NULL, NULL, 227293),
(227294, '3.30.70.330-FF-002241', NULL, NULL, 147, NULL, NULL, 227294),
(227295, '2.130.10.10-FF-005587', NULL, 'Predicted protein', 202, NULL, NULL, 227295),
(227296, '2.60.120.260-FF-000045', NULL, 'Reelin', 209, NULL, NULL, 227296),
(227297, '2.60.40.640-FF-000116', NULL, 'Uncharacterized protein', 154, NULL, NULL, 227297),
(227298, '1.20.140.40-FF-000031', NULL, 'Pectin methylesterase2', 171, NULL, NULL, 227298),
(227299, '2.120.10.30-FF-000523', NULL, 'Uncharacterized protein', 159, NULL, NULL, 227299),
(227300, '3.10.100.10-FF-000362', NULL, NULL, 60, NULL, NULL, 227300),
(227301, '3.60.21.10-FF-000066', NULL, 'Purple acid phosphatase 16', 270, NULL, NULL, 227301),
(227302, '3.30.160.60-FF-004529', NULL, NULL, 76, NULL, NULL, 227302),
(227303, '2.50.20.10-FF-000004', NULL, 'Outer membrane lipoprotein carrier protein LolA', 157, NULL, NULL, 227303),
(227304, '1.10.30.10-FF-000026', NULL, 'PMS1 homolog 1, mismatch repair system component', 87, NULL, NULL, 227304),
(227305, '3.40.50.300-FF-000079', NULL, 'probable ATP-dependent RNA helicase DDX17', 248, NULL, NULL, 227305),
(227306, '1.10.510.10-FF-001879', NULL, 'Phosphoinositide 3-kinase regulatory subunit', 129, NULL, NULL, 227306),
(227307, '2.60.120.970-FF-000073', NULL, 'Uncharacterized protein', 118, NULL, NULL, 227307),
(227308, '1.25.10.10-FF-001121', NULL, 'Uncharacterized protein', 1079, NULL, NULL, 227308),
(227309, '2.40.10.120-FF-000021', NULL, 'Genome polyprotein', 100, NULL, NULL, 227309),
(227310, '3.30.160.60-FF-001787', NULL, 'Zinc finger protein 619', 27, NULL, NULL, 227310),
(227311, '3.50.30.60-FF-000001', NULL, 'Murein tetrapeptide carboxypeptidase', 131, NULL, NULL, 227311),
(227312, '3.40.50.1000-FF-000434', NULL, NULL, 52, NULL, NULL, 227312),
(227313, '3.40.449.10-FF-000018', NULL, 'Uncharacterized protein', 95, NULL, NULL, 227313),
(227314, '3.40.50.720-FF-001267', NULL, '2-hydroxy-3-oxopropionate reductase', 177, NULL, NULL, 227314),
(227315, '3.30.1340.10-FF-000009', NULL, 'PTS system nitrogen regulatory IIA component', 82, NULL, NULL, 227315),
(227316, '3.90.79.10-FF-000175', NULL, 'Uncharacterized protein', 125, NULL, NULL, 227316),
(227317, '3.30.420.80-FF-000037', NULL, 'Uncharacterized protein', 134, NULL, NULL, 227317),
(227318, '3.90.175.10-FF-000005', NULL, 'Uncharacterized protein', 101, NULL, NULL, 227318),
(227319, '3.30.830.10-FF-000087', NULL, 'Probable zinc protease PqqL', 245, NULL, NULL, 227319),
(227320, '1.10.357.10-FF-000072', NULL, 'TetR family transcriptional regulator', 151, NULL, NULL, 227320),
(227321, '3.30.63.10-FF-000006', NULL, 'Guanylate kinase', 49, NULL, NULL, 227321),
(227322, '1.10.8.270-FF-000016', NULL, 'TBC1 domain family member 2A', 106, NULL, NULL, 227322),
(227323, '2.10.25.10-FF-001591', NULL, 'Delta-like protein', 41, NULL, NULL, 227323),
(227324, '2.60.40.150-FF-000407', NULL, 'Phosphatidylinositol 3-kinase VPS34', 146, NULL, NULL, 227324),
(227325, '2.60.40.150-FF-000155', NULL, 'extended synaptotagmin-2 isoform X1', 148, NULL, NULL, 227325),
(227326, '3.40.1280.10-FF-000120', NULL, 'rRNA methylase', 154, NULL, NULL, 227326),
(227327, '1.20.58.70-FF-000040', NULL, 'CBN-SYX-2 protein', 119, NULL, NULL, 227327),
(227328, '1.25.10.10-FF-002902', NULL, 'Protein CBR-PPFR-1', 134, NULL, NULL, 227328),
(227329, '2.30.22.10-FF-000015', NULL, 'Protein GrpE', 62, NULL, NULL, 227329),
(227330, '3.30.450.40-FF-000224', NULL, 'Two-component signal transduction', 187, NULL, NULL, 227330),
(227331, '3.30.450.20-FF-000105', NULL, 'Uncharacterized protein, isoform A', 142, NULL, NULL, 227331),
(227332, '3.10.20.90-FF-000578', NULL, 'Ubiquitin C', 23, NULL, NULL, 227332),
(227333, '2.60.40.10-FF-000718', NULL, 'Tyrosine-protein kinase receptor', 129, NULL, NULL, 227333),
(227334, '3.40.120.10-FF-000115', NULL, 'LOC100170455 protein', 137, NULL, NULL, 227334),
(227335, '2.10.110.10-FF-000041', NULL, 'LIM and calponin homology domains 1', 83, NULL, NULL, 227335);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(227336, '2.60.40.60-FF-000582', NULL, 'Desmocollin 2 like', 81, NULL, NULL, 227336),
(227337, '2.40.70.10-FF-000351', NULL, NULL, 150, NULL, NULL, 227337),
(227338, '3.30.530.20-FF-000163', NULL, 'Uncharacterized protein', 136, NULL, NULL, 227338),
(227339, '1.10.533.10-FF-000302', NULL, 'Uncharacterized protein', 67, NULL, NULL, 227339),
(227340, '2.60.40.4160-FF-000001', NULL, 'Protein interacting with hsp90', 81, NULL, NULL, 227340),
(227341, '3.30.200.20-FF-001588', NULL, 'Uncharacterized protein', 95, NULL, NULL, 227341),
(227342, '1.10.560.10-FF-000090', NULL, 'Uncharacterized protein', 118, NULL, NULL, 227342),
(227343, '2.20.70.10-FF-000211', NULL, 'Uncharacterized protein', 31, NULL, NULL, 227343),
(227344, '1.50.40.10-FF-000497', NULL, 'Predicted protein', 271, NULL, NULL, 227344),
(227345, '2.130.10.10-FF-003878', NULL, 'Semaphorin 7a', 279, NULL, NULL, 227345),
(227346, '3.40.50.2020-FF-000066', NULL, 'Ribose-phosphate pyrophosphokinase 2', 141, NULL, NULL, 227346),
(227347, '3.30.70.330-FF-000307', NULL, 'RNA-binding motif protein 12', 82, NULL, NULL, 227347),
(227348, '2.40.50.100-FF-000208', NULL, 'Uncharacterized protein', 66, NULL, NULL, 227348),
(227349, '3.40.50.2000-FF-000312', NULL, 'Probable glycosyl transferase', 185, NULL, NULL, 227349),
(227350, '1.20.1420.30-FF-000104', NULL, 'Uncharacterized protein', 149, NULL, NULL, 227350),
(227351, '3.40.50.10810-FF-000032', NULL, 'Helicase ARIP4', 322, NULL, NULL, 227351),
(227352, '3.50.50.60-FF-001519', NULL, 'Uncharacterized protein', 150, NULL, NULL, 227352),
(227353, '3.40.50.300-FF-002333', NULL, 'Deoxycytidylate deaminase, putative', 178, NULL, NULL, 227353),
(227354, '3.40.50.720-FF-001812', NULL, 'Slr1617 protein', 282, NULL, NULL, 227354),
(227355, '3.40.50.300-FF-004463', NULL, 'Bile salt export pump', 15, NULL, NULL, 227355),
(227356, '1.10.1450.10-FF-000029', NULL, 'Tetraspanin', 101, NULL, NULL, 227356),
(227357, '3.30.160.60-FF-002933', NULL, NULL, 28, NULL, NULL, 227357),
(227358, '1.10.760.10-FF-000071', NULL, 'Cytochrome C peroxidase', 193, NULL, NULL, 227358),
(227359, '1.10.238.10-FF-000234', NULL, 'Protein BM-40', 125, NULL, NULL, 227359),
(227360, '3.40.50.1240-FF-000056', NULL, 'Metal-independent phosphoserine phosphatase', 212, NULL, NULL, 227360),
(227361, '3.30.70.330-FF-000111', NULL, 'U2 snRNP auxiliary factor large subunit', 115, NULL, NULL, 227361),
(227362, '3.30.300.130-FF-000014', NULL, 'Unplaced genomic scaffold supercont1.16, whole genome shotgun sequence', 93, NULL, NULL, 227362),
(227363, '2.130.10.10-FF-001989', NULL, 'Protein cortex', 343, NULL, NULL, 227363),
(227364, '3.40.50.2000-FF-000060', NULL, 'Glycosyltransferase', 190, NULL, NULL, 227364),
(227365, '1.10.600.10-FF-000003', NULL, 'Farnesyl-diphosphate farnesyltransferase 1', 335, NULL, NULL, 227365),
(227366, '1.20.58.1290-FF-000003', NULL, 'Transcriptional regulator, CarD family', 98, NULL, NULL, 227366),
(227367, '2.60.40.60-FF-000891', NULL, 'Uncharacterized protein', 115, NULL, NULL, 227367),
(227368, '3.90.550.10-FF-000765', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 395, NULL, NULL, 227368),
(227369, '2.40.30.130-FF-000005', NULL, 'Alanyl-tRNA synthetase 2, mitochondrial', 77, NULL, NULL, 227369),
(227370, '3.30.559.70-FF-000018', NULL, 'Choline O-acetyltransferase', 331, NULL, NULL, 227370),
(227371, '1.10.510.10-FF-000569', NULL, 'Serine/threonine-protein kinase-like protein CCR4', 219, NULL, NULL, 227371),
(227372, '2.40.30.120-FF-000002', NULL, 'Capsid protein', 114, NULL, NULL, 227372),
(227373, '2.10.70.10-FF-000184', NULL, 'Haptoglobin', 39, NULL, NULL, 227373),
(227374, '1.10.3720.10-FF-000231', NULL, 'Amino acid ABC transporter, membrane protein, putative', 215, NULL, NULL, 227374),
(227375, '2.20.80.10-FF-000015', NULL, 'Uncharacterized protein', 93, NULL, NULL, 227375),
(227376, '1.20.1070.10-FF-001403', NULL, 'Leukocyte platelet-activating factor receptor', 236, NULL, NULL, 227376),
(227377, '1.20.5.190-FF-000170', NULL, NULL, 62, NULL, NULL, 227377),
(227378, '2.60.40.10-FF-000573', NULL, 'Cytokine receptor-like factor 3', 97, NULL, NULL, 227378);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(227379, '3.40.30.10-FF-000661', NULL, 'Glutathione peroxidase', 163, NULL, NULL, 227379),
(227380, '3.40.50.300-FF-008482', NULL, 'ATP binding cassette subfamily C member 8', 187, NULL, NULL, 227380),
(227381, '1.10.238.200-FF-000007', NULL, 'Defective in cullin neddylation protein', 104, NULL, NULL, 227381),
(227382, '3.40.47.10-FF-000171', NULL, NULL, 195, NULL, NULL, 227382),
(227383, '3.30.1120.30-FF-000010', NULL, 'Serine/threonine-protein kinase', 68, NULL, NULL, 227383),
(227384, '2.130.10.10-FF-002136', NULL, 'GD23699', 138, NULL, NULL, 227384),
(227385, '3.30.497.10-FF-000036', NULL, 'Serpin peptidase inhibitor 31', 219, NULL, NULL, 227385),
(227386, '2.70.130.10-FF-000118', NULL, NULL, 173, NULL, NULL, 227386),
(227387, '3.30.160.810-FF-000005', NULL, '50S ribosomal protein L3', 69, NULL, NULL, 227387),
(227388, '1.10.510.10-FF-002604', NULL, NULL, 170, NULL, NULL, 227388),
(227389, '1.10.1450.10-FF-000136', NULL, 'Uncharacterized protein', 97, NULL, NULL, 227389),
(227390, '3.30.70.330-FF-001527', NULL, 'Modulo, isoform C', 69, NULL, NULL, 227390),
(227391, '1.20.1070.10-FF-001931', NULL, 'Vomeronasal type-1 receptor', 278, NULL, NULL, 227391),
(227392, '3.40.630.30-FF-000194', NULL, 'Acetyltransferase Pat', 188, NULL, NULL, 227392),
(227393, '1.20.5.110-FF-000197', NULL, 'Protein BET1', 61, NULL, NULL, 227393),
(227394, '3.10.20.90-FF-000163', NULL, 'Rap guanine nucleotide exchange factor (GEF) 5', 115, NULL, NULL, 227394),
(227395, '2.60.40.150-FF-000626', NULL, 'Uncharacterized protein', 142, NULL, NULL, 227395),
(227396, '2.40.50.140-FF-000214', NULL, '30S ribosomal protein S1', 76, NULL, NULL, 227396),
(227397, '1.10.510.10-FF-001986', NULL, 'Kinase-like domain-containing protein', 256, NULL, NULL, 227397),
(227398, '2.60.120.10-FF-000199', NULL, 'Unplaced genomic scaffold supercont1.257, whole genome shotgun sequence', 94, NULL, NULL, 227398),
(227399, '1.20.200.10-FF-000004', NULL, 'Adenylosuccinate lyase', 267, NULL, NULL, 227399),
(227400, '1.10.510.10-FF-003211', NULL, NULL, 143, NULL, NULL, 227400),
(227401, '3.10.105.10-FF-000126', NULL, 'Glycine betaine/proline ABC transporter, periplasmic glycine betaine/proline-binding protein', 76, NULL, NULL, 227401),
(227402, '2.60.200.20-FF-000045', NULL, 'Forkhead protein', 118, NULL, NULL, 227402),
(227403, '2.40.70.10-FF-000042', NULL, 'Cathepsin D', 123, NULL, NULL, 227403),
(227404, '3.10.180.10-FF-000114', NULL, 'Uncharacterized protein', 179, NULL, NULL, 227404),
(227405, '2.40.10.10-FF-000375', NULL, NULL, 64, NULL, NULL, 227405),
(227406, '2.60.40.10-FF-004844', NULL, NULL, 112, NULL, NULL, 227406),
(227407, '3.40.50.150-FF-000652', NULL, 'Lovastatin nonaketide synthase, polyketide synthase component', 304, NULL, NULL, 227407),
(227408, '3.30.230.70-FF-000132', NULL, 'Exosomal 3''-5'' exoribonuclease complex, subunit Rrp43, putative', 194, NULL, NULL, 227408),
(227409, '1.25.40.10-FF-003669', NULL, 'TPR Domain containing protein', 359, NULL, NULL, 227409),
(227410, '3.10.110.10-FF-000166', NULL, 'Ubiquitin conjugating enzyme E2 U', 158, NULL, NULL, 227410),
(227411, '2.60.40.10-FF-004316', NULL, NULL, 98, NULL, NULL, 227411),
(227412, '3.80.10.10-FF-001809', NULL, 'GM16316', 246, NULL, NULL, 227412),
(227413, '2.60.260.20-FF-000021', NULL, 'Chaperone protein DnaJ', 103, NULL, NULL, 227413),
(227414, '1.10.510.10-FF-002823', NULL, NULL, 121, NULL, NULL, 227414),
(227415, '3.30.160.60-FF-002731', NULL, 'Zinc finger and BTB domain containing 48', 30, NULL, NULL, 227415),
(227416, '1.10.10.1480-FF-000001', NULL, 'Replication protein RepB', 74, NULL, NULL, 227416),
(227417, '1.10.418.10-FF-000107', NULL, 'M protein repeat protein', 147, NULL, NULL, 227417),
(227418, '3.40.190.290-FF-000105', NULL, 'Probable transcriptional regulator', 205, NULL, NULL, 227418),
(227419, '2.70.150.10-FF-000226', NULL, 'Predicted protein', 159, NULL, NULL, 227419),
(227420, '2.60.120.260-FF-000410', NULL, 'Coagulation factor VIII, procoagulant component', 150, NULL, NULL, 227420),
(227421, '3.30.200.20-FF-001279', NULL, 'Long-flagella protein, kinase, CMGC RCK', 81, NULL, NULL, 227421);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(227422, '1.10.238.10-FF-000649', NULL, 'GD21234', 78, NULL, NULL, 227422),
(227423, '3.80.10.10-FF-001158', NULL, 'Leucine-rich repeat protein kinase family protein', 143, NULL, NULL, 227423),
(227424, '2.60.200.10-FF-000042', NULL, 'Uncharacterized protein', 162, NULL, NULL, 227424),
(227425, '1.25.40.10-FF-001887', NULL, 'Predicted protein', 100, NULL, NULL, 227425),
(227426, '3.90.1150.10-FF-000043', NULL, 'Serine hydroxymethyltransferase', 172, NULL, NULL, 227426),
(227427, '1.20.890.10-FF-000027', NULL, 'Protein CBG05895', 47, NULL, NULL, 227427),
(227428, '1.20.58.390-FF-000241', NULL, 'Uncharacterized protein', 127, NULL, NULL, 227428),
(227429, '3.30.500.10-FF-000006', NULL, 'Uncharacterized protein', 175, NULL, NULL, 227429),
(227430, '1.20.120.1760-FF-000074', NULL, NULL, 191, NULL, NULL, 227430),
(227431, '4.10.280.10-FF-000096', NULL, 'Basic helix-loop-helix (BHLH) DNA-binding superfamily protein', 71, NULL, NULL, 227431),
(227432, '1.20.1070.10-FF-001622', NULL, 'Si:dkey-247m21.3', 143, NULL, NULL, 227432),
(227433, '3.30.70.330-FF-001836', NULL, NULL, 118, NULL, NULL, 227433),
(227434, '2.120.10.80-FF-000307', NULL, 'Uncharacterized protein', 184, NULL, NULL, 227434),
(227435, '3.40.930.10-FF-000019', NULL, 'Solute carrier family 4 member 11', 97, NULL, NULL, 227435),
(227436, '3.30.2170.10-FF-000002', NULL, 'Endonuclease V', 239, NULL, NULL, 227436),
(227437, '3.40.30.10-FF-000970', NULL, 'Chromosome 19, whole genome shotgun sequence', 97, NULL, NULL, 227437),
(227438, '1.10.10.10-FF-000665', NULL, 'Uncharacterized protein', 83, NULL, NULL, 227438),
(227439, '2.30.30.40-FF-000324', NULL, 'SH3 domain-containing protein', 65, NULL, NULL, 227439),
(227440, '1.20.1310.10-FF-000231', NULL, NULL, 112, NULL, NULL, 227440),
(227441, '1.10.510.10-FF-002284', NULL, 'Uncharacterized protein', 217, NULL, NULL, 227441),
(227442, '2.70.170.10-FF-000227', NULL, 'Uncharacterized protein', 93, NULL, NULL, 227442),
(227443, '1.10.472.130-FF-000064', NULL, 'Dynein heavy chain 7, axonemal', 161, NULL, NULL, 227443),
(227444, '1.10.472.10-FF-000042', NULL, 'FAM58A isoform 1', 110, NULL, NULL, 227444),
(227445, '3.30.1640.10-FF-000072', NULL, 'Predicted protein', 99, NULL, NULL, 227445),
(227446, '2.130.10.10-FF-004592', NULL, 'Uncharacterized protein', 206, NULL, NULL, 227446),
(227447, '2.60.40.720-FF-000005', NULL, 'p53, isoform E', 201, NULL, NULL, 227447),
(227448, '1.10.10.10-FF-000025', NULL, '40S ribosomal protein S10', 105, NULL, NULL, 227448),
(227449, '3.40.910.10-FF-000018', NULL, 'Uncharacterized protein', 356, NULL, NULL, 227449),
(227450, '3.30.200.20-FF-002206', NULL, 'Uncharacterized protein', 47, NULL, NULL, 227450),
(227451, '3.90.550.50-FF-000204', NULL, 'Uncharacterized protein', 178, NULL, NULL, 227451),
(227452, '2.60.40.10-FF-004625', NULL, NULL, 64, NULL, NULL, 227452),
(227453, '3.30.70.120-FF-000020', NULL, NULL, 114, NULL, NULL, 227453),
(227454, '3.30.470.30-FF-000020', NULL, 'RNA guanylyltransferase', 230, NULL, NULL, 227454),
(227455, '1.25.40.20-FF-000822', NULL, 'Poly [ADP-ribose] polymerase', 216, NULL, NULL, 227455),
(227456, '1.20.810.10-FF-000034', NULL, 'Cytochrome b mRNA maturase bI3', 216, NULL, NULL, 227456),
(227457, '3.20.20.190-FF-000168', NULL, NULL, 112, NULL, NULL, 227457),
(227458, '1.10.510.10-FF-002593', NULL, NULL, 192, NULL, NULL, 227458),
(227459, '2.130.10.10-FF-004283', NULL, 'Uncharacterized protein', 128, NULL, NULL, 227459),
(227460, '3.20.20.70-FF-000538', NULL, NULL, 231, NULL, NULL, 227460),
(227461, '2.60.120.920-FF-000209', NULL, 'Uncharacterized protein', 177, NULL, NULL, 227461),
(227462, '3.30.60.30-FF-000091', NULL, 'Agrin', 57, NULL, NULL, 227462),
(227463, '1.20.870.10-FF-000026', NULL, 'Uncharacterized protein, isoform A', 165, NULL, NULL, 227463),
(227464, '3.80.10.10-FF-003743', NULL, 'Uncharacterized protein', 129, NULL, NULL, 227464),
(227465, '2.160.20.10-FF-000128', NULL, 'GD20755', 105, NULL, NULL, 227465),
(227466, '3.40.50.150-FF-000904', NULL, 'Protein N-lysine methyltransferase METTL21A', 184, NULL, NULL, 227466);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(227467, '1.25.10.10-FF-002537', NULL, 'Condensin complex subunit, putative', 184, NULL, NULL, 227467),
(227468, '3.30.870.10-FF-000011', NULL, 'Phospholipase', 221, NULL, NULL, 227468),
(227469, '2.60.40.10-FF-006008', NULL, NULL, 38, NULL, NULL, 227469),
(227470, '3.30.160.60-FF-000477', NULL, 'Zinc finger protein', 24, NULL, NULL, 227470),
(227471, '3.80.10.10-FF-003412', NULL, 'Fbxl16, putative', 84, NULL, NULL, 227471),
(227472, '3.30.70.3490-FF-000020', NULL, 'Oxysterol binding protein (Osh7), putative', 98, NULL, NULL, 227472),
(227473, '1.20.120.1750-FF-000071', NULL, 'RBR-type E3 ubiquitin transferase', 46, NULL, NULL, 227473),
(227474, '2.40.70.10-FF-000132', NULL, 'Uncharacterized protein', 138, NULL, NULL, 227474),
(227475, '3.40.50.300-FF-004682', NULL, 'G Protein, Alpha subunit', 170, NULL, NULL, 227475),
(227476, '2.110.10.10-FF-000068', NULL, 'Uncharacterized protein', 123, NULL, NULL, 227476),
(227477, '2.60.40.10-FF-002265', NULL, 'Alpha-1-B glycoprotein', 86, NULL, NULL, 227477),
(227478, '3.90.740.10-FF-000033', NULL, 'Isoleucyl-tRNA synthetase, putative', 151, NULL, NULL, 227478),
(227479, '3.40.50.1820-FF-000005', NULL, 'Prolyl endopeptidase', 326, NULL, NULL, 227479),
(227480, '4.10.240.10-FF-000189', NULL, 'Fungal zinc cluster transcription factor, putative', 84, NULL, NULL, 227480),
(227481, '3.30.572.10-FF-000009', NULL, 'Thymidylate synthase', 281, NULL, NULL, 227481),
(227482, '3.50.30.10-FF-000008', NULL, 'Pyruvate kinase', 112, NULL, NULL, 227482),
(227483, '2.170.150.20-FF-000014', NULL, 'Peptide-methionine (R)-S-oxide reductase', 140, NULL, NULL, 227483),
(227484, '3.40.50.300-FF-006716', NULL, 'Uncharacterized protein', 74, NULL, NULL, 227484),
(227485, '3.40.50.720-FF-001503', NULL, 'Uncharacterized protein', 244, NULL, NULL, 227485),
(227486, '2.60.120.620-FF-000097', NULL, 'Uncharacterized protein', 142, NULL, NULL, 227486),
(227487, '1.10.8.70-FF-000002', NULL, 'Glutamate--tRNA ligase', 52, NULL, NULL, 227487),
(227488, '2.130.10.10-FF-000444', NULL, 'WD repeat domain 18', 155, NULL, NULL, 227488),
(227489, '1.10.167.10-FF-000018', NULL, 'A-kinase anchor protein 10, mitochondrial', 91, NULL, NULL, 227489),
(227490, '3.40.50.300-FF-004772', NULL, 'Uncharacterized protein', 117, NULL, NULL, 227490),
(227491, '3.10.20.90-FF-000943', NULL, 'Autophagy protein 5', 72, NULL, NULL, 227491),
(227492, '3.30.60.30-FF-000197', NULL, 'Uncharacterized protein', 66, NULL, NULL, 227492),
(227493, '2.170.150.10-FF-000011', NULL, 'Dss4p', 131, NULL, NULL, 227493),
(227494, '1.25.10.10-FF-000194', NULL, 'WD repeat-containing protein mip1', 227, NULL, NULL, 227494),
(227495, '1.10.287.1490-FF-000073', NULL, 'Mlp1p', 167, NULL, NULL, 227495),
(227496, '1.20.1310.10-FF-000028', NULL, 'CDK2-associated and cullin domain-containing protein 1', 127, NULL, NULL, 227496),
(227497, '1.20.58.390-FF-000095', NULL, 'Ionotropic GABA receptor subunit UNC-49B.3', 136, NULL, NULL, 227497),
(227498, '1.10.1200.270-FF-000009', NULL, 'Salicylate/benzoate carboxyl methyltransferase', 78, NULL, NULL, 227498),
(227499, '1.20.1070.10-FF-001257', NULL, 'Uncharacterized protein', 149, NULL, NULL, 227499),
(227500, '1.25.40.20-FF-000480', NULL, 'Calmodulin-binding transcription activator 2', 282, NULL, NULL, 227500),
(227501, '2.60.260.20-FF-000037', NULL, 'DnaJ heat shock protein', 97, NULL, NULL, 227501),
(227502, '1.10.620.20-FF-000024', NULL, 'Predicted protein', 325, NULL, NULL, 227502),
(227503, '3.80.10.10-FF-001613', NULL, 'Expressed protein', 200, NULL, NULL, 227503),
(227504, '2.40.33.10-FF-000046', NULL, 'Pyruvate kinase', 22, NULL, NULL, 227504),
(227505, '1.10.1070.11-FF-000041', NULL, 'DNA-dependent protein kinase catalytic subunit', 181, NULL, NULL, 227505),
(227506, '1.20.5.4130-FF-000007', NULL, 'Putative disease resistance protein At3g14460', 100, NULL, NULL, 227506),
(227507, '3.90.226.10-FF-000170', NULL, 'Peptidase S41', 171, NULL, NULL, 227507),
(227508, '1.10.8.80-FF-000005', NULL, 'MoxR-like ATPase', 116, NULL, NULL, 227508),
(227509, '3.40.50.1820-FF-001770', NULL, 'Chromosome 1, whole genome shotgun sequence', 207, NULL, NULL, 227509);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(227510, '3.30.200.20-FF-001953', NULL, 'Myosin light chain kinase 2', 130, NULL, NULL, 227510),
(227511, '1.50.40.10-FF-000278', NULL, 'Uncharacterized protein', 190, NULL, NULL, 227511),
(227512, '3.40.50.300-FF-006374', NULL, 'Uncharacterized protein', 137, NULL, NULL, 227512),
(227513, '1.10.10.60-FF-000343', NULL, 'Sigma-54-dependent Fis family transcriptional regulator', 45, NULL, NULL, 227513),
(227514, '3.40.50.300-FF-003968', NULL, 'ABC transporter, ATP-binding protein', 267, NULL, NULL, 227514),
(227515, '1.20.5.370-FF-000010', NULL, 'Myosin heavy chain, isoform G', 45, NULL, NULL, 227515),
(227516, '1.10.1200.260-FF-000006', NULL, 'EAG', 42, NULL, NULL, 227516),
(227517, '3.40.50.300-FF-008515', NULL, 'Uncharacterized protein', 137, NULL, NULL, 227517),
(227518, '3.30.1010.10-FF-000024', NULL, 'Phosphatidylinositol 4-kinase', 297, NULL, NULL, 227518),
(227519, '2.130.10.10-FF-003569', NULL, 'Uncharacterized protein', 378, NULL, NULL, 227519),
(227520, '3.40.47.10-FF-000261', NULL, NULL, 258, NULL, NULL, 227520),
(227521, '3.30.420.40-FF-000385', NULL, 'Putative actin-like protein', 59, NULL, NULL, 227521),
(227522, '3.90.730.10-FF-000004', NULL, 'Ribonuclease T2-like', 240, NULL, NULL, 227522),
(227523, '3.90.470.20-FF-000043', NULL, '4''-phosphopantetheinyl transferase superfamily protein', 95, NULL, NULL, 227523),
(227524, '3.40.50.300-FF-008173', NULL, 'Uncharacterized protein', 85, NULL, NULL, 227524),
(227525, '3.40.140.10-FF-000190', NULL, 'Eukaryotic translation initiation factor 3 subunit H', 227, NULL, NULL, 227525),
(227526, '3.30.160.60-FF-006222', NULL, NULL, 86, NULL, NULL, 227526),
(227527, '3.40.109.10-FF-000061', NULL, 'Nitroreductase', 198, NULL, NULL, 227527),
(227528, '3.30.160.60-FF-002169', NULL, 'Zgc:174573', 30, NULL, NULL, 227528),
(227529, '3.40.50.880-FF-000073', NULL, 'Glutamine amidotransferase', 187, NULL, NULL, 227529),
(227530, '3.90.230.10-FF-000056', NULL, NULL, 239, NULL, NULL, 227530),
(227531, '1.10.238.10-FF-000543', NULL, 'Dystrophin-1', 91, NULL, NULL, 227531),
(227532, '3.90.470.10-FF-000040', NULL, '50S ribosomal protein L22', 143, NULL, NULL, 227532),
(227533, '3.30.590.10-FF-000045', NULL, 'Glutamate-ammonia ligase', 112, NULL, NULL, 227533),
(227534, '1.10.533.10-FF-000156', NULL, 'Cell death protein 4', 109, NULL, NULL, 227534),
(227535, '3.40.50.150-FF-000343', NULL, 'Fibrillarin-like rRNA/tRNA 2''-O-methyltransferase', 177, NULL, NULL, 227535),
(227536, '2.10.25.10-FF-001821', NULL, 'Uncharacterized protein', 53, NULL, NULL, 227536),
(227537, '3.90.79.10-FF-000208', NULL, 'Adenine DNA glycosylase', 155, NULL, NULL, 227537),
(227538, '3.10.20.30-FF-000061', NULL, 'Developmentally-regulated GTP-binding protein, putative', 82, NULL, NULL, 227538),
(227539, '2.60.40.10-FF-004064', NULL, NULL, 96, NULL, NULL, 227539),
(227540, '3.90.1300.10-FF-000004', NULL, 'Outer envelope protein 64, mitochondrial', 408, NULL, NULL, 227540),
(227541, '1.25.40.10-FF-002034', NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform A', 168, NULL, NULL, 227541),
(227542, '3.90.1410.10-FF-000086', NULL, 'YALI0F20944p', 261, NULL, NULL, 227542),
(227543, '1.20.5.390-FF-000016', NULL, NULL, 67, NULL, NULL, 227543),
(227544, '1.10.10.60-FF-000433', NULL, 'Reproductive homeobox 2B', 62, NULL, NULL, 227544),
(227545, '3.50.7.10-FF-000006', NULL, 'T-complex protein 1 subunit eta', 156, NULL, NULL, 227545),
(227546, '3.90.1420.10-FF-000036', NULL, 'Rubisco large subunit N-methyltransferase', 167, NULL, NULL, 227546),
(227547, '3.30.70.330-FF-000420', NULL, 'serine-arginine protein 55 isoform X1', 100, NULL, NULL, 227547),
(227548, '3.30.450.90-FF-000014', NULL, 'Toxin co-regulated pilus biosynthesis protein T', 128, NULL, NULL, 227548),
(227549, '3.30.930.10-FF-000398', NULL, 'Uncharacterized protein', 121, NULL, NULL, 227549),
(227550, '3.30.40.10-FF-001191', NULL, 'putative E3 ubiquitin-protein ligase UBR7 isoform X2', 67, NULL, NULL, 227550),
(227551, '1.25.40.10-FF-004164', NULL, 'Uncharacterized protein', 103, NULL, NULL, 227551),
(227552, '1.25.10.10-FF-000284', NULL, 'Serine/threonine-protein kinase TOR', 198, NULL, NULL, 227552);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(227553, '3.30.160.60-FF-004277', NULL, NULL, 27, NULL, NULL, 227553),
(227554, '3.80.10.10-FF-001703', NULL, 'Probable leucine-rich repeat receptor-like protein kinase At5g63930', 99, NULL, NULL, 227554),
(227555, '1.10.150.80-FF-000017', NULL, 'ATP-dependent DNA helicase RecQ', 79, NULL, NULL, 227555),
(227556, '2.20.28.10-FF-000052', NULL, 'Ferredoxin-thioredoxin reductase, catalytic subunit, putative/rubredoxin', 37, NULL, NULL, 227556),
(227557, '3.40.50.2300-FF-001605', NULL, NULL, 68, NULL, NULL, 227557),
(227558, '3.10.20.90-FF-000269', NULL, 'Very-long-chain enoyl-CoA reductase', 86, NULL, NULL, 227558),
(227559, '3.40.50.1980-FF-000154', NULL, 'Histidinol dehydrogenase', 179, NULL, NULL, 227559),
(227560, '3.30.499.10-FF-000018', NULL, 'Aconitate hydratase', 187, NULL, NULL, 227560),
(227561, '1.10.565.10-FF-000185', NULL, 'Uncharacterized protein', 101, NULL, NULL, 227561),
(227562, '3.30.160.60-FF-004423', NULL, NULL, 27, NULL, NULL, 227562),
(227563, '4.10.400.10-FF-000286', NULL, 'Transmembrane serine protease 2', 37, NULL, NULL, 227563),
(227564, '3.90.1430.10-FF-000008', NULL, NULL, 97, NULL, NULL, 227564),
(227565, '3.30.450.80-FF-000011', NULL, NULL, 102, NULL, NULL, 227565),
(227566, '1.50.40.10-FF-000188', NULL, 'Mitochondrial RNA-splicing protein MRS3', 164, NULL, NULL, 227566),
(227567, '3.40.50.300-FF-002973', NULL, 'ESX-3 secretion system protein EccC3', 316, NULL, NULL, 227567),
(227568, '3.10.20.90-FF-000472', NULL, 'UV excision repair protein RAD23, putative', 83, NULL, NULL, 227568),
(227569, '1.20.1370.10-FF-000004', NULL, 'Larval serum protein 2', 96, NULL, NULL, 227569),
(227570, '4.10.60.10-FF-000116', NULL, 'Zinc knuckle (CCHC-type) family protein', 48, NULL, NULL, 227570),
(227571, '1.25.40.10-FF-001758', NULL, 'Rhomboid protease GluP', 123, NULL, NULL, 227571),
(227572, '2.60.40.10-FF-002517', NULL, 'Down syndrome cell adhesion molecule like 1', 94, NULL, NULL, 227572),
(227573, '1.10.1450.10-FF-000030', NULL, 'Tetraspanin', 126, NULL, NULL, 227573),
(227574, '2.30.130.40-FF-000046', NULL, 'Uncharacterized protein', 54, NULL, NULL, 227574),
(227575, '1.10.533.10-FF-000285', NULL, 'Uncharacterized protein', 116, NULL, NULL, 227575),
(227576, '3.40.140.10-FF-000223', NULL, 'Uncharacterized protein', 174, NULL, NULL, 227576),
(227577, '2.10.25.10-FF-001512', NULL, 'Fibulin-1', 53, NULL, NULL, 227577),
(227578, '3.30.200.20-FF-000407', NULL, 'Inka box actin regulator 1', 69, NULL, NULL, 227578),
(227579, '3.10.20.90-FF-000691', NULL, 'NSFL1 cofactor p47-like isoform X1', 123, NULL, NULL, 227579),
(227580, '3.30.9.10-FF-000168', NULL, 'Uncharacterized protein', 160, NULL, NULL, 227580),
(227581, '1.10.510.10-FF-004392', NULL, NULL, 88, NULL, NULL, 227581),
(227582, '3.90.70.10-FF-000672', NULL, 'Uncharacterized protein', 281, NULL, NULL, 227582),
(227583, '3.40.50.1820-FF-001309', NULL, 'Acetylcholinesterase/butyrylcholinesterase, putative', 265, NULL, NULL, 227583),
(227584, '3.40.30.10-FF-000767', NULL, 'Thiol peroxidase', 170, NULL, NULL, 227584),
(227585, '3.30.1360.120-FF-000084', NULL, 'Glycine cleavage system T protein', 140, NULL, NULL, 227585),
(227586, '1.10.510.10-FF-000805', NULL, 'Mitogen activated kinase-like protein', 306, NULL, NULL, 227586),
(227587, '3.90.1290.10-FF-000019', NULL, 'Short stop, isoform H', 192, NULL, NULL, 227587),
(227588, '3.30.40.10-FF-001729', NULL, 'Regulating synaptic membrane exocytosis protein 2', 146, NULL, NULL, 227588),
(227589, '1.20.1070.10-FF-001167', NULL, 'Uncharacterized protein', 290, NULL, NULL, 227589),
(227590, '1.20.120.330-FF-000014', NULL, 'Abl tyrosine kinase, isoform H', 108, NULL, NULL, 227590),
(227591, '3.30.420.110-FF-000046', NULL, 'DNA mismatch repair protein MSH2, putative', 207, NULL, NULL, 227591),
(227592, '1.10.150.60-FF-000011', NULL, 'AT-rich interactive domain-containing protein 2', 111, NULL, NULL, 227592),
(227593, '2.30.110.10-FF-000087', NULL, 'Flavin reductase domain protein FMN-binding', 155, NULL, NULL, 227593),
(227594, '3.30.160.60-FF-000713', NULL, 'Zinc finger protein 513', 30, NULL, NULL, 227594);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(227595, '3.30.70.330-FF-000201', NULL, 'heterogeneous nuclear ribonucleoprotein A3 isoform X1', 87, NULL, NULL, 227595),
(227596, '1.20.58.760-FF-000003', NULL, 'AFG3-like AAA ATPase 2', 193, NULL, NULL, 227596),
(227597, '3.40.50.1110-FF-000158', NULL, 'Uncharacterized protein', 133, NULL, NULL, 227597),
(227598, '1.10.510.10-FF-003588', NULL, NULL, 211, NULL, NULL, 227598),
(227599, '2.30.30.30-FF-000085', NULL, '50S ribosomal protein L2', 79, NULL, NULL, 227599),
(227600, '3.40.630.10-FF-000507', NULL, 'Predicted protein', 296, NULL, NULL, 227600),
(227601, '3.30.40.10-FF-001971', NULL, 'Uncharacterized protein', 62, NULL, NULL, 227601),
(227602, '2.60.40.10-FF-002826', NULL, NULL, 98, NULL, NULL, 227602),
(227603, '3.30.2160.10-FF-000052', NULL, 'Uncharacterized protein', 75, NULL, NULL, 227603),
(227604, '3.40.50.1000-FF-000765', NULL, NULL, 129, NULL, NULL, 227604),
(227605, '1.20.120.340-FF-000017', NULL, 'Similar to flagellar protein FliS', 123, NULL, NULL, 227605),
(227606, '3.60.21.10-FF-000375', NULL, '5'' nucleotidase, ecto, putative', 103, NULL, NULL, 227606),
(227607, '1.10.540.10-FF-000088', NULL, 'Acyl-coenzyme A oxidase', 34, NULL, NULL, 227607),
(227608, '2.90.10.10-FF-000042', NULL, 'Serine/threonine-protein kinase', 91, NULL, NULL, 227608),
(227609, '3.40.50.1240-FF-000146', NULL, 'Membrane-bound acid phosphatase, putative', 368, NULL, NULL, 227609),
(227610, '3.30.70.330-FF-002550', NULL, NULL, 32, NULL, NULL, 227610),
(227611, '2.60.40.10-FF-002175', NULL, 'Twitchin', 104, NULL, NULL, 227611),
(227612, '3.10.110.10-FF-000312', NULL, 'Uncharacterized protein', 73, NULL, NULL, 227612),
(227613, '2.30.30.40-FF-000088', NULL, 'Periplakin', 65, NULL, NULL, 227613),
(227614, '3.90.550.10-FF-000350', NULL, 'Beta-1,3-glucosyltransferase', 245, NULL, NULL, 227614),
(227615, '3.90.70.10-FF-000453', NULL, 'Senescence-specific cysteine protease SAG39', 60, NULL, NULL, 227615),
(227616, '1.10.287.110-FF-000254', NULL, 'DNAj-like protein', 99, NULL, NULL, 227616),
(227617, '1.10.533.10-FF-000066', NULL, 'Tumor necrosis factor receptor superfamily member 11B', 90, NULL, NULL, 227617),
(227618, '1.20.1250.20-FF-001830', NULL, 'Uncharacterized protein', 145, NULL, NULL, 227618),
(227619, '3.10.20.90-FF-000382', NULL, 'Nedd8-like protein RUB3, putative, expressed', 80, NULL, NULL, 227619),
(227620, '2.10.50.10-FF-000076', NULL, 'Neurotrophin receptor associated death domain', 57, NULL, NULL, 227620),
(227621, '1.10.510.10-FF-003897', NULL, NULL, 85, NULL, NULL, 227621),
(227622, '1.10.10.570-FF-000008', NULL, 'Putative dolicholphosphate-mannose synthase', 97, NULL, NULL, 227622),
(227623, '1.10.238.10-FF-000453', NULL, 'Leucine zipper and EF-hand containing transmembrane protein 1', 56, NULL, NULL, 227623),
(227624, '2.60.40.2030-FF-000031', NULL, 'Adhesion G protein-coupled receptor V1', 139, NULL, NULL, 227624),
(227625, '2.40.70.10-FF-000238', NULL, 'Os08g0207800 protein', 207, NULL, NULL, 227625),
(227626, '3.30.160.60-FF-000371', NULL, 'Zinc finger protein 555', 28, NULL, NULL, 227626),
(227627, '1.20.1070.10-FF-001818', NULL, 'Uncharacterized protein', 310, NULL, NULL, 227627),
(227628, '1.10.20.10-FF-000306', NULL, NULL, 46, NULL, NULL, 227628),
(227629, '3.60.21.10-FF-000285', NULL, 'Serine/threonine-protein phosphatase', 390, NULL, NULL, 227629),
(227630, '1.25.40.10-FF-004074', NULL, 'Uncharacterized protein', 159, NULL, NULL, 227630),
(227631, '3.40.50.300-FF-008263', NULL, 'Uncharacterized protein', 48, NULL, NULL, 227631),
(227632, '2.60.40.10-FF-002484', NULL, 'EmrB/QacA subfamily drug resistance transporter', 82, NULL, NULL, 227632),
(227633, '3.40.50.1100-FF-000155', NULL, 'Cysteine synthase', 155, NULL, NULL, 227633),
(227634, '3.10.110.10-FF-000060', NULL, 'Ubiquitin conjugating enzyme (UbcB)', 151, NULL, NULL, 227634),
(227635, '3.40.50.1820-FF-001551', NULL, 'Uncharacterized protein', 124, NULL, NULL, 227635),
(227636, '3.40.50.11530-FF-000017', NULL, 'Predicted protein', 155, NULL, NULL, 227636),
(227637, '1.25.40.10-FF-004383', NULL, 'Pentatricopeptide repeat-containing protein At4g14170', 143, NULL, NULL, 227637);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(227638, '1.10.1140.10-FF-000017', NULL, 'Uncharacterized protein', 95, NULL, NULL, 227638),
(227639, '3.30.70.60-FF-000021', NULL, '30S ribosomal protein S6', 99, NULL, NULL, 227639),
(227640, '1.20.1070.10-FF-001509', NULL, 'Predicted protein', 196, NULL, NULL, 227640),
(227641, '1.10.510.10-FF-004083', NULL, NULL, 164, NULL, NULL, 227641),
(227642, '3.80.10.10-FF-000995', NULL, 'Leucine-rich repeat-containing protein 40', 119, NULL, NULL, 227642),
(227643, '3.30.160.60-FF-000932', NULL, 'zinc finger and SCAN domain-containing protein 20 isoform X2', 27, NULL, NULL, 227643),
(227644, '3.30.160.60-FF-000680', NULL, 'S phase cyclin A-associated protein in the endoplasmic reticulum', 43, NULL, NULL, 227644),
(227645, '1.10.3720.10-FF-000028', NULL, 'sn-glycerol-3-phosphate ABC transporter permease UgpA', 241, NULL, NULL, 227645),
(227646, '2.60.40.1910-FF-000040', NULL, NULL, 90, NULL, NULL, 227646),
(227647, '3.80.10.10-FF-001922', NULL, 'Protein CBG04590', 199, NULL, NULL, 227647),
(227648, '3.30.450.30-FF-000002', NULL, 'Dynein light chain roadblock', 96, NULL, NULL, 227648),
(227649, '3.30.565.10-FF-000206', NULL, 'Chloroplast sensor kinase, chloroplastic', 170, NULL, NULL, 227649),
(227650, '3.30.70.330-FF-002218', NULL, NULL, 94, NULL, NULL, 227650),
(227651, '2.40.50.100-FF-000118', NULL, 'ABC transporter ATP-binding protein', 14, NULL, NULL, 227651),
(227652, '1.20.50.60-FF-000002', NULL, 'Exocrine gland-secreted peptide 1', 57, NULL, NULL, 227652),
(227653, '3.40.50.300-FF-000624', NULL, 'ADP-ribosylation factor 1', 176, NULL, NULL, 227653),
(227654, '1.10.10.10-FF-001969', NULL, 'Protamine-like protein', 69, NULL, NULL, 227654),
(227655, '3.90.70.10-FF-000762', NULL, 'Cathepsin Bb', 89, NULL, NULL, 227655),
(227656, '3.30.40.10-FF-001168', NULL, 'U-box domain-containing protein 31', 76, NULL, NULL, 227656),
(227657, '3.40.50.2300-FF-000520', NULL, 'Glutamate ionotropic receptor delta type subunit 1', 169, NULL, NULL, 227657),
(227658, '1.20.1540.10-FF-000040', NULL, 'Ubiquitin-associated /TS-N domain-containing protein', 180, NULL, NULL, 227658),
(227659, '1.10.20.10-FF-000054', NULL, 'Putative histone H1.5-like', 134, NULL, NULL, 227659),
(227660, '3.40.50.1820-FF-001860', NULL, 'Lipase, endothelial', 49, NULL, NULL, 227660),
(227661, '1.10.510.10-FF-000715', NULL, 'Serine/threonine-protein kinase PCRK2', 210, NULL, NULL, 227661),
(227662, '2.30.30.30-FF-000118', NULL, '60S ribosomal protein L26-1', 55, NULL, NULL, 227662),
(227663, '1.20.58.1780-FF-000021', NULL, 'Predicted protein', 95, NULL, NULL, 227663),
(227664, '2.20.25.210-FF-000001', NULL, 'Genome polyprotein', 61, NULL, NULL, 227664),
(227665, '1.25.10.10-FF-001947', NULL, 'Uncharacterized protein', 293, NULL, NULL, 227665),
(227666, '3.80.10.10-FF-001147', NULL, 'Uncharacterized protein', 206, NULL, NULL, 227666),
(227667, '2.40.50.40-FF-000010', NULL, 'Stromal cell-derived factor 1 precursor', 70, NULL, NULL, 227667),
(227668, '3.30.160.60-FF-006441', NULL, NULL, 35, NULL, NULL, 227668),
(227669, '2.10.250.10-FF-000017', NULL, 'Calnexin homolog-related protein', 41, NULL, NULL, 227669),
(227670, '2.60.40.150-FF-000492', NULL, 'C2 domain-containing protein 3', 189, NULL, NULL, 227670),
(227671, '2.130.10.10-FF-005929', NULL, 'Uncharacterized protein', 268, NULL, NULL, 227671),
(227672, '3.30.750.24-FF-000133', NULL, 'Sodium-independent sulfate anion transporter', 110, NULL, NULL, 227672),
(227673, '1.20.1250.20-FF-000060', NULL, 'Solute carrier family 17 member 3', 218, NULL, NULL, 227673),
(227674, '3.40.50.300-FF-000955', NULL, 'GTPase HflX', 191, NULL, NULL, 227674),
(227675, '3.90.76.10-FF-000056', NULL, 'Peptide ABC transporter, peptide-binding protein', 121, NULL, NULL, 227675),
(227676, '2.60.40.10-FF-002725', NULL, 'Peroxidasin', 99, NULL, NULL, 227676),
(227677, '4.10.400.10-FF-000319', NULL, 'Putative vitellogenin receptor', 43, NULL, NULL, 227677),
(227678, '1.20.1250.20-FF-001583', NULL, 'Uncharacterized protein', 346, NULL, NULL, 227678),
(227679, '3.30.500.50-FF-000001', NULL, 'Envelope glycoprotein H', 198, NULL, NULL, 227679);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(227680, '2.60.120.10-FF-000339', NULL, 'Mannose-6-phosphate isomerase', 92, NULL, NULL, 227680),
(227681, '3.30.160.60-FF-002158', NULL, 'Zinc finger protein ZIC 3', 29, NULL, NULL, 227681),
(227682, '3.60.15.10-FF-000102', NULL, 'Cleavage and polyadenylation specificity factor subunit 2', 255, NULL, NULL, 227682),
(227683, '3.30.40.10-FF-001398', NULL, 'Putative ubiquitin-hydrolase domain protein', 111, NULL, NULL, 227683),
(227684, '2.20.70.10-FF-000065', NULL, 'Rho GTPase activating protein 27', 47, NULL, NULL, 227684),
(227685, '1.10.3470.10-FF-000031', NULL, 'Manganese ABC transporter, membrane protein', 263, NULL, NULL, 227685),
(227686, '1.10.510.10-FF-002727', NULL, NULL, 203, NULL, NULL, 227686),
(227687, '3.30.2350.20-FF-000075', NULL, NULL, 76, NULL, NULL, 227687),
(227688, '4.10.1110.10-FF-000007', NULL, 'Zinc finger protein, putative', 82, NULL, NULL, 227688),
(227689, '1.25.10.10-FF-000424', NULL, 'Importin subunit beta-3', 1061, NULL, NULL, 227689),
(227690, '1.20.890.10-FF-000016', NULL, 'AAEL002786-PA', 42, NULL, NULL, 227690),
(227691, '3.30.70.2360-FF-000001', NULL, 'Endoribonuclease GhoS', 88, NULL, NULL, 227691),
(227692, '2.60.260.20-FF-000032', NULL, 'Chaperone protein DnaJ', 63, NULL, NULL, 227692),
(227693, '2.60.40.150-FF-000503', NULL, 'Synaptotagmin-C', 120, NULL, NULL, 227693),
(227694, '1.10.3430.10-FF-000017', NULL, 'Ammonium transporter', 414, NULL, NULL, 227694),
(227695, '1.10.8.720-FF-000056', NULL, 'Dynein heavy chain 11', 170, NULL, NULL, 227695),
(227696, '1.10.8.60-FF-000595', NULL, 'Cell division control protein', 82, NULL, NULL, 227696),
(227697, '3.90.470.20-FF-000048', NULL, 'Lipopeptide antibiotics iturin a biosynthesisprotein', 95, NULL, NULL, 227697),
(227698, '3.30.70.330-FF-002011', NULL, NULL, 79, NULL, NULL, 227698),
(227699, '2.40.170.20-FF-000035', NULL, 'Colicin I receptor', 474, NULL, NULL, 227699),
(227700, '2.40.50.140-FF-000203', NULL, 'TEN1 subunit of CST complex', 121, NULL, NULL, 227700),
(227701, '3.40.640.10-FF-000345', NULL, 'Perosamine synthetase', 247, NULL, NULL, 227701),
(227702, '3.30.559.10-FF-000040', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 234, NULL, NULL, 227702),
(227703, '1.25.40.10-FF-000347', NULL, 'Mitochondrial fission 1 protein', 134, NULL, NULL, 227703),
(227704, '3.40.50.300-FF-006262', NULL, 'Uncharacterized protein', 37, NULL, NULL, 227704),
(227705, '3.30.40.10-FF-001409', NULL, 'Uncharacterized protein', 87, NULL, NULL, 227705),
(227706, '1.10.150.20-FF-000140', NULL, 'DNA-directed RNA polymerase subunit alpha', 64, NULL, NULL, 227706),
(227707, '2.130.10.10-FF-002703', NULL, 'WD repeat domain phosphoinositide-interacting protein 3', 322, NULL, NULL, 227707),
(227708, '1.10.472.130-FF-000053', NULL, 'Predicted protein', 155, NULL, NULL, 227708),
(227709, '2.40.40.20-FF-000077', NULL, 'DNA-directed RNA polymerase subunit', 75, NULL, NULL, 227709),
(227710, '1.25.40.10-FF-000252', NULL, 'O-linked N-acetylglucosamine (GlcNAc) transferase', 157, NULL, NULL, 227710),
(227711, '2.60.40.10-FF-000590', NULL, 'V-set domain-containing T cell activation inhibitor 1', 101, NULL, NULL, 227711),
(227712, '1.10.730.10-FF-000131', NULL, 'Valyl Amino-acyl tRNA Synthetase', 179, NULL, NULL, 227712),
(227713, '3.30.2160.10-FF-000046', NULL, 'ADL280Wp', 79, NULL, NULL, 227713),
(227714, '1.10.10.10-FF-001879', NULL, 'Histone acetyltransferase', 49, NULL, NULL, 227714),
(227715, '3.90.400.10-FF-000013', NULL, 'Amino acid Transporter GlycoProtein subunit', 57, NULL, NULL, 227715),
(227716, '3.10.20.90-FF-000718', NULL, 'Uncharacterized protein', 83, NULL, NULL, 227716),
(227717, '1.10.510.10-FF-004291', NULL, NULL, 165, NULL, NULL, 227717),
(227718, '3.90.70.10-FF-000447', NULL, 'Putative ubiquitin carboxyl-terminal hydrolase 25', 403, NULL, NULL, 227718),
(227719, '3.30.497.10-FF-000053', NULL, 'GM17927', 163, NULL, NULL, 227719),
(227720, '1.20.1070.10-FF-001482', NULL, 'LOC791944 protein', 208, NULL, NULL, 227720),
(227721, '2.170.140.10-FF-000050', NULL, 'Chitin deacetylase 5A', 65, NULL, NULL, 227721);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(227722, '1.10.510.10-FF-000592', NULL, 'CAMK family protein kinase', 336, NULL, NULL, 227722),
(227723, '1.25.40.20-FF-000255', NULL, 'espin-like protein', 102, NULL, NULL, 227723),
(227724, '3.30.559.30-FF-000046', NULL, 'Nonribosomal peptide synthase GliP', 228, NULL, NULL, 227724),
(227725, '3.80.10.10-FF-004002', NULL, 'Uncharacterized protein', 150, NULL, NULL, 227725),
(227726, '3.40.980.10-FF-000045', NULL, 'Molybdopterin molybdenumtransferase', 182, NULL, NULL, 227726),
(227727, '3.40.50.300-FF-006683', NULL, 'Uncharacterized protein', 82, NULL, NULL, 227727),
(227728, '3.30.830.10-FF-000227', NULL, 'Protein CBG17023', 201, NULL, NULL, 227728),
(227729, '3.80.10.10-FF-003176', NULL, 'Uncharacterized protein', 255, NULL, NULL, 227729),
(227730, '3.10.490.10-FF-000008', NULL, 'Gamma-glutamylaminecyclotransferase A', 156, NULL, NULL, 227730),
(227731, '3.40.50.300-FF-000860', NULL, 'DExH-box ATP-dependent RNA helicase DExH6', 165, NULL, NULL, 227731),
(227732, '3.20.20.360-FF-000005', NULL, 'Malate synthase (GlcB)', 382, NULL, NULL, 227732),
(227733, '2.130.10.10-FF-004406', NULL, 'Uncharacterized protein', 372, NULL, NULL, 227733),
(227734, '1.25.40.10-FF-003899', NULL, 'Coatomer subunit epsilon', 310, NULL, NULL, 227734),
(227735, '1.10.630.10-FF-000764', NULL, 'Uncharacterized protein', 482, NULL, NULL, 227735),
(227736, '1.10.510.10-FF-000603', NULL, 'Receptor like protein kinase S.2', 223, NULL, NULL, 227736),
(227737, '3.40.50.261-FF-000012', NULL, 'Acyl-CoA synthetase FdrA', 168, NULL, NULL, 227737),
(227738, '1.10.1610.10-FF-000003', NULL, 'Nicotinate-nucleotide--dimethylbenzimidazole phosphoribosyltransferase', 54, NULL, NULL, 227738),
(227739, '2.120.10.30-FF-000181', NULL, 'RE14803p', 376, NULL, NULL, 227739),
(227740, '3.40.140.10-FF-000094', NULL, 'Cytidine deaminase', 112, NULL, NULL, 227740),
(227741, '3.40.50.1000-FF-000670', NULL, NULL, 193, NULL, NULL, 227741),
(227742, '1.25.10.10-FF-000519', NULL, 'WAPL (Wings apart-like protein regulation of heterochromatin) protein', 414, NULL, NULL, 227742),
(227743, '3.40.1090.10-FF-000072', NULL, 'Transmembrane protein', 147, NULL, NULL, 227743),
(227744, '2.40.110.10-FF-000023', NULL, 'Acyl-CoA dehydrogenase FadE10', 111, NULL, NULL, 227744),
(227745, '2.40.10.10-FF-000358', NULL, NULL, 98, NULL, NULL, 227745),
(227746, '3.20.20.370-FF-000008', NULL, 'Chitin deacetylase', 185, NULL, NULL, 227746),
(227747, '1.20.1260.80-FF-000005', NULL, 'Uncharacterized protein', 190, NULL, NULL, 227747),
(227748, '2.110.10.10-FF-000052', NULL, '72 kDa type IV collagenase-like', 202, NULL, NULL, 227748),
(227749, '3.40.50.12780-FF-000021', NULL, 'Long-chain-fatty-acid--CoA ligase ACSBG1 isoform 1', 150, NULL, NULL, 227749),
(227750, '3.30.200.20-FF-001936', NULL, 'Uncharacterized protein', 37, NULL, NULL, 227750),
(227751, '1.10.10.60-FF-000326', NULL, 'POU domain protein', 47, NULL, NULL, 227751),
(227752, '2.170.190.11-FF-000015', NULL, 'Molybdopterin molybdenumtransferase', 97, NULL, NULL, 227752),
(227753, '2.60.120.470-FF-000018', NULL, NULL, 169, NULL, NULL, 227753),
(227754, '1.20.5.190-FF-000147', NULL, NULL, 49, NULL, NULL, 227754),
(227755, '2.40.30.10-FF-000472', NULL, 'Predicted protein', 65, NULL, NULL, 227755),
(227756, '1.25.40.10-FF-004630', NULL, 'Uncharacterized protein', 122, NULL, NULL, 227756),
(227757, '1.25.10.10-FF-000750', NULL, 'Serine/threonine-protein kinase TOR', 224, NULL, NULL, 227757),
(227758, '2.20.130.20-FF-000003', NULL, 'CD109 molecule', 50, NULL, NULL, 227758),
(227759, '3.30.560.10-FF-000010', NULL, 'GMC oxidoreductase, putative (AFU_orthologue AFUA_3G08070)', 326, NULL, NULL, 227759),
(227760, '1.10.400.10-FF-000033', NULL, 'Uncharacterized protein', 71, NULL, NULL, 227760),
(227761, '1.20.870.10-FF-000021', NULL, 'Low temperature essential protein', 155, NULL, NULL, 227761),
(227762, '2.130.10.10-FF-000354', NULL, 'Protein HIRA', 272, NULL, NULL, 227762),
(227763, '3.40.50.300-FF-000629', NULL, 'Adenylyl-sulfate kinase', 207, NULL, NULL, 227763),
(227764, '2.130.10.10-FF-000242', NULL, 'WD repeat domain 19, isoform CRA_a', 350, NULL, NULL, 227764);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(227765, '2.60.120.10-FF-000665', NULL, 'Uncharacterized protein', 113, NULL, NULL, 227765),
(227766, '3.40.640.10-FF-000019', NULL, 'Pyridoxal phosphate-dependent aminotransferase', 242, NULL, NULL, 227766),
(227767, '2.70.170.10-FF-000194', NULL, 'Predicted protein', 195, NULL, NULL, 227767),
(227768, '2.60.40.150-FF-000166', NULL, 'Protein C2-DOMAIN ABA-RELATED 1', 125, NULL, NULL, 227768),
(227769, '2.40.100.10-FF-000084', NULL, 'Peptidyl-prolyl cis-trans isomerase', 132, NULL, NULL, 227769),
(227770, '2.60.40.10-FF-000685', NULL, 'basement membrane-specific heparan sulfate proteoglycan core protein-like', 90, NULL, NULL, 227770),
(227771, '2.40.30.270-FF-000002', NULL, 'DNA replication ATP-dependent helicase/nuclease DNA2', 102, NULL, NULL, 227771),
(227772, '3.40.50.300-FF-004912', NULL, 'Uncharacterized protein', 216, NULL, NULL, 227772),
(227773, '3.40.50.10860-FF-000007', NULL, 'Glutamate dehydrogenase 1, mitochondrial', 149, NULL, NULL, 227773),
(227774, '2.60.40.10-FF-006087', NULL, NULL, 117, NULL, NULL, 227774),
(227775, '1.10.533.10-FF-000061', NULL, 'nuclear factor NF-kappa-B p100 subunit isoform X1', 89, NULL, NULL, 227775),
(227776, '2.160.20.70-FF-000028', NULL, 'Uncharacterized protein', 167, NULL, NULL, 227776),
(227777, '3.40.50.300-FF-002193', NULL, 'Polynucleotide kinase', 152, NULL, NULL, 227777),
(227778, '3.40.50.300-FF-004019', NULL, 'DNA polymerase III subunit epsilon protein', 159, NULL, NULL, 227778),
(227779, '3.30.40.10-FF-001623', NULL, 'RBR-type E3 ubiquitin transferase', 81, NULL, NULL, 227779),
(227780, '3.30.1360.120-FF-000090', NULL, 'Putative transferase CAF17, mitochondrial', 155, NULL, NULL, 227780),
(227781, '3.30.40.10-FF-000212', NULL, 'pleckstrin homology domain-containing family F member 2', 80, NULL, NULL, 227781),
(227782, '1.20.5.780-FF-000015', NULL, 'FXYD domain-containing ion transport regulator', 83, NULL, NULL, 227782),
(227783, '1.10.533.10-FF-000173', NULL, 'Predicted protein', 108, NULL, NULL, 227783),
(227784, '2.40.70.10-FF-000255', NULL, NULL, 124, NULL, NULL, 227784),
(227785, '3.30.40.10-FF-001735', NULL, 'Ubiquitinyl hydrolase 1', 106, NULL, NULL, 227785),
(227786, '1.10.220.150-FF-000002', NULL, 'arf-GAP with SH3 domain, ANK repeat and PH domain-containing protein 1', 131, NULL, NULL, 227786),
(227787, '3.90.228.10-FF-000039', NULL, 'Poly [ADP-ribose] polymerase', 208, NULL, NULL, 227787),
(227788, '3.90.70.10-FF-000094', NULL, 'ubiquitin carboxyl-terminal hydrolase 35', 196, NULL, NULL, 227788),
(227789, '3.40.50.720-FF-001817', NULL, 'Alpha-aminoadipic semialdehyde synthase, mitochondrial', 219, NULL, NULL, 227789),
(227790, '3.90.260.10-FF-000024', NULL, 'Putative DNA-repair protein', 164, NULL, NULL, 227790),
(227791, '3.90.960.10-FF-000015', NULL, 'Proline--tRNA ligase', 145, NULL, NULL, 227791),
(227792, '3.30.700.20-FF-000002', NULL, 'YOR289W-like protein', 122, NULL, NULL, 227792),
(227793, '1.20.58.60-FF-000014', NULL, 'microtubule-actin cross-linking factor 1', 109, NULL, NULL, 227793),
(227794, '1.20.1270.420-FF-000003', NULL, 'IKK epsilon', 246, NULL, NULL, 227794),
(227795, '2.40.10.10-FF-000263', NULL, 'Uncharacterized protein', 81, NULL, NULL, 227795),
(227796, '2.130.10.10-FF-003889', NULL, 'WD repeat protein (AFU_orthologue AFUA_5G11870)', 274, NULL, NULL, 227796),
(227797, '3.30.200.20-FF-002442', NULL, 'Uncharacterized protein', 67, NULL, NULL, 227797),
(227798, '3.90.1410.10-FF-000114', NULL, 'Uncharacterized protein', 299, NULL, NULL, 227798),
(227799, '3.40.190.10-FF-000142', NULL, 'Ionotropic receptor 25a', 115, NULL, NULL, 227799),
(227800, '1.25.10.10-FF-002195', NULL, 'Uncharacterized protein', 444, NULL, NULL, 227800),
(227801, '2.60.120.920-FF-000075', NULL, 'Si:ch211-127b6.2', 175, NULL, NULL, 227801),
(227802, '2.10.25.10-FF-001052', NULL, 'Slit homolog 1b (Drosophila)', 41, NULL, NULL, 227802),
(227803, '3.40.630.10-FF-000064', NULL, 'Carboxypeptidase A6', 296, NULL, NULL, 227803),
(227804, '2.60.40.10-FF-005598', NULL, NULL, 78, NULL, NULL, 227804),
(227805, '3.40.30.10-FF-000296', NULL, 'Glutathione S-transferase', 166, NULL, NULL, 227805);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(227806, '3.30.1300.10-FF-000018', NULL, NULL, 124, NULL, NULL, 227806),
(227807, '2.60.40.1910-FF-000028', NULL, NULL, 120, NULL, NULL, 227807),
(227808, '2.60.40.60-FF-000251', NULL, 'Uncharacterized protein', 106, NULL, NULL, 227808),
(227809, '3.80.10.10-FF-001473', NULL, 'Leucine Rich Repeat domain protein', 131, NULL, NULL, 227809),
(227810, '2.60.40.640-FF-000088', NULL, 'Uncharacterized protein C557.05', 173, NULL, NULL, 227810),
(227811, '1.10.220.160-FF-000005', NULL, 'Histone-lysine N-methyltransferase, putative', 80, NULL, NULL, 227811),
(227812, '1.10.20.10-FF-000284', NULL, NULL, 72, NULL, NULL, 227812),
(227813, '2.60.40.1180-FF-000197', NULL, 'Glucan (1,4-alpha-),-branching enzyme 1b', 70, NULL, NULL, 227813),
(227814, '1.20.58.70-FF-000017', NULL, 'Syntaxin 19', 125, NULL, NULL, 227814),
(227815, '3.10.20.90-FF-000039', NULL, 'Tyrosine-protein phosphatase non-receptor type', 85, NULL, NULL, 227815),
(227816, '1.20.1250.20-FF-001369', NULL, 'Membrane transporter', 197, NULL, NULL, 227816),
(227817, '1.20.1070.10-FF-001268', NULL, 'uncharacterized protein LOC104265789', 193, NULL, NULL, 227817),
(227818, '1.20.1250.20-FF-001257', NULL, 'Peptide transporter 3', 389, NULL, NULL, 227818),
(227819, '1.20.1070.10-FF-001156', NULL, 'Olfactory receptor', 292, NULL, NULL, 227819),
(227820, '1.20.5.190-FF-000052', NULL, 'Abnormal spindle-like microcephaly-associated protein', 46, NULL, NULL, 227820),
(227821, '1.10.10.10-FF-002043', NULL, 'Probable sigma-70 factor, ECF subfamily', 92, NULL, NULL, 227821),
(227822, '3.40.390.10-FF-000123', NULL, 'Metalloendopeptidase', 170, NULL, NULL, 227822),
(227823, '1.10.533.10-FF-000268', NULL, 'Predicted protein', 100, NULL, NULL, 227823),
(227824, '2.50.20.20-FF-000002', NULL, 'Putative lipoprotein lprF', 210, NULL, NULL, 227824),
(227825, '1.25.40.990-FF-000052', NULL, 'Predicted protein', 294, NULL, NULL, 227825),
(227826, '1.10.1450.10-FF-000131', NULL, 'Uncharacterized protein', 114, NULL, NULL, 227826),
(227827, '3.30.56.30-FF-000013', NULL, 'SRP19 protein', 121, NULL, NULL, 227827),
(227828, '2.180.10.10-FF-000026', NULL, 'Teneurin-1', 406, NULL, NULL, 227828),
(227829, '1.10.10.60-FF-000231', NULL, 'Myb transcription factor', 46, NULL, NULL, 227829),
(227830, '1.20.1530.20-FF-000093', NULL, 'Uncharacterized protein', 282, NULL, NULL, 227830),
(227831, '1.10.510.10-FF-002048', NULL, 'Uncharacterized protein', 335, NULL, NULL, 227831),
(227832, '3.90.550.50-FF-000108', NULL, 'Hexosyltransferase', 217, NULL, NULL, 227832),
(227833, '1.10.287.110-FF-000484', NULL, 'Diphthamide biosynthesis protein 4', 71, NULL, NULL, 227833),
(227834, '2.60.40.1180-FF-000208', NULL, 'Predicted protein', 97, NULL, NULL, 227834),
(227835, '3.30.160.60-FF-004187', NULL, NULL, 81, NULL, NULL, 227835),
(227836, '3.30.70.330-FF-001494', NULL, 'Predicted protein', 131, NULL, NULL, 227836),
(227837, '2.60.40.10-FF-000264', NULL, 'Down syndrome cell adhesion molecule like 1', 101, NULL, NULL, 227837),
(227838, '3.40.50.720-FF-001722', NULL, 'Uncharacterized protein', 148, NULL, NULL, 227838),
(227839, '3.30.60.20-FF-000003', NULL, 'Protein kinase C delta', 66, NULL, NULL, 227839),
(227840, '3.10.20.90-FF-000932', NULL, 'Phosphatidylinositol 3-kinase catalytic subunit, putative', 80, NULL, NULL, 227840),
(227841, '2.10.90.10-FF-000168', NULL, 'Bone morphogenetic protein 8B-like protein', 98, NULL, NULL, 227841),
(227842, '1.10.510.10-FF-002941', NULL, NULL, 89, NULL, NULL, 227842),
(227843, '2.40.30.10-FF-000146', NULL, 'Elongation factor Tu, mitochondrial', 99, NULL, NULL, 227843),
(227844, '2.10.25.10-FF-001731', NULL, 'Uncharacterized protein', 39, NULL, NULL, 227844),
(227845, '3.30.830.10-FF-000115', NULL, 'Zinc protease PQQL-like', 187, NULL, NULL, 227845),
(227846, '3.80.10.10-FF-003064', NULL, 'Uncharacterized protein', 143, NULL, NULL, 227846),
(227847, '2.30.30.1020-FF-000044', NULL, NULL, 75, NULL, NULL, 227847),
(227848, '3.30.160.60-FF-003001', NULL, 'LD13921p', 26, NULL, NULL, 227848),
(227849, '1.25.40.10-FF-002590', NULL, 'Pentatricopeptide repeat-containing protein At2g45350, chloroplastic', 99, NULL, NULL, 227849);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(227850, '3.40.50.300-FF-002872', NULL, 'P-loop containing nucleoside triphosphate hydrolases superfamily protein', 327, NULL, NULL, 227850),
(227851, '1.10.10.60-FF-000438', NULL, 'DNA-invertase Hin', 52, NULL, NULL, 227851),
(227852, '2.60.120.260-FF-000062', NULL, 'Galactose-binding protein isoform 3', 144, NULL, NULL, 227852),
(227853, '1.20.58.390-FF-000117', NULL, 'Uncharacterized protein', 73, NULL, NULL, 227853),
(227854, '3.10.180.10-FF-000024', NULL, '2,3-dihydroxybiphenyl 1,2-dioxygenase', 130, NULL, NULL, 227854),
(227855, '1.10.220.10-FF-000047', NULL, 'Annexin', 80, NULL, NULL, 227855),
(227856, '1.10.135.10-FF-000012', NULL, 'creatine kinase B-type', 93, NULL, NULL, 227856),
(227857, '2.40.50.690-FF-000019', NULL, 'YALI0E03630p', 149, NULL, NULL, 227857),
(227858, '2.60.40.150-FF-000278', NULL, 'Synaptotagmin protein 4', 155, NULL, NULL, 227858),
(227859, '2.60.40.780-FF-000001', NULL, 'von Hippel-Lindau disease tumor suppressor', 90, NULL, NULL, 227859),
(227860, '2.40.30.10-FF-000360', NULL, 'Benzoyl-CoA oxygenase, A subunit', 136, NULL, NULL, 227860),
(227861, '3.40.50.300-FF-007785', NULL, 'RNA helicase, putative', 52, NULL, NULL, 227861),
(227862, '3.20.20.70-FF-000847', NULL, NULL, 82, NULL, NULL, 227862),
(227863, '1.25.40.10-FF-002601', NULL, 'UTP6 small subunit processome component', 170, NULL, NULL, 227863),
(227864, '1.25.40.10-FF-003787', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 150, NULL, NULL, 227864),
(227865, '1.25.40.60-FF-000008', NULL, 'Protein transport Sec1b', 124, NULL, NULL, 227865),
(227866, '1.10.10.580-FF-000028', NULL, 'Uncharacterized protein', 55, NULL, NULL, 227866),
(227867, '2.60.40.60-FF-000346', NULL, 'Desmocollin b', 107, NULL, NULL, 227867),
(227868, '3.40.50.2300-FF-000161', NULL, 'DNA-binding transcriptional repressor EbgR', 99, NULL, NULL, 227868),
(227869, '3.30.930.10-FF-000393', NULL, 'Uncharacterized protein', 165, NULL, NULL, 227869),
(227870, '2.130.10.10-FF-000449', NULL, 'Embryonic ectoderm development', 122, NULL, NULL, 227870),
(227871, '3.90.1480.20-FF-000037', NULL, 'Uncharacterized protein', 146, NULL, NULL, 227871),
(227872, '1.10.730.10-FF-000226', NULL, 'Probable methionine--tRNA ligase, mitochondrial', 170, NULL, NULL, 227872),
(227873, '2.60.40.60-FF-000913', NULL, 'Uncharacterized protein', 101, NULL, NULL, 227873),
(227874, '2.170.130.20-FF-000013', NULL, NULL, 81, NULL, NULL, 227874),
(227875, '3.40.390.10-FF-000140', NULL, 'Uncharacterized protein', 170, NULL, NULL, 227875),
(227876, '3.40.50.1240-FF-000039', NULL, 'Phosphoglycerate mutase family protein', 224, NULL, NULL, 227876),
(227877, '1.20.1440.240-FF-000005', NULL, 'RebO-like L-amino acid oxidase', 96, NULL, NULL, 227877),
(227878, '1.20.1440.230-FF-000002', NULL, 'NADH-quinone oxidoreductase subunit F', 99, NULL, NULL, 227878),
(227879, '3.90.1750.10-FF-000044', NULL, 'E3 ubiquitin-protein ligase Ufd4', 35, NULL, NULL, 227879),
(227880, '1.10.238.10-FF-000880', NULL, 'Serine/threonine-protein phosphatase', 134, NULL, NULL, 227880),
(227881, '3.40.50.450-FF-000079', NULL, '6-phosphofructokinase', 222, NULL, NULL, 227881),
(227882, '3.40.1570.10-FF-000002', NULL, 'Hemin degrading factor', 163, NULL, NULL, 227882),
(227883, '2.170.130.10-FF-000010', NULL, 'Ferripyoverdine receptor', 132, NULL, NULL, 227883),
(227884, '2.60.40.10-FF-005013', NULL, NULL, 105, NULL, NULL, 227884),
(227885, '3.40.50.2300-FF-001358', NULL, NULL, 27, NULL, NULL, 227885),
(227886, '3.30.40.10-FF-001286', NULL, 'Predicted protein', 72, NULL, NULL, 227886),
(227887, '1.20.1250.20-FF-001471', NULL, 'Uncharacterized protein', 352, NULL, NULL, 227887),
(227888, '3.90.780.10-FF-000029', NULL, 'Uncharacterized protein C17G6.03', 186, NULL, NULL, 227888),
(227889, '1.20.920.30-FF-000008', NULL, 'Dynein heavy chain domain 1', 158, NULL, NULL, 227889),
(227890, '2.10.25.10-FF-001714', NULL, 'Uncharacterized protein', 40, NULL, NULL, 227890),
(227891, '3.40.30.10-FF-000975', NULL, 'NADP-reducing hydrogenase subunit HndB', 94, NULL, NULL, 227891),
(227892, '2.20.25.10-FF-000129', NULL, 'DNA-directed RNA polymerase subunit', 78, NULL, NULL, 227892);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(227893, '3.30.70.330-FF-001847', NULL, NULL, 114, NULL, NULL, 227893),
(227894, '3.30.420.110-FF-000041', NULL, 'DNA mismatch repair protein', 160, NULL, NULL, 227894),
(227895, '3.40.50.300-FF-004345', NULL, 'ABC transporter', 246, NULL, NULL, 227895),
(227896, '3.50.30.30-FF-000099', NULL, 'Uncharacterized protein', 127, NULL, NULL, 227896),
(227897, '3.40.50.2000-FF-000998', NULL, 'Alpha-1,4 glucan phosphorylase', 37, NULL, NULL, 227897),
(227898, '3.40.1810.10-FF-000055', NULL, NULL, 81, NULL, NULL, 227898),
(227899, '3.40.50.2020-FF-000184', NULL, 'Ribose phosphate diphosphokinase Prs1, putative (AFU_orthologue AFUA_7G05670)', 79, NULL, NULL, 227899),
(227900, '3.30.70.330-FF-002123', NULL, NULL, 105, NULL, NULL, 227900),
(227901, '1.50.10.20-FF-000110', NULL, 'Uncharacterized protein', 250, NULL, NULL, 227901),
(227902, '3.30.70.3490-FF-000014', NULL, 'OSH7p Oxysterol-binding protein', 90, NULL, NULL, 227902),
(227903, '3.30.420.40-FF-000840', NULL, 'Cell division protein FtsA', 109, NULL, NULL, 227903),
(227904, '3.10.129.10-FF-000001', NULL, '3-hydroxyacyl-[acyl-carrier-protein] dehydratase FabZ', 151, NULL, NULL, 227904),
(227905, '3.40.30.10-FF-001251', NULL, 'NADH:ubiquinone oxidoreductase core subunit V2', 32, NULL, NULL, 227905),
(227906, '1.20.140.100-FF-000051', NULL, 'Uncharacterized protein', 110, NULL, NULL, 227906),
(227907, '1.20.1560.10-FF-000041', NULL, 'Multidrug-Resistance like protein 1, isoform C', 330, NULL, NULL, 227907),
(227908, '2.120.10.30-FF-000208', NULL, 'Low density lipoprotein receptor-related protein 1Bb', 320, NULL, NULL, 227908),
(227909, '3.40.630.30-FF-000637', NULL, 'Putative acetyltransferase', 173, NULL, NULL, 227909),
(227910, '3.40.640.10-FF-000233', NULL, 'Aminotransferase class V-fold PLP-dependent enzyme', 266, NULL, NULL, 227910),
(227911, '3.40.1350.10-FF-000019', NULL, 'tRNA intron endonuclease', 91, NULL, NULL, 227911),
(227912, '1.25.40.190-FF-000008', NULL, 'Actin-related protein 2/3 complex subunit 5', 75, NULL, NULL, 227912),
(227913, '3.40.50.1440-FF-000015', NULL, 'Tubulin beta class I', 117, NULL, NULL, 227913),
(227914, '1.10.287.110-FF-000372', NULL, 'Diphthamide biosynthesis protein 4', 76, NULL, NULL, 227914),
(227915, '3.30.160.60-FF-004850', NULL, NULL, 36, NULL, NULL, 227915),
(227916, '3.30.300.90-FF-000003', NULL, 'BolA family member 3', 81, NULL, NULL, 227916),
(227917, '2.120.10.80-FF-000167', NULL, 'Kelch motif family protein, expressed', 208, NULL, NULL, 227917),
(227918, '2.40.50.140-FF-000315', NULL, 'DNA helicase MCM9, putative', 105, NULL, NULL, 227918),
(227919, '3.90.1140.10-FF-000008', NULL, 'U6 snRNA phosphodiesterase', 215, NULL, NULL, 227919),
(227920, '2.40.10.10-FF-000600', NULL, NULL, 128, NULL, NULL, 227920),
(227921, '2.170.260.10-FF-000008', NULL, 'Protein argonaute 7', 124, NULL, NULL, 227921),
(227922, '2.102.10.10-FF-000058', NULL, 'Arsenate reductase (Azurin) small subunit', 129, NULL, NULL, 227922),
(227923, '3.90.550.10-FF-000664', NULL, 'Os04g0429500 protein', 114, NULL, NULL, 227923),
(227924, '1.20.120.340-FF-000006', NULL, 'Perilipin', 76, NULL, NULL, 227924),
(227925, '3.40.630.10-FF-000401', NULL, 'Acetylornithine deacetylase ArgE', 242, NULL, NULL, 227925),
(227926, '3.30.200.20-FF-002116', NULL, 'Uncharacterized protein', 77, NULL, NULL, 227926),
(227927, '1.20.810.10-FF-000028', NULL, 'Uncharacterized protein', 79, NULL, NULL, 227927),
(227928, '1.20.1560.10-FF-000867', NULL, 'Uncharacterized protein', 153, NULL, NULL, 227928),
(227929, '3.30.60.20-FF-000115', NULL, 'PRKD2 isoform 13', 46, NULL, NULL, 227929),
(227930, '3.10.20.70-FF-000033', NULL, 'Uncharacterized protein', 100, NULL, NULL, 227930),
(227931, '3.30.70.20-FF-000043', NULL, 'Respiratory nitrate reductase beta subunit', 72, NULL, NULL, 227931),
(227932, '3.30.500.10-FF-000017', NULL, 'Uncharacterized protein', 180, NULL, NULL, 227932),
(227933, '3.30.40.10-FF-001640', NULL, 'HMG1/2 (High mobility group) box-containing protein', 49, NULL, NULL, 227933),
(227934, '3.10.100.10-FF-000244', NULL, NULL, 137, NULL, NULL, 227934);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(227935, '2.60.200.20-FF-000135', NULL, 'Uncharacterized protein', 128, NULL, NULL, 227935),
(227936, '1.10.3720.10-FF-000236', NULL, 'Putative uncharacterized protein HI_1475', 118, NULL, NULL, 227936),
(227937, '2.40.30.10-FF-000258', NULL, 'Uncharacterized protein', 121, NULL, NULL, 227937),
(227938, '3.10.450.50-FF-000001', NULL, 'calcium/calmodulin-dependent protein kinase type II subunit gamma isoform X1', 147, NULL, NULL, 227938),
(227939, '3.40.449.10-FF-000007', NULL, 'phosphoenolpyruvate carboxykinase [GTP], mitochondrial', 151, NULL, NULL, 227939),
(227940, '3.10.110.10-FF-000172', NULL, 'SUMO-conjugating enzyme UBC9-B-like', 76, NULL, NULL, 227940),
(227941, '1.20.120.330-FF-000003', NULL, 'Tyrosine-protein kinase', 106, NULL, NULL, 227941),
(227942, '1.25.40.10-FF-002713', NULL, 'TPR repeat', 56, NULL, NULL, 227942),
(227943, '2.60.40.60-FF-000458', NULL, 'Cadherin, EGF LAG seven-pass G-type receptor 1', 67, NULL, NULL, 227943),
(227944, '3.10.450.60-FF-000004', NULL, 'Arachidonate 12-lipoxygenase, 12S-type', 113, NULL, NULL, 227944),
(227945, '1.10.510.10-FF-002374', NULL, NULL, 148, NULL, NULL, 227945),
(227946, '2.60.40.630-FF-000001', NULL, 'Signal transducer and activator of transcription', 144, NULL, NULL, 227946),
(227947, '1.25.70.10-FF-000063', NULL, NULL, 260, NULL, NULL, 227947),
(227948, '2.30.30.40-FF-000560', NULL, 'Uncharacterized protein', 59, NULL, NULL, 227948),
(227949, '3.40.525.10-FF-000050', NULL, 'Neurofibromin-A', 153, NULL, NULL, 227949),
(227950, '1.10.3430.10-FF-000034', NULL, 'Ammonium transporter, putative', 145, NULL, NULL, 227950),
(227951, '2.10.25.10-FF-001259', NULL, 'Crumbs cell polarity complex component 2', 59, NULL, NULL, 227951),
(227952, '3.80.10.10-FF-001714', NULL, 'Immunoglobulin superfamily-containing leucine-rich repeat 2', 99, NULL, NULL, 227952),
(227953, '3.40.50.300-FF-002546', NULL, 'Irc3p', 179, NULL, NULL, 227953),
(227954, '3.10.28.10-FF-000055', NULL, 'DNA polymerase', 171, NULL, NULL, 227954),
(227955, '3.90.70.10-FF-000661', NULL, 'Ubiquitin-specific peptidase 32', 40, NULL, NULL, 227955),
(227956, '3.40.630.10-FF-000305', NULL, 'Carboxypeptidase A', 175, NULL, NULL, 227956),
(227957, '3.80.10.10-FF-002996', NULL, 'Uncharacterized protein', 102, NULL, NULL, 227957),
(227958, '3.40.50.1100-FF-000256', NULL, 'Predicted protein', 165, NULL, NULL, 227958),
(227959, '2.40.50.100-FF-000219', NULL, 'ABC transporter related', 32, NULL, NULL, 227959),
(227960, '3.40.50.300-FF-006245', NULL, 'Type III restriction enzyme, res subunit family protein', 212, NULL, NULL, 227960),
(227961, '2.40.170.20-FF-000018', NULL, 'Carboxypeptidase regulatory-like domain protein', 651, NULL, NULL, 227961),
(227962, '2.70.150.10-FF-000097', NULL, 'Cation transporter ATPase G', 111, NULL, NULL, 227962),
(227963, '3.90.980.20-FF-000020', NULL, 'Uncharacterized protein', 123, NULL, NULL, 227963),
(227964, '2.130.10.10-FF-000337', NULL, 'ATG16 autophagy related 16-like 1 (S. cerevisiae)', 80, NULL, NULL, 227964),
(227965, '1.10.238.10-FF-000554', NULL, 'Reticulocalbin 3', 88, NULL, NULL, 227965),
(227966, '3.50.4.10-FF-000062', NULL, NULL, 83, NULL, NULL, 227966),
(227967, '1.10.287.1970-FF-000008', NULL, 'Cc2-5', 11, NULL, NULL, 227967),
(227968, '3.50.50.60-FF-000075', NULL, 'Nitric oxide reductase FlRd-NAD(+) reductase', 133, NULL, NULL, 227968),
(227969, '2.60.40.10-FF-002063', NULL, 'Glucans biosynthesis protein D', 115, NULL, NULL, 227969),
(227970, '1.10.1780.10-FF-000015', NULL, 'ATP-dependent chaperone ClpB', 150, NULL, NULL, 227970),
(227971, '3.50.7.10-FF-000001', NULL, '60 kDa chaperonin', 182, NULL, NULL, 227971),
(227972, '3.40.50.10840-FF-000001', NULL, 'Ketose-bisphosphate aldolase class-II family protein', 262, NULL, NULL, 227972),
(227973, '3.30.160.60-FF-000472', NULL, 'myoneurin isoform X1', 30, NULL, NULL, 227973),
(227974, '3.40.50.300-FF-004800', NULL, 'YALI0F20724p', 228, NULL, NULL, 227974),
(227975, '3.30.160.60-FF-000808', NULL, 'Zinc finger and BTB domain-containing protein 43', 90, NULL, NULL, 227975),
(227976, '1.10.10.10-FF-000244', NULL, 'ETS-related transcription factor Elf-5 isoform X1', 132, NULL, NULL, 227976);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(227977, '3.40.50.970-FF-000223', NULL, 'Uncharacterized protein', 378, NULL, NULL, 227977),
(227978, '3.30.540.10-FF-000008', NULL, 'Fructose-1,6-bisphosphatase, cytosolic', 200, NULL, NULL, 227978),
(227979, '3.40.140.10-FF-000105', NULL, 'Hypothetical_protein_-_conserved', 172, NULL, NULL, 227979),
(227980, '3.40.190.10-FF-000254', NULL, 'Prephenate dehydratase', 108, NULL, NULL, 227980),
(227981, '3.50.50.60-FF-001177', NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', 218, NULL, NULL, 227981),
(227982, '2.60.200.20-FF-000039', NULL, 'Forkhead transcription factor Fkh1/2', 130, NULL, NULL, 227982),
(227983, '2.60.40.10-FF-001787', NULL, 'Uncharacterized protein, isoform C', 99, NULL, NULL, 227983),
(227984, '3.30.40.10-FF-000100', NULL, 'E3 ubiquitin-protein ligase RING2', 71, NULL, NULL, 227984),
(227985, '3.40.50.11980-FF-000017', NULL, 'Uncharacterized protein', 29, NULL, NULL, 227985),
(227986, '3.40.50.1000-FF-000344', NULL, 'Protein CBG09463', 136, NULL, NULL, 227986),
(227987, '3.90.226.10-FF-000175', NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', 355, NULL, NULL, 227987),
(227988, '3.40.50.720-FF-001705', NULL, 'Myo-inositol-1-phosphate synthase', 171, NULL, NULL, 227988),
(227989, '2.120.10.30-FF-000304', NULL, 'Predicted protein', 243, NULL, NULL, 227989),
(227990, '2.30.180.10-FF-000142', NULL, NULL, 138, NULL, NULL, 227990),
(227991, '2.10.220.10-FF-000066', NULL, 'Receptor protein-tyrosine kinase', 48, NULL, NULL, 227991),
(227992, '1.25.70.10-FF-000080', NULL, NULL, 222, NULL, NULL, 227992),
(227993, '3.30.505.10-FF-000118', NULL, 'SH2 domain-containing adapter protein B', 52, NULL, NULL, 227993),
(227994, '2.130.10.10-FF-004053', NULL, 'Uncharacterized protein', 213, NULL, NULL, 227994),
(227995, '3.30.160.60-FF-002372', NULL, 'IKAROS family zinc finger 3', 60, NULL, NULL, 227995),
(227996, '3.30.160.60-FF-005013', NULL, NULL, 62, NULL, NULL, 227996),
(227997, '2.160.20.60-FF-000008', NULL, 'Ferredoxin/NAD(P)H-dependent glutamate synthase, large subunit', 286, NULL, NULL, 227997),
(227998, '1.25.40.10-FF-004304', NULL, 'Uncharacterized protein', 191, NULL, NULL, 227998),
(227999, '1.10.150.340-FF-000003', NULL, 'Uncharacterized protein', 74, NULL, NULL, 227999),
(228000, '3.40.50.1820-FF-001427', NULL, 'Predicted protein', 196, NULL, NULL, 228000),
(228001, '3.40.50.150-FF-000551', NULL, 'Methyltransferase domain containing protein, putative', 246, NULL, NULL, 228001),
(228002, '1.25.10.10-FF-001498', NULL, 'Pumilio/PUF RNA binding protein 10, putative', 199, NULL, NULL, 228002),
(228003, '3.30.60.30-FF-000118', NULL, 'Uncharacterized protein', 69, NULL, NULL, 228003),
(228004, '1.10.20.10-FF-000172', NULL, 'Histone H2A', 117, NULL, NULL, 228004),
(228005, '1.20.1280.50-FF-000138', NULL, 'Chromosome 1, whole genome shotgun sequence', 51, NULL, NULL, 228005),
(228006, '1.10.10.820-FF-000022', NULL, 'Uncharacterized protein, isoform A', 69, NULL, NULL, 228006),
(228007, '1.10.760.10-FF-000054', NULL, 'Cytochrome c551 peroxidase', 125, NULL, NULL, 228007),
(228008, '1.20.5.390-FF-000005', NULL, 'LINE-1 retrotransposable element ORF1 protein', 50, NULL, NULL, 228008),
(228009, '1.20.120.720-FF-000013', NULL, 'unconventional myosin-Ic isoform X2', 108, NULL, NULL, 228009),
(228010, '2.130.10.10-FF-003777', NULL, 'Uncharacterized protein', 316, NULL, NULL, 228010),
(228011, '3.40.50.2000-FF-000301', NULL, 'Glycosyltransferase', 246, NULL, NULL, 228011),
(228012, '3.30.230.10-FF-000024', NULL, '30S ribosomal protein S5', 76, NULL, NULL, 228012),
(228013, '2.130.10.10-FF-004620', NULL, 'EF hand family protein', 199, NULL, NULL, 228013),
(228014, '1.25.40.20-FF-001070', NULL, 'Poly [ADP-ribose] polymerase', 131, NULL, NULL, 228014),
(228015, '3.30.200.20-FF-000525', NULL, 'Serine/threonine-protein kinase KIN3', 87, NULL, NULL, 228015),
(228016, '1.20.1000.10-FF-000022', NULL, 'Uncharacterized protein', 295, NULL, NULL, 228016),
(228017, '3.90.1480.20-FF-000054', NULL, 'Alpha-2,8-sialyltransferase', 165, NULL, NULL, 228017),
(228018, '1.25.40.20-FF-000581', NULL, 'POTE ankyrin domain family member E', 284, NULL, NULL, 228018);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(228019, '1.20.1250.20-FF-001145', NULL, 'Battenin', 250, NULL, NULL, 228019),
(228020, '1.10.1420.10-FF-000062', NULL, 'DNA mismatch repair protein MSH2', 95, NULL, NULL, 228020),
(228021, '3.10.20.90-FF-000606', NULL, 'MAP kinase', 114, NULL, NULL, 228021),
(228022, '3.40.50.880-FF-000191', NULL, 'Imidazole glycerol phosphate synthase hisHF chloroplastic', 150, NULL, NULL, 228022),
(228023, '2.160.20.10-FF-000022', NULL, 'F-box only protein 10', 187, NULL, NULL, 228023),
(228024, '2.60.40.1120-FF-000011', NULL, 'Carboxypeptidase N catalytic chain', 78, NULL, NULL, 228024),
(228025, '3.30.160.60-FF-006424', NULL, NULL, 24, NULL, NULL, 228025),
(228026, '1.10.167.10-FF-000029', NULL, 'G protein-coupled receptor kinase', 54, NULL, NULL, 228026),
(228027, '1.20.120.730-FF-000016', NULL, 'Protein transport protein Sec24-like At3g07100', 138, NULL, NULL, 228027),
(228028, '3.90.70.10-FF-000335', NULL, 'Cysteine protease-related protein', 243, NULL, NULL, 228028),
(228029, '3.30.420.10-FF-000758', NULL, NULL, 70, NULL, NULL, 228029),
(228030, '2.60.40.10-FF-000808', NULL, 'Leukemia inhibitory factor receptor', 119, NULL, NULL, 228030),
(228031, '1.10.405.40-FF-000002', NULL, NULL, 164, NULL, NULL, 228031),
(228032, '6.10.140.2150-FF-000012', NULL, 'Putative sphingosine-1-phosphate lyase', 45, NULL, NULL, 228032),
(228033, '1.20.58.80-FF-000037', NULL, 'Putative associated molecule with the SH3 domain of STAM', 111, NULL, NULL, 228033),
(228034, '1.10.8.60-FF-000578', NULL, 'Uncharacterized protein', 44, NULL, NULL, 228034),
(228035, '1.10.10.10-FF-000805', NULL, 'ROK family transcriptional regulator', 68, NULL, NULL, 228035),
(228036, '3.30.160.60-FF-004524', NULL, NULL, 29, NULL, NULL, 228036),
(228037, '1.20.1070.10-FF-001594', NULL, 'Seven TM Receptor', 154, NULL, NULL, 228037),
(228038, '2.60.120.920-FF-000187', NULL, 'LOC100127740 protein', 109, NULL, NULL, 228038),
(228039, '2.40.100.10-FF-000067', NULL, 'Peptidyl-prolyl cis-trans isomerase', 189, NULL, NULL, 228039),
(228040, '3.90.740.10-FF-000038', NULL, 'Isoleucyl-tRNA synthetase', 166, NULL, NULL, 228040),
(228041, '3.40.50.300-FF-004671', NULL, 'Uncharacterized protein', 174, NULL, NULL, 228041),
(228042, '3.40.47.10-FF-000160', NULL, 'Beta-ketoacyl synthase PigJ', 262, NULL, NULL, 228042),
(228043, '1.50.40.10-FF-000289', NULL, 'Mitochondrial substrate carrier family protein', 210, NULL, NULL, 228043),
(228044, '3.30.450.200-FF-000006', NULL, 'DENN domain and WD repeat-containing protein SCD1', 176, NULL, NULL, 228044),
(228045, '3.40.50.150-FF-000449', NULL, '23S rRNA (Uracil-5-)-methyltransferase RumA', 209, NULL, NULL, 228045),
(228046, '3.90.550.10-FF-000097', NULL, 'Glycosyl transferase', 267, NULL, NULL, 228046),
(228047, '3.40.50.1980-FF-000042', NULL, 'Iron-regulated ABC transporter siderophore-binding protein SirA', 188, NULL, NULL, 228047),
(228048, '3.30.40.10-FF-001847', NULL, 'Uncharacterized protein', 82, NULL, NULL, 228048),
(228049, '2.40.70.10-FF-000143', NULL, 'OSJNBa0006A01.20 protein', 172, NULL, NULL, 228049),
(228050, '1.20.58.60-FF-000031', NULL, 'Microtubule-actin cross-linking factor 1', 111, NULL, NULL, 228050),
(228051, '2.120.10.100-FF-000001', NULL, 'Soluble calcium-activated nucleotidase 1', 325, NULL, NULL, 228051),
(228052, '2.30.29.30-FF-001228', NULL, 'Uncharacterized protein', 116, NULL, NULL, 228052),
(228053, '3.40.30.10-FF-000649', NULL, 'Magnesium transporter 1', 100, NULL, NULL, 228053),
(228054, '3.40.30.10-FF-000436', NULL, 'Probable 28S ribosomal protein S25, mitochondrial', 89, NULL, NULL, 228054),
(228055, '1.10.506.10-FF-000043', NULL, 'Plexin C1', 221, NULL, NULL, 228055),
(228056, '1.20.58.1930-FF-000004', NULL, 'Erythrocyte membrane protein 1, PfEMP1', 234, NULL, NULL, 228056),
(228057, '2.40.10.10-FF-000246', NULL, 'inactive serine protease 35', 52, NULL, NULL, 228057),
(228058, '3.30.565.10-FF-000195', NULL, 'Sensor histidine kinase', 151, NULL, NULL, 228058),
(228059, '1.25.10.10-FF-000183', NULL, 'Proteasome activator complex subunit 4', 501, NULL, NULL, 228059),
(228060, '2.70.98.20-FF-000006', NULL, 'Amine oxidase', 429, NULL, NULL, 228060);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(228061, '2.60.40.10-FF-005839', NULL, NULL, 109, NULL, NULL, 228061),
(228062, '1.20.58.70-FF-000034', NULL, 'Syntaxin 5', 206, NULL, NULL, 228062),
(228063, '3.10.10.10-FF-000003', NULL, 'Retrovirus-related Pol polyprotein from transposon 297-like Protein', 112, NULL, NULL, 228063),
(228064, '2.70.98.10-FF-000003', NULL, 'Aldose 1-epimerase', 348, NULL, NULL, 228064),
(228065, '1.25.10.10-FF-000396', NULL, 'E3 ubiquitin-protein ligase listerin isoform X1', 141, NULL, NULL, 228065),
(228066, '2.60.40.150-FF-000733', NULL, 'Phosphoinositide phospholipase C', 112, NULL, NULL, 228066),
(228067, '3.40.50.1580-FF-000012', NULL, 'Probable 6-oxopurine nucleoside phosphorylase', 265, NULL, NULL, 228067),
(228068, '4.10.60.10-FF-000004', NULL, 'cellular nucleic acid-binding protein isoform X2', 23, NULL, NULL, 228068),
(228069, '2.130.10.10-FF-002366', NULL, 'Uncharacterized protein', 326, NULL, NULL, 228069),
(228070, '2.170.270.10-FF-000166', NULL, 'Uncharacterized protein', 121, NULL, NULL, 228070),
(228071, '1.10.510.10-FF-000249', NULL, 'Calcium-dependent protein kinase SK5', 185, NULL, NULL, 228071),
(228072, '3.30.1380.20-FF-000032', NULL, 'Uncharacterized protein', 161, NULL, NULL, 228072),
(228073, '2.60.120.620-FF-000092', NULL, 'Uncharacterized protein', 259, NULL, NULL, 228073),
(228074, '2.130.10.10-FF-001877', NULL, 'Autophagy-related protein 16 isoform A', 159, NULL, NULL, 228074),
(228075, '3.30.1640.10-FF-000061', NULL, 'DNA helicase', 105, NULL, NULL, 228075),
(228076, '1.20.1250.20-FF-001706', NULL, 'Uncharacterized protein', 93, NULL, NULL, 228076),
(228077, '1.10.10.10-FF-000452', NULL, 'Rap guanine nucleotide exchange factor 5', 91, NULL, NULL, 228077),
(228078, '3.40.30.10-FF-000863', NULL, 'Grx4 family monothiol glutaredoxin', 126, NULL, NULL, 228078),
(228079, '1.20.1070.10-FF-001723', NULL, 'Uncharacterized protein', 99, NULL, NULL, 228079),
(228080, '3.40.50.970-FF-000015', NULL, '2-oxoisovalerate dehydrogenase subunit alpha', 399, NULL, NULL, 228080),
(228081, '3.40.50.300-FF-008156', NULL, 'Uncharacterized protein', 91, NULL, NULL, 228081),
(228082, '2.60.40.60-FF-000801', NULL, 'Uncharacterized protein', 81, NULL, NULL, 228082),
(228083, '3.40.1260.10-FF-000012', NULL, 'Uncharacterized protein', 114, NULL, NULL, 228083),
(228084, '1.10.472.10-FF-000255', NULL, 'Si:ch211-132b12.8', 119, NULL, NULL, 228084),
(228085, '3.40.50.300-FF-001231', NULL, 'Protein CLP1 homolog', 232, NULL, NULL, 228085),
(228086, '3.90.79.10-FF-000181', NULL, 'YALI0F26059p', 280, NULL, NULL, 228086),
(228087, '3.40.1280.10-FF-000013', NULL, 'RNA methyltransferase', 167, NULL, NULL, 228087),
(228088, '3.10.180.10-FF-000007', NULL, '4-hydroxyphenylpyruvate dioxygenase', 198, NULL, NULL, 228088),
(228089, '3.10.20.90-FF-000477', NULL, 'U11/U12 small nuclear ribonucleoprotein 25 kDa protein', 96, NULL, NULL, 228089),
(228090, '3.30.565.10-FF-000223', NULL, 'Sensor histidine kinase', 152, NULL, NULL, 228090),
(228091, '3.30.1380.20-FF-000026', NULL, 'Transport protein particle (Trapp) component, bet3 protein, putative', 159, NULL, NULL, 228091),
(228092, '3.30.2410.10-FF-000038', NULL, 'HECT-domain ubiquitin--protein ligase E3', 112, NULL, NULL, 228092),
(228093, '3.50.50.60-FF-000103', NULL, 'Putative N-methylproline demethylase', 130, NULL, NULL, 228093),
(228094, '3.30.1360.120-FF-000089', NULL, 'Uncharacterized protein', 255, NULL, NULL, 228094),
(228095, '2.60.40.10-FF-000247', NULL, 'Vascular endothelial growth factor receptor 3', 112, NULL, NULL, 228095),
(228096, '3.40.50.300-FF-002760', NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', 188, NULL, NULL, 228096),
(228097, '1.25.10.10-FF-002223', NULL, 'Os10g0508500 protein', 401, NULL, NULL, 228097),
(228098, '3.20.20.450-FF-000015', NULL, 'Biofilm formation regulator HmsP', 254, NULL, NULL, 228098),
(228099, '3.30.360.10-FF-000028', NULL, 'GLUCOSE-FRUCTOSE OXIDOREDUCTASE', 242, NULL, NULL, 228099),
(228100, '2.60.200.20-FF-000247', NULL, 'Uncharacterized protein', 121, NULL, NULL, 228100),
(228101, '1.25.40.20-FF-000704', NULL, 'Uncharacterized protein', 173, NULL, NULL, 228101);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(228102, '1.10.238.10-FF-000228', NULL, 'polycystin-2 isoform X1', 74, NULL, NULL, 228102),
(228103, '2.40.440.10-FF-000019', NULL, 'L,D-transpeptidase catalytic domain protein', 130, NULL, NULL, 228103),
(228104, '2.90.10.10-FF-000047', NULL, 'Putative inactive G-type lectin S-receptor-like serine/threonine-protein kinase SRK', 130, NULL, NULL, 228104),
(228105, '2.60.40.10-FF-004524', NULL, NULL, 50, NULL, NULL, 228105),
(228106, '3.10.129.10-FF-000113', NULL, 'Thioesterase superfamily protein', 137, NULL, NULL, 228106),
(228107, '1.10.10.10-FF-001975', NULL, 'Uncharacterized protein', 62, NULL, NULL, 228107),
(228108, '2.170.270.10-FF-000048', NULL, 'Histone-lysine N-methyltransferase, putative', 87, NULL, NULL, 228108),
(228109, '3.30.450.20-FF-000589', NULL, 'Uncharacterized protein', 159, NULL, NULL, 228109),
(228110, '1.25.40.10-FF-000701', NULL, 'Pentatricopeptide repeat protein (AFU_orthologue AFUA_4G07240)', 188, NULL, NULL, 228110),
(228111, '3.40.50.1980-FF-000137', NULL, 'Manganese ABC transporter, periplasmic protein', 126, NULL, NULL, 228111),
(228112, '3.30.200.20-FF-001386', NULL, 'Eukaryotic protein kinase', 89, NULL, NULL, 228112),
(228113, '1.10.510.10-FF-003003', NULL, NULL, 139, NULL, NULL, 228113),
(228114, '3.30.870.10-FF-000106', NULL, 'Phosphatidylcholine-hydrolyzing phospholipase D (PLD) family', 106, NULL, NULL, 228114),
(228115, '1.25.40.10-FF-002152', NULL, 'Pentatricopeptide repeat-containing protein', 121, NULL, NULL, 228115),
(228116, '4.10.400.10-FF-000084', NULL, 'Low density lipoprotein receptor', 38, NULL, NULL, 228116),
(228117, '3.30.160.60-FF-001410', NULL, 'Histone H4 transcription factor', 27, NULL, NULL, 228117),
(228118, '3.40.50.280-FF-000005', NULL, 'Fused isobutyryl-CoA mutase', 143, NULL, NULL, 228118),
(228119, '1.10.510.10-FF-002503', NULL, NULL, 146, NULL, NULL, 228119),
(228120, '3.30.200.20-FF-001487', NULL, 'Putative LRR receptor-like serine/threonine-protein kinase isoform A', 101, NULL, NULL, 228120),
(228121, '3.30.1320.10-FF-000020', NULL, 'Uncharacterized protein', 56, NULL, NULL, 228121),
(228122, '1.10.10.440-FF-000099', NULL, 'Uncharacterized protein', 49, NULL, NULL, 228122),
(228123, '3.30.70.330-FF-000206', NULL, 'Smooth, isoform L', 103, NULL, NULL, 228123),
(228124, '2.160.20.10-FF-000134', NULL, 'F-box protein 10', 94, NULL, NULL, 228124),
(228125, '3.40.640.10-FF-000121', NULL, 'Aspartate aminotransferase', 271, NULL, NULL, 228125),
(228126, '4.10.320.10-FF-000026', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 51, NULL, NULL, 228126),
(228127, '3.90.70.10-FF-000217', NULL, 'Uncharacterized protein, isoform B', 338, NULL, NULL, 228127),
(228128, '3.70.10.10-FF-000057', NULL, 'DNA polymerase III subunit beta', 189, NULL, NULL, 228128),
(228129, '3.40.120.10-FF-000109', NULL, 'Phosphoglucomutase', 176, NULL, NULL, 228129),
(228130, '3.90.110.10-FF-000007', NULL, 'ubiquitin-conjugating enzyme E2 variant 3 isoform X1', 153, NULL, NULL, 228130),
(228131, '3.40.50.300-FF-004457', NULL, 'Sulfate adenylyltransferase', 125, NULL, NULL, 228131),
(228132, '2.60.40.1800-FF-000001', NULL, 'Subtilisin-like serine protease', 119, NULL, NULL, 228132),
(228133, '1.20.1310.10-FF-000023', NULL, 'cullin-1', 157, NULL, NULL, 228133),
(228134, '3.40.50.720-FF-001694', NULL, 'Putative uncharacterized protein YPL276W', 25, NULL, NULL, 228134),
(228135, '3.40.30.10-FF-000762', NULL, 'Predicted protein', 78, NULL, NULL, 228135),
(228136, '3.30.420.40-FF-000177', NULL, 'Glycerol kinase', 255, NULL, NULL, 228136),
(228137, '3.40.50.150-FF-000219', NULL, 'tRNA (Carboxymethyluridine(34)-5-O)-methyltransferase', 202, NULL, NULL, 228137),
(228138, '1.10.510.10-FF-000148', NULL, 'Serine/threonine-protein kinase Nek7', 191, NULL, NULL, 228138),
(228139, '3.40.50.1820-FF-000022', NULL, 'Esterase FrsA', 399, NULL, NULL, 228139),
(228140, '3.40.250.10-FF-000198', NULL, 'Adenylyltransferase and sulfurtransferase UBA4', 103, NULL, NULL, 228140),
(228141, '2.60.40.60-FF-000700', NULL, 'Protocadherin Fat 4', 102, NULL, NULL, 228141);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(228142, '3.30.160.60-FF-000685', NULL, 'Zinc finger protein 653', 27, NULL, NULL, 228142),
(228143, '1.20.210.10-FF-000033', NULL, 'Cytochrome c oxidase, subunit I', 533, NULL, NULL, 228143),
(228144, '2.130.10.10-FF-004502', NULL, 'Dynein intermediate chain, putative', 239, NULL, NULL, 228144),
(228145, '2.30.30.30-FF-000113', NULL, '50S small subunit ribosomal protein L2', 105, NULL, NULL, 228145),
(228146, '1.10.10.60-FF-001299', NULL, NULL, 85, NULL, NULL, 228146),
(228147, '2.60.40.1820-FF-000007', NULL, 'NDR1/HIN1-like protein 13', 140, NULL, NULL, 228147),
(228148, '3.30.160.60-FF-004636', NULL, NULL, 27, NULL, NULL, 228148),
(228149, '1.10.238.10-FF-000341', NULL, 'Putative calcium-binding protein CML19', 69, NULL, NULL, 228149),
(228150, '2.120.10.30-FF-000085', NULL, 'Teneurin-1', 109, NULL, NULL, 228150),
(228151, '3.30.890.10-FF-000006', NULL, 'Methyl-CpG-binding domain protein 4', 127, NULL, NULL, 228151),
(228152, '2.30.30.40-FF-000116', NULL, 'Sorting nexin', 66, NULL, NULL, 228152),
(228153, '3.30.9.10-FF-000275', NULL, 'Predicted protein', 89, NULL, NULL, 228153),
(228154, '3.40.50.1820-FF-001545', NULL, 'Uncharacterized protein', 129, NULL, NULL, 228154),
(228155, '3.30.200.20-FF-002212', NULL, NULL, 46, NULL, NULL, 228155),
(228156, '2.30.230.10-FF-000011', NULL, 'Apolipophorins', 240, NULL, NULL, 228156),
(228157, '3.30.1490.40-FF-000012', NULL, NULL, 87, NULL, NULL, 228157),
(228158, '2.130.10.10-FF-004171', NULL, 'Uncharacterized protein', 167, NULL, NULL, 228158),
(228159, '2.130.10.10-FF-004491', NULL, 'WD repeat domain 5B-like', 135, NULL, NULL, 228159),
(228160, '2.120.10.80-FF-000280', NULL, 'Predicted protein', 312, NULL, NULL, 228160),
(228161, '3.30.565.10-FF-000318', NULL, 'DNA mismatch repair protein mlh1', 213, NULL, NULL, 228161),
(228162, '4.10.400.10-FF-000179', NULL, 'Terribly reduced optic lobes, isoform AH', 42, NULL, NULL, 228162),
(228163, '3.30.420.150-FF-000024', NULL, 'Ppx/GppA phosphatase family-domain-containing protein', 155, NULL, NULL, 228163),
(228164, '1.20.1250.20-FF-000301', NULL, 'Protein ZINC INDUCED FACILITATOR-LIKE 1', 434, NULL, NULL, 228164),
(228165, '1.20.1070.10-FF-000200', NULL, 'Adhesion G protein-coupled receptor L3', 282, NULL, NULL, 228165),
(228166, '1.10.287.3700-FF-000005', NULL, 'PAN2-PAN3 deadenylation complex subunit pan3', 92, NULL, NULL, 228166),
(228167, '3.30.450.200-FF-000012', NULL, 'DENN domain containing protein 2D', 131, NULL, NULL, 228167),
(228168, '1.25.40.10-FF-003675', NULL, 'Uncharacterized protein', 80, NULL, NULL, 228168),
(228169, '1.10.472.10-FF-000356', NULL, 'CYclin A', 107, NULL, NULL, 228169),
(228170, '2.130.10.10-FF-000803', NULL, 'WD repeat and SOCS box-containing 1, isoform CRA_b', 139, NULL, NULL, 228170),
(228171, '3.40.30.10-FF-001037', NULL, 'Uncharacterized protein', 32, NULL, NULL, 228171),
(228172, '1.10.510.10-FF-002278', NULL, NULL, 255, NULL, NULL, 228172),
(228173, '1.20.1050.10-FF-000300', NULL, 'Uncharacterized protein', 73, NULL, NULL, 228173),
(228174, '3.40.50.980-FF-000018', NULL, 'Non-ribosomal peptide synthetase', 162, NULL, NULL, 228174),
(228175, '3.60.21.10-FF-000280', NULL, 'Sphingomyelinase phosphodiesterase C', 346, NULL, NULL, 228175),
(228176, '1.10.3720.10-FF-000023', NULL, 'Peptide ABC transporter permease SapB', 206, NULL, NULL, 228176),
(228177, '3.40.50.300-FF-006711', NULL, 'Uncharacterized protein', 76, NULL, NULL, 228177),
(228178, '3.40.1280.30-FF-000019', NULL, 'Uncharacterized protein', 109, NULL, NULL, 228178),
(228179, '2.60.40.10-FF-004187', NULL, NULL, 84, NULL, NULL, 228179),
(228180, '3.40.50.2000-FF-001049', NULL, 'Protein CBG08157', 126, NULL, NULL, 228180),
(228181, '3.40.50.300-FF-000517', NULL, 'Cytoplasmic dynein heavy chain 1', 231, NULL, NULL, 228181),
(228182, '3.40.50.12390-FF-000011', NULL, 'Putative 5''-3'' exonuclease', 119, NULL, NULL, 228182),
(228183, '1.10.287.2900-FF-000007', NULL, 'MIX14p Mitochondrial intermembrane space protein', 45, NULL, NULL, 228183),
(228184, '3.40.630.30-FF-000188', NULL, 'Acetyltransferase, GNAT family', 168, NULL, NULL, 228184); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(228185, '3.30.450.20-FF-000004', NULL, 'Period circadian protein homolog 3', 158, NULL, NULL, 228185),
(228186, '3.90.550.10-FF-000125', NULL, 'Putative glycosyltransferase CsbB', 195, NULL, NULL, 228186),
(228187, '3.30.40.10-FF-000330', NULL, 'nitric oxide synthase-interacting protein-like', 118, NULL, NULL, 228187),
(228188, '1.10.510.10-FF-000575', NULL, 'Serine/threonine protein kinase', 259, NULL, NULL, 228188),
(228189, '1.10.238.10-FF-000436', NULL, 'AcTiniN', 66, NULL, NULL, 228189),
(228190, '3.40.50.300-FF-006812', NULL, 'ADP-ribosylation factor-like protein 4A', 47, NULL, NULL, 228190),
(228191, '3.90.550.50-FF-000210', NULL, 'Hexosyltransferase', 160, NULL, NULL, 228191),
(228192, '3.40.47.10-FF-000047', NULL, 'Acetyl-CoA acetyltransferase FadA6', 386, NULL, NULL, 228192),
(228193, '3.30.450.30-FF-000007', NULL, 'Profilin', 125, NULL, NULL, 228193),
(228194, '3.40.630.10-FF-000182', NULL, 'Peptidase M14 carboxypeptidase A', 303, NULL, NULL, 228194),
(228195, '1.10.30.10-FF-000127', NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily E member 1', 92, NULL, NULL, 228195),
(228196, '1.10.4080.10-FF-000007', NULL, 'Uncharacterized protein', 290, NULL, NULL, 228196),
(228197, '3.40.50.720-FF-001593', NULL, 'Putative ubiquinone oxidoreductase ndufa9/39kda subunit', 205, NULL, NULL, 228197),
(228198, '3.30.70.330-FF-001398', NULL, 'heterogeneous nuclear ribonucleoprotein A1 isoform X1', 79, NULL, NULL, 228198),
(228199, '3.40.50.720-FF-002211', NULL, '2''-dehydrokanamycin reductase', 298, NULL, NULL, 228199),
(228200, '3.40.50.1100-FF-000262', NULL, 'Uncharacterized protein', 120, NULL, NULL, 228200),
(228201, '1.25.40.10-FF-004181', NULL, 'Cytochrome c maturation system haem lyase subunit SirG', 85, NULL, NULL, 228201),
(228202, '3.20.20.220-FF-000076', NULL, 'Proline dehydrogenase', 178, NULL, NULL, 228202),
(228203, '3.40.50.300-FF-004558', NULL, 'Predicted protein', 139, NULL, NULL, 228203),
(228204, '3.30.1610.10-FF-000019', NULL, 'Predicted protein', 139, NULL, NULL, 228204),
(228205, '3.90.920.10-FF-000024', NULL, 'DNA primase', 357, NULL, NULL, 228205),
(228206, '2.120.10.30-FF-000416', NULL, 'Uncharacterized protein', 181, NULL, NULL, 228206),
(228207, '3.90.70.10-FF-000902', NULL, 'Probable ubiquitin carboxyl-terminal hydrolase 7', 282, NULL, NULL, 228207),
(228208, '1.10.150.80-FF-000034', NULL, 'ATP-dependent helicase SGS1, putative', 92, NULL, NULL, 228208),
(228209, '3.90.550.50-FF-000193', NULL, 'Predicted protein', 273, NULL, NULL, 228209),
(228210, '2.40.30.10-FF-000028', NULL, 'GTP-binding protein 1,-like', 75, NULL, NULL, 228210),
(228211, '1.20.1070.10-FF-000779', NULL, 'Predicted protein', 122, NULL, NULL, 228211),
(228212, '2.60.120.10-FF-000777', NULL, 'Uncharacterized protein', 20, NULL, NULL, 228212),
(228213, '3.60.21.10-FF-000487', NULL, 'Uncharacterized protein', 149, NULL, NULL, 228213),
(228214, '3.30.230.130-FF-000065', NULL, 'YALI0E04983p', 147, NULL, NULL, 228214),
(228215, '3.80.10.10-FF-001585', NULL, 'Leucine-rich repeat family protein', 80, NULL, NULL, 228215),
(228216, '4.10.1190.10-FF-000001', NULL, 'Photosystem I reaction center subunit N', 85, NULL, NULL, 228216),
(228217, '2.60.40.10-FF-004204', NULL, NULL, 80, NULL, NULL, 228217),
(228218, '1.10.10.10-FF-000238', NULL, 'HTH-type transcriptional activator TtdR', 84, NULL, NULL, 228218),
(228219, '1.25.40.20-FF-000693', NULL, 'Ankyrin repeat domain 2', 79, NULL, NULL, 228219),
(228220, '3.10.110.10-FF-000200', NULL, 'RBR-type E3 ubiquitin transferase', 89, NULL, NULL, 228220),
(228221, '1.20.5.190-FF-000164', NULL, NULL, 69, NULL, NULL, 228221),
(228222, '3.90.70.10-FF-000009', NULL, 'Putative ubiquitin carboxyl-terminal hydrolase CYLD', 374, NULL, NULL, 228222),
(228223, '2.60.40.1510-FF-000021', NULL, 'Integrin beta', 33, NULL, NULL, 228223),
(228224, '3.30.530.20-FF-000062', NULL, 'LD05321p', 202, NULL, NULL, 228224),
(228225, '1.20.120.430-FF-000027', NULL, 'AGAP002133-PA', 172, NULL, NULL, 228225),
(228226, '2.102.10.10-FF-000064', NULL, 'Ubiquinol cytochrome C reductase, subunit RIP1, putative', 83, NULL, NULL, 228226);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(228227, '3.90.70.200-FF-000002', NULL, 'Zinc finger CCCH domain-containing protein 19', 130, NULL, NULL, 228227),
(228228, '2.130.10.10-FF-005694', NULL, 'Uncharacterized protein', 153, NULL, NULL, 228228),
(228229, '4.10.400.10-FF-000292', NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein-like Protein', 41, NULL, NULL, 228229),
(228230, '3.30.360.10-FF-000141', NULL, 'Uncharacterized protein', 90, NULL, NULL, 228230),
(228231, '2.160.20.10-FF-000252', NULL, 'Uncharacterized protein', 88, NULL, NULL, 228231),
(228232, '3.30.590.10-FF-000051', NULL, 'Creatine kinase, M-type', 214, NULL, NULL, 228232),
(228233, '3.10.196.10-FF-000010', NULL, 'Methionine synthase', 112, NULL, NULL, 228233),
(228234, '3.30.750.24-FF-000150', NULL, 'Probable sulfate permease C320.05', 132, NULL, NULL, 228234),
(228235, '3.40.50.300-FF-008061', NULL, 'Uncharacterized protein', 125, NULL, NULL, 228235),
(228236, '3.90.550.10-FF-000552', NULL, 'Uncharacterized protein', 314, NULL, NULL, 228236),
(228237, '1.25.10.10-FF-002324', NULL, 'Uncharacterized protein', 305, NULL, NULL, 228237),
(228238, '1.20.1310.10-FF-000135', NULL, NULL, 115, NULL, NULL, 228238),
(228239, '3.30.230.70-FF-000126', NULL, 'Uncharacterized protein', 216, NULL, NULL, 228239),
(228240, '1.10.10.10-FF-001767', NULL, 'Uncharacterized protein', 84, NULL, NULL, 228240),
(228241, '2.70.170.10-FF-000109', NULL, 'Uncharacterized protein', 129, NULL, NULL, 228241),
(228242, '3.30.1540.20-FF-000016', NULL, 'DNA mismatch repair protein MutL', 34, NULL, NULL, 228242),
(228243, '2.30.30.40-FF-000228', NULL, 'RUN and SH3 domain containing 2', 91, NULL, NULL, 228243),
(228244, '3.90.226.10-FF-000063', NULL, 'ATP-dependent Clp protease proteolytic subunit', 184, NULL, NULL, 228244),
(228245, '3.30.70.240-FF-000056', NULL, 'Uncharacterized protein', 139, NULL, NULL, 228245),
(228246, '3.30.70.330-FF-001960', NULL, NULL, 241, NULL, NULL, 228246),
(228247, '3.30.160.60-FF-002607', NULL, 'zinc finger protein 184', 26, NULL, NULL, 228247),
(228248, '3.80.10.10-FF-003625', NULL, 'Uncharacterized protein', 249, NULL, NULL, 228248),
(228249, '3.30.200.20-FF-000290', NULL, 'Non-specific serine/threonine protein kinase', 123, NULL, NULL, 228249),
(228250, '2.10.25.10-FF-001265', NULL, 'Protein Z, vitamin K-dependent plasma glycoprotein a', 49, NULL, NULL, 228250),
(228251, '3.50.50.60-FF-000530', NULL, 'Choline dehydrogenase, like protein', 263, NULL, NULL, 228251),
(228252, '1.10.10.430-FF-000012', NULL, 'Protein phosphatase, Mg2+/Mn2+-dependent 1N', 44, NULL, NULL, 228252),
(228253, '3.80.10.10-FF-002788', NULL, 'Si:dkey-126g1.7', 186, NULL, NULL, 228253),
(228254, '3.30.160.60-FF-002725', NULL, 'Zinc finger protein B0310.2', 25, NULL, NULL, 228254),
(228255, '1.20.1220.12-FF-000001', NULL, 'Malate synthase', 121, NULL, NULL, 228255),
(228256, '2.40.70.10-FF-000463', NULL, NULL, 175, NULL, NULL, 228256),
(228257, '2.20.70.10-FF-000082', NULL, 'Phosphorylated CTD-interacting factor', 53, NULL, NULL, 228257),
(228258, '3.30.420.40-FF-000514', NULL, 'Glycerol kinase', 245, NULL, NULL, 228258),
(228259, '3.30.70.580-FF-000039', NULL, 'Ribosomal small subunit pseudouridylate synthase', 83, NULL, NULL, 228259),
(228260, '3.30.40.10-FF-001527', NULL, 'Zinc-binding phosphatase, putative', 109, NULL, NULL, 228260),
(228261, '2.130.10.10-FF-002821', NULL, 'SVP1-like protein 2', 131, NULL, NULL, 228261),
(228262, '1.10.510.10-FF-000480', NULL, 'Pollen receptor-like kinase 1', 213, NULL, NULL, 228262),
(228263, '3.30.200.20-FF-002324', NULL, 'Uncharacterized protein', 79, NULL, NULL, 228263),
(228264, '1.20.58.390-FF-000235', NULL, 'Uncharacterized protein', 166, NULL, NULL, 228264),
(228265, '1.20.120.1900-FF-000054', NULL, 'Gamma-tubulin complex component', 300, NULL, NULL, 228265),
(228266, '3.30.160.60-FF-004283', NULL, NULL, 27, NULL, NULL, 228266),
(228267, '3.40.50.1820-FF-001753', NULL, 'Uncharacterized protein', 391, NULL, NULL, 228267),
(228268, '3.10.20.90-FF-000157', NULL, 'Plexin A3', 117, NULL, NULL, 228268),
(228269, '1.10.510.10-FF-002166', NULL, 'Receptor-like protein kinase 4', 203, NULL, NULL, 228269);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(228270, '3.30.160.60-FF-000573', NULL, 'Putative zinc finger protein 236', 29, NULL, NULL, 228270),
(228271, '3.30.420.40-FF-000290', NULL, 'Arp6p', 114, NULL, NULL, 228271),
(228272, '2.20.80.10-FF-000021', NULL, 'Uncharacterized protein', 213, NULL, NULL, 228272),
(228273, '3.40.605.10-FF-000096', NULL, 'Succinate-semialdehyde dehydrogenase, mitochondrial', 296, NULL, NULL, 228273),
(228274, '3.60.21.10-FF-000392', NULL, 'Uncharacterized protein', 355, NULL, NULL, 228274),
(228275, '1.25.40.20-FF-001311', NULL, 'Predicted protein', 146, NULL, NULL, 228275),
(228276, '4.10.900.10-FF-000009', NULL, 'transcription factor 7 isoform X1', 62, NULL, NULL, 228276),
(228277, '1.10.287.110-FF-000271', NULL, 'Mitochondrial import inner membrane translocase subunit TIM16', 63, NULL, NULL, 228277),
(228278, '3.30.310.210-FF-000001', NULL, 'insulin-like growth factor 2 mRNA-binding protein 1 isoform X1', 163, NULL, NULL, 228278),
(228279, '3.40.50.720-FF-000879', NULL, 'Uronate dehydrogenase', 228, NULL, NULL, 228279),
(228280, '1.10.10.10-FF-000570', NULL, 'GntR family transcriptional regulator', 76, NULL, NULL, 228280),
(228281, '3.90.550.10-FF-000563', NULL, 'Glycosyltransferases', 126, NULL, NULL, 228281),
(228282, '3.30.160.60-FF-000146', NULL, 'C2H2 type zinc finger protein', 25, NULL, NULL, 228282),
(228283, '3.30.20.10-FF-000003', NULL, 'Chitinase', 76, NULL, NULL, 228283),
(228284, '3.40.630.30-FF-000396', NULL, 'FMN reductase', 138, NULL, NULL, 228284),
(228285, '3.30.310.220-FF-000004', NULL, 'Uncharacterized protein', 75, NULL, NULL, 228285),
(228286, '3.10.20.90-FF-000365', NULL, 'UBA52 isoform 14', 61, NULL, NULL, 228286),
(228287, '3.30.450.40-FF-000241', NULL, 'Phosphodiesterase', 113, NULL, NULL, 228287),
(228288, '3.40.630.10-FF-000390', NULL, 'Uncharacterized protein', 47, NULL, NULL, 228288),
(228289, '1.20.1070.10-FF-001835', NULL, 'Predicted protein', 304, NULL, NULL, 228289),
(228290, '2.70.170.10-FF-000222', NULL, 'Uncharacterized protein', 108, NULL, NULL, 228290),
(228291, '3.10.20.90-FF-000595', NULL, 'Uncharacterized protein', 33, NULL, NULL, 228291),
(228292, '2.60.40.10-FF-000713', NULL, 'Neural cell adhesion molecule L1', 90, NULL, NULL, 228292),
(228293, '2.130.10.10-FF-005817', NULL, 'Mitogen-activated protein kinase kinase kinase A', 71, NULL, NULL, 228293),
(228294, '3.80.10.10-FF-001265', NULL, 'Uncharacterized protein', 94, NULL, NULL, 228294),
(228295, '1.25.40.10-FF-004512', NULL, 'Bardet-Biedl syndrome 4 protein homolog', 87, NULL, NULL, 228295),
(228296, '2.130.10.10-FF-000680', NULL, 'UTP7p Nucleolar protein', 168, NULL, NULL, 228296),
(228297, '2.30.30.40-FF-000655', NULL, 'Rho GTPase-activating protein 27', 68, NULL, NULL, 228297),
(228298, '2.60.40.10-FF-002613', NULL, 'High Incidence of Males (Increased X chromosome loss)', 84, NULL, NULL, 228298),
(228299, '2.60.200.20-FF-000040', NULL, 'ras-associating and dilute domain-containing protein', 117, NULL, NULL, 228299),
(228300, '1.10.560.10-FF-000073', NULL, 'T-complex protein 1 subunit gamma', 80, NULL, NULL, 228300),
(228301, '3.40.50.150-FF-000450', NULL, 'N2,N2-dimethylguanosine tRNA methyltransferase, putative', 344, NULL, NULL, 228301),
(228302, '2.60.40.10-FF-001995', NULL, 'Muscle M-line assembly protein unc-89', 101, NULL, NULL, 228302),
(228303, '3.40.50.150-FF-000096', NULL, 'Guanidinoacetate N-methyltransferase', 234, NULL, NULL, 228303),
(228304, '3.40.50.280-FF-000016', NULL, 'Anaerobic magnesium-protoporphyrin IX monomethyl ester cyclase', 119, NULL, NULL, 228304),
(228305, '3.30.70.330-FF-000324', NULL, 'Polypyrimidine tract-binding protein-like 2', 106, NULL, NULL, 228305),
(228306, '1.25.40.40-FF-000002', NULL, 'cytochrome c oxidase subunit 5A, mitochondrial', 109, NULL, NULL, 228306),
(228307, '3.60.15.10-FF-000214', NULL, 'CPSF3L protein', 16, NULL, NULL, 228307),
(228308, '3.40.50.1000-FF-000552', NULL, NULL, 227, NULL, NULL, 228308),
(228309, '3.30.70.1660-FF-000027', NULL, 'Peptide chain release factor PrfB3, chloroplastic', 129, NULL, NULL, 228309),
(228310, '2.80.10.50-FF-000138', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 126, NULL, NULL, 228310);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(228311, '2.60.40.10-FF-004642', NULL, NULL, 116, NULL, NULL, 228311),
(228312, '2.130.10.10-FF-002580', NULL, 'Beta transducin Trp-Asp domain-containing protein, putative', 135, NULL, NULL, 228312),
(228313, '2.60.40.10-FF-004412', NULL, NULL, 99, NULL, NULL, 228313),
(228314, '2.30.29.30-FF-000031', NULL, 'protein numb isoform X1', 161, NULL, NULL, 228314),
(228315, '2.60.40.10-FF-000359', NULL, 'Sidekick cell adhesion molecule 2', 90, NULL, NULL, 228315),
(228316, '2.60.260.20-FF-000144', NULL, 'DnAJ-like protein slr0093', 110, NULL, NULL, 228316),
(228317, '1.10.8.60-FF-000483', NULL, 'Uncharacterized protein', 14, NULL, NULL, 228317),
(228318, '1.10.20.10-FF-000071', NULL, 'Transcription factor TFIID complex subunit', 44, NULL, NULL, 228318),
(228319, '3.40.50.1820-FF-001192', NULL, 'Uncharacterized protein', 289, NULL, NULL, 228319),
(228320, '1.20.1530.20-FF-000008', NULL, 'Sodium/bile acid cotransporter', 322, NULL, NULL, 228320),
(228321, '1.10.3730.20-FF-000066', NULL, 'Uncharacterized protein', 91, NULL, NULL, 228321),
(228322, '2.130.10.10-FF-003676', NULL, 'Protein CBR-IFTA-1', 416, NULL, NULL, 228322),
(228323, '2.60.40.150-FF-000380', NULL, 'Synaptotagmin 2', 136, NULL, NULL, 228323),
(228324, '2.40.10.10-FF-000690', NULL, NULL, 33, NULL, NULL, 228324),
(228325, '3.40.50.2300-FF-001257', NULL, NULL, 68, NULL, NULL, 228325),
(228326, '3.30.40.10-FF-001185', NULL, 'PHD-zinc-finger_like_domain/PHD-like_zinc-binding_domain_containing_protein_-_putative', 116, NULL, NULL, 228326),
(228327, '3.40.50.620-FF-000141', NULL, 'Argininosuccinate synthase', 140, NULL, NULL, 228327),
(228328, '3.20.20.70-FF-000398', NULL, 'Triosephosphate isomerase cytosolic', 102, NULL, NULL, 228328),
(228329, '3.40.50.720-FF-001155', NULL, 'Shikimate 5-dehydrogenase, putative', 156, NULL, NULL, 228329),
(228330, '3.10.180.10-FF-000018', NULL, '4-hydroxyphenylpyruvate dioxygenase', 153, NULL, NULL, 228330),
(228331, '3.10.120.10-FF-000015', NULL, 'Cytochrome b5, putative', 89, NULL, NULL, 228331),
(228332, '3.20.20.70-FF-000752', NULL, NULL, 65, NULL, NULL, 228332),
(228333, '1.20.140.40-FF-000036', NULL, 'Pectinesterase', 130, NULL, NULL, 228333),
(228334, '1.50.40.10-FF-000525', NULL, 'Predicted protein', 165, NULL, NULL, 228334),
(228335, '3.10.50.40-FF-000094', NULL, 'Peptidylprolyl isomerase', 132, NULL, NULL, 228335),
(228336, '2.130.10.10-FF-000450', NULL, 'Peptidylprolyl isomerase domain and WD-repeat protein 1', 266, NULL, NULL, 228336),
(228337, '1.20.1070.10-FF-002111', NULL, 'Predicted protein', 123, NULL, NULL, 228337),
(228338, '2.60.40.10-FF-004288', NULL, NULL, 205, NULL, NULL, 228338),
(228339, '3.40.50.150-FF-000337', NULL, 'Putative methyltransferase-like protein', 201, NULL, NULL, 228339),
(228340, '3.30.300.130-FF-000031', NULL, NULL, 81, NULL, NULL, 228340),
(228341, '2.70.150.10-FF-000114', NULL, 'Phospholipid-transporting ATPase', 138, NULL, NULL, 228341),
(228342, '1.25.40.10-FF-002258', NULL, 'Os04g0450200 protein', 136, NULL, NULL, 228342),
(228343, '1.10.530.10-FF-000037', NULL, 'Uncharacterized protein, isoform C', 127, NULL, NULL, 228343),
(228344, '3.40.350.10-FF-000031', NULL, 'Xaa-pro aminopeptidase, putative', 143, NULL, NULL, 228344),
(228345, '2.10.70.10-FF-000291', NULL, 'Uncharacterized protein', 55, NULL, NULL, 228345),
(228346, '3.90.79.10-FF-000304', NULL, 'Decapping enzyme complex catalytic component', 114, NULL, NULL, 228346),
(228347, '3.40.1090.10-FF-000100', NULL, 'Uncharacterized protein', 101, NULL, NULL, 228347),
(228348, '1.25.10.10-FF-000632', NULL, 'Pumilio domain-containing protein', 185, NULL, NULL, 228348),
(228349, '2.40.160.120-FF-000038', NULL, 'Sterol homeostasis modulator, putative', 179, NULL, NULL, 228349),
(228350, '3.30.70.330-FF-000083', NULL, 'Putative ecto-NOX disulfide-thiol exchanger 1', 102, NULL, NULL, 228350),
(228351, '1.10.8.960-FF-000009', NULL, 'Glutamate-cysteine ligase', 44, NULL, NULL, 228351),
(228352, '3.30.160.60-FF-005598', NULL, NULL, 44, NULL, NULL, 228352),
(228353, '3.30.160.60-FF-004075', NULL, NULL, 63, NULL, NULL, 228353);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(228354, '3.30.70.330-FF-002224', NULL, NULL, 94, NULL, NULL, 228354),
(228355, '3.40.50.1000-FF-000439', NULL, 'Heavy metal translocating P-type ATPase', 130, NULL, NULL, 228355),
(228356, '3.90.190.20-FF-000015', NULL, 'Dihydrofolate synthase/folylpolyglutamate synthase', 141, NULL, NULL, 228356),
(228357, '3.30.420.40-FF-000413', NULL, 'RNA polymerase II transcription factor, putative', 67, NULL, NULL, 228357),
(228358, '3.60.21.10-FF-000049', NULL, 'Serine/threonine-protein phosphatase with EF-hands', 350, NULL, NULL, 228358),
(228359, '3.30.450.40-FF-000128', NULL, 'Helix-turn-helix transcriptional regulator, IclR family', 177, NULL, NULL, 228359),
(228360, '1.20.1050.10-FF-000311', NULL, 'Putative glutathione S-transferase/histidinol dehydrogenase bifunctional related protein', 130, NULL, NULL, 228360),
(228361, '3.30.160.60-FF-003799', NULL, NULL, 25, NULL, NULL, 228361),
(228362, '2.60.40.1910-FF-000034', NULL, NULL, 81, NULL, NULL, 228362),
(228363, '2.30.39.10-FF-000099', NULL, 'Serin peptidase inhibitor, clade A (Alpha-1 antiproteinase, antitrypsin)-like', 101, NULL, NULL, 228363),
(228364, '2.80.10.50-FF-000239', NULL, 'Uncharacterized protein', 98, NULL, NULL, 228364),
(228365, '3.30.40.10-FF-002011', NULL, 'Uncharacterized protein', 48, NULL, NULL, 228365),
(228366, '3.40.50.11660-FF-000011', NULL, 'Uncharacterized protein', 208, NULL, NULL, 228366),
(228367, '3.40.50.10810-FF-000245', NULL, 'Predicted protein', 139, NULL, NULL, 228367),
(228368, '2.60.40.60-FF-000138', NULL, 'FAT atypical cadherin 4', 110, NULL, NULL, 228368),
(228369, '2.60.120.560-FF-000039', NULL, 'Predicted protein', 104, NULL, NULL, 228369),
(228370, '3.30.420.40-FF-000391', NULL, 'XylR family transcriptional regulator', 136, NULL, NULL, 228370),
(228371, '1.10.30.10-FF-000009', NULL, 'Histone-lysine N-methyltransferase', 90, NULL, NULL, 228371),
(228372, '1.10.510.10-FF-002609', NULL, NULL, 150, NULL, NULL, 228372),
(228373, '2.60.40.790-FF-000116', NULL, 'Sodium-and lithium-tolerant 1', 129, NULL, NULL, 228373),
(228374, '2.40.10.120-FF-000004', NULL, 'Serine protease HTRA2, mitochondrial', 211, NULL, NULL, 228374),
(228375, '1.10.357.10-FF-000055', NULL, 'TetR family transcriptional regulator', 209, NULL, NULL, 228375),
(228376, '3.10.290.10-FF-000027', NULL, 'Tyrosine--tRNA ligase', 101, NULL, NULL, 228376),
(228377, '2.60.40.10-FF-002158', NULL, 'Myotactin form B', 107, NULL, NULL, 228377),
(228378, '1.20.1510.10-FF-000010', NULL, 'Putative zinc transporter 1', 196, NULL, NULL, 228378),
(228379, '2.60.40.150-FF-000621', NULL, 'Uncharacterized protein', 146, NULL, NULL, 228379),
(228380, '2.40.160.110-FF-000035', NULL, 'Uncharacterized protein', 73, NULL, NULL, 228380),
(228381, '4.10.60.10-FF-000212', NULL, 'Nucleic acid binding protein', 28, NULL, NULL, 228381),
(228382, '2.40.50.140-FF-000074', NULL, 'DNA repair protein RecO', 78, NULL, NULL, 228382),
(228383, '1.10.510.10-FF-000137', NULL, 'Aurora kinase A', 170, NULL, NULL, 228383),
(228384, '3.40.50.880-FF-000090', NULL, 'Glutamine amidotransferase', 179, NULL, NULL, 228384),
(228385, '3.30.530.20-FF-000168', NULL, 'Uncharacterized protein', 125, NULL, NULL, 228385),
(228386, '1.10.10.1050-FF-000018', NULL, 'Hydrolase, NUDIX family protein', 98, NULL, NULL, 228386),
(228387, '2.30.30.40-FF-000217', NULL, 'Tyrosine-protein kinase', 69, NULL, NULL, 228387),
(228388, '1.20.1310.10-FF-000124', NULL, NULL, 148, NULL, NULL, 228388),
(228389, '1.20.1270.60-FF-000298', NULL, 'Uncharacterized protein', 136, NULL, NULL, 228389),
(228390, '3.30.160.60-FF-000584', NULL, 'Zinc finger protein 513', 36, NULL, NULL, 228390),
(228391, '2.130.10.10-FF-002248', NULL, 'Bardet-Biedl syndrome 1', 193, NULL, NULL, 228391),
(228392, '3.30.160.60-FF-001202', NULL, 'zinc finger protein 629 isoform X2', 26, NULL, NULL, 228392),
(228393, '4.10.320.10-FF-000015', NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', 54, NULL, NULL, 228393),
(228394, '1.25.40.10-FF-002051', NULL, 'E3 ubiquitin-protein ligase CHIP', 136, NULL, NULL, 228394);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(228395, '3.30.1230.20-FF-000015', NULL, 'Uncharacterized protein', 83, NULL, NULL, 228395),
(228396, '3.40.140.10-FF-000217', NULL, 'Uncharacterized protein', 191, NULL, NULL, 228396),
(228397, '2.60.40.1170-FF-000082', NULL, NULL, 120, NULL, NULL, 228397),
(228398, '3.90.480.20-FF-000010', NULL, 'Sulfite reductase, assimilatory-type', 88, NULL, NULL, 228398),
(228399, '3.40.50.2020-FF-000083', NULL, 'Ribose-phosphate pyrophosphokinase', 148, NULL, NULL, 228399),
(228400, '2.60.40.820-FF-000041', NULL, 'Uncharacterized protein', 164, NULL, NULL, 228400),
(228401, '1.10.287.160-FF-000027', NULL, 'Uncharacterized protein', 65, NULL, NULL, 228401),
(228402, '2.10.25.10-FF-000888', NULL, 'Crumbs', 47, NULL, NULL, 228402),
(228403, '3.40.50.880-FF-000202', NULL, 'Uncharacterized protein', 213, NULL, NULL, 228403),
(228404, '3.30.1520.10-FF-000113', NULL, 'Rho GTPase-activating protein (RhoGAP), putative', 121, NULL, NULL, 228404),
(228405, '2.60.40.150-FF-000048', NULL, 'U5 small nuclear ribonucleoprotein 200 kDa helicase', 122, NULL, NULL, 228405),
(228406, '2.60.40.10-FF-004081', NULL, NULL, 95, NULL, NULL, 228406),
(228407, '3.40.50.10260-FF-000041', NULL, 'Uncharacterized protein', 73, NULL, NULL, 228407),
(228408, '3.40.50.300-FF-000747', NULL, 'DNA helicase INO80 isoform X1', 241, NULL, NULL, 228408),
(228409, '1.10.10.2590-FF-000002', NULL, 'Putative nucleus accumbens-associated protein 2', 106, NULL, NULL, 228409),
(228410, '1.25.40.20-FF-000805', NULL, 'Os07g0632800 protein', 96, NULL, NULL, 228410),
(228411, '3.40.50.720-FF-000070', NULL, 'probable bifunctional methylenetetrahydrofolate dehydrogenase/cyclohydrolase 2', 137, NULL, NULL, 228411),
(228412, '1.10.287.370-FF-000096', NULL, 'Uncharacterized protein', 76, NULL, NULL, 228412),
(228413, '2.10.25.10-FF-001164', NULL, 'Laminin, alpha 2', 42, NULL, NULL, 228413),
(228414, '1.25.40.10-FF-001775', NULL, 'Pentatricopeptide repeat-containing protein At3g26540', 131, NULL, NULL, 228414),
(228415, '1.25.40.20-FF-000682', NULL, 'Short transient receptor potential channel', 257, NULL, NULL, 228415),
(228416, '2.40.10.10-FF-000151', NULL, 'Corin, isoform B', 253, NULL, NULL, 228416),
(228417, '3.40.50.300-FF-008611', NULL, 'Uncharacterized protein', 94, NULL, NULL, 228417),
(228418, '3.90.226.10-FF-000074', NULL, 'Enoyl-CoA hydratase (AFU_orthologue AFUA_2G10650)', 231, NULL, NULL, 228418),
(228419, '3.80.10.10-FF-003726', NULL, 'Os11g0569100 protein', 139, NULL, NULL, 228419),
(228420, '3.30.1360.70-FF-000017', NULL, NULL, 104, NULL, NULL, 228420),
(228421, '3.10.20.90-FF-000820', NULL, 'Uncharacterized protein', 116, NULL, NULL, 228421),
(228422, '1.10.510.10-FF-004077', NULL, NULL, 178, NULL, NULL, 228422),
(228423, '1.25.40.10-FF-000802', NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', 90, NULL, NULL, 228423),
(228424, '1.10.287.110-FF-000158', NULL, 'dnaJ homolog subfamily C member 8', 88, NULL, NULL, 228424),
(228425, '1.10.10.10-FF-000339', NULL, 'ATP-dependent DNA helicase RecQ', 177, NULL, NULL, 228425),
(228426, '3.40.50.11270-FF-000001', NULL, '4-hydroxy-3-methylbut-2-enyl diphosphate reductase', 85, NULL, NULL, 228426),
(228427, '3.10.610.10-FF-000002', NULL, 'General secretion pathway protein J', 112, NULL, NULL, 228427),
(228428, '2.30.18.10-FF-000011', NULL, 'Transcription initiation factor IIA subunit 2', 56, NULL, NULL, 228428),
(228429, '1.10.418.10-FF-000214', NULL, 'Predicted protein', 154, NULL, NULL, 228429),
(228430, '3.30.230.70-FF-000020', NULL, 'Polyribonucleotide nucleotidyltransferase 2 mitochondrial', 326, NULL, NULL, 228430),
(228431, '2.60.40.10-FF-002490', NULL, 'Uncharacterized protein', 125, NULL, NULL, 228431),
(228432, '3.40.50.1820-FF-000230', NULL, 'Cephalosporin-C deacetylase', 324, NULL, NULL, 228432),
(228433, '3.30.160.60-FF-000926', NULL, 'Kruppel like factor 13', 29, NULL, NULL, 228433),
(228434, '3.30.200.20-FF-000413', NULL, 'Serine/threonine-protein kinase NEK', 59, NULL, NULL, 228434),
(228435, '2.60.40.1180-FF-000085', NULL, '1,4-alpha-glucan branching enzyme GlgB', 122, NULL, NULL, 228435);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(228436, '3.40.50.300-FF-002428', NULL, 'Sigma-54-dependent Fis family transcriptional regulator', 178, NULL, NULL, 228436),
(228437, '3.40.50.300-FF-001023', NULL, 'Werner syndrome RecQ like helicase', 214, NULL, NULL, 228437),
(228438, '3.10.300.10-FF-000001', NULL, 'Putative 3-methyladenine DNA glycosylase', 208, NULL, NULL, 228438),
(228439, '1.10.390.10-FF-000048', NULL, 'Peptidase', 210, NULL, NULL, 228439),
(228440, '2.130.10.10-FF-004732', NULL, 'UDP-galactose:fucoside alpha-3-galactosyltransferase', 164, NULL, NULL, 228440),
(228441, '3.90.1600.10-FF-000027', NULL, 'DNA polymerase', 162, NULL, NULL, 228441),
(228442, '3.30.160.60-FF-002484', NULL, 'Protein CBR-LSY-2', 26, NULL, NULL, 228442),
(228443, '4.10.1130.20-FF-000006', NULL, 'Os02g0535400 protein', 37, NULL, NULL, 228443),
(228444, '1.10.1420.10-FF-000174', NULL, 'Uncharacterized protein', 26, NULL, NULL, 228444),
(228445, '3.30.300.10-FF-000036', NULL, 'S-adenosylmethionine synthetase', 15, NULL, NULL, 228445),
(228446, '1.20.58.70-FF-000129', NULL, 'Syntaxin 1A (brain)', 71, NULL, NULL, 228446),
(228447, '1.20.1250.20-FF-002100', NULL, 'Uncharacterized protein', 242, NULL, NULL, 228447),
(228448, '3.40.800.10-FF-000010', NULL, 'Formimidoylglutamase', 307, NULL, NULL, 228448),
(228449, '1.25.10.10-FF-002762', NULL, 'Uncharacterized protein', 602, NULL, NULL, 228449),
(228450, '3.90.420.10-FF-000008', NULL, 'Nitrate reductase, putative', 253, NULL, NULL, 228450),
(228451, '1.20.5.190-FF-000153', NULL, NULL, 39, NULL, NULL, 228451),
(228452, '3.90.79.10-FF-000192', NULL, 'Predicted protein', 170, NULL, NULL, 228452),
(228453, '3.40.800.20-FF-000013', NULL, 'Histone deacetylase', 377, NULL, NULL, 228453),
(228454, '1.20.1250.20-FF-001824', NULL, 'Uncharacterized protein', 151, NULL, NULL, 228454),
(228455, '3.40.50.300-FF-000528', NULL, 'ABC transporter G family member 31', 260, NULL, NULL, 228455),
(228456, '2.60.120.10-FF-000766', NULL, 'Uncharacterized protein', 58, NULL, NULL, 228456),
(228457, '3.40.50.300-FF-008509', NULL, 'Uncharacterized protein', 178, NULL, NULL, 228457),
(228458, '3.10.450.50-FF-000107', NULL, 'SOUL heme-binding protein', 100, NULL, NULL, 228458),
(228459, '3.90.1150.10-FF-000402', NULL, 'Predicted protein', 36, NULL, NULL, 228459),
(228460, '3.40.640.10-FF-000132', NULL, 'Serine C-palmitoyltransferase, putative', 236, NULL, NULL, 228460),
(228461, '3.30.200.20-FF-002004', NULL, 'CMGC family protein kinase', 96, NULL, NULL, 228461),
(228462, '2.70.98.10-FF-000121', NULL, 'Aldose 1-epimerase family protein, putative', 255, NULL, NULL, 228462),
(228463, '1.10.3720.10-FF-000124', NULL, 'ABC transporter permease subunit', 264, NULL, NULL, 228463),
(228464, '2.120.10.30-FF-000293', NULL, 'peptidyl-glycine alpha-amidating monooxygenase A', 325, NULL, NULL, 228464),
(228465, '3.80.10.10-FF-003384', NULL, 'RE59904p', 263, NULL, NULL, 228465),
(228466, '3.30.420.40-FF-000059', NULL, 'N-acetylglucosamine operon transcriptional repressor', 169, NULL, NULL, 228466),
(228467, '3.80.10.10-FF-002102', NULL, 'Serine/threonine kinase 11 interacting protein', 124, NULL, NULL, 228467),
(228468, '1.10.3380.30-FF-000030', NULL, 'ATP-dependent DNA helicase Hel308', 257, NULL, NULL, 228468),
(228469, '3.40.30.110-FF-000001', NULL, NULL, 61, NULL, NULL, 228469),
(228470, '3.30.200.20-FF-001728', NULL, 'Serine/threonine protein kinase TbPK6', 110, NULL, NULL, 228470),
(228471, '3.30.1010.10-FF-000030', NULL, 'Uncharacterized protein, isoform C', 114, NULL, NULL, 228471),
(228472, '1.25.40.20-FF-000463', NULL, 'ankyrin repeat domain-containing protein 17 isoform X7', 78, NULL, NULL, 228472),
(228473, '1.10.510.10-FF-002486', NULL, 'Predicted protein', 361, NULL, NULL, 228473),
(228474, '2.130.10.130-FF-000058', NULL, NULL, 112, NULL, NULL, 228474),
(228475, '3.10.129.10-FF-000102', NULL, 'Acyl-ACP thioesterase', 99, NULL, NULL, 228475),
(228476, '3.50.50.100-FF-000056', NULL, 'Uncharacterized protein', 392, NULL, NULL, 228476),
(228477, '1.10.10.60-FF-000118', NULL, 'WUSCHEL-related homeobox 11', 68, NULL, NULL, 228477),
(228478, '3.80.10.10-FF-001826', NULL, 'F-box/LRR-repeat protein 6 isoform X1', 84, NULL, NULL, 228478);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(228479, '2.40.70.10-FF-000025', NULL, 'Aspartyl protease family protein', 180, NULL, NULL, 228479),
(228480, '3.40.30.120-FF-000004', NULL, 'Aklavinone 12-hydroxylase DnrF', 89, NULL, NULL, 228480),
(228481, '1.20.120.980-FF-000057', NULL, 'Predicted protein', 47, NULL, NULL, 228481),
(228482, '3.30.70.580-FF-000028', NULL, 'tRNA pseudouridine synthase', 106, NULL, NULL, 228482),
(228483, '3.90.280.10-FF-000019', NULL, NULL, 118, NULL, NULL, 228483),
(228484, '1.20.1270.280-FF-000034', NULL, 'Dynein heavy chain, cytosolic, putative', 202, NULL, NULL, 228484),
(228485, '2.170.150.20-FF-000008', NULL, 'methionine-R-sulfoxide reductase B1', 103, NULL, NULL, 228485),
(228486, '3.30.70.330-FF-001729', NULL, NULL, 112, NULL, NULL, 228486),
(228487, '1.10.472.10-FF-000710', NULL, 'Apolipoprotein B-100', 55, NULL, NULL, 228487),
(228488, '1.25.40.10-FF-000460', NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', 195, NULL, NULL, 228488),
(228489, '3.40.630.30-FF-000519', NULL, 'Uncharacterized protein', 143, NULL, NULL, 228489),
(228490, '3.40.50.300-FF-006357', NULL, 'Uncharacterized protein', 141, NULL, NULL, 228490),
(228491, '2.120.10.80-FF-000072', NULL, 'Attractin', 126, NULL, NULL, 228491),
(228492, '1.10.510.10-FF-000811', NULL, 'Cyclin-dependent kinase WEE1', 205, NULL, NULL, 228492),
(228493, '1.10.1070.11-FF-000035', NULL, 'Phosphatidylinositol kinase (PIK-D)', 199, NULL, NULL, 228493),
(228494, '3.10.100.10-FF-000345', NULL, NULL, 93, NULL, NULL, 228494),
(228495, '1.20.1070.10-FF-001605', NULL, 'Uncharacterized protein', 150, NULL, NULL, 228495),
(228496, '3.40.390.10-FF-000022', NULL, 'Matrix metalloproteinase 1, isoform C', 253, NULL, NULL, 228496),
(228497, '3.40.1160.10-FF-000095', NULL, 'Aspartokinase 1 chloroplastic', 46, NULL, NULL, 228497),
(228498, '1.10.730.10-FF-000232', NULL, 'Uncharacterized protein', 165, NULL, NULL, 228498),
(228499, '1.10.8.60-FF-000589', NULL, 'Uncharacterized protein', 108, NULL, NULL, 228499),
(228500, '3.10.20.90-FF-000819', NULL, 'Uncharacterized protein', 117, NULL, NULL, 228500),
(228501, '3.30.1120.90-FF-000005', NULL, 'Nucleosome assembly protein11', 177, NULL, NULL, 228501),
(228502, '3.90.470.20-FF-000054', NULL, 'Uncharacterized protein', 100, NULL, NULL, 228502),
(228503, '3.30.160.60-FF-006435', NULL, NULL, 39, NULL, NULL, 228503),
(228504, '1.20.5.340-FF-000131', NULL, 'Viral A-type inclusion protein, putative', 118, NULL, NULL, 228504),
(228505, '3.80.10.10-FF-001153', NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At4g36180', 91, NULL, NULL, 228505),
(228506, '1.25.40.10-FF-000353', NULL, 'Pentatricopeptide repeat-containing protein At4g39530', 102, NULL, NULL, 228506),
(228507, '1.10.246.120-FF-000001', NULL, 'GTPase-activating protein and VPS9 domain-containing protein 1 isoform X1', 70, NULL, NULL, 228507),
(228508, '3.90.470.10-FF-000051', NULL, 'Uncharacterized protein', 175, NULL, NULL, 228508),
(228509, '3.30.1120.10-FF-000038', NULL, 'Arylsulfatase', 85, NULL, NULL, 228509),
(228510, '3.90.550.50-FF-000209', NULL, 'Uncharacterized protein', 161, NULL, NULL, 228510),
(228511, '1.20.1250.20-FF-002201', NULL, 'Uncharacterized protein', 145, NULL, NULL, 228511),
(228512, '3.30.40.10-FF-002016', NULL, 'Uncharacterized protein', 45, NULL, NULL, 228512),
(228513, '1.25.40.10-FF-002500', NULL, 'Pentatricopeptide repeat-containing protein OTP51, chloroplastic', 148, NULL, NULL, 228513),
(228514, '3.40.640.10-FF-000351', NULL, 'Putative low-specificity L-threonine aldolase 1', 76, NULL, NULL, 228514),
(228515, '3.40.50.1000-FF-000664', NULL, NULL, 311, NULL, NULL, 228515),
(228516, '3.30.160.40-FF-000022', NULL, 'Probable porphobilinogen deaminase', 76, NULL, NULL, 228516),
(228517, '3.40.50.300-FF-007886', NULL, 'ATP-dependent DNA helicase', 195, NULL, NULL, 228517),
(228518, '1.20.870.10-FF-000015', NULL, 'Rap guanine nucleotide exchange factor 3', 159, NULL, NULL, 228518),
(228519, '1.10.3430.10-FF-000023', NULL, 'Ammonium transporter', 459, NULL, NULL, 228519),
(228520, '1.25.40.10-FF-001876', NULL, 'Putative TPR repeat family protein', 176, NULL, NULL, 228520);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(228521, '3.30.70.3490-FF-000003', NULL, 'Oxysterol-binding protein', 64, NULL, NULL, 228521),
(228522, '3.30.420.40-FF-000851', NULL, 'Glucokinase (ROK family protein), conjectural', 155, NULL, NULL, 228522),
(228523, '3.90.1150.10-FF-000054', NULL, 'Aminotransferase, class I', 154, NULL, NULL, 228523),
(228524, '3.40.50.300-FF-000961', NULL, 'Ras-related protein Rab-8B', 198, NULL, NULL, 228524),
(228525, '3.30.930.10-FF-000387', NULL, 'Uncharacterized protein', 200, NULL, NULL, 228525),
(228526, '1.25.40.10-FF-004624', NULL, 'Uncharacterized protein', 149, NULL, NULL, 228526),
(228527, '2.60.40.10-FF-000477', NULL, 'DS cell adhesion molecule like 1', 99, NULL, NULL, 228527),
(228528, '1.25.10.10-FF-000418', NULL, 'U-box domain-containing protein 4', 172, NULL, NULL, 228528),
(228529, '3.40.30.10-FF-000088', NULL, 'Elongation factor 1-gamma', 79, NULL, NULL, 228529),
(228530, '1.20.890.10-FF-000022', NULL, 'cAMP-dependent protein kinase regulatory subunit', 39, NULL, NULL, 228530),
(228531, '2.170.190.11-FF-000009', NULL, 'Molybdopterin molybdenumtransferase', 94, NULL, NULL, 228531),
(228532, '3.50.50.60-FF-001278', NULL, 'Uncharacterized protein', 58, NULL, NULL, 228532),
(228533, '3.40.50.300-FF-008510', NULL, 'AAA ATPase, cell division control protein, putative', 178, NULL, NULL, 228533),
(228534, '2.40.10.10-FF-000471', NULL, NULL, 116, NULL, NULL, 228534),
(228535, '1.10.510.10-FF-004178', NULL, NULL, 207, NULL, NULL, 228535),
(228536, '1.10.418.10-FF-000091', NULL, 'Filamin B', 76, NULL, NULL, 228536),
(228537, '3.30.160.60-FF-002164', NULL, 'Zinc finger protein chinmo', 77, NULL, NULL, 228537),
(228538, '3.40.50.300-FF-000854', NULL, 'Multidrug ABC transporter ATP-binding protein', 247, NULL, NULL, 228538),
(228539, '3.40.50.2300-FF-001476', NULL, NULL, 141, NULL, NULL, 228539),
(228540, '1.25.40.20-FF-001879', NULL, 'Uncharacterized protein', 273, NULL, NULL, 228540),
(228541, '2.130.10.10-FF-000562', NULL, 'DNA damage-binding protein CMR1', 347, NULL, NULL, 228541),
(228542, '3.40.980.10-FF-000051', NULL, 'FAD synthase-like Protein', 135, NULL, NULL, 228542),
(228543, '3.40.1550.20-FF-000009', NULL, 'Transcriptional regulator MraZ', 131, NULL, NULL, 228543),
(228544, '3.30.70.580-FF-000040', NULL, 'Pseudouridine synthase', 78, NULL, NULL, 228544),
(228545, '2.130.10.10-FF-000455', NULL, 'Autophagy-related protein 18f', 169, NULL, NULL, 228545),
(228546, '2.10.90.10-FF-000174', NULL, 'Uncharacterized protein', 118, NULL, NULL, 228546),
(228547, '3.90.980.20-FF-000031', NULL, NULL, 96, NULL, NULL, 228547),
(228548, '3.40.50.720-FF-001716', NULL, 'Uncharacterized protein', 125, NULL, NULL, 228548),
(228549, '3.30.497.10-FF-000047', NULL, 'Serpin H1', 129, NULL, NULL, 228549),
(228550, '3.90.1030.20-FF-000003', NULL, 'DNA polymerase delta 3, accessory subunit', 105, NULL, NULL, 228550),
(228551, '1.25.10.10-FF-003398', NULL, 'Unc-45 homolog B (C. elegans) (Predicted)', 129, NULL, NULL, 228551),
(228552, '3.30.70.870-FF-000020', NULL, 'Putative elongation factor', 107, NULL, NULL, 228552),
(228553, '3.40.50.300-FF-007779', NULL, 'HL01868p', 55, NULL, NULL, 228553),
(228554, '1.10.1450.10-FF-000125', NULL, 'Creatine kinase, M-type', 85, NULL, NULL, 228554),
(228555, '3.30.60.290-FF-000001', NULL, 'DNA repair protein Rad4, putative', 57, NULL, NULL, 228555),
(228556, '2.60.40.60-FF-000352', NULL, 'CAlSYntenin/Alcadein homolog', 100, NULL, NULL, 228556),
(228557, '1.10.730.10-FF-000125', NULL, 'Leucine--tRNA ligase', 180, NULL, NULL, 228557),
(228558, '2.60.120.620-FF-000086', NULL, 'Uncharacterized protein', 184, NULL, NULL, 228558),
(228559, '3.30.200.20-FF-000312', NULL, 'striated muscle preferentially expressed protein kinase', 84, NULL, NULL, 228559),
(228560, '3.30.750.24-FF-000032', NULL, 'Anti-sigma factor antagonist', 116, NULL, NULL, 228560),
(228561, '1.20.5.340-FF-000024', NULL, 'Forkhead box P3, isoform CRA_b', 76, NULL, NULL, 228561),
(228562, '3.40.50.150-FF-000657', NULL, 'rRNA adenine N(6)-methyltransferase', 241, NULL, NULL, 228562),
(228563, '2.70.170.10-FF-000093', NULL, 'cDNA FLJ56966, highly similar to Gamma-aminobutyric-acid receptor alpha-5 subunit', 165, NULL, NULL, 228563);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(228564, '3.40.720.10-FF-000296', NULL, 'Putative phosphoethanolamine transferase HI_1064', 253, NULL, NULL, 228564),
(228565, '3.40.50.300-FF-006363', NULL, 'Muscle-specific beta 1 integrin-binding protein', 139, NULL, NULL, 228565),
(228566, '3.30.160.60-FF-002271', NULL, 'Zinc finger and BTB domain-containing 47b', 25, NULL, NULL, 228566),
(228567, '6.10.140.2150-FF-000006', NULL, 'Sphingosine-1-phosphate lyase', 46, NULL, NULL, 228567),
(228568, '3.30.70.330-FF-001286', NULL, 'U2 snRNP auxiliary factor large subunit', 107, NULL, NULL, 228568),
(228569, '3.30.56.30-FF-000007', NULL, 'Signal recognition particle 19 kDa protein', 118, NULL, NULL, 228569),
(228570, '2.40.170.20-FF-000029', NULL, 'SusC/RagA family TonB-linked outer membrane protein', 645, NULL, NULL, 228570),
(228571, '3.30.40.10-FF-001415', NULL, 'Predicted protein', 65, NULL, NULL, 228571),
(228572, '3.40.1110.10-FF-000479', NULL, NULL, 158, NULL, NULL, 228572),
(228573, '3.30.160.60-FF-004395', NULL, NULL, 24, NULL, NULL, 228573),
(228574, '2.130.10.10-FF-001978', NULL, 'BING4CT domain containing protein', 194, NULL, NULL, 228574),
(228575, '4.10.60.10-FF-000105', NULL, 'Os05g0120100 protein', 31, NULL, NULL, 228575),
(228576, '2.40.10.10-FF-000145', NULL, 'Genome polyprotein', 102, NULL, NULL, 228576),
(228577, '3.10.100.10-FF-000126', NULL, 'Regeneration, isoform B', 163, NULL, NULL, 228577),
(228578, '2.60.40.10-FF-002731', NULL, 'Receptor-type tyrosine-protein phosphatase beta', 93, NULL, NULL, 228578),
(228579, '3.40.50.300-FF-006256', NULL, 'Uncharacterized protein', 147, NULL, NULL, 228579),
(228580, '3.30.70.330-FF-001393', NULL, 'RBD (RNA binding domain) protein', 124, NULL, NULL, 228580),
(228581, '2.10.25.10-FF-001725', NULL, 'HGF activator', 39, NULL, NULL, 228581),
(228582, '2.40.10.10-FF-000038', NULL, 'Serine protease', 242, NULL, NULL, 228582),
(228583, '3.30.160.60-FF-003102', NULL, 'Uncharacterized protein', 42, NULL, NULL, 228583),
(228584, '2.30.38.10-FF-000001', NULL, 'Non-ribosomal peptide synthetase PvdI', 78, NULL, NULL, 228584),
(228585, '3.40.1550.10-FF-000006', NULL, 'Flagellar motor switch protein FliM', 186, NULL, NULL, 228585),
(228586, '1.10.510.10-FF-002840', NULL, 'Tyrosine-protein kinase', 287, NULL, NULL, 228586),
(228587, '1.10.510.10-FF-002054', NULL, 'Protein CBG03830', 281, NULL, NULL, 228587),
(228588, '3.90.1410.10-FF-000097', NULL, 'Histone-lysine N-methyltransferase setd3-like Protein', 81, NULL, NULL, 228588),
(228589, '1.10.510.10-FF-000923', NULL, 'Related to serine/threonine-protein kinase', 186, NULL, NULL, 228589),
(228590, '2.70.170.10-FF-000104', NULL, 'Uncharacterized protein', 74, NULL, NULL, 228590),
(228591, '3.30.160.60-FF-004288', NULL, NULL, 29, NULL, NULL, 228591),
(228592, '1.10.533.10-FF-000274', NULL, 'Si:ch211-112c15.8', 96, NULL, NULL, 228592),
(228593, '2.60.40.10-FF-000691', NULL, 'Tenascin R', 84, NULL, NULL, 228593),
(228594, '1.10.533.10-FF-000167', NULL, 'Nerve growth factor receptor', 94, NULL, NULL, 228594),
(228595, '2.60.40.10-FF-004069', NULL, NULL, 95, NULL, NULL, 228595),
(228596, '3.40.50.300-FF-006582', NULL, 'Predicted protein', 100, NULL, NULL, 228596),
(228597, '3.40.50.300-FF-006470', NULL, 'GPN-loop GTPase', 119, NULL, NULL, 228597),
(228598, '2.70.70.10-FF-000001', NULL, 'PTS system glucose-specific IIA component', 159, NULL, NULL, 228598),
(228599, '3.40.50.720-FF-001935', NULL, 'Uncharacterized protein', 284, NULL, NULL, 228599),
(228600, '1.20.1390.10-FF-000016', NULL, 'U1 snRNP-associated protein usp107', 111, NULL, NULL, 228600),
(228601, '1.20.5.190-FF-000046', NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', 46, NULL, NULL, 228601),
(228602, '1.25.10.10-FF-002661', NULL, 'Uncharacterized protein', 100, NULL, NULL, 228602),
(228603, '1.20.5.780-FF-000021', NULL, 'FXYD domain-containing ion transport regulator', 41, NULL, NULL, 228603),
(228604, '1.20.58.70-FF-000023', NULL, 't-SNARE syntaxin', 223, NULL, NULL, 228604),
(228605, '1.10.533.10-FF-000055', NULL, 'Interleukin-1 receptor-associated kinase 3', 92, NULL, NULL, 228605);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(228606, '3.30.40.10-FF-001741', NULL, 'FHA domain containing protein, putative', 100, NULL, NULL, 228606),
(228607, '3.90.1150.10-FF-000161', NULL, 'Threonine aldolase', 99, NULL, NULL, 228607),
(228608, '3.30.420.40-FF-000172', NULL, 'Heat shock 70 kDa protein', 89, NULL, NULL, 228608),
(228609, '2.60.120.10-FF-000659', NULL, 'AGAP005463-PA', 129, NULL, NULL, 228609),
(228610, '3.90.190.10-FF-000479', NULL, 'Uncharacterized protein', 170, NULL, NULL, 228610),
(228611, '3.20.20.70-FF-000853', NULL, NULL, 70, NULL, NULL, 228611),
(228612, '1.25.40.10-FF-001769', NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', 167, NULL, NULL, 228612),
(228613, '2.130.10.10-FF-000236', NULL, 'Polyubiquitin binding protein (Doa1/Ufd3)', 313, NULL, NULL, 228613),
(228614, '3.40.50.300-FF-000635', NULL, 'Sarcalumenin, putative', 226, NULL, NULL, 228614),
(228615, '3.30.60.30-FF-000219', NULL, 'Uncharacterized protein', 58, NULL, NULL, 228615),
(228616, '3.30.70.60-FF-000032', NULL, '30S ribosomal protein S6', 128, NULL, NULL, 228616),
(228617, '3.10.100.10-FF-000019', NULL, 'Mannose receptor C type 2', 130, NULL, NULL, 228617),
(228618, '2.60.120.10-FF-000547', NULL, 'Uncharacterized protein', 164, NULL, NULL, 228618),
(228619, '1.10.375.10-FF-000001', NULL, 'Gag polyprotein', 142, NULL, NULL, 228619),
(228620, '1.20.58.60-FF-000020', NULL, 'Spectrin alpha chain, non-erythrocytic 1', 107, NULL, NULL, 228620),
(228621, '1.10.760.10-FF-000060', NULL, 'Uncharacterized protein', 136, NULL, NULL, 228621),
(228622, '3.40.50.1580-FF-000023', NULL, 'Purine nucleoside permease', 273, NULL, NULL, 228622),
(228623, '1.10.510.10-FF-002380', NULL, NULL, 129, NULL, NULL, 228623),
(228624, '3.30.420.40-FF-000632', NULL, 'Uncharacterized protein', 115, NULL, NULL, 228624),
(228625, '2.60.40.10-FF-006093', NULL, NULL, 111, NULL, NULL, 228625),
(228626, '1.10.357.10-FF-000061', NULL, 'TetR family transcriptional regulator', 139, NULL, NULL, 228626),
(228627, '2.130.10.10-FF-002602', NULL, 'LD16387p', 235, NULL, NULL, 228627),
(228628, '1.20.5.110-FF-000079', NULL, 'synaptosomal-associated protein 29', 74, NULL, NULL, 228628),
(228629, '2.30.29.30-FF-001329', NULL, 'Uncharacterized protein', 60, NULL, NULL, 228629),
(228630, '1.10.400.10-FF-000027', NULL, 'G protein subunit alpha 11', 79, NULL, NULL, 228630),
(228631, '1.20.1050.10-FF-000070', NULL, 'Glutathione S-transferase, putative', 110, NULL, NULL, 228631),
(228632, '1.20.5.620-FF-000001', NULL, 'ATP synthase subunit b', 61, NULL, NULL, 228632),
(228633, '1.10.510.10-FF-000693', NULL, 'Serine/threonine protein kinase, putative', 296, NULL, NULL, 228633),
(228634, '1.10.579.10-FF-000003', NULL, 'Deoxyribodipyrimidine photo-lyase', 184, NULL, NULL, 228634),
(228635, '3.30.70.3040-FF-000003', NULL, 'Cell division protein FtsX', 110, NULL, NULL, 228635),
(228636, '1.10.10.60-FF-000444', NULL, 'AraC family transcriptional regulator', 53, NULL, NULL, 228636),
(228637, '3.30.497.10-FF-000154', NULL, 'Serpin, putative', 186, NULL, NULL, 228637),
(228638, '3.40.120.10-FF-000093', NULL, 'Uncharacterized protein', 52, NULL, NULL, 228638),
(228639, '3.30.360.50-FF-000006', NULL, 'Uncharacterized protein', 77, NULL, NULL, 228639),
(228640, '1.20.1060.10-FF-000025', NULL, 'DNA polymerase I family protein', 123, NULL, NULL, 228640),
(228641, '3.30.56.10-FF-000001', NULL, 'Phenylalanine--tRNA ligase beta subunit', 59, NULL, NULL, 228641),
(228642, '2.60.120.260-FF-000056', NULL, 'reelin', 190, NULL, NULL, 228642),
(228643, '1.25.40.10-FF-003916', NULL, 'Anaphase promoting complex subunit 7, isoform B', 442, NULL, NULL, 228643),
(228644, '2.30.29.30-FF-000132', NULL, 'pleckstrin homology domain-containing family G member 2', 124, NULL, NULL, 228644),
(228645, '1.25.10.10-FF-000637', NULL, 'Telomere repeat binding bouquet formation protein 1', 259, NULL, NULL, 228645),
(228646, '1.25.40.10-FF-004405', NULL, 'ABL100Wp', 136, NULL, NULL, 228646),
(228647, '2.60.40.10-FF-000258', NULL, 'Dyslexia-associated protein KIAA0319 homolog', 81, NULL, NULL, 228647),
(228648, '2.170.240.10-FF-000007', NULL, 'Predicted protein', 108, NULL, NULL, 228648);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(228649, '3.30.1330.30-FF-000077', NULL, 'ERF1 domain 3 family protein', 116, NULL, NULL, 228649),
(228650, '3.30.70.80-FF-000038', NULL, 'Peptidase S8/S53 domain-containing protein', 78, NULL, NULL, 228650),
(228651, '3.30.40.10-FF-000111', NULL, 'Anaphase-promoting complex subunit 11', 84, NULL, NULL, 228651),
(228652, '2.60.40.790-FF-000122', NULL, NULL, 115, NULL, NULL, 228652),
(228653, '1.10.20.10-FF-000278', NULL, NULL, 75, NULL, NULL, 228653),
(228654, '2.10.50.30-FF-000042', NULL, 'Vomeronasal 2, receptor 59', 76, NULL, NULL, 228654),
(228655, '1.20.1110.10-FF-000249', NULL, NULL, 101, NULL, NULL, 228655),
(228656, '2.30.30.1020-FF-000038', NULL, NULL, 145, NULL, NULL, 228656),
(228657, '2.10.25.10-FF-001613', NULL, 'Uncharacterized protein', 85, NULL, NULL, 228657),
(228658, '3.30.160.60-FF-004069', NULL, NULL, 33, NULL, NULL, 228658),
(228659, '2.60.40.10-FF-001888', NULL, 'Twitchin', 94, NULL, NULL, 228659),
(228660, '2.30.29.30-FF-001217', NULL, 'Uncharacterized protein', 43, NULL, NULL, 228660),
(228661, '1.10.10.1780-FF-000001', NULL, 'Toxin B', 69, NULL, NULL, 228661),
(228662, '1.10.730.10-FF-000013', NULL, 'leucine--tRNA ligase, cytoplasmic', 112, NULL, NULL, 228662),
(228663, '3.30.160.60-FF-002383', NULL, 'Pebbled, isoform A', 41, NULL, NULL, 228663),
(228664, '2.40.155.10-FF-000008', NULL, 'Fluorescent protein Dronpa', 162, NULL, NULL, 228664),
(228665, '3.40.50.720-FF-001256', NULL, 'Trifunctional enzyme subunit', 112, NULL, NULL, 228665),
(228666, '2.180.10.10-FF-000032', NULL, 'Uncharacterized protein', 490, NULL, NULL, 228666),
(228667, '3.50.50.60-FF-001385', NULL, 'Uncharacterized protein', 46, NULL, NULL, 228667),
(228668, '1.10.10.60-FF-000225', NULL, 'NK3 homeobox 2', 78, NULL, NULL, 228668),
(228669, '2.130.10.10-FF-004507', NULL, 'Chromosome 15, whole genome shotgun sequence', 237, NULL, NULL, 228669),
(228670, '3.30.450.40-FF-000229', NULL, 'GAF domain-containing protein', 174, NULL, NULL, 228670),
(228671, '1.10.510.10-FF-000704', NULL, 'Guanylate cyclase', 281, NULL, NULL, 228671),
(228672, '3.30.830.10-FF-000328', NULL, 'Presequence protease', 56, NULL, NULL, 228672),
(228673, '2.130.10.10-FF-001866', NULL, 'Bromodomain containing protein', 291, NULL, NULL, 228673),
(228674, '1.20.120.1150-FF-000008', NULL, 'Serine/threonine-protein phosphatase 2A activator', 115, NULL, NULL, 228674),
(228675, '2.60.40.640-FF-000105', NULL, 'Uncharacterized protein', 136, NULL, NULL, 228675),
(228676, '2.60.40.640-FF-000094', NULL, 'Uncharacterized protein', 63, NULL, NULL, 228676),
(228677, '3.30.200.20-FF-001835', NULL, 'Connectin', 115, NULL, NULL, 228677),
(228678, '3.40.140.10-FF-000195', NULL, 'Uncharacterized protein', 95, NULL, NULL, 228678),
(228679, '3.10.310.10-FF-000052', NULL, 'Uncharacterized protein', 15, NULL, NULL, 228679),
(228680, '3.40.50.300-FF-004906', NULL, 'GPN-loop GTPase 3', 260, NULL, NULL, 228680),
(228681, '2.10.25.10-FF-000989', NULL, 'Hemolectin, isoform B', 56, NULL, NULL, 228681),
(228682, '1.10.8.720-FF-000062', NULL, 'Uncharacterized protein', 91, NULL, NULL, 228682),
(228683, '3.30.1320.10-FF-000019', NULL, '30S ribosomal protein S16', 136, NULL, NULL, 228683),
(228684, '3.80.10.10-FF-003277', NULL, 'AGAP010669-PA', 158, NULL, NULL, 228684),
(228685, '3.60.15.10-FF-000001', NULL, 'Cleavage and polyadenylation specificity factor', 229, NULL, NULL, 228685),
(228686, '2.40.10.10-FF-000257', NULL, NULL, 24, NULL, NULL, 228686),
(228687, '3.40.50.11530-FF-000006', NULL, 'interleukin-17 receptor E isoform X2', 146, NULL, NULL, 228687),
(228688, '2.40.330.10-FF-000005', NULL, 'Transcriptional factor B3 family protein', 115, NULL, NULL, 228688),
(228689, '3.40.50.1440-FF-000009', NULL, 'Tubulin beta chain', 262, NULL, NULL, 228689),
(228690, '1.10.3470.10-FF-000025', NULL, 'Possible conserved integral membrane protein', 133, NULL, NULL, 228690),
(228691, '3.90.170.10-FF-000011', NULL, 'Uncharacterized protein', 43, NULL, NULL, 228691),
(228692, '2.60.40.10-FF-002512', NULL, 'Myotactin form B', 83, NULL, NULL, 228692),
(228693, '3.40.50.300-FF-006037', NULL, 'Methylenetetrahydrofolate dehydrogenase (NADP+-dependent) 1a, methenyltetrahydrofolate cyclohydrolase, formyltetrahydrofolate synthetase', 255, NULL, NULL, 228693);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(228694, '1.25.40.20-FF-000356', NULL, 'Poly [ADP-ribose] polymerase', 128, NULL, NULL, 228694),
(228695, '1.25.40.190-FF-000014', NULL, NULL, 144, NULL, NULL, 228695),
(228696, '1.10.10.60-FF-000770', NULL, NULL, 62, NULL, NULL, 228696),
(228697, '1.10.20.10-FF-000059', NULL, 'Transcription initiation factor TFIID subunit beta', 87, NULL, NULL, 228697),
(228698, '2.10.25.10-FF-001720', NULL, 'Uncharacterized protein', 59, NULL, NULL, 228698),
(228699, '3.40.30.10-FF-000981', NULL, 'Glutaredoxin family protein', 90, NULL, NULL, 228699),
(228700, '3.40.50.150-FF-000438', NULL, 'Probable thiol methyltransferase 2', 230, NULL, NULL, 228700),
(228701, '1.10.510.10-FF-004420', NULL, NULL, 68, NULL, NULL, 228701),
(228702, '1.10.510.10-FF-003796', NULL, NULL, 125, NULL, NULL, 228702),
(228703, '3.90.1750.10-FF-000038', NULL, 'Ubiquitin-protein ligase, putative', 120, NULL, NULL, 228703),
(228704, '3.90.780.10-FF-000035', NULL, '2`,3`-cyclic-nucleotide 2`-phosphodiesterase, putative', 221, NULL, NULL, 228704),
(228705, '1.25.40.10-FF-000465', NULL, 'lysine-specific demethylase 6A isoform X4', 164, NULL, NULL, 228705),
(228706, '3.40.50.1240-FF-000045', NULL, 'Extracellular phytase, putative', 438, NULL, NULL, 228706),
(228707, '1.20.120.1750-FF-000082', NULL, 'RBR-type E3 ubiquitin transferase', 243, NULL, NULL, 228707),
(228708, '2.60.40.790-FF-000015', NULL, 'dynein assembly factor 4, axonemal isoform X1', 98, NULL, NULL, 228708),
(228709, '3.30.565.10-FF-000105', NULL, 'Histidine kinase-DNA gyrase B-and HSP90-like ATPase family protein', 165, NULL, NULL, 228709),
(228710, '2.70.150.10-FF-000221', NULL, 'Uncharacterized protein (Fragment)', 143, NULL, NULL, 228710),
(228711, '2.170.130.10-FF-000004', NULL, 'Colicin I TonB-dependent receptor', 133, NULL, NULL, 228711),
(228712, '1.20.120.1760-FF-000085', NULL, NULL, 134, NULL, NULL, 228712),
(228713, '1.25.40.180-FF-000011', NULL, 'Eukaryotic translation initiation factor 4 gamma 2', 246, NULL, NULL, 228713),
(228714, '2.60.40.10-FF-006109', NULL, NULL, 49, NULL, NULL, 228714),
(228715, '3.90.440.10-FF-000004', NULL, 'Nitric oxide synthase', 25, NULL, NULL, 228715),
(228716, '3.40.50.450-FF-000085', NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase', 204, NULL, NULL, 228716),
(228717, '3.20.20.140-FF-000395', NULL, 'TatD DNase domain-containing 2', 147, NULL, NULL, 228717),
(228718, '3.40.1090.10-FF-000083', NULL, 'Lysophospholipase', 367, NULL, NULL, 228718),
(228719, '3.30.230.130-FF-000060', NULL, 'Cullin', 158, NULL, NULL, 228719),
(228720, '1.25.10.10-FF-000306', NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit', 403, NULL, NULL, 228720),
(228721, '2.60.120.330-FF-000229', NULL, 'Predicted protein', 151, NULL, NULL, 228721),
(228722, '2.60.40.10-FF-004743', NULL, NULL, 120, NULL, NULL, 228722),
(228723, '2.30.30.40-FF-000661', NULL, 'Uncharacterized protein', 66, NULL, NULL, 228723),
(228724, '3.40.1810.10-FF-000049', NULL, NULL, 83, NULL, NULL, 228724),
(228725, '2.30.250.10-FF-000001', NULL, 'Aspartyl aminopeptidase 1', 155, NULL, NULL, 228725),
(228726, '3.40.50.300-FF-000742', NULL, 'NFX1-type zinc finger-containing protein 1', 192, NULL, NULL, 228726),
(228727, '3.30.40.10-FF-001292', NULL, 'Uncharacterized protein', 114, NULL, NULL, 228727),
(228728, '3.30.160.60-FF-004518', NULL, NULL, 23, NULL, NULL, 228728),
(228729, '3.30.160.60-FF-000921', NULL, 'zinc finger and BTB domain-containing protein 21', 40, NULL, NULL, 228729),
(228730, '3.20.20.70-FF-000297', NULL, 'Unplaced genomic scaffold supercont1.57, whole genome shotgun sequence', 375, NULL, NULL, 228730),
(228731, '3.90.70.10-FF-000329', NULL, 'Ubiquitin carboxyl-terminal hydrolase 10', 365, NULL, NULL, 228731),
(228732, '2.20.200.10-FF-000006', NULL, 'ABC-type macrolide export system secretin component MacC', 85, NULL, NULL, 228732),
(228733, '1.25.40.90-FF-000101', NULL, 'AdaPTin or adaptin-related protein', 163, NULL, NULL, 228733),
(228734, '3.30.420.110-FF-000035', NULL, 'MutS family protein', 149, NULL, NULL, 228734),
(228735, '1.20.1480.30-FF-000001', NULL, 'Putative kinesin', 85, NULL, NULL, 228735);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(228736, '3.40.50.300-FF-000068', NULL, 'Site-determining protein', 254, NULL, NULL, 228736),
(228737, '2.30.30.40-FF-000554', NULL, 'Bbc1p', 68, NULL, NULL, 228737),
(228738, '3.40.525.10-FF-000044', NULL, 'Uncharacterized protein', 323, NULL, NULL, 228738),
(228739, '2.170.130.20-FF-000007', NULL, 'LCCL domain-containing protein', 107, NULL, NULL, 228739),
(228740, '3.40.1710.10-FF-000002', NULL, 'Transport permease protein', 129, NULL, NULL, 228740),
(228741, '3.40.50.300-FF-008268', NULL, 'Protein CBG17574', 43, NULL, NULL, 228741),
(228742, '1.10.1300.10-FF-000013', NULL, 'Phosphodiesterase', 380, NULL, NULL, 228742),
(228743, '2.40.20.10-FF-000078', NULL, 'Uncharacterized protein', 104, NULL, NULL, 228743),
(228744, '3.80.20.20-FF-000021', NULL, 'Receptor protein-tyrosine kinase', 176, NULL, NULL, 228744),
(228745, '2.60.40.60-FF-000571', NULL, 'Cadherin 5', 104, NULL, NULL, 228745),
(228746, '4.10.400.10-FF-000308', NULL, 'Uncharacterized protein', 37, NULL, NULL, 228746),
(228747, '1.20.58.1380-FF-000013', NULL, 'Uncharacterized protein', 92, NULL, NULL, 228747),
(228748, '1.20.1280.80-FF-000001', NULL, 'SepL/TyeA/HrpJ family type III secretion system gatekeeper', 91, NULL, NULL, 228748),
(228749, '1.20.1250.20-FF-001712', NULL, 'Os05g0567700 protein', 125, NULL, NULL, 228749),
(228750, '2.60.40.10-FF-000472', NULL, 'CD166 antigen isoform X2', 112, NULL, NULL, 228750),
(228751, '1.10.10.10-FF-002037', NULL, 'Probable transcriptional regulator', 86, NULL, NULL, 228751),
(228752, '2.110.10.10-FF-000063', NULL, 'Uncharacterized protein', 137, NULL, NULL, 228752),
(228753, '2.60.40.10-FF-000814', NULL, 'Platelet-derived growth factor receptor beta', 99, NULL, NULL, 228753),
(228754, '2.60.200.20-FF-000141', NULL, 'Penicillin-binding protein 1B', 123, NULL, NULL, 228754),
(228755, '3.40.50.300-FF-000416', NULL, 'p-loop nucleoside triphosphate hydrolase superfamily protein', 175, NULL, NULL, 228755),
(228756, '3.30.160.60-FF-000247', NULL, 'Zinc finger protein 236', 28, NULL, NULL, 228756),
(228757, '3.30.60.20-FF-000093', NULL, 'Related to ser/thr protein kinase', 56, NULL, NULL, 228757),
(228758, '3.30.70.3490-FF-000008', NULL, 'Oxysterol-binding protein-related protein 3C', 94, NULL, NULL, 228758),
(228759, '2.130.10.10-FF-000781', NULL, 'Cytoplasmic dynein intermediate chain', 326, NULL, NULL, 228759),
(228760, '3.90.1100.10-FF-000012', NULL, 'DNA-directed RNA polymerase subunit beta', 189, NULL, NULL, 228760),
(228761, '1.25.40.20-FF-000575', NULL, 'Potassium channel AKT1', 185, NULL, NULL, 228761),
(228762, '3.80.10.10-FF-001372', NULL, 'Uncharacterized protein', 156, NULL, NULL, 228762),
(228763, '1.20.1070.10-FF-001162', NULL, 'Uncharacterized protein', 291, NULL, NULL, 228763),
(228764, '1.10.10.10-FF-000457', NULL, 'Two component transcriptional regulator NrrA', 110, NULL, NULL, 228764),
(228765, '1.10.1070.11-FF-000136', NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', 135, NULL, NULL, 228765),
(228766, '1.25.40.10-FF-003793', NULL, 'Uncharacterized protein', 145, NULL, NULL, 228766),
(228767, '1.20.1070.10-FF-001504', NULL, 'Protease-activated receptor 3', 198, NULL, NULL, 228767),
(228768, '3.30.40.10-FF-001960', NULL, 'Uncharacterized protein', 65, NULL, NULL, 228768),
(228769, '1.10.8.60-FF-000584', NULL, 'Uncharacterized protein', 20, NULL, NULL, 228769),
(228770, '3.40.50.1000-FF-000119', NULL, 'Bifunctional riboflavin kinase/FMN phosphatase', 132, NULL, NULL, 228770),
(228771, '2.40.10.10-FF-000252', NULL, 'Serine protease H158', 243, NULL, NULL, 228771),
(228772, '1.25.40.10-FF-000920', NULL, 'Os03g0369700 protein', 117, NULL, NULL, 228772),
(228773, '3.40.50.720-FF-001930', NULL, 'Uncharacterized protein', 289, NULL, NULL, 228773),
(228774, '3.30.160.60-FF-002720', NULL, 'Zinc finger protein 234', 27, NULL, NULL, 228774),
(228775, '2.120.10.80-FF-000173', NULL, 'Multiple EGF-like-domains 8', 136, NULL, NULL, 228775),
(228776, '1.10.472.80-FF-000248', NULL, NULL, 123, NULL, NULL, 228776),
(228777, '1.10.150.80-FF-000028', NULL, 'ATP-dependent DNA helicase RecQ', 71, NULL, NULL, 228777);
INSERT INTO "PUBLIC"."MODEL" VALUES
(228778, '3.30.830.10-FF-000109', NULL, 'nardilysin', 236, NULL, NULL, 228778),
(228779, '1.10.10.820-FF-000016', NULL, 'Myosin-A', 56, NULL, NULL, 228779),
(228780, '1.10.730.10-FF-000018', NULL, 'Leucine--tRNA ligase', 159, NULL, NULL, 228780),
(228781, '3.30.540.10-FF-000014', NULL, 'Fructose-1,6-bisphosphatase, chloroplastic', 204, NULL, NULL, 228781),
(228782, '2.10.25.10-FF-001046', NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1a', 38, NULL, NULL, 228782),
(228783, '3.40.50.2020-FF-000190', NULL, 'Uridine monophosphate synthetase', 62, NULL, NULL, 228783),
(228784, '3.30.70.330-FF-002117', NULL, NULL, 111, NULL, NULL, 228784),
(228785, '1.10.287.110-FF-000259', NULL, 'AT29763p', 115, NULL, NULL, 228785),
(228786, '1.10.510.10-FF-000816', NULL, 'Uncharacterized protein, isoform D', 181, NULL, NULL, 228786),
(228787, '3.40.50.300-FF-004339', NULL, 'ABC transporter ATP-binding protein/permease', 250, NULL, NULL, 228787),
(228788, '1.25.40.20-FF-000923', NULL, 'Uncharacterized protein', 124, NULL, NULL, 228788),
(228789, '3.30.70.980-FF-000053', NULL, 'YALI0E16214p', 82, NULL, NULL, 228789),
(228790, '2.60.40.1110-FF-000002', NULL, 'tensin-1 isoform X2', 123, NULL, NULL, 228790),
(228791, '1.25.70.10-FF-000074', NULL, NULL, 206, NULL, NULL, 228791),
(228792, '3.40.50.880-FF-000101', NULL, '4-methyl-5(Beta-hydroxyethyl)-thiazole monophosphate synthesis protein, putative', 195, NULL, NULL, 228792),
(228793, '3.30.1520.10-FF-000012', NULL, 'Sorting nexin 10', 155, NULL, NULL, 228793),
(228794, '3.30.70.330-FF-003079', NULL, NULL, 94, NULL, NULL, 228794),
(228795, '1.25.40.10-FF-000572', NULL, 'Hsp70/Hsp90 organizing protein', 129, NULL, NULL, 228795),
(228796, '1.20.140.100-FF-000045', NULL, 'Dynein heavy chain 9', 151, NULL, NULL, 228796),
(228797, '3.90.25.70-FF-000001', NULL, 'Fatty acid synthase subunit alpha', 92, NULL, NULL, 228797),
(228798, '2.60.40.1120-FF-000005', NULL, 'Carboxypeptidase D', 94, NULL, NULL, 228798),
(228799, '3.20.20.70-FF-000639', NULL, 'Glycolate oxidase', 386, NULL, NULL, 228799),
(228800, '3.30.60.30-FF-000096', NULL, 'Protein CBG17314', 58, NULL, NULL, 228800),
(228801, '1.25.40.20-FF-000468', NULL, 'Ankyrin repeat and sterile alpha motif domain containing 1A', 64, NULL, NULL, 228801),
(228802, '1.20.1250.20-FF-001370', NULL, 'Uncharacterized protein', 272, NULL, NULL, 228802),
(228803, '1.20.1390.10-FF-000011', NULL, 'Uncharacterized protein', 116, NULL, NULL, 228803),
(228804, '3.30.160.60-FF-000466', NULL, 'zinc finger protein 62 homolog', 29, NULL, NULL, 228804),
(228805, '3.40.50.1000-FF-000338', NULL, 'Inorganic pyrophosphatase 2', 193, NULL, NULL, 228805),
(228806, '3.90.1150.10-FF-000503', NULL, 'Glycine cleavage system P protein', 99, NULL, NULL, 228806),
(228807, '4.10.365.10-FF-000006', NULL, 'Dacapo', 87, NULL, NULL, 228807),
(228808, '3.10.320.10-FF-000002', NULL, 'HLA class II histocompatibility antigen, DR alpha chain', 80, NULL, NULL, 228808),
(228809, '2.30.30.40-FF-000335', NULL, 'Endolysin', 96, NULL, NULL, 228809),
(228810, '1.10.1780.10-FF-000009', NULL, 'Chaperone protein ClpB1, putative', 151, NULL, NULL, 228810),
(228811, '3.90.70.10-FF-000548', NULL, 'Uncharacterized protein', 218, NULL, NULL, 228811),
(228812, '1.10.10.60-FF-000332', NULL, 'Motor neuron and pancreas homeobox 2b', 76, NULL, NULL, 228812),
(228813, '2.40.170.20-FF-000024', NULL, 'TonB-dependent siderophore receptor', 541, NULL, NULL, 228813),
(228814, '1.10.8.960-FF-000010', NULL, 'AaceriAFR086Cp', 64, NULL, NULL, 228814),
(228815, '2.60.40.10-FF-002057', NULL, 'Predicted protein', 99, NULL, NULL, 228815),
(228816, '3.40.950.10-FF-000009', NULL, 'Nuclear prelamin A recognition factor', 131, NULL, NULL, 228816),
(228817, '3.40.630.10-FF-000070', NULL, 'Putative carboxypeptidase suro-1', 330, NULL, NULL, 228817),
(228818, '1.20.1250.20-FF-000869', NULL, 'Pept-2', 132, NULL, NULL, 228818),
(228819, '3.40.1000.50-FF-000022', NULL, 'Repressor of RNA polymerase III transcription MAF1', 98, NULL, NULL, 228819),
(228820, '3.40.50.620-FF-000040', NULL, 'Tyrosine--tRNA ligase', 213, NULL, NULL, 228820);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(228821, '3.90.226.10-FF-000304', NULL, 'Uncharacterized protein', 120, NULL, NULL, 228821),
(228822, '2.30.180.10-FF-000136', NULL, NULL, 150, NULL, NULL, 228822),
(228823, '1.10.8.270-FF-000005', NULL, 'TBC1 domain family member 15', 114, NULL, NULL, 228823),
(228824, '3.30.200.20-FF-000531', NULL, 'Calcium/calmodulin-dependent protein kinase type', 98, NULL, NULL, 228824),
(228825, '1.10.405.10-FF-000016', NULL, 'Amine oxidase, flavin-containing', 116, NULL, NULL, 228825),
(228826, '2.30.29.30-FF-001099', NULL, 'Switch-associated protein 70-like Protein', 164, NULL, NULL, 228826),
(228827, '3.90.1180.10-FF-000005', NULL, '39S ribosomal protein L13, mitochondrial', 178, NULL, NULL, 228827),
(228828, '3.30.200.20-FF-001942', NULL, 'Uncharacterized protein', 109, NULL, NULL, 228828),
(228829, '2.130.10.10-FF-003783', NULL, 'Chromosome 1, whole genome shotgun sequence', 315, NULL, NULL, 228829),
(228830, '3.90.79.10-FF-000203', NULL, 'Phosphohydrolase (MutT/nudix family protein)', 139, NULL, NULL, 228830),
(228831, '1.25.40.20-FF-000794', NULL, 'Ankyrin repeat domain-containing protein 7', 95, NULL, NULL, 228831),
(228832, '2.60.40.60-FF-000245', NULL, 'Cadherin related family member 2', 116, NULL, NULL, 228832),
(228833, '3.40.50.2300-FF-000060', NULL, 'Protein-glutamate methylesterase/protein-glutamine glutaminase', 133, NULL, NULL, 228833),
(228834, '2.60.40.10-FF-003687', NULL, NULL, 109, NULL, NULL, 228834),
(228835, '2.60.40.10-FF-002950', NULL, 'AGAP003610-PA', 104, NULL, NULL, 228835),
(228836, '3.40.50.1820-FF-001091', NULL, 'Protein CBG23034', 275, NULL, NULL, 228836),
(228837, '3.40.225.10-FF-000004', NULL, 'gamma-adducin isoform X1', 259, NULL, NULL, 228837),
(228838, '3.30.810.10-FF-000007', NULL, 'Phosphatidylinositol 4-phosphate 5-kinase', 89, NULL, NULL, 228838),
(228839, '1.10.357.110-FF-000012', NULL, 'Uncharacterized protein', 198, NULL, NULL, 228839),
(228840, '1.25.10.10-FF-000744', NULL, 'HEAT repeat-containing protein 3 isoform X2', 391, NULL, NULL, 228840),
(228841, '1.10.1200.260-FF-000001', NULL, 'Potassium voltage-gated channel subfamily H member 7', 42, NULL, NULL, 228841),
(228842, '3.40.449.10-FF-000013', NULL, 'Phosphoenolypyruvate CarboxyKinase', 259, NULL, NULL, 228842),
(228843, '1.10.238.10-FF-000548', NULL, 'Calcium-dependent protein kinase 3', 96, NULL, NULL, 228843),
(228844, '3.90.260.10-FF-000018', NULL, 'XPC complex subunit, DNA damage recognition and repair factor', 235, NULL, NULL, 228844),
(228845, '1.10.418.10-FF-000102', NULL, 'Related to CDC24-GTP/GDP exchange factor for Cdc42p', 105, NULL, NULL, 228845),
(228846, '3.90.1800.10-FF-000020', NULL, 'DNA-directed RNA polymerase subunit beta', 121, NULL, NULL, 228846),
(228847, '3.40.366.10-FF-000022', NULL, 'Polyketide biosynthesis protein PksE', 204, NULL, NULL, 228847),
(228848, '1.10.510.10-FF-000581', NULL, 'Cysteine-rich receptor-like protein kinase 10', 206, NULL, NULL, 228848),
(228849, '3.90.550.10-FF-000226', NULL, 'Glucose-1-phosphate adenylyltransferase (ADP-glucose pyrophosphorylase)', 154, NULL, NULL, 228849),
(228850, '1.25.40.10-FF-000027', NULL, 'stress-induced-phosphoprotein 1 isoform X1', 120, NULL, NULL, 228850),
(228851, '3.40.50.2300-FF-000402', NULL, 'Uncharacterized protein', 289, NULL, NULL, 228851),
(228852, '3.40.50.300-FF-008049', NULL, 'Uncharacterized protein', 128, NULL, NULL, 228852),
(228853, '3.40.50.1980-FF-000036', NULL, 'Probable periplasmic iron-transport lipoprotein', 142, NULL, NULL, 228853),
(228854, '1.10.510.10-FF-003689', NULL, NULL, 169, NULL, NULL, 228854),
(228855, '3.40.50.1970-FF-000033', NULL, 'Alcohol dehydrogenase, putative', 193, NULL, NULL, 228855),
(228856, '3.50.50.60-FF-000081', NULL, 'prenylcysteine oxidase 1', 312, NULL, NULL, 228856),
(228857, '3.30.160.60-FF-004737', NULL, NULL, 30, NULL, NULL, 228857),
(228858, '2.70.130.10-FF-000107', NULL, NULL, 146, NULL, NULL, 228858),
(228859, '1.10.3900.10-FF-000003', NULL, 'Cell division protein ZapD', 163, NULL, NULL, 228859),
(228860, '3.50.30.10-FF-000003', NULL, 'Phosphoenolpyruvate-protein phosphotransferase ptsP', 105, NULL, NULL, 228860);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(228861, '3.30.160.60-FF-000814', NULL, 'Zinc finger and BTB domain-containing protein 26', 55, NULL, NULL, 228861),
(228862, '3.40.50.10860-FF-000013', NULL, 'Methylenetetrahydrofolate dehydrogenase (NADP+ dependent) 1 like', 123, NULL, NULL, 228862),
(228863, '1.25.10.10-FF-000525', NULL, 'Armadillo repeat-containing protein 5', 407, NULL, NULL, 228863),
(228864, '1.10.720.30-FF-000069', NULL, 'SUMO ligase', 38, NULL, NULL, 228864),
(228865, '3.30.160.60-FF-006430', NULL, NULL, 18, NULL, NULL, 228865),
(228866, '3.40.190.10-FF-000041', NULL, 'Putrescine-binding periplasmic protein', 162, NULL, NULL, 228866),
(228867, '3.40.50.10330-FF-000085', NULL, 'NAD kinase', 125, NULL, NULL, 228867),
(228868, '3.40.50.1000-FF-000557', NULL, NULL, 138, NULL, NULL, 228868),
(228869, '1.20.1530.20-FF-000003', NULL, 'Cation/H(+) antiporter 15', 403, NULL, NULL, 228869),
(228870, '1.25.40.20-FF-000249', NULL, 'Cyclin-dependent kinase inhibitor 2A', 83, NULL, NULL, 228870),
(228871, '2.60.120.310-FF-000004', NULL, 'DBH-like monooxygenase protein 1', 162, NULL, NULL, 228871),
(228872, '2.40.10.120-FF-000009', NULL, 'Complement factor B', 219, NULL, NULL, 228872),
(228873, '2.60.40.60-FF-000790', NULL, 'Uncharacterized protein', 77, NULL, NULL, 228873),
(228874, '1.10.10.60-FF-000551', NULL, 'Predicted protein', 60, NULL, NULL, 228874),
(228875, '3.30.60.20-FF-000109', NULL, 'Signal transducer', 68, NULL, NULL, 228875),
(228876, '3.90.1480.20-FF-000048', NULL, 'ST3 beta-galactoside alpha-2,3-sialyltransferase 1', 179, NULL, NULL, 228876),
(228877, '3.40.630.30-FF-000295', NULL, 'GCN5-related N-acetyltransferase', 208, NULL, NULL, 228877),
(228878, '2.160.20.70-FF-000017', NULL, 'Similar to tubulin-specific chaperone c', 162, NULL, NULL, 228878),
(228879, '2.130.10.10-FF-000343', NULL, 'WD repeat domain, phosphoinositide interacting 1', 274, NULL, NULL, 228879),
(228880, '3.40.50.720-FF-000300', NULL, 'Ubiquitin-activating enzyme E1 C', 227, NULL, NULL, 228880),
(228881, '3.40.50.300-FF-006475', NULL, 'Uncharacterized protein', 117, NULL, NULL, 228881),
(228882, '3.80.10.10-FF-001708', NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', 221, NULL, NULL, 228882),
(228883, '3.40.1620.30-FF-000001', NULL, 'Essential meiotic structure-specific endonuclease 1', 62, NULL, NULL, 228883),
(228884, '2.60.40.1510-FF-000009', NULL, 'Integrin alpha M', 152, NULL, NULL, 228884),
(228885, '4.10.60.10-FF-000217', NULL, 'Uncharacterized protein', 36, NULL, NULL, 228885),
(228886, '1.10.730.10-FF-000237', NULL, 'Methionine--tRNA ligase', 170, NULL, NULL, 228886),
(228887, '3.40.50.980-FF-000013', NULL, 'Long-chain fatty acid--CoA ligase', 177, NULL, NULL, 228887),
(228888, '1.25.40.10-FF-000246', NULL, 'SEL1L family member 3', 153, NULL, NULL, 228888),
(228889, '1.20.1270.170-FF-000001', NULL, 'Stress response kinase A', 98, NULL, NULL, 228889),
(228890, '1.20.960.30-FF-000005', NULL, 'Putative LisH domain protein', 63, NULL, NULL, 228890),
(228891, '2.120.10.30-FF-000310', NULL, 'Gluconolaconase', 292, NULL, NULL, 228891),
(228892, '2.60.260.20-FF-000026', NULL, 'Uncharacterized protein, isoform B', 82, NULL, NULL, 228892),
(228893, '3.90.400.10-FF-000007', NULL, 'Sucrose phosphorylase', 83, NULL, NULL, 228893),
(228894, '3.20.20.70-FF-000858', NULL, NULL, 50, NULL, NULL, 228894),
(228895, '3.40.50.200-FF-000156', NULL, 'Subtilisin-like alkaline protease, putative', 290, NULL, NULL, 228895),
(228896, '1.10.8.260-FF-000002', NULL, '3-dehydro-bile acid delta(4,6)-reductase', 65, NULL, NULL, 228896),
(228897, '3.40.50.1820-FF-001433', NULL, 'Uncharacterized protein', 194, NULL, NULL, 228897),
(228898, '2.130.10.10-FF-000904', NULL, 'Probable SEC13-protein transport protein', 321, NULL, NULL, 228898),
(228899, '2.130.10.10-FF-004614', NULL, 'Uncharacterized protein', 200, NULL, NULL, 228899),
(228900, '3.40.50.720-FF-001711', NULL, 'Oxidoreductase, putative', 135, NULL, NULL, 228900),
(228901, '1.10.238.10-FF-000335', NULL, 'Calcium-binding protein KIC', 117, NULL, NULL, 228901),
(228902, '3.40.50.970-FF-000010', NULL, '1-deoxy-D-xylulose-5-phosphate synthase', 227, NULL, NULL, 228902);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(228903, '3.20.20.450-FF-000021', NULL, 'Response regulator', 252, NULL, NULL, 228903),
(228904, '3.30.2350.20-FF-000081', NULL, NULL, 226, NULL, NULL, 228904),
(228905, '3.30.40.10-FF-002123', NULL, 'Uncharacterized protein', 92, NULL, NULL, 228905),
(228906, '3.30.1560.10-FF-000003', NULL, 'Transcription elongation factor A protein-like 4', 61, NULL, NULL, 228906),
(228907, '3.30.160.60-FF-004176', NULL, NULL, 27, NULL, NULL, 228907),
(228908, '2.40.70.10-FF-000356', NULL, NULL, 140, NULL, NULL, 228908),
(228909, '3.10.20.90-FF-000264', NULL, 'ISG15 ubiquitin-like modifier', 77, NULL, NULL, 228909),
(228910, '3.30.40.10-FF-001634', NULL, 'Structure-specific endonuclease subunit SLX1', 87, NULL, NULL, 228910),
(228911, '1.20.1070.10-FF-001381', NULL, 'Predicted protein', 251, NULL, NULL, 228911),
(228912, '2.60.40.10-FF-003001', NULL, 'Uncharacterized protein', 88, NULL, NULL, 228912),
(228913, '3.90.110.10-FF-000013', NULL, 'Malate dehydrogenase', 170, NULL, NULL, 228913),
(228914, '3.10.20.90-FF-000483', NULL, 'Histidine ammonia-lyase', 90, NULL, NULL, 228914),
(228915, '2.60.40.10-FF-002383', NULL, 'Muscle M-line assembly protein unc-89', 98, NULL, NULL, 228915),
(228916, '3.30.30.30-FF-000055', NULL, 'Hsp70 protein-domain-containing protein', 57, NULL, NULL, 228916),
(228917, '3.90.550.10-FF-000451', NULL, 'Uncharacterized protein', 175, NULL, NULL, 228917),
(228918, '2.60.40.1660-FF-000026', NULL, 'Uncharacterized protein', 285, NULL, NULL, 228918),
(228919, '1.10.510.10-FF-000255', NULL, 'Calcium/calmodulin-dependent protein kinase type IV', 180, NULL, NULL, 228919),
(228920, '3.40.50.300-FF-008162', NULL, 'Glutathione s-transferase', 89, NULL, NULL, 228920),
(228921, '2.60.40.1670-FF-000029', NULL, NULL, 85, NULL, NULL, 228921),
(228922, '3.40.1280.30-FF-000025', NULL, 'tRNA (guanine(9)-N1)-methyltransferase', 192, NULL, NULL, 228922),
(228923, '2.160.20.10-FF-000027', NULL, 'Probable exopolygalacturonase X', 385, NULL, NULL, 228923),
(228924, '3.30.450.40-FF-000123', NULL, 'Sigma-54-dependent Fis family transcriptional regulator', 167, NULL, NULL, 228924),
(228925, '2.10.25.10-FF-001490', NULL, 'Putative fibrillin 2', 36, NULL, NULL, 228925),
(228926, '2.60.40.10-FF-004530', NULL, NULL, 62, NULL, NULL, 228926),
(228927, '3.30.870.10-FF-000112', NULL, 'Tyrosyl-DNA phosphodiesterase 1', 204, NULL, NULL, 228927),
(228928, '3.30.1360.120-FF-000106', NULL, 'Uncharacterized protein', 69, NULL, NULL, 228928),
(228929, '3.90.230.10-FF-000067', NULL, NULL, 78, NULL, NULL, 228929),
(228930, '3.40.50.1820-FF-000123', NULL, 'Carboxypeptidase', 441, NULL, NULL, 228930),
(228931, '3.30.70.330-FF-001735', NULL, NULL, 89, NULL, NULL, 228931),
(228932, '3.40.50.1240-FF-000157', NULL, NULL, 204, NULL, NULL, 228932),
(228933, '1.10.3720.10-FF-000017', NULL, 'Arginine ABC transporter permease protein ArtM', 216, NULL, NULL, 228933),
(228934, '2.10.220.10-FF-000167', NULL, 'Proprotein convertase subtilisin/kexin type 5', 90, NULL, NULL, 228934),
(228935, '1.10.238.10-FF-000329', NULL, 'calcyphosin isoform X2', 99, NULL, NULL, 228935),
(228936, '2.60.120.10-FF-000098', NULL, 'Germin-like protein 9-3', 182, NULL, NULL, 228936),
(228937, '1.25.40.10-FF-004282', NULL, 'Uncharacterized protein', 206, NULL, NULL, 228937),
(228938, '3.30.565.10-FF-000217', NULL, 'Sensory transduction histidine kinase', 158, NULL, NULL, 228938),
(228939, '3.30.200.20-FF-002111', NULL, 'Haspin protein kinase', 178, NULL, NULL, 228939),
(228940, '3.40.50.1980-FF-000143', NULL, 'Sll1202 protein', 175, NULL, NULL, 228940),
(228941, '1.10.10.10-FF-001981', NULL, 'Uncharacterized protein', 57, NULL, NULL, 228941),
(228942, '3.80.10.10-FF-003619', NULL, 'Uncharacterized protein', 104, NULL, NULL, 228942),
(228943, '2.60.40.1670-FF-000035', NULL, NULL, 59, NULL, NULL, 228943),
(228944, '2.60.200.20-FF-000253', NULL, 'Gll1406 protein', 102, NULL, NULL, 228944),
(228945, '2.40.70.10-FF-000250', NULL, 'Uncharacterized protein', 177, NULL, NULL, 228945),
(228946, '2.90.10.10-FF-000053', NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase RLK1', 102, NULL, NULL, 228946);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(228947, '3.30.160.60-FF-006087', NULL, NULL, 26, NULL, NULL, 228947),
(228948, '2.60.40.60-FF-000683', NULL, 'Predicted protein', 116, NULL, NULL, 228948),
(228949, '3.30.30.30-FF-000049', NULL, 'AGAP007682-PA', 35, NULL, NULL, 228949),
(228950, '2.30.30.40-FF-000442', NULL, 'rho GTPase-activating protein 27 isoform X1', 79, NULL, NULL, 228950),
(228951, '1.20.1280.50-FF-000239', NULL, 'F-box/leucine rich repeat protein, putative', 46, NULL, NULL, 228951),
(228952, '3.30.70.330-FF-002342', NULL, NULL, 109, NULL, NULL, 228952),
(228953, '3.40.50.11610-FF-000030', NULL, NULL, 160, NULL, NULL, 228953),
(228954, '3.30.360.10-FF-000135', NULL, 'Uncharacterized protein', 191, NULL, NULL, 228954),
(228955, '3.30.565.10-FF-000324', NULL, 'Sensor histidine kinase', 156, NULL, NULL, 228955),
(228956, '1.25.10.10-FF-001599', NULL, 'Uncharacterized protein', 241, NULL, NULL, 228956),
(228957, '3.30.1360.120-FF-000095', NULL, 'Sarcosine dehydrogenase', 200, NULL, NULL, 228957),
(228958, '1.20.1420.30-FF-000003', NULL, 'sodium/calcium exchanger 1 isoform X1', 215, NULL, NULL, 228958),
(228959, '3.80.10.10-FF-000877', NULL, 'Ubiquitin ligase complex F-box protein GRR1', 95, NULL, NULL, 228959),
(228960, '3.60.21.10-FF-000167', NULL, 'Acid sphingomyelinase-like phosphodiesterase', 301, NULL, NULL, 228960),
(228961, '3.30.9.10-FF-000269', NULL, 'Uncharacterized protein', 109, NULL, NULL, 228961),
(228962, '2.60.40.1660-FF-000032', NULL, 'Uncharacterized protein', 161, NULL, NULL, 228962),
(228963, '1.10.287.110-FF-000153', NULL, 'Chaperone protein DnaJ', 112, NULL, NULL, 228963),
(228964, '1.20.1250.20-FF-001931', NULL, 'Uncharacterized protein', 211, NULL, NULL, 228964),
(228965, '3.90.79.10-FF-000080', NULL, '8-oxo-dGDP phosphatase NUDT18', 158, NULL, NULL, 228965),
(228966, '3.10.110.10-FF-000290', NULL, 'Ubiquitin-conjugating enzyme E2, J2 (UBC6 homolog, yeast)', 111, NULL, NULL, 228966),
(228967, '1.10.287.1490-FF-000062', NULL, 'Protein phosphatase 1 regulatory subunit 9A-like A', 159, NULL, NULL, 228967),
(228968, '1.25.10.10-FF-002330', NULL, 'Uncharacterized protein', 300, NULL, NULL, 228968),
(228969, '2.60.40.1510-FF-000015', NULL, 'Integrin subunit alpha 11', 173, NULL, NULL, 228969),
(228970, '1.10.238.10-FF-000661', NULL, '45 kDa calcium-binding protein', 186, NULL, NULL, 228970),
(228971, '2.10.25.10-FF-001501', NULL, 'Uncharacterized protein', 32, NULL, NULL, 228971),
(228972, '2.160.20.10-FF-000140', NULL, 'Uncharacterized protein', 68, NULL, NULL, 228972),
(228973, '3.40.50.970-FF-000122', NULL, 'Related to MET10-sulfite reductase flavin-binding subunit', 234, NULL, NULL, 228973),
(228974, '3.10.20.90-FF-000590', NULL, 'Tubulin-folding cofactor B', 85, NULL, NULL, 228974),
(228975, '1.10.3720.10-FF-000130', NULL, 'ABC transporter permease protein', 220, NULL, NULL, 228975),
(228976, '1.20.120.730-FF-000022', NULL, 'Protein transport protein Sec24C, putative', 134, NULL, NULL, 228976),
(228977, '3.40.190.10-FF-000147', NULL, 'Uncharacterized protein, isoform C', 126, NULL, NULL, 228977),
(228978, '3.30.40.10-FF-001067', NULL, 'Putative E3 ubiquitin-protein ligase RING1a', 161, NULL, NULL, 228978),
(228979, '3.50.50.60-FF-000204', NULL, 'Rab proteins geranylgeranyltransferase component', 200, NULL, NULL, 228979),
(228980, '1.10.287.110-FF-000046', NULL, 'dnaJ homolog subfamily C member 21', 80, NULL, NULL, 228980),
(228981, '1.20.144.10-FF-000053', NULL, 'Phosphatidylglycerophosphatase B, putative', 238, NULL, NULL, 228981),
(228982, '3.40.50.300-FF-008055', NULL, 'Uncharacterized protein', 126, NULL, NULL, 228982),
(228983, '1.10.3210.10-FF-000046', NULL, 'Retrograde regulation protein 2', 166, NULL, NULL, 228983),
(228984, '2.60.40.10-FF-002276', NULL, 'Twitchin', 92, NULL, NULL, 228984),
(228985, '3.60.21.10-FF-000493', NULL, 'Serine/threonine-protein phosphatase', 359, NULL, NULL, 228985),
(228986, '3.90.480.10-FF-000001', NULL, 'Sulfite reductase [ferredoxin], chloroplastic', 84, NULL, NULL, 228986),
(228987, '3.80.10.10-FF-001821', NULL, 'F-box protein SKIP17', 127, NULL, NULL, 228987);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(228988, '3.30.230.70-FF-000014', NULL, 'Polyribonucleotide nucleotidyltransferase', 318, NULL, NULL, 228988),
(228989, '3.30.200.20-FF-002094', NULL, 'Uncharacterized protein', 81, NULL, NULL, 228989),
(228990, '2.120.10.30-FF-000422', NULL, 'Tripartite motif-containing 3', 164, NULL, NULL, 228990),
(228991, '3.40.50.720-FF-001368', NULL, 'Oxidoreductase', 107, NULL, NULL, 228991),
(228992, '2.170.150.20-FF-000003', NULL, 'Peptide methionine sulfoxide reductase MsrB', 147, NULL, NULL, 228992),
(228993, '2.30.18.10-FF-000005', NULL, 'transcription initiation factor IIA large subunit', 67, NULL, NULL, 228993),
(228994, '2.130.10.10-FF-000910', NULL, 'Diphthamide biosynthesis 7', 336, NULL, NULL, 228994),
(228995, '3.90.70.10-FF-000099', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 369, NULL, NULL, 228995),
(228996, '3.90.480.20-FF-000004', NULL, 'Nitrite reductase large subunit', 101, NULL, NULL, 228996),
(228997, '3.30.870.10-FF-000095', NULL, 'Competence protein ComE', 180, NULL, NULL, 228997),
(228998, '3.40.50.300-FF-002653', NULL, 'Genome polyprotein', 127, NULL, NULL, 228998),
(228999, '1.10.1070.11-FF-000030', NULL, 'Histone acetylase complex subunit Paf400', 177, NULL, NULL, 228999),
(229000, '1.10.10.440-FF-000009', NULL, 'pre-mRNA-processing factor 40 homolog A isoform X1', 60, NULL, NULL, 229000),
(229001, '3.90.280.10-FF-000014', NULL, 'Phosphatidylethanolamine-binding protein, putative', 174, NULL, NULL, 229001),
(229002, '1.10.510.10-FF-001778', NULL, 'Protein kinase superfamily protein', 301, NULL, NULL, 229002),
(229003, '2.30.29.90-FF-000015', NULL, 'Uncharacterized protein C17G8.12', 133, NULL, NULL, 229003),
(229004, '3.30.1010.10-FF-000142', NULL, 'Si:dkeyp-75h12.7', 135, NULL, NULL, 229004),
(229005, '1.20.58.390-FF-000229', NULL, 'Uncharacterized protein', 69, NULL, NULL, 229005),
(229006, '3.20.20.300-FF-000010', NULL, 'Putative beta-D-xylosidase 5', 340, NULL, NULL, 229006),
(229007, '3.30.160.60-FF-002613', NULL, 'Uncharacterized protein', 27, NULL, NULL, 229007),
(229008, '1.10.10.430-FF-000006', NULL, 'Protein phosphatase 1B (formerly 2C)', 71, NULL, NULL, 229008),
(229009, '3.30.40.10-FF-001853', NULL, 'Uncharacterized protein', 81, NULL, NULL, 229009),
(229010, '2.40.70.10-FF-000137', NULL, 'Eukaryotic aspartyl protease family protein', 185, NULL, NULL, 229010),
(229011, '1.25.40.10-FF-004175', NULL, 'Uncharacterized protein', 95, NULL, NULL, 229011),
(229012, '3.30.50.10-FF-000044', NULL, 'retinoic acid receptor beta isoform X4', 102, NULL, NULL, 229012),
(229013, '1.10.620.20-FF-000013', NULL, 'Benzoyl-CoA oxygenase subunit B', 477, NULL, NULL, 229013),
(229014, '3.30.70.240-FF-000062', NULL, 'Ribosome-releasing factor 2, mitochondrial', 133, NULL, NULL, 229014),
(229015, '2.130.10.10-FF-002254', NULL, 'WD Repeat protein', 275, NULL, NULL, 229015),
(229016, '2.170.270.10-FF-000054', NULL, 'Blast:Chromosome-associated kinesin KIF4A', 111, NULL, NULL, 229016),
(229017, '2.40.390.10-FF-000003', NULL, 'Uncharacterized protein', 123, NULL, NULL, 229017),
(229018, '3.40.30.10-FF-000537', NULL, 'Diphosphomevalonate decarboxylase MVD2', 129, NULL, NULL, 229018),
(229019, '3.80.10.10-FF-003951', NULL, 'Uncharacterized protein', 66, NULL, NULL, 229019),
(229020, '2.130.10.10-FF-005688', NULL, 'Uncharacterized protein', 156, NULL, NULL, 229020),
(229021, '3.90.1420.10-FF-000047', NULL, 'Rubisco small subunit small subunit n-methyltransferase', 130, NULL, NULL, 229021),
(229022, '3.40.50.1820-FF-001652', NULL, 'Uncharacterized protein', 124, NULL, NULL, 229022),
(229023, '3.90.740.10-FF-000044', NULL, 'Isoleucine--tRNA ligase', 183, NULL, NULL, 229023),
(229024, '2.60.120.200-FF-000769', NULL, 'Laminin alpha 2', 62, NULL, NULL, 229024),
(229025, '1.20.1250.20-FF-001818', NULL, 'Uncharacterized protein', 155, NULL, NULL, 229025),
(229026, '1.20.1070.10-FF-001717', NULL, 'Uncharacterized protein', 101, NULL, NULL, 229026),
(229027, '3.30.230.130-FF-000059', NULL, 'AFR498Wp', 160, NULL, NULL, 229027),
(229028, '3.40.50.300-FF-000293', NULL, 'ATP binding cassette subfamily C member 1', 244, NULL, NULL, 229028);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(229029, '3.40.47.10-FF-000053', NULL, 'Alpha-pyrone synthesis polyketide synthase', 208, NULL, NULL, 229029),
(229030, '2.30.30.40-FF-000329', NULL, 'Trio, isoform D', 76, NULL, NULL, 229030),
(229031, '3.30.1490.100-FF-000033', NULL, 'DNA polymerase IV', 100, NULL, NULL, 229031),
(229032, '3.10.110.10-FF-000071', NULL, 'RWD domain-containing protein 1', 129, NULL, NULL, 229032),
(229033, '1.20.140.150-FF-000037', NULL, 'GSG1 like 2', 231, NULL, NULL, 229033),
(229034, '1.25.40.10-FF-002045', NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', 147, NULL, NULL, 229034),
(229035, '3.30.160.60-FF-004743', NULL, NULL, 27, NULL, NULL, 229035),
(229036, '3.40.50.880-FF-000084', NULL, '4-methyl-5(B-hydroxyethyl)-thiazole monophosphate biosynthesis enzyme', 183, NULL, NULL, 229036),
(229037, '2.30.42.10-FF-000331', NULL, 'Protease Do-like 8, chloroplastic', 103, NULL, NULL, 229037),
(229038, '3.60.21.10-FF-000274', NULL, 'Uncharacterized protein', 159, NULL, NULL, 229038),
(229039, '3.40.50.720-FF-001587', NULL, 'SDR family oxidoreductase', 227, NULL, NULL, 229039),
(229040, '2.60.40.10-FF-004417', NULL, NULL, 98, NULL, NULL, 229040),
(229041, '3.40.50.261-FF-000017', NULL, 'Succinyl-CoA synthetase subunit alpha', 180, NULL, NULL, 229041),
(229042, '1.10.10.10-FF-001868', NULL, 'Uncharacterized protein', 66, NULL, NULL, 229042),
(229043, '3.40.630.10-FF-000406', NULL, 'Uncharacterized protein', 180, NULL, NULL, 229043),
(229044, '3.10.110.10-FF-000301', NULL, 'Si:ch1073-205c8.3', 99, NULL, NULL, 229044),
(229045, '2.30.30.40-FF-000099', NULL, 'Uncharacterized protein, isoform C', 64, NULL, NULL, 229045),
(229046, '1.10.1670.10-FF-000001', NULL, 'Endonuclease III', 82, NULL, NULL, 229046),
(229047, '3.30.420.40-FF-000284', NULL, 'Probable bifunctional tRNA threonylcarbamoyladenosine biosynthesis protein', 156, NULL, NULL, 229047),
(229048, '3.30.2160.10-FF-000041', NULL, 'Ubiquitin-ubiquitin ligase', 81, NULL, NULL, 229048),
(229049, '4.10.1110.10-FF-000002', NULL, 'Immunoglobulin mu DNA-binding protein 2', 64, NULL, NULL, 229049),
(229050, '3.40.50.300-FF-006924', NULL, 'Uncharacterized protein', 232, NULL, NULL, 229050),
(229051, '1.20.58.60-FF-000132', NULL, 'microtubule-actin cross-linking factor 1 isoform X9', 190, NULL, NULL, 229051),
(229052, '2.10.25.10-FF-000776', NULL, 'Delta-like protein', 39, NULL, NULL, 229052),
(229053, '2.120.10.100-FF-000006', NULL, 'Calcium-activated nucleotidase 1a', 166, NULL, NULL, 229053),
(229054, '4.10.400.10-FF-000297', NULL, 'Uncharacterized protein', 33, NULL, NULL, 229054),
(229055, '1.10.418.10-FF-000208', NULL, 'Uncharacterized protein', 128, NULL, NULL, 229055),
(229056, '3.40.190.10-FF-000260', NULL, 'Porphobilinogen deaminase', 105, NULL, NULL, 229056),
(229057, '3.30.230.80-FF-000017', NULL, 'GHKL domain protein', 152, NULL, NULL, 229057),
(229058, '2.120.10.30-FF-000203', NULL, 'Uncharacterized protein', 133, NULL, NULL, 229058),
(229059, '3.40.630.10-FF-000176', NULL, 'Transferrin receptor, putative', 208, NULL, NULL, 229059),
(229060, '3.30.160.60-FF-000702', NULL, 'Transcription factor E4F1 isoform 1', 27, NULL, NULL, 229060),
(229061, '1.20.5.1200-FF-000010', NULL, 'Tocopherol (alpha) transfer protein', 15, NULL, NULL, 229061),
(229062, '3.90.550.10-FF-000119', NULL, 'Dolichol-phosphate mannosyltransferase subunit 1', 230, NULL, NULL, 229062),
(229063, '1.10.8.270-FF-000117', NULL, 'GTPase-activating protein GYP7', 106, NULL, NULL, 229063),
(229064, '3.30.200.20-FF-002330', NULL, 'Uncharacterized protein', 74, NULL, NULL, 229064),
(229065, '3.20.20.220-FF-000082', NULL, 'Proline dehydrogenase', 99, NULL, NULL, 229065),
(229066, '3.90.226.10-FF-000181', NULL, '3-hydroxybutyryl-CoA dehydratase', 201, NULL, NULL, 229066),
(229067, '2.60.40.2030-FF-000042', NULL, 'Adhesion G protein-coupled receptor V1', 116, NULL, NULL, 229067),
(229068, '2.130.10.10-FF-004165', NULL, 'Uncharacterized protein', 169, NULL, NULL, 229068),
(229069, '3.40.50.300-FF-004564', NULL, 'mitofusin-2', 227, NULL, NULL, 229069),
(229070, '3.30.420.40-FF-000520', NULL, 'Actin, actin related protein', 95, NULL, NULL, 229070);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(229071, '1.10.950.10-FF-000001', NULL, 'actin-binding LIM protein 1 isoform X2', 78, NULL, NULL, 229071),
(229072, '2.60.40.60-FF-000464', NULL, 'Protocadherin extracellular domain', 43, NULL, NULL, 229072),
(229073, '3.60.21.10-FF-000386', NULL, 'Predicted protein', 73, NULL, NULL, 229073),
(229074, '1.10.540.10-FF-000077', NULL, 'Putative acyl-CoA dehydrogenase', 118, NULL, NULL, 229074),
(229075, '3.30.559.70-FF-000030', NULL, 'Carnitine palmitoyltransferase 1B (Muscle)', 195, NULL, NULL, 229075),
(229076, '2.40.30.90-FF-000001', NULL, 'Adenosyl-chloride synthase', 120, NULL, NULL, 229076),
(229077, '1.10.510.10-FF-000474', NULL, 'Wall-associated receptor kinase 3', 208, NULL, NULL, 229077),
(229078, '2.10.25.10-FF-001271', NULL, 'Uncharacterized protein', 41, NULL, NULL, 229078),
(229079, '3.40.50.720-FF-000986', NULL, 'Uncharacterized protein', 305, NULL, NULL, 229079),
(229080, '3.40.50.1820-FF-001539', NULL, 'Uncharacterized protein', 135, NULL, NULL, 229080),
(229081, '1.10.10.2840-FF-000004', NULL, 'Putative regulatory protein', 129, NULL, NULL, 229081),
(229082, '3.90.550.10-FF-000338', NULL, 'Molybdenum cofactor guanylyltransferase', 194, NULL, NULL, 229082),
(229083, '3.10.450.50-FF-000102', NULL, 'Uncharacterized protein', 133, NULL, NULL, 229083),
(229084, '1.10.510.10-FF-000362', NULL, 'Ser/arg-rich protein kinase 4', 67, NULL, NULL, 229084),
(229085, '2.10.70.10-FF-000285', NULL, 'Uncharacterized protein', 59, NULL, NULL, 229085),
(229086, '1.20.1070.10-FF-001830', NULL, 'Uncharacterized protein', 306, NULL, NULL, 229086),
(229087, '2.40.50.140-FF-001277', NULL, NULL, 150, NULL, NULL, 229087),
(229088, '1.25.40.20-FF-000917', NULL, 'SoWAH (Drosophila) homolog', 140, NULL, NULL, 229088),
(229089, '2.60.40.10-FF-000146', NULL, 'Integrin beta', 98, NULL, NULL, 229089),
(229090, '3.30.70.330-FF-001954', NULL, NULL, 138, NULL, NULL, 229090),
(229091, '2.60.40.10-FF-002164', NULL, 'Basigin, isoform J', 105, NULL, NULL, 229091),
(229092, '1.20.1370.60-FF-000002', NULL, 'Uncharacterized protein', 117, NULL, NULL, 229092),
(229093, '3.40.50.300-FF-001130', NULL, 'RecBCD enzyme subunit RecD', 123, NULL, NULL, 229093),
(229094, '3.50.50.60-FF-000316', NULL, 'Sarcosine dehydrogenase', 216, NULL, NULL, 229094),
(229095, '3.10.100.10-FF-000238', NULL, NULL, 127, NULL, NULL, 229095),
(229096, '3.30.160.60-FF-000359', NULL, 'GLIS family zinc finger 2', 28, NULL, NULL, 229096),
(229097, '1.25.40.730-FF-000002', NULL, 'Clathrin heavy chain', 97, NULL, NULL, 229097),
(229098, '3.30.70.2630-FF-000009', NULL, 'Putative COX1/OXI3 intron 2 protein', 18, NULL, NULL, 229098),
(229099, '3.40.50.1820-FF-001871', NULL, 'Dipeptidyl Peptidase Four (IV) family', 219, NULL, NULL, 229099),
(229100, '3.30.70.2610-FF-000003', NULL, 'RNA polymerase II transcription factor B subunit 2', 75, NULL, NULL, 229100),
(229101, '2.40.50.100-FF-000096', NULL, 'Exosome complex exonuclease RRP4, putative', 55, NULL, NULL, 229101),
(229102, '2.30.30.30-FF-000107', NULL, 'Elongation factor P (EF-P) KOW-like domain containing protein, putative', 61, NULL, NULL, 229102),
(229103, '3.90.550.10-FF-000670', NULL, 'Uncharacterized protein', 107, NULL, NULL, 229103),
(229104, '2.10.270.10-FF-000007', NULL, 'Toxin B', 125, NULL, NULL, 229104),
(229105, '3.30.160.60-FF-000691', NULL, 'Zinc finger protein basonuclin-1', 79, NULL, NULL, 229105),
(229106, '3.80.10.10-FF-001602', NULL, 'Predicted protein', 89, NULL, NULL, 229106),
(229107, '3.40.50.10810-FF-000133', NULL, 'SNF2 histone linker PHD RING helicase', 69, NULL, NULL, 229107),
(229108, '3.30.200.20-FF-001493', NULL, 'Sporulation protein kinase mde3', 101, NULL, NULL, 229108),
(229109, '3.30.70.330-FF-000212', NULL, 'Meiosis regulator and mRNA stability factor 1', 73, NULL, NULL, 229109),
(229110, '3.30.450.30-FF-000013', NULL, 'Roadblock/LC7 domain protein', 118, NULL, NULL, 229110),
(229111, '3.30.505.10-FF-000096', NULL, 'SH2 domain-containing protein 4B-like', 101, NULL, NULL, 229111),
(229112, '2.40.50.100-FF-000107', NULL, 'DNA-directed RNA polymerase subunit beta''', 91, NULL, NULL, 229112);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(229113, '1.10.1070.11-FF-000142', NULL, 'Uncharacterized protein', 67, NULL, NULL, 229113),
(229114, '3.30.450.40-FF-000016', NULL, 'Heat-inducible transcription repressor HrcA', 128, NULL, NULL, 229114),
(229115, '4.10.400.10-FF-000078', NULL, 'low-density lipoprotein receptor-related protein 2', 42, NULL, NULL, 229115),
(229116, '3.30.310.210-FF-000006', NULL, 'RNA-binding KH domain-containing protein', 164, NULL, NULL, 229116),
(229117, '2.40.50.90-FF-000002', NULL, 'Staphylococcal nuclease domain-containing protein', 154, NULL, NULL, 229117),
(229118, '1.25.40.10-FF-004063', NULL, 'Uncharacterized protein', 341, NULL, NULL, 229118),
(229119, '3.30.200.20-FF-000076', NULL, 'CMGC/SRPK protein kinase', 91, NULL, NULL, 229119),
(229120, '1.10.287.490-FF-000002', NULL, 'Peptide synthetase ORF5', 43, NULL, NULL, 229120),
(229121, '3.90.920.10-FF-000030', NULL, 'DNA primase', 75, NULL, NULL, 229121),
(229122, '3.80.10.10-FF-001591', NULL, 'Os01g0170300 protein', 170, NULL, NULL, 229122),
(229123, '1.20.1310.10-FF-000017', NULL, 'Cullin 5', 145, NULL, NULL, 229123),
(229124, '3.30.450.20-FF-000010', NULL, 'Aryl hydrocarbon receptor nuclear translocator-like, isoform CRA_b', 135, NULL, NULL, 229124),
(229125, '1.50.40.10-FF-000396', NULL, 'alpha-1,2-Mannosidase', 84, NULL, NULL, 229125),
(229126, '3.40.30.10-FF-000756', NULL, 'Monothiol glutaredoxin-S6', 101, NULL, NULL, 229126),
(229127, '3.40.50.1820-FF-001540', NULL, 'Protein CBG11775', 134, NULL, NULL, 229127),
(229128, '3.90.70.10-FF-000442', NULL, 'Cysteine peptidase, Clan CA, family C2, putative', 151, NULL, NULL, 229128),
(229129, '3.40.50.720-FF-001604', NULL, 'Prephenate dehydrogenase', 155, NULL, NULL, 229129),
(229130, '1.10.238.10-FF-000442', NULL, 'Paralysed Arrest at Two-fold', 89, NULL, NULL, 229130),
(229131, '3.20.20.60-FF-000069', NULL, 'Pyruvate kinase', 66, NULL, NULL, 229131),
(229132, '1.10.560.10-FF-000078', NULL, '60 kDa chaperonin', 243, NULL, NULL, 229132),
(229133, '3.30.1680.10-FF-000057', NULL, 'Uncharacterized protein', 53, NULL, NULL, 229133),
(229134, '1.25.10.10-FF-000076', NULL, 'Elongation factor 3', 322, NULL, NULL, 229134),
(229135, '3.90.780.10-FF-000041', NULL, 'Slr0306 protein', 108, NULL, NULL, 229135),
(229136, '4.10.280.10-FF-000197', NULL, 'Predicted protein', 67, NULL, NULL, 229136),
(229137, '1.10.220.10-FF-000042', NULL, 'Annexin', 53, NULL, NULL, 229137),
(229138, '1.10.1070.11-FF-000029', NULL, 'Serine/threonine-protein kinase TOR', 178, NULL, NULL, 229138),
(229139, '3.40.50.300-FF-008274', NULL, 'Uncharacterized protein', 39, NULL, NULL, 229139),
(229140, '3.30.160.60-FF-006323', NULL, NULL, 84, NULL, NULL, 229140),
(229141, '2.120.10.80-FF-000066', NULL, 'Kelch domain-containing protein 8B', 232, NULL, NULL, 229141),
(229142, '2.30.22.10-FF-000004', NULL, 'Protein GrpE', 57, NULL, NULL, 229142),
(229143, '3.40.50.300-FF-005868', NULL, 'Uncharacterized protein', 247, NULL, NULL, 229143),
(229144, '2.20.70.10-FF-000200', NULL, 'Pre-mRNA-splicing factor URN1', 47, NULL, NULL, 229144),
(229145, '2.40.160.10-FF-000071', NULL, 'Outer membrane channel, putative', 378, NULL, NULL, 229145),
(229146, '3.10.20.90-FF-000371', NULL, 'Locomotion defects, isoform B', 73, NULL, NULL, 229146),
(229147, '3.40.50.1440-FF-000116', NULL, 'Tubulin gamma chain', 266, NULL, NULL, 229147),
(229148, '1.10.10.10-FF-000564', NULL, 'ATP-dependent DNA helicase RecQ', 177, NULL, NULL, 229148),
(229149, '2.60.120.260-FF-000511', NULL, 'Uncharacterized protein', 158, NULL, NULL, 229149),
(229150, '2.40.50.140-FF-000080', NULL, 'Aspartate--tRNA ligase', 106, NULL, NULL, 229150),
(229151, '1.10.1420.10-FF-000067', NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', 190, NULL, NULL, 229151),
(229152, '1.10.510.10-FF-004414', NULL, NULL, 77, NULL, NULL, 229152),
(229153, '1.20.1070.10-FF-001611', NULL, 'Uncharacterized protein', 149, NULL, NULL, 229153),
(229154, '2.30.29.30-FF-000025', NULL, 'Phosphoinositide phospholipase C', 123, NULL, NULL, 229154),
(229155, '3.40.50.300-FF-006144', NULL, 'Os11g0312340 protein', 97, NULL, NULL, 229155);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(229156, '3.90.550.10-FF-000557', NULL, 'Predicted protein', 196, NULL, NULL, 229156),
(229157, '1.10.238.10-FF-000099', NULL, 'calpain-2 catalytic subunit', 171, NULL, NULL, 229157),
(229158, '2.60.40.10-FF-000365', NULL, 'If kappa light chain', 113, NULL, NULL, 229158),
(229159, '2.30.110.10-FF-000076', NULL, 'Flavin reductase', 174, NULL, NULL, 229159),
(229160, '2.70.130.10-FF-000096', NULL, NULL, 153, NULL, NULL, 229160),
(229161, '3.30.450.40-FF-000235', NULL, 'Diguanylate cyclase with GAF sensory domain', 180, NULL, NULL, 229161),
(229162, '2.40.50.140-FF-000422', NULL, 'Replication protein A subunit', 190, NULL, NULL, 229162),
(229163, '3.80.10.10-FF-001259', NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', 104, NULL, NULL, 229163),
(229164, '3.40.50.300-FF-007998', NULL, 'Uncharacterized protein', 152, NULL, NULL, 229164),
(229165, '3.50.50.60-FF-001497', NULL, 'Uncharacterized protein', 37, NULL, NULL, 229165),
(229166, '1.20.5.4820-FF-000017', NULL, 'MYO19 isoform 4', 98, NULL, NULL, 229166),
(229167, '3.80.10.10-FF-003171', NULL, 'Uncharacterized protein', 269, NULL, NULL, 229167),
(229168, '2.60.200.10-FF-000031', NULL, 'Interferon regulatory factor like protein', 222, NULL, NULL, 229168),
(229169, '2.130.10.10-FF-002815', NULL, 'Periodic tryptophan protein 1, putative', 153, NULL, NULL, 229169),
(229170, '3.40.50.2300-FF-001364', NULL, NULL, 221, NULL, NULL, 229170),
(229171, '1.20.1000.10-FF-000027', NULL, NULL, 178, NULL, NULL, 229171),
(229172, '3.90.190.10-FF-000586', NULL, 'Putative tyrosine phosphatase', 97, NULL, NULL, 229172),
(229173, '1.25.40.10-FF-001988', NULL, 'Os07g0203900 protein', 102, NULL, NULL, 229173),
(229174, '1.20.1510.10-FF-000004', NULL, 'zinc transporter 9 isoform X1', 213, NULL, NULL, 229174),
(229175, '2.60.40.10-FF-004636', NULL, NULL, 98, NULL, NULL, 229175),
(229176, '3.20.20.140-FF-000389', NULL, 'Uncharacterized protein', 169, NULL, NULL, 229176),
(229177, '3.10.100.10-FF-000351', NULL, NULL, 98, NULL, NULL, 229177),
(229178, '1.20.5.30-FF-000006', NULL, 'Matrilin 2', 31, NULL, NULL, 229178),
(229179, '2.40.10.10-FF-000583', NULL, NULL, 42, NULL, NULL, 229179),
(229180, '2.60.40.150-FF-000615', NULL, 'Uncharacterized protein', 150, NULL, NULL, 229180),
(229181, '3.40.50.150-FF-000444', NULL, 'Phthiotriol/phenolphthiotriol dimycocerosates methyltransferase', 223, NULL, NULL, 229181),
(229182, '3.40.50.10810-FF-000239', NULL, 'Uncharacterized protein', 197, NULL, NULL, 229182),
(229183, '3.30.200.20-FF-001599', NULL, 'Uncharacterized protein', 105, NULL, NULL, 229183),
(229184, '3.10.20.90-FF-000713', NULL, 'Afadin', 66, NULL, NULL, 229184),
(229185, '3.30.70.330-FF-002230', NULL, NULL, 49, NULL, NULL, 229185),
(229186, '3.30.565.10-FF-000436', NULL, 'Histidine kinase', 157, NULL, NULL, 229186),
(229187, '2.60.200.20-FF-000034', NULL, 'kinesin-like protein KIF28P', 110, NULL, NULL, 229187),
(229188, '1.10.510.10-FF-002615', NULL, NULL, 128, NULL, NULL, 229188),
(229189, '3.40.1370.10-FF-000026', NULL, '50S ribosomal protein L4', 274, NULL, NULL, 229189),
(229190, '3.40.800.20-FF-000007', NULL, 'Histone deacetylase', 378, NULL, NULL, 229190),
(229191, '2.130.10.10-FF-000674', NULL, 'WD-repeat protein, putative', 166, NULL, NULL, 229191),
(229192, '3.60.21.10-FF-000055', NULL, 'Sphingomyelin phosphodiesterase', 87, NULL, NULL, 229192),
(229193, '1.20.5.20-FF-000003', NULL, 'Apolipoprotein AIV', 44, NULL, NULL, 229193),
(229194, '1.20.120.1900-FF-000048', NULL, 'Spindle pole body component', 315, NULL, NULL, 229194),
(229195, '1.25.40.10-FF-002264', NULL, 'YALI0F26631p', 269, NULL, NULL, 229195),
(229196, '2.20.80.10-FF-000026', NULL, 'Uncharacterized protein (Fragment)', 129, NULL, NULL, 229196),
(229197, '3.30.40.10-FF-000105', NULL, 'WD repeat and FYVE domain-containing protein 2', 76, NULL, NULL, 229197),
(229198, '2.70.98.10-FF-000115', NULL, 'Uncharacterized protein', 242, NULL, NULL, 229198),
(229199, '1.20.1640.10-FF-000008', NULL, 'NPC intracellular cholesterol transporter 1', 218, NULL, NULL, 229199),
(229200, '2.60.40.10-FF-002506', NULL, 'Unc-40 protein', 97, NULL, NULL, 229200);
INSERT INTO "PUBLIC"."MODEL" VALUES
(229201, '3.40.50.1000-FF-000445', NULL, 'HAD-superfamily hydrolase, subfamily IIA containing protein', 140, NULL, NULL, 229201),
(229202, '1.50.40.10-FF-000519', NULL, 'Uncharacterized protein', 182, NULL, NULL, 229202),
(229203, '3.80.10.10-FF-003058', NULL, 'Uncharacterized protein', 146, NULL, NULL, 229203),
(229204, '3.30.43.10-FF-000022', NULL, 'Possible oxidoreductase', 80, NULL, NULL, 229204),
(229205, '2.10.25.10-FF-000995', NULL, 'Integrin beta', 34, NULL, NULL, 229205),
(229206, '3.20.20.80-FF-000749', NULL, 'Predicted protein', 69, NULL, NULL, 229206),
(229207, '3.90.1410.10-FF-000108', NULL, 'Ribosomal lysine N-methyltransferase set11', 236, NULL, NULL, 229207),
(229208, '1.50.40.10-FF-000177', NULL, 'Kidney mitochondrial carrier protein 1', 297, NULL, NULL, 229208),
(229209, '3.30.300.130-FF-000025', NULL, NULL, 63, NULL, NULL, 229209),
(229210, '2.70.150.10-FF-000108', NULL, 'Cation transporting ATPase', 142, NULL, NULL, 229210),
(229211, '2.40.330.10-FF-000011', NULL, 'Putative B3 domain-containing protein At5g66980', 121, NULL, NULL, 229211),
(229212, '1.25.40.990-FF-000046', NULL, 'Uncharacterized protein', 217, NULL, NULL, 229212),
(229213, '3.80.10.10-FF-003513', NULL, 'Chromosome 1, whole genome shotgun sequence', 178, NULL, NULL, 229213),
(229214, '3.40.350.10-FF-000025', NULL, 'YER078C-like protein', 179, NULL, NULL, 229214),
(229215, '2.120.10.30-FF-000309', NULL, 'Regucalcin', 311, NULL, NULL, 229215),
(229216, '1.25.40.10-FF-000134', NULL, 'Beta-barrel assembly-enhancing protease', 71, NULL, NULL, 229216),
(229217, '2.60.40.150-FF-000273', NULL, 'Predicted protein', 146, NULL, NULL, 229217),
(229218, '3.30.160.60-FF-002719', NULL, 'Zinc finger protein 224', 29, NULL, NULL, 229218),
(229219, '2.40.30.10-FF-000034', NULL, 'Flavohemoprotein', 110, NULL, NULL, 229219),
(229220, '1.25.10.10-FF-002094', NULL, 'Uncharacterized protein', 232, NULL, NULL, 229220),
(229221, '1.25.40.10-FF-003568', NULL, 'WD40 domain-containing protein', 208, NULL, NULL, 229221),
(229222, '3.30.565.10-FF-000094', NULL, 'Ethylene receptor', 177, NULL, NULL, 229222),
(229223, '3.30.505.10-FF-000219', NULL, NULL, 104, NULL, NULL, 229223),
(229224, '3.90.550.50-FF-000103', NULL, 'Glycoprotein-N-acetylgalactosamine 3-beta-galactosyltransferase 1', 221, NULL, NULL, 229224),
(229225, '1.10.3730.20-FF-000072', NULL, 'Uncharacterized protein', 69, NULL, NULL, 229225),
(229226, '3.30.70.330-FF-000431', NULL, 'Heterogeneous nuclear ribonucleoprotein C', 102, NULL, NULL, 229226),
(229227, '3.20.20.70-FF-000746', NULL, NULL, 68, NULL, NULL, 229227),
(229228, '3.60.15.10-FF-000220', NULL, 'Uncharacterized protein', 137, NULL, NULL, 229228),
(229229, '1.10.3380.30-FF-000024', NULL, 'ATP-dependent DEAD/H RNA helicase, putative', 229, NULL, NULL, 229229),
(229230, '1.25.40.10-FF-002606', NULL, 'Zinc finger, C3H1-type-containing', 111, NULL, NULL, 229230),
(229231, '1.25.10.10-FF-002436', NULL, 'Uncharacterized protein', 239, NULL, NULL, 229231),
(229232, '1.10.472.10-FF-000143', NULL, 'Yin', 113, NULL, NULL, 229232),
(229233, '3.30.1540.20-FF-000011', NULL, 'Mlh3p', 84, NULL, NULL, 229233),
(229234, '1.25.10.10-FF-000295', NULL, 'Exportin-T', 949, NULL, NULL, 229234),
(229235, '3.30.1050.10-FF-000032', NULL, 'Uncharacterized protein', 114, NULL, NULL, 229235),
(229236, '1.10.1410.40-FF-000002', NULL, 'protein mab-21-like 1', 135, NULL, NULL, 229236),
(229237, '2.40.50.690-FF-000014', NULL, 'Probable exosome complex exonuclease RRP44', 131, NULL, NULL, 229237),
(229238, '1.10.1320.10-FF-000014', NULL, 'DNA-directed RNA polymerase', 151, NULL, NULL, 229238),
(229239, '3.40.50.720-FF-001823', NULL, 'Homospermidine synthase', 164, NULL, NULL, 229239),
(229240, '3.30.420.40-FF-000626', NULL, 'Actin 12', 24, NULL, NULL, 229240),
(229241, '1.10.8.60-FF-000477', NULL, 'Uncharacterized protein', 61, NULL, NULL, 229241),
(229242, '1.10.1450.10-FF-000018', NULL, 'Tetraspanin', 95, NULL, NULL, 229242),
(229243, '2.60.40.10-FF-000707', NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', 88, NULL, NULL, 229243); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(229244, '3.40.50.300-FF-007200', NULL, 'Predicted protein', 168, NULL, NULL, 229244),
(229245, '2.60.40.1180-FF-000214', NULL, 'Maltase-glucoamylase', 45, NULL, NULL, 229245),
(229246, '1.20.1110.10-FF-000255', NULL, NULL, 132, NULL, NULL, 229246),
(229247, '2.60.40.1180-FF-000091', NULL, 'Chromosome 1, whole genome shotgun sequence', 102, NULL, NULL, 229247),
(229248, '3.40.50.10260-FF-000035', NULL, 'NAD(P)H-hydrate epimerase', 226, NULL, NULL, 229248),
(229249, '2.60.40.150-FF-000054', NULL, 'otoferlin isoform X2', 112, NULL, NULL, 229249),
(229250, '3.40.50.1000-FF-000226', NULL, 'Cation transporting ATPase, putative', 132, NULL, NULL, 229250),
(229251, '3.40.630.10-FF-000300', NULL, 'Uncharacterized protein', 325, NULL, NULL, 229251),
(229252, '2.10.110.10-FF-000052', NULL, 'Four and a half LIM domains 1', 63, NULL, NULL, 229252),
(229253, '2.60.40.10-FF-004075', NULL, NULL, 95, NULL, NULL, 229253),
(229254, '3.40.50.920-FF-000023', NULL, '1-deoxy-D-xylulose-5-phosphate synthase', 128, NULL, NULL, 229254),
(229255, '3.30.470.30-FF-000008', NULL, 'DNA ligase', 213, NULL, NULL, 229255),
(229256, '1.10.10.580-FF-000023', NULL, 'double-strand-break repair protein rad21 homolog', 67, NULL, NULL, 229256),
(229257, '3.50.50.100-FF-000062', NULL, 'Uncharacterized protein', 107, NULL, NULL, 229257),
(229258, '3.30.1490.40-FF-000006', NULL, 'Eukaryotic translation initiation factor subunit eIF2A, putative', 75, NULL, NULL, 229258),
(229259, '3.40.140.10-FF-000088', NULL, 'Cytidine deaminase, putative', 148, NULL, NULL, 229259),
(229260, '2.130.10.10-FF-004384', NULL, 'Uncharacterized protein', 74, NULL, NULL, 229260),
(229261, '2.60.40.10-FF-003799', NULL, NULL, 93, NULL, NULL, 229261),
(229262, '3.40.50.720-FF-001481', NULL, 'uncharacterized protein LOC100179743', 157, NULL, NULL, 229262),
(229263, '1.10.510.10-FF-002492', NULL, NULL, 115, NULL, NULL, 229263),
(229264, '3.30.160.60-FF-000578', NULL, 'zinc finger protein 64 isoform X1', 27, NULL, NULL, 229264),
(229265, '1.20.1250.20-FF-001476', NULL, 'Major Facilitator Superfamily protein', 396, NULL, NULL, 229265),
(229266, '1.25.50.20-FF-000076', NULL, 'Aminopeptidase', 224, NULL, NULL, 229266),
(229267, '3.80.10.10-FF-003390', NULL, 'Uncharacterized protein', 101, NULL, NULL, 229267),
(229268, '3.10.20.30-FF-000049', NULL, '2Fe-2S ferredoxin-like superfamily protein', 114, NULL, NULL, 229268),
(229269, '3.40.50.2300-FF-001583', NULL, NULL, 141, NULL, NULL, 229269),
(229270, '3.30.160.60-FF-001995', NULL, NULL, 28, NULL, NULL, 229270),
(229271, '2.40.10.10-FF-000706', NULL, NULL, 38, NULL, NULL, 229271),
(229272, '1.20.5.110-FF-000298', NULL, 'Uncharacterized protein', 78, NULL, NULL, 229272),
(229273, '2.80.10.50-FF-000245', NULL, 'Polypeptide N-acetylgalactosaminyltransferase', 77, NULL, NULL, 229273),
(229274, '2.130.10.10-FF-001759', NULL, 'Atg21p', 217, NULL, NULL, 229274),
(229275, '1.20.1270.280-FF-000028', NULL, 'Dynein heavy chain 6, axonemal', 195, NULL, NULL, 229275),
(229276, '1.10.510.10-FF-002834', NULL, NULL, 84, NULL, NULL, 229276),
(229277, '1.10.472.10-FF-000704', NULL, 'Uncharacterized protein', 190, NULL, NULL, 229277),
(229278, '1.10.287.3700-FF-000011', NULL, 'PAN3-like protein', 51, NULL, NULL, 229278),
(229279, '1.20.5.320-FF-000012', NULL, '6-phosphogluconate dehydrogenase, decarboxylating', 22, NULL, NULL, 229279),
(229280, '2.120.10.30-FF-000080', NULL, 'E3 ubiquitin-protein ligase TRIM71', 55, NULL, NULL, 229280),
(229281, '2.30.30.40-FF-000223', NULL, 'Caspase recruitment domain family, member 14', 113, NULL, NULL, 229281),
(229282, '1.10.10.10-FF-000126', NULL, 'MarR family transcriptional regulator', 161, NULL, NULL, 229282),
(229283, '1.20.1310.10-FF-000130', NULL, NULL, 124, NULL, NULL, 229283),
(229284, '3.40.50.300-FF-000399', NULL, 'YLP motif containing 1', 158, NULL, NULL, 229284),
(229285, '1.10.10.60-FF-000663', NULL, 'GD19964', 47, NULL, NULL, 229285),
(229286, '3.40.1110.10-FF-000485', NULL, NULL, 29, NULL, NULL, 229286),
(229287, '3.40.50.150-FF-000663', NULL, 'Alkylated DNA repair protein alkB 8', 201, NULL, NULL, 229287);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(229288, '3.40.50.12390-FF-000005', NULL, '5''-3'' exoribonuclease 2', 199, NULL, NULL, 229288),
(229289, '1.20.1440.230-FF-000007', NULL, 'NADH:ubiquinone oxidoreductase core subunit V1', 76, NULL, NULL, 229289),
(229290, '3.30.560.10-FF-000009', NULL, 'Alcohol dehydrogenase', 111, NULL, NULL, 229290),
(229291, '3.40.50.1170-FF-000001', NULL, 'L-asparaginase 2', 217, NULL, NULL, 229291),
(229292, '3.30.530.20-FF-000174', NULL, 'Uncharacterized protein', 109, NULL, NULL, 229292),
(229293, '1.25.40.430-FF-000013', NULL, 'BUB1 mitotic checkpoint serine/threonine kinase', 148, NULL, NULL, 229293),
(229294, '3.40.50.300-FF-006705', NULL, 'Uncharacterized protein', 77, NULL, NULL, 229294),
(229295, '3.60.15.10-FF-000107', NULL, 'DNA cross-link repair 1C', 22, NULL, NULL, 229295),
(229296, '2.60.40.10-FF-000926', NULL, 'Interleukin 20 receptor subunit alpha', 111, NULL, NULL, 229296),
(229297, '3.40.640.10-FF-000126', NULL, 'Aminotransferase', 221, NULL, NULL, 229297),
(229298, '1.10.150.240-FF-000063', NULL, 'Putative glycosyl hydrolase', 94, NULL, NULL, 229298),
(229299, '3.30.420.40-FF-000065', NULL, 'N-acetylglucosamine repressor NagC', 122, NULL, NULL, 229299),
(229300, '2.130.10.10-FF-002035', NULL, 'probable U3 small nucleolar RNA-associated protein 7', 119, NULL, NULL, 229300),
(229301, '2.30.33.40-FF-000027', NULL, 'Os06g0197550 protein', 51, NULL, NULL, 229301),
(229302, '3.40.800.10-FF-000004', NULL, 'Agmatinase', 275, NULL, NULL, 229302),
(229303, '3.40.1550.10-FF-000012', NULL, NULL, 151, NULL, NULL, 229303),
(229304, '3.30.450.20-FF-000696', NULL, 'Energy taxis modulating methyl accepting sensory transducer with Cache_2 sensory domain', 149, NULL, NULL, 229304),
(229305, '2.60.40.10-FF-000584', NULL, 'Cell surface glycoprotein CD200 receptor 1', 85, NULL, NULL, 229305),
(229306, '1.10.10.10-FF-000345', NULL, 'Replication protein O', 100, NULL, NULL, 229306),
(229307, '1.25.40.450-FF-000019', NULL, 'Uncharacterized protein', 149, NULL, NULL, 229307),
(229308, '1.10.287.1970-FF-000003', NULL, 'Uncharacterized protein', 38, NULL, NULL, 229308),
(229309, '2.60.40.10-FF-001202', NULL, 'PKHD1 like 1', 102, NULL, NULL, 229309),
(229310, '1.10.472.10-FF-000362', NULL, 'Uncharacterized protein', 104, NULL, NULL, 229310),
(229311, '3.30.70.1230-FF-000247', NULL, 'Predicted protein', 216, NULL, NULL, 229311),
(229312, '2.60.120.10-FF-000772', NULL, 'Uncharacterized protein', 46, NULL, NULL, 229312),
(229313, '2.30.42.10-FF-000112', NULL, 'inaD-like protein isoform X3', 99, NULL, NULL, 229313),
(229314, '3.80.10.10-FF-002895', NULL, 'Uncharacterized protein', 56, NULL, NULL, 229314),
(229315, '3.30.160.60-FF-002832', NULL, 'Weckle, isoform B', 30, NULL, NULL, 229315),
(229316, '1.10.630.10-FF-000758', NULL, 'Uncharacterized protein', 485, NULL, NULL, 229316),
(229317, '2.60.40.1730-FF-000076', NULL, NULL, 167, NULL, NULL, 229317),
(229318, '2.40.30.10-FF-000253', NULL, 'NADPH-cytochrome P450 reductase', 54, NULL, NULL, 229318),
(229319, '3.10.100.10-FF-000132', NULL, 'Intimin', 93, NULL, NULL, 229319),
(229320, '1.10.510.10-FF-003110', NULL, NULL, 193, NULL, NULL, 229320),
(229321, '1.10.1420.10-FF-000180', NULL, 'Uncharacterized protein', 90, NULL, NULL, 229321),
(229322, '2.40.10.10-FF-000364', NULL, NULL, 138, NULL, NULL, 229322),
(229323, '3.90.1600.10-FF-000033', NULL, 'DNA polymerase', 98, NULL, NULL, 229323),
(229324, '3.40.50.300-FF-002434', NULL, 'ATP-dependent RNA helicase SUV3, putative', 82, NULL, NULL, 229324),
(229325, '3.40.50.720-FF-001149', NULL, '2-dehydropantoate 2-reductase', 178, NULL, NULL, 229325),
(229326, '1.20.140.40-FF-000042', NULL, 'Invertase/pectin methylesterase inhibitor family protein', 138, NULL, NULL, 229326),
(229327, '3.40.190.290-FF-000083', NULL, 'LysR family transcriptional regulator', 201, NULL, NULL, 229327),
(229328, '1.10.510.10-FF-002273', NULL, 'Eukaryotic protein kinase', 251, NULL, NULL, 229328),
(229329, '1.25.40.20-FF-000811', NULL, 'Uncharacterized protein', 181, NULL, NULL, 229329),
(229330, '1.20.5.340-FF-000018', NULL, 'Mitochondrial protein FMP32', 97, NULL, NULL, 229330);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(229331, '3.30.1360.10-FF-000022', NULL, 'DNA-directed RNA polymerase subunit alpha', 80, NULL, NULL, 229331),
(229332, '3.10.120.10-FF-000021', NULL, 'Delta(8)-fatty-acid desaturase 2', 85, NULL, NULL, 229332),
(229333, '3.30.160.60-FF-002490', NULL, 'Krueppel protein', 35, NULL, NULL, 229333),
(229334, '3.80.10.10-FF-003732', NULL, 'Uncharacterized protein', 135, NULL, NULL, 229334),
(229335, '3.30.420.40-FF-000407', NULL, 'Heat shock protein 70, putative', 87, NULL, NULL, 229335),
(229336, '2.130.10.10-FF-005469', NULL, 'WD repeat domain 90', 165, NULL, NULL, 229336),
(229337, '2.60.40.10-FF-004294', NULL, NULL, 140, NULL, NULL, 229337),
(229338, '2.10.25.10-FF-001158', NULL, 'Crumbs cell polarity complex component 1', 41, NULL, NULL, 229338),
(229339, '1.20.1280.20-FF-000011', NULL, 'DNaJ domain (Prokaryotic heat shock protein)', 83, NULL, NULL, 229339),
(229340, '3.30.200.20-FF-002217', NULL, 'Uncharacterized protein', 41, NULL, NULL, 229340),
(229341, '1.10.510.10-FF-001997', NULL, 'Serine/threonine-protein kinase PEPKR2', 198, NULL, NULL, 229341),
(229342, '3.40.50.300-FF-001017', NULL, 'Phosphonate C-P lyase system protein PhnK', 254, NULL, NULL, 229342),
(229343, '1.20.1550.10-FF-000001', NULL, 'Disulfide bond formation protein B', 176, NULL, NULL, 229343),
(229344, '1.25.10.10-FF-002217', NULL, 'Uncharacterized protein', 413, NULL, NULL, 229344),
(229345, '1.10.418.10-FF-000085', NULL, 'protein-methionine sulfoxide oxidase Mical isoform X3', 111, NULL, NULL, 229345),
(229346, '1.10.287.1270-FF-000001', NULL, 'G protein-coupled receptor kinase', 75, NULL, NULL, 229346),
(229347, '3.40.1160.10-FF-000089', NULL, 'Predicted protein', 136, NULL, NULL, 229347),
(229348, '2.70.170.10-FF-000216', NULL, 'Uncharacterized protein', 130, NULL, NULL, 229348),
(229349, '3tufA00', NULL, NULL, 116, NULL, NULL, 229349),
(229350, '3r15A00', NULL, NULL, 93, NULL, NULL, 229350),
(229351, '2fpnA02', NULL, NULL, 76, NULL, NULL, 229351),
(229352, '3hxlA01', NULL, NULL, 68, NULL, NULL, 229352),
(229353, '2ljwA00', NULL, NULL, 110, NULL, NULL, 229353),
(229354, '4i6mD00', NULL, NULL, 90, NULL, NULL, 229354),
(229355, '4iiwA01', NULL, NULL, 76, NULL, NULL, 229355),
(229356, '3f6gA02', NULL, NULL, 69, NULL, NULL, 229356),
(229357, '2xf5F00', NULL, NULL, 51, NULL, NULL, 229357),
(229358, '2xf5E00', NULL, NULL, 51, NULL, NULL, 229357),
(229359, '2xf5D00', NULL, NULL, 51, NULL, NULL, 229357),
(229360, '2xf5C00', NULL, NULL, 51, NULL, NULL, 229357),
(229361, '2xf5B00', NULL, NULL, 51, NULL, NULL, 229357),
(229362, '2xf7A00', NULL, NULL, 51, NULL, NULL, 229357),
(229363, '2xf5A00', NULL, NULL, 51, NULL, NULL, 229357),
(229364, '4dleA03', NULL, NULL, 125, NULL, NULL, 229358),
(229365, '1x9mA03', NULL, NULL, 178, NULL, NULL, 229358),
(229366, '1mswD03', NULL, NULL, 143, NULL, NULL, 229358),
(229367, '3px4A03', NULL, NULL, 130, NULL, NULL, 229358),
(229368, '2kfnA03', NULL, NULL, 125, NULL, NULL, 229358),
(229369, '4bwjA03', NULL, NULL, 125, NULL, NULL, 229358),
(229370, '1ixmB02', NULL, NULL, 119, NULL, NULL, 229359),
(229371, '2chhA00', NULL, NULL, 114, NULL, NULL, 229360),
(229372, '4ce8A00', NULL, NULL, 114, NULL, NULL, 229360),
(229373, '5a6yA00', NULL, NULL, 114, NULL, NULL, 229360),
(229374, '2xr4A00', NULL, NULL, 116, NULL, NULL, 229360),
(229375, '2wraA00', NULL, NULL, 128, NULL, NULL, 229360),
(229376, '4ut5A00', NULL, NULL, 114, NULL, NULL, 229360),
(229377, '2bv4A00', NULL, NULL, 113, NULL, NULL, 229360),
(229378, '3favA00', NULL, NULL, 85, NULL, NULL, 229361),
(229379, '3gwkE00', NULL, NULL, 98, NULL, NULL, 229361),
(229380, '3favD00', NULL, NULL, 94, NULL, NULL, 229361),
(229381, '3txsC01', NULL, NULL, 78, NULL, NULL, 229361),
(229382, '4gzrD00', NULL, NULL, 99, NULL, NULL, 229361),
(229383, '4gzrC00', NULL, NULL, 69, NULL, NULL, 229361),
(229384, '3q4hD00', NULL, NULL, 81, NULL, NULL, 229361),
(229385, '3q4hB00', NULL, NULL, 86, NULL, NULL, 229361),
(229386, '3q4hC00', NULL, NULL, 98, NULL, NULL, 229361),
(229387, '3fd9A03', NULL, NULL, 73, NULL, NULL, 229361),
(229388, '3h6pC00', NULL, NULL, 56, NULL, NULL, 229361);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(229389, '3zbhA00', NULL, NULL, 99, NULL, NULL, 229361),
(229390, '2de0X01', NULL, NULL, 67, NULL, NULL, 229361),
(229391, '4i0xK00', NULL, NULL, 94, NULL, NULL, 229361),
(229392, '3hr0B01', NULL, NULL, 93, NULL, NULL, 229361),
(229393, '3ogiD00', NULL, NULL, 99, NULL, NULL, 229361),
(229394, '4i0xG00', NULL, NULL, 70, NULL, NULL, 229361),
(229395, '4i0xH00', NULL, NULL, 87, NULL, NULL, 229361),
(229396, '3ogiB00', NULL, NULL, 99, NULL, NULL, 229361),
(229397, '4abmA00', NULL, NULL, 79, NULL, NULL, 229361),
(229398, '2kg7B00', NULL, NULL, 97, NULL, NULL, 229361),
(229399, '2kg7A00', NULL, NULL, 97, NULL, NULL, 229361),
(229400, '2az0B00', NULL, NULL, 73, NULL, NULL, 229361),
(229401, '3g80A00', NULL, NULL, 74, NULL, NULL, 229361),
(229402, '4lwsA00', NULL, NULL, 101, NULL, NULL, 229361),
(229403, '2vs0A00', NULL, NULL, 97, NULL, NULL, 229361),
(229404, '4lwsB00', NULL, NULL, 103, NULL, NULL, 229361),
(229405, '1n5uA03', NULL, NULL, 92, NULL, NULL, 229362),
(229406, '4f5sA01', NULL, NULL, 107, NULL, NULL, 229362),
(229407, '4f5sA02', NULL, NULL, 89, NULL, NULL, 229362),
(229408, '1n5uA02', NULL, NULL, 90, NULL, NULL, 229362),
(229409, '1n5uA01', NULL, NULL, 103, NULL, NULL, 229362),
(229410, '4f5sA05', NULL, NULL, 112, NULL, NULL, 229362),
(229411, '4f5sA06', NULL, NULL, 78, NULL, NULL, 229362),
(229412, '4f5sA03', NULL, NULL, 92, NULL, NULL, 229362),
(229413, '4f5sA04', NULL, NULL, 86, NULL, NULL, 229362),
(229414, '1n5uA05', NULL, NULL, 112, NULL, NULL, 229362),
(229415, '1n5uA04', NULL, NULL, 86, NULL, NULL, 229362),
(229416, '5oswA06', NULL, NULL, 78, NULL, NULL, 229362),
(229417, '5oswA05', NULL, NULL, 112, NULL, NULL, 229362),
(229418, '5oswA04', NULL, NULL, 86, NULL, NULL, 229362),
(229419, '5oswA03', NULL, NULL, 92, NULL, NULL, 229362),
(229420, '5oswA02', NULL, NULL, 89, NULL, NULL, 229362),
(229421, '5oswA01', NULL, NULL, 107, NULL, NULL, 229362),
(229422, '3sqjA06', NULL, NULL, 80, NULL, NULL, 229362),
(229423, '1kxpD04', NULL, NULL, 77, NULL, NULL, 229362),
(229424, '4zbqA01', NULL, NULL, 107, NULL, NULL, 229362),
(229425, '1kxpD05', NULL, NULL, 61, NULL, NULL, 229362),
(229426, '4zbqA02', NULL, NULL, 89, NULL, NULL, 229362),
(229427, '1kxpD02', NULL, NULL, 88, NULL, NULL, 229362),
(229428, '4zbqA03', NULL, NULL, 92, NULL, NULL, 229362),
(229429, '1kxpD03', NULL, NULL, 88, NULL, NULL, 229362),
(229430, '1kxpD01', NULL, NULL, 105, NULL, NULL, 229362),
(229431, '5ghkA04', NULL, NULL, 86, NULL, NULL, 229362),
(229432, '5ghkA05', NULL, NULL, 112, NULL, NULL, 229362),
(229433, '5ghkA06', NULL, NULL, 78, NULL, NULL, 229362),
(229434, '5ghkA01', NULL, NULL, 107, NULL, NULL, 229362),
(229435, '5ghkA02', NULL, NULL, 90, NULL, NULL, 229362),
(229436, '5ghkA03', NULL, NULL, 92, NULL, NULL, 229362),
(229437, '4zbqA04', NULL, NULL, 86, NULL, NULL, 229362),
(229438, '4zbqA05', NULL, NULL, 112, NULL, NULL, 229362),
(229439, '4zbqA06', NULL, NULL, 78, NULL, NULL, 229362),
(229440, '3v09A03', NULL, NULL, 92, NULL, NULL, 229362),
(229441, '3v09A04', NULL, NULL, 86, NULL, NULL, 229362),
(229442, '3v09A05', NULL, NULL, 112, NULL, NULL, 229362),
(229443, '3v09A06', NULL, NULL, 78, NULL, NULL, 229362),
(229444, '4luhA06', NULL, NULL, 78, NULL, NULL, 229362),
(229445, '3v09A01', NULL, NULL, 107, NULL, NULL, 229362),
(229446, '4k71A06', NULL, NULL, 75, NULL, NULL, 229362),
(229447, '3v09A02', NULL, NULL, 90, NULL, NULL, 229362),
(229448, '5yxeA06', NULL, NULL, 78, NULL, NULL, 229362),
(229449, '5yxeA04', NULL, NULL, 86, NULL, NULL, 229362),
(229450, '5yxeA05', NULL, NULL, 112, NULL, NULL, 229362),
(229451, '5yxeA02', NULL, NULL, 90, NULL, NULL, 229362),
(229452, '5yxeA03', NULL, NULL, 92, NULL, NULL, 229362),
(229453, '5yxeA01', NULL, NULL, 107, NULL, NULL, 229362),
(229454, '1fjrA01', NULL, NULL, 63, NULL, NULL, 229363),
(229455, '5d55A00', NULL, NULL, 157, NULL, NULL, 229364),
(229456, '2bcmC00', NULL, NULL, 138, NULL, NULL, 229364),
(229457, '2fvnA00', NULL, NULL, 153, NULL, NULL, 229364),
(229458, '4or1B00', NULL, NULL, 155, NULL, NULL, 229364),
(229459, '1ut1B00', NULL, NULL, 148, NULL, NULL, 229364);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(229460, '4phxA00', NULL, NULL, 142, NULL, NULL, 229364),
(229461, '2cnzA00', NULL, NULL, 125, NULL, NULL, 229364),
(229462, '1rxlA00', NULL, NULL, 156, NULL, NULL, 229364),
(229463, '3uizB00', NULL, NULL, 152, NULL, NULL, 229364),
(229464, '2axwA01', NULL, NULL, 118, NULL, NULL, 229364),
(229465, '2iu4A01', NULL, NULL, 171, NULL, NULL, 229365),
(229466, '1oi2A01', NULL, NULL, 173, NULL, NULL, 229365),
(229467, '5uxyA01', NULL, NULL, 111, NULL, NULL, 229365),
(229468, '3fdjA01', NULL, NULL, 111, NULL, NULL, 229365),
(229469, '1pzxB01', NULL, NULL, 122, NULL, NULL, 229365),
(229470, '3jr7A01', NULL, NULL, 118, NULL, NULL, 229365),
(229471, '3ct4A01', NULL, NULL, 172, NULL, NULL, 229365),
(229472, '3pl5A01', NULL, NULL, 119, NULL, NULL, 229365),
(229473, '2gk6A02', NULL, NULL, 90, NULL, NULL, 229366),
(229474, '2xzlA02', NULL, NULL, 93, NULL, NULL, 229366),
(229475, '1lpbA00', NULL, NULL, 95, NULL, NULL, 229367),
(229476, '2n8kA00', NULL, NULL, 76, NULL, NULL, 229367),
(229477, '1imtA00', NULL, NULL, 80, NULL, NULL, 229367),
(229478, '3s2kC00', NULL, NULL, 97, NULL, NULL, 229367),
(229479, '2kraA00', NULL, NULL, 77, NULL, NULL, 229367),
(229480, '2jtkA00', NULL, NULL, 90, NULL, NULL, 229367),
(229481, '1u02A02', NULL, NULL, 76, NULL, NULL, 229368),
(229482, '4rmpA00', NULL, NULL, 161, NULL, NULL, 229369),
(229483, '1b33B00', NULL, NULL, 161, NULL, NULL, 229369),
(229484, '1cpcB00', NULL, NULL, 172, NULL, NULL, 229369),
(229485, '2bv8A00', NULL, NULL, 162, NULL, NULL, 229369),
(229486, '4f0uA00', NULL, NULL, 160, NULL, NULL, 229369),
(229487, '1gh0A00', NULL, NULL, 162, NULL, NULL, 229369),
(229488, '1kn1B00', NULL, NULL, 161, NULL, NULL, 229369),
(229489, '1allA00', NULL, NULL, 160, NULL, NULL, 229369),
(229490, '3dbjB00', NULL, NULL, 161, NULL, NULL, 229369),
(229491, '4yjjB00', NULL, NULL, 172, NULL, NULL, 229369),
(229492, '2vjhB00', NULL, NULL, 177, NULL, NULL, 229369),
(229493, '2c7lB00', NULL, NULL, 172, NULL, NULL, 229369),
(229494, '4f0tB00', NULL, NULL, 172, NULL, NULL, 229369),
(229495, '4h0mB00', NULL, NULL, 173, NULL, NULL, 229369),
(229496, '3v57B00', NULL, NULL, 177, NULL, NULL, 229369),
(229497, '3kvsA00', NULL, NULL, 162, NULL, NULL, 229369),
(229498, '2uunB00', NULL, NULL, 172, NULL, NULL, 229369),
(229499, '1eyxB00', NULL, NULL, 177, NULL, NULL, 229369),
(229500, '5tjfB00', NULL, NULL, 161, NULL, NULL, 229369),
(229501, '2vjhA00', NULL, NULL, 164, NULL, NULL, 229369),
(229502, '5nb4A00', NULL, NULL, 164, NULL, NULL, 229369),
(229503, '1xg0C00', NULL, NULL, 177, NULL, NULL, 229369),
(229504, '4lm6D00', NULL, NULL, 177, NULL, NULL, 229369),
(229505, '1b8dA00', NULL, NULL, 164, NULL, NULL, 229369),
(229506, '2vjtA00', NULL, NULL, 161, NULL, NULL, 229369),
(229507, '3l0fB00', NULL, NULL, 172, NULL, NULL, 229369),
(229508, '1f99B00', NULL, NULL, 172, NULL, NULL, 229369),
(229509, '5touA00', NULL, NULL, 162, NULL, NULL, 229369),
(229510, '4po5B00', NULL, NULL, 161, NULL, NULL, 229369),
(229511, '2vmlB00', NULL, NULL, 172, NULL, NULL, 229369),
(229512, '1liaA00', NULL, NULL, 164, NULL, NULL, 229369),
(229513, '1gh0B00', NULL, NULL, 172, NULL, NULL, 229369),
(229514, '4rmpB00', NULL, NULL, 161, NULL, NULL, 229369),
(229515, '1b33A00', NULL, NULL, 160, NULL, NULL, 229369),
(229516, '1cpcA00', NULL, NULL, 162, NULL, NULL, 229369),
(229517, '4lmxD00', NULL, NULL, 177, NULL, NULL, 229369),
(229518, '4po5A00', NULL, NULL, 167, NULL, NULL, 229369),
(229519, '4f0uB00', NULL, NULL, 161, NULL, NULL, 229369),
(229520, '1kn1A00', NULL, NULL, 160, NULL, NULL, 229369),
(229521, '1allB00', NULL, NULL, 161, NULL, NULL, 229369),
(229522, '3dbjA00', NULL, NULL, 161, NULL, NULL, 229369),
(229523, '5b13G00', NULL, NULL, 177, NULL, NULL, 229369),
(229524, '4yjjA00', NULL, NULL, 162, NULL, NULL, 229369),
(229525, '2j96A00', NULL, NULL, 162, NULL, NULL, 229369),
(229526, '2bv8B00', NULL, NULL, 172, NULL, NULL, 229369),
(229527, '5b13A00', NULL, NULL, 164, NULL, NULL, 229369),
(229528, '5nb4M00', NULL, NULL, 184, NULL, NULL, 229369),
(229529, '3v57A00', NULL, NULL, 164, NULL, NULL, 229369),
(229530, '4lmsD00', NULL, NULL, 177, NULL, NULL, 229369);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(229531, '4h0mA00', NULL, NULL, 163, NULL, NULL, 229369),
(229532, '1eyxA00', NULL, NULL, 164, NULL, NULL, 229369),
(229533, '3kvsB00', NULL, NULL, 172, NULL, NULL, 229369),
(229534, '2uunA00', NULL, NULL, 162, NULL, NULL, 229369),
(229535, '5tjfA00', NULL, NULL, 160, NULL, NULL, 229369),
(229536, '4f0tA00', NULL, NULL, 162, NULL, NULL, 229369),
(229537, '2vjtB00', NULL, NULL, 161, NULL, NULL, 229369),
(229538, '1b8dB00', NULL, NULL, 177, NULL, NULL, 229369),
(229539, '3l0fA00', NULL, NULL, 162, NULL, NULL, 229369),
(229540, '1f99A00', NULL, NULL, 162, NULL, NULL, 229369),
(229541, '5touB00', NULL, NULL, 172, NULL, NULL, 229369),
(229542, '4xxiA00', NULL, NULL, 157, NULL, NULL, 229369),
(229543, '2vmlA00', NULL, NULL, 162, NULL, NULL, 229369),
(229544, '1liaB00', NULL, NULL, 177, NULL, NULL, 229369),
(229545, '4aq1A05', NULL, NULL, 110, NULL, NULL, 229370),
(229546, '3pufL00', NULL, NULL, 135, NULL, NULL, 229371),
(229547, '3kioC01', NULL, NULL, 93, NULL, NULL, 229371),
(229548, '3p5jC01', NULL, NULL, 92, NULL, NULL, 229371),
(229549, '4j32A00', NULL, NULL, 174, NULL, NULL, 229372),
(229550, '4hffA00', NULL, NULL, 175, NULL, NULL, 229372),
(229551, '4hflA00', NULL, NULL, 176, NULL, NULL, 229372),
(229552, '3m4iA02', NULL, NULL, 68, NULL, NULL, 229373),
(229553, '1n93X02', NULL, NULL, 135, NULL, NULL, 229374),
(229554, '3tufB00', NULL, NULL, 158, NULL, NULL, 229375),
(229555, '5kvpA00', NULL, NULL, 159, NULL, NULL, 229375),
(229556, '1f3zA00', NULL, NULL, 161, NULL, NULL, 229375),
(229557, '3csqA02', NULL, NULL, 168, NULL, NULL, 229375),
(229558, '4qp5A00', NULL, NULL, 140, NULL, NULL, 229375),
(229559, '3ourB00', NULL, NULL, 150, NULL, NULL, 229375),
(229560, '5b0hA00', NULL, NULL, 135, NULL, NULL, 229375),
(229561, '1qwyA02', NULL, NULL, 174, NULL, NULL, 229375),
(229562, '4rnyA03', NULL, NULL, 132, NULL, NULL, 229375),
(229563, '2hsiB02', NULL, NULL, 159, NULL, NULL, 229375),
(229564, '2gu1A03', NULL, NULL, 132, NULL, NULL, 229375),
(229565, '2gprA00', NULL, NULL, 154, NULL, NULL, 229375),
(229566, '3it5G00', NULL, NULL, 182, NULL, NULL, 229375),
(229567, '4bh5A00', NULL, NULL, 142, NULL, NULL, 229375),
(229568, '3uz0B00', NULL, NULL, 152, NULL, NULL, 229375),
(229569, '1gprA00', NULL, NULL, 162, NULL, NULL, 229375),
(229570, '4zybA00', NULL, NULL, 134, NULL, NULL, 229375),
(229571, '5kqbA00', NULL, NULL, 145, NULL, NULL, 229375),
(229572, '3sluB03', NULL, NULL, 129, NULL, NULL, 229375),
(229573, '3kt7A02', NULL, NULL, 359, NULL, NULL, 229376),
(229574, '1k90C03', NULL, NULL, 155, NULL, NULL, 229377),
(229575, '1k90B03', NULL, NULL, 121, NULL, NULL, 229377),
(229576, '4qxbB00', NULL, NULL, 68, NULL, NULL, 229378),
(229577, '3fd9B02', NULL, NULL, 95, NULL, NULL, 229379),
(229578, '1ywmA01', NULL, NULL, 98, NULL, NULL, 229380),
(229579, '1vhnA02', NULL, NULL, 80, NULL, NULL, 229381),
(229580, '4nohB02', NULL, NULL, 96, NULL, NULL, 229382),
(229581, '4nohA02', NULL, NULL, 96, NULL, NULL, 229382),
(229582, '1mabA03', NULL, NULL, 130, NULL, NULL, 229383),
(229583, '3oaaA03', NULL, NULL, 131, NULL, NULL, 229383),
(229584, '3ziaA03', NULL, NULL, 129, NULL, NULL, 229383),
(229585, '1fx0A03', NULL, NULL, 135, NULL, NULL, 229383),
(229586, '2qe7A03', NULL, NULL, 126, NULL, NULL, 229383),
(229587, '2ck3A03', NULL, NULL, 131, NULL, NULL, 229383),
(229588, '5fl7A03', NULL, NULL, 131, NULL, NULL, 229383),
(229589, '2r9vA03', NULL, NULL, 128, NULL, NULL, 229383),
(229590, '5cdfA03', NULL, NULL, 131, NULL, NULL, 229383),
(229591, '1skyB03', NULL, NULL, 128, NULL, NULL, 229383),
(229592, '2m5zA00', NULL, NULL, 44, NULL, NULL, 229384),
(229593, '2m60A00', NULL, NULL, 43, NULL, NULL, 229384),
(229594, '4owpB00', NULL, NULL, 174, NULL, NULL, 229385),
(229595, '2z3gB00', NULL, NULL, 130, NULL, NULL, 229385),
(229596, '3zpgA01', NULL, NULL, 138, NULL, NULL, 229385),
(229597, '1vq2A00', NULL, NULL, 193, NULL, NULL, 229385),
(229598, '4eg2A01', NULL, NULL, 151, NULL, NULL, 229385),
(229599, '1mq0A00', NULL, NULL, 140, NULL, NULL, 229385),
(229600, '4eg2A02', NULL, NULL, 116, NULL, NULL, 229385),
(229601, '3zefB06', NULL, NULL, 251, NULL, NULL, 229385); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(229602, '4wigA00', NULL, NULL, 133, NULL, NULL, 229385),
(229603, '4p9cA00', NULL, NULL, 138, NULL, NULL, 229385),
(229604, '2pw9D03', NULL, NULL, 156, NULL, NULL, 229385),
(229605, '3dmoA00', NULL, NULL, 138, NULL, NULL, 229385),
(229606, '3mpzA00', NULL, NULL, 131, NULL, NULL, 229385),
(229607, '2nx8A00', NULL, NULL, 179, NULL, NULL, 229385),
(229608, '1uwzA00', NULL, NULL, 136, NULL, NULL, 229385),
(229609, '2p8rA01', NULL, NULL, 247, NULL, NULL, 229385),
(229610, '2b3jC00', NULL, NULL, 159, NULL, NULL, 229385),
(229611, '4ocmA00', NULL, NULL, 187, NULL, NULL, 229385),
(229612, '2w4lD00', NULL, NULL, 178, NULL, NULL, 229385),
(229613, '5cw6A00', NULL, NULL, 166, NULL, NULL, 229385),
(229614, '1p6oA00', NULL, NULL, 161, NULL, NULL, 229385),
(229615, '1ox7B00', NULL, NULL, 161, NULL, NULL, 229385),
(229616, '1r5tA00', NULL, NULL, 142, NULL, NULL, 229385),
(229617, '3dh1B00', NULL, NULL, 173, NULL, NULL, 229385),
(229618, '4qftA00', NULL, NULL, 186, NULL, NULL, 229385),
(229619, '1wwrA00', NULL, NULL, 154, NULL, NULL, 229385),
(229620, '1oi0A00', NULL, NULL, 124, NULL, NULL, 229385),
(229621, '2nytD00', NULL, NULL, 190, NULL, NULL, 229385),
(229622, '2g6vA01', NULL, NULL, 140, NULL, NULL, 229385),
(229623, '1wkqB00', NULL, NULL, 164, NULL, NULL, 229385),
(229624, '1tiyA00', NULL, NULL, 164, NULL, NULL, 229385),
(229625, '2hxvA01', NULL, NULL, 159, NULL, NULL, 229385),
(229626, '2hvwA00', NULL, NULL, 148, NULL, NULL, 229385),
(229627, '2fr5A00', NULL, NULL, 146, NULL, NULL, 229385),
(229628, '2kcqA00', NULL, NULL, 153, NULL, NULL, 229385),
(229629, '4jxeB00', NULL, NULL, 197, NULL, NULL, 229385),
(229630, '3r2nD00', NULL, NULL, 138, NULL, NULL, 229385),
(229631, '3rzvA00', NULL, NULL, 179, NULL, NULL, 229385),
(229632, '2d30A00', NULL, NULL, 141, NULL, NULL, 229385),
(229633, '3e1uA00', NULL, NULL, 189, NULL, NULL, 229385),
(229634, '2o95B00', NULL, NULL, 187, NULL, NULL, 229385),
(229635, '2rpzA00', NULL, NULL, 192, NULL, NULL, 229385),
(229636, '1z3aA00', NULL, NULL, 168, NULL, NULL, 229385),
(229637, '3ocqA00', NULL, NULL, 146, NULL, NULL, 229385),
(229638, '2g84A01', NULL, NULL, 173, NULL, NULL, 229385),
(229639, '2znrA00', NULL, NULL, 178, NULL, NULL, 229385),
(229640, '2qlcA00', NULL, NULL, 126, NULL, NULL, 229385),
(229641, '2kksA00', NULL, NULL, 146, NULL, NULL, 229385),
(229642, '1cttA02', NULL, NULL, 115, NULL, NULL, 229385),
(229643, '1cttA01', NULL, NULL, 151, NULL, NULL, 229385),
(229644, '5w83A00', NULL, NULL, 177, NULL, NULL, 229385),
(229645, '3oj6A00', NULL, NULL, 134, NULL, NULL, 229385),
(229646, '4f3wB00', NULL, NULL, 135, NULL, NULL, 229385),
(229647, '4kitC00', NULL, NULL, 278, NULL, NULL, 229385),
(229648, '2b3zD01', NULL, NULL, 146, NULL, NULL, 229385),
(229649, '3b8fB00', NULL, NULL, 142, NULL, NULL, 229385),
(229650, '5m59D00', NULL, NULL, 276, NULL, NULL, 229385),
(229651, '2a8nB00', NULL, NULL, 144, NULL, NULL, 229385),
(229652, '4e0qA00', NULL, NULL, 141, NULL, NULL, 229385),
(229653, '4f7oA00', NULL, NULL, 257, NULL, NULL, 229385),
(229654, '2og4A01', NULL, NULL, 245, NULL, NULL, 229385),
(229655, '4o8yB00', NULL, NULL, 166, NULL, NULL, 229385),
(229656, '3g8qA01', NULL, NULL, 113, NULL, NULL, 229385),
(229657, '2k1hA00', NULL, NULL, 94, NULL, NULL, 229386),
(229658, '2ffmA00', NULL, NULL, 91, NULL, NULL, 229386),
(229659, '2ltmA00', NULL, NULL, 107, NULL, NULL, 229386),
(229660, '2ltlA00', NULL, NULL, 119, NULL, NULL, 229386),
(229661, '2llmA00', NULL, NULL, 43, NULL, NULL, 229387),
(229662, '2v3bB00', NULL, NULL, 55, NULL, NULL, 229388),
(229663, '1qcvA00', NULL, NULL, 53, NULL, NULL, 229388),
(229664, '1iu5A00', NULL, NULL, 53, NULL, NULL, 229388),
(229665, '5xpdA02', NULL, NULL, 58, NULL, NULL, 229388),
(229666, '4tpuA02', NULL, NULL, 37, NULL, NULL, 229388),
(229667, '2kn9A01', NULL, NULL, 64, NULL, NULL, 229388),
(229668, '2k2dA00', NULL, NULL, 47, NULL, NULL, 229388),
(229669, '1h7vA00', NULL, NULL, 60, NULL, NULL, 229388),
(229670, '2pvxA00', NULL, NULL, 54, NULL, NULL, 229388),
(229671, '2m4yA00', NULL, NULL, 56, NULL, NULL, 229388),
(229672, '3a43B02', NULL, NULL, 55, NULL, NULL, 229388);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(229673, '1rb9A00', NULL, NULL, 52, NULL, NULL, 229388),
(229674, '4me3A03', NULL, NULL, 55, NULL, NULL, 229388),
(229675, '4rxnA00', NULL, NULL, 54, NULL, NULL, 229388),
(229676, '1lkoA02', NULL, NULL, 45, NULL, NULL, 229388),
(229677, '2rdvA00', NULL, NULL, 52, NULL, NULL, 229388),
(229678, '1yk4A00', NULL, NULL, 52, NULL, NULL, 229388),
(229679, '1t9pA00', NULL, NULL, 54, NULL, NULL, 229388),
(229680, '1ltlA03', NULL, NULL, 49, NULL, NULL, 229388),
(229681, '2ms3A00', NULL, NULL, 57, NULL, NULL, 229388),
(229682, '2dsxA00', NULL, NULL, 52, NULL, NULL, 229388),
(229683, '1yuzA02', NULL, NULL, 38, NULL, NULL, 229388),
(229684, '1b2jA00', NULL, NULL, 54, NULL, NULL, 229388),
(229685, '5nw3A00', NULL, NULL, 54, NULL, NULL, 229388),
(229686, '6rxnA00', NULL, NULL, 46, NULL, NULL, 229388),
(229687, '4r7yA03', NULL, NULL, 48, NULL, NULL, 229388),
(229688, '3pwfA02', NULL, NULL, 39, NULL, NULL, 229388),
(229689, '2pveA00', NULL, NULL, 54, NULL, NULL, 229388),
(229690, '2lcqA02', NULL, NULL, 38, NULL, NULL, 229388),
(229691, '1iroA00', NULL, NULL, 54, NULL, NULL, 229388),
(229692, '2rxn000', NULL, NULL, 55, NULL, NULL, 229388),
(229693, '1yk5C00', NULL, NULL, 53, NULL, NULL, 229388),
(229694, '1s24A00', NULL, NULL, 56, NULL, NULL, 229388),
(229695, '4pofA03', NULL, NULL, 50, NULL, NULL, 229388),
(229696, '2m6xB00', NULL, NULL, 63, NULL, NULL, 229389),
(229697, '2yjlA00', NULL, NULL, 125, NULL, NULL, 229390),
(229698, '2kinB02', NULL, NULL, 20, NULL, NULL, 229391),
(229699, '2p22D00', NULL, NULL, 79, NULL, NULL, 229392),
(229700, '2cxaA01', NULL, NULL, 60, NULL, NULL, 229393),
(229701, '5z62J00', NULL, NULL, 56, NULL, NULL, 229394),
(229702, '5b1aJ00', NULL, NULL, 59, NULL, NULL, 229394),
(229703, '2kq8A01', NULL, NULL, 23, NULL, NULL, 229395),
(229704, '2lqvA00', NULL, NULL, 105, NULL, NULL, 229396),
(229705, '2xglA00', NULL, NULL, 103, NULL, NULL, 229396),
(229706, '3keyA01', NULL, NULL, 89, NULL, NULL, 229397),
(229707, '2ra1A01', NULL, NULL, 98, NULL, NULL, 229398),
(229708, '2zu0D00', NULL, NULL, 60, NULL, NULL, 229399),
(229709, '4hvzA01', NULL, NULL, 112, NULL, NULL, 229400),
(229710, '1z2nX01', NULL, NULL, 109, NULL, NULL, 229401),
(229711, '4u7bA01', NULL, NULL, 51, NULL, NULL, 229402),
(229712, '2i9iA00', NULL, NULL, 236, NULL, NULL, 229403),
(229713, '3bghB01', NULL, NULL, 201, NULL, NULL, 229403),
(229714, '1o75A03', NULL, NULL, 128, NULL, NULL, 229404),
(229715, '3fnnA01', NULL, NULL, 142, NULL, NULL, 229405),
(229716, '3gwcD01', NULL, NULL, 144, NULL, NULL, 229405),
(229717, '5bu9A00', NULL, NULL, 340, NULL, NULL, 229406),
(229718, '2oxnA00', NULL, NULL, 340, NULL, NULL, 229406),
(229719, '5g1mA00', NULL, NULL, 333, NULL, NULL, 229406),
(229720, '5bzaB01', NULL, NULL, 332, NULL, NULL, 229406),
(229721, '6gfvA00', NULL, NULL, 343, NULL, NULL, 229406),
(229722, '5m6gA01', NULL, NULL, 361, NULL, NULL, 229406),
(229723, '4gvfA00', NULL, NULL, 349, NULL, NULL, 229406),
(229724, '5fjiA01', NULL, NULL, 330, NULL, NULL, 229406),
(229725, '4g6cA00', NULL, NULL, 348, NULL, NULL, 229406),
(229726, '3wliA01', NULL, NULL, 377, NULL, NULL, 229406),
(229727, '4iibA01', NULL, NULL, 329, NULL, NULL, 229406),
(229728, '3zyzA01', NULL, NULL, 304, NULL, NULL, 229406),
(229729, '4zocA01', NULL, NULL, 359, NULL, NULL, 229406),
(229730, '5z9sB01', NULL, NULL, 344, NULL, NULL, 229406),
(229731, '3bmxA01', NULL, NULL, 394, NULL, NULL, 229406),
(229732, '3rrxA01', NULL, NULL, 364, NULL, NULL, 229406),
(229733, '5ju6A01', NULL, NULL, 325, NULL, NULL, 229406),
(229734, '3abzA01', NULL, NULL, 339, NULL, NULL, 229406),
(229735, '5iobG00', NULL, NULL, 348, NULL, NULL, 229406),
(229736, '5nbsA01', NULL, NULL, 345, NULL, NULL, 229406),
(229737, '3u48B01', NULL, NULL, 349, NULL, NULL, 229406),
(229738, '3tevB00', NULL, NULL, 335, NULL, NULL, 229406),
(229739, '5tf0B01', NULL, NULL, 358, NULL, NULL, 229406),
(229740, '3sqlB01', NULL, NULL, 379, NULL, NULL, 229406),
(229741, '2x41A01', NULL, NULL, 312, NULL, NULL, 229406),
(229742, '5fjjA01', NULL, NULL, 330, NULL, NULL, 229406),
(229743, '3wo8A01', NULL, NULL, 343, NULL, NULL, 229406);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(229744, '1tr9A00', NULL, NULL, 341, NULL, NULL, 229406),
(229745, '4i3gA01', NULL, NULL, 354, NULL, NULL, 229406),
(229746, '5xxlA01', NULL, NULL, 355, NULL, NULL, 229406),
(229747, '4yyfA00', NULL, NULL, 332, NULL, NULL, 229406),
(229748, '4zm6A01', NULL, NULL, 371, NULL, NULL, 229406),
(229749, '2lmdA00', NULL, NULL, 174, NULL, NULL, 229407),
(229750, '1mijA00', NULL, NULL, 152, NULL, NULL, 229407),
(229751, '2fefA02', NULL, NULL, 160, NULL, NULL, 229408),
(229752, '1xouA00', NULL, NULL, 74, NULL, NULL, 229409),
(229753, '3kp1E01', NULL, NULL, 44, NULL, NULL, 229410),
(229754, '1ig0A02', NULL, NULL, 132, NULL, NULL, 229411),
(229755, '2g9zB01', NULL, NULL, 139, NULL, NULL, 229411),
(229756, '1ig3A01', NULL, NULL, 97, NULL, NULL, 229411),
(229757, '3pxpB02', NULL, NULL, 199, NULL, NULL, 229412),
(229758, '3pxpA02', NULL, NULL, 199, NULL, NULL, 229412),
(229759, '3pxpC02', NULL, NULL, 199, NULL, NULL, 229412),
(229760, '3up6A02', NULL, NULL, 168, NULL, NULL, 229413),
(229761, '5ot0A02', NULL, NULL, 128, NULL, NULL, 229414),
(229762, '1o7jA02', NULL, NULL, 109, NULL, NULL, 229414),
(229763, '2himB02', NULL, NULL, 120, NULL, NULL, 229414),
(229764, '2ocdA02', NULL, NULL, 128, NULL, NULL, 229414),
(229765, '2d6fA03', NULL, NULL, 138, NULL, NULL, 229414),
(229766, '3pga102', NULL, NULL, 114, NULL, NULL, 229414),
(229767, '3ntxA02', NULL, NULL, 130, NULL, NULL, 229414),
(229768, '3nxkA02', NULL, NULL, 113, NULL, NULL, 229414),
(229769, '1zq1A03', NULL, NULL, 138, NULL, NULL, 229414),
(229770, '5dncA02', NULL, NULL, 126, NULL, NULL, 229414),
(229771, '4pgaA02', NULL, NULL, 114, NULL, NULL, 229414),
(229772, '5k4gA02', NULL, NULL, 113, NULL, NULL, 229414),
(229773, '1agxA02', NULL, NULL, 115, NULL, NULL, 229414),
(229774, '2wltA02', NULL, NULL, 112, NULL, NULL, 229414),
(229775, '2gvnA02', NULL, NULL, 109, NULL, NULL, 229414),
(229776, '5b74B00', NULL, NULL, 127, NULL, NULL, 229414),
(229777, '5mq5A02', NULL, NULL, 114, NULL, NULL, 229414),
(229778, '1wlsA02', NULL, NULL, 130, NULL, NULL, 229414),
(229779, '4gqzD00', NULL, NULL, 161, NULL, NULL, 229415),
(229780, '3p01A02', NULL, NULL, 95, NULL, NULL, 229416),
(229781, '2hgsA04', NULL, NULL, 122, NULL, NULL, 229417),
(229782, '5oesA04', NULL, NULL, 124, NULL, NULL, 229417),
(229783, '2wyoA04', NULL, NULL, 154, NULL, NULL, 229417),
(229784, '3kalA04', NULL, NULL, 124, NULL, NULL, 229417),
(229785, '1m0wA04', NULL, NULL, 134, NULL, NULL, 229417),
(229786, '1wlgA02', NULL, NULL, 140, NULL, NULL, 229418),
(229787, '3oaaD03', NULL, NULL, 116, NULL, NULL, 229419),
(229788, '3gqbA04', NULL, NULL, 149, NULL, NULL, 229419),
(229789, '3qjyA04', NULL, NULL, 151, NULL, NULL, 229419),
(229790, '3ziaD03', NULL, NULL, 121, NULL, NULL, 229419),
(229791, '4q4lA03', NULL, NULL, 117, NULL, NULL, 229419),
(229792, '6focD03', NULL, NULL, 120, NULL, NULL, 229419),
(229793, '6fkfB03', NULL, NULL, 124, NULL, NULL, 229419),
(229794, '2ck3D03', NULL, NULL, 121, NULL, NULL, 229419),
(229795, '5fl7D03', NULL, NULL, 121, NULL, NULL, 229419),
(229796, '6f5dD03', NULL, NULL, 123, NULL, NULL, 229419),
(229797, '1skyE03', NULL, NULL, 116, NULL, NULL, 229419),
(229798, '5cdfE03', NULL, NULL, 121, NULL, NULL, 229419),
(229799, '5bn3A04', NULL, NULL, 146, NULL, NULL, 229419),
(229800, '3vr4B04', NULL, NULL, 158, NULL, NULL, 229419),
(229801, '5ik2D03', NULL, NULL, 116, NULL, NULL, 229419),
(229802, '1vrmA02', NULL, NULL, 101, NULL, NULL, 229420),
(229803, '2yreA01', NULL, NULL, 50, NULL, NULL, 229421),
(229804, '5hayA02', NULL, NULL, 79, NULL, NULL, 229422),
(229805, '3i5pA02', NULL, NULL, 73, NULL, NULL, 229422),
(229806, '2gp4A03', NULL, NULL, 152, NULL, NULL, 229423),
(229807, '4kq7A01', NULL, NULL, 163, NULL, NULL, 229424),
(229808, '4kq7A02', NULL, NULL, 211, NULL, NULL, 229424),
(229809, '1ztmA01', NULL, NULL, 111, NULL, NULL, 229425),
(229810, '1g5gA01', NULL, NULL, 111, NULL, NULL, 229425),
(229811, '2b9bA01', NULL, NULL, 119, NULL, NULL, 229425),
(229812, '4gipD02', NULL, NULL, 89, NULL, NULL, 229425),
(229813, '2q7tA02', NULL, NULL, 33, NULL, NULL, 229426),
(229814, '3d3qA03', NULL, NULL, 81, NULL, NULL, 229427);
INSERT INTO "PUBLIC"."MODEL" VALUES
(229815, '3exaA03', NULL, NULL, 81, NULL, NULL, 229427),
(229816, '3a8tA02', NULL, NULL, 111, NULL, NULL, 229427),
(229817, '2ze7A02', NULL, NULL, 102, NULL, NULL, 229427),
(229818, '3crmA02', NULL, NULL, 84, NULL, NULL, 229427),
(229819, '3bt4A00', NULL, NULL, 86, NULL, NULL, 229428),
(229820, '4lj0A00', NULL, NULL, 66, NULL, NULL, 229429),
(229821, '2jwhA00', NULL, NULL, 48, NULL, NULL, 229430),
(229822, '4ae4B00', NULL, NULL, 118, NULL, NULL, 229431),
(229823, '4ae4A00', NULL, NULL, 118, NULL, NULL, 229431),
(229824, '3hr0A02', NULL, NULL, 170, NULL, NULL, 229432),
(229825, '2p2vA00', NULL, NULL, 288, NULL, NULL, 229433),
(229826, '1ro7C00', NULL, NULL, 259, NULL, NULL, 229433),
(229827, '1ro2A03', NULL, NULL, 25, NULL, NULL, 229434),
(229828, '1vq8M00', NULL, NULL, 194, NULL, NULL, 229435),
(229829, '1vwxN01', NULL, NULL, 197, NULL, NULL, 229435),
(229830, '6em3N00', NULL, NULL, 204, NULL, NULL, 229435),
(229831, '1jj2L00', NULL, NULL, 194, NULL, NULL, 229435),
(229832, '4a17L01', NULL, NULL, 197, NULL, NULL, 229435),
(229833, '1vx7P01', NULL, NULL, 198, NULL, NULL, 229435),
(229834, '2w8aC02', NULL, NULL, 21, NULL, NULL, 229436),
(229835, '1mjtB01', NULL, NULL, 129, NULL, NULL, 229437),
(229836, '2amoB01', NULL, NULL, 134, NULL, NULL, 229437),
(229837, '2flqA01', NULL, NULL, 140, NULL, NULL, 229437),
(229838, '6ngmB01', NULL, NULL, 168, NULL, NULL, 229437),
(229839, '1m7vA01', NULL, NULL, 132, NULL, NULL, 229437),
(229840, '3e7mA01', NULL, NULL, 174, NULL, NULL, 229437),
(229841, '4culB01', NULL, NULL, 224, NULL, NULL, 229437),
(229842, '3e7gA01', NULL, NULL, 169, NULL, NULL, 229437),
(229843, '6ng4B01', NULL, NULL, 168, NULL, NULL, 229437),
(229844, '4d1pA01', NULL, NULL, 169, NULL, NULL, 229437),
(229845, '4d3tA01', NULL, NULL, 132, NULL, NULL, 229437),
(229846, '1q2oA01', NULL, NULL, 169, NULL, NULL, 229437),
(229847, '2ortA01', NULL, NULL, 135, NULL, NULL, 229437),
(229848, '3it4B01', NULL, NULL, 79, NULL, NULL, 229438),
(229849, '2v4iB01', NULL, NULL, 78, NULL, NULL, 229438),
(229850, '1vraB01', NULL, NULL, 85, NULL, NULL, 229438),
(229851, '3m8aC00', NULL, NULL, 76, NULL, NULL, 229439),
(229852, '2lw7A01', NULL, NULL, 56, NULL, NULL, 229439),
(229853, '5optR02', NULL, NULL, 70, NULL, NULL, 229439),
(229854, '1yzbA02', NULL, NULL, 46, NULL, NULL, 229439),
(229855, '6g5iN02', NULL, NULL, 70, NULL, NULL, 229439),
(229856, '2n74A00', NULL, NULL, 73, NULL, NULL, 229439),
(229857, '5mmjo00', NULL, NULL, 90, NULL, NULL, 229439),
(229858, '2vqeO00', NULL, NULL, 89, NULL, NULL, 229439),
(229859, '1a32A00', NULL, NULL, 88, NULL, NULL, 229439),
(229860, '2z0aA00', NULL, NULL, 79, NULL, NULL, 229439),
(229861, '3o65A02', NULL, NULL, 46, NULL, NULL, 229439),
(229862, '6az1T02', NULL, NULL, 70, NULL, NULL, 229439),
(229863, '3o65C02', NULL, NULL, 46, NULL, NULL, 229439),
(229864, '4opaA01', NULL, NULL, 80, NULL, NULL, 229439),
(229865, '1xeqB00', NULL, NULL, 103, NULL, NULL, 229439),
(229866, '3o65E02', NULL, NULL, 46, NULL, NULL, 229439),
(229867, '5h5nA00', NULL, NULL, 74, NULL, NULL, 229439),
(229868, '3o65G02', NULL, NULL, 46, NULL, NULL, 229439),
(229869, '6e5uK00', NULL, NULL, 77, NULL, NULL, 229439),
(229870, '5by1A00', NULL, NULL, 84, NULL, NULL, 229439),
(229871, '1dk1A00', NULL, NULL, 86, NULL, NULL, 229439),
(229872, '4xpzA02', NULL, NULL, 44, NULL, NULL, 229439),
(229873, '1g1xB00', NULL, NULL, 88, NULL, NULL, 229439),
(229874, '6faiN02', NULL, NULL, 70, NULL, NULL, 229439),
(229875, '2xzmO02', NULL, NULL, 70, NULL, NULL, 229439),
(229876, '1fyjA00', NULL, NULL, 57, NULL, NULL, 229439),
(229877, '3j7aU02', NULL, NULL, 70, NULL, NULL, 229439),
(229878, '2zkoA00', NULL, NULL, 73, NULL, NULL, 229439),
(229879, '5o5jO00', NULL, NULL, 89, NULL, NULL, 229439),
(229880, '5xxuN02', NULL, NULL, 70, NULL, NULL, 229439),
(229881, '5xyiN02', NULL, NULL, 70, NULL, NULL, 229439),
(229882, '4iylA01', NULL, NULL, 57, NULL, NULL, 229439),
(229883, '1d2dA00', NULL, NULL, 59, NULL, NULL, 229439),
(229884, '5ujjA01', NULL, NULL, 62, NULL, NULL, 229439),
(229885, '4a5uB00', NULL, NULL, 88, NULL, NULL, 229439);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(229886, '1ailA00', NULL, NULL, 73, NULL, NULL, 229439),
(229887, '3bbaA00', NULL, NULL, 251, NULL, NULL, 229440),
(229888, '3bb7A01', NULL, NULL, 181, NULL, NULL, 229440),
(229889, '1dkiC01', NULL, NULL, 226, NULL, NULL, 229440),
(229890, '4d8bA00', NULL, NULL, 261, NULL, NULL, 229440),
(229891, '2km1A00', NULL, NULL, 136, NULL, NULL, 229441),
(229892, '3vtiA03', NULL, NULL, 121, NULL, NULL, 229442),
(229893, '2lnaA00', NULL, NULL, 99, NULL, NULL, 229443),
(229894, '5dhdA00', NULL, NULL, 100, NULL, NULL, 229444),
(229895, '1hehC00', NULL, NULL, 88, NULL, NULL, 229444),
(229896, '5dheA00', NULL, NULL, 100, NULL, NULL, 229444),
(229897, '1e5bA00', NULL, NULL, 87, NULL, NULL, 229444),
(229898, '3ndzE00', NULL, NULL, 107, NULL, NULL, 229444),
(229899, '2rttA00', NULL, NULL, 105, NULL, NULL, 229444),
(229900, '1c7sA01', NULL, NULL, 142, NULL, NULL, 229444),
(229901, '1exgA00', NULL, NULL, 110, NULL, NULL, 229444),
(229902, '2cwrA00', NULL, NULL, 103, NULL, NULL, 229444),
(229903, '2d16B00', NULL, NULL, 162, NULL, NULL, 229445),
(229904, '1vggA00', NULL, NULL, 161, NULL, NULL, 229445),
(229905, '1wvqC00', NULL, NULL, 167, NULL, NULL, 229445),
(229906, '2ekmA00', NULL, NULL, 162, NULL, NULL, 229445),
(229907, '1rlhA02', NULL, NULL, 101, NULL, NULL, 229445),
(229908, '1f0xA01', NULL, NULL, 100, NULL, NULL, 229446),
(229909, '3u5eQ00', NULL, NULL, 186, NULL, NULL, 229447),
(229910, '1vq8L02', NULL, NULL, 99, NULL, NULL, 229447),
(229911, '1vq8O00', NULL, NULL, 116, NULL, NULL, 229447),
(229912, '4a17K02', NULL, NULL, 90, NULL, NULL, 229447),
(229913, '4a17N00', NULL, NULL, 181, NULL, NULL, 229447),
(229914, '1vx7S00', NULL, NULL, 187, NULL, NULL, 229447),
(229915, '1vx7O02', NULL, NULL, 91, NULL, NULL, 229447),
(229916, '1vwxa02', NULL, NULL, 91, NULL, NULL, 229447),
(229917, '3o58Y02', NULL, NULL, 92, NULL, NULL, 229447),
(229918, '5v7qL01', NULL, NULL, 73, NULL, NULL, 229447),
(229919, '1vwxQ00', NULL, NULL, 188, NULL, NULL, 229447),
(229920, '1vs9J01', NULL, NULL, 79, NULL, NULL, 229447),
(229921, '6em3Q00', NULL, NULL, 145, NULL, NULL, 229447),
(229922, '2pwwA00', NULL, NULL, 127, NULL, NULL, 229448),
(229923, '2r5xA00', NULL, NULL, 129, NULL, NULL, 229448),
(229924, '1iieA00', NULL, NULL, 75, NULL, NULL, 229449),
(229925, '4ksaA01', NULL, NULL, 155, NULL, NULL, 229450),
(229926, '3abqB02', NULL, NULL, 30, NULL, NULL, 229451),
(229927, '1jrmA00', NULL, NULL, 104, NULL, NULL, 229452),
(229928, '1n91A00', NULL, NULL, 108, NULL, NULL, 229452),
(229929, '2zshB00', NULL, NULL, 66, NULL, NULL, 229453),
(229930, '1mjtA02', NULL, NULL, 95, NULL, NULL, 229454),
(229931, '2orpA02', NULL, NULL, 103, NULL, NULL, 229454),
(229932, '1d0cA02', NULL, NULL, 103, NULL, NULL, 229454),
(229933, '2flqA02', NULL, NULL, 102, NULL, NULL, 229454),
(229934, '6ngmA02', NULL, NULL, 103, NULL, NULL, 229454),
(229935, '1m7vA02', NULL, NULL, 103, NULL, NULL, 229454),
(229936, '3e7gA02', NULL, NULL, 103, NULL, NULL, 229454),
(229937, '4d3tA02', NULL, NULL, 103, NULL, NULL, 229454),
(229938, '4bryB00', NULL, NULL, 73, NULL, NULL, 229455),
(229939, '3wutG00', NULL, NULL, 63, NULL, NULL, 229455),
(229940, '4bryA00', NULL, NULL, 78, NULL, NULL, 229455),
(229941, '1wlqD00', NULL, NULL, 65, NULL, NULL, 229455),
(229942, '2zxxD00', NULL, NULL, 79, NULL, NULL, 229455),
(229943, '1uiiA00', NULL, NULL, 61, NULL, NULL, 229455),
(229944, '2q6qA00', NULL, NULL, 74, NULL, NULL, 229455),
(229945, '1puzA00', NULL, NULL, 82, NULL, NULL, 229456),
(229946, '1x6iB00', NULL, NULL, 91, NULL, NULL, 229456),
(229947, '2lm4A01', NULL, NULL, 92, NULL, NULL, 229456),
(229948, '6c12D00', NULL, NULL, 101, NULL, NULL, 229456),
(229949, '2jr5A00', NULL, NULL, 94, NULL, NULL, 229456),
(229950, '1iojA00', NULL, NULL, 57, NULL, NULL, 229457),
(229951, '1xdsA02', NULL, NULL, 73, NULL, NULL, 229458),
(229952, '3i53A02', NULL, NULL, 71, NULL, NULL, 229458),
(229953, '6clxA02', NULL, NULL, 76, NULL, NULL, 229458),
(229954, '5eehA02', NULL, NULL, 75, NULL, NULL, 229458),
(229955, '1qzzA02', NULL, NULL, 76, NULL, NULL, 229458),
(229956, '4kzsA03', NULL, NULL, 97, NULL, NULL, 229459);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(229957, '4jg9A00', NULL, NULL, 139, NULL, NULL, 229460),
(229958, '4fvmA08', NULL, NULL, 90, NULL, NULL, 229461),
(229959, '2iu8C01', NULL, NULL, 104, NULL, NULL, 229462),
(229960, '4c12A01', NULL, NULL, 98, NULL, NULL, 229462),
(229961, '1e8cA01', NULL, NULL, 103, NULL, NULL, 229462),
(229962, '4e79B01', NULL, NULL, 104, NULL, NULL, 229462),
(229963, '3pmoA01', NULL, NULL, 119, NULL, NULL, 229462),
(229964, '3zm6A01', NULL, NULL, 80, NULL, NULL, 229462),
(229965, '4bubB01', NULL, NULL, 98, NULL, NULL, 229462),
(229966, '3zl8A01', NULL, NULL, 62, NULL, NULL, 229462),
(229967, '4ihfA01', NULL, NULL, 106, NULL, NULL, 229462),
(229968, '1gg4A03', NULL, NULL, 80, NULL, NULL, 229462),
(229969, '2wtzC01', NULL, NULL, 110, NULL, NULL, 229462),
(229970, '4cvkA01', NULL, NULL, 82, NULL, NULL, 229462),
(229971, '4ziyA01', NULL, NULL, 101, NULL, NULL, 229462),
(229972, '3e2lD02', NULL, NULL, 91, NULL, NULL, 229463),
(229973, '3n4iB01', NULL, NULL, 74, NULL, NULL, 229463),
(229974, '2pxgA01', NULL, NULL, 77, NULL, NULL, 229463),
(229975, '4dm5A00', NULL, NULL, 103, NULL, NULL, 229463),
(229976, '2yh9B00', NULL, NULL, 88, NULL, NULL, 229463),
(229977, '3d4eA01', NULL, NULL, 84, NULL, NULL, 229463),
(229978, '3d4eA02', NULL, NULL, 78, NULL, NULL, 229463),
(229979, '3a98A02', NULL, NULL, 97, NULL, NULL, 229464),
(229980, '2klqA00', NULL, NULL, 114, NULL, NULL, 229465),
(229981, '4m0mA03', NULL, NULL, 79, NULL, NULL, 229466),
(229982, '2fiyA00', NULL, NULL, 291, NULL, NULL, 229467),
(229983, '3eojA00', NULL, NULL, 366, NULL, NULL, 229468),
(229984, '3vdiA00', NULL, NULL, 367, NULL, NULL, 229468),
(229985, '5h8zA00', NULL, NULL, 365, NULL, NULL, 229468),
(229986, '2wvoA00', NULL, NULL, 233, NULL, NULL, 229469),
(229987, '2wvqA00', NULL, NULL, 225, NULL, NULL, 229469),
(229988, '2wvnA01', NULL, NULL, 225, NULL, NULL, 229469),
(229989, '2m3aA00', NULL, NULL, 67, NULL, NULL, 229470),
(229990, '4bfaA02', NULL, NULL, 73, NULL, NULL, 229471),
(229991, '4j37A02', NULL, NULL, 212, NULL, NULL, 229472),
(229992, '1vs3A02', NULL, NULL, 144, NULL, NULL, 229472),
(229993, '1dj0A01', NULL, NULL, 138, NULL, NULL, 229472),
(229994, '1w5rA02', NULL, NULL, 100, NULL, NULL, 229473),
(229995, '4nv8A02', NULL, NULL, 97, NULL, NULL, 229473),
(229996, '3d9wA02', NULL, NULL, 102, NULL, NULL, 229473),
(229997, '1w4tA02', NULL, NULL, 99, NULL, NULL, 229473),
(229998, '4c5pA02', NULL, NULL, 100, NULL, NULL, 229473),
(229999, '4guzA02', NULL, NULL, 103, NULL, NULL, 229473),
(230000, '1e2tA03', NULL, NULL, 117, NULL, NULL, 229473),
(230001, '4bgfA02', NULL, NULL, 100, NULL, NULL, 229473),
(230002, '3tcqA01', NULL, NULL, 144, NULL, NULL, 229474),
(230003, '4lddA00', NULL, NULL, 159, NULL, NULL, 229474),
(230004, '1h2cA00', NULL, NULL, 140, NULL, NULL, 229474),
(230005, '5b0vA01', NULL, NULL, 150, NULL, NULL, 229474),
(230006, '2yfvC00', NULL, NULL, 63, NULL, NULL, 229475),
(230007, '2a5yB03', NULL, NULL, 80, NULL, NULL, 229476),
(230008, '4m9zD03', NULL, NULL, 70, NULL, NULL, 229476),
(230009, '4m9zC03', NULL, NULL, 80, NULL, NULL, 229476),
(230010, '4m9zB03', NULL, NULL, 70, NULL, NULL, 229476),
(230011, '4m9zA03', NULL, NULL, 80, NULL, NULL, 229476),
(230012, '4m9sD03', NULL, NULL, 70, NULL, NULL, 229476),
(230013, '4m9sA03', NULL, NULL, 80, NULL, NULL, 229476),
(230014, '4m9sB03', NULL, NULL, 70, NULL, NULL, 229476),
(230015, '4m9sC03', NULL, NULL, 80, NULL, NULL, 229476),
(230016, '3e38A02', NULL, NULL, 79, NULL, NULL, 229477),
(230017, '1l9nA02', NULL, NULL, 319, NULL, NULL, 229478),
(230018, '4ktyA02', NULL, NULL, 309, NULL, NULL, 229478),
(230019, '1g0dA02', NULL, NULL, 330, NULL, NULL, 229478),
(230020, '2qsfA01', NULL, NULL, 307, NULL, NULL, 229478),
(230021, '2q3zA02', NULL, NULL, 282, NULL, NULL, 229478),
(230022, '3r3lB02', NULL, NULL, 177, NULL, NULL, 229479),
(230023, '4gveA00', NULL, NULL, 213, NULL, NULL, 229479),
(230024, '3q7cA01', NULL, NULL, 203, NULL, NULL, 229479),
(230025, '6fgcA03', NULL, NULL, 98, NULL, NULL, 229480),
(230026, '1g8lA03', NULL, NULL, 92, NULL, NULL, 229480),
(230027, '6gbcA03', NULL, NULL, 97, NULL, NULL, 229480);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(230028, '1fc5A03', NULL, NULL, 92, NULL, NULL, 229480),
(230029, '1wu2A03', NULL, NULL, 99, NULL, NULL, 229480),
(230030, '1uz5A03', NULL, NULL, 97, NULL, NULL, 229480),
(230031, '1v1hA02', NULL, NULL, 27, NULL, NULL, 229481),
(230032, '1a8oA00', NULL, NULL, 70, NULL, NULL, 229482),
(230033, '5teoB00', NULL, NULL, 110, NULL, NULL, 229482),
(230034, '5teoA00', NULL, NULL, 84, NULL, NULL, 229482),
(230035, '1eiaA02', NULL, NULL, 74, NULL, NULL, 229482),
(230036, '1d1dA02', NULL, NULL, 90, NULL, NULL, 229482),
(230037, '5o2uA00', NULL, NULL, 73, NULL, NULL, 229482),
(230038, '4ph1A00', NULL, NULL, 93, NULL, NULL, 229482),
(230039, '2l6eA00', NULL, NULL, 105, NULL, NULL, 229482),
(230040, '4u0cA02', NULL, NULL, 82, NULL, NULL, 229482),
(230041, '5na2A02', NULL, NULL, 67, NULL, NULL, 229482),
(230042, '3vrlC00', NULL, NULL, 83, NULL, NULL, 229482),
(230043, '3g21A00', NULL, NULL, 77, NULL, NULL, 229482),
(230044, '1qrjA02', NULL, NULL, 85, NULL, NULL, 229482),
(230045, '3g1gB00', NULL, NULL, 87, NULL, NULL, 229482),
(230046, '4cocC00', NULL, NULL, 86, NULL, NULL, 229482),
(230047, '3ds4B00', NULL, NULL, 86, NULL, NULL, 229482),
(230048, '3d6wB02', NULL, NULL, 40, NULL, NULL, 229483),
(230049, '1zb9A01', NULL, NULL, 48, NULL, NULL, 229483),
(230050, '2p3yB01', NULL, NULL, 30, NULL, NULL, 229483),
(230051, '2de6A03', NULL, NULL, 55, NULL, NULL, 229483),
(230052, '1x3wA04', NULL, NULL, 40, NULL, NULL, 229483),
(230053, '1tfiA00', NULL, NULL, 50, NULL, NULL, 229483),
(230054, '4mh4A01', NULL, NULL, 53, NULL, NULL, 229483),
(230055, '2pk7A01', NULL, NULL, 62, NULL, NULL, 229483),
(230056, '2js4A01', NULL, NULL, 47, NULL, NULL, 229483),
(230057, '2bjoA01', NULL, NULL, 42, NULL, NULL, 229483),
(230058, '1uspB01', NULL, NULL, 44, NULL, NULL, 229483),
(230059, '3lusB01', NULL, NULL, 51, NULL, NULL, 229483),
(230060, '2f4mA02', NULL, NULL, 50, NULL, NULL, 229483),
(230061, '3q87A00', NULL, NULL, 125, NULL, NULL, 229483),
(230062, '1vlaA01', NULL, NULL, 48, NULL, NULL, 229483),
(230063, '1yuaA02', NULL, NULL, 58, NULL, NULL, 229483),
(230064, '1vlaC01', NULL, NULL, 48, NULL, NULL, 229483),
(230065, '1x3zA04', NULL, NULL, 54, NULL, NULL, 229483),
(230066, '6d9nB01', NULL, NULL, 52, NULL, NULL, 229483),
(230067, '3u50C02', NULL, NULL, 35, NULL, NULL, 229483),
(230068, '1l1oC02', NULL, NULL, 38, NULL, NULL, 229483),
(230069, '3vb9B01', NULL, NULL, 30, NULL, NULL, 229483),
(230070, '3vb9D01', NULL, NULL, 29, NULL, NULL, 229483),
(230071, '4nozB01', NULL, NULL, 55, NULL, NULL, 229483),
(230072, '2jr6A01', NULL, NULL, 61, NULL, NULL, 229483),
(230073, '2jnyA01', NULL, NULL, 58, NULL, NULL, 229483),
(230074, '2j6aA00', NULL, NULL, 141, NULL, NULL, 229483),
(230075, '2p3yA01', NULL, NULL, 30, NULL, NULL, 229483),
(230076, '2hf1A01', NULL, NULL, 61, NULL, NULL, 229483),
(230077, '3po3S02', NULL, NULL, 74, NULL, NULL, 229483),
(230078, '1dl6A00', NULL, NULL, 58, NULL, NULL, 229483),
(230079, '1ml8A01', NULL, NULL, 34, NULL, NULL, 229483),
(230080, '1lqlC01', NULL, NULL, 42, NULL, NULL, 229483),
(230081, '1lqlA01', NULL, NULL, 26, NULL, NULL, 229483),
(230082, '5cm2M00', NULL, NULL, 130, NULL, NULL, 229483),
(230083, '3i07B01', NULL, NULL, 51, NULL, NULL, 229483),
(230084, '3h0gI01', NULL, NULL, 46, NULL, NULL, 229483),
(230085, '3h0gI02', NULL, NULL, 67, NULL, NULL, 229483),
(230086, '1nuiA01', NULL, NULL, 56, NULL, NULL, 229483),
(230087, '2aklA01', NULL, NULL, 43, NULL, NULL, 229483),
(230088, '5flmI02', NULL, NULL, 69, NULL, NULL, 229483),
(230089, '3lusA01', NULL, NULL, 51, NULL, NULL, 229483),
(230090, '1vlaB01', NULL, NULL, 48, NULL, NULL, 229483),
(230091, '5flmI01', NULL, NULL, 56, NULL, NULL, 229483),
(230092, '1z01A03', NULL, NULL, 87, NULL, NULL, 229483),
(230093, '1twfI02', NULL, NULL, 76, NULL, NULL, 229483),
(230094, '1n2fA01', NULL, NULL, 47, NULL, NULL, 229483),
(230095, '1vlaD01', NULL, NULL, 48, NULL, NULL, 229483),
(230096, '1twfI01', NULL, NULL, 46, NULL, NULL, 229483),
(230097, '1qypA00', NULL, NULL, 57, NULL, NULL, 229483),
(230098, '3gcfA03', NULL, NULL, 55, NULL, NULL, 229483),
(230099, '2rblA01', NULL, NULL, 30, NULL, NULL, 229483);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(230100, '6mjnB01', NULL, NULL, 51, NULL, NULL, 229483),
(230101, '3vb9A01', NULL, NULL, 29, NULL, NULL, 229483),
(230102, '3vb9C01', NULL, NULL, 29, NULL, NULL, 229483),
(230103, '3gkqA03', NULL, NULL, 55, NULL, NULL, 229483),
(230104, '1pftA00', NULL, NULL, 50, NULL, NULL, 229483),
(230105, '2kpiA01', NULL, NULL, 39, NULL, NULL, 229483),
(230106, '3x01B01', NULL, NULL, 180, NULL, NULL, 229484),
(230107, '5e3sA01', NULL, NULL, 168, NULL, NULL, 229484),
(230108, '2gk9B01', NULL, NULL, 176, NULL, NULL, 229484),
(230109, '2ybxA01', NULL, NULL, 171, NULL, NULL, 229484),
(230110, '2rm8A00', NULL, NULL, 68, NULL, NULL, 229485),
(230111, '1fepA01', NULL, NULL, 146, NULL, NULL, 229486),
(230112, '4b7oA01', NULL, NULL, 111, NULL, NULL, 229486),
(230113, '2hdiA01', NULL, NULL, 133, NULL, NULL, 229486),
(230114, '4cu4A01', NULL, NULL, 141, NULL, NULL, 229486),
(230115, '3cslA01', NULL, NULL, 128, NULL, NULL, 229486),
(230116, '3efmA01', NULL, NULL, 103, NULL, NULL, 229486),
(230117, '2iahA02', NULL, NULL, 134, NULL, NULL, 229486),
(230118, '5necB01', NULL, NULL, 130, NULL, NULL, 229486),
(230119, '5fokB01', NULL, NULL, 130, NULL, NULL, 229486),
(230120, '4rdrA01', NULL, NULL, 124, NULL, NULL, 229486),
(230121, '1xkhA01', NULL, NULL, 104, NULL, NULL, 229486),
(230122, '3v8xA01', NULL, NULL, 132, NULL, NULL, 229486),
(230123, '3fhhA01', NULL, NULL, 124, NULL, NULL, 229486),
(230124, '1nqeA01', NULL, NULL, 124, NULL, NULL, 229486),
(230125, '1kmoA01', NULL, NULL, 128, NULL, NULL, 229486),
(230126, '1xkwA01', NULL, NULL, 100, NULL, NULL, 229486),
(230127, '3qlbA01', NULL, NULL, 135, NULL, NULL, 229486),
(230128, '4bs9A01', NULL, NULL, 97, NULL, NULL, 229487),
(230129, '5dmdA00', NULL, NULL, 151, NULL, NULL, 229488),
(230130, '2aj7B00', NULL, NULL, 163, NULL, NULL, 229488),
(230131, '1y9bB02', NULL, NULL, 41, NULL, NULL, 229489),
(230132, '3kxyT00', NULL, NULL, 66, NULL, NULL, 229490),
(230133, '1vszR00', NULL, NULL, 54, NULL, NULL, 229491),
(230134, '4l4hA03', NULL, NULL, 139, NULL, NULL, 229492),
(230135, '4i2sA03', NULL, NULL, 143, NULL, NULL, 229492),
(230136, '1n4kA02', NULL, NULL, 165, NULL, NULL, 229492),
(230137, '1i94M01', NULL, NULL, 51, NULL, NULL, 229493),
(230138, '3twlA02', NULL, NULL, 142, NULL, NULL, 229493),
(230139, '3vk8A02', NULL, NULL, 158, NULL, NULL, 229493),
(230140, '5mmjm01', NULL, NULL, 69, NULL, NULL, 229493),
(230141, '5xyiS01', NULL, NULL, 82, NULL, NULL, 229493),
(230142, '1ee8A02', NULL, NULL, 138, NULL, NULL, 229493),
(230143, '6fl1A02', NULL, NULL, 139, NULL, NULL, 229493),
(230144, '1k3xA02', NULL, NULL, 136, NULL, NULL, 229493),
(230145, '3doaA02', NULL, NULL, 70, NULL, NULL, 229493),
(230146, '3gpuA02', NULL, NULL, 124, NULL, NULL, 229493),
(230147, '5a2qS01', NULL, NULL, 80, NULL, NULL, 229493),
(230148, '2vqeM01', NULL, NULL, 72, NULL, NULL, 229493),
(230149, '5o5jM01', NULL, NULL, 72, NULL, NULL, 229493),
(230150, '2xzmM01', NULL, NULL, 82, NULL, NULL, 229493),
(230151, '1mu5A02', NULL, NULL, 78, NULL, NULL, 229493),
(230152, '3j7aS01', NULL, NULL, 82, NULL, NULL, 229493),
(230153, '5ituB02', NULL, NULL, 149, NULL, NULL, 229493),
(230154, '2q2eB02', NULL, NULL, 77, NULL, NULL, 229493),
(230155, '3w0fA02', NULL, NULL, 141, NULL, NULL, 229493),
(230156, '5xxuS01', NULL, NULL, 82, NULL, NULL, 229493),
(230157, '4mb7A02', NULL, NULL, 147, NULL, NULL, 229493),
(230158, '3jamS01', NULL, NULL, 82, NULL, NULL, 229493),
(230159, '1k82A02', NULL, NULL, 131, NULL, NULL, 229493),
(230160, '1vs5M01', NULL, NULL, 71, NULL, NULL, 229493),
(230161, '6bekD00', NULL, NULL, 107, NULL, NULL, 229493),
(230162, '1sr8A01', NULL, NULL, 39, NULL, NULL, 229494),
(230163, '4e18B00', NULL, NULL, 59, NULL, NULL, 229495),
(230164, '4ckbA01', NULL, NULL, 183, NULL, NULL, 229496),
(230165, '1kjnA00', NULL, NULL, 157, NULL, NULL, 229497),
(230166, '4a5gA02', NULL, NULL, 144, NULL, NULL, 229498),
(230167, '5aboA02', NULL, NULL, 137, NULL, NULL, 229498),
(230168, '5jhxA02', NULL, NULL, 210, NULL, NULL, 229498),
(230169, '1llpA02', NULL, NULL, 164, NULL, NULL, 229498),
(230170, '3fmuA02', NULL, NULL, 165, NULL, NULL, 229498); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(230171, '2vcnA02', NULL, NULL, 107, NULL, NULL, 229498),
(230172, '4cuoA02', NULL, NULL, 144, NULL, NULL, 229498),
(230173, '3hdlA02', NULL, NULL, 144, NULL, NULL, 229498),
(230174, '2ccaA04', NULL, NULL, 128, NULL, NULL, 229498),
(230175, '5whsA04', NULL, NULL, 124, NULL, NULL, 229498),
(230176, '1apxA02', NULL, NULL, 107, NULL, NULL, 229498),
(230177, '2ccaA02', NULL, NULL, 133, NULL, NULL, 229498),
(230178, '1jdrA02', NULL, NULL, 121, NULL, NULL, 229498),
(230179, '1gwuA02', NULL, NULL, 146, NULL, NULL, 229498),
(230180, '1fhfA02', NULL, NULL, 144, NULL, NULL, 229498),
(230181, '5twtA02', NULL, NULL, 134, NULL, NULL, 229498),
(230182, '4cznA02', NULL, NULL, 176, NULL, NULL, 229498),
(230183, '6a6qA02', NULL, NULL, 164, NULL, NULL, 229498),
(230184, '5whsA02', NULL, NULL, 225, NULL, NULL, 229498),
(230185, '1qgjA02', NULL, NULL, 146, NULL, NULL, 229498),
(230186, '1bgpA02', NULL, NULL, 136, NULL, NULL, 229498),
(230187, '5aogA02', NULL, NULL, 136, NULL, NULL, 229498),
(230188, '1ub2A04', NULL, NULL, 122, NULL, NULL, 229498),
(230189, '4bm1A02', NULL, NULL, 163, NULL, NULL, 229498),
(230190, '1iynA02', NULL, NULL, 124, NULL, NULL, 229498),
(230191, '1u2kA02', NULL, NULL, 128, NULL, NULL, 229498),
(230192, '1schA02', NULL, NULL, 135, NULL, NULL, 229498),
(230193, '1pa2A02', NULL, NULL, 144, NULL, NULL, 229498),
(230194, '1qpaA02', NULL, NULL, 165, NULL, NULL, 229498),
(230195, '2e39A02', NULL, NULL, 163, NULL, NULL, 229498),
(230196, '3m5qA02', NULL, NULL, 172, NULL, NULL, 229498),
(230197, '5sxwA04', NULL, NULL, 124, NULL, NULL, 229498),
(230198, '3wxoA02', NULL, NULL, 207, NULL, NULL, 229498),
(230199, '3q3uA02', NULL, NULL, 164, NULL, NULL, 229498),
(230200, '3wxoA04', NULL, NULL, 122, NULL, NULL, 229498),
(230201, '4bllA02', NULL, NULL, 153, NULL, NULL, 229498),
(230202, '5al9A02', NULL, NULL, 122, NULL, NULL, 229498),
(230203, '3vliA04', NULL, NULL, 129, NULL, NULL, 229498),
(230204, '5jhxA04', NULL, NULL, 124, NULL, NULL, 229498),
(230205, '3vlmB02', NULL, NULL, 203, NULL, NULL, 229498),
(230206, '4uscA02', NULL, NULL, 144, NULL, NULL, 229498),
(230207, '3e2oA02', NULL, NULL, 121, NULL, NULL, 229498),
(230208, '3vliA02', NULL, NULL, 134, NULL, NULL, 229498),
(230209, '5sxwA02', NULL, NULL, 205, NULL, NULL, 229498),
(230210, '1l8dA00', NULL, NULL, 112, NULL, NULL, 229499),
(230211, '1pjqA03', NULL, NULL, 65, NULL, NULL, 229500),
(230212, '6a02A02', NULL, NULL, 71, NULL, NULL, 229501),
(230213, '3dzaA02', NULL, NULL, 65, NULL, NULL, 229501),
(230214, '4dwfA00', NULL, NULL, 90, NULL, NULL, 229502),
(230215, '2gbrA00', NULL, NULL, 81, NULL, NULL, 229502),
(230216, '2v3sA00', NULL, NULL, 96, NULL, NULL, 229502),
(230217, '1j8cA00', NULL, NULL, 103, NULL, NULL, 229502),
(230218, '2byeA01', NULL, NULL, 101, NULL, NULL, 229502),
(230219, '5chwA02', NULL, NULL, 80, NULL, NULL, 229502),
(230220, '3v62D00', NULL, NULL, 84, NULL, NULL, 229502),
(230221, '5chwA01', NULL, NULL, 75, NULL, NULL, 229502),
(230222, '3m95A00', NULL, NULL, 125, NULL, NULL, 229502),
(230223, '4dbgA00', NULL, NULL, 86, NULL, NULL, 229502),
(230224, '2bkfA01', NULL, NULL, 83, NULL, NULL, 229502),
(230225, '1se9A00', NULL, NULL, 110, NULL, NULL, 229502),
(230226, '2lgxA00', NULL, NULL, 112, NULL, NULL, 229502),
(230227, '3h6nA00', NULL, NULL, 105, NULL, NULL, 229502),
(230228, '1h4rA01', NULL, NULL, 78, NULL, NULL, 229502),
(230229, '1yqbA01', NULL, NULL, 71, NULL, NULL, 229502),
(230230, '3hk0A01', NULL, NULL, 93, NULL, NULL, 229502),
(230231, '4bfrA01', NULL, NULL, 186, NULL, NULL, 229502),
(230232, '2mrpA00', NULL, NULL, 94, NULL, NULL, 229502),
(230233, '2mp2B00', NULL, NULL, 90, NULL, NULL, 229502),
(230234, '5d94A00', NULL, NULL, 130, NULL, NULL, 229502),
(230235, '5ia8A00', NULL, NULL, 97, NULL, NULL, 229502),
(230236, '5azfA00', NULL, NULL, 119, NULL, NULL, 229502),
(230237, '4npnA00', NULL, NULL, 78, NULL, NULL, 229502),
(230238, '2wxfA02', NULL, NULL, 136, NULL, NULL, 229502),
(230239, '1wghA01', NULL, NULL, 83, NULL, NULL, 229502),
(230240, '2mlbA00', NULL, NULL, 79, NULL, NULL, 229502),
(230241, '3hhmA01', NULL, NULL, 132, NULL, NULL, 229502);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(230242, '5e6oC00', NULL, NULL, 118, NULL, NULL, 229502),
(230243, '3hhmA03', NULL, NULL, 141, NULL, NULL, 229502),
(230244, '6aafA00', NULL, NULL, 119, NULL, NULL, 229502),
(230245, '4i6pA00', NULL, NULL, 88, NULL, NULL, 229502),
(230246, '1wgyA01', NULL, NULL, 76, NULL, NULL, 229502),
(230247, '4mjsA00', NULL, NULL, 91, NULL, NULL, 229502),
(230248, '1wz3A01', NULL, NULL, 85, NULL, NULL, 229502),
(230249, '5x3pA00', NULL, NULL, 83, NULL, NULL, 229502),
(230250, '2lxaA00', NULL, NULL, 87, NULL, NULL, 229502),
(230251, '1wxaA00', NULL, NULL, 116, NULL, NULL, 229502),
(230252, '2dzmA01', NULL, NULL, 72, NULL, NULL, 229502),
(230253, '2jvcA00', NULL, NULL, 82, NULL, NULL, 229502),
(230254, '2cs4A00', NULL, NULL, 95, NULL, NULL, 229502),
(230255, '2bpsA00', NULL, NULL, 81, NULL, NULL, 229502),
(230256, '1rlfA00', NULL, NULL, 90, NULL, NULL, 229502),
(230257, '2kqsA00', NULL, NULL, 99, NULL, NULL, 229502),
(230258, '1wh3A01', NULL, NULL, 71, NULL, NULL, 229502),
(230259, '3wamA00', NULL, NULL, 120, NULL, NULL, 229502),
(230260, '4zynB01', NULL, NULL, 81, NULL, NULL, 229502),
(230261, '1t0yA00', NULL, NULL, 92, NULL, NULL, 229502),
(230262, '3rd2A00', NULL, NULL, 82, NULL, NULL, 229502),
(230263, '2lwpA00', NULL, NULL, 97, NULL, NULL, 229502),
(230264, '1wiaA01', NULL, NULL, 70, NULL, NULL, 229502),
(230265, '6h77Q00', NULL, NULL, 78, NULL, NULL, 229502),
(230266, '2zpyA01', NULL, NULL, 79, NULL, NULL, 229502),
(230267, '4kikB02', NULL, NULL, 89, NULL, NULL, 229502),
(230268, '2pjhA00', NULL, NULL, 80, NULL, NULL, 229502),
(230269, '4bfrB02', NULL, NULL, 140, NULL, NULL, 229502),
(230270, '4gmvA01', NULL, NULL, 118, NULL, NULL, 229502),
(230271, '4b6wA00', NULL, NULL, 86, NULL, NULL, 229502),
(230272, '1ttnA01', NULL, NULL, 74, NULL, NULL, 229502),
(230273, '6ffaB00', NULL, NULL, 78, NULL, NULL, 229502),
(230274, '6elmA00', NULL, NULL, 98, NULL, NULL, 229502),
(230275, '4kv2A00', NULL, NULL, 92, NULL, NULL, 229502),
(230276, '4gn1A01', NULL, NULL, 92, NULL, NULL, 229502),
(230277, '2wyqA00', NULL, NULL, 85, NULL, NULL, 229502),
(230278, '2c7hA00', NULL, NULL, 86, NULL, NULL, 229502),
(230279, '2k25A00', NULL, NULL, 103, NULL, NULL, 229502),
(230280, '5yecD00', NULL, NULL, 119, NULL, NULL, 229502),
(230281, '1v86A00', NULL, NULL, 95, NULL, NULL, 229502),
(230282, '4melA02', NULL, NULL, 94, NULL, NULL, 229502),
(230283, '4tq1A01', NULL, NULL, 113, NULL, NULL, 229502),
(230284, '4ny0A01', NULL, NULL, 99, NULL, NULL, 229502),
(230285, '4efoA00', NULL, NULL, 94, NULL, NULL, 229502),
(230286, '6fj7A00', NULL, NULL, 80, NULL, NULL, 229502),
(230287, '3w1sC00', NULL, NULL, 91, NULL, NULL, 229502),
(230288, '4i6lB00', NULL, NULL, 76, NULL, NULL, 229502),
(230289, '1wxvA01', NULL, NULL, 76, NULL, NULL, 229502),
(230290, '1oeyA00', NULL, NULL, 83, NULL, NULL, 229502),
(230291, '2kmcA00', NULL, NULL, 102, NULL, NULL, 229502),
(230292, '1nddB00', NULL, NULL, 76, NULL, NULL, 229502),
(230293, '2c5lC01', NULL, NULL, 107, NULL, NULL, 229502),
(230294, '3kuzB00', NULL, NULL, 109, NULL, NULL, 229502),
(230295, '5d2mE00', NULL, NULL, 83, NULL, NULL, 229502),
(230296, '3d32B00', NULL, NULL, 119, NULL, NULL, 229502),
(230297, '2kd0A01', NULL, NULL, 71, NULL, NULL, 229502),
(230298, '2z0dB00', NULL, NULL, 125, NULL, NULL, 229502),
(230299, '3pluA00', NULL, NULL, 74, NULL, NULL, 229502),
(230300, '1zw7A00', NULL, NULL, 82, NULL, NULL, 229502),
(230301, '4f7zA05', NULL, NULL, 115, NULL, NULL, 229502),
(230302, '1wggA01', NULL, NULL, 73, NULL, NULL, 229502),
(230303, '1raxA00', NULL, NULL, 93, NULL, NULL, 229502),
(230304, '4icvA00', NULL, NULL, 85, NULL, NULL, 229502),
(230305, '2kzrA00', NULL, NULL, 86, NULL, NULL, 229502),
(230306, '2bwfA00', NULL, NULL, 77, NULL, NULL, 229502),
(230307, '3ai5A02', NULL, NULL, 76, NULL, NULL, 229502),
(230308, '5ms5B00', NULL, NULL, 137, NULL, NULL, 229502),
(230309, '1u4aA00', NULL, NULL, 87, NULL, NULL, 229502),
(230310, '3v6cB00', NULL, NULL, 91, NULL, NULL, 229502),
(230311, '4hdoA01', NULL, NULL, 101, NULL, NULL, 229502),
(230312, '4k81A01', NULL, NULL, 96, NULL, NULL, 229502);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(230313, '3au4A02', NULL, NULL, 94, NULL, NULL, 229502),
(230314, '6d2kA01', NULL, NULL, 86, NULL, NULL, 229502),
(230315, '6ibeA01', NULL, NULL, 83, NULL, NULL, 229502),
(230316, '5dptA00', NULL, NULL, 132, NULL, NULL, 229502),
(230317, '2lrwA00', NULL, NULL, 84, NULL, NULL, 229502),
(230318, '1c1yB00', NULL, NULL, 77, NULL, NULL, 229502),
(230319, '2zeqA00', NULL, NULL, 78, NULL, NULL, 229502),
(230320, '2rexA00', NULL, NULL, 121, NULL, NULL, 229502),
(230321, '1c3tA00', NULL, NULL, 76, NULL, NULL, 229502),
(230322, '2kxjA00', NULL, NULL, 90, NULL, NULL, 229502),
(230323, '2kmaA02', NULL, NULL, 83, NULL, NULL, 229502),
(230324, '3vtvA00', NULL, NULL, 134, NULL, NULL, 229502),
(230325, '3jyuA02', NULL, NULL, 93, NULL, NULL, 229502),
(230326, '4hjkA00', NULL, NULL, 77, NULL, NULL, 229502),
(230327, '1v2yA00', NULL, NULL, 105, NULL, NULL, 229502),
(230328, '1wmhA00', NULL, NULL, 89, NULL, NULL, 229502),
(230329, '2l7rA00', NULL, NULL, 74, NULL, NULL, 229502),
(230330, '4nnjB00', NULL, NULL, 79, NULL, NULL, 229502),
(230331, '2kfjA00', NULL, NULL, 87, NULL, NULL, 229502),
(230332, '3pvlA02', NULL, NULL, 96, NULL, NULL, 229502),
(230333, '1wjnA00', NULL, NULL, 97, NULL, NULL, 229502),
(230334, '4gu2A00', NULL, NULL, 80, NULL, NULL, 229502),
(230335, '4hk2D00', NULL, NULL, 78, NULL, NULL, 229502),
(230336, '1euvB00', NULL, NULL, 86, NULL, NULL, 229502),
(230337, '3a4rA00', NULL, NULL, 79, NULL, NULL, 229502),
(230338, '2bkrB00', NULL, NULL, 77, NULL, NULL, 229502),
(230339, '3ddcB00', NULL, NULL, 163, NULL, NULL, 229502),
(230340, '2mx2A00', NULL, NULL, 81, NULL, NULL, 229502),
(230341, '2gowA01', NULL, NULL, 105, NULL, NULL, 229502),
(230342, '5e6pA02', NULL, NULL, 135, NULL, NULL, 229502),
(230343, '3gznI00', NULL, NULL, 82, NULL, NULL, 229502),
(230344, '2kanA01', NULL, NULL, 73, NULL, NULL, 229502),
(230345, '2al3A00', NULL, NULL, 90, NULL, NULL, 229502),
(230346, '2kx3A00', NULL, NULL, 81, NULL, NULL, 229502),
(230347, '2m0xA00', NULL, NULL, 78, NULL, NULL, 229502),
(230348, '3vqiD03', NULL, NULL, 77, NULL, NULL, 229502),
(230349, '3vtuA00', NULL, NULL, 123, NULL, NULL, 229502),
(230350, '3rytB02', NULL, NULL, 126, NULL, NULL, 229502),
(230351, '2gbmA00', NULL, NULL, 84, NULL, NULL, 229502),
(230352, '6cb0B01', NULL, NULL, 100, NULL, NULL, 229502),
(230353, '4nj6B00', NULL, NULL, 95, NULL, NULL, 229502),
(230354, '2n7eA00', NULL, NULL, 86, NULL, NULL, 229502),
(230355, '2r2qA00', NULL, NULL, 110, NULL, NULL, 229502),
(230356, '2kdbA00', NULL, NULL, 77, NULL, NULL, 229502),
(230357, '1oqyA01', NULL, NULL, 84, NULL, NULL, 229502),
(230358, '4yl8A01', NULL, NULL, 90, NULL, NULL, 229502),
(230359, '2k1fA00', NULL, NULL, 88, NULL, NULL, 229502),
(230360, '3mtnB00', NULL, NULL, 85, NULL, NULL, 229502),
(230361, '6d2qA01', NULL, NULL, 83, NULL, NULL, 229502),
(230362, '3kh0A00', NULL, NULL, 118, NULL, NULL, 229502),
(230363, '1sifA00', NULL, NULL, 88, NULL, NULL, 229502),
(230364, '3hizA01', NULL, NULL, 137, NULL, NULL, 229502),
(230365, '3t9lA02', NULL, NULL, 98, NULL, NULL, 229502),
(230366, '5xacC00', NULL, NULL, 130, NULL, NULL, 229502),
(230367, '4pyuA00', NULL, NULL, 76, NULL, NULL, 229502),
(230368, '2l76A00', NULL, NULL, 95, NULL, NULL, 229502),
(230369, '4e71A00', NULL, NULL, 111, NULL, NULL, 229502),
(230370, '1zkhA00', NULL, NULL, 86, NULL, NULL, 229502),
(230371, '1wmhB00', NULL, NULL, 86, NULL, NULL, 229502),
(230372, '4a3pA02', NULL, NULL, 91, NULL, NULL, 229502),
(230373, '4eoyB00', NULL, NULL, 128, NULL, NULL, 229502),
(230374, '3n3kB00', NULL, NULL, 85, NULL, NULL, 229502),
(230375, '1wj4A01', NULL, NULL, 83, NULL, NULL, 229502),
(230376, '1uh6A00', NULL, NULL, 100, NULL, NULL, 229502),
(230377, '3rt3B01', NULL, NULL, 77, NULL, NULL, 229502),
(230378, '5dxtA01', NULL, NULL, 220, NULL, NULL, 229502),
(230379, '2cr5A01', NULL, NULL, 80, NULL, NULL, 229502),
(230380, '1v9jA00', NULL, NULL, 113, NULL, NULL, 229502),
(230381, '4chkB00', NULL, NULL, 91, NULL, NULL, 229502),
(230382, '1wm3A00', NULL, NULL, 72, NULL, NULL, 229502),
(230383, '4kvgB01', NULL, NULL, 90, NULL, NULL, 229502);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(230384, '2gbkC00', NULL, NULL, 83, NULL, NULL, 229502),
(230385, '2n1vA00', NULL, NULL, 111, NULL, NULL, 229502),
(230386, '2uwqA00', NULL, NULL, 86, NULL, NULL, 229502),
(230387, '2dzjA00', NULL, NULL, 88, NULL, NULL, 229502),
(230388, '2lruA00', NULL, NULL, 98, NULL, NULL, 229502),
(230389, '1rrbA00', NULL, NULL, 89, NULL, NULL, 229502),
(230390, '1wjuA00', NULL, NULL, 100, NULL, NULL, 229502),
(230391, '1ef5A00', NULL, NULL, 103, NULL, NULL, 229502),
(230392, '1lfdA00', NULL, NULL, 87, NULL, NULL, 229502),
(230393, '2dajA00', NULL, NULL, 91, NULL, NULL, 229502),
(230394, '1v5oA00', NULL, NULL, 102, NULL, NULL, 229502),
(230395, '2k8hA01', NULL, NULL, 84, NULL, NULL, 229502),
(230396, '2ylmA03', NULL, NULL, 97, NULL, NULL, 229502),
(230397, '1wx9A00', NULL, NULL, 86, NULL, NULL, 229502),
(230398, '2ylmA02', NULL, NULL, 116, NULL, NULL, 229502),
(230399, '1wf9A00', NULL, NULL, 107, NULL, NULL, 229502),
(230400, '4eutA03', NULL, NULL, 87, NULL, NULL, 229502),
(230401, '1oeyL00', NULL, NULL, 107, NULL, NULL, 229502),
(230402, '6d21A01', NULL, NULL, 82, NULL, NULL, 229502),
(230403, '2n7dA00', NULL, NULL, 97, NULL, NULL, 229502),
(230404, '1wywB00', NULL, NULL, 79, NULL, NULL, 229502),
(230405, '2pphA01', NULL, NULL, 68, NULL, NULL, 229502),
(230406, '4g50A01', NULL, NULL, 77, NULL, NULL, 229502),
(230407, '4kdiD00', NULL, NULL, 90, NULL, NULL, 229502),
(230408, '3v62A00', NULL, NULL, 84, NULL, NULL, 229502),
(230409, '4yknA03', NULL, NULL, 95, NULL, NULL, 229502),
(230410, '4gxbA01', NULL, NULL, 100, NULL, NULL, 229502),
(230411, '1wx8A00', NULL, NULL, 96, NULL, NULL, 229502),
(230412, '2nptB01', NULL, NULL, 81, NULL, NULL, 229502),
(230413, '2byvE05', NULL, NULL, 79, NULL, NULL, 229502),
(230414, '2kk8A01', NULL, NULL, 73, NULL, NULL, 229502),
(230415, '1bt0A00', NULL, NULL, 76, NULL, NULL, 229502),
(230416, '4v0iA01', NULL, NULL, 187, NULL, NULL, 229502),
(230417, '5fr6A00', NULL, NULL, 115, NULL, NULL, 229502),
(230418, '2m1mA00', NULL, NULL, 107, NULL, NULL, 229502),
(230419, '5x0wF00', NULL, NULL, 108, NULL, NULL, 229502),
(230420, '4a20A00', NULL, NULL, 81, NULL, NULL, 229502),
(230421, '1i42A00', NULL, NULL, 89, NULL, NULL, 229502),
(230422, '5o2cA03', NULL, NULL, 94, NULL, NULL, 229502),
(230423, '2dybA03', NULL, NULL, 108, NULL, NULL, 229502),
(230424, '4eewB00', NULL, NULL, 88, NULL, NULL, 229502),
(230425, '1wfyA01', NULL, NULL, 72, NULL, NULL, 229502),
(230426, '1we7A00', NULL, NULL, 115, NULL, NULL, 229502),
(230427, '2m4nA00', NULL, NULL, 108, NULL, NULL, 229502),
(230428, '4hpmD00', NULL, NULL, 93, NULL, NULL, 229502),
(230429, '5khqA00', NULL, NULL, 138, NULL, NULL, 229502),
(230430, '3cf6E04', NULL, NULL, 94, NULL, NULL, 229502),
(230431, '1uelA00', NULL, NULL, 95, NULL, NULL, 229502),
(230432, '5c1zA01', NULL, NULL, 76, NULL, NULL, 229502),
(230433, '4ekuA01', NULL, NULL, 118, NULL, NULL, 229502),
(230434, '3vvwB00', NULL, NULL, 128, NULL, NULL, 229502),
(230435, '1wxsA00', NULL, NULL, 90, NULL, NULL, 229502),
(230436, '2d07B00', NULL, NULL, 93, NULL, NULL, 229502),
(230437, '4ii2B00', NULL, NULL, 83, NULL, NULL, 229502),
(230438, '2gbjB00', NULL, NULL, 84, NULL, NULL, 229502),
(230439, '5v6rA02', NULL, NULL, 146, NULL, NULL, 229502),
(230440, '3qa8G02', NULL, NULL, 86, NULL, NULL, 229502),
(230441, '2kjrA01', NULL, NULL, 80, NULL, NULL, 229502),
(230442, '2dzkA01', NULL, NULL, 77, NULL, NULL, 229502),
(230443, '5v4kB00', NULL, NULL, 132, NULL, NULL, 229502),
(230444, '1we6A00', NULL, NULL, 111, NULL, NULL, 229502),
(230445, '4zdvA00', NULL, NULL, 132, NULL, NULL, 229502),
(230446, '3ixsI00', NULL, NULL, 111, NULL, NULL, 229502),
(230447, '2dyoA03', NULL, NULL, 88, NULL, NULL, 229502),
(230448, '4hwiB01', NULL, NULL, 72, NULL, NULL, 229502),
(230449, '1eo6A00', NULL, NULL, 117, NULL, NULL, 229502),
(230450, '5l83A00', NULL, NULL, 112, NULL, NULL, 229502),
(230451, '2nptA01', NULL, NULL, 92, NULL, NULL, 229502),
(230452, '2ktrB00', NULL, NULL, 100, NULL, NULL, 229502),
(230453, '4x57D00', NULL, NULL, 92, NULL, NULL, 229502),
(230454, '2r2oA00', NULL, NULL, 117, NULL, NULL, 229502);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(230455, '1wgrA01', NULL, NULL, 82, NULL, NULL, 229502),
(230456, '4nawA00', NULL, NULL, 91, NULL, NULL, 229502),
(230457, '3qq8B00', NULL, NULL, 85, NULL, NULL, 229502),
(230458, '4mjsX00', NULL, NULL, 104, NULL, NULL, 229502),
(230459, '3q3jA00', NULL, NULL, 112, NULL, NULL, 229502),
(230460, '3ec8A00', NULL, NULL, 166, NULL, NULL, 229502),
(230461, '4m8mA02', NULL, NULL, 152, NULL, NULL, 229502),
(230462, '5dpsC00', NULL, NULL, 132, NULL, NULL, 229502),
(230463, '2fazA00', NULL, NULL, 78, NULL, NULL, 229502),
(230464, '3walA00', NULL, NULL, 125, NULL, NULL, 229502),
(230465, '1wgdA00', NULL, NULL, 93, NULL, NULL, 229502),
(230466, '1x1mA00', NULL, NULL, 107, NULL, NULL, 229502),
(230467, '1wxmA01', NULL, NULL, 71, NULL, NULL, 229502),
(230468, '2v1yA00', NULL, NULL, 92, NULL, NULL, 229502),
(230469, '3qx1A00', NULL, NULL, 84, NULL, NULL, 229502),
(230470, '4wjqA00', NULL, NULL, 83, NULL, NULL, 229502),
(230471, '2dafA01', NULL, NULL, 76, NULL, NULL, 229502),
(230472, '3shqA01', NULL, NULL, 81, NULL, NULL, 229502),
(230473, '1ud7A00', NULL, NULL, 76, NULL, NULL, 229502),
(230474, '2nbvB00', NULL, NULL, 78, NULL, NULL, 229502),
(230475, '3goeA00', NULL, NULL, 82, NULL, NULL, 229502),
(230476, '3a9jB00', NULL, NULL, 77, NULL, NULL, 229502),
(230477, '5jh5C00', NULL, NULL, 109, NULL, NULL, 229502),
(230478, '2c60A01', NULL, NULL, 81, NULL, NULL, 229502),
(230479, '3m62B00', NULL, NULL, 74, NULL, NULL, 229502),
(230480, '4ic7E00', NULL, NULL, 126, NULL, NULL, 229502),
(230481, '3rulA00', NULL, NULL, 79, NULL, NULL, 229502),
(230482, '2kdiA00', NULL, NULL, 114, NULL, NULL, 229502),
(230483, '1ip9A00', NULL, NULL, 85, NULL, NULL, 229502),
(230484, '2dziA00', NULL, NULL, 81, NULL, NULL, 229502),
(230485, '4memA02', NULL, NULL, 100, NULL, NULL, 229502),
(230486, '3ivfA01', NULL, NULL, 84, NULL, NULL, 229502),
(230487, '3ivfA02', NULL, NULL, 66, NULL, NULL, 229502),
(230488, '3h9dA00', NULL, NULL, 119, NULL, NULL, 229502),
(230489, '2mbeA00', NULL, NULL, 75, NULL, NULL, 229502),
(230490, '3qijA01', NULL, NULL, 79, NULL, NULL, 229502),
(230491, '1yj1C00', NULL, NULL, 76, NULL, NULL, 229502),
(230492, '4e74A00', NULL, NULL, 117, NULL, NULL, 229502),
(230493, '3ig3A02', NULL, NULL, 114, NULL, NULL, 229502),
(230494, '3kucB00', NULL, NULL, 81, NULL, NULL, 229502),
(230495, '4wwoA01', NULL, NULL, 178, NULL, NULL, 229502),
(230496, '2juoA00', NULL, NULL, 89, NULL, NULL, 229502),
(230497, '5f3yA02', NULL, NULL, 97, NULL, NULL, 229502),
(230498, '2n9pC00', NULL, NULL, 100, NULL, NULL, 229502),
(230499, '1s3sH00', NULL, NULL, 127, NULL, NULL, 229502),
(230500, '2fnjB00', NULL, NULL, 98, NULL, NULL, 229502),
(230501, '2uyzB00', NULL, NULL, 79, NULL, NULL, 229502),
(230502, '4rm8A01', NULL, NULL, 87, NULL, NULL, 229502),
(230503, '1k8rB00', NULL, NULL, 110, NULL, NULL, 229502),
(230504, '2kj6A01', NULL, NULL, 83, NULL, NULL, 229502),
(230505, '4waaB00', NULL, NULL, 134, NULL, NULL, 229502),
(230506, '3x0wB00', NULL, NULL, 134, NULL, NULL, 229502),
(230507, '3w1yB00', NULL, NULL, 137, NULL, NULL, 229502),
(230508, '2dhzA01', NULL, NULL, 85, NULL, NULL, 229502),
(230509, '1v5tA00', NULL, NULL, 90, NULL, NULL, 229502),
(230510, '4jlcA03', NULL, NULL, 80, NULL, NULL, 229502),
(230511, '4n9fe00', NULL, NULL, 79, NULL, NULL, 229502),
(230512, '1tz1A00', NULL, NULL, 80, NULL, NULL, 229502),
(230513, '1e7uA01', NULL, NULL, 178, NULL, NULL, 229502),
(230514, '3ny5B01', NULL, NULL, 71, NULL, NULL, 229502),
(230515, '5xdaG00', NULL, NULL, 84, NULL, NULL, 229502),
(230516, '1gjzA00', NULL, NULL, 53, NULL, NULL, 229502),
(230517, '1wy8A00', NULL, NULL, 89, NULL, NULL, 229502),
(230518, '2i1jA01', NULL, NULL, 79, NULL, NULL, 229502),
(230519, '1v6eA01', NULL, NULL, 80, NULL, NULL, 229502),
(230520, '5yxiA00', NULL, NULL, 79, NULL, NULL, 229502),
(230521, '4lcdE00', NULL, NULL, 83, NULL, NULL, 229502),
(230522, '5dprA00', NULL, NULL, 136, NULL, NULL, 229502),
(230523, '2klcA00', NULL, NULL, 79, NULL, NULL, 229502),
(230524, '3vx8A02', NULL, NULL, 173, NULL, NULL, 229503),
(230525, '3v5wA01', NULL, NULL, 111, NULL, NULL, 229504);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(230526, '3nynA02', NULL, NULL, 92, NULL, NULL, 229504),
(230527, '4ag6A02', NULL, NULL, 121, NULL, NULL, 229505),
(230528, '1aooA00', NULL, NULL, 40, NULL, NULL, 229506),
(230529, '1aqsA00', NULL, NULL, 53, NULL, NULL, 229506),
(230530, '3vkgA15', NULL, NULL, 94, NULL, NULL, 229507),
(230531, '2nn4A00', NULL, NULL, 72, NULL, NULL, 229508),
(230532, '1q8dA00', NULL, NULL, 108, NULL, NULL, 229509),
(230533, '3u4qA02', NULL, NULL, 150, NULL, NULL, 229510),
(230534, '4illB01', NULL, NULL, 121, NULL, NULL, 229511),
(230535, '3e35A01', NULL, NULL, 232, NULL, NULL, 229512),
(230536, '2wamC01', NULL, NULL, 232, NULL, NULL, 229512),
(230537, '3mnfA00', NULL, NULL, 250, NULL, NULL, 229512),
(230538, '3vr0A00', NULL, NULL, 244, NULL, NULL, 229512),
(230539, '4g4sP00', NULL, NULL, 213, NULL, NULL, 229512),
(230540, '5un0100', NULL, NULL, 251, NULL, NULL, 229512),
(230541, '3gaaB00', NULL, NULL, 252, NULL, NULL, 229512),
(230542, '3wz2B00', NULL, NULL, 245, NULL, NULL, 229512),
(230543, '2p90A01', NULL, NULL, 229, NULL, NULL, 229512),
(230544, '3eslA01', NULL, NULL, 77, NULL, NULL, 229513),
(230545, '2ymsD00', NULL, NULL, 74, NULL, NULL, 229514),
(230546, '2ymsB00', NULL, NULL, 74, NULL, NULL, 229514),
(230547, '3f8tA01', NULL, NULL, 84, NULL, NULL, 229515),
(230548, '1wlfA02', NULL, NULL, 82, NULL, NULL, 229516),
(230549, '2jv2A00', NULL, NULL, 83, NULL, NULL, 229516),
(230550, '4rv0G02', NULL, NULL, 82, NULL, NULL, 229516),
(230551, '3qwzA02', NULL, NULL, 101, NULL, NULL, 229516),
(230552, '2yujA02', NULL, NULL, 75, NULL, NULL, 229516),
(230553, '5b6cA02', NULL, NULL, 85, NULL, NULL, 229516),
(230554, '1zc1A02', NULL, NULL, 77, NULL, NULL, 229516),
(230555, '1cz4A02', NULL, NULL, 81, NULL, NULL, 229516),
(230556, '2m3xA01', NULL, NULL, 82, NULL, NULL, 229516),
(230557, '1qcsA02', NULL, NULL, 112, NULL, NULL, 229516),
(230558, '1cr5B02', NULL, NULL, 104, NULL, NULL, 229516),
(230559, '5uz0A03', NULL, NULL, 168, NULL, NULL, 229517),
(230560, '5uz0A02', NULL, NULL, 147, NULL, NULL, 229517),
(230561, '4ehiB03', NULL, NULL, 131, NULL, NULL, 229517),
(230562, '1g8mB02', NULL, NULL, 166, NULL, NULL, 229517),
(230563, '4ehiA03', NULL, NULL, 139, NULL, NULL, 229517),
(230564, '4ehiB02', NULL, NULL, 124, NULL, NULL, 229517),
(230565, '4ehiA02', NULL, NULL, 156, NULL, NULL, 229517),
(230566, '1zczA03', NULL, NULL, 127, NULL, NULL, 229517),
(230567, '1thzA03', NULL, NULL, 147, NULL, NULL, 229517),
(230568, '3zzmA03', NULL, NULL, 130, NULL, NULL, 229517),
(230569, '1zczA02', NULL, NULL, 117, NULL, NULL, 229517),
(230570, '3zzmA02', NULL, NULL, 121, NULL, NULL, 229517),
(230571, '1gw3A00', NULL, NULL, 46, NULL, NULL, 229518),
(230572, '3r2pA02', NULL, NULL, 46, NULL, NULL, 229518),
(230573, '1ygtA01', NULL, NULL, 100, NULL, NULL, 229519),
(230574, '1xdxA01', NULL, NULL, 100, NULL, NULL, 229519),
(230575, '3i9v700', NULL, NULL, 129, NULL, NULL, 229520),
(230576, '3vdpA04', NULL, NULL, 25, NULL, NULL, 229521),
(230577, '1vddC04', NULL, NULL, 29, NULL, NULL, 229521),
(230578, '1yq5A00', NULL, NULL, 144, NULL, NULL, 229522),
(230579, '3fy6D01', NULL, NULL, 116, NULL, NULL, 229523),
(230580, '3fbqA01', NULL, NULL, 147, NULL, NULL, 229524),
(230581, '4u9nA00', NULL, NULL, 178, NULL, NULL, 229525),
(230582, '1ytfC00', NULL, NULL, 46, NULL, NULL, 229526),
(230583, '1nvpC00', NULL, NULL, 47, NULL, NULL, 229526),
(230584, '1nvpD02', NULL, NULL, 56, NULL, NULL, 229526),
(230585, '1nh2D02', NULL, NULL, 61, NULL, NULL, 229526),
(230586, '1nh2C00', NULL, NULL, 59, NULL, NULL, 229526),
(230587, '5dyfA02', NULL, NULL, 85, NULL, NULL, 229527),
(230588, '2gtqA02', NULL, NULL, 85, NULL, NULL, 229527),
(230589, '4qpeA02', NULL, NULL, 85, NULL, NULL, 229527),
(230590, '4pu2A02', NULL, NULL, 85, NULL, NULL, 229527),
(230591, '4pw4A02', NULL, NULL, 85, NULL, NULL, 229527),
(230592, '5dllA02', NULL, NULL, 85, NULL, NULL, 229527),
(230593, '4qmeA02', NULL, NULL, 85, NULL, NULL, 229527),
(230594, '4qirA02', NULL, NULL, 85, NULL, NULL, 229527),
(230595, '5zi7A02', NULL, NULL, 85, NULL, NULL, 229527),
(230596, '2xq0A02', NULL, NULL, 98, NULL, NULL, 229527);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(230597, '3b34A02', NULL, NULL, 85, NULL, NULL, 229527),
(230598, '4pvbA02', NULL, NULL, 85, NULL, NULL, 229527),
(230599, '4quoA02', NULL, NULL, 85, NULL, NULL, 229527),
(230600, '3ciaA02', NULL, NULL, 97, NULL, NULL, 229527),
(230601, '4qhpA02', NULL, NULL, 85, NULL, NULL, 229527),
(230602, '4gaaA02', NULL, NULL, 97, NULL, NULL, 229527),
(230603, '6ea2A02', NULL, NULL, 86, NULL, NULL, 229527),
(230604, '3u9wA02', NULL, NULL, 97, NULL, NULL, 229527),
(230605, '1fm2A00', NULL, NULL, 169, NULL, NULL, 229528),
(230606, '4yfbJ00', NULL, NULL, 178, NULL, NULL, 229528),
(230607, '1cp9A01', NULL, NULL, 147, NULL, NULL, 229528),
(230608, '4e57A02', NULL, NULL, 111, NULL, NULL, 229528),
(230609, '4pemC01', NULL, NULL, 147, NULL, NULL, 229528),
(230610, '4wksA00', NULL, NULL, 165, NULL, NULL, 229528),
(230611, '4hstA01', NULL, NULL, 164, NULL, NULL, 229528),
(230612, '3k3wA01', NULL, NULL, 150, NULL, NULL, 229528),
(230613, '1gk9A01', NULL, NULL, 149, NULL, NULL, 229528),
(230614, '2ju4A00', NULL, NULL, 86, NULL, NULL, 229529),
(230615, '2qgqB01', NULL, NULL, 236, NULL, NULL, 229530),
(230616, '2hgkA01', NULL, NULL, 105, NULL, NULL, 229531),
(230617, '4m70I00', NULL, NULL, 126, NULL, NULL, 229532),
(230618, '3qflA00', NULL, NULL, 115, NULL, NULL, 229532),
(230619, '4uhvA03', NULL, NULL, 63, NULL, NULL, 229533),
(230620, '2kz9A00', NULL, NULL, 69, NULL, NULL, 229534),
(230621, '4g7nA01', NULL, NULL, 122, NULL, NULL, 229535),
(230622, '4n9jA01', NULL, NULL, 120, NULL, NULL, 229535),
(230623, '4nkbA01', NULL, NULL, 114, NULL, NULL, 229535),
(230624, '2qmaA01', NULL, NULL, 99, NULL, NULL, 229536),
(230625, '1qmoE01', NULL, NULL, 84, NULL, NULL, 229537),
(230626, '1vomA05', NULL, NULL, 72, NULL, NULL, 229538),
(230627, '5mmiN01', NULL, NULL, 114, NULL, NULL, 229539),
(230628, '4a17H01', NULL, NULL, 174, NULL, NULL, 229539),
(230629, '3u5eI01', NULL, NULL, 174, NULL, NULL, 229539),
(230630, '3o58J00', NULL, NULL, 221, NULL, NULL, 229539),
(230631, '1jj2H00', NULL, NULL, 167, NULL, NULL, 229539),
(230632, '1wkiA01', NULL, NULL, 109, NULL, NULL, 229539),
(230633, '1vx7Q01', NULL, NULL, 174, NULL, NULL, 229539),
(230634, '6qklF01', NULL, NULL, 174, NULL, NULL, 229539),
(230635, '5v7qM01', NULL, NULL, 116, NULL, NULL, 229539),
(230636, '6hmaK01', NULL, NULL, 115, NULL, NULL, 229539),
(230637, '1vwxI01', NULL, NULL, 173, NULL, NULL, 229539),
(230638, '2pa2A00', NULL, NULL, 151, NULL, NULL, 229539),
(230639, '6qulN01', NULL, NULL, 116, NULL, NULL, 229539),
(230640, '5dm6J01', NULL, NULL, 119, NULL, NULL, 229539),
(230641, '1vw4K00', NULL, NULL, 195, NULL, NULL, 229539),
(230642, '5xymM01', NULL, NULL, 116, NULL, NULL, 229539),
(230643, '1vq8H00', NULL, NULL, 171, NULL, NULL, 229539),
(230644, '3ihvA01', NULL, NULL, 164, NULL, NULL, 229540),
(230645, '4v1av00', NULL, NULL, 131, NULL, NULL, 229541),
(230646, '5oomq00', NULL, NULL, 128, NULL, NULL, 229541),
(230647, '2dgbA00', NULL, NULL, 84, NULL, NULL, 229542),
(230648, '2zw2A00', NULL, NULL, 92, NULL, NULL, 229542),
(230649, '1vq3B00', NULL, NULL, 94, NULL, NULL, 229542),
(230650, '1gtdB00', NULL, NULL, 85, NULL, NULL, 229542),
(230651, '2yx5A00', NULL, NULL, 83, NULL, NULL, 229542),
(230652, '1t4aA00', NULL, NULL, 84, NULL, NULL, 229542),
(230653, '1gtdA00', NULL, NULL, 85, NULL, NULL, 229542),
(230654, '1dgfA03', NULL, NULL, 114, NULL, NULL, 229543),
(230655, '4b7hA03', NULL, NULL, 115, NULL, NULL, 229543),
(230656, '3rgpA03', NULL, NULL, 115, NULL, NULL, 229543),
(230657, '4mt1A03', NULL, NULL, 98, NULL, NULL, 229544),
(230658, '5t0oA03', NULL, NULL, 101, NULL, NULL, 229544),
(230659, '3w9iA03', NULL, NULL, 100, NULL, NULL, 229544),
(230660, '5enqC02', NULL, NULL, 103, NULL, NULL, 229544),
(230661, '3f6yA01', NULL, NULL, 134, NULL, NULL, 229545),
(230662, '3gc6B01', NULL, NULL, 134, NULL, NULL, 229545),
(230663, '1r12A01', NULL, NULL, 119, NULL, NULL, 229545),
(230664, '1isiA01', NULL, NULL, 123, NULL, NULL, 229545),
(230665, '2eg9A01', NULL, NULL, 141, NULL, NULL, 229545),
(230666, '4cmhA01', NULL, NULL, 128, NULL, NULL, 229545),
(230667, '5bnfA01', NULL, NULL, 122, NULL, NULL, 229545);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(230668, '5jrbA01', NULL, NULL, 148, NULL, NULL, 229546),
(230669, '3vsmA02', NULL, NULL, 192, NULL, NULL, 229547),
(230670, '6euaA01', NULL, NULL, 151, NULL, NULL, 229548),
(230671, '1fzcB01', NULL, NULL, 161, NULL, NULL, 229548),
(230672, '4m7hA01', NULL, NULL, 153, NULL, NULL, 229548),
(230673, '2j1gE01', NULL, NULL, 145, NULL, NULL, 229548),
(230674, '1m1jE01', NULL, NULL, 159, NULL, NULL, 229548),
(230675, '1fzdA01', NULL, NULL, 115, NULL, NULL, 229548),
(230676, '4jzcA01', NULL, NULL, 143, NULL, NULL, 229548),
(230677, '2wnpF01', NULL, NULL, 144, NULL, NULL, 229548),
(230678, '6eubA01', NULL, NULL, 154, NULL, NULL, 229548),
(230679, '2fibA01', NULL, NULL, 154, NULL, NULL, 229548),
(230680, '4epuA01', NULL, NULL, 146, NULL, NULL, 229548),
(230681, '1jc9A01', NULL, NULL, 152, NULL, NULL, 229548),
(230682, '1lwuC01', NULL, NULL, 151, NULL, NULL, 229548),
(230683, '1lwuB01', NULL, NULL, 158, NULL, NULL, 229548),
(230684, '1re3B01', NULL, NULL, 207, NULL, NULL, 229548),
(230685, '6qnvA01', NULL, NULL, 150, NULL, NULL, 229548),
(230686, '2j5zA01', NULL, NULL, 148, NULL, NULL, 229548),
(230687, '1m1jC01', NULL, NULL, 154, NULL, NULL, 229548),
(230688, '3ghgB02', NULL, NULL, 265, NULL, NULL, 229548),
(230689, '3ju0A00', NULL, NULL, 108, NULL, NULL, 229549),
(230690, '3jtzA00', NULL, NULL, 88, NULL, NULL, 229549),
(230691, '5f7uA02', NULL, NULL, 226, NULL, NULL, 229550),
(230692, '3topA02', NULL, NULL, 238, NULL, NULL, 229550),
(230693, '5nn4A02', NULL, NULL, 232, NULL, NULL, 229550),
(230694, '2g3mF01', NULL, NULL, 153, NULL, NULL, 229550),
(230695, '3weoA01', NULL, NULL, 276, NULL, NULL, 229550),
(230696, '2xvlA01', NULL, NULL, 234, NULL, NULL, 229550),
(230697, '4ba0A01', NULL, NULL, 201, NULL, NULL, 229550),
(230698, '4amwA01', NULL, NULL, 320, NULL, NULL, 229550),
(230699, '3lppA02', NULL, NULL, 237, NULL, NULL, 229550),
(230700, '6c9xA01', NULL, NULL, 156, NULL, NULL, 229550),
(230701, '2f2hA01', NULL, NULL, 245, NULL, NULL, 229550),
(230702, '3l4yA02', NULL, NULL, 238, NULL, NULL, 229550),
(230703, '5jouA01', NULL, NULL, 238, NULL, NULL, 229550),
(230704, '2e6iA00', NULL, NULL, 64, NULL, NULL, 229551),
(230705, '4wepA02', NULL, NULL, 114, NULL, NULL, 229552),
(230706, '3o66B02', NULL, NULL, 105, NULL, NULL, 229552),
(230707, '6eygA02', NULL, NULL, 105, NULL, NULL, 229552),
(230708, '5teuA02', NULL, NULL, 114, NULL, NULL, 229552),
(230709, '4z7eA02', NULL, NULL, 104, NULL, NULL, 229552),
(230710, '1sw5A02', NULL, NULL, 104, NULL, NULL, 229552),
(230711, '4ne4A02', NULL, NULL, 114, NULL, NULL, 229552),
(230712, '3ppqA02', NULL, NULL, 105, NULL, NULL, 229552),
(230713, '3tixB02', NULL, NULL, 145, NULL, NULL, 229553),
(230714, '2f40A00', NULL, NULL, 96, NULL, NULL, 229554),
(230715, '1ok8A02', NULL, NULL, 84, NULL, NULL, 229555),
(230716, '1okeB02', NULL, NULL, 77, NULL, NULL, 229555),
(230717, '5o6aA02', NULL, NULL, 75, NULL, NULL, 229555),
(230718, '3p54A02', NULL, NULL, 71, NULL, NULL, 229555),
(230719, '6j5cA02', NULL, NULL, 83, NULL, NULL, 229555),
(230720, '1uzgA02', NULL, NULL, 77, NULL, NULL, 229555),
(230721, '1svbA02', NULL, NULL, 83, NULL, NULL, 229555),
(230722, '5mv2A02', NULL, NULL, 74, NULL, NULL, 229555),
(230723, '6iw5A02', NULL, NULL, 74, NULL, NULL, 229555),
(230724, '5jhmA02', NULL, NULL, 77, NULL, NULL, 229555),
(230725, '6iw4A02', NULL, NULL, 72, NULL, NULL, 229555),
(230726, '3uajA02', NULL, NULL, 79, NULL, NULL, 229555),
(230727, '5lbsA02', NULL, NULL, 71, NULL, NULL, 229555),
(230728, '2hg0A02', NULL, NULL, 71, NULL, NULL, 229555),
(230729, '6a0pA02', NULL, NULL, 71, NULL, NULL, 229555),
(230730, '4gsxA02', NULL, NULL, 84, NULL, NULL, 229555),
(230731, '6co8A02', NULL, NULL, 72, NULL, NULL, 229555),
(230732, '6epkA02', NULL, NULL, 71, NULL, NULL, 229555),
(230733, '4fg0A02', NULL, NULL, 82, NULL, NULL, 229555),
(230734, '3j27A02', NULL, NULL, 72, NULL, NULL, 229555),
(230735, '3c5xA02', NULL, NULL, 78, NULL, NULL, 229555),
(230736, '1q74B00', NULL, NULL, 303, NULL, NULL, 229556),
(230737, '1uanA00', NULL, NULL, 227, NULL, NULL, 229556),
(230738, '2ixdA00', NULL, NULL, 242, NULL, NULL, 229556);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(230739, '3we7A00', NULL, NULL, 272, NULL, NULL, 229556),
(230740, '4xlzA00', NULL, NULL, 267, NULL, NULL, 229556),
(230741, '5bmoC00', NULL, NULL, 246, NULL, NULL, 229556),
(230742, '3dfiA00', NULL, NULL, 270, NULL, NULL, 229556),
(230743, '5cgzA00', NULL, NULL, 240, NULL, NULL, 229556),
(230744, '3dffA00', NULL, NULL, 273, NULL, NULL, 229556),
(230745, '4e6yA01', NULL, NULL, 53, NULL, NULL, 229557),
(230746, '2h12A01', NULL, NULL, 57, NULL, NULL, 229557),
(230747, '4jadA01', NULL, NULL, 49, NULL, NULL, 229557),
(230748, '4xghA01', NULL, NULL, 50, NULL, NULL, 229557),
(230749, '4tvmA01', NULL, NULL, 52, NULL, NULL, 229557),
(230750, '3msuA01', NULL, NULL, 58, NULL, NULL, 229557),
(230751, '2wxfA04', NULL, NULL, 152, NULL, NULL, 229558),
(230752, '5dxuA04', NULL, NULL, 154, NULL, NULL, 229558),
(230753, '4jpsA04', NULL, NULL, 157, NULL, NULL, 229558),
(230754, '4uwhA02', NULL, NULL, 154, NULL, NULL, 229558),
(230755, '4bfrA04', NULL, NULL, 153, NULL, NULL, 229558),
(230756, '1cjaA01', NULL, NULL, 165, NULL, NULL, 229558),
(230757, '1e7uA04', NULL, NULL, 158, NULL, NULL, 229558),
(230758, '2x6hA02', NULL, NULL, 157, NULL, NULL, 229558),
(230759, '1vk5A00', NULL, NULL, 122, NULL, NULL, 229559),
(230760, '5m04A01', NULL, NULL, 161, NULL, NULL, 229560),
(230761, '1lnzA01', NULL, NULL, 157, NULL, NULL, 229560),
(230762, '1udxA01', NULL, NULL, 154, NULL, NULL, 229560),
(230763, '2d9rA00', NULL, NULL, 85, NULL, NULL, 229561),
(230764, '2wro400', NULL, NULL, 48, NULL, NULL, 229562),
(230765, '3dahC02', NULL, NULL, 142, NULL, NULL, 229563),
(230766, '2dy0B00', NULL, NULL, 190, NULL, NULL, 229563),
(230767, '2ji4A01', NULL, NULL, 167, NULL, NULL, 229563),
(230768, '2igbB00', NULL, NULL, 179, NULL, NULL, 229563),
(230769, '1qb7A00', NULL, NULL, 236, NULL, NULL, 229563),
(230770, '1hgxA00', NULL, NULL, 183, NULL, NULL, 229563),
(230771, '6asvA01', NULL, NULL, 171, NULL, NULL, 229563),
(230772, '2ehjA00', NULL, NULL, 208, NULL, NULL, 229563),
(230773, '5vn4B00', NULL, NULL, 243, NULL, NULL, 229563),
(230774, '4wmlA00', NULL, NULL, 231, NULL, NULL, 229563),
(230775, '1tc1A00', NULL, NULL, 187, NULL, NULL, 229563),
(230776, '5xtkA00', NULL, NULL, 152, NULL, NULL, 229563),
(230777, '5knxB00', NULL, NULL, 182, NULL, NULL, 229563),
(230778, '4qyiA00', NULL, NULL, 186, NULL, NULL, 229563),
(230779, '2aeeB00', NULL, NULL, 211, NULL, NULL, 229563),
(230780, '4pfqC00', NULL, NULL, 184, NULL, NULL, 229563),
(230781, '1dkuA02', NULL, NULL, 176, NULL, NULL, 229563),
(230782, '1dkuA01', NULL, NULL, 141, NULL, NULL, 229563),
(230783, '3lrtA02', NULL, NULL, 132, NULL, NULL, 229563),
(230784, '3m3hA00', NULL, NULL, 214, NULL, NULL, 229563),
(230785, '3acdA00', NULL, NULL, 181, NULL, NULL, 229563),
(230786, '1vdmG00', NULL, NULL, 153, NULL, NULL, 229563),
(230787, '5jsqA00', NULL, NULL, 216, NULL, NULL, 229563),
(230788, '4p83D00', NULL, NULL, 182, NULL, NULL, 229563),
(230789, '4rqaA00', NULL, NULL, 186, NULL, NULL, 229563),
(230790, '3dahB01', NULL, NULL, 177, NULL, NULL, 229563),
(230791, '1bd3A00', NULL, NULL, 224, NULL, NULL, 229563),
(230792, '1g2qA00', NULL, NULL, 187, NULL, NULL, 229563),
(230793, '5ipfC00', NULL, NULL, 223, NULL, NULL, 229563),
(230794, '5bqpD00', NULL, NULL, 179, NULL, NULL, 229563),
(230795, '3mjdC00', NULL, NULL, 209, NULL, NULL, 229563),
(230796, '2xbuA00', NULL, NULL, 221, NULL, NULL, 229563),
(230797, '1lh0B00', NULL, NULL, 213, NULL, NULL, 229563),
(230798, '2yzkA00', NULL, NULL, 178, NULL, NULL, 229563),
(230799, '1xttB00', NULL, NULL, 216, NULL, NULL, 229563),
(230800, '6d9rA00', NULL, NULL, 183, NULL, NULL, 229563),
(230801, '3s5jA02', NULL, NULL, 144, NULL, NULL, 229563),
(230802, '4p84A00', NULL, NULL, 180, NULL, NULL, 229563),
(230803, '3s5jA01', NULL, NULL, 167, NULL, NULL, 229563),
(230804, '1ufrA00', NULL, NULL, 181, NULL, NULL, 229563),
(230805, '1fsgA00', NULL, NULL, 233, NULL, NULL, 229563),
(230806, '1l1qA00', NULL, NULL, 186, NULL, NULL, 229563),
(230807, '6ar9C00', NULL, NULL, 226, NULL, NULL, 229563),
(230808, '1vchD00', NULL, NULL, 175, NULL, NULL, 229563),
(230809, '4fymF00', NULL, NULL, 266, NULL, NULL, 229563);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(230810, '4lzaB00', NULL, NULL, 172, NULL, NULL, 229563),
(230811, '1dqnA00', NULL, NULL, 230, NULL, NULL, 229563),
(230812, '2ji4A02', NULL, NULL, 134, NULL, NULL, 229563),
(230813, '3qw4B02', NULL, NULL, 200, NULL, NULL, 229563),
(230814, '2vfaA00', NULL, NULL, 229, NULL, NULL, 229563),
(230815, '4p80B00', NULL, NULL, 180, NULL, NULL, 229563),
(230816, '5eswB00', NULL, NULL, 197, NULL, NULL, 229563),
(230817, '5e38B00', NULL, NULL, 216, NULL, NULL, 229563),
(230818, '5znqA00', NULL, NULL, 187, NULL, NULL, 229563),
(230819, '4p82A00', NULL, NULL, 183, NULL, NULL, 229563),
(230820, '1i5eA00', NULL, NULL, 209, NULL, NULL, 229563),
(230821, '1o5oB00', NULL, NULL, 221, NULL, NULL, 229563),
(230822, '3ozfC00', NULL, NULL, 230, NULL, NULL, 229563),
(230823, '1mzvA00', NULL, NULL, 217, NULL, NULL, 229563),
(230824, '6asvC02', NULL, NULL, 143, NULL, NULL, 229563),
(230825, '1w30B00', NULL, NULL, 201, NULL, NULL, 229563),
(230826, '2gebA00', NULL, NULL, 185, NULL, NULL, 229563),
(230827, '2e55A00', NULL, NULL, 208, NULL, NULL, 229563),
(230828, '1v9sD00', NULL, NULL, 208, NULL, NULL, 229563),
(230829, '1nulA00', NULL, NULL, 152, NULL, NULL, 229563),
(230830, '1u9yA02', NULL, NULL, 134, NULL, NULL, 229563),
(230831, '1u9yA01', NULL, NULL, 150, NULL, NULL, 229563),
(230832, '1y0bB01', NULL, NULL, 186, NULL, NULL, 229563),
(230833, '3dezB00', NULL, NULL, 209, NULL, NULL, 229563),
(230834, '1ao0A02', NULL, NULL, 132, NULL, NULL, 229563),
(230835, '3dmpC00', NULL, NULL, 217, NULL, NULL, 229563),
(230836, '5vogA00', NULL, NULL, 183, NULL, NULL, 229563),
(230837, '6nfeB02', NULL, NULL, 143, NULL, NULL, 229563),
(230838, '4qriA00', NULL, NULL, 178, NULL, NULL, 229563),
(230839, '1o57B02', NULL, NULL, 201, NULL, NULL, 229563),
(230840, '6fchA00', NULL, NULL, 178, NULL, NULL, 229563),
(230841, '4p3kA00', NULL, NULL, 180, NULL, NULL, 229563),
(230842, '4rhxA00', NULL, NULL, 201, NULL, NULL, 229563),
(230843, '3n2lF00', NULL, NULL, 193, NULL, NULL, 229563),
(230844, '4m0kC00', NULL, NULL, 176, NULL, NULL, 229563),
(230845, '1wd5A01', NULL, NULL, 147, NULL, NULL, 229563),
(230846, '4ohcC00', NULL, NULL, 236, NULL, NULL, 229563),
(230847, '4lyyA00', NULL, NULL, 181, NULL, NULL, 229563),
(230848, '4pawB00', NULL, NULL, 203, NULL, NULL, 229563),
(230849, '5hiaA00', NULL, NULL, 224, NULL, NULL, 229563),
(230850, '4twbA01', NULL, NULL, 152, NULL, NULL, 229563),
(230851, '3ohpA00', NULL, NULL, 177, NULL, NULL, 229563),
(230852, '4twbA02', NULL, NULL, 139, NULL, NULL, 229563),
(230853, '5mp7A02', NULL, NULL, 145, NULL, NULL, 229563),
(230854, '5zgoA00', NULL, NULL, 178, NULL, NULL, 229563),
(230855, '6czfA02', NULL, NULL, 137, NULL, NULL, 229563),
(230856, '3lrtB01', NULL, NULL, 154, NULL, NULL, 229563),
(230857, '5mp7A01', NULL, NULL, 181, NULL, NULL, 229563),
(230858, '2jbhA00', NULL, NULL, 225, NULL, NULL, 229563),
(230859, '2c4kA02', NULL, NULL, 135, NULL, NULL, 229563),
(230860, '2c4kA01', NULL, NULL, 167, NULL, NULL, 229563),
(230861, '6bo7E00', NULL, NULL, 238, NULL, NULL, 229563),
(230862, '5yw5A00', NULL, NULL, 179, NULL, NULL, 229563),
(230863, '5t3oA02', NULL, NULL, 139, NULL, NULL, 229563),
(230864, '1pzmA00', NULL, NULL, 192, NULL, NULL, 229563),
(230865, '5hklB00', NULL, NULL, 190, NULL, NULL, 229563),
(230866, '5t3oA01', NULL, NULL, 165, NULL, NULL, 229563),
(230867, '6nfeA01', NULL, NULL, 180, NULL, NULL, 229563),
(230868, '2p1zB00', NULL, NULL, 180, NULL, NULL, 229563),
(230869, '2wnsA00', NULL, NULL, 205, NULL, NULL, 229563),
(230870, '1hy9A00', NULL, NULL, 41, NULL, NULL, 229564),
(230871, '3sqlB02', NULL, NULL, 156, NULL, NULL, 229565),
(230872, '4u8uO01', NULL, NULL, 56, NULL, NULL, 229566),
(230873, '2gtlO01', NULL, NULL, 52, NULL, NULL, 229566),
(230874, '1n7lA00', NULL, NULL, 53, NULL, NULL, 229567),
(230875, '1zllA00', NULL, NULL, 52, NULL, NULL, 229567),
(230876, '1fjkA00', NULL, NULL, 52, NULL, NULL, 229567),
(230877, '2fgyA01', NULL, NULL, 107, NULL, NULL, 229568),
(230878, '3tnfB01', NULL, NULL, 184, NULL, NULL, 229569),
(230879, '3sfvB01', NULL, NULL, 144, NULL, NULL, 229569),
(230880, '3uafA00', NULL, NULL, 117, NULL, NULL, 229570);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(230881, '5vntA00', NULL, NULL, 63, NULL, NULL, 229571),
(230882, '1yu5X00', NULL, NULL, 67, NULL, NULL, 229571),
(230883, '1ujsA00', NULL, NULL, 88, NULL, NULL, 229571),
(230884, '2k6mS00', NULL, NULL, 67, NULL, NULL, 229571),
(230885, '2l3xA00', NULL, NULL, 67, NULL, NULL, 229571),
(230886, '1qzpA00', NULL, NULL, 68, NULL, NULL, 229571),
(230887, '3kvwA01', NULL, NULL, 73, NULL, NULL, 229572),
(230888, '3nqvA00', NULL, NULL, 253, NULL, NULL, 229573),
(230889, '2yx0A00', NULL, NULL, 342, NULL, NULL, 229573),
(230890, '1sflB00', NULL, NULL, 238, NULL, NULL, 229573),
(230891, '4mjmA00', NULL, NULL, 336, NULL, NULL, 229573),
(230892, '5zknA00', NULL, NULL, 225, NULL, NULL, 229573),
(230893, '4fb7A00', NULL, NULL, 275, NULL, NULL, 229573),
(230894, '1r2rB00', NULL, NULL, 248, NULL, NULL, 229573),
(230895, '3oixA01', NULL, NULL, 268, NULL, NULL, 229573),
(230896, '2b7oA01', NULL, NULL, 353, NULL, NULL, 229573),
(230897, '5lnuB00', NULL, NULL, 278, NULL, NULL, 229573),
(230898, '2g95B02', NULL, NULL, 259, NULL, NULL, 229573),
(230899, '4ohqB00', NULL, NULL, 256, NULL, NULL, 229573),
(230900, '2zbtA00', NULL, NULL, 278, NULL, NULL, 229573),
(230901, '4rv8C00', NULL, NULL, 361, NULL, NULL, 229573),
(230902, '2fiqD01', NULL, NULL, 296, NULL, NULL, 229573),
(230903, '4iqlA00', NULL, NULL, 313, NULL, NULL, 229573),
(230904, '4xkyA00', NULL, NULL, 300, NULL, NULL, 229573),
(230905, '1tqjC00', NULL, NULL, 230, NULL, NULL, 229573),
(230906, '4oriA00', NULL, NULL, 372, NULL, NULL, 229573),
(230907, '3no5E00', NULL, NULL, 275, NULL, NULL, 229573),
(230908, '3hpxA01', NULL, NULL, 298, NULL, NULL, 229573),
(230909, '6bngA00', NULL, NULL, 289, NULL, NULL, 229573),
(230910, '2r14A00', NULL, NULL, 377, NULL, NULL, 229573),
(230911, '1vcfB00', NULL, NULL, 310, NULL, NULL, 229573),
(230912, '1ea0A02', NULL, NULL, 358, NULL, NULL, 229573),
(230913, '5e1qA02', NULL, NULL, 273, NULL, NULL, 229573),
(230914, '5lntA00', NULL, NULL, 273, NULL, NULL, 229573),
(230915, '1o5xA00', NULL, NULL, 248, NULL, NULL, 229573),
(230916, '4uxdA00', NULL, NULL, 274, NULL, NULL, 229573),
(230917, '4nnaA01', NULL, NULL, 354, NULL, NULL, 229573),
(230918, '4ogzA02', NULL, NULL, 296, NULL, NULL, 229573),
(230919, '5u4nA00', NULL, NULL, 362, NULL, NULL, 229573),
(230920, '5ucsA00', NULL, NULL, 307, NULL, NULL, 229573),
(230921, '3tfxA00', NULL, NULL, 259, NULL, NULL, 229573),
(230922, '4grsA02', NULL, NULL, 263, NULL, NULL, 229573),
(230923, '5ahmB00', NULL, NULL, 380, NULL, NULL, 229573),
(230924, '4fhaA00', NULL, NULL, 311, NULL, NULL, 229573),
(230925, '2nv2I00', NULL, NULL, 272, NULL, NULL, 229573),
(230926, '3a9iA01', NULL, NULL, 271, NULL, NULL, 229573),
(230927, '4xwuA00', NULL, NULL, 338, NULL, NULL, 229573),
(230928, '2z0iA00', NULL, NULL, 330, NULL, NULL, 229573),
(230929, '3hjzA00', NULL, NULL, 334, NULL, NULL, 229573),
(230930, '4xq6A00', NULL, NULL, 323, NULL, NULL, 229573),
(230931, '4i7wA00', NULL, NULL, 308, NULL, NULL, 229573),
(230932, '1jcnA00', NULL, NULL, 464, NULL, NULL, 229573),
(230933, '4h3dB00', NULL, NULL, 258, NULL, NULL, 229573),
(230934, '4nu7C00', NULL, NULL, 230, NULL, NULL, 229573),
(230935, '1xi3A00', NULL, NULL, 215, NULL, NULL, 229573),
(230936, '4lt9A00', NULL, NULL, 269, NULL, NULL, 229573),
(230937, '1me8A00', NULL, NULL, 383, NULL, NULL, 229573),
(230938, '4k36B00', NULL, NULL, 370, NULL, NULL, 229573),
(230939, '3pm6A00', NULL, NULL, 306, NULL, NULL, 229573),
(230940, '5o0wB00', NULL, NULL, 359, NULL, NULL, 229573),
(230941, '1ydoA00', NULL, NULL, 307, NULL, NULL, 229573),
(230942, '5uprA00', NULL, NULL, 265, NULL, NULL, 229573),
(230943, '1rqbA01', NULL, NULL, 284, NULL, NULL, 229573),
(230944, '1wx0A00', NULL, NULL, 223, NULL, NULL, 229573),
(230945, '2b7nA02', NULL, NULL, 146, NULL, NULL, 229573),
(230946, '2yxgB00', NULL, NULL, 289, NULL, NULL, 229573),
(230947, '3exrA00', NULL, NULL, 221, NULL, NULL, 229573),
(230948, '1f6kC00', NULL, NULL, 293, NULL, NULL, 229573),
(230949, '4axkB00', NULL, NULL, 250, NULL, NULL, 229573),
(230950, '1v5xA00', NULL, NULL, 203, NULL, NULL, 229573),
(230951, '2nuwA00', NULL, NULL, 288, NULL, NULL, 229573);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(230952, '1b3oA00', NULL, NULL, 344, NULL, NULL, 229573),
(230953, '1ea0B03', NULL, NULL, 413, NULL, NULL, 229573),
(230954, '1f05A00', NULL, NULL, 337, NULL, NULL, 229573),
(230955, '4awtA00', NULL, NULL, 365, NULL, NULL, 229573),
(230956, '3tfcB02', NULL, NULL, 272, NULL, NULL, 229573),
(230957, '3cwoX00', NULL, NULL, 237, NULL, NULL, 229573),
(230958, '4mknA00', NULL, NULL, 254, NULL, NULL, 229573),
(230959, '1w5qB00', NULL, NULL, 337, NULL, NULL, 229573),
(230960, '3ktsA00', NULL, NULL, 192, NULL, NULL, 229573),
(230961, '5hqaA02', NULL, NULL, 416, NULL, NULL, 229573),
(230962, '1m6jA00', NULL, NULL, 261, NULL, NULL, 229573),
(230963, '5swvC01', NULL, NULL, 249, NULL, NULL, 229573),
(230964, '6arhA00', NULL, NULL, 314, NULL, NULL, 229573),
(230965, '2o7sA01', NULL, NULL, 233, NULL, NULL, 229573),
(230966, '4dppA00', NULL, NULL, 307, NULL, NULL, 229573),
(230967, '1geqB00', NULL, NULL, 248, NULL, NULL, 229573),
(230968, '3ndoA00', NULL, NULL, 231, NULL, NULL, 229573),
(230969, '5fewA00', NULL, NULL, 358, NULL, NULL, 229573),
(230970, '3cu2A00', NULL, NULL, 237, NULL, NULL, 229573),
(230971, '3clmA00', NULL, NULL, 352, NULL, NULL, 229573),
(230972, '4z0gA00', NULL, NULL, 413, NULL, NULL, 229573),
(230973, '6agmA00', NULL, NULL, 355, NULL, NULL, 229573),
(230974, '1yxyA00', NULL, NULL, 234, NULL, NULL, 229573),
(230975, '3ngjD00', NULL, NULL, 222, NULL, NULL, 229573),
(230976, '5ujwD00', NULL, NULL, 253, NULL, NULL, 229573),
(230977, '3ve9A00', NULL, NULL, 215, NULL, NULL, 229573),
(230978, '5h91A00', NULL, NULL, 227, NULL, NULL, 229573),
(230979, '4ml9A00', NULL, NULL, 286, NULL, NULL, 229573),
(230980, '1mxsA00', NULL, NULL, 225, NULL, NULL, 229573),
(230981, '2yyuB00', NULL, NULL, 246, NULL, NULL, 229573),
(230982, '1vhnA01', NULL, NULL, 238, NULL, NULL, 229573),
(230983, '5cgqA00', NULL, NULL, 268, NULL, NULL, 229573),
(230984, '5dxxA00', NULL, NULL, 387, NULL, NULL, 229573),
(230985, '4gj1A00', NULL, NULL, 243, NULL, NULL, 229573),
(230986, '2yr1A00', NULL, NULL, 257, NULL, NULL, 229573),
(230987, '1b9bB00', NULL, NULL, 255, NULL, NULL, 229573),
(230988, '3o6cA00', NULL, NULL, 260, NULL, NULL, 229573),
(230989, '5k9xA00', NULL, NULL, 275, NULL, NULL, 229573),
(230990, '3qfeB00', NULL, NULL, 318, NULL, NULL, 229573),
(230991, '4eivA00', NULL, NULL, 297, NULL, NULL, 229573),
(230992, '4utuA00', NULL, NULL, 229, NULL, NULL, 229573),
(230993, '5n6gA00', NULL, NULL, 379, NULL, NULL, 229573),
(230994, '5a5wA00', NULL, NULL, 253, NULL, NULL, 229573),
(230995, '5tchA00', NULL, NULL, 276, NULL, NULL, 229573),
(230996, '1vkfB00', NULL, NULL, 188, NULL, NULL, 229573),
(230997, '3q94A00', NULL, NULL, 288, NULL, NULL, 229573),
(230998, '4lu0D00', NULL, NULL, 287, NULL, NULL, 229573),
(230999, '5ui3A00', NULL, NULL, 307, NULL, NULL, 229573),
(231000, '1pv8B00', NULL, NULL, 330, NULL, NULL, 229573),
(231001, '1goxA00', NULL, NULL, 370, NULL, NULL, 229573),
(231002, '3ng3C00', NULL, NULL, 227, NULL, NULL, 229573),
(231003, '1h5yB00', NULL, NULL, 253, NULL, NULL, 229573),
(231004, '5u7sB00', NULL, NULL, 353, NULL, NULL, 229573),
(231005, '1piiA01', NULL, NULL, 261, NULL, NULL, 229573),
(231006, '5zkaA00', NULL, NULL, 307, NULL, NULL, 229573),
(231007, '1piiA02', NULL, NULL, 191, NULL, NULL, 229573),
(231008, '4tr9A00', NULL, NULL, 352, NULL, NULL, 229573),
(231009, '1f76A00', NULL, NULL, 336, NULL, NULL, 229573),
(231010, '2d73A02', NULL, NULL, 320, NULL, NULL, 229573),
(231011, '1n7kA00', NULL, NULL, 234, NULL, NULL, 229573),
(231012, '3navA00', NULL, NULL, 271, NULL, NULL, 229573),
(231013, '2yw3E00', NULL, NULL, 207, NULL, NULL, 229573),
(231014, '4rz4A00', NULL, NULL, 226, NULL, NULL, 229573),
(231015, '2a5hA02', NULL, NULL, 286, NULL, NULL, 229573),
(231016, '4p61A00', NULL, NULL, 248, NULL, NULL, 229573),
(231017, '2xn2A02', NULL, NULL, 323, NULL, NULL, 229573),
(231018, '1n8fA00', NULL, NULL, 350, NULL, NULL, 229573),
(231019, '4lvfB02', NULL, NULL, 269, NULL, NULL, 229573),
(231020, '5epdA00', NULL, NULL, 361, NULL, NULL, 229573),
(231021, '1p0kA00', NULL, NULL, 329, NULL, NULL, 229573),
(231022, '5f4wA00', NULL, NULL, 327, NULL, NULL, 229573);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(231023, '2nliB00', NULL, NULL, 326, NULL, NULL, 229573),
(231024, '1p1xB00', NULL, NULL, 260, NULL, NULL, 229573),
(231025, '5c54G00', NULL, NULL, 312, NULL, NULL, 229573),
(231026, '4a29A00', NULL, NULL, 258, NULL, NULL, 229573),
(231027, '1vrdB00', NULL, NULL, 354, NULL, NULL, 229573),
(231028, '3dz1A00', NULL, NULL, 313, NULL, NULL, 229573),
(231029, '5j6fA02', NULL, NULL, 274, NULL, NULL, 229573),
(231030, '3hblA05', NULL, NULL, 306, NULL, NULL, 229573),
(231031, '4y8fA00', NULL, NULL, 251, NULL, NULL, 229573),
(231032, '2y70A00', NULL, NULL, 245, NULL, NULL, 229573),
(231033, '5swuA00', NULL, NULL, 263, NULL, NULL, 229573),
(231034, '4qshA04', NULL, NULL, 305, NULL, NULL, 229573),
(231035, '1thfD00', NULL, NULL, 253, NULL, NULL, 229573),
(231036, '3s6dA00', NULL, NULL, 282, NULL, NULL, 229573),
(231037, '5ahnA00', NULL, NULL, 297, NULL, NULL, 229573),
(231038, '2z6iA00', NULL, NULL, 332, NULL, NULL, 229573),
(231039, '6ofuB00', NULL, NULL, 286, NULL, NULL, 229573),
(231040, '4mzyA02', NULL, NULL, 168, NULL, NULL, 229573),
(231041, '1vs1D00', NULL, NULL, 276, NULL, NULL, 229573),
(231042, '3cprA00', NULL, NULL, 304, NULL, NULL, 229573),
(231043, '4jdyA00', NULL, NULL, 264, NULL, NULL, 229573),
(231044, '3c61A01', NULL, NULL, 270, NULL, NULL, 229573),
(231045, '5lsmG00', NULL, NULL, 359, NULL, NULL, 229573),
(231046, '1aw2A00', NULL, NULL, 256, NULL, NULL, 229573),
(231047, '3wjsA00', NULL, NULL, 315, NULL, NULL, 229573),
(231048, '2h6rB00', NULL, NULL, 219, NULL, NULL, 229573),
(231049, '6mguB00', NULL, NULL, 363, NULL, NULL, 229573),
(231050, '2jbmA02', NULL, NULL, 146, NULL, NULL, 229573),
(231051, '2uv8G04', NULL, NULL, 289, NULL, NULL, 229573),
(231052, '5kinC00', NULL, NULL, 258, NULL, NULL, 229573),
(231053, '2w6rA00', NULL, NULL, 233, NULL, NULL, 229573),
(231054, '3q58A00', NULL, NULL, 229, NULL, NULL, 229573),
(231055, '2jkeA02', NULL, NULL, 430, NULL, NULL, 229573),
(231056, '3lm7A00', NULL, NULL, 249, NULL, NULL, 229573),
(231057, '1neyA00', NULL, NULL, 247, NULL, NULL, 229573),
(231058, '3chvA00', NULL, NULL, 284, NULL, NULL, 229573),
(231059, '4nvtA00', NULL, NULL, 262, NULL, NULL, 229573),
(231060, '5gvjA00', NULL, NULL, 314, NULL, NULL, 229573),
(231061, '1ep3A00', NULL, NULL, 311, NULL, NULL, 229573),
(231062, '3l21B00', NULL, NULL, 304, NULL, NULL, 229573),
(231063, '6htoB00', NULL, NULL, 400, NULL, NULL, 229573),
(231064, '4pfmA00', NULL, NULL, 295, NULL, NULL, 229573),
(231065, '2r8wA00', NULL, NULL, 303, NULL, NULL, 229573),
(231066, '3tsmA00', NULL, NULL, 272, NULL, NULL, 229573),
(231067, '5c5yA00', NULL, NULL, 263, NULL, NULL, 229573),
(231068, '5d38A00', NULL, NULL, 264, NULL, NULL, 229573),
(231069, '5uqgD00', NULL, NULL, 383, NULL, NULL, 229573),
(231070, '4iwwA00', NULL, NULL, 258, NULL, NULL, 229573),
(231071, '1xkyA00', NULL, NULL, 301, NULL, NULL, 229573),
(231072, '3tqvB02', NULL, NULL, 147, NULL, NULL, 229573),
(231073, '5czjA00', NULL, NULL, 320, NULL, NULL, 229573),
(231074, '2aamA00', NULL, NULL, 309, NULL, NULL, 229573),
(231075, '4lrtA01', NULL, NULL, 275, NULL, NULL, 229573),
(231076, '2v82A00', NULL, NULL, 212, NULL, NULL, 229573),
(231077, '4x2rA00', NULL, NULL, 250, NULL, NULL, 229573),
(231078, '3uy7A00', NULL, NULL, 252, NULL, NULL, 229573),
(231079, '1yadB00', NULL, NULL, 205, NULL, NULL, 229573),
(231080, '1vyrA00', NULL, NULL, 364, NULL, NULL, 229573),
(231081, '2p0oA01', NULL, NULL, 241, NULL, NULL, 229573),
(231082, '2wsrA00', NULL, NULL, 242, NULL, NULL, 229573),
(231083, '3uycB00', NULL, NULL, 249, NULL, NULL, 229573),
(231084, '4muzA00', NULL, NULL, 212, NULL, NULL, 229573),
(231085, '4umaA00', NULL, NULL, 335, NULL, NULL, 229573),
(231086, '3ajxA00', NULL, NULL, 207, NULL, NULL, 229573),
(231087, '3mbdA00', NULL, NULL, 342, NULL, NULL, 229573),
(231088, '1fdjA00', NULL, NULL, 363, NULL, NULL, 229573),
(231089, '2ox1A00', NULL, NULL, 196, NULL, NULL, 229573),
(231090, '1ub3A00', NULL, NULL, 220, NULL, NULL, 229573),
(231091, '4y9aB00', NULL, NULL, 261, NULL, NULL, 229573),
(231092, '3q37C00', NULL, NULL, 251, NULL, NULL, 229573),
(231093, '3b0pA01', NULL, NULL, 243, NULL, NULL, 229573);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(231094, '2vepA00', NULL, NULL, 244, NULL, NULL, 229573),
(231095, '5ud6A00', NULL, NULL, 303, NULL, NULL, 229573),
(231096, '4o4vA00', NULL, NULL, 252, NULL, NULL, 229573),
(231097, '3gkaA00', NULL, NULL, 361, NULL, NULL, 229573),
(231098, '4i9aA02', NULL, NULL, 146, NULL, NULL, 229573),
(231099, '1to3A00', NULL, NULL, 304, NULL, NULL, 229573),
(231100, '4nq1A00', NULL, NULL, 290, NULL, NULL, 229573),
(231101, '1qwgA00', NULL, NULL, 251, NULL, NULL, 229573),
(231102, '3hojA00', NULL, NULL, 248, NULL, NULL, 229573),
(231103, '1vpxE00', NULL, NULL, 230, NULL, NULL, 229573),
(231104, '3hg3A01', NULL, NULL, 293, NULL, NULL, 229573),
(231105, '4evzA00', NULL, NULL, 258, NULL, NULL, 229573),
(231106, '3eegB00', NULL, NULL, 279, NULL, NULL, 229573),
(231107, '6bmaA00', NULL, NULL, 261, NULL, NULL, 229573),
(231108, '4oqvA00', NULL, NULL, 377, NULL, NULL, 229573),
(231109, '1tqxA00', NULL, NULL, 227, NULL, NULL, 229573),
(231110, '3kx6B00', NULL, NULL, 357, NULL, NULL, 229573),
(231111, '6gjvE00', NULL, NULL, 430, NULL, NULL, 229573),
(231112, '4mjzB00', NULL, NULL, 298, NULL, NULL, 229573),
(231113, '2ftpA00', NULL, NULL, 302, NULL, NULL, 229573),
(231114, '3qm3H00', NULL, NULL, 357, NULL, NULL, 229573),
(231115, '3l0gA02', NULL, NULL, 153, NULL, NULL, 229573),
(231116, '1eepA00', NULL, NULL, 330, NULL, NULL, 229573),
(231117, '4qitB00', NULL, NULL, 357, NULL, NULL, 229573),
(231118, '3gdmA00', NULL, NULL, 267, NULL, NULL, 229573),
(231119, '3c8fA00', NULL, NULL, 245, NULL, NULL, 229573),
(231120, '4tu1D00', NULL, NULL, 339, NULL, NULL, 229573),
(231121, '3l5lA00', NULL, NULL, 363, NULL, NULL, 229573),
(231122, '2p10C01', NULL, NULL, 259, NULL, NULL, 229573),
(231123, '3thaB00', NULL, NULL, 252, NULL, NULL, 229573),
(231124, '3e02A00', NULL, NULL, 311, NULL, NULL, 229573),
(231125, '3tqkA00', NULL, NULL, 346, NULL, NULL, 229573),
(231126, '3lbmC00', NULL, NULL, 295, NULL, NULL, 229573),
(231127, '1wbhB00', NULL, NULL, 214, NULL, NULL, 229573),
(231128, '2issC00', NULL, NULL, 293, NULL, NULL, 229573),
(231129, '2fdsA00', NULL, NULL, 333, NULL, NULL, 229573),
(231130, '5hjlA00', NULL, NULL, 333, NULL, NULL, 229573),
(231131, '4ot7A00', NULL, NULL, 327, NULL, NULL, 229573),
(231132, '2i9eB00', NULL, NULL, 259, NULL, NULL, 229573),
(231133, '5z9yB00', NULL, NULL, 252, NULL, NULL, 229573),
(231134, '4qq3A00', NULL, NULL, 344, NULL, NULL, 229573),
(231135, '5upxA00', NULL, NULL, 386, NULL, NULL, 229573),
(231136, '1dbtA00', NULL, NULL, 239, NULL, NULL, 229573),
(231137, '4qslD03', NULL, NULL, 527, NULL, NULL, 229573),
(231138, '3og3A00', NULL, NULL, 251, NULL, NULL, 229573),
(231139, '3k30A01', NULL, NULL, 386, NULL, NULL, 229573),
(231140, '2ekcB00', NULL, NULL, 262, NULL, NULL, 229573),
(231141, '3a5fA00', NULL, NULL, 291, NULL, NULL, 229573),
(231142, '1r30A00', NULL, NULL, 312, NULL, NULL, 229573),
(231143, '5k7jB00', NULL, NULL, 249, NULL, NULL, 229573),
(231144, '2oczA00', NULL, NULL, 231, NULL, NULL, 229573),
(231145, '4nzfB01', NULL, NULL, 358, NULL, NULL, 229573),
(231146, '1rpxA00', NULL, NULL, 230, NULL, NULL, 229573),
(231147, '2i1oA02', NULL, NULL, 190, NULL, NULL, 229573),
(231148, '2nx9A01', NULL, NULL, 287, NULL, NULL, 229573),
(231149, '3m16A00', NULL, NULL, 329, NULL, NULL, 229573),
(231150, '5ysnA03', NULL, NULL, 312, NULL, NULL, 229573),
(231151, '3fokA00', NULL, NULL, 307, NULL, NULL, 229573),
(231152, '3gnnA02', NULL, NULL, 143, NULL, NULL, 229573),
(231153, '5x8oA01', NULL, NULL, 309, NULL, NULL, 229573),
(231154, '3th6A00', NULL, NULL, 249, NULL, NULL, 229573),
(231155, '6hxgA00', NULL, NULL, 267, NULL, NULL, 229573),
(231156, '2agkA00', NULL, NULL, 260, NULL, NULL, 229573),
(231157, '2cu0B00', NULL, NULL, 375, NULL, NULL, 229573),
(231158, '1q6oB00', NULL, NULL, 216, NULL, NULL, 229573),
(231159, '3tmqA00', NULL, NULL, 285, NULL, NULL, 229573),
(231160, '1nvmA01', NULL, NULL, 271, NULL, NULL, 229573),
(231161, '4gbuA00', NULL, NULL, 400, NULL, NULL, 229573),
(231162, '5im5100', NULL, NULL, 219, NULL, NULL, 229573),
(231163, '3w07A00', NULL, NULL, 228, NULL, NULL, 229573),
(231164, '2fliC00', NULL, NULL, 220, NULL, NULL, 229573);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(231165, '1o94A01', NULL, NULL, 384, NULL, NULL, 229573),
(231166, '3nl6B01', NULL, NULL, 230, NULL, NULL, 229573),
(231167, '2aqwA00', NULL, NULL, 332, NULL, NULL, 229573),
(231168, '1o60A00', NULL, NULL, 292, NULL, NULL, 229573),
(231169, '4ccdA02', NULL, NULL, 176, NULL, NULL, 229573),
(231170, '1uasA01', NULL, NULL, 274, NULL, NULL, 229573),
(231171, '3d0cB00', NULL, NULL, 314, NULL, NULL, 229573),
(231172, '3daqA00', NULL, NULL, 292, NULL, NULL, 229573),
(231173, '4qslC03', NULL, NULL, 418, NULL, NULL, 229573),
(231174, '5huoA02', NULL, NULL, 143, NULL, NULL, 229573),
(231175, '1yyaA00', NULL, NULL, 250, NULL, NULL, 229573),
(231176, '3nyzA00', NULL, NULL, 261, NULL, NULL, 229573),
(231177, '5kzmA00', NULL, NULL, 272, NULL, NULL, 229573),
(231178, '1vhcF00', NULL, NULL, 224, NULL, NULL, 229573),
(231179, '4njhA00', NULL, NULL, 209, NULL, NULL, 229573),
(231180, '5uwxD00', NULL, NULL, 363, NULL, NULL, 229573),
(231181, '1vr6A02', NULL, NULL, 268, NULL, NULL, 229573),
(231182, '6fz6A02', NULL, NULL, 286, NULL, NULL, 229573),
(231183, '3hgjA00', NULL, NULL, 349, NULL, NULL, 229573),
(231184, '1wa3D00', NULL, NULL, 205, NULL, NULL, 229573),
(231185, '3l5aA00', NULL, NULL, 380, NULL, NULL, 229573),
(231186, '4zqmA00', NULL, NULL, 357, NULL, NULL, 229573),
(231187, '3l9cA00', NULL, NULL, 259, NULL, NULL, 229573),
(231188, '2e6fA01', NULL, NULL, 270, NULL, NULL, 229573),
(231189, '2i14A02', NULL, NULL, 191, NULL, NULL, 229573),
(231190, '1ypfA00', NULL, NULL, 336, NULL, NULL, 229573),
(231191, '1w0mA00', NULL, NULL, 226, NULL, NULL, 229573),
(231192, '1qpoA02', NULL, NULL, 156, NULL, NULL, 229573),
(231193, '1jubA01', NULL, NULL, 267, NULL, NULL, 229573),
(231194, '4do4A01', NULL, NULL, 290, NULL, NULL, 229573),
(231195, '5ey5A00', NULL, NULL, 273, NULL, NULL, 229573),
(231196, '5tleD00', NULL, NULL, 363, NULL, NULL, 229573),
(231197, '3gnnB02', NULL, NULL, 103, NULL, NULL, 229573),
(231198, '3cc1B01', NULL, NULL, 345, NULL, NULL, 229573),
(231199, '1vc4A00', NULL, NULL, 254, NULL, NULL, 229573),
(231200, '4to8A00', NULL, NULL, 292, NULL, NULL, 229573),
(231201, '1sznA01', NULL, NULL, 315, NULL, NULL, 229573),
(231202, '2uvaG04', NULL, NULL, 289, NULL, NULL, 229573),
(231203, '1nfbA00', NULL, NULL, 429, NULL, NULL, 229573),
(231204, '3rfaA02', NULL, NULL, 271, NULL, NULL, 229573),
(231205, '4z1dA00', NULL, NULL, 276, NULL, NULL, 229573),
(231206, '3mi6A02', NULL, NULL, 323, NULL, NULL, 229573),
(231207, '2egzC00', NULL, NULL, 219, NULL, NULL, 229573),
(231208, '4ov4A01', NULL, NULL, 278, NULL, NULL, 229573),
(231209, '3iv3A00', NULL, NULL, 332, NULL, NULL, 229573),
(231210, '1m5wA00', NULL, NULL, 243, NULL, NULL, 229573),
(231211, '3r12A00', NULL, NULL, 260, NULL, NULL, 229573),
(231212, '3dxiA00', NULL, NULL, 304, NULL, NULL, 229573),
(231213, '3vkjA00', NULL, NULL, 368, NULL, NULL, 229573),
(231214, '4ur7D00', NULL, NULL, 311, NULL, NULL, 229573),
(231215, '1jvnA02', NULL, NULL, 314, NULL, NULL, 229573),
(231216, '3kruC00', NULL, NULL, 343, NULL, NULL, 229573),
(231217, '3pajA02', NULL, NULL, 147, NULL, NULL, 229573),
(231218, '4wy0B00', NULL, NULL, 282, NULL, NULL, 229573),
(231219, '4wd0A00', NULL, NULL, 250, NULL, NULL, 229573),
(231220, '1kbiB01', NULL, NULL, 381, NULL, NULL, 229573),
(231221, '1nsjA00', NULL, NULL, 205, NULL, NULL, 229573),
(231222, '1f2jA00', NULL, NULL, 370, NULL, NULL, 229573),
(231223, '6cg9B00', NULL, NULL, 256, NULL, NULL, 229573),
(231224, '1eixC00', NULL, NULL, 245, NULL, NULL, 229573),
(231225, '2qr6A02', NULL, NULL, 359, NULL, NULL, 229573),
(231226, '5ocsA00', NULL, NULL, 371, NULL, NULL, 229573),
(231227, '2czdB00', NULL, NULL, 208, NULL, NULL, 229573),
(231228, '3jr2C00', NULL, NULL, 218, NULL, NULL, 229573),
(231229, '3ceuA00', NULL, NULL, 210, NULL, NULL, 229573),
(231230, '5lhfB00', NULL, NULL, 209, NULL, NULL, 229573),
(231231, '3ovpB00', NULL, NULL, 228, NULL, NULL, 229573),
(231232, '5c6mA00', NULL, NULL, 248, NULL, NULL, 229573),
(231233, '1fcqA00', NULL, NULL, 330, NULL, NULL, 229573),
(231234, '1q45A00', NULL, NULL, 391, NULL, NULL, 229573),
(231235, '3b4uA00', NULL, NULL, 294, NULL, NULL, 229573);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(231236, '4p2vF00', NULL, NULL, 293, NULL, NULL, 229573),
(231237, '1w1zA00', NULL, NULL, 328, NULL, NULL, 229573),
(231238, '1vqtA00', NULL, NULL, 213, NULL, NULL, 229573),
(231239, '4y96A00', NULL, NULL, 255, NULL, NULL, 229573),
(231240, '2vxnA00', NULL, NULL, 251, NULL, NULL, 229573),
(231241, '3myoA00', NULL, NULL, 333, NULL, NULL, 229573),
(231242, '3b5vA00', NULL, NULL, 248, NULL, NULL, 229573),
(231243, '3igsB00', NULL, NULL, 232, NULL, NULL, 229573),
(231244, '6f4cB01', NULL, NULL, 274, NULL, NULL, 229573),
(231245, '2rfgA00', NULL, NULL, 297, NULL, NULL, 229573),
(231246, '1vjiA00', NULL, NULL, 372, NULL, NULL, 229573),
(231247, '6b8sA00', NULL, NULL, 359, NULL, NULL, 229573),
(231248, '3nzrA00', NULL, NULL, 248, NULL, NULL, 229573),
(231249, '3r5eA00', NULL, NULL, 360, NULL, NULL, 229573),
(231250, '3ru6B00', NULL, NULL, 228, NULL, NULL, 229573),
(231251, '3mmtB00', NULL, NULL, 347, NULL, NULL, 229573),
(231252, '2iqtA00', NULL, NULL, 296, NULL, NULL, 229573),
(231253, '2iswB00', NULL, NULL, 323, NULL, NULL, 229573),
(231254, '3krsA00', NULL, NULL, 249, NULL, NULL, 229573),
(231255, '1xm3B00', NULL, NULL, 264, NULL, NULL, 229573),
(231256, '2y88A00', NULL, NULL, 244, NULL, NULL, 229573),
(231257, '1rd5A00', NULL, NULL, 262, NULL, NULL, 229573),
(231258, '4wuiA00', NULL, NULL, 207, NULL, NULL, 229573),
(231259, '1vcvA00', NULL, NULL, 226, NULL, NULL, 229573),
(231260, '1x7fA01', NULL, NULL, 242, NULL, NULL, 229573),
(231261, '4ph6A00', NULL, NULL, 256, NULL, NULL, 229573),
(231262, '1ps9A01', NULL, NULL, 368, NULL, NULL, 229573),
(231263, '2v2hA00', NULL, NULL, 242, NULL, NULL, 229573),
(231264, '3fkrA00', NULL, NULL, 309, NULL, NULL, 229573),
(231265, '4adsA00', NULL, NULL, 282, NULL, NULL, 229573),
(231266, '3kaoA00', NULL, NULL, 329, NULL, NULL, 229573),
(231267, '2qezE03', NULL, NULL, 313, NULL, NULL, 229573),
(231268, '3vcrA00', NULL, NULL, 217, NULL, NULL, 229573),
(231269, '3c6cA00', NULL, NULL, 296, NULL, NULL, 229573),
(231270, '3lrkA01', NULL, NULL, 287, NULL, NULL, 229573),
(231271, '3rmjA00', NULL, NULL, 330, NULL, NULL, 229573),
(231272, '1hg3A00', NULL, NULL, 225, NULL, NULL, 229573),
(231273, '2j27A00', NULL, NULL, 250, NULL, NULL, 229573),
(231274, '3fs2A00', NULL, NULL, 275, NULL, NULL, 229573),
(231275, '3ctlA00', NULL, NULL, 231, NULL, NULL, 229573),
(231276, '4u28A00', NULL, NULL, 245, NULL, NULL, 229573),
(231277, '3g8rA01', NULL, NULL, 260, NULL, NULL, 229573),
(231278, '3s1xA00', NULL, NULL, 223, NULL, NULL, 229573),
(231279, '2a4aA00', NULL, NULL, 260, NULL, NULL, 229573),
(231280, '1rvgA00', NULL, NULL, 305, NULL, NULL, 229573),
(231281, '2pcqA00', NULL, NULL, 283, NULL, NULL, 229573),
(231282, '3ewbX00', NULL, NULL, 277, NULL, NULL, 229573),
(231283, '4fiqA00', NULL, NULL, 316, NULL, NULL, 229573),
(231284, '3tjlA00', NULL, NULL, 407, NULL, NULL, 229573),
(231285, '4m7tA00', NULL, NULL, 250, NULL, NULL, 229573),
(231286, '3elfA00', NULL, NULL, 349, NULL, NULL, 229573),
(231287, '4locA02', NULL, NULL, 288, NULL, NULL, 229573),
(231288, '1z41A00', NULL, NULL, 338, NULL, NULL, 229573),
(231289, '4bfaA01', NULL, NULL, 244, NULL, NULL, 229573),
(231290, '2htmC00', NULL, NULL, 241, NULL, NULL, 229573),
(231291, '3sgzB00', NULL, NULL, 352, NULL, NULL, 229573),
(231292, '3tw6B03', NULL, NULL, 528, NULL, NULL, 229573),
(231293, '1phwA00', NULL, NULL, 284, NULL, NULL, 229573),
(231294, '3bg3B02', NULL, NULL, 289, NULL, NULL, 229573),
(231295, '3cwnA00', NULL, NULL, 316, NULL, NULL, 229573),
(231296, '3vndA00', NULL, NULL, 267, NULL, NULL, 229573),
(231297, '2btmA00', NULL, NULL, 252, NULL, NULL, 229573),
(231298, '4x9sA00', NULL, NULL, 246, NULL, NULL, 229573),
(231299, '5dbuJ00', NULL, NULL, 223, NULL, NULL, 229573),
(231300, '2pe4A00', NULL, NULL, 424, NULL, NULL, 229573),
(231301, '2ehhC00', NULL, NULL, 294, NULL, NULL, 229573),
(231302, '3m6yA00', NULL, NULL, 252, NULL, NULL, 229573),
(231303, '2atmA00', NULL, NULL, 331, NULL, NULL, 229573),
(231304, '1xcfA00', NULL, NULL, 268, NULL, NULL, 229573),
(231305, '6i55B00', NULL, NULL, 382, NULL, NULL, 229573),
(231306, '3takA00', NULL, NULL, 291, NULL, NULL, 229573);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(231307, '2c6qG00', NULL, NULL, 333, NULL, NULL, 229573),
(231308, '1h1yA00', NULL, NULL, 228, NULL, NULL, 229573),
(231309, '2tpsB00', NULL, NULL, 227, NULL, NULL, 229573),
(231310, '3ldvA00', NULL, NULL, 232, NULL, NULL, 229573),
(231311, '1ujpA00', NULL, NULL, 271, NULL, NULL, 229573),
(231312, '3m0zD00', NULL, NULL, 249, NULL, NULL, 229573),
(231313, '4j9jA00', NULL, NULL, 246, NULL, NULL, 229573),
(231314, '2ffcA00', NULL, NULL, 334, NULL, NULL, 229573),
(231315, '3txvA01', NULL, NULL, 269, NULL, NULL, 229573),
(231316, '2jgqA00', NULL, NULL, 233, NULL, NULL, 229573),
(231317, '1wv2A00', NULL, NULL, 265, NULL, NULL, 229573),
(231318, '2gjlA00', NULL, NULL, 328, NULL, NULL, 229573),
(231319, '4e38C00', NULL, NULL, 232, NULL, NULL, 229573),
(231320, '3ta6B00', NULL, NULL, 267, NULL, NULL, 229573),
(231321, '4c1lA00', NULL, NULL, 262, NULL, NULL, 229573),
(231322, '3ivsA01', NULL, NULL, 277, NULL, NULL, 229573),
(231323, '3g0sB00', NULL, NULL, 294, NULL, NULL, 229573),
(231324, '3fluB00', NULL, NULL, 297, NULL, NULL, 229573),
(231325, '5k4xA00', NULL, NULL, 368, NULL, NULL, 229573),
(231326, '3upbB00', NULL, NULL, 319, NULL, NULL, 229573),
(231327, '2ojpA00', NULL, NULL, 292, NULL, NULL, 229573),
(231328, '3r8rA00', NULL, NULL, 212, NULL, NULL, 229573),
(231329, '4ymzA00', NULL, NULL, 251, NULL, NULL, 229573),
(231330, '2cw6D00', NULL, NULL, 298, NULL, NULL, 229573),
(231331, '4fnqA02', NULL, NULL, 323, NULL, NULL, 229573),
(231332, '4wozC00', NULL, NULL, 302, NULL, NULL, 229573),
(231333, '1gvfB00', NULL, NULL, 286, NULL, NULL, 229573),
(231334, '4dnhA01', NULL, NULL, 383, NULL, NULL, 229573),
(231335, '4ou1A00', NULL, NULL, 258, NULL, NULL, 229573),
(231336, '3uzjA00', NULL, NULL, 252, NULL, NULL, 229573),
(231337, '3oa3A00', NULL, NULL, 267, NULL, NULL, 229573),
(231338, '2qapA00', NULL, NULL, 371, NULL, NULL, 229573),
(231339, '2nzlA00', NULL, NULL, 367, NULL, NULL, 229573),
(231340, '3e96A00', NULL, NULL, 316, NULL, NULL, 229573),
(231341, '4n4pD00', NULL, NULL, 296, NULL, NULL, 229573),
(231342, '3hq1A01', NULL, NULL, 377, NULL, NULL, 229573),
(231343, '4o0kA00', NULL, NULL, 329, NULL, NULL, 229573),
(231344, '6djtA00', NULL, NULL, 312, NULL, NULL, 229573),
(231345, '6mqhA00', NULL, NULL, 308, NULL, NULL, 229573),
(231346, '2vc6A00', NULL, NULL, 292, NULL, NULL, 229573),
(231347, '5lkyB00', NULL, NULL, 300, NULL, NULL, 229573),
(231348, '2hsaB00', NULL, NULL, 386, NULL, NULL, 229573),
(231349, '3tuuA00', NULL, NULL, 307, NULL, NULL, 229573),
(231350, '4ly8B00', NULL, NULL, 306, NULL, NULL, 229573),
(231351, '3nq8A00', NULL, NULL, 251, NULL, NULL, 229573),
(231352, '1y0eA00', NULL, NULL, 223, NULL, NULL, 229573),
(231353, '2cwnB00', NULL, NULL, 332, NULL, NULL, 229573),
(231354, '1xfbA00', NULL, NULL, 344, NULL, NULL, 229573),
(231355, '4fezA00', NULL, NULL, 332, NULL, NULL, 229573),
(231356, '3o6yX00', NULL, NULL, 258, NULL, NULL, 229573),
(231357, '3obkA00', NULL, NULL, 356, NULL, NULL, 229573),
(231358, '1w3iA00', NULL, NULL, 293, NULL, NULL, 229573),
(231359, '2nwrA00', NULL, NULL, 267, NULL, NULL, 229573),
(231360, '3e49A00', NULL, NULL, 311, NULL, NULL, 229573),
(231361, '4qnwA00', NULL, NULL, 376, NULL, NULL, 229573),
(231362, '1w8sE00', NULL, NULL, 263, NULL, NULL, 229573),
(231363, '6neeB00', NULL, NULL, 252, NULL, NULL, 229573),
(231364, '2bleA00', NULL, NULL, 345, NULL, NULL, 229573),
(231365, '3eb2A00', NULL, NULL, 300, NULL, NULL, 229573),
(231366, '4jtfB00', NULL, NULL, 280, NULL, NULL, 229573),
(231367, '3f4nC00', NULL, NULL, 246, NULL, NULL, 229573),
(231368, '4mvaA00', NULL, NULL, 255, NULL, NULL, 229573),
(231369, '3m9yB00', NULL, NULL, 254, NULL, NULL, 229573),
(231370, '2yfoA02', NULL, NULL, 315, NULL, NULL, 229573),
(231371, '3gk0A00', NULL, NULL, 255, NULL, NULL, 229573),
(231372, '4dbdA00', NULL, NULL, 222, NULL, NULL, 229573),
(231373, '3ewwA00', NULL, NULL, 260, NULL, NULL, 229573),
(231374, '4ef8B01', NULL, NULL, 278, NULL, NULL, 229573),
(231375, '4n6fA00', NULL, NULL, 256, NULL, NULL, 229573),
(231376, '3a5vA01', NULL, NULL, 298, NULL, NULL, 229573),
(231377, '4nzjA02', NULL, NULL, 296, NULL, NULL, 229573);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(231378, '4aduA00', NULL, NULL, 297, NULL, NULL, 229573),
(231379, '6gvdA02', NULL, NULL, 325, NULL, NULL, 229573),
(231380, '3o1nA00', NULL, NULL, 252, NULL, NULL, 229573),
(231381, '5kswC00', NULL, NULL, 306, NULL, NULL, 229573),
(231382, '4luiB00', NULL, NULL, 215, NULL, NULL, 229573),
(231383, '1gteB05', NULL, NULL, 312, NULL, NULL, 229573),
(231384, '3sr7A00', NULL, NULL, 314, NULL, NULL, 229573),
(231385, '4cnnB00', NULL, NULL, 252, NULL, NULL, 229573),
(231386, '4jn6A01', NULL, NULL, 269, NULL, NULL, 229573),
(231387, '1o4uB02', NULL, NULL, 155, NULL, NULL, 229573),
(231388, '3qzeB00', NULL, NULL, 291, NULL, NULL, 229573),
(231389, '2w79A00', NULL, NULL, 241, NULL, NULL, 229573),
(231390, '5zg5A00', NULL, NULL, 248, NULL, NULL, 229573),
(231391, '1h7nA00', NULL, NULL, 342, NULL, NULL, 229573),
(231392, '3o63A00', NULL, NULL, 223, NULL, NULL, 229573),
(231393, '4af0A00', NULL, NULL, 422, NULL, NULL, 229573),
(231394, '3f4wA00', NULL, NULL, 211, NULL, NULL, 229573),
(231395, '2qjgA00', NULL, NULL, 273, NULL, NULL, 229573),
(231396, '1o5kA00', NULL, NULL, 306, NULL, NULL, 229573),
(231397, '5cg7B00', NULL, NULL, 249, NULL, NULL, 229573),
(231398, '4obtA00', NULL, NULL, 257, NULL, NULL, 229573),
(231399, '3ffsC00', NULL, NULL, 311, NULL, NULL, 229573),
(231400, '3qw3A01', NULL, NULL, 254, NULL, NULL, 229573),
(231401, '2fjkD00', NULL, NULL, 305, NULL, NULL, 229573),
(231402, '1x1oA02', NULL, NULL, 143, NULL, NULL, 229573),
(231403, '3inpA00', NULL, NULL, 220, NULL, NULL, 229573),
(231404, '2hmcA00', NULL, NULL, 327, NULL, NULL, 229573),
(231405, '2y7eB00', NULL, NULL, 282, NULL, NULL, 229573),
(231406, '5ibxC00', NULL, NULL, 255, NULL, NULL, 229573),
(231407, '3a21B01', NULL, NULL, 295, NULL, NULL, 229573),
(231408, '4n02A00', NULL, NULL, 335, NULL, NULL, 229573),
(231409, '3tdnB00', NULL, NULL, 247, NULL, NULL, 229573),
(231410, '4mozD00', NULL, NULL, 319, NULL, NULL, 229573),
(231411, '3lotA00', NULL, NULL, 314, NULL, NULL, 229573),
(231412, '3o07A00', NULL, NULL, 268, NULL, NULL, 229573),
(231413, '4aajA00', NULL, NULL, 209, NULL, NULL, 229573),
(231414, '2yzrC00', NULL, NULL, 313, NULL, NULL, 229573),
(231415, '1qapA02', NULL, NULL, 153, NULL, NULL, 229573),
(231416, '3r2gA00', NULL, NULL, 328, NULL, NULL, 229573),
(231417, '3s5oA00', NULL, NULL, 307, NULL, NULL, 229573),
(231418, '3bleA00', NULL, NULL, 319, NULL, NULL, 229573),
(231419, '1ktbA01', NULL, NULL, 291, NULL, NULL, 229573),
(231420, '4d2jA00', NULL, NULL, 353, NULL, NULL, 229573),
(231421, '4b5nA00', NULL, NULL, 355, NULL, NULL, 229573),
(231422, '3fa5A00', NULL, NULL, 282, NULL, NULL, 229573),
(231423, '3qc3B00', NULL, NULL, 225, NULL, NULL, 229573),
(231424, '4e2bA00', NULL, NULL, 382, NULL, NULL, 229573),
(231425, '3t7vA00', NULL, NULL, 350, NULL, NULL, 229573),
(231426, '4wzhA01', NULL, NULL, 269, NULL, NULL, 229573),
(231427, '3kxqA00', NULL, NULL, 250, NULL, NULL, 229573),
(231428, '5csrC00', NULL, NULL, 226, NULL, NULL, 229573),
(231429, '5xfwD01', NULL, NULL, 271, NULL, NULL, 229573),
(231430, '4df0A00', NULL, NULL, 202, NULL, NULL, 229573),
(231431, '1fbaA00', NULL, NULL, 361, NULL, NULL, 229573),
(231432, '4y90A00', NULL, NULL, 247, NULL, NULL, 229573),
(231433, '3c2eA02', NULL, NULL, 149, NULL, NULL, 229573),
(231434, '4ipiA01', NULL, NULL, 271, NULL, NULL, 229573),
(231435, '5xseA00', NULL, NULL, 208, NULL, NULL, 229573),
(231436, '1ofdA02', NULL, NULL, 345, NULL, NULL, 229573),
(231437, '1mo0A00', NULL, NULL, 275, NULL, NULL, 229573),
(231438, '1of8A00', NULL, NULL, 348, NULL, NULL, 229573),
(231439, '4oe7A00', NULL, NULL, 298, NULL, NULL, 229573),
(231440, '3hblD04', NULL, NULL, 420, NULL, NULL, 229573),
(231441, '5ktlA00', NULL, NULL, 295, NULL, NULL, 229573),
(231442, '1u83A00', NULL, NULL, 252, NULL, NULL, 229573),
(231443, '1ka9F00', NULL, NULL, 252, NULL, NULL, 229573),
(231444, '4tmbB00', NULL, NULL, 403, NULL, NULL, 229573),
(231445, '5vjeA00', NULL, NULL, 358, NULL, NULL, 229573),
(231446, '1vliA01', NULL, NULL, 315, NULL, NULL, 229573),
(231447, '4hhpB00', NULL, NULL, 251, NULL, NULL, 229573),
(231448, '1ofdA03', NULL, NULL, 469, NULL, NULL, 229573);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(231449, '5eywA00', NULL, NULL, 249, NULL, NULL, 229573),
(231450, '6mdyD00', NULL, NULL, 282, NULL, NULL, 229573),
(231451, '3tc6A00', NULL, NULL, 258, NULL, NULL, 229573),
(231452, '3na8B00', NULL, NULL, 293, NULL, NULL, 229573),
(231453, '3usbB00', NULL, NULL, 443, NULL, NULL, 229573),
(231454, '3r89A00', NULL, NULL, 290, NULL, NULL, 229573),
(231455, '1jr1A00', NULL, NULL, 498, NULL, NULL, 229573),
(231456, '3n3mB00', NULL, NULL, 324, NULL, NULL, 229573),
(231457, '3tmlB00', NULL, NULL, 288, NULL, NULL, 229573),
(231458, '4ijbA00', NULL, NULL, 256, NULL, NULL, 229573),
(231459, '5lzlA00', NULL, NULL, 338, NULL, NULL, 229573),
(231460, '5kmyA00', NULL, NULL, 275, NULL, NULL, 229573),
(231461, '1rqhA01', NULL, NULL, 284, NULL, NULL, 229573),
(231462, '3gr7A00', NULL, NULL, 340, NULL, NULL, 229573),
(231463, '1p4cA00', NULL, NULL, 356, NULL, NULL, 229573),
(231464, '4imeA00', NULL, NULL, 293, NULL, NULL, 229573),
(231465, '4a2rA00', NULL, NULL, 258, NULL, NULL, 229573),
(231466, '5afdA00', NULL, NULL, 300, NULL, NULL, 229573),
(231467, '1mzhA00', NULL, NULL, 225, NULL, NULL, 229573),
(231468, '3qc3A00', NULL, NULL, 225, NULL, NULL, 229573),
(231469, '3si9B00', NULL, NULL, 295, NULL, NULL, 229573),
(231470, '2r91A00', NULL, NULL, 286, NULL, NULL, 229573),
(231471, '5an7A00', NULL, NULL, 258, NULL, NULL, 229573),
(231472, '5dlcA00', NULL, NULL, 256, NULL, NULL, 229573),
(231473, '5zjbA00', NULL, NULL, 234, NULL, NULL, 229573),
(231474, '3e9aA00', NULL, NULL, 286, NULL, NULL, 229573),
(231475, '1tv8B00', NULL, NULL, 340, NULL, NULL, 229573),
(231476, '1i4nA00', NULL, NULL, 251, NULL, NULL, 229573),
(231477, '1l6sA00', NULL, NULL, 323, NULL, NULL, 229573),
(231478, '4ab4A00', NULL, NULL, 362, NULL, NULL, 229573),
(231479, '4bi6A00', NULL, NULL, 257, NULL, NULL, 229573),
(231480, '3bw2A00', NULL, NULL, 352, NULL, NULL, 229573),
(231481, '5umfC00', NULL, NULL, 235, NULL, NULL, 229573),
(231482, '3tr2B00', NULL, NULL, 239, NULL, NULL, 229573),
(231483, '3cq0B00', NULL, NULL, 339, NULL, NULL, 229573),
(231484, '1ydnA00', NULL, NULL, 295, NULL, NULL, 229573),
(231485, '3v75A01', NULL, NULL, 276, NULL, NULL, 229573),
(231486, '1icpA00', NULL, NULL, 376, NULL, NULL, 229573),
(231487, '1jr1B00', NULL, NULL, 394, NULL, NULL, 229573),
(231488, '1zfjA00', NULL, NULL, 491, NULL, NULL, 229573),
(231489, '4g1kA00', NULL, NULL, 248, NULL, NULL, 229573),
(231490, '6bveA00', NULL, NULL, 245, NULL, NULL, 229573),
(231491, '3r6oA01', NULL, NULL, 78, NULL, NULL, 229574),
(231492, '1n7xA01', NULL, NULL, 166, NULL, NULL, 229575),
(231493, '2v84A02', NULL, NULL, 158, NULL, NULL, 229575),
(231494, '2v84A01', NULL, NULL, 161, NULL, NULL, 229575),
(231495, '4onyA01', NULL, NULL, 335, NULL, NULL, 229575),
(231496, '4rpoA02', NULL, NULL, 101, NULL, NULL, 229575),
(231497, '5jk4A01', NULL, NULL, 224, NULL, NULL, 229575),
(231498, '5jk4A02', NULL, NULL, 149, NULL, NULL, 229575),
(231499, '4wxjB01', NULL, NULL, 161, NULL, NULL, 229575),
(231500, '4rpoA01', NULL, NULL, 122, NULL, NULL, 229575),
(231501, '3tchA01', NULL, NULL, 184, NULL, NULL, 229575),
(231502, '2pyyB01', NULL, NULL, 131, NULL, NULL, 229575),
(231503, '3qslA01', NULL, NULL, 207, NULL, NULL, 229575),
(231504, '3qslA02', NULL, NULL, 111, NULL, NULL, 229575),
(231505, '3todA01', NULL, NULL, 134, NULL, NULL, 229575),
(231506, '3vxbA01', NULL, NULL, 193, NULL, NULL, 229575),
(231507, '3todA02', NULL, NULL, 192, NULL, NULL, 229575),
(231508, '3cg1A01', NULL, NULL, 129, NULL, NULL, 229575),
(231509, '1eu8A02', NULL, NULL, 219, NULL, NULL, 229575),
(231510, '3cg1A02', NULL, NULL, 167, NULL, NULL, 229575),
(231511, '1ryoA02', NULL, NULL, 165, NULL, NULL, 229575),
(231512, '5eyfB01', NULL, NULL, 147, NULL, NULL, 229575),
(231513, '3kn3B01', NULL, NULL, 124, NULL, NULL, 229575),
(231514, '4jdfA01', NULL, NULL, 170, NULL, NULL, 229575),
(231515, '1ryoA01', NULL, NULL, 146, NULL, NULL, 229575),
(231516, '4jdfA02', NULL, NULL, 183, NULL, NULL, 229575),
(231517, '1eu8A01', NULL, NULL, 190, NULL, NULL, 229575),
(231518, '1uqwA01', NULL, NULL, 112, NULL, NULL, 229575),
(231519, '1cb6A04', NULL, NULL, 160, NULL, NULL, 229575);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(231520, '4ry1A01', NULL, NULL, 180, NULL, NULL, 229575),
(231521, '5ehmB01', NULL, NULL, 161, NULL, NULL, 229575),
(231522, '4ry1A02', NULL, NULL, 231, NULL, NULL, 229575),
(231523, '1cb6A03', NULL, NULL, 192, NULL, NULL, 229575),
(231524, '1cb6A02', NULL, NULL, 159, NULL, NULL, 229575),
(231525, '1cb6A01', NULL, NULL, 180, NULL, NULL, 229575),
(231526, '3oxnA01', NULL, NULL, 141, NULL, NULL, 229575),
(231527, '4oevA01', NULL, NULL, 155, NULL, NULL, 229575),
(231528, '4f3sA01', NULL, NULL, 135, NULL, NULL, 229575),
(231529, '4aq4A02', NULL, NULL, 217, NULL, NULL, 229575),
(231530, '4ombA02', NULL, NULL, 144, NULL, NULL, 229575),
(231531, '4aq4A01', NULL, NULL, 202, NULL, NULL, 229575),
(231532, '4ombA01', NULL, NULL, 168, NULL, NULL, 229575),
(231533, '4kysB01', NULL, NULL, 177, NULL, NULL, 229575),
(231534, '3lr1A01', NULL, NULL, 122, NULL, NULL, 229575),
(231535, '3lr1A02', NULL, NULL, 114, NULL, NULL, 229575),
(231536, '4rk2A00', NULL, NULL, 400, NULL, NULL, 229575),
(231537, '1sbpA02', NULL, NULL, 159, NULL, NULL, 229575),
(231538, '1sbpA01', NULL, NULL, 151, NULL, NULL, 229575),
(231539, '4q0cA01', NULL, NULL, 155, NULL, NULL, 229575),
(231540, '4q0cA02', NULL, NULL, 95, NULL, NULL, 229575),
(231541, '4gliA02', NULL, NULL, 216, NULL, NULL, 229575),
(231542, '3ecrA02', NULL, NULL, 104, NULL, NULL, 229575),
(231543, '3g3gA01', NULL, NULL, 154, NULL, NULL, 229575),
(231544, '3uorB02', NULL, NULL, 206, NULL, NULL, 229575),
(231545, '3q27A02', NULL, NULL, 211, NULL, NULL, 229575),
(231546, '3uorB01', NULL, NULL, 189, NULL, NULL, 229575),
(231547, '3fzvA03', NULL, NULL, 106, NULL, NULL, 229575),
(231548, '4wxjA02', NULL, NULL, 108, NULL, NULL, 229575),
(231549, '5ubgA01', NULL, NULL, 140, NULL, NULL, 229575),
(231550, '3kn3A02', NULL, NULL, 118, NULL, NULL, 229575),
(231551, '4r6yA01', NULL, NULL, 160, NULL, NULL, 229575),
(231552, '3cvgA01', NULL, NULL, 169, NULL, NULL, 229575),
(231553, '3cvgA02', NULL, NULL, 124, NULL, NULL, 229575),
(231554, '4r6yA02', NULL, NULL, 158, NULL, NULL, 229575),
(231555, '2h98A01', NULL, NULL, 118, NULL, NULL, 229575),
(231556, '3m8uA01', NULL, NULL, 135, NULL, NULL, 229575),
(231557, '2h98A02', NULL, NULL, 107, NULL, NULL, 229575),
(231558, '3gbaA02', NULL, NULL, 105, NULL, NULL, 229575),
(231559, '2f5xA02', NULL, NULL, 124, NULL, NULL, 229575),
(231560, '1xt8A01', NULL, NULL, 168, NULL, NULL, 229575),
(231561, '1pc3A01', NULL, NULL, 141, NULL, NULL, 229575),
(231562, '3ix1A02', NULL, NULL, 103, NULL, NULL, 229575),
(231563, '4kysA02', NULL, NULL, 182, NULL, NULL, 229575),
(231564, '1xt8A02', NULL, NULL, 91, NULL, NULL, 229575),
(231565, '4i1dC02', NULL, NULL, 145, NULL, NULL, 229575),
(231566, '4lvqA01', NULL, NULL, 161, NULL, NULL, 229575),
(231567, '4i1dC01', NULL, NULL, 178, NULL, NULL, 229575),
(231568, '3ho7A02', NULL, NULL, 102, NULL, NULL, 229575),
(231569, '3ho7A01', NULL, NULL, 130, NULL, NULL, 229575),
(231570, '1pc3A02', NULL, NULL, 184, NULL, NULL, 229575),
(231571, '3ix1A01', NULL, NULL, 199, NULL, NULL, 229575),
(231572, '3mc2A01', NULL, NULL, 182, NULL, NULL, 229575),
(231573, '4lvqA02', NULL, NULL, 166, NULL, NULL, 229575),
(231574, '3mc2A02', NULL, NULL, 152, NULL, NULL, 229575),
(231575, '3mc2A03', NULL, NULL, 190, NULL, NULL, 229575),
(231576, '1dpeA02', NULL, NULL, 119, NULL, NULL, 229575),
(231577, '3mc2A04', NULL, NULL, 159, NULL, NULL, 229575),
(231578, '3cijA02', NULL, NULL, 171, NULL, NULL, 229575),
(231579, '3vxcA02', NULL, NULL, 206, NULL, NULL, 229575),
(231580, '2pt1A02', NULL, NULL, 168, NULL, NULL, 229575),
(231581, '5b7hB01', NULL, NULL, 114, NULL, NULL, 229575),
(231582, '5uh0A02', NULL, NULL, 93, NULL, NULL, 229575),
(231583, '5uh0A01', NULL, NULL, 150, NULL, NULL, 229575),
(231584, '3ecrB01', NULL, NULL, 117, NULL, NULL, 229575),
(231585, '6dtuA01', NULL, NULL, 184, NULL, NULL, 229575),
(231586, '4esxB01', NULL, NULL, 200, NULL, NULL, 229575),
(231587, '6cvaA01', NULL, NULL, 132, NULL, NULL, 229575),
(231588, '6cvaA02', NULL, NULL, 109, NULL, NULL, 229575),
(231589, '3q25A02', NULL, NULL, 204, NULL, NULL, 229575),
(231590, '3k4uE01', NULL, NULL, 146, NULL, NULL, 229575);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(231591, '6fccA02', NULL, NULL, 82, NULL, NULL, 229575),
(231592, '3ttmA02', NULL, NULL, 173, NULL, NULL, 229575),
(231593, '2o1mA02', NULL, NULL, 121, NULL, NULL, 229575),
(231594, '3ttmA01', NULL, NULL, 173, NULL, NULL, 229575),
(231595, '6fccA01', NULL, NULL, 129, NULL, NULL, 229575),
(231596, '2y7pA01', NULL, NULL, 119, NULL, NULL, 229575),
(231597, '3waeB01', NULL, NULL, 149, NULL, NULL, 229575),
(231598, '2o1mA01', NULL, NULL, 137, NULL, NULL, 229575),
(231599, '2y7pA02', NULL, NULL, 99, NULL, NULL, 229575),
(231600, '1bgr004', NULL, NULL, 160, NULL, NULL, 229575),
(231601, '4ne4A01', NULL, NULL, 172, NULL, NULL, 229575),
(231602, '5cmmA02', NULL, NULL, 105, NULL, NULL, 229575),
(231603, '1bgr001', NULL, NULL, 181, NULL, NULL, 229575),
(231604, '1bgr003', NULL, NULL, 190, NULL, NULL, 229575),
(231605, '2vozA02', NULL, NULL, 170, NULL, NULL, 229575),
(231606, '4q5tA01', NULL, NULL, 147, NULL, NULL, 229575),
(231607, '4q5tA02', NULL, NULL, 110, NULL, NULL, 229575),
(231608, '3pu5A02', NULL, NULL, 167, NULL, NULL, 229575),
(231609, '3kotA02', NULL, NULL, 97, NULL, NULL, 229575),
(231610, '4gqoA02', NULL, NULL, 204, NULL, NULL, 229575),
(231611, '3qufA01', NULL, NULL, 156, NULL, NULL, 229575),
(231612, '4gqoA01', NULL, NULL, 200, NULL, NULL, 229575),
(231613, '3pu5A01', NULL, NULL, 166, NULL, NULL, 229575),
(231614, '2vd3A01', NULL, NULL, 124, NULL, NULL, 229575),
(231615, '2h9bA02', NULL, NULL, 107, NULL, NULL, 229575),
(231616, '3fasA01', NULL, NULL, 146, NULL, NULL, 229575),
(231617, '3qufA02', NULL, NULL, 232, NULL, NULL, 229575),
(231618, '3fasA02', NULL, NULL, 109, NULL, NULL, 229575),
(231619, '4eswA02', NULL, NULL, 111, NULL, NULL, 229575),
(231620, '2ieeA01', NULL, NULL, 143, NULL, NULL, 229575),
(231621, '5lomA01', NULL, NULL, 157, NULL, NULL, 229575),
(231622, '1al3A01', NULL, NULL, 101, NULL, NULL, 229575),
(231623, '5lomA02', NULL, NULL, 91, NULL, NULL, 229575),
(231624, '2hxwA01', NULL, NULL, 124, NULL, NULL, 229575),
(231625, '1al3A02', NULL, NULL, 136, NULL, NULL, 229575),
(231626, '2ieeA02', NULL, NULL, 100, NULL, NULL, 229575),
(231627, '5i84C01', NULL, NULL, 148, NULL, NULL, 229575),
(231628, '5i84C02', NULL, NULL, 166, NULL, NULL, 229575),
(231629, '2gh9A02', NULL, NULL, 199, NULL, NULL, 229575),
(231630, '5teuA01', NULL, NULL, 187, NULL, NULL, 229575),
(231631, '2gh9A01', NULL, NULL, 187, NULL, NULL, 229575),
(231632, '4g68A02', NULL, NULL, 206, NULL, NULL, 229575),
(231633, '5l9iB02', NULL, NULL, 156, NULL, NULL, 229575),
(231634, '5l9iB01', NULL, NULL, 176, NULL, NULL, 229575),
(231635, '6g7nA02', NULL, NULL, 170, NULL, NULL, 229575),
(231636, '4g68A01', NULL, NULL, 188, NULL, NULL, 229575),
(231637, '6g7nA01', NULL, NULL, 148, NULL, NULL, 229575),
(231638, '6dtuB02', NULL, NULL, 191, NULL, NULL, 229575),
(231639, '1b1xA03', NULL, NULL, 190, NULL, NULL, 229575),
(231640, '1b1xA04', NULL, NULL, 160, NULL, NULL, 229575),
(231641, '1b1xA01', NULL, NULL, 180, NULL, NULL, 229575),
(231642, '3cfzA02', NULL, NULL, 170, NULL, NULL, 229575),
(231643, '5l9sA02', NULL, NULL, 124, NULL, NULL, 229575),
(231644, '2vd3A02', NULL, NULL, 91, NULL, NULL, 229575),
(231645, '1b1xA02', NULL, NULL, 159, NULL, NULL, 229575),
(231646, '3cfzA01', NULL, NULL, 122, NULL, NULL, 229575),
(231647, '3ppqA01', NULL, NULL, 166, NULL, NULL, 229575),
(231648, '3kosA02', NULL, NULL, 97, NULL, NULL, 229575),
(231649, '3kosA01', NULL, NULL, 122, NULL, NULL, 229575),
(231650, '3k6vA01', NULL, NULL, 140, NULL, NULL, 229575),
(231651, '2o7iA01', NULL, NULL, 174, NULL, NULL, 229575),
(231652, '3q26A00', NULL, NULL, 404, NULL, NULL, 229575),
(231653, '1zbmA01', NULL, NULL, 188, NULL, NULL, 229575),
(231654, '4euoA01', NULL, NULL, 198, NULL, NULL, 229575),
(231655, '1zbmA02', NULL, NULL, 92, NULL, NULL, 229575),
(231656, '4euoA02', NULL, NULL, 122, NULL, NULL, 229575),
(231657, '2grvA01', NULL, NULL, 175, NULL, NULL, 229575),
(231658, '4jwxA01', NULL, NULL, 167, NULL, NULL, 229575),
(231659, '4jwxA02', NULL, NULL, 107, NULL, NULL, 229575),
(231660, '4kqpA01', NULL, NULL, 136, NULL, NULL, 229575),
(231661, '4h5gA01', NULL, NULL, 148, NULL, NULL, 229575);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(231662, '4kqpA02', NULL, NULL, 96, NULL, NULL, 229575),
(231663, '4h5gA02', NULL, NULL, 95, NULL, NULL, 229575),
(231664, '1yaeE01', NULL, NULL, 158, NULL, NULL, 229575),
(231665, '2esnA02', NULL, NULL, 118, NULL, NULL, 229575),
(231666, '2esnA03', NULL, NULL, 99, NULL, NULL, 229575),
(231667, '4gvoA02', NULL, NULL, 121, NULL, NULL, 229575),
(231668, '4gvoA01', NULL, NULL, 122, NULL, NULL, 229575),
(231669, '2qmwA02', NULL, NULL, 81, NULL, NULL, 229575),
(231670, '1ve4A02', NULL, NULL, 83, NULL, NULL, 229575),
(231671, '1ve4A01', NULL, NULL, 123, NULL, NULL, 229575),
(231672, '2qmwA01', NULL, NULL, 97, NULL, NULL, 229575),
(231673, '5l9sB01', NULL, NULL, 208, NULL, NULL, 229575),
(231674, '5icqA01', NULL, NULL, 317, NULL, NULL, 229575),
(231675, '4f3pA02', NULL, NULL, 96, NULL, NULL, 229575),
(231676, '3p7iA02', NULL, NULL, 112, NULL, NULL, 229575),
(231677, '3lc8A02', NULL, NULL, 201, NULL, NULL, 229575),
(231678, '4f3pA01', NULL, NULL, 130, NULL, NULL, 229575),
(231679, '3p7iA01', NULL, NULL, 147, NULL, NULL, 229575),
(231680, '6npoA01', NULL, NULL, 168, NULL, NULL, 229575),
(231681, '4q8rA01', NULL, NULL, 125, NULL, NULL, 229575),
(231682, '4q8rA02', NULL, NULL, 127, NULL, NULL, 229575),
(231683, '3muqA02', NULL, NULL, 113, NULL, NULL, 229575),
(231684, '3muqA01', NULL, NULL, 124, NULL, NULL, 229575),
(231685, '2czlA02', NULL, NULL, 93, NULL, NULL, 229575),
(231686, '3uifA01', NULL, NULL, 228, NULL, NULL, 229575),
(231687, '2x7qA01', NULL, NULL, 219, NULL, NULL, 229575),
(231688, '2x7qA02', NULL, NULL, 102, NULL, NULL, 229575),
(231689, '1hslA02', NULL, NULL, 101, NULL, NULL, 229575),
(231690, '2vd2A01', NULL, NULL, 132, NULL, NULL, 229575),
(231691, '1hslA01', NULL, NULL, 137, NULL, NULL, 229575),
(231692, '2vd2A02', NULL, NULL, 82, NULL, NULL, 229575),
(231693, '3uifA02', NULL, NULL, 102, NULL, NULL, 229575),
(231694, '1gvcA00', NULL, NULL, 157, NULL, NULL, 229575),
(231695, '2y7iA01', NULL, NULL, 135, NULL, NULL, 229575),
(231696, '2y7iA02', NULL, NULL, 94, NULL, NULL, 229575),
(231697, '3fd3A02', NULL, NULL, 101, NULL, NULL, 229575),
(231698, '3fd3A01', NULL, NULL, 107, NULL, NULL, 229575),
(231699, '3gzgA02', NULL, NULL, 112, NULL, NULL, 229575),
(231700, '3gzgA01', NULL, NULL, 120, NULL, NULL, 229575),
(231701, '3w9vA01', NULL, NULL, 220, NULL, NULL, 229575),
(231702, '3w9vA02', NULL, NULL, 156, NULL, NULL, 229575),
(231703, '5yqwA01', NULL, NULL, 179, NULL, NULL, 229575),
(231704, '5z6bA02', NULL, NULL, 218, NULL, NULL, 229575),
(231705, '5z6bA01', NULL, NULL, 176, NULL, NULL, 229575),
(231706, '3u1oB02', NULL, NULL, 235, NULL, NULL, 229575),
(231707, '2b3fA01', NULL, NULL, 191, NULL, NULL, 229575),
(231708, '5ci5B02', NULL, NULL, 210, NULL, NULL, 229575),
(231709, '4i62A01', NULL, NULL, 144, NULL, NULL, 229575),
(231710, '3jv9A02', NULL, NULL, 108, NULL, NULL, 229575),
(231711, '4ib2A01', NULL, NULL, 147, NULL, NULL, 229575),
(231712, '3jv9A01', NULL, NULL, 111, NULL, NULL, 229575),
(231713, '4i62A02', NULL, NULL, 94, NULL, NULL, 229575),
(231714, '4ib2A02', NULL, NULL, 105, NULL, NULL, 229575),
(231715, '5josA01', NULL, NULL, 151, NULL, NULL, 229575),
(231716, '3luyA01', NULL, NULL, 120, NULL, NULL, 229575),
(231717, '4edpA02', NULL, NULL, 156, NULL, NULL, 229575),
(231718, '4ze8A01', NULL, NULL, 171, NULL, NULL, 229575),
(231719, '5josA02', NULL, NULL, 96, NULL, NULL, 229575),
(231720, '3luyA02', NULL, NULL, 74, NULL, NULL, 229575),
(231721, '4edpA01', NULL, NULL, 160, NULL, NULL, 229575),
(231722, '6dtsA01', NULL, NULL, 184, NULL, NULL, 229575),
(231723, '5h6oA01', NULL, NULL, 126, NULL, NULL, 229575),
(231724, '5h6oA02', NULL, NULL, 100, NULL, NULL, 229575),
(231725, '3jzjA01', NULL, NULL, 192, NULL, NULL, 229575),
(231726, '2v3uA01', NULL, NULL, 151, NULL, NULL, 229575),
(231727, '2v3uA02', NULL, NULL, 114, NULL, NULL, 229575),
(231728, '2rinA01', NULL, NULL, 188, NULL, NULL, 229575),
(231729, '4c1uA02', NULL, NULL, 211, NULL, NULL, 229575),
(231730, '4kd5A01', NULL, NULL, 127, NULL, NULL, 229575),
(231731, '3waeA02', NULL, NULL, 159, NULL, NULL, 229575),
(231732, '4kd5A02', NULL, NULL, 106, NULL, NULL, 229575);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(231733, '4jwoA01', NULL, NULL, 141, NULL, NULL, 229575),
(231734, '4jwoA02', NULL, NULL, 143, NULL, NULL, 229575),
(231735, '4c1uA01', NULL, NULL, 185, NULL, NULL, 229575),
(231736, '4ef1A01', NULL, NULL, 137, NULL, NULL, 229575),
(231737, '4ef1A02', NULL, NULL, 109, NULL, NULL, 229575),
(231738, '2qmxA01', NULL, NULL, 95, NULL, NULL, 229575),
(231739, '2qmxA02', NULL, NULL, 86, NULL, NULL, 229575),
(231740, '4rk9A02', NULL, NULL, 229, NULL, NULL, 229575),
(231741, '1h3dA01', NULL, NULL, 135, NULL, NULL, 229575),
(231742, '4rk9A01', NULL, NULL, 172, NULL, NULL, 229575),
(231743, '1h3dA02', NULL, NULL, 90, NULL, NULL, 229575),
(231744, '2uvjA02', NULL, NULL, 225, NULL, NULL, 229575),
(231745, '2onsA01', NULL, NULL, 143, NULL, NULL, 229575),
(231746, '6nioA01', NULL, NULL, 123, NULL, NULL, 229575),
(231747, '2uvjA01', NULL, NULL, 183, NULL, NULL, 229575),
(231748, '6nioA02', NULL, NULL, 112, NULL, NULL, 229575),
(231749, '5yseB01', NULL, NULL, 197, NULL, NULL, 229575),
(231750, '2z23A01', NULL, NULL, 177, NULL, NULL, 229575),
(231751, '4oteB01', NULL, NULL, 137, NULL, NULL, 229575),
(231752, '3vvfA01', NULL, NULL, 143, NULL, NULL, 229575),
(231753, '5mmhA02', NULL, NULL, 97, NULL, NULL, 229575),
(231754, '2qpqA02', NULL, NULL, 124, NULL, NULL, 229575),
(231755, '4pfyB01', NULL, NULL, 156, NULL, NULL, 229575),
(231756, '3ttnB02', NULL, NULL, 170, NULL, NULL, 229575),
(231757, '3ttnB01', NULL, NULL, 170, NULL, NULL, 229575),
(231758, '2czlA01', NULL, NULL, 179, NULL, NULL, 229575),
(231759, '4zdmA02', NULL, NULL, 100, NULL, NULL, 229575),
(231760, '4zdmA01', NULL, NULL, 161, NULL, NULL, 229575),
(231761, '6dtsB02', NULL, NULL, 199, NULL, NULL, 229575),
(231762, '2hzlA02', NULL, NULL, 114, NULL, NULL, 229575),
(231763, '1i6aA02', NULL, NULL, 104, NULL, NULL, 229575),
(231764, '3delB01', NULL, NULL, 149, NULL, NULL, 229575),
(231765, '1p99A02', NULL, NULL, 111, NULL, NULL, 229575),
(231766, '1p99A01', NULL, NULL, 145, NULL, NULL, 229575),
(231767, '3jyrA02', NULL, NULL, 187, NULL, NULL, 229575),
(231768, '3delB02', NULL, NULL, 93, NULL, NULL, 229575),
(231769, '3jyrA01', NULL, NULL, 179, NULL, NULL, 229575),
(231770, '6hlyA01', NULL, NULL, 203, NULL, NULL, 229575),
(231771, '6hlyA02', NULL, NULL, 119, NULL, NULL, 229575),
(231772, '3rpwA02', NULL, NULL, 153, NULL, NULL, 229575),
(231773, '3rpwA01', NULL, NULL, 182, NULL, NULL, 229575),
(231774, '6eyqA01', NULL, NULL, 167, NULL, NULL, 229575),
(231775, '5k2xA00', NULL, NULL, 420, NULL, NULL, 229575),
(231776, '5wjpA01', NULL, NULL, 154, NULL, NULL, 229575),
(231777, '5wjpA02', NULL, NULL, 95, NULL, NULL, 229575),
(231778, '3gbaD01', NULL, NULL, 152, NULL, NULL, 229575),
(231779, '1jnfA01', NULL, NULL, 184, NULL, NULL, 229575),
(231780, '5my5A01', NULL, NULL, 138, NULL, NULL, 229575),
(231781, '1jnfA03', NULL, NULL, 185, NULL, NULL, 229575),
(231782, '5my5A02', NULL, NULL, 112, NULL, NULL, 229575),
(231783, '1jnfA04', NULL, NULL, 155, NULL, NULL, 229575),
(231784, '1svxB02', NULL, NULL, 195, NULL, NULL, 229575),
(231785, '2zyoA02', NULL, NULL, 193, NULL, NULL, 229575),
(231786, '4r6hA02', NULL, NULL, 239, NULL, NULL, 229575),
(231787, '2zyoA01', NULL, NULL, 204, NULL, NULL, 229575),
(231788, '4r6hA01', NULL, NULL, 162, NULL, NULL, 229575),
(231789, '4oerA01', NULL, NULL, 272, NULL, NULL, 229575),
(231790, '1yaeB02', NULL, NULL, 130, NULL, NULL, 229575),
(231791, '2yjpA02', NULL, NULL, 91, NULL, NULL, 229575),
(231792, '4r2bA01', NULL, NULL, 198, NULL, NULL, 229575),
(231793, '4r2bA02', NULL, NULL, 198, NULL, NULL, 229575),
(231794, '4f1vA01', NULL, NULL, 232, NULL, NULL, 229575),
(231795, '3un6A01', NULL, NULL, 192, NULL, NULL, 229575),
(231796, '3un6A02', NULL, NULL, 99, NULL, NULL, 229575),
(231797, '5h71A01', NULL, NULL, 221, NULL, NULL, 229575),
(231798, '5h71A02', NULL, NULL, 271, NULL, NULL, 229575),
(231799, '4f1vA02', NULL, NULL, 149, NULL, NULL, 229575),
(231800, '1pdaA01', NULL, NULL, 120, NULL, NULL, 229575),
(231801, '1i6aA01', NULL, NULL, 115, NULL, NULL, 229575),
(231802, '4c0rA01', NULL, NULL, 122, NULL, NULL, 229575),
(231803, '4c0rA02', NULL, NULL, 102, NULL, NULL, 229575);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(231804, '2z22A02', NULL, NULL, 166, NULL, NULL, 229575),
(231805, '2z22A01', NULL, NULL, 155, NULL, NULL, 229575),
(231806, '4m1vA02', NULL, NULL, 156, NULL, NULL, 229575),
(231807, '2xxpA01', NULL, NULL, 119, NULL, NULL, 229575),
(231808, '4m1vA01', NULL, NULL, 222, NULL, NULL, 229575),
(231809, '1ursB01', NULL, NULL, 186, NULL, NULL, 229575),
(231810, '2nxoA02', NULL, NULL, 102, NULL, NULL, 229575),
(231811, '1ce2A01', NULL, NULL, 176, NULL, NULL, 229575),
(231812, '1q35A01', NULL, NULL, 147, NULL, NULL, 229575),
(231813, '1ce2A02', NULL, NULL, 159, NULL, NULL, 229575),
(231814, '1ce2A03', NULL, NULL, 188, NULL, NULL, 229575),
(231815, '1q35A02', NULL, NULL, 173, NULL, NULL, 229575),
(231816, '2pyyA02', NULL, NULL, 97, NULL, NULL, 229575),
(231817, '1xvyA02', NULL, NULL, 156, NULL, NULL, 229575),
(231818, '1xvyA01', NULL, NULL, 153, NULL, NULL, 229575),
(231819, '2pt2A01', NULL, NULL, 148, NULL, NULL, 229575),
(231820, '3cg3A02', NULL, NULL, 167, NULL, NULL, 229575),
(231821, '4mfiA00', NULL, NULL, 406, NULL, NULL, 229575),
(231822, '3cg3A01', NULL, NULL, 153, NULL, NULL, 229575),
(231823, '3hv1A02', NULL, NULL, 101, NULL, NULL, 229575),
(231824, '5eyfA02', NULL, NULL, 98, NULL, NULL, 229575),
(231825, '3k2dA02', NULL, NULL, 106, NULL, NULL, 229575),
(231826, '3k2dA01', NULL, NULL, 131, NULL, NULL, 229575),
(231827, '1xs5A01', NULL, NULL, 135, NULL, NULL, 229575),
(231828, '1xs5A02', NULL, NULL, 106, NULL, NULL, 229575),
(231829, '4ryaA01', NULL, NULL, 216, NULL, NULL, 229575),
(231830, '4ryaA02', NULL, NULL, 208, NULL, NULL, 229575),
(231831, '3cvgC01', NULL, NULL, 91, NULL, NULL, 229575),
(231832, '1r9lA01', NULL, NULL, 168, NULL, NULL, 229575),
(231833, '3c9hA01', NULL, NULL, 208, NULL, NULL, 229575),
(231834, '3c9hA02', NULL, NULL, 147, NULL, NULL, 229575),
(231835, '1ixcA03', NULL, NULL, 106, NULL, NULL, 229575),
(231836, '4yu0A01', NULL, NULL, 149, NULL, NULL, 229575),
(231837, '1ixcA02', NULL, NULL, 100, NULL, NULL, 229575),
(231838, '1jw1A02', NULL, NULL, 159, NULL, NULL, 229575),
(231839, '4yahX01', NULL, NULL, 144, NULL, NULL, 229575),
(231840, '4powA02', NULL, NULL, 119, NULL, NULL, 229575),
(231841, '4yahX02', NULL, NULL, 107, NULL, NULL, 229575),
(231842, '2yjpB01', NULL, NULL, 155, NULL, NULL, 229575),
(231843, '2pvuA02', NULL, NULL, 98, NULL, NULL, 229575),
(231844, '4rjzA01', NULL, NULL, 190, NULL, NULL, 229575),
(231845, '2pvuA01', NULL, NULL, 123, NULL, NULL, 229575),
(231846, '4rjzA02', NULL, NULL, 192, NULL, NULL, 229575),
(231847, '3up9A02', NULL, NULL, 103, NULL, NULL, 229575),
(231848, '2v25A02', NULL, NULL, 101, NULL, NULL, 229575),
(231849, '5ci5A01', NULL, NULL, 184, NULL, NULL, 229575),
(231850, '5ng9A01', NULL, NULL, 149, NULL, NULL, 229575),
(231851, '4lubB01', NULL, NULL, 101, NULL, NULL, 229575),
(231852, '4jb7A01', NULL, NULL, 119, NULL, NULL, 229575),
(231853, '6dtqA02', NULL, NULL, 214, NULL, NULL, 229575),
(231854, '3mpkA01', NULL, NULL, 140, NULL, NULL, 229575),
(231855, '2wolA01', NULL, NULL, 331, NULL, NULL, 229575),
(231856, '2v25A01', NULL, NULL, 130, NULL, NULL, 229575),
(231857, '3mpkA02', NULL, NULL, 95, NULL, NULL, 229575),
(231858, '1jw1A01', NULL, NULL, 176, NULL, NULL, 229575),
(231859, '3s9eA02', NULL, NULL, 104, NULL, NULL, 229575),
(231860, '3s9eA01', NULL, NULL, 154, NULL, NULL, 229575),
(231861, '4jb7A02', NULL, NULL, 114, NULL, NULL, 229575),
(231862, '5ng9A02', NULL, NULL, 109, NULL, NULL, 229575),
(231863, '5dviA01', NULL, NULL, 196, NULL, NULL, 229575),
(231864, '3up9A01', NULL, NULL, 142, NULL, NULL, 229575),
(231865, '1gtkA02', NULL, NULL, 100, NULL, NULL, 229575),
(231866, '5dviA02', NULL, NULL, 200, NULL, NULL, 229575),
(231867, '3v83A04', NULL, NULL, 157, NULL, NULL, 229575),
(231868, '3v83A01', NULL, NULL, 181, NULL, NULL, 229575),
(231869, '1o63A02', NULL, NULL, 82, NULL, NULL, 229575),
(231870, '2qsxA01', NULL, NULL, 102, NULL, NULL, 229575),
(231871, '1ursA02', NULL, NULL, 186, NULL, NULL, 229575),
(231872, '4zefA01', NULL, NULL, 126, NULL, NULL, 229575),
(231873, '4r75A01', NULL, NULL, 165, NULL, NULL, 229575),
(231874, '1o63A01', NULL, NULL, 137, NULL, NULL, 229575);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(231875, '4r75A02', NULL, NULL, 156, NULL, NULL, 229575),
(231876, '4zefA02', NULL, NULL, 96, NULL, NULL, 229575),
(231877, '5ikbA02', NULL, NULL, 105, NULL, NULL, 229575),
(231878, '2d5wA01', NULL, NULL, 238, NULL, NULL, 229575),
(231879, '4pe5D03', NULL, NULL, 165, NULL, NULL, 229575),
(231880, '4ecfA02', NULL, NULL, 122, NULL, NULL, 229575),
(231881, '4ecfA01', NULL, NULL, 142, NULL, NULL, 229575),
(231882, '2p0sB01', NULL, NULL, 118, NULL, NULL, 229575),
(231883, '1z7mE02', NULL, NULL, 84, NULL, NULL, 229575),
(231884, '3kbrA01', NULL, NULL, 147, NULL, NULL, 229575),
(231885, '3kbrA02', NULL, NULL, 91, NULL, NULL, 229575),
(231886, '1vr5A01', NULL, NULL, 158, NULL, NULL, 229575),
(231887, '3i6vA01', NULL, NULL, 148, NULL, NULL, 229575),
(231888, '3tmgB01', NULL, NULL, 171, NULL, NULL, 229575),
(231889, '3i6vA02', NULL, NULL, 84, NULL, NULL, 229575),
(231890, '4pe5D04', NULL, NULL, 115, NULL, NULL, 229575),
(231891, '1dtzA01', NULL, NULL, 180, NULL, NULL, 229575),
(231892, '3hv1B01', NULL, NULL, 167, NULL, NULL, 229575),
(231893, '1dtzA03', NULL, NULL, 190, NULL, NULL, 229575),
(231894, '1dtzA02', NULL, NULL, 159, NULL, NULL, 229575),
(231895, '1dtzA04', NULL, NULL, 160, NULL, NULL, 229575),
(231896, '5ikbA01', NULL, NULL, 152, NULL, NULL, 229575),
(231897, '4petA02', NULL, NULL, 113, NULL, NULL, 229575),
(231898, '2rc8A01', NULL, NULL, 183, NULL, NULL, 229575),
(231899, '2rc8A02', NULL, NULL, 111, NULL, NULL, 229575),
(231900, '3tqwA02', NULL, NULL, 105, NULL, NULL, 229575),
(231901, '3n93A01', NULL, NULL, 169, NULL, NULL, 229575),
(231902, '3tqwA01', NULL, NULL, 134, NULL, NULL, 229575),
(231903, '2z8fB02', NULL, NULL, 239, NULL, NULL, 229575),
(231904, '5mmhD01', NULL, NULL, 125, NULL, NULL, 229575),
(231905, '4ovjA02', NULL, NULL, 218, NULL, NULL, 229575),
(231906, '4ovjA01', NULL, NULL, 181, NULL, NULL, 229575),
(231907, '3mq9D00', NULL, NULL, 454, NULL, NULL, 229575),
(231908, '1zu0A01', NULL, NULL, 176, NULL, NULL, 229575),
(231909, '4qhqA02', NULL, NULL, 108, NULL, NULL, 229575),
(231910, '4qhqA01', NULL, NULL, 133, NULL, NULL, 229575),
(231911, '3tqlA01', NULL, NULL, 128, NULL, NULL, 229575),
(231912, '3tqlA02', NULL, NULL, 99, NULL, NULL, 229575),
(231913, '3ombA01', NULL, NULL, 212, NULL, NULL, 229575),
(231914, '1wdnA01', NULL, NULL, 96, NULL, NULL, 229575),
(231915, '1wdnA02', NULL, NULL, 124, NULL, NULL, 229575),
(231916, '3ombA02', NULL, NULL, 291, NULL, NULL, 229575),
(231917, '1atgA02', NULL, NULL, 109, NULL, NULL, 229575),
(231918, '4jxiB02', NULL, NULL, 235, NULL, NULL, 229575),
(231919, '1z7mF01', NULL, NULL, 124, NULL, NULL, 229575),
(231920, '3tpaA01', NULL, NULL, 134, NULL, NULL, 229575),
(231921, '2i49A01', NULL, NULL, 262, NULL, NULL, 229575),
(231922, '1y9uA02', NULL, NULL, 171, NULL, NULL, 229575),
(231923, '2i49A02', NULL, NULL, 136, NULL, NULL, 229575),
(231924, '1y9uA01', NULL, NULL, 152, NULL, NULL, 229575),
(231925, '5wnnA01', NULL, NULL, 155, NULL, NULL, 229575),
(231926, '2vhaA02', NULL, NULL, 96, NULL, NULL, 229575),
(231927, '5wnnA02', NULL, NULL, 166, NULL, NULL, 229575),
(231928, '2vhaA01', NULL, NULL, 191, NULL, NULL, 229575),
(231929, '5kztA01', NULL, NULL, 184, NULL, NULL, 229575),
(231930, '4k3fA01', NULL, NULL, 135, NULL, NULL, 229575),
(231931, '1pb7A02', NULL, NULL, 108, NULL, NULL, 229575),
(231932, '4k3fA02', NULL, NULL, 105, NULL, NULL, 229575),
(231933, '1pb7A01', NULL, NULL, 184, NULL, NULL, 229575),
(231934, '1h76A02', NULL, NULL, 157, NULL, NULL, 229575),
(231935, '1h76A01', NULL, NULL, 185, NULL, NULL, 229575),
(231936, '3mwbA01', NULL, NULL, 102, NULL, NULL, 229575),
(231937, '3mwbA02', NULL, NULL, 89, NULL, NULL, 229575),
(231938, '1h76A04', NULL, NULL, 161, NULL, NULL, 229575),
(231939, '4x9tA02', NULL, NULL, 121, NULL, NULL, 229575),
(231940, '1h76A03', NULL, NULL, 183, NULL, NULL, 229575),
(231941, '2heuB01', NULL, NULL, 183, NULL, NULL, 229575),
(231942, '1twyD02', NULL, NULL, 135, NULL, NULL, 229575),
(231943, '5tu0A02', NULL, NULL, 201, NULL, NULL, 229575),
(231944, '5tu0A01', NULL, NULL, 189, NULL, NULL, 229575),
(231945, '4u1wC03', NULL, NULL, 145, NULL, NULL, 229575);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(231946, '3qaxB01', NULL, NULL, 131, NULL, NULL, 229575),
(231947, '1xvxA01', NULL, NULL, 156, NULL, NULL, 229575),
(231948, '4zs9A01', NULL, NULL, 171, NULL, NULL, 229575),
(231949, '4zs9A02', NULL, NULL, 218, NULL, NULL, 229575),
(231950, '1atgA01', NULL, NULL, 122, NULL, NULL, 229575),
(231951, '1xvxA02', NULL, NULL, 156, NULL, NULL, 229575),
(231952, '5j1dA02', NULL, NULL, 149, NULL, NULL, 229575),
(231953, '2qsxB02', NULL, NULL, 98, NULL, NULL, 229575),
(231954, '4eq9A01', NULL, NULL, 127, NULL, NULL, 229575),
(231955, '4eq9A02', NULL, NULL, 103, NULL, NULL, 229575),
(231956, '4tozA01', NULL, NULL, 183, NULL, NULL, 229575),
(231957, '4x6gE02', NULL, NULL, 117, NULL, NULL, 229575),
(231958, '4x6gE03', NULL, NULL, 108, NULL, NULL, 229575),
(231959, '1jetA01', NULL, NULL, 177, NULL, NULL, 229575),
(231960, '1xocA01', NULL, NULL, 155, NULL, NULL, 229575),
(231961, '4rxlA02', NULL, NULL, 112, NULL, NULL, 229575),
(231962, '4rxlA01', NULL, NULL, 122, NULL, NULL, 229575),
(231963, '2nxoD01', NULL, NULL, 189, NULL, NULL, 229575),
(231964, '1dotA04', NULL, NULL, 156, NULL, NULL, 229575),
(231965, '1dotA03', NULL, NULL, 191, NULL, NULL, 229575),
(231966, '2ylnA02', NULL, NULL, 95, NULL, NULL, 229575),
(231967, '1dotA01', NULL, NULL, 180, NULL, NULL, 229575),
(231968, '5gubB02', NULL, NULL, 261, NULL, NULL, 229575),
(231969, '3ry3A01', NULL, NULL, 256, NULL, NULL, 229575),
(231970, '2ylnA01', NULL, NULL, 134, NULL, NULL, 229575),
(231971, '5gubB01', NULL, NULL, 222, NULL, NULL, 229575),
(231972, '2g29A01', NULL, NULL, 257, NULL, NULL, 229575),
(231973, '3sewA02', NULL, NULL, 188, NULL, NULL, 229575),
(231974, '2g29A02', NULL, NULL, 133, NULL, NULL, 229575),
(231975, '3lswA01', NULL, NULL, 146, NULL, NULL, 229575),
(231976, '2b3fC02', NULL, NULL, 209, NULL, NULL, 229575),
(231977, '3lswA02', NULL, NULL, 109, NULL, NULL, 229575),
(231978, '4lonB02', NULL, NULL, 101, NULL, NULL, 229575),
(231979, '6dquA01', NULL, NULL, 186, NULL, NULL, 229575),
(231980, '1iq7A01', NULL, NULL, 134, NULL, NULL, 229575),
(231981, '1us5A02', NULL, NULL, 139, NULL, NULL, 229575),
(231982, '5orgA01', NULL, NULL, 143, NULL, NULL, 229575),
(231983, '1us5A01', NULL, NULL, 158, NULL, NULL, 229575),
(231984, '3kjtA02', NULL, NULL, 187, NULL, NULL, 229575),
(231985, '5on8A01', NULL, NULL, 274, NULL, NULL, 229575),
(231986, '3e13X02', NULL, NULL, 173, NULL, NULL, 229575),
(231987, '3e13X01', NULL, NULL, 149, NULL, NULL, 229575),
(231988, '5f7vA00', NULL, NULL, 400, NULL, NULL, 229575),
(231989, '4oteA02', NULL, NULL, 104, NULL, NULL, 229575),
(231990, '2heuA02', NULL, NULL, 218, NULL, NULL, 229575),
(231991, '6hkeA02', NULL, NULL, 124, NULL, NULL, 229575),
(231992, '2x26B01', NULL, NULL, 174, NULL, NULL, 229575),
(231993, '4kydB02', NULL, NULL, 215, NULL, NULL, 229575),
(231994, '3qaxA02', NULL, NULL, 94, NULL, NULL, 229575),
(231995, '3hn0A01', NULL, NULL, 185, NULL, NULL, 229575),
(231996, '4htgA02', NULL, NULL, 101, NULL, NULL, 229575),
(231997, '4htgA01', NULL, NULL, 131, NULL, NULL, 229575),
(231998, '3hn0A02', NULL, NULL, 98, NULL, NULL, 229575),
(231999, '3n5lA02', NULL, NULL, 113, NULL, NULL, 229575),
(232000, '3n5lA01', NULL, NULL, 137, NULL, NULL, 229575),
(232001, '3zs6A01', NULL, NULL, 167, NULL, NULL, 229575),
(232002, '4dz1A02', NULL, NULL, 99, NULL, NULL, 229575),
(232003, '4dz1A01', NULL, NULL, 136, NULL, NULL, 229575),
(232004, '1mdp102', NULL, NULL, 179, NULL, NULL, 229575),
(232005, '5iaiA01', NULL, NULL, 192, NULL, NULL, 229575),
(232006, '5iaiA02', NULL, NULL, 207, NULL, NULL, 229575),
(232007, '3fjmA02', NULL, NULL, 113, NULL, NULL, 229575),
(232008, '3thiA01', NULL, NULL, 175, NULL, NULL, 229575),
(232009, '3thiA02', NULL, NULL, 190, NULL, NULL, 229575),
(232010, '2d3iA02', NULL, NULL, 156, NULL, NULL, 229575),
(232011, '2d3iA01', NULL, NULL, 179, NULL, NULL, 229575),
(232012, '2de3A01', NULL, NULL, 193, NULL, NULL, 229575),
(232013, '4pp0B01', NULL, NULL, 146, NULL, NULL, 229575),
(232014, '3ksxA01', NULL, NULL, 166, NULL, NULL, 229575),
(232015, '3ksxA02', NULL, NULL, 100, NULL, NULL, 229575),
(232016, '2d3iA04', NULL, NULL, 159, NULL, NULL, 229575);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(232017, '2z8fA01', NULL, NULL, 173, NULL, NULL, 229575),
(232018, '2d3iA03', NULL, NULL, 185, NULL, NULL, 229575),
(232019, '4nmyA02', NULL, NULL, 102, NULL, NULL, 229575),
(232020, '4nmyA01', NULL, NULL, 201, NULL, NULL, 229575),
(232021, '2x26A02', NULL, NULL, 100, NULL, NULL, 229575),
(232022, '1a7lB02', NULL, NULL, 182, NULL, NULL, 229575),
(232023, '2x26A01', NULL, NULL, 185, NULL, NULL, 229575),
(232024, '4gl8A01', NULL, NULL, 155, NULL, NULL, 229575),
(232025, '5um2A01', NULL, NULL, 156, NULL, NULL, 229575),
(232026, '5um2A02', NULL, NULL, 160, NULL, NULL, 229575),
(232027, '3g3kA02', NULL, NULL, 105, NULL, NULL, 229575),
(232028, '3g3kA01', NULL, NULL, 154, NULL, NULL, 229575),
(232029, '2f7aA01', NULL, NULL, 125, NULL, NULL, 229575),
(232030, '3w15C00', NULL, NULL, 389, NULL, NULL, 229575),
(232031, '4fedA02', NULL, NULL, 216, NULL, NULL, 229575),
(232032, '3fxqA03', NULL, NULL, 102, NULL, NULL, 229575),
(232033, '4wepA01', NULL, NULL, 167, NULL, NULL, 229575),
(232034, '4r9fA02', NULL, NULL, 206, NULL, NULL, 229575),
(232035, '4z7eA01', NULL, NULL, 166, NULL, NULL, 229575),
(232036, '4r9fA01', NULL, NULL, 201, NULL, NULL, 229575),
(232037, '6ft2A02', NULL, NULL, 101, NULL, NULL, 229575),
(232038, '3hhgE02', NULL, NULL, 117, NULL, NULL, 229575),
(232039, '6ft2A01', NULL, NULL, 145, NULL, NULL, 229575),
(232040, '1nnfA02', NULL, NULL, 153, NULL, NULL, 229575),
(232041, '3fzvD02', NULL, NULL, 120, NULL, NULL, 229575),
(232042, '1nnfA01', NULL, NULL, 156, NULL, NULL, 229575),
(232043, '4ykiA02', NULL, NULL, 100, NULL, NULL, 229575),
(232044, '3rqtA01', NULL, NULL, 253, NULL, NULL, 229575),
(232045, '5z50A02', NULL, NULL, 101, NULL, NULL, 229575),
(232046, '2q88A01', NULL, NULL, 133, NULL, NULL, 229575),
(232047, '5z50A01', NULL, NULL, 136, NULL, NULL, 229575),
(232048, '1iejA01', NULL, NULL, 143, NULL, NULL, 229575),
(232049, '4ntlA02', NULL, NULL, 106, NULL, NULL, 229575),
(232050, '4ntlA01', NULL, NULL, 141, NULL, NULL, 229575),
(232051, '2q88A02', NULL, NULL, 102, NULL, NULL, 229575),
(232052, '2fyiA02', NULL, NULL, 101, NULL, NULL, 229575),
(232053, '1ii5A01', NULL, NULL, 140, NULL, NULL, 229575),
(232054, '1ii5A02', NULL, NULL, 93, NULL, NULL, 229575),
(232055, '4h1xA01', NULL, NULL, 137, NULL, NULL, 229575),
(232056, '6o9aA02', NULL, NULL, 113, NULL, NULL, 229575),
(232057, '3l6gA01', NULL, NULL, 150, NULL, NULL, 229575),
(232058, '6o9aA01', NULL, NULL, 151, NULL, NULL, 229575),
(232059, '4r2fA01', NULL, NULL, 195, NULL, NULL, 229575),
(232060, '4r2fA02', NULL, NULL, 199, NULL, NULL, 229575),
(232061, '6fthA02', NULL, NULL, 288, NULL, NULL, 229575),
(232062, '6fthA01', NULL, NULL, 208, NULL, NULL, 229575),
(232063, '4oenA02', NULL, NULL, 95, NULL, NULL, 229575),
(232064, '4yzzA02', NULL, NULL, 114, NULL, NULL, 229575),
(232065, '5hm4B01', NULL, NULL, 157, NULL, NULL, 229575),
(232066, '2ozzA01', NULL, NULL, 139, NULL, NULL, 229575),
(232067, '2ozzA02', NULL, NULL, 92, NULL, NULL, 229575),
(232068, '3h7mA02', NULL, NULL, 94, NULL, NULL, 229575),
(232069, '3h7mA01', NULL, NULL, 140, NULL, NULL, 229575),
(232070, '4hcwA01', NULL, NULL, 183, NULL, NULL, 229575),
(232071, '4h65B01', NULL, NULL, 196, NULL, NULL, 229575),
(232072, '3onmA02', NULL, NULL, 94, NULL, NULL, 229575),
(232073, '2rcaA01', NULL, NULL, 181, NULL, NULL, 229575),
(232074, '5bwjD02', NULL, NULL, 98, NULL, NULL, 229575),
(232075, '3kzgA02', NULL, NULL, 99, NULL, NULL, 229575),
(232076, '2rcaA02', NULL, NULL, 111, NULL, NULL, 229575),
(232077, '3kzgA01', NULL, NULL, 138, NULL, NULL, 229575),
(232078, '4ab5A02', NULL, NULL, 105, NULL, NULL, 229575),
(232079, '3onmA01', NULL, NULL, 97, NULL, NULL, 229575),
(232080, '4ua8A01', NULL, NULL, 194, NULL, NULL, 229575),
(232081, '3dm0A01', NULL, NULL, 370, NULL, NULL, 229575),
(232082, '4ua8A02', NULL, NULL, 189, NULL, NULL, 229575),
(232083, '2vozB01', NULL, NULL, 145, NULL, NULL, 229575),
(232084, '4tllB03', NULL, NULL, 162, NULL, NULL, 229575),
(232085, '2fyiC01', NULL, NULL, 127, NULL, NULL, 229575),
(232086, '5cm6A02', NULL, NULL, 113, NULL, NULL, 229575),
(232087, '4g4pA02', NULL, NULL, 96, NULL, NULL, 229575);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(232088, '4g4pA01', NULL, NULL, 124, NULL, NULL, 229575),
(232089, '4n13A02', NULL, NULL, 137, NULL, NULL, 229575),
(232090, '3i3vB01', NULL, NULL, 176, NULL, NULL, 229575),
(232091, '4n13A01', NULL, NULL, 128, NULL, NULL, 229575),
(232092, '1xc1A01', NULL, NULL, 156, NULL, NULL, 229575),
(232093, '1nh8A02', NULL, NULL, 86, NULL, NULL, 229575),
(232094, '5isuA01', NULL, NULL, 157, NULL, NULL, 229575),
(232095, '4hw8A02', NULL, NULL, 201, NULL, NULL, 229575),
(232096, '4ykiA01', NULL, NULL, 156, NULL, NULL, 229575),
(232097, '4hw8A01', NULL, NULL, 183, NULL, NULL, 229575),
(232098, '4oenB01', NULL, NULL, 128, NULL, NULL, 229575),
(232099, '1xc1A02', NULL, NULL, 153, NULL, NULL, 229575),
(232100, '1nh8A01', NULL, NULL, 117, NULL, NULL, 229575),
(232101, '2qryA02', NULL, NULL, 151, NULL, NULL, 229575),
(232102, '2qryA01', NULL, NULL, 158, NULL, NULL, 229575),
(232103, '1sw5A01', NULL, NULL, 171, NULL, NULL, 229575),
(232104, '4yb6A02', NULL, NULL, 90, NULL, NULL, 229575),
(232105, '5ftiA01', NULL, NULL, 146, NULL, NULL, 229575),
(232106, '4ohnA02', NULL, NULL, 99, NULL, NULL, 229575),
(232107, '2w7yA02', NULL, NULL, 195, NULL, NULL, 229575),
(232108, '4ohnA01', NULL, NULL, 158, NULL, NULL, 229575),
(232109, '1eljA02', NULL, NULL, 190, NULL, NULL, 229575),
(232110, '1potA01', NULL, NULL, 168, NULL, NULL, 229575),
(232111, '2w7yA01', NULL, NULL, 197, NULL, NULL, 229575),
(232112, '1eljA01', NULL, NULL, 183, NULL, NULL, 229575),
(232113, '1potA02', NULL, NULL, 157, NULL, NULL, 229575),
(232114, '3n94A02', NULL, NULL, 187, NULL, NULL, 229575),
(232115, '4p0gA02', NULL, NULL, 96, NULL, NULL, 229575),
(232116, '4ab5B01', NULL, NULL, 117, NULL, NULL, 229575),
(232117, '3k6xA01', NULL, NULL, 182, NULL, NULL, 229575),
(232118, '3k4uA02', NULL, NULL, 99, NULL, NULL, 229575),
(232119, '4exlA02', NULL, NULL, 122, NULL, NULL, 229575),
(232120, '3kg2B03', NULL, NULL, 146, NULL, NULL, 229575),
(232121, '1twyA01', NULL, NULL, 129, NULL, NULL, 229575),
(232122, '1h45A01', NULL, NULL, 141, NULL, NULL, 229575),
(232123, '4p0gA01', NULL, NULL, 145, NULL, NULL, 229575),
(232124, '4fajA01', NULL, NULL, 166, NULL, NULL, 229575),
(232125, '3t66A01', NULL, NULL, 275, NULL, NULL, 229575),
(232126, '3i3vA02', NULL, NULL, 229, NULL, NULL, 229575),
(232127, '4x1bA03', NULL, NULL, 184, NULL, NULL, 229575),
(232128, '3a09A01', NULL, NULL, 221, NULL, NULL, 229575),
(232129, '3a09A02', NULL, NULL, 269, NULL, NULL, 229575),
(232130, '3vv5A02', NULL, NULL, 98, NULL, NULL, 229575),
(232131, '4wedA01', NULL, NULL, 264, NULL, NULL, 229575),
(232132, '1ixhA02', NULL, NULL, 166, NULL, NULL, 229575),
(232133, '1ixhA01', NULL, NULL, 155, NULL, NULL, 229575),
(232134, '4qflA01', NULL, NULL, 123, NULL, NULL, 229575),
(232135, '3o66B01', NULL, NULL, 177, NULL, NULL, 229575),
(232136, '3mz1B01', NULL, NULL, 110, NULL, NULL, 229575),
(232137, '3mz1B02', NULL, NULL, 105, NULL, NULL, 229575),
(232138, '4eqbA02', NULL, NULL, 158, NULL, NULL, 229575),
(232139, '3cfxA02', NULL, NULL, 172, NULL, NULL, 229575),
(232140, '4eqbA01', NULL, NULL, 172, NULL, NULL, 229575),
(232141, '3fxqB02', NULL, NULL, 114, NULL, NULL, 229575),
(232142, '4dddA01', NULL, NULL, 162, NULL, NULL, 229575),
(232143, '4dddA02', NULL, NULL, 138, NULL, NULL, 229575),
(232144, '4mlvA02', NULL, NULL, 101, NULL, NULL, 229575),
(232145, '1tfdA02', NULL, NULL, 165, NULL, NULL, 229575),
(232146, '1tfdA01', NULL, NULL, 138, NULL, NULL, 229575),
(232147, '4io2A01', NULL, NULL, 144, NULL, NULL, 229575),
(232148, '4io2A02', NULL, NULL, 104, NULL, NULL, 229575),
(232149, '4la9A02', NULL, NULL, 96, NULL, NULL, 229575),
(232150, '4tllD04', NULL, NULL, 119, NULL, NULL, 229575),
(232151, '4la9A01', NULL, NULL, 130, NULL, NULL, 229575),
(232152, '4exlB01', NULL, NULL, 143, NULL, NULL, 229575),
(232153, '3oelA01', NULL, NULL, 173, NULL, NULL, 229575),
(232154, '2xd3A02', NULL, NULL, 200, NULL, NULL, 229575),
(232155, '5dt6A02', NULL, NULL, 108, NULL, NULL, 229575),
(232156, '5dt6A01', NULL, NULL, 149, NULL, NULL, 229575),
(232157, '2xd3A01', NULL, NULL, 181, NULL, NULL, 229575),
(232158, '2dvzA02', NULL, NULL, 124, NULL, NULL, 229575);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(232159, '3oo8A02', NULL, NULL, 216, NULL, NULL, 229575),
(232160, '5ehmA02', NULL, NULL, 107, NULL, NULL, 229575),
(232161, '6ddnA02', NULL, NULL, 160, NULL, NULL, 229575),
(232162, '3oo8A01', NULL, NULL, 174, NULL, NULL, 229575),
(232163, '4gl0A02', NULL, NULL, 159, NULL, NULL, 229575),
(232164, '4gl0A01', NULL, NULL, 174, NULL, NULL, 229575),
(232165, '3oxnB02', NULL, NULL, 100, NULL, NULL, 229575),
(232166, '2ql3A02', NULL, NULL, 106, NULL, NULL, 229575),
(232167, '2ql3A01', NULL, NULL, 103, NULL, NULL, 229575),
(232168, '3oelA02', NULL, NULL, 113, NULL, NULL, 229575),
(232169, '5f1qA01', NULL, NULL, 127, NULL, NULL, 229575),
(232170, '3hhfA02', NULL, NULL, 103, NULL, NULL, 229575),
(232171, '3skpA01', NULL, NULL, 136, NULL, NULL, 229575),
(232172, '3hhfA01', NULL, NULL, 110, NULL, NULL, 229575),
(232173, '4gotA02', NULL, NULL, 108, NULL, NULL, 229575),
(232174, '4gotA01', NULL, NULL, 141, NULL, NULL, 229575),
(232175, '4mlvA01', NULL, NULL, 120, NULL, NULL, 229575),
(232176, '4exkA01', NULL, NULL, 189, NULL, NULL, 229575),
(232177, '1blfA03', NULL, NULL, 188, NULL, NULL, 229575),
(232178, '1h44A01', NULL, NULL, 145, NULL, NULL, 229575),
(232179, '4exkA02', NULL, NULL, 185, NULL, NULL, 229575),
(232180, '4xxuA02', NULL, NULL, 112, NULL, NULL, 229575),
(232181, '3k01A02', NULL, NULL, 196, NULL, NULL, 229575),
(232182, '4xxuA01', NULL, NULL, 119, NULL, NULL, 229575),
(232183, '4h65A02', NULL, NULL, 111, NULL, NULL, 229575),
(232184, '4h67D02', NULL, NULL, 111, NULL, NULL, 229575),
(232185, '4u5wA00', NULL, NULL, 149, NULL, NULL, 229576),
(232186, '4orzB00', NULL, NULL, 119, NULL, NULL, 229576),
(232187, '3ik5A00', NULL, NULL, 143, NULL, NULL, 229576),
(232188, '4neeK00', NULL, NULL, 155, NULL, NULL, 229576),
(232189, '4neeH00', NULL, NULL, 155, NULL, NULL, 229576),
(232190, '4d8dB00', NULL, NULL, 151, NULL, NULL, 229576),
(232191, '4neeE00', NULL, NULL, 155, NULL, NULL, 229576),
(232192, '1avvA00', NULL, NULL, 102, NULL, NULL, 229576),
(232193, '4en2C00', NULL, NULL, 174, NULL, NULL, 229576),
(232194, '4neeC00', NULL, NULL, 155, NULL, NULL, 229576),
(232195, '2nefA00', NULL, NULL, 136, NULL, NULL, 229576),
(232196, '2xi1A00', NULL, NULL, 133, NULL, NULL, 229576),
(232197, '4cl1A01', NULL, NULL, 61, NULL, NULL, 229577),
(232198, '3fqmA01', NULL, NULL, 61, NULL, NULL, 229577),
(232199, '1p0sL01', NULL, NULL, 47, NULL, NULL, 229578),
(232200, '1cfhA00', NULL, NULL, 47, NULL, NULL, 229578),
(232201, '1whfA01', NULL, NULL, 46, NULL, NULL, 229578),
(232202, '1wheA01', NULL, NULL, 46, NULL, NULL, 229578),
(232203, '1pfxL01', NULL, NULL, 46, NULL, NULL, 229578),
(232204, '2q97T00', NULL, NULL, 109, NULL, NULL, 229579),
(232205, '4ga7A01', NULL, NULL, 235, NULL, NULL, 229580),
(232206, '1yxaB01', NULL, NULL, 225, NULL, NULL, 229580),
(232207, '1mtpA01', NULL, NULL, 230, NULL, NULL, 229580),
(232208, '3nddA01', NULL, NULL, 248, NULL, NULL, 229580),
(232209, '2wxzA02', NULL, NULL, 219, NULL, NULL, 229580),
(232210, '1wz9A01', NULL, NULL, 221, NULL, NULL, 229580),
(232211, '2h4pA01', NULL, NULL, 272, NULL, NULL, 229580),
(232212, '6hgeB01', NULL, NULL, 226, NULL, NULL, 229580),
(232213, '4r9iA01', NULL, NULL, 278, NULL, NULL, 229580),
(232214, '1imvA02', NULL, NULL, 206, NULL, NULL, 229580),
(232215, '3dy0A01', NULL, NULL, 226, NULL, NULL, 229580),
(232216, '3kcgI01', NULL, NULL, 271, NULL, NULL, 229580),
(232217, '1jjoC01', NULL, NULL, 166, NULL, NULL, 229580),
(232218, '2oayA01', NULL, NULL, 206, NULL, NULL, 229580),
(232219, '6f4vA01', NULL, NULL, 226, NULL, NULL, 229580),
(232220, '5c98A01', NULL, NULL, 233, NULL, NULL, 229580),
(232221, '1k9oI01', NULL, NULL, 217, NULL, NULL, 229580),
(232222, '2wxyC02', NULL, NULL, 210, NULL, NULL, 229580),
(232223, '2znhB01', NULL, NULL, 188, NULL, NULL, 229580),
(232224, '3cvmA01', NULL, NULL, 231, NULL, NULL, 229580),
(232225, '3f02A01', NULL, NULL, 237, NULL, NULL, 229580),
(232226, '1hp7A02', NULL, NULL, 241, NULL, NULL, 229580),
(232227, '3le2A01', NULL, NULL, 236, NULL, NULL, 229580),
(232228, '4kdsA01', NULL, NULL, 222, NULL, NULL, 229580),
(232229, '4c41A01', NULL, NULL, 228, NULL, NULL, 229580);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(232230, '3stoA01', NULL, NULL, 250, NULL, NULL, 229580),
(232231, '3pzfA02', NULL, NULL, 197, NULL, NULL, 229580),
(232232, '4dteA01', NULL, NULL, 190, NULL, NULL, 229580),
(232233, '4zk3A01', NULL, NULL, 239, NULL, NULL, 229580),
(232234, '1ovaB02', NULL, NULL, 236, NULL, NULL, 229580),
(232235, '4ajtA01', NULL, NULL, 231, NULL, NULL, 229580),
(232236, '1jmoA01', NULL, NULL, 227, NULL, NULL, 229580),
(232237, '1m93B01', NULL, NULL, 127, NULL, NULL, 229580),
(232238, '3lw2A01', NULL, NULL, 190, NULL, NULL, 229580),
(232239, '5hgcA01', NULL, NULL, 241, NULL, NULL, 229580),
(232240, '1f0cA01', NULL, NULL, 170, NULL, NULL, 229580),
(232241, '2arrA01', NULL, NULL, 229, NULL, NULL, 229580),
(232242, '6hgmA01', NULL, NULL, 222, NULL, NULL, 229580),
(232243, '5cdzA01', NULL, NULL, 217, NULL, NULL, 229580),
(232244, '2xn6A01', NULL, NULL, 254, NULL, NULL, 229580),
(232245, '6hgeA01', NULL, NULL, 224, NULL, NULL, 229580),
(232246, '2pefA01', NULL, NULL, 250, NULL, NULL, 229580),
(232247, '1lj5A01', NULL, NULL, 225, NULL, NULL, 229580),
(232248, '5inwA01', NULL, NULL, 232, NULL, NULL, 229580),
(232249, '1hleA02', NULL, NULL, 241, NULL, NULL, 229580),
(232250, '1attB02', NULL, NULL, 269, NULL, NULL, 229580),
(232251, '3vvjA01', NULL, NULL, 236, NULL, NULL, 229580),
(232252, '3ozqA02', NULL, NULL, 176, NULL, NULL, 229580),
(232253, '2wxwA02', NULL, NULL, 207, NULL, NULL, 229580),
(232254, '4p0fA01', NULL, NULL, 229, NULL, NULL, 229580),
(232255, '1a7cA01', NULL, NULL, 193, NULL, NULL, 229580),
(232256, '4au2B01', NULL, NULL, 243, NULL, NULL, 229580),
(232257, '3ndaA01', NULL, NULL, 242, NULL, NULL, 229580),
(232258, '5nbuA01', NULL, NULL, 246, NULL, NULL, 229580),
(232259, '2v95A01', NULL, NULL, 226, NULL, NULL, 229580),
(232260, '3fgqA02', NULL, NULL, 189, NULL, NULL, 229580),
(232261, '2h4qA01', NULL, NULL, 250, NULL, NULL, 229580),
(232262, '2peeA01', NULL, NULL, 241, NULL, NULL, 229580),
(232263, '4dy0B01', NULL, NULL, 193, NULL, NULL, 229580),
(232264, '4if8B01', NULL, NULL, 285, NULL, NULL, 229580),
(232265, '1sekA01', NULL, NULL, 192, NULL, NULL, 229580),
(232266, '2r9yA01', NULL, NULL, 230, NULL, NULL, 229580),
(232267, '3f1sA01', NULL, NULL, 235, NULL, NULL, 229580),
(232268, '4ys4A02', NULL, NULL, 141, NULL, NULL, 229581),
(232269, '2ymoA02', NULL, NULL, 136, NULL, NULL, 229581),
(232270, '2clyC01', NULL, NULL, 52, NULL, NULL, 229582),
(232271, '4nzvA02', NULL, NULL, 54, NULL, NULL, 229583),
(232272, '3qg5D02', NULL, NULL, 66, NULL, NULL, 229583),
(232273, '2lqxA00', NULL, NULL, 41, NULL, NULL, 229584),
(232274, '2o01G01', NULL, NULL, 75, NULL, NULL, 229585),
(232275, '2wscG00', NULL, NULL, 95, NULL, NULL, 229585),
(232276, '3lw5K00', NULL, NULL, 84, NULL, NULL, 229585),
(232277, '2wscK00', NULL, NULL, 89, NULL, NULL, 229585),
(232278, '3lw5G00', NULL, NULL, 95, NULL, NULL, 229585),
(232279, '3efoB04', NULL, NULL, 245, NULL, NULL, 229586),
(232280, '2xggB00', NULL, NULL, 160, NULL, NULL, 229586),
(232281, '4jduA00', NULL, NULL, 215, NULL, NULL, 229586),
(232282, '4igiA00', NULL, NULL, 203, NULL, NULL, 229586),
(232283, '2odpA01', NULL, NULL, 218, NULL, NULL, 229586),
(232284, '1u0oC00', NULL, NULL, 208, NULL, NULL, 229586),
(232285, '1n3yA00', NULL, NULL, 198, NULL, NULL, 229586),
(232286, '4cn9A01', NULL, NULL, 206, NULL, NULL, 229586),
(232287, '4cn9A02', NULL, NULL, 203, NULL, NULL, 229586),
(232288, '3zqkA00', NULL, NULL, 181, NULL, NULL, 229586),
(232289, '2nutB04', NULL, NULL, 239, NULL, NULL, 229586),
(232290, '2x5nA01', NULL, NULL, 182, NULL, NULL, 229586),
(232291, '1ck4B00', NULL, NULL, 198, NULL, NULL, 229586),
(232292, '1atzB00', NULL, NULL, 189, NULL, NULL, 229586),
(232293, '2iueA00', NULL, NULL, 212, NULL, NULL, 229586),
(232294, '3ibsA00', NULL, NULL, 218, NULL, NULL, 229586),
(232295, '4f1jA00', NULL, NULL, 203, NULL, NULL, 229586),
(232296, '1pcxA04', NULL, NULL, 248, NULL, NULL, 229586),
(232297, '4rckB00', NULL, NULL, 204, NULL, NULL, 229586),
(232298, '1v7pC00', NULL, NULL, 200, NULL, NULL, 229586),
(232299, '1jeyA01', NULL, NULL, 216, NULL, NULL, 229586),
(232300, '3v4vB02', NULL, NULL, 247, NULL, NULL, 229586);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(232301, '4fx5A02', NULL, NULL, 184, NULL, NULL, 229586),
(232302, '5ln1A01', NULL, NULL, 185, NULL, NULL, 229586),
(232303, '5hgjA00', NULL, NULL, 195, NULL, NULL, 229586),
(232304, '5ffgB00', NULL, NULL, 257, NULL, NULL, 229586),
(232305, '1shuX00', NULL, NULL, 182, NULL, NULL, 229586),
(232306, '4hqfA00', NULL, NULL, 215, NULL, NULL, 229586),
(232307, '1mf7A00', NULL, NULL, 194, NULL, NULL, 229586),
(232308, '3eh1A04', NULL, NULL, 240, NULL, NULL, 229586),
(232309, '2qtvA03', NULL, NULL, 278, NULL, NULL, 229586),
(232310, '3n2nA00', NULL, NULL, 185, NULL, NULL, 229586),
(232311, '4wk0B03', NULL, NULL, 240, NULL, NULL, 229586),
(232312, '3t3pB03', NULL, NULL, 249, NULL, NULL, 229586),
(232313, '4wfqA00', NULL, NULL, 192, NULL, NULL, 229586),
(232314, '4hqoA02', NULL, NULL, 189, NULL, NULL, 229586),
(232315, '2nutA03', NULL, NULL, 273, NULL, NULL, 229586),
(232316, '1q0pA00', NULL, NULL, 223, NULL, NULL, 229586),
(232317, '1yvrA01', NULL, NULL, 206, NULL, NULL, 229586),
(232318, '3eh2B04', NULL, NULL, 245, NULL, NULL, 229586),
(232319, '5e6sB03', NULL, NULL, 246, NULL, NULL, 229586),
(232320, '1jeyB01', NULL, NULL, 242, NULL, NULL, 229586),
(232321, '5bv8A00', NULL, NULL, 214, NULL, NULL, 229586),
(232322, '5nusA00', NULL, NULL, 229, NULL, NULL, 229586),
(232323, '3ragB00', NULL, NULL, 242, NULL, NULL, 229586),
(232324, '2ww8A03', NULL, NULL, 304, NULL, NULL, 229586),
(232325, '2nvoA01', NULL, NULL, 207, NULL, NULL, 229586),
(232326, '3tw0D01', NULL, NULL, 311, NULL, NULL, 229586),
(232327, '1rrkA01', NULL, NULL, 209, NULL, NULL, 229586),
(232328, '1mjnA00', NULL, NULL, 179, NULL, NULL, 229586),
(232329, '3fwbB00', NULL, NULL, 55, NULL, NULL, 229587),
(232330, '2gv5C00', NULL, NULL, 73, NULL, NULL, 229587),
(232331, '3fhnA04', NULL, NULL, 137, NULL, NULL, 229588),
(232332, '2a2fX02', NULL, NULL, 145, NULL, NULL, 229588),
(232333, '3do6A03', NULL, NULL, 89, NULL, NULL, 229589),
(232334, '4jimA03', NULL, NULL, 90, NULL, NULL, 229589),
(232335, '5a4jA03', NULL, NULL, 90, NULL, NULL, 229589),
(232336, '5a5gA03', NULL, NULL, 90, NULL, NULL, 229589),
(232337, '3zedA04', NULL, NULL, 108, NULL, NULL, 229590),
(232338, '2pusA04', NULL, NULL, 108, NULL, NULL, 229590),
(232339, '2xauA04', NULL, NULL, 47, NULL, NULL, 229591),
(232340, '2wzpR02', NULL, NULL, 99, NULL, NULL, 229592),
(232341, '3pvzA02', NULL, NULL, 79, NULL, NULL, 229593),
(232342, '2hekA02', NULL, NULL, 90, NULL, NULL, 229594),
(232343, '1tueG01', NULL, NULL, 108, NULL, NULL, 229595),
(232344, '2jexA01', NULL, NULL, 98, NULL, NULL, 229595),
(232345, '1r6nA01', NULL, NULL, 104, NULL, NULL, 229595),
(232346, '2nnuA01', NULL, NULL, 105, NULL, NULL, 229595),
(232347, '1z2zA01', NULL, NULL, 239, NULL, NULL, 229596),
(232348, '1szwA01', NULL, NULL, 203, NULL, NULL, 229596),
(232349, '5yvxA00', NULL, NULL, 60, NULL, NULL, 229597),
(232350, '2e61A00', NULL, NULL, 69, NULL, NULL, 229597),
(232351, '4z0oA00', NULL, NULL, 59, NULL, NULL, 229597),
(232352, '4qq4A00', NULL, NULL, 62, NULL, NULL, 229597),
(232353, '6o5wA00', NULL, NULL, 59, NULL, NULL, 229597),
(232354, '5svyA00', NULL, NULL, 50, NULL, NULL, 229597),
(232355, '4iq4E03', NULL, NULL, 91, NULL, NULL, 229598),
(232356, '2z16A02', NULL, NULL, 78, NULL, NULL, 229598),
(232357, '1aa7A02', NULL, NULL, 78, NULL, NULL, 229598),
(232358, '5v6gA02', NULL, NULL, 78, NULL, NULL, 229598),
(232359, '2e9xD02', NULL, NULL, 60, NULL, NULL, 229599),
(232360, '2e5rA00', NULL, NULL, 63, NULL, NULL, 229600),
(232361, '6ds6A00', NULL, NULL, 57, NULL, NULL, 229600),
(232362, '2n1aB00', NULL, NULL, 53, NULL, NULL, 229600),
(232363, '2o2cA03', NULL, NULL, 55, NULL, NULL, 229601),
(232364, '1hm5A03', NULL, NULL, 41, NULL, NULL, 229601),
(232365, '2cxnA03', NULL, NULL, 41, NULL, NULL, 229601),
(232366, '3qkiA03', NULL, NULL, 45, NULL, NULL, 229601),
(232367, '3ujhA03', NULL, NULL, 48, NULL, NULL, 229601),
(232368, '1t10A03', NULL, NULL, 49, NULL, NULL, 229601),
(232369, '3hjbA03', NULL, NULL, 39, NULL, NULL, 229601),
(232370, '2wu8A03', NULL, NULL, 45, NULL, NULL, 229601),
(232371, '1iatA03', NULL, NULL, 41, NULL, NULL, 229601);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(232372, '3nbuA03', NULL, NULL, 39, NULL, NULL, 229601),
(232373, '3ljkA03', NULL, NULL, 39, NULL, NULL, 229601),
(232374, '4em6A03', NULL, NULL, 40, NULL, NULL, 229601),
(232375, '1gzdA03', NULL, NULL, 43, NULL, NULL, 229601),
(232376, '4tweA02', NULL, NULL, 228, NULL, NULL, 229602),
(232377, '3i6sA03', NULL, NULL, 130, NULL, NULL, 229602),
(232378, '3icuA01', NULL, NULL, 161, NULL, NULL, 229602),
(232379, '3iibA02', NULL, NULL, 150, NULL, NULL, 229602),
(232380, '4cdjB00', NULL, NULL, 164, NULL, NULL, 229602),
(232381, '4kngE00', NULL, NULL, 160, NULL, NULL, 229602),
(232382, '5ib9A02', NULL, NULL, 127, NULL, NULL, 229602),
(232383, '4c9rA00', NULL, NULL, 161, NULL, NULL, 229602),
(232384, '4tjvA00', NULL, NULL, 165, NULL, NULL, 229602),
(232385, '5of0A02', NULL, NULL, 226, NULL, NULL, 229602),
(232386, '4c84A00', NULL, NULL, 164, NULL, NULL, 229602),
(232387, '3fedA02', NULL, NULL, 226, NULL, NULL, 229602),
(232388, '4c9vA00', NULL, NULL, 158, NULL, NULL, 229602),
(232389, '3kasA02', NULL, NULL, 181, NULL, NULL, 229602),
(232390, '1xf1A02', NULL, NULL, 148, NULL, NULL, 229602),
(232391, '3eifA02', NULL, NULL, 148, NULL, NULL, 229602),
(232392, '4yn3A02', NULL, NULL, 135, NULL, NULL, 229602),
(232393, '1y9zA02', NULL, NULL, 145, NULL, NULL, 229602),
(232394, '4q5gA00', NULL, NULL, 104, NULL, NULL, 229603),
(232395, '4ip8A00', NULL, NULL, 105, NULL, NULL, 229603),
(232396, '5vf3O00', NULL, NULL, 80, NULL, NULL, 229604),
(232397, '3ig9B00', NULL, NULL, 78, NULL, NULL, 229604),
(232398, '2ixsA01', NULL, NULL, 160, NULL, NULL, 229605),
(232399, '2l6oA02', NULL, NULL, 42, NULL, NULL, 229606),
(232400, '3zn4A00', NULL, NULL, 155, NULL, NULL, 229607),
(232401, '4bwpA03', NULL, NULL, 98, NULL, NULL, 229608),
(232402, '4xr7F02', NULL, NULL, 100, NULL, NULL, 229608),
(232403, '4bwxA03', NULL, NULL, 90, NULL, NULL, 229608),
(232404, '4czxB00', NULL, NULL, 118, NULL, NULL, 229608),
(232405, '4d0kB00', NULL, NULL, 105, NULL, NULL, 229608),
(232406, '4cyiB03', NULL, NULL, 92, NULL, NULL, 229608),
(232407, '3p24A01', NULL, NULL, 153, NULL, NULL, 229609),
(232408, '4on1A01', NULL, NULL, 168, NULL, NULL, 229609),
(232409, '3cnlA02', NULL, NULL, 91, NULL, NULL, 229610),
(232410, '1pujA02', NULL, NULL, 93, NULL, NULL, 229610),
(232411, '3gs9A02', NULL, NULL, 92, NULL, NULL, 229611),
(232412, '2jroA01', NULL, NULL, 65, NULL, NULL, 229612),
(232413, '2j5uA03', NULL, NULL, 80, NULL, NULL, 229613),
(232414, '2qf4A02', NULL, NULL, 91, NULL, NULL, 229613),
(232415, '4me3A01', NULL, NULL, 106, NULL, NULL, 229614),
(232416, '3jc6301', NULL, NULL, 113, NULL, NULL, 229614),
(232417, '3jc6201', NULL, NULL, 102, NULL, NULL, 229614),
(232418, '4ywkA01', NULL, NULL, 100, NULL, NULL, 229614),
(232419, '3ja8601', NULL, NULL, 105, NULL, NULL, 229614),
(232420, '4r7yA01', NULL, NULL, 104, NULL, NULL, 229614),
(232421, '1ltlA01', NULL, NULL, 98, NULL, NULL, 229614),
(232422, '4dq5B00', NULL, NULL, 173, NULL, NULL, 229615),
(232423, '4rnaA02', NULL, NULL, 127, NULL, NULL, 229616),
(232424, '4m0wA02', NULL, NULL, 124, NULL, NULL, 229616),
(232425, '5lzhA00', NULL, NULL, 103, NULL, NULL, 229617),
(232426, '2wv6H00', NULL, NULL, 103, NULL, NULL, 229617),
(232427, '1fnuA01', NULL, NULL, 80, NULL, NULL, 229617),
(232428, '1ty0A02', NULL, NULL, 75, NULL, NULL, 229617),
(232429, '1bxtB01', NULL, NULL, 87, NULL, NULL, 229617),
(232430, '2g9hD02', NULL, NULL, 70, NULL, NULL, 229617),
(232431, '2iciA02', NULL, NULL, 78, NULL, NULL, 229617),
(232432, '4l63F00', NULL, NULL, 112, NULL, NULL, 229617),
(232433, '2rdgA02', NULL, NULL, 71, NULL, NULL, 229617),
(232434, '1kluD01', NULL, NULL, 88, NULL, NULL, 229617),
(232435, '1v1pB02', NULL, NULL, 74, NULL, NULL, 229617),
(232436, '1an8A02', NULL, NULL, 75, NULL, NULL, 229617),
(232437, '4dxfA02', NULL, NULL, 76, NULL, NULL, 229617),
(232438, '3o13A02', NULL, NULL, 72, NULL, NULL, 229617),
(232439, '5i4dA02', NULL, NULL, 76, NULL, NULL, 229617),
(232440, '5whuC00', NULL, NULL, 128, NULL, NULL, 229617),
(232441, '4rfbA02', NULL, NULL, 75, NULL, NULL, 229617),
(232442, '3r2tA02', NULL, NULL, 74, NULL, NULL, 229617);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(232443, '1enfA01', NULL, NULL, 78, NULL, NULL, 229617),
(232444, '5lzgA00', NULL, NULL, 103, NULL, NULL, 229617),
(232445, '1et9A02', NULL, NULL, 92, NULL, NULL, 229617),
(232446, '1eu3A02', NULL, NULL, 80, NULL, NULL, 229617),
(232447, '4rhsA00', NULL, NULL, 122, NULL, NULL, 229617),
(232448, '1dyqA01', NULL, NULL, 83, NULL, NULL, 229617),
(232449, '2z8lA02', NULL, NULL, 75, NULL, NULL, 229617),
(232450, '2qejC02', NULL, NULL, 74, NULL, NULL, 229617),
(232451, '2j4xA02', NULL, NULL, 86, NULL, NULL, 229617),
(232452, '3efxF00', NULL, NULL, 103, NULL, NULL, 229617),
(232453, '6ialG00', NULL, NULL, 103, NULL, NULL, 229617),
(232454, '1steA01', NULL, NULL, 88, NULL, NULL, 229617),
(232455, '3sebA01', NULL, NULL, 90, NULL, NULL, 229617),
(232456, '4zysA02', NULL, NULL, 75, NULL, NULL, 229617),
(232457, '1bcpC02', NULL, NULL, 110, NULL, NULL, 229617),
(232458, '1bcpD00', NULL, NULL, 110, NULL, NULL, 229617),
(232459, '1bcpB02', NULL, NULL, 110, NULL, NULL, 229617),
(232460, '4z9cB00', NULL, NULL, 127, NULL, NULL, 229617),
(232461, '1ck1A01', NULL, NULL, 88, NULL, NULL, 229617),
(232462, '5fkaC02', NULL, NULL, 83, NULL, NULL, 229617),
(232463, '4o1nA02', NULL, NULL, 75, NULL, NULL, 229617),
(232464, '2aq2B02', NULL, NULL, 86, NULL, NULL, 229617),
(232465, '3r2iA02', NULL, NULL, 74, NULL, NULL, 229617),
(232466, '3mc0B02', NULL, NULL, 89, NULL, NULL, 229617),
(232467, '3ea6A02', NULL, NULL, 70, NULL, NULL, 229617),
(232468, '1bcpF00', NULL, NULL, 99, NULL, NULL, 229617),
(232469, '4ohjA02', NULL, NULL, 71, NULL, NULL, 229617),
(232470, '4bwgB00', NULL, NULL, 120, NULL, NULL, 229617),
(232471, '3onqA01', NULL, NULL, 50, NULL, NULL, 229618),
(232472, '3onqD01', NULL, NULL, 30, NULL, NULL, 229618),
(232473, '3onqB01', NULL, NULL, 50, NULL, NULL, 229618),
(232474, '3onqC01', NULL, NULL, 31, NULL, NULL, 229618),
(232475, '5iucA00', NULL, NULL, 127, NULL, NULL, 229619),
(232476, '3qksA02', NULL, NULL, 63, NULL, NULL, 229620),
(232477, '4iveA01', NULL, NULL, 72, NULL, NULL, 229621),
(232478, '4iveB01', NULL, NULL, 74, NULL, NULL, 229621),
(232479, '3kujA01', NULL, NULL, 73, NULL, NULL, 229621),
(232480, '2o3lA00', NULL, NULL, 85, NULL, NULL, 229621),
(232481, '1ifwA00', NULL, NULL, 92, NULL, NULL, 229621),
(232482, '2o3lB00', NULL, NULL, 85, NULL, NULL, 229621),
(232483, '1jgnA00', NULL, NULL, 98, NULL, NULL, 229621),
(232484, '1i2tA00', NULL, NULL, 61, NULL, NULL, 229621),
(232485, '2dydA00', NULL, NULL, 85, NULL, NULL, 229621),
(232486, '2o4tA00', NULL, NULL, 100, NULL, NULL, 229621),
(232487, '6h7bA01', NULL, NULL, 75, NULL, NULL, 229621),
(232488, '1nmrA01', NULL, NULL, 76, NULL, NULL, 229621),
(232489, '4iveC01', NULL, NULL, 73, NULL, NULL, 229621),
(232490, '2hh6A00', NULL, NULL, 113, NULL, NULL, 229621),
(232491, '4iveD01', NULL, NULL, 73, NULL, NULL, 229621),
(232492, '1y60A00', NULL, NULL, 169, NULL, NULL, 229622),
(232493, '4a4yA01', NULL, NULL, 102, NULL, NULL, 229623),
(232494, '2abyA00', NULL, NULL, 124, NULL, NULL, 229624),
(232495, '6bbtA02', NULL, NULL, 125, NULL, NULL, 229625),
(232496, '2y1vA03', NULL, NULL, 107, NULL, NULL, 229625),
(232497, '2xtlA02', NULL, NULL, 99, NULL, NULL, 229625),
(232498, '2x9zA02', NULL, NULL, 113, NULL, NULL, 229625),
(232499, '6bbwA02', NULL, NULL, 127, NULL, NULL, 229625),
(232500, '3gldA02', NULL, NULL, 137, NULL, NULL, 229625),
(232501, '2xidA04', NULL, NULL, 119, NULL, NULL, 229625),
(232502, '1d2oA02', NULL, NULL, 80, NULL, NULL, 229625),
(232503, '1d2oA01', NULL, NULL, 107, NULL, NULL, 229625),
(232504, '2joeA01', NULL, NULL, 128, NULL, NULL, 229626),
(232505, '3lyyA00', NULL, NULL, 107, NULL, NULL, 229627),
(232506, '3i57A02', NULL, NULL, 110, NULL, NULL, 229627),
(232507, '3q69A00', NULL, NULL, 105, NULL, NULL, 229627),
(232508, '4mt5A02', NULL, NULL, 112, NULL, NULL, 229627),
(232509, '3nz3A00', NULL, NULL, 112, NULL, NULL, 229627),
(232510, '4g7xA00', NULL, NULL, 105, NULL, NULL, 229628),
(232511, '4g7wA00', NULL, NULL, 98, NULL, NULL, 229628),
(232512, '3anuA01', NULL, NULL, 150, NULL, NULL, 229629),
(232513, '4v15A01', NULL, NULL, 144, NULL, NULL, 229629);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(232514, '3gwqB01', NULL, NULL, 170, NULL, NULL, 229629),
(232515, '3wqcA01', NULL, NULL, 167, NULL, NULL, 229629),
(232516, '3llxA01', NULL, NULL, 157, NULL, NULL, 229629),
(232517, '1srqC02', NULL, NULL, 190, NULL, NULL, 229630),
(232518, '6fbcA01', NULL, NULL, 155, NULL, NULL, 229631),
(232519, '4fw1B01', NULL, NULL, 167, NULL, NULL, 229631),
(232520, '3u3gA00', NULL, NULL, 140, NULL, NULL, 229631),
(232521, '3l3uA00', NULL, NULL, 163, NULL, NULL, 229631),
(232522, '3tr8A00', NULL, NULL, 186, NULL, NULL, 229631),
(232523, '1x9mA01', NULL, NULL, 226, NULL, NULL, 229631),
(232524, '2gbzA00', NULL, NULL, 194, NULL, NULL, 229631),
(232525, '3qipA05', NULL, NULL, 126, NULL, NULL, 229631),
(232526, '1vk0A00', NULL, NULL, 206, NULL, NULL, 229631),
(232527, '4fzxD00', NULL, NULL, 175, NULL, NULL, 229631),
(232528, '2gv9A03', NULL, NULL, 231, NULL, NULL, 229631),
(232529, '2yhaA02', NULL, NULL, 239, NULL, NULL, 229631),
(232530, '4ah9A00', NULL, NULL, 157, NULL, NULL, 229631),
(232531, '1jl1A00', NULL, NULL, 155, NULL, NULL, 229631),
(232532, '4e19A00', NULL, NULL, 133, NULL, NULL, 229631),
(232533, '6a4dB00', NULL, NULL, 184, NULL, NULL, 229631),
(232534, '4nlcA01', NULL, NULL, 272, NULL, NULL, 229631),
(232535, '1ekeB01', NULL, NULL, 175, NULL, NULL, 229631),
(232536, '3f2kB00', NULL, NULL, 226, NULL, NULL, 229631),
(232537, '1lwcA05', NULL, NULL, 106, NULL, NULL, 229631),
(232538, '4ibnA01', NULL, NULL, 197, NULL, NULL, 229631),
(232539, '2z1iA00', NULL, NULL, 155, NULL, NULL, 229631),
(232540, '1kcfB00', NULL, NULL, 258, NULL, NULL, 229631),
(232541, '2py5A01', NULL, NULL, 188, NULL, NULL, 229631),
(232542, '2d0bA02', NULL, NULL, 220, NULL, NULL, 229631),
(232543, '4fzyA00', NULL, NULL, 175, NULL, NULL, 229631),
(232544, '2rpiA00', NULL, NULL, 112, NULL, NULL, 229631),
(232545, '2ehgA00', NULL, NULL, 149, NULL, NULL, 229631),
(232546, '3o3fA00', NULL, NULL, 222, NULL, NULL, 229631),
(232547, '1mu2A05', NULL, NULL, 127, NULL, NULL, 229631),
(232548, '3vn5A02', NULL, NULL, 187, NULL, NULL, 229631),
(232549, '4mdaA00', NULL, NULL, 225, NULL, NULL, 229631),
(232550, '1yvuA04', NULL, NULL, 214, NULL, NULL, 229631),
(232551, '3v1oA00', NULL, NULL, 180, NULL, NULL, 229631),
(232552, '2kfnA01', NULL, NULL, 217, NULL, NULL, 229631),
(232553, '4yfuA01', NULL, NULL, 194, NULL, NULL, 229631),
(232554, '2p51A00', NULL, NULL, 255, NULL, NULL, 229631),
(232555, '1j9aA00', NULL, NULL, 184, NULL, NULL, 229631),
(232556, '5ywtA01', NULL, NULL, 220, NULL, NULL, 229631),
(232557, '2lsnA00', NULL, NULL, 165, NULL, NULL, 229631),
(232558, '3pufG01', NULL, NULL, 204, NULL, NULL, 229631),
(232559, '1noyB02', NULL, NULL, 232, NULL, NULL, 229631),
(232560, '5cr4A00', NULL, NULL, 230, NULL, NULL, 229631),
(232561, '5gq9A05', NULL, NULL, 219, NULL, NULL, 229631),
(232562, '5dmrA00', NULL, NULL, 172, NULL, NULL, 229631),
(232563, '3kksB00', NULL, NULL, 152, NULL, NULL, 229631),
(232564, '1hjrA00', NULL, NULL, 158, NULL, NULL, 229631),
(232565, '3h08B00', NULL, NULL, 146, NULL, NULL, 229631),
(232566, '4kreA04', NULL, NULL, 278, NULL, NULL, 229631),
(232567, '1io2A01', NULL, NULL, 160, NULL, NULL, 229631),
(232568, '4zhrA05', NULL, NULL, 126, NULL, NULL, 229631),
(232569, '2kw4A00', NULL, NULL, 147, NULL, NULL, 229631),
(232570, '1wljA00', NULL, NULL, 189, NULL, NULL, 229631),
(232571, '6q4tA02', NULL, NULL, 217, NULL, NULL, 229631),
(232572, '5dk5A01', NULL, NULL, 213, NULL, NULL, 229631),
(232573, '4qclA03', NULL, NULL, 300, NULL, NULL, 229631),
(232574, '2x78A00', NULL, NULL, 200, NULL, NULL, 229631),
(232575, '2jguA02', NULL, NULL, 217, NULL, NULL, 229631),
(232576, '2d5rA00', NULL, NULL, 252, NULL, NULL, 229631),
(232577, '5omvA02', NULL, NULL, 217, NULL, NULL, 229631),
(232578, '2e6mA00', NULL, NULL, 208, NULL, NULL, 229631),
(232579, '3iayA03', NULL, NULL, 219, NULL, NULL, 229631),
(232580, '5v5fA00', NULL, NULL, 200, NULL, NULL, 229631),
(232581, '2yv0X00', NULL, NULL, 155, NULL, NULL, 229631),
(232582, '3v9wB00', NULL, NULL, 207, NULL, NULL, 229631),
(232583, '1y97A01', NULL, NULL, 216, NULL, NULL, 229631),
(232584, '3oymA03', NULL, NULL, 134, NULL, NULL, 229631);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(232585, '3cymA01', NULL, NULL, 212, NULL, NULL, 229631),
(232586, '4ly7A00', NULL, NULL, 155, NULL, NULL, 229631),
(232587, '1tgoA02', NULL, NULL, 217, NULL, NULL, 229631),
(232588, '5vm9C04', NULL, NULL, 278, NULL, NULL, 229631),
(232589, '1b9fA00', NULL, NULL, 163, NULL, NULL, 229631),
(232590, '5c0yA01', NULL, NULL, 306, NULL, NULL, 229631),
(232591, '3safB01', NULL, NULL, 310, NULL, NULL, 229631),
(232592, '3dlbA04', NULL, NULL, 175, NULL, NULL, 229631),
(232593, '4ogeA01', NULL, NULL, 198, NULL, NULL, 229631),
(232594, '1cxqA00', NULL, NULL, 162, NULL, NULL, 229631),
(232595, '1s5jA02', NULL, NULL, 196, NULL, NULL, 229631),
(232596, '1uocB00', NULL, NULL, 289, NULL, NULL, 229631),
(232597, '3p5jA01', NULL, NULL, 202, NULL, NULL, 229631),
(232598, '1d5aA02', NULL, NULL, 217, NULL, NULL, 229631),
(232599, '2igiB00', NULL, NULL, 180, NULL, NULL, 229631),
(232600, '3qioA00', NULL, NULL, 150, NULL, NULL, 229631),
(232601, '2xriA01', NULL, NULL, 206, NULL, NULL, 229631),
(232602, '5jl4A00', NULL, NULL, 163, NULL, NULL, 229631),
(232603, '2f96A00', NULL, NULL, 206, NULL, NULL, 229631),
(232604, '1bcoA01', NULL, NULL, 240, NULL, NULL, 229631),
(232605, '6a45B01', NULL, NULL, 216, NULL, NULL, 229631),
(232606, '1rnhA00', NULL, NULL, 155, NULL, NULL, 229631),
(232607, '2qxfA01', NULL, NULL, 201, NULL, NULL, 229631),
(232608, '4rg8A01', NULL, NULL, 194, NULL, NULL, 229631),
(232609, '5cy4B00', NULL, NULL, 196, NULL, NULL, 229631),
(232610, '1c9rA05', NULL, NULL, 130, NULL, NULL, 229631),
(232611, '1i39A01', NULL, NULL, 155, NULL, NULL, 229631),
(232612, '5h12A02', NULL, NULL, 217, NULL, NULL, 229631),
(232613, '4ahcA02', NULL, NULL, 217, NULL, NULL, 229631),
(232614, '3hstB00', NULL, NULL, 141, NULL, NULL, 229631),
(232615, '5t3aA01', NULL, NULL, 154, NULL, NULL, 229631),
(232616, '1rilA00', NULL, NULL, 166, NULL, NULL, 229631),
(232617, '1exqA00', NULL, NULL, 154, NULL, NULL, 229631),
(232618, '4dleA01', NULL, NULL, 154, NULL, NULL, 229631),
(232619, '3p1gA00', NULL, NULL, 165, NULL, NULL, 229631),
(232620, '4qozB02', NULL, NULL, 242, NULL, NULL, 229631),
(232621, '2p1jA01', NULL, NULL, 150, NULL, NULL, 229631),
(232622, '4z4dA04', NULL, NULL, 278, NULL, NULL, 229631),
(232623, '4ktwA00', NULL, NULL, 161, NULL, NULL, 229631),
(232624, '2hb5A00', NULL, NULL, 164, NULL, NULL, 229631),
(232625, '4g1qA05', NULL, NULL, 129, NULL, NULL, 229631),
(232626, '1jl2A00', NULL, NULL, 156, NULL, NULL, 229631),
(232627, '1uaxA00', NULL, NULL, 220, NULL, NULL, 229631),
(232628, '2guiA00', NULL, NULL, 194, NULL, NULL, 229631),
(232629, '3p83D00', NULL, NULL, 217, NULL, NULL, 229631),
(232630, '3d45B01', NULL, NULL, 327, NULL, NULL, 229631),
(232631, '2z1hA00', NULL, NULL, 155, NULL, NULL, 229631),
(232632, '4ep4A00', NULL, NULL, 166, NULL, NULL, 229631),
(232633, '4okeA00', NULL, NULL, 168, NULL, NULL, 229631),
(232634, '4ogcA01', NULL, NULL, 200, NULL, NULL, 229631),
(232635, '4py5A02', NULL, NULL, 199, NULL, NULL, 229631),
(232636, '4fzxC00', NULL, NULL, 175, NULL, NULL, 229631),
(232637, '4mq3A00', NULL, NULL, 132, NULL, NULL, 229631),
(232638, '1w0hA00', NULL, NULL, 204, NULL, NULL, 229631),
(232639, '6dopA00', NULL, NULL, 142, NULL, NULL, 229631),
(232640, '2a1rB01', NULL, NULL, 313, NULL, NULL, 229631),
(232641, '2etjA00', NULL, NULL, 233, NULL, NULL, 229631),
(232642, '4flwA02', NULL, NULL, 217, NULL, NULL, 229631),
(232643, '2w42B02', NULL, NULL, 255, NULL, NULL, 229631),
(232644, '1c6vA00', NULL, NULL, 164, NULL, NULL, 229631),
(232645, '1u04A04', NULL, NULL, 224, NULL, NULL, 229631),
(232646, '2e4lA00', NULL, NULL, 158, NULL, NULL, 229631),
(232647, '3qexA02', NULL, NULL, 231, NULL, NULL, 229631),
(232648, '1aswA00', NULL, NULL, 162, NULL, NULL, 229631),
(232649, '5cz1A00', NULL, NULL, 169, NULL, NULL, 229631),
(232650, '2fbyA00', NULL, NULL, 205, NULL, NULL, 229631),
(232651, '2qkbA00', NULL, NULL, 154, NULL, NULL, 229631),
(232652, '4fvmA03', NULL, NULL, 236, NULL, NULL, 229631),
(232653, '1q8iA03', NULL, NULL, 197, NULL, NULL, 229631),
(232654, '1yt3A01', NULL, NULL, 194, NULL, NULL, 229631),
(232655, '4b3oA05', NULL, NULL, 126, NULL, NULL, 229631);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(232656, '3f9kA02', NULL, NULL, 154, NULL, NULL, 229631),
(232657, '1rifA01', NULL, NULL, 90, NULL, NULL, 229632),
(232658, '3fprA00', NULL, NULL, 100, NULL, NULL, 229633),
(232659, '2k4nA00', NULL, NULL, 111, NULL, NULL, 229634),
(232660, '1wh2A01', NULL, NULL, 61, NULL, NULL, 229635),
(232661, '4bwsF00', NULL, NULL, 71, NULL, NULL, 229635),
(232662, '3k3vA00', NULL, NULL, 100, NULL, NULL, 229635),
(232663, '4hkjD00', NULL, NULL, 206, NULL, NULL, 229636),
(232664, '4c91A03', NULL, NULL, 179, NULL, NULL, 229637),
(232665, '3hj4A02', NULL, NULL, 131, NULL, NULL, 229638),
(232666, '1ou5A01', NULL, NULL, 152, NULL, NULL, 229638),
(232667, '1v4aA02', NULL, NULL, 174, NULL, NULL, 229638),
(232668, '1q79A02', NULL, NULL, 156, NULL, NULL, 229638),
(232669, '2nrkA00', NULL, NULL, 173, NULL, NULL, 229638),
(232670, '2pbeA01', NULL, NULL, 147, NULL, NULL, 229638),
(232671, '3jyyA01', NULL, NULL, 136, NULL, NULL, 229638),
(232672, '2rffA00', NULL, NULL, 111, NULL, NULL, 229638),
(232673, '1vj7B02', NULL, NULL, 133, NULL, NULL, 229638),
(232674, '4at7A02', NULL, NULL, 152, NULL, NULL, 229638),
(232675, '4ud4A02', NULL, NULL, 125, NULL, NULL, 229638),
(232676, '3k7dA02', NULL, NULL, 250, NULL, NULL, 229638),
(232677, '3wfrF01', NULL, NULL, 167, NULL, NULL, 229638),
(232678, '3h37A01', NULL, NULL, 160, NULL, NULL, 229638),
(232679, '2hhpA02', NULL, NULL, 156, NULL, NULL, 229638),
(232680, '3uxoA03', NULL, NULL, 123, NULL, NULL, 229638),
(232681, '2ihmB03', NULL, NULL, 138, NULL, NULL, 229638),
(232682, '4wbyA01', NULL, NULL, 148, NULL, NULL, 229638),
(232683, '3wfrH01', NULL, NULL, 167, NULL, NULL, 229638),
(232684, '4ebjA01', NULL, NULL, 142, NULL, NULL, 229638),
(232685, '4p4mA02', NULL, NULL, 123, NULL, NULL, 229638),
(232686, '2o5aA01', NULL, NULL, 108, NULL, NULL, 229638),
(232687, '1wotA00', NULL, NULL, 98, NULL, NULL, 229638),
(232688, '1miwA01', NULL, NULL, 144, NULL, NULL, 229638),
(232689, '4ig8A01', NULL, NULL, 161, NULL, NULL, 229638),
(232690, '4s3nA01', NULL, NULL, 157, NULL, NULL, 229638),
(232691, '3wfsC01', NULL, NULL, 167, NULL, NULL, 229638),
(232692, '6fgjA01', NULL, NULL, 150, NULL, NULL, 229638),
(232693, '3wfqF01', NULL, NULL, 167, NULL, NULL, 229638),
(232694, '3wfqH01', NULL, NULL, 167, NULL, NULL, 229638),
(232695, '5decC01', NULL, NULL, 154, NULL, NULL, 229638),
(232696, '2bcqA03', NULL, NULL, 123, NULL, NULL, 229638),
(232697, '4lt6A02', NULL, NULL, 156, NULL, NULL, 229638),
(232698, '2id1A01', NULL, NULL, 105, NULL, NULL, 229638),
(232699, '1px5A01', NULL, NULL, 160, NULL, NULL, 229638),
(232700, '4xq7A01', NULL, NULL, 165, NULL, NULL, 229638),
(232701, '5xnxA02', NULL, NULL, 134, NULL, NULL, 229638),
(232702, '1ylqA00', NULL, NULL, 96, NULL, NULL, 229638),
(232703, '5hrbA01', NULL, NULL, 109, NULL, NULL, 229638),
(232704, '3wfoA01', NULL, NULL, 167, NULL, NULL, 229638),
(232705, '6fgkC01', NULL, NULL, 145, NULL, NULL, 229638),
(232706, '6q52A01', NULL, NULL, 143, NULL, NULL, 229638),
(232707, '1knyA01', NULL, NULL, 125, NULL, NULL, 229638),
(232708, '4at7B02', NULL, NULL, 198, NULL, NULL, 229638),
(232709, '2w9mB03', NULL, NULL, 81, NULL, NULL, 229638),
(232710, '4wcwA01', NULL, NULL, 112, NULL, NULL, 229638),
(232711, '3wfrE01', NULL, NULL, 167, NULL, NULL, 229638),
(232712, '5vzaA03', NULL, NULL, 124, NULL, NULL, 229638),
(232713, '3upsA00', NULL, NULL, 120, NULL, NULL, 229638),
(232714, '3wfrG01', NULL, NULL, 167, NULL, NULL, 229638),
(232715, '4qz9A03', NULL, NULL, 139, NULL, NULL, 229638),
(232716, '3upqA03', NULL, NULL, 118, NULL, NULL, 229638),
(232717, '1no5B00', NULL, NULL, 114, NULL, NULL, 229638),
(232718, '3l9dB01', NULL, NULL, 142, NULL, NULL, 229638),
(232719, '1r89A02', NULL, NULL, 128, NULL, NULL, 229638),
(232720, '4kliA03', NULL, NULL, 123, NULL, NULL, 229638),
(232721, '3c18A01', NULL, NULL, 115, NULL, NULL, 229638),
(232722, '3wfsD01', NULL, NULL, 167, NULL, NULL, 229638),
(232723, '3nybA02', NULL, NULL, 110, NULL, NULL, 229638),
(232724, '3aqlA01', NULL, NULL, 163, NULL, NULL, 229638),
(232725, '3wfqE01', NULL, NULL, 167, NULL, NULL, 229638),
(232726, '3wfqG01', NULL, NULL, 167, NULL, NULL, 229638);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(232727, '3b0xA03', NULL, NULL, 105, NULL, NULL, 229638),
(232728, '2be3B01', NULL, NULL, 149, NULL, NULL, 229638),
(232729, '2bvbA00', NULL, NULL, 137, NULL, NULL, 229639),
(232730, '4fo0A02', NULL, NULL, 44, NULL, NULL, 229640),
(232731, '4uzzB00', NULL, NULL, 68, NULL, NULL, 229641),
(232732, '1q57G01', NULL, NULL, 73, NULL, NULL, 229642),
(232733, '2azeC00', NULL, NULL, 46, NULL, NULL, 229643),
(232734, '2v8iA03', NULL, NULL, 63, NULL, NULL, 229644),
(232735, '5a29A03', NULL, NULL, 64, NULL, NULL, 229644),
(232736, '6h9nA01', NULL, NULL, 70, NULL, NULL, 229645),
(232737, '2mhjA00', NULL, NULL, 95, NULL, NULL, 229645),
(232738, '4k3cA02', NULL, NULL, 76, NULL, NULL, 229645),
(232739, '4k3cA01', NULL, NULL, 82, NULL, NULL, 229645),
(232740, '2vh2B01', NULL, NULL, 72, NULL, NULL, 229645),
(232741, '4k3bA05', NULL, NULL, 79, NULL, NULL, 229645),
(232742, '2qdfA03', NULL, NULL, 91, NULL, NULL, 229645),
(232743, '2qdfA02', NULL, NULL, 83, NULL, NULL, 229645),
(232744, '2x8xX01', NULL, NULL, 76, NULL, NULL, 229645),
(232745, '2qdfA01', NULL, NULL, 75, NULL, NULL, 229645),
(232746, '3mc9A01', NULL, NULL, 79, NULL, NULL, 229645),
(232747, '2x8xX02', NULL, NULL, 76, NULL, NULL, 229645),
(232748, '2x8xX03', NULL, NULL, 83, NULL, NULL, 229645),
(232749, '3mc9A02', NULL, NULL, 86, NULL, NULL, 229645),
(232750, '3njtA02', NULL, NULL, 73, NULL, NULL, 229645),
(232751, '3njtA03', NULL, NULL, 73, NULL, NULL, 229645),
(232752, '4k3bA03', NULL, NULL, 92, NULL, NULL, 229645),
(232753, '4k3bA04', NULL, NULL, 78, NULL, NULL, 229645),
(232754, '4k3bA01', NULL, NULL, 69, NULL, NULL, 229645),
(232755, '4k3bA02', NULL, NULL, 84, NULL, NULL, 229645),
(232756, '4bzaA03', NULL, NULL, 79, NULL, NULL, 229645),
(232757, '4bzaA02', NULL, NULL, 87, NULL, NULL, 229645),
(232758, '4bzaA01', NULL, NULL, 81, NULL, NULL, 229645),
(232759, '3q6bA02', NULL, NULL, 74, NULL, NULL, 229645),
(232760, '3q6bA01', NULL, NULL, 81, NULL, NULL, 229645),
(232761, '3og5A01', NULL, NULL, 86, NULL, NULL, 229645),
(232762, '3og5A02', NULL, NULL, 80, NULL, NULL, 229645),
(232763, '3mc8A03', NULL, NULL, 97, NULL, NULL, 229645),
(232764, '3tj9A02', NULL, NULL, 95, NULL, NULL, 229646),
(232765, '3tj8A02', NULL, NULL, 74, NULL, NULL, 229646),
(232766, '1earA02', NULL, NULL, 74, NULL, NULL, 229646),
(232767, '1gmwA01', NULL, NULL, 64, NULL, NULL, 229646),
(232768, '1gmuA01', NULL, NULL, 72, NULL, NULL, 229646),
(232769, '2hfvA01', NULL, NULL, 77, NULL, NULL, 229646),
(232770, '5xx1H04', NULL, NULL, 125, NULL, NULL, 229647),
(232771, '1c4kA04', NULL, NULL, 129, NULL, NULL, 229647),
(232772, '2vycA04', NULL, NULL, 125, NULL, NULL, 229647),
(232773, '3n75A04', NULL, NULL, 121, NULL, NULL, 229647),
(232774, '3opyA01', NULL, NULL, 170, NULL, NULL, 229648),
(232775, '2xsjB01', NULL, NULL, 133, NULL, NULL, 229649),
(232776, '3mm5B01', NULL, NULL, 116, NULL, NULL, 229649),
(232777, '2v4jB01', NULL, NULL, 133, NULL, NULL, 229649),
(232778, '3or1B01', NULL, NULL, 133, NULL, NULL, 229649),
(232779, '1k3iA02', NULL, NULL, 388, NULL, NULL, 229650),
(232780, '5c86A01', NULL, NULL, 382, NULL, NULL, 229650),
(232781, '3vu1A02', NULL, NULL, 87, NULL, NULL, 229651),
(232782, '3wovA02', NULL, NULL, 88, NULL, NULL, 229651),
(232783, '2zaiA02', NULL, NULL, 83, NULL, NULL, 229651),
(232784, '3lxuX04', NULL, NULL, 132, NULL, NULL, 229652),
(232785, '2ixnA02', NULL, NULL, 118, NULL, NULL, 229653),
(232786, '2ixmA02', NULL, NULL, 111, NULL, NULL, 229653),
(232787, '2ixoA02', NULL, NULL, 120, NULL, NULL, 229653),
(232788, '3fawA01', NULL, NULL, 95, NULL, NULL, 229654),
(232789, '2c9qA00', NULL, NULL, 102, NULL, NULL, 229654),
(232790, '6nfrA00', NULL, NULL, 98, NULL, NULL, 229654),
(232791, '4aq1A01', NULL, NULL, 94, NULL, NULL, 229654),
(232792, '2ya1A03', NULL, NULL, 97, NULL, NULL, 229654),
(232793, '1o6vA02', NULL, NULL, 82, NULL, NULL, 229654),
(232794, '1xeuA02', NULL, NULL, 83, NULL, NULL, 229654),
(232795, '3bz5A02', NULL, NULL, 86, NULL, NULL, 229654),
(232796, '4aw4A03', NULL, NULL, 103, NULL, NULL, 229654),
(232797, '1h6uA03', NULL, NULL, 103, NULL, NULL, 229654);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(232798, '2ra1A04', NULL, NULL, 97, NULL, NULL, 229654),
(232799, '5icuA00', NULL, NULL, 102, NULL, NULL, 229654),
(232800, '3bc9A01', NULL, NULL, 93, NULL, NULL, 229654),
(232801, '4cilA02', NULL, NULL, 76, NULL, NULL, 229654),
(232802, '1ix2A00', NULL, NULL, 104, NULL, NULL, 229654),
(232803, '3tugA02', NULL, NULL, 118, NULL, NULL, 229655),
(232804, '1zvdA03', NULL, NULL, 120, NULL, NULL, 229655),
(232805, '3pt3B00', NULL, NULL, 118, NULL, NULL, 229655),
(232806, '1nd7A03', NULL, NULL, 113, NULL, NULL, 229655),
(232807, '1c4zA03', NULL, NULL, 115, NULL, NULL, 229655),
(232808, '3h1dA03', NULL, NULL, 120, NULL, NULL, 229655),
(232809, '3olmA03', NULL, NULL, 120, NULL, NULL, 229655),
(232810, '2xbfA03', NULL, NULL, 120, NULL, NULL, 229655),
(232811, '2oniA03', NULL, NULL, 111, NULL, NULL, 229655),
(232812, '3neuA02', NULL, NULL, 46, NULL, NULL, 229656),
(232813, '4r1hA02', NULL, NULL, 51, NULL, NULL, 229656),
(232814, '2p12A01', NULL, NULL, 170, NULL, NULL, 229657),
(232815, '3exmA01', NULL, NULL, 195, NULL, NULL, 229657),
(232816, '5fbfA00', NULL, NULL, 267, NULL, NULL, 229658),
(232817, '3sngA00', NULL, NULL, 277, NULL, NULL, 229658),
(232818, '1olpA01', NULL, NULL, 249, NULL, NULL, 229658),
(232819, '1khoA01', NULL, NULL, 250, NULL, NULL, 229658),
(232820, '1ah7A00', NULL, NULL, 245, NULL, NULL, 229658),
(232821, '4cxpA00', NULL, NULL, 269, NULL, NULL, 229658),
(232822, '1ak0A00', NULL, NULL, 270, NULL, NULL, 229658),
(232823, '1ca1A01', NULL, NULL, 250, NULL, NULL, 229658),
(232824, '3t38A01', NULL, NULL, 79, NULL, NULL, 229659),
(232825, '1tkvA00', NULL, NULL, 90, NULL, NULL, 229660),
(232826, '3fhnA05', NULL, NULL, 67, NULL, NULL, 229661),
(232827, '3qq5A02', NULL, NULL, 109, NULL, NULL, 229662),
(232828, '5kh0A02', NULL, NULL, 109, NULL, NULL, 229662),
(232829, '1o75A04', NULL, NULL, 83, NULL, NULL, 229663),
(232830, '2pbiA02', NULL, NULL, 101, NULL, NULL, 229664),
(232831, '6n9gA02', NULL, NULL, 103, NULL, NULL, 229664),
(232832, '2e60A01', NULL, NULL, 59, NULL, NULL, 229665),
(232833, '2dt6A01', NULL, NULL, 59, NULL, NULL, 229665),
(232834, '2dt7B01', NULL, NULL, 59, NULL, NULL, 229665),
(232835, '4dgwB01', NULL, NULL, 53, NULL, NULL, 229665),
(232836, '1x4oA00', NULL, NULL, 78, NULL, NULL, 229665),
(232837, '1x4pA00', NULL, NULL, 66, NULL, NULL, 229665),
(232838, '2e5zA01', NULL, NULL, 59, NULL, NULL, 229665),
(232839, '1ug0A00', NULL, NULL, 88, NULL, NULL, 229665),
(232840, '1x74A05', NULL, NULL, 34, NULL, NULL, 229666),
(232841, '4cdpA02', NULL, NULL, 174, NULL, NULL, 229667),
(232842, '5exvC00', NULL, NULL, 167, NULL, NULL, 229667),
(232843, '2oviA00', NULL, NULL, 164, NULL, NULL, 229667),
(232844, '2hqvA00', NULL, NULL, 195, NULL, NULL, 229667),
(232845, '2ph0B00', NULL, NULL, 174, NULL, NULL, 229667),
(232846, '2j0pA02', NULL, NULL, 173, NULL, NULL, 229667),
(232847, '3fm2A00', NULL, NULL, 135, NULL, NULL, 229667),
(232848, '2j0pA01', NULL, NULL, 162, NULL, NULL, 229667),
(232849, '4mf9A02', NULL, NULL, 176, NULL, NULL, 229667),
(232850, '4mf9B01', NULL, NULL, 165, NULL, NULL, 229667),
(232851, '4cdpA01', NULL, NULL, 174, NULL, NULL, 229667),
(232852, '2w9yA00', NULL, NULL, 140, NULL, NULL, 229668),
(232853, '6bggB01', NULL, NULL, 81, NULL, NULL, 229669),
(232854, '2jnsA01', NULL, NULL, 81, NULL, NULL, 229669),
(232855, '3l8iA01', NULL, NULL, 54, NULL, NULL, 229670),
(232856, '4gehB00', NULL, NULL, 69, NULL, NULL, 229670),
(232857, '3ajmA01', NULL, NULL, 61, NULL, NULL, 229670),
(232858, '3w8hB00', NULL, NULL, 78, NULL, NULL, 229670),
(232859, '4b6zA01', NULL, NULL, 113, NULL, NULL, 229671),
(232860, '3l2nA01', NULL, NULL, 111, NULL, NULL, 229671),
(232861, '4a37A01', NULL, NULL, 126, NULL, NULL, 229671),
(232862, '3k2kA01', NULL, NULL, 113, NULL, NULL, 229671),
(232863, '4ycbB00', NULL, NULL, 163, NULL, NULL, 229672),
(232864, '4qgsA01', NULL, NULL, 175, NULL, NULL, 229672),
(232865, '5hvnA01', NULL, NULL, 175, NULL, NULL, 229672),
(232866, '3zokA01', NULL, NULL, 187, NULL, NULL, 229672),
(232867, '3ce9A01', NULL, NULL, 160, NULL, NULL, 229672),
(232868, '4p53A01', NULL, NULL, 176, NULL, NULL, 229672);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(232869, '3rf7A01', NULL, NULL, 203, NULL, NULL, 229672),
(232870, '3uhjC01', NULL, NULL, 157, NULL, NULL, 229672),
(232871, '5br4B01', NULL, NULL, 186, NULL, NULL, 229672),
(232872, '5fb3E01', NULL, NULL, 145, NULL, NULL, 229672),
(232873, '4ja0D02', NULL, NULL, 129, NULL, NULL, 229672),
(232874, '3hl0A01', NULL, NULL, 162, NULL, NULL, 229672),
(232875, '5eksB01', NULL, NULL, 179, NULL, NULL, 229672),
(232876, '3clhA01', NULL, NULL, 162, NULL, NULL, 229672),
(232877, '1ujnA01', NULL, NULL, 161, NULL, NULL, 229672),
(232878, '4fr2A01', NULL, NULL, 199, NULL, NULL, 229672),
(232879, '1jq5A01', NULL, NULL, 152, NULL, NULL, 229672),
(232880, '3iv7A01', NULL, NULL, 163, NULL, NULL, 229672),
(232881, '1xahA01', NULL, NULL, 166, NULL, NULL, 229672),
(232882, '5xn8A01', NULL, NULL, 159, NULL, NULL, 229672),
(232883, '3zdrA01', NULL, NULL, 193, NULL, NULL, 229672),
(232884, '4mcaA01', NULL, NULL, 159, NULL, NULL, 229672),
(232885, '5c5dD00', NULL, NULL, 159, NULL, NULL, 229672),
(232886, '6o55D00', NULL, NULL, 174, NULL, NULL, 229672),
(232887, '5tprA01', NULL, NULL, 184, NULL, NULL, 229672),
(232888, '5yvrA01', NULL, NULL, 203, NULL, NULL, 229672),
(232889, '2gruA01', NULL, NULL, 171, NULL, NULL, 229672),
(232890, '1ta9B01', NULL, NULL, 152, NULL, NULL, 229672),
(232891, '6c5cA01', NULL, NULL, 182, NULL, NULL, 229672),
(232892, '1kq3A01', NULL, NULL, 169, NULL, NULL, 229672),
(232893, '4grdA00', NULL, NULL, 173, NULL, NULL, 229672),
(232894, '1sg6A01', NULL, NULL, 182, NULL, NULL, 229672),
(232895, '3qbeA01', NULL, NULL, 180, NULL, NULL, 229672),
(232896, '3jzdA01', NULL, NULL, 164, NULL, NULL, 229672),
(232897, '3orsA00', NULL, NULL, 163, NULL, NULL, 229672),
(232898, '3w5sA01', NULL, NULL, 160, NULL, NULL, 229672),
(232899, '3kuuC00', NULL, NULL, 174, NULL, NULL, 229672),
(232900, '3ox4A01', NULL, NULL, 184, NULL, NULL, 229672),
(232901, '3trhG00', NULL, NULL, 169, NULL, NULL, 229672),
(232902, '1o2dA01', NULL, NULL, 173, NULL, NULL, 229672),
(232903, '1qczA00', NULL, NULL, 169, NULL, NULL, 229672),
(232904, '3oowD00', NULL, NULL, 166, NULL, NULL, 229672),
(232905, '5k8cA01', NULL, NULL, 186, NULL, NULL, 229672),
(232906, '4rflA01', NULL, NULL, 135, NULL, NULL, 229672),
(232907, '3bfjA01', NULL, NULL, 188, NULL, NULL, 229672),
(232908, '3lp6A00', NULL, NULL, 174, NULL, NULL, 229672),
(232909, '1o4vA00', NULL, NULL, 183, NULL, NULL, 229672),
(232910, '2ywxA00', NULL, NULL, 157, NULL, NULL, 229672),
(232911, '5zxlA01', NULL, NULL, 159, NULL, NULL, 229672),
(232912, '1vljA01', NULL, NULL, 176, NULL, NULL, 229672),
(232913, '5wq5A01', NULL, NULL, 159, NULL, NULL, 229672),
(232914, '3okfA01', NULL, NULL, 172, NULL, NULL, 229672),
(232915, '1xmpC00', NULL, NULL, 170, NULL, NULL, 229672),
(232916, '2h31A02', NULL, NULL, 130, NULL, NULL, 229672),
(232917, '2ov7A01', NULL, NULL, 64, NULL, NULL, 229673),
(232918, '1vkwA02', NULL, NULL, 96, NULL, NULL, 229674),
(232919, '2r5jA00', NULL, NULL, 423, NULL, NULL, 229675),
(232920, '5y9eE00', NULL, NULL, 431, NULL, NULL, 229675),
(232921, '5w1oD00', NULL, NULL, 427, NULL, NULL, 229675),
(232922, '2r5kA00', NULL, NULL, 424, NULL, NULL, 229675),
(232923, '5y9fA00', NULL, NULL, 431, NULL, NULL, 229675),
(232924, '6igfB00', NULL, NULL, 431, NULL, NULL, 229675),
(232925, '5w1xA00', NULL, NULL, 427, NULL, NULL, 229675),
(232926, '6igeI00', NULL, NULL, 424, NULL, NULL, 229675),
(232927, '3dclA03', NULL, NULL, 39, NULL, NULL, 229676),
(232928, '5b1aM00', NULL, NULL, 46, NULL, NULL, 229677),
(232929, '5z62M00', NULL, NULL, 43, NULL, NULL, 229677),
(232930, '4pswA03', NULL, NULL, 54, NULL, NULL, 229678),
(232931, '2p0wA03', NULL, NULL, 54, NULL, NULL, 229678),
(232932, '2e6xB00', NULL, NULL, 69, NULL, NULL, 229679),
(232933, '2aw4201', NULL, NULL, 29, NULL, NULL, 229680),
(232934, '3s28A02', NULL, NULL, 130, NULL, NULL, 229681),
(232935, '4rbnA02', NULL, NULL, 131, NULL, NULL, 229681),
(232936, '2kk4A00', NULL, NULL, 95, NULL, NULL, 229682),
(232937, '3n40P02', NULL, NULL, 217, NULL, NULL, 229683),
(232938, '3muuC01', NULL, NULL, 173, NULL, NULL, 229683),
(232939, '2ykfA01', NULL, NULL, 137, NULL, NULL, 229684);
INSERT INTO "PUBLIC"."MODEL" VALUES
(232940, '2mprA00', NULL, NULL, 427, NULL, NULL, 229685),
(232941, '1a0sP00', NULL, NULL, 413, NULL, NULL, 229685),
(232942, '1af6A00', NULL, NULL, 421, NULL, NULL, 229685),
(232943, '1u7lA02', NULL, NULL, 183, NULL, NULL, 229686),
(232944, '1cmbA00', NULL, NULL, 104, NULL, NULL, 229687),
(232945, '2v9kA01', NULL, NULL, 50, NULL, NULL, 229688),
(232946, '5tkyA05', NULL, NULL, 99, NULL, NULL, 229689),
(232947, '1ud0C01', NULL, NULL, 80, NULL, NULL, 229689),
(232948, '3lofA00', NULL, NULL, 85, NULL, NULL, 229689),
(232949, '5z8qA01', NULL, NULL, 97, NULL, NULL, 229689),
(232950, '1u00A02', NULL, NULL, 96, NULL, NULL, 229689),
(232951, '4kbqD00', NULL, NULL, 101, NULL, NULL, 229689),
(232952, '1dkxA02', NULL, NULL, 80, NULL, NULL, 229689),
(232953, '3d2eA06', NULL, NULL, 113, NULL, NULL, 229689),
(232954, '1dkyB02', NULL, NULL, 68, NULL, NULL, 229689),
(232955, '4po2A02', NULL, NULL, 104, NULL, NULL, 229689),
(232956, '2qffA00', NULL, NULL, 82, NULL, NULL, 229689),
(232957, '6asyA05', NULL, NULL, 100, NULL, NULL, 229689),
(232958, '3t46A00', NULL, NULL, 75, NULL, NULL, 229689),
(232959, '2p32A00', NULL, NULL, 94, NULL, NULL, 229689),
(232960, '3t47A00', NULL, NULL, 81, NULL, NULL, 229689),
(232961, '3t49A00', NULL, NULL, 73, NULL, NULL, 229689),
(232962, '4f01A02', NULL, NULL, 84, NULL, NULL, 229689),
(232963, '4f01B02', NULL, NULL, 101, NULL, NULL, 229689),
(232964, '1v65A00', NULL, NULL, 64, NULL, NULL, 229690),
(232965, '1hruA00', NULL, NULL, 188, NULL, NULL, 229691),
(232966, '1k4iA00', NULL, NULL, 233, NULL, NULL, 229691),
(232967, '2eqaA01', NULL, NULL, 214, NULL, NULL, 229691),
(232968, '1jcuA00', NULL, NULL, 208, NULL, NULL, 229691),
(232969, '1tksA00', NULL, NULL, 204, NULL, NULL, 229691),
(232970, '4ffjA00', NULL, NULL, 210, NULL, NULL, 229691),
(232971, '3l7vA00', NULL, NULL, 263, NULL, NULL, 229691),
(232972, '1g57A00', NULL, NULL, 217, NULL, NULL, 229691),
(232973, '1snnA00', NULL, NULL, 227, NULL, NULL, 229691),
(232974, '3h07B00', NULL, NULL, 220, NULL, NULL, 229691),
(232975, '4p6dB00', NULL, NULL, 213, NULL, NULL, 229691),
(232976, '1k7jA00', NULL, NULL, 206, NULL, NULL, 229691),
(232977, '3mioA00', NULL, NULL, 206, NULL, NULL, 229691),
(232978, '4aybA06', NULL, NULL, 48, NULL, NULL, 229692),
(232979, '3u5gf00', NULL, NULL, 76, NULL, NULL, 229693),
(232980, '3u5cf00', NULL, NULL, 71, NULL, NULL, 229693),
(232981, '3jamf00', NULL, NULL, 69, NULL, NULL, 229693),
(232982, '4ujfg00', NULL, NULL, 76, NULL, NULL, 229693),
(232983, '5flxf00', NULL, NULL, 78, NULL, NULL, 229693),
(232984, '4cuyf00', NULL, NULL, 64, NULL, NULL, 229693),
(232985, '5a2qf00', NULL, NULL, 72, NULL, NULL, 229693),
(232986, '2pajA03', NULL, NULL, 34, NULL, NULL, 229694),
(232987, '2p1jA02', NULL, NULL, 36, NULL, NULL, 229694),
(232988, '2p1jB02', NULL, NULL, 26, NULL, NULL, 229694),
(232989, '5j3pA00', NULL, NULL, 253, NULL, NULL, 229695),
(232990, '5j8nA00', NULL, NULL, 258, NULL, NULL, 229695),
(232991, '2imqX00', NULL, NULL, 282, NULL, NULL, 229695),
(232992, '2a40B00', NULL, NULL, 260, NULL, NULL, 229695),
(232993, '2j63A00', NULL, NULL, 358, NULL, NULL, 229695),
(232994, '3tebB00', NULL, NULL, 266, NULL, NULL, 229695),
(232995, '5dffB00', NULL, NULL, 276, NULL, NULL, 229695),
(232996, '2o3cA00', NULL, NULL, 282, NULL, NULL, 229695),
(232997, '5ht2A00', NULL, NULL, 256, NULL, NULL, 229695),
(232998, '6ca4B00', NULL, NULL, 250, NULL, NULL, 229695),
(232999, '2ei9A00', NULL, NULL, 219, NULL, NULL, 229695),
(233000, '3g91A00', NULL, NULL, 265, NULL, NULL, 229695),
(233001, '1vybA00', NULL, NULL, 238, NULL, NULL, 229695),
(233002, '2xswB00', NULL, NULL, 357, NULL, NULL, 229695),
(233003, '3wcxA00', NULL, NULL, 298, NULL, NULL, 229695),
(233004, '2ddrA00', NULL, NULL, 306, NULL, NULL, 229695),
(233005, '4ruwA01', NULL, NULL, 286, NULL, NULL, 229695),
(233006, '4cmlA00', NULL, NULL, 313, NULL, NULL, 229695),
(233007, '4cmnA00', NULL, NULL, 354, NULL, NULL, 229695),
(233008, '3mprB00', NULL, NULL, 298, NULL, NULL, 229695),
(233009, '2jc4A00', NULL, NULL, 256, NULL, NULL, 229695),
(233010, '3g6sA00', NULL, NULL, 267, NULL, NULL, 229695);
INSERT INTO "PUBLIC"."MODEL" VALUES
(233011, '1akoA00', NULL, NULL, 268, NULL, NULL, 229695),
(233012, '3ngqA00', NULL, NULL, 398, NULL, NULL, 229695),
(233013, '3l1wA00', NULL, NULL, 257, NULL, NULL, 229695),
(233014, '3i41A00', NULL, NULL, 290, NULL, NULL, 229695),
(233015, '1i9zA00', NULL, NULL, 347, NULL, NULL, 229695),
(233016, '4a9cA00', NULL, NULL, 316, NULL, NULL, 229695),
(233017, '2jc5A00', NULL, NULL, 259, NULL, NULL, 229695),
(233018, '5cfeA00', NULL, NULL, 252, NULL, NULL, 229695),
(233019, '5ewtA00', NULL, NULL, 247, NULL, NULL, 229695),
(233020, '1wduB00', NULL, NULL, 227, NULL, NULL, 229695),
(233021, '1zwxA00', NULL, NULL, 301, NULL, NULL, 229695),
(233022, '1sr4B00', NULL, NULL, 261, NULL, NULL, 229695),
(233023, '4jg3A00', NULL, NULL, 262, NULL, NULL, 229695),
(233024, '4awnA00', NULL, NULL, 260, NULL, NULL, 229695),
(233025, '2voaA00', NULL, NULL, 257, NULL, NULL, 229695),
(233026, '4fvaC00', NULL, NULL, 256, NULL, NULL, 229695),
(233027, '4fpvB00', NULL, NULL, 257, NULL, NULL, 229695),
(233028, '2f1nA00', NULL, NULL, 262, NULL, NULL, 229695),
(233029, '4k6lF00', NULL, NULL, 255, NULL, NULL, 229695),
(233030, '3qc5X03', NULL, NULL, 83, NULL, NULL, 229696),
(233031, '5kiqA02', NULL, NULL, 72, NULL, NULL, 229696),
(233032, '2f76X00', NULL, NULL, 100, NULL, NULL, 229697),
(233033, '1zelA01', NULL, NULL, 99, NULL, NULL, 229698),
(233034, '4hsiA02', NULL, NULL, 99, NULL, NULL, 229699),
(233035, '6escA02', NULL, NULL, 98, NULL, NULL, 229699),
(233036, '2gumA02', NULL, NULL, 101, NULL, NULL, 229699),
(233037, '3fvcA02', NULL, NULL, 100, NULL, NULL, 229699),
(233038, '4lg3A01', NULL, NULL, 138, NULL, NULL, 229700),
(233039, '5v37A04', NULL, NULL, 80, NULL, NULL, 229701),
(233040, '3ispB02', NULL, NULL, 228, NULL, NULL, 229702),
(233041, '3szpB02', NULL, NULL, 202, NULL, NULL, 229702),
(233042, '5y9qA00', NULL, NULL, 198, NULL, NULL, 229702),
(233043, '4qbaA00', NULL, NULL, 204, NULL, NULL, 229702),
(233044, '4jvcA00', NULL, NULL, 216, NULL, NULL, 229702),
(233045, '5fhkA00', NULL, NULL, 207, NULL, NULL, 229702),
(233046, '2hxrA00', NULL, NULL, 208, NULL, NULL, 229702),
(233047, '3qh6A00', NULL, NULL, 157, NULL, NULL, 229703),
(233048, '3vkwA01', NULL, NULL, 156, NULL, NULL, 229704),
(233049, '4df9C01', NULL, NULL, 140, NULL, NULL, 229705),
(233050, '3p1vA01', NULL, NULL, 139, NULL, NULL, 229705),
(233051, '6gm5A02', NULL, NULL, 222, NULL, NULL, 229706),
(233052, '1hfeL03', NULL, NULL, 143, NULL, NULL, 229706),
(233053, '4h3wA02', NULL, NULL, 149, NULL, NULL, 229707),
(233054, '4h3wB02', NULL, NULL, 149, NULL, NULL, 229707),
(233055, '3g3oA00', NULL, NULL, 308, NULL, NULL, 229708),
(233056, '3g3tA00', NULL, NULL, 295, NULL, NULL, 229708),
(233057, '2yi9A05', NULL, NULL, 77, NULL, NULL, 229709),
(233058, '1r94A00', NULL, NULL, 97, NULL, NULL, 229710),
(233059, '2k4zA01', NULL, NULL, 113, NULL, NULL, 229710),
(233060, '2qgoA00', NULL, NULL, 141, NULL, NULL, 229710),
(233061, '2p2eA00', NULL, NULL, 128, NULL, NULL, 229710),
(233062, '1x0gA00', NULL, NULL, 112, NULL, NULL, 229710),
(233063, '1nwbA00', NULL, NULL, 101, NULL, NULL, 229710),
(233064, '2d2aB01', NULL, NULL, 106, NULL, NULL, 229710),
(233065, '2apnA01', NULL, NULL, 96, NULL, NULL, 229710),
(233066, '2lopA00', NULL, NULL, 108, NULL, NULL, 229711),
(233067, '2losA00', NULL, NULL, 121, NULL, NULL, 229711),
(233068, '2looA02', NULL, NULL, 75, NULL, NULL, 229711),
(233069, '1ye9A03', NULL, NULL, 57, NULL, NULL, 229712),
(233070, '2zt5A02', NULL, NULL, 84, NULL, NULL, 229713),
(233071, '5enqB05', NULL, NULL, 101, NULL, NULL, 229714),
(233072, '3w9iA07', NULL, NULL, 100, NULL, NULL, 229714),
(233073, '4dx5A07', NULL, NULL, 94, NULL, NULL, 229714),
(233074, '4mt1A07', NULL, NULL, 104, NULL, NULL, 229714),
(233075, '5jmnB07', NULL, NULL, 99, NULL, NULL, 229714),
(233076, '3hjlA03', NULL, NULL, 41, NULL, NULL, 229715),
(233077, '3uswA02', NULL, NULL, 42, NULL, NULL, 229715),
(233078, '2k49A00', NULL, NULL, 118, NULL, NULL, 229716),
(233079, '2k8eA00', NULL, NULL, 130, NULL, NULL, 229716),
(233080, '2f23A01', NULL, NULL, 77, NULL, NULL, 229717),
(233081, '1grjA01', NULL, NULL, 75, NULL, NULL, 229717);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(233082, '2p4vA01', NULL, NULL, 76, NULL, NULL, 229717),
(233083, '1koyA00', NULL, NULL, 62, NULL, NULL, 229718),
(233084, '1iyrA00', NULL, NULL, 87, NULL, NULL, 229718),
(233085, '1jidA00', NULL, NULL, 128, NULL, NULL, 229719),
(233086, '1kvnA00', NULL, NULL, 104, NULL, NULL, 229719),
(233087, '1lngA00', NULL, NULL, 87, NULL, NULL, 229719),
(233088, '3ktwB00', NULL, NULL, 109, NULL, NULL, 229719),
(233089, '3dluA00', NULL, NULL, 106, NULL, NULL, 229719),
(233090, '5kxhA01', NULL, NULL, 190, NULL, NULL, 229720),
(233091, '5ux6B01', NULL, NULL, 191, NULL, NULL, 229720),
(233092, '2hhcA01', NULL, NULL, 150, NULL, NULL, 229720),
(233093, '4ap5A01', NULL, NULL, 200, NULL, NULL, 229720),
(233094, '3zy2A01', NULL, NULL, 193, NULL, NULL, 229720),
(233095, '1u96A01', NULL, NULL, 34, NULL, NULL, 229721),
(233096, '1u97A00', NULL, NULL, 69, NULL, NULL, 229721),
(233097, '1hp8A00', NULL, NULL, 68, NULL, NULL, 229721),
(233098, '2lgqA00', NULL, NULL, 67, NULL, NULL, 229721),
(233099, '3hi2B00', NULL, NULL, 101, NULL, NULL, 229722),
(233100, '3d8cA02', NULL, NULL, 44, NULL, NULL, 229723),
(233101, '1iz3A02', NULL, NULL, 44, NULL, NULL, 229723),
(233102, '2krhA00', NULL, NULL, 85, NULL, NULL, 229724),
(233103, '2l2oA00', NULL, NULL, 89, NULL, NULL, 229724),
(233104, '2w5qA01', NULL, NULL, 93, NULL, NULL, 229725),
(233105, '2w8dB01', NULL, NULL, 94, NULL, NULL, 229725),
(233106, '4uopA01', NULL, NULL, 93, NULL, NULL, 229725),
(233107, '4uorC01', NULL, NULL, 91, NULL, NULL, 229725),
(233108, '2arcA00', NULL, NULL, 164, NULL, NULL, 229726),
(233109, '3rwxA01', NULL, NULL, 127, NULL, NULL, 229727),
(233110, '3fgxA00', NULL, NULL, 114, NULL, NULL, 229728),
(233111, '3e0rB02', NULL, NULL, 121, NULL, NULL, 229729),
(233112, '2b6cA01', NULL, NULL, 121, NULL, NULL, 229730),
(233113, '3fd9A01', NULL, NULL, 72, NULL, NULL, 229731),
(233114, '2kz4A00', NULL, NULL, 112, NULL, NULL, 229732),
(233115, '2kcaA00', NULL, NULL, 109, NULL, NULL, 229732),
(233116, '3g8qB03', NULL, NULL, 85, NULL, NULL, 229733),
(233117, '1vbkA02', NULL, NULL, 82, NULL, NULL, 229733),
(233118, '2dirA01', NULL, NULL, 87, NULL, NULL, 229733),
(233119, '1ig0A01', NULL, NULL, 187, NULL, NULL, 229734),
(233120, '3l8mA00', NULL, NULL, 212, NULL, NULL, 229734),
(233121, '3s4yA00', NULL, NULL, 228, NULL, NULL, 229734),
(233122, '3lm8D00', NULL, NULL, 222, NULL, NULL, 229734),
(233123, '2omkB00', NULL, NULL, 209, NULL, NULL, 229734),
(233124, '3cq9A00', NULL, NULL, 227, NULL, NULL, 229734),
(233125, '2g9zA02', NULL, NULL, 182, NULL, NULL, 229734),
(233126, '3ihkA00', NULL, NULL, 218, NULL, NULL, 229734),
(233127, '3k94A00', NULL, NULL, 223, NULL, NULL, 229734),
(233128, '1ig3A02', NULL, NULL, 147, NULL, NULL, 229734),
(233129, '3melA00', NULL, NULL, 222, NULL, NULL, 229734),
(233130, '3m7gA02', NULL, NULL, 95, NULL, NULL, 229735),
(233131, '2w0tA00', NULL, NULL, 43, NULL, NULL, 229736),
(233132, '2l8eA00', NULL, NULL, 49, NULL, NULL, 229736),
(233133, '3aj1E01', NULL, NULL, 55, NULL, NULL, 229737),
(233134, '3aj1H01', NULL, NULL, 55, NULL, NULL, 229737),
(233135, '2z9eB01', NULL, NULL, 55, NULL, NULL, 229737),
(233136, '2z9eC01', NULL, NULL, 55, NULL, NULL, 229737),
(233137, '2z9eD01', NULL, NULL, 55, NULL, NULL, 229737),
(233138, '2z9eE01', NULL, NULL, 55, NULL, NULL, 229737),
(233139, '2z9eH01', NULL, NULL, 55, NULL, NULL, 229737),
(233140, '3aj1A01', NULL, NULL, 39, NULL, NULL, 229737),
(233141, '3aj1B01', NULL, NULL, 55, NULL, NULL, 229737),
(233142, '1h5wB02', NULL, NULL, 130, NULL, NULL, 229738),
(233143, '3p9aF00', NULL, NULL, 139, NULL, NULL, 229739),
(233144, '3qpiA00', NULL, NULL, 189, NULL, NULL, 229740),
(233145, '5k91B00', NULL, NULL, 188, NULL, NULL, 229740),
(233146, '4bpxD00', NULL, NULL, 269, NULL, NULL, 229741),
(233147, '4rr2B00', NULL, NULL, 224, NULL, NULL, 229741),
(233148, '2gvsA00', NULL, NULL, 109, NULL, NULL, 229742),
(233149, '1n8vB00', NULL, NULL, 112, NULL, NULL, 229742),
(233150, '2jntA00', NULL, NULL, 108, NULL, NULL, 229742),
(233151, '3etvA02', NULL, NULL, 238, NULL, NULL, 229743),
(233152, '3a2eA00', NULL, NULL, 108, NULL, NULL, 229744);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(233153, '3cr8C02', NULL, NULL, 218, NULL, NULL, 229745),
(233154, '3tzeB01', NULL, NULL, 243, NULL, NULL, 229745),
(233155, '2ielA00', NULL, NULL, 138, NULL, NULL, 229745),
(233156, '1kamA00', NULL, NULL, 194, NULL, NULL, 229745),
(233157, '5zm0A01', NULL, NULL, 133, NULL, NULL, 229745),
(233158, '2wsiA00', NULL, NULL, 306, NULL, NULL, 229745),
(233159, '5ts2A00', NULL, NULL, 167, NULL, NULL, 229745),
(233160, '3op1A01', NULL, NULL, 189, NULL, NULL, 229745),
(233161, '3ag6A01', NULL, NULL, 176, NULL, NULL, 229745),
(233162, '1vlhB00', NULL, NULL, 173, NULL, NULL, 229745),
(233163, '3nv7A00', NULL, NULL, 157, NULL, NULL, 229745),
(233164, '4mlpA01', NULL, NULL, 127, NULL, NULL, 229745),
(233165, '4h3sA01', NULL, NULL, 356, NULL, NULL, 229745),
(233166, '3n9iA01', NULL, NULL, 233, NULL, NULL, 229745),
(233167, '4g6zA01', NULL, NULL, 318, NULL, NULL, 229745),
(233168, '3hzrA01', NULL, NULL, 275, NULL, NULL, 229745),
(233169, '1jhdA01', NULL, NULL, 203, NULL, NULL, 229745),
(233170, '4bwvA00', NULL, NULL, 227, NULL, NULL, 229745),
(233171, '1korB01', NULL, NULL, 171, NULL, NULL, 229745),
(233172, '1h3fA01', NULL, NULL, 216, NULL, NULL, 229745),
(233173, '3ca8A02', NULL, NULL, 155, NULL, NULL, 229745),
(233174, '3prhB01', NULL, NULL, 215, NULL, NULL, 229745),
(233175, '3innA01', NULL, NULL, 176, NULL, NULL, 229745),
(233176, '1k4kB00', NULL, NULL, 213, NULL, NULL, 229745),
(233177, '2o5rA01', NULL, NULL, 133, NULL, NULL, 229745),
(233178, '3l92A00', NULL, NULL, 162, NULL, NULL, 229745),
(233179, '2zueA02', NULL, NULL, 394, NULL, NULL, 229745),
(233180, '1yumA00', NULL, NULL, 221, NULL, NULL, 229745),
(233181, '4natB00', NULL, NULL, 160, NULL, NULL, 229745),
(233182, '3k32B00', NULL, NULL, 203, NULL, NULL, 229745),
(233183, '4l2iB00', NULL, NULL, 263, NULL, NULL, 229745),
(233184, '1y42X01', NULL, NULL, 285, NULL, NULL, 229745),
(233185, '2cybA01', NULL, NULL, 207, NULL, NULL, 229745),
(233186, '3jxeA01', NULL, NULL, 260, NULL, NULL, 229745),
(233187, '3hv0A01', NULL, NULL, 240, NULL, NULL, 229745),
(233188, '1nzjA02', NULL, NULL, 138, NULL, NULL, 229745),
(233189, '3p52A00', NULL, NULL, 249, NULL, NULL, 229745),
(233190, '3fy4A01', NULL, NULL, 140, NULL, NULL, 229745),
(233191, '1i6mA01', NULL, NULL, 217, NULL, NULL, 229745),
(233192, '6hcdD00', NULL, NULL, 155, NULL, NULL, 229745),
(233193, '3h05B00', NULL, NULL, 177, NULL, NULL, 229745),
(233194, '3zxsA01', NULL, NULL, 174, NULL, NULL, 229745),
(233195, '3s3tA00', NULL, NULL, 146, NULL, NULL, 229745),
(233196, '3aiiA01', NULL, NULL, 314, NULL, NULL, 229745),
(233197, '1n3lA01', NULL, NULL, 209, NULL, NULL, 229745),
(233198, '3ilvA02', NULL, NULL, 354, NULL, NULL, 229745),
(233199, '1np7B01', NULL, NULL, 137, NULL, NULL, 229745),
(233200, '2d5bA01', NULL, NULL, 225, NULL, NULL, 229745),
(233201, '2cycA01', NULL, NULL, 226, NULL, NULL, 229745),
(233202, '3sp1A01', NULL, NULL, 318, NULL, NULL, 229745),
(233203, '4qreA01', NULL, NULL, 226, NULL, NULL, 229745),
(233204, '1gpmA02', NULL, NULL, 194, NULL, NULL, 229745),
(233205, '1tq8A00', NULL, NULL, 163, NULL, NULL, 229745),
(233206, '3uowA02', NULL, NULL, 206, NULL, NULL, 229745),
(233207, '5wp0A00', NULL, NULL, 279, NULL, NULL, 229745),
(233208, '5usfB02', NULL, NULL, 251, NULL, NULL, 229745),
(233209, '5usfB01', NULL, NULL, 315, NULL, NULL, 229745),
(233210, '5kwvB01', NULL, NULL, 173, NULL, NULL, 229745),
(233211, '3vgjA01', NULL, NULL, 219, NULL, NULL, 229745),
(233212, '4ymiB00', NULL, NULL, 208, NULL, NULL, 229745),
(233213, '2hz7A01', NULL, NULL, 123, NULL, NULL, 229745),
(233214, '1cozA00', NULL, NULL, 129, NULL, NULL, 229745),
(233215, '3n05A02', NULL, NULL, 189, NULL, NULL, 229745),
(233216, '4l2iA01', NULL, NULL, 207, NULL, NULL, 229745),
(233217, '2nz2A01', NULL, NULL, 180, NULL, NULL, 229745),
(233218, '3u1vA01', NULL, NULL, 227, NULL, NULL, 229745),
(233219, '1dnpA01', NULL, NULL, 130, NULL, NULL, 229745),
(233220, '1kqpA00', NULL, NULL, 271, NULL, NULL, 229745),
(233221, '5t5xA01', NULL, NULL, 129, NULL, NULL, 229745),
(233222, '1v8fA01', NULL, NULL, 172, NULL, NULL, 229745),
(233223, '4f4hA02', NULL, NULL, 285, NULL, NULL, 229745);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(233224, '4f3rB00', NULL, NULL, 162, NULL, NULL, 229745),
(233225, '2dumC00', NULL, NULL, 170, NULL, NULL, 229745),
(233226, '4p2bA01', NULL, NULL, 122, NULL, NULL, 229745),
(233227, '2vxoA02', NULL, NULL, 231, NULL, NULL, 229745),
(233228, '1pg2A01', NULL, NULL, 349, NULL, NULL, 229745),
(233229, '4kr6A02', NULL, NULL, 217, NULL, NULL, 229745),
(233230, '2cyaA01', NULL, NULL, 214, NULL, NULL, 229745),
(233231, '6c8qE00', NULL, NULL, 275, NULL, NULL, 229745),
(233232, '5ihxB01', NULL, NULL, 283, NULL, NULL, 229745),
(233233, '5jbnA00', NULL, NULL, 170, NULL, NULL, 229745),
(233234, '5l7pB01', NULL, NULL, 208, NULL, NULL, 229745),
(233235, '3mueB01', NULL, NULL, 182, NULL, NULL, 229745),
(233236, '4mafH02', NULL, NULL, 236, NULL, NULL, 229745),
(233237, '2qjoA01', NULL, NULL, 196, NULL, NULL, 229745),
(233238, '2dplA01', NULL, NULL, 185, NULL, NULL, 229745),
(233239, '2wq7A01', NULL, NULL, 137, NULL, NULL, 229745),
(233240, '2j5bB01', NULL, NULL, 223, NULL, NULL, 229745),
(233241, '6mtkA01', NULL, NULL, 225, NULL, NULL, 229745),
(233242, '2e0iA01', NULL, NULL, 126, NULL, NULL, 229745),
(233243, '1xngA01', NULL, NULL, 249, NULL, NULL, 229745),
(233244, '2ts1A01', NULL, NULL, 222, NULL, NULL, 229745),
(233245, '1gaxA01', NULL, NULL, 338, NULL, NULL, 229745),
(233246, '4zcrA00', NULL, NULL, 142, NULL, NULL, 229745),
(233247, '1x6vB03', NULL, NULL, 240, NULL, NULL, 229745),
(233248, '1o97C00', NULL, NULL, 264, NULL, NULL, 229745),
(233249, '1vl2A01', NULL, NULL, 189, NULL, NULL, 229745),
(233250, '2ejcA01', NULL, NULL, 176, NULL, NULL, 229745),
(233251, '4q16C00', NULL, NULL, 287, NULL, NULL, 229745),
(233252, '1q77A00', NULL, NULL, 138, NULL, NULL, 229745),
(233253, '2g36A01', NULL, NULL, 233, NULL, NULL, 229745),
(233254, '3tnjA01', NULL, NULL, 141, NULL, NULL, 229745),
(233255, '2qjtB01', NULL, NULL, 201, NULL, NULL, 229745),
(233256, '3focA01', NULL, NULL, 316, NULL, NULL, 229745),
(233257, '3bl5E00', NULL, NULL, 219, NULL, NULL, 229745),
(233258, '3i05A01', NULL, NULL, 257, NULL, NULL, 229745),
(233259, '3tqiA02', NULL, NULL, 193, NULL, NULL, 229745),
(233260, '2gksB02', NULL, NULL, 221, NULL, NULL, 229745),
(233261, '4ybrA00', NULL, NULL, 201, NULL, NULL, 229745),
(233262, '3hgmA00', NULL, NULL, 147, NULL, NULL, 229745),
(233263, '1vbkA03', NULL, NULL, 133, NULL, NULL, 229745),
(233264, '1efpB00', NULL, NULL, 252, NULL, NULL, 229745),
(233265, '4a91A01', NULL, NULL, 160, NULL, NULL, 229745),
(233266, '2z3vA00', NULL, NULL, 137, NULL, NULL, 229745),
(233267, '1m1zA02', NULL, NULL, 292, NULL, NULL, 229745),
(233268, '1lw7A01', NULL, NULL, 169, NULL, NULL, 229745),
(233269, '1zunA01', NULL, NULL, 206, NULL, NULL, 229745),
(233270, '1wy5A01', NULL, NULL, 217, NULL, NULL, 229745),
(233271, '4dnxA02', NULL, NULL, 204, NULL, NULL, 229745),
(233272, '3c8zA01', NULL, NULL, 331, NULL, NULL, 229745),
(233273, '2h29A00', NULL, NULL, 189, NULL, NULL, 229745),
(233274, '2ip1A01', NULL, NULL, 255, NULL, NULL, 229745),
(233275, '3vrhA00', NULL, NULL, 310, NULL, NULL, 229745),
(233276, '1kkuA00', NULL, NULL, 220, NULL, NULL, 229745),
(233277, '1ni5A01', NULL, NULL, 227, NULL, NULL, 229745),
(233278, '1mjhB00', NULL, NULL, 162, NULL, NULL, 229745),
(233279, '3gmiA02', NULL, NULL, 219, NULL, NULL, 229745),
(233280, '3afhA01', NULL, NULL, 121, NULL, NULL, 229745),
(233281, '6e5yA01', NULL, NULL, 164, NULL, NULL, 229745),
(233282, '4mw2A01', NULL, NULL, 241, NULL, NULL, 229745),
(233283, '2d13A01', NULL, NULL, 126, NULL, NULL, 229745),
(233284, '4pbrA01', NULL, NULL, 196, NULL, NULL, 229745),
(233285, '3covA01', NULL, NULL, 186, NULL, NULL, 229745),
(233286, '5ghaC00', NULL, NULL, 321, NULL, NULL, 229745),
(233287, '6ncrB01', NULL, NULL, 246, NULL, NULL, 229745),
(233288, '1j09A01', NULL, NULL, 121, NULL, NULL, 229745),
(233289, '1irxA01', NULL, NULL, 226, NULL, NULL, 229745),
(233290, '3tqoA01', NULL, NULL, 289, NULL, NULL, 229745),
(233291, '1efpA02', NULL, NULL, 181, NULL, NULL, 229745),
(233292, '3ziuA02', NULL, NULL, 386, NULL, NULL, 229745),
(233293, '2yxnA01', NULL, NULL, 227, NULL, NULL, 229745),
(233294, '4arcA02', NULL, NULL, 350, NULL, NULL, 229745);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(233295, '2ywbA02', NULL, NULL, 190, NULL, NULL, 229745),
(233296, '4wsoA00', NULL, NULL, 227, NULL, NULL, 229745),
(233297, '5lltA00', NULL, NULL, 213, NULL, NULL, 229745),
(233298, '1efvB00', NULL, NULL, 255, NULL, NULL, 229745),
(233299, '5bnzA01', NULL, NULL, 123, NULL, NULL, 229745),
(233300, '3sz3A01', NULL, NULL, 227, NULL, NULL, 229745),
(233301, '3fnrA02', NULL, NULL, 307, NULL, NULL, 229745),
(233302, '1wxiA00', NULL, NULL, 275, NULL, NULL, 229745),
(233303, '1r6uA01', NULL, NULL, 258, NULL, NULL, 229745),
(233304, '2hgzA01', NULL, NULL, 195, NULL, NULL, 229745),
(233305, '3elbA01', NULL, NULL, 139, NULL, NULL, 229745),
(233306, '5ekdA01', NULL, NULL, 216, NULL, NULL, 229745),
(233307, '3elbA02', NULL, NULL, 170, NULL, NULL, 229745),
(233308, '3cvvA01', NULL, NULL, 205, NULL, NULL, 229745),
(233309, '5h7xE00', NULL, NULL, 171, NULL, NULL, 229745),
(233310, '5khaB02', NULL, NULL, 281, NULL, NULL, 229745),
(233311, '5v0iA01', NULL, NULL, 224, NULL, NULL, 229745),
(233312, '1ct9B02', NULL, NULL, 321, NULL, NULL, 229745),
(233313, '3tzlA01', NULL, NULL, 218, NULL, NULL, 229745),
(233314, '5urbA01', NULL, NULL, 351, NULL, NULL, 229745),
(233315, '2b7lA00', NULL, NULL, 115, NULL, NULL, 229745),
(233316, '5h4vA01', NULL, NULL, 121, NULL, NULL, 229745),
(233317, '6b1zA01', NULL, NULL, 131, NULL, NULL, 229745),
(233318, '2j4dA01', NULL, NULL, 174, NULL, NULL, 229745),
(233319, '5ol2B00', NULL, NULL, 260, NULL, NULL, 229745),
(233320, '5ijxA01', NULL, NULL, 285, NULL, NULL, 229745),
(233321, '2pidA01', NULL, NULL, 246, NULL, NULL, 229745),
(233322, '4j76B01', NULL, NULL, 247, NULL, NULL, 229745),
(233323, '5tgtB01', NULL, NULL, 337, NULL, NULL, 229745),
(233324, '2yy5A01', NULL, NULL, 229, NULL, NULL, 229745),
(233325, '3fiuA00', NULL, NULL, 249, NULL, NULL, 229745),
(233326, '3a2kA01', NULL, NULL, 135, NULL, NULL, 229745),
(233327, '1mrzA01', NULL, NULL, 159, NULL, NULL, 229745),
(233328, '1obhA01', NULL, NULL, 322, NULL, NULL, 229745),
(233329, '3fwkA00', NULL, NULL, 308, NULL, NULL, 229745),
(233330, '5tevA01', NULL, NULL, 241, NULL, NULL, 229745),
(233331, '2gm3A00', NULL, NULL, 175, NULL, NULL, 229745),
(233332, '4yp6A00', NULL, NULL, 181, NULL, NULL, 229745),
(233333, '6bqyA00', NULL, NULL, 225, NULL, NULL, 229745),
(233334, '1o6bA00', NULL, NULL, 169, NULL, NULL, 229745),
(233335, '1u3dA01', NULL, NULL, 173, NULL, NULL, 229745),
(233336, '2el7B01', NULL, NULL, 230, NULL, NULL, 229745),
(233337, '3q12B01', NULL, NULL, 182, NULL, NULL, 229745),
(233338, '1nupB00', NULL, NULL, 234, NULL, NULL, 229745),
(233339, '1yi8B01', NULL, NULL, 216, NULL, NULL, 229745),
(233340, '1tezA01', NULL, NULL, 128, NULL, NULL, 229745),
(233341, '4xfjB01', NULL, NULL, 182, NULL, NULL, 229745),
(233342, '3hl4B00', NULL, NULL, 177, NULL, NULL, 229745),
(233343, '6b1pA01', NULL, NULL, 131, NULL, NULL, 229745),
(233344, '4griA01', NULL, NULL, 121, NULL, NULL, 229745),
(233345, '2pzbC00', NULL, NULL, 284, NULL, NULL, 229745),
(233346, '1ihoA01', NULL, NULL, 179, NULL, NULL, 229745),
(233347, '2a1uA01', NULL, NULL, 186, NULL, NULL, 229745),
(233348, '5n5uA01', NULL, NULL, 196, NULL, NULL, 229745),
(233349, '4wnyA00', NULL, NULL, 151, NULL, NULL, 229745),
(233350, '1rqgA01', NULL, NULL, 182, NULL, NULL, 229745),
(233351, '1r6uB01', NULL, NULL, 249, NULL, NULL, 229745),
(233352, '3fg9C01', NULL, NULL, 140, NULL, NULL, 229745),
(233353, '6fahB00', NULL, NULL, 262, NULL, NULL, 229745),
(233354, '6dfuB01', NULL, NULL, 224, NULL, NULL, 229745),
(233355, '2cfoA01', NULL, NULL, 121, NULL, NULL, 229745),
(233356, '1o97D01', NULL, NULL, 189, NULL, NULL, 229745),
(233357, '5z9rA00', NULL, NULL, 242, NULL, NULL, 229745),
(233358, '1qtqA05', NULL, NULL, 123, NULL, NULL, 229745),
(233359, '4r2lA00', NULL, NULL, 158, NULL, NULL, 229745),
(233360, '3nd5A00', NULL, NULL, 171, NULL, NULL, 229745),
(233361, '1kqnB00', NULL, NULL, 240, NULL, NULL, 229745),
(233362, '4u63A01', NULL, NULL, 189, NULL, NULL, 229745),
(233363, '3do8A00', NULL, NULL, 148, NULL, NULL, 229745),
(233364, '5f23A00', NULL, NULL, 283, NULL, NULL, 229745),
(233365, '1v47B02', NULL, NULL, 213, NULL, NULL, 229745);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(233366, '4gu5B01', NULL, NULL, 138, NULL, NULL, 229745),
(233367, '1j20A01', NULL, NULL, 136, NULL, NULL, 229745),
(233368, '3mxtA01', NULL, NULL, 175, NULL, NULL, 229745),
(233369, '3k9wA00', NULL, NULL, 168, NULL, NULL, 229745),
(233370, '3nbkD00', NULL, NULL, 177, NULL, NULL, 229745),
(233371, '2goyA00', NULL, NULL, 222, NULL, NULL, 229745),
(233372, '5o08A00', NULL, NULL, 162, NULL, NULL, 229745),
(233373, '3fetA00', NULL, NULL, 166, NULL, NULL, 229745),
(233374, '3a04A01', NULL, NULL, 256, NULL, NULL, 229745),
(233375, '3loqA02', NULL, NULL, 129, NULL, NULL, 229745),
(233376, '2c5sA02', NULL, NULL, 229, NULL, NULL, 229745),
(233377, '2jaxA02', NULL, NULL, 157, NULL, NULL, 229745),
(233378, '2jaxA01', NULL, NULL, 148, NULL, NULL, 229745),
(233379, '1wkbA01', NULL, NULL, 446, NULL, NULL, 229745),
(233380, '3uk2A01', NULL, NULL, 173, NULL, NULL, 229745),
(233381, '5xgqA01', NULL, NULL, 233, NULL, NULL, 229745),
(233382, '2janB01', NULL, NULL, 223, NULL, NULL, 229745),
(233383, '5hujA00', NULL, NULL, 274, NULL, NULL, 229745),
(233384, '3loqA01', NULL, NULL, 149, NULL, NULL, 229745),
(233385, '3fdxA00', NULL, NULL, 143, NULL, NULL, 229745),
(233386, '2x1lA01', NULL, NULL, 235, NULL, NULL, 229745),
(233387, '2hmaA01', NULL, NULL, 216, NULL, NULL, 229745),
(233388, '2derB01', NULL, NULL, 224, NULL, NULL, 229745),
(233389, '3kflA01', NULL, NULL, 234, NULL, NULL, 229745),
(233390, '1jilA01', NULL, NULL, 221, NULL, NULL, 229745),
(233391, '4py2B01', NULL, NULL, 224, NULL, NULL, 229745),
(233392, '4mvcB00', NULL, NULL, 224, NULL, NULL, 229745),
(233393, '2xryA01', NULL, NULL, 161, NULL, NULL, 229745),
(233394, '2x0kA01', NULL, NULL, 186, NULL, NULL, 229745),
(233395, '1f7uA01', NULL, NULL, 347, NULL, NULL, 229745),
(233396, '2j07A01', NULL, NULL, 121, NULL, NULL, 229745),
(233397, '1m8pA01', NULL, NULL, 200, NULL, NULL, 229745),
(233398, '2ja2A01', NULL, NULL, 131, NULL, NULL, 229745),
(233399, '3p0iB02', NULL, NULL, 229, NULL, NULL, 229745),
(233400, '1od6A00', NULL, NULL, 160, NULL, NULL, 229745),
(233401, '2qtrA00', NULL, NULL, 189, NULL, NULL, 229745),
(233402, '1r6xA02', NULL, NULL, 222, NULL, NULL, 229745),
(233403, '1k92A01', NULL, NULL, 160, NULL, NULL, 229745),
(233404, '2pg3A00', NULL, NULL, 232, NULL, NULL, 229745),
(233405, '1ileA01', NULL, NULL, 435, NULL, NULL, 229745),
(233406, '3n8hA01', NULL, NULL, 176, NULL, NULL, 229745),
(233407, '4djaA01', NULL, NULL, 164, NULL, NULL, 229745),
(233408, '3idfA00', NULL, NULL, 138, NULL, NULL, 229745),
(233409, '1surA00', NULL, NULL, 215, NULL, NULL, 229745),
(233410, '1jmvA00', NULL, NULL, 141, NULL, NULL, 229745),
(233411, '2oq2D00', NULL, NULL, 261, NULL, NULL, 229745),
(233412, '3p0hB02', NULL, NULL, 329, NULL, NULL, 229745),
(233413, '3p0hB01', NULL, NULL, 311, NULL, NULL, 229745),
(233414, '2csxA01', NULL, NULL, 223, NULL, NULL, 229745),
(233415, '1li5B01', NULL, NULL, 289, NULL, NULL, 229745),
(233416, '3hmqA00', NULL, NULL, 275, NULL, NULL, 229745),
(233417, '3ih5A00', NULL, NULL, 217, NULL, NULL, 229745),
(233418, '3dpiB00', NULL, NULL, 267, NULL, NULL, 229745),
(233419, '1iq0A01', NULL, NULL, 376, NULL, NULL, 229745),
(233420, '5ahwC00', NULL, NULL, 147, NULL, NULL, 229745),
(233421, '1qu3A01', NULL, NULL, 368, NULL, NULL, 229745),
(233422, '3glvA00', NULL, NULL, 122, NULL, NULL, 229745),
(233423, '1f9aA00', NULL, NULL, 168, NULL, NULL, 229745),
(233424, '3sdbA02', NULL, NULL, 221, NULL, NULL, 229745),
(233425, '2dlcX01', NULL, NULL, 217, NULL, NULL, 229745),
(233426, '3umvA01', NULL, NULL, 150, NULL, NULL, 229745),
(233427, '3q4gB00', NULL, NULL, 279, NULL, NULL, 229745),
(233428, '1q15D02', NULL, NULL, 297, NULL, NULL, 229745),
(233429, '4nzpA01', NULL, NULL, 152, NULL, NULL, 229745),
(233430, '2e18A00', NULL, NULL, 257, NULL, NULL, 229745),
(233431, '1i6kA01', NULL, NULL, 217, NULL, NULL, 229745),
(233432, '3h99A01', NULL, NULL, 350, NULL, NULL, 229745),
(233433, '3rk1B01', NULL, NULL, 141, NULL, NULL, 229745),
(233434, '4dduA04', NULL, NULL, 74, NULL, NULL, 229746),
(233435, '1vccA00', NULL, NULL, 77, NULL, NULL, 229747),
(233436, '2f4qA01', NULL, NULL, 90, NULL, NULL, 229747);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(233437, '3qhyB00', NULL, NULL, 282, NULL, NULL, 229748),
(233438, '4o2wA00', NULL, NULL, 365, NULL, NULL, 229748),
(233439, '4jhnA00', NULL, NULL, 369, NULL, NULL, 229748),
(233440, '3mvdK00', NULL, NULL, 395, NULL, NULL, 229748),
(233441, '4l1mA00', NULL, NULL, 369, NULL, NULL, 229748),
(233442, '3kciA00', NULL, NULL, 369, NULL, NULL, 229748),
(233443, '3of7A00', NULL, NULL, 473, NULL, NULL, 229748),
(233444, '4nbmA00', NULL, NULL, 377, NULL, NULL, 229748),
(233445, '1i2mB00', NULL, NULL, 402, NULL, NULL, 229748),
(233446, '2hzmH00', NULL, NULL, 253, NULL, NULL, 229749),
(233447, '3typB00', NULL, NULL, 155, NULL, NULL, 229749),
(233448, '2acaA00', NULL, NULL, 189, NULL, NULL, 229749),
(233449, '3tj7C00', NULL, NULL, 179, NULL, NULL, 229749),
(233450, '3c0tA00', NULL, NULL, 207, NULL, NULL, 229749),
(233451, '2hzsF00', NULL, NULL, 242, NULL, NULL, 229749),
(233452, '2gfgA00', NULL, NULL, 193, NULL, NULL, 229749),
(233453, '5a65B00', NULL, NULL, 217, NULL, NULL, 229749),
(233454, '2eenA00', NULL, NULL, 183, NULL, NULL, 229749),
(233455, '3bhdB00', NULL, NULL, 213, NULL, NULL, 229749),
(233456, '5a67A00', NULL, NULL, 212, NULL, NULL, 229749),
(233457, '2dc4A00', NULL, NULL, 165, NULL, NULL, 229749),
(233458, '3n10A00', NULL, NULL, 179, NULL, NULL, 229749),
(233459, '1yemB00', NULL, NULL, 179, NULL, NULL, 229749),
(233460, '3gb8A03', NULL, NULL, 33, NULL, NULL, 229750),
(233461, '4kjzA04', NULL, NULL, 36, NULL, NULL, 229751),
(233462, '3g98A00', NULL, NULL, 111, NULL, NULL, 229752),
(233463, '2zvfA02', NULL, NULL, 106, NULL, NULL, 229752),
(233464, '3h0gA05', NULL, NULL, 146, NULL, NULL, 229753),
(233465, '5fj8A06', NULL, NULL, 147, NULL, NULL, 229753),
(233466, '4aybA07', NULL, NULL, 120, NULL, NULL, 229753),
(233467, '1iw7N06', NULL, NULL, 141, NULL, NULL, 229753),
(233468, '2o5iN07', NULL, NULL, 116, NULL, NULL, 229753),
(233469, '1twfA06', NULL, NULL, 146, NULL, NULL, 229753),
(233470, '4c2mA06', NULL, NULL, 164, NULL, NULL, 229753),
(233471, '1ynjD06', NULL, NULL, 141, NULL, NULL, 229753),
(233472, '4qiwA05', NULL, NULL, 148, NULL, NULL, 229753),
(233473, '4l1gA00', NULL, NULL, 221, NULL, NULL, 229754),
(233474, '2y8uB00', NULL, NULL, 212, NULL, NULL, 229754),
(233475, '1z7aC00', NULL, NULL, 308, NULL, NULL, 229754),
(233476, '2j13A00', NULL, NULL, 247, NULL, NULL, 229754),
(233477, '1xw8A00', NULL, NULL, 252, NULL, NULL, 229754),
(233478, '2vyoA00', NULL, NULL, 220, NULL, NULL, 229754),
(233479, '4hd5A02', NULL, NULL, 219, NULL, NULL, 229754),
(233480, '2nlyA00', NULL, NULL, 226, NULL, NULL, 229754),
(233481, '3s6oA00', NULL, NULL, 321, NULL, NULL, 229754),
(233482, '2c1iA03', NULL, NULL, 195, NULL, NULL, 229754),
(233483, '2dfaA00', NULL, NULL, 250, NULL, NULL, 229754),
(233484, '2cc0A00', NULL, NULL, 195, NULL, NULL, 229754),
(233485, '4m1bA00', NULL, NULL, 208, NULL, NULL, 229754),
(233486, '2c71A00', NULL, NULL, 216, NULL, NULL, 229754),
(233487, '4u10A00', NULL, NULL, 264, NULL, NULL, 229754),
(233488, '3hftA00', NULL, NULL, 257, NULL, NULL, 229754),
(233489, '6go1A02', NULL, NULL, 221, NULL, NULL, 229754),
(233490, '2w3zA00', NULL, NULL, 244, NULL, NULL, 229754),
(233491, '3wx7A01', NULL, NULL, 307, NULL, NULL, 229754),
(233492, '4ly4A00', NULL, NULL, 292, NULL, NULL, 229754),
(233493, '4nz5A01', NULL, NULL, 311, NULL, NULL, 229754),
(233494, '1v6tA00', NULL, NULL, 255, NULL, NULL, 229754),
(233495, '5jmuA00', NULL, NULL, 226, NULL, NULL, 229754),
(233496, '2qv5A01', NULL, NULL, 247, NULL, NULL, 229754),
(233497, '4v33A02', NULL, NULL, 219, NULL, NULL, 229754),
(233498, '2i5iA00', NULL, NULL, 263, NULL, NULL, 229754),
(233499, '1ny1A00', NULL, NULL, 240, NULL, NULL, 229754),
(233500, '2e67A00', NULL, NULL, 264, NULL, NULL, 229754),
(233501, '4wcjA00', NULL, NULL, 235, NULL, NULL, 229754),
(233502, '3rxzA00', NULL, NULL, 300, NULL, NULL, 229754),
(233503, '2iw0A01', NULL, NULL, 220, NULL, NULL, 229754),
(233504, '2xu2A00', NULL, NULL, 252, NULL, NULL, 229754),
(233505, '5bu6A00', NULL, NULL, 277, NULL, NULL, 229754),
(233506, '5lfzA00', NULL, NULL, 205, NULL, NULL, 229754),
(233507, '3cl6A00', NULL, NULL, 308, NULL, NULL, 229754);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(233508, '3vusA00', NULL, NULL, 268, NULL, NULL, 229754),
(233509, '5oomJ01', NULL, NULL, 66, NULL, NULL, 229755),
(233510, '3cjsB00', NULL, NULL, 72, NULL, NULL, 229755),
(233511, '5d8hC01', NULL, NULL, 69, NULL, NULL, 229755),
(233512, '2qa4I01', NULL, NULL, 67, NULL, NULL, 229755),
(233513, '5o60J01', NULL, NULL, 73, NULL, NULL, 229755),
(233514, '1wibA00', NULL, NULL, 92, NULL, NULL, 229755),
(233515, '1mmsA01', NULL, NULL, 70, NULL, NULL, 229755),
(233516, '5dm6F01', NULL, NULL, 70, NULL, NULL, 229755),
(233517, '6i0yI01', NULL, NULL, 71, NULL, NULL, 229755),
(233518, '5mmiJ01', NULL, NULL, 64, NULL, NULL, 229755),
(233519, '5colA01', NULL, NULL, 83, NULL, NULL, 229755),
(233520, '4v19K01', NULL, NULL, 67, NULL, NULL, 229755),
(233521, '1aroP02', NULL, NULL, 47, NULL, NULL, 229756),
(233522, '1mswD02', NULL, NULL, 86, NULL, NULL, 229756),
(233523, '5aboA01', NULL, NULL, 178, NULL, NULL, 229757),
(233524, '1llpA01', NULL, NULL, 165, NULL, NULL, 229757),
(233525, '3vlmB01', NULL, NULL, 195, NULL, NULL, 229757),
(233526, '4a5gA01', NULL, NULL, 158, NULL, NULL, 229757),
(233527, '1fhfA01', NULL, NULL, 158, NULL, NULL, 229757),
(233528, '2vcnA01', NULL, NULL, 154, NULL, NULL, 229757),
(233529, '3hdlA01', NULL, NULL, 160, NULL, NULL, 229757),
(233530, '4cuoA01', NULL, NULL, 158, NULL, NULL, 229757),
(233531, '2ccaA03', NULL, NULL, 168, NULL, NULL, 229757),
(233532, '1apxA01', NULL, NULL, 142, NULL, NULL, 229757),
(233533, '2ccaA01', NULL, NULL, 142, NULL, NULL, 229757),
(233534, '1gwuA01', NULL, NULL, 158, NULL, NULL, 229757),
(233535, '5twtA01', NULL, NULL, 159, NULL, NULL, 229757),
(233536, '1c8iA01', NULL, NULL, 201, NULL, NULL, 229757),
(233537, '5whsA01', NULL, NULL, 211, NULL, NULL, 229757),
(233538, '3e2nA01', NULL, NULL, 166, NULL, NULL, 229757),
(233539, '5whsA03', NULL, NULL, 187, NULL, NULL, 229757),
(233540, '1qgjA01', NULL, NULL, 152, NULL, NULL, 229757),
(233541, '6a6qA01', NULL, NULL, 162, NULL, NULL, 229757),
(233542, '5jhyB01', NULL, NULL, 218, NULL, NULL, 229757),
(233543, '4cznA01', NULL, NULL, 159, NULL, NULL, 229757),
(233544, '5aogA01', NULL, NULL, 161, NULL, NULL, 229757),
(233545, '1bgpA01', NULL, NULL, 161, NULL, NULL, 229757),
(233546, '4bm1A01', NULL, NULL, 162, NULL, NULL, 229757),
(233547, '1schA01', NULL, NULL, 159, NULL, NULL, 229757),
(233548, '1pa2A01', NULL, NULL, 158, NULL, NULL, 229757),
(233549, '1qpaA01', NULL, NULL, 162, NULL, NULL, 229757),
(233550, '1iynA01', NULL, NULL, 151, NULL, NULL, 229757),
(233551, '1u2kA01', NULL, NULL, 164, NULL, NULL, 229757),
(233552, '3m5qA01', NULL, NULL, 159, NULL, NULL, 229757),
(233553, '2e39A01', NULL, NULL, 162, NULL, NULL, 229757),
(233554, '3q3uA01', NULL, NULL, 163, NULL, NULL, 229757),
(233555, '5al9A01', NULL, NULL, 148, NULL, NULL, 229757),
(233556, '3wxoA03', NULL, NULL, 170, NULL, NULL, 229757),
(233557, '4bllA01', NULL, NULL, 179, NULL, NULL, 229757),
(233558, '3vliA03', NULL, NULL, 173, NULL, NULL, 229757),
(233559, '3e2oA01', NULL, NULL, 173, NULL, NULL, 229757),
(233560, '3wxoA01', NULL, NULL, 211, NULL, NULL, 229757),
(233561, '4uscA01', NULL, NULL, 159, NULL, NULL, 229757),
(233562, '3rrwB01', NULL, NULL, 198, NULL, NULL, 229757),
(233563, '5sxwA01', NULL, NULL, 217, NULL, NULL, 229757),
(233564, '5jhxB03', NULL, NULL, 184, NULL, NULL, 229757),
(233565, '3vliA01', NULL, NULL, 142, NULL, NULL, 229757),
(233566, '5sxwA03', NULL, NULL, 182, NULL, NULL, 229757),
(233567, '3v22V00', NULL, NULL, 61, NULL, NULL, 229758),
(233568, '2jrmA00', NULL, NULL, 65, NULL, NULL, 229758),
(233569, '2bolA01', NULL, NULL, 70, NULL, NULL, 229759),
(233570, '4cihA00', NULL, NULL, 150, NULL, NULL, 229760),
(233571, '2l93A01', NULL, NULL, 36, NULL, NULL, 229761),
(233572, '1hnrA00', NULL, NULL, 47, NULL, NULL, 229761),
(233573, '2levA00', NULL, NULL, 57, NULL, NULL, 229761),
(233574, '5j1sB00', NULL, NULL, 239, NULL, NULL, 229762),
(233575, '4tvsA00', NULL, NULL, 231, NULL, NULL, 229762),
(233576, '1wkbA02', NULL, NULL, 243, NULL, NULL, 229763),
(233577, '4k47A00', NULL, NULL, 192, NULL, NULL, 229763),
(233578, '2ajgA00', NULL, NULL, 196, NULL, NULL, 229763);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(233579, '3pz6D00', NULL, NULL, 279, NULL, NULL, 229763),
(233580, '1wkaA00', NULL, NULL, 147, NULL, NULL, 229763),
(233581, '2v0cA02', NULL, NULL, 190, NULL, NULL, 229763),
(233582, '5agrA00', NULL, NULL, 201, NULL, NULL, 229763),
(233583, '2wfdA00', NULL, NULL, 252, NULL, NULL, 229763),
(233584, '3o0aA00', NULL, NULL, 219, NULL, NULL, 229763),
(233585, '1wk8B00', NULL, NULL, 194, NULL, NULL, 229763),
(233586, '1ffyA02', NULL, NULL, 207, NULL, NULL, 229763),
(233587, '5agiA00', NULL, NULL, 261, NULL, NULL, 229763),
(233588, '3ejbB01', NULL, NULL, 91, NULL, NULL, 229764),
(233589, '4mo1A00', NULL, NULL, 154, NULL, NULL, 229765),
(233590, '4gouA02', NULL, NULL, 161, NULL, NULL, 229766),
(233591, '3x1lB03', NULL, NULL, 105, NULL, NULL, 229767),
(233592, '4ak2A02', NULL, NULL, 170, NULL, NULL, 229768),
(233593, '2o98P00', NULL, NULL, 52, NULL, NULL, 229769),
(233594, '5k7bB00', NULL, NULL, 98, NULL, NULL, 229770),
(233595, '5hheA00', NULL, NULL, 93, NULL, NULL, 229770),
(233596, '3q8tA00', NULL, NULL, 96, NULL, NULL, 229770),
(233597, '3rfwA02', NULL, NULL, 83, NULL, NULL, 229771),
(233598, '2y5pA00', NULL, NULL, 74, NULL, NULL, 229772),
(233599, '3zheA02', NULL, NULL, 207, NULL, NULL, 229773),
(233600, '2y2mA03', NULL, NULL, 69, NULL, NULL, 229774),
(233601, '3tl4X02', NULL, NULL, 72, NULL, NULL, 229775),
(233602, '5fgpA00', NULL, NULL, 152, NULL, NULL, 229776),
(233603, '3i8sB02', NULL, NULL, 100, NULL, NULL, 229777),
(233604, '3a1sA02', NULL, NULL, 89, NULL, NULL, 229777),
(233605, '2wicA02', NULL, NULL, 93, NULL, NULL, 229777),
(233606, '3k53A02', NULL, NULL, 101, NULL, NULL, 229777),
(233607, '3tahA02', NULL, NULL, 99, NULL, NULL, 229777),
(233608, '3ibyD02', NULL, NULL, 84, NULL, NULL, 229777),
(233609, '3bl9A01', NULL, NULL, 110, NULL, NULL, 229778),
(233610, '1vlrA01', NULL, NULL, 104, NULL, NULL, 229778),
(233611, '5bv3D01', NULL, NULL, 125, NULL, NULL, 229778),
(233612, '5xl4C00', NULL, NULL, 176, NULL, NULL, 229779),
(233613, '4fqiB00', NULL, NULL, 177, NULL, NULL, 229779),
(233614, '4bsgB00', NULL, NULL, 177, NULL, NULL, 229779),
(233615, '4f23A01', NULL, NULL, 296, NULL, NULL, 229779),
(233616, '5bnyF00', NULL, NULL, 191, NULL, NULL, 229779),
(233617, '2yp9A01', NULL, NULL, 287, NULL, NULL, 229779),
(233618, '4k3xB00', NULL, NULL, 181, NULL, NULL, 229779),
(233619, '3m5jB00', NULL, NULL, 182, NULL, NULL, 229779),
(233620, '6n4fB00', NULL, NULL, 182, NULL, NULL, 229779),
(233621, '1flcB00', NULL, NULL, 175, NULL, NULL, 229779),
(233622, '5vliB00', NULL, NULL, 176, NULL, NULL, 229779),
(233623, '4m44B00', NULL, NULL, 182, NULL, NULL, 229779),
(233624, '4we5B00', NULL, NULL, 181, NULL, NULL, 229779),
(233625, '4f3zD00', NULL, NULL, 179, NULL, NULL, 229779),
(233626, '6aorB00', NULL, NULL, 174, NULL, NULL, 229779),
(233627, '4wswB00', NULL, NULL, 182, NULL, NULL, 229779),
(233628, '1rv0I00', NULL, NULL, 160, NULL, NULL, 229779),
(233629, '4fnkB00', NULL, NULL, 174, NULL, NULL, 229779),
(233630, '5e62B00', NULL, NULL, 149, NULL, NULL, 229779),
(233631, '2wr1C01', NULL, NULL, 272, NULL, NULL, 229779),
(233632, '4mc5A01', NULL, NULL, 289, NULL, NULL, 229779),
(233633, '1qu1F00', NULL, NULL, 155, NULL, NULL, 229779),
(233634, '3ubqH00', NULL, NULL, 177, NULL, NULL, 229779),
(233635, '5cjqB00', NULL, NULL, 172, NULL, NULL, 229779),
(233636, '4gxxF00', NULL, NULL, 176, NULL, NULL, 229779),
(233637, '1htmD00', NULL, NULL, 138, NULL, NULL, 229779),
(233638, '4wa1A01', NULL, NULL, 280, NULL, NULL, 229779),
(233639, '1jsdB00', NULL, NULL, 160, NULL, NULL, 229779),
(233640, '3ku3B00', NULL, NULL, 174, NULL, NULL, 229779),
(233641, '4h32D00', NULL, NULL, 171, NULL, NULL, 229779),
(233642, '5tg9B00', NULL, NULL, 175, NULL, NULL, 229779),
(233643, '4kpqB00', NULL, NULL, 175, NULL, NULL, 229779),
(233644, '5xrsB00', NULL, NULL, 174, NULL, NULL, 229779),
(233645, '4w8nD00', NULL, NULL, 179, NULL, NULL, 229779),
(233646, '5th1B00', NULL, NULL, 180, NULL, NULL, 229779),
(233647, '4wsrF01', NULL, NULL, 290, NULL, NULL, 229779),
(233648, '4jumB00', NULL, NULL, 182, NULL, NULL, 229779),
(233649, '4uo0B00', NULL, NULL, 172, NULL, NULL, 229779);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(233650, '4edbB00', NULL, NULL, 160, NULL, NULL, 229779),
(233651, '5t0bB00', NULL, NULL, 180, NULL, NULL, 229779),
(233652, '4ln6H00', NULL, NULL, 181, NULL, NULL, 229779),
(233653, '1yhnB00', NULL, NULL, 65, NULL, NULL, 229780),
(233654, '2xfdA00', NULL, NULL, 112, NULL, NULL, 229781),
(233655, '4k12B00', NULL, NULL, 84, NULL, NULL, 229782),
(233656, '3euhC02', NULL, NULL, 108, NULL, NULL, 229783),
(233657, '3gnaA00', NULL, NULL, 76, NULL, NULL, 229784),
(233658, '1vw4101', NULL, NULL, 130, NULL, NULL, 229785),
(233659, '3n40P03', NULL, NULL, 55, NULL, NULL, 229786),
(233660, '3a9sA03', NULL, NULL, 250, NULL, NULL, 229787),
(233661, '1fuiA03', NULL, NULL, 251, NULL, NULL, 229787),
(233662, '4c20A03', NULL, NULL, 250, NULL, NULL, 229787),
(233663, '3v5uA01', NULL, NULL, 76, NULL, NULL, 229788),
(233664, '2f4lA01', NULL, NULL, 172, NULL, NULL, 229789),
(233665, '3zg9A00', NULL, NULL, 47, NULL, NULL, 229790),
(233666, '4c2m400', NULL, NULL, 64, NULL, NULL, 229791),
(233667, '3vayA02', NULL, NULL, 87, NULL, NULL, 229792),
(233668, '6bogA02', NULL, NULL, 60, NULL, NULL, 229793),
(233669, '2k4vA00', NULL, NULL, 125, NULL, NULL, 229794),
(233670, '1b8xA03', NULL, NULL, 48, NULL, NULL, 229795),
(233671, '3wguA02', NULL, NULL, 423, NULL, NULL, 229796),
(233672, '3ar4A02', NULL, NULL, 412, NULL, NULL, 229796),
(233673, '3tlmA02', NULL, NULL, 417, NULL, NULL, 229796),
(233674, '5ksdA01', NULL, NULL, 380, NULL, NULL, 229796),
(233675, '5ylvA02', NULL, NULL, 417, NULL, NULL, 229796),
(233676, '5mpmA02', NULL, NULL, 416, NULL, NULL, 229796),
(233677, '1wpgA02', NULL, NULL, 433, NULL, NULL, 229796),
(233678, '2zxeA02', NULL, NULL, 416, NULL, NULL, 229796),
(233679, '1yuaA01', NULL, NULL, 64, NULL, NULL, 229797),
(233680, '2frxA02', NULL, NULL, 169, NULL, NULL, 229798),
(233681, '2pm7C00', NULL, NULL, 381, NULL, NULL, 229799),
(233682, '2xseA00', NULL, NULL, 170, NULL, NULL, 229800),
(233683, '2bhyA03', NULL, NULL, 41, NULL, NULL, 229801),
(233684, '3m07A03', NULL, NULL, 38, NULL, NULL, 229801),
(233685, '4id2A00', NULL, NULL, 142, NULL, NULL, 229802),
(233686, '3kd4A03', NULL, NULL, 137, NULL, NULL, 229803),
(233687, '2e5sA00', NULL, NULL, 98, NULL, NULL, 229804),
(233688, '3d2nA00', NULL, NULL, 83, NULL, NULL, 229804),
(233689, '3d2qD00', NULL, NULL, 70, NULL, NULL, 229804),
(233690, '3h3aA02', NULL, NULL, 86, NULL, NULL, 229805),
(233691, '1mivB02', NULL, NULL, 96, NULL, NULL, 229805),
(233692, '1mivA02', NULL, NULL, 96, NULL, NULL, 229805),
(233693, '1miyA02', NULL, NULL, 96, NULL, NULL, 229805),
(233694, '1miwA02', NULL, NULL, 96, NULL, NULL, 229805),
(233695, '1miwB02', NULL, NULL, 96, NULL, NULL, 229805),
(233696, '1sziA01', NULL, NULL, 78, NULL, NULL, 229806),
(233697, '2bnkA00', NULL, NULL, 67, NULL, NULL, 229807),
(233698, '4dt0A01', NULL, NULL, 81, NULL, NULL, 229808),
(233699, '2k88A00', NULL, NULL, 60, NULL, NULL, 229808),
(233700, '2kk7A00', NULL, NULL, 52, NULL, NULL, 229808),
(233701, '1l2pA00', NULL, NULL, 61, NULL, NULL, 229808),
(233702, '3v6iA01', NULL, NULL, 96, NULL, NULL, 229808),
(233703, '1lj2A00', NULL, NULL, 110, NULL, NULL, 229809),
(233704, '5afbA01', NULL, NULL, 112, NULL, NULL, 229810),
(233705, '2jx9A00', NULL, NULL, 106, NULL, NULL, 229810),
(233706, '2zx2A02', NULL, NULL, 99, NULL, NULL, 229810),
(233707, '2zx2A01', NULL, NULL, 96, NULL, NULL, 229810),
(233708, '2gf4A00', NULL, NULL, 100, NULL, NULL, 229811),
(233709, '2gf4B00', NULL, NULL, 75, NULL, NULL, 229811),
(233710, '1lpvA00', NULL, NULL, 52, NULL, NULL, 229812),
(233711, '3axjA01', NULL, NULL, 147, NULL, NULL, 229813),
(233712, '3axjB01', NULL, NULL, 175, NULL, NULL, 229813),
(233713, '1j1jA01', NULL, NULL, 144, NULL, NULL, 229813),
(233714, '1keyD01', NULL, NULL, 139, NULL, NULL, 229813),
(233715, '3pjaJ01', NULL, NULL, 155, NULL, NULL, 229813),
(233716, '3m4xA03', NULL, NULL, 58, NULL, NULL, 229814),
(233717, '3m6wA03', NULL, NULL, 71, NULL, NULL, 229814),
(233718, '2g80A02', NULL, NULL, 78, NULL, NULL, 229815),
(233719, '1zs9A02', NULL, NULL, 103, NULL, NULL, 229815),
(233720, '3b8mC01', NULL, NULL, 169, NULL, NULL, 229816);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(233721, '4e29B00', NULL, NULL, 248, NULL, NULL, 229816),
(233722, '4e2hC00', NULL, NULL, 240, NULL, NULL, 229816),
(233723, '4zm5C00', NULL, NULL, 243, NULL, NULL, 229816),
(233724, '4e2cB00', NULL, NULL, 245, NULL, NULL, 229816),
(233725, '3b8oA01', NULL, NULL, 229, NULL, NULL, 229816),
(233726, '3b8pC00', NULL, NULL, 189, NULL, NULL, 229816),
(233727, '1xo9A02', NULL, NULL, 47, NULL, NULL, 229817),
(233728, '3lmmA02', NULL, NULL, 79, NULL, NULL, 229818),
(233729, '3kmiA00', NULL, NULL, 177, NULL, NULL, 229819),
(233730, '1jo6A00', NULL, NULL, 45, NULL, NULL, 229820),
(233731, '3h0dA01', NULL, NULL, 71, NULL, NULL, 229821),
(233732, '4a4kA02', NULL, NULL, 133, NULL, NULL, 229822),
(233733, '1vx7i00', NULL, NULL, 104, NULL, NULL, 229823),
(233734, '4a18C00', NULL, NULL, 109, NULL, NULL, 229823),
(233735, '1vq8300', NULL, NULL, 92, NULL, NULL, 229823),
(233736, '3o58f00', NULL, NULL, 106, NULL, NULL, 229823),
(233737, '1vwxo00', NULL, NULL, 106, NULL, NULL, 229823),
(233738, '4ipeB03', NULL, NULL, 96, NULL, NULL, 229824),
(233739, '3q6mA02', NULL, NULL, 117, NULL, NULL, 229824),
(233740, '1y4uA03', NULL, NULL, 98, NULL, NULL, 229824),
(233741, '2cgeA02', NULL, NULL, 116, NULL, NULL, 229824),
(233742, '5ulsA03', NULL, NULL, 94, NULL, NULL, 229824),
(233743, '2gq0B02', NULL, NULL, 93, NULL, NULL, 229824),
(233744, '2o1wA03', NULL, NULL, 93, NULL, NULL, 229824),
(233745, '1y6zA02', NULL, NULL, 87, NULL, NULL, 229824),
(233746, '3pryB02', NULL, NULL, 94, NULL, NULL, 229824),
(233747, '3hjcA02', NULL, NULL, 117, NULL, NULL, 229824),
(233748, '1usuA02', NULL, NULL, 86, NULL, NULL, 229824),
(233749, '3qxyA01', NULL, NULL, 258, NULL, NULL, 229825),
(233750, '2h21C01', NULL, NULL, 255, NULL, NULL, 229825),
(233751, '3smtA01', NULL, NULL, 308, NULL, NULL, 229825),
(233752, '1i82A00', NULL, NULL, 189, NULL, NULL, 229826),
(233753, '1ulvA04', NULL, NULL, 247, NULL, NULL, 229826),
(233754, '2ivfC00', NULL, NULL, 214, NULL, NULL, 229826),
(233755, '4jpqB00', NULL, NULL, 220, NULL, NULL, 229826),
(233756, '3lxmA01', NULL, NULL, 152, NULL, NULL, 229827),
(233757, '3lxmA02', NULL, NULL, 158, NULL, NULL, 229827),
(233758, '6fbaB02', NULL, NULL, 172, NULL, NULL, 229827),
(233759, '4iv5A01', NULL, NULL, 162, NULL, NULL, 229827),
(233760, '1duvG02', NULL, NULL, 183, NULL, NULL, 229827),
(233761, '1duvG01', NULL, NULL, 150, NULL, NULL, 229827),
(233762, '3csuC02', NULL, NULL, 158, NULL, NULL, 229827),
(233763, '4h31A01', NULL, NULL, 154, NULL, NULL, 229827),
(233764, '4a8pF01', NULL, NULL, 172, NULL, NULL, 229827),
(233765, '1js1X02', NULL, NULL, 152, NULL, NULL, 229827),
(233766, '1dxhA01', NULL, NULL, 183, NULL, NULL, 229827),
(233767, '2ef0A01', NULL, NULL, 150, NULL, NULL, 229827),
(233768, '1pvvA02', NULL, NULL, 160, NULL, NULL, 229827),
(233769, '1dxhA02', NULL, NULL, 136, NULL, NULL, 229827),
(233770, '2ef0A02', NULL, NULL, 151, NULL, NULL, 229827),
(233771, '3sdsA02', NULL, NULL, 176, NULL, NULL, 229827),
(233772, '3tpfB01', NULL, NULL, 146, NULL, NULL, 229827),
(233773, '5g1nE01', NULL, NULL, 156, NULL, NULL, 229827),
(233774, '1pvvA01', NULL, NULL, 153, NULL, NULL, 229827),
(233775, '5g1nA02', NULL, NULL, 158, NULL, NULL, 229827),
(233776, '5nnnA01', NULL, NULL, 156, NULL, NULL, 229827),
(233777, '5nnnA02', NULL, NULL, 159, NULL, NULL, 229827),
(233778, '2atcA02', NULL, NULL, 153, NULL, NULL, 229827),
(233779, '3grfA01', NULL, NULL, 152, NULL, NULL, 229827),
(233780, '3grfA02', NULL, NULL, 173, NULL, NULL, 229827),
(233781, '4a8tA01', NULL, NULL, 149, NULL, NULL, 229827),
(233782, '4a8tA02', NULL, NULL, 164, NULL, NULL, 229827),
(233783, '4kwtA02', NULL, NULL, 182, NULL, NULL, 229827),
(233784, '2yfkA01', NULL, NULL, 201, NULL, NULL, 229827),
(233785, '2yfkA02', NULL, NULL, 196, NULL, NULL, 229827),
(233786, '4f2gA01', NULL, NULL, 152, NULL, NULL, 229827),
(233787, '2be7A02', NULL, NULL, 158, NULL, NULL, 229827),
(233788, '2be7A01', NULL, NULL, 151, NULL, NULL, 229827),
(233789, '4f2gA02', NULL, NULL, 154, NULL, NULL, 229827),
(233790, '1ml4A01', NULL, NULL, 150, NULL, NULL, 229827),
(233791, '2be9A01', NULL, NULL, 152, NULL, NULL, 229827);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(233792, '4fyyA01', NULL, NULL, 152, NULL, NULL, 229827),
(233793, '1ml4A02', NULL, NULL, 158, NULL, NULL, 229827),
(233794, '4eknB02', NULL, NULL, 157, NULL, NULL, 229827),
(233795, '6fbaC01', NULL, NULL, 177, NULL, NULL, 229827),
(233796, '3gd5A02', NULL, NULL, 160, NULL, NULL, 229827),
(233797, '3gd5A01', NULL, NULL, 163, NULL, NULL, 229827),
(233798, '3r7fA01', NULL, NULL, 162, NULL, NULL, 229827),
(233799, '2w37A01', NULL, NULL, 140, NULL, NULL, 229827),
(233800, '3r7fA02', NULL, NULL, 142, NULL, NULL, 229827),
(233801, '3q98A02', NULL, NULL, 196, NULL, NULL, 229827),
(233802, '2w37A02', NULL, NULL, 180, NULL, NULL, 229827),
(233803, '3q98A01', NULL, NULL, 203, NULL, NULL, 229827),
(233804, '4amuA01', NULL, NULL, 176, NULL, NULL, 229827),
(233805, '4amuA02', NULL, NULL, 168, NULL, NULL, 229827),
(233806, '4nf2A01', NULL, NULL, 153, NULL, NULL, 229827),
(233807, '4nf2A02', NULL, NULL, 159, NULL, NULL, 229827),
(233808, '4bjhB01', NULL, NULL, 147, NULL, NULL, 229827),
(233809, '4iv5D02', NULL, NULL, 172, NULL, NULL, 229827),
(233810, '4eknB01', NULL, NULL, 149, NULL, NULL, 229827),
(233811, '1js1Y01', NULL, NULL, 170, NULL, NULL, 229827),
(233812, '4bjhB02', NULL, NULL, 144, NULL, NULL, 229827),
(233813, '2i6uA02', NULL, NULL, 161, NULL, NULL, 229827),
(233814, '2i6uA01', NULL, NULL, 146, NULL, NULL, 229827),
(233815, '1vlvA02', NULL, NULL, 157, NULL, NULL, 229827),
(233816, '1pg5A02', NULL, NULL, 148, NULL, NULL, 229827),
(233817, '3sdsB01', NULL, NULL, 153, NULL, NULL, 229827),
(233818, '3tpfA02', NULL, NULL, 161, NULL, NULL, 229827),
(233819, '1vlvA01', NULL, NULL, 168, NULL, NULL, 229827),
(233820, '3kznA01', NULL, NULL, 166, NULL, NULL, 229827),
(233821, '3kznA02', NULL, NULL, 171, NULL, NULL, 229827),
(233822, '3updA01', NULL, NULL, 197, NULL, NULL, 229827),
(233823, '6ovwA01', NULL, NULL, 150, NULL, NULL, 229827),
(233824, '4oh7A02', NULL, NULL, 155, NULL, NULL, 229827),
(233825, '4oh7A01', NULL, NULL, 165, NULL, NULL, 229827),
(233826, '6ovwA02', NULL, NULL, 183, NULL, NULL, 229827),
(233827, '1othA01', NULL, NULL, 153, NULL, NULL, 229827),
(233828, '1othA02', NULL, NULL, 159, NULL, NULL, 229827),
(233829, '3kdjA00', NULL, NULL, 202, NULL, NULL, 229828),
(233830, '2lcgA00', NULL, NULL, 142, NULL, NULL, 229828),
(233831, '3w9kA00', NULL, NULL, 139, NULL, NULL, 229828),
(233832, '3oh8A01', NULL, NULL, 141, NULL, NULL, 229828),
(233833, '2ldkA00', NULL, NULL, 172, NULL, NULL, 229828),
(233834, '3ggnB00', NULL, NULL, 155, NULL, NULL, 229828),
(233835, '5mmqB00', NULL, NULL, 191, NULL, NULL, 229828),
(233836, '3cnwA00', NULL, NULL, 148, NULL, NULL, 229828),
(233837, '3r6pA00', NULL, NULL, 167, NULL, NULL, 229828),
(233838, '4jdlB00', NULL, NULL, 168, NULL, NULL, 229828),
(233839, '4jhgA00', NULL, NULL, 168, NULL, NULL, 229828),
(233840, '4q0kA00', NULL, NULL, 162, NULL, NULL, 229828),
(233841, '3rt2A00', NULL, NULL, 183, NULL, NULL, 229828),
(233842, '6alkA00', NULL, NULL, 159, NULL, NULL, 229828),
(233843, '4c9cA00', NULL, NULL, 162, NULL, NULL, 229828),
(233844, '2il5A00', NULL, NULL, 171, NULL, NULL, 229828),
(233845, '3rd6A00', NULL, NULL, 161, NULL, NULL, 229828),
(233846, '2qpvA00', NULL, NULL, 133, NULL, NULL, 229828),
(233847, '2le1A00', NULL, NULL, 151, NULL, NULL, 229828),
(233848, '4z3lA00', NULL, NULL, 159, NULL, NULL, 229828),
(233849, '4xrtA02', NULL, NULL, 160, NULL, NULL, 229828),
(233850, '4xrtA01', NULL, NULL, 142, NULL, NULL, 229828),
(233851, '2ns9A01', NULL, NULL, 148, NULL, NULL, 229828),
(233852, '1fm4A00', NULL, NULL, 159, NULL, NULL, 229828),
(233853, '4n0gC00', NULL, NULL, 164, NULL, NULL, 229828),
(233854, '2lf2A00', NULL, NULL, 175, NULL, NULL, 229828),
(233855, '1x53A01', NULL, NULL, 131, NULL, NULL, 229828),
(233856, '3tvrA00', NULL, NULL, 173, NULL, NULL, 229828),
(233857, '3eliA00', NULL, NULL, 152, NULL, NULL, 229828),
(233858, '5ujvB00', NULL, NULL, 212, NULL, NULL, 229828),
(233859, '3pu2B00', NULL, NULL, 164, NULL, NULL, 229828),
(233860, '3p9vA00', NULL, NULL, 161, NULL, NULL, 229828),
(233861, '1t17A00', NULL, NULL, 148, NULL, NULL, 229828),
(233862, '2lghA00', NULL, NULL, 144, NULL, NULL, 229828);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(233863, '4c94A00', NULL, NULL, 161, NULL, NULL, 229828),
(233864, '4xrwA02', NULL, NULL, 161, NULL, NULL, 229828),
(233865, '4xrwA01', NULL, NULL, 148, NULL, NULL, 229828),
(233866, '2kf2A00', NULL, NULL, 167, NULL, NULL, 229828),
(233867, '2bk0A00', NULL, NULL, 154, NULL, NULL, 229828),
(233868, '5mmuA00', NULL, NULL, 158, NULL, NULL, 229828),
(233869, '3qszA00', NULL, NULL, 189, NULL, NULL, 229828),
(233870, '2kewA00', NULL, NULL, 152, NULL, NULL, 229828),
(233871, '2r55A00', NULL, NULL, 212, NULL, NULL, 229828),
(233872, '3q64A00', NULL, NULL, 162, NULL, NULL, 229828),
(233873, '2pcsA00', NULL, NULL, 162, NULL, NULL, 229828),
(233874, '5ur4A00', NULL, NULL, 181, NULL, NULL, 229828),
(233875, '1kcmA00', NULL, NULL, 270, NULL, NULL, 229828),
(233876, '3ijtB00', NULL, NULL, 155, NULL, NULL, 229828),
(233877, '1zxfA00', NULL, NULL, 155, NULL, NULL, 229828),
(233878, '1z94B00', NULL, NULL, 147, NULL, NULL, 229828),
(233879, '4a8uA00', NULL, NULL, 159, NULL, NULL, 229828),
(233880, '3ni8A00', NULL, NULL, 141, NULL, NULL, 229828),
(233881, '3fo5B00', NULL, NULL, 258, NULL, NULL, 229828),
(233882, '2mouA00', NULL, NULL, 220, NULL, NULL, 229828),
(233883, '2l9pA00', NULL, NULL, 164, NULL, NULL, 229828),
(233884, '4rehA00', NULL, NULL, 151, NULL, NULL, 229828),
(233885, '1xn6A00', NULL, NULL, 143, NULL, NULL, 229828),
(233886, '1jssA00', NULL, NULL, 201, NULL, NULL, 229828),
(233887, '3p51A00', NULL, NULL, 160, NULL, NULL, 229828),
(233888, '2lakA00', NULL, NULL, 160, NULL, NULL, 229828),
(233889, '5i9jA00', NULL, NULL, 229, NULL, NULL, 229828),
(233890, '4bk7A00', NULL, NULL, 159, NULL, NULL, 229828),
(233891, '2leqA00', NULL, NULL, 146, NULL, NULL, 229828),
(233892, '2e3nA00', NULL, NULL, 234, NULL, NULL, 229828),
(233893, '1ln1A00', NULL, NULL, 214, NULL, NULL, 229828),
(233894, '3w9rA00', NULL, NULL, 189, NULL, NULL, 229828),
(233895, '5i8fA00', NULL, NULL, 165, NULL, NULL, 229828),
(233896, '1xfsA00', NULL, NULL, 178, NULL, NULL, 229828),
(233897, '5amwA00', NULL, NULL, 162, NULL, NULL, 229828),
(233898, '1e09A00', NULL, NULL, 159, NULL, NULL, 229828),
(233899, '3otlA00', NULL, NULL, 158, NULL, NULL, 229828),
(233900, '2k7hA00', NULL, NULL, 157, NULL, NULL, 229828),
(233901, '2psoB02', NULL, NULL, 187, NULL, NULL, 229828),
(233902, '3kl1B00', NULL, NULL, 190, NULL, NULL, 229828),
(233903, '2l8oA00', NULL, NULL, 144, NULL, NULL, 229828),
(233904, '2k5gA01', NULL, NULL, 180, NULL, NULL, 229828),
(233905, '1xdfA00', NULL, NULL, 157, NULL, NULL, 229828),
(233906, '1qmrA00', NULL, NULL, 159, NULL, NULL, 229828),
(233907, '1xuvA00', NULL, NULL, 178, NULL, NULL, 229828),
(233908, '3tfzB00', NULL, NULL, 172, NULL, NULL, 229828),
(233909, '3q63F00', NULL, NULL, 151, NULL, NULL, 229828),
(233910, '1ifvA00', NULL, NULL, 155, NULL, NULL, 229828),
(233911, '2nn5A00', NULL, NULL, 184, NULL, NULL, 229828),
(233912, '1vjhA00', NULL, NULL, 122, NULL, NULL, 229828),
(233913, '5e4bA00', NULL, NULL, 176, NULL, NULL, 229828),
(233914, '3q6aB00', NULL, NULL, 135, NULL, NULL, 229828),
(233915, '4igvA00', NULL, NULL, 150, NULL, NULL, 229828),
(233916, '2wqlA00', NULL, NULL, 154, NULL, NULL, 229828),
(233917, '2a1lA00', NULL, NULL, 270, NULL, NULL, 229828),
(233918, '3p0lD00', NULL, NULL, 221, NULL, NULL, 229828),
(233919, '4fpwB00', NULL, NULL, 181, NULL, NULL, 229828),
(233920, '3uidA00', NULL, NULL, 168, NULL, NULL, 229828),
(233921, '2lioA00', NULL, NULL, 136, NULL, NULL, 229828),
(233922, '1tw0A00', NULL, NULL, 157, NULL, NULL, 229828),
(233923, '2m89A00', NULL, NULL, 148, NULL, NULL, 229828),
(233924, '5moaA00', NULL, NULL, 206, NULL, NULL, 229828),
(233925, '5nonB00', NULL, NULL, 165, NULL, NULL, 229828),
(233926, '3putB00', NULL, NULL, 166, NULL, NULL, 229828),
(233927, '3tvqA00', NULL, NULL, 152, NULL, NULL, 229828),
(233928, '5zcgD00', NULL, NULL, 175, NULL, NULL, 229828),
(233929, '4ryvA00', NULL, NULL, 155, NULL, NULL, 229828),
(233930, '4m9bA00', NULL, NULL, 157, NULL, NULL, 229828),
(233931, '4r7kA00', NULL, NULL, 168, NULL, NULL, 229828),
(233932, '4dscA00', NULL, NULL, 188, NULL, NULL, 229828),
(233933, '3f08A00', NULL, NULL, 146, NULL, NULL, 229828);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(233934, '1xn5A00', NULL, NULL, 146, NULL, NULL, 229828),
(233935, '2m47A00', NULL, NULL, 163, NULL, NULL, 229828),
(233936, '4oicA00', NULL, NULL, 207, NULL, NULL, 229828),
(233937, '2i9yA00', NULL, NULL, 166, NULL, NULL, 229828),
(233938, '2ffsA00', NULL, NULL, 157, NULL, NULL, 229828),
(233939, '2flhB00', NULL, NULL, 155, NULL, NULL, 229828),
(233940, '2qimA00', NULL, NULL, 158, NULL, NULL, 229828),
(233941, '2d4rA00', NULL, NULL, 147, NULL, NULL, 229828),
(233942, '1vmoA00', NULL, NULL, 163, NULL, NULL, 229829),
(233943, '6g1iA00', NULL, NULL, 223, NULL, NULL, 229830),
(233944, '4ildA01', NULL, NULL, 80, NULL, NULL, 229831),
(233945, '2yq2A02', NULL, NULL, 76, NULL, NULL, 229831),
(233946, '3bbjA00', NULL, NULL, 272, NULL, NULL, 229832),
(233947, '3u0aA00', NULL, NULL, 285, NULL, NULL, 229832),
(233948, '3cjyA00', NULL, NULL, 259, NULL, NULL, 229832),
(233949, '4r9zB00', NULL, NULL, 278, NULL, NULL, 229832),
(233950, '3rd7A00', NULL, NULL, 286, NULL, NULL, 229832),
(233951, '3rqbB00', NULL, NULL, 275, NULL, NULL, 229832),
(233952, '4qfwA00', NULL, NULL, 288, NULL, NULL, 229832),
(233953, '5yuyA04', NULL, NULL, 111, NULL, NULL, 229833),
(233954, '2rdiA04', NULL, NULL, 104, NULL, NULL, 229833),
(233955, '5wm1A05', NULL, NULL, 117, NULL, NULL, 229833),
(233956, '3mfiA04', NULL, NULL, 121, NULL, NULL, 229833),
(233957, '1jx4A04', NULL, NULL, 109, NULL, NULL, 229833),
(233958, '3gqcC04', NULL, NULL, 126, NULL, NULL, 229833),
(233959, '4f4yA04', NULL, NULL, 100, NULL, NULL, 229833),
(233960, '3gv5D04', NULL, NULL, 122, NULL, NULL, 229833),
(233961, '5kfzA04', NULL, NULL, 123, NULL, NULL, 229833),
(233962, '6cstA04', NULL, NULL, 118, NULL, NULL, 229833),
(233963, '3o8oB03', NULL, NULL, 227, NULL, NULL, 229834),
(233964, '3o8oF01', NULL, NULL, 227, NULL, NULL, 229834),
(233965, '4jemA00', NULL, NULL, 170, NULL, NULL, 229834),
(233966, '4wl0A01', NULL, NULL, 216, NULL, NULL, 229834),
(233967, '1f8yA00', NULL, NULL, 157, NULL, NULL, 229834),
(233968, '3bq9A02', NULL, NULL, 334, NULL, NULL, 229834),
(233969, '2higA02', NULL, NULL, 192, NULL, NULL, 229834),
(233970, '4p5eA00', NULL, NULL, 152, NULL, NULL, 229834),
(233971, '1t35G00', NULL, NULL, 191, NULL, NULL, 229834),
(233972, '1t35E00', NULL, NULL, 191, NULL, NULL, 229834),
(233973, '5ajtA00', NULL, NULL, 217, NULL, NULL, 229834),
(233974, '3opyA02', NULL, NULL, 224, NULL, NULL, 229834),
(233975, '4ljrA00', NULL, NULL, 221, NULL, NULL, 229834),
(233976, '1wekC01', NULL, NULL, 203, NULL, NULL, 229834),
(233977, '5zbjA00', NULL, NULL, 186, NULL, NULL, 229834),
(233978, '4a3sA01', NULL, NULL, 188, NULL, NULL, 229834),
(233979, '2iz6A00', NULL, NULL, 176, NULL, NULL, 229834),
(233980, '5xz7A01', NULL, NULL, 189, NULL, NULL, 229834),
(233981, '1ydhA00', NULL, NULL, 188, NULL, NULL, 229834),
(233982, '1zxxA01', NULL, NULL, 181, NULL, NULL, 229834),
(233983, '3opyB04', NULL, NULL, 231, NULL, NULL, 229834),
(233984, '3ehdA00', NULL, NULL, 162, NULL, NULL, 229834),
(233985, '1s2gB00', NULL, NULL, 167, NULL, NULL, 229834),
(233986, '1t35C00', NULL, NULL, 191, NULL, NULL, 229834),
(233987, '1t35A00', NULL, NULL, 191, NULL, NULL, 229834),
(233988, '1wehA00', NULL, NULL, 171, NULL, NULL, 229834),
(233989, '3majA01', NULL, NULL, 305, NULL, NULL, 229834),
(233990, '4i7eA01', NULL, NULL, 188, NULL, NULL, 229834),
(233991, '3o8lA03', NULL, NULL, 216, NULL, NULL, 229834),
(233992, '3hnoA01', NULL, NULL, 230, NULL, NULL, 229834),
(233993, '3o8lA01', NULL, NULL, 238, NULL, NULL, 229834),
(233994, '3o8oA03', NULL, NULL, 237, NULL, NULL, 229834),
(233995, '5zblA00', NULL, NULL, 203, NULL, NULL, 229834),
(233996, '2f62A00', NULL, NULL, 161, NULL, NULL, 229834),
(233997, '1t35H00', NULL, NULL, 191, NULL, NULL, 229834),
(233998, '1t35F00', NULL, NULL, 191, NULL, NULL, 229834),
(233999, '1rcuA00', NULL, NULL, 172, NULL, NULL, 229834),
(234000, '6gflB02', NULL, NULL, 317, NULL, NULL, 229834),
(234001, '4mcjG00', NULL, NULL, 154, NULL, NULL, 229834),
(234002, '2nx2A00', NULL, NULL, 181, NULL, NULL, 229834),
(234003, '6qaiA00', NULL, NULL, 156, NULL, NULL, 229834),
(234004, '3opyB02', NULL, NULL, 226, NULL, NULL, 229834);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(234005, '2khzA00', NULL, NULL, 165, NULL, NULL, 229834),
(234006, '3quaA00', NULL, NULL, 179, NULL, NULL, 229834),
(234007, '4kxlD00', NULL, NULL, 152, NULL, NULL, 229834),
(234008, '3o8oA01', NULL, NULL, 228, NULL, NULL, 229834),
(234009, '1pfkA01', NULL, NULL, 189, NULL, NULL, 229834),
(234010, '3k2qA01', NULL, NULL, 231, NULL, NULL, 229834),
(234011, '3uqzB00', NULL, NULL, 288, NULL, NULL, 229834),
(234012, '4jenB00', NULL, NULL, 151, NULL, NULL, 229834),
(234013, '3opyA04', NULL, NULL, 240, NULL, NULL, 229834),
(234014, '3imkA00', NULL, NULL, 158, NULL, NULL, 229834),
(234015, '4u1rB03', NULL, NULL, 216, NULL, NULL, 229834),
(234016, '5wq3B01', NULL, NULL, 218, NULL, NULL, 229834),
(234017, '1t35D00', NULL, NULL, 191, NULL, NULL, 229834),
(234018, '1t35B00', NULL, NULL, 191, NULL, NULL, 229834),
(234019, '2a33A00', NULL, NULL, 190, NULL, NULL, 229834),
(234020, '2f48A01', NULL, NULL, 285, NULL, NULL, 229834),
(234021, '3gh1A02', NULL, NULL, 330, NULL, NULL, 229834),
(234022, '5vtoA00', NULL, NULL, 163, NULL, NULL, 229834),
(234023, '3sbxA00', NULL, NULL, 189, NULL, NULL, 229834),
(234024, '4xsgB00', NULL, NULL, 219, NULL, NULL, 229835),
(234025, '5urpA00', NULL, NULL, 201, NULL, NULL, 229835),
(234026, '4elnA00', NULL, NULL, 237, NULL, NULL, 229835),
(234027, '2gwmA00', NULL, NULL, 200, NULL, NULL, 229835),
(234028, '5wtzA01', NULL, NULL, 214, NULL, NULL, 229835),
(234029, '2c8hB00', NULL, NULL, 211, NULL, NULL, 229835),
(234030, '1gxyA00', NULL, NULL, 226, NULL, NULL, 229835),
(234031, '5wtzA02', NULL, NULL, 207, NULL, NULL, 229835),
(234032, '1r45A00', NULL, NULL, 204, NULL, NULL, 229835),
(234033, '4dv8A01', NULL, NULL, 218, NULL, NULL, 229835),
(234034, '3bw8A00', NULL, NULL, 217, NULL, NULL, 229835),
(234035, '5dzqO00', NULL, NULL, 186, NULL, NULL, 229835),
(234036, '4h03A01', NULL, NULL, 216, NULL, NULL, 229835),
(234037, '4fk7A00', NULL, NULL, 229, NULL, NULL, 229835),
(234038, '4fmlA00', NULL, NULL, 204, NULL, NULL, 229835),
(234039, '4h03A02', NULL, NULL, 202, NULL, NULL, 229835),
(234040, '1qs1A01', NULL, NULL, 203, NULL, NULL, 229835),
(234041, '1qs1A02', NULL, NULL, 198, NULL, NULL, 229835),
(234042, '2wn4A02', NULL, NULL, 202, NULL, NULL, 229835),
(234043, '1ojqA00', NULL, NULL, 212, NULL, NULL, 229835),
(234044, '2j3xA02', NULL, NULL, 212, NULL, NULL, 229835),
(234045, '2wn6A01', NULL, NULL, 202, NULL, NULL, 229835),
(234046, '2j3xA01', NULL, NULL, 219, NULL, NULL, 229835),
(234047, '3u0jA00', NULL, NULL, 236, NULL, NULL, 229835),
(234048, '2ox7A01', NULL, NULL, 62, NULL, NULL, 229836),
(234049, '1tt4A00', NULL, NULL, 368, NULL, NULL, 229837),
(234050, '3ln7A01', NULL, NULL, 430, NULL, NULL, 229837),
(234051, '3ln6A01', NULL, NULL, 426, NULL, NULL, 229837),
(234052, '3nztA00', NULL, NULL, 500, NULL, NULL, 229837),
(234053, '2gwcB00', NULL, NULL, 449, NULL, NULL, 229837),
(234054, '1va6B02', NULL, NULL, 447, NULL, NULL, 229837),
(234055, '1r8gB00', NULL, NULL, 372, NULL, NULL, 229837),
(234056, '1vpqA00', NULL, NULL, 273, NULL, NULL, 229838),
(234057, '1vpyA00', NULL, NULL, 289, NULL, NULL, 229838),
(234058, '2jpfA01', NULL, NULL, 87, NULL, NULL, 229839),
(234059, '1zghA02', NULL, NULL, 66, NULL, NULL, 229840),
(234060, '3nl9A00', NULL, NULL, 171, NULL, NULL, 229841),
(234061, '2yf4F00', NULL, NULL, 154, NULL, NULL, 229841),
(234062, '2k4yA00', NULL, NULL, 86, NULL, NULL, 229842),
(234063, '2qq9A03', NULL, NULL, 77, NULL, NULL, 229842),
(234064, '1fx7B03', NULL, NULL, 80, NULL, NULL, 229842),
(234065, '4o5vA03', NULL, NULL, 78, NULL, NULL, 229842),
(234066, '5cviB02', NULL, NULL, 76, NULL, NULL, 229842),
(234067, '3e19B01', NULL, NULL, 64, NULL, NULL, 229842),
(234068, '2k5fA01', NULL, NULL, 83, NULL, NULL, 229842),
(234069, '3mhxB00', NULL, NULL, 85, NULL, NULL, 229842),
(234070, '2h3jA01', NULL, NULL, 68, NULL, NULL, 229842),
(234071, '2k5lA00', NULL, NULL, 81, NULL, NULL, 229842),
(234072, '1bymA00', NULL, NULL, 97, NULL, NULL, 229842),
(234073, '2k5iA01', NULL, NULL, 84, NULL, NULL, 229842),
(234074, '3hrsA02', NULL, NULL, 76, NULL, NULL, 229842),
(234075, '2gcxA01', NULL, NULL, 69, NULL, NULL, 229842);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(234076, '2lx9A00', NULL, NULL, 83, NULL, NULL, 229842),
(234077, '2k5iA02', NULL, NULL, 78, NULL, NULL, 229842),
(234078, '2aj4B01', NULL, NULL, 250, NULL, NULL, 229843),
(234079, '1s4eB01', NULL, NULL, 186, NULL, NULL, 229843),
(234080, '4hy1A02', NULL, NULL, 176, NULL, NULL, 229843),
(234081, '6az1L00', NULL, NULL, 149, NULL, NULL, 229843),
(234082, '3ltoA01', NULL, NULL, 181, NULL, NULL, 229843),
(234083, '3zkbI02', NULL, NULL, 173, NULL, NULL, 229843),
(234084, '5x8ri00', NULL, NULL, 135, NULL, NULL, 229843),
(234085, '3v5rA01', NULL, NULL, 232, NULL, NULL, 229843),
(234086, '2hfsA01', NULL, NULL, 183, NULL, NULL, 229843),
(234087, '2x7iA01', NULL, NULL, 170, NULL, NULL, 229843),
(234088, '5xxuC02', NULL, NULL, 94, NULL, NULL, 229843),
(234089, '6emlF00', NULL, NULL, 143, NULL, NULL, 229843),
(234090, '1b63A02', NULL, NULL, 114, NULL, NULL, 229843),
(234091, '3qt5B01', NULL, NULL, 186, NULL, NULL, 229843),
(234092, '6n0iA04', NULL, NULL, 139, NULL, NULL, 229843),
(234093, '2xexA04', NULL, NULL, 140, NULL, NULL, 229843),
(234094, '1pkpA02', NULL, NULL, 77, NULL, NULL, 229843),
(234095, '5j5pA02', NULL, NULL, 183, NULL, NULL, 229843),
(234096, '5xyiC02', NULL, NULL, 94, NULL, NULL, 229843),
(234097, '5optd02', NULL, NULL, 94, NULL, NULL, 229843),
(234098, '1pieA01', NULL, NULL, 214, NULL, NULL, 229843),
(234099, '2gs8A01', NULL, NULL, 177, NULL, NULL, 229843),
(234100, '2r3vB01', NULL, NULL, 248, NULL, NULL, 229843),
(234101, '5o5jI00', NULL, NULL, 126, NULL, NULL, 229843),
(234102, '1kvkA01', NULL, NULL, 247, NULL, NULL, 229843),
(234103, '6faiC02', NULL, NULL, 94, NULL, NULL, 229843),
(234104, '4fwgA03', NULL, NULL, 240, NULL, NULL, 229843),
(234105, '1s4eG01', NULL, NULL, 152, NULL, NULL, 229843),
(234106, '6enhA02', NULL, NULL, 174, NULL, NULL, 229843),
(234107, '4fn5A04', NULL, NULL, 126, NULL, NULL, 229843),
(234108, '4jg4A00', NULL, NULL, 119, NULL, NULL, 229843),
(234109, '1z5bB03', NULL, NULL, 156, NULL, NULL, 229843),
(234110, '2v8pA01', NULL, NULL, 156, NULL, NULL, 229843),
(234111, '2oi2A01', NULL, NULL, 158, NULL, NULL, 229843),
(234112, '3gonA01', NULL, NULL, 194, NULL, NULL, 229843),
(234113, '3jamQ00', NULL, NULL, 143, NULL, NULL, 229843),
(234114, '3wu4A01', NULL, NULL, 188, NULL, NULL, 229843),
(234115, '2cz9A01', NULL, NULL, 175, NULL, NULL, 229843),
(234116, '4p7aA02', NULL, NULL, 127, NULL, NULL, 229843),
(234117, '3k1jB03', NULL, NULL, 210, NULL, NULL, 229843),
(234118, '6q3wD01', NULL, NULL, 221, NULL, NULL, 229843),
(234119, '1oj4A01', NULL, NULL, 164, NULL, NULL, 229843),
(234120, '4rpfC01', NULL, NULL, 177, NULL, NULL, 229843),
(234121, '4uskA01', NULL, NULL, 192, NULL, NULL, 229843),
(234122, '1h72C01', NULL, NULL, 161, NULL, NULL, 229843),
(234123, '3j7aM00', NULL, NULL, 144, NULL, NULL, 229843),
(234124, '1darA04', NULL, NULL, 119, NULL, NULL, 229843),
(234125, '6az1F02', NULL, NULL, 94, NULL, NULL, 229843),
(234126, '1s16A02', NULL, NULL, 175, NULL, NULL, 229843),
(234127, '2xzmE02', NULL, NULL, 95, NULL, NULL, 229843),
(234128, '4urlA02', NULL, NULL, 183, NULL, NULL, 229843),
(234129, '2ljpA00', NULL, NULL, 119, NULL, NULL, 229843),
(234130, '3pyfA01', NULL, NULL, 163, NULL, NULL, 229843),
(234131, '1z0wA00', NULL, NULL, 207, NULL, NULL, 229843),
(234132, '2a2cA01', NULL, NULL, 221, NULL, NULL, 229843),
(234133, '3lnuA02', NULL, NULL, 172, NULL, NULL, 229843),
(234134, '6g5iC02', NULL, NULL, 94, NULL, NULL, 229843),
(234135, '2xzmI00', NULL, NULL, 145, NULL, NULL, 229843),
(234136, '2x36D00', NULL, NULL, 207, NULL, NULL, 229843),
(234137, '5v2mA01', NULL, NULL, 183, NULL, NULL, 229843),
(234138, '6notA04', NULL, NULL, 128, NULL, NULL, 229843),
(234139, '5optr00', NULL, NULL, 149, NULL, NULL, 229843),
(234140, '1mg7A02', NULL, NULL, 167, NULL, NULL, 229843),
(234141, '4prxA02', NULL, NULL, 173, NULL, NULL, 229843),
(234142, '3cwvA02', NULL, NULL, 163, NULL, NULL, 229843),
(234143, '2hk2A01', NULL, NULL, 185, NULL, NULL, 229843),
(234144, '3hulB01', NULL, NULL, 169, NULL, NULL, 229843),
(234145, '5xxuQ00', NULL, NULL, 148, NULL, NULL, 229843),
(234146, '4emdA01', NULL, NULL, 175, NULL, NULL, 229843);
INSERT INTO "PUBLIC"."MODEL" VALUES
(234147, '1h7sA02', NULL, NULL, 133, NULL, NULL, 229843),
(234148, '5xyiQ00', NULL, NULL, 140, NULL, NULL, 229843),
(234149, '1vs5I00', NULL, NULL, 130, NULL, NULL, 229843),
(234150, '1qzrA02', NULL, NULL, 128, NULL, NULL, 229843),
(234151, '1uekA01', NULL, NULL, 148, NULL, NULL, 229843),
(234152, '5a2qQ00', NULL, NULL, 146, NULL, NULL, 229843),
(234153, '3k17A01', NULL, NULL, 225, NULL, NULL, 229843),
(234154, '1nz0D00', NULL, NULL, 118, NULL, NULL, 229843),
(234155, '2vqeI00', NULL, NULL, 128, NULL, NULL, 229843),
(234156, '3d4jB01', NULL, NULL, 205, NULL, NULL, 229843),
(234157, '6d1rA00', NULL, NULL, 119, NULL, NULL, 229843),
(234158, '1kkhA01', NULL, NULL, 181, NULL, NULL, 229843),
(234159, '3f0nB01', NULL, NULL, 199, NULL, NULL, 229843),
(234160, '1xhkA00', NULL, NULL, 187, NULL, NULL, 229843),
(234161, '2vqeE02', NULL, NULL, 75, NULL, NULL, 229843),
(234162, '3b82A05', NULL, NULL, 154, NULL, NULL, 229843),
(234163, '2vhoE02', NULL, NULL, 94, NULL, NULL, 229843),
(234164, '5gmdA01', NULL, NULL, 183, NULL, NULL, 229843),
(234165, '3m6aA04', NULL, NULL, 192, NULL, NULL, 229843),
(234166, '1zxmB02', NULL, NULL, 124, NULL, NULL, 229843),
(234167, '2zbkB03', NULL, NULL, 223, NULL, NULL, 229843),
(234168, '2q2eB03', NULL, NULL, 160, NULL, NULL, 229843),
(234169, '3jamC02', NULL, NULL, 94, NULL, NULL, 229843),
(234170, '4p52A01', NULL, NULL, 180, NULL, NULL, 229843),
(234171, '4hacB01', NULL, NULL, 192, NULL, NULL, 229843),
(234172, '2hkeB01', NULL, NULL, 184, NULL, NULL, 229843),
(234173, '3h4lB02', NULL, NULL, 146, NULL, NULL, 229843),
(234174, '3j7aG02', NULL, NULL, 94, NULL, NULL, 229843),
(234175, '1fi4A01', NULL, NULL, 196, NULL, NULL, 229843),
(234176, '1k0hA00', NULL, NULL, 117, NULL, NULL, 229844),
(234177, '2dy4B04', NULL, NULL, 104, NULL, NULL, 229845),
(234178, '1s5jA04', NULL, NULL, 61, NULL, NULL, 229845),
(234179, '3kd1E04', NULL, NULL, 104, NULL, NULL, 229845),
(234180, '5omvA04', NULL, NULL, 53, NULL, NULL, 229845),
(234181, '1d5aA04', NULL, NULL, 53, NULL, NULL, 229845),
(234182, '3qexA04', NULL, NULL, 104, NULL, NULL, 229845),
(234183, '4ahcA04', NULL, NULL, 53, NULL, NULL, 229845),
(234184, '4khnB04', NULL, NULL, 73, NULL, NULL, 229845),
(234185, '4i9qA04', NULL, NULL, 55, NULL, NULL, 229845),
(234186, '3k59A06', NULL, NULL, 47, NULL, NULL, 229845),
(234187, '2py5A04', NULL, NULL, 36, NULL, NULL, 229845),
(234188, '4flwA04', NULL, NULL, 53, NULL, NULL, 229845),
(234189, '1tgoA04', NULL, NULL, 53, NULL, NULL, 229845),
(234190, '2gv9A05', NULL, NULL, 59, NULL, NULL, 229845),
(234191, '2p5oC04', NULL, NULL, 58, NULL, NULL, 229845),
(234192, '6q4tA04', NULL, NULL, 53, NULL, NULL, 229845),
(234193, '5h12A04', NULL, NULL, 53, NULL, NULL, 229845),
(234194, '4fvmA06', NULL, NULL, 48, NULL, NULL, 229845),
(234195, '3df7A03', NULL, NULL, 41, NULL, NULL, 229846),
(234196, '2wscN00', NULL, NULL, 85, NULL, NULL, 229847),
(234197, '1k04A01', NULL, NULL, 38, NULL, NULL, 229848),
(234198, '2h88C01', NULL, NULL, 32, NULL, NULL, 229848),
(234199, '1pv3A01', NULL, NULL, 38, NULL, NULL, 229848),
(234200, '1ow6A01', NULL, NULL, 30, NULL, NULL, 229848),
(234201, '1zoyC01', NULL, NULL, 32, NULL, NULL, 229848),
(234202, '2g3aA01', NULL, NULL, 31, NULL, NULL, 229848),
(234203, '1to6A02', NULL, NULL, 229, NULL, NULL, 229849),
(234204, '3cwcA02', NULL, NULL, 235, NULL, NULL, 229849),
(234205, '3fcnA00', NULL, NULL, 164, NULL, NULL, 229850),
(234206, '3ieeA02', NULL, NULL, 103, NULL, NULL, 229851),
(234207, '3rh3B02', NULL, NULL, 103, NULL, NULL, 229851),
(234208, '3rh3A02', NULL, NULL, 103, NULL, NULL, 229851),
(234209, '2vfrA03', NULL, NULL, 87, NULL, NULL, 229852),
(234210, '3iv1A00', NULL, NULL, 78, NULL, NULL, 229853),
(234211, '4bjqA00', NULL, NULL, 78, NULL, NULL, 229854),
(234212, '1wkvA01', NULL, NULL, 78, NULL, NULL, 229855),
(234213, '1mtyG02', NULL, NULL, 73, NULL, NULL, 229856),
(234214, '1mhyG02', NULL, NULL, 73, NULL, NULL, 229856),
(234215, '3r9zA00', NULL, NULL, 178, NULL, NULL, 229857),
(234216, '1l3aA00', NULL, NULL, 166, NULL, NULL, 229857),
(234217, '4kooB00', NULL, NULL, 180, NULL, NULL, 229857);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(234218, '4koqA00', NULL, NULL, 180, NULL, NULL, 229857),
(234219, '2nvnA00', NULL, NULL, 122, NULL, NULL, 229857),
(234220, '2it9A00', NULL, NULL, 127, NULL, NULL, 229857),
(234221, '4aghA00', NULL, NULL, 80, NULL, NULL, 229857),
(234222, '4kopD00', NULL, NULL, 177, NULL, NULL, 229857),
(234223, '4bg7A00', NULL, NULL, 102, NULL, NULL, 229857),
(234224, '1pcfA00', NULL, NULL, 66, NULL, NULL, 229857),
(234225, '2ztbA03', NULL, NULL, 52, NULL, NULL, 229858),
(234226, '1iioA00', NULL, NULL, 84, NULL, NULL, 229859),
(234227, '1zvaA00', NULL, NULL, 77, NULL, NULL, 229860),
(234228, '3swfC00', NULL, NULL, 54, NULL, NULL, 229860),
(234229, '2bezC00', NULL, NULL, 77, NULL, NULL, 229860),
(234230, '1zv8G00', NULL, NULL, 50, NULL, NULL, 229860),
(234231, '4njlA00', NULL, NULL, 131, NULL, NULL, 229860),
(234232, '3efgA00', NULL, NULL, 58, NULL, NULL, 229860),
(234233, '1wdgB00', NULL, NULL, 94, NULL, NULL, 229860),
(234234, '1wdfA00', NULL, NULL, 95, NULL, NULL, 229860),
(234235, '5zvkA00', NULL, NULL, 80, NULL, NULL, 229860),
(234236, '4n6jA00', NULL, NULL, 50, NULL, NULL, 229860),
(234237, '1svfA00', NULL, NULL, 64, NULL, NULL, 229860),
(234238, '2ieqA00', NULL, NULL, 109, NULL, NULL, 229860),
(234239, '2fyzE00', NULL, NULL, 63, NULL, NULL, 229860),
(234240, '4n6jB00', NULL, NULL, 50, NULL, NULL, 229860),
(234241, '1wncA00', NULL, NULL, 80, NULL, NULL, 229860),
(234242, '1wncB00', NULL, NULL, 112, NULL, NULL, 229860),
(234243, '4eijA00', NULL, NULL, 65, NULL, NULL, 229860),
(234244, '3kpeA00', NULL, NULL, 51, NULL, NULL, 229860),
(234245, '4modA00', NULL, NULL, 90, NULL, NULL, 229860),
(234246, '3swyA00', NULL, NULL, 46, NULL, NULL, 229860),
(234247, '1wyyB00', NULL, NULL, 149, NULL, NULL, 229860),
(234248, '2hraB01', NULL, NULL, 102, NULL, NULL, 229861),
(234249, '2hraA01', NULL, NULL, 100, NULL, NULL, 229861),
(234250, '3mzlB02', NULL, NULL, 56, NULL, NULL, 229862),
(234251, '1wthD03', NULL, NULL, 104, NULL, NULL, 229863),
(234252, '2krxA01', NULL, NULL, 72, NULL, NULL, 229864),
(234253, '3dorA01', NULL, NULL, 145, NULL, NULL, 229865),
(234254, '1mr1D00', NULL, NULL, 99, NULL, NULL, 229866),
(234255, '1h5pA00', NULL, NULL, 95, NULL, NULL, 229866),
(234256, '5c4vF00', NULL, NULL, 102, NULL, NULL, 229866),
(234257, '1ufnA00', NULL, NULL, 94, NULL, NULL, 229866),
(234258, '1oqjA00', NULL, NULL, 97, NULL, NULL, 229866),
(234259, '4l7tA00', NULL, NULL, 506, NULL, NULL, 229867),
(234260, '4f7aA00', NULL, NULL, 511, NULL, NULL, 229867),
(234261, '5fq4A00', NULL, NULL, 463, NULL, NULL, 229867),
(234262, '3p1uA00', NULL, NULL, 529, NULL, NULL, 229867),
(234263, '3jq0A00', NULL, NULL, 493, NULL, NULL, 229867),
(234264, '3ckcA01', NULL, NULL, 230, NULL, NULL, 229867),
(234265, '4mruB00', NULL, NULL, 488, NULL, NULL, 229867),
(234266, '3l22A00', NULL, NULL, 441, NULL, NULL, 229867),
(234267, '3i4gA00', NULL, NULL, 528, NULL, NULL, 229867),
(234268, '5j90A00', NULL, NULL, 482, NULL, NULL, 229867),
(234269, '3iv0A00', NULL, NULL, 481, NULL, NULL, 229867),
(234270, '3ejnA01', NULL, NULL, 218, NULL, NULL, 229867),
(234271, '3myvA01', NULL, NULL, 237, NULL, NULL, 229867),
(234272, '3sghA00', NULL, NULL, 499, NULL, NULL, 229867),
(234273, '3fdhA01', NULL, NULL, 250, NULL, NULL, 229867),
(234274, '3cghA00', NULL, NULL, 516, NULL, NULL, 229867),
(234275, '3gzsA00', NULL, NULL, 495, NULL, NULL, 229867),
(234276, '3mcxA01', NULL, NULL, 242, NULL, NULL, 229867),
(234277, '3mx3A01', NULL, NULL, 198, NULL, NULL, 229867),
(234278, '5lx8A00', NULL, NULL, 539, NULL, NULL, 229867),
(234279, '3jq1B01', NULL, NULL, 320, NULL, NULL, 229867),
(234280, '4f53A00', NULL, NULL, 498, NULL, NULL, 229867),
(234281, '3ehmA01', NULL, NULL, 310, NULL, NULL, 229867),
(234282, '4q69B00', NULL, NULL, 462, NULL, NULL, 229867),
(234283, '3kezA01', NULL, NULL, 235, NULL, NULL, 229867),
(234284, '3jysA01', NULL, NULL, 237, NULL, NULL, 229867),
(234285, '4lerA01', NULL, NULL, 209, NULL, NULL, 229867),
(234286, '5e75A00', NULL, NULL, 519, NULL, NULL, 229867),
(234287, '3otnA00', NULL, NULL, 482, NULL, NULL, 229867),
(234288, '3hdxA00', NULL, NULL, 478, NULL, NULL, 229867); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(234289, '4pucA00', NULL, NULL, 488, NULL, NULL, 229867),
(234290, '3snxA00', NULL, NULL, 460, NULL, NULL, 229867),
(234291, '3lewA01', NULL, NULL, 338, NULL, NULL, 229867),
(234292, '3nqpA00', NULL, NULL, 498, NULL, NULL, 229867),
(234293, '3qnkC00', NULL, NULL, 517, NULL, NULL, 229867),
(234294, '3q9tA02', NULL, NULL, 322, NULL, NULL, 229868),
(234295, '1gpeA03', NULL, NULL, 302, NULL, NULL, 229868),
(234296, '5oc1A02', NULL, NULL, 310, NULL, NULL, 229868),
(234297, '4ha6A02', NULL, NULL, 263, NULL, NULL, 229868),
(234298, '4h7uA02', NULL, NULL, 311, NULL, NULL, 229868),
(234299, '3qvpA03', NULL, NULL, 302, NULL, NULL, 229868),
(234300, '2psmC01', NULL, NULL, 52, NULL, NULL, 229869),
(234301, '3iu3I02', NULL, NULL, 59, NULL, NULL, 229869),
(234302, '2z3qD01', NULL, NULL, 55, NULL, NULL, 229869),
(234303, '2b5iD02', NULL, NULL, 60, NULL, NULL, 229869),
(234304, '4ie5A02', NULL, NULL, 134, NULL, NULL, 229870),
(234305, '3weeA03', NULL, NULL, 111, NULL, NULL, 229871),
(234306, '1i7wD00', NULL, NULL, 97, NULL, NULL, 229872),
(234307, '1g3jB00', NULL, NULL, 61, NULL, NULL, 229872),
(234308, '3ouxB00', NULL, NULL, 67, NULL, NULL, 229872),
(234309, '1i7wB00', NULL, NULL, 68, NULL, NULL, 229872),
(234310, '4y99B00', NULL, NULL, 74, NULL, NULL, 229873),
(234311, '1ytzT00', NULL, NULL, 107, NULL, NULL, 229873),
(234312, '4y99C01', NULL, NULL, 118, NULL, NULL, 229873),
(234313, '1ytzI01', NULL, NULL, 127, NULL, NULL, 229873),
(234314, '1j1eF00', NULL, NULL, 161, NULL, NULL, 229873),
(234315, '1j1dE00', NULL, NULL, 89, NULL, NULL, 229873),
(234316, '6f9wA00', NULL, NULL, 87, NULL, NULL, 229874),
(234317, '3jb9b00', NULL, NULL, 87, NULL, NULL, 229874),
(234318, '1ycyB00', NULL, NULL, 71, NULL, NULL, 229874),
(234319, '2rb6A00', NULL, NULL, 61, NULL, NULL, 229874),
(234320, '3jb9Z00', NULL, NULL, 81, NULL, NULL, 229874),
(234321, '4c92A00', NULL, NULL, 130, NULL, NULL, 229874),
(234322, '2ra2E00', NULL, NULL, 64, NULL, NULL, 229874),
(234323, '4emkB00', NULL, NULL, 75, NULL, NULL, 229874),
(234324, '2ra2A00', NULL, NULL, 64, NULL, NULL, 229874),
(234325, '3jb9J00', NULL, NULL, 77, NULL, NULL, 229874),
(234326, '2rm4A01', NULL, NULL, 66, NULL, NULL, 229874),
(234327, '1b34B00', NULL, NULL, 93, NULL, NULL, 229874),
(234328, '4c8qA00', NULL, NULL, 101, NULL, NULL, 229874),
(234329, '2eayB02', NULL, NULL, 49, NULL, NULL, 229874),
(234330, '3jb9F00', NULL, NULL, 82, NULL, NULL, 229874),
(234331, '3fifB00', NULL, NULL, 61, NULL, NULL, 229874),
(234332, '1mgqF00', NULL, NULL, 83, NULL, NULL, 229874),
(234333, '3fifF00', NULL, NULL, 61, NULL, NULL, 229874),
(234334, '5szdC00', NULL, NULL, 83, NULL, NULL, 229874),
(234335, '4emhA00', NULL, NULL, 60, NULL, NULL, 229874),
(234336, '4a54A00', NULL, NULL, 96, NULL, NULL, 229874),
(234337, '4f7uG00', NULL, NULL, 76, NULL, NULL, 229874),
(234338, '2jn0A00', NULL, NULL, 61, NULL, NULL, 229874),
(234339, '1i8fA00', NULL, NULL, 81, NULL, NULL, 229874),
(234340, '4m7dI00', NULL, NULL, 95, NULL, NULL, 229874),
(234341, '4f7uC00', NULL, NULL, 82, NULL, NULL, 229874),
(234342, '6bk8o00', NULL, NULL, 85, NULL, NULL, 229874),
(234343, '6gwkR00', NULL, NULL, 82, NULL, NULL, 229874),
(234344, '2ej9A02', NULL, NULL, 49, NULL, NULL, 229874),
(234345, '4m7dA00', NULL, NULL, 67, NULL, NULL, 229874),
(234346, '1ljoA00', NULL, NULL, 77, NULL, NULL, 229874),
(234347, '3bfmA02', NULL, NULL, 44, NULL, NULL, 229874),
(234348, '2vc8A00', NULL, NULL, 84, NULL, NULL, 229874),
(234349, '3hsbB00', NULL, NULL, 78, NULL, NULL, 229874),
(234350, '4c92F00', NULL, NULL, 86, NULL, NULL, 229874),
(234351, '2rb6B00', NULL, NULL, 61, NULL, NULL, 229874),
(234352, '4c92B00', NULL, NULL, 105, NULL, NULL, 229874),
(234353, '1ycyA00', NULL, NULL, 71, NULL, NULL, 229874),
(234354, '1y96D00', NULL, NULL, 85, NULL, NULL, 229874),
(234355, '1i4kC00', NULL, NULL, 77, NULL, NULL, 229874),
(234356, '4a53A01', NULL, NULL, 62, NULL, NULL, 229874),
(234357, '4emgA00', NULL, NULL, 93, NULL, NULL, 229874),
(234358, '2ra2F00', NULL, NULL, 64, NULL, NULL, 229874),
(234359, '2fb7A00', NULL, NULL, 95, NULL, NULL, 229874);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(234360, '2ra2B00', NULL, NULL, 64, NULL, NULL, 229874),
(234361, '6bk8d00', NULL, NULL, 77, NULL, NULL, 229874),
(234362, '3jb9I00', NULL, NULL, 78, NULL, NULL, 229874),
(234363, '3swnS00', NULL, NULL, 82, NULL, NULL, 229874),
(234364, '3fifC00', NULL, NULL, 61, NULL, NULL, 229874),
(234365, '3bduA00', NULL, NULL, 62, NULL, NULL, 229874),
(234366, '4y91F00', NULL, NULL, 75, NULL, NULL, 229874),
(234367, '3pggA00', NULL, NULL, 97, NULL, NULL, 229874),
(234368, '3fifG00', NULL, NULL, 61, NULL, NULL, 229874),
(234369, '3swnC00', NULL, NULL, 88, NULL, NULL, 229874),
(234370, '4f7uF00', NULL, NULL, 86, NULL, NULL, 229874),
(234371, '4f7uB00', NULL, NULL, 97, NULL, NULL, 229874),
(234372, '4xq3B00', NULL, NULL, 91, NULL, NULL, 229874),
(234373, '1m5q101', NULL, NULL, 68, NULL, NULL, 229874),
(234374, '1ycyD00', NULL, NULL, 71, NULL, NULL, 229874),
(234375, '4c92G00', NULL, NULL, 90, NULL, NULL, 229874),
(234376, '1n9rB00', NULL, NULL, 69, NULL, NULL, 229874),
(234377, '1d3bC00', NULL, NULL, 75, NULL, NULL, 229874),
(234378, '1y96A00', NULL, NULL, 86, NULL, NULL, 229874),
(234379, '4c92C00', NULL, NULL, 89, NULL, NULL, 229874),
(234380, '1th7A00', NULL, NULL, 81, NULL, NULL, 229874),
(234381, '4xtvB02', NULL, NULL, 48, NULL, NULL, 229874),
(234382, '2ra2C00', NULL, NULL, 64, NULL, NULL, 229874),
(234383, '4wf2A03', NULL, NULL, 57, NULL, NULL, 229874),
(234384, '4pjoQ00', NULL, NULL, 91, NULL, NULL, 229874),
(234385, '5gmkm00', NULL, NULL, 109, NULL, NULL, 229874),
(234386, '3jb9H00', NULL, NULL, 84, NULL, NULL, 229874),
(234387, '4jliA00', NULL, NULL, 68, NULL, NULL, 229874),
(234388, '5gmke00', NULL, NULL, 67, NULL, NULL, 229874),
(234389, '4x9cD00', NULL, NULL, 71, NULL, NULL, 229874),
(234390, '5gan800', NULL, NULL, 67, NULL, NULL, 229874),
(234391, '6bk8q00', NULL, NULL, 110, NULL, NULL, 229874),
(234392, '2ylbC00', NULL, NULL, 74, NULL, NULL, 229874),
(234393, '3fifD00', NULL, NULL, 61, NULL, NULL, 229874),
(234394, '1kq1H00', NULL, NULL, 77, NULL, NULL, 229874),
(234395, '3rkxA03', NULL, NULL, 47, NULL, NULL, 229874),
(234396, '4f7uE00', NULL, NULL, 92, NULL, NULL, 229874),
(234397, '3fifH00', NULL, NULL, 61, NULL, NULL, 229874),
(234398, '6j6gi00', NULL, NULL, 94, NULL, NULL, 229874),
(234399, '4nl2B00', NULL, NULL, 77, NULL, NULL, 229874),
(234400, '3hfoB00', NULL, NULL, 70, NULL, NULL, 229874),
(234401, '4m7dC00', NULL, NULL, 89, NULL, NULL, 229874),
(234402, '3sb2A00', NULL, NULL, 79, NULL, NULL, 229874),
(234403, '2rd1B00', NULL, NULL, 62, NULL, NULL, 229874),
(234404, '4m78N00', NULL, NULL, 93, NULL, NULL, 229874),
(234405, '1d3bB00', NULL, NULL, 91, NULL, NULL, 229874),
(234406, '1ycyC00', NULL, NULL, 71, NULL, NULL, 229874),
(234407, '2k57A00', NULL, NULL, 61, NULL, NULL, 229874),
(234408, '2ra2D00', NULL, NULL, 64, NULL, NULL, 229874),
(234409, '4emkA00', NULL, NULL, 75, NULL, NULL, 229874),
(234410, '3hfnA00', NULL, NULL, 72, NULL, NULL, 229874),
(234411, '3by7E00', NULL, NULL, 100, NULL, NULL, 229874),
(234412, '2i2lB02', NULL, NULL, 71, NULL, NULL, 229874),
(234413, '1h64100', NULL, NULL, 75, NULL, NULL, 229874),
(234414, '5caiA00', NULL, NULL, 56, NULL, NULL, 229874),
(234415, '4m75F00', NULL, NULL, 115, NULL, NULL, 229874),
(234416, '2e10A02', NULL, NULL, 48, NULL, NULL, 229874),
(234417, '4m77A00', NULL, NULL, 109, NULL, NULL, 229874),
(234418, '5mkiH00', NULL, NULL, 72, NULL, NULL, 229874),
(234419, '2vxeA00', NULL, NULL, 88, NULL, NULL, 229874),
(234420, '3fifA00', NULL, NULL, 61, NULL, NULL, 229874),
(234421, '1hxdA03', NULL, NULL, 43, NULL, NULL, 229874),
(234422, '3fb9B00', NULL, NULL, 90, NULL, NULL, 229874),
(234423, '3inzF00', NULL, NULL, 82, NULL, NULL, 229874),
(234424, '3fifE00', NULL, NULL, 61, NULL, NULL, 229874),
(234425, '6j6gh00', NULL, NULL, 86, NULL, NULL, 229874),
(234426, '3jb9l00', NULL, NULL, 97, NULL, NULL, 229874),
(234427, '4m7dL00', NULL, NULL, 93, NULL, NULL, 229874),
(234428, '3q1pA01', NULL, NULL, 40, NULL, NULL, 229875),
(234429, '3pieC05', NULL, NULL, 172, NULL, NULL, 229876),
(234430, '2dkhA03', NULL, NULL, 213, NULL, NULL, 229877),
(234431, '1pn0A03', NULL, NULL, 209, NULL, NULL, 229877);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(234432, '4fixA01', NULL, NULL, 403, NULL, NULL, 229878),
(234433, '4aybA04', NULL, NULL, 74, NULL, NULL, 229879),
(234434, '3gnfB06', NULL, NULL, 51, NULL, NULL, 229880),
(234435, '3gnfB02', NULL, NULL, 62, NULL, NULL, 229880),
(234436, '2zuoA02', NULL, NULL, 54, NULL, NULL, 229880),
(234437, '5xogD02', NULL, NULL, 128, NULL, NULL, 229881),
(234438, '2c35A00', NULL, NULL, 129, NULL, NULL, 229881),
(234439, '1y14A01', NULL, NULL, 128, NULL, NULL, 229881),
(234440, '3h0gD00', NULL, NULL, 135, NULL, NULL, 229881),
(234441, '2ckzC01', NULL, NULL, 123, NULL, NULL, 229881),
(234442, '3ayhA00', NULL, NULL, 136, NULL, NULL, 229881),
(234443, '2qupA00', NULL, NULL, 122, NULL, NULL, 229882),
(234444, '2p61A00', NULL, NULL, 127, NULL, NULL, 229882),
(234445, '4k05A02', NULL, NULL, 154, NULL, NULL, 229883),
(234446, '4lr4A01', NULL, NULL, 186, NULL, NULL, 229884),
(234447, '2ebfX04', NULL, NULL, 253, NULL, NULL, 229885),
(234448, '2g5gX01', NULL, NULL, 209, NULL, NULL, 229885),
(234449, '4pwwA00', NULL, NULL, 89, NULL, NULL, 229886),
(234450, '2vqeJ00', NULL, NULL, 105, NULL, NULL, 229886),
(234451, '5mmjj00', NULL, NULL, 99, NULL, NULL, 229886),
(234452, '4hhuA02', NULL, NULL, 88, NULL, NULL, 229886),
(234453, '4hhuA01', NULL, NULL, 82, NULL, NULL, 229886),
(234454, '2mewA00', NULL, NULL, 82, NULL, NULL, 229886),
(234455, '5o5jJ00', NULL, NULL, 101, NULL, NULL, 229886),
(234456, '5xyiU00', NULL, NULL, 103, NULL, NULL, 229886),
(234457, '6az1M00', NULL, NULL, 116, NULL, NULL, 229886),
(234458, '3d3bJ00', NULL, NULL, 87, NULL, NULL, 229886),
(234459, '4neyA01', NULL, NULL, 84, NULL, NULL, 229886),
(234460, '4neyB01', NULL, NULL, 84, NULL, NULL, 229886),
(234461, '4neyA02', NULL, NULL, 79, NULL, NULL, 229886),
(234462, '2mq8A00', NULL, NULL, 112, NULL, NULL, 229886),
(234463, '4kyzA00', NULL, NULL, 172, NULL, NULL, 229886),
(234464, '4neyB02', NULL, NULL, 79, NULL, NULL, 229886),
(234465, '2xzmJ00', NULL, NULL, 120, NULL, NULL, 229886),
(234466, '6faiU00', NULL, NULL, 103, NULL, NULL, 229886),
(234467, '6g5iU00', NULL, NULL, 103, NULL, NULL, 229886),
(234468, '2mtlA00', NULL, NULL, 88, NULL, NULL, 229886),
(234469, '3w1yC00', NULL, NULL, 103, NULL, NULL, 229886),
(234470, '3r2cK00', NULL, NULL, 83, NULL, NULL, 229886),
(234471, '4rjvA00', NULL, NULL, 87, NULL, NULL, 229886),
(234472, '4nezA01', NULL, NULL, 76, NULL, NULL, 229886),
(234473, '4nezA02', NULL, NULL, 75, NULL, NULL, 229886),
(234474, '5xxuU00', NULL, NULL, 105, NULL, NULL, 229886),
(234475, '5optl00', NULL, NULL, 117, NULL, NULL, 229886),
(234476, '3jamU00', NULL, NULL, 117, NULL, NULL, 229886),
(234477, '3j7aN00', NULL, NULL, 98, NULL, NULL, 229886),
(234478, '1m56D00', NULL, NULL, 51, NULL, NULL, 229887),
(234479, '1qleD00', NULL, NULL, 43, NULL, NULL, 229887),
(234480, '5ca5A03', NULL, NULL, 75, NULL, NULL, 229888),
(234481, '3sdeA03', NULL, NULL, 75, NULL, NULL, 229888),
(234482, '4wiiB03', NULL, NULL, 75, NULL, NULL, 229888),
(234483, '3sdeB03', NULL, NULL, 75, NULL, NULL, 229888),
(234484, '5iplA01', NULL, NULL, 117, NULL, NULL, 229889),
(234485, '4c2mK00', NULL, NULL, 101, NULL, NULL, 229889),
(234486, '5tjgA01', NULL, NULL, 103, NULL, NULL, 229889),
(234487, '1xppD00', NULL, NULL, 115, NULL, NULL, 229889),
(234488, '5xogK00', NULL, NULL, 118, NULL, NULL, 229889),
(234489, '3h0gC01', NULL, NULL, 138, NULL, NULL, 229889),
(234490, '5xogC01', NULL, NULL, 139, NULL, NULL, 229889),
(234491, '3h0gK00', NULL, NULL, 123, NULL, NULL, 229889),
(234492, '4mexB01', NULL, NULL, 129, NULL, NULL, 229889),
(234493, '1twfK00', NULL, NULL, 120, NULL, NULL, 229889),
(234494, '2a6hA01', NULL, NULL, 103, NULL, NULL, 229889),
(234495, '4noiA01', NULL, NULL, 103, NULL, NULL, 229889),
(234496, '6dvcB01', NULL, NULL, 123, NULL, NULL, 229889),
(234497, '5tw1B01', NULL, NULL, 101, NULL, NULL, 229889),
(234498, '1twfC01', NULL, NULL, 142, NULL, NULL, 229889),
(234499, '4aybD01', NULL, NULL, 89, NULL, NULL, 229889),
(234500, '5zx3B01', NULL, NULL, 114, NULL, NULL, 229889),
(234501, '2pa8L00', NULL, NULL, 92, NULL, NULL, 229889),
(234502, '1bdfA01', NULL, NULL, 110, NULL, NULL, 229889);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(234503, '4aybL00', NULL, NULL, 92, NULL, NULL, 229889),
(234504, '2pa8D01', NULL, NULL, 89, NULL, NULL, 229889),
(234505, '6gmhK00', NULL, NULL, 117, NULL, NULL, 229889),
(234506, '6gmhC01', NULL, NULL, 144, NULL, NULL, 229889),
(234507, '4c2mC01', NULL, NULL, 164, NULL, NULL, 229889),
(234508, '4qjvB00', NULL, NULL, 94, NULL, NULL, 229889),
(234509, '4qjvA01', NULL, NULL, 89, NULL, NULL, 229889),
(234510, '4bgfF01', NULL, NULL, 183, NULL, NULL, 229890),
(234511, '4nv8A01', NULL, NULL, 177, NULL, NULL, 229890),
(234512, '3d9wB01', NULL, NULL, 191, NULL, NULL, 229890),
(234513, '1w4tA01', NULL, NULL, 181, NULL, NULL, 229890),
(234514, '4c5pA01', NULL, NULL, 183, NULL, NULL, 229890),
(234515, '4guzA01', NULL, NULL, 181, NULL, NULL, 229890),
(234516, '1w5rA01', NULL, NULL, 178, NULL, NULL, 229890),
(234517, '2a6hF01', NULL, NULL, 183, NULL, NULL, 229891),
(234518, '3ugoA00', NULL, NULL, 184, NULL, NULL, 229891),
(234519, '3levA00', NULL, NULL, 179, NULL, NULL, 229891),
(234520, '2b3tB01', NULL, NULL, 71, NULL, NULL, 229892),
(234521, '3nekB01', NULL, NULL, 125, NULL, NULL, 229893),
(234522, '3nekA02', NULL, NULL, 113, NULL, NULL, 229893),
(234523, '1l4dB00', NULL, NULL, 122, NULL, NULL, 229894),
(234524, '1l4zB00', NULL, NULL, 136, NULL, NULL, 229894),
(234525, '1qqrB00', NULL, NULL, 138, NULL, NULL, 229894),
(234526, '4it5A02', NULL, NULL, 93, NULL, NULL, 229895),
(234527, '3bvoA02', NULL, NULL, 86, NULL, NULL, 229895),
(234528, '2rkhA02', NULL, NULL, 78, NULL, NULL, 229895),
(234529, '1n1cB02', NULL, NULL, 89, NULL, NULL, 229895),
(234530, '4it5C02', NULL, NULL, 93, NULL, NULL, 229895),
(234531, '3uo3A02', NULL, NULL, 86, NULL, NULL, 229895),
(234532, '3hhoA02', NULL, NULL, 93, NULL, NULL, 229895),
(234533, '3hhoC02', NULL, NULL, 93, NULL, NULL, 229895),
(234534, '1fpoC02', NULL, NULL, 91, NULL, NULL, 229895),
(234535, '2lp4A01', NULL, NULL, 145, NULL, NULL, 229896),
(234536, '1tqgA00', NULL, NULL, 105, NULL, NULL, 229896),
(234537, '4pacA00', NULL, NULL, 159, NULL, NULL, 229896),
(234538, '4eukB00', NULL, NULL, 159, NULL, NULL, 229896),
(234539, '4g78A00', NULL, NULL, 152, NULL, NULL, 229896),
(234540, '2r25A00', NULL, NULL, 167, NULL, NULL, 229896),
(234541, '2ld6A00', NULL, NULL, 139, NULL, NULL, 229896),
(234542, '3myfA00', NULL, NULL, 119, NULL, NULL, 229896),
(234543, '3us6A00', NULL, NULL, 153, NULL, NULL, 229896),
(234544, '1i5nD00', NULL, NULL, 146, NULL, NULL, 229896),
(234545, '2a0bA00', NULL, NULL, 125, NULL, NULL, 229896),
(234546, '3u3bA00', NULL, NULL, 113, NULL, NULL, 229896),
(234547, '3iqtA01', NULL, NULL, 114, NULL, NULL, 229896),
(234548, '1sr2A00', NULL, NULL, 116, NULL, NULL, 229896),
(234549, '3kyjA00', NULL, NULL, 144, NULL, NULL, 229896),
(234550, '1y6dA00', NULL, NULL, 120, NULL, NULL, 229896),
(234551, '2oocB00', NULL, NULL, 113, NULL, NULL, 229896),
(234552, '1yviB00', NULL, NULL, 149, NULL, NULL, 229896),
(234553, '1wn0C00', NULL, NULL, 145, NULL, NULL, 229896),
(234554, '3kwlA02', NULL, NULL, 113, NULL, NULL, 229897),
(234555, '4opxA01', NULL, NULL, 91, NULL, NULL, 229898),
(234556, '3odcA00', NULL, NULL, 111, NULL, NULL, 229898),
(234557, '2l31A00', NULL, NULL, 112, NULL, NULL, 229898),
(234558, '3od8F00', NULL, NULL, 92, NULL, NULL, 229898),
(234559, '1uw0A01', NULL, NULL, 96, NULL, NULL, 229898),
(234560, '1v9xA00', NULL, NULL, 114, NULL, NULL, 229898),
(234561, '2zktA02', NULL, NULL, 99, NULL, NULL, 229899),
(234562, '4h63H04', NULL, NULL, 30, NULL, NULL, 229900),
(234563, '2bezF00', NULL, NULL, 42, NULL, NULL, 229900),
(234564, '2beqD00', NULL, NULL, 48, NULL, NULL, 229900),
(234565, '1e2tA01', NULL, NULL, 73, NULL, NULL, 229901),
(234566, '1lmlA02', NULL, NULL, 124, NULL, NULL, 229902),
(234567, '5yacA01', NULL, NULL, 59, NULL, NULL, 229903),
(234568, '2yx1A01', NULL, NULL, 67, NULL, NULL, 229903),
(234569, '4hceA00', NULL, NULL, 131, NULL, NULL, 229904),
(234570, '1oltA02', NULL, NULL, 94, NULL, NULL, 229905),
(234571, '4xgwA00', NULL, NULL, 340, NULL, NULL, 229906),
(234572, '1vrmA01', NULL, NULL, 208, NULL, NULL, 229906),
(234573, '3pndB00', NULL, NULL, 337, NULL, NULL, 229906);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(234574, '6nxiA00', NULL, NULL, 328, NULL, NULL, 229906),
(234575, '5mgyA00', NULL, NULL, 332, NULL, NULL, 229906),
(234576, '2o34A00', NULL, NULL, 250, NULL, NULL, 229906),
(234577, '4xduA00', NULL, NULL, 340, NULL, NULL, 229906),
(234578, '4lgdB02', NULL, NULL, 95, NULL, NULL, 229907),
(234579, '4lgdD02', NULL, NULL, 68, NULL, NULL, 229907),
(234580, '3lczA00', NULL, NULL, 53, NULL, NULL, 229908),
(234581, '2bx9A00', NULL, NULL, 53, NULL, NULL, 229908),
(234582, '1uvjA03', NULL, NULL, 176, NULL, NULL, 229909),
(234583, '1hi8A03', NULL, NULL, 176, NULL, NULL, 229909),
(234584, '3mp7A00', NULL, NULL, 457, NULL, NULL, 229910),
(234585, '5awwY00', NULL, NULL, 424, NULL, NULL, 229910),
(234586, '1rh5A00', NULL, NULL, 436, NULL, NULL, 229910),
(234587, '3rsiB01', NULL, NULL, 71, NULL, NULL, 229911),
(234588, '3sxmA00', NULL, NULL, 140, NULL, NULL, 229912),
(234589, '2di3B02', NULL, NULL, 163, NULL, NULL, 229912),
(234590, '3c7jA02', NULL, NULL, 146, NULL, NULL, 229912),
(234591, '2hs5A02', NULL, NULL, 146, NULL, NULL, 229912),
(234592, '3ihuA02', NULL, NULL, 141, NULL, NULL, 229912),
(234593, '3sxyA02', NULL, NULL, 141, NULL, NULL, 229912),
(234594, '1hw1A02', NULL, NULL, 160, NULL, NULL, 229912),
(234595, '4p9fA02', NULL, NULL, 145, NULL, NULL, 229912),
(234596, '5tpmB00', NULL, NULL, 141, NULL, NULL, 229912),
(234597, '4le7A01', NULL, NULL, 186, NULL, NULL, 229913),
(234598, '2ezvA02', NULL, NULL, 70, NULL, NULL, 229914),
(234599, '2fo1D00', NULL, NULL, 67, NULL, NULL, 229915),
(234600, '1kafA00', NULL, NULL, 108, NULL, NULL, 229916),
(234601, '3qugA00', NULL, NULL, 126, NULL, NULL, 229917),
(234602, '3rurD00', NULL, NULL, 121, NULL, NULL, 229917),
(234603, '2o6pA00', NULL, NULL, 123, NULL, NULL, 229917),
(234604, '2q7aA00', NULL, NULL, 152, NULL, NULL, 229917),
(234605, '5d1zI00', NULL, NULL, 157, NULL, NULL, 229917),
(234606, '3qzmA00', NULL, NULL, 127, NULL, NULL, 229917),
(234607, '4ympA00', NULL, NULL, 130, NULL, NULL, 229917),
(234608, '2moqA00', NULL, NULL, 163, NULL, NULL, 229917),
(234609, '3rurC00', NULL, NULL, 121, NULL, NULL, 229917),
(234610, '3rurB00', NULL, NULL, 121, NULL, NULL, 229917),
(234611, '3sz6A00', NULL, NULL, 121, NULL, NULL, 229917),
(234612, '3rurA00', NULL, NULL, 121, NULL, NULL, 229917),
(234613, '3rtlB00', NULL, NULL, 121, NULL, NULL, 229917),
(234614, '4mypA00', NULL, NULL, 122, NULL, NULL, 229917),
(234615, '4h8qA00', NULL, NULL, 129, NULL, NULL, 229917),
(234616, '2o1aA00', NULL, NULL, 126, NULL, NULL, 229917),
(234617, '3ovuB00', NULL, NULL, 146, NULL, NULL, 229917),
(234618, '4fc3E00', NULL, NULL, 144, NULL, NULL, 229917),
(234619, '6fqcA02', NULL, NULL, 44, NULL, NULL, 229918),
(234620, '2jn4A00', NULL, NULL, 66, NULL, NULL, 229919),
(234621, '3txaA01', NULL, NULL, 215, NULL, NULL, 229920),
(234622, '2ww8A02', NULL, NULL, 198, NULL, NULL, 229920),
(234623, '3k6eA00', NULL, NULL, 156, NULL, NULL, 229921),
(234624, '2pfiB01', NULL, NULL, 151, NULL, NULL, 229921),
(234625, '1pvmA00', NULL, NULL, 184, NULL, NULL, 229921),
(234626, '3gbyA00', NULL, NULL, 128, NULL, NULL, 229921),
(234627, '2o16B00', NULL, NULL, 160, NULL, NULL, 229921),
(234628, '3k2vA00', NULL, NULL, 130, NULL, NULL, 229921),
(234629, '3l2bA01', NULL, NULL, 129, NULL, NULL, 229921),
(234630, '2yvyA02', NULL, NULL, 123, NULL, NULL, 229921),
(234631, '3sl7A00', NULL, NULL, 161, NULL, NULL, 229921),
(234632, '3ocmB00', NULL, NULL, 155, NULL, NULL, 229921),
(234633, '2yziA00', NULL, NULL, 138, NULL, NULL, 229921),
(234634, '1o50A00', NULL, NULL, 157, NULL, NULL, 229921),
(234635, '4fxsA02', NULL, NULL, 115, NULL, NULL, 229921),
(234636, '2uv4A00', NULL, NULL, 152, NULL, NULL, 229921),
(234637, '4o9kA00', NULL, NULL, 130, NULL, NULL, 229921),
(234638, '3ocoA00', NULL, NULL, 153, NULL, NULL, 229921),
(234639, '2yzqA02', NULL, NULL, 129, NULL, NULL, 229921),
(234640, '2yzqA01', NULL, NULL, 121, NULL, NULL, 229921),
(234641, '3lhhA01', NULL, NULL, 105, NULL, NULL, 229921),
(234642, '1yavB00', NULL, NULL, 159, NULL, NULL, 229921),
(234643, '3fnaA00', NULL, NULL, 128, NULL, NULL, 229921),
(234644, '4esyB00', NULL, NULL, 170, NULL, NULL, 229921);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(234645, '4iy3B00', NULL, NULL, 153, NULL, NULL, 229921),
(234646, '3i8nB00', NULL, NULL, 130, NULL, NULL, 229921),
(234647, '2ouxA02', NULL, NULL, 129, NULL, NULL, 229921),
(234648, '3orgA02', NULL, NULL, 133, NULL, NULL, 229921),
(234649, '3fhmB00', NULL, NULL, 126, NULL, NULL, 229921),
(234650, '4dqwA02', NULL, NULL, 113, NULL, NULL, 229921),
(234651, '2qrdE01', NULL, NULL, 181, NULL, NULL, 229921),
(234652, '2ef7A00', NULL, NULL, 133, NULL, NULL, 229921),
(234653, '4nocD00', NULL, NULL, 151, NULL, NULL, 229921),
(234654, '2qrdE02', NULL, NULL, 153, NULL, NULL, 229921),
(234655, '3kh5A02', NULL, NULL, 136, NULL, NULL, 229921),
(234656, '2nycA00', NULL, NULL, 144, NULL, NULL, 229921),
(234657, '5iipD00', NULL, NULL, 117, NULL, NULL, 229921),
(234658, '3kh5A01', NULL, NULL, 144, NULL, NULL, 229921),
(234659, '2d4zB00', NULL, NULL, 177, NULL, NULL, 229921),
(234660, '4gqwA00', NULL, NULL, 152, NULL, NULL, 229921),
(234661, '3oi8A01', NULL, NULL, 91, NULL, NULL, 229921),
(234662, '1y5hA00', NULL, NULL, 133, NULL, NULL, 229921),
(234663, '3fv6A00', NULL, NULL, 159, NULL, NULL, 229921),
(234664, '3k2vB00', NULL, NULL, 129, NULL, NULL, 229921),
(234665, '2emqA00', NULL, NULL, 157, NULL, NULL, 229921),
(234666, '3pc3A03', NULL, NULL, 156, NULL, NULL, 229921),
(234667, '4uuuA00', NULL, NULL, 139, NULL, NULL, 229921),
(234668, '3ocoB00', NULL, NULL, 153, NULL, NULL, 229921),
(234669, '2yziB00', NULL, NULL, 138, NULL, NULL, 229921),
(234670, '4cooA03', NULL, NULL, 143, NULL, NULL, 229921),
(234671, '3hf7A00', NULL, NULL, 130, NULL, NULL, 229921),
(234672, '3t4nC01', NULL, NULL, 186, NULL, NULL, 229921),
(234673, '2rc3C00', NULL, NULL, 135, NULL, NULL, 229921),
(234674, '3fnaB00', NULL, NULL, 127, NULL, NULL, 229921),
(234675, '4pcuB03', NULL, NULL, 142, NULL, NULL, 229921),
(234676, '2p9mB00', NULL, NULL, 138, NULL, NULL, 229921),
(234677, '4iysA00', NULL, NULL, 156, NULL, NULL, 229921),
(234678, '4l3vA03', NULL, NULL, 154, NULL, NULL, 229921),
(234679, '3lqnA00', NULL, NULL, 150, NULL, NULL, 229921),
(234680, '3lv9A00', NULL, NULL, 131, NULL, NULL, 229921),
(234681, '5ks7A00', NULL, NULL, 126, NULL, NULL, 229921),
(234682, '1xkfB00', NULL, NULL, 133, NULL, NULL, 229921),
(234683, '5tqqA02', NULL, NULL, 158, NULL, NULL, 229921),
(234684, '3fhmA00', NULL, NULL, 165, NULL, NULL, 229921),
(234685, '5k24C00', NULL, NULL, 153, NULL, NULL, 229921),
(234686, '3kxrA02', NULL, NULL, 126, NULL, NULL, 229921),
(234687, '2rihA00', NULL, NULL, 141, NULL, NULL, 229921),
(234688, '2ef7B00', NULL, NULL, 133, NULL, NULL, 229921),
(234689, '3ddjA02', NULL, NULL, 144, NULL, NULL, 229921),
(234690, '2d4zA00', NULL, NULL, 175, NULL, NULL, 229921),
(234691, '4fryB00', NULL, NULL, 157, NULL, NULL, 229921),
(234692, '4hg0A01', NULL, NULL, 147, NULL, NULL, 229921),
(234693, '3kpbA00', NULL, NULL, 122, NULL, NULL, 229921),
(234694, '1pbjA00', NULL, NULL, 125, NULL, NULL, 229921),
(234695, '3ddjA01', NULL, NULL, 152, NULL, NULL, 229921),
(234696, '3tw8A02', NULL, NULL, 164, NULL, NULL, 229922),
(234697, '4e54B01', NULL, NULL, 85, NULL, NULL, 229923),
(234698, '5irqD00', NULL, NULL, 494, NULL, NULL, 229924),
(234699, '2fdvC00', NULL, NULL, 476, NULL, NULL, 229924),
(234700, '5hiwA00', NULL, NULL, 398, NULL, NULL, 229924),
(234701, '4r21B00', NULL, NULL, 449, NULL, NULL, 229924),
(234702, '2xbkA00', NULL, NULL, 404, NULL, NULL, 229924),
(234703, '5y1iB00', NULL, NULL, 403, NULL, NULL, 229924),
(234704, '5it1A00', NULL, NULL, 399, NULL, NULL, 229924),
(234705, '2uuqA00', NULL, NULL, 414, NULL, NULL, 229924),
(234706, '3s79A00', NULL, NULL, 459, NULL, NULL, 229924),
(234707, '3mzsA00', NULL, NULL, 486, NULL, NULL, 229924),
(234708, '4yt3A00', NULL, NULL, 410, NULL, NULL, 229924),
(234709, '3abbA00', NULL, NULL, 408, NULL, NULL, 229924),
(234710, '5yqaA00', NULL, NULL, 393, NULL, NULL, 229924),
(234711, '5kyoA00', NULL, NULL, 399, NULL, NULL, 229924),
(234712, '5h1zA00', NULL, NULL, 407, NULL, NULL, 229924),
(234713, '1cptA00', NULL, NULL, 428, NULL, NULL, 229924),
(234714, '5e0eA00', NULL, NULL, 463, NULL, NULL, 229924),
(234715, '5li7A00', NULL, NULL, 414, NULL, NULL, 229924);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(234716, '4yzrA00', NULL, NULL, 405, NULL, NULL, 229924),
(234717, '2rfbA00', NULL, NULL, 343, NULL, NULL, 229924),
(234718, '5hh3C00', NULL, NULL, 397, NULL, NULL, 229924),
(234719, '5yhjB00', NULL, NULL, 413, NULL, NULL, 229924),
(234720, '2z3tA00', NULL, NULL, 425, NULL, NULL, 229924),
(234721, '2wm5A00', NULL, NULL, 435, NULL, NULL, 229924),
(234722, '3mgxB00', NULL, NULL, 391, NULL, NULL, 229924),
(234723, '6fyjA00', NULL, NULL, 421, NULL, NULL, 229924),
(234724, '4dvqL00', NULL, NULL, 483, NULL, NULL, 229924),
(234725, '5ofqD00', NULL, NULL, 409, NULL, NULL, 229924),
(234726, '3tktA00', NULL, NULL, 427, NULL, NULL, 229924),
(234727, '5tl8A00', NULL, NULL, 466, NULL, NULL, 229924),
(234728, '2nnjA00', NULL, NULL, 476, NULL, NULL, 229924),
(234729, '3k9vA00', NULL, NULL, 464, NULL, NULL, 229924),
(234730, '2jjnA00', NULL, NULL, 395, NULL, NULL, 229924),
(234731, '1z8oA00', NULL, NULL, 404, NULL, NULL, 229924),
(234732, '5a5iA00', NULL, NULL, 477, NULL, NULL, 229924),
(234733, '3v8dB00', NULL, NULL, 491, NULL, NULL, 229924),
(234734, '5cweA00', NULL, NULL, 393, NULL, NULL, 229924),
(234735, '4j6cA00', NULL, NULL, 410, NULL, NULL, 229924),
(234736, '5fyfA00', NULL, NULL, 422, NULL, NULL, 229924),
(234737, '3czhA00', NULL, NULL, 481, NULL, NULL, 229924),
(234738, '4y8wA00', NULL, NULL, 466, NULL, NULL, 229924),
(234739, '3tbgB00', NULL, NULL, 479, NULL, NULL, 229924),
(234740, '2yooA00', NULL, NULL, 407, NULL, NULL, 229924),
(234741, '5xjnA00', NULL, NULL, 404, NULL, NULL, 229924),
(234742, '3b98B00', NULL, NULL, 475, NULL, NULL, 229924),
(234743, '3qi8A00', NULL, NULL, 472, NULL, NULL, 229924),
(234744, '3zpiA00', NULL, NULL, 406, NULL, NULL, 229924),
(234745, '3n9yB00', NULL, NULL, 487, NULL, NULL, 229924),
(234746, '3ivyA00', NULL, NULL, 414, NULL, NULL, 229924),
(234747, '6cvcA00', NULL, NULL, 433, NULL, NULL, 229924),
(234748, '3oftA00', NULL, NULL, 396, NULL, NULL, 229924),
(234749, '4z5pA00', NULL, NULL, 400, NULL, NULL, 229924),
(234750, '3pm0A00', NULL, NULL, 463, NULL, NULL, 229924),
(234751, '5l1rA00', NULL, NULL, 401, NULL, NULL, 229924),
(234752, '4rm4A00', NULL, NULL, 375, NULL, NULL, 229924),
(234753, '1s1fA00', NULL, NULL, 406, NULL, NULL, 229924),
(234754, '3abaA00', NULL, NULL, 403, NULL, NULL, 229924),
(234755, '1nr6A00', NULL, NULL, 473, NULL, NULL, 229924),
(234756, '5e58B00', NULL, NULL, 465, NULL, NULL, 229924),
(234757, '4apyA00', NULL, NULL, 415, NULL, NULL, 229924),
(234758, '1uedA00', NULL, NULL, 406, NULL, NULL, 229924),
(234759, '2ve3B00', NULL, NULL, 444, NULL, NULL, 229924),
(234760, '2wiyA00', NULL, NULL, 394, NULL, NULL, 229924),
(234761, '3r9bA00', NULL, NULL, 418, NULL, NULL, 229924),
(234762, '3qz1D00', NULL, NULL, 468, NULL, NULL, 229924),
(234763, '1n40A00', NULL, NULL, 396, NULL, NULL, 229924),
(234764, '3dskB00', NULL, NULL, 471, NULL, NULL, 229924),
(234765, '4ejiA00', NULL, NULL, 476, NULL, NULL, 229924),
(234766, '1io7A00', NULL, NULL, 368, NULL, NULL, 229924),
(234767, '4c9lA00', NULL, NULL, 421, NULL, NULL, 229924),
(234768, '1izoA00', NULL, NULL, 417, NULL, NULL, 229924),
(234769, '4c27B00', NULL, NULL, 467, NULL, NULL, 229924),
(234770, '4l6gA00', NULL, NULL, 398, NULL, NULL, 229924),
(234771, '4ze1A01', NULL, NULL, 487, NULL, NULL, 229924),
(234772, '1lfkA00', NULL, NULL, 398, NULL, NULL, 229924),
(234773, '4dxyA00', NULL, NULL, 417, NULL, NULL, 229924),
(234774, '1q5dA00', NULL, NULL, 419, NULL, NULL, 229924),
(234775, '4i8vD00', NULL, NULL, 491, NULL, NULL, 229924),
(234776, '4z5qA00', NULL, NULL, 391, NULL, NULL, 229924),
(234777, '5ex6C00', NULL, NULL, 393, NULL, NULL, 229924),
(234778, '6f0cA00', NULL, NULL, 395, NULL, NULL, 229924),
(234779, '3p3oA00', NULL, NULL, 416, NULL, NULL, 229924),
(234780, '5xw2A00', NULL, NULL, 399, NULL, NULL, 229924),
(234781, '2zbxA00', NULL, NULL, 412, NULL, NULL, 229924),
(234782, '2xkrA00', NULL, NULL, 398, NULL, NULL, 229924),
(234783, '3wvsA00', NULL, NULL, 401, NULL, NULL, 229924),
(234784, '6b82A00', NULL, NULL, 469, NULL, NULL, 229924),
(234785, '3b4xA00', NULL, NULL, 367, NULL, NULL, 229924),
(234786, '6m7xB00', NULL, NULL, 484, NULL, NULL, 229924);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(234787, '3bujA00', NULL, NULL, 397, NULL, NULL, 229924),
(234788, '5ysmA00', NULL, NULL, 402, NULL, NULL, 229924),
(234789, '6f8aA00', NULL, NULL, 400, NULL, NULL, 229924),
(234790, '5m0nA00', NULL, NULL, 428, NULL, NULL, 229924),
(234791, '2cibA00', NULL, NULL, 455, NULL, NULL, 229924),
(234792, '5vwsA00', NULL, NULL, 393, NULL, NULL, 229924),
(234793, '2y5nB00', NULL, NULL, 400, NULL, NULL, 229924),
(234794, '2yjnB00', NULL, NULL, 362, NULL, NULL, 229924),
(234795, '3l4dD00', NULL, NULL, 453, NULL, NULL, 229924),
(234796, '4dtyA00', NULL, NULL, 469, NULL, NULL, 229924),
(234797, '4g3jA00', NULL, NULL, 448, NULL, NULL, 229924),
(234798, '4l0fA00', NULL, NULL, 446, NULL, NULL, 229924),
(234799, '1jfbA00', NULL, NULL, 404, NULL, NULL, 229924),
(234800, '6hqdC00', NULL, NULL, 420, NULL, NULL, 229924),
(234801, '2ij2B00', NULL, NULL, 470, NULL, NULL, 229924),
(234802, '4dnjA00', NULL, NULL, 412, NULL, NULL, 229924),
(234803, '5foiA00', NULL, NULL, 389, NULL, NULL, 229924),
(234804, '4ggvA00', NULL, NULL, 396, NULL, NULL, 229924),
(234805, '3dbgA00', NULL, NULL, 446, NULL, NULL, 229924),
(234806, '5hdiA00', NULL, NULL, 404, NULL, NULL, 229924),
(234807, '3oo3A00', NULL, NULL, 384, NULL, NULL, 229924),
(234808, '4mm0B00', NULL, NULL, 399, NULL, NULL, 229924),
(234809, '4xe3A00', NULL, NULL, 407, NULL, NULL, 229924),
(234810, '3awmA00', NULL, NULL, 415, NULL, NULL, 229924),
(234811, '5vccA00', NULL, NULL, 487, NULL, NULL, 229924),
(234812, '5ex8A00', NULL, NULL, 424, NULL, NULL, 229924),
(234813, '3nc3B00', NULL, NULL, 401, NULL, NULL, 229924),
(234814, '5xntA00', NULL, NULL, 411, NULL, NULL, 229924),
(234815, '1gwiA00', NULL, NULL, 411, NULL, NULL, 229924),
(234816, '2hi4A00', NULL, NULL, 495, NULL, NULL, 229924),
(234817, '3danA00', NULL, NULL, 473, NULL, NULL, 229924),
(234818, '3a4gA00', NULL, NULL, 411, NULL, NULL, 229924),
(234819, '3wecA00', NULL, NULL, 419, NULL, NULL, 229924),
(234820, '3tywD00', NULL, NULL, 401, NULL, NULL, 229924),
(234821, '5ucwA00', NULL, NULL, 456, NULL, NULL, 229924),
(234822, '1odoA00', NULL, NULL, 408, NULL, NULL, 229924),
(234823, '2dkkA00', NULL, NULL, 411, NULL, NULL, 229924),
(234824, '5ufgA00', NULL, NULL, 476, NULL, NULL, 229924),
(234825, '6mjmA00', NULL, NULL, 480, NULL, NULL, 229924),
(234826, '6b11A00', NULL, NULL, 389, NULL, NULL, 229924),
(234827, '5z9jC00', NULL, NULL, 398, NULL, NULL, 229924),
(234828, '5l92A00', NULL, NULL, 410, NULL, NULL, 229924),
(234829, '3b6hA00', NULL, NULL, 498, NULL, NULL, 229924),
(234830, '4l4eA00', NULL, NULL, 415, NULL, NULL, 229924),
(234831, '4wpzA00', NULL, NULL, 397, NULL, NULL, 229924),
(234832, '1n97A00', NULL, NULL, 389, NULL, NULL, 229924),
(234833, '3rwlA00', NULL, NULL, 426, NULL, NULL, 229924),
(234834, '4ubsA00', NULL, NULL, 393, NULL, NULL, 229924),
(234835, '3mdmA00', NULL, NULL, 456, NULL, NULL, 229924),
(234836, '4tpoA00', NULL, NULL, 407, NULL, NULL, 229924),
(234837, '6gmfA00', NULL, NULL, 397, NULL, NULL, 229924),
(234838, '3ld6B00', NULL, NULL, 461, NULL, NULL, 229924),
(234839, '4tvfA00', NULL, NULL, 393, NULL, NULL, 229924),
(234840, '6bldA00', NULL, NULL, 419, NULL, NULL, 229924),
(234841, '2z36B00', NULL, NULL, 413, NULL, NULL, 229924),
(234842, '1po5A00', NULL, NULL, 476, NULL, NULL, 229924),
(234843, '3ejbH02', NULL, NULL, 274, NULL, NULL, 229924),
(234844, '4gqsD00', NULL, NULL, 477, NULL, NULL, 229924),
(234845, '6m7lA00', NULL, NULL, 379, NULL, NULL, 229924),
(234846, '3e6iB00', NULL, NULL, 476, NULL, NULL, 229924),
(234847, '4oqrA00', NULL, NULL, 391, NULL, NULL, 229924),
(234848, '4k2pA02', NULL, NULL, 114, NULL, NULL, 229925),
(234849, '3a8pA02', NULL, NULL, 114, NULL, NULL, 229925),
(234850, '3gkqA02', NULL, NULL, 58, NULL, NULL, 229926),
(234851, '2de6A02', NULL, NULL, 58, NULL, NULL, 229926),
(234852, '1z01A02', NULL, NULL, 61, NULL, NULL, 229926),
(234853, '3gcfA02', NULL, NULL, 58, NULL, NULL, 229926),
(234854, '2ew2A02', NULL, NULL, 134, NULL, NULL, 229927),
(234855, '5y8lA02', NULL, NULL, 134, NULL, NULL, 229927),
(234856, '4ol9A02', NULL, NULL, 127, NULL, NULL, 229927),
(234857, '2plaA02', NULL, NULL, 155, NULL, NULL, 229927);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(234858, '5ocmA02', NULL, NULL, 131, NULL, NULL, 229927),
(234859, '4d3dB02', NULL, NULL, 133, NULL, NULL, 229927),
(234860, '5je8B02', NULL, NULL, 132, NULL, NULL, 229927),
(234861, '1dljA03', NULL, NULL, 90, NULL, NULL, 229927),
(234862, '3l6dA02', NULL, NULL, 139, NULL, NULL, 229927),
(234863, '3hdhA02', NULL, NULL, 87, NULL, NULL, 229927),
(234864, '5zikA02', NULL, NULL, 123, NULL, NULL, 229927),
(234865, '1vpdA02', NULL, NULL, 131, NULL, NULL, 229927),
(234866, '1zcjA03', NULL, NULL, 137, NULL, NULL, 229927),
(234867, '1zcjA04', NULL, NULL, 110, NULL, NULL, 229927),
(234868, '1ks9A02', NULL, NULL, 123, NULL, NULL, 229927),
(234869, '4fgwA02', NULL, NULL, 158, NULL, NULL, 229927),
(234870, '4om8A02', NULL, NULL, 124, NULL, NULL, 229927),
(234871, '3dojA02', NULL, NULL, 126, NULL, NULL, 229927),
(234872, '4dllB02', NULL, NULL, 132, NULL, NULL, 229927),
(234873, '1f0yA02', NULL, NULL, 87, NULL, NULL, 229927),
(234874, '4d3sD02', NULL, NULL, 129, NULL, NULL, 229927),
(234875, '4ycaA02', NULL, NULL, 134, NULL, NULL, 229927),
(234876, '3k96A02', NULL, NULL, 143, NULL, NULL, 229927),
(234877, '3fr7B02', NULL, NULL, 274, NULL, NULL, 229927),
(234878, '6hrdA02', NULL, NULL, 86, NULL, NULL, 229927),
(234879, '4gwgA02', NULL, NULL, 255, NULL, NULL, 229927),
(234880, '6aa8A02', NULL, NULL, 86, NULL, NULL, 229927),
(234881, '3g0oA02', NULL, NULL, 131, NULL, NULL, 229927),
(234882, '3c7aA02', NULL, NULL, 198, NULL, NULL, 229927),
(234883, '3cumA02', NULL, NULL, 137, NULL, NULL, 229927),
(234884, '3ghyA02', NULL, NULL, 138, NULL, NULL, 229927),
(234885, '1z82B02', NULL, NULL, 147, NULL, NULL, 229927),
(234886, '3ckyA02', NULL, NULL, 135, NULL, NULL, 229927),
(234887, '1evyA02', NULL, NULL, 149, NULL, NULL, 229927),
(234888, '5g6rB02', NULL, NULL, 136, NULL, NULL, 229927),
(234889, '1yj8A02', NULL, NULL, 161, NULL, NULL, 229927),
(234890, '2pgdA02', NULL, NULL, 255, NULL, NULL, 229927),
(234891, '4pzcA02', NULL, NULL, 86, NULL, NULL, 229927),
(234892, '4r1nA02', NULL, NULL, 86, NULL, NULL, 229927),
(234893, '3q3cA02', NULL, NULL, 135, NULL, NULL, 229927),
(234894, '2uyyA02', NULL, NULL, 123, NULL, NULL, 229927),
(234895, '3f3sA02', NULL, NULL, 124, NULL, NULL, 229927),
(234896, '1yb4A02', NULL, NULL, 134, NULL, NULL, 229927),
(234897, '3wfiB02', NULL, NULL, 134, NULL, NULL, 229927),
(234898, '4oqzA02', NULL, NULL, 130, NULL, NULL, 229927),
(234899, '4j0eA02', NULL, NULL, 91, NULL, NULL, 229927),
(234900, '2qytA02', NULL, NULL, 125, NULL, NULL, 229927),
(234901, '3hwrA02', NULL, NULL, 129, NULL, NULL, 229927),
(234902, '6fqzA02', NULL, NULL, 257, NULL, NULL, 229927),
(234903, '4ezbA02', NULL, NULL, 121, NULL, NULL, 229927),
(234904, '3h2zA02', NULL, NULL, 176, NULL, NULL, 229927),
(234905, '3ctvA00', NULL, NULL, 94, NULL, NULL, 229927),
(234906, '1pgjA02', NULL, NULL, 258, NULL, NULL, 229927),
(234907, '2gf2A02', NULL, NULL, 134, NULL, NULL, 229927),
(234908, '4im7A02', NULL, NULL, 208, NULL, NULL, 229927),
(234909, '1i36A02', NULL, NULL, 105, NULL, NULL, 229927),
(234910, '2p4qA02', NULL, NULL, 256, NULL, NULL, 229927),
(234911, '3adoA02', NULL, NULL, 127, NULL, NULL, 229927),
(234912, '1bg6A02', NULL, NULL, 153, NULL, NULL, 229927),
(234913, '2zygA02', NULL, NULL, 254, NULL, NULL, 229927),
(234914, '3qhaB02', NULL, NULL, 123, NULL, NULL, 229927),
(234915, '4e12A02', NULL, NULL, 87, NULL, NULL, 229927),
(234916, '1qmgA02', NULL, NULL, 293, NULL, NULL, 229927),
(234917, '2h78A02', NULL, NULL, 137, NULL, NULL, 229927),
(234918, '4oqyB02', NULL, NULL, 130, NULL, NULL, 229927),
(234919, '3egoA02', NULL, NULL, 135, NULL, NULL, 229927),
(234920, '4e21B02', NULL, NULL, 157, NULL, NULL, 229927),
(234921, '5jnmA02', NULL, NULL, 174, NULL, NULL, 229927),
(234922, '6e8yB02', NULL, NULL, 157, NULL, NULL, 229927),
(234923, '3qsgA02', NULL, NULL, 118, NULL, NULL, 229927),
(234924, '2w90A02', NULL, NULL, 256, NULL, NULL, 229927),
(234925, '3i83A02', NULL, NULL, 141, NULL, NULL, 229927),
(234926, '3pduA02', NULL, NULL, 123, NULL, NULL, 229927),
(234927, '3ws7A02', NULL, NULL, 124, NULL, NULL, 229927),
(234928, '2iz1A02', NULL, NULL, 255, NULL, NULL, 229927);
INSERT INTO "PUBLIC"."MODEL" VALUES
(234929, '2hdhA02', NULL, NULL, 93, NULL, NULL, 229927),
(234930, '5ayvA02', NULL, NULL, 125, NULL, NULL, 229927),
(234931, '3ulkA02', NULL, NULL, 283, NULL, NULL, 229927),
(234932, '6eoiA02', NULL, NULL, 133, NULL, NULL, 229927),
(234933, '2zydA02', NULL, NULL, 254, NULL, NULL, 229927),
(234934, '2cvzA02', NULL, NULL, 132, NULL, NULL, 229927),
(234935, '3hn2A02', NULL, NULL, 135, NULL, NULL, 229927),
(234936, '5a9tA02', NULL, NULL, 129, NULL, NULL, 229927),
(234937, '1lj8A02', NULL, NULL, 208, NULL, NULL, 229927),
(234938, '4gbjC02', NULL, NULL, 135, NULL, NULL, 229927),
(234939, '3pidA02', NULL, NULL, 90, NULL, NULL, 229927),
(234940, '3zgyA02', NULL, NULL, 132, NULL, NULL, 229927),
(234941, '3obbA02', NULL, NULL, 135, NULL, NULL, 229927),
(234942, '3pefA02', NULL, NULL, 123, NULL, NULL, 229927),
(234943, '1txgA02', NULL, NULL, 155, NULL, NULL, 229927),
(234944, '4cgsB00', NULL, NULL, 173, NULL, NULL, 229928),
(234945, '3hw5B00', NULL, NULL, 202, NULL, NULL, 229928),
(234946, '4avlA00', NULL, NULL, 204, NULL, NULL, 229928),
(234947, '4cgxA00', NULL, NULL, 177, NULL, NULL, 229928),
(234948, '5jhtA00', NULL, NULL, 191, NULL, NULL, 229928),
(234949, '4nfzA00', NULL, NULL, 196, NULL, NULL, 229928),
(234950, '3p2nB01', NULL, NULL, 30, NULL, NULL, 229929),
(234951, '3bxwA01', NULL, NULL, 33, NULL, NULL, 229929),
(234952, '1r6vA01', NULL, NULL, 125, NULL, NULL, 229930),
(234953, '1cl8A00', NULL, NULL, 276, NULL, NULL, 229931),
(234954, '1d02B00', NULL, NULL, 202, NULL, NULL, 229931),
(234955, '1lshA01', NULL, NULL, 264, NULL, NULL, 229932),
(234956, '2fi9A00', NULL, NULL, 128, NULL, NULL, 229933),
(234957, '1ihnA00', NULL, NULL, 113, NULL, NULL, 229933),
(234958, '2gm2A01', NULL, NULL, 112, NULL, NULL, 229933),
(234959, '2fvtA01', NULL, NULL, 119, NULL, NULL, 229933),
(234960, '2ab1A00', NULL, NULL, 122, NULL, NULL, 229933),
(234961, '2cyjA00', NULL, NULL, 118, NULL, NULL, 229933),
(234962, '3cpkA00', NULL, NULL, 150, NULL, NULL, 229933),
(234963, '2a6hA02', NULL, NULL, 122, NULL, NULL, 229934),
(234964, '5tjgA02', NULL, NULL, 122, NULL, NULL, 229934),
(234965, '4noiA02', NULL, NULL, 121, NULL, NULL, 229934),
(234966, '5tw1A02', NULL, NULL, 121, NULL, NULL, 229934),
(234967, '1twfC02', NULL, NULL, 126, NULL, NULL, 229934),
(234968, '1bdfB02', NULL, NULL, 125, NULL, NULL, 229934),
(234969, '5zx3A02', NULL, NULL, 121, NULL, NULL, 229934),
(234970, '4aybD02', NULL, NULL, 119, NULL, NULL, 229934),
(234971, '5xogC02', NULL, NULL, 127, NULL, NULL, 229934),
(234972, '3h0gC02', NULL, NULL, 128, NULL, NULL, 229934),
(234973, '2pa8D02', NULL, NULL, 119, NULL, NULL, 229934),
(234974, '6gmhC02', NULL, NULL, 131, NULL, NULL, 229934),
(234975, '4c2mC02', NULL, NULL, 141, NULL, NULL, 229934),
(234976, '4qjvA02', NULL, NULL, 108, NULL, NULL, 229934),
(234977, '2lz0A00', NULL, NULL, 100, NULL, NULL, 229935),
(234978, '2hiyA02', NULL, NULL, 92, NULL, NULL, 229936),
(234979, '4g38A01', NULL, NULL, 151, NULL, NULL, 229937),
(234980, '1zj8A02', NULL, NULL, 152, NULL, NULL, 229937),
(234981, '1ynjJ01', NULL, NULL, 116, NULL, NULL, 229938),
(234982, '2g7oA00', NULL, NULL, 70, NULL, NULL, 229939),
(234983, '3on0C02', NULL, NULL, 70, NULL, NULL, 229939),
(234984, '3nisA01', NULL, NULL, 72, NULL, NULL, 229940),
(234985, '2kkmA01', NULL, NULL, 125, NULL, NULL, 229941),
(234986, '1qwyA01', NULL, NULL, 62, NULL, NULL, 229942),
(234987, '3g7vA02', NULL, NULL, 37, NULL, NULL, 229943),
(234988, '1vquB02', NULL, NULL, 270, NULL, NULL, 229944),
(234989, '1brwA02', NULL, NULL, 272, NULL, NULL, 229944),
(234990, '1o17D02', NULL, NULL, 240, NULL, NULL, 229944),
(234991, '3h5qA02', NULL, NULL, 272, NULL, NULL, 229944),
(234992, '2elcA02', NULL, NULL, 262, NULL, NULL, 229944),
(234993, '4ga4A02', NULL, NULL, 261, NULL, NULL, 229944),
(234994, '4ga6A03', NULL, NULL, 177, NULL, NULL, 229944),
(234995, '5bo3A02', NULL, NULL, 280, NULL, NULL, 229944),
(234996, '4eadA02', NULL, NULL, 229, NULL, NULL, 229944),
(234997, '4yi7A02', NULL, NULL, 279, NULL, NULL, 229944),
(234998, '1uouA02', NULL, NULL, 285, NULL, NULL, 229944),
(234999, '4muoA02', NULL, NULL, 256, NULL, NULL, 229944);
INSERT INTO "PUBLIC"."MODEL" VALUES
(235000, '2dsjA02', NULL, NULL, 264, NULL, NULL, 229944),
(235001, '4hkmB02', NULL, NULL, 273, NULL, NULL, 229944),
(235002, '5olnA02', NULL, NULL, 272, NULL, NULL, 229944),
(235003, '5noeA02', NULL, NULL, 227, NULL, NULL, 229944),
(235004, '1khdD02', NULL, NULL, 227, NULL, NULL, 229944),
(235005, '3i05B02', NULL, NULL, 117, NULL, NULL, 229945),
(235006, '4jfaC02', NULL, NULL, 133, NULL, NULL, 229945),
(235007, '3jxeB02', NULL, NULL, 132, NULL, NULL, 229945),
(235008, '1r6tB02', NULL, NULL, 123, NULL, NULL, 229945),
(235009, '3qe4A02', NULL, NULL, 116, NULL, NULL, 229945),
(235010, '3a04A02', NULL, NULL, 116, NULL, NULL, 229945),
(235011, '5tevB02', NULL, NULL, 103, NULL, NULL, 229945),
(235012, '2cyaA02', NULL, NULL, 150, NULL, NULL, 229945),
(235013, '3hzrA02', NULL, NULL, 111, NULL, NULL, 229945),
(235014, '2el7A02', NULL, NULL, 107, NULL, NULL, 229945),
(235015, '2yxnA02', NULL, NULL, 95, NULL, NULL, 229945),
(235016, '3n9iA02', NULL, NULL, 113, NULL, NULL, 229945),
(235017, '1h3fA02', NULL, NULL, 117, NULL, NULL, 229945),
(235018, '3sz3A02', NULL, NULL, 114, NULL, NULL, 229945),
(235019, '1yi8A02', NULL, NULL, 108, NULL, NULL, 229945),
(235020, '3kt3A02', NULL, NULL, 142, NULL, NULL, 229945),
(235021, '5usfA03', NULL, NULL, 95, NULL, NULL, 229945),
(235022, '3tzlA02', NULL, NULL, 104, NULL, NULL, 229945),
(235023, '1r6uA02', NULL, NULL, 145, NULL, NULL, 229945),
(235024, '1jilA02', NULL, NULL, 96, NULL, NULL, 229945),
(235025, '5ekdA02', NULL, NULL, 111, NULL, NULL, 229945),
(235026, '6mtkA02', NULL, NULL, 104, NULL, NULL, 229945),
(235027, '2yy5A02', NULL, NULL, 119, NULL, NULL, 229945),
(235028, '2ts1A02', NULL, NULL, 96, NULL, NULL, 229945),
(235029, '5ujjA03', NULL, NULL, 131, NULL, NULL, 229945),
(235030, '3hv0A02', NULL, NULL, 121, NULL, NULL, 229945),
(235031, '3tzeA02', NULL, NULL, 115, NULL, NULL, 229945),
(235032, '5ijxA02', NULL, NULL, 99, NULL, NULL, 229945),
(235033, '2pidA02', NULL, NULL, 110, NULL, NULL, 229945),
(235034, '2g36A02', NULL, NULL, 107, NULL, NULL, 229945),
(235035, '4j76B02', NULL, NULL, 121, NULL, NULL, 229945),
(235036, '3focA02', NULL, NULL, 108, NULL, NULL, 229945),
(235037, '1n3lA02', NULL, NULL, 126, NULL, NULL, 229945),
(235038, '6ncrA02', NULL, NULL, 108, NULL, NULL, 229945),
(235039, '2cycA02', NULL, NULL, 149, NULL, NULL, 229945),
(235040, '5ihxA02', NULL, NULL, 112, NULL, NULL, 229945),
(235041, '2janA02', NULL, NULL, 101, NULL, NULL, 229945),
(235042, '3prhA02', NULL, NULL, 111, NULL, NULL, 229945),
(235043, '4ojmX02', NULL, NULL, 107, NULL, NULL, 229945),
(235044, '5n5uA02', NULL, NULL, 118, NULL, NULL, 229945),
(235045, '3vgjA02', NULL, NULL, 135, NULL, NULL, 229945),
(235046, '1r6uB02', NULL, NULL, 113, NULL, NULL, 229945),
(235047, '2dlcX02', NULL, NULL, 136, NULL, NULL, 229945),
(235048, '2ip1A02', NULL, NULL, 108, NULL, NULL, 229945),
(235049, '2j5bA02', NULL, NULL, 125, NULL, NULL, 229945),
(235050, '3u1vA02', NULL, NULL, 111, NULL, NULL, 229945),
(235051, '4oudA02', NULL, NULL, 99, NULL, NULL, 229945),
(235052, '2cybB02', NULL, NULL, 116, NULL, NULL, 229945),
(235053, '1i6kA02', NULL, NULL, 111, NULL, NULL, 229945),
(235054, '4hwmA00', NULL, NULL, 130, NULL, NULL, 229946),
(235055, '1wv8A00', NULL, NULL, 73, NULL, NULL, 229947),
(235056, '1sf9A02', NULL, NULL, 54, NULL, NULL, 229948),
(235057, '2yxyA02', NULL, NULL, 59, NULL, NULL, 229948),
(235058, '2kz6A01', NULL, NULL, 83, NULL, NULL, 229949),
(235059, '2riqA02', NULL, NULL, 60, NULL, NULL, 229950),
(235060, '2l9sA00', NULL, NULL, 45, NULL, NULL, 229951),
(235061, '3v42A01', NULL, NULL, 132, NULL, NULL, 229952),
(235062, '2knjA00', NULL, NULL, 90, NULL, NULL, 229953),
(235063, '6ig5A02', NULL, NULL, 229, NULL, NULL, 229954),
(235064, '1w27A02', NULL, NULL, 332, NULL, NULL, 229954),
(235065, '6n1mA02', NULL, NULL, 268, NULL, NULL, 229954),
(235066, '6at7B02', NULL, NULL, 335, NULL, NULL, 229954),
(235067, '5uppA02', NULL, NULL, 269, NULL, NULL, 229954),
(235068, '3ocfD02', NULL, NULL, 267, NULL, NULL, 229954),
(235069, '3unvA02', NULL, NULL, 328, NULL, NULL, 229954),
(235070, '3qbpB02', NULL, NULL, 270, NULL, NULL, 229954);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(235071, '4eeiA02', NULL, NULL, 256, NULL, NULL, 229954),
(235072, '5eyvA02', NULL, NULL, 323, NULL, NULL, 229954),
(235073, '1k62A02', NULL, NULL, 228, NULL, NULL, 229954),
(235074, '1jswA02', NULL, NULL, 268, NULL, NULL, 229954),
(235075, '1c3cA02', NULL, NULL, 256, NULL, NULL, 229954),
(235076, '1tj7A02', NULL, NULL, 279, NULL, NULL, 229954),
(235077, '2e9fA02', NULL, NULL, 283, NULL, NULL, 229954),
(235078, '1gkmA02', NULL, NULL, 312, NULL, NULL, 229954),
(235079, '3rrpA02', NULL, NULL, 270, NULL, NULL, 229954),
(235080, '1q5nA02', NULL, NULL, 256, NULL, NULL, 229954),
(235081, '2ptrA02', NULL, NULL, 281, NULL, NULL, 229954),
(235082, '2qveA02', NULL, NULL, 333, NULL, NULL, 229954),
(235083, '4nslB02', NULL, NULL, 275, NULL, NULL, 229954),
(235084, '3c8tA02', NULL, NULL, 256, NULL, NULL, 229954),
(235085, '1k7wA02', NULL, NULL, 228, NULL, NULL, 229954),
(235086, '1yfmA02', NULL, NULL, 269, NULL, NULL, 229954),
(235087, '4admC02', NULL, NULL, 270, NULL, NULL, 229954),
(235088, '5vkwB02', NULL, NULL, 336, NULL, NULL, 229954),
(235089, '1yisA02', NULL, NULL, 338, NULL, NULL, 229954),
(235090, '1y2mC02', NULL, NULL, 342, NULL, NULL, 229954),
(235091, '2felA00', NULL, NULL, 359, NULL, NULL, 229954),
(235092, '2x75A02', NULL, NULL, 256, NULL, NULL, 229954),
(235093, '4mx2D02', NULL, NULL, 270, NULL, NULL, 229954),
(235094, '4c5sA02', NULL, NULL, 337, NULL, NULL, 229954),
(235095, '1vdkA02', NULL, NULL, 266, NULL, NULL, 229954),
(235096, '3gtdA02', NULL, NULL, 269, NULL, NULL, 229954),
(235097, '2o6yA02', NULL, NULL, 319, NULL, NULL, 229954),
(235098, '1furA02', NULL, NULL, 269, NULL, NULL, 229954),
(235099, '1i0aA02', NULL, NULL, 231, NULL, NULL, 229954),
(235100, '1re5D02', NULL, NULL, 256, NULL, NULL, 229954),
(235101, '5v4lD02', NULL, NULL, 337, NULL, NULL, 229954),
(235102, '1dofA01', NULL, NULL, 253, NULL, NULL, 229954),
(235103, '2nynA02', NULL, NULL, 342, NULL, NULL, 229954),
(235104, '4hgvD02', NULL, NULL, 268, NULL, NULL, 229954),
(235105, '2nyfA02', NULL, NULL, 335, NULL, NULL, 229954),
(235106, '5xnyA02', NULL, NULL, 265, NULL, NULL, 229954),
(235107, '3tv2A02', NULL, NULL, 269, NULL, NULL, 229954),
(235108, '2j91C02', NULL, NULL, 332, NULL, NULL, 229954),
(235109, '2qgaC02', NULL, NULL, 283, NULL, NULL, 229954),
(235110, '3rd8A02', NULL, NULL, 270, NULL, NULL, 229954),
(235111, '4nleA01', NULL, NULL, 259, NULL, NULL, 229954),
(235112, '3bhgA02', NULL, NULL, 275, NULL, NULL, 229954),
(235113, '2pfmA02', NULL, NULL, 256, NULL, NULL, 229954),
(235114, '3r6qA02', NULL, NULL, 268, NULL, NULL, 229954),
(235115, '4efcA02', NULL, NULL, 273, NULL, NULL, 229954),
(235116, '4h7oA01', NULL, NULL, 142, NULL, NULL, 229955),
(235117, '4n6aA01', NULL, NULL, 153, NULL, NULL, 229955),
(235118, '4hzdB01', NULL, NULL, 152, NULL, NULL, 229955),
(235119, '1ssqA01', NULL, NULL, 138, NULL, NULL, 229955),
(235120, '3q1xA01', NULL, NULL, 139, NULL, NULL, 229955),
(235121, '3gvdA01', NULL, NULL, 145, NULL, NULL, 229955),
(235122, '3f1xA01', NULL, NULL, 158, NULL, NULL, 229955),
(235123, '1t3dA01', NULL, NULL, 140, NULL, NULL, 229955),
(235124, '1xrsB01', NULL, NULL, 52, NULL, NULL, 229956),
(235125, '3kp0A03', NULL, NULL, 67, NULL, NULL, 229956),
(235126, '3kp1A03', NULL, NULL, 73, NULL, NULL, 229956),
(235127, '2wujA00', NULL, NULL, 57, NULL, NULL, 229957),
(235128, '4ecdA00', NULL, NULL, 340, NULL, NULL, 229958),
(235129, '1sq1A00', NULL, NULL, 330, NULL, NULL, 229958),
(235130, '4ob9A00', NULL, NULL, 363, NULL, NULL, 229958),
(235131, '1um0A00', NULL, NULL, 365, NULL, NULL, 229958),
(235132, '1qxoA00', NULL, NULL, 388, NULL, NULL, 229958),
(235133, '5z9aB00', NULL, NULL, 292, NULL, NULL, 229958),
(235134, '1r53A00', NULL, NULL, 341, NULL, NULL, 229958),
(235135, '1q1lA00', NULL, NULL, 370, NULL, NULL, 229958),
(235136, '2o11A00', NULL, NULL, 407, NULL, NULL, 229958),
(235137, '1sseB00', NULL, NULL, 86, NULL, NULL, 229959),
(235138, '3g7kA01', NULL, NULL, 201, NULL, NULL, 229960),
(235139, '1u0kA02', NULL, NULL, 151, NULL, NULL, 229960),
(235140, '3ednA02', NULL, NULL, 164, NULL, NULL, 229960),
(235141, '1u0kA01', NULL, NULL, 137, NULL, NULL, 229960);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(235142, '3ednA01', NULL, NULL, 135, NULL, NULL, 229960),
(235143, '2azpA01', NULL, NULL, 161, NULL, NULL, 229960),
(235144, '4dunA01', NULL, NULL, 131, NULL, NULL, 229960),
(235145, '2azpA02', NULL, NULL, 157, NULL, NULL, 229960),
(235146, '1ym5A01', NULL, NULL, 142, NULL, NULL, 229960),
(235147, '4dunA02', NULL, NULL, 132, NULL, NULL, 229960),
(235148, '1ym5A02', NULL, NULL, 158, NULL, NULL, 229960),
(235149, '6hjfA02', NULL, NULL, 179, NULL, NULL, 229960),
(235150, '6hjfA01', NULL, NULL, 176, NULL, NULL, 229960),
(235151, '1sdjA01', NULL, NULL, 147, NULL, NULL, 229960),
(235152, '2otnA02', NULL, NULL, 149, NULL, NULL, 229960),
(235153, '2h9fA01', NULL, NULL, 203, NULL, NULL, 229960),
(235154, '5k87B02', NULL, NULL, 195, NULL, NULL, 229960),
(235155, '4juuA02', NULL, NULL, 155, NULL, NULL, 229960),
(235156, '3ejxD01', NULL, NULL, 161, NULL, NULL, 229960),
(235157, '2h9fA02', NULL, NULL, 193, NULL, NULL, 229960),
(235158, '3ejxD02', NULL, NULL, 156, NULL, NULL, 229960),
(235159, '1tm0A01', NULL, NULL, 165, NULL, NULL, 229960),
(235160, '1tm0A02', NULL, NULL, 167, NULL, NULL, 229960),
(235161, '5h2gB01', NULL, NULL, 148, NULL, NULL, 229960),
(235162, '5ha4A02', NULL, NULL, 136, NULL, NULL, 229960),
(235163, '4jciA02', NULL, NULL, 153, NULL, NULL, 229960),
(235164, '4jbdA02', NULL, NULL, 153, NULL, NULL, 229960),
(235165, '4jbdA01', NULL, NULL, 155, NULL, NULL, 229960),
(235166, '4q2hA02', NULL, NULL, 164, NULL, NULL, 229960),
(235167, '1xubA02', NULL, NULL, 148, NULL, NULL, 229960),
(235168, '1xubA01', NULL, NULL, 130, NULL, NULL, 229960),
(235169, '3g7kB02', NULL, NULL, 181, NULL, NULL, 229960),
(235170, '4k7gB02', NULL, NULL, 168, NULL, NULL, 229960),
(235171, '4k7gB01', NULL, NULL, 170, NULL, NULL, 229960),
(235172, '6d1vA02', NULL, NULL, 137, NULL, NULL, 229960),
(235173, '6d1vA01', NULL, NULL, 128, NULL, NULL, 229960),
(235174, '4k8lA01', NULL, NULL, 177, NULL, NULL, 229960),
(235175, '3fveA02', NULL, NULL, 136, NULL, NULL, 229960),
(235176, '4k8lA02', NULL, NULL, 167, NULL, NULL, 229960),
(235177, '3fveA01', NULL, NULL, 154, NULL, NULL, 229960),
(235178, '2gkeA02', NULL, NULL, 137, NULL, NULL, 229960),
(235179, '2otnB01', NULL, NULL, 159, NULL, NULL, 229960),
(235180, '2gkeA01', NULL, NULL, 127, NULL, NULL, 229960),
(235181, '1qyaB01', NULL, NULL, 144, NULL, NULL, 229960),
(235182, '4juuB01', NULL, NULL, 156, NULL, NULL, 229960),
(235183, '5k87A01', NULL, NULL, 204, NULL, NULL, 229960),
(235184, '1s7jA02', NULL, NULL, 132, NULL, NULL, 229960),
(235185, '5h2gA02', NULL, NULL, 135, NULL, NULL, 229960),
(235186, '1s7jA01', NULL, NULL, 130, NULL, NULL, 229960),
(235187, '1qy9A02', NULL, NULL, 163, NULL, NULL, 229960),
(235188, '5ha4B01', NULL, NULL, 135, NULL, NULL, 229960),
(235189, '4jciB01', NULL, NULL, 158, NULL, NULL, 229960),
(235190, '4j9wA01', NULL, NULL, 157, NULL, NULL, 229960),
(235191, '4j9wA02', NULL, NULL, 153, NULL, NULL, 229960),
(235192, '4k7xA02', NULL, NULL, 153, NULL, NULL, 229960),
(235193, '4k7xA01', NULL, NULL, 162, NULL, NULL, 229960),
(235194, '6otvA01', NULL, NULL, 182, NULL, NULL, 229960),
(235195, '4lb0A02', NULL, NULL, 164, NULL, NULL, 229960),
(235196, '4lb0A01', NULL, NULL, 184, NULL, NULL, 229960),
(235197, '2pw0B02', NULL, NULL, 148, NULL, NULL, 229960),
(235198, '4q2hB01', NULL, NULL, 176, NULL, NULL, 229960),
(235199, '1u5kA02', NULL, NULL, 125, NULL, NULL, 229961),
(235200, '3q8dA02', NULL, NULL, 164, NULL, NULL, 229961),
(235201, '4a0tA01', NULL, NULL, 61, NULL, NULL, 229962),
(235202, '1vhmB00', NULL, NULL, 175, NULL, NULL, 229963),
(235203, '4rq9A02', NULL, NULL, 202, NULL, NULL, 229963),
(235204, '3oovA00', NULL, NULL, 169, NULL, NULL, 229963),
(235205, '3e98B00', NULL, NULL, 188, NULL, NULL, 229963),
(235206, '3lfvB02', NULL, NULL, 214, NULL, NULL, 229963),
(235207, '3mq0B02', NULL, NULL, 177, NULL, NULL, 229963),
(235208, '4q0jA01', NULL, NULL, 236, NULL, NULL, 229963),
(235209, '3lfvB01', NULL, NULL, 217, NULL, NULL, 229963),
(235210, '1yspA00', NULL, NULL, 181, NULL, NULL, 229963),
(235211, '4lrzE01', NULL, NULL, 190, NULL, NULL, 229963),
(235212, '3zq5A01', NULL, NULL, 225, NULL, NULL, 229963);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(235213, '3k2nA00', NULL, NULL, 177, NULL, NULL, 229963),
(235214, '3ci6B00', NULL, NULL, 171, NULL, NULL, 229963),
(235215, '3kshA00', NULL, NULL, 160, NULL, NULL, 229963),
(235216, '2w3gA00', NULL, NULL, 153, NULL, NULL, 229963),
(235217, '4g3kA00', NULL, NULL, 175, NULL, NULL, 229963),
(235218, '2zmfA00', NULL, NULL, 189, NULL, NULL, 229963),
(235219, '2qybA00', NULL, NULL, 159, NULL, NULL, 229963),
(235220, '4s21B01', NULL, NULL, 199, NULL, NULL, 229963),
(235221, '2xssA00', NULL, NULL, 181, NULL, NULL, 229963),
(235222, '2vzwB00', NULL, NULL, 149, NULL, NULL, 229963),
(235223, '4cqhA02', NULL, NULL, 172, NULL, NULL, 229963),
(235224, '3mmhA00', NULL, NULL, 167, NULL, NULL, 229963),
(235225, '5hpfA00', NULL, NULL, 178, NULL, NULL, 229963),
(235226, '4glqA00', NULL, NULL, 171, NULL, NULL, 229963),
(235227, '4r70B01', NULL, NULL, 210, NULL, NULL, 229963),
(235228, '5tjjB02', NULL, NULL, 183, NULL, NULL, 229963),
(235229, '4g3vA00', NULL, NULL, 172, NULL, NULL, 229963),
(235230, '2g7uA02', NULL, NULL, 178, NULL, NULL, 229963),
(235231, '3o5yB00', NULL, NULL, 149, NULL, NULL, 229963),
(235232, '3citA00', NULL, NULL, 160, NULL, NULL, 229963),
(235233, '2k2nA00', NULL, NULL, 172, NULL, NULL, 229963),
(235234, '3bjnA00', NULL, NULL, 165, NULL, NULL, 229963),
(235235, '3d3oB00', NULL, NULL, 178, NULL, NULL, 229963),
(235236, '4e04A02', NULL, NULL, 205, NULL, NULL, 229963),
(235237, '2xrnA02', NULL, NULL, 177, NULL, NULL, 229963),
(235238, '2gx5C00', NULL, NULL, 170, NULL, NULL, 229963),
(235239, '1ztuA02', NULL, NULL, 170, NULL, NULL, 229963),
(235240, '5llyA02', NULL, NULL, 185, NULL, NULL, 229963),
(235241, '6mghD00', NULL, NULL, 163, NULL, NULL, 229963),
(235242, '1mc0A01', NULL, NULL, 166, NULL, NULL, 229963),
(235243, '4q0hA02', NULL, NULL, 170, NULL, NULL, 229963),
(235244, '2o0yB02', NULL, NULL, 177, NULL, NULL, 229963),
(235245, '3ibjA01', NULL, NULL, 177, NULL, NULL, 229963),
(235246, '3ibjA02', NULL, NULL, 182, NULL, NULL, 229963),
(235247, '2oolB02', NULL, NULL, 201, NULL, NULL, 229963),
(235248, '4y2fA00', NULL, NULL, 149, NULL, NULL, 229963),
(235249, '2ia2A02', NULL, NULL, 182, NULL, NULL, 229963),
(235250, '1f5mA00', NULL, NULL, 180, NULL, NULL, 229963),
(235251, '4mn7A00', NULL, NULL, 149, NULL, NULL, 229963),
(235252, '3e0yA00', NULL, NULL, 181, NULL, NULL, 229963),
(235253, '3hcyA00', NULL, NULL, 151, NULL, NULL, 229963),
(235254, '4mcwB01', NULL, NULL, 166, NULL, NULL, 229963),
(235255, '3r4kA02', NULL, NULL, 183, NULL, NULL, 229963),
(235256, '5hsqA01', NULL, NULL, 212, NULL, NULL, 229963),
(235257, '4etxA01', NULL, NULL, 164, NULL, NULL, 229963),
(235258, '2o99B00', NULL, NULL, 182, NULL, NULL, 229963),
(235259, '5ey1B00', NULL, NULL, 168, NULL, NULL, 229963),
(235260, '3nhqB01', NULL, NULL, 214, NULL, NULL, 229963),
(235261, '3eeaA00', NULL, NULL, 162, NULL, NULL, 229963),
(235262, '1mkmB02', NULL, NULL, 171, NULL, NULL, 229963),
(235263, '4gw9A01', NULL, NULL, 215, NULL, NULL, 229963),
(235264, '3dbaA00', NULL, NULL, 180, NULL, NULL, 229963),
(235265, '5zohA00', NULL, NULL, 178, NULL, NULL, 229963),
(235266, '5hl6B00', NULL, NULL, 178, NULL, NULL, 229963),
(235267, '4iuhA00', NULL, NULL, 145, NULL, NULL, 229963),
(235268, '3trcA00', NULL, NULL, 171, NULL, NULL, 229963),
(235269, '1tf1B00', NULL, NULL, 181, NULL, NULL, 229963),
(235270, '1ysqA00', NULL, NULL, 193, NULL, NULL, 229963),
(235271, '5ajgA02', NULL, NULL, 172, NULL, NULL, 229963),
(235272, '3d3oA00', NULL, NULL, 178, NULL, NULL, 229963),
(235273, '2vjwA00', NULL, NULL, 149, NULL, NULL, 229963),
(235274, '1stzA02', NULL, NULL, 151, NULL, NULL, 229963),
(235275, '2w1rA00', NULL, NULL, 123, NULL, NULL, 229963),
(235276, '3rfbB00', NULL, NULL, 171, NULL, NULL, 229963),
(235277, '6bhnA00', NULL, NULL, 164, NULL, NULL, 229963),
(235278, '4bwiB02', NULL, NULL, 199, NULL, NULL, 229963),
(235279, '5dfyA00', NULL, NULL, 167, NULL, NULL, 229963),
(235280, '1ykdB01', NULL, NULL, 197, NULL, NULL, 229963),
(235281, '6baoA01', NULL, NULL, 219, NULL, NULL, 229963),
(235282, '3obfA00', NULL, NULL, 176, NULL, NULL, 229963),
(235283, '1ykdB02', NULL, NULL, 201, NULL, NULL, 229963);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(235284, '4pauA00', NULL, NULL, 133, NULL, NULL, 229963),
(235285, '2k31A00', NULL, NULL, 150, NULL, NULL, 229963),
(235286, '4bwiB01', NULL, NULL, 202, NULL, NULL, 229963),
(235287, '1b35D00', NULL, NULL, 57, NULL, NULL, 229964),
(235288, '3w5mA06', NULL, NULL, 111, NULL, NULL, 229965),
(235289, '4ktpB02', NULL, NULL, 90, NULL, NULL, 229965),
(235290, '1h54A03', NULL, NULL, 74, NULL, NULL, 229965),
(235291, '3qdeA03', NULL, NULL, 86, NULL, NULL, 229965),
(235292, '3rrsA03', NULL, NULL, 84, NULL, NULL, 229965),
(235293, '1v7wA02', NULL, NULL, 90, NULL, NULL, 229965),
(235294, '2okxA04', NULL, NULL, 92, NULL, NULL, 229965),
(235295, '3actA03', NULL, NULL, 84, NULL, NULL, 229965),
(235296, '3wirA03', NULL, NULL, 77, NULL, NULL, 229965),
(235297, '1td9D01', NULL, NULL, 175, NULL, NULL, 229966),
(235298, '2af4C01', NULL, NULL, 172, NULL, NULL, 229966),
(235299, '6iowA01', NULL, NULL, 179, NULL, NULL, 229966),
(235300, '1r5jA01', NULL, NULL, 181, NULL, NULL, 229966),
(235301, '1vmiA01', NULL, NULL, 178, NULL, NULL, 229966),
(235302, '4e4rA01', NULL, NULL, 173, NULL, NULL, 229966),
(235303, '3vx8A01', NULL, NULL, 145, NULL, NULL, 229967),
(235304, '1y2oA00', NULL, NULL, 250, NULL, NULL, 229968),
(235305, '3lllA01', NULL, NULL, 278, NULL, NULL, 229968),
(235306, '4atmA00', NULL, NULL, 224, NULL, NULL, 229968),
(235307, '3cazB00', NULL, NULL, 224, NULL, NULL, 229968),
(235308, '3i2wA01', NULL, NULL, 278, NULL, NULL, 229968),
(235309, '4bneA01', NULL, NULL, 279, NULL, NULL, 229968),
(235310, '2eflA00', NULL, NULL, 305, NULL, NULL, 229968),
(235311, '4fzsA00', NULL, NULL, 224, NULL, NULL, 229968),
(235312, '2c08A00', NULL, NULL, 204, NULL, NULL, 229968),
(235313, '4akvA02', NULL, NULL, 191, NULL, NULL, 229968),
(235314, '2ficB00', NULL, NULL, 202, NULL, NULL, 229968),
(235315, '1uruA01', NULL, NULL, 211, NULL, NULL, 229968),
(235316, '4nqiD00', NULL, NULL, 244, NULL, NULL, 229968),
(235317, '2d1lA00', NULL, NULL, 253, NULL, NULL, 229968),
(235318, '3abhA01', NULL, NULL, 278, NULL, NULL, 229968),
(235319, '3pltA00', NULL, NULL, 217, NULL, NULL, 229968),
(235320, '2x3wC01', NULL, NULL, 291, NULL, NULL, 229968),
(235321, '2yktA00', NULL, NULL, 237, NULL, NULL, 229968),
(235322, '3hahB01', NULL, NULL, 294, NULL, NULL, 229968),
(235323, '1zwwA00', NULL, NULL, 230, NULL, NULL, 229968),
(235324, '4dylA01', NULL, NULL, 271, NULL, NULL, 229968),
(235325, '3ok8A00', NULL, NULL, 222, NULL, NULL, 229968),
(235326, '3syvC01', NULL, NULL, 263, NULL, NULL, 229968),
(235327, '4nswB01', NULL, NULL, 260, NULL, NULL, 229968),
(235328, '4wpeA00', NULL, NULL, 281, NULL, NULL, 229968),
(235329, '2z0oA01', NULL, NULL, 265, NULL, NULL, 229968),
(235330, '1x04A00', NULL, NULL, 200, NULL, NULL, 229968),
(235331, '4avmA00', NULL, NULL, 237, NULL, NULL, 229968),
(235332, '2d4cB00', NULL, NULL, 256, NULL, NULL, 229968),
(235333, '4wpcA00', NULL, NULL, 317, NULL, NULL, 229968),
(235334, '3m3wA01', NULL, NULL, 291, NULL, NULL, 229968),
(235335, '2efkA01', NULL, NULL, 275, NULL, NULL, 229968),
(235336, '3g9gA00', NULL, NULL, 264, NULL, NULL, 229968),
(235337, '1i4dA00', NULL, NULL, 201, NULL, NULL, 229968),
(235338, '2z0vA00', NULL, NULL, 240, NULL, NULL, 229968),
(235339, '2q12A00', NULL, NULL, 265, NULL, NULL, 229968),
(235340, '2v0oB00', NULL, NULL, 276, NULL, NULL, 229968),
(235341, '3dytA02', NULL, NULL, 191, NULL, NULL, 229968),
(235342, '3qweA00', NULL, NULL, 279, NULL, NULL, 229968),
(235343, '5c5bB01', NULL, NULL, 230, NULL, NULL, 229968),
(235344, '2spcA00', NULL, NULL, 107, NULL, NULL, 229969),
(235345, '1hciA04', NULL, NULL, 114, NULL, NULL, 229969),
(235346, '1quuA02', NULL, NULL, 124, NULL, NULL, 229969),
(235347, '1hciA01', NULL, NULL, 127, NULL, NULL, 229969),
(235348, '1s35A01', NULL, NULL, 102, NULL, NULL, 229969),
(235349, '1quuA01', NULL, NULL, 126, NULL, NULL, 229969),
(235350, '1s35A02', NULL, NULL, 112, NULL, NULL, 229969),
(235351, '2odvA01', NULL, NULL, 120, NULL, NULL, 229969),
(235352, '2odvA02', NULL, NULL, 115, NULL, NULL, 229969),
(235353, '3uunA00', NULL, NULL, 119, NULL, NULL, 229969),
(235354, '3eduA00', NULL, NULL, 218, NULL, NULL, 229969);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(235355, '1g8xA06', NULL, NULL, 319, NULL, NULL, 229969),
(235356, '1cunA01', NULL, NULL, 102, NULL, NULL, 229969),
(235357, '3fb2A01', NULL, NULL, 112, NULL, NULL, 229969),
(235358, '5j1gA00', NULL, NULL, 234, NULL, NULL, 229969),
(235359, '3pe0A01', NULL, NULL, 107, NULL, NULL, 229969),
(235360, '3kbtA00', NULL, NULL, 309, NULL, NULL, 229969),
(235361, '3pe0A02', NULL, NULL, 109, NULL, NULL, 229969),
(235362, '1wlxA01', NULL, NULL, 127, NULL, NULL, 229969),
(235363, '1cunA02', NULL, NULL, 103, NULL, NULL, 229969),
(235364, '3f57B00', NULL, NULL, 209, NULL, NULL, 229969),
(235365, '3r6nB01', NULL, NULL, 225, NULL, NULL, 229969),
(235366, '3uumB00', NULL, NULL, 123, NULL, NULL, 229969),
(235367, '3f31B00', NULL, NULL, 149, NULL, NULL, 229969),
(235368, '3fb2B02', NULL, NULL, 104, NULL, NULL, 229969),
(235369, '2iakA01', NULL, NULL, 215, NULL, NULL, 229969),
(235370, '1owaA02', NULL, NULL, 106, NULL, NULL, 229969),
(235371, '3edvA02', NULL, NULL, 183, NULL, NULL, 229969),
(235372, '3lbxB02', NULL, NULL, 76, NULL, NULL, 229969),
(235373, '3edvA01', NULL, NULL, 137, NULL, NULL, 229969),
(235374, '3lbxB01', NULL, NULL, 109, NULL, NULL, 229969),
(235375, '1u5pA01', NULL, NULL, 109, NULL, NULL, 229969),
(235376, '3lbxA00', NULL, NULL, 140, NULL, NULL, 229969),
(235377, '3pdyA00', NULL, NULL, 210, NULL, NULL, 229969),
(235378, '2p0tA01', NULL, NULL, 76, NULL, NULL, 229970),
(235379, '2p0tA02', NULL, NULL, 76, NULL, NULL, 229970),
(235380, '2k35A00', NULL, NULL, 60, NULL, NULL, 229971),
(235381, '2ln8A00', NULL, NULL, 75, NULL, NULL, 229971),
(235382, '1chkA02', NULL, NULL, 95, NULL, NULL, 229972),
(235383, '4oltA02', NULL, NULL, 95, NULL, NULL, 229972),
(235384, '5hwaA01', NULL, NULL, 147, NULL, NULL, 229972),
(235385, '4ilyA02', NULL, NULL, 95, NULL, NULL, 229972),
(235386, '1nhwC00', NULL, NULL, 60, NULL, NULL, 229973),
(235387, '4f9aB01', NULL, NULL, 19, NULL, NULL, 229974),
(235388, '1t94A01', NULL, NULL, 102, NULL, NULL, 229975),
(235389, '6cstB01', NULL, NULL, 150, NULL, NULL, 229975),
(235390, '3e0zB00', NULL, NULL, 109, NULL, NULL, 229976),
(235391, '3egnA01', NULL, NULL, 41, NULL, NULL, 229977),
(235392, '2p9bA04', NULL, NULL, 92, NULL, NULL, 229978),
(235393, '4flaC00', NULL, NULL, 131, NULL, NULL, 229979),
(235394, '1vlrA02', NULL, NULL, 78, NULL, NULL, 229980),
(235395, '3bl9B02', NULL, NULL, 76, NULL, NULL, 229980),
(235396, '2x4jA01', NULL, NULL, 114, NULL, NULL, 229981),
(235397, '2kddA00', NULL, NULL, 57, NULL, NULL, 229982),
(235398, '4mqdA00', NULL, NULL, 135, NULL, NULL, 229983),
(235399, '3mqgA02', NULL, NULL, 39, NULL, NULL, 229984),
(235400, '4f8lA00', NULL, NULL, 145, NULL, NULL, 229985),
(235401, '5lndB00', NULL, NULL, 132, NULL, NULL, 229985),
(235402, '2e50P01', NULL, NULL, 79, NULL, NULL, 229986),
(235403, '3gywA01', NULL, NULL, 60, NULL, NULL, 229986),
(235404, '4jnhA02', NULL, NULL, 41, NULL, NULL, 229986),
(235405, '2xusA00', NULL, NULL, 49, NULL, NULL, 229986),
(235406, '3ismB00', NULL, NULL, 267, NULL, NULL, 229987),
(235407, '3s5bB00', NULL, NULL, 249, NULL, NULL, 229987),
(235408, '1zm8A00', NULL, NULL, 239, NULL, NULL, 229987),
(235409, '4a1nA01', NULL, NULL, 240, NULL, NULL, 229987),
(235410, '3nkrA04', NULL, NULL, 327, NULL, NULL, 229987),
(235411, '4zg6A04', NULL, NULL, 331, NULL, NULL, 229987),
(235412, '4qgoA00', NULL, NULL, 225, NULL, NULL, 229987),
(235413, '3owvB00', NULL, NULL, 232, NULL, NULL, 229987),
(235414, '2xgrA00', NULL, NULL, 220, NULL, NULL, 229987),
(235415, '4gtwB02', NULL, NULL, 323, NULL, NULL, 229987),
(235416, '4e3yA00', NULL, NULL, 245, NULL, NULL, 229987),
(235417, '5c5zA00', NULL, NULL, 137, NULL, NULL, 229988),
(235418, '2qikA01', NULL, NULL, 119, NULL, NULL, 229988),
(235419, '3judA00', NULL, NULL, 153, NULL, NULL, 229988),
(235420, '4issA03', NULL, NULL, 144, NULL, NULL, 229988),
(235421, '3cryA00', NULL, NULL, 188, NULL, NULL, 229988),
(235422, '2qikA02', NULL, NULL, 165, NULL, NULL, 229988),
(235423, '1xhsA00', NULL, NULL, 121, NULL, NULL, 229988),
(235424, '1vkbA00', NULL, NULL, 161, NULL, NULL, 229988),
(235425, '2jqvA01', NULL, NULL, 115, NULL, NULL, 229988);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(235426, '1v30A00', NULL, NULL, 124, NULL, NULL, 229988),
(235427, '2g0qA01', NULL, NULL, 124, NULL, NULL, 229988),
(235428, '1cf4B00', NULL, NULL, 44, NULL, NULL, 229989),
(235429, '3pa8B00', NULL, NULL, 254, NULL, NULL, 229990),
(235430, '3fzyA00', NULL, NULL, 234, NULL, NULL, 229990),
(235431, '3ho6B00', NULL, NULL, 267, NULL, NULL, 229990),
(235432, '4j07A00', NULL, NULL, 153, NULL, NULL, 229991),
(235433, '2b99C00', NULL, NULL, 156, NULL, NULL, 229991),
(235434, '1hqkA00', NULL, NULL, 154, NULL, NULL, 229991),
(235435, '1kz1C00', NULL, NULL, 159, NULL, NULL, 229991),
(235436, '4kq6E00', NULL, NULL, 158, NULL, NULL, 229991),
(235437, '1c41A00', NULL, NULL, 200, NULL, NULL, 229991),
(235438, '2i0fA00', NULL, NULL, 157, NULL, NULL, 229991),
(235439, '2obxA00', NULL, NULL, 157, NULL, NULL, 229991),
(235440, '1vsw100', NULL, NULL, 153, NULL, NULL, 229991),
(235441, '2jfbH00', NULL, NULL, 164, NULL, NULL, 229991),
(235442, '3nq4100', NULL, NULL, 156, NULL, NULL, 229991),
(235443, '1c2yA00', NULL, NULL, 156, NULL, NULL, 229991),
(235444, '1di0A00', NULL, NULL, 158, NULL, NULL, 229991),
(235445, '5im5A00', NULL, NULL, 156, NULL, NULL, 229991),
(235446, '2c92A00', NULL, NULL, 160, NULL, NULL, 229991),
(235447, '1ejbA00', NULL, NULL, 168, NULL, NULL, 229991),
(235448, '5im4M00', NULL, NULL, 162, NULL, NULL, 229991),
(235449, '1rvv100', NULL, NULL, 154, NULL, NULL, 229991),
(235450, '3cqcA00', NULL, NULL, 270, NULL, NULL, 229992),
(235451, '3rgzA02', NULL, NULL, 61, NULL, NULL, 229993),
(235452, '4j0mA02', NULL, NULL, 58, NULL, NULL, 229993),
(235453, '4q63A00', NULL, NULL, 105, NULL, NULL, 229994),
(235454, '2wtuB04', NULL, NULL, 117, NULL, NULL, 229995),
(235455, '1wb9A03', NULL, NULL, 148, NULL, NULL, 229995),
(235456, '1wb9A04', NULL, NULL, 136, NULL, NULL, 229995),
(235457, '3thxA03', NULL, NULL, 237, NULL, NULL, 229995),
(235458, '3thxB04', NULL, NULL, 128, NULL, NULL, 229995),
(235459, '1e3mB04', NULL, NULL, 152, NULL, NULL, 229995),
(235460, '1e3mB05', NULL, NULL, 98, NULL, NULL, 229995),
(235461, '3thxB03', NULL, NULL, 184, NULL, NULL, 229995),
(235462, '5yk4A03', NULL, NULL, 147, NULL, NULL, 229995),
(235463, '5yk4A04', NULL, NULL, 136, NULL, NULL, 229995),
(235464, '1ewrB02', NULL, NULL, 187, NULL, NULL, 229995),
(235465, '2o8bA04', NULL, NULL, 83, NULL, NULL, 229995),
(235466, '1ewqA03', NULL, NULL, 149, NULL, NULL, 229995),
(235467, '2o8bB03', NULL, NULL, 188, NULL, NULL, 229995),
(235468, '1ewqA04', NULL, NULL, 136, NULL, NULL, 229995),
(235469, '2o8bB04', NULL, NULL, 133, NULL, NULL, 229995),
(235470, '2wtuB03', NULL, NULL, 186, NULL, NULL, 229995),
(235471, '3hxlA05', NULL, NULL, 82, NULL, NULL, 229996),
(235472, '3n5bB02', NULL, NULL, 37, NULL, NULL, 229997),
(235473, '2xkoC02', NULL, NULL, 37, NULL, NULL, 229997),
(235474, '3dsoA00', NULL, NULL, 74, NULL, NULL, 229998),
(235475, '3zrgA00', NULL, NULL, 67, NULL, NULL, 229999),
(235476, '3pfyA01', NULL, NULL, 74, NULL, NULL, 230000),
(235477, '3tmoA01', NULL, NULL, 93, NULL, NULL, 230000),
(235478, '3uebF00', NULL, NULL, 110, NULL, NULL, 230001),
(235479, '1pu1A00', NULL, NULL, 94, NULL, NULL, 230001),
(235480, '1pg6A00', NULL, NULL, 243, NULL, NULL, 230002),
(235481, '1yoxC00', NULL, NULL, 250, NULL, NULL, 230002),
(235482, '1vt0M05', NULL, NULL, 74, NULL, NULL, 230003),
(235483, '3okgA02', NULL, NULL, 194, NULL, NULL, 230004),
(235484, '1yf2A03', NULL, NULL, 147, NULL, NULL, 230004),
(235485, '3okgA01', NULL, NULL, 218, NULL, NULL, 230004),
(235486, '1ydxA01', NULL, NULL, 128, NULL, NULL, 230004),
(235487, '1ydxA03', NULL, NULL, 144, NULL, NULL, 230004),
(235488, '1yf2A01', NULL, NULL, 171, NULL, NULL, 230004),
(235489, '4lleA00', NULL, NULL, 130, NULL, NULL, 230005),
(235490, '3opyI00', NULL, NULL, 351, NULL, NULL, 230006),
(235491, '4acoA02', NULL, NULL, 356, NULL, NULL, 230007),
(235492, '3sqiA02', NULL, NULL, 298, NULL, NULL, 230007),
(235493, '4dbgB01', NULL, NULL, 54, NULL, NULL, 230008),
(235494, '5l44A01', NULL, NULL, 399, NULL, NULL, 230009),
(235495, '1y79101', NULL, NULL, 406, NULL, NULL, 230009),
(235496, '4ka7A01', NULL, NULL, 435, NULL, NULL, 230009);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(235497, '4putA01', NULL, NULL, 417, NULL, NULL, 230009),
(235498, '4bj6B01', NULL, NULL, 140, NULL, NULL, 230010),
(235499, '3oetD03', NULL, NULL, 86, NULL, NULL, 230011),
(235500, '2o4cA03', NULL, NULL, 88, NULL, NULL, 230011),
(235501, '5dt9A03', NULL, NULL, 88, NULL, NULL, 230011),
(235502, '4bbrM00', NULL, NULL, 193, NULL, NULL, 230012),
(235503, '2pc6A02', NULL, NULL, 77, NULL, NULL, 230013),
(235504, '3phtA01', NULL, NULL, 107, NULL, NULL, 230013),
(235505, '2wvbA02', NULL, NULL, 97, NULL, NULL, 230013),
(235506, '2wvfA02', NULL, NULL, 94, NULL, NULL, 230013),
(235507, '2fgdD03', NULL, NULL, 81, NULL, NULL, 230013),
(235508, '1q5yB00', NULL, NULL, 85, NULL, NULL, 230013),
(235509, '2fgcA03', NULL, NULL, 82, NULL, NULL, 230013),
(235510, '2nzcB00', NULL, NULL, 86, NULL, NULL, 230013),
(235511, '2f1fA02', NULL, NULL, 78, NULL, NULL, 230013),
(235512, '2bj3D02', NULL, NULL, 88, NULL, NULL, 230013),
(235513, '3pg6A00', NULL, NULL, 135, NULL, NULL, 230014),
(235514, '1pavA00', NULL, NULL, 78, NULL, NULL, 230015),
(235515, '1je3A01', NULL, NULL, 73, NULL, NULL, 230015),
(235516, '1jdqA00', NULL, NULL, 98, NULL, NULL, 230015),
(235517, '3hz7A00', NULL, NULL, 87, NULL, NULL, 230015),
(235518, '2lxrA00', NULL, NULL, 76, NULL, NULL, 230015),
(235519, '3lvjC00', NULL, NULL, 82, NULL, NULL, 230015),
(235520, '3o39B00', NULL, NULL, 108, NULL, NULL, 230016),
(235521, '3layJ00', NULL, NULL, 81, NULL, NULL, 230016),
(235522, '3itfA00', NULL, NULL, 111, NULL, NULL, 230016),
(235523, '3itfB00', NULL, NULL, 111, NULL, NULL, 230016),
(235524, '5wnwA00', NULL, NULL, 97, NULL, NULL, 230016),
(235525, '3qzcA00', NULL, NULL, 117, NULL, NULL, 230016),
(235526, '3o39A00', NULL, NULL, 108, NULL, NULL, 230016),
(235527, '2y39A00', NULL, NULL, 118, NULL, NULL, 230016),
(235528, '3zgxA02', NULL, NULL, 91, NULL, NULL, 230017),
(235529, '2e52B01', NULL, NULL, 226, NULL, NULL, 230018),
(235530, '6c5xD02', NULL, NULL, 39, NULL, NULL, 230019),
(235531, '2c9wA02', NULL, NULL, 36, NULL, NULL, 230019),
(235532, '3zkjA02', NULL, NULL, 39, NULL, NULL, 230019),
(235533, '2uz5A01', NULL, NULL, 30, NULL, NULL, 230020),
(235534, '1l3xA00', NULL, NULL, 73, NULL, NULL, 230021),
(235535, '3c05B00', NULL, NULL, 64, NULL, NULL, 230021),
(235536, '3c05A00', NULL, NULL, 62, NULL, NULL, 230021),
(235537, '4r5rA00', NULL, NULL, 68, NULL, NULL, 230021),
(235538, '1j2lA00', NULL, NULL, 70, NULL, NULL, 230021),
(235539, '1mpzA00', NULL, NULL, 41, NULL, NULL, 230021),
(235540, '3uciA00', NULL, NULL, 72, NULL, NULL, 230021),
(235541, '1ro3A00', NULL, NULL, 49, NULL, NULL, 230021),
(235542, '2mop100', NULL, NULL, 83, NULL, NULL, 230021),
(235543, '1q7iA00', NULL, NULL, 68, NULL, NULL, 230021),
(235544, '1rmrA00', NULL, NULL, 64, NULL, NULL, 230021),
(235545, '2w9oA00', NULL, NULL, 46, NULL, NULL, 230021),
(235546, '3g5cA02', NULL, NULL, 55, NULL, NULL, 230021),
(235547, '1tejB00', NULL, NULL, 64, NULL, NULL, 230021),
(235548, '4rqgA00', NULL, NULL, 68, NULL, NULL, 230021),
(235549, '1tejA00', NULL, NULL, 64, NULL, NULL, 230021),
(235550, '1z1xA00', NULL, NULL, 64, NULL, NULL, 230021),
(235551, '2xfvA00', NULL, NULL, 108, NULL, NULL, 230022),
(235552, '2aeuA01', NULL, NULL, 157, NULL, NULL, 230023),
(235553, '4bvqA02', NULL, NULL, 147, NULL, NULL, 230024),
(235554, '5hweA02', NULL, NULL, 145, NULL, NULL, 230024),
(235555, '4nq3A02', NULL, NULL, 148, NULL, NULL, 230024),
(235556, '5hy4G02', NULL, NULL, 149, NULL, NULL, 230024),
(235557, '5cqgA03', NULL, NULL, 79, NULL, NULL, 230025),
(235558, '1uvjA02', NULL, NULL, 144, NULL, NULL, 230026),
(235559, '3nkgA00', NULL, NULL, 174, NULL, NULL, 230027),
(235560, '16vpA00', NULL, NULL, 321, NULL, NULL, 230028),
(235561, '3f3bA00', NULL, NULL, 126, NULL, NULL, 230029),
(235562, '1gaxA04', NULL, NULL, 50, NULL, NULL, 230030),
(235563, '4bwcB00', NULL, NULL, 321, NULL, NULL, 230031),
(235564, '3fgrB00', NULL, NULL, 357, NULL, NULL, 230031),
(235565, '1rp0A01', NULL, NULL, 21, NULL, NULL, 230032),
(235566, '2re3A01', NULL, NULL, 93, NULL, NULL, 230033),
(235567, '2ra9A01', NULL, NULL, 54, NULL, NULL, 230033);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(235568, '4h4nA00', NULL, NULL, 67, NULL, NULL, 230034),
(235569, '1urjA03', NULL, NULL, 98, NULL, NULL, 230035),
(235570, '2wxfA05', NULL, NULL, 198, NULL, NULL, 230036),
(235571, '5dxtA05', NULL, NULL, 199, NULL, NULL, 230036),
(235572, '1e8yA05', NULL, NULL, 201, NULL, NULL, 230036),
(235573, '1cjaA02', NULL, NULL, 177, NULL, NULL, 230036),
(235574, '2x6hA03', NULL, NULL, 201, NULL, NULL, 230036),
(235575, '4uwhA03', NULL, NULL, 193, NULL, NULL, 230036),
(235576, '4bfrA05', NULL, NULL, 205, NULL, NULL, 230036),
(235577, '3c9qA00', NULL, NULL, 205, NULL, NULL, 230037),
(235578, '4pswA01', NULL, NULL, 130, NULL, NULL, 230038),
(235579, '2p0wA01', NULL, NULL, 137, NULL, NULL, 230038),
(235580, '3d55C02', NULL, NULL, 53, NULL, NULL, 230039),
(235581, '3g5oA02', NULL, NULL, 60, NULL, NULL, 230039),
(235582, '2agcA00', NULL, NULL, 162, NULL, NULL, 230040),
(235583, '2ag4A00', NULL, NULL, 164, NULL, NULL, 230040),
(235584, '2gqcA01', NULL, NULL, 56, NULL, NULL, 230041),
(235585, '2zttC00', NULL, NULL, 79, NULL, NULL, 230042),
(235586, '2zttA00', NULL, NULL, 79, NULL, NULL, 230042),
(235587, '3a1gA00', NULL, NULL, 80, NULL, NULL, 230042),
(235588, '1vajA02', NULL, NULL, 74, NULL, NULL, 230043),
(235589, '1zq7A02', NULL, NULL, 73, NULL, NULL, 230043),
(235590, '1wscA02', NULL, NULL, 76, NULL, NULL, 230043),
(235591, '1vioA02', NULL, NULL, 102, NULL, NULL, 230044),
(235592, '2gmlA01', NULL, NULL, 112, NULL, NULL, 230044),
(235593, '1vs3A01', NULL, NULL, 105, NULL, NULL, 230044),
(235594, '2omlA01', NULL, NULL, 81, NULL, NULL, 230044),
(235595, '4j37A01', NULL, NULL, 124, NULL, NULL, 230044),
(235596, '1dj0A02', NULL, NULL, 107, NULL, NULL, 230044),
(235597, '3jszA03', NULL, NULL, 124, NULL, NULL, 230045),
(235598, '2wzfA03', NULL, NULL, 124, NULL, NULL, 230045),
(235599, '2npnA02', NULL, NULL, 109, NULL, NULL, 230046),
(235600, '4e16A02', NULL, NULL, 121, NULL, NULL, 230046),
(235601, '2yboA02', NULL, NULL, 133, NULL, NULL, 230046),
(235602, '1ve2B02', NULL, NULL, 119, NULL, NULL, 230046),
(235603, '3kwpA02', NULL, NULL, 117, NULL, NULL, 230046),
(235604, '1va0B02', NULL, NULL, 126, NULL, NULL, 230046),
(235605, '3ndcA02', NULL, NULL, 123, NULL, NULL, 230046),
(235606, '2z6rA02', NULL, NULL, 151, NULL, NULL, 230046),
(235607, '1vhvB02', NULL, NULL, 144, NULL, NULL, 230046),
(235608, '1s4dE02', NULL, NULL, 151, NULL, NULL, 230046),
(235609, '2bb3A02', NULL, NULL, 97, NULL, NULL, 230046),
(235610, '1wdeA02', NULL, NULL, 174, NULL, NULL, 230046),
(235611, '3i4tA02', NULL, NULL, 160, NULL, NULL, 230046),
(235612, '3nd1A02', NULL, NULL, 113, NULL, NULL, 230046),
(235613, '3nutB02', NULL, NULL, 131, NULL, NULL, 230046),
(235614, '3fq6B00', NULL, NULL, 115, NULL, NULL, 230046),
(235615, '5hw4A02', NULL, NULL, 121, NULL, NULL, 230046),
(235616, '2qbuA02', NULL, NULL, 100, NULL, NULL, 230046),
(235617, '1cbfA02', NULL, NULL, 121, NULL, NULL, 230046),
(235618, '3ffyA00', NULL, NULL, 115, NULL, NULL, 230046),
(235619, '2e0nB02', NULL, NULL, 126, NULL, NULL, 230046),
(235620, '1pjqB05', NULL, NULL, 126, NULL, NULL, 230046),
(235621, '2zvbA02', NULL, NULL, 128, NULL, NULL, 230046),
(235622, '1wyzB02', NULL, NULL, 121, NULL, NULL, 230046),
(235623, '1aorA01', NULL, NULL, 211, NULL, NULL, 230047),
(235624, '1b25A01', NULL, NULL, 209, NULL, NULL, 230047),
(235625, '4z3xA01', NULL, NULL, 211, NULL, NULL, 230047),
(235626, '2pagA00', NULL, NULL, 135, NULL, NULL, 230048),
(235627, '2icgA00', NULL, NULL, 160, NULL, NULL, 230048),
(235628, '2prvB00', NULL, NULL, 153, NULL, NULL, 230048),
(235629, '3d5pA00', NULL, NULL, 144, NULL, NULL, 230048),
(235630, '4dokA01', NULL, NULL, 155, NULL, NULL, 230049),
(235631, '5wl5A01', NULL, NULL, 162, NULL, NULL, 230049),
(235632, '4dolA01', NULL, NULL, 166, NULL, NULL, 230049),
(235633, '5wl7A01', NULL, NULL, 166, NULL, NULL, 230049),
(235634, '5yx3A01', NULL, NULL, 161, NULL, NULL, 230049),
(235635, '4dooA01', NULL, NULL, 151, NULL, NULL, 230049),
(235636, '5wkrA01', NULL, NULL, 163, NULL, NULL, 230049),
(235637, '4doiA01', NULL, NULL, 173, NULL, NULL, 230049),
(235638, '5wl4A01', NULL, NULL, 163, NULL, NULL, 230049);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(235639, '1eyqA02', NULL, NULL, 162, NULL, NULL, 230049),
(235640, '2eqyA01', NULL, NULL, 112, NULL, NULL, 230050),
(235641, '4ljxA00', NULL, NULL, 137, NULL, NULL, 230050),
(235642, '1c20A00', NULL, NULL, 128, NULL, NULL, 230050),
(235643, '5cehA02', NULL, NULL, 102, NULL, NULL, 230050),
(235644, '2rq5A00', NULL, NULL, 121, NULL, NULL, 230050),
(235645, '2jxjA00', NULL, NULL, 96, NULL, NULL, 230050),
(235646, '2cxyA00', NULL, NULL, 125, NULL, NULL, 230050),
(235647, '1ig6A00', NULL, NULL, 107, NULL, NULL, 230050),
(235648, '1kkxA00', NULL, NULL, 123, NULL, NULL, 230050),
(235649, '2lm1A00', NULL, NULL, 107, NULL, NULL, 230050),
(235650, '2jrzA00', NULL, NULL, 117, NULL, NULL, 230050),
(235651, '1ryuA00', NULL, NULL, 120, NULL, NULL, 230050),
(235652, '2li6A00', NULL, NULL, 116, NULL, NULL, 230050),
(235653, '2yqeA00', NULL, NULL, 100, NULL, NULL, 230050),
(235654, '4xjxB01', NULL, NULL, 197, NULL, NULL, 230051),
(235655, '4zc3A00', NULL, NULL, 68, NULL, NULL, 230052),
(235656, '2dvtA00', NULL, NULL, 327, NULL, NULL, 230053),
(235657, '3qgaC02', NULL, NULL, 380, NULL, NULL, 230053),
(235658, '2yxoB00', NULL, NULL, 267, NULL, NULL, 230053),
(235659, '1kcxA02', NULL, NULL, 373, NULL, NULL, 230053),
(235660, '2gzxA00', NULL, NULL, 265, NULL, NULL, 230053),
(235661, '4m51A02', NULL, NULL, 300, NULL, NULL, 230053),
(235662, '3lgdA00', NULL, NULL, 484, NULL, NULL, 230053),
(235663, '3feqC02', NULL, NULL, 303, NULL, NULL, 230053),
(235664, '4g2dA00', NULL, NULL, 315, NULL, NULL, 230053),
(235665, '2anuA00', NULL, NULL, 239, NULL, NULL, 230053),
(235666, '1vflA00', NULL, NULL, 356, NULL, NULL, 230053),
(235667, '2ftyD02', NULL, NULL, 415, NULL, NULL, 230053),
(235668, '2gwnA02', NULL, NULL, 336, NULL, NULL, 230053),
(235669, '1zzmA00', NULL, NULL, 259, NULL, NULL, 230053),
(235670, '3rcmA00', NULL, NULL, 287, NULL, NULL, 230053),
(235671, '4gx8B00', NULL, NULL, 315, NULL, NULL, 230053),
(235672, '5nksA02', NULL, NULL, 373, NULL, NULL, 230053),
(235673, '4cqbA02', NULL, NULL, 301, NULL, NULL, 230053),
(235674, '4tqtA01', NULL, NULL, 450, NULL, NULL, 230053),
(235675, '3sfwA02', NULL, NULL, 328, NULL, NULL, 230053),
(235676, '2oodA02', NULL, NULL, 323, NULL, NULL, 230053),
(235677, '1o12B02', NULL, NULL, 290, NULL, NULL, 230053),
(235678, '1ynyA02', NULL, NULL, 328, NULL, NULL, 230053),
(235679, '5lewA01', NULL, NULL, 289, NULL, NULL, 230053),
(235680, '3e74B02', NULL, NULL, 348, NULL, NULL, 230053),
(235681, '4lanB00', NULL, NULL, 376, NULL, NULL, 230053),
(235682, '3jzeB00', NULL, NULL, 343, NULL, NULL, 230053),
(235683, '1m65A00', NULL, NULL, 245, NULL, NULL, 230053),
(235684, '4hjwA00', NULL, NULL, 378, NULL, NULL, 230053),
(235685, '1xrtA02', NULL, NULL, 310, NULL, NULL, 230053),
(235686, '4di9A00', NULL, NULL, 303, NULL, NULL, 230053),
(235687, '3rhgA00', NULL, NULL, 365, NULL, NULL, 230053),
(235688, '4xd3A00', NULL, NULL, 333, NULL, NULL, 230053),
(235689, '2ob3A00', NULL, NULL, 330, NULL, NULL, 230053),
(235690, '2vunA02', NULL, NULL, 258, NULL, NULL, 230053),
(235691, '3mtwA02', NULL, NULL, 302, NULL, NULL, 230053),
(235692, '2hbvB00', NULL, NULL, 334, NULL, NULL, 230053),
(235693, '2ftwA01', NULL, NULL, 450, NULL, NULL, 230053),
(235694, '4dzhA02', NULL, NULL, 291, NULL, NULL, 230053),
(235695, '4do7A00', NULL, NULL, 303, NULL, NULL, 230053),
(235696, '3ly0A00', NULL, NULL, 364, NULL, NULL, 230053),
(235697, '3f2bA02', NULL, NULL, 263, NULL, NULL, 230053),
(235698, '3lu2A00', NULL, NULL, 311, NULL, NULL, 230053),
(235699, '1p1mA02', NULL, NULL, 281, NULL, NULL, 230053),
(235700, '1k1dA02', NULL, NULL, 328, NULL, NULL, 230053),
(235701, '2puzA02', NULL, NULL, 299, NULL, NULL, 230053),
(235702, '3griA02', NULL, NULL, 313, NULL, NULL, 230053),
(235703, '3e2vB00', NULL, NULL, 401, NULL, NULL, 230053),
(235704, '5xgwA02', NULL, NULL, 283, NULL, NULL, 230053),
(235705, '3guwA00', NULL, NULL, 261, NULL, NULL, 230053),
(235706, '5lxxA02', NULL, NULL, 373, NULL, NULL, 230053),
(235707, '2vhlA02', NULL, NULL, 301, NULL, NULL, 230053),
(235708, '1gkpB02', NULL, NULL, 329, NULL, NULL, 230053),
(235709, '4mupB00', NULL, NULL, 289, NULL, NULL, 230053);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(235710, '3tn4A00', NULL, NULL, 324, NULL, NULL, 230053),
(235711, '4i6kA00', NULL, NULL, 270, NULL, NULL, 230053),
(235712, '4i6vA01', NULL, NULL, 349, NULL, NULL, 230053),
(235713, '4yiwA02', NULL, NULL, 313, NULL, NULL, 230053),
(235714, '2vr2A01', NULL, NULL, 447, NULL, NULL, 230053),
(235715, '4c65A02', NULL, NULL, 318, NULL, NULL, 230053),
(235716, '3hpaA02', NULL, NULL, 332, NULL, NULL, 230053),
(235717, '1v77A00', NULL, NULL, 212, NULL, NULL, 230053),
(235718, '1e9yB02', NULL, NULL, 380, NULL, NULL, 230053),
(235719, '3gg7A00', NULL, NULL, 254, NULL, NULL, 230053),
(235720, '1yrrA02', NULL, NULL, 290, NULL, NULL, 230053),
(235721, '3id7A00', NULL, NULL, 400, NULL, NULL, 230053),
(235722, '4whbA02', NULL, NULL, 348, NULL, NULL, 230053),
(235723, '3ooqA02', NULL, NULL, 291, NULL, NULL, 230053),
(235724, '3pnuB00', NULL, NULL, 359, NULL, NULL, 230053),
(235725, '1ituA00', NULL, NULL, 369, NULL, NULL, 230053),
(235726, '3ovgA00', NULL, NULL, 363, NULL, NULL, 230053),
(235727, '3lnpA02', NULL, NULL, 296, NULL, NULL, 230053),
(235728, '3ij6A00', NULL, NULL, 312, NULL, NULL, 230053),
(235729, '4rdzB00', NULL, NULL, 316, NULL, NULL, 230053),
(235730, '2bb0A02', NULL, NULL, 298, NULL, NULL, 230053),
(235731, '3rysB00', NULL, NULL, 343, NULL, NULL, 230053),
(235732, '2i9uA02', NULL, NULL, 308, NULL, NULL, 230053),
(235733, '3nqbA02', NULL, NULL, 246, NULL, NULL, 230053),
(235734, '4lfyA00', NULL, NULL, 356, NULL, NULL, 230053),
(235735, '6bh7G00', NULL, NULL, 333, NULL, NULL, 230053),
(235736, '2z26B00', NULL, NULL, 347, NULL, NULL, 230053),
(235737, '4qrnB00', NULL, NULL, 348, NULL, NULL, 230053),
(235738, '2hpiA01', NULL, NULL, 284, NULL, NULL, 230053),
(235739, '3b0xA05', NULL, NULL, 249, NULL, NULL, 230053),
(235740, '1onwB02', NULL, NULL, 279, NULL, NULL, 230053),
(235741, '4f0lA02', NULL, NULL, 343, NULL, NULL, 230053),
(235742, '2imrA02', NULL, NULL, 311, NULL, NULL, 230053),
(235743, '6hfqA00', NULL, NULL, 368, NULL, NULL, 230053),
(235744, '1yixA00', NULL, NULL, 265, NULL, NULL, 230053),
(235745, '6gbjA00', NULL, NULL, 336, NULL, NULL, 230053),
(235746, '4ub9A02', NULL, NULL, 345, NULL, NULL, 230053),
(235747, '2yb1A01', NULL, NULL, 219, NULL, NULL, 230053),
(235748, '6ctyE00', NULL, NULL, 344, NULL, NULL, 230053),
(235749, '1gkrB02', NULL, NULL, 321, NULL, NULL, 230053),
(235750, '3hm7A02', NULL, NULL, 345, NULL, NULL, 230053),
(235751, '2wjeA00', NULL, NULL, 247, NULL, NULL, 230053),
(235752, '3nehA00', NULL, NULL, 318, NULL, NULL, 230053),
(235753, '4r85A02', NULL, NULL, 309, NULL, NULL, 230053),
(235754, '2w9mA05', NULL, NULL, 263, NULL, NULL, 230053),
(235755, '2z00A02', NULL, NULL, 319, NULL, NULL, 230053),
(235756, '3mviA00', NULL, NULL, 349, NULL, NULL, 230053),
(235757, '5vrkA00', NULL, NULL, 314, NULL, NULL, 230053),
(235758, '4qroG00', NULL, NULL, 332, NULL, NULL, 230053),
(235759, '2amxB00', NULL, NULL, 376, NULL, NULL, 230053),
(235760, '2ragA00', NULL, NULL, 381, NULL, NULL, 230053),
(235761, '1rk6A02', NULL, NULL, 297, NULL, NULL, 230053),
(235762, '4f0rA02', NULL, NULL, 291, NULL, NULL, 230053),
(235763, '2qs8A02', NULL, NULL, 307, NULL, NULL, 230053),
(235764, '3mkvA02', NULL, NULL, 306, NULL, NULL, 230053),
(235765, '4z42C02', NULL, NULL, 381, NULL, NULL, 230053),
(235766, '6bhlA00', NULL, NULL, 324, NULL, NULL, 230053),
(235767, '2wm1A00', NULL, NULL, 336, NULL, NULL, 230053),
(235768, '3ipwA00', NULL, NULL, 303, NULL, NULL, 230053),
(235769, '4lcqA01', NULL, NULL, 444, NULL, NULL, 230053),
(235770, '3dcpA00', NULL, NULL, 283, NULL, NULL, 230053),
(235771, '2gwgA00', NULL, NULL, 350, NULL, NULL, 230053),
(235772, '4l6dA00', NULL, NULL, 335, NULL, NULL, 230053),
(235773, '1j6oA00', NULL, NULL, 268, NULL, NULL, 230053),
(235774, '3k2gA00', NULL, NULL, 364, NULL, NULL, 230053),
(235775, '2icsA02', NULL, NULL, 267, NULL, NULL, 230053),
(235776, '2y1hB00', NULL, NULL, 272, NULL, NULL, 230053),
(235777, '2q09A02', NULL, NULL, 299, NULL, NULL, 230053),
(235778, '3nurA00', NULL, NULL, 335, NULL, NULL, 230053),
(235779, '4v1xA02', NULL, NULL, 356, NULL, NULL, 230053),
(235780, '3dc8A01', NULL, NULL, 438, NULL, NULL, 230053);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(235781, '4gbdA02', NULL, NULL, 291, NULL, NULL, 230053),
(235782, '5e5cA01', NULL, NULL, 441, NULL, NULL, 230053),
(235783, '1j5sA01', NULL, NULL, 360, NULL, NULL, 230053),
(235784, '2ffiA00', NULL, NULL, 288, NULL, NULL, 230053),
(235785, '3cjpA00', NULL, NULL, 272, NULL, NULL, 230053),
(235786, '3ls9A02', NULL, NULL, 324, NULL, NULL, 230053),
(235787, '5ol4C02', NULL, NULL, 381, NULL, NULL, 230053),
(235788, '3iacC01', NULL, NULL, 380, NULL, NULL, 230053),
(235789, '1bf6A00', NULL, NULL, 291, NULL, NULL, 230053),
(235790, '2a3lA01', NULL, NULL, 537, NULL, NULL, 230053),
(235791, '2q01A01', NULL, NULL, 391, NULL, NULL, 230053),
(235792, '4b91A01', NULL, NULL, 451, NULL, NULL, 230053),
(235793, '4if2A00', NULL, NULL, 326, NULL, NULL, 230053),
(235794, '4bknA02', NULL, NULL, 373, NULL, NULL, 230053),
(235795, '3iv8A02', NULL, NULL, 287, NULL, NULL, 230053),
(235796, '2f6kA00', NULL, NULL, 307, NULL, NULL, 230053),
(235797, '3icjA02', NULL, NULL, 287, NULL, NULL, 230053),
(235798, '4gxwB00', NULL, NULL, 380, NULL, NULL, 230053),
(235799, '3irsA00', NULL, NULL, 291, NULL, NULL, 230053),
(235800, '3e38B01', NULL, NULL, 245, NULL, NULL, 230053),
(235801, '3a4jA00', NULL, NULL, 329, NULL, NULL, 230053),
(235802, '3wyzA00', NULL, NULL, 220, NULL, NULL, 230053),
(235803, '3iarA00', NULL, NULL, 367, NULL, NULL, 230053),
(235804, '4aqlA02', NULL, NULL, 311, NULL, NULL, 230053),
(235805, '3paoB00', NULL, NULL, 326, NULL, NULL, 230053),
(235806, '3gtxA00', NULL, NULL, 339, NULL, NULL, 230053),
(235807, '4dziB00', NULL, NULL, 394, NULL, NULL, 230053),
(235808, '4pbeA00', NULL, NULL, 333, NULL, NULL, 230053),
(235809, '5nnlA00', NULL, NULL, 342, NULL, NULL, 230053),
(235810, '4g7eA04', NULL, NULL, 363, NULL, NULL, 230053),
(235811, '1ejxC02', NULL, NULL, 379, NULL, NULL, 230053),
(235812, '3b40A01', NULL, NULL, 359, NULL, NULL, 230053),
(235813, '2ogjA02', NULL, NULL, 266, NULL, NULL, 230053),
(235814, '6ii7A00', NULL, NULL, 367, NULL, NULL, 230053),
(235815, '4gy7A04', NULL, NULL, 363, NULL, NULL, 230053),
(235816, '2pajA02', NULL, NULL, 330, NULL, NULL, 230053),
(235817, '3be7A02', NULL, NULL, 300, NULL, NULL, 230053),
(235818, '6g23A00', NULL, NULL, 332, NULL, NULL, 230053),
(235819, '3ighX02', NULL, NULL, 294, NULL, NULL, 230053),
(235820, '4p5uA00', NULL, NULL, 262, NULL, NULL, 230053),
(235821, '2i5gA00', NULL, NULL, 325, NULL, NULL, 230053),
(235822, '3o0fA01', NULL, NULL, 227, NULL, NULL, 230053),
(235823, '4gc3A00', NULL, NULL, 264, NULL, NULL, 230053),
(235824, '3mduA02', NULL, NULL, 344, NULL, NULL, 230053),
(235825, '2xioA00', NULL, NULL, 301, NULL, NULL, 230053),
(235826, '3qy7A00', NULL, NULL, 262, NULL, NULL, 230053),
(235827, '3gipA02', NULL, NULL, 297, NULL, NULL, 230053),
(235828, '1ra0A02', NULL, NULL, 308, NULL, NULL, 230053),
(235829, '2pgfA00', NULL, NULL, 371, NULL, NULL, 230053),
(235830, '2qpxA00', NULL, NULL, 376, NULL, NULL, 230053),
(235831, '1nfgA02', NULL, NULL, 350, NULL, NULL, 230053),
(235832, '3pnzC00', NULL, NULL, 330, NULL, NULL, 230053),
(235833, '5nryA00', NULL, NULL, 385, NULL, NULL, 230053),
(235834, '5vgmA00', NULL, NULL, 345, NULL, NULL, 230053),
(235835, '3cniA00', NULL, NULL, 156, NULL, NULL, 230054),
(235836, '2kvcA01', NULL, NULL, 88, NULL, NULL, 230055),
(235837, '2m0nA00', NULL, NULL, 112, NULL, NULL, 230055),
(235838, '2lkyA00', NULL, NULL, 112, NULL, NULL, 230055),
(235839, '1ldjA05', NULL, NULL, 74, NULL, NULL, 230056),
(235840, '4n1vA00', NULL, NULL, 100, NULL, NULL, 230057),
(235841, '1owfB00', NULL, NULL, 94, NULL, NULL, 230057),
(235842, '1owfA00', NULL, NULL, 99, NULL, NULL, 230057),
(235843, '5lvtA00', NULL, NULL, 91, NULL, NULL, 230057),
(235844, '1p71B00', NULL, NULL, 94, NULL, NULL, 230057),
(235845, '4p3vA00', NULL, NULL, 90, NULL, NULL, 230057),
(235846, '2iieA02', NULL, NULL, 96, NULL, NULL, 230057),
(235847, '4fmrA02', NULL, NULL, 88, NULL, NULL, 230057),
(235848, '2np2A00', NULL, NULL, 108, NULL, NULL, 230057),
(235849, '5ekaA00', NULL, NULL, 96, NULL, NULL, 230057),
(235850, '3rhiB00', NULL, NULL, 93, NULL, NULL, 230057),
(235851, '1exeA00', NULL, NULL, 99, NULL, NULL, 230057);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(235852, '5fbmA00', NULL, NULL, 99, NULL, NULL, 230057),
(235853, '1b8zA00', NULL, NULL, 90, NULL, NULL, 230057),
(235854, '6n2lA00', NULL, NULL, 100, NULL, NULL, 230057),
(235855, '4pt4B00', NULL, NULL, 99, NULL, NULL, 230057),
(235856, '2ndpA00', NULL, NULL, 99, NULL, NULL, 230057),
(235857, '1huuA00', NULL, NULL, 90, NULL, NULL, 230057),
(235858, '1mulA00', NULL, NULL, 90, NULL, NULL, 230057),
(235859, '4qjuA00', NULL, NULL, 98, NULL, NULL, 230057),
(235860, '4k91A02', NULL, NULL, 91, NULL, NULL, 230058),
(235861, '1xp4C02', NULL, NULL, 101, NULL, NULL, 230058),
(235862, '3itbA02', NULL, NULL, 92, NULL, NULL, 230058),
(235863, '3mzfA02', NULL, NULL, 92, NULL, NULL, 230058),
(235864, '3a3jA02', NULL, NULL, 92, NULL, NULL, 230058),
(235865, '2rslA00', NULL, NULL, 122, NULL, NULL, 230059),
(235866, '5c35A00', NULL, NULL, 128, NULL, NULL, 230059),
(235867, '3bvpB00', NULL, NULL, 138, NULL, NULL, 230059),
(235868, '5c35B00', NULL, NULL, 128, NULL, NULL, 230059),
(235869, '2gm5D00', NULL, NULL, 139, NULL, NULL, 230059),
(235870, '2mhcA00', NULL, NULL, 120, NULL, NULL, 230059),
(235871, '3ilxA01', NULL, NULL, 99, NULL, NULL, 230059),
(235872, '5c31C00', NULL, NULL, 128, NULL, NULL, 230059),
(235873, '6dgbA01', NULL, NULL, 96, NULL, NULL, 230059),
(235874, '5c31D00', NULL, NULL, 128, NULL, NULL, 230059),
(235875, '5c31E00', NULL, NULL, 128, NULL, NULL, 230059),
(235876, '5c31F00', NULL, NULL, 128, NULL, NULL, 230059),
(235877, '5c31G00', NULL, NULL, 128, NULL, NULL, 230059),
(235878, '5c31H00', NULL, NULL, 128, NULL, NULL, 230059),
(235879, '5c31I00', NULL, NULL, 128, NULL, NULL, 230059),
(235880, '5c31J00', NULL, NULL, 128, NULL, NULL, 230059),
(235881, '4bqqA01', NULL, NULL, 149, NULL, NULL, 230059),
(235882, '3lhfC01', NULL, NULL, 99, NULL, NULL, 230059),
(235883, '5c31K00', NULL, NULL, 128, NULL, NULL, 230059),
(235884, '5c31L00', NULL, NULL, 128, NULL, NULL, 230059),
(235885, '3g13A00', NULL, NULL, 169, NULL, NULL, 230059),
(235886, '3pkzG00', NULL, NULL, 124, NULL, NULL, 230059),
(235887, '3guvA00', NULL, NULL, 167, NULL, NULL, 230059),
(235888, '3g13B00', NULL, NULL, 139, NULL, NULL, 230059),
(235889, '5c31B00', NULL, NULL, 128, NULL, NULL, 230059),
(235890, '5c31A00', NULL, NULL, 128, NULL, NULL, 230059),
(235891, '3lhkA01', NULL, NULL, 102, NULL, NULL, 230059),
(235892, '5c34B00', NULL, NULL, 128, NULL, NULL, 230059),
(235893, '5c32A00', NULL, NULL, 128, NULL, NULL, 230059),
(235894, '5c34C00', NULL, NULL, 128, NULL, NULL, 230059),
(235895, '5c32B00', NULL, NULL, 128, NULL, NULL, 230059),
(235896, '5c32C00', NULL, NULL, 128, NULL, NULL, 230059),
(235897, '6dgcA01', NULL, NULL, 101, NULL, NULL, 230059),
(235898, '5c32D00', NULL, NULL, 128, NULL, NULL, 230059),
(235899, '3uj3X00', NULL, NULL, 125, NULL, NULL, 230059),
(235900, '4e27B00', NULL, NULL, 175, NULL, NULL, 230060),
(235901, '4dmiA02', NULL, NULL, 137, NULL, NULL, 230060),
(235902, '1igqB00', NULL, NULL, 62, NULL, NULL, 230061),
(235903, '3otxA02', NULL, NULL, 63, NULL, NULL, 230062),
(235904, '3looA02', NULL, NULL, 63, NULL, NULL, 230062),
(235905, '2absA02', NULL, NULL, 62, NULL, NULL, 230062),
(235906, '5kb6A02', NULL, NULL, 63, NULL, NULL, 230062),
(235907, '3vasA02', NULL, NULL, 63, NULL, NULL, 230062),
(235908, '3n8hA02', NULL, NULL, 76, NULL, NULL, 230063),
(235909, '1v8fA02', NULL, NULL, 99, NULL, NULL, 230063),
(235910, '3mxtA02', NULL, NULL, 100, NULL, NULL, 230063),
(235911, '2ejcA02', NULL, NULL, 100, NULL, NULL, 230063),
(235912, '3innA02', NULL, NULL, 101, NULL, NULL, 230063),
(235913, '3mueC02', NULL, NULL, 105, NULL, NULL, 230063),
(235914, '5kwvA02', NULL, NULL, 99, NULL, NULL, 230063),
(235915, '3uk2A02', NULL, NULL, 103, NULL, NULL, 230063),
(235916, '3covA02', NULL, NULL, 115, NULL, NULL, 230063),
(235917, '3ag6A02', NULL, NULL, 100, NULL, NULL, 230063),
(235918, '3q12B02', NULL, NULL, 105, NULL, NULL, 230063),
(235919, '1ihoA02', NULL, NULL, 104, NULL, NULL, 230063),
(235920, '2l1nA00', NULL, NULL, 120, NULL, NULL, 230064),
(235921, '1q16A10', NULL, NULL, 89, NULL, NULL, 230065),
(235922, '3wvtA02', NULL, NULL, 46, NULL, NULL, 230066);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(235923, '3wvtA01', NULL, NULL, 60, NULL, NULL, 230066),
(235924, '1d4vA03', NULL, NULL, 46, NULL, NULL, 230066),
(235925, '1d4vA02', NULL, NULL, 31, NULL, NULL, 230066),
(235926, '1extA02', NULL, NULL, 51, NULL, NULL, 230066),
(235927, '1extA01', NULL, NULL, 87, NULL, NULL, 230066),
(235928, '4mxwR02', NULL, NULL, 85, NULL, NULL, 230066),
(235929, '4mxwS00', NULL, NULL, 83, NULL, NULL, 230066),
(235930, '2h9gS00', NULL, NULL, 64, NULL, NULL, 230066),
(235931, '2uwiA01', NULL, NULL, 84, NULL, NULL, 230066),
(235932, '2uwiA02', NULL, NULL, 58, NULL, NULL, 230066),
(235933, '5dmjA02', NULL, NULL, 82, NULL, NULL, 230066),
(235934, '2heyT02', NULL, NULL, 85, NULL, NULL, 230066),
(235935, '5dmjF01', NULL, NULL, 84, NULL, NULL, 230066),
(235936, '1sg1X01', NULL, NULL, 82, NULL, NULL, 230066),
(235937, '3thmF00', NULL, NULL, 79, NULL, NULL, 230066),
(235938, '3mi8D02', NULL, NULL, 34, NULL, NULL, 230066),
(235939, '3fl7A03', NULL, NULL, 65, NULL, NULL, 230066),
(235940, '2heyR01', NULL, NULL, 52, NULL, NULL, 230066),
(235941, '3me4B02', NULL, NULL, 79, NULL, NULL, 230066),
(235942, '3me4B01', NULL, NULL, 80, NULL, NULL, 230066),
(235943, '1sg1X02', NULL, NULL, 79, NULL, NULL, 230066),
(235944, '3u3pA02', NULL, NULL, 81, NULL, NULL, 230066),
(235945, '3u3pA01', NULL, NULL, 92, NULL, NULL, 230066),
(235946, '5cirE02', NULL, NULL, 40, NULL, NULL, 230066),
(235947, '3qd6R02', NULL, NULL, 40, NULL, NULL, 230066),
(235948, '3alqU01', NULL, NULL, 88, NULL, NULL, 230066),
(235949, '3alqR02', NULL, NULL, 85, NULL, NULL, 230066),
(235950, '5t2qA01', NULL, NULL, 61, NULL, NULL, 230066),
(235951, '3mhdD02', NULL, NULL, 51, NULL, NULL, 230066),
(235952, '5t2qB02', NULL, NULL, 47, NULL, NULL, 230066),
(235953, '3tjeF02', NULL, NULL, 42, NULL, NULL, 230066),
(235954, '4yn0A01', NULL, NULL, 94, NULL, NULL, 230066),
(235955, '5cirE01', NULL, NULL, 41, NULL, NULL, 230066),
(235956, '4kgqC01', NULL, NULL, 86, NULL, NULL, 230066),
(235957, '4i9xC02', NULL, NULL, 40, NULL, NULL, 230066),
(235958, '4e4dR01', NULL, NULL, 86, NULL, NULL, 230066),
(235959, '4m4pA03', NULL, NULL, 64, NULL, NULL, 230066),
(235960, '4e4dR02', NULL, NULL, 55, NULL, NULL, 230066),
(235961, '3urfZ02', NULL, NULL, 85, NULL, NULL, 230066),
(235962, '3tjeF01', NULL, NULL, 48, NULL, NULL, 230066),
(235963, '4yn0A02', NULL, NULL, 96, NULL, NULL, 230066),
(235964, '3urfZ01', NULL, NULL, 86, NULL, NULL, 230066),
(235965, '4kgqD02', NULL, NULL, 88, NULL, NULL, 230066),
(235966, '3ikoC02', NULL, NULL, 149, NULL, NULL, 230067),
(235967, '1a8vA01', NULL, NULL, 50, NULL, NULL, 230068),
(235968, '1e7lA02', NULL, NULL, 55, NULL, NULL, 230068),
(235969, '3l0oA01', NULL, NULL, 52, NULL, NULL, 230068),
(235970, '1a62A01', NULL, NULL, 47, NULL, NULL, 230068),
(235971, '2hjqA02', NULL, NULL, 53, NULL, NULL, 230068),
(235972, '3nymA00', NULL, NULL, 128, NULL, NULL, 230069),
(235973, '3nymB00', NULL, NULL, 128, NULL, NULL, 230069),
(235974, '2jynA01', NULL, NULL, 136, NULL, NULL, 230070),
(235975, '2nwdX00', NULL, NULL, 130, NULL, NULL, 230071),
(235976, '6ip9A00', NULL, NULL, 123, NULL, NULL, 230071),
(235977, '1wvvB02', NULL, NULL, 196, NULL, NULL, 230071),
(235978, '5xuwA00', NULL, NULL, 129, NULL, NULL, 230071),
(235979, '5h7tA01', NULL, NULL, 153, NULL, NULL, 230071),
(235980, '2fbdA00', NULL, NULL, 122, NULL, NULL, 230071),
(235981, '2z2fA00', NULL, NULL, 129, NULL, NULL, 230071),
(235982, '1gbsA00', NULL, NULL, 185, NULL, NULL, 230071),
(235983, '6gi4B00', NULL, NULL, 194, NULL, NULL, 230071),
(235984, '1j8wA00', NULL, NULL, 123, NULL, NULL, 230071),
(235985, '1b9oA00', NULL, NULL, 123, NULL, NULL, 230071),
(235986, '2z37A01', NULL, NULL, 185, NULL, NULL, 230071),
(235987, '3vwoA01', NULL, NULL, 110, NULL, NULL, 230071),
(235988, '1xsfA00', NULL, NULL, 108, NULL, NULL, 230071),
(235989, '4ow1A00', NULL, NULL, 92, NULL, NULL, 230071),
(235990, '1ltmA02', NULL, NULL, 173, NULL, NULL, 230071),
(235991, '2gv0A00', NULL, NULL, 131, NULL, NULL, 230071),
(235992, '4yf2A00', NULL, NULL, 138, NULL, NULL, 230071),
(235993, '1hfxA00', NULL, NULL, 123, NULL, NULL, 230071);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(235994, '3w6bB00', NULL, NULL, 153, NULL, NULL, 230071),
(235995, '1ghlA00', NULL, NULL, 130, NULL, NULL, 230071),
(235996, '3wyhA00', NULL, NULL, 185, NULL, NULL, 230071),
(235997, '3hbeX01', NULL, NULL, 146, NULL, NULL, 230071),
(235998, '4hpeA01', NULL, NULL, 160, NULL, NULL, 230071),
(235999, '1qqyA00', NULL, NULL, 130, NULL, NULL, 230071),
(236000, '4cfpA02', NULL, NULL, 168, NULL, NULL, 230071),
(236001, '2dkvA02', NULL, NULL, 209, NULL, NULL, 230071),
(236002, '1gd6A00', NULL, NULL, 119, NULL, NULL, 230071),
(236003, '1am7A00', NULL, NULL, 158, NULL, NULL, 230071),
(236004, '5dn4A01', NULL, NULL, 104, NULL, NULL, 230071),
(236005, '1yroA00', NULL, NULL, 123, NULL, NULL, 230071),
(236006, '2dqaA00', NULL, NULL, 124, NULL, NULL, 230071),
(236007, '4anrA02', NULL, NULL, 187, NULL, NULL, 230071),
(236008, '1jseA00', NULL, NULL, 129, NULL, NULL, 230071),
(236009, '2cjlA01', NULL, NULL, 143, NULL, NULL, 230071),
(236010, '2vb1A00', NULL, NULL, 129, NULL, NULL, 230071),
(236011, '2baaA01', NULL, NULL, 185, NULL, NULL, 230071),
(236012, '4dygA01', NULL, NULL, 186, NULL, NULL, 230071),
(236013, '3gxrC00', NULL, NULL, 187, NULL, NULL, 230071),
(236014, '5v92A00', NULL, NULL, 129, NULL, NULL, 230071),
(236015, '4tx7A01', NULL, NULL, 188, NULL, NULL, 230071),
(236016, '3wh1A01', NULL, NULL, 147, NULL, NULL, 230071),
(236017, '1wvvA01', NULL, NULL, 148, NULL, NULL, 230071),
(236018, '4g9sA00', NULL, NULL, 187, NULL, NULL, 230071),
(236019, '2zycA01', NULL, NULL, 107, NULL, NULL, 230071),
(236020, '3cqlA01', NULL, NULL, 185, NULL, NULL, 230071),
(236021, '4fdyA01', NULL, NULL, 161, NULL, NULL, 230071),
(236022, '4qdnA00', NULL, NULL, 136, NULL, NULL, 230071),
(236023, '3b0kA00', NULL, NULL, 123, NULL, NULL, 230071),
(236024, '3ct5A00', NULL, NULL, 159, NULL, NULL, 230071),
(236025, '4cgeB00', NULL, NULL, 75, NULL, NULL, 230071),
(236026, '4kt3A00', NULL, NULL, 149, NULL, NULL, 230071),
(236027, '3zvqA00', NULL, NULL, 70, NULL, NULL, 230071),
(236028, '1dxjA01', NULL, NULL, 185, NULL, NULL, 230071),
(236029, '3w3eA01', NULL, NULL, 186, NULL, NULL, 230071),
(236030, '1jugA00', NULL, NULL, 125, NULL, NULL, 230071),
(236031, '1iizA00', NULL, NULL, 120, NULL, NULL, 230071),
(236032, '4mstB01', NULL, NULL, 184, NULL, NULL, 230071),
(236033, '4mckA01', NULL, NULL, 143, NULL, NULL, 230071),
(236034, '3fi7A01', NULL, NULL, 130, NULL, NULL, 230071),
(236035, '1alcA00', NULL, NULL, 123, NULL, NULL, 230071),
(236036, '132lA00', NULL, NULL, 129, NULL, NULL, 230071),
(236037, '4pj2C00', NULL, NULL, 122, NULL, NULL, 230071),
(236038, '1qsaA03', NULL, NULL, 173, NULL, NULL, 230071),
(236039, '3cb7A00', NULL, NULL, 126, NULL, NULL, 230071),
(236040, '1hhlA00', NULL, NULL, 129, NULL, NULL, 230071),
(236041, '1lmqA00', NULL, NULL, 129, NULL, NULL, 230071),
(236042, '2ihlA00', NULL, NULL, 129, NULL, NULL, 230071),
(236043, '3bkhA02', NULL, NULL, 182, NULL, NULL, 230071),
(236044, '1ivmA00', NULL, NULL, 130, NULL, NULL, 230071),
(236045, '4emnA00', NULL, NULL, 81, NULL, NULL, 230071),
(236046, '1sziA02', NULL, NULL, 137, NULL, NULL, 230072),
(236047, '3iqcA00', NULL, NULL, 131, NULL, NULL, 230072),
(236048, '4iwbB00', NULL, NULL, 165, NULL, NULL, 230072),
(236049, '1orjD00', NULL, NULL, 130, NULL, NULL, 230072),
(236050, '4g6uA01', NULL, NULL, 88, NULL, NULL, 230073),
(236051, '3zs6A03', NULL, NULL, 217, NULL, NULL, 230074),
(236052, '1jetA03', NULL, NULL, 216, NULL, NULL, 230074),
(236053, '4qflA03', NULL, NULL, 219, NULL, NULL, 230074),
(236054, '1xocA03', NULL, NULL, 224, NULL, NULL, 230074),
(236055, '1zu0A03', NULL, NULL, 246, NULL, NULL, 230074),
(236056, '4onyA02', NULL, NULL, 260, NULL, NULL, 230074),
(236057, '2o7iA03', NULL, NULL, 254, NULL, NULL, 230074),
(236058, '3tchA03', NULL, NULL, 216, NULL, NULL, 230074),
(236059, '3ry3A02', NULL, NULL, 240, NULL, NULL, 230074),
(236060, '6npoA03', NULL, NULL, 227, NULL, NULL, 230074),
(236061, '2d5wA03', NULL, NULL, 248, NULL, NULL, 230074),
(236062, '6dquA03', NULL, NULL, 219, NULL, NULL, 230074),
(236063, '4fajA03', NULL, NULL, 217, NULL, NULL, 230074),
(236064, '3tpaA03', NULL, NULL, 218, NULL, NULL, 230074);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(236065, '3rqtA02', NULL, NULL, 213, NULL, NULL, 230074),
(236066, '4ze9A03', NULL, NULL, 210, NULL, NULL, 230074),
(236067, '5kztA03', NULL, NULL, 228, NULL, NULL, 230074),
(236068, '2b4lA02', NULL, NULL, 157, NULL, NULL, 230074),
(236069, '2grvB03', NULL, NULL, 222, NULL, NULL, 230074),
(236070, '1uqwA03', NULL, NULL, 225, NULL, NULL, 230074),
(236071, '3pamB00', NULL, NULL, 259, NULL, NULL, 230074),
(236072, '3o6pA00', NULL, NULL, 229, NULL, NULL, 230074),
(236073, '3t66A02', NULL, NULL, 221, NULL, NULL, 230074),
(236074, '5on8A02', NULL, NULL, 228, NULL, NULL, 230074),
(236075, '2z23A03', NULL, NULL, 216, NULL, NULL, 230074),
(236076, '3m8uA03', NULL, NULL, 218, NULL, NULL, 230074),
(236077, '3drfA02', NULL, NULL, 241, NULL, NULL, 230074),
(236078, '6i3gA03', NULL, NULL, 209, NULL, NULL, 230074),
(236079, '4oerA02', NULL, NULL, 228, NULL, NULL, 230074),
(236080, '4oevA03', NULL, NULL, 220, NULL, NULL, 230074),
(236081, '5f1qA03', NULL, NULL, 219, NULL, NULL, 230074),
(236082, '4pfyA03', NULL, NULL, 241, NULL, NULL, 230074),
(236083, '5yqwA03', NULL, NULL, 246, NULL, NULL, 230074),
(236084, '5isuA03', NULL, NULL, 211, NULL, NULL, 230074),
(236085, '5hm4B03', NULL, NULL, 243, NULL, NULL, 230074),
(236086, '1dpeA03', NULL, NULL, 219, NULL, NULL, 230074),
(236087, '4tozA03', NULL, NULL, 216, NULL, NULL, 230074),
(236088, '4wedA02', NULL, NULL, 226, NULL, NULL, 230074),
(236089, '3lvuB00', NULL, NULL, 258, NULL, NULL, 230074),
(236090, '4gl8A03', NULL, NULL, 211, NULL, NULL, 230074),
(236091, '4ze8A03', NULL, NULL, 210, NULL, NULL, 230074),
(236092, '2wolA02', NULL, NULL, 231, NULL, NULL, 230074),
(236093, '5icqA02', NULL, NULL, 259, NULL, NULL, 230074),
(236094, '3facA00', NULL, NULL, 118, NULL, NULL, 230075),
(236095, '1k90A02', NULL, NULL, 159, NULL, NULL, 230076),
(236096, '1yrtA02', NULL, NULL, 144, NULL, NULL, 230076),
(236097, '3nwsA02', NULL, NULL, 57, NULL, NULL, 230077),
(236098, '3oiqA02', NULL, NULL, 65, NULL, NULL, 230077),
(236099, '3lfjB00', NULL, NULL, 169, NULL, NULL, 230078),
(236100, '3p3vB00', NULL, NULL, 163, NULL, NULL, 230078),
(236101, '1vsqC00', NULL, NULL, 165, NULL, NULL, 230078),
(236102, '5t5dA00', NULL, NULL, 161, NULL, NULL, 230078),
(236103, '1nrzA00', NULL, NULL, 164, NULL, NULL, 230078),
(236104, '1bleA00', NULL, NULL, 163, NULL, NULL, 230078),
(236105, '3eyeA00', NULL, NULL, 168, NULL, NULL, 230078),
(236106, '2f4nA01', NULL, NULL, 168, NULL, NULL, 230079),
(236107, '2zbvA01', NULL, NULL, 158, NULL, NULL, 230079),
(236108, '1rqpA01', NULL, NULL, 192, NULL, NULL, 230079),
(236109, '2cw5C01', NULL, NULL, 166, NULL, NULL, 230079),
(236110, '2q6kA01', NULL, NULL, 163, NULL, NULL, 230079),
(236111, '5b6iB01', NULL, NULL, 185, NULL, NULL, 230079),
(236112, '2wr8A01', NULL, NULL, 163, NULL, NULL, 230079),
(236113, '2c5uA02', NULL, NULL, 131, NULL, NULL, 230080),
(236114, '3eujA01', NULL, NULL, 262, NULL, NULL, 230081),
(236115, '1qhlA00', NULL, NULL, 227, NULL, NULL, 230081),
(236116, '1c4qA00', NULL, NULL, 69, NULL, NULL, 230082),
(236117, '4m1uB00', NULL, NULL, 70, NULL, NULL, 230082),
(236118, '2bosA00', NULL, NULL, 68, NULL, NULL, 230082),
(236119, '3iylB03', NULL, NULL, 226, NULL, NULL, 230083),
(236120, '1jmuB04', NULL, NULL, 207, NULL, NULL, 230083),
(236121, '1h8pA01', NULL, NULL, 40, NULL, NULL, 230084),
(236122, '1h8pA02', NULL, NULL, 44, NULL, NULL, 230084),
(236123, '3mqlA02', NULL, NULL, 61, NULL, NULL, 230084),
(236124, '3m7pA02', NULL, NULL, 58, NULL, NULL, 230084),
(236125, '3m7pA03', NULL, NULL, 54, NULL, NULL, 230084),
(236126, '1l6jA04', NULL, NULL, 60, NULL, NULL, 230084),
(236127, '1l6jA05', NULL, NULL, 56, NULL, NULL, 230084),
(236128, '1l6jA03', NULL, NULL, 57, NULL, NULL, 230084),
(236129, '1eakA04', NULL, NULL, 59, NULL, NULL, 230084),
(236130, '1eakA03', NULL, NULL, 57, NULL, NULL, 230084),
(236131, '2v5oA04', NULL, NULL, 51, NULL, NULL, 230084),
(236132, '1ck7A03', NULL, NULL, 47, NULL, NULL, 230084),
(236133, '1ck7A02', NULL, NULL, 53, NULL, NULL, 230084),
(236134, '1eakA05', NULL, NULL, 56, NULL, NULL, 230084),
(236135, '1j7mA00', NULL, NULL, 72, NULL, NULL, 230084);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(236136, '2wkdA00', NULL, NULL, 89, NULL, NULL, 230085),
(236137, '1pv5A00', NULL, NULL, 264, NULL, NULL, 230086),
(236138, '1bvp103', NULL, NULL, 96, NULL, NULL, 230087),
(236139, '3r6nA02', NULL, NULL, 155, NULL, NULL, 230088),
(236140, '2x49A01', NULL, NULL, 96, NULL, NULL, 230089),
(236141, '4a5pB01', NULL, NULL, 142, NULL, NULL, 230089),
(236142, '3mixA01', NULL, NULL, 120, NULL, NULL, 230089),
(236143, '3lw9A00', NULL, NULL, 168, NULL, NULL, 230089),
(236144, '3mydA01', NULL, NULL, 144, NULL, NULL, 230089),
(236145, '6ch1A01', NULL, NULL, 144, NULL, NULL, 230089),
(236146, '4c1bB01', NULL, NULL, 68, NULL, NULL, 230090),
(236147, '4ft6A01', NULL, NULL, 383, NULL, NULL, 230091),
(236148, '4frtA00', NULL, NULL, 400, NULL, NULL, 230091),
(236149, '1phoA00', NULL, NULL, 330, NULL, NULL, 230091),
(236150, '4d65A00', NULL, NULL, 343, NULL, NULL, 230091),
(236151, '3sybA00', NULL, NULL, 467, NULL, NULL, 230091),
(236152, '4fspA01', NULL, NULL, 387, NULL, NULL, 230091),
(236153, '1osmA00', NULL, NULL, 342, NULL, NULL, 230091),
(236154, '4auiA00', NULL, NULL, 308, NULL, NULL, 230091),
(236155, '5nupA00', NULL, NULL, 344, NULL, NULL, 230091),
(236156, '4rjwA00', NULL, NULL, 429, NULL, NULL, 230091),
(236157, '5dl6A00', NULL, NULL, 413, NULL, NULL, 230091),
(236158, '3upgA00', NULL, NULL, 338, NULL, NULL, 230091),
(236159, '2o4vA00', NULL, NULL, 411, NULL, NULL, 230091),
(236160, '2y0lA01', NULL, NULL, 386, NULL, NULL, 230091),
(236161, '4frxA01', NULL, NULL, 426, NULL, NULL, 230091),
(236162, '3sy7A01', NULL, NULL, 404, NULL, NULL, 230091),
(236163, '3sy9C01', NULL, NULL, 410, NULL, NULL, 230091),
(236164, '2fgqX00', NULL, NULL, 332, NULL, NULL, 230091),
(236165, '5dl8A00', NULL, NULL, 391, NULL, NULL, 230091),
(236166, '5nxrA00', NULL, NULL, 352, NULL, NULL, 230091),
(236167, '4c69X00', NULL, NULL, 295, NULL, NULL, 230091),
(236168, '2y0hA01', NULL, NULL, 387, NULL, NULL, 230091),
(236169, '3nsgA00', NULL, NULL, 341, NULL, NULL, 230091),
(236170, '2porA00', NULL, NULL, 301, NULL, NULL, 230091),
(236171, '3t24C01', NULL, NULL, 390, NULL, NULL, 230091),
(236172, '3vy8X00', NULL, NULL, 355, NULL, NULL, 230091),
(236173, '2zfgA00', NULL, NULL, 340, NULL, NULL, 230091),
(236174, '2xe1A00', NULL, NULL, 354, NULL, NULL, 230091),
(236175, '4fsoB00', NULL, NULL, 406, NULL, NULL, 230091),
(236176, '2xe5A00', NULL, NULL, 343, NULL, NULL, 230091),
(236177, '3szvA01', NULL, NULL, 380, NULL, NULL, 230091),
(236178, '4bumX00', NULL, NULL, 289, NULL, NULL, 230091),
(236179, '5dl5A00', NULL, NULL, 430, NULL, NULL, 230091),
(236180, '2j1nA00', NULL, NULL, 346, NULL, NULL, 230091),
(236181, '5fvnA00', NULL, NULL, 342, NULL, NULL, 230091),
(236182, '3szdA01', NULL, NULL, 394, NULL, NULL, 230091),
(236183, '3jtyB01', NULL, NULL, 393, NULL, NULL, 230091),
(236184, '6eneA00', NULL, NULL, 329, NULL, NULL, 230091),
(236185, '5dl7A00', NULL, NULL, 402, NULL, NULL, 230091),
(236186, '3prnA00', NULL, NULL, 289, NULL, NULL, 230091),
(236187, '3wi5A00', NULL, NULL, 312, NULL, NULL, 230091),
(236188, '2y2xA01', NULL, NULL, 383, NULL, NULL, 230091),
(236189, '4injA01', NULL, NULL, 161, NULL, NULL, 230092),
(236190, '3tlaA01', NULL, NULL, 164, NULL, NULL, 230092),
(236191, '3g23A01', NULL, NULL, 167, NULL, NULL, 230092),
(236192, '5jybA01', NULL, NULL, 168, NULL, NULL, 230092),
(236193, '4e5sC01', NULL, NULL, 161, NULL, NULL, 230092),
(236194, '4h1hA01', NULL, NULL, 161, NULL, NULL, 230092),
(236195, '4eysA01', NULL, NULL, 161, NULL, NULL, 230092),
(236196, '4jvoB01', NULL, NULL, 167, NULL, NULL, 230092),
(236197, '1zl0B01', NULL, NULL, 172, NULL, NULL, 230092),
(236198, '3k8wA02', NULL, NULL, 109, NULL, NULL, 230093),
(236199, '2dlbA00', NULL, NULL, 80, NULL, NULL, 230094),
(236200, '2kvvA00', NULL, NULL, 78, NULL, NULL, 230095),
(236201, '2jz7A00', NULL, NULL, 81, NULL, NULL, 230096),
(236202, '1t9hA03', NULL, NULL, 68, NULL, NULL, 230097),
(236203, '2yv5A03', NULL, NULL, 70, NULL, NULL, 230097),
(236204, '1u0lA03', NULL, NULL, 65, NULL, NULL, 230097),
(236205, '2rcnA03', NULL, NULL, 75, NULL, NULL, 230097),
(236206, '3ol4B01', NULL, NULL, 44, NULL, NULL, 230098);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(236207, '1epuA03', NULL, NULL, 124, NULL, NULL, 230099),
(236208, '2xheA04', NULL, NULL, 118, NULL, NULL, 230099),
(236209, '1mqsA04', NULL, NULL, 103, NULL, NULL, 230099),
(236210, '4jehA04', NULL, NULL, 120, NULL, NULL, 230099),
(236211, '4ccaA04', NULL, NULL, 118, NULL, NULL, 230099),
(236212, '3pukA04', NULL, NULL, 116, NULL, NULL, 230099),
(236213, '2iu4A02', NULL, NULL, 155, NULL, NULL, 230100),
(236214, '1oi2A02', NULL, NULL, 173, NULL, NULL, 230100),
(236215, '3ct4A02', NULL, NULL, 147, NULL, NULL, 230100),
(236216, '2mgyA01', NULL, NULL, 160, NULL, NULL, 230101),
(236217, '2p38A01', NULL, NULL, 94, NULL, NULL, 230102),
(236218, '1sqwA01', NULL, NULL, 93, NULL, NULL, 230102),
(236219, '2qtsA02', NULL, NULL, 178, NULL, NULL, 230103),
(236220, '2wx4C00', NULL, NULL, 46, NULL, NULL, 230104),
(236221, '2wx3A00', NULL, NULL, 51, NULL, NULL, 230104),
(236222, '2looA01', NULL, NULL, 33, NULL, NULL, 230105),
(236223, '1z9hA02', NULL, NULL, 43, NULL, NULL, 230106),
(236224, '4qicC01', NULL, NULL, 139, NULL, NULL, 230107),
(236225, '2lfwA01', NULL, NULL, 141, NULL, NULL, 230107),
(236226, '4g97A01', NULL, NULL, 138, NULL, NULL, 230107),
(236227, '3t0yC00', NULL, NULL, 142, NULL, NULL, 230107),
(236228, '3n0rA01', NULL, NULL, 138, NULL, NULL, 230107),
(236229, '1rp3G02', NULL, NULL, 152, NULL, NULL, 230107),
(236230, '1go3F02', NULL, NULL, 47, NULL, NULL, 230108),
(236231, '4qjfB01', NULL, NULL, 54, NULL, NULL, 230108),
(236232, '2ewrA00', NULL, NULL, 170, NULL, NULL, 230109),
(236233, '4wh5A00', NULL, NULL, 162, NULL, NULL, 230109),
(236234, '4wqkA00', NULL, NULL, 178, NULL, NULL, 230109),
(236235, '2fclA00', NULL, NULL, 169, NULL, NULL, 230109),
(236236, '2a6aA02', NULL, NULL, 69, NULL, NULL, 230110),
(236237, '2lcuA01', NULL, NULL, 185, NULL, NULL, 230111),
(236238, '2g0jB00', NULL, NULL, 112, NULL, NULL, 230112),
(236239, '2idlA01', NULL, NULL, 114, NULL, NULL, 230112),
(236240, '1s12A00', NULL, NULL, 94, NULL, NULL, 230112),
(236241, '4peoB00', NULL, NULL, 106, NULL, NULL, 230112),
(236242, '2g0iA00', NULL, NULL, 113, NULL, NULL, 230112),
(236243, '5e62A01', NULL, NULL, 37, NULL, NULL, 230113),
(236244, '1flcA01', NULL, NULL, 37, NULL, NULL, 230113),
(236245, '3g4nA01', NULL, NULL, 90, NULL, NULL, 230114),
(236246, '1bcpC01', NULL, NULL, 89, NULL, NULL, 230114),
(236247, '1bcpB01', NULL, NULL, 86, NULL, NULL, 230114),
(236248, '1vx7T02', NULL, NULL, 127, NULL, NULL, 230115),
(236249, '4a17O02', NULL, NULL, 129, NULL, NULL, 230115),
(236250, '4a1cO02', NULL, NULL, 98, NULL, NULL, 230115),
(236251, '4a1eO02', NULL, NULL, 129, NULL, NULL, 230115),
(236252, '3o58S02', NULL, NULL, 133, NULL, NULL, 230115),
(236253, '1vwxR02', NULL, NULL, 140, NULL, NULL, 230115),
(236254, '2o01L01', NULL, NULL, 111, NULL, NULL, 230116),
(236255, '5l8rL00', NULL, NULL, 157, NULL, NULL, 230116),
(236256, '1jb0L00', NULL, NULL, 154, NULL, NULL, 230116),
(236257, '5oy0000', NULL, NULL, 154, NULL, NULL, 230116),
(236258, '4xk8L00', NULL, NULL, 153, NULL, NULL, 230116),
(236259, '2wscL00', NULL, NULL, 164, NULL, NULL, 230116),
(236260, '3hrgA01', NULL, NULL, 143, NULL, NULL, 230117),
(236261, '3hlsB00', NULL, NULL, 66, NULL, NULL, 230118),
(236262, '1htrP00', NULL, NULL, 43, NULL, NULL, 230119),
(236263, '4aj5S00', NULL, NULL, 123, NULL, NULL, 230120),
(236264, '5xzgA02', NULL, NULL, 180, NULL, NULL, 230121),
(236265, '5x9cA02', NULL, NULL, 192, NULL, NULL, 230121),
(236266, '4jlxA02', NULL, NULL, 180, NULL, NULL, 230121),
(236267, '4woyA02', NULL, NULL, 193, NULL, NULL, 230121),
(236268, '4levA02', NULL, NULL, 177, NULL, NULL, 230121),
(236269, '2dhmA01', NULL, NULL, 90, NULL, NULL, 230122),
(236270, '3o2eA00', NULL, NULL, 87, NULL, NULL, 230122),
(236271, '2mcqA01', NULL, NULL, 75, NULL, NULL, 230122),
(236272, '1ny8A00', NULL, NULL, 97, NULL, NULL, 230122),
(236273, '2nclA00', NULL, NULL, 81, NULL, NULL, 230122),
(236274, '3tr3B00', NULL, NULL, 82, NULL, NULL, 230122),
(236275, '5nfmA00', NULL, NULL, 75, NULL, NULL, 230122),
(236276, '2kz0A01', NULL, NULL, 71, NULL, NULL, 230122),
(236277, '4puhA00', NULL, NULL, 93, NULL, NULL, 230122); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(236278, '4pugB01', NULL, NULL, 95, NULL, NULL, 230122),
(236279, '4puiB01', NULL, NULL, 93, NULL, NULL, 230122),
(236280, '1xs3A01', NULL, NULL, 75, NULL, NULL, 230122),
(236281, '2n8qA01', NULL, NULL, 94, NULL, NULL, 230122),
(236282, '2kdnA00', NULL, NULL, 108, NULL, NULL, 230122),
(236283, '5lciA00', NULL, NULL, 88, NULL, NULL, 230122),
(236284, '1v60A01', NULL, NULL, 82, NULL, NULL, 230122),
(236285, '3k63A01', NULL, NULL, 102, NULL, NULL, 230123),
(236286, '4jc0A02', NULL, NULL, 111, NULL, NULL, 230124),
(236287, '3u5eZ00', NULL, NULL, 136, NULL, NULL, 230125),
(236288, '1vwxZ00', NULL, NULL, 136, NULL, NULL, 230125),
(236289, '1vx7100', NULL, NULL, 146, NULL, NULL, 230125),
(236290, '4a18N00', NULL, NULL, 144, NULL, NULL, 230125),
(236291, '5t13A01', NULL, NULL, 113, NULL, NULL, 230126),
(236292, '5hy0A01', NULL, NULL, 108, NULL, NULL, 230126),
(236293, '4bvqA01', NULL, NULL, 107, NULL, NULL, 230126),
(236294, '4nq3B01', NULL, NULL, 97, NULL, NULL, 230126),
(236295, '5hweA01', NULL, NULL, 107, NULL, NULL, 230126),
(236296, '4nq3A01', NULL, NULL, 99, NULL, NULL, 230126),
(236297, '1rp5A01', NULL, NULL, 51, NULL, NULL, 230127),
(236298, '5u47A01', NULL, NULL, 32, NULL, NULL, 230127),
(236299, '1nbwA02', NULL, NULL, 143, NULL, NULL, 230128),
(236300, '2d0oA02', NULL, NULL, 143, NULL, NULL, 230128),
(236301, '1xeeA01', NULL, NULL, 82, NULL, NULL, 230129),
(236302, '3pm9A04', NULL, NULL, 87, NULL, NULL, 230130),
(236303, '2mqdA00', NULL, NULL, 119, NULL, NULL, 230131),
(236304, '3ci0K02', NULL, NULL, 113, NULL, NULL, 230132),
(236305, '3ci0K03', NULL, NULL, 70, NULL, NULL, 230132),
(236306, '4ilgA02', NULL, NULL, 199, NULL, NULL, 230133),
(236307, '4iliB02', NULL, NULL, 170, NULL, NULL, 230133),
(236308, '3sbtB02', NULL, NULL, 174, NULL, NULL, 230133),
(236309, '3bhwA00', NULL, NULL, 209, NULL, NULL, 230134),
(236310, '2kl5A00', NULL, NULL, 110, NULL, NULL, 230135),
(236311, '4i9oA00', NULL, NULL, 85, NULL, NULL, 230136),
(236312, '5svhA00', NULL, NULL, 87, NULL, NULL, 230136),
(236313, '4d7xA00', NULL, NULL, 86, NULL, NULL, 230136),
(236314, '2gutA00', NULL, NULL, 77, NULL, NULL, 230136),
(236315, '2k0nA00', NULL, NULL, 85, NULL, NULL, 230136),
(236316, '5xoxA00', NULL, NULL, 243, NULL, NULL, 230137),
(236317, '4kgmA00', NULL, NULL, 245, NULL, NULL, 230137),
(236318, '5axmB00', NULL, NULL, 251, NULL, NULL, 230137),
(236319, '3otdA00', NULL, NULL, 269, NULL, NULL, 230137),
(236320, '3wbzB00', NULL, NULL, 271, NULL, NULL, 230137),
(236321, '1js8B02', NULL, NULL, 105, NULL, NULL, 230138),
(236322, '1lnlA02', NULL, NULL, 101, NULL, NULL, 230138),
(236323, '3qjoA02', NULL, NULL, 112, NULL, NULL, 230138),
(236324, '4g6vA00', NULL, NULL, 135, NULL, NULL, 230139),
(236325, '1vraB02', NULL, NULL, 130, NULL, NULL, 230140),
(236326, '3it4D02', NULL, NULL, 126, NULL, NULL, 230140),
(236327, '2v4iB02', NULL, NULL, 135, NULL, NULL, 230140),
(236328, '3zfnA02', NULL, NULL, 57, NULL, NULL, 230141),
(236329, '3zfpA02', NULL, NULL, 57, NULL, NULL, 230141),
(236330, '4h9jA02', NULL, NULL, 57, NULL, NULL, 230141),
(236331, '4rnaA03', NULL, NULL, 139, NULL, NULL, 230142),
(236332, '4m0wA03', NULL, NULL, 145, NULL, NULL, 230142),
(236333, '1iomA01', NULL, NULL, 242, NULL, NULL, 230143),
(236334, '5uquB01', NULL, NULL, 315, NULL, NULL, 230143),
(236335, '2ibpA01', NULL, NULL, 252, NULL, NULL, 230143),
(236336, '4e6yA02', NULL, NULL, 253, NULL, NULL, 230143),
(236337, '4jadA02', NULL, NULL, 254, NULL, NULL, 230143),
(236338, '2ifcA01', NULL, NULL, 244, NULL, NULL, 230143),
(236339, '1aj8A01', NULL, NULL, 242, NULL, NULL, 230143),
(236340, '4tvmA02', NULL, NULL, 253, NULL, NULL, 230143),
(236341, '3hwkA01', NULL, NULL, 239, NULL, NULL, 230143),
(236342, '3msuA02', NULL, NULL, 251, NULL, NULL, 230143),
(236343, '6abwA01', NULL, NULL, 240, NULL, NULL, 230143),
(236344, '2p2wA01', NULL, NULL, 234, NULL, NULL, 230143),
(236345, '6abxA01', NULL, NULL, 236, NULL, NULL, 230143),
(236346, '1a59A01', NULL, NULL, 241, NULL, NULL, 230143),
(236347, '2h12B02', NULL, NULL, 243, NULL, NULL, 230143),
(236348, '3tqgB01', NULL, NULL, 258, NULL, NULL, 230143);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(236349, '2c6xA01', NULL, NULL, 236, NULL, NULL, 230143),
(236350, '1vgpA01', NULL, NULL, 237, NULL, NULL, 230143),
(236351, '1o7xA01', NULL, NULL, 240, NULL, NULL, 230143),
(236352, '3o8jA01', NULL, NULL, 247, NULL, NULL, 230143),
(236353, '4xghA02', NULL, NULL, 254, NULL, NULL, 230143),
(236354, '1vgmA01', NULL, NULL, 240, NULL, NULL, 230143),
(236355, '5uqsA01', NULL, NULL, 305, NULL, NULL, 230143),
(236356, '1cshA01', NULL, NULL, 306, NULL, NULL, 230143),
(236357, '2qy1A00', NULL, NULL, 330, NULL, NULL, 230144),
(236358, '4oj6C03', NULL, NULL, 399, NULL, NULL, 230144),
(236359, '1gq8A00', NULL, NULL, 319, NULL, NULL, 230144),
(236360, '1qcxA00', NULL, NULL, 359, NULL, NULL, 230144),
(236361, '3vmvA00', NULL, NULL, 326, NULL, NULL, 230144),
(236362, '1bheA00', NULL, NULL, 376, NULL, NULL, 230144),
(236363, '2odlA00', NULL, NULL, 373, NULL, NULL, 230144),
(236364, '4nk6A00', NULL, NULL, 424, NULL, NULL, 230144),
(236365, '5amvA00', NULL, NULL, 399, NULL, NULL, 230144),
(236366, '1ogoX02', NULL, NULL, 367, NULL, NULL, 230144),
(236367, '1ee6A00', NULL, NULL, 197, NULL, NULL, 230144),
(236368, '1oflA00', NULL, NULL, 481, NULL, NULL, 230144),
(236369, '1k5cA00', NULL, NULL, 335, NULL, NULL, 230144),
(236370, '2pygA00', NULL, NULL, 377, NULL, NULL, 230144),
(236371, '1ia5A00', NULL, NULL, 339, NULL, NULL, 230144),
(236372, '4u49B02', NULL, NULL, 228, NULL, NULL, 230144),
(236373, '1ru4A00', NULL, NULL, 400, NULL, NULL, 230144),
(236374, '1czfA00', NULL, NULL, 335, NULL, NULL, 230144),
(236375, '4yz0A00', NULL, NULL, 204, NULL, NULL, 230144),
(236376, '2inuA00', NULL, NULL, 410, NULL, NULL, 230144),
(236377, '1rmgA00', NULL, NULL, 422, NULL, NULL, 230144),
(236378, '4hwvB00', NULL, NULL, 487, NULL, NULL, 230144),
(236379, '2iq7A00', NULL, NULL, 339, NULL, NULL, 230144),
(236380, '1idkA00', NULL, NULL, 359, NULL, NULL, 230144),
(236381, '1vblA00', NULL, NULL, 416, NULL, NULL, 230144),
(236382, '3vsvA01', NULL, NULL, 510, NULL, NULL, 230144),
(236383, '2x3hA00', NULL, NULL, 499, NULL, NULL, 230144),
(236384, '2nspA00', NULL, NULL, 342, NULL, NULL, 230144),
(236385, '2uvfB02', NULL, NULL, 457, NULL, NULL, 230144),
(236386, '1x0cA02', NULL, NULL, 374, NULL, NULL, 230144),
(236387, '1pxzA00', NULL, NULL, 346, NULL, NULL, 230144),
(236388, '1nhcA00', NULL, NULL, 336, NULL, NULL, 230144),
(236389, '1o88A00', NULL, NULL, 353, NULL, NULL, 230144),
(236390, '4mr0B00', NULL, NULL, 452, NULL, NULL, 230144),
(236391, '3uw0A00', NULL, NULL, 321, NULL, NULL, 230144),
(236392, '3eqnA01', NULL, NULL, 342, NULL, NULL, 230144),
(236393, '3gq8A01', NULL, NULL, 469, NULL, NULL, 230144),
(236394, '1pe9A00', NULL, NULL, 361, NULL, NULL, 230144),
(236395, '3eqnA02', NULL, NULL, 362, NULL, NULL, 230144),
(236396, '4pmhA00', NULL, NULL, 366, NULL, NULL, 230144),
(236397, '5olpA00', NULL, NULL, 433, NULL, NULL, 230144),
(236398, '4w8qA00', NULL, NULL, 242, NULL, NULL, 230144),
(236399, '4c2lA00', NULL, NULL, 372, NULL, NULL, 230144),
(236400, '1rwrA00', NULL, NULL, 301, NULL, NULL, 230144),
(236401, '3grhA00', NULL, NULL, 404, NULL, NULL, 230144),
(236402, '4xotA02', NULL, NULL, 433, NULL, NULL, 230144),
(236403, '4mxnB00', NULL, NULL, 228, NULL, NULL, 230144),
(236404, '5c1eA00', NULL, NULL, 299, NULL, NULL, 230144),
(236405, '3zscA00', NULL, NULL, 340, NULL, NULL, 230144),
(236406, '1h80B00', NULL, NULL, 464, NULL, NULL, 230144),
(236407, '3jurA00', NULL, NULL, 448, NULL, NULL, 230144),
(236408, '5m5zA01', NULL, NULL, 349, NULL, NULL, 230144),
(236409, '5m5zA02', NULL, NULL, 377, NULL, NULL, 230144),
(236410, '4i84A00', NULL, NULL, 307, NULL, NULL, 230144),
(236411, '3b4nA02', NULL, NULL, 226, NULL, NULL, 230144),
(236412, '5lw3A00', NULL, NULL, 387, NULL, NULL, 230144),
(236413, '1xg2A00', NULL, NULL, 317, NULL, NULL, 230144),
(236414, '1hg8A00', NULL, NULL, 349, NULL, NULL, 230144),
(236415, '2vbkA00', NULL, NULL, 514, NULL, NULL, 230144),
(236416, '2kdtA00', NULL, NULL, 45, NULL, NULL, 230145),
(236417, '2ke3A01', NULL, NULL, 33, NULL, NULL, 230145),
(236418, '3ah5B00', NULL, NULL, 216, NULL, NULL, 230146),
(236419, '4p5aC00', NULL, NULL, 239, NULL, NULL, 230146);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(236420, '3n3yC00', NULL, NULL, 216, NULL, NULL, 230146),
(236421, '4gt9A00', NULL, NULL, 232, NULL, NULL, 230146),
(236422, '4fzbC01', NULL, NULL, 168, NULL, NULL, 230146),
(236423, '1zi7A02', NULL, NULL, 50, NULL, NULL, 230147),
(236424, '3m9lA02', NULL, NULL, 51, NULL, NULL, 230148),
(236425, '3coqA00', NULL, NULL, 89, NULL, NULL, 230149),
(236426, '1d66A00', NULL, NULL, 66, NULL, NULL, 230149),
(236427, '1d66B01', NULL, NULL, 40, NULL, NULL, 230149),
(236428, '1pyiA01', NULL, NULL, 62, NULL, NULL, 230149),
(236429, '1zmeC01', NULL, NULL, 31, NULL, NULL, 230149),
(236430, '1hwtC01', NULL, NULL, 34, NULL, NULL, 230149),
(236431, '1f4sP00', NULL, NULL, 65, NULL, NULL, 230149),
(236432, '2ereA00', NULL, NULL, 72, NULL, NULL, 230149),
(236433, '1pycA00', NULL, NULL, 45, NULL, NULL, 230149),
(236434, '6f2rD01', NULL, NULL, 76, NULL, NULL, 230150),
(236435, '4eldB00', NULL, NULL, 114, NULL, NULL, 230150),
(236436, '2wj5A01', NULL, NULL, 77, NULL, NULL, 230150),
(236437, '4rzkA00', NULL, NULL, 90, NULL, NULL, 230150),
(236438, '1wfiA00', NULL, NULL, 131, NULL, NULL, 230150),
(236439, '1wgvA00', NULL, NULL, 124, NULL, NULL, 230150),
(236440, '3igfA02', NULL, NULL, 79, NULL, NULL, 230150),
(236441, '5ds1A00', NULL, NULL, 95, NULL, NULL, 230150),
(236442, '3w1zD00', NULL, NULL, 110, NULL, NULL, 230150),
(236443, '2y1zB00', NULL, NULL, 94, NULL, NULL, 230150),
(236444, '3w1zC00', NULL, NULL, 143, NULL, NULL, 230150),
(236445, '5j7nA00', NULL, NULL, 120, NULL, NULL, 230150),
(236446, '1gmeA00', NULL, NULL, 151, NULL, NULL, 230150),
(236447, '6ewnA00', NULL, NULL, 99, NULL, NULL, 230150),
(236448, '3eudB00', NULL, NULL, 115, NULL, NULL, 230150),
(236449, '2bolB02', NULL, NULL, 142, NULL, NULL, 230150),
(236450, '2bolA03', NULL, NULL, 93, NULL, NULL, 230150),
(236451, '1gmeB00', NULL, NULL, 109, NULL, NULL, 230150),
(236452, '1x5mA01', NULL, NULL, 106, NULL, NULL, 230150),
(236453, '2k8qA00', NULL, NULL, 134, NULL, NULL, 230150),
(236454, '3aabB00', NULL, NULL, 123, NULL, NULL, 230150),
(236455, '4jutE00', NULL, NULL, 107, NULL, NULL, 230150),
(236456, '1ejfA00', NULL, NULL, 125, NULL, NULL, 230150),
(236457, '4mjhA00', NULL, NULL, 93, NULL, NULL, 230150),
(236458, '3qorD00', NULL, NULL, 121, NULL, NULL, 230150),
(236459, '2o30A00', NULL, NULL, 89, NULL, NULL, 230150),
(236460, '3q9pA00', NULL, NULL, 85, NULL, NULL, 230150),
(236461, '3n3eB00', NULL, NULL, 106, NULL, NULL, 230150),
(236462, '1wh0A01', NULL, NULL, 111, NULL, NULL, 230150),
(236463, '3glaA00', NULL, NULL, 100, NULL, NULL, 230150),
(236464, '5ds2A00', NULL, NULL, 95, NULL, NULL, 230150),
(236465, '2n0kA00', NULL, NULL, 89, NULL, NULL, 230150),
(236466, '2rh0A01', NULL, NULL, 64, NULL, NULL, 230150),
(236467, '5lumA01', NULL, NULL, 76, NULL, NULL, 230150),
(236468, '4m5sA00', NULL, NULL, 87, NULL, NULL, 230150),
(236469, '2y1yA00', NULL, NULL, 90, NULL, NULL, 230150),
(236470, '4zj9A00', NULL, NULL, 108, NULL, NULL, 230150),
(236471, '2xcmC00', NULL, NULL, 92, NULL, NULL, 230150),
(236472, '4pbdA00', NULL, NULL, 110, NULL, NULL, 230150),
(236473, '4ye0A00', NULL, NULL, 100, NULL, NULL, 230150),
(236474, '2cr0A00', NULL, NULL, 121, NULL, NULL, 230150),
(236475, '2cg9X01', NULL, NULL, 119, NULL, NULL, 230150),
(236476, '4feiA00', NULL, NULL, 102, NULL, NULL, 230150),
(236477, '1rl1A00', NULL, NULL, 114, NULL, NULL, 230150),
(236478, '4ylbB00', NULL, NULL, 128, NULL, NULL, 230150),
(236479, '2kmwA01', NULL, NULL, 104, NULL, NULL, 230150),
(236480, '4ydzA00', NULL, NULL, 142, NULL, NULL, 230150),
(236481, '3l1eA01', NULL, NULL, 77, NULL, NULL, 230150),
(236482, '1hbxA01', NULL, NULL, 71, NULL, NULL, 230151),
(236483, '1egwB01', NULL, NULL, 66, NULL, NULL, 230151),
(236484, '1n6jB01', NULL, NULL, 82, NULL, NULL, 230151),
(236485, '1mnmA01', NULL, NULL, 73, NULL, NULL, 230151),
(236486, '6byyD01', NULL, NULL, 83, NULL, NULL, 230151),
(236487, '5f28B00', NULL, NULL, 77, NULL, NULL, 230151),
(236488, '3mu6A01', NULL, NULL, 60, NULL, NULL, 230151),
(236489, '1vzsA01', NULL, NULL, 63, NULL, NULL, 230152),
(236490, '2aegA02', NULL, NULL, 141, NULL, NULL, 230153);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(236491, '3rrrG01', NULL, NULL, 19, NULL, NULL, 230154),
(236492, '4uqlQ00', NULL, NULL, 544, NULL, NULL, 230155),
(236493, '3iam400', NULL, NULL, 385, NULL, NULL, 230155),
(236494, '6fpoL00', NULL, NULL, 582, NULL, NULL, 230155),
(236495, '4u9hL00', NULL, NULL, 533, NULL, NULL, 230155),
(236496, '4c3oA00', NULL, NULL, 585, NULL, NULL, 230155),
(236497, '5aa5E00', NULL, NULL, 559, NULL, NULL, 230155),
(236498, '5xvdL00', NULL, NULL, 552, NULL, NULL, 230155),
(236499, '5jskB00', NULL, NULL, 507, NULL, NULL, 230155),
(236500, '1yq9H00', NULL, NULL, 536, NULL, NULL, 230155),
(236501, '4kn9L00', NULL, NULL, 499, NULL, NULL, 230155),
(236502, '4omfA00', NULL, NULL, 386, NULL, NULL, 230155),
(236503, '3ayxA00', NULL, NULL, 596, NULL, NULL, 230155),
(236504, '5mdlL00', NULL, NULL, 603, NULL, NULL, 230155),
(236505, '6gamL00', NULL, NULL, 567, NULL, NULL, 230155),
(236506, '3myrB00', NULL, NULL, 561, NULL, NULL, 230155),
(236507, '6g2jD01', NULL, NULL, 385, NULL, NULL, 230155),
(236508, '1e3dB00', NULL, NULL, 542, NULL, NULL, 230155),
(236509, '2bcgG02', NULL, NULL, 157, NULL, NULL, 230156),
(236510, '3p1wA02', NULL, NULL, 162, NULL, NULL, 230156),
(236511, '1d5tA02', NULL, NULL, 153, NULL, NULL, 230156),
(236512, '6c87A02', NULL, NULL, 155, NULL, NULL, 230156),
(236513, '1vg0A02', NULL, NULL, 181, NULL, NULL, 230156),
(236514, '3vutA01', NULL, NULL, 40, NULL, NULL, 230157),
(236515, '1ea0B04', NULL, NULL, 274, NULL, NULL, 230158),
(236516, '1ofeB04', NULL, NULL, 280, NULL, NULL, 230158),
(236517, '1ofdA04', NULL, NULL, 276, NULL, NULL, 230158),
(236518, '3qjoA03', NULL, NULL, 93, NULL, NULL, 230159),
(236519, '3kh2E01', NULL, NULL, 49, NULL, NULL, 230160),
(236520, '3hryA01', NULL, NULL, 49, NULL, NULL, 230160),
(236521, '2a6qB00', NULL, NULL, 58, NULL, NULL, 230160),
(236522, '2a6qA01', NULL, NULL, 43, NULL, NULL, 230160),
(236523, '4zlxA00', NULL, NULL, 53, NULL, NULL, 230160),
(236524, '3d55A01', NULL, NULL, 38, NULL, NULL, 230160),
(236525, '2odkA00', NULL, NULL, 53, NULL, NULL, 230160),
(236526, '3ctoD00', NULL, NULL, 66, NULL, NULL, 230160),
(236527, '3g5oA01', NULL, NULL, 48, NULL, NULL, 230160),
(236528, '3k6qA01', NULL, NULL, 48, NULL, NULL, 230160),
(236529, '2m64A01', NULL, NULL, 114, NULL, NULL, 230161),
(236530, '2m64A02', NULL, NULL, 107, NULL, NULL, 230161),
(236531, '1l3pA00', NULL, NULL, 102, NULL, NULL, 230161),
(236532, '1nlxA00', NULL, NULL, 111, NULL, NULL, 230161),
(236533, '4bjnH00', NULL, NULL, 244, NULL, NULL, 230162),
(236534, '4bjmC00', NULL, NULL, 238, NULL, NULL, 230162),
(236535, '2ckwA02', NULL, NULL, 56, NULL, NULL, 230163),
(236536, '3bsoA02', NULL, NULL, 57, NULL, NULL, 230163),
(236537, '3uqsA02', NULL, NULL, 56, NULL, NULL, 230163),
(236538, '6a02A01', NULL, NULL, 114, NULL, NULL, 230164),
(236539, '3dzaC01', NULL, NULL, 125, NULL, NULL, 230164),
(236540, '3zh5A00', NULL, NULL, 134, NULL, NULL, 230165),
(236541, '3zh7B00', NULL, NULL, 129, NULL, NULL, 230165),
(236542, '4g1iA03', NULL, NULL, 69, NULL, NULL, 230166),
(236543, '4alzA03', NULL, NULL, 64, NULL, NULL, 230166),
(236544, '4ofqB01', NULL, NULL, 191, NULL, NULL, 230167),
(236545, '4ofqA02', NULL, NULL, 156, NULL, NULL, 230167),
(236546, '3qdhA01', NULL, NULL, 159, NULL, NULL, 230167),
(236547, '3v10A02', NULL, NULL, 150, NULL, NULL, 230167),
(236548, '4uzgA01', NULL, NULL, 166, NULL, NULL, 230167),
(236549, '3pf2A01', NULL, NULL, 177, NULL, NULL, 230167),
(236550, '2y1vA02', NULL, NULL, 152, NULL, NULL, 230167),
(236551, '2xtlB01', NULL, NULL, 153, NULL, NULL, 230167),
(236552, '2x9zA01', NULL, NULL, 149, NULL, NULL, 230167),
(236553, '4p0dA02', NULL, NULL, 172, NULL, NULL, 230167),
(236554, '4z1pA02', NULL, NULL, 155, NULL, NULL, 230167),
(236555, '2woyA02', NULL, NULL, 158, NULL, NULL, 230167),
(236556, '3opuA01', NULL, NULL, 180, NULL, NULL, 230167),
(236557, '3opuA02', NULL, NULL, 159, NULL, NULL, 230167),
(236558, '3qe5A01', NULL, NULL, 149, NULL, NULL, 230167),
(236559, '2woyA01', NULL, NULL, 175, NULL, NULL, 230167),
(236560, '3qe5A03', NULL, NULL, 160, NULL, NULL, 230167),
(236561, '3kptA02', NULL, NULL, 141, NULL, NULL, 230167);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(236562, '4hsqA01', NULL, NULL, 148, NULL, NULL, 230167),
(236563, '2okmA00', NULL, NULL, 147, NULL, NULL, 230167),
(236564, '3uxfA02', NULL, NULL, 166, NULL, NULL, 230167),
(236565, '4igbB02', NULL, NULL, 143, NULL, NULL, 230167),
(236566, '2f68X02', NULL, NULL, 170, NULL, NULL, 230167),
(236567, '5dzaA01', NULL, NULL, 173, NULL, NULL, 230167),
(236568, '3hr6A02', NULL, NULL, 157, NULL, NULL, 230167),
(236569, '5gipA03', NULL, NULL, 127, NULL, NULL, 230168),
(236570, '2ozbE02', NULL, NULL, 116, NULL, NULL, 230168),
(236571, '3gqxB00', NULL, NULL, 129, NULL, NULL, 230168),
(236572, '3nmuA03', NULL, NULL, 117, NULL, NULL, 230168),
(236573, '1nt2B03', NULL, NULL, 120, NULL, NULL, 230168),
(236574, '3iwgA01', NULL, NULL, 136, NULL, NULL, 230169),
(236575, '3h31A00', NULL, NULL, 74, NULL, NULL, 230170),
(236576, '1hpiA00', NULL, NULL, 71, NULL, NULL, 230170),
(236577, '3hipB00', NULL, NULL, 82, NULL, NULL, 230170),
(236578, '1hlqA00', NULL, NULL, 75, NULL, NULL, 230170),
(236579, '5d8vA00', NULL, NULL, 83, NULL, NULL, 230170),
(236580, '2hipA00', NULL, NULL, 72, NULL, NULL, 230170),
(236581, '1isuA00', NULL, NULL, 62, NULL, NULL, 230170),
(236582, '1b0yA00', NULL, NULL, 85, NULL, NULL, 230170),
(236583, '4jjjA03', NULL, NULL, 73, NULL, NULL, 230171),
(236584, '4xwmA03', NULL, NULL, 65, NULL, NULL, 230171),
(236585, '4l6xA03', NULL, NULL, 66, NULL, NULL, 230171),
(236586, '1l1yA03', NULL, NULL, 66, NULL, NULL, 230171),
(236587, '1g9gA03', NULL, NULL, 66, NULL, NULL, 230171),
(236588, '4fusA03', NULL, NULL, 65, NULL, NULL, 230171),
(236589, '2py5A03', NULL, NULL, 98, NULL, NULL, 230172),
(236590, '6c1wA01', NULL, NULL, 197, NULL, NULL, 230173),
(236591, '2yjgA01', NULL, NULL, 196, NULL, NULL, 230173),
(236592, '4narA02', NULL, NULL, 176, NULL, NULL, 230173),
(236593, '3rrkA01', NULL, NULL, 85, NULL, NULL, 230174),
(236594, '2pxtA00', NULL, NULL, 69, NULL, NULL, 230175),
(236595, '2pxuA00', NULL, NULL, 69, NULL, NULL, 230175),
(236596, '2v3cC03', NULL, NULL, 124, NULL, NULL, 230175),
(236597, '2pxvA00', NULL, NULL, 69, NULL, NULL, 230175),
(236598, '5gadi03', NULL, NULL, 115, NULL, NULL, 230175),
(236599, '5gagi00', NULL, NULL, 126, NULL, NULL, 230175),
(236600, '5gahi00', NULL, NULL, 126, NULL, NULL, 230175),
(236601, '2pxbA00', NULL, NULL, 69, NULL, NULL, 230175),
(236602, '2pxdA00', NULL, NULL, 69, NULL, NULL, 230175),
(236603, '2pxlA00', NULL, NULL, 69, NULL, NULL, 230175),
(236604, '2pxpA00', NULL, NULL, 69, NULL, NULL, 230175),
(236605, '1dulA00', NULL, NULL, 69, NULL, NULL, 230175),
(236606, '2pxqA00', NULL, NULL, 69, NULL, NULL, 230175),
(236607, '1qb2A00', NULL, NULL, 109, NULL, NULL, 230175),
(236608, '2pxkA00', NULL, NULL, 69, NULL, NULL, 230175),
(236609, '1hq1A00', NULL, NULL, 105, NULL, NULL, 230175),
(236610, '2jqeA00', NULL, NULL, 119, NULL, NULL, 230175),
(236611, '2pxfA00', NULL, NULL, 69, NULL, NULL, 230175),
(236612, '2pxeA00', NULL, NULL, 69, NULL, NULL, 230175),
(236613, '3dm5B03', NULL, NULL, 134, NULL, NULL, 230175),
(236614, '3lqxA00', NULL, NULL, 72, NULL, NULL, 230175),
(236615, '3kl4A03', NULL, NULL, 129, NULL, NULL, 230175),
(236616, '2ffhA03', NULL, NULL, 107, NULL, NULL, 230175),
(236617, '3ghmA01', NULL, NULL, 103, NULL, NULL, 230176),
(236618, '2rjqA02', NULL, NULL, 73, NULL, NULL, 230176),
(236619, '3b2zB02', NULL, NULL, 73, NULL, NULL, 230176),
(236620, '2v4bA02', NULL, NULL, 79, NULL, NULL, 230176),
(236621, '3sgfH02', NULL, NULL, 35, NULL, NULL, 230177),
(236622, '1j6rA00', NULL, NULL, 214, NULL, NULL, 230178),
(236623, '3g3zA03', NULL, NULL, 53, NULL, NULL, 230179),
(236624, '2ntxA01', NULL, NULL, 247, NULL, NULL, 230180),
(236625, '2ntxB01', NULL, NULL, 206, NULL, NULL, 230180),
(236626, '3njaA02', NULL, NULL, 49, NULL, NULL, 230181),
(236627, '3da7E00', NULL, NULL, 111, NULL, NULL, 230182),
(236628, '2gumB05', NULL, NULL, 65, NULL, NULL, 230183),
(236629, '6escA05', NULL, NULL, 59, NULL, NULL, 230183),
(236630, '3fvcA05', NULL, NULL, 69, NULL, NULL, 230183),
(236631, '1lxmA04', NULL, NULL, 78, NULL, NULL, 230184),
(236632, '4xpkA00', NULL, NULL, 163, NULL, NULL, 230185);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(236633, '1yreC00', NULL, NULL, 197, NULL, NULL, 230185),
(236634, '2arhA01', NULL, NULL, 158, NULL, NULL, 230185),
(236635, '3f8kA00', NULL, NULL, 160, NULL, NULL, 230185),
(236636, '2aj6A00', NULL, NULL, 130, NULL, NULL, 230185),
(236637, '2z10A00', NULL, NULL, 194, NULL, NULL, 230185),
(236638, '2qecA00', NULL, NULL, 204, NULL, NULL, 230185),
(236639, '2g0bH01', NULL, NULL, 185, NULL, NULL, 230185),
(236640, '2fckA00', NULL, NULL, 181, NULL, NULL, 230185),
(236641, '2ozgA01', NULL, NULL, 128, NULL, NULL, 230185),
(236642, '2ozgA02', NULL, NULL, 164, NULL, NULL, 230185),
(236643, '2pdoA01', NULL, NULL, 126, NULL, NULL, 230185),
(236644, '1ro5A01', NULL, NULL, 187, NULL, NULL, 230185),
(236645, '3efaA00', NULL, NULL, 147, NULL, NULL, 230185),
(236646, '2hv2B01', NULL, NULL, 99, NULL, NULL, 230185),
(236647, '4avaA02', NULL, NULL, 188, NULL, NULL, 230185),
(236648, '3i3gA00', NULL, NULL, 143, NULL, NULL, 230185),
(236649, '4zbgA00', NULL, NULL, 172, NULL, NULL, 230185),
(236650, '2cy2A00', NULL, NULL, 174, NULL, NULL, 230185),
(236651, '2jdcA00', NULL, NULL, 146, NULL, NULL, 230185),
(236652, '1rxtC02', NULL, NULL, 195, NULL, NULL, 230185),
(236653, '1i12D00', NULL, NULL, 160, NULL, NULL, 230185),
(236654, '2r7hB00', NULL, NULL, 159, NULL, NULL, 230185),
(236655, '1y9kB00', NULL, NULL, 157, NULL, NULL, 230185),
(236656, '1rxtC01', NULL, NULL, 140, NULL, NULL, 230185),
(236657, '5jphC00', NULL, NULL, 144, NULL, NULL, 230185),
(236658, '2b5gA00', NULL, NULL, 171, NULL, NULL, 230185),
(236659, '4rs2A00', NULL, NULL, 188, NULL, NULL, 230185),
(236660, '4pv6A00', NULL, NULL, 162, NULL, NULL, 230185),
(236661, '2d4pA00', NULL, NULL, 141, NULL, NULL, 230185),
(236662, '1iykA01', NULL, NULL, 147, NULL, NULL, 230185),
(236663, '4h89A00', NULL, NULL, 173, NULL, NULL, 230185),
(236664, '1iykA02', NULL, NULL, 245, NULL, NULL, 230185),
(236665, '3eo4D00', NULL, NULL, 164, NULL, NULL, 230185),
(236666, '4ab7H02', NULL, NULL, 163, NULL, NULL, 230185),
(236667, '4xnhB00', NULL, NULL, 238, NULL, NULL, 230185),
(236668, '3sxnA02', NULL, NULL, 156, NULL, NULL, 230185),
(236669, '3sxnA01', NULL, NULL, 139, NULL, NULL, 230185),
(236670, '2r1iA01', NULL, NULL, 130, NULL, NULL, 230185),
(236671, '2i79D00', NULL, NULL, 172, NULL, NULL, 230185),
(236672, '6bffA00', NULL, NULL, 178, NULL, NULL, 230185),
(236673, '3d8pB00', NULL, NULL, 163, NULL, NULL, 230185),
(236674, '4fd4A00', NULL, NULL, 217, NULL, NULL, 230185),
(236675, '2hv2A03', NULL, NULL, 149, NULL, NULL, 230185),
(236676, '3fixA00', NULL, NULL, 165, NULL, NULL, 230185),
(236677, '2hv2A01', NULL, NULL, 99, NULL, NULL, 230185),
(236678, '3owcB00', NULL, NULL, 188, NULL, NULL, 230185),
(236679, '1y7rA00', NULL, NULL, 133, NULL, NULL, 230185),
(236680, '1iicA02', NULL, NULL, 248, NULL, NULL, 230185),
(236681, '1iicA01', NULL, NULL, 173, NULL, NULL, 230185),
(236682, '3f5bA00', NULL, NULL, 182, NULL, NULL, 230185),
(236683, '3dsbA01', NULL, NULL, 105, NULL, NULL, 230185),
(236684, '1q2yA00', NULL, NULL, 140, NULL, NULL, 230185),
(236685, '4k30A00', NULL, NULL, 160, NULL, NULL, 230185),
(236686, '3fxtA00', NULL, NULL, 93, NULL, NULL, 230185),
(236687, '2p0wA02', NULL, NULL, 133, NULL, NULL, 230185),
(236688, '4nf1D00', NULL, NULL, 150, NULL, NULL, 230185),
(236689, '3ld2B00', NULL, NULL, 165, NULL, NULL, 230185),
(236690, '3qb8A00', NULL, NULL, 197, NULL, NULL, 230185),
(236691, '1yghA00', NULL, NULL, 164, NULL, NULL, 230185),
(236692, '1wwzA00', NULL, NULL, 159, NULL, NULL, 230185),
(236693, '3t90A00', NULL, NULL, 149, NULL, NULL, 230185),
(236694, '2cntA00', NULL, NULL, 160, NULL, NULL, 230185),
(236695, '5f47B00', NULL, NULL, 157, NULL, NULL, 230185),
(236696, '4xnhC00', NULL, NULL, 176, NULL, NULL, 230185),
(236697, '1nslA00', NULL, NULL, 184, NULL, NULL, 230185),
(236698, '4r3lA00', NULL, NULL, 173, NULL, NULL, 230185),
(236699, '3igrA00', NULL, NULL, 184, NULL, NULL, 230185),
(236700, '1vhsA00', NULL, NULL, 175, NULL, NULL, 230185),
(236701, '5ib0A00', NULL, NULL, 137, NULL, NULL, 230185),
(236702, '5vd6A00', NULL, NULL, 162, NULL, NULL, 230185),
(236703, '1n71B00', NULL, NULL, 180, NULL, NULL, 230185);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(236704, '3juwA00', NULL, NULL, 175, NULL, NULL, 230185),
(236705, '3gkrA02', NULL, NULL, 165, NULL, NULL, 230185),
(236706, '2jlmA00', NULL, NULL, 182, NULL, NULL, 230185),
(236707, '3n7zA01', NULL, NULL, 136, NULL, NULL, 230185),
(236708, '3n7zA02', NULL, NULL, 157, NULL, NULL, 230185),
(236709, '2pq8A02', NULL, NULL, 146, NULL, NULL, 230185),
(236710, '1y7rB00', NULL, NULL, 133, NULL, NULL, 230185),
(236711, '5ix3A00', NULL, NULL, 168, NULL, NULL, 230185),
(236712, '2prbA00', NULL, NULL, 196, NULL, NULL, 230185),
(236713, '4kvmE00', NULL, NULL, 156, NULL, NULL, 230185),
(236714, '3gkrA01', NULL, NULL, 165, NULL, NULL, 230185),
(236715, '5k9nB00', NULL, NULL, 216, NULL, NULL, 230185),
(236716, '2atrA00', NULL, NULL, 138, NULL, NULL, 230185),
(236717, '2vzyC00', NULL, NULL, 218, NULL, NULL, 230185),
(236718, '2o28A01', NULL, NULL, 161, NULL, NULL, 230185),
(236719, '3p2hA00', NULL, NULL, 201, NULL, NULL, 230185),
(236720, '1tiqA00', NULL, NULL, 180, NULL, NULL, 230185),
(236721, '3ey5A01', NULL, NULL, 160, NULL, NULL, 230185),
(236722, '1xebA00', NULL, NULL, 150, NULL, NULL, 230185),
(236723, '3tthB00', NULL, NULL, 170, NULL, NULL, 230185),
(236724, '1rxtA01', NULL, NULL, 123, NULL, NULL, 230185),
(236725, '6bvcA00', NULL, NULL, 154, NULL, NULL, 230185),
(236726, '2fe7B00', NULL, NULL, 166, NULL, NULL, 230185),
(236727, '5dwmB00', NULL, NULL, 187, NULL, NULL, 230185),
(236728, '1kzfA00', NULL, NULL, 210, NULL, NULL, 230185),
(236729, '1yk3B00', NULL, NULL, 210, NULL, NULL, 230185),
(236730, '4ri1C00', NULL, NULL, 186, NULL, NULL, 230185),
(236731, '4bmhA00', NULL, NULL, 207, NULL, NULL, 230185),
(236732, '2ou2A02', NULL, NULL, 135, NULL, NULL, 230185),
(236733, '2fsrA00', NULL, NULL, 195, NULL, NULL, 230185),
(236734, '3d2mA02', NULL, NULL, 150, NULL, NULL, 230185),
(236735, '5ls7B00', NULL, NULL, 137, NULL, NULL, 230185),
(236736, '2ae6A00', NULL, NULL, 166, NULL, NULL, 230185),
(236737, '3h4qA00', NULL, NULL, 188, NULL, NULL, 230185),
(236738, '4ag7A01', NULL, NULL, 149, NULL, NULL, 230185),
(236739, '1s7kA00', NULL, NULL, 182, NULL, NULL, 230185),
(236740, '1qstA00', NULL, NULL, 160, NULL, NULL, 230185),
(236741, '2zw5A01', NULL, NULL, 182, NULL, NULL, 230185),
(236742, '3fynA00', NULL, NULL, 176, NULL, NULL, 230185),
(236743, '2g3aA02', NULL, NULL, 105, NULL, NULL, 230185),
(236744, '2fl4A02', NULL, NULL, 106, NULL, NULL, 230185),
(236745, '3n7zB01', NULL, NULL, 136, NULL, NULL, 230185),
(236746, '5hmnB00', NULL, NULL, 159, NULL, NULL, 230185),
(236747, '3mgdB00', NULL, NULL, 157, NULL, NULL, 230185),
(236748, '4hkfA00', NULL, NULL, 191, NULL, NULL, 230185),
(236749, '2wpwC00', NULL, NULL, 339, NULL, NULL, 230185),
(236750, '3g8wB00', NULL, NULL, 169, NULL, NULL, 230185),
(236751, '1z4rA00', NULL, NULL, 168, NULL, NULL, 230185),
(236752, '3dnsA00', NULL, NULL, 135, NULL, NULL, 230185),
(236753, '4fd5A00', NULL, NULL, 222, NULL, NULL, 230185),
(236754, '1gheA00', NULL, NULL, 177, NULL, NULL, 230185),
(236755, '5fvjA00', NULL, NULL, 166, NULL, NULL, 230185),
(236756, '2pc1A00', NULL, NULL, 201, NULL, NULL, 230185),
(236757, '3d3sA00', NULL, NULL, 164, NULL, NULL, 230185),
(236758, '1yvkA00', NULL, NULL, 163, NULL, NULL, 230185),
(236759, '4ollA02', NULL, NULL, 191, NULL, NULL, 230185),
(236760, '2hqyA02', NULL, NULL, 168, NULL, NULL, 230185),
(236761, '2hqyA01', NULL, NULL, 137, NULL, NULL, 230185),
(236762, '5icwB00', NULL, NULL, 182, NULL, NULL, 230185),
(236763, '3exnA00', NULL, NULL, 160, NULL, NULL, 230185),
(236764, '2ozhA01', NULL, NULL, 133, NULL, NULL, 230185),
(236765, '5z6nB00', NULL, NULL, 153, NULL, NULL, 230185),
(236766, '6ao7A00', NULL, NULL, 162, NULL, NULL, 230185),
(236767, '4uwjA02', NULL, NULL, 248, NULL, NULL, 230185),
(236768, '4jxqA00', NULL, NULL, 186, NULL, NULL, 230185),
(236769, '4uwjA01', NULL, NULL, 159, NULL, NULL, 230185),
(236770, '2q7bA00', NULL, NULL, 165, NULL, NULL, 230185),
(236771, '5isvA00', NULL, NULL, 165, NULL, NULL, 230185),
(236772, '3c26A00', NULL, NULL, 266, NULL, NULL, 230185),
(236773, '3s6kA02', NULL, NULL, 151, NULL, NULL, 230185),
(236774, '2kcwA00', NULL, NULL, 147, NULL, NULL, 230185);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(236775, '3zj0A00', NULL, NULL, 206, NULL, NULL, 230185),
(236776, '1m4iB00', NULL, NULL, 181, NULL, NULL, 230185),
(236777, '3fncB00', NULL, NULL, 163, NULL, NULL, 230185),
(236778, '2hv2F01', NULL, NULL, 99, NULL, NULL, 230185),
(236779, '3n7zC01', NULL, NULL, 136, NULL, NULL, 230185),
(236780, '2fiwA00', NULL, NULL, 172, NULL, NULL, 230185),
(236781, '1vkcA01', NULL, NULL, 148, NULL, NULL, 230185),
(236782, '2ge3A00', NULL, NULL, 170, NULL, NULL, 230185),
(236783, '2qmlA00', NULL, NULL, 198, NULL, NULL, 230185),
(236784, '2ganA01', NULL, NULL, 145, NULL, NULL, 230185),
(236785, '1u6mA00', NULL, NULL, 199, NULL, NULL, 230185),
(236786, '1qsmD00', NULL, NULL, 152, NULL, NULL, 230185),
(236787, '4h6zA02', NULL, NULL, 139, NULL, NULL, 230185),
(236788, '5nnpF00', NULL, NULL, 178, NULL, NULL, 230185),
(236789, '4e2aA00', NULL, NULL, 171, NULL, NULL, 230185),
(236790, '3blnA00', NULL, NULL, 143, NULL, NULL, 230185),
(236791, '2ft0A00', NULL, NULL, 235, NULL, NULL, 230185),
(236792, '4fd7A00', NULL, NULL, 238, NULL, NULL, 230185),
(236793, '2vezA01', NULL, NULL, 162, NULL, NULL, 230185),
(236794, '3s6fA00', NULL, NULL, 145, NULL, NULL, 230185),
(236795, '2i00A02', NULL, NULL, 159, NULL, NULL, 230185),
(236796, '1yr0A00', NULL, NULL, 175, NULL, NULL, 230185),
(236797, '5i0cA00', NULL, NULL, 93, NULL, NULL, 230185),
(236798, '4my0A02', NULL, NULL, 140, NULL, NULL, 230185),
(236799, '5jtfB00', NULL, NULL, 179, NULL, NULL, 230185),
(236800, '3tt2A00', NULL, NULL, 330, NULL, NULL, 230185),
(236801, '6d72A00', NULL, NULL, 184, NULL, NULL, 230185),
(236802, '2fiaB00', NULL, NULL, 162, NULL, NULL, 230185),
(236803, '4y49B00', NULL, NULL, 169, NULL, NULL, 230185),
(236804, '3shpA00', NULL, NULL, 176, NULL, NULL, 230185),
(236805, '2hv2E01', NULL, NULL, 99, NULL, NULL, 230185),
(236806, '1mk4A00', NULL, NULL, 157, NULL, NULL, 230185),
(236807, '4j3gA00', NULL, NULL, 164, NULL, NULL, 230185),
(236808, '3n7zD01', NULL, NULL, 136, NULL, NULL, 230185),
(236809, '5jq4A00', NULL, NULL, 146, NULL, NULL, 230185),
(236810, '3frmA00', NULL, NULL, 254, NULL, NULL, 230185),
(236811, '3to7A02', NULL, NULL, 135, NULL, NULL, 230185),
(236812, '3ec4B00', NULL, NULL, 228, NULL, NULL, 230185),
(236813, '2dxqA00', NULL, NULL, 150, NULL, NULL, 230185),
(236814, '2q0yA01', NULL, NULL, 138, NULL, NULL, 230185),
(236815, '3w6sC00', NULL, NULL, 225, NULL, NULL, 230185),
(236816, '3r1kA02', NULL, NULL, 158, NULL, NULL, 230185),
(236817, '3lodA00', NULL, NULL, 162, NULL, NULL, 230185),
(236818, '3jvnA00', NULL, NULL, 136, NULL, NULL, 230185),
(236819, '3r1kA01', NULL, NULL, 137, NULL, NULL, 230185),
(236820, '3gy9A00', NULL, NULL, 150, NULL, NULL, 230185),
(236821, '4ua3A00', NULL, NULL, 194, NULL, NULL, 230185),
(236822, '4qc6A00', NULL, NULL, 179, NULL, NULL, 230185),
(236823, '6cy6A00', NULL, NULL, 186, NULL, NULL, 230185),
(236824, '4kvxB00', NULL, NULL, 156, NULL, NULL, 230185),
(236825, '4mi4B00', NULL, NULL, 171, NULL, NULL, 230185),
(236826, '4e8oB00', NULL, NULL, 148, NULL, NULL, 230185),
(236827, '5c82A00', NULL, NULL, 190, NULL, NULL, 230185),
(236828, '4m3sA00', NULL, NULL, 162, NULL, NULL, 230185),
(236829, '2ob0C01', NULL, NULL, 166, NULL, NULL, 230185),
(236830, '3t9yA00', NULL, NULL, 150, NULL, NULL, 230185),
(236831, '1s3zA00', NULL, NULL, 147, NULL, NULL, 230185),
(236832, '4pswA02', NULL, NULL, 133, NULL, NULL, 230185),
(236833, '5ktaA00', NULL, NULL, 188, NULL, NULL, 230185),
(236834, '5gi7A00', NULL, NULL, 215, NULL, NULL, 230185),
(236835, '2oh1C00', NULL, NULL, 179, NULL, NULL, 230185),
(236836, '1cjwA00', NULL, NULL, 166, NULL, NULL, 230185),
(236837, '2pr1A00', NULL, NULL, 163, NULL, NULL, 230185),
(236838, '4luaA00', NULL, NULL, 167, NULL, NULL, 230185),
(236839, '3s6gA02', NULL, NULL, 146, NULL, NULL, 230185),
(236840, '2g3tB00', NULL, NULL, 179, NULL, NULL, 230185),
(236841, '2zpaA03', NULL, NULL, 204, NULL, NULL, 230185),
(236842, '2hv2D01', NULL, NULL, 99, NULL, NULL, 230185),
(236843, '5jq4B00', NULL, NULL, 146, NULL, NULL, 230185),
(236844, '4iusA00', NULL, NULL, 261, NULL, NULL, 230185),
(236845, '3e0kA00', NULL, NULL, 150, NULL, NULL, 230185);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(236846, '4evyA00', NULL, NULL, 147, NULL, NULL, 230185),
(236847, '1y9wA01', NULL, NULL, 104, NULL, NULL, 230185),
(236848, '3iwgA02', NULL, NULL, 140, NULL, NULL, 230185),
(236849, '3n7zE01', NULL, NULL, 136, NULL, NULL, 230185),
(236850, '1lrzA02', NULL, NULL, 207, NULL, NULL, 230185),
(236851, '3fbuA00', NULL, NULL, 168, NULL, NULL, 230185),
(236852, '3pp9B00', NULL, NULL, 187, NULL, NULL, 230185),
(236853, '1ufhA00', NULL, NULL, 155, NULL, NULL, 230185),
(236854, '3dddA01', NULL, NULL, 130, NULL, NULL, 230185),
(236855, '2euiA01', NULL, NULL, 141, NULL, NULL, 230185),
(236856, '4nxyA00', NULL, NULL, 176, NULL, NULL, 230185),
(236857, '1z4eA00', NULL, NULL, 153, NULL, NULL, 230185),
(236858, '2q04F00', NULL, NULL, 211, NULL, NULL, 230185),
(236859, '3dr6B00', NULL, NULL, 174, NULL, NULL, 230185),
(236860, '4my0C01', NULL, NULL, 143, NULL, NULL, 230185),
(236861, '2i00C01', NULL, NULL, 152, NULL, NULL, 230185),
(236862, '5jphA00', NULL, NULL, 144, NULL, NULL, 230185),
(236863, '4kvxA00', NULL, NULL, 156, NULL, NULL, 230185),
(236864, '1cm0A00', NULL, NULL, 168, NULL, NULL, 230185),
(236865, '4m85C00', NULL, NULL, 186, NULL, NULL, 230185),
(236866, '1r57A00', NULL, NULL, 102, NULL, NULL, 230185),
(236867, '2ozuA02', NULL, NULL, 147, NULL, NULL, 230185),
(236868, '1p0hA00', NULL, NULL, 318, NULL, NULL, 230185),
(236869, '3tcvA00', NULL, NULL, 222, NULL, NULL, 230185),
(236870, '2hv2C01', NULL, NULL, 99, NULL, NULL, 230185),
(236871, '4yfjB00', NULL, NULL, 161, NULL, NULL, 230185),
(236872, '2j8mB00', NULL, NULL, 172, NULL, NULL, 230185),
(236873, '3n7zF01', NULL, NULL, 136, NULL, NULL, 230185),
(236874, '2beiB00', NULL, NULL, 170, NULL, NULL, 230185),
(236875, '1yx0A00', NULL, NULL, 159, NULL, NULL, 230185),
(236876, '1sqhA02', NULL, NULL, 131, NULL, NULL, 230185),
(236877, '1sqhA01', NULL, NULL, 181, NULL, NULL, 230185),
(236878, '2reeA00', NULL, NULL, 224, NULL, NULL, 230185),
(236879, '2vi7C00', NULL, NULL, 177, NULL, NULL, 230185),
(236880, '1lrzA01', NULL, NULL, 157, NULL, NULL, 230185),
(236881, '4b5oA00', NULL, NULL, 200, NULL, NULL, 230185),
(236882, '3r96B00', NULL, NULL, 188, NULL, NULL, 230185),
(236883, '1y9kA01', NULL, NULL, 113, NULL, NULL, 230185),
(236884, '4mbuA00', NULL, NULL, 166, NULL, NULL, 230185),
(236885, '3g3sA02', NULL, NULL, 133, NULL, NULL, 230185),
(236886, '3pzjB00', NULL, NULL, 189, NULL, NULL, 230185),
(236887, '4e0aA00', NULL, NULL, 164, NULL, NULL, 230185),
(236888, '3i9sA00', NULL, NULL, 161, NULL, NULL, 230185),
(236889, '5jphB00', NULL, NULL, 144, NULL, NULL, 230185),
(236890, '6c9mB00', NULL, NULL, 161, NULL, NULL, 230185),
(236891, '4qusB00', NULL, NULL, 149, NULL, NULL, 230185),
(236892, '1xmtA00', NULL, NULL, 103, NULL, NULL, 230185),
(236893, '2yb1A02', NULL, NULL, 73, NULL, NULL, 230186),
(236894, '3o0fA02', NULL, NULL, 74, NULL, NULL, 230186),
(236895, '2ke4A00', NULL, NULL, 98, NULL, NULL, 230187),
(236896, '4wjwA00', NULL, NULL, 77, NULL, NULL, 230188),
(236897, '1v9vA01', NULL, NULL, 95, NULL, NULL, 230189),
(236898, '2m9xA01', NULL, NULL, 95, NULL, NULL, 230189),
(236899, '3umhA00', NULL, NULL, 192, NULL, NULL, 230190),
(236900, '5tptA00', NULL, NULL, 197, NULL, NULL, 230190),
(236901, '3nyjA00', NULL, NULL, 189, NULL, NULL, 230190),
(236902, '3k66A01', NULL, NULL, 209, NULL, NULL, 230190),
(236903, '3pmrA00', NULL, NULL, 219, NULL, NULL, 230190),
(236904, '3fvqA02', NULL, NULL, 44, NULL, NULL, 230191),
(236905, '3pfyA02', NULL, NULL, 74, NULL, NULL, 230192),
(236906, '3tmoA02', NULL, NULL, 74, NULL, NULL, 230192),
(236907, '2fhdA02', NULL, NULL, 72, NULL, NULL, 230193),
(236908, '4ry2A02', NULL, NULL, 319, NULL, NULL, 230194),
(236909, '4mycA01', NULL, NULL, 328, NULL, NULL, 230194),
(236910, '4q4hA01', NULL, NULL, 325, NULL, NULL, 230194),
(236911, '4q4hB01', NULL, NULL, 343, NULL, NULL, 230194),
(236912, '4mrsA01', NULL, NULL, 349, NULL, NULL, 230194),
(236913, '3wmgA01', NULL, NULL, 328, NULL, NULL, 230194),
(236914, '3zdqA01', NULL, NULL, 335, NULL, NULL, 230194),
(236915, '4f4cA01', NULL, NULL, 721, NULL, NULL, 230194),
(236916, '4a82A01', NULL, NULL, 323, NULL, NULL, 230194); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(236917, '5ko2A01', NULL, NULL, 683, NULL, NULL, 230194),
(236918, '4bwcA01', NULL, NULL, 53, NULL, NULL, 230195),
(236919, '3fgrA01', NULL, NULL, 52, NULL, NULL, 230195),
(236920, '3fgtA01', NULL, NULL, 68, NULL, NULL, 230195),
(236921, '3gruA02', NULL, NULL, 89, NULL, NULL, 230196),
(236922, '3futA02', NULL, NULL, 68, NULL, NULL, 230196),
(236923, '3uzuA02', NULL, NULL, 69, NULL, NULL, 230196),
(236924, '1yubA02', NULL, NULL, 80, NULL, NULL, 230196),
(236925, '1qyrA02', NULL, NULL, 68, NULL, NULL, 230196),
(236926, '1qamA02', NULL, NULL, 78, NULL, NULL, 230196),
(236927, '4jxjA02', NULL, NULL, 65, NULL, NULL, 230196),
(236928, '1i4wA02', NULL, NULL, 75, NULL, NULL, 230196),
(236929, '4gc5A02', NULL, NULL, 90, NULL, NULL, 230196),
(236930, '3ftdA02', NULL, NULL, 65, NULL, NULL, 230196),
(236931, '3tqsA02', NULL, NULL, 65, NULL, NULL, 230196),
(236932, '6ifwA02', NULL, NULL, 77, NULL, NULL, 230196),
(236933, '2jovA01', NULL, NULL, 71, NULL, NULL, 230197),
(236934, '1a92A00', NULL, NULL, 50, NULL, NULL, 230198),
(236935, '2ilrA00', NULL, NULL, 264, NULL, NULL, 230199),
(236936, '1ylxA00', NULL, NULL, 103, NULL, NULL, 230200),
(236937, '1ylxB00', NULL, NULL, 103, NULL, NULL, 230200),
(236938, '2qziA00', NULL, NULL, 103, NULL, NULL, 230201),
(236939, '1xlyA00', NULL, NULL, 234, NULL, NULL, 230202),
(236940, '3i0wA03', NULL, NULL, 56, NULL, NULL, 230203),
(236941, '4unfA01', NULL, NULL, 131, NULL, NULL, 230203),
(236942, '2jhnA03', NULL, NULL, 62, NULL, NULL, 230203),
(236943, '3fhfA01', NULL, NULL, 104, NULL, NULL, 230203),
(236944, '3fhgA01', NULL, NULL, 94, NULL, NULL, 230203),
(236945, '1keaA01', NULL, NULL, 108, NULL, NULL, 230203),
(236946, '3n0uC01', NULL, NULL, 110, NULL, NULL, 230203),
(236947, '5kn8A01', NULL, NULL, 120, NULL, NULL, 230203),
(236948, '4ejyA03', NULL, NULL, 64, NULL, NULL, 230203),
(236949, '3f0zA03', NULL, NULL, 58, NULL, NULL, 230203),
(236950, '1xg7B01', NULL, NULL, 107, NULL, NULL, 230203),
(236951, '3g0qA01', NULL, NULL, 114, NULL, NULL, 230203),
(236952, '3n5nX01', NULL, NULL, 124, NULL, NULL, 230203),
(236953, '6g3xC02', NULL, NULL, 82, NULL, NULL, 230203),
(236954, '1kg2A01', NULL, NULL, 113, NULL, NULL, 230203),
(236955, '1pu6A01', NULL, NULL, 95, NULL, NULL, 230203),
(236956, '1mpgA03', NULL, NULL, 52, NULL, NULL, 230203),
(236957, '4uobA01', NULL, NULL, 126, NULL, NULL, 230203),
(236958, '2xhiA02', NULL, NULL, 80, NULL, NULL, 230203),
(236959, '1ornA02', NULL, NULL, 100, NULL, NULL, 230203),
(236960, '2abkA02', NULL, NULL, 99, NULL, NULL, 230203),
(236961, '1xqoA01', NULL, NULL, 121, NULL, NULL, 230203),
(236962, '3t5vF01', NULL, NULL, 20, NULL, NULL, 230204),
(236963, '2gytA01', NULL, NULL, 71, NULL, NULL, 230205),
(236964, '2h80A01', NULL, NULL, 68, NULL, NULL, 230205),
(236965, '4il7A00', NULL, NULL, 92, NULL, NULL, 230206),
(236966, '1ej6A01', NULL, NULL, 385, NULL, NULL, 230207),
(236967, '3iylW01', NULL, NULL, 389, NULL, NULL, 230207),
(236968, '1vnaA00', NULL, NULL, 65, NULL, NULL, 230208),
(236969, '2kbhA00', NULL, NULL, 66, NULL, NULL, 230208),
(236970, '1wmtA00', NULL, NULL, 41, NULL, NULL, 230208),
(236971, '2gl1A00', NULL, NULL, 47, NULL, NULL, 230208),
(236972, '1omyA00', NULL, NULL, 65, NULL, NULL, 230208),
(236973, '4kypA00', NULL, NULL, 84, NULL, NULL, 230208),
(236974, '2m8bB00', NULL, NULL, 51, NULL, NULL, 230208),
(236975, '2lr3A00', NULL, NULL, 47, NULL, NULL, 230208),
(236976, '2n2qA00', NULL, NULL, 54, NULL, NULL, 230208),
(236977, '1b3cA00', NULL, NULL, 64, NULL, NULL, 230208),
(236978, '1npiA00', NULL, NULL, 61, NULL, NULL, 230208),
(236979, '1bmrA00', NULL, NULL, 68, NULL, NULL, 230208),
(236980, '2ny9X00', NULL, NULL, 41, NULL, NULL, 230208),
(236981, '1nraA00', NULL, NULL, 63, NULL, NULL, 230208),
(236982, '1kv0A00', NULL, NULL, 66, NULL, NULL, 230208),
(236983, '2yc1C00', NULL, NULL, 66, NULL, NULL, 230208),
(236984, '1t0zA00', NULL, NULL, 72, NULL, NULL, 230208),
(236985, '2e3gA00', NULL, NULL, 40, NULL, NULL, 230208),
(236986, '1jzaA00', NULL, NULL, 66, NULL, NULL, 230208),
(236987, '2kbkA00', NULL, NULL, 64, NULL, NULL, 230208);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(236988, '5kk4E00', NULL, NULL, 48, NULL, NULL, 230208),
(236989, '1n4nA00', NULL, NULL, 47, NULL, NULL, 230208),
(236990, '1mynA00', NULL, NULL, 44, NULL, NULL, 230208),
(236991, '2sn3A00', NULL, NULL, 65, NULL, NULL, 230208),
(236992, '1snbA00', NULL, NULL, 64, NULL, NULL, 230208),
(236993, '1wt7A00', NULL, NULL, 41, NULL, NULL, 230208),
(236994, '2n2rA00', NULL, NULL, 51, NULL, NULL, 230208),
(236995, '5nceA00', NULL, NULL, 50, NULL, NULL, 230208),
(236996, '2lj7A00', NULL, NULL, 47, NULL, NULL, 230208),
(236997, '4hhfA00', NULL, NULL, 66, NULL, NULL, 230208),
(236998, '1lqqA00', NULL, NULL, 64, NULL, NULL, 230208),
(236999, '2e3fA00', NULL, NULL, 43, NULL, NULL, 230208),
(237000, '1ne5A00', NULL, NULL, 42, NULL, NULL, 230208),
(237001, '1gpsA00', NULL, NULL, 47, NULL, NULL, 230208),
(237002, '2li7A00', NULL, NULL, 67, NULL, NULL, 230208),
(237003, '1jxcA00', NULL, NULL, 68, NULL, NULL, 230208),
(237004, '4aazA00', NULL, NULL, 47, NULL, NULL, 230208),
(237005, '2lt8A01', NULL, NULL, 36, NULL, NULL, 230208),
(237006, '2yeoA00', NULL, NULL, 65, NULL, NULL, 230208),
(237007, '2kskA00', NULL, NULL, 71, NULL, NULL, 230208),
(237008, '2lkbA00', NULL, NULL, 66, NULL, NULL, 230208),
(237009, '1djtA00', NULL, NULL, 64, NULL, NULL, 230208),
(237010, '1wwnA00', NULL, NULL, 69, NULL, NULL, 230208),
(237011, '1ozzA00', NULL, NULL, 44, NULL, NULL, 230208),
(237012, '2atbA00', NULL, NULL, 65, NULL, NULL, 230208),
(237013, '1bk8A00', NULL, NULL, 50, NULL, NULL, 230208),
(237014, '1c55A00', NULL, NULL, 40, NULL, NULL, 230208),
(237015, '6avdA00', NULL, NULL, 40, NULL, NULL, 230208),
(237016, '4uj0A00', NULL, NULL, 49, NULL, NULL, 230208),
(237017, '1ahoA00', NULL, NULL, 64, NULL, NULL, 230208),
(237018, '1t1tA00', NULL, NULL, 63, NULL, NULL, 230208),
(237019, '1gptA00', NULL, NULL, 47, NULL, NULL, 230208),
(237020, '1icaA00', NULL, NULL, 40, NULL, NULL, 230208),
(237021, '2b68A01', NULL, NULL, 37, NULL, NULL, 230208),
(237022, '1i6fA00', NULL, NULL, 60, NULL, NULL, 230208),
(237023, '1dq7A00', NULL, NULL, 64, NULL, NULL, 230208),
(237024, '5cy0A00', NULL, NULL, 64, NULL, NULL, 230208),
(237025, '3psmA00', NULL, NULL, 47, NULL, NULL, 230208),
(237026, '6dmzA00', NULL, NULL, 47, NULL, NULL, 230208),
(237027, '1pe4A00', NULL, NULL, 67, NULL, NULL, 230208),
(237028, '1sn4A00', NULL, NULL, 64, NULL, NULL, 230208),
(237029, '6ay8A00', NULL, NULL, 40, NULL, NULL, 230208),
(237030, '2ny8X00', NULL, NULL, 40, NULL, NULL, 230208),
(237031, '2ljmA01', NULL, NULL, 53, NULL, NULL, 230208),
(237032, '1chzA00', NULL, NULL, 64, NULL, NULL, 230208),
(237033, '1segA00', NULL, NULL, 64, NULL, NULL, 230208),
(237034, '2kpyA01', NULL, NULL, 53, NULL, NULL, 230208),
(237035, '1ayjA00', NULL, NULL, 51, NULL, NULL, 230208),
(237036, '1i2uA00', NULL, NULL, 44, NULL, NULL, 230208),
(237037, '3e7rL01', NULL, NULL, 30, NULL, NULL, 230208),
(237038, '2mz0A00', NULL, NULL, 55, NULL, NULL, 230208),
(237039, '1jkzA00', NULL, NULL, 46, NULL, NULL, 230208),
(237040, '1ti5A00', NULL, NULL, 46, NULL, NULL, 230208),
(237041, '1zywA00', NULL, NULL, 66, NULL, NULL, 230208),
(237042, '2kyqA00', NULL, NULL, 53, NULL, NULL, 230208),
(237043, '2i61A00', NULL, NULL, 62, NULL, NULL, 230208),
(237044, '4he7A00', NULL, NULL, 54, NULL, NULL, 230208),
(237045, '5mouA00', NULL, NULL, 66, NULL, NULL, 230208),
(237046, '2oyyA00', NULL, NULL, 76, NULL, NULL, 230209),
(237047, '5u47A03', NULL, NULL, 90, NULL, NULL, 230210),
(237048, '2zc3A02', NULL, NULL, 90, NULL, NULL, 230210),
(237049, '3m6aA01', NULL, NULL, 50, NULL, NULL, 230211),
(237050, '5xteD00', NULL, NULL, 62, NULL, NULL, 230212),
(237051, '1pp9J00', NULL, NULL, 62, NULL, NULL, 230212),
(237052, '3tguW00', NULL, NULL, 61, NULL, NULL, 230212),
(237053, '3cx5I00', NULL, NULL, 65, NULL, NULL, 230212),
(237054, '4gywA03', NULL, NULL, 207, NULL, NULL, 230213),
(237055, '2vsyA02', NULL, NULL, 227, NULL, NULL, 230213),
(237056, '5a01A02', NULL, NULL, 188, NULL, NULL, 230213),
(237057, '3q3eA02', NULL, NULL, 166, NULL, NULL, 230213),
(237058, '3slkA01', NULL, NULL, 177, NULL, NULL, 230214),
(237059, '4impA02', NULL, NULL, 211, NULL, NULL, 230214);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(237060, '3d37A03', NULL, NULL, 69, NULL, NULL, 230215),
(237061, '1wruA03', NULL, NULL, 75, NULL, NULL, 230215),
(237062, '3cddB03', NULL, NULL, 76, NULL, NULL, 230215),
(237063, '2covG00', NULL, NULL, 104, NULL, NULL, 230216),
(237064, '3c9pA00', NULL, NULL, 123, NULL, NULL, 230217),
(237065, '2l48A00', NULL, NULL, 85, NULL, NULL, 230218),
(237066, '1wdiA01', NULL, NULL, 231, NULL, NULL, 230219),
(237067, '1vkyB01', NULL, NULL, 237, NULL, NULL, 230219),
(237068, '1yy3A01', NULL, NULL, 218, NULL, NULL, 230219),
(237069, '2b9wA03', NULL, NULL, 95, NULL, NULL, 230220),
(237070, '2qazD00', NULL, NULL, 128, NULL, NULL, 230221),
(237071, '1ou9B00', NULL, NULL, 129, NULL, NULL, 230221),
(237072, '1ou8A00', NULL, NULL, 111, NULL, NULL, 230221),
(237073, '2nysB00', NULL, NULL, 118, NULL, NULL, 230221),
(237074, '1yfnA00', NULL, NULL, 118, NULL, NULL, 230221),
(237075, '1zszC00', NULL, NULL, 113, NULL, NULL, 230221),
(237076, '2jaeA03', NULL, NULL, 101, NULL, NULL, 230222),
(237077, '4k0mC02', NULL, NULL, 89, NULL, NULL, 230223),
(237078, '4wweA02', NULL, NULL, 89, NULL, NULL, 230223),
(237079, '5dm6002', NULL, NULL, 93, NULL, NULL, 230223),
(237080, '4reoA02', NULL, NULL, 93, NULL, NULL, 230223),
(237081, '4wwtA02', NULL, NULL, 89, NULL, NULL, 230223),
(237082, '4lq4A02', NULL, NULL, 91, NULL, NULL, 230223),
(237083, '3o58A02', NULL, NULL, 95, NULL, NULL, 230223),
(237084, '1dwuA02', NULL, NULL, 91, NULL, NULL, 230223),
(237085, '1mzpA02', NULL, NULL, 91, NULL, NULL, 230223),
(237086, '3qoyA02', NULL, NULL, 93, NULL, NULL, 230223),
(237087, '3ctwB00', NULL, NULL, 131, NULL, NULL, 230224),
(237088, '1nktA04', NULL, NULL, 192, NULL, NULL, 230225),
(237089, '2fsgB04', NULL, NULL, 213, NULL, NULL, 230225),
(237090, '2fsiB04', NULL, NULL, 189, NULL, NULL, 230225),
(237091, '2ipcA04', NULL, NULL, 242, NULL, NULL, 230225),
(237092, '1tf5A04', NULL, NULL, 182, NULL, NULL, 230225),
(237093, '1m6nA04', NULL, NULL, 135, NULL, NULL, 230225),
(237094, '3n89A01', NULL, NULL, 216, NULL, NULL, 230226),
(237095, '2wzpP02', NULL, NULL, 26, NULL, NULL, 230227),
(237096, '3d3qB02', NULL, NULL, 76, NULL, NULL, 230228),
(237097, '3ephA02', NULL, NULL, 72, NULL, NULL, 230228),
(237098, '2zm5A02', NULL, NULL, 72, NULL, NULL, 230228),
(237099, '6az1E01', NULL, NULL, 114, NULL, NULL, 230229),
(237100, '2istA01', NULL, NULL, 75, NULL, NULL, 230229),
(237101, '1vs5D02', NULL, NULL, 94, NULL, NULL, 230229),
(237102, '5o5jD02', NULL, NULL, 94, NULL, NULL, 230229),
(237103, '6faiE01', NULL, NULL, 117, NULL, NULL, 230229),
(237104, '3kbgA01', NULL, NULL, 84, NULL, NULL, 230229),
(237105, '5mmjd02', NULL, NULL, 97, NULL, NULL, 230229),
(237106, '4lgtA01', NULL, NULL, 65, NULL, NULL, 230229),
(237107, '6g5iE01', NULL, NULL, 117, NULL, NULL, 230229),
(237108, '2vqeD02', NULL, NULL, 97, NULL, NULL, 230229),
(237109, '2k6pA00', NULL, NULL, 92, NULL, NULL, 230229),
(237110, '2xzmW01', NULL, NULL, 119, NULL, NULL, 230229),
(237111, '1jh3A00', NULL, NULL, 107, NULL, NULL, 230229),
(237112, '5optL01', NULL, NULL, 114, NULL, NULL, 230229),
(237113, '2janA03', NULL, NULL, 108, NULL, NULL, 230229),
(237114, '1h3fA03', NULL, NULL, 79, NULL, NULL, 230229),
(237115, '5z81A00', NULL, NULL, 106, NULL, NULL, 230229),
(237116, '5xxuE01', NULL, NULL, 117, NULL, NULL, 230229),
(237117, '5flxE01', NULL, NULL, 117, NULL, NULL, 230229),
(237118, '1c05A02', NULL, NULL, 88, NULL, NULL, 230229),
(237119, '1dm9A00', NULL, NULL, 108, NULL, NULL, 230229),
(237120, '3dh3B01', NULL, NULL, 62, NULL, NULL, 230229),
(237121, '1p9kA00', NULL, NULL, 79, NULL, NULL, 230229),
(237122, '3j7aF01', NULL, NULL, 117, NULL, NULL, 230229),
(237123, '4oudA03', NULL, NULL, 95, NULL, NULL, 230229),
(237124, '5xyiE01', NULL, NULL, 117, NULL, NULL, 230229),
(237125, '3hp7A01', NULL, NULL, 67, NULL, NULL, 230229),
(237126, '1h3eA03', NULL, NULL, 76, NULL, NULL, 230229),
(237127, '1kskA01', NULL, NULL, 66, NULL, NULL, 230229),
(237128, '1vioA01', NULL, NULL, 59, NULL, NULL, 230229),
(237129, '4mt0A01', NULL, NULL, 366, NULL, NULL, 230230),
(237130, '5azsC01', NULL, NULL, 367, NULL, NULL, 230230);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(237131, '5bunB00', NULL, NULL, 425, NULL, NULL, 230230),
(237132, '4k7kA00', NULL, NULL, 384, NULL, NULL, 230230),
(237133, '3d5kA01', NULL, NULL, 371, NULL, NULL, 230230),
(237134, '1ek9A00', NULL, NULL, 428, NULL, NULL, 230230),
(237135, '4k7rA01', NULL, NULL, 368, NULL, NULL, 230230),
(237136, '4mt4A00', NULL, NULL, 479, NULL, NULL, 230230),
(237137, '5azpB01', NULL, NULL, 374, NULL, NULL, 230230),
(237138, '1yc9A01', NULL, NULL, 334, NULL, NULL, 230230),
(237139, '1wp1B01', NULL, NULL, 425, NULL, NULL, 230230),
(237140, '2xr1A01', NULL, NULL, 99, NULL, NULL, 230231),
(237141, '2ycbA01', NULL, NULL, 95, NULL, NULL, 230231),
(237142, '3af5A01', NULL, NULL, 104, NULL, NULL, 230231),
(237143, '3h3iA00', NULL, NULL, 150, NULL, NULL, 230232),
(237144, '3uo9C01', NULL, NULL, 82, NULL, NULL, 230233),
(237145, '2a6hD09', NULL, NULL, 46, NULL, NULL, 230234),
(237146, '4esuA01', NULL, NULL, 168, NULL, NULL, 230235),
(237147, '4ervA01', NULL, NULL, 166, NULL, NULL, 230235),
(237148, '4etvA01', NULL, NULL, 166, NULL, NULL, 230235),
(237149, '1ru3A04', NULL, NULL, 89, NULL, NULL, 230236),
(237150, '1oaoC04', NULL, NULL, 91, NULL, NULL, 230236),
(237151, '4jdmA02', NULL, NULL, 63, NULL, NULL, 230237),
(237152, '3twlA01', NULL, NULL, 145, NULL, NULL, 230238),
(237153, '3vk8A01', NULL, NULL, 137, NULL, NULL, 230238),
(237154, '3u6pA01', NULL, NULL, 132, NULL, NULL, 230238),
(237155, '4mb7A01', NULL, NULL, 126, NULL, NULL, 230238),
(237156, '4cisA01', NULL, NULL, 133, NULL, NULL, 230238),
(237157, '3w0fA01', NULL, NULL, 146, NULL, NULL, 230238),
(237158, '6fl1A01', NULL, NULL, 132, NULL, NULL, 230238),
(237159, '1k82B01', NULL, NULL, 127, NULL, NULL, 230238),
(237160, '1k3xA01', NULL, NULL, 126, NULL, NULL, 230238),
(237161, '5itqA01', NULL, NULL, 133, NULL, NULL, 230238),
(237162, '1ee8A01', NULL, NULL, 120, NULL, NULL, 230238),
(237163, '2iz4A02', NULL, NULL, 42, NULL, NULL, 230239),
(237164, '3ix0A02', NULL, NULL, 42, NULL, NULL, 230239),
(237165, '4yfsA01', NULL, NULL, 170, NULL, NULL, 230240),
(237166, '3bqkA02', NULL, NULL, 164, NULL, NULL, 230240),
(237167, '3rrcA01', NULL, NULL, 176, NULL, NULL, 230240),
(237168, '2y8dA01', NULL, NULL, 175, NULL, NULL, 230240),
(237169, '2wauA01', NULL, NULL, 155, NULL, NULL, 230240),
(237170, '5x6nA01', NULL, NULL, 184, NULL, NULL, 230240),
(237171, '2m3eA00', NULL, NULL, 50, NULL, NULL, 230241),
(237172, '2k1aA00', NULL, NULL, 42, NULL, NULL, 230241),
(237173, '2kncA00', NULL, NULL, 54, NULL, NULL, 230241),
(237174, '1zl8A00', NULL, NULL, 53, NULL, NULL, 230242),
(237175, '1zl8B00', NULL, NULL, 54, NULL, NULL, 230242),
(237176, '3b40A02', NULL, NULL, 58, NULL, NULL, 230242),
(237177, '1rsoB00', NULL, NULL, 56, NULL, NULL, 230242),
(237178, '1y76A00', NULL, NULL, 62, NULL, NULL, 230242),
(237179, '1y76B00', NULL, NULL, 60, NULL, NULL, 230242),
(237180, '1y74A00', NULL, NULL, 57, NULL, NULL, 230242),
(237181, '1vf6A00', NULL, NULL, 62, NULL, NULL, 230242),
(237182, '1vf6C00', NULL, NULL, 72, NULL, NULL, 230242),
(237183, '4m5dB02', NULL, NULL, 60, NULL, NULL, 230243),
(237184, '4gxtA02', NULL, NULL, 157, NULL, NULL, 230244),
(237185, '1zt3A00', NULL, NULL, 80, NULL, NULL, 230245),
(237186, '2h7tA01', NULL, NULL, 74, NULL, NULL, 230245),
(237187, '2dsrG00', NULL, NULL, 82, NULL, NULL, 230245),
(237188, '1rmjA01', NULL, NULL, 75, NULL, NULL, 230245),
(237189, '1icfI00', NULL, NULL, 65, NULL, NULL, 230245),
(237190, '2idoB00', NULL, NULL, 83, NULL, NULL, 230246),
(237191, '1du2A00', NULL, NULL, 76, NULL, NULL, 230246),
(237192, '1rh7B01', NULL, NULL, 20, NULL, NULL, 230247),
(237193, '2wdtA01', NULL, NULL, 108, NULL, NULL, 230248),
(237194, '1szwA02', NULL, NULL, 136, NULL, NULL, 230249),
(237195, '1uglA00', NULL, NULL, 50, NULL, NULL, 230250),
(237196, '2x0qA02', NULL, NULL, 48, NULL, NULL, 230251),
(237197, '5o7oC02', NULL, NULL, 48, NULL, NULL, 230251),
(237198, '4q37A00', NULL, NULL, 128, NULL, NULL, 230252),
(237199, '3bulA02', NULL, NULL, 153, NULL, NULL, 230252),
(237200, '2xijA02', NULL, NULL, 164, NULL, NULL, 230252),
(237201, '1reqB02', NULL, NULL, 139, NULL, NULL, 230252);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(237202, '2yxbA00', NULL, NULL, 161, NULL, NULL, 230252),
(237203, '4hh3C02', NULL, NULL, 139, NULL, NULL, 230252),
(237204, '1reqA02', NULL, NULL, 164, NULL, NULL, 230252),
(237205, '3whpA02', NULL, NULL, 126, NULL, NULL, 230252),
(237206, '4jgiB02', NULL, NULL, 131, NULL, NULL, 230252),
(237207, '1xrsB02', NULL, NULL, 161, NULL, NULL, 230252),
(237208, '1ccwA00', NULL, NULL, 137, NULL, NULL, 230252),
(237209, '4r3uC00', NULL, NULL, 158, NULL, NULL, 230252),
(237210, '3ezxA02', NULL, NULL, 129, NULL, NULL, 230252),
(237211, '1y80A00', NULL, NULL, 126, NULL, NULL, 230252),
(237212, '1be1A00', NULL, NULL, 137, NULL, NULL, 230252),
(237213, '3kp1A04', NULL, NULL, 150, NULL, NULL, 230252),
(237214, '2i2xB02', NULL, NULL, 137, NULL, NULL, 230252),
(237215, '4xc7B01', NULL, NULL, 144, NULL, NULL, 230252),
(237216, '3o3mB02', NULL, NULL, 126, NULL, NULL, 230253),
(237217, '1s6yA02', NULL, NULL, 277, NULL, NULL, 230254),
(237218, '7mdhA02', NULL, NULL, 173, NULL, NULL, 230254),
(237219, '3wswA02', NULL, NULL, 175, NULL, NULL, 230254),
(237220, '1smkA02', NULL, NULL, 173, NULL, NULL, 230254),
(237221, '5nueB02', NULL, NULL, 177, NULL, NULL, 230254),
(237222, '2v65A02', NULL, NULL, 168, NULL, NULL, 230254),
(237223, '5c3mC02', NULL, NULL, 277, NULL, NULL, 230254),
(237224, '3p7mA02', NULL, NULL, 174, NULL, NULL, 230254),
(237225, '4bguA02', NULL, NULL, 161, NULL, NULL, 230254),
(237226, '4uuoA02', NULL, NULL, 188, NULL, NULL, 230254),
(237227, '5zi2A02', NULL, NULL, 198, NULL, NULL, 230254),
(237228, '3h3jB02', NULL, NULL, 169, NULL, NULL, 230254),
(237229, '1b8pA02', NULL, NULL, 172, NULL, NULL, 230254),
(237230, '3pqeA02', NULL, NULL, 166, NULL, NULL, 230254),
(237231, '1y6jA02', NULL, NULL, 170, NULL, NULL, 230254),
(237232, '1oc4A02', NULL, NULL, 171, NULL, NULL, 230254),
(237233, '1a5zA02', NULL, NULL, 166, NULL, NULL, 230254),
(237234, '1y7tA02', NULL, NULL, 172, NULL, NULL, 230254),
(237235, '5ujkA02', NULL, NULL, 175, NULL, NULL, 230254),
(237236, '1mldA02', NULL, NULL, 167, NULL, NULL, 230254),
(237237, '4m1qA02', NULL, NULL, 167, NULL, NULL, 230254),
(237238, '2d4aA02', NULL, NULL, 160, NULL, NULL, 230254),
(237239, '3tl2A02', NULL, NULL, 161, NULL, NULL, 230254),
(237240, '4uupB02', NULL, NULL, 188, NULL, NULL, 230254),
(237241, '4bgvA02', NULL, NULL, 174, NULL, NULL, 230254),
(237242, '3fi9A02', NULL, NULL, 192, NULL, NULL, 230254),
(237243, '1pzgC02', NULL, NULL, 176, NULL, NULL, 230254),
(237244, '1ldnA02', NULL, NULL, 168, NULL, NULL, 230254),
(237245, '4cl3A02', NULL, NULL, 161, NULL, NULL, 230254),
(237246, '1u8xX02', NULL, NULL, 281, NULL, NULL, 230254),
(237247, '2dfdA02', NULL, NULL, 167, NULL, NULL, 230254),
(237248, '4pltA02', NULL, NULL, 180, NULL, NULL, 230254),
(237249, '1sovA02', NULL, NULL, 175, NULL, NULL, 230254),
(237250, '2hjrB02', NULL, NULL, 172, NULL, NULL, 230254),
(237251, '5hs4A02', NULL, NULL, 167, NULL, NULL, 230254),
(237252, '3nepX02', NULL, NULL, 160, NULL, NULL, 230254),
(237253, '4tvoB02', NULL, NULL, 175, NULL, NULL, 230254),
(237254, '6ldhA02', NULL, NULL, 167, NULL, NULL, 230254),
(237255, '9ldtA02', NULL, NULL, 170, NULL, NULL, 230254),
(237256, '3hhpA02', NULL, NULL, 166, NULL, NULL, 230254),
(237257, '6ct6A02', NULL, NULL, 182, NULL, NULL, 230254),
(237258, '6duxB02', NULL, NULL, 274, NULL, NULL, 230254),
(237259, '2ldxA02', NULL, NULL, 170, NULL, NULL, 230254),
(237260, '3gviD02', NULL, NULL, 175, NULL, NULL, 230254),
(237261, '5nfrA02', NULL, NULL, 177, NULL, NULL, 230254),
(237262, '1ez4A02', NULL, NULL, 165, NULL, NULL, 230254),
(237263, '2x0jA02', NULL, NULL, 152, NULL, NULL, 230254),
(237264, '1guzA02', NULL, NULL, 162, NULL, NULL, 230254),
(237265, '6h9sA02', NULL, NULL, 162, NULL, NULL, 230254),
(237266, '6balA02', NULL, NULL, 165, NULL, NULL, 230254),
(237267, '1gv0A02', NULL, NULL, 161, NULL, NULL, 230254),
(237268, '4aj2A02', NULL, NULL, 168, NULL, NULL, 230254),
(237269, '1civA02', NULL, NULL, 175, NULL, NULL, 230254),
(237270, '5nqbA02', NULL, NULL, 170, NULL, NULL, 230254),
(237271, '4ln1A02', NULL, NULL, 167, NULL, NULL, 230254),
(237272, '3ldhA02', NULL, NULL, 167, NULL, NULL, 230254);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(237273, '4h7pA02', NULL, NULL, 170, NULL, NULL, 230254),
(237274, '1v6aA02', NULL, NULL, 168, NULL, NULL, 230254),
(237275, '1up6E02', NULL, NULL, 280, NULL, NULL, 230254),
(237276, '1hyeA02', NULL, NULL, 163, NULL, NULL, 230254),
(237277, '4uulA02', NULL, NULL, 188, NULL, NULL, 230254),
(237278, '6cepA02', NULL, NULL, 168, NULL, NULL, 230254),
(237279, '4plgA02', NULL, NULL, 179, NULL, NULL, 230254),
(237280, '4nd2A02', NULL, NULL, 175, NULL, NULL, 230254),
(237281, '2v6bC02', NULL, NULL, 165, NULL, NULL, 230254),
(237282, '1lldA02', NULL, NULL, 170, NULL, NULL, 230254),
(237283, '4jcoA02', NULL, NULL, 161, NULL, NULL, 230254),
(237284, '5w8jA02', NULL, NULL, 168, NULL, NULL, 230254),
(237285, '4e0bA02', NULL, NULL, 164, NULL, NULL, 230254),
(237286, '3d5tA02', NULL, NULL, 172, NULL, NULL, 230254),
(237287, '4q3nA02', NULL, NULL, 169, NULL, NULL, 230254),
(237288, '4plzA02', NULL, NULL, 173, NULL, NULL, 230254),
(237289, '3vpgA02', NULL, NULL, 169, NULL, NULL, 230254),
(237290, '5mdhA02', NULL, NULL, 180, NULL, NULL, 230254),
(237291, '6j9sB02', NULL, NULL, 176, NULL, NULL, 230254),
(237292, '1hyhC02', NULL, NULL, 159, NULL, NULL, 230254),
(237293, '2i6tA02', NULL, NULL, 153, NULL, NULL, 230254),
(237294, '5k0zA02', NULL, NULL, 168, NULL, NULL, 230254),
(237295, '3me5A03', NULL, NULL, 115, NULL, NULL, 230255),
(237296, '4nleA02', NULL, NULL, 136, NULL, NULL, 230256),
(237297, '1qgkB00', NULL, NULL, 44, NULL, NULL, 230257),
(237298, '2lhrA00', NULL, NULL, 78, NULL, NULL, 230258),
(237299, '3rsiB02', NULL, NULL, 135, NULL, NULL, 230259),
(237300, '1zatA01', NULL, NULL, 125, NULL, NULL, 230260),
(237301, '3te8A00', NULL, NULL, 127, NULL, NULL, 230261),
(237302, '3lr5A00', NULL, NULL, 123, NULL, NULL, 230261),
(237303, '2cwyA00', NULL, NULL, 94, NULL, NULL, 230262),
(237304, '2ijqB00', NULL, NULL, 118, NULL, NULL, 230262),
(237305, '2ijqA00', NULL, NULL, 161, NULL, NULL, 230262),
(237306, '2bh7A01', NULL, NULL, 27, NULL, NULL, 230263),
(237307, '2j42A02', NULL, NULL, 225, NULL, NULL, 230264),
(237308, '3tewA02', NULL, NULL, 207, NULL, NULL, 230264),
(237309, '3mzkB01', NULL, NULL, 58, NULL, NULL, 230265),
(237310, '1rz4A01', NULL, NULL, 121, NULL, NULL, 230266),
(237311, '1oh1A00', NULL, NULL, 109, NULL, NULL, 230267),
(237312, '1nycA00', NULL, NULL, 111, NULL, NULL, 230267),
(237313, '3ntkB01', NULL, NULL, 89, NULL, NULL, 230268),
(237314, '1fx3B00', NULL, NULL, 169, NULL, NULL, 230269),
(237315, '1fx3D00', NULL, NULL, 135, NULL, NULL, 230269),
(237316, '2o2aB00', NULL, NULL, 128, NULL, NULL, 230269),
(237317, '1qynD00', NULL, NULL, 153, NULL, NULL, 230269),
(237318, '2hngA00', NULL, NULL, 127, NULL, NULL, 230269),
(237319, '5v37A03', NULL, NULL, 86, NULL, NULL, 230270),
(237320, '3q9dA03', NULL, NULL, 50, NULL, NULL, 230271),
(237321, '4mlkA03', NULL, NULL, 60, NULL, NULL, 230271),
(237322, '2dq5A01', NULL, NULL, 29, NULL, NULL, 230272),
(237323, '1hc9A00', NULL, NULL, 74, NULL, NULL, 230273),
(237324, '2j8bA00', NULL, NULL, 79, NULL, NULL, 230273),
(237325, '6f21A00', NULL, NULL, 57, NULL, NULL, 230273),
(237326, '1vb0A00', NULL, NULL, 61, NULL, NULL, 230273),
(237327, '1qm7A00', NULL, NULL, 61, NULL, NULL, 230273),
(237328, '1f94A00', NULL, NULL, 63, NULL, NULL, 230273),
(237329, '1tgxA00', NULL, NULL, 60, NULL, NULL, 230273),
(237330, '3vtsA00', NULL, NULL, 61, NULL, NULL, 230273),
(237331, '5do6A00', NULL, NULL, 57, NULL, NULL, 230273),
(237332, '2n99A00', NULL, NULL, 76, NULL, NULL, 230273),
(237333, '1lsiA00', NULL, NULL, 66, NULL, NULL, 230273),
(237334, '2h62C00', NULL, NULL, 96, NULL, NULL, 230273),
(237335, '2hlrA00', NULL, NULL, 100, NULL, NULL, 230273),
(237336, '1nxbA00', NULL, NULL, 62, NULL, NULL, 230273),
(237337, '5tx4A00', NULL, NULL, 116, NULL, NULL, 230273),
(237338, '2muoA00', NULL, NULL, 82, NULL, NULL, 230273),
(237339, '4do8A00', NULL, NULL, 66, NULL, NULL, 230273),
(237340, '1v6pA00', NULL, NULL, 62, NULL, NULL, 230273),
(237341, '2l03A00', NULL, NULL, 74, NULL, NULL, 230273),
(237342, '1drsA00', NULL, NULL, 59, NULL, NULL, 230273),
(237343, '3ndsA00', NULL, NULL, 62, NULL, NULL, 230273);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(237344, '4lftB00', NULL, NULL, 73, NULL, NULL, 230273),
(237345, '1ntxA00', NULL, NULL, 60, NULL, NULL, 230273),
(237346, '1kxiA00', NULL, NULL, 62, NULL, NULL, 230273),
(237347, '2h7zB00', NULL, NULL, 77, NULL, NULL, 230273),
(237348, '4iyeA00', NULL, NULL, 66, NULL, NULL, 230273),
(237349, '1ff4A00', NULL, NULL, 65, NULL, NULL, 230273),
(237350, '1ug4A00', NULL, NULL, 60, NULL, NULL, 230273),
(237351, '5nh3A00', NULL, NULL, 99, NULL, NULL, 230273),
(237352, '4zqyA00', NULL, NULL, 65, NULL, NULL, 230273),
(237353, '2fd6U01', NULL, NULL, 81, NULL, NULL, 230273),
(237354, '2fd6U02', NULL, NULL, 96, NULL, NULL, 230273),
(237355, '2fd6U03', NULL, NULL, 88, NULL, NULL, 230273),
(237356, '2pjyC00', NULL, NULL, 79, NULL, NULL, 230273),
(237357, '1jgkA00', NULL, NULL, 66, NULL, NULL, 230273),
(237358, '5ngvA00', NULL, NULL, 99, NULL, NULL, 230273),
(237359, '1txaA00', NULL, NULL, 73, NULL, NULL, 230273),
(237360, '3evsC00', NULL, NULL, 98, NULL, NULL, 230273),
(237361, '1chvS00', NULL, NULL, 60, NULL, NULL, 230273),
(237362, '2mj0A00', NULL, NULL, 66, NULL, NULL, 230273),
(237363, '2abxA00', NULL, NULL, 74, NULL, NULL, 230273),
(237364, '5mg9A00', NULL, NULL, 65, NULL, NULL, 230273),
(237365, '1tfsA00', NULL, NULL, 60, NULL, NULL, 230273),
(237366, '1m9zA00', NULL, NULL, 111, NULL, NULL, 230273),
(237367, '3ebxA00', NULL, NULL, 62, NULL, NULL, 230273),
(237368, '3neqA00', NULL, NULL, 66, NULL, NULL, 230273),
(237369, '2qj9C00', NULL, NULL, 98, NULL, NULL, 230273),
(237370, '1h0jA00', NULL, NULL, 60, NULL, NULL, 230273),
(237371, '2jqpA00', NULL, NULL, 65, NULL, NULL, 230273),
(237372, '3fevA00', NULL, NULL, 65, NULL, NULL, 230273),
(237373, '1mr6A00', NULL, NULL, 68, NULL, NULL, 230273),
(237374, '2h62D00', NULL, NULL, 98, NULL, NULL, 230273),
(237375, '2h5fA00', NULL, NULL, 77, NULL, NULL, 230273),
(237376, '2h8uA00', NULL, NULL, 65, NULL, NULL, 230273),
(237377, '1ntnA00', NULL, NULL, 72, NULL, NULL, 230273),
(237378, '3laqU01', NULL, NULL, 81, NULL, NULL, 230273),
(237379, '3laqU02', NULL, NULL, 93, NULL, NULL, 230273),
(237380, '3laqU03', NULL, NULL, 92, NULL, NULL, 230273),
(237381, '5xweA00', NULL, NULL, 62, NULL, NULL, 230273),
(237382, '2mhyA00', NULL, NULL, 57, NULL, NULL, 230273),
(237383, '4aeaA00', NULL, NULL, 71, NULL, NULL, 230273),
(237384, '1bteA00', NULL, NULL, 97, NULL, NULL, 230273),
(237385, '2qjbC00', NULL, NULL, 98, NULL, NULL, 230273),
(237386, '2h7zA00', NULL, NULL, 75, NULL, NULL, 230273),
(237387, '1cdtA00', NULL, NULL, 60, NULL, NULL, 230273),
(237388, '1g6mA00', NULL, NULL, 62, NULL, NULL, 230273),
(237389, '2vlwA00', NULL, NULL, 65, NULL, NULL, 230273),
(237390, '5lueA00', NULL, NULL, 61, NULL, NULL, 230273),
(237391, '1ks6A00', NULL, NULL, 107, NULL, NULL, 230273),
(237392, '1kbaA00', NULL, NULL, 66, NULL, NULL, 230273),
(237393, '1fasA00', NULL, NULL, 61, NULL, NULL, 230273),
(237394, '3plcB00', NULL, NULL, 63, NULL, NULL, 230273),
(237395, '3hh7A00', NULL, NULL, 65, NULL, NULL, 230273),
(237396, '1cb9A00', NULL, NULL, 60, NULL, NULL, 230273),
(237397, '4om5A00', NULL, NULL, 60, NULL, NULL, 230273),
(237398, '2jveA00', NULL, NULL, 71, NULL, NULL, 230273),
(237399, '4faoC00', NULL, NULL, 85, NULL, NULL, 230273),
(237400, '4rudA00', NULL, NULL, 58, NULL, NULL, 230273),
(237401, '1p4qA00', NULL, NULL, 52, NULL, NULL, 230274),
(237402, '1r8uA00', NULL, NULL, 50, NULL, NULL, 230274),
(237403, '3mxnA02', NULL, NULL, 55, NULL, NULL, 230275),
(237404, '2l3nA00', NULL, NULL, 104, NULL, NULL, 230276),
(237405, '3w7tA04', NULL, NULL, 32, NULL, NULL, 230277),
(237406, '2ijrA02', NULL, NULL, 179, NULL, NULL, 230278),
(237407, '3q23A08', NULL, NULL, 154, NULL, NULL, 230279),
(237408, '2vovA00', NULL, NULL, 290, NULL, NULL, 230280),
(237409, '4bz4B00', NULL, NULL, 204, NULL, NULL, 230280),
(237410, '3vkgA14', NULL, NULL, 80, NULL, NULL, 230281),
(237411, '5dllA04', NULL, NULL, 94, NULL, NULL, 230282),
(237412, '4qhpA04', NULL, NULL, 101, NULL, NULL, 230282),
(237413, '3b34A04', NULL, NULL, 102, NULL, NULL, 230282),
(237414, '5zi7A04', NULL, NULL, 87, NULL, NULL, 230282),
(237415, '6ea2A04', NULL, NULL, 96, NULL, NULL, 230282);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(237416, '1irxA02', NULL, NULL, 43, NULL, NULL, 230283),
(237417, '1d6gA00', NULL, NULL, 47, NULL, NULL, 230284),
(237418, '2pifA02', NULL, NULL, 113, NULL, NULL, 230285),
(237419, '3db9A02', NULL, NULL, 112, NULL, NULL, 230285),
(237420, '1xawA01', NULL, NULL, 99, NULL, NULL, 230286),
(237421, '4ke2A00', NULL, NULL, 196, NULL, NULL, 230287),
(237422, '1rrzA00', NULL, NULL, 66, NULL, NULL, 230288),
(237423, '1itvA00', NULL, NULL, 195, NULL, NULL, 230289),
(237424, '1qhuA01', NULL, NULL, 190, NULL, NULL, 230289),
(237425, '3lp9A00', NULL, NULL, 227, NULL, NULL, 230289),
(237426, '3s18A00', NULL, NULL, 227, NULL, NULL, 230289),
(237427, '1fblA02', NULL, NULL, 191, NULL, NULL, 230289),
(237428, '1hxnA00', NULL, NULL, 219, NULL, NULL, 230289),
(237429, '3ba0A02', NULL, NULL, 193, NULL, NULL, 230289),
(237430, '1genA00', NULL, NULL, 200, NULL, NULL, 230289),
(237431, '1su3A02', NULL, NULL, 200, NULL, NULL, 230289),
(237432, '4fvlA02', NULL, NULL, 190, NULL, NULL, 230289),
(237433, '3oyoA00', NULL, NULL, 225, NULL, NULL, 230289),
(237434, '3c7xA00', NULL, NULL, 196, NULL, NULL, 230289),
(237435, '2x8kA03', NULL, NULL, 111, NULL, NULL, 230290),
(237436, '4divS02', NULL, NULL, 104, NULL, NULL, 230290),
(237437, '3p9yA02', NULL, NULL, 56, NULL, NULL, 230291),
(237438, '4h3kB02', NULL, NULL, 56, NULL, NULL, 230291),
(237439, '2cr8A01', NULL, NULL, 26, NULL, NULL, 230292),
(237440, '1amuA03', NULL, NULL, 81, NULL, NULL, 230293),
(237441, '4rlqA03', NULL, NULL, 112, NULL, NULL, 230293),
(237442, '1lciA03', NULL, NULL, 77, NULL, NULL, 230293),
(237443, '5u95B03', NULL, NULL, 75, NULL, NULL, 230293),
(237444, '3cw9A03', NULL, NULL, 80, NULL, NULL, 230293),
(237445, '3a9uA03', NULL, NULL, 75, NULL, NULL, 230293),
(237446, '2vsqA05', NULL, NULL, 77, NULL, NULL, 230293),
(237447, '1mdbA03', NULL, NULL, 76, NULL, NULL, 230293),
(237448, '6aaaA01', NULL, NULL, 95, NULL, NULL, 230293),
(237449, '2d1sA01', NULL, NULL, 94, NULL, NULL, 230293),
(237450, '5kytA01', NULL, NULL, 94, NULL, NULL, 230293),
(237451, '2ecsA00', NULL, NULL, 66, NULL, NULL, 230294),
(237452, '1d1mA00', NULL, NULL, 65, NULL, NULL, 230294),
(237453, '2a63A00', NULL, NULL, 66, NULL, NULL, 230294),
(237454, '2cw1A00', NULL, NULL, 65, NULL, NULL, 230294),
(237455, '4i5qA01', NULL, NULL, 67, NULL, NULL, 230295),
(237456, '1eejA01', NULL, NULL, 61, NULL, NULL, 230295),
(237457, '5g1lA01', NULL, NULL, 70, NULL, NULL, 230295),
(237458, '4npbA01', NULL, NULL, 64, NULL, NULL, 230295),
(237459, '1t3bA01', NULL, NULL, 49, NULL, NULL, 230295),
(237460, '2e87A01', NULL, NULL, 161, NULL, NULL, 230296),
(237461, '2l5qA01', NULL, NULL, 50, NULL, NULL, 230297),
(237462, '2h6oA03', NULL, NULL, 110, NULL, NULL, 230298),
(237463, '2fojA00', NULL, NULL, 155, NULL, NULL, 230299),
(237464, '5h9mA02', NULL, NULL, 133, NULL, NULL, 230299),
(237465, '4ca1B02', NULL, NULL, 134, NULL, NULL, 230299),
(237466, '4ysiA00', NULL, NULL, 143, NULL, NULL, 230299),
(237467, '1lb6A00', NULL, NULL, 160, NULL, NULL, 230299),
(237468, '3ivvA01', NULL, NULL, 138, NULL, NULL, 230299),
(237469, '1f3vB00', NULL, NULL, 171, NULL, NULL, 230299),
(237470, '3zjbA00', NULL, NULL, 197, NULL, NULL, 230299),
(237471, '2f1zB01', NULL, NULL, 152, NULL, NULL, 230299),
(237472, '4ghuA00', NULL, NULL, 198, NULL, NULL, 230299),
(237473, '6mydA00', NULL, NULL, 157, NULL, NULL, 230299),
(237474, '4gwmB03', NULL, NULL, 164, NULL, NULL, 230299),
(237475, '5e1tC00', NULL, NULL, 197, NULL, NULL, 230299),
(237476, '4gjhA00', NULL, NULL, 178, NULL, NULL, 230299),
(237477, '2b4vA02', NULL, NULL, 119, NULL, NULL, 230300),
(237478, '2z84A00', NULL, NULL, 218, NULL, NULL, 230301),
(237479, '3oqcA02', NULL, NULL, 212, NULL, NULL, 230301),
(237480, '3kr9A02', NULL, NULL, 64, NULL, NULL, 230302),
(237481, '3gnlB02', NULL, NULL, 76, NULL, NULL, 230302),
(237482, '3lecA02', NULL, NULL, 63, NULL, NULL, 230302),
(237483, '3rmqA02', NULL, NULL, 58, NULL, NULL, 230303),
(237484, '4ncbA02', NULL, NULL, 76, NULL, NULL, 230304),
(237485, '3vkgB06', NULL, NULL, 245, NULL, NULL, 230305),
(237486, '4akgA11', NULL, NULL, 307, NULL, NULL, 230305);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(237487, '3vkhA11', NULL, NULL, 342, NULL, NULL, 230305),
(237488, '3vkhB12', NULL, NULL, 144, NULL, NULL, 230305),
(237489, '3vkgA11', NULL, NULL, 114, NULL, NULL, 230305),
(237490, '2ixsA02', NULL, NULL, 162, NULL, NULL, 230306),
(237491, '3o6xA02', NULL, NULL, 149, NULL, NULL, 230307),
(237492, '2kktA00', NULL, NULL, 57, NULL, NULL, 230308),
(237493, '2lg7A00', NULL, NULL, 129, NULL, NULL, 230309),
(237494, '1apyB00', NULL, NULL, 141, NULL, NULL, 230310),
(237495, '1k2xB00', NULL, NULL, 143, NULL, NULL, 230310),
(237496, '6nq6B00', NULL, NULL, 144, NULL, NULL, 230310),
(237497, '4pv2B00', NULL, NULL, 131, NULL, NULL, 230310),
(237498, '2gezB00', NULL, NULL, 133, NULL, NULL, 230310),
(237499, '2wteA01', NULL, NULL, 146, NULL, NULL, 230311),
(237500, '2sakA00', NULL, NULL, 121, NULL, NULL, 230312),
(237501, '6qulC03', NULL, NULL, 78, NULL, NULL, 230313),
(237502, '5xymC03', NULL, NULL, 82, NULL, NULL, 230313),
(237503, '6hmaC03', NULL, NULL, 80, NULL, NULL, 230313),
(237504, '1vvmD03', NULL, NULL, 80, NULL, NULL, 230313),
(237505, '3pioA03', NULL, NULL, 79, NULL, NULL, 230313),
(237506, '1vq8A03', NULL, NULL, 80, NULL, NULL, 230313),
(237507, '5v7qC03', NULL, NULL, 84, NULL, NULL, 230313),
(237508, '1wfxA02', NULL, NULL, 94, NULL, NULL, 230314),
(237509, '4dwpA01', NULL, NULL, 92, NULL, NULL, 230315),
(237510, '4e0gA01', NULL, NULL, 92, NULL, NULL, 230315),
(237511, '3ckdA01', NULL, NULL, 81, NULL, NULL, 230316),
(237512, '6if7A00', NULL, NULL, 183, NULL, NULL, 230317),
(237513, '5l2vA00', NULL, NULL, 166, NULL, NULL, 230317),
(237514, '5fjqA00', NULL, NULL, 180, NULL, NULL, 230317),
(237515, '4a02A00', NULL, NULL, 166, NULL, NULL, 230317),
(237516, '2yoyA00', NULL, NULL, 178, NULL, NULL, 230317),
(237517, '5ftzA00', NULL, NULL, 172, NULL, NULL, 230317),
(237518, '4oy6A00', NULL, NULL, 186, NULL, NULL, 230317),
(237519, '2xwxA01', NULL, NULL, 179, NULL, NULL, 230317),
(237520, '3uamC00', NULL, NULL, 193, NULL, NULL, 230317),
(237521, '5opfA00', NULL, NULL, 194, NULL, NULL, 230317),
(237522, '2bemA00', NULL, NULL, 170, NULL, NULL, 230317),
(237523, '4oy7E00', NULL, NULL, 196, NULL, NULL, 230317),
(237524, '4gboA00', NULL, NULL, 186, NULL, NULL, 230317),
(237525, '5aa7A00', NULL, NULL, 142, NULL, NULL, 230317),
(237526, '5wszA00', NULL, NULL, 169, NULL, NULL, 230317),
(237527, '1e1hB01', NULL, NULL, 103, NULL, NULL, 230318),
(237528, '4bx8A04', NULL, NULL, 92, NULL, NULL, 230319),
(237529, '4jc8A04', NULL, NULL, 98, NULL, NULL, 230319),
(237530, '3hj6A02', NULL, NULL, 58, NULL, NULL, 230320),
(237531, '2c42A04', NULL, NULL, 41, NULL, NULL, 230321),
(237532, '1vjvA02', NULL, NULL, 74, NULL, NULL, 230322),
(237533, '4wkgC01', NULL, NULL, 304, NULL, NULL, 230323),
(237534, '4lxqB00', NULL, NULL, 274, NULL, NULL, 230323),
(237535, '2yn3D03', NULL, NULL, 70, NULL, NULL, 230324),
(237536, '2x51A07', NULL, NULL, 44, NULL, NULL, 230325),
(237537, '2rrfA00', NULL, NULL, 141, NULL, NULL, 230326),
(237538, '3ly7A01', NULL, NULL, 161, NULL, NULL, 230327),
(237539, '2lezA00', NULL, NULL, 120, NULL, NULL, 230328),
(237540, '3kxlA02', NULL, NULL, 26, NULL, NULL, 230329),
(237541, '2jhnA02', NULL, NULL, 120, NULL, NULL, 230330),
(237542, '4unfA02', NULL, NULL, 117, NULL, NULL, 230330),
(237543, '3fhfA02', NULL, NULL, 110, NULL, NULL, 230330),
(237544, '5kn8A02', NULL, NULL, 112, NULL, NULL, 230330),
(237545, '3n0uA02', NULL, NULL, 109, NULL, NULL, 230330),
(237546, '2ofkA00', NULL, NULL, 183, NULL, NULL, 230330),
(237547, '4ea4A00', NULL, NULL, 155, NULL, NULL, 230330),
(237548, '1xg7A02', NULL, NULL, 143, NULL, NULL, 230330),
(237549, '2yg9A02', NULL, NULL, 112, NULL, NULL, 230330),
(237550, '3s6iA02', NULL, NULL, 116, NULL, NULL, 230330),
(237551, '3n5nX02', NULL, NULL, 121, NULL, NULL, 230330),
(237552, '1ngnA00', NULL, NULL, 155, NULL, NULL, 230330),
(237553, '4uobA02', NULL, NULL, 126, NULL, NULL, 230330),
(237554, '1ornA01', NULL, NULL, 112, NULL, NULL, 230330),
(237555, '1xqoA02', NULL, NULL, 135, NULL, NULL, 230330),
(237556, '2abkA01', NULL, NULL, 112, NULL, NULL, 230330),
(237557, '3i0wA02', NULL, NULL, 121, NULL, NULL, 230330);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(237558, '4b21A02', NULL, NULL, 117, NULL, NULL, 230330),
(237559, '2jg6A00', NULL, NULL, 186, NULL, NULL, 230330),
(237560, '3fhgA02', NULL, NULL, 113, NULL, NULL, 230330),
(237561, '4ejyA02', NULL, NULL, 121, NULL, NULL, 230330),
(237562, '1keaA02', NULL, NULL, 113, NULL, NULL, 230330),
(237563, '1lmzA00', NULL, NULL, 187, NULL, NULL, 230330),
(237564, '4ofaA00', NULL, NULL, 143, NULL, NULL, 230330),
(237565, '1kg2A02', NULL, NULL, 112, NULL, NULL, 230330),
(237566, '6g3xA03', NULL, NULL, 126, NULL, NULL, 230330),
(237567, '1pu6A02', NULL, NULL, 123, NULL, NULL, 230330),
(237568, '2xhiA03', NULL, NULL, 126, NULL, NULL, 230330),
(237569, '1mpgA02', NULL, NULL, 118, NULL, NULL, 230330),
(237570, '2h56A02', NULL, NULL, 114, NULL, NULL, 230330),
(237571, '2qfzA02', NULL, NULL, 137, NULL, NULL, 230331),
(237572, '3qwlA03', NULL, NULL, 137, NULL, NULL, 230331),
(237573, '3hzjA03', NULL, NULL, 148, NULL, NULL, 230331),
(237574, '4hl4A02', NULL, NULL, 135, NULL, NULL, 230331),
(237575, '4nc6A03', NULL, NULL, 153, NULL, NULL, 230331),
(237576, '3qyeA03', NULL, NULL, 154, NULL, NULL, 230331),
(237577, '2qq8A03', NULL, NULL, 152, NULL, NULL, 230331),
(237578, '2g77A02', NULL, NULL, 138, NULL, NULL, 230331),
(237579, '3qybA03', NULL, NULL, 134, NULL, NULL, 230331),
(237580, '1fkmA02', NULL, NULL, 141, NULL, NULL, 230331),
(237581, '6d0sA02', NULL, NULL, 137, NULL, NULL, 230331),
(237582, '1fzdA02', NULL, NULL, 86, NULL, NULL, 230332),
(237583, '4m7hA02', NULL, NULL, 73, NULL, NULL, 230332),
(237584, '1m1jC02', NULL, NULL, 94, NULL, NULL, 230332),
(237585, '6qnvA02', NULL, NULL, 70, NULL, NULL, 230332),
(237586, '2wnpF02', NULL, NULL, 73, NULL, NULL, 230332),
(237587, '2fibA02', NULL, NULL, 94, NULL, NULL, 230332),
(237588, '2j1gB02', NULL, NULL, 73, NULL, NULL, 230332),
(237589, '4jzcA02', NULL, NULL, 75, NULL, NULL, 230332),
(237590, '6eubA02', NULL, NULL, 77, NULL, NULL, 230332),
(237591, '4epuA02', NULL, NULL, 75, NULL, NULL, 230332),
(237592, '1lwuC02', NULL, NULL, 94, NULL, NULL, 230332),
(237593, '1re3B02', NULL, NULL, 90, NULL, NULL, 230332),
(237594, '1lwuB02', NULL, NULL, 99, NULL, NULL, 230332),
(237595, '1jc9A02', NULL, NULL, 73, NULL, NULL, 230332),
(237596, '2j5zA02', NULL, NULL, 73, NULL, NULL, 230332),
(237597, '1m1jB02', NULL, NULL, 99, NULL, NULL, 230332),
(237598, '1z3uA02', NULL, NULL, 75, NULL, NULL, 230332),
(237599, '3latA00', NULL, NULL, 213, NULL, NULL, 230333),
(237600, '1yckA00', NULL, NULL, 175, NULL, NULL, 230333),
(237601, '2rkqA00', NULL, NULL, 169, NULL, NULL, 230333),
(237602, '2eaxA00', NULL, NULL, 164, NULL, NULL, 230333),
(237603, '1lbaA00', NULL, NULL, 146, NULL, NULL, 230333),
(237604, '4ivvA00', NULL, NULL, 188, NULL, NULL, 230333),
(237605, '1yb0B00', NULL, NULL, 159, NULL, NULL, 230333),
(237606, '2xz4A00', NULL, NULL, 180, NULL, NULL, 230333),
(237607, '3d2yA01', NULL, NULL, 151, NULL, NULL, 230333),
(237608, '2f2lX00', NULL, NULL, 167, NULL, NULL, 230333),
(237609, '4z8iA02', NULL, NULL, 176, NULL, NULL, 230333),
(237610, '4knkA00', NULL, NULL, 225, NULL, NULL, 230333),
(237611, '5xz3B00', NULL, NULL, 173, NULL, NULL, 230333),
(237612, '2y28B00', NULL, NULL, 187, NULL, NULL, 230333),
(237613, '4bolA01', NULL, NULL, 146, NULL, NULL, 230333),
(237614, '1sk4A00', NULL, NULL, 163, NULL, NULL, 230333),
(237615, '2l47A00', NULL, NULL, 165, NULL, NULL, 230333),
(237616, '3rt4A00', NULL, NULL, 171, NULL, NULL, 230333),
(237617, '2cb3B00', NULL, NULL, 175, NULL, NULL, 230333),
(237618, '3rdrA00', NULL, NULL, 157, NULL, NULL, 230333),
(237619, '4bxjB01', NULL, NULL, 156, NULL, NULL, 230333),
(237620, '4olsA00', NULL, NULL, 185, NULL, NULL, 230333),
(237621, '2f2lA00', NULL, NULL, 167, NULL, NULL, 230333),
(237622, '2xz8A00', NULL, NULL, 150, NULL, NULL, 230333),
(237623, '3ep1A00', NULL, NULL, 176, NULL, NULL, 230333),
(237624, '1sxrA00', NULL, NULL, 183, NULL, NULL, 230333),
(237625, '5xz4A00', NULL, NULL, 173, NULL, NULL, 230333),
(237626, '1ohtA00', NULL, NULL, 185, NULL, NULL, 230333),
(237627, '3u5eW02', NULL, NULL, 32, NULL, NULL, 230334),
(237628, '1uoyA01', NULL, NULL, 57, NULL, NULL, 230335);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(237629, '3gjnA00', NULL, NULL, 86, NULL, NULL, 230336),
(237630, '2vlqA00', NULL, NULL, 86, NULL, NULL, 230336),
(237631, '4uhpD00', NULL, NULL, 98, NULL, NULL, 230336),
(237632, '1gxgA00', NULL, NULL, 85, NULL, NULL, 230336),
(237633, '6er6A00', NULL, NULL, 93, NULL, NULL, 230336),
(237634, '4qkoG00', NULL, NULL, 95, NULL, NULL, 230336),
(237635, '1ceiA00', NULL, NULL, 94, NULL, NULL, 230336),
(237636, '2k0dX00', NULL, NULL, 101, NULL, NULL, 230336),
(237637, '4f37A00', NULL, NULL, 102, NULL, NULL, 230336),
(237638, '2wptA00', NULL, NULL, 86, NULL, NULL, 230336),
(237639, '1znvA00', NULL, NULL, 93, NULL, NULL, 230336),
(237640, '3gklC00', NULL, NULL, 86, NULL, NULL, 230336),
(237641, '6ereC00', NULL, NULL, 95, NULL, NULL, 230336),
(237642, '2pf4F02', NULL, NULL, 103, NULL, NULL, 230337),
(237643, '4bl6D00', NULL, NULL, 94, NULL, NULL, 230338),
(237644, '3rmhA00', NULL, NULL, 149, NULL, NULL, 230339),
(237645, '3kasA03', NULL, NULL, 142, NULL, NULL, 230340),
(237646, '3bi1A03', NULL, NULL, 156, NULL, NULL, 230340),
(237647, '3fedA03', NULL, NULL, 156, NULL, NULL, 230340),
(237648, '3eslA02', NULL, NULL, 124, NULL, NULL, 230341),
(237649, '5m1eA02', NULL, NULL, 118, NULL, NULL, 230342),
(237650, '4ip2A02', NULL, NULL, 129, NULL, NULL, 230342),
(237651, '3goxA03', NULL, NULL, 82, NULL, NULL, 230343),
(237652, '1e7lA01', NULL, NULL, 80, NULL, NULL, 230343),
(237653, '1eu1A03', NULL, NULL, 87, NULL, NULL, 230344),
(237654, '1dmrA03', NULL, NULL, 87, NULL, NULL, 230344),
(237655, '1tmoA03', NULL, NULL, 86, NULL, NULL, 230344),
(237656, '3ermB00', NULL, NULL, 70, NULL, NULL, 230345),
(237657, '3n1eA01', NULL, NULL, 46, NULL, NULL, 230346),
(237658, '2ko2A00', NULL, NULL, 79, NULL, NULL, 230347),
(237659, '2jv5A00', NULL, NULL, 54, NULL, NULL, 230347),
(237660, '2g31A01', NULL, NULL, 54, NULL, NULL, 230347),
(237661, '4gl3A00', NULL, NULL, 424, NULL, NULL, 230348),
(237662, '5gzkA00', NULL, NULL, 419, NULL, NULL, 230348),
(237663, '4qt9A00', NULL, NULL, 421, NULL, NULL, 230348),
(237664, '3eu8A00', NULL, NULL, 430, NULL, NULL, 230348),
(237665, '2im8A00', NULL, NULL, 131, NULL, NULL, 230349),
(237666, '2hujA00', NULL, NULL, 140, NULL, NULL, 230349),
(237667, '2etsA00', NULL, NULL, 128, NULL, NULL, 230349),
(237668, '5ic0A03', NULL, NULL, 165, NULL, NULL, 230350),
(237669, '2l10A00', NULL, NULL, 158, NULL, NULL, 230350),
(237670, '4w8pA01', NULL, NULL, 171, NULL, NULL, 230350),
(237671, '1sj7C00', NULL, NULL, 174, NULL, NULL, 230350),
(237672, '2l7nA00', NULL, NULL, 168, NULL, NULL, 230350),
(237673, '3dyjA01', NULL, NULL, 179, NULL, NULL, 230350),
(237674, '3dyjA02', NULL, NULL, 153, NULL, NULL, 230350),
(237675, '2kvpA00', NULL, NULL, 165, NULL, NULL, 230350),
(237676, '3ay5A01', NULL, NULL, 163, NULL, NULL, 230350),
(237677, '3fyqA00', NULL, NULL, 199, NULL, NULL, 230350),
(237678, '1hwyA01', NULL, NULL, 51, NULL, NULL, 230351),
(237679, '6dhqA01', NULL, NULL, 56, NULL, NULL, 230351),
(237680, '1l1fA03', NULL, NULL, 60, NULL, NULL, 230351),
(237681, '5tuxA01', NULL, NULL, 147, NULL, NULL, 230352),
(237682, '5hgrB01', NULL, NULL, 149, NULL, NULL, 230352),
(237683, '6mcjA00', NULL, NULL, 163, NULL, NULL, 230352),
(237684, '5ui2A01', NULL, NULL, 151, NULL, NULL, 230352),
(237685, '5fcyA00', NULL, NULL, 169, NULL, NULL, 230352),
(237686, '4xb4B00', NULL, NULL, 152, NULL, NULL, 230352),
(237687, '2mm0A00', NULL, NULL, 64, NULL, NULL, 230353),
(237688, '2mm2A00', NULL, NULL, 65, NULL, NULL, 230353),
(237689, '1p68A00', NULL, NULL, 102, NULL, NULL, 230354),
(237690, '2juaA00', NULL, NULL, 102, NULL, NULL, 230354),
(237691, '3vjfA00', NULL, NULL, 102, NULL, NULL, 230354),
(237692, '3vjfB00', NULL, NULL, 102, NULL, NULL, 230354),
(237693, '3bqoA00', NULL, NULL, 211, NULL, NULL, 230355),
(237694, '4m7cB00', NULL, NULL, 200, NULL, NULL, 230355),
(237695, '1vs9F02', NULL, NULL, 70, NULL, NULL, 230356),
(237696, '4a17E02', NULL, NULL, 103, NULL, NULL, 230356),
(237697, '1vx7H02', NULL, NULL, 104, NULL, NULL, 230356),
(237698, '4a17E01', NULL, NULL, 85, NULL, NULL, 230356),
(237699, '1vx7H01', NULL, NULL, 86, NULL, NULL, 230356);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(237700, '5mmiG01', NULL, NULL, 84, NULL, NULL, 230356),
(237701, '6qklB02', NULL, NULL, 103, NULL, NULL, 230356),
(237702, '1rl6A01', NULL, NULL, 81, NULL, NULL, 230356),
(237703, '1vw4F02', NULL, NULL, 97, NULL, NULL, 230356),
(237704, '5an9B01', NULL, NULL, 85, NULL, NULL, 230356),
(237705, '4wfaE02', NULL, NULL, 96, NULL, NULL, 230356),
(237706, '4wfaE01', NULL, NULL, 66, NULL, NULL, 230356),
(237707, '1vw4F01', NULL, NULL, 100, NULL, NULL, 230356),
(237708, '1rl6A02', NULL, NULL, 96, NULL, NULL, 230356),
(237709, '5gaeG02', NULL, NULL, 95, NULL, NULL, 230356),
(237710, '5gaeG01', NULL, NULL, 82, NULL, NULL, 230356),
(237711, '3knmH02', NULL, NULL, 98, NULL, NULL, 230356),
(237712, '5dm6E01', NULL, NULL, 78, NULL, NULL, 230356),
(237713, '5dm6E02', NULL, NULL, 93, NULL, NULL, 230356),
(237714, '2cqlA01', NULL, NULL, 88, NULL, NULL, 230356),
(237715, '5z3gL01', NULL, NULL, 85, NULL, NULL, 230356),
(237716, '5v7qG01', NULL, NULL, 83, NULL, NULL, 230356),
(237717, '5z3gL02', NULL, NULL, 106, NULL, NULL, 230356),
(237718, '5v7qG02', NULL, NULL, 96, NULL, NULL, 230356),
(237719, '5x8tG02', NULL, NULL, 98, NULL, NULL, 230356),
(237720, '1vwxH01', NULL, NULL, 87, NULL, NULL, 230356),
(237721, '1vwxH02', NULL, NULL, 105, NULL, NULL, 230356),
(237722, '1vq8E01', NULL, NULL, 80, NULL, NULL, 230356),
(237723, '1vq8E02', NULL, NULL, 98, NULL, NULL, 230356),
(237724, '4btdH01', NULL, NULL, 82, NULL, NULL, 230356),
(237725, '3og2A02', NULL, NULL, 184, NULL, NULL, 230357),
(237726, '1tg7A02', NULL, NULL, 181, NULL, NULL, 230357),
(237727, '4iugA02', NULL, NULL, 179, NULL, NULL, 230357),
(237728, '5ifpA02', NULL, NULL, 179, NULL, NULL, 230357),
(237729, '3wryA01', NULL, NULL, 201, NULL, NULL, 230358),
(237730, '1e5rB02', NULL, NULL, 84, NULL, NULL, 230359),
(237731, '3pe5A00', NULL, NULL, 277, NULL, NULL, 230360),
(237732, '3okzB00', NULL, NULL, 306, NULL, NULL, 230360),
(237733, '3nroA00', NULL, NULL, 262, NULL, NULL, 230360),
(237734, '3owqB00', NULL, NULL, 252, NULL, NULL, 230360),
(237735, '6mptA02', NULL, NULL, 95, NULL, NULL, 230360),
(237736, '3nxhA00', NULL, NULL, 269, NULL, NULL, 230360),
(237737, '2xxpA02', NULL, NULL, 279, NULL, NULL, 230360),
(237738, '4obmA00', NULL, NULL, 259, NULL, NULL, 230360),
(237739, '3qfiA00', NULL, NULL, 301, NULL, NULL, 230360),
(237740, '6atgC00', NULL, NULL, 214, NULL, NULL, 230361),
(237741, '2fsfB02', NULL, NULL, 31, NULL, NULL, 230362),
(237742, '2fsgB02', NULL, NULL, 38, NULL, NULL, 230362),
(237743, '2laiA00', NULL, NULL, 101, NULL, NULL, 230363),
(237744, '3pifC02', NULL, NULL, 103, NULL, NULL, 230364),
(237745, '3pieA02', NULL, NULL, 103, NULL, NULL, 230364),
(237746, '3pieC04', NULL, NULL, 130, NULL, NULL, 230364),
(237747, '3pieD02', NULL, NULL, 103, NULL, NULL, 230364),
(237748, '3pifD02', NULL, NULL, 103, NULL, NULL, 230364),
(237749, '3pifB04', NULL, NULL, 130, NULL, NULL, 230364),
(237750, '3vsmA03', NULL, NULL, 94, NULL, NULL, 230365),
(237751, '2g8lA02', NULL, NULL, 65, NULL, NULL, 230366),
(237752, '2ffjA02', NULL, NULL, 71, NULL, NULL, 230366),
(237753, '4rv9A01', NULL, NULL, 64, NULL, NULL, 230367),
(237754, '5t67A01', NULL, NULL, 64, NULL, NULL, 230367),
(237755, '4e2xA01', NULL, NULL, 64, NULL, NULL, 230367),
(237756, '4g1iB01', NULL, NULL, 58, NULL, NULL, 230368),
(237757, '3gr0D01', NULL, NULL, 41, NULL, NULL, 230368),
(237758, '4m4pA02', NULL, NULL, 59, NULL, NULL, 230369),
(237759, '3fl7A02', NULL, NULL, 61, NULL, NULL, 230369),
(237760, '3mbwA02', NULL, NULL, 59, NULL, NULL, 230369),
(237761, '2mizA00', NULL, NULL, 156, NULL, NULL, 230370),
(237762, '4pn6A00', NULL, NULL, 167, NULL, NULL, 230370),
(237763, '5dzzA02', NULL, NULL, 241, NULL, NULL, 230371),
(237764, '1lm5B00', NULL, NULL, 214, NULL, NULL, 230371),
(237765, '4qmdA00', NULL, NULL, 193, NULL, NULL, 230371),
(237766, '2n03A00', NULL, NULL, 215, NULL, NULL, 230371),
(237767, '5dzzA01', NULL, NULL, 253, NULL, NULL, 230371),
(237768, '3mstA00', NULL, NULL, 244, NULL, NULL, 230372),
(237769, '2a5hA03', NULL, NULL, 62, NULL, NULL, 230373),
(237770, '4dleA02', NULL, NULL, 117, NULL, NULL, 230374);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(237771, '6fbcA02', NULL, NULL, 117, NULL, NULL, 230374),
(237772, '1kfdA02', NULL, NULL, 71, NULL, NULL, 230374),
(237773, '1t7pA02', NULL, NULL, 182, NULL, NULL, 230374),
(237774, '2kfnA02', NULL, NULL, 116, NULL, NULL, 230374),
(237775, '4yfuA02', NULL, NULL, 115, NULL, NULL, 230374),
(237776, '2lf3A00', NULL, NULL, 107, NULL, NULL, 230375),
(237777, '3tl8F00', NULL, NULL, 93, NULL, NULL, 230375),
(237778, '2lf6A00', NULL, NULL, 101, NULL, NULL, 230375),
(237779, '2lrmA00', NULL, NULL, 90, NULL, NULL, 230376),
(237780, '3qrlA00', NULL, NULL, 140, NULL, NULL, 230377),
(237781, '3rlsB00', NULL, NULL, 175, NULL, NULL, 230377),
(237782, '2l7eA00', NULL, NULL, 131, NULL, NULL, 230377),
(237783, '5xtzA00', NULL, NULL, 141, NULL, NULL, 230377),
(237784, '5iqlA00', NULL, NULL, 133, NULL, NULL, 230377),
(237785, '6hq0A00', NULL, NULL, 155, NULL, NULL, 230377),
(237786, '5yyfC00', NULL, NULL, 141, NULL, NULL, 230377),
(237787, '4hsaC01', NULL, NULL, 167, NULL, NULL, 230378),
(237788, '1mnnA00', NULL, NULL, 308, NULL, NULL, 230379),
(237789, '2wvxA02', NULL, NULL, 163, NULL, NULL, 230380),
(237790, '2ww2A02', NULL, NULL, 166, NULL, NULL, 230380),
(237791, '3ue9A03', NULL, NULL, 173, NULL, NULL, 230381),
(237792, '5i34A03', NULL, NULL, 160, NULL, NULL, 230381),
(237793, '2v40A03', NULL, NULL, 160, NULL, NULL, 230381),
(237794, '4m9dB03', NULL, NULL, 165, NULL, NULL, 230381),
(237795, '1iweA03', NULL, NULL, 160, NULL, NULL, 230381),
(237796, '1adeA03', NULL, NULL, 166, NULL, NULL, 230381),
(237797, '1dj2A03', NULL, NULL, 160, NULL, NULL, 230381),
(237798, '3r7tA03', NULL, NULL, 155, NULL, NULL, 230381),
(237799, '1dj3A03', NULL, NULL, 160, NULL, NULL, 230381),
(237800, '1p9bA03', NULL, NULL, 169, NULL, NULL, 230381),
(237801, '3hidA03', NULL, NULL, 166, NULL, NULL, 230381),
(237802, '5b66Z00', NULL, NULL, 62, NULL, NULL, 230382),
(237803, '5xnlZ00', NULL, NULL, 62, NULL, NULL, 230382),
(237804, '3hrpA02', NULL, NULL, 304, NULL, NULL, 230383),
(237805, '2ojhA00', NULL, NULL, 280, NULL, NULL, 230383),
(237806, '4o5sB00', NULL, NULL, 337, NULL, NULL, 230383),
(237807, '6f0qA00', NULL, NULL, 256, NULL, NULL, 230383),
(237808, '1pjxA00', NULL, NULL, 314, NULL, NULL, 230383),
(237809, '1ijqA01', NULL, NULL, 262, NULL, NULL, 230383),
(237810, '4gn8A00', NULL, NULL, 299, NULL, NULL, 230383),
(237811, '2fp8B00', NULL, NULL, 322, NULL, NULL, 230383),
(237812, '2p4oA01', NULL, NULL, 292, NULL, NULL, 230383),
(237813, '3v64C02', NULL, NULL, 307, NULL, NULL, 230383),
(237814, '3dasA00', NULL, NULL, 347, NULL, NULL, 230383),
(237815, '3tc9A02', NULL, NULL, 323, NULL, NULL, 230383),
(237816, '3a9gA00', NULL, NULL, 354, NULL, NULL, 230383),
(237817, '4a0pA02', NULL, NULL, 335, NULL, NULL, 230383),
(237818, '3q6kA00', NULL, NULL, 381, NULL, NULL, 230383),
(237819, '5gtqA00', NULL, NULL, 311, NULL, NULL, 230383),
(237820, '4a0pA01', NULL, NULL, 293, NULL, NULL, 230383),
(237821, '2g8sB00', NULL, NULL, 353, NULL, NULL, 230383),
(237822, '3sreA00', NULL, NULL, 339, NULL, NULL, 230383),
(237823, '1h6lA00', NULL, NULL, 353, NULL, NULL, 230383),
(237824, '2ghsA00', NULL, NULL, 295, NULL, NULL, 230383),
(237825, '1q7fB00', NULL, NULL, 286, NULL, NULL, 230383),
(237826, '3fvzA00', NULL, NULL, 329, NULL, NULL, 230383),
(237827, '3kyaA02', NULL, NULL, 367, NULL, NULL, 230383),
(237828, '4pwzA02', NULL, NULL, 266, NULL, NULL, 230383),
(237829, '3e5zA00', NULL, NULL, 296, NULL, NULL, 230383),
(237830, '3dr2A00', NULL, NULL, 305, NULL, NULL, 230383),
(237831, '1npeA00', NULL, NULL, 267, NULL, NULL, 230383),
(237832, '3g4eA00', NULL, NULL, 297, NULL, NULL, 230383),
(237833, '1cruA00', NULL, NULL, 454, NULL, NULL, 230383),
(237834, '4hw6A02', NULL, NULL, 327, NULL, NULL, 230383),
(237835, '3i1cA00', NULL, NULL, 324, NULL, NULL, 230383),
(237836, '3amrA00', NULL, NULL, 355, NULL, NULL, 230383),
(237837, '3sovA01', NULL, NULL, 262, NULL, NULL, 230383),
(237838, '2hqsA02', NULL, NULL, 272, NULL, NULL, 230383),
(237839, '2dg1C00', NULL, NULL, 333, NULL, NULL, 230383),
(237840, '1rwiA00', NULL, NULL, 270, NULL, NULL, 230383),
(237841, '2qe8A00', NULL, NULL, 343, NULL, NULL, 230383);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(237842, '2ismA00', NULL, NULL, 333, NULL, NULL, 230383),
(237843, '3s94B02', NULL, NULL, 318, NULL, NULL, 230383),
(237844, '1i78B00', NULL, NULL, 297, NULL, NULL, 230384),
(237845, '2x55A00', NULL, NULL, 293, NULL, NULL, 230384),
(237846, '2g9wB02', NULL, NULL, 66, NULL, NULL, 230385),
(237847, '2l1pA00', NULL, NULL, 83, NULL, NULL, 230386),
(237848, '4q2jD02', NULL, NULL, 74, NULL, NULL, 230386),
(237849, '3nzlA00', NULL, NULL, 83, NULL, NULL, 230386),
(237850, '1llnA01', NULL, NULL, 175, NULL, NULL, 230387),
(237851, '3h5kA01', NULL, NULL, 177, NULL, NULL, 230387),
(237852, '1bryY01', NULL, NULL, 163, NULL, NULL, 230387),
(237853, '4fbcA01', NULL, NULL, 178, NULL, NULL, 230387),
(237854, '1tfmA01', NULL, NULL, 160, NULL, NULL, 230387),
(237855, '1r4qA01', NULL, NULL, 169, NULL, NULL, 230387),
(237856, '1apaA01', NULL, NULL, 182, NULL, NULL, 230387),
(237857, '1ggpA01', NULL, NULL, 149, NULL, NULL, 230387),
(237858, '2pqgB01', NULL, NULL, 188, NULL, NULL, 230387),
(237859, '2oqaA01', NULL, NULL, 161, NULL, NULL, 230387),
(237860, '2q8wA01', NULL, NULL, 177, NULL, NULL, 230387),
(237861, '1ce7A01', NULL, NULL, 162, NULL, NULL, 230387),
(237862, '2vlcA01', NULL, NULL, 171, NULL, NULL, 230387),
(237863, '2rg9A01', NULL, NULL, 167, NULL, NULL, 230387),
(237864, '4hr6B01', NULL, NULL, 120, NULL, NULL, 230387),
(237865, '5z37A01', NULL, NULL, 163, NULL, NULL, 230387),
(237866, '2b7uA01', NULL, NULL, 169, NULL, NULL, 230387),
(237867, '3mvgA01', NULL, NULL, 163, NULL, NULL, 230387),
(237868, '3sj6A01', NULL, NULL, 162, NULL, NULL, 230387),
(237869, '4yp2B01', NULL, NULL, 162, NULL, NULL, 230387),
(237870, '1nioA01', NULL, NULL, 162, NULL, NULL, 230387),
(237871, '2zr1A01', NULL, NULL, 167, NULL, NULL, 230387),
(237872, '1rl0A01', NULL, NULL, 181, NULL, NULL, 230387),
(237873, '2z4uA01', NULL, NULL, 177, NULL, NULL, 230387),
(237874, '1m2tA01', NULL, NULL, 167, NULL, NULL, 230387),
(237875, '4p2cA01', NULL, NULL, 170, NULL, NULL, 230387),
(237876, '3mk9A00', NULL, NULL, 189, NULL, NULL, 230387),
(237877, '1mrjA01', NULL, NULL, 162, NULL, NULL, 230387),
(237878, '1rzoA01', NULL, NULL, 178, NULL, NULL, 230387),
(237879, '4za3A01', NULL, NULL, 163, NULL, NULL, 230387),
(237880, '4m1uA01', NULL, NULL, 170, NULL, NULL, 230387),
(237881, '3ktzA01', NULL, NULL, 168, NULL, NULL, 230387),
(237882, '3px8X01', NULL, NULL, 176, NULL, NULL, 230387),
(237883, '3hisA01', NULL, NULL, 176, NULL, NULL, 230387),
(237884, '1qi7A01', NULL, NULL, 178, NULL, NULL, 230387),
(237885, '1qciA01', NULL, NULL, 178, NULL, NULL, 230387),
(237886, '1cf5A01', NULL, NULL, 160, NULL, NULL, 230387),
(237887, '2g5xA01', NULL, NULL, 172, NULL, NULL, 230387),
(237888, '3bwhA01', NULL, NULL, 160, NULL, NULL, 230387),
(237889, '3ctkA01', NULL, NULL, 167, NULL, NULL, 230387),
(237890, '4eb2A01', NULL, NULL, 167, NULL, NULL, 230387),
(237891, '1hwmA01', NULL, NULL, 164, NULL, NULL, 230387),
(237892, '1onkA01', NULL, NULL, 167, NULL, NULL, 230387),
(237893, '4jkxA01', NULL, NULL, 167, NULL, NULL, 230387),
(237894, '2q35A02', NULL, NULL, 47, NULL, NULL, 230388),
(237895, '4q1kB02', NULL, NULL, 49, NULL, NULL, 230388),
(237896, '3iiiA02', NULL, NULL, 52, NULL, NULL, 230389),
(237897, '3nfgP00', NULL, NULL, 123, NULL, NULL, 230390),
(237898, '1el6A03', NULL, NULL, 109, NULL, NULL, 230391),
(237899, '1vioA03', NULL, NULL, 82, NULL, NULL, 230392),
(237900, '2gmlA02', NULL, NULL, 74, NULL, NULL, 230392),
(237901, '2omlA02', NULL, NULL, 106, NULL, NULL, 230392),
(237902, '2l1iA00', NULL, NULL, 122, NULL, NULL, 230393),
(237903, '3k2yA00', NULL, NULL, 109, NULL, NULL, 230393),
(237904, '2vqeR00', NULL, NULL, 88, NULL, NULL, 230394),
(237905, '5o5jR00', NULL, NULL, 68, NULL, NULL, 230394),
(237906, '1fkaR00', NULL, NULL, 54, NULL, NULL, 230394),
(237907, '2vhoR00', NULL, NULL, 56, NULL, NULL, 230394),
(237908, '4jyaR00', NULL, NULL, 70, NULL, NULL, 230394),
(237909, '5x8rr00', NULL, NULL, 64, NULL, NULL, 230394),
(237910, '2lc2A01', NULL, NULL, 68, NULL, NULL, 230395),
(237911, '3zr8X00', NULL, NULL, 65, NULL, NULL, 230395),
(237912, '4gpvB01', NULL, NULL, 157, NULL, NULL, 230396);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(237913, '3r4rA01', NULL, NULL, 168, NULL, NULL, 230396),
(237914, '3up6A01', NULL, NULL, 179, NULL, NULL, 230396),
(237915, '4jrfA01', NULL, NULL, 185, NULL, NULL, 230396),
(237916, '4jg5A01', NULL, NULL, 183, NULL, NULL, 230396),
(237917, '5dhmC01', NULL, NULL, 128, NULL, NULL, 230396),
(237918, '4rdbA01', NULL, NULL, 151, NULL, NULL, 230396),
(237919, '2rrlA01', NULL, NULL, 115, NULL, NULL, 230397),
(237920, '1w36B02', NULL, NULL, 195, NULL, NULL, 230398),
(237921, '3rrkA03', NULL, NULL, 74, NULL, NULL, 230399),
(237922, '2pt7C01', NULL, NULL, 106, NULL, NULL, 230400),
(237923, '1p9rA01', NULL, NULL, 138, NULL, NULL, 230400),
(237924, '5tshE01', NULL, NULL, 106, NULL, NULL, 230400),
(237925, '2ewvA01', NULL, NULL, 113, NULL, NULL, 230400),
(237926, '5zfrC01', NULL, NULL, 110, NULL, NULL, 230400),
(237927, '5fl3A01', NULL, NULL, 109, NULL, NULL, 230400),
(237928, '4phtA02', NULL, NULL, 130, NULL, NULL, 230400),
(237929, '2gzaA01', NULL, NULL, 108, NULL, NULL, 230400),
(237930, '5oiuA01', NULL, NULL, 111, NULL, NULL, 230400),
(237931, '3jvvA01', NULL, NULL, 100, NULL, NULL, 230400),
(237932, '3ptyA02', NULL, NULL, 208, NULL, NULL, 230401),
(237933, '3wryA02', NULL, NULL, 221, NULL, NULL, 230402),
(237934, '1c1kA02', NULL, NULL, 115, NULL, NULL, 230403),
(237935, '3tcmA02', NULL, NULL, 51, NULL, NULL, 230404),
(237936, '3ihjA02', NULL, NULL, 38, NULL, NULL, 230404),
(237937, '2y6xA00', NULL, NULL, 113, NULL, NULL, 230405),
(237938, '5x56B00', NULL, NULL, 106, NULL, NULL, 230405),
(237939, '2kmfA01', NULL, NULL, 102, NULL, NULL, 230405),
(237940, '3kdqA00', NULL, NULL, 154, NULL, NULL, 230406),
(237941, '2griA01', NULL, NULL, 90, NULL, NULL, 230407),
(237942, '2m0aA01', NULL, NULL, 93, NULL, NULL, 230407),
(237943, '2derA02', NULL, NULL, 69, NULL, NULL, 230408),
(237944, '2hmaA02', NULL, NULL, 69, NULL, NULL, 230408),
(237945, '3wvoC02', NULL, NULL, 145, NULL, NULL, 230409),
(237946, '4an8A02', NULL, NULL, 139, NULL, NULL, 230409),
(237947, '4h3tA02', NULL, NULL, 150, NULL, NULL, 230409),
(237948, '3gw6F01', NULL, NULL, 93, NULL, NULL, 230410),
(237949, '3gw6B01', NULL, NULL, 107, NULL, NULL, 230410),
(237950, '3ju4A04', NULL, NULL, 154, NULL, NULL, 230410),
(237951, '3gw6A01', NULL, NULL, 134, NULL, NULL, 230410),
(237952, '4hizA04', NULL, NULL, 157, NULL, NULL, 230410),
(237953, '3ke4B01', NULL, NULL, 182, NULL, NULL, 230411),
(237954, '5cy5B00', NULL, NULL, 163, NULL, NULL, 230411),
(237955, '3ci3A01', NULL, NULL, 177, NULL, NULL, 230411),
(237956, '1wy1B00', NULL, NULL, 149, NULL, NULL, 230411),
(237957, '1wozA00', NULL, NULL, 159, NULL, NULL, 230411),
(237958, '6d5xA00', NULL, NULL, 172, NULL, NULL, 230411),
(237959, '4nwpD00', NULL, NULL, 150, NULL, NULL, 230411),
(237960, '1wvtA00', NULL, NULL, 151, NULL, NULL, 230411),
(237961, '5cy5A00', NULL, NULL, 149, NULL, NULL, 230411),
(237962, '1rtyA00', NULL, NULL, 172, NULL, NULL, 230411),
(237963, '2zhyC01', NULL, NULL, 167, NULL, NULL, 230411),
(237964, '2g2dA00', NULL, NULL, 165, NULL, NULL, 230411),
(237965, '2ah6B00', NULL, NULL, 162, NULL, NULL, 230411),
(237966, '1nigA00', NULL, NULL, 152, NULL, NULL, 230411),
(237967, '1nogA00', NULL, NULL, 155, NULL, NULL, 230411),
(237968, '1k5oA00', NULL, NULL, 86, NULL, NULL, 230412),
(237969, '1xjhA00', NULL, NULL, 62, NULL, NULL, 230413),
(237970, '1vq0A02', NULL, NULL, 60, NULL, NULL, 230413),
(237971, '1vzyA02', NULL, NULL, 57, NULL, NULL, 230413),
(237972, '4lr4A02', NULL, NULL, 183, NULL, NULL, 230414),
(237973, '3rwxA02', NULL, NULL, 134, NULL, NULL, 230415),
(237974, '4phtY02', NULL, NULL, 70, NULL, NULL, 230416),
(237975, '2bh1A02', NULL, NULL, 75, NULL, NULL, 230416),
(237976, '5tkwA02', NULL, NULL, 66, NULL, NULL, 230416),
(237977, '3q23A03', NULL, NULL, 72, NULL, NULL, 230417),
(237978, '3hzqA00', NULL, NULL, 94, NULL, NULL, 230418),
(237979, '2oarB00', NULL, NULL, 125, NULL, NULL, 230418),
(237980, '2oarC01', NULL, NULL, 96, NULL, NULL, 230418),
(237981, '3lmlB01', NULL, NULL, 123, NULL, NULL, 230419),
(237982, '3nrkA01', NULL, NULL, 214, NULL, NULL, 230420),
(237983, '1m5yA01', NULL, NULL, 128, NULL, NULL, 230420);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(237984, '3rgcA01', NULL, NULL, 174, NULL, NULL, 230420),
(237985, '2pv3A01', NULL, NULL, 188, NULL, NULL, 230420),
(237986, '5nn4A04', NULL, NULL, 116, NULL, NULL, 230421),
(237987, '5nn4A05', NULL, NULL, 132, NULL, NULL, 230421),
(237988, '5a6mA01', NULL, NULL, 106, NULL, NULL, 230421),
(237989, '1cgtA02', NULL, NULL, 94, NULL, NULL, 230421),
(237990, '1e43A03', NULL, NULL, 87, NULL, NULL, 230421),
(237991, '2e8yA04', NULL, NULL, 96, NULL, NULL, 230421),
(237992, '2y2wD01', NULL, NULL, 152, NULL, NULL, 230421),
(237993, '2y24A01', NULL, NULL, 107, NULL, NULL, 230421),
(237994, '4do4A02', NULL, NULL, 104, NULL, NULL, 230421),
(237995, '1sznA02', NULL, NULL, 102, NULL, NULL, 230421),
(237996, '3klkA04', NULL, NULL, 143, NULL, NULL, 230421),
(237997, '4aw7A01', NULL, NULL, 119, NULL, NULL, 230421),
(237998, '3fawA04', NULL, NULL, 95, NULL, NULL, 230421),
(237999, '4j27A02', NULL, NULL, 89, NULL, NULL, 230421),
(238000, '2f2hA03', NULL, NULL, 48, NULL, NULL, 230421),
(238001, '3hjeA05', NULL, NULL, 62, NULL, NULL, 230421),
(238002, '2f2hA04', NULL, NULL, 109, NULL, NULL, 230421),
(238003, '2yocA05', NULL, NULL, 93, NULL, NULL, 230421),
(238004, '3vsvA02', NULL, NULL, 128, NULL, NULL, 230421),
(238005, '4mb1A03', NULL, NULL, 78, NULL, NULL, 230421),
(238006, '1h3gB03', NULL, NULL, 80, NULL, NULL, 230421),
(238007, '5e1qA03', NULL, NULL, 96, NULL, NULL, 230421),
(238008, '3wn6A02', NULL, NULL, 58, NULL, NULL, 230421),
(238009, '3wdhA04', NULL, NULL, 87, NULL, NULL, 230421),
(238010, '1ud2A03', NULL, NULL, 87, NULL, NULL, 230421),
(238011, '4e2oA02', NULL, NULL, 88, NULL, NULL, 230421),
(238012, '3qgvA02', NULL, NULL, 98, NULL, NULL, 230421),
(238013, '3weoA04', NULL, NULL, 157, NULL, NULL, 230421),
(238014, '3bc9A04', NULL, NULL, 92, NULL, NULL, 230421),
(238015, '3weoA03', NULL, NULL, 101, NULL, NULL, 230421),
(238016, '4ogzA03', NULL, NULL, 83, NULL, NULL, 230421),
(238017, '1gcyA02', NULL, NULL, 56, NULL, NULL, 230421),
(238018, '4qawA01', NULL, NULL, 107, NULL, NULL, 230421),
(238019, '1qw9A01', NULL, NULL, 138, NULL, NULL, 230421),
(238020, '3amkA03', NULL, NULL, 117, NULL, NULL, 230421),
(238021, '5x7gA04', NULL, NULL, 124, NULL, NULL, 230421),
(238022, '5a2bA02', NULL, NULL, 98, NULL, NULL, 230421),
(238023, '3ucqA04', NULL, NULL, 83, NULL, NULL, 230421),
(238024, '3vx0A02', NULL, NULL, 104, NULL, NULL, 230421),
(238025, '3bh4A03', NULL, NULL, 87, NULL, NULL, 230421),
(238026, '4psrA02', NULL, NULL, 122, NULL, NULL, 230421),
(238027, '4howA03', NULL, NULL, 79, NULL, NULL, 230421),
(238028, '6f4cB02', NULL, NULL, 89, NULL, NULL, 230421),
(238029, '3k1dA03', NULL, NULL, 104, NULL, NULL, 230421),
(238030, '2g3mA04', NULL, NULL, 89, NULL, NULL, 230421),
(238031, '2g3mA03', NULL, NULL, 75, NULL, NULL, 230421),
(238032, '1hx0A02', NULL, NULL, 93, NULL, NULL, 230421),
(238033, '5lfcA05', NULL, NULL, 134, NULL, NULL, 230421),
(238034, '5jouA04', NULL, NULL, 79, NULL, NULL, 230421),
(238035, '5jouA05', NULL, NULL, 116, NULL, NULL, 230421),
(238036, '2wnwA01', NULL, NULL, 108, NULL, NULL, 230421),
(238037, '1h3gA03', NULL, NULL, 80, NULL, NULL, 230421),
(238038, '1kwgA03', NULL, NULL, 51, NULL, NULL, 230421),
(238039, '2wc7A02', NULL, NULL, 91, NULL, NULL, 230421),
(238040, '5e6zA03', NULL, NULL, 106, NULL, NULL, 230421),
(238041, '5do8B03', NULL, NULL, 77, NULL, NULL, 230421),
(238042, '5x7uA03', NULL, NULL, 89, NULL, NULL, 230421),
(238043, '1ht6A02', NULL, NULL, 58, NULL, NULL, 230421),
(238044, '3lrkA02', NULL, NULL, 156, NULL, NULL, 230421),
(238045, '5axgA03', NULL, NULL, 133, NULL, NULL, 230421),
(238046, '5cxpA01', NULL, NULL, 111, NULL, NULL, 230421),
(238047, '4aieA03', NULL, NULL, 81, NULL, NULL, 230421),
(238048, '3czgA04', NULL, NULL, 83, NULL, NULL, 230421),
(238049, '3topA04', NULL, NULL, 99, NULL, NULL, 230421),
(238050, '4ba0A04', NULL, NULL, 149, NULL, NULL, 230421),
(238051, '3topA05', NULL, NULL, 146, NULL, NULL, 230421),
(238052, '2xvlA05', NULL, NULL, 119, NULL, NULL, 230421),
(238053, '4uozA03', NULL, NULL, 62, NULL, NULL, 230421),
(238054, '2xvlA04', NULL, NULL, 79, NULL, NULL, 230421);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(238055, '2dh2A02', NULL, NULL, 91, NULL, NULL, 230421),
(238056, '4ba0A03', NULL, NULL, 51, NULL, NULL, 230421),
(238057, '4gklA02', NULL, NULL, 88, NULL, NULL, 230421),
(238058, '1d3cA02', NULL, NULL, 95, NULL, NULL, 230421),
(238059, '2zutA04', NULL, NULL, 64, NULL, NULL, 230421),
(238060, '3zr5A01', NULL, NULL, 139, NULL, NULL, 230421),
(238061, '1smaA04', NULL, NULL, 83, NULL, NULL, 230421),
(238062, '2fhfA05', NULL, NULL, 109, NULL, NULL, 230421),
(238063, '3fw6A01', NULL, NULL, 132, NULL, NULL, 230421),
(238064, '1uokA03', NULL, NULL, 78, NULL, NULL, 230421),
(238065, '3vm7A02', NULL, NULL, 99, NULL, NULL, 230421),
(238066, '2wanA05', NULL, NULL, 88, NULL, NULL, 230421),
(238067, '3dc0A02', NULL, NULL, 78, NULL, NULL, 230421),
(238068, '2e4tA01', NULL, NULL, 131, NULL, NULL, 230421),
(238069, '2d73A03', NULL, NULL, 113, NULL, NULL, 230421),
(238070, '6gxvA03', NULL, NULL, 87, NULL, NULL, 230421),
(238071, '4aeeA05', NULL, NULL, 79, NULL, NULL, 230421),
(238072, '1wzaA03', NULL, NULL, 79, NULL, NULL, 230421),
(238073, '3cc1A02', NULL, NULL, 88, NULL, NULL, 230421),
(238074, '4u33A04', NULL, NULL, 104, NULL, NULL, 230421),
(238075, '2aaaA02', NULL, NULL, 110, NULL, NULL, 230421),
(238076, '5i0fB04', NULL, NULL, 85, NULL, NULL, 230421),
(238077, '4bzyB03', NULL, NULL, 104, NULL, NULL, 230421),
(238078, '3lppD05', NULL, NULL, 138, NULL, NULL, 230421),
(238079, '2fgzA04', NULL, NULL, 87, NULL, NULL, 230421),
(238080, '2xn2A03', NULL, NULL, 96, NULL, NULL, 230421),
(238081, '3m07A04', NULL, NULL, 75, NULL, NULL, 230421),
(238082, '2c7fE01', NULL, NULL, 145, NULL, NULL, 230421),
(238083, '1jaeA02', NULL, NULL, 92, NULL, NULL, 230421),
(238084, '1m53A03', NULL, NULL, 77, NULL, NULL, 230421),
(238085, '1gjwA02', NULL, NULL, 69, NULL, NULL, 230421),
(238086, '3mi6B03', NULL, NULL, 112, NULL, NULL, 230421),
(238087, '5a57A03', NULL, NULL, 157, NULL, NULL, 230421),
(238088, '1wzlA04', NULL, NULL, 83, NULL, NULL, 230421),
(238089, '1zjaA03', NULL, NULL, 78, NULL, NULL, 230421),
(238090, '1cygA02', NULL, NULL, 95, NULL, NULL, 230421),
(238091, '4fnqA03', NULL, NULL, 97, NULL, NULL, 230421),
(238092, '2chnB04', NULL, NULL, 125, NULL, NULL, 230421),
(238093, '2ze0A03', NULL, NULL, 79, NULL, NULL, 230421),
(238094, '3ug3D01', NULL, NULL, 142, NULL, NULL, 230421),
(238095, '5f7uA04', NULL, NULL, 76, NULL, NULL, 230421),
(238096, '1mxgA02', NULL, NULL, 98, NULL, NULL, 230421),
(238097, '4xb3A03', NULL, NULL, 72, NULL, NULL, 230421),
(238098, '1o7dC02', NULL, NULL, 89, NULL, NULL, 230421),
(238099, '4amwA03', NULL, NULL, 71, NULL, NULL, 230421),
(238100, '4amwA04', NULL, NULL, 148, NULL, NULL, 230421),
(238101, '2zxqA03', NULL, NULL, 176, NULL, NULL, 230421),
(238102, '3l4yA05', NULL, NULL, 144, NULL, NULL, 230421),
(238103, '3vgfA03', NULL, NULL, 63, NULL, NULL, 230421),
(238104, '3edfA03', NULL, NULL, 80, NULL, NULL, 230421),
(238105, '3l4yA04', NULL, NULL, 98, NULL, NULL, 230421),
(238106, '1r75A00', NULL, NULL, 122, NULL, NULL, 230421),
(238107, '3bvxA03', NULL, NULL, 147, NULL, NULL, 230421),
(238108, '4j3vA04', NULL, NULL, 78, NULL, NULL, 230421),
(238109, '4jcmA02', NULL, NULL, 95, NULL, NULL, 230421),
(238110, '5cgmA04', NULL, NULL, 104, NULL, NULL, 230421),
(238111, '2wpgA04', NULL, NULL, 75, NULL, NULL, 230421),
(238112, '3a5vA02', NULL, NULL, 99, NULL, NULL, 230421),
(238113, '3ttyA03', NULL, NULL, 62, NULL, NULL, 230421),
(238114, '4j7rB03', NULL, NULL, 123, NULL, NULL, 230421),
(238115, '2yihA01', NULL, NULL, 135, NULL, NULL, 230421),
(238116, '4aysA04', NULL, NULL, 80, NULL, NULL, 230421),
(238117, '2yfoA03', NULL, NULL, 96, NULL, NULL, 230421),
(238118, '4nzjA03', NULL, NULL, 87, NULL, NULL, 230421),
(238119, '1iv8A05', NULL, NULL, 66, NULL, NULL, 230421),
(238120, '4aefA04', NULL, NULL, 62, NULL, NULL, 230421),
(238121, '1ua7A02', NULL, NULL, 78, NULL, NULL, 230421),
(238122, '1bf2A03', NULL, NULL, 114, NULL, NULL, 230421),
(238123, '4lxfA03', NULL, NULL, 101, NULL, NULL, 230421),
(238124, '4jclA02', NULL, NULL, 95, NULL, NULL, 230421),
(238125, '4fmvA01', NULL, NULL, 116, NULL, NULL, 230421);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(238126, '2ya0A03', NULL, NULL, 104, NULL, NULL, 230421),
(238127, '5gqwA04', NULL, NULL, 109, NULL, NULL, 230421),
(238128, '5h2tA03', NULL, NULL, 81, NULL, NULL, 230421),
(238129, '5i0dA05', NULL, NULL, 139, NULL, NULL, 230421),
(238130, '3aj7A03', NULL, NULL, 77, NULL, NULL, 230421),
(238131, '4uzsA03', NULL, NULL, 62, NULL, NULL, 230421),
(238132, '6q6nA02', NULL, NULL, 109, NULL, NULL, 230421),
(238133, '3s5zA02', NULL, NULL, 105, NULL, NULL, 230421),
(238134, '1g94A02', NULL, NULL, 93, NULL, NULL, 230421),
(238135, '2vncB03', NULL, NULL, 107, NULL, NULL, 230421),
(238136, '1ea9C04', NULL, NULL, 81, NULL, NULL, 230421),
(238137, '2bhzA04', NULL, NULL, 72, NULL, NULL, 230421),
(238138, '2fe0A01', NULL, NULL, 107, NULL, NULL, 230421),
(238139, '1avaA02', NULL, NULL, 58, NULL, NULL, 230421),
(238140, '3vmnA03', NULL, NULL, 148, NULL, NULL, 230421),
(238141, '2gjpA03', NULL, NULL, 87, NULL, NULL, 230421),
(238142, '6bs6B01', NULL, NULL, 92, NULL, NULL, 230421),
(238143, '5z0uA03', NULL, NULL, 90, NULL, NULL, 230421),
(238144, '3wnoB04', NULL, NULL, 132, NULL, NULL, 230421),
(238145, '4wf7A03', NULL, NULL, 84, NULL, NULL, 230421),
(238146, '3clwC01', NULL, NULL, 116, NULL, NULL, 230421),
(238147, '4nzfD02', NULL, NULL, 90, NULL, NULL, 230421),
(238148, '1ktbA02', NULL, NULL, 91, NULL, NULL, 230421),
(238149, '3vm5A02', NULL, NULL, 101, NULL, NULL, 230421),
(238150, '3lppA04', NULL, NULL, 99, NULL, NULL, 230421),
(238151, '4uzuA03', NULL, NULL, 88, NULL, NULL, 230421),
(238152, '2vrqA01', NULL, NULL, 135, NULL, NULL, 230421),
(238153, '3kl0D01', NULL, NULL, 118, NULL, NULL, 230421),
(238154, '3dhuA02', NULL, NULL, 75, NULL, NULL, 230421),
(238155, '5u3aA02', NULL, NULL, 93, NULL, NULL, 230421),
(238156, '3ik2A01', NULL, NULL, 127, NULL, NULL, 230421),
(238157, '2eabB03', NULL, NULL, 128, NULL, NULL, 230421),
(238158, '2dieA03', NULL, NULL, 87, NULL, NULL, 230421),
(238159, '5f7cA03', NULL, NULL, 49, NULL, NULL, 230421),
(238160, '3a21A02', NULL, NULL, 91, NULL, NULL, 230421),
(238161, '5l77A01', NULL, NULL, 133, NULL, NULL, 230421),
(238162, '3bmvA02', NULL, NULL, 95, NULL, NULL, 230421),
(238163, '3wy2A03', NULL, NULL, 73, NULL, NULL, 230421),
(238164, '4oifA03', NULL, NULL, 62, NULL, NULL, 230421),
(238165, '3zssA04', NULL, NULL, 102, NULL, NULL, 230421),
(238166, '2wskA03', NULL, NULL, 85, NULL, NULL, 230421),
(238167, '1lwjA03', NULL, NULL, 50, NULL, NULL, 230421),
(238168, '2osxA01', NULL, NULL, 99, NULL, NULL, 230421),
(238169, '1g5aA04', NULL, NULL, 74, NULL, NULL, 230421),
(238170, '3zo9B03', NULL, NULL, 101, NULL, NULL, 230421),
(238171, '1j0hA04', NULL, NULL, 83, NULL, NULL, 230421),
(238172, '5brqA03', NULL, NULL, 83, NULL, NULL, 230421),
(238173, '2igtA02', NULL, NULL, 68, NULL, NULL, 230421),
(238174, '1pamA02', NULL, NULL, 95, NULL, NULL, 230421),
(238175, '5zceA03', NULL, NULL, 79, NULL, NULL, 230421),
(238176, '1uasA02', NULL, NULL, 88, NULL, NULL, 230421),
(238177, '2z1kA02', NULL, NULL, 85, NULL, NULL, 230421),
(238178, '1qhoA02', NULL, NULL, 94, NULL, NULL, 230421),
(238179, '1wpcA03', NULL, NULL, 87, NULL, NULL, 230421),
(238180, '5e9aB03', NULL, NULL, 64, NULL, NULL, 230421),
(238181, '3gbeA03', NULL, NULL, 79, NULL, NULL, 230421),
(238182, '2zxdA02', NULL, NULL, 99, NULL, NULL, 230421),
(238183, '1vw4200', NULL, NULL, 114, NULL, NULL, 230422),
(238184, '5oom800', NULL, NULL, 99, NULL, NULL, 230422),
(238185, '4v1ad00', NULL, NULL, 99, NULL, NULL, 230422),
(238186, '3bh1A02', NULL, NULL, 101, NULL, NULL, 230423),
(238187, '3b21A00', NULL, NULL, 192, NULL, NULL, 230424),
(238188, '3m65A02', NULL, NULL, 88, NULL, NULL, 230425),
(238189, '3ljcA02', NULL, NULL, 126, NULL, NULL, 230425),
(238190, '5fqdB03', NULL, NULL, 70, NULL, NULL, 230425),
(238191, '4ci2B03', NULL, NULL, 70, NULL, NULL, 230425),
(238192, '3iwcB00', NULL, NULL, 62, NULL, NULL, 230426),
(238193, '4j7hA02', NULL, NULL, 168, NULL, NULL, 230427),
(238194, '2ewfA02', NULL, NULL, 81, NULL, NULL, 230428),
(238195, '3pvlA01', NULL, NULL, 232, NULL, NULL, 230429),
(238196, '3au4A01', NULL, NULL, 198, NULL, NULL, 230429);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(238197, '6ecsA00', NULL, NULL, 149, NULL, NULL, 230430),
(238198, '6cvkC00', NULL, NULL, 159, NULL, NULL, 230430),
(238199, '6hu4A00', NULL, NULL, 144, NULL, NULL, 230430),
(238200, '5gmzA00', NULL, NULL, 155, NULL, NULL, 230430),
(238201, '3q9dB01', NULL, NULL, 90, NULL, NULL, 230431),
(238202, '4mlkA01', NULL, NULL, 97, NULL, NULL, 230431),
(238203, '3hc7A02', NULL, NULL, 62, NULL, NULL, 230432),
(238204, '3l32A00', NULL, NULL, 45, NULL, NULL, 230433),
(238205, '2ga1A01', NULL, NULL, 32, NULL, NULL, 230434),
(238206, '2ga1B01', NULL, NULL, 32, NULL, NULL, 230434),
(238207, '3l9aX01', NULL, NULL, 75, NULL, NULL, 230435),
(238208, '2czrA01', NULL, NULL, 106, NULL, NULL, 230436),
(238209, '3oyxA02', NULL, NULL, 68, NULL, NULL, 230437),
(238210, '5taoA02', NULL, NULL, 101, NULL, NULL, 230437),
(238211, '3nbxX04', NULL, NULL, 107, NULL, NULL, 230438),
(238212, '4dx8K01', NULL, NULL, 92, NULL, NULL, 230439),
(238213, '4dx8J01', NULL, NULL, 156, NULL, NULL, 230439),
(238214, '6m9mA01', NULL, NULL, 88, NULL, NULL, 230440),
(238215, '3l9tA01', NULL, NULL, 89, NULL, NULL, 230440),
(238216, '3ce2A02', NULL, NULL, 47, NULL, NULL, 230441),
(238217, '2qr4A02', NULL, NULL, 47, NULL, NULL, 230441),
(238218, '5uklG00', NULL, NULL, 62, NULL, NULL, 230442),
(238219, '5kdoG00', NULL, NULL, 74, NULL, NULL, 230442),
(238220, '2pbiA03', NULL, NULL, 54, NULL, NULL, 230442),
(238221, '1xhmB00', NULL, NULL, 58, NULL, NULL, 230442),
(238222, '6crkG00', NULL, NULL, 71, NULL, NULL, 230442),
(238223, '3pvuG00', NULL, NULL, 74, NULL, NULL, 230442),
(238224, '1gotG00', NULL, NULL, 73, NULL, NULL, 230442),
(238225, '3ah8G00', NULL, NULL, 61, NULL, NULL, 230442),
(238226, '1frsA00', NULL, NULL, 129, NULL, NULL, 230443),
(238227, '2vf9A00', NULL, NULL, 131, NULL, NULL, 230443),
(238228, '1mscA00', NULL, NULL, 129, NULL, NULL, 230443),
(238229, '2qudA00', NULL, NULL, 125, NULL, NULL, 230443),
(238230, '1unaA00', NULL, NULL, 129, NULL, NULL, 230443),
(238231, '4l8hB00', NULL, NULL, 132, NULL, NULL, 230443),
(238232, '2p7vA00', NULL, NULL, 158, NULL, NULL, 230444),
(238233, '4xwjA00', NULL, NULL, 167, NULL, NULL, 230444),
(238234, '2cp6A01', NULL, NULL, 80, NULL, NULL, 230445),
(238235, '2cp3A00', NULL, NULL, 84, NULL, NULL, 230445),
(238236, '2cp5A01', NULL, NULL, 79, NULL, NULL, 230445),
(238237, '2cp2A00', NULL, NULL, 95, NULL, NULL, 230445),
(238238, '2e3iA00', NULL, NULL, 86, NULL, NULL, 230445),
(238239, '3tq7P00', NULL, NULL, 71, NULL, NULL, 230445),
(238240, '2hknA00', NULL, NULL, 97, NULL, NULL, 230445),
(238241, '2z0wA00', NULL, NULL, 96, NULL, NULL, 230445),
(238242, '2cowA01', NULL, NULL, 82, NULL, NULL, 230445),
(238243, '1lplA00', NULL, NULL, 95, NULL, NULL, 230445),
(238244, '1whjA00', NULL, NULL, 102, NULL, NULL, 230445),
(238245, '1whkA00', NULL, NULL, 91, NULL, NULL, 230445),
(238246, '1whgA01', NULL, NULL, 86, NULL, NULL, 230445),
(238247, '2e3hA00', NULL, NULL, 90, NULL, NULL, 230445),
(238248, '1whhA01', NULL, NULL, 82, NULL, NULL, 230445),
(238249, '4b6mB00', NULL, NULL, 84, NULL, NULL, 230445),
(238250, '2cp0A00', NULL, NULL, 95, NULL, NULL, 230445),
(238251, '1whmA01', NULL, NULL, 72, NULL, NULL, 230445),
(238252, '1ixdA00', NULL, NULL, 104, NULL, NULL, 230445),
(238253, '1whlA00', NULL, NULL, 95, NULL, NULL, 230445),
(238254, '2cozA01', NULL, NULL, 86, NULL, NULL, 230445),
(238255, '2fi0A00', NULL, NULL, 81, NULL, NULL, 230446),
(238256, '2k53A00', NULL, NULL, 76, NULL, NULL, 230446),
(238257, '2k5eA00', NULL, NULL, 73, NULL, NULL, 230446),
(238258, '4cykA00', NULL, NULL, 41, NULL, NULL, 230447),
(238259, '3zbdA00', NULL, NULL, 113, NULL, NULL, 230448),
(238260, '1taqA01', NULL, NULL, 175, NULL, NULL, 230449),
(238261, '1a76A01', NULL, NULL, 208, NULL, NULL, 230449),
(238262, '3zdbA01', NULL, NULL, 161, NULL, NULL, 230449),
(238263, '3i8oA01', NULL, NULL, 130, NULL, NULL, 230449),
(238264, '4mj7A00', NULL, NULL, 159, NULL, NULL, 230449),
(238265, '1rxwA01', NULL, NULL, 219, NULL, NULL, 230449),
(238266, '2fe1A00', NULL, NULL, 131, NULL, NULL, 230449),
(238267, '1mc8A01', NULL, NULL, 220, NULL, NULL, 230449);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(238268, '4chgA00', NULL, NULL, 133, NULL, NULL, 230449),
(238269, '1o4wA00', NULL, NULL, 126, NULL, NULL, 230449),
(238270, '6nklB00', NULL, NULL, 143, NULL, NULL, 230449),
(238271, '2wp8J01', NULL, NULL, 210, NULL, NULL, 230449),
(238272, '5ecdA00', NULL, NULL, 138, NULL, NULL, 230449),
(238273, '1v96A00', NULL, NULL, 149, NULL, NULL, 230449),
(238274, '1y82B00', NULL, NULL, 157, NULL, NULL, 230449),
(238275, '3zvkA00', NULL, NULL, 134, NULL, NULL, 230449),
(238276, '1y82C00', NULL, NULL, 157, NULL, NULL, 230449),
(238277, '5sv2A00', NULL, NULL, 146, NULL, NULL, 230449),
(238278, '1y82D00', NULL, NULL, 157, NULL, NULL, 230449),
(238279, '2qipA00', NULL, NULL, 165, NULL, NULL, 230449),
(238280, '2hwyA00', NULL, NULL, 164, NULL, NULL, 230449),
(238281, '2hwwB00', NULL, NULL, 181, NULL, NULL, 230449),
(238282, '1y82A00', NULL, NULL, 157, NULL, NULL, 230449),
(238283, '2h1cA00', NULL, NULL, 139, NULL, NULL, 230449),
(238284, '3h87B00', NULL, NULL, 140, NULL, NULL, 230449),
(238285, '1w8iA00', NULL, NULL, 156, NULL, NULL, 230449),
(238286, '2lcqA01', NULL, NULL, 127, NULL, NULL, 230449),
(238287, '5k97A01', NULL, NULL, 216, NULL, NULL, 230449),
(238288, '3ix7A00', NULL, NULL, 134, NULL, NULL, 230449),
(238289, '1b43A01', NULL, NULL, 220, NULL, NULL, 230449),
(238290, '3h7iA01', NULL, NULL, 207, NULL, NULL, 230449),
(238291, '5v07Z01', NULL, NULL, 207, NULL, NULL, 230449),
(238292, '2mdtA00', NULL, NULL, 119, NULL, NULL, 230449),
(238293, '3oryA01', NULL, NULL, 234, NULL, NULL, 230449),
(238294, '4xgqA00', NULL, NULL, 132, NULL, NULL, 230449),
(238295, '5hmmA01', NULL, NULL, 186, NULL, NULL, 230449),
(238296, '5k8jB00', NULL, NULL, 128, NULL, NULL, 230449),
(238297, '1cmwA01', NULL, NULL, 151, NULL, NULL, 230449),
(238298, '3dboB00', NULL, NULL, 131, NULL, NULL, 230449),
(238299, '1v8pF00', NULL, NULL, 158, NULL, NULL, 230449),
(238300, '3r2xC00', NULL, NULL, 93, NULL, NULL, 230450),
(238301, '1u84A00', NULL, NULL, 90, NULL, NULL, 230450),
(238302, '5k31C00', NULL, NULL, 238, NULL, NULL, 230451),
(238303, '4ae2B02', NULL, NULL, 171, NULL, NULL, 230451),
(238304, '6fzvC00', NULL, NULL, 237, NULL, NULL, 230451),
(238305, '1s2kA00', NULL, NULL, 206, NULL, NULL, 230452),
(238306, '1y43B00', NULL, NULL, 173, NULL, NULL, 230452),
(238307, '1ikpA03', NULL, NULL, 207, NULL, NULL, 230453),
(238308, '1f0lA01', NULL, NULL, 187, NULL, NULL, 230453),
(238309, '3essA00', NULL, NULL, 208, NULL, NULL, 230453),
(238310, '2o57A01', NULL, NULL, 105, NULL, NULL, 230454),
(238311, '4bhrA00', NULL, NULL, 95, NULL, NULL, 230455),
(238312, '5g2fA00', NULL, NULL, 95, NULL, NULL, 230455),
(238313, '2ijrA01', NULL, NULL, 97, NULL, NULL, 230456),
(238314, '2nluA01', NULL, NULL, 18, NULL, NULL, 230457),
(238315, '1qu3A03', NULL, NULL, 56, NULL, NULL, 230458),
(238316, '1ygmA01', NULL, NULL, 90, NULL, NULL, 230459),
(238317, '3besR03', NULL, NULL, 56, NULL, NULL, 230460),
(238318, '3drwA02', NULL, NULL, 119, NULL, NULL, 230461),
(238319, '5k27A02', NULL, NULL, 118, NULL, NULL, 230461),
(238320, '4b8rA02', NULL, NULL, 106, NULL, NULL, 230461),
(238321, '5od2A02', NULL, NULL, 118, NULL, NULL, 230461),
(238322, '5o0jA02', NULL, NULL, 106, NULL, NULL, 230461),
(238323, '6c8zA02', NULL, NULL, 115, NULL, NULL, 230461),
(238324, '1ua4A02', NULL, NULL, 112, NULL, NULL, 230461),
(238325, '3lxuX03', NULL, NULL, 62, NULL, NULL, 230462),
(238326, '3k2iA01', NULL, NULL, 131, NULL, NULL, 230463),
(238327, '3hlkA01', NULL, NULL, 147, NULL, NULL, 230463),
(238328, '2g7nA00', NULL, NULL, 425, NULL, NULL, 230464),
(238329, '3v0aB01', NULL, NULL, 460, NULL, NULL, 230464),
(238330, '2fpqA00', NULL, NULL, 444, NULL, NULL, 230464),
(238331, '5bqnA01', NULL, NULL, 480, NULL, NULL, 230464),
(238332, '1epwA01', NULL, NULL, 438, NULL, NULL, 230464),
(238333, '3zurA01', NULL, NULL, 477, NULL, NULL, 230464),
(238334, '1t3cA00', NULL, NULL, 421, NULL, NULL, 230464),
(238335, '2a97A00', NULL, NULL, 415, NULL, NULL, 230464),
(238336, '1z7hA00', NULL, NULL, 431, NULL, NULL, 230464),
(238337, '2qn0A00', NULL, NULL, 430, NULL, NULL, 230464),
(238338, '6bvdB00', NULL, NULL, 436, NULL, NULL, 230464);
INSERT INTO "PUBLIC"."MODEL" VALUES
(238339, '3fieA00', NULL, NULL, 427, NULL, NULL, 230464),
(238340, '3bonA00', NULL, NULL, 425, NULL, NULL, 230464),
(238341, '4zktB01', NULL, NULL, 468, NULL, NULL, 230464),
(238342, '3vuoA01', NULL, NULL, 467, NULL, NULL, 230464),
(238343, '1e1hA00', NULL, NULL, 243, NULL, NULL, 230464),
(238344, '1zb7A00', NULL, NULL, 438, NULL, NULL, 230464),
(238345, '3ffzB01', NULL, NULL, 516, NULL, NULL, 230464),
(238346, '3iacA02', NULL, NULL, 93, NULL, NULL, 230465),
(238347, '2q01A02', NULL, NULL, 100, NULL, NULL, 230465),
(238348, '2qeeA02', NULL, NULL, 82, NULL, NULL, 230465),
(238349, '4i6vA02', NULL, NULL, 84, NULL, NULL, 230465),
(238350, '1j5sA02', NULL, NULL, 91, NULL, NULL, 230465),
(238351, '3a1yG02', NULL, NULL, 77, NULL, NULL, 230466),
(238352, '4i9xA00', NULL, NULL, 215, NULL, NULL, 230467),
(238353, '2kx2A00', NULL, NULL, 96, NULL, NULL, 230468),
(238354, '2qnuA00', NULL, NULL, 226, NULL, NULL, 230469),
(238355, '2lexA00', NULL, NULL, 78, NULL, NULL, 230470),
(238356, '2aydA01', NULL, NULL, 67, NULL, NULL, 230470),
(238357, '5w3xD01', NULL, NULL, 72, NULL, NULL, 230470),
(238358, '4j7qA00', NULL, NULL, 333, NULL, NULL, 230471),
(238359, '3q8gA02', NULL, NULL, 228, NULL, NULL, 230471),
(238360, '1auaA01', NULL, NULL, 213, NULL, NULL, 230471),
(238361, '4omjA00', NULL, NULL, 278, NULL, NULL, 230471),
(238362, '3pg7A01', NULL, NULL, 146, NULL, NULL, 230471),
(238363, '3pegA01', NULL, NULL, 156, NULL, NULL, 230471),
(238364, '4uybA01', NULL, NULL, 291, NULL, NULL, 230471),
(238365, '1r5lA03', NULL, NULL, 146, NULL, NULL, 230471),
(238366, '3hx3A02', NULL, NULL, 182, NULL, NULL, 230471),
(238367, '1oizA02', NULL, NULL, 198, NULL, NULL, 230471),
(238368, '4tlgB01', NULL, NULL, 294, NULL, NULL, 230471),
(238369, '3w68A03', NULL, NULL, 146, NULL, NULL, 230471),
(238370, '3dfzA02', NULL, NULL, 75, NULL, NULL, 230472),
(238371, '4a2aA02', NULL, NULL, 87, NULL, NULL, 230473),
(238372, '1fi8D00', NULL, NULL, 58, NULL, NULL, 230474),
(238373, '1jeyA03', NULL, NULL, 63, NULL, NULL, 230475),
(238374, '2nrjA01', NULL, NULL, 337, NULL, NULL, 230476),
(238375, '4phqA00', NULL, NULL, 298, NULL, NULL, 230476),
(238376, '4k1pE00', NULL, NULL, 342, NULL, NULL, 230476),
(238377, '6ih0A01', NULL, NULL, 122, NULL, NULL, 230477),
(238378, '3p3gA01', NULL, NULL, 128, NULL, NULL, 230477),
(238379, '3uhmA01', NULL, NULL, 127, NULL, NULL, 230477),
(238380, '6amyA02', NULL, NULL, 170, NULL, NULL, 230478),
(238381, '1krrA00', NULL, NULL, 203, NULL, NULL, 230478),
(238382, '1xatA00', NULL, NULL, 212, NULL, NULL, 230478),
(238383, '2iu8C02', NULL, NULL, 211, NULL, NULL, 230478),
(238384, '1hm9A02', NULL, NULL, 189, NULL, NULL, 230478),
(238385, '5wegA02', NULL, NULL, 110, NULL, NULL, 230478),
(238386, '3jqyC00', NULL, NULL, 225, NULL, NULL, 230478),
(238387, '3otmA00', NULL, NULL, 212, NULL, NULL, 230478),
(238388, '3tioB00', NULL, NULL, 183, NULL, NULL, 230478),
(238389, '3mqgC01', NULL, NULL, 153, NULL, NULL, 230478),
(238390, '3hjjC00', NULL, NULL, 190, NULL, NULL, 230478),
(238391, '5jxxA01', NULL, NULL, 191, NULL, NULL, 230478),
(238392, '3pmoA02', NULL, NULL, 212, NULL, NULL, 230478),
(238393, '1ssqA02', NULL, NULL, 103, NULL, NULL, 230478),
(238394, '3fsyD03', NULL, NULL, 160, NULL, NULL, 230478),
(238395, '4mfgA00', NULL, NULL, 168, NULL, NULL, 230478),
(238396, '2i5kA02', NULL, NULL, 112, NULL, NULL, 230478),
(238397, '3cj8A03', NULL, NULL, 155, NULL, NULL, 230478),
(238398, '4fceA02', NULL, NULL, 229, NULL, NULL, 230478),
(238399, '3gueA02', NULL, NULL, 109, NULL, NULL, 230478),
(238400, '3r0sA01', NULL, NULL, 197, NULL, NULL, 230478),
(238401, '3eg4A02', NULL, NULL, 176, NULL, NULL, 230478),
(238402, '4n6aA02', NULL, NULL, 102, NULL, NULL, 230478),
(238403, '3tv0A00', NULL, NULL, 163, NULL, NULL, 230478),
(238404, '3bfpA02', NULL, NULL, 119, NULL, NULL, 230478),
(238405, '3r3rA00', NULL, NULL, 187, NULL, NULL, 230478),
(238406, '2wlgB00', NULL, NULL, 215, NULL, NULL, 230478),
(238407, '1j2zA01', NULL, NULL, 193, NULL, NULL, 230478),
(238408, '3nz2A00', NULL, NULL, 195, NULL, NULL, 230478),
(238409, '3hsqA01', NULL, NULL, 191, NULL, NULL, 230478);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(238410, '3ixcA00', NULL, NULL, 170, NULL, NULL, 230478),
(238411, '6iveA00', NULL, NULL, 171, NULL, NULL, 230478),
(238412, '5l6vE02', NULL, NULL, 131, NULL, NULL, 230478),
(238413, '1kgqA02', NULL, NULL, 170, NULL, NULL, 230478),
(238414, '2icyB02', NULL, NULL, 110, NULL, NULL, 230478),
(238415, '3tk8B02', NULL, NULL, 170, NULL, NULL, 230478),
(238416, '2rijA03', NULL, NULL, 180, NULL, NULL, 230478),
(238417, '5nzgA02', NULL, NULL, 109, NULL, NULL, 230478),
(238418, '5f42A01', NULL, NULL, 194, NULL, NULL, 230478),
(238419, '4mzuB01', NULL, NULL, 153, NULL, NULL, 230478),
(238420, '1xhdA00', NULL, NULL, 173, NULL, NULL, 230478),
(238421, '4h7oA02', NULL, NULL, 120, NULL, NULL, 230478),
(238422, '3brkX02', NULL, NULL, 127, NULL, NULL, 230478),
(238423, '4hzdA02', NULL, NULL, 108, NULL, NULL, 230478),
(238424, '3q1xA02', NULL, NULL, 103, NULL, NULL, 230478),
(238425, '4eqyC01', NULL, NULL, 190, NULL, NULL, 230478),
(238426, '5ux9A00', NULL, NULL, 221, NULL, NULL, 230478),
(238427, '3vnpA00', NULL, NULL, 183, NULL, NULL, 230478),
(238428, '3srtA00', NULL, NULL, 188, NULL, NULL, 230478),
(238429, '1hv9B02', NULL, NULL, 189, NULL, NULL, 230478),
(238430, '4r7pA02', NULL, NULL, 113, NULL, NULL, 230478),
(238431, '3t57A01', NULL, NULL, 221, NULL, NULL, 230478),
(238432, '1t3dA02', NULL, NULL, 131, NULL, NULL, 230478),
(238433, '3gvdA02', NULL, NULL, 131, NULL, NULL, 230478),
(238434, '5e3qA03', NULL, NULL, 155, NULL, NULL, 230478),
(238435, '3r8yA02', NULL, NULL, 137, NULL, NULL, 230478),
(238436, '1ssqD02', NULL, NULL, 129, NULL, NULL, 230478),
(238437, '3fs8A01', NULL, NULL, 223, NULL, NULL, 230478),
(238438, '5vmkC02', NULL, NULL, 230, NULL, NULL, 230478),
(238439, '3r1wA00', NULL, NULL, 189, NULL, NULL, 230478),
(238440, '3d98A02', NULL, NULL, 152, NULL, NULL, 230478),
(238441, '3kwdA00', NULL, NULL, 177, NULL, NULL, 230478),
(238442, '1yp2A02', NULL, NULL, 135, NULL, NULL, 230478),
(238443, '5v0zA00', NULL, NULL, 202, NULL, NULL, 230478),
(238444, '3vbiA01', NULL, NULL, 171, NULL, NULL, 230478),
(238445, '6mfkA00', NULL, NULL, 216, NULL, NULL, 230478),
(238446, '4e6uA01', NULL, NULL, 198, NULL, NULL, 230478),
(238447, '5afuV00', NULL, NULL, 165, NULL, NULL, 230478),
(238448, '3f1xA02', NULL, NULL, 119, NULL, NULL, 230478),
(238449, '2ggoA02', NULL, NULL, 191, NULL, NULL, 230478),
(238450, '3c8vC03', NULL, NULL, 166, NULL, NULL, 230478),
(238451, '3eevB00', NULL, NULL, 212, NULL, NULL, 230478),
(238452, '2p2oD00', NULL, NULL, 185, NULL, NULL, 230478),
(238453, '6f1tU00', NULL, NULL, 190, NULL, NULL, 230478),
(238454, '4g87A02', NULL, NULL, 189, NULL, NULL, 230478),
(238455, '6hy2X01', NULL, NULL, 196, NULL, NULL, 230478),
(238456, '3r5dA03', NULL, NULL, 172, NULL, NULL, 230478),
(238457, '4m98A02', NULL, NULL, 110, NULL, NULL, 230478),
(238458, '4eggC00', NULL, NULL, 187, NULL, NULL, 230478),
(238459, '1v3wA00', NULL, NULL, 173, NULL, NULL, 230478),
(238460, '1ocxA00', NULL, NULL, 182, NULL, NULL, 230478),
(238461, '3c8vA02', NULL, NULL, 251, NULL, NULL, 230478),
(238462, '3eh0A02', NULL, NULL, 210, NULL, NULL, 230478),
(238463, '2v0hA02', NULL, NULL, 229, NULL, NULL, 230478),
(238464, '4e79A02', NULL, NULL, 210, NULL, NULL, 230478),
(238465, '1mr7C00', NULL, NULL, 209, NULL, NULL, 230478),
(238466, '4n27A00', NULL, NULL, 175, NULL, NULL, 230478),
(238467, '4hurC00', NULL, NULL, 220, NULL, NULL, 230478),
(238468, '4r36A01', NULL, NULL, 189, NULL, NULL, 230478),
(238469, '4m9cA02', NULL, NULL, 115, NULL, NULL, 230478),
(238470, '4ea9A02', NULL, NULL, 110, NULL, NULL, 230478),
(238471, '1fxjA02', NULL, NULL, 95, NULL, NULL, 230478),
(238472, '3gosA02', NULL, NULL, 170, NULL, NULL, 230478),
(238473, '5demC01', NULL, NULL, 192, NULL, NULL, 230478),
(238474, '3vkgA08', NULL, NULL, 163, NULL, NULL, 230479),
(238475, '3vkhB08', NULL, NULL, 165, NULL, NULL, 230479),
(238476, '4akgA08', NULL, NULL, 156, NULL, NULL, 230479),
(238477, '4htgA03', NULL, NULL, 88, NULL, NULL, 230480),
(238478, '5h6oA03', NULL, NULL, 91, NULL, NULL, 230480),
(238479, '3ecrB03', NULL, NULL, 122, NULL, NULL, 230480),
(238480, '4mlvA03', NULL, NULL, 85, NULL, NULL, 230480);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(238481, '1gtkA03', NULL, NULL, 86, NULL, NULL, 230480),
(238482, '3l48A01', NULL, NULL, 76, NULL, NULL, 230481),
(238483, '3rfzE05', NULL, NULL, 93, NULL, NULL, 230481),
(238484, '2xetB00', NULL, NULL, 89, NULL, NULL, 230481),
(238485, '1x79A00', NULL, NULL, 98, NULL, NULL, 230482),
(238486, '1nwmX00', NULL, NULL, 113, NULL, NULL, 230482),
(238487, '1wr6A00', NULL, NULL, 92, NULL, NULL, 230482),
(238488, '1yd8G00', NULL, NULL, 98, NULL, NULL, 230482),
(238489, '1nafA02', NULL, NULL, 105, NULL, NULL, 230482),
(238490, '1o3xA00', NULL, NULL, 114, NULL, NULL, 230482),
(238491, '1wrdA00', NULL, NULL, 103, NULL, NULL, 230482),
(238492, '3dwlG00', NULL, NULL, 121, NULL, NULL, 230483),
(238493, '1k8kG00', NULL, NULL, 151, NULL, NULL, 230483),
(238494, '5tj5E00', NULL, NULL, 150, NULL, NULL, 230484),
(238495, '4bemJ00', NULL, NULL, 182, NULL, NULL, 230484),
(238496, '2bl2A00', NULL, NULL, 156, NULL, NULL, 230484),
(238497, '3nk4B01', NULL, NULL, 132, NULL, NULL, 230485),
(238498, '3d4gE03', NULL, NULL, 108, NULL, NULL, 230485),
(238499, '1qvrC04', NULL, NULL, 113, NULL, NULL, 230486),
(238500, '3wcoA01', NULL, NULL, 129, NULL, NULL, 230487),
(238501, '1vyiA00', NULL, NULL, 112, NULL, NULL, 230488),
(238502, '2wzlA00', NULL, NULL, 107, NULL, NULL, 230488),
(238503, '4wx3A00', NULL, NULL, 165, NULL, NULL, 230489),
(238504, '3a57A00', NULL, NULL, 165, NULL, NULL, 230489),
(238505, '3thoB03', NULL, NULL, 59, NULL, NULL, 230490),
(238506, '3tedA01', NULL, NULL, 126, NULL, NULL, 230491),
(238507, '4o6yB00', NULL, NULL, 230, NULL, NULL, 230492),
(238508, '1kmiZ01', NULL, NULL, 34, NULL, NULL, 230493),
(238509, '4fvmA07', NULL, NULL, 65, NULL, NULL, 230494),
(238510, '4u29A03', NULL, NULL, 50, NULL, NULL, 230495),
(238511, '2qsfA03', NULL, NULL, 50, NULL, NULL, 230495),
(238512, '4l1nA00', NULL, NULL, 161, NULL, NULL, 230496),
(238513, '2d6fA01', NULL, NULL, 85, NULL, NULL, 230497),
(238514, '1zq1A01', NULL, NULL, 78, NULL, NULL, 230497),
(238515, '4h6cB00', NULL, NULL, 195, NULL, NULL, 230498),
(238516, '2brjA00', NULL, NULL, 188, NULL, NULL, 230498),
(238517, '1zvcA00', NULL, NULL, 189, NULL, NULL, 230498),
(238518, '4h6aD00', NULL, NULL, 194, NULL, NULL, 230498),
(238519, '2dosA01', NULL, NULL, 115, NULL, NULL, 230499),
(238520, '1yzbA01', NULL, NULL, 124, NULL, NULL, 230499),
(238521, '3o65E01', NULL, NULL, 132, NULL, NULL, 230499),
(238522, '4fl4F02', NULL, NULL, 165, NULL, NULL, 230500),
(238523, '4ch7A01', NULL, NULL, 118, NULL, NULL, 230501),
(238524, '1lmmA01', NULL, NULL, 28, NULL, NULL, 230502),
(238525, '2j5iA02', NULL, NULL, 39, NULL, NULL, 230503),
(238526, '2ld7A00', NULL, NULL, 94, NULL, NULL, 230504),
(238527, '2bn8A00', NULL, NULL, 67, NULL, NULL, 230505),
(238528, '2zuqA00', NULL, NULL, 176, NULL, NULL, 230506),
(238529, '4y42A02', NULL, NULL, 68, NULL, NULL, 230507),
(238530, '1dw9A02', NULL, NULL, 68, NULL, NULL, 230507),
(238531, '3ffvA00', NULL, NULL, 181, NULL, NULL, 230508),
(238532, '1yg2A02', NULL, NULL, 90, NULL, NULL, 230509),
(238533, '2mmbA00', NULL, NULL, 107, NULL, NULL, 230510),
(238534, '3fanA03', NULL, NULL, 50, NULL, NULL, 230511),
(238535, '1mbmD03', NULL, NULL, 49, NULL, NULL, 230511),
(238536, '2xq2B01', NULL, NULL, 538, NULL, NULL, 230512),
(238537, '3dh4A01', NULL, NULL, 529, NULL, NULL, 230512),
(238538, '2zxpA02', NULL, NULL, 261, NULL, NULL, 230513),
(238539, '5f56A02', NULL, NULL, 263, NULL, NULL, 230513),
(238540, '4lqlA01', NULL, NULL, 175, NULL, NULL, 230514),
(238541, '4r1qB01', NULL, NULL, 176, NULL, NULL, 230514),
(238542, '4f2dA01', NULL, NULL, 175, NULL, NULL, 230514),
(238543, '1ciyA01', NULL, NULL, 225, NULL, NULL, 230515),
(238544, '2c9kA01', NULL, NULL, 249, NULL, NULL, 230515),
(238545, '3x0uB01', NULL, NULL, 243, NULL, NULL, 230515),
(238546, '1ji6A01', NULL, NULL, 227, NULL, NULL, 230515),
(238547, '4moaA01', NULL, NULL, 231, NULL, NULL, 230515),
(238548, '3eb7C01', NULL, NULL, 228, NULL, NULL, 230515),
(238549, '1w99A01', NULL, NULL, 173, NULL, NULL, 230515),
(238550, '1i5pA02', NULL, NULL, 234, NULL, NULL, 230515),
(238551, '1dlcA01', NULL, NULL, 229, NULL, NULL, 230515);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(238552, '5zi1A01', NULL, NULL, 239, NULL, NULL, 230515),
(238553, '4d8mA01', NULL, NULL, 218, NULL, NULL, 230515),
(238554, '2l8kA00', NULL, NULL, 123, NULL, NULL, 230516),
(238555, '1ro2A02', NULL, NULL, 121, NULL, NULL, 230517),
(238556, '3m1mA02', NULL, NULL, 159, NULL, NULL, 230517),
(238557, '4dx5A08', NULL, NULL, 89, NULL, NULL, 230518),
(238558, '4mt1A04', NULL, NULL, 96, NULL, NULL, 230518),
(238559, '3w9iA04', NULL, NULL, 96, NULL, NULL, 230518),
(238560, '5t0oA04', NULL, NULL, 96, NULL, NULL, 230518),
(238561, '4dx5A04', NULL, NULL, 96, NULL, NULL, 230518),
(238562, '3w9iA08', NULL, NULL, 89, NULL, NULL, 230518),
(238563, '4mt1A08', NULL, NULL, 89, NULL, NULL, 230518),
(238564, '3utkA00', NULL, NULL, 96, NULL, NULL, 230519),
(238565, '3solA00', NULL, NULL, 94, NULL, NULL, 230519),
(238566, '4a56A00', NULL, NULL, 93, NULL, NULL, 230519),
(238567, '3zxaC02', NULL, NULL, 106, NULL, NULL, 230520),
(238568, '3nrfA00', NULL, NULL, 106, NULL, NULL, 230521),
(238569, '3l1nA02', NULL, NULL, 87, NULL, NULL, 230522),
(238570, '3zoqC00', NULL, NULL, 56, NULL, NULL, 230523),
(238571, '4l5nC00', NULL, NULL, 55, NULL, NULL, 230523),
(238572, '4w6yA00', NULL, NULL, 151, NULL, NULL, 230524),
(238573, '5koxA02', NULL, NULL, 86, NULL, NULL, 230525),
(238574, '4k5sA02', NULL, NULL, 87, NULL, NULL, 230525),
(238575, '4k2xB02', NULL, NULL, 94, NULL, NULL, 230525),
(238576, '6brdC02', NULL, NULL, 87, NULL, NULL, 230525),
(238577, '2qa2A02', NULL, NULL, 84, NULL, NULL, 230525),
(238578, '3fmwC02', NULL, NULL, 87, NULL, NULL, 230525),
(238579, '2qa1A02', NULL, NULL, 84, NULL, NULL, 230525),
(238580, '3hhyA01', NULL, NULL, 71, NULL, NULL, 230526),
(238581, '2jiwA03', NULL, NULL, 183, NULL, NULL, 230527),
(238582, '2v5cA03', NULL, NULL, 130, NULL, NULL, 230527),
(238583, '2xj7B03', NULL, NULL, 269, NULL, NULL, 230527),
(238584, '5gipC00', NULL, NULL, 130, NULL, NULL, 230528),
(238585, '6g5iM00', NULL, NULL, 132, NULL, NULL, 230528),
(238586, '2vgnA03', NULL, NULL, 110, NULL, NULL, 230528),
(238587, '2kg4A00', NULL, NULL, 165, NULL, NULL, 230528),
(238588, '1ipaA01', NULL, NULL, 104, NULL, NULL, 230528),
(238589, '2lbwA00', NULL, NULL, 121, NULL, NULL, 230528),
(238590, '4x3lA01', NULL, NULL, 97, NULL, NULL, 230528),
(238591, '3obwA03', NULL, NULL, 102, NULL, NULL, 230528),
(238592, '3v7qA00', NULL, NULL, 101, NULL, NULL, 230528),
(238593, '3agkA03', NULL, NULL, 98, NULL, NULL, 230528),
(238594, '4nutA00', NULL, NULL, 129, NULL, NULL, 230528),
(238595, '2xzmU00', NULL, NULL, 126, NULL, NULL, 230528),
(238596, '1dt9A03', NULL, NULL, 160, NULL, NULL, 230528),
(238597, '3v7eA00', NULL, NULL, 82, NULL, NULL, 230528),
(238598, '1nmuB00', NULL, NULL, 104, NULL, NULL, 230528),
(238599, '3j7aR00', NULL, NULL, 120, NULL, NULL, 230528),
(238600, '1w41A00', NULL, NULL, 101, NULL, NULL, 230528),
(238601, '3gyqA01', NULL, NULL, 107, NULL, NULL, 230528),
(238602, '3ir9A02', NULL, NULL, 122, NULL, NULL, 230528),
(238603, '3vi6A00', NULL, NULL, 106, NULL, NULL, 230528),
(238604, '5xxuM00', NULL, NULL, 123, NULL, NULL, 230528),
(238605, '3wxmB03', NULL, NULL, 108, NULL, NULL, 230528),
(238606, '3cg6B00', NULL, NULL, 146, NULL, NULL, 230528),
(238607, '3mcaB03', NULL, NULL, 123, NULL, NULL, 230528),
(238608, '5ewrA00', NULL, NULL, 122, NULL, NULL, 230528),
(238609, '5eo3A00', NULL, NULL, 121, NULL, NULL, 230528),
(238610, '3nviB00', NULL, NULL, 129, NULL, NULL, 230528),
(238611, '4bw0B00', NULL, NULL, 123, NULL, NULL, 230528),
(238612, '3cpqB00', NULL, NULL, 110, NULL, NULL, 230528),
(238613, '1xbiA00', NULL, NULL, 120, NULL, NULL, 230528),
(238614, '2aifA00', NULL, NULL, 118, NULL, NULL, 230528),
(238615, '4a17F01', NULL, NULL, 183, NULL, NULL, 230528),
(238616, '2walB00', NULL, NULL, 159, NULL, NULL, 230528),
(238617, '1vx7J01', NULL, NULL, 171, NULL, NULL, 230528),
(238618, '2bo1A00', NULL, NULL, 101, NULL, NULL, 230528),
(238619, '6az1Q00', NULL, NULL, 115, NULL, NULL, 230528),
(238620, '3nk7B01', NULL, NULL, 107, NULL, NULL, 230528),
(238621, '2fc3A00', NULL, NULL, 124, NULL, NULL, 230528),
(238622, '6em3G00', NULL, NULL, 164, NULL, NULL, 230528);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(238623, '6faiM00', NULL, NULL, 126, NULL, NULL, 230528),
(238624, '1x7pA01', NULL, NULL, 101, NULL, NULL, 230528),
(238625, '3obyA03', NULL, NULL, 107, NULL, NULL, 230528),
(238626, '1gz0F01', NULL, NULL, 86, NULL, NULL, 230528),
(238627, '3jamM00', NULL, NULL, 134, NULL, NULL, 230528),
(238628, '3o58H00', NULL, NULL, 179, NULL, NULL, 230528),
(238629, '4a18G00', NULL, NULL, 104, NULL, NULL, 230528),
(238630, '1jj2F00', NULL, NULL, 119, NULL, NULL, 230528),
(238631, '1pxwB00', NULL, NULL, 128, NULL, NULL, 230528),
(238632, '2ohwA00', NULL, NULL, 133, NULL, NULL, 230528),
(238633, '3n4zA00', NULL, NULL, 101, NULL, NULL, 230528),
(238634, '3on1A00', NULL, NULL, 101, NULL, NULL, 230528),
(238635, '1vx7600', NULL, NULL, 108, NULL, NULL, 230528),
(238636, '1x7oA01', NULL, NULL, 99, NULL, NULL, 230528),
(238637, '1vwxG01', NULL, NULL, 185, NULL, NULL, 230528),
(238638, '2i6dA01', NULL, NULL, 96, NULL, NULL, 230528),
(238639, '2qi2A03', NULL, NULL, 103, NULL, NULL, 230528),
(238640, '2ozbD00', NULL, NULL, 130, NULL, NULL, 230528),
(238641, '3e20B02', NULL, NULL, 159, NULL, NULL, 230528),
(238642, '1vq8F00', NULL, NULL, 120, NULL, NULL, 230528),
(238643, '3o85B00', NULL, NULL, 122, NULL, NULL, 230528),
(238644, '5opti00', NULL, NULL, 121, NULL, NULL, 230528),
(238645, '3tu3B01', NULL, NULL, 76, NULL, NULL, 230529),
(238646, '4akxB01', NULL, NULL, 60, NULL, NULL, 230529),
(238647, '4qclA01', NULL, NULL, 88, NULL, NULL, 230530),
(238648, '4fvmA01', NULL, NULL, 82, NULL, NULL, 230530),
(238649, '3iayA01', NULL, NULL, 98, NULL, NULL, 230530),
(238650, '4fxdA01', NULL, NULL, 91, NULL, NULL, 230530),
(238651, '2b9kA00', NULL, NULL, 47, NULL, NULL, 230531),
(238652, '4iqjM02', NULL, NULL, 46, NULL, NULL, 230532),
(238653, '2w0gA00', NULL, NULL, 129, NULL, NULL, 230533),
(238654, '2d1cA02', NULL, NULL, 111, NULL, NULL, 230534),
(238655, '1szqA02', NULL, NULL, 142, NULL, NULL, 230535),
(238656, '5mviA02', NULL, NULL, 142, NULL, NULL, 230535),
(238657, '5muxA02', NULL, NULL, 139, NULL, NULL, 230535),
(238658, '2hp0A02', NULL, NULL, 131, NULL, NULL, 230535),
(238659, '1lkxA01', NULL, NULL, 260, NULL, NULL, 230536),
(238660, '4zg4E02', NULL, NULL, 252, NULL, NULL, 230536),
(238661, '3h4sA01', NULL, NULL, 337, NULL, NULL, 230536),
(238662, '1bg2A00', NULL, NULL, 325, NULL, NULL, 230536),
(238663, '1gojA00', NULL, NULL, 355, NULL, NULL, 230536),
(238664, '6b0cK00', NULL, NULL, 338, NULL, NULL, 230536),
(238665, '5gszA00', NULL, NULL, 353, NULL, NULL, 230536),
(238666, '5wdeA00', NULL, NULL, 330, NULL, NULL, 230536),
(238667, '3cobC00', NULL, NULL, 369, NULL, NULL, 230536),
(238668, '2mysA02', NULL, NULL, 253, NULL, NULL, 230536),
(238669, '1kk7A02', NULL, NULL, 252, NULL, NULL, 230536),
(238670, '3u06B00', NULL, NULL, 385, NULL, NULL, 230536),
(238671, '1v8kA00', NULL, NULL, 369, NULL, NULL, 230536),
(238672, '3b6vA00', NULL, NULL, 334, NULL, NULL, 230536),
(238673, '5zbrC00', NULL, NULL, 375, NULL, NULL, 230536),
(238674, '3nwnA00', NULL, NULL, 336, NULL, NULL, 230536),
(238675, '1ry6A00', NULL, NULL, 330, NULL, NULL, 230536),
(238676, '2zfiA00', NULL, NULL, 366, NULL, NULL, 230536),
(238677, '3x2tA00', NULL, NULL, 341, NULL, NULL, 230536),
(238678, '3zfdA00', NULL, NULL, 351, NULL, NULL, 230536),
(238679, '1vomA01', NULL, NULL, 345, NULL, NULL, 230536),
(238680, '6njeA00', NULL, NULL, 348, NULL, NULL, 230536),
(238681, '4a14A00', NULL, NULL, 344, NULL, NULL, 230536),
(238682, '2hehA00', NULL, NULL, 365, NULL, NULL, 230536),
(238683, '4h1gA02', NULL, NULL, 344, NULL, NULL, 230536),
(238684, '3lreB00', NULL, NULL, 355, NULL, NULL, 230536),
(238685, '2kinA00', NULL, NULL, 238, NULL, NULL, 230536),
(238686, '4pfoA02', NULL, NULL, 255, NULL, NULL, 230536),
(238687, '1t5cB00', NULL, NULL, 349, NULL, NULL, 230536),
(238688, '2vvgB00', NULL, NULL, 350, NULL, NULL, 230536),
(238689, '2owmD00', NULL, NULL, 386, NULL, NULL, 230536),
(238690, '3dc4A00', NULL, NULL, 326, NULL, NULL, 230536),
(238691, '3zcwA00', NULL, NULL, 348, NULL, NULL, 230536),
(238692, '3b6uA00', NULL, NULL, 352, NULL, NULL, 230536),
(238693, '4bn2C00', NULL, NULL, 361, NULL, NULL, 230536); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(238694, '1f9vA00', NULL, NULL, 347, NULL, NULL, 230536),
(238695, '5hleA00', NULL, NULL, 336, NULL, NULL, 230536),
(238696, '4gkrB00', NULL, NULL, 344, NULL, NULL, 230536),
(238697, '5wdhA00', NULL, NULL, 355, NULL, NULL, 230536),
(238698, '3t0qA00', NULL, NULL, 349, NULL, NULL, 230536),
(238699, '2y65A00', NULL, NULL, 365, NULL, NULL, 230536),
(238700, '1br2A01', NULL, NULL, 316, NULL, NULL, 230536),
(238701, '2gryA00', NULL, NULL, 358, NULL, NULL, 230536),
(238702, '1lvkA02', NULL, NULL, 245, NULL, NULL, 230536),
(238703, '3psfA01', NULL, NULL, 106, NULL, NULL, 230537),
(238704, '1jsuC00', NULL, NULL, 84, NULL, NULL, 230538),
(238705, '3tuoC00', NULL, NULL, 105, NULL, NULL, 230539),
(238706, '5u0lB01', NULL, NULL, 307, NULL, NULL, 230540),
(238707, '1ez0B01', NULL, NULL, 318, NULL, NULL, 230540),
(238708, '1vluA01', NULL, NULL, 264, NULL, NULL, 230540),
(238709, '4e3xA01', NULL, NULL, 345, NULL, NULL, 230540),
(238710, '5iuvA01', NULL, NULL, 269, NULL, NULL, 230540),
(238711, '4f3xA01', NULL, NULL, 283, NULL, NULL, 230540),
(238712, '4zz7A01', NULL, NULL, 282, NULL, NULL, 230540),
(238713, '3b4wA01', NULL, NULL, 304, NULL, NULL, 230540),
(238714, '3ifgA01', NULL, NULL, 294, NULL, NULL, 230540),
(238715, '4i3vA01', NULL, NULL, 284, NULL, NULL, 230540),
(238716, '3jz4A01', NULL, NULL, 291, NULL, NULL, 230540),
(238717, '4h7nA01', NULL, NULL, 281, NULL, NULL, 230540),
(238718, '3szaA01', NULL, NULL, 247, NULL, NULL, 230540),
(238719, '2y5dA01', NULL, NULL, 313, NULL, NULL, 230540),
(238720, '1uxtA01', NULL, NULL, 273, NULL, NULL, 230540),
(238721, '3my7C01', NULL, NULL, 237, NULL, NULL, 230540),
(238722, '4ogdA01', NULL, NULL, 275, NULL, NULL, 230540),
(238723, '3rjlA01', NULL, NULL, 325, NULL, NULL, 230540),
(238724, '2impA01', NULL, NULL, 288, NULL, NULL, 230540),
(238725, '2o2pA01', NULL, NULL, 301, NULL, NULL, 230540),
(238726, '3r64A01', NULL, NULL, 305, NULL, NULL, 230540),
(238727, '1ad3A01', NULL, NULL, 247, NULL, NULL, 230540),
(238728, '5mypA01', NULL, NULL, 282, NULL, NULL, 230540),
(238729, '6qapC01', NULL, NULL, 297, NULL, NULL, 230540),
(238730, '1o20A01', NULL, NULL, 278, NULL, NULL, 230540),
(238731, '1t90A01', NULL, NULL, 281, NULL, NULL, 230540),
(238732, '4cbbA01', NULL, NULL, 253, NULL, NULL, 230540),
(238733, '4yweA01', NULL, NULL, 294, NULL, NULL, 230540),
(238734, '3etfA01', NULL, NULL, 272, NULL, NULL, 230540),
(238735, '1a4sA01', NULL, NULL, 260, NULL, NULL, 230540),
(238736, '1o9jC01', NULL, NULL, 311, NULL, NULL, 230540),
(238737, '3prlD01', NULL, NULL, 289, NULL, NULL, 230540),
(238738, '1ag8A01', NULL, NULL, 269, NULL, NULL, 230540),
(238739, '2jg7A01', NULL, NULL, 317, NULL, NULL, 230540),
(238740, '5abmA01', NULL, NULL, 303, NULL, NULL, 230540),
(238741, '4knaB01', NULL, NULL, 304, NULL, NULL, 230540),
(238742, '1bi9A01', NULL, NULL, 263, NULL, NULL, 230540),
(238743, '4zvxA01', NULL, NULL, 302, NULL, NULL, 230540),
(238744, '5j6bA01', NULL, NULL, 295, NULL, NULL, 230540),
(238745, '3pqaB01', NULL, NULL, 279, NULL, NULL, 230540),
(238746, '5jfnC01', NULL, NULL, 259, NULL, NULL, 230540),
(238747, '4dngA01', NULL, NULL, 280, NULL, NULL, 230540),
(238748, '4qtoD01', NULL, NULL, 301, NULL, NULL, 230540),
(238749, '5j78A01', NULL, NULL, 264, NULL, NULL, 230540),
(238750, '4oe5A01', NULL, NULL, 304, NULL, NULL, 230540),
(238751, '3qanC01', NULL, NULL, 326, NULL, NULL, 230540),
(238752, '3ek1G01', NULL, NULL, 294, NULL, NULL, 230540),
(238753, '5vbfA01', NULL, NULL, 288, NULL, NULL, 230540),
(238754, '3rh9A01', NULL, NULL, 292, NULL, NULL, 230540),
(238755, '5mz5B01', NULL, NULL, 291, NULL, NULL, 230540),
(238756, '1uzbA01', NULL, NULL, 326, NULL, NULL, 230540),
(238757, '4qf6L01', NULL, NULL, 304, NULL, NULL, 230540),
(238758, '2h5gB01', NULL, NULL, 282, NULL, NULL, 230540),
(238759, '4qgkA01', NULL, NULL, 265, NULL, NULL, 230540),
(238760, '4jdcA01', NULL, NULL, 345, NULL, NULL, 230540),
(238761, '4pz2A01', NULL, NULL, 300, NULL, NULL, 230540),
(238762, '4ghkB01', NULL, NULL, 268, NULL, NULL, 230540),
(238763, '5ekcF01', NULL, NULL, 302, NULL, NULL, 230540),
(238764, '3vz0A01', NULL, NULL, 269, NULL, NULL, 230540);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(238765, '4jbeB01', NULL, NULL, 272, NULL, NULL, 230540),
(238766, '3iwkC01', NULL, NULL, 311, NULL, NULL, 230540),
(238767, '4iymC01', NULL, NULL, 282, NULL, NULL, 230540),
(238768, '5a2dC01', NULL, NULL, 305, NULL, NULL, 230540),
(238769, '4pxnA01', NULL, NULL, 312, NULL, NULL, 230540),
(238770, '4c3sA01', NULL, NULL, 259, NULL, NULL, 230540),
(238771, '3k2wA01', NULL, NULL, 303, NULL, NULL, 230540),
(238772, '5jryA01', NULL, NULL, 295, NULL, NULL, 230540),
(238773, '3i44A01', NULL, NULL, 285, NULL, NULL, 230540),
(238774, '1euhA01', NULL, NULL, 275, NULL, NULL, 230540),
(238775, '3iwjA01', NULL, NULL, 311, NULL, NULL, 230540),
(238776, '4go3E01', NULL, NULL, 302, NULL, NULL, 230540),
(238777, '3v4cB01', NULL, NULL, 312, NULL, NULL, 230540),
(238778, '3ty7B01', NULL, NULL, 289, NULL, NULL, 230540),
(238779, '3u4jA01', NULL, NULL, 304, NULL, NULL, 230540),
(238780, '1wndA01', NULL, NULL, 283, NULL, NULL, 230540),
(238781, '4itbA01', NULL, NULL, 266, NULL, NULL, 230540),
(238782, '4o5hC01', NULL, NULL, 321, NULL, NULL, 230540),
(238783, '4oe6A01', NULL, NULL, 295, NULL, NULL, 230540),
(238784, '3ju8A01', NULL, NULL, 299, NULL, NULL, 230540),
(238785, '4i9bA01', NULL, NULL, 306, NULL, NULL, 230540),
(238786, '4qyjA01', NULL, NULL, 289, NULL, NULL, 230540),
(238787, '4lihA01', NULL, NULL, 276, NULL, NULL, 230540),
(238788, '4u3wA01', NULL, NULL, 290, NULL, NULL, 230540),
(238789, '4i8pB01', NULL, NULL, 307, NULL, NULL, 230540),
(238790, '2j6lA01', NULL, NULL, 300, NULL, NULL, 230540),
(238791, '6dbbC01', NULL, NULL, 317, NULL, NULL, 230540),
(238792, '5ucdA01', NULL, NULL, 232, NULL, NULL, 230540),
(238793, '1o04A01', NULL, NULL, 303, NULL, NULL, 230540),
(238794, '2d4eA01', NULL, NULL, 309, NULL, NULL, 230540),
(238795, '5l2mA01', NULL, NULL, 311, NULL, NULL, 230540),
(238796, '4jz6A01', NULL, NULL, 253, NULL, NULL, 230540),
(238797, '3rosA01', NULL, NULL, 271, NULL, NULL, 230540),
(238798, '3r31A01', NULL, NULL, 260, NULL, NULL, 230540),
(238799, '5fhzF01', NULL, NULL, 295, NULL, NULL, 230540),
(238800, '5kloA01', NULL, NULL, 289, NULL, NULL, 230540),
(238801, '4o6rA01', NULL, NULL, 302, NULL, NULL, 230540),
(238802, '2w8nA01', NULL, NULL, 296, NULL, NULL, 230540),
(238803, '3k9dA01', NULL, NULL, 263, NULL, NULL, 230540),
(238804, '4pxlA01', NULL, NULL, 296, NULL, NULL, 230540),
(238805, '3ckcA03', NULL, NULL, 104, NULL, NULL, 230541),
(238806, '3jysA03', NULL, NULL, 76, NULL, NULL, 230541),
(238807, '1balA00', NULL, NULL, 51, NULL, NULL, 230542),
(238808, '4qoyE00', NULL, NULL, 46, NULL, NULL, 230542),
(238809, '1w3dA00', NULL, NULL, 55, NULL, NULL, 230542),
(238810, '1w85I00', NULL, NULL, 49, NULL, NULL, 230542),
(238811, '1zy8K00', NULL, NULL, 44, NULL, NULL, 230542),
(238812, '1w4iA01', NULL, NULL, 44, NULL, NULL, 230542),
(238813, '1w4hA00', NULL, NULL, 47, NULL, NULL, 230542),
(238814, '2f5zK00', NULL, NULL, 64, NULL, NULL, 230542),
(238815, '2eq9C00', NULL, NULL, 41, NULL, NULL, 230542),
(238816, '2kngA01', NULL, NULL, 43, NULL, NULL, 230542),
(238817, '3rnmF00', NULL, NULL, 58, NULL, NULL, 230542),
(238818, '4txrA00', NULL, NULL, 163, NULL, NULL, 230543),
(238819, '2rkkA01', NULL, NULL, 167, NULL, NULL, 230543),
(238820, '2mmpA00', NULL, NULL, 77, NULL, NULL, 230544),
(238821, '5anrA00', NULL, NULL, 258, NULL, NULL, 230545),
(238822, '1h6kA01', NULL, NULL, 225, NULL, NULL, 230545),
(238823, '2nszA00', NULL, NULL, 129, NULL, NULL, 230545),
(238824, '1ug3A02', NULL, NULL, 134, NULL, NULL, 230545),
(238825, '1ug3A01', NULL, NULL, 205, NULL, NULL, 230545),
(238826, '2zu6B02', NULL, NULL, 140, NULL, NULL, 230545),
(238827, '4c9bB00', NULL, NULL, 291, NULL, NULL, 230545),
(238828, '3rk6A00', NULL, NULL, 217, NULL, NULL, 230545),
(238829, '2i2oA00', NULL, NULL, 224, NULL, NULL, 230545),
(238830, '3juiA00', NULL, NULL, 182, NULL, NULL, 230545),
(238831, '4lunU00', NULL, NULL, 316, NULL, NULL, 230545),
(238832, '4b89A00', NULL, NULL, 249, NULL, NULL, 230545),
(238833, '3eijA01', NULL, NULL, 158, NULL, NULL, 230545),
(238834, '2iu1A00', NULL, NULL, 179, NULL, NULL, 230545),
(238835, '4iulB00', NULL, NULL, 246, NULL, NULL, 230545);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(238836, '1h2uA01', NULL, NULL, 262, NULL, NULL, 230545),
(238837, '3feyA01', NULL, NULL, 289, NULL, NULL, 230545),
(238838, '1paqA00', NULL, NULL, 169, NULL, NULL, 230545),
(238839, '3feyA02', NULL, NULL, 192, NULL, NULL, 230545),
(238840, '3l6aA01', NULL, NULL, 194, NULL, NULL, 230545),
(238841, '1h2tC03', NULL, NULL, 252, NULL, NULL, 230545),
(238842, '2iosA00', NULL, NULL, 128, NULL, NULL, 230545),
(238843, '3d3mA00', NULL, NULL, 168, NULL, NULL, 230545),
(238844, '2rg8A00', NULL, NULL, 149, NULL, NULL, 230545),
(238845, '2ggfA00', NULL, NULL, 137, NULL, NULL, 230545),
(238846, '1uw4B00', NULL, NULL, 248, NULL, NULL, 230545),
(238847, '2vsoF01', NULL, NULL, 258, NULL, NULL, 230545),
(238848, '4crwA00', NULL, NULL, 231, NULL, NULL, 230545),
(238849, '1hu3A00', NULL, NULL, 243, NULL, NULL, 230545),
(238850, '2fulB00', NULL, NULL, 159, NULL, NULL, 230545),
(238851, '4cemA00', NULL, NULL, 312, NULL, NULL, 230545),
(238852, '1ytlA00', NULL, NULL, 158, NULL, NULL, 230546),
(238853, '6eqsD01', NULL, NULL, 161, NULL, NULL, 230546),
(238854, '5ow0A02', NULL, NULL, 129, NULL, NULL, 230546),
(238855, '1q6zA02', NULL, NULL, 162, NULL, NULL, 230546),
(238856, '2pgnA02', NULL, NULL, 182, NULL, NULL, 230546),
(238857, '1m2kA01', NULL, NULL, 156, NULL, NULL, 230546),
(238858, '1pnoB00', NULL, NULL, 180, NULL, NULL, 230546),
(238859, '4i5iA01', NULL, NULL, 173, NULL, NULL, 230546),
(238860, '4rjjA02', NULL, NULL, 175, NULL, NULL, 230546),
(238861, '4zzjA02', NULL, NULL, 175, NULL, NULL, 230546),
(238862, '5ej8A02', NULL, NULL, 126, NULL, NULL, 230546),
(238863, '1q1aA01', NULL, NULL, 178, NULL, NULL, 230546),
(238864, '1efpA01', NULL, NULL, 126, NULL, NULL, 230546),
(238865, '5npuA02', NULL, NULL, 154, NULL, NULL, 230546),
(238866, '4kgdA02', NULL, NULL, 167, NULL, NULL, 230546),
(238867, '3eyaA02', NULL, NULL, 156, NULL, NULL, 230546),
(238868, '3cf4G01', NULL, NULL, 160, NULL, NULL, 230546),
(238869, '1q14A01', NULL, NULL, 201, NULL, NULL, 230546),
(238870, '2vbiA02', NULL, NULL, 161, NULL, NULL, 230546),
(238871, '1d4oA00', NULL, NULL, 184, NULL, NULL, 230546),
(238872, '1ybhA02', NULL, NULL, 201, NULL, NULL, 230546),
(238873, '5tmaA02', NULL, NULL, 163, NULL, NULL, 230546),
(238874, '4kxqA01', NULL, NULL, 167, NULL, NULL, 230546),
(238875, '3clsD02', NULL, NULL, 132, NULL, NULL, 230546),
(238876, '1yc5A01', NULL, NULL, 151, NULL, NULL, 230546),
(238877, '2x7jA02', NULL, NULL, 182, NULL, NULL, 230546),
(238878, '5imsA02', NULL, NULL, 178, NULL, NULL, 230546),
(238879, '6enxA01', NULL, NULL, 157, NULL, NULL, 230546),
(238880, '4j1tC00', NULL, NULL, 185, NULL, NULL, 230546),
(238881, '1s5pA01', NULL, NULL, 140, NULL, NULL, 230546),
(238882, '4y6lA01', NULL, NULL, 183, NULL, NULL, 230546),
(238883, '5ahkA02', NULL, NULL, 187, NULL, NULL, 230546),
(238884, '3lq1A02', NULL, NULL, 173, NULL, NULL, 230546),
(238885, '4q9dA02', NULL, NULL, 163, NULL, NULL, 230546),
(238886, '5dx6B02', NULL, NULL, 169, NULL, NULL, 230546),
(238887, '2nxwA02', NULL, NULL, 161, NULL, NULL, 230546),
(238888, '2panA02', NULL, NULL, 167, NULL, NULL, 230546),
(238889, '6isoK00', NULL, NULL, 227, NULL, NULL, 230546),
(238890, '2c31A02', NULL, NULL, 159, NULL, NULL, 230546),
(238891, '4cokA02', NULL, NULL, 159, NULL, NULL, 230546),
(238892, '2vbfA02', NULL, NULL, 163, NULL, NULL, 230546),
(238893, '2bruC00', NULL, NULL, 167, NULL, NULL, 230546),
(238894, '1ovmA02', NULL, NULL, 170, NULL, NULL, 230546),
(238895, '2vk8A02', NULL, NULL, 164, NULL, NULL, 230546),
(238896, '2uz1A02', NULL, NULL, 180, NULL, NULL, 230546),
(238897, '4k9qA02', NULL, NULL, 162, NULL, NULL, 230546),
(238898, '1v5eA02', NULL, NULL, 165, NULL, NULL, 230546),
(238899, '3u31A01', NULL, NULL, 165, NULL, NULL, 230546),
(238900, '2b4yA01', NULL, NULL, 156, NULL, NULL, 230546),
(238901, '4bn4A01', NULL, NULL, 176, NULL, NULL, 230546),
(238902, '2ihtA02', NULL, NULL, 164, NULL, NULL, 230546),
(238903, '4l2iA02', NULL, NULL, 139, NULL, NULL, 230546),
(238904, '2a1uA02', NULL, NULL, 129, NULL, NULL, 230546),
(238905, '2q28A02', NULL, NULL, 158, NULL, NULL, 230546),
(238906, '2vk4A02', NULL, NULL, 164, NULL, NULL, 230546);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(238907, '6hoyA01', NULL, NULL, 204, NULL, NULL, 230546),
(238908, '2hjhB01', NULL, NULL, 215, NULL, NULL, 230546),
(238909, '4twjA01', NULL, NULL, 154, NULL, NULL, 230546),
(238910, '6denA02', NULL, NULL, 180, NULL, NULL, 230546),
(238911, '2jh3A04', NULL, NULL, 78, NULL, NULL, 230547),
(238912, '2g50F03', NULL, NULL, 103, NULL, NULL, 230548),
(238913, '2e28A02', NULL, NULL, 97, NULL, NULL, 230548),
(238914, '4imaA03', NULL, NULL, 103, NULL, NULL, 230548),
(238915, '3gg8C03', NULL, NULL, 97, NULL, NULL, 230548),
(238916, '1e0tA03', NULL, NULL, 99, NULL, NULL, 230548),
(238917, '3qv9A03', NULL, NULL, 101, NULL, NULL, 230548),
(238918, '3g2gA03', NULL, NULL, 65, NULL, NULL, 230548),
(238919, '1a3wA03', NULL, NULL, 102, NULL, NULL, 230548),
(238920, '3khdB03', NULL, NULL, 98, NULL, NULL, 230548),
(238921, '3gr4A03', NULL, NULL, 103, NULL, NULL, 230548),
(238922, '3t05A02', NULL, NULL, 97, NULL, NULL, 230548),
(238923, '3qtgA02', NULL, NULL, 94, NULL, NULL, 230548),
(238924, '1pkyC03', NULL, NULL, 68, NULL, NULL, 230548),
(238925, '3hqnA03', NULL, NULL, 101, NULL, NULL, 230548),
(238926, '4drsA03', NULL, NULL, 97, NULL, NULL, 230548),
(238927, '1yx5A02', NULL, NULL, 41, NULL, NULL, 230549),
(238928, '1uelB00', NULL, NULL, 48, NULL, NULL, 230549),
(238929, '2i5hA02', NULL, NULL, 98, NULL, NULL, 230550),
(238930, '2eduA01', NULL, NULL, 81, NULL, NULL, 230550),
(238931, '4hsaF02', NULL, NULL, 105, NULL, NULL, 230551),
(238932, '4o4oA00', NULL, NULL, 207, NULL, NULL, 230552),
(238933, '2ejqB00', NULL, NULL, 130, NULL, NULL, 230553),
(238934, '3e11A00', NULL, NULL, 114, NULL, NULL, 230553),
(238935, '4fcyB05', NULL, NULL, 46, NULL, NULL, 230554),
(238936, '4n4rB00', NULL, NULL, 151, NULL, NULL, 230555),
(238937, '2r76A00', NULL, NULL, 152, NULL, NULL, 230555),
(238938, '4rh8C00', NULL, NULL, 152, NULL, NULL, 230555),
(238939, '4kwyA00', NULL, NULL, 140, NULL, NULL, 230555),
(238940, '2jxpA01', NULL, NULL, 141, NULL, NULL, 230555),
(238941, '3bf2A00', NULL, NULL, 152, NULL, NULL, 230555),
(238942, '5iv8B00', NULL, NULL, 155, NULL, NULL, 230555),
(238943, '2n8xA00', NULL, NULL, 166, NULL, NULL, 230555),
(238944, '5ixmB00', NULL, NULL, 149, NULL, NULL, 230555),
(238945, '5tseA00', NULL, NULL, 143, NULL, NULL, 230555),
(238946, '1tlyA00', NULL, NULL, 278, NULL, NULL, 230556),
(238947, '2phnA02', NULL, NULL, 95, NULL, NULL, 230557),
(238948, '2eucA00', NULL, NULL, 113, NULL, NULL, 230558),
(238949, '2z14A00', NULL, NULL, 133, NULL, NULL, 230559),
(238950, '2dlaA02', NULL, NULL, 54, NULL, NULL, 230560),
(238951, '4jo7A00', NULL, NULL, 89, NULL, NULL, 230561),
(238952, '3t98B00', NULL, NULL, 93, NULL, NULL, 230561),
(238953, '3egwA02', NULL, NULL, 1202, NULL, NULL, 230562),
(238954, '4akrD02', NULL, NULL, 161, NULL, NULL, 230563),
(238955, '3aa0B02', NULL, NULL, 155, NULL, NULL, 230563),
(238956, '3aa0A02', NULL, NULL, 145, NULL, NULL, 230563),
(238957, '6f1uL02', NULL, NULL, 182, NULL, NULL, 230563),
(238958, '4akrA02', NULL, NULL, 147, NULL, NULL, 230563),
(238959, '6f1uK02', NULL, NULL, 145, NULL, NULL, 230563),
(238960, '3w54B00', NULL, NULL, 266, NULL, NULL, 230564),
(238961, '2doqD00', NULL, NULL, 94, NULL, NULL, 230565),
(238962, '1o5zA01', NULL, NULL, 305, NULL, NULL, 230566),
(238963, '1gqyB02', NULL, NULL, 217, NULL, NULL, 230566),
(238964, '4hv4A02', NULL, NULL, 217, NULL, NULL, 230566),
(238965, '4qdiA02', NULL, NULL, 229, NULL, NULL, 230566),
(238966, '1j6uA02', NULL, NULL, 209, NULL, NULL, 230566),
(238967, '1e8cA02', NULL, NULL, 238, NULL, NULL, 230566),
(238968, '4c12A02', NULL, NULL, 238, NULL, NULL, 230566),
(238969, '2f00A02', NULL, NULL, 217, NULL, NULL, 230566),
(238970, '6cauA02', NULL, NULL, 218, NULL, NULL, 230566),
(238971, '3zm6A02', NULL, NULL, 223, NULL, NULL, 230566),
(238972, '1w78A01', NULL, NULL, 287, NULL, NULL, 230566),
(238973, '3hn7A02', NULL, NULL, 267, NULL, NULL, 230566),
(238974, '4bucA02', NULL, NULL, 204, NULL, NULL, 230566),
(238975, '5vvwA02', NULL, NULL, 219, NULL, NULL, 230566),
(238976, '3nrsA01', NULL, NULL, 302, NULL, NULL, 230566),
(238977, '3zl8A02', NULL, NULL, 226, NULL, NULL, 230566);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(238978, '4bubA02', NULL, NULL, 230, NULL, NULL, 230566),
(238979, '3eagA02', NULL, NULL, 231, NULL, NULL, 230566),
(238980, '2x5oA02', NULL, NULL, 206, NULL, NULL, 230566),
(238981, '1gg4A02', NULL, NULL, 231, NULL, NULL, 230566),
(238982, '3lk7A02', NULL, NULL, 206, NULL, NULL, 230566),
(238983, '4cvkA02', NULL, NULL, 236, NULL, NULL, 230566),
(238984, '2wtzA02', NULL, NULL, 234, NULL, NULL, 230566),
(238985, '2gc5A01', NULL, NULL, 298, NULL, NULL, 230566),
(238986, '2vosA01', NULL, NULL, 315, NULL, NULL, 230566),
(238987, '2jneA00', NULL, NULL, 71, NULL, NULL, 230567),
(238988, '2jrpA01', NULL, NULL, 61, NULL, NULL, 230567),
(238989, '4l9bA01', NULL, NULL, 173, NULL, NULL, 230568),
(238990, '1zruC01', NULL, NULL, 140, NULL, NULL, 230568),
(238991, '3kvpC00', NULL, NULL, 52, NULL, NULL, 230569),
(238992, '5o6uB00', NULL, NULL, 182, NULL, NULL, 230570),
(238993, '2xlkB00', NULL, NULL, 191, NULL, NULL, 230570),
(238994, '4p78C00', NULL, NULL, 66, NULL, NULL, 230571),
(238995, '4c26A00', NULL, NULL, 66, NULL, NULL, 230571),
(238996, '5yrzB00', NULL, NULL, 58, NULL, NULL, 230571),
(238997, '6g26E00', NULL, NULL, 64, NULL, NULL, 230571),
(238998, '1whzA00', NULL, NULL, 70, NULL, NULL, 230571),
(238999, '5gutA03', NULL, NULL, 175, NULL, NULL, 230572),
(239000, '4dovA00', NULL, NULL, 163, NULL, NULL, 230572),
(239001, '4bb7B00', NULL, NULL, 258, NULL, NULL, 230572),
(239002, '5gutA01', NULL, NULL, 139, NULL, NULL, 230572),
(239003, '2fl7A00', NULL, NULL, 232, NULL, NULL, 230572),
(239004, '3ptaA03', NULL, NULL, 180, NULL, NULL, 230572),
(239005, '1m4zA01', NULL, NULL, 210, NULL, NULL, 230572),
(239006, '3ptaA04', NULL, NULL, 213, NULL, NULL, 230572),
(239007, '1w4sA00', NULL, NULL, 149, NULL, NULL, 230572),
(239008, '4ft4B01', NULL, NULL, 166, NULL, NULL, 230572),
(239009, '4jjnK00', NULL, NULL, 214, NULL, NULL, 230572),
(239010, '2doaA00', NULL, NULL, 104, NULL, NULL, 230573),
(239011, '2e5nA00', NULL, NULL, 100, NULL, NULL, 230573),
(239012, '2ph7A01', NULL, NULL, 131, NULL, NULL, 230574),
(239013, '3eayA01', NULL, NULL, 127, NULL, NULL, 230575),
(239014, '1euvA01', NULL, NULL, 105, NULL, NULL, 230575),
(239015, '3k6oA02', NULL, NULL, 138, NULL, NULL, 230576),
(239016, '4pqxA02', NULL, NULL, 137, NULL, NULL, 230576),
(239017, '3k0yA02', NULL, NULL, 146, NULL, NULL, 230576),
(239018, '4j8qA02', NULL, NULL, 126, NULL, NULL, 230576),
(239019, '3qwnA02', NULL, NULL, 136, NULL, NULL, 230576),
(239020, '3e3xA03', NULL, NULL, 95, NULL, NULL, 230577),
(239021, '4zckA03', NULL, NULL, 94, NULL, NULL, 230577),
(239022, '4hfvA01', NULL, NULL, 119, NULL, NULL, 230578),
(239023, '3no8A00', NULL, NULL, 176, NULL, NULL, 230579),
(239024, '3gbwA00', NULL, NULL, 164, NULL, NULL, 230579),
(239025, '3hwjB00', NULL, NULL, 172, NULL, NULL, 230579),
(239026, '4nsmA00', NULL, NULL, 87, NULL, NULL, 230580),
(239027, '1n7dA02', NULL, NULL, 34, NULL, NULL, 230581),
(239028, '1ye9A02', NULL, NULL, 112, NULL, NULL, 230582),
(239029, '3d9xA01', NULL, NULL, 61, NULL, NULL, 230583),
(239030, '2m38A00', NULL, NULL, 153, NULL, NULL, 230584),
(239031, '3ljuX03', NULL, NULL, 131, NULL, NULL, 230584),
(239032, '3ljuX02', NULL, NULL, 111, NULL, NULL, 230584),
(239033, '2dfkC02', NULL, NULL, 155, NULL, NULL, 230584),
(239034, '3so6A00', NULL, NULL, 137, NULL, NULL, 230584),
(239035, '2codA01', NULL, NULL, 96, NULL, NULL, 230584),
(239036, '1wjmA00', NULL, NULL, 123, NULL, NULL, 230584),
(239037, '3pg7A02', NULL, NULL, 110, NULL, NULL, 230584),
(239038, '1h4rA03', NULL, NULL, 91, NULL, NULL, 230584),
(239039, '6bc0A00', NULL, NULL, 150, NULL, NULL, 230584),
(239040, '2ej8B00', NULL, NULL, 160, NULL, NULL, 230584),
(239041, '2dtcA00', NULL, NULL, 126, NULL, NULL, 230584),
(239042, '5njjB00', NULL, NULL, 156, NULL, NULL, 230584),
(239043, '4a6hA00', NULL, NULL, 120, NULL, NULL, 230584),
(239044, '2x18E00', NULL, NULL, 119, NULL, NULL, 230584),
(239045, '2lulA00', NULL, NULL, 164, NULL, NULL, 230584),
(239046, '2yf0A01', NULL, NULL, 98, NULL, NULL, 230584),
(239047, '1kz7C02', NULL, NULL, 158, NULL, NULL, 230584),
(239048, '5umsA02', NULL, NULL, 109, NULL, NULL, 230584);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(239049, '1x11B00', NULL, NULL, 172, NULL, NULL, 230584),
(239050, '1x1fA00', NULL, NULL, 149, NULL, NULL, 230584),
(239051, '1u5dA00', NULL, NULL, 108, NULL, NULL, 230584),
(239052, '1x05A00', NULL, NULL, 129, NULL, NULL, 230584),
(239053, '4khoB02', NULL, NULL, 132, NULL, NULL, 230584),
(239054, '3tfmA02', NULL, NULL, 109, NULL, NULL, 230584),
(239055, '2d9wA01', NULL, NULL, 110, NULL, NULL, 230584),
(239056, '3tfmA01', NULL, NULL, 99, NULL, NULL, 230584),
(239057, '2i5fA00', NULL, NULL, 109, NULL, NULL, 230584),
(239058, '2y7bA00', NULL, NULL, 134, NULL, NULL, 230584),
(239059, '5u78C00', NULL, NULL, 123, NULL, NULL, 230584),
(239060, '2kcjA00', NULL, NULL, 108, NULL, NULL, 230584),
(239061, '4d0nB02', NULL, NULL, 128, NULL, NULL, 230584),
(239062, '3f5rA00', NULL, NULL, 113, NULL, NULL, 230584),
(239063, '2zpyA03', NULL, NULL, 91, NULL, NULL, 230584),
(239064, '3hk0B02', NULL, NULL, 163, NULL, NULL, 230584),
(239065, '2ec1A00', NULL, NULL, 125, NULL, NULL, 230584),
(239066, '1v61A00', NULL, NULL, 132, NULL, NULL, 230584),
(239067, '1x1gA00', NULL, NULL, 129, NULL, NULL, 230584),
(239068, '1ntvA00', NULL, NULL, 152, NULL, NULL, 230584),
(239069, '3p6aB02', NULL, NULL, 143, NULL, NULL, 230584),
(239070, '2ys3A00', NULL, NULL, 137, NULL, NULL, 230584),
(239071, '1maiA00', NULL, NULL, 131, NULL, NULL, 230584),
(239072, '1fhoA00', NULL, NULL, 119, NULL, NULL, 230584),
(239073, '5c79A00', NULL, NULL, 118, NULL, NULL, 230584),
(239074, '1upqA00', NULL, NULL, 123, NULL, NULL, 230584),
(239075, '1v5mA00', NULL, NULL, 136, NULL, NULL, 230584),
(239076, '1wi1A01', NULL, NULL, 111, NULL, NULL, 230584),
(239077, '1ddwA00', NULL, NULL, 120, NULL, NULL, 230584),
(239078, '5zz9A00', NULL, NULL, 123, NULL, NULL, 230584),
(239079, '3sv1B00', NULL, NULL, 169, NULL, NULL, 230584),
(239080, '1faoA00', NULL, NULL, 126, NULL, NULL, 230584),
(239081, '1btnA00', NULL, NULL, 106, NULL, NULL, 230584),
(239082, '1x11A00', NULL, NULL, 172, NULL, NULL, 230584),
(239083, '6bnmA00', NULL, NULL, 162, NULL, NULL, 230584),
(239084, '1unqA00', NULL, NULL, 125, NULL, NULL, 230584),
(239085, '1qqgA01', NULL, NULL, 111, NULL, NULL, 230584),
(239086, '3fssA02', NULL, NULL, 86, NULL, NULL, 230584),
(239087, '1v89A00', NULL, NULL, 118, NULL, NULL, 230584),
(239088, '3hqcA00', NULL, NULL, 157, NULL, NULL, 230584),
(239089, '2fjlA00', NULL, NULL, 150, NULL, NULL, 230584),
(239090, '3ml4A02', NULL, NULL, 110, NULL, NULL, 230584),
(239091, '1xkeA00', NULL, NULL, 130, NULL, NULL, 230584),
(239092, '1v5pA01', NULL, NULL, 103, NULL, NULL, 230584),
(239093, '5cllB00', NULL, NULL, 167, NULL, NULL, 230584),
(239094, '5l81B00', NULL, NULL, 150, NULL, NULL, 230584),
(239095, '3au4A04', NULL, NULL, 105, NULL, NULL, 230584),
(239096, '4hdoA03', NULL, NULL, 102, NULL, NULL, 230584),
(239097, '4k81A02', NULL, NULL, 162, NULL, NULL, 230584),
(239098, '1fgyA00', NULL, NULL, 127, NULL, NULL, 230584),
(239099, '6d2kA03', NULL, NULL, 96, NULL, NULL, 230584),
(239100, '2kupA01', NULL, NULL, 91, NULL, NULL, 230584),
(239101, '3mpxA02', NULL, NULL, 102, NULL, NULL, 230584),
(239102, '6ibeA03', NULL, NULL, 95, NULL, NULL, 230584),
(239103, '3d8dA00', NULL, NULL, 148, NULL, NULL, 230584),
(239104, '2dlwA00', NULL, NULL, 113, NULL, NULL, 230584),
(239105, '2dx5A00', NULL, NULL, 139, NULL, NULL, 230584),
(239106, '4gzuB03', NULL, NULL, 104, NULL, NULL, 230584),
(239107, '4iapA01', NULL, NULL, 96, NULL, NULL, 230584),
(239108, '2d9vA01', NULL, NULL, 108, NULL, NULL, 230584),
(239109, '2adzA01', NULL, NULL, 109, NULL, NULL, 230584),
(239110, '1j0wB00', NULL, NULL, 103, NULL, NULL, 230584),
(239111, '1wguA01', NULL, NULL, 115, NULL, NULL, 230584),
(239112, '1eazA00', NULL, NULL, 125, NULL, NULL, 230584),
(239113, '1q67A01', NULL, NULL, 140, NULL, NULL, 230584),
(239114, '1wvhA00', NULL, NULL, 134, NULL, NULL, 230584),
(239115, '4pq0A02', NULL, NULL, 102, NULL, NULL, 230584),
(239116, '2y8gB00', NULL, NULL, 138, NULL, NULL, 230584),
(239117, '6bcbA00', NULL, NULL, 146, NULL, NULL, 230584),
(239118, '1p6sA00', NULL, NULL, 111, NULL, NULL, 230584),
(239119, '2rloA00', NULL, NULL, 128, NULL, NULL, 230584);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(239120, '4bbkA00', NULL, NULL, 140, NULL, NULL, 230584),
(239121, '3pvlA04', NULL, NULL, 99, NULL, NULL, 230584),
(239122, '1tqzA01', NULL, NULL, 123, NULL, NULL, 230584),
(239123, '2lydA00', NULL, NULL, 134, NULL, NULL, 230584),
(239124, '5efxA00', NULL, NULL, 144, NULL, NULL, 230584),
(239125, '4b6hA00', NULL, NULL, 134, NULL, NULL, 230584),
(239126, '5c16A01', NULL, NULL, 100, NULL, NULL, 230584),
(239127, '2cofA00', NULL, NULL, 107, NULL, NULL, 230584),
(239128, '4l6eA00', NULL, NULL, 126, NULL, NULL, 230584),
(239129, '3ulbA01', NULL, NULL, 92, NULL, NULL, 230584),
(239130, '2dyqA00', NULL, NULL, 144, NULL, NULL, 230584),
(239131, '1mi1A01', NULL, NULL, 105, NULL, NULL, 230584),
(239132, '1foeC02', NULL, NULL, 161, NULL, NULL, 230584),
(239133, '4chmB00', NULL, NULL, 126, NULL, NULL, 230584),
(239134, '1zsqA01', NULL, NULL, 101, NULL, NULL, 230584),
(239135, '1y5oA00', NULL, NULL, 115, NULL, NULL, 230584),
(239136, '6cb0B03', NULL, NULL, 119, NULL, NULL, 230584),
(239137, '2w2xC00', NULL, NULL, 124, NULL, NULL, 230584),
(239138, '4yl8A03', NULL, NULL, 97, NULL, NULL, 230584),
(239139, '5d3xB00', NULL, NULL, 167, NULL, NULL, 230584),
(239140, '6d2qA03', NULL, NULL, 96, NULL, NULL, 230584),
(239141, '4ioyX02', NULL, NULL, 115, NULL, NULL, 230584),
(239142, '1w1hD00', NULL, NULL, 151, NULL, NULL, 230584),
(239143, '4gn1C02', NULL, NULL, 163, NULL, NULL, 230584),
(239144, '1u29A00', NULL, NULL, 129, NULL, NULL, 230584),
(239145, '5ncgA00', NULL, NULL, 113, NULL, NULL, 230584),
(239146, '1xodB00', NULL, NULL, 118, NULL, NULL, 230584),
(239147, '5a3fC03', NULL, NULL, 123, NULL, NULL, 230584),
(239148, '2j59N00', NULL, NULL, 135, NULL, NULL, 230584),
(239149, '2dkpA01', NULL, NULL, 98, NULL, NULL, 230584),
(239150, '5c5bD02', NULL, NULL, 100, NULL, NULL, 230584),
(239151, '3qwmA00', NULL, NULL, 140, NULL, NULL, 230584),
(239152, '1qc6A00', NULL, NULL, 112, NULL, NULL, 230584),
(239153, '1zc3B00', NULL, NULL, 113, NULL, NULL, 230584),
(239154, '3gypA02', NULL, NULL, 97, NULL, NULL, 230584),
(239155, '3ml4C01', NULL, NULL, 114, NULL, NULL, 230584),
(239156, '2v76B00', NULL, NULL, 107, NULL, NULL, 230584),
(239157, '2pz1A03', NULL, NULL, 121, NULL, NULL, 230584),
(239158, '2dhjA00', NULL, NULL, 125, NULL, NULL, 230584),
(239159, '4f7uP00', NULL, NULL, 129, NULL, NULL, 230584),
(239160, '3a8pB01', NULL, NULL, 133, NULL, NULL, 230584),
(239161, '4kvgB02', NULL, NULL, 170, NULL, NULL, 230584),
(239162, '4tyzA00', NULL, NULL, 110, NULL, NULL, 230584),
(239163, '2q13A02', NULL, NULL, 122, NULL, NULL, 230584),
(239164, '3syxA00', NULL, NULL, 130, NULL, NULL, 230584),
(239165, '2vszB02', NULL, NULL, 117, NULL, NULL, 230584),
(239166, '2hthB00', NULL, NULL, 140, NULL, NULL, 230584),
(239167, '1droA00', NULL, NULL, 122, NULL, NULL, 230584),
(239168, '2crfA01', NULL, NULL, 125, NULL, NULL, 230584),
(239169, '2ys1A00', NULL, NULL, 113, NULL, NULL, 230584),
(239170, '2p8vA00', NULL, NULL, 117, NULL, NULL, 230584),
(239171, '3g9wA02', NULL, NULL, 98, NULL, NULL, 230584),
(239172, '2coaA01', NULL, NULL, 118, NULL, NULL, 230584),
(239173, '4k17D01', NULL, NULL, 115, NULL, NULL, 230584),
(239174, '1wgqA00', NULL, NULL, 109, NULL, NULL, 230584),
(239175, '1zyiA00', NULL, NULL, 116, NULL, NULL, 230584),
(239176, '2oqbA00', NULL, NULL, 117, NULL, NULL, 230584),
(239177, '2d9zA01', NULL, NULL, 122, NULL, NULL, 230584),
(239178, '3rcpA00', NULL, NULL, 103, NULL, NULL, 230584),
(239179, '6d21A03', NULL, NULL, 96, NULL, NULL, 230584),
(239180, '5jhhA02', NULL, NULL, 139, NULL, NULL, 230584),
(239181, '2kuqA00', NULL, NULL, 153, NULL, NULL, 230584),
(239182, '1ntyA02', NULL, NULL, 124, NULL, NULL, 230584),
(239183, '1pfjA00', NULL, NULL, 108, NULL, NULL, 230584),
(239184, '3zvrA03', NULL, NULL, 135, NULL, NULL, 230584),
(239185, '5uklA05', NULL, NULL, 107, NULL, NULL, 230584),
(239186, '1vu2300', NULL, NULL, 127, NULL, NULL, 230584),
(239187, '3ksyA03', NULL, NULL, 112, NULL, NULL, 230584),
(239188, '4gxbA03', NULL, NULL, 118, NULL, NULL, 230584),
(239189, '3oanA00', NULL, NULL, 130, NULL, NULL, 230584),
(239190, '1plsA00', NULL, NULL, 113, NULL, NULL, 230584);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(239191, '1fhwA00', NULL, NULL, 129, NULL, NULL, 230584),
(239192, '3dxeA00', NULL, NULL, 140, NULL, NULL, 230584),
(239193, '2aehA03', NULL, NULL, 111, NULL, NULL, 230584),
(239194, '1v5uA00', NULL, NULL, 117, NULL, NULL, 230584),
(239195, '6am0B01', NULL, NULL, 167, NULL, NULL, 230584),
(239196, '3qbvB02', NULL, NULL, 152, NULL, NULL, 230584),
(239197, '3f0wA00', NULL, NULL, 168, NULL, NULL, 230584),
(239198, '4k17C01', NULL, NULL, 115, NULL, NULL, 230584),
(239199, '4gzuA02', NULL, NULL, 156, NULL, NULL, 230584),
(239200, '3gyoA02', NULL, NULL, 86, NULL, NULL, 230584),
(239201, '2z0qA02', NULL, NULL, 136, NULL, NULL, 230584),
(239202, '2dhkA01', NULL, NULL, 100, NULL, NULL, 230584),
(239203, '4xwxA00', NULL, NULL, 167, NULL, NULL, 230584),
(239204, '2mfqA00', NULL, NULL, 115, NULL, NULL, 230584),
(239205, '5u1mA00', NULL, NULL, 105, NULL, NULL, 230584),
(239206, '4khbB01', NULL, NULL, 95, NULL, NULL, 230584),
(239207, '3wyfE00', NULL, NULL, 194, NULL, NULL, 230584),
(239208, '2cy5A00', NULL, NULL, 140, NULL, NULL, 230584),
(239209, '4ekuA03', NULL, NULL, 107, NULL, NULL, 230584),
(239210, '1u5fA01', NULL, NULL, 110, NULL, NULL, 230584),
(239211, '2dn6A00', NULL, NULL, 115, NULL, NULL, 230584),
(239212, '1mixA02', NULL, NULL, 93, NULL, NULL, 230584),
(239213, '2da0A00', NULL, NULL, 114, NULL, NULL, 230584),
(239214, '2vrwB02', NULL, NULL, 129, NULL, NULL, 230584),
(239215, '3qijB03', NULL, NULL, 93, NULL, NULL, 230584),
(239216, '1p5tA00', NULL, NULL, 110, NULL, NULL, 230584),
(239217, '3voqA00', NULL, NULL, 125, NULL, NULL, 230584),
(239218, '2d9yA00', NULL, NULL, 117, NULL, NULL, 230584),
(239219, '1btkA00', NULL, NULL, 169, NULL, NULL, 230584),
(239220, '5j3tA00', NULL, NULL, 130, NULL, NULL, 230584),
(239221, '2jp2A00', NULL, NULL, 126, NULL, NULL, 230584),
(239222, '3cxbB00', NULL, NULL, 112, NULL, NULL, 230584),
(239223, '4nswA02', NULL, NULL, 122, NULL, NULL, 230584),
(239224, '4k17B01', NULL, NULL, 115, NULL, NULL, 230584),
(239225, '1aqcA00', NULL, NULL, 172, NULL, NULL, 230584),
(239226, '2rgnB02', NULL, NULL, 150, NULL, NULL, 230584),
(239227, '2dhiA00', NULL, NULL, 120, NULL, NULL, 230584),
(239228, '1mkeA00', NULL, NULL, 152, NULL, NULL, 230584),
(239229, '4wsfA00', NULL, NULL, 122, NULL, NULL, 230584),
(239230, '4hatB00', NULL, NULL, 122, NULL, NULL, 230584),
(239231, '1p3rC00', NULL, NULL, 160, NULL, NULL, 230584),
(239232, '1k5dB00', NULL, NULL, 146, NULL, NULL, 230584),
(239233, '1t77A01', NULL, NULL, 105, NULL, NULL, 230584),
(239234, '3aj4A00', NULL, NULL, 112, NULL, NULL, 230584),
(239235, '3pp2A00', NULL, NULL, 124, NULL, NULL, 230584),
(239236, '4emoC00', NULL, NULL, 129, NULL, NULL, 230584),
(239237, '1dbhA02', NULL, NULL, 129, NULL, NULL, 230584),
(239238, '2yryA00', NULL, NULL, 122, NULL, NULL, 230584),
(239239, '1xr0B01', NULL, NULL, 91, NULL, NULL, 230584),
(239240, '4dx8D00', NULL, NULL, 154, NULL, NULL, 230584),
(239241, '1dynA00', NULL, NULL, 125, NULL, NULL, 230584),
(239242, '2cayB00', NULL, NULL, 145, NULL, NULL, 230584),
(239243, '1egxA00', NULL, NULL, 115, NULL, NULL, 230584),
(239244, '5f3yA04', NULL, NULL, 95, NULL, NULL, 230584),
(239245, '1ddvA00', NULL, NULL, 111, NULL, NULL, 230584),
(239246, '4hhvA00', NULL, NULL, 105, NULL, NULL, 230584),
(239247, '4f7hA00', NULL, NULL, 135, NULL, NULL, 230584),
(239248, '1txdA02', NULL, NULL, 152, NULL, NULL, 230584),
(239249, '2lg1A02', NULL, NULL, 115, NULL, NULL, 230584),
(239250, '1aqcB00', NULL, NULL, 172, NULL, NULL, 230584),
(239251, '2p0hA00', NULL, NULL, 129, NULL, NULL, 230584),
(239252, '4k17A01', NULL, NULL, 115, NULL, NULL, 230584),
(239253, '2d9xA01', NULL, NULL, 110, NULL, NULL, 230584),
(239254, '2rovA00', NULL, NULL, 117, NULL, NULL, 230584),
(239255, '5yi7A00', NULL, NULL, 141, NULL, NULL, 230584),
(239256, '4dbbA00', NULL, NULL, 162, NULL, NULL, 230584),
(239257, '2yszA01', NULL, NULL, 136, NULL, NULL, 230584),
(239258, '2cocA01', NULL, NULL, 100, NULL, NULL, 230584),
(239259, '4chjA00', NULL, NULL, 164, NULL, NULL, 230584),
(239260, '4wj7D00', NULL, NULL, 148, NULL, NULL, 230584),
(239261, '2yt0A01', NULL, NULL, 166, NULL, NULL, 230584);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(239262, '2i1jA03', NULL, NULL, 101, NULL, NULL, 230584),
(239263, '5umuA02', NULL, NULL, 128, NULL, NULL, 230584),
(239264, '6hhjA01', NULL, NULL, 113, NULL, NULL, 230584),
(239265, '4k2pD01', NULL, NULL, 130, NULL, NULL, 230584),
(239266, '4ywsA01', NULL, NULL, 125, NULL, NULL, 230585),
(239267, '2o56A01', NULL, NULL, 143, NULL, NULL, 230585),
(239268, '4m0xA01', NULL, NULL, 134, NULL, NULL, 230585),
(239269, '2gl5A01', NULL, NULL, 142, NULL, NULL, 230585),
(239270, '4dwdB01', NULL, NULL, 111, NULL, NULL, 230585),
(239271, '3p0wA01', NULL, NULL, 140, NULL, NULL, 230585),
(239272, '1tkkA01', NULL, NULL, 115, NULL, NULL, 230585),
(239273, '2al1A01', NULL, NULL, 126, NULL, NULL, 230585),
(239274, '3vc5A01', NULL, NULL, 150, NULL, NULL, 230585),
(239275, '3tj4A01', NULL, NULL, 135, NULL, NULL, 230585),
(239276, '1ec7C01', NULL, NULL, 150, NULL, NULL, 230585),
(239277, '3i4kA01', NULL, NULL, 122, NULL, NULL, 230585),
(239278, '3dgbA01', NULL, NULL, 137, NULL, NULL, 230585),
(239279, '6j36A01', NULL, NULL, 129, NULL, NULL, 230585),
(239280, '2pozA01', NULL, NULL, 136, NULL, NULL, 230585),
(239281, '4mggC01', NULL, NULL, 132, NULL, NULL, 230585),
(239282, '3i6tB01', NULL, NULL, 122, NULL, NULL, 230585),
(239283, '2qddA01', NULL, NULL, 140, NULL, NULL, 230585),
(239284, '4ip4A01', NULL, NULL, 129, NULL, NULL, 230585),
(239285, '2nqlA01', NULL, NULL, 168, NULL, NULL, 230585),
(239286, '3r0uA01', NULL, NULL, 117, NULL, NULL, 230585),
(239287, '4kemA01', NULL, NULL, 127, NULL, NULL, 230585),
(239288, '4ropA01', NULL, NULL, 124, NULL, NULL, 230585),
(239289, '3ik4B01', NULL, NULL, 119, NULL, NULL, 230585),
(239290, '1kd0A01', NULL, NULL, 164, NULL, NULL, 230585),
(239291, '3v3wA01', NULL, NULL, 140, NULL, NULL, 230585),
(239292, '2oqhB01', NULL, NULL, 144, NULL, NULL, 230585),
(239293, '3eezA01', NULL, NULL, 140, NULL, NULL, 230585),
(239294, '3boxA01', NULL, NULL, 173, NULL, NULL, 230585),
(239295, '3cawA01', NULL, NULL, 105, NULL, NULL, 230585),
(239296, '3n4eB01', NULL, NULL, 111, NULL, NULL, 230585),
(239297, '3thuB01', NULL, NULL, 142, NULL, NULL, 230585),
(239298, '3tcsB01', NULL, NULL, 113, NULL, NULL, 230585),
(239299, '3jvaA01', NULL, NULL, 114, NULL, NULL, 230585),
(239300, '3vcnA01', NULL, NULL, 141, NULL, NULL, 230585),
(239301, '4hnlA01', NULL, NULL, 148, NULL, NULL, 230585),
(239302, '4jn7A01', NULL, NULL, 119, NULL, NULL, 230585),
(239303, '3sbfA01', NULL, NULL, 148, NULL, NULL, 230585),
(239304, '2xsxB01', NULL, NULL, 128, NULL, NULL, 230585),
(239305, '2chrA01', NULL, NULL, 127, NULL, NULL, 230585),
(239306, '3sszA01', NULL, NULL, 143, NULL, NULL, 230585),
(239307, '4fi4B01', NULL, NULL, 141, NULL, NULL, 230585),
(239308, '3nxlC01', NULL, NULL, 144, NULL, NULL, 230585),
(239309, '1nu5A01', NULL, NULL, 116, NULL, NULL, 230585),
(239310, '1iyxA01', NULL, NULL, 125, NULL, NULL, 230585),
(239311, '3ugvA01', NULL, NULL, 126, NULL, NULL, 230585),
(239312, '5wroA01', NULL, NULL, 133, NULL, NULL, 230585),
(239313, '6nb2A01', NULL, NULL, 125, NULL, NULL, 230585),
(239314, '4a3rA01', NULL, NULL, 125, NULL, NULL, 230585),
(239315, '3mznA01', NULL, NULL, 153, NULL, NULL, 230585),
(239316, '2ovlA01', NULL, NULL, 138, NULL, NULL, 230585),
(239317, '3u4fA01', NULL, NULL, 117, NULL, NULL, 230585),
(239318, '4dwdA01', NULL, NULL, 111, NULL, NULL, 230585),
(239319, '3va8A01', NULL, NULL, 159, NULL, NULL, 230585),
(239320, '3t6cB01', NULL, NULL, 144, NULL, NULL, 230585),
(239321, '1pdzA01', NULL, NULL, 127, NULL, NULL, 230585),
(239322, '3dg6A01', NULL, NULL, 114, NULL, NULL, 230585),
(239323, '2ps2A01', NULL, NULL, 133, NULL, NULL, 230585),
(239324, '4dxkA01', NULL, NULL, 125, NULL, NULL, 230585),
(239325, '4ihcA01', NULL, NULL, 145, NULL, NULL, 230585),
(239326, '1wueB01', NULL, NULL, 149, NULL, NULL, 230585),
(239327, '3zlgA01', NULL, NULL, 125, NULL, NULL, 230585),
(239328, '3qkeA01', NULL, NULL, 142, NULL, NULL, 230585),
(239329, '2ptzA01', NULL, NULL, 124, NULL, NULL, 230585),
(239330, '3fcpA01', NULL, NULL, 136, NULL, NULL, 230585),
(239331, '2rdxA01', NULL, NULL, 142, NULL, NULL, 230585),
(239332, '2pgeA01', NULL, NULL, 136, NULL, NULL, 230585);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(239333, '4gfiC01', NULL, NULL, 107, NULL, NULL, 230585),
(239334, '4mksA01', NULL, NULL, 127, NULL, NULL, 230585),
(239335, '4gypC01', NULL, NULL, 149, NULL, NULL, 230585),
(239336, '3rcyB01', NULL, NULL, 142, NULL, NULL, 230585),
(239337, '1jpdX01', NULL, NULL, 105, NULL, NULL, 230585),
(239338, '4dhgD01', NULL, NULL, 198, NULL, NULL, 230585),
(239339, '4j1oA01', NULL, NULL, 131, NULL, NULL, 230585),
(239340, '2oztA01', NULL, NULL, 129, NULL, NULL, 230585),
(239341, '3cyjA01', NULL, NULL, 135, NULL, NULL, 230585),
(239342, '3vfcA01', NULL, NULL, 156, NULL, NULL, 230585),
(239343, '3gd6A01', NULL, NULL, 142, NULL, NULL, 230585),
(239344, '3n4eA01', NULL, NULL, 111, NULL, NULL, 230585),
(239345, '1r6wA02', NULL, NULL, 124, NULL, NULL, 230585),
(239346, '3tw9A01', NULL, NULL, 145, NULL, NULL, 230585),
(239347, '1mucA01', NULL, NULL, 137, NULL, NULL, 230585),
(239348, '3my9A01', NULL, NULL, 120, NULL, NULL, 230585),
(239349, '4j3zB01', NULL, NULL, 134, NULL, NULL, 230585),
(239350, '3t9pA01', NULL, NULL, 114, NULL, NULL, 230585),
(239351, '2gdqA01', NULL, NULL, 109, NULL, NULL, 230585),
(239352, '2podB01', NULL, NULL, 133, NULL, NULL, 230585),
(239353, '3ozyA01', NULL, NULL, 146, NULL, NULL, 230585),
(239354, '3gc2A01', NULL, NULL, 124, NULL, NULL, 230585),
(239355, '1sjdB01', NULL, NULL, 131, NULL, NULL, 230585),
(239356, '4jhmA01', NULL, NULL, 120, NULL, NULL, 230585),
(239357, '3otrA01', NULL, NULL, 132, NULL, NULL, 230585),
(239358, '2ox4A01', NULL, NULL, 140, NULL, NULL, 230585),
(239359, '4g7fA01', NULL, NULL, 124, NULL, NULL, 230585),
(239360, '2qq6B01', NULL, NULL, 118, NULL, NULL, 230585),
(239361, '2p8bA01', NULL, NULL, 134, NULL, NULL, 230585),
(239362, '4k8gA01', NULL, NULL, 141, NULL, NULL, 230585),
(239363, '4dyeA01', NULL, NULL, 135, NULL, NULL, 230585),
(239364, '4e5tE01', NULL, NULL, 129, NULL, NULL, 230585),
(239365, '3sqsA01', NULL, NULL, 143, NULL, NULL, 230585),
(239366, '3u9iA01', NULL, NULL, 118, NULL, NULL, 230585),
(239367, '4hpnA01', NULL, NULL, 114, NULL, NULL, 230585),
(239368, '2hxtA01', NULL, NULL, 131, NULL, NULL, 230585),
(239369, '2zc8A01', NULL, NULL, 139, NULL, NULL, 230585),
(239370, '1r0mA01', NULL, NULL, 145, NULL, NULL, 230585),
(239371, '2psnA01', NULL, NULL, 127, NULL, NULL, 230585),
(239372, '2og9A01', NULL, NULL, 160, NULL, NULL, 230585),
(239373, '4hchA01', NULL, NULL, 119, NULL, NULL, 230585),
(239374, '2hzgB01', NULL, NULL, 153, NULL, NULL, 230585),
(239375, '2fymA01', NULL, NULL, 125, NULL, NULL, 230585),
(239376, '4il2A01', NULL, NULL, 139, NULL, NULL, 230585),
(239377, '3ekgA01', NULL, NULL, 162, NULL, NULL, 230585),
(239378, '4e4uA01', NULL, NULL, 157, NULL, NULL, 230585),
(239379, '4hn8B01', NULL, NULL, 174, NULL, NULL, 230585),
(239380, '4g8tA01', NULL, NULL, 150, NULL, NULL, 230585),
(239381, '3ro6C01', NULL, NULL, 115, NULL, NULL, 230585),
(239382, '3q45A01', NULL, NULL, 126, NULL, NULL, 230585),
(239383, '6o4nA01', NULL, NULL, 125, NULL, NULL, 230585),
(239384, '5olcA01', NULL, NULL, 122, NULL, NULL, 230585),
(239385, '3rr1A01', NULL, NULL, 141, NULL, NULL, 230585),
(239386, '3qn3A01', NULL, NULL, 124, NULL, NULL, 230585),
(239387, '2pa6A01', NULL, NULL, 124, NULL, NULL, 230585),
(239388, '2pgwA01', NULL, NULL, 163, NULL, NULL, 230585),
(239389, '4h1zF01', NULL, NULL, 167, NULL, NULL, 230585),
(239390, '3qtpB01', NULL, NULL, 130, NULL, NULL, 230585),
(239391, '5boeB01', NULL, NULL, 128, NULL, NULL, 230585),
(239392, '4h2hA01', NULL, NULL, 139, NULL, NULL, 230585),
(239393, '3tjiA01', NULL, NULL, 146, NULL, NULL, 230585),
(239394, '3ijlA01', NULL, NULL, 109, NULL, NULL, 230585),
(239395, '2qdeA01', NULL, NULL, 158, NULL, NULL, 230585),
(239396, '1kkoA01', NULL, NULL, 164, NULL, NULL, 230585),
(239397, '4it1B01', NULL, NULL, 153, NULL, NULL, 230585),
(239398, '3qldB01', NULL, NULL, 157, NULL, NULL, 230585),
(239399, '3t4wA01', NULL, NULL, 157, NULL, NULL, 230585),
(239400, '3sjnA01', NULL, NULL, 120, NULL, NULL, 230585),
(239401, '2akzA01', NULL, NULL, 126, NULL, NULL, 230585),
(239402, '3tqpA01', NULL, NULL, 125, NULL, NULL, 230585),
(239403, '3mkcA01', NULL, NULL, 157, NULL, NULL, 230585);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(239404, '3go2A01', NULL, NULL, 115, NULL, NULL, 230585),
(239405, '3mwcA01', NULL, NULL, 147, NULL, NULL, 230585),
(239406, '5xd7A01', NULL, NULL, 136, NULL, NULL, 230585),
(239407, '2p0iB01', NULL, NULL, 167, NULL, NULL, 230585),
(239408, '3bjsA01', NULL, NULL, 120, NULL, NULL, 230585),
(239409, '2i5qA01', NULL, NULL, 174, NULL, NULL, 230585),
(239410, '4gghA01', NULL, NULL, 144, NULL, NULL, 230585),
(239411, '1bqgA01', NULL, NULL, 161, NULL, NULL, 230585),
(239412, '4hyrB01', NULL, NULL, 153, NULL, NULL, 230585),
(239413, '4h83F01', NULL, NULL, 133, NULL, NULL, 230585),
(239414, '2pp0A01', NULL, NULL, 147, NULL, NULL, 230585),
(239415, '2oz8A01', NULL, NULL, 137, NULL, NULL, 230585),
(239416, '4e4fA01', NULL, NULL, 141, NULL, NULL, 230585),
(239417, '2opjA01', NULL, NULL, 102, NULL, NULL, 230585),
(239418, '3stpA01', NULL, NULL, 142, NULL, NULL, 230585),
(239419, '2zadA01', NULL, NULL, 115, NULL, NULL, 230585),
(239420, '2qgyB01', NULL, NULL, 153, NULL, NULL, 230585),
(239421, '3ddmA01', NULL, NULL, 154, NULL, NULL, 230585),
(239422, '4a35A01', NULL, NULL, 134, NULL, NULL, 230585),
(239423, '3v5cA01', NULL, NULL, 129, NULL, NULL, 230585),
(239424, '2oktA01', NULL, NULL, 128, NULL, NULL, 230585),
(239425, '3mqtA01', NULL, NULL, 157, NULL, NULL, 230585),
(239426, '1wufA01', NULL, NULL, 131, NULL, NULL, 230585),
(239427, '3uj2A01', NULL, NULL, 125, NULL, NULL, 230585),
(239428, '3fv9C01', NULL, NULL, 143, NULL, NULL, 230585),
(239429, '3s47A01', NULL, NULL, 148, NULL, NULL, 230585),
(239430, '3i6eA01', NULL, NULL, 122, NULL, NULL, 230585),
(239431, '3t8qB01', NULL, NULL, 116, NULL, NULL, 230585),
(239432, '3toyA01', NULL, NULL, 127, NULL, NULL, 230585),
(239433, '1tzzB01', NULL, NULL, 132, NULL, NULL, 230585),
(239434, '3pfrA01', NULL, NULL, 156, NULL, NULL, 230585),
(239435, '3dipA01', NULL, NULL, 136, NULL, NULL, 230585),
(239436, '1yeyD01', NULL, NULL, 182, NULL, NULL, 230585),
(239437, '4x2pA01', NULL, NULL, 126, NULL, NULL, 230585),
(239438, '3s5sA01', NULL, NULL, 120, NULL, NULL, 230585),
(239439, '3m71A00', NULL, NULL, 314, NULL, NULL, 230586),
(239440, '5meyA00', NULL, NULL, 135, NULL, NULL, 230587),
(239441, '5nm9B00', NULL, NULL, 143, NULL, NULL, 230587),
(239442, '5od6A00', NULL, NULL, 128, NULL, NULL, 230587),
(239443, '3kmpB00', NULL, NULL, 124, NULL, NULL, 230587),
(239444, '4hl6A02', NULL, NULL, 92, NULL, NULL, 230588),
(239445, '4ed9A02', NULL, NULL, 92, NULL, NULL, 230588),
(239446, '1xk7A02', NULL, NULL, 103, NULL, NULL, 230588),
(239447, '2yimA02', NULL, NULL, 89, NULL, NULL, 230588),
(239448, '2vjqA02', NULL, NULL, 97, NULL, NULL, 230588),
(239449, '3ubmA02', NULL, NULL, 97, NULL, NULL, 230588),
(239450, '2g04A02', NULL, NULL, 89, NULL, NULL, 230588),
(239451, '1q7eA02', NULL, NULL, 97, NULL, NULL, 230588),
(239452, '2riqA01', NULL, NULL, 76, NULL, NULL, 230589),
(239453, '3eziA00', NULL, NULL, 107, NULL, NULL, 230590),
(239454, '4am6A03', NULL, NULL, 258, NULL, NULL, 230591),
(239455, '2xgjA03', NULL, NULL, 215, NULL, NULL, 230592),
(239456, '2zj8A03', NULL, NULL, 233, NULL, NULL, 230592),
(239457, '2va8A03', NULL, NULL, 222, NULL, NULL, 230592),
(239458, '2p6rA03', NULL, NULL, 218, NULL, NULL, 230592),
(239459, '4a4zA03', NULL, NULL, 229, NULL, NULL, 230592),
(239460, '3l9fA02', NULL, NULL, 81, NULL, NULL, 230593),
(239461, '5cecA02', NULL, NULL, 171, NULL, NULL, 230594),
(239462, '5cerG02', NULL, NULL, 163, NULL, NULL, 230594),
(239463, '3a3dA02', NULL, NULL, 102, NULL, NULL, 230594),
(239464, '2ex2A02', NULL, NULL, 103, NULL, NULL, 230594),
(239465, '1w5dA02', NULL, NULL, 102, NULL, NULL, 230594),
(239466, '1w79A02', NULL, NULL, 105, NULL, NULL, 230594),
(239467, '3m4wE01', NULL, NULL, 22, NULL, NULL, 230595),
(239468, '3ikmA04', NULL, NULL, 24, NULL, NULL, 230595),
(239469, '2im9A01', NULL, NULL, 125, NULL, NULL, 230596),
(239470, '2p1gA01', NULL, NULL, 139, NULL, NULL, 230596),
(239471, '4q68A01', NULL, NULL, 138, NULL, NULL, 230596),
(239472, '4m0mA04', NULL, NULL, 119, NULL, NULL, 230597),
(239473, '1wjxA00', NULL, NULL, 122, NULL, NULL, 230598),
(239474, '1p6vA00', NULL, NULL, 130, NULL, NULL, 230598); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(239475, '3lmmC04', NULL, NULL, 87, NULL, NULL, 230599),
(239476, '6om4A01', NULL, NULL, 90, NULL, NULL, 230600),
(239477, '3fp5A00', NULL, NULL, 106, NULL, NULL, 230601),
(239478, '3ivfA03', NULL, NULL, 110, NULL, NULL, 230601),
(239479, '1mixA01', NULL, NULL, 98, NULL, NULL, 230601),
(239480, '3qijA02', NULL, NULL, 106, NULL, NULL, 230601),
(239481, '3flvA00', NULL, NULL, 98, NULL, NULL, 230601),
(239482, '2lbbA00', NULL, NULL, 96, NULL, NULL, 230601),
(239483, '5f3yA03', NULL, NULL, 117, NULL, NULL, 230601),
(239484, '4hdoA02', NULL, NULL, 119, NULL, NULL, 230601),
(239485, '1h4rA02', NULL, NULL, 117, NULL, NULL, 230601),
(239486, '6cb0B02', NULL, NULL, 125, NULL, NULL, 230601),
(239487, '5ijmA00', NULL, NULL, 106, NULL, NULL, 230601),
(239488, '2copA00', NULL, NULL, 109, NULL, NULL, 230601),
(239489, '1ni2A02', NULL, NULL, 117, NULL, NULL, 230601),
(239490, '4yl8A02', NULL, NULL, 116, NULL, NULL, 230601),
(239491, '2cquA00', NULL, NULL, 116, NULL, NULL, 230601),
(239492, '5h3iD00', NULL, NULL, 95, NULL, NULL, 230601),
(239493, '5h3gA00', NULL, NULL, 94, NULL, NULL, 230601),
(239494, '2zpyA02', NULL, NULL, 117, NULL, NULL, 230601),
(239495, '6d2kA02', NULL, NULL, 104, NULL, NULL, 230601),
(239496, '6d2qA02', NULL, NULL, 104, NULL, NULL, 230601),
(239497, '6ibeA02', NULL, NULL, 108, NULL, NULL, 230601),
(239498, '3epyA00', NULL, NULL, 89, NULL, NULL, 230601),
(239499, '3g9wA01', NULL, NULL, 99, NULL, NULL, 230601),
(239500, '1hb6A00', NULL, NULL, 86, NULL, NULL, 230601),
(239501, '2wh5A00', NULL, NULL, 106, NULL, NULL, 230601),
(239502, '1st7A00', NULL, NULL, 86, NULL, NULL, 230601),
(239503, '6d21A02', NULL, NULL, 104, NULL, NULL, 230601),
(239504, '3au5A03', NULL, NULL, 141, NULL, NULL, 230601),
(239505, '2i1jA02', NULL, NULL, 117, NULL, NULL, 230601),
(239506, '2cb8A00', NULL, NULL, 87, NULL, NULL, 230601),
(239507, '3pvlA03', NULL, NULL, 118, NULL, NULL, 230601),
(239508, '1hbkA00', NULL, NULL, 89, NULL, NULL, 230601),
(239509, '4ekuA02', NULL, NULL, 124, NULL, NULL, 230601),
(239510, '4h63H01', NULL, NULL, 74, NULL, NULL, 230602),
(239511, '1yqeA02', NULL, NULL, 96, NULL, NULL, 230603),
(239512, '2gfqA02', NULL, NULL, 89, NULL, NULL, 230603),
(239513, '3epuB01', NULL, NULL, 23, NULL, NULL, 230604),
(239514, '4nc7A00', NULL, NULL, 81, NULL, NULL, 230605),
(239515, '3c6aA00', NULL, NULL, 206, NULL, NULL, 230606),
(239516, '3cpeA03', NULL, NULL, 213, NULL, NULL, 230606),
(239517, '5c15A00', NULL, NULL, 241, NULL, NULL, 230606),
(239518, '5m1pB00', NULL, NULL, 191, NULL, NULL, 230606),
(239519, '3mlgA00', NULL, NULL, 189, NULL, NULL, 230607),
(239520, '3k8pC02', NULL, NULL, 192, NULL, NULL, 230608),
(239521, '2e1mB02', NULL, NULL, 46, NULL, NULL, 230609),
(239522, '2gd5C00', NULL, NULL, 179, NULL, NULL, 230610),
(239523, '2gd5B00', NULL, NULL, 179, NULL, NULL, 230610),
(239524, '2gd5D00', NULL, NULL, 179, NULL, NULL, 230610),
(239525, '2gd5A00', NULL, NULL, 179, NULL, NULL, 230610),
(239526, '4cgyB01', NULL, NULL, 59, NULL, NULL, 230611),
(239527, '3nbiA01', NULL, NULL, 62, NULL, NULL, 230611),
(239528, '3htkC01', NULL, NULL, 213, NULL, NULL, 230612),
(239529, '3n72A00', NULL, NULL, 164, NULL, NULL, 230613),
(239530, '1usuB00', NULL, NULL, 145, NULL, NULL, 230613),
(239531, '4uhvA01', NULL, NULL, 196, NULL, NULL, 230614),
(239532, '2p5zX01', NULL, NULL, 185, NULL, NULL, 230614),
(239533, '5u89B00', NULL, NULL, 83, NULL, NULL, 230615),
(239534, '2khrA00', NULL, NULL, 74, NULL, NULL, 230615),
(239535, '1gh9A00', NULL, NULL, 71, NULL, NULL, 230615),
(239536, '5ja1B00', NULL, NULL, 74, NULL, NULL, 230615),
(239537, '4gr5C01', NULL, NULL, 68, NULL, NULL, 230615),
(239538, '2pstX00', NULL, NULL, 74, NULL, NULL, 230615),
(239539, '5wmmB00', NULL, NULL, 70, NULL, NULL, 230615),
(239540, '2myyA00', NULL, NULL, 80, NULL, NULL, 230615),
(239541, '1to6A01', NULL, NULL, 142, NULL, NULL, 230616),
(239542, '3cwcB01', NULL, NULL, 148, NULL, NULL, 230616),
(239543, '1m0dA00', NULL, NULL, 138, NULL, NULL, 230617),
(239544, '2fokA03', NULL, NULL, 175, NULL, NULL, 230617),
(239545, '3caeA00', NULL, NULL, 132, NULL, NULL, 230617);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(239546, '2hw2A00', NULL, NULL, 143, NULL, NULL, 230618),
(239547, '3bpqA00', NULL, NULL, 52, NULL, NULL, 230619),
(239548, '2g5dA03', NULL, NULL, 62, NULL, NULL, 230620),
(239549, '4dmgA01', NULL, NULL, 72, NULL, NULL, 230621),
(239550, '3zv0C01', NULL, NULL, 170, NULL, NULL, 230621),
(239551, '2b78A01', NULL, NULL, 66, NULL, NULL, 230621),
(239552, '1sgvA02', NULL, NULL, 63, NULL, NULL, 230621),
(239553, '2cx0A02', NULL, NULL, 83, NULL, NULL, 230621),
(239554, '3u28A01', NULL, NULL, 143, NULL, NULL, 230621),
(239555, '1sqwA02', NULL, NULL, 95, NULL, NULL, 230621),
(239556, '1r3eA02', NULL, NULL, 88, NULL, NULL, 230621),
(239557, '2ey4B01', NULL, NULL, 129, NULL, NULL, 230621),
(239558, '1wxxA01', NULL, NULL, 66, NULL, NULL, 230621),
(239559, '1q7hA02', NULL, NULL, 86, NULL, NULL, 230621),
(239560, '2apoA01', NULL, NULL, 104, NULL, NULL, 230621),
(239561, '2j5vA02', NULL, NULL, 94, NULL, NULL, 230621),
(239562, '3vseA01', NULL, NULL, 69, NULL, NULL, 230621),
(239563, '3d79A02', NULL, NULL, 94, NULL, NULL, 230621),
(239564, '3c0kA01', NULL, NULL, 72, NULL, NULL, 230621),
(239565, '2ausA01', NULL, NULL, 130, NULL, NULL, 230621),
(239566, '1iq8A04', NULL, NULL, 78, NULL, NULL, 230621),
(239567, '2q07A03', NULL, NULL, 76, NULL, NULL, 230621),
(239568, '1r3fA02', NULL, NULL, 65, NULL, NULL, 230621),
(239569, '4q1tA02', NULL, NULL, 103, NULL, NULL, 230621),
(239570, '2as0A01', NULL, NULL, 71, NULL, NULL, 230621),
(239571, '2p38A02', NULL, NULL, 72, NULL, NULL, 230621),
(239572, '1yhpA02', NULL, NULL, 120, NULL, NULL, 230622),
(239573, '4gh9A02', NULL, NULL, 52, NULL, NULL, 230623),
(239574, '3l29A02', NULL, NULL, 52, NULL, NULL, 230623),
(239575, '3fkeA02', NULL, NULL, 52, NULL, NULL, 230623),
(239576, '3l2aA02', NULL, NULL, 52, NULL, NULL, 230623),
(239577, '2ok2A03', NULL, NULL, 32, NULL, NULL, 230624),
(239578, '3h7rA00', NULL, NULL, 307, NULL, NULL, 230625),
(239579, '5az0A00', NULL, NULL, 353, NULL, NULL, 230625),
(239580, '4gacB00', NULL, NULL, 324, NULL, NULL, 230625),
(239581, '3erpA01', NULL, NULL, 318, NULL, NULL, 230625),
(239582, '4mhbA00', NULL, NULL, 297, NULL, NULL, 230625),
(239583, '2bp1B00', NULL, NULL, 323, NULL, NULL, 230625),
(239584, '3v0sA00', NULL, NULL, 337, NULL, NULL, 230625),
(239585, '2alrA00', NULL, NULL, 324, NULL, NULL, 230625),
(239586, '1c9wA00', NULL, NULL, 315, NULL, NULL, 230625),
(239587, '1mi3A00', NULL, NULL, 322, NULL, NULL, 230625),
(239588, '6hg6A01', NULL, NULL, 317, NULL, NULL, 230625),
(239589, '1ah4A00', NULL, NULL, 315, NULL, NULL, 230625),
(239590, '3n2tA00', NULL, NULL, 332, NULL, NULL, 230625),
(239591, '4otkA00', NULL, NULL, 276, NULL, NULL, 230625),
(239592, '1frbA00', NULL, NULL, 315, NULL, NULL, 230625),
(239593, '4q3mA00', NULL, NULL, 274, NULL, NULL, 230625),
(239594, '5c7hA00', NULL, NULL, 281, NULL, NULL, 230625),
(239595, '1m9hA00', NULL, NULL, 278, NULL, NULL, 230625),
(239596, '1ynpB01', NULL, NULL, 289, NULL, NULL, 230625),
(239597, '4xznX00', NULL, NULL, 316, NULL, NULL, 230625),
(239598, '1s1pA00', NULL, NULL, 331, NULL, NULL, 230625),
(239599, '5m2fX00', NULL, NULL, 316, NULL, NULL, 230625),
(239600, '5ketB00', NULL, NULL, 340, NULL, NULL, 230625),
(239601, '3h4gA00', NULL, NULL, 325, NULL, NULL, 230625),
(239602, '3wczA00', NULL, NULL, 308, NULL, NULL, 230625),
(239603, '5danA00', NULL, NULL, 274, NULL, NULL, 230625),
(239604, '3up8A00', NULL, NULL, 281, NULL, NULL, 230625),
(239605, '6m7kA00', NULL, NULL, 321, NULL, NULL, 230625),
(239606, '1gveB00', NULL, NULL, 327, NULL, NULL, 230625),
(239607, '1ur3M00', NULL, NULL, 298, NULL, NULL, 230625),
(239608, '2fvlA00', NULL, NULL, 324, NULL, NULL, 230625),
(239609, '1zgdA00', NULL, NULL, 312, NULL, NULL, 230625),
(239610, '3ln3A00', NULL, NULL, 324, NULL, NULL, 230625),
(239611, '3o3rA00', NULL, NULL, 316, NULL, NULL, 230625),
(239612, '4wghA00', NULL, NULL, 283, NULL, NULL, 230625),
(239613, '1afsA00', NULL, NULL, 323, NULL, NULL, 230625),
(239614, '5jgyB00', NULL, NULL, 327, NULL, NULL, 230625),
(239615, '3b3dA00', NULL, NULL, 280, NULL, NULL, 230625),
(239616, '1lqaA00', NULL, NULL, 346, NULL, NULL, 230625);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(239617, '2bgsA00', NULL, NULL, 308, NULL, NULL, 230625),
(239618, '4hbkA00', NULL, NULL, 310, NULL, NULL, 230625),
(239619, '2hejA00', NULL, NULL, 323, NULL, NULL, 230625),
(239620, '2clpI00', NULL, NULL, 322, NULL, NULL, 230625),
(239621, '3h7uA00', NULL, NULL, 312, NULL, NULL, 230625),
(239622, '4wevX00', NULL, NULL, 316, NULL, NULL, 230625),
(239623, '5jh1A00', NULL, NULL, 283, NULL, NULL, 230625),
(239624, '3eauA00', NULL, NULL, 327, NULL, NULL, 230625),
(239625, '1us0A00', NULL, NULL, 316, NULL, NULL, 230625),
(239626, '1q5mA00', NULL, NULL, 322, NULL, NULL, 230625),
(239627, '4r9oC00', NULL, NULL, 301, NULL, NULL, 230625),
(239628, '3krbA00', NULL, NULL, 314, NULL, NULL, 230625),
(239629, '3buvA00', NULL, NULL, 326, NULL, NULL, 230625),
(239630, '1mzrB00', NULL, NULL, 276, NULL, NULL, 230625),
(239631, '5z6uA00', NULL, NULL, 318, NULL, NULL, 230625),
(239632, '1pz1A00', NULL, NULL, 333, NULL, NULL, 230625),
(239633, '4f40A00', NULL, NULL, 288, NULL, NULL, 230625),
(239634, '3o0kA00', NULL, NULL, 263, NULL, NULL, 230625),
(239635, '1pyfA00', NULL, NULL, 312, NULL, NULL, 230625),
(239636, '1zuaX00', NULL, NULL, 317, NULL, NULL, 230625),
(239637, '4ijrA00', NULL, NULL, 344, NULL, NULL, 230625),
(239638, '4exbB00', NULL, NULL, 273, NULL, NULL, 230625),
(239639, '3wbwA00', NULL, NULL, 282, NULL, NULL, 230625),
(239640, '1j96B00', NULL, NULL, 323, NULL, NULL, 230625),
(239641, '1vp5A00', NULL, NULL, 298, NULL, NULL, 230625),
(239642, '3vxgA00', NULL, NULL, 304, NULL, NULL, 230625),
(239643, '5zcmA00', NULL, NULL, 341, NULL, NULL, 230625),
(239644, '3n6qB01', NULL, NULL, 332, NULL, NULL, 230625),
(239645, '1qwkA00', NULL, NULL, 317, NULL, NULL, 230625),
(239646, '4gieA00', NULL, NULL, 290, NULL, NULL, 230625),
(239647, '4xzmX00', NULL, NULL, 316, NULL, NULL, 230625),
(239648, '4xk2B00', NULL, NULL, 344, NULL, NULL, 230625),
(239649, '1vbjA00', NULL, NULL, 281, NULL, NULL, 230625),
(239650, '2wzmA00', NULL, NULL, 283, NULL, NULL, 230625),
(239651, '2c91B00', NULL, NULL, 338, NULL, NULL, 230625),
(239652, '3wg6A00', NULL, NULL, 307, NULL, NULL, 230625),
(239653, '3f7jA00', NULL, NULL, 276, NULL, NULL, 230625),
(239654, '4g2aA02', NULL, NULL, 87, NULL, NULL, 230626),
(239655, '4oe6B02', NULL, NULL, 205, NULL, NULL, 230627),
(239656, '4e3xA02', NULL, NULL, 199, NULL, NULL, 230627),
(239657, '4i8pA02', NULL, NULL, 192, NULL, NULL, 230627),
(239658, '5iuvA02', NULL, NULL, 193, NULL, NULL, 230627),
(239659, '3iwkA02', NULL, NULL, 192, NULL, NULL, 230627),
(239660, '3pqaA02', NULL, NULL, 186, NULL, NULL, 230627),
(239661, '4f3xA02', NULL, NULL, 191, NULL, NULL, 230627),
(239662, '4iymA02', NULL, NULL, 203, NULL, NULL, 230627),
(239663, '5a2dA02', NULL, NULL, 192, NULL, NULL, 230627),
(239664, '3ifgA02', NULL, NULL, 190, NULL, NULL, 230627),
(239665, '3b4wA02', NULL, NULL, 191, NULL, NULL, 230627),
(239666, '3jz4A02', NULL, NULL, 190, NULL, NULL, 230627),
(239667, '4i3vA02', NULL, NULL, 198, NULL, NULL, 230627),
(239668, '3szaA02', NULL, NULL, 195, NULL, NULL, 230627),
(239669, '4zz7A02', NULL, NULL, 203, NULL, NULL, 230627),
(239670, '4qtoA02', NULL, NULL, 194, NULL, NULL, 230627),
(239671, '2d4eA02', NULL, NULL, 197, NULL, NULL, 230627),
(239672, '1uxtA02', NULL, NULL, 198, NULL, NULL, 230627),
(239673, '5mz5A02', NULL, NULL, 189, NULL, NULL, 230627),
(239674, '5fhzA02', NULL, NULL, 190, NULL, NULL, 230627),
(239675, '4ogdA02', NULL, NULL, 190, NULL, NULL, 230627),
(239676, '3rjlA02', NULL, NULL, 191, NULL, NULL, 230627),
(239677, '4h7nA02', NULL, NULL, 191, NULL, NULL, 230627),
(239678, '2impA02', NULL, NULL, 191, NULL, NULL, 230627),
(239679, '3r64A02', NULL, NULL, 203, NULL, NULL, 230627),
(239680, '4cbbA02', NULL, NULL, 194, NULL, NULL, 230627),
(239681, '5mypA02', NULL, NULL, 208, NULL, NULL, 230627),
(239682, '1ad3A02', NULL, NULL, 195, NULL, NULL, 230627),
(239683, '1t90A02', NULL, NULL, 199, NULL, NULL, 230627),
(239684, '1o20A02', NULL, NULL, 149, NULL, NULL, 230627),
(239685, '3etfA02', NULL, NULL, 190, NULL, NULL, 230627),
(239686, '1o9jC02', NULL, NULL, 190, NULL, NULL, 230627),
(239687, '4o5hA02', NULL, NULL, 190, NULL, NULL, 230627);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(239688, '1a4sA02', NULL, NULL, 196, NULL, NULL, 230627),
(239689, '2o2pA02', NULL, NULL, 192, NULL, NULL, 230627),
(239690, '1ag8A02', NULL, NULL, 190, NULL, NULL, 230627),
(239691, '5u0lA02', NULL, NULL, 190, NULL, NULL, 230627),
(239692, '1ez0A02', NULL, NULL, 185, NULL, NULL, 230627),
(239693, '2jg7A02', NULL, NULL, 193, NULL, NULL, 230627),
(239694, '5abmA02', NULL, NULL, 190, NULL, NULL, 230627),
(239695, '5j6bA02', NULL, NULL, 190, NULL, NULL, 230627),
(239696, '6dbbA02', NULL, NULL, 194, NULL, NULL, 230627),
(239697, '4dngA02', NULL, NULL, 183, NULL, NULL, 230627),
(239698, '5j78A02', NULL, NULL, 184, NULL, NULL, 230627),
(239699, '4itaA02', NULL, NULL, 190, NULL, NULL, 230627),
(239700, '5vbfA02', NULL, NULL, 190, NULL, NULL, 230627),
(239701, '3rh9A02', NULL, NULL, 191, NULL, NULL, 230627),
(239702, '1uzbA02', NULL, NULL, 190, NULL, NULL, 230627),
(239703, '4oe5A02', NULL, NULL, 196, NULL, NULL, 230627),
(239704, '3v4cA02', NULL, NULL, 191, NULL, NULL, 230627),
(239705, '4qgkA02', NULL, NULL, 196, NULL, NULL, 230627),
(239706, '2h5gB02', NULL, NULL, 152, NULL, NULL, 230627),
(239707, '3prlA02', NULL, NULL, 193, NULL, NULL, 230627),
(239708, '4jdcA02', NULL, NULL, 198, NULL, NULL, 230627),
(239709, '4ghkB02', NULL, NULL, 154, NULL, NULL, 230627),
(239710, '4pz2A02', NULL, NULL, 193, NULL, NULL, 230627),
(239711, '4nmkA02', NULL, NULL, 189, NULL, NULL, 230627),
(239712, '3k9dA02', NULL, NULL, 185, NULL, NULL, 230627),
(239713, '1bi9D02', NULL, NULL, 190, NULL, NULL, 230627),
(239714, '4knaA02', NULL, NULL, 191, NULL, NULL, 230627),
(239715, '3vz0A02', NULL, NULL, 190, NULL, NULL, 230627),
(239716, '4qf6A02', NULL, NULL, 190, NULL, NULL, 230627),
(239717, '4pxnA02', NULL, NULL, 192, NULL, NULL, 230627),
(239718, '4c3sA02', NULL, NULL, 186, NULL, NULL, 230627),
(239719, '3my7A02', NULL, NULL, 216, NULL, NULL, 230627),
(239720, '5jryA02', NULL, NULL, 190, NULL, NULL, 230627),
(239721, '3i44A02', NULL, NULL, 191, NULL, NULL, 230627),
(239722, '3iwjA02', NULL, NULL, 192, NULL, NULL, 230627),
(239723, '1euhA02', NULL, NULL, 193, NULL, NULL, 230627),
(239724, '4go3A02', NULL, NULL, 193, NULL, NULL, 230627),
(239725, '6qapA02', NULL, NULL, 211, NULL, NULL, 230627),
(239726, '3u4jA02', NULL, NULL, 191, NULL, NULL, 230627),
(239727, '1wndA02', NULL, NULL, 191, NULL, NULL, 230627),
(239728, '4pxlB02', NULL, NULL, 190, NULL, NULL, 230627),
(239729, '1vluB02', NULL, NULL, 161, NULL, NULL, 230627),
(239730, '3ju8A02', NULL, NULL, 191, NULL, NULL, 230627),
(239731, '4i9bA02', NULL, NULL, 193, NULL, NULL, 230627),
(239732, '4qyjA02', NULL, NULL, 192, NULL, NULL, 230627),
(239733, '4lihA02', NULL, NULL, 192, NULL, NULL, 230627),
(239734, '4u3wA02', NULL, NULL, 195, NULL, NULL, 230627),
(239735, '5ucdA02', NULL, NULL, 194, NULL, NULL, 230627),
(239736, '2j6lA02', NULL, NULL, 193, NULL, NULL, 230627),
(239737, '4jbeA02', NULL, NULL, 140, NULL, NULL, 230627),
(239738, '3rosA02', NULL, NULL, 190, NULL, NULL, 230627),
(239739, '5kf0A02', NULL, NULL, 190, NULL, NULL, 230627),
(239740, '1o04A02', NULL, NULL, 190, NULL, NULL, 230627),
(239741, '5l2mA02', NULL, NULL, 190, NULL, NULL, 230627),
(239742, '5jfnA02', NULL, NULL, 187, NULL, NULL, 230627),
(239743, '3qanA02', NULL, NULL, 191, NULL, NULL, 230627),
(239744, '2y5dB02', NULL, NULL, 221, NULL, NULL, 230627),
(239745, '4jz6A02', NULL, NULL, 231, NULL, NULL, 230627),
(239746, '3r31A02', NULL, NULL, 193, NULL, NULL, 230627),
(239747, '3k2wB02', NULL, NULL, 194, NULL, NULL, 230627),
(239748, '5kloA02', NULL, NULL, 195, NULL, NULL, 230627),
(239749, '4yweH02', NULL, NULL, 193, NULL, NULL, 230627),
(239750, '3ty7A02', NULL, NULL, 189, NULL, NULL, 230627),
(239751, '4o6rA02', NULL, NULL, 194, NULL, NULL, 230627),
(239752, '2w8nA02', NULL, NULL, 191, NULL, NULL, 230627),
(239753, '3ek1A02', NULL, NULL, 188, NULL, NULL, 230627),
(239754, '3t7yA00', NULL, NULL, 97, NULL, NULL, 230628),
(239755, '3b1sB00', NULL, NULL, 87, NULL, NULL, 230628),
(239756, '5culB00', NULL, NULL, 79, NULL, NULL, 230628),
(239757, '3bzyB00', NULL, NULL, 83, NULL, NULL, 230628),
(239758, '2jliA00', NULL, NULL, 103, NULL, NULL, 230628);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(239759, '2w0rA00', NULL, NULL, 144, NULL, NULL, 230628),
(239760, '6ejpD00', NULL, NULL, 91, NULL, NULL, 230628),
(239761, '2vt1B00', NULL, NULL, 93, NULL, NULL, 230628),
(239762, '3b0zB00', NULL, NULL, 84, NULL, NULL, 230628),
(239763, '3bzsA00', NULL, NULL, 98, NULL, NULL, 230628),
(239764, '3c01E00', NULL, NULL, 98, NULL, NULL, 230628),
(239765, '2w45A01', NULL, NULL, 126, NULL, NULL, 230629),
(239766, '3fhdA01', NULL, NULL, 136, NULL, NULL, 230629),
(239767, '1xmxA03', NULL, NULL, 89, NULL, NULL, 230630),
(239768, '2jryA00', NULL, NULL, 46, NULL, NULL, 230631),
(239769, '2p4lA00', NULL, NULL, 46, NULL, NULL, 230631),
(239770, '3l0iA01', NULL, NULL, 185, NULL, NULL, 230632),
(239771, '3vygC00', NULL, NULL, 221, NULL, NULL, 230633),
(239772, '4ob0A00', NULL, NULL, 210, NULL, NULL, 230633),
(239773, '3hhtA00', NULL, NULL, 216, NULL, NULL, 230633),
(239774, '4zgjA00', NULL, NULL, 206, NULL, NULL, 230633),
(239775, '3a8gA00', NULL, NULL, 207, NULL, NULL, 230633),
(239776, '1v29A00', NULL, NULL, 220, NULL, NULL, 230633),
(239777, '3qyhA00', NULL, NULL, 205, NULL, NULL, 230633),
(239778, '3tixA02', NULL, NULL, 79, NULL, NULL, 230634),
(239779, '4ackB00', NULL, NULL, 156, NULL, NULL, 230635),
(239780, '4v3iA00', NULL, NULL, 160, NULL, NULL, 230635),
(239781, '3u66A00', NULL, NULL, 183, NULL, NULL, 230635),
(239782, '2m3xC02', NULL, NULL, 69, NULL, NULL, 230636),
(239783, '2vqgA00', NULL, NULL, 99, NULL, NULL, 230637),
(239784, '4ebgA00', NULL, NULL, 101, NULL, NULL, 230638),
(239785, '3i9v900', NULL, NULL, 157, NULL, NULL, 230639),
(239786, '3v42A02', NULL, NULL, 90, NULL, NULL, 230640),
(239787, '3i57A01', NULL, NULL, 75, NULL, NULL, 230641),
(239788, '4mt5A01', NULL, NULL, 72, NULL, NULL, 230641),
(239789, '2m9uA00', NULL, NULL, 89, NULL, NULL, 230642),
(239790, '1ny9A00', NULL, NULL, 94, NULL, NULL, 230643),
(239791, '3irbA01', NULL, NULL, 77, NULL, NULL, 230644),
(239792, '2h8nA00', NULL, NULL, 68, NULL, NULL, 230645),
(239793, '4egcB00', NULL, NULL, 271, NULL, NULL, 230646),
(239794, '2wbtA01', NULL, NULL, 51, NULL, NULL, 230647),
(239795, '1sf9A01', NULL, NULL, 74, NULL, NULL, 230648),
(239796, '2yxyA01', NULL, NULL, 56, NULL, NULL, 230648),
(239797, '4f55A01', NULL, NULL, 80, NULL, NULL, 230649),
(239798, '2hoqA02', NULL, NULL, 79, NULL, NULL, 230650),
(239799, '3w9iA06', NULL, NULL, 102, NULL, NULL, 230651),
(239800, '5t0oA02', NULL, NULL, 103, NULL, NULL, 230651),
(239801, '4mt1A02', NULL, NULL, 103, NULL, NULL, 230651),
(239802, '5enqA04', NULL, NULL, 99, NULL, NULL, 230651),
(239803, '4dx5A06', NULL, NULL, 105, NULL, NULL, 230651),
(239804, '4dx5A02', NULL, NULL, 103, NULL, NULL, 230651),
(239805, '3w9iA02', NULL, NULL, 103, NULL, NULL, 230651),
(239806, '4mt1A06', NULL, NULL, 101, NULL, NULL, 230651),
(239807, '2yufA00', NULL, NULL, 142, NULL, NULL, 230652),
(239808, '2x5iD00', NULL, NULL, 70, NULL, NULL, 230653),
(239809, '1z7s400', NULL, NULL, 68, NULL, NULL, 230653),
(239810, '1bev400', NULL, NULL, 47, NULL, NULL, 230653),
(239811, '1ncqD00', NULL, NULL, 40, NULL, NULL, 230653),
(239812, '4gb3400', NULL, NULL, 68, NULL, NULL, 230653),
(239813, '5osnD00', NULL, NULL, 45, NULL, NULL, 230653),
(239814, '1pvc400', NULL, NULL, 68, NULL, NULL, 230653),
(239815, '1ev1400', NULL, NULL, 68, NULL, NULL, 230653),
(239816, '1pov001', NULL, NULL, 68, NULL, NULL, 230653),
(239817, '1d4m400', NULL, NULL, 68, NULL, NULL, 230653),
(239818, '1oopD00', NULL, NULL, 69, NULL, NULL, 230653),
(239819, '4q4w400', NULL, NULL, 69, NULL, NULL, 230653),
(239820, '1x3aA00', NULL, NULL, 100, NULL, NULL, 230654),
(239821, '4lrtB02', NULL, NULL, 146, NULL, NULL, 230655),
(239822, '2q22A00', NULL, NULL, 139, NULL, NULL, 230655),
(239823, '3mtjA02', NULL, NULL, 178, NULL, NULL, 230655),
(239824, '6fziA02', NULL, NULL, 166, NULL, NULL, 230655),
(239825, '3wb9A02', NULL, NULL, 114, NULL, NULL, 230655),
(239826, '6bdxA02', NULL, NULL, 108, NULL, NULL, 230655),
(239827, '1nvmB02', NULL, NULL, 154, NULL, NULL, 230655),
(239828, '3c8mA02', NULL, NULL, 155, NULL, NULL, 230655),
(239829, '5eesA02', NULL, NULL, 109, NULL, NULL, 230655);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(239830, '1hdgO02', NULL, NULL, 165, NULL, NULL, 230655),
(239831, '4gqaB02', NULL, NULL, 254, NULL, NULL, 230655),
(239832, '3euwA02', NULL, NULL, 222, NULL, NULL, 230655),
(239833, '5einA02', NULL, NULL, 167, NULL, NULL, 230655),
(239834, '3evnA02', NULL, NULL, 206, NULL, NULL, 230655),
(239835, '4dplA02', NULL, NULL, 182, NULL, NULL, 230655),
(239836, '3e9mB02', NULL, NULL, 207, NULL, NULL, 230655),
(239837, '5ld5A02', NULL, NULL, 170, NULL, NULL, 230655),
(239838, '2axqA02', NULL, NULL, 171, NULL, NULL, 230655),
(239839, '1jkfA03', NULL, NULL, 60, NULL, NULL, 230655),
(239840, '6ok4A02', NULL, NULL, 166, NULL, NULL, 230655),
(239841, '1p1jA02', NULL, NULL, 115, NULL, NULL, 230655),
(239842, '6gg7A02', NULL, NULL, 165, NULL, NULL, 230655),
(239843, '3fhlA02', NULL, NULL, 222, NULL, NULL, 230655),
(239844, '3do5A02', NULL, NULL, 145, NULL, NULL, 230655),
(239845, '2hjsA02', NULL, NULL, 184, NULL, NULL, 230655),
(239846, '2nqtA02', NULL, NULL, 165, NULL, NULL, 230655),
(239847, '3e82E02', NULL, NULL, 216, NULL, NULL, 230655),
(239848, '1t4bA02', NULL, NULL, 216, NULL, NULL, 230655),
(239849, '2ep5A02', NULL, NULL, 177, NULL, NULL, 230655),
(239850, '6e08L02', NULL, NULL, 295, NULL, NULL, 230655),
(239851, '1obfO02', NULL, NULL, 164, NULL, NULL, 230655),
(239852, '2vynD02', NULL, NULL, 167, NULL, NULL, 230655),
(239853, '1ys4A02', NULL, NULL, 176, NULL, NULL, 230655),
(239854, '3tz6A02', NULL, NULL, 198, NULL, NULL, 230655),
(239855, '4lsmA02', NULL, NULL, 166, NULL, NULL, 230655),
(239856, '3b1jA02', NULL, NULL, 165, NULL, NULL, 230655),
(239857, '2p2sA02', NULL, NULL, 196, NULL, NULL, 230655),
(239858, '1dpgA02', NULL, NULL, 309, NULL, NULL, 230655),
(239859, '3pymA02', NULL, NULL, 166, NULL, NULL, 230655),
(239860, '4k9dA02', NULL, NULL, 167, NULL, NULL, 230655),
(239861, '3qvsA02', NULL, NULL, 101, NULL, NULL, 230655),
(239862, '3e18A02', NULL, NULL, 221, NULL, NULL, 230655),
(239863, '2x5kP02', NULL, NULL, 165, NULL, NULL, 230655),
(239864, '3qy9A02', NULL, NULL, 105, NULL, NULL, 230655),
(239865, '4ew6A02', NULL, NULL, 192, NULL, NULL, 230655),
(239866, '3dtyB02', NULL, NULL, 211, NULL, NULL, 230655),
(239867, '2h63D02', NULL, NULL, 151, NULL, NULL, 230655),
(239868, '3m2tA02', NULL, NULL, 152, NULL, NULL, 230655),
(239869, '3ijpA02', NULL, NULL, 108, NULL, NULL, 230655),
(239870, '1vm6A02', NULL, NULL, 83, NULL, NULL, 230655),
(239871, '2yv3A02', NULL, NULL, 189, NULL, NULL, 230655),
(239872, '4koaA02', NULL, NULL, 211, NULL, NULL, 230655),
(239873, '3ec7A02', NULL, NULL, 122, NULL, NULL, 230655),
(239874, '3db2B02', NULL, NULL, 212, NULL, NULL, 230655),
(239875, '2r00C02', NULL, NULL, 187, NULL, NULL, 230655),
(239876, '3lvfO02', NULL, NULL, 167, NULL, NULL, 230655),
(239877, '2cvoA02', NULL, NULL, 167, NULL, NULL, 230655),
(239878, '1u8fO02', NULL, NULL, 167, NULL, NULL, 230655),
(239879, '5loaA02', NULL, NULL, 138, NULL, NULL, 230655),
(239880, '2glxA02', NULL, NULL, 211, NULL, NULL, 230655),
(239881, '4wojA02', NULL, NULL, 212, NULL, NULL, 230655),
(239882, '4h3vB02', NULL, NULL, 250, NULL, NULL, 230655),
(239883, '4hadB02', NULL, NULL, 208, NULL, NULL, 230655),
(239884, '2g17A02', NULL, NULL, 160, NULL, NULL, 230655),
(239885, '3cmcO02', NULL, NULL, 165, NULL, NULL, 230655),
(239886, '5o1pA02', NULL, NULL, 174, NULL, NULL, 230655),
(239887, '3ceaC02', NULL, NULL, 192, NULL, NULL, 230655),
(239888, '1b7gO02', NULL, NULL, 184, NULL, NULL, 230655),
(239889, '1p9lA02', NULL, NULL, 107, NULL, NULL, 230655),
(239890, '4xb1A02', NULL, NULL, 134, NULL, NULL, 230655),
(239891, '3u3xA02', NULL, NULL, 199, NULL, NULL, 230655),
(239892, '4ywjA02', NULL, NULL, 108, NULL, NULL, 230655),
(239893, '3v5nD02', NULL, NULL, 206, NULL, NULL, 230655),
(239894, '1vkoA02', NULL, NULL, 113, NULL, NULL, 230655),
(239895, '2ejwA02', NULL, NULL, 149, NULL, NULL, 230655),
(239896, '3mz0A02', NULL, NULL, 123, NULL, NULL, 230655),
(239897, '4p8rA02', NULL, NULL, 166, NULL, NULL, 230655),
(239898, '3f4lA02', NULL, NULL, 223, NULL, NULL, 230655),
(239899, '6bacA02', NULL, NULL, 217, NULL, NULL, 230655),
(239900, '3ohsX02', NULL, NULL, 212, NULL, NULL, 230655);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(239901, '1ydwA02', NULL, NULL, 229, NULL, NULL, 230655),
(239902, '4rl6B02', NULL, NULL, 197, NULL, NULL, 230655),
(239903, '4pg7B02', NULL, NULL, 175, NULL, NULL, 230655),
(239904, '3docA02', NULL, NULL, 165, NULL, NULL, 230655),
(239905, '1xeaA02', NULL, NULL, 203, NULL, NULL, 230655),
(239906, '4miyA02', NULL, NULL, 125, NULL, NULL, 230655),
(239907, '3wgqA02', NULL, NULL, 140, NULL, NULL, 230655),
(239908, '6iqmA02', NULL, NULL, 168, NULL, NULL, 230655),
(239909, '5jw6A02', NULL, NULL, 186, NULL, NULL, 230655),
(239910, '1zh8A02', NULL, NULL, 182, NULL, NULL, 230655),
(239911, '5vmtA02', NULL, NULL, 166, NULL, NULL, 230655),
(239912, '1xygA02', NULL, NULL, 167, NULL, NULL, 230655),
(239913, '5temA02', NULL, NULL, 108, NULL, NULL, 230655),
(239914, '2pkqO02', NULL, NULL, 166, NULL, NULL, 230655),
(239915, '1dssG02', NULL, NULL, 166, NULL, NULL, 230655),
(239916, '3o9zD02', NULL, NULL, 180, NULL, NULL, 230655),
(239917, '6dfzA02', NULL, NULL, 167, NULL, NULL, 230655),
(239918, '4jn6B02', NULL, NULL, 146, NULL, NULL, 230655),
(239919, '1ff9A02', NULL, NULL, 178, NULL, NULL, 230655),
(239920, '3qv1A02', NULL, NULL, 165, NULL, NULL, 230655),
(239921, '3c1aA02', NULL, NULL, 145, NULL, NULL, 230655),
(239922, '2ixaA02', NULL, NULL, 257, NULL, NULL, 230655),
(239923, '3dr3A02', NULL, NULL, 160, NULL, NULL, 230655),
(239924, '6nlxA02', NULL, NULL, 167, NULL, NULL, 230655),
(239925, '4hktA02', NULL, NULL, 211, NULL, NULL, 230655),
(239926, '2g82A02', NULL, NULL, 164, NULL, NULL, 230655),
(239927, '1ebfA02', NULL, NULL, 175, NULL, NULL, 230655),
(239928, '4z0hO02', NULL, NULL, 166, NULL, NULL, 230655),
(239929, '3ingA02', NULL, NULL, 153, NULL, NULL, 230655),
(239930, '5j9gA02', NULL, NULL, 166, NULL, NULL, 230655),
(239931, '1j5pA02', NULL, NULL, 103, NULL, NULL, 230655),
(239932, '1gr0A02', NULL, NULL, 110, NULL, NULL, 230655),
(239933, '4o59O02', NULL, NULL, 167, NULL, NULL, 230655),
(239934, '1gadO02', NULL, NULL, 166, NULL, NULL, 230655),
(239935, '6fzhA02', NULL, NULL, 166, NULL, NULL, 230655),
(239936, '3btvA02', NULL, NULL, 235, NULL, NULL, 230655),
(239937, '3moiA02', NULL, NULL, 206, NULL, NULL, 230655),
(239938, '2czcA02', NULL, NULL, 162, NULL, NULL, 230655),
(239939, '3pzrA02', NULL, NULL, 217, NULL, NULL, 230655),
(239940, '5aq1A02', NULL, NULL, 279, NULL, NULL, 230655),
(239941, '3l0dA02', NULL, NULL, 165, NULL, NULL, 230655),
(239942, '2x0nA02', NULL, NULL, 171, NULL, NULL, 230655),
(239943, '3uuwB02', NULL, NULL, 185, NULL, NULL, 230655),
(239944, '3uw3A02', NULL, NULL, 221, NULL, NULL, 230655),
(239945, '5m6dA02', NULL, NULL, 166, NULL, NULL, 230655),
(239946, '3hjaA02', NULL, NULL, 167, NULL, NULL, 230655),
(239947, '3q2kA02', NULL, NULL, 161, NULL, NULL, 230655),
(239948, '3i23A02', NULL, NULL, 227, NULL, NULL, 230655),
(239949, '3gnqA02', NULL, NULL, 164, NULL, NULL, 230655),
(239950, '3ezyC02', NULL, NULL, 223, NULL, NULL, 230655),
(239951, '3abiB02', NULL, NULL, 177, NULL, NULL, 230655),
(239952, '5y37A02', NULL, NULL, 166, NULL, NULL, 230655),
(239953, '6c85A02', NULL, NULL, 185, NULL, NULL, 230655),
(239954, '3bioB02', NULL, NULL, 114, NULL, NULL, 230655),
(239955, '1dihA02', NULL, NULL, 108, NULL, NULL, 230655),
(239956, '3cpsA02', NULL, NULL, 169, NULL, NULL, 230655),
(239957, '4pg7A02', NULL, NULL, 177, NULL, NULL, 230655),
(239958, '3sthA02', NULL, NULL, 170, NULL, NULL, 230655),
(239959, '4r3nA02', NULL, NULL, 200, NULL, NULL, 230655),
(239960, '3rc2A02', NULL, NULL, 199, NULL, NULL, 230655),
(239961, '2nvwA02', NULL, NULL, 214, NULL, NULL, 230655),
(239962, '1cf2O02', NULL, NULL, 165, NULL, NULL, 230655),
(239963, '2dc1A02', NULL, NULL, 101, NULL, NULL, 230655),
(239964, '3hnpF02', NULL, NULL, 231, NULL, NULL, 230655),
(239965, '4dibA02', NULL, NULL, 165, NULL, NULL, 230655),
(239966, '3ip3A02', NULL, NULL, 211, NULL, NULL, 230655),
(239967, '1i32A02', NULL, NULL, 171, NULL, NULL, 230655),
(239968, '1rm4A02', NULL, NULL, 165, NULL, NULL, 230655),
(239969, '5ur0A02', NULL, NULL, 167, NULL, NULL, 230655),
(239970, '4lgvD02', NULL, NULL, 272, NULL, NULL, 230655),
(239971, '4fb5A02', NULL, NULL, 243, NULL, NULL, 230655);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(239972, '3oqbH02', NULL, NULL, 242, NULL, NULL, 230655),
(239973, '3gdoA02', NULL, NULL, 218, NULL, NULL, 230655),
(239974, '1tltA02', NULL, NULL, 197, NULL, NULL, 230655),
(239975, '2ep7A02', NULL, NULL, 172, NULL, NULL, 230655),
(239976, '1lc0A02', NULL, NULL, 151, NULL, NULL, 230655),
(239977, '6dzsA02', NULL, NULL, 182, NULL, NULL, 230655),
(239978, '5a04A02', NULL, NULL, 173, NULL, NULL, 230655),
(239979, '3oa2A02', NULL, NULL, 185, NULL, NULL, 230655),
(239980, '6jnjA02', NULL, NULL, 192, NULL, NULL, 230655),
(239981, '5c7iO02', NULL, NULL, 167, NULL, NULL, 230655),
(239982, '5kvsA02', NULL, NULL, 162, NULL, NULL, 230655),
(239983, '5gz3A02', NULL, NULL, 140, NULL, NULL, 230655),
(239984, '4ydrA02', NULL, NULL, 137, NULL, NULL, 230655),
(239985, '3cinA02', NULL, NULL, 104, NULL, NULL, 230655),
(239986, '2b4rO02', NULL, NULL, 169, NULL, NULL, 230655),
(239987, '3q2iA02', NULL, NULL, 162, NULL, NULL, 230655),
(239988, '5cefA02', NULL, NULL, 186, NULL, NULL, 230655),
(239989, '3hskA02', NULL, NULL, 187, NULL, NULL, 230655),
(239990, '1h6dA02', NULL, NULL, 190, NULL, NULL, 230655),
(239991, '2yyyA02', NULL, NULL, 168, NULL, NULL, 230655),
(239992, '4zhsA02', NULL, NULL, 185, NULL, NULL, 230655),
(239993, '4iq0C02', NULL, NULL, 198, NULL, NULL, 230655),
(239994, '6a3gA02', NULL, NULL, 255, NULL, NULL, 230655),
(239995, '4f3yA02', NULL, NULL, 108, NULL, NULL, 230655),
(239996, '3kuxA02', NULL, NULL, 204, NULL, NULL, 230655),
(239997, '4inaA02', NULL, NULL, 197, NULL, NULL, 230655),
(239998, '1vknA02', NULL, NULL, 165, NULL, NULL, 230655),
(239999, '3gpdG02', NULL, NULL, 164, NULL, NULL, 230655),
(240000, '5bntA02', NULL, NULL, 217, NULL, NULL, 230655),
(240001, '3h9eO02', NULL, NULL, 167, NULL, NULL, 230655),
(240002, '4mkzA02', NULL, NULL, 193, NULL, NULL, 230655),
(240003, '5yapD02', NULL, NULL, 249, NULL, NULL, 230655),
(240004, '3v1yA02', NULL, NULL, 166, NULL, NULL, 230655),
(240005, '2i5pO02', NULL, NULL, 165, NULL, NULL, 230655),
(240006, '3bioA02', NULL, NULL, 114, NULL, NULL, 230655),
(240007, '1pquA02', NULL, NULL, 218, NULL, NULL, 230655),
(240008, '4pg5A02', NULL, NULL, 180, NULL, NULL, 230655),
(240009, '3idsA02', NULL, NULL, 171, NULL, NULL, 230655),
(240010, '4lt6A03', NULL, NULL, 123, NULL, NULL, 230656),
(240011, '1q79A01', NULL, NULL, 123, NULL, NULL, 230656),
(240012, '1r89A03', NULL, NULL, 134, NULL, NULL, 230656),
(240013, '2hhpA03', NULL, NULL, 170, NULL, NULL, 230656),
(240014, '1udxA03', NULL, NULL, 74, NULL, NULL, 230657),
(240015, '2lsmA00', NULL, NULL, 61, NULL, NULL, 230658),
(240016, '2h6oA02', NULL, NULL, 155, NULL, NULL, 230659),
(240017, '3u2gA01', NULL, NULL, 155, NULL, NULL, 230660),
(240018, '4j8sA00', NULL, NULL, 180, NULL, NULL, 230661),
(240019, '1qh5A00', NULL, NULL, 260, NULL, NULL, 230662),
(240020, '3iogA00', NULL, NULL, 227, NULL, NULL, 230662),
(240021, '5ls3A00', NULL, NULL, 250, NULL, NULL, 230662),
(240022, '2ycbA03', NULL, NULL, 266, NULL, NULL, 230662),
(240023, '3md7A00', NULL, NULL, 270, NULL, NULL, 230662),
(240024, '3iekA01', NULL, NULL, 249, NULL, NULL, 230662),
(240025, '3dhaA01', NULL, NULL, 245, NULL, NULL, 230662),
(240026, '5iqkA00', NULL, NULL, 271, NULL, NULL, 230662),
(240027, '5aebA00', NULL, NULL, 272, NULL, NULL, 230662),
(240028, '2cbnA00', NULL, NULL, 306, NULL, NULL, 230662),
(240029, '4ax1B00', NULL, NULL, 277, NULL, NULL, 230662),
(240030, '6n9iA00', NULL, NULL, 276, NULL, NULL, 230662),
(240031, '6i1dA01', NULL, NULL, 287, NULL, NULL, 230662),
(240032, '6cgyL00', NULL, NULL, 282, NULL, NULL, 230662),
(240033, '6aufB00', NULL, NULL, 277, NULL, NULL, 230662),
(240034, '5q22A01', NULL, NULL, 195, NULL, NULL, 230662),
(240035, '4d02A01', NULL, NULL, 247, NULL, NULL, 230662),
(240036, '4ubqA00', NULL, NULL, 229, NULL, NULL, 230662),
(240037, '2p97A00', NULL, NULL, 201, NULL, NULL, 230662),
(240038, '5ve3A01', NULL, NULL, 244, NULL, NULL, 230662),
(240039, '3zwfA00', NULL, NULL, 320, NULL, NULL, 230662),
(240040, '3l6nA00', NULL, NULL, 219, NULL, NULL, 230662),
(240041, '2vw8A00', NULL, NULL, 303, NULL, NULL, 230662),
(240042, '5naiA00', NULL, NULL, 236, NULL, NULL, 230662);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(240043, '2i7xA01', NULL, NULL, 279, NULL, NULL, 230662),
(240044, '4xukA00', NULL, NULL, 291, NULL, NULL, 230662),
(240045, '6frnA01', NULL, NULL, 253, NULL, NULL, 230662),
(240046, '3rpcA00', NULL, NULL, 264, NULL, NULL, 230662),
(240047, '5ahoA01', NULL, NULL, 191, NULL, NULL, 230662),
(240048, '1wraA01', NULL, NULL, 303, NULL, NULL, 230662),
(240049, '5k0wA00', NULL, NULL, 274, NULL, NULL, 230662),
(240050, '3bk2A01', NULL, NULL, 313, NULL, NULL, 230662),
(240051, '3af5A03', NULL, NULL, 272, NULL, NULL, 230662),
(240052, '2e7yB00', NULL, NULL, 280, NULL, NULL, 230662),
(240053, '4d1tA00', NULL, NULL, 236, NULL, NULL, 230662),
(240054, '1xm8A00', NULL, NULL, 254, NULL, NULL, 230662),
(240055, '2p18A00', NULL, NULL, 295, NULL, NULL, 230662),
(240056, '5ew0A00', NULL, NULL, 234, NULL, NULL, 230662),
(240057, '4zo2A00', NULL, NULL, 294, NULL, NULL, 230662),
(240058, '5jqjA00', NULL, NULL, 228, NULL, NULL, 230662),
(240059, '2qedA00', NULL, NULL, 258, NULL, NULL, 230662),
(240060, '4ysbA00', NULL, NULL, 233, NULL, NULL, 230662),
(240061, '4c1hA00', NULL, NULL, 227, NULL, NULL, 230662),
(240062, '1zkpC00', NULL, NULL, 245, NULL, NULL, 230662),
(240063, '3x30A00', NULL, NULL, 227, NULL, NULL, 230662),
(240064, '4fekB00', NULL, NULL, 262, NULL, NULL, 230662),
(240065, '3r2uB01', NULL, NULL, 266, NULL, NULL, 230662),
(240066, '4v0hD00', NULL, NULL, 239, NULL, NULL, 230662),
(240067, '1e5dA02', NULL, NULL, 248, NULL, NULL, 230662),
(240068, '6brmH00', NULL, NULL, 269, NULL, NULL, 230662),
(240069, '4zejA00', NULL, NULL, 232, NULL, NULL, 230662),
(240070, '3eshA01', NULL, NULL, 263, NULL, NULL, 230662),
(240071, '6e0sA00', NULL, NULL, 264, NULL, NULL, 230662),
(240072, '1vjnA00', NULL, NULL, 220, NULL, NULL, 230662),
(240073, '5y5bA00', NULL, NULL, 228, NULL, NULL, 230662),
(240074, '3tp9A01', NULL, NULL, 262, NULL, NULL, 230662),
(240075, '5lm6A00', NULL, NULL, 235, NULL, NULL, 230662),
(240076, '2p4zA00', NULL, NULL, 284, NULL, NULL, 230662),
(240077, '2zwrB00', NULL, NULL, 207, NULL, NULL, 230662),
(240078, '1ycgA01', NULL, NULL, 247, NULL, NULL, 230662),
(240079, '1y44A00', NULL, NULL, 282, NULL, NULL, 230662),
(240080, '4z67A00', NULL, NULL, 309, NULL, NULL, 230662),
(240081, '5acsA00', NULL, NULL, 229, NULL, NULL, 230662),
(240082, '2xf4A00', NULL, NULL, 210, NULL, NULL, 230662),
(240083, '5axoA00', NULL, NULL, 262, NULL, NULL, 230662),
(240084, '2r2dA00', NULL, NULL, 276, NULL, NULL, 230662),
(240085, '3zq4A01', NULL, NULL, 297, NULL, NULL, 230662),
(240086, '4yslA00', NULL, NULL, 294, NULL, NULL, 230662),
(240087, '3g1pA00', NULL, NULL, 258, NULL, NULL, 230662),
(240088, '4efzB00', NULL, NULL, 298, NULL, NULL, 230662),
(240089, '4chlA01', NULL, NULL, 233, NULL, NULL, 230662),
(240090, '1p9eA00', NULL, NULL, 296, NULL, NULL, 230662),
(240091, '1ztcA00', NULL, NULL, 221, NULL, NULL, 230662),
(240092, '5a0tB01', NULL, NULL, 294, NULL, NULL, 230662),
(240093, '1znbB00', NULL, NULL, 232, NULL, NULL, 230662),
(240094, '3kl7A00', NULL, NULL, 235, NULL, NULL, 230662),
(240095, '3adrB00', NULL, NULL, 261, NULL, NULL, 230662),
(240096, '4le6D00', NULL, NULL, 252, NULL, NULL, 230662),
(240097, '2xr1A03', NULL, NULL, 265, NULL, NULL, 230662),
(240098, '5hifA00', NULL, NULL, 299, NULL, NULL, 230662),
(240099, '2wylC00', NULL, NULL, 337, NULL, NULL, 230662),
(240100, '5xp6A00', NULL, NULL, 243, NULL, NULL, 230662),
(240101, '2i7tA01', NULL, NULL, 279, NULL, NULL, 230662),
(240102, '4xwwB01', NULL, NULL, 311, NULL, NULL, 230662),
(240103, '5wcmA00', NULL, NULL, 263, NULL, NULL, 230662),
(240104, '1m2xA00', NULL, NULL, 223, NULL, NULL, 230662),
(240105, '3aj3A00', NULL, NULL, 274, NULL, NULL, 230662),
(240106, '2gcuB01', NULL, NULL, 229, NULL, NULL, 230662),
(240107, '3bv6A00', NULL, NULL, 353, NULL, NULL, 230662),
(240108, '1k07A00', NULL, NULL, 263, NULL, NULL, 230662),
(240109, '4ad9A01', NULL, NULL, 205, NULL, NULL, 230662),
(240110, '5evkA00', NULL, NULL, 271, NULL, NULL, 230662),
(240111, '3h3eA00', NULL, NULL, 267, NULL, NULL, 230662),
(240112, '6n36A00', NULL, NULL, 271, NULL, NULL, 230662),
(240113, '2q9uB01', NULL, NULL, 251, NULL, NULL, 230662);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(240114, '2zo4A01', NULL, NULL, 261, NULL, NULL, 230662),
(240115, '2ohhA01', NULL, NULL, 252, NULL, NULL, 230662),
(240116, '4z7rB00', NULL, NULL, 299, NULL, NULL, 230662),
(240117, '5mmdE00', NULL, NULL, 229, NULL, NULL, 230662),
(240118, '2az4A01', NULL, NULL, 275, NULL, NULL, 230662),
(240119, '5v8sA01', NULL, NULL, 261, NULL, NULL, 230662),
(240120, '5b3rB00', NULL, NULL, 228, NULL, NULL, 230662),
(240121, '1wdjA00', NULL, NULL, 187, NULL, NULL, 230663),
(240122, '3ot2A00', NULL, NULL, 187, NULL, NULL, 230663),
(240123, '2y8nB01', NULL, NULL, 42, NULL, NULL, 230664),
(240124, '2y8nB02', NULL, NULL, 44, NULL, NULL, 230664),
(240125, '2wtpA00', NULL, NULL, 96, NULL, NULL, 230665),
(240126, '2dwkA00', NULL, NULL, 180, NULL, NULL, 230666),
(240127, '3cwzB01', NULL, NULL, 150, NULL, NULL, 230666),
(240128, '2cxfA00', NULL, NULL, 174, NULL, NULL, 230666),
(240129, '4giwB00', NULL, NULL, 198, NULL, NULL, 230666),
(240130, '1wusA00', NULL, NULL, 180, NULL, NULL, 230666),
(240131, '2dwgA00', NULL, NULL, 180, NULL, NULL, 230666),
(240132, '2cxlA00', NULL, NULL, 172, NULL, NULL, 230666),
(240133, '2i4lA01', NULL, NULL, 340, NULL, NULL, 230667),
(240134, '5t8uB01', NULL, NULL, 276, NULL, NULL, 230667),
(240135, '3m4pC02', NULL, NULL, 329, NULL, NULL, 230667),
(240136, '1wleA02', NULL, NULL, 319, NULL, NULL, 230667),
(240137, '6nrzA02', NULL, NULL, 355, NULL, NULL, 230667),
(240138, '4g84A01', NULL, NULL, 362, NULL, NULL, 230667),
(240139, '3vbbF02', NULL, NULL, 340, NULL, NULL, 230667),
(240140, '2du7A02', NULL, NULL, 228, NULL, NULL, 230667),
(240141, '4p72A05', NULL, NULL, 206, NULL, NULL, 230667),
(240142, '3l4gB04', NULL, NULL, 199, NULL, NULL, 230667),
(240143, '3lc0A01', NULL, NULL, 330, NULL, NULL, 230667),
(240144, '6oteA02', NULL, NULL, 342, NULL, NULL, 230667),
(240145, '4wj4A02', NULL, NULL, 332, NULL, NULL, 230667),
(240146, '1wu7A01', NULL, NULL, 259, NULL, NULL, 230667),
(240147, '3lssA02', NULL, NULL, 342, NULL, NULL, 230667),
(240148, '5znjA02', NULL, NULL, 305, NULL, NULL, 230667),
(240149, '4h2wA00', NULL, NULL, 309, NULL, NULL, 230667),
(240150, '6aqgD02', NULL, NULL, 342, NULL, NULL, 230667),
(240151, '5xixA02', NULL, NULL, 330, NULL, NULL, 230667),
(240152, '1x54A02', NULL, NULL, 330, NULL, NULL, 230667),
(240153, '2eayB01', NULL, NULL, 183, NULL, NULL, 230667),
(240154, '2ddzE00', NULL, NULL, 190, NULL, NULL, 230667),
(240155, '1vqzA01', NULL, NULL, 253, NULL, NULL, 230667),
(240156, '3ikmC01', NULL, NULL, 268, NULL, NULL, 230667),
(240157, '6hcuA02', NULL, NULL, 352, NULL, NULL, 230667),
(240158, '3g1zB00', NULL, NULL, 326, NULL, NULL, 230667),
(240159, '4hwtA01', NULL, NULL, 291, NULL, NULL, 230667),
(240160, '1bbwA02', NULL, NULL, 345, NULL, NULL, 230667),
(240161, '4lnsA00', NULL, NULL, 314, NULL, NULL, 230667),
(240162, '6jp2A02', NULL, NULL, 216, NULL, NULL, 230667),
(240163, '3pcoA01', NULL, NULL, 222, NULL, NULL, 230667),
(240164, '2zt5A01', NULL, NULL, 325, NULL, NULL, 230667),
(240165, '2zzeB01', NULL, NULL, 263, NULL, NULL, 230667),
(240166, '3i7fB02', NULL, NULL, 359, NULL, NULL, 230667),
(240167, '1b7yB05', NULL, NULL, 191, NULL, NULL, 230667),
(240168, '3a32A01', NULL, NULL, 330, NULL, NULL, 230667),
(240169, '1e1oA02', NULL, NULL, 347, NULL, NULL, 230667),
(240170, '2qhsA01', NULL, NULL, 206, NULL, NULL, 230667),
(240171, '1hc7A01', NULL, NULL, 282, NULL, NULL, 230667),
(240172, '2ej9A01', NULL, NULL, 188, NULL, NULL, 230667),
(240173, '1nj8A01', NULL, NULL, 277, NULL, NULL, 230667),
(240174, '3rf1A01', NULL, NULL, 216, NULL, NULL, 230667),
(240175, '2dq3A02', NULL, NULL, 319, NULL, NULL, 230667),
(240176, '3hy0A01', NULL, NULL, 251, NULL, NULL, 230667),
(240177, '3bfmA01', NULL, NULL, 179, NULL, NULL, 230667),
(240178, '1n9wB02', NULL, NULL, 319, NULL, NULL, 230667),
(240179, '3a5yA00', NULL, NULL, 321, NULL, NULL, 230667),
(240180, '2e5aA01', NULL, NULL, 240, NULL, NULL, 230667),
(240181, '4wi1B01', NULL, NULL, 247, NULL, NULL, 230667),
(240182, '4p72D01', NULL, NULL, 233, NULL, NULL, 230667),
(240183, '1eovA02', NULL, NULL, 353, NULL, NULL, 230667),
(240184, '2du3B01', NULL, NULL, 240, NULL, NULL, 230667);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(240185, '1g5hA01', NULL, NULL, 313, NULL, NULL, 230667),
(240186, '1h4vB01', NULL, NULL, 323, NULL, NULL, 230667),
(240187, '2g4cA01', NULL, NULL, 314, NULL, NULL, 230667),
(240188, '4j15B02', NULL, NULL, 349, NULL, NULL, 230667),
(240189, '4xemA01', NULL, NULL, 252, NULL, NULL, 230667),
(240190, '2zzeA01', NULL, NULL, 263, NULL, NULL, 230667),
(240191, '3icaB00', NULL, NULL, 213, NULL, NULL, 230667),
(240192, '1b7yA00', NULL, NULL, 265, NULL, NULL, 230667),
(240193, '2iy5A00', NULL, NULL, 350, NULL, NULL, 230667),
(240194, '3ikmB01', NULL, NULL, 280, NULL, NULL, 230667),
(240195, '2j3mA02', NULL, NULL, 305, NULL, NULL, 230667),
(240196, '2p0lA00', NULL, NULL, 272, NULL, NULL, 230667),
(240197, '2cjaA02', NULL, NULL, 340, NULL, NULL, 230667),
(240198, '5zg8A02', NULL, NULL, 336, NULL, NULL, 230667),
(240199, '5f5wA01', NULL, NULL, 218, NULL, NULL, 230667),
(240200, '3hriF01', NULL, NULL, 298, NULL, NULL, 230667),
(240201, '2rhsC00', NULL, NULL, 271, NULL, NULL, 230667),
(240202, '2dq0A02', NULL, NULL, 348, NULL, NULL, 230667),
(240203, '4wi1A01', NULL, NULL, 240, NULL, NULL, 230667),
(240204, '4e51B01', NULL, NULL, 324, NULL, NULL, 230667),
(240205, '1wydA02', NULL, NULL, 327, NULL, NULL, 230667),
(240206, '3racA00', NULL, NULL, 356, NULL, NULL, 230667),
(240207, '2odrD02', NULL, NULL, 238, NULL, NULL, 230667),
(240208, '3uh0A01', NULL, NULL, 307, NULL, NULL, 230667),
(240209, '5ucmA02', NULL, NULL, 301, NULL, NULL, 230667),
(240210, '4upaA02', NULL, NULL, 373, NULL, NULL, 230667),
(240211, '3od1A01', NULL, NULL, 328, NULL, NULL, 230667),
(240212, '4wf2A02', NULL, NULL, 206, NULL, NULL, 230667),
(240213, '2ztgA01', NULL, NULL, 257, NULL, NULL, 230667),
(240214, '1z7mC00', NULL, NULL, 323, NULL, NULL, 230667),
(240215, '1evlA01', NULL, NULL, 289, NULL, NULL, 230667),
(240216, '3a7rA01', NULL, NULL, 248, NULL, NULL, 230667),
(240217, '1w66A01', NULL, NULL, 208, NULL, NULL, 230667),
(240218, '1nyrA03', NULL, NULL, 316, NULL, NULL, 230667),
(240219, '1httA01', NULL, NULL, 273, NULL, NULL, 230667),
(240220, '5w25A02', NULL, NULL, 320, NULL, NULL, 230667),
(240221, '6hcwB02', NULL, NULL, 355, NULL, NULL, 230667),
(240222, '3ig2B00', NULL, NULL, 213, NULL, NULL, 230667),
(240223, '3netB01', NULL, NULL, 367, NULL, NULL, 230667),
(240224, '2xgtA02', NULL, NULL, 332, NULL, NULL, 230667),
(240225, '3ialA01', NULL, NULL, 294, NULL, NULL, 230667),
(240226, '1usyA00', NULL, NULL, 275, NULL, NULL, 230667),
(240227, '2c8mB00', NULL, NULL, 262, NULL, NULL, 230667),
(240228, '3l4gM00', NULL, NULL, 333, NULL, NULL, 230667),
(240229, '3rkxA02', NULL, NULL, 212, NULL, NULL, 230667),
(240230, '4rmfA02', NULL, NULL, 309, NULL, NULL, 230667),
(240231, '5mgwA01', NULL, NULL, 308, NULL, NULL, 230667),
(240232, '6bljA02', NULL, NULL, 334, NULL, NULL, 230667),
(240233, '6girA02', NULL, NULL, 327, NULL, NULL, 230667),
(240234, '3a74A02', NULL, NULL, 345, NULL, NULL, 230667),
(240235, '2zzfA01', NULL, NULL, 263, NULL, NULL, 230667),
(240236, '3errA02', NULL, NULL, 326, NULL, NULL, 230667),
(240237, '4ex5A02', NULL, NULL, 345, NULL, NULL, 230667),
(240238, '3w3sA02', NULL, NULL, 358, NULL, NULL, 230667),
(240239, '3l4gC04', NULL, NULL, 274, NULL, NULL, 230667),
(240240, '1nnhA00', NULL, NULL, 294, NULL, NULL, 230667),
(240241, '4cs4A02', NULL, NULL, 221, NULL, NULL, 230667),
(240242, '2du7B03', NULL, NULL, 307, NULL, NULL, 230667),
(240243, '1l0wA02', NULL, NULL, 306, NULL, NULL, 230667),
(240244, '1qe0A01', NULL, NULL, 326, NULL, NULL, 230667),
(240245, '3rexB00', NULL, NULL, 294, NULL, NULL, 230667),
(240246, '2dxuA01', NULL, NULL, 187, NULL, NULL, 230667),
(240247, '2p5iA00', NULL, NULL, 288, NULL, NULL, 230667),
(240248, '4xtvA01', NULL, NULL, 222, NULL, NULL, 230667),
(240249, '5e3iA01', NULL, NULL, 295, NULL, NULL, 230667),
(240250, '3qneA02', NULL, NULL, 343, NULL, NULL, 230667),
(240251, '1yb3A00', NULL, NULL, 175, NULL, NULL, 230667),
(240252, '12asA00', NULL, NULL, 330, NULL, NULL, 230667),
(240253, '6ildB02', NULL, NULL, 352, NULL, NULL, 230667),
(240254, '5hgqA02', NULL, NULL, 350, NULL, NULL, 230667),
(240255, '4hvcA01', NULL, NULL, 281, NULL, NULL, 230667);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(240256, '1nj1A01', NULL, NULL, 271, NULL, NULL, 230667),
(240257, '6h9xA02', NULL, NULL, 326, NULL, NULL, 230667),
(240258, '1c0aA02', NULL, NULL, 327, NULL, NULL, 230667),
(240259, '2rhqB05', NULL, NULL, 204, NULL, NULL, 230667),
(240260, '1yfsA01', NULL, NULL, 234, NULL, NULL, 230667),
(240261, '3vqwA02', NULL, NULL, 215, NULL, NULL, 230667),
(240262, '1atiB01', NULL, NULL, 305, NULL, NULL, 230667),
(240263, '3nemA02', NULL, NULL, 333, NULL, NULL, 230667),
(240264, '4ah6A02', NULL, NULL, 299, NULL, NULL, 230667),
(240265, '1j5wB01', NULL, NULL, 216, NULL, NULL, 230667),
(240266, '3pcoB05', NULL, NULL, 209, NULL, NULL, 230667),
(240267, '6aqhA02', NULL, NULL, 348, NULL, NULL, 230667),
(240268, '3dsqA02', NULL, NULL, 219, NULL, NULL, 230667),
(240269, '1gwyA00', NULL, NULL, 175, NULL, NULL, 230668),
(240270, '3qdsA00', NULL, NULL, 143, NULL, NULL, 230668),
(240271, '1y2tA00', NULL, NULL, 142, NULL, NULL, 230668),
(240272, '2ofcA00', NULL, NULL, 142, NULL, NULL, 230668),
(240273, '2ks4A00', NULL, NULL, 176, NULL, NULL, 230668),
(240274, '4wdcA00', NULL, NULL, 179, NULL, NULL, 230668),
(240275, '1iazA00', NULL, NULL, 179, NULL, NULL, 230668),
(240276, '1x99A00', NULL, NULL, 145, NULL, NULL, 230668),
(240277, '1ifqB00', NULL, NULL, 138, NULL, NULL, 230669),
(240278, '4b93A00', NULL, NULL, 164, NULL, NULL, 230669),
(240279, '3kyqA01', NULL, NULL, 141, NULL, NULL, 230669),
(240280, '2dmwA01', NULL, NULL, 116, NULL, NULL, 230669),
(240281, '2vx8D00', NULL, NULL, 149, NULL, NULL, 230669),
(240282, '4afiB00', NULL, NULL, 153, NULL, NULL, 230669),
(240283, '2nutC00', NULL, NULL, 158, NULL, NULL, 230669),
(240284, '3bw6A00', NULL, NULL, 144, NULL, NULL, 230669),
(240285, '4ogqC03', NULL, NULL, 35, NULL, NULL, 230670),
(240286, '1vf5Q01', NULL, NULL, 47, NULL, NULL, 230670),
(240287, '4ogqD01', NULL, NULL, 47, NULL, NULL, 230670),
(240288, '4i7zC03', NULL, NULL, 35, NULL, NULL, 230670),
(240289, '2ymkA01', NULL, NULL, 37, NULL, NULL, 230670),
(240290, '1t6uD00', NULL, NULL, 117, NULL, NULL, 230671),
(240291, '1q0gA00', NULL, NULL, 117, NULL, NULL, 230671),
(240292, '5nwgH00', NULL, NULL, 49, NULL, NULL, 230672),
(240293, '3v3kD00', NULL, NULL, 165, NULL, NULL, 230673),
(240294, '2f6mD00', NULL, NULL, 109, NULL, NULL, 230674),
(240295, '2p22B00', NULL, NULL, 118, NULL, NULL, 230674),
(240296, '2cazE00', NULL, NULL, 102, NULL, NULL, 230674),
(240297, '3lzdA01', NULL, NULL, 95, NULL, NULL, 230675),
(240298, '1vs9G01', NULL, NULL, 59, NULL, NULL, 230676),
(240299, '4uy8H00', NULL, NULL, 50, NULL, NULL, 230676),
(240300, '1vw4G00', NULL, NULL, 64, NULL, NULL, 230676),
(240301, '2hbaA00', NULL, NULL, 52, NULL, NULL, 230676),
(240302, '2hc5A01', NULL, NULL, 98, NULL, NULL, 230677),
(240303, '1kbhA00', NULL, NULL, 47, NULL, NULL, 230678),
(240304, '4kzsA01', NULL, NULL, 102, NULL, NULL, 230679),
(240305, '2f4lA03', NULL, NULL, 82, NULL, NULL, 230679),
(240306, '3rlfF01', NULL, NULL, 95, NULL, NULL, 230680),
(240307, '4hr6A00', NULL, NULL, 41, NULL, NULL, 230681),
(240308, '1omiA02', NULL, NULL, 27, NULL, NULL, 230682),
(240309, '3i38I02', NULL, NULL, 31, NULL, NULL, 230682),
(240310, '3h25A02', NULL, NULL, 34, NULL, NULL, 230682),
(240311, '2g8yA03', NULL, NULL, 28, NULL, NULL, 230682),
(240312, '1zmeC02', NULL, NULL, 30, NULL, NULL, 230682),
(240313, '1tiwA02', NULL, NULL, 26, NULL, NULL, 230682),
(240314, '1zkcB02', NULL, NULL, 19, NULL, NULL, 230682),
(240315, '1fdoA05', NULL, NULL, 27, NULL, NULL, 230682),
(240316, '1wmkA03', NULL, NULL, 28, NULL, NULL, 230682),
(240317, '3in6A01', NULL, NULL, 30, NULL, NULL, 230682),
(240318, '2p10B02', NULL, NULL, 27, NULL, NULL, 230682),
(240319, '3o6qC01', NULL, NULL, 36, NULL, NULL, 230682),
(240320, '3o6qA01', NULL, NULL, 36, NULL, NULL, 230682),
(240321, '5aunA01', NULL, NULL, 84, NULL, NULL, 230683),
(240322, '5l7oB00', NULL, NULL, 179, NULL, NULL, 230684),
(240323, '3vboA00', NULL, NULL, 225, NULL, NULL, 230684),
(240324, '1b35C00', NULL, NULL, 282, NULL, NULL, 230684),
(240325, '1h8tC00', NULL, NULL, 238, NULL, NULL, 230684),
(240326, '3cjiA00', NULL, NULL, 263, NULL, NULL, 230684);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(240327, '1tmf100', NULL, NULL, 276, NULL, NULL, 230684),
(240328, '1x36A00', NULL, NULL, 198, NULL, NULL, 230684),
(240329, '1fmd300', NULL, NULL, 219, NULL, NULL, 230684),
(240330, '1ohfB02', NULL, NULL, 293, NULL, NULL, 230684),
(240331, '1rhi100', NULL, NULL, 288, NULL, NULL, 230684),
(240332, '5k0uC00', NULL, NULL, 265, NULL, NULL, 230684),
(240333, '4iv1C00', NULL, NULL, 221, NULL, NULL, 230684),
(240334, '6hbjC00', NULL, NULL, 239, NULL, NULL, 230684),
(240335, '1a6cA02', NULL, NULL, 165, NULL, NULL, 230684),
(240336, '4q4w100', NULL, NULL, 281, NULL, NULL, 230684),
(240337, '1a6cA01', NULL, NULL, 348, NULL, NULL, 230684),
(240338, '1r1a300', NULL, NULL, 238, NULL, NULL, 230684),
(240339, '2izwC00', NULL, NULL, 208, NULL, NULL, 230684),
(240340, '2ws9201', NULL, NULL, 195, NULL, NULL, 230684),
(240341, '6gv4C00', NULL, NULL, 256, NULL, NULL, 230684),
(240342, '2wzr300', NULL, NULL, 221, NULL, NULL, 230684),
(240343, '1d4m200', NULL, NULL, 261, NULL, NULL, 230684),
(240344, '3napC00', NULL, NULL, 285, NULL, NULL, 230684),
(240345, '6csgB00', NULL, NULL, 247, NULL, NULL, 230684),
(240346, '1oopA00', NULL, NULL, 283, NULL, NULL, 230684),
(240347, '1pov100', NULL, NULL, 235, NULL, NULL, 230684),
(240348, '4gb3200', NULL, NULL, 263, NULL, NULL, 230684),
(240349, '1m06G00', NULL, NULL, 187, NULL, NULL, 230684),
(240350, '1z7s200', NULL, NULL, 272, NULL, NULL, 230684),
(240351, '1c8nC00', NULL, NULL, 220, NULL, NULL, 230684),
(240352, '4fy1100', NULL, NULL, 221, NULL, NULL, 230684),
(240353, '5w3eA00', NULL, NULL, 289, NULL, NULL, 230684),
(240354, '5osnC00', NULL, NULL, 243, NULL, NULL, 230684),
(240355, '5c8cA00', NULL, NULL, 297, NULL, NULL, 230684),
(240356, '3vbhB00', NULL, NULL, 245, NULL, NULL, 230684),
(240357, '2bpa200', NULL, NULL, 175, NULL, NULL, 230684),
(240358, '5w3mA00', NULL, NULL, 273, NULL, NULL, 230684),
(240359, '4qpiA00', NULL, NULL, 278, NULL, NULL, 230684),
(240360, '2mev300', NULL, NULL, 231, NULL, NULL, 230684),
(240361, '1pvc200', NULL, NULL, 271, NULL, NULL, 230684),
(240362, '2df7J01', NULL, NULL, 289, NULL, NULL, 230684),
(240363, '1f8vC00', NULL, NULL, 311, NULL, NULL, 230684),
(240364, '4wm8A00', NULL, NULL, 297, NULL, NULL, 230684),
(240365, '2x5iA00', NULL, NULL, 292, NULL, NULL, 230684),
(240366, '1f2nC00', NULL, NULL, 212, NULL, NULL, 230684),
(240367, '1qqp100', NULL, NULL, 213, NULL, NULL, 230684),
(240368, '6qccB00', NULL, NULL, 182, NULL, NULL, 230684),
(240369, '1ev1300', NULL, NULL, 239, NULL, NULL, 230684),
(240370, '1hxs100', NULL, NULL, 302, NULL, NULL, 230684),
(240371, '3cjiB00', NULL, NULL, 239, NULL, NULL, 230684),
(240372, '5j98B00', NULL, NULL, 261, NULL, NULL, 230684),
(240373, '5mqcC00', NULL, NULL, 267, NULL, NULL, 230684),
(240374, '4jgyA00', NULL, NULL, 236, NULL, NULL, 230684),
(240375, '2gh8A01', NULL, NULL, 209, NULL, NULL, 230684),
(240376, '2y26A02', NULL, NULL, 162, NULL, NULL, 230684),
(240377, '4iv1B00', NULL, NULL, 218, NULL, NULL, 230684),
(240378, '5aca100', NULL, NULL, 214, NULL, NULL, 230684),
(240379, '1b35B00', NULL, NULL, 255, NULL, NULL, 230684),
(240380, '2y26A01', NULL, NULL, 342, NULL, NULL, 230684),
(240381, '1zba100', NULL, NULL, 212, NULL, NULL, 230684),
(240382, '5k0uB00', NULL, NULL, 235, NULL, NULL, 230684),
(240383, '1mqtA00', NULL, NULL, 283, NULL, NULL, 230684),
(240384, '1opoC01', NULL, NULL, 165, NULL, NULL, 230684),
(240385, '2qqpE02', NULL, NULL, 288, NULL, NULL, 230684),
(240386, '2ws9300', NULL, NULL, 226, NULL, NULL, 230684),
(240387, '1bev300', NULL, NULL, 242, NULL, NULL, 230684),
(240388, '3zxaC01', NULL, NULL, 189, NULL, NULL, 230684),
(240389, '1d4m300', NULL, NULL, 238, NULL, NULL, 230684),
(240390, '1e57B00', NULL, NULL, 188, NULL, NULL, 230684),
(240391, '1novA00', NULL, NULL, 309, NULL, NULL, 230684),
(240392, '5yhqC00', NULL, NULL, 240, NULL, NULL, 230684),
(240393, '3napB00', NULL, NULL, 255, NULL, NULL, 230684),
(240394, '1eah100', NULL, NULL, 278, NULL, NULL, 230684),
(240395, '1oopB00', NULL, NULL, 261, NULL, NULL, 230684),
(240396, '4gb3100', NULL, NULL, 281, NULL, NULL, 230684),
(240397, '1tme300', NULL, NULL, 236, NULL, NULL, 230684);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(240398, '5fmoS00', NULL, NULL, 194, NULL, NULL, 230684),
(240399, '1ihmB01', NULL, NULL, 229, NULL, NULL, 230684),
(240400, '2tbvA00', NULL, NULL, 287, NULL, NULL, 230684),
(240401, '3s6pA02', NULL, NULL, 293, NULL, NULL, 230684),
(240402, '1ddlA00', NULL, NULL, 188, NULL, NULL, 230684),
(240403, '2x5iB00', NULL, NULL, 260, NULL, NULL, 230684),
(240404, '1z7s300', NULL, NULL, 240, NULL, NULL, 230684),
(240405, '2bbvA00', NULL, NULL, 308, NULL, NULL, 230684),
(240406, '5cfcA00', NULL, NULL, 252, NULL, NULL, 230684),
(240407, '5c8cB00', NULL, NULL, 323, NULL, NULL, 230684),
(240408, '3vbhC00', NULL, NULL, 242, NULL, NULL, 230684),
(240409, '4nwvA01', NULL, NULL, 184, NULL, NULL, 230684),
(240410, '1ng0C00', NULL, NULL, 218, NULL, NULL, 230684),
(240411, '5osnB00', NULL, NULL, 244, NULL, NULL, 230684),
(240412, '1pvc300', NULL, NULL, 238, NULL, NULL, 230684),
(240413, '4wm8B00', NULL, NULL, 248, NULL, NULL, 230684),
(240414, '3hagA01', NULL, NULL, 191, NULL, NULL, 230684),
(240415, '2mev200', NULL, NULL, 256, NULL, NULL, 230684),
(240416, '3tn9100', NULL, NULL, 228, NULL, NULL, 230684),
(240417, '4qpiB00', NULL, NULL, 222, NULL, NULL, 230684),
(240418, '1aym100', NULL, NULL, 285, NULL, NULL, 230684),
(240419, '4ejrA00', NULL, NULL, 164, NULL, NULL, 230684),
(240420, '3cjiC00', NULL, NULL, 284, NULL, NULL, 230684),
(240421, '4ftbC00', NULL, NULL, 309, NULL, NULL, 230684),
(240422, '1fpn100', NULL, NULL, 289, NULL, NULL, 230684),
(240423, '1qqp200', NULL, NULL, 218, NULL, NULL, 230684),
(240424, '6qccA00', NULL, NULL, 377, NULL, NULL, 230684),
(240425, '1ev1200', NULL, NULL, 254, NULL, NULL, 230684),
(240426, '5mqcB00', NULL, NULL, 231, NULL, NULL, 230684),
(240427, '1fmd100', NULL, NULL, 208, NULL, NULL, 230684),
(240428, '5jzgA00', NULL, NULL, 226, NULL, NULL, 230684),
(240429, '6ilpC00', NULL, NULL, 238, NULL, NULL, 230684),
(240430, '1rhi300', NULL, NULL, 236, NULL, NULL, 230684),
(240431, '4iv1A00', NULL, NULL, 211, NULL, NULL, 230684),
(240432, '1zba200', NULL, NULL, 218, NULL, NULL, 230684),
(240433, '4q4w300', NULL, NULL, 240, NULL, NULL, 230684),
(240434, '5aca200', NULL, NULL, 207, NULL, NULL, 230684),
(240435, '1r1a100', NULL, NULL, 287, NULL, NULL, 230684),
(240436, '1b35A00', NULL, NULL, 260, NULL, NULL, 230684),
(240437, '1h8tA00', NULL, NULL, 292, NULL, NULL, 230684),
(240438, '1smvC00', NULL, NULL, 222, NULL, NULL, 230684),
(240439, '6aktB00', NULL, NULL, 255, NULL, NULL, 230684),
(240440, '2wzr100', NULL, NULL, 219, NULL, NULL, 230684),
(240441, '1bev200', NULL, NULL, 248, NULL, NULL, 230684),
(240442, '2fz1B00', NULL, NULL, 189, NULL, NULL, 230684),
(240443, '1tme200', NULL, NULL, 267, NULL, NULL, 230684),
(240444, '1eah200', NULL, NULL, 271, NULL, NULL, 230684),
(240445, '5yhqB00', NULL, NULL, 243, NULL, NULL, 230684),
(240446, '5mjvB00', NULL, NULL, 253, NULL, NULL, 230684),
(240447, '3napA00', NULL, NULL, 271, NULL, NULL, 230684),
(240448, '1oopC00', NULL, NULL, 238, NULL, NULL, 230684),
(240449, '3ideA01', NULL, NULL, 299, NULL, NULL, 230684),
(240450, '2x5iC00', NULL, NULL, 238, NULL, NULL, 230684),
(240451, '5cfcB00', NULL, NULL, 232, NULL, NULL, 230684),
(240452, '1hx6A02', NULL, NULL, 152, NULL, NULL, 230684),
(240453, '5osnA00', NULL, NULL, 275, NULL, NULL, 230684),
(240454, '5c8cC00', NULL, NULL, 242, NULL, NULL, 230684),
(240455, '2mev100', NULL, NULL, 277, NULL, NULL, 230684),
(240456, '1hxs200', NULL, NULL, 272, NULL, NULL, 230684),
(240457, '4wm8C00', NULL, NULL, 247, NULL, NULL, 230684),
(240458, '5w3mC00', NULL, NULL, 262, NULL, NULL, 230684),
(240459, '4rft000', NULL, NULL, 166, NULL, NULL, 230684),
(240460, '5c4wB00', NULL, NULL, 254, NULL, NULL, 230684),
(240461, '1aym200', NULL, NULL, 261, NULL, NULL, 230684),
(240462, '4qpiC00', NULL, NULL, 246, NULL, NULL, 230684),
(240463, '4llfA00', NULL, NULL, 289, NULL, NULL, 230684),
(240464, '1ev1100', NULL, NULL, 281, NULL, NULL, 230684),
(240465, '1fpn200', NULL, NULL, 261, NULL, NULL, 230684),
(240466, '1tmf200', NULL, NULL, 267, NULL, NULL, 230684),
(240467, '1qqp300', NULL, NULL, 220, NULL, NULL, 230684),
(240468, '3jb4C00', NULL, NULL, 244, NULL, NULL, 230684);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(240469, '4bcuA00', NULL, NULL, 196, NULL, NULL, 230684),
(240470, '3jb8A00', NULL, NULL, 185, NULL, NULL, 230684),
(240471, '1fmd200', NULL, NULL, 218, NULL, NULL, 230684),
(240472, '4sbvC00', NULL, NULL, 222, NULL, NULL, 230684),
(240473, '6crpA00', NULL, NULL, 247, NULL, NULL, 230684),
(240474, '3m8lA01', NULL, NULL, 201, NULL, NULL, 230684),
(240475, '2ws9100', NULL, NULL, 246, NULL, NULL, 230684),
(240476, '1pgw200', NULL, NULL, 351, NULL, NULL, 230684),
(240477, '1rhi200', NULL, NULL, 262, NULL, NULL, 230684),
(240478, '5fmoL00', NULL, NULL, 374, NULL, NULL, 230684),
(240479, '5aooC00', NULL, NULL, 223, NULL, NULL, 230684),
(240480, '2zahC01', NULL, NULL, 178, NULL, NULL, 230684),
(240481, '1r1a200', NULL, NULL, 263, NULL, NULL, 230684),
(240482, '4q4w200', NULL, NULL, 271, NULL, NULL, 230684),
(240483, '1zba300', NULL, NULL, 221, NULL, NULL, 230684),
(240484, '5aca300', NULL, NULL, 222, NULL, NULL, 230684),
(240485, '4ftsA00', NULL, NULL, 328, NULL, NULL, 230684),
(240486, '1h8tB00', NULL, NULL, 262, NULL, NULL, 230684),
(240487, '1pgl100', NULL, NULL, 185, NULL, NULL, 230684),
(240488, '1d4m100', NULL, NULL, 299, NULL, NULL, 230684),
(240489, '2wzr200', NULL, NULL, 219, NULL, NULL, 230684),
(240490, '4llfD01', NULL, NULL, 178, NULL, NULL, 230684),
(240491, '1tme100', NULL, NULL, 256, NULL, NULL, 230684),
(240492, '6gshA01', NULL, NULL, 201, NULL, NULL, 230684),
(240493, '5yhqA00', NULL, NULL, 235, NULL, NULL, 230684),
(240494, '6csgC00', NULL, NULL, 248, NULL, NULL, 230684),
(240495, '1eah300', NULL, NULL, 238, NULL, NULL, 230684),
(240496, '4gb3300', NULL, NULL, 238, NULL, NULL, 230684),
(240497, '5nej100', NULL, NULL, 211, NULL, NULL, 230684),
(240498, '5ne4100', NULL, NULL, 211, NULL, NULL, 230684),
(240499, '1z7s100', NULL, NULL, 298, NULL, NULL, 230684),
(240500, '3vbhA00', NULL, NULL, 297, NULL, NULL, 230684),
(240501, '1hxs300', NULL, NULL, 237, NULL, NULL, 230684),
(240502, '1pvc100', NULL, NULL, 279, NULL, NULL, 230684),
(240503, '5w3mB00', NULL, NULL, 236, NULL, NULL, 230684),
(240504, '1fpn300', NULL, NULL, 237, NULL, NULL, 230684),
(240505, '1gff200', NULL, NULL, 177, NULL, NULL, 230684),
(240506, '1aym300', NULL, NULL, 238, NULL, NULL, 230684),
(240507, '5cfcC00', NULL, NULL, 258, NULL, NULL, 230684),
(240508, '6akuC00', NULL, NULL, 240, NULL, NULL, 230684),
(240509, '1bev100', NULL, NULL, 281, NULL, NULL, 230684),
(240510, '2ahmA00', NULL, NULL, 88, NULL, NULL, 230685),
(240511, '3bzcA04', NULL, NULL, 132, NULL, NULL, 230686),
(240512, '3k9tA02', NULL, NULL, 97, NULL, NULL, 230687),
(240513, '4jdnC00', NULL, NULL, 152, NULL, NULL, 230688),
(240514, '2m76A00', NULL, NULL, 50, NULL, NULL, 230689),
(240515, '4f4fA01', NULL, NULL, 91, NULL, NULL, 230690),
(240516, '1vb3A01', NULL, NULL, 81, NULL, NULL, 230690),
(240517, '3v7nA01', NULL, NULL, 100, NULL, NULL, 230690),
(240518, '1kl7A01', NULL, NULL, 94, NULL, NULL, 230690),
(240519, '4nohA01', NULL, NULL, 73, NULL, NULL, 230691),
(240520, '2bhvB02', NULL, NULL, 45, NULL, NULL, 230692),
(240521, '2bhvA02', NULL, NULL, 32, NULL, NULL, 230692),
(240522, '2fhzB00', NULL, NULL, 108, NULL, NULL, 230693),
(240523, '2i2lA01', NULL, NULL, 53, NULL, NULL, 230694),
(240524, '4p72A06', NULL, NULL, 94, NULL, NULL, 230695),
(240525, '2rhsD06', NULL, NULL, 89, NULL, NULL, 230695),
(240526, '5mgwA02', NULL, NULL, 97, NULL, NULL, 230695),
(240527, '3pcoB06', NULL, NULL, 94, NULL, NULL, 230695),
(240528, '1b7yB06', NULL, NULL, 96, NULL, NULL, 230695),
(240529, '1nc7D00', NULL, NULL, 138, NULL, NULL, 230696),
(240530, '1nc7A00', NULL, NULL, 138, NULL, NULL, 230696),
(240531, '2ii7H00', NULL, NULL, 131, NULL, NULL, 230696),
(240532, '2ii8D00', NULL, NULL, 105, NULL, NULL, 230696),
(240533, '2iiaA00', NULL, NULL, 111, NULL, NULL, 230696),
(240534, '5z62L00', NULL, NULL, 47, NULL, NULL, 230697),
(240535, '6hu9h00', NULL, NULL, 47, NULL, NULL, 230697),
(240536, '5b1aL00', NULL, NULL, 47, NULL, NULL, 230697),
(240537, '2y3aA01', NULL, NULL, 308, NULL, NULL, 230698),
(240538, '5dxuA01', NULL, NULL, 315, NULL, NULL, 230698),
(240539, '4jpsA01', NULL, NULL, 327, NULL, NULL, 230698);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(240540, '2grkA00', NULL, NULL, 228, NULL, NULL, 230699),
(240541, '2vgaA00', NULL, NULL, 207, NULL, NULL, 230699),
(240542, '2ffkA00', NULL, NULL, 242, NULL, NULL, 230699),
(240543, '1cq3A00', NULL, NULL, 233, NULL, NULL, 230699),
(240544, '1busA00', NULL, NULL, 57, NULL, NULL, 230700),
(240545, '2p6aD02', NULL, NULL, 68, NULL, NULL, 230700),
(240546, '4hguA00', NULL, NULL, 40, NULL, NULL, 230700),
(240547, '1tihA00', NULL, NULL, 53, NULL, NULL, 230700),
(240548, '1kmaA00', NULL, NULL, 55, NULL, NULL, 230700),
(240549, '2f3cI00', NULL, NULL, 55, NULL, NULL, 230700),
(240550, '1cgiI00', NULL, NULL, 56, NULL, NULL, 230700),
(240551, '1iw4A00', NULL, NULL, 55, NULL, NULL, 230700),
(240552, '2m25A00', NULL, NULL, 75, NULL, NULL, 230700),
(240553, '1tbrR02', NULL, NULL, 52, NULL, NULL, 230700),
(240554, '1z7kB00', NULL, NULL, 62, NULL, NULL, 230700),
(240555, '1tbrR01', NULL, NULL, 51, NULL, NULL, 230700),
(240556, '3hh2C02', NULL, NULL, 73, NULL, NULL, 230700),
(240557, '2n71A00', NULL, NULL, 50, NULL, NULL, 230700),
(240558, '3sekC02', NULL, NULL, 67, NULL, NULL, 230700),
(240559, '1uvgA01', NULL, NULL, 60, NULL, NULL, 230700),
(240560, '1iy6A00', NULL, NULL, 54, NULL, NULL, 230700),
(240561, '1pceA00', NULL, NULL, 60, NULL, NULL, 230700),
(240562, '2jzmA00', NULL, NULL, 53, NULL, NULL, 230700),
(240563, '1r0rI00', NULL, NULL, 51, NULL, NULL, 230700),
(240564, '4sgbI00', NULL, NULL, 51, NULL, NULL, 230700),
(240565, '5daeA00', NULL, NULL, 65, NULL, NULL, 230700),
(240566, '1hdlA00', NULL, NULL, 55, NULL, NULL, 230700),
(240567, '2jxdA00', NULL, NULL, 62, NULL, NULL, 230700),
(240568, '2arpF01', NULL, NULL, 63, NULL, NULL, 230700),
(240569, '2arpF02', NULL, NULL, 72, NULL, NULL, 230700),
(240570, '1y1bA00', NULL, NULL, 48, NULL, NULL, 230700),
(240571, '2erwA00', NULL, NULL, 56, NULL, NULL, 230700),
(240572, '1ldtL00', NULL, NULL, 46, NULL, NULL, 230700),
(240573, '2jyyA00', NULL, NULL, 53, NULL, NULL, 230700),
(240574, '2wcyA01', NULL, NULL, 75, NULL, NULL, 230700),
(240575, '1ds3I00', NULL, NULL, 51, NULL, NULL, 230700),
(240576, '2leoA00', NULL, NULL, 66, NULL, NULL, 230700),
(240577, '2wcyA02', NULL, NULL, 80, NULL, NULL, 230700),
(240578, '3sekC03', NULL, NULL, 76, NULL, NULL, 230700),
(240579, '2xrcA02', NULL, NULL, 48, NULL, NULL, 230700),
(240580, '4gi3C00', NULL, NULL, 63, NULL, NULL, 230700),
(240581, '1pjuA01', NULL, NULL, 63, NULL, NULL, 230700),
(240582, '1pjuA02', NULL, NULL, 52, NULL, NULL, 230700),
(240583, '1h0zA00', NULL, NULL, 68, NULL, NULL, 230700),
(240584, '2n17A00', NULL, NULL, 58, NULL, NULL, 230700),
(240585, '2n52A00', NULL, NULL, 60, NULL, NULL, 230700),
(240586, '1ce3A00', NULL, NULL, 54, NULL, NULL, 230700),
(240587, '1y1cA00', NULL, NULL, 48, NULL, NULL, 230700),
(240588, '3hh2D04', NULL, NULL, 76, NULL, NULL, 230700),
(240589, '3hh2D03', NULL, NULL, 39, NULL, NULL, 230700),
(240590, '3ovoA00', NULL, NULL, 56, NULL, NULL, 230700),
(240591, '1n13E00', NULL, NULL, 52, NULL, NULL, 230700),
(240592, '5zfoA00', NULL, NULL, 50, NULL, NULL, 230700),
(240593, '1nubA01', NULL, NULL, 85, NULL, NULL, 230700),
(240594, '1tgsI00', NULL, NULL, 56, NULL, NULL, 230700),
(240595, '3dp7A02', NULL, NULL, 93, NULL, NULL, 230701),
(240596, '1t3oA01', NULL, NULL, 68, NULL, NULL, 230702),
(240597, '4krwA00', NULL, NULL, 79, NULL, NULL, 230702),
(240598, '1y00A00', NULL, NULL, 61, NULL, NULL, 230702),
(240599, '3u02A01', NULL, NULL, 155, NULL, NULL, 230703),
(240600, '1aapA00', NULL, NULL, 58, NULL, NULL, 230704),
(240601, '5yw1I00', NULL, NULL, 55, NULL, NULL, 230704),
(240602, '1ld6A00', NULL, NULL, 58, NULL, NULL, 230704),
(240603, '3aubA00', NULL, NULL, 58, NULL, NULL, 230704),
(240604, '1irhA00', NULL, NULL, 61, NULL, NULL, 230704),
(240605, '1adzA00', NULL, NULL, 71, NULL, NULL, 230704),
(240606, '2fi3I00', NULL, NULL, 58, NULL, NULL, 230704),
(240607, '6a5iA00', NULL, NULL, 68, NULL, NULL, 230704),
(240608, '1demA00', NULL, NULL, 60, NULL, NULL, 230704),
(240609, '6harE00', NULL, NULL, 80, NULL, NULL, 230704),
(240610, '6bx8B00', NULL, NULL, 80, NULL, NULL, 230704),
(240611, '3m7qB00', NULL, NULL, 61, NULL, NULL, 230704);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(240612, '2zjxB00', NULL, NULL, 58, NULL, NULL, 230704),
(240613, '5m4vA00', NULL, NULL, 57, NULL, NULL, 230704),
(240614, '5nmvK00', NULL, NULL, 65, NULL, NULL, 230704),
(240615, '5nx1D00', NULL, NULL, 56, NULL, NULL, 230704),
(240616, '1zr0B00', NULL, NULL, 63, NULL, NULL, 230704),
(240617, '1bunB00', NULL, NULL, 61, NULL, NULL, 230704),
(240618, '1ylcB00', NULL, NULL, 56, NULL, NULL, 230704),
(240619, '4u32X00', NULL, NULL, 55, NULL, NULL, 230704),
(240620, '4isoB00', NULL, NULL, 60, NULL, NULL, 230704),
(240621, '4u30W00', NULL, NULL, 59, NULL, NULL, 230704),
(240622, '1bikA00', NULL, NULL, 123, NULL, NULL, 230704),
(240623, '1g6xA00', NULL, NULL, 58, NULL, NULL, 230704),
(240624, '5ptiA00', NULL, NULL, 58, NULL, NULL, 230704),
(240625, '6gfiC00', NULL, NULL, 81, NULL, NULL, 230704),
(240626, '2jotA00', NULL, NULL, 55, NULL, NULL, 230704),
(240627, '1tocR02', NULL, NULL, 58, NULL, NULL, 230704),
(240628, '1tocR01', NULL, NULL, 52, NULL, NULL, 230704),
(240629, '1p2jI00', NULL, NULL, 58, NULL, NULL, 230704),
(240630, '2uuyB01', NULL, NULL, 36, NULL, NULL, 230704),
(240631, '3fp7J00', NULL, NULL, 43, NULL, NULL, 230704),
(240632, '5yv7A00', NULL, NULL, 60, NULL, NULL, 230704),
(240633, '1y62A00', NULL, NULL, 60, NULL, NULL, 230704),
(240634, '1yc0I00', NULL, NULL, 75, NULL, NULL, 230704),
(240635, '1fakI00', NULL, NULL, 55, NULL, NULL, 230704),
(240636, '3audC00', NULL, NULL, 65, NULL, NULL, 230704),
(240637, '3bybA00', NULL, NULL, 59, NULL, NULL, 230704),
(240638, '1aalB00', NULL, NULL, 58, NULL, NULL, 230704),
(240639, '3wnyB00', NULL, NULL, 63, NULL, NULL, 230704),
(240640, '2w8xB00', NULL, NULL, 72, NULL, NULL, 230704),
(240641, '1kthA00', NULL, NULL, 58, NULL, NULL, 230704),
(240642, '1jc6A00', NULL, NULL, 65, NULL, NULL, 230704),
(240643, '5h7vA04', NULL, NULL, 52, NULL, NULL, 230704),
(240644, '1yldB00', NULL, NULL, 56, NULL, NULL, 230704),
(240645, '1d0dA00', NULL, NULL, 60, NULL, NULL, 230704),
(240646, '5jb5A00', NULL, NULL, 58, NULL, NULL, 230704),
(240647, '3p95E00', NULL, NULL, 58, NULL, NULL, 230704),
(240648, '1dtxA00', NULL, NULL, 59, NULL, NULL, 230704),
(240649, '2j6dA00', NULL, NULL, 65, NULL, NULL, 230704),
(240650, '2ddiA00', NULL, NULL, 70, NULL, NULL, 230704),
(240651, '3l3tE00', NULL, NULL, 57, NULL, NULL, 230704),
(240652, '3augC00', NULL, NULL, 65, NULL, NULL, 230704),
(240653, '3aucA00', NULL, NULL, 65, NULL, NULL, 230704),
(240654, '1brbI00', NULL, NULL, 58, NULL, NULL, 230704),
(240655, '2odyE01', NULL, NULL, 66, NULL, NULL, 230704),
(240656, '2kcrA00', NULL, NULL, 61, NULL, NULL, 230704),
(240657, '2odyE02', NULL, NULL, 61, NULL, NULL, 230704),
(240658, '4dtgK00', NULL, NULL, 66, NULL, NULL, 230704),
(240659, '2m99A00', NULL, NULL, 57, NULL, NULL, 230704),
(240660, '2m01A00', NULL, NULL, 59, NULL, NULL, 230704),
(240661, '4ntwB00', NULL, NULL, 60, NULL, NULL, 230704),
(240662, '1co7I00', NULL, NULL, 57, NULL, NULL, 230704),
(240663, '4bd9B03', NULL, NULL, 55, NULL, NULL, 230704),
(240664, '4bd9B02', NULL, NULL, 56, NULL, NULL, 230704),
(240665, '4bd9B01', NULL, NULL, 54, NULL, NULL, 230704),
(240666, '1dtkA00', NULL, NULL, 57, NULL, NULL, 230704),
(240667, '4ag4A02', NULL, NULL, 188, NULL, NULL, 230705),
(240668, '1ii7B02', NULL, NULL, 84, NULL, NULL, 230706),
(240669, '5dm6U00', NULL, NULL, 72, NULL, NULL, 230707),
(240670, '4uy8X00', NULL, NULL, 77, NULL, NULL, 230707),
(240671, '2jz6A01', NULL, NULL, 50, NULL, NULL, 230707),
(240672, '2j01100', NULL, NULL, 98, NULL, NULL, 230707),
(240673, '5mmiY00', NULL, NULL, 77, NULL, NULL, 230707),
(240674, '3uoeA03', NULL, NULL, 44, NULL, NULL, 230708),
(240675, '1z2iA03', NULL, NULL, 37, NULL, NULL, 230708),
(240676, '1nxuB03', NULL, NULL, 43, NULL, NULL, 230708),
(240677, '1wtjA03', NULL, NULL, 49, NULL, NULL, 230708),
(240678, '3qhqA02', NULL, NULL, 62, NULL, NULL, 230709),
(240679, '6qxfA02', NULL, NULL, 62, NULL, NULL, 230709),
(240680, '3tocB02', NULL, NULL, 63, NULL, NULL, 230709),
(240681, '3s5uA02', NULL, NULL, 62, NULL, NULL, 230709),
(240682, '3fhnA03', NULL, NULL, 174, NULL, NULL, 230710),
(240683, '4h22A00', NULL, NULL, 103, NULL, NULL, 230711);
INSERT INTO "PUBLIC"."MODEL" VALUES
(240684, '3ojaA03', NULL, NULL, 83, NULL, NULL, 230711),
(240685, '3e0jC01', NULL, NULL, 337, NULL, NULL, 230712),
(240686, '2xvoB00', NULL, NULL, 192, NULL, NULL, 230713),
(240687, '2zpaA01', NULL, NULL, 191, NULL, NULL, 230714),
(240688, '3ep6B01', NULL, NULL, 48, NULL, NULL, 230715),
(240689, '5tvoB00', NULL, NULL, 59, NULL, NULL, 230715),
(240690, '1mhmB00', NULL, NULL, 72, NULL, NULL, 230715),
(240691, '4esqA00', NULL, NULL, 194, NULL, NULL, 230716),
(240692, '2gn4A02', NULL, NULL, 85, NULL, NULL, 230717),
(240693, '4g5hA02', NULL, NULL, 105, NULL, NULL, 230717),
(240694, '2pn5A02', NULL, NULL, 101, NULL, NULL, 230718),
(240695, '2p9rA00', NULL, NULL, 102, NULL, NULL, 230718),
(240696, '2a74D01', NULL, NULL, 138, NULL, NULL, 230718),
(240697, '2a74A05', NULL, NULL, 105, NULL, NULL, 230718),
(240698, '3cu7A02', NULL, NULL, 99, NULL, NULL, 230718),
(240699, '2a74A02', NULL, NULL, 101, NULL, NULL, 230718),
(240700, '5jtwA05', NULL, NULL, 121, NULL, NULL, 230718),
(240701, '3cu7A05', NULL, NULL, 106, NULL, NULL, 230718),
(240702, '2b39A05', NULL, NULL, 110, NULL, NULL, 230718),
(240703, '5jtwA02', NULL, NULL, 100, NULL, NULL, 230718),
(240704, '5jtwA01', NULL, NULL, 144, NULL, NULL, 230718),
(240705, '2b39A01', NULL, NULL, 96, NULL, NULL, 230718),
(240706, '2b39A02', NULL, NULL, 100, NULL, NULL, 230718),
(240707, '3hrzA01', NULL, NULL, 136, NULL, NULL, 230718),
(240708, '3hrzA02', NULL, NULL, 95, NULL, NULL, 230718),
(240709, '4kh9B02', NULL, NULL, 113, NULL, NULL, 230718),
(240710, '2pn5A05', NULL, NULL, 96, NULL, NULL, 230718),
(240711, '3hrzA05', NULL, NULL, 101, NULL, NULL, 230718),
(240712, '5b71E00', NULL, NULL, 110, NULL, NULL, 230718),
(240713, '3ci0J02', NULL, NULL, 50, NULL, NULL, 230719),
(240714, '2iayA00', NULL, NULL, 114, NULL, NULL, 230720),
(240715, '3imnA02', NULL, NULL, 70, NULL, NULL, 230721),
(240716, '3ikwA02', NULL, NULL, 70, NULL, NULL, 230721),
(240717, '1xruA01', NULL, NULL, 124, NULL, NULL, 230722),
(240718, '3r1fE02', NULL, NULL, 35, NULL, NULL, 230723),
(240719, '2r7rA07', NULL, NULL, 120, NULL, NULL, 230724),
(240720, '4l7aA00', NULL, NULL, 271, NULL, NULL, 230725),
(240721, '3fq4B01', NULL, NULL, 120, NULL, NULL, 230726),
(240722, '2lt9A00', NULL, NULL, 157, NULL, NULL, 230726),
(240723, '3e9tB00', NULL, NULL, 114, NULL, NULL, 230726),
(240724, '2kltA00', NULL, NULL, 163, NULL, NULL, 230726),
(240725, '3rb5A02', NULL, NULL, 139, NULL, NULL, 230726),
(240726, '2qvkA00', NULL, NULL, 124, NULL, NULL, 230726),
(240727, '2dpkA01', NULL, NULL, 141, NULL, NULL, 230726),
(240728, '3us9A02', NULL, NULL, 155, NULL, NULL, 230726),
(240729, '2nrqA00', NULL, NULL, 159, NULL, NULL, 230727),
(240730, '2pzzA01', NULL, NULL, 133, NULL, NULL, 230727),
(240731, '1vx7G00', NULL, NULL, 173, NULL, NULL, 230727),
(240732, '5gaeF00', NULL, NULL, 179, NULL, NULL, 230727),
(240733, '3c9gA01', NULL, NULL, 132, NULL, NULL, 230727),
(240734, '5dm6D00', NULL, NULL, 177, NULL, NULL, 230727),
(240735, '3u5eJ00', NULL, NULL, 174, NULL, NULL, 230727),
(240736, '2nwuB01', NULL, NULL, 138, NULL, NULL, 230727),
(240737, '4a17D00', NULL, NULL, 172, NULL, NULL, 230727),
(240738, '4wceD00', NULL, NULL, 179, NULL, NULL, 230727),
(240739, '1iq4A00', NULL, NULL, 179, NULL, NULL, 230727),
(240740, '5v7qF00', NULL, NULL, 187, NULL, NULL, 230727),
(240741, '3d7aA01', NULL, NULL, 137, NULL, NULL, 230727),
(240742, '1vwxJ00', NULL, NULL, 178, NULL, NULL, 230727),
(240743, '1vq8D00', NULL, NULL, 177, NULL, NULL, 230727),
(240744, '5x8tF00', NULL, NULL, 175, NULL, NULL, 230727),
(240745, '2ogkD00', NULL, NULL, 146, NULL, NULL, 230727),
(240746, '2wnyA00', NULL, NULL, 141, NULL, NULL, 230727),
(240747, '1mjiB00', NULL, NULL, 182, NULL, NULL, 230727),
(240748, '2btoA03', NULL, NULL, 54, NULL, NULL, 230728),
(240749, '2btqB03', NULL, NULL, 53, NULL, NULL, 230728),
(240750, '4i4tC03', NULL, NULL, 67, NULL, NULL, 230728),
(240751, '4i4tB03', NULL, NULL, 55, NULL, NULL, 230728),
(240752, '4u3jA03', NULL, NULL, 63, NULL, NULL, 230728),
(240753, '4u3jB03', NULL, NULL, 57, NULL, NULL, 230728),
(240754, '5iyzB03', NULL, NULL, 72, NULL, NULL, 230728);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(240755, '5nm5A03', NULL, NULL, 52, NULL, NULL, 230728),
(240756, '3e22A03', NULL, NULL, 66, NULL, NULL, 230728),
(240757, '3cb2A03', NULL, NULL, 61, NULL, NULL, 230728),
(240758, '3pl8A02', NULL, NULL, 62, NULL, NULL, 230729),
(240759, '5a2gA00', NULL, NULL, 502, NULL, NULL, 230730),
(240760, '5f4zC00', NULL, NULL, 393, NULL, NULL, 230730),
(240761, '3sk0A00', NULL, NULL, 311, NULL, NULL, 230730),
(240762, '3n2zB01', NULL, NULL, 293, NULL, NULL, 230730),
(240763, '6f9oA00', NULL, NULL, 309, NULL, NULL, 230730),
(240764, '4pscA00', NULL, NULL, 224, NULL, NULL, 230730),
(240765, '1hkhA00', NULL, NULL, 279, NULL, NULL, 230730),
(240766, '3flbA00', NULL, NULL, 249, NULL, NULL, 230730),
(240767, '1lgyA00', NULL, NULL, 269, NULL, NULL, 230730),
(240768, '4zv9A00', NULL, NULL, 238, NULL, NULL, 230730),
(240769, '4k2aC00', NULL, NULL, 300, NULL, NULL, 230730),
(240770, '1xklA00', NULL, NULL, 273, NULL, NULL, 230730),
(240771, '4i3fA00', NULL, NULL, 283, NULL, NULL, 230730),
(240772, '2pblA01', NULL, NULL, 243, NULL, NULL, 230730),
(240773, '4f21B00', NULL, NULL, 224, NULL, NULL, 230730),
(240774, '3ls2A00', NULL, NULL, 280, NULL, NULL, 230730),
(240775, '5xk2A00', NULL, NULL, 286, NULL, NULL, 230730),
(240776, '2fukA00', NULL, NULL, 220, NULL, NULL, 230730),
(240777, '5kwiA00', NULL, NULL, 283, NULL, NULL, 230730),
(240778, '4dm7A01', NULL, NULL, 284, NULL, NULL, 230730),
(240779, '3o0dA00', NULL, NULL, 301, NULL, NULL, 230730),
(240780, '3uueA00', NULL, NULL, 279, NULL, NULL, 230730),
(240781, '3lcrB00', NULL, NULL, 293, NULL, NULL, 230730),
(240782, '3fvtF00', NULL, NULL, 320, NULL, NULL, 230730),
(240783, '3wwcA00', NULL, NULL, 342, NULL, NULL, 230730),
(240784, '1jfrA00', NULL, NULL, 262, NULL, NULL, 230730),
(240785, '5jd5B00', NULL, NULL, 321, NULL, NULL, 230730),
(240786, '1mj5A00', NULL, NULL, 302, NULL, NULL, 230730),
(240787, '2bceA00', NULL, NULL, 539, NULL, NULL, 230730),
(240788, '5h3hB00', NULL, NULL, 272, NULL, NULL, 230730),
(240789, '6fkxA00', NULL, NULL, 324, NULL, NULL, 230730),
(240790, '3gffA00', NULL, NULL, 331, NULL, NULL, 230730),
(240791, '6atxA00', NULL, NULL, 276, NULL, NULL, 230730),
(240792, '5cw2A00', NULL, NULL, 325, NULL, NULL, 230730),
(240793, '5mxpA00', NULL, NULL, 302, NULL, NULL, 230730),
(240794, '5bv7A01', NULL, NULL, 226, NULL, NULL, 230730),
(240795, '1ukcB00', NULL, NULL, 522, NULL, NULL, 230730),
(240796, '5mifA00', NULL, NULL, 314, NULL, NULL, 230730),
(240797, '1g66A00', NULL, NULL, 207, NULL, NULL, 230730),
(240798, '4ci9A00', NULL, NULL, 415, NULL, NULL, 230730),
(240799, '4wy5A00', NULL, NULL, 332, NULL, NULL, 230730),
(240800, '2z3zA02', NULL, NULL, 256, NULL, NULL, 230730),
(240801, '4y7dA00', NULL, NULL, 302, NULL, NULL, 230730),
(240802, '3vjmA02', NULL, NULL, 264, NULL, NULL, 230730),
(240803, '4l9aA00', NULL, NULL, 273, NULL, NULL, 230730),
(240804, '3qmmA00', NULL, NULL, 181, NULL, NULL, 230730),
(240805, '5z7xA00', NULL, NULL, 274, NULL, NULL, 230730),
(240806, '4mydA00', NULL, NULL, 252, NULL, NULL, 230730),
(240807, '1z68A02', NULL, NULL, 255, NULL, NULL, 230730),
(240808, '1tqhA00', NULL, NULL, 247, NULL, NULL, 230730),
(240809, '1u2eA00', NULL, NULL, 289, NULL, NULL, 230730),
(240810, '5synA00', NULL, NULL, 231, NULL, NULL, 230730),
(240811, '3bf7A00', NULL, NULL, 255, NULL, NULL, 230730),
(240812, '1mtzA00', NULL, NULL, 293, NULL, NULL, 230730),
(240813, '1ycdB00', NULL, NULL, 243, NULL, NULL, 230730),
(240814, '1r1dA00', NULL, NULL, 247, NULL, NULL, 230730),
(240815, '1a8sA00', NULL, NULL, 273, NULL, NULL, 230730),
(240816, '3qitB00', NULL, NULL, 286, NULL, NULL, 230730),
(240817, '3i1iB01', NULL, NULL, 377, NULL, NULL, 230730),
(240818, '3r41A00', NULL, NULL, 306, NULL, NULL, 230730),
(240819, '4lxhA00', NULL, NULL, 277, NULL, NULL, 230730),
(240820, '4fleA00', NULL, NULL, 202, NULL, NULL, 230730),
(240821, '2xmrA00', NULL, NULL, 281, NULL, NULL, 230730),
(240822, '1r88A00', NULL, NULL, 280, NULL, NULL, 230730),
(240823, '3groA00', NULL, NULL, 298, NULL, NULL, 230730),
(240824, '4batA00', NULL, NULL, 301, NULL, NULL, 230730),
(240825, '4rpcA00', NULL, NULL, 263, NULL, NULL, 230730);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(240826, '3qzuA00', NULL, NULL, 181, NULL, NULL, 230730),
(240827, '3c8dB02', NULL, NULL, 256, NULL, NULL, 230730),
(240828, '5jd6A00', NULL, NULL, 221, NULL, NULL, 230730),
(240829, '5l2pA00', NULL, NULL, 306, NULL, NULL, 230730),
(240830, '2wueA00', NULL, NULL, 291, NULL, NULL, 230730),
(240831, '3tejA00', NULL, NULL, 329, NULL, NULL, 230730),
(240832, '4folA00', NULL, NULL, 299, NULL, NULL, 230730),
(240833, '2pplA01', NULL, NULL, 339, NULL, NULL, 230730),
(240834, '4qloA00', NULL, NULL, 329, NULL, NULL, 230730),
(240835, '3e4dA00', NULL, NULL, 278, NULL, NULL, 230730),
(240836, '2qvbA00', NULL, NULL, 297, NULL, NULL, 230730),
(240837, '3u0vA00', NULL, NULL, 239, NULL, NULL, 230730),
(240838, '5hzgA00', NULL, NULL, 267, NULL, NULL, 230730),
(240839, '3k6kA00', NULL, NULL, 322, NULL, NULL, 230730),
(240840, '2yysA00', NULL, NULL, 286, NULL, NULL, 230730),
(240841, '3g9xA00', NULL, NULL, 299, NULL, NULL, 230730),
(240842, '3picA00', NULL, NULL, 375, NULL, NULL, 230730),
(240843, '1bu8A01', NULL, NULL, 339, NULL, NULL, 230730),
(240844, '1xfdA02', NULL, NULL, 259, NULL, NULL, 230730),
(240845, '3zpxA01', NULL, NULL, 290, NULL, NULL, 230730),
(240846, '4qwwA00', NULL, NULL, 542, NULL, NULL, 230730),
(240847, '5z7zB00', NULL, NULL, 272, NULL, NULL, 230730),
(240848, '4e15B00', NULL, NULL, 303, NULL, NULL, 230730),
(240849, '1ys1X00', NULL, NULL, 320, NULL, NULL, 230730),
(240850, '3bdiA00', NULL, NULL, 207, NULL, NULL, 230730),
(240851, '1mo2A00', NULL, NULL, 269, NULL, NULL, 230730),
(240852, '1auoA00', NULL, NULL, 218, NULL, NULL, 230730),
(240853, '3cn9A00', NULL, NULL, 226, NULL, NULL, 230730),
(240854, '4a5sB01', NULL, NULL, 286, NULL, NULL, 230730),
(240855, '3b12A00', NULL, NULL, 304, NULL, NULL, 230730),
(240856, '4uhbA00', NULL, NULL, 328, NULL, NULL, 230730),
(240857, '3qyjA00', NULL, NULL, 291, NULL, NULL, 230730),
(240858, '4rgyA00', NULL, NULL, 271, NULL, NULL, 230730),
(240859, '3wi7A00', NULL, NULL, 304, NULL, NULL, 230730),
(240860, '5esrA00', NULL, NULL, 308, NULL, NULL, 230730),
(240861, '4ebbA01', NULL, NULL, 302, NULL, NULL, 230730),
(240862, '1hlgA00', NULL, NULL, 371, NULL, NULL, 230730),
(240863, '1brtA00', NULL, NULL, 277, NULL, NULL, 230730),
(240864, '4ypvA00', NULL, NULL, 313, NULL, NULL, 230730),
(240865, '3guuA01', NULL, NULL, 335, NULL, NULL, 230730),
(240866, '1cr6A02', NULL, NULL, 327, NULL, NULL, 230730),
(240867, '1crlA00', NULL, NULL, 534, NULL, NULL, 230730),
(240868, '4bp8A01', NULL, NULL, 370, NULL, NULL, 230730),
(240869, '4kyvB00', NULL, NULL, 306, NULL, NULL, 230730),
(240870, '6h1aA00', NULL, NULL, 547, NULL, NULL, 230730),
(240871, '4q3kB00', NULL, NULL, 242, NULL, NULL, 230730),
(240872, '3oosA01', NULL, NULL, 222, NULL, NULL, 230730),
(240873, '4q34A00', NULL, NULL, 323, NULL, NULL, 230730),
(240874, '4ns4A00', NULL, NULL, 295, NULL, NULL, 230730),
(240875, '2oryA00', NULL, NULL, 346, NULL, NULL, 230730),
(240876, '2e3jA00', NULL, NULL, 356, NULL, NULL, 230730),
(240877, '4ffvB01', NULL, NULL, 273, NULL, NULL, 230730),
(240878, '4nmwA00', NULL, NULL, 259, NULL, NULL, 230730),
(240879, '6qaaA00', NULL, NULL, 526, NULL, NULL, 230730),
(240880, '3wydA00', NULL, NULL, 207, NULL, NULL, 230730),
(240881, '2o7rA00', NULL, NULL, 321, NULL, NULL, 230730),
(240882, '6azbA00', NULL, NULL, 272, NULL, NULL, 230730),
(240883, '2pujA00', NULL, NULL, 286, NULL, NULL, 230730),
(240884, '4zwnB00', NULL, NULL, 313, NULL, NULL, 230730),
(240885, '1f0nA00', NULL, NULL, 285, NULL, NULL, 230730),
(240886, '3mgaA02', NULL, NULL, 255, NULL, NULL, 230730),
(240887, '3fleA00', NULL, NULL, 249, NULL, NULL, 230730),
(240888, '5cbkA00', NULL, NULL, 271, NULL, NULL, 230730),
(240889, '1qlwA00', NULL, NULL, 328, NULL, NULL, 230730),
(240890, '3wmrA00', NULL, NULL, 296, NULL, NULL, 230730),
(240891, '5ng7A00', NULL, NULL, 299, NULL, NULL, 230730),
(240892, '1ufoA00', NULL, NULL, 238, NULL, NULL, 230730),
(240893, '3ibtA01', NULL, NULL, 195, NULL, NULL, 230730),
(240894, '1uxoA00', NULL, NULL, 192, NULL, NULL, 230730),
(240895, '4cfsA01', NULL, NULL, 217, NULL, NULL, 230730),
(240896, '2qmqA00', NULL, NULL, 286, NULL, NULL, 230730);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(240897, '4wy8A00', NULL, NULL, 327, NULL, NULL, 230730),
(240898, '2z8xA01', NULL, NULL, 326, NULL, NULL, 230730),
(240899, '4be9B00', NULL, NULL, 545, NULL, NULL, 230730),
(240900, '4hs9A00', NULL, NULL, 287, NULL, NULL, 230730),
(240901, '3wj2B00', NULL, NULL, 308, NULL, NULL, 230730),
(240902, '5ctaA00', NULL, NULL, 180, NULL, NULL, 230730),
(240903, '3ksrA02', NULL, NULL, 216, NULL, NULL, 230730),
(240904, '3qh4A00', NULL, NULL, 317, NULL, NULL, 230730),
(240905, '3tglA00', NULL, NULL, 269, NULL, NULL, 230730),
(240906, '5xmdB00', NULL, NULL, 322, NULL, NULL, 230730),
(240907, '4uhcA00', NULL, NULL, 282, NULL, NULL, 230730),
(240908, '5dtiB00', NULL, NULL, 545, NULL, NULL, 230730),
(240909, '5o3uB01', NULL, NULL, 369, NULL, NULL, 230730),
(240910, '2qubA01', NULL, NULL, 329, NULL, NULL, 230730),
(240911, '3afiB00', NULL, NULL, 316, NULL, NULL, 230730),
(240912, '6g75A00', NULL, NULL, 296, NULL, NULL, 230730),
(240913, '2jbwA02', NULL, NULL, 262, NULL, NULL, 230730),
(240914, '4ccyB00', NULL, NULL, 296, NULL, NULL, 230730),
(240915, '4xjvA00', NULL, NULL, 241, NULL, NULL, 230730),
(240916, '1hplA01', NULL, NULL, 338, NULL, NULL, 230730),
(240917, '3icvA00', NULL, NULL, 299, NULL, NULL, 230730),
(240918, '5hc0A00', NULL, NULL, 341, NULL, NULL, 230730),
(240919, '2gzsA00', NULL, NULL, 278, NULL, NULL, 230730),
(240920, '4u2dA00', NULL, NULL, 236, NULL, NULL, 230730),
(240921, '4q3lB00', NULL, NULL, 280, NULL, NULL, 230730),
(240922, '2xuaA00', NULL, NULL, 266, NULL, NULL, 230730),
(240923, '3ilsA00', NULL, NULL, 265, NULL, NULL, 230730),
(240924, '3bxpB00', NULL, NULL, 277, NULL, NULL, 230730),
(240925, '1gklA00', NULL, NULL, 297, NULL, NULL, 230730),
(240926, '3be8B00', NULL, NULL, 566, NULL, NULL, 230730),
(240927, '2qm0B01', NULL, NULL, 259, NULL, NULL, 230730),
(240928, '4x90A01', NULL, NULL, 209, NULL, NULL, 230730),
(240929, '2fx5A00', NULL, NULL, 258, NULL, NULL, 230730),
(240930, '2psfA00', NULL, NULL, 310, NULL, NULL, 230730),
(240931, '3bwxA00', NULL, NULL, 285, NULL, NULL, 230730),
(240932, '5lk6A00', NULL, NULL, 314, NULL, NULL, 230730),
(240933, '3pfbA00', NULL, NULL, 270, NULL, NULL, 230730),
(240934, '1r3dA00', NULL, NULL, 264, NULL, NULL, 230730),
(240935, '2xmzA00', NULL, NULL, 269, NULL, NULL, 230730),
(240936, '1q0rA00', NULL, NULL, 298, NULL, NULL, 230730),
(240937, '2qjwA00', NULL, NULL, 176, NULL, NULL, 230730),
(240938, '1uwcA00', NULL, NULL, 261, NULL, NULL, 230730),
(240939, '2x5xA00', NULL, NULL, 342, NULL, NULL, 230730),
(240940, '3bjrA00', NULL, NULL, 267, NULL, NULL, 230730),
(240941, '5lukA00', NULL, NULL, 265, NULL, NULL, 230730),
(240942, '3wj1A00', NULL, NULL, 305, NULL, NULL, 230730),
(240943, '1jkmA00', NULL, NULL, 361, NULL, NULL, 230730),
(240944, '2zshA00', NULL, NULL, 351, NULL, NULL, 230730),
(240945, '3ainA00', NULL, NULL, 283, NULL, NULL, 230730),
(240946, '4f0jA00', NULL, NULL, 315, NULL, NULL, 230730),
(240947, '4v2iA00', NULL, NULL, 323, NULL, NULL, 230730),
(240948, '2fj0A01', NULL, NULL, 541, NULL, NULL, 230730),
(240949, '3w06A00', NULL, NULL, 272, NULL, NULL, 230730),
(240950, '4g9eA00', NULL, NULL, 279, NULL, NULL, 230730),
(240951, '1c4xA00', NULL, NULL, 285, NULL, NULL, 230730),
(240952, '2wflA00', NULL, NULL, 264, NULL, NULL, 230730),
(240953, '5a7gA00', NULL, NULL, 532, NULL, NULL, 230730),
(240954, '2uz0A00', NULL, NULL, 263, NULL, NULL, 230730),
(240955, '4kafB00', NULL, NULL, 307, NULL, NULL, 230730),
(240956, '5zrqA00', NULL, NULL, 265, NULL, NULL, 230730),
(240957, '5z7wB00', NULL, NULL, 277, NULL, NULL, 230730),
(240958, '1womA00', NULL, NULL, 271, NULL, NULL, 230730),
(240959, '3bdvA00', NULL, NULL, 191, NULL, NULL, 230730),
(240960, '1azwA00', NULL, NULL, 313, NULL, NULL, 230730),
(240961, '3dkrA00', NULL, NULL, 251, NULL, NULL, 230730),
(240962, '2vatL00', NULL, NULL, 379, NULL, NULL, 230730),
(240963, '2ogtA00', NULL, NULL, 498, NULL, NULL, 230730),
(240964, '5a71A00', NULL, NULL, 317, NULL, NULL, 230730),
(240965, '3pe6A00', NULL, NULL, 303, NULL, NULL, 230730),
(240966, '3iujA01', NULL, NULL, 356, NULL, NULL, 230730),
(240967, '2cb9A01', NULL, NULL, 180, NULL, NULL, 230730);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(240968, '5hk8A00', NULL, NULL, 253, NULL, NULL, 230730),
(240969, '3g8yA00', NULL, NULL, 391, NULL, NULL, 230730),
(240970, '3rm3A00', NULL, NULL, 250, NULL, NULL, 230730),
(240971, '3ia2A00', NULL, NULL, 271, NULL, NULL, 230730),
(240972, '3eblA00', NULL, NULL, 365, NULL, NULL, 230730),
(240973, '3g7nB00', NULL, NULL, 258, NULL, NULL, 230730),
(240974, '5dnuA00', NULL, NULL, 275, NULL, NULL, 230730),
(240975, '2qruA00', NULL, NULL, 274, NULL, NULL, 230730),
(240976, '4x00A00', NULL, NULL, 283, NULL, NULL, 230730),
(240977, '5gw8B00', NULL, NULL, 286, NULL, NULL, 230730),
(240978, '3r0vA00', NULL, NULL, 262, NULL, NULL, 230730),
(240979, '1lnsA02', NULL, NULL, 321, NULL, NULL, 230730),
(240980, '4x71A00', NULL, NULL, 392, NULL, NULL, 230730),
(240981, '3tjmA01', NULL, NULL, 193, NULL, NULL, 230730),
(240982, '4g4gA00', NULL, NULL, 367, NULL, NULL, 230730),
(240983, '3v48A00', NULL, NULL, 268, NULL, NULL, 230730),
(240984, '3fsgA00', NULL, NULL, 272, NULL, NULL, 230730),
(240985, '3wzmA00', NULL, NULL, 278, NULL, NULL, 230730),
(240986, '3f67A00', NULL, NULL, 241, NULL, NULL, 230730),
(240987, '1e89A00', NULL, NULL, 262, NULL, NULL, 230730),
(240988, '3h04A00', NULL, NULL, 275, NULL, NULL, 230730),
(240989, '5oljA02', NULL, NULL, 252, NULL, NULL, 230730),
(240990, '1j1iA00', NULL, NULL, 296, NULL, NULL, 230730),
(240991, '4qlaB00', NULL, NULL, 391, NULL, NULL, 230730),
(240992, '5y6yB00', NULL, NULL, 326, NULL, NULL, 230730),
(240993, '3d2aA00', NULL, NULL, 181, NULL, NULL, 230730),
(240994, '3g02B00', NULL, NULL, 408, NULL, NULL, 230730),
(240995, '1gxsA00', NULL, NULL, 270, NULL, NULL, 230730),
(240996, '6cofA00', NULL, NULL, 260, NULL, NULL, 230730),
(240997, '5a62A00', NULL, NULL, 277, NULL, NULL, 230730),
(240998, '3om8B00', NULL, NULL, 266, NULL, NULL, 230730),
(240999, '1dx4A00', NULL, NULL, 551, NULL, NULL, 230730),
(241000, '3ajaB00', NULL, NULL, 267, NULL, NULL, 230730),
(241001, '1rp1A01', NULL, NULL, 338, NULL, NULL, 230730),
(241002, '2vsqA08', NULL, NULL, 232, NULL, NULL, 230730),
(241003, '1m33A00', NULL, NULL, 258, NULL, NULL, 230730),
(241004, '3nwoA00', NULL, NULL, 302, NULL, NULL, 230730),
(241005, '1ku0B00', NULL, NULL, 388, NULL, NULL, 230730),
(241006, '6emiA00', NULL, NULL, 532, NULL, NULL, 230730),
(241007, '4meaA00', NULL, NULL, 331, NULL, NULL, 230730),
(241008, '1wm1A00', NULL, NULL, 317, NULL, NULL, 230730),
(241009, '3bixA00', NULL, NULL, 574, NULL, NULL, 230730),
(241010, '2hfkA00', NULL, NULL, 290, NULL, NULL, 230730),
(241011, '1orvA02', NULL, NULL, 258, NULL, NULL, 230730),
(241012, '2i3dB00', NULL, NULL, 226, NULL, NULL, 230730),
(241013, '4zi5A00', NULL, NULL, 250, NULL, NULL, 230730),
(241014, '4ob7A00', NULL, NULL, 341, NULL, NULL, 230730),
(241015, '4c6hA00', NULL, NULL, 291, NULL, NULL, 230730),
(241016, '2o2gA00', NULL, NULL, 223, NULL, NULL, 230730),
(241017, '2c7bA00', NULL, NULL, 295, NULL, NULL, 230730),
(241018, '4rotA00', NULL, NULL, 268, NULL, NULL, 230730),
(241019, '4q1vA02', NULL, NULL, 259, NULL, NULL, 230730),
(241020, '5x88A00', NULL, NULL, 199, NULL, NULL, 230730),
(241021, '4nvrA00', NULL, NULL, 307, NULL, NULL, 230730),
(241022, '4eziA01', NULL, NULL, 283, NULL, NULL, 230730),
(241023, '5ch5A00', NULL, NULL, 577, NULL, NULL, 230730),
(241024, '1mpxA01', NULL, NULL, 271, NULL, NULL, 230730),
(241025, '3zwqA00', NULL, NULL, 313, NULL, NULL, 230730),
(241026, '6azdA00', NULL, NULL, 271, NULL, NULL, 230730),
(241027, '5w95B00', NULL, NULL, 285, NULL, NULL, 230730),
(241028, '5frdA00', NULL, NULL, 260, NULL, NULL, 230730),
(241029, '1yr2A01', NULL, NULL, 351, NULL, NULL, 230730),
(241030, '1jjfA00', NULL, NULL, 268, NULL, NULL, 230730),
(241031, '3e0xA00', NULL, NULL, 245, NULL, NULL, 230730),
(241032, '1a88A00', NULL, NULL, 275, NULL, NULL, 230730),
(241033, '3llcA00', NULL, NULL, 270, NULL, NULL, 230730),
(241034, '2pl5A01', NULL, NULL, 265, NULL, NULL, 230730),
(241035, '4qnnA00', NULL, NULL, 300, NULL, NULL, 230730),
(241036, '4krxA00', NULL, NULL, 316, NULL, NULL, 230730),
(241037, '1imjA00', NULL, NULL, 210, NULL, NULL, 230730),
(241038, '5efzC00', NULL, NULL, 340, NULL, NULL, 230730);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(241039, '2k2qB00', NULL, NULL, 242, NULL, NULL, 230730),
(241040, '3fcyA00', NULL, NULL, 317, NULL, NULL, 230730),
(241041, '6eqeA00', NULL, NULL, 270, NULL, NULL, 230730),
(241042, '6ap7A00', NULL, NULL, 269, NULL, NULL, 230730),
(241043, '5c8zA00', NULL, NULL, 267, NULL, NULL, 230730),
(241044, '2b9vA01', NULL, NULL, 315, NULL, NULL, 230730),
(241045, '3hxkA00', NULL, NULL, 276, NULL, NULL, 230730),
(241046, '4hvtA01', NULL, NULL, 322, NULL, NULL, 230730),
(241047, '2h1iA00', NULL, NULL, 226, NULL, NULL, 230730),
(241048, '4b6gA00', NULL, NULL, 283, NULL, NULL, 230730),
(241049, '3qpdA00', NULL, NULL, 187, NULL, NULL, 230730),
(241050, '5fdfB00', NULL, NULL, 337, NULL, NULL, 230730),
(241051, '5gmsA00', NULL, NULL, 297, NULL, NULL, 230730),
(241052, '3d7rA00', NULL, NULL, 298, NULL, NULL, 230730),
(241053, '1l7aA00', NULL, NULL, 318, NULL, NULL, 230730),
(241054, '3fobA00', NULL, NULL, 281, NULL, NULL, 230730),
(241055, '3azoA02', NULL, NULL, 283, NULL, NULL, 230730),
(241056, '3qvmB00', NULL, NULL, 282, NULL, NULL, 230730),
(241057, '1llfA00', NULL, NULL, 534, NULL, NULL, 230730),
(241058, '1sfrA00', NULL, NULL, 288, NULL, NULL, 230730),
(241059, '2oxeA01', NULL, NULL, 341, NULL, NULL, 230730),
(241060, '6ap8B00', NULL, NULL, 269, NULL, NULL, 230730),
(241061, '5z95A00', NULL, NULL, 276, NULL, NULL, 230730),
(241062, '3nuzE00', NULL, NULL, 398, NULL, NULL, 230730),
(241063, '4cg1A00', NULL, NULL, 263, NULL, NULL, 230730),
(241064, '1k4yA00', NULL, NULL, 534, NULL, NULL, 230730),
(241065, '4az3A00', NULL, NULL, 260, NULL, NULL, 230730),
(241066, '5fv4A00', NULL, NULL, 544, NULL, NULL, 230730),
(241067, '3vvmA01', NULL, NULL, 266, NULL, NULL, 230730),
(241068, '2ocgA00', NULL, NULL, 254, NULL, NULL, 230730),
(241069, '2zyrA01', NULL, NULL, 217, NULL, NULL, 230730),
(241070, '2qs9A00', NULL, NULL, 194, NULL, NULL, 230730),
(241071, '3p2mA00', NULL, NULL, 293, NULL, NULL, 230730),
(241072, '3styB00', NULL, NULL, 267, NULL, NULL, 230730),
(241073, '1fj2A00', NULL, NULL, 232, NULL, NULL, 230730),
(241074, '3trdA00', NULL, NULL, 208, NULL, NULL, 230730),
(241075, '3ngmA00', NULL, NULL, 319, NULL, NULL, 230730),
(241076, '3c6xA00', NULL, NULL, 257, NULL, NULL, 230730),
(241077, '2r8bA00', NULL, NULL, 209, NULL, NULL, 230730),
(241078, '4l0cA00', NULL, NULL, 255, NULL, NULL, 230730),
(241079, '5w1uA00', NULL, NULL, 540, NULL, NULL, 230730),
(241080, '2bklA01', NULL, NULL, 340, NULL, NULL, 230730),
(241081, '6aryA00', NULL, NULL, 542, NULL, NULL, 230730),
(241082, '2y6uA01', NULL, NULL, 354, NULL, NULL, 230730),
(241083, '2ecfA02', NULL, NULL, 260, NULL, NULL, 230730),
(241084, '5hq3B00', NULL, NULL, 549, NULL, NULL, 230730),
(241085, '5xeqA00', NULL, NULL, 576, NULL, NULL, 230730),
(241086, '4ccwA00', NULL, NULL, 299, NULL, NULL, 230730),
(241087, '4hxfB02', NULL, NULL, 271, NULL, NULL, 230730),
(241088, '4oseB00', NULL, NULL, 298, NULL, NULL, 230730),
(241089, '1ex9A00', NULL, NULL, 285, NULL, NULL, 230730),
(241090, '2r11D00', NULL, NULL, 288, NULL, NULL, 230730),
(241091, '3d0kB00', NULL, NULL, 304, NULL, NULL, 230730),
(241092, '4q82A00', NULL, NULL, 237, NULL, NULL, 230730),
(241093, '3jw8A00', NULL, NULL, 298, NULL, NULL, 230730),
(241094, '1qozA00', NULL, NULL, 207, NULL, NULL, 230730),
(241095, '5bovB00', NULL, NULL, 304, NULL, NULL, 230730),
(241096, '6aidA00', NULL, NULL, 261, NULL, NULL, 230730),
(241097, '4fhzA00', NULL, NULL, 220, NULL, NULL, 230730),
(241098, '1qe3A00', NULL, NULL, 489, NULL, NULL, 230730),
(241099, '1thtA00', NULL, NULL, 305, NULL, NULL, 230730),
(241100, '4m0eA00', NULL, NULL, 542, NULL, NULL, 230730),
(241101, '5egnA00', NULL, NULL, 271, NULL, NULL, 230730),
(241102, '2xe4A01', NULL, NULL, 370, NULL, NULL, 230730),
(241103, '3hlkB02', NULL, NULL, 280, NULL, NULL, 230730),
(241104, '4pw0A00', NULL, NULL, 283, NULL, NULL, 230730),
(241105, '3iiiA01', NULL, NULL, 288, NULL, NULL, 230730),
(241106, '4inzA00', NULL, NULL, 286, NULL, NULL, 230730),
(241107, '4j7aA00', NULL, NULL, 355, NULL, NULL, 230730),
(241108, '1ac5A00', NULL, NULL, 483, NULL, NULL, 230730),
(241109, '2wtmA00', NULL, NULL, 251, NULL, NULL, 230730);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(241110, '3c5vA00', NULL, NULL, 316, NULL, NULL, 230730),
(241111, '1ehyA00', NULL, NULL, 294, NULL, NULL, 230730),
(241112, '1cpyA01', NULL, NULL, 349, NULL, NULL, 230730),
(241113, '3ga7A00', NULL, NULL, 326, NULL, NULL, 230730),
(241114, '2hm7A00', NULL, NULL, 310, NULL, NULL, 230730),
(241115, '4l3wA00', NULL, NULL, 265, NULL, NULL, 230730),
(241116, '3kxpA00', NULL, NULL, 268, NULL, NULL, 230730),
(241117, '5n4bA01', NULL, NULL, 363, NULL, NULL, 230730),
(241118, '5cmlA00', NULL, NULL, 263, NULL, NULL, 230730),
(241119, '1a8qA00', NULL, NULL, 274, NULL, NULL, 230730),
(241120, '5ap9A00', NULL, NULL, 269, NULL, NULL, 230730),
(241121, '3ds8A00', NULL, NULL, 254, NULL, NULL, 230730),
(241122, '4oylA00', NULL, NULL, 194, NULL, NULL, 230730),
(241123, '6agqA00', NULL, NULL, 321, NULL, NULL, 230730),
(241124, '3fnbA02', NULL, NULL, 270, NULL, NULL, 230730),
(241125, '3hc7A01', NULL, NULL, 192, NULL, NULL, 230730),
(241126, '4fkbA00', NULL, NULL, 388, NULL, NULL, 230730),
(241127, '2q0xA01', NULL, NULL, 287, NULL, NULL, 230730),
(241128, '5yhpB00', NULL, NULL, 319, NULL, NULL, 230730),
(241129, '3wlaA00', NULL, NULL, 336, NULL, NULL, 230730),
(241130, '5t88A01', NULL, NULL, 302, NULL, NULL, 230730),
(241131, '1jmkC01', NULL, NULL, 172, NULL, NULL, 230730),
(241132, '2xt0A00', NULL, NULL, 297, NULL, NULL, 230730),
(241133, '2czqA00', NULL, NULL, 205, NULL, NULL, 230730),
(241134, '5ch8A00', NULL, NULL, 279, NULL, NULL, 230730),
(241135, '4h18A00', NULL, NULL, 342, NULL, NULL, 230730),
(241136, '4psuA00', NULL, NULL, 295, NULL, NULL, 230730),
(241137, '3lp5A00', NULL, NULL, 250, NULL, NULL, 230730),
(241138, '1jjiA00', NULL, NULL, 311, NULL, NULL, 230730),
(241139, '1lzlA00', NULL, NULL, 323, NULL, NULL, 230730),
(241140, '3dohA02', NULL, NULL, 240, NULL, NULL, 230730),
(241141, '5uy1A00', NULL, NULL, 302, NULL, NULL, 230730),
(241142, '1pjaA00', NULL, NULL, 268, NULL, NULL, 230730),
(241143, '3d59A00', NULL, NULL, 383, NULL, NULL, 230730),
(241144, '4qa9A00', NULL, NULL, 388, NULL, NULL, 230730),
(241145, '6cl4A00', NULL, NULL, 290, NULL, NULL, 230730),
(241146, '4q05A00', NULL, NULL, 327, NULL, NULL, 230730),
(241147, '5dwdB00', NULL, NULL, 240, NULL, NULL, 230730),
(241148, '4dgqA00', NULL, NULL, 280, NULL, NULL, 230730),
(241149, '3u1tB00', NULL, NULL, 309, NULL, NULL, 230730),
(241150, '1ei9A00', NULL, NULL, 279, NULL, NULL, 230730),
(241151, '4c89C00', NULL, NULL, 354, NULL, NULL, 230730),
(241152, '3qmvB00', NULL, NULL, 254, NULL, NULL, 230730),
(241153, '3i6yA00', NULL, NULL, 280, NULL, NULL, 230730),
(241154, '5ai0A03', NULL, NULL, 312, NULL, NULL, 230730),
(241155, '4j0cA00', NULL, NULL, 470, NULL, NULL, 230730),
(241156, '5ajhA00', NULL, NULL, 208, NULL, NULL, 230730),
(241157, '5d6oA00', NULL, NULL, 349, NULL, NULL, 230730),
(241158, '4wjlB02', NULL, NULL, 254, NULL, NULL, 230730),
(241159, '4opmA00', NULL, NULL, 306, NULL, NULL, 230730),
(241160, '3fakA00', NULL, NULL, 322, NULL, NULL, 230730),
(241161, '1zoiA00', NULL, NULL, 276, NULL, NULL, 230730),
(241162, '3qpaA00', NULL, NULL, 197, NULL, NULL, 230730),
(241163, '1lpbB01', NULL, NULL, 338, NULL, NULL, 230730),
(241164, '5tdxC00', NULL, NULL, 272, NULL, NULL, 230730),
(241165, '4rncA00', NULL, NULL, 289, NULL, NULL, 230730),
(241166, '4ao8A00', NULL, NULL, 243, NULL, NULL, 230730),
(241167, '5ao9A00', NULL, NULL, 286, NULL, NULL, 230730),
(241168, '4fblB00', NULL, NULL, 246, NULL, NULL, 230730),
(241169, '2yijB00', NULL, NULL, 398, NULL, NULL, 230730),
(241170, '6g1uB00', NULL, NULL, 534, NULL, NULL, 230730),
(241171, '2roqA02', NULL, NULL, 246, NULL, NULL, 230730),
(241172, '4mj3B00', NULL, NULL, 303, NULL, NULL, 230730),
(241173, '4h0cA00', NULL, NULL, 210, NULL, NULL, 230730),
(241174, '2b61A01', NULL, NULL, 253, NULL, NULL, 230730),
(241175, '5d3kA00', NULL, NULL, 269, NULL, NULL, 230730),
(241176, '4eb0A00', NULL, NULL, 258, NULL, NULL, 230730),
(241177, '3h2gA01', NULL, NULL, 289, NULL, NULL, 230730),
(241178, '1vkhA00', NULL, NULL, 273, NULL, NULL, 230730),
(241179, '4n5hX00', NULL, NULL, 317, NULL, NULL, 230730),
(241180, '1gplA01', NULL, NULL, 321, NULL, NULL, 230730);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(241181, '2rauA00', NULL, NULL, 354, NULL, NULL, 230730),
(241182, '1ethA01', NULL, NULL, 338, NULL, NULL, 230730),
(241183, '1b6gA00', NULL, NULL, 310, NULL, NULL, 230730),
(241184, '1zi8A00', NULL, NULL, 236, NULL, NULL, 230730),
(241185, '5w8oA00', NULL, NULL, 363, NULL, NULL, 230730),
(241186, '1cvlA00', NULL, NULL, 319, NULL, NULL, 230730),
(241187, '3wwpA00', NULL, NULL, 266, NULL, NULL, 230730),
(241188, '4w9rB01', NULL, NULL, 269, NULL, NULL, 230730),
(241189, '1iupA00', NULL, NULL, 282, NULL, NULL, 230730),
(241190, '4pf1A01', NULL, NULL, 270, NULL, NULL, 230730),
(241191, '1qfmA01', NULL, NULL, 352, NULL, NULL, 230730),
(241192, '4q3oA00', NULL, NULL, 318, NULL, NULL, 230730),
(241193, '1w52X01', NULL, NULL, 339, NULL, NULL, 230730),
(241194, '5xksF00', NULL, NULL, 256, NULL, NULL, 230730),
(241195, '5cxxB00', NULL, NULL, 275, NULL, NULL, 230730),
(241196, '5jd4A00', NULL, NULL, 317, NULL, NULL, 230730),
(241197, '1whtA00', NULL, NULL, 256, NULL, NULL, 230730),
(241198, '4i4cB00', NULL, NULL, 398, NULL, NULL, 230730),
(241199, '3o4hA02', NULL, NULL, 261, NULL, NULL, 230730),
(241200, '2hihB00', NULL, NULL, 390, NULL, NULL, 230730),
(241201, '1gz7A00', NULL, NULL, 534, NULL, NULL, 230730),
(241202, '5w8pB00', NULL, NULL, 370, NULL, NULL, 230730),
(241203, '3fcxB00', NULL, NULL, 282, NULL, NULL, 230730),
(241204, '3dcnA00', NULL, NULL, 201, NULL, NULL, 230730),
(241205, '5ah0A00', NULL, NULL, 387, NULL, NULL, 230730),
(241206, '3i2kA01', NULL, NULL, 253, NULL, NULL, 230730),
(241207, '3b5eB00', NULL, NULL, 223, NULL, NULL, 230730),
(241208, '3k2iA02', NULL, NULL, 291, NULL, NULL, 230730),
(241209, '1thgA00', NULL, NULL, 544, NULL, NULL, 230730),
(241210, '3hssA00', NULL, NULL, 275, NULL, NULL, 230730),
(241211, '1qgeD00', NULL, NULL, 222, NULL, NULL, 230730),
(241212, '3og9A00', NULL, NULL, 209, NULL, NULL, 230730),
(241213, '2hdwA01', NULL, NULL, 230, NULL, NULL, 230730),
(241214, '1k8qA00', NULL, NULL, 377, NULL, NULL, 230730),
(241215, '4h3wB01', NULL, NULL, 125, NULL, NULL, 230731),
(241216, '4h3wA01', NULL, NULL, 125, NULL, NULL, 230731),
(241217, '3vorA00', NULL, NULL, 182, NULL, NULL, 230732),
(241218, '1oqvA00', NULL, NULL, 171, NULL, NULL, 230732),
(241219, '1zwtA00', NULL, NULL, 158, NULL, NULL, 230732),
(241220, '3hrvB00', NULL, NULL, 170, NULL, NULL, 230732),
(241221, '3fhvA00', NULL, NULL, 156, NULL, NULL, 230732),
(241222, '3ecsE01', NULL, NULL, 104, NULL, NULL, 230733),
(241223, '3o2zG01', NULL, NULL, 49, NULL, NULL, 230734),
(241224, '2vxzA02', NULL, NULL, 95, NULL, NULL, 230735),
(241225, '4a57A02', NULL, NULL, 366, NULL, NULL, 230736),
(241226, '3agrA02', NULL, NULL, 364, NULL, NULL, 230736),
(241227, '5w0kA01', NULL, NULL, 325, NULL, NULL, 230737),
(241228, '4xc5B00', NULL, NULL, 164, NULL, NULL, 230738),
(241229, '2oj5D00', NULL, NULL, 165, NULL, NULL, 230738),
(241230, '1tt5B03', NULL, NULL, 61, NULL, NULL, 230739),
(241231, '4k0dA00', NULL, NULL, 152, NULL, NULL, 230740),
(241232, '3vziB00', NULL, NULL, 226, NULL, NULL, 230741),
(241233, '3vzhA00', NULL, NULL, 214, NULL, NULL, 230741),
(241234, '3kg4A00', NULL, NULL, 202, NULL, NULL, 230741),
(241235, '4f3mA00', NULL, NULL, 222, NULL, NULL, 230741),
(241236, '4r0jA00', NULL, NULL, 216, NULL, NULL, 230741),
(241237, '4n77A00', NULL, NULL, 205, NULL, NULL, 230741),
(241238, '5h9fJ00', NULL, NULL, 224, NULL, NULL, 230741),
(241239, '3vkgA20', NULL, NULL, 134, NULL, NULL, 230742),
(241240, '2r4gA01', NULL, NULL, 203, NULL, NULL, 230743),
(241241, '4lmoA00', NULL, NULL, 254, NULL, NULL, 230743),
(241242, '4o26B00', NULL, NULL, 257, NULL, NULL, 230743),
(241243, '5c9hB01', NULL, NULL, 202, NULL, NULL, 230743),
(241244, '5cqgA01', NULL, NULL, 150, NULL, NULL, 230743),
(241245, '3eabG00', NULL, NULL, 50, NULL, NULL, 230744),
(241246, '1ezgA00', NULL, NULL, 84, NULL, NULL, 230745),
(241247, '6aeqA00', NULL, NULL, 72, NULL, NULL, 230746),
(241248, '4ou7A00', NULL, NULL, 71, NULL, NULL, 230746),
(241249, '4pkfB00', NULL, NULL, 81, NULL, NULL, 230747),
(241250, '5z0fB01', NULL, NULL, 73, NULL, NULL, 230748),
(241251, '2jv8A00', NULL, NULL, 73, NULL, NULL, 230748);
INSERT INTO "PUBLIC"."MODEL" VALUES
(241252, '1wxcB01', NULL, NULL, 73, NULL, NULL, 230748),
(241253, '4jkxA02', NULL, NULL, 82, NULL, NULL, 230749),
(241254, '1gikA02', NULL, NULL, 81, NULL, NULL, 230749),
(241255, '1llnA02', NULL, NULL, 87, NULL, NULL, 230749),
(241256, '1bryY02', NULL, NULL, 85, NULL, NULL, 230749),
(241257, '4fb9A02', NULL, NULL, 104, NULL, NULL, 230749),
(241258, '3h5kA02', NULL, NULL, 81, NULL, NULL, 230749),
(241259, '1apaA02', NULL, NULL, 81, NULL, NULL, 230749),
(241260, '2pqgB02', NULL, NULL, 77, NULL, NULL, 230749),
(241261, '2oqaA02', NULL, NULL, 80, NULL, NULL, 230749),
(241262, '4hr6B02', NULL, NULL, 86, NULL, NULL, 230749),
(241263, '2q8wA02', NULL, NULL, 81, NULL, NULL, 230749),
(241264, '1dm0L02', NULL, NULL, 115, NULL, NULL, 230749),
(241265, '3mvgB02', NULL, NULL, 87, NULL, NULL, 230749),
(241266, '1ce7A02', NULL, NULL, 79, NULL, NULL, 230749),
(241267, '1ggpA02', NULL, NULL, 85, NULL, NULL, 230749),
(241268, '5z37A02', NULL, NULL, 85, NULL, NULL, 230749),
(241269, '2zr1A02', NULL, NULL, 91, NULL, NULL, 230749),
(241270, '2b7uA02', NULL, NULL, 82, NULL, NULL, 230749),
(241271, '2vlcA02', NULL, NULL, 117, NULL, NULL, 230749),
(241272, '1rl0A02', NULL, NULL, 74, NULL, NULL, 230749),
(241273, '4yp2B02', NULL, NULL, 84, NULL, NULL, 230749),
(241274, '3sj6A02', NULL, NULL, 84, NULL, NULL, 230749),
(241275, '1nioA02', NULL, NULL, 85, NULL, NULL, 230749),
(241276, '1m2tA02', NULL, NULL, 87, NULL, NULL, 230749),
(241277, '2z4uA02', NULL, NULL, 81, NULL, NULL, 230749),
(241278, '1mrjA02', NULL, NULL, 85, NULL, NULL, 230749),
(241279, '4za3A02', NULL, NULL, 84, NULL, NULL, 230749),
(241280, '3ktzA02', NULL, NULL, 83, NULL, NULL, 230749),
(241281, '4m1uA02', NULL, NULL, 127, NULL, NULL, 230749),
(241282, '3px8X02', NULL, NULL, 82, NULL, NULL, 230749),
(241283, '1onkA02', NULL, NULL, 81, NULL, NULL, 230749),
(241284, '1qi7A02', NULL, NULL, 72, NULL, NULL, 230749),
(241285, '1qciA02', NULL, NULL, 81, NULL, NULL, 230749),
(241286, '1cf5A02', NULL, NULL, 86, NULL, NULL, 230749),
(241287, '3bwhA02', NULL, NULL, 85, NULL, NULL, 230749),
(241288, '2g5xA02', NULL, NULL, 62, NULL, NULL, 230749),
(241289, '3hisA02', NULL, NULL, 83, NULL, NULL, 230749),
(241290, '4eb2A02', NULL, NULL, 80, NULL, NULL, 230749),
(241291, '2vs6B02', NULL, NULL, 85, NULL, NULL, 230749),
(241292, '3ctkA02', NULL, NULL, 81, NULL, NULL, 230749),
(241293, '1hwmA02', NULL, NULL, 89, NULL, NULL, 230749),
(241294, '1ygyB03', NULL, NULL, 139, NULL, NULL, 230750),
(241295, '2iafA00', NULL, NULL, 151, NULL, NULL, 230750),
(241296, '2x49A04', NULL, NULL, 99, NULL, NULL, 230751),
(241297, '1lcuA02', NULL, NULL, 34, NULL, NULL, 230752),
(241298, '6av9A02', NULL, NULL, 34, NULL, NULL, 230752),
(241299, '6av9B02', NULL, NULL, 34, NULL, NULL, 230752),
(241300, '6av9C02', NULL, NULL, 34, NULL, NULL, 230752),
(241301, '1yagA02', NULL, NULL, 34, NULL, NULL, 230752),
(241302, '1k8kA02', NULL, NULL, 41, NULL, NULL, 230752),
(241303, '2pbdA02', NULL, NULL, 41, NULL, NULL, 230752),
(241304, '6avbC02', NULL, NULL, 34, NULL, NULL, 230752),
(241305, '6avbA02', NULL, NULL, 34, NULL, NULL, 230752),
(241306, '6avbB02', NULL, NULL, 34, NULL, NULL, 230752),
(241307, '5uboA02', NULL, NULL, 41, NULL, NULL, 230752),
(241308, '2v6eA04', NULL, NULL, 97, NULL, NULL, 230753),
(241309, '2hsiA01', NULL, NULL, 100, NULL, NULL, 230754),
(241310, '2i5eA02', NULL, NULL, 43, NULL, NULL, 230755),
(241311, '3s0xA01', NULL, NULL, 157, NULL, NULL, 230756),
(241312, '4oi3A00', NULL, NULL, 89, NULL, NULL, 230757),
(241313, '4hvzA02', NULL, NULL, 112, NULL, NULL, 230758),
(241314, '2j58A03', NULL, NULL, 81, NULL, NULL, 230759),
(241315, '3trkA01', NULL, NULL, 138, NULL, NULL, 230760),
(241316, '5ezqA01', NULL, NULL, 149, NULL, NULL, 230760),
(241317, '4guaA01', NULL, NULL, 153, NULL, NULL, 230760),
(241318, '2z2mD02', NULL, NULL, 42, NULL, NULL, 230761),
(241319, '3dwlF00', NULL, NULL, 168, NULL, NULL, 230762),
(241320, '3dwlD02', NULL, NULL, 187, NULL, NULL, 230762),
(241321, '1k8kD01', NULL, NULL, 151, NULL, NULL, 230762),
(241322, '1k8kF00', NULL, NULL, 168, NULL, NULL, 230762);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(241323, '1k8kD02', NULL, NULL, 131, NULL, NULL, 230762),
(241324, '3dwlD01', NULL, NULL, 129, NULL, NULL, 230762),
(241325, '1y02A01', NULL, NULL, 82, NULL, NULL, 230763),
(241326, '1dl5A02', NULL, NULL, 116, NULL, NULL, 230764),
(241327, '2kkxA00', NULL, NULL, 102, NULL, NULL, 230765),
(241328, '1mhwC00', NULL, NULL, 42, NULL, NULL, 230766),
(241329, '4oelB00', NULL, NULL, 70, NULL, NULL, 230766),
(241330, '2cs3A01', NULL, NULL, 59, NULL, NULL, 230767),
(241331, '5b7wA01', NULL, NULL, 79, NULL, NULL, 230768),
(241332, '2jz5A00', NULL, NULL, 91, NULL, NULL, 230768),
(241333, '2khdA00', NULL, NULL, 108, NULL, NULL, 230768),
(241334, '1in0A01', NULL, NULL, 71, NULL, NULL, 230768),
(241335, '2k3iA01', NULL, NULL, 85, NULL, NULL, 230768),
(241336, '3hagA02', NULL, NULL, 141, NULL, NULL, 230769),
(241337, '1vr6D01', NULL, NULL, 82, NULL, NULL, 230770),
(241338, '1rzmA01', NULL, NULL, 80, NULL, NULL, 230770),
(241339, '2e30B01', NULL, NULL, 22, NULL, NULL, 230771),
(241340, '4gf4A00', NULL, NULL, 418, NULL, NULL, 230772),
(241341, '5ffgA01', NULL, NULL, 439, NULL, NULL, 230773),
(241342, '5e6sC01', NULL, NULL, 400, NULL, NULL, 230773),
(241343, '4wk0A00', NULL, NULL, 452, NULL, NULL, 230773),
(241344, '3t3pC00', NULL, NULL, 457, NULL, NULL, 230773),
(241345, '4irzA01', NULL, NULL, 433, NULL, NULL, 230773),
(241346, '4nehA01', NULL, NULL, 390, NULL, NULL, 230773),
(241347, '2pyqA00', NULL, NULL, 114, NULL, NULL, 230774),
(241348, '2pyqD00', NULL, NULL, 114, NULL, NULL, 230774),
(241349, '2pyqC00', NULL, NULL, 114, NULL, NULL, 230774),
(241350, '2pyqB00', NULL, NULL, 114, NULL, NULL, 230774),
(241351, '3qq2B00', NULL, NULL, 266, NULL, NULL, 230775),
(241352, '3aehA00', NULL, NULL, 308, NULL, NULL, 230775),
(241353, '3kvnA02', NULL, NULL, 308, NULL, NULL, 230775),
(241354, '4meeA00', NULL, NULL, 325, NULL, NULL, 230775),
(241355, '1uynX00', NULL, NULL, 308, NULL, NULL, 230775),
(241356, '3sltA00', NULL, NULL, 313, NULL, NULL, 230775),
(241357, '4bpeY02', NULL, NULL, 98, NULL, NULL, 230776),
(241358, '5ll6T02', NULL, NULL, 106, NULL, NULL, 230776),
(241359, '5xxuG02', NULL, NULL, 91, NULL, NULL, 230776),
(241360, '3j7aH02', NULL, NULL, 83, NULL, NULL, 230776),
(241361, '5a2qG02', NULL, NULL, 100, NULL, NULL, 230776),
(241362, '3jamG02', NULL, NULL, 106, NULL, NULL, 230776),
(241363, '3hhsA01', NULL, NULL, 146, NULL, NULL, 230777),
(241364, '3hhsB01', NULL, NULL, 141, NULL, NULL, 230777),
(241365, '1llaA01', NULL, NULL, 109, NULL, NULL, 230777),
(241366, '3wkyB01', NULL, NULL, 131, NULL, NULL, 230777),
(241367, '4yzwA01', NULL, NULL, 165, NULL, NULL, 230777),
(241368, '1afoA00', NULL, NULL, 40, NULL, NULL, 230778),
(241369, '2j58A04', NULL, NULL, 35, NULL, NULL, 230778),
(241370, '4kkrA02', NULL, NULL, 113, NULL, NULL, 230779),
(241371, '4kkrA01', NULL, NULL, 128, NULL, NULL, 230779),
(241372, '3bg2A02', NULL, NULL, 121, NULL, NULL, 230780),
(241373, '2pgsA02', NULL, NULL, 119, NULL, NULL, 230780),
(241374, '4dvzA02', NULL, NULL, 148, NULL, NULL, 230781),
(241375, '4dvyP03', NULL, NULL, 179, NULL, NULL, 230781),
(241376, '3rv1A01', NULL, NULL, 84, NULL, NULL, 230782),
(241377, '3m7kA00', NULL, NULL, 142, NULL, NULL, 230783),
(241378, '2ztbA01', NULL, NULL, 98, NULL, NULL, 230784),
(241379, '3v67A01', NULL, NULL, 126, NULL, NULL, 230785),
(241380, '3e33A00', NULL, NULL, 323, NULL, NULL, 230786),
(241381, '4l9pA00', NULL, NULL, 351, NULL, NULL, 230786),
(241382, '3draA00', NULL, NULL, 306, NULL, NULL, 230786),
(241383, '1dceA01', NULL, NULL, 318, NULL, NULL, 230786),
(241384, '2h6fA00', NULL, NULL, 328, NULL, NULL, 230786),
(241385, '3q7aA00', NULL, NULL, 331, NULL, NULL, 230786),
(241386, '3dssA00', NULL, NULL, 331, NULL, NULL, 230786),
(241387, '3pqhA02', NULL, NULL, 25, NULL, NULL, 230787),
(241388, '1v5iB00', NULL, NULL, 76, NULL, NULL, 230788),
(241389, '3t41B01', NULL, NULL, 66, NULL, NULL, 230788),
(241390, '3afgB01', NULL, NULL, 93, NULL, NULL, 230788),
(241391, '3whiA01', NULL, NULL, 70, NULL, NULL, 230788),
(241392, '1scjB00', NULL, NULL, 71, NULL, NULL, 230788),
(241393, '1r6vA02', NULL, NULL, 78, NULL, NULL, 230788);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(241394, '4nmxA01', NULL, NULL, 88, NULL, NULL, 230788),
(241395, '3cnqP00', NULL, NULL, 80, NULL, NULL, 230788),
(241396, '2z30B00', NULL, NULL, 65, NULL, NULL, 230788),
(241397, '3vv2B00', NULL, NULL, 69, NULL, NULL, 230788),
(241398, '1itpA00', NULL, NULL, 77, NULL, NULL, 230788),
(241399, '1spbP00', NULL, NULL, 78, NULL, NULL, 230788),
(241400, '4yn3B00', NULL, NULL, 96, NULL, NULL, 230788),
(241401, '1khcA02', NULL, NULL, 69, NULL, NULL, 230789),
(241402, '3llrA02', NULL, NULL, 76, NULL, NULL, 230789),
(241403, '3d03A01', NULL, NULL, 131, NULL, NULL, 230790),
(241404, '1ev0A00', NULL, NULL, 58, NULL, NULL, 230791),
(241405, '3ku7B00', NULL, NULL, 62, NULL, NULL, 230791),
(241406, '3ku7A00', NULL, NULL, 80, NULL, NULL, 230791),
(241407, '2kxoA01', NULL, NULL, 61, NULL, NULL, 230791),
(241408, '1txuA01', NULL, NULL, 106, NULL, NULL, 230792),
(241409, '2ot3A01', NULL, NULL, 104, NULL, NULL, 230792),
(241410, '2efeA01', NULL, NULL, 81, NULL, NULL, 230792),
(241411, '1zmrA02', NULL, NULL, 209, NULL, NULL, 230793),
(241412, '1zmrA01', NULL, NULL, 178, NULL, NULL, 230793),
(241413, '4ng4B01', NULL, NULL, 190, NULL, NULL, 230793),
(241414, '4ng4C02', NULL, NULL, 213, NULL, NULL, 230793),
(241415, '4feyA02', NULL, NULL, 214, NULL, NULL, 230793),
(241416, '4feyA01', NULL, NULL, 181, NULL, NULL, 230793),
(241417, '4dg5A02', NULL, NULL, 202, NULL, NULL, 230793),
(241418, '4dg5A01', NULL, NULL, 182, NULL, NULL, 230793),
(241419, '1fw8A02', NULL, NULL, 190, NULL, NULL, 230793),
(241420, '1fw8A01', NULL, NULL, 226, NULL, NULL, 230793),
(241421, '3oz7A01', NULL, NULL, 187, NULL, NULL, 230793),
(241422, '3oz7A02', NULL, NULL, 209, NULL, NULL, 230793),
(241423, '3q3vB02', NULL, NULL, 204, NULL, NULL, 230793),
(241424, '3q3vA01', NULL, NULL, 177, NULL, NULL, 230793),
(241425, '2wzbA02', NULL, NULL, 209, NULL, NULL, 230793),
(241426, '1hdiA02', NULL, NULL, 209, NULL, NULL, 230793),
(241427, '1hdiA01', NULL, NULL, 185, NULL, NULL, 230793),
(241428, '1phpA02', NULL, NULL, 205, NULL, NULL, 230793),
(241429, '2p9tA02', NULL, NULL, 209, NULL, NULL, 230793),
(241430, '2p9tA01', NULL, NULL, 188, NULL, NULL, 230793),
(241431, '1phpA01', NULL, NULL, 170, NULL, NULL, 230793),
(241432, '3zlbA01', NULL, NULL, 177, NULL, NULL, 230793),
(241433, '3zlbA02', NULL, NULL, 202, NULL, NULL, 230793),
(241434, '1vpeA01', NULL, NULL, 169, NULL, NULL, 230793),
(241435, '1vpeA02', NULL, NULL, 208, NULL, NULL, 230793),
(241436, '16pkA01', NULL, NULL, 188, NULL, NULL, 230793),
(241437, '5bt8B01', NULL, NULL, 184, NULL, NULL, 230793),
(241438, '5bt8A02', NULL, NULL, 219, NULL, NULL, 230793),
(241439, '16pkA02', NULL, NULL, 208, NULL, NULL, 230793),
(241440, '2cunA02', NULL, NULL, 201, NULL, NULL, 230793),
(241441, '1vjdA01', NULL, NULL, 186, NULL, NULL, 230793),
(241442, '2cunA01', NULL, NULL, 209, NULL, NULL, 230793),
(241443, '3uwdA01', NULL, NULL, 170, NULL, NULL, 230793),
(241444, '3uwdA02', NULL, NULL, 205, NULL, NULL, 230793),
(241445, '1qpgA01', NULL, NULL, 186, NULL, NULL, 230793),
(241446, '5m1rA01', NULL, NULL, 188, NULL, NULL, 230793),
(241447, '1v6sA02', NULL, NULL, 213, NULL, NULL, 230793),
(241448, '3pgkA02', NULL, NULL, 209, NULL, NULL, 230793),
(241449, '1v6sA01', NULL, NULL, 177, NULL, NULL, 230793),
(241450, '1zavA02', NULL, NULL, 45, NULL, NULL, 230794),
(241451, '4gu4A01', NULL, NULL, 56, NULL, NULL, 230795),
(241452, '2vrsA02', NULL, NULL, 40, NULL, NULL, 230795),
(241453, '1v1hD00', NULL, NULL, 103, NULL, NULL, 230795),
(241454, '2bsfA01', NULL, NULL, 31, NULL, NULL, 230795),
(241455, '1v1hF01', NULL, NULL, 73, NULL, NULL, 230795),
(241456, '3s6xC03', NULL, NULL, 40, NULL, NULL, 230795),
(241457, '2mz8A00', NULL, NULL, 133, NULL, NULL, 230796),
(241458, '4q11A00', NULL, NULL, 133, NULL, NULL, 230796),
(241459, '1k3eB01', NULL, NULL, 40, NULL, NULL, 230797),
(241460, '1k3eA01', NULL, NULL, 51, NULL, NULL, 230797),
(241461, '1y0kA00', NULL, NULL, 209, NULL, NULL, 230798),
(241462, '2zihC00', NULL, NULL, 283, NULL, NULL, 230799),
(241463, '3kn1A00', NULL, NULL, 249, NULL, NULL, 230799),
(241464, '2nxcA02', NULL, NULL, 41, NULL, NULL, 230800);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(241465, '2nxnA02', NULL, NULL, 38, NULL, NULL, 230800),
(241466, '2iazA00', NULL, NULL, 113, NULL, NULL, 230801),
(241467, '2oeeB00', NULL, NULL, 117, NULL, NULL, 230801),
(241468, '2pihA00', NULL, NULL, 124, NULL, NULL, 230801),
(241469, '2oeeA00', NULL, NULL, 117, NULL, NULL, 230801),
(241470, '2oeqB00', NULL, NULL, 122, NULL, NULL, 230801),
(241471, '2oeqA00', NULL, NULL, 122, NULL, NULL, 230801),
(241472, '2oeqD00', NULL, NULL, 122, NULL, NULL, 230801),
(241473, '2oeqC00', NULL, NULL, 122, NULL, NULL, 230801),
(241474, '1x22A00', NULL, NULL, 42, NULL, NULL, 230802),
(241475, '1kv4A00', NULL, NULL, 42, NULL, NULL, 230802),
(241476, '2jr8A00', NULL, NULL, 42, NULL, NULL, 230802),
(241477, '3p2jA00', NULL, NULL, 191, NULL, NULL, 230803),
(241478, '4qajA00', NULL, NULL, 194, NULL, NULL, 230803),
(241479, '3neaA00', NULL, NULL, 187, NULL, NULL, 230803),
(241480, '2pthA00', NULL, NULL, 193, NULL, NULL, 230803),
(241481, '1rybA00', NULL, NULL, 205, NULL, NULL, 230803),
(241482, '4p7bC00', NULL, NULL, 200, NULL, NULL, 230803),
(241483, '3v2iA00', NULL, NULL, 201, NULL, NULL, 230803),
(241484, '5zx8A00', NULL, NULL, 187, NULL, NULL, 230803),
(241485, '4qt4A00', NULL, NULL, 189, NULL, NULL, 230803),
(241486, '4ylyB00', NULL, NULL, 198, NULL, NULL, 230803),
(241487, '2z2iA00', NULL, NULL, 191, NULL, NULL, 230803),
(241488, '4z86A00', NULL, NULL, 199, NULL, NULL, 230803),
(241489, '1rynA00', NULL, NULL, 202, NULL, NULL, 230803),
(241490, '6j93A00', NULL, NULL, 196, NULL, NULL, 230803),
(241491, '2md0A00', NULL, NULL, 51, NULL, NULL, 230804),
(241492, '3dddA02', NULL, NULL, 146, NULL, NULL, 230805),
(241493, '2i9cA01', NULL, NULL, 111, NULL, NULL, 230806),
(241494, '5dxuA03', NULL, NULL, 199, NULL, NULL, 230806),
(241495, '4uwhA01', NULL, NULL, 245, NULL, NULL, 230806),
(241496, '3hhmA02', NULL, NULL, 254, NULL, NULL, 230806),
(241497, '1he8A03', NULL, NULL, 111, NULL, NULL, 230806),
(241498, '1e7uA03', NULL, NULL, 200, NULL, NULL, 230806),
(241499, '4bfrA03', NULL, NULL, 203, NULL, NULL, 230806),
(241500, '2x6hA01', NULL, NULL, 191, NULL, NULL, 230806),
(241501, '3ls8B01', NULL, NULL, 183, NULL, NULL, 230806),
(241502, '2wxfA01', NULL, NULL, 240, NULL, NULL, 230806),
(241503, '4v0iA03', NULL, NULL, 101, NULL, NULL, 230806),
(241504, '4jpsA03', NULL, NULL, 217, NULL, NULL, 230806),
(241505, '3askA02', NULL, NULL, 158, NULL, NULL, 230807),
(241506, '1k4tA03', NULL, NULL, 155, NULL, NULL, 230808),
(241507, '2b9sA03', NULL, NULL, 200, NULL, NULL, 230808),
(241508, '2h7gX02', NULL, NULL, 241, NULL, NULL, 230808),
(241509, '3m4aA03', NULL, NULL, 119, NULL, NULL, 230808),
(241510, '1a41A01', NULL, NULL, 136, NULL, NULL, 230808),
(241511, '5q22A02', NULL, NULL, 148, NULL, NULL, 230809),
(241512, '5ahoA02', NULL, NULL, 123, NULL, NULL, 230809),
(241513, '3do9C02', NULL, NULL, 63, NULL, NULL, 230810),
(241514, '1gp8A00', NULL, NULL, 40, NULL, NULL, 230810),
(241515, '3g2mB01', NULL, NULL, 67, NULL, NULL, 230811),
(241516, '3g2oB01', NULL, NULL, 99, NULL, NULL, 230811),
(241517, '3lzdA03', NULL, NULL, 102, NULL, NULL, 230812),
(241518, '2ksnA01', NULL, NULL, 78, NULL, NULL, 230813),
(241519, '2lutA01', NULL, NULL, 57, NULL, NULL, 230814),
(241520, '1mknA00', NULL, NULL, 59, NULL, NULL, 230814),
(241521, '3zuqA02', NULL, NULL, 376, NULL, NULL, 230815),
(241522, '3v0aA02', NULL, NULL, 333, NULL, NULL, 230815),
(241523, '1epwA02', NULL, NULL, 331, NULL, NULL, 230815),
(241524, '5bqmB00', NULL, NULL, 403, NULL, NULL, 230815),
(241525, '4zktB02', NULL, NULL, 330, NULL, NULL, 230815),
(241526, '5bqnA02', NULL, NULL, 375, NULL, NULL, 230815),
(241527, '2w2dD01', NULL, NULL, 426, NULL, NULL, 230815),
(241528, '2nyyA02', NULL, NULL, 323, NULL, NULL, 230815),
(241529, '3vuoA02', NULL, NULL, 330, NULL, NULL, 230815),
(241530, '3v0aB02', NULL, NULL, 331, NULL, NULL, 230815),
(241531, '3ffzA02', NULL, NULL, 333, NULL, NULL, 230815),
(241532, '1u2zA01', NULL, NULL, 212, NULL, NULL, 230816),
(241533, '4af3D01', NULL, NULL, 37, NULL, NULL, 230817),
(241534, '2vgoC01', NULL, NULL, 29, NULL, NULL, 230817),
(241535, '3u7vA02', NULL, NULL, 144, NULL, NULL, 230818);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(241536, '5jawC02', NULL, NULL, 167, NULL, NULL, 230818),
(241537, '2aegA01', NULL, NULL, 70, NULL, NULL, 230819),
(241538, '5ezbA00', NULL, NULL, 143, NULL, NULL, 230820),
(241539, '3agdB02', NULL, NULL, 147, NULL, NULL, 230820),
(241540, '4qtpB00', NULL, NULL, 122, NULL, NULL, 230820),
(241541, '4xs5C00', NULL, NULL, 123, NULL, NULL, 230820),
(241542, '3lloA00', NULL, NULL, 143, NULL, NULL, 230820),
(241543, '4hylB00', NULL, NULL, 117, NULL, NULL, 230820),
(241544, '1auzA00', NULL, NULL, 116, NULL, NULL, 230820),
(241545, '2dfwA02', NULL, NULL, 87, NULL, NULL, 230820),
(241546, '3f43A01', NULL, NULL, 110, NULL, NULL, 230820),
(241547, '4dgfA00', NULL, NULL, 135, NULL, NULL, 230820),
(241548, '3oizA00', NULL, NULL, 99, NULL, NULL, 230820),
(241549, '4dghA00', NULL, NULL, 130, NULL, NULL, 230820),
(241550, '2klnA00', NULL, NULL, 130, NULL, NULL, 230820),
(241551, '3lklA00', NULL, NULL, 98, NULL, NULL, 230820),
(241552, '1th8B00', NULL, NULL, 116, NULL, NULL, 230820),
(241553, '1vc1A00', NULL, NULL, 110, NULL, NULL, 230820),
(241554, '1h4xA00', NULL, NULL, 117, NULL, NULL, 230820),
(241555, '3t6oA00', NULL, NULL, 121, NULL, NULL, 230820),
(241556, '3ny7A00', NULL, NULL, 118, NULL, NULL, 230820),
(241557, '3zxnA00', NULL, NULL, 123, NULL, NULL, 230820),
(241558, '3if5A02', NULL, NULL, 97, NULL, NULL, 230820),
(241559, '5bnyA01', NULL, NULL, 91, NULL, NULL, 230821),
(241560, '2viuA02', NULL, NULL, 84, NULL, NULL, 230821),
(241561, '6ml8A01', NULL, NULL, 99, NULL, NULL, 230821),
(241562, '4k3xA01', NULL, NULL, 108, NULL, NULL, 230821),
(241563, '3m6sA01', NULL, NULL, 99, NULL, NULL, 230821),
(241564, '5vliA01', NULL, NULL, 96, NULL, NULL, 230821),
(241565, '6e4xB01', NULL, NULL, 59, NULL, NULL, 230821),
(241566, '4we7A01', NULL, NULL, 68, NULL, NULL, 230821),
(241567, '2wrhH01', NULL, NULL, 94, NULL, NULL, 230821),
(241568, '4bh4A01', NULL, NULL, 106, NULL, NULL, 230821),
(241569, '5e32A01', NULL, NULL, 112, NULL, NULL, 230821),
(241570, '6e56D01', NULL, NULL, 74, NULL, NULL, 230821),
(241571, '4julL01', NULL, NULL, 107, NULL, NULL, 230821),
(241572, '4kw1C01', NULL, NULL, 108, NULL, NULL, 230821),
(241573, '4h32A01', NULL, NULL, 100, NULL, NULL, 230821),
(241574, '1jsdA02', NULL, NULL, 102, NULL, NULL, 230821),
(241575, '4w8nE01', NULL, NULL, 109, NULL, NULL, 230821),
(241576, '3ku3A01', NULL, NULL, 106, NULL, NULL, 230821),
(241577, '4kpqA01', NULL, NULL, 106, NULL, NULL, 230821),
(241578, '4jumA01', NULL, NULL, 107, NULL, NULL, 230821),
(241579, '4fqiA01', NULL, NULL, 112, NULL, NULL, 230821),
(241580, '4bsgA01', NULL, NULL, 105, NULL, NULL, 230821),
(241581, '1rvtH01', NULL, NULL, 96, NULL, NULL, 230821),
(241582, '6fywA01', NULL, NULL, 105, NULL, NULL, 230821),
(241583, '1jsmA02', NULL, NULL, 103, NULL, NULL, 230821),
(241584, '1qfuA02', NULL, NULL, 109, NULL, NULL, 230821),
(241585, '4f3zC01', NULL, NULL, 97, NULL, NULL, 230821),
(241586, '4kthC01', NULL, NULL, 108, NULL, NULL, 230821),
(241587, '3htoA01', NULL, NULL, 92, NULL, NULL, 230821),
(241588, '4wswA01', NULL, NULL, 109, NULL, NULL, 230821),
(241589, '3m5gC01', NULL, NULL, 109, NULL, NULL, 230821),
(241590, '5w08B01', NULL, NULL, 75, NULL, NULL, 230821),
(241591, '5hu8A01', NULL, NULL, 112, NULL, NULL, 230821),
(241592, '1rv0H01', NULL, NULL, 96, NULL, NULL, 230821),
(241593, '5umnA01', NULL, NULL, 58, NULL, NULL, 230821),
(241594, '3s13A01', NULL, NULL, 69, NULL, NULL, 230821),
(241595, '4cyvA01', NULL, NULL, 106, NULL, NULL, 230821),
(241596, '4gxxE01', NULL, NULL, 99, NULL, NULL, 230821),
(241597, '3ubqE01', NULL, NULL, 97, NULL, NULL, 230821),
(241598, '4fqjA01', NULL, NULL, 63, NULL, NULL, 230821),
(241599, '5xhvA01', NULL, NULL, 71, NULL, NULL, 230821),
(241600, '1rvxA01', NULL, NULL, 96, NULL, NULL, 230821),
(241601, '4we6A01', NULL, NULL, 63, NULL, NULL, 230821),
(241602, '5tg9A01', NULL, NULL, 106, NULL, NULL, 230821),
(241603, '4ln6A01', NULL, NULL, 109, NULL, NULL, 230821),
(241604, '5th1A01', NULL, NULL, 105, NULL, NULL, 230821),
(241605, '2virC01', NULL, NULL, 66, NULL, NULL, 230821),
(241606, '5t0bA01', NULL, NULL, 99, NULL, NULL, 230821);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(241607, '5gjsA01', NULL, NULL, 97, NULL, NULL, 230821),
(241608, '4edbA01', NULL, NULL, 99, NULL, NULL, 230821),
(241609, '3etvA01', NULL, NULL, 117, NULL, NULL, 230822),
(241610, '3etuA01', NULL, NULL, 65, NULL, NULL, 230822),
(241611, '1zhsA02', NULL, NULL, 58, NULL, NULL, 230823),
(241612, '1zhsA01', NULL, NULL, 55, NULL, NULL, 230823),
(241613, '4kqeA03', NULL, NULL, 68, NULL, NULL, 230824),
(241614, '3zj2A00', NULL, NULL, 71, NULL, NULL, 230825),
(241615, '3zj1A00', NULL, NULL, 83, NULL, NULL, 230825),
(241616, '5l2lF00', NULL, NULL, 77, NULL, NULL, 230825),
(241617, '3imiB02', NULL, NULL, 27, NULL, NULL, 230826),
(241618, '1y23D02', NULL, NULL, 29, NULL, NULL, 230826),
(241619, '2m4eA00', NULL, NULL, 86, NULL, NULL, 230827),
(241620, '2nvmB00', NULL, NULL, 126, NULL, NULL, 230828),
(241621, '2nwvA00', NULL, NULL, 114, NULL, NULL, 230828),
(241622, '3d7qB00', NULL, NULL, 112, NULL, NULL, 230828),
(241623, '2nlvA00', NULL, NULL, 112, NULL, NULL, 230828),
(241624, '3ivpC02', NULL, NULL, 50, NULL, NULL, 230829),
(241625, '5hmiA00', NULL, NULL, 104, NULL, NULL, 230830),
(241626, '1v31A00', NULL, NULL, 93, NULL, NULL, 230830),
(241627, '1v32A00', NULL, NULL, 101, NULL, NULL, 230830),
(241628, '2ruhA00', NULL, NULL, 131, NULL, NULL, 230830),
(241629, '5z02A00', NULL, NULL, 89, NULL, NULL, 230830),
(241630, '4n5tA00', NULL, NULL, 90, NULL, NULL, 230830),
(241631, '3tu1A00', NULL, NULL, 108, NULL, NULL, 230830),
(241632, '2mpsA00', NULL, NULL, 107, NULL, NULL, 230830),
(241633, '1uhrA00', NULL, NULL, 93, NULL, NULL, 230830),
(241634, '5c5aA00', NULL, NULL, 92, NULL, NULL, 230830),
(241635, '6q9yB00', NULL, NULL, 100, NULL, NULL, 230830),
(241636, '1ycqA00', NULL, NULL, 107, NULL, NULL, 230830),
(241637, '4lwuA00', NULL, NULL, 85, NULL, NULL, 230830),
(241638, '5trfA00', NULL, NULL, 109, NULL, NULL, 230830),
(241639, '4hg7A00', NULL, NULL, 97, NULL, NULL, 230830),
(241640, '2bw3B01', NULL, NULL, 73, NULL, NULL, 230831),
(241641, '2bw3A01', NULL, NULL, 56, NULL, NULL, 230831),
(241642, '1snzB00', NULL, NULL, 344, NULL, NULL, 230832),
(241643, '2htaA00', NULL, NULL, 309, NULL, NULL, 230832),
(241644, '1jovA00', NULL, NULL, 270, NULL, NULL, 230832),
(241645, '3mwxA00', NULL, NULL, 326, NULL, NULL, 230832),
(241646, '4rnlD00', NULL, NULL, 343, NULL, NULL, 230832),
(241647, '2cirA00', NULL, NULL, 297, NULL, NULL, 230832),
(241648, '1yq2A05', NULL, NULL, 300, NULL, NULL, 230832),
(241649, '1rwhA02', NULL, NULL, 271, NULL, NULL, 230832),
(241650, '3k25A00', NULL, NULL, 289, NULL, NULL, 230832),
(241651, '3decA05', NULL, NULL, 271, NULL, NULL, 230832),
(241652, '3imhA00', NULL, NULL, 338, NULL, NULL, 230832),
(241653, '1jz8A05', NULL, NULL, 293, NULL, NULL, 230832),
(241654, '1lurA00', NULL, NULL, 339, NULL, NULL, 230832),
(241655, '3bgaA05', NULL, NULL, 270, NULL, NULL, 230832),
(241656, '2ww2A01', NULL, NULL, 304, NULL, NULL, 230832),
(241657, '2d73A01', NULL, NULL, 284, NULL, NULL, 230832),
(241658, '1k1yB02', NULL, NULL, 274, NULL, NULL, 230832),
(241659, '3obaA05', NULL, NULL, 293, NULL, NULL, 230832),
(241660, '2zxqA01', NULL, NULL, 283, NULL, NULL, 230832),
(241661, '1cb8A02', NULL, NULL, 246, NULL, NULL, 230832),
(241662, '1ygaA00', NULL, NULL, 342, NULL, NULL, 230832),
(241663, '2wcoA02', NULL, NULL, 256, NULL, NULL, 230832),
(241664, '2q1fA03', NULL, NULL, 277, NULL, NULL, 230832),
(241665, '1x1iA02', NULL, NULL, 273, NULL, NULL, 230832),
(241666, '5a57A01', NULL, NULL, 284, NULL, NULL, 230832),
(241667, '1lf6A01', NULL, NULL, 273, NULL, NULL, 230832),
(241668, '2wvxA01', NULL, NULL, 299, NULL, NULL, 230832),
(241669, '1hn0A03', NULL, NULL, 281, NULL, NULL, 230832),
(241670, '2xsgB01', NULL, NULL, 292, NULL, NULL, 230832),
(241671, '1f1sA01', NULL, NULL, 275, NULL, NULL, 230832),
(241672, '1z45A03', NULL, NULL, 343, NULL, NULL, 230832),
(241673, '3dcdA00', NULL, NULL, 307, NULL, NULL, 230832),
(241674, '1nsxA00', NULL, NULL, 347, NULL, NULL, 230832),
(241675, '1n7oA01', NULL, NULL, 257, NULL, NULL, 230832),
(241676, '3q1nA00', NULL, NULL, 294, NULL, NULL, 230832),
(241677, '1nkgA01', NULL, NULL, 251, NULL, NULL, 230832);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(241678, '1ulvA01', NULL, NULL, 273, NULL, NULL, 230832),
(241679, '3os7A00', NULL, NULL, 341, NULL, NULL, 230832),
(241680, '3ty1A00', NULL, NULL, 384, NULL, NULL, 230832),
(241681, '5e1qB01', NULL, NULL, 286, NULL, NULL, 230832),
(241682, '3nreA00', NULL, NULL, 291, NULL, NULL, 230832),
(241683, '1txkA01', NULL, NULL, 376, NULL, NULL, 230832),
(241684, '2b9wA02', NULL, NULL, 118, NULL, NULL, 230833),
(241685, '2qvwA04', NULL, NULL, 147, NULL, NULL, 230834),
(241686, '1vw4900', NULL, NULL, 225, NULL, NULL, 230834),
(241687, '1vw4501', NULL, NULL, 234, NULL, NULL, 230834),
(241688, '2qvwC06', NULL, NULL, 156, NULL, NULL, 230834),
(241689, '4oogC01', NULL, NULL, 162, NULL, NULL, 230834),
(241690, '1u61A00', NULL, NULL, 138, NULL, NULL, 230834),
(241691, '1o0wA01', NULL, NULL, 154, NULL, NULL, 230834),
(241692, '2eb1C00', NULL, NULL, 200, NULL, NULL, 230834),
(241693, '3c4bA01', NULL, NULL, 198, NULL, NULL, 230834),
(241694, '2a11A00', NULL, NULL, 157, NULL, NULL, 230834),
(241695, '3rv1B02', NULL, NULL, 162, NULL, NULL, 230834),
(241696, '3o2rA00', NULL, NULL, 144, NULL, NULL, 230834),
(241697, '2nugA01', NULL, NULL, 149, NULL, NULL, 230834),
(241698, '2gslF00', NULL, NULL, 137, NULL, NULL, 230834),
(241699, '4ounA00', NULL, NULL, 140, NULL, NULL, 230834),
(241700, '4ebaG00', NULL, NULL, 83, NULL, NULL, 230835),
(241701, '2l9bA00', NULL, NULL, 109, NULL, NULL, 230835),
(241702, '3ub0A01', NULL, NULL, 103, NULL, NULL, 230836),
(241703, '1wjwA01', NULL, NULL, 85, NULL, NULL, 230837),
(241704, '3uw2A04', NULL, NULL, 94, NULL, NULL, 230837),
(241705, '3pmgA04', NULL, NULL, 161, NULL, NULL, 230837),
(241706, '2f7lA04', NULL, NULL, 85, NULL, NULL, 230837),
(241707, '2jpiA00', NULL, NULL, 96, NULL, NULL, 230837),
(241708, '5o9xA03', NULL, NULL, 93, NULL, NULL, 230837),
(241709, '6gyzA04', NULL, NULL, 84, NULL, NULL, 230837),
(241710, '4qg5A04', NULL, NULL, 143, NULL, NULL, 230837),
(241711, '1p5dX04', NULL, NULL, 93, NULL, NULL, 230837),
(241712, '1wqaA04', NULL, NULL, 85, NULL, NULL, 230837),
(241713, '4wxaA00', NULL, NULL, 94, NULL, NULL, 230837),
(241714, '3encA00', NULL, NULL, 87, NULL, NULL, 230837),
(241715, '3pdkA04', NULL, NULL, 79, NULL, NULL, 230837),
(241716, '5bmnA04', NULL, NULL, 83, NULL, NULL, 230837),
(241717, '1tuoA04', NULL, NULL, 85, NULL, NULL, 230837),
(241718, '4hjhA04', NULL, NULL, 103, NULL, NULL, 230837),
(241719, '3na5A04', NULL, NULL, 104, NULL, NULL, 230837),
(241720, '2dkdA03', NULL, NULL, 80, NULL, NULL, 230837),
(241721, '5jn5B04', NULL, NULL, 152, NULL, NULL, 230837),
(241722, '3i3wA04', NULL, NULL, 77, NULL, NULL, 230837),
(241723, '2z0fA04', NULL, NULL, 102, NULL, NULL, 230837),
(241724, '1kfiA04', NULL, NULL, 125, NULL, NULL, 230837),
(241725, '2f4iB02', NULL, NULL, 118, NULL, NULL, 230838),
(241726, '2f4iA02', NULL, NULL, 118, NULL, NULL, 230838),
(241727, '2f4iD02', NULL, NULL, 118, NULL, NULL, 230838),
(241728, '2f4iC02', NULL, NULL, 118, NULL, NULL, 230838),
(241729, '2jchA01', NULL, NULL, 88, NULL, NULL, 230839),
(241730, '2y2pA01', NULL, NULL, 113, NULL, NULL, 230839),
(241731, '2b78A02', NULL, NULL, 106, NULL, NULL, 230840),
(241732, '4dmgA02', NULL, NULL, 102, NULL, NULL, 230840),
(241733, '3vseB02', NULL, NULL, 105, NULL, NULL, 230840),
(241734, '3v97A03', NULL, NULL, 92, NULL, NULL, 230840),
(241735, '1wxxA02', NULL, NULL, 105, NULL, NULL, 230840),
(241736, '3c0kA02', NULL, NULL, 109, NULL, NULL, 230840),
(241737, '2as0A02', NULL, NULL, 107, NULL, NULL, 230840),
(241738, '1xfiA02', NULL, NULL, 90, NULL, NULL, 230841),
(241739, '2qtwB02', NULL, NULL, 230, NULL, NULL, 230842),
(241740, '3bpsA02', NULL, NULL, 170, NULL, NULL, 230842),
(241741, '6gfxC01', NULL, NULL, 90, NULL, NULL, 230843),
(241742, '3s84A01', NULL, NULL, 93, NULL, NULL, 230844),
(241743, '5gjhA00', NULL, NULL, 100, NULL, NULL, 230845),
(241744, '2eyvA01', NULL, NULL, 104, NULL, NULL, 230845),
(241745, '1d4tA00', NULL, NULL, 104, NULL, NULL, 230845),
(241746, '2knoA01', NULL, NULL, 110, NULL, NULL, 230845),
(241747, '3eazA00', NULL, NULL, 106, NULL, NULL, 230845),
(241748, '1h9oA00', NULL, NULL, 112, NULL, NULL, 230845);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(241749, '5dc4A00', NULL, NULL, 123, NULL, NULL, 230845),
(241750, '1fmkA02', NULL, NULL, 101, NULL, NULL, 230845),
(241751, '2y3aB02', NULL, NULL, 114, NULL, NULL, 230845),
(241752, '2xp1A02', NULL, NULL, 82, NULL, NULL, 230845),
(241753, '2lqnA01', NULL, NULL, 113, NULL, NULL, 230845),
(241754, '2xp1A01', NULL, NULL, 96, NULL, NULL, 230845),
(241755, '2eobA01', NULL, NULL, 113, NULL, NULL, 230845),
(241756, '1milA00', NULL, NULL, 104, NULL, NULL, 230845),
(241757, '2ci8A01', NULL, NULL, 56, NULL, NULL, 230845),
(241758, '2mk2A00', NULL, NULL, 109, NULL, NULL, 230845),
(241759, '2mqiA00', NULL, NULL, 111, NULL, NULL, 230845),
(241760, '5mtmA00', NULL, NULL, 116, NULL, NULL, 230845),
(241761, '3us4A00', NULL, NULL, 98, NULL, NULL, 230845),
(241762, '4fl3A01', NULL, NULL, 118, NULL, NULL, 230845),
(241763, '1rjaA00', NULL, NULL, 100, NULL, NULL, 230845),
(241764, '3bkbA01', NULL, NULL, 96, NULL, NULL, 230845),
(241765, '4fl3A03', NULL, NULL, 102, NULL, NULL, 230845),
(241766, '1uurA04', NULL, NULL, 133, NULL, NULL, 230845),
(241767, '5jn0A00', NULL, NULL, 99, NULL, NULL, 230845),
(241768, '2izvA00', NULL, NULL, 171, NULL, NULL, 230845),
(241769, '2augA00', NULL, NULL, 105, NULL, NULL, 230845),
(241770, '2dm0A01', NULL, NULL, 97, NULL, NULL, 230845),
(241771, '3vgoA03', NULL, NULL, 83, NULL, NULL, 230845),
(241772, '2b3oA01', NULL, NULL, 103, NULL, NULL, 230845),
(241773, '2b3oA02', NULL, NULL, 111, NULL, NULL, 230845),
(241774, '1nrvA00', NULL, NULL, 105, NULL, NULL, 230845),
(241775, '3pjpB01', NULL, NULL, 102, NULL, NULL, 230845),
(241776, '4jegA00', NULL, NULL, 124, NULL, NULL, 230845),
(241777, '2hmhA00', NULL, NULL, 134, NULL, NULL, 230845),
(241778, '4gl9E00', NULL, NULL, 143, NULL, NULL, 230845),
(241779, '2c9wA01', NULL, NULL, 129, NULL, NULL, 230845),
(241780, '1lkkA00', NULL, NULL, 105, NULL, NULL, 230845),
(241781, '3wa4A00', NULL, NULL, 98, NULL, NULL, 230845),
(241782, '5ehrB02', NULL, NULL, 106, NULL, NULL, 230845),
(241783, '2dx0A00', NULL, NULL, 138, NULL, NULL, 230845),
(241784, '1k9aA02', NULL, NULL, 86, NULL, NULL, 230845),
(241785, '1jyrA00', NULL, NULL, 96, NULL, NULL, 230845),
(241786, '4eihA00', NULL, NULL, 116, NULL, NULL, 230845),
(241787, '3cxlA01', NULL, NULL, 104, NULL, NULL, 230845),
(241788, '1bg1A04', NULL, NULL, 123, NULL, NULL, 230845),
(241789, '2crhA01', NULL, NULL, 102, NULL, NULL, 230845),
(241790, '3pfvA03', NULL, NULL, 86, NULL, NULL, 230845),
(241791, '1bf5A04', NULL, NULL, 129, NULL, NULL, 230845),
(241792, '3uf4A02', NULL, NULL, 101, NULL, NULL, 230845),
(241793, '5aulA00', NULL, NULL, 109, NULL, NULL, 230845),
(241794, '2rorA00', NULL, NULL, 138, NULL, NULL, 230845),
(241795, '4u1pA00', NULL, NULL, 122, NULL, NULL, 230845),
(241796, '4je4A00', NULL, NULL, 106, NULL, NULL, 230845),
(241797, '1shaA00', NULL, NULL, 104, NULL, NULL, 230845),
(241798, '2oq1A01', NULL, NULL, 109, NULL, NULL, 230845),
(241799, '2oq1A03', NULL, NULL, 100, NULL, NULL, 230845),
(241800, '1bljA00', NULL, NULL, 114, NULL, NULL, 230845),
(241801, '2ablA02', NULL, NULL, 97, NULL, NULL, 230845),
(241802, '3pjpA02', NULL, NULL, 97, NULL, NULL, 230845),
(241803, '2vifA01', NULL, NULL, 136, NULL, NULL, 230845),
(241804, '1luiA00', NULL, NULL, 110, NULL, NULL, 230845),
(241805, '3qwxX01', NULL, NULL, 115, NULL, NULL, 230845),
(241806, '2ekxA01', NULL, NULL, 97, NULL, NULL, 230845),
(241807, '1g83A02', NULL, NULL, 103, NULL, NULL, 230845),
(241808, '2kk6A00', NULL, NULL, 116, NULL, NULL, 230845),
(241809, '2dx0B01', NULL, NULL, 77, NULL, NULL, 230845),
(241810, '2ecdA00', NULL, NULL, 119, NULL, NULL, 230845),
(241811, '1xa6A01', NULL, NULL, 104, NULL, NULL, 230845),
(241812, '3mazA00', NULL, NULL, 109, NULL, NULL, 230845),
(241813, '5gjiA00', NULL, NULL, 108, NULL, NULL, 230845),
(241814, '1rpyB00', NULL, NULL, 97, NULL, NULL, 230845),
(241815, '2cs0A01', NULL, NULL, 95, NULL, NULL, 230845),
(241816, '2cr4A01', NULL, NULL, 99, NULL, NULL, 230845),
(241817, '2ysxA00', NULL, NULL, 119, NULL, NULL, 230845),
(241818, '4fbnA01', NULL, NULL, 117, NULL, NULL, 230845),
(241819, '4m4zA02', NULL, NULL, 105, NULL, NULL, 230845);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(241820, '3s9kA01', NULL, NULL, 81, NULL, NULL, 230845),
(241821, '5vkoA01', NULL, NULL, 108, NULL, NULL, 230845),
(241822, '2gsbA01', NULL, NULL, 84, NULL, NULL, 230845),
(241823, '1r1pB00', NULL, NULL, 100, NULL, NULL, 230845),
(241824, '5kazA00', NULL, NULL, 104, NULL, NULL, 230845),
(241825, '5eeqA00', NULL, NULL, 120, NULL, NULL, 230845),
(241826, '5vkoA02', NULL, NULL, 103, NULL, NULL, 230845),
(241827, '2ciaA00', NULL, NULL, 102, NULL, NULL, 230845),
(241828, '1fu5A00', NULL, NULL, 111, NULL, NULL, 230845),
(241829, '2ci9B00', NULL, NULL, 102, NULL, NULL, 230845),
(241830, '5mtjA00', NULL, NULL, 116, NULL, NULL, 230845),
(241831, '1y1uA04', NULL, NULL, 87, NULL, NULL, 230845),
(241832, '2eo3A00', NULL, NULL, 111, NULL, NULL, 230845),
(241833, '2l3tA02', NULL, NULL, 100, NULL, NULL, 230845),
(241834, '4rojA01', NULL, NULL, 102, NULL, NULL, 230845),
(241835, '2dvjA01', NULL, NULL, 146, NULL, NULL, 230845),
(241836, '3buxB03', NULL, NULL, 86, NULL, NULL, 230845),
(241837, '1yvlB05', NULL, NULL, 102, NULL, NULL, 230845),
(241838, '4k45A00', NULL, NULL, 106, NULL, NULL, 230845),
(241839, '2ge9A00', NULL, NULL, 125, NULL, NULL, 230845),
(241840, '3tkzA00', NULL, NULL, 109, NULL, NULL, 230845),
(241841, '5w3rA00', NULL, NULL, 114, NULL, NULL, 230845),
(241842, '1bmbA00', NULL, NULL, 123, NULL, NULL, 230845),
(241843, '2dlyA00', NULL, NULL, 121, NULL, NULL, 230845),
(241844, '1qcfA02', NULL, NULL, 102, NULL, NULL, 230845),
(241845, '1i3zA00', NULL, NULL, 103, NULL, NULL, 230845),
(241846, '4tziB00', NULL, NULL, 115, NULL, NULL, 230845),
(241847, '2eo6A01', NULL, NULL, 108, NULL, NULL, 230845),
(241848, '3vrpA03', NULL, NULL, 89, NULL, NULL, 230845),
(241849, '5tnwA00', NULL, NULL, 101, NULL, NULL, 230845),
(241850, '1ghuA00', NULL, NULL, 107, NULL, NULL, 230845),
(241851, '2el8A01', NULL, NULL, 91, NULL, NULL, 230845),
(241852, '2rvfA00', NULL, NULL, 104, NULL, NULL, 230845),
(241853, '2qzbA00', NULL, NULL, 166, NULL, NULL, 230846),
(241854, '3viqA00', NULL, NULL, 122, NULL, NULL, 230847),
(241855, '3m6zA02', NULL, NULL, 37, NULL, NULL, 230848),
(241856, '2f20A00', NULL, NULL, 240, NULL, NULL, 230849),
(241857, '2icuB00', NULL, NULL, 229, NULL, NULL, 230849),
(241858, '2bdvA00', NULL, NULL, 231, NULL, NULL, 230849),
(241859, '5ko9A00', NULL, NULL, 277, NULL, NULL, 230849),
(241860, '1zn6A00', NULL, NULL, 227, NULL, NULL, 230849),
(241861, '3vm9A02', NULL, NULL, 57, NULL, NULL, 230850),
(241862, '2kbzA00', NULL, NULL, 99, NULL, NULL, 230851),
(241863, '1pbyA02', NULL, NULL, 106, NULL, NULL, 230852),
(241864, '1jmxA02', NULL, NULL, 109, NULL, NULL, 230852),
(241865, '3e1sA04', NULL, NULL, 69, NULL, NULL, 230853),
(241866, '4npxA00', NULL, NULL, 80, NULL, NULL, 230854),
(241867, '4u12A00', NULL, NULL, 94, NULL, NULL, 230854),
(241868, '3mliA01', NULL, NULL, 89, NULL, NULL, 230854),
(241869, '1xl7A01', NULL, NULL, 113, NULL, NULL, 230855),
(241870, '3r7wB02', NULL, NULL, 138, NULL, NULL, 230856),
(241871, '3r7wC02', NULL, NULL, 124, NULL, NULL, 230856),
(241872, '5x6vG00', NULL, NULL, 139, NULL, NULL, 230856),
(241873, '5x6vF00', NULL, NULL, 135, NULL, NULL, 230856),
(241874, '4kx7A04', NULL, NULL, 332, NULL, NULL, 230857),
(241875, '5ab0C04', NULL, NULL, 332, NULL, NULL, 230857),
(241876, '4fyqA04', NULL, NULL, 333, NULL, NULL, 230857),
(241877, '4wz9A04', NULL, NULL, 331, NULL, NULL, 230857),
(241878, '5mj6A04', NULL, NULL, 331, NULL, NULL, 230857),
(241879, '6q4rA04', NULL, NULL, 325, NULL, NULL, 230857),
(241880, '4fkeA04', NULL, NULL, 339, NULL, NULL, 230857),
(241881, '3h09B02', NULL, NULL, 490, NULL, NULL, 230858),
(241882, '4kh3A00', NULL, NULL, 503, NULL, NULL, 230858),
(241883, '4om9A02', NULL, NULL, 650, NULL, NULL, 230858),
(241884, '2vfmA00', NULL, NULL, 559, NULL, NULL, 230858),
(241885, '2v5iA00', NULL, NULL, 559, NULL, NULL, 230858),
(241886, '1dabA00', NULL, NULL, 539, NULL, NULL, 230858),
(241887, '3syjA02', NULL, NULL, 653, NULL, NULL, 230858),
(241888, '3riqA00', NULL, NULL, 543, NULL, NULL, 230858),
(241889, '3szeA02', NULL, NULL, 647, NULL, NULL, 230858),
(241890, '2iouG00', NULL, NULL, 535, NULL, NULL, 230858);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(241891, '5j44A03', NULL, NULL, 670, NULL, NULL, 230858),
(241892, '3ak5D02', NULL, NULL, 713, NULL, NULL, 230858),
(241893, '1sg6A02', NULL, NULL, 209, NULL, NULL, 230859),
(241894, '4qgsA02', NULL, NULL, 204, NULL, NULL, 230859),
(241895, '3qbeA02', NULL, NULL, 188, NULL, NULL, 230859),
(241896, '3jzdA02', NULL, NULL, 194, NULL, NULL, 230859),
(241897, '3ce9A02', NULL, NULL, 194, NULL, NULL, 230859),
(241898, '1xaiA02', NULL, NULL, 188, NULL, NULL, 230859),
(241899, '3uhjF02', NULL, NULL, 206, NULL, NULL, 230859),
(241900, '5hvnA02', NULL, NULL, 187, NULL, NULL, 230859),
(241901, '4p53A02', NULL, NULL, 197, NULL, NULL, 230859),
(241902, '3rf7A02', NULL, NULL, 172, NULL, NULL, 230859),
(241903, '3w5sA02', NULL, NULL, 191, NULL, NULL, 230859),
(241904, '1vljA02', NULL, NULL, 211, NULL, NULL, 230859),
(241905, '3ox4A02', NULL, NULL, 199, NULL, NULL, 230859),
(241906, '5br4A02', NULL, NULL, 205, NULL, NULL, 230859),
(241907, '3hl0A02', NULL, NULL, 191, NULL, NULL, 230859),
(241908, '5fb3A02', NULL, NULL, 193, NULL, NULL, 230859),
(241909, '5eksA02', NULL, NULL, 189, NULL, NULL, 230859),
(241910, '3clhA02', NULL, NULL, 181, NULL, NULL, 230859),
(241911, '1o2dA02', NULL, NULL, 179, NULL, NULL, 230859),
(241912, '1ujnA02', NULL, NULL, 177, NULL, NULL, 230859),
(241913, '5k8cA02', NULL, NULL, 172, NULL, NULL, 230859),
(241914, '4fr2A02', NULL, NULL, 202, NULL, NULL, 230859),
(241915, '1jq5A02', NULL, NULL, 209, NULL, NULL, 230859),
(241916, '4rflA02', NULL, NULL, 199, NULL, NULL, 230859),
(241917, '4mcaB02', NULL, NULL, 208, NULL, NULL, 230859),
(241918, '5zxlA02', NULL, NULL, 208, NULL, NULL, 230859),
(241919, '3zdrA02', NULL, NULL, 218, NULL, NULL, 230859),
(241920, '5xn8A02', NULL, NULL, 206, NULL, NULL, 230859),
(241921, '3iv7A02', NULL, NULL, 201, NULL, NULL, 230859),
(241922, '6c5cB02', NULL, NULL, 208, NULL, NULL, 230859),
(241923, '3okfA02', NULL, NULL, 190, NULL, NULL, 230859),
(241924, '3bfjA02', NULL, NULL, 199, NULL, NULL, 230859),
(241925, '6c7lA02', NULL, NULL, 195, NULL, NULL, 230859),
(241926, '5tprA02', NULL, NULL, 224, NULL, NULL, 230859),
(241927, '3zokA02', NULL, NULL, 191, NULL, NULL, 230859),
(241928, '2gruA02', NULL, NULL, 197, NULL, NULL, 230859),
(241929, '1ta9A02', NULL, NULL, 230, NULL, NULL, 230859),
(241930, '1kq3A02', NULL, NULL, 207, NULL, NULL, 230859),
(241931, '3n40P04', NULL, NULL, 73, NULL, NULL, 230860),
(241932, '3muuB02', NULL, NULL, 90, NULL, NULL, 230860),
(241933, '2ygrF02', NULL, NULL, 111, NULL, NULL, 230861),
(241934, '2vf7A03', NULL, NULL, 125, NULL, NULL, 230861),
(241935, '2r6fA04', NULL, NULL, 122, NULL, NULL, 230861),
(241936, '3zqjE04', NULL, NULL, 118, NULL, NULL, 230861),
(241937, '3dteA01', NULL, NULL, 117, NULL, NULL, 230862),
(241938, '3jciA00', NULL, NULL, 190, NULL, NULL, 230863),
(241939, '5j09A00', NULL, NULL, 202, NULL, NULL, 230863),
(241940, '3r0rA00', NULL, NULL, 194, NULL, NULL, 230863),
(241941, '6b4eA00', NULL, NULL, 296, NULL, NULL, 230864),
(241942, '4dwrC00', NULL, NULL, 487, NULL, NULL, 230865),
(241943, '2epgB00', NULL, NULL, 487, NULL, NULL, 230865),
(241944, '2yt4A01', NULL, NULL, 38, NULL, NULL, 230866),
(241945, '3vnrA02', NULL, NULL, 107, NULL, NULL, 230867),
(241946, '2y4oB02', NULL, NULL, 108, NULL, NULL, 230867),
(241947, '4fuqA02', NULL, NULL, 106, NULL, NULL, 230867),
(241948, '4r0mA02', NULL, NULL, 108, NULL, NULL, 230867),
(241949, '4gxqB02', NULL, NULL, 109, NULL, NULL, 230867),
(241950, '3pbkA02', NULL, NULL, 108, NULL, NULL, 230867),
(241951, '3l8cA02', NULL, NULL, 120, NULL, NULL, 230867),
(241952, '1ry2A02', NULL, NULL, 137, NULL, NULL, 230867),
(241953, '2v7bA02', NULL, NULL, 102, NULL, NULL, 230867),
(241954, '4oycB00', NULL, NULL, 109, NULL, NULL, 230867),
(241955, '4d57A02', NULL, NULL, 80, NULL, NULL, 230867),
(241956, '3r44A02', NULL, NULL, 106, NULL, NULL, 230867),
(241957, '3fceA02', NULL, NULL, 115, NULL, NULL, 230867),
(241958, '4gxrA02', NULL, NULL, 106, NULL, NULL, 230867),
(241959, '5ifiC02', NULL, NULL, 83, NULL, NULL, 230867),
(241960, '1mdbA04', NULL, NULL, 110, NULL, NULL, 230867),
(241961, '4dg8A02', NULL, NULL, 96, NULL, NULL, 230867);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(241962, '5uptA02', NULL, NULL, 116, NULL, NULL, 230867),
(241963, '4wv3B02', NULL, NULL, 117, NULL, NULL, 230867),
(241964, '5buqA02', NULL, NULL, 81, NULL, NULL, 230867),
(241965, '4rvnC02', NULL, NULL, 105, NULL, NULL, 230867),
(241966, '2d1sA04', NULL, NULL, 109, NULL, NULL, 230867),
(241967, '4iz6A02', NULL, NULL, 106, NULL, NULL, 230867),
(241968, '5gxdA02', NULL, NULL, 135, NULL, NULL, 230867),
(241969, '2vsqA06', NULL, NULL, 105, NULL, NULL, 230867),
(241970, '4gs5A02', NULL, NULL, 110, NULL, NULL, 230867),
(241971, '2y27A02', NULL, NULL, 104, NULL, NULL, 230867),
(241972, '5ey8G02', NULL, NULL, 146, NULL, NULL, 230867),
(241973, '3nyqA02', NULL, NULL, 100, NULL, NULL, 230867),
(241974, '1amuA04', NULL, NULL, 96, NULL, NULL, 230867),
(241975, '4gxqA02', NULL, NULL, 109, NULL, NULL, 230867),
(241976, '3iteB02', NULL, NULL, 105, NULL, NULL, 230867),
(241977, '1pg4A02', NULL, NULL, 135, NULL, NULL, 230867),
(241978, '3c5eA02', NULL, NULL, 112, NULL, NULL, 230867),
(241979, '3laxA00', NULL, NULL, 109, NULL, NULL, 230867),
(241980, '1ultA02', NULL, NULL, 101, NULL, NULL, 230867),
(241981, '3g7sB02', NULL, NULL, 87, NULL, NULL, 230867),
(241982, '5keiA02', NULL, NULL, 101, NULL, NULL, 230867),
(241983, '3kxwA02', NULL, NULL, 133, NULL, NULL, 230867),
(241984, '1yj7D02', NULL, NULL, 93, NULL, NULL, 230867),
(241985, '3ni2A02', NULL, NULL, 103, NULL, NULL, 230867),
(241986, '4gxqC02', NULL, NULL, 109, NULL, NULL, 230867),
(241987, '4rlqB04', NULL, NULL, 91, NULL, NULL, 230867),
(241988, '3iplA02', NULL, NULL, 83, NULL, NULL, 230867),
(241989, '3etcB02', NULL, NULL, 88, NULL, NULL, 230867),
(241990, '1lciA04', NULL, NULL, 110, NULL, NULL, 230867),
(241991, '3e7wA02', NULL, NULL, 114, NULL, NULL, 230867),
(241992, '3cw9A04', NULL, NULL, 103, NULL, NULL, 230867),
(241993, '5x8fB02', NULL, NULL, 102, NULL, NULL, 230867),
(241994, '5ifiB02', NULL, NULL, 136, NULL, NULL, 230867),
(241995, '5u2aA02', NULL, NULL, 111, NULL, NULL, 230867),
(241996, '4futA02', NULL, NULL, 106, NULL, NULL, 230867),
(241997, '4oxiA02', NULL, NULL, 108, NULL, NULL, 230867),
(241998, '4isbB02', NULL, NULL, 116, NULL, NULL, 230867),
(241999, '5n9xB02', NULL, NULL, 107, NULL, NULL, 230867),
(242000, '5bsrA02', NULL, NULL, 106, NULL, NULL, 230867),
(242001, '3hl8A02', NULL, NULL, 140, NULL, NULL, 230868),
(242002, '4rg8A02', NULL, NULL, 140, NULL, NULL, 230868),
(242003, '2kmuA00', NULL, NULL, 56, NULL, NULL, 230869),
(242004, '3eeqA01', NULL, NULL, 121, NULL, NULL, 230870),
(242005, '2g30A01', NULL, NULL, 117, NULL, NULL, 230871),
(242006, '3s04A02', NULL, NULL, 109, NULL, NULL, 230872),
(242007, '1b12A02', NULL, NULL, 74, NULL, NULL, 230872),
(242008, '4o5qA01', NULL, NULL, 200, NULL, NULL, 230873),
(242009, '4mnnA00', NULL, NULL, 179, NULL, NULL, 230873),
(242010, '3l5oA02', NULL, NULL, 119, NULL, NULL, 230874),
(242011, '2wgoA00', NULL, NULL, 98, NULL, NULL, 230875),
(242012, '4y2lD00', NULL, NULL, 153, NULL, NULL, 230876),
(242013, '2hb0B02', NULL, NULL, 192, NULL, NULL, 230876),
(242014, '4hjiA00', NULL, NULL, 154, NULL, NULL, 230876),
(242015, '3f85A03', NULL, NULL, 160, NULL, NULL, 230876),
(242016, '3sxuA00', NULL, NULL, 150, NULL, NULL, 230877),
(242017, '5urbA02', NULL, NULL, 35, NULL, NULL, 230878),
(242018, '3h99A02', NULL, NULL, 35, NULL, NULL, 230878),
(242019, '4i69A00', NULL, NULL, 87, NULL, NULL, 230879),
(242020, '5maoA00', NULL, NULL, 71, NULL, NULL, 230879),
(242021, '3vkhB13', NULL, NULL, 166, NULL, NULL, 230880),
(242022, '3vkgA12', NULL, NULL, 222, NULL, NULL, 230880),
(242023, '2mxrA00', NULL, NULL, 56, NULL, NULL, 230881),
(242024, '3iylU02', NULL, NULL, 53, NULL, NULL, 230882),
(242025, '1ej6D02', NULL, NULL, 58, NULL, NULL, 230882),
(242026, '4xjxA02', NULL, NULL, 73, NULL, NULL, 230883),
(242027, '4awlA00', NULL, NULL, 62, NULL, NULL, 230884),
(242028, '4g92A00', NULL, NULL, 64, NULL, NULL, 230884),
(242029, '1xq4A00', NULL, NULL, 139, NULL, NULL, 230885),
(242030, '5hdwA00', NULL, NULL, 133, NULL, NULL, 230885),
(242031, '1xvsA00', NULL, NULL, 126, NULL, NULL, 230885),
(242032, '2f1eA00', NULL, NULL, 127, NULL, NULL, 230885);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(242033, '1tzaB00', NULL, NULL, 134, NULL, NULL, 230885),
(242034, '1i5jA00', NULL, NULL, 79, NULL, NULL, 230886),
(242035, '5xnlQ00', NULL, NULL, 129, NULL, NULL, 230887),
(242036, '1nzeA00', NULL, NULL, 112, NULL, NULL, 230887),
(242037, '3rfyA02', NULL, NULL, 107, NULL, NULL, 230887),
(242038, '1vykA00', NULL, NULL, 149, NULL, NULL, 230887),
(242039, '3zsuA00', NULL, NULL, 130, NULL, NULL, 230887),
(242040, '3ls1A00', NULL, NULL, 133, NULL, NULL, 230887),
(242041, '1ti2A01', NULL, NULL, 66, NULL, NULL, 230888),
(242042, '3cmnA01', NULL, NULL, 132, NULL, NULL, 230889),
(242043, '4dolA02', NULL, NULL, 51, NULL, NULL, 230890),
(242044, '4dokA02', NULL, NULL, 53, NULL, NULL, 230890),
(242045, '5yx3A02', NULL, NULL, 53, NULL, NULL, 230890),
(242046, '5wkrA02', NULL, NULL, 60, NULL, NULL, 230890),
(242047, '4dooA02', NULL, NULL, 54, NULL, NULL, 230890),
(242048, '4doiA02', NULL, NULL, 53, NULL, NULL, 230890),
(242049, '1eyqA01', NULL, NULL, 60, NULL, NULL, 230890),
(242050, '4dhxA00', NULL, NULL, 75, NULL, NULL, 230891),
(242051, '3mmjB01', NULL, NULL, 97, NULL, NULL, 230892),
(242052, '4jbcB01', NULL, NULL, 98, NULL, NULL, 230892),
(242053, '4wu3A02', NULL, NULL, 85, NULL, NULL, 230892),
(242054, '3mcbA00', NULL, NULL, 54, NULL, NULL, 230893),
(242055, '3mcbB00', NULL, NULL, 58, NULL, NULL, 230893),
(242056, '3lkxB00', NULL, NULL, 54, NULL, NULL, 230893),
(242057, '1tr8A01', NULL, NULL, 61, NULL, NULL, 230893),
(242058, '1tr8B01', NULL, NULL, 61, NULL, NULL, 230893),
(242059, '3kzxA02', NULL, NULL, 62, NULL, NULL, 230894),
(242060, '1yozA00', NULL, NULL, 116, NULL, NULL, 230895),
(242061, '2ns6A00', NULL, NULL, 185, NULL, NULL, 230896),
(242062, '4lviA01', NULL, NULL, 185, NULL, NULL, 230896),
(242063, '4ht4A00', NULL, NULL, 195, NULL, NULL, 230896),
(242064, '6o9qA02', NULL, NULL, 315, NULL, NULL, 230897),
(242065, '3kb9A00', NULL, NULL, 346, NULL, NULL, 230897),
(242066, '3aq0B00', NULL, NULL, 348, NULL, NULL, 230897),
(242067, '3qkcA00', NULL, NULL, 273, NULL, NULL, 230897),
(242068, '3wjkA00', NULL, NULL, 337, NULL, NULL, 230897),
(242069, '3pdeD00', NULL, NULL, 309, NULL, NULL, 230897),
(242070, '2h8oA00', NULL, NULL, 303, NULL, NULL, 230897),
(242071, '2j5cA02', NULL, NULL, 329, NULL, NULL, 230897),
(242072, '4jxyA00', NULL, NULL, 345, NULL, NULL, 230897),
(242073, '1v4eA00', NULL, NULL, 299, NULL, NULL, 230897),
(242074, '3zcdA00', NULL, NULL, 296, NULL, NULL, 230897),
(242075, '3p41A00', NULL, NULL, 303, NULL, NULL, 230897),
(242076, '6b04C00', NULL, NULL, 341, NULL, NULL, 230897),
(242077, '3lomA00', NULL, NULL, 313, NULL, NULL, 230897),
(242078, '2q80A00', NULL, NULL, 301, NULL, NULL, 230897),
(242079, '3mzvA00', NULL, NULL, 341, NULL, NULL, 230897),
(242080, '3ts7B00', NULL, NULL, 324, NULL, NULL, 230897),
(242081, '4jxnA00', NULL, NULL, 334, NULL, NULL, 230897),
(242082, '1yyqB00', NULL, NULL, 354, NULL, NULL, 230897),
(242083, '5xn6D00', NULL, NULL, 304, NULL, NULL, 230897),
(242084, '1n1bB02', NULL, NULL, 313, NULL, NULL, 230897),
(242085, '3wcaA00', NULL, NULL, 341, NULL, NULL, 230897),
(242086, '1di1A00', NULL, NULL, 300, NULL, NULL, 230897),
(242087, '4omhB00', NULL, NULL, 294, NULL, NULL, 230897),
(242088, '1ubyA00', NULL, NULL, 348, NULL, NULL, 230897),
(242089, '1rtrA00', NULL, NULL, 301, NULL, NULL, 230897),
(242090, '4lfgA00', NULL, NULL, 290, NULL, NULL, 230897),
(242091, '3n0fA02', NULL, NULL, 316, NULL, NULL, 230897),
(242092, '2j1pB00', NULL, NULL, 293, NULL, NULL, 230897),
(242093, '4fjqA01', NULL, NULL, 367, NULL, NULL, 230897),
(242094, '5jfqB00', NULL, NULL, 322, NULL, NULL, 230897),
(242095, '5e8hA00', NULL, NULL, 312, NULL, NULL, 230897),
(242096, '3p8rA00', NULL, NULL, 302, NULL, NULL, 230897),
(242097, '2z4vA00', NULL, NULL, 340, NULL, NULL, 230897),
(242098, '4llsA00', NULL, NULL, 311, NULL, NULL, 230897),
(242099, '5e8kA00', NULL, NULL, 313, NULL, NULL, 230897),
(242100, '3vj8A00', NULL, NULL, 343, NULL, NULL, 230897),
(242101, '4fp4A00', NULL, NULL, 254, NULL, NULL, 230897),
(242102, '1yhlA00', NULL, NULL, 362, NULL, NULL, 230897),
(242103, '3m0gB00', NULL, NULL, 297, NULL, NULL, 230897);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(242104, '5jo7A02', NULL, NULL, 313, NULL, NULL, 230897),
(242105, '4wk5A00', NULL, NULL, 273, NULL, NULL, 230897),
(242106, '2ftzA00', NULL, NULL, 284, NULL, NULL, 230897),
(242107, '1wmwB00', NULL, NULL, 330, NULL, NULL, 230897),
(242108, '4nuaA00', NULL, NULL, 345, NULL, NULL, 230897),
(242109, '5hn9C00', NULL, NULL, 375, NULL, NULL, 230897),
(242110, '3we9A00', NULL, NULL, 274, NULL, NULL, 230897),
(242111, '3pkoB00', NULL, NULL, 334, NULL, NULL, 230897),
(242112, '5e8lB00', NULL, NULL, 309, NULL, NULL, 230897),
(242113, '5b02B01', NULL, NULL, 278, NULL, NULL, 230897),
(242114, '5i1uA00', NULL, NULL, 316, NULL, NULL, 230897),
(242115, '3nf2A00', NULL, NULL, 352, NULL, NULL, 230897),
(242116, '3lsnA00', NULL, NULL, 304, NULL, NULL, 230897),
(242117, '3rmgA00', NULL, NULL, 334, NULL, NULL, 230897),
(242118, '5xn5A00', NULL, NULL, 305, NULL, NULL, 230897),
(242119, '4okmD00', NULL, NULL, 348, NULL, NULL, 230897),
(242120, '1rqjA00', NULL, NULL, 299, NULL, NULL, 230897),
(242121, '4dhdA00', NULL, NULL, 337, NULL, NULL, 230897),
(242122, '3npkA00', NULL, NULL, 291, NULL, NULL, 230897),
(242123, '5dz2A00', NULL, NULL, 338, NULL, NULL, 230897),
(242124, '3tc1B00', NULL, NULL, 315, NULL, NULL, 230897),
(242125, '3aqbB00', NULL, NULL, 325, NULL, NULL, 230897),
(242126, '3acxA00', NULL, NULL, 293, NULL, NULL, 230897),
(242127, '5h9dA00', NULL, NULL, 319, NULL, NULL, 230897),
(242128, '3q1oA00', NULL, NULL, 310, NULL, NULL, 230897),
(242129, '3g4dA01', NULL, NULL, 369, NULL, NULL, 230897),
(242130, '3p8lA00', NULL, NULL, 302, NULL, NULL, 230897),
(242131, '4jzxA00', NULL, NULL, 362, NULL, NULL, 230897),
(242132, '3v1vA00', NULL, NULL, 325, NULL, NULL, 230897),
(242133, '3kroD00', NULL, NULL, 295, NULL, NULL, 230897),
(242134, '2azjA00', NULL, NULL, 289, NULL, NULL, 230897),
(242135, '3ucaA00', NULL, NULL, 291, NULL, NULL, 230897),
(242136, '4kwdA00', NULL, NULL, 314, NULL, NULL, 230897),
(242137, '5eroA00', NULL, NULL, 307, NULL, NULL, 230897),
(242138, '5ermB00', NULL, NULL, 343, NULL, NULL, 230897),
(242139, '4f62A00', NULL, NULL, 292, NULL, NULL, 230897),
(242140, '4kk2B00', NULL, NULL, 338, NULL, NULL, 230897),
(242141, '4lixA03', NULL, NULL, 279, NULL, NULL, 230897),
(242142, '4hd1A00', NULL, NULL, 264, NULL, NULL, 230897),
(242143, '3lk5A00', NULL, NULL, 380, NULL, NULL, 230897),
(242144, '4kkmB00', NULL, NULL, 298, NULL, NULL, 230897),
(242145, '3kraC00', NULL, NULL, 274, NULL, NULL, 230897),
(242146, '5nx5B00', NULL, NULL, 309, NULL, NULL, 230897),
(242147, '1ps1A00', NULL, NULL, 313, NULL, NULL, 230897),
(242148, '5uv2A02', NULL, NULL, 330, NULL, NULL, 230897),
(242149, '1wy0A00', NULL, NULL, 342, NULL, NULL, 230897),
(242150, '5c05B02', NULL, NULL, 313, NULL, NULL, 230897),
(242151, '3sdrA03', NULL, NULL, 316, NULL, NULL, 230897),
(242152, '3oyrB00', NULL, NULL, 328, NULL, NULL, 230897),
(242153, '4lobA00', NULL, NULL, 347, NULL, NULL, 230897),
(242154, '2ongA02', NULL, NULL, 313, NULL, NULL, 230897),
(242155, '3p5pA03', NULL, NULL, 320, NULL, NULL, 230897),
(242156, '6oh6A00', NULL, NULL, 320, NULL, NULL, 230897),
(242157, '3s9vB03', NULL, NULL, 312, NULL, NULL, 230897),
(242158, '3q2qA00', NULL, NULL, 332, NULL, NULL, 230897),
(242159, '5il3A01', NULL, NULL, 371, NULL, NULL, 230897),
(242160, '2q58B00', NULL, NULL, 346, NULL, NULL, 230897),
(242161, '5aypB00', NULL, NULL, 297, NULL, NULL, 230897),
(242162, '4zq8A00', NULL, NULL, 325, NULL, NULL, 230897),
(242163, '4mc3A00', NULL, NULL, 310, NULL, NULL, 230897),
(242164, '3ipiA00', NULL, NULL, 295, NULL, NULL, 230897),
(242165, '3dyhA00', NULL, NULL, 367, NULL, NULL, 230897),
(242166, '4q6vA00', NULL, NULL, 136, NULL, NULL, 230898),
(242167, '4hrvB00', NULL, NULL, 167, NULL, NULL, 230898),
(242168, '3w1eA02', NULL, NULL, 177, NULL, NULL, 230898),
(242169, '4q6zA00', NULL, NULL, 136, NULL, NULL, 230898),
(242170, '4uv3E01', NULL, NULL, 217, NULL, NULL, 230898),
(242171, '2iqiB00', NULL, NULL, 192, NULL, NULL, 230898),
(242172, '4litA02', NULL, NULL, 169, NULL, NULL, 230899),
(242173, '4cswA02', NULL, NULL, 179, NULL, NULL, 230899),
(242174, '2vxgA02', NULL, NULL, 89, NULL, NULL, 230900);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(242175, '4a1nA02', NULL, NULL, 53, NULL, NULL, 230901),
(242176, '2w02B02', NULL, NULL, 70, NULL, NULL, 230902),
(242177, '4dapA01', NULL, NULL, 80, NULL, NULL, 230903),
(242178, '4da2A01', NULL, NULL, 79, NULL, NULL, 230903),
(242179, '2ptmA01', NULL, NULL, 69, NULL, NULL, 230904),
(242180, '3bpzA01', NULL, NULL, 70, NULL, NULL, 230904),
(242181, '4d7sA01', NULL, NULL, 67, NULL, NULL, 230904),
(242182, '5khhA01', NULL, NULL, 68, NULL, NULL, 230904),
(242183, '3u0zA01', NULL, NULL, 73, NULL, NULL, 230904),
(242184, '3etqB01', NULL, NULL, 72, NULL, NULL, 230904),
(242185, '3otfA01', NULL, NULL, 67, NULL, NULL, 230904),
(242186, '2hy7A01', NULL, NULL, 229, NULL, NULL, 230905),
(242187, '4ebbA02', NULL, NULL, 149, NULL, NULL, 230906),
(242188, '3n2zB02', NULL, NULL, 149, NULL, NULL, 230906),
(242189, '6bogA07', NULL, NULL, 78, NULL, NULL, 230907),
(242190, '1u0sA00', NULL, NULL, 86, NULL, NULL, 230908),
(242191, '3o4zA02', NULL, NULL, 204, NULL, NULL, 230909),
(242192, '5v3nA00', NULL, NULL, 113, NULL, NULL, 230910),
(242193, '6mjcA00', NULL, NULL, 116, NULL, NULL, 230910),
(242194, '5ktbA02', NULL, NULL, 108, NULL, NULL, 230910),
(242195, '4ofzA01', NULL, NULL, 117, NULL, NULL, 230911),
(242196, '2qezA01', NULL, NULL, 54, NULL, NULL, 230912),
(242197, '5ysnA01', NULL, NULL, 54, NULL, NULL, 230912),
(242198, '1hs7A00', NULL, NULL, 97, NULL, NULL, 230913),
(242199, '2dnxA00', NULL, NULL, 130, NULL, NULL, 230913),
(242200, '2xheB01', NULL, NULL, 222, NULL, NULL, 230913),
(242201, '3lg7A00', NULL, NULL, 133, NULL, NULL, 230913),
(242202, '5m4yA00', NULL, NULL, 194, NULL, NULL, 230913),
(242203, '4jehB00', NULL, NULL, 224, NULL, NULL, 230913),
(242204, '1fioA00', NULL, NULL, 196, NULL, NULL, 230913),
(242205, '1ez3A00', NULL, NULL, 127, NULL, NULL, 230913),
(242206, '4tx5B00', NULL, NULL, 192, NULL, NULL, 230913),
(242207, '1s94B00', NULL, NULL, 125, NULL, NULL, 230913),
(242208, '1nxhA00', NULL, NULL, 126, NULL, NULL, 230914),
(242209, '2ekgA02', NULL, NULL, 243, NULL, NULL, 230915),
(242210, '6fnuA00', NULL, NULL, 308, NULL, NULL, 230915),
(242211, '4h6qA00', NULL, NULL, 294, NULL, NULL, 230915),
(242212, '3fstA00', NULL, NULL, 304, NULL, NULL, 230915),
(242213, '3aptA00', NULL, NULL, 292, NULL, NULL, 230915),
(242214, '3e2qA01', NULL, NULL, 430, NULL, NULL, 230915),
(242215, '5umeE00', NULL, NULL, 295, NULL, NULL, 230915),
(242216, '4o8aA01', NULL, NULL, 432, NULL, NULL, 230915),
(242217, '3ijdA00', NULL, NULL, 315, NULL, NULL, 230915),
(242218, '3ca8A01', NULL, NULL, 111, NULL, NULL, 230916),
(242219, '2lxeA01', NULL, NULL, 69, NULL, NULL, 230917),
(242220, '4es8B02', NULL, NULL, 105, NULL, NULL, 230918),
(242221, '1jsgA00', NULL, NULL, 114, NULL, NULL, 230919),
(242222, '1jnpA00', NULL, NULL, 116, NULL, NULL, 230919),
(242223, '1a1xA00', NULL, NULL, 108, NULL, NULL, 230919),
(242224, '2qzgA01', NULL, NULL, 84, NULL, NULL, 230920),
(242225, '2bl7A00', NULL, NULL, 82, NULL, NULL, 230920),
(242226, '2bl8B00', NULL, NULL, 85, NULL, NULL, 230920),
(242227, '1tdpA00', NULL, NULL, 111, NULL, NULL, 230920),
(242228, '2qsbA00', NULL, NULL, 89, NULL, NULL, 230920),
(242229, '2fu2A00', NULL, NULL, 79, NULL, NULL, 230920),
(242230, '2ahrA02', NULL, NULL, 106, NULL, NULL, 230921),
(242231, '5uavB02', NULL, NULL, 103, NULL, NULL, 230921),
(242232, '2rcyA02', NULL, NULL, 108, NULL, NULL, 230921),
(242233, '1yqgA02', NULL, NULL, 113, NULL, NULL, 230921),
(242234, '3triA02', NULL, NULL, 110, NULL, NULL, 230921),
(242235, '5bseA02', NULL, NULL, 99, NULL, NULL, 230921),
(242236, '2wyrA01', NULL, NULL, 241, NULL, NULL, 230922),
(242237, '3cpxB01', NULL, NULL, 259, NULL, NULL, 230922),
(242238, '4okoA00', NULL, NULL, 312, NULL, NULL, 230922),
(242239, '2fvgA01', NULL, NULL, 253, NULL, NULL, 230922),
(242240, '1vhoA01', NULL, NULL, 261, NULL, NULL, 230922),
(242241, '2qyvA01', NULL, NULL, 271, NULL, NULL, 230922),
(242242, '1fnoA01', NULL, NULL, 296, NULL, NULL, 230922),
(242243, '1y7eA01', NULL, NULL, 320, NULL, NULL, 230922),
(242244, '1gytL02', NULL, NULL, 318, NULL, NULL, 230922),
(242245, '5uejB01', NULL, NULL, 270, NULL, NULL, 230922);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(242246, '3l2nA02', NULL, NULL, 264, NULL, NULL, 230922),
(242247, '4ewtA01', NULL, NULL, 277, NULL, NULL, 230922),
(242248, '4emeA01', NULL, NULL, 354, NULL, NULL, 230922),
(242249, '4pxeA01', NULL, NULL, 313, NULL, NULL, 230922),
(242250, '5xoyA01', NULL, NULL, 249, NULL, NULL, 230922),
(242251, '2qvpC00', NULL, NULL, 275, NULL, NULL, 230922),
(242252, '2wznA01', NULL, NULL, 260, NULL, NULL, 230922),
(242253, '4g1pA01', NULL, NULL, 313, NULL, NULL, 230922),
(242254, '3si2A00', NULL, NULL, 327, NULL, NULL, 230922),
(242255, '4x8iA01', NULL, NULL, 252, NULL, NULL, 230922),
(242256, '3guxA00', NULL, NULL, 298, NULL, NULL, 230922),
(242257, '5nthA02', NULL, NULL, 345, NULL, NULL, 230922),
(242258, '6qqlA00', NULL, NULL, 293, NULL, NULL, 230922),
(242259, '3cdxD00', NULL, NULL, 354, NULL, NULL, 230922),
(242260, '1lfwA01', NULL, NULL, 276, NULL, NULL, 230922),
(242261, '2glfA01', NULL, NULL, 315, NULL, NULL, 230922),
(242262, '2pcuA00', NULL, NULL, 305, NULL, NULL, 230922),
(242263, '1jqgA02', NULL, NULL, 316, NULL, NULL, 230922),
(242264, '4wjbA01', NULL, NULL, 309, NULL, NULL, 230922),
(242265, '3isxA01', NULL, NULL, 254, NULL, NULL, 230922),
(242266, '3na6A00', NULL, NULL, 331, NULL, NULL, 230922),
(242267, '3k2kA02', NULL, NULL, 270, NULL, NULL, 230922),
(242268, '1kwmA02', NULL, NULL, 314, NULL, NULL, 230922),
(242269, '1pcaA02', NULL, NULL, 300, NULL, NULL, 230922),
(242270, '4dyoA01', NULL, NULL, 320, NULL, NULL, 230922),
(242271, '3d4uA00', NULL, NULL, 309, NULL, NULL, 230922),
(242272, '1lamA02', NULL, NULL, 318, NULL, NULL, 230922),
(242273, '6omeA02', NULL, NULL, 332, NULL, NULL, 230922),
(242274, '3gb0A01', NULL, NULL, 261, NULL, NULL, 230922),
(242275, '3pb6X00', NULL, NULL, 313, NULL, NULL, 230922),
(242276, '4faiA00', NULL, NULL, 330, NULL, NULL, 230922),
(242277, '3khxA01', NULL, NULL, 231, NULL, NULL, 230922),
(242278, '1xmbA01', NULL, NULL, 300, NULL, NULL, 230922),
(242279, '5mrvA00', NULL, NULL, 307, NULL, NULL, 230922),
(242280, '5hxdA00', NULL, NULL, 237, NULL, NULL, 230922),
(242281, '1m4lA00', NULL, NULL, 307, NULL, NULL, 230922),
(242282, '4mhpA00', NULL, NULL, 326, NULL, NULL, 230922),
(242283, '2v8hA01', NULL, NULL, 315, NULL, NULL, 230922),
(242284, '5of0A01', NULL, NULL, 325, NULL, NULL, 230922),
(242285, '6qroA00', NULL, NULL, 292, NULL, NULL, 230922),
(242286, '1dtdA00', NULL, NULL, 303, NULL, NULL, 230922),
(242287, '2c1cA00', NULL, NULL, 312, NULL, NULL, 230922),
(242288, '4mxuA01', NULL, NULL, 265, NULL, NULL, 230922),
(242289, '2nsmA01', NULL, NULL, 321, NULL, NULL, 230922),
(242290, '5ib9A01', NULL, NULL, 294, NULL, NULL, 230922),
(242291, '3fmcC01', NULL, NULL, 292, NULL, NULL, 230922),
(242292, '5ds0C01', NULL, NULL, 270, NULL, NULL, 230922),
(242293, '4b6zB02', NULL, NULL, 270, NULL, NULL, 230922),
(242294, '3iehA00', NULL, NULL, 276, NULL, NULL, 230922),
(242295, '3h8gA02', NULL, NULL, 319, NULL, NULL, 230922),
(242296, '5jgfA01', NULL, NULL, 323, NULL, NULL, 230922),
(242297, '1yw6B00', NULL, NULL, 335, NULL, NULL, 230922),
(242298, '3kzwA02', NULL, NULL, 329, NULL, NULL, 230922),
(242299, '1q7lA00', NULL, NULL, 198, NULL, NULL, 230922),
(242300, '3io1A01', NULL, NULL, 329, NULL, NULL, 230922),
(242301, '3dljA01', NULL, NULL, 311, NULL, NULL, 230922),
(242302, '3rzaA01', NULL, NULL, 285, NULL, NULL, 230922),
(242303, '4wwvA01', NULL, NULL, 271, NULL, NULL, 230922),
(242304, '3n5fA01', NULL, NULL, 294, NULL, NULL, 230922),
(242305, '3kl9A01', NULL, NULL, 265, NULL, NULL, 230922),
(242306, '3ij3A02', NULL, NULL, 325, NULL, NULL, 230922),
(242307, '5k8pD01', NULL, NULL, 294, NULL, NULL, 230922),
(242308, '1uwyA01', NULL, NULL, 296, NULL, NULL, 230922),
(242309, '1vixB01', NULL, NULL, 308, NULL, NULL, 230922),
(242310, '3ct9B01', NULL, NULL, 249, NULL, NULL, 230922),
(242311, '1yloA01', NULL, NULL, 266, NULL, NULL, 230922),
(242312, '1h8lA01', NULL, NULL, 301, NULL, NULL, 230922),
(242313, '3lwuA01', NULL, NULL, 295, NULL, NULL, 230922),
(242314, '3iibA01', NULL, NULL, 294, NULL, NULL, 230922),
(242315, '2pokA01', NULL, NULL, 288, NULL, NULL, 230922),
(242316, '2g9dA01', NULL, NULL, 285, NULL, NULL, 230922);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(242317, '1rtqA00', NULL, NULL, 299, NULL, NULL, 230922),
(242318, '3jruA02', NULL, NULL, 317, NULL, NULL, 230922),
(242319, '4fuuA00', NULL, NULL, 309, NULL, NULL, 230922),
(242320, '4f9uA00', NULL, NULL, 312, NULL, NULL, 230922),
(242321, '4h2kA00', NULL, NULL, 269, NULL, NULL, 230922),
(242322, '4ihmA00', NULL, NULL, 326, NULL, NULL, 230922),
(242323, '3nh4A01', NULL, NULL, 279, NULL, NULL, 230922),
(242324, '4a37A02', NULL, NULL, 262, NULL, NULL, 230922),
(242325, '1cg2A01', NULL, NULL, 283, NULL, NULL, 230922),
(242326, '4zi6C02', NULL, NULL, 312, NULL, NULL, 230922),
(242327, '1tkjA00', NULL, NULL, 284, NULL, NULL, 230922),
(242328, '5ntdA02', NULL, NULL, 330, NULL, NULL, 230922),
(242329, '2greA01', NULL, NULL, 253, NULL, NULL, 230922),
(242330, '2hc9A02', NULL, NULL, 336, NULL, NULL, 230922),
(242331, '5lhjA02', NULL, NULL, 343, NULL, NULL, 230922),
(242332, '3varA01', NULL, NULL, 320, NULL, NULL, 230922),
(242333, '1yw4B00', NULL, NULL, 341, NULL, NULL, 230922),
(242334, '4axvA00', NULL, NULL, 243, NULL, NULL, 230922),
(242335, '3pfeA01', NULL, NULL, 301, NULL, NULL, 230922),
(242336, '2qj8A00', NULL, NULL, 332, NULL, NULL, 230922),
(242337, '2gljA01', NULL, NULL, 323, NULL, NULL, 230922),
(242338, '2rb7A01', NULL, NULL, 257, NULL, NULL, 230922),
(242339, '2q4zA01', NULL, NULL, 264, NULL, NULL, 230922),
(242340, '2bcoB01', NULL, NULL, 349, NULL, NULL, 230922),
(242341, '4ruhB01', NULL, NULL, 301, NULL, NULL, 230922),
(242342, '3tx8A01', NULL, NULL, 255, NULL, NULL, 230922),
(242343, '4tweA01', NULL, NULL, 324, NULL, NULL, 230922),
(242344, '5d8nB02', NULL, NULL, 329, NULL, NULL, 230922),
(242345, '2f7vA01', NULL, NULL, 255, NULL, NULL, 230922),
(242346, '4onwA00', NULL, NULL, 268, NULL, NULL, 230922),
(242347, '2zogA01', NULL, NULL, 305, NULL, NULL, 230922),
(242348, '4q7aA01', NULL, NULL, 263, NULL, NULL, 230922),
(242349, '3pfoA01', NULL, NULL, 305, NULL, NULL, 230922),
(242350, '6c0dA01', NULL, NULL, 305, NULL, NULL, 230922),
(242351, '2afwA00', NULL, NULL, 329, NULL, NULL, 230922),
(242352, '3mn8A01', NULL, NULL, 309, NULL, NULL, 230922),
(242353, '1y0yA01', NULL, NULL, 259, NULL, NULL, 230922),
(242354, '4z65A00', NULL, NULL, 304, NULL, NULL, 230922),
(242355, '5thwD01', NULL, NULL, 297, NULL, NULL, 230922),
(242356, '3fjuA00', NULL, NULL, 307, NULL, NULL, 230922),
(242357, '3ifeA01', NULL, NULL, 305, NULL, NULL, 230922),
(242358, '3peiA02', NULL, NULL, 319, NULL, NULL, 230922),
(242359, '3mruA01', NULL, NULL, 275, NULL, NULL, 230922),
(242360, '5tp4B01', NULL, NULL, 316, NULL, NULL, 230922),
(242361, '5jm6A01', NULL, NULL, 318, NULL, NULL, 230922),
(242362, '3k9tA01', NULL, NULL, 259, NULL, NULL, 230922),
(242363, '4p10A02', NULL, NULL, 312, NULL, NULL, 230922),
(242364, '5ntfA02', NULL, NULL, 331, NULL, NULL, 230922),
(242365, '4mmoA01', NULL, NULL, 270, NULL, NULL, 230922),
(242366, '5i4mB01', NULL, NULL, 299, NULL, NULL, 230922),
(242367, '1nsaA02', NULL, NULL, 303, NULL, NULL, 230922),
(242368, '1ysjA01', NULL, NULL, 263, NULL, NULL, 230922),
(242369, '1vheA01', NULL, NULL, 283, NULL, NULL, 230922),
(242370, '3tc8A00', NULL, NULL, 293, NULL, NULL, 230922),
(242371, '4pxdA01', NULL, NULL, 298, NULL, NULL, 230922),
(242372, '3wt4A01', NULL, NULL, 296, NULL, NULL, 230922),
(242373, '3ramA01', NULL, NULL, 276, NULL, NULL, 230922),
(242374, '3kasA01', NULL, NULL, 308, NULL, NULL, 230922),
(242375, '3fedA01', NULL, NULL, 325, NULL, NULL, 230922),
(242376, '3t8wC02', NULL, NULL, 310, NULL, NULL, 230922),
(242377, '3b2yA00', NULL, NULL, 275, NULL, NULL, 230922),
(242378, '3fdjA02', NULL, NULL, 38, NULL, NULL, 230923),
(242379, '3jr7A02', NULL, NULL, 38, NULL, NULL, 230923),
(242380, '1pzxA02', NULL, NULL, 35, NULL, NULL, 230923),
(242381, '3pl5A02', NULL, NULL, 37, NULL, NULL, 230923),
(242382, '2m05A00', NULL, NULL, 65, NULL, NULL, 230924),
(242383, '2fmaA00', NULL, NULL, 59, NULL, NULL, 230924),
(242384, '4jdoA01', NULL, NULL, 71, NULL, NULL, 230925),
(242385, '4rv9A03', NULL, NULL, 52, NULL, NULL, 230926),
(242386, '4e2xA03', NULL, NULL, 51, NULL, NULL, 230926),
(242387, '5t67A03', NULL, NULL, 51, NULL, NULL, 230926);
INSERT INTO "PUBLIC"."MODEL" VALUES
(242388, '1dysA00', NULL, NULL, 348, NULL, NULL, 230927),
(242389, '3vogA00', NULL, NULL, 373, NULL, NULL, 230927),
(242390, '5xyhA00', NULL, NULL, 425, NULL, NULL, 230927),
(242391, '1oc7A00', NULL, NULL, 364, NULL, NULL, 230927),
(242392, '3ru8X00', NULL, NULL, 282, NULL, NULL, 230927),
(242393, '4a05A00', NULL, NULL, 364, NULL, NULL, 230927),
(242394, '4ax7B00', NULL, NULL, 363, NULL, NULL, 230927),
(242395, '6faoA00', NULL, NULL, 296, NULL, NULL, 230927),
(242396, '2bogX00', NULL, NULL, 286, NULL, NULL, 230927),
(242397, '5jx5A00', NULL, NULL, 322, NULL, NULL, 230927),
(242398, '5xcyA00', NULL, NULL, 358, NULL, NULL, 230927),
(242399, '4b4hA00', NULL, NULL, 420, NULL, NULL, 230927),
(242400, '3rptA00', NULL, NULL, 282, NULL, NULL, 230927),
(242401, '4i5uA00', NULL, NULL, 364, NULL, NULL, 230927),
(242402, '3a9bA00', NULL, NULL, 395, NULL, NULL, 230927),
(242403, '1uozA01', NULL, NULL, 286, NULL, NULL, 230927),
(242404, '2p3yA03', NULL, NULL, 148, NULL, NULL, 230928),
(242405, '3h0gE02', NULL, NULL, 73, NULL, NULL, 230929),
(242406, '4aybH00', NULL, NULL, 84, NULL, NULL, 230929),
(242407, '5xogE02', NULL, NULL, 73, NULL, NULL, 230929),
(242408, '6gmhE02', NULL, NULL, 73, NULL, NULL, 230929),
(242409, '1dzfA02', NULL, NULL, 73, NULL, NULL, 230929),
(242410, '4qiwH00', NULL, NULL, 82, NULL, NULL, 230929),
(242411, '1eikA00', NULL, NULL, 77, NULL, NULL, 230929),
(242412, '3s9zA02', NULL, NULL, 129, NULL, NULL, 230930),
(242413, '4ex4B02', NULL, NULL, 130, NULL, NULL, 230930),
(242414, '1d8cA02', NULL, NULL, 128, NULL, NULL, 230930),
(242415, '2w02B01', NULL, NULL, 80, NULL, NULL, 230931),
(242416, '1n0eA00', NULL, NULL, 145, NULL, NULL, 230932),
(242417, '5cqgA05', NULL, NULL, 189, NULL, NULL, 230933),
(242418, '1vquA01', NULL, NULL, 67, NULL, NULL, 230934),
(242419, '1khdA01', NULL, NULL, 111, NULL, NULL, 230934),
(242420, '3h5qA01', NULL, NULL, 70, NULL, NULL, 230934),
(242421, '4giuA01', NULL, NULL, 67, NULL, NULL, 230934),
(242422, '1brwA03', NULL, NULL, 67, NULL, NULL, 230934),
(242423, '4muoA01', NULL, NULL, 72, NULL, NULL, 230934),
(242424, '2elcA01', NULL, NULL, 67, NULL, NULL, 230934),
(242425, '4ga4A01', NULL, NULL, 68, NULL, NULL, 230934),
(242426, '4eadA01', NULL, NULL, 107, NULL, NULL, 230934),
(242427, '1zvwA01', NULL, NULL, 66, NULL, NULL, 230934),
(242428, '1zvwB01', NULL, NULL, 66, NULL, NULL, 230934),
(242429, '4yi7A01', NULL, NULL, 86, NULL, NULL, 230934),
(242430, '1uouA01', NULL, NULL, 68, NULL, NULL, 230934),
(242431, '2dsjA01', NULL, NULL, 67, NULL, NULL, 230934),
(242432, '1o17A01', NULL, NULL, 102, NULL, NULL, 230934),
(242433, '5noeA01', NULL, NULL, 97, NULL, NULL, 230934),
(242434, '5olnB01', NULL, NULL, 69, NULL, NULL, 230934),
(242435, '4hkmA01', NULL, NULL, 73, NULL, NULL, 230934),
(242436, '4hkmB01', NULL, NULL, 73, NULL, NULL, 230934),
(242437, '3bb7A02', NULL, NULL, 108, NULL, NULL, 230935),
(242438, '1dkiA02', NULL, NULL, 145, NULL, NULL, 230935),
(242439, '3s4lA00', NULL, NULL, 216, NULL, NULL, 230936),
(242440, '4q2cA01', NULL, NULL, 263, NULL, NULL, 230936),
(242441, '4qqwA01', NULL, NULL, 246, NULL, NULL, 230936),
(242442, '3sk9A00', NULL, NULL, 265, NULL, NULL, 230936),
(242443, '4emcC01', NULL, NULL, 28, NULL, NULL, 230937),
(242444, '3zs3A00', NULL, NULL, 222, NULL, NULL, 230938),
(242445, '1aunA00', NULL, NULL, 208, NULL, NULL, 230938),
(242446, '4bctA00', NULL, NULL, 201, NULL, NULL, 230938),
(242447, '2ahnA00', NULL, NULL, 222, NULL, NULL, 230938),
(242448, '4mbtA00', NULL, NULL, 198, NULL, NULL, 230938),
(242449, '4jruA00', NULL, NULL, 201, NULL, NULL, 230938),
(242450, '3g7mA00', NULL, NULL, 151, NULL, NULL, 230938),
(242451, '5x9lA00', NULL, NULL, 207, NULL, NULL, 230938),
(242452, '4l2jA00', NULL, NULL, 206, NULL, NULL, 230938),
(242453, '1du5A00', NULL, NULL, 206, NULL, NULL, 230938),
(242454, '1pcvA00', NULL, NULL, 205, NULL, NULL, 230938),
(242455, '1z3qA00', NULL, NULL, 200, NULL, NULL, 230938),
(242456, '3gd0A01', NULL, NULL, 252, NULL, NULL, 230938),
(242457, '2i0wA00', NULL, NULL, 207, NULL, NULL, 230938),
(242458, '4g6dB02', NULL, NULL, 81, NULL, NULL, 230939);
INSERT INTO "PUBLIC"."MODEL" VALUES
(242459, '3d03A02', NULL, NULL, 126, NULL, NULL, 230940),
(242460, '2pusA05', NULL, NULL, 84, NULL, NULL, 230941),
(242461, '3hveB02', NULL, NULL, 126, NULL, NULL, 230942),
(242462, '4hs2A00', NULL, NULL, 79, NULL, NULL, 230942),
(242463, '2eqxA01', NULL, NULL, 94, NULL, NULL, 230942),
(242464, '4hxiA02', NULL, NULL, 80, NULL, NULL, 230942),
(242465, '3hveA02', NULL, NULL, 126, NULL, NULL, 230942),
(242466, '3i3nA02', NULL, NULL, 106, NULL, NULL, 230942),
(242467, '2lp4A02', NULL, NULL, 80, NULL, NULL, 230943),
(242468, '1eayD00', NULL, NULL, 74, NULL, NULL, 230943),
(242469, '2gu1A02', NULL, NULL, 105, NULL, NULL, 230944),
(242470, '2gu1A01', NULL, NULL, 94, NULL, NULL, 230944),
(242471, '4rnyA02', NULL, NULL, 155, NULL, NULL, 230944),
(242472, '3sluA02', NULL, NULL, 141, NULL, NULL, 230944),
(242473, '3sluB01', NULL, NULL, 99, NULL, NULL, 230944),
(242474, '3m5rD00', NULL, NULL, 133, NULL, NULL, 230945),
(242475, '3p31A00', NULL, NULL, 131, NULL, NULL, 230945),
(242476, '3d6rA00', NULL, NULL, 114, NULL, NULL, 230945),
(242477, '2rhkA00', NULL, NULL, 120, NULL, NULL, 230945),
(242478, '3d6rB00', NULL, NULL, 158, NULL, NULL, 230945),
(242479, '3rvcA00', NULL, NULL, 125, NULL, NULL, 230945),
(242480, '2gx9A00', NULL, NULL, 129, NULL, NULL, 230945),
(242481, '2gx9B00', NULL, NULL, 129, NULL, NULL, 230945),
(242482, '3ee9B00', NULL, NULL, 122, NULL, NULL, 230945),
(242483, '3f5tA02', NULL, NULL, 114, NULL, NULL, 230945),
(242484, '6dgkA00', NULL, NULL, 120, NULL, NULL, 230945),
(242485, '6e5uU00', NULL, NULL, 125, NULL, NULL, 230945),
(242486, '1g8mA04', NULL, NULL, 190, NULL, NULL, 230946),
(242487, '1a9xA08', NULL, NULL, 106, NULL, NULL, 230946),
(242488, '1wo8A00', NULL, NULL, 126, NULL, NULL, 230946),
(242489, '6f2cA00', NULL, NULL, 124, NULL, NULL, 230946),
(242490, '1zczA01', NULL, NULL, 168, NULL, NULL, 230946),
(242491, '5uz0D01', NULL, NULL, 206, NULL, NULL, 230946),
(242492, '1b93B00', NULL, NULL, 152, NULL, NULL, 230946),
(242493, '5h3lA00', NULL, NULL, 151, NULL, NULL, 230946),
(242494, '4ehiB01', NULL, NULL, 215, NULL, NULL, 230946),
(242495, '4ehiA01', NULL, NULL, 184, NULL, NULL, 230946),
(242496, '2yvqA00', NULL, NULL, 143, NULL, NULL, 230946),
(242497, '1c30A08', NULL, NULL, 137, NULL, NULL, 230946),
(242498, '1vmdA00', NULL, NULL, 162, NULL, NULL, 230946),
(242499, '3zzmB01', NULL, NULL, 204, NULL, NULL, 230946),
(242500, '2xw6A00', NULL, NULL, 134, NULL, NULL, 230946),
(242501, '5i2mA01', NULL, NULL, 91, NULL, NULL, 230947),
(242502, '4d6wA01', NULL, NULL, 92, NULL, NULL, 230947),
(242503, '4egxD01', NULL, NULL, 68, NULL, NULL, 230948),
(242504, '1sg4C02', NULL, NULL, 56, NULL, NULL, 230949),
(242505, '1xx4A02', NULL, NULL, 56, NULL, NULL, 230949),
(242506, '6myiB00', NULL, NULL, 139, NULL, NULL, 230950),
(242507, '4oebA00', NULL, NULL, 138, NULL, NULL, 230950),
(242508, '4joxA00', NULL, NULL, 123, NULL, NULL, 230950),
(242509, '5v3sB00', NULL, NULL, 154, NULL, NULL, 230950),
(242510, '4v33A01', NULL, NULL, 97, NULL, NULL, 230951),
(242511, '6go1A01', NULL, NULL, 97, NULL, NULL, 230951),
(242512, '4hd5A01', NULL, NULL, 97, NULL, NULL, 230951),
(242513, '4l1iA00', NULL, NULL, 230, NULL, NULL, 230952),
(242514, '2dueA00', NULL, NULL, 236, NULL, NULL, 230952),
(242515, '2vvhA00', NULL, NULL, 226, NULL, NULL, 230952),
(242516, '4en1B00', NULL, NULL, 226, NULL, NULL, 230952),
(242517, '3nedA00', NULL, NULL, 242, NULL, NULL, 230952),
(242518, '5drfA00', NULL, NULL, 248, NULL, NULL, 230952),
(242519, '4he4A00', NULL, NULL, 244, NULL, NULL, 230952),
(242520, '2h5pA00', NULL, NULL, 234, NULL, NULL, 230952),
(242521, '5wj3A00', NULL, NULL, 239, NULL, NULL, 230952),
(242522, '5j3nB00', NULL, NULL, 236, NULL, NULL, 230952),
(242523, '5yr2A00', NULL, NULL, 247, NULL, NULL, 230952),
(242524, '5eb6A00', NULL, NULL, 229, NULL, NULL, 230952),
(242525, '1xmzA00', NULL, NULL, 241, NULL, NULL, 230952),
(242526, '2vadA00', NULL, NULL, 223, NULL, NULL, 230952),
(242527, '3gb3A00', NULL, NULL, 235, NULL, NULL, 230952),
(242528, '4ohsA00', NULL, NULL, 237, NULL, NULL, 230952),
(242529, '3e5tA00', NULL, NULL, 242, NULL, NULL, 230952);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(242530, '1rrxA00', NULL, NULL, 226, NULL, NULL, 230952),
(242531, '2zo6A00', NULL, NULL, 221, NULL, NULL, 230952),
(242532, '3st0A00', NULL, NULL, 227, NULL, NULL, 230952),
(242533, '2v4eB00', NULL, NULL, 218, NULL, NULL, 230952),
(242534, '5lk4A00', NULL, NULL, 217, NULL, NULL, 230952),
(242535, '2hpwA00', NULL, NULL, 233, NULL, NULL, 230952),
(242536, '3akoA00', NULL, NULL, 153, NULL, NULL, 230952),
(242537, '1h4uA00', NULL, NULL, 265, NULL, NULL, 230952),
(242538, '4lqtA00', NULL, NULL, 246, NULL, NULL, 230952),
(242539, '5ltqF00', NULL, NULL, 222, NULL, NULL, 230952),
(242540, '2rh7B00', NULL, NULL, 239, NULL, NULL, 230952),
(242541, '5y00A00', NULL, NULL, 230, NULL, NULL, 230952),
(242542, '2a46A00', NULL, NULL, 238, NULL, NULL, 230952),
(242543, '3cglC00', NULL, NULL, 225, NULL, NULL, 230952),
(242544, '2a50B00', NULL, NULL, 168, NULL, NULL, 230952),
(242545, '3svsA00', NULL, NULL, 233, NULL, NULL, 230952),
(242546, '5b61A00', NULL, NULL, 238, NULL, NULL, 230952),
(242547, '4kf4A00', NULL, NULL, 223, NULL, NULL, 230952),
(242548, '4jc2A00', NULL, NULL, 222, NULL, NULL, 230952),
(242549, '3ir8B00', NULL, NULL, 221, NULL, NULL, 230952),
(242550, '3cfaA00', NULL, NULL, 167, NULL, NULL, 230952),
(242551, '1zgoA00', NULL, NULL, 223, NULL, NULL, 230952),
(242552, '6b7tA00', NULL, NULL, 246, NULL, NULL, 230952),
(242553, '2q6pA00', NULL, NULL, 236, NULL, NULL, 230952),
(242554, '4q7uA00', NULL, NULL, 223, NULL, NULL, 230952),
(242555, '4ppkC00', NULL, NULL, 220, NULL, NULL, 230952),
(242556, '3h1oA00', NULL, NULL, 231, NULL, NULL, 230952),
(242557, '2qu1A00', NULL, NULL, 239, NULL, NULL, 230952),
(242558, '2ib5A00', NULL, NULL, 233, NULL, NULL, 230952),
(242559, '3evpA00', NULL, NULL, 243, NULL, NULL, 230952),
(242560, '2oteA00', NULL, NULL, 214, NULL, NULL, 230952),
(242561, '2g6yB00', NULL, NULL, 217, NULL, NULL, 230952),
(242562, '4gf6B00', NULL, NULL, 246, NULL, NULL, 230952),
(242563, '3cd1A00', NULL, NULL, 248, NULL, NULL, 230952),
(242564, '4w6tA00', NULL, NULL, 229, NULL, NULL, 230952),
(242565, '6gp0A00', NULL, NULL, 229, NULL, NULL, 230952),
(242566, '4zf5B00', NULL, NULL, 252, NULL, NULL, 230952),
(242567, '3adfA00', NULL, NULL, 226, NULL, NULL, 230952),
(242568, '3ip2A00', NULL, NULL, 242, NULL, NULL, 230952),
(242569, '3o77A02', NULL, NULL, 248, NULL, NULL, 230952),
(242570, '2wurA00', NULL, NULL, 236, NULL, NULL, 230952),
(242571, '4oj0A00', NULL, NULL, 244, NULL, NULL, 230952),
(242572, '6mdra00', NULL, NULL, 247, NULL, NULL, 230952),
(242573, '5yr3A00', NULL, NULL, 225, NULL, NULL, 230952),
(242574, '2vaeA00', NULL, NULL, 223, NULL, NULL, 230952),
(242575, '4oy4A02', NULL, NULL, 231, NULL, NULL, 230952),
(242576, '4rysA00', NULL, NULL, 241, NULL, NULL, 230952),
(242577, '6jgjA00', NULL, NULL, 228, NULL, NULL, 230952),
(242578, '6jc6A00', NULL, NULL, 228, NULL, NULL, 230952),
(242579, '3lf3A00', NULL, NULL, 229, NULL, NULL, 230952),
(242580, '6gp1B00', NULL, NULL, 163, NULL, NULL, 230952),
(242581, '6aa7B00', NULL, NULL, 233, NULL, NULL, 230952),
(242582, '3ai5A01', NULL, NULL, 231, NULL, NULL, 230952),
(242583, '2zo7A00', NULL, NULL, 222, NULL, NULL, 230952),
(242584, '2zmuA00', NULL, NULL, 223, NULL, NULL, 230952),
(242585, '3la1A00', NULL, NULL, 237, NULL, NULL, 230952),
(242586, '4as8A00', NULL, NULL, 243, NULL, NULL, 230952),
(242587, '3rwaA00', NULL, NULL, 233, NULL, NULL, 230952),
(242588, '2ogrA00', NULL, NULL, 229, NULL, NULL, 230952),
(242589, '2c9iB00', NULL, NULL, 226, NULL, NULL, 230952),
(242590, '4lw5D00', NULL, NULL, 239, NULL, NULL, 230952),
(242591, '6b7rA00', NULL, NULL, 236, NULL, NULL, 230952),
(242592, '4z4mA00', NULL, NULL, 260, NULL, NULL, 230952),
(242593, '2awkA00', NULL, NULL, 228, NULL, NULL, 230952),
(242594, '6dejD00', NULL, NULL, 235, NULL, NULL, 230952),
(242595, '3lf4B00', NULL, NULL, 164, NULL, NULL, 230952),
(242596, '4kpiA00', NULL, NULL, 243, NULL, NULL, 230952),
(242597, '4j8aA00', NULL, NULL, 229, NULL, NULL, 230952),
(242598, '3p28A00', NULL, NULL, 239, NULL, NULL, 230952),
(242599, '2ie2E00', NULL, NULL, 222, NULL, NULL, 230952),
(242600, '3nt3A00', NULL, NULL, 243, NULL, NULL, 230952);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(242601, '2dd7A00', NULL, NULL, 216, NULL, NULL, 230952),
(242602, '2ojkA00', NULL, NULL, 229, NULL, NULL, 230952),
(242603, '4i2yB01', NULL, NULL, 271, NULL, NULL, 230952),
(242604, '4jgeB00', NULL, NULL, 226, NULL, NULL, 230952),
(242605, '4dknB00', NULL, NULL, 221, NULL, NULL, 230952),
(242606, '4q9wA00', NULL, NULL, 218, NULL, NULL, 230952),
(242607, '3u0lA00', NULL, NULL, 230, NULL, NULL, 230952),
(242608, '2c9jD00', NULL, NULL, 223, NULL, NULL, 230952),
(242609, '6mdrb00', NULL, NULL, 240, NULL, NULL, 230952),
(242610, '5mseA00', NULL, NULL, 238, NULL, NULL, 230952),
(242611, '2ddcA00', NULL, NULL, 225, NULL, NULL, 230952),
(242612, '3pibC00', NULL, NULL, 236, NULL, NULL, 230952),
(242613, '2h5oA00', NULL, NULL, 234, NULL, NULL, 230952),
(242614, '2vzxA00', NULL, NULL, 229, NULL, NULL, 230952),
(242615, '3dq7A00', NULL, NULL, 241, NULL, NULL, 230952),
(242616, '3ls3D00', NULL, NULL, 235, NULL, NULL, 230952),
(242617, '5ltrA00', NULL, NULL, 226, NULL, NULL, 230952),
(242618, '5f9gA00', NULL, NULL, 257, NULL, NULL, 230952),
(242619, '4kw9A00', NULL, NULL, 239, NULL, NULL, 230952),
(242620, '5exbA00', NULL, NULL, 232, NULL, NULL, 230952),
(242621, '4dxmB00', NULL, NULL, 229, NULL, NULL, 230952),
(242622, '4ornA00', NULL, NULL, 239, NULL, NULL, 230952),
(242623, '2gw3A00', NULL, NULL, 225, NULL, NULL, 230952),
(242624, '2p4mA00', NULL, NULL, 219, NULL, NULL, 230952),
(242625, '4dkmA00', NULL, NULL, 214, NULL, NULL, 230952),
(242626, '2gw4B00', NULL, NULL, 162, NULL, NULL, 230952),
(242627, '3st3C00', NULL, NULL, 234, NULL, NULL, 230952),
(242628, '4edsA00', NULL, NULL, 241, NULL, NULL, 230952),
(242629, '5bqlD00', NULL, NULL, 242, NULL, NULL, 230952),
(242630, '2icrA00', NULL, NULL, 237, NULL, NULL, 230952),
(242631, '3u0kA02', NULL, NULL, 233, NULL, NULL, 230952),
(242632, '3m24D00', NULL, NULL, 232, NULL, NULL, 230952),
(242633, '4zb1A00', NULL, NULL, 227, NULL, NULL, 230952),
(242634, '5excJ00', NULL, NULL, 170, NULL, NULL, 230952),
(242635, '3kcsA00', NULL, NULL, 234, NULL, NULL, 230952),
(242636, '4xgyA00', NULL, NULL, 248, NULL, NULL, 230952),
(242637, '1kp5A00', NULL, NULL, 246, NULL, NULL, 230952),
(242638, '2qliB00', NULL, NULL, 224, NULL, NULL, 230952),
(242639, '4gobB00', NULL, NULL, 228, NULL, NULL, 230952),
(242640, '3rwtA00', NULL, NULL, 235, NULL, NULL, 230952),
(242641, '3lvcA00', NULL, NULL, 236, NULL, NULL, 230952),
(242642, '6ciuA00', NULL, NULL, 236, NULL, NULL, 230952),
(242643, '4hvfA00', NULL, NULL, 226, NULL, NULL, 230952),
(242644, '4kgeB00', NULL, NULL, 243, NULL, NULL, 230952),
(242645, '4zblA00', NULL, NULL, 240, NULL, NULL, 230952),
(242646, '2g2sB00', NULL, NULL, 173, NULL, NULL, 230952),
(242647, '1l8nA03', NULL, NULL, 206, NULL, NULL, 230953),
(242648, '1gqiA03', NULL, NULL, 237, NULL, NULL, 230953),
(242649, '3ihmA03', NULL, NULL, 49, NULL, NULL, 230954),
(242650, '2posA00', NULL, NULL, 94, NULL, NULL, 230955),
(242651, '2aibA00', NULL, NULL, 98, NULL, NULL, 230955),
(242652, '1lriA00', NULL, NULL, 98, NULL, NULL, 230955),
(242653, '3bs0A00', NULL, NULL, 439, NULL, NULL, 230956),
(242654, '3pguA00', NULL, NULL, 427, NULL, NULL, 230956),
(242655, '3bryA00', NULL, NULL, 441, NULL, NULL, 230956),
(242656, '3dwoX00', NULL, NULL, 451, NULL, NULL, 230956),
(242657, '4y1lC00', NULL, NULL, 113, NULL, NULL, 230957),
(242658, '1y8xA00', NULL, NULL, 160, NULL, NULL, 230957),
(242659, '3cegA00', NULL, NULL, 300, NULL, NULL, 230957),
(242660, '4onlB00', NULL, NULL, 160, NULL, NULL, 230957),
(242661, '1jatB00', NULL, NULL, 138, NULL, NULL, 230957),
(242662, '4gprA00', NULL, NULL, 151, NULL, NULL, 230957),
(242663, '2a7lA00', NULL, NULL, 136, NULL, NULL, 230957),
(242664, '2gjdA00', NULL, NULL, 157, NULL, NULL, 230957),
(242665, '3r3qA00', NULL, NULL, 162, NULL, NULL, 230957),
(242666, '2h2yA01', NULL, NULL, 117, NULL, NULL, 230957),
(242667, '2aakA00', NULL, NULL, 152, NULL, NULL, 230957),
(242668, '5eggA00', NULL, NULL, 156, NULL, NULL, 230957),
(242669, '1wzvA00', NULL, NULL, 155, NULL, NULL, 230957),
(242670, '5d0mA00', NULL, NULL, 152, NULL, NULL, 230957),
(242671, '2daxA01', NULL, NULL, 141, NULL, NULL, 230957);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(242672, '3kpaA00', NULL, NULL, 168, NULL, NULL, 230957),
(242673, '2mt6A00', NULL, NULL, 151, NULL, NULL, 230957),
(242674, '1zdnA00', NULL, NULL, 158, NULL, NULL, 230957),
(242675, '4r62A00', NULL, NULL, 150, NULL, NULL, 230957),
(242676, '2yz0A00', NULL, NULL, 138, NULL, NULL, 230957),
(242677, '2f4zA00', NULL, NULL, 162, NULL, NULL, 230957),
(242678, '3k9oA01', NULL, NULL, 158, NULL, NULL, 230957),
(242679, '3zqsA01', NULL, NULL, 88, NULL, NULL, 230957),
(242680, '1fzyA00', NULL, NULL, 149, NULL, NULL, 230957),
(242681, '4onmB00', NULL, NULL, 160, NULL, NULL, 230957),
(242682, '4q5eC00', NULL, NULL, 156, NULL, NULL, 230957),
(242683, '2ebmA00', NULL, NULL, 128, NULL, NULL, 230957),
(242684, '2f4wB00', NULL, NULL, 187, NULL, NULL, 230957),
(242685, '5lbnA00', NULL, NULL, 158, NULL, NULL, 230957),
(242686, '5knlF00', NULL, NULL, 175, NULL, NULL, 230957),
(242687, '4p5oG01', NULL, NULL, 160, NULL, NULL, 230957),
(242688, '2z6oA00', NULL, NULL, 172, NULL, NULL, 230957),
(242689, '4ii2C00', NULL, NULL, 163, NULL, NULL, 230957),
(242690, '2yb6A00', NULL, NULL, 152, NULL, NULL, 230957),
(242691, '1uzxA00', NULL, NULL, 169, NULL, NULL, 230957),
(242692, '1z3dA00', NULL, NULL, 157, NULL, NULL, 230957),
(242693, '2oxqA00', NULL, NULL, 152, NULL, NULL, 230957),
(242694, '3fn1B00', NULL, NULL, 167, NULL, NULL, 230957),
(242695, '3rczB00', NULL, NULL, 163, NULL, NULL, 230957),
(242696, '3o2uA01', NULL, NULL, 162, NULL, NULL, 230957),
(242697, '2y9mA00', NULL, NULL, 172, NULL, NULL, 230957),
(242698, '2eskA00', NULL, NULL, 149, NULL, NULL, 230957),
(242699, '4m1nA00', NULL, NULL, 160, NULL, NULL, 230957),
(242700, '1ukxA00', NULL, NULL, 137, NULL, NULL, 230957),
(242701, '4onlA00', NULL, NULL, 153, NULL, NULL, 230957),
(242702, '4ds2B00', NULL, NULL, 167, NULL, NULL, 230957),
(242703, '1jatA00', NULL, NULL, 155, NULL, NULL, 230957),
(242704, '2a4dA00', NULL, NULL, 140, NULL, NULL, 230957),
(242705, '2z5dB00', NULL, NULL, 155, NULL, NULL, 230957),
(242706, '4l83A00', NULL, NULL, 175, NULL, NULL, 230957),
(242707, '2r0jA00', NULL, NULL, 149, NULL, NULL, 230957),
(242708, '4x57C00', NULL, NULL, 149, NULL, NULL, 230957),
(242709, '2fo3A00', NULL, NULL, 125, NULL, NULL, 230957),
(242710, '3obqA00', NULL, NULL, 146, NULL, NULL, 230957),
(242711, '2onuA00', NULL, NULL, 152, NULL, NULL, 230957),
(242712, '3rz3D00', NULL, NULL, 183, NULL, NULL, 230957),
(242713, '4ccgB00', NULL, NULL, 167, NULL, NULL, 230957),
(242714, '1pzvA00', NULL, NULL, 164, NULL, NULL, 230957),
(242715, '2dmfA00', NULL, NULL, 137, NULL, NULL, 230957),
(242716, '4qplB00', NULL, NULL, 154, NULL, NULL, 230957),
(242717, '1yrvA00', NULL, NULL, 169, NULL, NULL, 230957),
(242718, '5v0rA00', NULL, NULL, 152, NULL, NULL, 230957),
(242719, '5f6eA00', NULL, NULL, 157, NULL, NULL, 230957),
(242720, '1z2uA00', NULL, NULL, 150, NULL, NULL, 230957),
(242721, '2e2cA00', NULL, NULL, 156, NULL, NULL, 230957),
(242722, '1yf9A00', NULL, NULL, 171, NULL, NULL, 230957),
(242723, '3h8kA00', NULL, NULL, 164, NULL, NULL, 230957),
(242724, '4yc1B00', NULL, NULL, 159, NULL, NULL, 230957),
(242725, '4yiiU00', NULL, NULL, 155, NULL, NULL, 230957),
(242726, '2ayvA00', NULL, NULL, 148, NULL, NULL, 230957),
(242727, '2dawA01', NULL, NULL, 133, NULL, NULL, 230957),
(242728, '1br7003', NULL, NULL, 117, NULL, NULL, 230957),
(242729, '4jquA00', NULL, NULL, 169, NULL, NULL, 230957),
(242730, '1x23B00', NULL, NULL, 155, NULL, NULL, 230957),
(242731, '5ojjF00', NULL, NULL, 154, NULL, NULL, 230957),
(242732, '2q0vA00', NULL, NULL, 156, NULL, NULL, 230957),
(242733, '2awfA00', NULL, NULL, 143, NULL, NULL, 230957),
(242734, '1zuoB00', NULL, NULL, 140, NULL, NULL, 230957),
(242735, '3we5A00', NULL, NULL, 152, NULL, NULL, 230957),
(242736, '4ap4B00', NULL, NULL, 153, NULL, NULL, 230957),
(242737, '4ldtC00', NULL, NULL, 148, NULL, NULL, 230957),
(242738, '2pwqA00', NULL, NULL, 154, NULL, NULL, 230957),
(242739, '2qgxA00', NULL, NULL, 169, NULL, NULL, 230957),
(242740, '1qcqA00', NULL, NULL, 148, NULL, NULL, 230957),
(242741, '2ljuA01', NULL, NULL, 75, NULL, NULL, 230958),
(242742, '2jyaA00', NULL, NULL, 83, NULL, NULL, 230958);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(242743, '2xgjA05', NULL, NULL, 130, NULL, NULL, 230959),
(242744, '4zyjA03', NULL, NULL, 154, NULL, NULL, 230960),
(242745, '4xvxA03', NULL, NULL, 147, NULL, NULL, 230960),
(242746, '2ddhA04', NULL, NULL, 132, NULL, NULL, 230960),
(242747, '2ddhA03', NULL, NULL, 167, NULL, NULL, 230960),
(242748, '2fonA03', NULL, NULL, 171, NULL, NULL, 230960),
(242749, '3sf6A03', NULL, NULL, 154, NULL, NULL, 230960),
(242750, '2fonA04', NULL, NULL, 129, NULL, NULL, 230960),
(242751, '3affB03', NULL, NULL, 185, NULL, NULL, 230960),
(242752, '4n5fA03', NULL, NULL, 148, NULL, NULL, 230960),
(242753, '2rfqC03', NULL, NULL, 185, NULL, NULL, 230960),
(242754, '3fo3A03', NULL, NULL, 108, NULL, NULL, 230960),
(242755, '5iduC03', NULL, NULL, 163, NULL, NULL, 230960),
(242756, '2c0uA03', NULL, NULL, 177, NULL, NULL, 230960),
(242757, '4u83A03', NULL, NULL, 148, NULL, NULL, 230960),
(242758, '2dvlA03', NULL, NULL, 149, NULL, NULL, 230960),
(242759, '2c0uC03', NULL, NULL, 177, NULL, NULL, 230960),
(242760, '2z1qA03', NULL, NULL, 166, NULL, NULL, 230960),
(242761, '2rdzA02', NULL, NULL, 143, NULL, NULL, 230960),
(242762, '4doyA03', NULL, NULL, 183, NULL, NULL, 230960),
(242763, '1w07A03', NULL, NULL, 171, NULL, NULL, 230960),
(242764, '4o5mC03', NULL, NULL, 152, NULL, NULL, 230960),
(242765, '1w07A04', NULL, NULL, 129, NULL, NULL, 230960),
(242766, '3m9vA03', NULL, NULL, 157, NULL, NULL, 230960),
(242767, '1udyA03', NULL, NULL, 145, NULL, NULL, 230960),
(242768, '5zw7A03', NULL, NULL, 152, NULL, NULL, 230960),
(242769, '2jifA03', NULL, NULL, 154, NULL, NULL, 230960),
(242770, '3owaB04', NULL, NULL, 172, NULL, NULL, 230960),
(242771, '3sxqA03', NULL, NULL, 108, NULL, NULL, 230960),
(242772, '4ktoA03', NULL, NULL, 144, NULL, NULL, 230960),
(242773, '3owaD04', NULL, NULL, 172, NULL, NULL, 230960),
(242774, '2wbiB03', NULL, NULL, 162, NULL, NULL, 230960),
(242775, '2pg0A03', NULL, NULL, 149, NULL, NULL, 230960),
(242776, '4l1fA03', NULL, NULL, 145, NULL, NULL, 230960),
(242777, '4w9uB03', NULL, NULL, 154, NULL, NULL, 230960),
(242778, '3mpiA03', NULL, NULL, 150, NULL, NULL, 230960),
(242779, '6fahC03', NULL, NULL, 142, NULL, NULL, 230960),
(242780, '6cxtB03', NULL, NULL, 151, NULL, NULL, 230960),
(242781, '3r7kC03', NULL, NULL, 150, NULL, NULL, 230960),
(242782, '2ebaA03', NULL, NULL, 153, NULL, NULL, 230960),
(242783, '4hr3A03', NULL, NULL, 157, NULL, NULL, 230960),
(242784, '5k3jA03', NULL, NULL, 174, NULL, NULL, 230960),
(242785, '4m9aA03', NULL, NULL, 148, NULL, NULL, 230960),
(242786, '5k3jA04', NULL, NULL, 130, NULL, NULL, 230960),
(242787, '4rm7A03', NULL, NULL, 141, NULL, NULL, 230960),
(242788, '5xdcA03', NULL, NULL, 183, NULL, NULL, 230960),
(242789, '1rx0A03', NULL, NULL, 155, NULL, NULL, 230960),
(242790, '1r2jA03', NULL, NULL, 154, NULL, NULL, 230960),
(242791, '4g5eA03', NULL, NULL, 210, NULL, NULL, 230960),
(242792, '3pfdC03', NULL, NULL, 150, NULL, NULL, 230960),
(242793, '2c12A03', NULL, NULL, 177, NULL, NULL, 230960),
(242794, '5k3hB04', NULL, NULL, 133, NULL, NULL, 230960),
(242795, '4oo2A02', NULL, NULL, 206, NULL, NULL, 230960),
(242796, '5k3hB03', NULL, NULL, 161, NULL, NULL, 230960),
(242797, '2yykA03', NULL, NULL, 215, NULL, NULL, 230960),
(242798, '3p4tA03', NULL, NULL, 150, NULL, NULL, 230960),
(242799, '2ix5A03', NULL, NULL, 160, NULL, NULL, 230960),
(242800, '4p13A03', NULL, NULL, 141, NULL, NULL, 230960),
(242801, '2j7aA02', NULL, NULL, 124, NULL, NULL, 230960),
(242802, '2c0uB03', NULL, NULL, 177, NULL, NULL, 230960),
(242803, '3bnjA02', NULL, NULL, 142, NULL, NULL, 230960),
(242804, '2jbrA03', NULL, NULL, 185, NULL, NULL, 230960),
(242805, '3ubrA02', NULL, NULL, 143, NULL, NULL, 230960),
(242806, '2c0uD03', NULL, NULL, 177, NULL, NULL, 230960),
(242807, '3hwcA03', NULL, NULL, 210, NULL, NULL, 230960),
(242808, '2z1qB04', NULL, NULL, 136, NULL, NULL, 230960),
(242809, '1ivhA03', NULL, NULL, 141, NULL, NULL, 230960),
(242810, '3swoA03', NULL, NULL, 155, NULL, NULL, 230960),
(242811, '2or0A03', NULL, NULL, 188, NULL, NULL, 230960),
(242812, '4x28C03', NULL, NULL, 152, NULL, NULL, 230960),
(242813, '4irnA03', NULL, NULL, 150, NULL, NULL, 230960);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(242814, '3mxlB03', NULL, NULL, 157, NULL, NULL, 230960),
(242815, '2d29A03', NULL, NULL, 149, NULL, NULL, 230960),
(242816, '1oahA02', NULL, NULL, 142, NULL, NULL, 230960),
(242817, '3owaA04', NULL, NULL, 172, NULL, NULL, 230960),
(242818, '4x28A03', NULL, NULL, 168, NULL, NULL, 230960),
(242819, '3owaA03', NULL, NULL, 171, NULL, NULL, 230960),
(242820, '3mkhA03', NULL, NULL, 178, NULL, NULL, 230960),
(242821, '3owaC04', NULL, NULL, 172, NULL, NULL, 230960),
(242822, '4iv6A03', NULL, NULL, 149, NULL, NULL, 230960),
(242823, '1ukwA03', NULL, NULL, 153, NULL, NULL, 230960),
(242824, '1u8vB03', NULL, NULL, 213, NULL, NULL, 230960),
(242825, '2vigA03', NULL, NULL, 141, NULL, NULL, 230960),
(242826, '3ii9D03', NULL, NULL, 154, NULL, NULL, 230960),
(242827, '1jqiA03', NULL, NULL, 141, NULL, NULL, 230960),
(242828, '1bucA03', NULL, NULL, 141, NULL, NULL, 230960),
(242829, '2uxwA01', NULL, NULL, 186, NULL, NULL, 230960),
(242830, '1siqA03', NULL, NULL, 157, NULL, NULL, 230960),
(242831, '5jscA03', NULL, NULL, 141, NULL, NULL, 230960),
(242832, '2uxwA04', NULL, NULL, 130, NULL, NULL, 230960),
(242833, '3nf4B03', NULL, NULL, 141, NULL, NULL, 230960),
(242834, '1qdbA02', NULL, NULL, 143, NULL, NULL, 230960),
(242835, '5lnxB03', NULL, NULL, 143, NULL, NULL, 230960),
(242836, '4cofB01', NULL, NULL, 220, NULL, NULL, 230961),
(242837, '5fjvD00', NULL, NULL, 213, NULL, NULL, 230961),
(242838, '3jafA01', NULL, NULL, 211, NULL, NULL, 230961),
(242839, '2wn9D00', NULL, NULL, 228, NULL, NULL, 230961),
(242840, '6hzwA01', NULL, NULL, 196, NULL, NULL, 230961),
(242841, '2y7yB00', NULL, NULL, 217, NULL, NULL, 230961),
(242842, '3rqwA01', NULL, NULL, 200, NULL, NULL, 230961),
(242843, '2bj0A00', NULL, NULL, 203, NULL, NULL, 230961),
(242844, '2bg9A01', NULL, NULL, 210, NULL, NULL, 230961),
(242845, '2bg9B01', NULL, NULL, 207, NULL, NULL, 230961),
(242846, '2bg9C01', NULL, NULL, 209, NULL, NULL, 230961),
(242847, '2bg9E01', NULL, NULL, 210, NULL, NULL, 230961),
(242848, '2qc1B00', NULL, NULL, 212, NULL, NULL, 230961),
(242849, '4afhE00', NULL, NULL, 213, NULL, NULL, 230961),
(242850, '4tnwA01', NULL, NULL, 212, NULL, NULL, 230961),
(242851, '3igqC00', NULL, NULL, 201, NULL, NULL, 230961),
(242852, '5tinA01', NULL, NULL, 219, NULL, NULL, 230961),
(242853, '4zjsC00', NULL, NULL, 230, NULL, NULL, 230961),
(242854, '5obgA00', NULL, NULL, 206, NULL, NULL, 230961),
(242855, '6hiqA01', NULL, NULL, 211, NULL, NULL, 230961),
(242856, '3sioA00', NULL, NULL, 230, NULL, NULL, 230961),
(242857, '5afnA00', NULL, NULL, 207, NULL, NULL, 230961),
(242858, '3t4mJ00', NULL, NULL, 230, NULL, NULL, 230961),
(242859, '6d6tB01', NULL, NULL, 222, NULL, NULL, 230961),
(242860, '6d6tA01', NULL, NULL, 217, NULL, NULL, 230961),
(242861, '6d6tE01', NULL, NULL, 208, NULL, NULL, 230961),
(242862, '4zk1C00', NULL, NULL, 218, NULL, NULL, 230961),
(242863, '5tvcB00', NULL, NULL, 230, NULL, NULL, 230961),
(242864, '4uxuA00', NULL, NULL, 218, NULL, NULL, 230961),
(242865, '2c10A01', NULL, NULL, 137, NULL, NULL, 230962),
(242866, '2c10A02', NULL, NULL, 132, NULL, NULL, 230962),
(242867, '1w7cA03', NULL, NULL, 115, NULL, NULL, 230962),
(242868, '1w7cA02', NULL, NULL, 117, NULL, NULL, 230962),
(242869, '3sxxC01', NULL, NULL, 117, NULL, NULL, 230962),
(242870, '3sxxD02', NULL, NULL, 109, NULL, NULL, 230962),
(242871, '2gu3A01', NULL, NULL, 73, NULL, NULL, 230962),
(242872, '2y73B01', NULL, NULL, 109, NULL, NULL, 230962),
(242873, '1tu5A01', NULL, NULL, 108, NULL, NULL, 230962),
(242874, '2gu3A02', NULL, NULL, 63, NULL, NULL, 230962),
(242875, '4exrA02', NULL, NULL, 72, NULL, NULL, 230962),
(242876, '3hi7B02', NULL, NULL, 142, NULL, NULL, 230962),
(242877, '3hi7B01', NULL, NULL, 117, NULL, NULL, 230962),
(242878, '3pgbA03', NULL, NULL, 116, NULL, NULL, 230962),
(242879, '4exrA01', NULL, NULL, 81, NULL, NULL, 230962),
(242880, '3loyA02', NULL, NULL, 114, NULL, NULL, 230962),
(242881, '3pgbA02', NULL, NULL, 118, NULL, NULL, 230962),
(242882, '2ia7A00', NULL, NULL, 134, NULL, NULL, 230962),
(242883, '3loyA01', NULL, NULL, 101, NULL, NULL, 230962),
(242884, '1tu5B02', NULL, NULL, 122, NULL, NULL, 230962);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(242885, '2k0mA00', NULL, NULL, 104, NULL, NULL, 230962),
(242886, '5iw9B00', NULL, NULL, 131, NULL, NULL, 230962),
(242887, '3wa2X02', NULL, NULL, 102, NULL, NULL, 230962),
(242888, '3wa2X01', NULL, NULL, 87, NULL, NULL, 230962),
(242889, '3nqzA02', NULL, NULL, 84, NULL, NULL, 230962),
(242890, '6grrA02', NULL, NULL, 101, NULL, NULL, 230962),
(242891, '6grrA03', NULL, NULL, 106, NULL, NULL, 230962),
(242892, '1ksiA02', NULL, NULL, 96, NULL, NULL, 230962),
(242893, '1ksiA01', NULL, NULL, 96, NULL, NULL, 230962),
(242894, '4hlbA00', NULL, NULL, 95, NULL, NULL, 230963),
(242895, '3duzA05', NULL, NULL, 48, NULL, NULL, 230964),
(242896, '3fppA03', NULL, NULL, 88, NULL, NULL, 230965),
(242897, '2vvfA02', NULL, NULL, 128, NULL, NULL, 230966),
(242898, '2vvfA01', NULL, NULL, 141, NULL, NULL, 230966),
(242899, '5o5jM02', NULL, NULL, 52, NULL, NULL, 230967),
(242900, '2vhoM02', NULL, NULL, 47, NULL, NULL, 230967),
(242901, '5mmjm02', NULL, NULL, 56, NULL, NULL, 230967),
(242902, '1i94M02', NULL, NULL, 30, NULL, NULL, 230967),
(242903, '5x8rm02', NULL, NULL, 44, NULL, NULL, 230967),
(242904, '3o30L02', NULL, NULL, 53, NULL, NULL, 230967),
(242905, '2vqeM02', NULL, NULL, 54, NULL, NULL, 230967),
(242906, '4eo0A00', NULL, NULL, 115, NULL, NULL, 230968),
(242907, '4fx5A01', NULL, NULL, 144, NULL, NULL, 230969),
(242908, '3myvA02', NULL, NULL, 41, NULL, NULL, 230970),
(242909, '3kezA02', NULL, NULL, 42, NULL, NULL, 230970),
(242910, '3mcxA02', NULL, NULL, 42, NULL, NULL, 230970),
(242911, '4pkcC00', NULL, NULL, 60, NULL, NULL, 230971),
(242912, '2ds5A00', NULL, NULL, 51, NULL, NULL, 230972),
(242913, '2y3mA02', NULL, NULL, 61, NULL, NULL, 230973),
(242914, '6fjqA00', NULL, NULL, 195, NULL, NULL, 230974),
(242915, '4xqaA00', NULL, NULL, 194, NULL, NULL, 230974),
(242916, '1qhvA00', NULL, NULL, 195, NULL, NULL, 230974),
(242917, '6g47A00', NULL, NULL, 171, NULL, NULL, 230974),
(242918, '1kacA00', NULL, NULL, 185, NULL, NULL, 230974),
(242919, '2wstA00', NULL, NULL, 176, NULL, NULL, 230974),
(242920, '6fjnA00', NULL, NULL, 184, NULL, NULL, 230974),
(242921, '6hcnA00', NULL, NULL, 186, NULL, NULL, 230974),
(242922, '3f0yA00', NULL, NULL, 208, NULL, NULL, 230974),
(242923, '2qlkA00', NULL, NULL, 194, NULL, NULL, 230974),
(242924, '3l88C00', NULL, NULL, 201, NULL, NULL, 230974),
(242925, '6f6oA00', NULL, NULL, 196, NULL, NULL, 230974),
(242926, '2bzvA00', NULL, NULL, 181, NULL, NULL, 230974),
(242927, '3cncA00', NULL, NULL, 196, NULL, NULL, 230974),
(242928, '3exvA00', NULL, NULL, 197, NULL, NULL, 230974),
(242929, '3exwA00', NULL, NULL, 213, NULL, NULL, 230974),
(242930, '2j2jA00', NULL, NULL, 197, NULL, NULL, 230974),
(242931, '1yu0A03', NULL, NULL, 179, NULL, NULL, 230975),
(242932, '2y3cA00', NULL, NULL, 278, NULL, NULL, 230975),
(242933, '1z70X00', NULL, NULL, 311, NULL, NULL, 230975),
(242934, '5nyyA00', NULL, NULL, 300, NULL, NULL, 230975),
(242935, '2q17D00', NULL, NULL, 295, NULL, NULL, 230975),
(242936, '1y4jA00', NULL, NULL, 268, NULL, NULL, 230975),
(242937, '1yu2A03', NULL, NULL, 179, NULL, NULL, 230975),
(242938, '4w4kB00', NULL, NULL, 174, NULL, NULL, 230976),
(242939, '2jl6101', NULL, NULL, 45, NULL, NULL, 230977),
(242940, '3kdrA03', NULL, NULL, 50, NULL, NULL, 230978),
(242941, '1tvsA00', NULL, NULL, 75, NULL, NULL, 230979),
(242942, '3g0tA02', NULL, NULL, 70, NULL, NULL, 230980),
(242943, '3euhD01', NULL, NULL, 78, NULL, NULL, 230981),
(242944, '3eukL01', NULL, NULL, 81, NULL, NULL, 230981),
(242945, '4ef8A02', NULL, NULL, 44, NULL, NULL, 230982),
(242946, '2e6fA02', NULL, NULL, 44, NULL, NULL, 230982),
(242947, '5xfwA02', NULL, NULL, 44, NULL, NULL, 230982),
(242948, '1jubA02', NULL, NULL, 44, NULL, NULL, 230982),
(242949, '4wzhA02', NULL, NULL, 44, NULL, NULL, 230982),
(242950, '3oixA02', NULL, NULL, 42, NULL, NULL, 230982),
(242951, '1wd5A02', NULL, NULL, 61, NULL, NULL, 230983),
(242952, '1ryiA02', NULL, NULL, 140, NULL, NULL, 230984),
(242953, '2qcuA02', NULL, NULL, 161, NULL, NULL, 230984),
(242954, '1pj5A02', NULL, NULL, 178, NULL, NULL, 230984),
(242955, '2gagB02', NULL, NULL, 154, NULL, NULL, 230984);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(242956, '3dmeA02', NULL, NULL, 153, NULL, NULL, 230984),
(242957, '1y56B02', NULL, NULL, 151, NULL, NULL, 230984),
(242958, '6dllA02', NULL, NULL, 149, NULL, NULL, 230984),
(242959, '3ps9A03', NULL, NULL, 150, NULL, NULL, 230984),
(242960, '3da1A02', NULL, NULL, 158, NULL, NULL, 230984),
(242961, '3pvcA03', NULL, NULL, 150, NULL, NULL, 230984),
(242962, '1pn0A02', NULL, NULL, 187, NULL, NULL, 230984),
(242963, '3nycA02', NULL, NULL, 150, NULL, NULL, 230984),
(242964, '2rghA02', NULL, NULL, 163, NULL, NULL, 230984),
(242965, '6iweA02', NULL, NULL, 210, NULL, NULL, 230984),
(242966, '3wgtA02', NULL, NULL, 141, NULL, NULL, 230984),
(242967, '4k22A02', NULL, NULL, 108, NULL, NULL, 230984),
(242968, '3djdB02', NULL, NULL, 206, NULL, NULL, 230984),
(242969, '6a6sA02', NULL, NULL, 210, NULL, NULL, 230984),
(242970, '1zovA02', NULL, NULL, 195, NULL, NULL, 230984),
(242971, '5l46A02', NULL, NULL, 170, NULL, NULL, 230984),
(242972, '4pabA02', NULL, NULL, 170, NULL, NULL, 230984),
(242973, '2olnA02', NULL, NULL, 166, NULL, NULL, 230984),
(242974, '2r0cA02', NULL, NULL, 138, NULL, NULL, 230984),
(242975, '1x31B02', NULL, NULL, 154, NULL, NULL, 230984),
(242976, '2dkhA02', NULL, NULL, 125, NULL, NULL, 230984),
(242977, '3c4nA02', NULL, NULL, 125, NULL, NULL, 230984),
(242978, '3axbA02', NULL, NULL, 179, NULL, NULL, 230984),
(242979, '1c0pA02', NULL, NULL, 163, NULL, NULL, 230984),
(242980, '5xaoA02', NULL, NULL, 219, NULL, NULL, 230984),
(242981, '4yshA02', NULL, NULL, 146, NULL, NULL, 230984),
(242982, '1k0iA02', NULL, NULL, 148, NULL, NULL, 230984),
(242983, '2uzzA02', NULL, NULL, 191, NULL, NULL, 230984),
(242984, '2gf3A02', NULL, NULL, 195, NULL, NULL, 230984),
(242985, '3aljA02', NULL, NULL, 152, NULL, NULL, 230984),
(242986, '4wctA02', NULL, NULL, 208, NULL, NULL, 230984),
(242987, '3znnA02', NULL, NULL, 141, NULL, NULL, 230984),
(242988, '4x9mA02', NULL, NULL, 159, NULL, NULL, 230984),
(242989, '3oz2A02', NULL, NULL, 160, NULL, NULL, 230984),
(242990, '2x3nA02', NULL, NULL, 145, NULL, NULL, 230984),
(242991, '3ihgA02', NULL, NULL, 145, NULL, NULL, 230984),
(242992, '4d0gC00', NULL, NULL, 69, NULL, NULL, 230985),
(242993, '3tsoC00', NULL, NULL, 75, NULL, NULL, 230985),
(242994, '2d7cC00', NULL, NULL, 42, NULL, NULL, 230985),
(242995, '2hv8D00', NULL, NULL, 64, NULL, NULL, 230985),
(242996, '2k6sA00', NULL, NULL, 41, NULL, NULL, 230985),
(242997, '2v3aA03', NULL, NULL, 64, NULL, NULL, 230986),
(242998, '2wlbB00', NULL, NULL, 103, NULL, NULL, 230987),
(242999, '1v8cA01', NULL, NULL, 85, NULL, NULL, 230987),
(243000, '1wgkA01', NULL, NULL, 96, NULL, NULL, 230987),
(243001, '1rm6C01', NULL, NULL, 78, NULL, NULL, 230987),
(243002, '2wdqB01', NULL, NULL, 106, NULL, NULL, 230987),
(243003, '5ldaB00', NULL, NULL, 69, NULL, NULL, 230987),
(243004, '1ffvA01', NULL, NULL, 76, NULL, NULL, 230987),
(243005, '1i7hC00', NULL, NULL, 111, NULL, NULL, 230987),
(243006, '4itkA00', NULL, NULL, 105, NULL, NULL, 230987),
(243007, '4zhpA00', NULL, NULL, 106, NULL, NULL, 230987),
(243008, '1czpA00', NULL, NULL, 98, NULL, NULL, 230987),
(243009, '1frrA00', NULL, NULL, 95, NULL, NULL, 230987),
(243010, '2mjdA00', NULL, NULL, 115, NULL, NULL, 230987),
(243011, '3zyyX01', NULL, NULL, 95, NULL, NULL, 230987),
(243012, '4wwmA00', NULL, NULL, 91, NULL, NULL, 230987),
(243013, '2jx5A00', NULL, NULL, 69, NULL, NULL, 230987),
(243014, '2dbyA02', NULL, NULL, 107, NULL, NULL, 230987),
(243015, '2piaA03', NULL, NULL, 96, NULL, NULL, 230987),
(243016, '2n0sB00', NULL, NULL, 94, NULL, NULL, 230987),
(243017, '1t3qA01', NULL, NULL, 87, NULL, NULL, 230987),
(243018, '4idiB00', NULL, NULL, 124, NULL, NULL, 230987),
(243019, '3rpfC00', NULL, NULL, 74, NULL, NULL, 230987),
(243020, '1rfkA00', NULL, NULL, 98, NULL, NULL, 230987),
(243021, '3ah7A00', NULL, NULL, 113, NULL, NULL, 230987),
(243022, '3b2gA00', NULL, NULL, 98, NULL, NULL, 230987),
(243023, '1wxqA03', NULL, NULL, 79, NULL, NULL, 230987),
(243024, '2ekiA00', NULL, NULL, 93, NULL, NULL, 230987),
(243025, '4zohC01', NULL, NULL, 84, NULL, NULL, 230987),
(243026, '1ni3A02', NULL, NULL, 104, NULL, NULL, 230987);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(243027, '3wcqA00', NULL, NULL, 97, NULL, NULL, 230987),
(243028, '4usaA01', NULL, NULL, 74, NULL, NULL, 230987),
(243029, '5ee0A02', NULL, NULL, 109, NULL, NULL, 230987),
(243030, '1jalA02', NULL, NULL, 103, NULL, NULL, 230987),
(243031, '1zoyB01', NULL, NULL, 114, NULL, NULL, 230987),
(243032, '2g1eA00', NULL, NULL, 90, NULL, NULL, 230987),
(243033, '3hvzA00', NULL, NULL, 78, NULL, NULL, 230987),
(243034, '3kwlA01', NULL, NULL, 97, NULL, NULL, 230987),
(243035, '1kf6B01', NULL, NULL, 104, NULL, NULL, 230987),
(243036, '2kmmA00', NULL, NULL, 73, NULL, NULL, 230987),
(243037, '3p1mA00', NULL, NULL, 132, NULL, NULL, 230987),
(243038, '2bs2B01', NULL, NULL, 106, NULL, NULL, 230987),
(243039, '2l52A00', NULL, NULL, 99, NULL, NULL, 230987),
(243040, '4ysxB01', NULL, NULL, 106, NULL, NULL, 230987),
(243041, '2mj3A00', NULL, NULL, 116, NULL, NULL, 230987),
(243042, '3an1A01', NULL, NULL, 94, NULL, NULL, 230987),
(243043, '4n6eB00', NULL, NULL, 90, NULL, NULL, 230987),
(243044, '4hrsA00', NULL, NULL, 67, NULL, NULL, 230987),
(243045, '1wriA00', NULL, NULL, 93, NULL, NULL, 230987),
(243046, '1dgjA01', NULL, NULL, 74, NULL, NULL, 230987),
(243047, '1n62A01', NULL, NULL, 79, NULL, NULL, 230987),
(243048, '4fxcA00', NULL, NULL, 98, NULL, NULL, 230987),
(243049, '2lekA00', NULL, NULL, 73, NULL, NULL, 230987),
(243050, '1nyrB01', NULL, NULL, 65, NULL, NULL, 230987),
(243051, '5auiA00', NULL, NULL, 97, NULL, NULL, 230987),
(243052, '4zhoA00', NULL, NULL, 105, NULL, NULL, 230987),
(243053, '1doiA00', NULL, NULL, 128, NULL, NULL, 230987),
(243054, '4n58A01', NULL, NULL, 93, NULL, NULL, 230987),
(243055, '2bt6B00', NULL, NULL, 108, NULL, NULL, 230987),
(243056, '1pfdA00', NULL, NULL, 96, NULL, NULL, 230987),
(243057, '4ltuA00', NULL, NULL, 107, NULL, NULL, 230987),
(243058, '2k9xA00', NULL, NULL, 110, NULL, NULL, 230987),
(243059, '5mpoB00', NULL, NULL, 84, NULL, NULL, 230987),
(243060, '4hroB00', NULL, NULL, 90, NULL, NULL, 230987),
(243061, '3n9yC00', NULL, NULL, 68, NULL, NULL, 230987),
(243062, '3av8A00', NULL, NULL, 97, NULL, NULL, 230987),
(243063, '5aukA00', NULL, NULL, 96, NULL, NULL, 230987),
(243064, '1a70A00', NULL, NULL, 97, NULL, NULL, 230987),
(243065, '3huiA00', NULL, NULL, 126, NULL, NULL, 230987),
(243066, '3zyvA01', NULL, NULL, 94, NULL, NULL, 230987),
(243067, '2h88B01', NULL, NULL, 114, NULL, NULL, 230987),
(243068, '5y6qA01', NULL, NULL, 80, NULL, NULL, 230987),
(243069, '3hrdD01', NULL, NULL, 79, NULL, NULL, 230987),
(243070, '1awdA00', NULL, NULL, 94, NULL, NULL, 230987),
(243071, '4p6vF01', NULL, NULL, 95, NULL, NULL, 230987),
(243072, '2ohfA02', NULL, NULL, 110, NULL, NULL, 230987),
(243073, '1zud400', NULL, NULL, 66, NULL, NULL, 230987),
(243074, '2cu3B00', NULL, NULL, 64, NULL, NULL, 230987),
(243075, '5xmjB01', NULL, NULL, 105, NULL, NULL, 230987),
(243076, '2e1qC01', NULL, NULL, 94, NULL, NULL, 230987),
(243077, '1xlqA00', NULL, NULL, 106, NULL, NULL, 230987),
(243078, '3lxfA00', NULL, NULL, 104, NULL, NULL, 230987),
(243079, '1tygB00', NULL, NULL, 66, NULL, NULL, 230987),
(243080, '3nvwA01', NULL, NULL, 85, NULL, NULL, 230987),
(243081, '1vjkA00', NULL, NULL, 98, NULL, NULL, 230987),
(243082, '1l5pA00', NULL, NULL, 93, NULL, NULL, 230987),
(243083, '2qjlA00', NULL, NULL, 99, NULL, NULL, 230987),
(243084, '4a9aA03', NULL, NULL, 78, NULL, NULL, 230987),
(243085, '5ffiE00', NULL, NULL, 122, NULL, NULL, 230987),
(243086, '1wwtA01', NULL, NULL, 62, NULL, NULL, 230987),
(243087, '4wqmA01', NULL, NULL, 95, NULL, NULL, 230987),
(243088, '1jq4A00', NULL, NULL, 98, NULL, NULL, 230987),
(243089, '1iueA00', NULL, NULL, 98, NULL, NULL, 230987),
(243090, '2y5cA00', NULL, NULL, 109, NULL, NULL, 230987),
(243091, '1frdA00', NULL, NULL, 98, NULL, NULL, 230987),
(243092, '3cwiA00', NULL, NULL, 78, NULL, NULL, 230987),
(243093, '3b2fA00', NULL, NULL, 98, NULL, NULL, 230987),
(243094, '5g5gA01', NULL, NULL, 85, NULL, NULL, 230987),
(243095, '1e0zA00', NULL, NULL, 128, NULL, NULL, 230987),
(243096, '1krhA01', NULL, NULL, 104, NULL, NULL, 230987),
(243097, '2q5wD00', NULL, NULL, 77, NULL, NULL, 230987);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(243098, '1uwmA00', NULL, NULL, 106, NULL, NULL, 230987),
(243099, '2w3sA01', NULL, NULL, 80, NULL, NULL, 230987),
(243100, '1tkeA01', NULL, NULL, 64, NULL, NULL, 230987),
(243101, '1b9rA00', NULL, NULL, 105, NULL, NULL, 230987),
(243102, '1fm0D00', NULL, NULL, 81, NULL, NULL, 230987),
(243103, '1ryjA00', NULL, NULL, 70, NULL, NULL, 230987),
(243104, '2m19A00', NULL, NULL, 106, NULL, NULL, 230987),
(243105, '3dwgC00', NULL, NULL, 93, NULL, NULL, 230987),
(243106, '1r5sA01', NULL, NULL, 36, NULL, NULL, 230988),
(243107, '2g7zA02', NULL, NULL, 125, NULL, NULL, 230989),
(243108, '3lupA02', NULL, NULL, 128, NULL, NULL, 230989),
(243109, '2dt8A02', NULL, NULL, 130, NULL, NULL, 230989),
(243110, '3nyiA02', NULL, NULL, 137, NULL, NULL, 230989),
(243111, '4x9xA02', NULL, NULL, 129, NULL, NULL, 230989),
(243112, '3fdjA03', NULL, NULL, 128, NULL, NULL, 230989),
(243113, '3jr7A03', NULL, NULL, 125, NULL, NULL, 230989),
(243114, '1pzxA03', NULL, NULL, 132, NULL, NULL, 230989),
(243115, '3pl5A03', NULL, NULL, 129, NULL, NULL, 230989),
(243116, '3fysA02', NULL, NULL, 129, NULL, NULL, 230989),
(243117, '6dj6A02', NULL, NULL, 126, NULL, NULL, 230989),
(243118, '1mgpA02', NULL, NULL, 134, NULL, NULL, 230989),
(243119, '2ve7C01', NULL, NULL, 172, NULL, NULL, 230990),
(243120, '3bvxA05', NULL, NULL, 96, NULL, NULL, 230991),
(243121, '1o7dE00', NULL, NULL, 126, NULL, NULL, 230991),
(243122, '4ku0D00', NULL, NULL, 96, NULL, NULL, 230992),
(243123, '4jiwD00', NULL, NULL, 93, NULL, NULL, 230992),
(243124, '4jivD00', NULL, NULL, 93, NULL, NULL, 230992),
(243125, '2ymbA00', NULL, NULL, 161, NULL, NULL, 230993),
(243126, '4a5zB00', NULL, NULL, 163, NULL, NULL, 230993),
(243127, '1vwxg02', NULL, NULL, 79, NULL, NULL, 230994),
(243128, '3u5eg02', NULL, NULL, 83, NULL, NULL, 230994),
(243129, '4a18L02', NULL, NULL, 85, NULL, NULL, 230994),
(243130, '1vx7a02', NULL, NULL, 69, NULL, NULL, 230994),
(243131, '2yf2E00', NULL, NULL, 65, NULL, NULL, 230995),
(243132, '4b0fB00', NULL, NULL, 65, NULL, NULL, 230995),
(243133, '4i8oA01', NULL, NULL, 93, NULL, NULL, 230996),
(243134, '1s9rA01', NULL, NULL, 319, NULL, NULL, 230997),
(243135, '6b10B00', NULL, NULL, 333, NULL, NULL, 230997),
(243136, '2ewoA00', NULL, NULL, 377, NULL, NULL, 230997),
(243137, '5hp5A03', NULL, NULL, 372, NULL, NULL, 230997),
(243138, '3i4aA00', NULL, NULL, 278, NULL, NULL, 230997),
(243139, '1x72A00', NULL, NULL, 334, NULL, NULL, 230997),
(243140, '1g62A00', NULL, NULL, 224, NULL, NULL, 230997),
(243141, '5an9I00', NULL, NULL, 224, NULL, NULL, 230997),
(243142, '2ci1A00', NULL, NULL, 275, NULL, NULL, 230997),
(243143, '4e4jA01', NULL, NULL, 318, NULL, NULL, 230997),
(243144, '5wpiA00', NULL, NULL, 364, NULL, NULL, 230997),
(243145, '2dewX03', NULL, NULL, 370, NULL, NULL, 230997),
(243146, '4bofA01', NULL, NULL, 317, NULL, NULL, 230997),
(243147, '4n2kA03', NULL, NULL, 375, NULL, NULL, 230997),
(243148, '1xknA00', NULL, NULL, 355, NULL, NULL, 230997),
(243149, '2jerB00', NULL, NULL, 365, NULL, NULL, 230997),
(243150, '4a18J00', NULL, NULL, 228, NULL, NULL, 230997),
(243151, '4ytbA01', NULL, NULL, 316, NULL, NULL, 230997),
(243152, '1bwdA00', NULL, NULL, 348, NULL, NULL, 230997),
(243153, '5m3qA00', NULL, NULL, 225, NULL, NULL, 230997),
(243154, '6nibA00', NULL, NULL, 367, NULL, NULL, 230997),
(243155, '2aafB01', NULL, NULL, 333, NULL, NULL, 230997),
(243156, '6ce1A03', NULL, NULL, 371, NULL, NULL, 230997),
(243157, '3hvmA00', NULL, NULL, 330, NULL, NULL, 230997),
(243158, '1zbrA00', NULL, NULL, 349, NULL, NULL, 230997),
(243159, '1g61A00', NULL, NULL, 228, NULL, NULL, 230997),
(243160, '1h70A00', NULL, NULL, 255, NULL, NULL, 230997),
(243161, '1vkpB00', NULL, NULL, 383, NULL, NULL, 230997),
(243162, '1jdwA00', NULL, NULL, 360, NULL, NULL, 230997),
(243163, '2v0xA01', NULL, NULL, 179, NULL, NULL, 230998),
(243164, '2x9qB00', NULL, NULL, 241, NULL, NULL, 230999),
(243165, '6ez3C00', NULL, NULL, 234, NULL, NULL, 230999),
(243166, '3oqvA00', NULL, NULL, 220, NULL, NULL, 230999),
(243167, '3oqiB00', NULL, NULL, 234, NULL, NULL, 230999),
(243168, '1x9bA00', NULL, NULL, 53, NULL, NULL, 231000);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(243169, '3b5mC02', NULL, NULL, 85, NULL, NULL, 231000),
(243170, '2imlA02', NULL, NULL, 76, NULL, NULL, 231000),
(243171, '2ptfB02', NULL, NULL, 68, NULL, NULL, 231000),
(243172, '2nr4A02', NULL, NULL, 60, NULL, NULL, 231000),
(243173, '4phzB00', NULL, NULL, 252, NULL, NULL, 231001),
(243174, '1yewB00', NULL, NULL, 247, NULL, NULL, 231001),
(243175, '3chxB00', NULL, NULL, 252, NULL, NULL, 231001),
(243176, '6cxhB00', NULL, NULL, 247, NULL, NULL, 231001),
(243177, '1wwpA00', NULL, NULL, 119, NULL, NULL, 231002),
(243178, '1o3uA00', NULL, NULL, 135, NULL, NULL, 231002),
(243179, '1k04A02', NULL, NULL, 107, NULL, NULL, 231002),
(243180, '1qvxA00', NULL, NULL, 134, NULL, NULL, 231002),
(243181, '1v4aA03', NULL, NULL, 156, NULL, NULL, 231002),
(243182, '2pbeA02', NULL, NULL, 136, NULL, NULL, 231002),
(243183, '1wtyA00', NULL, NULL, 119, NULL, NULL, 231002),
(243184, '2kk1A01', NULL, NULL, 103, NULL, NULL, 231002),
(243185, '3brjC00', NULL, NULL, 175, NULL, NULL, 231002),
(243186, '1jogD00', NULL, NULL, 146, NULL, NULL, 231002),
(243187, '2hktC00', NULL, NULL, 172, NULL, NULL, 231002),
(243188, '1jogC00', NULL, NULL, 146, NULL, NULL, 231002),
(243189, '3mfnB00', NULL, NULL, 129, NULL, NULL, 231002),
(243190, '1jogB00', NULL, NULL, 146, NULL, NULL, 231002),
(243191, '1jogA00', NULL, NULL, 146, NULL, NULL, 231002),
(243192, '1knyA02', NULL, NULL, 128, NULL, NULL, 231002),
(243193, '3k7dA03', NULL, NULL, 135, NULL, NULL, 231002),
(243194, '4ebjA02', NULL, NULL, 130, NULL, NULL, 231002),
(243195, '3jz0A02', NULL, NULL, 130, NULL, NULL, 231002),
(243196, '3u0cA00', NULL, NULL, 153, NULL, NULL, 231002),
(243197, '2l6gA00', NULL, NULL, 176, NULL, NULL, 231002),
(243198, '4xekA00', NULL, NULL, 139, NULL, NULL, 231002),
(243199, '1ufbA00', NULL, NULL, 127, NULL, NULL, 231002),
(243200, '2q00B00', NULL, NULL, 129, NULL, NULL, 231002),
(243201, '6iuhA00', NULL, NULL, 132, NULL, NULL, 231002),
(243202, '1zzpA00', NULL, NULL, 109, NULL, NULL, 231002),
(243203, '2hsbA00', NULL, NULL, 126, NULL, NULL, 231002),
(243204, '1ktmA02', NULL, NULL, 104, NULL, NULL, 231002),
(243205, '1wolA00', NULL, NULL, 122, NULL, NULL, 231002),
(243206, '3c8gA00', NULL, NULL, 172, NULL, NULL, 231002),
(243207, '1k40A00', NULL, NULL, 126, NULL, NULL, 231002),
(243208, '3c8gB00', NULL, NULL, 172, NULL, NULL, 231002),
(243209, '4nqfA00', NULL, NULL, 158, NULL, NULL, 231002),
(243210, '3c8gC00', NULL, NULL, 172, NULL, NULL, 231002),
(243211, '3c18A02', NULL, NULL, 118, NULL, NULL, 231002),
(243212, '3c8gD00', NULL, NULL, 172, NULL, NULL, 231002),
(243213, '3o10C00', NULL, NULL, 141, NULL, NULL, 231002),
(243214, '2l6hA00', NULL, NULL, 180, NULL, NULL, 231002),
(243215, '3tulC00', NULL, NULL, 158, NULL, NULL, 231002),
(243216, '3gm3A00', NULL, NULL, 153, NULL, NULL, 231002),
(243217, '3ajmB02', NULL, NULL, 152, NULL, NULL, 231002),
(243218, '2yicD03', NULL, NULL, 254, NULL, NULL, 231003),
(243219, '2xt6B03', NULL, NULL, 259, NULL, NULL, 231003),
(243220, '2jgdA03', NULL, NULL, 243, NULL, NULL, 231003),
(243221, '1w36D01', NULL, NULL, 110, NULL, NULL, 231004),
(243222, '4n2pA00', NULL, NULL, 143, NULL, NULL, 231005),
(243223, '1jw3A00', NULL, NULL, 140, NULL, NULL, 231005),
(243224, '1j5uA01', NULL, NULL, 117, NULL, NULL, 231005),
(243225, '2lboA00', NULL, NULL, 123, NULL, NULL, 231006),
(243226, '2jh1A02', NULL, NULL, 112, NULL, NULL, 231006),
(243227, '2jh1A01', NULL, NULL, 108, NULL, NULL, 231006),
(243228, '3ue9C01', NULL, NULL, 180, NULL, NULL, 231007),
(243229, '5i34A01', NULL, NULL, 170, NULL, NULL, 231007),
(243230, '2v40A01', NULL, NULL, 169, NULL, NULL, 231007),
(243231, '1dj2A01', NULL, NULL, 166, NULL, NULL, 231007),
(243232, '3r7tA01', NULL, NULL, 165, NULL, NULL, 231007),
(243233, '1dj3A01', NULL, NULL, 166, NULL, NULL, 231007),
(243234, '1adeA01', NULL, NULL, 165, NULL, NULL, 231007),
(243235, '1iweA01', NULL, NULL, 167, NULL, NULL, 231007),
(243236, '3hidA01', NULL, NULL, 166, NULL, NULL, 231007),
(243237, '4m9dB01', NULL, NULL, 167, NULL, NULL, 231007),
(243238, '1p9bA01', NULL, NULL, 175, NULL, NULL, 231007),
(243239, '3crvA02', NULL, NULL, 108, NULL, NULL, 231008);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(243240, '2vl7A02', NULL, NULL, 110, NULL, NULL, 231008),
(243241, '4fmhO00', NULL, NULL, 289, NULL, NULL, 231009),
(243242, '4pcgB00', NULL, NULL, 276, NULL, NULL, 231009),
(243243, '4pchB00', NULL, NULL, 273, NULL, NULL, 231009),
(243244, '1sidF00', NULL, NULL, 366, NULL, NULL, 231009),
(243245, '3bwrA00', NULL, NULL, 272, NULL, NULL, 231009),
(243246, '4u60C00', NULL, NULL, 280, NULL, NULL, 231009),
(243247, '5cpuB00', NULL, NULL, 284, NULL, NULL, 231009),
(243248, '4mj0D00', NULL, NULL, 275, NULL, NULL, 231009),
(243249, '4mbyH00', NULL, NULL, 278, NULL, NULL, 231009),
(243250, '3s7xA00', NULL, NULL, 267, NULL, NULL, 231009),
(243251, '3s7vC00', NULL, NULL, 277, NULL, NULL, 231009),
(243252, '6esb400', NULL, NULL, 318, NULL, NULL, 231009),
(243253, '1sva400', NULL, NULL, 343, NULL, NULL, 231009),
(243254, '4x0yE00', NULL, NULL, 272, NULL, NULL, 231009),
(243255, '4poqJ00', NULL, NULL, 278, NULL, NULL, 231009),
(243256, '2q82A00', NULL, NULL, 129, NULL, NULL, 231010),
(243257, '4egdA00', NULL, NULL, 234, NULL, NULL, 231011),
(243258, '3c12A02', NULL, NULL, 87, NULL, NULL, 231012),
(243259, '3osvA02', NULL, NULL, 87, NULL, NULL, 231012),
(243260, '4zzfA02', NULL, NULL, 96, NULL, NULL, 231012),
(243261, '3e56A00', NULL, NULL, 81, NULL, NULL, 231013),
(243262, '2quyF00', NULL, NULL, 335, NULL, NULL, 231014),
(243263, '5j9rA00', NULL, NULL, 326, NULL, NULL, 231014),
(243264, '5hkeA01', NULL, NULL, 314, NULL, NULL, 231014),
(243265, '2bjfA01', NULL, NULL, 319, NULL, NULL, 231014),
(243266, '3gvzA00', NULL, NULL, 274, NULL, NULL, 231014),
(243267, '2hf0A00', NULL, NULL, 316, NULL, NULL, 231014),
(243268, '3hbcA00', NULL, NULL, 320, NULL, NULL, 231014),
(243269, '2oqcA00', NULL, NULL, 327, NULL, NULL, 231014),
(243270, '4wl2A00', NULL, NULL, 355, NULL, NULL, 231014),
(243271, '5gs7A01', NULL, NULL, 313, NULL, NULL, 231014),
(243272, '2x1dA01', NULL, NULL, 283, NULL, NULL, 231014),
(243273, '1fd9A02', NULL, NULL, 106, NULL, NULL, 231015),
(243274, '1q6hA01', NULL, NULL, 121, NULL, NULL, 231015),
(243275, '3dt5A00', NULL, NULL, 135, NULL, NULL, 231016),
(243276, '3woeB00', NULL, NULL, 106, NULL, NULL, 231017),
(243277, '3wodG00', NULL, NULL, 141, NULL, NULL, 231017),
(243278, '2v7qJ00', NULL, NULL, 50, NULL, NULL, 231018),
(243279, '1gmjD00', NULL, NULL, 62, NULL, NULL, 231018),
(243280, '1hf9A00', NULL, NULL, 41, NULL, NULL, 231018),
(243281, '3kltB00', NULL, NULL, 72, NULL, NULL, 231018),
(243282, '4tsfI00', NULL, NULL, 66, NULL, NULL, 231018),
(243283, '3p42A02', NULL, NULL, 70, NULL, NULL, 231019),
(243284, '6e6qA00', NULL, NULL, 56, NULL, NULL, 231020),
(243285, '2hu9A02', NULL, NULL, 69, NULL, NULL, 231020),
(243286, '1y56A04', NULL, NULL, 77, NULL, NULL, 231020),
(243287, '2h7bA01', NULL, NULL, 96, NULL, NULL, 231021),
(243288, '2pp4A00', NULL, NULL, 107, NULL, NULL, 231021),
(243289, '2p6vA00', NULL, NULL, 114, NULL, NULL, 231021),
(243290, '1kvdA00', NULL, NULL, 63, NULL, NULL, 231022),
(243291, '1ka5A00', NULL, NULL, 88, NULL, NULL, 231023),
(243292, '1sphA00', NULL, NULL, 88, NULL, NULL, 231023),
(243293, '1pchA00', NULL, NULL, 88, NULL, NULL, 231023),
(243294, '2nzuL00', NULL, NULL, 88, NULL, NULL, 231023),
(243295, '1y51A00', NULL, NULL, 88, NULL, NULL, 231023),
(243296, '1ptfA00', NULL, NULL, 88, NULL, NULL, 231023),
(243297, '3le1B00', NULL, NULL, 88, NULL, NULL, 231023),
(243298, '5t17A00', NULL, NULL, 85, NULL, NULL, 231023),
(243299, '1zvvJ00', NULL, NULL, 85, NULL, NULL, 231023),
(243300, '3ihsA00', NULL, NULL, 85, NULL, NULL, 231023),
(243301, '1qr5A00', NULL, NULL, 88, NULL, NULL, 231023),
(243302, '1mu4A00', NULL, NULL, 87, NULL, NULL, 231023),
(243303, '3ccdA00', NULL, NULL, 85, NULL, NULL, 231023),
(243304, '2dlvA01', NULL, NULL, 51, NULL, NULL, 231024),
(243305, '2ihdA01', NULL, NULL, 48, NULL, NULL, 231024),
(243306, '2d9jA01', NULL, NULL, 54, NULL, NULL, 231024),
(243307, '2jm5A01', NULL, NULL, 49, NULL, NULL, 231024),
(243308, '2bv1B01', NULL, NULL, 60, NULL, NULL, 231024),
(243309, '2v4zB01', NULL, NULL, 62, NULL, NULL, 231024),
(243310, '2crpA01', NULL, NULL, 54, NULL, NULL, 231024);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(243311, '2odeB01', NULL, NULL, 61, NULL, NULL, 231024),
(243312, '2oj4A01', NULL, NULL, 47, NULL, NULL, 231024),
(243313, '1dk8A01', NULL, NULL, 48, NULL, NULL, 231024),
(243314, '2odeD01', NULL, NULL, 45, NULL, NULL, 231024),
(243315, '3c7lB01', NULL, NULL, 47, NULL, NULL, 231024),
(243316, '2af0A01', NULL, NULL, 51, NULL, NULL, 231024),
(243317, '1agrH01', NULL, NULL, 36, NULL, NULL, 231024),
(243318, '2ebzA01', NULL, NULL, 68, NULL, NULL, 231024),
(243319, '2ihbB01', NULL, NULL, 50, NULL, NULL, 231024),
(243320, '2bt2C01', NULL, NULL, 56, NULL, NULL, 231024),
(243321, '1cmzA01', NULL, NULL, 58, NULL, NULL, 231024),
(243322, '1agrE01', NULL, NULL, 47, NULL, NULL, 231024),
(243323, '1fqiA01', NULL, NULL, 48, NULL, NULL, 231024),
(243324, '2jnuA01', NULL, NULL, 49, NULL, NULL, 231024),
(243325, '2fm9A00', NULL, NULL, 215, NULL, NULL, 231025),
(243326, '2ntkB00', NULL, NULL, 202, NULL, NULL, 231026),
(243327, '3f42A00', NULL, NULL, 99, NULL, NULL, 231027),
(243328, '3f42B00', NULL, NULL, 99, NULL, NULL, 231027),
(243329, '1pugB00', NULL, NULL, 74, NULL, NULL, 231027),
(243330, '1pugC00', NULL, NULL, 109, NULL, NULL, 231027),
(243331, '5yrxA00', NULL, NULL, 71, NULL, NULL, 231027),
(243332, '1ybxA00', NULL, NULL, 101, NULL, NULL, 231027),
(243333, '1j8bA00', NULL, NULL, 112, NULL, NULL, 231027),
(243334, '5bnzA05', NULL, NULL, 117, NULL, NULL, 231028),
(243335, '5bnzA04', NULL, NULL, 94, NULL, NULL, 231028),
(243336, '1dfuP00', NULL, NULL, 94, NULL, NULL, 231028),
(243337, '4wfaS01', NULL, NULL, 94, NULL, NULL, 231028),
(243338, '4p2bA04', NULL, NULL, 102, NULL, NULL, 231028),
(243339, '3aiiA03', NULL, NULL, 89, NULL, NULL, 231028),
(243340, '4p2bA05', NULL, NULL, 119, NULL, NULL, 231028),
(243341, '4h3sA03', NULL, NULL, 120, NULL, NULL, 231028),
(243342, '4h3sA02', NULL, NULL, 127, NULL, NULL, 231028),
(243343, '2hz7A04', NULL, NULL, 125, NULL, NULL, 231028),
(243344, '2hz7A05', NULL, NULL, 128, NULL, NULL, 231028),
(243345, '5dm6S01', NULL, NULL, 86, NULL, NULL, 231028),
(243346, '1feuA01', NULL, NULL, 91, NULL, NULL, 231028),
(243347, '5iznA00', NULL, NULL, 95, NULL, NULL, 231028),
(243348, '1qtqA02', NULL, NULL, 90, NULL, NULL, 231028),
(243349, '1qtqA01', NULL, NULL, 118, NULL, NULL, 231028),
(243350, '3cwxA00', NULL, NULL, 130, NULL, NULL, 231029),
(243351, '2om6A02', NULL, NULL, 79, NULL, NULL, 231030),
(243352, '1yr1A00', NULL, NULL, 119, NULL, NULL, 231031),
(243353, '1iq0A03', NULL, NULL, 116, NULL, NULL, 231032),
(243354, '2x1lA03', NULL, NULL, 175, NULL, NULL, 231032),
(243355, '3fnrA01', NULL, NULL, 157, NULL, NULL, 231032),
(243356, '3kflA03', NULL, NULL, 186, NULL, NULL, 231032),
(243357, '3ziuA01', NULL, NULL, 251, NULL, NULL, 231032),
(243358, '1qu3A04', NULL, NULL, 150, NULL, NULL, 231032),
(243359, '2zueA03', NULL, NULL, 119, NULL, NULL, 231032),
(243360, '2v0cA04', NULL, NULL, 159, NULL, NULL, 231032),
(243361, '4py2A03', NULL, NULL, 176, NULL, NULL, 231032),
(243362, '1f7uA02', NULL, NULL, 125, NULL, NULL, 231032),
(243363, '1ileA03', NULL, NULL, 191, NULL, NULL, 231032),
(243364, '1rqgA04', NULL, NULL, 151, NULL, NULL, 231032),
(243365, '2d5bA03', NULL, NULL, 164, NULL, NULL, 231032),
(243366, '5urbA03', NULL, NULL, 139, NULL, NULL, 231032),
(243367, '1wkbA03', NULL, NULL, 121, NULL, NULL, 231032),
(243368, '1gaxA02', NULL, NULL, 227, NULL, NULL, 231032),
(243369, '5xgqA03', NULL, NULL, 189, NULL, NULL, 231032),
(243370, '4qreA03', NULL, NULL, 173, NULL, NULL, 231032),
(243371, '3ziuB01', NULL, NULL, 189, NULL, NULL, 231032),
(243372, '4mw0B03', NULL, NULL, 180, NULL, NULL, 231032),
(243373, '3zgzA04', NULL, NULL, 177, NULL, NULL, 231032),
(243374, '3h99A03', NULL, NULL, 138, NULL, NULL, 231032),
(243375, '2csxA03', NULL, NULL, 163, NULL, NULL, 231032),
(243376, '1wveC00', NULL, NULL, 80, NULL, NULL, 231033),
(243377, '5n1tB00', NULL, NULL, 75, NULL, NULL, 231033),
(243378, '1mz4A00', NULL, NULL, 137, NULL, NULL, 231033),
(243379, '3hq9A01', NULL, NULL, 155, NULL, NULL, 231033),
(243380, '1dw0A00', NULL, NULL, 112, NULL, NULL, 231033),
(243381, '1eb7A01', NULL, NULL, 154, NULL, NULL, 231033);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(243382, '1ql3A00', NULL, NULL, 99, NULL, NULL, 231033),
(243383, '1gdvA00', NULL, NULL, 85, NULL, NULL, 231033),
(243384, '4o1wA00', NULL, NULL, 79, NULL, NULL, 231033),
(243385, '4wqdA01', NULL, NULL, 136, NULL, NULL, 231033),
(243386, '4gydA00', NULL, NULL, 86, NULL, NULL, 231033),
(243387, '4xxlA00', NULL, NULL, 98, NULL, NULL, 231033),
(243388, '4q5pA00', NULL, NULL, 106, NULL, NULL, 231033),
(243389, '5c0zA00', NULL, NULL, 105, NULL, NULL, 231033),
(243390, '2zxyA00', NULL, NULL, 87, NULL, NULL, 231033),
(243391, '1h32A02', NULL, NULL, 88, NULL, NULL, 231033),
(243392, '4n0kA00', NULL, NULL, 108, NULL, NULL, 231033),
(243393, '1h32A01', NULL, NULL, 169, NULL, NULL, 231033),
(243394, '2c8sA00', NULL, NULL, 149, NULL, NULL, 231033),
(243395, '3tguD01', NULL, NULL, 196, NULL, NULL, 231033),
(243396, '3oa8A02', NULL, NULL, 100, NULL, NULL, 231033),
(243397, '5aurA00', NULL, NULL, 83, NULL, NULL, 231033),
(243398, '1ctjA00', NULL, NULL, 89, NULL, NULL, 231033),
(243399, '2qjyB01', NULL, NULL, 221, NULL, NULL, 231033),
(243400, '1c52A00', NULL, NULL, 131, NULL, NULL, 231033),
(243401, '5xteH01', NULL, NULL, 196, NULL, NULL, 231033),
(243402, '1raqA00', NULL, NULL, 108, NULL, NULL, 231033),
(243403, '3oa8A01', NULL, NULL, 130, NULL, NULL, 231033),
(243404, '2c1dA01', NULL, NULL, 175, NULL, NULL, 231033),
(243405, '2c1dA02', NULL, NULL, 89, NULL, NULL, 231033),
(243406, '1kb0A02', NULL, NULL, 97, NULL, NULL, 231033),
(243407, '1f1cA00', NULL, NULL, 129, NULL, NULL, 231033),
(243408, '3m97X00', NULL, NULL, 140, NULL, NULL, 231033),
(243409, '2aiuA00', NULL, NULL, 105, NULL, NULL, 231033),
(243410, '1nirA01', NULL, NULL, 116, NULL, NULL, 231033),
(243411, '1nmlA01', NULL, NULL, 154, NULL, NULL, 231033),
(243412, '4eieA00', NULL, NULL, 87, NULL, NULL, 231033),
(243413, '1zrtD01', NULL, NULL, 219, NULL, NULL, 231033),
(243414, '3dmiA00', NULL, NULL, 88, NULL, NULL, 231033),
(243415, '2xtsB01', NULL, NULL, 137, NULL, NULL, 231033),
(243416, '2b4zA00', NULL, NULL, 104, NULL, NULL, 231033),
(243417, '155cA00', NULL, NULL, 135, NULL, NULL, 231033),
(243418, '1cnoG00', NULL, NULL, 87, NULL, NULL, 231033),
(243419, '1f1fA00', NULL, NULL, 89, NULL, NULL, 231033),
(243420, '2gc4D00', NULL, NULL, 147, NULL, NULL, 231033),
(243421, '3cx5D01', NULL, NULL, 197, NULL, NULL, 231033),
(243422, '2l4dA00', NULL, NULL, 110, NULL, NULL, 231033),
(243423, '4kmgA00', NULL, NULL, 88, NULL, NULL, 231033),
(243424, '3mk7C03', NULL, NULL, 91, NULL, NULL, 231033),
(243425, '3wfdC00', NULL, NULL, 146, NULL, NULL, 231033),
(243426, '1c6rA00', NULL, NULL, 89, NULL, NULL, 231033),
(243427, '2d0wA00', NULL, NULL, 170, NULL, NULL, 231033),
(243428, '3vrdA02', NULL, NULL, 96, NULL, NULL, 231033),
(243429, '4pwaD00', NULL, NULL, 88, NULL, NULL, 231033),
(243430, '3vrdA01', NULL, NULL, 78, NULL, NULL, 231033),
(243431, '1h32B00', NULL, NULL, 138, NULL, NULL, 231033),
(243432, '1zzhA01', NULL, NULL, 156, NULL, NULL, 231033),
(243433, '1zzhA02', NULL, NULL, 172, NULL, NULL, 231033),
(243434, '3mk7B02', NULL, NULL, 163, NULL, NULL, 231033),
(243435, '1jdlA00', NULL, NULL, 121, NULL, NULL, 231033),
(243436, '2ce0A00', NULL, NULL, 105, NULL, NULL, 231033),
(243437, '5b6qA00', NULL, NULL, 76, NULL, NULL, 231033),
(243438, '1ls9A00', NULL, NULL, 91, NULL, NULL, 231033),
(243439, '4jcgA00', NULL, NULL, 81, NULL, NULL, 231033),
(243440, '4j20A00', NULL, NULL, 88, NULL, NULL, 231033),
(243441, '1c75A00', NULL, NULL, 71, NULL, NULL, 231033),
(243442, '3a9fA01', NULL, NULL, 68, NULL, NULL, 231033),
(243443, '2c1dB00', NULL, NULL, 137, NULL, NULL, 231033),
(243444, '4v2kA02', NULL, NULL, 117, NULL, NULL, 231033),
(243445, '2c1vA01', NULL, NULL, 161, NULL, NULL, 231033),
(243446, '2c1vA02', NULL, NULL, 177, NULL, NULL, 231033),
(243447, '1corA00', NULL, NULL, 82, NULL, NULL, 231033),
(243448, '4ljiB00', NULL, NULL, 141, NULL, NULL, 231033),
(243449, '3ziyA03', NULL, NULL, 136, NULL, NULL, 231033),
(243450, '1m70A02', NULL, NULL, 99, NULL, NULL, 231033),
(243451, '1h1oA02', NULL, NULL, 84, NULL, NULL, 231033),
(243452, '1h1oA01', NULL, NULL, 86, NULL, NULL, 231033);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(243453, '1m70A01', NULL, NULL, 91, NULL, NULL, 231033),
(243454, '2zzs100', NULL, NULL, 82, NULL, NULL, 231033),
(243455, '5dfsA00', NULL, NULL, 105, NULL, NULL, 231033),
(243456, '4eicA00', NULL, NULL, 93, NULL, NULL, 231033),
(243457, '3zooA00', NULL, NULL, 104, NULL, NULL, 231033),
(243458, '1ccrA00', NULL, NULL, 112, NULL, NULL, 231033),
(243459, '1fcdC02', NULL, NULL, 96, NULL, NULL, 231033),
(243460, '1fcdC01', NULL, NULL, 78, NULL, NULL, 231033),
(243461, '6fu3B02', NULL, NULL, 180, NULL, NULL, 231033),
(243462, '6fu3B01', NULL, NULL, 159, NULL, NULL, 231033),
(243463, '1yebA00', NULL, NULL, 108, NULL, NULL, 231033),
(243464, '1fhbA00', NULL, NULL, 108, NULL, NULL, 231033),
(243465, '1i8oA00', NULL, NULL, 114, NULL, NULL, 231033),
(243466, '1vydA00', NULL, NULL, 116, NULL, NULL, 231033),
(243467, '1qn2A00', NULL, NULL, 100, NULL, NULL, 231033),
(243468, '2bh4X00', NULL, NULL, 134, NULL, NULL, 231033),
(243469, '3cp5A00', NULL, NULL, 124, NULL, NULL, 231033),
(243470, '2yiuB01', NULL, NULL, 193, NULL, NULL, 231033),
(243471, '4nfgB00', NULL, NULL, 104, NULL, NULL, 231033),
(243472, '3mk7C02', NULL, NULL, 126, NULL, NULL, 231033),
(243473, '1cieA00', NULL, NULL, 108, NULL, NULL, 231033),
(243474, '1dvvA00', NULL, NULL, 82, NULL, NULL, 231033),
(243475, '1pp9D02', NULL, NULL, 196, NULL, NULL, 231033),
(243476, '1rz6A02', NULL, NULL, 172, NULL, NULL, 231033),
(243477, '1hroA00', NULL, NULL, 106, NULL, NULL, 231033),
(243478, '1gu2A00', NULL, NULL, 124, NULL, NULL, 231033),
(243479, '2zboA00', NULL, NULL, 86, NULL, NULL, 231033),
(243480, '4gedB00', NULL, NULL, 113, NULL, NULL, 231033),
(243481, '1w2lA00', NULL, NULL, 99, NULL, NULL, 231033),
(243482, '2zonG00', NULL, NULL, 87, NULL, NULL, 231033),
(243483, '1kx2A00', NULL, NULL, 81, NULL, NULL, 231033),
(243484, '2vhdA02', NULL, NULL, 169, NULL, NULL, 231033),
(243485, '1cotA00', NULL, NULL, 129, NULL, NULL, 231033),
(243486, '3o5cC01', NULL, NULL, 162, NULL, NULL, 231033),
(243487, '3o5cC02', NULL, NULL, 158, NULL, NULL, 231033),
(243488, '1e29A00', NULL, NULL, 135, NULL, NULL, 231033),
(243489, '3sjlA01', NULL, NULL, 170, NULL, NULL, 231033),
(243490, '3sjlA02', NULL, NULL, 203, NULL, NULL, 231033),
(243491, '1qksA01', NULL, NULL, 100, NULL, NULL, 231033),
(243492, '1kv9A02', NULL, NULL, 107, NULL, NULL, 231033),
(243493, '2blfB01', NULL, NULL, 63, NULL, NULL, 231033),
(243494, '3hq9B02', NULL, NULL, 169, NULL, NULL, 231033),
(243495, '1cchA00', NULL, NULL, 82, NULL, NULL, 231033),
(243496, '1ytcA00', NULL, NULL, 112, NULL, NULL, 231033),
(243497, '6cunA00', NULL, NULL, 123, NULL, NULL, 231033),
(243498, '2d0sA00', NULL, NULL, 79, NULL, NULL, 231033),
(243499, '3x39A00', NULL, NULL, 82, NULL, NULL, 231033),
(243500, '3c2cA00', NULL, NULL, 112, NULL, NULL, 231033),
(243501, '1co6A00', NULL, NULL, 107, NULL, NULL, 231033),
(243502, '2yk3A00', NULL, NULL, 114, NULL, NULL, 231033),
(243503, '3cu4A00', NULL, NULL, 85, NULL, NULL, 231033),
(243504, '1cyjA00', NULL, NULL, 90, NULL, NULL, 231033),
(243505, '1i54A00', NULL, NULL, 103, NULL, NULL, 231033),
(243506, '2zooA02', NULL, NULL, 123, NULL, NULL, 231033),
(243507, '1cxcA00', NULL, NULL, 124, NULL, NULL, 231033),
(243508, '3dp5A00', NULL, NULL, 99, NULL, NULL, 231033),
(243509, '1gksA00', NULL, NULL, 78, NULL, NULL, 231033),
(243510, '1cc5A00', NULL, NULL, 83, NULL, NULL, 231033),
(243511, '4xydB00', NULL, NULL, 150, NULL, NULL, 231033),
(243512, '1yiqA02', NULL, NULL, 111, NULL, NULL, 231033),
(243513, '3ph2B00', NULL, NULL, 86, NULL, NULL, 231033),
(243514, '3oa8B00', NULL, NULL, 180, NULL, NULL, 231033),
(243515, '1dvhA00', NULL, NULL, 79, NULL, NULL, 231033),
(243516, '4aanA01', NULL, NULL, 153, NULL, NULL, 231033),
(243517, '1iqcA01', NULL, NULL, 154, NULL, NULL, 231033),
(243518, '4aanA02', NULL, NULL, 170, NULL, NULL, 231033),
(243519, '1c6sA00', NULL, NULL, 87, NULL, NULL, 231033),
(243520, '1iqcA02', NULL, NULL, 154, NULL, NULL, 231033),
(243521, '3c2qA02', NULL, NULL, 242, NULL, NULL, 231034),
(243522, '1z6tA03', NULL, NULL, 81, NULL, NULL, 231035),
(243523, '3sfzA02', NULL, NULL, 91, NULL, NULL, 231035);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(243524, '2ffwA00', NULL, NULL, 78, NULL, NULL, 231036),
(243525, '1xrsA00', NULL, NULL, 516, NULL, NULL, 231037),
(243526, '3kp1A01', NULL, NULL, 413, NULL, NULL, 231037),
(243527, '2m13A00', NULL, NULL, 65, NULL, NULL, 231038),
(243528, '4dk1C01', NULL, NULL, 79, NULL, NULL, 231039),
(243529, '4kbxA01', NULL, NULL, 231, NULL, NULL, 231040),
(243530, '4qhpA05', NULL, NULL, 327, NULL, NULL, 231041),
(243531, '5dllA05', NULL, NULL, 318, NULL, NULL, 231041),
(243532, '3b34A05', NULL, NULL, 325, NULL, NULL, 231041),
(243533, '6ea2A05', NULL, NULL, 339, NULL, NULL, 231041),
(243534, '1r6eA00', NULL, NULL, 168, NULL, NULL, 231042),
(243535, '1gzsB00', NULL, NULL, 165, NULL, NULL, 231042),
(243536, '2jokA01', NULL, NULL, 177, NULL, NULL, 231042),
(243537, '2mkzA01', NULL, NULL, 121, NULL, NULL, 231043),
(243538, '3dzmB00', NULL, NULL, 214, NULL, NULL, 231044),
(243539, '2uvaG06', NULL, NULL, 119, NULL, NULL, 231045),
(243540, '2uv8G06', NULL, NULL, 117, NULL, NULL, 231045),
(243541, '2fknA01', NULL, NULL, 344, NULL, NULL, 231046),
(243542, '1x87A01', NULL, NULL, 333, NULL, NULL, 231046),
(243543, '1uwkB01', NULL, NULL, 349, NULL, NULL, 231046),
(243544, '2uvaG09', NULL, NULL, 116, NULL, NULL, 231047),
(243545, '2uv8G09', NULL, NULL, 115, NULL, NULL, 231047),
(243546, '3thxB02', NULL, NULL, 175, NULL, NULL, 231048),
(243547, '3thxA02', NULL, NULL, 173, NULL, NULL, 231048),
(243548, '1wb9A02', NULL, NULL, 136, NULL, NULL, 231048),
(243549, '1ewqA02', NULL, NULL, 118, NULL, NULL, 231048),
(243550, '2o8bB02', NULL, NULL, 197, NULL, NULL, 231048),
(243551, '1pfiA00', NULL, NULL, 46, NULL, NULL, 231049),
(243552, '2yfaA02', NULL, NULL, 116, NULL, NULL, 231050),
(243553, '2yfaB01', NULL, NULL, 124, NULL, NULL, 231050),
(243554, '4akgA16', NULL, NULL, 165, NULL, NULL, 231051),
(243555, '3vkgA18', NULL, NULL, 173, NULL, NULL, 231051),
(243556, '1musA01', NULL, NULL, 69, NULL, NULL, 231052),
(243557, '2kvtA00', NULL, NULL, 71, NULL, NULL, 231053),
(243558, '3obwA02', NULL, NULL, 118, NULL, NULL, 231054),
(243559, '3agkA02', NULL, NULL, 136, NULL, NULL, 231054),
(243560, '2qi2A02', NULL, NULL, 118, NULL, NULL, 231054),
(243561, '3mcaB02', NULL, NULL, 133, NULL, NULL, 231054),
(243562, '3obyA02', NULL, NULL, 117, NULL, NULL, 231054),
(243563, '4af1A02', NULL, NULL, 126, NULL, NULL, 231054),
(243564, '3wxmB02', NULL, NULL, 122, NULL, NULL, 231054),
(243565, '1dt9A02', NULL, NULL, 112, NULL, NULL, 231054),
(243566, '2vgnB02', NULL, NULL, 136, NULL, NULL, 231054),
(243567, '3e1yC02', NULL, NULL, 145, NULL, NULL, 231054),
(243568, '2v66B00', NULL, NULL, 111, NULL, NULL, 231055),
(243569, '4fxkB01', NULL, NULL, 94, NULL, NULL, 231056),
(243570, '4p39A00', NULL, NULL, 77, NULL, NULL, 231056),
(243571, '2a73B01', NULL, NULL, 79, NULL, NULL, 231056),
(243572, '4uu9D00', NULL, NULL, 75, NULL, NULL, 231056),
(243573, '4p3aA00', NULL, NULL, 79, NULL, NULL, 231056),
(243574, '1c5aA00', NULL, NULL, 73, NULL, NULL, 231056),
(243575, '4hw5A00', NULL, NULL, 83, NULL, NULL, 231056),
(243576, '3cu7A08', NULL, NULL, 81, NULL, NULL, 231056),
(243577, '2b39A08', NULL, NULL, 81, NULL, NULL, 231056),
(243578, '4f2vA00', NULL, NULL, 272, NULL, NULL, 231057),
(243579, '5h38A00', NULL, NULL, 284, NULL, NULL, 231057),
(243580, '3nrrA03', NULL, NULL, 283, NULL, NULL, 231057),
(243581, '4dq1B00', NULL, NULL, 321, NULL, NULL, 231057),
(243582, '6nnrA00', NULL, NULL, 264, NULL, NULL, 231057),
(243583, '3ix6B00', NULL, NULL, 269, NULL, NULL, 231057),
(243584, '4fqsA00', NULL, NULL, 263, NULL, NULL, 231057),
(243585, '1tisA00', NULL, NULL, 286, NULL, NULL, 231057),
(243586, '3irmD02', NULL, NULL, 286, NULL, NULL, 231057),
(243587, '4h0rB00', NULL, NULL, 266, NULL, NULL, 231057),
(243588, '5m4zB00', NULL, NULL, 290, NULL, NULL, 231057),
(243589, '4ez8A00', NULL, NULL, 287, NULL, NULL, 231057),
(243590, '4xscC00', NULL, NULL, 281, NULL, NULL, 231057),
(243591, '3ik0A00', NULL, NULL, 316, NULL, NULL, 231057),
(243592, '3kgbA00', NULL, NULL, 294, NULL, NULL, 231057),
(243593, '6qyaA00', NULL, NULL, 282, NULL, NULL, 231057),
(243594, '3hj3A03', NULL, NULL, 284, NULL, NULL, 231057);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(243595, '1b5eA00', NULL, NULL, 246, NULL, NULL, 231057),
(243596, '4eilA03', NULL, NULL, 286, NULL, NULL, 231057),
(243597, '1bkpA00', NULL, NULL, 278, NULL, NULL, 231057),
(243598, '3hj3D02', NULL, NULL, 45, NULL, NULL, 231057),
(243599, '2aazI00', NULL, NULL, 317, NULL, NULL, 231057),
(243600, '4iqbA00', NULL, NULL, 292, NULL, NULL, 231057),
(243601, '3ed7A00', NULL, NULL, 295, NULL, NULL, 231057),
(243602, '3qg2A03', NULL, NULL, 285, NULL, NULL, 231057),
(243603, '3v8hC00', NULL, NULL, 327, NULL, NULL, 231057),
(243604, '6aujB00', NULL, NULL, 272, NULL, NULL, 231057),
(243605, '1qzfA02', NULL, NULL, 59, NULL, NULL, 231057),
(243606, '1f28A00', NULL, NULL, 297, NULL, NULL, 231057),
(243607, '2ot2A02', NULL, NULL, 31, NULL, NULL, 231058),
(243608, '3madA01', NULL, NULL, 62, NULL, NULL, 231059),
(243609, '4q6rB01', NULL, NULL, 68, NULL, NULL, 231059),
(243610, '3hhsA03', NULL, NULL, 272, NULL, NULL, 231060),
(243611, '3hhsB03', NULL, NULL, 266, NULL, NULL, 231060),
(243612, '3gwjA03', NULL, NULL, 207, NULL, NULL, 231060),
(243613, '1hcyA03', NULL, NULL, 214, NULL, NULL, 231060),
(243614, '3wjmD03', NULL, NULL, 211, NULL, NULL, 231060),
(243615, '1llaA02', NULL, NULL, 251, NULL, NULL, 231060),
(243616, '3wkyB03', NULL, NULL, 260, NULL, NULL, 231060),
(243617, '3wjmA03', NULL, NULL, 214, NULL, NULL, 231060),
(243618, '4yzwA03', NULL, NULL, 279, NULL, NULL, 231060),
(243619, '1qexA01', NULL, NULL, 35, NULL, NULL, 231061),
(243620, '3wwfA00', NULL, NULL, 90, NULL, NULL, 231062),
(243621, '4zcnA00', NULL, NULL, 87, NULL, NULL, 231062),
(243622, '1vfiA00', NULL, NULL, 95, NULL, NULL, 231063),
(243623, '3rw0A02', NULL, NULL, 107, NULL, NULL, 231064),
(243624, '5hk7B00', NULL, NULL, 152, NULL, NULL, 231064),
(243625, '1qleC01', NULL, NULL, 77, NULL, NULL, 231064),
(243626, '2a9hA00', NULL, NULL, 110, NULL, NULL, 231064),
(243627, '3oufB00', NULL, NULL, 97, NULL, NULL, 231064),
(243628, '4bw5C00', NULL, NULL, 265, NULL, NULL, 231064),
(243629, '3sypA02', NULL, NULL, 130, NULL, NULL, 231064),
(243630, '2r9rB03', NULL, NULL, 111, NULL, NULL, 231064),
(243631, '3k04B00', NULL, NULL, 96, NULL, NULL, 231064),
(243632, '6hu9c01', NULL, NULL, 78, NULL, NULL, 231064),
(243633, '2qksA01', NULL, NULL, 106, NULL, NULL, 231064),
(243634, '6cq9A00', NULL, NULL, 312, NULL, NULL, 231064),
(243635, '5cbgA00', NULL, NULL, 106, NULL, NULL, 231064),
(243636, '4x89A00', NULL, NULL, 97, NULL, NULL, 231064),
(243637, '2h8pC00', NULL, NULL, 57, NULL, NULL, 231064),
(243638, '4ekwC02', NULL, NULL, 99, NULL, NULL, 231064),
(243639, '1orqC01', NULL, NULL, 218, NULL, NULL, 231064),
(243640, '5vk6C00', NULL, NULL, 96, NULL, NULL, 231064),
(243641, '2ih3C00', NULL, NULL, 99, NULL, NULL, 231064),
(243642, '2k1eA00', NULL, NULL, 103, NULL, NULL, 231064),
(243643, '3rvyA02', NULL, NULL, 107, NULL, NULL, 231064),
(243644, '2yevA02', NULL, NULL, 74, NULL, NULL, 231064),
(243645, '4ekwA02', NULL, NULL, 105, NULL, NULL, 231064),
(243646, '5b1aC01', NULL, NULL, 70, NULL, NULL, 231064),
(243647, '3rw0B02', NULL, NULL, 107, NULL, NULL, 231064),
(243648, '4mswC00', NULL, NULL, 103, NULL, NULL, 231064),
(243649, '3behB02', NULL, NULL, 105, NULL, NULL, 231064),
(243650, '4j9zB00', NULL, NULL, 102, NULL, NULL, 231064),
(243651, '4dxwC02', NULL, NULL, 113, NULL, NULL, 231064),
(243652, '4gx0A01', NULL, NULL, 117, NULL, NULL, 231064),
(243653, '6jb1A02', NULL, NULL, 129, NULL, NULL, 231064),
(243654, '4h33A00', NULL, NULL, 102, NULL, NULL, 231064),
(243655, '1r3jC00', NULL, NULL, 103, NULL, NULL, 231064),
(243656, '3kg2A05', NULL, NULL, 169, NULL, NULL, 231064),
(243657, '3vouB00', NULL, NULL, 148, NULL, NULL, 231064),
(243658, '4lp8A01', NULL, NULL, 104, NULL, NULL, 231064),
(243659, '4twkB00', NULL, NULL, 266, NULL, NULL, 231064),
(243660, '5wbxB00', NULL, NULL, 95, NULL, NULL, 231064),
(243661, '5vkhC00', NULL, NULL, 103, NULL, NULL, 231064),
(243662, '2q67A00', NULL, NULL, 114, NULL, NULL, 231064),
(243663, '4wfeA00', NULL, NULL, 272, NULL, NULL, 231064),
(243664, '3ukmA01', NULL, NULL, 274, NULL, NULL, 231064),
(243665, '3um7A03', NULL, NULL, 105, NULL, NULL, 231064);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(243666, '3rbzA01', NULL, NULL, 68, NULL, NULL, 231064),
(243667, '3um7A01', NULL, NULL, 110, NULL, NULL, 231064),
(243668, '3ldcA00', NULL, NULL, 82, NULL, NULL, 231064),
(243669, '4ekwD02', NULL, NULL, 103, NULL, NULL, 231064),
(243670, '1m56C01', NULL, NULL, 70, NULL, NULL, 231064),
(243671, '5kukA02', NULL, NULL, 132, NULL, NULL, 231064),
(243672, '1lnqA01', NULL, NULL, 80, NULL, NULL, 231064),
(243673, '1p7bA01', NULL, NULL, 108, NULL, NULL, 231064),
(243674, '4ekwB02', NULL, NULL, 105, NULL, NULL, 231064),
(243675, '2x5rA01', NULL, NULL, 118, NULL, NULL, 231065),
(243676, '2oy9A01', NULL, NULL, 85, NULL, NULL, 231066),
(243677, '2qmiA02', NULL, NULL, 100, NULL, NULL, 231067),
(243678, '3vb8B00', NULL, NULL, 161, NULL, NULL, 231068),
(243679, '3ii2A00', NULL, NULL, 157, NULL, NULL, 231068),
(243680, '3m4aA02', NULL, NULL, 136, NULL, NULL, 231069),
(243681, '3thrA01', NULL, NULL, 83, NULL, NULL, 231070),
(243682, '1r74B01', NULL, NULL, 83, NULL, NULL, 231070),
(243683, '1kiaA01', NULL, NULL, 83, NULL, NULL, 231070),
(243684, '5xteF00', NULL, NULL, 106, NULL, NULL, 231071),
(243685, '2fyuF00', NULL, NULL, 110, NULL, NULL, 231071),
(243686, '3tguF00', NULL, NULL, 110, NULL, NULL, 231071),
(243687, '1bccF00', NULL, NULL, 109, NULL, NULL, 231071),
(243688, '3cx5G00', NULL, NULL, 126, NULL, NULL, 231071),
(243689, '2knrA00', NULL, NULL, 121, NULL, NULL, 231072),
(243690, '4goqA00', NULL, NULL, 110, NULL, NULL, 231072),
(243691, '3snhA02', NULL, NULL, 246, NULL, NULL, 231073),
(243692, '3zvrA02', NULL, NULL, 238, NULL, NULL, 231073),
(243693, '5a3fA02', NULL, NULL, 245, NULL, NULL, 231073),
(243694, '4bejD02', NULL, NULL, 256, NULL, NULL, 231073),
(243695, '3ljbA00', NULL, NULL, 231, NULL, NULL, 231073),
(243696, '4x0rB00', NULL, NULL, 239, NULL, NULL, 231073),
(243697, '4ysxB02', NULL, NULL, 144, NULL, NULL, 231074),
(243698, '2h88B02', NULL, NULL, 138, NULL, NULL, 231074),
(243699, '5xmjB02', NULL, NULL, 124, NULL, NULL, 231074),
(243700, '1kf6B02', NULL, NULL, 138, NULL, NULL, 231074),
(243701, '1zoyB02', NULL, NULL, 138, NULL, NULL, 231074),
(243702, '1gteA02', NULL, NULL, 157, NULL, NULL, 231074),
(243703, '2bs2B02', NULL, NULL, 124, NULL, NULL, 231074),
(243704, '2wdqB02', NULL, NULL, 132, NULL, NULL, 231074),
(243705, '2z0jH00', NULL, NULL, 237, NULL, NULL, 231075),
(243706, '1vr0C00', NULL, NULL, 247, NULL, NULL, 231075),
(243707, '2yyvB00', NULL, NULL, 227, NULL, NULL, 231075),
(243708, '1q90D02', NULL, NULL, 93, NULL, NULL, 231076),
(243709, '4ogqB02', NULL, NULL, 94, NULL, NULL, 231076),
(243710, '4i7zB02', NULL, NULL, 94, NULL, NULL, 231076),
(243711, '2ba3A01', NULL, NULL, 29, NULL, NULL, 231077),
(243712, '3qoqC00', NULL, NULL, 69, NULL, NULL, 231077),
(243713, '2bsqE01', NULL, NULL, 50, NULL, NULL, 231077),
(243714, '4hv0C00', NULL, NULL, 106, NULL, NULL, 231077),
(243715, '3ft7B00', NULL, NULL, 55, NULL, NULL, 231077),
(243716, '2wvbA01', NULL, NULL, 35, NULL, NULL, 231077),
(243717, '3qoqD00', NULL, NULL, 51, NULL, NULL, 231077),
(243718, '2bj7A01', NULL, NULL, 41, NULL, NULL, 231077),
(243719, '2gpeD01', NULL, NULL, 42, NULL, NULL, 231077),
(243720, '1mntA00', NULL, NULL, 76, NULL, NULL, 231077),
(243721, '1nlaA00', NULL, NULL, 64, NULL, NULL, 231077),
(243722, '2k6lA00', NULL, NULL, 51, NULL, NULL, 231077),
(243723, '4d8jB02', NULL, NULL, 53, NULL, NULL, 231077),
(243724, '3veaA02', NULL, NULL, 54, NULL, NULL, 231077),
(243725, '4me7F00', NULL, NULL, 94, NULL, NULL, 231077),
(243726, '2hzaA01', NULL, NULL, 47, NULL, NULL, 231077),
(243727, '4me7E00', NULL, NULL, 94, NULL, NULL, 231077),
(243728, '2wvfA01', NULL, NULL, 38, NULL, NULL, 231077),
(243729, '2cpgB00', NULL, NULL, 45, NULL, NULL, 231077),
(243730, '3vw4A02', NULL, NULL, 33, NULL, NULL, 231077),
(243731, '1mylA00', NULL, NULL, 53, NULL, NULL, 231077),
(243732, '2k5jA01', NULL, NULL, 55, NULL, NULL, 231077),
(243733, '4fxeA00', NULL, NULL, 79, NULL, NULL, 231077),
(243734, '2jxgA01', NULL, NULL, 35, NULL, NULL, 231077),
(243735, '1bazC00', NULL, NULL, 53, NULL, NULL, 231077),
(243736, '3gxqA00', NULL, NULL, 54, NULL, NULL, 231077);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(243737, '2k29A00', NULL, NULL, 53, NULL, NULL, 231077),
(243738, '1u9pA00', NULL, NULL, 120, NULL, NULL, 231077),
(243739, '1p94A00', NULL, NULL, 76, NULL, NULL, 231077),
(243740, '3fmtE01', NULL, NULL, 41, NULL, NULL, 231077),
(243741, '1y9bB01', NULL, NULL, 49, NULL, NULL, 231077),
(243742, '2kelA00', NULL, NULL, 56, NULL, NULL, 231077),
(243743, '1irqA00', NULL, NULL, 48, NULL, NULL, 231077),
(243744, '1x93A01', NULL, NULL, 47, NULL, NULL, 231077),
(243745, '3h87D01', NULL, NULL, 65, NULL, NULL, 231077),
(243746, '2k1oA00', NULL, NULL, 66, NULL, NULL, 231077),
(243747, '1v9fA02', NULL, NULL, 43, NULL, NULL, 231078),
(243748, '6c44A00', NULL, NULL, 70, NULL, NULL, 231079),
(243749, '1r6rA00', NULL, NULL, 80, NULL, NULL, 231079),
(243750, '5ow2A00', NULL, NULL, 80, NULL, NULL, 231079),
(243751, '1sfkA00', NULL, NULL, 76, NULL, NULL, 231079),
(243752, '1sfkH00', NULL, NULL, 59, NULL, NULL, 231079),
(243753, '5yghA00', NULL, NULL, 76, NULL, NULL, 231079),
(243754, '3onqA02', NULL, NULL, 81, NULL, NULL, 231080),
(243755, '1y8aA02', NULL, NULL, 116, NULL, NULL, 231081),
(243756, '3er9B01', NULL, NULL, 117, NULL, NULL, 231082),
(243757, '3owgA01', NULL, NULL, 112, NULL, NULL, 231082),
(243758, '4wqnA00', NULL, NULL, 156, NULL, NULL, 231083),
(243759, '5dnoA00', NULL, NULL, 178, NULL, NULL, 231083),
(243760, '2eveA00', NULL, NULL, 157, NULL, NULL, 231083),
(243761, '2yu6A01', NULL, NULL, 134, NULL, NULL, 231083),
(243762, '4rcmB00', NULL, NULL, 167, NULL, NULL, 231083),
(243763, '2ar1A00', NULL, NULL, 172, NULL, NULL, 231083),
(243764, '3eopB00', NULL, NULL, 176, NULL, NULL, 231083),
(243765, '4rcjA01', NULL, NULL, 146, NULL, NULL, 231083),
(243766, '2gbsA00', NULL, NULL, 145, NULL, NULL, 231083),
(243767, '2g2xA00', NULL, NULL, 157, NULL, NULL, 231083),
(243768, '1zceA00', NULL, NULL, 155, NULL, NULL, 231083),
(243769, '4rdnA00', NULL, NULL, 167, NULL, NULL, 231083),
(243770, '2p5dA00', NULL, NULL, 147, NULL, NULL, 231083),
(243771, '2yudA01', NULL, NULL, 155, NULL, NULL, 231083),
(243772, '4u8tE00', NULL, NULL, 177, NULL, NULL, 231083),
(243773, '2hd9A00', NULL, NULL, 145, NULL, NULL, 231083),
(243774, '2iumA00', NULL, NULL, 211, NULL, NULL, 231084),
(243775, '2vtwA00', NULL, NULL, 205, NULL, NULL, 231084),
(243776, '4h4kA01', NULL, NULL, 124, NULL, NULL, 231085),
(243777, '4jpbB00', NULL, NULL, 90, NULL, NULL, 231086),
(243778, '4lt6A01', NULL, NULL, 190, NULL, NULL, 231087),
(243779, '1q79A03', NULL, NULL, 190, NULL, NULL, 231087),
(243780, '2b4vA01', NULL, NULL, 234, NULL, NULL, 231087),
(243781, '4ud4A01', NULL, NULL, 215, NULL, NULL, 231087),
(243782, '4m5dA01', NULL, NULL, 208, NULL, NULL, 231087),
(243783, '3nybA01', NULL, NULL, 213, NULL, NULL, 231087),
(243784, '3hj4A01', NULL, NULL, 253, NULL, NULL, 231087),
(243785, '2hhpA01', NULL, NULL, 196, NULL, NULL, 231087),
(243786, '1wz2A05', NULL, NULL, 52, NULL, NULL, 231088),
(243787, '1fftC00', NULL, NULL, 186, NULL, NULL, 231089),
(243788, '1qleC02', NULL, NULL, 196, NULL, NULL, 231089),
(243789, '2yevA03', NULL, NULL, 184, NULL, NULL, 231089),
(243790, '5b1aC02', NULL, NULL, 191, NULL, NULL, 231089),
(243791, '6giqc02', NULL, NULL, 191, NULL, NULL, 231089),
(243792, '1m56C02', NULL, NULL, 196, NULL, NULL, 231089),
(243793, '1nqjB00', NULL, NULL, 119, NULL, NULL, 231090),
(243794, '3afgA03', NULL, NULL, 102, NULL, NULL, 231090),
(243795, '3jqwC00', NULL, NULL, 121, NULL, NULL, 231090),
(243796, '2xvlA02', NULL, NULL, 147, NULL, NULL, 231090),
(243797, '4g9sB00', NULL, NULL, 111, NULL, NULL, 231090),
(243798, '4dzgA00', NULL, NULL, 114, NULL, NULL, 231090),
(243799, '5fbzA02', NULL, NULL, 117, NULL, NULL, 231090),
(243800, '1df0A03', NULL, NULL, 151, NULL, NULL, 231090),
(243801, '2luwA00', NULL, NULL, 101, NULL, NULL, 231090),
(243802, '4i3gA03', NULL, NULL, 107, NULL, NULL, 231090),
(243803, '2qfeA00', NULL, NULL, 148, NULL, NULL, 231090),
(243804, '5jouA02', NULL, NULL, 142, NULL, NULL, 231090),
(243805, '1wmdA02', NULL, NULL, 117, NULL, NULL, 231090),
(243806, '5sv5A00', NULL, NULL, 105, NULL, NULL, 231090),
(243807, '1kfuL03', NULL, NULL, 161, NULL, NULL, 231090);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(243808, '1qxpA03', NULL, NULL, 160, NULL, NULL, 231090),
(243809, '4dy5A00', NULL, NULL, 111, NULL, NULL, 231090),
(243810, '2jxuA00', NULL, NULL, 153, NULL, NULL, 231091),
(243811, '2h5nC00', NULL, NULL, 133, NULL, NULL, 231091),
(243812, '2ou3A01', NULL, NULL, 156, NULL, NULL, 231091),
(243813, '3okqA00', NULL, NULL, 141, NULL, NULL, 231092),
(243814, '4indA03', NULL, NULL, 123, NULL, NULL, 231093),
(243815, '3cqcB01', NULL, NULL, 92, NULL, NULL, 231094),
(243816, '4ipbA00', NULL, NULL, 142, NULL, NULL, 231095),
(243817, '3u1wA01', NULL, NULL, 187, NULL, NULL, 231095),
(243818, '3u1wA02', NULL, NULL, 66, NULL, NULL, 231095),
(243819, '4hbrD00', NULL, NULL, 140, NULL, NULL, 231095),
(243820, '4k61B00', NULL, NULL, 140, NULL, NULL, 231095),
(243821, '4fr9A00', NULL, NULL, 144, NULL, NULL, 231095),
(243822, '2yevC00', NULL, NULL, 66, NULL, NULL, 231096),
(243823, '6as6A01', NULL, NULL, 455, NULL, NULL, 231097),
(243824, '4ex4A01', NULL, NULL, 466, NULL, NULL, 231097),
(243825, '5vfbA01', NULL, NULL, 458, NULL, NULL, 231097),
(243826, '3cuxA01', NULL, NULL, 406, NULL, NULL, 231097),
(243827, '1p7tB01', NULL, NULL, 459, NULL, NULL, 231097),
(243828, '6axeB01', NULL, NULL, 470, NULL, NULL, 231097),
(243829, '3cuzA01', NULL, NULL, 410, NULL, NULL, 231097),
(243830, '3i4uA01', NULL, NULL, 110, NULL, NULL, 231098),
(243831, '1e91A00', NULL, NULL, 85, NULL, NULL, 231099),
(243832, '2rmrA01', NULL, NULL, 63, NULL, NULL, 231099),
(243833, '2ld7B00', NULL, NULL, 75, NULL, NULL, 231099),
(243834, '2cr7A01', NULL, NULL, 63, NULL, NULL, 231099),
(243835, '1g1eB00', NULL, NULL, 89, NULL, NULL, 231099),
(243836, '2afrA00', NULL, NULL, 231, NULL, NULL, 231100),
(243837, '4au1A00', NULL, NULL, 208, NULL, NULL, 231100),
(243838, '1ou0B00', NULL, NULL, 207, NULL, NULL, 231100),
(243839, '1v9cB00', NULL, NULL, 218, NULL, NULL, 231100),
(243840, '1f2vA00', NULL, NULL, 219, NULL, NULL, 231100),
(243841, '3e7dA00', NULL, NULL, 212, NULL, NULL, 231100),
(243842, '1vr9A02', NULL, NULL, 56, NULL, NULL, 231101),
(243843, '5cqgA02', NULL, NULL, 72, NULL, NULL, 231102),
(243844, '2g8lA01', NULL, NULL, 80, NULL, NULL, 231103),
(243845, '2g8lB01', NULL, NULL, 80, NULL, NULL, 231103),
(243846, '2ffjA01', NULL, NULL, 62, NULL, NULL, 231103),
(243847, '3hglA00', NULL, NULL, 85, NULL, NULL, 231104),
(243848, '3sviA00', NULL, NULL, 83, NULL, NULL, 231104),
(243849, '3tjyA00', NULL, NULL, 78, NULL, NULL, 231104),
(243850, '3vldA01', NULL, NULL, 304, NULL, NULL, 231105),
(243851, '2cw8A04', NULL, NULL, 53, NULL, NULL, 231106),
(243852, '3e2dA04', NULL, NULL, 32, NULL, NULL, 231107),
(243853, '2hldQ02', NULL, NULL, 41, NULL, NULL, 231108),
(243854, '5lw5A00', NULL, NULL, 154, NULL, NULL, 231109),
(243855, '1bhaA00', NULL, NULL, 71, NULL, NULL, 231110),
(243856, '2huhA01', NULL, NULL, 136, NULL, NULL, 231111),
(243857, '1z2nX03', NULL, NULL, 106, NULL, NULL, 231112),
(243858, '4c91A04', NULL, NULL, 191, NULL, NULL, 231113),
(243859, '2otoA00', NULL, NULL, 139, NULL, NULL, 231114),
(243860, '3hhsB02', NULL, NULL, 277, NULL, NULL, 231115),
(243861, '3w6wB01', NULL, NULL, 457, NULL, NULL, 231115),
(243862, '4z0zA00', NULL, NULL, 350, NULL, NULL, 231115),
(243863, '2p3xA00', NULL, NULL, 339, NULL, NULL, 231115),
(243864, '1hcyA02', NULL, NULL, 228, NULL, NULL, 231115),
(243865, '3gwjA02', NULL, NULL, 233, NULL, NULL, 231115),
(243866, '5ce9B00', NULL, NULL, 339, NULL, NULL, 231115),
(243867, '3qjoA01', NULL, NULL, 286, NULL, NULL, 231115),
(243868, '1js8A01', NULL, NULL, 284, NULL, NULL, 231115),
(243869, '3hhsA02', NULL, NULL, 276, NULL, NULL, 231115),
(243870, '4hd4A00', NULL, NULL, 303, NULL, NULL, 231115),
(243871, '3wjmA02', NULL, NULL, 233, NULL, NULL, 231115),
(243872, '5z0fA00', NULL, NULL, 281, NULL, NULL, 231115),
(243873, '3wjmB02', NULL, NULL, 233, NULL, NULL, 231115),
(243874, '4yzwA02', NULL, NULL, 276, NULL, NULL, 231115),
(243875, '1llaA03', NULL, NULL, 268, NULL, NULL, 231115),
(243876, '2y9wA00', NULL, NULL, 391, NULL, NULL, 231115),
(243877, '5or3A00', NULL, NULL, 383, NULL, NULL, 231115),
(243878, '1lnlA01', NULL, NULL, 307, NULL, NULL, 231115);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(243879, '1bt3A00', NULL, NULL, 345, NULL, NULL, 231115),
(243880, '4ouaB01', NULL, NULL, 378, NULL, NULL, 231115),
(243881, '3wkyA02', NULL, NULL, 281, NULL, NULL, 231115),
(243882, '4aukA01', NULL, NULL, 79, NULL, NULL, 231116),
(243883, '3dtdD00', NULL, NULL, 152, NULL, NULL, 231117),
(243884, '3if8A03', NULL, NULL, 46, NULL, NULL, 231118),
(243885, '4m1xD00', NULL, NULL, 72, NULL, NULL, 231119),
(243886, '3ialA03', NULL, NULL, 78, NULL, NULL, 231120),
(243887, '1nj1A03', NULL, NULL, 70, NULL, NULL, 231120),
(243888, '4wi1A03', NULL, NULL, 91, NULL, NULL, 231120),
(243889, '4hvcA03', NULL, NULL, 88, NULL, NULL, 231120),
(243890, '1hc7A03', NULL, NULL, 74, NULL, NULL, 231120),
(243891, '1nj8A03', NULL, NULL, 61, NULL, NULL, 231120),
(243892, '6qm7D00', NULL, NULL, 248, NULL, NULL, 231121),
(243893, '4hnzA00', NULL, NULL, 179, NULL, NULL, 231121),
(243894, '1ea0A01', NULL, NULL, 422, NULL, NULL, 231121),
(243895, '1g3kA00', NULL, NULL, 174, NULL, NULL, 231121),
(243896, '1ryp200', NULL, NULL, 233, NULL, NULL, 231121),
(243897, '1cp9B01', NULL, NULL, 298, NULL, NULL, 231121),
(243898, '5fmgE00', NULL, NULL, 256, NULL, NULL, 231121),
(243899, '5fmgI00', NULL, NULL, 190, NULL, NULL, 231121),
(243900, '1yarH00', NULL, NULL, 217, NULL, NULL, 231121),
(243901, '5fmgA00', NULL, NULL, 260, NULL, NULL, 231121),
(243902, '2imhA01', NULL, NULL, 218, NULL, NULL, 231121),
(243903, '1rypK00', NULL, NULL, 198, NULL, NULL, 231121),
(243904, '1jgtB01', NULL, NULL, 207, NULL, NULL, 231121),
(243905, '5fmgN00', NULL, NULL, 202, NULL, NULL, 231121),
(243906, '4e57A01', NULL, NULL, 343, NULL, NULL, 231121),
(243907, '6qm7M00', NULL, NULL, 214, NULL, NULL, 231121),
(243908, '1rypG00', NULL, NULL, 244, NULL, NULL, 231121),
(243909, '6qm7I00', NULL, NULL, 225, NULL, NULL, 231121),
(243910, '5le5K00', NULL, NULL, 204, NULL, NULL, 231121),
(243911, '1rypC00', NULL, NULL, 244, NULL, NULL, 231121),
(243912, '1fm2B01', NULL, NULL, 262, NULL, NULL, 231121),
(243913, '5le5F00', NULL, NULL, 255, NULL, NULL, 231121),
(243914, '1q5qA00', NULL, NULL, 235, NULL, NULL, 231121),
(243915, '6qm7A00', NULL, NULL, 250, NULL, NULL, 231121),
(243916, '4hstB01', NULL, NULL, 329, NULL, NULL, 231121),
(243917, '1q15A01', NULL, NULL, 206, NULL, NULL, 231121),
(243918, '5fmgF00', NULL, NULL, 237, NULL, NULL, 231121),
(243919, '6avoA00', NULL, NULL, 199, NULL, NULL, 231121),
(243920, '5fmgJ00', NULL, NULL, 218, NULL, NULL, 231121),
(243921, '1j2qH00', NULL, NULL, 202, NULL, NULL, 231121),
(243922, '5fmgB00', NULL, NULL, 235, NULL, NULL, 231121),
(243923, '1rypL00', NULL, NULL, 212, NULL, NULL, 231121),
(243924, '5le5b00', NULL, NULL, 205, NULL, NULL, 231121),
(243925, '1m4yA00', NULL, NULL, 171, NULL, NULL, 231121),
(243926, '1rypH00', NULL, NULL, 205, NULL, NULL, 231121),
(243927, '6hv3H00', NULL, NULL, 226, NULL, NULL, 231121),
(243928, '5fmgK00', NULL, NULL, 195, NULL, NULL, 231121),
(243929, '3unfN00', NULL, NULL, 199, NULL, NULL, 231121),
(243930, '6qm7N00', NULL, NULL, 220, NULL, NULL, 231121),
(243931, '1rypD00', NULL, NULL, 241, NULL, NULL, 231121),
(243932, '4zflD00', NULL, NULL, 234, NULL, NULL, 231121),
(243933, '4pemB01', NULL, NULL, 302, NULL, NULL, 231121),
(243934, '6qm7J00', NULL, NULL, 205, NULL, NULL, 231121),
(243935, '3k3wB01', NULL, NULL, 296, NULL, NULL, 231121),
(243936, '5le5J00', NULL, NULL, 201, NULL, NULL, 231121),
(243937, '6qm7F00', NULL, NULL, 238, NULL, NULL, 231121),
(243938, '5le5E00', NULL, NULL, 237, NULL, NULL, 231121),
(243939, '3mkaZ00', NULL, NULL, 272, NULL, NULL, 231121),
(243940, '5le5A00', NULL, NULL, 234, NULL, NULL, 231121),
(243941, '1q5qH00', NULL, NULL, 235, NULL, NULL, 231121),
(243942, '5fmgC00', NULL, NULL, 246, NULL, NULL, 231121),
(243943, '3ty6A00', NULL, NULL, 183, NULL, NULL, 231121),
(243944, '5fmgG00', NULL, NULL, 252, NULL, NULL, 231121),
(243945, '1e94A00', NULL, NULL, 175, NULL, NULL, 231121),
(243946, '6avoB00', NULL, NULL, 234, NULL, NULL, 231121),
(243947, '2advC01', NULL, NULL, 210, NULL, NULL, 231121),
(243948, '1xffA00', NULL, NULL, 240, NULL, NULL, 231121),
(243949, '3mi0F00', NULL, NULL, 248, NULL, NULL, 231121);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(243950, '1ofdA01', NULL, NULL, 430, NULL, NULL, 231121),
(243951, '1te5A00', NULL, NULL, 257, NULL, NULL, 231121),
(243952, '1rypI00', NULL, NULL, 222, NULL, NULL, 231121),
(243953, '5l5yK00', NULL, NULL, 211, NULL, NULL, 231121),
(243954, '2z3bA00', NULL, NULL, 180, NULL, NULL, 231121),
(243955, '5fmgL00', NULL, NULL, 194, NULL, NULL, 231121),
(243956, '4yfbC01', NULL, NULL, 287, NULL, NULL, 231121),
(243957, '3mi0200', NULL, NULL, 223, NULL, NULL, 231121),
(243958, '5le5U00', NULL, NULL, 246, NULL, NULL, 231121),
(243959, '6qm7S00', NULL, NULL, 238, NULL, NULL, 231121),
(243960, '3mdnD00', NULL, NULL, 274, NULL, NULL, 231121),
(243961, '3unfK00', NULL, NULL, 204, NULL, NULL, 231121),
(243962, '5le5Q00', NULL, NULL, 248, NULL, NULL, 231121),
(243963, '5le5M00', NULL, NULL, 219, NULL, NULL, 231121),
(243964, '6qm7K00', NULL, NULL, 206, NULL, NULL, 231121),
(243965, '1rypE00', NULL, NULL, 242, NULL, NULL, 231121),
(243966, '1ao0A01', NULL, NULL, 304, NULL, NULL, 231121),
(243967, '6qm7G00', NULL, NULL, 238, NULL, NULL, 231121),
(243968, '5le5I00', NULL, NULL, 205, NULL, NULL, 231121),
(243969, '1or0B01', NULL, NULL, 259, NULL, NULL, 231121),
(243970, '1rypA00', NULL, NULL, 243, NULL, NULL, 231121),
(243971, '3hfa100', NULL, NULL, 240, NULL, NULL, 231121),
(243972, '5le5D00', NULL, NULL, 241, NULL, NULL, 231121),
(243973, '5l5aK00', NULL, NULL, 211, NULL, NULL, 231121),
(243974, '1ryp100', NULL, NULL, 222, NULL, NULL, 231121),
(243975, '5fmgD00', NULL, NULL, 241, NULL, NULL, 231121),
(243976, '4wksC01', NULL, NULL, 277, NULL, NULL, 231121),
(243977, '5fmgH00', NULL, NULL, 196, NULL, NULL, 231121),
(243978, '6avoC00', NULL, NULL, 204, NULL, NULL, 231121),
(243979, '1yarA00', NULL, NULL, 233, NULL, NULL, 231121),
(243980, '1rypJ00', NULL, NULL, 204, NULL, NULL, 231121),
(243981, '1g0uD00', NULL, NULL, 241, NULL, NULL, 231121),
(243982, '5fmgM00', NULL, NULL, 209, NULL, NULL, 231121),
(243983, '3unfH00', NULL, NULL, 234, NULL, NULL, 231121),
(243984, '1gk9B01', NULL, NULL, 302, NULL, NULL, 231121),
(243985, '1j2pA00', NULL, NULL, 246, NULL, NULL, 231121),
(243986, '6czfA01', NULL, NULL, 321, NULL, NULL, 231121),
(243987, '1ct9A01', NULL, NULL, 192, NULL, NULL, 231121),
(243988, '5le5P00', NULL, NULL, 261, NULL, NULL, 231121),
(243989, '1rypF00', NULL, NULL, 233, NULL, NULL, 231121),
(243990, '6qm7L00', NULL, NULL, 203, NULL, NULL, 231121),
(243991, '5le5L00', NULL, NULL, 213, NULL, NULL, 231121),
(243992, '1rypB00', NULL, NULL, 250, NULL, NULL, 231121),
(243993, '5le5H00', NULL, NULL, 234, NULL, NULL, 231121),
(243994, '1xu0A00', NULL, NULL, 102, NULL, NULL, 231122),
(243995, '1tqbA00', NULL, NULL, 102, NULL, NULL, 231122),
(243996, '2prp000', NULL, NULL, 142, NULL, NULL, 231122),
(243997, '1b10A00', NULL, NULL, 107, NULL, NULL, 231122),
(243998, '1i17A00', NULL, NULL, 107, NULL, NULL, 231122),
(243999, '2ktmA00', NULL, NULL, 68, NULL, NULL, 231122),
(244000, '3o79B00', NULL, NULL, 105, NULL, NULL, 231122),
(244001, '1u5lA00', NULL, NULL, 108, NULL, NULL, 231122),
(244002, '2mv8A01', NULL, NULL, 96, NULL, NULL, 231122),
(244003, '2k56A00', NULL, NULL, 113, NULL, NULL, 231122),
(244004, '1xyqA00', NULL, NULL, 111, NULL, NULL, 231122),
(244005, '6aq7A00', NULL, NULL, 101, NULL, NULL, 231122),
(244006, '1xyjA00', NULL, NULL, 111, NULL, NULL, 231122),
(244007, '1lg4A00', NULL, NULL, 101, NULL, NULL, 231122),
(244008, '1u3mA00', NULL, NULL, 117, NULL, NULL, 231122),
(244009, '3hakA00', NULL, NULL, 103, NULL, NULL, 231122),
(244010, '1uw3A00', NULL, NULL, 106, NULL, NULL, 231122),
(244011, '2lsbA00', NULL, NULL, 142, NULL, NULL, 231122),
(244012, '1i4mA00', NULL, NULL, 108, NULL, NULL, 231122),
(244013, '2ku4A00', NULL, NULL, 113, NULL, NULL, 231122),
(244014, '2kflA00', NULL, NULL, 112, NULL, NULL, 231122),
(244015, '3i2dA01', NULL, NULL, 155, NULL, NULL, 231123),
(244016, '4mvtB01', NULL, NULL, 154, NULL, NULL, 231123),
(244017, '4fo9A01', NULL, NULL, 154, NULL, NULL, 231123),
(244018, '3eapD00', NULL, NULL, 271, NULL, NULL, 231124),
(244019, '2ovjA00', NULL, NULL, 201, NULL, NULL, 231124),
(244020, '1pbwB00', NULL, NULL, 216, NULL, NULL, 231124);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(244021, '5my3A00', NULL, NULL, 208, NULL, NULL, 231124),
(244022, '3msxB00', NULL, NULL, 201, NULL, NULL, 231124),
(244023, '2qv2A02', NULL, NULL, 168, NULL, NULL, 231124),
(244024, '5c5sB00', NULL, NULL, 216, NULL, NULL, 231124),
(244025, '2mbgA01', NULL, NULL, 199, NULL, NULL, 231124),
(244026, '1xa6A03', NULL, NULL, 190, NULL, NULL, 231124),
(244027, '3iugB00', NULL, NULL, 210, NULL, NULL, 231124),
(244028, '2xs6A00', NULL, NULL, 190, NULL, NULL, 231124),
(244029, '5jcpB01', NULL, NULL, 204, NULL, NULL, 231124),
(244030, '3kuqA00', NULL, NULL, 228, NULL, NULL, 231124),
(244031, '1f7cA00', NULL, NULL, 201, NULL, NULL, 231124),
(244032, '3wpsA00', NULL, NULL, 208, NULL, NULL, 231124),
(244033, '2osaA00', NULL, NULL, 202, NULL, NULL, 231124),
(244034, '6d85A00', NULL, NULL, 193, NULL, NULL, 231124),
(244035, '1tx4A00', NULL, NULL, 198, NULL, NULL, 231124),
(244036, '5ircB00', NULL, NULL, 201, NULL, NULL, 231124),
(244037, '3byiD00', NULL, NULL, 214, NULL, NULL, 231124),
(244038, '2ee4A01', NULL, NULL, 192, NULL, NULL, 231124),
(244039, '1x6mA00', NULL, NULL, 196, NULL, NULL, 231125),
(244040, '5uncB00', NULL, NULL, 287, NULL, NULL, 231126),
(244041, '2ze3A01', NULL, NULL, 232, NULL, NULL, 231126),
(244042, '2x0sA06', NULL, NULL, 341, NULL, NULL, 231126),
(244043, '3qv9A02', NULL, NULL, 234, NULL, NULL, 231126),
(244044, '4lsbA01', NULL, NULL, 242, NULL, NULL, 231126),
(244045, '3oyzA01', NULL, NULL, 272, NULL, NULL, 231126),
(244046, '1f8mA00', NULL, NULL, 429, NULL, NULL, 231126),
(244047, '3hqnA02', NULL, NULL, 234, NULL, NULL, 231126),
(244048, '2bg5D00', NULL, NULL, 324, NULL, NULL, 231126),
(244049, '1a3wA02', NULL, NULL, 235, NULL, NULL, 231126),
(244050, '3qtgA01', NULL, NULL, 251, NULL, NULL, 231126),
(244051, '2xz9B00', NULL, NULL, 324, NULL, NULL, 231126),
(244052, '2bg5B00', NULL, NULL, 324, NULL, NULL, 231126),
(244053, '4mg4C00', NULL, NULL, 261, NULL, NULL, 231126),
(244054, '4drsA02', NULL, NULL, 248, NULL, NULL, 231126),
(244055, '3eooB00', NULL, NULL, 298, NULL, NULL, 231126),
(244056, '1oy0A00', NULL, NULL, 264, NULL, NULL, 231126),
(244057, '4kctA02', NULL, NULL, 234, NULL, NULL, 231126),
(244058, '2hroA03', NULL, NULL, 342, NULL, NULL, 231126),
(244059, '1igwA00', NULL, NULL, 417, NULL, NULL, 231126),
(244060, '3r4iA01', NULL, NULL, 268, NULL, NULL, 231126),
(244061, '3fa4J00', NULL, NULL, 302, NULL, NULL, 231126),
(244062, '3qz6A00', NULL, NULL, 261, NULL, NULL, 231126),
(244063, '2v5jB00', NULL, NULL, 271, NULL, NULL, 231126),
(244064, '1o66C00', NULL, NULL, 258, NULL, NULL, 231126),
(244065, '1o68D00', NULL, NULL, 275, NULL, NULL, 231126),
(244066, '1o66E00', NULL, NULL, 259, NULL, NULL, 231126),
(244067, '1o68B00', NULL, NULL, 275, NULL, NULL, 231126),
(244068, '4tv5A00', NULL, NULL, 259, NULL, NULL, 231126),
(244069, '1o66A00', NULL, NULL, 275, NULL, NULL, 231126),
(244070, '4l80D00', NULL, NULL, 348, NULL, NULL, 231126),
(244071, '1e0tA02', NULL, NULL, 235, NULL, NULL, 231126),
(244072, '3khdA02', NULL, NULL, 236, NULL, NULL, 231126),
(244073, '2vwsA00', NULL, NULL, 267, NULL, NULL, 231126),
(244074, '1sgjA00', NULL, NULL, 234, NULL, NULL, 231126),
(244075, '3eolA00', NULL, NULL, 411, NULL, NULL, 231126),
(244076, '1u5hA00', NULL, NULL, 223, NULL, NULL, 231126),
(244077, '2qiwA01', NULL, NULL, 236, NULL, NULL, 231126),
(244078, '2hjpA00', NULL, NULL, 290, NULL, NULL, 231126),
(244079, '4ip7B02', NULL, NULL, 240, NULL, NULL, 231126),
(244080, '3ez4F00', NULL, NULL, 269, NULL, NULL, 231126),
(244081, '4l9yB00', NULL, NULL, 264, NULL, NULL, 231126),
(244082, '6b6uA02', NULL, NULL, 240, NULL, NULL, 231126),
(244083, '1izcA00', NULL, NULL, 300, NULL, NULL, 231126),
(244084, '2wqdA02', NULL, NULL, 338, NULL, NULL, 231126),
(244085, '2e28A01', NULL, NULL, 243, NULL, NULL, 231126),
(244086, '2olsA04', NULL, NULL, 314, NULL, NULL, 231126),
(244087, '3i4eA00', NULL, NULL, 416, NULL, NULL, 231126),
(244088, '1dquA01', NULL, NULL, 411, NULL, NULL, 231126),
(244089, '5ws9A01', NULL, NULL, 234, NULL, NULL, 231126),
(244090, '3t05A01', NULL, NULL, 241, NULL, NULL, 231126),
(244091, '2hwgA03', NULL, NULL, 346, NULL, NULL, 231126);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(244092, '2bg5C00', NULL, NULL, 324, NULL, NULL, 231126),
(244093, '1zlpA00', NULL, NULL, 291, NULL, NULL, 231126),
(244094, '2bg5A00', NULL, NULL, 324, NULL, NULL, 231126),
(244095, '1m3uA00', NULL, NULL, 264, NULL, NULL, 231126),
(244096, '1vbgA06', NULL, NULL, 342, NULL, NULL, 231126),
(244097, '3b8iC00', NULL, NULL, 287, NULL, NULL, 231126),
(244098, '1kblA04', NULL, NULL, 343, NULL, NULL, 231126),
(244099, '6r62A00', NULL, NULL, 252, NULL, NULL, 231126),
(244100, '3qqwC01', NULL, NULL, 269, NULL, NULL, 231126),
(244101, '4mf4A00', NULL, NULL, 269, NULL, NULL, 231126),
(244102, '5jvjB06', NULL, NULL, 341, NULL, NULL, 231126),
(244103, '1o66B00', NULL, NULL, 258, NULL, NULL, 231126),
(244104, '1xg4D00', NULL, NULL, 295, NULL, NULL, 231126),
(244105, '1o66D00', NULL, NULL, 275, NULL, NULL, 231126),
(244106, '1o68E00', NULL, NULL, 275, NULL, NULL, 231126),
(244107, '6du6A02', NULL, NULL, 240, NULL, NULL, 231126),
(244108, '1o68C00', NULL, NULL, 258, NULL, NULL, 231126),
(244109, '4iqdB00', NULL, NULL, 305, NULL, NULL, 231126),
(244110, '1o68A00', NULL, NULL, 275, NULL, NULL, 231126),
(244111, '3lg3B00', NULL, NULL, 418, NULL, NULL, 231126),
(244112, '1ujqB00', NULL, NULL, 285, NULL, NULL, 231126),
(244113, '3qllA00', NULL, NULL, 236, NULL, NULL, 231126),
(244114, '3vavH00', NULL, NULL, 275, NULL, NULL, 231126),
(244115, '3gg8A02', NULL, NULL, 241, NULL, NULL, 231126),
(244116, '1s2wA00', NULL, NULL, 278, NULL, NULL, 231126),
(244117, '4roqA00', NULL, NULL, 324, NULL, NULL, 231126),
(244118, '3lyeA00', NULL, NULL, 307, NULL, NULL, 231126),
(244119, '1dxeA00', NULL, NULL, 256, NULL, NULL, 231126),
(244120, '5h0iA01', NULL, NULL, 292, NULL, NULL, 231127),
(244121, '1cvrA02', NULL, NULL, 231, NULL, NULL, 231127),
(244122, '3uoaB01', NULL, NULL, 228, NULL, NULL, 231127),
(244123, '3bijB00', NULL, NULL, 285, NULL, NULL, 231127),
(244124, '4hq0A00', NULL, NULL, 240, NULL, NULL, 231127),
(244125, '4jr2A00', NULL, NULL, 250, NULL, NULL, 231127),
(244126, '3sipC00', NULL, NULL, 157, NULL, NULL, 231127),
(244127, '4jj7A00', NULL, NULL, 275, NULL, NULL, 231127),
(244128, '4n6oA00', NULL, NULL, 278, NULL, NULL, 231127),
(244129, '1nw9B00', NULL, NULL, 277, NULL, NULL, 231127),
(244130, '3sirA00', NULL, NULL, 259, NULL, NULL, 231127),
(244131, '4jb8A00', NULL, NULL, 145, NULL, NULL, 231127),
(244132, '3od5A00', NULL, NULL, 278, NULL, NULL, 231127),
(244133, '2dkoA00', NULL, NULL, 146, NULL, NULL, 231127),
(244134, '6f6rA00', NULL, NULL, 180, NULL, NULL, 231127),
(244135, '1m72A00', NULL, NULL, 272, NULL, NULL, 231127),
(244136, '2fqqA01', NULL, NULL, 133, NULL, NULL, 231127),
(244137, '1qtnA00', NULL, NULL, 164, NULL, NULL, 231127),
(244138, '5jftB00', NULL, NULL, 249, NULL, NULL, 231127),
(244139, '4d3xA00', NULL, NULL, 262, NULL, NULL, 231127),
(244140, '1pyoC00', NULL, NULL, 167, NULL, NULL, 231127),
(244141, '3e4cB00', NULL, NULL, 277, NULL, NULL, 231127),
(244142, '2fp3A01', NULL, NULL, 228, NULL, NULL, 231127),
(244143, '4hvaA00', NULL, NULL, 265, NULL, NULL, 231127),
(244144, '3v4oA00', NULL, NULL, 245, NULL, NULL, 231127),
(244145, '3p4uA00', NULL, NULL, 157, NULL, NULL, 231127),
(244146, '4m9rB00', NULL, NULL, 259, NULL, NULL, 231127),
(244147, '4nomA01', NULL, NULL, 283, NULL, NULL, 231127),
(244148, '3h11A00', NULL, NULL, 212, NULL, NULL, 231127),
(244149, '2j32A00', NULL, NULL, 250, NULL, NULL, 231127),
(244150, '2mc5A00', NULL, NULL, 73, NULL, NULL, 231128),
(244151, '5ghrD00', NULL, NULL, 56, NULL, NULL, 231129),
(244152, '3anwA02', NULL, NULL, 60, NULL, NULL, 231129),
(244153, '2e9xB01', NULL, NULL, 66, NULL, NULL, 231129),
(244154, '5ghrB00', NULL, NULL, 55, NULL, NULL, 231129),
(244155, '1aolA00', NULL, NULL, 228, NULL, NULL, 231130),
(244156, '1lcsA00', NULL, NULL, 211, NULL, NULL, 231130),
(244157, '2uvaG13', NULL, NULL, 37, NULL, NULL, 231131),
(244158, '2uv8G13', NULL, NULL, 39, NULL, NULL, 231131),
(244159, '3dkxA01', NULL, NULL, 136, NULL, NULL, 231132),
(244160, '2hdeA01', NULL, NULL, 123, NULL, NULL, 231133),
(244161, '4a90A00', NULL, NULL, 143, NULL, NULL, 231133),
(244162, '4a6qA00', NULL, NULL, 143, NULL, NULL, 231133);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(244163, '4py9A02', NULL, NULL, 128, NULL, NULL, 231134),
(244164, '2zxrA03', NULL, NULL, 116, NULL, NULL, 231134),
(244165, '5ippB02', NULL, NULL, 115, NULL, NULL, 231134),
(244166, '4ls9B02', NULL, NULL, 123, NULL, NULL, 231134),
(244167, '3devA02', NULL, NULL, 120, NULL, NULL, 231134),
(244168, '5f56A03', NULL, NULL, 116, NULL, NULL, 231134),
(244169, '1iipA02', NULL, NULL, 85, NULL, NULL, 231135),
(244170, '2yweA03', NULL, NULL, 82, NULL, NULL, 231136),
(244171, '4zckA01', NULL, NULL, 112, NULL, NULL, 231136),
(244172, '1n0uA04', NULL, NULL, 76, NULL, NULL, 231136),
(244173, '2dy1A03', NULL, NULL, 76, NULL, NULL, 231136),
(244174, '4kiyV03', NULL, NULL, 76, NULL, NULL, 231136),
(244175, '2xexA03', NULL, NULL, 78, NULL, NULL, 231136),
(244176, '3cb4A03', NULL, NULL, 82, NULL, NULL, 231136),
(244177, '6n0iA03', NULL, NULL, 80, NULL, NULL, 231136),
(244178, '2mzwA01', NULL, NULL, 76, NULL, NULL, 231136),
(244179, '3jcmH04', NULL, NULL, 77, NULL, NULL, 231136),
(244180, '4zciA03', NULL, NULL, 89, NULL, NULL, 231136),
(244181, '4fn5A03', NULL, NULL, 79, NULL, NULL, 231136),
(244182, '4qjty03', NULL, NULL, 82, NULL, NULL, 231136),
(244183, '3e3xA01', NULL, NULL, 113, NULL, NULL, 231136),
(244184, '2bm0A03', NULL, NULL, 51, NULL, NULL, 231136),
(244185, '1vx4405', NULL, NULL, 78, NULL, NULL, 231136),
(244186, '2bv3A03', NULL, NULL, 49, NULL, NULL, 231136),
(244187, '6notB03', NULL, NULL, 51, NULL, NULL, 231136),
(244188, '2wriY03', NULL, NULL, 76, NULL, NULL, 231136),
(244189, '3r4iA02', NULL, NULL, 71, NULL, NULL, 231137),
(244190, '6baqB00', NULL, NULL, 210, NULL, NULL, 231138),
(244191, '2obdA02', NULL, NULL, 189, NULL, NULL, 231138),
(244192, '3zpmA00', NULL, NULL, 211, NULL, NULL, 231138),
(244193, '4m4dA02', NULL, NULL, 178, NULL, NULL, 231138),
(244194, '5i7jA00', NULL, NULL, 214, NULL, NULL, 231138),
(244195, '1ewfA01', NULL, NULL, 180, NULL, NULL, 231138),
(244196, '3p57P00', NULL, NULL, 112, NULL, NULL, 231139),
(244197, '1r8uB00', NULL, NULL, 100, NULL, NULL, 231139),
(244198, '3io2A00', NULL, NULL, 114, NULL, NULL, 231139),
(244199, '2mh0B00', NULL, NULL, 92, NULL, NULL, 231139),
(244200, '2ka6A00', NULL, NULL, 92, NULL, NULL, 231139),
(244201, '5hp0A00', NULL, NULL, 122, NULL, NULL, 231139),
(244202, '3t92A00', NULL, NULL, 121, NULL, NULL, 231139),
(244203, '1l3eB00', NULL, NULL, 101, NULL, NULL, 231139),
(244204, '3qr8A02', NULL, NULL, 73, NULL, NULL, 231140),
(244205, '4i8oA04', NULL, NULL, 108, NULL, NULL, 231141),
(244206, '4i8oB04', NULL, NULL, 108, NULL, NULL, 231141),
(244207, '4hbeA00', NULL, NULL, 98, NULL, NULL, 231142),
(244208, '4hboC00', NULL, NULL, 99, NULL, NULL, 231142),
(244209, '3ed4A02', NULL, NULL, 83, NULL, NULL, 231143),
(244210, '2qzuA02', NULL, NULL, 94, NULL, NULL, 231143),
(244211, '1hdhA02', NULL, NULL, 86, NULL, NULL, 231143),
(244212, '1aukA02', NULL, NULL, 101, NULL, NULL, 231143),
(244213, '1fsuA02', NULL, NULL, 121, NULL, NULL, 231143),
(244214, '1p49A03', NULL, NULL, 112, NULL, NULL, 231143),
(244215, '4fdiA02', NULL, NULL, 100, NULL, NULL, 231143),
(244216, '1ozhA03', NULL, NULL, 25, NULL, NULL, 231144),
(244217, '3o6qD01', NULL, NULL, 23, NULL, NULL, 231144),
(244218, '2rh0A02', NULL, NULL, 32, NULL, NULL, 231144),
(244219, '2o01N01', NULL, NULL, 22, NULL, NULL, 231144),
(244220, '2axcA02', NULL, NULL, 33, NULL, NULL, 231144),
(244221, '4fccA01', NULL, NULL, 81, NULL, NULL, 231145),
(244222, '1bgvA03', NULL, NULL, 76, NULL, NULL, 231145),
(244223, '5gudB01', NULL, NULL, 77, NULL, NULL, 231145),
(244224, '1at3A00', NULL, NULL, 231, NULL, NULL, 231146),
(244225, '4p3hA00', NULL, NULL, 193, NULL, NULL, 231146),
(244226, '1wpoB00', NULL, NULL, 256, NULL, NULL, 231146),
(244227, '1jq6A00', NULL, NULL, 230, NULL, NULL, 231146),
(244228, '1o6eA00', NULL, NULL, 235, NULL, NULL, 231146),
(244229, '4v08A00', NULL, NULL, 224, NULL, NULL, 231146),
(244230, '1vzvA00', NULL, NULL, 221, NULL, NULL, 231146),
(244231, '2ychA02', NULL, NULL, 61, NULL, NULL, 231147),
(244232, '5eoxB02', NULL, NULL, 60, NULL, NULL, 231147),
(244233, '1o0sA01', NULL, NULL, 76, NULL, NULL, 231148);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(244234, '2yxlA02', NULL, NULL, 28, NULL, NULL, 231149),
(244235, '1sqgA02', NULL, NULL, 27, NULL, NULL, 231149),
(244236, '2fh0A00', NULL, NULL, 81, NULL, NULL, 231150),
(244237, '2jxnA01', NULL, NULL, 106, NULL, NULL, 231150),
(244238, '2cruA01', NULL, NULL, 77, NULL, NULL, 231150),
(244239, '1eijA00', NULL, NULL, 80, NULL, NULL, 231150),
(244240, '3o2zC02', NULL, NULL, 104, NULL, NULL, 231151),
(244241, '5optm02', NULL, NULL, 123, NULL, NULL, 231151),
(244242, '5o5jC02', NULL, NULL, 103, NULL, NULL, 231151),
(244243, '6az1C02', NULL, NULL, 128, NULL, NULL, 231151),
(244244, '5xxuD02', NULL, NULL, 122, NULL, NULL, 231151),
(244245, '2xzmC02', NULL, NULL, 148, NULL, NULL, 231151),
(244246, '3jamD02', NULL, NULL, 145, NULL, NULL, 231151),
(244247, '5flxD02', NULL, NULL, 129, NULL, NULL, 231151),
(244248, '3u5cD02', NULL, NULL, 148, NULL, NULL, 231151),
(244249, '5mmjc02', NULL, NULL, 100, NULL, NULL, 231151),
(244250, '2vqeC02', NULL, NULL, 101, NULL, NULL, 231151),
(244251, '3j7aD01', NULL, NULL, 96, NULL, NULL, 231151),
(244252, '2vhoC02', NULL, NULL, 101, NULL, NULL, 231151),
(244253, '5xyiD02', NULL, NULL, 123, NULL, NULL, 231151),
(244254, '2h4oD00', NULL, NULL, 76, NULL, NULL, 231152),
(244255, '2h4oC00', NULL, NULL, 76, NULL, NULL, 231152),
(244256, '2h4oB00', NULL, NULL, 76, NULL, NULL, 231152),
(244257, '2h4oA00', NULL, NULL, 76, NULL, NULL, 231152),
(244258, '1lr0A00', NULL, NULL, 129, NULL, NULL, 231153),
(244259, '3qdpA00', NULL, NULL, 88, NULL, NULL, 231153),
(244260, '1tolA02', NULL, NULL, 73, NULL, NULL, 231153),
(244261, '2k9kA00', NULL, NULL, 106, NULL, NULL, 231153),
(244262, '2m2kA00', NULL, NULL, 131, NULL, NULL, 231153),
(244263, '2x9aB00', NULL, NULL, 98, NULL, NULL, 231153),
(244264, '4g7xB00', NULL, NULL, 103, NULL, NULL, 231153),
(244265, '4g2aA01', NULL, NULL, 235, NULL, NULL, 231154),
(244266, '3tgnA01', NULL, NULL, 35, NULL, NULL, 231155),
(244267, '4gi2B01', NULL, NULL, 283, NULL, NULL, 231156),
(244268, '5dp2A01', NULL, NULL, 201, NULL, NULL, 231156),
(244269, '3s2eA01', NULL, NULL, 202, NULL, NULL, 231156),
(244270, '3widA01', NULL, NULL, 186, NULL, NULL, 231156),
(244271, '3hzzA01', NULL, NULL, 299, NULL, NULL, 231156),
(244272, '3pi7A01', NULL, NULL, 202, NULL, NULL, 231156),
(244273, '1pl8A01', NULL, NULL, 217, NULL, NULL, 231156),
(244274, '1vj1A01', NULL, NULL, 181, NULL, NULL, 231156),
(244275, '3jynA01', NULL, NULL, 179, NULL, NULL, 231156),
(244276, '2jhfA01', NULL, NULL, 235, NULL, NULL, 231156),
(244277, '1p0fA01', NULL, NULL, 234, NULL, NULL, 231156),
(244278, '3cosA01', NULL, NULL, 242, NULL, NULL, 231156),
(244279, '3qwbA01', NULL, NULL, 189, NULL, NULL, 231156),
(244280, '5ylnC01', NULL, NULL, 219, NULL, NULL, 231156),
(244281, '3uogA01', NULL, NULL, 197, NULL, NULL, 231156),
(244282, '5o9fC01', NULL, NULL, 215, NULL, NULL, 231156),
(244283, '1kolA01', NULL, NULL, 231, NULL, NULL, 231156),
(244284, '4c4oB01', NULL, NULL, 206, NULL, NULL, 231156),
(244285, '3iupA01', NULL, NULL, 191, NULL, NULL, 231156),
(244286, '5zxnA01', NULL, NULL, 158, NULL, NULL, 231156),
(244287, '3ukoA01', NULL, NULL, 239, NULL, NULL, 231156),
(244288, '5vm2A01', NULL, NULL, 208, NULL, NULL, 231156),
(244289, '5k1sB00', NULL, NULL, 346, NULL, NULL, 231156),
(244290, '2b5wA01', NULL, NULL, 224, NULL, NULL, 231156),
(244291, '3gazA01', NULL, NULL, 175, NULL, NULL, 231156),
(244292, '6n7lC01', NULL, NULL, 215, NULL, NULL, 231156),
(244293, '1h2bB01', NULL, NULL, 219, NULL, NULL, 231156),
(244294, '4idcA01', NULL, NULL, 217, NULL, NULL, 231156),
(244295, '2j8zA01', NULL, NULL, 190, NULL, NULL, 231156),
(244296, '2dphA01', NULL, NULL, 232, NULL, NULL, 231156),
(244297, '1cdoA01', NULL, NULL, 236, NULL, NULL, 231156),
(244298, '4a27A01', NULL, NULL, 161, NULL, NULL, 231156),
(244299, '2vcyA01', NULL, NULL, 192, NULL, NULL, 231156),
(244300, '4uejA01', NULL, NULL, 208, NULL, NULL, 231156),
(244301, '3fpcA01', NULL, NULL, 221, NULL, NULL, 231156),
(244302, '4eezB01', NULL, NULL, 208, NULL, NULL, 231156),
(244303, '5yatA01', NULL, NULL, 208, NULL, NULL, 231156),
(244304, '1piwA01', NULL, NULL, 223, NULL, NULL, 231156);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(244305, '5fi3A01', NULL, NULL, 200, NULL, NULL, 231156),
(244306, '4oh1A01', NULL, NULL, 214, NULL, NULL, 231156),
(244307, '1u3wA01', NULL, NULL, 235, NULL, NULL, 231156),
(244308, '4gkvA01', NULL, NULL, 198, NULL, NULL, 231156),
(244309, '2fzwA01', NULL, NULL, 234, NULL, NULL, 231156),
(244310, '1v3vA01', NULL, NULL, 155, NULL, NULL, 231156),
(244311, '4jxkA01', NULL, NULL, 162, NULL, NULL, 231156),
(244312, '3nx4A01', NULL, NULL, 157, NULL, NULL, 231156),
(244313, '4oaqA01', NULL, NULL, 226, NULL, NULL, 231156),
(244314, '2j3hB01', NULL, NULL, 168, NULL, NULL, 231156),
(244315, '2vn8A01', NULL, NULL, 175, NULL, NULL, 231156),
(244316, '1e3jA02', NULL, NULL, 209, NULL, NULL, 231156),
(244317, '5gxeA01', NULL, NULL, 162, NULL, NULL, 231156),
(244318, '1yqdA01', NULL, NULL, 209, NULL, NULL, 231156),
(244319, '3gmsA01', NULL, NULL, 214, NULL, NULL, 231156),
(244320, '1u3tA01', NULL, NULL, 235, NULL, NULL, 231156),
(244321, '2vz8A07', NULL, NULL, 359, NULL, NULL, 231156),
(244322, '1o89A01', NULL, NULL, 157, NULL, NULL, 231156),
(244323, '4ej6A01', NULL, NULL, 211, NULL, NULL, 231156),
(244324, '2zb3A01', NULL, NULL, 171, NULL, NULL, 231156),
(244325, '3fbgA01', NULL, NULL, 199, NULL, NULL, 231156),
(244326, '2h6eA01', NULL, NULL, 201, NULL, NULL, 231156),
(244327, '4jlwA01', NULL, NULL, 232, NULL, NULL, 231156),
(244328, '2dfvA01', NULL, NULL, 212, NULL, NULL, 231156),
(244329, '1rjwA01', NULL, NULL, 202, NULL, NULL, 231156),
(244330, '4nh4A01', NULL, NULL, 181, NULL, NULL, 231156),
(244331, '5h81B01', NULL, NULL, 207, NULL, NULL, 231156),
(244332, '3twoB01', NULL, NULL, 195, NULL, NULL, 231156),
(244333, '5h83A01', NULL, NULL, 203, NULL, NULL, 231156),
(244334, '5z0cA01', NULL, NULL, 217, NULL, NULL, 231156),
(244335, '1u3uA01', NULL, NULL, 235, NULL, NULL, 231156),
(244336, '1jvbA01', NULL, NULL, 206, NULL, NULL, 231156),
(244337, '3ip1A01', NULL, NULL, 242, NULL, NULL, 231156),
(244338, '5zxuA01', NULL, NULL, 155, NULL, NULL, 231156),
(244339, '2zb4A01', NULL, NULL, 175, NULL, NULL, 231156),
(244340, '4dl9A01', NULL, NULL, 240, NULL, NULL, 231156),
(244341, '4eyeA01', NULL, NULL, 152, NULL, NULL, 231156),
(244342, '2ouiA01', NULL, NULL, 229, NULL, NULL, 231156),
(244343, '3gohA01', NULL, NULL, 189, NULL, NULL, 231156),
(244344, '2y05A01', NULL, NULL, 150, NULL, NULL, 231156),
(244345, '3krtC01', NULL, NULL, 309, NULL, NULL, 231156),
(244346, '4ilkA01', NULL, NULL, 203, NULL, NULL, 231156),
(244347, '3fplA01', NULL, NULL, 213, NULL, NULL, 231156),
(244348, '5tnxA01', NULL, NULL, 246, NULL, NULL, 231156),
(244349, '4jbgA01', NULL, NULL, 199, NULL, NULL, 231156),
(244350, '4w6zA01', NULL, NULL, 205, NULL, NULL, 231156),
(244351, '5dp1A01', NULL, NULL, 192, NULL, NULL, 231156),
(244352, '3gqvA01', NULL, NULL, 178, NULL, NULL, 231156),
(244353, '5vktA01', NULL, NULL, 205, NULL, NULL, 231156),
(244354, '2c0cA01', NULL, NULL, 183, NULL, NULL, 231156),
(244355, '5dovB01', NULL, NULL, 197, NULL, NULL, 231156),
(244356, '4hfmA01', NULL, NULL, 174, NULL, NULL, 231156),
(244357, '1yb5A01', NULL, NULL, 156, NULL, NULL, 231156),
(244358, '1n9gA01', NULL, NULL, 207, NULL, NULL, 231156),
(244359, '3qe3A01', NULL, NULL, 216, NULL, NULL, 231156),
(244360, '3tqhA01', NULL, NULL, 188, NULL, NULL, 231156),
(244361, '1uufA01', NULL, NULL, 191, NULL, NULL, 231156),
(244362, '6eowA01', NULL, NULL, 164, NULL, NULL, 231156),
(244363, '2eerA01', NULL, NULL, 210, NULL, NULL, 231156),
(244364, '2eihA01', NULL, NULL, 200, NULL, NULL, 231156),
(244365, '3slkA02', NULL, NULL, 327, NULL, NULL, 231156),
(244366, '1f8fA01', NULL, NULL, 234, NULL, NULL, 231156),
(244367, '4b7cA01', NULL, NULL, 159, NULL, NULL, 231156),
(244368, '4rqtA01', NULL, NULL, 236, NULL, NULL, 231156),
(244369, '5a3vB01', NULL, NULL, 184, NULL, NULL, 231156),
(244370, '2cdcA01', NULL, NULL, 176, NULL, NULL, 231156),
(244371, '4dvjB01', NULL, NULL, 199, NULL, NULL, 231156),
(244372, '4cpdC01', NULL, NULL, 212, NULL, NULL, 231156),
(244373, '3m6iA01', NULL, NULL, 222, NULL, NULL, 231156),
(244374, '1d1tA01', NULL, NULL, 234, NULL, NULL, 231156),
(244375, '4j6fA01', NULL, NULL, 203, NULL, NULL, 231156);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(244376, '3gfbA01', NULL, NULL, 215, NULL, NULL, 231156),
(244377, '4dupA01', NULL, NULL, 187, NULL, NULL, 231156),
(244378, '1lluA01', NULL, NULL, 204, NULL, NULL, 231156),
(244379, '1tt7A01', NULL, NULL, 164, NULL, NULL, 231156),
(244380, '3meqA01', NULL, NULL, 202, NULL, NULL, 231156),
(244381, '1zsyA01', NULL, NULL, 180, NULL, NULL, 231156),
(244382, '2cf5A01', NULL, NULL, 200, NULL, NULL, 231156),
(244383, '2dq4A01', NULL, NULL, 209, NULL, NULL, 231156),
(244384, '1vj0B01', NULL, NULL, 233, NULL, NULL, 231156),
(244385, '5kiaA01', NULL, NULL, 217, NULL, NULL, 231156),
(244386, '4rvuA01', NULL, NULL, 184, NULL, NULL, 231156),
(244387, '4w82A01', NULL, NULL, 163, NULL, NULL, 231156),
(244388, '1wlyA01', NULL, NULL, 186, NULL, NULL, 231156),
(244389, '1xa0A01', NULL, NULL, 164, NULL, NULL, 231156),
(244390, '1qorA01', NULL, NULL, 181, NULL, NULL, 231156),
(244391, '1e3iB01', NULL, NULL, 239, NULL, NULL, 231156),
(244392, '4a0sC01', NULL, NULL, 300, NULL, NULL, 231156),
(244393, '1iz0A01', NULL, NULL, 141, NULL, NULL, 231156),
(244394, '4z6kA01', NULL, NULL, 208, NULL, NULL, 231156),
(244395, '2dhrA03', NULL, NULL, 196, NULL, NULL, 231157),
(244396, '2ce7C03', NULL, NULL, 211, NULL, NULL, 231157),
(244397, '2di4A00', NULL, NULL, 211, NULL, NULL, 231157),
(244398, '2mrlA00', NULL, NULL, 72, NULL, NULL, 231158),
(244399, '1wteB01', NULL, NULL, 147, NULL, NULL, 231159),
(244400, '3c19A01', NULL, NULL, 100, NULL, NULL, 231160),
(244401, '3drxB03', NULL, NULL, 57, NULL, NULL, 231161),
(244402, '4y5tB00', NULL, NULL, 293, NULL, NULL, 231162),
(244403, '5ep9C00', NULL, NULL, 256, NULL, NULL, 231162),
(244404, '3bvcA01', NULL, NULL, 203, NULL, NULL, 231162),
(244405, '5zm4B00', NULL, NULL, 286, NULL, NULL, 231162),
(244406, '4bqyA00', NULL, NULL, 252, NULL, NULL, 231162),
(244407, '3pl0B00', NULL, NULL, 254, NULL, NULL, 231162),
(244408, '3emrA00', NULL, NULL, 310, NULL, NULL, 231162),
(244409, '2a1xA00', NULL, NULL, 308, NULL, NULL, 231162),
(244410, '4xaaA00', NULL, NULL, 223, NULL, NULL, 231162),
(244411, '3gjbA00', NULL, NULL, 275, NULL, NULL, 231162),
(244412, '4nhxA01', NULL, NULL, 222, NULL, NULL, 231162),
(244413, '4j25F00', NULL, NULL, 200, NULL, NULL, 231162),
(244414, '2fctB00', NULL, NULL, 313, NULL, NULL, 231162),
(244415, '4nhxA02', NULL, NULL, 239, NULL, NULL, 231162),
(244416, '5oa4A00', NULL, NULL, 308, NULL, NULL, 231162),
(244417, '4naoA00', NULL, NULL, 305, NULL, NULL, 231162),
(244418, '3nnfA00', NULL, NULL, 320, NULL, NULL, 231162),
(244419, '2rdqA00', NULL, NULL, 269, NULL, NULL, 231162),
(244420, '5m0tB00', NULL, NULL, 294, NULL, NULL, 231162),
(244421, '3w20B00', NULL, NULL, 273, NULL, NULL, 231162),
(244422, '5v1bA00', NULL, NULL, 240, NULL, NULL, 231162),
(244423, '4xcbD00', NULL, NULL, 261, NULL, NULL, 231162),
(244424, '4mhrA00', NULL, NULL, 314, NULL, NULL, 231162),
(244425, '3itqA01', NULL, NULL, 193, NULL, NULL, 231162),
(244426, '5c5uB00', NULL, NULL, 210, NULL, NULL, 231162),
(244427, '3dkqA01', NULL, NULL, 195, NULL, NULL, 231162),
(244428, '2rg4A01', NULL, NULL, 203, NULL, NULL, 231162),
(244429, '4xabA00', NULL, NULL, 252, NULL, NULL, 231162),
(244430, '2hbtA00', NULL, NULL, 247, NULL, NULL, 231162),
(244431, '3kt7A01', NULL, NULL, 250, NULL, NULL, 231162),
(244432, '2jigA01', NULL, NULL, 206, NULL, NULL, 231162),
(244433, '5epaF00', NULL, NULL, 263, NULL, NULL, 231162),
(244434, '2opwA00', NULL, NULL, 291, NULL, NULL, 231162),
(244435, '3kp1E02', NULL, NULL, 77, NULL, NULL, 231163),
(244436, '2yskA00', NULL, NULL, 145, NULL, NULL, 231164),
(244437, '3qxbA00', NULL, NULL, 316, NULL, NULL, 231165),
(244438, '2j6vA00', NULL, NULL, 283, NULL, NULL, 231165),
(244439, '3p14D00', NULL, NULL, 424, NULL, NULL, 231165),
(244440, '4xkmA00', NULL, NULL, 435, NULL, NULL, 231165),
(244441, '3dx5A00', NULL, NULL, 286, NULL, NULL, 231165),
(244442, '1ximA00', NULL, NULL, 393, NULL, NULL, 231165),
(244443, '3tvaA00', NULL, NULL, 290, NULL, NULL, 231165),
(244444, '3cqjA00', NULL, NULL, 295, NULL, NULL, 231165),
(244445, '1xlaA00', NULL, NULL, 394, NULL, NULL, 231165),
(244446, '1bxcA00', NULL, NULL, 387, NULL, NULL, 231165);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(244447, '4hnoA00', NULL, NULL, 288, NULL, NULL, 231165),
(244448, '4gqbA01', NULL, NULL, 299, NULL, NULL, 231165),
(244449, '2zdsB00', NULL, NULL, 323, NULL, NULL, 231165),
(244450, '1a0dA00', NULL, NULL, 440, NULL, NULL, 231165),
(244451, '1qt1A00', NULL, NULL, 387, NULL, NULL, 231165),
(244452, '5avhA00', NULL, NULL, 386, NULL, NULL, 231165),
(244453, '3ktcA00', NULL, NULL, 333, NULL, NULL, 231165),
(244454, '3bdkA00', NULL, NULL, 368, NULL, NULL, 231165),
(244455, '3wqoA00', NULL, NULL, 293, NULL, NULL, 231165),
(244456, '3ngfB00', NULL, NULL, 269, NULL, NULL, 231165),
(244457, '3l23A00', NULL, NULL, 303, NULL, NULL, 231165),
(244458, '2q02A00', NULL, NULL, 272, NULL, NULL, 231165),
(244459, '4hhlB00', NULL, NULL, 388, NULL, NULL, 231165),
(244460, '3bwwA01', NULL, NULL, 265, NULL, NULL, 231165),
(244461, '5nhmB00', NULL, NULL, 437, NULL, NULL, 231165),
(244462, '1bxbA00', NULL, NULL, 387, NULL, NULL, 231165),
(244463, '4eacC01', NULL, NULL, 263, NULL, NULL, 231165),
(244464, '1a0eA00', NULL, NULL, 443, NULL, NULL, 231165),
(244465, '3m0mD00', NULL, NULL, 421, NULL, NULL, 231165),
(244466, '3ua4A01', NULL, NULL, 285, NULL, NULL, 231165),
(244467, '3kwsA00', NULL, NULL, 265, NULL, NULL, 231165),
(244468, '1yx1B01', NULL, NULL, 162, NULL, NULL, 231165),
(244469, '5zfsB00', NULL, NULL, 297, NULL, NULL, 231165),
(244470, '3u0hA00', NULL, NULL, 281, NULL, NULL, 231165),
(244471, '1qtwA00', NULL, NULL, 285, NULL, NULL, 231165),
(244472, '4ovxA00', NULL, NULL, 277, NULL, NULL, 231165),
(244473, '4k3zA00', NULL, NULL, 310, NULL, NULL, 231165),
(244474, '3aalA00', NULL, NULL, 303, NULL, NULL, 231165),
(244475, '1tz9A00', NULL, NULL, 367, NULL, NULL, 231165),
(244476, '3tc3B00', NULL, NULL, 290, NULL, NULL, 231165),
(244477, '1xp3A00', NULL, NULL, 307, NULL, NULL, 231165),
(244478, '1k77A00', NULL, NULL, 260, NULL, NULL, 231165),
(244479, '2g0wB00', NULL, NULL, 296, NULL, NULL, 231165),
(244480, '4kw2A00', NULL, NULL, 246, NULL, NULL, 231165),
(244481, '3cnyA00', NULL, NULL, 301, NULL, NULL, 231165),
(244482, '4xslC00', NULL, NULL, 300, NULL, NULL, 231165),
(244483, '5b7yA00', NULL, NULL, 270, NULL, NULL, 231165),
(244484, '3obeB00', NULL, NULL, 305, NULL, NULL, 231165),
(244485, '3lmzA00', NULL, NULL, 257, NULL, NULL, 231165),
(244486, '5tnvA00', NULL, NULL, 306, NULL, NULL, 231165),
(244487, '3vniA00', NULL, NULL, 294, NULL, NULL, 231165),
(244488, '4q7iA00', NULL, NULL, 298, NULL, NULL, 231165),
(244489, '3vylA00', NULL, NULL, 297, NULL, NULL, 231165),
(244490, '1i60A00', NULL, NULL, 278, NULL, NULL, 231165),
(244491, '4g56A01', NULL, NULL, 287, NULL, NULL, 231165),
(244492, '3p6lA00', NULL, NULL, 262, NULL, NULL, 231165),
(244493, '3aamA00', NULL, NULL, 270, NULL, NULL, 231165),
(244494, '2hk0A00', NULL, NULL, 288, NULL, NULL, 231165),
(244495, '3qc0A00', NULL, NULL, 275, NULL, NULL, 231165),
(244496, '1d8wC00', NULL, NULL, 426, NULL, NULL, 231165),
(244497, '2qw5A00', NULL, NULL, 335, NULL, NULL, 231165),
(244498, '1a0cA00', NULL, NULL, 438, NULL, NULL, 231165),
(244499, '3ayvD00', NULL, NULL, 254, NULL, NULL, 231165),
(244500, '1muwA00', NULL, NULL, 386, NULL, NULL, 231165),
(244501, '1yx1A00', NULL, NULL, 264, NULL, NULL, 231165),
(244502, '2bnmA01', NULL, NULL, 78, NULL, NULL, 231166),
(244503, '2a6cB00', NULL, NULL, 83, NULL, NULL, 231166),
(244504, '2kpjA01', NULL, NULL, 70, NULL, NULL, 231166),
(244505, '3fmyA00', NULL, NULL, 73, NULL, NULL, 231166),
(244506, '3mlfE00', NULL, NULL, 88, NULL, NULL, 231166),
(244507, '2b5aA00', NULL, NULL, 77, NULL, NULL, 231166),
(244508, '1neqA00', NULL, NULL, 74, NULL, NULL, 231166),
(244509, '3g7dA04', NULL, NULL, 91, NULL, NULL, 231166),
(244510, '2xcjA00', NULL, NULL, 99, NULL, NULL, 231166),
(244511, '3r1fQ00', NULL, NULL, 135, NULL, NULL, 231166),
(244512, '3g7dA01', NULL, NULL, 104, NULL, NULL, 231166),
(244513, '2ictA01', NULL, NULL, 82, NULL, NULL, 231166),
(244514, '3qq6A00', NULL, NULL, 78, NULL, NULL, 231166),
(244515, '3kjxD01', NULL, NULL, 68, NULL, NULL, 231166),
(244516, '5wc9A01', NULL, NULL, 90, NULL, NULL, 231166),
(244517, '5d4z401', NULL, NULL, 70, NULL, NULL, 231166);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(244518, '2h8rB01', NULL, NULL, 98, NULL, NULL, 231166),
(244519, '4y42A01', NULL, NULL, 88, NULL, NULL, 231166),
(244520, '2mezA00', NULL, NULL, 106, NULL, NULL, 231166),
(244521, '1r69A00', NULL, NULL, 69, NULL, NULL, 231166),
(244522, '1uxdA00', NULL, NULL, 65, NULL, NULL, 231166),
(244523, '1au7A01', NULL, NULL, 72, NULL, NULL, 231166),
(244524, '5woqA00', NULL, NULL, 89, NULL, NULL, 231166),
(244525, '3bs3A00', NULL, NULL, 76, NULL, NULL, 231166),
(244526, '3h5tA01', NULL, NULL, 53, NULL, NULL, 231166),
(244527, '1sq8A00', NULL, NULL, 64, NULL, NULL, 231166),
(244528, '1wh6A01', NULL, NULL, 85, NULL, NULL, 231166),
(244529, '2a6cA00', NULL, NULL, 83, NULL, NULL, 231166),
(244530, '2ppxA00', NULL, NULL, 67, NULL, NULL, 231166),
(244531, '3l1pA01', NULL, NULL, 67, NULL, NULL, 231166),
(244532, '4z5hA00', NULL, NULL, 72, NULL, NULL, 231166),
(244533, '3pxpA01', NULL, NULL, 93, NULL, NULL, 231166),
(244534, '2pijB00', NULL, NULL, 67, NULL, NULL, 231166),
(244535, '4pu7A00', NULL, NULL, 82, NULL, NULL, 231166),
(244536, '3mlfB00', NULL, NULL, 95, NULL, NULL, 231166),
(244537, '5k98B00', NULL, NULL, 91, NULL, NULL, 231166),
(244538, '1zs4C00', NULL, NULL, 83, NULL, NULL, 231166),
(244539, '2ef8B00', NULL, NULL, 84, NULL, NULL, 231166),
(244540, '2ebyA01', NULL, NULL, 85, NULL, NULL, 231166),
(244541, '3f51C00', NULL, NULL, 95, NULL, NULL, 231166),
(244542, '2l8nA00', NULL, NULL, 67, NULL, NULL, 231166),
(244543, '4gqmA00', NULL, NULL, 118, NULL, NULL, 231166),
(244544, '2ewtA00', NULL, NULL, 71, NULL, NULL, 231166),
(244545, '2o38A01', NULL, NULL, 65, NULL, NULL, 231166),
(244546, '2hinA00', NULL, NULL, 71, NULL, NULL, 231166),
(244547, '4ybaA00', NULL, NULL, 81, NULL, NULL, 231166),
(244548, '2mqkA00', NULL, NULL, 65, NULL, NULL, 231166),
(244549, '3b7hA00', NULL, NULL, 78, NULL, NULL, 231166),
(244550, '1b0nA00', NULL, NULL, 111, NULL, NULL, 231166),
(244551, '2xi8A00', NULL, NULL, 66, NULL, NULL, 231166),
(244552, '5w8yA00', NULL, NULL, 73, NULL, NULL, 231166),
(244553, '3qwgB00', NULL, NULL, 93, NULL, NULL, 231166),
(244554, '1wh8A01', NULL, NULL, 89, NULL, NULL, 231166),
(244555, '3zkcA00', NULL, NULL, 62, NULL, NULL, 231166),
(244556, '3fymA00', NULL, NULL, 83, NULL, NULL, 231166),
(244557, '1jftA01', NULL, NULL, 57, NULL, NULL, 231166),
(244558, '2wusS00', NULL, NULL, 84, NULL, NULL, 231166),
(244559, '3f52A00', NULL, NULL, 77, NULL, NULL, 231166),
(244560, '4jcyA00', NULL, NULL, 98, NULL, NULL, 231166),
(244561, '6f8hC00', NULL, NULL, 105, NULL, NULL, 231166),
(244562, '1x2lA01', NULL, NULL, 85, NULL, NULL, 231166),
(244563, '3d1nP00', NULL, NULL, 82, NULL, NULL, 231166),
(244564, '3o9xA02', NULL, NULL, 73, NULL, NULL, 231166),
(244565, '2hsgA01', NULL, NULL, 60, NULL, NULL, 231166),
(244566, '2xsdC01', NULL, NULL, 71, NULL, NULL, 231166),
(244567, '3vk0B00', NULL, NULL, 91, NULL, NULL, 231166),
(244568, '2bjcA00', NULL, NULL, 62, NULL, NULL, 231166),
(244569, '1rioB00', NULL, NULL, 98, NULL, NULL, 231166),
(244570, '3kz3A00', NULL, NULL, 80, NULL, NULL, 231166),
(244571, '3trbA00', NULL, NULL, 104, NULL, NULL, 231166),
(244572, '3r1fO00', NULL, NULL, 95, NULL, NULL, 231166),
(244573, '2csfA01', NULL, NULL, 79, NULL, NULL, 231166),
(244574, '2icpA01', NULL, NULL, 82, NULL, NULL, 231166),
(244575, '2ebyB00', NULL, NULL, 113, NULL, NULL, 231166),
(244576, '3bd1B00', NULL, NULL, 63, NULL, NULL, 231166),
(244577, '3cecA00', NULL, NULL, 104, NULL, NULL, 231166),
(244578, '2jvlA01', NULL, NULL, 85, NULL, NULL, 231166),
(244579, '1ic8A01', NULL, NULL, 96, NULL, NULL, 231166),
(244580, '1y9qA01', NULL, NULL, 88, NULL, NULL, 231166),
(244581, '3omtA00', NULL, NULL, 73, NULL, NULL, 231166),
(244582, '1efaA01', NULL, NULL, 60, NULL, NULL, 231166),
(244583, '1wizA01', NULL, NULL, 79, NULL, NULL, 231166),
(244584, '3f6wE00', NULL, NULL, 83, NULL, NULL, 231166),
(244585, '2r1jL00', NULL, NULL, 68, NULL, NULL, 231166),
(244586, '2croA00', NULL, NULL, 71, NULL, NULL, 231166),
(244587, '2o4aA00', NULL, NULL, 93, NULL, NULL, 231166),
(244588, '6cf1B01', NULL, NULL, 77, NULL, NULL, 231166),
(244589, '1x57A00', NULL, NULL, 91, NULL, NULL, 231166);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(244590, '2ofyA01', NULL, NULL, 70, NULL, NULL, 231166),
(244591, '3ivpD01', NULL, NULL, 76, NULL, NULL, 231166),
(244592, '1lmb300', NULL, NULL, 92, NULL, NULL, 231166),
(244593, '4o8bA00', NULL, NULL, 101, NULL, NULL, 231166),
(244594, '3eusB00', NULL, NULL, 86, NULL, NULL, 231166),
(244595, '3bd1A00', NULL, NULL, 79, NULL, NULL, 231166),
(244596, '5w8zA00', NULL, NULL, 70, NULL, NULL, 231166),
(244597, '2fjrA01', NULL, NULL, 76, NULL, NULL, 231166),
(244598, '2awiA01', NULL, NULL, 67, NULL, NULL, 231166),
(244599, '4ghjB00', NULL, NULL, 76, NULL, NULL, 231166),
(244600, '3kxaA02', NULL, NULL, 66, NULL, NULL, 231166),
(244601, '2l49B01', NULL, NULL, 53, NULL, NULL, 231166),
(244602, '1rzsA00', NULL, NULL, 61, NULL, NULL, 231166),
(244603, '5a7lA00', NULL, NULL, 80, NULL, NULL, 231166),
(244604, '3zhiA00', NULL, NULL, 83, NULL, NULL, 231166),
(244605, '4i6rA00', NULL, NULL, 82, NULL, NULL, 231166),
(244606, '1dw9A01', NULL, NULL, 88, NULL, NULL, 231166),
(244607, '3op9A01', NULL, NULL, 73, NULL, NULL, 231166),
(244608, '2d5vA01', NULL, NULL, 79, NULL, NULL, 231166),
(244609, '2auwB02', NULL, NULL, 83, NULL, NULL, 231166),
(244610, '3u3wA01', NULL, NULL, 71, NULL, NULL, 231166),
(244611, '3oqmA01', NULL, NULL, 60, NULL, NULL, 231166),
(244612, '1e3oC01', NULL, NULL, 71, NULL, NULL, 231166),
(244613, '1y7yA00', NULL, NULL, 74, NULL, NULL, 231166),
(244614, '3frnA03', NULL, NULL, 70, NULL, NULL, 231167),
(244615, '3teeA02', NULL, NULL, 82, NULL, NULL, 231167),
(244616, '3vkiA02', NULL, NULL, 60, NULL, NULL, 231167),
(244617, '2m7oA00', NULL, NULL, 70, NULL, NULL, 231168),
(244618, '6dftF00', NULL, NULL, 342, NULL, NULL, 231169),
(244619, '1rozB00', NULL, NULL, 342, NULL, NULL, 231169),
(244620, '4p63A00', NULL, NULL, 342, NULL, NULL, 231169),
(244621, '3ph0C00', NULL, NULL, 61, NULL, NULL, 231170),
(244622, '5nnpA01', NULL, NULL, 500, NULL, NULL, 231170),
(244623, '4e6hA00', NULL, NULL, 555, NULL, NULL, 231170),
(244624, '4kvmA01', NULL, NULL, 506, NULL, NULL, 231170),
(244625, '3pieC01', NULL, NULL, 284, NULL, NULL, 231171),
(244626, '5e1vB00', NULL, NULL, 274, NULL, NULL, 231172),
(244627, '3kg7C00', NULL, NULL, 293, NULL, NULL, 231172),
(244628, '3kg6B00', NULL, NULL, 285, NULL, NULL, 231172),
(244629, '5o16B00', NULL, NULL, 293, NULL, NULL, 231172),
(244630, '2vz8A04', NULL, NULL, 254, NULL, NULL, 231172),
(244631, '4ln9A00', NULL, NULL, 299, NULL, NULL, 231172),
(244632, '3el6A00', NULL, NULL, 288, NULL, NULL, 231172),
(244633, '5kbzB00', NULL, NULL, 332, NULL, NULL, 231172),
(244634, '5tz5A00', NULL, NULL, 296, NULL, NULL, 231172),
(244635, '5njiA00', NULL, NULL, 296, NULL, NULL, 231172),
(244636, '4u3vA00', NULL, NULL, 263, NULL, NULL, 231172),
(244637, '5bp3B00', NULL, NULL, 305, NULL, NULL, 231172),
(244638, '5o15B00', NULL, NULL, 294, NULL, NULL, 231172),
(244639, '4kc5C03', NULL, NULL, 306, NULL, NULL, 231172),
(244640, '5kkuD00', NULL, NULL, 300, NULL, NULL, 231172),
(244641, '3do9A01', NULL, NULL, 125, NULL, NULL, 231173),
(244642, '4k4hA01', NULL, NULL, 88, NULL, NULL, 231174),
(244643, '5vzaA01', NULL, NULL, 103, NULL, NULL, 231174),
(244644, '4i2aA01', NULL, NULL, 94, NULL, NULL, 231174),
(244645, '2kp7A01', NULL, NULL, 74, NULL, NULL, 231174),
(244646, '4kliA01', NULL, NULL, 91, NULL, NULL, 231174),
(244647, '2w9mB01', NULL, NULL, 91, NULL, NULL, 231174),
(244648, '2ihmA01', NULL, NULL, 94, NULL, NULL, 231174),
(244649, '1bpeA01', NULL, NULL, 91, NULL, NULL, 231174),
(244650, '3v7jA01', NULL, NULL, 96, NULL, NULL, 231174),
(244651, '2bcqA01', NULL, NULL, 91, NULL, NULL, 231174),
(244652, '3b0xA01', NULL, NULL, 87, NULL, NULL, 231174),
(244653, '6h5hA00', NULL, NULL, 71, NULL, NULL, 231174),
(244654, '3zs6A02', NULL, NULL, 122, NULL, NULL, 231175),
(244655, '1jetA02', NULL, NULL, 124, NULL, NULL, 231175),
(244656, '4qflA02', NULL, NULL, 171, NULL, NULL, 231175),
(244657, '1xocA02', NULL, NULL, 120, NULL, NULL, 231175),
(244658, '2o7iA02', NULL, NULL, 164, NULL, NULL, 231175),
(244659, '3tchA02', NULL, NULL, 124, NULL, NULL, 231175),
(244660, '6npoA02', NULL, NULL, 123, NULL, NULL, 231175);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(244661, '2d5wA02', NULL, NULL, 117, NULL, NULL, 231175),
(244662, '4fajA02', NULL, NULL, 124, NULL, NULL, 231175),
(244663, '6dquA02', NULL, NULL, 125, NULL, NULL, 231175),
(244664, '3tpaA02', NULL, NULL, 169, NULL, NULL, 231175),
(244665, '2grvA02', NULL, NULL, 113, NULL, NULL, 231175),
(244666, '1uqwA02', NULL, NULL, 149, NULL, NULL, 231175),
(244667, '5kztA02', NULL, NULL, 124, NULL, NULL, 231175),
(244668, '4oevA02', NULL, NULL, 115, NULL, NULL, 231175),
(244669, '3m8uA02', NULL, NULL, 169, NULL, NULL, 231175),
(244670, '2z23A02', NULL, NULL, 124, NULL, NULL, 231175),
(244671, '6i3gA02', NULL, NULL, 118, NULL, NULL, 231175),
(244672, '5isuA02', NULL, NULL, 117, NULL, NULL, 231175),
(244673, '4pfyA02', NULL, NULL, 147, NULL, NULL, 231175),
(244674, '5f1qA02', NULL, NULL, 169, NULL, NULL, 231175),
(244675, '5yqwA02', NULL, NULL, 107, NULL, NULL, 231175),
(244676, '5hm4B02', NULL, NULL, 147, NULL, NULL, 231175),
(244677, '4tozA02', NULL, NULL, 124, NULL, NULL, 231175),
(244678, '6hlxA02', NULL, NULL, 148, NULL, NULL, 231175),
(244679, '1dpeA01', NULL, NULL, 169, NULL, NULL, 231175),
(244680, '4ze8A02', NULL, NULL, 118, NULL, NULL, 231175),
(244681, '1zu0A02', NULL, NULL, 107, NULL, NULL, 231175),
(244682, '4gl8A02', NULL, NULL, 134, NULL, NULL, 231175),
(244683, '3gg2A02', NULL, NULL, 32, NULL, NULL, 231176),
(244684, '2n9yB00', NULL, NULL, 43, NULL, NULL, 231176),
(244685, '3plnA02', NULL, NULL, 32, NULL, NULL, 231176),
(244686, '3tguD02', NULL, NULL, 45, NULL, NULL, 231176),
(244687, '1ppjD01', NULL, NULL, 44, NULL, NULL, 231176),
(244688, '1zrtD02', NULL, NULL, 39, NULL, NULL, 231176),
(244689, '2qjpB02', NULL, NULL, 35, NULL, NULL, 231176),
(244690, '2jwaA00', NULL, NULL, 44, NULL, NULL, 231176),
(244691, '2y0cA02', NULL, NULL, 32, NULL, NULL, 231176),
(244692, '3vmaA01', NULL, NULL, 25, NULL, NULL, 231176),
(244693, '2o3jA02', NULL, NULL, 32, NULL, NULL, 231176),
(244694, '2qjyB02', NULL, NULL, 48, NULL, NULL, 231176),
(244695, '3gw6A04', NULL, NULL, 30, NULL, NULL, 231176),
(244696, '5xteH02', NULL, NULL, 45, NULL, NULL, 231176),
(244697, '3cx5D02', NULL, NULL, 48, NULL, NULL, 231176),
(244698, '4a7pA02', NULL, NULL, 32, NULL, NULL, 231176),
(244699, '2k9jB00', NULL, NULL, 43, NULL, NULL, 231176),
(244700, '2q3eA02', NULL, NULL, 32, NULL, NULL, 231176),
(244701, '5hlaA01', NULL, NULL, 39, NULL, NULL, 231176),
(244702, '2yiuB02', NULL, NULL, 41, NULL, NULL, 231176),
(244703, '2kncB00', NULL, NULL, 79, NULL, NULL, 231176),
(244704, '2gefA02', NULL, NULL, 75, NULL, NULL, 231177),
(244705, '2zyrB03', NULL, NULL, 153, NULL, NULL, 231178),
(244706, '3hwcA01', NULL, NULL, 147, NULL, NULL, 231179),
(244707, '1u8vA01', NULL, NULL, 143, NULL, NULL, 231179),
(244708, '2yykA01', NULL, NULL, 138, NULL, NULL, 231179),
(244709, '4g5eA01', NULL, NULL, 148, NULL, NULL, 231179),
(244710, '6gamT01', NULL, NULL, 186, NULL, NULL, 231180),
(244711, '5jskA01', NULL, NULL, 202, NULL, NULL, 231180),
(244712, '4omfG01', NULL, NULL, 159, NULL, NULL, 231180),
(244713, '5mdlS01', NULL, NULL, 181, NULL, NULL, 231180),
(244714, '1yq9A01', NULL, NULL, 179, NULL, NULL, 231180),
(244715, '4c3oB01', NULL, NULL, 181, NULL, NULL, 231180),
(244716, '4kn9S01', NULL, NULL, 202, NULL, NULL, 231180),
(244717, '3ayxB01', NULL, NULL, 190, NULL, NULL, 231180),
(244718, '4uqlB01', NULL, NULL, 179, NULL, NULL, 231180),
(244719, '3myrA01', NULL, NULL, 179, NULL, NULL, 231180),
(244720, '6fpoS01', NULL, NULL, 181, NULL, NULL, 231180),
(244721, '4u9hS01', NULL, NULL, 180, NULL, NULL, 231180),
(244722, '1e3dA01', NULL, NULL, 181, NULL, NULL, 231180),
(244723, '1m1cA00', NULL, NULL, 651, NULL, NULL, 231181),
(244724, '6amyA01', NULL, NULL, 78, NULL, NULL, 231182),
(244725, '3eg4A01', NULL, NULL, 70, NULL, NULL, 231182),
(244726, '3gosA01', NULL, NULL, 72, NULL, NULL, 231182),
(244727, '1kgqA01', NULL, NULL, 70, NULL, NULL, 231182),
(244728, '3bxyA01', NULL, NULL, 81, NULL, NULL, 231182),
(244729, '3tk8B01', NULL, NULL, 70, NULL, NULL, 231182),
(244730, '3fz2E00', NULL, NULL, 134, NULL, NULL, 231183),
(244731, '1uunA01', NULL, NULL, 132, NULL, NULL, 231184);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(244732, '3l4bH02', NULL, NULL, 101, NULL, NULL, 231185),
(244733, '4gx0B03', NULL, NULL, 78, NULL, NULL, 231185),
(244734, '4gx0B05', NULL, NULL, 86, NULL, NULL, 231185),
(244735, '2bkoA02', NULL, NULL, 88, NULL, NULL, 231185),
(244736, '4j91C02', NULL, NULL, 85, NULL, NULL, 231185),
(244737, '2aefA03', NULL, NULL, 80, NULL, NULL, 231185),
(244738, '4g65A04', NULL, NULL, 92, NULL, NULL, 231185),
(244739, '4g65B02', NULL, NULL, 93, NULL, NULL, 231185),
(244740, '4j9vB04', NULL, NULL, 92, NULL, NULL, 231185),
(244741, '4xttA00', NULL, NULL, 85, NULL, NULL, 231185),
(244742, '5f29B00', NULL, NULL, 73, NULL, NULL, 231185),
(244743, '3jxoA00', NULL, NULL, 86, NULL, NULL, 231185),
(244744, '4epzA00', NULL, NULL, 162, NULL, NULL, 231186),
(244745, '5wrkA01', NULL, NULL, 134, NULL, NULL, 231187),
(244746, '3l81A02', NULL, NULL, 122, NULL, NULL, 231187),
(244747, '3l81A01', NULL, NULL, 147, NULL, NULL, 231187),
(244748, '2vglM02', NULL, NULL, 167, NULL, NULL, 231187),
(244749, '2pr9A02', NULL, NULL, 112, NULL, NULL, 231187),
(244750, '2pr9A01', NULL, NULL, 165, NULL, NULL, 231187),
(244751, '4iknA02', NULL, NULL, 112, NULL, NULL, 231187),
(244752, '4iknA01', NULL, NULL, 149, NULL, NULL, 231187),
(244753, '4en2A02', NULL, NULL, 113, NULL, NULL, 231187),
(244754, '4en2A01', NULL, NULL, 153, NULL, NULL, 231187),
(244755, '3m1mA03', NULL, NULL, 110, NULL, NULL, 231188),
(244756, '3h20A04', NULL, NULL, 91, NULL, NULL, 231188),
(244757, '1a5tA03', NULL, NULL, 122, NULL, NULL, 231189),
(244758, '3bgeA01', NULL, NULL, 99, NULL, NULL, 231189),
(244759, '1iqpA03', NULL, NULL, 94, NULL, NULL, 231189),
(244760, '1sxjC03', NULL, NULL, 102, NULL, NULL, 231189),
(244761, '1jqjD02', NULL, NULL, 86, NULL, NULL, 231189),
(244762, '1sxjD03', NULL, NULL, 91, NULL, NULL, 231189),
(244763, '1sxjA03', NULL, NULL, 117, NULL, NULL, 231189),
(244764, '1sxjB03', NULL, NULL, 93, NULL, NULL, 231189),
(244765, '3zh9B03', NULL, NULL, 134, NULL, NULL, 231189),
(244766, '2r9gL01', NULL, NULL, 105, NULL, NULL, 231189),
(244767, '1sxjE03', NULL, NULL, 97, NULL, NULL, 231189),
(244768, '1jqjC02', NULL, NULL, 98, NULL, NULL, 231189),
(244769, '2gnoA03', NULL, NULL, 106, NULL, NULL, 231189),
(244770, '3pvsA03', NULL, NULL, 105, NULL, NULL, 231189),
(244771, '1jr3C02', NULL, NULL, 122, NULL, NULL, 231189),
(244772, '3ctdA01', NULL, NULL, 94, NULL, NULL, 231189),
(244773, '1jr3D02', NULL, NULL, 130, NULL, NULL, 231189),
(244774, '3u61D03', NULL, NULL, 91, NULL, NULL, 231189),
(244775, '2chqA03', NULL, NULL, 94, NULL, NULL, 231189),
(244776, '3e7jA02', NULL, NULL, 320, NULL, NULL, 231190),
(244777, '4ok4A02', NULL, NULL, 364, NULL, NULL, 231190),
(244778, '4mmhA02', NULL, NULL, 279, NULL, NULL, 231190),
(244779, '3a0oA03', NULL, NULL, 281, NULL, NULL, 231190),
(244780, '4fnvA02', NULL, NULL, 282, NULL, NULL, 231190),
(244781, '5jmfA02', NULL, NULL, 271, NULL, NULL, 231190),
(244782, '3e20H01', NULL, NULL, 145, NULL, NULL, 231191),
(244783, '1w9rA00', NULL, NULL, 119, NULL, NULL, 231192),
(244784, '1rp3H01', NULL, NULL, 49, NULL, NULL, 231193),
(244785, '2ztbA02', NULL, NULL, 99, NULL, NULL, 231194),
(244786, '3aibB01', NULL, NULL, 74, NULL, NULL, 231195),
(244787, '2k5cA00', NULL, NULL, 95, NULL, NULL, 231196),
(244788, '4h6zA01', NULL, NULL, 51, NULL, NULL, 231197),
(244789, '2vlaA02', NULL, NULL, 87, NULL, NULL, 231198),
(244790, '2w2gA02', NULL, NULL, 128, NULL, NULL, 231199),
(244791, '2xciC01', NULL, NULL, 165, NULL, NULL, 231200),
(244792, '2xepB01', NULL, NULL, 126, NULL, NULL, 231201),
(244793, '3mp7B00', NULL, NULL, 61, NULL, NULL, 231202),
(244794, '3jc2200', NULL, NULL, 62, NULL, NULL, 231202),
(244795, '1rh5B00', NULL, NULL, 74, NULL, NULL, 231202),
(244796, '1vp7D00', NULL, NULL, 76, NULL, NULL, 231203),
(244797, '2l3lA01', NULL, NULL, 106, NULL, NULL, 231204),
(244798, '2qguA02', NULL, NULL, 82, NULL, NULL, 231205),
(244799, '4uuwB02', NULL, NULL, 74, NULL, NULL, 231206),
(244800, '3kdrA01', NULL, NULL, 118, NULL, NULL, 231207),
(244801, '2lzfA00', NULL, NULL, 68, NULL, NULL, 231208),
(244802, '3es5A02', NULL, NULL, 122, NULL, NULL, 231209);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(244803, '2kxyA01', NULL, NULL, 85, NULL, NULL, 231210),
(244804, '2vpzC00', NULL, NULL, 253, NULL, NULL, 231211),
(244805, '1ztmA02', NULL, NULL, 199, NULL, NULL, 231212),
(244806, '1g5gA02', NULL, NULL, 170, NULL, NULL, 231212),
(244807, '3rkiA02', NULL, NULL, 171, NULL, NULL, 231212),
(244808, '3sd2A01', NULL, NULL, 77, NULL, NULL, 231213),
(244809, '3d33B00', NULL, NULL, 108, NULL, NULL, 231213),
(244810, '4g5aA00', NULL, NULL, 99, NULL, NULL, 231213),
(244811, '1zq9A02', NULL, NULL, 98, NULL, NULL, 231214),
(244812, '2h1rA02', NULL, NULL, 99, NULL, NULL, 231214),
(244813, '3dtnA02', NULL, NULL, 37, NULL, NULL, 231215),
(244814, '1c0wC03', NULL, NULL, 62, NULL, NULL, 231216),
(244815, '2vqpA01', NULL, NULL, 122, NULL, NULL, 231217),
(244816, '4lp7A01', NULL, NULL, 121, NULL, NULL, 231217),
(244817, '4adiA02', NULL, NULL, 92, NULL, NULL, 231218),
(244818, '2vpzA04', NULL, NULL, 61, NULL, NULL, 231219),
(244819, '4bmjA00', NULL, NULL, 69, NULL, NULL, 231220),
(244820, '2rp4A00', NULL, NULL, 76, NULL, NULL, 231221),
(244821, '3pjsK02', NULL, NULL, 45, NULL, NULL, 231222),
(244822, '1ifpA00', NULL, NULL, 44, NULL, NULL, 231222),
(244823, '1jekA00', NULL, NULL, 42, NULL, NULL, 231222),
(244824, '4wvzD01', NULL, NULL, 45, NULL, NULL, 231222),
(244825, '4qmaA01', NULL, NULL, 51, NULL, NULL, 231222),
(244826, '2jdiH02', NULL, NULL, 43, NULL, NULL, 231222),
(244827, '4djgB00', NULL, NULL, 52, NULL, NULL, 231222),
(244828, '2qe7H02', NULL, NULL, 47, NULL, NULL, 231222),
(244829, '1fs0E02', NULL, NULL, 44, NULL, NULL, 231222),
(244830, '2e5yA02', NULL, NULL, 45, NULL, NULL, 231222),
(244831, '3effK02', NULL, NULL, 45, NULL, NULL, 231222),
(244832, '2c1lA02', NULL, NULL, 170, NULL, NULL, 231223),
(244833, '5cn2A00', NULL, NULL, 125, NULL, NULL, 231224),
(244834, '1p4uA00', NULL, NULL, 153, NULL, NULL, 231224),
(244835, '2a7bA00', NULL, NULL, 120, NULL, NULL, 231224),
(244836, '3mnmA00', NULL, NULL, 123, NULL, NULL, 231224),
(244837, '3zhfA00', NULL, NULL, 124, NULL, NULL, 231224),
(244838, '1kyfA01', NULL, NULL, 134, NULL, NULL, 231224),
(244839, '3zy7A00', NULL, NULL, 122, NULL, NULL, 231224),
(244840, '2dwyB00', NULL, NULL, 133, NULL, NULL, 231224),
(244841, '2k2wA00', NULL, NULL, 118, NULL, NULL, 231225),
(244842, '2ihr102', NULL, NULL, 158, NULL, NULL, 231226),
(244843, '1gqeA02', NULL, NULL, 145, NULL, NULL, 231226),
(244844, '1zbtA02', NULL, NULL, 164, NULL, NULL, 231226),
(244845, '2b3tB02', NULL, NULL, 157, NULL, NULL, 231226),
(244846, '3d5aX02', NULL, NULL, 159, NULL, NULL, 231226),
(244847, '1rq0A02', NULL, NULL, 166, NULL, NULL, 231226),
(244848, '3qexA06', NULL, NULL, 92, NULL, NULL, 231227),
(244849, '5uj1A04', NULL, NULL, 131, NULL, NULL, 231228),
(244850, '1i7dA04', NULL, NULL, 127, NULL, NULL, 231228),
(244851, '4cgyA04', NULL, NULL, 125, NULL, NULL, 231228),
(244852, '1gkuB08', NULL, NULL, 119, NULL, NULL, 231228),
(244853, '4dduA08', NULL, NULL, 122, NULL, NULL, 231228),
(244854, '1mw9X04', NULL, NULL, 125, NULL, NULL, 231228),
(244855, '2gaiA04', NULL, NULL, 134, NULL, NULL, 231228),
(244856, '5gvcA04', NULL, NULL, 126, NULL, NULL, 231228),
(244857, '1knxA01', NULL, NULL, 133, NULL, NULL, 231229),
(244858, '3l2bA02', NULL, NULL, 116, NULL, NULL, 231229),
(244859, '2iojA00', NULL, NULL, 139, NULL, NULL, 231229),
(244860, '1ko7B01', NULL, NULL, 128, NULL, NULL, 231229),
(244861, '3cygA02', NULL, NULL, 101, NULL, NULL, 231230),
(244862, '2hhiA02', NULL, NULL, 86, NULL, NULL, 231230),
(244863, '5jenA02', NULL, NULL, 99, NULL, NULL, 231230),
(244864, '4e72A02', NULL, NULL, 95, NULL, NULL, 231230),
(244865, '3s5tA02', NULL, NULL, 100, NULL, NULL, 231230),
(244866, '1l6kA00', NULL, NULL, 77, NULL, NULL, 231231),
(244867, '1tfpA00', NULL, NULL, 130, NULL, NULL, 231232),
(244868, '1f86A00', NULL, NULL, 115, NULL, NULL, 231232),
(244869, '1kgiA00', NULL, NULL, 127, NULL, NULL, 231232),
(244870, '4q14A00', NULL, NULL, 118, NULL, NULL, 231232),
(244871, '3iwvB00', NULL, NULL, 117, NULL, NULL, 231232),
(244872, '3qvaA00', NULL, NULL, 116, NULL, NULL, 231232),
(244873, '4tlsA00', NULL, NULL, 125, NULL, NULL, 231232); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(244874, '2qpfA00', NULL, NULL, 128, NULL, NULL, 231232),
(244875, '1oo2A00', NULL, NULL, 119, NULL, NULL, 231232),
(244876, '2h0eB00', NULL, NULL, 121, NULL, NULL, 231232),
(244877, '2g2nC00', NULL, NULL, 114, NULL, NULL, 231232),
(244878, '4hiqA00', NULL, NULL, 127, NULL, NULL, 231232),
(244879, '2gpzA00', NULL, NULL, 111, NULL, NULL, 231232),
(244880, '1hq0A00', NULL, NULL, 295, NULL, NULL, 231233),
(244881, '3h0nA00', NULL, NULL, 188, NULL, NULL, 231234),
(244882, '2axqA03', NULL, NULL, 100, NULL, NULL, 231235),
(244883, '1ff9A03', NULL, NULL, 100, NULL, NULL, 231235),
(244884, '5cwtA00', NULL, NULL, 54, NULL, NULL, 231236),
(244885, '2qfaC00', NULL, NULL, 47, NULL, NULL, 231236),
(244886, '3ontA00', NULL, NULL, 152, NULL, NULL, 231237),
(244887, '2qtfA02', NULL, NULL, 68, NULL, NULL, 231238),
(244888, '4guaA03', NULL, NULL, 157, NULL, NULL, 231239),
(244889, '2dx6A00', NULL, NULL, 159, NULL, NULL, 231239),
(244890, '4d86A01', NULL, NULL, 197, NULL, NULL, 231239),
(244891, '5d8nA01', NULL, NULL, 200, NULL, NULL, 231239),
(244892, '1gytL01', NULL, NULL, 180, NULL, NULL, 231239),
(244893, '3sigA00', NULL, NULL, 277, NULL, NULL, 231239),
(244894, '3jruA01', NULL, NULL, 163, NULL, NULL, 231239),
(244895, '6fy5B00', NULL, NULL, 198, NULL, NULL, 231239),
(244896, '3ewoA00', NULL, NULL, 177, NULL, NULL, 231239),
(244897, '4zi6C01', NULL, NULL, 190, NULL, NULL, 231239),
(244898, '4etkA00', NULL, NULL, 167, NULL, NULL, 231239),
(244899, '2vriA00', NULL, NULL, 174, NULL, NULL, 231239),
(244900, '1njrA00', NULL, NULL, 284, NULL, NULL, 231239),
(244901, '4kybA00', NULL, NULL, 167, NULL, NULL, 231239),
(244902, '1zr5B00', NULL, NULL, 190, NULL, NULL, 231239),
(244903, '5o2dA00', NULL, NULL, 200, NULL, NULL, 231239),
(244904, '1lamA01', NULL, NULL, 165, NULL, NULL, 231239),
(244905, '5e3bA00', NULL, NULL, 159, NULL, NULL, 231239),
(244906, '4j4zA00', NULL, NULL, 167, NULL, NULL, 231239),
(244907, '5dusA00', NULL, NULL, 168, NULL, NULL, 231239),
(244908, '1yd9B00', NULL, NULL, 193, NULL, NULL, 231239),
(244909, '3q71A00', NULL, NULL, 221, NULL, NULL, 231239),
(244910, '3kqxL01', NULL, NULL, 198, NULL, NULL, 231239),
(244911, '4j5rA00', NULL, NULL, 146, NULL, NULL, 231239),
(244912, '5fszA00', NULL, NULL, 268, NULL, NULL, 231239),
(244913, '5fsvA00', NULL, NULL, 266, NULL, NULL, 231239),
(244914, '3ejfA00', NULL, NULL, 176, NULL, NULL, 231239),
(244915, '3etiA00', NULL, NULL, 168, NULL, NULL, 231239),
(244916, '3gqeA00', NULL, NULL, 168, NULL, NULL, 231239),
(244917, '2acfD00', NULL, NULL, 182, NULL, NULL, 231239),
(244918, '1vhuA00', NULL, NULL, 211, NULL, NULL, 231239),
(244919, '5lauA00', NULL, NULL, 187, NULL, NULL, 231239),
(244920, '5cb3A00', NULL, NULL, 183, NULL, NULL, 231239),
(244921, '5ailB00', NULL, NULL, 186, NULL, NULL, 231239),
(244922, '2afcA00', NULL, NULL, 168, NULL, NULL, 231239),
(244923, '3peiA01', NULL, NULL, 147, NULL, NULL, 231239),
(244924, '5iq5A00', NULL, NULL, 166, NULL, NULL, 231239),
(244925, '4iqyB00', NULL, NULL, 240, NULL, NULL, 231239),
(244926, '3h8gA01', NULL, NULL, 161, NULL, NULL, 231239),
(244927, '4jgkD00', NULL, NULL, 167, NULL, NULL, 231239),
(244928, '3v2bA00', NULL, NULL, 181, NULL, NULL, 231239),
(244929, '2fg1A00', NULL, NULL, 158, NULL, NULL, 231239),
(244930, '2x47A00', NULL, NULL, 235, NULL, NULL, 231239),
(244931, '3gpgA00', NULL, NULL, 168, NULL, NULL, 231239),
(244932, '3ejgA00', NULL, NULL, 165, NULL, NULL, 231239),
(244933, '3kzwA01', NULL, NULL, 158, NULL, NULL, 231239),
(244934, '4gvwA00', NULL, NULL, 199, NULL, NULL, 231239),
(244935, '5qhtA00', NULL, NULL, 183, NULL, NULL, 231239),
(244936, '3ij3A01', NULL, NULL, 131, NULL, NULL, 231239),
(244937, '4umlA00', NULL, NULL, 229, NULL, NULL, 231239),
(244938, '4pvkA03', NULL, NULL, 177, NULL, NULL, 231240),
(244939, '4dnsA03', NULL, NULL, 176, NULL, NULL, 231240),
(244940, '5d79A03', NULL, NULL, 187, NULL, NULL, 231240),
(244941, '3rjaA02', NULL, NULL, 229, NULL, NULL, 231240),
(244942, '2bvfA03', NULL, NULL, 210, NULL, NULL, 231240),
(244943, '5l6gA02', NULL, NULL, 229, NULL, NULL, 231240),
(244944, '2y3sA02', NULL, NULL, 252, NULL, NULL, 231240);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(244945, '4ud8A03', NULL, NULL, 188, NULL, NULL, 231240),
(244946, '3popA02', NULL, NULL, 252, NULL, NULL, 231240),
(244947, '5i1vA02', NULL, NULL, 253, NULL, NULL, 231240),
(244948, '5awvA02', NULL, NULL, 250, NULL, NULL, 231240),
(244949, '2ipiA02', NULL, NULL, 248, NULL, NULL, 231240),
(244950, '1zr6A03', NULL, NULL, 203, NULL, NULL, 231240),
(244951, '3vteA03', NULL, NULL, 192, NULL, NULL, 231240),
(244952, '3fw9A03', NULL, NULL, 184, NULL, NULL, 231240),
(244953, '6foqA03', NULL, NULL, 210, NULL, NULL, 231240),
(244954, '1khvA01', NULL, NULL, 63, NULL, NULL, 231241),
(244955, '3zqsA02', NULL, NULL, 98, NULL, NULL, 231242),
(244956, '3zc0D00', NULL, NULL, 199, NULL, NULL, 231243),
(244957, '5jrcA00', NULL, NULL, 186, NULL, NULL, 231243),
(244958, '2l2gA00', NULL, NULL, 151, NULL, NULL, 231244),
(244959, '1q25A01', NULL, NULL, 129, NULL, NULL, 231244),
(244960, '2kvaA01', NULL, NULL, 141, NULL, NULL, 231244),
(244961, '3aihB01', NULL, NULL, 119, NULL, NULL, 231244),
(244962, '2l21A00', NULL, NULL, 154, NULL, NULL, 231244),
(244963, '2llaA00', NULL, NULL, 140, NULL, NULL, 231244),
(244964, '2v5oA02', NULL, NULL, 150, NULL, NULL, 231244),
(244965, '4xqmA00', NULL, NULL, 94, NULL, NULL, 231244),
(244966, '2v5oA03', NULL, NULL, 138, NULL, NULL, 231244),
(244967, '2rl8A00', NULL, NULL, 154, NULL, NULL, 231244),
(244968, '2v5oA05', NULL, NULL, 146, NULL, NULL, 231244),
(244969, '1q25A02', NULL, NULL, 156, NULL, NULL, 231244),
(244970, '1gp0A00', NULL, NULL, 143, NULL, NULL, 231244),
(244971, '5ieiA00', NULL, NULL, 142, NULL, NULL, 231244),
(244972, '2l29A00', NULL, NULL, 142, NULL, NULL, 231244),
(244973, '1q25A03', NULL, NULL, 147, NULL, NULL, 231244),
(244974, '3nufB00', NULL, NULL, 119, NULL, NULL, 231245),
(244975, '1h99A02', NULL, NULL, 110, NULL, NULL, 231245),
(244976, '1h99A01', NULL, NULL, 104, NULL, NULL, 231245),
(244977, '3rioA02', NULL, NULL, 100, NULL, NULL, 231245),
(244978, '3nvwB03', NULL, NULL, 116, NULL, NULL, 231246),
(244979, '2e1qC05', NULL, NULL, 118, NULL, NULL, 231246),
(244980, '1t3qC03', NULL, NULL, 114, NULL, NULL, 231246),
(244981, '3a7rA02', NULL, NULL, 89, NULL, NULL, 231246),
(244982, '5g5gB02', NULL, NULL, 96, NULL, NULL, 231246),
(244983, '1vqzA02', NULL, NULL, 88, NULL, NULL, 231246),
(244984, '1rm6B02', NULL, NULL, 108, NULL, NULL, 231246),
(244985, '2e5aA02', NULL, NULL, 107, NULL, NULL, 231246),
(244986, '2w3sA05', NULL, NULL, 104, NULL, NULL, 231246),
(244987, '3zyvA05', NULL, NULL, 117, NULL, NULL, 231246),
(244988, '1ffvC02', NULL, NULL, 105, NULL, NULL, 231246),
(244989, '5y6qB02', NULL, NULL, 106, NULL, NULL, 231246),
(244990, '3hrdC02', NULL, NULL, 118, NULL, NULL, 231246),
(244991, '3r07C00', NULL, NULL, 91, NULL, NULL, 231246),
(244992, '4zohB03', NULL, NULL, 106, NULL, NULL, 231246),
(244993, '1n62C02', NULL, NULL, 105, NULL, NULL, 231246),
(244994, '3an1A05', NULL, NULL, 118, NULL, NULL, 231246),
(244995, '2cjsC01', NULL, NULL, 38, NULL, NULL, 231247),
(244996, '5grmA02', NULL, NULL, 147, NULL, NULL, 231248),
(244997, '6mx3B02', NULL, NULL, 147, NULL, NULL, 231248),
(244998, '5cflA02', NULL, NULL, 147, NULL, NULL, 231248),
(244999, '4qxoA02', NULL, NULL, 147, NULL, NULL, 231248),
(245000, '4lojA02', NULL, NULL, 147, NULL, NULL, 231248),
(245001, '2gjvA00', NULL, NULL, 136, NULL, NULL, 231249),
(245002, '3wajA04', NULL, NULL, 88, NULL, NULL, 231250),
(245003, '3ilxA02', NULL, NULL, 44, NULL, NULL, 231251),
(245004, '6dgcC02', NULL, NULL, 43, NULL, NULL, 231251),
(245005, '3lhkC02', NULL, NULL, 52, NULL, NULL, 231251),
(245006, '3lhfD02', NULL, NULL, 42, NULL, NULL, 231251),
(245007, '2kgsA01', NULL, NULL, 110, NULL, NULL, 231252),
(245008, '5dmhB02', NULL, NULL, 180, NULL, NULL, 231253),
(245009, '1yzyA02', NULL, NULL, 178, NULL, NULL, 231253),
(245010, '3dqqB02', NULL, NULL, 178, NULL, NULL, 231253),
(245011, '2zyrA02', NULL, NULL, 94, NULL, NULL, 231254),
(245012, '1lfpA01', NULL, NULL, 64, NULL, NULL, 231255),
(245013, '3hphB01', NULL, NULL, 58, NULL, NULL, 231255),
(245014, '4f3qA01', NULL, NULL, 84, NULL, NULL, 231255),
(245015, '5cz2G00', NULL, NULL, 41, NULL, NULL, 231255);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(245016, '3hphD01', NULL, NULL, 43, NULL, NULL, 231255),
(245017, '1k6yA01', NULL, NULL, 46, NULL, NULL, 231255),
(245018, '3f9kA01', NULL, NULL, 56, NULL, NULL, 231255),
(245019, '1mw7A01', NULL, NULL, 58, NULL, NULL, 231255),
(245020, '1konA01', NULL, NULL, 84, NULL, NULL, 231255),
(245021, '3ol0B00', NULL, NULL, 48, NULL, NULL, 231256),
(245022, '1szhA02', NULL, NULL, 93, NULL, NULL, 231257),
(245023, '3ayjA02', NULL, NULL, 309, NULL, NULL, 231258),
(245024, '1uptB00', NULL, NULL, 60, NULL, NULL, 231259),
(245025, '1uptD00', NULL, NULL, 60, NULL, NULL, 231259),
(245026, '1r4aE00', NULL, NULL, 51, NULL, NULL, 231259),
(245027, '1uptF00', NULL, NULL, 60, NULL, NULL, 231259),
(245028, '1uptH00', NULL, NULL, 60, NULL, NULL, 231259),
(245029, '4ar9A02', NULL, NULL, 142, NULL, NULL, 231260),
(245030, '4arfA02', NULL, NULL, 142, NULL, NULL, 231260),
(245031, '2yayA02', NULL, NULL, 135, NULL, NULL, 231261),
(245032, '4dk2A02', NULL, NULL, 164, NULL, NULL, 231261),
(245033, '1oglA02', NULL, NULL, 152, NULL, NULL, 231261),
(245034, '5b66j00', NULL, NULL, 40, NULL, NULL, 231262),
(245035, '3fhkA01', NULL, NULL, 27, NULL, NULL, 231263),
(245036, '3opxA02', NULL, NULL, 70, NULL, NULL, 231264),
(245037, '3nuqA01', NULL, NULL, 101, NULL, NULL, 231264),
(245038, '1o70A01', NULL, NULL, 140, NULL, NULL, 231265),
(245039, '1o70A02', NULL, NULL, 156, NULL, NULL, 231265),
(245040, '2vxpA00', NULL, NULL, 132, NULL, NULL, 231265),
(245041, '1w7dA00', NULL, NULL, 137, NULL, NULL, 231265),
(245042, '5wt7A00', NULL, NULL, 140, NULL, NULL, 231265),
(245043, '1nyoA00', NULL, NULL, 163, NULL, NULL, 231265),
(245044, '2nr5G00', NULL, NULL, 67, NULL, NULL, 231266),
(245045, '2nr5H00', NULL, NULL, 67, NULL, NULL, 231266),
(245046, '2nr5C00', NULL, NULL, 67, NULL, NULL, 231266),
(245047, '2nr5D00', NULL, NULL, 67, NULL, NULL, 231266),
(245048, '2nr5E00', NULL, NULL, 67, NULL, NULL, 231266),
(245049, '2nr5F00', NULL, NULL, 67, NULL, NULL, 231266),
(245050, '2gboA00', NULL, NULL, 85, NULL, NULL, 231266),
(245051, '2odmA00', NULL, NULL, 91, NULL, NULL, 231266),
(245052, '2nr5A00', NULL, NULL, 67, NULL, NULL, 231266),
(245053, '2nr5B00', NULL, NULL, 67, NULL, NULL, 231266),
(245054, '2gukA00', NULL, NULL, 120, NULL, NULL, 231267),
(245055, '3rfaA01', NULL, NULL, 62, NULL, NULL, 231268),
(245056, '3rf9B01', NULL, NULL, 78, NULL, NULL, 231268),
(245057, '2b56A03', NULL, NULL, 99, NULL, NULL, 231269),
(245058, '2b4vA03', NULL, NULL, 99, NULL, NULL, 231269),
(245059, '1sg5A01', NULL, NULL, 77, NULL, NULL, 231270),
(245060, '2fpnA01', NULL, NULL, 140, NULL, NULL, 231271),
(245061, '4c8yA01', NULL, NULL, 109, NULL, NULL, 231272),
(245062, '4c98A01', NULL, NULL, 127, NULL, NULL, 231272),
(245063, '3i4hX01', NULL, NULL, 133, NULL, NULL, 231272),
(245064, '5yi6B01', NULL, NULL, 124, NULL, NULL, 231272),
(245065, '3ufcX01', NULL, NULL, 122, NULL, NULL, 231272),
(245066, '3qjlA01', NULL, NULL, 124, NULL, NULL, 231272),
(245067, '3iynQ01', NULL, NULL, 81, NULL, NULL, 231273),
(245068, '4icsA01', NULL, NULL, 183, NULL, NULL, 231274),
(245069, '2ayiA01', NULL, NULL, 177, NULL, NULL, 231274),
(245070, '1zjcA01', NULL, NULL, 185, NULL, NULL, 231274),
(245071, '3lnoD00', NULL, NULL, 108, NULL, NULL, 231275),
(245072, '3lnoE00', NULL, NULL, 108, NULL, NULL, 231275),
(245073, '3lnoB00', NULL, NULL, 108, NULL, NULL, 231275),
(245074, '3lnoC00', NULL, NULL, 108, NULL, NULL, 231275),
(245075, '1uwdA00', NULL, NULL, 103, NULL, NULL, 231275),
(245076, '3lnoF00', NULL, NULL, 108, NULL, NULL, 231275),
(245077, '1th5A00', NULL, NULL, 74, NULL, NULL, 231275),
(245078, '3lnoA00', NULL, NULL, 108, NULL, NULL, 231275),
(245079, '3cq2A00', NULL, NULL, 103, NULL, NULL, 231275),
(245080, '3ux3A01', NULL, NULL, 97, NULL, NULL, 231275),
(245081, '2z51A01', NULL, NULL, 82, NULL, NULL, 231275),
(245082, '1vehA01', NULL, NULL, 75, NULL, NULL, 231275),
(245083, '2z51A02', NULL, NULL, 72, NULL, NULL, 231275),
(245084, '1xhjA00', NULL, NULL, 88, NULL, NULL, 231275),
(245085, '2m5oA01', NULL, NULL, 75, NULL, NULL, 231275),
(245086, '2jnvA00', NULL, NULL, 91, NULL, NULL, 231275);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(245087, '3rtxA02', NULL, NULL, 107, NULL, NULL, 231276),
(245088, '2qyuA03', NULL, NULL, 75, NULL, NULL, 231277),
(245089, '3nb2A03', NULL, NULL, 103, NULL, NULL, 231277),
(245090, '2o3oB01', NULL, NULL, 134, NULL, NULL, 231278),
(245091, '4hfvA02', NULL, NULL, 71, NULL, NULL, 231279),
(245092, '4aqzA00', NULL, NULL, 138, NULL, NULL, 231280),
(245093, '3obhA00', NULL, NULL, 82, NULL, NULL, 231281),
(245094, '3sjlE00', NULL, NULL, 137, NULL, NULL, 231282),
(245095, '2oizH00', NULL, NULL, 135, NULL, NULL, 231282),
(245096, '1mdaL00', NULL, NULL, 121, NULL, NULL, 231282),
(245097, '4o1qC00', NULL, NULL, 137, NULL, NULL, 231282),
(245098, '2d7eA01', NULL, NULL, 90, NULL, NULL, 231283),
(245099, '4nl4H01', NULL, NULL, 111, NULL, NULL, 231283),
(245100, '4i1oD02', NULL, NULL, 154, NULL, NULL, 231284),
(245101, '4jvsA02', NULL, NULL, 159, NULL, NULL, 231284),
(245102, '4jw1B02', NULL, NULL, 157, NULL, NULL, 231284),
(245103, '2uvbC04', NULL, NULL, 46, NULL, NULL, 231285),
(245104, '4f88102', NULL, NULL, 236, NULL, NULL, 231286),
(245105, '4f98A00', NULL, NULL, 69, NULL, NULL, 231287),
(245106, '3hnpE01', NULL, NULL, 86, NULL, NULL, 231288),
(245107, '1dqaD01', NULL, NULL, 60, NULL, NULL, 231288),
(245108, '1hw8A01', NULL, NULL, 88, NULL, NULL, 231288),
(245109, '2r4fD01', NULL, NULL, 79, NULL, NULL, 231288),
(245110, '2jugA01', NULL, NULL, 55, NULL, NULL, 231289),
(245111, '1m4uA02', NULL, NULL, 66, NULL, NULL, 231290),
(245112, '2im9A03', NULL, NULL, 36, NULL, NULL, 231290),
(245113, '4ldvA03', NULL, NULL, 76, NULL, NULL, 231291),
(245114, '4lduA03', NULL, NULL, 76, NULL, NULL, 231291),
(245115, '3h3aA03', NULL, NULL, 128, NULL, NULL, 231292),
(245116, '4fasA02', NULL, NULL, 233, NULL, NULL, 231293),
(245117, '3fnnA03', NULL, NULL, 52, NULL, NULL, 231294),
(245118, '3gwcB03', NULL, NULL, 52, NULL, NULL, 231294),
(245119, '2wssW01', NULL, NULL, 95, NULL, NULL, 231295),
(245120, '1abvA00', NULL, NULL, 105, NULL, NULL, 231295),
(245121, '4atkB00', NULL, NULL, 60, NULL, NULL, 231296),
(245122, '2ypaA00', NULL, NULL, 72, NULL, NULL, 231296),
(245123, '4atiA00', NULL, NULL, 61, NULL, NULL, 231296),
(245124, '2ypaB00', NULL, NULL, 82, NULL, NULL, 231296),
(245125, '4f3lA01', NULL, NULL, 77, NULL, NULL, 231296),
(245126, '1hloB00', NULL, NULL, 80, NULL, NULL, 231296),
(245127, '1a0aA00', NULL, NULL, 63, NULL, NULL, 231296),
(245128, '2ql2B00', NULL, NULL, 60, NULL, NULL, 231296),
(245129, '4h10B00', NULL, NULL, 71, NULL, NULL, 231296),
(245130, '2ql2C00', NULL, NULL, 60, NULL, NULL, 231296),
(245131, '4h10A00', NULL, NULL, 73, NULL, NULL, 231296),
(245132, '4f3lB01', NULL, NULL, 68, NULL, NULL, 231296),
(245133, '5i4zA00', NULL, NULL, 74, NULL, NULL, 231296),
(245134, '1r05A00', NULL, NULL, 87, NULL, NULL, 231296),
(245135, '4ayaA00', NULL, NULL, 67, NULL, NULL, 231296),
(245136, '2c0sA00', NULL, NULL, 64, NULL, NULL, 231296),
(245137, '1uklC00', NULL, NULL, 61, NULL, NULL, 231296),
(245138, '2lfhA00', NULL, NULL, 68, NULL, NULL, 231296),
(245139, '1an4A00', NULL, NULL, 65, NULL, NULL, 231296),
(245140, '1nkpD00', NULL, NULL, 88, NULL, NULL, 231296),
(245141, '6g6kB00', NULL, NULL, 83, NULL, NULL, 231296),
(245142, '6g6kC00', NULL, NULL, 94, NULL, NULL, 231296),
(245143, '6fx5A00', NULL, NULL, 80, NULL, NULL, 231296),
(245144, '6od3A00', NULL, NULL, 62, NULL, NULL, 231296),
(245145, '5i50B00', NULL, NULL, 96, NULL, NULL, 231296),
(245146, '2mh3A00', NULL, NULL, 70, NULL, NULL, 231296),
(245147, '1nlwD00', NULL, NULL, 80, NULL, NULL, 231296),
(245148, '1am9B00', NULL, NULL, 82, NULL, NULL, 231296),
(245149, '3u5vA01', NULL, NULL, 64, NULL, NULL, 231296),
(245150, '1mdyA00', NULL, NULL, 68, NULL, NULL, 231296),
(245151, '4atiB00', NULL, NULL, 72, NULL, NULL, 231296),
(245152, '2bzbA00', NULL, NULL, 62, NULL, NULL, 231296),
(245153, '1xakA00', NULL, NULL, 83, NULL, NULL, 231297),
(245154, '3hq1B04', NULL, NULL, 119, NULL, NULL, 231298),
(245155, '3hq1A02', NULL, NULL, 180, NULL, NULL, 231298),
(245156, '2qgmA01', NULL, NULL, 213, NULL, NULL, 231299),
(245157, '3b55A01', NULL, NULL, 217, NULL, NULL, 231299);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(245158, '2jq3A00', NULL, NULL, 79, NULL, NULL, 231300),
(245159, '4jquB00', NULL, NULL, 54, NULL, NULL, 231301),
(245160, '5cdkA00', NULL, NULL, 183, NULL, NULL, 231302),
(245161, '5da8I03', NULL, NULL, 181, NULL, NULL, 231302),
(245162, '3vz6A00', NULL, NULL, 199, NULL, NULL, 231302),
(245163, '3ruvA03', NULL, NULL, 152, NULL, NULL, 231302),
(245164, '3kfeA03', NULL, NULL, 131, NULL, NULL, 231302),
(245165, '1fy9A00', NULL, NULL, 193, NULL, NULL, 231302),
(245166, '1srvA00', NULL, NULL, 145, NULL, NULL, 231302),
(245167, '3p9dC03', NULL, NULL, 152, NULL, NULL, 231302),
(245168, '1dk7A00', NULL, NULL, 146, NULL, NULL, 231302),
(245169, '3p9dD03', NULL, NULL, 161, NULL, NULL, 231302),
(245170, '3p9dA03', NULL, NULL, 161, NULL, NULL, 231302),
(245171, '3rtkA03', NULL, NULL, 185, NULL, NULL, 231302),
(245172, '1iokA03', NULL, NULL, 181, NULL, NULL, 231302),
(245173, '1la1A00', NULL, NULL, 192, NULL, NULL, 231302),
(245174, '3m6cA00', NULL, NULL, 194, NULL, NULL, 231302),
(245175, '5cdjA00', NULL, NULL, 186, NULL, NULL, 231302),
(245176, '3kttB03', NULL, NULL, 153, NULL, NULL, 231302),
(245177, '1q3qA03', NULL, NULL, 152, NULL, NULL, 231302),
(245178, '4ki8A03', NULL, NULL, 207, NULL, NULL, 231302),
(245179, '4aolB03', NULL, NULL, 136, NULL, NULL, 231302),
(245180, '3aq1B03', NULL, NULL, 152, NULL, NULL, 231302),
(245181, '4aolE03', NULL, NULL, 160, NULL, NULL, 231302),
(245182, '1gmlA00', NULL, NULL, 170, NULL, NULL, 231302),
(245183, '4xcdC03', NULL, NULL, 152, NULL, NULL, 231302),
(245184, '3p9dG03', NULL, NULL, 156, NULL, NULL, 231302),
(245185, '3ko1A03', NULL, NULL, 152, NULL, NULL, 231302),
(245186, '3p9dH03', NULL, NULL, 155, NULL, NULL, 231302),
(245187, '4pj1A03', NULL, NULL, 183, NULL, NULL, 231302),
(245188, '4xcgA03', NULL, NULL, 155, NULL, NULL, 231302),
(245189, '1assA00', NULL, NULL, 159, NULL, NULL, 231302),
(245190, '4d8qF03', NULL, NULL, 162, NULL, NULL, 231302),
(245191, '3osxA00', NULL, NULL, 201, NULL, NULL, 231302),
(245192, '1a6dB03', NULL, NULL, 152, NULL, NULL, 231302),
(245193, '1we3H03', NULL, NULL, 184, NULL, NULL, 231302),
(245194, '3m6jA01', NULL, NULL, 126, NULL, NULL, 231303),
(245195, '2w7vA00', NULL, NULL, 95, NULL, NULL, 231304),
(245196, '5hl8C00', NULL, NULL, 92, NULL, NULL, 231304),
(245197, '1uv7A00', NULL, NULL, 88, NULL, NULL, 231304),
(245198, '3rwnB00', NULL, NULL, 161, NULL, NULL, 231305),
(245199, '2x7aA00', NULL, NULL, 61, NULL, NULL, 231306),
(245200, '2qa7A00', NULL, NULL, 114, NULL, NULL, 231306),
(245201, '3mkxD00', NULL, NULL, 112, NULL, NULL, 231306),
(245202, '4pkyE00', NULL, NULL, 50, NULL, NULL, 231306),
(245203, '3cveB00', NULL, NULL, 72, NULL, NULL, 231306),
(245204, '3cvfA00', NULL, NULL, 79, NULL, NULL, 231306),
(245205, '3i00A00', NULL, NULL, 85, NULL, NULL, 231306),
(245206, '2xg7C00', NULL, NULL, 77, NULL, NULL, 231306),
(245207, '2gqtA01', NULL, NULL, 70, NULL, NULL, 231307),
(245208, '4dnsB01', NULL, NULL, 111, NULL, NULL, 231307),
(245209, '5d79B01', NULL, NULL, 106, NULL, NULL, 231307),
(245210, '2bvfA01', NULL, NULL, 79, NULL, NULL, 231307),
(245211, '3i99A01', NULL, NULL, 82, NULL, NULL, 231307),
(245212, '4bbyB01', NULL, NULL, 128, NULL, NULL, 231307),
(245213, '4ud8B01', NULL, NULL, 111, NULL, NULL, 231307),
(245214, '4pytA01', NULL, NULL, 88, NULL, NULL, 231307),
(245215, '1ffvC01', NULL, NULL, 54, NULL, NULL, 231307),
(245216, '3pm9A01', NULL, NULL, 104, NULL, NULL, 231307),
(245217, '6c80A01', NULL, NULL, 126, NULL, NULL, 231307),
(245218, '1zr6A01', NULL, NULL, 93, NULL, NULL, 231307),
(245219, '2exrA01', NULL, NULL, 123, NULL, NULL, 231307),
(245220, '2vfrA01', NULL, NULL, 72, NULL, NULL, 231307),
(245221, '1n62C01', NULL, NULL, 54, NULL, NULL, 231307),
(245222, '3an1B03', NULL, NULL, 66, NULL, NULL, 231307),
(245223, '6foqA01', NULL, NULL, 79, NULL, NULL, 231307),
(245224, '4o95A01', NULL, NULL, 101, NULL, NULL, 231307),
(245225, '4pvkA01', NULL, NULL, 109, NULL, NULL, 231307),
(245226, '2e1qC03', NULL, NULL, 62, NULL, NULL, 231307),
(245227, '1t3qC01', NULL, NULL, 56, NULL, NULL, 231307),
(245228, '3vteA01', NULL, NULL, 108, NULL, NULL, 231307);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(245229, '5fxdA01', NULL, NULL, 111, NULL, NULL, 231307),
(245230, '3js8A01', NULL, NULL, 76, NULL, NULL, 231307),
(245231, '3tx1A01', NULL, NULL, 84, NULL, NULL, 231307),
(245232, '2i0kA01', NULL, NULL, 76, NULL, NULL, 231307),
(245233, '3nvwB01', NULL, NULL, 92, NULL, NULL, 231307),
(245234, '3zyvD03', NULL, NULL, 67, NULL, NULL, 231307),
(245235, '1e8gA01', NULL, NULL, 128, NULL, NULL, 231307),
(245236, '2w3sA03', NULL, NULL, 50, NULL, NULL, 231307),
(245237, '1uxyA02', NULL, NULL, 66, NULL, NULL, 231307),
(245238, '4mlaB01', NULL, NULL, 117, NULL, NULL, 231307),
(245239, '4mlaA01', NULL, NULL, 147, NULL, NULL, 231307),
(245240, '3nvwK01', NULL, NULL, 63, NULL, NULL, 231307),
(245241, '1w1oA01', NULL, NULL, 124, NULL, NULL, 231307),
(245242, '1hskA02', NULL, NULL, 102, NULL, NULL, 231307),
(245243, '4zohB01', NULL, NULL, 53, NULL, NULL, 231307),
(245244, '1f0xB02', NULL, NULL, 152, NULL, NULL, 231307),
(245245, '1wvfA01', NULL, NULL, 113, NULL, NULL, 231307),
(245246, '4jb1A01', NULL, NULL, 75, NULL, NULL, 231307),
(245247, '3fw9A01', NULL, NULL, 100, NULL, NULL, 231307),
(245248, '5na1A00', NULL, NULL, 408, NULL, NULL, 231308),
(245249, '5wedA00', NULL, NULL, 405, NULL, NULL, 231308),
(245250, '3hywA00', NULL, NULL, 430, NULL, NULL, 231308),
(245251, '3sx6A00', NULL, NULL, 421, NULL, NULL, 231308),
(245252, '4g6hA00', NULL, NULL, 472, NULL, NULL, 231308),
(245253, '3qb2D00', NULL, NULL, 159, NULL, NULL, 231309),
(245254, '3qb2A00', NULL, NULL, 156, NULL, NULL, 231309),
(245255, '4kt6B00', NULL, NULL, 161, NULL, NULL, 231309),
(245256, '4nehA05', NULL, NULL, 188, NULL, NULL, 231310),
(245257, '5es4A05', NULL, NULL, 179, NULL, NULL, 231310),
(245258, '3fcsA04', NULL, NULL, 180, NULL, NULL, 231310),
(245259, '4g1eA04', NULL, NULL, 260, NULL, NULL, 231310),
(245260, '4g1mA04', NULL, NULL, 220, NULL, NULL, 231310),
(245261, '2oyrA01', NULL, NULL, 56, NULL, NULL, 231311),
(245262, '2pkwA01', NULL, NULL, 56, NULL, NULL, 231311),
(245263, '2pgxA01', NULL, NULL, 56, NULL, NULL, 231311),
(245264, '2r6zA01', NULL, NULL, 55, NULL, NULL, 231311),
(245265, '2ajrA02', NULL, NULL, 53, NULL, NULL, 231312),
(245266, '2qcvA02', NULL, NULL, 43, NULL, NULL, 231312),
(245267, '3pl2A02', NULL, NULL, 44, NULL, NULL, 231312),
(245268, '3bf5A02', NULL, NULL, 43, NULL, NULL, 231312),
(245269, '2ciwA00', NULL, NULL, 299, NULL, NULL, 231313),
(245270, '6ekzA00', NULL, NULL, 328, NULL, NULL, 231313),
(245271, '3fajA00', NULL, NULL, 108, NULL, NULL, 231314),
(245272, '4rnaA01', NULL, NULL, 58, NULL, NULL, 231315),
(245273, '4m0wA01', NULL, NULL, 58, NULL, NULL, 231315),
(245274, '4p16A01', NULL, NULL, 62, NULL, NULL, 231315),
(245275, '2v0cA03', NULL, NULL, 57, NULL, NULL, 231316),
(245276, '3s57A00', NULL, NULL, 204, NULL, NULL, 231317),
(245277, '4qkdA00', NULL, NULL, 200, NULL, NULL, 231317),
(245278, '4ie5A01', NULL, NULL, 301, NULL, NULL, 231317),
(245279, '2iuwA00', NULL, NULL, 220, NULL, NULL, 231317),
(245280, '4o7xA00', NULL, NULL, 230, NULL, NULL, 231317),
(245281, '4jhtA00', NULL, NULL, 206, NULL, NULL, 231317),
(245282, '4nplA00', NULL, NULL, 225, NULL, NULL, 231317),
(245283, '2vnuD01', NULL, NULL, 113, NULL, NULL, 231318),
(245284, '2r01A02', NULL, NULL, 44, NULL, NULL, 231319),
(245285, '3lmbA01', NULL, NULL, 157, NULL, NULL, 231320),
(245286, '5hd6D00', NULL, NULL, 175, NULL, NULL, 231320),
(245287, '6n3pA00', NULL, NULL, 154, NULL, NULL, 231320),
(245288, '4e3eA00', NULL, NULL, 352, NULL, NULL, 231320),
(245289, '4ffuD00', NULL, NULL, 151, NULL, NULL, 231320),
(245290, '3bnvD00', NULL, NULL, 152, NULL, NULL, 231320),
(245291, '3hduB00', NULL, NULL, 157, NULL, NULL, 231320),
(245292, '1sbkA00', NULL, NULL, 144, NULL, NULL, 231320),
(245293, '3kh8B01', NULL, NULL, 162, NULL, NULL, 231320),
(245294, '2gvhB02', NULL, NULL, 134, NULL, NULL, 231320),
(245295, '4ordA00', NULL, NULL, 149, NULL, NULL, 231320),
(245296, '5hmbA00', NULL, NULL, 141, NULL, NULL, 231320),
(245297, '1q4tA00', NULL, NULL, 151, NULL, NULL, 231320),
(245298, '1pn2D02', NULL, NULL, 128, NULL, NULL, 231320),
(245299, '3f1tB00', NULL, NULL, 148, NULL, NULL, 231320);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(245300, '3lbeB00', NULL, NULL, 126, NULL, NULL, 231320),
(245301, '4rmmA00', NULL, NULL, 154, NULL, NULL, 231320),
(245302, '2uv8G08', NULL, NULL, 289, NULL, NULL, 231320),
(245303, '2nujA01', NULL, NULL, 148, NULL, NULL, 231320),
(245304, '3d6xF00', NULL, NULL, 146, NULL, NULL, 231320),
(245305, '3esiA00', NULL, NULL, 129, NULL, NULL, 231320),
(245306, '3hm0A00', NULL, NULL, 134, NULL, NULL, 231320),
(245307, '4xy5A00', NULL, NULL, 137, NULL, NULL, 231320),
(245308, '4rv2B00', NULL, NULL, 141, NULL, NULL, 231320),
(245309, '2uvaG08', NULL, NULL, 293, NULL, NULL, 231320),
(245310, '1njkA00', NULL, NULL, 156, NULL, NULL, 231320),
(245311, '2gllF00', NULL, NULL, 149, NULL, NULL, 231320),
(245312, '2qq2J00', NULL, NULL, 157, NULL, NULL, 231320),
(245313, '4ae7A00', NULL, NULL, 196, NULL, NULL, 231320),
(245314, '4h4gD00', NULL, NULL, 160, NULL, NULL, 231320),
(245315, '1t82B00', NULL, NULL, 155, NULL, NULL, 231320),
(245316, '4mobA02', NULL, NULL, 154, NULL, NULL, 231320),
(245317, '4mobA01', NULL, NULL, 148, NULL, NULL, 231320),
(245318, '5hd6E00', NULL, NULL, 175, NULL, NULL, 231320),
(245319, '3d6xB00', NULL, NULL, 146, NULL, NULL, 231320),
(245320, '2fs2B00', NULL, NULL, 151, NULL, NULL, 231320),
(245321, '3f5oA00', NULL, NULL, 148, NULL, NULL, 231320),
(245322, '1ixlA00', NULL, NULL, 131, NULL, NULL, 231320),
(245323, '3qooA00', NULL, NULL, 138, NULL, NULL, 231320),
(245324, '5hd6C00', NULL, NULL, 175, NULL, NULL, 231320),
(245325, '3ck1A00', NULL, NULL, 150, NULL, NULL, 231320),
(245326, '2f3xA00', NULL, NULL, 157, NULL, NULL, 231320),
(245327, '4i4jF00', NULL, NULL, 159, NULL, NULL, 231320),
(245328, '3e1eC00', NULL, NULL, 141, NULL, NULL, 231320),
(245329, '2o5uA00', NULL, NULL, 148, NULL, NULL, 231320),
(245330, '1s9cC01', NULL, NULL, 163, NULL, NULL, 231320),
(245331, '2eisA00', NULL, NULL, 133, NULL, NULL, 231320),
(245332, '1sc0A00', NULL, NULL, 138, NULL, NULL, 231320),
(245333, '2ownA00', NULL, NULL, 262, NULL, NULL, 231320),
(245334, '1lo7A00', NULL, NULL, 141, NULL, NULL, 231320),
(245335, '5dm5A00', NULL, NULL, 135, NULL, NULL, 231320),
(245336, '2hx5A00', NULL, NULL, 152, NULL, NULL, 231320),
(245337, '1zkiA00', NULL, NULL, 133, NULL, NULL, 231320),
(245338, '3bjkC00', NULL, NULL, 153, NULL, NULL, 231320),
(245339, '2gvhC01', NULL, NULL, 136, NULL, NULL, 231320),
(245340, '5eo4A01', NULL, NULL, 142, NULL, NULL, 231320),
(245341, '3hduA00', NULL, NULL, 157, NULL, NULL, 231320),
(245342, '2w3xC00', NULL, NULL, 147, NULL, NULL, 231320),
(245343, '2bi0A01', NULL, NULL, 160, NULL, NULL, 231320),
(245344, '2bi0A02', NULL, NULL, 147, NULL, NULL, 231320),
(245345, '3nwzC00', NULL, NULL, 176, NULL, NULL, 231320),
(245346, '3wewA00', NULL, NULL, 258, NULL, NULL, 231320),
(245347, '6b7jB00', NULL, NULL, 175, NULL, NULL, 231320),
(245348, '3d6xE00', NULL, NULL, 146, NULL, NULL, 231320),
(245349, '3s4kA00', NULL, NULL, 126, NULL, NULL, 231320),
(245350, '3lw3B00', NULL, NULL, 145, NULL, NULL, 231320),
(245351, '3exzA00', NULL, NULL, 154, NULL, NULL, 231320),
(245352, '5cpgA00', NULL, NULL, 155, NULL, NULL, 231320),
(245353, '5vpjC00', NULL, NULL, 159, NULL, NULL, 231320),
(245354, '5tz6A01', NULL, NULL, 150, NULL, NULL, 231320),
(245355, '1s5uE00', NULL, NULL, 138, NULL, NULL, 231320),
(245356, '2gf6A00', NULL, NULL, 135, NULL, NULL, 231320),
(245357, '4m20A00', NULL, NULL, 127, NULL, NULL, 231320),
(245358, '1y7uA00', NULL, NULL, 174, NULL, NULL, 231320),
(245359, '1u1zB00', NULL, NULL, 146, NULL, NULL, 231320),
(245360, '1wluA00', NULL, NULL, 117, NULL, NULL, 231320),
(245361, '3qy3A00', NULL, NULL, 132, NULL, NULL, 231320),
(245362, '5buyB00', NULL, NULL, 156, NULL, NULL, 231320),
(245363, '3d6xA00', NULL, NULL, 146, NULL, NULL, 231320),
(245364, '5byuA00', NULL, NULL, 133, NULL, NULL, 231320),
(245365, '1z54A00', NULL, NULL, 132, NULL, NULL, 231320),
(245366, '5hd6H00', NULL, NULL, 175, NULL, NULL, 231320),
(245367, '4k02A00', NULL, NULL, 139, NULL, NULL, 231320),
(245368, '5hd6B00', NULL, NULL, 175, NULL, NULL, 231320),
(245369, '2c2iA00', NULL, NULL, 151, NULL, NULL, 231320),
(245370, '3khpC02', NULL, NULL, 134, NULL, NULL, 231320);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(245371, '2egjA00', NULL, NULL, 128, NULL, NULL, 231320),
(245372, '5dm5B00', NULL, NULL, 136, NULL, NULL, 231320),
(245373, '4a0zB00', NULL, NULL, 139, NULL, NULL, 231320),
(245374, '1zkiB00', NULL, NULL, 133, NULL, NULL, 231320),
(245375, '5v10A00', NULL, NULL, 151, NULL, NULL, 231320),
(245376, '2pimA00', NULL, NULL, 141, NULL, NULL, 231320),
(245377, '3k67A00', NULL, NULL, 159, NULL, NULL, 231320),
(245378, '4i83A00', NULL, NULL, 152, NULL, NULL, 231320),
(245379, '3omlA03', NULL, NULL, 296, NULL, NULL, 231320),
(245380, '1yocA00', NULL, NULL, 147, NULL, NULL, 231320),
(245381, '1tbuB00', NULL, NULL, 118, NULL, NULL, 231320),
(245382, '1q6wG00', NULL, NULL, 161, NULL, NULL, 231320),
(245383, '3b7kC02', NULL, NULL, 110, NULL, NULL, 231320),
(245384, '4w78F00', NULL, NULL, 127, NULL, NULL, 231320),
(245385, '4ae8D00', NULL, NULL, 211, NULL, NULL, 231320),
(245386, '4mocA02', NULL, NULL, 151, NULL, NULL, 231320),
(245387, '2cyeC00', NULL, NULL, 133, NULL, NULL, 231320),
(245388, '2v1oB00', NULL, NULL, 151, NULL, NULL, 231320),
(245389, '4mtuA00', NULL, NULL, 144, NULL, NULL, 231320),
(245390, '2hljA01', NULL, NULL, 140, NULL, NULL, 231320),
(245391, '4a12A02', NULL, NULL, 110, NULL, NULL, 231320),
(245392, '4qd8A00', NULL, NULL, 152, NULL, NULL, 231320),
(245393, '3d6xD00', NULL, NULL, 146, NULL, NULL, 231320),
(245394, '2pzhA00', NULL, NULL, 135, NULL, NULL, 231320),
(245395, '2prxA00', NULL, NULL, 160, NULL, NULL, 231320),
(245396, '4rljA00', NULL, NULL, 158, NULL, NULL, 231320),
(245397, '1vpmB00', NULL, NULL, 169, NULL, NULL, 231320),
(245398, '1z6bA00', NULL, NULL, 154, NULL, NULL, 231320),
(245399, '2h4uD00', NULL, NULL, 145, NULL, NULL, 231320),
(245400, '2qwzA01', NULL, NULL, 135, NULL, NULL, 231320),
(245401, '4b0bB00', NULL, NULL, 171, NULL, NULL, 231320),
(245402, '2cy9B00', NULL, NULL, 140, NULL, NULL, 231320),
(245403, '4k00A00', NULL, NULL, 141, NULL, NULL, 231320),
(245404, '5hd6G00', NULL, NULL, 175, NULL, NULL, 231320),
(245405, '5hd6A00', NULL, NULL, 175, NULL, NULL, 231320),
(245406, '2cwzA00', NULL, NULL, 141, NULL, NULL, 231320),
(245407, '1s9cE02', NULL, NULL, 136, NULL, NULL, 231320),
(245408, '3khpD01', NULL, NULL, 154, NULL, NULL, 231320),
(245409, '2oafB00', NULL, NULL, 151, NULL, NULL, 231320),
(245410, '2f41B00', NULL, NULL, 121, NULL, NULL, 231320),
(245411, '2essA02', NULL, NULL, 99, NULL, NULL, 231320),
(245412, '2q78F00', NULL, NULL, 153, NULL, NULL, 231320),
(245413, '6qsrA00', NULL, NULL, 119, NULL, NULL, 231320),
(245414, '2q2bA00', NULL, NULL, 162, NULL, NULL, 231320),
(245415, '4gakA00', NULL, NULL, 250, NULL, NULL, 231320),
(245416, '5eglA00', NULL, NULL, 176, NULL, NULL, 231320),
(245417, '3hduC00', NULL, NULL, 157, NULL, NULL, 231320),
(245418, '4zw0C00', NULL, NULL, 161, NULL, NULL, 231320),
(245419, '3kh8A02', NULL, NULL, 134, NULL, NULL, 231320),
(245420, '1pn2C01', NULL, NULL, 152, NULL, NULL, 231320),
(245421, '2essA01', NULL, NULL, 149, NULL, NULL, 231320),
(245422, '4w78G00', NULL, NULL, 178, NULL, NULL, 231320),
(245423, '2oiwA00', NULL, NULL, 136, NULL, NULL, 231320),
(245424, '2hboA01', NULL, NULL, 145, NULL, NULL, 231320),
(245425, '1c8uA02', NULL, NULL, 115, NULL, NULL, 231320),
(245426, '3e29B00', NULL, NULL, 144, NULL, NULL, 231320),
(245427, '3dkzA00', NULL, NULL, 142, NULL, NULL, 231320),
(245428, '1c8uA01', NULL, NULL, 156, NULL, NULL, 231320),
(245429, '3d6xC00', NULL, NULL, 146, NULL, NULL, 231320),
(245430, '3ir3A00', NULL, NULL, 148, NULL, NULL, 231320),
(245431, '4rv2A00', NULL, NULL, 146, NULL, NULL, 231320),
(245432, '3gekA00', NULL, NULL, 146, NULL, NULL, 231320),
(245433, '4rljB00', NULL, NULL, 147, NULL, NULL, 231320),
(245434, '2xemA00', NULL, NULL, 150, NULL, NULL, 231320),
(245435, '1vh5A00', NULL, NULL, 148, NULL, NULL, 231320),
(245436, '4hzpA00', NULL, NULL, 318, NULL, NULL, 231320),
(245437, '3kuvB00', NULL, NULL, 139, NULL, NULL, 231320),
(245438, '4kehB00', NULL, NULL, 171, NULL, NULL, 231320),
(245439, '1sh8B00', NULL, NULL, 154, NULL, NULL, 231320),
(245440, '5szvA00', NULL, NULL, 160, NULL, NULL, 231320),
(245441, '5f6rB00', NULL, NULL, 175, NULL, NULL, 231320);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(245442, '1iq6B00', NULL, NULL, 134, NULL, NULL, 231320),
(245443, '3r87A00', NULL, NULL, 135, NULL, NULL, 231320),
(245444, '3d6lA00', NULL, NULL, 137, NULL, NULL, 231320),
(245445, '3e8pA00', NULL, NULL, 164, NULL, NULL, 231320),
(245446, '2ov9B01', NULL, NULL, 157, NULL, NULL, 231320),
(245447, '2cy9A00', NULL, NULL, 140, NULL, NULL, 231320),
(245448, '5hd6F00', NULL, NULL, 175, NULL, NULL, 231320),
(245449, '4k4cA00', NULL, NULL, 137, NULL, NULL, 231320),
(245450, '2fujA00', NULL, NULL, 137, NULL, NULL, 231320),
(245451, '5buwA00', NULL, NULL, 144, NULL, NULL, 231320),
(245452, '5j47A01', NULL, NULL, 100, NULL, NULL, 231321),
(245453, '1svmA01', NULL, NULL, 105, NULL, NULL, 231321),
(245454, '2v9pA01', NULL, NULL, 76, NULL, NULL, 231321),
(245455, '3liuA01', NULL, NULL, 118, NULL, NULL, 231322),
(245456, '2gfpA00', NULL, NULL, 375, NULL, NULL, 231323),
(245457, '3cwzB03', NULL, NULL, 121, NULL, NULL, 231324),
(245458, '1olpA02', NULL, NULL, 121, NULL, NULL, 231324),
(245459, '1gplA02', NULL, NULL, 110, NULL, NULL, 231324),
(245460, '1ethA02', NULL, NULL, 109, NULL, NULL, 231324),
(245461, '3fg1A01', NULL, NULL, 118, NULL, NULL, 231324),
(245462, '1loxA02', NULL, NULL, 111, NULL, NULL, 231324),
(245463, '2iujA01', NULL, NULL, 163, NULL, NULL, 231324),
(245464, '2oxeB02', NULL, NULL, 125, NULL, NULL, 231324),
(245465, '1w52X02', NULL, NULL, 113, NULL, NULL, 231324),
(245466, '2iukA01', NULL, NULL, 175, NULL, NULL, 231324),
(245467, '4wfoA01', NULL, NULL, 159, NULL, NULL, 231324),
(245468, '1hplA02', NULL, NULL, 111, NULL, NULL, 231324),
(245469, '1khoA02', NULL, NULL, 120, NULL, NULL, 231324),
(245470, '3v98B01', NULL, NULL, 132, NULL, NULL, 231324),
(245471, '2wxuA02', NULL, NULL, 120, NULL, NULL, 231324),
(245472, '1bu8A02', NULL, NULL, 112, NULL, NULL, 231324),
(245473, '1ik3A01', NULL, NULL, 167, NULL, NULL, 231324),
(245474, '3vf1A01', NULL, NULL, 118, NULL, NULL, 231324),
(245475, '1rp1A02', NULL, NULL, 110, NULL, NULL, 231324),
(245476, '2pplA02', NULL, NULL, 110, NULL, NULL, 231324),
(245477, '4nreA01', NULL, NULL, 120, NULL, NULL, 231324),
(245478, '2hqsA01', NULL, NULL, 143, NULL, NULL, 231325),
(245479, '4pwzA01', NULL, NULL, 146, NULL, NULL, 231325),
(245480, '2z1dA03', NULL, NULL, 53, NULL, NULL, 231326),
(245481, '2bteA05', NULL, NULL, 64, NULL, NULL, 231327),
(245482, '4arcA05', NULL, NULL, 62, NULL, NULL, 231327),
(245483, '2qr6A01', NULL, NULL, 34, NULL, NULL, 231328),
(245484, '2b39A07', NULL, NULL, 41, NULL, NULL, 231329),
(245485, '6ereA00', NULL, NULL, 134, NULL, NULL, 231330),
(245486, '6er6B00', NULL, NULL, 134, NULL, NULL, 231330),
(245487, '3u43B00', NULL, NULL, 134, NULL, NULL, 231330),
(245488, '3zfkA00', NULL, NULL, 135, NULL, NULL, 231330),
(245489, '1mz8D00', NULL, NULL, 131, NULL, NULL, 231330),
(245490, '2gykB00', NULL, NULL, 134, NULL, NULL, 231330),
(245491, '2erhB00', NULL, NULL, 127, NULL, NULL, 231330),
(245492, '4qkoB00', NULL, NULL, 134, NULL, NULL, 231330),
(245493, '4uhqA00', NULL, NULL, 136, NULL, NULL, 231330),
(245494, '1k32A01', NULL, NULL, 284, NULL, NULL, 231331),
(245495, '3da1A03', NULL, NULL, 148, NULL, NULL, 231332),
(245496, '2rgoB03', NULL, NULL, 134, NULL, NULL, 231332),
(245497, '2qcuA03', NULL, NULL, 71, NULL, NULL, 231332),
(245498, '4it6B00', NULL, NULL, 124, NULL, NULL, 231333),
(245499, '5mu3B00', NULL, NULL, 165, NULL, NULL, 231334),
(245500, '1y6uA01', NULL, NULL, 49, NULL, NULL, 231335),
(245501, '2hdiB00', NULL, NULL, 113, NULL, NULL, 231336),
(245502, '1hgvA00', NULL, NULL, 46, NULL, NULL, 231337),
(245503, '2c0wA00', NULL, NULL, 50, NULL, NULL, 231337),
(245504, '6a7fA00', NULL, NULL, 53, NULL, NULL, 231337),
(245505, '3hzsA00', NULL, NULL, 209, NULL, NULL, 231338),
(245506, '5fgzA02', NULL, NULL, 163, NULL, NULL, 231338),
(245507, '2olvB02', NULL, NULL, 198, NULL, NULL, 231338),
(245508, '3vmaA04', NULL, NULL, 204, NULL, NULL, 231338),
(245509, '2oqoA00', NULL, NULL, 200, NULL, NULL, 231338),
(245510, '3cqbB01', NULL, NULL, 94, NULL, NULL, 231339),
(245511, '3cqbA01', NULL, NULL, 94, NULL, NULL, 231339),
(245512, '4qhfA00', NULL, NULL, 110, NULL, NULL, 231339);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(245513, '4aw6A02', NULL, NULL, 84, NULL, NULL, 231339),
(245514, '4jixB00', NULL, NULL, 112, NULL, NULL, 231339),
(245515, '4jiuA00', NULL, NULL, 105, NULL, NULL, 231339),
(245516, '4il3A02', NULL, NULL, 84, NULL, NULL, 231339),
(245517, '2lq3A01', NULL, NULL, 75, NULL, NULL, 231340),
(245518, '2e4uA03', NULL, NULL, 77, NULL, NULL, 231341),
(245519, '5e24F01', NULL, NULL, 172, NULL, NULL, 231342),
(245520, '3iagC01', NULL, NULL, 170, NULL, NULL, 231342),
(245521, '3brdA01', NULL, NULL, 209, NULL, NULL, 231342),
(245522, '3ijmA00', NULL, NULL, 151, NULL, NULL, 231343),
(245523, '4apmA03', NULL, NULL, 76, NULL, NULL, 231344),
(245524, '2zw3A00', NULL, NULL, 226, NULL, NULL, 231345),
(245525, '1lu9A01', NULL, NULL, 136, NULL, NULL, 231346),
(245526, '2pusA01', NULL, NULL, 343, NULL, NULL, 231347),
(245527, '2yi9A01', NULL, NULL, 338, NULL, NULL, 231347),
(245528, '2j9lA02', NULL, NULL, 92, NULL, NULL, 231348),
(245529, '1v74B00', NULL, NULL, 87, NULL, NULL, 231349),
(245530, '4l4qA02', NULL, NULL, 127, NULL, NULL, 231350),
(245531, '4l7iA02', NULL, NULL, 127, NULL, NULL, 231350),
(245532, '2r41D00', NULL, NULL, 110, NULL, NULL, 231351),
(245533, '6ig5A03', NULL, NULL, 72, NULL, NULL, 231352),
(245534, '4mx2B03', NULL, NULL, 66, NULL, NULL, 231352),
(245535, '5uppA03', NULL, NULL, 52, NULL, NULL, 231352),
(245536, '3ocfB03', NULL, NULL, 35, NULL, NULL, 231352),
(245537, '3ocfA03', NULL, NULL, 51, NULL, NULL, 231352),
(245538, '1re5A03', NULL, NULL, 89, NULL, NULL, 231352),
(245539, '3qbpA03', NULL, NULL, 56, NULL, NULL, 231352),
(245540, '4eeiA03', NULL, NULL, 90, NULL, NULL, 231352),
(245541, '1i0aA03', NULL, NULL, 72, NULL, NULL, 231352),
(245542, '1furB03', NULL, NULL, 51, NULL, NULL, 231352),
(245543, '1k62A03', NULL, NULL, 72, NULL, NULL, 231352),
(245544, '1jswB03', NULL, NULL, 50, NULL, NULL, 231352),
(245545, '1furA03', NULL, NULL, 60, NULL, NULL, 231352),
(245546, '6n1mA03', NULL, NULL, 52, NULL, NULL, 231352),
(245547, '1dofA03', NULL, NULL, 56, NULL, NULL, 231352),
(245548, '1hy0A03', NULL, NULL, 72, NULL, NULL, 231352),
(245549, '1c3cA03', NULL, NULL, 81, NULL, NULL, 231352),
(245550, '4hgvA03', NULL, NULL, 51, NULL, NULL, 231352),
(245551, '3c8tA03', NULL, NULL, 92, NULL, NULL, 231352),
(245552, '3tv2A03', NULL, NULL, 56, NULL, NULL, 231352),
(245553, '2ptrB03', NULL, NULL, 64, NULL, NULL, 231352),
(245554, '3rrpA03', NULL, NULL, 56, NULL, NULL, 231352),
(245555, '2e9fA03', NULL, NULL, 71, NULL, NULL, 231352),
(245556, '1tj7A03', NULL, NULL, 71, NULL, NULL, 231352),
(245557, '4nleA03', NULL, NULL, 76, NULL, NULL, 231352),
(245558, '1q5nA03', NULL, NULL, 81, NULL, NULL, 231352),
(245559, '1k7wA03', NULL, NULL, 72, NULL, NULL, 231352),
(245560, '4nslA03', NULL, NULL, 64, NULL, NULL, 231352),
(245561, '1yfmA03', NULL, NULL, 52, NULL, NULL, 231352),
(245562, '2qgaB03', NULL, NULL, 66, NULL, NULL, 231352),
(245563, '3oceA03', NULL, NULL, 64, NULL, NULL, 231352),
(245564, '3rd8A03', NULL, NULL, 56, NULL, NULL, 231352),
(245565, '3gtdA03', NULL, NULL, 48, NULL, NULL, 231352),
(245566, '4admA03', NULL, NULL, 56, NULL, NULL, 231352),
(245567, '3bhgA03', NULL, NULL, 64, NULL, NULL, 231352),
(245568, '2pfmA03', NULL, NULL, 85, NULL, NULL, 231352),
(245569, '1vdkB03', NULL, NULL, 62, NULL, NULL, 231352),
(245570, '3r6qA03', NULL, NULL, 52, NULL, NULL, 231352),
(245571, '2x75A03', NULL, NULL, 83, NULL, NULL, 231352),
(245572, '4efcA03', NULL, NULL, 66, NULL, NULL, 231352),
(245573, '1k8bA00', NULL, NULL, 52, NULL, NULL, 231353),
(245574, '2k5qA00', NULL, NULL, 105, NULL, NULL, 231354),
(245575, '2k5wA00', NULL, NULL, 117, NULL, NULL, 231354),
(245576, '3nppA00', NULL, NULL, 87, NULL, NULL, 231354),
(245577, '4ritB01', NULL, NULL, 242, NULL, NULL, 231355),
(245578, '2okkA01', NULL, NULL, 248, NULL, NULL, 231355),
(245579, '2jisA01', NULL, NULL, 239, NULL, NULL, 231355),
(245580, '3vp6B01', NULL, NULL, 262, NULL, NULL, 231355),
(245581, '6enzA01', NULL, NULL, 244, NULL, NULL, 231355),
(245582, '4obuA01', NULL, NULL, 249, NULL, NULL, 231355),
(245583, '2h88A04', NULL, NULL, 65, NULL, NULL, 231356);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(245584, '4ysxA04', NULL, NULL, 65, NULL, NULL, 231356),
(245585, '3gqhA02', NULL, NULL, 40, NULL, NULL, 231356),
(245586, '1kf6A04', NULL, NULL, 35, NULL, NULL, 231356),
(245587, '1zoyA04', NULL, NULL, 65, NULL, NULL, 231356),
(245588, '2wdqA04', NULL, NULL, 41, NULL, NULL, 231356),
(245589, '4myzC00', NULL, NULL, 79, NULL, NULL, 231357),
(245590, '2r4jB04', NULL, NULL, 40, NULL, NULL, 231358),
(245591, '3pmcA00', NULL, NULL, 139, NULL, NULL, 231359),
(245592, '3pmdA00', NULL, NULL, 153, NULL, NULL, 231359),
(245593, '2konA00', NULL, NULL, 82, NULL, NULL, 231360),
(245594, '2mj6A00', NULL, NULL, 90, NULL, NULL, 231361),
(245595, '1l5jA01', NULL, NULL, 161, NULL, NULL, 231362),
(245596, '2r3sA02', NULL, NULL, 37, NULL, NULL, 231363),
(245597, '6bdyA01', NULL, NULL, 245, NULL, NULL, 231364),
(245598, '2o2kA01', NULL, NULL, 263, NULL, NULL, 231364),
(245599, '2od0A00', NULL, NULL, 105, NULL, NULL, 231365),
(245600, '2p01A02', NULL, NULL, 105, NULL, NULL, 231366),
(245601, '2fcwA00', NULL, NULL, 109, NULL, NULL, 231366),
(245602, '1op1A00', NULL, NULL, 82, NULL, NULL, 231366),
(245603, '4ar9A01', NULL, NULL, 144, NULL, NULL, 231367),
(245604, '4arfA01', NULL, NULL, 143, NULL, NULL, 231367),
(245605, '2wb0X02', NULL, NULL, 176, NULL, NULL, 231368),
(245606, '1aduB02', NULL, NULL, 165, NULL, NULL, 231368),
(245607, '2m5sA00', NULL, NULL, 130, NULL, NULL, 231369),
(245608, '4ak2A01', NULL, NULL, 118, NULL, NULL, 231370),
(245609, '2xdpA02', NULL, NULL, 54, NULL, NULL, 231371),
(245610, '4uc4A02', NULL, NULL, 55, NULL, NULL, 231371),
(245611, '2qqrA02', NULL, NULL, 53, NULL, NULL, 231371),
(245612, '6f1dA00', NULL, NULL, 117, NULL, NULL, 231372),
(245613, '3pojB00', NULL, NULL, 115, NULL, NULL, 231372),
(245614, '4losA01', NULL, NULL, 118, NULL, NULL, 231372),
(245615, '6gh8A00', NULL, NULL, 133, NULL, NULL, 231372),
(245616, '4gz9A02', NULL, NULL, 124, NULL, NULL, 231372),
(245617, '4gz9A01', NULL, NULL, 127, NULL, NULL, 231372),
(245618, '1sfpA00', NULL, NULL, 114, NULL, NULL, 231372),
(245619, '1szbB01', NULL, NULL, 125, NULL, NULL, 231372),
(245620, '3kq4B02', NULL, NULL, 118, NULL, NULL, 231372),
(245621, '1sppB00', NULL, NULL, 116, NULL, NULL, 231372),
(245622, '3demA01', NULL, NULL, 120, NULL, NULL, 231372),
(245623, '3kq4B01', NULL, NULL, 116, NULL, NULL, 231372),
(245624, '3kq4B04', NULL, NULL, 111, NULL, NULL, 231372),
(245625, '3demA03', NULL, NULL, 114, NULL, NULL, 231372),
(245626, '3kq4B03', NULL, NULL, 112, NULL, NULL, 231372),
(245627, '2qqmA01', NULL, NULL, 129, NULL, NULL, 231372),
(245628, '2qqoA01', NULL, NULL, 126, NULL, NULL, 231372),
(245629, '1sppA00', NULL, NULL, 109, NULL, NULL, 231372),
(245630, '2wnoA01', NULL, NULL, 113, NULL, NULL, 231372),
(245631, '1nziA01', NULL, NULL, 117, NULL, NULL, 231372),
(245632, '5cisA03', NULL, NULL, 116, NULL, NULL, 231372),
(245633, '5cisA01', NULL, NULL, 118, NULL, NULL, 231372),
(245634, '3zx7A01', NULL, NULL, 163, NULL, NULL, 231373),
(245635, '3drxA02', NULL, NULL, 46, NULL, NULL, 231374),
(245636, '3lynB00', NULL, NULL, 136, NULL, NULL, 231375),
(245637, '5ii8A00', NULL, NULL, 138, NULL, NULL, 231375),
(245638, '1gakA00', NULL, NULL, 141, NULL, NULL, 231375),
(245639, '1bjtA01', NULL, NULL, 43, NULL, NULL, 231376),
(245640, '3l4jA02', NULL, NULL, 47, NULL, NULL, 231376),
(245641, '4fm9A02', NULL, NULL, 44, NULL, NULL, 231376),
(245642, '2xqhA01', NULL, NULL, 135, NULL, NULL, 231377),
(245643, '3wp8A02', NULL, NULL, 152, NULL, NULL, 231377),
(245644, '3laaA00', NULL, NULL, 175, NULL, NULL, 231377),
(245645, '3ntnB01', NULL, NULL, 168, NULL, NULL, 231377),
(245646, '3s6lD00', NULL, NULL, 178, NULL, NULL, 231377),
(245647, '1k7iA01', NULL, NULL, 234, NULL, NULL, 231377),
(245648, '1p9hA00', NULL, NULL, 189, NULL, NULL, 231377),
(245649, '3u1rA01', NULL, NULL, 231, NULL, NULL, 231377),
(245650, '1g9kA01', NULL, NULL, 233, NULL, NULL, 231377),
(245651, '3hbvP02', NULL, NULL, 242, NULL, NULL, 231377),
(245652, '1kapP01', NULL, NULL, 246, NULL, NULL, 231377),
(245653, '3ultA00', NULL, NULL, 133, NULL, NULL, 231377),
(245654, '2yo0A01', NULL, NULL, 159, NULL, NULL, 231377);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(245655, '5d7wA01', NULL, NULL, 237, NULL, NULL, 231377),
(245656, '2fknA02', NULL, NULL, 208, NULL, NULL, 231378),
(245657, '1x87A02', NULL, NULL, 218, NULL, NULL, 231378),
(245658, '1uwkA02', NULL, NULL, 208, NULL, NULL, 231378),
(245659, '2kkrA01', NULL, NULL, 27, NULL, NULL, 231379),
(245660, '4krgA02', NULL, NULL, 205, NULL, NULL, 231380),
(245661, '2gm4A02', NULL, NULL, 39, NULL, NULL, 231381),
(245662, '1gdtB02', NULL, NULL, 40, NULL, NULL, 231381),
(245663, '1zr4A02', NULL, NULL, 39, NULL, NULL, 231381),
(245664, '4fwvA02', NULL, NULL, 146, NULL, NULL, 231382),
(245665, '1rquA01', NULL, NULL, 52, NULL, NULL, 231383),
(245666, '1rquB01', NULL, NULL, 31, NULL, NULL, 231383),
(245667, '1dd4D01', NULL, NULL, 30, NULL, NULL, 231383),
(245668, '1dd3A01', NULL, NULL, 57, NULL, NULL, 231383),
(245669, '3on9A00', NULL, NULL, 163, NULL, NULL, 231384),
(245670, '1af7A01', NULL, NULL, 80, NULL, NULL, 231385),
(245671, '1bx7A00', NULL, NULL, 55, NULL, NULL, 231386),
(245672, '3bg4D00', NULL, NULL, 57, NULL, NULL, 231386),
(245673, '1skzA02', NULL, NULL, 62, NULL, NULL, 231386),
(245674, '1ejaB00', NULL, NULL, 59, NULL, NULL, 231386),
(245675, '1skzA01', NULL, NULL, 57, NULL, NULL, 231386),
(245676, '4bwpB02', NULL, NULL, 45, NULL, NULL, 231387),
(245677, '4bwxA02', NULL, NULL, 53, NULL, NULL, 231387),
(245678, '4cyiA02', NULL, NULL, 59, NULL, NULL, 231387),
(245679, '4bwkA02', NULL, NULL, 44, NULL, NULL, 231387),
(245680, '1wp9B03', NULL, NULL, 130, NULL, NULL, 231388),
(245681, '3ez9A01', NULL, NULL, 70, NULL, NULL, 231389),
(245682, '3ez2A01', NULL, NULL, 70, NULL, NULL, 231389),
(245683, '6fmeA03', NULL, NULL, 62, NULL, NULL, 231390),
(245684, '4u3jA01', NULL, NULL, 269, NULL, NULL, 231391),
(245685, '3v3tA01', NULL, NULL, 213, NULL, NULL, 231391),
(245686, '4u3jB01', NULL, NULL, 259, NULL, NULL, 231391),
(245687, '3zidB00', NULL, NULL, 373, NULL, NULL, 231391),
(245688, '4b45A01', NULL, NULL, 223, NULL, NULL, 231391),
(245689, '3m89A00', NULL, NULL, 406, NULL, NULL, 231391),
(245690, '2r75101', NULL, NULL, 220, NULL, NULL, 231391),
(245691, '4m8iA01', NULL, NULL, 210, NULL, NULL, 231391),
(245692, '5mn7A01', NULL, NULL, 166, NULL, NULL, 231391),
(245693, '6e7bB01', NULL, NULL, 259, NULL, NULL, 231391),
(245694, '1w5fA01', NULL, NULL, 195, NULL, NULL, 231391),
(245695, '4e6eA01', NULL, NULL, 218, NULL, NULL, 231391),
(245696, '4b46A01', NULL, NULL, 229, NULL, NULL, 231391),
(245697, '5nquA01', NULL, NULL, 268, NULL, NULL, 231391),
(245698, '3cb2B01', NULL, NULL, 269, NULL, NULL, 231391),
(245699, '1rq2A01', NULL, NULL, 220, NULL, NULL, 231391),
(245700, '4i4tB01', NULL, NULL, 259, NULL, NULL, 231391),
(245701, '3zbqA00', NULL, NULL, 333, NULL, NULL, 231391),
(245702, '2vapA01', NULL, NULL, 212, NULL, NULL, 231391),
(245703, '3r4vA01', NULL, NULL, 295, NULL, NULL, 231391),
(245704, '2vxyA01', NULL, NULL, 220, NULL, NULL, 231391),
(245705, '1ofuA01', NULL, NULL, 213, NULL, NULL, 231391),
(245706, '4ei7A02', NULL, NULL, 234, NULL, NULL, 231391),
(245707, '2btqA01', NULL, NULL, 377, NULL, NULL, 231391),
(245708, '2btqB01', NULL, NULL, 266, NULL, NULL, 231391),
(245709, '3vpaB00', NULL, NULL, 308, NULL, NULL, 231391),
(245710, '2btoA01', NULL, NULL, 272, NULL, NULL, 231391),
(245711, '1hn3A01', NULL, NULL, 30, NULL, NULL, 231392),
(245712, '1ydxA02', NULL, NULL, 99, NULL, NULL, 231393),
(245713, '1yf2A02', NULL, NULL, 107, NULL, NULL, 231393),
(245714, '2lfuA01', NULL, NULL, 31, NULL, NULL, 231394),
(245715, '4rlbA00', NULL, NULL, 213, NULL, NULL, 231395),
(245716, '4fuvA00', NULL, NULL, 233, NULL, NULL, 231395),
(245717, '4rl9A00', NULL, NULL, 212, NULL, NULL, 231395),
(245718, '4fcaA02', NULL, NULL, 135, NULL, NULL, 231396),
(245719, '2ky4A01', NULL, NULL, 131, NULL, NULL, 231397),
(245720, '3osjA01', NULL, NULL, 129, NULL, NULL, 231397),
(245721, '3nphB00', NULL, NULL, 148, NULL, NULL, 231397),
(245722, '2l8vA01', NULL, NULL, 128, NULL, NULL, 231397),
(245723, '3pruA01', NULL, NULL, 128, NULL, NULL, 231397),
(245724, '2l3wA01', NULL, NULL, 128, NULL, NULL, 231397),
(245725, '3ohwA00', NULL, NULL, 128, NULL, NULL, 231397);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(245726, '2h6oA01', NULL, NULL, 149, NULL, NULL, 231398),
(245727, '4rlzA02', NULL, NULL, 110, NULL, NULL, 231399),
(245728, '4rdlA02', NULL, NULL, 107, NULL, NULL, 231399),
(245729, '4qv2A02', NULL, NULL, 148, NULL, NULL, 231399),
(245730, '6jyrA02', NULL, NULL, 110, NULL, NULL, 231399),
(245731, '5e6tA02', NULL, NULL, 94, NULL, NULL, 231399),
(245732, '4p1vA02', NULL, NULL, 100, NULL, NULL, 231399),
(245733, '5iypA02', NULL, NULL, 107, NULL, NULL, 231399),
(245734, '6gw4A02', NULL, NULL, 114, NULL, NULL, 231399),
(245735, '2obsA02', NULL, NULL, 107, NULL, NULL, 231399),
(245736, '6gw0A02', NULL, NULL, 108, NULL, NULL, 231399),
(245737, '6e48A02', NULL, NULL, 114, NULL, NULL, 231399),
(245738, '4qvaA02', NULL, NULL, 117, NULL, NULL, 231399),
(245739, '5f4jA02', NULL, NULL, 111, NULL, NULL, 231399),
(245740, '3astA02', NULL, NULL, 101, NULL, NULL, 231399),
(245741, '3q39B02', NULL, NULL, 118, NULL, NULL, 231399),
(245742, '5zuqA02', NULL, NULL, 111, NULL, NULL, 231399),
(245743, '4ooxA02', NULL, NULL, 113, NULL, NULL, 231399),
(245744, '5j35A02', NULL, NULL, 113, NULL, NULL, 231399),
(245745, '4oovA02', NULL, NULL, 113, NULL, NULL, 231399),
(245746, '5konA02', NULL, NULL, 113, NULL, NULL, 231399),
(245747, '2zl7A02', NULL, NULL, 91, NULL, NULL, 231399),
(245748, '5lkkA02', NULL, NULL, 110, NULL, NULL, 231399),
(245749, '5ysxA02', NULL, NULL, 115, NULL, NULL, 231399),
(245750, '3pvdA02', NULL, NULL, 107, NULL, NULL, 231399),
(245751, '4rpdA02', NULL, NULL, 108, NULL, NULL, 231399),
(245752, '6jyoA02', NULL, NULL, 111, NULL, NULL, 231399),
(245753, '5o02A02', NULL, NULL, 109, NULL, NULL, 231399),
(245754, '4rpbA02', NULL, NULL, 115, NULL, NULL, 231399),
(245755, '3sjpA02', NULL, NULL, 107, NULL, NULL, 231399),
(245756, '3r6kA02', NULL, NULL, 108, NULL, NULL, 231399),
(245757, '2w62A02', NULL, NULL, 113, NULL, NULL, 231400),
(245758, '2w61A03', NULL, NULL, 120, NULL, NULL, 231400),
(245759, '4n7bA01', NULL, NULL, 116, NULL, NULL, 231401),
(245760, '4n7bA03', NULL, NULL, 97, NULL, NULL, 231401),
(245761, '3dnfA03', NULL, NULL, 99, NULL, NULL, 231401),
(245762, '3dnfB01', NULL, NULL, 115, NULL, NULL, 231401),
(245763, '4h4dA03', NULL, NULL, 100, NULL, NULL, 231401),
(245764, '4h4dA01', NULL, NULL, 121, NULL, NULL, 231401),
(245765, '3vqiA01', NULL, NULL, 125, NULL, NULL, 231402),
(245766, '4tq1A02', NULL, NULL, 102, NULL, NULL, 231402),
(245767, '2dymC01', NULL, NULL, 122, NULL, NULL, 231402),
(245768, '3bg5B02', NULL, NULL, 24, NULL, NULL, 231403),
(245769, '4e0iA01', NULL, NULL, 47, NULL, NULL, 231404),
(245770, '1zhxA03', NULL, NULL, 191, NULL, NULL, 231405),
(245771, '3wwtA00', NULL, NULL, 139, NULL, NULL, 231406),
(245772, '1bgfA00', NULL, NULL, 124, NULL, NULL, 231406),
(245773, '4ziaE00', NULL, NULL, 129, NULL, NULL, 231406),
(245774, '1zvpD00', NULL, NULL, 133, NULL, NULL, 231407),
(245775, '2f06A00', NULL, NULL, 144, NULL, NULL, 231407),
(245776, '3c1mA02', NULL, NULL, 171, NULL, NULL, 231407),
(245777, '3ab4E02', NULL, NULL, 177, NULL, NULL, 231407),
(245778, '1zhvA00', NULL, NULL, 134, NULL, NULL, 231407),
(245779, '3tviE02', NULL, NULL, 167, NULL, NULL, 231407),
(245780, '5yeiA02', NULL, NULL, 161, NULL, NULL, 231407),
(245781, '2gjhA00', NULL, NULL, 62, NULL, NULL, 231408),
(245782, '3pesA00', NULL, NULL, 85, NULL, NULL, 231409),
(245783, '2k6xA00', NULL, NULL, 72, NULL, NULL, 231410),
(245784, '4kn7X01', NULL, NULL, 64, NULL, NULL, 231410),
(245785, '1z8sA02', NULL, NULL, 42, NULL, NULL, 231411),
(245786, '2r6cI02', NULL, NULL, 42, NULL, NULL, 231411),
(245787, '2r6cH02', NULL, NULL, 42, NULL, NULL, 231411),
(245788, '2r6cG02', NULL, NULL, 42, NULL, NULL, 231411),
(245789, '2r6aC02', NULL, NULL, 42, NULL, NULL, 231411),
(245790, '4czzB00', NULL, NULL, 133, NULL, NULL, 231412),
(245791, '2iw5B00', NULL, NULL, 133, NULL, NULL, 231412),
(245792, '2eeyA00', NULL, NULL, 162, NULL, NULL, 231413),
(245793, '2ohdF00', NULL, NULL, 151, NULL, NULL, 231413),
(245794, '1ekrA00', NULL, NULL, 161, NULL, NULL, 231413),
(245795, '4pydF00', NULL, NULL, 122, NULL, NULL, 231413),
(245796, '2iihA00', NULL, NULL, 157, NULL, NULL, 231413);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(245797, '2eknA00', NULL, NULL, 159, NULL, NULL, 231413),
(245798, '4fdfB00', NULL, NULL, 153, NULL, NULL, 231413),
(245799, '2igpA00', NULL, NULL, 120, NULL, NULL, 231414),
(245800, '3geeA02', NULL, NULL, 168, NULL, NULL, 231415),
(245801, '1xzpA02', NULL, NULL, 166, NULL, NULL, 231415),
(245802, '3gehA02', NULL, NULL, 167, NULL, NULL, 231415),
(245803, '1xl3C00', NULL, NULL, 92, NULL, NULL, 231416),
(245804, '3l4gC01', NULL, NULL, 105, NULL, NULL, 231417),
(245805, '3thfA00', NULL, NULL, 190, NULL, NULL, 231418),
(245806, '3x1lB02', NULL, NULL, 63, NULL, NULL, 231419),
(245807, '4bwcA02', NULL, NULL, 117, NULL, NULL, 231420),
(245808, '3fgrA02', NULL, NULL, 134, NULL, NULL, 231420),
(245809, '1mukA02', NULL, NULL, 510, NULL, NULL, 231421),
(245810, '5zvs202', NULL, NULL, 511, NULL, NULL, 231421),
(245811, '2wjnH01', NULL, NULL, 119, NULL, NULL, 231422),
(245812, '5y5sH01', NULL, NULL, 118, NULL, NULL, 231422),
(245813, '1rzhH01', NULL, NULL, 105, NULL, NULL, 231422),
(245814, '6az1Y00', NULL, NULL, 90, NULL, NULL, 231423),
(245815, '2xzmZ00', NULL, NULL, 97, NULL, NULL, 231423),
(245816, '5xxuV00', NULL, NULL, 82, NULL, NULL, 231423),
(245817, '6faiV00', NULL, NULL, 87, NULL, NULL, 231423),
(245818, '3jamV00', NULL, NULL, 87, NULL, NULL, 231423),
(245819, '5xyiV00', NULL, NULL, 89, NULL, NULL, 231423),
(245820, '3j7aZ00', NULL, NULL, 82, NULL, NULL, 231423),
(245821, '5optg00', NULL, NULL, 86, NULL, NULL, 231423),
(245822, '6g5iV00', NULL, NULL, 83, NULL, NULL, 231423),
(245823, '1nbwB00', NULL, NULL, 117, NULL, NULL, 231424),
(245824, '5d5pA02', NULL, NULL, 131, NULL, NULL, 231424),
(245825, '2d0oB00', NULL, NULL, 125, NULL, NULL, 231424),
(245826, '3brcB02', NULL, NULL, 121, NULL, NULL, 231424),
(245827, '3wb0A02', NULL, NULL, 129, NULL, NULL, 231424),
(245828, '5yrvE00', NULL, NULL, 179, NULL, NULL, 231424),
(245829, '1iwpB00', NULL, NULL, 194, NULL, NULL, 231424),
(245830, '3qdrB00', NULL, NULL, 63, NULL, NULL, 231425),
(245831, '1mhyG01', NULL, NULL, 68, NULL, NULL, 231426),
(245832, '1mtyG01', NULL, NULL, 68, NULL, NULL, 231426),
(245833, '1rylA00', NULL, NULL, 167, NULL, NULL, 231427),
(245834, '2nogA01', NULL, NULL, 70, NULL, NULL, 231428),
(245835, '2y9yA01', NULL, NULL, 92, NULL, NULL, 231428),
(245836, '2y9zA01', NULL, NULL, 94, NULL, NULL, 231428),
(245837, '1ofcX01', NULL, NULL, 108, NULL, NULL, 231428),
(245838, '4ragA02', NULL, NULL, 73, NULL, NULL, 231429),
(245839, '4exnB00', NULL, NULL, 175, NULL, NULL, 231430),
(245840, '4dkcB00', NULL, NULL, 190, NULL, NULL, 231430),
(245841, '4dkdB00', NULL, NULL, 185, NULL, NULL, 231430),
(245842, '4dkfB00', NULL, NULL, 146, NULL, NULL, 231430),
(245843, '5u91A02', NULL, NULL, 200, NULL, NULL, 231431),
(245844, '5dcfA01', NULL, NULL, 183, NULL, NULL, 231431),
(245845, '1xo0A02', NULL, NULL, 200, NULL, NULL, 231431),
(245846, '2a3vA02', NULL, NULL, 217, NULL, NULL, 231431),
(245847, '4a8eA02', NULL, NULL, 197, NULL, NULL, 231431),
(245848, '3vcfA00', NULL, NULL, 163, NULL, NULL, 231431),
(245849, '1floC02', NULL, NULL, 268, NULL, NULL, 231431),
(245850, '5c6kB00', NULL, NULL, 175, NULL, NULL, 231431),
(245851, '1ae9A00', NULL, NULL, 179, NULL, NULL, 231431),
(245852, '1aihA00', NULL, NULL, 170, NULL, NULL, 231431),
(245853, '3nkhA00', NULL, NULL, 224, NULL, NULL, 231431),
(245854, '1rkiA01', NULL, NULL, 97, NULL, NULL, 231432),
(245855, '3cqcB02', NULL, NULL, 135, NULL, NULL, 231433),
(245856, '1vx7e00', NULL, NULL, 51, NULL, NULL, 231434),
(245857, '1vwxl00', NULL, NULL, 51, NULL, NULL, 231434),
(245858, '1vq8200', NULL, NULL, 50, NULL, NULL, 231434),
(245859, '4a18B00', NULL, NULL, 52, NULL, NULL, 231434),
(245860, '3o58e00', NULL, NULL, 51, NULL, NULL, 231434),
(245861, '2j7nA02', NULL, NULL, 80, NULL, NULL, 231435),
(245862, '5fswA02', NULL, NULL, 77, NULL, NULL, 231435),
(245863, '2l81A00', NULL, NULL, 176, NULL, NULL, 231436),
(245864, '1z23A00', NULL, NULL, 163, NULL, NULL, 231436),
(245865, '2iw3A02', NULL, NULL, 90, NULL, NULL, 231437),
(245866, '1ztmB04', NULL, NULL, 57, NULL, NULL, 231438),
(245867, '1wp7A00', NULL, NULL, 89, NULL, NULL, 231438);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(245868, '2qtsD01', NULL, NULL, 72, NULL, NULL, 231438),
(245869, '4ntwA01', NULL, NULL, 69, NULL, NULL, 231438),
(245870, '2fb5A01', NULL, NULL, 73, NULL, NULL, 231438),
(245871, '3n27C00', NULL, NULL, 80, NULL, NULL, 231438),
(245872, '3s3xB01', NULL, NULL, 44, NULL, NULL, 231438),
(245873, '2l35A00', NULL, NULL, 63, NULL, NULL, 231438),
(245874, '6humC00', NULL, NULL, 132, NULL, NULL, 231439),
(245875, '3rkoA00', NULL, NULL, 126, NULL, NULL, 231439),
(245876, '5lnkA00', NULL, NULL, 115, NULL, NULL, 231439),
(245877, '5xtcj00', NULL, NULL, 115, NULL, NULL, 231439),
(245878, '4heaA00', NULL, NULL, 119, NULL, NULL, 231439),
(245879, '6g2jA00', NULL, NULL, 115, NULL, NULL, 231439),
(245880, '3bjqJ00', NULL, NULL, 316, NULL, NULL, 231440),
(245881, '4esnA00', NULL, NULL, 104, NULL, NULL, 231441),
(245882, '3ld7A00', NULL, NULL, 101, NULL, NULL, 231441),
(245883, '1m1hA02', NULL, NULL, 82, NULL, NULL, 231441),
(245884, '4obiA00', NULL, NULL, 106, NULL, NULL, 231441),
(245885, '3lhoA01', NULL, NULL, 239, NULL, NULL, 231442),
(245886, '3iuzA00', NULL, NULL, 340, NULL, NULL, 231442),
(245887, '3bulA04', NULL, NULL, 60, NULL, NULL, 231443),
(245888, '6bm5A02', NULL, NULL, 88, NULL, NULL, 231443),
(245889, '2o2kA02', NULL, NULL, 92, NULL, NULL, 231443),
(245890, '4ihqA02', NULL, NULL, 64, NULL, NULL, 231444),
(245891, '4a4pA02', NULL, NULL, 113, NULL, NULL, 231445),
(245892, '1ku1A02', NULL, NULL, 135, NULL, NULL, 231445),
(245893, '4oiyA02', NULL, NULL, 108, NULL, NULL, 231445),
(245894, '3l8nA02', NULL, NULL, 118, NULL, NULL, 231445),
(245895, '2r09A02', NULL, NULL, 124, NULL, NULL, 231445),
(245896, '4c0aA02', NULL, NULL, 118, NULL, NULL, 231445),
(245897, '1xszA02', NULL, NULL, 115, NULL, NULL, 231445),
(245898, '1re0B02', NULL, NULL, 141, NULL, NULL, 231445),
(245899, '4jxhA02', NULL, NULL, 118, NULL, NULL, 231445),
(245900, '4d7rA02', NULL, NULL, 116, NULL, NULL, 231445),
(245901, '3ltlA02', NULL, NULL, 119, NULL, NULL, 231445),
(245902, '3lyrA00', NULL, NULL, 243, NULL, NULL, 231446),
(245903, '4c2xA00', NULL, NULL, 388, NULL, NULL, 231447),
(245904, '4c68A00', NULL, NULL, 384, NULL, NULL, 231447),
(245905, '5o6hA00', NULL, NULL, 391, NULL, NULL, 231447),
(245906, '4c7iA00', NULL, NULL, 411, NULL, NULL, 231447),
(245907, '2fzlA02', NULL, NULL, 62, NULL, NULL, 231448),
(245908, '2yokA00', NULL, NULL, 426, NULL, NULL, 231449),
(245909, '1ojjA00', NULL, NULL, 402, NULL, NULL, 231449),
(245910, '5w0aA00', NULL, NULL, 373, NULL, NULL, 231449),
(245911, '4ipmA00', NULL, NULL, 431, NULL, NULL, 231449),
(245912, '3pfzA00', NULL, NULL, 437, NULL, NULL, 231449),
(245913, '2rfwA00', NULL, NULL, 430, NULL, NULL, 231449),
(245914, '4csiB00', NULL, NULL, 439, NULL, NULL, 231449),
(245915, '4xebA00', NULL, NULL, 436, NULL, NULL, 231449),
(245916, '1eg1A00', NULL, NULL, 371, NULL, NULL, 231449),
(245917, '5o5dA00', NULL, NULL, 430, NULL, NULL, 231449),
(245918, '2v3iA00', NULL, NULL, 434, NULL, NULL, 231449),
(245919, '4v20A00', NULL, NULL, 440, NULL, NULL, 231449),
(245920, '5oa5A00', NULL, NULL, 434, NULL, NULL, 231449),
(245921, '4xnnA00', NULL, NULL, 445, NULL, NULL, 231449),
(245922, '3ovwA00', NULL, NULL, 411, NULL, NULL, 231449),
(245923, '4zzqA00', NULL, NULL, 438, NULL, NULL, 231449),
(245924, '2xspA00', NULL, NULL, 440, NULL, NULL, 231449),
(245925, '5w11A00', NULL, NULL, 440, NULL, NULL, 231449),
(245926, '4zzpA00', NULL, NULL, 439, NULL, NULL, 231449),
(245927, '1gpiA00', NULL, NULL, 431, NULL, NULL, 231449),
(245928, '4zzvA00', NULL, NULL, 438, NULL, NULL, 231449),
(245929, '4c2vD00', NULL, NULL, 44, NULL, NULL, 231450),
(245930, '3kq5A01', NULL, NULL, 226, NULL, NULL, 231451),
(245931, '3j26N01', NULL, NULL, 186, NULL, NULL, 231452),
(245932, '2b1eA01', NULL, NULL, 97, NULL, NULL, 231453),
(245933, '1hc8B00', NULL, NULL, 76, NULL, NULL, 231454),
(245934, '4hubI02', NULL, NULL, 92, NULL, NULL, 231454),
(245935, '5mmiJ02', NULL, NULL, 82, NULL, NULL, 231454),
(245936, '6i0yI02', NULL, NULL, 70, NULL, NULL, 231454),
(245937, '1mmsB00', NULL, NULL, 71, NULL, NULL, 231454),
(245938, '5oomJ02', NULL, NULL, 74, NULL, NULL, 231454);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(245939, '2zjrF00', NULL, NULL, 71, NULL, NULL, 231454),
(245940, '2nxnB02', NULL, NULL, 77, NULL, NULL, 231454),
(245941, '1vx4K02', NULL, NULL, 88, NULL, NULL, 231454),
(245942, '5o60J02', NULL, NULL, 69, NULL, NULL, 231454),
(245943, '1vq8I00', NULL, NULL, 70, NULL, NULL, 231454),
(245944, '2kdlA00', NULL, NULL, 56, NULL, NULL, 231455),
(245945, '2lhgA00', NULL, NULL, 56, NULL, NULL, 231455),
(245946, '2jwsA00', NULL, NULL, 56, NULL, NULL, 231455),
(245947, '2n35A00', NULL, NULL, 52, NULL, NULL, 231455),
(245948, '2j5yA00', NULL, NULL, 61, NULL, NULL, 231455),
(245949, '2mh8A00', NULL, NULL, 56, NULL, NULL, 231455),
(245950, '1gjsA00', NULL, NULL, 65, NULL, NULL, 231455),
(245951, '2fs1A00', NULL, NULL, 56, NULL, NULL, 231455),
(245952, '2vixC02', NULL, NULL, 89, NULL, NULL, 231456),
(245953, '2vixA02', NULL, NULL, 89, NULL, NULL, 231456),
(245954, '2vixB02', NULL, NULL, 89, NULL, NULL, 231456),
(245955, '2vj4A02', NULL, NULL, 89, NULL, NULL, 231456),
(245956, '2vj5A02', NULL, NULL, 89, NULL, NULL, 231456),
(245957, '2vj4B02', NULL, NULL, 89, NULL, NULL, 231456),
(245958, '1ibtC00', NULL, NULL, 81, NULL, NULL, 231457),
(245959, '3fn2A00', NULL, NULL, 106, NULL, NULL, 231458),
(245960, '4bxmB00', NULL, NULL, 141, NULL, NULL, 231459),
(245961, '4bobA00', NULL, NULL, 136, NULL, NULL, 231459),
(245962, '4j38A00', NULL, NULL, 132, NULL, NULL, 231459),
(245963, '2px0A01', NULL, NULL, 73, NULL, NULL, 231460),
(245964, '4dixA01', NULL, NULL, 99, NULL, NULL, 231461),
(245965, '3hl8A03', NULL, NULL, 62, NULL, NULL, 231462),
(245966, '4rg8A03', NULL, NULL, 61, NULL, NULL, 231462),
(245967, '2p62A01', NULL, NULL, 148, NULL, NULL, 231463),
(245968, '4h7aA00', NULL, NULL, 168, NULL, NULL, 231464),
(245969, '5h9fB00', NULL, NULL, 165, NULL, NULL, 231464),
(245970, '4h79A00', NULL, NULL, 196, NULL, NULL, 231464),
(245971, '3wa8B00', NULL, NULL, 205, NULL, NULL, 231464),
(245972, '2zcaB00', NULL, NULL, 169, NULL, NULL, 231464),
(245973, '3tpqM02', NULL, NULL, 57, NULL, NULL, 231465),
(245974, '1ng6A01', NULL, NULL, 91, NULL, NULL, 231466),
(245975, '1u6zA04', NULL, NULL, 57, NULL, NULL, 231467),
(245976, '3d0wD00', NULL, NULL, 85, NULL, NULL, 231468),
(245977, '2k9lA00', NULL, NULL, 76, NULL, NULL, 231469),
(245978, '5ui5I01', NULL, NULL, 70, NULL, NULL, 231469),
(245979, '3k59A01', NULL, NULL, 86, NULL, NULL, 231470),
(245980, '6c6zB01', NULL, NULL, 145, NULL, NULL, 231471),
(245981, '5xgrA01', NULL, NULL, 147, NULL, NULL, 231471),
(245982, '3d0gE01', NULL, NULL, 130, NULL, NULL, 231471),
(245983, '2ghvC01', NULL, NULL, 152, NULL, NULL, 231471),
(245984, '4l3nA01', NULL, NULL, 149, NULL, NULL, 231471),
(245985, '4qzvB01', NULL, NULL, 154, NULL, NULL, 231471),
(245986, '5anpA00', NULL, NULL, 146, NULL, NULL, 231472),
(245987, '4oa3A00', NULL, NULL, 146, NULL, NULL, 231472),
(245988, '3pvhA00', NULL, NULL, 153, NULL, NULL, 231472),
(245989, '2kptA00', NULL, NULL, 148, NULL, NULL, 231472),
(245990, '2kw7A00', NULL, NULL, 157, NULL, NULL, 231472),
(245991, '1s7bA00', NULL, NULL, 110, NULL, NULL, 231473),
(245992, '1f5nA01', NULL, NULL, 296, NULL, NULL, 231474),
(245993, '3bsuA00', NULL, NULL, 53, NULL, NULL, 231475),
(245994, '1qhkA00', NULL, NULL, 47, NULL, NULL, 231475),
(245995, '4acvB00', NULL, NULL, 129, NULL, NULL, 231476),
(245996, '2lfpA01', NULL, NULL, 136, NULL, NULL, 231476),
(245997, '4aflB00', NULL, NULL, 104, NULL, NULL, 231477),
(245998, '4hyzA00', NULL, NULL, 114, NULL, NULL, 231478),
(245999, '4l8kA01', NULL, NULL, 95, NULL, NULL, 231479),
(246000, '1k32A03', NULL, NULL, 72, NULL, NULL, 231479),
(246001, '1fc6A01', NULL, NULL, 99, NULL, NULL, 231479),
(246002, '1j7xA01', NULL, NULL, 88, NULL, NULL, 231479),
(246003, '4ghnA01', NULL, NULL, 114, NULL, NULL, 231479),
(246004, '2akjA03', NULL, NULL, 131, NULL, NULL, 231480),
(246005, '5h92B03', NULL, NULL, 151, NULL, NULL, 231480),
(246006, '2xsjA03', NULL, NULL, 188, NULL, NULL, 231480),
(246007, '2xsjB02', NULL, NULL, 183, NULL, NULL, 231480),
(246008, '2akjA02', NULL, NULL, 186, NULL, NULL, 231480),
(246009, '2v4jB02', NULL, NULL, 183, NULL, NULL, 231480);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(246010, '2v4jA03', NULL, NULL, 188, NULL, NULL, 231480),
(246011, '3or1B02', NULL, NULL, 188, NULL, NULL, 231480),
(246012, '3or1A03', NULL, NULL, 188, NULL, NULL, 231480),
(246013, '3b0hA03', NULL, NULL, 131, NULL, NULL, 231480),
(246014, '3b0hA02', NULL, NULL, 186, NULL, NULL, 231480),
(246015, '3b0gA02', NULL, NULL, 186, NULL, NULL, 231480),
(246016, '3b0gA03', NULL, NULL, 132, NULL, NULL, 231480),
(246017, '4s39A02', NULL, NULL, 118, NULL, NULL, 231480),
(246018, '3mm5B02', NULL, NULL, 191, NULL, NULL, 231480),
(246019, '3mm5A03', NULL, NULL, 186, NULL, NULL, 231480),
(246020, '3noyB02', NULL, NULL, 101, NULL, NULL, 231480),
(246021, '6c3mA03', NULL, NULL, 143, NULL, NULL, 231480),
(246022, '1zj8A03', NULL, NULL, 165, NULL, NULL, 231480),
(246023, '5h8yD02', NULL, NULL, 212, NULL, NULL, 231480),
(246024, '6c3mA02', NULL, NULL, 193, NULL, NULL, 231480),
(246025, '1zj8A04', NULL, NULL, 148, NULL, NULL, 231480),
(246026, '1b33N01', NULL, NULL, 55, NULL, NULL, 231481),
(246027, '1coyA02', NULL, NULL, 157, NULL, NULL, 231482),
(246028, '4rekA02', NULL, NULL, 157, NULL, NULL, 231482),
(246029, '1kdgA02', NULL, NULL, 204, NULL, NULL, 231482),
(246030, '4xvvB00', NULL, NULL, 77, NULL, NULL, 231483),
(246031, '4xvvA00', NULL, NULL, 77, NULL, NULL, 231483),
(246032, '1dj8A00', NULL, NULL, 89, NULL, NULL, 231483),
(246033, '2myjA00', NULL, NULL, 79, NULL, NULL, 231483),
(246034, '2xuvC00', NULL, NULL, 79, NULL, NULL, 231483),
(246035, '2xuvD00', NULL, NULL, 79, NULL, NULL, 231483),
(246036, '2xuvA00', NULL, NULL, 79, NULL, NULL, 231483),
(246037, '2xuvB00', NULL, NULL, 79, NULL, NULL, 231483),
(246038, '3shgB00', NULL, NULL, 61, NULL, NULL, 231484),
(246039, '1bcpA00', NULL, NULL, 235, NULL, NULL, 231485),
(246040, '1lt3A00', NULL, NULL, 240, NULL, NULL, 231485),
(246041, '1ltsA00', NULL, NULL, 185, NULL, NULL, 231485),
(246042, '5h6kA00', NULL, NULL, 227, NULL, NULL, 231485),
(246043, '4z9cA00', NULL, NULL, 223, NULL, NULL, 231485),
(246044, '1tiiA00', NULL, NULL, 190, NULL, NULL, 231485),
(246045, '1s5dA00', NULL, NULL, 240, NULL, NULL, 231485),
(246046, '2cb4A00', NULL, NULL, 291, NULL, NULL, 231485),
(246047, '4k6lG00', NULL, NULL, 224, NULL, NULL, 231485),
(246048, '4qxaB00', NULL, NULL, 180, NULL, NULL, 231486),
(246049, '2bicA01', NULL, NULL, 28, NULL, NULL, 231487),
(246050, '5h3xA01', NULL, NULL, 166, NULL, NULL, 231488),
(246051, '3doaA01', NULL, NULL, 165, NULL, NULL, 231488),
(246052, '4j3vA01', NULL, NULL, 120, NULL, NULL, 231489),
(246053, '2fgzA01', NULL, NULL, 115, NULL, NULL, 231489),
(246054, '2wanA01', NULL, NULL, 95, NULL, NULL, 231489),
(246055, '2yocA02', NULL, NULL, 115, NULL, NULL, 231489),
(246056, '2yocB02', NULL, NULL, 112, NULL, NULL, 231489),
(246057, '1dceA02', NULL, NULL, 103, NULL, NULL, 231489),
(246058, '2fhfA02', NULL, NULL, 114, NULL, NULL, 231489),
(246059, '3hynA00', NULL, NULL, 189, NULL, NULL, 231490),
(246060, '2z4tA02', NULL, NULL, 225, NULL, NULL, 231491),
(246061, '3s44A01', NULL, NULL, 209, NULL, NULL, 231491),
(246062, '4r84A02', NULL, NULL, 224, NULL, NULL, 231491),
(246063, '2zwiA01', NULL, NULL, 218, NULL, NULL, 231491),
(246064, '4v3cA01', NULL, NULL, 209, NULL, NULL, 231491),
(246065, '3a2kA02', NULL, NULL, 81, NULL, NULL, 231492),
(246066, '2gi3A02', NULL, NULL, 71, NULL, NULL, 231493),
(246067, '1gttA01', NULL, NULL, 211, NULL, NULL, 231494),
(246068, '3qdfA02', NULL, NULL, 207, NULL, NULL, 231494),
(246069, '6iymA02', NULL, NULL, 220, NULL, NULL, 231494),
(246070, '3v77A00', NULL, NULL, 224, NULL, NULL, 231494),
(246071, '1wzoB02', NULL, NULL, 206, NULL, NULL, 231494),
(246072, '3rr6A02', NULL, NULL, 204, NULL, NULL, 231494),
(246073, '4pfzB02', NULL, NULL, 205, NULL, NULL, 231494),
(246074, '2dfuA02', NULL, NULL, 220, NULL, NULL, 231494),
(246075, '4qkuC02', NULL, NULL, 303, NULL, NULL, 231494),
(246076, '2eb4D00', NULL, NULL, 267, NULL, NULL, 231494),
(246077, '1hyoA02', NULL, NULL, 286, NULL, NULL, 231494),
(246078, '5ti1A02', NULL, NULL, 302, NULL, NULL, 231494),
(246079, '3lzkB00', NULL, NULL, 340, NULL, NULL, 231494),
(246080, '1i7oA02', NULL, NULL, 218, NULL, NULL, 231494);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(246081, '2q18X02', NULL, NULL, 223, NULL, NULL, 231494),
(246082, '2wqtA00', NULL, NULL, 270, NULL, NULL, 231494),
(246083, '4dbhA02', NULL, NULL, 211, NULL, NULL, 231494),
(246084, '6fohB00', NULL, NULL, 224, NULL, NULL, 231494),
(246085, '4maqB00', NULL, NULL, 240, NULL, NULL, 231494),
(246086, '6jvvB02', NULL, NULL, 204, NULL, NULL, 231494),
(246087, '5d2kA00', NULL, NULL, 269, NULL, NULL, 231494),
(246088, '3r6oA02', NULL, NULL, 230, NULL, NULL, 231494),
(246089, '3s52A00', NULL, NULL, 221, NULL, NULL, 231494),
(246090, '1nr9A00', NULL, NULL, 223, NULL, NULL, 231494),
(246091, '1nkqE00', NULL, NULL, 259, NULL, NULL, 231494),
(246092, '2p3yA04', NULL, NULL, 184, NULL, NULL, 231495),
(246093, '1zylA01', NULL, NULL, 70, NULL, NULL, 231496),
(246094, '1p27A00', NULL, NULL, 144, NULL, NULL, 231497),
(246095, '1oo0A00', NULL, NULL, 147, NULL, NULL, 231497),
(246096, '4pelA02', NULL, NULL, 47, NULL, NULL, 231498),
(246097, '1pnkA02', NULL, NULL, 60, NULL, NULL, 231498),
(246098, '1gk9A02', NULL, NULL, 30, NULL, NULL, 231498),
(246099, '3k3wA02', NULL, NULL, 30, NULL, NULL, 231498),
(246100, '1cp9A02', NULL, NULL, 30, NULL, NULL, 231498),
(246101, '2kjxA01', NULL, NULL, 53, NULL, NULL, 231499),
(246102, '5ig6A00', NULL, NULL, 115, NULL, NULL, 231500),
(246103, '3lqhA02', NULL, NULL, 108, NULL, NULL, 231500),
(246104, '4qylA00', NULL, NULL, 117, NULL, NULL, 231500),
(246105, '4qzsA01', NULL, NULL, 105, NULL, NULL, 231500),
(246106, '3tlpA00', NULL, NULL, 134, NULL, NULL, 231500),
(246107, '5mwzA00', NULL, NULL, 116, NULL, NULL, 231500),
(246108, '4kcxA01', NULL, NULL, 113, NULL, NULL, 231500),
(246109, '4qc3A00', NULL, NULL, 107, NULL, NULL, 231500),
(246110, '2g4aA00', NULL, NULL, 116, NULL, NULL, 231500),
(246111, '2dvrB00', NULL, NULL, 122, NULL, NULL, 231500),
(246112, '2dvsC00', NULL, NULL, 122, NULL, NULL, 231500),
(246113, '3jvlA00', NULL, NULL, 120, NULL, NULL, 231500),
(246114, '5czgA00', NULL, NULL, 116, NULL, NULL, 231500),
(246115, '2yynB00', NULL, NULL, 135, NULL, NULL, 231500),
(246116, '1x0jA00', NULL, NULL, 122, NULL, NULL, 231500),
(246117, '5fh7A00', NULL, NULL, 124, NULL, NULL, 231500),
(246118, '3aqaB00', NULL, NULL, 128, NULL, NULL, 231500),
(246119, '2h60A00', NULL, NULL, 128, NULL, NULL, 231500),
(246120, '3qztA00', NULL, NULL, 115, NULL, NULL, 231500),
(246121, '5enfA00', NULL, NULL, 131, NULL, NULL, 231500),
(246122, '4ldfA00', NULL, NULL, 116, NULL, NULL, 231500),
(246123, '4pklA00', NULL, NULL, 119, NULL, NULL, 231500),
(246124, '3mqmA00', NULL, NULL, 126, NULL, NULL, 231500),
(246125, '3nxbA00', NULL, NULL, 116, NULL, NULL, 231500),
(246126, '3tlpB00', NULL, NULL, 132, NULL, NULL, 231500),
(246127, '6fggA00', NULL, NULL, 106, NULL, NULL, 231500),
(246128, '5n13A00', NULL, NULL, 109, NULL, NULL, 231500),
(246129, '4aknA00', NULL, NULL, 125, NULL, NULL, 231500),
(246130, '5ko4A00', NULL, NULL, 107, NULL, NULL, 231500),
(246131, '2dkwA00', NULL, NULL, 131, NULL, NULL, 231500),
(246132, '5k29A00', NULL, NULL, 126, NULL, NULL, 231500),
(246133, '6nimA00', NULL, NULL, 121, NULL, NULL, 231500),
(246134, '2dvrC00', NULL, NULL, 122, NULL, NULL, 231500),
(246135, '3iu5A00', NULL, NULL, 116, NULL, NULL, 231500),
(246136, '6g8rB02', NULL, NULL, 118, NULL, NULL, 231500),
(246137, '5vs7A00', NULL, NULL, 119, NULL, NULL, 231500),
(246138, '2yw5A00', NULL, NULL, 138, NULL, NULL, 231500),
(246139, '3aqaC00', NULL, NULL, 128, NULL, NULL, 231500),
(246140, '5mr8A02', NULL, NULL, 116, NULL, NULL, 231500),
(246141, '6df4A00', NULL, NULL, 138, NULL, NULL, 231500),
(246142, '3q2eA00', NULL, NULL, 123, NULL, NULL, 231500),
(246143, '4n4gA01', NULL, NULL, 115, NULL, NULL, 231500),
(246144, '4algA00', NULL, NULL, 129, NULL, NULL, 231500),
(246145, '5dkhA00', NULL, NULL, 123, NULL, NULL, 231500),
(246146, '2dvqA00', NULL, NULL, 122, NULL, NULL, 231500),
(246147, '5c4qB00', NULL, NULL, 125, NULL, NULL, 231500),
(246148, '3u5nA02', NULL, NULL, 130, NULL, NULL, 231500),
(246149, '5ibnA00', NULL, NULL, 111, NULL, NULL, 231500),
(246150, '2dwwA00', NULL, NULL, 114, NULL, NULL, 231500),
(246151, '4z93A00', NULL, NULL, 112, NULL, NULL, 231500);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(246152, '5ji8A00', NULL, NULL, 111, NULL, NULL, 231500),
(246153, '2datA00', NULL, NULL, 123, NULL, NULL, 231500),
(246154, '3k2jA00', NULL, NULL, 130, NULL, NULL, 231500),
(246155, '3hmhA00', NULL, NULL, 155, NULL, NULL, 231500),
(246156, '5pg1A00', NULL, NULL, 117, NULL, NULL, 231500),
(246157, '2i8nA00', NULL, NULL, 114, NULL, NULL, 231500),
(246158, '5mkxB00', NULL, NULL, 119, NULL, NULL, 231500),
(246159, '4qb3A01', NULL, NULL, 105, NULL, NULL, 231500),
(246160, '5uiyA00', NULL, NULL, 116, NULL, NULL, 231500),
(246161, '2dvsA00', NULL, NULL, 122, NULL, NULL, 231500),
(246162, '4qnsA00', NULL, NULL, 106, NULL, NULL, 231500),
(246163, '6j3pA00', NULL, NULL, 109, NULL, NULL, 231500),
(246164, '5epbA00', NULL, NULL, 130, NULL, NULL, 231500),
(246165, '2nxbA01', NULL, NULL, 106, NULL, NULL, 231500),
(246166, '1x0jC00', NULL, NULL, 122, NULL, NULL, 231500),
(246167, '3ljwA00', NULL, NULL, 120, NULL, NULL, 231500),
(246168, '5mq1A00', NULL, NULL, 112, NULL, NULL, 231500),
(246169, '2ri7A02', NULL, NULL, 111, NULL, NULL, 231500),
(246170, '6bqaA00', NULL, NULL, 102, NULL, NULL, 231500),
(246171, '2wp1B00', NULL, NULL, 126, NULL, NULL, 231500),
(246172, '2dvqB00', NULL, NULL, 122, NULL, NULL, 231500),
(246173, '5fg6A00', NULL, NULL, 128, NULL, NULL, 231500),
(246174, '4uitA00', NULL, NULL, 106, NULL, NULL, 231500),
(246175, '3iu6A00', NULL, NULL, 147, NULL, NULL, 231500),
(246176, '4j1pA00', NULL, NULL, 114, NULL, NULL, 231500),
(246177, '2r0yA01', NULL, NULL, 114, NULL, NULL, 231500),
(246178, '2r0yA02', NULL, NULL, 145, NULL, NULL, 231500),
(246179, '5n17A01', NULL, NULL, 104, NULL, NULL, 231500),
(246180, '5u9nB00', NULL, NULL, 151, NULL, NULL, 231500),
(246181, '6g5pB02', NULL, NULL, 120, NULL, NULL, 231500),
(246182, '1e6iA00', NULL, NULL, 121, NULL, NULL, 231500),
(246183, '5ulcX00', NULL, NULL, 142, NULL, NULL, 231500),
(246184, '2wp2A01', NULL, NULL, 105, NULL, NULL, 231500),
(246185, '5bt3A00', NULL, NULL, 116, NULL, NULL, 231500),
(246186, '5ml0A00', NULL, NULL, 110, NULL, NULL, 231500),
(246187, '6cw0A00', NULL, NULL, 106, NULL, NULL, 231500),
(246188, '3aadA01', NULL, NULL, 163, NULL, NULL, 231500),
(246189, '6neyA00', NULL, NULL, 131, NULL, NULL, 231500),
(246190, '5tcmB00', NULL, NULL, 130, NULL, NULL, 231500),
(246191, '2dvrA00', NULL, NULL, 122, NULL, NULL, 231500),
(246192, '5pqiA00', NULL, NULL, 135, NULL, NULL, 231500),
(246193, '3uv5A01', NULL, NULL, 125, NULL, NULL, 231500),
(246194, '3uv5A02', NULL, NULL, 140, NULL, NULL, 231500),
(246195, '2dvsB00', NULL, NULL, 122, NULL, NULL, 231500),
(246196, '5helA00', NULL, NULL, 126, NULL, NULL, 231500),
(246197, '4ybmA02', NULL, NULL, 123, NULL, NULL, 231500),
(246198, '5i86A00', NULL, NULL, 118, NULL, NULL, 231500),
(246199, '3aqaA00', NULL, NULL, 128, NULL, NULL, 231500),
(246200, '1n72A00', NULL, NULL, 118, NULL, NULL, 231500),
(246201, '3lxjD00', NULL, NULL, 136, NULL, NULL, 231500),
(246202, '1x0jB00', NULL, NULL, 122, NULL, NULL, 231500),
(246203, '2d9eA00', NULL, NULL, 121, NULL, NULL, 231500),
(246204, '4py6C00', NULL, NULL, 129, NULL, NULL, 231500),
(246205, '2grcA00', NULL, NULL, 129, NULL, NULL, 231500),
(246206, '2dvqC00', NULL, NULL, 122, NULL, NULL, 231500),
(246207, '5c8gB00', NULL, NULL, 136, NULL, NULL, 231500),
(246208, '3s92A00', NULL, NULL, 113, NULL, NULL, 231500),
(246209, '3hj6A03', NULL, NULL, 35, NULL, NULL, 231501),
(246210, '3vthA01', NULL, NULL, 307, NULL, NULL, 231502),
(246211, '1y1uA01', NULL, NULL, 205, NULL, NULL, 231503),
(246212, '1bg1A01', NULL, NULL, 184, NULL, NULL, 231503),
(246213, '1yvlA02', NULL, NULL, 183, NULL, NULL, 231503),
(246214, '4j5tA01', NULL, NULL, 316, NULL, NULL, 231504),
(246215, '4lb8A02', NULL, NULL, 137, NULL, NULL, 231505),
(246216, '4nw4A02', NULL, NULL, 141, NULL, NULL, 231506),
(246217, '4kh8A02', NULL, NULL, 145, NULL, NULL, 231506),
(246218, '4kh8A01', NULL, NULL, 173, NULL, NULL, 231506),
(246219, '4nw4A01', NULL, NULL, 132, NULL, NULL, 231506),
(246220, '1v5vA03', NULL, NULL, 75, NULL, NULL, 231507),
(246221, '1pj5A05', NULL, NULL, 78, NULL, NULL, 231507),
(246222, '3girA04', NULL, NULL, 78, NULL, NULL, 231507);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(246223, '5l46A05', NULL, NULL, 79, NULL, NULL, 231507),
(246224, '1wosA04', NULL, NULL, 89, NULL, NULL, 231507),
(246225, '1yx2B04', NULL, NULL, 83, NULL, NULL, 231507),
(246226, '1wsrA04', NULL, NULL, 77, NULL, NULL, 231507),
(246227, '4pabA05', NULL, NULL, 77, NULL, NULL, 231507),
(246228, '1vloA04', NULL, NULL, 93, NULL, NULL, 231507),
(246229, '3ip4B03', NULL, NULL, 65, NULL, NULL, 231508),
(246230, '1ng6A02', NULL, NULL, 57, NULL, NULL, 231508),
(246231, '3al0B03', NULL, NULL, 63, NULL, NULL, 231508),
(246232, '3sp8A03', NULL, NULL, 80, NULL, NULL, 231509),
(246233, '2dohX00', NULL, NULL, 165, NULL, NULL, 231509),
(246234, '2sptA00', NULL, NULL, 145, NULL, NULL, 231509),
(246235, '1krnA00', NULL, NULL, 88, NULL, NULL, 231509),
(246236, '5hpgA00', NULL, NULL, 84, NULL, NULL, 231509),
(246237, '3k65A00', NULL, NULL, 93, NULL, NULL, 231509),
(246238, '5fwsA01', NULL, NULL, 83, NULL, NULL, 231509),
(246239, '1nl1A00', NULL, NULL, 147, NULL, NULL, 231509),
(246240, '2i9aC02', NULL, NULL, 94, NULL, NULL, 231509),
(246241, '2febA00', NULL, NULL, 102, NULL, NULL, 231509),
(246242, '1i71A00', NULL, NULL, 83, NULL, NULL, 231509),
(246243, '2pf1A01', NULL, NULL, 115, NULL, NULL, 231509),
(246244, '4durB05', NULL, NULL, 91, NULL, NULL, 231509),
(246245, '4durB06', NULL, NULL, 106, NULL, NULL, 231509),
(246246, '4nzqA01', NULL, NULL, 113, NULL, NULL, 231509),
(246247, '6ba5M00', NULL, NULL, 82, NULL, NULL, 231509),
(246248, '1a0hA01', NULL, NULL, 89, NULL, NULL, 231509),
(246249, '1pmlA00', NULL, NULL, 86, NULL, NULL, 231509),
(246250, '1ki0A02', NULL, NULL, 88, NULL, NULL, 231509),
(246251, '2qj2A02', NULL, NULL, 84, NULL, NULL, 231509),
(246252, '1ki0A03', NULL, NULL, 83, NULL, NULL, 231509),
(246253, '3e6pL01', NULL, NULL, 90, NULL, NULL, 231509),
(246254, '4bvvA00', NULL, NULL, 81, NULL, NULL, 231509),
(246255, '1ki0A01', NULL, NULL, 82, NULL, NULL, 231509),
(246256, '4bvcA00', NULL, NULL, 79, NULL, NULL, 231509),
(246257, '4iuaA03', NULL, NULL, 80, NULL, NULL, 231509),
(246258, '1nl2A00', NULL, NULL, 146, NULL, NULL, 231509),
(246259, '3laqA02', NULL, NULL, 84, NULL, NULL, 231509),
(246260, '4o03A01', NULL, NULL, 81, NULL, NULL, 231509),
(246261, '6dcmA00', NULL, NULL, 85, NULL, NULL, 231509),
(246262, '2k4rA00', NULL, NULL, 77, NULL, NULL, 231509),
(246263, '2pf2A00', NULL, NULL, 156, NULL, NULL, 231509),
(246264, '2icwG01', NULL, NULL, 124, NULL, NULL, 231510),
(246265, '2cb0A01', NULL, NULL, 159, NULL, NULL, 231511),
(246266, '1hm5A01', NULL, NULL, 320, NULL, NULL, 231511),
(246267, '3qkiB01', NULL, NULL, 380, NULL, NULL, 231511),
(246268, '2xhzB00', NULL, NULL, 183, NULL, NULL, 231511),
(246269, '3ff1B01', NULL, NULL, 231, NULL, NULL, 231511),
(246270, '1hm5A02', NULL, NULL, 195, NULL, NULL, 231511),
(246271, '3ff1B02', NULL, NULL, 184, NULL, NULL, 231511),
(246272, '2a3nA02', NULL, NULL, 161, NULL, NULL, 231511),
(246273, '2a3nA01', NULL, NULL, 162, NULL, NULL, 231511),
(246274, '2cb0A02', NULL, NULL, 152, NULL, NULL, 231511),
(246275, '3hbaA02', NULL, NULL, 126, NULL, NULL, 231511),
(246276, '3hbaA01', NULL, NULL, 193, NULL, NULL, 231511),
(246277, '3hjbA01', NULL, NULL, 318, NULL, NULL, 231511),
(246278, '3hjbA02', NULL, NULL, 194, NULL, NULL, 231511),
(246279, '1nriA00', NULL, NULL, 259, NULL, NULL, 231511),
(246280, '5lu5D00', NULL, NULL, 197, NULL, NULL, 231511),
(246281, '4ivnA02', NULL, NULL, 188, NULL, NULL, 231511),
(246282, '2vhoB01', NULL, NULL, 150, NULL, NULL, 231511),
(246283, '3ljkA01', NULL, NULL, 309, NULL, NULL, 231511),
(246284, '3g68B01', NULL, NULL, 207, NULL, NULL, 231511),
(246285, '3ljkA02', NULL, NULL, 195, NULL, NULL, 231511),
(246286, '2amlB01', NULL, NULL, 226, NULL, NULL, 231511),
(246287, '3jx9A00', NULL, NULL, 170, NULL, NULL, 231511),
(246288, '3odpA01', NULL, NULL, 204, NULL, NULL, 231511),
(246289, '3odpA02', NULL, NULL, 182, NULL, NULL, 231511),
(246290, '3ujhA02', NULL, NULL, 203, NULL, NULL, 231511),
(246291, '4toiA01', NULL, NULL, 182, NULL, NULL, 231511),
(246292, '3fj1A02', NULL, NULL, 136, NULL, NULL, 231511),
(246293, '3fj1A01', NULL, NULL, 193, NULL, NULL, 231511);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(246294, '3nbuA01', NULL, NULL, 316, NULL, NULL, 231511),
(246295, '3i0zA02', NULL, NULL, 176, NULL, NULL, 231511),
(246296, '3i0zA01', NULL, NULL, 205, NULL, NULL, 231511),
(246297, '2o2cC01', NULL, NULL, 379, NULL, NULL, 231511),
(246298, '3trjD00', NULL, NULL, 201, NULL, NULL, 231511),
(246299, '1wiwA02', NULL, NULL, 133, NULL, NULL, 231511),
(246300, '1x92A00', NULL, NULL, 199, NULL, NULL, 231511),
(246301, '1iatA02', NULL, NULL, 195, NULL, NULL, 231511),
(246302, '2yvaA00', NULL, NULL, 196, NULL, NULL, 231511),
(246303, '1m3sB00', NULL, NULL, 186, NULL, NULL, 231511),
(246304, '3jamA01', NULL, NULL, 197, NULL, NULL, 231511),
(246305, '2i2wA00', NULL, NULL, 192, NULL, NULL, 231511),
(246306, '3g68A02', NULL, NULL, 145, NULL, NULL, 231511),
(246307, '3tbfA02', NULL, NULL, 149, NULL, NULL, 231511),
(246308, '2amlA02', NULL, NULL, 147, NULL, NULL, 231511),
(246309, '1iatA01', NULL, NULL, 319, NULL, NULL, 231511),
(246310, '4em6C01', NULL, NULL, 320, NULL, NULL, 231511),
(246311, '1moqA01', NULL, NULL, 220, NULL, NULL, 231511),
(246312, '1moqA02', NULL, NULL, 148, NULL, NULL, 231511),
(246313, '4s12B01', NULL, NULL, 221, NULL, NULL, 231511),
(246314, '3fxaA00', NULL, NULL, 201, NULL, NULL, 231511),
(246315, '5o5jV01', NULL, NULL, 137, NULL, NULL, 231511),
(246316, '3etnB00', NULL, NULL, 220, NULL, NULL, 231511),
(246317, '1vi6C01', NULL, NULL, 197, NULL, NULL, 231511),
(246318, '5by2A00', NULL, NULL, 199, NULL, NULL, 231511),
(246319, '1vimA00', NULL, NULL, 200, NULL, NULL, 231511),
(246320, '6az1B01', NULL, NULL, 195, NULL, NULL, 231511),
(246321, '3fkjA01', NULL, NULL, 174, NULL, NULL, 231511),
(246322, '2vqeB01', NULL, NULL, 177, NULL, NULL, 231511),
(246323, '5mmjb01', NULL, NULL, 141, NULL, NULL, 231511),
(246324, '1j5xA02', NULL, NULL, 150, NULL, NULL, 231511),
(246325, '1tk9A00', NULL, NULL, 188, NULL, NULL, 231511),
(246326, '1j5xA01', NULL, NULL, 181, NULL, NULL, 231511),
(246327, '2e5fA02', NULL, NULL, 152, NULL, NULL, 231511),
(246328, '2e5lB01', NULL, NULL, 136, NULL, NULL, 231511),
(246329, '2e5fA01', NULL, NULL, 159, NULL, NULL, 231511),
(246330, '4bpeB01', NULL, NULL, 194, NULL, NULL, 231511),
(246331, '3tbfB01', NULL, NULL, 222, NULL, NULL, 231511),
(246332, '3ifsA02', NULL, NULL, 188, NULL, NULL, 231511),
(246333, '5i01A00', NULL, NULL, 204, NULL, NULL, 231511),
(246334, '5xxuA01', NULL, NULL, 195, NULL, NULL, 231511),
(246335, '3w0lD02', NULL, NULL, 347, NULL, NULL, 231511),
(246336, '3knzA01', NULL, NULL, 194, NULL, NULL, 231511),
(246337, '3knzA02', NULL, NULL, 146, NULL, NULL, 231511),
(246338, '5xyiA01', NULL, NULL, 206, NULL, NULL, 231511),
(246339, '1tzbA02', NULL, NULL, 139, NULL, NULL, 231511),
(246340, '3c3jA02', NULL, NULL, 179, NULL, NULL, 231511),
(246341, '5uqiA00', NULL, NULL, 198, NULL, NULL, 231511),
(246342, '3c3jA01', NULL, NULL, 197, NULL, NULL, 231511),
(246343, '1gzdA01', NULL, NULL, 319, NULL, NULL, 231511),
(246344, '1gzdA02', NULL, NULL, 195, NULL, NULL, 231511),
(246345, '3euaF01', NULL, NULL, 156, NULL, NULL, 231511),
(246346, '5optf01', NULL, NULL, 194, NULL, NULL, 231511),
(246347, '1tzbA01', NULL, NULL, 163, NULL, NULL, 231511),
(246348, '3qkiA02', NULL, NULL, 151, NULL, NULL, 231511),
(246349, '3cvjC00', NULL, NULL, 243, NULL, NULL, 231511),
(246350, '2o2cA02', NULL, NULL, 134, NULL, NULL, 231511),
(246351, '2zj3A01', NULL, NULL, 227, NULL, NULL, 231511),
(246352, '2zj3A02', NULL, NULL, 148, NULL, NULL, 231511),
(246353, '2wu8A02', NULL, NULL, 194, NULL, NULL, 231511),
(246354, '4lc9A01', NULL, NULL, 348, NULL, NULL, 231511),
(246355, '2wu8A01', NULL, NULL, 310, NULL, NULL, 231511),
(246356, '2cxnA02', NULL, NULL, 195, NULL, NULL, 231511),
(246357, '1zzgA02', NULL, NULL, 169, NULL, NULL, 231511),
(246358, '1zzgA01', NULL, NULL, 246, NULL, NULL, 231511),
(246359, '1t10A01', NULL, NULL, 374, NULL, NULL, 231511),
(246360, '6faiA01', NULL, NULL, 195, NULL, NULL, 231511),
(246361, '1t10A02', NULL, NULL, 134, NULL, NULL, 231511),
(246362, '2cxnA01', NULL, NULL, 320, NULL, NULL, 231511),
(246363, '2pocB01', NULL, NULL, 205, NULL, NULL, 231511),
(246364, '2pocB02', NULL, NULL, 162, NULL, NULL, 231511);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(246365, '4s1wB01', NULL, NULL, 201, NULL, NULL, 231511),
(246366, '4s1wB02', NULL, NULL, 157, NULL, NULL, 231511),
(246367, '3ifsB01', NULL, NULL, 233, NULL, NULL, 231511),
(246368, '4em6A02', NULL, NULL, 193, NULL, NULL, 231511),
(246369, '4bb9A02', NULL, NULL, 348, NULL, NULL, 231511),
(246370, '3t1yB01', NULL, NULL, 175, NULL, NULL, 231511),
(246371, '1b0zA02', NULL, NULL, 184, NULL, NULL, 231511),
(246372, '3ujhB01', NULL, NULL, 316, NULL, NULL, 231511),
(246373, '1jeoA00', NULL, NULL, 180, NULL, NULL, 231511),
(246374, '1x94A00', NULL, NULL, 191, NULL, NULL, 231511),
(246375, '1b0zA01', NULL, NULL, 228, NULL, NULL, 231511),
(246376, '3j7aC01', NULL, NULL, 192, NULL, NULL, 231511),
(246377, '3bchA01', NULL, NULL, 207, NULL, NULL, 231511),
(246378, '3shoA00', NULL, NULL, 187, NULL, NULL, 231511),
(246379, '3nbuB02', NULL, NULL, 194, NULL, NULL, 231511),
(246380, '2q8nA02', NULL, NULL, 164, NULL, NULL, 231511),
(246381, '2q8nA01', NULL, NULL, 296, NULL, NULL, 231511),
(246382, '1s4kA00', NULL, NULL, 120, NULL, NULL, 231512),
(246383, '2ox6D00', NULL, NULL, 166, NULL, NULL, 231512),
(246384, '4pj1100', NULL, NULL, 114, NULL, NULL, 231513),
(246385, '1p3hB00', NULL, NULL, 99, NULL, NULL, 231513),
(246386, '1pcqO00', NULL, NULL, 97, NULL, NULL, 231513),
(246387, '1g31A00', NULL, NULL, 111, NULL, NULL, 231513),
(246388, '1wnrG00', NULL, NULL, 94, NULL, NULL, 231513),
(246389, '3nx6A00', NULL, NULL, 95, NULL, NULL, 231513),
(246390, '6mqdA00', NULL, NULL, 122, NULL, NULL, 231514),
(246391, '1p7oA00', NULL, NULL, 124, NULL, NULL, 231514),
(246392, '6ce2A00', NULL, NULL, 121, NULL, NULL, 231514),
(246393, '3u8iA00', NULL, NULL, 124, NULL, NULL, 231514),
(246394, '4dcfA00', NULL, NULL, 122, NULL, NULL, 231514),
(246395, '1s6bA00', NULL, NULL, 119, NULL, NULL, 231514),
(246396, '2h4cB00', NULL, NULL, 122, NULL, NULL, 231514),
(246397, '1poaA00', NULL, NULL, 118, NULL, NULL, 231514),
(246398, '1mc2A00', NULL, NULL, 122, NULL, NULL, 231514),
(246399, '3i03A00', NULL, NULL, 121, NULL, NULL, 231514),
(246400, '2pvtA00', NULL, NULL, 121, NULL, NULL, 231514),
(246401, '3eloA00', NULL, NULL, 133, NULL, NULL, 231514),
(246402, '1y75B00', NULL, NULL, 118, NULL, NULL, 231514),
(246403, '1s8iA00', NULL, NULL, 121, NULL, NULL, 231514),
(246404, '1fe5A00', NULL, NULL, 118, NULL, NULL, 231514),
(246405, '1jltB00', NULL, NULL, 122, NULL, NULL, 231514),
(246406, '2ph4A00', NULL, NULL, 121, NULL, NULL, 231514),
(246407, '2wg7A00', NULL, NULL, 130, NULL, NULL, 231514),
(246408, '3jr8A00', NULL, NULL, 122, NULL, NULL, 231514),
(246409, '1oqsB00', NULL, NULL, 122, NULL, NULL, 231514),
(246410, '1oz6A00', NULL, NULL, 120, NULL, NULL, 231514),
(246411, '1ozyA00', NULL, NULL, 121, NULL, NULL, 231514),
(246412, '1mh8A00', NULL, NULL, 119, NULL, NULL, 231514),
(246413, '3vbzA00', NULL, NULL, 118, NULL, NULL, 231514),
(246414, '3vc0A00', NULL, NULL, 118, NULL, NULL, 231514),
(246415, '4ntwC00', NULL, NULL, 119, NULL, NULL, 231514),
(246416, '1m8tA00', NULL, NULL, 119, NULL, NULL, 231514),
(246417, '1q6vA00', NULL, NULL, 121, NULL, NULL, 231514),
(246418, '1tc8A00', NULL, NULL, 118, NULL, NULL, 231514),
(246419, '1y6oA00', NULL, NULL, 131, NULL, NULL, 231514),
(246420, '1pp2L00', NULL, NULL, 122, NULL, NULL, 231514),
(246421, '3ux7A00', NULL, NULL, 122, NULL, NULL, 231514),
(246422, '1owsA00', NULL, NULL, 118, NULL, NULL, 231514),
(246423, '1mh2B00', NULL, NULL, 119, NULL, NULL, 231514),
(246424, '4h0sA00', NULL, NULL, 121, NULL, NULL, 231514),
(246425, '1s6bB00', NULL, NULL, 119, NULL, NULL, 231514),
(246426, '5tfvA00', NULL, NULL, 122, NULL, NULL, 231514),
(246427, '2h4cA00', NULL, NULL, 122, NULL, NULL, 231514),
(246428, '4e4cA00', NULL, NULL, 119, NULL, NULL, 231514),
(246429, '2oshA00', NULL, NULL, 119, NULL, NULL, 231514),
(246430, '1l8sA00', NULL, NULL, 124, NULL, NULL, 231514),
(246431, '1lwbA00', NULL, NULL, 122, NULL, NULL, 231514),
(246432, '1mkuA00', NULL, NULL, 123, NULL, NULL, 231514),
(246433, '1g0zA00', NULL, NULL, 118, NULL, NULL, 231514),
(246434, '1gmzB00', NULL, NULL, 122, NULL, NULL, 231514),
(246435, '1pocA00', NULL, NULL, 134, NULL, NULL, 231514);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(246436, '5owcA00', NULL, NULL, 122, NULL, NULL, 231514),
(246437, '4aupB00', NULL, NULL, 123, NULL, NULL, 231514),
(246438, '2qhdA00', NULL, NULL, 122, NULL, NULL, 231514),
(246439, '4hg9A00', NULL, NULL, 122, NULL, NULL, 231514),
(246440, '1pwoA00', NULL, NULL, 124, NULL, NULL, 231514),
(246441, '1vapA00', NULL, NULL, 123, NULL, NULL, 231514),
(246442, '1jltA00', NULL, NULL, 122, NULL, NULL, 231514),
(246443, '3g8hA00', NULL, NULL, 122, NULL, NULL, 231514),
(246444, '1gp7A00', NULL, NULL, 124, NULL, NULL, 231514),
(246445, '2qogB00', NULL, NULL, 122, NULL, NULL, 231514),
(246446, '1vipA00', NULL, NULL, 121, NULL, NULL, 231514),
(246447, '2wq5A00', NULL, NULL, 119, NULL, NULL, 231514),
(246448, '1zlbA00', NULL, NULL, 122, NULL, NULL, 231514),
(246449, '1ijlA00', NULL, NULL, 123, NULL, NULL, 231514),
(246450, '4rfpA00', NULL, NULL, 121, NULL, NULL, 231514),
(246451, '3v9mA00', NULL, NULL, 118, NULL, NULL, 231514),
(246452, '3jqlA00', NULL, NULL, 119, NULL, NULL, 231514),
(246453, '1a2aA00', NULL, NULL, 122, NULL, NULL, 231514),
(246454, '1g2xA00', NULL, NULL, 118, NULL, NULL, 231514),
(246455, '2g58A00', NULL, NULL, 121, NULL, NULL, 231514),
(246456, '1oqsA00', NULL, NULL, 122, NULL, NULL, 231514),
(246457, '1godA00', NULL, NULL, 121, NULL, NULL, 231514),
(246458, '3dihA00', NULL, NULL, 122, NULL, NULL, 231514),
(246459, '1lffA00', NULL, NULL, 119, NULL, NULL, 231514),
(246460, '6al3A00', NULL, NULL, 122, NULL, NULL, 231514),
(246461, '1m8rA00', NULL, NULL, 124, NULL, NULL, 231514),
(246462, '5y5eA00', NULL, NULL, 123, NULL, NULL, 231514),
(246463, '1owsB00', NULL, NULL, 118, NULL, NULL, 231514),
(246464, '2aozA00', NULL, NULL, 121, NULL, NULL, 231514),
(246465, '3r0lD00', NULL, NULL, 122, NULL, NULL, 231514),
(246466, '1g4iA00', NULL, NULL, 123, NULL, NULL, 231514),
(246467, '1bunA00', NULL, NULL, 120, NULL, NULL, 231514),
(246468, '1mh2A00', NULL, NULL, 119, NULL, NULL, 231514),
(246469, '1y4lA00', NULL, NULL, 121, NULL, NULL, 231514),
(246470, '1dpyA00', NULL, NULL, 118, NULL, NULL, 231514),
(246471, '2notA00', NULL, NULL, 119, NULL, NULL, 231514),
(246472, '1yxhA00', NULL, NULL, 126, NULL, NULL, 231514),
(246473, '3h20A02', NULL, NULL, 107, NULL, NULL, 231515),
(246474, '2eplX03', NULL, NULL, 225, NULL, NULL, 231516),
(246475, '4a4aA04', NULL, NULL, 295, NULL, NULL, 231516),
(246476, '5a6bA03', NULL, NULL, 225, NULL, NULL, 231516),
(246477, '2fi2A00', NULL, NULL, 94, NULL, NULL, 231517),
(246478, '4bhxB00', NULL, NULL, 94, NULL, NULL, 231517),
(246479, '4e6sA00', NULL, NULL, 93, NULL, NULL, 231517),
(246480, '1y7qA00', NULL, NULL, 98, NULL, NULL, 231517),
(246481, '3lhrB00', NULL, NULL, 93, NULL, NULL, 231517),
(246482, '3gkuC01', NULL, NULL, 59, NULL, NULL, 231518),
(246483, '2eo2A00', NULL, NULL, 71, NULL, NULL, 231519),
(246484, '6e4lA00', NULL, NULL, 369, NULL, NULL, 231520),
(246485, '2rt9A00', NULL, NULL, 59, NULL, NULL, 231521),
(246486, '1rqfD02', NULL, NULL, 71, NULL, NULL, 231521),
(246487, '2jmoA01', NULL, NULL, 55, NULL, NULL, 231521),
(246488, '4dglB02', NULL, NULL, 78, NULL, NULL, 231521),
(246489, '2m6nA00', NULL, NULL, 58, NULL, NULL, 231521),
(246490, '1qf8A02', NULL, NULL, 75, NULL, NULL, 231521),
(246491, '1qf8B02', NULL, NULL, 60, NULL, NULL, 231521),
(246492, '2nyaA04', NULL, NULL, 125, NULL, NULL, 231522),
(246493, '5b6cA01', NULL, NULL, 89, NULL, NULL, 231522),
(246494, '1g8kA04', NULL, NULL, 135, NULL, NULL, 231522),
(246495, '1h0hA04', NULL, NULL, 176, NULL, NULL, 231522),
(246496, '5t5iD00', NULL, NULL, 130, NULL, NULL, 231522),
(246497, '2napA04', NULL, NULL, 114, NULL, NULL, 231522),
(246498, '5ls7D00', NULL, NULL, 102, NULL, NULL, 231522),
(246499, '2vpzA05', NULL, NULL, 161, NULL, NULL, 231522),
(246500, '1q16A13', NULL, NULL, 152, NULL, NULL, 231522),
(246501, '2c45A00', NULL, NULL, 114, NULL, NULL, 231522),
(246502, '1pqhB00', NULL, NULL, 126, NULL, NULL, 231522),
(246503, '1tmoA04', NULL, NULL, 173, NULL, NULL, 231522),
(246504, '3qq8A01', NULL, NULL, 106, NULL, NULL, 231522),
(246505, '1ti2A04', NULL, NULL, 155, NULL, NULL, 231522),
(246506, '2o5iN04', NULL, NULL, 93, NULL, NULL, 231522);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(246507, '3h0gA02', NULL, NULL, 101, NULL, NULL, 231522),
(246508, '3plxB00', NULL, NULL, 102, NULL, NULL, 231522),
(246509, '5nqdA04', NULL, NULL, 136, NULL, NULL, 231522),
(246510, '1uheA00', NULL, NULL, 97, NULL, NULL, 231522),
(246511, '3ml1A04', NULL, NULL, 125, NULL, NULL, 231522),
(246512, '2a6hD04', NULL, NULL, 145, NULL, NULL, 231522),
(246513, '1wlfA01', NULL, NULL, 97, NULL, NULL, 231522),
(246514, '1cz4A01', NULL, NULL, 92, NULL, NULL, 231522),
(246515, '1dmrA04', NULL, NULL, 163, NULL, NULL, 231522),
(246516, '1eu1A04', NULL, NULL, 163, NULL, NULL, 231522),
(246517, '4rv0A01', NULL, NULL, 89, NULL, NULL, 231522),
(246518, '2ki8A01', NULL, NULL, 125, NULL, NULL, 231522),
(246519, '1ogyA04', NULL, NULL, 125, NULL, NULL, 231522),
(246520, '4ga6A01', NULL, NULL, 83, NULL, NULL, 231522),
(246521, '1cr5A01', NULL, NULL, 81, NULL, NULL, 231522),
(246522, '4aybA02', NULL, NULL, 114, NULL, NULL, 231522),
(246523, '5fj8A03', NULL, NULL, 126, NULL, NULL, 231522),
(246524, '1twfA03', NULL, NULL, 101, NULL, NULL, 231522),
(246525, '1y5iA04', NULL, NULL, 191, NULL, NULL, 231522),
(246526, '1yleA02', NULL, NULL, 67, NULL, NULL, 231522),
(246527, '4qiwA02', NULL, NULL, 102, NULL, NULL, 231522),
(246528, '2iv2X04', NULL, NULL, 117, NULL, NULL, 231522),
(246529, '1vc3B00', NULL, NULL, 96, NULL, NULL, 231522),
(246530, '5x4lA01', NULL, NULL, 88, NULL, NULL, 231522),
(246531, '1kqfA04', NULL, NULL, 176, NULL, NULL, 231522),
(246532, '3ougA00', NULL, NULL, 114, NULL, NULL, 231522),
(246533, '4c2mA03', NULL, NULL, 102, NULL, NULL, 231522),
(246534, '1qcsA01', NULL, NULL, 82, NULL, NULL, 231522),
(246535, '2e7zA04', NULL, NULL, 161, NULL, NULL, 231522),
(246536, '1uouA03', NULL, NULL, 95, NULL, NULL, 231523),
(246537, '5olnA03', NULL, NULL, 93, NULL, NULL, 231523),
(246538, '4eadA03', NULL, NULL, 97, NULL, NULL, 231523),
(246539, '1brwA01', NULL, NULL, 94, NULL, NULL, 231523),
(246540, '3h5qA03', NULL, NULL, 93, NULL, NULL, 231523),
(246541, '2dsjA03', NULL, NULL, 92, NULL, NULL, 231523),
(246542, '4ga6A04', NULL, NULL, 81, NULL, NULL, 231523),
(246543, '5ey3A03', NULL, NULL, 97, NULL, NULL, 231523),
(246544, '3g87A02', NULL, NULL, 67, NULL, NULL, 231524),
(246545, '4qbuA03', NULL, NULL, 66, NULL, NULL, 231524),
(246546, '3im8A02', NULL, NULL, 73, NULL, NULL, 231524),
(246547, '5dz6A02', NULL, NULL, 69, NULL, NULL, 231524),
(246548, '3sbmA02', NULL, NULL, 68, NULL, NULL, 231524),
(246549, '4rr5A02', NULL, NULL, 64, NULL, NULL, 231524),
(246550, '2jfkA03', NULL, NULL, 66, NULL, NULL, 231524),
(246551, '3r8yA01', NULL, NULL, 66, NULL, NULL, 231524),
(246552, '5dz7A02', NULL, NULL, 69, NULL, NULL, 231524),
(246553, '3tqeA02', NULL, NULL, 73, NULL, NULL, 231524),
(246554, '3cj8B02', NULL, NULL, 66, NULL, NULL, 231524),
(246555, '5ypvA02', NULL, NULL, 74, NULL, NULL, 231524),
(246556, '3tzyA02', NULL, NULL, 70, NULL, NULL, 231524),
(246557, '1nm2A01', NULL, NULL, 68, NULL, NULL, 231524),
(246558, '2cuyA02', NULL, NULL, 69, NULL, NULL, 231524),
(246559, '5my2A04', NULL, NULL, 66, NULL, NULL, 231524),
(246560, '3h0pA02', NULL, NULL, 73, NULL, NULL, 231524),
(246561, '3hjvA02', NULL, NULL, 73, NULL, NULL, 231524),
(246562, '3bv8A00', NULL, NULL, 87, NULL, NULL, 231524),
(246563, '1mlaA01', NULL, NULL, 73, NULL, NULL, 231524),
(246564, '2qc3A02', NULL, NULL, 64, NULL, NULL, 231524),
(246565, '3im9A02', NULL, NULL, 74, NULL, NULL, 231524),
(246566, '3hhdA04', NULL, NULL, 66, NULL, NULL, 231524),
(246567, '3qatA02', NULL, NULL, 73, NULL, NULL, 231524),
(246568, '2c2nA02', NULL, NULL, 77, NULL, NULL, 231524),
(246569, '3k89A02', NULL, NULL, 73, NULL, NULL, 231524),
(246570, '3ptwA02', NULL, NULL, 70, NULL, NULL, 231524),
(246571, '4rl1A02', NULL, NULL, 71, NULL, NULL, 231524),
(246572, '3ezoA02', NULL, NULL, 73, NULL, NULL, 231524),
(246573, '2h1yA02', NULL, NULL, 70, NULL, NULL, 231524),
(246574, '5zcrA03', NULL, NULL, 85, NULL, NULL, 231525),
(246575, '1iv8A03', NULL, NULL, 85, NULL, NULL, 231525),
(246576, '3hjeA03', NULL, NULL, 91, NULL, NULL, 231525),
(246577, '4akgA04', NULL, NULL, 156, NULL, NULL, 231526);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(246578, '3vkgB03', NULL, NULL, 156, NULL, NULL, 231526),
(246579, '4fl3A02', NULL, NULL, 41, NULL, NULL, 231527),
(246580, '2oq1A02', NULL, NULL, 45, NULL, NULL, 231527),
(246581, '1ei6A02', NULL, NULL, 111, NULL, NULL, 231528),
(246582, '3szyA02', NULL, NULL, 111, NULL, NULL, 231528),
(246583, '2wy3B00', NULL, NULL, 137, NULL, NULL, 231529),
(246584, '5t57A01', NULL, NULL, 175, NULL, NULL, 231530),
(246585, '3widA02', NULL, NULL, 183, NULL, NULL, 231530),
(246586, '3pwzA02', NULL, NULL, 122, NULL, NULL, 231530),
(246587, '4gx0B04', NULL, NULL, 131, NULL, NULL, 231530),
(246588, '3f1lB00', NULL, NULL, 252, NULL, NULL, 231530),
(246589, '1xdwA02', NULL, NULL, 197, NULL, NULL, 231530),
(246590, '3gg2A01', NULL, NULL, 204, NULL, NULL, 231530),
(246591, '1xdwA01', NULL, NULL, 133, NULL, NULL, 231530),
(246592, '3c8mA01', NULL, NULL, 176, NULL, NULL, 231530),
(246593, '3wb9A01', NULL, NULL, 191, NULL, NULL, 231530),
(246594, '3l6dA01', NULL, NULL, 164, NULL, NULL, 231530),
(246595, '2bd0A01', NULL, NULL, 235, NULL, NULL, 231530),
(246596, '1hdgO01', NULL, NULL, 167, NULL, NULL, 231530),
(246597, '3evnA01', NULL, NULL, 123, NULL, NULL, 231530),
(246598, '3euwA01', NULL, NULL, 122, NULL, NULL, 231530),
(246599, '3un1C00', NULL, NULL, 234, NULL, NULL, 231530),
(246600, '4r1sB00', NULL, NULL, 337, NULL, NULL, 231530),
(246601, '4rf5A00', NULL, NULL, 251, NULL, NULL, 231530),
(246602, '1eq2A01', NULL, NULL, 203, NULL, NULL, 231530),
(246603, '2amfA01', NULL, NULL, 149, NULL, NULL, 231530),
(246604, '1a5zA01', NULL, NULL, 141, NULL, NULL, 231530),
(246605, '1kolA02', NULL, NULL, 167, NULL, NULL, 231530),
(246606, '4nr0A00', NULL, NULL, 273, NULL, NULL, 231530),
(246607, '5yecC00', NULL, NULL, 340, NULL, NULL, 231530),
(246608, '3h2sA00', NULL, NULL, 224, NULL, NULL, 231530),
(246609, '2bgkA00', NULL, NULL, 278, NULL, NULL, 231530),
(246610, '5kvsB01', NULL, NULL, 199, NULL, NULL, 231530),
(246611, '3kb6A01', NULL, NULL, 132, NULL, NULL, 231530),
(246612, '3kb6A02', NULL, NULL, 202, NULL, NULL, 231530),
(246613, '2b5wA02', NULL, NULL, 133, NULL, NULL, 231530),
(246614, '3b1jA01', NULL, NULL, 174, NULL, NULL, 231530),
(246615, '3gt0A01', NULL, NULL, 160, NULL, NULL, 231530),
(246616, '4xdzA01', NULL, NULL, 182, NULL, NULL, 231530),
(246617, '3pgxA00', NULL, NULL, 280, NULL, NULL, 231530),
(246618, '3l4bC01', NULL, NULL, 117, NULL, NULL, 231530),
(246619, '4h15A00', NULL, NULL, 261, NULL, NULL, 231530),
(246620, '1z45A01', NULL, NULL, 278, NULL, NULL, 231530),
(246621, '4x54A00', NULL, NULL, 243, NULL, NULL, 231530),
(246622, '4a27A02', NULL, NULL, 188, NULL, NULL, 231530),
(246623, '4k6fA00', NULL, NULL, 255, NULL, NULL, 231530),
(246624, '4pzcA01', NULL, NULL, 189, NULL, NULL, 231530),
(246625, '2uv9E03', NULL, NULL, 455, NULL, NULL, 231530),
(246626, '4rziA00', NULL, NULL, 240, NULL, NULL, 231530),
(246627, '2cvoA01', NULL, NULL, 168, NULL, NULL, 231530),
(246628, '4fccA03', NULL, NULL, 165, NULL, NULL, 231530),
(246629, '5loaA01', NULL, NULL, 167, NULL, NULL, 231530),
(246630, '1mx3A02', NULL, NULL, 194, NULL, NULL, 231530),
(246631, '1yovD01', NULL, NULL, 242, NULL, NULL, 231530),
(246632, '4hy3A02', NULL, NULL, 187, NULL, NULL, 231530),
(246633, '4hy3A01', NULL, NULL, 151, NULL, NULL, 231530),
(246634, '3nx4A02', NULL, NULL, 167, NULL, NULL, 231530),
(246635, '3ennD00', NULL, NULL, 249, NULL, NULL, 231530),
(246636, '4cpdA02', NULL, NULL, 135, NULL, NULL, 231530),
(246637, '2vn8A02', NULL, NULL, 183, NULL, NULL, 231530),
(246638, '1mx3A01', NULL, NULL, 133, NULL, NULL, 231530),
(246639, '2ldxA01', NULL, NULL, 161, NULL, NULL, 231530),
(246640, '3oidC00', NULL, NULL, 258, NULL, NULL, 231530),
(246641, '3e82B01', NULL, NULL, 148, NULL, NULL, 231530),
(246642, '2z1mB01', NULL, NULL, 238, NULL, NULL, 231530),
(246643, '3k31B00', NULL, NULL, 276, NULL, NULL, 231530),
(246644, '3t4xA00', NULL, NULL, 267, NULL, NULL, 231530),
(246645, '2ptgA01', NULL, NULL, 247, NULL, NULL, 231530),
(246646, '3awdA00', NULL, NULL, 260, NULL, NULL, 231530),
(246647, '1c1dA02', NULL, NULL, 202, NULL, NULL, 231530),
(246648, '1civA01', NULL, NULL, 153, NULL, NULL, 231530);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(246649, '2pkqT01', NULL, NULL, 176, NULL, NULL, 231530),
(246650, '1yxmC00', NULL, NULL, 303, NULL, NULL, 231530),
(246651, '2ejwA01', NULL, NULL, 183, NULL, NULL, 231530),
(246652, '6bi4A01', NULL, NULL, 221, NULL, NULL, 231530),
(246653, '3vpxB02', NULL, NULL, 203, NULL, NULL, 231530),
(246654, '4ypoA01', NULL, NULL, 179, NULL, NULL, 231530),
(246655, '3tjrA00', NULL, NULL, 278, NULL, NULL, 231530),
(246656, '3f1kA00', NULL, NULL, 252, NULL, NULL, 231530),
(246657, '4npcA00', NULL, NULL, 265, NULL, NULL, 231530),
(246658, '4b4uB01', NULL, NULL, 133, NULL, NULL, 231530),
(246659, '1bxkA01', NULL, NULL, 252, NULL, NULL, 231530),
(246660, '4yxfB00', NULL, NULL, 237, NULL, NULL, 231530),
(246661, '5z75A00', NULL, NULL, 308, NULL, NULL, 231530),
(246662, '4nd2A01', NULL, NULL, 146, NULL, NULL, 231530),
(246663, '4ej6A02', NULL, NULL, 139, NULL, NULL, 231530),
(246664, '3uw3B01', NULL, NULL, 156, NULL, NULL, 231530),
(246665, '4jcoA01', NULL, NULL, 143, NULL, NULL, 231530),
(246666, '1q7bB00', NULL, NULL, 244, NULL, NULL, 231530),
(246667, '2cvzA01', NULL, NULL, 157, NULL, NULL, 231530),
(246668, '2v6fA00', NULL, NULL, 364, NULL, NULL, 231530),
(246669, '2vq3A00', NULL, NULL, 187, NULL, NULL, 231530),
(246670, '3pidA01', NULL, NULL, 199, NULL, NULL, 231530),
(246671, '1euzA02', NULL, NULL, 237, NULL, NULL, 231530),
(246672, '1zh8A01', NULL, NULL, 158, NULL, NULL, 231530),
(246673, '4b7cB02', NULL, NULL, 177, NULL, NULL, 231530),
(246674, '3pidA03', NULL, NULL, 109, NULL, NULL, 231530),
(246675, '7mdhA01', NULL, NULL, 153, NULL, NULL, 231530),
(246676, '5f5nA00', NULL, NULL, 289, NULL, NULL, 231530),
(246677, '3e48A01', NULL, NULL, 184, NULL, NULL, 231530),
(246678, '4mkxA01', NULL, NULL, 162, NULL, NULL, 231530),
(246679, '4m55E00', NULL, NULL, 177, NULL, NULL, 231530),
(246680, '3wfiA01', NULL, NULL, 178, NULL, NULL, 231530),
(246681, '4fshB02', NULL, NULL, 133, NULL, NULL, 231530),
(246682, '5t67A04', NULL, NULL, 99, NULL, NULL, 231530),
(246683, '3eheA01', NULL, NULL, 197, NULL, NULL, 231530),
(246684, '3qv1A01', NULL, NULL, 170, NULL, NULL, 231530),
(246685, '5je8B01', NULL, NULL, 170, NULL, NULL, 231530),
(246686, '3c1aA01', NULL, NULL, 170, NULL, NULL, 231530),
(246687, '2py6A02', NULL, NULL, 120, NULL, NULL, 231530),
(246688, '1z82A01', NULL, NULL, 188, NULL, NULL, 231530),
(246689, '4b79B00', NULL, NULL, 242, NULL, NULL, 231530),
(246690, '1y6jA01', NULL, NULL, 148, NULL, NULL, 231530),
(246691, '4mowC00', NULL, NULL, 256, NULL, NULL, 231530),
(246692, '2o7sA03', NULL, NULL, 184, NULL, NULL, 231530),
(246693, '1yo6F00', NULL, NULL, 250, NULL, NULL, 231530),
(246694, '1nffA00', NULL, NULL, 260, NULL, NULL, 231530),
(246695, '5o9fA02', NULL, NULL, 137, NULL, NULL, 231530),
(246696, '3gohA02', NULL, NULL, 126, NULL, NULL, 231530),
(246697, '1qmgB01', NULL, NULL, 230, NULL, NULL, 231530),
(246698, '1vj0A02', NULL, NULL, 147, NULL, NULL, 231530),
(246699, '3i23A01', NULL, NULL, 122, NULL, NULL, 231530),
(246700, '3gnqA01', NULL, NULL, 179, NULL, NULL, 231530),
(246701, '2b69A01', NULL, NULL, 232, NULL, NULL, 231530),
(246702, '1kc0A00', NULL, NULL, 299, NULL, NULL, 231530),
(246703, '4iiuC00', NULL, NULL, 242, NULL, NULL, 231530),
(246704, '3k8zC03', NULL, NULL, 154, NULL, NULL, 231530),
(246705, '3nklB00', NULL, NULL, 125, NULL, NULL, 231530),
(246706, '2ph3B00', NULL, NULL, 245, NULL, NULL, 231530),
(246707, '3tqhA02', NULL, NULL, 133, NULL, NULL, 231530),
(246708, '4ijkB00', NULL, NULL, 247, NULL, NULL, 231530),
(246709, '6biiA02', NULL, NULL, 193, NULL, NULL, 231530),
(246710, '6biiA01', NULL, NULL, 140, NULL, NULL, 231530),
(246711, '3u9lA00', NULL, NULL, 299, NULL, NULL, 231530),
(246712, '4trrG00', NULL, NULL, 269, NULL, NULL, 231530),
(246713, '3dfuA01', NULL, NULL, 131, NULL, NULL, 231530),
(246714, '1yj8A01', NULL, NULL, 214, NULL, NULL, 231530),
(246715, '3h9eP01', NULL, NULL, 179, NULL, NULL, 231530),
(246716, '5z76D00', NULL, NULL, 314, NULL, NULL, 231530),
(246717, '3tl3B00', NULL, NULL, 257, NULL, NULL, 231530),
(246718, '4da9B00', NULL, NULL, 255, NULL, NULL, 231530),
(246719, '3ajrB00', NULL, NULL, 317, NULL, NULL, 231530);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(246720, '1sbyA00', NULL, NULL, 254, NULL, NULL, 231530),
(246721, '2jl1A01', NULL, NULL, 171, NULL, NULL, 231530),
(246722, '3gafH00', NULL, NULL, 256, NULL, NULL, 231530),
(246723, '4hy3C01', NULL, NULL, 128, NULL, NULL, 231530),
(246724, '4tklB00', NULL, NULL, 258, NULL, NULL, 231530),
(246725, '2fr1A00', NULL, NULL, 486, NULL, NULL, 231530),
(246726, '4j0eA01', NULL, NULL, 205, NULL, NULL, 231530),
(246727, '3ojoA01', NULL, NULL, 207, NULL, NULL, 231530),
(246728, '3ew7A00', NULL, NULL, 221, NULL, NULL, 231530),
(246729, '4k26A00', NULL, NULL, 276, NULL, NULL, 231530),
(246730, '3oetA02', NULL, NULL, 166, NULL, NULL, 231530),
(246731, '5l53A00', NULL, NULL, 324, NULL, NULL, 231530),
(246732, '3wyeB00', NULL, NULL, 256, NULL, NULL, 231530),
(246733, '4dupA02', NULL, NULL, 143, NULL, NULL, 231530),
(246734, '5l4lA00', NULL, NULL, 283, NULL, NULL, 231530),
(246735, '3wmwA00', NULL, NULL, 309, NULL, NULL, 231530),
(246736, '5axaA02', NULL, NULL, 160, NULL, NULL, 231530),
(246737, '1lluA02', NULL, NULL, 138, NULL, NULL, 231530),
(246738, '1lc0A01', NULL, NULL, 143, NULL, NULL, 231530),
(246739, '4eueA00', NULL, NULL, 397, NULL, NULL, 231530),
(246740, '4mo2B01', NULL, NULL, 192, NULL, NULL, 231530),
(246741, '5jnmA01', NULL, NULL, 203, NULL, NULL, 231530),
(246742, '5dt9A01', NULL, NULL, 133, NULL, NULL, 231530),
(246743, '5gy7A01', NULL, NULL, 212, NULL, NULL, 231530),
(246744, '5dt9A02', NULL, NULL, 166, NULL, NULL, 231530),
(246745, '1mxhA00', NULL, NULL, 276, NULL, NULL, 231530),
(246746, '5aovA01', NULL, NULL, 143, NULL, NULL, 231530),
(246747, '3uf0A00', NULL, NULL, 249, NULL, NULL, 231530),
(246748, '1h6dA01', NULL, NULL, 170, NULL, NULL, 231530),
(246749, '2h63A01', NULL, NULL, 141, NULL, NULL, 231530),
(246750, '1v3uB02', NULL, NULL, 178, NULL, NULL, 231530),
(246751, '2z1nA00', NULL, NULL, 260, NULL, NULL, 231530),
(246752, '4b4oG00', NULL, NULL, 298, NULL, NULL, 231530),
(246753, '4esoD00', NULL, NULL, 255, NULL, NULL, 231530),
(246754, '5aovA02', NULL, NULL, 193, NULL, NULL, 231530),
(246755, '4nk4F00', NULL, NULL, 266, NULL, NULL, 231530),
(246756, '5xi0A00', NULL, NULL, 400, NULL, NULL, 231530),
(246757, '4oneC00', NULL, NULL, 262, NULL, NULL, 231530),
(246758, '4lswA02', NULL, NULL, 186, NULL, NULL, 231530),
(246759, '4lswA01', NULL, NULL, 132, NULL, NULL, 231530),
(246760, '1p3dA01', NULL, NULL, 88, NULL, NULL, 231530),
(246761, '2hunA01', NULL, NULL, 221, NULL, NULL, 231530),
(246762, '5a3vA02', NULL, NULL, 145, NULL, NULL, 231530),
(246763, '5i7sA00', NULL, NULL, 258, NULL, NULL, 231530),
(246764, '4lrtB01', NULL, NULL, 158, NULL, NULL, 231530),
(246765, '1h5qA00', NULL, NULL, 265, NULL, NULL, 231530),
(246766, '3d64A02', NULL, NULL, 158, NULL, NULL, 231530),
(246767, '4wojB01', NULL, NULL, 158, NULL, NULL, 231530),
(246768, '2eklA01', NULL, NULL, 122, NULL, NULL, 231530),
(246769, '2eklA02', NULL, NULL, 191, NULL, NULL, 231530),
(246770, '2yjzA00', NULL, NULL, 183, NULL, NULL, 231530),
(246771, '5zi2A01', NULL, NULL, 147, NULL, NULL, 231530),
(246772, '6acfA02', NULL, NULL, 203, NULL, NULL, 231530),
(246773, '5ceeA02', NULL, NULL, 233, NULL, NULL, 231530),
(246774, '3g79A01', NULL, NULL, 227, NULL, NULL, 231530),
(246775, '3g79A02', NULL, NULL, 251, NULL, NULL, 231530),
(246776, '1ks9A01', NULL, NULL, 167, NULL, NULL, 231530),
(246777, '3uxyD00', NULL, NULL, 241, NULL, NULL, 231530),
(246778, '1nvmB01', NULL, NULL, 158, NULL, NULL, 231530),
(246779, '5thkA00', NULL, NULL, 266, NULL, NULL, 231530),
(246780, '1f0yA01', NULL, NULL, 207, NULL, NULL, 231530),
(246781, '3s2eA02', NULL, NULL, 138, NULL, NULL, 231530),
(246782, '4m8sD00', NULL, NULL, 248, NULL, NULL, 231530),
(246783, '6e08L01', NULL, NULL, 193, NULL, NULL, 231530),
(246784, '2bmaA02', NULL, NULL, 224, NULL, NULL, 231530),
(246785, '4bvaA02', NULL, NULL, 162, NULL, NULL, 231530),
(246786, '3tl2A01', NULL, NULL, 152, NULL, NULL, 231530),
(246787, '3dhnA00', NULL, NULL, 227, NULL, NULL, 231530),
(246788, '3tz6A01', NULL, NULL, 146, NULL, NULL, 231530),
(246789, '4nbrA00', NULL, NULL, 273, NULL, NULL, 231530),
(246790, '5yw4A00', NULL, NULL, 334, NULL, NULL, 231530);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(246791, '1l7eA01', NULL, NULL, 183, NULL, NULL, 231530),
(246792, '4bnwB00', NULL, NULL, 252, NULL, NULL, 231530),
(246793, '4qedA00', NULL, NULL, 248, NULL, NULL, 231530),
(246794, '3hn2B01', NULL, NULL, 177, NULL, NULL, 231530),
(246795, '3g0oA01', NULL, NULL, 172, NULL, NULL, 231530),
(246796, '1xq1A00', NULL, NULL, 266, NULL, NULL, 231530),
(246797, '3ay3A01', NULL, NULL, 227, NULL, NULL, 231530),
(246798, '2p4qA01', NULL, NULL, 187, NULL, NULL, 231530),
(246799, '2ew2B01', NULL, NULL, 182, NULL, NULL, 231530),
(246800, '2uyyA01', NULL, NULL, 169, NULL, NULL, 231530),
(246801, '2ae2A00', NULL, NULL, 260, NULL, NULL, 231530),
(246802, '4d3dA01', NULL, NULL, 158, NULL, NULL, 231530),
(246803, '4n18A02', NULL, NULL, 183, NULL, NULL, 231530),
(246804, '2glxA01', NULL, NULL, 121, NULL, NULL, 231530),
(246805, '3nepX01', NULL, NULL, 143, NULL, NULL, 231530),
(246806, '4n18A01', NULL, NULL, 130, NULL, NULL, 231530),
(246807, '5zecA00', NULL, NULL, 342, NULL, NULL, 231530),
(246808, '1r0kA01', NULL, NULL, 150, NULL, NULL, 231530),
(246809, '4nheB01', NULL, NULL, 116, NULL, NULL, 231530),
(246810, '1lqtA01', NULL, NULL, 220, NULL, NULL, 231530),
(246811, '4ywjA01', NULL, NULL, 168, NULL, NULL, 231530),
(246812, '2wm3A01', NULL, NULL, 197, NULL, NULL, 231530),
(246813, '4yrdA01', NULL, NULL, 240, NULL, NULL, 231530),
(246814, '4xcvA01', NULL, NULL, 133, NULL, NULL, 231530),
(246815, '4ospD00', NULL, NULL, 263, NULL, NULL, 231530),
(246816, '4bkrA00', NULL, NULL, 406, NULL, NULL, 231530),
(246817, '4yqyB00', NULL, NULL, 247, NULL, NULL, 231530),
(246818, '4dyvA00', NULL, NULL, 245, NULL, NULL, 231530),
(246819, '5t5qB00', NULL, NULL, 247, NULL, NULL, 231530),
(246820, '1e3jA01', NULL, NULL, 138, NULL, NULL, 231530),
(246821, '4xcvA02', NULL, NULL, 187, NULL, NULL, 231530),
(246822, '4qqrB00', NULL, NULL, 301, NULL, NULL, 231530),
(246823, '4h7pA01', NULL, NULL, 154, NULL, NULL, 231530),
(246824, '5b4tA00', NULL, NULL, 260, NULL, NULL, 231530),
(246825, '3fr7A01', NULL, NULL, 230, NULL, NULL, 231530),
(246826, '5u4qB00', NULL, NULL, 337, NULL, NULL, 231530),
(246827, '3ulkA01', NULL, NULL, 208, NULL, NULL, 231530),
(246828, '1iy8A00', NULL, NULL, 267, NULL, NULL, 231530),
(246829, '3i6iA01', NULL, NULL, 195, NULL, NULL, 231530),
(246830, '4zn6A01', NULL, NULL, 159, NULL, NULL, 231530),
(246831, '3s8mA00', NULL, NULL, 391, NULL, NULL, 231530),
(246832, '4plgA01', NULL, NULL, 155, NULL, NULL, 231530),
(246833, '3llvA00', NULL, NULL, 141, NULL, NULL, 231530),
(246834, '4a0sA02', NULL, NULL, 147, NULL, NULL, 231530),
(246835, '4a5oB01', NULL, NULL, 133, NULL, NULL, 231530),
(246836, '6aqzF01', NULL, NULL, 241, NULL, NULL, 231530),
(246837, '1rpnA01', NULL, NULL, 243, NULL, NULL, 231530),
(246838, '4z0pA02', NULL, NULL, 187, NULL, NULL, 231530),
(246839, '6iheA01', NULL, NULL, 140, NULL, NULL, 231530),
(246840, '4z0pA01', NULL, NULL, 133, NULL, NULL, 231530),
(246841, '3u0bA01', NULL, NULL, 178, NULL, NULL, 231530),
(246842, '3u0bA02', NULL, NULL, 247, NULL, NULL, 231530),
(246843, '4xijA02', NULL, NULL, 139, NULL, NULL, 231530),
(246844, '2gasA01', NULL, NULL, 188, NULL, NULL, 231530),
(246845, '6j9sB01', NULL, NULL, 150, NULL, NULL, 231530),
(246846, '4ol9A01', NULL, NULL, 177, NULL, NULL, 231530),
(246847, '3sxpA01', NULL, NULL, 215, NULL, NULL, 231530),
(246848, '1s6yA01', NULL, NULL, 173, NULL, NULL, 231530),
(246849, '2eezA01', NULL, NULL, 193, NULL, NULL, 231530),
(246850, '1xygA01', NULL, NULL, 179, NULL, NULL, 231530),
(246851, '2eezA02', NULL, NULL, 176, NULL, NULL, 231530),
(246852, '3grkG00', NULL, NULL, 267, NULL, NULL, 231530),
(246853, '3gg2C03', NULL, NULL, 214, NULL, NULL, 231530),
(246854, '3rkrA00', NULL, NULL, 238, NULL, NULL, 231530),
(246855, '3dl2A01', NULL, NULL, 150, NULL, NULL, 231530),
(246856, '2yv1A01', NULL, NULL, 128, NULL, NULL, 231530),
(246857, '1dljA01', NULL, NULL, 204, NULL, NULL, 231530),
(246858, '4g65A01', NULL, NULL, 138, NULL, NULL, 231530),
(246859, '4kmsB00', NULL, NULL, 249, NULL, NULL, 231530),
(246860, '1dljA02', NULL, NULL, 108, NULL, NULL, 231530),
(246861, '4g65A03', NULL, NULL, 134, NULL, NULL, 231530);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(246862, '1vl0A01', NULL, NULL, 214, NULL, NULL, 231530),
(246863, '6cauA01', NULL, NULL, 100, NULL, NULL, 231530),
(246864, '2zb4A02', NULL, NULL, 181, NULL, NULL, 231530),
(246865, '1ez4B01', NULL, NULL, 146, NULL, NULL, 231530),
(246866, '3v5nA01', NULL, NULL, 177, NULL, NULL, 231530),
(246867, '3fi9A01', NULL, NULL, 151, NULL, NULL, 231530),
(246868, '1zemA00', NULL, NULL, 262, NULL, NULL, 231530),
(246869, '3pqeA01', NULL, NULL, 147, NULL, NULL, 231530),
(246870, '4k28A02', NULL, NULL, 147, NULL, NULL, 231530),
(246871, '3rufA01', NULL, NULL, 243, NULL, NULL, 231530),
(246872, '1gu7A02', NULL, NULL, 181, NULL, NULL, 231530),
(246873, '2y05A02', NULL, NULL, 178, NULL, NULL, 231530),
(246874, '3k96A01', NULL, NULL, 187, NULL, NULL, 231530),
(246875, '3fplA02', NULL, NULL, 138, NULL, NULL, 231530),
(246876, '6huyA01', NULL, NULL, 205, NULL, NULL, 231530),
(246877, '4yrbA00', NULL, NULL, 235, NULL, NULL, 231530),
(246878, '4xkjA02', NULL, NULL, 195, NULL, NULL, 231530),
(246879, '1snyA00', NULL, NULL, 267, NULL, NULL, 231530),
(246880, '3b1fA01', NULL, NULL, 179, NULL, NULL, 231530),
(246881, '2ztuB00', NULL, NULL, 260, NULL, NULL, 231530),
(246882, '4r16A01', NULL, NULL, 196, NULL, NULL, 231530),
(246883, '3qvoA00', NULL, NULL, 236, NULL, NULL, 231530),
(246884, '3ckyA01', NULL, NULL, 166, NULL, NULL, 231530),
(246885, '2i99A02', NULL, NULL, 162, NULL, NULL, 231530),
(246886, '3k30A02', NULL, NULL, 160, NULL, NULL, 231530),
(246887, '3gvxA02', NULL, NULL, 177, NULL, NULL, 231530),
(246888, '3slkA03', NULL, NULL, 247, NULL, NULL, 231530),
(246889, '6aqjA01', NULL, NULL, 180, NULL, NULL, 231530),
(246890, '4e5nC01', NULL, NULL, 133, NULL, NULL, 231530),
(246891, '5ff5B02', NULL, NULL, 288, NULL, NULL, 231530),
(246892, '3p19B00', NULL, NULL, 266, NULL, NULL, 231530),
(246893, '4xwyA00', NULL, NULL, 258, NULL, NULL, 231530),
(246894, '2zatA00', NULL, NULL, 260, NULL, NULL, 231530),
(246895, '4e12A01', NULL, NULL, 193, NULL, NULL, 231530),
(246896, '4r16A02', NULL, NULL, 189, NULL, NULL, 231530),
(246897, '5h82B02', NULL, NULL, 157, NULL, NULL, 231530),
(246898, '3e9qA00', NULL, NULL, 255, NULL, NULL, 231530),
(246899, '4p4gA02', NULL, NULL, 139, NULL, NULL, 231530),
(246900, '1edoA00', NULL, NULL, 244, NULL, NULL, 231530),
(246901, '4wokA01', NULL, NULL, 213, NULL, NULL, 231530),
(246902, '2d1yA00', NULL, NULL, 256, NULL, NULL, 231530),
(246903, '3tscA00', NULL, NULL, 277, NULL, NULL, 231530),
(246904, '2rh8A00', NULL, NULL, 338, NULL, NULL, 231530),
(246905, '2b4rO01', NULL, NULL, 176, NULL, NULL, 231530),
(246906, '4nbtA00', NULL, NULL, 240, NULL, NULL, 231530),
(246907, '3jtmA01', NULL, NULL, 160, NULL, NULL, 231530),
(246908, '3jtmA02', NULL, NULL, 191, NULL, NULL, 231530),
(246909, '3op4B00', NULL, NULL, 248, NULL, NULL, 231530),
(246910, '3sc6A01', NULL, NULL, 208, NULL, NULL, 231530),
(246911, '6cepA01', NULL, NULL, 148, NULL, NULL, 231530),
(246912, '1oi7A01', NULL, NULL, 122, NULL, NULL, 231530),
(246913, '1yb1B01', NULL, NULL, 241, NULL, NULL, 231530),
(246914, '1h2bA02', NULL, NULL, 140, NULL, NULL, 231530),
(246915, '3v2uA01', NULL, NULL, 186, NULL, NULL, 231530),
(246916, '5zxnB02', NULL, NULL, 182, NULL, NULL, 231530),
(246917, '4jp2A00', NULL, NULL, 239, NULL, NULL, 231530),
(246918, '5z1zA01', NULL, NULL, 132, NULL, NULL, 231530),
(246919, '2q1sA01', NULL, NULL, 258, NULL, NULL, 231530),
(246920, '3d5tC01', NULL, NULL, 159, NULL, NULL, 231530),
(246921, '2rafB01', NULL, NULL, 188, NULL, NULL, 231530),
(246922, '1vknA01', NULL, NULL, 173, NULL, NULL, 231530),
(246923, '1xu9C00', NULL, NULL, 286, NULL, NULL, 231530),
(246924, '1x13B01', NULL, NULL, 202, NULL, NULL, 231530),
(246925, '1edzA01', NULL, NULL, 158, NULL, NULL, 231530),
(246926, '2tmgA02', NULL, NULL, 237, NULL, NULL, 231530),
(246927, '3db2A01', NULL, NULL, 142, NULL, NULL, 231530),
(246928, '3o26A00', NULL, NULL, 311, NULL, NULL, 231530),
(246929, '2nm0A00', NULL, NULL, 234, NULL, NULL, 231530),
(246930, '6dc6A04', NULL, NULL, 223, NULL, NULL, 231530),
(246931, '2q2qF00', NULL, NULL, 255, NULL, NULL, 231530),
(246932, '4uuoA01', NULL, NULL, 152, NULL, NULL, 231530);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(246933, '4lgvA01', NULL, NULL, 189, NULL, NULL, 231530),
(246934, '4pvdD00', NULL, NULL, 342, NULL, NULL, 231530),
(246935, '3qp9D00', NULL, NULL, 499, NULL, NULL, 231530),
(246936, '2fwmX00', NULL, NULL, 214, NULL, NULL, 231530),
(246937, '4gqaB01', NULL, NULL, 134, NULL, NULL, 231530),
(246938, '3qhaA01', NULL, NULL, 173, NULL, NULL, 231530),
(246939, '3a28A00', NULL, NULL, 258, NULL, NULL, 231530),
(246940, '1gz6B01', NULL, NULL, 246, NULL, NULL, 231530),
(246941, '1sc6A01', NULL, NULL, 133, NULL, NULL, 231530),
(246942, '2axqA01', NULL, NULL, 174, NULL, NULL, 231530),
(246943, '3p2oA01', NULL, NULL, 132, NULL, NULL, 231530),
(246944, '3krtA02', NULL, NULL, 147, NULL, NULL, 231530),
(246945, '4yrbC00', NULL, NULL, 329, NULL, NULL, 231530),
(246946, '3hnpA01', NULL, NULL, 122, NULL, NULL, 231530),
(246947, '2et6A01', NULL, NULL, 292, NULL, NULL, 231530),
(246948, '1ys4A01', NULL, NULL, 178, NULL, NULL, 231530),
(246949, '2gdzA00', NULL, NULL, 267, NULL, NULL, 231530),
(246950, '2et6A02', NULL, NULL, 304, NULL, NULL, 231530),
(246951, '3k5pA02', NULL, NULL, 189, NULL, NULL, 231530),
(246952, '4bmnD00', NULL, NULL, 253, NULL, NULL, 231530),
(246953, '3rc1A01', NULL, NULL, 126, NULL, NULL, 231530),
(246954, '3gazA02', NULL, NULL, 168, NULL, NULL, 231530),
(246955, '1yl5A01', NULL, NULL, 140, NULL, NULL, 231530),
(246956, '3pymA01', NULL, NULL, 166, NULL, NULL, 231530),
(246957, '2v6bB01', NULL, NULL, 139, NULL, NULL, 231530),
(246958, '4j2oD01', NULL, NULL, 236, NULL, NULL, 231530),
(246959, '1bgvA01', NULL, NULL, 167, NULL, NULL, 231530),
(246960, '3e18A01', NULL, NULL, 138, NULL, NULL, 231530),
(246961, '5y1fA00', NULL, NULL, 311, NULL, NULL, 231530),
(246962, '4kzpB00', NULL, NULL, 300, NULL, NULL, 231530),
(246963, '1u8xX01', NULL, NULL, 166, NULL, NULL, 231530),
(246964, '5b6kA00', NULL, NULL, 346, NULL, NULL, 231530),
(246965, '4pltA01', NULL, NULL, 151, NULL, NULL, 231530),
(246966, '2a35A00', NULL, NULL, 215, NULL, NULL, 231530),
(246967, '3kvoA00', NULL, NULL, 275, NULL, NULL, 231530),
(246968, '3sc4A00', NULL, NULL, 285, NULL, NULL, 231530),
(246969, '5fydB00', NULL, NULL, 263, NULL, NULL, 231530),
(246970, '1yqgA01', NULL, NULL, 150, NULL, NULL, 231530),
(246971, '1a4iB01', NULL, NULL, 138, NULL, NULL, 231530),
(246972, '4a7pA03', NULL, NULL, 206, NULL, NULL, 231530),
(246973, '3k5pA01', NULL, NULL, 142, NULL, NULL, 231530),
(246974, '4cr6A00', NULL, NULL, 271, NULL, NULL, 231530),
(246975, '1gtmA02', NULL, NULL, 238, NULL, NULL, 231530),
(246976, '4p22A01', NULL, NULL, 232, NULL, NULL, 231530),
(246977, '3iusB00', NULL, NULL, 286, NULL, NULL, 231530),
(246978, '2pd4A00', NULL, NULL, 275, NULL, NULL, 231530),
(246979, '1u8fO01', NULL, NULL, 168, NULL, NULL, 231530),
(246980, '4hv4A01', NULL, NULL, 88, NULL, NULL, 231530),
(246981, '1u3wA02', NULL, NULL, 139, NULL, NULL, 231530),
(246982, '2p4hX00', NULL, NULL, 322, NULL, NULL, 231530),
(246983, '1v9lA02', NULL, NULL, 242, NULL, NULL, 231530),
(246984, '4g2nA01', NULL, NULL, 129, NULL, NULL, 231530),
(246985, '4xb1A01', NULL, NULL, 185, NULL, NULL, 231530),
(246986, '3ai3A00', NULL, NULL, 263, NULL, NULL, 231530),
(246987, '3oecB00', NULL, NULL, 276, NULL, NULL, 231530),
(246988, '5xtfA00', NULL, NULL, 257, NULL, NULL, 231530),
(246989, '4g2nA02', NULL, NULL, 182, NULL, NULL, 231530),
(246990, '2x0jA01', NULL, NULL, 142, NULL, NULL, 231530),
(246991, '1bg6A01', NULL, NULL, 195, NULL, NULL, 231530),
(246992, '4zqbB01', NULL, NULL, 133, NULL, NULL, 231530),
(246993, '3c24A01', NULL, NULL, 182, NULL, NULL, 231530),
(246994, '1wzeA01', NULL, NULL, 153, NULL, NULL, 231530),
(246995, '4bucA01', NULL, NULL, 109, NULL, NULL, 231530),
(246996, '3wfjH01', NULL, NULL, 142, NULL, NULL, 231530),
(246997, '3wohA00', NULL, NULL, 251, NULL, NULL, 231530),
(246998, '3mz0A01', NULL, NULL, 221, NULL, NULL, 231530),
(246999, '3dmyA01', NULL, NULL, 149, NULL, NULL, 231530),
(247000, '3iccA00', NULL, NULL, 255, NULL, NULL, 231530),
(247001, '4oqyA01', NULL, NULL, 160, NULL, NULL, 231530),
(247002, '4oo3A01', NULL, NULL, 147, NULL, NULL, 231530),
(247003, '2jahA00', NULL, NULL, 247, NULL, NULL, 231530);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(247004, '3r1iB00', NULL, NULL, 255, NULL, NULL, 231530),
(247005, '2o3sA02', NULL, NULL, 128, NULL, NULL, 231530),
(247006, '6bacA01', NULL, NULL, 162, NULL, NULL, 231530),
(247007, '5n2iD00', NULL, NULL, 232, NULL, NULL, 231530),
(247008, '3ws7A01', NULL, NULL, 182, NULL, NULL, 231530),
(247009, '5ayvA01', NULL, NULL, 171, NULL, NULL, 231530),
(247010, '2h6eA02', NULL, NULL, 143, NULL, NULL, 231530),
(247011, '2c07A00', NULL, NULL, 251, NULL, NULL, 231530),
(247012, '4j9vA03', NULL, NULL, 134, NULL, NULL, 231530),
(247013, '3ay7B00', NULL, NULL, 269, NULL, NULL, 231530),
(247014, '4j9vA01', NULL, NULL, 139, NULL, NULL, 231530),
(247015, '3wtcA00', NULL, NULL, 262, NULL, NULL, 231530),
(247016, '1lldA01', NULL, NULL, 149, NULL, NULL, 231530),
(247017, '4fdaA00', NULL, NULL, 273, NULL, NULL, 231530),
(247018, '5u8pA00', NULL, NULL, 292, NULL, NULL, 231530),
(247019, '4q3nA01', NULL, NULL, 145, NULL, NULL, 231530),
(247020, '3abiA01', NULL, NULL, 188, NULL, NULL, 231530),
(247021, '5yabA01', NULL, NULL, 131, NULL, NULL, 231530),
(247022, '3lz6A00', NULL, NULL, 263, NULL, NULL, 231530),
(247023, '5br7A01', NULL, NULL, 216, NULL, NULL, 231530),
(247024, '3ksuB00', NULL, NULL, 262, NULL, NULL, 231530),
(247025, '3ktdC01', NULL, NULL, 207, NULL, NULL, 231530),
(247026, '5h83A02', NULL, NULL, 157, NULL, NULL, 231530),
(247027, '1xkqB00', NULL, NULL, 280, NULL, NULL, 231530),
(247028, '3vpgA01', NULL, NULL, 141, NULL, NULL, 231530),
(247029, '3qljF00', NULL, NULL, 300, NULL, NULL, 231530),
(247030, '5msoA00', NULL, NULL, 443, NULL, NULL, 231530),
(247031, '1ps9A02', NULL, NULL, 145, NULL, NULL, 231530),
(247032, '6oz7B00', NULL, NULL, 254, NULL, NULL, 231530),
(247033, '6ct6B01', NULL, NULL, 156, NULL, NULL, 231530),
(247034, '3rfxA01', NULL, NULL, 228, NULL, NULL, 231530),
(247035, '2q1wC00', NULL, NULL, 314, NULL, NULL, 231530),
(247036, '1dssG01', NULL, NULL, 166, NULL, NULL, 231530),
(247037, '5gudE02', NULL, NULL, 221, NULL, NULL, 231530),
(247038, '2pv7A01', NULL, NULL, 171, NULL, NULL, 231530),
(247039, '4gqaD01', NULL, NULL, 135, NULL, NULL, 231530),
(247040, '4xa8A02', NULL, NULL, 183, NULL, NULL, 231530),
(247041, '5t8kA02', NULL, NULL, 162, NULL, NULL, 231530),
(247042, '5tt0B00', NULL, NULL, 263, NULL, NULL, 231530),
(247043, '5yeqA01', NULL, NULL, 182, NULL, NULL, 231530),
(247044, '3gg9A02', NULL, NULL, 198, NULL, NULL, 231530),
(247045, '4w6zA02', NULL, NULL, 142, NULL, NULL, 231530),
(247046, '3rihC00', NULL, NULL, 259, NULL, NULL, 231530),
(247047, '3gg9A01', NULL, NULL, 154, NULL, NULL, 231530),
(247048, '4ilkA02', NULL, NULL, 134, NULL, NULL, 231530),
(247049, '4xa8A01', NULL, NULL, 137, NULL, NULL, 231530),
(247050, '2f1kA01', NULL, NULL, 165, NULL, NULL, 231530),
(247051, '1j5pA01', NULL, NULL, 130, NULL, NULL, 231530),
(247052, '5nc8A00', NULL, NULL, 163, NULL, NULL, 231530),
(247053, '1pzgA01', NULL, NULL, 155, NULL, NULL, 231530),
(247054, '1hdoA00', NULL, NULL, 206, NULL, NULL, 231530),
(247055, '1a7aA02', NULL, NULL, 160, NULL, NULL, 231530),
(247056, '2r6jA01', NULL, NULL, 190, NULL, NULL, 231530),
(247057, '2czcA01', NULL, NULL, 172, NULL, NULL, 231530),
(247058, '3d4oB01', NULL, NULL, 146, NULL, NULL, 231530),
(247059, '4e21A01', NULL, NULL, 201, NULL, NULL, 231530),
(247060, '4nbvA00', NULL, NULL, 246, NULL, NULL, 231530),
(247061, '4fflA01', NULL, NULL, 94, NULL, NULL, 231530),
(247062, '5bseA01', NULL, NULL, 178, NULL, NULL, 231530),
(247063, '3hjaA01', NULL, NULL, 168, NULL, NULL, 231530),
(247064, '3ghyA01', NULL, NULL, 197, NULL, NULL, 231530),
(247065, '3qe3A02', NULL, NULL, 139, NULL, NULL, 231530),
(247066, '4jigA00', NULL, NULL, 261, NULL, NULL, 231530),
(247067, '6eowA02', NULL, NULL, 177, NULL, NULL, 231530),
(247068, '1xhlA00', NULL, NULL, 275, NULL, NULL, 231530),
(247069, '2g76A01', NULL, NULL, 120, NULL, NULL, 231530),
(247070, '3e9nA00', NULL, NULL, 245, NULL, NULL, 231530),
(247071, '4rqtA02', NULL, NULL, 139, NULL, NULL, 231530),
(247072, '2belB00', NULL, NULL, 260, NULL, NULL, 231530),
(247073, '2eihA02', NULL, NULL, 143, NULL, NULL, 231530),
(247074, '5bntB01', NULL, NULL, 161, NULL, NULL, 231530);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(247075, '9ldtA01', NULL, NULL, 162, NULL, NULL, 231530),
(247076, '3wgqB01', NULL, NULL, 172, NULL, NULL, 231530),
(247077, '1dihA01', NULL, NULL, 165, NULL, NULL, 231530),
(247078, '5hs4A01', NULL, NULL, 146, NULL, NULL, 231530),
(247079, '2yutA00', NULL, NULL, 207, NULL, NULL, 231530),
(247080, '2dc1A01', NULL, NULL, 135, NULL, NULL, 231530),
(247081, '2cdcA02', NULL, NULL, 190, NULL, NULL, 231530),
(247082, '3tpcB00', NULL, NULL, 257, NULL, NULL, 231530),
(247083, '5ycxA00', NULL, NULL, 266, NULL, NULL, 231530),
(247084, '4z9fA00', NULL, NULL, 244, NULL, NULL, 231530),
(247085, '4u5qB00', NULL, NULL, 437, NULL, NULL, 231530),
(247086, '3adoA01', NULL, NULL, 192, NULL, NULL, 231530),
(247087, '2o3jA03', NULL, NULL, 230, NULL, NULL, 231530),
(247088, '3osuB00', NULL, NULL, 246, NULL, NULL, 231530),
(247089, '1vc2A01', NULL, NULL, 167, NULL, NULL, 231530),
(247090, '2ggsA01', NULL, NULL, 205, NULL, NULL, 231530),
(247091, '3s55E00', NULL, NULL, 281, NULL, NULL, 231530),
(247092, '1guzA01', NULL, NULL, 143, NULL, NULL, 231530),
(247093, '1wvgA01', NULL, NULL, 193, NULL, NULL, 231530),
(247094, '1tltA01', NULL, NULL, 122, NULL, NULL, 231530),
(247095, '1k2wA00', NULL, NULL, 256, NULL, NULL, 231530),
(247096, '5nqbA01', NULL, NULL, 162, NULL, NULL, 231530),
(247097, '4d3sA01', NULL, NULL, 164, NULL, NULL, 231530),
(247098, '5tqmA00', NULL, NULL, 315, NULL, NULL, 231530),
(247099, '6d9yA00', NULL, NULL, 258, NULL, NULL, 231530),
(247100, '1yrlB01', NULL, NULL, 153, NULL, NULL, 231530),
(247101, '2obnD01', NULL, NULL, 135, NULL, NULL, 231530),
(247102, '3cinA01', NULL, NULL, 290, NULL, NULL, 231530),
(247103, '6c49A02', NULL, NULL, 155, NULL, NULL, 231530),
(247104, '1zud100', NULL, NULL, 251, NULL, NULL, 231530),
(247105, '3gemD00', NULL, NULL, 234, NULL, NULL, 231530),
(247106, '1np3B01', NULL, NULL, 182, NULL, NULL, 231530),
(247107, '5gz3A01', NULL, NULL, 172, NULL, NULL, 231530),
(247108, '3hskA01', NULL, NULL, 177, NULL, NULL, 231530),
(247109, '3h8vB00', NULL, NULL, 260, NULL, NULL, 231530),
(247110, '3slgF01', NULL, NULL, 235, NULL, NULL, 231530),
(247111, '3aogA03', NULL, NULL, 155, NULL, NULL, 231530),
(247112, '3ijpB01', NULL, NULL, 160, NULL, NULL, 231530),
(247113, '3o4rD00', NULL, NULL, 261, NULL, NULL, 231530),
(247114, '3vvbA00', NULL, NULL, 341, NULL, NULL, 231530),
(247115, '1lj8A01', NULL, NULL, 285, NULL, NULL, 231530),
(247116, '1ae1A00', NULL, NULL, 273, NULL, NULL, 231530),
(247117, '5vmlA00', NULL, NULL, 245, NULL, NULL, 231530),
(247118, '2o23A00', NULL, NULL, 265, NULL, NULL, 231530),
(247119, '2i5pO01', NULL, NULL, 177, NULL, NULL, 231530),
(247120, '5dp2A02', NULL, NULL, 141, NULL, NULL, 231530),
(247121, '2y0eB01', NULL, NULL, 214, NULL, NULL, 231530),
(247122, '3mtjA01', NULL, NULL, 183, NULL, NULL, 231530),
(247123, '1pl8A02', NULL, NULL, 139, NULL, NULL, 231530),
(247124, '2g6tA01', NULL, NULL, 99, NULL, NULL, 231530),
(247125, '4xiyA01', NULL, NULL, 181, NULL, NULL, 231530),
(247126, '4impD00', NULL, NULL, 517, NULL, NULL, 231530),
(247127, '2d59A00', NULL, NULL, 144, NULL, NULL, 231530),
(247128, '1ooeA00', NULL, NULL, 236, NULL, NULL, 231530),
(247129, '2y0eB03', NULL, NULL, 232, NULL, NULL, 231530),
(247130, '3oh8A02', NULL, NULL, 289, NULL, NULL, 231530),
(247131, '3jynA02', NULL, NULL, 146, NULL, NULL, 231530),
(247132, '5uzhA01', NULL, NULL, 240, NULL, NULL, 231530),
(247133, '6dhqA03', NULL, NULL, 295, NULL, NULL, 231530),
(247134, '2a4kB01', NULL, NULL, 236, NULL, NULL, 231530),
(247135, '4xgnE00', NULL, NULL, 260, NULL, NULL, 231530),
(247136, '3hn7A01', NULL, NULL, 109, NULL, NULL, 231530),
(247137, '2hjsA01', NULL, NULL, 156, NULL, NULL, 231530),
(247138, '4zgwB00', NULL, NULL, 245, NULL, NULL, 231530),
(247139, '2nqtA01', NULL, NULL, 174, NULL, NULL, 231530),
(247140, '6g2uA03', NULL, NULL, 296, NULL, NULL, 231530),
(247141, '3k92A03', NULL, NULL, 154, NULL, NULL, 231530),
(247142, '1p1hB02', NULL, NULL, 225, NULL, NULL, 231530),
(247143, '3iupA02', NULL, NULL, 188, NULL, NULL, 231530),
(247144, '3wgtA01', NULL, NULL, 198, NULL, NULL, 231530),
(247145, '1obfO01', NULL, NULL, 170, NULL, NULL, 231530);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(247146, '3qvsA01', NULL, NULL, 291, NULL, NULL, 231530),
(247147, '2vynD01', NULL, NULL, 167, NULL, NULL, 231530),
(247148, '4bgvA01', NULL, NULL, 149, NULL, NULL, 231530),
(247149, '3ucxA00', NULL, NULL, 264, NULL, NULL, 231530),
(247150, '4l4xA00', NULL, NULL, 518, NULL, NULL, 231530),
(247151, '1dpgA01', NULL, NULL, 175, NULL, NULL, 231530),
(247152, '4mp8A02', NULL, NULL, 173, NULL, NULL, 231530),
(247153, '1xa0B02', NULL, NULL, 164, NULL, NULL, 231530),
(247154, '3svtA00', NULL, NULL, 281, NULL, NULL, 231530),
(247155, '6eoiB01', NULL, NULL, 165, NULL, NULL, 231530),
(247156, '4ew6A01', NULL, NULL, 120, NULL, NULL, 231530),
(247157, '3wr5C01', NULL, NULL, 190, NULL, NULL, 231530),
(247158, '5tx7A02', NULL, NULL, 190, NULL, NULL, 231530),
(247159, '5tx7A01', NULL, NULL, 137, NULL, NULL, 231530),
(247160, '6melA01', NULL, NULL, 123, NULL, NULL, 231530),
(247161, '3rwbA00', NULL, NULL, 247, NULL, NULL, 231530),
(247162, '5itwA00', NULL, NULL, 255, NULL, NULL, 231530),
(247163, '4alkB00', NULL, NULL, 255, NULL, NULL, 231530),
(247164, '3zgyD01', NULL, NULL, 178, NULL, NULL, 231530),
(247165, '5yatA02', NULL, NULL, 142, NULL, NULL, 231530),
(247166, '1i24A01', NULL, NULL, 246, NULL, NULL, 231530),
(247167, '5uscB01', NULL, NULL, 172, NULL, NULL, 231530),
(247168, '2g17A01', NULL, NULL, 177, NULL, NULL, 231530),
(247169, '1i36A01', NULL, NULL, 159, NULL, NULL, 231530),
(247170, '1yb4A01', NULL, NULL, 161, NULL, NULL, 231530),
(247171, '4oh1A02', NULL, NULL, 136, NULL, NULL, 231530),
(247172, '4ni5A00', NULL, NULL, 254, NULL, NULL, 231530),
(247173, '1j4aD01', NULL, NULL, 136, NULL, NULL, 231530),
(247174, '6fqzA01', NULL, NULL, 179, NULL, NULL, 231530),
(247175, '3r3sA00', NULL, NULL, 294, NULL, NULL, 231530),
(247176, '4iboB00', NULL, NULL, 253, NULL, NULL, 231530),
(247177, '3h2zA01', NULL, NULL, 205, NULL, NULL, 231530),
(247178, '1b7gO01', NULL, NULL, 156, NULL, NULL, 231530),
(247179, '1xeaA01', NULL, NULL, 120, NULL, NULL, 231530),
(247180, '5idqB00', NULL, NULL, 233, NULL, NULL, 231530),
(247181, '5if3B00', NULL, NULL, 230, NULL, NULL, 231530),
(247182, '3imfC00', NULL, NULL, 257, NULL, NULL, 231530),
(247183, '6f9qA00', NULL, NULL, 272, NULL, NULL, 231530),
(247184, '5uaxA01', NULL, NULL, 192, NULL, NULL, 231530),
(247185, '1e6uA01', NULL, NULL, 220, NULL, NULL, 231530),
(247186, '1y8qB01', NULL, NULL, 227, NULL, NULL, 231530),
(247187, '4fgsB00', NULL, NULL, 250, NULL, NULL, 231530),
(247188, '3lylD00', NULL, NULL, 247, NULL, NULL, 231530),
(247189, '5jy6B01', NULL, NULL, 169, NULL, NULL, 231530),
(247190, '2vz8A06', NULL, NULL, 347, NULL, NULL, 231530),
(247191, '2x4gA00', NULL, NULL, 342, NULL, NULL, 231530),
(247192, '1v6aA01', NULL, NULL, 148, NULL, NULL, 231530),
(247193, '3d3wA00', NULL, NULL, 244, NULL, NULL, 231530),
(247194, '3ohsX01', NULL, NULL, 122, NULL, NULL, 231530),
(247195, '3l9wA01', NULL, NULL, 166, NULL, NULL, 231530),
(247196, '1c0pA01', NULL, NULL, 199, NULL, NULL, 231530),
(247197, '1uzmB00', NULL, NULL, 247, NULL, NULL, 231530),
(247198, '5jazA01', NULL, NULL, 165, NULL, NULL, 231530),
(247199, '1o89A02', NULL, NULL, 167, NULL, NULL, 231530),
(247200, '4jgbB00', NULL, NULL, 213, NULL, NULL, 231530),
(247201, '5g6rA01', NULL, NULL, 159, NULL, NULL, 231530),
(247202, '1rjwA02', NULL, NULL, 137, NULL, NULL, 231530),
(247203, '3pk0D00', NULL, NULL, 262, NULL, NULL, 231530),
(247204, '3eagA01', NULL, NULL, 95, NULL, NULL, 231530),
(247205, '2w2kA01', NULL, NULL, 152, NULL, NULL, 231530),
(247206, '2w2kA02', NULL, NULL, 196, NULL, NULL, 231530),
(247207, '5k0zA01', NULL, NULL, 146, NULL, NULL, 231530),
(247208, '3wswA01', NULL, NULL, 147, NULL, NULL, 231530),
(247209, '2gsdA02', NULL, NULL, 192, NULL, NULL, 231530),
(247210, '5ldgA00', NULL, NULL, 316, NULL, NULL, 231530),
(247211, '2gsdA01', NULL, NULL, 210, NULL, NULL, 231530),
(247212, '3g1uA02', NULL, NULL, 160, NULL, NULL, 231530),
(247213, '1f8fA02', NULL, NULL, 137, NULL, NULL, 231530),
(247214, '3l07B01', NULL, NULL, 131, NULL, NULL, 231530),
(247215, '4zicB01', NULL, NULL, 172, NULL, NULL, 231530),
(247216, '6duxA01', NULL, NULL, 169, NULL, NULL, 231530);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(247217, '3aoeC03', NULL, NULL, 151, NULL, NULL, 231530),
(247218, '2c20A01', NULL, NULL, 204, NULL, NULL, 231530),
(247219, '6apeA01', NULL, NULL, 142, NULL, NULL, 231530),
(247220, '1vl6B02', NULL, NULL, 223, NULL, NULL, 231530),
(247221, '5zz5B02', NULL, NULL, 133, NULL, NULL, 231530),
(247222, '5gudA03', NULL, NULL, 163, NULL, NULL, 231530),
(247223, '5f1pA00', NULL, NULL, 265, NULL, NULL, 231530),
(247224, '6a3fA01', NULL, NULL, 135, NULL, NULL, 231530),
(247225, '3tzqB01', NULL, NULL, 249, NULL, NULL, 231530),
(247226, '4dl9A02', NULL, NULL, 139, NULL, NULL, 231530),
(247227, '3f4bC00', NULL, NULL, 323, NULL, NULL, 231530),
(247228, '3rkuA00', NULL, NULL, 268, NULL, NULL, 231530),
(247229, '2a9fB02', NULL, NULL, 237, NULL, NULL, 231530),
(247230, '5tnxA02', NULL, NULL, 137, NULL, NULL, 231530),
(247231, '3i3oG00', NULL, NULL, 262, NULL, NULL, 231530),
(247232, '3m1aJ00', NULL, NULL, 281, NULL, NULL, 231530),
(247233, '3omlA01', NULL, NULL, 262, NULL, NULL, 231530),
(247234, '6jnjB01', NULL, NULL, 119, NULL, NULL, 231530),
(247235, '4hfmA02', NULL, NULL, 177, NULL, NULL, 231530),
(247236, '2wyuD00', NULL, NULL, 261, NULL, NULL, 231530),
(247237, '4d79A00', NULL, NULL, 276, NULL, NULL, 231530),
(247238, '3gqvA02', NULL, NULL, 193, NULL, NULL, 231530),
(247239, '2c0cA02', NULL, NULL, 179, NULL, NULL, 231530),
(247240, '4cujA02', NULL, NULL, 196, NULL, NULL, 231530),
(247241, '3r3jA02', NULL, NULL, 224, NULL, NULL, 231530),
(247242, '4cujA01', NULL, NULL, 141, NULL, NULL, 231530),
(247243, '3gvhA01', NULL, NULL, 149, NULL, NULL, 231530),
(247244, '4dgsA02', NULL, NULL, 185, NULL, NULL, 231530),
(247245, '4dgsA01', NULL, NULL, 123, NULL, NULL, 231530),
(247246, '3t7cD00', NULL, NULL, 277, NULL, NULL, 231530),
(247247, '3pvzB00', NULL, NULL, 326, NULL, NULL, 231530),
(247248, '3wr5A02', NULL, NULL, 190, NULL, NULL, 231530),
(247249, '1uufA02', NULL, NULL, 156, NULL, NULL, 231530),
(247250, '6om4B02', NULL, NULL, 258, NULL, NULL, 231530),
(247251, '5ig2A00', NULL, NULL, 297, NULL, NULL, 231530),
(247252, '4f6cB00', NULL, NULL, 391, NULL, NULL, 231530),
(247253, '2v65A01', NULL, NULL, 147, NULL, NULL, 231530),
(247254, '4e2xA04', NULL, NULL, 99, NULL, NULL, 231530),
(247255, '3v1yB01', NULL, NULL, 171, NULL, NULL, 231530),
(247256, '3asuB01', NULL, NULL, 235, NULL, NULL, 231530),
(247257, '5ktkA00', NULL, NULL, 473, NULL, NULL, 231530),
(247258, '1pquA01', NULL, NULL, 153, NULL, NULL, 231530),
(247259, '3ip3A01', NULL, NULL, 125, NULL, NULL, 231530),
(247260, '4ezbA01', NULL, NULL, 195, NULL, NULL, 231530),
(247261, '3h7aA00', NULL, NULL, 252, NULL, NULL, 231530),
(247262, '2ehdA00', NULL, NULL, 234, NULL, NULL, 231530),
(247263, '4fb5A01', NULL, NULL, 127, NULL, NULL, 231530),
(247264, '2f00A01', NULL, NULL, 88, NULL, NULL, 231530),
(247265, '5ovkC00', NULL, NULL, 256, NULL, NULL, 231530),
(247266, '4iuyA00', NULL, NULL, 254, NULL, NULL, 231530),
(247267, '5iz4A00', NULL, NULL, 271, NULL, NULL, 231530),
(247268, '1p1jB01', NULL, NULL, 418, NULL, NULL, 231530),
(247269, '3evtA02', NULL, NULL, 182, NULL, NULL, 231530),
(247270, '1zsyA02', NULL, NULL, 177, NULL, NULL, 231530),
(247271, '3evtA01', NULL, NULL, 134, NULL, NULL, 231530),
(247272, '6dzsA01', NULL, NULL, 174, NULL, NULL, 231530),
(247273, '6abjB01', NULL, NULL, 132, NULL, NULL, 231530),
(247274, '4ycaB01', NULL, NULL, 160, NULL, NULL, 231530),
(247275, '3ceaA01', NULL, NULL, 153, NULL, NULL, 231530),
(247276, '1uayB00', NULL, NULL, 242, NULL, NULL, 231530),
(247277, '2cfcA00', NULL, NULL, 250, NULL, NULL, 231530),
(247278, '1nhwA00', NULL, NULL, 229, NULL, NULL, 231530),
(247279, '2dq4A02', NULL, NULL, 134, NULL, NULL, 231530),
(247280, '3oa2A01', NULL, NULL, 133, NULL, NULL, 231530),
(247281, '4omuA02', NULL, NULL, 145, NULL, NULL, 231530),
(247282, '1qycA01', NULL, NULL, 188, NULL, NULL, 231530),
(247283, '5dcyB00', NULL, NULL, 368, NULL, NULL, 231530),
(247284, '3mwdB01', NULL, NULL, 138, NULL, NULL, 231530),
(247285, '1gy8D02', NULL, NULL, 241, NULL, NULL, 231530),
(247286, '1gdhA02', NULL, NULL, 184, NULL, NULL, 231530),
(247287, '1gdhA01', NULL, NULL, 128, NULL, NULL, 231530);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(247288, '3lt0A00', NULL, NULL, 287, NULL, NULL, 231530),
(247289, '2vt3B02', NULL, NULL, 133, NULL, NULL, 231530),
(247290, '4xr9B01', NULL, NULL, 212, NULL, NULL, 231530),
(247291, '1qp8A02', NULL, NULL, 181, NULL, NULL, 231530),
(247292, '4xr9B02', NULL, NULL, 211, NULL, NULL, 231530),
(247293, '1vm6B01', NULL, NULL, 145, NULL, NULL, 231530),
(247294, '1qp8A01', NULL, NULL, 122, NULL, NULL, 231530),
(247295, '4s1vA02', NULL, NULL, 191, NULL, NULL, 231530),
(247296, '2d5cA02', NULL, NULL, 136, NULL, NULL, 231530),
(247297, '6gpkC01', NULL, NULL, 241, NULL, NULL, 231530),
(247298, '3tfoB00', NULL, NULL, 239, NULL, NULL, 231530),
(247299, '3gpdG01', NULL, NULL, 170, NULL, NULL, 231530),
(247300, '4z0tA00', NULL, NULL, 254, NULL, NULL, 231530),
(247301, '3kuxA01', NULL, NULL, 148, NULL, NULL, 231530),
(247302, '6abiA01', NULL, NULL, 136, NULL, NULL, 231530),
(247303, '6abiA02', NULL, NULL, 197, NULL, NULL, 231530),
(247304, '2dtxA00', NULL, NULL, 264, NULL, NULL, 231530),
(247305, '5b37B02', NULL, NULL, 201, NULL, NULL, 231530),
(247306, '4u8gA00', NULL, NULL, 278, NULL, NULL, 231530),
(247307, '1smkA01', NULL, NULL, 153, NULL, NULL, 231530),
(247308, '6balF01', NULL, NULL, 149, NULL, NULL, 231530),
(247309, '6bdxA01', NULL, NULL, 162, NULL, NULL, 231530),
(247310, '2ntvA00', NULL, NULL, 268, NULL, NULL, 231530),
(247311, '4w9nC02', NULL, NULL, 174, NULL, NULL, 231530),
(247312, '1wmaA00', NULL, NULL, 276, NULL, NULL, 231530),
(247313, '1yovC01', NULL, NULL, 328, NULL, NULL, 231530),
(247314, '5eesA01', NULL, NULL, 138, NULL, NULL, 231530),
(247315, '3cosA02', NULL, NULL, 139, NULL, NULL, 231530),
(247316, '5einA01', NULL, NULL, 164, NULL, NULL, 231530),
(247317, '1cjcA01', NULL, NULL, 219, NULL, NULL, 231530),
(247318, '3ojoB02', NULL, NULL, 191, NULL, NULL, 231530),
(247319, '1kyqB01', NULL, NULL, 150, NULL, NULL, 231530),
(247320, '3ftpD00', NULL, NULL, 248, NULL, NULL, 231530),
(247321, '2zcuA01', NULL, NULL, 168, NULL, NULL, 231530),
(247322, '3uogA02', NULL, NULL, 142, NULL, NULL, 231530),
(247323, '1gegA00', NULL, NULL, 256, NULL, NULL, 231530),
(247324, '3do5A01', NULL, NULL, 182, NULL, NULL, 231530),
(247325, '5jlaA00', NULL, NULL, 274, NULL, NULL, 231530),
(247326, '3i1jB00', NULL, NULL, 247, NULL, NULL, 231530),
(247327, '2ep5A01', NULL, NULL, 173, NULL, NULL, 231530),
(247328, '3wnvA02', NULL, NULL, 185, NULL, NULL, 231530),
(247329, '3wnvA01', NULL, NULL, 145, NULL, NULL, 231530),
(247330, '4rzhA00', NULL, NULL, 247, NULL, NULL, 231530),
(247331, '4lsmA01', NULL, NULL, 180, NULL, NULL, 231530),
(247332, '4g81A00', NULL, NULL, 255, NULL, NULL, 231530),
(247333, '4j1qA00', NULL, NULL, 426, NULL, NULL, 231530),
(247334, '3d0oA01', NULL, NULL, 148, NULL, NULL, 231530),
(247335, '3grpD00', NULL, NULL, 246, NULL, NULL, 231530),
(247336, '3c7aA01', NULL, NULL, 206, NULL, NULL, 231530),
(247337, '3triA01', NULL, NULL, 170, NULL, NULL, 231530),
(247338, '4idcA02', NULL, NULL, 115, NULL, NULL, 231530),
(247339, '2dphA02', NULL, NULL, 166, NULL, NULL, 231530),
(247340, '6nrpC00', NULL, NULL, 240, NULL, NULL, 231530),
(247341, '1nvtA02', NULL, NULL, 142, NULL, NULL, 231530),
(247342, '1cdoA02', NULL, NULL, 138, NULL, NULL, 231530),
(247343, '4s1vB01', NULL, NULL, 124, NULL, NULL, 231530),
(247344, '3pvzD01', NULL, NULL, 319, NULL, NULL, 231530),
(247345, '4yacA01', NULL, NULL, 254, NULL, NULL, 231530),
(247346, '3fbtA02', NULL, NULL, 132, NULL, NULL, 231530),
(247347, '4n5mA00', NULL, NULL, 246, NULL, NULL, 231530),
(247348, '4bkoA00', NULL, NULL, 417, NULL, NULL, 231530),
(247349, '2g0tB01', NULL, NULL, 157, NULL, NULL, 231530),
(247350, '4o5oA00', NULL, NULL, 263, NULL, NULL, 231530),
(247351, '4gx0A02', NULL, NULL, 142, NULL, NULL, 231530),
(247352, '4oaqA02', NULL, NULL, 141, NULL, NULL, 231530),
(247353, '4bs9A02', NULL, NULL, 228, NULL, NULL, 231530),
(247354, '4j2hA00', NULL, NULL, 257, NULL, NULL, 231530),
(247355, '3vtfA02', NULL, NULL, 208, NULL, NULL, 231530),
(247356, '1pj3A02', NULL, NULL, 307, NULL, NULL, 231530),
(247357, '3vtfA01', NULL, NULL, 215, NULL, NULL, 231530),
(247358, '3u5tC00', NULL, NULL, 239, NULL, NULL, 231530);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(247359, '1zmtA00', NULL, NULL, 254, NULL, NULL, 231530),
(247360, '4okiA00', NULL, NULL, 182, NULL, NULL, 231530),
(247361, '3wdsA00', NULL, NULL, 263, NULL, NULL, 231530),
(247362, '4xdyA01', NULL, NULL, 186, NULL, NULL, 231530),
(247363, '4imrB00', NULL, NULL, 253, NULL, NULL, 231530),
(247364, '4xymA01', NULL, NULL, 129, NULL, NULL, 231530),
(247365, '3cmcO01', NULL, NULL, 169, NULL, NULL, 231530),
(247366, '1orrC00', NULL, NULL, 347, NULL, NULL, 231530),
(247367, '6d4bA02', NULL, NULL, 197, NULL, NULL, 231530),
(247368, '6d4bA01', NULL, NULL, 167, NULL, NULL, 231530),
(247369, '2fmuA00', NULL, NULL, 248, NULL, NULL, 231530),
(247370, '4z0hR01', NULL, NULL, 168, NULL, NULL, 231530),
(247371, '4dllA01', NULL, NULL, 160, NULL, NULL, 231530),
(247372, '1g0oA00', NULL, NULL, 283, NULL, NULL, 231530),
(247373, '3ba1A02', NULL, NULL, 184, NULL, NULL, 231530),
(247374, '3sx2H00', NULL, NULL, 278, NULL, NULL, 231530),
(247375, '5wqoB00', NULL, NULL, 234, NULL, NULL, 231530),
(247376, '4zd6C00', NULL, NULL, 227, NULL, NULL, 231530),
(247377, '3ba1A01', NULL, NULL, 128, NULL, NULL, 231530),
(247378, '3i83A01', NULL, NULL, 179, NULL, NULL, 231530),
(247379, '2zb3A02', NULL, NULL, 181, NULL, NULL, 231530),
(247380, '4r01A00', NULL, NULL, 210, NULL, NULL, 231530),
(247381, '2g1uA00', NULL, NULL, 155, NULL, NULL, 231530),
(247382, '4rgbA00', NULL, NULL, 274, NULL, NULL, 231530),
(247383, '3ckyD01', NULL, NULL, 126, NULL, NULL, 231530),
(247384, '4id9A01', NULL, NULL, 211, NULL, NULL, 231530),
(247385, '5u2wB00', NULL, NULL, 254, NULL, NULL, 231530),
(247386, '1zejA01', NULL, NULL, 174, NULL, NULL, 231530),
(247387, '4xybA01', NULL, NULL, 185, NULL, NULL, 231530),
(247388, '5k9zA00', NULL, NULL, 285, NULL, NULL, 231530),
(247389, '4xybA02', NULL, NULL, 190, NULL, NULL, 231530),
(247390, '3mogC01', NULL, NULL, 190, NULL, NULL, 231530),
(247391, '3obbA01', NULL, NULL, 165, NULL, NULL, 231530),
(247392, '3is3A00', NULL, NULL, 270, NULL, NULL, 231530),
(247393, '5mdhA01', NULL, NULL, 153, NULL, NULL, 231530),
(247394, '3ip1A02', NULL, NULL, 150, NULL, NULL, 231530),
(247395, '2nwqA01', NULL, NULL, 238, NULL, NULL, 231530),
(247396, '3v2gA00', NULL, NULL, 252, NULL, NULL, 231530),
(247397, '4lmpA01', NULL, NULL, 195, NULL, NULL, 231530),
(247398, '1d7oA00', NULL, NULL, 297, NULL, NULL, 231530),
(247399, '4hy3B01', NULL, NULL, 151, NULL, NULL, 231530),
(247400, '3dttA00', NULL, NULL, 245, NULL, NULL, 231530),
(247401, '4lmpA02', NULL, NULL, 176, NULL, NULL, 231530),
(247402, '5zxuA02', NULL, NULL, 182, NULL, NULL, 231530),
(247403, '4za2C00', NULL, NULL, 253, NULL, NULL, 231530),
(247404, '1ff9A01', NULL, NULL, 172, NULL, NULL, 231530),
(247405, '2x5jQ01', NULL, NULL, 174, NULL, NULL, 231530),
(247406, '2aefA01', NULL, NULL, 124, NULL, NULL, 231530),
(247407, '3hdhA01', NULL, NULL, 207, NULL, NULL, 231530),
(247408, '2ixaA01', NULL, NULL, 169, NULL, NULL, 231530),
(247409, '4om8A01', NULL, NULL, 185, NULL, NULL, 231530),
(247410, '2g82A01', NULL, NULL, 167, NULL, NULL, 231530),
(247411, '5krvA01', NULL, NULL, 151, NULL, NULL, 231530),
(247412, '1ebfA01', NULL, NULL, 183, NULL, NULL, 231530),
(247413, '2uv8A04', NULL, NULL, 537, NULL, NULL, 231530),
(247414, '3oqbA01', NULL, NULL, 141, NULL, NULL, 231530),
(247415, '3dojA01', NULL, NULL, 167, NULL, NULL, 231530),
(247416, '6g4lA00', NULL, NULL, 270, NULL, NULL, 231530),
(247417, '4ln1B01', NULL, NULL, 169, NULL, NULL, 231530),
(247418, '1b0aA01', NULL, NULL, 131, NULL, NULL, 231530),
(247419, '1mldA01', NULL, NULL, 145, NULL, NULL, 231530),
(247420, '1gr0A01', NULL, NULL, 256, NULL, NULL, 231530),
(247421, '5jo9A00', NULL, NULL, 242, NULL, NULL, 231530),
(247422, '4o59O01', NULL, NULL, 165, NULL, NULL, 231530),
(247423, '2xoxA00', NULL, NULL, 288, NULL, NULL, 231530),
(247424, '2w90B01', NULL, NULL, 181, NULL, NULL, 231530),
(247425, '3pzrA01', NULL, NULL, 153, NULL, NULL, 231530),
(247426, '3q2kA01', NULL, NULL, 161, NULL, NULL, 231530),
(247427, '3l0dA01', NULL, NULL, 170, NULL, NULL, 231530),
(247428, '1y1pA01', NULL, NULL, 327, NULL, NULL, 231530),
(247429, '2x0nA01', NULL, NULL, 184, NULL, NULL, 231530);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(247430, '5cdyB00', NULL, NULL, 244, NULL, NULL, 231530),
(247431, '3i4fC00', NULL, NULL, 264, NULL, NULL, 231530),
(247432, '3on5B02', NULL, NULL, 162, NULL, NULL, 231530),
(247433, '3gpiA00', NULL, NULL, 286, NULL, NULL, 231530),
(247434, '3c85A00', NULL, NULL, 151, NULL, NULL, 231530),
(247435, '5epoA00', NULL, NULL, 262, NULL, NULL, 231530),
(247436, '2aw5A02', NULL, NULL, 297, NULL, NULL, 231530),
(247437, '2eerA02', NULL, NULL, 137, NULL, NULL, 231530),
(247438, '6ixjC00', NULL, NULL, 256, NULL, NULL, 231530),
(247439, '3twoA02', NULL, NULL, 153, NULL, NULL, 231530),
(247440, '2uvdA00', NULL, NULL, 246, NULL, NULL, 231530),
(247441, '1oaaA00', NULL, NULL, 259, NULL, NULL, 231530),
(247442, '4pcvB00', NULL, NULL, 240, NULL, NULL, 231530),
(247443, '1lssA00', NULL, NULL, 140, NULL, NULL, 231530),
(247444, '5y8lB01', NULL, NULL, 161, NULL, NULL, 231530),
(247445, '1jqbA02', NULL, NULL, 138, NULL, NULL, 231530),
(247446, '6ci8B00', NULL, NULL, 262, NULL, NULL, 231530),
(247447, '1sb8A01', NULL, NULL, 245, NULL, NULL, 231530),
(247448, '4m55F00', NULL, NULL, 273, NULL, NULL, 231530),
(247449, '3hg7A02', NULL, NULL, 185, NULL, NULL, 231530),
(247450, '2rirA02', NULL, NULL, 147, NULL, NULL, 231530),
(247451, '3hg7A01', NULL, NULL, 139, NULL, NULL, 231530),
(247452, '5ocmB01', NULL, NULL, 160, NULL, NULL, 231530),
(247453, '2g5cA01', NULL, NULL, 170, NULL, NULL, 231530),
(247454, '4wecC00', NULL, NULL, 253, NULL, NULL, 231530),
(247455, '3m6iA02', NULL, NULL, 141, NULL, NULL, 231530),
(247456, '1oc2A01', NULL, NULL, 251, NULL, NULL, 231530),
(247457, '3gdoA01', NULL, NULL, 137, NULL, NULL, 231530),
(247458, '3zv4A00', NULL, NULL, 281, NULL, NULL, 231530),
(247459, '1teaA01', NULL, NULL, 168, NULL, NULL, 231530),
(247460, '1xq6A00', NULL, NULL, 253, NULL, NULL, 231530),
(247461, '1tt7A02', NULL, NULL, 166, NULL, NULL, 231530),
(247462, '5koiC00', NULL, NULL, 271, NULL, NULL, 231530),
(247463, '3egoA01', NULL, NULL, 172, NULL, NULL, 231530),
(247464, '2cf5A02', NULL, NULL, 157, NULL, NULL, 231530),
(247465, '5kiaA02', NULL, NULL, 134, NULL, NULL, 231530),
(247466, '6mggA01', NULL, NULL, 123, NULL, NULL, 231530),
(247467, '3v2hB00', NULL, NULL, 281, NULL, NULL, 231530),
(247468, '4yt2A01', NULL, NULL, 207, NULL, NULL, 231530),
(247469, '4uulA01', NULL, NULL, 153, NULL, NULL, 231530),
(247470, '3l6eA00', NULL, NULL, 235, NULL, NULL, 231530),
(247471, '5ilgB00', NULL, NULL, 271, NULL, NULL, 231530),
(247472, '3u62A02', NULL, NULL, 128, NULL, NULL, 231530),
(247473, '2nu8A01', NULL, NULL, 122, NULL, NULL, 231530),
(247474, '2we8A02', NULL, NULL, 155, NULL, NULL, 231530),
(247475, '4yqzB00', NULL, NULL, 233, NULL, NULL, 231530),
(247476, '4xgiA03', NULL, NULL, 155, NULL, NULL, 231530),
(247477, '3idsA01', NULL, NULL, 183, NULL, NULL, 231530),
(247478, '2csuA01', NULL, NULL, 128, NULL, NULL, 231530),
(247479, '2p91C00', NULL, NULL, 268, NULL, NULL, 231530),
(247480, '3afmB00', NULL, NULL, 258, NULL, NULL, 231530),
(247481, '1txgA01', NULL, NULL, 180, NULL, NULL, 231530),
(247482, '1hyhA01', NULL, NULL, 148, NULL, NULL, 231530),
(247483, '2pd6A00', NULL, NULL, 264, NULL, NULL, 231530),
(247484, '3donA02', NULL, NULL, 133, NULL, NULL, 231530),
(247485, '2nvwB01', NULL, NULL, 232, NULL, NULL, 231530),
(247486, '4hadA01', NULL, NULL, 142, NULL, NULL, 231530),
(247487, '4h3vA01', NULL, NULL, 140, NULL, NULL, 231530),
(247488, '5v7nA01', NULL, NULL, 137, NULL, NULL, 231530),
(247489, '4dioA02', NULL, NULL, 183, NULL, NULL, 231530),
(247490, '2c29D00', NULL, NULL, 337, NULL, NULL, 231530),
(247491, '4dioA01', NULL, NULL, 179, NULL, NULL, 231530),
(247492, '6ixmB00', NULL, NULL, 249, NULL, NULL, 231530),
(247493, '1o0sA04', NULL, NULL, 185, NULL, NULL, 231530),
(247494, '3oetH01', NULL, NULL, 129, NULL, NULL, 231530),
(247495, '4fgwA01', NULL, NULL, 201, NULL, NULL, 231530),
(247496, '2dbqA01', NULL, NULL, 141, NULL, NULL, 231530),
(247497, '6h9sB01', NULL, NULL, 141, NULL, NULL, 231530),
(247498, '2dbqA02', NULL, NULL, 193, NULL, NULL, 231530),
(247499, '1n2sA01', NULL, NULL, 213, NULL, NULL, 231530),
(247500, '1t4bA01', NULL, NULL, 151, NULL, NULL, 231530);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(247501, '5uzxA00', NULL, NULL, 245, NULL, NULL, 231530),
(247502, '3h9uA02', NULL, NULL, 160, NULL, NULL, 231530),
(247503, '6jcvA01', NULL, NULL, 182, NULL, NULL, 231530),
(247504, '4rplA01', NULL, NULL, 216, NULL, NULL, 231530),
(247505, '3lf2A01', NULL, NULL, 250, NULL, NULL, 231530),
(247506, '4r1uA00', NULL, NULL, 323, NULL, NULL, 231530),
(247507, '6bwlA01', NULL, NULL, 207, NULL, NULL, 231530),
(247508, '3op4A00', NULL, NULL, 248, NULL, NULL, 231530),
(247509, '4kwhA00', NULL, NULL, 263, NULL, NULL, 231530),
(247510, '4zjuA00', NULL, NULL, 275, NULL, NULL, 231530),
(247511, '3ic5A00', NULL, NULL, 118, NULL, NULL, 231530),
(247512, '2j8zA02', NULL, NULL, 144, NULL, NULL, 231530),
(247513, '5zxnA02', NULL, NULL, 182, NULL, NULL, 231530),
(247514, '5yjlA02', NULL, NULL, 153, NULL, NULL, 231530),
(247515, '2hk9A02', NULL, NULL, 130, NULL, NULL, 231530),
(247516, '5itgA01', NULL, NULL, 285, NULL, NULL, 231530),
(247517, '4zqeA01', NULL, NULL, 150, NULL, NULL, 231530),
(247518, '1bvuA02', NULL, NULL, 237, NULL, NULL, 231530),
(247519, '5mlrA00', NULL, NULL, 364, NULL, NULL, 231530),
(247520, '4qukA00', NULL, NULL, 319, NULL, NULL, 231530),
(247521, '2c2xA01', NULL, NULL, 127, NULL, NULL, 231530),
(247522, '3iahA00', NULL, NULL, 256, NULL, NULL, 231530),
(247523, '1npyA02', NULL, NULL, 171, NULL, NULL, 231530),
(247524, '4uejA02', NULL, NULL, 138, NULL, NULL, 231530),
(247525, '6dntA01', NULL, NULL, 202, NULL, NULL, 231530),
(247526, '4ii2A04', NULL, NULL, 226, NULL, NULL, 231530),
(247527, '5jy1A00', NULL, NULL, 274, NULL, NULL, 231530),
(247528, '4koaA01', NULL, NULL, 122, NULL, NULL, 231530),
(247529, '5nzoA00', NULL, NULL, 195, NULL, NULL, 231530),
(247530, '5u9cA01', NULL, NULL, 215, NULL, NULL, 231530),
(247531, '1x13A02', NULL, NULL, 182, NULL, NULL, 231530),
(247532, '3e03A00', NULL, NULL, 274, NULL, NULL, 231530),
(247533, '1t2dA01', NULL, NULL, 149, NULL, NULL, 231530),
(247534, '2qytA01', NULL, NULL, 192, NULL, NULL, 231530),
(247535, '5mh5A02', NULL, NULL, 186, NULL, NULL, 231530),
(247536, '2ag5C00', NULL, NULL, 246, NULL, NULL, 231530),
(247537, '4gkvA02', NULL, NULL, 138, NULL, NULL, 231530),
(247538, '5u9pC00', NULL, NULL, 265, NULL, NULL, 231530),
(247539, '1ek6A02', NULL, NULL, 218, NULL, NULL, 231530),
(247540, '1lu9A02', NULL, NULL, 151, NULL, NULL, 231530),
(247541, '1hxhA00', NULL, NULL, 253, NULL, NULL, 231530),
(247542, '1zk4A00', NULL, NULL, 251, NULL, NULL, 231530),
(247543, '1isiA02', NULL, NULL, 142, NULL, NULL, 231530),
(247544, '3wg9A02', NULL, NULL, 147, NULL, NULL, 231530),
(247545, '1geeA00', NULL, NULL, 261, NULL, NULL, 231530),
(247546, '1yqdA02', NULL, NULL, 157, NULL, NULL, 231530),
(247547, '1vkoA01', NULL, NULL, 402, NULL, NULL, 231530),
(247548, '3v1tC02', NULL, NULL, 247, NULL, NULL, 231530),
(247549, '3v1tC01', NULL, NULL, 179, NULL, NULL, 231530),
(247550, '3d7lA00', NULL, NULL, 202, NULL, NULL, 231530),
(247551, '2x9gD00', NULL, NULL, 267, NULL, NULL, 231530),
(247552, '5jc8C00', NULL, NULL, 276, NULL, NULL, 231530),
(247553, '3l77A00', NULL, NULL, 235, NULL, NULL, 231530),
(247554, '4cjxA01', NULL, NULL, 140, NULL, NULL, 231530),
(247555, '1pjqA01', NULL, NULL, 112, NULL, NULL, 231530),
(247556, '1dxyA01', NULL, NULL, 136, NULL, NULL, 231530),
(247557, '1dxyA02', NULL, NULL, 196, NULL, NULL, 231530),
(247558, '3k6jA01', NULL, NULL, 233, NULL, NULL, 231530),
(247559, '3t4eA02', NULL, NULL, 151, NULL, NULL, 231530),
(247560, '3fbgA02', NULL, NULL, 147, NULL, NULL, 231530),
(247561, '1w6uD00', NULL, NULL, 302, NULL, NULL, 231530),
(247562, '4dmmD00', NULL, NULL, 246, NULL, NULL, 231530),
(247563, '5tdeB01', NULL, NULL, 138, NULL, NULL, 231530),
(247564, '3docA01', NULL, NULL, 170, NULL, NULL, 231530),
(247565, '4z9xA00', NULL, NULL, 264, NULL, NULL, 231530),
(247566, '4gbjC01', NULL, NULL, 162, NULL, NULL, 231530),
(247567, '3qivA00', NULL, NULL, 222, NULL, NULL, 231530),
(247568, '4miyA01', NULL, NULL, 214, NULL, NULL, 231530),
(247569, '4yaeA00', NULL, NULL, 234, NULL, NULL, 231530),
(247570, '4edfC03', NULL, NULL, 221, NULL, NULL, 231530),
(247571, '3dqpA00', NULL, NULL, 219, NULL, NULL, 231530);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(247572, '5z0cA02', NULL, NULL, 157, NULL, NULL, 231530),
(247573, '4gvlA01', NULL, NULL, 139, NULL, NULL, 231530),
(247574, '4cqmG00', NULL, NULL, 244, NULL, NULL, 231530),
(247575, '4yteA00', NULL, NULL, 194, NULL, NULL, 231530),
(247576, '3vpsB01', NULL, NULL, 211, NULL, NULL, 231530),
(247577, '3iieA01', NULL, NULL, 153, NULL, NULL, 231530),
(247578, '4a26A01', NULL, NULL, 142, NULL, NULL, 231530),
(247579, '1y7tA01', NULL, NULL, 153, NULL, NULL, 231530),
(247580, '1kewA01', NULL, NULL, 259, NULL, NULL, 231530),
(247581, '3ioyB01', NULL, NULL, 229, NULL, NULL, 231530),
(247582, '4b3hA02', NULL, NULL, 184, NULL, NULL, 231530),
(247583, '2omeA01', NULL, NULL, 136, NULL, NULL, 231530),
(247584, '2omeA02', NULL, NULL, 194, NULL, NULL, 231530),
(247585, '3o8qA02', NULL, NULL, 143, NULL, NULL, 231530),
(247586, '3ff4A00', NULL, NULL, 122, NULL, NULL, 231530),
(247587, '3cpsA01', NULL, NULL, 168, NULL, NULL, 231530),
(247588, '1wdkA02', NULL, NULL, 184, NULL, NULL, 231530),
(247589, '3moiA01', NULL, NULL, 175, NULL, NULL, 231530),
(247590, '6e8yA01', NULL, NULL, 192, NULL, NULL, 231530),
(247591, '5tf4B00', NULL, NULL, 274, NULL, NULL, 231530),
(247592, '2iz1B01', NULL, NULL, 183, NULL, NULL, 231530),
(247593, '6n7lA02', NULL, NULL, 138, NULL, NULL, 231530),
(247594, '1evyA01', NULL, NULL, 206, NULL, NULL, 231530),
(247595, '4wkgA02', NULL, NULL, 347, NULL, NULL, 231530),
(247596, '1ldnA01', NULL, NULL, 148, NULL, NULL, 231530),
(247597, '3vtzC00', NULL, NULL, 269, NULL, NULL, 231530),
(247598, '3mjeB00', NULL, NULL, 478, NULL, NULL, 231530),
(247599, '4fn4A00', NULL, NULL, 254, NULL, NULL, 231530),
(247600, '3gedA00', NULL, NULL, 247, NULL, NULL, 231530),
(247601, '4is2A00', NULL, NULL, 248, NULL, NULL, 231530),
(247602, '3u09A00', NULL, NULL, 251, NULL, NULL, 231530),
(247603, '1iukA00', NULL, NULL, 140, NULL, NULL, 231530),
(247604, '3znnA01', NULL, NULL, 206, NULL, NULL, 231530),
(247605, '2pgdA01', NULL, NULL, 180, NULL, NULL, 231530),
(247606, '5vpsA00', NULL, NULL, 267, NULL, NULL, 231530),
(247607, '4boyA01', NULL, NULL, 173, NULL, NULL, 231530),
(247608, '2eggA02', NULL, NULL, 140, NULL, NULL, 231530),
(247609, '5zfmA00', NULL, NULL, 248, NULL, NULL, 231530),
(247610, '4pg7A01', NULL, NULL, 169, NULL, NULL, 231530),
(247611, '4lw8A01', NULL, NULL, 237, NULL, NULL, 231530),
(247612, '2rirE01', NULL, NULL, 153, NULL, NULL, 231530),
(247613, '4gi2A02', NULL, NULL, 160, NULL, NULL, 231530),
(247614, '2rhcA00', NULL, NULL, 257, NULL, NULL, 231530),
(247615, '3wxbB00', NULL, NULL, 256, NULL, NULL, 231530),
(247616, '4ggpA00', NULL, NULL, 401, NULL, NULL, 231530),
(247617, '1x7dA02', NULL, NULL, 170, NULL, NULL, 231530),
(247618, '1cf2O01', NULL, NULL, 172, NULL, NULL, 231530),
(247619, '3hwrA01', NULL, NULL, 169, NULL, NULL, 231530),
(247620, '4r3nA01', NULL, NULL, 166, NULL, NULL, 231530),
(247621, '1gq2A02', NULL, NULL, 300, NULL, NULL, 231530),
(247622, '1rm4A01', NULL, NULL, 171, NULL, NULL, 231530),
(247623, '1l7dA02', NULL, NULL, 188, NULL, NULL, 231530),
(247624, '4urfA00', NULL, NULL, 248, NULL, NULL, 231530),
(247625, '1i32A01', NULL, NULL, 183, NULL, NULL, 231530),
(247626, '1q0hA01', NULL, NULL, 158, NULL, NULL, 231530),
(247627, '1qorA02', NULL, NULL, 146, NULL, NULL, 231530),
(247628, '2d8aA02', NULL, NULL, 135, NULL, NULL, 231530),
(247629, '2yv2A01', NULL, NULL, 129, NULL, NULL, 231530),
(247630, '1o94A02', NULL, NULL, 168, NULL, NULL, 231530),
(247631, '5a04A01', NULL, NULL, 166, NULL, NULL, 231530),
(247632, '6aa8B01', NULL, NULL, 188, NULL, NULL, 231530),
(247633, '3pduA01', NULL, NULL, 164, NULL, NULL, 231530),
(247634, '2i76A01', NULL, NULL, 155, NULL, NULL, 231530),
(247635, '1bdbA00', NULL, NULL, 277, NULL, NULL, 231530),
(247636, '1wwkA01', NULL, NULL, 116, NULL, NULL, 231530),
(247637, '1wwkA02', NULL, NULL, 191, NULL, NULL, 231530),
(247638, '5cefA01', NULL, NULL, 189, NULL, NULL, 231530),
(247639, '3hdqA01', NULL, NULL, 207, NULL, NULL, 231530),
(247640, '5dovA02', NULL, NULL, 141, NULL, NULL, 231530),
(247641, '4lisA01', NULL, NULL, 230, NULL, NULL, 231530),
(247642, '5t2vA00', NULL, NULL, 248, NULL, NULL, 231530);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(247643, '1db3A01', NULL, NULL, 241, NULL, NULL, 231530),
(247644, '2qrjA02', NULL, NULL, 191, NULL, NULL, 231530),
(247645, '3q2iA01', NULL, NULL, 164, NULL, NULL, 231530),
(247646, '3gc6A02', NULL, NULL, 113, NULL, NULL, 231530),
(247647, '5a9tA01', NULL, NULL, 161, NULL, NULL, 231530),
(247648, '4f3yA01', NULL, NULL, 164, NULL, NULL, 231530),
(247649, '5tqvB00', NULL, NULL, 233, NULL, NULL, 231530),
(247650, '4z6kA02', NULL, NULL, 138, NULL, NULL, 231530),
(247651, '5unlB00', NULL, NULL, 273, NULL, NULL, 231530),
(247652, '4inaA01', NULL, NULL, 208, NULL, NULL, 231530),
(247653, '4eezA02', NULL, NULL, 140, NULL, NULL, 231530),
(247654, '6nnaA02', NULL, NULL, 355, NULL, NULL, 231530),
(247655, '2hrbA00', NULL, NULL, 274, NULL, NULL, 231530),
(247656, '1iz0A02', NULL, NULL, 161, NULL, NULL, 231530),
(247657, '2o4cA01', NULL, NULL, 126, NULL, NULL, 231530),
(247658, '3gvxB01', NULL, NULL, 113, NULL, NULL, 231530),
(247659, '4ydrA01', NULL, NULL, 167, NULL, NULL, 231530),
(247660, '2o4cA02', NULL, NULL, 166, NULL, NULL, 231530),
(247661, '3pp8A01', NULL, NULL, 131, NULL, NULL, 231530),
(247662, '3pp8A02', NULL, NULL, 183, NULL, NULL, 231530),
(247663, '2z5lA00', NULL, NULL, 490, NULL, NULL, 231530),
(247664, '5vt6D00', NULL, NULL, 245, NULL, NULL, 231530),
(247665, '1ygyA02', NULL, NULL, 182, NULL, NULL, 231530),
(247666, '3o03A00', NULL, NULL, 268, NULL, NULL, 231530),
(247667, '1ygyA01', NULL, NULL, 138, NULL, NULL, 231530),
(247668, '4dvjA02', NULL, NULL, 146, NULL, NULL, 231530),
(247669, '3pxxD00', NULL, NULL, 287, NULL, NULL, 231530),
(247670, '2yy7A00', NULL, NULL, 312, NULL, NULL, 231530),
(247671, '1jtvA00', NULL, NULL, 285, NULL, NULL, 231530),
(247672, '3a06B01', NULL, NULL, 142, NULL, NULL, 231530),
(247673, '2o3jB01', NULL, NULL, 219, NULL, NULL, 231530),
(247674, '2ydyA00', NULL, NULL, 298, NULL, NULL, 231530),
(247675, '2pk3A01', NULL, NULL, 231, NULL, NULL, 231530),
(247676, '4kqwA01', NULL, NULL, 192, NULL, NULL, 231530),
(247677, '2b0jA01', NULL, NULL, 252, NULL, NULL, 231530),
(247678, '3qwbA02', NULL, NULL, 145, NULL, NULL, 231530),
(247679, '3sjuA00', NULL, NULL, 255, NULL, NULL, 231530),
(247680, '3o38B01', NULL, NULL, 262, NULL, NULL, 231530),
(247681, '1hdcA00', NULL, NULL, 254, NULL, NULL, 231530),
(247682, '4dplA01', NULL, NULL, 177, NULL, NULL, 231530),
(247683, '4zqbA02', NULL, NULL, 183, NULL, NULL, 231530),
(247684, '1pjcA02', NULL, NULL, 176, NULL, NULL, 231530),
(247685, '1pjcA01', NULL, NULL, 185, NULL, NULL, 231530),
(247686, '3x2fA02', NULL, NULL, 160, NULL, NULL, 231530),
(247687, '3fhlA01', NULL, NULL, 140, NULL, NULL, 231530),
(247688, '5va8A00', NULL, NULL, 267, NULL, NULL, 231530),
(247689, '4ej0A01', NULL, NULL, 215, NULL, NULL, 231530),
(247690, '5b1yA00', NULL, NULL, 250, NULL, NULL, 231530),
(247691, '3g1tA00', NULL, NULL, 258, NULL, NULL, 231530),
(247692, '5g4kA00', NULL, NULL, 264, NULL, NULL, 231530),
(247693, '4hxyA00', NULL, NULL, 438, NULL, NULL, 231530),
(247694, '1xgkA01', NULL, NULL, 234, NULL, NULL, 231530),
(247695, '4iy1A00', NULL, NULL, 254, NULL, NULL, 231530),
(247696, '3dfzB01', NULL, NULL, 127, NULL, NULL, 231530),
(247697, '3mtgA02', NULL, NULL, 159, NULL, NULL, 231530),
(247698, '2qrlA01', NULL, NULL, 180, NULL, NULL, 231530),
(247699, '4k9dA01', NULL, NULL, 180, NULL, NULL, 231530),
(247700, '1omoA02', NULL, NULL, 171, NULL, NULL, 231530),
(247701, '1ja9A00', NULL, NULL, 274, NULL, NULL, 231530),
(247702, '2b4qB00', NULL, NULL, 256, NULL, NULL, 231530),
(247703, '2yv3A01', NULL, NULL, 142, NULL, NULL, 231530),
(247704, '2dvmB02', NULL, NULL, 280, NULL, NULL, 231530),
(247705, '3ezyA01', NULL, NULL, 121, NULL, NULL, 231530),
(247706, '3oigA00', NULL, NULL, 266, NULL, NULL, 231530),
(247707, '1piwA02', NULL, NULL, 137, NULL, NULL, 231530),
(247708, '3ec7A01', NULL, NULL, 213, NULL, NULL, 231530),
(247709, '2bkaA00', NULL, NULL, 242, NULL, NULL, 231530),
(247710, '3fpcA02', NULL, NULL, 131, NULL, NULL, 231530),
(247711, '4nbuA00', NULL, NULL, 250, NULL, NULL, 231530),
(247712, '4zgsA02', NULL, NULL, 202, NULL, NULL, 231530),
(247713, '4e5nA02', NULL, NULL, 197, NULL, NULL, 231530);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(247714, '4zgsA01', NULL, NULL, 143, NULL, NULL, 231530),
(247715, '2bllA01', NULL, NULL, 243, NULL, NULL, 231530),
(247716, '5l9aB00', NULL, NULL, 321, NULL, NULL, 231530),
(247717, '3p7mB01', NULL, NULL, 147, NULL, NULL, 231530),
(247718, '2fzwA02', NULL, NULL, 139, NULL, NULL, 231530),
(247719, '1n5dA00', NULL, NULL, 288, NULL, NULL, 231530),
(247720, '1vjtA01', NULL, NULL, 126, NULL, NULL, 231530),
(247721, '5er6C00', NULL, NULL, 251, NULL, NULL, 231530),
(247722, '1pgjA01', NULL, NULL, 186, NULL, NULL, 231530),
(247723, '4dryA00', NULL, NULL, 248, NULL, NULL, 231530),
(247724, '4gqaC01', NULL, NULL, 134, NULL, NULL, 231530),
(247725, '4e5yC01', NULL, NULL, 221, NULL, NULL, 231530),
(247726, '5gxeA02', NULL, NULL, 169, NULL, NULL, 231530),
(247727, '4dqxB00', NULL, NULL, 254, NULL, NULL, 231530),
(247728, '4izhA02', NULL, NULL, 179, NULL, NULL, 231530),
(247729, '3n58A02', NULL, NULL, 158, NULL, NULL, 231530),
(247730, '6b9uB00', NULL, NULL, 257, NULL, NULL, 231530),
(247731, '3f3sA01', NULL, NULL, 189, NULL, NULL, 231530),
(247732, '4p8rA01', NULL, NULL, 173, NULL, NULL, 231530),
(247733, '3phhA02', NULL, NULL, 133, NULL, NULL, 231530),
(247734, '4xkjA01', NULL, NULL, 139, NULL, NULL, 231530),
(247735, '1mg5A00', NULL, NULL, 255, NULL, NULL, 231530),
(247736, '2qq5A00', NULL, NULL, 260, NULL, NULL, 231530),
(247737, '3qsgA01', NULL, NULL, 168, NULL, NULL, 231530),
(247738, '2rcyA01', NULL, NULL, 154, NULL, NULL, 231530),
(247739, '4uupA01', NULL, NULL, 153, NULL, NULL, 231530),
(247740, '2eg9A02', NULL, NULL, 112, NULL, NULL, 231530),
(247741, '3p2yA02', NULL, NULL, 179, NULL, NULL, 231530),
(247742, '3p2yA01', NULL, NULL, 175, NULL, NULL, 231530),
(247743, '4jlwA02', NULL, NULL, 167, NULL, NULL, 231530),
(247744, '3gvcA00', NULL, NULL, 251, NULL, NULL, 231530),
(247745, '1nytA02', NULL, NULL, 143, NULL, NULL, 231530),
(247746, '3qy9B01', NULL, NULL, 138, NULL, NULL, 231530),
(247747, '3dtyA01', NULL, NULL, 187, NULL, NULL, 231530),
(247748, '4tqgA00', NULL, NULL, 323, NULL, NULL, 231530),
(247749, '1p77A02', NULL, NULL, 123, NULL, NULL, 231530),
(247750, '1vi2A02', NULL, NULL, 150, NULL, NULL, 231530),
(247751, '4o6vA00', NULL, NULL, 242, NULL, NULL, 231530),
(247752, '3lk7A01', NULL, NULL, 86, NULL, NULL, 231530),
(247753, '5jw6A01', NULL, NULL, 185, NULL, NULL, 231530),
(247754, '1q0qA01', NULL, NULL, 158, NULL, NULL, 231530),
(247755, '3lvfP01', NULL, NULL, 171, NULL, NULL, 231530),
(247756, '3guyA00', NULL, NULL, 230, NULL, NULL, 231530),
(247757, '4tvoA01', NULL, NULL, 155, NULL, NULL, 231530),
(247758, '1j4aA02', NULL, NULL, 196, NULL, NULL, 231530),
(247759, '1jvbA02', NULL, NULL, 141, NULL, NULL, 231530),
(247760, '2fp4A01', NULL, NULL, 123, NULL, NULL, 231530),
(247761, '1vl8A00', NULL, NULL, 251, NULL, NULL, 231530),
(247762, '3ko8A01', NULL, NULL, 200, NULL, NULL, 231530),
(247763, '1b8pA01', NULL, NULL, 157, NULL, NULL, 231530),
(247764, '6bwcB01', NULL, NULL, 237, NULL, NULL, 231530),
(247765, '5v7gA02', NULL, NULL, 186, NULL, NULL, 231530),
(247766, '3dzbA01', NULL, NULL, 185, NULL, NULL, 231530),
(247767, '4d44A00', NULL, NULL, 254, NULL, NULL, 231530),
(247768, '5ok4A01', NULL, NULL, 254, NULL, NULL, 231530),
(247769, '1jayA00', NULL, NULL, 212, NULL, NULL, 231530),
(247770, '3dr3A01', NULL, NULL, 177, NULL, NULL, 231530),
(247771, '3uuwA01', NULL, NULL, 123, NULL, NULL, 231530),
(247772, '4eyeA02', NULL, NULL, 168, NULL, NULL, 231530),
(247773, '3vvcA01', NULL, NULL, 238, NULL, NULL, 231530),
(247774, '5fffA00', NULL, NULL, 257, NULL, NULL, 231530),
(247775, '1zcjA02', NULL, NULL, 184, NULL, NULL, 231530),
(247776, '3r6dA00', NULL, NULL, 221, NULL, NULL, 231530),
(247777, '2plaA01', NULL, NULL, 194, NULL, NULL, 231530),
(247778, '5mspA02', NULL, NULL, 444, NULL, NULL, 231530),
(247779, '2q3eD01', NULL, NULL, 213, NULL, NULL, 231530),
(247780, '4wuvA00', NULL, NULL, 280, NULL, NULL, 231530),
(247781, '6hrdA01', NULL, NULL, 191, NULL, NULL, 231530),
(247782, '5vktA02', NULL, NULL, 157, NULL, NULL, 231530),
(247783, '3gvpA02', NULL, NULL, 159, NULL, NULL, 231530),
(247784, '4izhA01', NULL, NULL, 180, NULL, NULL, 231530);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(247785, '5mlnA00', NULL, NULL, 241, NULL, NULL, 231530),
(247786, '2duwA00', NULL, NULL, 145, NULL, NULL, 231530),
(247787, '2zydB01', NULL, NULL, 192, NULL, NULL, 231530),
(247788, '6g4qA01', NULL, NULL, 123, NULL, NULL, 231530),
(247789, '1e3iA02', NULL, NULL, 137, NULL, NULL, 231530),
(247790, '1p33A00', NULL, NULL, 289, NULL, NULL, 231530),
(247791, '4r1nA01', NULL, NULL, 187, NULL, NULL, 231530),
(247792, '1y81A00', NULL, NULL, 138, NULL, NULL, 231530),
(247793, '3ctmC00', NULL, NULL, 279, NULL, NULL, 231530),
(247794, '2yq5A02', NULL, NULL, 197, NULL, NULL, 231530),
(247795, '1jw9B00', NULL, NULL, 249, NULL, NULL, 231530),
(247796, '3bioB01', NULL, NULL, 190, NULL, NULL, 231530),
(247797, '3f9iA00', NULL, NULL, 249, NULL, NULL, 231530),
(247798, '5tr4A04', NULL, NULL, 226, NULL, NULL, 231530),
(247799, '3ngxA01', NULL, NULL, 126, NULL, NULL, 231530),
(247800, '4dibA01', NULL, NULL, 180, NULL, NULL, 231530),
(247801, '4im7A01', NULL, NULL, 275, NULL, NULL, 231530),
(247802, '3nv9A02', NULL, NULL, 295, NULL, NULL, 231530),
(247803, '2gf2A01', NULL, NULL, 162, NULL, NULL, 231530),
(247804, '4iqgA00', NULL, NULL, 248, NULL, NULL, 231530),
(247805, '3kzvA00', NULL, NULL, 254, NULL, NULL, 231530),
(247806, '3rd5A00', NULL, NULL, 291, NULL, NULL, 231530),
(247807, '5ojiA00', NULL, NULL, 260, NULL, NULL, 231530),
(247808, '4j6fA02', NULL, NULL, 159, NULL, NULL, 231530),
(247809, '4tskA01', NULL, NULL, 181, NULL, NULL, 231530),
(247810, '1xg5B00', NULL, NULL, 257, NULL, NULL, 231530),
(247811, '1e6wB00', NULL, NULL, 260, NULL, NULL, 231530),
(247812, '5ej2A00', NULL, NULL, 277, NULL, NULL, 231530),
(247813, '3gfbA02', NULL, NULL, 135, NULL, NULL, 231530),
(247814, '1gv0A01', NULL, NULL, 143, NULL, NULL, 231530),
(247815, '3meqA02', NULL, NULL, 140, NULL, NULL, 231530),
(247816, '5vvwA01', NULL, NULL, 96, NULL, NULL, 231530),
(247817, '4c4oA02', NULL, NULL, 130, NULL, NULL, 231530),
(247818, '1dhrA00', NULL, NULL, 241, NULL, NULL, 231530),
(247819, '2d4aD01', NULL, NULL, 141, NULL, NULL, 231530),
(247820, '2hmtA00', NULL, NULL, 144, NULL, NULL, 231530),
(247821, '3d4oA02', NULL, NULL, 147, NULL, NULL, 231530),
(247822, '2dt5A02', NULL, NULL, 138, NULL, NULL, 231530),
(247823, '4rvuA02', NULL, NULL, 148, NULL, NULL, 231530),
(247824, '2yyyA01', NULL, NULL, 175, NULL, NULL, 231530),
(247825, '2hrzA01', NULL, NULL, 231, NULL, NULL, 231530),
(247826, '1fjhA00', NULL, NULL, 257, NULL, NULL, 231530),
(247827, '3e8xA00', NULL, NULL, 236, NULL, NULL, 231530),
(247828, '4lvuA00', NULL, NULL, 254, NULL, NULL, 231530),
(247829, '4gkbA00', NULL, NULL, 258, NULL, NULL, 231530),
(247830, '3d1lB01', NULL, NULL, 167, NULL, NULL, 231530),
(247831, '2pzmB00', NULL, NULL, 330, NULL, NULL, 231530),
(247832, '3ondA02', NULL, NULL, 162, NULL, NULL, 231530),
(247833, '4a7pB01', NULL, NULL, 208, NULL, NULL, 231530),
(247834, '3m2pB00', NULL, NULL, 295, NULL, NULL, 231530),
(247835, '4w4tB00', NULL, NULL, 394, NULL, NULL, 231530),
(247836, '2x5oA01', NULL, NULL, 92, NULL, NULL, 231530),
(247837, '4cv2A00', NULL, NULL, 270, NULL, NULL, 231530),
(247838, '4e6pA00', NULL, NULL, 259, NULL, NULL, 231530),
(247839, '1rkxA01', NULL, NULL, 193, NULL, NULL, 231530),
(247840, '4q9nA00', NULL, NULL, 298, NULL, NULL, 231530),
(247841, '3pi7A02', NULL, NULL, 147, NULL, NULL, 231530),
(247842, '4nbwA00', NULL, NULL, 257, NULL, NULL, 231530),
(247843, '3qa9A00', NULL, NULL, 149, NULL, NULL, 231530),
(247844, '4hy3D01', NULL, NULL, 152, NULL, NULL, 231530),
(247845, '1up7A01', NULL, NULL, 137, NULL, NULL, 231530),
(247846, '1qydA01', NULL, NULL, 192, NULL, NULL, 231530),
(247847, '4egfD00', NULL, NULL, 266, NULL, NULL, 231530),
(247848, '1p0fA02', NULL, NULL, 139, NULL, NULL, 231530),
(247849, '2j3hA02', NULL, NULL, 177, NULL, NULL, 231530),
(247850, '2jhfA02', NULL, NULL, 139, NULL, NULL, 231530),
(247851, '3ce6A02', NULL, NULL, 161, NULL, NULL, 231530),
(247852, '2ew8B00', NULL, NULL, 249, NULL, NULL, 231530),
(247853, '5h5xI00', NULL, NULL, 263, NULL, NULL, 231530),
(247854, '4o1mB00', NULL, NULL, 315, NULL, NULL, 231530),
(247855, '1sowB01', NULL, NULL, 153, NULL, NULL, 231530);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(247856, '5ujkA01', NULL, NULL, 145, NULL, NULL, 231530),
(247857, '1lehA02', NULL, NULL, 203, NULL, NULL, 231530),
(247858, '5t6bB04', NULL, NULL, 99, NULL, NULL, 231530),
(247859, '2c5aA01', NULL, NULL, 183, NULL, NULL, 231530),
(247860, '3toxB00', NULL, NULL, 257, NULL, NULL, 231530),
(247861, '4gwgA01', NULL, NULL, 182, NULL, NULL, 231530),
(247862, '4pg4B01', NULL, NULL, 159, NULL, NULL, 231530),
(247863, '1gpjA02', NULL, NULL, 154, NULL, NULL, 231530),
(247864, '6abjA02', NULL, NULL, 196, NULL, NULL, 231530),
(247865, '1hyeA01', NULL, NULL, 147, NULL, NULL, 231530),
(247866, '3ukoA02', NULL, NULL, 139, NULL, NULL, 231530),
(247867, '4m1qA01', NULL, NULL, 144, NULL, NULL, 231530),
(247868, '3edmD00', NULL, NULL, 259, NULL, NULL, 231530),
(247869, '3v8bC00', NULL, NULL, 255, NULL, NULL, 231530),
(247870, '2p68B00', NULL, NULL, 248, NULL, NULL, 231530),
(247871, '3oj0A00', NULL, NULL, 144, NULL, NULL, 231530),
(247872, '4rl6A01', NULL, NULL, 230, NULL, NULL, 231530),
(247873, '2p2sA01', NULL, NULL, 140, NULL, NULL, 231530),
(247874, '5fi3A02', NULL, NULL, 157, NULL, NULL, 231530),
(247875, '3eagB01', NULL, NULL, 95, NULL, NULL, 231530),
(247876, '6iumA02', NULL, NULL, 191, NULL, NULL, 231530),
(247877, '4e4yA00', NULL, NULL, 244, NULL, NULL, 231530),
(247878, '3fwzA00', NULL, NULL, 140, NULL, NULL, 231530),
(247879, '3ppiC00', NULL, NULL, 258, NULL, NULL, 231530),
(247880, '2yq5C01', NULL, NULL, 145, NULL, NULL, 231530),
(247881, '1fmcA00', NULL, NULL, 255, NULL, NULL, 231530),
(247882, '4j3fA00', NULL, NULL, 259, NULL, NULL, 231530),
(247883, '3hdjA02', NULL, NULL, 171, NULL, NULL, 231530),
(247884, '4fc7D00', NULL, NULL, 277, NULL, NULL, 231530),
(247885, '3u49D00', NULL, NULL, 260, NULL, NULL, 231530),
(247886, '4rv9A04', NULL, NULL, 109, NULL, NULL, 231530),
(247887, '4yrbF00', NULL, NULL, 250, NULL, NULL, 231530),
(247888, '6ldhA01', NULL, NULL, 163, NULL, NULL, 231530),
(247889, '3o9zA01', NULL, NULL, 132, NULL, NULL, 231530),
(247890, '5dzsB02', NULL, NULL, 132, NULL, NULL, 231530),
(247891, '4jxkA02', NULL, NULL, 165, NULL, NULL, 231530),
(247892, '5nfrA01', NULL, NULL, 143, NULL, NULL, 231530),
(247893, '3wtbC00', NULL, NULL, 246, NULL, NULL, 231530),
(247894, '3u3xA01', NULL, NULL, 137, NULL, NULL, 231530),
(247895, '5bt9D00', NULL, NULL, 253, NULL, NULL, 231530),
(247896, '3e9mA01', NULL, NULL, 123, NULL, NULL, 231530),
(247897, '2cukA01', NULL, NULL, 129, NULL, NULL, 231530),
(247898, '1r6dA01', NULL, NULL, 218, NULL, NULL, 231530),
(247899, '1zbqA01', NULL, NULL, 244, NULL, NULL, 231530),
(247900, '5thqA00', NULL, NULL, 248, NULL, NULL, 231530),
(247901, '5o1pA01', NULL, NULL, 173, NULL, NULL, 231530),
(247902, '2y1eA01', NULL, NULL, 141, NULL, NULL, 231530),
(247903, '2cukA02', NULL, NULL, 182, NULL, NULL, 231530),
(247904, '4gh5B00', NULL, NULL, 253, NULL, NULL, 231530),
(247905, '3sthC01', NULL, NULL, 171, NULL, NULL, 231530),
(247906, '3gmsA02', NULL, NULL, 126, NULL, NULL, 231530),
(247907, '1ydwA01', NULL, NULL, 133, NULL, NULL, 231530),
(247908, '1e7wB00', NULL, NULL, 291, NULL, NULL, 231530),
(247909, '2wsbA00', NULL, NULL, 254, NULL, NULL, 231530),
(247910, '1ulsC00', NULL, NULL, 245, NULL, NULL, 231530),
(247911, '1spxA00', NULL, NULL, 278, NULL, NULL, 231530),
(247912, '1i8tA01', NULL, NULL, 190, NULL, NULL, 231530),
(247913, '3jyoA02', NULL, NULL, 143, NULL, NULL, 231530),
(247914, '5g0tC00', NULL, NULL, 269, NULL, NULL, 231530),
(247915, '4j4hA02', NULL, NULL, 124, NULL, NULL, 231530),
(247916, '3f4lA01', NULL, NULL, 122, NULL, NULL, 231530),
(247917, '3wj7A00', NULL, NULL, 342, NULL, NULL, 231530),
(247918, '4o0lA00', NULL, NULL, 275, NULL, NULL, 231530),
(247919, '4jroB00', NULL, NULL, 247, NULL, NULL, 231530),
(247920, '3m2tB01', NULL, NULL, 194, NULL, NULL, 231530),
(247921, '3keoB02', NULL, NULL, 135, NULL, NULL, 231530),
(247922, '4nh4A02', NULL, NULL, 177, NULL, NULL, 231530),
(247923, '5m67A02', NULL, NULL, 158, NULL, NULL, 231530),
(247924, '6el3B00', NULL, NULL, 364, NULL, NULL, 231530),
(247925, '5bnfB02', NULL, NULL, 110, NULL, NULL, 231530),
(247926, '2hjrA01', NULL, NULL, 156, NULL, NULL, 231530);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(247927, '4xqcA01', NULL, NULL, 178, NULL, NULL, 231530),
(247928, '5temA01', NULL, NULL, 161, NULL, NULL, 231530),
(247929, '4hp8A00', NULL, NULL, 247, NULL, NULL, 231530),
(247930, '4bguA01', NULL, NULL, 142, NULL, NULL, 231530),
(247931, '2d0iA01', NULL, NULL, 141, NULL, NULL, 231530),
(247932, '4jn6B01', NULL, NULL, 160, NULL, NULL, 231530),
(247933, '2d0iA02', NULL, NULL, 192, NULL, NULL, 231530),
(247934, '1vpdA01', NULL, NULL, 168, NULL, NULL, 231530),
(247935, '3orfA00', NULL, NULL, 230, NULL, NULL, 231530),
(247936, '4zrmA01', NULL, NULL, 204, NULL, NULL, 231530),
(247937, '4e3zB00', NULL, NULL, 247, NULL, NULL, 231530),
(247938, '4nimA00', NULL, NULL, 277, NULL, NULL, 231530),
(247939, '4hktA01', NULL, NULL, 120, NULL, NULL, 231530),
(247940, '4jbgA02', NULL, NULL, 134, NULL, NULL, 231530),
(247941, '5yssA00', NULL, NULL, 256, NULL, NULL, 231530),
(247942, '6dv2G02', NULL, NULL, 184, NULL, NULL, 231530),
(247943, '2gcgA01', NULL, NULL, 141, NULL, NULL, 231530),
(247944, '3tnlA02', NULL, NULL, 151, NULL, NULL, 231530),
(247945, '2nacA02', NULL, NULL, 190, NULL, NULL, 231530),
(247946, '2nacA01', NULL, NULL, 184, NULL, NULL, 231530),
(247947, '2gcgA02', NULL, NULL, 189, NULL, NULL, 231530),
(247948, '1y8qC00', NULL, NULL, 346, NULL, NULL, 231530),
(247949, '1o5iA00', NULL, NULL, 249, NULL, NULL, 231530),
(247950, '5tc4A01', NULL, NULL, 146, NULL, NULL, 231530),
(247951, '3ingA01', NULL, NULL, 172, NULL, NULL, 231530),
(247952, '2ep7B01', NULL, NULL, 170, NULL, NULL, 231530),
(247953, '1yb5A02', NULL, NULL, 168, NULL, NULL, 231530),
(247954, '4y9dA00', NULL, NULL, 237, NULL, NULL, 231530),
(247955, '3uveA00', NULL, NULL, 286, NULL, NULL, 231530),
(247956, '5dp1A02', NULL, NULL, 140, NULL, NULL, 231530),
(247957, '4weoA00', NULL, NULL, 266, NULL, NULL, 231530),
(247958, '3enkA01', NULL, NULL, 211, NULL, NULL, 231530),
(247959, '5aq1A01', NULL, NULL, 205, NULL, NULL, 231530),
(247960, '1gadO01', NULL, NULL, 164, NULL, NULL, 231530),
(247961, '4e0bB01', NULL, NULL, 149, NULL, NULL, 231530),
(247962, '2yfqB03', NULL, NULL, 160, NULL, NULL, 231530),
(247963, '4cl3A01', NULL, NULL, 144, NULL, NULL, 231530),
(247964, '4m89A00', NULL, NULL, 261, NULL, NULL, 231530),
(247965, '4prkA02', NULL, NULL, 195, NULL, NULL, 231530),
(247966, '6c85A01', NULL, NULL, 190, NULL, NULL, 231530),
(247967, '4prkA01', NULL, NULL, 140, NULL, NULL, 231530),
(247968, '4iptA00', NULL, NULL, 221, NULL, NULL, 231530),
(247969, '5o98A00', NULL, NULL, 293, NULL, NULL, 231530),
(247970, '2r00A01', NULL, NULL, 149, NULL, NULL, 231530),
(247971, '2ph5A01', NULL, NULL, 177, NULL, NULL, 231530),
(247972, '4oqzA01', NULL, NULL, 159, NULL, NULL, 231530),
(247973, '4hujA00', NULL, NULL, 204, NULL, NULL, 231530),
(247974, '3hhpA01', NULL, NULL, 146, NULL, NULL, 231530),
(247975, '5v96A02', NULL, NULL, 161, NULL, NULL, 231530),
(247976, '5nueA01', NULL, NULL, 155, NULL, NULL, 231530),
(247977, '4impA03', NULL, NULL, 256, NULL, NULL, 231530),
(247978, '1j6uA01', NULL, NULL, 87, NULL, NULL, 231530),
(247979, '2gn4B01', NULL, NULL, 242, NULL, NULL, 231530),
(247980, '6ih3A02', NULL, NULL, 198, NULL, NULL, 231530),
(247981, '6ih3A01', NULL, NULL, 138, NULL, NULL, 231530),
(247982, '1mv8A03', NULL, NULL, 202, NULL, NULL, 231530),
(247983, '1mv8A01', NULL, NULL, 202, NULL, NULL, 231530),
(247984, '1d1tA02', NULL, NULL, 139, NULL, NULL, 231530),
(247985, '2hq1A00', NULL, NULL, 247, NULL, NULL, 231530),
(247986, '3nywD00', NULL, NULL, 250, NULL, NULL, 231530),
(247987, '2p5yA01', NULL, NULL, 200, NULL, NULL, 231530),
(247988, '3uceA00', NULL, NULL, 223, NULL, NULL, 231530),
(247989, '3gdgA00', NULL, NULL, 267, NULL, NULL, 231530),
(247990, '1cydA00', NULL, NULL, 244, NULL, NULL, 231530),
(247991, '3ldhA01', NULL, NULL, 163, NULL, NULL, 231530),
(247992, '1ybaA02', NULL, NULL, 189, NULL, NULL, 231530),
(247993, '5c7iO01', NULL, NULL, 166, NULL, NULL, 231530),
(247994, '2dldA01', NULL, NULL, 139, NULL, NULL, 231530),
(247995, '3plnA03', NULL, NULL, 167, NULL, NULL, 231530),
(247996, '4njmA01', NULL, NULL, 143, NULL, NULL, 231530),
(247997, '2dldA02', NULL, NULL, 196, NULL, NULL, 231530);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(247998, '1r12A02', NULL, NULL, 139, NULL, NULL, 231530),
(247999, '4wpgA01', NULL, NULL, 210, NULL, NULL, 231530),
(248000, '4bmvI00', NULL, NULL, 262, NULL, NULL, 231530),
(248001, '3c1oA01', NULL, NULL, 188, NULL, NULL, 231530),
(248002, '4njmA02', NULL, NULL, 166, NULL, NULL, 231530),
(248003, '2wtbA02', NULL, NULL, 184, NULL, NULL, 231530),
(248004, '1n7hA02', NULL, NULL, 239, NULL, NULL, 231530),
(248005, '5er9B01', NULL, NULL, 213, NULL, NULL, 231530),
(248006, '1id1A00', NULL, NULL, 153, NULL, NULL, 231530),
(248007, '2bi7A01', NULL, NULL, 202, NULL, NULL, 231530),
(248008, '4gqaA01', NULL, NULL, 134, NULL, NULL, 231530),
(248009, '5kvcA00', NULL, NULL, 254, NULL, NULL, 231530),
(248010, '1v8bA02', NULL, NULL, 161, NULL, NULL, 231530),
(248011, '1wlyA02', NULL, NULL, 147, NULL, NULL, 231530),
(248012, '2dknB00', NULL, NULL, 255, NULL, NULL, 231530),
(248013, '3pefA01', NULL, NULL, 164, NULL, NULL, 231530),
(248014, '3pmiA02', NULL, NULL, 57, NULL, NULL, 231531),
(248015, '3qilB00', NULL, NULL, 97, NULL, NULL, 231532),
(248016, '6bmeA00', NULL, NULL, 128, NULL, NULL, 231533),
(248017, '3d1kA00', NULL, NULL, 142, NULL, NULL, 231533),
(248018, '6o0aA01', NULL, NULL, 149, NULL, NULL, 231533),
(248019, '1it2A00', NULL, NULL, 146, NULL, NULL, 231533),
(248020, '1mwcA00', NULL, NULL, 153, NULL, NULL, 231533),
(248021, '1tu9A00', NULL, NULL, 134, NULL, NULL, 231533),
(248022, '1yhuA00', NULL, NULL, 145, NULL, NULL, 231533),
(248023, '1cqxA01', NULL, NULL, 150, NULL, NULL, 231533),
(248024, '1hdsA00', NULL, NULL, 141, NULL, NULL, 231533),
(248025, '3wr1A00', NULL, NULL, 141, NULL, NULL, 231533),
(248026, '4u8uA00', NULL, NULL, 150, NULL, NULL, 231533),
(248027, '3hf4A00', NULL, NULL, 141, NULL, NULL, 231533),
(248028, '3gdjB00', NULL, NULL, 146, NULL, NULL, 231533),
(248029, '2xykB00', NULL, NULL, 133, NULL, NULL, 231533),
(248030, '5yceA00', NULL, NULL, 154, NULL, NULL, 231533),
(248031, '4h2lA00', NULL, NULL, 141, NULL, NULL, 231533),
(248032, '4b4yA00', NULL, NULL, 154, NULL, NULL, 231533),
(248033, '1dlyA00', NULL, NULL, 121, NULL, NULL, 231533),
(248034, '1fhjB00', NULL, NULL, 146, NULL, NULL, 231533),
(248035, '1i3dA00', NULL, NULL, 146, NULL, NULL, 231533),
(248036, '1binA00', NULL, NULL, 143, NULL, NULL, 231533),
(248037, '2vebA00', NULL, NULL, 195, NULL, NULL, 231533),
(248038, '3d1kB00', NULL, NULL, 146, NULL, NULL, 231533),
(248039, '1yhuB00', NULL, NULL, 144, NULL, NULL, 231533),
(248040, '2ig3A00', NULL, NULL, 127, NULL, NULL, 231533),
(248041, '1s69A00', NULL, NULL, 124, NULL, NULL, 231533),
(248042, '1jebD00', NULL, NULL, 146, NULL, NULL, 231533),
(248043, '1ithA00', NULL, NULL, 141, NULL, NULL, 231533),
(248044, '1a9wE00', NULL, NULL, 146, NULL, NULL, 231533),
(248045, '1ch4A00', NULL, NULL, 146, NULL, NULL, 231533),
(248046, '2d5xB00', NULL, NULL, 146, NULL, NULL, 231533),
(248047, '3wr1B00', NULL, NULL, 146, NULL, NULL, 231533),
(248048, '2qrwB00', NULL, NULL, 128, NULL, NULL, 231533),
(248049, '1fhjA00', NULL, NULL, 141, NULL, NULL, 231533),
(248050, '2w72B00', NULL, NULL, 146, NULL, NULL, 231533),
(248051, '3bomB00', NULL, NULL, 147, NULL, NULL, 231533),
(248052, '5ojcA00', NULL, NULL, 163, NULL, NULL, 231533),
(248053, '1hbrA00', NULL, NULL, 141, NULL, NULL, 231533),
(248054, '3cy5A00', NULL, NULL, 141, NULL, NULL, 231533),
(248055, '1mbsA00', NULL, NULL, 153, NULL, NULL, 231533),
(248056, '3d1aA00', NULL, NULL, 142, NULL, NULL, 231533),
(248057, '1gdjA00', NULL, NULL, 153, NULL, NULL, 231533),
(248058, '4wchD00', NULL, NULL, 140, NULL, NULL, 231533),
(248059, '1gcvB00', NULL, NULL, 136, NULL, NULL, 231533),
(248060, '2bkmA00', NULL, NULL, 128, NULL, NULL, 231533),
(248061, '2h8fB00', NULL, NULL, 146, NULL, NULL, 231533),
(248062, '1uc3A00', NULL, NULL, 149, NULL, NULL, 231533),
(248063, '2zs0A00', NULL, NULL, 140, NULL, NULL, 231533),
(248064, '4u8uC00', NULL, NULL, 151, NULL, NULL, 231533),
(248065, '5euiA00', NULL, NULL, 141, NULL, NULL, 231533),
(248066, '1hbgA00', NULL, NULL, 147, NULL, NULL, 231533),
(248067, '3g46A00', NULL, NULL, 146, NULL, NULL, 231533),
(248068, '1qpwB00', NULL, NULL, 146, NULL, NULL, 231533);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(248069, '1xq5A00', NULL, NULL, 143, NULL, NULL, 231533),
(248070, '1b0bA00', NULL, NULL, 142, NULL, NULL, 231533),
(248071, '2w72A00', NULL, NULL, 141, NULL, NULL, 231533),
(248072, '2r50D00', NULL, NULL, 165, NULL, NULL, 231533),
(248073, '2xkiA00', NULL, NULL, 110, NULL, NULL, 231533),
(248074, '2zfbA00', NULL, NULL, 141, NULL, NULL, 231533),
(248075, '3qqqB00', NULL, NULL, 168, NULL, NULL, 231533),
(248076, '2gkmA00', NULL, NULL, 136, NULL, NULL, 231533),
(248077, '5ychA00', NULL, NULL, 154, NULL, NULL, 231533),
(248078, '3d1aB00', NULL, NULL, 145, NULL, NULL, 231533),
(248079, '2bnlC00', NULL, NULL, 136, NULL, NULL, 231533),
(248080, '1q1fA00', NULL, NULL, 151, NULL, NULL, 231533),
(248081, '4mpmA00', NULL, NULL, 151, NULL, NULL, 231533),
(248082, '1h97A00', NULL, NULL, 147, NULL, NULL, 231533),
(248083, '4u8uB00', NULL, NULL, 142, NULL, NULL, 231533),
(248084, '3gdjA00', NULL, NULL, 141, NULL, NULL, 231533),
(248085, '4yu3A00', NULL, NULL, 141, NULL, NULL, 231533),
(248086, '1x9fD00', NULL, NULL, 140, NULL, NULL, 231533),
(248087, '3aq9A00', NULL, NULL, 121, NULL, NULL, 231533),
(248088, '1dlwA00', NULL, NULL, 116, NULL, NULL, 231533),
(248089, '3tm9A00', NULL, NULL, 146, NULL, NULL, 231533),
(248090, '4maxA00', NULL, NULL, 123, NULL, NULL, 231533),
(248091, '1outB00', NULL, NULL, 146, NULL, NULL, 231533),
(248092, '1ecaA00', NULL, NULL, 136, NULL, NULL, 231533),
(248093, '3vrgB00', NULL, NULL, 146, NULL, NULL, 231533),
(248094, '6iyiB00', NULL, NULL, 146, NULL, NULL, 231533),
(248095, '3wtgA00', NULL, NULL, 142, NULL, NULL, 231533),
(248096, '2zfbB00', NULL, NULL, 146, NULL, NULL, 231533),
(248097, '3mvcB00', NULL, NULL, 161, NULL, NULL, 231533),
(248098, '6ii1C00', NULL, NULL, 138, NULL, NULL, 231533),
(248099, '5kerA00', NULL, NULL, 141, NULL, NULL, 231533),
(248100, '3wctB00', NULL, NULL, 144, NULL, NULL, 231533),
(248101, '1a4fA00', NULL, NULL, 141, NULL, NULL, 231533),
(248102, '3rgkA00', NULL, NULL, 153, NULL, NULL, 231533),
(248103, '3fh9A00', NULL, NULL, 141, NULL, NULL, 231533),
(248104, '4uiqB00', NULL, NULL, 155, NULL, NULL, 231533),
(248105, '3mkbA00', NULL, NULL, 140, NULL, NULL, 231533),
(248106, '1ashA00', NULL, NULL, 150, NULL, NULL, 231533),
(248107, '1spgA00', NULL, NULL, 144, NULL, NULL, 231533),
(248108, '2r80A00', NULL, NULL, 141, NULL, NULL, 231533),
(248109, '3gqpB00', NULL, NULL, 145, NULL, NULL, 231533),
(248110, '1a4fB00', NULL, NULL, 146, NULL, NULL, 231533),
(248111, '1mbaA00', NULL, NULL, 147, NULL, NULL, 231533),
(248112, '1x9fC00', NULL, NULL, 153, NULL, NULL, 231533),
(248113, '2wy4A00', NULL, NULL, 140, NULL, NULL, 231533),
(248114, '2aa1B00', NULL, NULL, 146, NULL, NULL, 231533),
(248115, '3bj1B00', NULL, NULL, 146, NULL, NULL, 231533),
(248116, '2zs0C00', NULL, NULL, 147, NULL, NULL, 231533),
(248117, '2vywA00', NULL, NULL, 148, NULL, NULL, 231533),
(248118, '1wmuB00', NULL, NULL, 146, NULL, NULL, 231533),
(248119, '1ux8A00', NULL, NULL, 132, NULL, NULL, 231533),
(248120, '4uurA00', NULL, NULL, 124, NULL, NULL, 231533),
(248121, '1jf3A00', NULL, NULL, 147, NULL, NULL, 231533),
(248122, '5d1vA00', NULL, NULL, 127, NULL, NULL, 231533),
(248123, '4yu3B00', NULL, NULL, 146, NULL, NULL, 231533),
(248124, '2d2mD00', NULL, NULL, 145, NULL, NULL, 231533),
(248125, '1or4B00', NULL, NULL, 158, NULL, NULL, 231533),
(248126, '4hrrA00', NULL, NULL, 150, NULL, NULL, 231533),
(248127, '4c0nA00', NULL, NULL, 151, NULL, NULL, 231533),
(248128, '6bmgA00', NULL, NULL, 154, NULL, NULL, 231533),
(248129, '1cg5A00', NULL, NULL, 141, NULL, NULL, 231533),
(248130, '1hlmA00', NULL, NULL, 159, NULL, NULL, 231533),
(248131, '1outA00', NULL, NULL, 143, NULL, NULL, 231533),
(248132, '3vrgA00', NULL, NULL, 141, NULL, NULL, 231533),
(248133, '3mjpA00', NULL, NULL, 141, NULL, NULL, 231533),
(248134, '2dc3B00', NULL, NULL, 174, NULL, NULL, 231533),
(248135, '3k8bA00', NULL, NULL, 141, NULL, NULL, 231533),
(248136, '6iyiA00', NULL, NULL, 142, NULL, NULL, 231533),
(248137, '1jf4A00', NULL, NULL, 147, NULL, NULL, 231533),
(248138, '3bomA00', NULL, NULL, 143, NULL, NULL, 231533),
(248139, '2gnvB00', NULL, NULL, 165, NULL, NULL, 231533);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(248140, '3wctA00', NULL, NULL, 146, NULL, NULL, 231533),
(248141, '3lb2A00', NULL, NULL, 137, NULL, NULL, 231533),
(248142, '2raoB00', NULL, NULL, 146, NULL, NULL, 231533),
(248143, '3mkbB00', NULL, NULL, 136, NULL, NULL, 231533),
(248144, '3fh9B00', NULL, NULL, 146, NULL, NULL, 231533),
(248145, '4hrrH00', NULL, NULL, 152, NULL, NULL, 231533),
(248146, '3gqpA00', NULL, NULL, 141, NULL, NULL, 231533),
(248147, '3bcqA00', NULL, NULL, 142, NULL, NULL, 231533),
(248148, '1gcvA00', NULL, NULL, 140, NULL, NULL, 231533),
(248149, '1x9fB00', NULL, NULL, 145, NULL, NULL, 231533),
(248150, '1shrB00', NULL, NULL, 146, NULL, NULL, 231533),
(248151, '2c0kB00', NULL, NULL, 151, NULL, NULL, 231533),
(248152, '6ciiA00', NULL, NULL, 135, NULL, NULL, 231533),
(248153, '1urvA00', NULL, NULL, 154, NULL, NULL, 231533),
(248154, '2zs0B00', NULL, NULL, 142, NULL, NULL, 231533),
(248155, '2oifB00', NULL, NULL, 162, NULL, NULL, 231533),
(248156, '5v3tA00', NULL, NULL, 132, NULL, NULL, 231533),
(248157, '4nk2A01', NULL, NULL, 146, NULL, NULL, 231533),
(248158, '4twvA00', NULL, NULL, 154, NULL, NULL, 231533),
(248159, '5euiB00', NULL, NULL, 146, NULL, NULL, 231533),
(248160, '1hlbA00', NULL, NULL, 158, NULL, NULL, 231533),
(248161, '1qpwA00', NULL, NULL, 141, NULL, NULL, 231533),
(248162, '3qqrA00', NULL, NULL, 162, NULL, NULL, 231533),
(248163, '4bjaA00', NULL, NULL, 197, NULL, NULL, 231533),
(248164, '4esaA00', NULL, NULL, 143, NULL, NULL, 231533),
(248165, '3w4uA00', NULL, NULL, 142, NULL, NULL, 231533),
(248166, '5ycgA00', NULL, NULL, 157, NULL, NULL, 231533),
(248167, '3hyuB00', NULL, NULL, 146, NULL, NULL, 231533),
(248168, '1cg5B00', NULL, NULL, 141, NULL, NULL, 231533),
(248169, '3at5A00', NULL, NULL, 141, NULL, NULL, 231533),
(248170, '2w31A00', NULL, NULL, 162, NULL, NULL, 231533),
(248171, '2bk9A00', NULL, NULL, 153, NULL, NULL, 231533),
(248172, '2bmmA00', NULL, NULL, 123, NULL, NULL, 231533),
(248173, '1yhuC00', NULL, NULL, 148, NULL, NULL, 231533),
(248174, '5k1lA00', NULL, NULL, 137, NULL, NULL, 231533),
(248175, '3wctD00', NULL, NULL, 149, NULL, NULL, 231533),
(248176, '2raoA00', NULL, NULL, 141, NULL, NULL, 231533),
(248177, '1emyA00', NULL, NULL, 153, NULL, NULL, 231533),
(248178, '1x9fA00', NULL, NULL, 151, NULL, NULL, 231533),
(248179, '3bcqB00', NULL, NULL, 146, NULL, NULL, 231533),
(248180, '2lhbA00', NULL, NULL, 149, NULL, NULL, 231533),
(248181, '3ubcA00', NULL, NULL, 131, NULL, NULL, 231533),
(248182, '2nrlA00', NULL, NULL, 147, NULL, NULL, 231533),
(248183, '3wfwA00', NULL, NULL, 138, NULL, NULL, 231533),
(248184, '2d5xA00', NULL, NULL, 141, NULL, NULL, 231533),
(248185, '1x3kA01', NULL, NULL, 147, NULL, NULL, 231533),
(248186, '1v4xB00', NULL, NULL, 146, NULL, NULL, 231533),
(248187, '3pt8A00', NULL, NULL, 152, NULL, NULL, 231533),
(248188, '4esaD00', NULL, NULL, 146, NULL, NULL, 231533),
(248189, '3hyuA00', NULL, NULL, 141, NULL, NULL, 231533),
(248190, '3wtgB00', NULL, NULL, 146, NULL, NULL, 231533),
(248191, '3at5B00', NULL, NULL, 146, NULL, NULL, 231533),
(248192, '1lhsA00', NULL, NULL, 153, NULL, NULL, 231533),
(248193, '2wtgA00', NULL, NULL, 159, NULL, NULL, 231533),
(248194, '3fs4A00', NULL, NULL, 141, NULL, NULL, 231533),
(248195, '1yhuD00', NULL, NULL, 149, NULL, NULL, 231533),
(248196, '6ii1D00', NULL, NULL, 145, NULL, NULL, 231533),
(248197, '6iyhB00', NULL, NULL, 145, NULL, NULL, 231533),
(248198, '3eokA00', NULL, NULL, 141, NULL, NULL, 231533),
(248199, '3wctC00', NULL, NULL, 150, NULL, NULL, 231533),
(248200, '4g1vA01', NULL, NULL, 145, NULL, NULL, 231533),
(248201, '1spgB00', NULL, NULL, 147, NULL, NULL, 231533),
(248202, '2r80B00', NULL, NULL, 146, NULL, NULL, 231533),
(248203, '1hdsB00', NULL, NULL, 145, NULL, NULL, 231533),
(248204, '6iyhA00', NULL, NULL, 142, NULL, NULL, 231533),
(248205, '1wmuA00', NULL, NULL, 141, NULL, NULL, 231533),
(248206, '2zs0D00', NULL, NULL, 145, NULL, NULL, 231533),
(248207, '4zvaA00', NULL, NULL, 149, NULL, NULL, 231533),
(248208, '3zhwB00', NULL, NULL, 160, NULL, NULL, 231533),
(248209, '3hrwA00', NULL, NULL, 141, NULL, NULL, 231533),
(248210, '3hf4B00', NULL, NULL, 146, NULL, NULL, 231533);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(248211, '1x46A00', NULL, NULL, 150, NULL, NULL, 231533),
(248212, '3pt8B00', NULL, NULL, 152, NULL, NULL, 231533),
(248213, '1v4xA00', NULL, NULL, 144, NULL, NULL, 231533),
(248214, '1gvhA01', NULL, NULL, 148, NULL, NULL, 231533),
(248215, '4h2lB00', NULL, NULL, 146, NULL, NULL, 231533),
(248216, '3qauA03', NULL, NULL, 52, NULL, NULL, 231534),
(248217, '2wmoA01', NULL, NULL, 149, NULL, NULL, 231535),
(248218, '2yinA01', NULL, NULL, 151, NULL, NULL, 231535),
(248219, '3nw0B01', NULL, NULL, 84, NULL, NULL, 231536),
(248220, '2wa0A01', NULL, NULL, 114, NULL, NULL, 231536),
(248221, '2pffB01', NULL, NULL, 63, NULL, NULL, 231537),
(248222, '1dgfA01', NULL, NULL, 64, NULL, NULL, 231538),
(248223, '4b7hA01', NULL, NULL, 63, NULL, NULL, 231538),
(248224, '3rgpA01', NULL, NULL, 65, NULL, NULL, 231538),
(248225, '4fuqC01', NULL, NULL, 397, NULL, NULL, 231539),
(248226, '4lgcA00', NULL, NULL, 400, NULL, NULL, 231539),
(248227, '3vnrA01', NULL, NULL, 411, NULL, NULL, 231539),
(248228, '3tsyA01', NULL, NULL, 438, NULL, NULL, 231539),
(248229, '4d4iA01', NULL, NULL, 409, NULL, NULL, 231539),
(248230, '1ry2A01', NULL, NULL, 503, NULL, NULL, 231539),
(248231, '2v7bA01', NULL, NULL, 406, NULL, NULL, 231539),
(248232, '3iplB01', NULL, NULL, 396, NULL, NULL, 231539),
(248233, '3r44A01', NULL, NULL, 411, NULL, NULL, 231539),
(248234, '3wv4A00', NULL, NULL, 403, NULL, NULL, 231539),
(248235, '5jrhB01', NULL, NULL, 517, NULL, NULL, 231539),
(248236, '3qyaA00', NULL, NULL, 433, NULL, NULL, 231539),
(248237, '3fceA01', NULL, NULL, 397, NULL, NULL, 231539),
(248238, '5n81A00', NULL, NULL, 399, NULL, NULL, 231539),
(248239, '5x8fA01', NULL, NULL, 383, NULL, NULL, 231539),
(248240, '3etcA01', NULL, NULL, 449, NULL, NULL, 231539),
(248241, '4wv3B01', NULL, NULL, 412, NULL, NULL, 231539),
(248242, '5ifiC01', NULL, NULL, 506, NULL, NULL, 231539),
(248243, '4dg8A01', NULL, NULL, 403, NULL, NULL, 231539),
(248244, '5uptA01', NULL, NULL, 409, NULL, NULL, 231539),
(248245, '5n9xA01', NULL, NULL, 406, NULL, NULL, 231539),
(248246, '5gxdA01', NULL, NULL, 495, NULL, NULL, 231539),
(248247, '4rvnA01', NULL, NULL, 331, NULL, NULL, 231539),
(248248, '4gs5A01', NULL, NULL, 248, NULL, NULL, 231539),
(248249, '3iteB01', NULL, NULL, 419, NULL, NULL, 231539),
(248250, '2y4oA01', NULL, NULL, 335, NULL, NULL, 231539),
(248251, '3c5eA01', NULL, NULL, 432, NULL, NULL, 231539),
(248252, '5keiA01', NULL, NULL, 440, NULL, NULL, 231539),
(248253, '4r0mB01', NULL, NULL, 436, NULL, NULL, 231539),
(248254, '4isbA01', NULL, NULL, 424, NULL, NULL, 231539),
(248255, '3ni2A01', NULL, NULL, 433, NULL, NULL, 231539),
(248256, '3g7sB01', NULL, NULL, 437, NULL, NULL, 231539),
(248257, '3pbkB01', NULL, NULL, 459, NULL, NULL, 231539),
(248258, '3ivrA00', NULL, NULL, 397, NULL, NULL, 231539),
(248259, '3t5aA00', NULL, NULL, 457, NULL, NULL, 231539),
(248260, '3l8cB01', NULL, NULL, 401, NULL, NULL, 231539),
(248261, '4w8oB00', NULL, NULL, 427, NULL, NULL, 231539),
(248262, '3rixA00', NULL, NULL, 435, NULL, NULL, 231539),
(248263, '1v25A01', NULL, NULL, 435, NULL, NULL, 231539),
(248264, '3nyqA01', NULL, NULL, 382, NULL, NULL, 231539),
(248265, '5d6nA00', NULL, NULL, 482, NULL, NULL, 231539),
(248266, '3e7wA01', NULL, NULL, 397, NULL, NULL, 231539),
(248267, '4gr5B02', NULL, NULL, 403, NULL, NULL, 231539),
(248268, '4futA01', NULL, NULL, 394, NULL, NULL, 231539),
(248269, '4oxiA01', NULL, NULL, 419, NULL, NULL, 231539),
(248270, '4iz6B01', NULL, NULL, 430, NULL, NULL, 231539),
(248271, '5bsrA01', NULL, NULL, 436, NULL, NULL, 231539),
(248272, '2y27B01', NULL, NULL, 333, NULL, NULL, 231539),
(248273, '3o83A00', NULL, NULL, 439, NULL, NULL, 231539),
(248274, '2uuvB01', NULL, NULL, 291, NULL, NULL, 231540),
(248275, '2k3dA00', NULL, NULL, 87, NULL, NULL, 231541),
(248276, '3h95A02', NULL, NULL, 34, NULL, NULL, 231542),
(248277, '2oqrA02', NULL, NULL, 39, NULL, NULL, 231543),
(248278, '1vwxO02', NULL, NULL, 54, NULL, NULL, 231544),
(248279, '3o58P02', NULL, NULL, 50, NULL, NULL, 231544),
(248280, '3m92A01', NULL, NULL, 69, NULL, NULL, 231545),
(248281, '4didB01', NULL, NULL, 124, NULL, NULL, 231546);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(248282, '4b3fX02', NULL, NULL, 108, NULL, NULL, 231547),
(248283, '5jmcD00', NULL, NULL, 102, NULL, NULL, 231548),
(248284, '4yc5A00', NULL, NULL, 216, NULL, NULL, 231548),
(248285, '2xtyB00', NULL, NULL, 217, NULL, NULL, 231548),
(248286, '3du1X00', NULL, NULL, 238, NULL, NULL, 231548),
(248287, '2bm5B00', NULL, NULL, 186, NULL, NULL, 231548),
(248288, '3pssA00', NULL, NULL, 216, NULL, NULL, 231548),
(248289, '3n90A00', NULL, NULL, 152, NULL, NULL, 231548),
(248290, '2j8iA01', NULL, NULL, 102, NULL, NULL, 231548),
(248291, '2xt2B00', NULL, NULL, 200, NULL, NULL, 231548),
(248292, '2qyuA01', NULL, NULL, 164, NULL, NULL, 231548),
(248293, '5jlvC00', NULL, NULL, 98, NULL, NULL, 231548),
(248294, '2qzaB01', NULL, NULL, 170, NULL, NULL, 231548),
(248295, '2f3lA00', NULL, NULL, 133, NULL, NULL, 231548),
(248296, '2j8kA01', NULL, NULL, 187, NULL, NULL, 231548),
(248297, '3nb2A01', NULL, NULL, 178, NULL, NULL, 231548),
(248298, '4yfoA00', NULL, NULL, 239, NULL, NULL, 231548),
(248299, '2w7zA00', NULL, NULL, 214, NULL, NULL, 231548),
(248300, '5moyB00', NULL, NULL, 111, NULL, NULL, 231548),
(248301, '5dnsA00', NULL, NULL, 227, NULL, NULL, 231548),
(248302, '1y8xB00', NULL, NULL, 98, NULL, NULL, 231549),
(248303, '1y8qD03', NULL, NULL, 105, NULL, NULL, 231549),
(248304, '5fq2B00', NULL, NULL, 105, NULL, NULL, 231549),
(248305, '3kycB03', NULL, NULL, 138, NULL, NULL, 231549),
(248306, '3onhA01', NULL, NULL, 122, NULL, NULL, 231549),
(248307, '3eg5B01', NULL, NULL, 55, NULL, NULL, 231550),
(248308, '4b0eD00', NULL, NULL, 119, NULL, NULL, 231551),
(248309, '1ze3D00', NULL, NULL, 125, NULL, NULL, 231551),
(248310, '3rfzB01', NULL, NULL, 96, NULL, NULL, 231551),
(248311, '1nbwA03', NULL, NULL, 154, NULL, NULL, 231552),
(248312, '2d0oA03', NULL, NULL, 151, NULL, NULL, 231552),
(248313, '3vepC00', NULL, NULL, 58, NULL, NULL, 231553),
(248314, '1t6aA02', NULL, NULL, 80, NULL, NULL, 231554),
(248315, '1bbgA00', NULL, NULL, 40, NULL, NULL, 231555),
(248316, '1z3xA01', NULL, NULL, 162, NULL, NULL, 231556),
(248317, '4xkbA01', NULL, NULL, 154, NULL, NULL, 231556),
(248318, '1tuwA00', NULL, NULL, 109, NULL, NULL, 231557),
(248319, '6g2jF04', NULL, NULL, 96, NULL, NULL, 231558),
(248320, '3i9v104', NULL, NULL, 103, NULL, NULL, 231558),
(248321, '2w82A02', NULL, NULL, 42, NULL, NULL, 231559),
(248322, '3bu2A02', NULL, NULL, 72, NULL, NULL, 231560),
(248323, '2qqpD00', NULL, NULL, 40, NULL, NULL, 231561),
(248324, '2wl8C00', NULL, NULL, 126, NULL, NULL, 231562),
(248325, '2b1eA02', NULL, NULL, 168, NULL, NULL, 231563),
(248326, '1zkdA03', NULL, NULL, 43, NULL, NULL, 231564),
(248327, '2mvgA01', NULL, NULL, 146, NULL, NULL, 231565),
(248328, '4onrA00', NULL, NULL, 166, NULL, NULL, 231565),
(248329, '2lquA01', NULL, NULL, 154, NULL, NULL, 231565),
(248330, '2mtdA00', NULL, NULL, 164, NULL, NULL, 231565),
(248331, '2mtcA00', NULL, NULL, 166, NULL, NULL, 231565),
(248332, '5ls9B00', NULL, NULL, 173, NULL, NULL, 231566),
(248333, '2yjkC00', NULL, NULL, 161, NULL, NULL, 231566),
(248334, '1rcdA00', NULL, NULL, 173, NULL, NULL, 231566),
(248335, '3oghB00', NULL, NULL, 171, NULL, NULL, 231566),
(248336, '5ux1D00', NULL, NULL, 197, NULL, NULL, 231566),
(248337, '3kxuA00', NULL, NULL, 157, NULL, NULL, 231566),
(248338, '3qz3A00', NULL, NULL, 184, NULL, NULL, 231566),
(248339, '1r03A00', NULL, NULL, 182, NULL, NULL, 231566),
(248340, '2gyqA00', NULL, NULL, 173, NULL, NULL, 231566),
(248341, '1lb3A00', NULL, NULL, 182, NULL, NULL, 231566),
(248342, '5lbhA00', NULL, NULL, 145, NULL, NULL, 231566),
(248343, '1ji5A00', NULL, NULL, 142, NULL, NULL, 231566),
(248344, '3fseB02', NULL, NULL, 144, NULL, NULL, 231566),
(248345, '4cvrA00', NULL, NULL, 159, NULL, NULL, 231566),
(248346, '1j30A00', NULL, NULL, 144, NULL, NULL, 231566),
(248347, '2rbdA01', NULL, NULL, 157, NULL, NULL, 231566),
(248348, '2c2uA00', NULL, NULL, 178, NULL, NULL, 231566),
(248349, '1s3qB00', NULL, NULL, 173, NULL, NULL, 231566),
(248350, '1s3qF00', NULL, NULL, 173, NULL, NULL, 231566),
(248351, '4mudC00', NULL, NULL, 235, NULL, NULL, 231566),
(248352, '1sq3J00', NULL, NULL, 173, NULL, NULL, 231566);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(248353, '1s3qJ00', NULL, NULL, 173, NULL, NULL, 231566),
(248354, '2fkzA00', NULL, NULL, 155, NULL, NULL, 231566),
(248355, '1sq3F00', NULL, NULL, 173, NULL, NULL, 231566),
(248356, '1jgcA00', NULL, NULL, 161, NULL, NULL, 231566),
(248357, '3kx9A00', NULL, NULL, 173, NULL, NULL, 231566),
(248358, '1sq3A00', NULL, NULL, 173, NULL, NULL, 231566),
(248359, '2bk6C00', NULL, NULL, 156, NULL, NULL, 231566),
(248360, '6nlfA00', NULL, NULL, 158, NULL, NULL, 231566),
(248361, '4eveA00', NULL, NULL, 144, NULL, NULL, 231566),
(248362, '5u1aL00', NULL, NULL, 182, NULL, NULL, 231566),
(248363, '4a25B01', NULL, NULL, 161, NULL, NULL, 231566),
(248364, '3hiuC00', NULL, NULL, 166, NULL, NULL, 231566),
(248365, '5j93A00', NULL, NULL, 176, NULL, NULL, 231566),
(248366, '5zurB00', NULL, NULL, 158, NULL, NULL, 231566),
(248367, '2d5kB00', NULL, NULL, 156, NULL, NULL, 231566),
(248368, '2wluA00', NULL, NULL, 175, NULL, NULL, 231566),
(248369, '3wnwA00', NULL, NULL, 173, NULL, NULL, 231566),
(248370, '3q4oA00', NULL, NULL, 174, NULL, NULL, 231566),
(248371, '5uwzA01', NULL, NULL, 229, NULL, NULL, 231566),
(248372, '3vnxA00', NULL, NULL, 204, NULL, NULL, 231566),
(248373, '4z5sA01', NULL, NULL, 218, NULL, NULL, 231566),
(248374, '1s3qC00', NULL, NULL, 173, NULL, NULL, 231566),
(248375, '3uoiA00', NULL, NULL, 161, NULL, NULL, 231566),
(248376, '2jd6000', NULL, NULL, 174, NULL, NULL, 231566),
(248377, '3iq1B00', NULL, NULL, 159, NULL, NULL, 231566),
(248378, '3ge4A00', NULL, NULL, 173, NULL, NULL, 231566),
(248379, '1s3qG00', NULL, NULL, 173, NULL, NULL, 231566),
(248380, '4eruA00', NULL, NULL, 170, NULL, NULL, 231566),
(248381, '1sq3I00', NULL, NULL, 173, NULL, NULL, 231566),
(248382, '1s3qK00', NULL, NULL, 173, NULL, NULL, 231566),
(248383, '3gvyB00', NULL, NULL, 161, NULL, NULL, 231566),
(248384, '1sq3E00', NULL, NULL, 173, NULL, NULL, 231566),
(248385, '1zujA00', NULL, NULL, 179, NULL, NULL, 231566),
(248386, '2c2jA00', NULL, NULL, 170, NULL, NULL, 231566),
(248387, '2cf7A00', NULL, NULL, 165, NULL, NULL, 231566),
(248388, '3a9qE00', NULL, NULL, 183, NULL, NULL, 231566),
(248389, '3bt5A00', NULL, NULL, 159, NULL, NULL, 231566),
(248390, '1krqA00', NULL, NULL, 167, NULL, NULL, 231566),
(248391, '5k52A01', NULL, NULL, 220, NULL, NULL, 231566),
(248392, '4cmyA00', NULL, NULL, 163, NULL, NULL, 231566),
(248393, '1nfvA00', NULL, NULL, 179, NULL, NULL, 231566),
(248394, '4am5A00', NULL, NULL, 159, NULL, NULL, 231566),
(248395, '3hiuD00', NULL, NULL, 166, NULL, NULL, 231566),
(248396, '2z6mA00', NULL, NULL, 176, NULL, NULL, 231566),
(248397, '3qhbA00', NULL, NULL, 179, NULL, NULL, 231566),
(248398, '4rc8A01', NULL, NULL, 218, NULL, NULL, 231566),
(248399, '5hjfA00', NULL, NULL, 185, NULL, NULL, 231566),
(248400, '2pybA00', NULL, NULL, 151, NULL, NULL, 231566),
(248401, '5gouA00', NULL, NULL, 173, NULL, NULL, 231566),
(248402, '3pvtB00', NULL, NULL, 259, NULL, NULL, 231566),
(248403, '3ez0C00', NULL, NULL, 225, NULL, NULL, 231566),
(248404, '6b0dA00', NULL, NULL, 166, NULL, NULL, 231566),
(248405, '1jigA00', NULL, NULL, 146, NULL, NULL, 231566),
(248406, '4m32A01', NULL, NULL, 156, NULL, NULL, 231566),
(248407, '2qqyA00', NULL, NULL, 149, NULL, NULL, 231566),
(248408, '3unoE00', NULL, NULL, 189, NULL, NULL, 231566),
(248409, '2yw6B00', NULL, NULL, 160, NULL, NULL, 231566),
(248410, '4r42A01', NULL, NULL, 187, NULL, NULL, 231566),
(248411, '4di0B00', NULL, NULL, 144, NULL, NULL, 231566),
(248412, '5uxiA01', NULL, NULL, 220, NULL, NULL, 231566),
(248413, '2fzfA01', NULL, NULL, 150, NULL, NULL, 231566),
(248414, '1s3qD00', NULL, NULL, 173, NULL, NULL, 231566),
(248415, '1sq3L00', NULL, NULL, 173, NULL, NULL, 231566),
(248416, '1s3qH00', NULL, NULL, 173, NULL, NULL, 231566),
(248417, '4dyxA00', NULL, NULL, 172, NULL, NULL, 231566),
(248418, '1sq3H00', NULL, NULL, 173, NULL, NULL, 231566),
(248419, '1s3qL00', NULL, NULL, 173, NULL, NULL, 231566),
(248420, '1sq3D00', NULL, NULL, 173, NULL, NULL, 231566),
(248421, '1sq3C00', NULL, NULL, 173, NULL, NULL, 231566),
(248422, '3bknA00', NULL, NULL, 161, NULL, NULL, 231566),
(248423, '1yuzB01', NULL, NULL, 138, NULL, NULL, 231566);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(248424, '3kwoA00', NULL, NULL, 152, NULL, NULL, 231566),
(248425, '4cy9A00', NULL, NULL, 168, NULL, NULL, 231566),
(248426, '6b8fA00', NULL, NULL, 182, NULL, NULL, 231566),
(248427, '4y08A00', NULL, NULL, 183, NULL, NULL, 231566),
(248428, '2vzbB00', NULL, NULL, 170, NULL, NULL, 231566),
(248429, '3ezuA01', NULL, NULL, 183, NULL, NULL, 231566),
(248430, '1bg7A00', NULL, NULL, 176, NULL, NULL, 231566),
(248431, '2qf9B01', NULL, NULL, 169, NULL, NULL, 231566),
(248432, '3hiuA00', NULL, NULL, 166, NULL, NULL, 231566),
(248433, '4dyuH00', NULL, NULL, 170, NULL, NULL, 231566),
(248434, '1zs3A00', NULL, NULL, 182, NULL, NULL, 231566),
(248435, '4iwkA00', NULL, NULL, 168, NULL, NULL, 231566),
(248436, '3hl1B01', NULL, NULL, 252, NULL, NULL, 231566),
(248437, '3pvtA00', NULL, NULL, 311, NULL, NULL, 231566),
(248438, '2wtlA00', NULL, NULL, 173, NULL, NULL, 231566),
(248439, '5xx9A00', NULL, NULL, 167, NULL, NULL, 231566),
(248440, '5wpnA00', NULL, NULL, 171, NULL, NULL, 231566),
(248441, '1o9rA00', NULL, NULL, 162, NULL, NULL, 231566),
(248442, '2za8A00', NULL, NULL, 167, NULL, NULL, 231566),
(248443, '3fvbA00', NULL, NULL, 163, NULL, NULL, 231566),
(248444, '6a4uA00', NULL, NULL, 169, NULL, NULL, 231566),
(248445, '2ib0A01', NULL, NULL, 135, NULL, NULL, 231566),
(248446, '4cybD00', NULL, NULL, 173, NULL, NULL, 231566),
(248447, '1z6oM00', NULL, NULL, 191, NULL, NULL, 231566),
(248448, '4etrB00', NULL, NULL, 153, NULL, NULL, 231566),
(248449, '2oh3A01', NULL, NULL, 150, NULL, NULL, 231566),
(248450, '2itbB00', NULL, NULL, 206, NULL, NULL, 231566),
(248451, '3ak8F00', NULL, NULL, 167, NULL, NULL, 231566),
(248452, '1n1qA00', NULL, NULL, 149, NULL, NULL, 231566),
(248453, '2gs4A00', NULL, NULL, 166, NULL, NULL, 231566),
(248454, '5k53A01', NULL, NULL, 217, NULL, NULL, 231566),
(248455, '2c41C01', NULL, NULL, 150, NULL, NULL, 231566),
(248456, '1s3qA00', NULL, NULL, 173, NULL, NULL, 231566),
(248457, '1lkoA01', NULL, NULL, 146, NULL, NULL, 231566),
(248458, '1s3qE00', NULL, NULL, 173, NULL, NULL, 231566),
(248459, '1vjxA00', NULL, NULL, 157, NULL, NULL, 231566),
(248460, '5ffdA00', NULL, NULL, 154, NULL, NULL, 231566),
(248461, '1tjoB00', NULL, NULL, 182, NULL, NULL, 231566),
(248462, '1sq3K00', NULL, NULL, 173, NULL, NULL, 231566),
(248463, '2vxxA00', NULL, NULL, 176, NULL, NULL, 231566),
(248464, '1s3qI00', NULL, NULL, 173, NULL, NULL, 231566),
(248465, '2v8tA01', NULL, NULL, 301, NULL, NULL, 231566),
(248466, '1sq3G00', NULL, NULL, 173, NULL, NULL, 231566),
(248467, '2oc5A01', NULL, NULL, 217, NULL, NULL, 231566),
(248468, '1sq3B00', NULL, NULL, 173, NULL, NULL, 231566),
(248469, '3bvfA00', NULL, NULL, 181, NULL, NULL, 231566),
(248470, '5jklA00', NULL, NULL, 183, NULL, NULL, 231566),
(248471, '5ux2B01', NULL, NULL, 227, NULL, NULL, 231566),
(248472, '3pwfA01', NULL, NULL, 131, NULL, NULL, 231566),
(248473, '1vlgA00', NULL, NULL, 176, NULL, NULL, 231566),
(248474, '5gouG00', NULL, NULL, 137, NULL, NULL, 231566),
(248475, '3r2kA00', NULL, NULL, 154, NULL, NULL, 231566),
(248476, '3hiuB00', NULL, NULL, 166, NULL, NULL, 231566),
(248477, '1z6oA00', NULL, NULL, 212, NULL, NULL, 231566),
(248478, '1jkvA01', NULL, NULL, 197, NULL, NULL, 231566),
(248479, '2qf9A01', NULL, NULL, 169, NULL, NULL, 231566),
(248480, '4zttE00', NULL, NULL, 166, NULL, NULL, 231566),
(248481, '6ippA00', NULL, NULL, 176, NULL, NULL, 231566),
(248482, '2v2pA00', NULL, NULL, 174, NULL, NULL, 231566),
(248483, '2fjcB00', NULL, NULL, 156, NULL, NULL, 231566),
(248484, '2chpA00', NULL, NULL, 153, NULL, NULL, 231566),
(248485, '2clbA01', NULL, NULL, 159, NULL, NULL, 231566),
(248486, '3jckC00', NULL, NULL, 381, NULL, NULL, 231567),
(248487, '4lctB00', NULL, NULL, 348, NULL, NULL, 231567),
(248488, '3txnA00', NULL, NULL, 362, NULL, NULL, 231567),
(248489, '4g1qA01', NULL, NULL, 133, NULL, NULL, 231568),
(248490, '5c24A01', NULL, NULL, 129, NULL, NULL, 231568),
(248491, '1lweB01', NULL, NULL, 139, NULL, NULL, 231568),
(248492, '6mihA02', NULL, NULL, 92, NULL, NULL, 231568),
(248493, '4ol8B02', NULL, NULL, 125, NULL, NULL, 231568),
(248494, '1c9rA01', NULL, NULL, 131, NULL, NULL, 231568);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(248495, '1harA01', NULL, NULL, 134, NULL, NULL, 231568),
(248496, '1mu2B01', NULL, NULL, 126, NULL, NULL, 231568),
(248497, '3dlkB01', NULL, NULL, 128, NULL, NULL, 231568),
(248498, '4rw6A01', NULL, NULL, 131, NULL, NULL, 231568),
(248499, '3dlkA01', NULL, NULL, 132, NULL, NULL, 231568),
(248500, '3kliA01', NULL, NULL, 133, NULL, NULL, 231568),
(248501, '4g1qB01', NULL, NULL, 131, NULL, NULL, 231568),
(248502, '2qkdA03', NULL, NULL, 51, NULL, NULL, 231569),
(248503, '2qkdA01', NULL, NULL, 58, NULL, NULL, 231569),
(248504, '4ogrL00', NULL, NULL, 75, NULL, NULL, 231570),
(248505, '3ug9A03', NULL, NULL, 39, NULL, NULL, 231571),
(248506, '1vibA00', NULL, NULL, 55, NULL, NULL, 231572),
(248507, '5xluB01', NULL, NULL, 179, NULL, NULL, 231573),
(248508, '2dg5B00', NULL, NULL, 190, NULL, NULL, 231573),
(248509, '4gdxB00', NULL, NULL, 195, NULL, NULL, 231573),
(248510, '2qmcB00', NULL, NULL, 188, NULL, NULL, 231573),
(248511, '5hftD00', NULL, NULL, 187, NULL, NULL, 231573),
(248512, '3g9kS01', NULL, NULL, 174, NULL, NULL, 231573),
(248513, '3whrB01', NULL, NULL, 179, NULL, NULL, 231573),
(248514, '5zjgB00', NULL, NULL, 194, NULL, NULL, 231573),
(248515, '2oxlA00', NULL, NULL, 64, NULL, NULL, 231574),
(248516, '2w02B06', NULL, NULL, 92, NULL, NULL, 231575),
(248517, '2lzrA00', NULL, NULL, 55, NULL, NULL, 231576),
(248518, '2mn6A00', NULL, NULL, 50, NULL, NULL, 231576),
(248519, '2l16A00', NULL, NULL, 52, NULL, NULL, 231576),
(248520, '3nd0A00', NULL, NULL, 425, NULL, NULL, 231577),
(248521, '4eneB00', NULL, NULL, 446, NULL, NULL, 231577),
(248522, '3orgA01', NULL, NULL, 444, NULL, NULL, 231577),
(248523, '1kplA00', NULL, NULL, 443, NULL, NULL, 231577),
(248524, '2ykoA03', NULL, NULL, 84, NULL, NULL, 231578),
(248525, '2jrbA00', NULL, NULL, 88, NULL, NULL, 231578),
(248526, '3sooA01', NULL, NULL, 71, NULL, NULL, 231578),
(248527, '3sooB01', NULL, NULL, 71, NULL, NULL, 231578),
(248528, '3sooC01', NULL, NULL, 71, NULL, NULL, 231578),
(248529, '1np6A02', NULL, NULL, 27, NULL, NULL, 231579),
(248530, '2ikbB00', NULL, NULL, 167, NULL, NULL, 231580),
(248531, '1chkA01', NULL, NULL, 143, NULL, NULL, 231580),
(248532, '4oltB01', NULL, NULL, 153, NULL, NULL, 231580),
(248533, '4ilyA01', NULL, NULL, 155, NULL, NULL, 231580),
(248534, '5hwaA02', NULL, NULL, 111, NULL, NULL, 231580),
(248535, '2nr7A00', NULL, NULL, 195, NULL, NULL, 231580),
(248536, '2w9mA04', NULL, NULL, 55, NULL, NULL, 231581),
(248537, '1zqwA03', NULL, NULL, 69, NULL, NULL, 231581),
(248538, '5hrbA02', NULL, NULL, 69, NULL, NULL, 231581),
(248539, '2fmpA04', NULL, NULL, 64, NULL, NULL, 231581),
(248540, '5vzaA04', NULL, NULL, 69, NULL, NULL, 231581),
(248541, '2ihmA04', NULL, NULL, 69, NULL, NULL, 231581),
(248542, '3b0xA04', NULL, NULL, 65, NULL, NULL, 231581),
(248543, '3c5gB04', NULL, NULL, 67, NULL, NULL, 231581),
(248544, '4p4mA03', NULL, NULL, 101, NULL, NULL, 231581),
(248545, '2bcqA04', NULL, NULL, 67, NULL, NULL, 231581),
(248546, '3uxoA04', NULL, NULL, 64, NULL, NULL, 231581),
(248547, '4i2aA04', NULL, NULL, 70, NULL, NULL, 231581),
(248548, '3m7vA02', NULL, NULL, 121, NULL, NULL, 231582),
(248549, '3ot9A02', NULL, NULL, 119, NULL, NULL, 231582),
(248550, '2p11A02', NULL, NULL, 75, NULL, NULL, 231583),
(248551, '1yg9A01', NULL, NULL, 74, NULL, NULL, 231584),
(248552, '3sjrB00', NULL, NULL, 126, NULL, NULL, 231585),
(248553, '4hn9A03', NULL, NULL, 101, NULL, NULL, 231586),
(248554, '5m29A02', NULL, NULL, 126, NULL, NULL, 231586),
(248555, '6allB01', NULL, NULL, 106, NULL, NULL, 231586),
(248556, '3r5tA01', NULL, NULL, 116, NULL, NULL, 231586),
(248557, '3be6A02', NULL, NULL, 181, NULL, NULL, 231586),
(248558, '3be6A01', NULL, NULL, 116, NULL, NULL, 231586),
(248559, '3r5tA02', NULL, NULL, 189, NULL, NULL, 231586),
(248560, '4pm4A01', NULL, NULL, 135, NULL, NULL, 231586),
(248561, '5khlB01', NULL, NULL, 135, NULL, NULL, 231586),
(248562, '4fkmA01', NULL, NULL, 90, NULL, NULL, 231586),
(248563, '4hn9A01', NULL, NULL, 130, NULL, NULL, 231586),
(248564, '4fkmA02', NULL, NULL, 171, NULL, NULL, 231586),
(248565, '3lhsA01', NULL, NULL, 112, NULL, NULL, 231586);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(248566, '5jg7B00', NULL, NULL, 160, NULL, NULL, 231586),
(248567, '3pdiB02', NULL, NULL, 123, NULL, NULL, 231586),
(248568, '6an0A02', NULL, NULL, 193, NULL, NULL, 231586),
(248569, '6an0A01', NULL, NULL, 155, NULL, NULL, 231586),
(248570, '3pdiB01', NULL, NULL, 145, NULL, NULL, 231586),
(248571, '4cl2A01', NULL, NULL, 155, NULL, NULL, 231586),
(248572, '4oxrA01', NULL, NULL, 155, NULL, NULL, 231586),
(248573, '4cl2A02', NULL, NULL, 115, NULL, NULL, 231586),
(248574, '4oxrA02', NULL, NULL, 130, NULL, NULL, 231586),
(248575, '3eixA02', NULL, NULL, 184, NULL, NULL, 231586),
(248576, '3ujpA02', NULL, NULL, 115, NULL, NULL, 231586),
(248577, '3tlkB02', NULL, NULL, 181, NULL, NULL, 231586),
(248578, '3cx3B01', NULL, NULL, 175, NULL, NULL, 231586),
(248579, '2xdqB04', NULL, NULL, 94, NULL, NULL, 231586),
(248580, '1toaA01', NULL, NULL, 143, NULL, NULL, 231586),
(248581, '1toaA02', NULL, NULL, 131, NULL, NULL, 231586),
(248582, '2xdqB01', NULL, NULL, 147, NULL, NULL, 231586),
(248583, '2xdqB02', NULL, NULL, 90, NULL, NULL, 231586),
(248584, '4wesA03', NULL, NULL, 112, NULL, NULL, 231586),
(248585, '4wesA02', NULL, NULL, 143, NULL, NULL, 231586),
(248586, '4m7oA02', NULL, NULL, 134, NULL, NULL, 231586),
(248587, '4m7oA01', NULL, NULL, 125, NULL, NULL, 231586),
(248588, '1qguA03', NULL, NULL, 114, NULL, NULL, 231586),
(248589, '1qguA01', NULL, NULL, 196, NULL, NULL, 231586),
(248590, '1qguA02', NULL, NULL, 143, NULL, NULL, 231586),
(248591, '4pm4B02', NULL, NULL, 166, NULL, NULL, 231586),
(248592, '5jpdA01', NULL, NULL, 159, NULL, NULL, 231586),
(248593, '4inoA01', NULL, NULL, 136, NULL, NULL, 231586),
(248594, '5jpdA02', NULL, NULL, 131, NULL, NULL, 231586),
(248595, '4inoA02', NULL, NULL, 166, NULL, NULL, 231586),
(248596, '3tnyA01', NULL, NULL, 107, NULL, NULL, 231586),
(248597, '3tnyA02', NULL, NULL, 180, NULL, NULL, 231586),
(248598, '2etvA02', NULL, NULL, 197, NULL, NULL, 231586),
(248599, '2etvA01', NULL, NULL, 149, NULL, NULL, 231586),
(248600, '1efdN02', NULL, NULL, 174, NULL, NULL, 231586),
(248601, '4mdyA02', NULL, NULL, 149, NULL, NULL, 231586),
(248602, '3md9A01', NULL, NULL, 122, NULL, NULL, 231586),
(248603, '4mdyA01', NULL, NULL, 146, NULL, NULL, 231586),
(248604, '1efdN01', NULL, NULL, 92, NULL, NULL, 231586),
(248605, '2r7aB01', NULL, NULL, 122, NULL, NULL, 231586),
(248606, '2ynmD01', NULL, NULL, 147, NULL, NULL, 231586),
(248607, '2x4lA02', NULL, NULL, 149, NULL, NULL, 231586),
(248608, '3md9A02', NULL, NULL, 133, NULL, NULL, 231586),
(248609, '3pdiA01', NULL, NULL, 154, NULL, NULL, 231586),
(248610, '3tefA01', NULL, NULL, 188, NULL, NULL, 231586),
(248611, '2x4lA01', NULL, NULL, 139, NULL, NULL, 231586),
(248612, '3tefA02', NULL, NULL, 104, NULL, NULL, 231586),
(248613, '3mfqA02', NULL, NULL, 135, NULL, NULL, 231586),
(248614, '3mfqA01', NULL, NULL, 145, NULL, NULL, 231586),
(248615, '4mx8A02', NULL, NULL, 112, NULL, NULL, 231586),
(248616, '3cx3A02', NULL, NULL, 109, NULL, NULL, 231586),
(248617, '4fkmB02', NULL, NULL, 171, NULL, NULL, 231586),
(248618, '5m3bB01', NULL, NULL, 120, NULL, NULL, 231586),
(248619, '5w56B02', NULL, NULL, 128, NULL, NULL, 231586),
(248620, '5w56B01', NULL, NULL, 156, NULL, NULL, 231586),
(248621, '5uxsA01', NULL, NULL, 153, NULL, NULL, 231586),
(248622, '1kaeA02', NULL, NULL, 192, NULL, NULL, 231586),
(248623, '1kaeA01', NULL, NULL, 157, NULL, NULL, 231586),
(248624, '3gfvA02', NULL, NULL, 103, NULL, NULL, 231586),
(248625, '5ggyA01', NULL, NULL, 103, NULL, NULL, 231586),
(248626, '3g9qA02', NULL, NULL, 164, NULL, NULL, 231586),
(248627, '1qguB02', NULL, NULL, 105, NULL, NULL, 231586),
(248628, '1qguB03', NULL, NULL, 106, NULL, NULL, 231586),
(248629, '4mlzA02', NULL, NULL, 175, NULL, NULL, 231586),
(248630, '1qguB01', NULL, NULL, 144, NULL, NULL, 231586),
(248631, '3aekC01', NULL, NULL, 156, NULL, NULL, 231586),
(248632, '4mlzA01', NULL, NULL, 126, NULL, NULL, 231586),
(248633, '5cr9A02', NULL, NULL, 177, NULL, NULL, 231586),
(248634, '5cr9A01', NULL, NULL, 134, NULL, NULL, 231586),
(248635, '5n6yA01', NULL, NULL, 194, NULL, NULL, 231586),
(248636, '4k3vA01', NULL, NULL, 158, NULL, NULL, 231586);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(248637, '4ljsA02', NULL, NULL, 146, NULL, NULL, 231586),
(248638, '1h1lD03', NULL, NULL, 133, NULL, NULL, 231586),
(248639, '5kohC01', NULL, NULL, 217, NULL, NULL, 231586),
(248640, '4b8yA02', NULL, NULL, 165, NULL, NULL, 231586),
(248641, '4ljsA01', NULL, NULL, 177, NULL, NULL, 231586),
(248642, '5mbqB01', NULL, NULL, 189, NULL, NULL, 231586),
(248643, '5ad1A02', NULL, NULL, 102, NULL, NULL, 231586),
(248644, '3pdiH04', NULL, NULL, 125, NULL, NULL, 231586),
(248645, '2etvB01', NULL, NULL, 149, NULL, NULL, 231586),
(248646, '2etvB02', NULL, NULL, 197, NULL, NULL, 231586),
(248647, '6mflA02', NULL, NULL, 104, NULL, NULL, 231586),
(248648, '3u7qA01', NULL, NULL, 197, NULL, NULL, 231586),
(248649, '3u7qA02', NULL, NULL, 143, NULL, NULL, 231586),
(248650, '3u7qA03', NULL, NULL, 115, NULL, NULL, 231586),
(248651, '4pagA01', NULL, NULL, 137, NULL, NULL, 231586),
(248652, '4pagA03', NULL, NULL, 104, NULL, NULL, 231586),
(248653, '2ynmC01', NULL, NULL, 164, NULL, NULL, 231586),
(248654, '2ynmC02', NULL, NULL, 139, NULL, NULL, 231586),
(248655, '2r7aA02', NULL, NULL, 134, NULL, NULL, 231586),
(248656, '4g07A01', NULL, NULL, 158, NULL, NULL, 231586),
(248657, '3pshA02', NULL, NULL, 161, NULL, NULL, 231586),
(248658, '2o1eA02', NULL, NULL, 124, NULL, NULL, 231586),
(248659, '3pshA01', NULL, NULL, 165, NULL, NULL, 231586),
(248660, '4nnoA02', NULL, NULL, 130, NULL, NULL, 231586),
(248661, '3hh8A01', NULL, NULL, 163, NULL, NULL, 231586),
(248662, '3hh8A02', NULL, NULL, 131, NULL, NULL, 231586),
(248663, '4n01B01', NULL, NULL, 117, NULL, NULL, 231586),
(248664, '5gj3A01', NULL, NULL, 126, NULL, NULL, 231586),
(248665, '4nnoA01', NULL, NULL, 161, NULL, NULL, 231586),
(248666, '1l5hA02', NULL, NULL, 148, NULL, NULL, 231586),
(248667, '2wi8A01', NULL, NULL, 126, NULL, NULL, 231586),
(248668, '2wi8A02', NULL, NULL, 169, NULL, NULL, 231586),
(248669, '4gicA01', NULL, NULL, 143, NULL, NULL, 231586),
(248670, '4wesC01', NULL, NULL, 240, NULL, NULL, 231586),
(248671, '4gicA02', NULL, NULL, 239, NULL, NULL, 231586),
(248672, '3aekB01', NULL, NULL, 137, NULL, NULL, 231586),
(248673, '3gfvB01', NULL, NULL, 200, NULL, NULL, 231586),
(248674, '2ynmD02', NULL, NULL, 123, NULL, NULL, 231586),
(248675, '2ynmD03', NULL, NULL, 181, NULL, NULL, 231586),
(248676, '3aekB02', NULL, NULL, 90, NULL, NULL, 231586),
(248677, '3aekB04', NULL, NULL, 94, NULL, NULL, 231586),
(248678, '2q8pA02', NULL, NULL, 172, NULL, NULL, 231586),
(248679, '5kohB02', NULL, NULL, 103, NULL, NULL, 231586),
(248680, '3gi1B01', NULL, NULL, 177, NULL, NULL, 231586),
(248681, '5kohB01', NULL, NULL, 144, NULL, NULL, 231586),
(248682, '5kohB04', NULL, NULL, 99, NULL, NULL, 231586),
(248683, '2q8pA01', NULL, NULL, 88, NULL, NULL, 231586),
(248684, '1pq4A02', NULL, NULL, 105, NULL, NULL, 231586),
(248685, '2r79A02', NULL, NULL, 157, NULL, NULL, 231586),
(248686, '1pq4A01', NULL, NULL, 152, NULL, NULL, 231586),
(248687, '2r79A01', NULL, NULL, 122, NULL, NULL, 231586),
(248688, '4g09A02', NULL, NULL, 192, NULL, NULL, 231586),
(248689, '3zk9A02', NULL, NULL, 131, NULL, NULL, 231586),
(248690, '3zk9A01', NULL, NULL, 147, NULL, NULL, 231586),
(248691, '5flyA02', NULL, NULL, 167, NULL, NULL, 231586),
(248692, '3u7qB01', NULL, NULL, 146, NULL, NULL, 231586),
(248693, '3u7qB02', NULL, NULL, 105, NULL, NULL, 231586),
(248694, '5vlcE02', NULL, NULL, 193, NULL, NULL, 231586),
(248695, '3u7qB04', NULL, NULL, 106, NULL, NULL, 231586),
(248696, '5vlcA01', NULL, NULL, 158, NULL, NULL, 231586),
(248697, '5gizA02', NULL, NULL, 142, NULL, NULL, 231586),
(248698, '2o1eB01', NULL, NULL, 168, NULL, NULL, 231586),
(248699, '3tlkA01', NULL, NULL, 119, NULL, NULL, 231586),
(248700, '4mx8C01', NULL, NULL, 203, NULL, NULL, 231586),
(248701, '4n01A01', NULL, NULL, 117, NULL, NULL, 231586),
(248702, '3ujpB01', NULL, NULL, 153, NULL, NULL, 231586),
(248703, '4h0fA02', NULL, NULL, 109, NULL, NULL, 231586),
(248704, '4n01A02', NULL, NULL, 179, NULL, NULL, 231586),
(248705, '3mwfA02', NULL, NULL, 188, NULL, NULL, 231586),
(248706, '2xdqA02', NULL, NULL, 136, NULL, NULL, 231586),
(248707, '2xdqA03', NULL, NULL, 153, NULL, NULL, 231586);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(248708, '3mwfA01', NULL, NULL, 110, NULL, NULL, 231586),
(248709, '5yscA02', NULL, NULL, 132, NULL, NULL, 231586),
(248710, '5yscA01', NULL, NULL, 123, NULL, NULL, 231586),
(248711, '4wesB02', NULL, NULL, 104, NULL, NULL, 231586),
(248712, '4h59A02', NULL, NULL, 166, NULL, NULL, 231586),
(248713, '4jccA01', NULL, NULL, 182, NULL, NULL, 231586),
(248714, '3aekA02', NULL, NULL, 139, NULL, NULL, 231586),
(248715, '4wesB01', NULL, NULL, 141, NULL, NULL, 231586),
(248716, '4h59A01', NULL, NULL, 141, NULL, NULL, 231586),
(248717, '4jccA02', NULL, NULL, 104, NULL, NULL, 231586),
(248718, '4wesB04', NULL, NULL, 98, NULL, NULL, 231586),
(248719, '6feaB01', NULL, NULL, 146, NULL, NULL, 231586),
(248720, '5joqA02', NULL, NULL, 172, NULL, NULL, 231586),
(248721, '2ogwA01', NULL, NULL, 170, NULL, NULL, 231586),
(248722, '2ynmC03', NULL, NULL, 123, NULL, NULL, 231586),
(248723, '5gizA01', NULL, NULL, 129, NULL, NULL, 231586),
(248724, '3aekA03', NULL, NULL, 123, NULL, NULL, 231586),
(248725, '2prsA02', NULL, NULL, 114, NULL, NULL, 231586),
(248726, '5joqA01', NULL, NULL, 86, NULL, NULL, 231586),
(248727, '5kohA03', NULL, NULL, 115, NULL, NULL, 231586),
(248728, '5kohA02', NULL, NULL, 143, NULL, NULL, 231586),
(248729, '2xy4A02', NULL, NULL, 114, NULL, NULL, 231586),
(248730, '2xdqA01', NULL, NULL, 171, NULL, NULL, 231586),
(248731, '2xy4A01', NULL, NULL, 174, NULL, NULL, 231586),
(248732, '1pzqA01', NULL, NULL, 41, NULL, NULL, 231587),
(248733, '3mk7C01', NULL, NULL, 94, NULL, NULL, 231588),
(248734, '2qv7A01', NULL, NULL, 145, NULL, NULL, 231589),
(248735, '4v24B01', NULL, NULL, 158, NULL, NULL, 231589),
(248736, '4haoA01', NULL, NULL, 167, NULL, NULL, 231589),
(248737, '1u0tA01', NULL, NULL, 135, NULL, NULL, 231589),
(248738, '2i2cA01', NULL, NULL, 133, NULL, NULL, 231589),
(248739, '3s40A01', NULL, NULL, 137, NULL, NULL, 231589),
(248740, '1u0tB01', NULL, NULL, 170, NULL, NULL, 231589),
(248741, '4werA01', NULL, NULL, 137, NULL, NULL, 231589),
(248742, '3pfnD01', NULL, NULL, 163, NULL, NULL, 231589),
(248743, '1z0sA01', NULL, NULL, 124, NULL, NULL, 231589),
(248744, '1u0rB01', NULL, NULL, 134, NULL, NULL, 231589),
(248745, '1y3iA01', NULL, NULL, 105, NULL, NULL, 231589),
(248746, '2an1D01', NULL, NULL, 155, NULL, NULL, 231589),
(248747, '2bonA01', NULL, NULL, 128, NULL, NULL, 231589),
(248748, '3afoB01', NULL, NULL, 217, NULL, NULL, 231589),
(248749, '2p1rA01', NULL, NULL, 132, NULL, NULL, 231589),
(248750, '1yt5A01', NULL, NULL, 132, NULL, NULL, 231589),
(248751, '2iukA03', NULL, NULL, 89, NULL, NULL, 231590),
(248752, '4wfoA03', NULL, NULL, 89, NULL, NULL, 231590),
(248753, '1ik3A03', NULL, NULL, 89, NULL, NULL, 231590),
(248754, '2iujA03', NULL, NULL, 89, NULL, NULL, 231590),
(248755, '4au7B01', NULL, NULL, 102, NULL, NULL, 231591),
(248756, '3rq4A01', NULL, NULL, 100, NULL, NULL, 231591),
(248757, '4bupB01', NULL, NULL, 126, NULL, NULL, 231591),
(248758, '5cprB01', NULL, NULL, 92, NULL, NULL, 231591),
(248759, '3s8pB01', NULL, NULL, 128, NULL, NULL, 231591),
(248760, '5dzsA01', NULL, NULL, 144, NULL, NULL, 231592),
(248761, '3pwzA01', NULL, NULL, 150, NULL, NULL, 231592),
(248762, '3donA01', NULL, NULL, 144, NULL, NULL, 231592),
(248763, '5swvC02', NULL, NULL, 136, NULL, NULL, 231592),
(248764, '6apeA02', NULL, NULL, 86, NULL, NULL, 231592),
(248765, '1npdB01', NULL, NULL, 139, NULL, NULL, 231592),
(248766, '6acfA01', NULL, NULL, 154, NULL, NULL, 231592),
(248767, '5gudA02', NULL, NULL, 136, NULL, NULL, 231592),
(248768, '6dhqA02', NULL, NULL, 149, NULL, NULL, 231592),
(248769, '3aoeC02', NULL, NULL, 136, NULL, NULL, 231592),
(248770, '4k28A01', NULL, NULL, 122, NULL, NULL, 231592),
(248771, '3tnlA01', NULL, NULL, 137, NULL, NULL, 231592),
(248772, '4a26A02', NULL, NULL, 87, NULL, NULL, 231592),
(248773, '2o7sA02', NULL, NULL, 98, NULL, NULL, 231592),
(248774, '1lehA01', NULL, NULL, 151, NULL, NULL, 231592),
(248775, '3p2oA02', NULL, NULL, 86, NULL, NULL, 231592),
(248776, '4omuA01', NULL, NULL, 114, NULL, NULL, 231592),
(248777, '5tc4A02', NULL, NULL, 86, NULL, NULL, 231592),
(248778, '1b0aA02', NULL, NULL, 86, NULL, NULL, 231592);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(248779, '3o8qA01', NULL, NULL, 122, NULL, NULL, 231592),
(248780, '3k92A02', NULL, NULL, 136, NULL, NULL, 231592),
(248781, '2eggA01', NULL, NULL, 138, NULL, NULL, 231592),
(248782, '4omuB01', NULL, NULL, 160, NULL, NULL, 231592),
(248783, '4b4uA02', NULL, NULL, 86, NULL, NULL, 231592),
(248784, '3k8zA02', NULL, NULL, 135, NULL, NULL, 231592),
(248785, '3vpxA01', NULL, NULL, 151, NULL, NULL, 231592),
(248786, '1bgvA02', NULL, NULL, 136, NULL, NULL, 231592),
(248787, '1bvuA01', NULL, NULL, 146, NULL, NULL, 231592),
(248788, '2c2xA02', NULL, NULL, 154, NULL, NULL, 231592),
(248789, '1npyA01', NULL, NULL, 100, NULL, NULL, 231592),
(248790, '4a5oA02', NULL, NULL, 86, NULL, NULL, 231592),
(248791, '1o9bA01', NULL, NULL, 139, NULL, NULL, 231592),
(248792, '5b37E01', NULL, NULL, 150, NULL, NULL, 231592),
(248793, '1gtmA01', NULL, NULL, 146, NULL, NULL, 231592),
(248794, '3fbtA01', NULL, NULL, 150, NULL, NULL, 231592),
(248795, '1nvtA01', NULL, NULL, 145, NULL, NULL, 231592),
(248796, '3ngxA02', NULL, NULL, 84, NULL, NULL, 231592),
(248797, '4fccA02', NULL, NULL, 136, NULL, NULL, 231592),
(248798, '3l07A02', NULL, NULL, 86, NULL, NULL, 231592),
(248799, '1v9lA01', NULL, NULL, 144, NULL, NULL, 231592),
(248800, '4fshA01', NULL, NULL, 138, NULL, NULL, 231592),
(248801, '1npdA01', NULL, NULL, 137, NULL, NULL, 231592),
(248802, '4p4gA01', NULL, NULL, 138, NULL, NULL, 231592),
(248803, '1c1dA01', NULL, NULL, 141, NULL, NULL, 231592),
(248804, '3phhA01', NULL, NULL, 136, NULL, NULL, 231592),
(248805, '4cjxA02', NULL, NULL, 87, NULL, NULL, 231592),
(248806, '3jyoA01', NULL, NULL, 140, NULL, NULL, 231592),
(248807, '3t4eA01', NULL, NULL, 132, NULL, NULL, 231592),
(248808, '1nytA01', NULL, NULL, 115, NULL, NULL, 231592),
(248809, '1o9bB01', NULL, NULL, 137, NULL, NULL, 231592),
(248810, '2hk9B01', NULL, NULL, 145, NULL, NULL, 231592),
(248811, '3u62A01', NULL, NULL, 125, NULL, NULL, 231592),
(248812, '1p77A01', NULL, NULL, 149, NULL, NULL, 231592),
(248813, '2yfqA02', NULL, NULL, 137, NULL, NULL, 231592),
(248814, '3aogA02', NULL, NULL, 136, NULL, NULL, 231592),
(248815, '2d5cA01', NULL, NULL, 113, NULL, NULL, 231592),
(248816, '4xgiA02', NULL, NULL, 136, NULL, NULL, 231592),
(248817, '1vi2A01', NULL, NULL, 149, NULL, NULL, 231592),
(248818, '3sefC01', NULL, NULL, 153, NULL, NULL, 231592),
(248819, '1euzA01', NULL, NULL, 146, NULL, NULL, 231592),
(248820, '1a4iA02', NULL, NULL, 89, NULL, NULL, 231592),
(248821, '1edzA02', NULL, NULL, 132, NULL, NULL, 231592),
(248822, '4xijA01', NULL, NULL, 136, NULL, NULL, 231592),
(248823, '2tmgA01', NULL, NULL, 144, NULL, NULL, 231592),
(248824, '2vveA01', NULL, NULL, 95, NULL, NULL, 231593),
(248825, '2ebfX02', NULL, NULL, 143, NULL, NULL, 231594),
(248826, '2advC02', NULL, NULL, 89, NULL, NULL, 231595),
(248827, '3k3wB02', NULL, NULL, 73, NULL, NULL, 231595),
(248828, '1gk9B02', NULL, NULL, 73, NULL, NULL, 231595),
(248829, '4pemD02', NULL, NULL, 73, NULL, NULL, 231595),
(248830, '4wksC02', NULL, NULL, 75, NULL, NULL, 231595),
(248831, '4hstB02', NULL, NULL, 68, NULL, NULL, 231595),
(248832, '1fm2B03', NULL, NULL, 66, NULL, NULL, 231595),
(248833, '4yfbC02', NULL, NULL, 78, NULL, NULL, 231595),
(248834, '1cp9B02', NULL, NULL, 73, NULL, NULL, 231595),
(248835, '1h6wA03', NULL, NULL, 67, NULL, NULL, 231596),
(248836, '2xgfA01', NULL, NULL, 56, NULL, NULL, 231596),
(248837, '1pyoB00', NULL, NULL, 105, NULL, NULL, 231597),
(248838, '1qtnB00', NULL, NULL, 95, NULL, NULL, 231597),
(248839, '4jb8B00', NULL, NULL, 105, NULL, NULL, 231597),
(248840, '5k20B00', NULL, NULL, 113, NULL, NULL, 231597),
(248841, '1sc3B00', NULL, NULL, 88, NULL, NULL, 231597),
(248842, '3p4uB00', NULL, NULL, 108, NULL, NULL, 231597),
(248843, '3sipD00', NULL, NULL, 109, NULL, NULL, 231597),
(248844, '2dkoB00', NULL, NULL, 103, NULL, NULL, 231597),
(248845, '2o0aA00', NULL, NULL, 298, NULL, NULL, 231598),
(248846, '4gkpB00', NULL, NULL, 275, NULL, NULL, 231598),
(248847, '3ii6X02', NULL, NULL, 41, NULL, NULL, 231599),
(248848, '2o3iA02', NULL, NULL, 141, NULL, NULL, 231600),
(248849, '3bq9A01', NULL, NULL, 115, NULL, NULL, 231601);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(248850, '3gh1A01', NULL, NULL, 122, NULL, NULL, 231601),
(248851, '6gflB01', NULL, NULL, 127, NULL, NULL, 231601),
(248852, '3nk4A02', NULL, NULL, 165, NULL, NULL, 231602),
(248853, '5bupA00', NULL, NULL, 172, NULL, NULL, 231602),
(248854, '3qw9B00', NULL, NULL, 176, NULL, NULL, 231602),
(248855, '2mzyA00', NULL, NULL, 91, NULL, NULL, 231603),
(248856, '1xs8A01', NULL, NULL, 75, NULL, NULL, 231603),
(248857, '1t07A00', NULL, NULL, 94, NULL, NULL, 231603),
(248858, '1yhdA01', NULL, NULL, 75, NULL, NULL, 231603),
(248859, '2l14B00', NULL, NULL, 49, NULL, NULL, 231604),
(248860, '2d7dA03', NULL, NULL, 99, NULL, NULL, 231605),
(248861, '3fwlA03', NULL, NULL, 90, NULL, NULL, 231605),
(248862, '3fpnB00', NULL, NULL, 106, NULL, NULL, 231605),
(248863, '3vmaA03', NULL, NULL, 90, NULL, NULL, 231605),
(248864, '3hjhA02', NULL, NULL, 86, NULL, NULL, 231605),
(248865, '1d2mA02', NULL, NULL, 99, NULL, NULL, 231605),
(248866, '1q60A00', NULL, NULL, 99, NULL, NULL, 231606),
(248867, '2e3lA00', NULL, NULL, 99, NULL, NULL, 231606),
(248868, '2d99A00', NULL, NULL, 90, NULL, NULL, 231606),
(248869, '2ejeA00', NULL, NULL, 114, NULL, NULL, 231606),
(248870, '2ed2A00', NULL, NULL, 99, NULL, NULL, 231606),
(248871, '2d9bA00', NULL, NULL, 109, NULL, NULL, 231606),
(248872, '2dn5A00', NULL, NULL, 89, NULL, NULL, 231606),
(248873, '2dn4A00', NULL, NULL, 99, NULL, NULL, 231606),
(248874, '2dzqA01', NULL, NULL, 87, NULL, NULL, 231606),
(248875, '2dzrA00', NULL, NULL, 99, NULL, NULL, 231606),
(248876, '2yk0A03', NULL, NULL, 227, NULL, NULL, 231607),
(248877, '1wu7A02', NULL, NULL, 55, NULL, NULL, 231608),
(248878, '3t5qG01', NULL, NULL, 105, NULL, NULL, 231609),
(248879, '2czrA02', NULL, NULL, 120, NULL, NULL, 231610),
(248880, '4akgA14', NULL, NULL, 109, NULL, NULL, 231611),
(248881, '2fqmA01', NULL, NULL, 50, NULL, NULL, 231612),
(248882, '2hpuA02', NULL, NULL, 78, NULL, NULL, 231613),
(248883, '2ezvA01', NULL, NULL, 199, NULL, NULL, 231614),
(248884, '3kinB00', NULL, NULL, 117, NULL, NULL, 231615),
(248885, '6grrB01', NULL, NULL, 79, NULL, NULL, 231616),
(248886, '5luzA01', NULL, NULL, 138, NULL, NULL, 231617),
(248887, '2o36A01', NULL, NULL, 136, NULL, NULL, 231617),
(248888, '2o3eA01', NULL, NULL, 152, NULL, NULL, 231617),
(248889, '1tgrA00', NULL, NULL, 52, NULL, NULL, 231618),
(248890, '3lriA00', NULL, NULL, 83, NULL, NULL, 231618),
(248891, '2kqpA00', NULL, NULL, 86, NULL, NULL, 231618),
(248892, '1zeiA00', NULL, NULL, 53, NULL, NULL, 231618),
(248893, '2jzqA00', NULL, NULL, 57, NULL, NULL, 231618),
(248894, '5wdmD00', NULL, NULL, 57, NULL, NULL, 231618),
(248895, '3kr3D00', NULL, NULL, 67, NULL, NULL, 231618),
(248896, '1imxA00', NULL, NULL, 70, NULL, NULL, 231618),
(248897, '6insE00', NULL, NULL, 50, NULL, NULL, 231618),
(248898, '2kjiA00', NULL, NULL, 50, NULL, NULL, 231618),
(248899, '3puaA02', NULL, NULL, 86, NULL, NULL, 231619),
(248900, '3purA03', NULL, NULL, 128, NULL, NULL, 231619),
(248901, '2yu1A02', NULL, NULL, 125, NULL, NULL, 231619),
(248902, '3k3oA02', NULL, NULL, 94, NULL, NULL, 231619),
(248903, '3kv5D03', NULL, NULL, 107, NULL, NULL, 231619),
(248904, '3n1eA02', NULL, NULL, 95, NULL, NULL, 231620),
(248905, '3hieB01', NULL, NULL, 151, NULL, NULL, 231621),
(248906, '5bvrA01', NULL, NULL, 120, NULL, NULL, 231622),
(248907, '5bvrA02', NULL, NULL, 116, NULL, NULL, 231622),
(248908, '1dxxA01', NULL, NULL, 121, NULL, NULL, 231622),
(248909, '2qjxA00', NULL, NULL, 127, NULL, NULL, 231622),
(248910, '1wkuA01', NULL, NULL, 112, NULL, NULL, 231622),
(248911, '3co1A00', NULL, NULL, 132, NULL, NULL, 231622),
(248912, '2wa7A02', NULL, NULL, 116, NULL, NULL, 231622),
(248913, '1wylA01', NULL, NULL, 103, NULL, NULL, 231622),
(248914, '1p2xA00', NULL, NULL, 159, NULL, NULL, 231622),
(248915, '4edmA00', NULL, NULL, 133, NULL, NULL, 231622),
(248916, '1rt8A04', NULL, NULL, 115, NULL, NULL, 231622),
(248917, '1dxxA02', NULL, NULL, 125, NULL, NULL, 231622),
(248918, '2d88A01', NULL, NULL, 105, NULL, NULL, 231622),
(248919, '1wypA00', NULL, NULL, 136, NULL, NULL, 231622),
(248920, '2wa7A01', NULL, NULL, 129, NULL, NULL, 231622);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(248921, '1pxyB01', NULL, NULL, 128, NULL, NULL, 231622),
(248922, '5l0oA00', NULL, NULL, 164, NULL, NULL, 231622),
(248923, '1pxyB03', NULL, NULL, 118, NULL, NULL, 231622),
(248924, '1pxyB02', NULL, NULL, 129, NULL, NULL, 231622),
(248925, '3hopA01', NULL, NULL, 117, NULL, NULL, 231622),
(248926, '1v5kA00', NULL, NULL, 115, NULL, NULL, 231622),
(248927, '3ky9A01', NULL, NULL, 167, NULL, NULL, 231622),
(248928, '4txiA03', NULL, NULL, 109, NULL, NULL, 231622),
(248929, '2r0oA02', NULL, NULL, 118, NULL, NULL, 231622),
(248930, '3ferA02', NULL, NULL, 125, NULL, NULL, 231622),
(248931, '1h67A00', NULL, NULL, 108, NULL, NULL, 231622),
(248932, '1wymA01', NULL, NULL, 132, NULL, NULL, 231622),
(248933, '2d87A01', NULL, NULL, 108, NULL, NULL, 231622),
(248934, '1wyqA01', NULL, NULL, 105, NULL, NULL, 231622),
(248935, '1aoaA01', NULL, NULL, 118, NULL, NULL, 231622),
(248936, '1aoaA02', NULL, NULL, 136, NULL, NULL, 231622),
(248937, '2ee7A01', NULL, NULL, 115, NULL, NULL, 231622),
(248938, '1wkuB02', NULL, NULL, 120, NULL, NULL, 231622),
(248939, '5a37A02', NULL, NULL, 120, NULL, NULL, 231622),
(248940, '2eyiA02', NULL, NULL, 120, NULL, NULL, 231622),
(248941, '2qjzA00', NULL, NULL, 123, NULL, NULL, 231622),
(248942, '2vzcB00', NULL, NULL, 131, NULL, NULL, 231622),
(248943, '1sh5A01', NULL, NULL, 104, NULL, NULL, 231622),
(248944, '2jv9A01', NULL, NULL, 108, NULL, NULL, 231622),
(248945, '1qagA01', NULL, NULL, 100, NULL, NULL, 231622),
(248946, '2d86A01', NULL, NULL, 125, NULL, NULL, 231622),
(248947, '4q57B01', NULL, NULL, 133, NULL, NULL, 231622),
(248948, '1wynA01', NULL, NULL, 108, NULL, NULL, 231622),
(248949, '4q57B02', NULL, NULL, 111, NULL, NULL, 231622),
(248950, '1wjoA01', NULL, NULL, 104, NULL, NULL, 231622),
(248951, '1wyrA00', NULL, NULL, 121, NULL, NULL, 231622),
(248952, '1bhdA00', NULL, NULL, 118, NULL, NULL, 231622),
(248953, '2d89A01', NULL, NULL, 112, NULL, NULL, 231622),
(248954, '1pxyA04', NULL, NULL, 111, NULL, NULL, 231622),
(248955, '4b7lA01', NULL, NULL, 126, NULL, NULL, 231622),
(248956, '1rt8A02', NULL, NULL, 115, NULL, NULL, 231622),
(248957, '1rt8A03', NULL, NULL, 117, NULL, NULL, 231622),
(248958, '3hopB02', NULL, NULL, 110, NULL, NULL, 231622),
(248959, '1rt8A01', NULL, NULL, 136, NULL, NULL, 231622),
(248960, '1wixA01', NULL, NULL, 153, NULL, NULL, 231622),
(248961, '1bkrA00', NULL, NULL, 109, NULL, NULL, 231622),
(248962, '2r8uA00', NULL, NULL, 131, NULL, NULL, 231622),
(248963, '2l3gA00', NULL, NULL, 126, NULL, NULL, 231622),
(248964, '2r0oB01', NULL, NULL, 119, NULL, NULL, 231622),
(248965, '2yrnA01', NULL, NULL, 125, NULL, NULL, 231622),
(248966, '5nl7A02', NULL, NULL, 111, NULL, NULL, 231622),
(248967, '5nl7A01', NULL, NULL, 123, NULL, NULL, 231622),
(248968, '2eyiA01', NULL, NULL, 114, NULL, NULL, 231622),
(248969, '6b9hA00', NULL, NULL, 161, NULL, NULL, 231622),
(248970, '2e9kA01', NULL, NULL, 105, NULL, NULL, 231622),
(248971, '2d85A01', NULL, NULL, 104, NULL, NULL, 231622),
(248972, '1ujoA00', NULL, NULL, 144, NULL, NULL, 231622),
(248973, '3k1hA00', NULL, NULL, 115, NULL, NULL, 231623),
(248974, '3ksvA02', NULL, NULL, 27, NULL, NULL, 231624),
(248975, '1b3qA01', NULL, NULL, 62, NULL, NULL, 231625),
(248976, '3wdmD00', NULL, NULL, 261, NULL, NULL, 231626),
(248977, '4mb0A00', NULL, NULL, 261, NULL, NULL, 231626),
(248978, '4eozD03', NULL, NULL, 50, NULL, NULL, 231627),
(248979, '4eozB03', NULL, NULL, 51, NULL, NULL, 231627),
(248980, '1mkfA02', NULL, NULL, 172, NULL, NULL, 231628),
(248981, '4p1nC00', NULL, NULL, 61, NULL, NULL, 231629),
(248982, '3zpgA02', NULL, NULL, 222, NULL, NULL, 231630),
(248983, '3nzbX00', NULL, NULL, 206, NULL, NULL, 231630),
(248984, '4pssA00', NULL, NULL, 159, NULL, NULL, 231630),
(248985, '3ix9A00', NULL, NULL, 169, NULL, NULL, 231630),
(248986, '4m7uA00', NULL, NULL, 176, NULL, NULL, 231630),
(248987, '3cseA00', NULL, NULL, 227, NULL, NULL, 231630),
(248988, '4or7A00', NULL, NULL, 165, NULL, NULL, 231630),
(248989, '3dfrA00', NULL, NULL, 162, NULL, NULL, 231630),
(248990, '2p4gA00', NULL, NULL, 270, NULL, NULL, 231630),
(248991, '4klxA00', NULL, NULL, 161, NULL, NULL, 231630);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(248992, '3tq8A00', NULL, NULL, 178, NULL, NULL, 231630),
(248993, '2bl9A00', NULL, NULL, 238, NULL, NULL, 231630),
(248994, '3ky8A01', NULL, NULL, 174, NULL, NULL, 231630),
(248995, '1zdrA00', NULL, NULL, 164, NULL, NULL, 231630),
(248996, '1juvA00', NULL, NULL, 193, NULL, NULL, 231630),
(248997, '3ia4A00', NULL, NULL, 162, NULL, NULL, 231630),
(248998, '3hj3A01', NULL, NULL, 178, NULL, NULL, 231630),
(248999, '3vcoA00', NULL, NULL, 183, NULL, NULL, 231630),
(249000, '2b3zA02', NULL, NULL, 227, NULL, NULL, 231630),
(249001, '2w9hA00', NULL, NULL, 159, NULL, NULL, 231630),
(249002, '3d80A00', NULL, NULL, 186, NULL, NULL, 231630),
(249003, '4eilB01', NULL, NULL, 207, NULL, NULL, 231630),
(249004, '4xt6A00', NULL, NULL, 258, NULL, NULL, 231630),
(249005, '3jtwA00', NULL, NULL, 178, NULL, NULL, 231630),
(249006, '1kmvA00', NULL, NULL, 186, NULL, NULL, 231630),
(249007, '2g6vA02', NULL, NULL, 240, NULL, NULL, 231630),
(249008, '2d0kA00', NULL, NULL, 159, NULL, NULL, 231630),
(249009, '3nrrB01', NULL, NULL, 192, NULL, NULL, 231630),
(249010, '1cz3B00', NULL, NULL, 168, NULL, NULL, 231630),
(249011, '2h2qB01', NULL, NULL, 235, NULL, NULL, 231630),
(249012, '4eckA01', NULL, NULL, 219, NULL, NULL, 231630),
(249013, '1vdrA00', NULL, NULL, 162, NULL, NULL, 231630),
(249014, '5xv0E00', NULL, NULL, 240, NULL, NULL, 231630),
(249015, '2hxvA02', NULL, NULL, 201, NULL, NULL, 231630),
(249016, '4qi9B00', NULL, NULL, 167, NULL, NULL, 231630),
(249017, '6cxmA00', NULL, NULL, 164, NULL, NULL, 231630),
(249018, '5fdaA00', NULL, NULL, 163, NULL, NULL, 231630),
(249019, '4dphB01', NULL, NULL, 229, NULL, NULL, 231630),
(249020, '2aznA00', NULL, NULL, 219, NULL, NULL, 231630),
(249021, '8dfrA00', NULL, NULL, 189, NULL, NULL, 231630),
(249022, '3kgyA00', NULL, NULL, 231, NULL, NULL, 231630),
(249023, '2w9sA00', NULL, NULL, 161, NULL, NULL, 231630),
(249024, '2gd9A01', NULL, NULL, 177, NULL, NULL, 231630),
(249025, '3s9uA00', NULL, NULL, 165, NULL, NULL, 231630),
(249026, '5dxvA00', NULL, NULL, 156, NULL, NULL, 231630),
(249027, '4ha7B00', NULL, NULL, 249, NULL, NULL, 231630),
(249028, '5eccA00', NULL, NULL, 157, NULL, NULL, 231630),
(249029, '2w3wA00', NULL, NULL, 167, NULL, NULL, 231630),
(249030, '1aoeA00', NULL, NULL, 192, NULL, NULL, 231630),
(249031, '3rg9A00', NULL, NULL, 218, NULL, NULL, 231630),
(249032, '2xw7A00', NULL, NULL, 178, NULL, NULL, 231630),
(249033, '2yeqA01', NULL, NULL, 109, NULL, NULL, 231631),
(249034, '1xzwA01', NULL, NULL, 98, NULL, NULL, 231631),
(249035, '6hwrA01', NULL, NULL, 97, NULL, NULL, 231631),
(249036, '2gpiA00', NULL, NULL, 91, NULL, NULL, 231632),
(249037, '4indA02', NULL, NULL, 113, NULL, NULL, 231633),
(249038, '1gccA00', NULL, NULL, 63, NULL, NULL, 231634),
(249039, '2a79B02', NULL, NULL, 61, NULL, NULL, 231635),
(249040, '4fbwA02', NULL, NULL, 111, NULL, NULL, 231636),
(249041, '4ykeB02', NULL, NULL, 111, NULL, NULL, 231636),
(249042, '3t1iA02', NULL, NULL, 106, NULL, NULL, 231636),
(249043, '5z42A00', NULL, NULL, 102, NULL, NULL, 231637),
(249044, '1x9zA01', NULL, NULL, 99, NULL, NULL, 231637),
(249045, '3ncvA01', NULL, NULL, 100, NULL, NULL, 231637),
(249046, '3kdgB01', NULL, NULL, 99, NULL, NULL, 231637),
(249047, '2pfcA00', NULL, NULL, 164, NULL, NULL, 231638),
(249048, '1n02A00', NULL, NULL, 102, NULL, NULL, 231639),
(249049, '2l2fA00', NULL, NULL, 108, NULL, NULL, 231639),
(249050, '2y1sA00', NULL, NULL, 108, NULL, NULL, 231639),
(249051, '2jzlA00', NULL, NULL, 114, NULL, NULL, 231639),
(249052, '2rdkA00', NULL, NULL, 109, NULL, NULL, 231639),
(249053, '3hnxA00', NULL, NULL, 110, NULL, NULL, 231639),
(249054, '2jzkA00', NULL, NULL, 106, NULL, NULL, 231639),
(249055, '2jzjA01', NULL, NULL, 111, NULL, NULL, 231639),
(249056, '3ezmA00', NULL, NULL, 101, NULL, NULL, 231639),
(249057, '3czzA00', NULL, NULL, 101, NULL, NULL, 231639),
(249058, '5c8qB01', NULL, NULL, 108, NULL, NULL, 231639),
(249059, '4yhbA02', NULL, NULL, 138, NULL, NULL, 231640),
(249060, '1tvcA02', NULL, NULL, 141, NULL, NULL, 231640),
(249061, '5kswB02', NULL, NULL, 117, NULL, NULL, 231640),
(249062, '4dqlA03', NULL, NULL, 161, NULL, NULL, 231640);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(249063, '4fk8A02', NULL, NULL, 160, NULL, NULL, 231640),
(249064, '1gawA02', NULL, NULL, 163, NULL, NULL, 231640),
(249065, '1cqxA03', NULL, NULL, 142, NULL, NULL, 231640),
(249066, '1a8pA02', NULL, NULL, 162, NULL, NULL, 231640),
(249067, '2rc5A02', NULL, NULL, 161, NULL, NULL, 231640),
(249068, '3lo8A02', NULL, NULL, 162, NULL, NULL, 231640),
(249069, '2cndA02', NULL, NULL, 154, NULL, NULL, 231640),
(249070, '4eh1B02', NULL, NULL, 133, NULL, NULL, 231640),
(249071, '3w5hA02', NULL, NULL, 154, NULL, NULL, 231640),
(249072, '2bpoA04', NULL, NULL, 166, NULL, NULL, 231640),
(249073, '2piaA02', NULL, NULL, 121, NULL, NULL, 231640),
(249074, '5gxuB03', NULL, NULL, 154, NULL, NULL, 231640),
(249075, '1umkA02', NULL, NULL, 154, NULL, NULL, 231640),
(249076, '2b5oA02', NULL, NULL, 163, NULL, NULL, 231640),
(249077, '2eixA02', NULL, NULL, 136, NULL, NULL, 231640),
(249078, '2qtlA03', NULL, NULL, 161, NULL, NULL, 231640),
(249079, '3vo1A02', NULL, NULL, 163, NULL, NULL, 231640),
(249080, '1f20A01', NULL, NULL, 163, NULL, NULL, 231640),
(249081, '4wqmA03', NULL, NULL, 133, NULL, NULL, 231640),
(249082, '5ylyA02', NULL, NULL, 149, NULL, NULL, 231640),
(249083, '3qfsA03', NULL, NULL, 157, NULL, NULL, 231640),
(249084, '1ja1A04', NULL, NULL, 158, NULL, NULL, 231640),
(249085, '3fpkA02', NULL, NULL, 152, NULL, NULL, 231640),
(249086, '2bmwA02', NULL, NULL, 167, NULL, NULL, 231640),
(249087, '1fnbA02', NULL, NULL, 163, NULL, NULL, 231640),
(249088, '4u9uA02', NULL, NULL, 119, NULL, NULL, 231640),
(249089, '3jqqD02', NULL, NULL, 159, NULL, NULL, 231640),
(249090, '1ddgA03', NULL, NULL, 155, NULL, NULL, 231640),
(249091, '3vo2A02', NULL, NULL, 163, NULL, NULL, 231640),
(249092, '5o0xA02', NULL, NULL, 183, NULL, NULL, 231640),
(249093, '2qdxA02', NULL, NULL, 162, NULL, NULL, 231640),
(249094, '1fdrA02', NULL, NULL, 152, NULL, NULL, 231640),
(249095, '4g1vA03', NULL, NULL, 136, NULL, NULL, 231640),
(249096, '1ep3B02', NULL, NULL, 117, NULL, NULL, 231640),
(249097, '5tr9A02', NULL, NULL, 158, NULL, NULL, 231640),
(249098, '2gpjA02', NULL, NULL, 147, NULL, NULL, 231640),
(249099, '3lyuA01', NULL, NULL, 112, NULL, NULL, 231640),
(249100, '1krhA03', NULL, NULL, 134, NULL, NULL, 231640),
(249101, '1qfjA02', NULL, NULL, 135, NULL, NULL, 231640),
(249102, '4b4dA02', NULL, NULL, 162, NULL, NULL, 231640),
(249103, '1qfzA02', NULL, NULL, 163, NULL, NULL, 231640),
(249104, '2r6hA02', NULL, NULL, 118, NULL, NULL, 231640),
(249105, '5thxA02', NULL, NULL, 162, NULL, NULL, 231640),
(249106, '3a1fA00', NULL, NULL, 186, NULL, NULL, 231640),
(249107, '1sm4A02', NULL, NULL, 163, NULL, NULL, 231640),
(249108, '1gvhA03', NULL, NULL, 142, NULL, NULL, 231640),
(249109, '1qx4A02', NULL, NULL, 155, NULL, NULL, 231640),
(249110, '2bgiA02', NULL, NULL, 154, NULL, NULL, 231640),
(249111, '2rdcA00', NULL, NULL, 133, NULL, NULL, 231641),
(249112, '3d5aX01', NULL, NULL, 102, NULL, NULL, 231642),
(249113, '1zbtA01', NULL, NULL, 120, NULL, NULL, 231642),
(249114, '2vy1A00', NULL, NULL, 170, NULL, NULL, 231643),
(249115, '4bhkA00', NULL, NULL, 171, NULL, NULL, 231643),
(249116, '5z62I00', NULL, NULL, 73, NULL, NULL, 231644),
(249117, '5b1aI00', NULL, NULL, 73, NULL, NULL, 231644),
(249118, '3kwlA03', NULL, NULL, 152, NULL, NULL, 231645),
(249119, '3mgjA00', NULL, NULL, 97, NULL, NULL, 231646),
(249120, '4a0tA02', NULL, NULL, 33, NULL, NULL, 231647),
(249121, '1qhdA02', NULL, NULL, 228, NULL, NULL, 231648),
(249122, '2a74A06', NULL, NULL, 64, NULL, NULL, 231649),
(249123, '5jtwA06', NULL, NULL, 62, NULL, NULL, 231649),
(249124, '3hrzA06', NULL, NULL, 61, NULL, NULL, 231649),
(249125, '3u61A01', NULL, NULL, 33, NULL, NULL, 231650),
(249126, '4hi6C00', NULL, NULL, 142, NULL, NULL, 231651),
(249127, '3s6xC01', NULL, NULL, 58, NULL, NULL, 231652),
(249128, '1pp0B00', NULL, NULL, 199, NULL, NULL, 231653),
(249129, '3ronA00', NULL, NULL, 212, NULL, NULL, 231653),
(249130, '1cbyA00', NULL, NULL, 241, NULL, NULL, 231653),
(249131, '2rciA00', NULL, NULL, 204, NULL, NULL, 231653),
(249132, '3ga9L02', NULL, NULL, 101, NULL, NULL, 231654),
(249133, '3g9kD02', NULL, NULL, 101, NULL, NULL, 231654);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(249134, '3g9kL02', NULL, NULL, 101, NULL, NULL, 231654),
(249135, '4b8cD02', NULL, NULL, 92, NULL, NULL, 231655),
(249136, '5ffgA02', NULL, NULL, 162, NULL, NULL, 231656),
(249137, '3fcsA02', NULL, NULL, 154, NULL, NULL, 231656),
(249138, '4irzA02', NULL, NULL, 164, NULL, NULL, 231656),
(249139, '3vi3A02', NULL, NULL, 152, NULL, NULL, 231656),
(249140, '4nehA03', NULL, NULL, 155, NULL, NULL, 231656),
(249141, '4kx7A03', NULL, NULL, 88, NULL, NULL, 231657),
(249142, '1z5hA03', NULL, NULL, 73, NULL, NULL, 231657),
(249143, '4wz9A03', NULL, NULL, 88, NULL, NULL, 231657),
(249144, '5ab0A03', NULL, NULL, 89, NULL, NULL, 231657),
(249145, '4fytA03', NULL, NULL, 86, NULL, NULL, 231657),
(249146, '5mj6A03', NULL, NULL, 89, NULL, NULL, 231657),
(249147, '4fkeA03', NULL, NULL, 87, NULL, NULL, 231657),
(249148, '6q4rA03', NULL, NULL, 83, NULL, NULL, 231657),
(249149, '1yrtA03', NULL, NULL, 55, NULL, NULL, 231658),
(249150, '4ioxC00', NULL, NULL, 260, NULL, NULL, 231659),
(249151, '3n4pC00', NULL, NULL, 246, NULL, NULL, 231659),
(249152, '3fcsB06', NULL, NULL, 86, NULL, NULL, 231660),
(249153, '1jv2B04', NULL, NULL, 88, NULL, NULL, 231660),
(249154, '5cyuA01', NULL, NULL, 76, NULL, NULL, 231661),
(249155, '3x3mA01', NULL, NULL, 97, NULL, NULL, 231661),
(249156, '4kk7A01', NULL, NULL, 81, NULL, NULL, 231661),
(249157, '3x3nA01', NULL, NULL, 78, NULL, NULL, 231661),
(249158, '2a7yA00', NULL, NULL, 83, NULL, NULL, 231662),
(249159, '5tipA02', NULL, NULL, 215, NULL, NULL, 231663),
(249160, '4bkwA03', NULL, NULL, 153, NULL, NULL, 231664),
(249161, '2lnuA01', NULL, NULL, 40, NULL, NULL, 231665),
(249162, '1li5A02', NULL, NULL, 87, NULL, NULL, 231666),
(249163, '3c8zA02', NULL, NULL, 83, NULL, NULL, 231666),
(249164, '3tqoA02', NULL, NULL, 87, NULL, NULL, 231666),
(249165, '4gvbB00', NULL, NULL, 81, NULL, NULL, 231667),
(249166, '4gvbA00', NULL, NULL, 80, NULL, NULL, 231667),
(249167, '1v8cA02', NULL, NULL, 83, NULL, NULL, 231668),
(249168, '5gnpA02', NULL, NULL, 167, NULL, NULL, 231669),
(249169, '5dkoA02', NULL, NULL, 167, NULL, NULL, 231669),
(249170, '2oezB02', NULL, NULL, 167, NULL, NULL, 231669),
(249171, '2kvzA00', NULL, NULL, 85, NULL, NULL, 231670),
(249172, '2kywA00', NULL, NULL, 87, NULL, NULL, 231670),
(249173, '4m02A01', NULL, NULL, 81, NULL, NULL, 231670),
(249174, '2kt7A01', NULL, NULL, 85, NULL, NULL, 231670),
(249175, '1aafA00', NULL, NULL, 55, NULL, NULL, 231671),
(249176, '1a1tA00', NULL, NULL, 55, NULL, NULL, 231671),
(249177, '2ec7A00', NULL, NULL, 49, NULL, NULL, 231671),
(249178, '2cqfA00', NULL, NULL, 63, NULL, NULL, 231671),
(249179, '1u6pA00', NULL, NULL, 56, NULL, NULL, 231671),
(249180, '3nybB00', NULL, NULL, 83, NULL, NULL, 231671),
(249181, '5udzA02', NULL, NULL, 54, NULL, NULL, 231671),
(249182, '1a6bB00', NULL, NULL, 40, NULL, NULL, 231671),
(249183, '2li8A00', NULL, NULL, 74, NULL, NULL, 231671),
(249184, '2l4lA00', NULL, NULL, 45, NULL, NULL, 231671),
(249185, '2ysaA00', NULL, NULL, 55, NULL, NULL, 231671),
(249186, '2ihxA00', NULL, NULL, 61, NULL, NULL, 231671),
(249187, '5b2nA00', NULL, NULL, 279, NULL, NULL, 231672),
(249188, '1uazA00', NULL, NULL, 236, NULL, NULL, 231672),
(249189, '3oduB01', NULL, NULL, 277, NULL, NULL, 231672),
(249190, '4hyjA00', NULL, NULL, 241, NULL, NULL, 231672),
(249191, '4qi1A00', NULL, NULL, 238, NULL, NULL, 231672),
(249192, '4ea3B02', NULL, NULL, 285, NULL, NULL, 231672),
(249193, '6b73B00', NULL, NULL, 281, NULL, NULL, 231672),
(249194, '4ldeA02', NULL, NULL, 291, NULL, NULL, 231672),
(249195, '1h2sA00', NULL, NULL, 225, NULL, NULL, 231672),
(249196, '5azdB00', NULL, NULL, 252, NULL, NULL, 231672),
(249197, '2z73B01', NULL, NULL, 346, NULL, NULL, 231672),
(249198, '4buoA00', NULL, NULL, 335, NULL, NULL, 231672),
(249199, '2jafA00', NULL, NULL, 253, NULL, NULL, 231672),
(249200, '5ax0A00', NULL, NULL, 244, NULL, NULL, 231672),
(249201, '4mbsA00', NULL, NULL, 346, NULL, NULL, 231672),
(249202, '3pblB01', NULL, NULL, 281, NULL, NULL, 231672),
(249203, '4jq6B00', NULL, NULL, 235, NULL, NULL, 231672),
(249204, '5b0wD00', NULL, NULL, 274, NULL, NULL, 231672);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(249205, '5tgzA01', NULL, NULL, 305, NULL, NULL, 231672),
(249206, '3uonA01', NULL, NULL, 289, NULL, NULL, 231672),
(249207, '1u19B00', NULL, NULL, 349, NULL, NULL, 231672),
(249208, '4klyB00', NULL, NULL, 238, NULL, NULL, 231672),
(249209, '4k5yA01', NULL, NULL, 264, NULL, NULL, 231672),
(249210, '3kj6A00', NULL, NULL, 274, NULL, NULL, 231672),
(249211, '1c8rA00', NULL, NULL, 231, NULL, NULL, 231672),
(249212, '2ks9A00', NULL, NULL, 364, NULL, NULL, 231672),
(249213, '4jkvB02', NULL, NULL, 366, NULL, NULL, 231672),
(249214, '1xioA00', NULL, NULL, 226, NULL, NULL, 231672),
(249215, '2rh1A01', NULL, NULL, 282, NULL, NULL, 231672),
(249216, '2lnlA00', NULL, NULL, 309, NULL, NULL, 231672),
(249217, '5zimA00', NULL, NULL, 228, NULL, NULL, 231672),
(249218, '5lweA00', NULL, NULL, 310, NULL, NULL, 231672),
(249219, '4bv0A00', NULL, NULL, 338, NULL, NULL, 231672),
(249220, '4l35A00', NULL, NULL, 250, NULL, NULL, 231672),
(249221, '3am6A00', NULL, NULL, 229, NULL, NULL, 231672),
(249222, '4fbzA00', NULL, NULL, 241, NULL, NULL, 231672),
(249223, '4xtlA00', NULL, NULL, 288, NULL, NULL, 231672),
(249224, '4eiyA01', NULL, NULL, 298, NULL, NULL, 231672),
(249225, '4pxkA00', NULL, NULL, 238, NULL, NULL, 231672),
(249226, '4iarA01', NULL, NULL, 295, NULL, NULL, 231672),
(249227, '4xt1A00', NULL, NULL, 296, NULL, NULL, 231672),
(249228, '3ug9A02', NULL, NULL, 233, NULL, NULL, 231672),
(249229, '5c1mA00', NULL, NULL, 296, NULL, NULL, 231672),
(249230, '3v2yA01', NULL, NULL, 302, NULL, NULL, 231672),
(249231, '3s8fB01', NULL, NULL, 46, NULL, NULL, 231672),
(249232, '4x1hA00', NULL, NULL, 326, NULL, NULL, 231672),
(249233, '4bvnA00', NULL, NULL, 315, NULL, NULL, 231672),
(249234, '6gyhA00', NULL, NULL, 236, NULL, NULL, 231672),
(249235, '4knfC00', NULL, NULL, 240, NULL, NULL, 231672),
(249236, '4grvA01', NULL, NULL, 301, NULL, NULL, 231672),
(249237, '4l6rA02', NULL, NULL, 319, NULL, NULL, 231672),
(249238, '3rzeA01', NULL, NULL, 292, NULL, NULL, 231672),
(249239, '4ib4A01', NULL, NULL, 302, NULL, NULL, 231672),
(249240, '4n6hA02', NULL, NULL, 286, NULL, NULL, 231672),
(249241, '2l6xA00', NULL, NULL, 243, NULL, NULL, 231672),
(249242, '4dajA01', NULL, NULL, 265, NULL, NULL, 231672),
(249243, '3ddlB00', NULL, NULL, 273, NULL, NULL, 231672),
(249244, '3wqjA00', NULL, NULL, 240, NULL, NULL, 231672),
(249245, '6d9hR00', NULL, NULL, 297, NULL, NULL, 231672),
(249246, '3vw7A01', NULL, NULL, 295, NULL, NULL, 231672),
(249247, '1z6gA02', NULL, NULL, 60, NULL, NULL, 231673),
(249248, '3tvtA03', NULL, NULL, 61, NULL, NULL, 231673),
(249249, '3neyF02', NULL, NULL, 63, NULL, NULL, 231673),
(249250, '1kjwA03', NULL, NULL, 61, NULL, NULL, 231673),
(249251, '3tr0A02', NULL, NULL, 60, NULL, NULL, 231673),
(249252, '1kgdA02', NULL, NULL, 63, NULL, NULL, 231673),
(249253, '1s96A02', NULL, NULL, 60, NULL, NULL, 231673),
(249254, '1ex7A01', NULL, NULL, 60, NULL, NULL, 231673),
(249255, '3lncA02', NULL, NULL, 60, NULL, NULL, 231673),
(249256, '3tauA02', NULL, NULL, 60, NULL, NULL, 231673),
(249257, '1znwA02', NULL, NULL, 63, NULL, NULL, 231673),
(249258, '3w9yA02', NULL, NULL, 61, NULL, NULL, 231673),
(249259, '2qorA02', NULL, NULL, 60, NULL, NULL, 231673),
(249260, '1lvgA01', NULL, NULL, 60, NULL, NULL, 231673),
(249261, '4qrhA02', NULL, NULL, 60, NULL, NULL, 231673),
(249262, '4ijfA01', NULL, NULL, 76, NULL, NULL, 231674),
(249263, '6dkuA01', NULL, NULL, 76, NULL, NULL, 231674),
(249264, '4gh9A01', NULL, NULL, 70, NULL, NULL, 231674),
(249265, '3fkeA01', NULL, NULL, 77, NULL, NULL, 231674),
(249266, '3l2aA01', NULL, NULL, 77, NULL, NULL, 231674),
(249267, '3ck6C02', NULL, NULL, 125, NULL, NULL, 231675),
(249268, '3rkgA02', NULL, NULL, 167, NULL, NULL, 231675),
(249269, '4i0uA03', NULL, NULL, 78, NULL, NULL, 231675),
(249270, '4i0uA02', NULL, NULL, 118, NULL, NULL, 231675),
(249271, '4egwA02', NULL, NULL, 127, NULL, NULL, 231675),
(249272, '3nvoB02', NULL, NULL, 123, NULL, NULL, 231675),
(249273, '4ev6A03', NULL, NULL, 58, NULL, NULL, 231675),
(249274, '2hn1A02', NULL, NULL, 104, NULL, NULL, 231675),
(249275, '3bgeA02', NULL, NULL, 100, NULL, NULL, 231676);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(249276, '2r9gA02', NULL, NULL, 82, NULL, NULL, 231676),
(249277, '3ctdB02', NULL, NULL, 84, NULL, NULL, 231676),
(249278, '3pvsA04', NULL, NULL, 102, NULL, NULL, 231676),
(249279, '3ctdA02', NULL, NULL, 67, NULL, NULL, 231676),
(249280, '3tguG00', NULL, NULL, 81, NULL, NULL, 231677),
(249281, '1pp9T00', NULL, NULL, 81, NULL, NULL, 231677),
(249282, '3cx5H00', NULL, NULL, 93, NULL, NULL, 231677),
(249283, '1bccG00', NULL, NULL, 81, NULL, NULL, 231677),
(249284, '5xteA00', NULL, NULL, 81, NULL, NULL, 231677),
(249285, '2rawB00', NULL, NULL, 68, NULL, NULL, 231678),
(249286, '2qfaB00', NULL, NULL, 62, NULL, NULL, 231678),
(249287, '1q0vA00', NULL, NULL, 81, NULL, NULL, 231679),
(249288, '2kkeA00', NULL, NULL, 53, NULL, NULL, 231680),
(249289, '1x4qA01', NULL, NULL, 71, NULL, NULL, 231681),
(249290, '3v53E00', NULL, NULL, 119, NULL, NULL, 231681),
(249291, '6ff4Y00', NULL, NULL, 95, NULL, NULL, 231681),
(249292, '3rj2X00', NULL, NULL, 138, NULL, NULL, 231682),
(249293, '4mloA01', NULL, NULL, 164, NULL, NULL, 231683),
(249294, '1aqzA00', NULL, NULL, 149, NULL, NULL, 231684),
(249295, '1rdsA00', NULL, NULL, 105, NULL, NULL, 231684),
(249296, '5gy6A00', NULL, NULL, 100, NULL, NULL, 231684),
(249297, '1q9eA00', NULL, NULL, 104, NULL, NULL, 231684),
(249298, '1gouA00', NULL, NULL, 116, NULL, NULL, 231684),
(249299, '1pylA00', NULL, NULL, 97, NULL, NULL, 231684),
(249300, '1mgrA00', NULL, NULL, 99, NULL, NULL, 231684),
(249301, '1fusA00', NULL, NULL, 106, NULL, NULL, 231684),
(249302, '4haaA00', NULL, NULL, 109, NULL, NULL, 231684),
(249303, '3agnA00', NULL, NULL, 114, NULL, NULL, 231684),
(249304, '1lniA00', NULL, NULL, 96, NULL, NULL, 231684),
(249305, '3wr2A00', NULL, NULL, 101, NULL, NULL, 231684),
(249306, '2c4bA00', NULL, NULL, 143, NULL, NULL, 231684),
(249307, '1r4yA00', NULL, NULL, 136, NULL, NULL, 231684),
(249308, '1a2pA00', NULL, NULL, 110, NULL, NULL, 231684),
(249309, '2kaaA00', NULL, NULL, 130, NULL, NULL, 231684),
(249310, '1i0vA00', NULL, NULL, 104, NULL, NULL, 231684),
(249311, '3a5eA00', NULL, NULL, 96, NULL, NULL, 231684),
(249312, '4f5cF00', NULL, NULL, 158, NULL, NULL, 231685),
(249313, '3kbhE00', NULL, NULL, 136, NULL, NULL, 231685),
(249314, '3ripA02', NULL, NULL, 304, NULL, NULL, 231686),
(249315, '3v4yB01', NULL, NULL, 29, NULL, NULL, 231687),
(249316, '3nbiA02', NULL, NULL, 154, NULL, NULL, 231688),
(249317, '2hzmA02', NULL, NULL, 89, NULL, NULL, 231689),
(249318, '2z3xA00', NULL, NULL, 63, NULL, NULL, 231690),
(249319, '2qrdB01', NULL, NULL, 38, NULL, NULL, 231691),
(249320, '3t4nB01', NULL, NULL, 39, NULL, NULL, 231691),
(249321, '2qlvB02', NULL, NULL, 38, NULL, NULL, 231691),
(249322, '1x74A02', NULL, NULL, 30, NULL, NULL, 231692),
(249323, '1wn9A00', NULL, NULL, 131, NULL, NULL, 231693),
(249324, '3sggA02', NULL, NULL, 254, NULL, NULL, 231694),
(249325, '5xteE00', NULL, NULL, 75, NULL, NULL, 231695),
(249326, '1pp9H00', NULL, NULL, 78, NULL, NULL, 231695),
(249327, '3cx5F00', NULL, NULL, 74, NULL, NULL, 231695),
(249328, '3tguH00', NULL, NULL, 77, NULL, NULL, 231695),
(249329, '1nc5A00', NULL, NULL, 373, NULL, NULL, 231696),
(249330, '1h54A02', NULL, NULL, 367, NULL, NULL, 231696),
(249331, '3w5mA05', NULL, NULL, 337, NULL, NULL, 231696),
(249332, '5yj6A01', NULL, NULL, 434, NULL, NULL, 231696),
(249333, '5czlA00', NULL, NULL, 316, NULL, NULL, 231696),
(249334, '3wiwA00', NULL, NULL, 375, NULL, NULL, 231696),
(249335, '3wkgA00', NULL, NULL, 412, NULL, NULL, 231696),
(249336, '4z4jA00', NULL, NULL, 402, NULL, NULL, 231696),
(249337, '3rrsA04', NULL, NULL, 387, NULL, NULL, 231696),
(249338, '3w7tA03', NULL, NULL, 457, NULL, NULL, 231696),
(249339, '4doeA00', NULL, NULL, 454, NULL, NULL, 231696),
(249340, '4j5tA02', NULL, NULL, 495, NULL, NULL, 231696),
(249341, '1tf4A01', NULL, NULL, 454, NULL, NULL, 231696),
(249342, '1v5dA01', NULL, NULL, 357, NULL, NULL, 231696),
(249343, '1wzzA00', NULL, NULL, 334, NULL, NULL, 231696),
(249344, '5bv9A01', NULL, NULL, 484, NULL, NULL, 231696),
(249345, '2zblB00', NULL, NULL, 421, NULL, NULL, 231696),
(249346, '1g87A01', NULL, NULL, 450, NULL, NULL, 231696);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(249347, '5zigA00', NULL, NULL, 404, NULL, NULL, 231696),
(249348, '3qxfA00', NULL, NULL, 339, NULL, NULL, 231696),
(249349, '1ut9A02', NULL, NULL, 511, NULL, NULL, 231696),
(249350, '3gt5A00', NULL, NULL, 402, NULL, NULL, 231696),
(249351, '2yikA00', NULL, NULL, 494, NULL, NULL, 231696),
(249352, '3h7lB02', NULL, NULL, 492, NULL, NULL, 231696),
(249353, '3t33A00', NULL, NULL, 415, NULL, NULL, 231696),
(249354, '5z66A00', NULL, NULL, 522, NULL, NULL, 231696),
(249355, '3gzkA02', NULL, NULL, 452, NULL, NULL, 231696),
(249356, '1h12A00', NULL, NULL, 405, NULL, NULL, 231696),
(249357, '4ce7B00', NULL, NULL, 349, NULL, NULL, 231696),
(249358, '5noaA00', NULL, NULL, 354, NULL, NULL, 231696),
(249359, '1gaiA00', NULL, NULL, 472, NULL, NULL, 231696),
(249360, '3p2cA01', NULL, NULL, 433, NULL, NULL, 231696),
(249361, '5m7yA01', NULL, NULL, 423, NULL, NULL, 231696),
(249362, '4q88A00', NULL, NULL, 359, NULL, NULL, 231696),
(249363, '5dgrB02', NULL, NULL, 494, NULL, NULL, 231696),
(249364, '3actA04', NULL, NULL, 387, NULL, NULL, 231696),
(249365, '6gdtE02', NULL, NULL, 473, NULL, NULL, 231696),
(249366, '4q2bB00', NULL, NULL, 349, NULL, NULL, 231696),
(249367, '3on6A01', NULL, NULL, 429, NULL, NULL, 231696),
(249368, '1ks8A00', NULL, NULL, 433, NULL, NULL, 231696),
(249369, '5xd0A01', NULL, NULL, 351, NULL, NULL, 231696),
(249370, '1v7wA03', NULL, NULL, 415, NULL, NULL, 231696),
(249371, '1ulvA02', NULL, NULL, 414, NULL, NULL, 231696),
(249372, '3e6uA00', NULL, NULL, 411, NULL, NULL, 231696),
(249373, '1wu4A01', NULL, NULL, 374, NULL, NULL, 231696),
(249374, '1dl2A00', NULL, NULL, 511, NULL, NULL, 231696),
(249375, '4l6xA01', NULL, NULL, 437, NULL, NULL, 231696),
(249376, '4ayoA00', NULL, NULL, 447, NULL, NULL, 231696),
(249377, '1ia6A00', NULL, NULL, 441, NULL, NULL, 231696),
(249378, '2gz6A00', NULL, NULL, 388, NULL, NULL, 231696),
(249379, '3vw5A00', NULL, NULL, 389, NULL, NULL, 231696),
(249380, '6g00A01', NULL, NULL, 389, NULL, NULL, 231696),
(249381, '4wu0A00', NULL, NULL, 361, NULL, NULL, 231696),
(249382, '2rgkA00', NULL, NULL, 421, NULL, NULL, 231696),
(249383, '4ktpA03', NULL, NULL, 391, NULL, NULL, 231696),
(249384, '2vn4A01', NULL, NULL, 485, NULL, NULL, 231696),
(249385, '4fusA01', NULL, NULL, 434, NULL, NULL, 231696),
(249386, '4zh5A00', NULL, NULL, 426, NULL, NULL, 231696),
(249387, '1fp3A00', NULL, NULL, 402, NULL, NULL, 231696),
(249388, '3pmmA00', NULL, NULL, 382, NULL, NULL, 231696),
(249389, '4xuvA00', NULL, NULL, 373, NULL, NULL, 231696),
(249390, '4cj0A02', NULL, NULL, 439, NULL, NULL, 231696),
(249391, '2p0vA01', NULL, NULL, 437, NULL, NULL, 231696),
(249392, '5gxxA01', NULL, NULL, 439, NULL, NULL, 231696),
(249393, '2xfgA00', NULL, NULL, 446, NULL, NULL, 231696),
(249394, '3renA00', NULL, NULL, 350, NULL, NULL, 231696),
(249395, '2ahfA00', NULL, NULL, 377, NULL, NULL, 231696),
(249396, '3qwtA00', NULL, NULL, 381, NULL, NULL, 231696),
(249397, '3qryA01', NULL, NULL, 423, NULL, NULL, 231696),
(249398, '2zzrA00', NULL, NULL, 397, NULL, NULL, 231696),
(249399, '4wvaB00', NULL, NULL, 420, NULL, NULL, 231696),
(249400, '3wc3A00', NULL, NULL, 438, NULL, NULL, 231696),
(249401, '6f04A00', NULL, NULL, 399, NULL, NULL, 231696),
(249402, '5x32B00', NULL, NULL, 394, NULL, NULL, 231696),
(249403, '5yxtA01', NULL, NULL, 371, NULL, NULL, 231696),
(249404, '5cd2A00', NULL, NULL, 348, NULL, NULL, 231696),
(249405, '2jg0A00', NULL, NULL, 517, NULL, NULL, 231696),
(249406, '1kwfA00', NULL, NULL, 363, NULL, NULL, 231696),
(249407, '4jjjA01', NULL, NULL, 432, NULL, NULL, 231696),
(249408, '2okxA05', NULL, NULL, 334, NULL, NULL, 231696),
(249409, '4xwmA01', NULL, NULL, 440, NULL, NULL, 231696),
(249410, '1x9dA00', NULL, NULL, 455, NULL, NULL, 231696),
(249411, '3qdeA04', NULL, NULL, 381, NULL, NULL, 231696),
(249412, '1hcuC00', NULL, NULL, 503, NULL, NULL, 231696),
(249413, '1lf6A02', NULL, NULL, 392, NULL, NULL, 231696),
(249414, '2ri9A00', NULL, NULL, 475, NULL, NULL, 231696),
(249415, '1nxcA00', NULL, NULL, 478, NULL, NULL, 231696),
(249416, '3k11A00', NULL, NULL, 445, NULL, NULL, 231696),
(249417, '3x17A02', NULL, NULL, 446, NULL, NULL, 231696);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(249418, '1g9gA01', NULL, NULL, 425, NULL, NULL, 231696),
(249419, '2fbaA00', NULL, NULL, 492, NULL, NULL, 231696),
(249420, '2eabA02', NULL, NULL, 511, NULL, NULL, 231696),
(249421, '5gy3A00', NULL, NULL, 310, NULL, NULL, 231696),
(249422, '3wirA02', NULL, NULL, 386, NULL, NULL, 231696),
(249423, '1vlyA01', NULL, NULL, 97, NULL, NULL, 231697),
(249424, '3nj2A00', NULL, NULL, 151, NULL, NULL, 231698),
(249425, '3g7pA00', NULL, NULL, 156, NULL, NULL, 231698),
(249426, '2za4B00', NULL, NULL, 90, NULL, NULL, 231699),
(249427, '5f4cA00', NULL, NULL, 93, NULL, NULL, 231699),
(249428, '2cx6A00', NULL, NULL, 90, NULL, NULL, 231699),
(249429, '2hxxA00', NULL, NULL, 89, NULL, NULL, 231699),
(249430, '3sb1A01', NULL, NULL, 100, NULL, NULL, 231700),
(249431, '3q23A02', NULL, NULL, 149, NULL, NULL, 231701),
(249432, '2ia9F00', NULL, NULL, 100, NULL, NULL, 231702),
(249433, '2i9xB00', NULL, NULL, 87, NULL, NULL, 231702),
(249434, '2i9xA00', NULL, NULL, 87, NULL, NULL, 231702),
(249435, '2i9zA00', NULL, NULL, 105, NULL, NULL, 231702),
(249436, '2i9zB00', NULL, NULL, 87, NULL, NULL, 231702),
(249437, '5xogF00', NULL, NULL, 85, NULL, NULL, 231703),
(249438, '3h0gF00', NULL, NULL, 83, NULL, NULL, 231703),
(249439, '2a6hE00', NULL, NULL, 99, NULL, NULL, 231703),
(249440, '4aybK00', NULL, NULL, 95, NULL, NULL, 231703),
(249441, '2waqK00', NULL, NULL, 95, NULL, NULL, 231703),
(249442, '4qiwK00', NULL, NULL, 57, NULL, NULL, 231703),
(249443, '5uagE00', NULL, NULL, 90, NULL, NULL, 231703),
(249444, '6gmhF00', NULL, NULL, 82, NULL, NULL, 231703),
(249445, '1qklA00', NULL, NULL, 127, NULL, NULL, 231703),
(249446, '1twfF00', NULL, NULL, 84, NULL, NULL, 231703),
(249447, '5tjgE00', NULL, NULL, 99, NULL, NULL, 231703),
(249448, '5hpeA00', NULL, NULL, 350, NULL, NULL, 231704),
(249449, '3av0A01', NULL, NULL, 250, NULL, NULL, 231704),
(249450, '3icfB00', NULL, NULL, 335, NULL, NULL, 231704),
(249451, '4b2oA00', NULL, NULL, 264, NULL, NULL, 231704),
(249452, '2wdcA01', NULL, NULL, 289, NULL, NULL, 231704),
(249453, '1s70A00', NULL, NULL, 311, NULL, NULL, 231704),
(249454, '4ltyA01', NULL, NULL, 290, NULL, NULL, 231704),
(249455, '5h7wA01', NULL, NULL, 311, NULL, NULL, 231704),
(249456, '3gveA00', NULL, NULL, 341, NULL, NULL, 231704),
(249457, '4ykeA01', NULL, NULL, 301, NULL, NULL, 231704),
(249458, '4h2gA01', NULL, NULL, 311, NULL, NULL, 231704),
(249459, '1nnwB00', NULL, NULL, 252, NULL, NULL, 231704),
(249460, '1uf3A00', NULL, NULL, 228, NULL, NULL, 231704),
(249461, '5eqvA00', NULL, NULL, 340, NULL, NULL, 231704),
(249462, '4j6oA00', NULL, NULL, 264, NULL, NULL, 231704),
(249463, '1xm7A00', NULL, NULL, 195, NULL, NULL, 231704),
(249464, '3ck2A00', NULL, NULL, 176, NULL, NULL, 231704),
(249465, '1t70A00', NULL, NULL, 255, NULL, NULL, 231704),
(249466, '2bq8X00', NULL, NULL, 304, NULL, NULL, 231704),
(249467, '3iveA01', NULL, NULL, 311, NULL, NULL, 231704),
(249468, '3c9fA01', NULL, NULL, 327, NULL, NULL, 231704),
(249469, '2a22B00', NULL, NULL, 215, NULL, NULL, 231704),
(249470, '5b8iA00', NULL, NULL, 361, NULL, NULL, 231704),
(249471, '3rl5A00', NULL, NULL, 296, NULL, NULL, 231704),
(249472, '2xmoA01', NULL, NULL, 325, NULL, NULL, 231704),
(249473, '4f0zA00', NULL, NULL, 372, NULL, NULL, 231704),
(249474, '4nzvA01', NULL, NULL, 266, NULL, NULL, 231704),
(249475, '2z1aA01', NULL, NULL, 305, NULL, NULL, 231704),
(249476, '3rqzC00', NULL, NULL, 246, NULL, NULL, 231704),
(249477, '2nxfA01', NULL, NULL, 314, NULL, NULL, 231704),
(249478, '4or9A00', NULL, NULL, 427, NULL, NULL, 231704),
(249479, '4fbwB01', NULL, NULL, 306, NULL, NULL, 231704),
(249480, '4q7fA01', NULL, NULL, 302, NULL, NULL, 231704),
(249481, '4i5lC00', NULL, NULL, 311, NULL, NULL, 231704),
(249482, '5uq6A00', NULL, NULL, 313, NULL, NULL, 231704),
(249483, '2kknA00', NULL, NULL, 157, NULL, NULL, 231704),
(249484, '1t71A00', NULL, NULL, 281, NULL, NULL, 231704),
(249485, '2qjcA00', NULL, NULL, 262, NULL, NULL, 231704),
(249486, '2gjuA00', NULL, NULL, 252, NULL, NULL, 231704),
(249487, '5gtuA00', NULL, NULL, 186, NULL, NULL, 231704),
(249488, '3h63A00', NULL, NULL, 315, NULL, NULL, 231704);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(249489, '3jyfB00', NULL, NULL, 339, NULL, NULL, 231704),
(249490, '5w8mB00', NULL, NULL, 203, NULL, NULL, 231704),
(249491, '5jjtA02', NULL, NULL, 348, NULL, NULL, 231704),
(249492, '1g5bB00', NULL, NULL, 221, NULL, NULL, 231704),
(249493, '3tghA00', NULL, NULL, 342, NULL, NULL, 231704),
(249494, '1su1A00', NULL, NULL, 184, NULL, NULL, 231704),
(249495, '2z06A00', NULL, NULL, 252, NULL, NULL, 231704),
(249496, '1xzwA02', NULL, NULL, 305, NULL, NULL, 231704),
(249497, '6hwrA02', NULL, NULL, 310, NULL, NULL, 231704),
(249498, '3ztvA01', NULL, NULL, 356, NULL, NULL, 231704),
(249499, '3t1iD01', NULL, NULL, 298, NULL, NULL, 231704),
(249500, '1hp1A01', NULL, NULL, 328, NULL, NULL, 231704),
(249501, '2dfjA00', NULL, NULL, 280, NULL, NULL, 231704),
(249502, '1ii7A01', NULL, NULL, 249, NULL, NULL, 231704),
(249503, '1qhwA00', NULL, NULL, 302, NULL, NULL, 231704),
(249504, '1s3lA00', NULL, NULL, 165, NULL, NULL, 231704),
(249505, '5inbA00', NULL, NULL, 305, NULL, NULL, 231704),
(249506, '5xcjB00', NULL, NULL, 193, NULL, NULL, 231704),
(249507, '4il1A02', NULL, NULL, 330, NULL, NULL, 231704),
(249508, '5jpfA00', NULL, NULL, 297, NULL, NULL, 231704),
(249509, '4orcA01', NULL, NULL, 325, NULL, NULL, 231704),
(249510, '4movB00', NULL, NULL, 299, NULL, NULL, 231704),
(249511, '2yvtA00', NULL, NULL, 260, NULL, NULL, 231704),
(249512, '2z72A00', NULL, NULL, 342, NULL, NULL, 231704),
(249513, '3qfmA00', NULL, NULL, 270, NULL, NULL, 231704),
(249514, '3ib7A00', NULL, NULL, 310, NULL, NULL, 231704),
(249515, '1v5rA00', NULL, NULL, 97, NULL, NULL, 231705),
(249516, '1qv9A01', NULL, NULL, 155, NULL, NULL, 231706),
(249517, '1u6kB01', NULL, NULL, 155, NULL, NULL, 231706),
(249518, '1u6kC01', NULL, NULL, 155, NULL, NULL, 231706),
(249519, '3iqeA01', NULL, NULL, 156, NULL, NULL, 231706),
(249520, '1u6kA01', NULL, NULL, 155, NULL, NULL, 231706),
(249521, '1qv9B01', NULL, NULL, 155, NULL, NULL, 231706),
(249522, '1qv9C01', NULL, NULL, 155, NULL, NULL, 231706),
(249523, '1iznB03', NULL, NULL, 31, NULL, NULL, 231707),
(249524, '2kerA00', NULL, NULL, 78, NULL, NULL, 231708),
(249525, '1ok0A00', NULL, NULL, 74, NULL, NULL, 231708),
(249526, '3qq5A03', NULL, NULL, 111, NULL, NULL, 231709),
(249527, '5kh0A03', NULL, NULL, 113, NULL, NULL, 231709),
(249528, '4htiA00', NULL, NULL, 99, NULL, NULL, 231710),
(249529, '3n01A00', NULL, NULL, 89, NULL, NULL, 231710),
(249530, '2hsnA02', NULL, NULL, 107, NULL, NULL, 231711),
(249531, '2pfdA02', NULL, NULL, 145, NULL, NULL, 231712),
(249532, '1qd1B02', NULL, NULL, 145, NULL, NULL, 231712),
(249533, '2fz6C00', NULL, NULL, 75, NULL, NULL, 231713),
(249534, '2k6aA00', NULL, NULL, 68, NULL, NULL, 231713),
(249535, '4aogA00', NULL, NULL, 80, NULL, NULL, 231713),
(249536, '2b97A00', NULL, NULL, 71, NULL, NULL, 231713),
(249537, '4bwhA00', NULL, NULL, 88, NULL, NULL, 231713),
(249538, '3gztB01', NULL, NULL, 150, NULL, NULL, 231714),
(249539, '3fmgA01', NULL, NULL, 162, NULL, NULL, 231714),
(249540, '2fl4A01', NULL, NULL, 43, NULL, NULL, 231715),
(249541, '4ag6D01', NULL, NULL, 101, NULL, NULL, 231716),
(249542, '4qnlA01', NULL, NULL, 96, NULL, NULL, 231717),
(249543, '4oj5A01', NULL, NULL, 95, NULL, NULL, 231717),
(249544, '2hg6A00', NULL, NULL, 106, NULL, NULL, 231718),
(249545, '4ph8A00', NULL, NULL, 156, NULL, NULL, 231719),
(249546, '2mpvA00', NULL, NULL, 145, NULL, NULL, 231719),
(249547, '3prbA03', NULL, NULL, 82, NULL, NULL, 231720),
(249548, '3e7jA03', NULL, NULL, 96, NULL, NULL, 231721),
(249549, '2qggA02', NULL, NULL, 84, NULL, NULL, 231722),
(249550, '3htrB00', NULL, NULL, 95, NULL, NULL, 231722),
(249551, '1pm3A00', NULL, NULL, 78, NULL, NULL, 231722),
(249552, '3h9nA02', NULL, NULL, 88, NULL, NULL, 231722),
(249553, '2dyiA02', NULL, NULL, 71, NULL, NULL, 231722),
(249554, '2f1lA02', NULL, NULL, 75, NULL, NULL, 231722),
(249555, '3l9dA02', NULL, NULL, 54, NULL, NULL, 231723),
(249556, '5dedF02', NULL, NULL, 48, NULL, NULL, 231723),
(249557, '5decA02', NULL, NULL, 64, NULL, NULL, 231723),
(249558, '2be3B02', NULL, NULL, 54, NULL, NULL, 231723),
(249559, '4bhqA00', NULL, NULL, 114, NULL, NULL, 231724);
INSERT INTO "PUBLIC"."MODEL" VALUES
(249560, '2b39A03', NULL, NULL, 125, NULL, NULL, 231725),
(249561, '2pn5A03', NULL, NULL, 105, NULL, NULL, 231725),
(249562, '3hrzA03', NULL, NULL, 120, NULL, NULL, 231725),
(249563, '2qkiA03', NULL, NULL, 122, NULL, NULL, 231725),
(249564, '5jtwA03', NULL, NULL, 127, NULL, NULL, 231725),
(249565, '3cu7A03', NULL, NULL, 128, NULL, NULL, 231725),
(249566, '1musA02', NULL, NULL, 276, NULL, NULL, 231726),
(249567, '4fzlA01', NULL, NULL, 87, NULL, NULL, 231727),
(249568, '2c3aA00', NULL, NULL, 286, NULL, NULL, 231728),
(249569, '2c36A00', NULL, NULL, 285, NULL, NULL, 231728),
(249570, '3w9eC00', NULL, NULL, 229, NULL, NULL, 231728),
(249571, '1l2gA00', NULL, NULL, 257, NULL, NULL, 231728),
(249572, '4gl6A01', NULL, NULL, 86, NULL, NULL, 231729),
(249573, '2fgtA03', NULL, NULL, 144, NULL, NULL, 231730),
(249574, '2o3oA02', NULL, NULL, 120, NULL, NULL, 231730),
(249575, '2obeA03', NULL, NULL, 152, NULL, NULL, 231731),
(249576, '1p2zA02', NULL, NULL, 152, NULL, NULL, 231731),
(249577, '2kn8A00', NULL, NULL, 68, NULL, NULL, 231732),
(249578, '3kihC01', NULL, NULL, 36, NULL, NULL, 231733),
(249579, '3cygA01', NULL, NULL, 121, NULL, NULL, 231734),
(249580, '2hhiA01', NULL, NULL, 118, NULL, NULL, 231734),
(249581, '3s5tA01', NULL, NULL, 165, NULL, NULL, 231734),
(249582, '5jenA01', NULL, NULL, 111, NULL, NULL, 231734),
(249583, '4e72A01', NULL, NULL, 131, NULL, NULL, 231734),
(249584, '3k7dA01', NULL, NULL, 113, NULL, NULL, 231735),
(249585, '3lazA01', NULL, NULL, 79, NULL, NULL, 231736),
(249586, '3k3sH01', NULL, NULL, 83, NULL, NULL, 231736),
(249587, '5h3xA03', NULL, NULL, 39, NULL, NULL, 231737),
(249588, '3doaA03', NULL, NULL, 53, NULL, NULL, 231737),
(249589, '3gzfD00', NULL, NULL, 96, NULL, NULL, 231738),
(249590, '3vc8B00', NULL, NULL, 94, NULL, NULL, 231738),
(249591, '5fo8B03', NULL, NULL, 121, NULL, NULL, 231739),
(249592, '2b39A10', NULL, NULL, 116, NULL, NULL, 231739),
(249593, '3cu7A10', NULL, NULL, 115, NULL, NULL, 231739),
(249594, '2pn5A08', NULL, NULL, 111, NULL, NULL, 231739),
(249595, '5jpnB04', NULL, NULL, 121, NULL, NULL, 231739),
(249596, '4lnvA08', NULL, NULL, 111, NULL, NULL, 231739),
(249597, '4h61A00', NULL, NULL, 139, NULL, NULL, 231740),
(249598, '4mfkA02', NULL, NULL, 151, NULL, NULL, 231741),
(249599, '4mfzA02', NULL, NULL, 147, NULL, NULL, 231741),
(249600, '4fioC02', NULL, NULL, 203, NULL, NULL, 231742),
(249601, '1qlmA02', NULL, NULL, 198, NULL, NULL, 231742),
(249602, '4gvqA02', NULL, NULL, 198, NULL, NULL, 231742),
(249603, '3a9sA01', NULL, NULL, 180, NULL, NULL, 231743),
(249604, '1fuiA01', NULL, NULL, 175, NULL, NULL, 231743),
(249605, '4c20A01', NULL, NULL, 172, NULL, NULL, 231743),
(249606, '2zciD03', NULL, NULL, 280, NULL, NULL, 231744),
(249607, '1ytmA03', NULL, NULL, 253, NULL, NULL, 231744),
(249608, '1j3bA03', NULL, NULL, 253, NULL, NULL, 231744),
(249609, '4gmuA03', NULL, NULL, 268, NULL, NULL, 231744),
(249610, '4wl8A03', NULL, NULL, 278, NULL, NULL, 231744),
(249611, '2fafA03', NULL, NULL, 276, NULL, NULL, 231744),
(249612, '6at4A03', NULL, NULL, 251, NULL, NULL, 231744),
(249613, '1ylhA03', NULL, NULL, 253, NULL, NULL, 231744),
(249614, '1ii2A03', NULL, NULL, 256, NULL, NULL, 231744),
(249615, '1khbA03', NULL, NULL, 276, NULL, NULL, 231744),
(249616, '2q18X01', NULL, NULL, 70, NULL, NULL, 231745),
(249617, '2x1dA02', NULL, NULL, 74, NULL, NULL, 231746),
(249618, '1xszA03', NULL, NULL, 157, NULL, NULL, 231747),
(249619, '4d7qA03', NULL, NULL, 149, NULL, NULL, 231747),
(249620, '2mjfB00', NULL, NULL, 95, NULL, NULL, 231748),
(249621, '2kssA01', NULL, NULL, 63, NULL, NULL, 231749),
(249622, '4hteA03', NULL, NULL, 81, NULL, NULL, 231750),
(249623, '4e6nA02', NULL, NULL, 77, NULL, NULL, 231751),
(249624, '2pfzA00', NULL, NULL, 301, NULL, NULL, 231752),
(249625, '4nguA00', NULL, NULL, 319, NULL, NULL, 231752),
(249626, '4nx1A00', NULL, NULL, 326, NULL, NULL, 231752),
(249627, '4o94B00', NULL, NULL, 309, NULL, NULL, 231752),
(249628, '4n8gD00', NULL, NULL, 325, NULL, NULL, 231752),
(249629, '4nq8A00', NULL, NULL, 300, NULL, NULL, 231752),
(249630, '4ovrA00', NULL, NULL, 299, NULL, NULL, 231752);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(249631, '2vpnA00', NULL, NULL, 316, NULL, NULL, 231752),
(249632, '4uabB00', NULL, NULL, 317, NULL, NULL, 231752),
(249633, '4x8rA00', NULL, NULL, 304, NULL, NULL, 231752),
(249634, '3fxbA00', NULL, NULL, 326, NULL, NULL, 231752),
(249635, '4petA01', NULL, NULL, 218, NULL, NULL, 231752),
(249636, '4nf0A00', NULL, NULL, 291, NULL, NULL, 231752),
(249637, '4pfiA00', NULL, NULL, 309, NULL, NULL, 231752),
(249638, '4mx6A00', NULL, NULL, 312, NULL, NULL, 231752),
(249639, '4mncA00', NULL, NULL, 305, NULL, NULL, 231752),
(249640, '3u65A00', NULL, NULL, 328, NULL, NULL, 231752),
(249641, '4mcoA00', NULL, NULL, 316, NULL, NULL, 231752),
(249642, '4x26A01', NULL, NULL, 219, NULL, NULL, 231752),
(249643, '4mijA00', NULL, NULL, 307, NULL, NULL, 231752),
(249644, '4pe3A00', NULL, NULL, 315, NULL, NULL, 231752),
(249645, '4mmpA00', NULL, NULL, 308, NULL, NULL, 231752),
(249646, '5cm6B01', NULL, NULL, 218, NULL, NULL, 231752),
(249647, '4pfbA00', NULL, NULL, 308, NULL, NULL, 231752),
(249648, '2zzvA00', NULL, NULL, 330, NULL, NULL, 231752),
(249649, '4ovsA00', NULL, NULL, 309, NULL, NULL, 231752),
(249650, '4pf6A00', NULL, NULL, 306, NULL, NULL, 231752),
(249651, '4oanB00', NULL, NULL, 310, NULL, NULL, 231752),
(249652, '4nhbA00', NULL, NULL, 313, NULL, NULL, 231752),
(249653, '4pf8B00', NULL, NULL, 302, NULL, NULL, 231752),
(249654, '4pakA00', NULL, NULL, 303, NULL, NULL, 231752),
(249655, '4yzzA01', NULL, NULL, 218, NULL, NULL, 231752),
(249656, '4p1eA00', NULL, NULL, 298, NULL, NULL, 231752),
(249657, '4napD00', NULL, NULL, 312, NULL, NULL, 231752),
(249658, '4napB00', NULL, NULL, 312, NULL, NULL, 231752),
(249659, '4p47A00', NULL, NULL, 320, NULL, NULL, 231752),
(249660, '4pc9A00', NULL, NULL, 322, NULL, NULL, 231752),
(249661, '4pgnA00', NULL, NULL, 310, NULL, NULL, 231752),
(249662, '2hpgC00', NULL, NULL, 327, NULL, NULL, 231752),
(249663, '2hzlB01', NULL, NULL, 218, NULL, NULL, 231752),
(249664, '5im2A00', NULL, NULL, 322, NULL, NULL, 231752),
(249665, '4pbhA00', NULL, NULL, 308, NULL, NULL, 231752),
(249666, '4magA00', NULL, NULL, 307, NULL, NULL, 231752),
(249667, '4ovtA00', NULL, NULL, 301, NULL, NULL, 231752),
(249668, '4xfeA00', NULL, NULL, 317, NULL, NULL, 231752),
(249669, '4p1lA00', NULL, NULL, 302, NULL, NULL, 231752),
(249670, '4pfrA00', NULL, NULL, 307, NULL, NULL, 231752),
(249671, '4n6kA00', NULL, NULL, 323, NULL, NULL, 231752),
(249672, '5i7iA00', NULL, NULL, 318, NULL, NULL, 231752),
(249673, '4pdhA00', NULL, NULL, 301, NULL, NULL, 231752),
(249674, '4pddA00', NULL, NULL, 303, NULL, NULL, 231752),
(249675, '4x26B01', NULL, NULL, 219, NULL, NULL, 231752),
(249676, '5cm6A01', NULL, NULL, 218, NULL, NULL, 231752),
(249677, '4xeqA00', NULL, NULL, 305, NULL, NULL, 231752),
(249678, '4n91A00', NULL, NULL, 318, NULL, NULL, 231752),
(249679, '4petB01', NULL, NULL, 217, NULL, NULL, 231752),
(249680, '4n8yA00', NULL, NULL, 308, NULL, NULL, 231752),
(249681, '4mnpA00', NULL, NULL, 312, NULL, NULL, 231752),
(249682, '4o8mD00', NULL, NULL, 301, NULL, NULL, 231752),
(249683, '4p56A00', NULL, NULL, 317, NULL, NULL, 231752),
(249684, '4n17A00', NULL, NULL, 309, NULL, NULL, 231752),
(249685, '4ng7A00', NULL, NULL, 305, NULL, NULL, 231752),
(249686, '4pf8A00', NULL, NULL, 301, NULL, NULL, 231752),
(249687, '4ovqA00', NULL, NULL, 302, NULL, NULL, 231752),
(249688, '4pbqA00', NULL, NULL, 304, NULL, NULL, 231752),
(249689, '4n4uB00', NULL, NULL, 302, NULL, NULL, 231752),
(249690, '4o7mD00', NULL, NULL, 304, NULL, NULL, 231752),
(249691, '4n6dA00', NULL, NULL, 319, NULL, NULL, 231752),
(249692, '4napC00', NULL, NULL, 312, NULL, NULL, 231752),
(249693, '2pfyA00', NULL, NULL, 301, NULL, NULL, 231752),
(249694, '4napA00', NULL, NULL, 312, NULL, NULL, 231752),
(249695, '2xwvA00', NULL, NULL, 312, NULL, NULL, 231752),
(249696, '4nn3A00', NULL, NULL, 311, NULL, NULL, 231752),
(249697, '4p8bA00', NULL, NULL, 314, NULL, NULL, 231752),
(249698, '4x04A00', NULL, NULL, 300, NULL, NULL, 231752),
(249699, '6iw3A00', NULL, NULL, 82, NULL, NULL, 231753),
(249700, '1wspA00', NULL, NULL, 84, NULL, NULL, 231753),
(249701, '3pz8A00', NULL, NULL, 86, NULL, NULL, 231753);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(249702, '3pz7A00', NULL, NULL, 91, NULL, NULL, 231753),
(249703, '5y3cA00', NULL, NULL, 85, NULL, NULL, 231753),
(249704, '5y3bA00', NULL, NULL, 86, NULL, NULL, 231753),
(249705, '1yueA03', NULL, NULL, 126, NULL, NULL, 231754),
(249706, '1kpsB00', NULL, NULL, 171, NULL, NULL, 231755),
(249707, '2grrB00', NULL, NULL, 170, NULL, NULL, 231755),
(249708, '1ahsA00', NULL, NULL, 126, NULL, NULL, 231756),
(249709, '1bvp102', NULL, NULL, 133, NULL, NULL, 231756),
(249710, '1uf2C02', NULL, NULL, 157, NULL, NULL, 231756),
(249711, '1qhdA01', NULL, NULL, 170, NULL, NULL, 231756),
(249712, '1tx9A00', NULL, NULL, 151, NULL, NULL, 231757),
(249713, '1vclA03', NULL, NULL, 148, NULL, NULL, 231758),
(249714, '5me7A00', NULL, NULL, 186, NULL, NULL, 231759),
(249715, '2idrA00', NULL, NULL, 177, NULL, NULL, 231759),
(249716, '1ztpA01', NULL, NULL, 219, NULL, NULL, 231759),
(249717, '6fc0A00', NULL, NULL, 200, NULL, NULL, 231759),
(249718, '5m7zB00', NULL, NULL, 190, NULL, NULL, 231759),
(249719, '2wmcA00', NULL, NULL, 178, NULL, NULL, 231759),
(249720, '5t46C00', NULL, NULL, 188, NULL, NULL, 231759),
(249721, '5abxA00', NULL, NULL, 190, NULL, NULL, 231759),
(249722, '1ap8A00', NULL, NULL, 213, NULL, NULL, 231759),
(249723, '3m94A00', NULL, NULL, 189, NULL, NULL, 231759),
(249724, '4ue8A00', NULL, NULL, 184, NULL, NULL, 231759),
(249725, '4b6uA00', NULL, NULL, 207, NULL, NULL, 231759),
(249726, '2jgbA01', NULL, NULL, 173, NULL, NULL, 231759),
(249727, '3hxiA01', NULL, NULL, 171, NULL, NULL, 231759),
(249728, '1m5q102', NULL, NULL, 58, NULL, NULL, 231760),
(249729, '1m5qB02', NULL, NULL, 57, NULL, NULL, 231760),
(249730, '1s2xA00', NULL, NULL, 186, NULL, NULL, 231761),
(249731, '2rt6A00', NULL, NULL, 98, NULL, NULL, 231762),
(249732, '4o2cA01', NULL, NULL, 181, NULL, NULL, 231763),
(249733, '3wl9A01', NULL, NULL, 182, NULL, NULL, 231763),
(249734, '6c98A01', NULL, NULL, 175, NULL, NULL, 231763),
(249735, '1e27A01', NULL, NULL, 181, NULL, NULL, 231763),
(249736, '3ln4A01', NULL, NULL, 181, NULL, NULL, 231763),
(249737, '5m02A01', NULL, NULL, 181, NULL, NULL, 231763),
(249738, '4cw1A01', NULL, NULL, 178, NULL, NULL, 231763),
(249739, '3l9rA01', NULL, NULL, 176, NULL, NULL, 231763),
(249740, '3rwiA01', NULL, NULL, 181, NULL, NULL, 231763),
(249741, '5vclA01', NULL, NULL, 182, NULL, NULL, 231763),
(249742, '3s6cA02', NULL, NULL, 175, NULL, NULL, 231763),
(249743, '1r3hA01', NULL, NULL, 166, NULL, NULL, 231763),
(249744, '3jvgA01', NULL, NULL, 178, NULL, NULL, 231763),
(249745, '5j1aA01', NULL, NULL, 175, NULL, NULL, 231763),
(249746, '1pqzA01', NULL, NULL, 137, NULL, NULL, 231763),
(249747, '3bwaA01', NULL, NULL, 181, NULL, NULL, 231763),
(249748, '3vj6A01', NULL, NULL, 181, NULL, NULL, 231763),
(249749, '6ei2A01', NULL, NULL, 182, NULL, NULL, 231763),
(249750, '1efxA01', NULL, NULL, 181, NULL, NULL, 231763),
(249751, '4iiqC02', NULL, NULL, 178, NULL, NULL, 231763),
(249752, '5nq0A01', NULL, NULL, 181, NULL, NULL, 231763),
(249753, '4d0dA01', NULL, NULL, 178, NULL, NULL, 231763),
(249754, '1kjvA01', NULL, NULL, 181, NULL, NULL, 231763),
(249755, '1zvsA01', NULL, NULL, 181, NULL, NULL, 231763),
(249756, '1a1mA01', NULL, NULL, 181, NULL, NULL, 231763),
(249757, '1k5nA01', NULL, NULL, 181, NULL, NULL, 231763),
(249758, '3fonA01', NULL, NULL, 181, NULL, NULL, 231763),
(249759, '4g43A01', NULL, NULL, 181, NULL, NULL, 231763),
(249760, '3it8D01', NULL, NULL, 180, NULL, NULL, 231763),
(249761, '5j6hA01', NULL, NULL, 182, NULL, NULL, 231763),
(249762, '5gsbA01', NULL, NULL, 181, NULL, NULL, 231763),
(249763, '4lcyA01', NULL, NULL, 181, NULL, NULL, 231763),
(249764, '5weuA01', NULL, NULL, 181, NULL, NULL, 231763),
(249765, '1mhcA01', NULL, NULL, 181, NULL, NULL, 231763),
(249766, '3p73A01', NULL, NULL, 180, NULL, NULL, 231763),
(249767, '1x7qA01', NULL, NULL, 181, NULL, NULL, 231763),
(249768, '1hyrC01', NULL, NULL, 180, NULL, NULL, 231763),
(249769, '2xfxA01', NULL, NULL, 181, NULL, NULL, 231763),
(249770, '5gjyA01', NULL, NULL, 181, NULL, NULL, 231763),
(249771, '3jtsA01', NULL, NULL, 181, NULL, NULL, 231763),
(249772, '3eryA00', NULL, NULL, 174, NULL, NULL, 231763);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(249773, '5wl1A01', NULL, NULL, 176, NULL, NULL, 231763),
(249774, '3tidA01', NULL, NULL, 188, NULL, NULL, 231763),
(249775, '1t7vA01', NULL, NULL, 178, NULL, NULL, 231763),
(249776, '3fruA01', NULL, NULL, 177, NULL, NULL, 231763),
(249777, '3kyoA01', NULL, NULL, 180, NULL, NULL, 231763),
(249778, '3bo8A01', NULL, NULL, 181, NULL, NULL, 231763),
(249779, '3mreA01', NULL, NULL, 181, NULL, NULL, 231763),
(249780, '4zuuA01', NULL, NULL, 181, NULL, NULL, 231763),
(249781, '4g59B00', NULL, NULL, 176, NULL, NULL, 231763),
(249782, '6mt3A01', NULL, NULL, 181, NULL, NULL, 231763),
(249783, '1lqvB00', NULL, NULL, 193, NULL, NULL, 231763),
(249784, '4f7eA01', NULL, NULL, 182, NULL, NULL, 231763),
(249785, '5h94A01', NULL, NULL, 181, NULL, NULL, 231763),
(249786, '5f1nA01', NULL, NULL, 182, NULL, NULL, 231763),
(249787, '3d2uE01', NULL, NULL, 189, NULL, NULL, 231763),
(249788, '2wy3A00', NULL, NULL, 176, NULL, NULL, 231763),
(249789, '5h5zA01', NULL, NULL, 177, NULL, NULL, 231763),
(249790, '1kcgC00', NULL, NULL, 178, NULL, NULL, 231763),
(249791, '4u1mA01', NULL, NULL, 181, NULL, NULL, 231763),
(249792, '6mtlA01', NULL, NULL, 181, NULL, NULL, 231763),
(249793, '1k8dA01', NULL, NULL, 181, NULL, NULL, 231763),
(249794, '3gmoA01', NULL, NULL, 184, NULL, NULL, 231763),
(249795, '1lk2A01', NULL, NULL, 181, NULL, NULL, 231763),
(249796, '3pwuA01', NULL, NULL, 180, NULL, NULL, 231763),
(249797, '5xmfA01', NULL, NULL, 181, NULL, NULL, 231763),
(249798, '1zs8A01', NULL, NULL, 180, NULL, NULL, 231763),
(249799, '3bevA01', NULL, NULL, 178, NULL, NULL, 231763),
(249800, '5ylxA01', NULL, NULL, 181, NULL, NULL, 231763),
(249801, '4ww2C01', NULL, NULL, 183, NULL, NULL, 231763),
(249802, '6bmhA01', NULL, NULL, 181, NULL, NULL, 231763),
(249803, '3spvA01', NULL, NULL, 181, NULL, NULL, 231763),
(249804, '4zfzA01', NULL, NULL, 182, NULL, NULL, 231763),
(249805, '3qq4A01', NULL, NULL, 181, NULL, NULL, 231763),
(249806, '1qqdA01', NULL, NULL, 180, NULL, NULL, 231763),
(249807, '4s0uC00', NULL, NULL, 175, NULL, NULL, 231763),
(249808, '3dbxA01', NULL, NULL, 186, NULL, NULL, 231763),
(249809, '6mt6A01', NULL, NULL, 181, NULL, NULL, 231763),
(249810, '1zt1A01', NULL, NULL, 182, NULL, NULL, 231763),
(249811, '1c16A01', NULL, NULL, 163, NULL, NULL, 231763),
(249812, '1a6zA01', NULL, NULL, 182, NULL, NULL, 231763),
(249813, '5nq2A01', NULL, NULL, 182, NULL, NULL, 231763),
(249814, '4pp8D00', NULL, NULL, 174, NULL, NULL, 231763),
(249815, '5iueA01', NULL, NULL, 181, NULL, NULL, 231763),
(249816, '4l4vC01', NULL, NULL, 179, NULL, NULL, 231763),
(249817, '1ld9A01', NULL, NULL, 181, NULL, NULL, 231763),
(249818, '6gh1A01', NULL, NULL, 180, NULL, NULL, 231763),
(249819, '5c9jA01', NULL, NULL, 177, NULL, NULL, 231763),
(249820, '5ymwA01', NULL, NULL, 179, NULL, NULL, 231763),
(249821, '4nt6A01', NULL, NULL, 181, NULL, NULL, 231763),
(249822, '5w6aA01', NULL, NULL, 181, NULL, NULL, 231763),
(249823, '1kjmA01', NULL, NULL, 181, NULL, NULL, 231763),
(249824, '4pdcE00', NULL, NULL, 150, NULL, NULL, 231763),
(249825, '2bvpA01', NULL, NULL, 181, NULL, NULL, 231763),
(249826, '1nezA01', NULL, NULL, 181, NULL, NULL, 231763),
(249827, '3k50A01', NULL, NULL, 104, NULL, NULL, 231764),
(249828, '2oyoA01', NULL, NULL, 52, NULL, NULL, 231765),
(249829, '3c1lA01', NULL, NULL, 50, NULL, NULL, 231765),
(249830, '2prrA01', NULL, NULL, 53, NULL, NULL, 231765),
(249831, '2pfxB01', NULL, NULL, 51, NULL, NULL, 231765),
(249832, '2pfxA01', NULL, NULL, 51, NULL, NULL, 231765),
(249833, '3l4gC03', NULL, NULL, 53, NULL, NULL, 231766),
(249834, '4bsxA00', NULL, NULL, 156, NULL, NULL, 231767),
(249835, '1mswD01', NULL, NULL, 318, NULL, NULL, 231768),
(249836, '4dqnA01', NULL, NULL, 163, NULL, NULL, 231769),
(249837, '5cm0B01', NULL, NULL, 129, NULL, NULL, 231769),
(249838, '6nstB01', NULL, NULL, 122, NULL, NULL, 231769),
(249839, '3wwhA01', NULL, NULL, 154, NULL, NULL, 231769),
(249840, '3wwjA01', NULL, NULL, 154, NULL, NULL, 231769),
(249841, '1iyeA01', NULL, NULL, 139, NULL, NULL, 231769),
(249842, '3cswC01', NULL, NULL, 116, NULL, NULL, 231769),
(249843, '4tviA01', NULL, NULL, 126, NULL, NULL, 231769);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(249844, '4chiB01', NULL, NULL, 145, NULL, NULL, 231769),
(249845, '5k3wA01', NULL, NULL, 139, NULL, NULL, 231769),
(249846, '2eiyB01', NULL, NULL, 126, NULL, NULL, 231769),
(249847, '4pbcB01', NULL, NULL, 144, NULL, NULL, 231769),
(249848, '3qqmA01', NULL, NULL, 88, NULL, NULL, 231769),
(249849, '6bb9A01', NULL, NULL, 114, NULL, NULL, 231769),
(249850, '4tm5A01', NULL, NULL, 145, NULL, NULL, 231769),
(249851, '3u0gD01', NULL, NULL, 131, NULL, NULL, 231769),
(249852, '2hhfA01', NULL, NULL, 183, NULL, NULL, 231769),
(249853, '4jxuA01', NULL, NULL, 137, NULL, NULL, 231769),
(249854, '4cmfA01', NULL, NULL, 145, NULL, NULL, 231769),
(249855, '2zgiA01', NULL, NULL, 100, NULL, NULL, 231769),
(249856, '3snoA01', NULL, NULL, 132, NULL, NULL, 231769),
(249857, '2y4rA01', NULL, NULL, 110, NULL, NULL, 231769),
(249858, '3lulA01', NULL, NULL, 116, NULL, NULL, 231769),
(249859, '4ce5A01', NULL, NULL, 146, NULL, NULL, 231769),
(249860, '1i2kA01', NULL, NULL, 108, NULL, NULL, 231769),
(249861, '5ce8A01', NULL, NULL, 134, NULL, NULL, 231769),
(249862, '3uzoA01', NULL, NULL, 155, NULL, NULL, 231769),
(249863, '5mr0D01', NULL, NULL, 128, NULL, NULL, 231769),
(249864, '3dtgA01', NULL, NULL, 199, NULL, NULL, 231769),
(249865, '2coiB01', NULL, NULL, 183, NULL, NULL, 231769),
(249866, '6fteB01', NULL, NULL, 145, NULL, NULL, 231769),
(249867, '3daaA01', NULL, NULL, 118, NULL, NULL, 231769),
(249868, '3cebA01', NULL, NULL, 85, NULL, NULL, 231769),
(249869, '5u3fB01', NULL, NULL, 140, NULL, NULL, 231769),
(249870, '1zvzA01', NULL, NULL, 129, NULL, NULL, 231770),
(249871, '4iggB02', NULL, NULL, 121, NULL, NULL, 231770),
(249872, '5xflC02', NULL, NULL, 128, NULL, NULL, 231770),
(249873, '5h5mA02', NULL, NULL, 146, NULL, NULL, 231770),
(249874, '1h6gA01', NULL, NULL, 119, NULL, NULL, 231770),
(249875, '1h6gA02', NULL, NULL, 126, NULL, NULL, 231770),
(249876, '2l7aA00', NULL, NULL, 131, NULL, NULL, 231770),
(249877, '1rkeB00', NULL, NULL, 185, NULL, NULL, 231770),
(249878, '3rf3B01', NULL, NULL, 129, NULL, NULL, 231770),
(249879, '3rf3A02', NULL, NULL, 129, NULL, NULL, 231770),
(249880, '1u89A00', NULL, NULL, 139, NULL, NULL, 231770),
(249881, '2lqgA00', NULL, NULL, 138, NULL, NULL, 231770),
(249882, '2b0hA01', NULL, NULL, 128, NULL, NULL, 231770),
(249883, '4iggB06', NULL, NULL, 215, NULL, NULL, 231770),
(249884, '3myiA00', NULL, NULL, 172, NULL, NULL, 231770),
(249885, '1tr2A05', NULL, NULL, 171, NULL, NULL, 231770),
(249886, '1tr2A04', NULL, NULL, 117, NULL, NULL, 231770),
(249887, '1tr2B05', NULL, NULL, 171, NULL, NULL, 231770),
(249888, '1qkrB00', NULL, NULL, 188, NULL, NULL, 231770),
(249889, '1sj8A02', NULL, NULL, 129, NULL, NULL, 231770),
(249890, '6duwA00', NULL, NULL, 192, NULL, NULL, 231770),
(249891, '1dowA00', NULL, NULL, 205, NULL, NULL, 231770),
(249892, '1yo7A00', NULL, NULL, 120, NULL, NULL, 231770),
(249893, '4p9tA01', NULL, NULL, 132, NULL, NULL, 231770),
(249894, '5w93A00', NULL, NULL, 137, NULL, NULL, 231770),
(249895, '6dv1A00', NULL, NULL, 219, NULL, NULL, 231770),
(249896, '4w8pA02', NULL, NULL, 130, NULL, NULL, 231770),
(249897, '4p9tA02', NULL, NULL, 112, NULL, NULL, 231770),
(249898, '3qgaA02', NULL, NULL, 122, NULL, NULL, 231771),
(249899, '1e9yA01', NULL, NULL, 133, NULL, NULL, 231771),
(249900, '4gy7A03', NULL, NULL, 113, NULL, NULL, 231771),
(249901, '4z42B00', NULL, NULL, 114, NULL, NULL, 231771),
(249902, '4g7eB03', NULL, NULL, 113, NULL, NULL, 231771),
(249903, '4ep8B00', NULL, NULL, 101, NULL, NULL, 231771),
(249904, '5ol4B00', NULL, NULL, 122, NULL, NULL, 231771),
(249905, '4i6jB01', NULL, NULL, 42, NULL, NULL, 231772),
(249906, '1fs1A00', NULL, NULL, 53, NULL, NULL, 231772),
(249907, '5ibkE00', NULL, NULL, 63, NULL, NULL, 231772),
(249908, '3ogkB01', NULL, NULL, 52, NULL, NULL, 231772),
(249909, '2e31A01', NULL, NULL, 67, NULL, NULL, 231772),
(249910, '5ibkB00', NULL, NULL, 47, NULL, NULL, 231772),
(249911, '1ldkE00', NULL, NULL, 41, NULL, NULL, 231772),
(249912, '3l2oB01', NULL, NULL, 92, NULL, NULL, 231772),
(249913, '3wsoA01', NULL, NULL, 67, NULL, NULL, 231772),
(249914, '3v7dD01', NULL, NULL, 109, NULL, NULL, 231772); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(249915, '2p1oB01', NULL, NULL, 45, NULL, NULL, 231772),
(249916, '6m90A01', NULL, NULL, 108, NULL, NULL, 231772),
(249917, '2ovrB01', NULL, NULL, 87, NULL, NULL, 231772),
(249918, '3fdeB01', NULL, NULL, 195, NULL, NULL, 231773),
(249919, '4pw7E01', NULL, NULL, 191, NULL, NULL, 231773),
(249920, '2zkgC00', NULL, NULL, 210, NULL, NULL, 231773),
(249921, '3q0bX00', NULL, NULL, 167, NULL, NULL, 231773),
(249922, '3olnA00', NULL, NULL, 192, NULL, NULL, 231773),
(249923, '3bi7A01', NULL, NULL, 195, NULL, NULL, 231773),
(249924, '2yfqB01', NULL, NULL, 56, NULL, NULL, 231774),
(249925, '3aogA01', NULL, NULL, 62, NULL, NULL, 231774),
(249926, '3k8zA01', NULL, NULL, 50, NULL, NULL, 231774),
(249927, '4xgiA01', NULL, NULL, 77, NULL, NULL, 231774),
(249928, '3aoeD01', NULL, NULL, 64, NULL, NULL, 231774),
(249929, '3k92A01', NULL, NULL, 66, NULL, NULL, 231774),
(249930, '2v3mB00', NULL, NULL, 113, NULL, NULL, 231775),
(249931, '2ey4D00', NULL, NULL, 82, NULL, NULL, 231775),
(249932, '3u28C00', NULL, NULL, 92, NULL, NULL, 231775),
(249933, '2eqnA01', NULL, NULL, 87, NULL, NULL, 231775),
(249934, '1ru3A03', NULL, NULL, 178, NULL, NULL, 231776),
(249935, '1oaoC03', NULL, NULL, 176, NULL, NULL, 231776),
(249936, '1wyuB01', NULL, NULL, 78, NULL, NULL, 231777),
(249937, '2kk2A00', NULL, NULL, 61, NULL, NULL, 231778),
(249938, '2nswA00', NULL, NULL, 60, NULL, NULL, 231778),
(249939, '2jmsA01', NULL, NULL, 47, NULL, NULL, 231778),
(249940, '2kc6A01', NULL, NULL, 38, NULL, NULL, 231778),
(249941, '1dquA02', NULL, NULL, 109, NULL, NULL, 231779),
(249942, '4mewA02', NULL, NULL, 88, NULL, NULL, 231780),
(249943, '4i5jA01', NULL, NULL, 116, NULL, NULL, 231780),
(249944, '1dqcA00', NULL, NULL, 74, NULL, NULL, 231781),
(249945, '3pm2A00', NULL, NULL, 173, NULL, NULL, 231782),
(249946, '4ij7A00', NULL, NULL, 172, NULL, NULL, 231782),
(249947, '2hjeA01', NULL, NULL, 157, NULL, NULL, 231783),
(249948, '3c38A01', NULL, NULL, 156, NULL, NULL, 231783),
(249949, '1vt0k00', NULL, NULL, 150, NULL, NULL, 231784),
(249950, '1zc1A01', NULL, NULL, 103, NULL, NULL, 231785),
(249951, '2yujA01', NULL, NULL, 115, NULL, NULL, 231785),
(249952, '5ok4A02', NULL, NULL, 90, NULL, NULL, 231786),
(249953, '2b0jA02', NULL, NULL, 106, NULL, NULL, 231786),
(249954, '4yt2A02', NULL, NULL, 106, NULL, NULL, 231786),
(249955, '3nynA05', NULL, NULL, 25, NULL, NULL, 231787),
(249956, '2kpqA01', NULL, NULL, 74, NULL, NULL, 231788),
(249957, '3k1lA01', NULL, NULL, 96, NULL, NULL, 231789),
(249958, '2b5uA02', NULL, NULL, 161, NULL, NULL, 231790),
(249959, '2ysuB00', NULL, NULL, 135, NULL, NULL, 231790),
(249960, '3c3dA02', NULL, NULL, 88, NULL, NULL, 231791),
(249961, '2kx7A00', NULL, NULL, 117, NULL, NULL, 231792),
(249962, '3m6zA03', NULL, NULL, 75, NULL, NULL, 231793),
(249963, '4kp3C00', NULL, NULL, 84, NULL, NULL, 231794),
(249964, '4omfB02', NULL, NULL, 47, NULL, NULL, 231795),
(249965, '2pqrA01', NULL, NULL, 93, NULL, NULL, 231796),
(249966, '1ouvA00', NULL, NULL, 273, NULL, NULL, 231796),
(249967, '3e4bA00', NULL, NULL, 434, NULL, NULL, 231796),
(249968, '3ro3A00', NULL, NULL, 164, NULL, NULL, 231796),
(249969, '4kbqA00', NULL, NULL, 139, NULL, NULL, 231796),
(249970, '2ifuD00', NULL, NULL, 277, NULL, NULL, 231796),
(249971, '1klxA00', NULL, NULL, 138, NULL, NULL, 231796),
(249972, '4w9rA02', NULL, NULL, 94, NULL, NULL, 231796),
(249973, '4i2zA01', NULL, NULL, 133, NULL, NULL, 231796),
(249974, '4h7yA00', NULL, NULL, 161, NULL, NULL, 231796),
(249975, '5jjtB01', NULL, NULL, 131, NULL, NULL, 231796),
(249976, '4jhrB00', NULL, NULL, 308, NULL, NULL, 231796),
(249977, '2uy1B00', NULL, NULL, 455, NULL, NULL, 231796),
(249978, '4kyoD00', NULL, NULL, 328, NULL, NULL, 231796),
(249979, '3wxxE00', NULL, NULL, 151, NULL, NULL, 231796),
(249980, '3zn3A00', NULL, NULL, 291, NULL, NULL, 231796),
(249981, '1w3bB00', NULL, NULL, 388, NULL, NULL, 231796),
(249982, '3lpzA01', NULL, NULL, 313, NULL, NULL, 231796),
(249983, '4gywA02', NULL, NULL, 111, NULL, NULL, 231796),
(249984, '4u04B01', NULL, NULL, 91, NULL, NULL, 231796),
(249985, '4gywA01', NULL, NULL, 110, NULL, NULL, 231796);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(249986, '4i17A00', NULL, NULL, 228, NULL, NULL, 231796),
(249987, '3q15B00', NULL, NULL, 378, NULL, NULL, 231796),
(249988, '3as8A01', NULL, NULL, 178, NULL, NULL, 231796),
(249989, '2l6jA00', NULL, NULL, 111, NULL, NULL, 231796),
(249990, '4eqfA00', NULL, NULL, 313, NULL, NULL, 231796),
(249991, '3kaeA00', NULL, NULL, 242, NULL, NULL, 231796),
(249992, '4ja7A01', NULL, NULL, 138, NULL, NULL, 231796),
(249993, '1na0A00', NULL, NULL, 125, NULL, NULL, 231796),
(249994, '1qqeA00', NULL, NULL, 292, NULL, NULL, 231796),
(249995, '2pziA04', NULL, NULL, 188, NULL, NULL, 231796),
(249996, '4abnA01', NULL, NULL, 279, NULL, NULL, 231796),
(249997, '1elwA00', NULL, NULL, 118, NULL, NULL, 231796),
(249998, '4cgwA00', NULL, NULL, 117, NULL, NULL, 231796),
(249999, '1xnfA00', NULL, NULL, 275, NULL, NULL, 231796),
(250000, '4j8eA00', NULL, NULL, 119, NULL, NULL, 231796),
(250001, '2y4tB01', NULL, NULL, 334, NULL, NULL, 231796),
(250002, '2fo7A00', NULL, NULL, 136, NULL, NULL, 231796),
(250003, '2e2eA01', NULL, NULL, 151, NULL, NULL, 231796),
(250004, '3ru0A05', NULL, NULL, 83, NULL, NULL, 231796),
(250005, '2mhkA01', NULL, NULL, 125, NULL, NULL, 231796),
(250006, '1hh8A00', NULL, NULL, 193, NULL, NULL, 231796),
(250007, '4ga2A00', NULL, NULL, 150, NULL, NULL, 231796),
(250008, '5waqA00', NULL, NULL, 251, NULL, NULL, 231796),
(250009, '1ihgA02', NULL, NULL, 150, NULL, NULL, 231796),
(250010, '4apoB00', NULL, NULL, 165, NULL, NULL, 231796),
(250011, '2q7fA00', NULL, NULL, 202, NULL, NULL, 231796),
(250012, '3hymL00', NULL, NULL, 311, NULL, NULL, 231796),
(250013, '4wnfA00', NULL, NULL, 259, NULL, NULL, 231796),
(250014, '1elrA00', NULL, NULL, 131, NULL, NULL, 231796),
(250015, '3gw4A00', NULL, NULL, 203, NULL, NULL, 231796),
(250016, '2ff4A02', NULL, NULL, 182, NULL, NULL, 231796),
(250017, '3ma5A00', NULL, NULL, 100, NULL, NULL, 231796),
(250018, '4uqxA01', NULL, NULL, 89, NULL, NULL, 231796),
(250019, '4g1tA03', NULL, NULL, 255, NULL, NULL, 231796),
(250020, '3fp3A01', NULL, NULL, 147, NULL, NULL, 231796),
(250021, '4g1tA02', NULL, NULL, 61, NULL, NULL, 231796),
(250022, '4g1tA01', NULL, NULL, 131, NULL, NULL, 231796),
(250023, '2pziB03', NULL, NULL, 156, NULL, NULL, 231796),
(250024, '1hz4A00', NULL, NULL, 373, NULL, NULL, 231796),
(250025, '2ho1B00', NULL, NULL, 221, NULL, NULL, 231796),
(250026, '2gw1A02', NULL, NULL, 387, NULL, NULL, 231796),
(250027, '2gw1A01', NULL, NULL, 127, NULL, NULL, 231796),
(250028, '2qfcA00', NULL, NULL, 293, NULL, NULL, 231796),
(250029, '3q49B00', NULL, NULL, 137, NULL, NULL, 231796),
(250030, '3nf1A00', NULL, NULL, 311, NULL, NULL, 231796),
(250031, '4in3B00', NULL, NULL, 671, NULL, NULL, 231796),
(250032, '1nznA00', NULL, NULL, 126, NULL, NULL, 231796),
(250033, '4a1sB00', NULL, NULL, 342, NULL, NULL, 231796),
(250034, '2ooeA01', NULL, NULL, 190, NULL, NULL, 231796),
(250035, '3uq3A01', NULL, NULL, 133, NULL, NULL, 231796),
(250036, '2ondA00', NULL, NULL, 308, NULL, NULL, 231796),
(250037, '5g05P02', NULL, NULL, 211, NULL, NULL, 231796),
(250038, '5g05P01', NULL, NULL, 302, NULL, NULL, 231796),
(250039, '4cgvB00', NULL, NULL, 136, NULL, NULL, 231796),
(250040, '4rg9B01', NULL, NULL, 173, NULL, NULL, 231796),
(250041, '4rg9B04', NULL, NULL, 104, NULL, NULL, 231796),
(250042, '2avpA00', NULL, NULL, 70, NULL, NULL, 231796),
(250043, '1pc2A00', NULL, NULL, 152, NULL, NULL, 231796),
(250044, '4i1aA00', NULL, NULL, 274, NULL, NULL, 231796),
(250045, '1iygA00', NULL, NULL, 133, NULL, NULL, 231796),
(250046, '4gcnA00', NULL, NULL, 127, NULL, NULL, 231796),
(250047, '4n5cD06', NULL, NULL, 134, NULL, NULL, 231796),
(250048, '3k9iA01', NULL, NULL, 109, NULL, NULL, 231796),
(250049, '3zheC01', NULL, NULL, 193, NULL, NULL, 231796),
(250050, '3mekA05', NULL, NULL, 75, NULL, NULL, 231796),
(250051, '2fbnA00', NULL, NULL, 153, NULL, NULL, 231796),
(250052, '2vq2A00', NULL, NULL, 225, NULL, NULL, 231796),
(250053, '2v5fA00', NULL, NULL, 104, NULL, NULL, 231796),
(250054, '3beeA00', NULL, NULL, 93, NULL, NULL, 231796),
(250055, '1p5qA02', NULL, NULL, 166, NULL, NULL, 231796),
(250056, '3zfwB00', NULL, NULL, 245, NULL, NULL, 231796);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(250057, '2kckA00', NULL, NULL, 112, NULL, NULL, 231796),
(250058, '4yvoA00', NULL, NULL, 119, NULL, NULL, 231796),
(250059, '2i6hA02', NULL, NULL, 102, NULL, NULL, 231796),
(250060, '4gpkF02', NULL, NULL, 265, NULL, NULL, 231796),
(250061, '3as5A01', NULL, NULL, 178, NULL, NULL, 231796),
(250062, '2vsyA01', NULL, NULL, 142, NULL, NULL, 231796),
(250063, '4g26A01', NULL, NULL, 302, NULL, NULL, 231796),
(250064, '3ks2A00', NULL, NULL, 151, NULL, NULL, 231796),
(250065, '2xgsB01', NULL, NULL, 73, NULL, NULL, 231796),
(250066, '2xgmA01', NULL, NULL, 106, NULL, NULL, 231796),
(250067, '4i1aB01', NULL, NULL, 155, NULL, NULL, 231796),
(250068, '5v37A05', NULL, NULL, 75, NULL, NULL, 231796),
(250069, '1kt0A03', NULL, NULL, 158, NULL, NULL, 231796),
(250070, '4i1aB02', NULL, NULL, 236, NULL, NULL, 231796),
(250071, '2katA00', NULL, NULL, 115, NULL, NULL, 231796),
(250072, '3zheD01', NULL, NULL, 209, NULL, NULL, 231796),
(250073, '3mkrA00', NULL, NULL, 291, NULL, NULL, 231796),
(250074, '3mv2B00', NULL, NULL, 310, NULL, NULL, 231796),
(250075, '4f3vB01', NULL, NULL, 280, NULL, NULL, 231796),
(250076, '2vgxB00', NULL, NULL, 148, NULL, NULL, 231796),
(250077, '2dbaA01', NULL, NULL, 118, NULL, NULL, 231796),
(250078, '6evnA00', NULL, NULL, 102, NULL, NULL, 231796),
(250079, '2xcbA00', NULL, NULL, 142, NULL, NULL, 231796),
(250080, '2pl2A00', NULL, NULL, 197, NULL, NULL, 231796),
(250081, '2xevB00', NULL, NULL, 129, NULL, NULL, 231796),
(250082, '1hxiA00', NULL, NULL, 121, NULL, NULL, 231796),
(250083, '4me2A00', NULL, NULL, 194, NULL, NULL, 231796),
(250084, '3u4tB00', NULL, NULL, 272, NULL, NULL, 231796),
(250085, '3qkyA00', NULL, NULL, 261, NULL, NULL, 231796),
(250086, '3ma5D00', NULL, NULL, 77, NULL, NULL, 231796),
(250087, '3kd7A00', NULL, NULL, 108, NULL, NULL, 231796),
(250088, '3qdnA03', NULL, NULL, 88, NULL, NULL, 231796),
(250089, '4gyoA02', NULL, NULL, 222, NULL, NULL, 231796),
(250090, '3upvA00', NULL, NULL, 126, NULL, NULL, 231796),
(250091, '3qdnA02', NULL, NULL, 84, NULL, NULL, 231796),
(250092, '2if4A02', NULL, NULL, 133, NULL, NULL, 231796),
(250093, '2r5sA01', NULL, NULL, 88, NULL, NULL, 231796),
(250094, '2r5sA02', NULL, NULL, 88, NULL, NULL, 231796),
(250095, '4ui9Y03', NULL, NULL, 80, NULL, NULL, 231796),
(250096, '4j8dD00', NULL, NULL, 175, NULL, NULL, 231796),
(250097, '4leuA00', NULL, NULL, 187, NULL, NULL, 231796),
(250098, '3ulqA00', NULL, NULL, 383, NULL, NULL, 231796),
(250099, '5fzsA00', NULL, NULL, 109, NULL, NULL, 231796),
(250100, '3urzA00', NULL, NULL, 208, NULL, NULL, 231796),
(250101, '4g2vA00', NULL, NULL, 340, NULL, NULL, 231796),
(250102, '6fdpA00', NULL, NULL, 120, NULL, NULL, 231796),
(250103, '2p58C00', NULL, NULL, 116, NULL, NULL, 231796),
(250104, '5ft9A01', NULL, NULL, 303, NULL, NULL, 231796),
(250105, '2vgxA00', NULL, NULL, 148, NULL, NULL, 231796),
(250106, '4houB00', NULL, NULL, 273, NULL, NULL, 231796),
(250107, '2bugA00', NULL, NULL, 140, NULL, NULL, 231796),
(250108, '2uwjG00', NULL, NULL, 115, NULL, NULL, 231796),
(250109, '4gcoA00', NULL, NULL, 126, NULL, NULL, 231796),
(250110, '2kc7A00', NULL, NULL, 99, NULL, NULL, 231796),
(250111, '1zu2A00', NULL, NULL, 158, NULL, NULL, 231796),
(250112, '3fflA00', NULL, NULL, 147, NULL, NULL, 231796),
(250113, '4gyoB01', NULL, NULL, 151, NULL, NULL, 231796),
(250114, '3qouA02', NULL, NULL, 84, NULL, NULL, 231796),
(250115, '3iegA00', NULL, NULL, 359, NULL, NULL, 231796),
(250116, '4wuyA03', NULL, NULL, 200, NULL, NULL, 231796),
(250117, '3ly7A02', NULL, NULL, 162, NULL, NULL, 231796),
(250118, '4nq0A00', NULL, NULL, 266, NULL, NULL, 231796),
(250119, '4horA02', NULL, NULL, 65, NULL, NULL, 231796),
(250120, '3qouA03', NULL, NULL, 88, NULL, NULL, 231796),
(250121, '3rjvA01', NULL, NULL, 147, NULL, NULL, 231796),
(250122, '2hr2A00', NULL, NULL, 159, NULL, NULL, 231796),
(250123, '4horA01', NULL, NULL, 133, NULL, NULL, 231796),
(250124, '4bwrA00', NULL, NULL, 467, NULL, NULL, 231796),
(250125, '3n71A03', NULL, NULL, 213, NULL, NULL, 231796),
(250126, '4i9cA01', NULL, NULL, 153, NULL, NULL, 231796),
(250127, '3asdA00', NULL, NULL, 137, NULL, NULL, 231796);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(250128, '2yhcA00', NULL, NULL, 225, NULL, NULL, 231796),
(250129, '4i9cA02', NULL, NULL, 228, NULL, NULL, 231796),
(250130, '1na3A00', NULL, NULL, 91, NULL, NULL, 231796),
(250131, '5m72A00', NULL, NULL, 160, NULL, NULL, 231796),
(250132, '1a17A00', NULL, NULL, 166, NULL, NULL, 231796),
(250133, '3sz7A00', NULL, NULL, 164, NULL, NULL, 231796),
(250134, '2lniA00', NULL, NULL, 133, NULL, NULL, 231796),
(250135, '5a7dD00', NULL, NULL, 345, NULL, NULL, 231796),
(250136, '1ya0A01', NULL, NULL, 206, NULL, NULL, 231796),
(250137, '2wpvE00', NULL, NULL, 292, NULL, NULL, 231796),
(250138, '4gywC01', NULL, NULL, 83, NULL, NULL, 231796),
(250139, '4wndA00', NULL, NULL, 341, NULL, NULL, 231796),
(250140, '4nrhB00', NULL, NULL, 178, NULL, NULL, 231796),
(250141, '2vyiA00', NULL, NULL, 131, NULL, NULL, 231796),
(250142, '5lypA00', NULL, NULL, 140, NULL, NULL, 231796),
(250143, '3ckcA02', NULL, NULL, 177, NULL, NULL, 231796),
(250144, '3e4bD01', NULL, NULL, 316, NULL, NULL, 231796),
(250145, '4bt9A02', NULL, NULL, 130, NULL, NULL, 231796),
(250146, '4xi0D00', NULL, NULL, 177, NULL, NULL, 231796),
(250147, '1b89A00', NULL, NULL, 341, NULL, NULL, 231796),
(250148, '3ceqA00', NULL, NULL, 283, NULL, NULL, 231796),
(250149, '4y6wA00', NULL, NULL, 229, NULL, NULL, 231796),
(250150, '3o48A01', NULL, NULL, 118, NULL, NULL, 231796),
(250151, '4rg6A03', NULL, NULL, 133, NULL, NULL, 231796),
(250152, '4rg6A02', NULL, NULL, 77, NULL, NULL, 231796),
(250153, '3zpjA00', NULL, NULL, 359, NULL, NULL, 231796),
(250154, '3vtxA00', NULL, NULL, 184, NULL, NULL, 231796),
(250155, '3jysA02', NULL, NULL, 186, NULL, NULL, 231796),
(250156, '1zbpA01', NULL, NULL, 86, NULL, NULL, 231796),
(250157, '3cvpA00', NULL, NULL, 327, NULL, NULL, 231796),
(250158, '3rkvA00', NULL, NULL, 162, NULL, NULL, 231796),
(250159, '3u3wA02', NULL, NULL, 222, NULL, NULL, 231796),
(250160, '5jj6B01', NULL, NULL, 107, NULL, NULL, 231796),
(250161, '3gz1A00', NULL, NULL, 151, NULL, NULL, 231796),
(250162, '2vgyA00', NULL, NULL, 148, NULL, NULL, 231796),
(250163, '2xpiD00', NULL, NULL, 553, NULL, NULL, 231796),
(250164, '5g05K00', NULL, NULL, 494, NULL, NULL, 231796),
(250165, '1y07B01', NULL, NULL, 40, NULL, NULL, 231797),
(250166, '4co6D00', NULL, NULL, 52, NULL, NULL, 231798),
(250167, '4axpA01', NULL, NULL, 45, NULL, NULL, 231799),
(250168, '3zx4A02', NULL, NULL, 87, NULL, NULL, 231800),
(250169, '1xviA02', NULL, NULL, 94, NULL, NULL, 231800),
(250170, '2zosA02', NULL, NULL, 83, NULL, NULL, 231800),
(250171, '6hoyA02', NULL, NULL, 56, NULL, NULL, 231801),
(250172, '1dtdB00', NULL, NULL, 61, NULL, NULL, 231802),
(250173, '2e52A02', NULL, NULL, 74, NULL, NULL, 231803),
(250174, '2v9kA04', NULL, NULL, 109, NULL, NULL, 231804),
(250175, '2apoA03', NULL, NULL, 103, NULL, NULL, 231804),
(250176, '3ik3A01', NULL, NULL, 90, NULL, NULL, 231805),
(250177, '2i0yA01', NULL, NULL, 104, NULL, NULL, 231805),
(250178, '4otwA01', NULL, NULL, 95, NULL, NULL, 231805),
(250179, '3cc6A01', NULL, NULL, 93, NULL, NULL, 231805),
(250180, '2a19C01', NULL, NULL, 104, NULL, NULL, 231805),
(250181, '3lzhA01', NULL, NULL, 91, NULL, NULL, 231805),
(250182, '4yomB01', NULL, NULL, 98, NULL, NULL, 231805),
(250183, '1z57A01', NULL, NULL, 94, NULL, NULL, 231805),
(250184, '4aw2A01', NULL, NULL, 213, NULL, NULL, 231805),
(250185, '5xy1A01', NULL, NULL, 88, NULL, NULL, 231805),
(250186, '5cemA01', NULL, NULL, 82, NULL, NULL, 231805),
(250187, '3aoxA01', NULL, NULL, 107, NULL, NULL, 231805),
(250188, '5bq0A01', NULL, NULL, 100, NULL, NULL, 231805),
(250189, '2vd5B01', NULL, NULL, 204, NULL, NULL, 231805),
(250190, '3enmB01', NULL, NULL, 83, NULL, NULL, 231805),
(250191, '6dcgA01', NULL, NULL, 112, NULL, NULL, 231805),
(250192, '1p4oA01', NULL, NULL, 108, NULL, NULL, 231805),
(250193, '3qc4B01', NULL, NULL, 114, NULL, NULL, 231805),
(250194, '4uy9A01', NULL, NULL, 91, NULL, NULL, 231805),
(250195, '1blxA01', NULL, NULL, 92, NULL, NULL, 231805),
(250196, '4feuF01', NULL, NULL, 79, NULL, NULL, 231805),
(250197, '3d5vA01', NULL, NULL, 95, NULL, NULL, 231805),
(250198, '3vjnA01', NULL, NULL, 104, NULL, NULL, 231805);
INSERT INTO "PUBLIC"."MODEL" VALUES
(250199, '2vwiD01', NULL, NULL, 94, NULL, NULL, 231805),
(250200, '4usfA01', NULL, NULL, 94, NULL, NULL, 231805),
(250201, '5lwmA01', NULL, NULL, 96, NULL, NULL, 231805),
(250202, '2rkuA01', NULL, NULL, 89, NULL, NULL, 231805),
(250203, '3dlsB01', NULL, NULL, 112, NULL, NULL, 231805),
(250204, '1fvrA01', NULL, NULL, 107, NULL, NULL, 231805),
(250205, '2bujB01', NULL, NULL, 112, NULL, NULL, 231805),
(250206, '2y94A01', NULL, NULL, 97, NULL, NULL, 231805),
(250207, '3udbA01', NULL, NULL, 96, NULL, NULL, 231805),
(250208, '3eb0A01', NULL, NULL, 84, NULL, NULL, 231805),
(250209, '6cthA01', NULL, NULL, 93, NULL, NULL, 231805),
(250210, '4pmpA01', NULL, NULL, 91, NULL, NULL, 231805),
(250211, '3skjF00', NULL, NULL, 151, NULL, NULL, 231805),
(250212, '2cmwA01', NULL, NULL, 79, NULL, NULL, 231805),
(250213, '4hctA01', NULL, NULL, 86, NULL, NULL, 231805),
(250214, '5hu3A01', NULL, NULL, 94, NULL, NULL, 231805),
(250215, '2ozaA01', NULL, NULL, 98, NULL, NULL, 231805),
(250216, '3utoA02', NULL, NULL, 127, NULL, NULL, 231805),
(250217, '1yvjA01', NULL, NULL, 91, NULL, NULL, 231805),
(250218, '3a7fA01', NULL, NULL, 101, NULL, NULL, 231805),
(250219, '5oq5A01', NULL, NULL, 97, NULL, NULL, 231805),
(250220, '2qg7B01', NULL, NULL, 102, NULL, NULL, 231805),
(250221, '3enmC01', NULL, NULL, 84, NULL, NULL, 231805),
(250222, '6fngA01', NULL, NULL, 101, NULL, NULL, 231805),
(250223, '3n9xA01', NULL, NULL, 168, NULL, NULL, 231805),
(250224, '2ipxA01', NULL, NULL, 55, NULL, NULL, 231805),
(250225, '6fylA01', NULL, NULL, 108, NULL, NULL, 231805),
(250226, '2b9hA01', NULL, NULL, 110, NULL, NULL, 231805),
(250227, '2vz6B01', NULL, NULL, 83, NULL, NULL, 231805),
(250228, '6ferF01', NULL, NULL, 104, NULL, NULL, 231805),
(250229, '5jzjA01', NULL, NULL, 94, NULL, NULL, 231805),
(250230, '3g2fA01', NULL, NULL, 95, NULL, NULL, 231805),
(250231, '5x5oA01', NULL, NULL, 87, NULL, NULL, 231805),
(250232, '4wihA02', NULL, NULL, 125, NULL, NULL, 231805),
(250233, '3kk8A01', NULL, NULL, 86, NULL, NULL, 231805),
(250234, '2dq7X01', NULL, NULL, 86, NULL, NULL, 231805),
(250235, '3uiuA01', NULL, NULL, 115, NULL, NULL, 231805),
(250236, '4b6lA01', NULL, NULL, 89, NULL, NULL, 231805),
(250237, '2acxA02', NULL, NULL, 91, NULL, NULL, 231805),
(250238, '5zj6A01', NULL, NULL, 101, NULL, NULL, 231805),
(250239, '2i6lA01', NULL, NULL, 105, NULL, NULL, 231805),
(250240, '2wqbA01', NULL, NULL, 104, NULL, NULL, 231805),
(250241, '4nstA01', NULL, NULL, 105, NULL, NULL, 231805),
(250242, '4uakA01', NULL, NULL, 216, NULL, NULL, 231805),
(250243, '6cnhA01', NULL, NULL, 89, NULL, NULL, 231805),
(250244, '1nt2A01', NULL, NULL, 36, NULL, NULL, 231805),
(250245, '3c5iD01', NULL, NULL, 88, NULL, NULL, 231805),
(250246, '1x8bA01', NULL, NULL, 88, NULL, NULL, 231805),
(250247, '4e7wA01', NULL, NULL, 83, NULL, NULL, 231805),
(250248, '3cblA02', NULL, NULL, 90, NULL, NULL, 231805),
(250249, '5cnoB01', NULL, NULL, 100, NULL, NULL, 231805),
(250250, '4iz7A01', NULL, NULL, 121, NULL, NULL, 231805),
(250251, '2wntB01', NULL, NULL, 57, NULL, NULL, 231805),
(250252, '1rjbA01', NULL, NULL, 132, NULL, NULL, 231805),
(250253, '4lrjA01', NULL, NULL, 79, NULL, NULL, 231805),
(250254, '5drbA01', NULL, NULL, 94, NULL, NULL, 231805),
(250255, '2izrA01', NULL, NULL, 87, NULL, NULL, 231805),
(250256, '2v62A01', NULL, NULL, 110, NULL, NULL, 231805),
(250257, '3geqA01', NULL, NULL, 93, NULL, NULL, 231805),
(250258, '2ktyA01', NULL, NULL, 134, NULL, NULL, 231805),
(250259, '3fmeA01', NULL, NULL, 88, NULL, NULL, 231805),
(250260, '3atsA01', NULL, NULL, 116, NULL, NULL, 231805),
(250261, '4d9uA01', NULL, NULL, 97, NULL, NULL, 231805),
(250262, '4o38A01', NULL, NULL, 96, NULL, NULL, 231805),
(250263, '1fotA02', NULL, NULL, 125, NULL, NULL, 231805),
(250264, '3nynB01', NULL, NULL, 255, NULL, NULL, 231805),
(250265, '3w2rA01', NULL, NULL, 101, NULL, NULL, 231805),
(250266, '5nclA01', NULL, NULL, 128, NULL, NULL, 231805),
(250267, '4dhfA01', NULL, NULL, 96, NULL, NULL, 231805),
(250268, '4ymjA01', NULL, NULL, 98, NULL, NULL, 231805),
(250269, '2c47D01', NULL, NULL, 82, NULL, NULL, 231805);
INSERT INTO "PUBLIC"."MODEL" VALUES
(250270, '5l6oA01', NULL, NULL, 82, NULL, NULL, 231805),
(250271, '3bhhA01', NULL, NULL, 84, NULL, NULL, 231805),
(250272, '3lltA01', NULL, NULL, 93, NULL, NULL, 231805),
(250273, '2hakH01', NULL, NULL, 99, NULL, NULL, 231805),
(250274, '2pywB01', NULL, NULL, 122, NULL, NULL, 231805),
(250275, '2pmlX01', NULL, NULL, 124, NULL, NULL, 231805),
(250276, '4q9zB01', NULL, NULL, 131, NULL, NULL, 231805),
(250277, '2z02A01', NULL, NULL, 105, NULL, NULL, 231805),
(250278, '6egeD01', NULL, NULL, 106, NULL, NULL, 231805),
(250279, '2y6oA01', NULL, NULL, 96, NULL, NULL, 231805),
(250280, '4e1zA01', NULL, NULL, 94, NULL, NULL, 231805),
(250281, '3lm5A01', NULL, NULL, 89, NULL, NULL, 231805),
(250282, '3enmA01', NULL, NULL, 86, NULL, NULL, 231805),
(250283, '6o6qA02', NULL, NULL, 91, NULL, NULL, 231805),
(250284, '6gu2A01', NULL, NULL, 89, NULL, NULL, 231805),
(250285, '3pooA02', NULL, NULL, 125, NULL, NULL, 231805),
(250286, '1jpaA01', NULL, NULL, 96, NULL, NULL, 231805),
(250287, '1s9iB01', NULL, NULL, 97, NULL, NULL, 231805),
(250288, '1q8yA01', NULL, NULL, 97, NULL, NULL, 231805),
(250289, '3q5zA02', NULL, NULL, 143, NULL, NULL, 231805),
(250290, '4lrkA01', NULL, NULL, 77, NULL, NULL, 231805),
(250291, '3cd8A01', NULL, NULL, 113, NULL, NULL, 231805),
(250292, '3hmiA01', NULL, NULL, 85, NULL, NULL, 231805),
(250293, '5cenA01', NULL, NULL, 83, NULL, NULL, 231805),
(250294, '6di1A01', NULL, NULL, 88, NULL, NULL, 231805),
(250295, '3pp0A01', NULL, NULL, 99, NULL, NULL, 231805),
(250296, '4j7bA01', NULL, NULL, 89, NULL, NULL, 231805),
(250297, '2r0iA01', NULL, NULL, 94, NULL, NULL, 231805),
(250298, '4crsA01', NULL, NULL, 141, NULL, NULL, 231805),
(250299, '4yjqA01', NULL, NULL, 96, NULL, NULL, 231805),
(250300, '3qupA01', NULL, NULL, 112, NULL, NULL, 231805),
(250301, '4hvsA01', NULL, NULL, 131, NULL, NULL, 231805),
(250302, '3gu4A01', NULL, NULL, 91, NULL, NULL, 231805),
(250303, '3wf7A01', NULL, NULL, 108, NULL, NULL, 231805),
(250304, '4kujA01', NULL, NULL, 150, NULL, NULL, 231805),
(250305, '1q5kA01', NULL, NULL, 97, NULL, NULL, 231805),
(250306, '3c4zA02', NULL, NULL, 91, NULL, NULL, 231805),
(250307, '6cd7A01', NULL, NULL, 91, NULL, NULL, 231805),
(250308, '3ugcA01', NULL, NULL, 94, NULL, NULL, 231805),
(250309, '2w4oA01', NULL, NULL, 87, NULL, NULL, 231805),
(250310, '5o1vA01', NULL, NULL, 99, NULL, NULL, 231805),
(250311, '2reiA01', NULL, NULL, 107, NULL, NULL, 231805),
(250312, '6hjjA01', NULL, NULL, 98, NULL, NULL, 231805),
(250313, '2j0iA01', NULL, NULL, 109, NULL, NULL, 231805),
(250314, '3en9A03', NULL, NULL, 73, NULL, NULL, 231805),
(250315, '3bhyA01', NULL, NULL, 92, NULL, NULL, 231805),
(250316, '3e7oB01', NULL, NULL, 103, NULL, NULL, 231805),
(250317, '5xkaB01', NULL, NULL, 99, NULL, NULL, 231805),
(250318, '2oo8X01', NULL, NULL, 72, NULL, NULL, 231805),
(250319, '2q83B01', NULL, NULL, 113, NULL, NULL, 231805),
(250320, '3hyhA01', NULL, NULL, 94, NULL, NULL, 231805),
(250321, '4bgqA01', NULL, NULL, 94, NULL, NULL, 231805),
(250322, '4yhjA02', NULL, NULL, 91, NULL, NULL, 231805),
(250323, '6mibA01', NULL, NULL, 90, NULL, NULL, 231805),
(250324, '4czuA01', NULL, NULL, 92, NULL, NULL, 231805),
(250325, '3mvhA01', NULL, NULL, 139, NULL, NULL, 231805),
(250326, '3c0iA01', NULL, NULL, 88, NULL, NULL, 231805),
(250327, '4fieA01', NULL, NULL, 108, NULL, NULL, 231805),
(250328, '1csnA01', NULL, NULL, 87, NULL, NULL, 231805),
(250329, '2y7jA01', NULL, NULL, 90, NULL, NULL, 231805),
(250330, '4gcjA01', NULL, NULL, 84, NULL, NULL, 231805),
(250331, '3v5wA03', NULL, NULL, 108, NULL, NULL, 231805),
(250332, '3iecB01', NULL, NULL, 87, NULL, NULL, 231805),
(250333, '4r1vA01', NULL, NULL, 105, NULL, NULL, 231805),
(250334, '4mvfA01', NULL, NULL, 93, NULL, NULL, 231805),
(250335, '4csvA01', NULL, NULL, 88, NULL, NULL, 231805),
(250336, '4d28B01', NULL, NULL, 90, NULL, NULL, 231805),
(250337, '5ut3A01', NULL, NULL, 93, NULL, NULL, 231805),
(250338, '3hztA01', NULL, NULL, 95, NULL, NULL, 231805),
(250339, '5byzA01', NULL, NULL, 110, NULL, NULL, 231805),
(250340, '5efqA01', NULL, NULL, 103, NULL, NULL, 231805);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(250341, '5a9uA01', NULL, NULL, 114, NULL, NULL, 231805),
(250342, '3o0gA01', NULL, NULL, 84, NULL, NULL, 231805),
(250343, '4aqcB01', NULL, NULL, 100, NULL, NULL, 231805),
(250344, '5lmaA01', NULL, NULL, 92, NULL, NULL, 231805),
(250345, '6bfnA01', NULL, NULL, 102, NULL, NULL, 231805),
(250346, '4mwiA01', NULL, NULL, 110, NULL, NULL, 231805),
(250347, '2eu9A01', NULL, NULL, 99, NULL, NULL, 231805),
(250348, '1opkA03', NULL, NULL, 86, NULL, NULL, 231805),
(250349, '2welA01', NULL, NULL, 85, NULL, NULL, 231805),
(250350, '3uc3A01', NULL, NULL, 97, NULL, NULL, 231805),
(250351, '4aguC01', NULL, NULL, 85, NULL, NULL, 231805),
(250352, '4c0tA01', NULL, NULL, 92, NULL, NULL, 231805),
(250353, '2w96B01', NULL, NULL, 94, NULL, NULL, 231805),
(250354, '2w1zA02', NULL, NULL, 143, NULL, NULL, 231805),
(250355, '4rgjA01', NULL, NULL, 100, NULL, NULL, 231805),
(250356, '5xkaA01', NULL, NULL, 99, NULL, NULL, 231805),
(250357, '3socA01', NULL, NULL, 105, NULL, NULL, 231805),
(250358, '2xikA01', NULL, NULL, 98, NULL, NULL, 231805),
(250359, '3ohtA01', NULL, NULL, 136, NULL, NULL, 231805),
(250360, '2pmiA01', NULL, NULL, 68, NULL, NULL, 231805),
(250361, '2wqmA01', NULL, NULL, 72, NULL, NULL, 231805),
(250362, '3csvA01', NULL, NULL, 93, NULL, NULL, 231805),
(250363, '3mi9A01', NULL, NULL, 107, NULL, NULL, 231805),
(250364, '3kn6A01', NULL, NULL, 66, NULL, NULL, 231805),
(250365, '4jbvA01', NULL, NULL, 96, NULL, NULL, 231805),
(250366, '4fe2A01', NULL, NULL, 97, NULL, NULL, 231805),
(250367, '4ytfA01', NULL, NULL, 95, NULL, NULL, 231805),
(250368, '4itjB01', NULL, NULL, 94, NULL, NULL, 231805),
(250369, '3nynA01', NULL, NULL, 148, NULL, NULL, 231805),
(250370, '4g31A01', NULL, NULL, 96, NULL, NULL, 231805),
(250371, '6gzdA01', NULL, NULL, 64, NULL, NULL, 231805),
(250372, '4l00A01', NULL, NULL, 113, NULL, NULL, 231805),
(250373, '4nfnA01', NULL, NULL, 64, NULL, NULL, 231805),
(250374, '2ycfA01', NULL, NULL, 95, NULL, NULL, 231805),
(250375, '4lg4F01', NULL, NULL, 87, NULL, NULL, 231805),
(250376, '4h05B01', NULL, NULL, 93, NULL, NULL, 231805),
(250377, '4lqsA01', NULL, NULL, 86, NULL, NULL, 231805),
(250378, '3mesA01', NULL, NULL, 75, NULL, NULL, 231805),
(250379, '3gopA01', NULL, NULL, 131, NULL, NULL, 231805),
(250380, '5ci6A01', NULL, NULL, 128, NULL, NULL, 231805),
(250381, '4an3A01', NULL, NULL, 89, NULL, NULL, 231805),
(250382, '3wzdA01', NULL, NULL, 105, NULL, NULL, 231805),
(250383, '2i0eB01', NULL, NULL, 138, NULL, NULL, 231805),
(250384, '5kmiA01', NULL, NULL, 118, NULL, NULL, 231805),
(250385, '4ebvA01', NULL, NULL, 92, NULL, NULL, 231805),
(250386, '2cnqA01', NULL, NULL, 112, NULL, NULL, 231805),
(250387, '3hngA01', NULL, NULL, 113, NULL, NULL, 231805),
(250388, '6cz4A01', NULL, NULL, 89, NULL, NULL, 231805),
(250389, '6fyvA01', NULL, NULL, 94, NULL, NULL, 231805),
(250390, '1ua2A01', NULL, NULL, 95, NULL, NULL, 231805),
(250391, '1wzyA01', NULL, NULL, 139, NULL, NULL, 231805),
(250392, '4y85C01', NULL, NULL, 148, NULL, NULL, 231805),
(250393, '3orkA01', NULL, NULL, 97, NULL, NULL, 231805),
(250394, '3fe3A01', NULL, NULL, 95, NULL, NULL, 231805),
(250395, '4gt4B01', NULL, NULL, 92, NULL, NULL, 231805),
(250396, '3is5E01', NULL, NULL, 103, NULL, NULL, 231805),
(250397, '3id6C01', NULL, NULL, 54, NULL, NULL, 231805),
(250398, '3f3zA01', NULL, NULL, 87, NULL, NULL, 231805),
(250399, '3lffA01', NULL, NULL, 93, NULL, NULL, 231805),
(250400, '4nt4A01', NULL, NULL, 96, NULL, NULL, 231805),
(250401, '2jamA01', NULL, NULL, 81, NULL, NULL, 231805),
(250402, '3plsA01', NULL, NULL, 104, NULL, NULL, 231805),
(250403, '3kreA01', NULL, NULL, 98, NULL, NULL, 231805),
(250404, '1kobA01', NULL, NULL, 109, NULL, NULL, 231805),
(250405, '3hkoA01', NULL, NULL, 109, NULL, NULL, 231805),
(250406, '2gqrA01', NULL, NULL, 101, NULL, NULL, 231805),
(250407, '3gp0A01', NULL, NULL, 137, NULL, NULL, 231805),
(250408, '3fi8A01', NULL, NULL, 80, NULL, NULL, 231805),
(250409, '4l44A01', NULL, NULL, 145, NULL, NULL, 231805),
(250410, '3op5D01', NULL, NULL, 110, NULL, NULL, 231805),
(250411, '3dzoA02', NULL, NULL, 141, NULL, NULL, 231805);
INSERT INTO "PUBLIC"."MODEL" VALUES
(250412, '6ccyA01', NULL, NULL, 140, NULL, NULL, 231805),
(250413, '3ggfA01', NULL, NULL, 85, NULL, NULL, 231805),
(250414, '4c2vB01', NULL, NULL, 89, NULL, NULL, 231805),
(250415, '3uc4A01', NULL, NULL, 96, NULL, NULL, 231805),
(250416, '4qtbB01', NULL, NULL, 116, NULL, NULL, 231805),
(250417, '1kutB01', NULL, NULL, 95, NULL, NULL, 231805),
(250418, '3etaA01', NULL, NULL, 100, NULL, NULL, 231805),
(250419, '2zv7A01', NULL, NULL, 88, NULL, NULL, 231805),
(250420, '2rioA01', NULL, NULL, 89, NULL, NULL, 231805),
(250421, '3lxpA01', NULL, NULL, 93, NULL, NULL, 231805),
(250422, '3p86A01', NULL, NULL, 86, NULL, NULL, 231805),
(250423, '5g6vA01', NULL, NULL, 83, NULL, NULL, 231805),
(250424, '3g0eA01', NULL, NULL, 131, NULL, NULL, 231805),
(250425, '4d4rB01', NULL, NULL, 91, NULL, NULL, 231805),
(250426, '2ckoB01', NULL, NULL, 86, NULL, NULL, 231805),
(250427, '3kfaA01', NULL, NULL, 90, NULL, NULL, 231805),
(250428, '3nz0A01', NULL, NULL, 99, NULL, NULL, 231805),
(250429, '2fstX01', NULL, NULL, 147, NULL, NULL, 231805),
(250430, '4krdA01', NULL, NULL, 86, NULL, NULL, 231805),
(250431, '6n7aB01', NULL, NULL, 96, NULL, NULL, 231805),
(250432, '4b9dB01', NULL, NULL, 104, NULL, NULL, 231805),
(250433, '6hhjA02', NULL, NULL, 90, NULL, NULL, 231805),
(250434, '4wovA01', NULL, NULL, 110, NULL, NULL, 231805),
(250435, '5wp1A01', NULL, NULL, 128, NULL, NULL, 231805),
(250436, '5wnoA01', NULL, NULL, 104, NULL, NULL, 231805),
(250437, '3a8xB01', NULL, NULL, 136, NULL, NULL, 231805),
(250438, '4fg9A01', NULL, NULL, 97, NULL, NULL, 231805),
(250439, '3ubdA01', NULL, NULL, 109, NULL, NULL, 231805),
(250440, '4da5A01', NULL, NULL, 108, NULL, NULL, 231805),
(250441, '2h6dA01', NULL, NULL, 92, NULL, NULL, 231805),
(250442, '3nuaA01', NULL, NULL, 102, NULL, NULL, 231805),
(250443, '5m06A01', NULL, NULL, 91, NULL, NULL, 231805),
(250444, '6eixA01', NULL, NULL, 96, NULL, NULL, 231805),
(250445, '5f9eA01', NULL, NULL, 151, NULL, NULL, 231805),
(250446, '6g38A01', NULL, NULL, 136, NULL, NULL, 231805),
(250447, '6hmqA02', NULL, NULL, 91, NULL, NULL, 231805),
(250448, '2jc6A01', NULL, NULL, 101, NULL, NULL, 231805),
(250449, '3bu3A01', NULL, NULL, 101, NULL, NULL, 231805),
(250450, '3pfqA01', NULL, NULL, 190, NULL, NULL, 231805),
(250451, '1nd4A01', NULL, NULL, 95, NULL, NULL, 231805),
(250452, '4yzbA02', NULL, NULL, 88, NULL, NULL, 231805),
(250453, '4fuyA01', NULL, NULL, 129, NULL, NULL, 231805),
(250454, '3sv0A01', NULL, NULL, 64, NULL, NULL, 231805),
(250455, '2h34A01', NULL, NULL, 82, NULL, NULL, 231805),
(250456, '1fmkA03', NULL, NULL, 86, NULL, NULL, 231805),
(250457, '5x3fB01', NULL, NULL, 89, NULL, NULL, 231805),
(250458, '1gzkA02', NULL, NULL, 100, NULL, NULL, 231805),
(250459, '3nieA01', NULL, NULL, 163, NULL, NULL, 231805),
(250460, '4q5eA01', NULL, NULL, 78, NULL, NULL, 231805),
(250461, '2r2pA01', NULL, NULL, 104, NULL, NULL, 231805),
(250462, '4e5bA01', NULL, NULL, 151, NULL, NULL, 231805),
(250463, '5ftgA01', NULL, NULL, 84, NULL, NULL, 231805),
(250464, '4af3A01', NULL, NULL, 88, NULL, NULL, 231805),
(250465, '4g3fA01', NULL, NULL, 131, NULL, NULL, 231805),
(250466, '5vi9A02', NULL, NULL, 102, NULL, NULL, 231805),
(250467, '5larA01', NULL, NULL, 141, NULL, NULL, 231805),
(250468, '1phkA01', NULL, NULL, 105, NULL, NULL, 231805),
(250469, '4yneA01', NULL, NULL, 98, NULL, NULL, 231805),
(250470, '5mjaA01', NULL, NULL, 91, NULL, NULL, 231805),
(250471, '4i93A01', NULL, NULL, 106, NULL, NULL, 231805),
(250472, '3q4uB01', NULL, NULL, 89, NULL, NULL, 231805),
(250473, '1u59A01', NULL, NULL, 90, NULL, NULL, 231805),
(250474, '5x18A01', NULL, NULL, 84, NULL, NULL, 231805),
(250475, '5ipjA01', NULL, NULL, 105, NULL, NULL, 231805),
(250476, '5k5xA01', NULL, NULL, 131, NULL, NULL, 231805),
(250477, '1ob3A01', NULL, NULL, 83, NULL, NULL, 231805),
(250478, '4xbrA01', NULL, NULL, 151, NULL, NULL, 231805),
(250479, '4u3yB01', NULL, NULL, 108, NULL, NULL, 231805),
(250480, '3zduA01', NULL, NULL, 84, NULL, NULL, 231805),
(250481, '5hg8A01', NULL, NULL, 99, NULL, NULL, 231805),
(250482, '4wnkA02', NULL, NULL, 100, NULL, NULL, 231805);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(250483, '3lkmA01', NULL, NULL, 162, NULL, NULL, 231805),
(250484, '3tm0A01', NULL, NULL, 90, NULL, NULL, 231805),
(250485, '4ianA01', NULL, NULL, 87, NULL, NULL, 231805),
(250486, '1k9aA03', NULL, NULL, 86, NULL, NULL, 231805),
(250487, '5ig1A01', NULL, NULL, 88, NULL, NULL, 231805),
(250488, '2qkwB01', NULL, NULL, 72, NULL, NULL, 231805),
(250489, '4qnyA01', NULL, NULL, 126, NULL, NULL, 231805),
(250490, '4qqtA01', NULL, NULL, 99, NULL, NULL, 231805),
(250491, '3lijA02', NULL, NULL, 87, NULL, NULL, 231805),
(250492, '4l68A01', NULL, NULL, 116, NULL, NULL, 231805),
(250493, '2v7oA01', NULL, NULL, 113, NULL, NULL, 231805),
(250494, '3sxsA01', NULL, NULL, 84, NULL, NULL, 231805),
(250495, '3kmmA01', NULL, NULL, 97, NULL, NULL, 231805),
(250496, '3my0C01', NULL, NULL, 89, NULL, NULL, 231805),
(250497, '3jr1A01', NULL, NULL, 112, NULL, NULL, 231805),
(250498, '3oz6A01', NULL, NULL, 110, NULL, NULL, 231805),
(250499, '3warA02', NULL, NULL, 91, NULL, NULL, 231805),
(250500, '6eimB01', NULL, NULL, 97, NULL, NULL, 231805),
(250501, '5nxdA01', NULL, NULL, 80, NULL, NULL, 231805),
(250502, '1b6cB01', NULL, NULL, 123, NULL, NULL, 231805),
(250503, '5ftqA01', NULL, NULL, 106, NULL, NULL, 231805),
(250504, '4yznA01', NULL, NULL, 104, NULL, NULL, 231805),
(250505, '1nw1A01', NULL, NULL, 96, NULL, NULL, 231805),
(250506, '5my8A01', NULL, NULL, 101, NULL, NULL, 231805),
(250507, '3u55A01', NULL, NULL, 102, NULL, NULL, 231805),
(250508, '2pziB02', NULL, NULL, 151, NULL, NULL, 231805),
(250509, '2a2aB01', NULL, NULL, 98, NULL, NULL, 231805),
(250510, '5lohB01', NULL, NULL, 87, NULL, NULL, 231805),
(250511, '4euuA01', NULL, NULL, 90, NULL, NULL, 231805),
(250512, '5lvoA01', NULL, NULL, 93, NULL, NULL, 231805),
(250513, '4ynzA01', NULL, NULL, 90, NULL, NULL, 231805),
(250514, '4uyaA01', NULL, NULL, 90, NULL, NULL, 231805),
(250515, '5vamA01', NULL, NULL, 91, NULL, NULL, 231805),
(250516, '4aaaA01', NULL, NULL, 84, NULL, NULL, 231805),
(250517, '3qd2B01', NULL, NULL, 98, NULL, NULL, 231805),
(250518, '5e8xA01', NULL, NULL, 88, NULL, NULL, 231805),
(250519, '5iqaA01', NULL, NULL, 90, NULL, NULL, 231805),
(250520, '6gzmA01', NULL, NULL, 64, NULL, NULL, 231805),
(250521, '1zarA02', NULL, NULL, 94, NULL, NULL, 231805),
(250522, '4gkhK01', NULL, NULL, 100, NULL, NULL, 231805),
(250523, '2ywvA01', NULL, NULL, 107, NULL, NULL, 231805),
(250524, '1lufA01', NULL, NULL, 97, NULL, NULL, 231805),
(250525, '4azsA02', NULL, NULL, 89, NULL, NULL, 231805),
(250526, '4qqjA01', NULL, NULL, 99, NULL, NULL, 231805),
(250527, '4qmlA01', NULL, NULL, 84, NULL, NULL, 231805),
(250528, '2weiA01', NULL, NULL, 90, NULL, NULL, 231805),
(250529, '1g8aA01', NULL, NULL, 51, NULL, NULL, 231805),
(250530, '1fbnA01', NULL, NULL, 52, NULL, NULL, 231805),
(250531, '2pulB01', NULL, NULL, 119, NULL, NULL, 231805),
(250532, '2y4iB01', NULL, NULL, 91, NULL, NULL, 231805),
(250533, '3alnB01', NULL, NULL, 103, NULL, NULL, 231805),
(250534, '4df3A01', NULL, NULL, 55, NULL, NULL, 231805),
(250535, '2jiiA01', NULL, NULL, 121, NULL, NULL, 231805),
(250536, '4i5pA01', NULL, NULL, 89, NULL, NULL, 231805),
(250537, '4hzrA01', NULL, NULL, 95, NULL, NULL, 231805),
(250538, '1cm8A01', NULL, NULL, 90, NULL, NULL, 231805),
(250539, '5u6bA01', NULL, NULL, 111, NULL, NULL, 231805),
(250540, '5xvuA02', NULL, NULL, 91, NULL, NULL, 231805),
(250541, '3fegA01', NULL, NULL, 79, NULL, NULL, 231805),
(250542, '2ac3A01', NULL, NULL, 80, NULL, NULL, 231805),
(250543, '4ks7A01', NULL, NULL, 101, NULL, NULL, 231805),
(250544, '4js8A01', NULL, NULL, 89, NULL, NULL, 231805),
(250545, '2wtkC01', NULL, NULL, 101, NULL, NULL, 231805),
(250546, '2ppqA01', NULL, NULL, 104, NULL, NULL, 231805),
(250547, '3b2tB01', NULL, NULL, 99, NULL, NULL, 231805),
(250548, '4qtdA01', NULL, NULL, 113, NULL, NULL, 231805),
(250549, '2x7gA01', NULL, NULL, 88, NULL, NULL, 231805),
(250550, '4pf4A01', NULL, NULL, 91, NULL, NULL, 231805),
(250551, '4x7qB01', NULL, NULL, 94, NULL, NULL, 231805),
(250552, '2r5tA01', NULL, NULL, 95, NULL, NULL, 231805),
(250553, '3uqcB01', NULL, NULL, 93, NULL, NULL, 231805);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(250554, '3nizA01', NULL, NULL, 102, NULL, NULL, 231805),
(250555, '4aw5A01', NULL, NULL, 96, NULL, NULL, 231805),
(250556, '3p1aA01', NULL, NULL, 112, NULL, NULL, 231805),
(250557, '5l8lA01', NULL, NULL, 98, NULL, NULL, 231805),
(250558, '6d1zA01', NULL, NULL, 115, NULL, NULL, 231805),
(250559, '6fnkA01', NULL, NULL, 100, NULL, NULL, 231805),
(250560, '3mfrA01', NULL, NULL, 89, NULL, NULL, 231805),
(250561, '4yz9A01', NULL, NULL, 82, NULL, NULL, 231805),
(250562, '4jr7A02', NULL, NULL, 125, NULL, NULL, 231805),
(250563, '3qa8A01', NULL, NULL, 83, NULL, NULL, 231805),
(250564, '3rp9A01', NULL, NULL, 143, NULL, NULL, 231805),
(250565, '3qyzA01', NULL, NULL, 134, NULL, NULL, 231805),
(250566, '6ctzA01', NULL, NULL, 93, NULL, NULL, 231805),
(250567, '6fucA01', NULL, NULL, 88, NULL, NULL, 231805),
(250568, '3f7wA01', NULL, NULL, 91, NULL, NULL, 231805),
(250569, '1o6lA02', NULL, NULL, 137, NULL, NULL, 231805),
(250570, '4oa2A01', NULL, NULL, 97, NULL, NULL, 231805),
(250571, '4k33A01', NULL, NULL, 99, NULL, NULL, 231805),
(250572, '5hidA01', NULL, NULL, 93, NULL, NULL, 231805),
(250573, '3cokA01', NULL, NULL, 89, NULL, NULL, 231805),
(250574, '1u5qA01', NULL, NULL, 96, NULL, NULL, 231805),
(250575, '5qinA01', NULL, NULL, 96, NULL, NULL, 231805),
(250576, '6fexA01', NULL, NULL, 111, NULL, NULL, 231805),
(250577, '4g3cA01', NULL, NULL, 147, NULL, NULL, 231805),
(250578, '2z7rA01', NULL, NULL, 95, NULL, NULL, 231805),
(250579, '3q5iA02', NULL, NULL, 98, NULL, NULL, 231805),
(250580, '1ia9A01', NULL, NULL, 147, NULL, NULL, 231805),
(250581, '4ylkA01', NULL, NULL, 109, NULL, NULL, 231805),
(250582, '3vw8A01', NULL, NULL, 135, NULL, NULL, 231805),
(250583, '3kvwA02', NULL, NULL, 104, NULL, NULL, 231805),
(250584, '4f9cA01', NULL, NULL, 102, NULL, NULL, 231805),
(250585, '3g15A01', NULL, NULL, 84, NULL, NULL, 231805),
(250586, '6fdyU01', NULL, NULL, 92, NULL, NULL, 231805),
(250587, '3dxqA01', NULL, NULL, 90, NULL, NULL, 231805),
(250588, '4m68A01', NULL, NULL, 95, NULL, NULL, 231805),
(250589, '2qr8A01', NULL, NULL, 60, NULL, NULL, 231805),
(250590, '4ow8A01', NULL, NULL, 97, NULL, NULL, 231805),
(250591, '3txoA01', NULL, NULL, 128, NULL, NULL, 231805),
(250592, '3i1aA01', NULL, NULL, 105, NULL, NULL, 231805),
(250593, '1k3aA01', NULL, NULL, 94, NULL, NULL, 231805),
(250594, '4ckjA01', NULL, NULL, 100, NULL, NULL, 231805),
(250595, '4dcaA01', NULL, NULL, 86, NULL, NULL, 231805),
(250596, '4tndA01', NULL, NULL, 255, NULL, NULL, 231805),
(250597, '1vzoA01', NULL, NULL, 111, NULL, NULL, 231805),
(250598, '4gyiA02', NULL, NULL, 100, NULL, NULL, 231805),
(250599, '5li9A01', NULL, NULL, 143, NULL, NULL, 231805),
(250600, '1t46A01', NULL, NULL, 96, NULL, NULL, 231805),
(250601, '5itaA01', NULL, NULL, 86, NULL, NULL, 231805),
(250602, '3dxpA01', NULL, NULL, 104, NULL, NULL, 231805),
(250603, '2qluA01', NULL, NULL, 96, NULL, NULL, 231805),
(250604, '5b2lA01', NULL, NULL, 98, NULL, NULL, 231805),
(250605, '4jrnA02', NULL, NULL, 141, NULL, NULL, 231805),
(250606, '4at5A01', NULL, NULL, 96, NULL, NULL, 231805),
(250607, '5grnA01', NULL, NULL, 94, NULL, NULL, 231805),
(250608, '4rlkA02', NULL, NULL, 91, NULL, NULL, 231805),
(250609, '3zbfA01', NULL, NULL, 95, NULL, NULL, 231805),
(250610, '5jgaA01', NULL, NULL, 83, NULL, NULL, 231805),
(250611, '5e8sA01', NULL, NULL, 87, NULL, NULL, 231805),
(250612, '2hw6A01', NULL, NULL, 92, NULL, NULL, 231805),
(250613, '6gr8A01', NULL, NULL, 92, NULL, NULL, 231805),
(250614, '5vdkA01', NULL, NULL, 92, NULL, NULL, 231805),
(250615, '4fr4E01', NULL, NULL, 150, NULL, NULL, 231805),
(250616, '3kulA01', NULL, NULL, 89, NULL, NULL, 231805),
(250617, '3mdyA01', NULL, NULL, 118, NULL, NULL, 231805),
(250618, '3qgyA01', NULL, NULL, 85, NULL, NULL, 231805),
(250619, '4xufB01', NULL, NULL, 94, NULL, NULL, 231805),
(250620, '5x2aA01', NULL, NULL, 101, NULL, NULL, 231805),
(250621, '2yexA01', NULL, NULL, 97, NULL, NULL, 231805),
(250622, '2w5aA01', NULL, NULL, 66, NULL, NULL, 231805),
(250623, '3r9rA01', NULL, NULL, 97, NULL, NULL, 231805),
(250624, '4ix3A01', NULL, NULL, 113, NULL, NULL, 231805); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(250625, '1tkiA01', NULL, NULL, 84, NULL, NULL, 231805),
(250626, '1zy4A01', NULL, NULL, 100, NULL, NULL, 231805),
(250627, '3uimA01', NULL, NULL, 108, NULL, NULL, 231805),
(250628, '6bg2A02', NULL, NULL, 125, NULL, NULL, 231805),
(250629, '4ynoA01', NULL, NULL, 93, NULL, NULL, 231805),
(250630, '3a4oX01', NULL, NULL, 89, NULL, NULL, 231805),
(250631, '3comB01', NULL, NULL, 89, NULL, NULL, 231805),
(250632, '4pdyA01', NULL, NULL, 111, NULL, NULL, 231805),
(250633, '3bceA01', NULL, NULL, 97, NULL, NULL, 231805),
(250634, '4ra4A01', NULL, NULL, 130, NULL, NULL, 231805),
(250635, '2f2uB01', NULL, NULL, 203, NULL, NULL, 231805),
(250636, '3s95A01', NULL, NULL, 88, NULL, NULL, 231805),
(250637, '4fnxA01', NULL, NULL, 115, NULL, NULL, 231805),
(250638, '5wnfB01', NULL, NULL, 216, NULL, NULL, 231805),
(250639, '5dbxA01', NULL, NULL, 90, NULL, NULL, 231805),
(250640, '4ct2A01', NULL, NULL, 91, NULL, NULL, 231805),
(250641, '4wunA01', NULL, NULL, 109, NULL, NULL, 231805),
(250642, '3uibA01', NULL, NULL, 135, NULL, NULL, 231805),
(250643, '5uq3A01', NULL, NULL, 66, NULL, NULL, 231805),
(250644, '3enmD01', NULL, NULL, 88, NULL, NULL, 231805),
(250645, '4wnoA01', NULL, NULL, 98, NULL, NULL, 231805),
(250646, '3gbzA01', NULL, NULL, 85, NULL, NULL, 231805),
(250647, '6e2nA01', NULL, NULL, 101, NULL, NULL, 231805),
(250648, '3amaA02', NULL, NULL, 125, NULL, NULL, 231805),
(250649, '3fxzA01', NULL, NULL, 98, NULL, NULL, 231805),
(250650, '3a99A01', NULL, NULL, 92, NULL, NULL, 231805),
(250651, '4o2zA01', NULL, NULL, 165, NULL, NULL, 231805),
(250652, '3h4jB01', NULL, NULL, 90, NULL, NULL, 231805),
(250653, '5jfwA01', NULL, NULL, 103, NULL, NULL, 231805),
(250654, '2x4fB01', NULL, NULL, 88, NULL, NULL, 231805),
(250655, '3eqcA01', NULL, NULL, 114, NULL, NULL, 231805),
(250656, '2zv2A01', NULL, NULL, 88, NULL, NULL, 231805),
(250657, '3rgfA01', NULL, NULL, 101, NULL, NULL, 231805),
(250658, '4g3dD01', NULL, NULL, 134, NULL, NULL, 231805),
(250659, '3vwaA01', NULL, NULL, 90, NULL, NULL, 231805),
(250660, '3e3pA01', NULL, NULL, 88, NULL, NULL, 231805),
(250661, '3gniB01', NULL, NULL, 89, NULL, NULL, 231805),
(250662, '5f9eB01', NULL, NULL, 105, NULL, NULL, 231805),
(250663, '4pdoA01', NULL, NULL, 117, NULL, NULL, 231805),
(250664, '5awmA01', NULL, NULL, 104, NULL, NULL, 231805),
(250665, '4eqmA01', NULL, NULL, 92, NULL, NULL, 231805),
(250666, '3fhrA01', NULL, NULL, 82, NULL, NULL, 231805),
(250667, '6emhA01', NULL, NULL, 103, NULL, NULL, 231805),
(250668, '3omvA01', NULL, NULL, 86, NULL, NULL, 231805),
(250669, '2f57B01', NULL, NULL, 107, NULL, NULL, 231805),
(250670, '3brbB01', NULL, NULL, 99, NULL, NULL, 231805),
(250671, '4pdpB01', NULL, NULL, 85, NULL, NULL, 231805),
(250672, '4r78A01', NULL, NULL, 96, NULL, NULL, 231805),
(250673, '5ax9B01', NULL, NULL, 101, NULL, NULL, 231805),
(250674, '4c3fA01', NULL, NULL, 86, NULL, NULL, 231805),
(250675, '1qpcA01', NULL, NULL, 88, NULL, NULL, 231805),
(250676, '4othA01', NULL, NULL, 147, NULL, NULL, 231805),
(250677, '3dj6A01', NULL, NULL, 97, NULL, NULL, 231805),
(250678, '4hokM01', NULL, NULL, 64, NULL, NULL, 231805),
(250679, '2qolA01', NULL, NULL, 107, NULL, NULL, 231805),
(250680, '2hb0A01', NULL, NULL, 177, NULL, NULL, 231806),
(250681, '2damA00', NULL, NULL, 67, NULL, NULL, 231807),
(250682, '2qhoD00', NULL, NULL, 53, NULL, NULL, 231807),
(250683, '2knzA00', NULL, NULL, 53, NULL, NULL, 231807),
(250684, '2daeA00', NULL, NULL, 75, NULL, NULL, 231807),
(250685, '1r4gA00', NULL, NULL, 53, NULL, NULL, 231807),
(250686, '1zv1A00', NULL, NULL, 65, NULL, NULL, 231807),
(250687, '4un2B00', NULL, NULL, 48, NULL, NULL, 231807),
(250688, '1g3iF02', NULL, NULL, 23, NULL, NULL, 231807),
(250689, '4f2lA00', NULL, NULL, 61, NULL, NULL, 231807),
(250690, '3ihpB04', NULL, NULL, 48, NULL, NULL, 231807),
(250691, '3ihpB05', NULL, NULL, 71, NULL, NULL, 231807),
(250692, '1wgnA00', NULL, NULL, 63, NULL, NULL, 231807),
(250693, '1vdlA00', NULL, NULL, 80, NULL, NULL, 231807),
(250694, '1g41A02', NULL, NULL, 30, NULL, NULL, 231807),
(250695, '2h5xA03', NULL, NULL, 63, NULL, NULL, 231807);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(250696, '4heoA00', NULL, NULL, 64, NULL, NULL, 231807),
(250697, '1y8gB03', NULL, NULL, 43, NULL, NULL, 231807),
(250698, '3e21A00', NULL, NULL, 45, NULL, NULL, 231807),
(250699, '2oo9A00', NULL, NULL, 46, NULL, NULL, 231807),
(250700, '2l2dA00', NULL, NULL, 73, NULL, NULL, 231807),
(250701, '2cwbA00', NULL, NULL, 46, NULL, NULL, 231807),
(250702, '1wivA00', NULL, NULL, 73, NULL, NULL, 231807),
(250703, '2lbcA01', NULL, NULL, 42, NULL, NULL, 231807),
(250704, '3mmpA01', NULL, NULL, 56, NULL, NULL, 231807),
(250705, '3t6pA02', NULL, NULL, 66, NULL, NULL, 231807),
(250706, '1otrA00', NULL, NULL, 49, NULL, NULL, 231807),
(250707, '2ooaA00', NULL, NULL, 52, NULL, NULL, 231807),
(250708, '2l4eA00', NULL, NULL, 59, NULL, NULL, 231807),
(250709, '1oaiA00', NULL, NULL, 59, NULL, NULL, 231807),
(250710, '3frhA01', NULL, NULL, 58, NULL, NULL, 231807),
(250711, '1bvsF03', NULL, NULL, 52, NULL, NULL, 231807),
(250712, '2lbcA02', NULL, NULL, 53, NULL, NULL, 231807),
(250713, '1wj7A01', NULL, NULL, 60, NULL, NULL, 231807),
(250714, '1cukA03', NULL, NULL, 48, NULL, NULL, 231807),
(250715, '2dakA00', NULL, NULL, 63, NULL, NULL, 231807),
(250716, '1ufzA01', NULL, NULL, 58, NULL, NULL, 231807),
(250717, '2cp8A00', NULL, NULL, 54, NULL, NULL, 231807),
(250718, '2qsfX02', NULL, NULL, 52, NULL, NULL, 231807),
(250719, '2ekfA01', NULL, NULL, 46, NULL, NULL, 231807),
(250720, '4dbgB02', NULL, NULL, 61, NULL, NULL, 231807),
(250721, '2knaA01', NULL, NULL, 54, NULL, NULL, 231807),
(250722, '2lvnC00', NULL, NULL, 52, NULL, NULL, 231807),
(250723, '2b3tA01', NULL, NULL, 84, NULL, NULL, 231807),
(250724, '2ekkA00', NULL, NULL, 47, NULL, NULL, 231807),
(250725, '1oksA00', NULL, NULL, 56, NULL, NULL, 231807),
(250726, '4gewA01', NULL, NULL, 95, NULL, NULL, 231807),
(250727, '1im2A02', NULL, NULL, 40, NULL, NULL, 231807),
(250728, '1g3iW02', NULL, NULL, 18, NULL, NULL, 231807),
(250729, '1vekA01', NULL, NULL, 47, NULL, NULL, 231807),
(250730, '1g4aE02', NULL, NULL, 47, NULL, NULL, 231807),
(250731, '3h4jA03', NULL, NULL, 61, NULL, NULL, 231807),
(250732, '2ltuA00', NULL, NULL, 62, NULL, NULL, 231807),
(250733, '2jp7A00', NULL, NULL, 57, NULL, NULL, 231807),
(250734, '1vg5A00', NULL, NULL, 73, NULL, NULL, 231807),
(250735, '2daiA00', NULL, NULL, 83, NULL, NULL, 231807),
(250736, '1p3qQ00', NULL, NULL, 54, NULL, NULL, 231807),
(250737, '1whcA01', NULL, NULL, 42, NULL, NULL, 231807),
(250738, '2dhyA00', NULL, NULL, 67, NULL, NULL, 231807),
(250739, '5lxjA00', NULL, NULL, 53, NULL, NULL, 231807),
(250740, '1nv8B01', NULL, NULL, 87, NULL, NULL, 231807),
(250741, '4g3oA00', NULL, NULL, 58, NULL, NULL, 231807),
(250742, '3k9oA02', NULL, NULL, 43, NULL, NULL, 231807),
(250743, '1dv0A00', NULL, NULL, 47, NULL, NULL, 231807),
(250744, '2rruA00', NULL, NULL, 53, NULL, NULL, 231807),
(250745, '5ji2E02', NULL, NULL, 85, NULL, NULL, 231807),
(250746, '3lcvB01', NULL, NULL, 71, NULL, NULL, 231807),
(250747, '2mr9A00', NULL, NULL, 44, NULL, NULL, 231807),
(250748, '1wglA00', NULL, NULL, 59, NULL, NULL, 231807),
(250749, '1v92A00', NULL, NULL, 46, NULL, NULL, 231807),
(250750, '2mgwA00', NULL, NULL, 52, NULL, NULL, 231807),
(250751, '2jujA00', NULL, NULL, 56, NULL, NULL, 231807),
(250752, '3fe3A03', NULL, NULL, 43, NULL, NULL, 231807),
(250753, '2jy5A00', NULL, NULL, 52, NULL, NULL, 231807),
(250754, '1mn3A00', NULL, NULL, 54, NULL, NULL, 231807),
(250755, '2hwjA02', NULL, NULL, 61, NULL, NULL, 231807),
(250756, '2ztdA03', NULL, NULL, 51, NULL, NULL, 231807),
(250757, '1ixsA00', NULL, NULL, 62, NULL, NULL, 231807),
(250758, '1a5tA02', NULL, NULL, 40, NULL, NULL, 231807),
(250759, '1pgyA00', NULL, NULL, 47, NULL, NULL, 231807),
(250760, '1t6oA00', NULL, NULL, 51, NULL, NULL, 231807),
(250761, '3bbzA00', NULL, NULL, 49, NULL, NULL, 231807),
(250762, '3ihpA05', NULL, NULL, 66, NULL, NULL, 231807),
(250763, '2lvaA01', NULL, NULL, 44, NULL, NULL, 231807),
(250764, '2hakH03', NULL, NULL, 48, NULL, NULL, 231807),
(250765, '1oqyA04', NULL, NULL, 44, NULL, NULL, 231807),
(250766, '2dzlA00', NULL, NULL, 66, NULL, NULL, 231807),
(250767, '1vejA00', NULL, NULL, 74, NULL, NULL, 231807);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(250768, '1y8gA03', NULL, NULL, 43, NULL, NULL, 231807),
(250769, '1tr8A02', NULL, NULL, 40, NULL, NULL, 231807),
(250770, '1ifyA00', NULL, NULL, 49, NULL, NULL, 231807),
(250771, '1aipH03', NULL, NULL, 54, NULL, NULL, 231807),
(250772, '1kyiS02', NULL, NULL, 23, NULL, NULL, 231807),
(250773, '2dnaA00', NULL, NULL, 67, NULL, NULL, 231807),
(250774, '2g3qA00', NULL, NULL, 43, NULL, NULL, 231807),
(250775, '2di0A01', NULL, NULL, 46, NULL, NULL, 231807),
(250776, '1vegA01', NULL, NULL, 44, NULL, NULL, 231807),
(250777, '4wp2F00', NULL, NULL, 61, NULL, NULL, 231807),
(250778, '1tteA02', NULL, NULL, 57, NULL, NULL, 231807),
(250779, '2r0iA03', NULL, NULL, 43, NULL, NULL, 231807),
(250780, '1q02A00', NULL, NULL, 52, NULL, NULL, 231807),
(250781, '1xb2B01', NULL, NULL, 60, NULL, NULL, 231807),
(250782, '3teqB00', NULL, NULL, 101, NULL, NULL, 231808),
(250783, '3terA00', NULL, NULL, 136, NULL, NULL, 231808),
(250784, '2py5A05', NULL, NULL, 30, NULL, NULL, 231809),
(250785, '2vlaA01', NULL, NULL, 78, NULL, NULL, 231810),
(250786, '5e33A03', NULL, NULL, 79, NULL, NULL, 231811),
(250787, '3cskA03', NULL, NULL, 76, NULL, NULL, 231811),
(250788, '3iylW02', NULL, NULL, 148, NULL, NULL, 231812),
(250789, '1ej6A02', NULL, NULL, 148, NULL, NULL, 231812),
(250790, '1mgtA01', NULL, NULL, 88, NULL, NULL, 231813),
(250791, '4zyeA01', NULL, NULL, 80, NULL, NULL, 231813),
(250792, '1sfeA01', NULL, NULL, 93, NULL, NULL, 231813),
(250793, '4bhbA01', NULL, NULL, 70, NULL, NULL, 231813),
(250794, '3l00A01', NULL, NULL, 80, NULL, NULL, 231813),
(250795, '1wrjA01', NULL, NULL, 67, NULL, NULL, 231813),
(250796, '5ysnB01', NULL, NULL, 67, NULL, NULL, 231814),
(250797, '1vprA02', NULL, NULL, 84, NULL, NULL, 231815),
(250798, '4l3fA02', NULL, NULL, 143, NULL, NULL, 231816),
(250799, '4l3aA03', NULL, NULL, 112, NULL, NULL, 231816),
(250800, '4qfrB02', NULL, NULL, 99, NULL, NULL, 231817),
(250801, '2v8qB00', NULL, NULL, 87, NULL, NULL, 231817),
(250802, '3dteA03', NULL, NULL, 97, NULL, NULL, 231818),
(250803, '3akjA02', NULL, NULL, 201, NULL, NULL, 231819),
(250804, '2lw1A00', NULL, NULL, 85, NULL, NULL, 231820),
(250805, '1gaxA05', NULL, NULL, 73, NULL, NULL, 231820),
(250806, '3imoC00', NULL, NULL, 112, NULL, NULL, 231821),
(250807, '3zw0B01', NULL, NULL, 82, NULL, NULL, 231822),
(250808, '5o7vA01', NULL, NULL, 84, NULL, NULL, 231822),
(250809, '5o7wA01', NULL, NULL, 84, NULL, NULL, 231822),
(250810, '5o7uB01', NULL, NULL, 84, NULL, NULL, 231822),
(250811, '5o7uA01', NULL, NULL, 84, NULL, NULL, 231822),
(250812, '5o7vB01', NULL, NULL, 84, NULL, NULL, 231822),
(250813, '5o7wB01', NULL, NULL, 84, NULL, NULL, 231822),
(250814, '6f7wA01', NULL, NULL, 84, NULL, NULL, 231822),
(250815, '2bt9C01', NULL, NULL, 84, NULL, NULL, 231822),
(250816, '4dmiD01', NULL, NULL, 39, NULL, NULL, 231823),
(250817, '1yzmA00', NULL, NULL, 51, NULL, NULL, 231824),
(250818, '3dkqA02', NULL, NULL, 47, NULL, NULL, 231824),
(250819, '3v1aA00', NULL, NULL, 48, NULL, NULL, 231824),
(250820, '1z0kB00', NULL, NULL, 69, NULL, NULL, 231824),
(250821, '1z0jB00', NULL, NULL, 59, NULL, NULL, 231824),
(250822, '1vx7X00', NULL, NULL, 100, NULL, NULL, 231825),
(250823, '3u5eU00', NULL, NULL, 121, NULL, NULL, 231825),
(250824, '4a18M00', NULL, NULL, 118, NULL, NULL, 231825),
(250825, '1vwxU00', NULL, NULL, 112, NULL, NULL, 231825),
(250826, '1n6zA00', NULL, NULL, 105, NULL, NULL, 231826),
(250827, '5k2lA00', NULL, NULL, 49, NULL, NULL, 231827),
(250828, '4b8vA03', NULL, NULL, 49, NULL, NULL, 231827),
(250829, '4uz3C00', NULL, NULL, 48, NULL, NULL, 231827),
(250830, '5ylgD00', NULL, NULL, 49, NULL, NULL, 231827),
(250831, '5bumA00', NULL, NULL, 50, NULL, NULL, 231827),
(250832, '4a1kA01', NULL, NULL, 48, NULL, NULL, 231827),
(250833, '1e0gA00', NULL, NULL, 48, NULL, NULL, 231827),
(250834, '2mkxA00', NULL, NULL, 58, NULL, NULL, 231827),
(250835, '4b8vA01', NULL, NULL, 67, NULL, NULL, 231827),
(250836, '2djpA00', NULL, NULL, 77, NULL, NULL, 231827),
(250837, '4b8vA02', NULL, NULL, 77, NULL, NULL, 231827),
(250838, '5c8qB02', NULL, NULL, 46, NULL, NULL, 231827),
(250839, '4lg3A02', NULL, NULL, 43, NULL, NULL, 231828);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(250840, '3pmqA02', NULL, NULL, 50, NULL, NULL, 231829),
(250841, '3f0dA00', NULL, NULL, 162, NULL, NULL, 231830),
(250842, '2pmpA00', NULL, NULL, 160, NULL, NULL, 231830),
(250843, '1vh8A00', NULL, NULL, 170, NULL, NULL, 231830),
(250844, '5b8fB00', NULL, NULL, 164, NULL, NULL, 231830),
(250845, '3fpiA00', NULL, NULL, 165, NULL, NULL, 231830),
(250846, '1gx1A00', NULL, NULL, 160, NULL, NULL, 231830),
(250847, '2uzhA00', NULL, NULL, 165, NULL, NULL, 231830),
(250848, '1w55A02', NULL, NULL, 163, NULL, NULL, 231830),
(250849, '3re3A00', NULL, NULL, 162, NULL, NULL, 231830),
(250850, '1iv3A00', NULL, NULL, 152, NULL, NULL, 231830),
(250851, '1t0aA00', NULL, NULL, 159, NULL, NULL, 231830),
(250852, '4c81A00', NULL, NULL, 184, NULL, NULL, 231830),
(250853, '4c8gA00', NULL, NULL, 161, NULL, NULL, 231830),
(250854, '3b6nA00', NULL, NULL, 187, NULL, NULL, 231830),
(250855, '5aysC00', NULL, NULL, 112, NULL, NULL, 231831),
(250856, '2kcdA00', NULL, NULL, 120, NULL, NULL, 231831),
(250857, '1p49A02', NULL, NULL, 59, NULL, NULL, 231832),
(250858, '2g8gA00', NULL, NULL, 524, NULL, NULL, 231833),
(250859, '3kicA00', NULL, NULL, 520, NULL, NULL, 231833),
(250860, '4iovA00', NULL, NULL, 520, NULL, NULL, 231833),
(250861, '1c8eA00', NULL, NULL, 548, NULL, NULL, 231833),
(250862, '1k3vA00', NULL, NULL, 542, NULL, NULL, 231833),
(250863, '4qc8A00', NULL, NULL, 498, NULL, NULL, 231833),
(250864, '6nf9A00', NULL, NULL, 541, NULL, NULL, 231833),
(250865, '2qa0A00', NULL, NULL, 519, NULL, NULL, 231833),
(250866, '4g0rA00', NULL, NULL, 556, NULL, NULL, 231833),
(250867, '3ng9A00', NULL, NULL, 520, NULL, NULL, 231833),
(250868, '3nttA00', NULL, NULL, 516, NULL, NULL, 231833),
(250869, '6nn3A00', NULL, NULL, 534, NULL, NULL, 231833),
(250870, '6ihbA00', NULL, NULL, 517, NULL, NULL, 231833),
(250871, '3ux1A00', NULL, NULL, 518, NULL, NULL, 231833),
(250872, '4rsoA00', NULL, NULL, 520, NULL, NULL, 231833),
(250873, '5uf6A00', NULL, NULL, 517, NULL, NULL, 231833),
(250874, '1z14A00', NULL, NULL, 549, NULL, NULL, 231833),
(250875, '3n6zA01', NULL, NULL, 265, NULL, NULL, 231834),
(250876, '3d1bB00', NULL, NULL, 124, NULL, NULL, 231835),
(250877, '3ungC04', NULL, NULL, 107, NULL, NULL, 231836),
(250878, '1ysmA01', NULL, NULL, 48, NULL, NULL, 231837),
(250879, '4u1cA01', NULL, NULL, 55, NULL, NULL, 231837),
(250880, '1qojA00', NULL, NULL, 46, NULL, NULL, 231837),
(250881, '2a26B01', NULL, NULL, 45, NULL, NULL, 231837),
(250882, '2lf0A01', NULL, NULL, 63, NULL, NULL, 231837),
(250883, '1e52A00', NULL, NULL, 63, NULL, NULL, 231837),
(250884, '3pxgA04', NULL, NULL, 59, NULL, NULL, 231837),
(250885, '2pebA00', NULL, NULL, 122, NULL, NULL, 231838),
(250886, '2p8iC00', NULL, NULL, 117, NULL, NULL, 231838),
(250887, '5avmA02', NULL, NULL, 167, NULL, NULL, 231839),
(250888, '2v9yB02', NULL, NULL, 195, NULL, NULL, 231839),
(250889, '2hs0A01', NULL, NULL, 204, NULL, NULL, 231839),
(250890, '2z1uA02', NULL, NULL, 190, NULL, NULL, 231839),
(250891, '3fd5A02', NULL, NULL, 251, NULL, NULL, 231839),
(250892, '3u0oA02', NULL, NULL, 184, NULL, NULL, 231839),
(250893, '2yxzA02', NULL, NULL, 168, NULL, NULL, 231839),
(250894, '3vtiC02', NULL, NULL, 179, NULL, NULL, 231839),
(250895, '3viuA04', NULL, NULL, 173, NULL, NULL, 231839),
(250896, '3viuA01', NULL, NULL, 219, NULL, NULL, 231839),
(250897, '3m84A02', NULL, NULL, 177, NULL, NULL, 231839),
(250898, '3mdoA02', NULL, NULL, 221, NULL, NULL, 231839),
(250899, '3kizA02', NULL, NULL, 225, NULL, NULL, 231839),
(250900, '2z1eA02', NULL, NULL, 171, NULL, NULL, 231839),
(250901, '3c9uA02', NULL, NULL, 166, NULL, NULL, 231839),
(250902, '2rb9A02', NULL, NULL, 178, NULL, NULL, 231839),
(250903, '1cliA02', NULL, NULL, 175, NULL, NULL, 231839),
(250904, '2zodA02', NULL, NULL, 181, NULL, NULL, 231839),
(250905, '2z01A02', NULL, NULL, 179, NULL, NULL, 231839),
(250906, '2btuA02', NULL, NULL, 179, NULL, NULL, 231839),
(250907, '5vk4A02', NULL, NULL, 176, NULL, NULL, 231839),
(250908, '1vk3A01', NULL, NULL, 216, NULL, NULL, 231839),
(250909, '3p4eA02', NULL, NULL, 175, NULL, NULL, 231839),
(250910, '3mcqA02', NULL, NULL, 178, NULL, NULL, 231839);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(250911, '5cm7A02', NULL, NULL, 155, NULL, NULL, 231839),
(250912, '2e1mA05', NULL, NULL, 91, NULL, NULL, 231840),
(250913, '3rhaB03', NULL, NULL, 93, NULL, NULL, 231840),
(250914, '2bcgG03', NULL, NULL, 105, NULL, NULL, 231840),
(250915, '5z2gA03', NULL, NULL, 101, NULL, NULL, 231840),
(250916, '1d5tA03', NULL, NULL, 105, NULL, NULL, 231840),
(250917, '1reoA03', NULL, NULL, 101, NULL, NULL, 231840),
(250918, '3p1wA03', NULL, NULL, 105, NULL, NULL, 231840),
(250919, '2iidA03', NULL, NULL, 101, NULL, NULL, 231840),
(250920, '5ts5A03', NULL, NULL, 101, NULL, NULL, 231840),
(250921, '6c87A03', NULL, NULL, 106, NULL, NULL, 231840),
(250922, '1o5wB03', NULL, NULL, 92, NULL, NULL, 231840),
(250923, '2bxrA03', NULL, NULL, 92, NULL, NULL, 231840),
(250924, '1vg0A03', NULL, NULL, 99, NULL, NULL, 231840),
(250925, '2yg5A03', NULL, NULL, 93, NULL, NULL, 231840),
(250926, '1s3eA03', NULL, NULL, 92, NULL, NULL, 231840),
(250927, '4i59A03', NULL, NULL, 92, NULL, NULL, 231840),
(250928, '3kveA03', NULL, NULL, 101, NULL, NULL, 231840),
(250929, '3u6gA00', NULL, NULL, 126, NULL, NULL, 231841),
(250930, '4qeyA00', NULL, NULL, 132, NULL, NULL, 231841),
(250931, '1vx7F02', NULL, NULL, 75, NULL, NULL, 231842),
(250932, '2ac1A02', NULL, NULL, 192, NULL, NULL, 231843),
(250933, '1w2tA02', NULL, NULL, 134, NULL, NULL, 231843),
(250934, '3h3lC00', NULL, NULL, 241, NULL, NULL, 231843),
(250935, '4hxcA00', NULL, NULL, 263, NULL, NULL, 231843),
(250936, '3ligA02', NULL, NULL, 169, NULL, NULL, 231843),
(250937, '3hbkA00', NULL, NULL, 245, NULL, NULL, 231843),
(250938, '4ffhA02', NULL, NULL, 165, NULL, NULL, 231843),
(250939, '3nmbA00', NULL, NULL, 260, NULL, NULL, 231843),
(250940, '4b1mA00', NULL, NULL, 165, NULL, NULL, 231843),
(250941, '1st8A02', NULL, NULL, 190, NULL, NULL, 231843),
(250942, '3kf3A02', NULL, NULL, 177, NULL, NULL, 231843),
(250943, '4jqtA02', NULL, NULL, 230, NULL, NULL, 231843),
(250944, '4qhzB00', NULL, NULL, 246, NULL, NULL, 231843),
(250945, '4jqtA01', NULL, NULL, 201, NULL, NULL, 231843),
(250946, '4qhzA00', NULL, NULL, 246, NULL, NULL, 231843),
(250947, '4qhzD00', NULL, NULL, 246, NULL, NULL, 231843),
(250948, '4qhzC00', NULL, NULL, 246, NULL, NULL, 231843),
(250949, '4eqvA02', NULL, NULL, 176, NULL, NULL, 231843),
(250950, '4ccdA03', NULL, NULL, 200, NULL, NULL, 231843),
(250951, '1y4wA02', NULL, NULL, 163, NULL, NULL, 231843),
(250952, '3sc7X02', NULL, NULL, 157, NULL, NULL, 231843),
(250953, '3pijA02', NULL, NULL, 149, NULL, NULL, 231843),
(250954, '5xh8A02', NULL, NULL, 178, NULL, NULL, 231843),
(250955, '5nslA02', NULL, NULL, 196, NULL, NULL, 231843),
(250956, '3u1xA00', NULL, NULL, 236, NULL, NULL, 231843),
(250957, '3immA00', NULL, NULL, 201, NULL, NULL, 231843),
(250958, '3ugfB02', NULL, NULL, 187, NULL, NULL, 231843),
(250959, '3osdA00', NULL, NULL, 265, NULL, NULL, 231843),
(250960, '3s5qA00', NULL, NULL, 214, NULL, NULL, 231843),
(250961, '4l9hA00', NULL, NULL, 160, NULL, NULL, 231844),
(250962, '4ouhC00', NULL, NULL, 163, NULL, NULL, 231844),
(250963, '4g1gA02', NULL, NULL, 169, NULL, NULL, 231845),
(250964, '3ljuX01', NULL, NULL, 144, NULL, NULL, 231846),
(250965, '2owaA01', NULL, NULL, 120, NULL, NULL, 231846),
(250966, '2olmA00', NULL, NULL, 140, NULL, NULL, 231846),
(250967, '3t9kA01', NULL, NULL, 120, NULL, NULL, 231846),
(250968, '3subB00', NULL, NULL, 138, NULL, NULL, 231846),
(250969, '2d9lA00', NULL, NULL, 134, NULL, NULL, 231846),
(250970, '2crwA00', NULL, NULL, 149, NULL, NULL, 231846),
(250971, '2crrA01', NULL, NULL, 121, NULL, NULL, 231846),
(250972, '2b0oG01', NULL, NULL, 122, NULL, NULL, 231846),
(250973, '2p57A00', NULL, NULL, 127, NULL, NULL, 231846),
(250974, '1dcqA01', NULL, NULL, 121, NULL, NULL, 231846),
(250975, '3dwdA00', NULL, NULL, 126, NULL, NULL, 231846),
(250976, '2iqjB00', NULL, NULL, 134, NULL, NULL, 231846),
(250977, '3kfwX02', NULL, NULL, 82, NULL, NULL, 231847),
(250978, '4q0jA03', NULL, NULL, 151, NULL, NULL, 231848),
(250979, '3nhqC03', NULL, NULL, 162, NULL, NULL, 231848),
(250980, '4r70B03', NULL, NULL, 157, NULL, NULL, 231848),
(250981, '3zq5A03', NULL, NULL, 155, NULL, NULL, 231848);
INSERT INTO "PUBLIC"."MODEL" VALUES
(250982, '5hsqA03', NULL, NULL, 162, NULL, NULL, 231848),
(250983, '4s21B03', NULL, NULL, 150, NULL, NULL, 231848),
(250984, '4gw9B03', NULL, NULL, 179, NULL, NULL, 231848),
(250985, '6baoA03', NULL, NULL, 151, NULL, NULL, 231848),
(250986, '1p35C00', NULL, NULL, 299, NULL, NULL, 231849),
(250987, '2jz8A00', NULL, NULL, 87, NULL, NULL, 231850),
(250988, '2jvmA01', NULL, NULL, 53, NULL, NULL, 231850),
(250989, '2odxA00', NULL, NULL, 62, NULL, NULL, 231850),
(250990, '2jrrA01', NULL, NULL, 53, NULL, NULL, 231850),
(250991, '3vpbE00', NULL, NULL, 56, NULL, NULL, 231851),
(250992, '3wwlA00', NULL, NULL, 54, NULL, NULL, 231851),
(250993, '5k2mF00', NULL, NULL, 53, NULL, NULL, 231851),
(250994, '2r7fA03', NULL, NULL, 21, NULL, NULL, 231852),
(250995, '2py5A06', NULL, NULL, 44, NULL, NULL, 231852),
(250996, '2pw9A01', NULL, NULL, 33, NULL, NULL, 231852),
(250997, '3fi7A02', NULL, NULL, 27, NULL, NULL, 231852),
(250998, '2b9bA04', NULL, NULL, 76, NULL, NULL, 231853),
(250999, '4i43B02', NULL, NULL, 119, NULL, NULL, 231854),
(251000, '2hdwA02', NULL, NULL, 91, NULL, NULL, 231855),
(251001, '2a6mB01', NULL, NULL, 133, NULL, NULL, 231856),
(251002, '4er8A00', NULL, NULL, 165, NULL, NULL, 231856),
(251003, '2fyxA00', NULL, NULL, 143, NULL, NULL, 231856),
(251004, '2f5gA00', NULL, NULL, 133, NULL, NULL, 231856),
(251005, '2ec2B00', NULL, NULL, 136, NULL, NULL, 231856),
(251006, '2vjvA00', NULL, NULL, 134, NULL, NULL, 231856),
(251007, '2xqcD00', NULL, NULL, 140, NULL, NULL, 231856),
(251008, '5tkyA04', NULL, NULL, 116, NULL, NULL, 231857),
(251009, '4f01A01', NULL, NULL, 139, NULL, NULL, 231857),
(251010, '1bprA00', NULL, NULL, 191, NULL, NULL, 231857),
(251011, '4r5kA01', NULL, NULL, 144, NULL, NULL, 231857),
(251012, '6eofA04', NULL, NULL, 116, NULL, NULL, 231857),
(251013, '2qxlB05', NULL, NULL, 152, NULL, NULL, 231857),
(251014, '4wv5B00', NULL, NULL, 151, NULL, NULL, 231857),
(251015, '2v7yA04', NULL, NULL, 150, NULL, NULL, 231857),
(251016, '1u00A01', NULL, NULL, 131, NULL, NULL, 231857),
(251017, '3n8eA00', NULL, NULL, 159, NULL, NULL, 231857),
(251018, '1ckrA00', NULL, NULL, 159, NULL, NULL, 231857),
(251019, '3dobA00', NULL, NULL, 152, NULL, NULL, 231857),
(251020, '3d2fA05', NULL, NULL, 136, NULL, NULL, 231857),
(251021, '3h0xA00', NULL, NULL, 152, NULL, NULL, 231857),
(251022, '4po2A01', NULL, NULL, 131, NULL, NULL, 231857),
(251023, '3dqgC00', NULL, NULL, 151, NULL, NULL, 231857),
(251024, '4jnfA01', NULL, NULL, 132, NULL, NULL, 231857),
(251025, '4fl9A05', NULL, NULL, 154, NULL, NULL, 231857),
(251026, '2op6A00', NULL, NULL, 152, NULL, NULL, 231857),
(251027, '4f01B01', NULL, NULL, 140, NULL, NULL, 231857),
(251028, '6az1F01', NULL, NULL, 107, NULL, NULL, 231858),
(251029, '2ihr103', NULL, NULL, 74, NULL, NULL, 231858),
(251030, '5npaA00', NULL, NULL, 72, NULL, NULL, 231858),
(251031, '2ljhA01', NULL, NULL, 63, NULL, NULL, 231858),
(251032, '3d5aX03', NULL, NULL, 91, NULL, NULL, 231858),
(251033, '1vs5E01', NULL, NULL, 73, NULL, NULL, 231858),
(251034, '3llhB00', NULL, NULL, 90, NULL, NULL, 231858),
(251035, '2l3cA00', NULL, NULL, 74, NULL, NULL, 231858),
(251036, '2xzmE01', NULL, NULL, 116, NULL, NULL, 231858),
(251037, '4dkkA02', NULL, NULL, 74, NULL, NULL, 231858),
(251038, '6htuA00', NULL, NULL, 77, NULL, NULL, 231858),
(251039, '1di2A00', NULL, NULL, 69, NULL, NULL, 231858),
(251040, '6htuC00', NULL, NULL, 77, NULL, NULL, 231858),
(251041, '1t4lB00', NULL, NULL, 90, NULL, NULL, 231858),
(251042, '1t4nA00', NULL, NULL, 94, NULL, NULL, 231858),
(251043, '1whnA01', NULL, NULL, 101, NULL, NULL, 231858),
(251044, '1x49A01', NULL, NULL, 70, NULL, NULL, 231858),
(251045, '5cffF00', NULL, NULL, 72, NULL, NULL, 231858),
(251046, '2b3tB03', NULL, NULL, 69, NULL, NULL, 231858),
(251047, '3vyxA00', NULL, NULL, 96, NULL, NULL, 231858),
(251048, '5xxuC01', NULL, NULL, 113, NULL, NULL, 231858),
(251049, '3j7yp00', NULL, NULL, 93, NULL, NULL, 231858),
(251050, '1rq0B03', NULL, NULL, 81, NULL, NULL, 231858),
(251051, '2rs7A01', NULL, NULL, 74, NULL, NULL, 231858),
(251052, '6g5iC01', NULL, NULL, 106, NULL, NULL, 231858);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(251053, '2ltsA00', NULL, NULL, 97, NULL, NULL, 231858),
(251054, '5optd01', NULL, NULL, 109, NULL, NULL, 231858),
(251055, '2mdrA00', NULL, NULL, 94, NULL, NULL, 231858),
(251056, '2jy9A01', NULL, NULL, 108, NULL, NULL, 231858),
(251057, '3rv0B03', NULL, NULL, 91, NULL, NULL, 231858),
(251058, '2cpnA01', NULL, NULL, 75, NULL, NULL, 231858),
(251059, '1x48A00', NULL, NULL, 88, NULL, NULL, 231858),
(251060, '5xyiC01', NULL, NULL, 107, NULL, NULL, 231858),
(251061, '1pkpA01', NULL, NULL, 73, NULL, NULL, 231858),
(251062, '2nugB02', NULL, NULL, 72, NULL, NULL, 231858),
(251063, '3adlA01', NULL, NULL, 75, NULL, NULL, 231858),
(251064, '1whqA01', NULL, NULL, 71, NULL, NULL, 231858),
(251065, '2n3fA02', NULL, NULL, 76, NULL, NULL, 231858),
(251066, '3adgA00', NULL, NULL, 73, NULL, NULL, 231858),
(251067, '4dh9Y00', NULL, NULL, 140, NULL, NULL, 231858),
(251068, '3vyyB00', NULL, NULL, 91, NULL, NULL, 231858),
(251069, '1j26A01', NULL, NULL, 87, NULL, NULL, 231858),
(251070, '5npgA00', NULL, NULL, 83, NULL, NULL, 231858),
(251071, '6faiC01', NULL, NULL, 105, NULL, NULL, 231858),
(251072, '4x8wA00', NULL, NULL, 75, NULL, NULL, 231858),
(251073, '1qu6A02', NULL, NULL, 76, NULL, NULL, 231858),
(251074, '1qu6A01', NULL, NULL, 85, NULL, NULL, 231858),
(251075, '3c4bA02', NULL, NULL, 67, NULL, NULL, 231858),
(251076, '2ltrA00', NULL, NULL, 105, NULL, NULL, 231858),
(251077, '2vqeE01', NULL, NULL, 68, NULL, NULL, 231858),
(251078, '1x47A01', NULL, NULL, 87, NULL, NULL, 231858),
(251079, '2db2A01', NULL, NULL, 94, NULL, NULL, 231858),
(251080, '2lrsA00', NULL, NULL, 71, NULL, NULL, 231858),
(251081, '1ekzA00', NULL, NULL, 76, NULL, NULL, 231858),
(251082, '2l2mA00', NULL, NULL, 77, NULL, NULL, 231858),
(251083, '2dixA01', NULL, NULL, 78, NULL, NULL, 231858),
(251084, '2n3gA00', NULL, NULL, 72, NULL, NULL, 231858),
(251085, '3p1xA00', NULL, NULL, 75, NULL, NULL, 231858),
(251086, '2rsmA00', NULL, NULL, 115, NULL, NULL, 231858),
(251087, '1gqeA03', NULL, NULL, 83, NULL, NULL, 231858),
(251088, '1uhzA00', NULL, NULL, 89, NULL, NULL, 231858),
(251089, '2b7vA00', NULL, NULL, 71, NULL, NULL, 231858),
(251090, '3htxA01', NULL, NULL, 90, NULL, NULL, 231858),
(251091, '1vw4502', NULL, NULL, 92, NULL, NULL, 231858),
(251092, '2khxA00', NULL, NULL, 85, NULL, NULL, 231858),
(251093, '2rtxA00', NULL, NULL, 121, NULL, NULL, 231858),
(251094, '1o0wA02', NULL, NULL, 68, NULL, NULL, 231858),
(251095, '2na2A00', NULL, NULL, 82, NULL, NULL, 231858),
(251096, '2yt4A03', NULL, NULL, 110, NULL, NULL, 231858),
(251097, '1t4oA00', NULL, NULL, 83, NULL, NULL, 231858),
(251098, '2yt4A02', NULL, NULL, 57, NULL, NULL, 231858),
(251099, '1zbtA03', NULL, NULL, 81, NULL, NULL, 231858),
(251100, '3j7aG01', NULL, NULL, 112, NULL, NULL, 231858),
(251101, '4wyqB00', NULL, NULL, 75, NULL, NULL, 231858),
(251102, '4wftB00', NULL, NULL, 104, NULL, NULL, 231858),
(251103, '2dmyA00', NULL, NULL, 97, NULL, NULL, 231858),
(251104, '6c4hv00', NULL, NULL, 63, NULL, NULL, 231858),
(251105, '2jvaA00', NULL, NULL, 108, NULL, NULL, 231858),
(251106, '3adjA00', NULL, NULL, 76, NULL, NULL, 231858),
(251107, '2l2nA00', NULL, NULL, 85, NULL, NULL, 231858),
(251108, '3fwcB00', NULL, NULL, 85, NULL, NULL, 231859),
(251109, '3hvnA01', NULL, NULL, 174, NULL, NULL, 231860),
(251110, '1s3rA01', NULL, NULL, 180, NULL, NULL, 231860),
(251111, '3cqfA01', NULL, NULL, 180, NULL, NULL, 231860),
(251112, '1pfoA01', NULL, NULL, 183, NULL, NULL, 231860),
(251113, '4hscX01', NULL, NULL, 181, NULL, NULL, 231860),
(251114, '3h0dA02', NULL, NULL, 84, NULL, NULL, 231861),
(251115, '3h0dB02', NULL, NULL, 84, NULL, NULL, 231861),
(251116, '3zyyX04', NULL, NULL, 188, NULL, NULL, 231862),
(251117, '2v6zM00', NULL, NULL, 75, NULL, NULL, 231863),
(251118, '1in4A03', NULL, NULL, 75, NULL, NULL, 231863),
(251119, '2chgA02', NULL, NULL, 66, NULL, NULL, 231863),
(251120, '1um8A02', NULL, NULL, 105, NULL, NULL, 231863),
(251121, '1l8qA02', NULL, NULL, 49, NULL, NULL, 231863),
(251122, '3uk6A02', NULL, NULL, 83, NULL, NULL, 231863),
(251123, '2qenA02', NULL, NULL, 78, NULL, NULL, 231863);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(251124, '3pvsA02', NULL, NULL, 76, NULL, NULL, 231863),
(251125, '3bosA02', NULL, NULL, 67, NULL, NULL, 231863),
(251126, '3u61C02', NULL, NULL, 67, NULL, NULL, 231863),
(251127, '3whkA02', NULL, NULL, 72, NULL, NULL, 231863),
(251128, '3hwsA02', NULL, NULL, 109, NULL, NULL, 231863),
(251129, '2v1uA01', NULL, NULL, 107, NULL, NULL, 231863),
(251130, '3pfiA02', NULL, NULL, 75, NULL, NULL, 231863),
(251131, '4fwdA02', NULL, NULL, 78, NULL, NULL, 231863),
(251132, '1sxjC02', NULL, NULL, 69, NULL, NULL, 231863),
(251133, '4d81A02', NULL, NULL, 100, NULL, NULL, 231863),
(251134, '2qz4A02', NULL, NULL, 77, NULL, NULL, 231863),
(251135, '4lcbA02', NULL, NULL, 99, NULL, NULL, 231863),
(251136, '2fnaA02', NULL, NULL, 76, NULL, NULL, 231863),
(251137, '1d2nA02', NULL, NULL, 67, NULL, NULL, 231863),
(251138, '3u60E02', NULL, NULL, 59, NULL, NULL, 231863),
(251139, '3ajiB00', NULL, NULL, 83, NULL, NULL, 231863),
(251140, '1qzmA00', NULL, NULL, 94, NULL, NULL, 231863),
(251141, '5eqtA02', NULL, NULL, 72, NULL, NULL, 231863),
(251142, '2qbyA01', NULL, NULL, 108, NULL, NULL, 231863),
(251143, '5m32h03', NULL, NULL, 72, NULL, NULL, 231863),
(251144, '4lgmA02', NULL, NULL, 100, NULL, NULL, 231863),
(251145, '3h4mA02', NULL, NULL, 72, NULL, NULL, 231863),
(251146, '5ftnA06', NULL, NULL, 101, NULL, NULL, 231863),
(251147, '3sc3B02', NULL, NULL, 67, NULL, NULL, 231863),
(251148, '6gcnD02', NULL, NULL, 80, NULL, NULL, 231863),
(251149, '2ce7D02', NULL, NULL, 78, NULL, NULL, 231863),
(251150, '1hqcA02', NULL, NULL, 76, NULL, NULL, 231863),
(251151, '3bosB02', NULL, NULL, 67, NULL, NULL, 231863),
(251152, '2z4sA02', NULL, NULL, 72, NULL, NULL, 231863),
(251153, '2dznF00', NULL, NULL, 82, NULL, NULL, 231863),
(251154, '1sxjB02', NULL, NULL, 64, NULL, NULL, 231863),
(251155, '1fnnA01', NULL, NULL, 102, NULL, NULL, 231863),
(251156, '3kw6A01', NULL, NULL, 75, NULL, NULL, 231863),
(251157, '5c1bA06', NULL, NULL, 79, NULL, NULL, 231863),
(251158, '1im2A03', NULL, NULL, 98, NULL, NULL, 231863),
(251159, '1qvrC03', NULL, NULL, 96, NULL, NULL, 231863),
(251160, '3b9pA02', NULL, NULL, 84, NULL, NULL, 231863),
(251161, '5ep2A02', NULL, NULL, 82, NULL, NULL, 231863),
(251162, '1ixzA02', NULL, NULL, 68, NULL, NULL, 231863),
(251163, '4l15A02', NULL, NULL, 83, NULL, NULL, 231863),
(251164, '1xwiA02', NULL, NULL, 123, NULL, NULL, 231863),
(251165, '2qbyB01', NULL, NULL, 108, NULL, NULL, 231863),
(251166, '1iqpA02', NULL, NULL, 64, NULL, NULL, 231863),
(251167, '3te6A02', NULL, NULL, 121, NULL, NULL, 231863),
(251168, '1jqjD03', NULL, NULL, 89, NULL, NULL, 231863),
(251169, '6blbA02', NULL, NULL, 76, NULL, NULL, 231863),
(251170, '2x8aA02', NULL, NULL, 97, NULL, NULL, 231863),
(251171, '1lv7A02', NULL, NULL, 76, NULL, NULL, 231863),
(251172, '3sc3A02', NULL, NULL, 67, NULL, NULL, 231863),
(251173, '3mhvC00', NULL, NULL, 117, NULL, NULL, 231863),
(251174, '2zanA02', NULL, NULL, 123, NULL, NULL, 231863),
(251175, '1e94E03', NULL, NULL, 106, NULL, NULL, 231863),
(251176, '4zpxA02', NULL, NULL, 93, NULL, NULL, 231863),
(251177, '1njgA02', NULL, NULL, 66, NULL, NULL, 231863),
(251178, '1ojlD02', NULL, NULL, 82, NULL, NULL, 231863),
(251179, '6az0A02', NULL, NULL, 73, NULL, NULL, 231863),
(251180, '4gitA00', NULL, NULL, 94, NULL, NULL, 231863),
(251181, '1sxjE02', NULL, NULL, 64, NULL, NULL, 231863),
(251182, '3d8bB02', NULL, NULL, 84, NULL, NULL, 231863),
(251183, '1c1kA01', NULL, NULL, 102, NULL, NULL, 231863),
(251184, '1sxjA02', NULL, NULL, 72, NULL, NULL, 231863),
(251185, '4ko8B04', NULL, NULL, 90, NULL, NULL, 231863),
(251186, '1jr3D03', NULL, NULL, 71, NULL, NULL, 231863),
(251187, '4lrtC02', NULL, NULL, 74, NULL, NULL, 231863),
(251188, '3dzdA03', NULL, NULL, 69, NULL, NULL, 231863),
(251189, '3vfdA02', NULL, NULL, 84, NULL, NULL, 231863),
(251190, '4l4uA03', NULL, NULL, 73, NULL, NULL, 231863),
(251191, '4jn6C02', NULL, NULL, 71, NULL, NULL, 231863),
(251192, '5ftjA04', NULL, NULL, 95, NULL, NULL, 231863),
(251193, '2r62A02', NULL, NULL, 86, NULL, NULL, 231863),
(251194, '1nvmA02', NULL, NULL, 68, NULL, NULL, 231863),
(251195, '3m6aA03', NULL, NULL, 86, NULL, NULL, 231863);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(251196, '4lj9A02', NULL, NULL, 98, NULL, NULL, 231863),
(251197, '2c9oB03', NULL, NULL, 91, NULL, NULL, 231863),
(251198, '1njgB01', NULL, NULL, 84, NULL, NULL, 231863),
(251199, '3sykA02', NULL, NULL, 93, NULL, NULL, 231863),
(251200, '1sxjD02', NULL, NULL, 70, NULL, NULL, 231863),
(251201, '5expA02', NULL, NULL, 77, NULL, NULL, 231863),
(251202, '4qosA02', NULL, NULL, 86, NULL, NULL, 231863),
(251203, '5ftjA06', NULL, NULL, 99, NULL, NULL, 231863),
(251204, '6b5cA02', NULL, NULL, 86, NULL, NULL, 231863),
(251205, '3zh9B02', NULL, NULL, 70, NULL, NULL, 231863),
(251206, '1r6bX03', NULL, NULL, 88, NULL, NULL, 231863),
(251207, '5dygA04', NULL, NULL, 97, NULL, NULL, 231863),
(251208, '5m7oA03', NULL, NULL, 87, NULL, NULL, 231863),
(251209, '1r6bX05', NULL, NULL, 106, NULL, NULL, 231863),
(251210, '2xszD02', NULL, NULL, 101, NULL, NULL, 231863),
(251211, '1w5sA01', NULL, NULL, 94, NULL, NULL, 231863),
(251212, '4a3vB01', NULL, NULL, 72, NULL, NULL, 231863),
(251213, '4qhsA02', NULL, NULL, 79, NULL, NULL, 231863),
(251214, '3pxgA03', NULL, NULL, 83, NULL, NULL, 231863),
(251215, '3vhxF00', NULL, NULL, 120, NULL, NULL, 231864),
(251216, '3vhxH00', NULL, NULL, 95, NULL, NULL, 231864),
(251217, '1z5zA02', NULL, NULL, 76, NULL, NULL, 231865),
(251218, '1z3iX03', NULL, NULL, 99, NULL, NULL, 231865),
(251219, '1z63A03', NULL, NULL, 104, NULL, NULL, 231865),
(251220, '3nf5B00', NULL, NULL, 164, NULL, NULL, 231866),
(251221, '3pbpB00', NULL, NULL, 148, NULL, NULL, 231866),
(251222, '2q5xA00', NULL, NULL, 155, NULL, NULL, 231866),
(251223, '3kepB00', NULL, NULL, 155, NULL, NULL, 231866),
(251224, '5hb6B00', NULL, NULL, 144, NULL, NULL, 231866),
(251225, '5e0qB00', NULL, NULL, 153, NULL, NULL, 231866),
(251226, '5c2mA00', NULL, NULL, 250, NULL, NULL, 231867),
(251227, '1tl2A00', NULL, NULL, 236, NULL, NULL, 231867),
(251228, '1zk5A00', NULL, NULL, 176, NULL, NULL, 231868),
(251229, '2bscA00', NULL, NULL, 177, NULL, NULL, 231868),
(251230, '3tpqM01', NULL, NULL, 60, NULL, NULL, 231869),
(251231, '2yjeM00', NULL, NULL, 58, NULL, NULL, 231869),
(251232, '2py6A01', NULL, NULL, 87, NULL, NULL, 231870),
(251233, '1w36C01', NULL, NULL, 217, NULL, NULL, 231871),
(251234, '1w36F01', NULL, NULL, 175, NULL, NULL, 231871),
(251235, '2iboA00', NULL, NULL, 104, NULL, NULL, 231872),
(251236, '1vk8A00', NULL, NULL, 106, NULL, NULL, 231872),
(251237, '1s7hA02', NULL, NULL, 89, NULL, NULL, 231872),
(251238, '1yqhB00', NULL, NULL, 109, NULL, NULL, 231872),
(251239, '1sbrA02', NULL, NULL, 89, NULL, NULL, 231872),
(251240, '2epiB00', NULL, NULL, 100, NULL, NULL, 231872),
(251241, '1lxnA00', NULL, NULL, 99, NULL, NULL, 231872),
(251242, '1sbrB02', NULL, NULL, 89, NULL, NULL, 231872),
(251243, '1s99A01', NULL, NULL, 87, NULL, NULL, 231872),
(251244, '1lxjA00', NULL, NULL, 104, NULL, NULL, 231872),
(251245, '1s99A02', NULL, NULL, 89, NULL, NULL, 231872),
(251246, '1s99B02', NULL, NULL, 89, NULL, NULL, 231872),
(251247, '4b0zA00', NULL, NULL, 229, NULL, NULL, 231873),
(251248, '3t5vA00', NULL, NULL, 316, NULL, NULL, 231873),
(251249, '3g74A00', NULL, NULL, 100, NULL, NULL, 231874),
(251250, '3g74B00', NULL, NULL, 100, NULL, NULL, 231874),
(251251, '3g74C00', NULL, NULL, 100, NULL, NULL, 231874),
(251252, '3g74D00', NULL, NULL, 100, NULL, NULL, 231874),
(251253, '3g74E00', NULL, NULL, 100, NULL, NULL, 231874),
(251254, '3g74F00', NULL, NULL, 100, NULL, NULL, 231874),
(251255, '3g74G00', NULL, NULL, 100, NULL, NULL, 231874),
(251256, '3g74H00', NULL, NULL, 100, NULL, NULL, 231874),
(251257, '2q2eB05', NULL, NULL, 111, NULL, NULL, 231875),
(251258, '1io1A03', NULL, NULL, 95, NULL, NULL, 231876),
(251259, '1l8qA03', NULL, NULL, 109, NULL, NULL, 231877),
(251260, '3pvvA00', NULL, NULL, 101, NULL, NULL, 231877),
(251261, '1j1vA00', NULL, NULL, 94, NULL, NULL, 231877),
(251262, '2lvaA02', NULL, NULL, 27, NULL, NULL, 231878),
(251263, '3mp6A05', NULL, NULL, 72, NULL, NULL, 231879),
(251264, '2m0oA00', NULL, NULL, 79, NULL, NULL, 231879),
(251265, '2e6nA00', NULL, NULL, 104, NULL, NULL, 231879),
(251266, '2eqjA00', NULL, NULL, 66, NULL, NULL, 231879);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(251267, '2g3rA01', NULL, NULL, 58, NULL, NULL, 231879),
(251268, '4hczA00', NULL, NULL, 58, NULL, NULL, 231879),
(251269, '3meuB02', NULL, NULL, 76, NULL, NULL, 231879),
(251270, '5ygbA02', NULL, NULL, 80, NULL, NULL, 231879),
(251271, '2qqrA01', NULL, NULL, 65, NULL, NULL, 231879),
(251272, '2hqxA01', NULL, NULL, 81, NULL, NULL, 231879),
(251273, '3oq5A01', NULL, NULL, 113, NULL, NULL, 231879),
(251274, '4ld6A00', NULL, NULL, 117, NULL, NULL, 231879),
(251275, '5c6sA01', NULL, NULL, 120, NULL, NULL, 231879),
(251276, '1oz2A03', NULL, NULL, 108, NULL, NULL, 231879),
(251277, '5vqhA02', NULL, NULL, 80, NULL, NULL, 231879),
(251278, '3m9qB00', NULL, NULL, 101, NULL, NULL, 231879),
(251279, '3pnwL00', NULL, NULL, 61, NULL, NULL, 231879),
(251280, '4c5eA03', NULL, NULL, 115, NULL, NULL, 231879),
(251281, '4c5eA04', NULL, NULL, 78, NULL, NULL, 231879),
(251282, '4pliA00', NULL, NULL, 59, NULL, NULL, 231879),
(251283, '6a7kA00', NULL, NULL, 74, NULL, NULL, 231879),
(251284, '2ckkA01', NULL, NULL, 53, NULL, NULL, 231879),
(251285, '3kufA02', NULL, NULL, 86, NULL, NULL, 231879),
(251286, '4c5eA01', NULL, NULL, 153, NULL, NULL, 231879),
(251287, '3lx7A01', NULL, NULL, 58, NULL, NULL, 231879),
(251288, '4rg2B01', NULL, NULL, 57, NULL, NULL, 231879),
(251289, '3askA01', NULL, NULL, 68, NULL, NULL, 231879),
(251290, '2mamA00', NULL, NULL, 118, NULL, NULL, 231879),
(251291, '1wjrA00', NULL, NULL, 127, NULL, NULL, 231879),
(251292, '2xk0A00', NULL, NULL, 69, NULL, NULL, 231879),
(251293, '2xdpA01', NULL, NULL, 69, NULL, NULL, 231879),
(251294, '3pmiA01', NULL, NULL, 65, NULL, NULL, 231879),
(251295, '4ovaA01', NULL, NULL, 53, NULL, NULL, 231879),
(251296, '4ii1A02', NULL, NULL, 56, NULL, NULL, 231879),
(251297, '6bybA02', NULL, NULL, 101, NULL, NULL, 231879),
(251298, '3pmtA00', NULL, NULL, 59, NULL, NULL, 231879),
(251299, '2l89A00', NULL, NULL, 108, NULL, NULL, 231879),
(251300, '3ntkA02', NULL, NULL, 80, NULL, NULL, 231879),
(251301, '2k3yA01', NULL, NULL, 117, NULL, NULL, 231879),
(251302, '2f5kA01', NULL, NULL, 50, NULL, NULL, 231879),
(251303, '3vytA00', NULL, NULL, 53, NULL, NULL, 231879),
(251304, '5j39A02', NULL, NULL, 70, NULL, NULL, 231879),
(251305, '1wjsA00', NULL, NULL, 127, NULL, NULL, 231879),
(251306, '2digA00', NULL, NULL, 68, NULL, NULL, 231879),
(251307, '2e5qA00', NULL, NULL, 63, NULL, NULL, 231879),
(251308, '3qbyB00', NULL, NULL, 94, NULL, NULL, 231879),
(251309, '4iupA02', NULL, NULL, 73, NULL, NULL, 231879),
(251310, '2eqmA01', NULL, NULL, 53, NULL, NULL, 231879),
(251311, '3oa6A01', NULL, NULL, 60, NULL, NULL, 231879),
(251312, '3ceyB01', NULL, NULL, 146, NULL, NULL, 231879),
(251313, '3oymA02', NULL, NULL, 70, NULL, NULL, 231879),
(251314, '2budA00', NULL, NULL, 92, NULL, NULL, 231879),
(251315, '2m1hA00', NULL, NULL, 118, NULL, NULL, 231879),
(251316, '2equA00', NULL, NULL, 74, NULL, NULL, 231879),
(251317, '2bivA01', NULL, NULL, 108, NULL, NULL, 231879),
(251318, '2r58A01', NULL, NULL, 111, NULL, NULL, 231879),
(251319, '3o8vA01', NULL, NULL, 45, NULL, NULL, 231879),
(251320, '2ot2A01', NULL, NULL, 59, NULL, NULL, 231879),
(251321, '1ssfA01', NULL, NULL, 62, NULL, NULL, 231879),
(251322, '2fhdA01', NULL, NULL, 63, NULL, NULL, 231879),
(251323, '1ri0A01', NULL, NULL, 81, NULL, NULL, 231879),
(251324, '1khcA01', NULL, NULL, 65, NULL, NULL, 231879),
(251325, '2r58A02', NULL, NULL, 104, NULL, NULL, 231879),
(251326, '3feoB03', NULL, NULL, 107, NULL, NULL, 231879),
(251327, '3feoB01', NULL, NULL, 151, NULL, NULL, 231879),
(251328, '3feoB02', NULL, NULL, 96, NULL, NULL, 231879),
(251329, '5d6wA01', NULL, NULL, 66, NULL, NULL, 231879),
(251330, '3c4sA00', NULL, NULL, 66, NULL, NULL, 231879),
(251331, '4qw2B02', NULL, NULL, 68, NULL, NULL, 231879),
(251332, '3goxA01', NULL, NULL, 51, NULL, NULL, 231879),
(251333, '1h3zA00', NULL, NULL, 109, NULL, NULL, 231879),
(251334, '3d3rA00', NULL, NULL, 103, NULL, NULL, 231879),
(251335, '3ceyB02', NULL, NULL, 104, NULL, NULL, 231879),
(251336, '2lrqA00', NULL, NULL, 85, NULL, NULL, 231879),
(251337, '3pfsB00', NULL, NULL, 134, NULL, NULL, 231879);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(251338, '3p8dA00', NULL, NULL, 67, NULL, NULL, 231879),
(251339, '1wjqA01', NULL, NULL, 78, NULL, NULL, 231879),
(251340, '2l8dA00', NULL, NULL, 66, NULL, NULL, 231879),
(251341, '2rhyA01', NULL, NULL, 107, NULL, NULL, 231879),
(251342, '3fdrA00', NULL, NULL, 94, NULL, NULL, 231879),
(251343, '3sd4A00', NULL, NULL, 69, NULL, NULL, 231879),
(251344, '3h8zA01', NULL, NULL, 48, NULL, NULL, 231879),
(251345, '6bogA01', NULL, NULL, 53, NULL, NULL, 231879),
(251346, '6bhdA01', NULL, NULL, 60, NULL, NULL, 231879),
(251347, '3qiiA00', NULL, NULL, 65, NULL, NULL, 231879),
(251348, '4c5eC02', NULL, NULL, 105, NULL, NULL, 231879),
(251349, '4c5iA04', NULL, NULL, 79, NULL, NULL, 231879),
(251350, '4b9wA02', NULL, NULL, 56, NULL, NULL, 231879),
(251351, '2eqkA01', NULL, NULL, 73, NULL, NULL, 231879),
(251352, '2z1cB00', NULL, NULL, 75, NULL, NULL, 231879),
(251353, '6bhdA03', NULL, NULL, 67, NULL, NULL, 231879),
(251354, '3h8zA02', NULL, NULL, 80, NULL, NULL, 231879),
(251355, '2wacA02', NULL, NULL, 91, NULL, NULL, 231879),
(251356, '2ltoA00', NULL, NULL, 58, NULL, NULL, 231879),
(251357, '4qq6A00', NULL, NULL, 67, NULL, NULL, 231879),
(251358, '5in1A01', NULL, NULL, 50, NULL, NULL, 231879),
(251359, '2daqA00', NULL, NULL, 110, NULL, NULL, 231879),
(251360, '6bphA00', NULL, NULL, 69, NULL, NULL, 231879),
(251361, '3ut1A02', NULL, NULL, 104, NULL, NULL, 231879),
(251362, '3ut1A03', NULL, NULL, 108, NULL, NULL, 231879),
(251363, '2jtfA00', NULL, NULL, 83, NULL, NULL, 231879),
(251364, '3ut1A01', NULL, NULL, 112, NULL, NULL, 231879),
(251365, '1oyxA01', NULL, NULL, 119, NULL, NULL, 231879),
(251366, '4ns5A02', NULL, NULL, 105, NULL, NULL, 231879),
(251367, '2p0kA01', NULL, NULL, 108, NULL, NULL, 231879),
(251368, '2p0kA02', NULL, NULL, 104, NULL, NULL, 231879),
(251369, '3e9fA00', NULL, NULL, 121, NULL, NULL, 231879),
(251370, '3llrB01', NULL, NULL, 74, NULL, NULL, 231879),
(251371, '4qqdB01', NULL, NULL, 85, NULL, NULL, 231879),
(251372, '3f70A04', NULL, NULL, 78, NULL, NULL, 231879),
(251373, '4fu6A00', NULL, NULL, 109, NULL, NULL, 231879),
(251374, '2efiA00', NULL, NULL, 100, NULL, NULL, 231879),
(251375, '4z02B01', NULL, NULL, 118, NULL, NULL, 231879),
(251376, '3ceyA03', NULL, NULL, 106, NULL, NULL, 231879),
(251377, '4a4fA00', NULL, NULL, 64, NULL, NULL, 231879),
(251378, '5yj8A00', NULL, NULL, 60, NULL, NULL, 231879),
(251379, '3f70A02', NULL, NULL, 72, NULL, NULL, 231879),
(251380, '2ekoA00', NULL, NULL, 87, NULL, NULL, 231879),
(251381, '2m16A00', NULL, NULL, 97, NULL, NULL, 231879),
(251382, '4uc4A01', NULL, NULL, 64, NULL, NULL, 231879),
(251383, '5kcoA01', NULL, NULL, 70, NULL, NULL, 231879),
(251384, '3pnwO00', NULL, NULL, 77, NULL, NULL, 231879),
(251385, '4qqgG00', NULL, NULL, 81, NULL, NULL, 231879),
(251386, '1wgsA00', NULL, NULL, 133, NULL, NULL, 231879),
(251387, '2gfuA00', NULL, NULL, 134, NULL, NULL, 231879),
(251388, '2yrvA01', NULL, NULL, 113, NULL, NULL, 231879),
(251389, '2bivC02', NULL, NULL, 104, NULL, NULL, 231879),
(251390, '3zehA00', NULL, NULL, 105, NULL, NULL, 231879),
(251391, '4q5wA02', NULL, NULL, 85, NULL, NULL, 231879),
(251392, '1n27A00', NULL, NULL, 96, NULL, NULL, 231879),
(251393, '3gu3A02', NULL, NULL, 108, NULL, NULL, 231880),
(251394, '3f2bA07', NULL, NULL, 86, NULL, NULL, 231881),
(251395, '4o9bC00', NULL, NULL, 104, NULL, NULL, 231882),
(251396, '3p8cD01', NULL, NULL, 65, NULL, NULL, 231882),
(251397, '1wt6B00', NULL, NULL, 81, NULL, NULL, 231882),
(251398, '3basB00', NULL, NULL, 89, NULL, NULL, 231882),
(251399, '4n78D01', NULL, NULL, 85, NULL, NULL, 231882),
(251400, '1ic2A00', NULL, NULL, 81, NULL, NULL, 231882),
(251401, '1d7mA00', NULL, NULL, 101, NULL, NULL, 231882),
(251402, '3ojaB03', NULL, NULL, 95, NULL, NULL, 231882),
(251403, '5bu5A01', NULL, NULL, 97, NULL, NULL, 231882),
(251404, '3hrnA00', NULL, NULL, 64, NULL, NULL, 231882),
(251405, '2qihA00', NULL, NULL, 141, NULL, NULL, 231882),
(251406, '1x79B00', NULL, NULL, 92, NULL, NULL, 231882),
(251407, '4i1lA00', NULL, NULL, 76, NULL, NULL, 231882),
(251408, '6h9mA00', NULL, NULL, 96, NULL, NULL, 231882);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(251409, '3u1cA00', NULL, NULL, 101, NULL, NULL, 231882),
(251410, '3vp9B00', NULL, NULL, 92, NULL, NULL, 231882),
(251411, '2pohA01', NULL, NULL, 156, NULL, NULL, 231882),
(251412, '2fxmB00', NULL, NULL, 129, NULL, NULL, 231882),
(251413, '5ktbA01', NULL, NULL, 63, NULL, NULL, 231882),
(251414, '5ktbB01', NULL, NULL, 82, NULL, NULL, 231882),
(251415, '2pohF01', NULL, NULL, 143, NULL, NULL, 231882),
(251416, '3u59D00', NULL, NULL, 101, NULL, NULL, 231882),
(251417, '3o0zB00', NULL, NULL, 168, NULL, NULL, 231882),
(251418, '4zkpA01', NULL, NULL, 102, NULL, NULL, 231882),
(251419, '2jeeA00', NULL, NULL, 81, NULL, NULL, 231882),
(251420, '3s28A01', NULL, NULL, 121, NULL, NULL, 231883),
(251421, '4rbnA01', NULL, NULL, 132, NULL, NULL, 231883),
(251422, '2r7rA03', NULL, NULL, 76, NULL, NULL, 231884),
(251423, '3u02A02', NULL, NULL, 97, NULL, NULL, 231885),
(251424, '2dbsA00', NULL, NULL, 90, NULL, NULL, 231886),
(251425, '3fybB00', NULL, NULL, 88, NULL, NULL, 231887),
(251426, '3fybA00', NULL, NULL, 104, NULL, NULL, 231887),
(251427, '2o35B00', NULL, NULL, 105, NULL, NULL, 231887),
(251428, '2o35A00', NULL, NULL, 82, NULL, NULL, 231887),
(251429, '2au3A02', NULL, NULL, 127, NULL, NULL, 231888),
(251430, '4edgA01', NULL, NULL, 134, NULL, NULL, 231888),
(251431, '5gujA01', NULL, NULL, 132, NULL, NULL, 231888),
(251432, '1dd9A01', NULL, NULL, 126, NULL, NULL, 231888),
(251433, '5vazA01', NULL, NULL, 130, NULL, NULL, 231888),
(251434, '5w36B01', NULL, NULL, 136, NULL, NULL, 231888),
(251435, '1xfjA00', NULL, NULL, 261, NULL, NULL, 231889),
(251436, '1z9tA00', NULL, NULL, 255, NULL, NULL, 231889),
(251437, '1t8hA00', NULL, NULL, 277, NULL, NULL, 231889),
(251438, '1rw0A00', NULL, NULL, 243, NULL, NULL, 231889),
(251439, '1rv9A00', NULL, NULL, 259, NULL, NULL, 231889),
(251440, '1ut7B01', NULL, NULL, 146, NULL, NULL, 231890),
(251441, '3ulxA01', NULL, NULL, 151, NULL, NULL, 231890),
(251442, '1ykhA00', NULL, NULL, 108, NULL, NULL, 231891),
(251443, '5cecB00', NULL, NULL, 203, NULL, NULL, 231892),
(251444, '5kwdA00', NULL, NULL, 160, NULL, NULL, 231892),
(251445, '2f8xK00', NULL, NULL, 256, NULL, NULL, 231892),
(251446, '5madE00', NULL, NULL, 160, NULL, NULL, 231892),
(251447, '4j7wA00', NULL, NULL, 169, NULL, NULL, 231892),
(251448, '5bxoB00', NULL, NULL, 164, NULL, NULL, 231892),
(251449, '5hryH00', NULL, NULL, 169, NULL, NULL, 231892),
(251450, '1k1aA00', NULL, NULL, 241, NULL, NULL, 231892),
(251451, '5eilB00', NULL, NULL, 159, NULL, NULL, 231892),
(251452, '2rfmA00', NULL, NULL, 192, NULL, NULL, 231892),
(251453, '1sw6A00', NULL, NULL, 272, NULL, NULL, 231892),
(251454, '2fo1E00', NULL, NULL, 305, NULL, NULL, 231892),
(251455, '2jabC00', NULL, NULL, 136, NULL, NULL, 231892),
(251456, '4zhbA00', NULL, NULL, 114, NULL, NULL, 231892),
(251457, '4ydwA00', NULL, NULL, 169, NULL, NULL, 231892),
(251458, '4rlyA00', NULL, NULL, 329, NULL, NULL, 231892),
(251459, '5u0kA00', NULL, NULL, 98, NULL, NULL, 231892),
(251460, '4hb5B00', NULL, NULL, 169, NULL, NULL, 231892),
(251461, '5eylB00', NULL, NULL, 152, NULL, NULL, 231892),
(251462, '5mblB00', NULL, NULL, 171, NULL, NULL, 231892),
(251463, '5kngB00', NULL, NULL, 169, NULL, NULL, 231892),
(251464, '5u0iB00', NULL, NULL, 93, NULL, NULL, 231892),
(251465, '6ghmC01', NULL, NULL, 139, NULL, NULL, 231892),
(251466, '6ne1B00', NULL, NULL, 161, NULL, NULL, 231892),
(251467, '2l6bA00', NULL, NULL, 115, NULL, NULL, 231892),
(251468, '5aqaA01', NULL, NULL, 153, NULL, NULL, 231892),
(251469, '2bkkD00', NULL, NULL, 169, NULL, NULL, 231892),
(251470, '1n11A00', NULL, NULL, 437, NULL, NULL, 231892),
(251471, '3hraA00', NULL, NULL, 201, NULL, NULL, 231892),
(251472, '4duiA00', NULL, NULL, 169, NULL, NULL, 231892),
(251473, '1n0qB00', NULL, NULL, 93, NULL, NULL, 231892),
(251474, '3v31A00', NULL, NULL, 167, NULL, NULL, 231892),
(251475, '1dcqA02', NULL, NULL, 157, NULL, NULL, 231892),
(251476, '4b93B00', NULL, NULL, 197, NULL, NULL, 231892),
(251477, '3ehrA02', NULL, NULL, 116, NULL, NULL, 231892),
(251478, '1s70B01', NULL, NULL, 162, NULL, NULL, 231892),
(251479, '1s70B02', NULL, NULL, 137, NULL, NULL, 231892);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(251480, '5oovA00', NULL, NULL, 168, NULL, NULL, 231892),
(251481, '5ja4D00', NULL, NULL, 158, NULL, NULL, 231892),
(251482, '6fp7B00', NULL, NULL, 164, NULL, NULL, 231892),
(251483, '1bi7B00', NULL, NULL, 134, NULL, NULL, 231892),
(251484, '3zu7B00', NULL, NULL, 169, NULL, NULL, 231892),
(251485, '2v5qC00', NULL, NULL, 141, NULL, NULL, 231892),
(251486, '3utmB01', NULL, NULL, 175, NULL, NULL, 231892),
(251487, '6h47B00', NULL, NULL, 158, NULL, NULL, 231892),
(251488, '5op1A00', NULL, NULL, 168, NULL, NULL, 231892),
(251489, '3t9kA02', NULL, NULL, 157, NULL, NULL, 231892),
(251490, '5ooyA00', NULL, NULL, 168, NULL, NULL, 231892),
(251491, '4f6rD00', NULL, NULL, 169, NULL, NULL, 231892),
(251492, '5oyjA00', NULL, NULL, 169, NULL, NULL, 231892),
(251493, '5aarA00', NULL, NULL, 185, NULL, NULL, 231892),
(251494, '5y4fB00', NULL, NULL, 416, NULL, NULL, 231892),
(251495, '5hs0A00', NULL, NULL, 166, NULL, NULL, 231892),
(251496, '4hi8A00', NULL, NULL, 179, NULL, NULL, 231892),
(251497, '4besA02', NULL, NULL, 133, NULL, NULL, 231892),
(251498, '5gikA00', NULL, NULL, 154, NULL, NULL, 231892),
(251499, '2v4hD00', NULL, NULL, 136, NULL, NULL, 231892),
(251500, '3deoA02', NULL, NULL, 146, NULL, NULL, 231892),
(251501, '4k5aB00', NULL, NULL, 169, NULL, NULL, 231892),
(251502, '5z2mB00', NULL, NULL, 138, NULL, NULL, 231892),
(251503, '3nogD00', NULL, NULL, 169, NULL, NULL, 231892),
(251504, '1mx4B00', NULL, NULL, 168, NULL, NULL, 231892),
(251505, '1blxB00', NULL, NULL, 166, NULL, NULL, 231892),
(251506, '5aaoE00', NULL, NULL, 169, NULL, NULL, 231892),
(251507, '3aaaC00', NULL, NULL, 123, NULL, NULL, 231892),
(251508, '2vgeA00', NULL, NULL, 229, NULL, NULL, 231892),
(251509, '4qfvC02', NULL, NULL, 69, NULL, NULL, 231892),
(251510, '1awcB00', NULL, NULL, 153, NULL, NULL, 231892),
(251511, '3ljnA00', NULL, NULL, 319, NULL, NULL, 231892),
(251512, '6fpaA00', NULL, NULL, 164, NULL, NULL, 231892),
(251513, '4hqdA00', NULL, NULL, 169, NULL, NULL, 231892),
(251514, '4o1pA01', NULL, NULL, 306, NULL, NULL, 231892),
(251515, '5y4eA00', NULL, NULL, 251, NULL, NULL, 231892),
(251516, '2zgdA00', NULL, NULL, 110, NULL, NULL, 231892),
(251517, '3keaA00', NULL, NULL, 285, NULL, NULL, 231892),
(251518, '1wdyA00', NULL, NULL, 285, NULL, NULL, 231892),
(251519, '5mlbB00', NULL, NULL, 157, NULL, NULL, 231892),
(251520, '2p2cP00', NULL, NULL, 169, NULL, NULL, 231892),
(251521, '4hbdA00', NULL, NULL, 245, NULL, NULL, 231892),
(251522, '4bszB00', NULL, NULL, 158, NULL, NULL, 231892),
(251523, '6ndzF00', NULL, NULL, 200, NULL, NULL, 231892),
(251524, '2xenA00', NULL, NULL, 91, NULL, NULL, 231892),
(251525, '1yyhB00', NULL, NULL, 199, NULL, NULL, 231892),
(251526, '3zuvB00', NULL, NULL, 136, NULL, NULL, 231892),
(251527, '3eu9C00', NULL, NULL, 240, NULL, NULL, 231892),
(251528, '3utmA02', NULL, NULL, 131, NULL, NULL, 231892),
(251529, '5op3A00', NULL, NULL, 168, NULL, NULL, 231892),
(251530, '5aq7A01', NULL, NULL, 153, NULL, NULL, 231892),
(251531, '6d66B00', NULL, NULL, 136, NULL, NULL, 231892),
(251532, '5aqbA01', NULL, NULL, 115, NULL, NULL, 231892),
(251533, '2qyjA00', NULL, NULL, 166, NULL, NULL, 231892),
(251534, '4atzD00', NULL, NULL, 154, NULL, NULL, 231892),
(251535, '5lw2A00', NULL, NULL, 169, NULL, NULL, 231892),
(251536, '6iybB00', NULL, NULL, 154, NULL, NULL, 231892),
(251537, '5enqD00', NULL, NULL, 169, NULL, NULL, 231892),
(251538, '3c5rA00', NULL, NULL, 137, NULL, NULL, 231892),
(251539, '4uucA00', NULL, NULL, 226, NULL, NULL, 231892),
(251540, '1bd8A00', NULL, NULL, 156, NULL, NULL, 231892),
(251541, '5mlaB00', NULL, NULL, 142, NULL, NULL, 231892),
(251542, '2dznA00', NULL, NULL, 228, NULL, NULL, 231892),
(251543, '3hg0D00', NULL, NULL, 136, NULL, NULL, 231892),
(251544, '5eypF00', NULL, NULL, 142, NULL, NULL, 231892),
(251545, '1uohA00', NULL, NULL, 226, NULL, NULL, 231892),
(251546, '2etbA00', NULL, NULL, 256, NULL, NULL, 231892),
(251547, '4jb8P00', NULL, NULL, 171, NULL, NULL, 231892),
(251548, '4dx1B00', NULL, NULL, 259, NULL, NULL, 231892),
(251549, '5oouA00', NULL, NULL, 168, NULL, NULL, 231892),
(251550, '3lvqE03', NULL, NULL, 59, NULL, NULL, 231892);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(251551, '1ympA00', NULL, NULL, 135, NULL, NULL, 231892),
(251552, '5uqeC03', NULL, NULL, 87, NULL, NULL, 231892),
(251553, '2rfaA00', NULL, NULL, 232, NULL, NULL, 231892),
(251554, '4k5cB00', NULL, NULL, 183, NULL, NULL, 231892),
(251555, '6h46B00', NULL, NULL, 156, NULL, NULL, 231892),
(251556, '1oy3D00', NULL, NULL, 220, NULL, NULL, 231892),
(251557, '3w9fC00', NULL, NULL, 260, NULL, NULL, 231892),
(251558, '5d66A00', NULL, NULL, 198, NULL, NULL, 231892),
(251559, '4n5qA00', NULL, NULL, 257, NULL, NULL, 231892),
(251560, '3d9hA00', NULL, NULL, 244, NULL, NULL, 231892),
(251561, '5an8A01', NULL, NULL, 298, NULL, NULL, 231892),
(251562, '2qc9A00', NULL, NULL, 193, NULL, NULL, 231892),
(251563, '3t8kB00', NULL, NULL, 186, NULL, NULL, 231892),
(251564, '2xzdH00', NULL, NULL, 136, NULL, NULL, 231892),
(251565, '2f8yB00', NULL, NULL, 223, NULL, NULL, 231892),
(251566, '5mbmC00', NULL, NULL, 171, NULL, NULL, 231892),
(251567, '2xehA00', NULL, NULL, 157, NULL, NULL, 231892),
(251568, '4hrmB00', NULL, NULL, 152, NULL, NULL, 231892),
(251569, '2f37A00', NULL, NULL, 251, NULL, NULL, 231892),
(251570, '3j5pA01', NULL, NULL, 305, NULL, NULL, 231892),
(251571, '5eidA00', NULL, NULL, 123, NULL, NULL, 231892),
(251572, '5ma6B00', NULL, NULL, 161, NULL, NULL, 231892),
(251573, '4k5bA00', NULL, NULL, 169, NULL, NULL, 231892),
(251574, '4o60B00', NULL, NULL, 234, NULL, NULL, 231892),
(251575, '6ne2B00', NULL, NULL, 200, NULL, NULL, 231892),
(251576, '4gmrA00', NULL, NULL, 169, NULL, NULL, 231892),
(251577, '2pnnA00', NULL, NULL, 273, NULL, NULL, 231892),
(251578, '5ybuA00', NULL, NULL, 253, NULL, NULL, 231892),
(251579, '5yayA00', NULL, NULL, 257, NULL, NULL, 231892),
(251580, '1svxA00', NULL, NULL, 169, NULL, NULL, 231892),
(251581, '6gvmD00', NULL, NULL, 169, NULL, NULL, 231892),
(251582, '1ot8C00', NULL, NULL, 193, NULL, NULL, 231892),
(251583, '4lszF00', NULL, NULL, 169, NULL, NULL, 231892),
(251584, '2ajaA00', NULL, NULL, 349, NULL, NULL, 231892),
(251585, '1n0rA00', NULL, NULL, 126, NULL, NULL, 231892),
(251586, '3v30A00', NULL, NULL, 172, NULL, NULL, 231892),
(251587, '5kbaB00', NULL, NULL, 169, NULL, NULL, 231892),
(251588, '3b7bB00', NULL, NULL, 237, NULL, NULL, 231892),
(251589, '4hrlA00', NULL, NULL, 171, NULL, NULL, 231892),
(251590, '3nocD00', NULL, NULL, 169, NULL, NULL, 231892),
(251591, '5aq8A01', NULL, NULL, 161, NULL, NULL, 231892),
(251592, '4cymD00', NULL, NULL, 175, NULL, NULL, 231892),
(251593, '2b0oE02', NULL, NULL, 155, NULL, NULL, 231892),
(251594, '2bkgA00', NULL, NULL, 166, NULL, NULL, 231892),
(251595, '4gpmA00', NULL, NULL, 169, NULL, NULL, 231892),
(251596, '2y1lE00', NULL, NULL, 169, NULL, NULL, 231892),
(251597, '3q9nD00', NULL, NULL, 158, NULL, NULL, 231892),
(251598, '5gp7A00', NULL, NULL, 169, NULL, NULL, 231892),
(251599, '1d9sA00', NULL, NULL, 136, NULL, NULL, 231892),
(251600, '1iknD00', NULL, NULL, 236, NULL, NULL, 231892),
(251601, '4qfvA01', NULL, NULL, 165, NULL, NULL, 231892),
(251602, '3ajiA00', NULL, NULL, 231, NULL, NULL, 231892),
(251603, '1td6A02', NULL, NULL, 92, NULL, NULL, 231893),
(251604, '1wijA00', NULL, NULL, 140, NULL, NULL, 231894),
(251605, '4zdsB00', NULL, NULL, 134, NULL, NULL, 231894),
(251606, '5aa5A02', NULL, NULL, 79, NULL, NULL, 231895),
(251607, '5jskA02', NULL, NULL, 81, NULL, NULL, 231895),
(251608, '6gamS02', NULL, NULL, 90, NULL, NULL, 231895),
(251609, '6g94Q02', NULL, NULL, 111, NULL, NULL, 231895),
(251610, '4c3oF02', NULL, NULL, 98, NULL, NULL, 231895),
(251611, '3myrA02', NULL, NULL, 90, NULL, NULL, 231895),
(251612, '1yq9A02', NULL, NULL, 85, NULL, NULL, 231895),
(251613, '5a4mS02', NULL, NULL, 97, NULL, NULL, 231895),
(251614, '4kn9S02', NULL, NULL, 81, NULL, NULL, 231895),
(251615, '4uqlA02', NULL, NULL, 85, NULL, NULL, 231895),
(251616, '1e3dA02', NULL, NULL, 85, NULL, NULL, 231895),
(251617, '6fpoS02', NULL, NULL, 86, NULL, NULL, 231895),
(251618, '4u9hS02', NULL, NULL, 85, NULL, NULL, 231895),
(251619, '5d51S02', NULL, NULL, 87, NULL, NULL, 231895),
(251620, '3ayxD02', NULL, NULL, 93, NULL, NULL, 231895),
(251621, '5vqfB01', NULL, NULL, 35, NULL, NULL, 231896);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(251622, '1whsB01', NULL, NULL, 40, NULL, NULL, 231897),
(251623, '1gxsB01', NULL, NULL, 40, NULL, NULL, 231897),
(251624, '2nnuA02', NULL, NULL, 100, NULL, NULL, 231898),
(251625, '1tueG02', NULL, NULL, 94, NULL, NULL, 231898),
(251626, '1qqhA00', NULL, NULL, 144, NULL, NULL, 231898),
(251627, '2jexA02', NULL, NULL, 111, NULL, NULL, 231898),
(251628, '1r6nA02', NULL, NULL, 107, NULL, NULL, 231898),
(251629, '2fmlA01', NULL, NULL, 35, NULL, NULL, 231899),
(251630, '1umyA00', NULL, NULL, 407, NULL, NULL, 231900),
(251631, '4cczA01', NULL, NULL, 341, NULL, NULL, 231900),
(251632, '5dmmA00', NULL, NULL, 310, NULL, NULL, 231900),
(251633, '1q7zA01', NULL, NULL, 300, NULL, NULL, 231900),
(251634, '1lt7B00', NULL, NULL, 371, NULL, NULL, 231900),
(251635, '4jejA00', NULL, NULL, 244, NULL, NULL, 231901),
(251636, '3vk5B00', NULL, NULL, 265, NULL, NULL, 231901),
(251637, '3w01A00', NULL, NULL, 235, NULL, NULL, 231901),
(251638, '6nkeA00', NULL, NULL, 252, NULL, NULL, 231901),
(251639, '3vzxB00', NULL, NULL, 228, NULL, NULL, 231901),
(251640, '2f6uA00', NULL, NULL, 234, NULL, NULL, 231901),
(251641, '4nafA00', NULL, NULL, 226, NULL, NULL, 231901),
(251642, '5ndyD00', NULL, NULL, 256, NULL, NULL, 231901),
(251643, '6jo3A00', NULL, NULL, 253, NULL, NULL, 231901),
(251644, '2mkgA00', NULL, NULL, 63, NULL, NULL, 231902),
(251645, '2clyA00', NULL, NULL, 105, NULL, NULL, 231903),
(251646, '2wssT00', NULL, NULL, 93, NULL, NULL, 231903),
(251647, '3j81j03', NULL, NULL, 84, NULL, NULL, 231904),
(251648, '1yz7A02', NULL, NULL, 90, NULL, NULL, 231904),
(251649, '2qn6B00', NULL, NULL, 93, NULL, NULL, 231904),
(251650, '1q8kA03', NULL, NULL, 124, NULL, NULL, 231904),
(251651, '3tutA01', NULL, NULL, 240, NULL, NULL, 231905),
(251652, '4clqA01', NULL, NULL, 270, NULL, NULL, 231905),
(251653, '3pqvC01', NULL, NULL, 269, NULL, NULL, 231905),
(251654, '4o89A01', NULL, NULL, 239, NULL, NULL, 231905),
(251655, '4a17H02', NULL, NULL, 41, NULL, NULL, 231906),
(251656, '1vwxI02', NULL, NULL, 40, NULL, NULL, 231906),
(251657, '3u5eI02', NULL, NULL, 47, NULL, NULL, 231906),
(251658, '5an9F02', NULL, NULL, 43, NULL, NULL, 231906),
(251659, '1vx7Q02', NULL, NULL, 45, NULL, NULL, 231906),
(251660, '1kptA00', NULL, NULL, 105, NULL, NULL, 231907),
(251661, '2vobB03', NULL, NULL, 82, NULL, NULL, 231908),
(251662, '2an1C02', NULL, NULL, 137, NULL, NULL, 231909),
(251663, '2q5fA02', NULL, NULL, 139, NULL, NULL, 231909),
(251664, '4haoA02', NULL, NULL, 137, NULL, NULL, 231909),
(251665, '1u0tA02', NULL, NULL, 137, NULL, NULL, 231909),
(251666, '3afoB02', NULL, NULL, 171, NULL, NULL, 231909),
(251667, '3pfnC02', NULL, NULL, 164, NULL, NULL, 231909),
(251668, '1yt5A02', NULL, NULL, 126, NULL, NULL, 231909),
(251669, '1z0sA02', NULL, NULL, 125, NULL, NULL, 231909),
(251670, '1pprM02', NULL, NULL, 157, NULL, NULL, 231910),
(251671, '3iisM00', NULL, NULL, 151, NULL, NULL, 231910),
(251672, '1vrbA02', NULL, NULL, 87, NULL, NULL, 231911),
(251673, '5xluA02', NULL, NULL, 128, NULL, NULL, 231912),
(251674, '4gdxA02', NULL, NULL, 111, NULL, NULL, 231912),
(251675, '2z8iA02', NULL, NULL, 114, NULL, NULL, 231912),
(251676, '2qmcC02', NULL, NULL, 114, NULL, NULL, 231912),
(251677, '3whrA02', NULL, NULL, 128, NULL, NULL, 231912),
(251678, '5zjgA02', NULL, NULL, 112, NULL, NULL, 231912),
(251679, '2joiA00', NULL, NULL, 96, NULL, NULL, 231913),
(251680, '2kkwA01', NULL, NULL, 105, NULL, NULL, 231914),
(251681, '1xq8A00', NULL, NULL, 140, NULL, NULL, 231914),
(251682, '4ildA03', NULL, NULL, 98, NULL, NULL, 231915),
(251683, '6o39C00', NULL, NULL, 123, NULL, NULL, 231916),
(251684, '3hklA00', NULL, NULL, 141, NULL, NULL, 231916),
(251685, '6ahyE00', NULL, NULL, 118, NULL, NULL, 231916),
(251686, '2mahA00', NULL, NULL, 128, NULL, NULL, 231916),
(251687, '5un5A00', NULL, NULL, 129, NULL, NULL, 231916),
(251688, '6ahyC00', NULL, NULL, 125, NULL, NULL, 231916),
(251689, '4c7aA00', NULL, NULL, 131, NULL, NULL, 231916),
(251690, '1ijyA00', NULL, NULL, 130, NULL, NULL, 231916),
(251691, '6c0bB00', NULL, NULL, 122, NULL, NULL, 231916),
(251692, '5cl1D00', NULL, NULL, 131, NULL, NULL, 231916);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(251693, '5t44A00', NULL, NULL, 131, NULL, NULL, 231916),
(251694, '1ijxD00', NULL, NULL, 127, NULL, NULL, 231916),
(251695, '5l7dA01', NULL, NULL, 135, NULL, NULL, 231916),
(251696, '6o3bH00', NULL, NULL, 124, NULL, NULL, 231916),
(251697, '5kzzA00', NULL, NULL, 127, NULL, NULL, 231916),
(251698, '4f0aA00', NULL, NULL, 132, NULL, NULL, 231916),
(251699, '5bpbA00', NULL, NULL, 124, NULL, NULL, 231916),
(251700, '1ik7A00', NULL, NULL, 52, NULL, NULL, 231917),
(251701, '2w00A05', NULL, NULL, 112, NULL, NULL, 231918),
(251702, '5jxdA00', NULL, NULL, 198, NULL, NULL, 231919),
(251703, '4q9vA00', NULL, NULL, 186, NULL, NULL, 231919),
(251704, '3f4mA00', NULL, NULL, 161, NULL, NULL, 231919),
(251705, '4a3pA01', NULL, NULL, 126, NULL, NULL, 231920),
(251706, '4memA01', NULL, NULL, 127, NULL, NULL, 231920),
(251707, '4melA01', NULL, NULL, 120, NULL, NULL, 231920),
(251708, '3pv1A01', NULL, NULL, 123, NULL, NULL, 231920),
(251709, '5ctrC01', NULL, NULL, 139, NULL, NULL, 231920),
(251710, '3jyuB01', NULL, NULL, 138, NULL, NULL, 231920),
(251711, '2e28A04', NULL, NULL, 112, NULL, NULL, 231921),
(251712, '2hwgA01', NULL, NULL, 99, NULL, NULL, 231921),
(251713, '3t05A04', NULL, NULL, 112, NULL, NULL, 231921),
(251714, '5jvjA05', NULL, NULL, 125, NULL, NULL, 231921),
(251715, '2hroA01', NULL, NULL, 101, NULL, NULL, 231921),
(251716, '2olsA03', NULL, NULL, 106, NULL, NULL, 231921),
(251717, '1vbhA05', NULL, NULL, 125, NULL, NULL, 231921),
(251718, '5woyA01', NULL, NULL, 120, NULL, NULL, 231921),
(251719, '1zymA01', NULL, NULL, 132, NULL, NULL, 231921),
(251720, '2x0sA05', NULL, NULL, 121, NULL, NULL, 231921),
(251721, '1kblA03', NULL, NULL, 125, NULL, NULL, 231921),
(251722, '2hi6A00', NULL, NULL, 141, NULL, NULL, 231921),
(251723, '1g6eA00', NULL, NULL, 87, NULL, NULL, 231922),
(251724, '1c01A00', NULL, NULL, 76, NULL, NULL, 231922),
(251725, '1bhuA00', NULL, NULL, 102, NULL, NULL, 231922),
(251726, '1f53A00', NULL, NULL, 84, NULL, NULL, 231922),
(251727, '3i9v102', NULL, NULL, 179, NULL, NULL, 231923),
(251728, '6g2jF02', NULL, NULL, 180, NULL, NULL, 231923),
(251729, '2jvuA00', NULL, NULL, 104, NULL, NULL, 231924),
(251730, '4ksfA01', NULL, NULL, 133, NULL, NULL, 231925),
(251731, '4ksaC02', NULL, NULL, 143, NULL, NULL, 231925),
(251732, '2ygwA01', NULL, NULL, 161, NULL, NULL, 231925),
(251733, '4ks9A01', NULL, NULL, 136, NULL, NULL, 231925),
(251734, '2gscC00', NULL, NULL, 128, NULL, NULL, 231926),
(251735, '2rldB00', NULL, NULL, 121, NULL, NULL, 231926),
(251736, '4dwlB00', NULL, NULL, 114, NULL, NULL, 231926),
(251737, '1rkuA02', NULL, NULL, 95, NULL, NULL, 231927),
(251738, '3sqnA03', NULL, NULL, 126, NULL, NULL, 231928),
(251739, '2x43S00', NULL, NULL, 67, NULL, NULL, 231929),
(251740, '3krmA00', NULL, NULL, 163, NULL, NULL, 231930),
(251741, '3n89A02', NULL, NULL, 153, NULL, NULL, 231930),
(251742, '3wwjA02', NULL, NULL, 176, NULL, NULL, 231931),
(251743, '5cm0A02', NULL, NULL, 156, NULL, NULL, 231931),
(251744, '4dqnA02', NULL, NULL, 182, NULL, NULL, 231931),
(251745, '6nstA02', NULL, NULL, 163, NULL, NULL, 231931),
(251746, '3wwhA02', NULL, NULL, 176, NULL, NULL, 231931),
(251747, '4jxuB02', NULL, NULL, 157, NULL, NULL, 231931),
(251748, '1iyeA02', NULL, NULL, 160, NULL, NULL, 231931),
(251749, '5k3wB02', NULL, NULL, 174, NULL, NULL, 231931),
(251750, '4chiA02', NULL, NULL, 187, NULL, NULL, 231931),
(251751, '2eiyB02', NULL, NULL, 164, NULL, NULL, 231931),
(251752, '4pbcA02', NULL, NULL, 142, NULL, NULL, 231931),
(251753, '4tm5A02', NULL, NULL, 166, NULL, NULL, 231931),
(251754, '3qqmA02', NULL, NULL, 133, NULL, NULL, 231931),
(251755, '4tviA02', NULL, NULL, 154, NULL, NULL, 231931),
(251756, '3cswA02', NULL, NULL, 169, NULL, NULL, 231931),
(251757, '3u0gF02', NULL, NULL, 167, NULL, NULL, 231931),
(251758, '3lulB02', NULL, NULL, 157, NULL, NULL, 231931),
(251759, '4ce5A02', NULL, NULL, 187, NULL, NULL, 231931),
(251760, '4cmfA02', NULL, NULL, 177, NULL, NULL, 231931),
(251761, '2y4rA02', NULL, NULL, 160, NULL, NULL, 231931),
(251762, '3snoA02', NULL, NULL, 130, NULL, NULL, 231931),
(251763, '2zgiD02', NULL, NULL, 146, NULL, NULL, 231931);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(251764, '5ce8A02', NULL, NULL, 161, NULL, NULL, 231931),
(251765, '1i2kA02', NULL, NULL, 145, NULL, NULL, 231931),
(251766, '3uzoA02', NULL, NULL, 180, NULL, NULL, 231931),
(251767, '6h65A02', NULL, NULL, 165, NULL, NULL, 231931),
(251768, '5mr0A02', NULL, NULL, 156, NULL, NULL, 231931),
(251769, '3dtgA02', NULL, NULL, 173, NULL, NULL, 231931),
(251770, '5cr5A02', NULL, NULL, 175, NULL, NULL, 231931),
(251771, '6bb9A02', NULL, NULL, 158, NULL, NULL, 231931),
(251772, '2coiA02', NULL, NULL, 180, NULL, NULL, 231931),
(251773, '4k6nA02', NULL, NULL, 153, NULL, NULL, 231931),
(251774, '6fteB02', NULL, NULL, 190, NULL, NULL, 231931),
(251775, '6q8eA02', NULL, NULL, 165, NULL, NULL, 231931),
(251776, '3cebA02', NULL, NULL, 109, NULL, NULL, 231931),
(251777, '3lqsA02', NULL, NULL, 162, NULL, NULL, 231931),
(251778, '5u3fA02', NULL, NULL, 187, NULL, NULL, 231931),
(251779, '2q07A02', NULL, NULL, 65, NULL, NULL, 231932),
(251780, '1iq8A03', NULL, NULL, 74, NULL, NULL, 231932),
(251781, '5b66O01', NULL, NULL, 187, NULL, NULL, 231933),
(251782, '5g38A00', NULL, NULL, 172, NULL, NULL, 231933),
(251783, '5xnlo01', NULL, NULL, 176, NULL, NULL, 231933),
(251784, '3jcuO01', NULL, NULL, 177, NULL, NULL, 231933),
(251785, '5b66B02', NULL, NULL, 173, NULL, NULL, 231934),
(251786, '5xnlB02', NULL, NULL, 173, NULL, NULL, 231934),
(251787, '4bgpA02', NULL, NULL, 104, NULL, NULL, 231935),
(251788, '4jngA02', NULL, NULL, 103, NULL, NULL, 231935),
(251789, '3zlaA02', NULL, NULL, 103, NULL, NULL, 231935),
(251790, '4j1jA02', NULL, NULL, 103, NULL, NULL, 231935),
(251791, '2ogfA00', NULL, NULL, 122, NULL, NULL, 231936),
(251792, '2i52B00', NULL, NULL, 121, NULL, NULL, 231936),
(251793, '2iecD00', NULL, NULL, 131, NULL, NULL, 231936),
(251794, '3ic3A01', NULL, NULL, 64, NULL, NULL, 231937),
(251795, '1fd6A00', NULL, NULL, 57, NULL, NULL, 231938),
(251796, '4kgsA00', NULL, NULL, 57, NULL, NULL, 231938),
(251797, '1fclA00', NULL, NULL, 56, NULL, NULL, 231938),
(251798, '1em7A00', NULL, NULL, 56, NULL, NULL, 231938),
(251799, '2zw0A00', NULL, NULL, 57, NULL, NULL, 231938),
(251800, '5uceA00', NULL, NULL, 56, NULL, NULL, 231938),
(251801, '4ozaA00', NULL, NULL, 57, NULL, NULL, 231938),
(251802, '1ibxB00', NULL, NULL, 89, NULL, NULL, 231938),
(251803, '6nl7A00', NULL, NULL, 56, NULL, NULL, 231938),
(251804, '1vx7U01', NULL, NULL, 78, NULL, NULL, 231938),
(251805, '6nlaA00', NULL, NULL, 56, NULL, NULL, 231938),
(251806, '1vx7U02', NULL, NULL, 76, NULL, NULL, 231938),
(251807, '4ikgA00', NULL, NULL, 81, NULL, NULL, 231938),
(251808, '1mhxA00', NULL, NULL, 65, NULL, NULL, 231938),
(251809, '2pw9D02', NULL, NULL, 79, NULL, NULL, 231938),
(251810, '4kgrD00', NULL, NULL, 57, NULL, NULL, 231938),
(251811, '1xf5M00', NULL, NULL, 80, NULL, NULL, 231938),
(251812, '4kgrB00', NULL, NULL, 57, NULL, NULL, 231938),
(251813, '5ofsA00', NULL, NULL, 56, NULL, NULL, 231938),
(251814, '4kgrH00', NULL, NULL, 57, NULL, NULL, 231938),
(251815, '3mp9A00', NULL, NULL, 64, NULL, NULL, 231938),
(251816, '1ymhE00', NULL, NULL, 65, NULL, NULL, 231938),
(251817, '4kgrF00', NULL, NULL, 57, NULL, NULL, 231938),
(251818, '5hg2B00', NULL, NULL, 57, NULL, NULL, 231938),
(251819, '5hg2D00', NULL, NULL, 57, NULL, NULL, 231938),
(251820, '4d2kB00', NULL, NULL, 87, NULL, NULL, 231938),
(251821, '4kgtA00', NULL, NULL, 55, NULL, NULL, 231938),
(251822, '2jxtA01', NULL, NULL, 76, NULL, NULL, 231938),
(251823, '5hi1A00', NULL, NULL, 57, NULL, NULL, 231938),
(251824, '5hi1C00', NULL, NULL, 57, NULL, NULL, 231938),
(251825, '5hi1E00', NULL, NULL, 57, NULL, NULL, 231938),
(251826, '5hfyA00', NULL, NULL, 57, NULL, NULL, 231938),
(251827, '5u6aE00', NULL, NULL, 63, NULL, NULL, 231938),
(251828, '5hi1G00', NULL, NULL, 57, NULL, NULL, 231938),
(251829, '4ozbB00', NULL, NULL, 57, NULL, NULL, 231938),
(251830, '6nl6A00', NULL, NULL, 56, NULL, NULL, 231938),
(251831, '1igdA00', NULL, NULL, 61, NULL, NULL, 231938),
(251832, '2qsdA01', NULL, NULL, 80, NULL, NULL, 231938),
(251833, '2kdmA00', NULL, NULL, 56, NULL, NULL, 231938),
(251834, '1f2rI00', NULL, NULL, 100, NULL, NULL, 231938);
INSERT INTO "PUBLIC"."MODEL" VALUES
(251835, '1zxhA00', NULL, NULL, 56, NULL, NULL, 231938),
(251836, '4kgsB00', NULL, NULL, 57, NULL, NULL, 231938),
(251837, '3u4eG00', NULL, NULL, 124, NULL, NULL, 231938),
(251838, '3v3xA00', NULL, NULL, 56, NULL, NULL, 231938),
(251839, '4i4m600', NULL, NULL, 56, NULL, NULL, 231938),
(251840, '1ibxA00', NULL, NULL, 86, NULL, NULL, 231938),
(251841, '1gb4A00', NULL, NULL, 57, NULL, NULL, 231938),
(251842, '4ozcA00', NULL, NULL, 57, NULL, NULL, 231938),
(251843, '2on8A00', NULL, NULL, 56, NULL, NULL, 231938),
(251844, '1c9fA00', NULL, NULL, 90, NULL, NULL, 231938),
(251845, '4a18X02', NULL, NULL, 76, NULL, NULL, 231938),
(251846, '4a18X01', NULL, NULL, 80, NULL, NULL, 231938),
(251847, '1qkzA00', NULL, NULL, 64, NULL, NULL, 231938),
(251848, '1hz6A00', NULL, NULL, 72, NULL, NULL, 231938),
(251849, '2kacA00', NULL, NULL, 64, NULL, NULL, 231938),
(251850, '1mvkH00', NULL, NULL, 56, NULL, NULL, 231938),
(251851, '2zw1A00', NULL, NULL, 57, NULL, NULL, 231938),
(251852, '2jzpA00', NULL, NULL, 64, NULL, NULL, 231938),
(251853, '4kgrE00', NULL, NULL, 57, NULL, NULL, 231938),
(251854, '2pw9C02', NULL, NULL, 58, NULL, NULL, 231938),
(251855, '4kgrC00', NULL, NULL, 57, NULL, NULL, 231938),
(251856, '2rpvA00', NULL, NULL, 75, NULL, NULL, 231938),
(251857, '5ubsA00', NULL, NULL, 56, NULL, NULL, 231938),
(251858, '2qmtA00', NULL, NULL, 56, NULL, NULL, 231938),
(251859, '6em3S01', NULL, NULL, 69, NULL, NULL, 231938),
(251860, '4kgrG00', NULL, NULL, 57, NULL, NULL, 231938),
(251861, '1d4bA00', NULL, NULL, 122, NULL, NULL, 231938),
(251862, '2ptlA00', NULL, NULL, 78, NULL, NULL, 231938),
(251863, '5hg2C00', NULL, NULL, 57, NULL, NULL, 231938),
(251864, '6em3S02', NULL, NULL, 77, NULL, NULL, 231938),
(251865, '1pgxA00', NULL, NULL, 83, NULL, NULL, 231938),
(251866, '5xpcA00', NULL, NULL, 100, NULL, NULL, 231938),
(251867, '4kgrA00', NULL, NULL, 57, NULL, NULL, 231938),
(251868, '4kgtB00', NULL, NULL, 55, NULL, NULL, 231938),
(251869, '5hi1B00', NULL, NULL, 57, NULL, NULL, 231938),
(251870, '5hg2A00', NULL, NULL, 57, NULL, NULL, 231938),
(251871, '1kh0A00', NULL, NULL, 65, NULL, NULL, 231938),
(251872, '4glsC00', NULL, NULL, 56, NULL, NULL, 231938),
(251873, '5hi1D00', NULL, NULL, 57, NULL, NULL, 231938),
(251874, '3filB00', NULL, NULL, 56, NULL, NULL, 231938),
(251875, '5hi1F00', NULL, NULL, 57, NULL, NULL, 231938),
(251876, '5hfyB00', NULL, NULL, 57, NULL, NULL, 231938),
(251877, '4ozbA00', NULL, NULL, 57, NULL, NULL, 231938),
(251878, '1jmlA00', NULL, NULL, 72, NULL, NULL, 231938),
(251879, '5hi1H00', NULL, NULL, 57, NULL, NULL, 231938),
(251880, '1mi0B00', NULL, NULL, 65, NULL, NULL, 231938),
(251881, '4wh4A00', NULL, NULL, 56, NULL, NULL, 231938),
(251882, '2eelA00', NULL, NULL, 91, NULL, NULL, 231938),
(251883, '2jwuA00', NULL, NULL, 56, NULL, NULL, 231938),
(251884, '3u2sC00', NULL, NULL, 124, NULL, NULL, 231938),
(251885, '1vwxS02', NULL, NULL, 76, NULL, NULL, 231938),
(251886, '1vwxS01', NULL, NULL, 71, NULL, NULL, 231938),
(251887, '1k6kA00', NULL, NULL, 143, NULL, NULL, 231939),
(251888, '3zriA01', NULL, NULL, 155, NULL, NULL, 231939),
(251889, '1khyD00', NULL, NULL, 148, NULL, NULL, 231939),
(251890, '4uqwB00', NULL, NULL, 163, NULL, NULL, 231939),
(251891, '2y1qA00', NULL, NULL, 150, NULL, NULL, 231939),
(251892, '3wdcA00', NULL, NULL, 153, NULL, NULL, 231939),
(251893, '4hh5A00', NULL, NULL, 163, NULL, NULL, 231939),
(251894, '4p15A00', NULL, NULL, 146, NULL, NULL, 231939),
(251895, '3fesA00', NULL, NULL, 145, NULL, NULL, 231939),
(251896, '1qvrC01', NULL, NULL, 142, NULL, NULL, 231939),
(251897, '5guiA00', NULL, NULL, 153, NULL, NULL, 231939),
(251898, '3fh2A00', NULL, NULL, 146, NULL, NULL, 231939),
(251899, '4y0cB00', NULL, NULL, 157, NULL, NULL, 231939),
(251900, '4y0bA00', NULL, NULL, 144, NULL, NULL, 231939),
(251901, '4irfB00', NULL, NULL, 156, NULL, NULL, 231939),
(251902, '2qg8A00', NULL, NULL, 163, NULL, NULL, 231940),
(251903, '5xu7A00', NULL, NULL, 126, NULL, NULL, 231940),
(251904, '1qr0A01', NULL, NULL, 125, NULL, NULL, 231940),
(251905, '1qr0A02', NULL, NULL, 103, NULL, NULL, 231940);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(251906, '2cg5A01', NULL, NULL, 157, NULL, NULL, 231940),
(251907, '5cxdB01', NULL, NULL, 120, NULL, NULL, 231940),
(251908, '1fthA00', NULL, NULL, 122, NULL, NULL, 231940),
(251909, '3hykA00', NULL, NULL, 122, NULL, NULL, 231940),
(251910, '5suvC00', NULL, NULL, 126, NULL, NULL, 231940),
(251911, '2c43A01', NULL, NULL, 145, NULL, NULL, 231940),
(251912, '1f7lA00', NULL, NULL, 121, NULL, NULL, 231940),
(251913, '2c43A02', NULL, NULL, 125, NULL, NULL, 231940),
(251914, '3qmnS00', NULL, NULL, 129, NULL, NULL, 231940),
(251915, '4hc6A00', NULL, NULL, 129, NULL, NULL, 231940),
(251916, '2wdsA00', NULL, NULL, 123, NULL, NULL, 231940),
(251917, '3nfdD00', NULL, NULL, 153, NULL, NULL, 231940),
(251918, '3gwmA00', NULL, NULL, 129, NULL, NULL, 231940),
(251919, '5xukA00', NULL, NULL, 119, NULL, NULL, 231940),
(251920, '2wasB00', NULL, NULL, 122, NULL, NULL, 231940),
(251921, '3ieyB00', NULL, NULL, 153, NULL, NULL, 231941),
(251922, '3p1yA01', NULL, NULL, 138, NULL, NULL, 231941),
(251923, '3lzdA02', NULL, NULL, 109, NULL, NULL, 231942),
(251924, '4oazA00', NULL, NULL, 92, NULL, NULL, 231943),
(251925, '5tzdB00', NULL, NULL, 91, NULL, NULL, 231943),
(251926, '4m0nA01', NULL, NULL, 135, NULL, NULL, 231944),
(251927, '4m0hA01', NULL, NULL, 154, NULL, NULL, 231944),
(251928, '4pabA03', NULL, NULL, 188, NULL, NULL, 231945),
(251929, '5l46A03', NULL, NULL, 189, NULL, NULL, 231945),
(251930, '1x31A02', NULL, NULL, 392, NULL, NULL, 231945),
(251931, '1x31C01', NULL, NULL, 105, NULL, NULL, 231945),
(251932, '3tfiA00', NULL, NULL, 369, NULL, NULL, 231945),
(251933, '1xzpB00', NULL, NULL, 131, NULL, NULL, 231945),
(251934, '1pj5A03', NULL, NULL, 198, NULL, NULL, 231945),
(251935, '2gahA02', NULL, NULL, 392, NULL, NULL, 231945),
(251936, '1vloA01', NULL, NULL, 155, NULL, NULL, 231945),
(251937, '2gagC01', NULL, NULL, 115, NULL, NULL, 231945),
(251938, '3gehA01', NULL, NULL, 129, NULL, NULL, 231945),
(251939, '1wosA01', NULL, NULL, 147, NULL, NULL, 231945),
(251940, '3ttgA00', NULL, NULL, 355, NULL, NULL, 231945),
(251941, '3geeA01', NULL, NULL, 137, NULL, NULL, 231945),
(251942, '1v5vA01', NULL, NULL, 166, NULL, NULL, 231945),
(251943, '1wsrA01', NULL, NULL, 149, NULL, NULL, 231945),
(251944, '3girA01', NULL, NULL, 141, NULL, NULL, 231945),
(251945, '1yx2A01', NULL, NULL, 152, NULL, NULL, 231945),
(251946, '3f7wA03', NULL, NULL, 101, NULL, NULL, 231946),
(251947, '3hgtA00', NULL, NULL, 307, NULL, NULL, 231947),
(251948, '1ys5A01', NULL, NULL, 149, NULL, NULL, 231948),
(251949, '4o4uA02', NULL, NULL, 166, NULL, NULL, 231948),
(251950, '3pquA02', NULL, NULL, 177, NULL, NULL, 231948),
(251951, '4o4uC04', NULL, NULL, 148, NULL, NULL, 231948),
(251952, '4z3tA02', NULL, NULL, 123, NULL, NULL, 231948),
(251953, '3pqsA04', NULL, NULL, 145, NULL, NULL, 231948),
(251954, '5nqxA02', NULL, NULL, 136, NULL, NULL, 231948),
(251955, '2lfuA02', NULL, NULL, 129, NULL, NULL, 231948),
(251956, '3pqsA02', NULL, NULL, 160, NULL, NULL, 231948),
(251957, '5ee2A00', NULL, NULL, 159, NULL, NULL, 231948),
(251958, '5nqzA02', NULL, NULL, 136, NULL, NULL, 231948),
(251959, '3ve2A02', NULL, NULL, 207, NULL, NULL, 231948),
(251960, '3ve2A04', NULL, NULL, 156, NULL, NULL, 231948),
(251961, '4qq1B02', NULL, NULL, 183, NULL, NULL, 231948),
(251962, '3v8uA04', NULL, NULL, 154, NULL, NULL, 231948),
(251963, '3uaqB02', NULL, NULL, 173, NULL, NULL, 231948),
(251964, '4u9cA02', NULL, NULL, 173, NULL, NULL, 231948),
(251965, '3v8uA02', NULL, NULL, 208, NULL, NULL, 231948),
(251966, '5nqyA02', NULL, NULL, 137, NULL, NULL, 231948),
(251967, '4qq1C04', NULL, NULL, 147, NULL, NULL, 231948),
(251968, '2y7sA02', NULL, NULL, 123, NULL, NULL, 231948),
(251969, '2kdyA02', NULL, NULL, 116, NULL, NULL, 231948),
(251970, '3holA02', NULL, NULL, 166, NULL, NULL, 231948),
(251971, '4o3wA04', NULL, NULL, 145, NULL, NULL, 231948),
(251972, '3holA04', NULL, NULL, 145, NULL, NULL, 231948),
(251973, '5kkxA02', NULL, NULL, 147, NULL, NULL, 231948),
(251974, '4n3oB00', NULL, NULL, 342, NULL, NULL, 231949),
(251975, '3k85A00', NULL, NULL, 357, NULL, NULL, 231949),
(251976, '2liyA00', NULL, NULL, 45, NULL, NULL, 231950);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(251977, '5uquA02', NULL, NULL, 117, NULL, NULL, 231951),
(251978, '1iomA02', NULL, NULL, 102, NULL, NULL, 231951),
(251979, '4tvmA03', NULL, NULL, 112, NULL, NULL, 231951),
(251980, '1owbA03', NULL, NULL, 109, NULL, NULL, 231951),
(251981, '6abxA02', NULL, NULL, 102, NULL, NULL, 231951),
(251982, '1a59A02', NULL, NULL, 108, NULL, NULL, 231951),
(251983, '1vgmA02', NULL, NULL, 104, NULL, NULL, 231951),
(251984, '3tqgA02', NULL, NULL, 99, NULL, NULL, 231951),
(251985, '4xghA03', NULL, NULL, 111, NULL, NULL, 231951),
(251986, '1o7xA02', NULL, NULL, 104, NULL, NULL, 231951),
(251987, '4e6yA03', NULL, NULL, 111, NULL, NULL, 231951),
(251988, '4jadA03', NULL, NULL, 109, NULL, NULL, 231951),
(251989, '2ifcA02', NULL, NULL, 104, NULL, NULL, 231951),
(251990, '3msuB03', NULL, NULL, 110, NULL, NULL, 231951),
(251991, '1aj8A02', NULL, NULL, 98, NULL, NULL, 231951),
(251992, '1cscA02', NULL, NULL, 115, NULL, NULL, 231951),
(251993, '2ibpA02', NULL, NULL, 106, NULL, NULL, 231951),
(251994, '2c6xA02', NULL, NULL, 103, NULL, NULL, 231951),
(251995, '2p2wA02', NULL, NULL, 98, NULL, NULL, 231951),
(251996, '3hwkA02', NULL, NULL, 99, NULL, NULL, 231951),
(251997, '6abwA02', NULL, NULL, 104, NULL, NULL, 231951),
(251998, '2h12A03', NULL, NULL, 110, NULL, NULL, 231951),
(251999, '1vgpA02', NULL, NULL, 104, NULL, NULL, 231951),
(252000, '1cshA02', NULL, NULL, 115, NULL, NULL, 231951),
(252001, '3o8jA02', NULL, NULL, 99, NULL, NULL, 231951),
(252002, '5uqsA02', NULL, NULL, 115, NULL, NULL, 231951),
(252003, '1x3lA02', NULL, NULL, 245, NULL, NULL, 231952),
(252004, '2b8nA02', NULL, NULL, 227, NULL, NULL, 231952),
(252005, '2vldA01', NULL, NULL, 120, NULL, NULL, 231953),
(252006, '3bg2A03', NULL, NULL, 115, NULL, NULL, 231954),
(252007, '2pgsA03', NULL, NULL, 113, NULL, NULL, 231954),
(252008, '3aquA02', NULL, NULL, 67, NULL, NULL, 231955),
(252009, '6epbA02', NULL, NULL, 63, NULL, NULL, 231955),
(252010, '1kfwA02', NULL, NULL, 63, NULL, NULL, 231955),
(252011, '3oa5A01', NULL, NULL, 132, NULL, NULL, 231955),
(252012, '1vf8A02', NULL, NULL, 71, NULL, NULL, 231955),
(252013, '4s3kA03', NULL, NULL, 60, NULL, NULL, 231955),
(252014, '4mnkA02', NULL, NULL, 65, NULL, NULL, 231955),
(252015, '2pi6A02', NULL, NULL, 68, NULL, NULL, 231955),
(252016, '3arxA03', NULL, NULL, 86, NULL, NULL, 231955),
(252017, '4dwsC01', NULL, NULL, 125, NULL, NULL, 231955),
(252018, '5gqbA03', NULL, NULL, 76, NULL, NULL, 231955),
(252019, '3fy1A02', NULL, NULL, 71, NULL, NULL, 231955),
(252020, '3g6mA02', NULL, NULL, 63, NULL, NULL, 231955),
(252021, '5dezA03', NULL, NULL, 74, NULL, NULL, 231955),
(252022, '3bxwA03', NULL, NULL, 55, NULL, NULL, 231955),
(252023, '4nzcA02', NULL, NULL, 97, NULL, NULL, 231955),
(252024, '1w9pA02', NULL, NULL, 63, NULL, NULL, 231955),
(252025, '5jh8A02', NULL, NULL, 67, NULL, NULL, 231955),
(252026, '4wiwA02', NULL, NULL, 69, NULL, NULL, 231955),
(252027, '3w4rA02', NULL, NULL, 78, NULL, NULL, 231955),
(252028, '1edqA03', NULL, NULL, 76, NULL, NULL, 231955),
(252029, '4p8vA02', NULL, NULL, 69, NULL, NULL, 231955),
(252030, '1hjxA02', NULL, NULL, 70, NULL, NULL, 231955),
(252031, '4uriA02', NULL, NULL, 59, NULL, NULL, 231955),
(252032, '3cz8A02', NULL, NULL, 57, NULL, NULL, 231955),
(252033, '1xrvA02', NULL, NULL, 68, NULL, NULL, 231955),
(252034, '4s3jA03', NULL, NULL, 60, NULL, NULL, 231955),
(252035, '4wkaA02', NULL, NULL, 69, NULL, NULL, 231955),
(252036, '1goiA02', NULL, NULL, 90, NULL, NULL, 231955),
(252037, '2escA02', NULL, NULL, 68, NULL, NULL, 231955),
(252038, '4w5uA02', NULL, NULL, 61, NULL, NULL, 231955),
(252039, '1ll7A02', NULL, NULL, 63, NULL, NULL, 231955),
(252040, '3qokA02', NULL, NULL, 97, NULL, NULL, 231955),
(252041, '1jndA02', NULL, NULL, 94, NULL, NULL, 231955),
(252042, '4q7nA02', NULL, NULL, 68, NULL, NULL, 231955),
(252043, '3alfA02', NULL, NULL, 70, NULL, NULL, 231955),
(252044, '1itxA02', NULL, NULL, 73, NULL, NULL, 231955),
(252045, '2qkwA00', NULL, NULL, 101, NULL, NULL, 231956),
(252046, '2wmfA03', NULL, NULL, 126, NULL, NULL, 231957),
(252047, '4d6gA03', NULL, NULL, 142, NULL, NULL, 231957);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(252048, '1hn0A04', NULL, NULL, 122, NULL, NULL, 231957),
(252049, '1rwhA03', NULL, NULL, 114, NULL, NULL, 231957),
(252050, '1f1sA03', NULL, NULL, 82, NULL, NULL, 231957),
(252051, '1cb8A03', NULL, NULL, 110, NULL, NULL, 231957),
(252052, '2q1fA04', NULL, NULL, 152, NULL, NULL, 231957),
(252053, '2wcoA03', NULL, NULL, 115, NULL, NULL, 231957),
(252054, '1x1iA03', NULL, NULL, 118, NULL, NULL, 231957),
(252055, '1n7oA03', NULL, NULL, 85, NULL, NULL, 231957),
(252056, '1ufiD01', NULL, NULL, 42, NULL, NULL, 231958),
(252057, '1ufiC01', NULL, NULL, 58, NULL, NULL, 231958),
(252058, '1nepA00', NULL, NULL, 130, NULL, NULL, 231959),
(252059, '1xwvA00', NULL, NULL, 129, NULL, NULL, 231959),
(252060, '3b2dC00', NULL, NULL, 144, NULL, NULL, 231959),
(252061, '3vq2C00', NULL, NULL, 144, NULL, NULL, 231959),
(252062, '3m7oA00', NULL, NULL, 137, NULL, NULL, 231959),
(252063, '2e56A00', NULL, NULL, 144, NULL, NULL, 231959),
(252064, '1ktjA00', NULL, NULL, 129, NULL, NULL, 231959),
(252065, '3mtxA00', NULL, NULL, 151, NULL, NULL, 231959),
(252066, '3webA00', NULL, NULL, 132, NULL, NULL, 231959),
(252067, '5kwyC00', NULL, NULL, 133, NULL, NULL, 231959),
(252068, '3rg1P00', NULL, NULL, 147, NULL, NULL, 231959),
(252069, '4jzaA03', NULL, NULL, 154, NULL, NULL, 231960),
(252070, '1u5tA01', NULL, NULL, 67, NULL, NULL, 231961),
(252071, '3akjA01', NULL, NULL, 94, NULL, NULL, 231962),
(252072, '3cdjA02', NULL, NULL, 21, NULL, NULL, 231963),
(252073, '1or7C00', NULL, NULL, 66, NULL, NULL, 231964),
(252074, '2gqtA03', NULL, NULL, 77, NULL, NULL, 231965),
(252075, '3i99A03', NULL, NULL, 126, NULL, NULL, 231965),
(252076, '1uxyA01', NULL, NULL, 124, NULL, NULL, 231965),
(252077, '3tx1A03', NULL, NULL, 87, NULL, NULL, 231965),
(252078, '1hskA03', NULL, NULL, 97, NULL, NULL, 231965),
(252079, '4pytA03', NULL, NULL, 93, NULL, NULL, 231965),
(252080, '4jb1A03', NULL, NULL, 111, NULL, NULL, 231965),
(252081, '5jzxD03', NULL, NULL, 127, NULL, NULL, 231965),
(252082, '2wr8A02', NULL, NULL, 96, NULL, NULL, 231966),
(252083, '2f4nB02', NULL, NULL, 105, NULL, NULL, 231966),
(252084, '2zbvA02', NULL, NULL, 105, NULL, NULL, 231966),
(252085, '1rqpA02', NULL, NULL, 107, NULL, NULL, 231966),
(252086, '2cw5A02', NULL, NULL, 89, NULL, NULL, 231966),
(252087, '2q6kA02', NULL, NULL, 120, NULL, NULL, 231966),
(252088, '5b6iA02', NULL, NULL, 107, NULL, NULL, 231966),
(252089, '2c34A00', NULL, NULL, 116, NULL, NULL, 231967),
(252090, '2wgnB01', NULL, NULL, 97, NULL, NULL, 231967),
(252091, '3m86A00', NULL, NULL, 111, NULL, NULL, 231967),
(252092, '2nnrA00', NULL, NULL, 110, NULL, NULL, 231967),
(252093, '3pnrB00', NULL, NULL, 129, NULL, NULL, 231967),
(252094, '4zmhA02', NULL, NULL, 288, NULL, NULL, 231968),
(252095, '4c91A02', NULL, NULL, 290, NULL, NULL, 231968),
(252096, '5xtbC00', NULL, NULL, 156, NULL, NULL, 231969),
(252097, '3i9v600', NULL, NULL, 181, NULL, NULL, 231969),
(252098, '6cfwJ00', NULL, NULL, 167, NULL, NULL, 231969),
(252099, '6g2jB00', NULL, NULL, 155, NULL, NULL, 231969),
(252100, '3bamA00', NULL, NULL, 213, NULL, NULL, 231970),
(252101, '1sdoA00', NULL, NULL, 203, NULL, NULL, 231970),
(252102, '3odhA00', NULL, NULL, 194, NULL, NULL, 231970),
(252103, '1dfmB00', NULL, NULL, 223, NULL, NULL, 231970),
(252104, '2wn3A02', NULL, NULL, 99, NULL, NULL, 231971),
(252105, '3wmqA00', NULL, NULL, 94, NULL, NULL, 231971),
(252106, '2ccvA00', NULL, NULL, 101, NULL, NULL, 231971),
(252107, '2vm9A02', NULL, NULL, 98, NULL, NULL, 231971),
(252108, '4q56A00', NULL, NULL, 101, NULL, NULL, 231971),
(252109, '1z9bA01', NULL, NULL, 84, NULL, NULL, 231972),
(252110, '1g7sA03', NULL, NULL, 81, NULL, NULL, 231972),
(252111, '4n3sA03', NULL, NULL, 106, NULL, NULL, 231972),
(252112, '4kjzB04', NULL, NULL, 108, NULL, NULL, 231972),
(252113, '5fg3A03', NULL, NULL, 115, NULL, NULL, 231972),
(252114, '4nclB03', NULL, NULL, 106, NULL, NULL, 231972),
(252115, '3e4oA01', NULL, NULL, 64, NULL, NULL, 231973),
(252116, '2qyaA01', NULL, NULL, 110, NULL, NULL, 231974),
(252117, '5gl2B00', NULL, NULL, 269, NULL, NULL, 231975),
(252118, '1un8A02', NULL, NULL, 202, NULL, NULL, 231976);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(252119, '3pnlB00', NULL, NULL, 211, NULL, NULL, 231976),
(252120, '3cr3A00', NULL, NULL, 192, NULL, NULL, 231976),
(252121, '4esjA01', NULL, NULL, 167, NULL, NULL, 231977),
(252122, '2qvwB05', NULL, NULL, 83, NULL, NULL, 231978),
(252123, '1x9lA01', NULL, NULL, 117, NULL, NULL, 231979),
(252124, '2k6wA01', NULL, NULL, 114, NULL, NULL, 231979),
(252125, '3zjaA01', NULL, NULL, 106, NULL, NULL, 231979),
(252126, '4gfxA00', NULL, NULL, 151, NULL, NULL, 231980),
(252127, '5f0pB02', NULL, NULL, 144, NULL, NULL, 231980),
(252128, '2r51A01', NULL, NULL, 158, NULL, NULL, 231980),
(252129, '2r51A02', NULL, NULL, 142, NULL, NULL, 231980),
(252130, '4p2aA01', NULL, NULL, 156, NULL, NULL, 231980),
(252131, '2fauA01', NULL, NULL, 158, NULL, NULL, 231980),
(252132, '4geiA00', NULL, NULL, 150, NULL, NULL, 231980),
(252133, '4r7vA00', NULL, NULL, 173, NULL, NULL, 231980),
(252134, '4ll1C02', NULL, NULL, 146, NULL, NULL, 231980),
(252135, '6md5A01', NULL, NULL, 148, NULL, NULL, 231980),
(252136, '6md5A02', NULL, NULL, 143, NULL, NULL, 231980),
(252137, '3uguA02', NULL, NULL, 186, NULL, NULL, 231980),
(252138, '5f0jB02', NULL, NULL, 183, NULL, NULL, 231980),
(252139, '1g4mA02', NULL, NULL, 207, NULL, NULL, 231980),
(252140, '5tv1A02', NULL, NULL, 169, NULL, NULL, 231980),
(252141, '1sujA02', NULL, NULL, 179, NULL, NULL, 231980),
(252142, '2gefA01', NULL, NULL, 125, NULL, NULL, 231981),
(252143, '1rm6A03', NULL, NULL, 132, NULL, NULL, 231982),
(252144, '1rm6A01', NULL, NULL, 119, NULL, NULL, 231982),
(252145, '1rm6A05', NULL, NULL, 173, NULL, NULL, 231982),
(252146, '3an1B08', NULL, NULL, 157, NULL, NULL, 231982),
(252147, '3hrdB01', NULL, NULL, 164, NULL, NULL, 231982),
(252148, '3hrdB02', NULL, NULL, 149, NULL, NULL, 231982),
(252149, '2e1qC10', NULL, NULL, 128, NULL, NULL, 231982),
(252150, '1n62B05', NULL, NULL, 97, NULL, NULL, 231982),
(252151, '1n62B04', NULL, NULL, 254, NULL, NULL, 231982),
(252152, '1n62B03', NULL, NULL, 166, NULL, NULL, 231982),
(252153, '1n62B02', NULL, NULL, 145, NULL, NULL, 231982),
(252154, '2e1qC06', NULL, NULL, 286, NULL, NULL, 231982),
(252155, '2e3tB06', NULL, NULL, 227, NULL, NULL, 231982),
(252156, '3nvwC02', NULL, NULL, 170, NULL, NULL, 231982),
(252157, '3nvwC03', NULL, NULL, 96, NULL, NULL, 231982),
(252158, '3nvwC05', NULL, NULL, 140, NULL, NULL, 231982),
(252159, '3zyvB08', NULL, NULL, 159, NULL, NULL, 231982),
(252160, '2e1qC09', NULL, NULL, 96, NULL, NULL, 231982),
(252161, '2e1qC08', NULL, NULL, 170, NULL, NULL, 231982),
(252162, '1ffvB05', NULL, NULL, 97, NULL, NULL, 231982),
(252163, '1ffvB04', NULL, NULL, 198, NULL, NULL, 231982),
(252164, '2w3sB02', NULL, NULL, 177, NULL, NULL, 231982),
(252165, '1ffvB03', NULL, NULL, 166, NULL, NULL, 231982),
(252166, '4usaA06', NULL, NULL, 201, NULL, NULL, 231982),
(252167, '4usaA07', NULL, NULL, 126, NULL, NULL, 231982),
(252168, '4zohA05', NULL, NULL, 150, NULL, NULL, 231982),
(252169, '4zohA04', NULL, NULL, 172, NULL, NULL, 231982),
(252170, '4usaA04', NULL, NULL, 157, NULL, NULL, 231982),
(252171, '4zohA03', NULL, NULL, 93, NULL, NULL, 231982),
(252172, '4zohA02', NULL, NULL, 133, NULL, NULL, 231982),
(252173, '4usaA05', NULL, NULL, 93, NULL, NULL, 231982),
(252174, '1dgjA07', NULL, NULL, 200, NULL, NULL, 231982),
(252175, '1dgjA05', NULL, NULL, 94, NULL, NULL, 231982),
(252176, '1dgjA06', NULL, NULL, 125, NULL, NULL, 231982),
(252177, '2w3sB03', NULL, NULL, 94, NULL, NULL, 231982),
(252178, '1ffvB02', NULL, NULL, 145, NULL, NULL, 231982),
(252179, '1rm6D04', NULL, NULL, 237, NULL, NULL, 231982),
(252180, '2w3sB04', NULL, NULL, 207, NULL, NULL, 231982),
(252181, '2w3sB05', NULL, NULL, 159, NULL, NULL, 231982),
(252182, '3an1A09', NULL, NULL, 96, NULL, NULL, 231982),
(252183, '3hrdA02', NULL, NULL, 176, NULL, NULL, 231982),
(252184, '1dgjA04', NULL, NULL, 158, NULL, NULL, 231982),
(252185, '3an1A06', NULL, NULL, 285, NULL, NULL, 231982),
(252186, '1t3qB03', NULL, NULL, 97, NULL, NULL, 231982),
(252187, '1t3qB04', NULL, NULL, 196, NULL, NULL, 231982),
(252188, '3an1A10', NULL, NULL, 128, NULL, NULL, 231982),
(252189, '3zyvC06', NULL, NULL, 295, NULL, NULL, 231982); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(252190, '5g5gC03', NULL, NULL, 93, NULL, NULL, 231982),
(252191, '3zyvA09', NULL, NULL, 96, NULL, NULL, 231982),
(252192, '3unaB06', NULL, NULL, 300, NULL, NULL, 231982),
(252193, '3zyvA10', NULL, NULL, 128, NULL, NULL, 231982),
(252194, '3nvwL04', NULL, NULL, 227, NULL, NULL, 231982),
(252195, '3zuaA01', NULL, NULL, 131, NULL, NULL, 231983),
(252196, '1aecA00', NULL, NULL, 218, NULL, NULL, 231983),
(252197, '2pnsA00', NULL, NULL, 208, NULL, NULL, 231983),
(252198, '4q8gA00', NULL, NULL, 376, NULL, NULL, 231983),
(252199, '3pw3D00', NULL, NULL, 383, NULL, NULL, 231983),
(252200, '1pciA00', NULL, NULL, 322, NULL, NULL, 231983),
(252201, '2y6eE00', NULL, NULL, 367, NULL, NULL, 231983),
(252202, '1qxpA02', NULL, NULL, 144, NULL, NULL, 231983),
(252203, '3rvvA00', NULL, NULL, 223, NULL, NULL, 231983),
(252204, '5ef4B00', NULL, NULL, 328, NULL, NULL, 231983),
(252205, '6ffaA00', NULL, NULL, 167, NULL, NULL, 231983),
(252206, '6gh9B00', NULL, NULL, 346, NULL, NULL, 231983),
(252207, '1ppoA00', NULL, NULL, 216, NULL, NULL, 231983),
(252208, '4msxA02', NULL, NULL, 327, NULL, NULL, 231983),
(252209, '6czsA00', NULL, NULL, 312, NULL, NULL, 231983),
(252210, '3bcnA00', NULL, NULL, 209, NULL, NULL, 231983),
(252211, '4x6hA00', NULL, NULL, 215, NULL, NULL, 231983),
(252212, '5a24A00', NULL, NULL, 222, NULL, NULL, 231983),
(252213, '2vhfB00', NULL, NULL, 374, NULL, NULL, 231983),
(252214, '1o0eA00', NULL, NULL, 208, NULL, NULL, 231983),
(252215, '1iwdA00', NULL, NULL, 215, NULL, NULL, 231983),
(252216, '1pxvA00', NULL, NULL, 183, NULL, NULL, 231983),
(252217, '6bdtB02', NULL, NULL, 150, NULL, NULL, 231983),
(252218, '1m6dA00', NULL, NULL, 214, NULL, NULL, 231983),
(252219, '2vhsA00', NULL, NULL, 217, NULL, NULL, 231983),
(252220, '3ioqA00', NULL, NULL, 213, NULL, NULL, 231983),
(252221, '2dccA00', NULL, NULL, 256, NULL, NULL, 231983),
(252222, '1mirA00', NULL, NULL, 322, NULL, NULL, 231983),
(252223, '5ef4A00', NULL, NULL, 345, NULL, NULL, 231983),
(252224, '8pchA00', NULL, NULL, 220, NULL, NULL, 231983),
(252225, '2xu3A00', NULL, NULL, 220, NULL, NULL, 231983),
(252226, '2cb5A01', NULL, NULL, 401, NULL, NULL, 231983),
(252227, '3ervA00', NULL, NULL, 208, NULL, NULL, 231983),
(252228, '4yyqA00', NULL, NULL, 217, NULL, NULL, 231983),
(252229, '4yywA00', NULL, NULL, 220, NULL, NULL, 231983),
(252230, '3pdfA02', NULL, NULL, 235, NULL, NULL, 231983),
(252231, '5fpwA00', NULL, NULL, 321, NULL, NULL, 231983),
(252232, '1zcmA02', NULL, NULL, 134, NULL, NULL, 231983),
(252233, '3oisB00', NULL, NULL, 268, NULL, NULL, 231983),
(252234, '4bs6A00', NULL, NULL, 225, NULL, NULL, 231983),
(252235, '1kfuL02', NULL, NULL, 143, NULL, NULL, 231983),
(252236, '1gecE00', NULL, NULL, 216, NULL, NULL, 231983),
(252237, '2c0yA00', NULL, NULL, 315, NULL, NULL, 231983),
(252238, '4ry2A01', NULL, NULL, 155, NULL, NULL, 231983),
(252239, '1vjvA01', NULL, NULL, 317, NULL, NULL, 231983),
(252240, '1theA00', NULL, NULL, 260, NULL, NULL, 231983),
(252241, '3b79A00', NULL, NULL, 129, NULL, NULL, 231983),
(252242, '4k7cA01', NULL, NULL, 394, NULL, NULL, 231983),
(252243, '1jqpA02', NULL, NULL, 233, NULL, NULL, 231983),
(252244, '3wxfA00', NULL, NULL, 312, NULL, NULL, 231983),
(252245, '5cvmA00', NULL, NULL, 334, NULL, NULL, 231983),
(252246, '3u8eA00', NULL, NULL, 222, NULL, NULL, 231983),
(252247, '1yalA00', NULL, NULL, 218, NULL, NULL, 231983),
(252248, '1cqdA00', NULL, NULL, 221, NULL, NULL, 231983),
(252249, '6ml1A00', NULL, NULL, 349, NULL, NULL, 231983),
(252250, '2fo5A00', NULL, NULL, 226, NULL, NULL, 231983),
(252251, '5chtB00', NULL, NULL, 326, NULL, NULL, 231983),
(252252, '2b1mA00', NULL, NULL, 226, NULL, NULL, 231983),
(252253, '3qj3B00', NULL, NULL, 315, NULL, NULL, 231983),
(252254, '2cioA00', NULL, NULL, 212, NULL, NULL, 231983),
(252255, '2oulA00', NULL, NULL, 241, NULL, NULL, 231983),
(252256, '5k16A00', NULL, NULL, 355, NULL, NULL, 231983),
(252257, '4i07A00', NULL, NULL, 254, NULL, NULL, 231983),
(252258, '3hhiA00', NULL, NULL, 270, NULL, NULL, 231983),
(252259, '1df0A02', NULL, NULL, 114, NULL, NULL, 231983),
(252260, '3i06A00', NULL, NULL, 215, NULL, NULL, 231983);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(252261, '1x9yA02', NULL, NULL, 191, NULL, NULL, 231983),
(252262, '3k8uA01', NULL, NULL, 146, NULL, NULL, 231983),
(252263, '2wbfX00', NULL, NULL, 265, NULL, NULL, 231983),
(252264, '4qrvA00', NULL, NULL, 316, NULL, NULL, 231983),
(252265, '1mhwA00', NULL, NULL, 175, NULL, NULL, 231983),
(252266, '1cv8A00', NULL, NULL, 174, NULL, NULL, 231983),
(252267, '3p5uA00', NULL, NULL, 220, NULL, NULL, 231983),
(252268, '4g54A01', NULL, NULL, 125, NULL, NULL, 231983),
(252269, '1mdwB02', NULL, NULL, 137, NULL, NULL, 231983),
(252270, '3f75A00', NULL, NULL, 224, NULL, NULL, 231983),
(252271, '2p86A00', NULL, NULL, 215, NULL, NULL, 231983),
(252272, '3f5vA00', NULL, NULL, 222, NULL, NULL, 231983),
(252273, '2e01A01', NULL, NULL, 400, NULL, NULL, 231983),
(252274, '2r9fA02', NULL, NULL, 145, NULL, NULL, 231983),
(252275, '2actA00', NULL, NULL, 220, NULL, NULL, 231983),
(252276, '2gfoA00', NULL, NULL, 349, NULL, NULL, 231983),
(252277, '4oelA02', NULL, NULL, 156, NULL, NULL, 231983),
(252278, '3qt4A00', NULL, NULL, 310, NULL, NULL, 231983),
(252279, '1zivA02', NULL, NULL, 146, NULL, NULL, 231983),
(252280, '5z5oA00', NULL, NULL, 314, NULL, NULL, 231983),
(252281, '2bdzA00', NULL, NULL, 214, NULL, NULL, 231983),
(252282, '3bwkC00', NULL, NULL, 243, NULL, NULL, 231983),
(252283, '1cs8A00', NULL, NULL, 316, NULL, NULL, 231983),
(252284, '2f7dA00', NULL, NULL, 215, NULL, NULL, 231983),
(252285, '4yyuA00', NULL, NULL, 222, NULL, NULL, 231983),
(252286, '5mblA00', NULL, NULL, 256, NULL, NULL, 231983),
(252287, '3ihpA03', NULL, NULL, 357, NULL, NULL, 231983),
(252288, '1deuB00', NULL, NULL, 277, NULL, NULL, 231983),
(252289, '3i3tA00', NULL, NULL, 355, NULL, NULL, 231983),
(252290, '2nqaA02', NULL, NULL, 137, NULL, NULL, 231983),
(252291, '6okjA00', NULL, NULL, 215, NULL, NULL, 231983),
(252292, '2avwD01', NULL, NULL, 155, NULL, NULL, 231983),
(252293, '4fk5A02', NULL, NULL, 343, NULL, NULL, 231983),
(252294, '5t6uA00', NULL, NULL, 215, NULL, NULL, 231983),
(252295, '4i05A00', NULL, NULL, 285, NULL, NULL, 231983),
(252296, '6ay2B00', NULL, NULL, 255, NULL, NULL, 231983),
(252297, '1fh0A00', NULL, NULL, 221, NULL, NULL, 231983),
(252298, '5xveA00', NULL, NULL, 356, NULL, NULL, 231983),
(252299, '2o6xA00', NULL, NULL, 310, NULL, NULL, 231983),
(252300, '4czwA01', NULL, NULL, 404, NULL, NULL, 231983),
(252301, '1xkgA00', NULL, NULL, 312, NULL, NULL, 231983),
(252302, '6iikB00', NULL, NULL, 399, NULL, NULL, 231983),
(252303, '1s4vB00', NULL, NULL, 229, NULL, NULL, 231983),
(252304, '2h7jA00', NULL, NULL, 220, NULL, NULL, 231983),
(252305, '1x3zA01', NULL, NULL, 26, NULL, NULL, 231984),
(252306, '3u5cI02', NULL, NULL, 112, NULL, NULL, 231985),
(252307, '1vx2I02', NULL, NULL, 114, NULL, NULL, 231985),
(252308, '2xzm202', NULL, NULL, 121, NULL, NULL, 231985),
(252309, '3bpdB01', NULL, NULL, 88, NULL, NULL, 231986),
(252310, '2raqB01', NULL, NULL, 87, NULL, NULL, 231986),
(252311, '2x3dF01', NULL, NULL, 87, NULL, NULL, 231986),
(252312, '6hu9j00', NULL, NULL, 82, NULL, NULL, 231987),
(252313, '5z62H00', NULL, NULL, 82, NULL, NULL, 231987),
(252314, '5b1aH00', NULL, NULL, 85, NULL, NULL, 231987),
(252315, '4j4hA01', NULL, NULL, 135, NULL, NULL, 231988),
(252316, '2ehwA00', NULL, NULL, 120, NULL, NULL, 231989),
(252317, '3fvvA02', NULL, NULL, 75, NULL, NULL, 231990),
(252318, '2jmkA00', NULL, NULL, 111, NULL, NULL, 231991),
(252319, '5bn8A04', NULL, NULL, 83, NULL, NULL, 231992),
(252320, '2hf3A03', NULL, NULL, 92, NULL, NULL, 231992),
(252321, '4i6mA03', NULL, NULL, 141, NULL, NULL, 231992),
(252322, '5aqmA04', NULL, NULL, 84, NULL, NULL, 231992),
(252323, '4b1yB03', NULL, NULL, 89, NULL, NULL, 231992),
(252324, '1d4xA03', NULL, NULL, 92, NULL, NULL, 231992),
(252325, '6gfaA04', NULL, NULL, 85, NULL, NULL, 231992),
(252326, '4rtfD03', NULL, NULL, 89, NULL, NULL, 231992),
(252327, '6eofA03', NULL, NULL, 84, NULL, NULL, 231992),
(252328, '4cbuA03', NULL, NULL, 92, NULL, NULL, 231992),
(252329, '2v7yA03', NULL, NULL, 82, NULL, NULL, 231992),
(252330, '5i9eA03', NULL, NULL, 113, NULL, NULL, 231992),
(252331, '1c0gA03', NULL, NULL, 92, NULL, NULL, 231992);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(252332, '4am6A02', NULL, NULL, 155, NULL, NULL, 231992),
(252333, '4cbxA03', NULL, NULL, 93, NULL, NULL, 231992),
(252334, '3d2fA04', NULL, NULL, 84, NULL, NULL, 231992),
(252335, '4gniA04', NULL, NULL, 86, NULL, NULL, 231992),
(252336, '3gdqA04', NULL, NULL, 84, NULL, NULL, 231992),
(252337, '4fo0A03', NULL, NULL, 153, NULL, NULL, 231992),
(252338, '4jneA03', NULL, NULL, 88, NULL, NULL, 231992),
(252339, '4efhA03', NULL, NULL, 92, NULL, NULL, 231992),
(252340, '1jcfA03', NULL, NULL, 76, NULL, NULL, 231992),
(252341, '4a2aA04', NULL, NULL, 65, NULL, NULL, 231992),
(252342, '4czlA03', NULL, NULL, 76, NULL, NULL, 231992),
(252343, '3dwlA03', NULL, NULL, 94, NULL, NULL, 231992),
(252344, '3cipA03', NULL, NULL, 92, NULL, NULL, 231992),
(252345, '1yagA04', NULL, NULL, 86, NULL, NULL, 231992),
(252346, '3gl1A04', NULL, NULL, 84, NULL, NULL, 231992),
(252347, '2pbdA04', NULL, NULL, 89, NULL, NULL, 231992),
(252348, '5tkyA03', NULL, NULL, 84, NULL, NULL, 231992),
(252349, '4kboA04', NULL, NULL, 88, NULL, NULL, 231992),
(252350, '4pl7A03', NULL, NULL, 89, NULL, NULL, 231992),
(252351, '3fe1A04', NULL, NULL, 84, NULL, NULL, 231992),
(252352, '6f1uB03', NULL, NULL, 88, NULL, NULL, 231992),
(252353, '1k8kA04', NULL, NULL, 92, NULL, NULL, 231992),
(252354, '1k8kB02', NULL, NULL, 87, NULL, NULL, 231992),
(252355, '4ci6A03', NULL, NULL, 92, NULL, NULL, 231992),
(252356, '3qfuA04', NULL, NULL, 84, NULL, NULL, 231992),
(252357, '3kvgA04', NULL, NULL, 85, NULL, NULL, 231992),
(252358, '3i33A04', NULL, NULL, 84, NULL, NULL, 231992),
(252359, '3a5nC03', NULL, NULL, 92, NULL, NULL, 231992),
(252360, '4mveA00', NULL, NULL, 151, NULL, NULL, 231993),
(252361, '1qexA03', NULL, NULL, 114, NULL, NULL, 231994),
(252362, '3lfrB01', NULL, NULL, 69, NULL, NULL, 231995),
(252363, '3lfrA02', NULL, NULL, 67, NULL, NULL, 231995),
(252364, '3nqrA02', NULL, NULL, 66, NULL, NULL, 231995),
(252365, '3nqrB01', NULL, NULL, 61, NULL, NULL, 231995),
(252366, '3nqrB02', NULL, NULL, 66, NULL, NULL, 231995),
(252367, '3nqrC02', NULL, NULL, 66, NULL, NULL, 231995),
(252368, '3nqrD02', NULL, NULL, 66, NULL, NULL, 231995),
(252369, '3jtfB01', NULL, NULL, 66, NULL, NULL, 231995),
(252370, '3jtfA02', NULL, NULL, 62, NULL, NULL, 231995),
(252371, '3oi8A02', NULL, NULL, 65, NULL, NULL, 231995),
(252372, '2j9lF01', NULL, NULL, 93, NULL, NULL, 231995),
(252373, '5yz2A02', NULL, NULL, 66, NULL, NULL, 231995),
(252374, '5yz2A01', NULL, NULL, 78, NULL, NULL, 231995),
(252375, '1vr9A01', NULL, NULL, 77, NULL, NULL, 231995),
(252376, '3ghdA00', NULL, NULL, 70, NULL, NULL, 231995),
(252377, '4k15B00', NULL, NULL, 130, NULL, NULL, 231996),
(252378, '4c0eA02', NULL, NULL, 229, NULL, NULL, 231997),
(252379, '4by6D02', NULL, NULL, 230, NULL, NULL, 231997),
(252380, '2eqpA00', NULL, NULL, 50, NULL, NULL, 231998),
(252381, '2kn0A00', NULL, NULL, 50, NULL, NULL, 231998),
(252382, '1t95A02', NULL, NULL, 75, NULL, NULL, 231999),
(252383, '2wbmA02', NULL, NULL, 75, NULL, NULL, 231999),
(252384, '2kdoA02', NULL, NULL, 73, NULL, NULL, 231999),
(252385, '4h63Q01', NULL, NULL, 57, NULL, NULL, 232000),
(252386, '4qbuA01', NULL, NULL, 134, NULL, NULL, 232001),
(252387, '2jfkD01', NULL, NULL, 135, NULL, NULL, 232001),
(252388, '2hg4A02', NULL, NULL, 141, NULL, NULL, 232001),
(252389, '2vz9A02', NULL, NULL, 130, NULL, NULL, 232001),
(252390, '2vz8B02', NULL, NULL, 129, NULL, NULL, 232001),
(252391, '4oqjA02', NULL, NULL, 126, NULL, NULL, 232001),
(252392, '5elpD02', NULL, NULL, 154, NULL, NULL, 232001),
(252393, '4kc5D02', NULL, NULL, 127, NULL, NULL, 232001),
(252394, '2qo3A02', NULL, NULL, 136, NULL, NULL, 232001),
(252395, '2jfkC01', NULL, NULL, 99, NULL, NULL, 232001),
(252396, '3hhdA02', NULL, NULL, 104, NULL, NULL, 232001),
(252397, '2gl5A02', NULL, NULL, 268, NULL, NULL, 232002),
(252398, '4m0xA02', NULL, NULL, 235, NULL, NULL, 232002),
(252399, '3t6cA02', NULL, NULL, 270, NULL, NULL, 232002),
(252400, '3tj4A02', NULL, NULL, 237, NULL, NULL, 232002),
(252401, '3qkeD02', NULL, NULL, 263, NULL, NULL, 232002),
(252402, '3vc5A02', NULL, NULL, 243, NULL, NULL, 232002);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(252403, '1wueA02', NULL, NULL, 220, NULL, NULL, 232002),
(252404, '3dgbA02', NULL, NULL, 236, NULL, NULL, 232002),
(252405, '3i4kA02', NULL, NULL, 261, NULL, NULL, 232002),
(252406, '4hyrA02', NULL, NULL, 261, NULL, NULL, 232002),
(252407, '2pozA02', NULL, NULL, 256, NULL, NULL, 232002),
(252408, '4kemA02', NULL, NULL, 263, NULL, NULL, 232002),
(252409, '4ropA02', NULL, NULL, 299, NULL, NULL, 232002),
(252410, '4ip4A02', NULL, NULL, 296, NULL, NULL, 232002),
(252411, '2nqlA02', NULL, NULL, 220, NULL, NULL, 232002),
(252412, '2fymC02', NULL, NULL, 305, NULL, NULL, 232002),
(252413, '2qgyA02', NULL, NULL, 238, NULL, NULL, 232002),
(252414, '2qddA02', NULL, NULL, 238, NULL, NULL, 232002),
(252415, '3v5cB02', NULL, NULL, 263, NULL, NULL, 232002),
(252416, '2oz3E02', NULL, NULL, 242, NULL, NULL, 232002),
(252417, '2ovlA02', NULL, NULL, 233, NULL, NULL, 232002),
(252418, '3eezA02', NULL, NULL, 238, NULL, NULL, 232002),
(252419, '1kd0A02', NULL, NULL, 249, NULL, NULL, 232002),
(252420, '3v3wA02', NULL, NULL, 262, NULL, NULL, 232002),
(252421, '3ro6A02', NULL, NULL, 241, NULL, NULL, 232002),
(252422, '3cawA02', NULL, NULL, 225, NULL, NULL, 232002),
(252423, '3boxA02', NULL, NULL, 242, NULL, NULL, 232002),
(252424, '1rvkA02', NULL, NULL, 265, NULL, NULL, 232002),
(252425, '4jn7A02', NULL, NULL, 276, NULL, NULL, 232002),
(252426, '4e4fA02', NULL, NULL, 264, NULL, NULL, 232002),
(252427, '3vcnA02', NULL, NULL, 262, NULL, NULL, 232002),
(252428, '4hnlA02', NULL, NULL, 253, NULL, NULL, 232002),
(252429, '2podA02', NULL, NULL, 277, NULL, NULL, 232002),
(252430, '3t8qA02', NULL, NULL, 254, NULL, NULL, 232002),
(252431, '3sbfA02', NULL, NULL, 253, NULL, NULL, 232002),
(252432, '5wroA02', NULL, NULL, 306, NULL, NULL, 232002),
(252433, '1iyxA02', NULL, NULL, 304, NULL, NULL, 232002),
(252434, '3ugvA02', NULL, NULL, 236, NULL, NULL, 232002),
(252435, '3sszA02', NULL, NULL, 248, NULL, NULL, 232002),
(252436, '1sjdA02', NULL, NULL, 237, NULL, NULL, 232002),
(252437, '1nu5A02', NULL, NULL, 254, NULL, NULL, 232002),
(252438, '3vdgA02', NULL, NULL, 242, NULL, NULL, 232002),
(252439, '1tkkA02', NULL, NULL, 251, NULL, NULL, 232002),
(252440, '4a3rA02', NULL, NULL, 303, NULL, NULL, 232002),
(252441, '2oz3A02', NULL, NULL, 242, NULL, NULL, 232002),
(252442, '3mznA02', NULL, NULL, 260, NULL, NULL, 232002),
(252443, '2chrA02', NULL, NULL, 202, NULL, NULL, 232002),
(252444, '3u4fA02', NULL, NULL, 254, NULL, NULL, 232002),
(252445, '4dwdA02', NULL, NULL, 263, NULL, NULL, 232002),
(252446, '4gisA02', NULL, NULL, 253, NULL, NULL, 232002),
(252447, '3va8A02', NULL, NULL, 244, NULL, NULL, 232002),
(252448, '2ps2A02', NULL, NULL, 238, NULL, NULL, 232002),
(252449, '1pdzA02', NULL, NULL, 307, NULL, NULL, 232002),
(252450, '3gc2A02', NULL, NULL, 198, NULL, NULL, 232002),
(252451, '3zlgA02', NULL, NULL, 308, NULL, NULL, 232002),
(252452, '3fcpA02', NULL, NULL, 235, NULL, NULL, 232002),
(252453, '2ptwA02', NULL, NULL, 304, NULL, NULL, 232002),
(252454, '2hzgA02', NULL, NULL, 248, NULL, NULL, 232002),
(252455, '3i6tA02', NULL, NULL, 259, NULL, NULL, 232002),
(252456, '2rdxA02', NULL, NULL, 237, NULL, NULL, 232002),
(252457, '2pgeA02', NULL, NULL, 241, NULL, NULL, 232002),
(252458, '3qn3A02', NULL, NULL, 287, NULL, NULL, 232002),
(252459, '6j36B02', NULL, NULL, 329, NULL, NULL, 232002),
(252460, '4gypC02', NULL, NULL, 261, NULL, NULL, 232002),
(252461, '3r0uB02', NULL, NULL, 262, NULL, NULL, 232002),
(252462, '2oz3D02', NULL, NULL, 242, NULL, NULL, 232002),
(252463, '4hn8A02', NULL, NULL, 261, NULL, NULL, 232002),
(252464, '1jpdX02', NULL, NULL, 207, NULL, NULL, 232002),
(252465, '2oztA02', NULL, NULL, 203, NULL, NULL, 232002),
(252466, '3ik4A02', NULL, NULL, 246, NULL, NULL, 232002),
(252467, '2oz3H02', NULL, NULL, 242, NULL, NULL, 232002),
(252468, '4j1oA02', NULL, NULL, 234, NULL, NULL, 232002),
(252469, '3cyjA02', NULL, NULL, 237, NULL, NULL, 232002),
(252470, '3gd6A02', NULL, NULL, 226, NULL, NULL, 232002),
(252471, '3fv9A02', NULL, NULL, 243, NULL, NULL, 232002),
(252472, '1r6wA01', NULL, NULL, 198, NULL, NULL, 232002),
(252473, '3jvaB02', NULL, NULL, 240, NULL, NULL, 232002);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(252474, '1mucA02', NULL, NULL, 236, NULL, NULL, 232002),
(252475, '3thuA02', NULL, NULL, 262, NULL, NULL, 232002),
(252476, '3my9A02', NULL, NULL, 257, NULL, NULL, 232002),
(252477, '3t9pA02', NULL, NULL, 254, NULL, NULL, 232002),
(252478, '3qtpA02', NULL, NULL, 311, NULL, NULL, 232002),
(252479, '2gdqA02', NULL, NULL, 273, NULL, NULL, 232002),
(252480, '4fi4A02', NULL, NULL, 262, NULL, NULL, 232002),
(252481, '3tqpB02', NULL, NULL, 300, NULL, NULL, 232002),
(252482, '4jhmA02', NULL, NULL, 263, NULL, NULL, 232002),
(252483, '4it1A02', NULL, NULL, 246, NULL, NULL, 232002),
(252484, '3qldA02', NULL, NULL, 231, NULL, NULL, 232002),
(252485, '4g7fA02', NULL, NULL, 302, NULL, NULL, 232002),
(252486, '6nb2B02', NULL, NULL, 296, NULL, NULL, 232002),
(252487, '3ozyA02', NULL, NULL, 243, NULL, NULL, 232002),
(252488, '2ox4A02', NULL, NULL, 263, NULL, NULL, 232002),
(252489, '2akzB02', NULL, NULL, 313, NULL, NULL, 232002),
(252490, '2p8bA02', NULL, NULL, 235, NULL, NULL, 232002),
(252491, '4k8gA02', NULL, NULL, 262, NULL, NULL, 232002),
(252492, '4dyeA02', NULL, NULL, 241, NULL, NULL, 232002),
(252493, '2qvhA02', NULL, NULL, 225, NULL, NULL, 232002),
(252494, '4hpnA02', NULL, NULL, 264, NULL, NULL, 232002),
(252495, '3cb3A02', NULL, NULL, 233, NULL, NULL, 232002),
(252496, '3sqsA02', NULL, NULL, 248, NULL, NULL, 232002),
(252497, '3nxlA02', NULL, NULL, 261, NULL, NULL, 232002),
(252498, '1ec7A02', NULL, NULL, 261, NULL, NULL, 232002),
(252499, '2o56G02', NULL, NULL, 264, NULL, NULL, 232002),
(252500, '2zc8A02', NULL, NULL, 230, NULL, NULL, 232002),
(252501, '4il2A02', NULL, NULL, 264, NULL, NULL, 232002),
(252502, '4mggA02', NULL, NULL, 237, NULL, NULL, 232002),
(252503, '1r0mA02', NULL, NULL, 230, NULL, NULL, 232002),
(252504, '3zviA02', NULL, NULL, 234, NULL, NULL, 232002),
(252505, '4h83A02', NULL, NULL, 237, NULL, NULL, 232002),
(252506, '4mksB02', NULL, NULL, 313, NULL, NULL, 232002),
(252507, '3rcyA02', NULL, NULL, 254, NULL, NULL, 232002),
(252508, '3ekgA02', NULL, NULL, 242, NULL, NULL, 232002),
(252509, '3dg3A02', NULL, NULL, 253, NULL, NULL, 232002),
(252510, '4e4uA02', NULL, NULL, 255, NULL, NULL, 232002),
(252511, '2oz3G02', NULL, NULL, 242, NULL, NULL, 232002),
(252512, '3q45A02', NULL, NULL, 242, NULL, NULL, 232002),
(252513, '4g8tA02', NULL, NULL, 261, NULL, NULL, 232002),
(252514, '5olcA02', NULL, NULL, 274, NULL, NULL, 232002),
(252515, '4j3zA02', NULL, NULL, 253, NULL, NULL, 232002),
(252516, '2pgwA02', NULL, NULL, 221, NULL, NULL, 232002),
(252517, '3otrF02', NULL, NULL, 320, NULL, NULL, 232002),
(252518, '5boeB02', NULL, NULL, 312, NULL, NULL, 232002),
(252519, '1tzzA02', NULL, NULL, 260, NULL, NULL, 232002),
(252520, '3tjiA02', NULL, NULL, 253, NULL, NULL, 232002),
(252521, '4dxkA02', NULL, NULL, 241, NULL, NULL, 232002),
(252522, '4h2hA02', NULL, NULL, 234, NULL, NULL, 232002),
(252523, '2pa6A02', NULL, NULL, 289, NULL, NULL, 232002),
(252524, '3fxgA02', NULL, NULL, 241, NULL, NULL, 232002),
(252525, '2qdeA02', NULL, NULL, 239, NULL, NULL, 232002),
(252526, '3go2A02', NULL, NULL, 272, NULL, NULL, 232002),
(252527, '3ijlA02', NULL, NULL, 229, NULL, NULL, 232002),
(252528, '3gy1B02', NULL, NULL, 253, NULL, NULL, 232002),
(252529, '3p0wC02', NULL, NULL, 261, NULL, NULL, 232002),
(252530, '1kkoA02', NULL, NULL, 249, NULL, NULL, 232002),
(252531, '6o4nA02', NULL, NULL, 295, NULL, NULL, 232002),
(252532, '3t4wA02', NULL, NULL, 254, NULL, NULL, 232002),
(252533, '3sjnA02', NULL, NULL, 254, NULL, NULL, 232002),
(252534, '3mkcA02', NULL, NULL, 237, NULL, NULL, 232002),
(252535, '2oz3C02', NULL, NULL, 242, NULL, NULL, 232002),
(252536, '2qq6A02', NULL, NULL, 267, NULL, NULL, 232002),
(252537, '4ywsB02', NULL, NULL, 298, NULL, NULL, 232002),
(252538, '3mwcA02', NULL, NULL, 253, NULL, NULL, 232002),
(252539, '5xd7A02', NULL, NULL, 232, NULL, NULL, 232002),
(252540, '3bjsA02', NULL, NULL, 254, NULL, NULL, 232002),
(252541, '4e5tD02', NULL, NULL, 261, NULL, NULL, 232002),
(252542, '1bqgA02', NULL, NULL, 260, NULL, NULL, 232002),
(252543, '3u9iB02', NULL, NULL, 252, NULL, NULL, 232002),
(252544, '1w6tA02', NULL, NULL, 307, NULL, NULL, 232002);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(252545, '2psnD02', NULL, NULL, 307, NULL, NULL, 232002),
(252546, '2pp0A02', NULL, NULL, 233, NULL, NULL, 232002),
(252547, '2zadA02', NULL, NULL, 230, NULL, NULL, 232002),
(252548, '3tw9C02', NULL, NULL, 270, NULL, NULL, 232002),
(252549, '2al1B02', NULL, NULL, 310, NULL, NULL, 232002),
(252550, '3stpA02', NULL, NULL, 248, NULL, NULL, 232002),
(252551, '4gfiA02', NULL, NULL, 222, NULL, NULL, 232002),
(252552, '2oz8A02', NULL, NULL, 232, NULL, NULL, 232002),
(252553, '3ekgB02', NULL, NULL, 242, NULL, NULL, 232002),
(252554, '3ddmA02', NULL, NULL, 238, NULL, NULL, 232002),
(252555, '4h1zA02', NULL, NULL, 221, NULL, NULL, 232002),
(252556, '1kd0B02', NULL, NULL, 234, NULL, NULL, 232002),
(252557, '3rr1B02', NULL, NULL, 243, NULL, NULL, 232002),
(252558, '2oz3F02', NULL, NULL, 242, NULL, NULL, 232002),
(252559, '4a35A02', NULL, NULL, 307, NULL, NULL, 232002),
(252560, '2oktA02', NULL, NULL, 206, NULL, NULL, 232002),
(252561, '3tcsA02', NULL, NULL, 254, NULL, NULL, 232002),
(252562, '3mqtA02', NULL, NULL, 237, NULL, NULL, 232002),
(252563, '3uj2A02', NULL, NULL, 298, NULL, NULL, 232002),
(252564, '3i6eA02', NULL, NULL, 263, NULL, NULL, 232002),
(252565, '1wufA02', NULL, NULL, 244, NULL, NULL, 232002),
(252566, '2xsxA02', NULL, NULL, 307, NULL, NULL, 232002),
(252567, '3pfrA02', NULL, NULL, 261, NULL, NULL, 232002),
(252568, '3dipA02', NULL, NULL, 274, NULL, NULL, 232002),
(252569, '1yeyD02', NULL, NULL, 262, NULL, NULL, 232002),
(252570, '3toyA02', NULL, NULL, 230, NULL, NULL, 232002),
(252571, '2oz3B02', NULL, NULL, 242, NULL, NULL, 232002),
(252572, '3s5sA02', NULL, NULL, 253, NULL, NULL, 232002),
(252573, '4x2pA02', NULL, NULL, 230, NULL, NULL, 232002),
(252574, '4nx9A02', NULL, NULL, 121, NULL, NULL, 232003),
(252575, '1jqoA03', NULL, NULL, 137, NULL, NULL, 232004),
(252576, '1vsgA02', NULL, NULL, 161, NULL, NULL, 232005),
(252577, '2vsgA02', NULL, NULL, 160, NULL, NULL, 232005),
(252578, '5b7wA02', NULL, NULL, 90, NULL, NULL, 232006),
(252579, '1in0A02', NULL, NULL, 92, NULL, NULL, 232006),
(252580, '4zqwB00', NULL, NULL, 177, NULL, NULL, 232007),
(252581, '4zqvA00', NULL, NULL, 175, NULL, NULL, 232007),
(252582, '2gkpA00', NULL, NULL, 167, NULL, NULL, 232007),
(252583, '4zquB00', NULL, NULL, 185, NULL, NULL, 232007),
(252584, '3bh1A01', NULL, NULL, 244, NULL, NULL, 232008),
(252585, '1v64A00', NULL, NULL, 108, NULL, NULL, 232009),
(252586, '2cs1A00', NULL, NULL, 92, NULL, NULL, 232009),
(252587, '3u2bC00', NULL, NULL, 79, NULL, NULL, 232009),
(252588, '4qr9A00', NULL, NULL, 76, NULL, NULL, 232009),
(252589, '2lefA00', NULL, NULL, 86, NULL, NULL, 232009),
(252590, '1wxlA00', NULL, NULL, 73, NULL, NULL, 232009),
(252591, '3fghA00', NULL, NULL, 67, NULL, NULL, 232009),
(252592, '1l8yA00', NULL, NULL, 91, NULL, NULL, 232009),
(252593, '1i11A00', NULL, NULL, 81, NULL, NULL, 232009),
(252594, '2d7lA01', NULL, NULL, 53, NULL, NULL, 232009),
(252595, '2yrqA01', NULL, NULL, 87, NULL, NULL, 232009),
(252596, '2yukA00', NULL, NULL, 90, NULL, NULL, 232009),
(252597, '2yrqA02', NULL, NULL, 86, NULL, NULL, 232009),
(252598, '1wz6A01', NULL, NULL, 60, NULL, NULL, 232009),
(252599, '1j3cA00', NULL, NULL, 79, NULL, NULL, 232009),
(252600, '2co9A00', NULL, NULL, 102, NULL, NULL, 232009),
(252601, '2yqiA00', NULL, NULL, 81, NULL, NULL, 232009),
(252602, '2hdzA00', NULL, NULL, 69, NULL, NULL, 232009),
(252603, '3tq6B02', NULL, NULL, 82, NULL, NULL, 232009),
(252604, '1hsmA00', NULL, NULL, 79, NULL, NULL, 232009),
(252605, '1v63A00', NULL, NULL, 101, NULL, NULL, 232009),
(252606, '1k99A00', NULL, NULL, 99, NULL, NULL, 232009),
(252607, '1wgfA01', NULL, NULL, 53, NULL, NULL, 232009),
(252608, '3tmmA01', NULL, NULL, 109, NULL, NULL, 232009),
(252609, '2eqzA00', NULL, NULL, 86, NULL, NULL, 232009),
(252610, '2crjA00', NULL, NULL, 92, NULL, NULL, 232009),
(252611, '2e6oA00', NULL, NULL, 87, NULL, NULL, 232009),
(252612, '3f27D00', NULL, NULL, 83, NULL, NULL, 232009),
(252613, '4y60C00', NULL, NULL, 80, NULL, NULL, 232009),
(252614, '2lhjA01', NULL, NULL, 80, NULL, NULL, 232009),
(252615, '2ctoA01', NULL, NULL, 61, NULL, NULL, 232009);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(252616, '6edbB00', NULL, NULL, 73, NULL, NULL, 232009),
(252617, '1j46A00', NULL, NULL, 85, NULL, NULL, 232009),
(252618, '4s2qD00', NULL, NULL, 76, NULL, NULL, 232009),
(252619, '5vweA00', NULL, NULL, 69, NULL, NULL, 232009),
(252620, '2yulA00', NULL, NULL, 82, NULL, NULL, 232009),
(252621, '1cg7A00', NULL, NULL, 93, NULL, NULL, 232009),
(252622, '1j3xA00', NULL, NULL, 77, NULL, NULL, 232009),
(252623, '1qrvA00', NULL, NULL, 73, NULL, NULL, 232009),
(252624, '1gt0D00', NULL, NULL, 80, NULL, NULL, 232009),
(252625, '6b5fA01', NULL, NULL, 78, NULL, NULL, 232010),
(252626, '4hdrD01', NULL, NULL, 73, NULL, NULL, 232010),
(252627, '4hdrA01', NULL, NULL, 73, NULL, NULL, 232010),
(252628, '1l5mA01', NULL, NULL, 74, NULL, NULL, 232010),
(252629, '4kqkB01', NULL, NULL, 81, NULL, NULL, 232010),
(252630, '1wx1A01', NULL, NULL, 62, NULL, NULL, 232010),
(252631, '4glkA00', NULL, NULL, 172, NULL, NULL, 232011),
(252632, '2xdbA00', NULL, NULL, 171, NULL, NULL, 232011),
(252633, '4atoA00', NULL, NULL, 172, NULL, NULL, 232011),
(252634, '4rmoA00', NULL, NULL, 155, NULL, NULL, 232011),
(252635, '2qqpA03', NULL, NULL, 137, NULL, NULL, 232012),
(252636, '6b6uB01', NULL, NULL, 182, NULL, NULL, 232013),
(252637, '1vp8A00', NULL, NULL, 201, NULL, NULL, 232013),
(252638, '1pkmA01', NULL, NULL, 187, NULL, NULL, 232013),
(252639, '2e28A03', NULL, NULL, 135, NULL, NULL, 232013),
(252640, '3g2gA01', NULL, NULL, 173, NULL, NULL, 232013),
(252641, '3qv9A01', NULL, NULL, 163, NULL, NULL, 232013),
(252642, '6du6A01', NULL, NULL, 164, NULL, NULL, 232013),
(252643, '1e0tA01', NULL, NULL, 132, NULL, NULL, 232013),
(252644, '2g50A01', NULL, NULL, 187, NULL, NULL, 232013),
(252645, '3qtgA03', NULL, NULL, 115, NULL, NULL, 232013),
(252646, '2vggB01', NULL, NULL, 178, NULL, NULL, 232013),
(252647, '3khdA01', NULL, NULL, 166, NULL, NULL, 232013),
(252648, '3hqnD01', NULL, NULL, 163, NULL, NULL, 232013),
(252649, '1a3wA01', NULL, NULL, 161, NULL, NULL, 232013),
(252650, '3t05A03', NULL, NULL, 135, NULL, NULL, 232013),
(252651, '4ip7A01', NULL, NULL, 175, NULL, NULL, 232013),
(252652, '1t57A00', NULL, NULL, 185, NULL, NULL, 232013),
(252653, '4kctA01', NULL, NULL, 163, NULL, NULL, 232013),
(252654, '3gg8C01', NULL, NULL, 173, NULL, NULL, 232013),
(252655, '3me3C01', NULL, NULL, 174, NULL, NULL, 232013),
(252656, '3ma8B01', NULL, NULL, 156, NULL, NULL, 232013),
(252657, '3u88M00', NULL, NULL, 57, NULL, NULL, 232014),
(252658, '1t1jA00', NULL, NULL, 125, NULL, NULL, 232015),
(252659, '2ztjA02', NULL, NULL, 49, NULL, NULL, 232016),
(252660, '2b6cB02', NULL, NULL, 99, NULL, NULL, 232017),
(252661, '6m9mA02', NULL, NULL, 119, NULL, NULL, 232017),
(252662, '1ug7A00', NULL, NULL, 128, NULL, NULL, 232018),
(252663, '1xoyA00', NULL, NULL, 161, NULL, NULL, 232019),
(252664, '1wwyA00', NULL, NULL, 171, NULL, NULL, 232019),
(252665, '1pbyC00', NULL, NULL, 79, NULL, NULL, 232020),
(252666, '1jmxG00', NULL, NULL, 79, NULL, NULL, 232020),
(252667, '5mp4A00', NULL, NULL, 198, NULL, NULL, 232021),
(252668, '1ydgA00', NULL, NULL, 211, NULL, NULL, 232021),
(252669, '3fvwB00', NULL, NULL, 192, NULL, NULL, 232021),
(252670, '2hnaA00', NULL, NULL, 147, NULL, NULL, 232021),
(252671, '4lafC00', NULL, NULL, 207, NULL, NULL, 232021),
(252672, '6fsgA00', NULL, NULL, 147, NULL, NULL, 232021),
(252673, '3hlyC00', NULL, NULL, 161, NULL, NULL, 232021),
(252674, '3fjoA01', NULL, NULL, 172, NULL, NULL, 232021),
(252675, '2bmvA00', NULL, NULL, 164, NULL, NULL, 232021),
(252676, '1ykgA00', NULL, NULL, 167, NULL, NULL, 232021),
(252677, '3kapA00', NULL, NULL, 147, NULL, NULL, 232021),
(252678, '4fglA00', NULL, NULL, 233, NULL, NULL, 232021),
(252679, '3d7nA00', NULL, NULL, 193, NULL, NULL, 232021),
(252680, '4oxxA00', NULL, NULL, 162, NULL, NULL, 232021),
(252681, '4ltnA00', NULL, NULL, 197, NULL, NULL, 232021),
(252682, '2q9uA02', NULL, NULL, 145, NULL, NULL, 232021),
(252683, '3l9wB02', NULL, NULL, 182, NULL, NULL, 232021),
(252684, '4h2dA00', NULL, NULL, 165, NULL, NULL, 232021),
(252685, '4d02A02', NULL, NULL, 143, NULL, NULL, 232021),
(252686, '1ja1A01', NULL, NULL, 172, NULL, NULL, 232021);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(252687, '3qfcA01', NULL, NULL, 181, NULL, NULL, 232021),
(252688, '2wc1A00', NULL, NULL, 182, NULL, NULL, 232021),
(252689, '4j8pA00', NULL, NULL, 159, NULL, NULL, 232021),
(252690, '3ha2A00', NULL, NULL, 177, NULL, NULL, 232021),
(252691, '6ebqA00', NULL, NULL, 140, NULL, NULL, 232021),
(252692, '2xodA00', NULL, NULL, 119, NULL, NULL, 232021),
(252693, '1t5bB00', NULL, NULL, 201, NULL, NULL, 232021),
(252694, '6frnA02', NULL, NULL, 145, NULL, NULL, 232021),
(252695, '2hpvA00', NULL, NULL, 208, NULL, NULL, 232021),
(252696, '2amjB00', NULL, NULL, 204, NULL, NULL, 232021),
(252697, '6dxpC00', NULL, NULL, 200, NULL, NULL, 232021),
(252698, '5b3kA00', NULL, NULL, 150, NULL, NULL, 232021),
(252699, '5vegB00', NULL, NULL, 149, NULL, NULL, 232021),
(252700, '1rliD00', NULL, NULL, 184, NULL, NULL, 232021),
(252701, '5lvaA00', NULL, NULL, 174, NULL, NULL, 232021),
(252702, '4heqA00', NULL, NULL, 146, NULL, NULL, 232021),
(252703, '6gaqA00', NULL, NULL, 154, NULL, NULL, 232021),
(252704, '3k1yA00', NULL, NULL, 191, NULL, NULL, 232021),
(252705, '3svlB00', NULL, NULL, 193, NULL, NULL, 232021),
(252706, '3u7rA00', NULL, NULL, 190, NULL, NULL, 232021),
(252707, '2fzvD00', NULL, NULL, 255, NULL, NULL, 232021),
(252708, '1dxqA00', NULL, NULL, 273, NULL, NULL, 232021),
(252709, '1bvyF00', NULL, NULL, 152, NULL, NULL, 232021),
(252710, '2mt9A00', NULL, NULL, 173, NULL, NULL, 232021),
(252711, '1qrdA00', NULL, NULL, 273, NULL, NULL, 232021),
(252712, '5ljpA00', NULL, NULL, 169, NULL, NULL, 232021),
(252713, '1e5dA01', NULL, NULL, 143, NULL, NULL, 232021),
(252714, '1t0iA00', NULL, NULL, 191, NULL, NULL, 232021),
(252715, '5yobA00', NULL, NULL, 148, NULL, NULL, 232021),
(252716, '2fcrA00', NULL, NULL, 173, NULL, NULL, 232021),
(252717, '5k9bA00', NULL, NULL, 180, NULL, NULL, 232021),
(252718, '4r81C00', NULL, NULL, 206, NULL, NULL, 232021),
(252719, '3fniA00', NULL, NULL, 159, NULL, NULL, 232021),
(252720, '1ycgA02', NULL, NULL, 143, NULL, NULL, 232021),
(252721, '2z98A00', NULL, NULL, 200, NULL, NULL, 232021),
(252722, '3klbA00', NULL, NULL, 162, NULL, NULL, 232021),
(252723, '5f4bA00', NULL, NULL, 202, NULL, NULL, 232021),
(252724, '2fzvA00', NULL, NULL, 235, NULL, NULL, 232021),
(252725, '4n65B00', NULL, NULL, 212, NULL, NULL, 232021),
(252726, '2bpoA01', NULL, NULL, 172, NULL, NULL, 232021),
(252727, '2zkiD00', NULL, NULL, 199, NULL, NULL, 232021),
(252728, '4hs4A00', NULL, NULL, 199, NULL, NULL, 232021),
(252729, '4gi5A00', NULL, NULL, 280, NULL, NULL, 232021),
(252730, '4c76A00', NULL, NULL, 182, NULL, NULL, 232021),
(252731, '3f2vA00', NULL, NULL, 192, NULL, NULL, 232021),
(252732, '3zhoA00', NULL, NULL, 197, NULL, NULL, 232021),
(252733, '4n82B00', NULL, NULL, 157, NULL, NULL, 232021),
(252734, '3edoA00', NULL, NULL, 151, NULL, NULL, 232021),
(252735, '3w7aA00', NULL, NULL, 211, NULL, NULL, 232021),
(252736, '6dqpB00', NULL, NULL, 173, NULL, NULL, 232021),
(252737, '1rljA00', NULL, NULL, 139, NULL, NULL, 232021),
(252738, '1sqsA00', NULL, NULL, 242, NULL, NULL, 232021),
(252739, '3f6rA00', NULL, NULL, 148, NULL, NULL, 232021),
(252740, '2m6rA00', NULL, NULL, 149, NULL, NULL, 232021),
(252741, '1cznA00', NULL, NULL, 169, NULL, NULL, 232021),
(252742, '3rpeB00', NULL, NULL, 195, NULL, NULL, 232021),
(252743, '3lcmB00', NULL, NULL, 196, NULL, NULL, 232021),
(252744, '4iciA00', NULL, NULL, 171, NULL, NULL, 232021),
(252745, '5nulA00', NULL, NULL, 138, NULL, NULL, 232021),
(252746, '3p0rA00', NULL, NULL, 211, NULL, NULL, 232021),
(252747, '1tllA01', NULL, NULL, 209, NULL, NULL, 232021),
(252748, '4cetA00', NULL, NULL, 222, NULL, NULL, 232021),
(252749, '1ag9A00', NULL, NULL, 175, NULL, NULL, 232021),
(252750, '2fz5A00', NULL, NULL, 137, NULL, NULL, 232021),
(252751, '4c0xA00', NULL, NULL, 203, NULL, NULL, 232021),
(252752, '2a5lB00', NULL, NULL, 200, NULL, NULL, 232021),
(252753, '2arkA00', NULL, NULL, 188, NULL, NULL, 232021),
(252754, '2ohhA02', NULL, NULL, 144, NULL, NULL, 232021),
(252755, '3gfsC00', NULL, NULL, 174, NULL, NULL, 232021),
(252756, '3u7iA00', NULL, NULL, 223, NULL, NULL, 232021),
(252757, '3w77A00', NULL, NULL, 208, NULL, NULL, 232021);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(252758, '1rttA00', NULL, NULL, 193, NULL, NULL, 232021),
(252759, '3n3aC00', NULL, NULL, 131, NULL, NULL, 232021),
(252760, '5ljlA00', NULL, NULL, 149, NULL, NULL, 232021),
(252761, '2q62G01', NULL, NULL, 205, NULL, NULL, 232021),
(252762, '5v8sA02', NULL, NULL, 149, NULL, NULL, 232021),
(252763, '3hr4E00', NULL, NULL, 203, NULL, NULL, 232021),
(252764, '4eseA00', NULL, NULL, 204, NULL, NULL, 232021),
(252765, '1g5zA00', NULL, NULL, 164, NULL, NULL, 232022),
(252766, '1f1mA00', NULL, NULL, 164, NULL, NULL, 232022),
(252767, '1ggqA00', NULL, NULL, 174, NULL, NULL, 232022),
(252768, '1yjgA00', NULL, NULL, 158, NULL, NULL, 232022),
(252769, '2w4yA00', NULL, NULL, 122, NULL, NULL, 232023),
(252770, '1uf5A00', NULL, NULL, 303, NULL, NULL, 232024),
(252771, '2vhhA00', NULL, NULL, 386, NULL, NULL, 232024),
(252772, '4hg5C00', NULL, NULL, 303, NULL, NULL, 232024),
(252773, '4f4hB01', NULL, NULL, 280, NULL, NULL, 232024),
(252774, '5g3pC00', NULL, NULL, 326, NULL, NULL, 232024),
(252775, '1f89A00', NULL, NULL, 291, NULL, NULL, 232024),
(252776, '3ivzA00', NULL, NULL, 262, NULL, NULL, 232024),
(252777, '2w1vA00', NULL, NULL, 276, NULL, NULL, 232024),
(252778, '1emsA01', NULL, NULL, 280, NULL, NULL, 232024),
(252779, '4cyfA01', NULL, NULL, 305, NULL, NULL, 232024),
(252780, '2uxyA00', NULL, NULL, 341, NULL, NULL, 232024),
(252781, '3sdbA01', NULL, NULL, 323, NULL, NULL, 232024),
(252782, '3wuyA00', NULL, NULL, 294, NULL, NULL, 232024),
(252783, '6mg6A00', NULL, NULL, 300, NULL, NULL, 232024),
(252784, '2dyuA01', NULL, NULL, 306, NULL, NULL, 232024),
(252785, '3ilvA01', NULL, NULL, 280, NULL, NULL, 232024),
(252786, '3n05A01', NULL, NULL, 304, NULL, NULL, 232024),
(252787, '1j31A00', NULL, NULL, 262, NULL, NULL, 232024),
(252788, '3p8kA00', NULL, NULL, 281, NULL, NULL, 232024),
(252789, '5khaB01', NULL, NULL, 268, NULL, NULL, 232024),
(252790, '2e11A00', NULL, NULL, 266, NULL, NULL, 232024),
(252791, '5h8iB00', NULL, NULL, 304, NULL, NULL, 232024),
(252792, '5jqnA00', NULL, NULL, 266, NULL, NULL, 232024),
(252793, '4lf0A00', NULL, NULL, 348, NULL, NULL, 232024),
(252794, '2kinB01', NULL, NULL, 80, NULL, NULL, 232025),
(252795, '4k7jA02', NULL, NULL, 123, NULL, NULL, 232026),
(252796, '1lqsL02', NULL, NULL, 43, NULL, NULL, 232027),
(252797, '1fvpA00', NULL, NULL, 231, NULL, NULL, 232028),
(252798, '2i7gB00', NULL, NULL, 376, NULL, NULL, 232028),
(252799, '4uwmA00', NULL, NULL, 378, NULL, NULL, 232028),
(252800, '1z69A00', NULL, NULL, 327, NULL, NULL, 232028),
(252801, '5lxeA00', NULL, NULL, 335, NULL, NULL, 232028),
(252802, '1lucB00', NULL, NULL, 324, NULL, NULL, 232028),
(252803, '6askA00', NULL, NULL, 444, NULL, NULL, 232028),
(252804, '1lucA00', NULL, NULL, 355, NULL, NULL, 232028),
(252805, '1rhcA00', NULL, NULL, 330, NULL, NULL, 232028),
(252806, '2b81C00', NULL, NULL, 323, NULL, NULL, 232028),
(252807, '3raoB00', NULL, NULL, 353, NULL, NULL, 232028),
(252808, '5xkcA00', NULL, NULL, 453, NULL, NULL, 232028),
(252809, '5w4zA00', NULL, NULL, 461, NULL, NULL, 232028),
(252810, '1ezwA00', NULL, NULL, 349, NULL, NULL, 232028),
(252811, '1nfpA00', NULL, NULL, 228, NULL, NULL, 232028),
(252812, '3c8nA00', NULL, NULL, 356, NULL, NULL, 232028),
(252813, '6friA00', NULL, NULL, 325, NULL, NULL, 232028),
(252814, '5dqpB00', NULL, NULL, 430, NULL, NULL, 232028),
(252815, '3b9oA00', NULL, NULL, 440, NULL, NULL, 232028),
(252816, '4us5C00', NULL, NULL, 338, NULL, NULL, 232028),
(252817, '3sdoB00', NULL, NULL, 418, NULL, NULL, 232028),
(252818, '1nqkA00', NULL, NULL, 362, NULL, NULL, 232028),
(252819, '1f07A00', NULL, NULL, 321, NULL, NULL, 232028),
(252820, '4epsA02', NULL, NULL, 125, NULL, NULL, 232029),
(252821, '3gmxA00', NULL, NULL, 154, NULL, NULL, 232030),
(252822, '3gmvX00', NULL, NULL, 156, NULL, NULL, 232030),
(252823, '1x3lA01', NULL, NULL, 195, NULL, NULL, 232031),
(252824, '2b8nA01', NULL, NULL, 202, NULL, NULL, 232031),
(252825, '4p02B05', NULL, NULL, 102, NULL, NULL, 232032),
(252826, '1sigA00', NULL, NULL, 339, NULL, NULL, 232033),
(252827, '5uagF01', NULL, NULL, 313, NULL, NULL, 232033),
(252828, '3b4sA02', NULL, NULL, 43, NULL, NULL, 232034);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(252829, '5kycB02', NULL, NULL, 53, NULL, NULL, 232035),
(252830, '3egwA01', NULL, NULL, 42, NULL, NULL, 232036),
(252831, '1q16A01', NULL, NULL, 28, NULL, NULL, 232036),
(252832, '1mswD04', NULL, NULL, 78, NULL, NULL, 232037),
(252833, '2vvyA01', NULL, NULL, 134, NULL, NULL, 232038),
(252834, '2vvwA00', NULL, NULL, 162, NULL, NULL, 232038),
(252835, '4lqkA00', NULL, NULL, 143, NULL, NULL, 232038),
(252836, '4m0sA00', NULL, NULL, 146, NULL, NULL, 232038),
(252837, '2uxeA00', NULL, NULL, 117, NULL, NULL, 232038),
(252838, '3jrvA00', NULL, NULL, 149, NULL, NULL, 232038),
(252839, '2uxeB00', NULL, NULL, 117, NULL, NULL, 232038),
(252840, '2i39B00', NULL, NULL, 121, NULL, NULL, 232038),
(252841, '2uxeC00', NULL, NULL, 117, NULL, NULL, 232038),
(252842, '2uxeD00', NULL, NULL, 117, NULL, NULL, 232038),
(252843, '2uxeE00', NULL, NULL, 117, NULL, NULL, 232038),
(252844, '2uxeF00', NULL, NULL, 117, NULL, NULL, 232038),
(252845, '1vz0C02', NULL, NULL, 113, NULL, NULL, 232039),
(252846, '3mkyP00', NULL, NULL, 114, NULL, NULL, 232039),
(252847, '3vwbA00', NULL, NULL, 120, NULL, NULL, 232039),
(252848, '3nbxX03', NULL, NULL, 102, NULL, NULL, 232040),
(252849, '2d68A00', NULL, NULL, 82, NULL, NULL, 232041),
(252850, '5i34A02', NULL, NULL, 95, NULL, NULL, 232042),
(252851, '3ue9A02', NULL, NULL, 100, NULL, NULL, 232042),
(252852, '3r7tA02', NULL, NULL, 99, NULL, NULL, 232042),
(252853, '1dj3A02', NULL, NULL, 99, NULL, NULL, 232042),
(252854, '2v40A02', NULL, NULL, 100, NULL, NULL, 232042),
(252855, '1adeA02', NULL, NULL, 100, NULL, NULL, 232042),
(252856, '1iweA02', NULL, NULL, 100, NULL, NULL, 232042),
(252857, '3hidA02', NULL, NULL, 100, NULL, NULL, 232042),
(252858, '4m9dA02', NULL, NULL, 100, NULL, NULL, 232042),
(252859, '1dj2A02', NULL, NULL, 99, NULL, NULL, 232042),
(252860, '1p9bA02', NULL, NULL, 98, NULL, NULL, 232042),
(252861, '3ii7A00', NULL, NULL, 306, NULL, NULL, 232043),
(252862, '6gy5A00', NULL, NULL, 304, NULL, NULL, 232043),
(252863, '2zwaA02', NULL, NULL, 327, NULL, NULL, 232043),
(252864, '4chbA00', NULL, NULL, 302, NULL, NULL, 232043),
(252865, '4ascA00', NULL, NULL, 315, NULL, NULL, 232043),
(252866, '4ch9A00', NULL, NULL, 292, NULL, NULL, 232043),
(252867, '1zgkA00', NULL, NULL, 288, NULL, NULL, 232043),
(252868, '1x2jA00', NULL, NULL, 316, NULL, NULL, 232043),
(252869, '2vpjA00', NULL, NULL, 301, NULL, NULL, 232043),
(252870, '2wozA00', NULL, NULL, 318, NULL, NULL, 232043),
(252871, '5wfvB00', NULL, NULL, 300, NULL, NULL, 232043),
(252872, '4yy8A02', NULL, NULL, 299, NULL, NULL, 232043),
(252873, '2xzmP00', NULL, NULL, 149, NULL, NULL, 232044),
(252874, '3j7a100', NULL, NULL, 133, NULL, NULL, 232044),
(252875, '6faiY00', NULL, NULL, 135, NULL, NULL, 232044),
(252876, '5xxuY00', NULL, NULL, 135, NULL, NULL, 232044),
(252877, '6g5iY00', NULL, NULL, 133, NULL, NULL, 232044),
(252878, '6az1Z00', NULL, NULL, 137, NULL, NULL, 232044),
(252879, '3jamY00', NULL, NULL, 135, NULL, NULL, 232044),
(252880, '5optY00', NULL, NULL, 137, NULL, NULL, 232044),
(252881, '5xyiY00', NULL, NULL, 117, NULL, NULL, 232044),
(252882, '3i5qA01', NULL, NULL, 171, NULL, NULL, 232045),
(252883, '2l6oA01', NULL, NULL, 72, NULL, NULL, 232046),
(252884, '1l9lA00', NULL, NULL, 74, NULL, NULL, 232047),
(252885, '1of9A00', NULL, NULL, 77, NULL, NULL, 232047),
(252886, '1qdmA03', NULL, NULL, 104, NULL, NULL, 232047),
(252887, '2qypB00', NULL, NULL, 91, NULL, NULL, 232047),
(252888, '5nxbC00', NULL, NULL, 87, NULL, NULL, 232047),
(252889, '3s63A00', NULL, NULL, 88, NULL, NULL, 232047),
(252890, '2rqyA01', NULL, NULL, 77, NULL, NULL, 232047),
(252891, '2w50B00', NULL, NULL, 102, NULL, NULL, 232047),
(252892, '3rfiA00', NULL, NULL, 108, NULL, NULL, 232047),
(252893, '2js9A00', NULL, NULL, 81, NULL, NULL, 232047),
(252894, '2w51A01', NULL, NULL, 96, NULL, NULL, 232047),
(252895, '3s64A00', NULL, NULL, 87, NULL, NULL, 232047),
(252896, '4v2oB00', NULL, NULL, 82, NULL, NULL, 232047),
(252897, '2gtgA00', NULL, NULL, 83, NULL, NULL, 232047),
(252898, '3bqpA00', NULL, NULL, 80, NULL, NULL, 232047),
(252899, '5u85A00', NULL, NULL, 83, NULL, NULL, 232047);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(252900, '4uexA00', NULL, NULL, 85, NULL, NULL, 232047),
(252901, '1nklA00', NULL, NULL, 78, NULL, NULL, 232047),
(252902, '5xzgA01', NULL, NULL, 182, NULL, NULL, 232048),
(252903, '5x9cA01', NULL, NULL, 144, NULL, NULL, 232048),
(252904, '4at7A01', NULL, NULL, 183, NULL, NULL, 232048),
(252905, '4at7B01', NULL, NULL, 140, NULL, NULL, 232048),
(252906, '4woyA01', NULL, NULL, 136, NULL, NULL, 232048),
(252907, '4mkpA01', NULL, NULL, 187, NULL, NULL, 232048),
(252908, '4jlxA01', NULL, NULL, 186, NULL, NULL, 232048),
(252909, '1ceuA00', NULL, NULL, 51, NULL, NULL, 232049),
(252910, '1vziA01', NULL, NULL, 39, NULL, NULL, 232050),
(252911, '2yuaA01', NULL, NULL, 75, NULL, NULL, 232051),
(252912, '2qwoB00', NULL, NULL, 92, NULL, NULL, 232051),
(252913, '2ej7A01', NULL, NULL, 74, NULL, NULL, 232051),
(252914, '2guzA00', NULL, NULL, 71, NULL, NULL, 232051),
(252915, '2ctpA01', NULL, NULL, 72, NULL, NULL, 232051),
(252916, '2guzB00', NULL, NULL, 65, NULL, NULL, 232051),
(252917, '2ctwA00', NULL, NULL, 109, NULL, NULL, 232051),
(252918, '2ctrA00', NULL, NULL, 88, NULL, NULL, 232051),
(252919, '1iurA01', NULL, NULL, 63, NULL, NULL, 232051),
(252920, '2lo1A00', NULL, NULL, 71, NULL, NULL, 232051),
(252921, '1fpoA01', NULL, NULL, 79, NULL, NULL, 232051),
(252922, '3apqB01', NULL, NULL, 92, NULL, NULL, 232051),
(252923, '2dmxA00', NULL, NULL, 92, NULL, NULL, 232051),
(252924, '2qsaA00', NULL, NULL, 109, NULL, NULL, 232051),
(252925, '2cugA01', NULL, NULL, 72, NULL, NULL, 232051),
(252926, '2y4tA02', NULL, NULL, 58, NULL, NULL, 232051),
(252927, '2ochA00', NULL, NULL, 73, NULL, NULL, 232051),
(252928, '3ucsC00', NULL, NULL, 74, NULL, NULL, 232051),
(252929, '1nz6A00', NULL, NULL, 101, NULL, NULL, 232051),
(252930, '2dn9A01', NULL, NULL, 73, NULL, NULL, 232051),
(252931, '4it5A01', NULL, NULL, 81, NULL, NULL, 232051),
(252932, '1fafA00', NULL, NULL, 79, NULL, NULL, 232051),
(252933, '3uo2A01', NULL, NULL, 87, NULL, NULL, 232051),
(252934, '1n4cA01', NULL, NULL, 129, NULL, NULL, 232051),
(252935, '2n04A00', NULL, NULL, 105, NULL, NULL, 232051),
(252936, '4j7zF00', NULL, NULL, 113, NULL, NULL, 232051),
(252937, '2ctqA01', NULL, NULL, 94, NULL, NULL, 232051),
(252938, '3ag7A00', NULL, NULL, 106, NULL, NULL, 232051),
(252939, '4rwuA00', NULL, NULL, 92, NULL, NULL, 232051),
(252940, '3bvoB01', NULL, NULL, 115, NULL, NULL, 232051),
(252941, '2pf4G01', NULL, NULL, 92, NULL, NULL, 232051),
(252942, '2lgwA00', NULL, NULL, 71, NULL, NULL, 232051),
(252943, '2ys8A00', NULL, NULL, 90, NULL, NULL, 232051),
(252944, '5nroB00', NULL, NULL, 65, NULL, NULL, 232051),
(252945, '2pf4E01', NULL, NULL, 71, NULL, NULL, 232051),
(252946, '1gh6A01', NULL, NULL, 101, NULL, NULL, 232051),
(252947, '4wb7A01', NULL, NULL, 56, NULL, NULL, 232051),
(252948, '1wjzA00', NULL, NULL, 94, NULL, NULL, 232051),
(252949, '2l6lA01', NULL, NULL, 90, NULL, NULL, 232051),
(252950, '1hdjA00', NULL, NULL, 77, NULL, NULL, 232051),
(252951, '2j58H01', NULL, NULL, 109, NULL, NULL, 232052),
(252952, '2w8hA01', NULL, NULL, 114, NULL, NULL, 232052),
(252953, '2j58F01', NULL, NULL, 109, NULL, NULL, 232052),
(252954, '2j58G01', NULL, NULL, 109, NULL, NULL, 232052),
(252955, '2j58D01', NULL, NULL, 109, NULL, NULL, 232052),
(252956, '2j58E01', NULL, NULL, 109, NULL, NULL, 232052),
(252957, '2j58B01', NULL, NULL, 109, NULL, NULL, 232052),
(252958, '2j58A02', NULL, NULL, 95, NULL, NULL, 232052),
(252959, '2j58C01', NULL, NULL, 109, NULL, NULL, 232052),
(252960, '3p42A03', NULL, NULL, 74, NULL, NULL, 232052),
(252961, '2j58A01', NULL, NULL, 109, NULL, NULL, 232052),
(252962, '4nc6A01', NULL, NULL, 47, NULL, NULL, 232053),
(252963, '3hzjC01', NULL, NULL, 49, NULL, NULL, 232053),
(252964, '2qq8A01', NULL, NULL, 61, NULL, NULL, 232053),
(252965, '5ejcA01', NULL, NULL, 60, NULL, NULL, 232053),
(252966, '3qwlA01', NULL, NULL, 59, NULL, NULL, 232053),
(252967, '2k4qA00', NULL, NULL, 156, NULL, NULL, 232054),
(252968, '4je3B00', NULL, NULL, 85, NULL, NULL, 232055),
(252969, '4ogeA05', NULL, NULL, 97, NULL, NULL, 232056),
(252970, '2cx0A01', NULL, NULL, 104, NULL, NULL, 232057);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(252971, '3d79A01', NULL, NULL, 85, NULL, NULL, 232057),
(252972, '1q7hA01', NULL, NULL, 67, NULL, NULL, 232057),
(252973, '2l1tA00', NULL, NULL, 109, NULL, NULL, 232058),
(252974, '2v8sV00', NULL, NULL, 96, NULL, NULL, 232059),
(252975, '1vcsA00', NULL, NULL, 102, NULL, NULL, 232059),
(252976, '2qywA00', NULL, NULL, 102, NULL, NULL, 232059),
(252977, '3onjA00', NULL, NULL, 97, NULL, NULL, 232059),
(252978, '3i6sA04', NULL, NULL, 116, NULL, NULL, 232060),
(252979, '3vtaB03', NULL, NULL, 131, NULL, NULL, 232060),
(252980, '4yn3A03', NULL, NULL, 106, NULL, NULL, 232060),
(252981, '3eeqA02', NULL, NULL, 77, NULL, NULL, 232061),
(252982, '4p1wE00', NULL, NULL, 151, NULL, NULL, 232062),
(252983, '5tzbG00', NULL, NULL, 369, NULL, NULL, 232063),
(252984, '4iheA00', NULL, NULL, 374, NULL, NULL, 232063),
(252985, '2drhB00', NULL, NULL, 361, NULL, NULL, 232063),
(252986, '2v4iA00', NULL, NULL, 173, NULL, NULL, 232063),
(252987, '5y0mA00', NULL, NULL, 337, NULL, NULL, 232063),
(252988, '1vz6A01', NULL, NULL, 260, NULL, NULL, 232063),
(252989, '1vraA00', NULL, NULL, 191, NULL, NULL, 232063),
(252990, '3n2wD00', NULL, NULL, 373, NULL, NULL, 232063),
(252991, '3it4A00', NULL, NULL, 199, NULL, NULL, 232063),
(252992, '1b65A00', NULL, NULL, 375, NULL, NULL, 232063),
(252993, '3o3mB01', NULL, NULL, 103, NULL, NULL, 232064),
(252994, '4ypoA02', NULL, NULL, 154, NULL, NULL, 232065),
(252995, '4xiyA02', NULL, NULL, 157, NULL, NULL, 232065),
(252996, '4tskA02', NULL, NULL, 153, NULL, NULL, 232065),
(252997, '4xdyA02', NULL, NULL, 152, NULL, NULL, 232065),
(252998, '4xdzA02', NULL, NULL, 161, NULL, NULL, 232065),
(252999, '5yeqA02', NULL, NULL, 158, NULL, NULL, 232065),
(253000, '1np3A02', NULL, NULL, 157, NULL, NULL, 232065),
(253001, '4kqwA02', NULL, NULL, 158, NULL, NULL, 232065),
(253002, '5yeqB02', NULL, NULL, 158, NULL, NULL, 232065),
(253003, '6aqjA02', NULL, NULL, 159, NULL, NULL, 232065),
(253004, '5nqdA01', NULL, NULL, 172, NULL, NULL, 232066),
(253005, '1g8kA01', NULL, NULL, 173, NULL, NULL, 232066),
(253006, '1l1cA00', NULL, NULL, 55, NULL, NULL, 232067),
(253007, '3rioA01', NULL, NULL, 80, NULL, NULL, 232067),
(253008, '1auuA00', NULL, NULL, 55, NULL, NULL, 232067),
(253009, '2l0cA00', NULL, NULL, 97, NULL, NULL, 232068),
(253010, '3rd4B00', NULL, NULL, 100, NULL, NULL, 232068),
(253011, '3nlcA01', NULL, NULL, 91, NULL, NULL, 232069),
(253012, '4r55A00', NULL, NULL, 55, NULL, NULL, 232070),
(253013, '3kxtA00', NULL, NULL, 56, NULL, NULL, 232070),
(253014, '3cuqB01', NULL, NULL, 68, NULL, NULL, 232071),
(253015, '4n6qA00', NULL, NULL, 200, NULL, NULL, 232072),
(253016, '4n6rB00', NULL, NULL, 201, NULL, NULL, 232072),
(253017, '3pcrA01', NULL, NULL, 99, NULL, NULL, 232073),
(253018, '3q1cA01', NULL, NULL, 102, NULL, NULL, 232073),
(253019, '3ee1A01', NULL, NULL, 69, NULL, NULL, 232073),
(253020, '3eb8B01', NULL, NULL, 70, NULL, NULL, 232073),
(253021, '2kebA00', NULL, NULL, 78, NULL, NULL, 232074),
(253022, '3iwpH00', NULL, NULL, 249, NULL, NULL, 232075),
(253023, '4r9xA00', NULL, NULL, 233, NULL, NULL, 232075),
(253024, '1x7iA00', NULL, NULL, 256, NULL, NULL, 232075),
(253025, '2bdqA00', NULL, NULL, 224, NULL, NULL, 232075),
(253026, '1iq8A02', NULL, NULL, 70, NULL, NULL, 232076),
(253027, '2np9A01', NULL, NULL, 146, NULL, NULL, 232077),
(253028, '3bzcA03', NULL, NULL, 128, NULL, NULL, 232078),
(253029, '1vhxB00', NULL, NULL, 150, NULL, NULL, 232078),
(253030, '1nu0A00', NULL, NULL, 138, NULL, NULL, 232078),
(253031, '3psfA04', NULL, NULL, 164, NULL, NULL, 232078),
(253032, '1iv0A00', NULL, NULL, 98, NULL, NULL, 232078),
(253033, '1j5yA02', NULL, NULL, 108, NULL, NULL, 232079),
(253034, '4axsA00', NULL, NULL, 307, NULL, NULL, 232080),
(253035, '3l76A01', NULL, NULL, 259, NULL, NULL, 232080),
(253036, '1ybdC00', NULL, NULL, 239, NULL, NULL, 232080),
(253037, '3wwnA00', NULL, NULL, 269, NULL, NULL, 232080),
(253038, '1ybdA00', NULL, NULL, 239, NULL, NULL, 232080),
(253039, '3s6kA01', NULL, NULL, 287, NULL, NULL, 232080),
(253040, '2ap9B00', NULL, NULL, 299, NULL, NULL, 232080),
(253041, '2rd5A00', NULL, NULL, 281, NULL, NULL, 232080);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(253042, '2va1B00', NULL, NULL, 256, NULL, NULL, 232080),
(253043, '3ek6A00', NULL, NULL, 243, NULL, NULL, 232080),
(253044, '3tviA01', NULL, NULL, 279, NULL, NULL, 232080),
(253045, '2cdqA01', NULL, NULL, 204, NULL, NULL, 232080),
(253046, '2akoA00', NULL, NULL, 251, NULL, NULL, 232080),
(253047, '2we5A00', NULL, NULL, 310, NULL, NULL, 232080),
(253048, '4q1tB01', NULL, NULL, 273, NULL, NULL, 232080),
(253049, '2w21A00', NULL, NULL, 259, NULL, NULL, 232080),
(253050, '3l86A00', NULL, NULL, 245, NULL, NULL, 232080),
(253051, '2jjxA00', NULL, NULL, 255, NULL, NULL, 232080),
(253052, '5yeiA01', NULL, NULL, 243, NULL, NULL, 232080),
(253053, '1z9dA00', NULL, NULL, 252, NULL, NULL, 232080),
(253054, '2a1fC00', NULL, NULL, 247, NULL, NULL, 232080),
(253055, '2btyA00', NULL, NULL, 282, NULL, NULL, 232080),
(253056, '3c1mA01', NULL, NULL, 302, NULL, NULL, 232080),
(253057, '2v5hA00', NULL, NULL, 294, NULL, NULL, 232080),
(253058, '2ij9B00', NULL, NULL, 219, NULL, NULL, 232080),
(253059, '3s6gY01', NULL, NULL, 284, NULL, NULL, 232080),
(253060, '2j5vB01', NULL, NULL, 233, NULL, NULL, 232080),
(253061, '3aawC01', NULL, NULL, 244, NULL, NULL, 232080),
(253062, '4ndoA00', NULL, NULL, 245, NULL, NULL, 232080),
(253063, '3nwyB00', NULL, NULL, 236, NULL, NULL, 232080),
(253064, '2bnfA00', NULL, NULL, 241, NULL, NULL, 232080),
(253065, '2bufK00', NULL, NULL, 300, NULL, NULL, 232080),
(253066, '3zzhC00', NULL, NULL, 307, NULL, NULL, 232080),
(253067, '2brxA00', NULL, NULL, 226, NULL, NULL, 232080),
(253068, '1e19A00', NULL, NULL, 314, NULL, NULL, 232080),
(253069, '2j4jF00', NULL, NULL, 226, NULL, NULL, 232080),
(253070, '3d2mA01', NULL, NULL, 282, NULL, NULL, 232080),
(253071, '1ybdB00', NULL, NULL, 239, NULL, NULL, 232080),
(253072, '3k4oA00', NULL, NULL, 266, NULL, NULL, 232080),
(253073, '1gs5A00', NULL, NULL, 258, NULL, NULL, 232080),
(253074, '3t7bB00', NULL, NULL, 260, NULL, NULL, 232080),
(253075, '2bneB00', NULL, NULL, 241, NULL, NULL, 232080),
(253076, '3lkkB00', NULL, NULL, 249, NULL, NULL, 232080),
(253077, '2j0wA01', NULL, NULL, 200, NULL, NULL, 232080),
(253078, '4a7wA00', NULL, NULL, 240, NULL, NULL, 232080),
(253079, '3d40A00', NULL, NULL, 286, NULL, NULL, 232080),
(253080, '2e9yB00', NULL, NULL, 316, NULL, NULL, 232080),
(253081, '3ll9B00', NULL, NULL, 269, NULL, NULL, 232080),
(253082, '4ndoB00', NULL, NULL, 270, NULL, NULL, 232080),
(253083, '4jz8B00', NULL, NULL, 317, NULL, NULL, 232080),
(253084, '1nd7A01', NULL, NULL, 181, NULL, NULL, 232081),
(253085, '1zvdA01', NULL, NULL, 182, NULL, NULL, 232081),
(253086, '3jw0D01', NULL, NULL, 187, NULL, NULL, 232081),
(253087, '3olmA01', NULL, NULL, 231, NULL, NULL, 232081),
(253088, '2xbfA01', NULL, NULL, 188, NULL, NULL, 232081),
(253089, '2oniA01', NULL, NULL, 203, NULL, NULL, 232081),
(253090, '3h1dA01', NULL, NULL, 205, NULL, NULL, 232081),
(253091, '1c4zA01', NULL, NULL, 162, NULL, NULL, 232081),
(253092, '3tugA01', NULL, NULL, 181, NULL, NULL, 232081),
(253093, '3s13B01', NULL, NULL, 28, NULL, NULL, 232082),
(253094, '2ghjB01', NULL, NULL, 26, NULL, NULL, 232082),
(253095, '2ghjA01', NULL, NULL, 32, NULL, NULL, 232082),
(253096, '3l0iA02', NULL, NULL, 115, NULL, NULL, 232083),
(253097, '1ep3B03', NULL, NULL, 42, NULL, NULL, 232084),
(253098, '3rp8A02', NULL, NULL, 224, NULL, NULL, 232085),
(253099, '4bjyA02', NULL, NULL, 227, NULL, NULL, 232085),
(253100, '3c96A02', NULL, NULL, 239, NULL, NULL, 232085),
(253101, '3qyeB01', NULL, NULL, 82, NULL, NULL, 232086),
(253102, '3qybA01', NULL, NULL, 74, NULL, NULL, 232086),
(253103, '4od4A02', NULL, NULL, 126, NULL, NULL, 232087),
(253104, '5vkwA03', NULL, NULL, 41, NULL, NULL, 232088),
(253105, '5nx8B03', NULL, NULL, 41, NULL, NULL, 232088),
(253106, '5eytA03', NULL, NULL, 41, NULL, NULL, 232088),
(253107, '5v4lA03', NULL, NULL, 41, NULL, NULL, 232088),
(253108, '1zcdA00', NULL, NULL, 388, NULL, NULL, 232089),
(253109, '2pmvA02', NULL, NULL, 108, NULL, NULL, 232090),
(253110, '4kkiA02', NULL, NULL, 104, NULL, NULL, 232090),
(253111, '3u7zA00', NULL, NULL, 101, NULL, NULL, 232090),
(253112, '5nsaA00', NULL, NULL, 108, NULL, NULL, 232090);
INSERT INTO "PUBLIC"."MODEL" VALUES
(253113, '2bb6A02', NULL, NULL, 106, NULL, NULL, 232090),
(253114, '3l5oA01', NULL, NULL, 128, NULL, NULL, 232091),
(253115, '2fz4A01', NULL, NULL, 57, NULL, NULL, 232092),
(253116, '1m3gA00', NULL, NULL, 145, NULL, NULL, 232093),
(253117, '2bzlA00', NULL, NULL, 293, NULL, NULL, 232093),
(253118, '2fh7A01', NULL, NULL, 292, NULL, NULL, 232093),
(253119, '2i75A00', NULL, NULL, 291, NULL, NULL, 232093),
(253120, '5y15A00', NULL, NULL, 148, NULL, NULL, 232093),
(253121, '2jjdF02', NULL, NULL, 305, NULL, NULL, 232093),
(253122, '3n0aA01', NULL, NULL, 207, NULL, NULL, 232093),
(253123, '1wchA00', NULL, NULL, 315, NULL, NULL, 232093),
(253124, '5k23A00', NULL, NULL, 167, NULL, NULL, 232093),
(253125, '4jbcA02', NULL, NULL, 225, NULL, NULL, 232093),
(253126, '2cjzA00', NULL, NULL, 289, NULL, NULL, 232093),
(253127, '4ikcA00', NULL, NULL, 281, NULL, NULL, 232093),
(253128, '3i36A00', NULL, NULL, 286, NULL, NULL, 232093),
(253129, '2nt2A00', NULL, NULL, 145, NULL, NULL, 232093),
(253130, '1zc0A00', NULL, NULL, 309, NULL, NULL, 232093),
(253131, '1oheA01', NULL, NULL, 152, NULL, NULL, 232093),
(253132, '4y2eA00', NULL, NULL, 149, NULL, NULL, 232093),
(253133, '2gjtB00', NULL, NULL, 295, NULL, NULL, 232093),
(253134, '1oheA02', NULL, NULL, 169, NULL, NULL, 232093),
(253135, '1xriA00', NULL, NULL, 151, NULL, NULL, 232093),
(253136, '1ywfA00', NULL, NULL, 242, NULL, NULL, 232093),
(253137, '2ooqA00', NULL, NULL, 286, NULL, NULL, 232093),
(253138, '2y96A01', NULL, NULL, 167, NULL, NULL, 232093),
(253139, '4ge6A00', NULL, NULL, 314, NULL, NULL, 232093),
(253140, '2q05A00', NULL, NULL, 195, NULL, NULL, 232093),
(253141, '2i6jA00', NULL, NULL, 161, NULL, NULL, 232093),
(253142, '2fh7A02', NULL, NULL, 303, NULL, NULL, 232093),
(253143, '5hdeA00', NULL, NULL, 307, NULL, NULL, 232093),
(253144, '4yr8H00', NULL, NULL, 144, NULL, NULL, 232093),
(253145, '1d5rA01', NULL, NULL, 181, NULL, NULL, 232093),
(253146, '3s3eB00', NULL, NULL, 287, NULL, NULL, 232093),
(253147, '3ezzA00', NULL, NULL, 144, NULL, NULL, 232093),
(253148, '4nyhA00', NULL, NULL, 182, NULL, NULL, 232093),
(253149, '2cm2A00', NULL, NULL, 304, NULL, NULL, 232093),
(253150, '5ehrB03', NULL, NULL, 310, NULL, NULL, 232093),
(253151, '1yn9B00', NULL, NULL, 169, NULL, NULL, 232093),
(253152, '4wu3A01', NULL, NULL, 296, NULL, NULL, 232093),
(253153, '2r0bA00', NULL, NULL, 154, NULL, NULL, 232093),
(253154, '4wu3A03', NULL, NULL, 213, NULL, NULL, 232093),
(253155, '1larA02', NULL, NULL, 289, NULL, NULL, 232093),
(253156, '2nv5A00', NULL, NULL, 299, NULL, NULL, 232093),
(253157, '6h8sA00', NULL, NULL, 301, NULL, NULL, 232093),
(253158, '4tvvC00', NULL, NULL, 293, NULL, NULL, 232093),
(253159, '3emuA00', NULL, NULL, 161, NULL, NULL, 232093),
(253160, '3cweA00', NULL, NULL, 290, NULL, NULL, 232093),
(253161, '1yfoA00', NULL, NULL, 302, NULL, NULL, 232093),
(253162, '5bx1A00', NULL, NULL, 157, NULL, NULL, 232093),
(253163, '2esbA00', NULL, NULL, 171, NULL, NULL, 232093),
(253164, '2hxpA00', NULL, NULL, 155, NULL, NULL, 232093),
(253165, '1g4wR02', NULL, NULL, 225, NULL, NULL, 232093),
(253166, '4jmkA00', NULL, NULL, 152, NULL, NULL, 232093),
(253167, '1yz4B01', NULL, NULL, 153, NULL, NULL, 232093),
(253168, '1yguA02', NULL, NULL, 315, NULL, NULL, 232093),
(253169, '2p6xB00', NULL, NULL, 309, NULL, NULL, 232093),
(253170, '1fpzC00', NULL, NULL, 190, NULL, NULL, 232093),
(253171, '3v0dA01', NULL, NULL, 195, NULL, NULL, 232093),
(253172, '4wohA01', NULL, NULL, 159, NULL, NULL, 232093),
(253173, '4ki9A00', NULL, NULL, 163, NULL, NULL, 232093),
(253174, '2q05D00', NULL, NULL, 195, NULL, NULL, 232093),
(253175, '1mkpA00', NULL, NULL, 144, NULL, NULL, 232093),
(253176, '2i1yA00', NULL, NULL, 301, NULL, NULL, 232093),
(253177, '4ercA00', NULL, NULL, 150, NULL, NULL, 232093),
(253178, '5xjvB00', NULL, NULL, 185, NULL, NULL, 232093),
(253179, '3gxhA00', NULL, NULL, 157, NULL, NULL, 232093),
(253180, '1jlnA00', NULL, NULL, 297, NULL, NULL, 232093),
(253181, '2qepB00', NULL, NULL, 304, NULL, NULL, 232093),
(253182, '2oc3A00', NULL, NULL, 303, NULL, NULL, 232093),
(253183, '1i9sA00', NULL, NULL, 210, NULL, NULL, 232093);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(253184, '3rgoA00', NULL, NULL, 157, NULL, NULL, 232093),
(253185, '1larB01', NULL, NULL, 247, NULL, NULL, 232093),
(253186, '2j16B00', NULL, NULL, 145, NULL, NULL, 232093),
(253187, '2pi7B00', NULL, NULL, 296, NULL, NULL, 232093),
(253188, '2hc1A00', NULL, NULL, 291, NULL, NULL, 232093),
(253189, '4bjoA00', NULL, NULL, 298, NULL, NULL, 232093),
(253190, '4nx8B00', NULL, NULL, 261, NULL, NULL, 232093),
(253191, '4hrfA00', NULL, NULL, 160, NULL, NULL, 232093),
(253192, '4kyqA00', NULL, NULL, 208, NULL, NULL, 232093),
(253193, '3f81A00', NULL, NULL, 183, NULL, NULL, 232093),
(253194, '3cm3A00', NULL, NULL, 176, NULL, NULL, 232093),
(253195, '2p4dA00', NULL, NULL, 172, NULL, NULL, 232093),
(253196, '2hcmA01', NULL, NULL, 154, NULL, NULL, 232093),
(253197, '2q05C00', NULL, NULL, 175, NULL, NULL, 232093),
(253198, '2f46A00', NULL, NULL, 156, NULL, NULL, 232093),
(253199, '2c7sA00', NULL, NULL, 291, NULL, NULL, 232093),
(253200, '2pq5A00', NULL, NULL, 181, NULL, NULL, 232093),
(253201, '5ncrB00', NULL, NULL, 181, NULL, NULL, 232093),
(253202, '5awxA00', NULL, NULL, 298, NULL, NULL, 232093),
(253203, '2g6zA00', NULL, NULL, 147, NULL, NULL, 232093),
(253204, '4rkkA02', NULL, NULL, 193, NULL, NULL, 232093),
(253205, '2b49A00', NULL, NULL, 268, NULL, NULL, 232093),
(253206, '4r0sA00', NULL, NULL, 162, NULL, NULL, 232093),
(253207, '4az1B00', NULL, NULL, 302, NULL, NULL, 232093),
(253208, '5z59A00', NULL, NULL, 147, NULL, NULL, 232093),
(253209, '2h4vA00', NULL, NULL, 302, NULL, NULL, 232093),
(253210, '2jjdA01', NULL, NULL, 294, NULL, NULL, 232093),
(253211, '1l8kA00', NULL, NULL, 277, NULL, NULL, 232093),
(253212, '5m43A00', NULL, NULL, 175, NULL, NULL, 232093),
(253213, '1rpmA00', NULL, NULL, 278, NULL, NULL, 232093),
(253214, '4grzA00', NULL, NULL, 288, NULL, NULL, 232093),
(253215, '3mmjA02', NULL, NULL, 217, NULL, NULL, 232093),
(253216, '1p15B00', NULL, NULL, 253, NULL, NULL, 232093),
(253217, '3v0eA01', NULL, NULL, 180, NULL, NULL, 232093),
(253218, '5tsrA00', NULL, NULL, 172, NULL, NULL, 232093),
(253219, '4pyhA01', NULL, NULL, 203, NULL, NULL, 232093),
(253220, '3s4oA00', NULL, NULL, 167, NULL, NULL, 232093),
(253221, '2c46B00', NULL, NULL, 221, NULL, NULL, 232093),
(253222, '3zm1A00', NULL, NULL, 284, NULL, NULL, 232093),
(253223, '2wgpA00', NULL, NULL, 168, NULL, NULL, 232093),
(253224, '1zzwA00', NULL, NULL, 149, NULL, NULL, 232093),
(253225, '2q05B00', NULL, NULL, 195, NULL, NULL, 232093),
(253226, '3m4uB00', NULL, NULL, 306, NULL, NULL, 232093),
(253227, '2nlkA02', NULL, NULL, 288, NULL, NULL, 232093),
(253228, '1ygrB01', NULL, NULL, 295, NULL, NULL, 232093),
(253229, '4yaaA00', NULL, NULL, 282, NULL, NULL, 232093),
(253230, '3rz2A00', NULL, NULL, 161, NULL, NULL, 232093),
(253231, '4d3pA00', NULL, NULL, 147, NULL, NULL, 232093),
(253232, '5mmzB00', NULL, NULL, 157, NULL, NULL, 232093),
(253233, '3vtnA01', NULL, NULL, 32, NULL, NULL, 232094),
(253234, '2omzB00', NULL, NULL, 105, NULL, NULL, 232095),
(253235, '1l3wA01', NULL, NULL, 107, NULL, NULL, 232095),
(253236, '1l3wA04', NULL, NULL, 106, NULL, NULL, 232095),
(253237, '5dzwA04', NULL, NULL, 114, NULL, NULL, 232095),
(253238, '5dzwA03', NULL, NULL, 109, NULL, NULL, 232095),
(253239, '5szmA04', NULL, NULL, 114, NULL, NULL, 232095),
(253240, '1l3wA05', NULL, NULL, 107, NULL, NULL, 232095),
(253241, '1l3wA02', NULL, NULL, 112, NULL, NULL, 232095),
(253242, '1l3wA03', NULL, NULL, 114, NULL, NULL, 232095),
(253243, '3k6iA00', NULL, NULL, 99, NULL, NULL, 232095),
(253244, '5dzwA02', NULL, NULL, 107, NULL, NULL, 232095),
(253245, '5kj4C02', NULL, NULL, 122, NULL, NULL, 232095),
(253246, '5dzwA01', NULL, NULL, 99, NULL, NULL, 232095),
(253247, '5cyxA02', NULL, NULL, 118, NULL, NULL, 232095),
(253248, '5cyxA03', NULL, NULL, 121, NULL, NULL, 232095),
(253249, '5cyxA01', NULL, NULL, 88, NULL, NULL, 232095),
(253250, '5i8dA01', NULL, NULL, 116, NULL, NULL, 232095),
(253251, '5co1B02', NULL, NULL, 114, NULL, NULL, 232095),
(253252, '3k6dA00', NULL, NULL, 99, NULL, NULL, 232095),
(253253, '5szpA03', NULL, NULL, 104, NULL, NULL, 232095),
(253254, '5szpA04', NULL, NULL, 114, NULL, NULL, 232095);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(253255, '6cgbA01', NULL, NULL, 99, NULL, NULL, 232095),
(253256, '3ppeA02', NULL, NULL, 106, NULL, NULL, 232095),
(253257, '2v37A00', NULL, NULL, 105, NULL, NULL, 232095),
(253258, '3ppeA01', NULL, NULL, 97, NULL, NULL, 232095),
(253259, '2ystA01', NULL, NULL, 105, NULL, NULL, 232095),
(253260, '3q2wA03', NULL, NULL, 119, NULL, NULL, 232095),
(253261, '2a4eA02', NULL, NULL, 115, NULL, NULL, 232095),
(253262, '3q2wA05', NULL, NULL, 101, NULL, NULL, 232095),
(253263, '3q2wA04', NULL, NULL, 105, NULL, NULL, 232095),
(253264, '3lndB02', NULL, NULL, 108, NULL, NULL, 232095),
(253265, '5wj8A02', NULL, NULL, 120, NULL, NULL, 232095),
(253266, '5wj8A01', NULL, NULL, 105, NULL, NULL, 232095),
(253267, '5czrA02', NULL, NULL, 127, NULL, NULL, 232095),
(253268, '5szpA01', NULL, NULL, 98, NULL, NULL, 232095),
(253269, '5szpA02', NULL, NULL, 107, NULL, NULL, 232095),
(253270, '4zpsA02', NULL, NULL, 108, NULL, NULL, 232095),
(253271, '4zpsA03', NULL, NULL, 116, NULL, NULL, 232095),
(253272, '4nqqD02', NULL, NULL, 112, NULL, NULL, 232095),
(253273, '3q2vB03', NULL, NULL, 114, NULL, NULL, 232095),
(253274, '4zpsA01', NULL, NULL, 97, NULL, NULL, 232095),
(253275, '5tpkA01', NULL, NULL, 104, NULL, NULL, 232095),
(253276, '5tpkA02', NULL, NULL, 114, NULL, NULL, 232095),
(253277, '1wyjA01', NULL, NULL, 95, NULL, NULL, 232095),
(253278, '3k5sA02', NULL, NULL, 117, NULL, NULL, 232095),
(253279, '5co1C01', NULL, NULL, 105, NULL, NULL, 232095),
(253280, '3mvsA01', NULL, NULL, 102, NULL, NULL, 232095),
(253281, '3mvsA02', NULL, NULL, 108, NULL, NULL, 232095),
(253282, '5vh2A01', NULL, NULL, 106, NULL, NULL, 232095),
(253283, '6cg6A01', NULL, NULL, 99, NULL, NULL, 232095),
(253284, '2x2uA02', NULL, NULL, 108, NULL, NULL, 232095),
(253285, '2x2uA01', NULL, NULL, 123, NULL, NULL, 232095),
(253286, '5dzxB01', NULL, NULL, 100, NULL, NULL, 232095),
(253287, '1zxkA01', NULL, NULL, 94, NULL, NULL, 232095),
(253288, '5vh2A02', NULL, NULL, 114, NULL, NULL, 232095),
(253289, '1zvnA01', NULL, NULL, 94, NULL, NULL, 232095),
(253290, '4nuqA02', NULL, NULL, 114, NULL, NULL, 232095),
(253291, '4zi8A03', NULL, NULL, 108, NULL, NULL, 232095),
(253292, '4zi8A02', NULL, NULL, 108, NULL, NULL, 232095),
(253293, '4apxB02', NULL, NULL, 122, NULL, NULL, 232095),
(253294, '3ubhA04', NULL, NULL, 99, NULL, NULL, 232095),
(253295, '5dzyB01', NULL, NULL, 100, NULL, NULL, 232095),
(253296, '3q2vA04', NULL, NULL, 106, NULL, NULL, 232095),
(253297, '3q2vA05', NULL, NULL, 114, NULL, NULL, 232095),
(253298, '5kj4A01', NULL, NULL, 112, NULL, NULL, 232095),
(253299, '4nqqA01', NULL, NULL, 99, NULL, NULL, 232095),
(253300, '4zpmA01', NULL, NULL, 99, NULL, NULL, 232095),
(253301, '1op4A01', NULL, NULL, 89, NULL, NULL, 232095),
(253302, '5dzvB05', NULL, NULL, 120, NULL, NULL, 232095),
(253303, '5dzxA04', NULL, NULL, 113, NULL, NULL, 232095),
(253304, '5dzvB02', NULL, NULL, 110, NULL, NULL, 232095),
(253305, '6cgsA01', NULL, NULL, 99, NULL, NULL, 232095),
(253306, '5iu9A02', NULL, NULL, 107, NULL, NULL, 232095),
(253307, '5dzxA03', NULL, NULL, 105, NULL, NULL, 232095),
(253308, '5dzxA02', NULL, NULL, 107, NULL, NULL, 232095),
(253309, '4zpmA03', NULL, NULL, 119, NULL, NULL, 232095),
(253310, '5t9tA05', NULL, NULL, 120, NULL, NULL, 232095),
(253311, '4zi8B01', NULL, NULL, 118, NULL, NULL, 232095),
(253312, '5t9tA02', NULL, NULL, 110, NULL, NULL, 232095),
(253313, '5t9tA01', NULL, NULL, 95, NULL, NULL, 232095),
(253314, '5t9tA04', NULL, NULL, 106, NULL, NULL, 232095),
(253315, '5t9tA03', NULL, NULL, 104, NULL, NULL, 232095),
(253316, '6cg7A01', NULL, NULL, 99, NULL, NULL, 232095),
(253317, '5vt8D02', NULL, NULL, 119, NULL, NULL, 232095),
(253318, '3ubfA02', NULL, NULL, 113, NULL, NULL, 232095),
(253319, '3ubfA03', NULL, NULL, 106, NULL, NULL, 232095),
(253320, '5dzyA04', NULL, NULL, 114, NULL, NULL, 232095),
(253321, '5dzyA02', NULL, NULL, 107, NULL, NULL, 232095),
(253322, '4zplA03', NULL, NULL, 116, NULL, NULL, 232095),
(253323, '4zpoA01', NULL, NULL, 97, NULL, NULL, 232095),
(253324, '4zt1A02', NULL, NULL, 112, NULL, NULL, 232095),
(253325, '4zpoA02', NULL, NULL, 108, NULL, NULL, 232095);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(253326, '4zplA02', NULL, NULL, 108, NULL, NULL, 232095),
(253327, '4zpoA03', NULL, NULL, 119, NULL, NULL, 232095),
(253328, '4zplA01', NULL, NULL, 98, NULL, NULL, 232095),
(253329, '3qrbA02', NULL, NULL, 112, NULL, NULL, 232095),
(253330, '3qrbA01', NULL, NULL, 99, NULL, NULL, 232095),
(253331, '2ee0A01', NULL, NULL, 100, NULL, NULL, 232095),
(253332, '5tflB02', NULL, NULL, 123, NULL, NULL, 232095),
(253333, '4ak1A03', NULL, NULL, 102, NULL, NULL, 232095),
(253334, '4zi9A02', NULL, NULL, 108, NULL, NULL, 232095),
(253335, '4zi9A01', NULL, NULL, 99, NULL, NULL, 232095),
(253336, '4zi9A03', NULL, NULL, 111, NULL, NULL, 232095),
(253337, '2yqgA00', NULL, NULL, 123, NULL, NULL, 232095),
(253338, '5t4nB03', NULL, NULL, 105, NULL, NULL, 232095),
(253339, '5sznA02', NULL, NULL, 110, NULL, NULL, 232095),
(253340, '5sznA01', NULL, NULL, 97, NULL, NULL, 232095),
(253341, '5sznA04', NULL, NULL, 106, NULL, NULL, 232095),
(253342, '2omwB00', NULL, NULL, 105, NULL, NULL, 232095),
(253343, '5sznA05', NULL, NULL, 120, NULL, NULL, 232095),
(253344, '3ubgB01', NULL, NULL, 97, NULL, NULL, 232095),
(253345, '5dzvA03', NULL, NULL, 107, NULL, NULL, 232095),
(253346, '3k6fA00', NULL, NULL, 100, NULL, NULL, 232095),
(253347, '5dzvA04', NULL, NULL, 106, NULL, NULL, 232095),
(253348, '6cguA01', NULL, NULL, 99, NULL, NULL, 232095),
(253349, '4zpmB02', NULL, NULL, 108, NULL, NULL, 232095),
(253350, '1nciA00', NULL, NULL, 110, NULL, NULL, 232095),
(253351, '6bx7A02', NULL, NULL, 110, NULL, NULL, 232095),
(253352, '5k8rA01', NULL, NULL, 98, NULL, NULL, 232095),
(253353, '5k8rA02', NULL, NULL, 107, NULL, NULL, 232095),
(253354, '6bx7A03', NULL, NULL, 108, NULL, NULL, 232095),
(253355, '4zmyA02', NULL, NULL, 112, NULL, NULL, 232095),
(253356, '6bx7A04', NULL, NULL, 130, NULL, NULL, 232095),
(253357, '3k5rA02', NULL, NULL, 117, NULL, NULL, 232095),
(253358, '5czrB01', NULL, NULL, 98, NULL, NULL, 232095),
(253359, '4zmyA01', NULL, NULL, 99, NULL, NULL, 232095),
(253360, '5vt8C01', NULL, NULL, 102, NULL, NULL, 232095),
(253361, '5wjmA02', NULL, NULL, 118, NULL, NULL, 232095),
(253362, '5k8rA03', NULL, NULL, 106, NULL, NULL, 232095),
(253363, '5wjmA01', NULL, NULL, 107, NULL, NULL, 232095),
(253364, '5k8rA04', NULL, NULL, 103, NULL, NULL, 232095),
(253365, '1vqqA03', NULL, NULL, 70, NULL, NULL, 232096),
(253366, '4rg8A04', NULL, NULL, 62, NULL, NULL, 232097),
(253367, '3hl8A04', NULL, NULL, 62, NULL, NULL, 232097),
(253368, '4z49A02', NULL, NULL, 90, NULL, NULL, 232098),
(253369, '3ub1A01', NULL, NULL, 144, NULL, NULL, 232099),
(253370, '3ub1D02', NULL, NULL, 117, NULL, NULL, 232099),
(253371, '4ec6A00', NULL, NULL, 109, NULL, NULL, 232099),
(253372, '1iuqA01', NULL, NULL, 76, NULL, NULL, 232100),
(253373, '1cw5A00', NULL, NULL, 48, NULL, NULL, 232101),
(253374, '2a2bA00', NULL, NULL, 41, NULL, NULL, 232101),
(253375, '1ohnA00', NULL, NULL, 43, NULL, NULL, 232101),
(253376, '3c6fA02', NULL, NULL, 64, NULL, NULL, 232102),
(253377, '3c6fA01', NULL, NULL, 77, NULL, NULL, 232102),
(253378, '5gipA01', NULL, NULL, 134, NULL, NULL, 232103),
(253379, '3t7zA00', NULL, NULL, 119, NULL, NULL, 232103),
(253380, '2nnwA01', NULL, NULL, 135, NULL, NULL, 232103),
(253381, '3id6A01', NULL, NULL, 107, NULL, NULL, 232103),
(253382, '1c0aA03', NULL, NULL, 150, NULL, NULL, 232104),
(253383, '4ah6A03', NULL, NULL, 152, NULL, NULL, 232104),
(253384, '4wj4A03', NULL, NULL, 150, NULL, NULL, 232104),
(253385, '4rmfA03', NULL, NULL, 142, NULL, NULL, 232104),
(253386, '2d6fC02', NULL, NULL, 125, NULL, NULL, 232104),
(253387, '2p8tA02', NULL, NULL, 109, NULL, NULL, 232104),
(253388, '1l0wA03', NULL, NULL, 138, NULL, NULL, 232104),
(253389, '5w25A03', NULL, NULL, 142, NULL, NULL, 232104),
(253390, '1zq1C02', NULL, NULL, 131, NULL, NULL, 232104),
(253391, '4ix7A00', NULL, NULL, 115, NULL, NULL, 232105),
(253392, '4x0gB00', NULL, NULL, 109, NULL, NULL, 232105),
(253393, '1y55X00', NULL, NULL, 126, NULL, NULL, 232106),
(253394, '2zscA00', NULL, NULL, 124, NULL, NULL, 232106),
(253395, '2c1sA00', NULL, NULL, 126, NULL, NULL, 232106),
(253396, '3ew1E00', NULL, NULL, 135, NULL, NULL, 232106);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(253397, '1wbiB00', NULL, NULL, 129, NULL, NULL, 232106),
(253398, '4bcsB00', NULL, NULL, 125, NULL, NULL, 232106),
(253399, '4bx5A00', NULL, NULL, 138, NULL, NULL, 232106),
(253400, '5f2bA00', NULL, NULL, 134, NULL, NULL, 232106),
(253401, '4ggtB00', NULL, NULL, 115, NULL, NULL, 232106),
(253402, '3wyqB00', NULL, NULL, 127, NULL, NULL, 232106),
(253403, '3rdsA00', NULL, NULL, 129, NULL, NULL, 232106),
(253404, '6gmiA00', NULL, NULL, 156, NULL, NULL, 232106),
(253405, '6aueA00', NULL, NULL, 133, NULL, NULL, 232106),
(253406, '4ekvA00', NULL, NULL, 143, NULL, NULL, 232106),
(253407, '1moyA00', NULL, NULL, 130, NULL, NULL, 232106),
(253408, '4bj8K00', NULL, NULL, 126, NULL, NULL, 232106),
(253409, '2jgsB00', NULL, NULL, 130, NULL, NULL, 232106),
(253410, '2y3eA00', NULL, NULL, 134, NULL, NULL, 232106),
(253411, '4gdaB00', NULL, NULL, 131, NULL, NULL, 232106),
(253412, '2c4iA01', NULL, NULL, 132, NULL, NULL, 232106),
(253413, '2c4iA02', NULL, NULL, 135, NULL, NULL, 232106),
(253414, '4jnjA00', NULL, NULL, 115, NULL, NULL, 232106),
(253415, '1rxjA00', NULL, NULL, 121, NULL, NULL, 232106),
(253416, '2f01B00', NULL, NULL, 127, NULL, NULL, 232106),
(253417, '1vyoA00', NULL, NULL, 128, NULL, NULL, 232106),
(253418, '4bboA00', NULL, NULL, 118, NULL, NULL, 232106),
(253419, '5n8jB00', NULL, NULL, 120, NULL, NULL, 232106),
(253420, '3szhC00', NULL, NULL, 122, NULL, NULL, 232106),
(253421, '4z2oA00', NULL, NULL, 134, NULL, NULL, 232106),
(253422, '2uywA00', NULL, NULL, 130, NULL, NULL, 232106),
(253423, '6hdtB00', NULL, NULL, 133, NULL, NULL, 232106),
(253424, '4u46A00', NULL, NULL, 138, NULL, NULL, 232106),
(253425, '3ioxA01', NULL, NULL, 110, NULL, NULL, 232107),
(253426, '4hzeA00', NULL, NULL, 306, NULL, NULL, 232108),
(253427, '4q40D00', NULL, NULL, 347, NULL, NULL, 232108),
(253428, '2a0mA00', NULL, NULL, 316, NULL, NULL, 232108),
(253429, '1gq6B00', NULL, NULL, 313, NULL, NULL, 232108),
(253430, '4rhmA00', NULL, NULL, 308, NULL, NULL, 232108),
(253431, '6nfpA00', NULL, NULL, 299, NULL, NULL, 232108),
(253432, '2aebB00', NULL, NULL, 322, NULL, NULL, 232108),
(253433, '1wohA00', NULL, NULL, 305, NULL, NULL, 232108),
(253434, '3nioA00', NULL, NULL, 319, NULL, NULL, 232108),
(253435, '5hj9A00', NULL, NULL, 330, NULL, NULL, 232108),
(253436, '3m1rB01', NULL, NULL, 294, NULL, NULL, 232108),
(253437, '4dz4A00', NULL, NULL, 324, NULL, NULL, 232108),
(253438, '3lhlA00', NULL, NULL, 287, NULL, NULL, 232108),
(253439, '1xfkA00', NULL, NULL, 336, NULL, NULL, 232108),
(253440, '1d3vA00', NULL, NULL, 323, NULL, NULL, 232108),
(253441, '3niqB00', NULL, NULL, 326, NULL, NULL, 232108),
(253442, '2cevA00', NULL, NULL, 299, NULL, NULL, 232108),
(253443, '4rhiA00', NULL, NULL, 335, NULL, NULL, 232108),
(253444, '3pzlB00', NULL, NULL, 313, NULL, NULL, 232108),
(253445, '3sl1A00', NULL, NULL, 308, NULL, NULL, 232108),
(253446, '2ef5A00', NULL, NULL, 290, NULL, NULL, 232108),
(253447, '6nbkA00', NULL, NULL, 297, NULL, NULL, 232108),
(253448, '4g3hC00', NULL, NULL, 311, NULL, NULL, 232108),
(253449, '2m4gA00', NULL, NULL, 75, NULL, NULL, 232109),
(253450, '2gb7D00', NULL, NULL, 305, NULL, NULL, 232110),
(253451, '1na6B02', NULL, NULL, 227, NULL, NULL, 232110),
(253452, '3bm3A00', NULL, NULL, 272, NULL, NULL, 232110),
(253453, '1sr8A03', NULL, NULL, 90, NULL, NULL, 232111),
(253454, '5ktnA03', NULL, NULL, 82, NULL, NULL, 232112),
(253455, '4hheA01', NULL, NULL, 109, NULL, NULL, 232112),
(253456, '5ktnA02', NULL, NULL, 87, NULL, NULL, 232112),
(253457, '4hheA02', NULL, NULL, 105, NULL, NULL, 232112),
(253458, '5ktmA01', NULL, NULL, 104, NULL, NULL, 232112),
(253459, '4hheA03', NULL, NULL, 85, NULL, NULL, 232112),
(253460, '5f33A03', NULL, NULL, 84, NULL, NULL, 232112),
(253461, '5f33A02', NULL, NULL, 86, NULL, NULL, 232112),
(253462, '5f33A01', NULL, NULL, 103, NULL, NULL, 232112),
(253463, '2dpmA02', NULL, NULL, 103, NULL, NULL, 232113),
(253464, '2g1pA02', NULL, NULL, 100, NULL, NULL, 232113),
(253465, '1yf3A02', NULL, NULL, 95, NULL, NULL, 232113),
(253466, '5dmzA01', NULL, NULL, 63, NULL, NULL, 232114),
(253467, '6f7bA01', NULL, NULL, 59, NULL, NULL, 232114);
INSERT INTO "PUBLIC"."MODEL" VALUES
(253468, '4qpmA01', NULL, NULL, 54, NULL, NULL, 232114),
(253469, '1o0sA02', NULL, NULL, 108, NULL, NULL, 232115),
(253470, '3rfzB04', NULL, NULL, 91, NULL, NULL, 232116),
(253471, '2ap3A00', NULL, NULL, 199, NULL, NULL, 232117),
(253472, '1iuqA02', NULL, NULL, 282, NULL, NULL, 232118),
(253473, '1mg7A01', NULL, NULL, 182, NULL, NULL, 232119),
(253474, '1vwxi01', NULL, NULL, 72, NULL, NULL, 232120),
(253475, '6em3i00', NULL, NULL, 74, NULL, NULL, 232120),
(253476, '4a18Q01', NULL, NULL, 70, NULL, NULL, 232120),
(253477, '1vx7b00', NULL, NULL, 112, NULL, NULL, 232120),
(253478, '5dnyA02', NULL, NULL, 58, NULL, NULL, 232121),
(253479, '1xu1A00', NULL, NULL, 138, NULL, NULL, 232122),
(253480, '4qpyB00', NULL, NULL, 136, NULL, NULL, 232122),
(253481, '1dg6A00', NULL, NULL, 162, NULL, NULL, 232122),
(253482, '1alyA00', NULL, NULL, 146, NULL, NULL, 232122),
(253483, '2rjlA01', NULL, NULL, 157, NULL, NULL, 232122),
(253484, '5ybzA00', NULL, NULL, 138, NULL, NULL, 232122),
(253485, '4d7yA00', NULL, NULL, 146, NULL, NULL, 232122),
(253486, '4f3jA00', NULL, NULL, 148, NULL, NULL, 232122),
(253487, '2zjcA00', NULL, NULL, 157, NULL, NULL, 232122),
(253488, '2hevF00', NULL, NULL, 137, NULL, NULL, 232122),
(253489, '2ka3A00', NULL, NULL, 162, NULL, NULL, 232122),
(253490, '3urfA00', NULL, NULL, 162, NULL, NULL, 232122),
(253491, '6mgpA00', NULL, NULL, 153, NULL, NULL, 232122),
(253492, '6mkbA00', NULL, NULL, 171, NULL, NULL, 232122),
(253493, '4douA02', NULL, NULL, 148, NULL, NULL, 232122),
(253494, '2q8oA00', NULL, NULL, 136, NULL, NULL, 232122),
(253495, '2wnvB00', NULL, NULL, 136, NULL, NULL, 232122),
(253496, '4mxwD00', NULL, NULL, 166, NULL, NULL, 232122),
(253497, '2wnvD00', NULL, NULL, 134, NULL, NULL, 232122),
(253498, '2wnvC00', NULL, NULL, 131, NULL, NULL, 232122),
(253499, '4ousA00', NULL, NULL, 143, NULL, NULL, 232122),
(253500, '5hbaA00', NULL, NULL, 134, NULL, NULL, 232122),
(253501, '2z5wA00', NULL, NULL, 136, NULL, NULL, 232122),
(253502, '4oumA00', NULL, NULL, 140, NULL, NULL, 232122),
(253503, '2tnfA00', NULL, NULL, 156, NULL, NULL, 232122),
(253504, '2e7aB00', NULL, NULL, 157, NULL, NULL, 232122),
(253505, '5l19A00', NULL, NULL, 153, NULL, NULL, 232122),
(253506, '1kxgA00', NULL, NULL, 152, NULL, NULL, 232122),
(253507, '2hewF00', NULL, NULL, 152, NULL, NULL, 232122),
(253508, '3b93A00', NULL, NULL, 133, NULL, NULL, 232122),
(253509, '1s55A00', NULL, NULL, 156, NULL, NULL, 232122),
(253510, '5h4cB00', NULL, NULL, 135, NULL, NULL, 232122),
(253511, '4qqhA00', NULL, NULL, 137, NULL, NULL, 232122),
(253512, '4g4fA00', NULL, NULL, 126, NULL, NULL, 232122),
(253513, '5kwrA00', NULL, NULL, 143, NULL, NULL, 232122),
(253514, '4rsuB00', NULL, NULL, 165, NULL, NULL, 232122),
(253515, '4ht1T00', NULL, NULL, 154, NULL, NULL, 232122),
(253516, '4db5A00', NULL, NULL, 125, NULL, NULL, 232122),
(253517, '1gr3A00', NULL, NULL, 132, NULL, NULL, 232122),
(253518, '4kgqA00', NULL, NULL, 158, NULL, NULL, 232122),
(253519, '1c3hA00', NULL, NULL, 137, NULL, NULL, 232122),
(253520, '4e4sE00', NULL, NULL, 125, NULL, NULL, 232122),
(253521, '1rj8A00', NULL, NULL, 142, NULL, NULL, 232122),
(253522, '1tnrA00', NULL, NULL, 144, NULL, NULL, 232122),
(253523, '1o91A00', NULL, NULL, 131, NULL, NULL, 232122),
(253524, '5uuiA00', NULL, NULL, 158, NULL, NULL, 232122),
(253525, '4tsvA00', NULL, NULL, 150, NULL, NULL, 232122),
(253526, '2jwyA01', NULL, NULL, 135, NULL, NULL, 232123),
(253527, '4c47A01', NULL, NULL, 136, NULL, NULL, 232123),
(253528, '2w02B07', NULL, NULL, 26, NULL, NULL, 232124),
(253529, '1ow1A00', NULL, NULL, 170, NULL, NULL, 232125),
(253530, '1jeyA02', NULL, NULL, 126, NULL, NULL, 232125),
(253531, '1jeyB02', NULL, NULL, 201, NULL, NULL, 232125),
(253532, '3if8A02', NULL, NULL, 78, NULL, NULL, 232126),
(253533, '3zwcA03', NULL, NULL, 238, NULL, NULL, 232127),
(253534, '3k6jA02', NULL, NULL, 208, NULL, NULL, 232127),
(253535, '2wtbA03', NULL, NULL, 215, NULL, NULL, 232127),
(253536, '6iumA03', NULL, NULL, 225, NULL, NULL, 232127),
(253537, '3mogC02', NULL, NULL, 199, NULL, NULL, 232127),
(253538, '1wdkB03', NULL, NULL, 212, NULL, NULL, 232127);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(253539, '4b3hA03', NULL, NULL, 212, NULL, NULL, 232127),
(253540, '2npmB00', NULL, NULL, 237, NULL, NULL, 232128),
(253541, '5n10A00', NULL, NULL, 246, NULL, NULL, 232128),
(253542, '5lhoA00', NULL, NULL, 235, NULL, NULL, 232128),
(253543, '4dx0A00', NULL, NULL, 243, NULL, NULL, 232128),
(253544, '5yqgD00', NULL, NULL, 252, NULL, NULL, 232128),
(253545, '2o8pA00', NULL, NULL, 227, NULL, NULL, 232128),
(253546, '4zdrB00', NULL, NULL, 266, NULL, NULL, 232128),
(253547, '5nwjA00', NULL, NULL, 245, NULL, NULL, 232128),
(253548, '3axyJ00', NULL, NULL, 240, NULL, NULL, 232128),
(253549, '5lu1F00', NULL, NULL, 234, NULL, NULL, 232128),
(253550, '3efzB00', NULL, NULL, 239, NULL, NULL, 232128),
(253551, '6bcrA00', NULL, NULL, 245, NULL, NULL, 232128),
(253552, '2br9A00', NULL, NULL, 234, NULL, NULL, 232128),
(253553, '5n6nA00', NULL, NULL, 240, NULL, NULL, 232128),
(253554, '4dnkB00', NULL, NULL, 247, NULL, NULL, 232128),
(253555, '4zq0D00', NULL, NULL, 234, NULL, NULL, 232128),
(253556, '3iquA00', NULL, NULL, 236, NULL, NULL, 232128),
(253557, '2o02B00', NULL, NULL, 230, NULL, NULL, 232128),
(253558, '3uzdA00', NULL, NULL, 248, NULL, NULL, 232128),
(253559, '2dgyA02', NULL, NULL, 32, NULL, NULL, 232129),
(253560, '2kjzA01', NULL, NULL, 54, NULL, NULL, 232130),
(253561, '3sk1C01', NULL, NULL, 62, NULL, NULL, 232130),
(253562, '3itwB01', NULL, NULL, 67, NULL, NULL, 232130),
(253563, '3vcxA01', NULL, NULL, 54, NULL, NULL, 232130),
(253564, '2vkcA00', NULL, NULL, 105, NULL, NULL, 232131),
(253565, '3fauB00', NULL, NULL, 82, NULL, NULL, 232131),
(253566, '2zqeA00', NULL, NULL, 83, NULL, NULL, 232131),
(253567, '3qd7X00', NULL, NULL, 137, NULL, NULL, 232131),
(253568, '4od6A00', NULL, NULL, 90, NULL, NULL, 232131),
(253569, '6g94A00', NULL, NULL, 207, NULL, NULL, 232132),
(253570, '1kqfC00', NULL, NULL, 217, NULL, NULL, 232132),
(253571, '1y5iC01', NULL, NULL, 216, NULL, NULL, 232132),
(253572, '2ch0A01', NULL, NULL, 98, NULL, NULL, 232133),
(253573, '2vkhA03', NULL, NULL, 69, NULL, NULL, 232134),
(253574, '5uqmA03', NULL, NULL, 69, NULL, NULL, 232134),
(253575, '2bl0A00', NULL, NULL, 63, NULL, NULL, 232135),
(253576, '1wdcA00', NULL, NULL, 64, NULL, NULL, 232135),
(253577, '4ofzA03', NULL, NULL, 96, NULL, NULL, 232136),
(253578, '4cfiA01', NULL, NULL, 148, NULL, NULL, 232137),
(253579, '3pwxA01', NULL, NULL, 199, NULL, NULL, 232137),
(253580, '5gy2C00', NULL, NULL, 183, NULL, NULL, 232137),
(253581, '4nx9A01', NULL, NULL, 171, NULL, NULL, 232137),
(253582, '1io1A01', NULL, NULL, 172, NULL, NULL, 232137),
(253583, '3k8wA01', NULL, NULL, 194, NULL, NULL, 232137),
(253584, '2d4xA00', NULL, NULL, 225, NULL, NULL, 232137),
(253585, '5kayA00', NULL, NULL, 201, NULL, NULL, 232137),
(253586, '3k8vA01', NULL, NULL, 219, NULL, NULL, 232137),
(253587, '5mawD00', NULL, NULL, 260, NULL, NULL, 232137),
(253588, '3v47D01', NULL, NULL, 168, NULL, NULL, 232137),
(253589, '3ksrA01', NULL, NULL, 27, NULL, NULL, 232138),
(253590, '2qsfA02', NULL, NULL, 58, NULL, NULL, 232139),
(253591, '2r2zA00', NULL, NULL, 93, NULL, NULL, 232140),
(253592, '2p13A00', NULL, NULL, 90, NULL, NULL, 232140),
(253593, '5d79A02', NULL, NULL, 213, NULL, NULL, 232140),
(253594, '2bvfA02', NULL, NULL, 141, NULL, NULL, 232140),
(253595, '2gqtA02', NULL, NULL, 121, NULL, NULL, 232140),
(253596, '2nqwA00', NULL, NULL, 93, NULL, NULL, 232140),
(253597, '5awvA01', NULL, NULL, 236, NULL, NULL, 232140),
(253598, '2uuuA02', NULL, NULL, 231, NULL, NULL, 232140),
(253599, '4ud8A02', NULL, NULL, 206, NULL, NULL, 232140),
(253600, '2y3sB01', NULL, NULL, 231, NULL, NULL, 232140),
(253601, '3hsuA01', NULL, NULL, 249, NULL, NULL, 232140),
(253602, '2w3sA04', NULL, NULL, 114, NULL, NULL, 232140),
(253603, '3pm9A02', NULL, NULL, 122, NULL, NULL, 232140),
(253604, '4pytA02', NULL, NULL, 128, NULL, NULL, 232140),
(253605, '1e8gA02', NULL, NULL, 111, NULL, NULL, 232140),
(253606, '6c80A02', NULL, NULL, 127, NULL, NULL, 232140),
(253607, '2oaiA00', NULL, NULL, 94, NULL, NULL, 232140),
(253608, '2vfrA02', NULL, NULL, 130, NULL, NULL, 232140),
(253609, '1zr6A02', NULL, NULL, 141, NULL, NULL, 232140);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(253610, '2exrA02', NULL, NULL, 128, NULL, NULL, 232140),
(253611, '3llbA00', NULL, NULL, 83, NULL, NULL, 232140),
(253612, '2p3hA00', NULL, NULL, 101, NULL, NULL, 232140),
(253613, '6foqA02', NULL, NULL, 140, NULL, NULL, 232140),
(253614, '2pliA00', NULL, NULL, 91, NULL, NULL, 232140),
(253615, '2p4pA00', NULL, NULL, 86, NULL, NULL, 232140),
(253616, '1t3qC02', NULL, NULL, 118, NULL, NULL, 232140),
(253617, '2e1qC04', NULL, NULL, 130, NULL, NULL, 232140),
(253618, '3js8A02', NULL, NULL, 128, NULL, NULL, 232140),
(253619, '2i0kA02', NULL, NULL, 126, NULL, NULL, 232140),
(253620, '3tx1A02', NULL, NULL, 127, NULL, NULL, 232140),
(253621, '2ipiA01', NULL, NULL, 231, NULL, NULL, 232140),
(253622, '4mlaA02', NULL, NULL, 121, NULL, NULL, 232140),
(253623, '1w1oA02', NULL, NULL, 127, NULL, NULL, 232140),
(253624, '1hskA01', NULL, NULL, 127, NULL, NULL, 232140),
(253625, '4jb1A02', NULL, NULL, 154, NULL, NULL, 232140),
(253626, '4dnsA02', NULL, NULL, 210, NULL, NULL, 232140),
(253627, '4bbyA03', NULL, NULL, 121, NULL, NULL, 232140),
(253628, '3rjaA01', NULL, NULL, 244, NULL, NULL, 232140),
(253629, '3i99A02', NULL, NULL, 149, NULL, NULL, 232140),
(253630, '3popA01', NULL, NULL, 237, NULL, NULL, 232140),
(253631, '3laeA00', NULL, NULL, 81, NULL, NULL, 232140),
(253632, '2o3gA00', NULL, NULL, 76, NULL, NULL, 232140),
(253633, '6eo5B01', NULL, NULL, 262, NULL, NULL, 232140),
(253634, '3dedC00', NULL, NULL, 91, NULL, NULL, 232140),
(253635, '2yvsA01', NULL, NULL, 114, NULL, NULL, 232140),
(253636, '1n62C03', NULL, NULL, 115, NULL, NULL, 232140),
(253637, '3an1A04', NULL, NULL, 130, NULL, NULL, 232140),
(253638, '3nvwB02', NULL, NULL, 126, NULL, NULL, 232140),
(253639, '4pvkA02', NULL, NULL, 214, NULL, NULL, 232140),
(253640, '2plsA00', NULL, NULL, 86, NULL, NULL, 232140),
(253641, '5fxdA02', NULL, NULL, 127, NULL, NULL, 232140),
(253642, '5l6gA01', NULL, NULL, 244, NULL, NULL, 232140),
(253643, '3vteA02', NULL, NULL, 218, NULL, NULL, 232140),
(253644, '4o95A02', NULL, NULL, 132, NULL, NULL, 232140),
(253645, '5jzxD02', NULL, NULL, 153, NULL, NULL, 232140),
(253646, '5i1vC01', NULL, NULL, 234, NULL, NULL, 232140),
(253647, '2rk5A00', NULL, NULL, 87, NULL, NULL, 232140),
(253648, '2p4pB00', NULL, NULL, 86, NULL, NULL, 232140),
(253649, '1ffvC03', NULL, NULL, 114, NULL, NULL, 232140),
(253650, '1uxyA03', NULL, NULL, 150, NULL, NULL, 232140),
(253651, '4hg0A02', NULL, NULL, 95, NULL, NULL, 232140),
(253652, '4zohB02', NULL, NULL, 109, NULL, NULL, 232140),
(253653, '1f0xA03', NULL, NULL, 163, NULL, NULL, 232140),
(253654, '3fw9A02', NULL, NULL, 211, NULL, NULL, 232140),
(253655, '1wvfA02', NULL, NULL, 128, NULL, NULL, 232140),
(253656, '2a1sC02', NULL, NULL, 99, NULL, NULL, 232141),
(253657, '1whrA00', NULL, NULL, 124, NULL, NULL, 232141),
(253658, '1ug8A00', NULL, NULL, 87, NULL, NULL, 232141),
(253659, '2cpmA00', NULL, NULL, 94, NULL, NULL, 232141),
(253660, '2a1sA02', NULL, NULL, 76, NULL, NULL, 232141),
(253661, '2lrrA00', NULL, NULL, 86, NULL, NULL, 232141),
(253662, '3gkuA03', NULL, NULL, 85, NULL, NULL, 232141),
(253663, '4f15J02', NULL, NULL, 58, NULL, NULL, 232142),
(253664, '1uzrB00', NULL, NULL, 296, NULL, NULL, 232143),
(253665, '4bmoA00', NULL, NULL, 290, NULL, NULL, 232143),
(253666, '2rccA01', NULL, NULL, 259, NULL, NULL, 232143),
(253667, '1r2fA00', NULL, NULL, 288, NULL, NULL, 232143),
(253668, '1za0A00', NULL, NULL, 275, NULL, NULL, 232143),
(253669, '2uw1B00', NULL, NULL, 338, NULL, NULL, 232143),
(253670, '2innD00', NULL, NULL, 333, NULL, NULL, 232143),
(253671, '3ge3B00', NULL, NULL, 306, NULL, NULL, 232143),
(253672, '2innC00', NULL, NULL, 333, NULL, NULL, 232143),
(253673, '1mxrA00', NULL, NULL, 339, NULL, NULL, 232143),
(253674, '1h0oA00', NULL, NULL, 288, NULL, NULL, 232143),
(253675, '4n83A00', NULL, NULL, 287, NULL, NULL, 232143),
(253676, '3oljA00', NULL, NULL, 286, NULL, NULL, 232143),
(253677, '2o1zA01', NULL, NULL, 279, NULL, NULL, 232143),
(253678, '4dr0B00', NULL, NULL, 291, NULL, NULL, 232143),
(253679, '4m1hB00', NULL, NULL, 348, NULL, NULL, 232143),
(253680, '3chtA00', NULL, NULL, 313, NULL, NULL, 232143);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(253681, '3n37A00', NULL, NULL, 288, NULL, NULL, 232143),
(253682, '3u52D00', NULL, NULL, 333, NULL, NULL, 232143),
(253683, '4a5hA00', NULL, NULL, 271, NULL, NULL, 232143),
(253684, '5hyhA00', NULL, NULL, 317, NULL, NULL, 232143),
(253685, '3u52B00', NULL, NULL, 511, NULL, NULL, 232143),
(253686, '3mjoA00', NULL, NULL, 296, NULL, NULL, 232143),
(253687, '3pf7B00', NULL, NULL, 481, NULL, NULL, 232143),
(253688, '1oq4A00', NULL, NULL, 346, NULL, NULL, 232143),
(253689, '1mtyB00', NULL, NULL, 384, NULL, NULL, 232143),
(253690, '1jk0A00', NULL, NULL, 334, NULL, NULL, 232143),
(253691, '1mtyD00', NULL, NULL, 512, NULL, NULL, 232143),
(253692, '6f6mB00', NULL, NULL, 284, NULL, NULL, 232143),
(253693, '1mhyD00', NULL, NULL, 521, NULL, NULL, 232143),
(253694, '2incA00', NULL, NULL, 491, NULL, NULL, 232143),
(253695, '2incB00', NULL, NULL, 322, NULL, NULL, 232143),
(253696, '1mhyB00', NULL, NULL, 395, NULL, NULL, 232143),
(253697, '3ge3A00', NULL, NULL, 500, NULL, NULL, 232143),
(253698, '1smsA00', NULL, NULL, 325, NULL, NULL, 232143),
(253699, '4djnA00', NULL, NULL, 295, NULL, NULL, 232143),
(253700, '6qrzA00', NULL, NULL, 285, NULL, NULL, 232143),
(253701, '3ee4A00', NULL, NULL, 299, NULL, NULL, 232143),
(253702, '3aahB00', NULL, NULL, 57, NULL, NULL, 232144),
(253703, '1lrwB00', NULL, NULL, 83, NULL, NULL, 232144),
(253704, '4tqoI00', NULL, NULL, 72, NULL, NULL, 232144),
(253705, '2ad6B00', NULL, NULL, 69, NULL, NULL, 232144),
(253706, '2d0vE00', NULL, NULL, 72, NULL, NULL, 232144),
(253707, '5xm3B00', NULL, NULL, 66, NULL, NULL, 232144),
(253708, '1w6sB00', NULL, NULL, 74, NULL, NULL, 232144),
(253709, '1d2tA00', NULL, NULL, 231, NULL, NULL, 232145),
(253710, '3bb0A01', NULL, NULL, 178, NULL, NULL, 232145),
(253711, '4px7A00', NULL, NULL, 262, NULL, NULL, 232145),
(253712, '2ipbA00', NULL, NULL, 230, NULL, NULL, 232145),
(253713, '4muqA01', NULL, NULL, 104, NULL, NULL, 232146),
(253714, '2l9nA01', NULL, NULL, 96, NULL, NULL, 232147),
(253715, '1t95A01', NULL, NULL, 80, NULL, NULL, 232147),
(253716, '2wbmA01', NULL, NULL, 81, NULL, NULL, 232147),
(253717, '1nynA00', NULL, NULL, 111, NULL, NULL, 232147),
(253718, '2uv9A02', NULL, NULL, 56, NULL, NULL, 232148),
(253719, '2uv8A03', NULL, NULL, 56, NULL, NULL, 232148),
(253720, '6ensA00', NULL, NULL, 193, NULL, NULL, 232149),
(253721, '2r77A00', NULL, NULL, 205, NULL, NULL, 232149),
(253722, '1vw4102', NULL, NULL, 217, NULL, NULL, 232149),
(253723, '3axyA00', NULL, NULL, 170, NULL, NULL, 232149),
(253724, '1behB00', NULL, NULL, 187, NULL, NULL, 232149),
(253725, '2evvB00', NULL, NULL, 184, NULL, NULL, 232149),
(253726, '1fjjA00', NULL, NULL, 159, NULL, NULL, 232149),
(253727, '1qouB00', NULL, NULL, 181, NULL, NULL, 232149),
(253728, '1kn3A00', NULL, NULL, 183, NULL, NULL, 232149),
(253729, '4begB00', NULL, NULL, 178, NULL, NULL, 232149),
(253730, '1wkoA00', NULL, NULL, 180, NULL, NULL, 232149),
(253731, '1fuxA00', NULL, NULL, 166, NULL, NULL, 232149),
(253732, '3n08B00', NULL, NULL, 153, NULL, NULL, 232149),
(253733, '1wkpA00', NULL, NULL, 171, NULL, NULL, 232149),
(253734, '2jyzA00', NULL, NULL, 179, NULL, NULL, 232149),
(253735, '2gzqA00', NULL, NULL, 200, NULL, NULL, 232149),
(253736, '2iqyA00', NULL, NULL, 190, NULL, NULL, 232149),
(253737, '1wpxB00', NULL, NULL, 220, NULL, NULL, 232149),
(253738, '1a44A00', NULL, NULL, 185, NULL, NULL, 232149),
(253739, '5tvdA00', NULL, NULL, 195, NULL, NULL, 232149),
(253740, '3ha4B00', NULL, NULL, 131, NULL, NULL, 232150),
(253741, '2i6hA01', NULL, NULL, 82, NULL, NULL, 232151),
(253742, '2gmhA02', NULL, NULL, 203, NULL, NULL, 232152),
(253743, '3euaA03', NULL, NULL, 94, NULL, NULL, 232153),
(253744, '3fkjA03', NULL, NULL, 94, NULL, NULL, 232153),
(253745, '4ok9A00', NULL, NULL, 149, NULL, NULL, 232154),
(253746, '1wpuA00', NULL, NULL, 147, NULL, NULL, 232154),
(253747, '2v05A01', NULL, NULL, 128, NULL, NULL, 232155),
(253748, '1mw5A01', NULL, NULL, 145, NULL, NULL, 232156),
(253749, '3uc9A00', NULL, NULL, 184, NULL, NULL, 232157),
(253750, '2gmqA00', NULL, NULL, 118, NULL, NULL, 232158),
(253751, '1h7cA00', NULL, NULL, 108, NULL, NULL, 232159);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(253752, '3p7iA03', NULL, NULL, 62, NULL, NULL, 232159),
(253753, '4cqiA00', NULL, NULL, 107, NULL, NULL, 232159),
(253754, '1zkeA00', NULL, NULL, 83, NULL, NULL, 232159),
(253755, '2mbgA02', NULL, NULL, 66, NULL, NULL, 232159),
(253756, '4fi5A00', NULL, NULL, 71, NULL, NULL, 232159),
(253757, '1ij5A01', NULL, NULL, 80, NULL, NULL, 232159),
(253758, '3mxzA00', NULL, NULL, 116, NULL, NULL, 232159),
(253759, '3fxdB00', NULL, NULL, 73, NULL, NULL, 232159),
(253760, '2xtlA04', NULL, NULL, 64, NULL, NULL, 232159),
(253761, '2x9xA04', NULL, NULL, 60, NULL, NULL, 232159),
(253762, '1qsdA00', NULL, NULL, 106, NULL, NULL, 232159),
(253763, '1lrzA03', NULL, NULL, 62, NULL, NULL, 232159),
(253764, '2g0uA01', NULL, NULL, 70, NULL, NULL, 232159),
(253765, '1lvfB00', NULL, NULL, 110, NULL, NULL, 232159),
(253766, '2k48A01', NULL, NULL, 78, NULL, NULL, 232159),
(253767, '4l0rB00', NULL, NULL, 79, NULL, NULL, 232159),
(253768, '1z0pA00', NULL, NULL, 84, NULL, NULL, 232159),
(253769, '3ckdA03', NULL, NULL, 77, NULL, NULL, 232159),
(253770, '3tklB01', NULL, NULL, 62, NULL, NULL, 232159),
(253771, '3l3pA03', NULL, NULL, 78, NULL, NULL, 232159),
(253772, '2ic6A00', NULL, NULL, 78, NULL, NULL, 232159),
(253773, '4j2cC00', NULL, NULL, 110, NULL, NULL, 232159),
(253774, '2ca5B00', NULL, NULL, 85, NULL, NULL, 232159),
(253775, '2ca5A00', NULL, NULL, 66, NULL, NULL, 232159),
(253776, '2c5jA00', NULL, NULL, 95, NULL, NULL, 232159),
(253777, '2kwhA00', NULL, NULL, 56, NULL, NULL, 232159),
(253778, '3n5lA03', NULL, NULL, 60, NULL, NULL, 232159),
(253779, '4dndA00', NULL, NULL, 104, NULL, NULL, 232159),
(253780, '4b6xA00', NULL, NULL, 69, NULL, NULL, 232159),
(253781, '3esmA00', NULL, NULL, 152, NULL, NULL, 232160),
(253782, '3vtiA07', NULL, NULL, 147, NULL, NULL, 232161),
(253783, '6az1E02', NULL, NULL, 51, NULL, NULL, 232162),
(253784, '4bpnW02', NULL, NULL, 51, NULL, NULL, 232162),
(253785, '3j7aF02', NULL, NULL, 51, NULL, NULL, 232162),
(253786, '5optL02', NULL, NULL, 51, NULL, NULL, 232162),
(253787, '5xxuE02', NULL, NULL, 51, NULL, NULL, 232162),
(253788, '5flxE02', NULL, NULL, 51, NULL, NULL, 232162),
(253789, '6faiE02', NULL, NULL, 51, NULL, NULL, 232162),
(253790, '3jamE02', NULL, NULL, 51, NULL, NULL, 232162),
(253791, '5xyiE02', NULL, NULL, 51, NULL, NULL, 232162),
(253792, '6g5iE02', NULL, NULL, 51, NULL, NULL, 232162),
(253793, '3kbgA02', NULL, NULL, 53, NULL, NULL, 232162),
(253794, '2d2sA02', NULL, NULL, 104, NULL, NULL, 232163),
(253795, '3f2bA04', NULL, NULL, 75, NULL, NULL, 232164),
(253796, '2lh9A00', NULL, NULL, 78, NULL, NULL, 232165),
(253797, '2ly1A03', NULL, NULL, 81, NULL, NULL, 232165),
(253798, '3s93A00', NULL, NULL, 80, NULL, NULL, 232165),
(253799, '2ly1A01', NULL, NULL, 79, NULL, NULL, 232165),
(253800, '2kzvA01', NULL, NULL, 73, NULL, NULL, 232165),
(253801, '2kpmA01', NULL, NULL, 75, NULL, NULL, 232165),
(253802, '3rcoB00', NULL, NULL, 89, NULL, NULL, 232165),
(253803, '5nt7A00', NULL, NULL, 107, NULL, NULL, 232165),
(253804, '1twfA09', NULL, NULL, 135, NULL, NULL, 232166),
(253805, '3h0gA08', NULL, NULL, 138, NULL, NULL, 232166),
(253806, '3t2cA02', NULL, NULL, 30, NULL, NULL, 232167),
(253807, '1ugiD00', NULL, NULL, 84, NULL, NULL, 232168),
(253808, '5dnyA03', NULL, NULL, 47, NULL, NULL, 232169),
(253809, '2d5bA02', NULL, NULL, 111, NULL, NULL, 232170),
(253810, '2x1lA02', NULL, NULL, 114, NULL, NULL, 232170),
(253811, '4zt6B02', NULL, NULL, 121, NULL, NULL, 232170),
(253812, '2x1lC02', NULL, NULL, 77, NULL, NULL, 232170),
(253813, '3kflA02', NULL, NULL, 121, NULL, NULL, 232170),
(253814, '5xgqA02', NULL, NULL, 113, NULL, NULL, 232170),
(253815, '2ct8A02', NULL, NULL, 79, NULL, NULL, 232170),
(253816, '4py2A02', NULL, NULL, 113, NULL, NULL, 232170),
(253817, '1rqgA02', NULL, NULL, 154, NULL, NULL, 232170),
(253818, '4dlpB02', NULL, NULL, 81, NULL, NULL, 232170),
(253819, '4qreA02', NULL, NULL, 120, NULL, NULL, 232170),
(253820, '4ntqB00', NULL, NULL, 155, NULL, NULL, 232171),
(253821, '2ra1A03', NULL, NULL, 63, NULL, NULL, 232172),
(253822, '4aybF01', NULL, NULL, 44, NULL, NULL, 232173);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(253823, '2pmzF01', NULL, NULL, 44, NULL, NULL, 232173),
(253824, '1lmlA03', NULL, NULL, 67, NULL, NULL, 232174),
(253825, '6ha4A00', NULL, NULL, 55, NULL, NULL, 232175),
(253826, '1afpA00', NULL, NULL, 51, NULL, NULL, 232175),
(253827, '3ukvC01', NULL, NULL, 46, NULL, NULL, 232176),
(253828, '1qveB00', NULL, NULL, 126, NULL, NULL, 232177),
(253829, '4v1jA00', NULL, NULL, 142, NULL, NULL, 232177),
(253830, '3fu1A01', NULL, NULL, 109, NULL, NULL, 232177),
(253831, '3g20A01', NULL, NULL, 116, NULL, NULL, 232177),
(253832, '3jyzA00', NULL, NULL, 150, NULL, NULL, 232177),
(253833, '3gn9A01', NULL, NULL, 109, NULL, NULL, 232177),
(253834, '2hi2A00', NULL, NULL, 158, NULL, NULL, 232177),
(253835, '3sokB00', NULL, NULL, 151, NULL, NULL, 232177),
(253836, '2kepA01', NULL, NULL, 108, NULL, NULL, 232177),
(253837, '3sojB00', NULL, NULL, 115, NULL, NULL, 232177),
(253838, '1oqwA00', NULL, NULL, 144, NULL, NULL, 232177),
(253839, '1t92A01', NULL, NULL, 100, NULL, NULL, 232177),
(253840, '5jw8A00', NULL, NULL, 137, NULL, NULL, 232177),
(253841, '1x6zA00', NULL, NULL, 123, NULL, NULL, 232177),
(253842, '1z2zA02', NULL, NULL, 90, NULL, NULL, 232178),
(253843, '4lvpA00', NULL, NULL, 127, NULL, NULL, 232179),
(253844, '3ig5A03', NULL, NULL, 84, NULL, NULL, 232180),
(253845, '2y8yA02', NULL, NULL, 124, NULL, NULL, 232181),
(253846, '4dzdA02', NULL, NULL, 123, NULL, NULL, 232181),
(253847, '4hu2A01', NULL, NULL, 98, NULL, NULL, 232182),
(253848, '4mu3A02', NULL, NULL, 109, NULL, NULL, 232183),
(253849, '2ae8B01', NULL, NULL, 88, NULL, NULL, 232183),
(253850, '2ae8A02', NULL, NULL, 105, NULL, NULL, 232183),
(253851, '5xdsA01', NULL, NULL, 104, NULL, NULL, 232183),
(253852, '5xdsA02', NULL, NULL, 112, NULL, NULL, 232183),
(253853, '5ekwA01', NULL, NULL, 96, NULL, NULL, 232183),
(253854, '5dnlA02', NULL, NULL, 101, NULL, NULL, 232183),
(253855, '5dnlA01', NULL, NULL, 75, NULL, NULL, 232183),
(253856, '1rhyA02', NULL, NULL, 106, NULL, NULL, 232183),
(253857, '1rhyA01', NULL, NULL, 96, NULL, NULL, 232183),
(253858, '2f1dA01', NULL, NULL, 98, NULL, NULL, 232183),
(253859, '4flnA02', NULL, NULL, 152, NULL, NULL, 232184),
(253860, '5ilbA02', NULL, NULL, 156, NULL, NULL, 232184),
(253861, '3hg9A02', NULL, NULL, 46, NULL, NULL, 232185),
(253862, '1xouB00', NULL, NULL, 95, NULL, NULL, 232186),
(253863, '3da0A01', NULL, NULL, 107, NULL, NULL, 232187),
(253864, '2f0cA02', NULL, NULL, 104, NULL, NULL, 232187),
(253865, '1bm8A00', NULL, NULL, 99, NULL, NULL, 232188),
(253866, '1l3gA00', NULL, NULL, 136, NULL, NULL, 232188),
(253867, '4ux5A00', NULL, NULL, 136, NULL, NULL, 232188),
(253868, '1a87A01', NULL, NULL, 97, NULL, NULL, 232189),
(253869, '4cq4B00', NULL, NULL, 102, NULL, NULL, 232190),
(253870, '5ao2B02', NULL, NULL, 90, NULL, NULL, 232191),
(253871, '3u1nC02', NULL, NULL, 131, NULL, NULL, 232191),
(253872, '2yicA01', NULL, NULL, 86, NULL, NULL, 232192),
(253873, '2jgdA01', NULL, NULL, 83, NULL, NULL, 232192),
(253874, '2xv9A00', NULL, NULL, 134, NULL, NULL, 232193),
(253875, '3umvA02', NULL, NULL, 171, NULL, NULL, 232194),
(253876, '1owlA02', NULL, NULL, 123, NULL, NULL, 232194),
(253877, '1np7B02', NULL, NULL, 171, NULL, NULL, 232194),
(253878, '5zm0A02', NULL, NULL, 128, NULL, NULL, 232194),
(253879, '4mlpA02', NULL, NULL, 127, NULL, NULL, 232194),
(253880, '4cdnB02', NULL, NULL, 178, NULL, NULL, 232194),
(253881, '3cvvA02', NULL, NULL, 131, NULL, NULL, 232194),
(253882, '2e0iA02', NULL, NULL, 98, NULL, NULL, 232194),
(253883, '2j07A02', NULL, NULL, 108, NULL, NULL, 232194),
(253884, '1np7A02', NULL, NULL, 119, NULL, NULL, 232194),
(253885, '4djaA02', NULL, NULL, 157, NULL, NULL, 232194),
(253886, '3fy4A02', NULL, NULL, 129, NULL, NULL, 232194),
(253887, '1dnpA02', NULL, NULL, 123, NULL, NULL, 232194),
(253888, '4u63A02', NULL, NULL, 121, NULL, NULL, 232194),
(253889, '4jzyA02', NULL, NULL, 138, NULL, NULL, 232194),
(253890, '1u3dA02', NULL, NULL, 134, NULL, NULL, 232194),
(253891, '3zxsC02', NULL, NULL, 157, NULL, NULL, 232194),
(253892, '2j4dA02', NULL, NULL, 170, NULL, NULL, 232194),
(253893, '5t5xA02', NULL, NULL, 136, NULL, NULL, 232194);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(253894, '2l5qA02', NULL, NULL, 92, NULL, NULL, 232195),
(253895, '2welA03', NULL, NULL, 36, NULL, NULL, 232196),
(253896, '3zqjA06', NULL, NULL, 139, NULL, NULL, 232197),
(253897, '3zqjE02', NULL, NULL, 169, NULL, NULL, 232197),
(253898, '2vf7A02', NULL, NULL, 153, NULL, NULL, 232197),
(253899, '2vf8B05', NULL, NULL, 158, NULL, NULL, 232197),
(253900, '2r6fA02', NULL, NULL, 155, NULL, NULL, 232197),
(253901, '2r6fA06', NULL, NULL, 138, NULL, NULL, 232197),
(253902, '1rpuB00', NULL, NULL, 149, NULL, NULL, 232198),
(253903, '4j39A01', NULL, NULL, 113, NULL, NULL, 232198),
(253904, '2bx2L02', NULL, NULL, 110, NULL, NULL, 232199),
(253905, '4odjA01', NULL, NULL, 113, NULL, NULL, 232200),
(253906, '4odjA03', NULL, NULL, 132, NULL, NULL, 232200),
(253907, '1xrbA02', NULL, NULL, 101, NULL, NULL, 232200),
(253908, '5h9uA01', NULL, NULL, 109, NULL, NULL, 232200),
(253909, '5a1iA02', NULL, NULL, 141, NULL, NULL, 232200),
(253910, '3imlD01', NULL, NULL, 118, NULL, NULL, 232200),
(253911, '3imlC03', NULL, NULL, 129, NULL, NULL, 232200),
(253912, '5a1iA01', NULL, NULL, 125, NULL, NULL, 232200),
(253913, '5t8sB03', NULL, NULL, 152, NULL, NULL, 232200),
(253914, '5h9uA03', NULL, NULL, 150, NULL, NULL, 232200),
(253915, '5t8sA01', NULL, NULL, 117, NULL, NULL, 232200),
(253916, '3imlD03', NULL, NULL, 91, NULL, NULL, 232200),
(253917, '5h9uA02', NULL, NULL, 129, NULL, NULL, 232200),
(253918, '4l4qA03', NULL, NULL, 125, NULL, NULL, 232200),
(253919, '5t8sA02', NULL, NULL, 128, NULL, NULL, 232200),
(253920, '3so4A03', NULL, NULL, 157, NULL, NULL, 232200),
(253921, '3so4A02', NULL, NULL, 128, NULL, NULL, 232200),
(253922, '3tqiA03', NULL, NULL, 109, NULL, NULL, 232200),
(253923, '3imlA02', NULL, NULL, 128, NULL, NULL, 232200),
(253924, '3so4A01', NULL, NULL, 109, NULL, NULL, 232200),
(253925, '2ywbA03', NULL, NULL, 108, NULL, NULL, 232200),
(253926, '1gpmA03', NULL, NULL, 108, NULL, NULL, 232200),
(253927, '1qm4A03', NULL, NULL, 110, NULL, NULL, 232200),
(253928, '3tdeB01', NULL, NULL, 119, NULL, NULL, 232200),
(253929, '3tdeA03', NULL, NULL, 132, NULL, NULL, 232200),
(253930, '3uowB03', NULL, NULL, 115, NULL, NULL, 232200),
(253931, '1p7lA02', NULL, NULL, 129, NULL, NULL, 232200),
(253932, '1p7lA01', NULL, NULL, 141, NULL, NULL, 232200),
(253933, '4le5B03', NULL, NULL, 135, NULL, NULL, 232200),
(253934, '2obvA01', NULL, NULL, 114, NULL, NULL, 232200),
(253935, '4le5A02', NULL, NULL, 148, NULL, NULL, 232200),
(253936, '6c07D02', NULL, NULL, 125, NULL, NULL, 232200),
(253937, '4le5A01', NULL, NULL, 111, NULL, NULL, 232200),
(253938, '2dplA02', NULL, NULL, 123, NULL, NULL, 232200),
(253939, '3s82A03', NULL, NULL, 132, NULL, NULL, 232200),
(253940, '2obvA03', NULL, NULL, 128, NULL, NULL, 232200),
(253941, '3s82A02', NULL, NULL, 131, NULL, NULL, 232200),
(253942, '3s82B01', NULL, NULL, 118, NULL, NULL, 232200),
(253943, '2obvA02', NULL, NULL, 141, NULL, NULL, 232200),
(253944, '5a1iA03', NULL, NULL, 128, NULL, NULL, 232200),
(253945, '1p7lA03', NULL, NULL, 106, NULL, NULL, 232200),
(253946, '3rv2A01', NULL, NULL, 118, NULL, NULL, 232200),
(253947, '4l7iB03', NULL, NULL, 121, NULL, NULL, 232200),
(253948, '4ixjA01', NULL, NULL, 90, NULL, NULL, 232201),
(253949, '2hx0A01', NULL, NULL, 137, NULL, NULL, 232202),
(253950, '5xneA02', NULL, NULL, 123, NULL, NULL, 232202),
(253951, '3hwuA00', NULL, NULL, 147, NULL, NULL, 232202),
(253952, '2p6yA00', NULL, NULL, 142, NULL, NULL, 232202),
(253953, '3htnB00', NULL, NULL, 149, NULL, NULL, 232202),
(253954, '2dt4A00', NULL, NULL, 143, NULL, NULL, 232202),
(253955, '1xv2C01', NULL, NULL, 115, NULL, NULL, 232202),
(253956, '1xv2D02', NULL, NULL, 123, NULL, NULL, 232202),
(253957, '4bt2A02', NULL, NULL, 123, NULL, NULL, 232202),
(253958, '4bt2A01', NULL, NULL, 115, NULL, NULL, 232202),
(253959, '2h6lA00', NULL, NULL, 146, NULL, NULL, 232202),
(253960, '3fewX03', NULL, NULL, 81, NULL, NULL, 232203),
(253961, '3fewX02', NULL, NULL, 95, NULL, NULL, 232203),
(253962, '2hj1A00', NULL, NULL, 97, NULL, NULL, 232204),
(253963, '3iuoA00', NULL, NULL, 122, NULL, NULL, 232205),
(253964, '2obeB02', NULL, NULL, 186, NULL, NULL, 232206);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(253965, '1p2zA01', NULL, NULL, 181, NULL, NULL, 232206),
(253966, '1p30A01', NULL, NULL, 204, NULL, NULL, 232206),
(253967, '1dhxA01', NULL, NULL, 181, NULL, NULL, 232206),
(253968, '2ckzB01', NULL, NULL, 79, NULL, NULL, 232207),
(253969, '4aybE01', NULL, NULL, 81, NULL, NULL, 232207),
(253970, '2rf4C01', NULL, NULL, 110, NULL, NULL, 232207),
(253971, '4qjfA01', NULL, NULL, 81, NULL, NULL, 232207),
(253972, '1go3E02', NULL, NULL, 81, NULL, NULL, 232207),
(253973, '3h0gG01', NULL, NULL, 83, NULL, NULL, 232207),
(253974, '5xogG01', NULL, NULL, 82, NULL, NULL, 232207),
(253975, '3ayhB01', NULL, NULL, 79, NULL, NULL, 232207),
(253976, '1y14D01', NULL, NULL, 84, NULL, NULL, 232207),
(253977, '2c35B01', NULL, NULL, 80, NULL, NULL, 232207),
(253978, '2gttC01', NULL, NULL, 194, NULL, NULL, 232208),
(253979, '3hhwK01', NULL, NULL, 183, NULL, NULL, 232208),
(253980, '2e1mC01', NULL, NULL, 68, NULL, NULL, 232209),
(253981, '3wx7A02', NULL, NULL, 95, NULL, NULL, 232210),
(253982, '4nz5A02', NULL, NULL, 108, NULL, NULL, 232210),
(253983, '4fgmA01', NULL, NULL, 173, NULL, NULL, 232211),
(253984, '4oq1A01', NULL, NULL, 121, NULL, NULL, 232212),
(253985, '1jo0A00', NULL, NULL, 98, NULL, NULL, 232213),
(253986, '1ln4A00', NULL, NULL, 104, NULL, NULL, 232213),
(253987, '1rq8A00', NULL, NULL, 104, NULL, NULL, 232213),
(253988, '4bs9A05', NULL, NULL, 124, NULL, NULL, 232214),
(253989, '2wyoC01', NULL, NULL, 113, NULL, NULL, 232215),
(253990, '3u7qB03', NULL, NULL, 83, NULL, NULL, 232216),
(253991, '5kohB03', NULL, NULL, 83, NULL, NULL, 232216),
(253992, '4wesB03', NULL, NULL, 79, NULL, NULL, 232216),
(253993, '1qguB04', NULL, NULL, 83, NULL, NULL, 232216),
(253994, '1zvdA02', NULL, NULL, 78, NULL, NULL, 232217),
(253995, '1nd7A02', NULL, NULL, 80, NULL, NULL, 232217),
(253996, '2xbfA02', NULL, NULL, 78, NULL, NULL, 232217),
(253997, '3olmA02', NULL, NULL, 78, NULL, NULL, 232217),
(253998, '2oniA02', NULL, NULL, 78, NULL, NULL, 232217),
(253999, '3h1dA02', NULL, NULL, 80, NULL, NULL, 232217),
(254000, '1c4zA02', NULL, NULL, 81, NULL, NULL, 232217),
(254001, '2yo3A02', NULL, NULL, 54, NULL, NULL, 232218),
(254002, '1el6A02', NULL, NULL, 47, NULL, NULL, 232219),
(254003, '3og2A03', NULL, NULL, 89, NULL, NULL, 232220),
(254004, '1tg7A03', NULL, NULL, 89, NULL, NULL, 232220),
(254005, '4iugA03', NULL, NULL, 89, NULL, NULL, 232220),
(254006, '5ifpA03', NULL, NULL, 89, NULL, NULL, 232220),
(254007, '3h1kI00', NULL, NULL, 47, NULL, NULL, 232221),
(254008, '3l71V00', NULL, NULL, 47, NULL, NULL, 232221),
(254009, '3h1iI00', NULL, NULL, 47, NULL, NULL, 232221),
(254010, '3cwbI00', NULL, NULL, 52, NULL, NULL, 232221),
(254011, '3l73V00', NULL, NULL, 47, NULL, NULL, 232221),
(254012, '3l70I00', NULL, NULL, 47, NULL, NULL, 232221),
(254013, '3h1jV00', NULL, NULL, 47, NULL, NULL, 232221),
(254014, '3h1hV00', NULL, NULL, 47, NULL, NULL, 232221),
(254015, '3cwbV00', NULL, NULL, 52, NULL, NULL, 232221),
(254016, '3tguV00', NULL, NULL, 76, NULL, NULL, 232221),
(254017, '3l74I00', NULL, NULL, 47, NULL, NULL, 232221),
(254018, '1ppjI00', NULL, NULL, 47, NULL, NULL, 232221),
(254019, '3h1lV00', NULL, NULL, 47, NULL, NULL, 232221),
(254020, '2fyuI00', NULL, NULL, 57, NULL, NULL, 232221),
(254021, '4u3fI00', NULL, NULL, 48, NULL, NULL, 232221),
(254022, '3l72I00', NULL, NULL, 47, NULL, NULL, 232221),
(254023, '3h1jI00', NULL, NULL, 47, NULL, NULL, 232221),
(254024, '3h1lI00', NULL, NULL, 47, NULL, NULL, 232221),
(254025, '3l70V00', NULL, NULL, 47, NULL, NULL, 232221),
(254026, '3h1hI00', NULL, NULL, 47, NULL, NULL, 232221),
(254027, '3l74V00', NULL, NULL, 47, NULL, NULL, 232221),
(254028, '3l72V00', NULL, NULL, 47, NULL, NULL, 232221),
(254029, '4u3fV00', NULL, NULL, 48, NULL, NULL, 232221),
(254030, '3tguI00', NULL, NULL, 76, NULL, NULL, 232221),
(254031, '5xteB00', NULL, NULL, 57, NULL, NULL, 232221),
(254032, '3h1iV00', NULL, NULL, 47, NULL, NULL, 232221),
(254033, '3l71I00', NULL, NULL, 47, NULL, NULL, 232221),
(254034, '3l75V00', NULL, NULL, 47, NULL, NULL, 232221),
(254035, '3l75I00', NULL, NULL, 47, NULL, NULL, 232221),
(254036, '3l73I00', NULL, NULL, 47, NULL, NULL, 232221);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(254037, '3h1kV00', NULL, NULL, 47, NULL, NULL, 232221),
(254038, '4lmsC00', NULL, NULL, 70, NULL, NULL, 232222),
(254039, '4lmxE00', NULL, NULL, 67, NULL, NULL, 232222),
(254040, '4lmxC00', NULL, NULL, 67, NULL, NULL, 232222),
(254041, '4lmsA00', NULL, NULL, 80, NULL, NULL, 232222),
(254042, '4lm6A00', NULL, NULL, 62, NULL, NULL, 232222),
(254043, '1xg0A00', NULL, NULL, 76, NULL, NULL, 232222),
(254044, '1xg0B00', NULL, NULL, 67, NULL, NULL, 232222),
(254045, '3dktA01', NULL, NULL, 169, NULL, NULL, 232223),
(254046, '3o4xE01', NULL, NULL, 73, NULL, NULL, 232224),
(254047, '2ebrA00', NULL, NULL, 47, NULL, NULL, 232225),
(254048, '2ebqA00', NULL, NULL, 47, NULL, NULL, 232225),
(254049, '1n0zA00', NULL, NULL, 45, NULL, NULL, 232225),
(254050, '4l3uA00', NULL, NULL, 139, NULL, NULL, 232226),
(254051, '3agtA00', NULL, NULL, 136, NULL, NULL, 232227),
(254052, '2hmqA00', NULL, NULL, 113, NULL, NULL, 232227),
(254053, '1i4yA00', NULL, NULL, 114, NULL, NULL, 232227),
(254054, '2mhrA00', NULL, NULL, 118, NULL, NULL, 232227),
(254055, '4xpxA00', NULL, NULL, 130, NULL, NULL, 232227),
(254056, '2m1lA00', NULL, NULL, 69, NULL, NULL, 232228),
(254057, '2kw6A00', NULL, NULL, 65, NULL, NULL, 232228),
(254058, '3ljeA00', NULL, NULL, 130, NULL, NULL, 232229),
(254059, '3ql1A00', NULL, NULL, 124, NULL, NULL, 232229),
(254060, '1dy5A00', NULL, NULL, 124, NULL, NULL, 232229),
(254061, '2bwkA00', NULL, NULL, 121, NULL, NULL, 232229),
(254062, '1n1xA00', NULL, NULL, 124, NULL, NULL, 232229),
(254063, '3f8gA00', NULL, NULL, 125, NULL, NULL, 232229),
(254064, '3zbvA00', NULL, NULL, 121, NULL, NULL, 232229),
(254065, '2e0jA00', NULL, NULL, 129, NULL, NULL, 232229),
(254066, '1dzaB00', NULL, NULL, 129, NULL, NULL, 232229),
(254067, '2hkyA00', NULL, NULL, 129, NULL, NULL, 232229),
(254068, '1y94A00', NULL, NULL, 124, NULL, NULL, 232229),
(254069, '3tsrB00', NULL, NULL, 125, NULL, NULL, 232229),
(254070, '6enpA00', NULL, NULL, 128, NULL, NULL, 232229),
(254071, '1z5fA00', NULL, NULL, 105, NULL, NULL, 232229),
(254072, '2zpoA00', NULL, NULL, 119, NULL, NULL, 232229),
(254073, '4perB00', NULL, NULL, 113, NULL, NULL, 232229),
(254074, '1rnfA00', NULL, NULL, 120, NULL, NULL, 232229),
(254075, '5ar6A00', NULL, NULL, 122, NULL, NULL, 232229),
(254076, '2j4tA00', NULL, NULL, 119, NULL, NULL, 232229),
(254077, '3ljdA00', NULL, NULL, 126, NULL, NULL, 232229),
(254078, '1gqvA00', NULL, NULL, 135, NULL, NULL, 232229),
(254079, '4qfiB00', NULL, NULL, 126, NULL, NULL, 232229),
(254080, '1gv7A00', NULL, NULL, 123, NULL, NULL, 232229),
(254081, '1c9vA00', NULL, NULL, 124, NULL, NULL, 232229),
(254082, '1b6vA00', NULL, NULL, 124, NULL, NULL, 232229),
(254083, '4aohA00', NULL, NULL, 124, NULL, NULL, 232229),
(254084, '3zbwB00', NULL, NULL, 121, NULL, NULL, 232229),
(254085, '1m07A00', NULL, NULL, 111, NULL, NULL, 232229),
(254086, '3snfA00', NULL, NULL, 104, NULL, NULL, 232229),
(254087, '2vq9A00', NULL, NULL, 123, NULL, NULL, 232229),
(254088, '1m58A00', NULL, NULL, 106, NULL, NULL, 232229),
(254089, '2p7sA00', NULL, NULL, 114, NULL, NULL, 232229),
(254090, '4b36A00', NULL, NULL, 126, NULL, NULL, 232229),
(254091, '3fkzA00', NULL, NULL, 124, NULL, NULL, 232229),
(254092, '2e0oB00', NULL, NULL, 129, NULL, NULL, 232229),
(254093, '1agiA00', NULL, NULL, 125, NULL, NULL, 232229),
(254094, '1rraA00', NULL, NULL, 124, NULL, NULL, 232229),
(254095, '1kvzA00', NULL, NULL, 107, NULL, NULL, 232229),
(254096, '4x08A00', NULL, NULL, 134, NULL, NULL, 232229),
(254097, '1oj8A00', NULL, NULL, 105, NULL, NULL, 232229),
(254098, '2nuiA00', NULL, NULL, 124, NULL, NULL, 232229),
(254099, '4akgA13', NULL, NULL, 95, NULL, NULL, 232230),
(254100, '3zgxC00', NULL, NULL, 76, NULL, NULL, 232231),
(254101, '1vfjB00', NULL, NULL, 116, NULL, NULL, 232232),
(254102, '1naqB00', NULL, NULL, 112, NULL, NULL, 232232),
(254103, '4ushA00', NULL, NULL, 125, NULL, NULL, 232232),
(254104, '4rleA01', NULL, NULL, 104, NULL, NULL, 232232),
(254105, '2dclA00', NULL, NULL, 127, NULL, NULL, 232232),
(254106, '2gw8A00', NULL, NULL, 114, NULL, NULL, 232232),
(254107, '2zfhC00', NULL, NULL, 117, NULL, NULL, 232232);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(254108, '6gdxA00', NULL, NULL, 108, NULL, NULL, 232232),
(254109, '2o66C00', NULL, NULL, 135, NULL, NULL, 232232),
(254110, '4rwxC01', NULL, NULL, 72, NULL, NULL, 232232),
(254111, '1nzaA00', NULL, NULL, 103, NULL, NULL, 232232),
(254112, '1gnkA00', NULL, NULL, 112, NULL, NULL, 232232),
(254113, '4iyqA00', NULL, NULL, 107, NULL, NULL, 232232),
(254114, '3gsdD00', NULL, NULL, 104, NULL, NULL, 232232),
(254115, '3hluA00', NULL, NULL, 78, NULL, NULL, 232232),
(254116, '2gx8A02', NULL, NULL, 110, NULL, NULL, 232232),
(254117, '1ukuA00', NULL, NULL, 102, NULL, NULL, 232232),
(254118, '3ncqA00', NULL, NULL, 119, NULL, NULL, 232232),
(254119, '4affA00', NULL, NULL, 116, NULL, NULL, 232232),
(254120, '1kr4A00', NULL, NULL, 125, NULL, NULL, 232232),
(254121, '3lnlB02', NULL, NULL, 109, NULL, NULL, 232232),
(254122, '1vhfA00', NULL, NULL, 113, NULL, NULL, 232232),
(254123, '4e98C00', NULL, NULL, 105, NULL, NULL, 232232),
(254124, '3opkA00', NULL, NULL, 118, NULL, NULL, 232232),
(254125, '4zk7M00', NULL, NULL, 111, NULL, NULL, 232232),
(254126, '2zomA00', NULL, NULL, 113, NULL, NULL, 232232),
(254127, '4rwwA01', NULL, NULL, 103, NULL, NULL, 232232),
(254128, '1ul3A00', NULL, NULL, 112, NULL, NULL, 232232),
(254129, '3l7pC00', NULL, NULL, 115, NULL, NULL, 232232),
(254130, '4d3hB01', NULL, NULL, 104, NULL, NULL, 232232),
(254131, '1o51A00', NULL, NULL, 114, NULL, NULL, 232232),
(254132, '2vd3A03', NULL, NULL, 74, NULL, NULL, 232232),
(254133, '3bzqA00', NULL, NULL, 114, NULL, NULL, 232232),
(254134, '3dfeA00', NULL, NULL, 111, NULL, NULL, 232232),
(254135, '2cz4A00', NULL, NULL, 99, NULL, NULL, 232232),
(254136, '5d4nC00', NULL, NULL, 108, NULL, NULL, 232232),
(254137, '4rx6D00', NULL, NULL, 121, NULL, NULL, 232232),
(254138, '1p1lA00', NULL, NULL, 102, NULL, NULL, 232232),
(254139, '2j9cA00', NULL, NULL, 119, NULL, NULL, 232232),
(254140, '3hluB00', NULL, NULL, 78, NULL, NULL, 232232),
(254141, '1h3dA03', NULL, NULL, 74, NULL, NULL, 232232),
(254142, '5l9nA00', NULL, NULL, 112, NULL, NULL, 232232),
(254143, '3m05B01', NULL, NULL, 104, NULL, NULL, 232232),
(254144, '2nuhA00', NULL, NULL, 118, NULL, NULL, 232232),
(254145, '4ozjA00', NULL, NULL, 118, NULL, NULL, 232232),
(254146, '1hwuB00', NULL, NULL, 112, NULL, NULL, 232232),
(254147, '4co3A00', NULL, NULL, 112, NULL, NULL, 232232),
(254148, '3ce8A00', NULL, NULL, 100, NULL, NULL, 232232),
(254149, '3t9zB00', NULL, NULL, 118, NULL, NULL, 232232),
(254150, '1nh8A03', NULL, NULL, 67, NULL, NULL, 232232),
(254151, '1oscA00', NULL, NULL, 109, NULL, NULL, 232232),
(254152, '3n5bA00', NULL, NULL, 112, NULL, NULL, 232232),
(254153, '4yb6A03', NULL, NULL, 74, NULL, NULL, 232232),
(254154, '2eg2A00', NULL, NULL, 112, NULL, NULL, 232232),
(254155, '1o5jA00', NULL, NULL, 113, NULL, NULL, 232232),
(254156, '3ahpA00', NULL, NULL, 108, NULL, NULL, 232232),
(254157, '3fhnA01', NULL, NULL, 193, NULL, NULL, 232233),
(254158, '1cd3B00', NULL, NULL, 68, NULL, NULL, 232234),
(254159, '1al0B00', NULL, NULL, 49, NULL, NULL, 232234),
(254160, '4mdwA00', NULL, NULL, 147, NULL, NULL, 232235),
(254161, '4whiA00', NULL, NULL, 102, NULL, NULL, 232236),
(254162, '4kxfB02', NULL, NULL, 57, NULL, NULL, 232237),
(254163, '4l4yA00', NULL, NULL, 249, NULL, NULL, 232238),
(254164, '3nzeA00', NULL, NULL, 267, NULL, NULL, 232238),
(254165, '1y89A00', NULL, NULL, 238, NULL, NULL, 232238),
(254166, '3tx2A00', NULL, NULL, 251, NULL, NULL, 232238),
(254167, '3kv1A00', NULL, NULL, 267, NULL, NULL, 232238),
(254168, '1lk5A01', NULL, NULL, 150, NULL, NULL, 232238),
(254169, '1xtzA01', NULL, NULL, 162, NULL, NULL, 232238),
(254170, '6eepA01', NULL, NULL, 146, NULL, NULL, 232238),
(254171, '3cssA00', NULL, NULL, 267, NULL, NULL, 232238),
(254172, '1o8bB01', NULL, NULL, 147, NULL, NULL, 232238),
(254173, '4tm7A00', NULL, NULL, 256, NULL, NULL, 232238),
(254174, '3ixqA01', NULL, NULL, 148, NULL, NULL, 232238),
(254175, '2bkxA00', NULL, NULL, 242, NULL, NULL, 232238),
(254176, '3e15A00', NULL, NULL, 312, NULL, NULL, 232238),
(254177, '2r5fA00', NULL, NULL, 264, NULL, NULL, 232238),
(254178, '3hheA01', NULL, NULL, 142, NULL, NULL, 232238); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(254179, '3icoA00', NULL, NULL, 245, NULL, NULL, 232238),
(254180, '3eb9A00', NULL, NULL, 266, NULL, NULL, 232238),
(254181, '5uf2A01', NULL, NULL, 150, NULL, NULL, 232238),
(254182, '3l7oA01', NULL, NULL, 142, NULL, NULL, 232238),
(254183, '2gnpA00', NULL, NULL, 266, NULL, NULL, 232238),
(254184, '3nwpA00', NULL, NULL, 233, NULL, NULL, 232238),
(254185, '1vl1A00', NULL, NULL, 232, NULL, NULL, 232238),
(254186, '6j1kA01', NULL, NULL, 144, NULL, NULL, 232238),
(254187, '4nmlA01', NULL, NULL, 149, NULL, NULL, 232238),
(254188, '2w48C02', NULL, NULL, 261, NULL, NULL, 232238),
(254189, '2ri0A00', NULL, NULL, 234, NULL, NULL, 232238),
(254190, '1fs5A00', NULL, NULL, 266, NULL, NULL, 232238),
(254191, '1m0sA01', NULL, NULL, 146, NULL, NULL, 232238),
(254192, '4gmkA01', NULL, NULL, 147, NULL, NULL, 232238),
(254193, '4r9nA00', NULL, NULL, 254, NULL, NULL, 232238),
(254194, '3uw1A01', NULL, NULL, 162, NULL, NULL, 232238),
(254195, '4io1A01', NULL, NULL, 152, NULL, NULL, 232238),
(254196, '5hj5A00', NULL, NULL, 267, NULL, NULL, 232238),
(254197, '3lhiA00', NULL, NULL, 232, NULL, NULL, 232238),
(254198, '3hn6F00', NULL, NULL, 271, NULL, NULL, 232238),
(254199, '3enqA01', NULL, NULL, 145, NULL, NULL, 232238),
(254200, '4x84B01', NULL, NULL, 159, NULL, NULL, 232238),
(254201, '2f8mA01', NULL, NULL, 152, NULL, NULL, 232238),
(254202, '1uj6A01', NULL, NULL, 146, NULL, NULL, 232238),
(254203, '3efbC00', NULL, NULL, 266, NULL, NULL, 232238),
(254204, '1ne7B00', NULL, NULL, 289, NULL, NULL, 232238),
(254205, '4oqpA00', NULL, NULL, 264, NULL, NULL, 232238),
(254206, '2okgA00', NULL, NULL, 255, NULL, NULL, 232238),
(254207, '2o0mA00', NULL, NULL, 251, NULL, NULL, 232238),
(254208, '3lwdA00', NULL, NULL, 226, NULL, NULL, 232238),
(254209, '4dkkA01', NULL, NULL, 35, NULL, NULL, 232239),
(254210, '2gsvB00', NULL, NULL, 80, NULL, NULL, 232240),
(254211, '3qi7A02', NULL, NULL, 166, NULL, NULL, 232241),
(254212, '1euvA02', NULL, NULL, 105, NULL, NULL, 232242),
(254213, '3eayA02', NULL, NULL, 131, NULL, NULL, 232242),
(254214, '3h6pA00', NULL, NULL, 60, NULL, NULL, 232243),
(254215, '1n2dC00', NULL, NULL, 48, NULL, NULL, 232243),
(254216, '2ix7C00', NULL, NULL, 58, NULL, NULL, 232243),
(254217, '1kfnA00', NULL, NULL, 56, NULL, NULL, 232243),
(254218, '2guvA00', NULL, NULL, 56, NULL, NULL, 232243),
(254219, '1eq7A00', NULL, NULL, 56, NULL, NULL, 232243),
(254220, '1jcdB00', NULL, NULL, 52, NULL, NULL, 232243),
(254221, '1jccC00', NULL, NULL, 56, NULL, NULL, 232243),
(254222, '1t8zC00', NULL, NULL, 53, NULL, NULL, 232243),
(254223, '2jekA00', NULL, NULL, 145, NULL, NULL, 232244),
(254224, '3u95C00', NULL, NULL, 477, NULL, NULL, 232245),
(254225, '3fefA00', NULL, NULL, 450, NULL, NULL, 232245),
(254226, '1obbB00', NULL, NULL, 480, NULL, NULL, 232245),
(254227, '1cksB00', NULL, NULL, 79, NULL, NULL, 232246),
(254228, '2astC00', NULL, NULL, 69, NULL, NULL, 232246),
(254229, '3qy2A00', NULL, NULL, 117, NULL, NULL, 232246),
(254230, '1pucA00', NULL, NULL, 105, NULL, NULL, 232246),
(254231, '4lpaA00', NULL, NULL, 119, NULL, NULL, 232246),
(254232, '2oap101', NULL, NULL, 230, NULL, NULL, 232247),
(254233, '2dewX02', NULL, NULL, 175, NULL, NULL, 232248),
(254234, '4n2kA02', NULL, NULL, 173, NULL, NULL, 232248),
(254235, '6ce1A02', NULL, NULL, 173, NULL, NULL, 232248),
(254236, '5hp5A02', NULL, NULL, 171, NULL, NULL, 232248),
(254237, '1lbuA02', NULL, NULL, 129, NULL, NULL, 232249),
(254238, '4murA00', NULL, NULL, 190, NULL, NULL, 232249),
(254239, '1tzpB00', NULL, NULL, 255, NULL, NULL, 232249),
(254240, '4muqA02', NULL, NULL, 146, NULL, NULL, 232249),
(254241, '2wfqA00', NULL, NULL, 165, NULL, NULL, 232249),
(254242, '1vhhA00', NULL, NULL, 162, NULL, NULL, 232249),
(254243, '4ox3A00', NULL, NULL, 219, NULL, NULL, 232249),
(254244, '4mphA00', NULL, NULL, 192, NULL, NULL, 232249),
(254245, '1r44A00', NULL, NULL, 202, NULL, NULL, 232249),
(254246, '2ibgE00', NULL, NULL, 150, NULL, NULL, 232249),
(254247, '5hnmC00', NULL, NULL, 181, NULL, NULL, 232249),
(254248, '3k7iB00', NULL, NULL, 162, NULL, NULL, 232249),
(254249, '4nt9A00', NULL, NULL, 185, NULL, NULL, 232249);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(254250, '4c4mA00', NULL, NULL, 164, NULL, NULL, 232249),
(254251, '5zhfA00', NULL, NULL, 189, NULL, NULL, 232249),
(254252, '3n1mB00', NULL, NULL, 169, NULL, NULL, 232249),
(254253, '6akvA01', NULL, NULL, 132, NULL, NULL, 232249),
(254254, '2vo9A01', NULL, NULL, 133, NULL, NULL, 232249),
(254255, '1dvoA00', NULL, NULL, 152, NULL, NULL, 232250),
(254256, '3mw6B00', NULL, NULL, 94, NULL, NULL, 232250),
(254257, '3mw6C00', NULL, NULL, 119, NULL, NULL, 232250),
(254258, '3kf8A00', NULL, NULL, 220, NULL, NULL, 232251),
(254259, '2o8gI00', NULL, NULL, 96, NULL, NULL, 232252),
(254260, '3uc2A00', NULL, NULL, 139, NULL, NULL, 232253),
(254261, '3cqlA02', NULL, NULL, 58, NULL, NULL, 232254),
(254262, '3w3eA02', NULL, NULL, 56, NULL, NULL, 232254),
(254263, '4dygA02', NULL, NULL, 58, NULL, NULL, 232254),
(254264, '2baaA02', NULL, NULL, 58, NULL, NULL, 232254),
(254265, '4mstA02', NULL, NULL, 58, NULL, NULL, 232254),
(254266, '3hbeX02', NULL, NULL, 58, NULL, NULL, 232254),
(254267, '3wh1A02', NULL, NULL, 59, NULL, NULL, 232254),
(254268, '4mckA02', NULL, NULL, 58, NULL, NULL, 232254),
(254269, '1wvvA02', NULL, NULL, 61, NULL, NULL, 232254),
(254270, '5h7tA02', NULL, NULL, 59, NULL, NULL, 232254),
(254271, '4tx7A02', NULL, NULL, 57, NULL, NULL, 232254),
(254272, '2dkvA03', NULL, NULL, 57, NULL, NULL, 232254),
(254273, '2z37A02', NULL, NULL, 59, NULL, NULL, 232254),
(254274, '1dxjA02', NULL, NULL, 56, NULL, NULL, 232254),
(254275, '2cjlA02', NULL, NULL, 61, NULL, NULL, 232254),
(254276, '3nrhA00', NULL, NULL, 182, NULL, NULL, 232255),
(254277, '3do6A02', NULL, NULL, 119, NULL, NULL, 232256),
(254278, '3do6B02', NULL, NULL, 119, NULL, NULL, 232256),
(254279, '4jimA02', NULL, NULL, 119, NULL, NULL, 232256),
(254280, '5a5gA02', NULL, NULL, 119, NULL, NULL, 232256),
(254281, '5a4jA02', NULL, NULL, 119, NULL, NULL, 232256),
(254282, '4jgpA02', NULL, NULL, 99, NULL, NULL, 232257),
(254283, '2kdkA01', NULL, NULL, 109, NULL, NULL, 232257),
(254284, '3mqqB00', NULL, NULL, 120, NULL, NULL, 232257),
(254285, '5f68A00', NULL, NULL, 103, NULL, NULL, 232257),
(254286, '4jgpA01', NULL, NULL, 92, NULL, NULL, 232257),
(254287, '2oolA01', NULL, NULL, 111, NULL, NULL, 232257),
(254288, '2m1cA00', NULL, NULL, 113, NULL, NULL, 232257),
(254289, '2h28A01', NULL, NULL, 92, NULL, NULL, 232257),
(254290, '3lidA03', NULL, NULL, 96, NULL, NULL, 232257),
(254291, '3lidA02', NULL, NULL, 134, NULL, NULL, 232257),
(254292, '3li9A02', NULL, NULL, 138, NULL, NULL, 232257),
(254293, '3li9A01', NULL, NULL, 134, NULL, NULL, 232257),
(254294, '1oj5A00', NULL, NULL, 114, NULL, NULL, 232257),
(254295, '1jnuA00', NULL, NULL, 104, NULL, NULL, 232257),
(254296, '1ot6A00', NULL, NULL, 125, NULL, NULL, 232257),
(254297, '3gdiA01', NULL, NULL, 151, NULL, NULL, 232257),
(254298, '4dj2A01', NULL, NULL, 162, NULL, NULL, 232257),
(254299, '4l9eA00', NULL, NULL, 115, NULL, NULL, 232257),
(254300, '4hi4A00', NULL, NULL, 121, NULL, NULL, 232257),
(254301, '4s21B02', NULL, NULL, 134, NULL, NULL, 232257),
(254302, '3nhqA02', NULL, NULL, 119, NULL, NULL, 232257),
(254303, '5y7wA00', NULL, NULL, 127, NULL, NULL, 232257),
(254304, '2z6cA00', NULL, NULL, 129, NULL, NULL, 232257),
(254305, '2r78C00', NULL, NULL, 117, NULL, NULL, 232257),
(254306, '2ykfA02', NULL, NULL, 151, NULL, NULL, 232257),
(254307, '3njaA01', NULL, NULL, 60, NULL, NULL, 232257),
(254308, '4r70B02', NULL, NULL, 138, NULL, NULL, 232257),
(254309, '3by9A02', NULL, NULL, 122, NULL, NULL, 232257),
(254310, '5hwvA00', NULL, NULL, 130, NULL, NULL, 232257),
(254311, '4gczB01', NULL, NULL, 126, NULL, NULL, 232257),
(254312, '2vv6D00', NULL, NULL, 119, NULL, NULL, 232257),
(254313, '3a0sA00', NULL, NULL, 96, NULL, NULL, 232257),
(254314, '4hh3A01', NULL, NULL, 125, NULL, NULL, 232257),
(254315, '3e4pA03', NULL, NULL, 113, NULL, NULL, 232257),
(254316, '3e4pA02', NULL, NULL, 81, NULL, NULL, 232257),
(254317, '4hp4B00', NULL, NULL, 130, NULL, NULL, 232257),
(254318, '1mzuB00', NULL, NULL, 129, NULL, NULL, 232257),
(254319, '3c8cB01', NULL, NULL, 127, NULL, NULL, 232257),
(254320, '3p7nA01', NULL, NULL, 126, NULL, NULL, 232257);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(254321, '3c8cB02', NULL, NULL, 113, NULL, NULL, 232257),
(254322, '4dj3B01', NULL, NULL, 136, NULL, NULL, 232257),
(254323, '3ue6C00', NULL, NULL, 122, NULL, NULL, 232257),
(254324, '3mxqC00', NULL, NULL, 152, NULL, NULL, 232257),
(254325, '4dj3B02', NULL, NULL, 157, NULL, NULL, 232257),
(254326, '4h6jA00', NULL, NULL, 113, NULL, NULL, 232257),
(254327, '4r3aB01', NULL, NULL, 171, NULL, NULL, 232257),
(254328, '6gpuA00', NULL, NULL, 115, NULL, NULL, 232257),
(254329, '3icyA00', NULL, NULL, 118, NULL, NULL, 232257),
(254330, '4eetB00', NULL, NULL, 115, NULL, NULL, 232257),
(254331, '2w0nA00', NULL, NULL, 118, NULL, NULL, 232257),
(254332, '2qkpD00', NULL, NULL, 151, NULL, NULL, 232257),
(254333, '3lyxB00', NULL, NULL, 124, NULL, NULL, 232257),
(254334, '4hh2C04', NULL, NULL, 118, NULL, NULL, 232257),
(254335, '6iouA02', NULL, NULL, 112, NULL, NULL, 232257),
(254336, '3bwlB00', NULL, NULL, 126, NULL, NULL, 232257),
(254337, '3k3dA00', NULL, NULL, 149, NULL, NULL, 232257),
(254338, '1p97A00', NULL, NULL, 114, NULL, NULL, 232257),
(254339, '4r38A00', NULL, NULL, 120, NULL, NULL, 232257),
(254340, '3libA02', NULL, NULL, 138, NULL, NULL, 232257),
(254341, '3by8A00', NULL, NULL, 142, NULL, NULL, 232257),
(254342, '3fg8A00', NULL, NULL, 118, NULL, NULL, 232257),
(254343, '2vlgC00', NULL, NULL, 111, NULL, NULL, 232257),
(254344, '5djtA00', NULL, NULL, 145, NULL, NULL, 232257),
(254345, '3t50A00', NULL, NULL, 128, NULL, NULL, 232257),
(254346, '2pr5B00', NULL, NULL, 132, NULL, NULL, 232257),
(254347, '5dkkA00', NULL, NULL, 145, NULL, NULL, 232257),
(254348, '2j80B00', NULL, NULL, 135, NULL, NULL, 232257),
(254349, '3gdiB02', NULL, NULL, 158, NULL, NULL, 232257),
(254350, '4ywzB00', NULL, NULL, 152, NULL, NULL, 232257),
(254351, '5hsqA02', NULL, NULL, 129, NULL, NULL, 232257),
(254352, '4dj2B02', NULL, NULL, 158, NULL, NULL, 232257),
(254353, '5kizA00', NULL, NULL, 114, NULL, NULL, 232257),
(254354, '2basB03', NULL, NULL, 116, NULL, NULL, 232257),
(254355, '3f1pA00', NULL, NULL, 117, NULL, NULL, 232257),
(254356, '4gw9A02', NULL, NULL, 92, NULL, NULL, 232257),
(254357, '3cloC01', NULL, NULL, 194, NULL, NULL, 232257),
(254358, '3luqB00', NULL, NULL, 114, NULL, NULL, 232257),
(254359, '3by9B01', NULL, NULL, 133, NULL, NULL, 232257),
(254360, '5g4zA00', NULL, NULL, 158, NULL, NULL, 232257),
(254361, '5ajgA01', NULL, NULL, 157, NULL, NULL, 232257),
(254362, '4exoA00', NULL, NULL, 146, NULL, NULL, 232257),
(254363, '4hhdA00', NULL, NULL, 166, NULL, NULL, 232257),
(254364, '4m4xA00', NULL, NULL, 161, NULL, NULL, 232257),
(254365, '4gw9A04', NULL, NULL, 124, NULL, NULL, 232257),
(254366, '3caxA02', NULL, NULL, 148, NULL, NULL, 232257),
(254367, '2pd8B00', NULL, NULL, 149, NULL, NULL, 232257),
(254368, '4q0jA02', NULL, NULL, 137, NULL, NULL, 232257),
(254369, '3f1pB01', NULL, NULL, 110, NULL, NULL, 232257),
(254370, '4rq9A01', NULL, NULL, 111, NULL, NULL, 232257),
(254371, '4eepA00', NULL, NULL, 115, NULL, NULL, 232257),
(254372, '2z6dA00', NULL, NULL, 130, NULL, NULL, 232257),
(254373, '4hiaA00', NULL, NULL, 176, NULL, NULL, 232257),
(254374, '4lrzE02', NULL, NULL, 106, NULL, NULL, 232257),
(254375, '3libH01', NULL, NULL, 152, NULL, NULL, 232257),
(254376, '1nwzA00', NULL, NULL, 125, NULL, NULL, 232257),
(254377, '1n9lA00', NULL, NULL, 109, NULL, NULL, 232257),
(254378, '4f3lA03', NULL, NULL, 122, NULL, NULL, 232257),
(254379, '4f3lA02', NULL, NULL, 144, NULL, NULL, 232257),
(254380, '4mn6A00', NULL, NULL, 107, NULL, NULL, 232257),
(254381, '3b33A00', NULL, NULL, 115, NULL, NULL, 232257),
(254382, '4lloB00', NULL, NULL, 134, NULL, NULL, 232257),
(254383, '4ew7A00', NULL, NULL, 127, NULL, NULL, 232257),
(254384, '1xfnA00', NULL, NULL, 113, NULL, NULL, 232257),
(254385, '4nxfA00', NULL, NULL, 118, NULL, NULL, 232257),
(254386, '2basA03', NULL, NULL, 116, NULL, NULL, 232257),
(254387, '4eeuA00', NULL, NULL, 118, NULL, NULL, 232257),
(254388, '6gg9A00', NULL, NULL, 144, NULL, NULL, 232257),
(254389, '4kukA00', NULL, NULL, 127, NULL, NULL, 232257),
(254390, '1s67L00', NULL, NULL, 119, NULL, NULL, 232257),
(254391, '3ewkA01', NULL, NULL, 103, NULL, NULL, 232257);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(254392, '2gj3A00', NULL, NULL, 120, NULL, NULL, 232257),
(254393, '3ewkA03', NULL, NULL, 107, NULL, NULL, 232257),
(254394, '3lifB01', NULL, NULL, 150, NULL, NULL, 232257),
(254395, '3licA02', NULL, NULL, 96, NULL, NULL, 232257),
(254396, '2jheA02', NULL, NULL, 109, NULL, NULL, 232257),
(254397, '3licA01', NULL, NULL, 178, NULL, NULL, 232257),
(254398, '2ea9A01', NULL, NULL, 96, NULL, NULL, 232257),
(254399, '4kqdB00', NULL, NULL, 121, NULL, NULL, 232257),
(254400, '1d06A00', NULL, NULL, 130, NULL, NULL, 232257),
(254401, '4k08A00', NULL, NULL, 153, NULL, NULL, 232257),
(254402, '4l9fA00', NULL, NULL, 115, NULL, NULL, 232257),
(254403, '4i5sA02', NULL, NULL, 98, NULL, NULL, 232257),
(254404, '5j7eC00', NULL, NULL, 121, NULL, NULL, 232257),
(254405, '6rhfA00', NULL, NULL, 113, NULL, NULL, 232257),
(254406, '4f3lB03', NULL, NULL, 120, NULL, NULL, 232257),
(254407, '4f3lB02', NULL, NULL, 193, NULL, NULL, 232257),
(254408, '3cwfA00', NULL, NULL, 122, NULL, NULL, 232257),
(254409, '2l1mA00', NULL, NULL, 150, NULL, NULL, 232257),
(254410, '4wn5A00', NULL, NULL, 115, NULL, NULL, 232257),
(254411, '5iu1B00', NULL, NULL, 116, NULL, NULL, 232257),
(254412, '3ub8A00', NULL, NULL, 181, NULL, NULL, 232257),
(254413, '3mr0A01', NULL, NULL, 121, NULL, NULL, 232257),
(254414, '1ll8A00', NULL, NULL, 114, NULL, NULL, 232257),
(254415, '5luvA00', NULL, NULL, 146, NULL, NULL, 232257),
(254416, '2w27A03', NULL, NULL, 116, NULL, NULL, 232257),
(254417, '4wujD00', NULL, NULL, 147, NULL, NULL, 232257),
(254418, '3eehA00', NULL, NULL, 125, NULL, NULL, 232257),
(254419, '4wf0A00', NULL, NULL, 158, NULL, NULL, 232257),
(254420, '3h9wA00', NULL, NULL, 115, NULL, NULL, 232257),
(254421, '3rtyB01', NULL, NULL, 138, NULL, NULL, 232257),
(254422, '3fc7A00', NULL, NULL, 100, NULL, NULL, 232257),
(254423, '3mfxB00', NULL, NULL, 129, NULL, NULL, 232257),
(254424, '3njaB01', NULL, NULL, 76, NULL, NULL, 232257),
(254425, '4hp9A00', NULL, NULL, 128, NULL, NULL, 232257),
(254426, '6i20C00', NULL, NULL, 130, NULL, NULL, 232257),
(254427, '3mjqA00', NULL, NULL, 108, NULL, NULL, 232257),
(254428, '4mn5A00', NULL, NULL, 128, NULL, NULL, 232257),
(254429, '2inwA01', NULL, NULL, 107, NULL, NULL, 232257),
(254430, '2veaA02', NULL, NULL, 140, NULL, NULL, 232257),
(254431, '3lifA02', NULL, NULL, 90, NULL, NULL, 232257),
(254432, '3oloA00', NULL, NULL, 118, NULL, NULL, 232257),
(254433, '4e04B01', NULL, NULL, 122, NULL, NULL, 232257),
(254434, '1wa9A02', NULL, NULL, 168, NULL, NULL, 232257),
(254435, '4hp4A00', NULL, NULL, 130, NULL, NULL, 232257),
(254436, '5svvD00', NULL, NULL, 137, NULL, NULL, 232257),
(254437, '6baoA02', NULL, NULL, 143, NULL, NULL, 232257),
(254438, '1otdA00', NULL, NULL, 105, NULL, NULL, 232257),
(254439, '2hzdA00', NULL, NULL, 82, NULL, NULL, 232258),
(254440, '3gs9A01', NULL, NULL, 90, NULL, NULL, 232259),
(254441, '4qdcA02', NULL, NULL, 229, NULL, NULL, 232260),
(254442, '2ckfC01', NULL, NULL, 326, NULL, NULL, 232260),
(254443, '1z01A01', NULL, NULL, 298, NULL, NULL, 232260),
(254444, '3gkeA02', NULL, NULL, 218, NULL, NULL, 232260),
(254445, '3gcfA01', NULL, NULL, 281, NULL, NULL, 232260),
(254446, '2zylA02', NULL, NULL, 231, NULL, NULL, 232260),
(254447, '2gbwC01', NULL, NULL, 333, NULL, NULL, 232260),
(254448, '1wqlA01', NULL, NULL, 310, NULL, NULL, 232260),
(254449, '3n0qA01', NULL, NULL, 290, NULL, NULL, 232260),
(254450, '4qdfB02', NULL, NULL, 238, NULL, NULL, 232260),
(254451, '5aewU01', NULL, NULL, 311, NULL, NULL, 232260),
(254452, '3gkqA01', NULL, NULL, 276, NULL, NULL, 232260),
(254453, '3eqqA01', NULL, NULL, 323, NULL, NULL, 232260),
(254454, '4hm8A01', NULL, NULL, 320, NULL, NULL, 232260),
(254455, '2bmoA01', NULL, NULL, 318, NULL, NULL, 232260),
(254456, '2b1xA01', NULL, NULL, 315, NULL, NULL, 232260),
(254457, '3vcaA01', NULL, NULL, 293, NULL, NULL, 232260),
(254458, '5xbpA01', NULL, NULL, 317, NULL, NULL, 232260),
(254459, '2de6A01', NULL, NULL, 267, NULL, NULL, 232260),
(254460, '1uliA01', NULL, NULL, 317, NULL, NULL, 232260),
(254461, '3gzxA01', NULL, NULL, 309, NULL, NULL, 232260),
(254462, '4uzbA00', NULL, NULL, 141, NULL, NULL, 232261);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(254463, '4blgA00', NULL, NULL, 141, NULL, NULL, 232261),
(254464, '6nppB00', NULL, NULL, 134, NULL, NULL, 232261),
(254465, '5t7xA00', NULL, NULL, 149, NULL, NULL, 232261),
(254466, '2yq1C00', NULL, NULL, 139, NULL, NULL, 232261),
(254467, '4k2jB00', NULL, NULL, 140, NULL, NULL, 232261),
(254468, '6hx1A03', NULL, NULL, 130, NULL, NULL, 232262),
(254469, '2rioA03', NULL, NULL, 133, NULL, NULL, 232262),
(254470, '4oavD03', NULL, NULL, 131, NULL, NULL, 232262),
(254471, '4pl3A03', NULL, NULL, 143, NULL, NULL, 232262),
(254472, '4o1pA03', NULL, NULL, 147, NULL, NULL, 232262),
(254473, '4u5hA00', NULL, NULL, 90, NULL, NULL, 232263),
(254474, '2iwxA00', NULL, NULL, 214, NULL, NULL, 232264),
(254475, '4i5sB04', NULL, NULL, 160, NULL, NULL, 232264),
(254476, '4urlA01', NULL, NULL, 206, NULL, NULL, 232264),
(254477, '1s14B00', NULL, NULL, 178, NULL, NULL, 232264),
(254478, '1tilA00', NULL, NULL, 146, NULL, NULL, 232264),
(254479, '4q20A02', NULL, NULL, 160, NULL, NULL, 232264),
(254480, '4e01A02', NULL, NULL, 195, NULL, NULL, 232264),
(254481, '4hy1A01', NULL, NULL, 214, NULL, NULL, 232264),
(254482, '1id0A00', NULL, NULL, 152, NULL, NULL, 232264),
(254483, '2gqpA00', NULL, NULL, 236, NULL, NULL, 232264),
(254484, '4mpcA02', NULL, NULL, 184, NULL, NULL, 232264),
(254485, '5idmA00', NULL, NULL, 179, NULL, NULL, 232264),
(254486, '5zxmA01', NULL, NULL, 208, NULL, NULL, 232264),
(254487, '5cphA00', NULL, NULL, 196, NULL, NULL, 232264),
(254488, '3lnuA01', NULL, NULL, 203, NULL, NULL, 232264),
(254489, '2cg9A01', NULL, NULL, 227, NULL, NULL, 232264),
(254490, '6cjiA00', NULL, NULL, 214, NULL, NULL, 232264),
(254491, '4xclA00', NULL, NULL, 223, NULL, NULL, 232264),
(254492, '4fppA02', NULL, NULL, 137, NULL, NULL, 232264),
(254493, '3cwvA01', NULL, NULL, 206, NULL, NULL, 232264),
(254494, '4gczB03', NULL, NULL, 166, NULL, NULL, 232264),
(254495, '5ucjC00', NULL, NULL, 220, NULL, NULL, 232264),
(254496, '1b63A01', NULL, NULL, 216, NULL, NULL, 232264),
(254497, '3u67A00', NULL, NULL, 231, NULL, NULL, 232264),
(254498, '1h7sA01', NULL, NULL, 203, NULL, NULL, 232264),
(254499, '1zxmA01', NULL, NULL, 239, NULL, NULL, 232264),
(254500, '4u7oB02', NULL, NULL, 171, NULL, NULL, 232264),
(254501, '1r62A00', NULL, NULL, 160, NULL, NULL, 232264),
(254502, '3cgzA00', NULL, NULL, 157, NULL, NULL, 232264),
(254503, '1gkxA01', NULL, NULL, 151, NULL, NULL, 232264),
(254504, '3h4lA01', NULL, NULL, 221, NULL, NULL, 232264),
(254505, '5h22A00', NULL, NULL, 215, NULL, NULL, 232264),
(254506, '3fv5B00', NULL, NULL, 201, NULL, NULL, 232264),
(254507, '4iynB01', NULL, NULL, 203, NULL, NULL, 232264),
(254508, '2c2aA02', NULL, NULL, 168, NULL, NULL, 232264),
(254509, '4baeD00', NULL, NULL, 205, NULL, NULL, 232264),
(254510, '4pl9A00', NULL, NULL, 183, NULL, NULL, 232264),
(254511, '3zxoA00', NULL, NULL, 129, NULL, NULL, 232264),
(254512, '4bizA02', NULL, NULL, 155, NULL, NULL, 232264),
(254513, '2e0aA02', NULL, NULL, 185, NULL, NULL, 232264),
(254514, '3pehA01', NULL, NULL, 217, NULL, NULL, 232264),
(254515, '3zxqB00', NULL, NULL, 124, NULL, NULL, 232264),
(254516, '4qpkB02', NULL, NULL, 134, NULL, NULL, 232264),
(254517, '5f3kB00', NULL, NULL, 213, NULL, NULL, 232264),
(254518, '2q8gA02', NULL, NULL, 185, NULL, NULL, 232264),
(254519, '3ke6A02', NULL, NULL, 142, NULL, NULL, 232264),
(254520, '2o1uB01', NULL, NULL, 165, NULL, NULL, 232264),
(254521, '4bxiA00', NULL, NULL, 153, NULL, NULL, 232264),
(254522, '3a0yB00', NULL, NULL, 152, NULL, NULL, 232264),
(254523, '3zkbP01', NULL, NULL, 202, NULL, NULL, 232264),
(254524, '1ysrA00', NULL, NULL, 150, NULL, NULL, 232264),
(254525, '1y8oA02', NULL, NULL, 185, NULL, NULL, 232264),
(254526, '6enhA01', NULL, NULL, 219, NULL, NULL, 232264),
(254527, '2iorA00', NULL, NULL, 216, NULL, NULL, 232264),
(254528, '4x9lA00', NULL, NULL, 215, NULL, NULL, 232264),
(254529, '6blkC00', NULL, NULL, 158, NULL, NULL, 232264),
(254530, '4duhA00', NULL, NULL, 220, NULL, NULL, 232264),
(254531, '1mu5A01', NULL, NULL, 221, NULL, NULL, 232264),
(254532, '4gqtA00', NULL, NULL, 227, NULL, NULL, 232264),
(254533, '5j80A00', NULL, NULL, 225, NULL, NULL, 232264);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(254534, '3iedA00', NULL, NULL, 240, NULL, NULL, 232264),
(254535, '4k4oA00', NULL, NULL, 215, NULL, NULL, 232264),
(254536, '3d36B01', NULL, NULL, 160, NULL, NULL, 232264),
(254537, '3nmqA00', NULL, NULL, 239, NULL, NULL, 232264),
(254538, '1i58A00', NULL, NULL, 189, NULL, NULL, 232264),
(254539, '4uroA00', NULL, NULL, 206, NULL, NULL, 232264),
(254540, '4p7aA01', NULL, NULL, 214, NULL, NULL, 232264),
(254541, '3k60A00', NULL, NULL, 223, NULL, NULL, 232264),
(254542, '2q2eB01', NULL, NULL, 234, NULL, NULL, 232264),
(254543, '1pvgA01', NULL, NULL, 244, NULL, NULL, 232264),
(254544, '3t0hA00', NULL, NULL, 228, NULL, NULL, 232264),
(254545, '4hymB00', NULL, NULL, 273, NULL, NULL, 232264),
(254546, '4gt8A00', NULL, NULL, 139, NULL, NULL, 232264),
(254547, '3ehgA00', NULL, NULL, 128, NULL, NULL, 232264),
(254548, '4emvA00', NULL, NULL, 210, NULL, NULL, 232264),
(254549, '2xcmA00', NULL, NULL, 214, NULL, NULL, 232264),
(254550, '4kp4A02', NULL, NULL, 157, NULL, NULL, 232264),
(254551, '3o6oB00', NULL, NULL, 214, NULL, NULL, 232264),
(254552, '1th8A00', NULL, NULL, 145, NULL, NULL, 232264),
(254553, '3jz3B01', NULL, NULL, 174, NULL, NULL, 232264),
(254554, '4hz5A00', NULL, NULL, 216, NULL, NULL, 232264),
(254555, '4r3aA02', NULL, NULL, 150, NULL, NULL, 232264),
(254556, '3sl2A00', NULL, NULL, 153, NULL, NULL, 232264),
(254557, '4a57A01', NULL, NULL, 245, NULL, NULL, 232265),
(254558, '3agrA01', NULL, NULL, 238, NULL, NULL, 232265),
(254559, '2freA00', NULL, NULL, 200, NULL, NULL, 232266),
(254560, '3pxvC00', NULL, NULL, 189, NULL, NULL, 232266),
(254561, '4urpA00', NULL, NULL, 193, NULL, NULL, 232266),
(254562, '2wqfA00', NULL, NULL, 202, NULL, NULL, 232266),
(254563, '3pxvA00', NULL, NULL, 189, NULL, NULL, 232266),
(254564, '1f5vA00', NULL, NULL, 240, NULL, NULL, 232266),
(254565, '3eo8A00', NULL, NULL, 219, NULL, NULL, 232266),
(254566, '5j6cA00', NULL, NULL, 173, NULL, NULL, 232266),
(254567, '5heiC00', NULL, NULL, 253, NULL, NULL, 232266),
(254568, '5krdB00', NULL, NULL, 228, NULL, NULL, 232266),
(254569, '3ge6A00', NULL, NULL, 212, NULL, NULL, 232266),
(254570, '5yakE01', NULL, NULL, 184, NULL, NULL, 232266),
(254571, '2wzvA01', NULL, NULL, 231, NULL, NULL, 232266),
(254572, '3h4oA00', NULL, NULL, 171, NULL, NULL, 232266),
(254573, '3hj9B00', NULL, NULL, 223, NULL, NULL, 232266),
(254574, '3hznC00', NULL, NULL, 220, NULL, NULL, 232266),
(254575, '5hdjA00', NULL, NULL, 257, NULL, NULL, 232266),
(254576, '4eo3A02', NULL, NULL, 183, NULL, NULL, 232266),
(254577, '3gagA00', NULL, NULL, 206, NULL, NULL, 232266),
(254578, '1noxA00', NULL, NULL, 205, NULL, NULL, 232266),
(254579, '3k6hA01', NULL, NULL, 167, NULL, NULL, 232266),
(254580, '3kwkA00', NULL, NULL, 175, NULL, NULL, 232266),
(254581, '3e39A00', NULL, NULL, 178, NULL, NULL, 232266),
(254582, '2h0uA00', NULL, NULL, 217, NULL, NULL, 232266),
(254583, '6czpG00', NULL, NULL, 220, NULL, NULL, 232266),
(254584, '3e10A00', NULL, NULL, 168, NULL, NULL, 232266),
(254585, '3bemB00', NULL, NULL, 218, NULL, NULL, 232266),
(254586, '3gr3A00', NULL, NULL, 230, NULL, NULL, 232266),
(254587, '1ywqA00', NULL, NULL, 200, NULL, NULL, 232266),
(254588, '3ge5A00', NULL, NULL, 176, NULL, NULL, 232266),
(254589, '4xomB00', NULL, NULL, 207, NULL, NULL, 232266),
(254590, '2iskA01', NULL, NULL, 204, NULL, NULL, 232266),
(254591, '3gfaA00', NULL, NULL, 198, NULL, NULL, 232266),
(254592, '3ek3A01', NULL, NULL, 171, NULL, NULL, 232266),
(254593, '2ymvA02', NULL, NULL, 225, NULL, NULL, 232266),
(254594, '3eofB00', NULL, NULL, 248, NULL, NULL, 232266),
(254595, '1kqbA00', NULL, NULL, 217, NULL, NULL, 232266),
(254596, '1icrA00', NULL, NULL, 217, NULL, NULL, 232266),
(254597, '3bm1A00', NULL, NULL, 183, NULL, NULL, 232266),
(254598, '4g8sA00', NULL, NULL, 191, NULL, NULL, 232266),
(254599, '4dn2A00', NULL, NULL, 192, NULL, NULL, 232266),
(254600, '3g14B00', NULL, NULL, 193, NULL, NULL, 232266),
(254601, '3pxvD00', NULL, NULL, 189, NULL, NULL, 232266),
(254602, '3pxvB00', NULL, NULL, 189, NULL, NULL, 232266),
(254603, '5j62B00', NULL, NULL, 215, NULL, NULL, 232266),
(254604, '1vfrA00', NULL, NULL, 218, NULL, NULL, 232266);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(254605, '1zchA00', NULL, NULL, 255, NULL, NULL, 232266),
(254606, '3hoiA00', NULL, NULL, 193, NULL, NULL, 232266),
(254607, '3gbhA00', NULL, NULL, 213, NULL, NULL, 232266),
(254608, '3ge6B00', NULL, NULL, 212, NULL, NULL, 232266),
(254609, '4qlxB00', NULL, NULL, 219, NULL, NULL, 232266),
(254610, '1vkwA01', NULL, NULL, 122, NULL, NULL, 232266),
(254611, '2r01A01', NULL, NULL, 166, NULL, NULL, 232266),
(254612, '3n2sD00', NULL, NULL, 249, NULL, NULL, 232266),
(254613, '2i7hA00', NULL, NULL, 189, NULL, NULL, 232266),
(254614, '3eo7A02', NULL, NULL, 257, NULL, NULL, 232266),
(254615, '3eo7A01', NULL, NULL, 240, NULL, NULL, 232266),
(254616, '3gb5A00', NULL, NULL, 224, NULL, NULL, 232266),
(254617, '3of4A00', NULL, NULL, 209, NULL, NULL, 232266),
(254618, '2hayC00', NULL, NULL, 224, NULL, NULL, 232266),
(254619, '3m5kA00', NULL, NULL, 172, NULL, NULL, 232266),
(254620, '3bemA00', NULL, NULL, 218, NULL, NULL, 232266),
(254621, '1bkjA00', NULL, NULL, 240, NULL, NULL, 232266),
(254622, '2b67A00', NULL, NULL, 204, NULL, NULL, 232266),
(254623, '5uu6A00', NULL, NULL, 243, NULL, NULL, 232266),
(254624, '2ifaB00', NULL, NULL, 208, NULL, NULL, 232266),
(254625, '3qdlA00', NULL, NULL, 178, NULL, NULL, 232266),
(254626, '1o9iA02', NULL, NULL, 63, NULL, NULL, 232267),
(254627, '2qrdA00', NULL, NULL, 137, NULL, NULL, 232268),
(254628, '1v5sA00', NULL, NULL, 126, NULL, NULL, 232268),
(254629, '4zhxC03', NULL, NULL, 90, NULL, NULL, 232268),
(254630, '1ul7A00', NULL, NULL, 102, NULL, NULL, 232268),
(254631, '3oseA00', NULL, NULL, 100, NULL, NULL, 232268),
(254632, '3t4nA01', NULL, NULL, 126, NULL, NULL, 232268),
(254633, '2v8qA01', NULL, NULL, 89, NULL, NULL, 232268),
(254634, '2zfdB00', NULL, NULL, 123, NULL, NULL, 232268),
(254635, '2y8lA01', NULL, NULL, 91, NULL, NULL, 232268),
(254636, '2y94A03', NULL, NULL, 76, NULL, NULL, 232268),
(254637, '2ehbD00', NULL, NULL, 127, NULL, NULL, 232268),
(254638, '4eagA01', NULL, NULL, 117, NULL, NULL, 232268),
(254639, '2v9bA00', NULL, NULL, 46, NULL, NULL, 232269),
(254640, '1ejgA00', NULL, NULL, 46, NULL, NULL, 232269),
(254641, '3ue7B00', NULL, NULL, 46, NULL, NULL, 232269),
(254642, '1wuwA00', NULL, NULL, 45, NULL, NULL, 232269),
(254643, '1bhpA00', NULL, NULL, 45, NULL, NULL, 232269),
(254644, '1jmnA00', NULL, NULL, 46, NULL, NULL, 232269),
(254645, '3nirA00', NULL, NULL, 46, NULL, NULL, 232269),
(254646, '1okhA00', NULL, NULL, 46, NULL, NULL, 232269),
(254647, '1orlA00', NULL, NULL, 46, NULL, NULL, 232269),
(254648, '3szsB00', NULL, NULL, 46, NULL, NULL, 232269),
(254649, '2plhA00', NULL, NULL, 45, NULL, NULL, 232269),
(254650, '3c8pA00', NULL, NULL, 46, NULL, NULL, 232269),
(254651, '4qhbD01', NULL, NULL, 216, NULL, NULL, 232270),
(254652, '4r4xA02', NULL, NULL, 189, NULL, NULL, 232270),
(254653, '3ks7B01', NULL, NULL, 218, NULL, NULL, 232270),
(254654, '3aiiA02', NULL, NULL, 64, NULL, NULL, 232271),
(254655, '3payC01', NULL, NULL, 177, NULL, NULL, 232272),
(254656, '3gf8A01', NULL, NULL, 170, NULL, NULL, 232272),
(254657, '4qdgA01', NULL, NULL, 171, NULL, NULL, 232272),
(254658, '2qtsA04', NULL, NULL, 84, NULL, NULL, 232273),
(254659, '4zy7A00', NULL, NULL, 143, NULL, NULL, 232274),
(254660, '2ln3A00', NULL, NULL, 83, NULL, NULL, 232275),
(254661, '2yggA00', NULL, NULL, 70, NULL, NULL, 232276),
(254662, '1s3rA02', NULL, NULL, 53, NULL, NULL, 232277),
(254663, '3hvnA02', NULL, NULL, 53, NULL, NULL, 232277),
(254664, '4hscX02', NULL, NULL, 53, NULL, NULL, 232277),
(254665, '1pfoA02', NULL, NULL, 53, NULL, NULL, 232277),
(254666, '3cqfA02', NULL, NULL, 53, NULL, NULL, 232277),
(254667, '3gcmA03', NULL, NULL, 225, NULL, NULL, 232278),
(254668, '3krnA00', NULL, NULL, 222, NULL, NULL, 232278),
(254669, '5xexE01', NULL, NULL, 226, NULL, NULL, 232278),
(254670, '5xexD03', NULL, NULL, 231, NULL, NULL, 232278),
(254671, '3hkmB00', NULL, NULL, 246, NULL, NULL, 232278),
(254672, '4nbqA03', NULL, NULL, 223, NULL, NULL, 232278),
(254673, '4nbqA01', NULL, NULL, 237, NULL, NULL, 232278),
(254674, '1r6lA01', NULL, NULL, 226, NULL, NULL, 232278),
(254675, '1e3hA01', NULL, NULL, 248, NULL, NULL, 232278);
INSERT INTO "PUBLIC"."MODEL" VALUES
(254676, '2wnrB01', NULL, NULL, 217, NULL, NULL, 232278),
(254677, '1oysA01', NULL, NULL, 233, NULL, NULL, 232278),
(254678, '2nn6D00', NULL, NULL, 211, NULL, NULL, 232278),
(254679, '2nn6E00', NULL, NULL, 287, NULL, NULL, 232278),
(254680, '2nn6F00', NULL, NULL, 244, NULL, NULL, 232278),
(254681, '2wnrE00', NULL, NULL, 251, NULL, NULL, 232278),
(254682, '2wp8A00', NULL, NULL, 305, NULL, NULL, 232278),
(254683, '3gmeA01', NULL, NULL, 226, NULL, NULL, 232278),
(254684, '6d6qA00', NULL, NULL, 287, NULL, NULL, 232278),
(254685, '1e3pA03', NULL, NULL, 227, NULL, NULL, 232278),
(254686, '3u1kA03', NULL, NULL, 232, NULL, NULL, 232278),
(254687, '3u1kC01', NULL, NULL, 229, NULL, NULL, 232278),
(254688, '3dd6A01', NULL, NULL, 233, NULL, NULL, 232278),
(254689, '2po1A01', NULL, NULL, 226, NULL, NULL, 232278),
(254690, '2po1B00', NULL, NULL, 277, NULL, NULL, 232278),
(254691, '2nn6B01', NULL, NULL, 226, NULL, NULL, 232278),
(254692, '2nn6C00', NULL, NULL, 278, NULL, NULL, 232278),
(254693, '3m7nE01', NULL, NULL, 235, NULL, NULL, 232278),
(254694, '3m7nG01', NULL, NULL, 253, NULL, NULL, 232278),
(254695, '1udnA01', NULL, NULL, 243, NULL, NULL, 232278),
(254696, '2je6B01', NULL, NULL, 223, NULL, NULL, 232278),
(254697, '3b4tA01', NULL, NULL, 245, NULL, NULL, 232278),
(254698, '5jeaB00', NULL, NULL, 249, NULL, NULL, 232278),
(254699, '5jeaC00', NULL, NULL, 394, NULL, NULL, 232278),
(254700, '4aidB01', NULL, NULL, 244, NULL, NULL, 232278),
(254701, '5jeaD00', NULL, NULL, 226, NULL, NULL, 232278),
(254702, '2je6A01', NULL, NULL, 264, NULL, NULL, 232278),
(254703, '4aidB02', NULL, NULL, 326, NULL, NULL, 232278),
(254704, '5jeaE00', NULL, NULL, 268, NULL, NULL, 232278),
(254705, '5jeaF00', NULL, NULL, 250, NULL, NULL, 232278),
(254706, '4aidC03', NULL, NULL, 223, NULL, NULL, 232278),
(254707, '3bk3C00', NULL, NULL, 67, NULL, NULL, 232279),
(254708, '1v8dC00', NULL, NULL, 196, NULL, NULL, 232280),
(254709, '1ui0A00', NULL, NULL, 205, NULL, NULL, 232281),
(254710, '3wdfA00', NULL, NULL, 226, NULL, NULL, 232281),
(254711, '3zoqA00', NULL, NULL, 225, NULL, NULL, 232281),
(254712, '3cxmA00', NULL, NULL, 244, NULL, NULL, 232281),
(254713, '5h9iA00', NULL, NULL, 240, NULL, NULL, 232281),
(254714, '2d3yA00', NULL, NULL, 219, NULL, NULL, 232281),
(254715, '2c2qA01', NULL, NULL, 180, NULL, NULL, 232281),
(254716, '4uqmA00', NULL, NULL, 247, NULL, NULL, 232281),
(254717, '3uf7A00', NULL, NULL, 237, NULL, NULL, 232281),
(254718, '5nnhA00', NULL, NULL, 240, NULL, NULL, 232281),
(254719, '1udgA00', NULL, NULL, 228, NULL, NULL, 232281),
(254720, '2l3fA00', NULL, NULL, 166, NULL, NULL, 232281),
(254721, '4zbyA00', NULL, NULL, 194, NULL, NULL, 232281),
(254722, '1vk2A00', NULL, NULL, 204, NULL, NULL, 232281),
(254723, '1okbA00', NULL, NULL, 223, NULL, NULL, 232281),
(254724, '1mugA00', NULL, NULL, 168, NULL, NULL, 232281),
(254725, '2jhqA00', NULL, NULL, 226, NULL, NULL, 232281),
(254726, '3fciA00', NULL, NULL, 223, NULL, NULL, 232281),
(254727, '3ikbA00', NULL, NULL, 198, NULL, NULL, 232281),
(254728, '4ygmB00', NULL, NULL, 232, NULL, NULL, 232281),
(254729, '3tr7A00', NULL, NULL, 232, NULL, NULL, 232281),
(254730, '2j8xC00', NULL, NULL, 231, NULL, NULL, 232281),
(254731, '4z47A00', NULL, NULL, 204, NULL, NULL, 232281),
(254732, '4wpkA00', NULL, NULL, 238, NULL, NULL, 232281),
(254733, '1oe4A00', NULL, NULL, 247, NULL, NULL, 232281),
(254734, '4nq3A03', NULL, NULL, 109, NULL, NULL, 232282),
(254735, '5t13A03', NULL, NULL, 116, NULL, NULL, 232282),
(254736, '4bvqA03', NULL, NULL, 110, NULL, NULL, 232282),
(254737, '5hweA03', NULL, NULL, 118, NULL, NULL, 232282),
(254738, '5hy0D03', NULL, NULL, 118, NULL, NULL, 232282),
(254739, '4dguA01', NULL, NULL, 127, NULL, NULL, 232283),
(254740, '1cwvA04', NULL, NULL, 91, NULL, NULL, 232284),
(254741, '2mh4A00', NULL, NULL, 101, NULL, NULL, 232284),
(254742, '4hu8A01', NULL, NULL, 78, NULL, NULL, 232284),
(254743, '1f00I02', NULL, NULL, 89, NULL, NULL, 232284),
(254744, '2l04A00', NULL, NULL, 91, NULL, NULL, 232284),
(254745, '2mogA00', NULL, NULL, 95, NULL, NULL, 232284),
(254746, '3ncxB01', NULL, NULL, 96, NULL, NULL, 232284);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(254747, '4aq1A02', NULL, NULL, 91, NULL, NULL, 232284),
(254748, '1fn9A02', NULL, NULL, 225, NULL, NULL, 232285),
(254749, '4khbC00', NULL, NULL, 127, NULL, NULL, 232286),
(254750, '3qc5X01', NULL, NULL, 154, NULL, NULL, 232287),
(254751, '4csbA00', NULL, NULL, 124, NULL, NULL, 232288),
(254752, '5aeoA00', NULL, NULL, 125, NULL, NULL, 232288),
(254753, '4cv7A00', NULL, NULL, 113, NULL, NULL, 232288),
(254754, '3bo6B01', NULL, NULL, 199, NULL, NULL, 232289),
(254755, '2z8nA01', NULL, NULL, 193, NULL, NULL, 232289),
(254756, '3i0uB01', NULL, NULL, 184, NULL, NULL, 232289),
(254757, '1p1hB01', NULL, NULL, 192, NULL, NULL, 232290),
(254758, '2cw8A02', NULL, NULL, 146, NULL, NULL, 232291),
(254759, '3myuB02', NULL, NULL, 187, NULL, NULL, 232292),
(254760, '3ekiA02', NULL, NULL, 189, NULL, NULL, 232292),
(254761, '1kn7A00', NULL, NULL, 78, NULL, NULL, 232293),
(254762, '2b2nB01', NULL, NULL, 232, NULL, NULL, 232294),
(254763, '3hjhA01', NULL, NULL, 267, NULL, NULL, 232294),
(254764, '1vu2201', NULL, NULL, 170, NULL, NULL, 232295),
(254765, '2lehA00', NULL, NULL, 189, NULL, NULL, 232295),
(254766, '2lw6A00', NULL, NULL, 80, NULL, NULL, 232296),
(254767, '3zfiA00', NULL, NULL, 104, NULL, NULL, 232297),
(254768, '3fssA01', NULL, NULL, 141, NULL, NULL, 232298),
(254769, '1yn5A00', NULL, NULL, 103, NULL, NULL, 232299),
(254770, '1fnuA02', NULL, NULL, 138, NULL, NULL, 232299),
(254771, '1yn3A00', NULL, NULL, 98, NULL, NULL, 232299),
(254772, '1bxtA02', NULL, NULL, 144, NULL, NULL, 232299),
(254773, '1ty0B01', NULL, NULL, 136, NULL, NULL, 232299),
(254774, '1v1oA01', NULL, NULL, 122, NULL, NULL, 232299),
(254775, '2iciA01', NULL, NULL, 149, NULL, NULL, 232299),
(254776, '2g9hD01', NULL, NULL, 148, NULL, NULL, 232299),
(254777, '3o13A01', NULL, NULL, 126, NULL, NULL, 232299),
(254778, '1an8A01', NULL, NULL, 133, NULL, NULL, 232299),
(254779, '4dxfA01', NULL, NULL, 128, NULL, NULL, 232299),
(254780, '3r2tA01', NULL, NULL, 121, NULL, NULL, 232299),
(254781, '5i4dB01', NULL, NULL, 117, NULL, NULL, 232299),
(254782, '4rfbA01', NULL, NULL, 119, NULL, NULL, 232299),
(254783, '1enfA02', NULL, NULL, 133, NULL, NULL, 232299),
(254784, '1yn4A00', NULL, NULL, 99, NULL, NULL, 232299),
(254785, '1et9A01', NULL, NULL, 110, NULL, NULL, 232299),
(254786, '1eu3A01', NULL, NULL, 122, NULL, NULL, 232299),
(254787, '2z8lA01', NULL, NULL, 117, NULL, NULL, 232299),
(254788, '2qejD01', NULL, NULL, 127, NULL, NULL, 232299),
(254789, '1dyqA02', NULL, NULL, 148, NULL, NULL, 232299),
(254790, '2j4xA01', NULL, NULL, 127, NULL, NULL, 232299),
(254791, '1sebD02', NULL, NULL, 138, NULL, NULL, 232299),
(254792, '2rdgA01', NULL, NULL, 125, NULL, NULL, 232299),
(254793, '3sebA02', NULL, NULL, 134, NULL, NULL, 232299),
(254794, '4zysA01', NULL, NULL, 122, NULL, NULL, 232299),
(254795, '5fkaC01', NULL, NULL, 147, NULL, NULL, 232299),
(254796, '3mc0D01', NULL, NULL, 150, NULL, NULL, 232299),
(254797, '3r2iA01', NULL, NULL, 120, NULL, NULL, 232299),
(254798, '3ea6A01', NULL, NULL, 149, NULL, NULL, 232299),
(254799, '4o1nD01', NULL, NULL, 115, NULL, NULL, 232299),
(254800, '4ohjB01', NULL, NULL, 140, NULL, NULL, 232299),
(254801, '2aq2B01', NULL, NULL, 151, NULL, NULL, 232299),
(254802, '3gmgA00', NULL, NULL, 152, NULL, NULL, 232300),
(254803, '4iaoC01', NULL, NULL, 68, NULL, NULL, 232301),
(254804, '3ziwA02', NULL, NULL, 115, NULL, NULL, 232302),
(254805, '3am2A02', NULL, NULL, 124, NULL, NULL, 232302),
(254806, '1d0qA00', NULL, NULL, 103, NULL, NULL, 232303),
(254807, '2au3A01', NULL, NULL, 99, NULL, NULL, 232303),
(254808, '2r7rA02', NULL, NULL, 153, NULL, NULL, 232304),
(254809, '2olvA01', NULL, NULL, 108, NULL, NULL, 232305),
(254810, '3dwkB01', NULL, NULL, 103, NULL, NULL, 232305),
(254811, '2zg6A02', NULL, NULL, 77, NULL, NULL, 232306),
(254812, '5emiA00', NULL, NULL, 180, NULL, NULL, 232307),
(254813, '2q7sA00', NULL, NULL, 290, NULL, NULL, 232307),
(254814, '4lq6A00', NULL, NULL, 218, NULL, NULL, 232307),
(254815, '2odfB01', NULL, NULL, 243, NULL, NULL, 232307),
(254816, '4binA02', NULL, NULL, 243, NULL, NULL, 232307),
(254817, '1jwqA00', NULL, NULL, 179, NULL, NULL, 232307);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(254818, '3qayA00', NULL, NULL, 180, NULL, NULL, 232307),
(254819, '1xovA01', NULL, NULL, 188, NULL, NULL, 232307),
(254820, '4rn7A00', NULL, NULL, 188, NULL, NULL, 232307),
(254821, '3ne8A00', NULL, NULL, 234, NULL, NULL, 232307),
(254822, '3czxA00', NULL, NULL, 182, NULL, NULL, 232307),
(254823, '2lu1A00', NULL, NULL, 89, NULL, NULL, 232308),
(254824, '3o0lB00', NULL, NULL, 112, NULL, NULL, 232309),
(254825, '4gioA00', NULL, NULL, 107, NULL, NULL, 232309),
(254826, '4khoB01', NULL, NULL, 167, NULL, NULL, 232310),
(254827, '4pq0A01', NULL, NULL, 140, NULL, NULL, 232310),
(254828, '4z2nA01', NULL, NULL, 155, NULL, NULL, 232310),
(254829, '5umsA01', NULL, NULL, 136, NULL, NULL, 232310),
(254830, '5umuA01', NULL, NULL, 155, NULL, NULL, 232310),
(254831, '4ioyX01', NULL, NULL, 153, NULL, NULL, 232310),
(254832, '3u12A00', NULL, NULL, 104, NULL, NULL, 232311),
(254833, '3h3aA04', NULL, NULL, 50, NULL, NULL, 232312),
(254834, '6q52A04', NULL, NULL, 61, NULL, NULL, 232312),
(254835, '1miwA04', NULL, NULL, 64, NULL, NULL, 232312),
(254836, '2cxaA02', NULL, NULL, 178, NULL, NULL, 232313),
(254837, '1r8oB01', NULL, NULL, 66, NULL, NULL, 232314),
(254838, '6i0y501', NULL, NULL, 130, NULL, NULL, 232315),
(254839, '3jsyA01', NULL, NULL, 133, NULL, NULL, 232315),
(254840, '1zavA01', NULL, NULL, 135, NULL, NULL, 232315),
(254841, '2qa4G01', NULL, NULL, 122, NULL, NULL, 232315),
(254842, '4v19J00', NULL, NULL, 168, NULL, NULL, 232315),
(254843, '4nwbA01', NULL, NULL, 132, NULL, NULL, 232315),
(254844, '1vx4q01', NULL, NULL, 133, NULL, NULL, 232315),
(254845, '5o60I00', NULL, NULL, 126, NULL, NULL, 232315),
(254846, '5oomI00', NULL, NULL, 168, NULL, NULL, 232315),
(254847, '3kitJ00', NULL, NULL, 133, NULL, NULL, 232315),
(254848, '3u5iq00', NULL, NULL, 145, NULL, NULL, 232315),
(254849, '3a1yG01', NULL, NULL, 134, NULL, NULL, 232315),
(254850, '4hubG01', NULL, NULL, 175, NULL, NULL, 232315),
(254851, '3o5hM00', NULL, NULL, 132, NULL, NULL, 232315),
(254852, '2lseA00', NULL, NULL, 101, NULL, NULL, 232316),
(254853, '3iefA02', NULL, NULL, 65, NULL, NULL, 232317),
(254854, '4ig6A02', NULL, NULL, 61, NULL, NULL, 232317),
(254855, '1p9pA02', NULL, NULL, 95, NULL, NULL, 232317),
(254856, '4h3zA02', NULL, NULL, 84, NULL, NULL, 232317),
(254857, '4yqaA02', NULL, NULL, 74, NULL, NULL, 232317),
(254858, '4mccA02', NULL, NULL, 59, NULL, NULL, 232317),
(254859, '5wyqA02', NULL, NULL, 75, NULL, NULL, 232317),
(254860, '1oy5A02', NULL, NULL, 57, NULL, NULL, 232317),
(254861, '1uajA02', NULL, NULL, 94, NULL, NULL, 232317),
(254862, '5zhjA02', NULL, NULL, 79, NULL, NULL, 232317),
(254863, '3ky7A02', NULL, NULL, 76, NULL, NULL, 232317),
(254864, '3quvB02', NULL, NULL, 77, NULL, NULL, 232317),
(254865, '5zhiA02', NULL, NULL, 61, NULL, NULL, 232317),
(254866, '3knuD02', NULL, NULL, 37, NULL, NULL, 232317),
(254867, '1ywmA02', NULL, NULL, 78, NULL, NULL, 232318),
(254868, '1vs5U01', NULL, NULL, 39, NULL, NULL, 232319),
(254869, '2w56B00', NULL, NULL, 147, NULL, NULL, 232320),
(254870, '2v1lA00', NULL, NULL, 148, NULL, NULL, 232320),
(254871, '4k17A02', NULL, NULL, 44, NULL, NULL, 232321),
(254872, '3a1yA00', NULL, NULL, 58, NULL, NULL, 232322),
(254873, '4behB01', NULL, NULL, 61, NULL, NULL, 232322),
(254874, '4behA01', NULL, NULL, 64, NULL, NULL, 232322),
(254875, '3kk7A01', NULL, NULL, 111, NULL, NULL, 232323),
(254876, '3n91A02', NULL, NULL, 136, NULL, NULL, 232324),
(254877, '2ahmE01', NULL, NULL, 51, NULL, NULL, 232325),
(254878, '3urgA02', NULL, NULL, 66, NULL, NULL, 232326),
(254879, '3n7sD00', NULL, NULL, 96, NULL, NULL, 232327),
(254880, '3aqeA00', NULL, NULL, 91, NULL, NULL, 232327),
(254881, '2yx8A00', NULL, NULL, 93, NULL, NULL, 232327),
(254882, '2xvtC00', NULL, NULL, 94, NULL, NULL, 232327),
(254883, '3f3hA00', NULL, NULL, 111, NULL, NULL, 232328),
(254884, '1osyB00', NULL, NULL, 115, NULL, NULL, 232328),
(254885, '3kcwA00', NULL, NULL, 111, NULL, NULL, 232328),
(254886, '4hl6B01', NULL, NULL, 284, NULL, NULL, 232329),
(254887, '1xk7B01', NULL, NULL, 305, NULL, NULL, 232329),
(254888, '1xk6A01', NULL, NULL, 305, NULL, NULL, 232329);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(254889, '4ed9A01', NULL, NULL, 293, NULL, NULL, 232329),
(254890, '1xk7C01', NULL, NULL, 305, NULL, NULL, 232329),
(254891, '1x74A01', NULL, NULL, 175, NULL, NULL, 232329),
(254892, '3ubmA01', NULL, NULL, 331, NULL, NULL, 232329),
(254893, '2vjqA01', NULL, NULL, 331, NULL, NULL, 232329),
(254894, '1q7eA01', NULL, NULL, 331, NULL, NULL, 232329),
(254895, '1xa4A01', NULL, NULL, 298, NULL, NULL, 232329),
(254896, '1xa3B01', NULL, NULL, 318, NULL, NULL, 232329),
(254897, '1xvtA01', NULL, NULL, 305, NULL, NULL, 232329),
(254898, '1xvuA01', NULL, NULL, 305, NULL, NULL, 232329),
(254899, '1xk7A01', NULL, NULL, 305, NULL, NULL, 232329),
(254900, '2yimA01', NULL, NULL, 271, NULL, NULL, 232329),
(254901, '2g04A01', NULL, NULL, 270, NULL, NULL, 232329),
(254902, '2vh3A00', NULL, NULL, 113, NULL, NULL, 232330),
(254903, '6a8uA00', NULL, NULL, 149, NULL, NULL, 232331),
(254904, '3bqaA00', NULL, NULL, 148, NULL, NULL, 232331),
(254905, '4ueyA00', NULL, NULL, 153, NULL, NULL, 232331),
(254906, '1u7lA01', NULL, NULL, 119, NULL, NULL, 232332),
(254907, '4ds7E00', NULL, NULL, 55, NULL, NULL, 232333),
(254908, '4dbfA01', NULL, NULL, 58, NULL, NULL, 232334),
(254909, '3qdfA01', NULL, NULL, 61, NULL, NULL, 232334),
(254910, '3rr6A01', NULL, NULL, 61, NULL, NULL, 232334),
(254911, '4pfzB01', NULL, NULL, 54, NULL, NULL, 232334),
(254912, '1wzoA01', NULL, NULL, 40, NULL, NULL, 232334),
(254913, '2dfuA01', NULL, NULL, 44, NULL, NULL, 232334),
(254914, '1zzaA00', NULL, NULL, 90, NULL, NULL, 232335),
(254915, '2dsmA00', NULL, NULL, 72, NULL, NULL, 232336),
(254916, '2z1dA02', NULL, NULL, 165, NULL, NULL, 232337),
(254917, '5uv2A01', NULL, NULL, 200, NULL, NULL, 232338),
(254918, '6o9qA01', NULL, NULL, 200, NULL, NULL, 232338),
(254919, '3sdrA01', NULL, NULL, 252, NULL, NULL, 232338),
(254920, '5il3A02', NULL, NULL, 160, NULL, NULL, 232338),
(254921, '5jo7D01', NULL, NULL, 198, NULL, NULL, 232338),
(254922, '4gaxA02', NULL, NULL, 162, NULL, NULL, 232338),
(254923, '2j5cA01', NULL, NULL, 179, NULL, NULL, 232338),
(254924, '3p5pA01', NULL, NULL, 242, NULL, NULL, 232338),
(254925, '3s9vA01', NULL, NULL, 244, NULL, NULL, 232338),
(254926, '1n1bA01', NULL, NULL, 206, NULL, NULL, 232338),
(254927, '2ongA01', NULL, NULL, 204, NULL, NULL, 232338),
(254928, '3g4dA02', NULL, NULL, 160, NULL, NULL, 232338),
(254929, '4lixA01', NULL, NULL, 237, NULL, NULL, 232338),
(254930, '3n0fA01', NULL, NULL, 200, NULL, NULL, 232338),
(254931, '5c05A01', NULL, NULL, 202, NULL, NULL, 232338),
(254932, '5dqxA00', NULL, NULL, 252, NULL, NULL, 232339),
(254933, '1qd5A00', NULL, NULL, 257, NULL, NULL, 232339),
(254934, '4j42B00', NULL, NULL, 93, NULL, NULL, 232340),
(254935, '4w4kA00', NULL, NULL, 107, NULL, NULL, 232340),
(254936, '4w4lA00', NULL, NULL, 90, NULL, NULL, 232340),
(254937, '4iyhA00', NULL, NULL, 98, NULL, NULL, 232340),
(254938, '3fx7A00', NULL, NULL, 94, NULL, NULL, 232340),
(254939, '1bh9B00', NULL, NULL, 89, NULL, NULL, 232341),
(254940, '2nqbD00', NULL, NULL, 95, NULL, NULL, 232341),
(254941, '5ay8E00', NULL, NULL, 98, NULL, NULL, 232341),
(254942, '1kx3G00', NULL, NULL, 128, NULL, NULL, 232341),
(254943, '4csrB00', NULL, NULL, 94, NULL, NULL, 232341),
(254944, '2yfvB00', NULL, NULL, 74, NULL, NULL, 232341),
(254945, '2ly8A00', NULL, NULL, 121, NULL, NULL, 232341),
(254946, '2bykD00', NULL, NULL, 98, NULL, NULL, 232341),
(254947, '1ulyA02', NULL, NULL, 102, NULL, NULL, 232341),
(254948, '1kx5B00', NULL, NULL, 102, NULL, NULL, 232341),
(254949, '1tzyE00', NULL, NULL, 129, NULL, NULL, 232341),
(254950, '1kx5D00', NULL, NULL, 125, NULL, NULL, 232341),
(254951, '5b0zG00', NULL, NULL, 115, NULL, NULL, 232341),
(254952, '5x7xA00', NULL, NULL, 98, NULL, NULL, 232341),
(254953, '1r4vA00', NULL, NULL, 151, NULL, NULL, 232341),
(254954, '4khaB00', NULL, NULL, 92, NULL, NULL, 232341),
(254955, '1tzyC00', NULL, NULL, 95, NULL, NULL, 232341),
(254956, '1wwiA00', NULL, NULL, 148, NULL, NULL, 232341),
(254957, '3v9rB00', NULL, NULL, 88, NULL, NULL, 232341),
(254958, '1kx3A00', NULL, NULL, 98, NULL, NULL, 232341),
(254959, '3v9rD00', NULL, NULL, 88, NULL, NULL, 232341);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(254960, '2rvqD00', NULL, NULL, 129, NULL, NULL, 232341),
(254961, '2io5B00', NULL, NULL, 76, NULL, NULL, 232341),
(254962, '5y0dA00', NULL, NULL, 98, NULL, NULL, 232341),
(254963, '2l5aA00', NULL, NULL, 235, NULL, NULL, 232341),
(254964, '4jjnF00', NULL, NULL, 102, NULL, NULL, 232341),
(254965, '1h3oB00', NULL, NULL, 76, NULL, NULL, 232341),
(254966, '1jfiB00', NULL, NULL, 146, NULL, NULL, 232341),
(254967, '5omxG00', NULL, NULL, 129, NULL, NULL, 232341),
(254968, '2yfwE00', NULL, NULL, 92, NULL, NULL, 232341),
(254969, '6nj9A00', NULL, NULL, 99, NULL, NULL, 232341),
(254970, '1q9cA01', NULL, NULL, 155, NULL, NULL, 232341),
(254971, '5g49A00', NULL, NULL, 97, NULL, NULL, 232341),
(254972, '1tafA00', NULL, NULL, 68, NULL, NULL, 232341),
(254973, '1b67A00', NULL, NULL, 68, NULL, NULL, 232341),
(254974, '3x1tC00', NULL, NULL, 128, NULL, NULL, 232341),
(254975, '2hueC00', NULL, NULL, 84, NULL, NULL, 232341),
(254976, '2bykA00', NULL, NULL, 72, NULL, NULL, 232341),
(254977, '3b0dB00', NULL, NULL, 111, NULL, NULL, 232341),
(254978, '4wnnD00', NULL, NULL, 102, NULL, NULL, 232341),
(254979, '5chlB00', NULL, NULL, 193, NULL, NULL, 232341),
(254980, '4g92C00', NULL, NULL, 119, NULL, NULL, 232341),
(254981, '1ku5A00', NULL, NULL, 70, NULL, NULL, 232341),
(254982, '4drbD00', NULL, NULL, 120, NULL, NULL, 232341),
(254983, '4cayA00', NULL, NULL, 91, NULL, NULL, 232341),
(254984, '4x23A00', NULL, NULL, 98, NULL, NULL, 232341),
(254985, '5veyA00', NULL, NULL, 194, NULL, NULL, 232341),
(254986, '1a7wA00', NULL, NULL, 69, NULL, NULL, 232341),
(254987, '3ksyA01', NULL, NULL, 155, NULL, NULL, 232341),
(254988, '3azjG00', NULL, NULL, 96, NULL, NULL, 232341),
(254989, '5y27A00', NULL, NULL, 107, NULL, NULL, 232341),
(254990, '4wzsB00', NULL, NULL, 149, NULL, NULL, 232341),
(254991, '2nqbG00', NULL, NULL, 123, NULL, NULL, 232341),
(254992, '4h9nA00', NULL, NULL, 99, NULL, NULL, 232341),
(254993, '3b0dC00', NULL, NULL, 76, NULL, NULL, 232341),
(254994, '4wnnA00', NULL, NULL, 86, NULL, NULL, 232341),
(254995, '3b0bB00', NULL, NULL, 107, NULL, NULL, 232341),
(254996, '6a7uA00', NULL, NULL, 204, NULL, NULL, 232341),
(254997, '4wv4B00', NULL, NULL, 97, NULL, NULL, 232341),
(254998, '4csrA00', NULL, NULL, 94, NULL, NULL, 232341),
(254999, '2yfvA00', NULL, NULL, 73, NULL, NULL, 232341),
(255000, '5zbxA00', NULL, NULL, 100, NULL, NULL, 232341),
(255001, '1kx5A00', NULL, NULL, 135, NULL, NULL, 232341),
(255002, '4z5tE00', NULL, NULL, 97, NULL, NULL, 232341),
(255003, '5z23G00', NULL, NULL, 104, NULL, NULL, 232341),
(255004, '5gt0C00', NULL, NULL, 130, NULL, NULL, 232341),
(255005, '2f8nG00', NULL, NULL, 120, NULL, NULL, 232341),
(255006, '1kx3D00', NULL, NULL, 94, NULL, NULL, 232341),
(255007, '3v9rA00', NULL, NULL, 90, NULL, NULL, 232341),
(255008, '1tzyF00', NULL, NULL, 93, NULL, NULL, 232341),
(255009, '3wkjD00', NULL, NULL, 94, NULL, NULL, 232341),
(255010, '6ae8A00', NULL, NULL, 193, NULL, NULL, 232341),
(255011, '1jfiA00', NULL, NULL, 75, NULL, NULL, 232341),
(255012, '4jjnE00', NULL, NULL, 97, NULL, NULL, 232341),
(255013, '1h3oA00', NULL, NULL, 50, NULL, NULL, 232341),
(255014, '4jjnC00', NULL, NULL, 131, NULL, NULL, 232341),
(255015, '2yfwB00', NULL, NULL, 74, NULL, NULL, 232341),
(255016, '5g49B00', NULL, NULL, 95, NULL, NULL, 232341),
(255017, '5z23C00', NULL, NULL, 121, NULL, NULL, 232341),
(255018, '6e0pA00', NULL, NULL, 99, NULL, NULL, 232341),
(255019, '5b1mD00', NULL, NULL, 95, NULL, NULL, 232341),
(255020, '2hueB00', NULL, NULL, 77, NULL, NULL, 232341),
(255021, '1tafB00', NULL, NULL, 70, NULL, NULL, 232341),
(255022, '4g92B00', NULL, NULL, 92, NULL, NULL, 232341),
(255023, '5b31G00', NULL, NULL, 112, NULL, NULL, 232341),
(255024, '4cayB00', NULL, NULL, 97, NULL, NULL, 232341),
(255025, '4ne3A00', NULL, NULL, 93, NULL, NULL, 232341),
(255026, '1f1eA00', NULL, NULL, 154, NULL, NULL, 232341),
(255027, '1bh9A00', NULL, NULL, 45, NULL, NULL, 232341),
(255028, '5wvoC02', NULL, NULL, 97, NULL, NULL, 232342),
(255029, '2ynqA00', NULL, NULL, 161, NULL, NULL, 232343),
(255030, '5xnlC02', NULL, NULL, 96, NULL, NULL, 232344);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(255031, '5b66C02', NULL, NULL, 96, NULL, NULL, 232344),
(255032, '3k4tB00', NULL, NULL, 73, NULL, NULL, 232345),
(255033, '2m3lA00', NULL, NULL, 76, NULL, NULL, 232346),
(255034, '4xr8F01', NULL, NULL, 66, NULL, NULL, 232346),
(255035, '2ljyA00', NULL, NULL, 84, NULL, NULL, 232346),
(255036, '4xr8H02', NULL, NULL, 76, NULL, NULL, 232346),
(255037, '3vbhD00', NULL, NULL, 58, NULL, NULL, 232347),
(255038, '5c4wD00', NULL, NULL, 69, NULL, NULL, 232347),
(255039, '2yilA02', NULL, NULL, 55, NULL, NULL, 232348),
(255040, '6q4tA01', NULL, NULL, 151, NULL, NULL, 232349),
(255041, '1noyA01', NULL, NULL, 135, NULL, NULL, 232349),
(255042, '2p5gB01', NULL, NULL, 204, NULL, NULL, 232349),
(255043, '5h12A01', NULL, NULL, 151, NULL, NULL, 232349),
(255044, '5omvA01', NULL, NULL, 151, NULL, NULL, 232349),
(255045, '1tgoA01', NULL, NULL, 151, NULL, NULL, 232349),
(255046, '3qexA01', NULL, NULL, 151, NULL, NULL, 232349),
(255047, '4ahcA01', NULL, NULL, 151, NULL, NULL, 232349),
(255048, '1d5aA01', NULL, NULL, 151, NULL, NULL, 232349),
(255049, '4flwA01', NULL, NULL, 154, NULL, NULL, 232349),
(255050, '2conA00', NULL, NULL, 79, NULL, NULL, 232350),
(255051, '4a9aA01', NULL, NULL, 126, NULL, NULL, 232351),
(255052, '5xnlo02', NULL, NULL, 39, NULL, NULL, 232352),
(255053, '3jcuO02', NULL, NULL, 39, NULL, NULL, 232352),
(255054, '5b66O02', NULL, NULL, 36, NULL, NULL, 232352),
(255055, '3o3mD03', NULL, NULL, 156, NULL, NULL, 232353),
(255056, '1he1A00', NULL, NULL, 135, NULL, NULL, 232354),
(255057, '1hy5B00', NULL, NULL, 136, NULL, NULL, 232354),
(255058, '1he9A00', NULL, NULL, 134, NULL, NULL, 232354),
(255059, '1g4uS01', NULL, NULL, 133, NULL, NULL, 232354),
(255060, '1r4tA00', NULL, NULL, 135, NULL, NULL, 232354),
(255061, '4akgA06', NULL, NULL, 107, NULL, NULL, 232355),
(255062, '3vkgB04', NULL, NULL, 131, NULL, NULL, 232355),
(255063, '2lq4p01', NULL, NULL, 43, NULL, NULL, 232356),
(255064, '3h90A01', NULL, NULL, 199, NULL, NULL, 232357),
(255065, '2qlzA02', NULL, NULL, 86, NULL, NULL, 232358),
(255066, '4ps6A00', NULL, NULL, 130, NULL, NULL, 232359),
(255067, '1xs0A00', NULL, NULL, 136, NULL, NULL, 232359),
(255068, '2kafA00', NULL, NULL, 67, NULL, NULL, 232360),
(255069, '1vw3C02', NULL, NULL, 67, NULL, NULL, 232361),
(255070, '2w2sA00', NULL, NULL, 173, NULL, NULL, 232362),
(255071, '1vw4T01', NULL, NULL, 112, NULL, NULL, 232363),
(255072, '1qw2A00', NULL, NULL, 102, NULL, NULL, 232364),
(255073, '4i7aD00', NULL, NULL, 95, NULL, NULL, 232365),
(255074, '2hd3A00', NULL, NULL, 103, NULL, NULL, 232365),
(255075, '2qw7C00', NULL, NULL, 95, NULL, NULL, 232365),
(255076, '5l37C00', NULL, NULL, 95, NULL, NULL, 232365),
(255077, '4jvzA00', NULL, NULL, 99, NULL, NULL, 232365),
(255078, '4jw0A00', NULL, NULL, 108, NULL, NULL, 232365),
(255079, '2rcfA00', NULL, NULL, 91, NULL, NULL, 232365),
(255080, '4n8xT00', NULL, NULL, 109, NULL, NULL, 232365),
(255081, '4zg4E04', NULL, NULL, 151, NULL, NULL, 232366),
(255082, '2v26A05', NULL, NULL, 163, NULL, NULL, 232366),
(255083, '1lkxA04', NULL, NULL, 188, NULL, NULL, 232366),
(255084, '2mysA05', NULL, NULL, 151, NULL, NULL, 232366),
(255085, '1vomA04', NULL, NULL, 160, NULL, NULL, 232366),
(255086, '1lvkA05', NULL, NULL, 150, NULL, NULL, 232366),
(255087, '1b7tA04', NULL, NULL, 159, NULL, NULL, 232366),
(255088, '1br2A04', NULL, NULL, 206, NULL, NULL, 232366),
(255089, '4fw1A02', NULL, NULL, 55, NULL, NULL, 232367),
(255090, '5tc2A00', NULL, NULL, 56, NULL, NULL, 232367),
(255091, '1ihvA00', NULL, NULL, 52, NULL, NULL, 232367),
(255092, '1c6vX00', NULL, NULL, 58, NULL, NULL, 232367),
(255093, '5d7uA00', NULL, NULL, 58, NULL, NULL, 232367),
(255094, '1ex4B02', NULL, NULL, 59, NULL, NULL, 232367),
(255095, '4a1rC00', NULL, NULL, 149, NULL, NULL, 232368),
(255096, '3zhnA00', NULL, NULL, 131, NULL, NULL, 232368),
(255097, '3rx9A00', NULL, NULL, 134, NULL, NULL, 232368),
(255098, '4nooB00', NULL, NULL, 98, NULL, NULL, 232369),
(255099, '4nsoB00', NULL, NULL, 108, NULL, NULL, 232369),
(255100, '2gnxA01', NULL, NULL, 209, NULL, NULL, 232370),
(255101, '3hshE00', NULL, NULL, 56, NULL, NULL, 232371);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(255102, '3n3fA01', NULL, NULL, 43, NULL, NULL, 232371),
(255103, '5tw4A02', NULL, NULL, 69, NULL, NULL, 232372),
(255104, '4pr6A00', NULL, NULL, 95, NULL, NULL, 232373),
(255105, '4uqtA00', NULL, NULL, 93, NULL, NULL, 232373),
(255106, '3ulhA00', NULL, NULL, 84, NULL, NULL, 232373),
(255107, '2aymA00', NULL, NULL, 83, NULL, NULL, 232373),
(255108, '3culA00', NULL, NULL, 98, NULL, NULL, 232373),
(255109, '2hglA01', NULL, NULL, 100, NULL, NULL, 232373),
(255110, '4wiiB01', NULL, NULL, 99, NULL, NULL, 232373),
(255111, '2fphX02', NULL, NULL, 88, NULL, NULL, 232373),
(255112, '2ghpA03', NULL, NULL, 85, NULL, NULL, 232373),
(255113, '3u1lA02', NULL, NULL, 110, NULL, NULL, 232373),
(255114, '2osrA00', NULL, NULL, 87, NULL, NULL, 232373),
(255115, '2mxyA00', NULL, NULL, 105, NULL, NULL, 232373),
(255116, '2dnpA01', NULL, NULL, 73, NULL, NULL, 232373),
(255117, '3d2wA00', NULL, NULL, 89, NULL, NULL, 232373),
(255118, '2m2bA00', NULL, NULL, 131, NULL, NULL, 232373),
(255119, '2mmyA01', NULL, NULL, 86, NULL, NULL, 232373),
(255120, '2g0cA00', NULL, NULL, 76, NULL, NULL, 232373),
(255121, '4eglA02', NULL, NULL, 63, NULL, NULL, 232373),
(255122, '2e5jA01', NULL, NULL, 88, NULL, NULL, 232373),
(255123, '5ho4A02', NULL, NULL, 81, NULL, NULL, 232373),
(255124, '5ho4A01', NULL, NULL, 85, NULL, NULL, 232373),
(255125, '2f3jA02', NULL, NULL, 103, NULL, NULL, 232373),
(255126, '1ufwA00', NULL, NULL, 95, NULL, NULL, 232373),
(255127, '1wf1A01', NULL, NULL, 90, NULL, NULL, 232373),
(255128, '2dnkA00', NULL, NULL, 105, NULL, NULL, 232373),
(255129, '2mzqA00', NULL, NULL, 101, NULL, NULL, 232373),
(255130, '2q79A00', NULL, NULL, 93, NULL, NULL, 232373),
(255131, '1n88A00', NULL, NULL, 96, NULL, NULL, 232373),
(255132, '5cyjA00', NULL, NULL, 98, NULL, NULL, 232373),
(255133, '3ue2A01', NULL, NULL, 88, NULL, NULL, 232373),
(255134, '4lmzA02', NULL, NULL, 86, NULL, NULL, 232373),
(255135, '6hmaR00', NULL, NULL, 89, NULL, NULL, 232373),
(255136, '2cpfA00', NULL, NULL, 98, NULL, NULL, 232373),
(255137, '4lmzA01', NULL, NULL, 94, NULL, NULL, 232373),
(255138, '1uw4A00', NULL, NULL, 91, NULL, NULL, 232373),
(255139, '2mjuA01', NULL, NULL, 108, NULL, NULL, 232373),
(255140, '6cmnA00', NULL, NULL, 94, NULL, NULL, 232373),
(255141, '2do0A01', NULL, NULL, 76, NULL, NULL, 232373),
(255142, '1wf0A01', NULL, NULL, 78, NULL, NULL, 232373),
(255143, '2la4A00', NULL, NULL, 101, NULL, NULL, 232373),
(255144, '2mgzA00', NULL, NULL, 94, NULL, NULL, 232373),
(255145, '1qm9A02', NULL, NULL, 89, NULL, NULL, 232373),
(255146, '4a17R00', NULL, NULL, 121, NULL, NULL, 232373),
(255147, '1qm9A01', NULL, NULL, 98, NULL, NULL, 232373),
(255148, '3jb9a02', NULL, NULL, 69, NULL, NULL, 232373),
(255149, '1x4eA00', NULL, NULL, 85, NULL, NULL, 232373),
(255150, '3culB00', NULL, NULL, 98, NULL, NULL, 232373),
(255151, '2dhxA01', NULL, NULL, 75, NULL, NULL, 232373),
(255152, '1p27B00', NULL, NULL, 106, NULL, NULL, 232373),
(255153, '2n82B00', NULL, NULL, 104, NULL, NULL, 232373),
(255154, '2x1fA00', NULL, NULL, 96, NULL, NULL, 232373),
(255155, '3lqvA01', NULL, NULL, 80, NULL, NULL, 232373),
(255156, '2cpeA01', NULL, NULL, 85, NULL, NULL, 232373),
(255157, '2dguA00', NULL, NULL, 103, NULL, NULL, 232373),
(255158, '1h2vZ00', NULL, NULL, 93, NULL, NULL, 232373),
(255159, '1sjqA00', NULL, NULL, 105, NULL, NULL, 232373),
(255160, '1b7fA01', NULL, NULL, 71, NULL, NULL, 232373),
(255161, '1b7fA02', NULL, NULL, 77, NULL, NULL, 232373),
(255162, '2n3lA00', NULL, NULL, 89, NULL, NULL, 232373),
(255163, '2ad9A00', NULL, NULL, 98, NULL, NULL, 232373),
(255164, '2cq1A00', NULL, NULL, 101, NULL, NULL, 232373),
(255165, '2dnzA01', NULL, NULL, 93, NULL, NULL, 232373),
(255166, '5o2vA00', NULL, NULL, 92, NULL, NULL, 232373),
(255167, '3feyB00', NULL, NULL, 126, NULL, NULL, 232373),
(255168, '2i38A02', NULL, NULL, 85, NULL, NULL, 232373),
(255169, '3mdfA00', NULL, NULL, 85, NULL, NULL, 232373),
(255170, '1wezA01', NULL, NULL, 82, NULL, NULL, 232373),
(255171, '1xn9A00', NULL, NULL, 101, NULL, NULL, 232373),
(255172, '2u1aA00', NULL, NULL, 88, NULL, NULL, 232373);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(255173, '1sxlA00', NULL, NULL, 97, NULL, NULL, 232373),
(255174, '4y0fA00', NULL, NULL, 103, NULL, NULL, 232373),
(255175, '2e5iA01', NULL, NULL, 95, NULL, NULL, 232373),
(255176, '3nnaA02', NULL, NULL, 86, NULL, NULL, 232373),
(255177, '2rvjA01', NULL, NULL, 98, NULL, NULL, 232373),
(255178, '3egnA02', NULL, NULL, 102, NULL, NULL, 232373),
(255179, '2fc9A00', NULL, NULL, 101, NULL, NULL, 232373),
(255180, '3cunB00', NULL, NULL, 98, NULL, NULL, 232373),
(255181, '3sdeA02', NULL, NULL, 89, NULL, NULL, 232373),
(255182, '3rw6B01', NULL, NULL, 86, NULL, NULL, 232373),
(255183, '3sdeA01', NULL, NULL, 97, NULL, NULL, 232373),
(255184, '3s6eB00', NULL, NULL, 114, NULL, NULL, 232373),
(255185, '2cqcA01', NULL, NULL, 83, NULL, NULL, 232373),
(255186, '2bopA00', NULL, NULL, 85, NULL, NULL, 232373),
(255187, '5lxrA00', NULL, NULL, 90, NULL, NULL, 232373),
(255188, '2xs2A00', NULL, NULL, 102, NULL, NULL, 232373),
(255189, '1wg1A01', NULL, NULL, 71, NULL, NULL, 232373),
(255190, '4cq1B01', NULL, NULL, 78, NULL, NULL, 232373),
(255191, '6n3dA01', NULL, NULL, 86, NULL, NULL, 232373),
(255192, '3ucgA00', NULL, NULL, 89, NULL, NULL, 232373),
(255193, '2dgwA01', NULL, NULL, 80, NULL, NULL, 232373),
(255194, '1whvA00', NULL, NULL, 100, NULL, NULL, 232373),
(255195, '1vwxX00', NULL, NULL, 119, NULL, NULL, 232373),
(255196, '2lkzA01', NULL, NULL, 85, NULL, NULL, 232373),
(255197, '1x4dA00', NULL, NULL, 102, NULL, NULL, 232373),
(255198, '5w0hA00', NULL, NULL, 84, NULL, NULL, 232373),
(255199, '5uazA00', NULL, NULL, 111, NULL, NULL, 232373),
(255200, '2e44A01', NULL, NULL, 75, NULL, NULL, 232373),
(255201, '3p3dA00', NULL, NULL, 105, NULL, NULL, 232373),
(255202, '4iufA00', NULL, NULL, 77, NULL, NULL, 232373),
(255203, '4yudA01', NULL, NULL, 89, NULL, NULL, 232373),
(255204, '2dnoA00', NULL, NULL, 102, NULL, NULL, 232373),
(255205, '2dhaA00', NULL, NULL, 123, NULL, NULL, 232373),
(255206, '2j76E00', NULL, NULL, 81, NULL, NULL, 232373),
(255207, '2ywkA01', NULL, NULL, 79, NULL, NULL, 232373),
(255208, '2vooA02', NULL, NULL, 95, NULL, NULL, 232373),
(255209, '2cjkA01', NULL, NULL, 86, NULL, NULL, 232373),
(255210, '5oomU00', NULL, NULL, 153, NULL, NULL, 232373),
(255211, '2l08A00', NULL, NULL, 97, NULL, NULL, 232373),
(255212, '2cjkA02', NULL, NULL, 81, NULL, NULL, 232373),
(255213, '4f25A00', NULL, NULL, 85, NULL, NULL, 232373),
(255214, '4f02A01', NULL, NULL, 92, NULL, NULL, 232373),
(255215, '3smzA03', NULL, NULL, 101, NULL, NULL, 232373),
(255216, '3smzA02', NULL, NULL, 71, NULL, NULL, 232373),
(255217, '3smzA01', NULL, NULL, 112, NULL, NULL, 232373),
(255218, '1vq8S00', NULL, NULL, 85, NULL, NULL, 232373),
(255219, '3egzA00', NULL, NULL, 98, NULL, NULL, 232373),
(255220, '3sdeB02', NULL, NULL, 89, NULL, NULL, 232373),
(255221, '3sdeB01', NULL, NULL, 97, NULL, NULL, 232373),
(255222, '3thtA01', NULL, NULL, 97, NULL, NULL, 232373),
(255223, '2jwnA01', NULL, NULL, 100, NULL, NULL, 232373),
(255224, '2dnnA01', NULL, NULL, 82, NULL, NULL, 232373),
(255225, '5iqqA00', NULL, NULL, 91, NULL, NULL, 232373),
(255226, '1weyA00', NULL, NULL, 104, NULL, NULL, 232373),
(255227, '2dh7A00', NULL, NULL, 105, NULL, NULL, 232373),
(255228, '1r8hA00', NULL, NULL, 87, NULL, NULL, 232373),
(255229, '1fjcA00', NULL, NULL, 96, NULL, NULL, 232373),
(255230, '3tp2B02', NULL, NULL, 112, NULL, NULL, 232373),
(255231, '1f9fD00', NULL, NULL, 83, NULL, NULL, 232373),
(255232, '2mzjA00', NULL, NULL, 82, NULL, NULL, 232373),
(255233, '4cq1A02', NULL, NULL, 80, NULL, NULL, 232373),
(255234, '2do4A01', NULL, NULL, 76, NULL, NULL, 232373),
(255235, '2dgqA00', NULL, NULL, 108, NULL, NULL, 232373),
(255236, '2mkhA02', NULL, NULL, 102, NULL, NULL, 232373),
(255237, '2krrA01', NULL, NULL, 74, NULL, NULL, 232373),
(255238, '4zkaA01', NULL, NULL, 95, NULL, NULL, 232373),
(255239, '3q2sD00', NULL, NULL, 92, NULL, NULL, 232373),
(255240, '2g1dA00', NULL, NULL, 98, NULL, NULL, 232373),
(255241, '2krrA02', NULL, NULL, 77, NULL, NULL, 232373),
(255242, '3uwtA01', NULL, NULL, 109, NULL, NULL, 232373),
(255243, '2d9pA01', NULL, NULL, 74, NULL, NULL, 232373);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(255244, '2hgmA01', NULL, NULL, 82, NULL, NULL, 232373),
(255245, '5uzgA00', NULL, NULL, 101, NULL, NULL, 232373),
(255246, '5lslA00', NULL, NULL, 102, NULL, NULL, 232373),
(255247, '2rs2A00', NULL, NULL, 84, NULL, NULL, 232373),
(255248, '5dm6Q00', NULL, NULL, 93, NULL, NULL, 232373),
(255249, '2ki2A00', NULL, NULL, 90, NULL, NULL, 232373),
(255250, '2dhgA01', NULL, NULL, 79, NULL, NULL, 232373),
(255251, '3vajB01', NULL, NULL, 118, NULL, NULL, 232373),
(255252, '2cqhA00', NULL, NULL, 93, NULL, NULL, 232373),
(255253, '3vajB02', NULL, NULL, 56, NULL, NULL, 232373),
(255254, '2krbA00', NULL, NULL, 81, NULL, NULL, 232373),
(255255, '2g4bA01', NULL, NULL, 93, NULL, NULL, 232373),
(255256, '4p6qA01', NULL, NULL, 78, NULL, NULL, 232373),
(255257, '2m70A01', NULL, NULL, 87, NULL, NULL, 232373),
(255258, '6d0yA00', NULL, NULL, 151, NULL, NULL, 232373),
(255259, '4p6qA02', NULL, NULL, 76, NULL, NULL, 232373),
(255260, '2jrsA01', NULL, NULL, 79, NULL, NULL, 232373),
(255261, '4p6qA03', NULL, NULL, 95, NULL, NULL, 232373),
(255262, '2dgvA01', NULL, NULL, 87, NULL, NULL, 232373),
(255263, '1whwA01', NULL, NULL, 94, NULL, NULL, 232373),
(255264, '2disA01', NULL, NULL, 83, NULL, NULL, 232373),
(255265, '2rraA01', NULL, NULL, 87, NULL, NULL, 232373),
(255266, '2la6A01', NULL, NULL, 86, NULL, NULL, 232373),
(255267, '3u5iX00', NULL, NULL, 120, NULL, NULL, 232373),
(255268, '2jx2A00', NULL, NULL, 87, NULL, NULL, 232373),
(255269, '6qulU00', NULL, NULL, 100, NULL, NULL, 232373),
(255270, '3sxlA01', NULL, NULL, 71, NULL, NULL, 232373),
(255271, '3sxlA02', NULL, NULL, 55, NULL, NULL, 232373),
(255272, '2mkcA00', NULL, NULL, 118, NULL, NULL, 232373),
(255273, '2mztA00', NULL, NULL, 100, NULL, NULL, 232373),
(255274, '1wg5A01', NULL, NULL, 82, NULL, NULL, 232373),
(255275, '5kw6A02', NULL, NULL, 91, NULL, NULL, 232373),
(255276, '2m4mA00', NULL, NULL, 124, NULL, NULL, 232373),
(255277, '5tkzA00', NULL, NULL, 94, NULL, NULL, 232373),
(255278, '2ytcA01', NULL, NULL, 71, NULL, NULL, 232373),
(255279, '2dnhA00', NULL, NULL, 105, NULL, NULL, 232373),
(255280, '1d8zA00', NULL, NULL, 89, NULL, NULL, 232373),
(255281, '1x5oA01', NULL, NULL, 86, NULL, NULL, 232373),
(255282, '5tbxB00', NULL, NULL, 92, NULL, NULL, 232373),
(255283, '4qptA01', NULL, NULL, 104, NULL, NULL, 232373),
(255284, '4fxwC00', NULL, NULL, 106, NULL, NULL, 232373),
(255285, '3s01A01', NULL, NULL, 101, NULL, NULL, 232373),
(255286, '2rt3A00', NULL, NULL, 97, NULL, NULL, 232373),
(255287, '2dgsA01', NULL, NULL, 89, NULL, NULL, 232373),
(255288, '2divA01', NULL, NULL, 85, NULL, NULL, 232373),
(255289, '2mpuA00', NULL, NULL, 92, NULL, NULL, 232373),
(255290, '5wu6A01', NULL, NULL, 74, NULL, NULL, 232373),
(255291, '4f02D02', NULL, NULL, 96, NULL, NULL, 232373),
(255292, '4c0oC01', NULL, NULL, 77, NULL, NULL, 232373),
(255293, '3r27A01', NULL, NULL, 73, NULL, NULL, 232373),
(255294, '3zzyB00', NULL, NULL, 106, NULL, NULL, 232373),
(255295, '1wexA01', NULL, NULL, 73, NULL, NULL, 232373),
(255296, '1u1qA01', NULL, NULL, 87, NULL, NULL, 232373),
(255297, '3s8sA00', NULL, NULL, 110, NULL, NULL, 232373),
(255298, '1oiaA00', NULL, NULL, 95, NULL, NULL, 232373),
(255299, '1x4hA00', NULL, NULL, 111, NULL, NULL, 232373),
(255300, '2mb0B01', NULL, NULL, 76, NULL, NULL, 232373),
(255301, '2fc8A00', NULL, NULL, 102, NULL, NULL, 232373),
(255302, '2ek6A00', NULL, NULL, 95, NULL, NULL, 232373),
(255303, '2hvzA01', NULL, NULL, 72, NULL, NULL, 232373),
(255304, '3rw7A01', NULL, NULL, 55, NULL, NULL, 232373),
(255305, '3s7rA00', NULL, NULL, 87, NULL, NULL, 232373),
(255306, '1wwhA01', NULL, NULL, 74, NULL, NULL, 232373),
(255307, '5uzmA01', NULL, NULL, 90, NULL, NULL, 232373),
(255308, '2lxiA00', NULL, NULL, 91, NULL, NULL, 232373),
(255309, '2khcA00', NULL, NULL, 118, NULL, NULL, 232373),
(255310, '5zswA01', NULL, NULL, 85, NULL, NULL, 232373),
(255311, '2dgxA01', NULL, NULL, 80, NULL, NULL, 232373),
(255312, '2m88A01', NULL, NULL, 86, NULL, NULL, 232373),
(255313, '1d9aA00', NULL, NULL, 85, NULL, NULL, 232373),
(255314, '4yoeA02', NULL, NULL, 83, NULL, NULL, 232373);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(255315, '4v19X00', NULL, NULL, 150, NULL, NULL, 232373),
(255316, '3ns6A00', NULL, NULL, 100, NULL, NULL, 232373),
(255317, '3nmrA02', NULL, NULL, 86, NULL, NULL, 232373),
(255318, '4qu6A01', NULL, NULL, 98, NULL, NULL, 232373),
(255319, '3nmrA01', NULL, NULL, 89, NULL, NULL, 232373),
(255320, '2n3oA00', NULL, NULL, 123, NULL, NULL, 232373),
(255321, '5w0gA00', NULL, NULL, 87, NULL, NULL, 232373),
(255322, '2cqiA00', NULL, NULL, 103, NULL, NULL, 232373),
(255323, '4lirB01', NULL, NULL, 75, NULL, NULL, 232373),
(255324, '1ywxA01', NULL, NULL, 92, NULL, NULL, 232373),
(255325, '3cunA00', NULL, NULL, 98, NULL, NULL, 232373),
(255326, '1nu4A00', NULL, NULL, 97, NULL, NULL, 232373),
(255327, '2hgnA00', NULL, NULL, 95, NULL, NULL, 232373),
(255328, '1x5tA01', NULL, NULL, 94, NULL, NULL, 232373),
(255329, '2d9oA00', NULL, NULL, 100, NULL, NULL, 232373),
(255330, '2v94B00', NULL, NULL, 107, NULL, NULL, 232373),
(255331, '3md1A00', NULL, NULL, 83, NULL, NULL, 232373),
(255332, '3p5tM00', NULL, NULL, 90, NULL, NULL, 232373),
(255333, '1oo0B00', NULL, NULL, 93, NULL, NULL, 232373),
(255334, '5szwA00', NULL, NULL, 101, NULL, NULL, 232373),
(255335, '2leaA01', NULL, NULL, 91, NULL, NULL, 232373),
(255336, '2dnrA00', NULL, NULL, 91, NULL, NULL, 232373),
(255337, '2cq4A01', NULL, NULL, 97, NULL, NULL, 232373),
(255338, '3ctrA00', NULL, NULL, 75, NULL, NULL, 232373),
(255339, '5uznA00', NULL, NULL, 92, NULL, NULL, 232373),
(255340, '1fjeB01', NULL, NULL, 81, NULL, NULL, 232373),
(255341, '1whxA00', NULL, NULL, 111, NULL, NULL, 232373),
(255342, '2cpxA01', NULL, NULL, 79, NULL, NULL, 232373),
(255343, '5d78A00', NULL, NULL, 81, NULL, NULL, 232373),
(255344, '3bs9A00', NULL, NULL, 87, NULL, NULL, 232373),
(255345, '2xnqA00', NULL, NULL, 79, NULL, NULL, 232373),
(255346, '1wg4A01', NULL, NULL, 77, NULL, NULL, 232373),
(255347, '2mzsA00', NULL, NULL, 99, NULL, NULL, 232373),
(255348, '1jmtA00', NULL, NULL, 104, NULL, NULL, 232373),
(255349, '1a7gE00', NULL, NULL, 82, NULL, NULL, 232373),
(255350, '2dnmA00', NULL, NULL, 103, NULL, NULL, 232373),
(255351, '1fnxH01', NULL, NULL, 71, NULL, NULL, 232373),
(255352, '2dh8A01', NULL, NULL, 74, NULL, NULL, 232373),
(255353, '2cqdA01', NULL, NULL, 77, NULL, NULL, 232373),
(255354, '4fxvA00', NULL, NULL, 99, NULL, NULL, 232373),
(255355, '4ed5B02', NULL, NULL, 87, NULL, NULL, 232373),
(255356, '2cphA01', NULL, NULL, 79, NULL, NULL, 232373),
(255357, '4pkdB02', NULL, NULL, 126, NULL, NULL, 232373),
(255358, '4tlqB00', NULL, NULL, 97, NULL, NULL, 232373),
(255359, '3j7yU00', NULL, NULL, 112, NULL, NULL, 232373),
(255360, '1x4gA00', NULL, NULL, 109, NULL, NULL, 232373),
(255361, '2a3jA00', NULL, NULL, 106, NULL, NULL, 232373),
(255362, '5im0A00', NULL, NULL, 87, NULL, NULL, 232373),
(255363, '2mssA00', NULL, NULL, 75, NULL, NULL, 232373),
(255364, '6j6ga00', NULL, NULL, 84, NULL, NULL, 232373),
(255365, '5ca5A01', NULL, NULL, 95, NULL, NULL, 232373),
(255366, '5ca5A02', NULL, NULL, 89, NULL, NULL, 232373),
(255367, '3md3A01', NULL, NULL, 79, NULL, NULL, 232373),
(255368, '2dnlA01', NULL, NULL, 89, NULL, NULL, 232373),
(255369, '2rugA00', NULL, NULL, 114, NULL, NULL, 232373),
(255370, '1ft8E00', NULL, NULL, 57, NULL, NULL, 232373),
(255371, '1a9nD00', NULL, NULL, 96, NULL, NULL, 232373),
(255372, '1vx7Y01', NULL, NULL, 81, NULL, NULL, 232373),
(255373, '4n0tA04', NULL, NULL, 119, NULL, NULL, 232373),
(255374, '4n0tA03', NULL, NULL, 88, NULL, NULL, 232373),
(255375, '4n0tA02', NULL, NULL, 85, NULL, NULL, 232373),
(255376, '1hl6C00', NULL, NULL, 165, NULL, NULL, 232373),
(255377, '4n0tA01', NULL, NULL, 82, NULL, NULL, 232373),
(255378, '2m9kA00', NULL, NULL, 93, NULL, NULL, 232373),
(255379, '1wf2A00', NULL, NULL, 98, NULL, NULL, 232373),
(255380, '1kohA01', NULL, NULL, 106, NULL, NULL, 232373),
(255381, '2ku7A00', NULL, NULL, 140, NULL, NULL, 232373),
(255382, '3n9uI00', NULL, NULL, 99, NULL, NULL, 232373),
(255383, '1wtbA00', NULL, NULL, 79, NULL, NULL, 232373),
(255384, '4a8xA00', NULL, NULL, 88, NULL, NULL, 232373),
(255385, '2mjnA02', NULL, NULL, 87, NULL, NULL, 232373);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(255386, '2mkjA02', NULL, NULL, 99, NULL, NULL, 232373),
(255387, '1p1tA00', NULL, NULL, 104, NULL, NULL, 232373),
(255388, '2kviA00', NULL, NULL, 96, NULL, NULL, 232373),
(255389, '2mqmA01', NULL, NULL, 107, NULL, NULL, 232373),
(255390, '3tytA02', NULL, NULL, 94, NULL, NULL, 232373),
(255391, '2dngA00', NULL, NULL, 103, NULL, NULL, 232373),
(255392, '1l3kA02', NULL, NULL, 78, NULL, NULL, 232373),
(255393, '2cpzA01', NULL, NULL, 91, NULL, NULL, 232373),
(255394, '6f4jC00', NULL, NULL, 98, NULL, NULL, 232373),
(255395, '1l3kA01', NULL, NULL, 91, NULL, NULL, 232373),
(255396, '2cpjA00', NULL, NULL, 99, NULL, NULL, 232373),
(255397, '3o58W01', NULL, NULL, 81, NULL, NULL, 232373),
(255398, '4wkrA02', NULL, NULL, 72, NULL, NULL, 232373),
(255399, '1cvjH02', NULL, NULL, 65, NULL, NULL, 232373),
(255400, '1fxlA01', NULL, NULL, 71, NULL, NULL, 232373),
(255401, '1fxlA02', NULL, NULL, 77, NULL, NULL, 232373),
(255402, '4c7qA00', NULL, NULL, 86, NULL, NULL, 232373),
(255403, '1welA00', NULL, NULL, 124, NULL, NULL, 232373),
(255404, '1whyA01', NULL, NULL, 72, NULL, NULL, 232373),
(255405, '2jvoA00', NULL, NULL, 81, NULL, NULL, 232373),
(255406, '3nncA01', NULL, NULL, 89, NULL, NULL, 232373),
(255407, '5mmjv00', NULL, NULL, 80, NULL, NULL, 232373),
(255408, '3nncA02', NULL, NULL, 86, NULL, NULL, 232373),
(255409, '2diuA01', NULL, NULL, 73, NULL, NULL, 232373),
(255410, '2dgtA01', NULL, NULL, 73, NULL, NULL, 232373),
(255411, '5kvyA01', NULL, NULL, 125, NULL, NULL, 232373),
(255412, '3to8A01', NULL, NULL, 107, NULL, NULL, 232373),
(255413, '2lxuA01', NULL, NULL, 97, NULL, NULL, 232373),
(255414, '2cpyA01', NULL, NULL, 82, NULL, NULL, 232373),
(255415, '3jb9k00', NULL, NULL, 93, NULL, NULL, 232373),
(255416, '2ek1A00', NULL, NULL, 95, NULL, NULL, 232373),
(255417, '5im0B00', NULL, NULL, 82, NULL, NULL, 232373),
(255418, '2cq0A00', NULL, NULL, 103, NULL, NULL, 232373),
(255419, '2rqcA00', NULL, NULL, 115, NULL, NULL, 232373),
(255420, '6hipA01', NULL, NULL, 85, NULL, NULL, 232373),
(255421, '1u6fA00', NULL, NULL, 139, NULL, NULL, 232373),
(255422, '4wiiA02', NULL, NULL, 89, NULL, NULL, 232373),
(255423, '2mzrA00', NULL, NULL, 95, NULL, NULL, 232373),
(255424, '1x4aA00', NULL, NULL, 109, NULL, NULL, 232373),
(255425, '1s79A00', NULL, NULL, 103, NULL, NULL, 232373),
(255426, '2e5hA01', NULL, NULL, 80, NULL, NULL, 232373),
(255427, '5ithA00', NULL, NULL, 92, NULL, NULL, 232373),
(255428, '2kh9A00', NULL, NULL, 92, NULL, NULL, 232373),
(255429, '2x1bA00', NULL, NULL, 97, NULL, NULL, 232373),
(255430, '2j8aA01', NULL, NULL, 94, NULL, NULL, 232373),
(255431, '2cpiA01', NULL, NULL, 81, NULL, NULL, 232373),
(255432, '1owxA00', NULL, NULL, 121, NULL, NULL, 232373),
(255433, '2dk2A00', NULL, NULL, 97, NULL, NULL, 232373),
(255434, '4qu7A00', NULL, NULL, 81, NULL, NULL, 232373),
(255435, '2u2fA00', NULL, NULL, 85, NULL, NULL, 232373),
(255436, '3hi9D00', NULL, NULL, 84, NULL, NULL, 232373),
(255437, '2myfA00', NULL, NULL, 89, NULL, NULL, 232373),
(255438, '1x4fA00', NULL, NULL, 112, NULL, NULL, 232373),
(255439, '4erdA00', NULL, NULL, 129, NULL, NULL, 232373),
(255440, '4zkaE00', NULL, NULL, 84, NULL, NULL, 232373),
(255441, '5x3yA00', NULL, NULL, 96, NULL, NULL, 232373),
(255442, '2wbrA00', NULL, NULL, 89, NULL, NULL, 232373),
(255443, '3v4mB00', NULL, NULL, 105, NULL, NULL, 232373),
(255444, '6ez7A00', NULL, NULL, 83, NULL, NULL, 232373),
(255445, '3mi7X00', NULL, NULL, 85, NULL, NULL, 232373),
(255446, '2fy1A01', NULL, NULL, 83, NULL, NULL, 232373),
(255447, '2dnqA01', NULL, NULL, 73, NULL, NULL, 232373),
(255448, '5gvqA01', NULL, NULL, 80, NULL, NULL, 232373),
(255449, '5xymT00', NULL, NULL, 100, NULL, NULL, 232373),
(255450, '5v7qT00', NULL, NULL, 100, NULL, NULL, 232373),
(255451, '4ch0S00', NULL, NULL, 97, NULL, NULL, 232373),
(255452, '5mmiU01', NULL, NULL, 85, NULL, NULL, 232373),
(255453, '4bs2A02', NULL, NULL, 85, NULL, NULL, 232373),
(255454, '2cpdA01', NULL, NULL, 75, NULL, NULL, 232373),
(255455, '1enwA00', NULL, NULL, 114, NULL, NULL, 232374),
(255456, '5hvqC01', NULL, NULL, 82, NULL, NULL, 232375);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(255457, '1yukA02', NULL, NULL, 44, NULL, NULL, 232376),
(255458, '3kyzA00', NULL, NULL, 125, NULL, NULL, 232377),
(255459, '1h6wA01', NULL, NULL, 41, NULL, NULL, 232378),
(255460, '1m7lA00', NULL, NULL, 40, NULL, NULL, 232379),
(255461, '3c5xC00', NULL, NULL, 81, NULL, NULL, 232380),
(255462, '2fji102', NULL, NULL, 190, NULL, NULL, 232381),
(255463, '3p5pA02', NULL, NULL, 202, NULL, NULL, 232382),
(255464, '4lixA02', NULL, NULL, 211, NULL, NULL, 232382),
(255465, '3s9vA02', NULL, NULL, 203, NULL, NULL, 232382),
(255466, '3sdrA02', NULL, NULL, 215, NULL, NULL, 232382),
(255467, '1ob0A02', NULL, NULL, 102, NULL, NULL, 232383),
(255468, '1wpcA02', NULL, NULL, 105, NULL, NULL, 232383),
(255469, '1ud2A02', NULL, NULL, 102, NULL, NULL, 232383),
(255470, '6gxvA02', NULL, NULL, 103, NULL, NULL, 232383),
(255471, '3bh4A02', NULL, NULL, 104, NULL, NULL, 232383),
(255472, '2dieA02', NULL, NULL, 105, NULL, NULL, 232383),
(255473, '3bc9A03', NULL, NULL, 93, NULL, NULL, 232383),
(255474, '2gjpA02', NULL, NULL, 105, NULL, NULL, 232383),
(255475, '4uzuA02', NULL, NULL, 102, NULL, NULL, 232383),
(255476, '2uv1A00', NULL, NULL, 79, NULL, NULL, 232384),
(255477, '2uuzB00', NULL, NULL, 99, NULL, NULL, 232384),
(255478, '2sliA03', NULL, NULL, 100, NULL, NULL, 232385),
(255479, '4x4aA02', NULL, NULL, 96, NULL, NULL, 232385),
(255480, '4xjwA03', NULL, NULL, 98, NULL, NULL, 232385),
(255481, '4yz1B03', NULL, NULL, 98, NULL, NULL, 232385),
(255482, '2bf6A02', NULL, NULL, 66, NULL, NULL, 232385),
(255483, '2w20A02', NULL, NULL, 80, NULL, NULL, 232385),
(255484, '5v1yB00', NULL, NULL, 115, NULL, NULL, 232386),
(255485, '2z4dA00', NULL, NULL, 96, NULL, NULL, 232386),
(255486, '1nxjA00', NULL, NULL, 156, NULL, NULL, 232387),
(255487, '2pcnA00', NULL, NULL, 161, NULL, NULL, 232387),
(255488, '3k4iC01', NULL, NULL, 171, NULL, NULL, 232387),
(255489, '5ir2A00', NULL, NULL, 222, NULL, NULL, 232387),
(255490, '1q5xA00', NULL, NULL, 161, NULL, NULL, 232387),
(255491, '1j3lA00', NULL, NULL, 164, NULL, NULL, 232387),
(255492, '3nojA01', NULL, NULL, 152, NULL, NULL, 232387),
(255493, '1vi4A00', NULL, NULL, 174, NULL, NULL, 232387),
(255494, '3c8oB00', NULL, NULL, 162, NULL, NULL, 232387),
(255495, '2c5qF00', NULL, NULL, 240, NULL, NULL, 232387),
(255496, '3n2qA02', NULL, NULL, 117, NULL, NULL, 232388),
(255497, '1va6A01', NULL, NULL, 70, NULL, NULL, 232389),
(255498, '2e1mC02', NULL, NULL, 50, NULL, NULL, 232390),
(255499, '1sx5B00', NULL, NULL, 244, NULL, NULL, 232391),
(255500, '2gigB00', NULL, NULL, 257, NULL, NULL, 232391),
(255501, '1ev7A01', NULL, NULL, 176, NULL, NULL, 232391),
(255502, '1azoA00', NULL, NULL, 232, NULL, NULL, 232391),
(255503, '2aorB00', NULL, NULL, 223, NULL, NULL, 232391),
(255504, '4hl4A01', NULL, NULL, 157, NULL, NULL, 232392),
(255505, '3sxuB00', NULL, NULL, 105, NULL, NULL, 232393),
(255506, '4ew5B00', NULL, NULL, 102, NULL, NULL, 232394),
(255507, '2l1sA00', NULL, NULL, 83, NULL, NULL, 232394),
(255508, '2b3yA02', NULL, NULL, 128, NULL, NULL, 232395),
(255509, '1c96A02', NULL, NULL, 113, NULL, NULL, 232395),
(255510, '1l5jA03', NULL, NULL, 173, NULL, NULL, 232395),
(255511, '2hy5C00', NULL, NULL, 102, NULL, NULL, 232396),
(255512, '1l1sA00', NULL, NULL, 113, NULL, NULL, 232396),
(255513, '1jx7A00', NULL, NULL, 117, NULL, NULL, 232396),
(255514, '2hy5B00', NULL, NULL, 136, NULL, NULL, 232396),
(255515, '2qs7B00', NULL, NULL, 144, NULL, NULL, 232396),
(255516, '2qs7A00', NULL, NULL, 144, NULL, NULL, 232396),
(255517, '2d1pC00', NULL, NULL, 95, NULL, NULL, 232396),
(255518, '2d1pA00', NULL, NULL, 140, NULL, NULL, 232396),
(255519, '2d1pB00', NULL, NULL, 119, NULL, NULL, 232396),
(255520, '3pnxA00', NULL, NULL, 160, NULL, NULL, 232396),
(255521, '2qs7D00', NULL, NULL, 144, NULL, NULL, 232396),
(255522, '3pnxB00', NULL, NULL, 160, NULL, NULL, 232396),
(255523, '2qs7C00', NULL, NULL, 144, NULL, NULL, 232396),
(255524, '2pd2A00', NULL, NULL, 108, NULL, NULL, 232396),
(255525, '1rhxA00', NULL, NULL, 87, NULL, NULL, 232396),
(255526, '3pnxE00', NULL, NULL, 160, NULL, NULL, 232396),
(255527, '2fb6A00', NULL, NULL, 117, NULL, NULL, 232396);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(255528, '3pnxF00', NULL, NULL, 160, NULL, NULL, 232396),
(255529, '3mc3A00', NULL, NULL, 134, NULL, NULL, 232396),
(255530, '2hy5A00', NULL, NULL, 130, NULL, NULL, 232396),
(255531, '3pnxC00', NULL, NULL, 160, NULL, NULL, 232396),
(255532, '3pnxD00', NULL, NULL, 160, NULL, NULL, 232396),
(255533, '6mptA01', NULL, NULL, 191, NULL, NULL, 232397),
(255534, '2i3tD01', NULL, NULL, 46, NULL, NULL, 232398),
(255535, '2y0nC00', NULL, NULL, 211, NULL, NULL, 232399),
(255536, '2f5jB00', NULL, NULL, 181, NULL, NULL, 232399),
(255537, '2wdcA02', NULL, NULL, 53, NULL, NULL, 232400),
(255538, '3p5jB02', NULL, NULL, 140, NULL, NULL, 232401),
(255539, '1vhkA01', NULL, NULL, 76, NULL, NULL, 232402),
(255540, '4l69A01', NULL, NULL, 73, NULL, NULL, 232402),
(255541, '2nwaG01', NULL, NULL, 77, NULL, NULL, 232402),
(255542, '2nwaH01', NULL, NULL, 77, NULL, NULL, 232402),
(255543, '2nwaE01', NULL, NULL, 77, NULL, NULL, 232402),
(255544, '2nwaF01', NULL, NULL, 77, NULL, NULL, 232402),
(255545, '1v6zA01', NULL, NULL, 66, NULL, NULL, 232402),
(255546, '4e8bA01', NULL, NULL, 73, NULL, NULL, 232402),
(255547, '1vhyA01', NULL, NULL, 75, NULL, NULL, 232402),
(255548, '1z85A01', NULL, NULL, 80, NULL, NULL, 232402),
(255549, '2egvA01', NULL, NULL, 66, NULL, NULL, 232402),
(255550, '3kw2A01', NULL, NULL, 72, NULL, NULL, 232402),
(255551, '2nwaC01', NULL, NULL, 77, NULL, NULL, 232402),
(255552, '2nwaD01', NULL, NULL, 77, NULL, NULL, 232402),
(255553, '2nwaA01', NULL, NULL, 77, NULL, NULL, 232402),
(255554, '2nwaB01', NULL, NULL, 77, NULL, NULL, 232402),
(255555, '4j3cB01', NULL, NULL, 69, NULL, NULL, 232402),
(255556, '5o95D01', NULL, NULL, 76, NULL, NULL, 232402),
(255557, '5tsqA00', NULL, NULL, 312, NULL, NULL, 232403),
(255558, '3fz0D00', NULL, NULL, 360, NULL, NULL, 232403),
(255559, '1ezrA00', NULL, NULL, 314, NULL, NULL, 232403),
(255560, '4kl0A00', NULL, NULL, 379, NULL, NULL, 232403),
(255561, '2yhgA01', NULL, NULL, 301, NULL, NULL, 232403),
(255562, '4wr2A00', NULL, NULL, 318, NULL, NULL, 232403),
(255563, '3b9gB00', NULL, NULL, 328, NULL, NULL, 232403),
(255564, '2c40A00', NULL, NULL, 312, NULL, NULL, 232403),
(255565, '6ba1D00', NULL, NULL, 321, NULL, NULL, 232403),
(255566, '4kpoB00', NULL, NULL, 330, NULL, NULL, 232403),
(255567, '1yoeA00', NULL, NULL, 322, NULL, NULL, 232403),
(255568, '2masA00', NULL, NULL, 314, NULL, NULL, 232403),
(255569, '3t8jA00', NULL, NULL, 311, NULL, NULL, 232403),
(255570, '1q8fA00', NULL, NULL, 313, NULL, NULL, 232403),
(255571, '3t8iA00', NULL, NULL, 306, NULL, NULL, 232403),
(255572, '4kpnA00', NULL, NULL, 318, NULL, NULL, 232403),
(255573, '4i71A00', NULL, NULL, 330, NULL, NULL, 232403),
(255574, '6ba0A00', NULL, NULL, 315, NULL, NULL, 232403),
(255575, '1zroA02', NULL, NULL, 35, NULL, NULL, 232404),
(255576, '4gf2A02', NULL, NULL, 35, NULL, NULL, 232404),
(255577, '3kdeC01', NULL, NULL, 69, NULL, NULL, 232405),
(255578, '2ae0X02', NULL, NULL, 138, NULL, NULL, 232406),
(255579, '2pnwA02', NULL, NULL, 161, NULL, NULL, 232406),
(255580, '3czbA02', NULL, NULL, 161, NULL, NULL, 232406),
(255581, '2g5dA02', NULL, NULL, 133, NULL, NULL, 232406),
(255582, '2g6gA02', NULL, NULL, 195, NULL, NULL, 232406),
(255583, '3h0gA04', NULL, NULL, 153, NULL, NULL, 232407),
(255584, '4c2mA05', NULL, NULL, 171, NULL, NULL, 232407),
(255585, '1twfA05', NULL, NULL, 153, NULL, NULL, 232407),
(255586, '4qiwA04', NULL, NULL, 194, NULL, NULL, 232407),
(255587, '1ynjD05', NULL, NULL, 180, NULL, NULL, 232407),
(255588, '2a6hD05', NULL, NULL, 186, NULL, NULL, 232407),
(255589, '3sbtB01', NULL, NULL, 143, NULL, NULL, 232408),
(255590, '3oaaD01', NULL, NULL, 74, NULL, NULL, 232409),
(255591, '6fkfB01', NULL, NULL, 80, NULL, NULL, 232409),
(255592, '3ziaF01', NULL, NULL, 82, NULL, NULL, 232409),
(255593, '3dclE02', NULL, NULL, 91, NULL, NULL, 232409),
(255594, '6focF01', NULL, NULL, 85, NULL, NULL, 232409),
(255595, '4q4lA01', NULL, NULL, 74, NULL, NULL, 232409),
(255596, '3dclD02', NULL, NULL, 91, NULL, NULL, 232409),
(255597, '3dclC02', NULL, NULL, 91, NULL, NULL, 232409),
(255598, '3mlqG00', NULL, NULL, 52, NULL, NULL, 232409);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(255599, '3dclB02', NULL, NULL, 91, NULL, NULL, 232409),
(255600, '3mlqH00', NULL, NULL, 54, NULL, NULL, 232409),
(255601, '3dclA02', NULL, NULL, 91, NULL, NULL, 232409),
(255602, '5fl7E01', NULL, NULL, 75, NULL, NULL, 232409),
(255603, '2ck3D01', NULL, NULL, 85, NULL, NULL, 232409),
(255604, '4kbmB01', NULL, NULL, 60, NULL, NULL, 232409),
(255605, '4l5gB01', NULL, NULL, 62, NULL, NULL, 232409),
(255606, '2eyqA05', NULL, NULL, 59, NULL, NULL, 232409),
(255607, '2lt1A00', NULL, NULL, 75, NULL, NULL, 232409),
(255608, '5ik2E01', NULL, NULL, 76, NULL, NULL, 232409),
(255609, '2lt4A00', NULL, NULL, 71, NULL, NULL, 232409),
(255610, '5cdfE01', NULL, NULL, 76, NULL, NULL, 232409),
(255611, '1skyE01', NULL, NULL, 82, NULL, NULL, 232409),
(255612, '6f5dD01', NULL, NULL, 76, NULL, NULL, 232409),
(255613, '3n99H02', NULL, NULL, 90, NULL, NULL, 232409),
(255614, '2vixB03', NULL, NULL, 113, NULL, NULL, 232410),
(255615, '2vixC03', NULL, NULL, 113, NULL, NULL, 232410),
(255616, '2vixA03', NULL, NULL, 113, NULL, NULL, 232410),
(255617, '2vj4B03', NULL, NULL, 113, NULL, NULL, 232410),
(255618, '2vj5A03', NULL, NULL, 113, NULL, NULL, 232410),
(255619, '2vj4A03', NULL, NULL, 113, NULL, NULL, 232410),
(255620, '2kxtA01', NULL, NULL, 168, NULL, NULL, 232411),
(255621, '2qngA01', NULL, NULL, 165, NULL, NULL, 232411),
(255622, '2qz7A01', NULL, NULL, 164, NULL, NULL, 232411),
(255623, '3ibzA01', NULL, NULL, 168, NULL, NULL, 232411),
(255624, '4i8oA03', NULL, NULL, 67, NULL, NULL, 232412),
(255625, '6fhpD00', NULL, NULL, 62, NULL, NULL, 232413),
(255626, '4kx7A02', NULL, NULL, 249, NULL, NULL, 232413),
(255627, '3nqxA02', NULL, NULL, 153, NULL, NULL, 232413),
(255628, '5jviE02', NULL, NULL, 161, NULL, NULL, 232413),
(255629, '5mj6A02', NULL, NULL, 249, NULL, NULL, 232413),
(255630, '5ab0C02', NULL, NULL, 275, NULL, NULL, 232413),
(255631, '6f8bA02', NULL, NULL, 149, NULL, NULL, 232413),
(255632, '4fkeA02', NULL, NULL, 262, NULL, NULL, 232413),
(255633, '1bqbA02', NULL, NULL, 144, NULL, NULL, 232413),
(255634, '3b34A03', NULL, NULL, 164, NULL, NULL, 232413),
(255635, '4qhpA03', NULL, NULL, 164, NULL, NULL, 232413),
(255636, '4gaaA03', NULL, NULL, 157, NULL, NULL, 232413),
(255637, '4fgmA02', NULL, NULL, 275, NULL, NULL, 232413),
(255638, '3u9wA03', NULL, NULL, 157, NULL, NULL, 232413),
(255639, '1z5hA02', NULL, NULL, 245, NULL, NULL, 232413),
(255640, '3ciaA03', NULL, NULL, 155, NULL, NULL, 232413),
(255641, '6q4rA02', NULL, NULL, 250, NULL, NULL, 232413),
(255642, '4k90A02', NULL, NULL, 188, NULL, NULL, 232413),
(255643, '4wz9A02', NULL, NULL, 254, NULL, NULL, 232413),
(255644, '4fytA02', NULL, NULL, 261, NULL, NULL, 232413),
(255645, '5dllA03', NULL, NULL, 164, NULL, NULL, 232413),
(255646, '4gerA02', NULL, NULL, 156, NULL, NULL, 232413),
(255647, '5zi7A03', NULL, NULL, 153, NULL, NULL, 232413),
(255648, '1npcA02', NULL, NULL, 161, NULL, NULL, 232413),
(255649, '2xq0A03', NULL, NULL, 157, NULL, NULL, 232413),
(255650, '2vqxA02', NULL, NULL, 167, NULL, NULL, 232413),
(255651, '6ea2A03', NULL, NULL, 171, NULL, NULL, 232413),
(255652, '4l6v600', NULL, NULL, 125, NULL, NULL, 232414),
(255653, '1jb0F00', NULL, NULL, 141, NULL, NULL, 232414),
(255654, '6igzF00', NULL, NULL, 165, NULL, NULL, 232414),
(255655, '5zjiF00', NULL, NULL, 159, NULL, NULL, 232414),
(255656, '4xk8F00', NULL, NULL, 151, NULL, NULL, 232414),
(255657, '5zgbF00', NULL, NULL, 156, NULL, NULL, 232414),
(255658, '5oy0600', NULL, NULL, 143, NULL, NULL, 232414),
(255659, '6ijjF00', NULL, NULL, 165, NULL, NULL, 232414),
(255660, '5l8rF00', NULL, NULL, 154, NULL, NULL, 232414),
(255661, '2w4sA00', NULL, NULL, 92, NULL, NULL, 232415),
(255662, '2xc7A00', NULL, NULL, 104, NULL, NULL, 232415),
(255663, '1qsaA01', NULL, NULL, 363, NULL, NULL, 232416),
(255664, '1z00B00', NULL, NULL, 84, NULL, NULL, 232417),
(255665, '4f4wA03', NULL, NULL, 67, NULL, NULL, 232417),
(255666, '3n4mB00', NULL, NULL, 84, NULL, NULL, 232417),
(255667, '3ntuA01', NULL, NULL, 63, NULL, NULL, 232417),
(255668, '3k4gB00', NULL, NULL, 86, NULL, NULL, 232417),
(255669, '1tk5A04', NULL, NULL, 112, NULL, NULL, 232417);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(255670, '1z3eB00', NULL, NULL, 73, NULL, NULL, 232417),
(255671, '2q0zX02', NULL, NULL, 58, NULL, NULL, 232417),
(255672, '3k4gF00', NULL, NULL, 86, NULL, NULL, 232417),
(255673, '1y88A02', NULL, NULL, 59, NULL, NULL, 232417),
(255674, '2dflA01', NULL, NULL, 72, NULL, NULL, 232417),
(255675, '1kftA00', NULL, NULL, 56, NULL, NULL, 232417),
(255676, '1d8lA01', NULL, NULL, 69, NULL, NULL, 232417),
(255677, '1b43A02', NULL, NULL, 61, NULL, NULL, 232417),
(255678, '1b22A00', NULL, NULL, 85, NULL, NULL, 232417),
(255679, '1cukA02', NULL, NULL, 76, NULL, NULL, 232417),
(255680, '2kfnA04', NULL, NULL, 144, NULL, NULL, 232417),
(255681, '1bgxT02', NULL, NULL, 73, NULL, NULL, 232417),
(255682, '1ixrB02', NULL, NULL, 75, NULL, NULL, 232417),
(255683, '4i2aA02', NULL, NULL, 59, NULL, NULL, 232417),
(255684, '5hmlA02', NULL, NULL, 80, NULL, NULL, 232417),
(255685, '2z43B01', NULL, NULL, 64, NULL, NULL, 232417),
(255686, '2zubB01', NULL, NULL, 50, NULL, NULL, 232417),
(255687, '1mc8A02', NULL, NULL, 61, NULL, NULL, 232417),
(255688, '4dezA03', NULL, NULL, 72, NULL, NULL, 232417),
(255689, '1pznA01', NULL, NULL, 66, NULL, NULL, 232417),
(255690, '3k4gA00', NULL, NULL, 86, NULL, NULL, 232417),
(255691, '3ewaA01', NULL, NULL, 66, NULL, NULL, 232417),
(255692, '3k4gE00', NULL, NULL, 86, NULL, NULL, 232417),
(255693, '3osnA03', NULL, NULL, 77, NULL, NULL, 232417),
(255694, '3rr7A04', NULL, NULL, 144, NULL, NULL, 232417),
(255695, '3im1A02', NULL, NULL, 58, NULL, NULL, 232417),
(255696, '1doqA00', NULL, NULL, 69, NULL, NULL, 232417),
(255697, '2vanA01', NULL, NULL, 58, NULL, NULL, 232417),
(255698, '2va8A04', NULL, NULL, 56, NULL, NULL, 232417),
(255699, '5k97A02', NULL, NULL, 68, NULL, NULL, 232417),
(255700, '4kliA02', NULL, NULL, 57, NULL, NULL, 232417),
(255701, '4bxoA02', NULL, NULL, 80, NULL, NULL, 232417),
(255702, '1bvsA02', NULL, NULL, 83, NULL, NULL, 232417),
(255703, '4yfkA03', NULL, NULL, 67, NULL, NULL, 232417),
(255704, '3b0xA02', NULL, NULL, 69, NULL, NULL, 232417),
(255705, '3mabA00', NULL, NULL, 93, NULL, NULL, 232417),
(255706, '3oryA02', NULL, NULL, 65, NULL, NULL, 232417),
(255707, '1rxwA02', NULL, NULL, 62, NULL, NULL, 232417),
(255708, '5kfzA03', NULL, NULL, 58, NULL, NULL, 232417),
(255709, '2p6rA04', NULL, NULL, 56, NULL, NULL, 232417),
(255710, '5cb1A02', NULL, NULL, 63, NULL, NULL, 232417),
(255711, '4f92B05', NULL, NULL, 57, NULL, NULL, 232417),
(255712, '2w9mA02', NULL, NULL, 68, NULL, NULL, 232417),
(255713, '5dcaA07', NULL, NULL, 58, NULL, NULL, 232417),
(255714, '5m59A11', NULL, NULL, 65, NULL, NULL, 232417),
(255715, '4ez6A04', NULL, NULL, 113, NULL, NULL, 232417),
(255716, '2a1jA00', NULL, NULL, 63, NULL, NULL, 232417),
(255717, '3gqcA03', NULL, NULL, 54, NULL, NULL, 232417),
(255718, '3k4gD00', NULL, NULL, 86, NULL, NULL, 232417),
(255719, '3k4gH00', NULL, NULL, 86, NULL, NULL, 232417),
(255720, '4p4mA01', NULL, NULL, 63, NULL, NULL, 232417),
(255721, '4tqrA03', NULL, NULL, 67, NULL, NULL, 232417),
(255722, '3gfkB00', NULL, NULL, 79, NULL, NULL, 232417),
(255723, '1u9lB00', NULL, NULL, 70, NULL, NULL, 232417),
(255724, '6ib8C01', NULL, NULL, 60, NULL, NULL, 232417),
(255725, '3mfiA03', NULL, NULL, 79, NULL, NULL, 232417),
(255726, '5wm1A04', NULL, NULL, 89, NULL, NULL, 232417),
(255727, '2nrtA02', NULL, NULL, 63, NULL, NULL, 232417),
(255728, '3h7iA02', NULL, NULL, 77, NULL, NULL, 232417),
(255729, '1dgsA05', NULL, NULL, 69, NULL, NULL, 232417),
(255730, '5yuyA03', NULL, NULL, 55, NULL, NULL, 232417),
(255731, '4bxoB02', NULL, NULL, 72, NULL, NULL, 232417),
(255732, '3c1yA03', NULL, NULL, 65, NULL, NULL, 232417),
(255733, '4dleA04', NULL, NULL, 144, NULL, NULL, 232417),
(255734, '2bgwA02', NULL, NULL, 74, NULL, NULL, 232417),
(255735, '1aroP05', NULL, NULL, 231, NULL, NULL, 232417),
(255736, '2zj8A04', NULL, NULL, 57, NULL, NULL, 232417),
(255737, '4f92B11', NULL, NULL, 57, NULL, NULL, 232417),
(255738, '5m59A05', NULL, NULL, 57, NULL, NULL, 232417),
(255739, '3ldaA01', NULL, NULL, 74, NULL, NULL, 232417),
(255740, '1bpbA01', NULL, NULL, 61, NULL, NULL, 232417),
(255741, '2bcqA02', NULL, NULL, 54, NULL, NULL, 232417);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(255742, '2ztdA02', NULL, NULL, 68, NULL, NULL, 232417),
(255743, '5tt5A04', NULL, NULL, 79, NULL, NULL, 232417),
(255744, '4m6wA02', NULL, NULL, 69, NULL, NULL, 232417),
(255745, '1dgsA06', NULL, NULL, 83, NULL, NULL, 232417),
(255746, '5tt5A05', NULL, NULL, 77, NULL, NULL, 232417),
(255747, '2m9nA00', NULL, NULL, 63, NULL, NULL, 232417),
(255748, '1a76A02', NULL, NULL, 60, NULL, NULL, 232417),
(255749, '3zdbA02', NULL, NULL, 90, NULL, NULL, 232417),
(255750, '5nwlA01', NULL, NULL, 73, NULL, NULL, 232417),
(255751, '4dsfA04', NULL, NULL, 113, NULL, NULL, 232417),
(255752, '5vzaA02', NULL, NULL, 57, NULL, NULL, 232417),
(255753, '2ihmA02', NULL, NULL, 58, NULL, NULL, 232417),
(255754, '3k4gC00', NULL, NULL, 86, NULL, NULL, 232417),
(255755, '2a1jB01', NULL, NULL, 69, NULL, NULL, 232417),
(255756, '3k4gG00', NULL, NULL, 86, NULL, NULL, 232417),
(255757, '1x2iA00', NULL, NULL, 75, NULL, NULL, 232417),
(255758, '5v07Z02', NULL, NULL, 78, NULL, NULL, 232417),
(255759, '2mutA00', NULL, NULL, 96, NULL, NULL, 232417),
(255760, '3px4A04', NULL, NULL, 144, NULL, NULL, 232417),
(255761, '4he8D00', NULL, NULL, 160, NULL, NULL, 232418),
(255762, '3rkoF01', NULL, NULL, 160, NULL, NULL, 232418),
(255763, '4gl6A02', NULL, NULL, 160, NULL, NULL, 232419),
(255764, '4evfA03', NULL, NULL, 80, NULL, NULL, 232420),
(255765, '4evfA02', NULL, NULL, 74, NULL, NULL, 232420),
(255766, '4evfA01', NULL, NULL, 72, NULL, NULL, 232420),
(255767, '4evfA04', NULL, NULL, 69, NULL, NULL, 232420),
(255768, '1dk5A02', NULL, NULL, 72, NULL, NULL, 232420),
(255769, '1dk5A03', NULL, NULL, 75, NULL, NULL, 232420),
(255770, '1i4aA01', NULL, NULL, 73, NULL, NULL, 232420),
(255771, '1i4aA02', NULL, NULL, 74, NULL, NULL, 232420),
(255772, '1i4aA03', NULL, NULL, 86, NULL, NULL, 232420),
(255773, '1axnA02', NULL, NULL, 74, NULL, NULL, 232420),
(255774, '1axnA01', NULL, NULL, 73, NULL, NULL, 232420),
(255775, '1axnA04', NULL, NULL, 72, NULL, NULL, 232420),
(255776, '1dk5A04', NULL, NULL, 70, NULL, NULL, 232420),
(255777, '1axnA03', NULL, NULL, 86, NULL, NULL, 232420),
(255778, '1w3wA04', NULL, NULL, 72, NULL, NULL, 232420),
(255779, '1w3wA03', NULL, NULL, 87, NULL, NULL, 232420),
(255780, '1w3wA02', NULL, NULL, 74, NULL, NULL, 232420),
(255781, '1w3wA01', NULL, NULL, 73, NULL, NULL, 232420),
(255782, '1hm6A01', NULL, NULL, 73, NULL, NULL, 232420),
(255783, '1avcA01', NULL, NULL, 80, NULL, NULL, 232420),
(255784, '1hm6A02', NULL, NULL, 74, NULL, NULL, 232420),
(255785, '1avcA02', NULL, NULL, 78, NULL, NULL, 232420),
(255786, '4mdvB03', NULL, NULL, 100, NULL, NULL, 232420),
(255787, '1hm6A03', NULL, NULL, 86, NULL, NULL, 232420),
(255788, '1hm6A04', NULL, NULL, 73, NULL, NULL, 232420),
(255789, '2zhjA02', NULL, NULL, 74, NULL, NULL, 232420),
(255790, '1avcA08', NULL, NULL, 74, NULL, NULL, 232420),
(255791, '2zhjA01', NULL, NULL, 73, NULL, NULL, 232420),
(255792, '2zhjA04', NULL, NULL, 74, NULL, NULL, 232420),
(255793, '2zhjA03', NULL, NULL, 86, NULL, NULL, 232420),
(255794, '1avcA06', NULL, NULL, 74, NULL, NULL, 232420),
(255795, '1avcA07', NULL, NULL, 89, NULL, NULL, 232420),
(255796, '1m9iA02', NULL, NULL, 78, NULL, NULL, 232420),
(255797, '1m9iA01', NULL, NULL, 80, NULL, NULL, 232420),
(255798, '1m9iA08', NULL, NULL, 70, NULL, NULL, 232420),
(255799, '1m9iA07', NULL, NULL, 89, NULL, NULL, 232420),
(255800, '1m9iA04', NULL, NULL, 72, NULL, NULL, 232420),
(255801, '1m9iA03', NULL, NULL, 83, NULL, NULL, 232420),
(255802, '1m9iA06', NULL, NULL, 74, NULL, NULL, 232420),
(255803, '1m9iA05', NULL, NULL, 74, NULL, NULL, 232420),
(255804, '2hyvA01', NULL, NULL, 73, NULL, NULL, 232420),
(255805, '4mduA04', NULL, NULL, 72, NULL, NULL, 232420),
(255806, '4mduA02', NULL, NULL, 82, NULL, NULL, 232420),
(255807, '4mduA01', NULL, NULL, 73, NULL, NULL, 232420),
(255808, '1n00A01', NULL, NULL, 87, NULL, NULL, 232420),
(255809, '1n00A03', NULL, NULL, 73, NULL, NULL, 232420),
(255810, '1n00A02', NULL, NULL, 72, NULL, NULL, 232420),
(255811, '1n00A04', NULL, NULL, 72, NULL, NULL, 232420),
(255812, '1dk5B01', NULL, NULL, 90, NULL, NULL, 232420),
(255813, '2zocA01', NULL, NULL, 73, NULL, NULL, 232420);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(255814, '2h0lA01', NULL, NULL, 73, NULL, NULL, 232420),
(255815, '2zocA02', NULL, NULL, 74, NULL, NULL, 232420),
(255816, '2zocA04', NULL, NULL, 72, NULL, NULL, 232420),
(255817, '2hyvA04', NULL, NULL, 74, NULL, NULL, 232420),
(255818, '2hyvA03', NULL, NULL, 81, NULL, NULL, 232420),
(255819, '2hyvA02', NULL, NULL, 80, NULL, NULL, 232420),
(255820, '1ycnA03', NULL, NULL, 77, NULL, NULL, 232420),
(255821, '2ii2A02', NULL, NULL, 58, NULL, NULL, 232420),
(255822, '2ii2A01', NULL, NULL, 74, NULL, NULL, 232420),
(255823, '1ycnA02', NULL, NULL, 72, NULL, NULL, 232420),
(255824, '1ycnA04', NULL, NULL, 76, NULL, NULL, 232420),
(255825, '1bo9A00', NULL, NULL, 73, NULL, NULL, 232420),
(255826, '1dm5A04', NULL, NULL, 72, NULL, NULL, 232420),
(255827, '2ii2A04', NULL, NULL, 80, NULL, NULL, 232420),
(255828, '1dm5A03', NULL, NULL, 86, NULL, NULL, 232420),
(255829, '2ii2A03', NULL, NULL, 98, NULL, NULL, 232420),
(255830, '1dm5A02', NULL, NULL, 74, NULL, NULL, 232420),
(255831, '1dm5A01', NULL, NULL, 73, NULL, NULL, 232420),
(255832, '2xo3A01', NULL, NULL, 73, NULL, NULL, 232420),
(255833, '2xo3A04', NULL, NULL, 74, NULL, NULL, 232420),
(255834, '2ie7A04', NULL, NULL, 72, NULL, NULL, 232420),
(255835, '1anxA02', NULL, NULL, 74, NULL, NULL, 232420),
(255836, '2ie7A01', NULL, NULL, 73, NULL, NULL, 232420),
(255837, '1anxA01', NULL, NULL, 73, NULL, NULL, 232420),
(255838, '2ie7A03', NULL, NULL, 86, NULL, NULL, 232420),
(255839, '1anxA03', NULL, NULL, 86, NULL, NULL, 232420),
(255840, '2ie7A02', NULL, NULL, 74, NULL, NULL, 232420),
(255841, '1yiiA03', NULL, NULL, 86, NULL, NULL, 232420),
(255842, '1yiiA04', NULL, NULL, 75, NULL, NULL, 232420),
(255843, '1ycnA01', NULL, NULL, 70, NULL, NULL, 232420),
(255844, '1yiiA01', NULL, NULL, 73, NULL, NULL, 232420),
(255845, '1yiiA02', NULL, NULL, 74, NULL, NULL, 232420),
(255846, '4gnkE00', NULL, NULL, 259, NULL, NULL, 232421),
(255847, '1jadA00', NULL, NULL, 251, NULL, NULL, 232421),
(255848, '4onsB00', NULL, NULL, 69, NULL, NULL, 232422),
(255849, '3ajfD00', NULL, NULL, 94, NULL, NULL, 232423),
(255850, '2l6qA00', NULL, NULL, 62, NULL, NULL, 232424),
(255851, '1bmlC03', NULL, NULL, 83, NULL, NULL, 232425),
(255852, '2i71A02', NULL, NULL, 159, NULL, NULL, 232426),
(255853, '4epsA01', NULL, NULL, 141, NULL, NULL, 232427),
(255854, '3t2lA01', NULL, NULL, 135, NULL, NULL, 232427),
(255855, '3sy6B01', NULL, NULL, 141, NULL, NULL, 232427),
(255856, '4k4kB01', NULL, NULL, 141, NULL, NULL, 232427),
(255857, '3ufiA01', NULL, NULL, 162, NULL, NULL, 232427),
(255858, '1miwA03', NULL, NULL, 100, NULL, NULL, 232428),
(255859, '2x2zB03', NULL, NULL, 47, NULL, NULL, 232429),
(255860, '3zleA03', NULL, NULL, 49, NULL, NULL, 232429),
(255861, '2y8tA03', NULL, NULL, 70, NULL, NULL, 232429),
(255862, '4aplA03', NULL, NULL, 58, NULL, NULL, 232429),
(255863, '2x2zD03', NULL, NULL, 35, NULL, NULL, 232429),
(255864, '5cqeB01', NULL, NULL, 81, NULL, NULL, 232430),
(255865, '2z16B01', NULL, NULL, 86, NULL, NULL, 232430),
(255866, '3vdxB02', NULL, NULL, 85, NULL, NULL, 232430),
(255867, '2fy2A02', NULL, NULL, 318, NULL, NULL, 232431),
(255868, '1t1uA02', NULL, NULL, 321, NULL, NULL, 232431),
(255869, '1xl7A02', NULL, NULL, 320, NULL, NULL, 232431),
(255870, '1nm8A02', NULL, NULL, 315, NULL, NULL, 232431),
(255871, '1ndbA02', NULL, NULL, 314, NULL, NULL, 232431),
(255872, '2debA03', NULL, NULL, 282, NULL, NULL, 232431),
(255873, '3v8uA03', NULL, NULL, 158, NULL, NULL, 232432),
(255874, '3ve2B03', NULL, NULL, 158, NULL, NULL, 232432),
(255875, '3holA03', NULL, NULL, 89, NULL, NULL, 232432),
(255876, '4o4uA03', NULL, NULL, 90, NULL, NULL, 232432),
(255877, '3pquA03', NULL, NULL, 89, NULL, NULL, 232432),
(255878, '5kkxB01', NULL, NULL, 92, NULL, NULL, 232432),
(255879, '4qq1C03', NULL, NULL, 93, NULL, NULL, 232432),
(255880, '3pqsA03', NULL, NULL, 88, NULL, NULL, 232432),
(255881, '5xnxA01', NULL, NULL, 197, NULL, NULL, 232433),
(255882, '3kh1A00', NULL, NULL, 200, NULL, NULL, 232433),
(255883, '1vj7B01', NULL, NULL, 196, NULL, NULL, 232433),
(255884, '1xx7A00', NULL, NULL, 184, NULL, NULL, 232433);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(255885, '2parB00', NULL, NULL, 201, NULL, NULL, 232433),
(255886, '3bg2A01', NULL, NULL, 208, NULL, NULL, 232433),
(255887, '2hekA01', NULL, NULL, 281, NULL, NULL, 232433),
(255888, '3nr1A00', NULL, NULL, 178, NULL, NULL, 232433),
(255889, '3p3qB00', NULL, NULL, 258, NULL, NULL, 232433),
(255890, '4mcwA02', NULL, NULL, 196, NULL, NULL, 232433),
(255891, '4mz7A01', NULL, NULL, 340, NULL, NULL, 232433),
(255892, '3mzoB00', NULL, NULL, 216, NULL, NULL, 232433),
(255893, '4r8zA00', NULL, NULL, 218, NULL, NULL, 232433),
(255894, '3tm8B00', NULL, NULL, 307, NULL, NULL, 232433),
(255895, '2dqbB00', NULL, NULL, 376, NULL, NULL, 232433),
(255896, '3memA02', NULL, NULL, 310, NULL, NULL, 232433),
(255897, '3i7aA00', NULL, NULL, 281, NULL, NULL, 232433),
(255898, '1ynbA00', NULL, NULL, 173, NULL, NULL, 232433),
(255899, '4l1jB00', NULL, NULL, 204, NULL, NULL, 232433),
(255900, '3rf0A00', NULL, NULL, 209, NULL, NULL, 232433),
(255901, '3nqwA00', NULL, NULL, 179, NULL, NULL, 232433),
(255902, '3m1tA00', NULL, NULL, 275, NULL, NULL, 232433),
(255903, '4l7wA00', NULL, NULL, 204, NULL, NULL, 232433),
(255904, '1vqrB00', NULL, NULL, 280, NULL, NULL, 232433),
(255905, '6oi7A01', NULL, NULL, 197, NULL, NULL, 232433),
(255906, '2pgsA01', NULL, NULL, 204, NULL, NULL, 232433),
(255907, '5tk8A00', NULL, NULL, 194, NULL, NULL, 232433),
(255908, '4mlmA00', NULL, NULL, 196, NULL, NULL, 232433),
(255909, '2honB01', NULL, NULL, 269, NULL, NULL, 232433),
(255910, '2q14C01', NULL, NULL, 241, NULL, NULL, 232433),
(255911, '1u6zA03', NULL, NULL, 146, NULL, NULL, 232433),
(255912, '2pq7A00', NULL, NULL, 182, NULL, NULL, 232433),
(255913, '3irhD01', NULL, NULL, 287, NULL, NULL, 232433),
(255914, '2gz4A00', NULL, NULL, 207, NULL, NULL, 232433),
(255915, '4l7eB00', NULL, NULL, 204, NULL, NULL, 232433),
(255916, '2o08A00', NULL, NULL, 188, NULL, NULL, 232433),
(255917, '3hi0A03', NULL, NULL, 201, NULL, NULL, 232433),
(255918, '3ccgA00', NULL, NULL, 190, NULL, NULL, 232433),
(255919, '3hc1A00', NULL, NULL, 305, NULL, NULL, 232433),
(255920, '2ogiB00', NULL, NULL, 196, NULL, NULL, 232433),
(255921, '2cqzA00', NULL, NULL, 177, NULL, NULL, 232433),
(255922, '2lfvA00', NULL, NULL, 106, NULL, NULL, 232434),
(255923, '1x60A01', NULL, NULL, 72, NULL, NULL, 232434),
(255924, '1utaA00', NULL, NULL, 81, NULL, NULL, 232434),
(255925, '3cetB02', NULL, NULL, 223, NULL, NULL, 232435),
(255926, '2aj4B03', NULL, NULL, 175, NULL, NULL, 232436),
(255927, '2a2cA03', NULL, NULL, 138, NULL, NULL, 232436),
(255928, '3v5rA03', NULL, NULL, 173, NULL, NULL, 232436),
(255929, '2hd0A02', NULL, NULL, 33, NULL, NULL, 232437),
(255930, '4p79A00', NULL, NULL, 198, NULL, NULL, 232438),
(255931, '6akeC00', NULL, NULL, 190, NULL, NULL, 232438),
(255932, '3x29A00', NULL, NULL, 185, NULL, NULL, 232438),
(255933, '5gjvE00', NULL, NULL, 222, NULL, NULL, 232438),
(255934, '3vu1B03', NULL, NULL, 123, NULL, NULL, 232439),
(255935, '3wovA03', NULL, NULL, 105, NULL, NULL, 232439),
(255936, '2zaiC03', NULL, NULL, 110, NULL, NULL, 232439),
(255937, '1iw7D12', NULL, NULL, 23, NULL, NULL, 232440),
(255938, '2a6hC04', NULL, NULL, 65, NULL, NULL, 232441),
(255939, '1ynjC04', NULL, NULL, 66, NULL, NULL, 232441),
(255940, '4kn7H04', NULL, NULL, 67, NULL, NULL, 232441),
(255941, '3vsjD00', NULL, NULL, 312, NULL, NULL, 232442),
(255942, '3vsjA00', NULL, NULL, 271, NULL, NULL, 232442),
(255943, '2pw6A00', NULL, NULL, 271, NULL, NULL, 232442),
(255944, '3wraA01', NULL, NULL, 303, NULL, NULL, 232442),
(255945, '5heeA00', NULL, NULL, 262, NULL, NULL, 232442),
(255946, '1b4uB00', NULL, NULL, 302, NULL, NULL, 232442),
(255947, '3bczA00', NULL, NULL, 293, NULL, NULL, 232442),
(255948, '3d5kA02', NULL, NULL, 83, NULL, NULL, 232443),
(255949, '5azsA02', NULL, NULL, 83, NULL, NULL, 232443),
(255950, '4mt0A02', NULL, NULL, 77, NULL, NULL, 232443),
(255951, '4k7rA02', NULL, NULL, 77, NULL, NULL, 232443),
(255952, '5azpA02', NULL, NULL, 81, NULL, NULL, 232443),
(255953, '1yc9A02', NULL, NULL, 83, NULL, NULL, 232443),
(255954, '2lhtA01', NULL, NULL, 76, NULL, NULL, 232444),
(255955, '3vwnX02', NULL, NULL, 100, NULL, NULL, 232445);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(255956, '2jxwA00', NULL, NULL, 75, NULL, NULL, 232446),
(255957, '2l4jA00', NULL, NULL, 46, NULL, NULL, 232446),
(255958, '1nmvA01', NULL, NULL, 47, NULL, NULL, 232446),
(255959, '2djyA01', NULL, NULL, 35, NULL, NULL, 232446),
(255960, '1zcnA01', NULL, NULL, 36, NULL, NULL, 232446),
(255961, '2e45A01', NULL, NULL, 23, NULL, NULL, 232446),
(255962, '2ez5W01', NULL, NULL, 36, NULL, NULL, 232446),
(255963, '1yw5A01', NULL, NULL, 63, NULL, NULL, 232446),
(255964, '2yshA01', NULL, NULL, 33, NULL, NULL, 232446),
(255965, '3cngA01', NULL, NULL, 37, NULL, NULL, 232446),
(255966, '4rohA01', NULL, NULL, 41, NULL, NULL, 232446),
(255967, '1pinA01', NULL, NULL, 37, NULL, NULL, 232446),
(255968, '2m3oW01', NULL, NULL, 36, NULL, NULL, 232446),
(255969, '5cq2A02', NULL, NULL, 51, NULL, NULL, 232446),
(255970, '2zajA01', NULL, NULL, 36, NULL, NULL, 232446),
(255971, '2zqvA01', NULL, NULL, 37, NULL, NULL, 232446),
(255972, '5dwsC01', NULL, NULL, 35, NULL, NULL, 232446),
(255973, '3m7nA03', NULL, NULL, 34, NULL, NULL, 232446),
(255974, '2m8iA01', NULL, NULL, 33, NULL, NULL, 232446),
(255975, '1eg3A01', NULL, NULL, 39, NULL, NULL, 232446),
(255976, '2re3B03', NULL, NULL, 30, NULL, NULL, 232446),
(255977, '2f21A01', NULL, NULL, 48, NULL, NULL, 232446),
(255978, '2ysiA01', NULL, NULL, 33, NULL, NULL, 232446),
(255979, '2lajA01', NULL, NULL, 37, NULL, NULL, 232446),
(255980, '2dk7A00', NULL, NULL, 73, NULL, NULL, 232446),
(255981, '2jv4A00', NULL, NULL, 54, NULL, NULL, 232446),
(255982, '2zr4A01', NULL, NULL, 37, NULL, NULL, 232446),
(255983, '2zquA01', NULL, NULL, 37, NULL, NULL, 232446),
(255984, '2jx8A00', NULL, NULL, 52, NULL, NULL, 232446),
(255985, '1wmvA01', NULL, NULL, 24, NULL, NULL, 232446),
(255986, '2kxqA02', NULL, NULL, 42, NULL, NULL, 232446),
(255987, '2kxqA01', NULL, NULL, 30, NULL, NULL, 232446),
(255988, '2dwvA01', NULL, NULL, 36, NULL, NULL, 232446),
(255989, '4e5rA00', NULL, NULL, 56, NULL, NULL, 232446),
(255990, '1tk7A01', NULL, NULL, 37, NULL, NULL, 232446),
(255991, '3tc5A01', NULL, NULL, 40, NULL, NULL, 232446),
(255992, '1tk7A02', NULL, NULL, 29, NULL, NULL, 232446),
(255993, '1i5hW00', NULL, NULL, 50, NULL, NULL, 232446),
(255994, '2dmvA01', NULL, NULL, 36, NULL, NULL, 232446),
(255995, '2ysbA01', NULL, NULL, 38, NULL, NULL, 232446),
(255996, '2jmfA01', NULL, NULL, 35, NULL, NULL, 232446),
(255997, '4u85A01', NULL, NULL, 31, NULL, NULL, 232446),
(255998, '2ysfA01', NULL, NULL, 33, NULL, NULL, 232446),
(255999, '4rexA00', NULL, NULL, 49, NULL, NULL, 232446),
(256000, '2mdiA00', NULL, NULL, 56, NULL, NULL, 232446),
(256001, '3le4A00', NULL, NULL, 56, NULL, NULL, 232446),
(256002, '1o6wA01', NULL, NULL, 26, NULL, NULL, 232446),
(256003, '1o6wA02', NULL, NULL, 33, NULL, NULL, 232446),
(256004, '2ysgA01', NULL, NULL, 33, NULL, NULL, 232446),
(256005, '2dk1A00', NULL, NULL, 50, NULL, NULL, 232446),
(256006, '2wyrB02', NULL, NULL, 91, NULL, NULL, 232447),
(256007, '4x8iA02', NULL, NULL, 94, NULL, NULL, 232447),
(256008, '3cpxA02', NULL, NULL, 62, NULL, NULL, 232447),
(256009, '2pe3D02', NULL, NULL, 94, NULL, NULL, 232447),
(256010, '2fvgA02', NULL, NULL, 87, NULL, NULL, 232447),
(256011, '5ds0A02', NULL, NULL, 88, NULL, NULL, 232447),
(256012, '1vhoA02', NULL, NULL, 85, NULL, NULL, 232447),
(256013, '1yloE02', NULL, NULL, 84, NULL, NULL, 232447),
(256014, '2greF02', NULL, NULL, 96, NULL, NULL, 232447),
(256015, '1vheA02', NULL, NULL, 88, NULL, NULL, 232447),
(256016, '1y0yA02', NULL, NULL, 94, NULL, NULL, 232447),
(256017, '4wwvB02', NULL, NULL, 94, NULL, NULL, 232447),
(256018, '3isxA02', NULL, NULL, 89, NULL, NULL, 232447),
(256019, '3kl9A02', NULL, NULL, 89, NULL, NULL, 232447),
(256020, '3w6wB02', NULL, NULL, 163, NULL, NULL, 232448),
(256021, '2xrhA00', NULL, NULL, 100, NULL, NULL, 232449),
(256022, '3zyyX03', NULL, NULL, 87, NULL, NULL, 232450),
(256023, '4phtB01', NULL, NULL, 79, NULL, NULL, 232451),
(256024, '2d28C02', NULL, NULL, 86, NULL, NULL, 232451),
(256025, '2bh1X00', NULL, NULL, 96, NULL, NULL, 232451),
(256026, '3o6uA00', NULL, NULL, 128, NULL, NULL, 232452),
(256027, '2kzxA00', NULL, NULL, 131, NULL, NULL, 232452);
INSERT INTO "PUBLIC"."MODEL" VALUES
(256028, '3kk7A03', NULL, NULL, 62, NULL, NULL, 232453),
(256029, '4dw1A02', NULL, NULL, 274, NULL, NULL, 232454),
(256030, '5u1xA02', NULL, NULL, 275, NULL, NULL, 232454),
(256031, '5xw6A02', NULL, NULL, 262, NULL, NULL, 232454),
(256032, '5svkA02', NULL, NULL, 265, NULL, NULL, 232454),
(256033, '5f1cA02', NULL, NULL, 284, NULL, NULL, 232454),
(256034, '4pg7A03', NULL, NULL, 81, NULL, NULL, 232455),
(256035, '4pg4B03', NULL, NULL, 75, NULL, NULL, 232455),
(256036, '2m20A00', NULL, NULL, 60, NULL, NULL, 232456),
(256037, '2n5sA00', NULL, NULL, 54, NULL, NULL, 232456),
(256038, '1xezA03', NULL, NULL, 48, NULL, NULL, 232457),
(256039, '6dcjA02', NULL, NULL, 112, NULL, NULL, 232458),
(256040, '2mhkA02', NULL, NULL, 109, NULL, NULL, 232458),
(256041, '3gw6A02', NULL, NULL, 52, NULL, NULL, 232459),
(256042, '3qwnD01', NULL, NULL, 78, NULL, NULL, 232460),
(256043, '3k0yA01', NULL, NULL, 83, NULL, NULL, 232460),
(256044, '3k6oA01', NULL, NULL, 86, NULL, NULL, 232460),
(256045, '3nqiA01', NULL, NULL, 79, NULL, NULL, 232460),
(256046, '4j8qA01', NULL, NULL, 81, NULL, NULL, 232460),
(256047, '4pqxA01', NULL, NULL, 80, NULL, NULL, 232460),
(256048, '5oomm00', NULL, NULL, 45, NULL, NULL, 232461),
(256049, '4v19400', NULL, NULL, 45, NULL, NULL, 232461),
(256050, '2r33B00', NULL, NULL, 58, NULL, NULL, 232462),
(256051, '2aihA00', NULL, NULL, 67, NULL, NULL, 232462),
(256052, '1bi6H00', NULL, NULL, 41, NULL, NULL, 232462),
(256053, '2qn5B02', NULL, NULL, 66, NULL, NULL, 232462),
(256054, '2qn5B01', NULL, NULL, 67, NULL, NULL, 232462),
(256055, '3mywI00', NULL, NULL, 72, NULL, NULL, 232462),
(256056, '5j4sB00', NULL, NULL, 71, NULL, NULL, 232462),
(256057, '2fj8A01', NULL, NULL, 63, NULL, NULL, 232462),
(256058, '1pi2A00', NULL, NULL, 63, NULL, NULL, 232462),
(256059, '2fj8A02', NULL, NULL, 62, NULL, NULL, 232462),
(256060, '2ilnI00', NULL, NULL, 62, NULL, NULL, 232462),
(256061, '1d6rI00', NULL, NULL, 58, NULL, NULL, 232462),
(256062, '1h34A00', NULL, NULL, 83, NULL, NULL, 232462),
(256063, '2g81I00', NULL, NULL, 67, NULL, NULL, 232462),
(256064, '1pbiA00', NULL, NULL, 72, NULL, NULL, 232462),
(256065, '2ot6B00', NULL, NULL, 62, NULL, NULL, 232462),
(256066, '2pv4A00', NULL, NULL, 145, NULL, NULL, 232463),
(256067, '2lxoA00', NULL, NULL, 44, NULL, NULL, 232464),
(256068, '2lwlA00', NULL, NULL, 49, NULL, NULL, 232464),
(256069, '1fd3A00', NULL, NULL, 41, NULL, NULL, 232464),
(256070, '2mjkA00', NULL, NULL, 41, NULL, NULL, 232464),
(256071, '1kj6A00', NULL, NULL, 45, NULL, NULL, 232464),
(256072, '2lnhC00', NULL, NULL, 48, NULL, NULL, 232465),
(256073, '2hh2A00', NULL, NULL, 85, NULL, NULL, 232466),
(256074, '2axyA00', NULL, NULL, 73, NULL, NULL, 232466),
(256075, '2je6I03', NULL, NULL, 69, NULL, NULL, 232466),
(256076, '2ctjA00', NULL, NULL, 95, NULL, NULL, 232466),
(256077, '4lijC00', NULL, NULL, 90, NULL, NULL, 232466),
(256078, '2ctfA00', NULL, NULL, 102, NULL, NULL, 232466),
(256079, '4wanG00', NULL, NULL, 129, NULL, NULL, 232466),
(256080, '4nbqB04', NULL, NULL, 79, NULL, NULL, 232466),
(256081, '1dtjA00', NULL, NULL, 76, NULL, NULL, 232466),
(256082, '3v69B00', NULL, NULL, 122, NULL, NULL, 232466),
(256083, '2bl5A00', NULL, NULL, 140, NULL, NULL, 232466),
(256084, '2mjhA00', NULL, NULL, 142, NULL, NULL, 232466),
(256085, '2opvA00', NULL, NULL, 85, NULL, NULL, 232466),
(256086, '4b8tA00', NULL, NULL, 106, NULL, NULL, 232466),
(256087, '1j4wA01', NULL, NULL, 74, NULL, NULL, 232466),
(256088, '5wwxA01', NULL, NULL, 71, NULL, NULL, 232466),
(256089, '1j4wA02', NULL, NULL, 71, NULL, NULL, 232466),
(256090, '2ctkA00', NULL, NULL, 104, NULL, NULL, 232466),
(256091, '3u1kB04', NULL, NULL, 73, NULL, NULL, 232466),
(256092, '3l7zF03', NULL, NULL, 96, NULL, NULL, 232466),
(256093, '2qndB01', NULL, NULL, 64, NULL, NULL, 232466),
(256094, '4qmfB01', NULL, NULL, 88, NULL, NULL, 232466),
(256095, '4am3A04', NULL, NULL, 74, NULL, NULL, 232466),
(256096, '4qmfD02', NULL, NULL, 103, NULL, NULL, 232466),
(256097, '1vigA00', NULL, NULL, 71, NULL, NULL, 232466),
(256098, '2opuA00', NULL, NULL, 89, NULL, NULL, 232466);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(256099, '1we8A01', NULL, NULL, 84, NULL, NULL, 232466),
(256100, '2ctlA00', NULL, NULL, 97, NULL, NULL, 232466),
(256101, '1x4mA01', NULL, NULL, 72, NULL, NULL, 232466),
(256102, '2yqrA01', NULL, NULL, 103, NULL, NULL, 232466),
(256103, '2p2rA00', NULL, NULL, 76, NULL, NULL, 232466),
(256104, '2jzxA02', NULL, NULL, 79, NULL, NULL, 232466),
(256105, '4jvhA00', NULL, NULL, 209, NULL, NULL, 232466),
(256106, '1zzkA00', NULL, NULL, 82, NULL, NULL, 232466),
(256107, '2nn6G03', NULL, NULL, 88, NULL, NULL, 232466),
(256108, '1tuaA01', NULL, NULL, 84, NULL, NULL, 232466),
(256109, '1tuaA02', NULL, NULL, 107, NULL, NULL, 232466),
(256110, '2cpqA01', NULL, NULL, 64, NULL, NULL, 232466),
(256111, '2jvzA01', NULL, NULL, 80, NULL, NULL, 232466),
(256112, '2jvzA02', NULL, NULL, 84, NULL, NULL, 232466),
(256113, '2cteA01', NULL, NULL, 79, NULL, NULL, 232466),
(256114, '2z0sA02', NULL, NULL, 87, NULL, NULL, 232466),
(256115, '2ja9A02', NULL, NULL, 84, NULL, NULL, 232466),
(256116, '2e3uA01', NULL, NULL, 82, NULL, NULL, 232466),
(256117, '1k1gA00', NULL, NULL, 131, NULL, NULL, 232466),
(256118, '2e3uA02', NULL, NULL, 105, NULL, NULL, 232466),
(256119, '2hh3A00', NULL, NULL, 82, NULL, NULL, 232466),
(256120, '2ba0A03', NULL, NULL, 93, NULL, NULL, 232466),
(256121, '1x4nA00', NULL, NULL, 92, NULL, NULL, 232466),
(256122, '3vkeA00', NULL, NULL, 76, NULL, NULL, 232466),
(256123, '2qndA02', NULL, NULL, 80, NULL, NULL, 232466),
(256124, '2ctmA00', NULL, NULL, 95, NULL, NULL, 232466),
(256125, '2anrA01', NULL, NULL, 82, NULL, NULL, 232466),
(256126, '1wvnA00', NULL, NULL, 82, NULL, NULL, 232466),
(256127, '2anrA02', NULL, NULL, 79, NULL, NULL, 232466),
(256128, '4jvyB00', NULL, NULL, 196, NULL, NULL, 232466),
(256129, '2dgrA01', NULL, NULL, 67, NULL, NULL, 232466),
(256130, '5wwwA01', NULL, NULL, 77, NULL, NULL, 232466),
(256131, '1dt4A00', NULL, NULL, 73, NULL, NULL, 232466),
(256132, '4aw7A03', NULL, NULL, 122, NULL, NULL, 232467),
(256133, '5ta0A03', NULL, NULL, 125, NULL, NULL, 232467),
(256134, '3zn6A02', NULL, NULL, 87, NULL, NULL, 232468),
(256135, '1y7jA00', NULL, NULL, 53, NULL, NULL, 232469),
(256136, '1hykA00', NULL, NULL, 46, NULL, NULL, 232469),
(256137, '2zuoC12', NULL, NULL, 43, NULL, NULL, 232470),
(256138, '3m6nC02', NULL, NULL, 60, NULL, NULL, 232471),
(256139, '5fusA02', NULL, NULL, 61, NULL, NULL, 232471),
(256140, '3qwuA03', NULL, NULL, 139, NULL, NULL, 232472),
(256141, '5ymrC00', NULL, NULL, 808, NULL, NULL, 232473),
(256142, '3o0qA00', NULL, NULL, 644, NULL, NULL, 232473),
(256143, '2xapA02', NULL, NULL, 507, NULL, NULL, 232473),
(256144, '1peqA02', NULL, NULL, 506, NULL, NULL, 232473),
(256145, '1l1lA01', NULL, NULL, 518, NULL, NULL, 232473),
(256146, '6cgmA02', NULL, NULL, 500, NULL, NULL, 232473),
(256147, '1h16A00', NULL, NULL, 759, NULL, NULL, 232473),
(256148, '3k8tA00', NULL, NULL, 657, NULL, NULL, 232473),
(256149, '2ha9B00', NULL, NULL, 446, NULL, NULL, 232473),
(256150, '2f3oA00', NULL, NULL, 776, NULL, NULL, 232473),
(256151, '2wghA00', NULL, NULL, 676, NULL, NULL, 232473),
(256152, '1hk8A00', NULL, NULL, 561, NULL, NULL, 232473),
(256153, '5a0uA01', NULL, NULL, 789, NULL, NULL, 232473),
(256154, '1r9dA01', NULL, NULL, 779, NULL, NULL, 232473),
(256155, '5favA00', NULL, NULL, 815, NULL, NULL, 232473),
(256156, '5i2gA01', NULL, NULL, 792, NULL, NULL, 232473),
(256157, '2y8nA00', NULL, NULL, 869, NULL, NULL, 232473),
(256158, '2cs8A01', NULL, NULL, 35, NULL, NULL, 232474),
(256159, '2cs8A02', NULL, NULL, 36, NULL, NULL, 232474),
(256160, '2ymsA00', NULL, NULL, 130, NULL, NULL, 232475),
(256161, '1f0xA04', NULL, NULL, 85, NULL, NULL, 232476),
(256162, '2ffgA00', NULL, NULL, 87, NULL, NULL, 232477),
(256163, '3q23A06', NULL, NULL, 45, NULL, NULL, 232478),
(256164, '5teqA01', NULL, NULL, 236, NULL, NULL, 232479),
(256165, '3rklA00', NULL, NULL, 87, NULL, NULL, 232480),
(256166, '3m1cA01', NULL, NULL, 52, NULL, NULL, 232481),
(256167, '3d1lA02', NULL, NULL, 99, NULL, NULL, 232482),
(256168, '2i76B02', NULL, NULL, 101, NULL, NULL, 232482),
(256169, '3hnwA00', NULL, NULL, 138, NULL, NULL, 232483);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(256170, '3g8qA02', NULL, NULL, 80, NULL, NULL, 232484),
(256171, '3fo8D02', NULL, NULL, 91, NULL, NULL, 232485),
(256172, '2ov9A02', NULL, NULL, 59, NULL, NULL, 232486),
(256173, '3hlzB01', NULL, NULL, 140, NULL, NULL, 232487),
(256174, '2xb3A00', NULL, NULL, 165, NULL, NULL, 232487),
(256175, '2vu4A00', NULL, NULL, 171, NULL, NULL, 232487),
(256176, '4bq6F00', NULL, NULL, 153, NULL, NULL, 232487),
(256177, '1v2bB00', NULL, NULL, 177, NULL, NULL, 232487),
(256178, '1tu1A00', NULL, NULL, 148, NULL, NULL, 232487),
(256179, '2lnjA00', NULL, NULL, 170, NULL, NULL, 232487),
(256180, '1jhsA00', NULL, NULL, 188, NULL, NULL, 232487),
(256181, '3v7bA00', NULL, NULL, 151, NULL, NULL, 232487),
(256182, '3lydA01', NULL, NULL, 142, NULL, NULL, 232487),
(256183, '4rthB00', NULL, NULL, 186, NULL, NULL, 232487),
(256184, '5xnlP00', NULL, NULL, 186, NULL, NULL, 232487),
(256185, '2loqA01', NULL, NULL, 84, NULL, NULL, 232488),
(256186, '4dhiB01', NULL, NULL, 102, NULL, NULL, 232489),
(256187, '4fjvC01', NULL, NULL, 93, NULL, NULL, 232489),
(256188, '2zfyA01', NULL, NULL, 90, NULL, NULL, 232489),
(256189, '4ldtA01', NULL, NULL, 121, NULL, NULL, 232489),
(256190, '3lovA02', NULL, NULL, 216, NULL, NULL, 232490),
(256191, '1sezA02', NULL, NULL, 185, NULL, NULL, 232490),
(256192, '3i6dA02', NULL, NULL, 192, NULL, NULL, 232490),
(256193, '2ivdA02', NULL, NULL, 188, NULL, NULL, 232490),
(256194, '5h7wA02', NULL, NULL, 218, NULL, NULL, 232491),
(256195, '1hp1A02', NULL, NULL, 187, NULL, NULL, 232491),
(256196, '3iveA02', NULL, NULL, 198, NULL, NULL, 232491),
(256197, '3c9fA02', NULL, NULL, 177, NULL, NULL, 232491),
(256198, '4h2gA02', NULL, NULL, 213, NULL, NULL, 232491),
(256199, '2wdcA03', NULL, NULL, 200, NULL, NULL, 232491),
(256200, '4q7fA02', NULL, NULL, 208, NULL, NULL, 232491),
(256201, '3ztvA02', NULL, NULL, 223, NULL, NULL, 232491),
(256202, '2z1aA02', NULL, NULL, 202, NULL, NULL, 232491),
(256203, '2avuA00', NULL, NULL, 78, NULL, NULL, 232492),
(256204, '2avuB00', NULL, NULL, 116, NULL, NULL, 232492),
(256205, '1g8eB00', NULL, NULL, 82, NULL, NULL, 232492),
(256206, '5hxgB00', NULL, NULL, 69, NULL, NULL, 232492),
(256207, '2mf3A00', NULL, NULL, 47, NULL, NULL, 232493),
(256208, '1vz0A01', NULL, NULL, 63, NULL, NULL, 232494),
(256209, '3ol4A02', NULL, NULL, 63, NULL, NULL, 232495),
(256210, '2vfrA04', NULL, NULL, 94, NULL, NULL, 232496),
(256211, '2iukA02', NULL, NULL, 97, NULL, NULL, 232497),
(256212, '2iujA02', NULL, NULL, 99, NULL, NULL, 232497),
(256213, '4wfoA02', NULL, NULL, 100, NULL, NULL, 232497),
(256214, '1ik3A02', NULL, NULL, 100, NULL, NULL, 232497),
(256215, '3cskA02', NULL, NULL, 162, NULL, NULL, 232498),
(256216, '5e33A02', NULL, NULL, 163, NULL, NULL, 232498),
(256217, '1bk4A02', NULL, NULL, 135, NULL, NULL, 232499),
(256218, '1dcuA02', NULL, NULL, 131, NULL, NULL, 232499),
(256219, '2gq1A02', NULL, NULL, 138, NULL, NULL, 232499),
(256220, '2pcrA02', NULL, NULL, 115, NULL, NULL, 232499),
(256221, '1nuwA02', NULL, NULL, 135, NULL, NULL, 232499),
(256222, '5i3sC02', NULL, NULL, 136, NULL, NULL, 232499),
(256223, '1lbvA02', NULL, NULL, 114, NULL, NULL, 232499),
(256224, '2bjiB02', NULL, NULL, 131, NULL, NULL, 232499),
(256225, '2q74A02', NULL, NULL, 135, NULL, NULL, 232499),
(256226, '5oezA02', NULL, NULL, 146, NULL, NULL, 232499),
(256227, '2p3nA02', NULL, NULL, 121, NULL, NULL, 232499),
(256228, '4n81A02', NULL, NULL, 117, NULL, NULL, 232499),
(256229, '6giuA02', NULL, NULL, 131, NULL, NULL, 232499),
(256230, '1xi6A02', NULL, NULL, 114, NULL, NULL, 232499),
(256231, '4qxdB02', NULL, NULL, 135, NULL, NULL, 232499),
(256232, '2wefA02', NULL, NULL, 136, NULL, NULL, 232499),
(256233, '5eq7A02', NULL, NULL, 124, NULL, NULL, 232499),
(256234, '1g0hA02', NULL, NULL, 115, NULL, NULL, 232499),
(256235, '5esyA02', NULL, NULL, 132, NULL, NULL, 232499),
(256236, '1spiA02', NULL, NULL, 132, NULL, NULL, 232499),
(256237, '4he2A02', NULL, NULL, 134, NULL, NULL, 232499),
(256238, '4as5A02', NULL, NULL, 131, NULL, NULL, 232499),
(256239, '5pzrA02', NULL, NULL, 135, NULL, NULL, 232499),
(256240, '6ib8B02', NULL, NULL, 127, NULL, NULL, 232499);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(256241, '1inpA03', NULL, NULL, 166, NULL, NULL, 232499),
(256242, '1vdwA02', NULL, NULL, 114, NULL, NULL, 232499),
(256243, '3lv0A02', NULL, NULL, 121, NULL, NULL, 232499),
(256244, '1ka1A02', NULL, NULL, 137, NULL, NULL, 232499),
(256245, '5iz3B02', NULL, NULL, 142, NULL, NULL, 232499),
(256246, '3b8bA02', NULL, NULL, 112, NULL, NULL, 232499),
(256247, '4o7iA02', NULL, NULL, 143, NULL, NULL, 232499),
(256248, '1jp4A02', NULL, NULL, 129, NULL, NULL, 232499),
(256249, '2fvzA02', NULL, NULL, 131, NULL, NULL, 232499),
(256250, '4ir8B02', NULL, NULL, 132, NULL, NULL, 232499),
(256251, '5zhhA02', NULL, NULL, 118, NULL, NULL, 232499),
(256252, '5iz1A02', NULL, NULL, 131, NULL, NULL, 232499),
(256253, '4i3yA02', NULL, NULL, 120, NULL, NULL, 232499),
(256254, '2r5oA01', NULL, NULL, 151, NULL, NULL, 232500),
(256255, '5hnoA00', NULL, NULL, 170, NULL, NULL, 232500),
(256256, '4aybB08', NULL, NULL, 109, NULL, NULL, 232501),
(256257, '3h0gB08', NULL, NULL, 99, NULL, NULL, 232501),
(256258, '4c2mB08', NULL, NULL, 149, NULL, NULL, 232501),
(256259, '1twfB08', NULL, NULL, 85, NULL, NULL, 232501),
(256260, '4qiwB08', NULL, NULL, 81, NULL, NULL, 232501),
(256261, '3cqzB08', NULL, NULL, 97, NULL, NULL, 232501),
(256262, '3tfgA00', NULL, NULL, 189, NULL, NULL, 232502),
(256263, '4u9bA00', NULL, NULL, 187, NULL, NULL, 232502),
(256264, '3sj5A00', NULL, NULL, 188, NULL, NULL, 232502),
(256265, '4hstA02', NULL, NULL, 65, NULL, NULL, 232503),
(256266, '4hspA00', NULL, NULL, 150, NULL, NULL, 232504),
(256267, '2c52B00', NULL, NULL, 59, NULL, NULL, 232505),
(256268, '2xi9A03', NULL, NULL, 101, NULL, NULL, 232506),
(256269, '4c0zA02', NULL, NULL, 96, NULL, NULL, 232506),
(256270, '5a0lA02', NULL, NULL, 99, NULL, NULL, 232506),
(256271, '3tklB02', NULL, NULL, 131, NULL, NULL, 232507),
(256272, '1wjvA01', NULL, NULL, 51, NULL, NULL, 232508),
(256273, '1rf8B01', NULL, NULL, 69, NULL, NULL, 232509),
(256274, '3adyA00', NULL, NULL, 127, NULL, NULL, 232510),
(256275, '1td9A02', NULL, NULL, 154, NULL, NULL, 232511),
(256276, '6iowA02', NULL, NULL, 161, NULL, NULL, 232511),
(256277, '1r5jA02', NULL, NULL, 156, NULL, NULL, 232511),
(256278, '2af4C02', NULL, NULL, 161, NULL, NULL, 232511),
(256279, '4e4rA02', NULL, NULL, 158, NULL, NULL, 232511),
(256280, '1vmiA02', NULL, NULL, 157, NULL, NULL, 232511),
(256281, '2wadB03', NULL, NULL, 103, NULL, NULL, 232512),
(256282, '3vskA02', NULL, NULL, 140, NULL, NULL, 232512),
(256283, '3iylW03', NULL, NULL, 263, NULL, NULL, 232513),
(256284, '1ej6A03', NULL, NULL, 263, NULL, NULL, 232513),
(256285, '2vszA01', NULL, NULL, 32, NULL, NULL, 232514),
(256286, '4aq1A03', NULL, NULL, 115, NULL, NULL, 232515),
(256287, '2kzkA00', NULL, NULL, 107, NULL, NULL, 232516),
(256288, '2kzbA00', NULL, NULL, 118, NULL, NULL, 232516),
(256289, '2d13A02', NULL, NULL, 101, NULL, NULL, 232517),
(256290, '3rk1B02', NULL, NULL, 96, NULL, NULL, 232517),
(256291, '1gkuB07', NULL, NULL, 102, NULL, NULL, 232518),
(256292, '4dduA07', NULL, NULL, 107, NULL, NULL, 232518),
(256293, '2p5zX03', NULL, NULL, 16, NULL, NULL, 232519),
(256294, '3be3A00', NULL, NULL, 91, NULL, NULL, 232520),
(256295, '1vpjA00', NULL, NULL, 192, NULL, NULL, 232521),
(256296, '5dniA00', NULL, NULL, 179, NULL, NULL, 232521),
(256297, '1vpjB00', NULL, NULL, 192, NULL, NULL, 232521),
(256298, '2isbA00', NULL, NULL, 192, NULL, NULL, 232521),
(256299, '4f27A02', NULL, NULL, 171, NULL, NULL, 232522),
(256300, '4mboA02', NULL, NULL, 160, NULL, NULL, 232522),
(256301, '3irpX02', NULL, NULL, 148, NULL, NULL, 232522),
(256302, '4bbwA01', NULL, NULL, 161, NULL, NULL, 232522),
(256303, '4mbrA02', NULL, NULL, 177, NULL, NULL, 232522),
(256304, '3at0A02', NULL, NULL, 181, NULL, NULL, 232522),
(256305, '4fj6D01', NULL, NULL, 163, NULL, NULL, 232522),
(256306, '5ihwA02', NULL, NULL, 166, NULL, NULL, 232522),
(256307, '4je0A02', NULL, NULL, 161, NULL, NULL, 232522),
(256308, '2vr3B02', NULL, NULL, 158, NULL, NULL, 232522),
(256309, '4q6kA01', NULL, NULL, 166, NULL, NULL, 232522),
(256310, '4b60A02', NULL, NULL, 168, NULL, NULL, 232522),
(256311, '4rmbB00', NULL, NULL, 166, NULL, NULL, 232522);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(256312, '1r17A02', NULL, NULL, 158, NULL, NULL, 232522),
(256313, '5cfaA02', NULL, NULL, 166, NULL, NULL, 232522),
(256314, '2g0qA02', NULL, NULL, 49, NULL, NULL, 232523),
(256315, '3di2A00', NULL, NULL, 154, NULL, NULL, 232524),
(256316, '3di2C00', NULL, NULL, 122, NULL, NULL, 232524),
(256317, '2fgyA03', NULL, NULL, 117, NULL, NULL, 232525),
(256318, '2w8sA02', NULL, NULL, 44, NULL, NULL, 232526),
(256319, '4upkA02', NULL, NULL, 46, NULL, NULL, 232526),
(256320, '2vqrA02', NULL, NULL, 44, NULL, NULL, 232526),
(256321, '3bjvA00', NULL, NULL, 161, NULL, NULL, 232527),
(256322, '6mtoT00', NULL, NULL, 160, NULL, NULL, 232527),
(256323, '3t43A00', NULL, NULL, 162, NULL, NULL, 232527),
(256324, '4ky9P00', NULL, NULL, 306, NULL, NULL, 232527),
(256325, '2a0jA00', NULL, NULL, 149, NULL, NULL, 232527),
(256326, '2oqtD00', NULL, NULL, 162, NULL, NULL, 232527),
(256327, '2oq3A00', NULL, NULL, 150, NULL, NULL, 232527),
(256328, '1a3aC00', NULL, NULL, 148, NULL, NULL, 232527),
(256329, '5sy8O00', NULL, NULL, 163, NULL, NULL, 232527),
(256330, '3oxpA00', NULL, NULL, 150, NULL, NULL, 232527),
(256331, '1xizB00', NULL, NULL, 159, NULL, NULL, 232527),
(256332, '3urrA00', NULL, NULL, 153, NULL, NULL, 232527),
(256333, '1a6jB00', NULL, NULL, 163, NULL, NULL, 232527),
(256334, '1rsoA01', NULL, NULL, 51, NULL, NULL, 232528),
(256335, '2f93B00', NULL, NULL, 51, NULL, NULL, 232528),
(256336, '3lnnB03', NULL, NULL, 67, NULL, NULL, 232528),
(256337, '5d5pC01', NULL, NULL, 36, NULL, NULL, 232528),
(256338, '3wb0A01', NULL, NULL, 37, NULL, NULL, 232528),
(256339, '1vf7A03', NULL, NULL, 60, NULL, NULL, 232528),
(256340, '2f1mA03', NULL, NULL, 74, NULL, NULL, 232528),
(256341, '4l8jA04', NULL, NULL, 59, NULL, NULL, 232528),
(256342, '3brcA01', NULL, NULL, 35, NULL, NULL, 232528),
(256343, '4g1uA00', NULL, NULL, 331, NULL, NULL, 232529),
(256344, '2nq2A00', NULL, NULL, 337, NULL, NULL, 232529),
(256345, '5b57B00', NULL, NULL, 338, NULL, NULL, 232529),
(256346, '1l7vA00', NULL, NULL, 326, NULL, NULL, 232529),
(256347, '2qi9A00', NULL, NULL, 326, NULL, NULL, 232529),
(256348, '4dnyA00', NULL, NULL, 126, NULL, NULL, 232530),
(256349, '3e0jB00', NULL, NULL, 144, NULL, NULL, 232531),
(256350, '2la7A01', NULL, NULL, 128, NULL, NULL, 232532),
(256351, '4zgfA00', NULL, NULL, 141, NULL, NULL, 232532),
(256352, '4l3rA00', NULL, NULL, 146, NULL, NULL, 232532),
(256353, '2ktsA01', NULL, NULL, 102, NULL, NULL, 232532),
(256354, '2wjvD02', NULL, NULL, 32, NULL, NULL, 232533),
(256355, '1vddA02', NULL, NULL, 23, NULL, NULL, 232534),
(256356, '3vdpA02', NULL, NULL, 23, NULL, NULL, 232534),
(256357, '3d00A02', NULL, NULL, 30, NULL, NULL, 232534),
(256358, '4qbuA02', NULL, NULL, 241, NULL, NULL, 232535),
(256359, '3im8A01', NULL, NULL, 234, NULL, NULL, 232535),
(256360, '3sbmA01', NULL, NULL, 213, NULL, NULL, 232535),
(256361, '5dz6A01', NULL, NULL, 219, NULL, NULL, 232535),
(256362, '4rl1A01', NULL, NULL, 257, NULL, NULL, 232535),
(256363, '4rr5A01', NULL, NULL, 229, NULL, NULL, 232535),
(256364, '2jfkA02', NULL, NULL, 248, NULL, NULL, 232535),
(256365, '2uvaG02', NULL, NULL, 306, NULL, NULL, 232535),
(256366, '5czcB01', NULL, NULL, 235, NULL, NULL, 232535),
(256367, '2uv8G02', NULL, NULL, 308, NULL, NULL, 232535),
(256368, '5dz7A01', NULL, NULL, 219, NULL, NULL, 232535),
(256369, '5my2A03', NULL, NULL, 175, NULL, NULL, 232535),
(256370, '3tqeA01', NULL, NULL, 243, NULL, NULL, 232535),
(256371, '3tzyA01', NULL, NULL, 397, NULL, NULL, 232535),
(256372, '2cuyA01', NULL, NULL, 236, NULL, NULL, 232535),
(256373, '5ypvA01', NULL, NULL, 240, NULL, NULL, 232535),
(256374, '1nm2A02', NULL, NULL, 239, NULL, NULL, 232535),
(256375, '3g87A01', NULL, NULL, 226, NULL, NULL, 232535),
(256376, '1mlaA02', NULL, NULL, 236, NULL, NULL, 232535),
(256377, '3h0pA01', NULL, NULL, 239, NULL, NULL, 232535),
(256378, '3hjvA01', NULL, NULL, 239, NULL, NULL, 232535),
(256379, '3im9A01', NULL, NULL, 242, NULL, NULL, 232535),
(256380, '2qc3A01', NULL, NULL, 239, NULL, NULL, 232535),
(256381, '2vz8B03', NULL, NULL, 299, NULL, NULL, 232535),
(256382, '4ammA00', NULL, NULL, 401, NULL, NULL, 232535);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(256383, '3k89A01', NULL, NULL, 241, NULL, NULL, 232535),
(256384, '3hhdA03', NULL, NULL, 175, NULL, NULL, 232535),
(256385, '3qatA01', NULL, NULL, 245, NULL, NULL, 232535),
(256386, '2c2nA01', NULL, NULL, 240, NULL, NULL, 232535),
(256387, '2uvaJ10', NULL, NULL, 170, NULL, NULL, 232535),
(256388, '3ptwA01', NULL, NULL, 247, NULL, NULL, 232535),
(256389, '2hg4D03', NULL, NULL, 304, NULL, NULL, 232535),
(256390, '3ezoA01', NULL, NULL, 245, NULL, NULL, 232535),
(256391, '2qo3A03', NULL, NULL, 305, NULL, NULL, 232535),
(256392, '2h1yB01', NULL, NULL, 251, NULL, NULL, 232535),
(256393, '3bt7A02', NULL, NULL, 145, NULL, NULL, 232536),
(256394, '2jjqA03', NULL, NULL, 144, NULL, NULL, 232536),
(256395, '1uwvA03', NULL, NULL, 137, NULL, NULL, 232536),
(256396, '3vywA01', NULL, NULL, 70, NULL, NULL, 232537),
(256397, '2kuyA00', NULL, NULL, 43, NULL, NULL, 232538),
(256398, '1vpuA00', NULL, NULL, 45, NULL, NULL, 232539),
(256399, '4as2A02', NULL, NULL, 103, NULL, NULL, 232540),
(256400, '6bbtB01', NULL, NULL, 148, NULL, NULL, 232541),
(256401, '6bbwA01', NULL, NULL, 148, NULL, NULL, 232541),
(256402, '3gldA01', NULL, NULL, 143, NULL, NULL, 232541),
(256403, '6n0aB01', NULL, NULL, 149, NULL, NULL, 232541),
(256404, '3klqA01', NULL, NULL, 123, NULL, NULL, 232541),
(256405, '4fjoA00', NULL, NULL, 97, NULL, NULL, 232542),
(256406, '4extA00', NULL, NULL, 96, NULL, NULL, 232542),
(256407, '4ba9A00', NULL, NULL, 114, NULL, NULL, 232542),
(256408, '2eefA01', NULL, NULL, 127, NULL, NULL, 232543),
(256409, '4bfoA00', NULL, NULL, 106, NULL, NULL, 232543),
(256410, '4eibA00', NULL, NULL, 109, NULL, NULL, 232543),
(256411, '2m83A00', NULL, NULL, 139, NULL, NULL, 232543),
(256412, '2j42A01', NULL, NULL, 246, NULL, NULL, 232544),
(256413, '3tewA01', NULL, NULL, 258, NULL, NULL, 232544),
(256414, '2oyhE01', NULL, NULL, 37, NULL, NULL, 232545),
(256415, '1fzcB03', NULL, NULL, 51, NULL, NULL, 232545),
(256416, '2a45G00', NULL, NULL, 57, NULL, NULL, 232545),
(256417, '1m1jC03', NULL, NULL, 138, NULL, NULL, 232545),
(256418, '1m1jB03', NULL, NULL, 144, NULL, NULL, 232545),
(256419, '1fzcA00', NULL, NULL, 87, NULL, NULL, 232545),
(256420, '1jy2N00', NULL, NULL, 53, NULL, NULL, 232545),
(256421, '1jy2O00', NULL, NULL, 56, NULL, NULL, 232545),
(256422, '2a45H00', NULL, NULL, 52, NULL, NULL, 232545),
(256423, '1fzcC03', NULL, NULL, 56, NULL, NULL, 232545),
(256424, '3e1iA00', NULL, NULL, 64, NULL, NULL, 232545),
(256425, '1n73D00', NULL, NULL, 100, NULL, NULL, 232545),
(256426, '2oyhA00', NULL, NULL, 66, NULL, NULL, 232545),
(256427, '2a45L00', NULL, NULL, 45, NULL, NULL, 232545),
(256428, '1lwuC03', NULL, NULL, 66, NULL, NULL, 232545),
(256429, '3ghgJ01', NULL, NULL, 150, NULL, NULL, 232545),
(256430, '1lwuB03', NULL, NULL, 66, NULL, NULL, 232545),
(256431, '1jy2S00', NULL, NULL, 48, NULL, NULL, 232545),
(256432, '1t3uA02', NULL, NULL, 56, NULL, NULL, 232545),
(256433, '1m1jA00', NULL, NULL, 192, NULL, NULL, 232545),
(256434, '3ghgB01', NULL, NULL, 139, NULL, NULL, 232545),
(256435, '3ghgC01', NULL, NULL, 143, NULL, NULL, 232545),
(256436, '2wm9A03', NULL, NULL, 122, NULL, NULL, 232546),
(256437, '2yinA03', NULL, NULL, 130, NULL, NULL, 232546),
(256438, '6ajlA02', NULL, NULL, 123, NULL, NULL, 232546),
(256439, '3vhlA02', NULL, NULL, 123, NULL, NULL, 232546),
(256440, '4tqrA02', NULL, NULL, 67, NULL, NULL, 232547),
(256441, '3osnA02', NULL, NULL, 62, NULL, NULL, 232547),
(256442, '5yuyA02', NULL, NULL, 53, NULL, NULL, 232547),
(256443, '3gqcD02', NULL, NULL, 44, NULL, NULL, 232547),
(256444, '4f4wA02', NULL, NULL, 67, NULL, NULL, 232547),
(256445, '3gqcA02', NULL, NULL, 65, NULL, NULL, 232547),
(256446, '3mfiA02', NULL, NULL, 97, NULL, NULL, 232547),
(256447, '5wm1A03', NULL, NULL, 72, NULL, NULL, 232547),
(256448, '6cstA03', NULL, NULL, 59, NULL, NULL, 232547),
(256449, '4dezA02', NULL, NULL, 67, NULL, NULL, 232547),
(256450, '5kfzA02', NULL, NULL, 70, NULL, NULL, 232547),
(256451, '4lsbA02', NULL, NULL, 52, NULL, NULL, 232548),
(256452, '4phzA01', NULL, NULL, 153, NULL, NULL, 232549),
(256453, '4o65A00', NULL, NULL, 166, NULL, NULL, 232549);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(256454, '1yewA01', NULL, NULL, 149, NULL, NULL, 232549),
(256455, '3chxA01', NULL, NULL, 147, NULL, NULL, 232549),
(256456, '6cxhA01', NULL, NULL, 149, NULL, NULL, 232549),
(256457, '1sx3A01', NULL, NULL, 250, NULL, NULL, 232550),
(256458, '5cdiA01', NULL, NULL, 257, NULL, NULL, 232550),
(256459, '1iokA01', NULL, NULL, 253, NULL, NULL, 232550),
(256460, '4aolZ01', NULL, NULL, 277, NULL, NULL, 232550),
(256461, '5x9vA01', NULL, NULL, 254, NULL, NULL, 232550),
(256462, '3ruvA01', NULL, NULL, 263, NULL, NULL, 232550),
(256463, '4pj1A01', NULL, NULL, 257, NULL, NULL, 232550),
(256464, '4aolQ01', NULL, NULL, 281, NULL, NULL, 232550),
(256465, '5da8X01', NULL, NULL, 252, NULL, NULL, 232550),
(256466, '3p9dB01', NULL, NULL, 271, NULL, NULL, 232550),
(256467, '3rtkA01', NULL, NULL, 182, NULL, NULL, 232550),
(256468, '4aolA01', NULL, NULL, 290, NULL, NULL, 232550),
(256469, '4aolD01', NULL, NULL, 262, NULL, NULL, 232550),
(256470, '1q3qA01', NULL, NULL, 267, NULL, NULL, 232550),
(256471, '4aolE01', NULL, NULL, 261, NULL, NULL, 232550),
(256472, '4aolG01', NULL, NULL, 267, NULL, NULL, 232550),
(256473, '3aq1B01', NULL, NULL, 165, NULL, NULL, 232550),
(256474, '3kttB01', NULL, NULL, 255, NULL, NULL, 232550),
(256475, '3p9dG01', NULL, NULL, 268, NULL, NULL, 232550),
(256476, '3ko1A01', NULL, NULL, 244, NULL, NULL, 232550),
(256477, '4xciB01', NULL, NULL, 248, NULL, NULL, 232550),
(256478, '4xcgA01', NULL, NULL, 246, NULL, NULL, 232550),
(256479, '1a6dA01', NULL, NULL, 244, NULL, NULL, 232550),
(256480, '1a6dB01', NULL, NULL, 242, NULL, NULL, 232550),
(256481, '1we3G01', NULL, NULL, 253, NULL, NULL, 232550),
(256482, '1heiA03', NULL, NULL, 157, NULL, NULL, 232551),
(256483, '5wdxA05', NULL, NULL, 134, NULL, NULL, 232551),
(256484, '2zjoA03', NULL, NULL, 175, NULL, NULL, 232551),
(256485, '4wxpA03', NULL, NULL, 168, NULL, NULL, 232551),
(256486, '3o8bA05', NULL, NULL, 134, NULL, NULL, 232551),
(256487, '1urjA02', NULL, NULL, 217, NULL, NULL, 232552),
(256488, '2kjyA00', NULL, NULL, 60, NULL, NULL, 232553),
(256489, '1m6nA05', NULL, NULL, 85, NULL, NULL, 232554),
(256490, '1pmiA02', NULL, NULL, 136, NULL, NULL, 232555),
(256491, '2wfpA03', NULL, NULL, 113, NULL, NULL, 232555),
(256492, '4hcwA02', NULL, NULL, 168, NULL, NULL, 232556),
(256493, '1xmbA02', NULL, NULL, 118, NULL, NULL, 232557),
(256494, '1vixA02', NULL, NULL, 112, NULL, NULL, 232557),
(256495, '3ct9A02', NULL, NULL, 107, NULL, NULL, 232557),
(256496, '3tx8A02', NULL, NULL, 114, NULL, NULL, 232557),
(256497, '1fnoA02', NULL, NULL, 110, NULL, NULL, 232557),
(256498, '2pokA02', NULL, NULL, 170, NULL, NULL, 232557),
(256499, '5uejA02', NULL, NULL, 114, NULL, NULL, 232557),
(256500, '3pfoA02', NULL, NULL, 128, NULL, NULL, 232557),
(256501, '2zogA02', NULL, NULL, 174, NULL, NULL, 232557),
(256502, '2f7vA02', NULL, NULL, 114, NULL, NULL, 232557),
(256503, '5xoyB02', NULL, NULL, 107, NULL, NULL, 232557),
(256504, '4q7aC02', NULL, NULL, 108, NULL, NULL, 232557),
(256505, '4ewtA02', NULL, NULL, 115, NULL, NULL, 232557),
(256506, '4pxeA02', NULL, NULL, 117, NULL, NULL, 232557),
(256507, '2v8hA02', NULL, NULL, 116, NULL, NULL, 232557),
(256508, '3ifeA02', NULL, NULL, 111, NULL, NULL, 232557),
(256509, '4g1pA02', NULL, NULL, 174, NULL, NULL, 232557),
(256510, '5tp4A02', NULL, NULL, 115, NULL, NULL, 232557),
(256511, '1cg2A02', NULL, NULL, 110, NULL, NULL, 232557),
(256512, '5vo3A02', NULL, NULL, 114, NULL, NULL, 232557),
(256513, '1lfwA02', NULL, NULL, 106, NULL, NULL, 232557),
(256514, '1lfwA03', NULL, NULL, 88, NULL, NULL, 232557),
(256515, '3pfeA02', NULL, NULL, 130, NULL, NULL, 232557),
(256516, '5i4mA02', NULL, NULL, 115, NULL, NULL, 232557),
(256517, '3dljA02', NULL, NULL, 174, NULL, NULL, 232557),
(256518, '2rb7A02', NULL, NULL, 107, NULL, NULL, 232557),
(256519, '1ysjA02', NULL, NULL, 113, NULL, NULL, 232557),
(256520, '3io1A02', NULL, NULL, 116, NULL, NULL, 232557),
(256521, '4pxdA02', NULL, NULL, 115, NULL, NULL, 232557),
(256522, '3ramA02', NULL, NULL, 118, NULL, NULL, 232557),
(256523, '3rzaA02', NULL, NULL, 111, NULL, NULL, 232557),
(256524, '3n5fA02', NULL, NULL, 114, NULL, NULL, 232557);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(256525, '5k8pA02', NULL, NULL, 131, NULL, NULL, 232557),
(256526, '3gb0A02', NULL, NULL, 112, NULL, NULL, 232557),
(256527, '4ruhB02', NULL, NULL, 174, NULL, NULL, 232557),
(256528, '4mmoA02', NULL, NULL, 167, NULL, NULL, 232557),
(256529, '4wjbA02', NULL, NULL, 115, NULL, NULL, 232557),
(256530, '3dgsA02', NULL, NULL, 104, NULL, NULL, 232558),
(256531, '1g3pA02', NULL, NULL, 104, NULL, NULL, 232558),
(256532, '3knqA02', NULL, NULL, 101, NULL, NULL, 232558),
(256533, '4mkvA01', NULL, NULL, 127, NULL, NULL, 232559),
(256534, '3kdnI01', NULL, NULL, 136, NULL, NULL, 232559),
(256535, '1bxnA01', NULL, NULL, 127, NULL, NULL, 232559),
(256536, '3zxwA01', NULL, NULL, 127, NULL, NULL, 232559),
(256537, '1rblA01', NULL, NULL, 127, NULL, NULL, 232559),
(256538, '5oyaC01', NULL, NULL, 128, NULL, NULL, 232559),
(256539, '5rubA01', NULL, NULL, 132, NULL, NULL, 232559),
(256540, '1ykwA01', NULL, NULL, 145, NULL, NULL, 232559),
(256541, '1svdA01', NULL, NULL, 140, NULL, NULL, 232559),
(256542, '1wddA01', NULL, NULL, 127, NULL, NULL, 232559),
(256543, '1gk8A01', NULL, NULL, 127, NULL, NULL, 232559),
(256544, '4nasB01', NULL, NULL, 123, NULL, NULL, 232559),
(256545, '3nwrA01', NULL, NULL, 142, NULL, NULL, 232559),
(256546, '5nv3A01', NULL, NULL, 128, NULL, NULL, 232559),
(256547, '2d69B01', NULL, NULL, 133, NULL, NULL, 232559),
(256548, '2oemA01', NULL, NULL, 120, NULL, NULL, 232559),
(256549, '5macE01', NULL, NULL, 140, NULL, NULL, 232559),
(256550, '3rubL01', NULL, NULL, 127, NULL, NULL, 232559),
(256551, '6ftlA01', NULL, NULL, 128, NULL, NULL, 232559),
(256552, '5c2cA01', NULL, NULL, 132, NULL, NULL, 232559),
(256553, '5iu0A01', NULL, NULL, 127, NULL, NULL, 232559),
(256554, '5hjxA01', NULL, NULL, 133, NULL, NULL, 232559),
(256555, '3fk4B01', NULL, NULL, 121, NULL, NULL, 232559),
(256556, '2zviA01', NULL, NULL, 113, NULL, NULL, 232559),
(256557, '2qygA01', NULL, NULL, 145, NULL, NULL, 232559),
(256558, '3qfwA01', NULL, NULL, 112, NULL, NULL, 232559),
(256559, '8rucA01', NULL, NULL, 127, NULL, NULL, 232559),
(256560, '4f0hA01', NULL, NULL, 127, NULL, NULL, 232559),
(256561, '2vf1A04', NULL, NULL, 157, NULL, NULL, 232560),
(256562, '3p3gA02', NULL, NULL, 172, NULL, NULL, 232561),
(256563, '4ozeB02', NULL, NULL, 160, NULL, NULL, 232561),
(256564, '3nzkA02', NULL, NULL, 178, NULL, NULL, 232561),
(256565, '3p3eA02', NULL, NULL, 172, NULL, NULL, 232561),
(256566, '3p3cA02', NULL, NULL, 153, NULL, NULL, 232561),
(256567, '1eg3A02', NULL, NULL, 49, NULL, NULL, 232562),
(256568, '4iefA00', NULL, NULL, 210, NULL, NULL, 232563),
(256569, '2yeqA02', NULL, NULL, 418, NULL, NULL, 232564),
(256570, '3nctB00', NULL, NULL, 144, NULL, NULL, 232565),
(256571, '3lnnB01', NULL, NULL, 95, NULL, NULL, 232566),
(256572, '3ne5C02', NULL, NULL, 102, NULL, NULL, 232566),
(256573, '4tkoB01', NULL, NULL, 124, NULL, NULL, 232566),
(256574, '1vf7F01', NULL, NULL, 102, NULL, NULL, 232566),
(256575, '3fppA01', NULL, NULL, 116, NULL, NULL, 232566),
(256576, '4kkuA02', NULL, NULL, 105, NULL, NULL, 232566),
(256577, '2f1mA01', NULL, NULL, 110, NULL, NULL, 232566),
(256578, '2f1mB01', NULL, NULL, 109, NULL, NULL, 232566),
(256579, '4l8jA02', NULL, NULL, 95, NULL, NULL, 232566),
(256580, '4dk0A02', NULL, NULL, 109, NULL, NULL, 232566),
(256581, '2f1mC01', NULL, NULL, 111, NULL, NULL, 232566),
(256582, '2f1mD01', NULL, NULL, 109, NULL, NULL, 232566),
(256583, '3eujB00', NULL, NULL, 90, NULL, NULL, 232567),
(256584, '1vwxV00', NULL, NULL, 140, NULL, NULL, 232568),
(256585, '4a17J00', NULL, NULL, 141, NULL, NULL, 232568),
(256586, '5mmiL00', NULL, NULL, 121, NULL, NULL, 232568),
(256587, '6c0fV00', NULL, NULL, 137, NULL, NULL, 232568),
(256588, '4v19O00', NULL, NULL, 115, NULL, NULL, 232568),
(256589, '1vx7M00', NULL, NULL, 139, NULL, NULL, 232568),
(256590, '6qklE00', NULL, NULL, 136, NULL, NULL, 232568),
(256591, '1vw4I00', NULL, NULL, 138, NULL, NULL, 232568),
(256592, '1whiA00', NULL, NULL, 122, NULL, NULL, 232568),
(256593, '6hmaI00', NULL, NULL, 122, NULL, NULL, 232568),
(256594, '5oomL00', NULL, NULL, 115, NULL, NULL, 232568),
(256595, '1vsaI00', NULL, NULL, 122, NULL, NULL, 232568);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(256596, '5dm6H00', NULL, NULL, 134, NULL, NULL, 232568),
(256597, '6qulL00', NULL, NULL, 123, NULL, NULL, 232568),
(256598, '1vq8K00', NULL, NULL, 132, NULL, NULL, 232568),
(256599, '5xymK00', NULL, NULL, 122, NULL, NULL, 232568),
(256600, '1a73A00', NULL, NULL, 163, NULL, NULL, 232569),
(256601, '2enxA02', NULL, NULL, 120, NULL, NULL, 232570),
(256602, '1i74A02', NULL, NULL, 119, NULL, NULL, 232570),
(256603, '1k20A02', NULL, NULL, 120, NULL, NULL, 232570),
(256604, '4rpaA02', NULL, NULL, 128, NULL, NULL, 232570),
(256605, '2qb7B02', NULL, NULL, 145, NULL, NULL, 232570),
(256606, '2hawA02', NULL, NULL, 120, NULL, NULL, 232570),
(256607, '2eb0B02', NULL, NULL, 119, NULL, NULL, 232570),
(256608, '4arcA04', NULL, NULL, 55, NULL, NULL, 232571),
(256609, '3zgzD04', NULL, NULL, 62, NULL, NULL, 232571),
(256610, '4hj1A01', NULL, NULL, 166, NULL, NULL, 232572),
(256611, '3ieeA01', NULL, NULL, 166, NULL, NULL, 232573),
(256612, '4yjwA00', NULL, NULL, 169, NULL, NULL, 232573),
(256613, '3rh3A01', NULL, NULL, 158, NULL, NULL, 232573),
(256614, '1jhfB00', NULL, NULL, 128, NULL, NULL, 232574),
(256615, '3iiqA01', NULL, NULL, 136, NULL, NULL, 232574),
(256616, '3bdnA02', NULL, NULL, 139, NULL, NULL, 232574),
(256617, '2fjrA02', NULL, NULL, 113, NULL, NULL, 232574),
(256618, '1umuB00', NULL, NULL, 116, NULL, NULL, 232574),
(256619, '4me8A00', NULL, NULL, 129, NULL, NULL, 232574),
(256620, '4nv4B00', NULL, NULL, 126, NULL, NULL, 232574),
(256621, '6a2qA00', NULL, NULL, 98, NULL, NULL, 232574),
(256622, '4k8wA00', NULL, NULL, 129, NULL, NULL, 232574),
(256623, '2hnfA00', NULL, NULL, 133, NULL, NULL, 232574),
(256624, '3k2zA02', NULL, NULL, 119, NULL, NULL, 232574),
(256625, '1f39A00', NULL, NULL, 101, NULL, NULL, 232574),
(256626, '2vh2A02', NULL, NULL, 133, NULL, NULL, 232575),
(256627, '6h9nA02', NULL, NULL, 134, NULL, NULL, 232575),
(256628, '4jrfA03', NULL, NULL, 106, NULL, NULL, 232576),
(256629, '2jooA00', NULL, NULL, 66, NULL, NULL, 232577),
(256630, '2pw8I00', NULL, NULL, 65, NULL, NULL, 232577),
(256631, '4htcI00', NULL, NULL, 65, NULL, NULL, 232577),
(256632, '2hirA00', NULL, NULL, 49, NULL, NULL, 232577),
(256633, '1e0fI01', NULL, NULL, 33, NULL, NULL, 232577),
(256634, '2dcfA01', NULL, NULL, 24, NULL, NULL, 232578),
(256635, '2xzn800', NULL, NULL, 93, NULL, NULL, 232579),
(256636, '4z8lB00', NULL, NULL, 100, NULL, NULL, 232580),
(256637, '1m8lA01', NULL, NULL, 64, NULL, NULL, 232580),
(256638, '5jk7F00', NULL, NULL, 74, NULL, NULL, 232580),
(256639, '4cc9B00', NULL, NULL, 119, NULL, NULL, 232580),
(256640, '5ajaB00', NULL, NULL, 102, NULL, NULL, 232580),
(256641, '1esxA01', NULL, NULL, 86, NULL, NULL, 232580),
(256642, '2l5yA02', NULL, NULL, 68, NULL, NULL, 232581),
(256643, '2qarD00', NULL, NULL, 86, NULL, NULL, 232581),
(256644, '2e8mA01', NULL, NULL, 84, NULL, NULL, 232581),
(256645, '1v85A00', NULL, NULL, 91, NULL, NULL, 232581),
(256646, '3senB02', NULL, NULL, 76, NULL, NULL, 232581),
(256647, '2d3dA00', NULL, NULL, 88, NULL, NULL, 232581),
(256648, '6fxfA00', NULL, NULL, 65, NULL, NULL, 232581),
(256649, '1x9xA00', NULL, NULL, 68, NULL, NULL, 232581),
(256650, '1sv0D00', NULL, NULL, 82, NULL, NULL, 232581),
(256651, '2kmdA01', NULL, NULL, 97, NULL, NULL, 232581),
(256652, '3kkaD00', NULL, NULL, 69, NULL, NULL, 232581),
(256653, '3tadD01', NULL, NULL, 62, NULL, NULL, 232581),
(256654, '2f3nA00', NULL, NULL, 76, NULL, NULL, 232581),
(256655, '4is7A02', NULL, NULL, 78, NULL, NULL, 232581),
(256656, '4is7A01', NULL, NULL, 68, NULL, NULL, 232581),
(256657, '1z1vA00', NULL, NULL, 80, NULL, NULL, 232581),
(256658, '2d8cA01', NULL, NULL, 76, NULL, NULL, 232581),
(256659, '1b0xA00', NULL, NULL, 72, NULL, NULL, 232581),
(256660, '1lkyA00', NULL, NULL, 77, NULL, NULL, 232581),
(256661, '1ucvA00', NULL, NULL, 81, NULL, NULL, 232581),
(256662, '2lpeA02', NULL, NULL, 71, NULL, NULL, 232581),
(256663, '2dl0A01', NULL, NULL, 59, NULL, NULL, 232581),
(256664, '3bs7A00', NULL, NULL, 78, NULL, NULL, 232581),
(256665, '3h8mA00', NULL, NULL, 72, NULL, NULL, 232581),
(256666, '5zrzA00', NULL, NULL, 80, NULL, NULL, 232581);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(256667, '2k60A02', NULL, NULL, 68, NULL, NULL, 232581),
(256668, '2e8pA01', NULL, NULL, 71, NULL, NULL, 232581),
(256669, '4mhvA00', NULL, NULL, 97, NULL, NULL, 232581),
(256670, '5j8yA00', NULL, NULL, 80, NULL, NULL, 232581),
(256671, '1x40A00', NULL, NULL, 91, NULL, NULL, 232581),
(256672, '3tacB01', NULL, NULL, 138, NULL, NULL, 232581),
(256673, '2qb1A00', NULL, NULL, 78, NULL, NULL, 232581),
(256674, '3tacB02', NULL, NULL, 80, NULL, NULL, 232581),
(256675, '2y9uA00', NULL, NULL, 69, NULL, NULL, 232581),
(256676, '1dxsA00', NULL, NULL, 64, NULL, NULL, 232581),
(256677, '3tacB03', NULL, NULL, 96, NULL, NULL, 232581),
(256678, '3bs5B00', NULL, NULL, 80, NULL, NULL, 232581),
(256679, '1pk1A00', NULL, NULL, 89, NULL, NULL, 232581),
(256680, '2dkzA01', NULL, NULL, 61, NULL, NULL, 232581),
(256681, '4pzoE00', NULL, NULL, 82, NULL, NULL, 232581),
(256682, '2eapA01', NULL, NULL, 77, NULL, NULL, 232581),
(256683, '1b4fG00', NULL, NULL, 82, NULL, NULL, 232581),
(256684, '1sv0A00', NULL, NULL, 85, NULL, NULL, 232581),
(256685, '2ke7A00', NULL, NULL, 63, NULL, NULL, 232581),
(256686, '2e8oA01', NULL, NULL, 62, NULL, NULL, 232581),
(256687, '5jrtA00', NULL, NULL, 77, NULL, NULL, 232581),
(256688, '3senA01', NULL, NULL, 81, NULL, NULL, 232581),
(256689, '3bq7C00', NULL, NULL, 81, NULL, NULL, 232581),
(256690, '3hilA00', NULL, NULL, 63, NULL, NULL, 232581),
(256691, '2gleA00', NULL, NULL, 74, NULL, NULL, 232581),
(256692, '1sxeA00', NULL, NULL, 97, NULL, NULL, 232581),
(256693, '1ji7A00', NULL, NULL, 89, NULL, NULL, 232581),
(256694, '2kivA01', NULL, NULL, 76, NULL, NULL, 232581),
(256695, '2kivA02', NULL, NULL, 60, NULL, NULL, 232581),
(256696, '1x66A01', NULL, NULL, 70, NULL, NULL, 232581),
(256697, '3tadC02', NULL, NULL, 102, NULL, NULL, 232581),
(256698, '1sggA00', NULL, NULL, 75, NULL, NULL, 232581),
(256699, '3tadC03', NULL, NULL, 101, NULL, NULL, 232581),
(256700, '4nl9B01', NULL, NULL, 62, NULL, NULL, 232581),
(256701, '2eaoA01', NULL, NULL, 60, NULL, NULL, 232581),
(256702, '3seiB02', NULL, NULL, 76, NULL, NULL, 232581),
(256703, '4nl9D01', NULL, NULL, 64, NULL, NULL, 232581),
(256704, '1wwuA01', NULL, NULL, 64, NULL, NULL, 232581),
(256705, '2qkqA00', NULL, NULL, 83, NULL, NULL, 232581),
(256706, '4rqmA01', NULL, NULL, 65, NULL, NULL, 232581),
(256707, '1v38A00', NULL, NULL, 78, NULL, NULL, 232581),
(256708, '2e8nA00', NULL, NULL, 88, NULL, NULL, 232581),
(256709, '3seiA01', NULL, NULL, 73, NULL, NULL, 232581),
(256710, '1kw4A00', NULL, NULL, 89, NULL, NULL, 232581),
(256711, '2kg5A01', NULL, NULL, 64, NULL, NULL, 232581),
(256712, '3tadB01', NULL, NULL, 110, NULL, NULL, 232581),
(256713, '1sxdA00', NULL, NULL, 91, NULL, NULL, 232581),
(256714, '5zrzB00', NULL, NULL, 70, NULL, NULL, 232581),
(256715, '1rg6A00', NULL, NULL, 75, NULL, NULL, 232581),
(256716, '3k1rB00', NULL, NULL, 74, NULL, NULL, 232581),
(256717, '5f3xB00', NULL, NULL, 81, NULL, NULL, 232581),
(256718, '2k4pA00', NULL, NULL, 65, NULL, NULL, 232581),
(256719, '2lmrA01', NULL, NULL, 60, NULL, NULL, 232581),
(256720, '1oxjA01', NULL, NULL, 63, NULL, NULL, 232581),
(256721, '2dkxA00', NULL, NULL, 96, NULL, NULL, 232581),
(256722, '1pk1B00', NULL, NULL, 89, NULL, NULL, 232581),
(256723, '5j8yD00', NULL, NULL, 89, NULL, NULL, 232581),
(256724, '5n2oA00', NULL, NULL, 70, NULL, NULL, 232581),
(256725, '1wwvA00', NULL, NULL, 91, NULL, NULL, 232581),
(256726, '3idwA00', NULL, NULL, 72, NULL, NULL, 232581),
(256727, '5ju5C00', NULL, NULL, 79, NULL, NULL, 232581),
(256728, '2eanA00', NULL, NULL, 83, NULL, NULL, 232581),
(256729, '3hl6A01', NULL, NULL, 75, NULL, NULL, 232582),
(256730, '5lktA02', NULL, NULL, 67, NULL, NULL, 232583),
(256731, '5i8gA03', NULL, NULL, 69, NULL, NULL, 232583),
(256732, '4pw8F02', NULL, NULL, 51, NULL, NULL, 232584),
(256733, '4hkaA02', NULL, NULL, 51, NULL, NULL, 232584),
(256734, '2x6uA00', NULL, NULL, 182, NULL, NULL, 232585),
(256735, '4a04A00', NULL, NULL, 203, NULL, NULL, 232585),
(256736, '5t1jA00', NULL, NULL, 204, NULL, NULL, 232585),
(256737, '6f59A00', NULL, NULL, 192, NULL, NULL, 232585),
(256738, '1h6fA00', NULL, NULL, 193, NULL, NULL, 232585);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(256739, '1xbrB00', NULL, NULL, 184, NULL, NULL, 232585),
(256740, '5bqdB00', NULL, NULL, 194, NULL, NULL, 232585),
(256741, '3dcxE00', NULL, NULL, 117, NULL, NULL, 232586),
(256742, '3hsaE00', NULL, NULL, 126, NULL, NULL, 232586),
(256743, '3hsaD00', NULL, NULL, 126, NULL, NULL, 232586),
(256744, '3hsaC00', NULL, NULL, 126, NULL, NULL, 232586),
(256745, '3hsaB00', NULL, NULL, 126, NULL, NULL, 232586),
(256746, '3hsaA00', NULL, NULL, 126, NULL, NULL, 232586),
(256747, '3b77A01', NULL, NULL, 104, NULL, NULL, 232586),
(256748, '3dpuA03', NULL, NULL, 88, NULL, NULL, 232587),
(256749, '2rjbC00', NULL, NULL, 420, NULL, NULL, 232588),
(256750, '2rjbD00', NULL, NULL, 438, NULL, NULL, 232588),
(256751, '1mqvA00', NULL, NULL, 125, NULL, NULL, 232589),
(256752, '1gqaA00', NULL, NULL, 130, NULL, NULL, 232589),
(256753, '4jkvB01', NULL, NULL, 109, NULL, NULL, 232589),
(256754, '3vrcA00', NULL, NULL, 131, NULL, NULL, 232589),
(256755, '3hnjA00', NULL, NULL, 106, NULL, NULL, 232589),
(256756, '2ykzA00', NULL, NULL, 127, NULL, NULL, 232589),
(256757, '4ulvA00', NULL, NULL, 128, NULL, NULL, 232589),
(256758, '2ccyA00', NULL, NULL, 128, NULL, NULL, 232589),
(256759, '3nmiA00', NULL, NULL, 106, NULL, NULL, 232589),
(256760, '4u9dA00', NULL, NULL, 106, NULL, NULL, 232589),
(256761, '1bbhA00', NULL, NULL, 131, NULL, NULL, 232589),
(256762, '1yyjA00', NULL, NULL, 106, NULL, NULL, 232589),
(256763, '4jeaA00', NULL, NULL, 106, NULL, NULL, 232589),
(256764, '2j8wA00', NULL, NULL, 129, NULL, NULL, 232589),
(256765, '3de8A00', NULL, NULL, 106, NULL, NULL, 232589),
(256766, '1cpqA00', NULL, NULL, 129, NULL, NULL, 232589),
(256767, '4n6hA01', NULL, NULL, 120, NULL, NULL, 232589),
(256768, '1s05A00', NULL, NULL, 129, NULL, NULL, 232589),
(256769, '1cgnA00', NULL, NULL, 127, NULL, NULL, 232589),
(256770, '4er9A00', NULL, NULL, 106, NULL, NULL, 232589),
(256771, '5b3iA00', NULL, NULL, 135, NULL, NULL, 232589),
(256772, '256bA00', NULL, NULL, 106, NULL, NULL, 232589),
(256773, '3tolA00', NULL, NULL, 106, NULL, NULL, 232589),
(256774, '3qxyA02', NULL, NULL, 173, NULL, NULL, 232590),
(256775, '2h21A02', NULL, NULL, 165, NULL, NULL, 232590),
(256776, '3smtA02', NULL, NULL, 170, NULL, NULL, 232590),
(256777, '3w0oA01', NULL, NULL, 78, NULL, NULL, 232591),
(256778, '6neqN01', NULL, NULL, 91, NULL, NULL, 232592),
(256779, '1vs5N01', NULL, NULL, 91, NULL, NULL, 232592),
(256780, '5mmjn01', NULL, NULL, 90, NULL, NULL, 232592),
(256781, '6dzkN01', NULL, NULL, 90, NULL, NULL, 232592),
(256782, '4fxeC00', NULL, NULL, 47, NULL, NULL, 232593),
(256783, '3tw6D02', NULL, NULL, 76, NULL, NULL, 232594),
(256784, '4qslC02', NULL, NULL, 72, NULL, NULL, 232594),
(256785, '4qslA04', NULL, NULL, 102, NULL, NULL, 232594),
(256786, '3tw6A03', NULL, NULL, 103, NULL, NULL, 232594),
(256787, '3bg3B01', NULL, NULL, 100, NULL, NULL, 232594),
(256788, '4hntA04', NULL, NULL, 101, NULL, NULL, 232594),
(256789, '2qf7A03', NULL, NULL, 90, NULL, NULL, 232594),
(256790, '4hnvB02', NULL, NULL, 90, NULL, NULL, 232594),
(256791, '3hb9D03', NULL, NULL, 78, NULL, NULL, 232594),
(256792, '4locA01', NULL, NULL, 95, NULL, NULL, 232594),
(256793, '4cgkA01', NULL, NULL, 214, NULL, NULL, 232595),
(256794, '4hpmA00', NULL, NULL, 122, NULL, NULL, 232596),
(256795, '4hplA00', NULL, NULL, 119, NULL, NULL, 232596),
(256796, '3i9wA00', NULL, NULL, 274, NULL, NULL, 232597),
(256797, '3i9yA00', NULL, NULL, 237, NULL, NULL, 232597),
(256798, '2jpnA00', NULL, NULL, 79, NULL, NULL, 232598),
(256799, '2vugA04', NULL, NULL, 90, NULL, NULL, 232599),
(256800, '1kblA02', NULL, NULL, 63, NULL, NULL, 232600),
(256801, '5jvjA04', NULL, NULL, 63, NULL, NULL, 232600),
(256802, '2x0sA04', NULL, NULL, 65, NULL, NULL, 232600),
(256803, '1vbgA04', NULL, NULL, 63, NULL, NULL, 232600),
(256804, '3f2bA08', NULL, NULL, 137, NULL, NULL, 232601),
(256805, '2x98A02', NULL, NULL, 73, NULL, NULL, 232602),
(256806, '3a52A02', NULL, NULL, 85, NULL, NULL, 232602),
(256807, '4jkjA00', NULL, NULL, 228, NULL, NULL, 232603),
(256808, '4i6nA00', NULL, NULL, 231, NULL, NULL, 232603),
(256809, '1cmxA00', NULL, NULL, 235, NULL, NULL, 232603);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(256810, '3riiB00', NULL, NULL, 233, NULL, NULL, 232603),
(256811, '1xd3C00', NULL, NULL, 230, NULL, NULL, 232603),
(256812, '2kluA00', NULL, NULL, 70, NULL, NULL, 232604),
(256813, '4lr3A01', NULL, NULL, 54, NULL, NULL, 232605),
(256814, '1wpbG01', NULL, NULL, 58, NULL, NULL, 232605),
(256815, '3vtiA06', NULL, NULL, 105, NULL, NULL, 232606),
(256816, '3t5qG03', NULL, NULL, 18, NULL, NULL, 232607),
(256817, '3behA01', NULL, NULL, 125, NULL, NULL, 232608),
(256818, '4m70B00', NULL, NULL, 99, NULL, NULL, 232609),
(256819, '2qtpA00', NULL, NULL, 172, NULL, NULL, 232610),
(256820, '3byqA00', NULL, NULL, 193, NULL, NULL, 232610),
(256821, '5tkwA01', NULL, NULL, 171, NULL, NULL, 232611),
(256822, '4phtX01', NULL, NULL, 176, NULL, NULL, 232611),
(256823, '2bh1A01', NULL, NULL, 175, NULL, NULL, 232611),
(256824, '2p14A00', NULL, NULL, 192, NULL, NULL, 232612),
(256825, '2ewfA03', NULL, NULL, 225, NULL, NULL, 232612),
(256826, '3mkqA03', NULL, NULL, 214, NULL, NULL, 232613),
(256827, '3mkqB00', NULL, NULL, 177, NULL, NULL, 232613),
(256828, '3c24B02', NULL, NULL, 104, NULL, NULL, 232614),
(256829, '3c24A02', NULL, NULL, 104, NULL, NULL, 232614),
(256830, '2xnxM00', NULL, NULL, 114, NULL, NULL, 232615),
(256831, '4driB00', NULL, NULL, 98, NULL, NULL, 232616),
(256832, '5gpgB00', NULL, NULL, 93, NULL, NULL, 232616),
(256833, '1go4H00', NULL, NULL, 100, NULL, NULL, 232617),
(256834, '1a6sA00', NULL, NULL, 87, NULL, NULL, 232618),
(256835, '1ed1A00', NULL, NULL, 119, NULL, NULL, 232618),
(256836, '4jmuA00', NULL, NULL, 112, NULL, NULL, 232618),
(256837, '4ic9A00', NULL, NULL, 133, NULL, NULL, 232618),
(256838, '2nv3A01', NULL, NULL, 113, NULL, NULL, 232618),
(256839, '2h3qA01', NULL, NULL, 116, NULL, NULL, 232618),
(256840, '1tamA00', NULL, NULL, 132, NULL, NULL, 232618),
(256841, '1hekA00', NULL, NULL, 131, NULL, NULL, 232618),
(256842, '2k4hA01', NULL, NULL, 109, NULL, NULL, 232618),
(256843, '4icaA00', NULL, NULL, 134, NULL, NULL, 232618),
(256844, '5ez3A02', NULL, NULL, 54, NULL, NULL, 232619),
(256845, '3djlA02', NULL, NULL, 54, NULL, NULL, 232619),
(256846, '1hhnA00', NULL, NULL, 101, NULL, NULL, 232620),
(256847, '1k9cA00', NULL, NULL, 74, NULL, NULL, 232620),
(256848, '1jhnA02', NULL, NULL, 146, NULL, NULL, 232620),
(256849, '2f5tX02', NULL, NULL, 90, NULL, NULL, 232621),
(256850, '6dc6A01', NULL, NULL, 120, NULL, NULL, 232622),
(256851, '4ii2A01', NULL, NULL, 116, NULL, NULL, 232622),
(256852, '5tr4A01', NULL, NULL, 120, NULL, NULL, 232622),
(256853, '1fsuA01', NULL, NULL, 371, NULL, NULL, 232623),
(256854, '3lxqA02', NULL, NULL, 287, NULL, NULL, 232623),
(256855, '4upiA01', NULL, NULL, 499, NULL, NULL, 232623),
(256856, '3a52A01', NULL, NULL, 315, NULL, NULL, 232623),
(256857, '3nvlA01', NULL, NULL, 305, NULL, NULL, 232623),
(256858, '2gsoA01', NULL, NULL, 290, NULL, NULL, 232623),
(256859, '4b56B01', NULL, NULL, 323, NULL, NULL, 232623),
(256860, '3mk1A00', NULL, NULL, 484, NULL, NULL, 232623),
(256861, '3kd8A01', NULL, NULL, 243, NULL, NULL, 232623),
(256862, '5veoA01', NULL, NULL, 288, NULL, NULL, 232623),
(256863, '4uplC01', NULL, NULL, 502, NULL, NULL, 232623),
(256864, '4uorA02', NULL, NULL, 309, NULL, NULL, 232623),
(256865, '4tn0A00', NULL, NULL, 325, NULL, NULL, 232623),
(256866, '3tg0A00', NULL, NULL, 449, NULL, NULL, 232623),
(256867, '4lr2A01', NULL, NULL, 305, NULL, NULL, 232623),
(256868, '4fdiB01', NULL, NULL, 402, NULL, NULL, 232623),
(256869, '5mx9A00', NULL, NULL, 324, NULL, NULL, 232623),
(256870, '4my4A01', NULL, NULL, 283, NULL, NULL, 232623),
(256871, '4uphA00', NULL, NULL, 504, NULL, NULL, 232623),
(256872, '5eghB01', NULL, NULL, 296, NULL, NULL, 232623),
(256873, '4gtwB01', NULL, NULL, 413, NULL, NULL, 232623),
(256874, '4kjdB00', NULL, NULL, 427, NULL, NULL, 232623),
(256875, '3m7vA01', NULL, NULL, 292, NULL, NULL, 232623),
(256876, '2w5vA00', NULL, NULL, 346, NULL, NULL, 232623),
(256877, '3ed4C01', NULL, NULL, 393, NULL, NULL, 232623),
(256878, '2w8dA02', NULL, NULL, 310, NULL, NULL, 232623),
(256879, '1hdhA01', NULL, NULL, 450, NULL, NULL, 232623),
(256880, '4kavA00', NULL, NULL, 335, NULL, NULL, 232623);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(256881, '5tcdA01', NULL, NULL, 284, NULL, NULL, 232623),
(256882, '4upkA01', NULL, NULL, 460, NULL, NULL, 232623),
(256883, '5xwiA01', NULL, NULL, 400, NULL, NULL, 232623),
(256884, '2ifyA01', NULL, NULL, 272, NULL, NULL, 232623),
(256885, '3ot9A01', NULL, NULL, 280, NULL, NULL, 232623),
(256886, '2d1gA02', NULL, NULL, 308, NULL, NULL, 232623),
(256887, '2x98A01', NULL, NULL, 358, NULL, NULL, 232623),
(256888, '6bncA00', NULL, NULL, 344, NULL, NULL, 232623),
(256889, '3szyA01', NULL, NULL, 316, NULL, NULL, 232623),
(256890, '2w8sA01', NULL, NULL, 468, NULL, NULL, 232623),
(256891, '5tj3A01', NULL, NULL, 432, NULL, NULL, 232623),
(256892, '3e2dA01', NULL, NULL, 381, NULL, NULL, 232623),
(256893, '4uopA02', NULL, NULL, 312, NULL, NULL, 232623),
(256894, '3wbhA01', NULL, NULL, 376, NULL, NULL, 232623),
(256895, '1o98A02', NULL, NULL, 273, NULL, NULL, 232623),
(256896, '1aukA01', NULL, NULL, 388, NULL, NULL, 232623),
(256897, '2w5qA02', NULL, NULL, 311, NULL, NULL, 232623),
(256898, '5g2uA00', NULL, NULL, 468, NULL, NULL, 232623),
(256899, '1k7hA00', NULL, NULL, 476, NULL, NULL, 232623),
(256900, '1ei6A01', NULL, NULL, 295, NULL, NULL, 232623),
(256901, '4mhxA01', NULL, NULL, 459, NULL, NULL, 232623),
(256902, '2qzuA01', NULL, NULL, 365, NULL, NULL, 232623),
(256903, '2zktB01', NULL, NULL, 262, NULL, NULL, 232623),
(256904, '3igzB01', NULL, NULL, 317, NULL, NULL, 232623),
(256905, '4zg7A03', NULL, NULL, 399, NULL, NULL, 232623),
(256906, '1p49A01', NULL, NULL, 391, NULL, NULL, 232623),
(256907, '5kgnB01', NULL, NULL, 299, NULL, NULL, 232623),
(256908, '5dltA03', NULL, NULL, 399, NULL, NULL, 232623),
(256909, '2vqrA01', NULL, NULL, 469, NULL, NULL, 232623),
(256910, '5k4pA00', NULL, NULL, 324, NULL, NULL, 232623),
(256911, '1pl4A01', NULL, NULL, 64, NULL, NULL, 232624),
(256912, '1b06A01', NULL, NULL, 67, NULL, NULL, 232624),
(256913, '1mngA01', NULL, NULL, 71, NULL, NULL, 232624),
(256914, '3ceiA01', NULL, NULL, 63, NULL, NULL, 232624),
(256915, '1wb7A01', NULL, NULL, 67, NULL, NULL, 232624),
(256916, '6ex3C01', NULL, NULL, 70, NULL, NULL, 232624),
(256917, '4e4eB01', NULL, NULL, 71, NULL, NULL, 232624),
(256918, '6ex5A01', NULL, NULL, 70, NULL, NULL, 232624),
(256919, '1ma1A01', NULL, NULL, 64, NULL, NULL, 232624),
(256920, '4e4eA01', NULL, NULL, 71, NULL, NULL, 232624),
(256921, '4e4eD01', NULL, NULL, 71, NULL, NULL, 232624),
(256922, '4ffkA01', NULL, NULL, 65, NULL, NULL, 232624),
(256923, '4e4eC01', NULL, NULL, 71, NULL, NULL, 232624),
(256924, '4br6A01', NULL, NULL, 64, NULL, NULL, 232624),
(256925, '4yioA01', NULL, NULL, 70, NULL, NULL, 232624),
(256926, '1idsA01', NULL, NULL, 64, NULL, NULL, 232624),
(256927, '3lsuA01', NULL, NULL, 71, NULL, NULL, 232624),
(256928, '2rcvB01', NULL, NULL, 71, NULL, NULL, 232624),
(256929, '3lsuD01', NULL, NULL, 71, NULL, NULL, 232624),
(256930, '6elkA01', NULL, NULL, 64, NULL, NULL, 232624),
(256931, '3lsuC01', NULL, NULL, 71, NULL, NULL, 232624),
(256932, '6bejA01', NULL, NULL, 70, NULL, NULL, 232624),
(256933, '3lsuB01', NULL, NULL, 71, NULL, NULL, 232624),
(256934, '4gunA01', NULL, NULL, 64, NULL, NULL, 232624),
(256935, '5tirA01', NULL, NULL, 64, NULL, NULL, 232624),
(256936, '1xuqA01', NULL, NULL, 71, NULL, NULL, 232624),
(256937, '1xreA01', NULL, NULL, 71, NULL, NULL, 232624),
(256938, '4c7uA01', NULL, NULL, 64, NULL, NULL, 232624),
(256939, '1bsmA01', NULL, NULL, 64, NULL, NULL, 232624),
(256940, '5x2jA01', NULL, NULL, 70, NULL, NULL, 232624),
(256941, '1kkcA01', NULL, NULL, 64, NULL, NULL, 232624),
(256942, '3tjtA01', NULL, NULL, 71, NULL, NULL, 232624),
(256943, '3kkyA01', NULL, NULL, 70, NULL, NULL, 232624),
(256944, '4yipA01', NULL, NULL, 70, NULL, NULL, 232624),
(256945, '3ic9A02', NULL, NULL, 70, NULL, NULL, 232624),
(256946, '3rn4A01', NULL, NULL, 71, NULL, NULL, 232624),
(256947, '3ak2A01', NULL, NULL, 64, NULL, NULL, 232624),
(256948, '1jr9A01', NULL, NULL, 71, NULL, NULL, 232624),
(256949, '6gscA01', NULL, NULL, 66, NULL, NULL, 232624),
(256950, '4f6eB01', NULL, NULL, 71, NULL, NULL, 232624),
(256951, '4f6eC01', NULL, NULL, 71, NULL, NULL, 232624);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(256952, '4f6eA01', NULL, NULL, 71, NULL, NULL, 232624),
(256953, '3evkA01', NULL, NULL, 64, NULL, NULL, 232624),
(256954, '1ix9A01', NULL, NULL, 71, NULL, NULL, 232624),
(256955, '4f6eD01', NULL, NULL, 71, NULL, NULL, 232624),
(256956, '3gw6A03', NULL, NULL, 59, NULL, NULL, 232625),
(256957, '3ua0A00', NULL, NULL, 83, NULL, NULL, 232626),
(256958, '3ecqA01', NULL, NULL, 183, NULL, NULL, 232627),
(256959, '3qp1A00', NULL, NULL, 182, NULL, NULL, 232628),
(256960, '4y13A01', NULL, NULL, 176, NULL, NULL, 232628),
(256961, '6cc0A01', NULL, NULL, 167, NULL, NULL, 232628),
(256962, '5l10B00', NULL, NULL, 173, NULL, NULL, 232628),
(256963, '1l3lA01', NULL, NULL, 171, NULL, NULL, 232628),
(256964, '5l09B00', NULL, NULL, 179, NULL, NULL, 232628),
(256965, '2q0oA01', NULL, NULL, 169, NULL, NULL, 232628),
(256966, '4lfuA01', NULL, NULL, 176, NULL, NULL, 232628),
(256967, '3ix3A00', NULL, NULL, 173, NULL, NULL, 232628),
(256968, '3qp8A00', NULL, NULL, 184, NULL, NULL, 232628),
(256969, '2uv0H00', NULL, NULL, 175, NULL, NULL, 232628),
(256970, '2b3wA00', NULL, NULL, 168, NULL, NULL, 232629),
(256971, '2o3bB00', NULL, NULL, 136, NULL, NULL, 232630),
(256972, '1ucuA01', NULL, NULL, 68, NULL, NULL, 232631),
(256973, '4i1sB00', NULL, NULL, 52, NULL, NULL, 232632),
(256974, '5bv3D02', NULL, NULL, 220, NULL, NULL, 232633),
(256975, '2fitA00', NULL, NULL, 147, NULL, NULL, 232633),
(256976, '5waaA00', NULL, NULL, 129, NULL, NULL, 232633),
(256977, '6iq1A00', NULL, NULL, 160, NULL, NULL, 232633),
(256978, '3bl9A02', NULL, NULL, 191, NULL, NULL, 232633),
(256979, '4xbaB00', NULL, NULL, 200, NULL, NULL, 232633),
(256980, '6gqdA01', NULL, NULL, 141, NULL, NULL, 232633),
(256981, '6gqdA02', NULL, NULL, 184, NULL, NULL, 232633),
(256982, '5uvmA00', NULL, NULL, 115, NULL, NULL, 232633),
(256983, '3i24B00', NULL, NULL, 149, NULL, NULL, 232633),
(256984, '1gupB01', NULL, NULL, 173, NULL, NULL, 232633),
(256985, '1gupA02', NULL, NULL, 132, NULL, NULL, 232633),
(256986, '3bl9B03', NULL, NULL, 119, NULL, NULL, 232633),
(256987, '3oj7A00', NULL, NULL, 117, NULL, NULL, 232633),
(256988, '1z84A02', NULL, NULL, 133, NULL, NULL, 232633),
(256989, '1z84B01', NULL, NULL, 198, NULL, NULL, 232633),
(256990, '3i4sA00', NULL, NULL, 149, NULL, NULL, 232633),
(256991, '3nrdA00', NULL, NULL, 135, NULL, NULL, 232633),
(256992, '3p0tA00', NULL, NULL, 138, NULL, NULL, 232633),
(256993, '3o0mB00', NULL, NULL, 149, NULL, NULL, 232633),
(256994, '3n1sJ00', NULL, NULL, 119, NULL, NULL, 232633),
(256995, '2oikA00', NULL, NULL, 154, NULL, NULL, 232633),
(256996, '3ksvA01', NULL, NULL, 122, NULL, NULL, 232633),
(256997, '2oikB00', NULL, NULL, 154, NULL, NULL, 232633),
(256998, '3r6fA00', NULL, NULL, 135, NULL, NULL, 232633),
(256999, '1y23A00', NULL, NULL, 145, NULL, NULL, 232633),
(257000, '2oikC00', NULL, NULL, 154, NULL, NULL, 232633),
(257001, '2oikD00', NULL, NULL, 154, NULL, NULL, 232633),
(257002, '3l7xA00', NULL, NULL, 173, NULL, NULL, 232633),
(257003, '1vlrB03', NULL, NULL, 119, NULL, NULL, 232633),
(257004, '1emsA02', NULL, NULL, 149, NULL, NULL, 232633),
(257005, '4zglD00', NULL, NULL, 112, NULL, NULL, 232633),
(257006, '3imiC00', NULL, NULL, 147, NULL, NULL, 232633),
(257007, '6cvqA00', NULL, NULL, 180, NULL, NULL, 232633),
(257008, '2eo4A00', NULL, NULL, 149, NULL, NULL, 232633),
(257009, '3lb5B00', NULL, NULL, 138, NULL, NULL, 232633),
(257010, '5cs2A00', NULL, NULL, 150, NULL, NULL, 232633),
(257011, '1vkvB01', NULL, NULL, 197, NULL, NULL, 232633),
(257012, '4incB00', NULL, NULL, 112, NULL, NULL, 232633),
(257013, '1vkvA01', NULL, NULL, 196, NULL, NULL, 232633),
(257014, '3anoA00', NULL, NULL, 190, NULL, NULL, 232633),
(257015, '3oheA00', NULL, NULL, 137, NULL, NULL, 232633),
(257016, '3o1cA00', NULL, NULL, 126, NULL, NULL, 232633),
(257017, '4eguA00', NULL, NULL, 119, NULL, NULL, 232633),
(257018, '6d6jB00', NULL, NULL, 121, NULL, NULL, 232633),
(257019, '1r89A04', NULL, NULL, 44, NULL, NULL, 232634),
(257020, '2wwxB00', NULL, NULL, 200, NULL, NULL, 232635),
(257021, '3jz9A00', NULL, NULL, 197, NULL, NULL, 232635),
(257022, '3l0mA01', NULL, NULL, 213, NULL, NULL, 232635);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(257023, '4az6A02', NULL, NULL, 68, NULL, NULL, 232636),
(257024, '4azcB02', NULL, NULL, 64, NULL, NULL, 232636),
(257025, '3rpmA02', NULL, NULL, 97, NULL, NULL, 232636),
(257026, '2oo2A00', NULL, NULL, 86, NULL, NULL, 232636),
(257027, '2pmrA00', NULL, NULL, 87, NULL, NULL, 232636),
(257028, '4fzpB00', NULL, NULL, 82, NULL, NULL, 232636),
(257029, '2oznB01', NULL, NULL, 81, NULL, NULL, 232636),
(257030, '1m1fB00', NULL, NULL, 110, NULL, NULL, 232637),
(257031, '5cqxA00', NULL, NULL, 119, NULL, NULL, 232637),
(257032, '3vubA00', NULL, NULL, 101, NULL, NULL, 232637),
(257033, '4mdxA00', NULL, NULL, 117, NULL, NULL, 232637),
(257034, '3jscA00', NULL, NULL, 105, NULL, NULL, 232637),
(257035, '4of1A00', NULL, NULL, 128, NULL, NULL, 232637),
(257036, '5hk3B00', NULL, NULL, 114, NULL, NULL, 232637),
(257037, '5uctB00', NULL, NULL, 103, NULL, NULL, 232637),
(257038, '5dloA00', NULL, NULL, 133, NULL, NULL, 232637),
(257039, '4hkeA00', NULL, NULL, 120, NULL, NULL, 232637),
(257040, '2jjqA01', NULL, NULL, 57, NULL, NULL, 232638),
(257041, '4ex5B01', NULL, NULL, 139, NULL, NULL, 232638),
(257042, '3f2bA01', NULL, NULL, 102, NULL, NULL, 232638),
(257043, '2mfiA00', NULL, NULL, 96, NULL, NULL, 232638),
(257044, '6nrzA01', NULL, NULL, 155, NULL, NULL, 232638),
(257045, '1v1qA00', NULL, NULL, 134, NULL, NULL, 232638),
(257046, '1vwxA01', NULL, NULL, 86, NULL, NULL, 232638),
(257047, '2vqeL00', NULL, NULL, 135, NULL, NULL, 232638),
(257048, '2it1A03', NULL, NULL, 61, NULL, NULL, 232638),
(257049, '3jami00', NULL, NULL, 96, NULL, NULL, 232638),
(257050, '5yzwB01', NULL, NULL, 104, NULL, NULL, 232638),
(257051, '2ytvA01', NULL, NULL, 73, NULL, NULL, 232638),
(257052, '5xogG02', NULL, NULL, 89, NULL, NULL, 232638),
(257053, '4up7A01', NULL, NULL, 153, NULL, NULL, 232638),
(257054, '4wj4A01', NULL, NULL, 115, NULL, NULL, 232638),
(257055, '3w1gA03', NULL, NULL, 156, NULL, NULL, 232638),
(257056, '4pz7A01', NULL, NULL, 137, NULL, NULL, 232638),
(257057, '4mz9A00', NULL, NULL, 115, NULL, NULL, 232638),
(257058, '2cwpA00', NULL, NULL, 112, NULL, NULL, 232638),
(257059, '1iz6A02', NULL, NULL, 64, NULL, NULL, 232638),
(257060, '2k50A01', NULL, NULL, 109, NULL, NULL, 232638),
(257061, '5ytxA00', NULL, NULL, 83, NULL, NULL, 232638),
(257062, '4gnxB00', NULL, NULL, 136, NULL, NULL, 232638),
(257063, '1ntgA00', NULL, NULL, 172, NULL, NULL, 232638),
(257064, '2vl6A02', NULL, NULL, 115, NULL, NULL, 232638),
(257065, '1ah9A00', NULL, NULL, 71, NULL, NULL, 232638),
(257066, '2kctA01', NULL, NULL, 93, NULL, NULL, 232638),
(257067, '1nbwA05', NULL, NULL, 45, NULL, NULL, 232638),
(257068, '2wg5F02', NULL, NULL, 72, NULL, NULL, 232638),
(257069, '2d62A03', NULL, NULL, 45, NULL, NULL, 232638),
(257070, '5u4jl00', NULL, NULL, 124, NULL, NULL, 232638),
(257071, '3kdfB00', NULL, NULL, 132, NULL, NULL, 232638),
(257072, '5yzwA02', NULL, NULL, 97, NULL, NULL, 232638),
(257073, '1vs0A03', NULL, NULL, 121, NULL, NULL, 232638),
(257074, '6aqgA01', NULL, NULL, 141, NULL, NULL, 232638),
(257075, '4gnxC02', NULL, NULL, 141, NULL, NULL, 232638),
(257076, '4gnxC03', NULL, NULL, 192, NULL, NULL, 232638),
(257077, '3pioA01', NULL, NULL, 96, NULL, NULL, 232638),
(257078, '4gnxC01', NULL, NULL, 111, NULL, NULL, 232638),
(257079, '3dm3A00', NULL, NULL, 105, NULL, NULL, 232638),
(257080, '2q2iB00', NULL, NULL, 116, NULL, NULL, 232638),
(257081, '1miuA05', NULL, NULL, 145, NULL, NULL, 232638),
(257082, '1miuA03', NULL, NULL, 117, NULL, NULL, 232638),
(257083, '1bvsA01', NULL, NULL, 65, NULL, NULL, 232638),
(257084, '3ulpD00', NULL, NULL, 124, NULL, NULL, 232638),
(257085, '1miuA02', NULL, NULL, 130, NULL, NULL, 232638),
(257086, '3vdyA00', NULL, NULL, 116, NULL, NULL, 232638),
(257087, '2k14A00', NULL, NULL, 84, NULL, NULL, 232638),
(257088, '2a19A01', NULL, NULL, 89, NULL, NULL, 232638),
(257089, '3u4zA00', NULL, NULL, 109, NULL, NULL, 232638),
(257090, '3kdfA00', NULL, NULL, 121, NULL, NULL, 232638),
(257091, '3pf4A00', NULL, NULL, 67, NULL, NULL, 232638),
(257092, '2bh8B01', NULL, NULL, 68, NULL, NULL, 232638),
(257093, '3ebeB00', NULL, NULL, 181, NULL, NULL, 232638);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(257094, '3j7a500', NULL, NULL, 67, NULL, NULL, 232638),
(257095, '3i4oA00', NULL, NULL, 79, NULL, NULL, 232638),
(257096, '5xv9A00', NULL, NULL, 68, NULL, NULL, 232638),
(257097, '4a17A01', NULL, NULL, 87, NULL, NULL, 232638),
(257098, '3f1zI00', NULL, NULL, 116, NULL, NULL, 232638),
(257099, '2c35B02', NULL, NULL, 92, NULL, NULL, 232638),
(257100, '3gdeA03', NULL, NULL, 137, NULL, NULL, 232638),
(257101, '1oxxK02', NULL, NULL, 45, NULL, NULL, 232638),
(257102, '1x9nA04', NULL, NULL, 147, NULL, NULL, 232638),
(257103, '1uwvA01', NULL, NULL, 87, NULL, NULL, 232638),
(257104, '4gn5B00', NULL, NULL, 113, NULL, NULL, 232638),
(257105, '5j3bB03', NULL, NULL, 58, NULL, NULL, 232638),
(257106, '3kojB00', NULL, NULL, 108, NULL, NULL, 232638),
(257107, '3m9bB02', NULL, NULL, 59, NULL, NULL, 232638),
(257108, '5o5jQ00', NULL, NULL, 98, NULL, NULL, 232638),
(257109, '2rhsD02', NULL, NULL, 122, NULL, NULL, 232638),
(257110, '3sgiA03', NULL, NULL, 87, NULL, NULL, 232638),
(257111, '4klkA00', NULL, NULL, 180, NULL, NULL, 232638),
(257112, '1a0iA02', NULL, NULL, 109, NULL, NULL, 232638),
(257113, '3ayhB02', NULL, NULL, 124, NULL, NULL, 232638),
(257114, '2asbA01', NULL, NULL, 78, NULL, NULL, 232638),
(257115, '4dkaC00', NULL, NULL, 105, NULL, NULL, 232638),
(257116, '1luzA00', NULL, NULL, 88, NULL, NULL, 232638),
(257117, '1bkbA02', NULL, NULL, 65, NULL, NULL, 232638),
(257118, '1vq8A01', NULL, NULL, 79, NULL, NULL, 232638),
(257119, '3aevA01', NULL, NULL, 70, NULL, NULL, 232638),
(257120, '1ybyA02', NULL, NULL, 64, NULL, NULL, 232638),
(257121, '1c0aA01', NULL, NULL, 106, NULL, NULL, 232638),
(257122, '1ybyA03', NULL, NULL, 58, NULL, NULL, 232638),
(257123, '5yuoD00', NULL, NULL, 121, NULL, NULL, 232638),
(257124, '2nchA00', NULL, NULL, 87, NULL, NULL, 232638),
(257125, '4oxpA01', NULL, NULL, 106, NULL, NULL, 232638),
(257126, '5xogH00', NULL, NULL, 145, NULL, NULL, 232638),
(257127, '5odnC00', NULL, NULL, 110, NULL, NULL, 232638),
(257128, '5j3bA02', NULL, NULL, 66, NULL, NULL, 232638),
(257129, '2ja9A01', NULL, NULL, 83, NULL, NULL, 232638),
(257130, '5xyic00', NULL, NULL, 68, NULL, NULL, 232638),
(257131, '2ytxA01', NULL, NULL, 70, NULL, NULL, 232638),
(257132, '4eq5A03', NULL, NULL, 138, NULL, NULL, 232638),
(257133, '1fguB01', NULL, NULL, 105, NULL, NULL, 232638),
(257134, '5eayC00', NULL, NULL, 118, NULL, NULL, 232638),
(257135, '3rloA02', NULL, NULL, 99, NULL, NULL, 232638),
(257136, '1xtdA02', NULL, NULL, 80, NULL, NULL, 232638),
(257137, '3rloA01', NULL, NULL, 105, NULL, NULL, 232638),
(257138, '1u0lA01', NULL, NULL, 72, NULL, NULL, 232638),
(257139, '5jx4B00', NULL, NULL, 66, NULL, NULL, 232638),
(257140, '1z47A03', NULL, NULL, 49, NULL, NULL, 232638),
(257141, '3m9bA03', NULL, NULL, 96, NULL, NULL, 232638),
(257142, '5nh2A02', NULL, NULL, 65, NULL, NULL, 232638),
(257143, '3a5zD03', NULL, NULL, 59, NULL, NULL, 232638),
(257144, '3a5zD02', NULL, NULL, 64, NULL, NULL, 232638),
(257145, '3psiA06', NULL, NULL, 100, NULL, NULL, 232638),
(257146, '5hy6A02', NULL, NULL, 75, NULL, NULL, 232638),
(257147, '4l5tB01', NULL, NULL, 95, NULL, NULL, 232638),
(257148, '4l5tB02', NULL, NULL, 94, NULL, NULL, 232638),
(257149, '6aqhA01', NULL, NULL, 142, NULL, NULL, 232638),
(257150, '2je6I02', NULL, NULL, 88, NULL, NULL, 232638),
(257151, '2zjrA01', NULL, NULL, 86, NULL, NULL, 232638),
(257152, '4joiA00', NULL, NULL, 166, NULL, NULL, 232638),
(257153, '5h34A00', NULL, NULL, 111, NULL, NULL, 232638),
(257154, '4apvA00', NULL, NULL, 112, NULL, NULL, 232638),
(257155, '2ht1A01', NULL, NULL, 99, NULL, NULL, 232638),
(257156, '1kxlA00', NULL, NULL, 199, NULL, NULL, 232638),
(257157, '2i5hA01', NULL, NULL, 72, NULL, NULL, 232638),
(257158, '4p72A02', NULL, NULL, 115, NULL, NULL, 232638),
(257159, '6c00A00', NULL, NULL, 83, NULL, NULL, 232638),
(257160, '1uebA03', NULL, NULL, 58, NULL, NULL, 232638),
(257161, '4tquS03', NULL, NULL, 45, NULL, NULL, 232638),
(257162, '3s24A03', NULL, NULL, 94, NULL, NULL, 232638),
(257163, '1uebA02', NULL, NULL, 63, NULL, NULL, 232638),
(257164, '2exdA00', NULL, NULL, 80, NULL, NULL, 232638);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(257165, '3stbC00', NULL, NULL, 111, NULL, NULL, 232638),
(257166, '1fl0A00', NULL, NULL, 171, NULL, NULL, 232638),
(257167, '2k75A01', NULL, NULL, 103, NULL, NULL, 232638),
(257168, '3wwvA00', NULL, NULL, 80, NULL, NULL, 232638),
(257169, '1ripA00', NULL, NULL, 81, NULL, NULL, 232638),
(257170, '4ywkB02', NULL, NULL, 106, NULL, NULL, 232638),
(257171, '2ytyA00', NULL, NULL, 88, NULL, NULL, 232638),
(257172, '1b7yB02', NULL, NULL, 116, NULL, NULL, 232638),
(257173, '4r1jA00', NULL, NULL, 174, NULL, NULL, 232638),
(257174, '1k3rA02', NULL, NULL, 59, NULL, NULL, 232638),
(257175, '3ullB00', NULL, NULL, 132, NULL, NULL, 232638),
(257176, '5aj3L00', NULL, NULL, 109, NULL, NULL, 232638),
(257177, '2n78A00', NULL, NULL, 72, NULL, NULL, 232638),
(257178, '5mmiC01', NULL, NULL, 95, NULL, NULL, 232638),
(257179, '2i5lX00', NULL, NULL, 67, NULL, NULL, 232638),
(257180, '2nzhB00', NULL, NULL, 113, NULL, NULL, 232638),
(257181, '3e0eA00', NULL, NULL, 97, NULL, NULL, 232638),
(257182, '3rn5A02', NULL, NULL, 99, NULL, NULL, 232638),
(257183, '3rn5A01', NULL, NULL, 109, NULL, NULL, 232638),
(257184, '3pgzA00', NULL, NULL, 114, NULL, NULL, 232638),
(257185, '1gd7A00', NULL, NULL, 109, NULL, NULL, 232638),
(257186, '1ckmA02', NULL, NULL, 83, NULL, NULL, 232638),
(257187, '1z9fA00', NULL, NULL, 120, NULL, NULL, 232638),
(257188, '1mjcA00', NULL, NULL, 69, NULL, NULL, 232638),
(257189, '1u5kA01', NULL, NULL, 84, NULL, NULL, 232638),
(257190, '4hikA00', NULL, NULL, 143, NULL, NULL, 232638),
(257191, '1pybA00', NULL, NULL, 111, NULL, NULL, 232638),
(257192, '1o7iB00', NULL, NULL, 119, NULL, NULL, 232638),
(257193, '1jb7A03', NULL, NULL, 169, NULL, NULL, 232638),
(257194, '1jb7A01', NULL, NULL, 174, NULL, NULL, 232638),
(257195, '1jb7A02', NULL, NULL, 116, NULL, NULL, 232638),
(257196, '4mtnA02', NULL, NULL, 63, NULL, NULL, 232638),
(257197, '3l0oA02', NULL, NULL, 78, NULL, NULL, 232638),
(257198, '2hivA03', NULL, NULL, 164, NULL, NULL, 232638),
(257199, '2xgtB01', NULL, NULL, 103, NULL, NULL, 232638),
(257200, '4aybG00', NULL, NULL, 132, NULL, NULL, 232638),
(257201, '2e8gA02', NULL, NULL, 117, NULL, NULL, 232638),
(257202, '6qulC01', NULL, NULL, 114, NULL, NULL, 232638),
(257203, '3a0jA00', NULL, NULL, 73, NULL, NULL, 232638),
(257204, '4joiC00', NULL, NULL, 122, NULL, NULL, 232638),
(257205, '2oqkA00', NULL, NULL, 96, NULL, NULL, 232638),
(257206, '3m4pA01', NULL, NULL, 127, NULL, NULL, 232638),
(257207, '3uljB00', NULL, NULL, 90, NULL, NULL, 232638),
(257208, '1wydA01', NULL, NULL, 102, NULL, NULL, 232638),
(257209, '4c2mV02', NULL, NULL, 82, NULL, NULL, 232638),
(257210, '4glvB00', NULL, NULL, 107, NULL, NULL, 232638),
(257211, '2hqlA01', NULL, NULL, 97, NULL, NULL, 232638),
(257212, '5o5jL00', NULL, NULL, 124, NULL, NULL, 232638),
(257213, '3eivD00', NULL, NULL, 120, NULL, NULL, 232638),
(257214, '4aimA04', NULL, NULL, 76, NULL, NULL, 232638),
(257215, '3camA00', NULL, NULL, 67, NULL, NULL, 232638),
(257216, '1sr3A00', NULL, NULL, 114, NULL, NULL, 232638),
(257217, '1rl2A01', NULL, NULL, 56, NULL, NULL, 232638),
(257218, '3d31A02', NULL, NULL, 46, NULL, NULL, 232638),
(257219, '4jbmB01', NULL, NULL, 96, NULL, NULL, 232638),
(257220, '3i2zA00', NULL, NULL, 71, NULL, NULL, 232638),
(257221, '3f8tA02', NULL, NULL, 80, NULL, NULL, 232638),
(257222, '5v7qC01', NULL, NULL, 115, NULL, NULL, 232638),
(257223, '3kf6B00', NULL, NULL, 105, NULL, NULL, 232638),
(257224, '2eqsA01', NULL, NULL, 89, NULL, NULL, 232638),
(257225, '3k7uC00', NULL, NULL, 118, NULL, NULL, 232638),
(257226, '4glaC00', NULL, NULL, 92, NULL, NULL, 232638),
(257227, '5yyuB00', NULL, NULL, 112, NULL, NULL, 232638),
(257228, '3nemA01', NULL, NULL, 105, NULL, NULL, 232638),
(257229, '1xjvA01', NULL, NULL, 145, NULL, NULL, 232638),
(257230, '3cqzH00', NULL, NULL, 146, NULL, NULL, 232638),
(257231, '1smxA00', NULL, NULL, 96, NULL, NULL, 232638),
(257232, '1xjvA02', NULL, NULL, 149, NULL, NULL, 232638),
(257233, '2n3sA00', NULL, NULL, 72, NULL, NULL, 232638),
(257234, '4me3A02', NULL, NULL, 105, NULL, NULL, 232638),
(257235, '3k8aB00', NULL, NULL, 103, NULL, NULL, 232638);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(257236, '4jbmA02', NULL, NULL, 97, NULL, NULL, 232638),
(257237, '1a62A02', NULL, NULL, 70, NULL, NULL, 232638),
(257238, '2k5hA01', NULL, NULL, 73, NULL, NULL, 232638),
(257239, '1ltlA02', NULL, NULL, 100, NULL, NULL, 232638),
(257240, '2dgyA01', NULL, NULL, 79, NULL, NULL, 232638),
(257241, '2q2tA03', NULL, NULL, 111, NULL, NULL, 232638),
(257242, '1wocC00', NULL, NULL, 103, NULL, NULL, 232638),
(257243, '4gnxA00', NULL, NULL, 114, NULL, NULL, 232638),
(257244, '4jg2A00', NULL, NULL, 188, NULL, NULL, 232638),
(257245, '2wfwA01', NULL, NULL, 64, NULL, NULL, 232638),
(257246, '4aybE02', NULL, NULL, 99, NULL, NULL, 232638),
(257247, '3kf6A00', NULL, NULL, 159, NULL, NULL, 232638),
(257248, '1vs7Q00', NULL, NULL, 84, NULL, NULL, 232638),
(257249, '1jt8A00', NULL, NULL, 102, NULL, NULL, 232638),
(257250, '4qqbX01', NULL, NULL, 68, NULL, NULL, 232638),
(257251, '1bbuA01', NULL, NULL, 140, NULL, NULL, 232638),
(257252, '4ah6A01', NULL, NULL, 116, NULL, NULL, 232638),
(257253, '2n8nA00', NULL, NULL, 72, NULL, NULL, 232638),
(257254, '2k52A00', NULL, NULL, 80, NULL, NULL, 232638),
(257255, '4gs3A00', NULL, NULL, 107, NULL, NULL, 232638),
(257256, '5aj3Q00', NULL, NULL, 110, NULL, NULL, 232638),
(257257, '3fhwA00', NULL, NULL, 115, NULL, NULL, 232638),
(257258, '1hr0W00', NULL, NULL, 71, NULL, NULL, 232638),
(257259, '3u4vA00', NULL, NULL, 117, NULL, NULL, 232638),
(257260, '2pi2D00', NULL, NULL, 132, NULL, NULL, 232638),
(257261, '1hh2P02', NULL, NULL, 63, NULL, NULL, 232638),
(257262, '2mo0A00', NULL, NULL, 68, NULL, NULL, 232638),
(257263, '2qgqA02', NULL, NULL, 68, NULL, NULL, 232638),
(257264, '4dniA01', NULL, NULL, 133, NULL, NULL, 232638),
(257265, '2rcnA01', NULL, NULL, 68, NULL, NULL, 232638),
(257266, '1jjgA00', NULL, NULL, 102, NULL, NULL, 232638),
(257267, '4rg1A02', NULL, NULL, 67, NULL, NULL, 232638),
(257268, '1pfsA00', NULL, NULL, 78, NULL, NULL, 232638),
(257269, '4j15A01', NULL, NULL, 132, NULL, NULL, 232638),
(257270, '3tqyC00', NULL, NULL, 113, NULL, NULL, 232638),
(257271, '1mjeA03', NULL, NULL, 165, NULL, NULL, 232638),
(257272, '3afpA00', NULL, NULL, 120, NULL, NULL, 232638),
(257273, '5zdiA00', NULL, NULL, 107, NULL, NULL, 232638),
(257274, '3mxnB00', NULL, NULL, 131, NULL, NULL, 232638),
(257275, '2ihfA02', NULL, NULL, 113, NULL, NULL, 232638),
(257276, '2ckzB02', NULL, NULL, 108, NULL, NULL, 232638),
(257277, '2ahoB01', NULL, NULL, 85, NULL, NULL, 232638),
(257278, '3m7nA02', NULL, NULL, 86, NULL, NULL, 232638),
(257279, '1lm0A00', NULL, NULL, 107, NULL, NULL, 232638),
(257280, '3hkzG00', NULL, NULL, 132, NULL, NULL, 232638),
(257281, '2wfwB02', NULL, NULL, 89, NULL, NULL, 232638),
(257282, '3g48B00', NULL, NULL, 112, NULL, NULL, 232638),
(257283, '1e1oA01', NULL, NULL, 140, NULL, NULL, 232638),
(257284, '1ynxA01', NULL, NULL, 109, NULL, NULL, 232638),
(257285, '2d0oA05', NULL, NULL, 45, NULL, NULL, 232638),
(257286, '1wfqA01', NULL, NULL, 73, NULL, NULL, 232638),
(257287, '1je5A00', NULL, NULL, 206, NULL, NULL, 232638),
(257288, '1go3E01', NULL, NULL, 101, NULL, NULL, 232638),
(257289, '5o6fA00', NULL, NULL, 82, NULL, NULL, 232638),
(257290, '2haxA01', NULL, NULL, 43, NULL, NULL, 232638),
(257291, '2nn6I02', NULL, NULL, 139, NULL, NULL, 232638),
(257292, '2oq0C01', NULL, NULL, 113, NULL, NULL, 232638),
(257293, '3cpfB02', NULL, NULL, 68, NULL, NULL, 232638),
(257294, '1eovA01', NULL, NULL, 134, NULL, NULL, 232638),
(257295, '1x6oA02', NULL, NULL, 80, NULL, NULL, 232638),
(257296, '4gn3D00', NULL, NULL, 113, NULL, NULL, 232638),
(257297, '3o2zF00', NULL, NULL, 88, NULL, NULL, 232638),
(257298, '1vw3B01', NULL, NULL, 93, NULL, NULL, 232638),
(257299, '5zg8A01', NULL, NULL, 102, NULL, NULL, 232638),
(257300, '3kf8B00', NULL, NULL, 123, NULL, NULL, 232638),
(257301, '1se8A01', NULL, NULL, 116, NULL, NULL, 232638),
(257302, '4v19D01', NULL, NULL, 107, NULL, NULL, 232638),
(257303, '1se8A02', NULL, NULL, 117, NULL, NULL, 232638),
(257304, '4bpe000', NULL, NULL, 99, NULL, NULL, 232638),
(257305, '2kbnA00', NULL, NULL, 109, NULL, NULL, 232638),
(257306, '2eifA02', NULL, NULL, 62, NULL, NULL, 232638);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(257307, '4npsA02', NULL, NULL, 58, NULL, NULL, 232638),
(257308, '4mnoA00', NULL, NULL, 115, NULL, NULL, 232638),
(257309, '1qvcD00', NULL, NULL, 145, NULL, NULL, 232638),
(257310, '1t9hA01', NULL, NULL, 74, NULL, NULL, 232638),
(257311, '1n9wA01', NULL, NULL, 92, NULL, NULL, 232638),
(257312, '2vnuD04', NULL, NULL, 90, NULL, NULL, 232638),
(257313, '5gqoB00', NULL, NULL, 115, NULL, NULL, 232638),
(257314, '3q8dA01', NULL, NULL, 78, NULL, NULL, 232638),
(257315, '1mkhA00', NULL, NULL, 107, NULL, NULL, 232638),
(257316, '5zkgA00', NULL, NULL, 165, NULL, NULL, 232638),
(257317, '6g5ic00', NULL, NULL, 69, NULL, NULL, 232638),
(257318, '4glxA04', NULL, NULL, 74, NULL, NULL, 232638),
(257319, '1qzgA00', NULL, NULL, 187, NULL, NULL, 232638),
(257320, '5xgtA00', NULL, NULL, 111, NULL, NULL, 232638),
(257321, '5w25A01', NULL, NULL, 111, NULL, NULL, 232638),
(257322, '3treA02', NULL, NULL, 62, NULL, NULL, 232638),
(257323, '2lssA00', NULL, NULL, 70, NULL, NULL, 232638),
(257324, '4rmfA01', NULL, NULL, 107, NULL, NULL, 232638),
(257325, '3a74A01', NULL, NULL, 141, NULL, NULL, 232638),
(257326, '3cp0A00', NULL, NULL, 63, NULL, NULL, 232638),
(257327, '1vx7D01', NULL, NULL, 86, NULL, NULL, 232638),
(257328, '4pmwA04', NULL, NULL, 91, NULL, NULL, 232638),
(257329, '3l2pA04', NULL, NULL, 146, NULL, NULL, 232638),
(257330, '1jmcA02', NULL, NULL, 126, NULL, NULL, 232638),
(257331, '3fp9A02', NULL, NULL, 94, NULL, NULL, 232638),
(257332, '3fp9A01', NULL, NULL, 59, NULL, NULL, 232638),
(257333, '4ql5A00', NULL, NULL, 73, NULL, NULL, 232638),
(257334, '5ie8A00', NULL, NULL, 89, NULL, NULL, 232638),
(257335, '2ba0A02', NULL, NULL, 87, NULL, NULL, 232638),
(257336, '2ix0A01', NULL, NULL, 79, NULL, NULL, 232638),
(257337, '5hgqA01', NULL, NULL, 149, NULL, NULL, 232638),
(257338, '1gm5A03', NULL, NULL, 102, NULL, NULL, 232638),
(257339, '6hcwA01', NULL, NULL, 144, NULL, NULL, 232638),
(257340, '3bzcA05', NULL, NULL, 96, NULL, NULL, 232638),
(257341, '5groA00', NULL, NULL, 115, NULL, NULL, 232638),
(257342, '2yv5A01', NULL, NULL, 67, NULL, NULL, 232638),
(257343, '1gvpA00', NULL, NULL, 87, NULL, NULL, 232638),
(257344, '3bu2A01', NULL, NULL, 127, NULL, NULL, 232638),
(257345, '6gmhH01', NULL, NULL, 145, NULL, NULL, 232638),
(257346, '2cqoA01', NULL, NULL, 92, NULL, NULL, 232638),
(257347, '3lgjB00', NULL, NULL, 114, NULL, NULL, 232638),
(257348, '2k5nA00', NULL, NULL, 74, NULL, NULL, 232638),
(257349, '4gn4B00', NULL, NULL, 108, NULL, NULL, 232638),
(257350, '5mmjl00', NULL, NULL, 123, NULL, NULL, 232638),
(257351, '6bhwC00', NULL, NULL, 119, NULL, NULL, 232638),
(257352, '3h0gH00', NULL, NULL, 125, NULL, NULL, 232638),
(257353, '1g29102', NULL, NULL, 45, NULL, NULL, 232638),
(257354, '2wg6D00', NULL, NULL, 109, NULL, NULL, 232638),
(257355, '5jjiE01', NULL, NULL, 132, NULL, NULL, 232638),
(257356, '3u50C01', NULL, NULL, 137, NULL, NULL, 232638),
(257357, '5fj8G02', NULL, NULL, 133, NULL, NULL, 232638),
(257358, '3jc6602', NULL, NULL, 98, NULL, NULL, 232638),
(257359, '1x54A01', NULL, NULL, 104, NULL, NULL, 232638),
(257360, '3rr5A03', NULL, NULL, 137, NULL, NULL, 232638),
(257361, '2vw9B00', NULL, NULL, 106, NULL, NULL, 232638),
(257362, '5odpG00', NULL, NULL, 112, NULL, NULL, 232638),
(257363, '1g6pA00', NULL, NULL, 66, NULL, NULL, 232638),
(257364, '3kyhC02', NULL, NULL, 165, NULL, NULL, 232638),
(257365, '1x65A01', NULL, NULL, 73, NULL, NULL, 232638),
(257366, '1wjjA01', NULL, NULL, 110, NULL, NULL, 232638),
(257367, '4qjfA02', NULL, NULL, 109, NULL, NULL, 232638),
(257368, '4a4iB00', NULL, NULL, 90, NULL, NULL, 232638),
(257369, '1cukA01', NULL, NULL, 66, NULL, NULL, 232638),
(257370, '4ifdI02', NULL, NULL, 167, NULL, NULL, 232638),
(257371, '3hksA02', NULL, NULL, 75, NULL, NULL, 232638),
(257372, '1sroA00', NULL, NULL, 76, NULL, NULL, 232638),
(257373, '2kcmA00', NULL, NULL, 74, NULL, NULL, 232638),
(257374, '3d0fA01', NULL, NULL, 73, NULL, NULL, 232638),
(257375, '3u5eA01', NULL, NULL, 86, NULL, NULL, 232638),
(257376, '2yyzA03', NULL, NULL, 63, NULL, NULL, 232638),
(257377, '3j7yD01', NULL, NULL, 106, NULL, NULL, 232638);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(257378, '2z0sA01', NULL, NULL, 89, NULL, NULL, 232638),
(257379, '3h0gG02', NULL, NULL, 89, NULL, NULL, 232638),
(257380, '3go5A03', NULL, NULL, 70, NULL, NULL, 232638),
(257381, '3go5A02', NULL, NULL, 79, NULL, NULL, 232638),
(257382, '5xixB01', NULL, NULL, 103, NULL, NULL, 232638),
(257383, '3er0A02', NULL, NULL, 73, NULL, NULL, 232638),
(257384, '1l1oF01', NULL, NULL, 141, NULL, NULL, 232638),
(257385, '1p16B02', NULL, NULL, 151, NULL, NULL, 232638),
(257386, '2awnC03', NULL, NULL, 58, NULL, NULL, 232638),
(257387, '1ixrA01', NULL, NULL, 63, NULL, NULL, 232638),
(257388, '1ny4A00', NULL, NULL, 82, NULL, NULL, 232638),
(257389, '1v43A03', NULL, NULL, 68, NULL, NULL, 232638),
(257390, '3irbA02', NULL, NULL, 68, NULL, NULL, 232638),
(257391, '2cwaA01', NULL, NULL, 126, NULL, NULL, 232638),
(257392, '2cwaA02', NULL, NULL, 102, NULL, NULL, 232638),
(257393, '6hmaC01', NULL, NULL, 113, NULL, NULL, 232638),
(257394, '1y14D02', NULL, NULL, 87, NULL, NULL, 232638),
(257395, '1c9oA00', NULL, NULL, 66, NULL, NULL, 232638),
(257396, '2k4kA01', NULL, NULL, 87, NULL, NULL, 232638),
(257397, '2mqhA00', NULL, NULL, 82, NULL, NULL, 232638),
(257398, '3ersX00', NULL, NULL, 118, NULL, NULL, 232638),
(257399, '4oonA03', NULL, NULL, 104, NULL, NULL, 232638),
(257400, '3zjyC00', NULL, NULL, 85, NULL, NULL, 232638),
(257401, '1yezA00', NULL, NULL, 68, NULL, NULL, 232638),
(257402, '2oq0B02', NULL, NULL, 93, NULL, NULL, 232638),
(257403, '2lxjA00', NULL, NULL, 66, NULL, NULL, 232638),
(257404, '4qy7A01', NULL, NULL, 87, NULL, NULL, 232638),
(257405, '2khjA00', NULL, NULL, 89, NULL, NULL, 232638),
(257406, '2id0A04', NULL, NULL, 87, NULL, NULL, 232638),
(257407, '2fxqA01', NULL, NULL, 126, NULL, NULL, 232638),
(257408, '3oyyB03', NULL, NULL, 60, NULL, NULL, 232638),
(257409, '2id0A01', NULL, NULL, 82, NULL, NULL, 232638),
(257410, '1iyjB02', NULL, NULL, 131, NULL, NULL, 232638),
(257411, '2fxqA02', NULL, NULL, 103, NULL, NULL, 232638),
(257412, '1q8kA01', NULL, NULL, 87, NULL, NULL, 232638),
(257413, '1iyjB03', NULL, NULL, 142, NULL, NULL, 232638),
(257414, '1iyjB04', NULL, NULL, 138, NULL, NULL, 232638),
(257415, '5yzpA02', NULL, NULL, 97, NULL, NULL, 232638),
(257416, '5xymC01', NULL, NULL, 115, NULL, NULL, 232638),
(257417, '5yzpA01', NULL, NULL, 113, NULL, NULL, 232638),
(257418, '6ildA01', NULL, NULL, 144, NULL, NULL, 232638),
(257419, '6faic00', NULL, NULL, 67, NULL, NULL, 232638),
(257420, '1dgsA04', NULL, NULL, 73, NULL, NULL, 232638),
(257421, '2cfmA03', NULL, NULL, 140, NULL, NULL, 232638),
(257422, '2ztdA01', NULL, NULL, 80, NULL, NULL, 232638),
(257423, '2xzm100', NULL, NULL, 68, NULL, NULL, 232638),
(257424, '5xxuc00', NULL, NULL, 68, NULL, NULL, 232638),
(257425, '2vqeQ00', NULL, NULL, 105, NULL, NULL, 232638),
(257426, '3aqqA00', NULL, NULL, 107, NULL, NULL, 232638),
(257427, '1i94Q00', NULL, NULL, 104, NULL, NULL, 232638),
(257428, '1d7qA00', NULL, NULL, 143, NULL, NULL, 232638),
(257429, '5udzA01', NULL, NULL, 94, NULL, NULL, 232638),
(257430, '1kl9A01', NULL, NULL, 89, NULL, NULL, 232638),
(257431, '4fdbA00', NULL, NULL, 101, NULL, NULL, 232638),
(257432, '2zteA01', NULL, NULL, 79, NULL, NULL, 232638),
(257433, '2nn6G02', NULL, NULL, 77, NULL, NULL, 232638),
(257434, '3udfA03', NULL, NULL, 95, NULL, NULL, 232638),
(257435, '4damC00', NULL, NULL, 128, NULL, NULL, 232638),
(257436, '1l0wA01', NULL, NULL, 106, NULL, NULL, 232638),
(257437, '1khiA02', NULL, NULL, 75, NULL, NULL, 232638),
(257438, '4l5rC01', NULL, NULL, 109, NULL, NULL, 232638),
(257439, '2r7dA03', NULL, NULL, 66, NULL, NULL, 232638),
(257440, '6neqQ00', NULL, NULL, 109, NULL, NULL, 232638),
(257441, '6az1d00', NULL, NULL, 66, NULL, NULL, 232638),
(257442, '3o2zP00', NULL, NULL, 119, NULL, NULL, 232638),
(257443, '6hcuB01', NULL, NULL, 149, NULL, NULL, 232638),
(257444, '3oyyA02', NULL, NULL, 65, NULL, NULL, 232638),
(257445, '1wi5A01', NULL, NULL, 75, NULL, NULL, 232638),
(257446, '1yvcA00', NULL, NULL, 70, NULL, NULL, 232638),
(257447, '4owwB00', NULL, NULL, 111, NULL, NULL, 232638),
(257448, '1vvmD01', NULL, NULL, 115, NULL, NULL, 232638);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(257449, '3pcoB02', NULL, NULL, 116, NULL, NULL, 232638),
(257450, '1ne3A00', NULL, NULL, 68, NULL, NULL, 232638),
(257451, '1x3eA00', NULL, NULL, 120, NULL, NULL, 232638),
(257452, '3i7fA01', NULL, NULL, 128, NULL, NULL, 232638),
(257453, '4l5rC02', NULL, NULL, 89, NULL, NULL, 232638),
(257454, '2khiA00', NULL, NULL, 95, NULL, NULL, 232638),
(257455, '3deeA02', NULL, NULL, 114, NULL, NULL, 232639),
(257456, '2micA00', NULL, NULL, 41, NULL, NULL, 232640),
(257457, '1x91A00', NULL, NULL, 153, NULL, NULL, 232641),
(257458, '2cj4A00', NULL, NULL, 150, NULL, NULL, 232641),
(257459, '1xg2B00', NULL, NULL, 153, NULL, NULL, 232641),
(257460, '4fwwA02', NULL, NULL, 46, NULL, NULL, 232642),
(257461, '4gz8A02', NULL, NULL, 53, NULL, NULL, 232642),
(257462, '1yukA01', NULL, NULL, 59, NULL, NULL, 232642),
(257463, '3nvqA02', NULL, NULL, 57, NULL, NULL, 232642),
(257464, '4gz8B02', NULL, NULL, 76, NULL, NULL, 232642),
(257465, '4k3jB02', NULL, NULL, 57, NULL, NULL, 232642),
(257466, '5b4wE02', NULL, NULL, 47, NULL, NULL, 232642),
(257467, '2uzyB02', NULL, NULL, 45, NULL, NULL, 232642),
(257468, '1olzA02', NULL, NULL, 57, NULL, NULL, 232642),
(257469, '3ol2B02', NULL, NULL, 63, NULL, NULL, 232642),
(257470, '4wk0B01', NULL, NULL, 61, NULL, NULL, 232642),
(257471, '3t3pB01', NULL, NULL, 57, NULL, NULL, 232642),
(257472, '3al9A02', NULL, NULL, 60, NULL, NULL, 232642),
(257473, '3okyB02', NULL, NULL, 66, NULL, NULL, 232642),
(257474, '3al8B02', NULL, NULL, 33, NULL, NULL, 232642),
(257475, '4um9D01', NULL, NULL, 61, NULL, NULL, 232642),
(257476, '4tzcD00', NULL, NULL, 108, NULL, NULL, 232643),
(257477, '5fqdB01', NULL, NULL, 138, NULL, NULL, 232643),
(257478, '3cxkA00', NULL, NULL, 134, NULL, NULL, 232643),
(257479, '2kv1A01', NULL, NULL, 86, NULL, NULL, 232643),
(257480, '2k8dA00', NULL, NULL, 151, NULL, NULL, 232643),
(257481, '1l1dA00', NULL, NULL, 152, NULL, NULL, 232643),
(257482, '3hcgB00', NULL, NULL, 146, NULL, NULL, 232643),
(257483, '3maoA00', NULL, NULL, 105, NULL, NULL, 232643),
(257484, '4ci2B01', NULL, NULL, 122, NULL, NULL, 232643),
(257485, '5amhA00', NULL, NULL, 107, NULL, NULL, 232643),
(257486, '3e0mA02', NULL, NULL, 149, NULL, NULL, 232643),
(257487, '1vzrA01', NULL, NULL, 109, NULL, NULL, 232643),
(257488, '3hcjA01', NULL, NULL, 145, NULL, NULL, 232643),
(257489, '3e0oC00', NULL, NULL, 144, NULL, NULL, 232643),
(257490, '1l1lA03', NULL, NULL, 109, NULL, NULL, 232644),
(257491, '1q16A09', NULL, NULL, 45, NULL, NULL, 232645),
(257492, '4oi4C01', NULL, NULL, 84, NULL, NULL, 232646),
(257493, '4ohyA01', NULL, NULL, 85, NULL, NULL, 232646),
(257494, '2kp6A00', NULL, NULL, 82, NULL, NULL, 232647),
(257495, '3r1kA03', NULL, NULL, 96, NULL, NULL, 232648),
(257496, '3sxnA03', NULL, NULL, 98, NULL, NULL, 232648),
(257497, '3bn8B00', NULL, NULL, 128, NULL, NULL, 232648),
(257498, '3bn8A00', NULL, NULL, 128, NULL, NULL, 232648),
(257499, '2cx7A00', NULL, NULL, 130, NULL, NULL, 232648),
(257500, '4pdxA03', NULL, NULL, 138, NULL, NULL, 232648),
(257501, '2qztA00', NULL, NULL, 111, NULL, NULL, 232648),
(257502, '4my0A03', NULL, NULL, 100, NULL, NULL, 232648),
(257503, '2i00A03', NULL, NULL, 95, NULL, NULL, 232648),
(257504, '2ozgA03', NULL, NULL, 94, NULL, NULL, 232648),
(257505, '4jgxA00', NULL, NULL, 129, NULL, NULL, 232648),
(257506, '4axhA03', NULL, NULL, 136, NULL, NULL, 232648),
(257507, '4nurA03', NULL, NULL, 131, NULL, NULL, 232648),
(257508, '2hv2C02', NULL, NULL, 123, NULL, NULL, 232648),
(257509, '3n7zB03', NULL, NULL, 95, NULL, NULL, 232648),
(257510, '4ueiA00', NULL, NULL, 127, NULL, NULL, 232648),
(257511, '1pz4A00', NULL, NULL, 116, NULL, NULL, 232648),
(257512, '1iktA00', NULL, NULL, 120, NULL, NULL, 232648),
(257513, '1c44A00', NULL, NULL, 123, NULL, NULL, 232648),
(257514, '3bkrA00', NULL, NULL, 126, NULL, NULL, 232648),
(257515, '3cnuA00', NULL, NULL, 116, NULL, NULL, 232648),
(257516, '2nbmA00', NULL, NULL, 111, NULL, NULL, 232648),
(257517, '2cfuA03', NULL, NULL, 138, NULL, NULL, 232648),
(257518, '3g43E00', NULL, NULL, 81, NULL, NULL, 232649),
(257519, '3oxqE00', NULL, NULL, 78, NULL, NULL, 232649);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(257520, '5nrgS02', NULL, NULL, 82, NULL, NULL, 232650),
(257521, '5dm6S02', NULL, NULL, 89, NULL, NULL, 232650),
(257522, '1feuA02', NULL, NULL, 94, NULL, NULL, 232650),
(257523, '3blxE00', NULL, NULL, 349, NULL, NULL, 232651),
(257524, '1tyoB00', NULL, NULL, 435, NULL, NULL, 232651),
(257525, '2iv0A00', NULL, NULL, 412, NULL, NULL, 232651),
(257526, '3vmkA00', NULL, NULL, 375, NULL, NULL, 232651),
(257527, '2qfyA00', NULL, NULL, 427, NULL, NULL, 232651),
(257528, '3tsnA00', NULL, NULL, 367, NULL, NULL, 232651),
(257529, '1x0lA00', NULL, NULL, 333, NULL, NULL, 232651),
(257530, '3ty4B00', NULL, NULL, 366, NULL, NULL, 232651),
(257531, '1vi1A00', NULL, NULL, 345, NULL, NULL, 232651),
(257532, '1yxoA00', NULL, NULL, 328, NULL, NULL, 232651),
(257533, '3lxyA00', NULL, NULL, 334, NULL, NULL, 232651),
(257534, '3dmsA00', NULL, NULL, 427, NULL, NULL, 232651),
(257535, '4jqpA00', NULL, NULL, 342, NULL, NULL, 232651),
(257536, '1ycoA00', NULL, NULL, 279, NULL, NULL, 232651),
(257537, '5hn3A00', NULL, NULL, 332, NULL, NULL, 232651),
(257538, '4xxvA00', NULL, NULL, 363, NULL, NULL, 232651),
(257539, '1zorB00', NULL, NULL, 399, NULL, NULL, 232651),
(257540, '3us8A00', NULL, NULL, 403, NULL, NULL, 232651),
(257541, '2y3zA00', NULL, NULL, 359, NULL, NULL, 232651),
(257542, '4atyA00', NULL, NULL, 349, NULL, NULL, 232651),
(257543, '1ptmA00', NULL, NULL, 329, NULL, NULL, 232651),
(257544, '2hi1A00', NULL, NULL, 330, NULL, NULL, 232651),
(257545, '1v53A00', NULL, NULL, 366, NULL, NULL, 232651),
(257546, '5j34A00', NULL, NULL, 365, NULL, NULL, 232651),
(257547, '5griA00', NULL, NULL, 339, NULL, NULL, 232651),
(257548, '1pb1A00', NULL, NULL, 416, NULL, NULL, 232651),
(257549, '2d1cA01', NULL, NULL, 385, NULL, NULL, 232651),
(257550, '1xacA00', NULL, NULL, 345, NULL, NULL, 232651),
(257551, '3blxB00', NULL, NULL, 354, NULL, NULL, 232651),
(257552, '6e85A00', NULL, NULL, 331, NULL, NULL, 232651),
(257553, '1r8kA00', NULL, NULL, 329, NULL, NULL, 232651),
(257554, '3u1hB00', NULL, NULL, 368, NULL, NULL, 232651),
(257555, '5m2eA00', NULL, NULL, 418, NULL, NULL, 232651),
(257556, '3uduA00', NULL, NULL, 361, NULL, NULL, 232651),
(257557, '1w0dA00', NULL, NULL, 337, NULL, NULL, 232651),
(257558, '3vmlA00', NULL, NULL, 375, NULL, NULL, 232651),
(257559, '1u7nA00', NULL, NULL, 336, NULL, NULL, 232651),
(257560, '4aoyA00', NULL, NULL, 402, NULL, NULL, 232651),
(257561, '1a05A00', NULL, NULL, 358, NULL, NULL, 232651),
(257562, '4hcxA00', NULL, NULL, 409, NULL, NULL, 232651),
(257563, '1hqsA00', NULL, NULL, 423, NULL, NULL, 232651),
(257564, '1cm7A00', NULL, NULL, 363, NULL, NULL, 232651),
(257565, '3flkA00', NULL, NULL, 364, NULL, NULL, 232651),
(257566, '4ja8B00', NULL, NULL, 416, NULL, NULL, 232651),
(257567, '2d4vA00', NULL, NULL, 429, NULL, NULL, 232651),
(257568, '3wzyA00', NULL, NULL, 375, NULL, NULL, 232651),
(257569, '1cnzA00', NULL, NULL, 363, NULL, NULL, 232651),
(257570, '1vlcA00', NULL, NULL, 366, NULL, NULL, 232651),
(257571, '3uf6B00', NULL, NULL, 291, NULL, NULL, 232651),
(257572, '2uxqB00', NULL, NULL, 402, NULL, NULL, 232651),
(257573, '6bkxA00', NULL, NULL, 425, NULL, NULL, 232651),
(257574, '6c0eB00', NULL, NULL, 419, NULL, NULL, 232651),
(257575, '1wpwA00', NULL, NULL, 336, NULL, NULL, 232651),
(257576, '2e0cA00', NULL, NULL, 409, NULL, NULL, 232651),
(257577, '4y1pB00', NULL, NULL, 337, NULL, NULL, 232651),
(257578, '5yzhB00', NULL, NULL, 414, NULL, NULL, 232651),
(257579, '5griB00', NULL, NULL, 354, NULL, NULL, 232651),
(257580, '1hi8A04', NULL, NULL, 58, NULL, NULL, 232652),
(257581, '1uvjA04', NULL, NULL, 58, NULL, NULL, 232652),
(257582, '1wacA04', NULL, NULL, 56, NULL, NULL, 232652),
(257583, '4fe9A02', NULL, NULL, 114, NULL, NULL, 232653),
(257584, '4fe9A03', NULL, NULL, 110, NULL, NULL, 232653),
(257585, '4fchA01', NULL, NULL, 117, NULL, NULL, 232653),
(257586, '1hf2A01', NULL, NULL, 100, NULL, NULL, 232654),
(257587, '2oo4A02', NULL, NULL, 116, NULL, NULL, 232655),
(257588, '3etoA02', NULL, NULL, 120, NULL, NULL, 232655),
(257589, '5czxA02', NULL, NULL, 143, NULL, NULL, 232655),
(257590, '2hh8A00', NULL, NULL, 133, NULL, NULL, 232656);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(257591, '2jv7A00', NULL, NULL, 78, NULL, NULL, 232657),
(257592, '4x7rA03', NULL, NULL, 169, NULL, NULL, 232658),
(257593, '5du2B01', NULL, NULL, 229, NULL, NULL, 232658),
(257594, '2vsyA03', NULL, NULL, 179, NULL, NULL, 232658),
(257595, '2iuyA02', NULL, NULL, 176, NULL, NULL, 232658),
(257596, '3ot5B01', NULL, NULL, 218, NULL, NULL, 232658),
(257597, '2r60A02', NULL, NULL, 215, NULL, NULL, 232658),
(257598, '4hwgA01', NULL, NULL, 223, NULL, NULL, 232658),
(257599, '4x7rA01', NULL, NULL, 204, NULL, NULL, 232658),
(257600, '2x0dA02', NULL, NULL, 176, NULL, NULL, 232658),
(257601, '4hwgA02', NULL, NULL, 162, NULL, NULL, 232658),
(257602, '2r60A01', NULL, NULL, 247, NULL, NULL, 232658),
(257603, '4w6qB01', NULL, NULL, 176, NULL, NULL, 232658),
(257604, '1pn3A02', NULL, NULL, 170, NULL, NULL, 232658),
(257605, '1z8dA02', NULL, NULL, 327, NULL, NULL, 232658),
(257606, '2iuyA01', NULL, NULL, 161, NULL, NULL, 232658),
(257607, '3ia7A02', NULL, NULL, 167, NULL, NULL, 232658),
(257608, '3ia7A01', NULL, NULL, 235, NULL, NULL, 232658),
(257609, '5du2B02', NULL, NULL, 160, NULL, NULL, 232658),
(257610, '4g2tA01', NULL, NULL, 222, NULL, NULL, 232658),
(257611, '3s2uA02', NULL, NULL, 178, NULL, NULL, 232658),
(257612, '3uykA01', NULL, NULL, 210, NULL, NULL, 232658),
(257613, '4g2tA02', NULL, NULL, 175, NULL, NULL, 232658),
(257614, '6d9tA02', NULL, NULL, 182, NULL, NULL, 232658),
(257615, '6d9tA01', NULL, NULL, 201, NULL, NULL, 232658),
(257616, '1l5wA02', NULL, NULL, 329, NULL, NULL, 232658),
(257617, '2iyaA01', NULL, NULL, 261, NULL, NULL, 232658),
(257618, '3ddsA02', NULL, NULL, 327, NULL, NULL, 232658),
(257619, '1l5wA01', NULL, NULL, 467, NULL, NULL, 232658),
(257620, '5v0tA02', NULL, NULL, 209, NULL, NULL, 232658),
(257621, '2iyaA02', NULL, NULL, 163, NULL, NULL, 232658),
(257622, '3hbfA02', NULL, NULL, 176, NULL, NULL, 232658),
(257623, '1vgvA02', NULL, NULL, 170, NULL, NULL, 232658),
(257624, '1vgvA01', NULL, NULL, 214, NULL, NULL, 232658),
(257625, '1jg7A01', NULL, NULL, 183, NULL, NULL, 232658),
(257626, '1jg7A02', NULL, NULL, 166, NULL, NULL, 232658),
(257627, '2o6lB00', NULL, NULL, 170, NULL, NULL, 232658),
(257628, '5ikoA01', NULL, NULL, 487, NULL, NULL, 232658),
(257629, '5ikoA02', NULL, NULL, 327, NULL, NULL, 232658),
(257630, '4amgB01', NULL, NULL, 224, NULL, NULL, 232658),
(257631, '4nesA02', NULL, NULL, 165, NULL, NULL, 232658),
(257632, '4nesA01', NULL, NULL, 209, NULL, NULL, 232658),
(257633, '2bfwA01', NULL, NULL, 189, NULL, NULL, 232658),
(257634, '2pq6A02', NULL, NULL, 177, NULL, NULL, 232658),
(257635, '3rhzA01', NULL, NULL, 182, NULL, NULL, 232658),
(257636, '6gnfB02', NULL, NULL, 216, NULL, NULL, 232658),
(257637, '5nlmA02', NULL, NULL, 198, NULL, NULL, 232658),
(257638, '5hvmA02', NULL, NULL, 208, NULL, NULL, 232658),
(257639, '3rhzA02', NULL, NULL, 157, NULL, NULL, 232658),
(257640, '6gnfB01', NULL, NULL, 328, NULL, NULL, 232658),
(257641, '5nlmA01', NULL, NULL, 266, NULL, NULL, 232658),
(257642, '4fkzA02', NULL, NULL, 161, NULL, NULL, 232658),
(257643, '3dzcA02', NULL, NULL, 170, NULL, NULL, 232658),
(257644, '2c4mA01', NULL, NULL, 462, NULL, NULL, 232658),
(257645, '4fkzA01', NULL, NULL, 227, NULL, NULL, 232658),
(257646, '3dzcA01', NULL, NULL, 203, NULL, NULL, 232658),
(257647, '2c4mA02', NULL, NULL, 334, NULL, NULL, 232658),
(257648, '3beoA02', NULL, NULL, 161, NULL, NULL, 232658),
(257649, '4gywA05', NULL, NULL, 161, NULL, NULL, 232658),
(257650, '3beoA01', NULL, NULL, 214, NULL, NULL, 232658),
(257651, '3t5tA02', NULL, NULL, 188, NULL, NULL, 232658),
(257652, '3nb0B02', NULL, NULL, 244, NULL, NULL, 232658),
(257653, '1uqtA02', NULL, NULL, 208, NULL, NULL, 232658),
(257654, '1v4vA01', NULL, NULL, 219, NULL, NULL, 232658),
(257655, '1v4vA02', NULL, NULL, 157, NULL, NULL, 232658),
(257656, '3okpA02', NULL, NULL, 189, NULL, NULL, 232658),
(257657, '1uqtA01', NULL, NULL, 248, NULL, NULL, 232658),
(257658, '3okpA01', NULL, NULL, 205, NULL, NULL, 232658),
(257659, '5i45A00', NULL, NULL, 199, NULL, NULL, 232658),
(257660, '1f0kA02', NULL, NULL, 176, NULL, NULL, 232658),
(257661, '4qlbB01', NULL, NULL, 336, NULL, NULL, 232658);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(257662, '1f0kA01', NULL, NULL, 188, NULL, NULL, 232658),
(257663, '4w6qA02', NULL, NULL, 157, NULL, NULL, 232658),
(257664, '2p6pA02', NULL, NULL, 164, NULL, NULL, 232658),
(257665, '5hvlA02', NULL, NULL, 208, NULL, NULL, 232658),
(257666, '3otgA01', NULL, NULL, 228, NULL, NULL, 232658),
(257667, '3otgA02', NULL, NULL, 167, NULL, NULL, 232658),
(257668, '2atiA01', NULL, NULL, 480, NULL, NULL, 232658),
(257669, '2pq6A01', NULL, NULL, 252, NULL, NULL, 232658),
(257670, '1rzuB01', NULL, NULL, 276, NULL, NULL, 232658),
(257671, '2yjnA02', NULL, NULL, 171, NULL, NULL, 232658),
(257672, '5hvoA02', NULL, NULL, 208, NULL, NULL, 232658),
(257673, '2gt1A01', NULL, NULL, 163, NULL, NULL, 232658),
(257674, '2gt1A02', NULL, NULL, 163, NULL, NULL, 232658),
(257675, '4rigA01', NULL, NULL, 210, NULL, NULL, 232658),
(257676, '3oy2A02', NULL, NULL, 232, NULL, NULL, 232658),
(257677, '1rrvA02', NULL, NULL, 166, NULL, NULL, 232658),
(257678, '3vueA02', NULL, NULL, 211, NULL, NULL, 232658),
(257679, '2x6rB01', NULL, NULL, 219, NULL, NULL, 232658),
(257680, '1rrvA01', NULL, NULL, 250, NULL, NULL, 232658),
(257681, '4hlnA01', NULL, NULL, 307, NULL, NULL, 232658),
(257682, '5hxaA01', NULL, NULL, 256, NULL, NULL, 232658),
(257683, '4hlnA02', NULL, NULL, 211, NULL, NULL, 232658),
(257684, '2yjnA01', NULL, NULL, 252, NULL, NULL, 232658),
(257685, '5hxaA02', NULL, NULL, 209, NULL, NULL, 232658),
(257686, '5uofA02', NULL, NULL, 209, NULL, NULL, 232658),
(257687, '1xv5A01', NULL, NULL, 191, NULL, NULL, 232658),
(257688, '5dldA02', NULL, NULL, 170, NULL, NULL, 232658),
(257689, '1xv5A02', NULL, NULL, 210, NULL, NULL, 232658),
(257690, '3t5tB01', NULL, NULL, 288, NULL, NULL, 232658),
(257691, '5dldA01', NULL, NULL, 243, NULL, NULL, 232658),
(257692, '3vueA01', NULL, NULL, 302, NULL, NULL, 232658),
(257693, '5uofA01', NULL, NULL, 257, NULL, NULL, 232658),
(257694, '2xciA02', NULL, NULL, 187, NULL, NULL, 232658),
(257695, '5tvgA02', NULL, NULL, 209, NULL, NULL, 232658),
(257696, '5tvgA01', NULL, NULL, 257, NULL, NULL, 232658),
(257697, '1ygpA02', NULL, NULL, 345, NULL, NULL, 232658),
(257698, '1ygpA01', NULL, NULL, 495, NULL, NULL, 232658),
(257699, '2iyfB02', NULL, NULL, 164, NULL, NULL, 232658),
(257700, '2jzcA00', NULL, NULL, 201, NULL, NULL, 232658),
(257701, '3qhpA00', NULL, NULL, 166, NULL, NULL, 232658),
(257702, '2jjmA01', NULL, NULL, 212, NULL, NULL, 232658),
(257703, '2acvA02', NULL, NULL, 187, NULL, NULL, 232658),
(257704, '4qlbA02', NULL, NULL, 253, NULL, NULL, 232658),
(257705, '5lqdD01', NULL, NULL, 258, NULL, NULL, 232658),
(257706, '2acvA01', NULL, NULL, 274, NULL, NULL, 232658),
(257707, '2p6pB01', NULL, NULL, 210, NULL, NULL, 232658),
(257708, '2x6qA02', NULL, NULL, 197, NULL, NULL, 232658),
(257709, '2jjmA02', NULL, NULL, 182, NULL, NULL, 232658),
(257710, '3otiA02', NULL, NULL, 158, NULL, NULL, 232658),
(257711, '3otiA01', NULL, NULL, 222, NULL, NULL, 232658),
(257712, '4rifA02', NULL, NULL, 159, NULL, NULL, 232658),
(257713, '2vchA02', NULL, NULL, 196, NULL, NULL, 232658),
(257714, '3hbmA02', NULL, NULL, 141, NULL, NULL, 232658),
(257715, '2vchA01', NULL, NULL, 269, NULL, NULL, 232658),
(257716, '5lr8A02', NULL, NULL, 333, NULL, NULL, 232658),
(257717, '6bk0A02', NULL, NULL, 192, NULL, NULL, 232658),
(257718, '3froA01', NULL, NULL, 245, NULL, NULL, 232658),
(257719, '6bk0A01', NULL, NULL, 275, NULL, NULL, 232658),
(257720, '3tovA01', NULL, NULL, 163, NULL, NULL, 232658),
(257721, '3tovA02', NULL, NULL, 186, NULL, NULL, 232658),
(257722, '1pswA02', NULL, NULL, 186, NULL, NULL, 232658),
(257723, '3rscA01', NULL, NULL, 252, NULL, NULL, 232658),
(257724, '3rscA02', NULL, NULL, 163, NULL, NULL, 232658),
(257725, '2hy7A02', NULL, NULL, 156, NULL, NULL, 232658),
(257726, '1rzuA02', NULL, NULL, 209, NULL, NULL, 232658),
(257727, '1pswA01', NULL, NULL, 151, NULL, NULL, 232658),
(257728, '3h4tA01', NULL, NULL, 240, NULL, NULL, 232658),
(257729, '3tsaA02', NULL, NULL, 177, NULL, NULL, 232658),
(257730, '3h4tA02', NULL, NULL, 164, NULL, NULL, 232658),
(257731, '3s28A03', NULL, NULL, 312, NULL, NULL, 232658),
(257732, '3s28A04', NULL, NULL, 227, NULL, NULL, 232658);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(257733, '3c48A01', NULL, NULL, 230, NULL, NULL, 232658),
(257734, '5enzA02', NULL, NULL, 161, NULL, NULL, 232658),
(257735, '3hbjA01', NULL, NULL, 277, NULL, NULL, 232658),
(257736, '3wadA02', NULL, NULL, 172, NULL, NULL, 232658),
(257737, '3nb0D01', NULL, NULL, 310, NULL, NULL, 232658),
(257738, '4n9wA02', NULL, NULL, 177, NULL, NULL, 232658),
(257739, '4pqgA03', NULL, NULL, 174, NULL, NULL, 232658),
(257740, '4n9wA01', NULL, NULL, 213, NULL, NULL, 232658),
(257741, '2c1xA02', NULL, NULL, 172, NULL, NULL, 232658),
(257742, '2qzsA02', NULL, NULL, 210, NULL, NULL, 232658),
(257743, '2qzsA01', NULL, NULL, 275, NULL, NULL, 232658),
(257744, '5v2jA02', NULL, NULL, 194, NULL, NULL, 232658),
(257745, '5d01B02', NULL, NULL, 182, NULL, NULL, 232658),
(257746, '5dxfB01', NULL, NULL, 310, NULL, NULL, 232658),
(257747, '5lqdA02', NULL, NULL, 207, NULL, NULL, 232658),
(257748, '3ot5A02', NULL, NULL, 161, NULL, NULL, 232658),
(257749, '2gj4A01', NULL, NULL, 497, NULL, NULL, 232658),
(257750, '4rifB01', NULL, NULL, 210, NULL, NULL, 232658),
(257751, '2gj4A02', NULL, NULL, 327, NULL, NULL, 232658),
(257752, '5lr8B01', NULL, NULL, 499, NULL, NULL, 232658),
(257753, '1iirA02', NULL, NULL, 164, NULL, NULL, 232658),
(257754, '2iw1A01', NULL, NULL, 188, NULL, NULL, 232658),
(257755, '2iw1A02', NULL, NULL, 186, NULL, NULL, 232658),
(257756, '1iirA01', NULL, NULL, 251, NULL, NULL, 232658),
(257757, '4rbnA03', NULL, NULL, 303, NULL, NULL, 232658),
(257758, '4rbnA04', NULL, NULL, 228, NULL, NULL, 232658),
(257759, '5v0tE01', NULL, NULL, 257, NULL, NULL, 232658),
(257760, '4bqeA01', NULL, NULL, 495, NULL, NULL, 232658),
(257761, '4bqeA02', NULL, NULL, 332, NULL, NULL, 232658),
(257762, '4l22A02', NULL, NULL, 328, NULL, NULL, 232658),
(257763, '5enzB01', NULL, NULL, 224, NULL, NULL, 232658),
(257764, '4l22A01', NULL, NULL, 430, NULL, NULL, 232658),
(257765, '3s2uA01', NULL, NULL, 187, NULL, NULL, 232658),
(257766, '5jioA02', NULL, NULL, 209, NULL, NULL, 232658),
(257767, '3wadB01', NULL, NULL, 247, NULL, NULL, 232658),
(257768, '4relA01', NULL, NULL, 268, NULL, NULL, 232658),
(257769, '4relA02', NULL, NULL, 176, NULL, NULL, 232658),
(257770, '5a01A04', NULL, NULL, 164, NULL, NULL, 232658),
(257771, '3c48B02', NULL, NULL, 190, NULL, NULL, 232658),
(257772, '4ambB02', NULL, NULL, 156, NULL, NULL, 232658),
(257773, '5d01A01', NULL, NULL, 197, NULL, NULL, 232658),
(257774, '2f9fA00', NULL, NULL, 177, NULL, NULL, 232658),
(257775, '3q3eA03', NULL, NULL, 191, NULL, NULL, 232658),
(257776, '2c1zA01', NULL, NULL, 270, NULL, NULL, 232658),
(257777, '4ldpA01', NULL, NULL, 237, NULL, NULL, 232658),
(257778, '4ldpA02', NULL, NULL, 182, NULL, NULL, 232658),
(257779, '4bfcA00', NULL, NULL, 193, NULL, NULL, 232658),
(257780, '4m83A01', NULL, NULL, 253, NULL, NULL, 232658),
(257781, '5dxfA02', NULL, NULL, 207, NULL, NULL, 232658),
(257782, '3aonA00', NULL, NULL, 201, NULL, NULL, 232659),
(257783, '3w3aG00', NULL, NULL, 210, NULL, NULL, 232659),
(257784, '3nqzA01', NULL, NULL, 96, NULL, NULL, 232660),
(257785, '3nuhB02', NULL, NULL, 121, NULL, NULL, 232661),
(257786, '2f4mB00', NULL, NULL, 61, NULL, NULL, 232662),
(257787, '1x3wB01', NULL, NULL, 51, NULL, NULL, 232662),
(257788, '1oqyA03', NULL, NULL, 58, NULL, NULL, 232662),
(257789, '2qsfX01', NULL, NULL, 55, NULL, NULL, 232662),
(257790, '1tp4A00', NULL, NULL, 68, NULL, NULL, 232662),
(257791, '1k28D02', NULL, NULL, 88, NULL, NULL, 232663),
(257792, '1wthD02', NULL, NULL, 88, NULL, NULL, 232663),
(257793, '4gk9A01', NULL, NULL, 144, NULL, NULL, 232664),
(257794, '3oblA00', NULL, NULL, 132, NULL, NULL, 232664),
(257795, '4gk9A02', NULL, NULL, 135, NULL, NULL, 232664),
(257796, '4fboA00', NULL, NULL, 133, NULL, NULL, 232664),
(257797, '4fbrA01', NULL, NULL, 133, NULL, NULL, 232664),
(257798, '4fbrA02', NULL, NULL, 134, NULL, NULL, 232664),
(257799, '3duzA02', NULL, NULL, 54, NULL, NULL, 232665),
(257800, '4fprB00', NULL, NULL, 131, NULL, NULL, 232666),
(257801, '1xiqA00', NULL, NULL, 157, NULL, NULL, 232667),
(257802, '1nhkR00', NULL, NULL, 144, NULL, NULL, 232667),
(257803, '3em1A00', NULL, NULL, 146, NULL, NULL, 232667);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(257804, '3mpdA00', NULL, NULL, 151, NULL, NULL, 232667),
(257805, '5u2iA00', NULL, NULL, 159, NULL, NULL, 232667),
(257806, '3bh7B02', NULL, NULL, 121, NULL, NULL, 232667),
(257807, '1ucnA00', NULL, NULL, 152, NULL, NULL, 232667),
(257808, '4w98A00', NULL, NULL, 145, NULL, NULL, 232667),
(257809, '1pkuA00', NULL, NULL, 150, NULL, NULL, 232667),
(257810, '5iolA00', NULL, NULL, 150, NULL, NULL, 232667),
(257811, '1zs6A00', NULL, NULL, 152, NULL, NULL, 232667),
(257812, '2hurA00', NULL, NULL, 142, NULL, NULL, 232667),
(257813, '1w7wB00', NULL, NULL, 153, NULL, NULL, 232667),
(257814, '3ztpA00', NULL, NULL, 142, NULL, NULL, 232667),
(257815, '4uohB00', NULL, NULL, 151, NULL, NULL, 232667),
(257816, '1wkjA00', NULL, NULL, 137, NULL, NULL, 232667),
(257817, '5go1A00', NULL, NULL, 151, NULL, NULL, 232667),
(257818, '3vvtA00', NULL, NULL, 139, NULL, NULL, 232667),
(257819, '4fkxB00', NULL, NULL, 161, NULL, NULL, 232667),
(257820, '3r9lA00', NULL, NULL, 155, NULL, NULL, 232667),
(257821, '3pj9D00', NULL, NULL, 140, NULL, NULL, 232667),
(257822, '3q8uA00', NULL, NULL, 157, NULL, NULL, 232667),
(257823, '3wx8C00', NULL, NULL, 153, NULL, NULL, 232667),
(257824, '3prvE00', NULL, NULL, 157, NULL, NULL, 232667),
(257825, '4c6aA00', NULL, NULL, 154, NULL, NULL, 232667),
(257826, '6agyA00', NULL, NULL, 161, NULL, NULL, 232667),
(257827, '3bbbC00', NULL, NULL, 151, NULL, NULL, 232667),
(257828, '2vu5A00', NULL, NULL, 148, NULL, NULL, 232667),
(257829, '2dxfA00', NULL, NULL, 160, NULL, NULL, 232667),
(257830, '3vgsA00', NULL, NULL, 141, NULL, NULL, 232667),
(257831, '6ay1A00', NULL, NULL, 145, NULL, NULL, 232667),
(257832, '3js9A00', NULL, NULL, 156, NULL, NULL, 232667),
(257833, '3b54A00', NULL, NULL, 161, NULL, NULL, 232667),
(257834, '6aesA00', NULL, NULL, 143, NULL, NULL, 232667),
(257835, '5x00A00', NULL, NULL, 144, NULL, NULL, 232667),
(257836, '2az3B00', NULL, NULL, 164, NULL, NULL, 232667),
(257837, '4hr2A00', NULL, NULL, 145, NULL, NULL, 232667),
(257838, '4aneA00', NULL, NULL, 136, NULL, NULL, 232667),
(257839, '1xqiA00', NULL, NULL, 195, NULL, NULL, 232667),
(257840, '3gp9A00', NULL, NULL, 142, NULL, NULL, 232667),
(257841, '4kpcA00', NULL, NULL, 150, NULL, NULL, 232667),
(257842, '1ehwA00', NULL, NULL, 143, NULL, NULL, 232667),
(257843, '3ngsB00', NULL, NULL, 151, NULL, NULL, 232667),
(257844, '2zuaB00', NULL, NULL, 152, NULL, NULL, 232667),
(257845, '4dz6A00', NULL, NULL, 168, NULL, NULL, 232667),
(257846, '1s57B00', NULL, NULL, 153, NULL, NULL, 232667),
(257847, '3vvuA00', NULL, NULL, 139, NULL, NULL, 232667),
(257848, '5bxiC00', NULL, NULL, 160, NULL, NULL, 232667),
(257849, '1be4A00', NULL, NULL, 151, NULL, NULL, 232667),
(257850, '1nb2A00', NULL, NULL, 150, NULL, NULL, 232667),
(257851, '1vyaA00', NULL, NULL, 149, NULL, NULL, 232667),
(257852, '1u8wA00', NULL, NULL, 149, NULL, NULL, 232667),
(257853, '5v6dF00', NULL, NULL, 149, NULL, NULL, 232667),
(257854, '4irvA00', NULL, NULL, 221, NULL, NULL, 232668),
(257855, '3kcnA00', NULL, NULL, 151, NULL, NULL, 232669),
(257856, '1peaA02', NULL, NULL, 186, NULL, NULL, 232669),
(257857, '3rotA01', NULL, NULL, 137, NULL, NULL, 232669),
(257858, '4irxA02', NULL, NULL, 162, NULL, NULL, 232669),
(257859, '3rotA02', NULL, NULL, 137, NULL, NULL, 232669),
(257860, '2a9oA00', NULL, NULL, 120, NULL, NULL, 232669),
(257861, '4irxA01', NULL, NULL, 134, NULL, NULL, 232669),
(257862, '3grcA00', NULL, NULL, 140, NULL, NULL, 232669),
(257863, '2r48A00', NULL, NULL, 106, NULL, NULL, 232669),
(257864, '1peaA01', NULL, NULL, 199, NULL, NULL, 232669),
(257865, '8abpA01', NULL, NULL, 139, NULL, NULL, 232669),
(257866, '5hkoA01', NULL, NULL, 166, NULL, NULL, 232669),
(257867, '3ctpA01', NULL, NULL, 128, NULL, NULL, 232669),
(257868, '1dcfA00', NULL, NULL, 136, NULL, NULL, 232669),
(257869, '3ctpA02', NULL, NULL, 143, NULL, NULL, 232669),
(257870, '5hkoA02', NULL, NULL, 150, NULL, NULL, 232669),
(257871, '4n0pA00', NULL, NULL, 151, NULL, NULL, 232669),
(257872, '3kkeB01', NULL, NULL, 147, NULL, NULL, 232669),
(257873, '5dleA00', NULL, NULL, 113, NULL, NULL, 232669),
(257874, '8abpA02', NULL, NULL, 167, NULL, NULL, 232669);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(257875, '4m88A02', NULL, NULL, 143, NULL, NULL, 232669),
(257876, '6br7B00', NULL, NULL, 133, NULL, NULL, 232669),
(257877, '4m88A01', NULL, NULL, 214, NULL, NULL, 232669),
(257878, '3czcA00', NULL, NULL, 93, NULL, NULL, 232669),
(257879, '3n75A01', NULL, NULL, 129, NULL, NULL, 232669),
(257880, '2qvcD01', NULL, NULL, 149, NULL, NULL, 232669),
(257881, '1i3cA00', NULL, NULL, 149, NULL, NULL, 232669),
(257882, '3h5lA01', NULL, NULL, 244, NULL, NULL, 232669),
(257883, '2wjwA02', NULL, NULL, 177, NULL, NULL, 232669),
(257884, '3h5lA02', NULL, NULL, 175, NULL, NULL, 232669),
(257885, '2wjwA01', NULL, NULL, 211, NULL, NULL, 232669),
(257886, '3gbvA01', NULL, NULL, 146, NULL, NULL, 232669),
(257887, '3gbvA02', NULL, NULL, 158, NULL, NULL, 232669),
(257888, '2n9uA00', NULL, NULL, 129, NULL, NULL, 232669),
(257889, '3hdgA00', NULL, NULL, 137, NULL, NULL, 232669),
(257890, '3gybA02', NULL, NULL, 146, NULL, NULL, 232669),
(257891, '3gybA01', NULL, NULL, 134, NULL, NULL, 232669),
(257892, '2rgyA02', NULL, NULL, 135, NULL, NULL, 232669),
(257893, '3ckmA02', NULL, NULL, 148, NULL, NULL, 232669),
(257894, '2rgyA01', NULL, NULL, 131, NULL, NULL, 232669),
(257895, '3ckmA01', NULL, NULL, 179, NULL, NULL, 232669),
(257896, '2h0aA01', NULL, NULL, 127, NULL, NULL, 232669),
(257897, '3luaA00', NULL, NULL, 140, NULL, NULL, 232669),
(257898, '3eodA00', NULL, NULL, 130, NULL, NULL, 232669),
(257899, '2h0aA02', NULL, NULL, 139, NULL, NULL, 232669),
(257900, '1yvuA03', NULL, NULL, 174, NULL, NULL, 232669),
(257901, '4wwhA02', NULL, NULL, 181, NULL, NULL, 232669),
(257902, '4wwhA01', NULL, NULL, 148, NULL, NULL, 232669),
(257903, '3w9sB00', NULL, NULL, 131, NULL, NULL, 232669),
(257904, '4nicA00', NULL, NULL, 128, NULL, NULL, 232669),
(257905, '4q6bA02', NULL, NULL, 147, NULL, NULL, 232669),
(257906, '3egcA01', NULL, NULL, 139, NULL, NULL, 232669),
(257907, '2r25B00', NULL, NULL, 133, NULL, NULL, 232669),
(257908, '4q6bA01', NULL, NULL, 209, NULL, NULL, 232669),
(257909, '3jy6A01', NULL, NULL, 133, NULL, NULL, 232669),
(257910, '3h1gA00', NULL, NULL, 129, NULL, NULL, 232669),
(257911, '3qk7C02', NULL, NULL, 152, NULL, NULL, 232669),
(257912, '3kkeA02', NULL, NULL, 158, NULL, NULL, 232669),
(257913, '1jdpB02', NULL, NULL, 221, NULL, NULL, 232669),
(257914, '4rk1A02', NULL, NULL, 140, NULL, NULL, 232669),
(257915, '1k68A00', NULL, NULL, 140, NULL, NULL, 232669),
(257916, '5dteA02', NULL, NULL, 153, NULL, NULL, 232669),
(257917, '4p98A01', NULL, NULL, 144, NULL, NULL, 232669),
(257918, '4p98A02', NULL, NULL, 155, NULL, NULL, 232669),
(257919, '3t95A01', NULL, NULL, 161, NULL, NULL, 232669),
(257920, '2r47A01', NULL, NULL, 138, NULL, NULL, 232669),
(257921, '5wq0D00', NULL, NULL, 129, NULL, NULL, 232669),
(257922, '3t95A02', NULL, NULL, 153, NULL, NULL, 232669),
(257923, '1jx6A02', NULL, NULL, 151, NULL, NULL, 232669),
(257924, '1jx6A01', NULL, NULL, 185, NULL, NULL, 232669),
(257925, '1vkrA00', NULL, NULL, 107, NULL, NULL, 232669),
(257926, '1dz3A00', NULL, NULL, 130, NULL, NULL, 232669),
(257927, '3hutA01', NULL, NULL, 198, NULL, NULL, 232669),
(257928, '1u2pA00', NULL, NULL, 163, NULL, NULL, 232669),
(257929, '3hutA02', NULL, NULL, 160, NULL, NULL, 232669),
(257930, '2jk1A00', NULL, NULL, 139, NULL, NULL, 232669),
(257931, '3eq2B01', NULL, NULL, 110, NULL, NULL, 232669),
(257932, '4kv7A02', NULL, NULL, 158, NULL, NULL, 232669),
(257933, '4kv7A01', NULL, NULL, 223, NULL, NULL, 232669),
(257934, '3h5vA02', NULL, NULL, 175, NULL, NULL, 232669),
(257935, '1p6qA00', NULL, NULL, 129, NULL, NULL, 232669),
(257936, '3n53A00', NULL, NULL, 140, NULL, NULL, 232669),
(257937, '5dclA00', NULL, NULL, 120, NULL, NULL, 232669),
(257938, '4rweA01', NULL, NULL, 131, NULL, NULL, 232669),
(257939, '4rweA02', NULL, NULL, 161, NULL, NULL, 232669),
(257940, '5bq3C01', NULL, NULL, 157, NULL, NULL, 232669),
(257941, '2x7xA01', NULL, NULL, 135, NULL, NULL, 232669),
(257942, '4maaA01', NULL, NULL, 203, NULL, NULL, 232669),
(257943, '4maaA02', NULL, NULL, 171, NULL, NULL, 232669),
(257944, '1xhfA00', NULL, NULL, 123, NULL, NULL, 232669),
(257945, '5xx1A01', NULL, NULL, 140, NULL, NULL, 232669);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(257946, '4etnA00', NULL, NULL, 151, NULL, NULL, 232669),
(257947, '4evqA01', NULL, NULL, 216, NULL, NULL, 232669),
(257948, '3lftA01', NULL, NULL, 149, NULL, NULL, 232669),
(257949, '4evqA02', NULL, NULL, 159, NULL, NULL, 232669),
(257950, '2x7xA02', NULL, NULL, 138, NULL, NULL, 232669),
(257951, '2wb4B01', NULL, NULL, 288, NULL, NULL, 232669),
(257952, '3huuC02', NULL, NULL, 147, NULL, NULL, 232669),
(257953, '2gwrA01', NULL, NULL, 125, NULL, NULL, 232669),
(257954, '5ibqA01', NULL, NULL, 134, NULL, NULL, 232669),
(257955, '3jy6D02', NULL, NULL, 143, NULL, NULL, 232669),
(257956, '3n0xA01', NULL, NULL, 210, NULL, NULL, 232669),
(257957, '3e61B01', NULL, NULL, 119, NULL, NULL, 232669),
(257958, '4mldA00', NULL, NULL, 143, NULL, NULL, 232669),
(257959, '4kzkA02', NULL, NULL, 165, NULL, NULL, 232669),
(257960, '4kzkA01', NULL, NULL, 136, NULL, NULL, 232669),
(257961, '1k66A00', NULL, NULL, 149, NULL, NULL, 232669),
(257962, '3kloA01', NULL, NULL, 144, NULL, NULL, 232669),
(257963, '6fpjC01', NULL, NULL, 220, NULL, NULL, 232669),
(257964, '6fpjC02', NULL, NULL, 170, NULL, NULL, 232669),
(257965, '4dadA01', NULL, NULL, 128, NULL, NULL, 232669),
(257966, '3eulB00', NULL, NULL, 136, NULL, NULL, 232669),
(257967, '5dteB01', NULL, NULL, 134, NULL, NULL, 232669),
(257968, '3hzhA00', NULL, NULL, 134, NULL, NULL, 232669),
(257969, '3ks9B02', NULL, NULL, 184, NULL, NULL, 232669),
(257970, '3ks9B01', NULL, NULL, 312, NULL, NULL, 232669),
(257971, '3cg0A00', NULL, NULL, 140, NULL, NULL, 232669),
(257972, '1dbqA02', NULL, NULL, 147, NULL, NULL, 232669),
(257973, '2qvcB01', NULL, NULL, 149, NULL, NULL, 232669),
(257974, '1dbqA01', NULL, NULL, 141, NULL, NULL, 232669),
(257975, '3m9wA01', NULL, NULL, 145, NULL, NULL, 232669),
(257976, '3m9wA02', NULL, NULL, 168, NULL, NULL, 232669),
(257977, '3k4hA02', NULL, NULL, 146, NULL, NULL, 232669),
(257978, '1qkkA00', NULL, NULL, 155, NULL, NULL, 232669),
(257979, '2qsjB00', NULL, NULL, 132, NULL, NULL, 232669),
(257980, '1zy2A00', NULL, NULL, 150, NULL, NULL, 232669),
(257981, '2m1zA00', NULL, NULL, 106, NULL, NULL, 232669),
(257982, '4yo7A01', NULL, NULL, 130, NULL, NULL, 232669),
(257983, '4rv5A01', NULL, NULL, 209, NULL, NULL, 232669),
(257984, '2pl1A00', NULL, NULL, 121, NULL, NULL, 232669),
(257985, '3lftB02', NULL, NULL, 147, NULL, NULL, 232669),
(257986, '4yo7A02', NULL, NULL, 156, NULL, NULL, 232669),
(257987, '4rv5A02', NULL, NULL, 155, NULL, NULL, 232669),
(257988, '3q7rA00', NULL, NULL, 121, NULL, NULL, 232669),
(257989, '2p4uA00', NULL, NULL, 168, NULL, NULL, 232669),
(257990, '3huuD01', NULL, NULL, 138, NULL, NULL, 232669),
(257991, '3n0wA01', NULL, NULL, 209, NULL, NULL, 232669),
(257992, '3n0wA02', NULL, NULL, 132, NULL, NULL, 232669),
(257993, '4ldaB00', NULL, NULL, 131, NULL, NULL, 232669),
(257994, '5gqsA00', NULL, NULL, 92, NULL, NULL, 232669),
(257995, '3b2nA00', NULL, NULL, 133, NULL, NULL, 232669),
(257996, '3kjxA02', NULL, NULL, 133, NULL, NULL, 232669),
(257997, '3snkA00', NULL, NULL, 135, NULL, NULL, 232669),
(257998, '2qxyA00', NULL, NULL, 121, NULL, NULL, 232669),
(257999, '2l2qA00', NULL, NULL, 109, NULL, NULL, 232669),
(258000, '3kjxA03', NULL, NULL, 143, NULL, NULL, 232669),
(258001, '2qvcC01', NULL, NULL, 149, NULL, NULL, 232669),
(258002, '2cwdA00', NULL, NULL, 161, NULL, NULL, 232669),
(258003, '1srrC00', NULL, NULL, 124, NULL, NULL, 232669),
(258004, '3jteA00', NULL, NULL, 143, NULL, NULL, 232669),
(258005, '1sxhA01', NULL, NULL, 140, NULL, NULL, 232669),
(258006, '3uugA02', NULL, NULL, 181, NULL, NULL, 232669),
(258007, '3uugA01', NULL, NULL, 149, NULL, NULL, 232669),
(258008, '3e3mA01', NULL, NULL, 133, NULL, NULL, 232669),
(258009, '3e3mA02', NULL, NULL, 152, NULL, NULL, 232669),
(258010, '3lmkA01', NULL, NULL, 313, NULL, NULL, 232669),
(258011, '3crnA00', NULL, NULL, 132, NULL, NULL, 232669),
(258012, '4kvfA01', NULL, NULL, 160, NULL, NULL, 232669),
(258013, '4kvfA02', NULL, NULL, 154, NULL, NULL, 232669),
(258014, '5m7oA01', NULL, NULL, 134, NULL, NULL, 232669),
(258015, '3lmkA02', NULL, NULL, 179, NULL, NULL, 232669),
(258016, '4n0qA01', NULL, NULL, 210, NULL, NULL, 232669);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(258017, '3o1iD02', NULL, NULL, 161, NULL, NULL, 232669),
(258018, '2b4aA00', NULL, NULL, 138, NULL, NULL, 232669),
(258019, '4n0qA02', NULL, NULL, 144, NULL, NULL, 232669),
(258020, '1mb3A00', NULL, NULL, 124, NULL, NULL, 232669),
(258021, '3sy8A01', NULL, NULL, 139, NULL, NULL, 232669),
(258022, '4o1iD00', NULL, NULL, 118, NULL, NULL, 232669),
(258023, '3h5oA02', NULL, NULL, 150, NULL, NULL, 232669),
(258024, '2qzjA00', NULL, NULL, 136, NULL, NULL, 232669),
(258025, '3ilhA00', NULL, NULL, 146, NULL, NULL, 232669),
(258026, '3ktoA00', NULL, NULL, 136, NULL, NULL, 232669),
(258027, '3h5oA01', NULL, NULL, 127, NULL, NULL, 232669),
(258028, '3mizA01', NULL, NULL, 146, NULL, NULL, 232669),
(258029, '4ycsA00', NULL, NULL, 128, NULL, NULL, 232669),
(258030, '3f6pA00', NULL, NULL, 120, NULL, NULL, 232669),
(258031, '2qu7A01', NULL, NULL, 135, NULL, NULL, 232669),
(258032, '2qu7A02', NULL, NULL, 138, NULL, NULL, 232669),
(258033, '3s99A02', NULL, NULL, 195, NULL, NULL, 232669),
(258034, '4yleA02', NULL, NULL, 147, NULL, NULL, 232669),
(258035, '2yhaA01', NULL, NULL, 143, NULL, NULL, 232669),
(258036, '4wzzA01', NULL, NULL, 162, NULL, NULL, 232669),
(258037, '4yleA01', NULL, NULL, 137, NULL, NULL, 232669),
(258038, '3s99A01', NULL, NULL, 136, NULL, NULL, 232669),
(258039, '3nndA02', NULL, NULL, 155, NULL, NULL, 232669),
(258040, '3nndA01', NULL, NULL, 211, NULL, NULL, 232669),
(258041, '3k9cA02', NULL, NULL, 150, NULL, NULL, 232669),
(258042, '4wzzA02', NULL, NULL, 159, NULL, NULL, 232669),
(258043, '4rk1D01', NULL, NULL, 140, NULL, NULL, 232669),
(258044, '3olzB02', NULL, NULL, 185, NULL, NULL, 232669),
(258045, '4etmB00', NULL, NULL, 173, NULL, NULL, 232669),
(258046, '1y1lA00', NULL, NULL, 124, NULL, NULL, 232669),
(258047, '3jvdA02', NULL, NULL, 144, NULL, NULL, 232669),
(258048, '1yioA01', NULL, NULL, 141, NULL, NULL, 232669),
(258049, '3cg4A00', NULL, NULL, 142, NULL, NULL, 232669),
(258050, '2r4qA00', NULL, NULL, 106, NULL, NULL, 232669),
(258051, '3ipcA02', NULL, NULL, 156, NULL, NULL, 232669),
(258052, '1gcaA01', NULL, NULL, 148, NULL, NULL, 232669),
(258053, '3o1iC01', NULL, NULL, 143, NULL, NULL, 232669),
(258054, '3ipcA01', NULL, NULL, 200, NULL, NULL, 232669),
(258055, '1gcaA02', NULL, NULL, 161, NULL, NULL, 232669),
(258056, '6bgdA02', NULL, NULL, 182, NULL, NULL, 232669),
(258057, '1zgzA00', NULL, NULL, 122, NULL, NULL, 232669),
(258058, '4mptA01', NULL, NULL, 231, NULL, NULL, 232669),
(258059, '4mptA02', NULL, NULL, 149, NULL, NULL, 232669),
(258060, '4rk0D01', NULL, NULL, 140, NULL, NULL, 232669),
(258061, '3mizB02', NULL, NULL, 155, NULL, NULL, 232669),
(258062, '2hqbA02', NULL, NULL, 156, NULL, NULL, 232669),
(258063, '3i09A01', NULL, NULL, 205, NULL, NULL, 232669),
(258064, '1p8aA00', NULL, NULL, 146, NULL, NULL, 232669),
(258065, '3i09A02', NULL, NULL, 132, NULL, NULL, 232669),
(258066, '2hqbA01', NULL, NULL, 140, NULL, NULL, 232669),
(258067, '6ekgY00', NULL, NULL, 123, NULL, NULL, 232669),
(258068, '2j48A00', NULL, NULL, 119, NULL, NULL, 232669),
(258069, '3nnnA00', NULL, NULL, 122, NULL, NULL, 232669),
(258070, '4kreA03', NULL, NULL, 170, NULL, NULL, 232669),
(258071, '3c3mA00', NULL, NULL, 138, NULL, NULL, 232669),
(258072, '4f06A01', NULL, NULL, 200, NULL, NULL, 232669),
(258073, '4dn6A01', NULL, NULL, 128, NULL, NULL, 232669),
(258074, '4q7eA00', NULL, NULL, 129, NULL, NULL, 232669),
(258075, '4f06A02', NULL, NULL, 171, NULL, NULL, 232669),
(258076, '2fekA00', NULL, NULL, 147, NULL, NULL, 232669),
(258077, '5ix8A01', NULL, NULL, 159, NULL, NULL, 232669),
(258078, '5iebA00', NULL, NULL, 130, NULL, NULL, 232669),
(258079, '5ix8A02', NULL, NULL, 162, NULL, NULL, 232669),
(258080, '3k9cB01', NULL, NULL, 139, NULL, NULL, 232669),
(258081, '3brsA01', NULL, NULL, 141, NULL, NULL, 232669),
(258082, '3brsA02', NULL, NULL, 148, NULL, NULL, 232669),
(258083, '4wxmB00', NULL, NULL, 143, NULL, NULL, 232669),
(258084, '2qr3A00', NULL, NULL, 140, NULL, NULL, 232669),
(258085, '4kq9A02', NULL, NULL, 201, NULL, NULL, 232669),
(258086, '2e4uA02', NULL, NULL, 173, NULL, NULL, 232669),
(258087, '2qvcA01', NULL, NULL, 149, NULL, NULL, 232669);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(258088, '3n0xA02', NULL, NULL, 164, NULL, NULL, 232669),
(258089, '4kq9A01', NULL, NULL, 98, NULL, NULL, 232669),
(258090, '3fmvH01', NULL, NULL, 139, NULL, NULL, 232669),
(258091, '5ibqA02', NULL, NULL, 154, NULL, NULL, 232669),
(258092, '4p1zA00', NULL, NULL, 128, NULL, NULL, 232669),
(258093, '3jvdB01', NULL, NULL, 126, NULL, NULL, 232669),
(258094, '1d1qB00', NULL, NULL, 161, NULL, NULL, 232669),
(258095, '1usgA01', NULL, NULL, 201, NULL, NULL, 232669),
(258096, '3k4hB01', NULL, NULL, 146, NULL, NULL, 232669),
(258097, '1usgA02', NULL, NULL, 144, NULL, NULL, 232669),
(258098, '3ukjA01', NULL, NULL, 209, NULL, NULL, 232669),
(258099, '2iksB02', NULL, NULL, 180, NULL, NULL, 232669),
(258100, '1a04A01', NULL, NULL, 127, NULL, NULL, 232669),
(258101, '4egsA00', NULL, NULL, 147, NULL, NULL, 232669),
(258102, '3ukjA02', NULL, NULL, 153, NULL, NULL, 232669),
(258103, '2gi4A00', NULL, NULL, 156, NULL, NULL, 232669),
(258104, '3hv2A00', NULL, NULL, 153, NULL, NULL, 232669),
(258105, '3lucA01', NULL, NULL, 129, NULL, NULL, 232669),
(258106, '4o1hA00', NULL, NULL, 139, NULL, NULL, 232669),
(258107, '3h6gA01', NULL, NULL, 210, NULL, NULL, 232669),
(258108, '5x5jA00', NULL, NULL, 137, NULL, NULL, 232669),
(258109, '3h6gA02', NULL, NULL, 179, NULL, NULL, 232669),
(258110, '3hsyA01', NULL, NULL, 211, NULL, NULL, 232669),
(258111, '3cz5C00', NULL, NULL, 153, NULL, NULL, 232669),
(258112, '4rk0A02', NULL, NULL, 134, NULL, NULL, 232669),
(258113, '3hsyA02', NULL, NULL, 165, NULL, NULL, 232669),
(258114, '3i09B01', NULL, NULL, 206, NULL, NULL, 232669),
(258115, '5kwsA01', NULL, NULL, 153, NULL, NULL, 232669),
(258116, '5kwsA02', NULL, NULL, 160, NULL, NULL, 232669),
(258117, '2rjoA01', NULL, NULL, 151, NULL, NULL, 232669),
(258118, '4rxtA02', NULL, NULL, 162, NULL, NULL, 232669),
(258119, '1jdpA01', NULL, NULL, 179, NULL, NULL, 232669),
(258120, '4rxtA01', NULL, NULL, 137, NULL, NULL, 232669),
(258121, '2rjoA02', NULL, NULL, 181, NULL, NULL, 232669),
(258122, '4h60A00', NULL, NULL, 120, NULL, NULL, 232669),
(258123, '4kqcA01', NULL, NULL, 159, NULL, NULL, 232669),
(258124, '4kqcA02', NULL, NULL, 160, NULL, NULL, 232669),
(258125, '4rkrB01', NULL, NULL, 143, NULL, NULL, 232669),
(258126, '3c3wA01', NULL, NULL, 98, NULL, NULL, 232669),
(258127, '4qpjD00', NULL, NULL, 121, NULL, NULL, 232669),
(258128, '3fmvG01', NULL, NULL, 139, NULL, NULL, 232669),
(258129, '2q5cA01', NULL, NULL, 106, NULL, NULL, 232669),
(258130, '4y9tA02', NULL, NULL, 176, NULL, NULL, 232669),
(258131, '4y9tA01', NULL, NULL, 145, NULL, NULL, 232669),
(258132, '2ioyA01', NULL, NULL, 125, NULL, NULL, 232669),
(258133, '2ioyA02', NULL, NULL, 158, NULL, NULL, 232669),
(258134, '2iksA01', NULL, NULL, 96, NULL, NULL, 232669),
(258135, '1tjyA02', NULL, NULL, 153, NULL, NULL, 232669),
(258136, '1tjyA01', NULL, NULL, 163, NULL, NULL, 232669),
(258137, '3sg0A01', NULL, NULL, 209, NULL, NULL, 232669),
(258138, '3t38A02', NULL, NULL, 134, NULL, NULL, 232669),
(258139, '3sg0A02', NULL, NULL, 153, NULL, NULL, 232669),
(258140, '4l4uA01', NULL, NULL, 145, NULL, NULL, 232669),
(258141, '5tqjA00', NULL, NULL, 136, NULL, NULL, 232669),
(258142, '3dzdA01', NULL, NULL, 121, NULL, NULL, 232669),
(258143, '4g0oA00', NULL, NULL, 139, NULL, NULL, 232669),
(258144, '4eygA02', NULL, NULL, 170, NULL, NULL, 232669),
(258145, '2wrzA01', NULL, NULL, 139, NULL, NULL, 232669),
(258146, '5c5cA01', NULL, NULL, 303, NULL, NULL, 232669),
(258147, '4eygA01', NULL, NULL, 198, NULL, NULL, 232669),
(258148, '4b09A01', NULL, NULL, 126, NULL, NULL, 232669),
(258149, '5c5cA02', NULL, NULL, 178, NULL, NULL, 232669),
(258150, '3qk7A01', NULL, NULL, 142, NULL, NULL, 232669),
(258151, '4d74A00', NULL, NULL, 151, NULL, NULL, 232669),
(258152, '2w42B01', NULL, NULL, 172, NULL, NULL, 232669),
(258153, '5hqjA02', NULL, NULL, 150, NULL, NULL, 232669),
(258154, '5hqjA01', NULL, NULL, 138, NULL, NULL, 232669),
(258155, '4pevA01', NULL, NULL, 131, NULL, NULL, 232669),
(258156, '2nt4A00', NULL, NULL, 127, NULL, NULL, 232669),
(258157, '4rkrD02', NULL, NULL, 151, NULL, NULL, 232669),
(258158, '6dspA02', NULL, NULL, 164, NULL, NULL, 232669);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(258159, '5uxwA02', NULL, NULL, 138, NULL, NULL, 232669),
(258160, '3fmvF01', NULL, NULL, 139, NULL, NULL, 232669),
(258161, '6dspA01', NULL, NULL, 162, NULL, NULL, 232669),
(258162, '3olzA01', NULL, NULL, 213, NULL, NULL, 232669),
(258163, '2nzuG01', NULL, NULL, 140, NULL, NULL, 232669),
(258164, '3lopA02', NULL, NULL, 149, NULL, NULL, 232669),
(258165, '3a0uA00', NULL, NULL, 116, NULL, NULL, 232669),
(258166, '3lopA01', NULL, NULL, 214, NULL, NULL, 232669),
(258167, '2fqxA01', NULL, NULL, 133, NULL, NULL, 232669),
(258168, '4rxuA02', NULL, NULL, 193, NULL, NULL, 232669),
(258169, '5vm9A03', NULL, NULL, 170, NULL, NULL, 232669),
(258170, '3sajB02', NULL, NULL, 166, NULL, NULL, 232669),
(258171, '3sajB01', NULL, NULL, 218, NULL, NULL, 232669),
(258172, '3om0A02', NULL, NULL, 161, NULL, NULL, 232669),
(258173, '4rxuA01', NULL, NULL, 147, NULL, NULL, 232669),
(258174, '5lnnA00', NULL, NULL, 169, NULL, NULL, 232669),
(258175, '3lkvA02', NULL, NULL, 146, NULL, NULL, 232669),
(258176, '4ru1A01', NULL, NULL, 140, NULL, NULL, 232669),
(258177, '2fqxA02', NULL, NULL, 185, NULL, NULL, 232669),
(258178, '3om0A01', NULL, NULL, 214, NULL, NULL, 232669),
(258179, '3lkvA01', NULL, NULL, 156, NULL, NULL, 232669),
(258180, '4ru1A02', NULL, NULL, 148, NULL, NULL, 232669),
(258181, '3ejwA02', NULL, NULL, 154, NULL, NULL, 232669),
(258182, '3tx6A02', NULL, NULL, 153, NULL, NULL, 232669),
(258183, '2mswA00', NULL, NULL, 125, NULL, NULL, 232669),
(258184, '4h3kE01', NULL, NULL, 134, NULL, NULL, 232669),
(258185, '3ejwA01', NULL, NULL, 161, NULL, NULL, 232669),
(258186, '3tx6A01', NULL, NULL, 209, NULL, NULL, 232669),
(258187, '5jntA00', NULL, NULL, 160, NULL, NULL, 232669),
(258188, '1gudA02', NULL, NULL, 149, NULL, NULL, 232669),
(258189, '1gudA01', NULL, NULL, 139, NULL, NULL, 232669),
(258190, '3breB01', NULL, NULL, 155, NULL, NULL, 232669),
(258191, '3t6kA00', NULL, NULL, 136, NULL, NULL, 232669),
(258192, '3fdfA01', NULL, NULL, 139, NULL, NULL, 232669),
(258193, '3i42A00', NULL, NULL, 127, NULL, NULL, 232669),
(258194, '3c3kA02', NULL, NULL, 145, NULL, NULL, 232669),
(258195, '4ywhA01', NULL, NULL, 145, NULL, NULL, 232669),
(258196, '4ms4A02', NULL, NULL, 193, NULL, NULL, 232669),
(258197, '4ms4A01', NULL, NULL, 227, NULL, NULL, 232669),
(258198, '4joqA01', NULL, NULL, 141, NULL, NULL, 232669),
(258199, '4joqA02', NULL, NULL, 155, NULL, NULL, 232669),
(258200, '1u8tB00', NULL, NULL, 128, NULL, NULL, 232669),
(258201, '4gnrA01', NULL, NULL, 206, NULL, NULL, 232669),
(258202, '3uk0A02', NULL, NULL, 153, NULL, NULL, 232669),
(258203, '3tb6A01', NULL, NULL, 152, NULL, NULL, 232669),
(258204, '3uk0A01', NULL, NULL, 209, NULL, NULL, 232669),
(258205, '4eukA00', NULL, NULL, 153, NULL, NULL, 232669),
(258206, '4gnrA02', NULL, NULL, 147, NULL, NULL, 232669),
(258207, '3fmvE01', NULL, NULL, 139, NULL, NULL, 232669),
(258208, '2v0nA02', NULL, NULL, 146, NULL, NULL, 232669),
(258209, '1p2fA01', NULL, NULL, 119, NULL, NULL, 232669),
(258210, '3cnbA00', NULL, NULL, 143, NULL, NULL, 232669),
(258211, '4z0nA01', NULL, NULL, 148, NULL, NULL, 232669),
(258212, '4z0nA02', NULL, NULL, 159, NULL, NULL, 232669),
(258213, '2rjnA00', NULL, NULL, 138, NULL, NULL, 232669),
(258214, '1dp4C02', NULL, NULL, 210, NULL, NULL, 232669),
(258215, '3kyjB00', NULL, NULL, 145, NULL, NULL, 232669),
(258216, '1zh2A00', NULL, NULL, 121, NULL, NULL, 232669),
(258217, '5ufhA02', NULL, NULL, 154, NULL, NULL, 232669),
(258218, '1e6mA00', NULL, NULL, 128, NULL, NULL, 232669),
(258219, '3sm9A02', NULL, NULL, 175, NULL, NULL, 232669),
(258220, '2qv0A00', NULL, NULL, 143, NULL, NULL, 232669),
(258221, '3lufB01', NULL, NULL, 123, NULL, NULL, 232669),
(258222, '3f6cA00', NULL, NULL, 134, NULL, NULL, 232669),
(258223, '3lufB02', NULL, NULL, 136, NULL, NULL, 232669),
(258224, '4ywhB02', NULL, NULL, 164, NULL, NULL, 232669),
(258225, '4hyeA01', NULL, NULL, 131, NULL, NULL, 232669),
(258226, '3c3kB01', NULL, NULL, 140, NULL, NULL, 232669),
(258227, '4ry8C02', NULL, NULL, 166, NULL, NULL, 232669),
(258228, '5ic5A00', NULL, NULL, 166, NULL, NULL, 232669),
(258229, '4wutA02', NULL, NULL, 152, NULL, NULL, 232669);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(258230, '4xaqB01', NULL, NULL, 294, NULL, NULL, 232669),
(258231, '4wutA01', NULL, NULL, 138, NULL, NULL, 232669),
(258232, '1jl3A00', NULL, NULL, 139, NULL, NULL, 232669),
(258233, '3nhmA00', NULL, NULL, 133, NULL, NULL, 232669),
(258234, '3tb6B02', NULL, NULL, 146, NULL, NULL, 232669),
(258235, '3brqB02', NULL, NULL, 145, NULL, NULL, 232669),
(258236, '3brqB01', NULL, NULL, 132, NULL, NULL, 232669),
(258237, '4kmrA02', NULL, NULL, 146, NULL, NULL, 232669),
(258238, '3cs3A01', NULL, NULL, 131, NULL, NULL, 232669),
(258239, '3lkbA01', NULL, NULL, 217, NULL, NULL, 232669),
(258240, '4kmrA01', NULL, NULL, 133, NULL, NULL, 232669),
(258241, '3cs3A02', NULL, NULL, 146, NULL, NULL, 232669),
(258242, '3lkbA02', NULL, NULL, 175, NULL, NULL, 232669),
(258243, '3fmvD01', NULL, NULL, 139, NULL, NULL, 232669),
(258244, '4ja2A00', NULL, NULL, 122, NULL, NULL, 232669),
(258245, '1r8jB01', NULL, NULL, 162, NULL, NULL, 232669),
(258246, '3p9yA01', NULL, NULL, 142, NULL, NULL, 232669),
(258247, '1s8nA01', NULL, NULL, 142, NULL, NULL, 232669),
(258248, '3vnbA00', NULL, NULL, 155, NULL, NULL, 232669),
(258249, '3lteD00', NULL, NULL, 132, NULL, NULL, 232669),
(258250, '1xwwA00', NULL, NULL, 157, NULL, NULL, 232669),
(258251, '2jbaA00', NULL, NULL, 127, NULL, NULL, 232669),
(258252, '3q9sA01', NULL, NULL, 121, NULL, NULL, 232669),
(258253, '4xltA00', NULL, NULL, 133, NULL, NULL, 232669),
(258254, '3h75A02', NULL, NULL, 139, NULL, NULL, 232669),
(258255, '4g0xA00', NULL, NULL, 147, NULL, NULL, 232669),
(258256, '4tn5A00', NULL, NULL, 113, NULL, NULL, 232669),
(258257, '1dbwB00', NULL, NULL, 126, NULL, NULL, 232669),
(258258, '2hsgA03', NULL, NULL, 143, NULL, NULL, 232669),
(258259, '3rh0B00', NULL, NULL, 129, NULL, NULL, 232669),
(258260, '3o74A02', NULL, NULL, 177, NULL, NULL, 232669),
(258261, '3o74A01', NULL, NULL, 95, NULL, NULL, 232669),
(258262, '4g0mA00', NULL, NULL, 150, NULL, NULL, 232669),
(258263, '3fdfC01', NULL, NULL, 139, NULL, NULL, 232669),
(258264, '4g97A02', NULL, NULL, 132, NULL, NULL, 232669),
(258265, '4o5aA02', NULL, NULL, 140, NULL, NULL, 232669),
(258266, '1dc7A00', NULL, NULL, 124, NULL, NULL, 232669),
(258267, '4xxhA01', NULL, NULL, 138, NULL, NULL, 232669),
(258268, '3h75A01', NULL, NULL, 211, NULL, NULL, 232669),
(258269, '4xxhA02', NULL, NULL, 117, NULL, NULL, 232669),
(258270, '4xaqA02', NULL, NULL, 185, NULL, NULL, 232669),
(258271, '4o5aA01', NULL, NULL, 140, NULL, NULL, 232669),
(258272, '6e7rD01', NULL, NULL, 195, NULL, NULL, 232669),
(258273, '1a2oA01', NULL, NULL, 133, NULL, NULL, 232669),
(258274, '3to5A00', NULL, NULL, 134, NULL, NULL, 232669),
(258275, '4pz0A01', NULL, NULL, 171, NULL, NULL, 232669),
(258276, '4pz0A02', NULL, NULL, 153, NULL, NULL, 232669),
(258277, '1jbeA00', NULL, NULL, 128, NULL, NULL, 232669),
(258278, '4fe7A02', NULL, NULL, 146, NULL, NULL, 232669),
(258279, '4fe7A01', NULL, NULL, 134, NULL, NULL, 232669),
(258280, '4lrqC00', NULL, NULL, 155, NULL, NULL, 232669),
(258281, '3n0rA02', NULL, NULL, 129, NULL, NULL, 232669),
(258282, '3fmvC01', NULL, NULL, 139, NULL, NULL, 232669),
(258283, '4rxmB02', NULL, NULL, 163, NULL, NULL, 232669),
(258284, '2wmyC00', NULL, NULL, 150, NULL, NULL, 232669),
(258285, '4picA00', NULL, NULL, 156, NULL, NULL, 232669),
(258286, '1qo0D01', NULL, NULL, 128, NULL, NULL, 232669),
(258287, '2hqoA00', NULL, NULL, 123, NULL, NULL, 232669),
(258288, '3d8uB01', NULL, NULL, 125, NULL, NULL, 232669),
(258289, '4rsmA02', NULL, NULL, 150, NULL, NULL, 232669),
(258290, '4if4A01', NULL, NULL, 140, NULL, NULL, 232669),
(258291, '2pjuC01', NULL, NULL, 112, NULL, NULL, 232669),
(258292, '3d8uB02', NULL, NULL, 150, NULL, NULL, 232669),
(258293, '5t3yA00', NULL, NULL, 125, NULL, NULL, 232669),
(258294, '3i5aA01', NULL, NULL, 153, NULL, NULL, 232669),
(258295, '5te9A00', NULL, NULL, 158, NULL, NULL, 232669),
(258296, '5uicB00', NULL, NULL, 127, NULL, NULL, 232669),
(258297, '3fdfB01', NULL, NULL, 139, NULL, NULL, 232669),
(258298, '4ncbA05', NULL, NULL, 147, NULL, NULL, 232669),
(258299, '4ry8A01', NULL, NULL, 162, NULL, NULL, 232669),
(258300, '3gt7A00', NULL, NULL, 154, NULL, NULL, 232669);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(258301, '3td9A01', NULL, NULL, 214, NULL, NULL, 232669),
(258302, '3td9A02', NULL, NULL, 152, NULL, NULL, 232669),
(258303, '3fmvB01', NULL, NULL, 139, NULL, NULL, 232669),
(258304, '3bblA02', NULL, NULL, 147, NULL, NULL, 232669),
(258305, '3bblA01', NULL, NULL, 140, NULL, NULL, 232669),
(258306, '2qvgA00', NULL, NULL, 143, NULL, NULL, 232669),
(258307, '4le1A00', NULL, NULL, 139, NULL, NULL, 232669),
(258308, '3l6uA01', NULL, NULL, 134, NULL, NULL, 232669),
(258309, '3nhzC00', NULL, NULL, 125, NULL, NULL, 232669),
(258310, '3l6uA02', NULL, NULL, 153, NULL, NULL, 232669),
(258311, '4rxmA01', NULL, NULL, 129, NULL, NULL, 232669),
(258312, '4ys6A01', NULL, NULL, 146, NULL, NULL, 232669),
(258313, '4ys6A02', NULL, NULL, 178, NULL, NULL, 232669),
(258314, '4xarA01', NULL, NULL, 300, NULL, NULL, 232669),
(258315, '5bq3A02', NULL, NULL, 155, NULL, NULL, 232669),
(258316, '3gv0A01', NULL, NULL, 142, NULL, NULL, 232669),
(258317, '3gv0A02', NULL, NULL, 146, NULL, NULL, 232669),
(258318, '2kyrA00', NULL, NULL, 111, NULL, NULL, 232669),
(258319, '4zylB00', NULL, NULL, 163, NULL, NULL, 232669),
(258320, '4zjpA01', NULL, NULL, 125, NULL, NULL, 232669),
(258321, '6m8oA00', NULL, NULL, 118, NULL, NULL, 232669),
(258322, '3i45A01', NULL, NULL, 199, NULL, NULL, 232669),
(258323, '4zjpA02', NULL, NULL, 144, NULL, NULL, 232669),
(258324, '4gvpA01', NULL, NULL, 206, NULL, NULL, 232669),
(258325, '1ys7A01', NULL, NULL, 128, NULL, NULL, 232669),
(258326, '3i45A02', NULL, NULL, 188, NULL, NULL, 232669),
(258327, '3qekB01', NULL, NULL, 193, NULL, NULL, 232669),
(258328, '3eqzB00', NULL, NULL, 135, NULL, NULL, 232669),
(258329, '1mvoA00', NULL, NULL, 136, NULL, NULL, 232669),
(258330, '4myrC00', NULL, NULL, 128, NULL, NULL, 232669),
(258331, '3cfyA00', NULL, NULL, 137, NULL, NULL, 232669),
(258332, '3g85A02', NULL, NULL, 126, NULL, NULL, 232669),
(258333, '4jb0A02', NULL, NULL, 154, NULL, NULL, 232669),
(258334, '3g85A01', NULL, NULL, 162, NULL, NULL, 232669),
(258335, '6e7rB02', NULL, NULL, 168, NULL, NULL, 232669),
(258336, '3q41A01', NULL, NULL, 194, NULL, NULL, 232669),
(258337, '3fmvA01', NULL, NULL, 139, NULL, NULL, 232669),
(258338, '3h5tA03', NULL, NULL, 165, NULL, NULL, 232669),
(258339, '2driA02', NULL, NULL, 146, NULL, NULL, 232669),
(258340, '2driA01', NULL, NULL, 125, NULL, NULL, 232669),
(258341, '3ksmA02', NULL, NULL, 150, NULL, NULL, 232669),
(258342, '2oqrA01', NULL, NULL, 83, NULL, NULL, 232669),
(258343, '3ksmA01', NULL, NULL, 126, NULL, NULL, 232669),
(258344, '3nbmA00', NULL, NULL, 108, NULL, NULL, 232669),
(258345, '4ry9A01', NULL, NULL, 140, NULL, NULL, 232669),
(258346, '2lpmA00', NULL, NULL, 123, NULL, NULL, 232669),
(258347, '4ry9A02', NULL, NULL, 162, NULL, NULL, 232669),
(258348, '2vk2A02', NULL, NULL, 174, NULL, NULL, 232669),
(258349, '2h3hB02', NULL, NULL, 165, NULL, NULL, 232669),
(258350, '3h5tA02', NULL, NULL, 133, NULL, NULL, 232669),
(258351, '2vk2A01', NULL, NULL, 132, NULL, NULL, 232669),
(258352, '3rofA00', NULL, NULL, 158, NULL, NULL, 232669),
(258353, '4gpaA01', NULL, NULL, 219, NULL, NULL, 232669),
(258354, '5brjA00', NULL, NULL, 141, NULL, NULL, 232669),
(258355, '4gpaA02', NULL, NULL, 170, NULL, NULL, 232669),
(258356, '3g1wA01', NULL, NULL, 149, NULL, NULL, 232669),
(258357, '3g1wA02', NULL, NULL, 156, NULL, NULL, 232669),
(258358, '3l49A01', NULL, NULL, 129, NULL, NULL, 232669),
(258359, '3l49A02', NULL, NULL, 147, NULL, NULL, 232669),
(258360, '3h5iA00', NULL, NULL, 140, NULL, NULL, 232669),
(258361, '2fepA01', NULL, NULL, 148, NULL, NULL, 232669),
(258362, '3fdfD01', NULL, NULL, 139, NULL, NULL, 232669),
(258363, '2fepA02', NULL, NULL, 141, NULL, NULL, 232669),
(258364, '2o20B01', NULL, NULL, 138, NULL, NULL, 232669),
(258365, '3e61A02', NULL, NULL, 153, NULL, NULL, 232669),
(258366, '5jnvA00', NULL, NULL, 159, NULL, NULL, 232669),
(258367, '5kc8A02', NULL, NULL, 170, NULL, NULL, 232669),
(258368, '3jviA00', NULL, NULL, 161, NULL, NULL, 232669),
(258369, '5kc8A01', NULL, NULL, 239, NULL, NULL, 232669),
(258370, '4tllB02', NULL, NULL, 177, NULL, NULL, 232669),
(258371, '3rqiA01', NULL, NULL, 133, NULL, NULL, 232669);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(258372, '3clkA02', NULL, NULL, 149, NULL, NULL, 232669),
(258373, '3hcwA02', NULL, NULL, 149, NULL, NULL, 232669),
(258374, '6ifhA00', NULL, NULL, 119, NULL, NULL, 232669),
(258375, '3hcwA01', NULL, NULL, 146, NULL, NULL, 232669),
(258376, '2rdmA00', NULL, NULL, 132, NULL, NULL, 232669),
(258377, '2ayzA00', NULL, NULL, 133, NULL, NULL, 232669),
(258378, '3sqnB04', NULL, NULL, 90, NULL, NULL, 232669),
(258379, '4rk4A02', NULL, NULL, 142, NULL, NULL, 232669),
(258380, '1jyeA02', NULL, NULL, 141, NULL, NULL, 232669),
(258381, '3hdvB00', NULL, NULL, 136, NULL, NULL, 232669),
(258382, '1jyeA01', NULL, NULL, 130, NULL, NULL, 232669),
(258383, '5kc9B01', NULL, NULL, 238, NULL, NULL, 232669),
(258384, '4rsmD01', NULL, NULL, 177, NULL, NULL, 232669),
(258385, '5i4cA00', NULL, NULL, 147, NULL, NULL, 232669),
(258386, '5ed4A01', NULL, NULL, 122, NULL, NULL, 232669),
(258387, '4iilA01', NULL, NULL, 137, NULL, NULL, 232669),
(258388, '4xfkA01', NULL, NULL, 223, NULL, NULL, 232669),
(258389, '4qicA02', NULL, NULL, 100, NULL, NULL, 232669),
(258390, '4iilA02', NULL, NULL, 179, NULL, NULL, 232669),
(258391, '4xfkA02', NULL, NULL, 176, NULL, NULL, 232669),
(258392, '3cu5B00', NULL, NULL, 141, NULL, NULL, 232669),
(258393, '1heyA00', NULL, NULL, 128, NULL, NULL, 232669),
(258394, '3egcD02', NULL, NULL, 135, NULL, NULL, 232669),
(258395, '2fn9A02', NULL, NULL, 162, NULL, NULL, 232669),
(258396, '4zpjA01', NULL, NULL, 200, NULL, NULL, 232669),
(258397, '4zpjA02', NULL, NULL, 171, NULL, NULL, 232669),
(258398, '2fn9A01', NULL, NULL, 128, NULL, NULL, 232669),
(258399, '4n03A01', NULL, NULL, 213, NULL, NULL, 232669),
(258400, '2o20A02', NULL, NULL, 137, NULL, NULL, 232669),
(258401, '4n03A02', NULL, NULL, 176, NULL, NULL, 232669),
(258402, '4rzsC01', NULL, NULL, 131, NULL, NULL, 232669),
(258403, '3kg2B01', NULL, NULL, 161, NULL, NULL, 232669),
(258404, '1z15A01', NULL, NULL, 199, NULL, NULL, 232669),
(258405, '1z15A02', NULL, NULL, 145, NULL, NULL, 232669),
(258406, '5hsgA02', NULL, NULL, 161, NULL, NULL, 232669),
(258407, '3m6mD00', NULL, NULL, 143, NULL, NULL, 232669),
(258408, '5hsgA01', NULL, NULL, 125, NULL, NULL, 232669),
(258409, '2vycA01', NULL, NULL, 139, NULL, NULL, 232669),
(258410, '3c97A01', NULL, NULL, 67, NULL, NULL, 232669),
(258411, '5braA01', NULL, NULL, 186, NULL, NULL, 232669),
(258412, '5braA02', NULL, NULL, 136, NULL, NULL, 232669),
(258413, '1udrA00', NULL, NULL, 129, NULL, NULL, 232669),
(258414, '3clkB01', NULL, NULL, 141, NULL, NULL, 232669),
(258415, '3hs3A02', NULL, NULL, 144, NULL, NULL, 232669),
(258416, '3hs3A01', NULL, NULL, 133, NULL, NULL, 232669),
(258417, '4z4dA03', NULL, NULL, 170, NULL, NULL, 232669),
(258418, '4rk6A01', NULL, NULL, 140, NULL, NULL, 232669),
(258419, '1dp4A01', NULL, NULL, 215, NULL, NULL, 232669),
(258420, '5kc9C02', NULL, NULL, 169, NULL, NULL, 232669),
(258421, '2plnA00', NULL, NULL, 137, NULL, NULL, 232669),
(258422, '3khtA00', NULL, NULL, 144, NULL, NULL, 232669),
(258423, '3bilA01', NULL, NULL, 132, NULL, NULL, 232669),
(258424, '1w25A01', NULL, NULL, 141, NULL, NULL, 232669),
(258425, '3bilA02', NULL, NULL, 149, NULL, NULL, 232669),
(258426, '1iibA00', NULL, NULL, 106, NULL, NULL, 232669),
(258427, '4evsA02', NULL, NULL, 171, NULL, NULL, 232669),
(258428, '4evsA01', NULL, NULL, 200, NULL, NULL, 232669),
(258429, '3kcnB00', NULL, NULL, 151, NULL, NULL, 232669),
(258430, '4uhjA00', NULL, NULL, 136, NULL, NULL, 232669),
(258431, '4pyrA01', NULL, NULL, 185, NULL, NULL, 232669),
(258432, '3qekA02', NULL, NULL, 191, NULL, NULL, 232669),
(258433, '4pyrA02', NULL, NULL, 120, NULL, NULL, 232669),
(258434, '3kloD00', NULL, NULL, 185, NULL, NULL, 232669),
(258435, '2fvyA02', NULL, NULL, 161, NULL, NULL, 232669),
(258436, '3eafA02', NULL, NULL, 183, NULL, NULL, 232669),
(258437, '4rk5A01', NULL, NULL, 141, NULL, NULL, 232669),
(258438, '4mgeA00', NULL, NULL, 116, NULL, NULL, 232669),
(258439, '5gotA00', NULL, NULL, 153, NULL, NULL, 232669),
(258440, '3eafA01', NULL, NULL, 208, NULL, NULL, 232669),
(258441, '3kg2A02', NULL, NULL, 167, NULL, NULL, 232669),
(258442, '2fvyA01', NULL, NULL, 148, NULL, NULL, 232669);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(258443, '4ms4B01', NULL, NULL, 236, NULL, NULL, 232669),
(258444, '4ms4B02', NULL, NULL, 197, NULL, NULL, 232669),
(258445, '1tvmA01', NULL, NULL, 93, NULL, NULL, 232669),
(258446, '1jf8A00', NULL, NULL, 131, NULL, NULL, 232669),
(258447, '3hebA00', NULL, NULL, 152, NULL, NULL, 232669),
(258448, '4tllD01', NULL, NULL, 202, NULL, NULL, 232669),
(258449, '5fbkB02', NULL, NULL, 190, NULL, NULL, 232669),
(258450, '5fbkB01', NULL, NULL, 331, NULL, NULL, 232669),
(258451, '1u04A03', NULL, NULL, 215, NULL, NULL, 232669),
(258452, '4yv7A02', NULL, NULL, 157, NULL, NULL, 232669),
(258453, '4yv7A01', NULL, NULL, 131, NULL, NULL, 232669),
(258454, '3q41B02', NULL, NULL, 190, NULL, NULL, 232669),
(258455, '5tq0B02', NULL, NULL, 166, NULL, NULL, 232669),
(258456, '3d02A02', NULL, NULL, 153, NULL, NULL, 232669),
(258457, '5tq0B01', NULL, NULL, 194, NULL, NULL, 232669),
(258458, '2l17A00', NULL, NULL, 134, NULL, NULL, 232669),
(258459, '4wt7B02', NULL, NULL, 190, NULL, NULL, 232669),
(258460, '4qywA00', NULL, NULL, 119, NULL, NULL, 232669),
(258461, '3d02A01', NULL, NULL, 150, NULL, NULL, 232669),
(258462, '4rk6B02', NULL, NULL, 147, NULL, NULL, 232669),
(258463, '2zayA00', NULL, NULL, 130, NULL, NULL, 232669),
(258464, '1kgsA01', NULL, NULL, 122, NULL, NULL, 232669),
(258465, '5jnuA00', NULL, NULL, 160, NULL, NULL, 232669),
(258466, '5vfaA01', NULL, NULL, 123, NULL, NULL, 232669),
(258467, '4d6yA00', NULL, NULL, 131, NULL, NULL, 232669),
(258468, '2h3hA01', NULL, NULL, 148, NULL, NULL, 232669),
(258469, '5z3mB00', NULL, NULL, 166, NULL, NULL, 232669),
(258470, '3t8yB00', NULL, NULL, 142, NULL, NULL, 232669),
(258471, '4gfcB00', NULL, NULL, 189, NULL, NULL, 232670),
(258472, '3q0yC00', NULL, NULL, 161, NULL, NULL, 232670),
(258473, '3q0xA01', NULL, NULL, 155, NULL, NULL, 232670),
(258474, '4g79A00', NULL, NULL, 142, NULL, NULL, 232670),
(258475, '4cknD00', NULL, NULL, 190, NULL, NULL, 232670),
(258476, '4ckmB00', NULL, NULL, 145, NULL, NULL, 232670),
(258477, '2y3vD00', NULL, NULL, 159, NULL, NULL, 232670),
(258478, '3ksxA03', NULL, NULL, 34, NULL, NULL, 232671),
(258479, '2x26B03', NULL, NULL, 34, NULL, NULL, 232671),
(258480, '3s24F02', NULL, NULL, 53, NULL, NULL, 232672),
(258481, '1ckmA03', NULL, NULL, 54, NULL, NULL, 232672),
(258482, '3l09A01', NULL, NULL, 98, NULL, NULL, 232673),
(258483, '3kfwX03', NULL, NULL, 88, NULL, NULL, 232673),
(258484, '1hw7A02', NULL, NULL, 50, NULL, NULL, 232674),
(258485, '5dm6001', NULL, NULL, 121, NULL, NULL, 232675),
(258486, '4dfcB00', NULL, NULL, 126, NULL, NULL, 232675),
(258487, '4wweA01', NULL, NULL, 117, NULL, NULL, 232675),
(258488, '3zqjA03', NULL, NULL, 118, NULL, NULL, 232675),
(258489, '4wwtA01', NULL, NULL, 117, NULL, NULL, 232675),
(258490, '4reoA01', NULL, NULL, 121, NULL, NULL, 232675),
(258491, '4lq4A01', NULL, NULL, 120, NULL, NULL, 232675),
(258492, '1dwuA01', NULL, NULL, 121, NULL, NULL, 232675),
(258493, '3fpnA00', NULL, NULL, 119, NULL, NULL, 232675),
(258494, '1mzpA01', NULL, NULL, 126, NULL, NULL, 232675),
(258495, '3o58A01', NULL, NULL, 120, NULL, NULL, 232675),
(258496, '3qoyA01', NULL, NULL, 134, NULL, NULL, 232675),
(258497, '1x1pA02', NULL, NULL, 45, NULL, NULL, 232676),
(258498, '1i39A02', NULL, NULL, 50, NULL, NULL, 232676),
(258499, '2dffA02', NULL, NULL, 47, NULL, NULL, 232676),
(258500, '3pufA02', NULL, NULL, 51, NULL, NULL, 232676),
(258501, '1io2A02', NULL, NULL, 47, NULL, NULL, 232676),
(258502, '3kioA02', NULL, NULL, 49, NULL, NULL, 232676),
(258503, '2dfeA02', NULL, NULL, 48, NULL, NULL, 232676),
(258504, '1ekeB02', NULL, NULL, 47, NULL, NULL, 232676),
(258505, '2ve7C02', NULL, NULL, 65, NULL, NULL, 232677),
(258506, '1bvp101', NULL, NULL, 120, NULL, NULL, 232678),
(258507, '3lsoA03', NULL, NULL, 158, NULL, NULL, 232679),
(258508, '4im0A04', NULL, NULL, 252, NULL, NULL, 232680),
(258509, '4jlcA04', NULL, NULL, 251, NULL, NULL, 232680),
(258510, '1edxA00', NULL, NULL, 40, NULL, NULL, 232681),
(258511, '3cesA03', NULL, NULL, 92, NULL, NULL, 232682),
(258512, '2zxiA03', NULL, NULL, 97, NULL, NULL, 232682),
(258513, '3cp8D03', NULL, NULL, 106, NULL, NULL, 232682);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(258514, '4g84A02', NULL, NULL, 102, NULL, NULL, 232683),
(258515, '2i4lB02', NULL, NULL, 101, NULL, NULL, 232683),
(258516, '1v95A01', NULL, NULL, 116, NULL, NULL, 232683),
(258517, '4e51A02', NULL, NULL, 101, NULL, NULL, 232683),
(258518, '4wi1B02', NULL, NULL, 108, NULL, NULL, 232683),
(258519, '2j3lA01', NULL, NULL, 120, NULL, NULL, 232683),
(258520, '3uh0A02', NULL, NULL, 124, NULL, NULL, 232683),
(258521, '3iklA02', NULL, NULL, 112, NULL, NULL, 232683),
(258522, '1hc7A02', NULL, NULL, 104, NULL, NULL, 232683),
(258523, '5ucmA01', NULL, NULL, 125, NULL, NULL, 232683),
(258524, '3lc0A02', NULL, NULL, 102, NULL, NULL, 232683),
(258525, '1nj8A02', NULL, NULL, 103, NULL, NULL, 232683),
(258526, '1wu7A03', NULL, NULL, 105, NULL, NULL, 232683),
(258527, '1qe0A02', NULL, NULL, 91, NULL, NULL, 232683),
(258528, '1g5hB02', NULL, NULL, 117, NULL, NULL, 232683),
(258529, '4kr2A02', NULL, NULL, 118, NULL, NULL, 232683),
(258530, '1h4vB02', NULL, NULL, 95, NULL, NULL, 232683),
(258531, '5znjA01', NULL, NULL, 116, NULL, NULL, 232683),
(258532, '5e3iA02', NULL, NULL, 99, NULL, NULL, 232683),
(258533, '1evlA02', NULL, NULL, 112, NULL, NULL, 232683),
(258534, '4hvcB02', NULL, NULL, 110, NULL, NULL, 232683),
(258535, '1nyrA04', NULL, NULL, 106, NULL, NULL, 232683),
(258536, '4hwtA02', NULL, NULL, 122, NULL, NULL, 232683),
(258537, '1nj1A02', NULL, NULL, 104, NULL, NULL, 232683),
(258538, '3netB02', NULL, NULL, 98, NULL, NULL, 232683),
(258539, '1httA02', NULL, NULL, 98, NULL, NULL, 232683),
(258540, '3ialA02', NULL, NULL, 128, NULL, NULL, 232683),
(258541, '1atiB02', NULL, NULL, 112, NULL, NULL, 232683),
(258542, '2zt5A03', NULL, NULL, 121, NULL, NULL, 232683),
(258543, '3hriA02', NULL, NULL, 102, NULL, NULL, 232683),
(258544, '3a32A02', NULL, NULL, 141, NULL, NULL, 232683),
(258545, '2vouA02', NULL, NULL, 147, NULL, NULL, 232684),
(258546, '4n2kA01', NULL, NULL, 119, NULL, NULL, 232685),
(258547, '5n0mA01', NULL, NULL, 125, NULL, NULL, 232685),
(258548, '5hp5A01', NULL, NULL, 141, NULL, NULL, 232685),
(258549, '6ce1A01', NULL, NULL, 119, NULL, NULL, 232685),
(258550, '3godC01', NULL, NULL, 88, NULL, NULL, 232686),
(258551, '5fclE01', NULL, NULL, 103, NULL, NULL, 232686),
(258552, '4n06A01', NULL, NULL, 82, NULL, NULL, 232686),
(258553, '3godD01', NULL, NULL, 103, NULL, NULL, 232686),
(258554, '4w8kA01', NULL, NULL, 95, NULL, NULL, 232686),
(258555, '4wj0A01', NULL, NULL, 82, NULL, NULL, 232686),
(258556, '4xtkA01', NULL, NULL, 87, NULL, NULL, 232686),
(258557, '3nkdB01', NULL, NULL, 96, NULL, NULL, 232686),
(258558, '2yzsA01', NULL, NULL, 80, NULL, NULL, 232686),
(258559, '3oy2A01', NULL, NULL, 160, NULL, NULL, 232687),
(258560, '4k51B00', NULL, NULL, 166, NULL, NULL, 232688),
(258561, '1ef1C01', NULL, NULL, 76, NULL, NULL, 232689),
(258562, '2i1jA05', NULL, NULL, 83, NULL, NULL, 232689),
(258563, '3h2tA01', NULL, NULL, 77, NULL, NULL, 232690),
(258564, '2raaA00', NULL, NULL, 188, NULL, NULL, 232691),
(258565, '3g2eB00', NULL, NULL, 194, NULL, NULL, 232691),
(258566, '2c42A03', NULL, NULL, 212, NULL, NULL, 232691),
(258567, '3on3B00', NULL, NULL, 183, NULL, NULL, 232691),
(258568, '4nn5B01', NULL, NULL, 93, NULL, NULL, 232692),
(258569, '3up1B01', NULL, NULL, 93, NULL, NULL, 232692),
(258570, '4b8cD03', NULL, NULL, 55, NULL, NULL, 232693),
(258571, '4al0A00', NULL, NULL, 152, NULL, NULL, 232694),
(258572, '2h8aA00', NULL, NULL, 154, NULL, NULL, 232694),
(258573, '3leoA00', NULL, NULL, 155, NULL, NULL, 232694),
(258574, '3pcvA00', NULL, NULL, 156, NULL, NULL, 232694),
(258575, '4bpmA00', NULL, NULL, 178, NULL, NULL, 232694),
(258576, '2q7rC00', NULL, NULL, 161, NULL, NULL, 232694),
(258577, '4ntfA00', NULL, NULL, 156, NULL, NULL, 232694),
(258578, '2f8xM00', NULL, NULL, 63, NULL, NULL, 232695),
(258579, '3kdrA02', NULL, NULL, 140, NULL, NULL, 232696),
(258580, '2o9xA02', NULL, NULL, 78, NULL, NULL, 232697),
(258581, '2v6eA02', NULL, NULL, 129, NULL, NULL, 232698),
(258582, '1zklA00', NULL, NULL, 326, NULL, NULL, 232699),
(258583, '2ousA00', NULL, NULL, 331, NULL, NULL, 232699),
(258584, '2r8qA00', NULL, NULL, 359, NULL, NULL, 232699);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(258585, '1xm6B00', NULL, NULL, 349, NULL, NULL, 232699),
(258586, '6fe3B00', NULL, NULL, 333, NULL, NULL, 232699),
(258587, '5h2qB00', NULL, NULL, 337, NULL, NULL, 232699),
(258588, '2qymA00', NULL, NULL, 330, NULL, NULL, 232699),
(258589, '1tbfA00', NULL, NULL, 326, NULL, NULL, 232699),
(258590, '2h44A00', NULL, NULL, 326, NULL, NULL, 232699),
(258591, '3jwqC00', NULL, NULL, 330, NULL, NULL, 232699),
(258592, '4y86B00', NULL, NULL, 326, NULL, NULL, 232699),
(258593, '2qykA00', NULL, NULL, 335, NULL, NULL, 232699),
(258594, '3g4gB00', NULL, NULL, 343, NULL, NULL, 232699),
(258595, '1tazA00', NULL, NULL, 365, NULL, NULL, 232699),
(258596, '5ohjB00', NULL, NULL, 342, NULL, NULL, 232699),
(258597, '3ecmA00', NULL, NULL, 338, NULL, NULL, 232699),
(258598, '4kp6A00', NULL, NULL, 340, NULL, NULL, 232699),
(258599, '3frgA00', NULL, NULL, 337, NULL, NULL, 232699),
(258600, '1y2kA00', NULL, NULL, 328, NULL, NULL, 232699),
(258601, '1so2A00', NULL, NULL, 383, NULL, NULL, 232699),
(258602, '6fdcB00', NULL, NULL, 343, NULL, NULL, 232699),
(258603, '6c7eD00', NULL, NULL, 342, NULL, NULL, 232699),
(258604, '3v93F01', NULL, NULL, 310, NULL, NULL, 232699),
(258605, '4xwmA02', NULL, NULL, 133, NULL, NULL, 232700),
(258606, '5yj6A02', NULL, NULL, 130, NULL, NULL, 232700),
(258607, '4jjjA02', NULL, NULL, 136, NULL, NULL, 232700),
(258608, '4l6xA02', NULL, NULL, 132, NULL, NULL, 232700),
(258609, '1g9gA02', NULL, NULL, 136, NULL, NULL, 232700),
(258610, '4fusA02', NULL, NULL, 135, NULL, NULL, 232700),
(258611, '5bv9A02', NULL, NULL, 132, NULL, NULL, 232700),
(258612, '4bt9A01', NULL, NULL, 94, NULL, NULL, 232701),
(258613, '1w36C06', NULL, NULL, 72, NULL, NULL, 232702),
(258614, '4co9A00', NULL, NULL, 211, NULL, NULL, 232703),
(258615, '4cobA00', NULL, NULL, 215, NULL, NULL, 232703),
(258616, '2b0aA00', NULL, NULL, 186, NULL, NULL, 232703),
(258617, '4cogA00', NULL, NULL, 215, NULL, NULL, 232703),
(258618, '5nmpB00', NULL, NULL, 265, NULL, NULL, 232703),
(258619, '4m8dA00', NULL, NULL, 263, NULL, NULL, 232703),
(258620, '1r61A00', NULL, NULL, 207, NULL, NULL, 232703),
(258621, '5nnaA00', NULL, NULL, 264, NULL, NULL, 232703),
(258622, '2odrD03', NULL, NULL, 47, NULL, NULL, 232704),
(258623, '3gyxB02', NULL, NULL, 100, NULL, NULL, 232705),
(258624, '1jnrB02', NULL, NULL, 83, NULL, NULL, 232705),
(258625, '4qmkA02', NULL, NULL, 299, NULL, NULL, 232706),
(258626, '4pk9A00', NULL, NULL, 373, NULL, NULL, 232706),
(258627, '4akfA01', NULL, NULL, 344, NULL, NULL, 232706),
(258628, '1cjyB02', NULL, NULL, 501, NULL, NULL, 232706),
(258629, '3tu3B02', NULL, NULL, 335, NULL, NULL, 232706),
(258630, '2w83C00', NULL, NULL, 77, NULL, NULL, 232707),
(258631, '4hetA02', NULL, NULL, 254, NULL, NULL, 232708),
(258632, '3s30A00', NULL, NULL, 258, NULL, NULL, 232708),
(258633, '3hbzA02', NULL, NULL, 248, NULL, NULL, 232708),
(258634, '4jrlA02', NULL, NULL, 255, NULL, NULL, 232708),
(258635, '3b5iA02', NULL, NULL, 95, NULL, NULL, 232709),
(258636, '3llkA01', NULL, NULL, 105, NULL, NULL, 232710),
(258637, '3t58C03', NULL, NULL, 121, NULL, NULL, 232710),
(258638, '4adnA01', NULL, NULL, 94, NULL, NULL, 232711),
(258639, '2yb5F01', NULL, NULL, 86, NULL, NULL, 232711),
(258640, '2kw3C00', NULL, NULL, 62, NULL, NULL, 232712),
(258641, '5udhA02', NULL, NULL, 239, NULL, NULL, 232713),
(258642, '1uunA02', NULL, NULL, 52, NULL, NULL, 232714),
(258643, '1ci4A00', NULL, NULL, 89, NULL, NULL, 232715),
(258644, '6ghdA00', NULL, NULL, 88, NULL, NULL, 232715),
(258645, '5fr1B00', NULL, NULL, 179, NULL, NULL, 232716),
(258646, '1qvyA00', NULL, NULL, 139, NULL, NULL, 232716),
(258647, '5h1dA00', NULL, NULL, 143, NULL, NULL, 232716),
(258648, '1ds6B00', NULL, NULL, 180, NULL, NULL, 232716),
(258649, '1hh4E00', NULL, NULL, 182, NULL, NULL, 232716),
(258650, '1kmtA00', NULL, NULL, 141, NULL, NULL, 232716),
(258651, '1rhoA00', NULL, NULL, 145, NULL, NULL, 232716),
(258652, '3g1jA00', NULL, NULL, 93, NULL, NULL, 232717),
(258653, '3ei3A04', NULL, NULL, 97, NULL, NULL, 232718),
(258654, '2zy2A02', NULL, NULL, 147, NULL, NULL, 232719),
(258655, '2zy4A02', NULL, NULL, 148, NULL, NULL, 232719);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(258656, '3f6tA02', NULL, NULL, 147, NULL, NULL, 232719),
(258657, '6cm9S00', NULL, NULL, 154, NULL, NULL, 232720),
(258658, '5mc7A00', NULL, NULL, 147, NULL, NULL, 232720),
(258659, '1nrjA00', NULL, NULL, 158, NULL, NULL, 232720),
(258660, '2vglM01', NULL, NULL, 141, NULL, NULL, 232720),
(258661, '4p6zS00', NULL, NULL, 158, NULL, NULL, 232720),
(258662, '2fh5A01', NULL, NULL, 129, NULL, NULL, 232720),
(258663, '4p6zM01', NULL, NULL, 122, NULL, NULL, 232720),
(258664, '2vglS00', NULL, NULL, 142, NULL, NULL, 232720),
(258665, '5ck3C00', NULL, NULL, 142, NULL, NULL, 232720),
(258666, '5hkgA00', NULL, NULL, 107, NULL, NULL, 232721),
(258667, '3kz7A00', NULL, NULL, 119, NULL, NULL, 232721),
(258668, '5ez1A01', NULL, NULL, 100, NULL, NULL, 232721),
(258669, '2jzvA00', NULL, NULL, 111, NULL, NULL, 232721),
(258670, '4g2pA00', NULL, NULL, 110, NULL, NULL, 232721),
(258671, '1kt0A02', NULL, NULL, 114, NULL, NULL, 232721),
(258672, '4layA01', NULL, NULL, 118, NULL, NULL, 232721),
(258673, '1yw5A02', NULL, NULL, 114, NULL, NULL, 232721),
(258674, '4layA02', NULL, NULL, 121, NULL, NULL, 232721),
(258675, '2kgjA00', NULL, NULL, 102, NULL, NULL, 232721),
(258676, '1zk6A00', NULL, NULL, 93, NULL, NULL, 232721),
(258677, '1pinA02', NULL, NULL, 110, NULL, NULL, 232721),
(258678, '1hxvA00', NULL, NULL, 85, NULL, NULL, 232721),
(258679, '3jxvA01', NULL, NULL, 118, NULL, NULL, 232721),
(258680, '1yatA00', NULL, NULL, 113, NULL, NULL, 232721),
(258681, '3jxvA02', NULL, NULL, 121, NULL, NULL, 232721),
(258682, '5hwcA00', NULL, NULL, 115, NULL, NULL, 232721),
(258683, '4mspA01', NULL, NULL, 125, NULL, NULL, 232721),
(258684, '1u79A00', NULL, NULL, 129, NULL, NULL, 232721),
(258685, '3prbA01', NULL, NULL, 105, NULL, NULL, 232721),
(258686, '1kt1A01', NULL, NULL, 106, NULL, NULL, 232721),
(258687, '6gmpA00', NULL, NULL, 122, NULL, NULL, 232721),
(258688, '1t11A03', NULL, NULL, 97, NULL, NULL, 232721),
(258689, '1kt1A02', NULL, NULL, 114, NULL, NULL, 232721),
(258690, '5b8iC00', NULL, NULL, 130, NULL, NULL, 232721),
(258691, '3i6cA00', NULL, NULL, 123, NULL, NULL, 232721),
(258692, '3ui4A00', NULL, NULL, 101, NULL, NULL, 232721),
(258693, '1ix5A00', NULL, NULL, 151, NULL, NULL, 232721),
(258694, '3pr9A00', NULL, NULL, 157, NULL, NULL, 232721),
(258695, '4o2tA00', NULL, NULL, 168, NULL, NULL, 232721),
(258696, '5huaA00', NULL, NULL, 115, NULL, NULL, 232721),
(258697, '2mf9A00', NULL, NULL, 157, NULL, NULL, 232721),
(258698, '2pv1A00', NULL, NULL, 103, NULL, NULL, 232721),
(258699, '6b4pB00', NULL, NULL, 127, NULL, NULL, 232721),
(258700, '3b7xA00', NULL, NULL, 134, NULL, NULL, 232721),
(258701, '5i7qA01', NULL, NULL, 113, NULL, NULL, 232721),
(258702, '1j6yA00', NULL, NULL, 120, NULL, NULL, 232721),
(258703, '2y78A00', NULL, NULL, 133, NULL, NULL, 232721),
(258704, '3ey6A00', NULL, NULL, 121, NULL, NULL, 232721),
(258705, '2pbcA00', NULL, NULL, 102, NULL, NULL, 232721),
(258706, '2lj4A00', NULL, NULL, 115, NULL, NULL, 232721),
(258707, '3ni6A01', NULL, NULL, 120, NULL, NULL, 232721),
(258708, '1jvwA00', NULL, NULL, 167, NULL, NULL, 232721),
(258709, '1rotA00', NULL, NULL, 129, NULL, NULL, 232721),
(258710, '2nd5A00', NULL, NULL, 111, NULL, NULL, 232721),
(258711, '4qt3A01', NULL, NULL, 120, NULL, NULL, 232721),
(258712, '1jnsA00', NULL, NULL, 92, NULL, NULL, 232721),
(258713, '2m1iA00', NULL, NULL, 97, NULL, NULL, 232721),
(258714, '3rgcA02', NULL, NULL, 78, NULL, NULL, 232721),
(258715, '5xb0A02', NULL, NULL, 102, NULL, NULL, 232721),
(258716, '2kfwA01', NULL, NULL, 113, NULL, NULL, 232721),
(258717, '2lknA00', NULL, NULL, 165, NULL, NULL, 232721),
(258718, '4odkA00', NULL, NULL, 158, NULL, NULL, 232721),
(258719, '5gpgA00', NULL, NULL, 117, NULL, NULL, 232721),
(258720, '3jymB01', NULL, NULL, 116, NULL, NULL, 232721),
(258721, '1fd9A01', NULL, NULL, 107, NULL, NULL, 232721),
(258722, '4driA00', NULL, NULL, 121, NULL, NULL, 232721),
(258723, '3nrkA02', NULL, NULL, 109, NULL, NULL, 232721),
(258724, '1w26A03', NULL, NULL, 97, NULL, NULL, 232721),
(258725, '5i7pA01', NULL, NULL, 113, NULL, NULL, 232721),
(258726, '2m08A00', NULL, NULL, 93, NULL, NULL, 232721);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(258727, '1p5qA01', NULL, NULL, 116, NULL, NULL, 232721),
(258728, '3uqiA00', NULL, NULL, 108, NULL, NULL, 232721),
(258729, '2kr7A01', NULL, NULL, 94, NULL, NULL, 232721),
(258730, '2f4eB00', NULL, NULL, 127, NULL, NULL, 232721),
(258731, '3rfwA03', NULL, NULL, 108, NULL, NULL, 232721),
(258732, '3gpkA00', NULL, NULL, 112, NULL, NULL, 232721),
(258733, '3o5qA00', NULL, NULL, 128, NULL, NULL, 232721),
(258734, '1m5yA03', NULL, NULL, 107, NULL, NULL, 232721),
(258735, '4dt4A01', NULL, NULL, 79, NULL, NULL, 232721),
(258736, '1m5yC02', NULL, NULL, 136, NULL, NULL, 232721),
(258737, '4dipH00', NULL, NULL, 125, NULL, NULL, 232721),
(258738, '2ppnA00', NULL, NULL, 107, NULL, NULL, 232721),
(258739, '4jysB00', NULL, NULL, 118, NULL, NULL, 232721),
(258740, '4bf8A00', NULL, NULL, 117, NULL, NULL, 232721),
(258741, '4odpA00', NULL, NULL, 110, NULL, NULL, 232721),
(258742, '5i98B00', NULL, NULL, 120, NULL, NULL, 232721),
(258743, '1r9hA00', NULL, NULL, 135, NULL, NULL, 232721),
(258744, '2lgoA00', NULL, NULL, 130, NULL, NULL, 232721),
(258745, '1q6hA02', NULL, NULL, 103, NULL, NULL, 232721),
(258746, '1jiwI00', NULL, NULL, 106, NULL, NULL, 232722),
(258747, '4kcaA03', NULL, NULL, 97, NULL, NULL, 232722),
(258748, '2x8sA02', NULL, NULL, 95, NULL, NULL, 232722),
(258749, '1smpI00', NULL, NULL, 101, NULL, NULL, 232722),
(258750, '3lv4A02', NULL, NULL, 108, NULL, NULL, 232722),
(258751, '5ho9B02', NULL, NULL, 102, NULL, NULL, 232722),
(258752, '4kc7A02', NULL, NULL, 100, NULL, NULL, 232722),
(258753, '4dl8A00', NULL, NULL, 233, NULL, NULL, 232723),
(258754, '1w2yA00', NULL, NULL, 229, NULL, NULL, 232723),
(258755, '2l9dA00', NULL, NULL, 108, NULL, NULL, 232724),
(258756, '4u6uA00', NULL, NULL, 77, NULL, NULL, 232725),
(258757, '3khiA01', NULL, NULL, 125, NULL, NULL, 232726),
(258758, '3s1sA01', NULL, NULL, 174, NULL, NULL, 232727),
(258759, '3h1tA01', NULL, NULL, 157, NULL, NULL, 232727),
(258760, '5v00A02', NULL, NULL, 103, NULL, NULL, 232728),
(258761, '5d1iA00', NULL, NULL, 131, NULL, NULL, 232728),
(258762, '3mdpA00', NULL, NULL, 142, NULL, NULL, 232728),
(258763, '4r52A01', NULL, NULL, 166, NULL, NULL, 232728),
(258764, '5wxuD01', NULL, NULL, 273, NULL, NULL, 232728),
(258765, '3u11B02', NULL, NULL, 137, NULL, NULL, 232728),
(258766, '1uikA01', NULL, NULL, 207, NULL, NULL, 232728),
(258767, '2o1qA01', NULL, NULL, 127, NULL, NULL, 232728),
(258768, '2qnkA00', NULL, NULL, 286, NULL, NULL, 232728),
(258769, '2qjvB01', NULL, NULL, 157, NULL, NULL, 232728),
(258770, '3shrA02', NULL, NULL, 137, NULL, NULL, 232728),
(258771, '3shrA01', NULL, NULL, 141, NULL, NULL, 232728),
(258772, '4d7sA02', NULL, NULL, 131, NULL, NULL, 232728),
(258773, '3h7jA01', NULL, NULL, 115, NULL, NULL, 232728),
(258774, '2qdrA01', NULL, NULL, 280, NULL, NULL, 232728),
(258775, '3h7jA02', NULL, NULL, 110, NULL, NULL, 232728),
(258776, '2i45D00', NULL, NULL, 107, NULL, NULL, 232728),
(258777, '2n7gA00', NULL, NULL, 131, NULL, NULL, 232728),
(258778, '5e1rB02', NULL, NULL, 186, NULL, NULL, 232728),
(258779, '5k8sB00', NULL, NULL, 148, NULL, NULL, 232728),
(258780, '2oz6A01', NULL, NULL, 132, NULL, NULL, 232728),
(258781, '2d40B00', NULL, NULL, 307, NULL, NULL, 232728),
(258782, '4avaA01', NULL, NULL, 145, NULL, NULL, 232728),
(258783, '3c3vA02', NULL, NULL, 170, NULL, NULL, 232728),
(258784, '5e16A00', NULL, NULL, 143, NULL, NULL, 232728),
(258785, '4e2gF00', NULL, NULL, 126, NULL, NULL, 232728),
(258786, '1yllC02', NULL, NULL, 109, NULL, NULL, 232728),
(258787, '4i2oA01', NULL, NULL, 118, NULL, NULL, 232728),
(258788, '5gylA01', NULL, NULL, 227, NULL, NULL, 232728),
(258789, '5gylA02', NULL, NULL, 173, NULL, NULL, 232728),
(258790, '5jixA00', NULL, NULL, 152, NULL, NULL, 232728),
(258791, '4rd7A00', NULL, NULL, 127, NULL, NULL, 232728),
(258792, '2pfwA00', NULL, NULL, 116, NULL, NULL, 232728),
(258793, '1nxmA00', NULL, NULL, 197, NULL, NULL, 232728),
(258794, '3c3vA01', NULL, NULL, 257, NULL, NULL, 232728),
(258795, '2xlgA00', NULL, NULL, 239, NULL, NULL, 232728),
(258796, '4ofgA00', NULL, NULL, 144, NULL, NULL, 232728),
(258797, '5l0nA00', NULL, NULL, 135, NULL, NULL, 232728);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(258798, '1juhA01', NULL, NULL, 145, NULL, NULL, 232728),
(258799, '4lukA00', NULL, NULL, 189, NULL, NULL, 232728),
(258800, '1juhA02', NULL, NULL, 145, NULL, NULL, 232728),
(258801, '5v00B01', NULL, NULL, 90, NULL, NULL, 232728),
(258802, '1o7fA01', NULL, NULL, 155, NULL, NULL, 232728),
(258803, '4yarA03', NULL, NULL, 124, NULL, NULL, 232728),
(258804, '4r8hA01', NULL, NULL, 130, NULL, NULL, 232728),
(258805, '3b02A01', NULL, NULL, 110, NULL, NULL, 232728),
(258806, '1o7fA03', NULL, NULL, 109, NULL, NULL, 232728),
(258807, '4yarA02', NULL, NULL, 123, NULL, NULL, 232728),
(258808, '2mhfA00', NULL, NULL, 143, NULL, NULL, 232728),
(258809, '5fljA00', NULL, NULL, 186, NULL, NULL, 232728),
(258810, '3es4A00', NULL, NULL, 116, NULL, NULL, 232728),
(258811, '3kmhA00', NULL, NULL, 226, NULL, NULL, 232728),
(258812, '2wfpA01', NULL, NULL, 98, NULL, NULL, 232728),
(258813, '5e44A01', NULL, NULL, 146, NULL, NULL, 232728),
(258814, '2wfpA02', NULL, NULL, 183, NULL, NULL, 232728),
(258815, '3la3A01', NULL, NULL, 112, NULL, NULL, 232728),
(258816, '4e2gE00', NULL, NULL, 126, NULL, NULL, 232728),
(258817, '3ww3A00', NULL, NULL, 256, NULL, NULL, 232728),
(258818, '3lwcA00', NULL, NULL, 119, NULL, NULL, 232728),
(258819, '5avpA00', NULL, NULL, 248, NULL, NULL, 232728),
(258820, '3nstA01', NULL, NULL, 322, NULL, NULL, 232728),
(258821, '4lloC00', NULL, NULL, 177, NULL, NULL, 232728),
(258822, '1j3qB00', NULL, NULL, 190, NULL, NULL, 232728),
(258823, '2o8qA00', NULL, NULL, 134, NULL, NULL, 232728),
(258824, '3ibmB00', NULL, NULL, 167, NULL, NULL, 232728),
(258825, '3balA01', NULL, NULL, 133, NULL, NULL, 232728),
(258826, '4qgnA00', NULL, NULL, 183, NULL, NULL, 232728),
(258827, '5vf5A01', NULL, NULL, 197, NULL, NULL, 232728),
(258828, '5vf5A02', NULL, NULL, 201, NULL, NULL, 232728),
(258829, '5nfoA00', NULL, NULL, 317, NULL, NULL, 232728),
(258830, '6h1hA02', NULL, NULL, 163, NULL, NULL, 232728),
(258831, '6h1hA01', NULL, NULL, 123, NULL, NULL, 232728),
(258832, '3d82E00', NULL, NULL, 102, NULL, NULL, 232728),
(258833, '3u0zA02', NULL, NULL, 137, NULL, NULL, 232728),
(258834, '3rnsA02', NULL, NULL, 101, NULL, NULL, 232728),
(258835, '5zbeA02', NULL, NULL, 107, NULL, NULL, 232728),
(258836, '3rnsA01', NULL, NULL, 110, NULL, NULL, 232728),
(258837, '1fxzA01', NULL, NULL, 237, NULL, NULL, 232728),
(258838, '1fxzA02', NULL, NULL, 170, NULL, NULL, 232728),
(258839, '3of1A02', NULL, NULL, 133, NULL, NULL, 232728),
(258840, '1sq4A02', NULL, NULL, 126, NULL, NULL, 232728),
(258841, '1yudA01', NULL, NULL, 166, NULL, NULL, 232728),
(258842, '1sq4A01', NULL, NULL, 152, NULL, NULL, 232728),
(258843, '6c46C00', NULL, NULL, 189, NULL, NULL, 232728),
(258844, '2phlB02', NULL, NULL, 159, NULL, NULL, 232728),
(258845, '2vpvA00', NULL, NULL, 94, NULL, NULL, 232728),
(258846, '3of1A01', NULL, NULL, 113, NULL, NULL, 232728),
(258847, '1zybA01', NULL, NULL, 223, NULL, NULL, 232728),
(258848, '1pmiA01', NULL, NULL, 185, NULL, NULL, 232728),
(258849, '1h2kA01', NULL, NULL, 303, NULL, NULL, 232728),
(258850, '1pmiA03', NULL, NULL, 119, NULL, NULL, 232728),
(258851, '3h8uA00', NULL, NULL, 125, NULL, NULL, 232728),
(258852, '2gu9A01', NULL, NULL, 104, NULL, NULL, 232728),
(258853, '1sefA01', NULL, NULL, 155, NULL, NULL, 232728),
(258854, '4e2gD00', NULL, NULL, 126, NULL, NULL, 232728),
(258855, '3bu7A00', NULL, NULL, 356, NULL, NULL, 232728),
(258856, '3myxA02', NULL, NULL, 115, NULL, NULL, 232728),
(258857, '4qmaA02', NULL, NULL, 143, NULL, NULL, 232728),
(258858, '3loiA01', NULL, NULL, 169, NULL, NULL, 232728),
(258859, '4f7zA03', NULL, NULL, 179, NULL, NULL, 232728),
(258860, '2pqqA00', NULL, NULL, 149, NULL, NULL, 232728),
(258861, '3h9aB01', NULL, NULL, 115, NULL, NULL, 232728),
(258862, '3jzvA00', NULL, NULL, 166, NULL, NULL, 232728),
(258863, '1zvfB01', NULL, NULL, 168, NULL, NULL, 232728),
(258864, '3smhE02', NULL, NULL, 188, NULL, NULL, 232728),
(258865, '1yhfA01', NULL, NULL, 110, NULL, NULL, 232728),
(258866, '2h6cA01', NULL, NULL, 129, NULL, NULL, 232728),
(258867, '4dinB02', NULL, NULL, 144, NULL, NULL, 232728),
(258868, '4dinB01', NULL, NULL, 134, NULL, NULL, 232728);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(258869, '1sefA02', NULL, NULL, 119, NULL, NULL, 232728),
(258870, '2z69B00', NULL, NULL, 154, NULL, NULL, 232728),
(258871, '1uijB01', NULL, NULL, 177, NULL, NULL, 232728),
(258872, '2vecA01', NULL, NULL, 103, NULL, NULL, 232728),
(258873, '2vecA02', NULL, NULL, 124, NULL, NULL, 232728),
(258874, '2xhkB01', NULL, NULL, 128, NULL, NULL, 232728),
(258875, '5j7mA00', NULL, NULL, 123, NULL, NULL, 232728),
(258876, '1o5lA00', NULL, NULL, 141, NULL, NULL, 232728),
(258877, '1znpA00', NULL, NULL, 154, NULL, NULL, 232728),
(258878, '4b29A00', NULL, NULL, 195, NULL, NULL, 232728),
(258879, '2qvsB02', NULL, NULL, 131, NULL, NULL, 232728),
(258880, '2qvsB01', NULL, NULL, 153, NULL, NULL, 232728),
(258881, '3iwzA01', NULL, NULL, 134, NULL, NULL, 232728),
(258882, '1x8mA02', NULL, NULL, 145, NULL, NULL, 232728),
(258883, '1fi2A00', NULL, NULL, 201, NULL, NULL, 232728),
(258884, '3i7dA00', NULL, NULL, 163, NULL, NULL, 232728),
(258885, '2p17A00', NULL, NULL, 249, NULL, NULL, 232728),
(258886, '3hqxA00', NULL, NULL, 111, NULL, NULL, 232728),
(258887, '3d0jA00', NULL, NULL, 140, NULL, NULL, 232728),
(258888, '2phlA01', NULL, NULL, 204, NULL, NULL, 232728),
(258889, '4zu4C00', NULL, NULL, 148, NULL, NULL, 232728),
(258890, '4la2A00', NULL, NULL, 198, NULL, NULL, 232728),
(258891, '1ep0A00', NULL, NULL, 185, NULL, NULL, 232728),
(258892, '1xe7A00', NULL, NULL, 203, NULL, NULL, 232728),
(258893, '3la7A01', NULL, NULL, 124, NULL, NULL, 232728),
(258894, '3kgzA00', NULL, NULL, 156, NULL, NULL, 232728),
(258895, '1uikB02', NULL, NULL, 187, NULL, NULL, 232728),
(258896, '1vr3A00', NULL, NULL, 191, NULL, NULL, 232728),
(258897, '3tnpB02', NULL, NULL, 122, NULL, NULL, 232728),
(258898, '4e2gC00', NULL, NULL, 126, NULL, NULL, 232728),
(258899, '5i8tA00', NULL, NULL, 179, NULL, NULL, 232728),
(258900, '4jvaA01', NULL, NULL, 144, NULL, NULL, 232728),
(258901, '1wgpA01', NULL, NULL, 121, NULL, NULL, 232728),
(258902, '3m70A01', NULL, NULL, 107, NULL, NULL, 232728),
(258903, '2d5fA02', NULL, NULL, 158, NULL, NULL, 232728),
(258904, '5u55A02', NULL, NULL, 122, NULL, NULL, 232728),
(258905, '1ne6A01', NULL, NULL, 122, NULL, NULL, 232728),
(258906, '3ht1A00', NULL, NULL, 145, NULL, NULL, 232728),
(258907, '3dl3E00', NULL, NULL, 119, NULL, NULL, 232728),
(258908, '3h9aA01', NULL, NULL, 115, NULL, NULL, 232728),
(258909, '1omiA01', NULL, NULL, 120, NULL, NULL, 232728),
(258910, '2ixkA00', NULL, NULL, 184, NULL, NULL, 232728),
(258911, '6exmA01', NULL, NULL, 111, NULL, NULL, 232728),
(258912, '2d5fA01', NULL, NULL, 266, NULL, NULL, 232728),
(258913, '3fx3B01', NULL, NULL, 140, NULL, NULL, 232728),
(258914, '5cadA02', NULL, NULL, 195, NULL, NULL, 232728),
(258915, '5cadA01', NULL, NULL, 197, NULL, NULL, 232728),
(258916, '3sxwA00', NULL, NULL, 201, NULL, NULL, 232728),
(258917, '3qacA01', NULL, NULL, 291, NULL, NULL, 232728),
(258918, '3qacA02', NULL, NULL, 174, NULL, NULL, 232728),
(258919, '1ft9A01', NULL, NULL, 132, NULL, NULL, 232728),
(258920, '2hkxB00', NULL, NULL, 149, NULL, NULL, 232728),
(258921, '4ollA01', NULL, NULL, 149, NULL, NULL, 232728),
(258922, '1dzrA00', NULL, NULL, 183, NULL, NULL, 232728),
(258923, '5i0uA00', NULL, NULL, 200, NULL, NULL, 232728),
(258924, '2fqpA00', NULL, NULL, 97, NULL, NULL, 232728),
(258925, '6cdhA00', NULL, NULL, 200, NULL, NULL, 232728),
(258926, '1cx4A02', NULL, NULL, 152, NULL, NULL, 232728),
(258927, '4cydB01', NULL, NULL, 145, NULL, NULL, 232728),
(258928, '3dn7B00', NULL, NULL, 147, NULL, NULL, 232728),
(258929, '4e2qA00', NULL, NULL, 266, NULL, NULL, 232728),
(258930, '5jr7B02', NULL, NULL, 115, NULL, NULL, 232728),
(258931, '2bnmA02', NULL, NULL, 120, NULL, NULL, 232728),
(258932, '1sfnA00', NULL, NULL, 246, NULL, NULL, 232728),
(258933, '1oi6A00', NULL, NULL, 205, NULL, NULL, 232728),
(258934, '2pa7A00', NULL, NULL, 141, NULL, NULL, 232728),
(258935, '5bpxA00', NULL, NULL, 153, NULL, NULL, 232728),
(258936, '4hn1A00', NULL, NULL, 201, NULL, NULL, 232728),
(258937, '1rc6A00', NULL, NULL, 261, NULL, NULL, 232728),
(258938, '3fz3A02', NULL, NULL, 169, NULL, NULL, 232728),
(258939, '3fz3A01', NULL, NULL, 263, NULL, NULL, 232728);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(258940, '3zdsA02', NULL, NULL, 145, NULL, NULL, 232728),
(258941, '1qwrB01', NULL, NULL, 230, NULL, NULL, 232728),
(258942, '3fjsC00', NULL, NULL, 114, NULL, NULL, 232728),
(258943, '4e2gB00', NULL, NULL, 126, NULL, NULL, 232728),
(258944, '3cewA01', NULL, NULL, 110, NULL, NULL, 232728),
(258945, '3idbB01', NULL, NULL, 134, NULL, NULL, 232728),
(258946, '6cb4A02', NULL, NULL, 180, NULL, NULL, 232728),
(258947, '3bcwA01', NULL, NULL, 105, NULL, NULL, 232728),
(258948, '6cb4A01', NULL, NULL, 199, NULL, NULL, 232728),
(258949, '1o5uA00', NULL, NULL, 101, NULL, NULL, 232728),
(258950, '1gqgC01', NULL, NULL, 142, NULL, NULL, 232728),
(258951, '1gqgC02', NULL, NULL, 200, NULL, NULL, 232728),
(258952, '2q1zB02', NULL, NULL, 94, NULL, NULL, 232728),
(258953, '3kscB02', NULL, NULL, 170, NULL, NULL, 232728),
(258954, '4qglA00', NULL, NULL, 174, NULL, NULL, 232728),
(258955, '4h7lB00', NULL, NULL, 130, NULL, NULL, 232728),
(258956, '1o4tA00', NULL, NULL, 115, NULL, NULL, 232728),
(258957, '3rykA00', NULL, NULL, 182, NULL, NULL, 232728),
(258958, '5cu1A00', NULL, NULL, 212, NULL, NULL, 232728),
(258959, '2opkB01', NULL, NULL, 94, NULL, NULL, 232728),
(258960, '3kglA02', NULL, NULL, 175, NULL, NULL, 232728),
(258961, '3d82B00', NULL, NULL, 102, NULL, NULL, 232728),
(258962, '2mngA00', NULL, NULL, 131, NULL, NULL, 232728),
(258963, '2ozjA00', NULL, NULL, 114, NULL, NULL, 232728),
(258964, '6ndrA00', NULL, NULL, 195, NULL, NULL, 232728),
(258965, '1sq4B01', NULL, NULL, 152, NULL, NULL, 232728),
(258966, '2b8mA00', NULL, NULL, 117, NULL, NULL, 232728),
(258967, '1tq5A02', NULL, NULL, 125, NULL, NULL, 232728),
(258968, '4lejA02', NULL, NULL, 183, NULL, NULL, 232728),
(258969, '3fe5A00', NULL, NULL, 285, NULL, NULL, 232728),
(258970, '4lejA01', NULL, NULL, 207, NULL, NULL, 232728),
(258971, '4q0pA00', NULL, NULL, 260, NULL, NULL, 232728),
(258972, '3lagB00', NULL, NULL, 98, NULL, NULL, 232728),
(258973, '1qwrA02', NULL, NULL, 89, NULL, NULL, 232728),
(258974, '1tq5A01', NULL, NULL, 117, NULL, NULL, 232728),
(258975, '1uijC02', NULL, NULL, 183, NULL, NULL, 232728),
(258976, '3myxB01', NULL, NULL, 125, NULL, NULL, 232728),
(258977, '3dv8A01', NULL, NULL, 143, NULL, NULL, 232728),
(258978, '2zcwA01', NULL, NULL, 117, NULL, NULL, 232728),
(258979, '4e2gA00', NULL, NULL, 126, NULL, NULL, 232728),
(258980, '3bb6C00', NULL, NULL, 127, NULL, NULL, 232728),
(258981, '2vqaA02', NULL, NULL, 177, NULL, NULL, 232728),
(258982, '4wvzA02', NULL, NULL, 143, NULL, NULL, 232728),
(258983, '5buvB00', NULL, NULL, 178, NULL, NULL, 232728),
(258984, '5yjsB02', NULL, NULL, 198, NULL, NULL, 232728),
(258985, '5vg3A01', NULL, NULL, 198, NULL, NULL, 232728),
(258986, '1q43B02', NULL, NULL, 137, NULL, NULL, 232728),
(258987, '5vg3A02', NULL, NULL, 174, NULL, NULL, 232728),
(258988, '4yrdA02', NULL, NULL, 119, NULL, NULL, 232728),
(258989, '5by5A00', NULL, NULL, 115, NULL, NULL, 232728),
(258990, '2c0zA01', NULL, NULL, 190, NULL, NULL, 232728),
(258991, '3cf6E02', NULL, NULL, 131, NULL, NULL, 232728),
(258992, '4uxaA00', NULL, NULL, 131, NULL, NULL, 232728),
(258993, '3kscC01', NULL, NULL, 228, NULL, NULL, 232728),
(258994, '3es1A02', NULL, NULL, 132, NULL, NULL, 232728),
(258995, '2y0oA00', NULL, NULL, 175, NULL, NULL, 232728),
(258996, '3kglB01', NULL, NULL, 236, NULL, NULL, 232728),
(258997, '3d82A00', NULL, NULL, 102, NULL, NULL, 232728),
(258998, '3gydA00', NULL, NULL, 187, NULL, NULL, 232728),
(258999, '3e6cC01', NULL, NULL, 147, NULL, NULL, 232728),
(259000, '5tpvB00', NULL, NULL, 153, NULL, NULL, 232728),
(259001, '3s7iB01', NULL, NULL, 213, NULL, NULL, 232728),
(259002, '2ptmA02', NULL, NULL, 129, NULL, NULL, 232728),
(259003, '1xruA02', NULL, NULL, 158, NULL, NULL, 232728),
(259004, '1ywkC00', NULL, NULL, 264, NULL, NULL, 232728),
(259005, '3ebrA00', NULL, NULL, 159, NULL, NULL, 232728),
(259006, '5fq0A00', NULL, NULL, 114, NULL, NULL, 232728),
(259007, '1upiA00', NULL, NULL, 205, NULL, NULL, 232728),
(259008, '6d0pA02', NULL, NULL, 170, NULL, NULL, 232728),
(259009, '5yjsA02', NULL, NULL, 198, NULL, NULL, 232728),
(259010, '5yjsA01', NULL, NULL, 192, NULL, NULL, 232728);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(259011, '2eaaA01', NULL, NULL, 209, NULL, NULL, 232728),
(259012, '1wltA00', NULL, NULL, 176, NULL, NULL, 232728),
(259013, '3e6dB00', NULL, NULL, 210, NULL, NULL, 232728),
(259014, '5fpzA00', NULL, NULL, 110, NULL, NULL, 232728),
(259015, '2oyzA00', NULL, NULL, 94, NULL, NULL, 232728),
(259016, '1y9qA02', NULL, NULL, 104, NULL, NULL, 232728),
(259017, '5tpuA00', NULL, NULL, 139, NULL, NULL, 232728),
(259018, '2d93A00', NULL, NULL, 134, NULL, NULL, 232728),
(259019, '6b4sA02', NULL, NULL, 160, NULL, NULL, 232728),
(259020, '5wpwB01', NULL, NULL, 254, NULL, NULL, 232728),
(259021, '3e97A01', NULL, NULL, 146, NULL, NULL, 232728),
(259022, '1zx5A01', NULL, NULL, 217, NULL, NULL, 232728),
(259023, '1zx5A02', NULL, NULL, 83, NULL, NULL, 232728),
(259024, '4e2gH00', NULL, NULL, 126, NULL, NULL, 232728),
(259025, '5wseB00', NULL, NULL, 118, NULL, NULL, 232728),
(259026, '2e9qA02', NULL, NULL, 169, NULL, NULL, 232728),
(259027, '5h5oA00', NULL, NULL, 129, NULL, NULL, 232728),
(259028, '1yllA01', NULL, NULL, 97, NULL, NULL, 232728),
(259029, '3d82D00', NULL, NULL, 102, NULL, NULL, 232728),
(259030, '4mv2A00', NULL, NULL, 128, NULL, NULL, 232728),
(259031, '2pytA00', NULL, NULL, 133, NULL, NULL, 232728),
(259032, '3cjxA01', NULL, NULL, 150, NULL, NULL, 232728),
(259033, '2gauA01', NULL, NULL, 151, NULL, NULL, 232728),
(259034, '2e9qA01', NULL, NULL, 265, NULL, NULL, 232728),
(259035, '2qjvA01', NULL, NULL, 157, NULL, NULL, 232728),
(259036, '2oa2A01', NULL, NULL, 127, NULL, NULL, 232728),
(259037, '3eo6A00', NULL, NULL, 106, NULL, NULL, 232728),
(259038, '3uknA02', NULL, NULL, 166, NULL, NULL, 232728),
(259039, '3pnaA01', NULL, NULL, 128, NULL, NULL, 232728),
(259040, '4axoB00', NULL, NULL, 151, NULL, NULL, 232728),
(259041, '1eybA02', NULL, NULL, 146, NULL, NULL, 232728),
(259042, '2f4pA00', NULL, NULL, 147, NULL, NULL, 232728),
(259043, '4qu2A00', NULL, NULL, 318, NULL, NULL, 232728),
(259044, '5wxuA02', NULL, NULL, 162, NULL, NULL, 232728),
(259045, '1v70A00', NULL, NULL, 105, NULL, NULL, 232728),
(259046, '2vqaC01', NULL, NULL, 184, NULL, NULL, 232728),
(259047, '3l2hA01', NULL, NULL, 147, NULL, NULL, 232728),
(259048, '1xruB02', NULL, NULL, 158, NULL, NULL, 232728),
(259049, '1y3tA01', NULL, NULL, 167, NULL, NULL, 232728),
(259050, '4ev0D01', NULL, NULL, 139, NULL, NULL, 232728),
(259051, '4qm9A00', NULL, NULL, 173, NULL, NULL, 232728),
(259052, '1y3tA02', NULL, NULL, 170, NULL, NULL, 232728),
(259053, '4muvA00', NULL, NULL, 142, NULL, NULL, 232728),
(259054, '4ku8B00', NULL, NULL, 122, NULL, NULL, 232728),
(259055, '2cv6A02', NULL, NULL, 175, NULL, NULL, 232728),
(259056, '2cv6A01', NULL, NULL, 205, NULL, NULL, 232728),
(259057, '3m3iB01', NULL, NULL, 193, NULL, NULL, 232728),
(259058, '2qjvA02', NULL, NULL, 113, NULL, NULL, 232728),
(259059, '5kjzA00', NULL, NULL, 150, NULL, NULL, 232728),
(259060, '2q30A01', NULL, NULL, 88, NULL, NULL, 232728),
(259061, '1lr5B00', NULL, NULL, 163, NULL, NULL, 232728),
(259062, '5e1rA01', NULL, NULL, 196, NULL, NULL, 232728),
(259063, '6cpbA00', NULL, NULL, 141, NULL, NULL, 232728),
(259064, '2hjiA00', NULL, NULL, 156, NULL, NULL, 232728),
(259065, '4hvqA00', NULL, NULL, 154, NULL, NULL, 232728),
(259066, '6b4sB01', NULL, NULL, 266, NULL, NULL, 232728),
(259067, '4zu5A00', NULL, NULL, 144, NULL, NULL, 232728),
(259068, '5wpwA02', NULL, NULL, 170, NULL, NULL, 232728),
(259069, '4e2gG00', NULL, NULL, 126, NULL, NULL, 232728),
(259070, '3o14A00', NULL, NULL, 223, NULL, NULL, 232728),
(259071, '3ejkA00', NULL, NULL, 174, NULL, NULL, 232728),
(259072, '3bpzA02', NULL, NULL, 132, NULL, NULL, 232728),
(259073, '4l11A02', NULL, NULL, 146, NULL, NULL, 232728),
(259074, '5c8wB00', NULL, NULL, 143, NULL, NULL, 232728),
(259075, '3d0sB01', NULL, NULL, 151, NULL, NULL, 232728),
(259076, '4n9iA01', NULL, NULL, 132, NULL, NULL, 232728),
(259077, '3d82C00', NULL, NULL, 102, NULL, NULL, 232728),
(259078, '3ocpB00', NULL, NULL, 139, NULL, NULL, 232728),
(259079, '2ea7C01', NULL, NULL, 210, NULL, NULL, 232728),
(259080, '5j3uA01', NULL, NULL, 124, NULL, NULL, 232728),
(259081, '5j3uA02', NULL, NULL, 137, NULL, NULL, 232728);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(259082, '5kbfA01', NULL, NULL, 127, NULL, NULL, 232728),
(259083, '2ea7C02', NULL, NULL, 174, NULL, NULL, 232728),
(259084, '2fupA00', NULL, NULL, 131, NULL, NULL, 232729),
(259085, '3opcA01', NULL, NULL, 124, NULL, NULL, 232729),
(259086, '2l37A00', NULL, NULL, 43, NULL, NULL, 232730),
(259087, '2okuA00', NULL, NULL, 131, NULL, NULL, 232731),
(259088, '4dlqA02', NULL, NULL, 106, NULL, NULL, 232732),
(259089, '4dloB02', NULL, NULL, 124, NULL, NULL, 232732),
(259090, '1yx3A01', NULL, NULL, 41, NULL, NULL, 232733),
(259091, '2xsjC01', NULL, NULL, 41, NULL, NULL, 232733),
(259092, '1sauA01', NULL, NULL, 45, NULL, NULL, 232733),
(259093, '2v4jC01', NULL, NULL, 41, NULL, NULL, 232733),
(259094, '3or1C01', NULL, NULL, 41, NULL, NULL, 232733),
(259095, '1ji8A01', NULL, NULL, 47, NULL, NULL, 232733),
(259096, '4fyyB02', NULL, NULL, 53, NULL, NULL, 232734),
(259097, '1pg5B02', NULL, NULL, 61, NULL, NULL, 232734),
(259098, '4amcA01', NULL, NULL, 52, NULL, NULL, 232734),
(259099, '2atcB02', NULL, NULL, 52, NULL, NULL, 232734),
(259100, '2ywwB02', NULL, NULL, 51, NULL, NULL, 232734),
(259101, '2be7D02', NULL, NULL, 54, NULL, NULL, 232734),
(259102, '3sfvB02', NULL, NULL, 200, NULL, NULL, 232735),
(259103, '3hh2D01', NULL, NULL, 96, NULL, NULL, 232736),
(259104, '1apjA00', NULL, NULL, 74, NULL, NULL, 232736),
(259105, '2w86A02', NULL, NULL, 60, NULL, NULL, 232736),
(259106, '3b4vD01', NULL, NULL, 75, NULL, NULL, 232736),
(259107, '1ksqA00', NULL, NULL, 75, NULL, NULL, 232736),
(259108, '1uzkA02', NULL, NULL, 75, NULL, NULL, 232736),
(259109, '1poiA02', NULL, NULL, 53, NULL, NULL, 232737),
(259110, '2dgmC03', NULL, NULL, 107, NULL, NULL, 232738),
(259111, '3hbxA03', NULL, NULL, 88, NULL, NULL, 232738),
(259112, '4v19S00', NULL, NULL, 143, NULL, NULL, 232739),
(259113, '6g5iO00', NULL, NULL, 135, NULL, NULL, 232739),
(259114, '4cvnG00', NULL, NULL, 137, NULL, NULL, 232739),
(259115, '6az1O00', NULL, NULL, 144, NULL, NULL, 232739),
(259116, '2vqeK00', NULL, NULL, 129, NULL, NULL, 232739),
(259117, '5mmjk00', NULL, NULL, 117, NULL, NULL, 232739),
(259118, '5optV00', NULL, NULL, 144, NULL, NULL, 232739),
(259119, '5o5jK00', NULL, NULL, 116, NULL, NULL, 232739),
(259120, '5xxuO00', NULL, NULL, 130, NULL, NULL, 232739),
(259121, '6neqK00', NULL, NULL, 136, NULL, NULL, 232739),
(259122, '6faiO00', NULL, NULL, 137, NULL, NULL, 232739),
(259123, '2xzmK00', NULL, NULL, 151, NULL, NULL, 232739),
(259124, '5xyiO00', NULL, NULL, 135, NULL, NULL, 232739),
(259125, '5oomP00', NULL, NULL, 142, NULL, NULL, 232739),
(259126, '3j7aP00', NULL, NULL, 127, NULL, NULL, 232739),
(259127, '1vs5K00', NULL, NULL, 129, NULL, NULL, 232739),
(259128, '3qhqB01', NULL, NULL, 167, NULL, NULL, 232740),
(259129, '3tocB01', NULL, NULL, 161, NULL, NULL, 232740),
(259130, '6qxfA01', NULL, NULL, 157, NULL, NULL, 232740),
(259131, '3s5uE01', NULL, NULL, 158, NULL, NULL, 232740),
(259132, '4j8cA00', NULL, NULL, 46, NULL, NULL, 232741),
(259133, '1vwxT02', NULL, NULL, 62, NULL, NULL, 232742),
(259134, '1vx7V02', NULL, NULL, 62, NULL, NULL, 232742),
(259135, '4a17P02', NULL, NULL, 59, NULL, NULL, 232742),
(259136, '3u5eT02', NULL, NULL, 62, NULL, NULL, 232742),
(259137, '2wd6A00', NULL, NULL, 315, NULL, NULL, 232743),
(259138, '3ioxA02', NULL, NULL, 337, NULL, NULL, 232743),
(259139, '4qoaA00', NULL, NULL, 127, NULL, NULL, 232744),
(259140, '3dueA00', NULL, NULL, 127, NULL, NULL, 232744),
(259141, '4poiB00', NULL, NULL, 129, NULL, NULL, 232744),
(259142, '3db7A00', NULL, NULL, 127, NULL, NULL, 232744),
(259143, '4dsdA00', NULL, NULL, 129, NULL, NULL, 232744),
(259144, '3elgB00', NULL, NULL, 128, NULL, NULL, 232744),
(259145, '4jx0A01', NULL, NULL, 159, NULL, NULL, 232745),
(259146, '5e6sB02', NULL, NULL, 152, NULL, NULL, 232745),
(259147, '1yukB01', NULL, NULL, 78, NULL, NULL, 232745),
(259148, '4nehA04', NULL, NULL, 154, NULL, NULL, 232745),
(259149, '2p26A02', NULL, NULL, 123, NULL, NULL, 232745),
(259150, '4um9B02', NULL, NULL, 174, NULL, NULL, 232745),
(259151, '3v4vB01', NULL, NULL, 128, NULL, NULL, 232745),
(259152, '4wk0B02', NULL, NULL, 144, NULL, NULL, 232745); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(259153, '3t3pB02', NULL, NULL, 166, NULL, NULL, 232745),
(259154, '3fcsA03', NULL, NULL, 140, NULL, NULL, 232745),
(259155, '3fcsD02', NULL, NULL, 139, NULL, NULL, 232745),
(259156, '4g1mA03', NULL, NULL, 140, NULL, NULL, 232745),
(259157, '2vdrB02', NULL, NULL, 159, NULL, NULL, 232745),
(259158, '4um8B02', NULL, NULL, 139, NULL, NULL, 232745),
(259159, '3dclA01', NULL, NULL, 154, NULL, NULL, 232746),
(259160, '1u7iA01', NULL, NULL, 66, NULL, NULL, 232747),
(259161, '3omsA01', NULL, NULL, 65, NULL, NULL, 232747),
(259162, '1vwxg01', NULL, NULL, 38, NULL, NULL, 232748),
(259163, '3u5eg01', NULL, NULL, 38, NULL, NULL, 232748),
(259164, '1vx7a01', NULL, NULL, 38, NULL, NULL, 232748),
(259165, '4a18L01', NULL, NULL, 38, NULL, NULL, 232748),
(259166, '3h9pB00', NULL, NULL, 249, NULL, NULL, 232749),
(259167, '2kqrA01', NULL, NULL, 74, NULL, NULL, 232750),
(259168, '4zyaA00', NULL, NULL, 77, NULL, NULL, 232750),
(259169, '4zyaB00', NULL, NULL, 77, NULL, NULL, 232750),
(259170, '3i5pA01', NULL, NULL, 169, NULL, NULL, 232751),
(259171, '3rwrB02', NULL, NULL, 45, NULL, NULL, 232752),
(259172, '1ik9B02', NULL, NULL, 95, NULL, NULL, 232752),
(259173, '5cj4A02', NULL, NULL, 59, NULL, NULL, 232752),
(259174, '5cj4B02', NULL, NULL, 59, NULL, NULL, 232752),
(259175, '5cj4C02', NULL, NULL, 59, NULL, NULL, 232752),
(259176, '5cj4D02', NULL, NULL, 59, NULL, NULL, 232752),
(259177, '3mudA02', NULL, NULL, 54, NULL, NULL, 232752),
(259178, '3ii6A02', NULL, NULL, 58, NULL, NULL, 232752),
(259179, '5chxB02', NULL, NULL, 58, NULL, NULL, 232752),
(259180, '5chxA02', NULL, NULL, 58, NULL, NULL, 232752),
(259181, '5wlzC02', NULL, NULL, 55, NULL, NULL, 232752),
(259182, '1fu1B02', NULL, NULL, 56, NULL, NULL, 232752),
(259183, '1fu1A02', NULL, NULL, 60, NULL, NULL, 232752),
(259184, '4xa4A02', NULL, NULL, 56, NULL, NULL, 232752),
(259185, '5cj0B02', NULL, NULL, 59, NULL, NULL, 232752),
(259186, '1z56B00', NULL, NULL, 91, NULL, NULL, 232752),
(259187, '5wj7A02', NULL, NULL, 54, NULL, NULL, 232752),
(259188, '1g2rA00', NULL, NULL, 100, NULL, NULL, 232753),
(259189, '3oe7Q00', NULL, NULL, 137, NULL, NULL, 232754),
(259190, '5dn6I00', NULL, NULL, 84, NULL, NULL, 232754),
(259191, '5zwlE01', NULL, NULL, 88, NULL, NULL, 232754),
(259192, '2e5yA01', NULL, NULL, 88, NULL, NULL, 232754),
(259193, '5fl7H01', NULL, NULL, 94, NULL, NULL, 232754),
(259194, '6fkfe01', NULL, NULL, 87, NULL, NULL, 232754),
(259195, '1h8eH00', NULL, NULL, 103, NULL, NULL, 232754),
(259196, '2hldH01', NULL, NULL, 97, NULL, NULL, 232754),
(259197, '2qe7H01', NULL, NULL, 88, NULL, NULL, 232754),
(259198, '3oehH01', NULL, NULL, 90, NULL, NULL, 232754),
(259199, '1fs0E01', NULL, NULL, 88, NULL, NULL, 232754),
(259200, '6b46I00', NULL, NULL, 80, NULL, NULL, 232755),
(259201, '1m45A02', NULL, NULL, 75, NULL, NULL, 232756),
(259202, '3fwbA01', NULL, NULL, 90, NULL, NULL, 232756),
(259203, '1m45A01', NULL, NULL, 73, NULL, NULL, 232756),
(259204, '3akbA00', NULL, NULL, 166, NULL, NULL, 232756),
(259205, '2zfdA00', NULL, NULL, 195, NULL, NULL, 232756),
(259206, '1iq3A00', NULL, NULL, 110, NULL, NULL, 232756),
(259207, '2y5iA00', NULL, NULL, 99, NULL, NULL, 232756),
(259208, '2lhiA00', NULL, NULL, 176, NULL, NULL, 232756),
(259209, '1h4bA00', NULL, NULL, 84, NULL, NULL, 232756),
(259210, '4c0kA02', NULL, NULL, 198, NULL, NULL, 232756),
(259211, '2nxqA00', NULL, NULL, 67, NULL, NULL, 232756),
(259212, '3kheA01', NULL, NULL, 114, NULL, NULL, 232756),
(259213, '4c0kA01', NULL, NULL, 106, NULL, NULL, 232756),
(259214, '3kheA02', NULL, NULL, 77, NULL, NULL, 232756),
(259215, '1niwA01', NULL, NULL, 74, NULL, NULL, 232756),
(259216, '4cidA03', NULL, NULL, 103, NULL, NULL, 232756),
(259217, '1s6jA01', NULL, NULL, 76, NULL, NULL, 232756),
(259218, '1oe9B01', NULL, NULL, 82, NULL, NULL, 232756),
(259219, '1zmzA01', NULL, NULL, 73, NULL, NULL, 232756),
(259220, '4mzjA02', NULL, NULL, 65, NULL, NULL, 232756),
(259221, '4uslA00', NULL, NULL, 173, NULL, NULL, 232756),
(259222, '3h4sE00', NULL, NULL, 117, NULL, NULL, 232756),
(259223, '3a8rA01', NULL, NULL, 116, NULL, NULL, 232756);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(259224, '2egdB00', NULL, NULL, 98, NULL, NULL, 232756),
(259225, '1br1B01', NULL, NULL, 81, NULL, NULL, 232756),
(259226, '4l9mA03', NULL, NULL, 76, NULL, NULL, 232756),
(259227, '1br1B02', NULL, NULL, 69, NULL, NULL, 232756),
(259228, '1niwA02', NULL, NULL, 61, NULL, NULL, 232756),
(259229, '1ggzA01', NULL, NULL, 76, NULL, NULL, 232756),
(259230, '5zgmA00', NULL, NULL, 110, NULL, NULL, 232756),
(259231, '2k2aA00', NULL, NULL, 70, NULL, NULL, 232756),
(259232, '1ggzA02', NULL, NULL, 68, NULL, NULL, 232756),
(259233, '3kevA01', NULL, NULL, 92, NULL, NULL, 232756),
(259234, '3nxaB00', NULL, NULL, 100, NULL, NULL, 232756),
(259235, '1k2hA00', NULL, NULL, 93, NULL, NULL, 232756),
(259236, '1eg3A03', NULL, NULL, 91, NULL, NULL, 232756),
(259237, '4ovnG01', NULL, NULL, 122, NULL, NULL, 232756),
(259238, '1eg3A04', NULL, NULL, 82, NULL, NULL, 232756),
(259239, '4dirB00', NULL, NULL, 92, NULL, NULL, 232756),
(259240, '4yi8A01', NULL, NULL, 86, NULL, NULL, 232756),
(259241, '1jbaA02', NULL, NULL, 94, NULL, NULL, 232756),
(259242, '1jbaA01', NULL, NULL, 83, NULL, NULL, 232756),
(259243, '4yi8A02', NULL, NULL, 88, NULL, NULL, 232756),
(259244, '3fs7B00', NULL, NULL, 109, NULL, NULL, 232756),
(259245, '1c07A00', NULL, NULL, 95, NULL, NULL, 232756),
(259246, '1ig5A00', NULL, NULL, 75, NULL, NULL, 232756),
(259247, '1yx7A00', NULL, NULL, 83, NULL, NULL, 232756),
(259248, '3pn7B02', NULL, NULL, 68, NULL, NULL, 232756),
(259249, '1uurA03', NULL, NULL, 88, NULL, NULL, 232756),
(259250, '1ncxA01', NULL, NULL, 90, NULL, NULL, 232756),
(259251, '1qasA01', NULL, NULL, 88, NULL, NULL, 232756),
(259252, '4ndcB00', NULL, NULL, 186, NULL, NULL, 232756),
(259253, '2doqA01', NULL, NULL, 90, NULL, NULL, 232756),
(259254, '2f33A01', NULL, NULL, 73, NULL, NULL, 232756),
(259255, '1y6wA01', NULL, NULL, 78, NULL, NULL, 232756),
(259256, '1wlzA01', NULL, NULL, 80, NULL, NULL, 232756),
(259257, '2f33A02', NULL, NULL, 103, NULL, NULL, 232756),
(259258, '2gv5D01', NULL, NULL, 90, NULL, NULL, 232756),
(259259, '4p2yB00', NULL, NULL, 91, NULL, NULL, 232756),
(259260, '2l2eA02', NULL, NULL, 95, NULL, NULL, 232756),
(259261, '2ggzA00', NULL, NULL, 165, NULL, NULL, 232756),
(259262, '2l2eA01', NULL, NULL, 95, NULL, NULL, 232756),
(259263, '2scpA00', NULL, NULL, 174, NULL, NULL, 232756),
(259264, '3e3rB01', NULL, NULL, 87, NULL, NULL, 232756),
(259265, '1sl8A00', NULL, NULL, 191, NULL, NULL, 232756),
(259266, '5w1aB02', NULL, NULL, 65, NULL, NULL, 232756),
(259267, '5w1aB01', NULL, NULL, 82, NULL, NULL, 232756),
(259268, '2e6wA00', NULL, NULL, 100, NULL, NULL, 232756),
(259269, '4ygaA04', NULL, NULL, 87, NULL, NULL, 232756),
(259270, '4gaoA01', NULL, NULL, 90, NULL, NULL, 232756),
(259271, '4ygaA03', NULL, NULL, 93, NULL, NULL, 232756),
(259272, '5vp3A00', NULL, NULL, 206, NULL, NULL, 232756),
(259273, '3tduA01', NULL, NULL, 90, NULL, NULL, 232756),
(259274, '3hx4A01', NULL, NULL, 209, NULL, NULL, 232756),
(259275, '2f33A03', NULL, NULL, 87, NULL, NULL, 232756),
(259276, '4n5xA02', NULL, NULL, 75, NULL, NULL, 232756),
(259277, '3o4yA01', NULL, NULL, 128, NULL, NULL, 232756),
(259278, '4n5xA01', NULL, NULL, 80, NULL, NULL, 232756),
(259279, '1gjyA00', NULL, NULL, 167, NULL, NULL, 232756),
(259280, '3o4yA02', NULL, NULL, 68, NULL, NULL, 232756),
(259281, '2zndA00', NULL, NULL, 172, NULL, NULL, 232756),
(259282, '1fi5A00', NULL, NULL, 81, NULL, NULL, 232756),
(259283, '4mspB02', NULL, NULL, 76, NULL, NULL, 232756),
(259284, '2m1uA01', NULL, NULL, 67, NULL, NULL, 232756),
(259285, '1bg1A03', NULL, NULL, 122, NULL, NULL, 232756),
(259286, '4f0zB00', NULL, NULL, 170, NULL, NULL, 232756),
(259287, '4ovnH01', NULL, NULL, 122, NULL, NULL, 232756),
(259288, '1bocA00', NULL, NULL, 76, NULL, NULL, 232756),
(259289, '3zniA02', NULL, NULL, 89, NULL, NULL, 232756),
(259290, '5b8iB00', NULL, NULL, 171, NULL, NULL, 232756),
(259291, '2sasA00', NULL, NULL, 185, NULL, NULL, 232756),
(259292, '3nsoA00', NULL, NULL, 101, NULL, NULL, 232756),
(259293, '4mewA03', NULL, NULL, 173, NULL, NULL, 232756),
(259294, '4i5jA02', NULL, NULL, 169, NULL, NULL, 232756);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(259295, '1s6iA01', NULL, NULL, 76, NULL, NULL, 232756),
(259296, '2wcbA00', NULL, NULL, 95, NULL, NULL, 232756),
(259297, '4ygbB00', NULL, NULL, 78, NULL, NULL, 232756),
(259298, '1s6iA02', NULL, NULL, 112, NULL, NULL, 232756),
(259299, '2opoC00', NULL, NULL, 86, NULL, NULL, 232756),
(259300, '1k8uA00', NULL, NULL, 90, NULL, NULL, 232756),
(259301, '2hf5A00', NULL, NULL, 68, NULL, NULL, 232756),
(259302, '2aucB01', NULL, NULL, 59, NULL, NULL, 232756),
(259303, '2lv7A00', NULL, NULL, 100, NULL, NULL, 232756),
(259304, '3k21A02', NULL, NULL, 68, NULL, NULL, 232756),
(259305, '2doqB01', NULL, NULL, 90, NULL, NULL, 232756),
(259306, '3k21A01', NULL, NULL, 123, NULL, NULL, 232756),
(259307, '3e3rA02', NULL, NULL, 101, NULL, NULL, 232756),
(259308, '4gbaA01', NULL, NULL, 91, NULL, NULL, 232756),
(259309, '4jpzB01', NULL, NULL, 112, NULL, NULL, 232756),
(259310, '4ggnA02', NULL, NULL, 65, NULL, NULL, 232756),
(259311, '1j1dD01', NULL, NULL, 89, NULL, NULL, 232756),
(259312, '2ggmA02', NULL, NULL, 73, NULL, NULL, 232756),
(259313, '1sraA00', NULL, NULL, 151, NULL, NULL, 232756),
(259314, '1xfxP02', NULL, NULL, 70, NULL, NULL, 232756),
(259315, '1xfxP01', NULL, NULL, 61, NULL, NULL, 232756),
(259316, '3ox6A01', NULL, NULL, 80, NULL, NULL, 232756),
(259317, '1rfjA01', NULL, NULL, 78, NULL, NULL, 232756),
(259318, '3ox6A02', NULL, NULL, 73, NULL, NULL, 232756),
(259319, '2is9A01', NULL, NULL, 113, NULL, NULL, 232756),
(259320, '1rfjA02', NULL, NULL, 71, NULL, NULL, 232756),
(259321, '2jc2A02', NULL, NULL, 132, NULL, NULL, 232756),
(259322, '2lc5A00', NULL, NULL, 85, NULL, NULL, 232756),
(259323, '1niwC01', NULL, NULL, 74, NULL, NULL, 232756),
(259324, '2gv5A01', NULL, NULL, 90, NULL, NULL, 232756),
(259325, '2doqB02', NULL, NULL, 71, NULL, NULL, 232756),
(259326, '5vt9B02', NULL, NULL, 68, NULL, NULL, 232756),
(259327, '1a03A00', NULL, NULL, 90, NULL, NULL, 232756),
(259328, '2jnxA01', NULL, NULL, 68, NULL, NULL, 232756),
(259329, '2jnxA02', NULL, NULL, 66, NULL, NULL, 232756),
(259330, '2ggmA01', NULL, NULL, 76, NULL, NULL, 232756),
(259331, '2kbiA01', NULL, NULL, 79, NULL, NULL, 232756),
(259332, '1df0A04', NULL, NULL, 171, NULL, NULL, 232756),
(259333, '5e37A01', NULL, NULL, 86, NULL, NULL, 232756),
(259334, '5e37A02', NULL, NULL, 86, NULL, NULL, 232756),
(259335, '1a75A00', NULL, NULL, 108, NULL, NULL, 232756),
(259336, '5d7fA00', NULL, NULL, 92, NULL, NULL, 232756),
(259337, '2hpsA00', NULL, NULL, 186, NULL, NULL, 232756),
(259338, '1jfkA02', NULL, NULL, 50, NULL, NULL, 232756),
(259339, '4ovnI01', NULL, NULL, 122, NULL, NULL, 232756),
(259340, '1tizA00', NULL, NULL, 67, NULL, NULL, 232756),
(259341, '3ohmB02', NULL, NULL, 92, NULL, NULL, 232756),
(259342, '1g4yR01', NULL, NULL, 80, NULL, NULL, 232756),
(259343, '2ma2A00', NULL, NULL, 81, NULL, NULL, 232756),
(259344, '1ap4A00', NULL, NULL, 89, NULL, NULL, 232756),
(259345, '3i5gC02', NULL, NULL, 72, NULL, NULL, 232756),
(259346, '3i5gC01', NULL, NULL, 79, NULL, NULL, 232756),
(259347, '5k89C00', NULL, NULL, 94, NULL, NULL, 232756),
(259348, '2m97A00', NULL, NULL, 69, NULL, NULL, 232756),
(259349, '3ekjA02', NULL, NULL, 73, NULL, NULL, 232756),
(259350, '1fi6A00', NULL, NULL, 92, NULL, NULL, 232756),
(259351, '2mbxA00', NULL, NULL, 109, NULL, NULL, 232756),
(259352, '1bjfA01', NULL, NULL, 88, NULL, NULL, 232756),
(259353, '1bjfA02', NULL, NULL, 97, NULL, NULL, 232756),
(259354, '1jfjA02', NULL, NULL, 71, NULL, NULL, 232756),
(259355, '4d1eA04', NULL, NULL, 69, NULL, NULL, 232756),
(259356, '1y1uA03', NULL, NULL, 122, NULL, NULL, 232756),
(259357, '4mn0A00', NULL, NULL, 192, NULL, NULL, 232756),
(259358, '2qacA01', NULL, NULL, 81, NULL, NULL, 232756),
(259359, '1wdcC02', NULL, NULL, 72, NULL, NULL, 232756),
(259360, '1xfxO02', NULL, NULL, 70, NULL, NULL, 232756),
(259361, '3buxB02', NULL, NULL, 89, NULL, NULL, 232756),
(259362, '3ek4A01', NULL, NULL, 123, NULL, NULL, 232756),
(259363, '3kf9A02', NULL, NULL, 57, NULL, NULL, 232756),
(259364, '2pvbA00', NULL, NULL, 108, NULL, NULL, 232756),
(259365, '3fiaA00', NULL, NULL, 121, NULL, NULL, 232756);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(259366, '1jf0A00', NULL, NULL, 195, NULL, NULL, 232756),
(259367, '1pulA00', NULL, NULL, 108, NULL, NULL, 232756),
(259368, '1xfxO01', NULL, NULL, 61, NULL, NULL, 232756),
(259369, '2doqC01', NULL, NULL, 90, NULL, NULL, 232756),
(259370, '1qxpB04', NULL, NULL, 172, NULL, NULL, 232756),
(259371, '2gv5B01', NULL, NULL, 90, NULL, NULL, 232756),
(259372, '4pcwC00', NULL, NULL, 94, NULL, NULL, 232756),
(259373, '2otgB01', NULL, NULL, 82, NULL, NULL, 232756),
(259374, '1qjtA00', NULL, NULL, 99, NULL, NULL, 232756),
(259375, '1bu3A00', NULL, NULL, 109, NULL, NULL, 232756),
(259376, '1ttxA00', NULL, NULL, 109, NULL, NULL, 232756),
(259377, '4ovnJ01', NULL, NULL, 122, NULL, NULL, 232756),
(259378, '4dckA01', NULL, NULL, 123, NULL, NULL, 232756),
(259379, '3pm8B02', NULL, NULL, 92, NULL, NULL, 232756),
(259380, '1ij5A02', NULL, NULL, 110, NULL, NULL, 232756),
(259381, '3pm8B01', NULL, NULL, 89, NULL, NULL, 232756),
(259382, '1ij5A03', NULL, NULL, 133, NULL, NULL, 232756),
(259383, '1wdcB02', NULL, NULL, 68, NULL, NULL, 232756),
(259384, '1f54A00', NULL, NULL, 77, NULL, NULL, 232756),
(259385, '2julA00', NULL, NULL, 181, NULL, NULL, 232756),
(259386, '2o5gA00', NULL, NULL, 148, NULL, NULL, 232756),
(259387, '4aqiA00', NULL, NULL, 109, NULL, NULL, 232756),
(259388, '1snlA00', NULL, NULL, 103, NULL, NULL, 232756),
(259389, '2bkiD01', NULL, NULL, 56, NULL, NULL, 232756),
(259390, '1np8A00', NULL, NULL, 159, NULL, NULL, 232756),
(259391, '4cpvA00', NULL, NULL, 109, NULL, NULL, 232756),
(259392, '3i5gB02', NULL, NULL, 69, NULL, NULL, 232756),
(259393, '4duqB00', NULL, NULL, 98, NULL, NULL, 232756),
(259394, '1cb1A00', NULL, NULL, 78, NULL, NULL, 232756),
(259395, '3i5gB01', NULL, NULL, 78, NULL, NULL, 232756),
(259396, '2lvvA00', NULL, NULL, 226, NULL, NULL, 232756),
(259397, '2m7lA01', NULL, NULL, 86, NULL, NULL, 232756),
(259398, '2m7lA02', NULL, NULL, 58, NULL, NULL, 232756),
(259399, '1nshA00', NULL, NULL, 101, NULL, NULL, 232756),
(259400, '1k9uA00', NULL, NULL, 78, NULL, NULL, 232756),
(259401, '2ehbA00', NULL, NULL, 187, NULL, NULL, 232756),
(259402, '2zkmX02', NULL, NULL, 91, NULL, NULL, 232756),
(259403, '1k94A00', NULL, NULL, 165, NULL, NULL, 232756),
(259404, '1qx7I01', NULL, NULL, 74, NULL, NULL, 232756),
(259405, '4ggfC00', NULL, NULL, 114, NULL, NULL, 232756),
(259406, '4jwqC00', NULL, NULL, 79, NULL, NULL, 232756),
(259407, '5v89A01', NULL, NULL, 89, NULL, NULL, 232756),
(259408, '1qx7I02', NULL, NULL, 70, NULL, NULL, 232756),
(259409, '1xfxR01', NULL, NULL, 61, NULL, NULL, 232756),
(259410, '1xfxR02', NULL, NULL, 70, NULL, NULL, 232756),
(259411, '1wrkA00', NULL, NULL, 88, NULL, NULL, 232756),
(259412, '2be4A01', NULL, NULL, 83, NULL, NULL, 232756),
(259413, '1qx7A01', NULL, NULL, 76, NULL, NULL, 232756),
(259414, '1yvlA04', NULL, NULL, 121, NULL, NULL, 232756),
(259415, '3c1vB00', NULL, NULL, 113, NULL, NULL, 232756),
(259416, '5z1qA00', NULL, NULL, 75, NULL, NULL, 232756),
(259417, '1qx7A02', NULL, NULL, 68, NULL, NULL, 232756),
(259418, '1niwE01', NULL, NULL, 74, NULL, NULL, 232756),
(259419, '2be4A02', NULL, NULL, 101, NULL, NULL, 232756),
(259420, '1eh2A00', NULL, NULL, 106, NULL, NULL, 232756),
(259421, '2kldA01', NULL, NULL, 46, NULL, NULL, 232756),
(259422, '2be4A03', NULL, NULL, 88, NULL, NULL, 232756),
(259423, '2bcxA01', NULL, NULL, 73, NULL, NULL, 232756),
(259424, '1nyaA00', NULL, NULL, 176, NULL, NULL, 232756),
(259425, '1y1aA02', NULL, NULL, 87, NULL, NULL, 232756),
(259426, '1y1aA01', NULL, NULL, 96, NULL, NULL, 232756),
(259427, '5xndA00', NULL, NULL, 114, NULL, NULL, 232756),
(259428, '2f2pA02', NULL, NULL, 100, NULL, NULL, 232756),
(259429, '1wdcC01', NULL, NULL, 80, NULL, NULL, 232756),
(259430, '3qrxA02', NULL, NULL, 73, NULL, NULL, 232756),
(259431, '1qx2A00', NULL, NULL, 76, NULL, NULL, 232756),
(259432, '2kffA00', NULL, NULL, 105, NULL, NULL, 232756),
(259433, '6c0aA00', NULL, NULL, 71, NULL, NULL, 232756),
(259434, '1prwA01', NULL, NULL, 75, NULL, NULL, 232756),
(259435, '2kgrA00', NULL, NULL, 111, NULL, NULL, 232756),
(259436, '4il1B01', NULL, NULL, 186, NULL, NULL, 232756);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(259437, '5h0pA00', NULL, NULL, 104, NULL, NULL, 232756),
(259438, '2m0rA00', NULL, NULL, 104, NULL, NULL, 232756),
(259439, '3tz1A00', NULL, NULL, 74, NULL, NULL, 232756),
(259440, '2d8nA01', NULL, NULL, 82, NULL, NULL, 232756),
(259441, '1tnxA02', NULL, NULL, 78, NULL, NULL, 232756),
(259442, '2d8nA02', NULL, NULL, 88, NULL, NULL, 232756),
(259443, '1rwyA00', NULL, NULL, 109, NULL, NULL, 232756),
(259444, '1aj5A00', NULL, NULL, 173, NULL, NULL, 232756),
(259445, '5g08A01', NULL, NULL, 85, NULL, NULL, 232756),
(259446, '3pn7E01', NULL, NULL, 86, NULL, NULL, 232756),
(259447, '5g08A02', NULL, NULL, 91, NULL, NULL, 232756),
(259448, '4mvfA03', NULL, NULL, 187, NULL, NULL, 232756),
(259449, '2ncoA00', NULL, NULL, 102, NULL, NULL, 232756),
(259450, '5ibwA00', NULL, NULL, 77, NULL, NULL, 232756),
(259451, '2cxjA00', NULL, NULL, 98, NULL, NULL, 232756),
(259452, '1r2uA00', NULL, NULL, 89, NULL, NULL, 232756),
(259453, '4phjA00', NULL, NULL, 173, NULL, NULL, 232756),
(259454, '1c7vA00', NULL, NULL, 81, NULL, NULL, 232756),
(259455, '2ggmB01', NULL, NULL, 75, NULL, NULL, 232756),
(259456, '4ygcH00', NULL, NULL, 74, NULL, NULL, 232756),
(259457, '4nqgA00', NULL, NULL, 197, NULL, NULL, 232756),
(259458, '1dtlA02', NULL, NULL, 65, NULL, NULL, 232756),
(259459, '1xfxQ01', NULL, NULL, 61, NULL, NULL, 232756),
(259460, '1xfxQ02', NULL, NULL, 70, NULL, NULL, 232756),
(259461, '1kfxL04', NULL, NULL, 171, NULL, NULL, 232756),
(259462, '1xo5B00', NULL, NULL, 183, NULL, NULL, 232756),
(259463, '2pmyA00', NULL, NULL, 73, NULL, NULL, 232756),
(259464, '1j55A00', NULL, NULL, 95, NULL, NULL, 232756),
(259465, '3sjsA01', NULL, NULL, 202, NULL, NULL, 232756),
(259466, '1xk4C00', NULL, NULL, 91, NULL, NULL, 232756),
(259467, '4okhC00', NULL, NULL, 165, NULL, NULL, 232756),
(259468, '2bl0C02', NULL, NULL, 67, NULL, NULL, 232756),
(259469, '2bl0C01', NULL, NULL, 75, NULL, NULL, 232756),
(259470, '2m29A00', NULL, NULL, 72, NULL, NULL, 232756),
(259471, '1w7jB02', NULL, NULL, 60, NULL, NULL, 232756),
(259472, '2amiA00', NULL, NULL, 76, NULL, NULL, 232756),
(259473, '4ds7A02', NULL, NULL, 68, NULL, NULL, 232756),
(259474, '4ds7A01', NULL, NULL, 79, NULL, NULL, 232756),
(259475, '3jvtB01', NULL, NULL, 80, NULL, NULL, 232756),
(259476, '1smgA00', NULL, NULL, 90, NULL, NULL, 232756),
(259477, '1uhhB00', NULL, NULL, 191, NULL, NULL, 232756),
(259478, '1wlmA01', NULL, NULL, 103, NULL, NULL, 232756),
(259479, '2y4qA00', NULL, NULL, 79, NULL, NULL, 232756),
(259480, '2gv5E01', NULL, NULL, 90, NULL, NULL, 232756),
(259481, '1djxB01', NULL, NULL, 52, NULL, NULL, 232756),
(259482, '2mhhA00', NULL, NULL, 96, NULL, NULL, 232756),
(259483, '4hrgB00', NULL, NULL, 115, NULL, NULL, 232756),
(259484, '4ggfA00', NULL, NULL, 93, NULL, NULL, 232756),
(259485, '1xfxT01', NULL, NULL, 61, NULL, NULL, 232756),
(259486, '1xfxT02', NULL, NULL, 70, NULL, NULL, 232756),
(259487, '5jolA00', NULL, NULL, 82, NULL, NULL, 232756),
(259488, '2g2bA01', NULL, NULL, 139, NULL, NULL, 232756),
(259489, '2lucA00', NULL, NULL, 105, NULL, NULL, 232756),
(259490, '1niwG01', NULL, NULL, 74, NULL, NULL, 232756),
(259491, '1cdlB01', NULL, NULL, 76, NULL, NULL, 232756),
(259492, '1qv0A00', NULL, NULL, 195, NULL, NULL, 232756),
(259493, '1wy9A00', NULL, NULL, 111, NULL, NULL, 232756),
(259494, '1tcfA00', NULL, NULL, 159, NULL, NULL, 232756),
(259495, '4tncA01', NULL, NULL, 76, NULL, NULL, 232756),
(259496, '4cfrB00', NULL, NULL, 104, NULL, NULL, 232756),
(259497, '2f3yA02', NULL, NULL, 68, NULL, NULL, 232756),
(259498, '1s6cA00', NULL, NULL, 183, NULL, NULL, 232756),
(259499, '5palA00', NULL, NULL, 109, NULL, NULL, 232756),
(259500, '2bl0B02', NULL, NULL, 77, NULL, NULL, 232756),
(259501, '1pvaA00', NULL, NULL, 110, NULL, NULL, 232756),
(259502, '1topA02', NULL, NULL, 87, NULL, NULL, 232756),
(259503, '3cs1A02', NULL, NULL, 94, NULL, NULL, 232756),
(259504, '3cs1A01', NULL, NULL, 109, NULL, NULL, 232756),
(259505, '2ct9A00', NULL, NULL, 208, NULL, NULL, 232756),
(259506, '1g33A00', NULL, NULL, 73, NULL, NULL, 232756),
(259507, '2bl0B01', NULL, NULL, 68, NULL, NULL, 232756);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(259508, '1qlsA00', NULL, NULL, 99, NULL, NULL, 232756),
(259509, '2b1uA00', NULL, NULL, 71, NULL, NULL, 232756),
(259510, '3kpxA00', NULL, NULL, 198, NULL, NULL, 232756),
(259511, '3mseB00', NULL, NULL, 180, NULL, NULL, 232756),
(259512, '2lmtA01', NULL, NULL, 77, NULL, NULL, 232756),
(259513, '2kycA00', NULL, NULL, 108, NULL, NULL, 232756),
(259514, '1j7qA00', NULL, NULL, 86, NULL, NULL, 232756),
(259515, '1up5A02', NULL, NULL, 70, NULL, NULL, 232756),
(259516, '1mxeA02', NULL, NULL, 68, NULL, NULL, 232756),
(259517, '5xopA00', NULL, NULL, 66, NULL, NULL, 232756),
(259518, '5zh6B00', NULL, NULL, 107, NULL, NULL, 232756),
(259519, '1j1dA02', NULL, NULL, 65, NULL, NULL, 232756),
(259520, '2jnfA01', NULL, NULL, 74, NULL, NULL, 232756),
(259521, '1ggwA02', NULL, NULL, 70, NULL, NULL, 232756),
(259522, '1ggwA01', NULL, NULL, 67, NULL, NULL, 232756),
(259523, '4wriA00', NULL, NULL, 192, NULL, NULL, 232756),
(259524, '2aaoB00', NULL, NULL, 166, NULL, NULL, 232756),
(259525, '1qx7R01', NULL, NULL, 74, NULL, NULL, 232756),
(259526, '1exrA01', NULL, NULL, 76, NULL, NULL, 232756),
(259527, '1exrA02', NULL, NULL, 68, NULL, NULL, 232756),
(259528, '1qx7R02', NULL, NULL, 70, NULL, NULL, 232756),
(259529, '1xfxS02', NULL, NULL, 70, NULL, NULL, 232756),
(259530, '4ociA01', NULL, NULL, 73, NULL, NULL, 232756),
(259531, '1rjvA00', NULL, NULL, 110, NULL, NULL, 232756),
(259532, '4ociA02', NULL, NULL, 73, NULL, NULL, 232756),
(259533, '1xfxS01', NULL, NULL, 61, NULL, NULL, 232756),
(259534, '5hydA00', NULL, NULL, 99, NULL, NULL, 232756),
(259535, '1qx7B00', NULL, NULL, 148, NULL, NULL, 232756),
(259536, '2r2iA01', NULL, NULL, 111, NULL, NULL, 232756),
(259537, '2becA00', NULL, NULL, 202, NULL, NULL, 232756),
(259538, '3dd4A00', NULL, NULL, 229, NULL, NULL, 232756),
(259539, '1a4pA00', NULL, NULL, 96, NULL, NULL, 232756),
(259540, '2r2iA02', NULL, NULL, 87, NULL, NULL, 232756),
(259541, '5n69G02', NULL, NULL, 70, NULL, NULL, 232756),
(259542, '5n69G01', NULL, NULL, 87, NULL, NULL, 232756),
(259543, '1qtxA02', NULL, NULL, 68, NULL, NULL, 232756),
(259544, '1qtxA01', NULL, NULL, 74, NULL, NULL, 232756),
(259545, '1aj4A00', NULL, NULL, 161, NULL, NULL, 232756),
(259546, '1fpwA02', NULL, NULL, 94, NULL, NULL, 232756),
(259547, '1y1xB00', NULL, NULL, 191, NULL, NULL, 232756),
(259548, '1fpwA01', NULL, NULL, 89, NULL, NULL, 232756),
(259549, '5kszA01', NULL, NULL, 104, NULL, NULL, 232756),
(259550, '4ovnF01', NULL, NULL, 122, NULL, NULL, 232756),
(259551, '5kszA02', NULL, NULL, 196, NULL, NULL, 232756),
(259552, '4gukA01', NULL, NULL, 85, NULL, NULL, 232756),
(259553, '1rroA00', NULL, NULL, 108, NULL, NULL, 232756),
(259554, '2os8B01', NULL, NULL, 65, NULL, NULL, 232756),
(259555, '4pe0A00', NULL, NULL, 92, NULL, NULL, 232756),
(259556, '4gukA02', NULL, NULL, 93, NULL, NULL, 232756),
(259557, '3vrpA02', NULL, NULL, 89, NULL, NULL, 232756),
(259558, '2i7aA00', NULL, NULL, 174, NULL, NULL, 232756),
(259559, '1psrA00', NULL, NULL, 100, NULL, NULL, 232756),
(259560, '3pn7C02', NULL, NULL, 72, NULL, NULL, 232756),
(259561, '3fxhA00', NULL, NULL, 116, NULL, NULL, 232757),
(259562, '2zuoA08', NULL, NULL, 78, NULL, NULL, 232758),
(259563, '3t6aA00', NULL, NULL, 333, NULL, NULL, 232759),
(259564, '3qxlA00', NULL, NULL, 246, NULL, NULL, 232759),
(259565, '4l9mA02', NULL, NULL, 270, NULL, NULL, 232759),
(259566, '4jgwB02', NULL, NULL, 300, NULL, NULL, 232759),
(259567, '6eieA02', NULL, NULL, 248, NULL, NULL, 232759),
(259568, '2ijeS00', NULL, NULL, 240, NULL, NULL, 232759),
(259569, '3t6gC00', NULL, NULL, 300, NULL, NULL, 232759),
(259570, '6axgE02', NULL, NULL, 231, NULL, NULL, 232759),
(259571, '5cm9A02', NULL, NULL, 266, NULL, NULL, 232759),
(259572, '3cf6E05', NULL, NULL, 253, NULL, NULL, 232759),
(259573, '6d55B02', NULL, NULL, 242, NULL, NULL, 232759),
(259574, '1xd4B04', NULL, NULL, 224, NULL, NULL, 232759),
(259575, '4ftdA01', NULL, NULL, 108, NULL, NULL, 232760),
(259576, '3hbzA01', NULL, NULL, 94, NULL, NULL, 232760),
(259577, '4jrlA01', NULL, NULL, 101, NULL, NULL, 232760),
(259578, '4hetA01', NULL, NULL, 106, NULL, NULL, 232760);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(259579, '5fmuC01', NULL, NULL, 131, NULL, NULL, 232761),
(259580, '5fmtB01', NULL, NULL, 133, NULL, NULL, 232761),
(259581, '2eqoA01', NULL, NULL, 131, NULL, NULL, 232761),
(259582, '1kqfB03', NULL, NULL, 48, NULL, NULL, 232762),
(259583, '5dqvB01', NULL, NULL, 106, NULL, NULL, 232763),
(259584, '2qgsB01', NULL, NULL, 99, NULL, NULL, 232763),
(259585, '3djbA01', NULL, NULL, 99, NULL, NULL, 232763),
(259586, '3b57A01', NULL, NULL, 100, NULL, NULL, 232763),
(259587, '2pjqA01', NULL, NULL, 104, NULL, NULL, 232763),
(259588, '3dtoA01', NULL, NULL, 100, NULL, NULL, 232763),
(259589, '3tixB03', NULL, NULL, 153, NULL, NULL, 232764),
(259590, '5ez3A03', NULL, NULL, 155, NULL, NULL, 232765),
(259591, '3djlA03', NULL, NULL, 156, NULL, NULL, 232765),
(259592, '5nd6B03', NULL, NULL, 130, NULL, NULL, 232766),
(259593, '2o1sD03', NULL, NULL, 127, NULL, NULL, 232766),
(259594, '3rimB03', NULL, NULL, 132, NULL, NULL, 232766),
(259595, '3uk1A03', NULL, NULL, 129, NULL, NULL, 232766),
(259596, '4c7vA03', NULL, NULL, 125, NULL, NULL, 232766),
(259597, '2o1sA03', NULL, NULL, 127, NULL, NULL, 232766),
(259598, '3ai7A03', NULL, NULL, 190, NULL, NULL, 232766),
(259599, '3komA03', NULL, NULL, 125, NULL, NULL, 232766),
(259600, '2qtcA03', NULL, NULL, 181, NULL, NULL, 232766),
(259601, '2o1sC03', NULL, NULL, 127, NULL, NULL, 232766),
(259602, '1umdB02', NULL, NULL, 128, NULL, NULL, 232766),
(259603, '2o1sB03', NULL, NULL, 127, NULL, NULL, 232766),
(259604, '3ahcA03', NULL, NULL, 182, NULL, NULL, 232766),
(259605, '3m49A03', NULL, NULL, 127, NULL, NULL, 232766),
(259606, '1w85B02', NULL, NULL, 133, NULL, NULL, 232766),
(259607, '3l84A03', NULL, NULL, 118, NULL, NULL, 232766),
(259608, '1ik6A02', NULL, NULL, 125, NULL, NULL, 232766),
(259609, '4xeuA03', NULL, NULL, 128, NULL, NULL, 232766),
(259610, '4kxwA03', NULL, NULL, 148, NULL, NULL, 232766),
(259611, '3ju3A00', NULL, NULL, 118, NULL, NULL, 232766),
(259612, '2r8oB03', NULL, NULL, 132, NULL, NULL, 232766),
(259613, '5xvtA03', NULL, NULL, 137, NULL, NULL, 232766),
(259614, '2e6kA03', NULL, NULL, 121, NULL, NULL, 232766),
(259615, '2o1xD03', NULL, NULL, 133, NULL, NULL, 232766),
(259616, '2bfdB02', NULL, NULL, 125, NULL, NULL, 232766),
(259617, '5vrbA03', NULL, NULL, 125, NULL, NULL, 232766),
(259618, '5exeA02', NULL, NULL, 144, NULL, NULL, 232766),
(259619, '2c42A02', NULL, NULL, 157, NULL, NULL, 232766),
(259620, '1qs0B02', NULL, NULL, 134, NULL, NULL, 232766),
(259621, '1r9jA03', NULL, NULL, 137, NULL, NULL, 232766),
(259622, '1gpuA03', NULL, NULL, 137, NULL, NULL, 232766),
(259623, '1itzA03', NULL, NULL, 127, NULL, NULL, 232766),
(259624, '2ozlB02', NULL, NULL, 134, NULL, NULL, 232766),
(259625, '3i08A02', NULL, NULL, 96, NULL, NULL, 232767),
(259626, '3i08A01', NULL, NULL, 81, NULL, NULL, 232767),
(259627, '2v7kA01', NULL, NULL, 118, NULL, NULL, 232768),
(259628, '2v9kA03', NULL, NULL, 125, NULL, NULL, 232769),
(259629, '2v7sA00', NULL, NULL, 181, NULL, NULL, 232770),
(259630, '1tlqA00', NULL, NULL, 166, NULL, NULL, 232771),
(259631, '1rfzC00', NULL, NULL, 168, NULL, NULL, 232771),
(259632, '1y9iA00', NULL, NULL, 178, NULL, NULL, 232771),
(259633, '3b4sB01', NULL, NULL, 51, NULL, NULL, 232772),
(259634, '2gfhA02', NULL, NULL, 90, NULL, NULL, 232773),
(259635, '1mmdA06', NULL, NULL, 71, NULL, NULL, 232774),
(259636, '2x51A06', NULL, NULL, 67, NULL, NULL, 232774),
(259637, '1ciyA02', NULL, NULL, 196, NULL, NULL, 232775),
(259638, '4arxA03', NULL, NULL, 197, NULL, NULL, 232775),
(259639, '1ji6A03', NULL, NULL, 199, NULL, NULL, 232775),
(259640, '3eb7A03', NULL, NULL, 197, NULL, NULL, 232775),
(259641, '2c9kA03', NULL, NULL, 199, NULL, NULL, 232775),
(259642, '1i5pA03', NULL, NULL, 198, NULL, NULL, 232775),
(259643, '1w99A03', NULL, NULL, 180, NULL, NULL, 232775),
(259644, '1dlcA03', NULL, NULL, 197, NULL, NULL, 232775),
(259645, '2qdjA02', NULL, NULL, 77, NULL, NULL, 232776),
(259646, '1hr7C02', NULL, NULL, 234, NULL, NULL, 232777),
(259647, '3cwwA02', NULL, NULL, 230, NULL, NULL, 232777),
(259648, '4nnzA02', NULL, NULL, 198, NULL, NULL, 232777),
(259649, '3cwwA01', NULL, NULL, 256, NULL, NULL, 232777);
INSERT INTO "PUBLIC"."MODEL" VALUES
(259650, '4nnzA01', NULL, NULL, 225, NULL, NULL, 232777),
(259651, '3cwwA04', NULL, NULL, 251, NULL, NULL, 232777),
(259652, '3cwwA03', NULL, NULL, 227, NULL, NULL, 232777),
(259653, '3eoqA01', NULL, NULL, 212, NULL, NULL, 232777),
(259654, '3amiA01', NULL, NULL, 225, NULL, NULL, 232777),
(259655, '3amiA02', NULL, NULL, 199, NULL, NULL, 232777),
(259656, '4rpuB02', NULL, NULL, 235, NULL, NULL, 232777),
(259657, '3ivlA00', NULL, NULL, 208, NULL, NULL, 232777),
(259658, '4rpuB03', NULL, NULL, 226, NULL, NULL, 232777),
(259659, '2fgeA01', NULL, NULL, 265, NULL, NULL, 232777),
(259660, '2fgeA02', NULL, NULL, 239, NULL, NULL, 232777),
(259661, '2fgeA03', NULL, NULL, 241, NULL, NULL, 232777),
(259662, '2fgeA04', NULL, NULL, 250, NULL, NULL, 232777),
(259663, '3cx5A01', NULL, NULL, 202, NULL, NULL, 232777),
(259664, '2a06A02', NULL, NULL, 208, NULL, NULL, 232777),
(259665, '3cx5A02', NULL, NULL, 223, NULL, NULL, 232777),
(259666, '4l3tA03', NULL, NULL, 226, NULL, NULL, 232777),
(259667, '3gwbA01', NULL, NULL, 213, NULL, NULL, 232777),
(259668, '4l3tA02', NULL, NULL, 235, NULL, NULL, 232777),
(259669, '4l3tA01', NULL, NULL, 270, NULL, NULL, 232777),
(259670, '1bccA01', NULL, NULL, 214, NULL, NULL, 232777),
(259671, '3gwbA02', NULL, NULL, 206, NULL, NULL, 232777),
(259672, '1bccA02', NULL, NULL, 204, NULL, NULL, 232777),
(259673, '1hr6B02', NULL, NULL, 208, NULL, NULL, 232777),
(259674, '5eufA02', NULL, NULL, 190, NULL, NULL, 232777),
(259675, '1hr6B01', NULL, NULL, 217, NULL, NULL, 232777),
(259676, '3d3yA01', NULL, NULL, 235, NULL, NULL, 232777),
(259677, '3tguB02', NULL, NULL, 201, NULL, NULL, 232777),
(259678, '3d3yA02', NULL, NULL, 190, NULL, NULL, 232777),
(259679, '3amjB02', NULL, NULL, 203, NULL, NULL, 232777),
(259680, '3amjB01', NULL, NULL, 216, NULL, NULL, 232777),
(259681, '5xteL01', NULL, NULL, 214, NULL, NULL, 232777),
(259682, '5xteL02', NULL, NULL, 204, NULL, NULL, 232777),
(259683, '1q2lA04', NULL, NULL, 230, NULL, NULL, 232777),
(259684, '1q2lA03', NULL, NULL, 230, NULL, NULL, 232777),
(259685, '1q2lA02', NULL, NULL, 231, NULL, NULL, 232777),
(259686, '1q2lA01', NULL, NULL, 248, NULL, NULL, 232777),
(259687, '4ngeA03', NULL, NULL, 226, NULL, NULL, 232777),
(259688, '4iofB01', NULL, NULL, 189, NULL, NULL, 232777),
(259689, '4rpuA03', NULL, NULL, 226, NULL, NULL, 232777),
(259690, '3tguO01', NULL, NULL, 210, NULL, NULL, 232777),
(259691, '2a06B02', NULL, NULL, 204, NULL, NULL, 232777),
(259692, '2a06B01', NULL, NULL, 235, NULL, NULL, 232777),
(259693, '3cx5B02', NULL, NULL, 135, NULL, NULL, 232777),
(259694, '3eoqB02', NULL, NULL, 183, NULL, NULL, 232777),
(259695, '3cx5B01', NULL, NULL, 211, NULL, NULL, 232777),
(259696, '4l3tB02', NULL, NULL, 235, NULL, NULL, 232777),
(259697, '4l3tB01', NULL, NULL, 270, NULL, NULL, 232777),
(259698, '3go9A01', NULL, NULL, 249, NULL, NULL, 232777),
(259699, '3go9A02', NULL, NULL, 216, NULL, NULL, 232777),
(259700, '4l3tB04', NULL, NULL, 283, NULL, NULL, 232777),
(259701, '1bccB02', NULL, NULL, 201, NULL, NULL, 232777),
(259702, '4l3tB03', NULL, NULL, 226, NULL, NULL, 232777),
(259703, '1bccB01', NULL, NULL, 210, NULL, NULL, 232777),
(259704, '5eufB01', NULL, NULL, 228, NULL, NULL, 232777),
(259705, '3tguA01', NULL, NULL, 214, NULL, NULL, 232777),
(259706, '3p7lA01', NULL, NULL, 244, NULL, NULL, 232777),
(259707, '3tguA02', NULL, NULL, 204, NULL, NULL, 232777),
(259708, '3p7lA04', NULL, NULL, 251, NULL, NULL, 232777),
(259709, '4xeaA02', NULL, NULL, 192, NULL, NULL, 232777),
(259710, '4xeaA01', NULL, NULL, 231, NULL, NULL, 232777),
(259711, '3hdiA02', NULL, NULL, 204, NULL, NULL, 232777),
(259712, '1hr6A01', NULL, NULL, 214, NULL, NULL, 232777),
(259713, '1pp9A01', NULL, NULL, 214, NULL, NULL, 232777),
(259714, '3hdiA01', NULL, NULL, 217, NULL, NULL, 232777),
(259715, '5xteK02', NULL, NULL, 204, NULL, NULL, 232777),
(259716, '5xteK01', NULL, NULL, 215, NULL, NULL, 232777),
(259717, '3fvqA03', NULL, NULL, 73, NULL, NULL, 232778),
(259718, '2gagC02', NULL, NULL, 80, NULL, NULL, 232779),
(259719, '1x31C02', NULL, NULL, 80, NULL, NULL, 232779),
(259720, '4mk3A02', NULL, NULL, 115, NULL, NULL, 232780);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(259721, '1pn9B02', NULL, NULL, 130, NULL, NULL, 232780),
(259722, '4gltA02', NULL, NULL, 114, NULL, NULL, 232780),
(259723, '6jwkA02', NULL, NULL, 139, NULL, NULL, 232780),
(259724, '4zxgA02', NULL, NULL, 122, NULL, NULL, 232780),
(259725, '3m3mA02', NULL, NULL, 116, NULL, NULL, 232780),
(259726, '5y7iA02', NULL, NULL, 142, NULL, NULL, 232780),
(259727, '2vctA02', NULL, NULL, 109, NULL, NULL, 232780),
(259728, '6atrA02', NULL, NULL, 109, NULL, NULL, 232780),
(259729, '4iw9A02', NULL, NULL, 113, NULL, NULL, 232780),
(259730, '1z9hA03', NULL, NULL, 155, NULL, NULL, 232780),
(259731, '4yh2B02', NULL, NULL, 142, NULL, NULL, 232780),
(259732, '5f07A02', NULL, NULL, 123, NULL, NULL, 232780),
(259733, '5eckB02', NULL, NULL, 130, NULL, NULL, 232780),
(259734, '3cbuA02', NULL, NULL, 136, NULL, NULL, 232780),
(259735, '4exjA02', NULL, NULL, 121, NULL, NULL, 232780),
(259736, '4qq7A02', NULL, NULL, 108, NULL, NULL, 232780),
(259737, '1m0uA02', NULL, NULL, 112, NULL, NULL, 232780),
(259738, '4gtuA02', NULL, NULL, 105, NULL, NULL, 232780),
(259739, '2yv9B02', NULL, NULL, 144, NULL, NULL, 232780),
(259740, '1oe8A02', NULL, NULL, 128, NULL, NULL, 232780),
(259741, '2on5A02', NULL, NULL, 115, NULL, NULL, 232780),
(259742, '4puaA02', NULL, NULL, 118, NULL, NULL, 232780),
(259743, '6n8uA02', NULL, NULL, 105, NULL, NULL, 232780),
(259744, '3ic8A02', NULL, NULL, 100, NULL, NULL, 232780),
(259745, '4q5fA02', NULL, NULL, 115, NULL, NULL, 232780),
(259746, '1r5aA02', NULL, NULL, 139, NULL, NULL, 232780),
(259747, '1b4pA02', NULL, NULL, 105, NULL, NULL, 232780),
(259748, '6j3gB02', NULL, NULL, 148, NULL, NULL, 232780),
(259749, '4isdB02', NULL, NULL, 109, NULL, NULL, 232780),
(259750, '5ld0A02', NULL, NULL, 109, NULL, NULL, 232780),
(259751, '4pngA02', NULL, NULL, 143, NULL, NULL, 232780),
(259752, '3mdkA02', NULL, NULL, 105, NULL, NULL, 232780),
(259753, '1e6bA02', NULL, NULL, 130, NULL, NULL, 232780),
(259754, '4zb6B02', NULL, NULL, 131, NULL, NULL, 232780),
(259755, '3vurA02', NULL, NULL, 113, NULL, NULL, 232780),
(259756, '4gf0A02', NULL, NULL, 113, NULL, NULL, 232780),
(259757, '2hraA02', NULL, NULL, 91, NULL, NULL, 232780),
(259758, '4o7hB02', NULL, NULL, 120, NULL, NULL, 232780),
(259759, '5zwpA02', NULL, NULL, 131, NULL, NULL, 232780),
(259760, '1yq1A02', NULL, NULL, 116, NULL, NULL, 232780),
(259761, '2hnlA02', NULL, NULL, 110, NULL, NULL, 232780),
(259762, '3ubkB02', NULL, NULL, 131, NULL, NULL, 232780),
(259763, '3vk9A02', NULL, NULL, 136, NULL, NULL, 232780),
(259764, '2ws2A02', NULL, NULL, 113, NULL, NULL, 232780),
(259765, '4chsA02', NULL, NULL, 132, NULL, NULL, 232780),
(259766, '3f6dB02', NULL, NULL, 139, NULL, NULL, 232780),
(259767, '2yv9A02', NULL, NULL, 181, NULL, NULL, 232780),
(259768, '5j4uA02', NULL, NULL, 132, NULL, NULL, 232780),
(259769, '1f2eA02', NULL, NULL, 106, NULL, NULL, 232780),
(259770, '1k0oB02', NULL, NULL, 144, NULL, NULL, 232780),
(259771, '3lxzB02', NULL, NULL, 149, NULL, NULL, 232780),
(259772, '2dc5A02', NULL, NULL, 105, NULL, NULL, 232780),
(259773, '5f06A02', NULL, NULL, 123, NULL, NULL, 232780),
(259774, '3touA02', NULL, NULL, 115, NULL, NULL, 232780),
(259775, '3ppuB02', NULL, NULL, 113, NULL, NULL, 232780),
(259776, '1zl9A02', NULL, NULL, 114, NULL, NULL, 232780),
(259777, '3ir4A02', NULL, NULL, 126, NULL, NULL, 232780),
(259778, '2cz2A02', NULL, NULL, 127, NULL, NULL, 232780),
(259779, '4j2fA02', NULL, NULL, 137, NULL, NULL, 232780),
(259780, '4mpgA02', NULL, NULL, 162, NULL, NULL, 232780),
(259781, '5yx1A02', NULL, NULL, 108, NULL, NULL, 232780),
(259782, '5fhiA02', NULL, NULL, 139, NULL, NULL, 232780),
(259783, '1pmtA02', NULL, NULL, 107, NULL, NULL, 232780),
(259784, '1f3aA02', NULL, NULL, 109, NULL, NULL, 232780),
(259785, '1jlvA02', NULL, NULL, 132, NULL, NULL, 232780),
(259786, '4hojA02', NULL, NULL, 106, NULL, NULL, 232780),
(259787, '4e8hA02', NULL, NULL, 136, NULL, NULL, 232780),
(259788, '5g5aA02', NULL, NULL, 134, NULL, NULL, 232780),
(259789, '1nhyA02', NULL, NULL, 140, NULL, NULL, 232780),
(259790, '5h5lB02', NULL, NULL, 111, NULL, NULL, 232780),
(259791, '4bvxA02', NULL, NULL, 105, NULL, NULL, 232780);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(259792, '2gsrA02', NULL, NULL, 108, NULL, NULL, 232780),
(259793, '4fquA02', NULL, NULL, 111, NULL, NULL, 232780),
(259794, '2wb9A02', NULL, NULL, 128, NULL, NULL, 232780),
(259795, '6gsvA02', NULL, NULL, 105, NULL, NULL, 232780),
(259796, '2aheA02', NULL, NULL, 145, NULL, NULL, 232780),
(259797, '2vo4A02', NULL, NULL, 132, NULL, NULL, 232780),
(259798, '5u56A02', NULL, NULL, 112, NULL, NULL, 232780),
(259799, '1fheA02', NULL, NULL, 105, NULL, NULL, 232780),
(259800, '4f0bA02', NULL, NULL, 112, NULL, NULL, 232780),
(259801, '4kgiA02', NULL, NULL, 106, NULL, NULL, 232780),
(259802, '3r2qA02', NULL, NULL, 113, NULL, NULL, 232780),
(259803, '4pxoA02', NULL, NULL, 132, NULL, NULL, 232780),
(259804, '3isoA02', NULL, NULL, 105, NULL, NULL, 232780),
(259805, '3wd6A02', NULL, NULL, 118, NULL, NULL, 232780),
(259806, '2imiB02', NULL, NULL, 141, NULL, NULL, 232780),
(259807, '1tw9F02', NULL, NULL, 115, NULL, NULL, 232780),
(259808, '2ycdA02', NULL, NULL, 117, NULL, NULL, 232780),
(259809, '5lolA02', NULL, NULL, 125, NULL, NULL, 232780),
(259810, '5b7cA02', NULL, NULL, 119, NULL, NULL, 232780),
(259811, '3ay8A02', NULL, NULL, 136, NULL, NULL, 232780),
(259812, '6ji6A02', NULL, NULL, 105, NULL, NULL, 232780),
(259813, '2gsqA02', NULL, NULL, 108, NULL, NULL, 232780),
(259814, '4ri6A02', NULL, NULL, 119, NULL, NULL, 232780),
(259815, '4n0vA02', NULL, NULL, 118, NULL, NULL, 232780),
(259816, '4f0cA02', NULL, NULL, 138, NULL, NULL, 232780),
(259817, '5hfkA02', NULL, NULL, 110, NULL, NULL, 232780),
(259818, '1hqoA02', NULL, NULL, 153, NULL, NULL, 232780),
(259819, '4zbaA02', NULL, NULL, 131, NULL, NULL, 232780),
(259820, '4hz2A02', NULL, NULL, 116, NULL, NULL, 232780),
(259821, '4f03B02', NULL, NULL, 147, NULL, NULL, 232780),
(259822, '4agsB04', NULL, NULL, 139, NULL, NULL, 232780),
(259823, '4ecjA02', NULL, NULL, 109, NULL, NULL, 232780),
(259824, '3nivC02', NULL, NULL, 136, NULL, NULL, 232780),
(259825, '3w8sA02', NULL, NULL, 115, NULL, NULL, 232780),
(259826, '6n8uB02', NULL, NULL, 105, NULL, NULL, 232780),
(259827, '5ft3A02', NULL, NULL, 142, NULL, NULL, 232780),
(259828, '5an1A02', NULL, NULL, 103, NULL, NULL, 232780),
(259829, '4o92A02', NULL, NULL, 105, NULL, NULL, 232780),
(259830, '4g0iA02', NULL, NULL, 111, NULL, NULL, 232780),
(259831, '1b48A02', NULL, NULL, 109, NULL, NULL, 232780),
(259832, '2hqtK00', NULL, NULL, 124, NULL, NULL, 232780),
(259833, '4kh7B02', NULL, NULL, 118, NULL, NULL, 232780),
(259834, '2r4vA02', NULL, NULL, 144, NULL, NULL, 232780),
(259835, '4pqhA02', NULL, NULL, 132, NULL, NULL, 232780),
(259836, '2fheA02', NULL, NULL, 105, NULL, NULL, 232780),
(259837, '3fy7A02', NULL, NULL, 135, NULL, NULL, 232780),
(259838, '5y9zA02', NULL, NULL, 108, NULL, NULL, 232780),
(259839, '4agsA02', NULL, NULL, 135, NULL, NULL, 232780),
(259840, '1oyjB02', NULL, NULL, 137, NULL, NULL, 232780),
(259841, '4gciA02', NULL, NULL, 107, NULL, NULL, 232780),
(259842, '4ivfA02', NULL, NULL, 116, NULL, NULL, 232780),
(259843, '5g5eA02', NULL, NULL, 148, NULL, NULL, 232780),
(259844, '1axdA02', NULL, NULL, 123, NULL, NULL, 232780),
(259845, '4lmwA02', NULL, NULL, 145, NULL, NULL, 232780),
(259846, '3h1nA02', NULL, NULL, 120, NULL, NULL, 232780),
(259847, '4id0A02', NULL, NULL, 112, NULL, NULL, 232780),
(259848, '4kf9A02', NULL, NULL, 134, NULL, NULL, 232780),
(259849, '5yvnA02', NULL, NULL, 115, NULL, NULL, 232780),
(259850, '3rbtA02', NULL, NULL, 117, NULL, NULL, 232780),
(259851, '4nhwD02', NULL, NULL, 127, NULL, NULL, 232780),
(259852, '3c8eA02', NULL, NULL, 157, NULL, NULL, 232780),
(259853, '1fw1A02', NULL, NULL, 127, NULL, NULL, 232780),
(259854, '4mdcD02', NULL, NULL, 123, NULL, NULL, 232780),
(259855, '3vwxA02', NULL, NULL, 142, NULL, NULL, 232780),
(259856, '4lmvA02', NULL, NULL, 147, NULL, NULL, 232780),
(259857, '2c4jA02', NULL, NULL, 105, NULL, NULL, 232780),
(259858, '2n5fA02', NULL, NULL, 129, NULL, NULL, 232780),
(259859, '1tu7A02', NULL, NULL, 109, NULL, NULL, 232780),
(259860, '2vcvA02', NULL, NULL, 109, NULL, NULL, 232780),
(259861, '3m1gA02', NULL, NULL, 149, NULL, NULL, 232780),
(259862, '5d73A02', NULL, NULL, 109, NULL, NULL, 232780);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(259863, '5a4uF02', NULL, NULL, 125, NULL, NULL, 232780),
(259864, '4q5nA02', NULL, NULL, 115, NULL, NULL, 232780),
(259865, '4nhzA02', NULL, NULL, 116, NULL, NULL, 232780),
(259866, '3einA02', NULL, NULL, 131, NULL, NULL, 232780),
(259867, '2c3nA02', NULL, NULL, 160, NULL, NULL, 232780),
(259868, '4bvxB02', NULL, NULL, 107, NULL, NULL, 232780),
(259869, '2pvqA02', NULL, NULL, 106, NULL, NULL, 232780),
(259870, '4jedA02', NULL, NULL, 114, NULL, NULL, 232780),
(259871, '5f0gB02', NULL, NULL, 138, NULL, NULL, 232780),
(259872, '2x64A02', NULL, NULL, 113, NULL, NULL, 232780),
(259873, '1vf1A02', NULL, NULL, 109, NULL, NULL, 232780),
(259874, '3f6fA02', NULL, NULL, 132, NULL, NULL, 232780),
(259875, '4ussA02', NULL, NULL, 111, NULL, NULL, 232780),
(259876, '4kx4A02', NULL, NULL, 126, NULL, NULL, 232780),
(259877, '1u3iA02', NULL, NULL, 128, NULL, NULL, 232780),
(259878, '1xw6A02', NULL, NULL, 105, NULL, NULL, 232780),
(259879, '4mf5A02', NULL, NULL, 116, NULL, NULL, 232780),
(259880, '3zmlA02', NULL, NULL, 141, NULL, NULL, 232780),
(259881, '3ik7A02', NULL, NULL, 109, NULL, NULL, 232780),
(259882, '6ghfB02', NULL, NULL, 135, NULL, NULL, 232780),
(259883, '4kdxA02', NULL, NULL, 119, NULL, NULL, 232780),
(259884, '1gsuA02', NULL, NULL, 105, NULL, NULL, 232780),
(259885, '3lypA02', NULL, NULL, 106, NULL, NULL, 232780),
(259886, '3m8nA02', NULL, NULL, 117, NULL, NULL, 232780),
(259887, '2v6kA02', NULL, NULL, 130, NULL, NULL, 232780),
(259888, '2wrtA02', NULL, NULL, 105, NULL, NULL, 232780),
(259889, '4hz4A02', NULL, NULL, 112, NULL, NULL, 232780),
(259890, '3n5oA02', NULL, NULL, 131, NULL, NULL, 232780),
(259891, '4igjB02', NULL, NULL, 132, NULL, NULL, 232780),
(259892, '4mp4A02', NULL, NULL, 109, NULL, NULL, 232780),
(259893, '6eryA02', NULL, NULL, 144, NULL, NULL, 232780),
(259894, '4dejA02', NULL, NULL, 101, NULL, NULL, 232780),
(259895, '3bbyA02', NULL, NULL, 120, NULL, NULL, 232780),
(259896, '6f05I02', NULL, NULL, 123, NULL, NULL, 232780),
(259897, '4l8eA02', NULL, NULL, 110, NULL, NULL, 232780),
(259898, '1gwcA02', NULL, NULL, 147, NULL, NULL, 232780),
(259899, '2yv7A02', NULL, NULL, 145, NULL, NULL, 232780),
(259900, '1yy7A02', NULL, NULL, 105, NULL, NULL, 232780),
(259901, '1v2aA02', NULL, NULL, 134, NULL, NULL, 232780),
(259902, '3gtuB02', NULL, NULL, 105, NULL, NULL, 232780),
(259903, '3ibhA02', NULL, NULL, 118, NULL, NULL, 232780),
(259904, '3lykA02', NULL, NULL, 104, NULL, NULL, 232780),
(259905, '4q5qA02', NULL, NULL, 105, NULL, NULL, 232780),
(259906, '5uuoA02', NULL, NULL, 158, NULL, NULL, 232780),
(259907, '4i97A02', NULL, NULL, 131, NULL, NULL, 232780),
(259908, '5d9vA02', NULL, NULL, 123, NULL, NULL, 232780),
(259909, '5iqyA02', NULL, NULL, 123, NULL, NULL, 232780),
(259910, '3uarA02', NULL, NULL, 107, NULL, NULL, 232780),
(259911, '3o76A02', NULL, NULL, 108, NULL, NULL, 232780),
(259912, '6ep6A02', NULL, NULL, 133, NULL, NULL, 232780),
(259913, '3m0fB02', NULL, NULL, 132, NULL, NULL, 232780),
(259914, '5j41A02', NULL, NULL, 108, NULL, NULL, 232780),
(259915, '3wywA02', NULL, NULL, 136, NULL, NULL, 232780),
(259916, '6j3eA02', NULL, NULL, 152, NULL, NULL, 232780),
(259917, '4ptsB02', NULL, NULL, 178, NULL, NULL, 232780),
(259918, '4ielA02', NULL, NULL, 119, NULL, NULL, 232780),
(259919, '5nr1A02', NULL, NULL, 120, NULL, NULL, 232780),
(259920, '5f05A02', NULL, NULL, 126, NULL, NULL, 232780),
(259921, '5jpoD02', NULL, NULL, 138, NULL, NULL, 232780),
(259922, '4q5rA02', NULL, NULL, 112, NULL, NULL, 232780),
(259923, '2dsaA02', NULL, NULL, 106, NULL, NULL, 232780),
(259924, '3q18A02', NULL, NULL, 116, NULL, NULL, 232780),
(259925, '4g10A02', NULL, NULL, 136, NULL, NULL, 232780),
(259926, '4pqiA02', NULL, NULL, 132, NULL, NULL, 232780),
(259927, '2fnoA02', NULL, NULL, 145, NULL, NULL, 232780),
(259928, '3qavA02', NULL, NULL, 140, NULL, NULL, 232780),
(259929, '1aw9A02', NULL, NULL, 121, NULL, NULL, 232780),
(259930, '5ey6A02', NULL, NULL, 122, NULL, NULL, 232780),
(259931, '2on7A02', NULL, NULL, 115, NULL, NULL, 232780),
(259932, '4naxA02', NULL, NULL, 115, NULL, NULL, 232780),
(259933, '4jbbA02', NULL, NULL, 109, NULL, NULL, 232780);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(259934, '4ikhA02', NULL, NULL, 138, NULL, NULL, 232780),
(259935, '3lszA02', NULL, NULL, 125, NULL, NULL, 232780),
(259936, '4mzwB02', NULL, NULL, 118, NULL, NULL, 232780),
(259937, '5elgA02', NULL, NULL, 132, NULL, NULL, 232780),
(259938, '4zbdA02', NULL, NULL, 131, NULL, NULL, 232780),
(259939, '4hi7B02', NULL, NULL, 148, NULL, NULL, 232780),
(259940, '4egvA02', NULL, NULL, 75, NULL, NULL, 232781),
(259941, '5vqpA01', NULL, NULL, 253, NULL, NULL, 232782),
(259942, '5vqfD01', NULL, NULL, 244, NULL, NULL, 232782),
(259943, '3rnvA00', NULL, NULL, 123, NULL, NULL, 232783),
(259944, '4umoA00', NULL, NULL, 79, NULL, NULL, 232784),
(259945, '2vhjA02', NULL, NULL, 62, NULL, NULL, 232785),
(259946, '3fldA01', NULL, NULL, 40, NULL, NULL, 232786),
(259947, '2rp5A00', NULL, NULL, 117, NULL, NULL, 232787),
(259948, '3fggB00', NULL, NULL, 146, NULL, NULL, 232788),
(259949, '3fh3B00', NULL, NULL, 158, NULL, NULL, 232788),
(259950, '3fggA00', NULL, NULL, 147, NULL, NULL, 232788),
(259951, '3fh3A00', NULL, NULL, 158, NULL, NULL, 232788),
(259952, '4j8zA02', NULL, NULL, 27, NULL, NULL, 232789),
(259953, '2ob9A00', NULL, NULL, 130, NULL, NULL, 232790),
(259954, '3ecqA07', NULL, NULL, 56, NULL, NULL, 232791),
(259955, '3ecqB07', NULL, NULL, 61, NULL, NULL, 232791),
(259956, '3w3wA02', NULL, NULL, 31, NULL, NULL, 232792),
(259957, '2xjpA02', NULL, NULL, 34, NULL, NULL, 232793),
(259958, '1pm6A00', NULL, NULL, 72, NULL, NULL, 232794),
(259959, '1rh6A00', NULL, NULL, 55, NULL, NULL, 232794),
(259960, '3iayA06', NULL, NULL, 38, NULL, NULL, 232795),
(259961, '4c3iG02', NULL, NULL, 157, NULL, NULL, 232796),
(259962, '3icxA02', NULL, NULL, 52, NULL, NULL, 232797),
(259963, '6bn1A00', NULL, NULL, 57, NULL, NULL, 232798),
(259964, '3kypE01', NULL, NULL, 45, NULL, NULL, 232798),
(259965, '3zy1A00', NULL, NULL, 46, NULL, NULL, 232798),
(259966, '5hobA00', NULL, NULL, 50, NULL, NULL, 232798),
(259967, '4a9zB00', NULL, NULL, 61, NULL, NULL, 232798),
(259968, '3wwsA00', NULL, NULL, 51, NULL, NULL, 232798),
(259969, '3wwsB00', NULL, NULL, 49, NULL, NULL, 232798),
(259970, '4l0nJ00', NULL, NULL, 51, NULL, NULL, 232798),
(259971, '3wwsC00', NULL, NULL, 49, NULL, NULL, 232798),
(259972, '4d1lD00', NULL, NULL, 48, NULL, NULL, 232798),
(259973, '2mw4A00', NULL, NULL, 47, NULL, NULL, 232798),
(259974, '1olgA00', NULL, NULL, 42, NULL, NULL, 232798),
(259975, '3wwsD00', NULL, NULL, 49, NULL, NULL, 232798),
(259976, '2wqiA00', NULL, NULL, 51, NULL, NULL, 232798),
(259977, '4hkdC00', NULL, NULL, 53, NULL, NULL, 232798),
(259978, '4hkdD00', NULL, NULL, 53, NULL, NULL, 232798),
(259979, '4hkdA00', NULL, NULL, 53, NULL, NULL, 232798),
(259980, '4hkdB00', NULL, NULL, 53, NULL, NULL, 232798),
(259981, '4nr2B00', NULL, NULL, 51, NULL, NULL, 232798),
(259982, '4bqnA02', NULL, NULL, 127, NULL, NULL, 232799),
(259983, '2bf1A00', NULL, NULL, 316, NULL, NULL, 232800),
(259984, '4j6rG01', NULL, NULL, 359, NULL, NULL, 232800),
(259985, '3tihA01', NULL, NULL, 345, NULL, NULL, 232800),
(259986, '6cm3D01', NULL, NULL, 412, NULL, NULL, 232800),
(259987, '2i5yG00', NULL, NULL, 313, NULL, NULL, 232800),
(259988, '4r2gE00', NULL, NULL, 309, NULL, NULL, 232800),
(259989, '5vn3G01', NULL, NULL, 400, NULL, NULL, 232800),
(259990, '5te7G01', NULL, NULL, 350, NULL, NULL, 232800),
(259991, '4lstG01', NULL, NULL, 355, NULL, NULL, 232800),
(259992, '4r4nA01', NULL, NULL, 352, NULL, NULL, 232800),
(259993, '4jzzA01', NULL, NULL, 352, NULL, NULL, 232800),
(259994, '4xvsG01', NULL, NULL, 358, NULL, NULL, 232800),
(259995, '3hi1G00', NULL, NULL, 321, NULL, NULL, 232800),
(259996, '4i53B01', NULL, NULL, 358, NULL, NULL, 232800),
(259997, '2ny4A00', NULL, NULL, 317, NULL, NULL, 232800),
(259998, '3jwdB01', NULL, NULL, 370, NULL, NULL, 232800),
(259999, '5fa2A01', NULL, NULL, 353, NULL, NULL, 232800),
(260000, '4lssG01', NULL, NULL, 359, NULL, NULL, 232800),
(260001, '5t33G00', NULL, NULL, 357, NULL, NULL, 232800),
(260002, '5cayG01', NULL, NULL, 345, NULL, NULL, 232800),
(260003, '3lqaG00', NULL, NULL, 332, NULL, NULL, 232800),
(260004, '4ye4G01', NULL, NULL, 356, NULL, NULL, 232800);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(260005, '4jm2E00', NULL, NULL, 321, NULL, NULL, 232800),
(260006, '4xvtG01', NULL, NULL, 353, NULL, NULL, 232800),
(260007, '4xmpG01', NULL, NULL, 354, NULL, NULL, 232800),
(260008, '5te4G01', NULL, NULL, 360, NULL, NULL, 232800),
(260009, '3qlbB02', NULL, NULL, 541, NULL, NULL, 232801),
(260010, '1xkwA02', NULL, NULL, 538, NULL, NULL, 232801),
(260011, '1fepA02', NULL, NULL, 573, NULL, NULL, 232801),
(260012, '4b7oA02', NULL, NULL, 574, NULL, NULL, 232801),
(260013, '3fhhA02', NULL, NULL, 516, NULL, NULL, 232801),
(260014, '3v8xA02', NULL, NULL, 610, NULL, NULL, 232801),
(260015, '4cu4A02', NULL, NULL, 565, NULL, NULL, 232801),
(260016, '2hdiA02', NULL, NULL, 501, NULL, NULL, 232801),
(260017, '4aipA02', NULL, NULL, 571, NULL, NULL, 232801),
(260018, '4epaA00', NULL, NULL, 639, NULL, NULL, 232801),
(260019, '3efmA02', NULL, NULL, 518, NULL, NULL, 232801),
(260020, '5c58A02', NULL, NULL, 625, NULL, NULL, 232801),
(260021, '2w16A03', NULL, NULL, 543, NULL, NULL, 232801),
(260022, '5fokB02', NULL, NULL, 573, NULL, NULL, 232801),
(260023, '2gskA02', NULL, NULL, 464, NULL, NULL, 232801),
(260024, '1kmoA02', NULL, NULL, 519, NULL, NULL, 232801),
(260025, '2x8nA01', NULL, NULL, 97, NULL, NULL, 232802),
(260026, '3k8rA01', NULL, NULL, 68, NULL, NULL, 232802),
(260027, '4csqA00', NULL, NULL, 113, NULL, NULL, 232803),
(260028, '1j72A03', NULL, NULL, 100, NULL, NULL, 232804),
(260029, '5ivuA00', NULL, NULL, 141, NULL, NULL, 232804),
(260030, '1hqz800', NULL, NULL, 141, NULL, NULL, 232804),
(260031, '3efoB05', NULL, NULL, 121, NULL, NULL, 232804),
(260032, '1m2oA05', NULL, NULL, 105, NULL, NULL, 232804),
(260033, '1cnuA00', NULL, NULL, 137, NULL, NULL, 232804),
(260034, '5yu8H00', NULL, NULL, 166, NULL, NULL, 232804),
(260035, '1t3yA00', NULL, NULL, 141, NULL, NULL, 232804),
(260036, '2i2qA00', NULL, NULL, 137, NULL, NULL, 232804),
(260037, '2mp4A00', NULL, NULL, 165, NULL, NULL, 232804),
(260038, '1d0nA05', NULL, NULL, 96, NULL, NULL, 232804),
(260039, '5y1zA01', NULL, NULL, 134, NULL, NULL, 232804),
(260040, '1d0nA06', NULL, NULL, 127, NULL, NULL, 232804),
(260041, '1j72A02', NULL, NULL, 102, NULL, NULL, 232804),
(260042, '1d0nA03', NULL, NULL, 121, NULL, NULL, 232804),
(260043, '2w0iA00', NULL, NULL, 135, NULL, NULL, 232804),
(260044, '1j72A01', NULL, NULL, 119, NULL, NULL, 232804),
(260045, '2nutB05', NULL, NULL, 129, NULL, NULL, 232804),
(260046, '1d0nA02', NULL, NULL, 110, NULL, NULL, 232804),
(260047, '2xfaA00', NULL, NULL, 148, NULL, NULL, 232804),
(260048, '3l50A00', NULL, NULL, 136, NULL, NULL, 232804),
(260049, '3q2bA00', NULL, NULL, 124, NULL, NULL, 232804),
(260050, '1wm4A00', NULL, NULL, 142, NULL, NULL, 232804),
(260051, '3fg7A00', NULL, NULL, 121, NULL, NULL, 232804),
(260052, '1m4jA00', NULL, NULL, 142, NULL, NULL, 232804),
(260053, '1ak6A00', NULL, NULL, 174, NULL, NULL, 232804),
(260054, '5fafA00', NULL, NULL, 119, NULL, NULL, 232804),
(260055, '3ffnA03', NULL, NULL, 119, NULL, NULL, 232804),
(260056, '3fg6F03', NULL, NULL, 112, NULL, NULL, 232804),
(260057, '3tu5B00', NULL, NULL, 132, NULL, NULL, 232804),
(260058, '4pkhG00', NULL, NULL, 159, NULL, NULL, 232804),
(260059, '1svyA00', NULL, NULL, 114, NULL, NULL, 232804),
(260060, '3cipG00', NULL, NULL, 128, NULL, NULL, 232804),
(260061, '2fh1B03', NULL, NULL, 127, NULL, NULL, 232804),
(260062, '5ynrA00', NULL, NULL, 140, NULL, NULL, 232804),
(260063, '2vacA00', NULL, NULL, 134, NULL, NULL, 232804),
(260064, '3eh1A05', NULL, NULL, 129, NULL, NULL, 232804),
(260065, '2lj8A00', NULL, NULL, 144, NULL, NULL, 232804),
(260066, '4cbuG00', NULL, NULL, 127, NULL, NULL, 232804),
(260067, '3dawB00', NULL, NULL, 147, NULL, NULL, 232804),
(260068, '5a1mA00', NULL, NULL, 104, NULL, NULL, 232804),
(260069, '5l6wC00', NULL, NULL, 167, NULL, NULL, 232804),
(260070, '1rgiG03', NULL, NULL, 111, NULL, NULL, 232804),
(260071, '2lxxA00', NULL, NULL, 152, NULL, NULL, 232804),
(260072, '2vikA00', NULL, NULL, 126, NULL, NULL, 232804),
(260073, '2nutA05', NULL, NULL, 127, NULL, NULL, 232804),
(260074, '1v6fA00', NULL, NULL, 151, NULL, NULL, 232804),
(260075, '1vkkA00', NULL, NULL, 137, NULL, NULL, 232804);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(260076, '3eh2B05', NULL, NULL, 121, NULL, NULL, 232804),
(260077, '2mv2A00', NULL, NULL, 148, NULL, NULL, 232804),
(260078, '2llfA00', NULL, NULL, 107, NULL, NULL, 232804),
(260079, '1f7sA00', NULL, NULL, 139, NULL, NULL, 232804),
(260080, '1nphA01', NULL, NULL, 119, NULL, NULL, 232804),
(260081, '2kvkA00', NULL, NULL, 144, NULL, NULL, 232804),
(260082, '2l72A00', NULL, NULL, 118, NULL, NULL, 232804),
(260083, '1nphA02', NULL, NULL, 95, NULL, NULL, 232804),
(260084, '4kefA00', NULL, NULL, 143, NULL, NULL, 232804),
(260085, '2fh1A02', NULL, NULL, 95, NULL, NULL, 232804),
(260086, '3fg6A02', NULL, NULL, 94, NULL, NULL, 232804),
(260087, '3fg6A01', NULL, NULL, 99, NULL, NULL, 232804),
(260088, '1pd0A05', NULL, NULL, 152, NULL, NULL, 232804),
(260089, '1x67A01', NULL, NULL, 133, NULL, NULL, 232804),
(260090, '2fh1A01', NULL, NULL, 121, NULL, NULL, 232804),
(260091, '4lizA00', NULL, NULL, 142, NULL, NULL, 232804),
(260092, '1t44G00', NULL, NULL, 147, NULL, NULL, 232804),
(260093, '4iqnA00', NULL, NULL, 225, NULL, NULL, 232805),
(260094, '4hg1B00', NULL, NULL, 225, NULL, NULL, 232805),
(260095, '4iqnB00', NULL, NULL, 225, NULL, NULL, 232805),
(260096, '4iqnC00', NULL, NULL, 225, NULL, NULL, 232805),
(260097, '1bc9A01', NULL, NULL, 79, NULL, NULL, 232806),
(260098, '4a4pA01', NULL, NULL, 79, NULL, NULL, 232806),
(260099, '1ku1A01', NULL, NULL, 74, NULL, NULL, 232806),
(260100, '2r09A01', NULL, NULL, 78, NULL, NULL, 232806),
(260101, '4c0aA01', NULL, NULL, 96, NULL, NULL, 232806),
(260102, '1re0B01', NULL, NULL, 80, NULL, NULL, 232806),
(260103, '3ltlA01', NULL, NULL, 92, NULL, NULL, 232806),
(260104, '4jxhA01', NULL, NULL, 79, NULL, NULL, 232806),
(260105, '3ltlB01', NULL, NULL, 73, NULL, NULL, 232806),
(260106, '4d7rA01', NULL, NULL, 82, NULL, NULL, 232806),
(260107, '1xszA01', NULL, NULL, 84, NULL, NULL, 232806),
(260108, '4oiyA01', NULL, NULL, 83, NULL, NULL, 232806),
(260109, '3swvA01', NULL, NULL, 83, NULL, NULL, 232806),
(260110, '2f6mC00', NULL, NULL, 65, NULL, NULL, 232807),
(260111, '3pehA02', NULL, NULL, 44, NULL, NULL, 232808),
(260112, '1t6t200', NULL, NULL, 118, NULL, NULL, 232809),
(260113, '4edgA02', NULL, NULL, 125, NULL, NULL, 232809),
(260114, '1vddA03', NULL, NULL, 92, NULL, NULL, 232809),
(260115, '1dd9A02', NULL, NULL, 127, NULL, NULL, 232809),
(260116, '5z2vA01', NULL, NULL, 93, NULL, NULL, 232809),
(260117, '2q2eA02', NULL, NULL, 224, NULL, NULL, 232809),
(260118, '2fcjB00', NULL, NULL, 119, NULL, NULL, 232809),
(260119, '5zvqA01', NULL, NULL, 92, NULL, NULL, 232809),
(260120, '1q57G02', NULL, NULL, 126, NULL, NULL, 232809),
(260121, '2zbkA02', NULL, NULL, 231, NULL, NULL, 232809),
(260122, '3ve5A03', NULL, NULL, 122, NULL, NULL, 232809),
(260123, '2au3A03', NULL, NULL, 124, NULL, NULL, 232809),
(260124, '5gujA02', NULL, NULL, 125, NULL, NULL, 232809),
(260125, '1d3yB02', NULL, NULL, 226, NULL, NULL, 232809),
(260126, '3vdpA03', NULL, NULL, 94, NULL, NULL, 232809),
(260127, '5vazA02', NULL, NULL, 128, NULL, NULL, 232809),
(260128, '3jqoB00', NULL, NULL, 135, NULL, NULL, 232810),
(260129, '2ofqA01', NULL, NULL, 89, NULL, NULL, 232810),
(260130, '2n01B00', NULL, NULL, 106, NULL, NULL, 232810),
(260131, '4py9A01', NULL, NULL, 215, NULL, NULL, 232811),
(260132, '4rpaA01', NULL, NULL, 189, NULL, NULL, 232811),
(260133, '1i74A01', NULL, NULL, 190, NULL, NULL, 232811),
(260134, '1wpnA00', NULL, NULL, 188, NULL, NULL, 232811),
(260135, '2enxA01', NULL, NULL, 190, NULL, NULL, 232811),
(260136, '2qb7A01', NULL, NULL, 252, NULL, NULL, 232811),
(260137, '5ippC01', NULL, NULL, 201, NULL, NULL, 232811),
(260138, '1k20A01', NULL, NULL, 190, NULL, NULL, 232811),
(260139, '3devA01', NULL, NULL, 199, NULL, NULL, 232811),
(260140, '4ls9A01', NULL, NULL, 209, NULL, NULL, 232811),
(260141, '2eb0A01', NULL, NULL, 188, NULL, NULL, 232811),
(260142, '1se0A00', NULL, NULL, 116, NULL, NULL, 232812),
(260143, '5c3kA00', NULL, NULL, 110, NULL, NULL, 232812),
(260144, '1g73D00', NULL, NULL, 103, NULL, NULL, 232812),
(260145, '3hl5A00', NULL, NULL, 95, NULL, NULL, 232812),
(260146, '2uvlB00', NULL, NULL, 96, NULL, NULL, 232812);
INSERT INTO "PUBLIC"."MODEL" VALUES
(260147, '1oxnB00', NULL, NULL, 109, NULL, NULL, 232812),
(260148, '5m6nA00', NULL, NULL, 101, NULL, NULL, 232812),
(260149, '3uw4A00', NULL, NULL, 92, NULL, NULL, 232812),
(260150, '3m1dA00', NULL, NULL, 85, NULL, NULL, 232812),
(260151, '3siqE00', NULL, NULL, 136, NULL, NULL, 232812),
(260152, '2poiA00', NULL, NULL, 78, NULL, NULL, 232812),
(260153, '1m4mA00', NULL, NULL, 118, NULL, NULL, 232812),
(260154, '4hy4B00', NULL, NULL, 95, NULL, NULL, 232812),
(260155, '6exwA00', NULL, NULL, 122, NULL, NULL, 232812),
(260156, '4j44A00', NULL, NULL, 86, NULL, NULL, 232812),
(260157, '1i3oF00', NULL, NULL, 121, NULL, NULL, 232812),
(260158, '2qfaA00', NULL, NULL, 142, NULL, NULL, 232812),
(260159, '2i3hB00', NULL, NULL, 95, NULL, NULL, 232812),
(260160, '3m0aD00', NULL, NULL, 75, NULL, NULL, 232812),
(260161, '2vm5A00', NULL, NULL, 106, NULL, NULL, 232812),
(260162, '1jd5A00', NULL, NULL, 124, NULL, NULL, 232812),
(260163, '3t6pA01', NULL, NULL, 138, NULL, NULL, 232812),
(260164, '1xb0B00', NULL, NULL, 108, NULL, NULL, 232812),
(260165, '2j5dA01', NULL, NULL, 32, NULL, NULL, 232813),
(260166, '1r8jA02', NULL, NULL, 117, NULL, NULL, 232814),
(260167, '1v2zA00', NULL, NULL, 111, NULL, NULL, 232814),
(260168, '1w53A00', NULL, NULL, 84, NULL, NULL, 232814),
(260169, '1r5qA00', NULL, NULL, 102, NULL, NULL, 232814),
(260170, '1yarO01', NULL, NULL, 227, NULL, NULL, 232815),
(260171, '1avoB00', NULL, NULL, 140, NULL, NULL, 232815),
(260172, '2bcoA02', NULL, NULL, 65, NULL, NULL, 232816),
(260173, '2g9dA02', NULL, NULL, 65, NULL, NULL, 232816),
(260174, '1iq8A01', NULL, NULL, 360, NULL, NULL, 232817),
(260175, '5n6fA00', NULL, NULL, 375, NULL, NULL, 232817),
(260176, '2ashA00', NULL, NULL, 381, NULL, NULL, 232817),
(260177, '3keyA02', NULL, NULL, 96, NULL, NULL, 232818),
(260178, '2e9hA01', NULL, NULL, 113, NULL, NULL, 232819),
(260179, '2qmuC00', NULL, NULL, 138, NULL, NULL, 232819),
(260180, '2x2zD01', NULL, NULL, 152, NULL, NULL, 232820),
(260181, '2k13X00', NULL, NULL, 103, NULL, NULL, 232820),
(260182, '5eokA02', NULL, NULL, 90, NULL, NULL, 232820),
(260183, '5eokA01', NULL, NULL, 89, NULL, NULL, 232820),
(260184, '3zleI01', NULL, NULL, 100, NULL, NULL, 232820),
(260185, '5eokA04', NULL, NULL, 83, NULL, NULL, 232820),
(260186, '5eokA03', NULL, NULL, 97, NULL, NULL, 232820),
(260187, '3hmrA00', NULL, NULL, 99, NULL, NULL, 232820),
(260188, '1yxeA01', NULL, NULL, 101, NULL, NULL, 232820),
(260189, '4durB01', NULL, NULL, 82, NULL, NULL, 232820),
(260190, '3sriA01', NULL, NULL, 110, NULL, NULL, 232820),
(260191, '1gp9C01', NULL, NULL, 92, NULL, NULL, 232820),
(260192, '4aplB01', NULL, NULL, 103, NULL, NULL, 232820),
(260193, '2y8tD01', NULL, NULL, 104, NULL, NULL, 232820),
(260194, '4z0eA01', NULL, NULL, 92, NULL, NULL, 232820),
(260195, '1w8kA02', NULL, NULL, 110, NULL, NULL, 232820),
(260196, '4uv6A01', NULL, NULL, 127, NULL, NULL, 232820),
(260197, '1gmnB01', NULL, NULL, 66, NULL, NULL, 232820),
(260198, '4yivA01', NULL, NULL, 160, NULL, NULL, 232820),
(260199, '3hmsA00', NULL, NULL, 101, NULL, NULL, 232820),
(260200, '2ll3A00', NULL, NULL, 82, NULL, NULL, 232820),
(260201, '2yilA01', NULL, NULL, 83, NULL, NULL, 232820),
(260202, '1i8nA00', NULL, NULL, 90, NULL, NULL, 232820),
(260203, '3srjA01', NULL, NULL, 113, NULL, NULL, 232820),
(260204, '1hkyA00', NULL, NULL, 86, NULL, NULL, 232820),
(260205, '4apmA01', NULL, NULL, 108, NULL, NULL, 232820),
(260206, '4r1bA01', NULL, NULL, 92, NULL, NULL, 232820),
(260207, '1zw8A01', NULL, NULL, 50, NULL, NULL, 232821),
(260208, '1vicA00', NULL, NULL, 262, NULL, NULL, 232822),
(260209, '5vctA00', NULL, NULL, 302, NULL, NULL, 232822),
(260210, '4jd0A00', NULL, NULL, 251, NULL, NULL, 232822),
(260211, '4jisA00', NULL, NULL, 247, NULL, NULL, 232822),
(260212, '6ckmA00', NULL, NULL, 228, NULL, NULL, 232822),
(260213, '4y7uA00', NULL, NULL, 231, NULL, NULL, 232822),
(260214, '5ddtA00', NULL, NULL, 232, NULL, NULL, 232822),
(260215, '3k8dA00', NULL, NULL, 247, NULL, NULL, 232822),
(260216, '2ux8B00', NULL, NULL, 297, NULL, NULL, 232822),
(260217, '1qwjB00', NULL, NULL, 229, NULL, NULL, 232822); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(260218, '1e5kA00', NULL, NULL, 201, NULL, NULL, 232822),
(260219, '4d48A00', NULL, NULL, 302, NULL, NULL, 232822),
(260220, '3jukA00', NULL, NULL, 281, NULL, NULL, 232822),
(260221, '2i5kA01', NULL, NULL, 376, NULL, NULL, 232822),
(260222, '1yp2D01', NULL, NULL, 316, NULL, NULL, 232822),
(260223, '4p02A02', NULL, NULL, 242, NULL, NULL, 232822),
(260224, '3ngwA00', NULL, NULL, 208, NULL, NULL, 232822),
(260225, '5j49A00', NULL, NULL, 301, NULL, NULL, 232822),
(260226, '2d0jA00', NULL, NULL, 246, NULL, NULL, 232822),
(260227, '4irqC00', NULL, NULL, 251, NULL, NULL, 232822),
(260228, '2i5eA01', NULL, NULL, 168, NULL, NULL, 232822),
(260229, '1jv1B01', NULL, NULL, 437, NULL, NULL, 232822),
(260230, '6b5kB00', NULL, NULL, 296, NULL, NULL, 232822),
(260231, '2qh5B00', NULL, NULL, 268, NULL, NULL, 232822),
(260232, '3zf8A00', NULL, NULL, 305, NULL, NULL, 232822),
(260233, '3f1yA00', NULL, NULL, 326, NULL, NULL, 232822),
(260234, '2wawA00', NULL, NULL, 199, NULL, NULL, 232822),
(260235, '2nxvA01', NULL, NULL, 233, NULL, NULL, 232822),
(260236, '3d5nA00', NULL, NULL, 178, NULL, NULL, 232822),
(260237, '3ogzA01', NULL, NULL, 472, NULL, NULL, 232822),
(260238, '1tzfA00', NULL, NULL, 259, NULL, NULL, 232822),
(260239, '1fgxA00', NULL, NULL, 272, NULL, NULL, 232822),
(260240, '3tztA00', NULL, NULL, 272, NULL, NULL, 232822),
(260241, '5nzgA01', NULL, NULL, 379, NULL, NULL, 232822),
(260242, '3oc9A00', NULL, NULL, 405, NULL, NULL, 232822),
(260243, '3tqdA00', NULL, NULL, 256, NULL, NULL, 232822),
(260244, '1jykA00', NULL, NULL, 232, NULL, NULL, 232822),
(260245, '3rsbB00', NULL, NULL, 196, NULL, NULL, 232822),
(260246, '1iimA00', NULL, NULL, 292, NULL, NULL, 232822),
(260247, '5wegB01', NULL, NULL, 366, NULL, NULL, 232822),
(260248, '3u2uA00', NULL, NULL, 263, NULL, NULL, 232822),
(260249, '1hv9B01', NULL, NULL, 248, NULL, NULL, 232822),
(260250, '3i0gA00', NULL, NULL, 287, NULL, NULL, 232822),
(260251, '4kt7A00', NULL, NULL, 237, NULL, NULL, 232822),
(260252, '3cgxA00', NULL, NULL, 242, NULL, NULL, 232822),
(260253, '3ckjA00', NULL, NULL, 329, NULL, NULL, 232822),
(260254, '2vshA00', NULL, NULL, 236, NULL, NULL, 232822),
(260255, '2yqcA01', NULL, NULL, 450, NULL, NULL, 232822),
(260256, '5vmkA01', NULL, NULL, 232, NULL, NULL, 232822),
(260257, '2z86D02', NULL, NULL, 281, NULL, NULL, 232822),
(260258, '2yc3A00', NULL, NULL, 228, NULL, NULL, 232822),
(260259, '4g3qA01', NULL, NULL, 269, NULL, NULL, 232822),
(260260, '2ggoA01', NULL, NULL, 210, NULL, NULL, 232822),
(260261, '4evwA00', NULL, NULL, 255, NULL, NULL, 232822),
(260262, '1g9rA00', NULL, NULL, 282, NULL, NULL, 232822),
(260263, '2wvlB00', NULL, NULL, 391, NULL, NULL, 232822),
(260264, '3gueB01', NULL, NULL, 375, NULL, NULL, 232822),
(260265, '3cu0A00', NULL, NULL, 261, NULL, NULL, 232822),
(260266, '5ajoA01', NULL, NULL, 363, NULL, NULL, 232822),
(260267, '1mc3A00', NULL, NULL, 296, NULL, NULL, 232822),
(260268, '4ho4A00', NULL, NULL, 297, NULL, NULL, 232822),
(260269, '2icyA01', NULL, NULL, 359, NULL, NULL, 232822),
(260270, '1lvwD00', NULL, NULL, 295, NULL, NULL, 232822),
(260271, '2xwlB00', NULL, NULL, 223, NULL, NULL, 232822),
(260272, '2weeB00', NULL, NULL, 197, NULL, NULL, 232822),
(260273, '1xhbA01', NULL, NULL, 257, NULL, NULL, 232822),
(260274, '5i1fA00', NULL, NULL, 302, NULL, NULL, 232822),
(260275, '1h7eA00', NULL, NULL, 245, NULL, NULL, 232822),
(260276, '2xmeF00', NULL, NULL, 232, NULL, NULL, 232822),
(260277, '4ecmA00', NULL, NULL, 250, NULL, NULL, 232822),
(260278, '3r3iC01', NULL, NULL, 369, NULL, NULL, 232822),
(260279, '2dpwA00', NULL, NULL, 232, NULL, NULL, 232822),
(260280, '4uegB00', NULL, NULL, 263, NULL, NULL, 232822),
(260281, '2e8bA00', NULL, NULL, 201, NULL, NULL, 232822),
(260282, '6g9vA01', NULL, NULL, 440, NULL, NULL, 232822),
(260283, '1w55A01', NULL, NULL, 208, NULL, NULL, 232822),
(260284, '4fceA01', NULL, NULL, 230, NULL, NULL, 232822),
(260285, '4cvhA01', NULL, NULL, 241, NULL, NULL, 232822),
(260286, '4aylA00', NULL, NULL, 246, NULL, NULL, 232822),
(260287, '1h5rA00', NULL, NULL, 293, NULL, NULL, 232822),
(260288, '4mybA00', NULL, NULL, 228, NULL, NULL, 232822);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(260289, '4fcuA00', NULL, NULL, 253, NULL, NULL, 232822),
(260290, '2fy7A00', NULL, NULL, 287, NULL, NULL, 232822),
(260291, '2z86D01', NULL, NULL, 344, NULL, NULL, 232822),
(260292, '2bo4A01', NULL, NULL, 193, NULL, NULL, 232822),
(260293, '1i52A00', NULL, NULL, 236, NULL, NULL, 232822),
(260294, '2d7iA01', NULL, NULL, 386, NULL, NULL, 232822),
(260295, '3f1cB00', NULL, NULL, 246, NULL, NULL, 232822),
(260296, '1vm8B01', NULL, NULL, 449, NULL, NULL, 232822),
(260297, '5l6vI01', NULL, NULL, 300, NULL, NULL, 232822),
(260298, '1ll3A00', NULL, NULL, 266, NULL, NULL, 232822),
(260299, '1hm9A01', NULL, NULL, 260, NULL, NULL, 232822),
(260300, '3bcvA00', NULL, NULL, 218, NULL, NULL, 232822),
(260301, '1o7qA00', NULL, NULL, 289, NULL, NULL, 232822),
(260302, '3brkX01', NULL, NULL, 293, NULL, NULL, 232822),
(260303, '1vgwB00', NULL, NULL, 231, NULL, NULL, 232822),
(260304, '4d11F00', NULL, NULL, 287, NULL, NULL, 232822),
(260305, '3lw6A00', NULL, NULL, 241, NULL, NULL, 232822),
(260306, '6n0uD00', NULL, NULL, 305, NULL, NULL, 232822),
(260307, '3jtjA00', NULL, NULL, 253, NULL, NULL, 232822),
(260308, '5idsC00', NULL, NULL, 302, NULL, NULL, 232822),
(260309, '2e3dD00', NULL, NULL, 302, NULL, NULL, 232822),
(260310, '5ifyC00', NULL, NULL, 305, NULL, NULL, 232822),
(260311, '2x65A00', NULL, NULL, 336, NULL, NULL, 232822),
(260312, '4decA00', NULL, NULL, 306, NULL, NULL, 232822),
(260313, '1v84A00', NULL, NULL, 253, NULL, NULL, 232822),
(260314, '2cu2A00', NULL, NULL, 337, NULL, NULL, 232822),
(260315, '2p6wA00', NULL, NULL, 213, NULL, NULL, 232822),
(260316, '2zu9B00', NULL, NULL, 394, NULL, NULL, 232822),
(260317, '1omzB00', NULL, NULL, 269, NULL, NULL, 232822),
(260318, '3iohA00', NULL, NULL, 298, NULL, NULL, 232822),
(260319, '4zdqA00', NULL, NULL, 241, NULL, NULL, 232822),
(260320, '3oamA00', NULL, NULL, 252, NULL, NULL, 232822),
(260321, '4xwiA00', NULL, NULL, 262, NULL, NULL, 232822),
(260322, '2v0hA01', NULL, NULL, 227, NULL, NULL, 232822),
(260323, '2px7A00', NULL, NULL, 213, NULL, NULL, 232822),
(260324, '1vpaA00', NULL, NULL, 234, NULL, NULL, 232822),
(260325, '2pa4A00', NULL, NULL, 305, NULL, NULL, 232822),
(260326, '2apcA01', NULL, NULL, 226, NULL, NULL, 232822),
(260327, '3q80A00', NULL, NULL, 231, NULL, NULL, 232822),
(260328, '1s4nB00', NULL, NULL, 348, NULL, NULL, 232822),
(260329, '1yroB00', NULL, NULL, 286, NULL, NULL, 232822),
(260330, '3pnnA00', NULL, NULL, 303, NULL, NULL, 232822),
(260331, '5fuhD00', NULL, NULL, 303, NULL, NULL, 232822),
(260332, '1qg8A00', NULL, NULL, 255, NULL, NULL, 232822),
(260333, '4bqhA00', NULL, NULL, 549, NULL, NULL, 232822),
(260334, '2y6pB00', NULL, NULL, 234, NULL, NULL, 232822),
(260335, '4o3vA00', NULL, NULL, 143, NULL, NULL, 232823),
(260336, '2cc3A00', NULL, NULL, 150, NULL, NULL, 232823),
(260337, '4jf8A00', NULL, NULL, 144, NULL, NULL, 232823),
(260338, '5i97C00', NULL, NULL, 139, NULL, NULL, 232823),
(260339, '4nhfB00', NULL, NULL, 142, NULL, NULL, 232823),
(260340, '4kz1A00', NULL, NULL, 138, NULL, NULL, 232823),
(260341, '4lsoA00', NULL, NULL, 141, NULL, NULL, 232823),
(260342, '5jbsA00', NULL, NULL, 142, NULL, NULL, 232823),
(260343, '3j4uH00', NULL, NULL, 140, NULL, NULL, 232824),
(260344, '4hynA00', NULL, NULL, 202, NULL, NULL, 232825),
(260345, '4hynB00', NULL, NULL, 202, NULL, NULL, 232825),
(260346, '3hzhB00', NULL, NULL, 172, NULL, NULL, 232825),
(260347, '4fhrA00', NULL, NULL, 187, NULL, NULL, 232825),
(260348, '3hm4A00', NULL, NULL, 156, NULL, NULL, 232825),
(260349, '3h4yA00', NULL, NULL, 156, NULL, NULL, 232825),
(260350, '4gc8B00', NULL, NULL, 190, NULL, NULL, 232825),
(260351, '3iicA00', NULL, NULL, 155, NULL, NULL, 232825),
(260352, '3iicB00', NULL, NULL, 155, NULL, NULL, 232825),
(260353, '3qtaB00', NULL, NULL, 199, NULL, NULL, 232825),
(260354, '1xkoB00', NULL, NULL, 159, NULL, NULL, 232825),
(260355, '1xkrA00', NULL, NULL, 206, NULL, NULL, 232825),
(260356, '3h2dA00', NULL, NULL, 155, NULL, NULL, 232825),
(260357, '3h2dB00', NULL, NULL, 155, NULL, NULL, 232825),
(260358, '1ej6B00', NULL, NULL, 1035, NULL, NULL, 232826),
(260359, '4gipA00', NULL, NULL, 81, NULL, NULL, 232827);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(260360, '3godB02', NULL, NULL, 211, NULL, NULL, 232828),
(260361, '4n06A02', NULL, NULL, 265, NULL, NULL, 232828),
(260362, '5fclA02', NULL, NULL, 212, NULL, NULL, 232828),
(260363, '4xtkB02', NULL, NULL, 239, NULL, NULL, 232828),
(260364, '4w8kA02', NULL, NULL, 204, NULL, NULL, 232828),
(260365, '3nkeA00', NULL, NULL, 200, NULL, NULL, 232828),
(260366, '4wj0A02', NULL, NULL, 240, NULL, NULL, 232828),
(260367, '2yzsA02', NULL, NULL, 235, NULL, NULL, 232828),
(260368, '1k92A03', NULL, NULL, 64, NULL, NULL, 232829),
(260369, '6e5yA03', NULL, NULL, 69, NULL, NULL, 232829),
(260370, '4ohfA03', NULL, NULL, 77, NULL, NULL, 232830),
(260371, '2lepA00', NULL, NULL, 69, NULL, NULL, 232831),
(260372, '5kiuA00', NULL, NULL, 81, NULL, NULL, 232832),
(260373, '2q2fA00', NULL, NULL, 72, NULL, NULL, 232832),
(260374, '2ozaA03', NULL, NULL, 68, NULL, NULL, 232833),
(260375, '1vk3A04', NULL, NULL, 96, NULL, NULL, 232834),
(260376, '3hpeA00', NULL, NULL, 164, NULL, NULL, 232835),
(260377, '3q34B00', NULL, NULL, 184, NULL, NULL, 232835),
(260378, '1y0gA00', NULL, NULL, 169, NULL, NULL, 232835),
(260379, '1wubA00', NULL, NULL, 178, NULL, NULL, 232835),
(260380, '5w39A01', NULL, NULL, 159, NULL, NULL, 232835),
(260381, '5ixgA00', NULL, NULL, 169, NULL, NULL, 232835),
(260382, '2x34B00', NULL, NULL, 181, NULL, NULL, 232835),
(260383, '2x32A00', NULL, NULL, 179, NULL, NULL, 232835),
(260384, '2oxgD00', NULL, NULL, 124, NULL, NULL, 232836),
(260385, '2nncA00', NULL, NULL, 124, NULL, NULL, 232836),
(260386, '4uwqB00', NULL, NULL, 136, NULL, NULL, 232836),
(260387, '2j0wA02', NULL, NULL, 93, NULL, NULL, 232837),
(260388, '2cdqA02', NULL, NULL, 97, NULL, NULL, 232837),
(260389, '4aqfC02', NULL, NULL, 113, NULL, NULL, 232838),
(260390, '4aqgA02', NULL, NULL, 110, NULL, NULL, 232838),
(260391, '4aklA02', NULL, NULL, 113, NULL, NULL, 232838),
(260392, '4xzcA02', NULL, NULL, 119, NULL, NULL, 232838),
(260393, '3u3iA02', NULL, NULL, 109, NULL, NULL, 232838),
(260394, '3n9tA00', NULL, NULL, 290, NULL, NULL, 232839),
(260395, '5td3B00', NULL, NULL, 322, NULL, NULL, 232839),
(260396, '5umhA00', NULL, NULL, 319, NULL, NULL, 232839),
(260397, '2boyF00', NULL, NULL, 254, NULL, NULL, 232839),
(260398, '2bumA00', NULL, NULL, 209, NULL, NULL, 232839),
(260399, '3o5uA00', NULL, NULL, 257, NULL, NULL, 232839),
(260400, '1tmxB00', NULL, NULL, 293, NULL, NULL, 232839),
(260401, '2bumB00', NULL, NULL, 241, NULL, NULL, 232839),
(260402, '4whsA00', NULL, NULL, 200, NULL, NULL, 232839),
(260403, '5vxtA00', NULL, NULL, 325, NULL, NULL, 232839),
(260404, '2azqA00', NULL, NULL, 311, NULL, NULL, 232839),
(260405, '1dmhA00', NULL, NULL, 311, NULL, NULL, 232839),
(260406, '4whsD00', NULL, NULL, 238, NULL, NULL, 232839),
(260407, '3th1C00', NULL, NULL, 260, NULL, NULL, 232839),
(260408, '4ilvB00', NULL, NULL, 157, NULL, NULL, 232839),
(260409, '3hhyA02', NULL, NULL, 185, NULL, NULL, 232839),
(260410, '2xsuA00', NULL, NULL, 312, NULL, NULL, 232839),
(260411, '3ubyA00', NULL, NULL, 219, NULL, NULL, 232840),
(260412, '3sf4D00', NULL, NULL, 52, NULL, NULL, 232841),
(260413, '2p4wA02', NULL, NULL, 99, NULL, NULL, 232842),
(260414, '2koeA00', NULL, NULL, 40, NULL, NULL, 232843),
(260415, '3iynR02', NULL, NULL, 46, NULL, NULL, 232844),
(260416, '2clyB00', NULL, NULL, 123, NULL, NULL, 232845),
(260417, '3dupA02', NULL, NULL, 106, NULL, NULL, 232846),
(260418, '2n1uA00', NULL, NULL, 70, NULL, NULL, 232847),
(260419, '2kdpA00', NULL, NULL, 71, NULL, NULL, 232847),
(260420, '1n0uA03', NULL, NULL, 107, NULL, NULL, 232848),
(260421, '3ejnA03', NULL, NULL, 111, NULL, NULL, 232849),
(260422, '4lerA03', NULL, NULL, 113, NULL, NULL, 232849),
(260423, '3mx3A03', NULL, NULL, 113, NULL, NULL, 232849),
(260424, '3ehmA03', NULL, NULL, 118, NULL, NULL, 232849),
(260425, '4f52C02', NULL, NULL, 161, NULL, NULL, 232850),
(260426, '3dplC02', NULL, NULL, 173, NULL, NULL, 232850),
(260427, '4akmB00', NULL, NULL, 166, NULL, NULL, 232851),
(260428, '5gv0A00', NULL, NULL, 168, NULL, NULL, 232851),
(260429, '5bnzA02', NULL, NULL, 109, NULL, NULL, 232852),
(260430, '3afhA02', NULL, NULL, 104, NULL, NULL, 232852);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(260431, '4griA02', NULL, NULL, 123, NULL, NULL, 232852),
(260432, '4p2bA02', NULL, NULL, 109, NULL, NULL, 232852),
(260433, '2o5rA02', NULL, NULL, 123, NULL, NULL, 232852),
(260434, '6b1pA02', NULL, NULL, 109, NULL, NULL, 232852),
(260435, '2hz7A02', NULL, NULL, 109, NULL, NULL, 232852),
(260436, '1j09A03', NULL, NULL, 116, NULL, NULL, 232852),
(260437, '2cfoA02', NULL, NULL, 120, NULL, NULL, 232852),
(260438, '1qtqA04', NULL, NULL, 109, NULL, NULL, 232852),
(260439, '6b1zA02', NULL, NULL, 129, NULL, NULL, 232852),
(260440, '5h4vA02', NULL, NULL, 109, NULL, NULL, 232852),
(260441, '2ja2A02', NULL, NULL, 120, NULL, NULL, 232852),
(260442, '1z6tA05', NULL, NULL, 141, NULL, NULL, 232853),
(260443, '3sfzA04', NULL, NULL, 141, NULL, NULL, 232853),
(260444, '4axhB01', NULL, NULL, 359, NULL, NULL, 232854),
(260445, '4nurA01', NULL, NULL, 361, NULL, NULL, 232854),
(260446, '2cfuA01', NULL, NULL, 360, NULL, NULL, 232854),
(260447, '4pdxA01', NULL, NULL, 361, NULL, NULL, 232854),
(260448, '3g2oA01', NULL, NULL, 89, NULL, NULL, 232855),
(260449, '4m3oA00', NULL, NULL, 157, NULL, NULL, 232856),
(260450, '5c2yB00', NULL, NULL, 183, NULL, NULL, 232856),
(260451, '1tdjA03', NULL, NULL, 177, NULL, NULL, 232857),
(260452, '2rh3A00', NULL, NULL, 121, NULL, NULL, 232858),
(260453, '3p8cF01', NULL, NULL, 105, NULL, NULL, 232859),
(260454, '3mqzA00', NULL, NULL, 215, NULL, NULL, 232860),
(260455, '2a8eA00', NULL, NULL, 220, NULL, NULL, 232860),
(260456, '4gaaA04', NULL, NULL, 151, NULL, NULL, 232861),
(260457, '3u9wA04', NULL, NULL, 149, NULL, NULL, 232861),
(260458, '2xq0A04', NULL, NULL, 165, NULL, NULL, 232861),
(260459, '3ciaA04', NULL, NULL, 141, NULL, NULL, 232861),
(260460, '3ehfB01', NULL, NULL, 125, NULL, NULL, 232862),
(260461, '1hi9A01', NULL, NULL, 198, NULL, NULL, 232863),
(260462, '2jtxA01', NULL, NULL, 46, NULL, NULL, 232864),
(260463, '6ccgB00', NULL, NULL, 73, NULL, NULL, 232865),
(260464, '6ogjA00', NULL, NULL, 82, NULL, NULL, 232865),
(260465, '6ogkA00', NULL, NULL, 99, NULL, NULL, 232865),
(260466, '5bt2A01', NULL, NULL, 64, NULL, NULL, 232865),
(260467, '2ky8A00', NULL, NULL, 72, NULL, NULL, 232865),
(260468, '6c1tA00', NULL, NULL, 79, NULL, NULL, 232865),
(260469, '1ub1A00', NULL, NULL, 133, NULL, NULL, 232865),
(260470, '3vxvA00', NULL, NULL, 69, NULL, NULL, 232865),
(260471, '4lg7A00', NULL, NULL, 68, NULL, NULL, 232865),
(260472, '6d1tA00', NULL, NULL, 79, NULL, NULL, 232865),
(260473, '3rc3A05', NULL, NULL, 113, NULL, NULL, 232866),
(260474, '2d6fC03', NULL, NULL, 60, NULL, NULL, 232867),
(260475, '1zq1C03', NULL, NULL, 57, NULL, NULL, 232867),
(260476, '1ogpA01', NULL, NULL, 262, NULL, NULL, 232868),
(260477, '2a9dA01', NULL, NULL, 249, NULL, NULL, 232868),
(260478, '2xtsA01', NULL, NULL, 260, NULL, NULL, 232868),
(260479, '2biiA01', NULL, NULL, 239, NULL, NULL, 232868),
(260480, '1xdyG00', NULL, NULL, 279, NULL, NULL, 232868),
(260481, '2blfA01', NULL, NULL, 259, NULL, NULL, 232868),
(260482, '5k3xB01', NULL, NULL, 232, NULL, NULL, 232868),
(260483, '4hfxC00', NULL, NULL, 97, NULL, NULL, 232869),
(260484, '3nfkA00', NULL, NULL, 107, NULL, NULL, 232870),
(260485, '2vz5A00', NULL, NULL, 118, NULL, NULL, 232870),
(260486, '5dthD01', NULL, NULL, 107, NULL, NULL, 232870),
(260487, '1wifA01', NULL, NULL, 85, NULL, NULL, 232870),
(260488, '1x5rA01', NULL, NULL, 93, NULL, NULL, 232870),
(260489, '4q2qA00', NULL, NULL, 102, NULL, NULL, 232870),
(260490, '2v90A00', NULL, NULL, 96, NULL, NULL, 232870),
(260491, '1v5lA00', NULL, NULL, 103, NULL, NULL, 232870),
(260492, '4g69A00', NULL, NULL, 100, NULL, NULL, 232870),
(260493, '2edzA01', NULL, NULL, 111, NULL, NULL, 232870),
(260494, '2csjA00', NULL, NULL, 117, NULL, NULL, 232870),
(260495, '2pktA00', NULL, NULL, 91, NULL, NULL, 232870),
(260496, '1wfgA00', NULL, NULL, 131, NULL, NULL, 232870),
(260497, '1fc6A02', NULL, NULL, 92, NULL, NULL, 232870),
(260498, '3pv2A03', NULL, NULL, 88, NULL, NULL, 232870),
(260499, '4ghnA02', NULL, NULL, 105, NULL, NULL, 232870),
(260500, '3pv2A02', NULL, NULL, 111, NULL, NULL, 232870),
(260501, '3fy5B00', NULL, NULL, 91, NULL, NULL, 232870);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(260502, '2kbsA00', NULL, NULL, 92, NULL, NULL, 232870),
(260503, '4q2nD00', NULL, NULL, 103, NULL, NULL, 232870),
(260504, '5gljC00', NULL, NULL, 96, NULL, NULL, 232870),
(260505, '2pntB00', NULL, NULL, 98, NULL, NULL, 232870),
(260506, '2f0aB00', NULL, NULL, 98, NULL, NULL, 232870),
(260507, '2dlsA00', NULL, NULL, 93, NULL, NULL, 232870),
(260508, '4wyuA02', NULL, NULL, 109, NULL, NULL, 232870),
(260509, '2dm8A00', NULL, NULL, 116, NULL, NULL, 232870),
(260510, '3r0hC02', NULL, NULL, 95, NULL, NULL, 232870),
(260511, '2iwqA00', NULL, NULL, 101, NULL, NULL, 232870),
(260512, '1y8tA03', NULL, NULL, 98, NULL, NULL, 232870),
(260513, '4wyuA01', NULL, NULL, 103, NULL, NULL, 232870),
(260514, '2jikB00', NULL, NULL, 101, NULL, NULL, 232870),
(260515, '2yubA01', NULL, NULL, 110, NULL, NULL, 232870),
(260516, '4r2zA00', NULL, NULL, 91, NULL, NULL, 232870),
(260517, '1p1eA00', NULL, NULL, 101, NULL, NULL, 232870),
(260518, '5fb8C00', NULL, NULL, 102, NULL, NULL, 232870),
(260519, '5t69A02', NULL, NULL, 112, NULL, NULL, 232870),
(260520, '2kl1A01', NULL, NULL, 83, NULL, NULL, 232870),
(260521, '4gvcA00', NULL, NULL, 94, NULL, NULL, 232870),
(260522, '5zysA00', NULL, NULL, 97, NULL, NULL, 232870),
(260523, '2gzvA01', NULL, NULL, 88, NULL, NULL, 232870),
(260524, '3suzA02', NULL, NULL, 97, NULL, NULL, 232870),
(260525, '2ogpA00', NULL, NULL, 97, NULL, NULL, 232870),
(260526, '3fy5A00', NULL, NULL, 91, NULL, NULL, 232870),
(260527, '4jokA00', NULL, NULL, 87, NULL, NULL, 232870),
(260528, '4ic6B03', NULL, NULL, 112, NULL, NULL, 232870),
(260529, '1q3oA00', NULL, NULL, 109, NULL, NULL, 232870),
(260530, '2edpA01', NULL, NULL, 86, NULL, NULL, 232870),
(260531, '2k1zA00', NULL, NULL, 104, NULL, NULL, 232870),
(260532, '2egoB00', NULL, NULL, 96, NULL, NULL, 232870),
(260533, '2f0aC00', NULL, NULL, 98, NULL, NULL, 232870),
(260534, '2he4A00', NULL, NULL, 90, NULL, NULL, 232870),
(260535, '1vb7A00', NULL, NULL, 94, NULL, NULL, 232870),
(260536, '5vwiA00', NULL, NULL, 96, NULL, NULL, 232870),
(260537, '1i16A00', NULL, NULL, 130, NULL, NULL, 232870),
(260538, '3cbzA00', NULL, NULL, 108, NULL, NULL, 232870),
(260539, '2qkvA00', NULL, NULL, 96, NULL, NULL, 232870),
(260540, '3i18A00', NULL, NULL, 100, NULL, NULL, 232870),
(260541, '2m0tA00', NULL, NULL, 117, NULL, NULL, 232870),
(260542, '2omjA00', NULL, NULL, 89, NULL, NULL, 232870),
(260543, '2m3mA00', NULL, NULL, 97, NULL, NULL, 232870),
(260544, '2qg1A00', NULL, NULL, 92, NULL, NULL, 232870),
(260545, '5jxbA00', NULL, NULL, 123, NULL, NULL, 232870),
(260546, '2hgaA01', NULL, NULL, 85, NULL, NULL, 232870),
(260547, '1wfvA01', NULL, NULL, 88, NULL, NULL, 232870),
(260548, '3id4A00', NULL, NULL, 93, NULL, NULL, 232870),
(260549, '2rczA01', NULL, NULL, 59, NULL, NULL, 232870),
(260550, '4hopB00', NULL, NULL, 123, NULL, NULL, 232870),
(260551, '2f5yA00', NULL, NULL, 91, NULL, NULL, 232870),
(260552, '3axaA00', NULL, NULL, 106, NULL, NULL, 232870),
(260553, '2qt5B02', NULL, NULL, 100, NULL, NULL, 232870),
(260554, '3k50A02', NULL, NULL, 105, NULL, NULL, 232870),
(260555, '5e6pB00', NULL, NULL, 88, NULL, NULL, 232870),
(260556, '1ueqA00', NULL, NULL, 123, NULL, NULL, 232870),
(260557, '4o06A00', NULL, NULL, 106, NULL, NULL, 232870),
(260558, '2d90A00', NULL, NULL, 102, NULL, NULL, 232870),
(260559, '2uzcC00', NULL, NULL, 88, NULL, NULL, 232870),
(260560, '2edvA00', NULL, NULL, 96, NULL, NULL, 232870),
(260561, '2jxoA00', NULL, NULL, 98, NULL, NULL, 232870),
(260562, '1ujvA00', NULL, NULL, 96, NULL, NULL, 232870),
(260563, '4xhvA00', NULL, NULL, 94, NULL, NULL, 232870),
(260564, '2eegA00', NULL, NULL, 94, NULL, NULL, 232870),
(260565, '1te0A03', NULL, NULL, 100, NULL, NULL, 232870),
(260566, '3jxtB00', NULL, NULL, 104, NULL, NULL, 232870),
(260567, '1qauA00', NULL, NULL, 112, NULL, NULL, 232870),
(260568, '1k32A04', NULL, NULL, 95, NULL, NULL, 232870),
(260569, '4ydpA00', NULL, NULL, 85, NULL, NULL, 232870),
(260570, '2h3lB00', NULL, NULL, 103, NULL, NULL, 232870),
(260571, '2vsvB00', NULL, NULL, 109, NULL, NULL, 232870),
(260572, '2v1wB00', NULL, NULL, 90, NULL, NULL, 232870);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(260573, '2kpkA00', NULL, NULL, 129, NULL, NULL, 232870),
(260574, '1uitA00', NULL, NULL, 117, NULL, NULL, 232870),
(260575, '3rl7D00', NULL, NULL, 107, NULL, NULL, 232870),
(260576, '3vqfA00', NULL, NULL, 94, NULL, NULL, 232870),
(260577, '4h11A00', NULL, NULL, 103, NULL, NULL, 232870),
(260578, '2f0aD00', NULL, NULL, 98, NULL, NULL, 232870),
(260579, '4q2pA00', NULL, NULL, 99, NULL, NULL, 232870),
(260580, '3ps4A00', NULL, NULL, 102, NULL, NULL, 232870),
(260581, '1wg6A01', NULL, NULL, 100, NULL, NULL, 232870),
(260582, '3nghA00', NULL, NULL, 106, NULL, NULL, 232870),
(260583, '2yuyA00', NULL, NULL, 126, NULL, NULL, 232870),
(260584, '4z8jA00', NULL, NULL, 101, NULL, NULL, 232870),
(260585, '1oziA00', NULL, NULL, 99, NULL, NULL, 232870),
(260586, '5ohwB00', NULL, NULL, 94, NULL, NULL, 232870),
(260587, '5zdsA00', NULL, NULL, 96, NULL, NULL, 232870),
(260588, '1v6bA00', NULL, NULL, 118, NULL, NULL, 232870),
(260589, '2la8A00', NULL, NULL, 106, NULL, NULL, 232870),
(260590, '2db5A00', NULL, NULL, 128, NULL, NULL, 232870),
(260591, '2bygA00', NULL, NULL, 98, NULL, NULL, 232870),
(260592, '1uezA00', NULL, NULL, 101, NULL, NULL, 232870),
(260593, '1whaA01', NULL, NULL, 101, NULL, NULL, 232870),
(260594, '4oeoA00', NULL, NULL, 107, NULL, NULL, 232870),
(260595, '3gslA02', NULL, NULL, 99, NULL, NULL, 232870),
(260596, '3gslA01', NULL, NULL, 97, NULL, NULL, 232870),
(260597, '1wi2A00', NULL, NULL, 104, NULL, NULL, 232870),
(260598, '2dazA01', NULL, NULL, 112, NULL, NULL, 232870),
(260599, '1ry4A00', NULL, NULL, 128, NULL, NULL, 232870),
(260600, '1uf1A00', NULL, NULL, 128, NULL, NULL, 232870),
(260601, '2zpmA00', NULL, NULL, 91, NULL, NULL, 232870),
(260602, '2ejyA00', NULL, NULL, 97, NULL, NULL, 232870),
(260603, '1nf3C00', NULL, NULL, 128, NULL, NULL, 232870),
(260604, '2djtA00', NULL, NULL, 104, NULL, NULL, 232870),
(260605, '1w9eA01', NULL, NULL, 87, NULL, NULL, 232870),
(260606, '2w7rA00', NULL, NULL, 98, NULL, NULL, 232870),
(260607, '1w9eA02', NULL, NULL, 79, NULL, NULL, 232870),
(260608, '3tsvA00', NULL, NULL, 97, NULL, NULL, 232870),
(260609, '1uepA00', NULL, NULL, 103, NULL, NULL, 232870),
(260610, '1vaeA00', NULL, NULL, 111, NULL, NULL, 232870),
(260611, '4n6xA00', NULL, NULL, 91, NULL, NULL, 232870),
(260612, '2o2tB00', NULL, NULL, 117, NULL, NULL, 232870),
(260613, '2iwoA00', NULL, NULL, 96, NULL, NULL, 232870),
(260614, '2opgA00', NULL, NULL, 98, NULL, NULL, 232870),
(260615, '3khfA00', NULL, NULL, 99, NULL, NULL, 232870),
(260616, '2yt8A00', NULL, NULL, 94, NULL, NULL, 232870),
(260617, '2eehA00', NULL, NULL, 100, NULL, NULL, 232870),
(260618, '6akqA02', NULL, NULL, 95, NULL, NULL, 232870),
(260619, '1v62A00', NULL, NULL, 117, NULL, NULL, 232870),
(260620, '6akqA01', NULL, NULL, 94, NULL, NULL, 232870),
(260621, '1ihjB00', NULL, NULL, 98, NULL, NULL, 232870),
(260622, '1wh1A01', NULL, NULL, 90, NULL, NULL, 232870),
(260623, '4l8nA01', NULL, NULL, 94, NULL, NULL, 232870),
(260624, '4nxrA00', NULL, NULL, 94, NULL, NULL, 232870),
(260625, '2kqfA00', NULL, NULL, 96, NULL, NULL, 232870),
(260626, '2q3gA00', NULL, NULL, 89, NULL, NULL, 232870),
(260627, '4p0cA00', NULL, NULL, 88, NULL, NULL, 232870),
(260628, '2qbwA01', NULL, NULL, 97, NULL, NULL, 232870),
(260629, '2reyA00', NULL, NULL, 100, NULL, NULL, 232870),
(260630, '1n7eA00', NULL, NULL, 97, NULL, NULL, 232870),
(260631, '3rl8C00', NULL, NULL, 105, NULL, NULL, 232870),
(260632, '1r6jA00', NULL, NULL, 82, NULL, NULL, 232870),
(260633, '3cbyB00', NULL, NULL, 108, NULL, NULL, 232870),
(260634, '1m5zA00', NULL, NULL, 91, NULL, NULL, 232870),
(260635, '2ehrA00', NULL, NULL, 117, NULL, NULL, 232870),
(260636, '5m3nA03', NULL, NULL, 97, NULL, NULL, 232870),
(260637, '3id1A00', NULL, NULL, 95, NULL, NULL, 232870),
(260638, '3o46A00', NULL, NULL, 93, NULL, NULL, 232870),
(260639, '1ujdA00', NULL, NULL, 117, NULL, NULL, 232870),
(260640, '1l6oB00', NULL, NULL, 95, NULL, NULL, 232870),
(260641, '5e1yA00', NULL, NULL, 95, NULL, NULL, 232870),
(260642, '3r0hG01', NULL, NULL, 111, NULL, NULL, 232870),
(260643, '3k1rA02', NULL, NULL, 111, NULL, NULL, 232870);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(260644, '3lnyA00', NULL, NULL, 96, NULL, NULL, 232870),
(260645, '6eziA00', NULL, NULL, 89, NULL, NULL, 232870),
(260646, '2awxA00', NULL, NULL, 105, NULL, NULL, 232870),
(260647, '2fe5A00', NULL, NULL, 94, NULL, NULL, 232870),
(260648, '3ggeA00', NULL, NULL, 95, NULL, NULL, 232870),
(260649, '1ujuA00', NULL, NULL, 111, NULL, NULL, 232870),
(260650, '2jreA00', NULL, NULL, 108, NULL, NULL, 232870),
(260651, '5h3jA01', NULL, NULL, 113, NULL, NULL, 232870),
(260652, '5h3jA02', NULL, NULL, 98, NULL, NULL, 232870),
(260653, '1qavA00', NULL, NULL, 90, NULL, NULL, 232870),
(260654, '3eggC01', NULL, NULL, 109, NULL, NULL, 232870),
(260655, '2q9vA00', NULL, NULL, 90, NULL, NULL, 232870),
(260656, '2kv8A00', NULL, NULL, 83, NULL, NULL, 232870),
(260657, '2qt5A01', NULL, NULL, 100, NULL, NULL, 232870),
(260658, '4q2oA00', NULL, NULL, 98, NULL, NULL, 232870),
(260659, '1wf8A00', NULL, NULL, 107, NULL, NULL, 232870),
(260660, '4wsiA01', NULL, NULL, 103, NULL, NULL, 232870),
(260661, '1pdrA00', NULL, NULL, 99, NULL, NULL, 232870),
(260662, '2e7kA00', NULL, NULL, 91, NULL, NULL, 232870),
(260663, '2jilA00', NULL, NULL, 97, NULL, NULL, 232870),
(260664, '1zubA00', NULL, NULL, 114, NULL, NULL, 232870),
(260665, '1uewA00', NULL, NULL, 114, NULL, NULL, 232870),
(260666, '2komA00', NULL, NULL, 101, NULL, NULL, 232870),
(260667, '2yt7A01', NULL, NULL, 87, NULL, NULL, 232870),
(260668, '2iwnA00', NULL, NULL, 97, NULL, NULL, 232870),
(260669, '2luiA00', NULL, NULL, 116, NULL, NULL, 232870),
(260670, '2joaA01', NULL, NULL, 104, NULL, NULL, 232870),
(260671, '2eeiA00', NULL, NULL, 106, NULL, NULL, 232870),
(260672, '4fgmA03', NULL, NULL, 113, NULL, NULL, 232870),
(260673, '2r4hC01', NULL, NULL, 88, NULL, NULL, 232870),
(260674, '2z17A00', NULL, NULL, 104, NULL, NULL, 232870),
(260675, '2dluA00', NULL, NULL, 111, NULL, NULL, 232870),
(260676, '1l6oA00', NULL, NULL, 95, NULL, NULL, 232870),
(260677, '2i1nA00', NULL, NULL, 102, NULL, NULL, 232870),
(260678, '3qikA01', NULL, NULL, 84, NULL, NULL, 232870),
(260679, '2he2B00', NULL, NULL, 102, NULL, NULL, 232870),
(260680, '2l97A01', NULL, NULL, 106, NULL, NULL, 232870),
(260681, '1vj6A00', NULL, NULL, 102, NULL, NULL, 232870),
(260682, '3otpB04', NULL, NULL, 98, NULL, NULL, 232870),
(260683, '4uu5A00', NULL, NULL, 90, NULL, NULL, 232870),
(260684, '3hvqC01', NULL, NULL, 109, NULL, NULL, 232870),
(260685, '2vrfA00', NULL, NULL, 95, NULL, NULL, 232870),
(260686, '3stjA03', NULL, NULL, 108, NULL, NULL, 232870),
(260687, '4amhA00', NULL, NULL, 106, NULL, NULL, 232870),
(260688, '1ufxA00', NULL, NULL, 103, NULL, NULL, 232870),
(260689, '2h2bA00', NULL, NULL, 107, NULL, NULL, 232870),
(260690, '6ieoA03', NULL, NULL, 99, NULL, NULL, 232870),
(260691, '2i04A00', NULL, NULL, 85, NULL, NULL, 232870),
(260692, '6hksB00', NULL, NULL, 94, NULL, NULL, 232870),
(260693, '1wi4A01', NULL, NULL, 89, NULL, NULL, 232870),
(260694, '3i4wA00', NULL, NULL, 104, NULL, NULL, 232870),
(260695, '3r69B00', NULL, NULL, 89, NULL, NULL, 232870),
(260696, '1u3bA01', NULL, NULL, 89, NULL, NULL, 232870),
(260697, '3dorA02', NULL, NULL, 107, NULL, NULL, 232870),
(260698, '2enoA00', NULL, NULL, 120, NULL, NULL, 232870),
(260699, '1ky9B03', NULL, NULL, 94, NULL, NULL, 232870),
(260700, '1um7A00', NULL, NULL, 113, NULL, NULL, 232870),
(260701, '1ky9B04', NULL, NULL, 71, NULL, NULL, 232870),
(260702, '5hj1A00', NULL, NULL, 103, NULL, NULL, 232870),
(260703, '5vwkA01', NULL, NULL, 94, NULL, NULL, 232870),
(260704, '3b76A00', NULL, NULL, 101, NULL, NULL, 232870),
(260705, '5ovpA00', NULL, NULL, 96, NULL, NULL, 232870),
(260706, '3soeA00', NULL, NULL, 113, NULL, NULL, 232870),
(260707, '1uhpA00', NULL, NULL, 107, NULL, NULL, 232870),
(260708, '2ozfA00', NULL, NULL, 92, NULL, NULL, 232870),
(260709, '1x6dA01', NULL, NULL, 91, NULL, NULL, 232870),
(260710, '2fneA00', NULL, NULL, 95, NULL, NULL, 232870),
(260711, '5wouA00', NULL, NULL, 100, NULL, NULL, 232870),
(260712, '2kjpA01', NULL, NULL, 79, NULL, NULL, 232870),
(260713, '2eejA00', NULL, NULL, 96, NULL, NULL, 232870),
(260714, '2i6vA00', NULL, NULL, 87, NULL, NULL, 232870);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(260715, '3r68A00', NULL, NULL, 95, NULL, NULL, 232870),
(260716, '2i4sB00', NULL, NULL, 105, NULL, NULL, 232870),
(260717, '3i1eA00', NULL, NULL, 90, NULL, NULL, 232870),
(260718, '5i7zA00', NULL, NULL, 96, NULL, NULL, 232870),
(260719, '2dkrA00', NULL, NULL, 93, NULL, NULL, 232870),
(260720, '1kwaA00', NULL, NULL, 88, NULL, NULL, 232870),
(260721, '2w4fA00', NULL, NULL, 97, NULL, NULL, 232870),
(260722, '1p1dA02', NULL, NULL, 94, NULL, NULL, 232870),
(260723, '1kefA00', NULL, NULL, 93, NULL, NULL, 232870),
(260724, '2d92A00', NULL, NULL, 108, NULL, NULL, 232870),
(260725, '4reyA02', NULL, NULL, 100, NULL, NULL, 232870),
(260726, '3hpkB00', NULL, NULL, 107, NULL, NULL, 232870),
(260727, '4reyA01', NULL, NULL, 113, NULL, NULL, 232870),
(260728, '2x7zA00', NULL, NULL, 99, NULL, NULL, 232870),
(260729, '3e17A01', NULL, NULL, 59, NULL, NULL, 232870),
(260730, '3mh7A03', NULL, NULL, 94, NULL, NULL, 232870),
(260731, '3mh7A04', NULL, NULL, 100, NULL, NULL, 232870),
(260732, '5g1eA01', NULL, NULL, 97, NULL, NULL, 232870),
(260733, '5g1eA02', NULL, NULL, 85, NULL, NULL, 232870),
(260734, '3bpuA00', NULL, NULL, 88, NULL, NULL, 232870),
(260735, '1whdA00', NULL, NULL, 100, NULL, NULL, 232870),
(260736, '1t2mA00', NULL, NULL, 101, NULL, NULL, 232870),
(260737, '2pa1A00', NULL, NULL, 87, NULL, NULL, 232870),
(260738, '3dj3D00', NULL, NULL, 113, NULL, NULL, 232870),
(260739, '1tp5A00', NULL, NULL, 119, NULL, NULL, 232870),
(260740, '2eaqA00', NULL, NULL, 90, NULL, NULL, 232870),
(260741, '1l6oC00', NULL, NULL, 95, NULL, NULL, 232870),
(260742, '1y7nA00', NULL, NULL, 90, NULL, NULL, 232870),
(260743, '2f0aA00', NULL, NULL, 98, NULL, NULL, 232870),
(260744, '1mc7A00', NULL, NULL, 95, NULL, NULL, 232870),
(260745, '3cc0C00', NULL, NULL, 108, NULL, NULL, 232870),
(260746, '4kfvA02', NULL, NULL, 101, NULL, NULL, 232870),
(260747, '1wf7A01', NULL, NULL, 85, NULL, NULL, 232870),
(260748, '3sfjA00', NULL, NULL, 104, NULL, NULL, 232870),
(260749, '1um1A00', NULL, NULL, 110, NULL, NULL, 232870),
(260750, '3qo6A03', NULL, NULL, 116, NULL, NULL, 232870),
(260751, '5f67B00', NULL, NULL, 108, NULL, NULL, 232870),
(260752, '5tytA00', NULL, NULL, 89, NULL, NULL, 232870),
(260753, '2i4sA00', NULL, NULL, 105, NULL, NULL, 232870),
(260754, '2p3wB01', NULL, NULL, 104, NULL, NULL, 232870),
(260755, '5xbfB00', NULL, NULL, 125, NULL, NULL, 232870),
(260756, '1zkrB00', NULL, NULL, 153, NULL, NULL, 232871),
(260757, '1puoB00', NULL, NULL, 170, NULL, NULL, 232871),
(260758, '3hkzY00', NULL, NULL, 45, NULL, NULL, 232872),
(260759, '2waqQ00', NULL, NULL, 45, NULL, NULL, 232872),
(260760, '4akgA03', NULL, NULL, 83, NULL, NULL, 232873),
(260761, '3vkgA03', NULL, NULL, 100, NULL, NULL, 232873),
(260762, '5kdiA00', NULL, NULL, 211, NULL, NULL, 232874),
(260763, '2i3fA00', NULL, NULL, 224, NULL, NULL, 232874),
(260764, '4k84A00', NULL, NULL, 215, NULL, NULL, 232874),
(260765, '3kv0A01', NULL, NULL, 171, NULL, NULL, 232874),
(260766, '4kbrD00', NULL, NULL, 217, NULL, NULL, 232874),
(260767, '4nt1D00', NULL, NULL, 207, NULL, NULL, 232874),
(260768, '3rznA01', NULL, NULL, 185, NULL, NULL, 232874),
(260769, '3smvA02', NULL, NULL, 77, NULL, NULL, 232875),
(260770, '1wa9B03', NULL, NULL, 34, NULL, NULL, 232876),
(260771, '4jj0B00', NULL, NULL, 188, NULL, NULL, 232877),
(260772, '3lcnB00', NULL, NULL, 105, NULL, NULL, 232878),
(260773, '3tbiB02', NULL, NULL, 100, NULL, NULL, 232879),
(260774, '3anwA01', NULL, NULL, 113, NULL, NULL, 232880),
(260775, '2ehoE01', NULL, NULL, 153, NULL, NULL, 232880),
(260776, '2ehoF01', NULL, NULL, 129, NULL, NULL, 232880),
(260777, '3jc6D01', NULL, NULL, 167, NULL, NULL, 232880),
(260778, '2ehoB01', NULL, NULL, 129, NULL, NULL, 232880),
(260779, '2e9xD01', NULL, NULL, 143, NULL, NULL, 232880),
(260780, '2ehoA00', NULL, NULL, 203, NULL, NULL, 232880),
(260781, '2e9xA01', NULL, NULL, 128, NULL, NULL, 232880),
(260782, '2ehoI01', NULL, NULL, 153, NULL, NULL, 232880),
(260783, '2ehoJ01', NULL, NULL, 129, NULL, NULL, 232880),
(260784, '2w8mA00', NULL, NULL, 194, NULL, NULL, 232881),
(260785, '1vprA01', NULL, NULL, 112, NULL, NULL, 232882); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(260786, '2o79A00', NULL, NULL, 170, NULL, NULL, 232883),
(260787, '139lA00', NULL, NULL, 164, NULL, NULL, 232883),
(260788, '1cx6A00', NULL, NULL, 164, NULL, NULL, 232883),
(260789, '1l36A00', NULL, NULL, 164, NULL, NULL, 232883),
(260790, '5i14A00', NULL, NULL, 121, NULL, NULL, 232883),
(260791, '4aqnA02', NULL, NULL, 193, NULL, NULL, 232883),
(260792, '3sbbC00', NULL, NULL, 165, NULL, NULL, 232883),
(260793, '2o7aA00', NULL, NULL, 124, NULL, NULL, 232883),
(260794, '157lA00', NULL, NULL, 164, NULL, NULL, 232883),
(260795, '2f2qA00', NULL, NULL, 175, NULL, NULL, 232883),
(260796, '3hh6A00', NULL, NULL, 164, NULL, NULL, 232883),
(260797, '6et6A00', NULL, NULL, 149, NULL, NULL, 232883),
(260798, '1t8fA00', NULL, NULL, 164, NULL, NULL, 232883),
(260799, '192lA00', NULL, NULL, 164, NULL, NULL, 232883),
(260800, '3dkeX00', NULL, NULL, 164, NULL, NULL, 232883),
(260801, '174lA00', NULL, NULL, 164, NULL, NULL, 232883),
(260802, '3guiA00', NULL, NULL, 164, NULL, NULL, 232883),
(260803, '170lA00', NULL, NULL, 164, NULL, NULL, 232883),
(260804, '1wthA03', NULL, NULL, 169, NULL, NULL, 232883),
(260805, '4epiA02', NULL, NULL, 164, NULL, NULL, 232883),
(260806, '1lpyA00', NULL, NULL, 164, NULL, NULL, 232883),
(260807, '1d3nA00', NULL, NULL, 164, NULL, NULL, 232883),
(260808, '4iapA02', NULL, NULL, 163, NULL, NULL, 232883),
(260809, '1p36A00', NULL, NULL, 164, NULL, NULL, 232883),
(260810, '3hdeC00', NULL, NULL, 165, NULL, NULL, 232883),
(260811, '2anvA00', NULL, NULL, 146, NULL, NULL, 232883),
(260812, '1lwkA00', NULL, NULL, 164, NULL, NULL, 232883),
(260813, '1xjuA00', NULL, NULL, 163, NULL, NULL, 232883),
(260814, '1swyA00', NULL, NULL, 164, NULL, NULL, 232883),
(260815, '1lwgA00', NULL, NULL, 164, NULL, NULL, 232883),
(260816, '189lA00', NULL, NULL, 164, NULL, NULL, 232883),
(260817, '176lA00', NULL, NULL, 164, NULL, NULL, 232883),
(260818, '1pqiA00', NULL, NULL, 164, NULL, NULL, 232883),
(260819, '2o4wA00', NULL, NULL, 171, NULL, NULL, 232883),
(260820, '168lA00', NULL, NULL, 164, NULL, NULL, 232883),
(260821, '1p3nA00', NULL, NULL, 164, NULL, NULL, 232883),
(260822, '6h9dA00', NULL, NULL, 149, NULL, NULL, 232883),
(260823, '3q10D02', NULL, NULL, 45, NULL, NULL, 232884),
(260824, '6m9yA00', NULL, NULL, 58, NULL, NULL, 232885),
(260825, '3lf4A00', NULL, NULL, 66, NULL, NULL, 232885),
(260826, '2a50C00', NULL, NULL, 73, NULL, NULL, 232885),
(260827, '3cfaM00', NULL, NULL, 62, NULL, NULL, 232885),
(260828, '5excA00', NULL, NULL, 62, NULL, NULL, 232885),
(260829, '6gp1A00', NULL, NULL, 66, NULL, NULL, 232885),
(260830, '2g2sA00', NULL, NULL, 66, NULL, NULL, 232885),
(260831, '2gw4A00', NULL, NULL, 63, NULL, NULL, 232885),
(260832, '4abnA02', NULL, NULL, 158, NULL, NULL, 232886),
(260833, '2xvsA00', NULL, NULL, 166, NULL, NULL, 232886),
(260834, '2xskA00', NULL, NULL, 110, NULL, NULL, 232887),
(260835, '2n59A00', NULL, NULL, 106, NULL, NULL, 232887),
(260836, '4dozA01', NULL, NULL, 258, NULL, NULL, 232888),
(260837, '3ungC01', NULL, NULL, 240, NULL, NULL, 232888),
(260838, '2ksdA00', NULL, NULL, 89, NULL, NULL, 232889),
(260839, '2dk4A00', NULL, NULL, 76, NULL, NULL, 232890),
(260840, '2qdlA02', NULL, NULL, 93, NULL, NULL, 232891),
(260841, '1b3qA04', NULL, NULL, 63, NULL, NULL, 232891),
(260842, '4jpbW02', NULL, NULL, 79, NULL, NULL, 232891),
(260843, '2wb7A02', NULL, NULL, 155, NULL, NULL, 232892),
(260844, '1m9sA03', NULL, NULL, 75, NULL, NULL, 232893),
(260845, '1m9sA04', NULL, NULL, 86, NULL, NULL, 232893),
(260846, '4epcA02', NULL, NULL, 71, NULL, NULL, 232893),
(260847, '1m9sA05', NULL, NULL, 87, NULL, NULL, 232893),
(260848, '4epcA01', NULL, NULL, 81, NULL, NULL, 232893),
(260849, '1p2zA03', NULL, NULL, 265, NULL, NULL, 232894),
(260850, '1dhxA03', NULL, NULL, 254, NULL, NULL, 232894),
(260851, '2obeA01', NULL, NULL, 265, NULL, NULL, 232894),
(260852, '3mtvA01', NULL, NULL, 80, NULL, NULL, 232895),
(260853, '4k90A01', NULL, NULL, 201, NULL, NULL, 232896),
(260854, '1bqbA01', NULL, NULL, 154, NULL, NULL, 232896),
(260855, '3nqxA01', NULL, NULL, 153, NULL, NULL, 232896),
(260856, '2vqxA01', NULL, NULL, 174, NULL, NULL, 232896);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(260857, '5jviE01', NULL, NULL, 149, NULL, NULL, 232896),
(260858, '4gerA01', NULL, NULL, 147, NULL, NULL, 232896),
(260859, '6f8bA01', NULL, NULL, 152, NULL, NULL, 232896),
(260860, '1npcA01', NULL, NULL, 150, NULL, NULL, 232896),
(260861, '4fzlA02', NULL, NULL, 160, NULL, NULL, 232897),
(260862, '4g75A02', NULL, NULL, 138, NULL, NULL, 232897),
(260863, '2xmxA02', NULL, NULL, 130, NULL, NULL, 232897),
(260864, '4n59A02', NULL, NULL, 158, NULL, NULL, 232897),
(260865, '4khbD02', NULL, NULL, 100, NULL, NULL, 232898),
(260866, '4d6wB02', NULL, NULL, 92, NULL, NULL, 232899),
(260867, '5i2mA02', NULL, NULL, 91, NULL, NULL, 232899),
(260868, '1io1A02', NULL, NULL, 131, NULL, NULL, 232900),
(260869, '4p1wA00', NULL, NULL, 74, NULL, NULL, 232901),
(260870, '4hpqD00', NULL, NULL, 69, NULL, NULL, 232901),
(260871, '4hpqA00', NULL, NULL, 69, NULL, NULL, 232901),
(260872, '5jhfA00', NULL, NULL, 87, NULL, NULL, 232901),
(260873, '4p1wD00', NULL, NULL, 74, NULL, NULL, 232901),
(260874, '3nggB00', NULL, NULL, 50, NULL, NULL, 232902),
(260875, '1fleI00', NULL, NULL, 57, NULL, NULL, 232902),
(260876, '1udkA00', NULL, NULL, 51, NULL, NULL, 232902),
(260877, '2z7fI00', NULL, NULL, 50, NULL, NULL, 232902),
(260878, '3phuA02', NULL, NULL, 25, NULL, NULL, 232903),
(260879, '1gjjA00', NULL, NULL, 108, NULL, NULL, 232904),
(260880, '6ghdG00', NULL, NULL, 45, NULL, NULL, 232904),
(260881, '1h9eA00', NULL, NULL, 56, NULL, NULL, 232904),
(260882, '1h9fA00', NULL, NULL, 57, NULL, NULL, 232904),
(260883, '2wq4A01', NULL, NULL, 130, NULL, NULL, 232905),
(260884, '1wthA01', NULL, NULL, 128, NULL, NULL, 232906),
(260885, '4j32B00', NULL, NULL, 101, NULL, NULL, 232907),
(260886, '3zibC00', NULL, NULL, 103, NULL, NULL, 232907),
(260887, '4hfkB00', NULL, NULL, 105, NULL, NULL, 232907),
(260888, '4ax2A01', NULL, NULL, 119, NULL, NULL, 232907),
(260889, '4b6iA00', NULL, NULL, 102, NULL, NULL, 232907),
(260890, '2ivwA01', NULL, NULL, 80, NULL, NULL, 232908),
(260891, '2y4yA00', NULL, NULL, 93, NULL, NULL, 232908),
(260892, '3ossC00', NULL, NULL, 68, NULL, NULL, 232908),
(260893, '2lnvA01', NULL, NULL, 68, NULL, NULL, 232908),
(260894, '2w3qA01', NULL, NULL, 52, NULL, NULL, 232909),
(260895, '1s6dA01', NULL, NULL, 85, NULL, NULL, 232910),
(260896, '2algA00', NULL, NULL, 92, NULL, NULL, 232910),
(260897, '5tviW00', NULL, NULL, 92, NULL, NULL, 232910),
(260898, '6frrA00', NULL, NULL, 92, NULL, NULL, 232910),
(260899, '1tukA00', NULL, NULL, 67, NULL, NULL, 232910),
(260900, '1rzlA00', NULL, NULL, 91, NULL, NULL, 232910),
(260901, '1l6hA00', NULL, NULL, 69, NULL, NULL, 232910),
(260902, '1b1uA00', NULL, NULL, 122, NULL, NULL, 232910),
(260903, '2n2zA00', NULL, NULL, 93, NULL, NULL, 232910),
(260904, '2malA00', NULL, NULL, 93, NULL, NULL, 232910),
(260905, '2ds2D01', NULL, NULL, 60, NULL, NULL, 232910),
(260906, '1sm7A00', NULL, NULL, 109, NULL, NULL, 232910),
(260907, '1psyA01', NULL, NULL, 100, NULL, NULL, 232910),
(260908, '1siyA00', NULL, NULL, 91, NULL, NULL, 232910),
(260909, '1pnbB00', NULL, NULL, 75, NULL, NULL, 232910),
(260910, '2lvfA00', NULL, NULL, 114, NULL, NULL, 232910),
(260911, '2rknA00', NULL, NULL, 77, NULL, NULL, 232910),
(260912, '5domA00', NULL, NULL, 122, NULL, NULL, 232910),
(260913, '4xuwA00', NULL, NULL, 92, NULL, NULL, 232910),
(260914, '1w2qA01', NULL, NULL, 113, NULL, NULL, 232910),
(260915, '1midA00', NULL, NULL, 91, NULL, NULL, 232910),
(260916, '1t12A00', NULL, NULL, 91, NULL, NULL, 232910),
(260917, '1bwoA00', NULL, NULL, 90, NULL, NULL, 232910),
(260918, '2n81A00', NULL, NULL, 95, NULL, NULL, 232910),
(260919, '1hypA00', NULL, NULL, 80, NULL, NULL, 232910),
(260920, '1hssA00', NULL, NULL, 124, NULL, NULL, 232910),
(260921, '4cvwC00', NULL, NULL, 120, NULL, NULL, 232910),
(260922, '1beaA00', NULL, NULL, 127, NULL, NULL, 232910),
(260923, '1fk5A00', NULL, NULL, 93, NULL, NULL, 232910),
(260924, '2kc5A01', NULL, NULL, 136, NULL, NULL, 232911),
(260925, '1wapA00', NULL, NULL, 75, NULL, NULL, 232912),
(260926, '3zteA00', NULL, NULL, 78, NULL, NULL, 232912),
(260927, '3zzsA00', NULL, NULL, 65, NULL, NULL, 232912); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(260928, '3zzlA00', NULL, NULL, 70, NULL, NULL, 232912),
(260929, '1fiuA00', NULL, NULL, 286, NULL, NULL, 232913),
(260930, '4hgzA02', NULL, NULL, 60, NULL, NULL, 232914),
(260931, '2mcaA00', NULL, NULL, 103, NULL, NULL, 232915),
(260932, '2xtzB02', NULL, NULL, 94, NULL, NULL, 232916),
(260933, '2odeA02', NULL, NULL, 119, NULL, NULL, 232916),
(260934, '1tadA02', NULL, NULL, 119, NULL, NULL, 232916),
(260935, '4ekdA02', NULL, NULL, 118, NULL, NULL, 232916),
(260936, '1cipA02', NULL, NULL, 119, NULL, NULL, 232916),
(260937, '6au6A02', NULL, NULL, 115, NULL, NULL, 232916),
(260938, '3c7kA02', NULL, NULL, 120, NULL, NULL, 232916),
(260939, '1zcbA02', NULL, NULL, 126, NULL, NULL, 232916),
(260940, '1zcaA02', NULL, NULL, 122, NULL, NULL, 232916),
(260941, '4fidA02', NULL, NULL, 114, NULL, NULL, 232916),
(260942, '2xtzA02', NULL, NULL, 126, NULL, NULL, 232916),
(260943, '5do9A02', NULL, NULL, 118, NULL, NULL, 232916),
(260944, '1vb5A01', NULL, NULL, 95, NULL, NULL, 232917),
(260945, '1t5oA01', NULL, NULL, 142, NULL, NULL, 232917),
(260946, '2yvkA01', NULL, NULL, 148, NULL, NULL, 232917),
(260947, '1t9kA01', NULL, NULL, 144, NULL, NULL, 232917),
(260948, '2a0uB01', NULL, NULL, 160, NULL, NULL, 232917),
(260949, '3a11B01', NULL, NULL, 137, NULL, NULL, 232917),
(260950, '4ldrA01', NULL, NULL, 159, NULL, NULL, 232917),
(260951, '5yfjA01', NULL, NULL, 123, NULL, NULL, 232917),
(260952, '6a34A01', NULL, NULL, 156, NULL, NULL, 232917),
(260953, '1w2wA00', NULL, NULL, 211, NULL, NULL, 232917),
(260954, '2rf4B01', NULL, NULL, 66, NULL, NULL, 232918),
(260955, '4c2mD01', NULL, NULL, 48, NULL, NULL, 232918),
(260956, '4c2mS01', NULL, NULL, 79, NULL, NULL, 232918),
(260957, '3ioyA02', NULL, NULL, 58, NULL, NULL, 232919),
(260958, '2yh5A00', NULL, NULL, 127, NULL, NULL, 232920),
(260959, '2re3A02', NULL, NULL, 70, NULL, NULL, 232921),
(260960, '2ra9A02', NULL, NULL, 75, NULL, NULL, 232921),
(260961, '3b4qA00', NULL, NULL, 94, NULL, NULL, 232922),
(260962, '2x3gA00', NULL, NULL, 119, NULL, NULL, 232923),
(260963, '1gxlA01', NULL, NULL, 127, NULL, NULL, 232924),
(260964, '2gmoA01', NULL, NULL, 60, NULL, NULL, 232925),
(260965, '3l56B02', NULL, NULL, 73, NULL, NULL, 232925),
(260966, '3khwA02', NULL, NULL, 55, NULL, NULL, 232925),
(260967, '3r2vA02', NULL, NULL, 67, NULL, NULL, 232925),
(260968, '3o6qA02', NULL, NULL, 121, NULL, NULL, 232926),
(260969, '3zzoA00', NULL, NULL, 95, NULL, NULL, 232927),
(260970, '1vpcA00', NULL, NULL, 45, NULL, NULL, 232928),
(260971, '2lotA00', NULL, NULL, 64, NULL, NULL, 232929),
(260972, '4mh8A04', NULL, NULL, 76, NULL, NULL, 232930),
(260973, '3c12A01', NULL, NULL, 51, NULL, NULL, 232931),
(260974, '3osvC01', NULL, NULL, 51, NULL, NULL, 232931),
(260975, '1v76A00', NULL, NULL, 96, NULL, NULL, 232932),
(260976, '2ki7A00', NULL, NULL, 111, NULL, NULL, 232932),
(260977, '1ts9A00', NULL, NULL, 102, NULL, NULL, 232932),
(260978, '1oqkA00', NULL, NULL, 97, NULL, NULL, 232932),
(260979, '2r4gA02', NULL, NULL, 64, NULL, NULL, 232933),
(260980, '2bh8A02', NULL, NULL, 33, NULL, NULL, 232934),
(260981, '1vsgA01', NULL, NULL, 203, NULL, NULL, 232935),
(260982, '2vsgA01', NULL, NULL, 198, NULL, NULL, 232935),
(260983, '2qhqA00', NULL, NULL, 125, NULL, NULL, 232936),
(260984, '2qhqB00', NULL, NULL, 125, NULL, NULL, 232936),
(260985, '2qm2B00', NULL, NULL, 125, NULL, NULL, 232936),
(260986, '1kp0A01', NULL, NULL, 154, NULL, NULL, 232937),
(260987, '1kp0B01', NULL, NULL, 154, NULL, NULL, 232937),
(260988, '1wy2A01', NULL, NULL, 125, NULL, NULL, 232937),
(260989, '4s2rP01', NULL, NULL, 158, NULL, NULL, 232937),
(260990, '3ctzA01', NULL, NULL, 155, NULL, NULL, 232937),
(260991, '4s2rP02', NULL, NULL, 158, NULL, NULL, 232937),
(260992, '3ctzA02', NULL, NULL, 164, NULL, NULL, 232937),
(260993, '5mc1A01', NULL, NULL, 180, NULL, NULL, 232937),
(260994, '2zsgA01', NULL, NULL, 131, NULL, NULL, 232937),
(260995, '3o5vA00', NULL, NULL, 132, NULL, NULL, 232937),
(260996, '3i7mA00', NULL, NULL, 140, NULL, NULL, 232937),
(260997, '3ig4A01', NULL, NULL, 171, NULL, NULL, 232937),
(260998, '3oooA00', NULL, NULL, 132, NULL, NULL, 232937);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(260999, '4zngA01', NULL, NULL, 132, NULL, NULL, 232937),
(261000, '5e2cA00', NULL, NULL, 132, NULL, NULL, 232937),
(261001, '3cb6A01', NULL, NULL, 175, NULL, NULL, 232937),
(261002, '4r60A01', NULL, NULL, 165, NULL, NULL, 232937),
(261003, '4b28A01', NULL, NULL, 199, NULL, NULL, 232937),
(261004, '5e5bA01', NULL, NULL, 171, NULL, NULL, 232937),
(261005, '4fkcA01', NULL, NULL, 148, NULL, NULL, 232937),
(261006, '4rzyA01', NULL, NULL, 207, NULL, NULL, 232937),
(261007, '5ce6A01', NULL, NULL, 173, NULL, NULL, 232937),
(261008, '4egeA01', NULL, NULL, 147, NULL, NULL, 232937),
(261009, '1chmA01', NULL, NULL, 155, NULL, NULL, 232937),
(261010, '4qr8A01', NULL, NULL, 159, NULL, NULL, 232937),
(261011, '1pv9B01', NULL, NULL, 122, NULL, NULL, 232937),
(261012, '4zwuA01', NULL, NULL, 157, NULL, NULL, 232937),
(261013, '3ovkA00', NULL, NULL, 132, NULL, NULL, 232937),
(261014, '3rvaA01', NULL, NULL, 157, NULL, NULL, 232937),
(261015, '2v3zA01', NULL, NULL, 173, NULL, NULL, 232937),
(261016, '3q6dA01', NULL, NULL, 128, NULL, NULL, 232937),
(261017, '4pv4A01', NULL, NULL, 171, NULL, NULL, 232937),
(261018, '5cdvA01', NULL, NULL, 124, NULL, NULL, 232937),
(261019, '3il0A00', NULL, NULL, 131, NULL, NULL, 232937),
(261020, '3qocA00', NULL, NULL, 135, NULL, NULL, 232937),
(261021, '5wzeA01', NULL, NULL, 173, NULL, NULL, 232937),
(261022, '5cnxA01', NULL, NULL, 125, NULL, NULL, 232937),
(261023, '6a8mA01', NULL, NULL, 174, NULL, NULL, 232937),
(261024, '3pn9A00', NULL, NULL, 138, NULL, NULL, 232937),
(261025, '3pebA00', NULL, NULL, 137, NULL, NULL, 232937),
(261026, '1wn1A01', NULL, NULL, 129, NULL, NULL, 232937),
(261027, '3biqA01', NULL, NULL, 175, NULL, NULL, 232937),
(261028, '2awiF02', NULL, NULL, 235, NULL, NULL, 232938),
(261029, '2no2A00', NULL, NULL, 107, NULL, NULL, 232939),
(261030, '1qsaA02', NULL, NULL, 70, NULL, NULL, 232940),
(261031, '3bjdA01', NULL, NULL, 88, NULL, NULL, 232940),
(261032, '4kiz502', NULL, NULL, 18, NULL, NULL, 232941),
(261033, '5osiK00', NULL, NULL, 311, NULL, NULL, 232942),
(261034, '5imsB01', NULL, NULL, 198, NULL, NULL, 232943),
(261035, '5imsB03', NULL, NULL, 182, NULL, NULL, 232943),
(261036, '1q6zA01', NULL, NULL, 179, NULL, NULL, 232943),
(261037, '2pgnA01', NULL, NULL, 188, NULL, NULL, 232943),
(261038, '2pgnA03', NULL, NULL, 219, NULL, NULL, 232943),
(261039, '1umdB01', NULL, NULL, 196, NULL, NULL, 232943),
(261040, '3komA02', NULL, NULL, 212, NULL, NULL, 232943),
(261041, '1w88E00', NULL, NULL, 368, NULL, NULL, 232943),
(261042, '3m49B01', NULL, NULL, 328, NULL, NULL, 232943),
(261043, '3ahcA02', NULL, NULL, 218, NULL, NULL, 232943),
(261044, '4q9dB01', NULL, NULL, 179, NULL, NULL, 232943),
(261045, '3ahcA01', NULL, NULL, 386, NULL, NULL, 232943),
(261046, '4q9dB03', NULL, NULL, 203, NULL, NULL, 232943),
(261047, '5npuA03', NULL, NULL, 203, NULL, NULL, 232943),
(261048, '5npuA01', NULL, NULL, 188, NULL, NULL, 232943),
(261049, '3exiA00', NULL, NULL, 382, NULL, NULL, 232943),
(261050, '2e6kA02', NULL, NULL, 202, NULL, NULL, 232943),
(261051, '2e6kA01', NULL, NULL, 327, NULL, NULL, 232943),
(261052, '2r8oA01', NULL, NULL, 326, NULL, NULL, 232943),
(261053, '2c42A06', NULL, NULL, 385, NULL, NULL, 232943),
(261054, '2r8oA02', NULL, NULL, 211, NULL, NULL, 232943),
(261055, '2c42A01', NULL, NULL, 257, NULL, NULL, 232943),
(261056, '3ey9A03', NULL, NULL, 228, NULL, NULL, 232943),
(261057, '2bfdB01', NULL, NULL, 197, NULL, NULL, 232943),
(261058, '1qs0A00', NULL, NULL, 407, NULL, NULL, 232943),
(261059, '1q6zA03', NULL, NULL, 187, NULL, NULL, 232943),
(261060, '3rimA02', NULL, NULL, 214, NULL, NULL, 232943),
(261061, '4xeuA02', NULL, NULL, 212, NULL, NULL, 232943),
(261062, '4xeuA01', NULL, NULL, 333, NULL, NULL, 232943),
(261063, '2o1sA02', NULL, NULL, 177, NULL, NULL, 232943),
(261064, '3komB02', NULL, NULL, 212, NULL, NULL, 232943),
(261065, '2qtcA02', NULL, NULL, 235, NULL, NULL, 232943),
(261066, '3komB01', NULL, NULL, 326, NULL, NULL, 232943),
(261067, '2qtcA01', NULL, NULL, 415, NULL, NULL, 232943),
(261068, '1w85B01', NULL, NULL, 191, NULL, NULL, 232943),
(261069, '5femA03', NULL, NULL, 228, NULL, NULL, 232943);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(261070, '3lq1A01', NULL, NULL, 177, NULL, NULL, 232943),
(261071, '4cokA01', NULL, NULL, 183, NULL, NULL, 232943),
(261072, '2panA01', NULL, NULL, 170, NULL, NULL, 232943),
(261073, '4cokA03', NULL, NULL, 189, NULL, NULL, 232943),
(261074, '2panA03', NULL, NULL, 224, NULL, NULL, 232943),
(261075, '1ovmA01', NULL, NULL, 186, NULL, NULL, 232943),
(261076, '2yicC02', NULL, NULL, 366, NULL, NULL, 232943),
(261077, '1ovmA03', NULL, NULL, 188, NULL, NULL, 232943),
(261078, '2ji7A03', NULL, NULL, 215, NULL, NULL, 232943),
(261079, '2uz1A01', NULL, NULL, 183, NULL, NULL, 232943),
(261080, '1v5eA03', NULL, NULL, 190, NULL, NULL, 232943),
(261081, '2o1xD01', NULL, NULL, 221, NULL, NULL, 232943),
(261082, '1v5eA01', NULL, NULL, 183, NULL, NULL, 232943),
(261083, '2ihtA03', NULL, NULL, 214, NULL, NULL, 232943),
(261084, '1gpuA01', NULL, NULL, 331, NULL, NULL, 232943),
(261085, '1qs0B01', NULL, NULL, 204, NULL, NULL, 232943),
(261086, '2vk4A03', NULL, NULL, 202, NULL, NULL, 232943),
(261087, '2q28A03', NULL, NULL, 214, NULL, NULL, 232943),
(261088, '6denA03', NULL, NULL, 228, NULL, NULL, 232943),
(261089, '2vk4A01', NULL, NULL, 188, NULL, NULL, 232943),
(261090, '2q28A01', NULL, NULL, 192, NULL, NULL, 232943),
(261091, '1gpuA02', NULL, NULL, 212, NULL, NULL, 232943),
(261092, '6denA01', NULL, NULL, 191, NULL, NULL, 232943),
(261093, '3rimB01', NULL, NULL, 354, NULL, NULL, 232943),
(261094, '4kgdA03', NULL, NULL, 190, NULL, NULL, 232943),
(261095, '2o1xA02', NULL, NULL, 178, NULL, NULL, 232943),
(261096, '3lq1B03', NULL, NULL, 173, NULL, NULL, 232943),
(261097, '4rjjA03', NULL, NULL, 204, NULL, NULL, 232943),
(261098, '5ej8A03', NULL, NULL, 210, NULL, NULL, 232943),
(261099, '5ej8A01', NULL, NULL, 196, NULL, NULL, 232943),
(261100, '4kgdA01', NULL, NULL, 192, NULL, NULL, 232943),
(261101, '4rjjE01', NULL, NULL, 192, NULL, NULL, 232943),
(261102, '1ik6A01', NULL, NULL, 188, NULL, NULL, 232943),
(261103, '5xvtA01', NULL, NULL, 326, NULL, NULL, 232943),
(261104, '5tmaA01', NULL, NULL, 186, NULL, NULL, 232943),
(261105, '5xvtA02', NULL, NULL, 212, NULL, NULL, 232943),
(261106, '2uz1B03', NULL, NULL, 200, NULL, NULL, 232943),
(261107, '3eyaA03', NULL, NULL, 216, NULL, NULL, 232943),
(261108, '2ihuA01', NULL, NULL, 195, NULL, NULL, 232943),
(261109, '5erxA01', NULL, NULL, 207, NULL, NULL, 232943),
(261110, '5erxA03', NULL, NULL, 204, NULL, NULL, 232943),
(261111, '2vbiA03', NULL, NULL, 189, NULL, NULL, 232943),
(261112, '1ybhA01', NULL, NULL, 195, NULL, NULL, 232943),
(261113, '1ybhA03', NULL, NULL, 194, NULL, NULL, 232943),
(261114, '5tmaA03', NULL, NULL, 194, NULL, NULL, 232943),
(261115, '1itzA02', NULL, NULL, 207, NULL, NULL, 232943),
(261116, '2x7jA01', NULL, NULL, 195, NULL, NULL, 232943),
(261117, '1itzA01', NULL, NULL, 331, NULL, NULL, 232943),
(261118, '1r9jA01', NULL, NULL, 335, NULL, NULL, 232943),
(261119, '2vbiA01', NULL, NULL, 186, NULL, NULL, 232943),
(261120, '2x7jA03', NULL, NULL, 202, NULL, NULL, 232943),
(261121, '2ozlB01', NULL, NULL, 193, NULL, NULL, 232943),
(261122, '1r9jA02', NULL, NULL, 201, NULL, NULL, 232943),
(261123, '4kxvA01', NULL, NULL, 295, NULL, NULL, 232943),
(261124, '4kxvA02', NULL, NULL, 194, NULL, NULL, 232943),
(261125, '3ai7A02', NULL, NULL, 226, NULL, NULL, 232943),
(261126, '5nd6A02', NULL, NULL, 207, NULL, NULL, 232943),
(261127, '3ai7A01', NULL, NULL, 398, NULL, NULL, 232943),
(261128, '4c7vA02', NULL, NULL, 209, NULL, NULL, 232943),
(261129, '3uk1A02', NULL, NULL, 216, NULL, NULL, 232943),
(261130, '4c7vA01', NULL, NULL, 329, NULL, NULL, 232943),
(261131, '3uk1A01', NULL, NULL, 326, NULL, NULL, 232943),
(261132, '5ahkA01', NULL, NULL, 183, NULL, NULL, 232943),
(261133, '2o1sC01', NULL, NULL, 234, NULL, NULL, 232943),
(261134, '5nd6A01', NULL, NULL, 332, NULL, NULL, 232943),
(261135, '5ahkA03', NULL, NULL, 188, NULL, NULL, 232943),
(261136, '3m49A02', NULL, NULL, 209, NULL, NULL, 232943),
(261137, '5dx6B01', NULL, NULL, 208, NULL, NULL, 232943),
(261138, '2nxwA03', NULL, NULL, 202, NULL, NULL, 232943),
(261139, '3l84A02', NULL, NULL, 196, NULL, NULL, 232943),
(261140, '2nxwA01', NULL, NULL, 202, NULL, NULL, 232943);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(261141, '2vbfA03', NULL, NULL, 190, NULL, NULL, 232943),
(261142, '5dx6B03', NULL, NULL, 202, NULL, NULL, 232943),
(261143, '3l84A01', NULL, NULL, 318, NULL, NULL, 232943),
(261144, '2vbfA01', NULL, NULL, 204, NULL, NULL, 232943),
(261145, '2c31A01', NULL, NULL, 194, NULL, NULL, 232943),
(261146, '2vk8A01', NULL, NULL, 188, NULL, NULL, 232943),
(261147, '4k9qA01', NULL, NULL, 176, NULL, NULL, 232943),
(261148, '2vk8A03', NULL, NULL, 202, NULL, NULL, 232943),
(261149, '3eyaH01', NULL, NULL, 178, NULL, NULL, 232943),
(261150, '1um9A00', NULL, NULL, 367, NULL, NULL, 232943),
(261151, '4k9qA03', NULL, NULL, 201, NULL, NULL, 232943),
(261152, '5exeA01', NULL, NULL, 251, NULL, NULL, 232943),
(261153, '5vrbA02', NULL, NULL, 211, NULL, NULL, 232943),
(261154, '5vrbA01', NULL, NULL, 331, NULL, NULL, 232943),
(261155, '2bfdA00', NULL, NULL, 400, NULL, NULL, 232943),
(261156, '2wvgA03', NULL, NULL, 194, NULL, NULL, 232943),
(261157, '4wbxC01', NULL, NULL, 209, NULL, NULL, 232943),
(261158, '2jgdB02', NULL, NULL, 365, NULL, NULL, 232943),
(261159, '4f7zA04', NULL, NULL, 161, NULL, NULL, 232944),
(261160, '4l9mA01', NULL, NULL, 137, NULL, NULL, 232944),
(261161, '4jgwA01', NULL, NULL, 173, NULL, NULL, 232944),
(261162, '6eieA01', NULL, NULL, 217, NULL, NULL, 232944),
(261163, '6d55B01', NULL, NULL, 217, NULL, NULL, 232944),
(261164, '3cf6E03', NULL, NULL, 161, NULL, NULL, 232944),
(261165, '3kwlA04', NULL, NULL, 136, NULL, NULL, 232945),
(261166, '5v37A02', NULL, NULL, 49, NULL, NULL, 232946),
(261167, '4a24A00', NULL, NULL, 47, NULL, NULL, 232946),
(261168, '2oddA00', NULL, NULL, 64, NULL, NULL, 232946),
(261169, '2jw6A00', NULL, NULL, 52, NULL, NULL, 232946),
(261170, '2od1A00', NULL, NULL, 60, NULL, NULL, 232946),
(261171, '5y5sC01', NULL, NULL, 136, NULL, NULL, 232947),
(261172, '5y5sC02', NULL, NULL, 144, NULL, NULL, 232947),
(261173, '2wjnC01', NULL, NULL, 142, NULL, NULL, 232947),
(261174, '2wjnC02', NULL, NULL, 156, NULL, NULL, 232947),
(261175, '4ftfA00', NULL, NULL, 112, NULL, NULL, 232948),
(261176, '3npdA00', NULL, NULL, 118, NULL, NULL, 232948),
(261177, '6i2vA00', NULL, NULL, 114, NULL, NULL, 232948),
(261178, '3gzdA02', NULL, NULL, 90, NULL, NULL, 232949),
(261179, '3a9zA02', NULL, NULL, 90, NULL, NULL, 232949),
(261180, '4xq7A02', NULL, NULL, 194, NULL, NULL, 232950),
(261181, '1px5A02', NULL, NULL, 189, NULL, NULL, 232950),
(261182, '4s3nA02', NULL, NULL, 212, NULL, NULL, 232950),
(261183, '4ig8A02', NULL, NULL, 188, NULL, NULL, 232950),
(261184, '3vldA02', NULL, NULL, 168, NULL, NULL, 232951),
(261185, '3opbA01', NULL, NULL, 295, NULL, NULL, 232952),
(261186, '2eg5E01', NULL, NULL, 142, NULL, NULL, 232953),
(261187, '5f2kB01', NULL, NULL, 153, NULL, NULL, 232953),
(261188, '2efjA01', NULL, NULL, 155, NULL, NULL, 232953),
(261189, '1m6eX01', NULL, NULL, 145, NULL, NULL, 232953),
(261190, '4gkwA00', NULL, NULL, 167, NULL, NULL, 232954),
(261191, '4iylA02', NULL, NULL, 36, NULL, NULL, 232955),
(261192, '3rjvA02', NULL, NULL, 65, NULL, NULL, 232956),
(261193, '1cwxA00', NULL, NULL, 44, NULL, NULL, 232957),
(261194, '4ak1A01', NULL, NULL, 107, NULL, NULL, 232958),
(261195, '4fioA01', NULL, NULL, 118, NULL, NULL, 232959),
(261196, '1qlmA01', NULL, NULL, 118, NULL, NULL, 232959),
(261197, '4gvqA01', NULL, NULL, 118, NULL, NULL, 232959),
(261198, '3dd9D02', NULL, NULL, 41, NULL, NULL, 232960),
(261199, '4a18U02', NULL, NULL, 42, NULL, NULL, 232961),
(261200, '2vokA00', NULL, NULL, 188, NULL, NULL, 232962),
(261201, '3uv9A00', NULL, NULL, 186, NULL, NULL, 232962),
(261202, '4p9jA00', NULL, NULL, 180, NULL, NULL, 232962),
(261203, '4b8eB00', NULL, NULL, 195, NULL, NULL, 232962),
(261204, '3kb5A00', NULL, NULL, 193, NULL, NULL, 232962),
(261205, '2wl1A00', NULL, NULL, 191, NULL, NULL, 232962),
(261206, '5vsnA00', NULL, NULL, 169, NULL, NULL, 232962),
(261207, '4wvmB04', NULL, NULL, 196, NULL, NULL, 232962),
(261208, '2yyoA00', NULL, NULL, 171, NULL, NULL, 232962),
(261209, '6itaA00', NULL, NULL, 196, NULL, NULL, 232962),
(261210, '4wvmA04', NULL, NULL, 196, NULL, NULL, 232962),
(261211, '4xw3A00', NULL, NULL, 205, NULL, NULL, 232962);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(261212, '4qt6A00', NULL, NULL, 159, NULL, NULL, 232962),
(261213, '5lygA00', NULL, NULL, 187, NULL, NULL, 232962),
(261214, '5ji7A00', NULL, NULL, 204, NULL, NULL, 232962),
(261215, '6flmA00', NULL, NULL, 199, NULL, NULL, 232962),
(261216, '2e63A00', NULL, NULL, 170, NULL, NULL, 232962),
(261217, '5c33A00', NULL, NULL, 198, NULL, NULL, 232962),
(261218, '2fbeD00', NULL, NULL, 201, NULL, NULL, 232962),
(261219, '5f6lB00', NULL, NULL, 184, NULL, NULL, 232962),
(261220, '2iwgB00', NULL, NULL, 181, NULL, NULL, 232962),
(261221, '5jiaJ00', NULL, NULL, 210, NULL, NULL, 232962),
(261222, '4kg0A01', NULL, NULL, 153, NULL, NULL, 232962),
(261223, '6j0gC00', NULL, NULL, 190, NULL, NULL, 232962),
(261224, '3f2eA00', NULL, NULL, 100, NULL, NULL, 232963),
(261225, '3j9x101', NULL, NULL, 86, NULL, NULL, 232963),
(261226, '3fblA00', NULL, NULL, 82, NULL, NULL, 232963),
(261227, '3fbzA01', NULL, NULL, 105, NULL, NULL, 232963),
(261228, '2wvxA03', NULL, NULL, 95, NULL, NULL, 232964),
(261229, '2ww2A03', NULL, NULL, 95, NULL, NULL, 232964),
(261230, '1ul4A01', NULL, NULL, 72, NULL, NULL, 232965),
(261231, '1ul5A01', NULL, NULL, 67, NULL, NULL, 232965),
(261232, '1wj0A00', NULL, NULL, 60, NULL, NULL, 232965),
(261233, '2xwsA00', NULL, NULL, 133, NULL, NULL, 232966),
(261234, '2xvyA02', NULL, NULL, 124, NULL, NULL, 232966),
(261235, '2xvyA01', NULL, NULL, 145, NULL, NULL, 232966),
(261236, '2jh3A02', NULL, NULL, 132, NULL, NULL, 232966),
(261237, '2c8jB01', NULL, NULL, 169, NULL, NULL, 232966),
(261238, '2c8jA02', NULL, NULL, 142, NULL, NULL, 232966),
(261239, '1lbqB01', NULL, NULL, 223, NULL, NULL, 232966),
(261240, '1lbqA02', NULL, NULL, 139, NULL, NULL, 232966),
(261241, '2h1vA02', NULL, NULL, 142, NULL, NULL, 232966),
(261242, '2jh3A01', NULL, NULL, 142, NULL, NULL, 232966),
(261243, '3lyhB00', NULL, NULL, 126, NULL, NULL, 232966),
(261244, '3hcnA02', NULL, NULL, 143, NULL, NULL, 232966),
(261245, '4ccsA02', NULL, NULL, 122, NULL, NULL, 232966),
(261246, '3hcnA01', NULL, NULL, 216, NULL, NULL, 232966),
(261247, '2xwpA02', NULL, NULL, 123, NULL, NULL, 232966),
(261248, '2xwpA01', NULL, NULL, 141, NULL, NULL, 232966),
(261249, '4ccsA01', NULL, NULL, 109, NULL, NULL, 232966),
(261250, '2h1vA01', NULL, NULL, 168, NULL, NULL, 232966),
(261251, '3b0pA02', NULL, NULL, 75, NULL, NULL, 232967),
(261252, '2kwpA00', NULL, NULL, 129, NULL, NULL, 232968),
(261253, '2mt4A00', NULL, NULL, 124, NULL, NULL, 232968),
(261254, '4mtnA01', NULL, NULL, 100, NULL, NULL, 232968),
(261255, '1k0rA01', NULL, NULL, 99, NULL, NULL, 232968),
(261256, '1hh2P01', NULL, NULL, 125, NULL, NULL, 232968),
(261257, '3gwcA02', NULL, NULL, 62, NULL, NULL, 232969),
(261258, '3fnnA02', NULL, NULL, 62, NULL, NULL, 232969),
(261259, '1nu7D02', NULL, NULL, 128, NULL, NULL, 232970),
(261260, '5y5qC00', NULL, NULL, 153, NULL, NULL, 232971),
(261261, '4lhrA00', NULL, NULL, 140, NULL, NULL, 232971),
(261262, '1pkhB00', NULL, NULL, 175, NULL, NULL, 232971),
(261263, '3mdxA00', NULL, NULL, 150, NULL, NULL, 232971),
(261264, '3ca9A00', NULL, NULL, 141, NULL, NULL, 232971),
(261265, '5ccoA00', NULL, NULL, 170, NULL, NULL, 232971),
(261266, '3km3B00', NULL, NULL, 158, NULL, NULL, 232971),
(261267, '1f7dA00', NULL, NULL, 118, NULL, NULL, 232971),
(261268, '1sjnB00', NULL, NULL, 140, NULL, NULL, 232971),
(261269, '1dunA00', NULL, NULL, 134, NULL, NULL, 232971),
(261270, '3h6xB00', NULL, NULL, 132, NULL, NULL, 232971),
(261271, '4b0hB00', NULL, NULL, 144, NULL, NULL, 232971),
(261272, '4gv8D00', NULL, NULL, 169, NULL, NULL, 232971),
(261273, '3c3iB00', NULL, NULL, 141, NULL, NULL, 232971),
(261274, '6mjkA00', NULL, NULL, 155, NULL, NULL, 232971),
(261275, '3so2A00', NULL, NULL, 146, NULL, NULL, 232971),
(261276, '2bsyA02', NULL, NULL, 106, NULL, NULL, 232971),
(261277, '2bsyA01', NULL, NULL, 150, NULL, NULL, 232971),
(261278, '4oopB00', NULL, NULL, 142, NULL, NULL, 232971),
(261279, '1euwA00', NULL, NULL, 136, NULL, NULL, 232971),
(261280, '6maiA00', NULL, NULL, 160, NULL, NULL, 232971),
(261281, '3ecyA00', NULL, NULL, 126, NULL, NULL, 232971),
(261282, '1sixA00', NULL, NULL, 174, NULL, NULL, 232971); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(261283, '2okbA00', NULL, NULL, 113, NULL, NULL, 232971),
(261284, '3t64A01', NULL, NULL, 152, NULL, NULL, 232971),
(261285, '4xjcF00', NULL, NULL, 177, NULL, NULL, 232971),
(261286, '2v9xJ01', NULL, NULL, 163, NULL, NULL, 232971),
(261287, '3ehwA00', NULL, NULL, 141, NULL, NULL, 232971),
(261288, '4gk6A00', NULL, NULL, 138, NULL, NULL, 232971),
(261289, '2ol1C00', NULL, NULL, 131, NULL, NULL, 232971),
(261290, '4ao5B01', NULL, NULL, 119, NULL, NULL, 232971),
(261291, '2qlpA01', NULL, NULL, 154, NULL, NULL, 232971),
(261292, '3p48C00', NULL, NULL, 147, NULL, NULL, 232971),
(261293, '2yzjA01', NULL, NULL, 151, NULL, NULL, 232971),
(261294, '5f9kB00', NULL, NULL, 130, NULL, NULL, 232971),
(261295, '3tqzA00', NULL, NULL, 155, NULL, NULL, 232971),
(261296, '3lqwA00', NULL, NULL, 141, NULL, NULL, 232971),
(261297, '2r9qC01', NULL, NULL, 172, NULL, NULL, 232971),
(261298, '4dhkB00', NULL, NULL, 163, NULL, NULL, 232971),
(261299, '3tq5A01', NULL, NULL, 105, NULL, NULL, 232971),
(261300, '2r9qA02', NULL, NULL, 173, NULL, NULL, 232971),
(261301, '3hzaA01', NULL, NULL, 139, NULL, NULL, 232971),
(261302, '3dwlE00', NULL, NULL, 92, NULL, NULL, 232972),
(261303, '5b66U01', NULL, NULL, 93, NULL, NULL, 232973),
(261304, '2duyA00', NULL, NULL, 75, NULL, NULL, 232973),
(261305, '2kdcA00', NULL, NULL, 121, NULL, NULL, 232974),
(261306, '2qrvD02', NULL, NULL, 56, NULL, NULL, 232975),
(261307, '1rp3A01', NULL, NULL, 87, NULL, NULL, 232976),
(261308, '2wpgA01', NULL, NULL, 91, NULL, NULL, 232976),
(261309, '1r0kC03', NULL, NULL, 87, NULL, NULL, 232976),
(261310, '4nqwA01', NULL, NULL, 85, NULL, NULL, 232976),
(261311, '1g5aA01', NULL, NULL, 97, NULL, NULL, 232976),
(261312, '4zn6A03', NULL, NULL, 87, NULL, NULL, 232976),
(261313, '5jazA03', NULL, NULL, 93, NULL, NULL, 232976),
(261314, '2o7gB00', NULL, NULL, 91, NULL, NULL, 232976),
(261315, '4zqeA03', NULL, NULL, 100, NULL, NULL, 232976),
(261316, '3a06B03', NULL, NULL, 90, NULL, NULL, 232976),
(261317, '3czgA01', NULL, NULL, 90, NULL, NULL, 232976),
(261318, '3iieB03', NULL, NULL, 87, NULL, NULL, 232976),
(261319, '4aysA01', NULL, NULL, 71, NULL, NULL, 232976),
(261320, '3t0yA01', NULL, NULL, 79, NULL, NULL, 232976),
(261321, '5or5A00', NULL, NULL, 95, NULL, NULL, 232976),
(261322, '5krvA03', NULL, NULL, 91, NULL, NULL, 232976),
(261323, '1h3lB00', NULL, NULL, 87, NULL, NULL, 232976),
(261324, '2y1eA03', NULL, NULL, 87, NULL, NULL, 232976),
(261325, '4lupA00', NULL, NULL, 106, NULL, NULL, 232976),
(261326, '4cxfA01', NULL, NULL, 91, NULL, NULL, 232976),
(261327, '1or7B01', NULL, NULL, 123, NULL, NULL, 232976),
(261328, '3ucqA01', NULL, NULL, 95, NULL, NULL, 232976),
(261329, '1q0qA03', NULL, NULL, 87, NULL, NULL, 232976),
(261330, '4b1zM01', NULL, NULL, 71, NULL, NULL, 232977),
(261331, '1chdA00', NULL, NULL, 203, NULL, NULL, 232978),
(261332, '3sftA00', NULL, NULL, 193, NULL, NULL, 232978),
(261333, '2l1aA00', NULL, NULL, 107, NULL, NULL, 232979),
(261334, '3pm9A03', NULL, NULL, 121, NULL, NULL, 232980),
(261335, '3d3uA02', NULL, NULL, 105, NULL, NULL, 232981),
(261336, '3eh7A02', NULL, NULL, 105, NULL, NULL, 232981),
(261337, '2oasA02', NULL, NULL, 104, NULL, NULL, 232981),
(261338, '3gk7A02', NULL, NULL, 105, NULL, NULL, 232981),
(261339, '4p02B02', NULL, NULL, 122, NULL, NULL, 232982),
(261340, '2i15A02', NULL, NULL, 91, NULL, NULL, 232983),
(261341, '1iokA02', NULL, NULL, 92, NULL, NULL, 232984),
(261342, '4d8qA02', NULL, NULL, 102, NULL, NULL, 232984),
(261343, '1kp8A02', NULL, NULL, 94, NULL, NULL, 232984),
(261344, '3ruvA02', NULL, NULL, 104, NULL, NULL, 232984),
(261345, '4d8qC02', NULL, NULL, 114, NULL, NULL, 232984),
(261346, '3p9dD02', NULL, NULL, 105, NULL, NULL, 232984),
(261347, '3p9dE02', NULL, NULL, 105, NULL, NULL, 232984),
(261348, '3rtkA02', NULL, NULL, 88, NULL, NULL, 232984),
(261349, '5cdiA02', NULL, NULL, 90, NULL, NULL, 232984),
(261350, '3kttB02', NULL, NULL, 105, NULL, NULL, 232984),
(261351, '4ki8A02', NULL, NULL, 66, NULL, NULL, 232984),
(261352, '1q3qA02', NULL, NULL, 107, NULL, NULL, 232984),
(261353, '4aolB02', NULL, NULL, 120, NULL, NULL, 232984);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(261354, '3aq1B02', NULL, NULL, 110, NULL, NULL, 232984),
(261355, '1we3A02', NULL, NULL, 92, NULL, NULL, 232984),
(261356, '3p9dH02', NULL, NULL, 113, NULL, NULL, 232984),
(261357, '3ko1A02', NULL, NULL, 107, NULL, NULL, 232984),
(261358, '3p9dF02', NULL, NULL, 107, NULL, NULL, 232984),
(261359, '4pj1A02', NULL, NULL, 92, NULL, NULL, 232984),
(261360, '3p9dG02', NULL, NULL, 106, NULL, NULL, 232984),
(261361, '4xciB02', NULL, NULL, 106, NULL, NULL, 232984),
(261362, '4xcgA02', NULL, NULL, 113, NULL, NULL, 232984),
(261363, '1a6dB02', NULL, NULL, 107, NULL, NULL, 232984),
(261364, '1a6dA02', NULL, NULL, 106, NULL, NULL, 232984),
(261365, '5da8A02', NULL, NULL, 94, NULL, NULL, 232984),
(261366, '4fvsE00', NULL, NULL, 215, NULL, NULL, 232985),
(261367, '3fzxA00', NULL, NULL, 218, NULL, NULL, 232985),
(261368, '3gw7A00', NULL, NULL, 239, NULL, NULL, 232986),
(261369, '2p5tA00', NULL, NULL, 92, NULL, NULL, 232987),
(261370, '1gvnA00', NULL, NULL, 90, NULL, NULL, 232987),
(261371, '1okgA03', NULL, NULL, 71, NULL, NULL, 232988),
(261372, '2xwxA03', NULL, NULL, 98, NULL, NULL, 232989),
(261373, '2aplA02', NULL, NULL, 88, NULL, NULL, 232990),
(261374, '5a6sA02', NULL, NULL, 80, NULL, NULL, 232991),
(261375, '4cu5A00', NULL, NULL, 85, NULL, NULL, 232991),
(261376, '2if6B00', NULL, NULL, 186, NULL, NULL, 232992),
(261377, '4cgkA02', NULL, NULL, 102, NULL, NULL, 232992),
(261378, '3m1uA01', NULL, NULL, 171, NULL, NULL, 232992),
(261379, '3m1uB01', NULL, NULL, 171, NULL, NULL, 232992),
(261380, '4f0wA00', NULL, NULL, 152, NULL, NULL, 232992),
(261381, '4r0kA03', NULL, NULL, 163, NULL, NULL, 232992),
(261382, '4q4gX00', NULL, NULL, 207, NULL, NULL, 232992),
(261383, '3pbiA00', NULL, NULL, 214, NULL, NULL, 232992),
(261384, '2vobB02', NULL, NULL, 214, NULL, NULL, 232992),
(261385, '2vpmA01', NULL, NULL, 203, NULL, NULL, 232992),
(261386, '2k3aA01', NULL, NULL, 100, NULL, NULL, 232992),
(261387, '2hbwA02', NULL, NULL, 148, NULL, NULL, 232992),
(261388, '4dpzX00', NULL, NULL, 137, NULL, NULL, 232992),
(261389, '4fdyA02', NULL, NULL, 134, NULL, NULL, 232992),
(261390, '3i86B00', NULL, NULL, 141, NULL, NULL, 232992),
(261391, '4q95A00', NULL, NULL, 149, NULL, NULL, 232992),
(261392, '4lj1A00', NULL, NULL, 147, NULL, NULL, 232992),
(261393, '4hz9A00', NULL, NULL, 119, NULL, NULL, 232992),
(261394, '2k1gA00', NULL, NULL, 135, NULL, NULL, 232992),
(261395, '2lktA00', NULL, NULL, 125, NULL, NULL, 232992),
(261396, '3kw0A00', NULL, NULL, 194, NULL, NULL, 232992),
(261397, '4hpeA02', NULL, NULL, 126, NULL, NULL, 232992),
(261398, '2evrA02', NULL, NULL, 148, NULL, NULL, 232992),
(261399, '3gt2A00', NULL, NULL, 142, NULL, NULL, 232992),
(261400, '2lrjA00', NULL, NULL, 113, NULL, NULL, 232992),
(261401, '4dotA00', NULL, NULL, 140, NULL, NULL, 232992),
(261402, '3a2zA00', NULL, NULL, 197, NULL, NULL, 232992),
(261403, '3h41A03', NULL, NULL, 126, NULL, NULL, 232992),
(261404, '4ct3A00', NULL, NULL, 165, NULL, NULL, 232992),
(261405, '3npfA03', NULL, NULL, 161, NULL, NULL, 232992),
(261406, '3u9jA00', NULL, NULL, 160, NULL, NULL, 232993),
(261407, '3caxA01', NULL, NULL, 221, NULL, NULL, 232993),
(261408, '2p0nA00', NULL, NULL, 172, NULL, NULL, 232993),
(261409, '2a5hA01', NULL, NULL, 53, NULL, NULL, 232994),
(261410, '3vpvA00', NULL, NULL, 85, NULL, NULL, 232995),
(261411, '3rq9A00', NULL, NULL, 85, NULL, NULL, 232995),
(261412, '3stqF00', NULL, NULL, 82, NULL, NULL, 232995),
(261413, '3zc4F02', NULL, NULL, 67, NULL, NULL, 232996),
(261414, '2o5iN05', NULL, NULL, 52, NULL, NULL, 232997),
(261415, '3w0lB03', NULL, NULL, 134, NULL, NULL, 232998),
(261416, '3u5ch02', NULL, NULL, 93, NULL, NULL, 232999),
(261417, '4ujfi02', NULL, NULL, 93, NULL, NULL, 232999),
(261418, '3cuqC01', NULL, NULL, 101, NULL, NULL, 233000),
(261419, '1xb4B01', NULL, NULL, 125, NULL, NULL, 233000),
(261420, '2l7qA01', NULL, NULL, 102, NULL, NULL, 233001),
(261421, '2l3bA00', NULL, NULL, 130, NULL, NULL, 233001),
(261422, '4lbaA01', NULL, NULL, 101, NULL, NULL, 233001),
(261423, '1e1rG00', NULL, NULL, 122, NULL, NULL, 233002),
(261424, '2r9iA00', NULL, NULL, 75, NULL, NULL, 233002);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(261425, '2qe7G01', NULL, NULL, 99, NULL, NULL, 233002),
(261426, '5dn6G01', NULL, NULL, 67, NULL, NULL, 233002),
(261427, '3oaaG01', NULL, NULL, 140, NULL, NULL, 233002),
(261428, '5fl7G01', NULL, NULL, 66, NULL, NULL, 233002),
(261429, '3ziaG01', NULL, NULL, 67, NULL, NULL, 233002),
(261430, '2ck3G01', NULL, NULL, 61, NULL, NULL, 233002),
(261431, '1ohhG00', NULL, NULL, 94, NULL, NULL, 233002),
(261432, '3ofnY00', NULL, NULL, 117, NULL, NULL, 233002),
(261433, '2dw4A03', NULL, NULL, 116, NULL, NULL, 233002),
(261434, '1fs0G02', NULL, NULL, 89, NULL, NULL, 233002),
(261435, '1mabG00', NULL, NULL, 152, NULL, NULL, 233002),
(261436, '1sxvA00', NULL, NULL, 172, NULL, NULL, 233003),
(261437, '3sw5A00', NULL, NULL, 180, NULL, NULL, 233003),
(261438, '3q46A00', NULL, NULL, 178, NULL, NULL, 233003),
(261439, '1twlA00', NULL, NULL, 186, NULL, NULL, 233003),
(261440, '5c5vA02', NULL, NULL, 254, NULL, NULL, 233003),
(261441, '3tr4B00', NULL, NULL, 178, NULL, NULL, 233003),
(261442, '3fq3A00', NULL, NULL, 176, NULL, NULL, 233003),
(261443, '6n1cA00', NULL, NULL, 186, NULL, NULL, 233003),
(261444, '1udeA00', NULL, NULL, 175, NULL, NULL, 233003),
(261445, '4qlzB00', NULL, NULL, 287, NULL, NULL, 233003),
(261446, '3i4qA00', NULL, NULL, 176, NULL, NULL, 233003),
(261447, '2au7A00', NULL, NULL, 175, NULL, NULL, 233003),
(261448, '2prdA00', NULL, NULL, 174, NULL, NULL, 233003),
(261449, '3lo0A00', NULL, NULL, 169, NULL, NULL, 233003),
(261450, '3ld3A00', NULL, NULL, 174, NULL, NULL, 233003),
(261451, '1e9gB00', NULL, NULL, 286, NULL, NULL, 233003),
(261452, '4ecpB00', NULL, NULL, 167, NULL, NULL, 233003),
(261453, '1qezA00', NULL, NULL, 173, NULL, NULL, 233003),
(261454, '6c45B00', NULL, NULL, 289, NULL, NULL, 233003),
(261455, '2bqxA00', NULL, NULL, 173, NULL, NULL, 233003),
(261456, '3eizA00', NULL, NULL, 196, NULL, NULL, 233003),
(261457, '5wrtB00', NULL, NULL, 235, NULL, NULL, 233003),
(261458, '5ls0B00', NULL, NULL, 179, NULL, NULL, 233003),
(261459, '3d53C00', NULL, NULL, 173, NULL, NULL, 233003),
(261460, '5cuxB00', NULL, NULL, 263, NULL, NULL, 233003),
(261461, '4xelA00', NULL, NULL, 183, NULL, NULL, 233003),
(261462, '5teaB00', NULL, NULL, 185, NULL, NULL, 233003),
(261463, '1vx7T01', NULL, NULL, 55, NULL, NULL, 233004),
(261464, '1vq8P01', NULL, NULL, 56, NULL, NULL, 233004),
(261465, '3o58S01', NULL, NULL, 56, NULL, NULL, 233004),
(261466, '4a17O01', NULL, NULL, 56, NULL, NULL, 233004),
(261467, '1vwxR01', NULL, NULL, 56, NULL, NULL, 233004),
(261468, '3pf6D00', NULL, NULL, 62, NULL, NULL, 233005),
(261469, '3pf6C00', NULL, NULL, 62, NULL, NULL, 233005),
(261470, '3pf6B00', NULL, NULL, 62, NULL, NULL, 233005),
(261471, '3pf6A00', NULL, NULL, 62, NULL, NULL, 233005),
(261472, '3sqiA01', NULL, NULL, 103, NULL, NULL, 233006),
(261473, '3tiqA00', NULL, NULL, 214, NULL, NULL, 233007),
(261474, '4wveA00', NULL, NULL, 215, NULL, NULL, 233007),
(261475, '4f3fC00', NULL, NULL, 69, NULL, NULL, 233008),
(261476, '4bgpA01', NULL, NULL, 132, NULL, NULL, 233009),
(261477, '3zlaD01', NULL, NULL, 132, NULL, NULL, 233009),
(261478, '4jngC01', NULL, NULL, 130, NULL, NULL, 233009),
(261479, '4j1jD01', NULL, NULL, 132, NULL, NULL, 233009),
(261480, '1x9zA02', NULL, NULL, 89, NULL, NULL, 233010),
(261481, '3ncvA02', NULL, NULL, 96, NULL, NULL, 233010),
(261482, '3kdgA02', NULL, NULL, 98, NULL, NULL, 233010),
(261483, '3k6cD00', NULL, NULL, 95, NULL, NULL, 233011),
(261484, '5n5fA00', NULL, NULL, 98, NULL, NULL, 233011),
(261485, '5da5C00', NULL, NULL, 96, NULL, NULL, 233011),
(261486, '4twgC00', NULL, NULL, 161, NULL, NULL, 233012),
(261487, '3k6aA00', NULL, NULL, 180, NULL, NULL, 233012),
(261488, '3tcrA00', NULL, NULL, 158, NULL, NULL, 233012),
(261489, '1wu2B01', NULL, NULL, 165, NULL, NULL, 233012),
(261490, '1uz5A01', NULL, NULL, 174, NULL, NULL, 233012),
(261491, '6fgcA01', NULL, NULL, 182, NULL, NULL, 233012),
(261492, '3pzyA00', NULL, NULL, 164, NULL, NULL, 233012),
(261493, '1xi8A01', NULL, NULL, 170, NULL, NULL, 233012),
(261494, '1di6A00', NULL, NULL, 195, NULL, NULL, 233012),
(261495, '4nwoA00', NULL, NULL, 177, NULL, NULL, 233012);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(261496, '1uuyA00', NULL, NULL, 167, NULL, NULL, 233012),
(261497, '1jljA00', NULL, NULL, 189, NULL, NULL, 233012),
(261498, '3rfqC00', NULL, NULL, 161, NULL, NULL, 233012),
(261499, '2g4rA00', NULL, NULL, 160, NULL, NULL, 233012),
(261500, '3mchB00', NULL, NULL, 164, NULL, NULL, 233012),
(261501, '1g8lA01', NULL, NULL, 188, NULL, NULL, 233012),
(261502, '3iwtA00', NULL, NULL, 178, NULL, NULL, 233012),
(261503, '4lhbC00', NULL, NULL, 160, NULL, NULL, 233012),
(261504, '4uuwA01', NULL, NULL, 172, NULL, NULL, 233012),
(261505, '1y5eC00', NULL, NULL, 169, NULL, NULL, 233012),
(261506, '2g2cA00', NULL, NULL, 167, NULL, NULL, 233012),
(261507, '1wu2A01', NULL, NULL, 164, NULL, NULL, 233012),
(261508, '3kbqB00', NULL, NULL, 172, NULL, NULL, 233012),
(261509, '6gbcA01', NULL, NULL, 198, NULL, NULL, 233012),
(261510, '2pbqC00', NULL, NULL, 178, NULL, NULL, 233012),
(261511, '1mkzB00', NULL, NULL, 172, NULL, NULL, 233012),
(261512, '4xcwA00', NULL, NULL, 178, NULL, NULL, 233012),
(261513, '2qsrA01', NULL, NULL, 166, NULL, NULL, 233013),
(261514, '2eyqA07', NULL, NULL, 148, NULL, NULL, 233013),
(261515, '4impA01', NULL, NULL, 53, NULL, NULL, 233014),
(261516, '5mu9A02', NULL, NULL, 139, NULL, NULL, 233015),
(261517, '5muaA02', NULL, NULL, 138, NULL, NULL, 233015),
(261518, '4p0pB02', NULL, NULL, 104, NULL, NULL, 233016),
(261519, '2ziuA02', NULL, NULL, 83, NULL, NULL, 233016),
(261520, '4p0pA02', NULL, NULL, 83, NULL, NULL, 233016),
(261521, '2kicA00', NULL, NULL, 98, NULL, NULL, 233017),
(261522, '1e5wA04', NULL, NULL, 55, NULL, NULL, 233018),
(261523, '4m5dA05', NULL, NULL, 144, NULL, NULL, 233019),
(261524, '4djdC02', NULL, NULL, 130, NULL, NULL, 233020),
(261525, '2h9aA02', NULL, NULL, 130, NULL, NULL, 233020),
(261526, '3psfA02', NULL, NULL, 152, NULL, NULL, 233021),
(261527, '3bzcA01', NULL, NULL, 114, NULL, NULL, 233021),
(261528, '3p3aB02', NULL, NULL, 143, NULL, NULL, 233022),
(261529, '5wqjA01', NULL, NULL, 158, NULL, NULL, 233022),
(261530, '1hzmA00', NULL, NULL, 154, NULL, NULL, 233022),
(261531, '1okgA01', NULL, NULL, 161, NULL, NULL, 233022),
(261532, '1urhA02', NULL, NULL, 132, NULL, NULL, 233022),
(261533, '4jgtA02', NULL, NULL, 131, NULL, NULL, 233022),
(261534, '1okgA02', NULL, NULL, 141, NULL, NULL, 233022),
(261535, '4jgtC01', NULL, NULL, 150, NULL, NULL, 233022),
(261536, '1urhA01', NULL, NULL, 148, NULL, NULL, 233022),
(261537, '2gwfC00', NULL, NULL, 139, NULL, NULL, 233022),
(261538, '1uarA01', NULL, NULL, 143, NULL, NULL, 233022),
(261539, '1uarA02', NULL, NULL, 142, NULL, NULL, 233022),
(261540, '3icsA03', NULL, NULL, 102, NULL, NULL, 233022),
(261541, '3tp9A02', NULL, NULL, 110, NULL, NULL, 233022),
(261542, '5wqjA02', NULL, NULL, 139, NULL, NULL, 233022),
(261543, '3aayA01', NULL, NULL, 141, NULL, NULL, 233022),
(261544, '3aayA02', NULL, NULL, 136, NULL, NULL, 233022),
(261545, '3tp9A03', NULL, NULL, 102, NULL, NULL, 233022),
(261546, '1c25A00', NULL, NULL, 161, NULL, NULL, 233022),
(261547, '2fsxA00', NULL, NULL, 148, NULL, NULL, 233022),
(261548, '2kl3A01', NULL, NULL, 106, NULL, NULL, 233022),
(261549, '2jtqA00', NULL, NULL, 85, NULL, NULL, 233022),
(261550, '3flhB00', NULL, NULL, 124, NULL, NULL, 233022),
(261551, '3gk5A00', NULL, NULL, 108, NULL, NULL, 233022),
(261552, '1e0cA02', NULL, NULL, 127, NULL, NULL, 233022),
(261553, '2wlxA03', NULL, NULL, 160, NULL, NULL, 233022),
(261554, '3utnX02', NULL, NULL, 148, NULL, NULL, 233022),
(261555, '3i2vA00', NULL, NULL, 127, NULL, NULL, 233022),
(261556, '1e0cA01', NULL, NULL, 144, NULL, NULL, 233022),
(261557, '3utnX01', NULL, NULL, 156, NULL, NULL, 233022),
(261558, '3fojA00', NULL, NULL, 100, NULL, NULL, 233022),
(261559, '3mzzA00', NULL, NULL, 103, NULL, NULL, 233022),
(261560, '3hzuA02', NULL, NULL, 142, NULL, NULL, 233022),
(261561, '3hzuA01', NULL, NULL, 153, NULL, NULL, 233022),
(261562, '2hhgA00', NULL, NULL, 139, NULL, NULL, 233022),
(261563, '2a2kA00', NULL, NULL, 175, NULL, NULL, 233022),
(261564, '2eg4A02', NULL, NULL, 111, NULL, NULL, 233022),
(261565, '1veeA00', NULL, NULL, 134, NULL, NULL, 233022),
(261566, '2eg4A01', NULL, NULL, 118, NULL, NULL, 233022);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(261567, '5ve3A02', NULL, NULL, 112, NULL, NULL, 233022),
(261568, '3d1pA00', NULL, NULL, 120, NULL, NULL, 233022),
(261569, '5hbpA00', NULL, NULL, 106, NULL, NULL, 233022),
(261570, '3r2uA02', NULL, NULL, 84, NULL, NULL, 233022),
(261571, '3k9rC00', NULL, NULL, 115, NULL, NULL, 233022),
(261572, '1wv9A00', NULL, NULL, 94, NULL, NULL, 233022),
(261573, '3g5jA00', NULL, NULL, 134, NULL, NULL, 233022),
(261574, '2vswA00', NULL, NULL, 134, NULL, NULL, 233022),
(261575, '3op3A00', NULL, NULL, 183, NULL, NULL, 233022),
(261576, '2j6pA00', NULL, NULL, 152, NULL, NULL, 233022),
(261577, '2uzqA00', NULL, NULL, 182, NULL, NULL, 233022),
(261578, '1tq1A00', NULL, NULL, 129, NULL, NULL, 233022),
(261579, '3p3aA01', NULL, NULL, 153, NULL, NULL, 233022),
(261580, '1yt8A03', NULL, NULL, 91, NULL, NULL, 233022),
(261581, '1yt8A04', NULL, NULL, 107, NULL, NULL, 233022),
(261582, '4f67A02', NULL, NULL, 158, NULL, NULL, 233022),
(261583, '2oucA00', NULL, NULL, 142, NULL, NULL, 233022),
(261584, '1qxnA00', NULL, NULL, 137, NULL, NULL, 233022),
(261585, '1yt8A01', NULL, NULL, 97, NULL, NULL, 233022),
(261586, '1rhsA01', NULL, NULL, 156, NULL, NULL, 233022),
(261587, '1yt8A02', NULL, NULL, 108, NULL, NULL, 233022),
(261588, '1rhsA02', NULL, NULL, 136, NULL, NULL, 233022),
(261589, '3ilmB00', NULL, NULL, 141, NULL, NULL, 233022),
(261590, '1t3kA00', NULL, NULL, 132, NULL, NULL, 233022),
(261591, '1gmxA00', NULL, NULL, 108, NULL, NULL, 233022),
(261592, '2k0zA00', NULL, NULL, 110, NULL, NULL, 233022),
(261593, '3f4aA00', NULL, NULL, 144, NULL, NULL, 233022),
(261594, '2wlrA02', NULL, NULL, 145, NULL, NULL, 233022),
(261595, '2wlrA03', NULL, NULL, 160, NULL, NULL, 233022),
(261596, '3nhvC01', NULL, NULL, 120, NULL, NULL, 233022),
(261597, '2wlrA01', NULL, NULL, 118, NULL, NULL, 233022),
(261598, '3ntdA03', NULL, NULL, 95, NULL, NULL, 233022),
(261599, '3foaB01', NULL, NULL, 231, NULL, NULL, 233023),
(261600, '4od8D00', NULL, NULL, 52, NULL, NULL, 233024),
(261601, '2wyhB06', NULL, NULL, 283, NULL, NULL, 233025),
(261602, '5kbpA04', NULL, NULL, 285, NULL, NULL, 233025),
(261603, '4k35A02', NULL, NULL, 204, NULL, NULL, 233025),
(261604, '1o7dD01', NULL, NULL, 264, NULL, NULL, 233025),
(261605, '3bvxA04', NULL, NULL, 280, NULL, NULL, 233025),
(261606, '4lo6B01', NULL, NULL, 141, NULL, NULL, 233026),
(261607, '2zoeA00', NULL, NULL, 168, NULL, NULL, 233026),
(261608, '3ziwA01', NULL, NULL, 171, NULL, NULL, 233026),
(261609, '4lo6A00', NULL, NULL, 170, NULL, NULL, 233026),
(261610, '4en6B01', NULL, NULL, 140, NULL, NULL, 233026),
(261611, '4iffA00', NULL, NULL, 86, NULL, NULL, 233027),
(261612, '1no4B00', NULL, NULL, 75, NULL, NULL, 233027),
(261613, '3mtuE00', NULL, NULL, 77, NULL, NULL, 233027),
(261614, '2wnfA00', NULL, NULL, 298, NULL, NULL, 233028),
(261615, '5bo7B00', NULL, NULL, 293, NULL, NULL, 233028),
(261616, '4mpsA00', NULL, NULL, 310, NULL, NULL, 233028),
(261617, '4js1A00', NULL, NULL, 318, NULL, NULL, 233028),
(261618, '4qjvA03', NULL, NULL, 62, NULL, NULL, 233029),
(261619, '3clqD02', NULL, NULL, 158, NULL, NULL, 233030),
(261620, '3clqC02', NULL, NULL, 158, NULL, NULL, 233030),
(261621, '3clqB02', NULL, NULL, 158, NULL, NULL, 233030),
(261622, '3clqA02', NULL, NULL, 158, NULL, NULL, 233030),
(261623, '2nzxA02', NULL, NULL, 126, NULL, NULL, 233031),
(261624, '5t1dB00', NULL, NULL, 112, NULL, NULL, 233032),
(261625, '2wp7A00', NULL, NULL, 168, NULL, NULL, 233033),
(261626, '2ww8A04', NULL, NULL, 74, NULL, NULL, 233034),
(261627, '3tvyA02', NULL, NULL, 59, NULL, NULL, 233034),
(261628, '3kmlA00', NULL, NULL, 161, NULL, NULL, 233035),
(261629, '3fbqA02', NULL, NULL, 145, NULL, NULL, 233036),
(261630, '3t4rA00', NULL, NULL, 81, NULL, NULL, 233037),
(261631, '4g1iA02', NULL, NULL, 71, NULL, NULL, 233038),
(261632, '2ksgA01', NULL, NULL, 42, NULL, NULL, 233039),
(261633, '3wguB00', NULL, NULL, 303, NULL, NULL, 233040),
(261634, '4xe5B02', NULL, NULL, 242, NULL, NULL, 233040),
(261635, '2zxeB02', NULL, NULL, 243, NULL, NULL, 233040),
(261636, '4hytB02', NULL, NULL, 242, NULL, NULL, 233040),
(261637, '1uz3B00', NULL, NULL, 102, NULL, NULL, 233041);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(261638, '2fmmE00', NULL, NULL, 133, NULL, NULL, 233041),
(261639, '1kvdB00', NULL, NULL, 77, NULL, NULL, 233042),
(261640, '3h4sA02', NULL, NULL, 49, NULL, NULL, 233043),
(261641, '2oojB00', NULL, NULL, 141, NULL, NULL, 233044),
(261642, '2q03B00', NULL, NULL, 138, NULL, NULL, 233044),
(261643, '3bdlA01', NULL, NULL, 166, NULL, NULL, 233045),
(261644, '4k14A00', NULL, NULL, 136, NULL, NULL, 233045),
(261645, '5vqhA01', NULL, NULL, 157, NULL, NULL, 233045),
(261646, '3bdlA03', NULL, NULL, 125, NULL, NULL, 233045),
(261647, '3bdlA02', NULL, NULL, 154, NULL, NULL, 233045),
(261648, '4qmgC01', NULL, NULL, 169, NULL, NULL, 233045),
(261649, '4qmgA02', NULL, NULL, 156, NULL, NULL, 233045),
(261650, '1rknA00', NULL, NULL, 110, NULL, NULL, 233045),
(261651, '1snqA00', NULL, NULL, 149, NULL, NULL, 233045),
(261652, '4kd4A00', NULL, NULL, 149, NULL, NULL, 233045),
(261653, '2of1A00', NULL, NULL, 138, NULL, NULL, 233045),
(261654, '4b9wA01', NULL, NULL, 113, NULL, NULL, 233045),
(261655, '5j39A01', NULL, NULL, 138, NULL, NULL, 233045),
(261656, '4k5wA00', NULL, NULL, 149, NULL, NULL, 233045),
(261657, '5m9oA01', NULL, NULL, 131, NULL, NULL, 233045),
(261658, '2wacA01', NULL, NULL, 127, NULL, NULL, 233045),
(261659, '3tmeA00', NULL, NULL, 143, NULL, NULL, 233045),
(261660, '4eqpA00', NULL, NULL, 143, NULL, NULL, 233045),
(261661, '1f2zA00', NULL, NULL, 149, NULL, NULL, 233045),
(261662, '5ygbA01', NULL, NULL, 143, NULL, NULL, 233045),
(261663, '3mmyB00', NULL, NULL, 56, NULL, NULL, 233046),
(261664, '1sg2B00', NULL, NULL, 119, NULL, NULL, 233047),
(261665, '1u2mB00', NULL, NULL, 143, NULL, NULL, 233047),
(261666, '1u2mA00', NULL, NULL, 86, NULL, NULL, 233047),
(261667, '2b1eA03', NULL, NULL, 172, NULL, NULL, 233048),
(261668, '5hzxA00', NULL, NULL, 154, NULL, NULL, 233049),
(261669, '1k2eA00', NULL, NULL, 156, NULL, NULL, 233049),
(261670, '5wwdA00', NULL, NULL, 149, NULL, NULL, 233049),
(261671, '1x51A01', NULL, NULL, 143, NULL, NULL, 233049),
(261672, '3i9xA00', NULL, NULL, 165, NULL, NULL, 233049),
(261673, '3i7uA01', NULL, NULL, 126, NULL, NULL, 233049),
(261674, '4kyxA00', NULL, NULL, 149, NULL, NULL, 233049),
(261675, '3exqA01', NULL, NULL, 144, NULL, NULL, 233049),
(261676, '3o69A00', NULL, NULL, 191, NULL, NULL, 233049),
(261677, '3f13B00', NULL, NULL, 163, NULL, NULL, 233049),
(261678, '2yyhA00', NULL, NULL, 139, NULL, NULL, 233049),
(261679, '4kg3B00', NULL, NULL, 146, NULL, NULL, 233049),
(261680, '3smdA00', NULL, NULL, 153, NULL, NULL, 233049),
(261681, '5zrcA00', NULL, NULL, 128, NULL, NULL, 233049),
(261682, '2fmlA02', NULL, NULL, 164, NULL, NULL, 233049),
(261683, '3q91B00', NULL, NULL, 147, NULL, NULL, 233049),
(261684, '4hfqA02', NULL, NULL, 139, NULL, NULL, 233049),
(261685, '3grnA00', NULL, NULL, 153, NULL, NULL, 233049),
(261686, '3edsA00', NULL, NULL, 153, NULL, NULL, 233049),
(261687, '1mk1A00', NULL, NULL, 207, NULL, NULL, 233049),
(261688, '1vhzA01', NULL, NULL, 189, NULL, NULL, 233049),
(261689, '3fcmA00', NULL, NULL, 197, NULL, NULL, 233049),
(261690, '2pqvB00', NULL, NULL, 154, NULL, NULL, 233049),
(261691, '2b06A00', NULL, NULL, 155, NULL, NULL, 233049),
(261692, '4dywA00', NULL, NULL, 132, NULL, NULL, 233049),
(261693, '2a8tB00', NULL, NULL, 195, NULL, NULL, 233049),
(261694, '1f3yA00', NULL, NULL, 165, NULL, NULL, 233049),
(261695, '3hyqA00', NULL, NULL, 151, NULL, NULL, 233049),
(261696, '3sonA00', NULL, NULL, 149, NULL, NULL, 233049),
(261697, '3hhjB00', NULL, NULL, 132, NULL, NULL, 233049),
(261698, '5qoqA00', NULL, NULL, 151, NULL, NULL, 233049),
(261699, '2rrkA00', NULL, NULL, 140, NULL, NULL, 233049),
(261700, '2o1cA00', NULL, NULL, 150, NULL, NULL, 233049),
(261701, '3kvhA00', NULL, NULL, 214, NULL, NULL, 233049),
(261702, '1ryaA00', NULL, NULL, 160, NULL, NULL, 233049),
(261703, '2w4eA00', NULL, NULL, 145, NULL, NULL, 233049),
(261704, '3o8sA00', NULL, NULL, 139, NULL, NULL, 233049),
(261705, '3fjyA01', NULL, NULL, 182, NULL, NULL, 233049),
(261706, '6dt3B00', NULL, NULL, 144, NULL, NULL, 233049),
(261707, '3qsjA00', NULL, NULL, 232, NULL, NULL, 233049),
(261708, '4jzuA00', NULL, NULL, 158, NULL, NULL, 233049);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(261709, '3h95A01', NULL, NULL, 140, NULL, NULL, 233049),
(261710, '4mpoB00', NULL, NULL, 153, NULL, NULL, 233049),
(261711, '3bhoA01', NULL, NULL, 193, NULL, NULL, 233049),
(261712, '1sjyA00', NULL, NULL, 159, NULL, NULL, 233049),
(261713, '5x1xA00', NULL, NULL, 130, NULL, NULL, 233049),
(261714, '3dupB01', NULL, NULL, 178, NULL, NULL, 233049),
(261715, '3j7ye00', NULL, NULL, 135, NULL, NULL, 233049),
(261716, '5deqA01', NULL, NULL, 143, NULL, NULL, 233049),
(261717, '5lpgA00', NULL, NULL, 164, NULL, NULL, 233049),
(261718, '2r5wB02', NULL, NULL, 151, NULL, NULL, 233049),
(261719, '3a6sA00', NULL, NULL, 129, NULL, NULL, 233049),
(261720, '2b0vA00', NULL, NULL, 153, NULL, NULL, 233049),
(261721, '5z78B00', NULL, NULL, 209, NULL, NULL, 233049),
(261722, '1q33A02', NULL, NULL, 171, NULL, NULL, 233049),
(261723, '3fk9A00', NULL, NULL, 155, NULL, NULL, 233049),
(261724, '5mzeA00', NULL, NULL, 153, NULL, NULL, 233049),
(261725, '2o5fB00', NULL, NULL, 171, NULL, NULL, 233049),
(261726, '5c7qB00', NULL, NULL, 182, NULL, NULL, 233049),
(261727, '3f6aA00', NULL, NULL, 159, NULL, NULL, 233049),
(261728, '4ickA00', NULL, NULL, 155, NULL, NULL, 233049),
(261729, '5ws7A00', NULL, NULL, 156, NULL, NULL, 233049),
(261730, '2qjoB02', NULL, NULL, 145, NULL, NULL, 233049),
(261731, '4nfwF00', NULL, NULL, 153, NULL, NULL, 233049),
(261732, '4ktbA00', NULL, NULL, 161, NULL, NULL, 233049),
(261733, '4v14A00', NULL, NULL, 138, NULL, NULL, 233049),
(261734, '3cngC02', NULL, NULL, 152, NULL, NULL, 233049),
(261735, '3fspA03', NULL, NULL, 132, NULL, NULL, 233049),
(261736, '5ltuB00', NULL, NULL, 147, NULL, NULL, 233049),
(261737, '3q91D00', NULL, NULL, 184, NULL, NULL, 233049),
(261738, '4s2xA00', NULL, NULL, 161, NULL, NULL, 233049),
(261739, '1vw4601', NULL, NULL, 129, NULL, NULL, 233049),
(261740, '3rh7A02', NULL, NULL, 129, NULL, NULL, 233049),
(261741, '1ppvA00', NULL, NULL, 183, NULL, NULL, 233049),
(261742, '1ktgA00', NULL, NULL, 138, NULL, NULL, 233049),
(261743, '1vcdA01', NULL, NULL, 122, NULL, NULL, 233049),
(261744, '3eesA00', NULL, NULL, 134, NULL, NULL, 233049),
(261745, '3mgmA00', NULL, NULL, 164, NULL, NULL, 233049),
(261746, '3gz8C01', NULL, NULL, 140, NULL, NULL, 233049),
(261747, '2yvpA00', NULL, NULL, 182, NULL, NULL, 233049),
(261748, '2pnyA00', NULL, NULL, 246, NULL, NULL, 233049),
(261749, '5cfjA00', NULL, NULL, 152, NULL, NULL, 233049),
(261750, '1nqzA00', NULL, NULL, 194, NULL, NULL, 233049),
(261751, '2fkbC00', NULL, NULL, 180, NULL, NULL, 233049),
(261752, '3id9B00', NULL, NULL, 149, NULL, NULL, 233049),
(261753, '3n77A00', NULL, NULL, 144, NULL, NULL, 233049),
(261754, '4hvyA00', NULL, NULL, 162, NULL, NULL, 233049),
(261755, '1vk6A02', NULL, NULL, 132, NULL, NULL, 233049),
(261756, '5qk0D00', NULL, NULL, 209, NULL, NULL, 233049),
(261757, '3x0iA00', NULL, NULL, 170, NULL, NULL, 233049),
(261758, '2dhoA00', NULL, NULL, 215, NULL, NULL, 233049),
(261759, '2qkmB02', NULL, NULL, 158, NULL, NULL, 233049),
(261760, '3mcfA00', NULL, NULL, 136, NULL, NULL, 233049),
(261761, '1hztA00', NULL, NULL, 160, NULL, NULL, 233049),
(261762, '1g0sA00', NULL, NULL, 209, NULL, NULL, 233049),
(261763, '3gwyB00', NULL, NULL, 140, NULL, NULL, 233049),
(261764, '3q1pA02', NULL, NULL, 165, NULL, NULL, 233049),
(261765, '3e57A00', NULL, NULL, 211, NULL, NULL, 233049),
(261766, '2fvvA00', NULL, NULL, 135, NULL, NULL, 233049),
(261767, '3r03A00', NULL, NULL, 144, NULL, NULL, 233049),
(261768, '2azwA00', NULL, NULL, 148, NULL, NULL, 233049),
(261769, '4hkrA00', NULL, NULL, 214, NULL, NULL, 233050),
(261770, '2hvbA00', NULL, NULL, 124, NULL, NULL, 233051),
(261771, '1dfxA00', NULL, NULL, 125, NULL, NULL, 233051),
(261772, '1dqiA00', NULL, NULL, 124, NULL, NULL, 233051),
(261773, '1vziA02', NULL, NULL, 87, NULL, NULL, 233051),
(261774, '4d7pA00', NULL, NULL, 111, NULL, NULL, 233051),
(261775, '4bk8A00', NULL, NULL, 124, NULL, NULL, 233051),
(261776, '4bglD00', NULL, NULL, 125, NULL, NULL, 233051),
(261777, '4bv1A00', NULL, NULL, 109, NULL, NULL, 233051),
(261778, '3qzbA00', NULL, NULL, 143, NULL, NULL, 233051),
(261779, '1y07A02', NULL, NULL, 88, NULL, NULL, 233051);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(261780, '3ka7A02', NULL, NULL, 206, NULL, NULL, 233052),
(261781, '3nrnA02', NULL, NULL, 197, NULL, NULL, 233052),
(261782, '3pieC09', NULL, NULL, 112, NULL, NULL, 233053),
(261783, '3eaqA02', NULL, NULL, 53, NULL, NULL, 233054),
(261784, '3d19B00', NULL, NULL, 283, NULL, NULL, 233055),
(261785, '3dbyL00', NULL, NULL, 269, NULL, NULL, 233055),
(261786, '5e3qA01', NULL, NULL, 91, NULL, NULL, 233056),
(261787, '3fsyB01', NULL, NULL, 112, NULL, NULL, 233056),
(261788, '2rijA01', NULL, NULL, 166, NULL, NULL, 233056),
(261789, '3r5dA01', NULL, NULL, 134, NULL, NULL, 233056),
(261790, '4iuwA02', NULL, NULL, 339, NULL, NULL, 233057),
(261791, '4xbhA02', NULL, NULL, 374, NULL, NULL, 233057),
(261792, '3zukA02', NULL, NULL, 342, NULL, NULL, 233057),
(261793, '3dwbA02', NULL, NULL, 355, NULL, NULL, 233057),
(261794, '6gidA02', NULL, NULL, 374, NULL, NULL, 233057),
(261795, '3vemA00', NULL, NULL, 83, NULL, NULL, 233058),
(261796, '3a54A01', NULL, NULL, 90, NULL, NULL, 233059),
(261797, '1jb0A00', NULL, NULL, 755, NULL, NULL, 233060),
(261798, '1jb0B00', NULL, NULL, 740, NULL, NULL, 233060),
(261799, '4kt0A00', NULL, NULL, 751, NULL, NULL, 233060),
(261800, '4kt0B00', NULL, NULL, 731, NULL, NULL, 233060),
(261801, '5l8rB00', NULL, NULL, 734, NULL, NULL, 233060),
(261802, '5l8rA00', NULL, NULL, 758, NULL, NULL, 233060),
(261803, '4p3fA00', NULL, NULL, 199, NULL, NULL, 233061),
(261804, '4p3gD00', NULL, NULL, 224, NULL, NULL, 233061),
(261805, '1pbuA00', NULL, NULL, 162, NULL, NULL, 233062),
(261806, '1x7fA02', NULL, NULL, 119, NULL, NULL, 233063),
(261807, '1qnhA00', NULL, NULL, 170, NULL, NULL, 233063),
(261808, '4o8hA00', NULL, NULL, 165, NULL, NULL, 233063),
(261809, '2rmcA00', NULL, NULL, 182, NULL, NULL, 233063),
(261810, '2hq6A00', NULL, NULL, 185, NULL, NULL, 233063),
(261811, '2a2nA00', NULL, NULL, 176, NULL, NULL, 233063),
(261812, '4jjmB00', NULL, NULL, 175, NULL, NULL, 233063),
(261813, '3jb9d00', NULL, NULL, 155, NULL, NULL, 233063),
(261814, '3ichA00', NULL, NULL, 188, NULL, NULL, 233063),
(261815, '2mvzA00', NULL, NULL, 148, NULL, NULL, 233063),
(261816, '6hmzX00', NULL, NULL, 180, NULL, NULL, 233063),
(261817, '2igvA00', NULL, NULL, 173, NULL, NULL, 233063),
(261818, '1w74A00', NULL, NULL, 171, NULL, NULL, 233063),
(261819, '2ok3A00', NULL, NULL, 161, NULL, NULL, 233063),
(261820, '2eslA00', NULL, NULL, 190, NULL, NULL, 233063),
(261821, '2cfeA00', NULL, NULL, 162, NULL, NULL, 233063),
(261822, '2c3bA00', NULL, NULL, 172, NULL, NULL, 233063),
(261823, '4fruA00', NULL, NULL, 185, NULL, NULL, 233063),
(261824, '3t1uA00', NULL, NULL, 163, NULL, NULL, 233063),
(261825, '3va7A04', NULL, NULL, 159, NULL, NULL, 233063),
(261826, '2b71A00', NULL, NULL, 174, NULL, NULL, 233063),
(261827, '1lopA00', NULL, NULL, 164, NULL, NULL, 233063),
(261828, '1h0pA00', NULL, NULL, 182, NULL, NULL, 233063),
(261829, '2wfiA00', NULL, NULL, 179, NULL, NULL, 233063),
(261830, '3pmpA00', NULL, NULL, 164, NULL, NULL, 233063),
(261831, '4jcpA00', NULL, NULL, 175, NULL, NULL, 233063),
(261832, '6fk1A00', NULL, NULL, 172, NULL, NULL, 233063),
(261833, '1a58A00', NULL, NULL, 177, NULL, NULL, 233063),
(261834, '2cmtA00', NULL, NULL, 172, NULL, NULL, 233063),
(261835, '1mzwA00', NULL, NULL, 177, NULL, NULL, 233063),
(261836, '3mmlE02', NULL, NULL, 120, NULL, NULL, 233063),
(261837, '4i9yA00', NULL, NULL, 167, NULL, NULL, 233063),
(261838, '5jheA01', NULL, NULL, 202, NULL, NULL, 233063),
(261839, '1v9tA00', NULL, NULL, 166, NULL, NULL, 233063),
(261840, '2p0oA02', NULL, NULL, 131, NULL, NULL, 233063),
(261841, '5ybaA00', NULL, NULL, 175, NULL, NULL, 233063),
(261842, '5dudC02', NULL, NULL, 141, NULL, NULL, 233063),
(261843, '2hqjA00', NULL, NULL, 183, NULL, NULL, 233063),
(261844, '3s6mA00', NULL, NULL, 167, NULL, NULL, 233063),
(261845, '2poeA00', NULL, NULL, 185, NULL, NULL, 233063),
(261846, '2he9A00', NULL, NULL, 174, NULL, NULL, 233063),
(261847, '4eyvA00', NULL, NULL, 167, NULL, NULL, 233063),
(261848, '4hy7A00', NULL, NULL, 171, NULL, NULL, 233063),
(261849, '2zp2B00', NULL, NULL, 141, NULL, NULL, 233063),
(261850, '2x7kA00', NULL, NULL, 166, NULL, NULL, 233063);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(261851, '1vdnA00', NULL, NULL, 162, NULL, NULL, 233063),
(261852, '3oepA04', NULL, NULL, 111, NULL, NULL, 233063),
(261853, '2phcB02', NULL, NULL, 141, NULL, NULL, 233063),
(261854, '3oepA02', NULL, NULL, 133, NULL, NULL, 233063),
(261855, '4r3fA00', NULL, NULL, 204, NULL, NULL, 233063),
(261856, '5f66A00', NULL, NULL, 165, NULL, NULL, 233063),
(261857, '1xo7A00', NULL, NULL, 166, NULL, NULL, 233063),
(261858, '2r99A00', NULL, NULL, 173, NULL, NULL, 233063),
(261859, '2fu0A00', NULL, NULL, 160, NULL, NULL, 233063),
(261860, '2haqA00', NULL, NULL, 172, NULL, NULL, 233063),
(261861, '3bo7A00', NULL, NULL, 176, NULL, NULL, 233063),
(261862, '1ihgA01', NULL, NULL, 185, NULL, NULL, 233063),
(261863, '1zkcB01', NULL, NULL, 160, NULL, NULL, 233063),
(261864, '1z81A00', NULL, NULL, 186, NULL, NULL, 233063),
(261865, '2poyA00', NULL, NULL, 169, NULL, NULL, 233063),
(261866, '2mc9A00', NULL, NULL, 178, NULL, NULL, 233063),
(261867, '2oseA00', NULL, NULL, 214, NULL, NULL, 233063),
(261868, '3k2cB00', NULL, NULL, 193, NULL, NULL, 233063),
(261869, '4r3eA00', NULL, NULL, 180, NULL, NULL, 233063),
(261870, '3mmlB02', NULL, NULL, 132, NULL, NULL, 233063),
(261871, '3bkpA00', NULL, NULL, 206, NULL, NULL, 233063),
(261872, '2js5A00', NULL, NULL, 71, NULL, NULL, 233064),
(261873, '3qg5A02', NULL, NULL, 55, NULL, NULL, 233064),
(261874, '3icxA01', NULL, NULL, 76, NULL, NULL, 233064),
(261875, '1nt2B02', NULL, NULL, 67, NULL, NULL, 233064),
(261876, '2f66F00', NULL, NULL, 82, NULL, NULL, 233064),
(261877, '2cazF00', NULL, NULL, 64, NULL, NULL, 233064),
(261878, '3b2eF00', NULL, NULL, 84, NULL, NULL, 233064),
(261879, '3sjaC00', NULL, NULL, 65, NULL, NULL, 233064),
(261880, '1x4tA01', NULL, NULL, 58, NULL, NULL, 233064),
(261881, '3csxB00', NULL, NULL, 81, NULL, NULL, 233064),
(261882, '3csxA00', NULL, NULL, 64, NULL, NULL, 233064),
(261883, '3qf7A02', NULL, NULL, 69, NULL, NULL, 233064),
(261884, '1skvA00', NULL, NULL, 69, NULL, NULL, 233064),
(261885, '3ce2A03', NULL, NULL, 379, NULL, NULL, 233065),
(261886, '2qr4A03', NULL, NULL, 332, NULL, NULL, 233065),
(261887, '3ck6D01', NULL, NULL, 127, NULL, NULL, 233066),
(261888, '4egwA01', NULL, NULL, 131, NULL, NULL, 233066),
(261889, '3ck6E01', NULL, NULL, 127, NULL, NULL, 233066),
(261890, '3ck6B01', NULL, NULL, 127, NULL, NULL, 233066),
(261891, '3ck6C01', NULL, NULL, 127, NULL, NULL, 233066),
(261892, '3nvoA01', NULL, NULL, 141, NULL, NULL, 233066),
(261893, '2bbhA01', NULL, NULL, 168, NULL, NULL, 233066),
(261894, '3ck6A01', NULL, NULL, 127, NULL, NULL, 233066),
(261895, '4eebA01', NULL, NULL, 134, NULL, NULL, 233066),
(261896, '3bhcA01', NULL, NULL, 124, NULL, NULL, 233066),
(261897, '3bhcB01', NULL, NULL, 124, NULL, NULL, 233066),
(261898, '3bhcC01', NULL, NULL, 124, NULL, NULL, 233066),
(261899, '3bhcD01', NULL, NULL, 124, NULL, NULL, 233066),
(261900, '3bhcE01', NULL, NULL, 124, NULL, NULL, 233066),
(261901, '2hn1A01', NULL, NULL, 142, NULL, NULL, 233066),
(261902, '2ktaA01', NULL, NULL, 57, NULL, NULL, 233067),
(261903, '2w82A03', NULL, NULL, 62, NULL, NULL, 233068),
(261904, '2qklB00', NULL, NULL, 95, NULL, NULL, 233069),
(261905, '2qkmB01', NULL, NULL, 102, NULL, NULL, 233069),
(261906, '2a6tB01', NULL, NULL, 59, NULL, NULL, 233069),
(261907, '2xr7A02', NULL, NULL, 220, NULL, NULL, 233070),
(261908, '5falA02', NULL, NULL, 227, NULL, NULL, 233070),
(261909, '5falA01', NULL, NULL, 217, NULL, NULL, 233070),
(261910, '6dd2A01', NULL, NULL, 209, NULL, NULL, 233070),
(261911, '2xr7A01', NULL, NULL, 233, NULL, NULL, 233070),
(261912, '2debB02', NULL, NULL, 287, NULL, NULL, 233070),
(261913, '1xl8B03', NULL, NULL, 179, NULL, NULL, 233070),
(261914, '2fy4A01', NULL, NULL, 294, NULL, NULL, 233070),
(261915, '4hvmB01', NULL, NULL, 210, NULL, NULL, 233070),
(261916, '4n72B00', NULL, NULL, 249, NULL, NULL, 233070),
(261917, '1nm8A01', NULL, NULL, 284, NULL, NULL, 233070),
(261918, '2bghA02', NULL, NULL, 211, NULL, NULL, 233070),
(261919, '2bghA01', NULL, NULL, 210, NULL, NULL, 233070),
(261920, '2rkvA02', NULL, NULL, 222, NULL, NULL, 233070),
(261921, '2zbaB02', NULL, NULL, 221, NULL, NULL, 233070);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(261922, '2rkvA01', NULL, NULL, 215, NULL, NULL, 233070),
(261923, '4g22A02', NULL, NULL, 211, NULL, NULL, 233070),
(261924, '1xl7A03', NULL, NULL, 179, NULL, NULL, 233070),
(261925, '3claA00', NULL, NULL, 213, NULL, NULL, 233070),
(261926, '3l60A01', NULL, NULL, 220, NULL, NULL, 233070),
(261927, '2jgpA02', NULL, NULL, 192, NULL, NULL, 233070),
(261928, '2vsqA01', NULL, NULL, 219, NULL, NULL, 233070),
(261929, '1q23B00', NULL, NULL, 219, NULL, NULL, 233070),
(261930, '2ii3A01', NULL, NULL, 224, NULL, NULL, 233070),
(261931, '6dd2B02', NULL, NULL, 236, NULL, NULL, 233070),
(261932, '5kjsA01', NULL, NULL, 205, NULL, NULL, 233070),
(261933, '2i9dA00', NULL, NULL, 217, NULL, NULL, 233070),
(261934, '1q9jB01', NULL, NULL, 227, NULL, NULL, 233070),
(261935, '1l5aA01', NULL, NULL, 191, NULL, NULL, 233070),
(261936, '5kjsA02', NULL, NULL, 224, NULL, NULL, 233070),
(261937, '2e1vA01', NULL, NULL, 238, NULL, NULL, 233070),
(261938, '1dpbA00', NULL, NULL, 243, NULL, NULL, 233070),
(261939, '2e1vA02', NULL, NULL, 216, NULL, NULL, 233070),
(261940, '1xl8A03', NULL, NULL, 179, NULL, NULL, 233070),
(261941, '4ke4A01', NULL, NULL, 214, NULL, NULL, 233070),
(261942, '3maeA00', NULL, NULL, 256, NULL, NULL, 233070),
(261943, '2zbaA01', NULL, NULL, 224, NULL, NULL, 233070),
(261944, '5t3eB01', NULL, NULL, 184, NULL, NULL, 233070),
(261945, '5kjvA02', NULL, NULL, 218, NULL, NULL, 233070),
(261946, '1xmcB03', NULL, NULL, 179, NULL, NULL, 233070),
(261947, '5kjvA01', NULL, NULL, 205, NULL, NULL, 233070),
(261948, '4g22B01', NULL, NULL, 210, NULL, NULL, 233070),
(261949, '1xl7B03', NULL, NULL, 179, NULL, NULL, 233070),
(261950, '1ndbA01', NULL, NULL, 280, NULL, NULL, 233070),
(261951, '1sczA00', NULL, NULL, 233, NULL, NULL, 233070),
(261952, '3fotA01', NULL, NULL, 255, NULL, NULL, 233070),
(261953, '5du9A01', NULL, NULL, 215, NULL, NULL, 233070),
(261954, '1t1uA01', NULL, NULL, 276, NULL, NULL, 233070),
(261955, '2xhgA01', NULL, NULL, 183, NULL, NULL, 233070),
(261956, '3nr5A00', NULL, NULL, 164, NULL, NULL, 233071),
(261957, '2ckcA00', NULL, NULL, 60, NULL, NULL, 233072),
(261958, '2ckaA01', NULL, NULL, 49, NULL, NULL, 233072),
(261959, '2v0eA00', NULL, NULL, 55, NULL, NULL, 233072),
(261960, '2hpuA01', NULL, NULL, 63, NULL, NULL, 233073),
(261961, '4abxA02', NULL, NULL, 87, NULL, NULL, 233074),
(261962, '3v76A03', NULL, NULL, 61, NULL, NULL, 233075),
(261963, '2gqfA03', NULL, NULL, 61, NULL, NULL, 233075),
(261964, '3t2lA02', NULL, NULL, 157, NULL, NULL, 233076),
(261965, '3sy6A02', NULL, NULL, 150, NULL, NULL, 233076),
(261966, '3ufiA02', NULL, NULL, 135, NULL, NULL, 233076),
(261967, '4k4kA02', NULL, NULL, 141, NULL, NULL, 233076),
(261968, '3r75B01', NULL, NULL, 399, NULL, NULL, 233077),
(261969, '1qdlA00', NULL, NULL, 422, NULL, NULL, 233077),
(261970, '4grhA00', NULL, NULL, 457, NULL, NULL, 233077),
(261971, '5kckA00', NULL, NULL, 450, NULL, NULL, 233077),
(261972, '2fn0B00', NULL, NULL, 437, NULL, NULL, 233077),
(261973, '1k0eB00', NULL, NULL, 453, NULL, NULL, 233077),
(261974, '1i1qA00', NULL, NULL, 520, NULL, NULL, 233077),
(261975, '3os6C00', NULL, NULL, 399, NULL, NULL, 233077),
(261976, '3h9mA00', NULL, NULL, 436, NULL, NULL, 233077),
(261977, '5jxzA00', NULL, NULL, 391, NULL, NULL, 233077),
(261978, '3st6C00', NULL, NULL, 450, NULL, NULL, 233077),
(261979, '1i7qA00', NULL, NULL, 519, NULL, NULL, 233077),
(261980, '5cwaA00', NULL, NULL, 513, NULL, NULL, 233077),
(261981, '3bzmA00', NULL, NULL, 431, NULL, NULL, 233077),
(261982, '3gseA00', NULL, NULL, 458, NULL, NULL, 233077),
(261983, '4c1bA02', NULL, NULL, 103, NULL, NULL, 233078),
(261984, '1jmuB03', NULL, NULL, 157, NULL, NULL, 233079),
(261985, '3iylB02', NULL, NULL, 134, NULL, NULL, 233079),
(261986, '4n2oD00', NULL, NULL, 201, NULL, NULL, 233080),
(261987, '4n2oC00', NULL, NULL, 201, NULL, NULL, 233080),
(261988, '3l8qC02', NULL, NULL, 179, NULL, NULL, 233080),
(261989, '4n2oF00', NULL, NULL, 201, NULL, NULL, 233080),
(261990, '4n2oE00', NULL, NULL, 201, NULL, NULL, 233080),
(261991, '4n2oB00', NULL, NULL, 201, NULL, NULL, 233080),
(261992, '3kcpA01', NULL, NULL, 153, NULL, NULL, 233080);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(261993, '5m0yA00', NULL, NULL, 186, NULL, NULL, 233080),
(261994, '4n2oA00', NULL, NULL, 201, NULL, NULL, 233080),
(261995, '5lxvA01', NULL, NULL, 171, NULL, NULL, 233080),
(261996, '2vn6A00', NULL, NULL, 151, NULL, NULL, 233080),
(261997, '1tyjA00', NULL, NULL, 170, NULL, NULL, 233080),
(261998, '3bwzA00', NULL, NULL, 181, NULL, NULL, 233080),
(261999, '4iu2A00', NULL, NULL, 212, NULL, NULL, 233080),
(262000, '3ul4A01', NULL, NULL, 145, NULL, NULL, 233080),
(262001, '2zf9B00', NULL, NULL, 194, NULL, NULL, 233080),
(262002, '2xdhA00', NULL, NULL, 163, NULL, NULL, 233080),
(262003, '1aohB00', NULL, NULL, 147, NULL, NULL, 233080),
(262004, '4umsA01', NULL, NULL, 142, NULL, NULL, 233080),
(262005, '4n2oH00', NULL, NULL, 201, NULL, NULL, 233080),
(262006, '4n2oG00', NULL, NULL, 201, NULL, NULL, 233080),
(262007, '4wkzB00', NULL, NULL, 191, NULL, NULL, 233080),
(262008, '4uypA01', NULL, NULL, 140, NULL, NULL, 233080),
(262009, '2cclA01', NULL, NULL, 142, NULL, NULL, 233080),
(262010, '5m2sA00', NULL, NULL, 149, NULL, NULL, 233080),
(262011, '4u3sA00', NULL, NULL, 168, NULL, NULL, 233080),
(262012, '5aozA00', NULL, NULL, 146, NULL, NULL, 233080),
(262013, '5k39A00', NULL, NULL, 171, NULL, NULL, 233080),
(262014, '2oznA00', NULL, NULL, 136, NULL, NULL, 233080),
(262015, '2vo8A00', NULL, NULL, 143, NULL, NULL, 233080),
(262016, '4dh2A00', NULL, NULL, 170, NULL, NULL, 233080),
(262017, '2hoxA01', NULL, NULL, 100, NULL, NULL, 233081),
(262018, '4otwA02', NULL, NULL, 190, NULL, NULL, 233082),
(262019, '2i0yA02', NULL, NULL, 192, NULL, NULL, 233082),
(262020, '4pteB02', NULL, NULL, 219, NULL, NULL, 233082),
(262021, '4nstC02', NULL, NULL, 228, NULL, NULL, 233082),
(262022, '2bujA02', NULL, NULL, 205, NULL, NULL, 233082),
(262023, '4ymjB02', NULL, NULL, 194, NULL, NULL, 233082),
(262024, '3repA02', NULL, NULL, 180, NULL, NULL, 233082),
(262025, '4aw2A02', NULL, NULL, 203, NULL, NULL, 233082),
(262026, '5cemA02', NULL, NULL, 210, NULL, NULL, 233082),
(262027, '1z57A02', NULL, NULL, 245, NULL, NULL, 233082),
(262028, '2hakE02', NULL, NULL, 190, NULL, NULL, 233082),
(262029, '2vwiD02', NULL, NULL, 209, NULL, NULL, 233082),
(262030, '4ualA02', NULL, NULL, 203, NULL, NULL, 233082),
(262031, '5zn1A01', NULL, NULL, 232, NULL, NULL, 233082),
(262032, '6qatA02', NULL, NULL, 185, NULL, NULL, 233082),
(262033, '5ug9A02', NULL, NULL, 193, NULL, NULL, 233082),
(262034, '1p4oA02', NULL, NULL, 214, NULL, NULL, 233082),
(262035, '4cyiE01', NULL, NULL, 295, NULL, NULL, 233082),
(262036, '4im0A02', NULL, NULL, 218, NULL, NULL, 233082),
(262037, '3g2fB02', NULL, NULL, 241, NULL, NULL, 233082),
(262038, '4uy9A02', NULL, NULL, 232, NULL, NULL, 233082),
(262039, '4w9wA00', NULL, NULL, 306, NULL, NULL, 233082),
(262040, '1blxA02', NULL, NULL, 197, NULL, NULL, 233082),
(262041, '1s9iA02', NULL, NULL, 257, NULL, NULL, 233082),
(262042, '2rsvA00', NULL, NULL, 403, NULL, NULL, 233082),
(262043, '3cc6A02', NULL, NULL, 183, NULL, NULL, 233082),
(262044, '2w9zB02', NULL, NULL, 197, NULL, NULL, 233082),
(262045, '4m66B00', NULL, NULL, 325, NULL, NULL, 233082),
(262046, '6hx1A02', NULL, NULL, 191, NULL, NULL, 233082),
(262047, '6bg2B01', NULL, NULL, 199, NULL, NULL, 233082),
(262048, '2rkuA02', NULL, NULL, 173, NULL, NULL, 233082),
(262049, '5lwmA02', NULL, NULL, 198, NULL, NULL, 233082),
(262050, '3dlsB02', NULL, NULL, 182, NULL, NULL, 233082),
(262051, '2acxA03', NULL, NULL, 199, NULL, NULL, 233082),
(262052, '2y94A02', NULL, NULL, 204, NULL, NULL, 233082),
(262053, '5vd8A02', NULL, NULL, 201, NULL, NULL, 233082),
(262054, '3eb0A02', NULL, NULL, 262, NULL, NULL, 233082),
(262055, '6cthA02', NULL, NULL, 216, NULL, NULL, 233082),
(262056, '3bhhC02', NULL, NULL, 211, NULL, NULL, 233082),
(262057, '2cmwA02', NULL, NULL, 231, NULL, NULL, 233082),
(262058, '5ew8A02', NULL, NULL, 196, NULL, NULL, 233082),
(262059, '5hu3A02', NULL, NULL, 191, NULL, NULL, 233082),
(262060, '3utoA03', NULL, NULL, 244, NULL, NULL, 233082),
(262061, '5ng0A00', NULL, NULL, 304, NULL, NULL, 233082),
(262062, '2b9hA02', NULL, NULL, 243, NULL, NULL, 233082),
(262063, '2y4pD00', NULL, NULL, 230, NULL, NULL, 233082);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(262064, '3n9xA02', NULL, NULL, 230, NULL, NULL, 233082),
(262065, '5x5oA02', NULL, NULL, 223, NULL, NULL, 233082),
(262066, '5jzjA02', NULL, NULL, 182, NULL, NULL, 233082),
(262067, '2dq7X02', NULL, NULL, 177, NULL, NULL, 233082),
(262068, '4wihA01', NULL, NULL, 209, NULL, NULL, 233082),
(262069, '3kk8A02', NULL, NULL, 198, NULL, NULL, 233082),
(262070, '4o38B02', NULL, NULL, 220, NULL, NULL, 233082),
(262071, '4b6lA02', NULL, NULL, 173, NULL, NULL, 233082),
(262072, '2i6lA02', NULL, NULL, 215, NULL, NULL, 233082),
(262073, '5zj6A02', NULL, NULL, 186, NULL, NULL, 233082),
(262074, '3slsB02', NULL, NULL, 198, NULL, NULL, 233082),
(262075, '6cnhA02', NULL, NULL, 262, NULL, NULL, 233082),
(262076, '5l2qB02', NULL, NULL, 196, NULL, NULL, 233082),
(262077, '2qocA02', NULL, NULL, 204, NULL, NULL, 233082),
(262078, '4e7wA02', NULL, NULL, 247, NULL, NULL, 233082),
(262079, '5gz8A00', NULL, NULL, 305, NULL, NULL, 233082),
(262080, '3cblA03', NULL, NULL, 180, NULL, NULL, 233082),
(262081, '2c47C02', NULL, NULL, 215, NULL, NULL, 233082),
(262082, '4lrjA02', NULL, NULL, 90, NULL, NULL, 233082),
(262083, '1rjbA02', NULL, NULL, 212, NULL, NULL, 233082),
(262084, '4anoA00', NULL, NULL, 219, NULL, NULL, 233082),
(262085, '4usfB02', NULL, NULL, 210, NULL, NULL, 233082),
(262086, '3fmeA02', NULL, NULL, 202, NULL, NULL, 233082),
(262087, '2izrA02', NULL, NULL, 215, NULL, NULL, 233082),
(262088, '5drbA02', NULL, NULL, 181, NULL, NULL, 233082),
(262089, '4neuB00', NULL, NULL, 333, NULL, NULL, 233082),
(262090, '2v62A02', NULL, NULL, 211, NULL, NULL, 233082),
(262091, '2vz6A02', NULL, NULL, 211, NULL, NULL, 233082),
(262092, '6gqmA02', NULL, NULL, 192, NULL, NULL, 233082),
(262093, '4el9A02', NULL, NULL, 195, NULL, NULL, 233082),
(262094, '1fotA01', NULL, NULL, 191, NULL, NULL, 233082),
(262095, '3lcdA02', NULL, NULL, 186, NULL, NULL, 233082),
(262096, '2a19B02', NULL, NULL, 183, NULL, NULL, 233082),
(262097, '5lqfD02', NULL, NULL, 213, NULL, NULL, 233082),
(262098, '5l6oA02', NULL, NULL, 189, NULL, NULL, 233082),
(262099, '3lltA02', NULL, NULL, 248, NULL, NULL, 233082),
(262100, '2pmlX02', NULL, NULL, 224, NULL, NULL, 233082),
(262101, '6egeD02', NULL, NULL, 196, NULL, NULL, 233082),
(262102, '2y6oA02', NULL, NULL, 195, NULL, NULL, 233082),
(262103, '3lm5A02', NULL, NULL, 174, NULL, NULL, 233082),
(262104, '4e1zA02', NULL, NULL, 197, NULL, NULL, 233082),
(262105, '3vvhB02', NULL, NULL, 204, NULL, NULL, 233082),
(262106, '6o6qA01', NULL, NULL, 234, NULL, NULL, 233082),
(262107, '5cvgA01', NULL, NULL, 232, NULL, NULL, 233082),
(262108, '2yabA02', NULL, NULL, 204, NULL, NULL, 233082),
(262109, '5cenA02', NULL, NULL, 217, NULL, NULL, 233082),
(262110, '1s9iB02', NULL, NULL, 204, NULL, NULL, 233082),
(262111, '1jpaA02', NULL, NULL, 189, NULL, NULL, 233082),
(262112, '4btfA02', NULL, NULL, 210, NULL, NULL, 233082),
(262113, '3hmiA02', NULL, NULL, 183, NULL, NULL, 233082),
(262114, '4lrkA02', NULL, NULL, 90, NULL, NULL, 233082),
(262115, '1howA02', NULL, NULL, 276, NULL, NULL, 233082),
(262116, '4j7bA02', NULL, NULL, 173, NULL, NULL, 233082),
(262117, '6di1A02', NULL, NULL, 183, NULL, NULL, 233082),
(262118, '3pp0A02', NULL, NULL, 193, NULL, NULL, 233082),
(262119, '4crsA02', NULL, NULL, 193, NULL, NULL, 233082),
(262120, '3qupA02', NULL, NULL, 186, NULL, NULL, 233082),
(262121, '4hvsA02', NULL, NULL, 204, NULL, NULL, 233082),
(262122, '3oy1A02', NULL, NULL, 234, NULL, NULL, 233082),
(262123, '4otdA02', NULL, NULL, 193, NULL, NULL, 233082),
(262124, '3iecA02', NULL, NULL, 190, NULL, NULL, 233082),
(262125, '3wf7A02', NULL, NULL, 196, NULL, NULL, 233082),
(262126, '6bfnB02', NULL, NULL, 240, NULL, NULL, 233082),
(262127, '3c4zA03', NULL, NULL, 202, NULL, NULL, 233082),
(262128, '4d28A02', NULL, NULL, 182, NULL, NULL, 233082),
(262129, '2i1mA02', NULL, NULL, 190, NULL, NULL, 233082),
(262130, '5o1vA02', NULL, NULL, 186, NULL, NULL, 233082),
(262131, '5wnlA00', NULL, NULL, 288, NULL, NULL, 233082),
(262132, '4c2vA02', NULL, NULL, 174, NULL, NULL, 233082),
(262133, '2w4oA02', NULL, NULL, 180, NULL, NULL, 233082),
(262134, '2j0iA02', NULL, NULL, 194, NULL, NULL, 233082);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(262135, '2reiA02', NULL, NULL, 193, NULL, NULL, 233082),
(262136, '3en9A04', NULL, NULL, 119, NULL, NULL, 233082),
(262137, '3bhyA02', NULL, NULL, 191, NULL, NULL, 233082),
(262138, '3e7oB02', NULL, NULL, 220, NULL, NULL, 233082),
(262139, '4yhjA03', NULL, NULL, 199, NULL, NULL, 233082),
(262140, '4bgqA02', NULL, NULL, 210, NULL, NULL, 233082),
(262141, '3vvhC02', NULL, NULL, 197, NULL, NULL, 233082),
(262142, '4czuA02', NULL, NULL, 184, NULL, NULL, 233082),
(262143, '3c0iA02', NULL, NULL, 210, NULL, NULL, 233082),
(262144, '1csnA02', NULL, NULL, 211, NULL, NULL, 233082),
(262145, '2y7jA02', NULL, NULL, 184, NULL, NULL, 233082),
(262146, '4mvfA02', NULL, NULL, 180, NULL, NULL, 233082),
(262147, '2a2aA02', NULL, NULL, 207, NULL, NULL, 233082),
(262148, '4csvA02', NULL, NULL, 187, NULL, NULL, 233082),
(262149, '4bwxA01', NULL, NULL, 286, NULL, NULL, 233082),
(262150, '2eu9A02', NULL, NULL, 256, NULL, NULL, 233082),
(262151, '4lg4E02', NULL, NULL, 212, NULL, NULL, 233082),
(262152, '6gqqA02', NULL, NULL, 198, NULL, NULL, 233082),
(262153, '5byzA02', NULL, NULL, 233, NULL, NULL, 233082),
(262154, '2wntA02', NULL, NULL, 247, NULL, NULL, 233082),
(262155, '3hztA02', NULL, NULL, 193, NULL, NULL, 233082),
(262156, '4mwiA02', NULL, NULL, 184, NULL, NULL, 233082),
(262157, '5efqA02', NULL, NULL, 244, NULL, NULL, 233082),
(262158, '2welA02', NULL, NULL, 183, NULL, NULL, 233082),
(262159, '3uc3A02', NULL, NULL, 188, NULL, NULL, 233082),
(262160, '6ferB02', NULL, NULL, 205, NULL, NULL, 233082),
(262161, '2w1zA01', NULL, NULL, 225, NULL, NULL, 233082),
(262162, '3kmuA02', NULL, NULL, 180, NULL, NULL, 233082),
(262163, '4rgjA02', NULL, NULL, 184, NULL, NULL, 233082),
(262164, '3ohtA02', NULL, NULL, 209, NULL, NULL, 233082),
(262165, '2xikA02', NULL, NULL, 196, NULL, NULL, 233082),
(262166, '2wqmA02', NULL, NULL, 219, NULL, NULL, 233082),
(262167, '3qa8G01', NULL, NULL, 293, NULL, NULL, 233082),
(262168, '6gzdA02', NULL, NULL, 207, NULL, NULL, 233082),
(262169, '4xr7E01', NULL, NULL, 322, NULL, NULL, 233082),
(262170, '3a7iA02', NULL, NULL, 202, NULL, NULL, 233082),
(262171, '3kn6A02', NULL, NULL, 259, NULL, NULL, 233082),
(262172, '4dfxE01', NULL, NULL, 219, NULL, NULL, 233082),
(262173, '4itjB02', NULL, NULL, 200, NULL, NULL, 233082),
(262174, '4c0tA02', NULL, NULL, 196, NULL, NULL, 233082),
(262175, '4ivaA02', NULL, NULL, 197, NULL, NULL, 233082),
(262176, '4g31A02', NULL, NULL, 203, NULL, NULL, 233082),
(262177, '4l00A02', NULL, NULL, 191, NULL, NULL, 233082),
(262178, '3uc4B02', NULL, NULL, 189, NULL, NULL, 233082),
(262179, '4c58A02', NULL, NULL, 206, NULL, NULL, 233082),
(262180, '4nfnA02', NULL, NULL, 210, NULL, NULL, 233082),
(262181, '2ycfA02', NULL, NULL, 207, NULL, NULL, 233082),
(262182, '5ci6A02', NULL, NULL, 229, NULL, NULL, 233082),
(262183, '4lqsA02', NULL, NULL, 212, NULL, NULL, 233082),
(262184, '4aguB02', NULL, NULL, 208, NULL, NULL, 233082),
(262185, '3hngA02', NULL, NULL, 182, NULL, NULL, 233082),
(262186, '1ua2A02', NULL, NULL, 216, NULL, NULL, 233082),
(262187, '4z55A02', NULL, NULL, 191, NULL, NULL, 233082),
(262188, '6gukA02', NULL, NULL, 211, NULL, NULL, 233082),
(262189, '6cz4A02', NULL, NULL, 175, NULL, NULL, 233082),
(262190, '2i0eB02', NULL, NULL, 197, NULL, NULL, 233082),
(262191, '5g6vB02', NULL, NULL, 241, NULL, NULL, 233082),
(262192, '3orkA02', NULL, NULL, 190, NULL, NULL, 233082),
(262193, '3fe3A02', NULL, NULL, 190, NULL, NULL, 233082),
(262194, '4r1vA02', NULL, NULL, 186, NULL, NULL, 233082),
(262195, '4y95A02', NULL, NULL, 183, NULL, NULL, 233082),
(262196, '4b9dA02', NULL, NULL, 202, NULL, NULL, 233082),
(262197, '3f3zA02', NULL, NULL, 190, NULL, NULL, 233082),
(262198, '3plsA02', NULL, NULL, 194, NULL, NULL, 233082),
(262199, '4nt4A02', NULL, NULL, 216, NULL, NULL, 233082),
(262200, '5kkrB02', NULL, NULL, 189, NULL, NULL, 233082),
(262201, '3lffA02', NULL, NULL, 209, NULL, NULL, 233082),
(262202, '2jamB02', NULL, NULL, 217, NULL, NULL, 233082),
(262203, '1kobA02', NULL, NULL, 256, NULL, NULL, 233082),
(262204, '3hkoA02', NULL, NULL, 236, NULL, NULL, 233082),
(262205, '3ggfA02', NULL, NULL, 199, NULL, NULL, 233082);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(262206, '4pl3A02', NULL, NULL, 191, NULL, NULL, 233082),
(262207, '3gp0A02', NULL, NULL, 209, NULL, NULL, 233082),
(262208, '3dzoA01', NULL, NULL, 241, NULL, NULL, 233082),
(262209, '3m2wA02', NULL, NULL, 203, NULL, NULL, 233082),
(262210, '5a4eC00', NULL, NULL, 289, NULL, NULL, 233082),
(262211, '3p86A02', NULL, NULL, 192, NULL, NULL, 233082),
(262212, '2zv7A02', NULL, NULL, 191, NULL, NULL, 233082),
(262213, '2rioA02', NULL, NULL, 212, NULL, NULL, 233082),
(262214, '3is5F02', NULL, NULL, 182, NULL, NULL, 233082),
(262215, '3lxpA02', NULL, NULL, 202, NULL, NULL, 233082),
(262216, '4d4rB02', NULL, NULL, 185, NULL, NULL, 233082),
(262217, '3g0eA02', NULL, NULL, 205, NULL, NULL, 233082),
(262218, '3kfaA02', NULL, NULL, 180, NULL, NULL, 233082),
(262219, '4gt4A02', NULL, NULL, 194, NULL, NULL, 233082),
(262220, '4krdA02', NULL, NULL, 215, NULL, NULL, 233082),
(262221, '6n7aB02', NULL, NULL, 196, NULL, NULL, 233082),
(262222, '4qtaA02', NULL, NULL, 229, NULL, NULL, 233082),
(262223, '4wovA02', NULL, NULL, 180, NULL, NULL, 233082),
(262224, '3ka0A02', NULL, NULL, 226, NULL, NULL, 233082),
(262225, '3mn3A02', NULL, NULL, 186, NULL, NULL, 233082),
(262226, '2h6dA02', NULL, NULL, 184, NULL, NULL, 233082),
(262227, '5f9eA02', NULL, NULL, 202, NULL, NULL, 233082),
(262228, '4u3yA02', NULL, NULL, 204, NULL, NULL, 233082),
(262229, '5u6bB02', NULL, NULL, 196, NULL, NULL, 233082),
(262230, '6hmqA01', NULL, NULL, 236, NULL, NULL, 233082),
(262231, '4lqqD02', NULL, NULL, 175, NULL, NULL, 233082),
(262232, '3bu3A02', NULL, NULL, 203, NULL, NULL, 233082),
(262233, '3sv0A02', NULL, NULL, 210, NULL, NULL, 233082),
(262234, '4kikA01', NULL, NULL, 314, NULL, NULL, 233082),
(262235, '2h34A02', NULL, NULL, 193, NULL, NULL, 233082),
(262236, '2jc6A02', NULL, NULL, 179, NULL, NULL, 233082),
(262237, '4qtbA02', NULL, NULL, 231, NULL, NULL, 233082),
(262238, '4bfmA00', NULL, NULL, 334, NULL, NULL, 233082),
(262239, '3pg1A02', NULL, NULL, 227, NULL, NULL, 233082),
(262240, '6cn9B02', NULL, NULL, 181, NULL, NULL, 233082),
(262241, '4q5eA02', NULL, NULL, 96, NULL, NULL, 233082),
(262242, '5ap1A02', NULL, NULL, 202, NULL, NULL, 233082),
(262243, '4y85A02', NULL, NULL, 184, NULL, NULL, 233082),
(262244, '4oavB02', NULL, NULL, 265, NULL, NULL, 233082),
(262245, '2r2pA02', NULL, NULL, 191, NULL, NULL, 233082),
(262246, '3oz6B02', NULL, NULL, 266, NULL, NULL, 233082),
(262247, '6eimA02', NULL, NULL, 205, NULL, NULL, 233082),
(262248, '4af3A02', NULL, NULL, 174, NULL, NULL, 233082),
(262249, '4idtB02', NULL, NULL, 209, NULL, NULL, 233082),
(262250, '4g3fA02', NULL, NULL, 205, NULL, NULL, 233082),
(262251, '1phkA02', NULL, NULL, 193, NULL, NULL, 233082),
(262252, '5o1sA02', NULL, NULL, 236, NULL, NULL, 233082),
(262253, '3q4uB02', NULL, NULL, 212, NULL, NULL, 233082),
(262254, '5x18A02', NULL, NULL, 211, NULL, NULL, 233082),
(262255, '1u59A02', NULL, NULL, 197, NULL, NULL, 233082),
(262256, '3bceB02', NULL, NULL, 195, NULL, NULL, 233082),
(262257, '4xr7I01', NULL, NULL, 323, NULL, NULL, 233082),
(262258, '2pziA01', NULL, NULL, 186, NULL, NULL, 233082),
(262259, '1ob3A02', NULL, NULL, 205, NULL, NULL, 233082),
(262260, '3zduA02', NULL, NULL, 212, NULL, NULL, 233082),
(262261, '3dtcA02', NULL, NULL, 182, NULL, NULL, 233082),
(262262, '4gl9A02', NULL, NULL, 197, NULL, NULL, 233082),
(262263, '2yleA00', NULL, NULL, 203, NULL, NULL, 233082),
(262264, '1xjdA02', NULL, NULL, 204, NULL, NULL, 233082),
(262265, '3hx4A03', NULL, NULL, 181, NULL, NULL, 233082),
(262266, '3aloA02', NULL, NULL, 208, NULL, NULL, 233082),
(262267, '1zylA02', NULL, NULL, 134, NULL, NULL, 233082),
(262268, '5ig1A02', NULL, NULL, 206, NULL, NULL, 233082),
(262269, '2qkwB02', NULL, NULL, 199, NULL, NULL, 233082),
(262270, '3sxsA02', NULL, NULL, 184, NULL, NULL, 233082),
(262271, '4qnyA02', NULL, NULL, 223, NULL, NULL, 233082),
(262272, '4qqtA02', NULL, NULL, 196, NULL, NULL, 233082),
(262273, '5l4qB00', NULL, NULL, 307, NULL, NULL, 233082),
(262274, '2v7oA02', NULL, NULL, 223, NULL, NULL, 233082),
(262275, '5v5nA02', NULL, NULL, 225, NULL, NULL, 233082),
(262276, '3lijA03', NULL, NULL, 181, NULL, NULL, 233082);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(262277, '4l68A02', NULL, NULL, 224, NULL, NULL, 233082),
(262278, '3f66A02', NULL, NULL, 190, NULL, NULL, 233082),
(262279, '5nxdA02', NULL, NULL, 193, NULL, NULL, 233082),
(262280, '3i7bA02', NULL, NULL, 192, NULL, NULL, 233082),
(262281, '4fr4A02', NULL, NULL, 216, NULL, NULL, 233082),
(262282, '4xv9A02', NULL, NULL, 190, NULL, NULL, 233082),
(262283, '5my8A02', NULL, NULL, 282, NULL, NULL, 233082),
(262284, '4yznA02', NULL, NULL, 183, NULL, NULL, 233082),
(262285, '3qd2B02', NULL, NULL, 190, NULL, NULL, 233082),
(262286, '5lvoA02', NULL, NULL, 192, NULL, NULL, 233082),
(262287, '4euuA02', NULL, NULL, 229, NULL, NULL, 233082),
(262288, '4aaaA02', NULL, NULL, 212, NULL, NULL, 233082),
(262289, '5vamA02', NULL, NULL, 190, NULL, NULL, 233082),
(262290, '4fg8B02', NULL, NULL, 202, NULL, NULL, 233082),
(262291, '4uyaA02', NULL, NULL, 232, NULL, NULL, 233082),
(262292, '3v8sA02', NULL, NULL, 199, NULL, NULL, 233082),
(262293, '1bygA02', NULL, NULL, 177, NULL, NULL, 233082),
(262294, '5j5tA00', NULL, NULL, 304, NULL, NULL, 233082),
(262295, '4qd6B00', NULL, NULL, 266, NULL, NULL, 233082),
(262296, '6gzmA02', NULL, NULL, 210, NULL, NULL, 233082),
(262297, '1zarA03', NULL, NULL, 98, NULL, NULL, 233082),
(262298, '4azsA03', NULL, NULL, 162, NULL, NULL, 233082),
(262299, '1lufA02', NULL, NULL, 202, NULL, NULL, 233082),
(262300, '2weiA02', NULL, NULL, 182, NULL, NULL, 233082),
(262301, '2jiiA02', NULL, NULL, 200, NULL, NULL, 233082),
(262302, '4i5pA02', NULL, NULL, 173, NULL, NULL, 233082),
(262303, '1cm8A02', NULL, NULL, 215, NULL, NULL, 233082),
(262304, '4hzrA02', NULL, NULL, 182, NULL, NULL, 233082),
(262305, '4qtcA02', NULL, NULL, 191, NULL, NULL, 233082),
(262306, '4ks7A02', NULL, NULL, 191, NULL, NULL, 233082),
(262307, '5xvuA01', NULL, NULL, 241, NULL, NULL, 233082),
(262308, '4lv5A01', NULL, NULL, 228, NULL, NULL, 233082),
(262309, '2ac3A02', NULL, NULL, 208, NULL, NULL, 233082),
(262310, '6mweB02', NULL, NULL, 208, NULL, NULL, 233082),
(262311, '2wtkC02', NULL, NULL, 201, NULL, NULL, 233082),
(262312, '3my0V02', NULL, NULL, 216, NULL, NULL, 233082),
(262313, '4qtdA02', NULL, NULL, 220, NULL, NULL, 233082),
(262314, '4hzsA02', NULL, NULL, 246, NULL, NULL, 233082),
(262315, '2x7gA02', NULL, NULL, 280, NULL, NULL, 233082),
(262316, '4pf4A02', NULL, NULL, 179, NULL, NULL, 233082),
(262317, '4jr7A01', NULL, NULL, 249, NULL, NULL, 233082),
(262318, '3blhA02', NULL, NULL, 223, NULL, NULL, 233082),
(262319, '2xrwA02', NULL, NULL, 220, NULL, NULL, 233082),
(262320, '4x7qB02', NULL, NULL, 167, NULL, NULL, 233082),
(262321, '4bwpB01', NULL, NULL, 276, NULL, NULL, 233082),
(262322, '5l8lA02', NULL, NULL, 170, NULL, NULL, 233082),
(262323, '2r5tA02', NULL, NULL, 190, NULL, NULL, 233082),
(262324, '3nieB02', NULL, NULL, 234, NULL, NULL, 233082),
(262325, '3q4tB02', NULL, NULL, 217, NULL, NULL, 233082),
(262326, '3nizA02', NULL, NULL, 209, NULL, NULL, 233082),
(262327, '6fnkA02', NULL, NULL, 189, NULL, NULL, 233082),
(262328, '4otpA02', NULL, NULL, 143, NULL, NULL, 233082),
(262329, '3p1aA02', NULL, NULL, 175, NULL, NULL, 233082),
(262330, '3qa8A02', NULL, NULL, 210, NULL, NULL, 233082),
(262331, '3rp9A02', NULL, NULL, 271, NULL, NULL, 233082),
(262332, '5y80A00', NULL, NULL, 313, NULL, NULL, 233082),
(262333, '5mjaB02', NULL, NULL, 189, NULL, NULL, 233082),
(262334, '5nkfA02', NULL, NULL, 205, NULL, NULL, 233082),
(262335, '1o6lA01', NULL, NULL, 194, NULL, NULL, 233082),
(262336, '4oa2A02', NULL, NULL, 202, NULL, NULL, 233082),
(262337, '3cokA02', NULL, NULL, 182, NULL, NULL, 233082),
(262338, '4k33A02', NULL, NULL, 196, NULL, NULL, 233082),
(262339, '1u5qA02', NULL, NULL, 213, NULL, NULL, 233082),
(262340, '3nr9A02', NULL, NULL, 255, NULL, NULL, 233082),
(262341, '3f7wA02', NULL, NULL, 96, NULL, NULL, 233082),
(262342, '5qinA02', NULL, NULL, 220, NULL, NULL, 233082),
(262343, '4ylkA02', NULL, NULL, 252, NULL, NULL, 233082),
(262344, '3q5iA03', NULL, NULL, 181, NULL, NULL, 233082),
(262345, '4au8B02', NULL, NULL, 201, NULL, NULL, 233082),
(262346, '3kvwA03', NULL, NULL, 232, NULL, NULL, 233082),
(262347, '3kulB02', NULL, NULL, 194, NULL, NULL, 233082);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(262348, '4f9cA02', NULL, NULL, 198, NULL, NULL, 233082),
(262349, '4lgdC01', NULL, NULL, 283, NULL, NULL, 233082),
(262350, '2o8yB02', NULL, NULL, 195, NULL, NULL, 233082),
(262351, '3brbA02', NULL, NULL, 186, NULL, NULL, 233082),
(262352, '6fdyU02', NULL, NULL, 184, NULL, NULL, 233082),
(262353, '4ow8A02', NULL, NULL, 185, NULL, NULL, 233082),
(262354, '4y8dA02', NULL, NULL, 174, NULL, NULL, 233082),
(262355, '3txoA02', NULL, NULL, 195, NULL, NULL, 233082),
(262356, '4qoxA02', NULL, NULL, 187, NULL, NULL, 233082),
(262357, '3i1aA02', NULL, NULL, 109, NULL, NULL, 233082),
(262358, '6bruA02', NULL, NULL, 207, NULL, NULL, 233082),
(262359, '4tndA03', NULL, NULL, 206, NULL, NULL, 233082),
(262360, '4ckjA02', NULL, NULL, 204, NULL, NULL, 233082),
(262361, '1vzoA02', NULL, NULL, 214, NULL, NULL, 233082),
(262362, '4annA00', NULL, NULL, 176, NULL, NULL, 233082),
(262363, '4m68A02', NULL, NULL, 188, NULL, NULL, 233082),
(262364, '4gyiA03', NULL, NULL, 148, NULL, NULL, 233082),
(262365, '5uklA04', NULL, NULL, 204, NULL, NULL, 233082),
(262366, '2z7qA02', NULL, NULL, 206, NULL, NULL, 233082),
(262367, '5li9A02', NULL, NULL, 207, NULL, NULL, 233082),
(262368, '2qluA02', NULL, NULL, 218, NULL, NULL, 233082),
(262369, '5b2lA02', NULL, NULL, 204, NULL, NULL, 233082),
(262370, '4j99B02', NULL, NULL, 196, NULL, NULL, 233082),
(262371, '4jrnA01', NULL, NULL, 224, NULL, NULL, 233082),
(262372, '4b4lA02', NULL, NULL, 206, NULL, NULL, 233082),
(262373, '2f2uA02', NULL, NULL, 199, NULL, NULL, 233082),
(262374, '4at5A02', NULL, NULL, 191, NULL, NULL, 233082),
(262375, '5lohA02', NULL, NULL, 193, NULL, NULL, 233082),
(262376, '5i4nA02', NULL, NULL, 196, NULL, NULL, 233082),
(262377, '5grnA02', NULL, NULL, 202, NULL, NULL, 233082),
(262378, '4rlkA01', NULL, NULL, 241, NULL, NULL, 233082),
(262379, '5e8sA02', NULL, NULL, 219, NULL, NULL, 233082),
(262380, '2hw6A02', NULL, NULL, 215, NULL, NULL, 233082),
(262381, '6gr8A02', NULL, NULL, 174, NULL, NULL, 233082),
(262382, '1kwpB02', NULL, NULL, 225, NULL, NULL, 233082),
(262383, '3zbfA02', NULL, NULL, 193, NULL, NULL, 233082),
(262384, '4yjrA02', NULL, NULL, 185, NULL, NULL, 233082),
(262385, '3mdyA02', NULL, NULL, 219, NULL, NULL, 233082),
(262386, '5vdkA02', NULL, NULL, 205, NULL, NULL, 233082),
(262387, '3byvA01', NULL, NULL, 220, NULL, NULL, 233082),
(262388, '2yexA02', NULL, NULL, 179, NULL, NULL, 233082),
(262389, '2w5aA02', NULL, NULL, 213, NULL, NULL, 233082),
(262390, '4ix3A02', NULL, NULL, 237, NULL, NULL, 233082),
(262391, '3uqcD02', NULL, NULL, 153, NULL, NULL, 233082),
(262392, '1tkiA02', NULL, NULL, 237, NULL, NULL, 233082),
(262393, '1zy4A02', NULL, NULL, 203, NULL, NULL, 233082),
(262394, '3alnC02', NULL, NULL, 185, NULL, NULL, 233082),
(262395, '2x4fA02', NULL, NULL, 203, NULL, NULL, 233082),
(262396, '4ynoA02', NULL, NULL, 208, NULL, NULL, 233082),
(262397, '3uimA02', NULL, NULL, 218, NULL, NULL, 233082),
(262398, '4o2zA02', NULL, NULL, 211, NULL, NULL, 233082),
(262399, '3comB02', NULL, NULL, 209, NULL, NULL, 233082),
(262400, '4ra4A02', NULL, NULL, 194, NULL, NULL, 233082),
(262401, '1k9aF04', NULL, NULL, 178, NULL, NULL, 233082),
(262402, '3s95A02', NULL, NULL, 222, NULL, NULL, 233082),
(262403, '5dbxA02', NULL, NULL, 213, NULL, NULL, 233082),
(262404, '4i92A02', NULL, NULL, 193, NULL, NULL, 233082),
(262405, '1nxkD02', NULL, NULL, 189, NULL, NULL, 233082),
(262406, '6e2nA02', NULL, NULL, 194, NULL, NULL, 233082),
(262407, '3gbzA02', NULL, NULL, 213, NULL, NULL, 233082),
(262408, '4wnoA02', NULL, NULL, 189, NULL, NULL, 233082),
(262409, '4ysjB03', NULL, NULL, 183, NULL, NULL, 233082),
(262410, '5ax9A02', NULL, NULL, 207, NULL, NULL, 233082),
(262411, '3fxzA02', NULL, NULL, 199, NULL, NULL, 233082),
(262412, '3a99A02', NULL, NULL, 189, NULL, NULL, 233082),
(262413, '4o1pD02', NULL, NULL, 253, NULL, NULL, 233082),
(262414, '5gzaA00', NULL, NULL, 290, NULL, NULL, 233082),
(262415, '3h4jB02', NULL, NULL, 185, NULL, NULL, 233082),
(262416, '5jfwA02', NULL, NULL, 205, NULL, NULL, 233082),
(262417, '2zv2A02', NULL, NULL, 179, NULL, NULL, 233082),
(262418, '3eqcA02', NULL, NULL, 246, NULL, NULL, 233082);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(262419, '3rgfA02', NULL, NULL, 254, NULL, NULL, 233082),
(262420, '3vwaA02', NULL, NULL, 143, NULL, NULL, 233082),
(262421, '4gv1A02', NULL, NULL, 195, NULL, NULL, 233082),
(262422, '3gniB02', NULL, NULL, 223, NULL, NULL, 233082),
(262423, '3e3pA02', NULL, NULL, 251, NULL, NULL, 233082),
(262424, '5awmA02', NULL, NULL, 221, NULL, NULL, 233082),
(262425, '5wvdB02', NULL, NULL, 166, NULL, NULL, 233082),
(262426, '3fhrA02', NULL, NULL, 229, NULL, NULL, 233082),
(262427, '4eqmA02', NULL, NULL, 189, NULL, NULL, 233082),
(262428, '3omvA02', NULL, NULL, 193, NULL, NULL, 233082),
(262429, '2vd5A02', NULL, NULL, 203, NULL, NULL, 233082),
(262430, '2f57B02', NULL, NULL, 194, NULL, NULL, 233082),
(262431, '6fexA02', NULL, NULL, 210, NULL, NULL, 233082),
(262432, '4pdpB02', NULL, NULL, 221, NULL, NULL, 233082),
(262433, '1qpcA02', NULL, NULL, 181, NULL, NULL, 233082),
(262434, '3dj6A02', NULL, NULL, 171, NULL, NULL, 233082),
(262435, '4hcuA02', NULL, NULL, 183, NULL, NULL, 233082),
(262436, '2srcA04', NULL, NULL, 175, NULL, NULL, 233082),
(262437, '6f7bA02', NULL, NULL, 302, NULL, NULL, 233082),
(262438, '5wnoA02', NULL, NULL, 200, NULL, NULL, 233082),
(262439, '4bkyA00', NULL, NULL, 347, NULL, NULL, 233082),
(262440, '2xi5A00', NULL, NULL, 184, NULL, NULL, 233083),
(262441, '4aaiA01', NULL, NULL, 57, NULL, NULL, 233084),
(262442, '4ejqB01', NULL, NULL, 37, NULL, NULL, 233085),
(262443, '1vdiA00', NULL, NULL, 52, NULL, NULL, 233086),
(262444, '1ew4A00', NULL, NULL, 106, NULL, NULL, 233087),
(262445, '3oeqA01', NULL, NULL, 104, NULL, NULL, 233087),
(262446, '4hs5A00', NULL, NULL, 105, NULL, NULL, 233087),
(262447, '3t3lA00', NULL, NULL, 129, NULL, NULL, 233087),
(262448, '4jpdA00', NULL, NULL, 112, NULL, NULL, 233087),
(262449, '6fcoD00', NULL, NULL, 126, NULL, NULL, 233087),
(262450, '3q5wA00', NULL, NULL, 207, NULL, NULL, 233088),
(262451, '2in3A02', NULL, NULL, 123, NULL, NULL, 233089),
(262452, '3ig5A02', NULL, NULL, 358, NULL, NULL, 233090),
(262453, '2xtcB00', NULL, NULL, 66, NULL, NULL, 233091),
(262454, '2xtcA00', NULL, NULL, 90, NULL, NULL, 233091),
(262455, '1uujB00', NULL, NULL, 88, NULL, NULL, 233091),
(262456, '2w70A03', NULL, NULL, 73, NULL, NULL, 233092),
(262457, '1bxrA07', NULL, NULL, 70, NULL, NULL, 233092),
(262458, '3k3pB03', NULL, NULL, 70, NULL, NULL, 233092),
(262459, '1a9xA03', NULL, NULL, 70, NULL, NULL, 233092),
(262460, '3ufxB02', NULL, NULL, 76, NULL, NULL, 233092),
(262461, '4egjB03', NULL, NULL, 70, NULL, NULL, 233092),
(262462, '4fu0A03', NULL, NULL, 63, NULL, NULL, 233092),
(262463, '3mjfA02', NULL, NULL, 70, NULL, NULL, 233092),
(262464, '5lxtF03', NULL, NULL, 92, NULL, NULL, 233092),
(262465, '2dwcB02', NULL, NULL, 72, NULL, NULL, 233092),
(262466, '3ouzB03', NULL, NULL, 72, NULL, NULL, 233092),
(262467, '2qk4B02', NULL, NULL, 71, NULL, NULL, 233092),
(262468, '2fb9A03', NULL, NULL, 57, NULL, NULL, 233092),
(262469, '4wd3A02', NULL, NULL, 75, NULL, NULL, 233092),
(262470, '3gidB02', NULL, NULL, 106, NULL, NULL, 233092),
(262471, '3tiiA03', NULL, NULL, 92, NULL, NULL, 233092),
(262472, '4qslF02', NULL, NULL, 71, NULL, NULL, 233092),
(262473, '3q2oA02', NULL, NULL, 69, NULL, NULL, 233092),
(262474, '5tdeA02', NULL, NULL, 82, NULL, NULL, 233092),
(262475, '3lp8A02', NULL, NULL, 70, NULL, NULL, 233092),
(262476, '1ulzA02', NULL, NULL, 72, NULL, NULL, 233092),
(262477, '4egqA03', NULL, NULL, 70, NULL, NULL, 233092),
(262478, '1gsaA03', NULL, NULL, 65, NULL, NULL, 233092),
(262479, '2olsA01', NULL, NULL, 195, NULL, NULL, 233092),
(262480, '2yrxA02', NULL, NULL, 70, NULL, NULL, 233092),
(262481, '2r6fA03', NULL, NULL, 72, NULL, NULL, 233092),
(262482, '3tqtA03', NULL, NULL, 71, NULL, NULL, 233092),
(262483, '2r7kA03', NULL, NULL, 64, NULL, NULL, 233092),
(262484, '1i7nA01', NULL, NULL, 60, NULL, NULL, 233092),
(262485, '4i50F03', NULL, NULL, 59, NULL, NULL, 233092),
(262486, '1auvA01', NULL, NULL, 60, NULL, NULL, 233092),
(262487, '2xclA02', NULL, NULL, 70, NULL, NULL, 233092),
(262488, '5h80A02', NULL, NULL, 72, NULL, NULL, 233092),
(262489, '1vbgA01', NULL, NULL, 161, NULL, NULL, 233092);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(262490, '2pbzA03', NULL, NULL, 54, NULL, NULL, 233092),
(262491, '2cqyA01', NULL, NULL, 72, NULL, NULL, 233092),
(262492, '3vpdA02', NULL, NULL, 69, NULL, NULL, 233092),
(262493, '1kblA01', NULL, NULL, 153, NULL, NULL, 233092),
(262494, '5jvlC01', NULL, NULL, 159, NULL, NULL, 233092),
(262495, '1vkzA02', NULL, NULL, 70, NULL, NULL, 233092),
(262496, '3hblC02', NULL, NULL, 71, NULL, NULL, 233092),
(262497, '3e5nA03', NULL, NULL, 70, NULL, NULL, 233092),
(262498, '1uc9A02', NULL, NULL, 69, NULL, NULL, 233092),
(262499, '4mamA02', NULL, NULL, 81, NULL, NULL, 233092),
(262500, '3ethA03', NULL, NULL, 62, NULL, NULL, 233092),
(262501, '4eg0A03', NULL, NULL, 70, NULL, NULL, 233092),
(262502, '3se7A03', NULL, NULL, 58, NULL, NULL, 233092),
(262503, '2yw2A02', NULL, NULL, 70, NULL, NULL, 233092),
(262504, '1w96A03', NULL, NULL, 63, NULL, NULL, 233092),
(262505, '3lwbA03', NULL, NULL, 66, NULL, NULL, 233092),
(262506, '2pvpA03', NULL, NULL, 64, NULL, NULL, 233092),
(262507, '3orqA03', NULL, NULL, 63, NULL, NULL, 233092),
(262508, '2x0sA01', NULL, NULL, 145, NULL, NULL, 233092),
(262509, '1uc8A02', NULL, NULL, 69, NULL, NULL, 233092),
(262510, '2c00A03', NULL, NULL, 73, NULL, NULL, 233092),
(262511, '2p0aA03', NULL, NULL, 60, NULL, NULL, 233092),
(262512, '3n6rG02', NULL, NULL, 72, NULL, NULL, 233092),
(262513, '1pk8A01', NULL, NULL, 60, NULL, NULL, 233092),
(262514, '3k5iA02', NULL, NULL, 70, NULL, NULL, 233092),
(262515, '5bphD03', NULL, NULL, 73, NULL, NULL, 233092),
(262516, '3vpbA02', NULL, NULL, 69, NULL, NULL, 233092),
(262517, '5k2mA02', NULL, NULL, 69, NULL, NULL, 233092),
(262518, '6dgiA03', NULL, NULL, 68, NULL, NULL, 233092),
(262519, '3ouuA03', NULL, NULL, 72, NULL, NULL, 233092),
(262520, '3wnzA02', NULL, NULL, 92, NULL, NULL, 233092),
(262521, '1e4eA02', NULL, NULL, 58, NULL, NULL, 233092),
(262522, '2dzdB02', NULL, NULL, 72, NULL, NULL, 233092),
(262523, '2yl2A03', NULL, NULL, 63, NULL, NULL, 233092),
(262524, '1uc9B02', NULL, NULL, 69, NULL, NULL, 233092),
(262525, '5zctA02', NULL, NULL, 66, NULL, NULL, 233092),
(262526, '2nu8B02', NULL, NULL, 84, NULL, NULL, 233092),
(262527, '1kjqB02', NULL, NULL, 74, NULL, NULL, 233092),
(262528, '3i12A03', NULL, NULL, 70, NULL, NULL, 233092),
(262529, '3u9tA03', NULL, NULL, 69, NULL, NULL, 233092),
(262530, '5d8dD03', NULL, NULL, 66, NULL, NULL, 233092),
(262531, '5i47B02', NULL, NULL, 67, NULL, NULL, 233092),
(262532, '4izoA02', NULL, NULL, 72, NULL, NULL, 233092),
(262533, '2fp4B02', NULL, NULL, 91, NULL, NULL, 233092),
(262534, '2r85A03', NULL, NULL, 62, NULL, NULL, 233092),
(262535, '1gsoA02', NULL, NULL, 70, NULL, NULL, 233092),
(262536, '3r5xD03', NULL, NULL, 67, NULL, NULL, 233092),
(262537, '1uc8B02', NULL, NULL, 69, NULL, NULL, 233092),
(262538, '2ip4A02', NULL, NULL, 66, NULL, NULL, 233092),
(262539, '3ouzA03', NULL, NULL, 72, NULL, NULL, 233092),
(262540, '3glkA03', NULL, NULL, 63, NULL, NULL, 233092),
(262541, '2pn1A02', NULL, NULL, 87, NULL, NULL, 233092),
(262542, '1ehiA03', NULL, NULL, 68, NULL, NULL, 233092),
(262543, '4e4tB02', NULL, NULL, 72, NULL, NULL, 233092),
(262544, '1wr2A02', NULL, NULL, 78, NULL, NULL, 233092),
(262545, '2i87A03', NULL, NULL, 73, NULL, NULL, 233092),
(262546, '3ouuB03', NULL, NULL, 72, NULL, NULL, 233092),
(262547, '4xylB02', NULL, NULL, 78, NULL, NULL, 233092),
(262548, '5hv6B01', NULL, NULL, 197, NULL, NULL, 233092),
(262549, '4c5cA03', NULL, NULL, 73, NULL, NULL, 233092),
(262550, '2vpqA03', NULL, NULL, 72, NULL, NULL, 233092),
(262551, '4mv4A03', NULL, NULL, 73, NULL, NULL, 233092),
(262552, '5vevB02', NULL, NULL, 70, NULL, NULL, 233092),
(262553, '4fyyB01', NULL, NULL, 93, NULL, NULL, 233093),
(262554, '1pg5B01', NULL, NULL, 107, NULL, NULL, 233093),
(262555, '2atcB01', NULL, NULL, 100, NULL, NULL, 233093),
(262556, '2ywwA01', NULL, NULL, 98, NULL, NULL, 233093),
(262557, '2be7E01', NULL, NULL, 99, NULL, NULL, 233093),
(262558, '3n54B01', NULL, NULL, 67, NULL, NULL, 233094),
(262559, '2w9jB00', NULL, NULL, 91, NULL, NULL, 233095),
(262560, '4uyjC00', NULL, NULL, 85, NULL, NULL, 233095),
(262561, '5aoxE00', NULL, NULL, 94, NULL, NULL, 233095);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(262562, '1914A00', NULL, NULL, 213, NULL, NULL, 233095),
(262563, '5aoxA00', NULL, NULL, 85, NULL, NULL, 233095),
(262564, '4uykB00', NULL, NULL, 107, NULL, NULL, 233095),
(262565, '4uyjA00', NULL, NULL, 85, NULL, NULL, 233095),
(262566, '4uykA00', NULL, NULL, 85, NULL, NULL, 233095),
(262567, '2jwkA00', NULL, NULL, 74, NULL, NULL, 233096),
(262568, '2pfuA01', NULL, NULL, 70, NULL, NULL, 233096),
(262569, '2qvwA03', NULL, NULL, 33, NULL, NULL, 233097),
(262570, '1jb0K00', NULL, NULL, 64, NULL, NULL, 233098),
(262571, '4kt0K00', NULL, NULL, 75, NULL, NULL, 233098),
(262572, '5xxua00', NULL, NULL, 112, NULL, NULL, 233099),
(262573, '3j7a300', NULL, NULL, 107, NULL, NULL, 233099),
(262574, '5optT00', NULL, NULL, 112, NULL, NULL, 233099),
(262575, '6g5ha00', NULL, NULL, 115, NULL, NULL, 233099),
(262576, '5xyia00', NULL, NULL, 102, NULL, NULL, 233099),
(262577, '5ll6e00', NULL, NULL, 98, NULL, NULL, 233099),
(262578, '6az1b00', NULL, NULL, 112, NULL, NULL, 233099),
(262579, '3jama00', NULL, NULL, 99, NULL, NULL, 233099),
(262580, '2xzm500', NULL, NULL, 99, NULL, NULL, 233099),
(262581, '2vf1A02', NULL, NULL, 48, NULL, NULL, 233100),
(262582, '1mufA01', NULL, NULL, 113, NULL, NULL, 233101),
(262583, '3m58A01', NULL, NULL, 88, NULL, NULL, 233101),
(262584, '1n6aA01', NULL, NULL, 86, NULL, NULL, 233101),
(262585, '5yltA01', NULL, NULL, 90, NULL, NULL, 233101),
(262586, '3wx4A00', NULL, NULL, 100, NULL, NULL, 233102),
(262587, '1m6yA02', NULL, NULL, 105, NULL, NULL, 233103),
(262588, '1wg8A02', NULL, NULL, 101, NULL, NULL, 233103),
(262589, '3tkaA02', NULL, NULL, 103, NULL, NULL, 233103),
(262590, '1xxqA00', NULL, NULL, 161, NULL, NULL, 233104),
(262591, '3mitA00', NULL, NULL, 141, NULL, NULL, 233104),
(262592, '1toqA00', NULL, NULL, 133, NULL, NULL, 233104),
(262593, '1vboA00', NULL, NULL, 149, NULL, NULL, 233104),
(262594, '1zgrA01', NULL, NULL, 149, NULL, NULL, 233104),
(262595, '1zgrA02', NULL, NULL, 146, NULL, NULL, 233104),
(262596, '3aqgB00', NULL, NULL, 158, NULL, NULL, 233104),
(262597, '1c3kA00', NULL, NULL, 147, NULL, NULL, 233104),
(262598, '5krpA00', NULL, NULL, 150, NULL, NULL, 233104),
(262599, '3apaA00', NULL, NULL, 141, NULL, NULL, 233104),
(262600, '4pitA00', NULL, NULL, 149, NULL, NULL, 233104),
(262601, '4ddnA00', NULL, NULL, 160, NULL, NULL, 233104),
(262602, '5bn6E00', NULL, NULL, 138, NULL, NULL, 233104),
(262603, '6flwA00', NULL, NULL, 144, NULL, NULL, 233104),
(262604, '4akdC00', NULL, NULL, 150, NULL, NULL, 233104),
(262605, '1ouwA00', NULL, NULL, 152, NULL, NULL, 233104),
(262606, '5gvyA00', NULL, NULL, 145, NULL, NULL, 233104),
(262607, '3llzA00', NULL, NULL, 133, NULL, NULL, 233104),
(262608, '5exgB00', NULL, NULL, 150, NULL, NULL, 233104),
(262609, '3ll2A00', NULL, NULL, 123, NULL, NULL, 233104),
(262610, '3wocA00', NULL, NULL, 151, NULL, NULL, 233104),
(262611, '5gqtA01', NULL, NULL, 145, NULL, NULL, 233104),
(262612, '1xezA04', NULL, NULL, 135, NULL, NULL, 233104),
(262613, '2jz4A02', NULL, NULL, 151, NULL, NULL, 233104),
(262614, '4mq0A02', NULL, NULL, 145, NULL, NULL, 233104),
(262615, '2jz4A01', NULL, NULL, 148, NULL, NULL, 233104),
(262616, '4mq0A01', NULL, NULL, 149, NULL, NULL, 233104),
(262617, '4r6rA00', NULL, NULL, 133, NULL, NULL, 233104),
(262618, '5v6fA00', NULL, NULL, 138, NULL, NULL, 233104),
(262619, '4mq0A03', NULL, NULL, 152, NULL, NULL, 233104),
(262620, '1ujrA01', NULL, NULL, 83, NULL, NULL, 233105),
(262621, '1x4rA01', NULL, NULL, 79, NULL, NULL, 233105),
(262622, '2a90A02', NULL, NULL, 70, NULL, NULL, 233105),
(262623, '2a90A01', NULL, NULL, 98, NULL, NULL, 233105),
(262624, '3v3lB00', NULL, NULL, 85, NULL, NULL, 233105),
(262625, '2dk6A01', NULL, NULL, 94, NULL, NULL, 233105),
(262626, '2f0cB01', NULL, NULL, 44, NULL, NULL, 233106),
(262627, '4hepA01', NULL, NULL, 59, NULL, NULL, 233106),
(262628, '3oymA04', NULL, NULL, 46, NULL, NULL, 233107),
(262629, '3d30A02', NULL, NULL, 94, NULL, NULL, 233108),
(262630, '3ft1C00', NULL, NULL, 100, NULL, NULL, 233108),
(262631, '4jcwA02', NULL, NULL, 90, NULL, NULL, 233108),
(262632, '2hczX02', NULL, NULL, 104, NULL, NULL, 233108);
INSERT INTO "PUBLIC"."MODEL" VALUES
(262633, '1n10A02', NULL, NULL, 103, NULL, NULL, 233108),
(262634, '2bh0A02', NULL, NULL, 94, NULL, NULL, 233108),
(262635, '1whoA00', NULL, NULL, 96, NULL, NULL, 233108),
(262636, '4o2hA00', NULL, NULL, 150, NULL, NULL, 233109),
(262637, '2v8iA02', NULL, NULL, 53, NULL, NULL, 233110),
(262638, '5a29A02', NULL, NULL, 49, NULL, NULL, 233110),
(262639, '5tj3A02', NULL, NULL, 117, NULL, NULL, 233111),
(262640, '5xwkA02', NULL, NULL, 126, NULL, NULL, 233111),
(262641, '2l3uA00', NULL, NULL, 98, NULL, NULL, 233112),
(262642, '3lywA00', NULL, NULL, 90, NULL, NULL, 233112),
(262643, '2kq1A01', NULL, NULL, 93, NULL, NULL, 233112),
(262644, '5hqhA00', NULL, NULL, 109, NULL, NULL, 233112),
(262645, '1ya5T01', NULL, NULL, 84, NULL, NULL, 233113),
(262646, '2kpoA00', NULL, NULL, 110, NULL, NULL, 233114),
(262647, '2l82A00', NULL, NULL, 162, NULL, NULL, 233114),
(262648, '2l69A00', NULL, NULL, 134, NULL, NULL, 233114),
(262649, '2mr5A00', NULL, NULL, 136, NULL, NULL, 233114),
(262650, '4j29A00', NULL, NULL, 134, NULL, NULL, 233114),
(262651, '2mr6A00', NULL, NULL, 136, NULL, NULL, 233114),
(262652, '2lciA00', NULL, NULL, 134, NULL, NULL, 233114),
(262653, '2n3zA00', NULL, NULL, 99, NULL, NULL, 233114),
(262654, '2lndA00', NULL, NULL, 112, NULL, NULL, 233114),
(262655, '4q0yA00', NULL, NULL, 134, NULL, NULL, 233115),
(262656, '4kmdA02', NULL, NULL, 133, NULL, NULL, 233116),
(262657, '4blbD03', NULL, NULL, 143, NULL, NULL, 233116),
(262658, '4kmaA02', NULL, NULL, 133, NULL, NULL, 233116),
(262659, '3u4kA00', NULL, NULL, 163, NULL, NULL, 233117),
(262660, '3nqkA01', NULL, NULL, 159, NULL, NULL, 233118),
(262661, '3n91A01', NULL, NULL, 187, NULL, NULL, 233118),
(262662, '3pohA01', NULL, NULL, 143, NULL, NULL, 233118),
(262663, '3p02A01', NULL, NULL, 156, NULL, NULL, 233118),
(262664, '4dqaA01', NULL, NULL, 138, NULL, NULL, 233118),
(262665, '5ku7B00', NULL, NULL, 177, NULL, NULL, 233119),
(262666, '4domA01', NULL, NULL, 136, NULL, NULL, 233119),
(262667, '2j67A00', NULL, NULL, 149, NULL, NULL, 233119),
(262668, '5forA00', NULL, NULL, 139, NULL, NULL, 233119),
(262669, '3h16B00', NULL, NULL, 137, NULL, NULL, 233119),
(262670, '4lzpA00', NULL, NULL, 176, NULL, NULL, 233119),
(262671, '1t3gB00', NULL, NULL, 159, NULL, NULL, 233119),
(262672, '4lqcB00', NULL, NULL, 148, NULL, NULL, 233119),
(262673, '1fyxA00', NULL, NULL, 149, NULL, NULL, 233119),
(262674, '3ub2A00', NULL, NULL, 146, NULL, NULL, 233119),
(262675, '1fyvA00', NULL, NULL, 161, NULL, NULL, 233119),
(262676, '1fywA00', NULL, NULL, 149, NULL, NULL, 233119),
(262677, '5tebG00', NULL, NULL, 168, NULL, NULL, 233119),
(262678, '4w8hA00', NULL, NULL, 129, NULL, NULL, 233119),
(262679, '3jrnA00', NULL, NULL, 176, NULL, NULL, 233119),
(262680, '4c6sA00', NULL, NULL, 150, NULL, NULL, 233119),
(262681, '4c6rA00', NULL, NULL, 171, NULL, NULL, 233119),
(262682, '3oziB00', NULL, NULL, 171, NULL, NULL, 233119),
(262683, '4eo7A01', NULL, NULL, 137, NULL, NULL, 233119),
(262684, '4om7A00', NULL, NULL, 143, NULL, NULL, 233119),
(262685, '5tecB00', NULL, NULL, 174, NULL, NULL, 233119),
(262686, '2m1xA00', NULL, NULL, 160, NULL, NULL, 233119),
(262687, '2lrdA00', NULL, NULL, 61, NULL, NULL, 233120),
(262688, '4hr1A00', NULL, NULL, 126, NULL, NULL, 233121),
(262689, '3w1eA03', NULL, NULL, 93, NULL, NULL, 233122),
(262690, '3nzpB04', NULL, NULL, 51, NULL, NULL, 233123),
(262691, '3nzpA04', NULL, NULL, 65, NULL, NULL, 233123),
(262692, '3n2oA04', NULL, NULL, 61, NULL, NULL, 233123),
(262693, '3nzqA04', NULL, NULL, 62, NULL, NULL, 233123),
(262694, '2y9mB00', NULL, NULL, 130, NULL, NULL, 233124),
(262695, '5uj1A03', NULL, NULL, 171, NULL, NULL, 233125),
(262696, '1mw9X03', NULL, NULL, 136, NULL, NULL, 233125),
(262697, '4cgyA03', NULL, NULL, 128, NULL, NULL, 233125),
(262698, '2gaiA03', NULL, NULL, 123, NULL, NULL, 233125),
(262699, '1i7dA03', NULL, NULL, 141, NULL, NULL, 233125),
(262700, '1vx7V01', NULL, NULL, 99, NULL, NULL, 233126),
(262701, '1vq8Q00', NULL, NULL, 96, NULL, NULL, 233126),
(262702, '4a17P01', NULL, NULL, 98, NULL, NULL, 233126),
(262703, '3o58T01', NULL, NULL, 98, NULL, NULL, 233126);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(262704, '1vwxT01', NULL, NULL, 98, NULL, NULL, 233126),
(262705, '4c2mA08', NULL, NULL, 127, NULL, NULL, 233127),
(262706, '1dgwX00', NULL, NULL, 79, NULL, NULL, 233128),
(262707, '3zcjA00', NULL, NULL, 220, NULL, NULL, 233129),
(262708, '3zciA00', NULL, NULL, 220, NULL, NULL, 233129),
(262709, '3zcjC00', NULL, NULL, 220, NULL, NULL, 233129),
(262710, '3zcjB00', NULL, NULL, 220, NULL, NULL, 233129),
(262711, '3zcjE00', NULL, NULL, 220, NULL, NULL, 233129),
(262712, '3zcjD00', NULL, NULL, 220, NULL, NULL, 233129),
(262713, '3zcjF00', NULL, NULL, 220, NULL, NULL, 233129),
(262714, '4yrvA02', NULL, NULL, 68, NULL, NULL, 233130),
(262715, '4izzB02', NULL, NULL, 68, NULL, NULL, 233130),
(262716, '5j1nA02', NULL, NULL, 85, NULL, NULL, 233131),
(262717, '4i1tA02', NULL, NULL, 84, NULL, NULL, 233131),
(262718, '5ltnA02', NULL, NULL, 85, NULL, NULL, 233131),
(262719, '4hteA02', NULL, NULL, 117, NULL, NULL, 233132),
(262720, '3ezxA01', NULL, NULL, 86, NULL, NULL, 233133),
(262721, '3bulA01', NULL, NULL, 89, NULL, NULL, 233133),
(262722, '4hh3C01', NULL, NULL, 85, NULL, NULL, 233133),
(262723, '2i2xB01', NULL, NULL, 100, NULL, NULL, 233133),
(262724, '4hh0A02', NULL, NULL, 136, NULL, NULL, 233133),
(262725, '4jgiA01', NULL, NULL, 80, NULL, NULL, 233133),
(262726, '3whpA01', NULL, NULL, 79, NULL, NULL, 233133),
(262727, '5uwvA03', NULL, NULL, 142, NULL, NULL, 233134),
(262728, '4a1iA02', NULL, NULL, 117, NULL, NULL, 233134),
(262729, '4z7aA03', NULL, NULL, 137, NULL, NULL, 233134),
(262730, '4lpqA02', NULL, NULL, 129, NULL, NULL, 233134),
(262731, '1zatA02', NULL, NULL, 125, NULL, NULL, 233134),
(262732, '4qrbA03', NULL, NULL, 142, NULL, NULL, 233134),
(262733, '5e5lB02', NULL, NULL, 128, NULL, NULL, 233134),
(262734, '4xvoA02', NULL, NULL, 128, NULL, NULL, 233134),
(262735, '6d4kA02', NULL, NULL, 146, NULL, NULL, 233134),
(262736, '2kvlA00', NULL, NULL, 61, NULL, NULL, 233135),
(262737, '1elkA00', NULL, NULL, 157, NULL, NULL, 233136),
(262738, '5m9dA00', NULL, NULL, 142, NULL, NULL, 233136),
(262739, '3cljA00', NULL, NULL, 157, NULL, NULL, 233136),
(262740, '1mhqA00', NULL, NULL, 148, NULL, NULL, 233136),
(262741, '4gzcA00', NULL, NULL, 135, NULL, NULL, 233136),
(262742, '3zyqA01', NULL, NULL, 155, NULL, NULL, 233136),
(262743, '3onkA00', NULL, NULL, 150, NULL, NULL, 233136),
(262744, '3ldzA00', NULL, NULL, 140, NULL, NULL, 233136),
(262745, '5cmyA00', NULL, NULL, 170, NULL, NULL, 233136),
(262746, '1inzA00', NULL, NULL, 148, NULL, NULL, 233136),
(262747, '4nacA00', NULL, NULL, 139, NULL, NULL, 233136),
(262748, '3g2sB00', NULL, NULL, 149, NULL, NULL, 233136),
(262749, '1eduA00', NULL, NULL, 149, NULL, NULL, 233136),
(262750, '3zylA01', NULL, NULL, 153, NULL, NULL, 233136),
(262751, '1x5bA01', NULL, NULL, 135, NULL, NULL, 233136),
(262752, '1vdyA00', NULL, NULL, 140, NULL, NULL, 233136),
(262753, '1sz9C00', NULL, NULL, 144, NULL, NULL, 233136),
(262754, '4flbA00', NULL, NULL, 144, NULL, NULL, 233136),
(262755, '1xgwA00', NULL, NULL, 149, NULL, NULL, 233136),
(262756, '5uccA00', NULL, NULL, 155, NULL, NULL, 233136),
(262757, '1hx8A01', NULL, NULL, 121, NULL, NULL, 233136),
(262758, '5lozA00', NULL, NULL, 137, NULL, NULL, 233136),
(262759, '3d9jB00', NULL, NULL, 145, NULL, NULL, 233136),
(262760, '1juqC00', NULL, NULL, 171, NULL, NULL, 233136),
(262761, '5mdtA00', NULL, NULL, 162, NULL, NULL, 233136),
(262762, '2bf0X00', NULL, NULL, 143, NULL, NULL, 233136),
(262763, '2diwA01', NULL, NULL, 141, NULL, NULL, 233136),
(262764, '4jxtA00', NULL, NULL, 138, NULL, NULL, 233136),
(262765, '4q94A00', NULL, NULL, 135, NULL, NULL, 233136),
(262766, '1eyhA00', NULL, NULL, 144, NULL, NULL, 233136),
(262767, '5lp0A00', NULL, NULL, 145, NULL, NULL, 233136),
(262768, '1dvpA01', NULL, NULL, 140, NULL, NULL, 233136),
(262769, '3rruA00', NULL, NULL, 152, NULL, NULL, 233136),
(262770, '4citA00', NULL, NULL, 429, NULL, NULL, 233137),
(262771, '2mhdA00', NULL, NULL, 110, NULL, NULL, 233138),
(262772, '5a0yB01', NULL, NULL, 296, NULL, NULL, 233139),
(262773, '5a0yA03', NULL, NULL, 260, NULL, NULL, 233139),
(262774, '5a8wB01', NULL, NULL, 296, NULL, NULL, 233139);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(262775, '5a8wA03', NULL, NULL, 229, NULL, NULL, 233139),
(262776, '1e6vA03', NULL, NULL, 230, NULL, NULL, 233139),
(262777, '1e6vB02', NULL, NULL, 296, NULL, NULL, 233139),
(262778, '5n1qB01', NULL, NULL, 296, NULL, NULL, 233139),
(262779, '3sqgA03', NULL, NULL, 235, NULL, NULL, 233139),
(262780, '5n1qA03', NULL, NULL, 229, NULL, NULL, 233139),
(262781, '3sqgB01', NULL, NULL, 288, NULL, NULL, 233139),
(262782, '1e6yA03', NULL, NULL, 236, NULL, NULL, 233139),
(262783, '1e6yB02', NULL, NULL, 286, NULL, NULL, 233139),
(262784, '5n28B01', NULL, NULL, 297, NULL, NULL, 233139),
(262785, '5n28A03', NULL, NULL, 229, NULL, NULL, 233139),
(262786, '1vx7f00', NULL, NULL, 52, NULL, NULL, 233140),
(262787, '4a18K00', NULL, NULL, 52, NULL, NULL, 233140),
(262788, '3u5em00', NULL, NULL, 52, NULL, NULL, 233140),
(262789, '1vwxm00', NULL, NULL, 52, NULL, NULL, 233140),
(262790, '2ayjA00', NULL, NULL, 56, NULL, NULL, 233140),
(262791, '5an9H00', NULL, NULL, 52, NULL, NULL, 233140),
(262792, '5oy0c00', NULL, NULL, 81, NULL, NULL, 233141),
(262793, '3c8yA02', NULL, NULL, 84, NULL, NULL, 233141),
(262794, '1fxdA00', NULL, NULL, 58, NULL, NULL, 233141),
(262795, '1rgvA00', NULL, NULL, 80, NULL, NULL, 233141),
(262796, '1durA00', NULL, NULL, 55, NULL, NULL, 233141),
(262797, '2xsjB03', NULL, NULL, 70, NULL, NULL, 233141),
(262798, '1fcaA00', NULL, NULL, 55, NULL, NULL, 233141),
(262799, '4id8A00', NULL, NULL, 69, NULL, NULL, 233141),
(262800, '1clfA00', NULL, NULL, 55, NULL, NULL, 233141),
(262801, '4omfG02', NULL, NULL, 72, NULL, NULL, 233141),
(262802, '2v4jB03', NULL, NULL, 65, NULL, NULL, 233141),
(262803, '2c42A05', NULL, NULL, 117, NULL, NULL, 233141),
(262804, '3eunA00', NULL, NULL, 82, NULL, NULL, 233141),
(262805, '5l8rC00', NULL, NULL, 81, NULL, NULL, 233141),
(262806, '1q16B01', NULL, NULL, 162, NULL, NULL, 233141),
(262807, '3or1A04', NULL, NULL, 84, NULL, NULL, 233141),
(262808, '5zgbC00', NULL, NULL, 81, NULL, NULL, 233141),
(262809, '4aybD03', NULL, NULL, 57, NULL, NULL, 233141),
(262810, '3gyxB01', NULL, NULL, 66, NULL, NULL, 233141),
(262811, '3mm5A04', NULL, NULL, 68, NULL, NULL, 233141),
(262812, '2pa8D03', NULL, NULL, 57, NULL, NULL, 233141),
(262813, '1vjwA00', NULL, NULL, 60, NULL, NULL, 233141),
(262814, '1xerA00', NULL, NULL, 103, NULL, NULL, 233141),
(262815, '6igzC00', NULL, NULL, 81, NULL, NULL, 233141),
(262816, '1gteA01', NULL, NULL, 118, NULL, NULL, 233141),
(262817, '2vpzB02', NULL, NULL, 52, NULL, NULL, 233141),
(262818, '5zjiC00', NULL, NULL, 81, NULL, NULL, 233141),
(262819, '2fgoA00', NULL, NULL, 82, NULL, NULL, 233141),
(262820, '2vpzB01', NULL, NULL, 135, NULL, NULL, 233141),
(262821, '1sj1A00', NULL, NULL, 66, NULL, NULL, 233141),
(262822, '2zvsA00', NULL, NULL, 85, NULL, NULL, 233141),
(262823, '1h0hB01', NULL, NULL, 150, NULL, NULL, 233141),
(262824, '2xsjA04', NULL, NULL, 84, NULL, NULL, 233141),
(262825, '1h0hB02', NULL, NULL, 64, NULL, NULL, 233141),
(262826, '1h98A00', NULL, NULL, 78, NULL, NULL, 233141),
(262827, '1iqzA00', NULL, NULL, 81, NULL, NULL, 233141),
(262828, '1ti6B02', NULL, NULL, 57, NULL, NULL, 233141),
(262829, '1ti2B01', NULL, NULL, 133, NULL, NULL, 233141),
(262830, '2vkrA00', NULL, NULL, 103, NULL, NULL, 233141),
(262831, '2gmhA03', NULL, NULL, 96, NULL, NULL, 233141),
(262832, '2v2kB00', NULL, NULL, 105, NULL, NULL, 233141),
(262833, '1bc6A00', NULL, NULL, 77, NULL, NULL, 233141),
(262834, '2v4jA04', NULL, NULL, 84, NULL, NULL, 233141),
(262835, '1hfeL02', NULL, NULL, 52, NULL, NULL, 233141),
(262836, '3or1B03', NULL, NULL, 65, NULL, NULL, 233141),
(262837, '1jnrB01', NULL, NULL, 67, NULL, NULL, 233141),
(262838, '6ijjC00', NULL, NULL, 81, NULL, NULL, 233141),
(262839, '3mm5B03', NULL, NULL, 59, NULL, NULL, 233141),
(262840, '7fd1A00', NULL, NULL, 106, NULL, NULL, 233141),
(262841, '2fdnA00', NULL, NULL, 55, NULL, NULL, 233141),
(262842, '1kqfB02', NULL, NULL, 137, NULL, NULL, 233141),
(262843, '1kqfB01', NULL, NULL, 91, NULL, NULL, 233141),
(262844, '1fxrA00', NULL, NULL, 64, NULL, NULL, 233141),
(262845, '2xc1A01', NULL, NULL, 110, NULL, NULL, 233142);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(262846, '1zb9A02', NULL, NULL, 95, NULL, NULL, 233143),
(262847, '2pn2A00', NULL, NULL, 155, NULL, NULL, 233143),
(262848, '3cjeA00', NULL, NULL, 167, NULL, NULL, 233143),
(262849, '1vs5C01', NULL, NULL, 91, NULL, NULL, 233143),
(262850, '2kzfA00', NULL, NULL, 106, NULL, NULL, 233143),
(262851, '4mh4A02', NULL, NULL, 94, NULL, NULL, 233143),
(262852, '1hh2P03', NULL, NULL, 79, NULL, NULL, 233143),
(262853, '1hh2P04', NULL, NULL, 68, NULL, NULL, 233143),
(262854, '2jmpA01', NULL, NULL, 94, NULL, NULL, 233143),
(262855, '3ievA02', NULL, NULL, 116, NULL, NULL, 233143),
(262856, '2xzmC01', NULL, NULL, 95, NULL, NULL, 233143),
(262857, '2ycbA02', NULL, NULL, 71, NULL, NULL, 233143),
(262858, '2bjoA02', NULL, NULL, 94, NULL, NULL, 233143),
(262859, '1wh9A01', NULL, NULL, 82, NULL, NULL, 233143),
(262860, '3eerA02', NULL, NULL, 97, NULL, NULL, 233143),
(262861, '1josA00', NULL, NULL, 106, NULL, NULL, 233143),
(262862, '3jamD01', NULL, NULL, 92, NULL, NULL, 233143),
(262863, '1qwiA00', NULL, NULL, 143, NULL, NULL, 233143),
(262864, '1kkgA00', NULL, NULL, 108, NULL, NULL, 233143),
(262865, '1pa4A00', NULL, NULL, 116, NULL, NULL, 233143),
(262866, '4dcuA03', NULL, NULL, 84, NULL, NULL, 233143),
(262867, '6mjnC02', NULL, NULL, 96, NULL, NULL, 233143),
(262868, '2e8eA00', NULL, NULL, 132, NULL, NULL, 233143),
(262869, '2pt7G01', NULL, NULL, 80, NULL, NULL, 233143),
(262870, '2asbA03', NULL, NULL, 72, NULL, NULL, 233143),
(262871, '2asbA02', NULL, NULL, 79, NULL, NULL, 233143),
(262872, '2ql8A00', NULL, NULL, 143, NULL, NULL, 233143),
(262873, '2xr1A02', NULL, NULL, 71, NULL, NULL, 233143),
(262874, '5o5jC01', NULL, NULL, 90, NULL, NULL, 233143),
(262875, '1ml8A02', NULL, NULL, 100, NULL, NULL, 233143),
(262876, '4bszA01', NULL, NULL, 95, NULL, NULL, 233143),
(262877, '6az1C01', NULL, NULL, 91, NULL, NULL, 233143),
(262878, '2d7vB00', NULL, NULL, 162, NULL, NULL, 233143),
(262879, '1lqlA02', NULL, NULL, 103, NULL, NULL, 233143),
(262880, '2egtA02', NULL, NULL, 100, NULL, NULL, 233143),
(262881, '2vqeC01', NULL, NULL, 91, NULL, NULL, 233143),
(262882, '2cxcA01', NULL, NULL, 75, NULL, NULL, 233143),
(262883, '1egaA02', NULL, NULL, 106, NULL, NULL, 233143),
(262884, '1mkyA03', NULL, NULL, 90, NULL, NULL, 233143),
(262885, '2cxcA02', NULL, NULL, 69, NULL, NULL, 233143),
(262886, '2oplB01', NULL, NULL, 175, NULL, NULL, 233143),
(262887, '2e7gA01', NULL, NULL, 106, NULL, NULL, 233143),
(262888, '3af5A02', NULL, NULL, 71, NULL, NULL, 233143),
(262889, '1vlaD02', NULL, NULL, 102, NULL, NULL, 233143),
(262890, '1uspA02', NULL, NULL, 95, NULL, NULL, 233143),
(262891, '5optm01', NULL, NULL, 91, NULL, NULL, 233143),
(262892, '1n2fA02', NULL, NULL, 95, NULL, NULL, 233143),
(262893, '5xxuD01', NULL, NULL, 94, NULL, NULL, 233143),
(262894, '1wf3A02', NULL, NULL, 117, NULL, NULL, 233143),
(262895, '4mtnA03', NULL, NULL, 79, NULL, NULL, 233143),
(262896, '2dyjA00', NULL, NULL, 95, NULL, NULL, 233143),
(262897, '5flxD01', NULL, NULL, 92, NULL, NULL, 233143),
(262898, '6d9nA02', NULL, NULL, 96, NULL, NULL, 233143),
(262899, '1ukkA00', NULL, NULL, 142, NULL, NULL, 233143),
(262900, '4nozA02', NULL, NULL, 94, NULL, NULL, 233143),
(262901, '2onfA01', NULL, NULL, 134, NULL, NULL, 233143),
(262902, '5xyiD01', NULL, NULL, 93, NULL, NULL, 233143),
(262903, '3gkuC02', NULL, NULL, 89, NULL, NULL, 233143),
(262904, '4az3B00', NULL, NULL, 155, NULL, NULL, 233144),
(262905, '2l9qA00', NULL, NULL, 109, NULL, NULL, 233145),
(262906, '2k7vB01', NULL, NULL, 26, NULL, NULL, 233146),
(262907, '2r18A02', NULL, NULL, 60, NULL, NULL, 233147),
(262908, '2qyzA01', NULL, NULL, 56, NULL, NULL, 233148),
(262909, '3ol1A00', NULL, NULL, 119, NULL, NULL, 233149),
(262910, '1useA00', NULL, NULL, 45, NULL, NULL, 233149),
(262911, '3mudD00', NULL, NULL, 48, NULL, NULL, 233149),
(262912, '3swkB00', NULL, NULL, 86, NULL, NULL, 233149),
(262913, '3ssuA00', NULL, NULL, 46, NULL, NULL, 233149),
(262914, '5khtA00', NULL, NULL, 47, NULL, NULL, 233149),
(262915, '4ypcA00', NULL, NULL, 83, NULL, NULL, 233149),
(262916, '2q2eB04', NULL, NULL, 39, NULL, NULL, 233150);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(262917, '2auaA01', NULL, NULL, 133, NULL, NULL, 233151),
(262918, '1r71A01', NULL, NULL, 56, NULL, NULL, 233152),
(262919, '2erlA00', NULL, NULL, 40, NULL, NULL, 233153),
(262920, '2uvaG07', NULL, NULL, 136, NULL, NULL, 233154),
(262921, '2uv8G07', NULL, NULL, 132, NULL, NULL, 233154),
(262922, '1e3mB03', NULL, NULL, 56, NULL, NULL, 233155),
(262923, '1ok8A03', NULL, NULL, 81, NULL, NULL, 233156),
(262924, '6j5cA03', NULL, NULL, 80, NULL, NULL, 233156),
(262925, '4utaA03', NULL, NULL, 79, NULL, NULL, 233156),
(262926, '1uzgA03', NULL, NULL, 79, NULL, NULL, 233156),
(262927, '1svbA03', NULL, NULL, 80, NULL, NULL, 233156),
(262928, '5mv2A03', NULL, NULL, 79, NULL, NULL, 233156),
(262929, '5jhmA03', NULL, NULL, 79, NULL, NULL, 233156),
(262930, '2hg0A03', NULL, NULL, 85, NULL, NULL, 233156),
(262931, '3uajA03', NULL, NULL, 80, NULL, NULL, 233156),
(262932, '6a0pA03', NULL, NULL, 85, NULL, NULL, 233156),
(262933, '6ivzA03', NULL, NULL, 81, NULL, NULL, 233156),
(262934, '4fg0A03', NULL, NULL, 81, NULL, NULL, 233156),
(262935, '4gsxA03', NULL, NULL, 81, NULL, NULL, 233156),
(262936, '1vx7E01', NULL, NULL, 92, NULL, NULL, 233157),
(262937, '5an9A01', NULL, NULL, 92, NULL, NULL, 233157),
(262938, '4a17B01', NULL, NULL, 92, NULL, NULL, 233157),
(262939, '1vq8B01', NULL, NULL, 90, NULL, NULL, 233157),
(262940, '1vwxB01', NULL, NULL, 91, NULL, NULL, 233157),
(262941, '3u5eB01', NULL, NULL, 92, NULL, NULL, 233157),
(262942, '1szqA01', NULL, NULL, 341, NULL, NULL, 233158),
(262943, '2hp0A01', NULL, NULL, 335, NULL, NULL, 233158),
(262944, '5mviA01', NULL, NULL, 341, NULL, NULL, 233158),
(262945, '5muxF01', NULL, NULL, 333, NULL, NULL, 233158),
(262946, '2p9xA00', NULL, NULL, 99, NULL, NULL, 233159),
(262947, '3urgA01', NULL, NULL, 60, NULL, NULL, 233160),
(262948, '1t50A00', NULL, NULL, 58, NULL, NULL, 233161),
(262949, '3akoD00', NULL, NULL, 93, NULL, NULL, 233162),
(262950, '2e1mA04', NULL, NULL, 37, NULL, NULL, 233163),
(262951, '1zhxA04', NULL, NULL, 127, NULL, NULL, 233164),
(262952, '3t4lA02', NULL, NULL, 217, NULL, NULL, 233165),
(262953, '3anwB00', NULL, NULL, 171, NULL, NULL, 233166),
(262954, '3jc6C00', NULL, NULL, 194, NULL, NULL, 233166),
(262955, '2e9xG00', NULL, NULL, 195, NULL, NULL, 233166),
(262956, '3toeA00', NULL, NULL, 91, NULL, NULL, 233167),
(262957, '2ek0A00', NULL, NULL, 90, NULL, NULL, 233167),
(262958, '3iabB01', NULL, NULL, 132, NULL, NULL, 233167),
(262959, '1nfjA00', NULL, NULL, 89, NULL, NULL, 233167),
(262960, '2bkyX00', NULL, NULL, 89, NULL, NULL, 233167),
(262961, '2z7cA00', NULL, NULL, 93, NULL, NULL, 233167),
(262962, '3u6yA00', NULL, NULL, 102, NULL, NULL, 233167),
(262963, '1nh9A00', NULL, NULL, 87, NULL, NULL, 233167),
(262964, '1vm0A00', NULL, NULL, 112, NULL, NULL, 233167),
(262965, '4z9eA00', NULL, NULL, 97, NULL, NULL, 233167),
(262966, '2bkyA00', NULL, NULL, 97, NULL, NULL, 233167),
(262967, '3tlxC01', NULL, NULL, 27, NULL, NULL, 233168),
(262968, '2xqhA03', NULL, NULL, 68, NULL, NULL, 233169),
(262969, '2nw8B00', NULL, NULL, 270, NULL, NULL, 233170),
(262970, '4pw8D01', NULL, NULL, 298, NULL, NULL, 233170),
(262971, '4hkaA01', NULL, NULL, 296, NULL, NULL, 233170),
(262972, '2v7kA02', NULL, NULL, 228, NULL, NULL, 233170),
(262973, '2nwbA02', NULL, NULL, 254, NULL, NULL, 233170),
(262974, '3bk9F00', NULL, NULL, 261, NULL, NULL, 233170),
(262975, '2noxC00', NULL, NULL, 260, NULL, NULL, 233170),
(262976, '4u72A01', NULL, NULL, 253, NULL, NULL, 233170),
(262977, '3pt1A02', NULL, NULL, 120, NULL, NULL, 233171),
(262978, '4jglA00', NULL, NULL, 152, NULL, NULL, 233172),
(262979, '1w6kA01', NULL, NULL, 52, NULL, NULL, 233173),
(262980, '4ng0B00', NULL, NULL, 97, NULL, NULL, 233174),
(262981, '1fo8A02', NULL, NULL, 80, NULL, NULL, 233175),
(262982, '2lpeA01', NULL, NULL, 78, NULL, NULL, 233176),
(262983, '3fbiD00', NULL, NULL, 94, NULL, NULL, 233177),
(262984, '5n9jR00', NULL, NULL, 104, NULL, NULL, 233177),
(262985, '2j8pA00', NULL, NULL, 49, NULL, NULL, 233178),
(262986, '4m4dA01', NULL, NULL, 289, NULL, NULL, 233179),
(262987, '1ewfA02', NULL, NULL, 276, NULL, NULL, 233179); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(262988, '2obdA01', NULL, NULL, 287, NULL, NULL, 233179),
(262989, '3vwoA02', NULL, NULL, 51, NULL, NULL, 233180),
(262990, '5dn4A02', NULL, NULL, 51, NULL, NULL, 233180),
(262991, '4rgdA00', NULL, NULL, 70, NULL, NULL, 233181),
(262992, '2mp8A00', NULL, NULL, 64, NULL, NULL, 233181),
(262993, '2kjfA00', NULL, NULL, 60, NULL, NULL, 233181),
(262994, '4divC02', NULL, NULL, 45, NULL, NULL, 233182),
(262995, '2f4iC01', NULL, NULL, 62, NULL, NULL, 233183),
(262996, '2f4iB01', NULL, NULL, 62, NULL, NULL, 233183),
(262997, '2f4iA01', NULL, NULL, 61, NULL, NULL, 233183),
(262998, '2f4iD01', NULL, NULL, 61, NULL, NULL, 233183),
(262999, '1rzhM02', NULL, NULL, 164, NULL, NULL, 233184),
(263000, '1l9bM01', NULL, NULL, 109, NULL, NULL, 233184),
(263001, '5y5sL02', NULL, NULL, 100, NULL, NULL, 233184),
(263002, '5y5sM01', NULL, NULL, 143, NULL, NULL, 233184),
(263003, '5y5sM02', NULL, NULL, 159, NULL, NULL, 233184),
(263004, '5y5sL01', NULL, NULL, 172, NULL, NULL, 233184),
(263005, '2wjnL02', NULL, NULL, 108, NULL, NULL, 233184),
(263006, '2wjnM01', NULL, NULL, 144, NULL, NULL, 233184),
(263007, '2wjnL01', NULL, NULL, 166, NULL, NULL, 233184),
(263008, '2wjnM02', NULL, NULL, 159, NULL, NULL, 233184),
(263009, '1rzhL02', NULL, NULL, 100, NULL, NULL, 233184),
(263010, '1rzhM01', NULL, NULL, 143, NULL, NULL, 233184),
(263011, '1rzhL01', NULL, NULL, 163, NULL, NULL, 233184),
(263012, '1wruA02', NULL, NULL, 88, NULL, NULL, 233185),
(263013, '3d37A02', NULL, NULL, 85, NULL, NULL, 233185),
(263014, '3cddA02', NULL, NULL, 85, NULL, NULL, 233185),
(263015, '2p5zX02', NULL, NULL, 97, NULL, NULL, 233185),
(263016, '4uhvA02', NULL, NULL, 92, NULL, NULL, 233185),
(263017, '5tcsD00', NULL, NULL, 115, NULL, NULL, 233186),
(263018, '5t6jB00', NULL, NULL, 92, NULL, NULL, 233186),
(263019, '3vz9B00', NULL, NULL, 106, NULL, NULL, 233186),
(263020, '1m93A00', NULL, NULL, 55, NULL, NULL, 233187),
(263021, '1jjoA00', NULL, NULL, 40, NULL, NULL, 233187),
(263022, '2kr6A01', NULL, NULL, 106, NULL, NULL, 233188),
(263023, '1vsy300', NULL, NULL, 76, NULL, NULL, 233189),
(263024, '2af5A01', NULL, NULL, 59, NULL, NULL, 233190),
(263025, '2ol6O01', NULL, NULL, 104, NULL, NULL, 233190),
(263026, '1ospO01', NULL, NULL, 111, NULL, NULL, 233190),
(263027, '3ckfA01', NULL, NULL, 81, NULL, NULL, 233190),
(263028, '2fkgA01', NULL, NULL, 82, NULL, NULL, 233190),
(263029, '3aumO01', NULL, NULL, 105, NULL, NULL, 233190),
(263030, '2i5vO01', NULL, NULL, 105, NULL, NULL, 233190),
(263031, '2g8cO01', NULL, NULL, 105, NULL, NULL, 233190),
(263032, '3dd9D01', NULL, NULL, 94, NULL, NULL, 233191),
(263033, '4ar9A03', NULL, NULL, 108, NULL, NULL, 233192),
(263034, '4arfA03', NULL, NULL, 109, NULL, NULL, 233192),
(263035, '4areA02', NULL, NULL, 114, NULL, NULL, 233192),
(263036, '1cseI00', NULL, NULL, 70, NULL, NULL, 233193),
(263037, '3rdyA00', NULL, NULL, 79, NULL, NULL, 233193),
(263038, '1hymA00', NULL, NULL, 45, NULL, NULL, 233193),
(263039, '4h4fB00', NULL, NULL, 70, NULL, NULL, 233193),
(263040, '1to2I00', NULL, NULL, 64, NULL, NULL, 233193),
(263041, '1tinA00', NULL, NULL, 69, NULL, NULL, 233193),
(263042, '5ffnI00', NULL, NULL, 72, NULL, NULL, 233193),
(263043, '3w0eA00', NULL, NULL, 68, NULL, NULL, 233193),
(263044, '1ypcI00', NULL, NULL, 64, NULL, NULL, 233193),
(263045, '1cisA00', NULL, NULL, 66, NULL, NULL, 233193),
(263046, '1dwmA00', NULL, NULL, 70, NULL, NULL, 233193),
(263047, '1vbwA00', NULL, NULL, 68, NULL, NULL, 233193),
(263048, '2uvaG11', NULL, NULL, 55, NULL, NULL, 233194),
(263049, '2uv8G11', NULL, NULL, 54, NULL, NULL, 233194),
(263050, '1lshA03', NULL, NULL, 98, NULL, NULL, 233195),
(263051, '2vqcA00', NULL, NULL, 79, NULL, NULL, 233196),
(263052, '2b2cA01', NULL, NULL, 89, NULL, NULL, 233197),
(263053, '2cmgA01', NULL, NULL, 51, NULL, NULL, 233197),
(263054, '1uirA01', NULL, NULL, 52, NULL, NULL, 233197),
(263055, '2o07A01', NULL, NULL, 59, NULL, NULL, 233197),
(263056, '3o4fC01', NULL, NULL, 60, NULL, NULL, 233197),
(263057, '3c6kA02', NULL, NULL, 56, NULL, NULL, 233197),
(263058, '2i7cA01', NULL, NULL, 59, NULL, NULL, 233197);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(263059, '1iy9A02', NULL, NULL, 52, NULL, NULL, 233197),
(263060, '1inlC02', NULL, NULL, 67, NULL, NULL, 233197),
(263061, '1xj5B01', NULL, NULL, 60, NULL, NULL, 233197),
(263062, '3bwcA01', NULL, NULL, 76, NULL, NULL, 233197),
(263063, '4yv1A01', NULL, NULL, 59, NULL, NULL, 233197),
(263064, '4yuvA01', NULL, NULL, 76, NULL, NULL, 233197),
(263065, '3bwbB01', NULL, NULL, 76, NULL, NULL, 233197),
(263066, '3bwbA01', NULL, NULL, 76, NULL, NULL, 233197),
(263067, '3bwcB01', NULL, NULL, 76, NULL, NULL, 233197),
(263068, '1mjfA01', NULL, NULL, 55, NULL, NULL, 233197),
(263069, '2o06B01', NULL, NULL, 76, NULL, NULL, 233197),
(263070, '2e5wA01', NULL, NULL, 56, NULL, NULL, 233197),
(263071, '3bmbA01', NULL, NULL, 44, NULL, NULL, 233198),
(263072, '2pn0A01', NULL, NULL, 47, NULL, NULL, 233198),
(263073, '1efuB04', NULL, NULL, 47, NULL, NULL, 233198),
(263074, '1tfeA02', NULL, NULL, 45, NULL, NULL, 233198),
(263075, '3d9rB00', NULL, NULL, 135, NULL, NULL, 233199),
(263076, '3gzbB00', NULL, NULL, 137, NULL, NULL, 233199),
(263077, '3fkaB00', NULL, NULL, 120, NULL, NULL, 233199),
(263078, '1of5B00', NULL, NULL, 149, NULL, NULL, 233199),
(263079, '5drvA00', NULL, NULL, 142, NULL, NULL, 233199),
(263080, '3cu3A00', NULL, NULL, 172, NULL, NULL, 233199),
(263081, '3g16B00', NULL, NULL, 156, NULL, NULL, 233199),
(263082, '2a15A00', NULL, NULL, 139, NULL, NULL, 233199),
(263083, '6c1xA00', NULL, NULL, 131, NULL, NULL, 233199),
(263084, '4lehA00', NULL, NULL, 185, NULL, NULL, 233199),
(263085, '2owpA00', NULL, NULL, 129, NULL, NULL, 233199),
(263086, '3dmcA00', NULL, NULL, 134, NULL, NULL, 233199),
(263087, '3kkgA00', NULL, NULL, 146, NULL, NULL, 233199),
(263088, '4orlA00', NULL, NULL, 110, NULL, NULL, 233199),
(263089, '3b7cA00', NULL, NULL, 122, NULL, NULL, 233199),
(263090, '3gzbF00', NULL, NULL, 137, NULL, NULL, 233199),
(263091, '2jq5A00', NULL, NULL, 128, NULL, NULL, 233199),
(263092, '3kspA00', NULL, NULL, 129, NULL, NULL, 233199),
(263093, '6fejA00', NULL, NULL, 124, NULL, NULL, 233199),
(263094, '4hm8B00', NULL, NULL, 194, NULL, NULL, 233199),
(263095, '2bmoB00', NULL, NULL, 194, NULL, NULL, 233199),
(263096, '2chcC00', NULL, NULL, 170, NULL, NULL, 233199),
(263097, '1gy7B00', NULL, NULL, 125, NULL, NULL, 233199),
(263098, '4r1kB00', NULL, NULL, 138, NULL, NULL, 233199),
(263099, '5ig3A00', NULL, NULL, 153, NULL, NULL, 233199),
(263100, '3fljA00', NULL, NULL, 155, NULL, NULL, 233199),
(263101, '4hz9B00', NULL, NULL, 123, NULL, NULL, 233199),
(263102, '2r4iA00', NULL, NULL, 123, NULL, NULL, 233199),
(263103, '2f86B00', NULL, NULL, 143, NULL, NULL, 233199),
(263104, '2w2cH00', NULL, NULL, 144, NULL, NULL, 233199),
(263105, '2imjD01', NULL, NULL, 152, NULL, NULL, 233199),
(263106, '3ff0A01', NULL, NULL, 141, NULL, NULL, 233199),
(263107, '3h51A00', NULL, NULL, 156, NULL, NULL, 233199),
(263108, '1sjwA00', NULL, NULL, 144, NULL, NULL, 233199),
(263109, '3dxoB00', NULL, NULL, 121, NULL, NULL, 233199),
(263110, '2f99C00', NULL, NULL, 153, NULL, NULL, 233199),
(263111, '1jkgB00', NULL, NULL, 186, NULL, NULL, 233199),
(263112, '3ebyA00', NULL, NULL, 163, NULL, NULL, 233199),
(263113, '5kvbA01', NULL, NULL, 146, NULL, NULL, 233199),
(263114, '3f8hA00', NULL, NULL, 150, NULL, NULL, 233199),
(263115, '1q40D00', NULL, NULL, 219, NULL, NULL, 233199),
(263116, '3f9sB00', NULL, NULL, 146, NULL, NULL, 233199),
(263117, '3fsdA00', NULL, NULL, 134, NULL, NULL, 233199),
(263118, '3ef8A00', NULL, NULL, 150, NULL, NULL, 233199),
(263119, '1s5aB00', NULL, NULL, 150, NULL, NULL, 233199),
(263120, '1ohpA00', NULL, NULL, 125, NULL, NULL, 233199),
(263121, '5cxoB00', NULL, NULL, 148, NULL, NULL, 233199),
(263122, '3soaA03', NULL, NULL, 142, NULL, NULL, 233199),
(263123, '3lygA00', NULL, NULL, 120, NULL, NULL, 233199),
(263124, '4gb5A00', NULL, NULL, 159, NULL, NULL, 233199),
(263125, '3gzxB00', NULL, NULL, 186, NULL, NULL, 233199),
(263126, '3b8lA01', NULL, NULL, 141, NULL, NULL, 233199),
(263127, '3gzbA00', NULL, NULL, 154, NULL, NULL, 233199),
(263128, '5tgnA00', NULL, NULL, 111, NULL, NULL, 233199),
(263129, '6of9B00', NULL, NULL, 134, NULL, NULL, 233199);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(263130, '5tuxA02', NULL, NULL, 136, NULL, NULL, 233199),
(263131, '1of5A00', NULL, NULL, 183, NULL, NULL, 233199),
(263132, '5hgrA02', NULL, NULL, 136, NULL, NULL, 233199),
(263133, '2rgqB00', NULL, NULL, 144, NULL, NULL, 233199),
(263134, '4l8pA00', NULL, NULL, 187, NULL, NULL, 233199),
(263135, '4lehB00', NULL, NULL, 185, NULL, NULL, 233199),
(263136, '4u13A00', NULL, NULL, 109, NULL, NULL, 233199),
(263137, '2ckfB00', NULL, NULL, 174, NULL, NULL, 233199),
(263138, '3gzbE00', NULL, NULL, 154, NULL, NULL, 233199),
(263139, '4cdlA00', NULL, NULL, 141, NULL, NULL, 233199),
(263140, '3owuA00', NULL, NULL, 131, NULL, NULL, 233199),
(263141, '4ovmC00', NULL, NULL, 144, NULL, NULL, 233199),
(263142, '4xdwF00', NULL, NULL, 155, NULL, NULL, 233199),
(263143, '4xbxB00', NULL, NULL, 155, NULL, NULL, 233199),
(263144, '3jumA01', NULL, NULL, 141, NULL, NULL, 233199),
(263145, '3en1B00', NULL, NULL, 187, NULL, NULL, 233199),
(263146, '3soyA00', NULL, NULL, 145, NULL, NULL, 233199),
(263147, '3fh1A00', NULL, NULL, 129, NULL, NULL, 233199),
(263148, '3dm8A00', NULL, NULL, 143, NULL, NULL, 233199),
(263149, '5ieoA00', NULL, NULL, 137, NULL, NULL, 233199),
(263150, '4x2oA00', NULL, NULL, 193, NULL, NULL, 233199),
(263151, '3stdA00', NULL, NULL, 165, NULL, NULL, 233199),
(263152, '4q53B00', NULL, NULL, 110, NULL, NULL, 233199),
(263153, '4pejB00', NULL, NULL, 141, NULL, NULL, 233199),
(263154, '6of8A00', NULL, NULL, 135, NULL, NULL, 233199),
(263155, '3nv0B00', NULL, NULL, 136, NULL, NULL, 233199),
(263156, '3ke7B00', NULL, NULL, 134, NULL, NULL, 233199),
(263157, '2rfrA00', NULL, NULL, 155, NULL, NULL, 233199),
(263158, '1jkgA00', NULL, NULL, 140, NULL, NULL, 233199),
(263159, '1nwwA00', NULL, NULL, 149, NULL, NULL, 233199),
(263160, '1idpA00', NULL, NULL, 155, NULL, NULL, 233199),
(263161, '3grdA00', NULL, NULL, 134, NULL, NULL, 233199),
(263162, '3a76A01', NULL, NULL, 139, NULL, NULL, 233199),
(263163, '3k7cA00', NULL, NULL, 114, NULL, NULL, 233199),
(263164, '3cnxA00', NULL, NULL, 170, NULL, NULL, 233199),
(263165, '2qiyA00', NULL, NULL, 154, NULL, NULL, 233199),
(263166, '5aewJ00', NULL, NULL, 188, NULL, NULL, 233199),
(263167, '5xbpC00', NULL, NULL, 193, NULL, NULL, 233199),
(263168, '2gxfA00', NULL, NULL, 142, NULL, NULL, 233199),
(263169, '3ec9A00', NULL, NULL, 140, NULL, NULL, 233199),
(263170, '5ig4E00', NULL, NULL, 145, NULL, NULL, 233199),
(263171, '3bb9B00', NULL, NULL, 125, NULL, NULL, 233199),
(263172, '3g8zA00', NULL, NULL, 128, NULL, NULL, 233199),
(263173, '4lehC00', NULL, NULL, 185, NULL, NULL, 233199),
(263174, '3gzbH00', NULL, NULL, 137, NULL, NULL, 233199),
(263175, '3ehcB00', NULL, NULL, 128, NULL, NULL, 233199),
(263176, '3lzaA00', NULL, NULL, 141, NULL, NULL, 233199),
(263177, '3f40A00', NULL, NULL, 114, NULL, NULL, 233199),
(263178, '5evhA00', NULL, NULL, 127, NULL, NULL, 233199),
(263179, '3gzbD00', NULL, NULL, 137, NULL, NULL, 233199),
(263180, '3k0zA00', NULL, NULL, 159, NULL, NULL, 233199),
(263181, '3kztA00', NULL, NULL, 143, NULL, NULL, 233199),
(263182, '3gwrB00', NULL, NULL, 144, NULL, NULL, 233199),
(263183, '3hk4A00', NULL, NULL, 136, NULL, NULL, 233199),
(263184, '5if6A00', NULL, NULL, 134, NULL, NULL, 233199),
(263185, '3rgaA02', NULL, NULL, 150, NULL, NULL, 233199),
(263186, '3rgaA01', NULL, NULL, 133, NULL, NULL, 233199),
(263187, '2b1xB00', NULL, NULL, 172, NULL, NULL, 233199),
(263188, '2gexA00', NULL, NULL, 152, NULL, NULL, 233199),
(263189, '2qguA01', NULL, NULL, 101, NULL, NULL, 233199),
(263190, '3f7sA00', NULL, NULL, 142, NULL, NULL, 233199),
(263191, '1uliB00', NULL, NULL, 187, NULL, NULL, 233199),
(263192, '3dukA00', NULL, NULL, 125, NULL, NULL, 233199),
(263193, '3robA00', NULL, NULL, 139, NULL, NULL, 233199),
(263194, '3ejvA00', NULL, NULL, 159, NULL, NULL, 233199),
(263195, '2rcdA00', NULL, NULL, 129, NULL, NULL, 233199),
(263196, '3nv0A00', NULL, NULL, 205, NULL, NULL, 233199),
(263197, '3g0kA00', NULL, NULL, 128, NULL, NULL, 233199),
(263198, '3i0yA00', NULL, NULL, 140, NULL, NULL, 233199),
(263199, '4mjdA00', NULL, NULL, 113, NULL, NULL, 233199),
(263200, '3f7xA00', NULL, NULL, 151, NULL, NULL, 233199);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(263201, '4i4kA00', NULL, NULL, 143, NULL, NULL, 233199),
(263202, '5ui2A02', NULL, NULL, 128, NULL, NULL, 233199),
(263203, '4h3uA00', NULL, NULL, 133, NULL, NULL, 233199),
(263204, '1wqlB00', NULL, NULL, 186, NULL, NULL, 233199),
(263205, '2gbwB00', NULL, NULL, 174, NULL, NULL, 233199),
(263206, '4lmiB00', NULL, NULL, 139, NULL, NULL, 233199),
(263207, '1tuhA00', NULL, NULL, 131, NULL, NULL, 233199),
(263208, '6f54A00', NULL, NULL, 125, NULL, NULL, 233199),
(263209, '2i9wA00', NULL, NULL, 184, NULL, NULL, 233199),
(263210, '3ecfA00', NULL, NULL, 130, NULL, NULL, 233199),
(263211, '3ov4B00', NULL, NULL, 125, NULL, NULL, 233199),
(263212, '5iepA00', NULL, NULL, 137, NULL, NULL, 233199),
(263213, '2geyB00', NULL, NULL, 134, NULL, NULL, 233199),
(263214, '2k54A00', NULL, NULL, 123, NULL, NULL, 233199),
(263215, '5bvbA00', NULL, NULL, 132, NULL, NULL, 233199),
(263216, '3en8A01', NULL, NULL, 112, NULL, NULL, 233199),
(263217, '1q42A00', NULL, NULL, 179, NULL, NULL, 233199),
(263218, '6bjuA00', NULL, NULL, 132, NULL, NULL, 233199),
(263219, '4fcjA00', NULL, NULL, 142, NULL, NULL, 233199),
(263220, '1z1sA00', NULL, NULL, 163, NULL, NULL, 233199),
(263221, '1tp6A00', NULL, NULL, 128, NULL, NULL, 233199),
(263222, '4j8tA00', NULL, NULL, 137, NULL, NULL, 233199),
(263223, '1zo2A00', NULL, NULL, 129, NULL, NULL, 233199),
(263224, '3gzbC00', NULL, NULL, 154, NULL, NULL, 233199),
(263225, '3hx8A00', NULL, NULL, 129, NULL, NULL, 233199),
(263226, '3blzA00', NULL, NULL, 128, NULL, NULL, 233199),
(263227, '2bngC00', NULL, NULL, 149, NULL, NULL, 233199),
(263228, '3h3hB00', NULL, NULL, 122, NULL, NULL, 233199),
(263229, '3ebtA00', NULL, NULL, 132, NULL, NULL, 233199),
(263230, '3gzbG00', NULL, NULL, 154, NULL, NULL, 233199),
(263231, '6d34A00', NULL, NULL, 132, NULL, NULL, 233199),
(263232, '4r9kA00', NULL, NULL, 148, NULL, NULL, 233199),
(263233, '3fgyA00', NULL, NULL, 135, NULL, NULL, 233199),
(263234, '3hzpA00', NULL, NULL, 131, NULL, NULL, 233199),
(263235, '5ig5E00', NULL, NULL, 145, NULL, NULL, 233199),
(263236, '4ouqA00', NULL, NULL, 110, NULL, NULL, 233199),
(263237, '3er7B00', NULL, NULL, 131, NULL, NULL, 233199),
(263238, '5z3rF00', NULL, NULL, 145, NULL, NULL, 233199),
(263239, '3ff2A00', NULL, NULL, 117, NULL, NULL, 233199),
(263240, '4l8oA00', NULL, NULL, 169, NULL, NULL, 233199),
(263241, '3s5cA01', NULL, NULL, 139, NULL, NULL, 233199),
(263242, '1nu3A00', NULL, NULL, 149, NULL, NULL, 233199),
(263243, '3msoB00', NULL, NULL, 143, NULL, NULL, 233199),
(263244, '4lgqA00', NULL, NULL, 140, NULL, NULL, 233199),
(263245, '5aigA00', NULL, NULL, 125, NULL, NULL, 233199),
(263246, '3ujmA00', NULL, NULL, 120, NULL, NULL, 233199),
(263247, '5aiiH00', NULL, NULL, 135, NULL, NULL, 233199),
(263248, '2ux0A00', NULL, NULL, 143, NULL, NULL, 233199),
(263249, '3f8xB00', NULL, NULL, 132, NULL, NULL, 233199),
(263250, '1gy6A00', NULL, NULL, 127, NULL, NULL, 233199),
(263251, '3wmdA00', NULL, NULL, 144, NULL, NULL, 233199),
(263252, '3gzrB00', NULL, NULL, 146, NULL, NULL, 233199),
(263253, '3e99A00', NULL, NULL, 164, NULL, NULL, 233199),
(263254, '3f14A00', NULL, NULL, 112, NULL, NULL, 233199),
(263255, '5ig0A00', NULL, NULL, 148, NULL, NULL, 233199),
(263256, '5ienA00', NULL, NULL, 137, NULL, NULL, 233199),
(263257, '4llfD02', NULL, NULL, 120, NULL, NULL, 233200),
(263258, '2zahA02', NULL, NULL, 128, NULL, NULL, 233200),
(263259, '2ayxA01', NULL, NULL, 114, NULL, NULL, 233201),
(263260, '1b8tA02', NULL, NULL, 63, NULL, NULL, 233202),
(263261, '2mbvA00', NULL, NULL, 96, NULL, NULL, 233202),
(263262, '1b8tA01', NULL, NULL, 69, NULL, NULL, 233202),
(263263, '4jcjC02', NULL, NULL, 58, NULL, NULL, 233202),
(263264, '2d8yA01', NULL, NULL, 72, NULL, NULL, 233202),
(263265, '3ixeB00', NULL, NULL, 72, NULL, NULL, 233202),
(263266, '2o10A00', NULL, NULL, 60, NULL, NULL, 233202),
(263267, '1x3hA00', NULL, NULL, 80, NULL, NULL, 233202),
(263268, '1a7iA00', NULL, NULL, 81, NULL, NULL, 233202),
(263269, '1x68A00', NULL, NULL, 76, NULL, NULL, 233202),
(263270, '1x64A01', NULL, NULL, 63, NULL, NULL, 233202),
(263271, '1wyhA00', NULL, NULL, 72, NULL, NULL, 233202);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(263272, '2cuqA00', NULL, NULL, 80, NULL, NULL, 233202),
(263273, '2l4zA01', NULL, NULL, 65, NULL, NULL, 233202),
(263274, '2lzuA00', NULL, NULL, 72, NULL, NULL, 233202),
(263275, '2cu8A00', NULL, NULL, 76, NULL, NULL, 233202),
(263276, '4hi8B00', NULL, NULL, 72, NULL, NULL, 233202),
(263277, '2d8zA00', NULL, NULL, 70, NULL, NULL, 233202),
(263278, '1x4lA00', NULL, NULL, 72, NULL, NULL, 233202),
(263279, '2dj7A00', NULL, NULL, 80, NULL, NULL, 233202),
(263280, '2dloA00', NULL, NULL, 81, NULL, NULL, 233202),
(263281, '6cmeA02', NULL, NULL, 91, NULL, NULL, 233202),
(263282, '6cmeA01', NULL, NULL, 78, NULL, NULL, 233202),
(263283, '1m3vA00', NULL, NULL, 122, NULL, NULL, 233202),
(263284, '1x61A00', NULL, NULL, 72, NULL, NULL, 233202),
(263285, '1cxxA00', NULL, NULL, 59, NULL, NULL, 233202),
(263286, '2cupA01', NULL, NULL, 67, NULL, NULL, 233202),
(263287, '1v6gA00', NULL, NULL, 81, NULL, NULL, 233202),
(263288, '2iybE00', NULL, NULL, 65, NULL, NULL, 233202),
(263289, '1g47A00', NULL, NULL, 77, NULL, NULL, 233202),
(263290, '2xjyA02', NULL, NULL, 68, NULL, NULL, 233202),
(263291, '2xjyA01', NULL, NULL, 63, NULL, NULL, 233202),
(263292, '1x6aA01', NULL, NULL, 62, NULL, NULL, 233202),
(263293, '1j2oA00', NULL, NULL, 114, NULL, NULL, 233202),
(263294, '4jcjB01', NULL, NULL, 69, NULL, NULL, 233202),
(263295, '2miuA00', NULL, NULL, 98, NULL, NULL, 233202),
(263296, '2corA00', NULL, NULL, 79, NULL, NULL, 233202),
(263297, '2rgtB02', NULL, NULL, 61, NULL, NULL, 233202),
(263298, '2l6yB00', NULL, NULL, 96, NULL, NULL, 233202),
(263299, '2lxdA00', NULL, NULL, 125, NULL, NULL, 233202),
(263300, '2rgtB01', NULL, NULL, 66, NULL, NULL, 233202),
(263301, '2darA01', NULL, NULL, 72, NULL, NULL, 233202),
(263302, '1x62A01', NULL, NULL, 60, NULL, NULL, 233202),
(263303, '1rutX01', NULL, NULL, 93, NULL, NULL, 233202),
(263304, '1rutX02', NULL, NULL, 95, NULL, NULL, 233202),
(263305, '1imlA00', NULL, NULL, 76, NULL, NULL, 233202),
(263306, '1ctlA00', NULL, NULL, 85, NULL, NULL, 233202),
(263307, '1wigA00', NULL, NULL, 73, NULL, NULL, 233202),
(263308, '2d8xA00', NULL, NULL, 70, NULL, NULL, 233202),
(263309, '4kfzA01', NULL, NULL, 83, NULL, NULL, 233202),
(263310, '2eheA00', NULL, NULL, 82, NULL, NULL, 233202),
(263311, '1nypA00', NULL, NULL, 66, NULL, NULL, 233202),
(263312, '2o13A00', NULL, NULL, 58, NULL, NULL, 233202),
(263313, '2egqA00', NULL, NULL, 77, NULL, NULL, 233202),
(263314, '1x63A00', NULL, NULL, 82, NULL, NULL, 233202),
(263315, '2co8A00', NULL, NULL, 82, NULL, NULL, 233202),
(263316, '2xqnT01', NULL, NULL, 63, NULL, NULL, 233202),
(263317, '2curA00', NULL, NULL, 69, NULL, NULL, 233202),
(263318, '2e2fA00', NULL, NULL, 41, NULL, NULL, 233203),
(263319, '1knzA01', NULL, NULL, 108, NULL, NULL, 233204),
(263320, '3hjeA02', NULL, NULL, 115, NULL, NULL, 233205),
(263321, '5zcrA02', NULL, NULL, 132, NULL, NULL, 233205),
(263322, '1iv8A02', NULL, NULL, 118, NULL, NULL, 233205),
(263323, '1wihA00', NULL, NULL, 84, NULL, NULL, 233206),
(263324, '1ge9A02', NULL, NULL, 74, NULL, NULL, 233206),
(263325, '3lpxB02', NULL, NULL, 98, NULL, NULL, 233206),
(263326, '4fm9A04', NULL, NULL, 104, NULL, NULL, 233206),
(263327, '5cj9A02', NULL, NULL, 82, NULL, NULL, 233206),
(263328, '3foeA02', NULL, NULL, 97, NULL, NULL, 233206),
(263329, '5jvoA00', NULL, NULL, 79, NULL, NULL, 233206),
(263330, '1dd5A02', NULL, NULL, 75, NULL, NULL, 233206),
(263331, '3opfB01', NULL, NULL, 72, NULL, NULL, 233206),
(263332, '2zfzD00', NULL, NULL, 79, NULL, NULL, 233206),
(263333, '2kwaA00', NULL, NULL, 101, NULL, NULL, 233206),
(263334, '2phcB01', NULL, NULL, 84, NULL, NULL, 233206),
(263335, '1iseA02', NULL, NULL, 75, NULL, NULL, 233206),
(263336, '2p5mA00', NULL, NULL, 83, NULL, NULL, 233206),
(263337, '4ckkB02', NULL, NULL, 98, NULL, NULL, 233206),
(263338, '4gfqA02', NULL, NULL, 75, NULL, NULL, 233206),
(263339, '3l4jA04', NULL, NULL, 102, NULL, NULL, 233206),
(263340, '1is1A02', NULL, NULL, 75, NULL, NULL, 233206),
(263341, '4kddA02', NULL, NULL, 75, NULL, NULL, 233206),
(263342, '3va7A05', NULL, NULL, 100, NULL, NULL, 233206),
(263343, '3qx3B03', NULL, NULL, 104, NULL, NULL, 233206);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(263344, '3v4gA02', NULL, NULL, 86, NULL, NULL, 233206),
(263345, '1xxaC00', NULL, NULL, 78, NULL, NULL, 233206),
(263346, '6bq9A02', NULL, NULL, 94, NULL, NULL, 233206),
(263347, '1b4bA00', NULL, NULL, 71, NULL, NULL, 233206),
(263348, '2xcqA03', NULL, NULL, 98, NULL, NULL, 233206),
(263349, '4ddqA02', NULL, NULL, 97, NULL, NULL, 233206),
(263350, '1eh1A02', NULL, NULL, 75, NULL, NULL, 233206),
(263351, '3mmlF01', NULL, NULL, 79, NULL, NULL, 233206),
(263352, '4udxX01', NULL, NULL, 175, NULL, NULL, 233207),
(263353, '1jqkA03', NULL, NULL, 175, NULL, NULL, 233207),
(263354, '3i01A01', NULL, NULL, 177, NULL, NULL, 233207),
(263355, '6b6wA01', NULL, NULL, 179, NULL, NULL, 233207),
(263356, '6elqA01', NULL, NULL, 176, NULL, NULL, 233207),
(263357, '4by2B00', NULL, NULL, 165, NULL, NULL, 233208),
(263358, '4ld1A00', NULL, NULL, 184, NULL, NULL, 233208),
(263359, '2ksfA00', NULL, NULL, 107, NULL, NULL, 233209),
(263360, '1vajA01', NULL, NULL, 140, NULL, NULL, 233210),
(263361, '1zq7B01', NULL, NULL, 134, NULL, NULL, 233210),
(263362, '1wscB01', NULL, NULL, 154, NULL, NULL, 233210),
(263363, '1vs5D01', NULL, NULL, 112, NULL, NULL, 233211),
(263364, '1c05A01', NULL, NULL, 71, NULL, NULL, 233211),
(263365, '5o5jD01', NULL, NULL, 107, NULL, NULL, 233211),
(263366, '2vqeD01', NULL, NULL, 112, NULL, NULL, 233211),
(263367, '1fkaD01', NULL, NULL, 67, NULL, NULL, 233211),
(263368, '5mmjd01', NULL, NULL, 104, NULL, NULL, 233211),
(263369, '2fhzA00', NULL, NULL, 109, NULL, NULL, 233212),
(263370, '2zfuA01', NULL, NULL, 52, NULL, NULL, 233213),
(263371, '1d9xA03', NULL, NULL, 64, NULL, NULL, 233214),
(263372, '3v4rA03', NULL, NULL, 63, NULL, NULL, 233214),
(263373, '1d2mA03', NULL, NULL, 66, NULL, NULL, 233214),
(263374, '2zvfA01', NULL, NULL, 65, NULL, NULL, 233215),
(263375, '2gu0A02', NULL, NULL, 169, NULL, NULL, 233216),
(263376, '4g0aB02', NULL, NULL, 161, NULL, NULL, 233216),
(263377, '2m2fA00', NULL, NULL, 62, NULL, NULL, 233217),
(263378, '4e1tA00', NULL, NULL, 245, NULL, NULL, 233218),
(263379, '4e1sA00', NULL, NULL, 242, NULL, NULL, 233218),
(263380, '1m1eB01', NULL, NULL, 54, NULL, NULL, 233219),
(263381, '2zdjA00', NULL, NULL, 69, NULL, NULL, 233220),
(263382, '3ei3B01', NULL, NULL, 39, NULL, NULL, 233221),
(263383, '3ei4B01', NULL, NULL, 51, NULL, NULL, 233221),
(263384, '4bgbB01', NULL, NULL, 140, NULL, NULL, 233222),
(263385, '2jo7A00', NULL, NULL, 224, NULL, NULL, 233223),
(263386, '1oisA01', NULL, NULL, 92, NULL, NULL, 233224),
(263387, '2b9sA02', NULL, NULL, 87, NULL, NULL, 233224),
(263388, '1k4tA02', NULL, NULL, 88, NULL, NULL, 233224),
(263389, '5ml3B00', NULL, NULL, 149, NULL, NULL, 233225),
(263390, '1ksjB00', NULL, NULL, 152, NULL, NULL, 233225),
(263391, '3gqqF00', NULL, NULL, 195, NULL, NULL, 233225),
(263392, '2vxdA00', NULL, NULL, 54, NULL, NULL, 233226),
(263393, '3cf6E01', NULL, NULL, 55, NULL, NULL, 233227),
(263394, '3ufeA02', NULL, NULL, 53, NULL, NULL, 233228),
(263395, '2h7oA01', NULL, NULL, 152, NULL, NULL, 233229),
(263396, '1w59A01', NULL, NULL, 37, NULL, NULL, 233230),
(263397, '3tl4X01', NULL, NULL, 115, NULL, NULL, 233231),
(263398, '1pm4A00', NULL, NULL, 119, NULL, NULL, 233232),
(263399, '4i5tB00', NULL, NULL, 333, NULL, NULL, 233233),
(263400, '4narA01', NULL, NULL, 259, NULL, NULL, 233234),
(263401, '2yjgA02', NULL, NULL, 233, NULL, NULL, 233234),
(263402, '6c1wA02', NULL, NULL, 236, NULL, NULL, 233234),
(263403, '3c7fA01', NULL, NULL, 142, NULL, NULL, 233235),
(263404, '5ifpA05', NULL, NULL, 176, NULL, NULL, 233235),
(263405, '3w5mA04', NULL, NULL, 120, NULL, NULL, 233235),
(263406, '4qpwA00', NULL, NULL, 142, NULL, NULL, 233235),
(263407, '1lnsA04', NULL, NULL, 186, NULL, NULL, 233235),
(263408, '2wz8A00', NULL, NULL, 156, NULL, NULL, 233235),
(263409, '2w87A00', NULL, NULL, 139, NULL, NULL, 233235),
(263410, '2w1sA00', NULL, NULL, 139, NULL, NULL, 233235),
(263411, '2zexA00', NULL, NULL, 147, NULL, NULL, 233235),
(263412, '3w5mA02', NULL, NULL, 197, NULL, NULL, 233235),
(263413, '4iugA05', NULL, NULL, 176, NULL, NULL, 233235),
(263414, '4iugA04', NULL, NULL, 167, NULL, NULL, 233235); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(263415, '5ifpA04', NULL, NULL, 175, NULL, NULL, 233235),
(263416, '1gu3A00', NULL, NULL, 149, NULL, NULL, 233235),
(263417, '1wkyA02', NULL, NULL, 151, NULL, NULL, 233235),
(263418, '2rj2A00', NULL, NULL, 185, NULL, NULL, 233235),
(263419, '2c4xA02', NULL, NULL, 162, NULL, NULL, 233235),
(263420, '3skvA01', NULL, NULL, 157, NULL, NULL, 233235),
(263421, '1guiA00', NULL, NULL, 155, NULL, NULL, 233235),
(263422, '2id4A02', NULL, NULL, 138, NULL, NULL, 233235),
(263423, '1cx1A00', NULL, NULL, 153, NULL, NULL, 233235),
(263424, '6mvgA01', NULL, NULL, 150, NULL, NULL, 233235),
(263425, '3nruE00', NULL, NULL, 187, NULL, NULL, 233235),
(263426, '2dckA02', NULL, NULL, 119, NULL, NULL, 233235),
(263427, '3zyjB02', NULL, NULL, 244, NULL, NULL, 233235),
(263428, '4xurA00', NULL, NULL, 181, NULL, NULL, 233235),
(263429, '3thdA03', NULL, NULL, 137, NULL, NULL, 233235),
(263430, '2v72A00', NULL, NULL, 143, NULL, NULL, 233235),
(263431, '1k3iA01', NULL, NULL, 154, NULL, NULL, 233235),
(263432, '6bjqA01', NULL, NULL, 191, NULL, NULL, 233235),
(263433, '4a3zA00', NULL, NULL, 136, NULL, NULL, 233235),
(263434, '2waoA01', NULL, NULL, 120, NULL, NULL, 233235),
(263435, '3nngA00', NULL, NULL, 168, NULL, NULL, 233235),
(263436, '6mvhA01', NULL, NULL, 150, NULL, NULL, 233235),
(263437, '1j83A00', NULL, NULL, 180, NULL, NULL, 233235),
(263438, '1mpxA03', NULL, NULL, 238, NULL, NULL, 233235),
(263439, '5x7gA03', NULL, NULL, 130, NULL, NULL, 233235),
(263440, '3zm8A01', NULL, NULL, 135, NULL, NULL, 233235),
(263441, '4gwiA00', NULL, NULL, 153, NULL, NULL, 233235),
(263442, '1w99A02', NULL, NULL, 191, NULL, NULL, 233235),
(263443, '4txwA00', NULL, NULL, 173, NULL, NULL, 233235),
(263444, '3w5nA03', NULL, NULL, 167, NULL, NULL, 233235),
(263445, '1dlcA02', NULL, NULL, 158, NULL, NULL, 233235),
(263446, '3k4zA01', NULL, NULL, 162, NULL, NULL, 233235),
(263447, '3hnyM00', NULL, NULL, 159, NULL, NULL, 233235),
(263448, '3uesA02', NULL, NULL, 122, NULL, NULL, 233235),
(263449, '3etpA00', NULL, NULL, 187, NULL, NULL, 233235),
(263450, '2e26A01', NULL, NULL, 219, NULL, NULL, 233235),
(263451, '2j1aA00', NULL, NULL, 150, NULL, NULL, 233235),
(263452, '1uwwB00', NULL, NULL, 191, NULL, NULL, 233235),
(263453, '2e26A04', NULL, NULL, 157, NULL, NULL, 233235),
(263454, '2e26A03', NULL, NULL, 194, NULL, NULL, 233235),
(263455, '2e26A02', NULL, NULL, 155, NULL, NULL, 233235),
(263456, '3decA01', NULL, NULL, 221, NULL, NULL, 233235),
(263457, '2xomA00', NULL, NULL, 152, NULL, NULL, 233235),
(263458, '5t9gA01', NULL, NULL, 152, NULL, NULL, 233235),
(263459, '1cztA00', NULL, NULL, 160, NULL, NULL, 233235),
(263460, '2b9vA03', NULL, NULL, 234, NULL, NULL, 233235),
(263461, '2c9kA02', NULL, NULL, 164, NULL, NULL, 233235),
(263462, '1h6yA00', NULL, NULL, 170, NULL, NULL, 233235),
(263463, '2v4vA00', NULL, NULL, 129, NULL, NULL, 233235),
(263464, '3obaA01', NULL, NULL, 212, NULL, NULL, 233235),
(263465, '2hyxA02', NULL, NULL, 131, NULL, NULL, 233235),
(263466, '1od3A00', NULL, NULL, 133, NULL, NULL, 233235),
(263467, '4uapA00', NULL, NULL, 152, NULL, NULL, 233235),
(263468, '6nk1B00', NULL, NULL, 187, NULL, NULL, 233235),
(263469, '4aqsA01', NULL, NULL, 256, NULL, NULL, 233235),
(263470, '4bj0A00', NULL, NULL, 176, NULL, NULL, 233235),
(263471, '2vtfA02', NULL, NULL, 177, NULL, NULL, 233235),
(263472, '3achA00', NULL, NULL, 203, NULL, NULL, 233235),
(263473, '1gqpA00', NULL, NULL, 194, NULL, NULL, 233235),
(263474, '1w8oA03', NULL, NULL, 145, NULL, NULL, 233235),
(263475, '2je8A01', NULL, NULL, 196, NULL, NULL, 233235),
(263476, '2z4fA00', NULL, NULL, 173, NULL, NULL, 233235),
(263477, '2orzA01', NULL, NULL, 155, NULL, NULL, 233235),
(263478, '2orzA02', NULL, NULL, 159, NULL, NULL, 233235),
(263479, '1pmhX00', NULL, NULL, 185, NULL, NULL, 233235),
(263480, '3thdC02', NULL, NULL, 205, NULL, NULL, 233235),
(263481, '1ciyA03', NULL, NULL, 159, NULL, NULL, 233235),
(263482, '2j1vA00', NULL, NULL, 151, NULL, NULL, 233235),
(263483, '4lksA00', NULL, NULL, 167, NULL, NULL, 233235),
(263484, '4aqtA01', NULL, NULL, 276, NULL, NULL, 233235),
(263485, '5dq0A00', NULL, NULL, 162, NULL, NULL, 233235);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(263486, '4xuoA00', NULL, NULL, 159, NULL, NULL, 233235),
(263487, '2w5fB01', NULL, NULL, 159, NULL, NULL, 233235),
(263488, '2wn3A01', NULL, NULL, 155, NULL, NULL, 233235),
(263489, '4bxsV07', NULL, NULL, 160, NULL, NULL, 233235),
(263490, '4bxsV06', NULL, NULL, 156, NULL, NULL, 233235),
(263491, '5a57A04', NULL, NULL, 163, NULL, NULL, 233235),
(263492, '1p8jA02', NULL, NULL, 132, NULL, NULL, 233235),
(263493, '5fuiA00', NULL, NULL, 132, NULL, NULL, 233235),
(263494, '1jz7A01', NULL, NULL, 218, NULL, NULL, 233235),
(263495, '4a41A00', NULL, NULL, 139, NULL, NULL, 233235),
(263496, '4pqqA00', NULL, NULL, 156, NULL, NULL, 233235),
(263497, '4dxtA00', NULL, NULL, 198, NULL, NULL, 233235),
(263498, '5a57A05', NULL, NULL, 206, NULL, NULL, 233235),
(263499, '4qdqA02', NULL, NULL, 170, NULL, NULL, 233235),
(263500, '4cuaA00', NULL, NULL, 183, NULL, NULL, 233235),
(263501, '2j22A00', NULL, NULL, 148, NULL, NULL, 233235),
(263502, '5ak1A02', NULL, NULL, 167, NULL, NULL, 233235),
(263503, '4a4aA01', NULL, NULL, 135, NULL, NULL, 233235),
(263504, '4jx0A02', NULL, NULL, 143, NULL, NULL, 233235),
(263505, '4a42A00', NULL, NULL, 127, NULL, NULL, 233235),
(263506, '3bn6A00', NULL, NULL, 158, NULL, NULL, 233235),
(263507, '2l9lA00', NULL, NULL, 170, NULL, NULL, 233235),
(263508, '2y38A01', NULL, NULL, 240, NULL, NULL, 233235),
(263509, '5f7uA06', NULL, NULL, 126, NULL, NULL, 233235),
(263510, '3iiiA03', NULL, NULL, 181, NULL, NULL, 233235),
(263511, '2zxqA04', NULL, NULL, 159, NULL, NULL, 233235),
(263512, '2zxqA05', NULL, NULL, 198, NULL, NULL, 233235),
(263513, '6b6lA01', NULL, NULL, 163, NULL, NULL, 233235),
(263514, '3seeA00', NULL, NULL, 222, NULL, NULL, 233235),
(263515, '3gm8A01', NULL, NULL, 160, NULL, NULL, 233235),
(263516, '1uy4A00', NULL, NULL, 145, NULL, NULL, 233235),
(263517, '2vzsA01', NULL, NULL, 184, NULL, NULL, 233235),
(263518, '1tg7A04', NULL, NULL, 170, NULL, NULL, 233235),
(263519, '1tg7A05', NULL, NULL, 176, NULL, NULL, 233235),
(263520, '4mgqA01', NULL, NULL, 158, NULL, NULL, 233235),
(263521, '4pt6A00', NULL, NULL, 169, NULL, NULL, 233235),
(263522, '3f2zA00', NULL, NULL, 159, NULL, NULL, 233235),
(263523, '5jr2C00', NULL, NULL, 179, NULL, NULL, 233235),
(263524, '4e8dA03', NULL, NULL, 138, NULL, NULL, 233235),
(263525, '4e8dA02', NULL, NULL, 183, NULL, NULL, 233235),
(263526, '4mo3M00', NULL, NULL, 156, NULL, NULL, 233235),
(263527, '3nqhA02', NULL, NULL, 136, NULL, NULL, 233235),
(263528, '2jdaB00', NULL, NULL, 145, NULL, NULL, 233235),
(263529, '3eypA02', NULL, NULL, 132, NULL, NULL, 233235),
(263530, '4cu7A01', NULL, NULL, 169, NULL, NULL, 233235),
(263531, '4d0qA00', NULL, NULL, 169, NULL, NULL, 233235),
(263532, '1nkgA03', NULL, NULL, 172, NULL, NULL, 233235),
(263533, '3cihA02', NULL, NULL, 123, NULL, NULL, 233235),
(263534, '1k42A00', NULL, NULL, 168, NULL, NULL, 233235),
(263535, '3cihA01', NULL, NULL, 158, NULL, NULL, 233235),
(263536, '2bbaA00', NULL, NULL, 185, NULL, NULL, 233235),
(263537, '3lqcA00', NULL, NULL, 152, NULL, NULL, 233235),
(263538, '3p6bA00', NULL, NULL, 186, NULL, NULL, 233235),
(263539, '2wo1B00', NULL, NULL, 185, NULL, NULL, 233235),
(263540, '3bgaA01', NULL, NULL, 225, NULL, NULL, 233235),
(263541, '4d8mA02', NULL, NULL, 170, NULL, NULL, 233235),
(263542, '3wnoA03', NULL, NULL, 130, NULL, NULL, 233235),
(263543, '1uxzA00', NULL, NULL, 131, NULL, NULL, 233235),
(263544, '5z1aA01', NULL, NULL, 148, NULL, NULL, 233235),
(263545, '3og2A04', NULL, NULL, 178, NULL, NULL, 233235),
(263546, '1k12A00', NULL, NULL, 158, NULL, NULL, 233235),
(263547, '3og2A05', NULL, NULL, 178, NULL, NULL, 233235),
(263548, '3hn3D01', NULL, NULL, 204, NULL, NULL, 233235),
(263549, '4et7A00', NULL, NULL, 179, NULL, NULL, 233235),
(263550, '1oh4A00', NULL, NULL, 179, NULL, NULL, 233235),
(263551, '3jxsA00', NULL, NULL, 174, NULL, NULL, 233235),
(263552, '5c71A01', NULL, NULL, 179, NULL, NULL, 233235),
(263553, '2okxA01', NULL, NULL, 170, NULL, NULL, 233235),
(263554, '2okxA02', NULL, NULL, 170, NULL, NULL, 233235),
(263555, '2okxA03', NULL, NULL, 190, NULL, NULL, 233235),
(263556, '4devD01', NULL, NULL, 125, NULL, NULL, 233235);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(263557, '2y8kA02', NULL, NULL, 153, NULL, NULL, 233235),
(263558, '3wsoA02', NULL, NULL, 188, NULL, NULL, 233235),
(263559, '2ls6A00', NULL, NULL, 164, NULL, NULL, 233235),
(263560, '5y4mA00', NULL, NULL, 154, NULL, NULL, 233235),
(263561, '6fmcA00', NULL, NULL, 158, NULL, NULL, 233235),
(263562, '3wqbA02', NULL, NULL, 169, NULL, NULL, 233235),
(263563, '2vm9A01', NULL, NULL, 159, NULL, NULL, 233235),
(263564, '2wuhA00', NULL, NULL, 178, NULL, NULL, 233235),
(263565, '6ed1A01', NULL, NULL, 160, NULL, NULL, 233235),
(263566, '6mvfA01', NULL, NULL, 148, NULL, NULL, 233235),
(263567, '4pf1B03', NULL, NULL, 240, NULL, NULL, 233235),
(263568, '3gglA00', NULL, NULL, 169, NULL, NULL, 233235),
(263569, '2xqxA00', NULL, NULL, 151, NULL, NULL, 233235),
(263570, '1tvgA00', NULL, NULL, 153, NULL, NULL, 233235),
(263571, '4madA03', NULL, NULL, 134, NULL, NULL, 233235),
(263572, '4lhsA01', NULL, NULL, 154, NULL, NULL, 233235),
(263573, '4plmA01', NULL, NULL, 283, NULL, NULL, 233235),
(263574, '1w0nA00', NULL, NULL, 131, NULL, NULL, 233235),
(263575, '4ag4A01', NULL, NULL, 163, NULL, NULL, 233235),
(263576, '4lplA00', NULL, NULL, 142, NULL, NULL, 233235),
(263577, '6dj4A02', NULL, NULL, 169, NULL, NULL, 233235),
(263578, '5jxgA02', NULL, NULL, 132, NULL, NULL, 233235),
(263579, '4zy9A00', NULL, NULL, 137, NULL, NULL, 233235),
(263580, '3cqoA02', NULL, NULL, 145, NULL, NULL, 233235),
(263581, '3a21A03', NULL, NULL, 101, NULL, NULL, 233235),
(263582, '3gzaB02', NULL, NULL, 98, NULL, NULL, 233235),
(263583, '3cqoA01', NULL, NULL, 148, NULL, NULL, 233235),
(263584, '2w3jA00', NULL, NULL, 145, NULL, NULL, 233235),
(263585, '5b4nA00', NULL, NULL, 174, NULL, NULL, 233235),
(263586, '4madA02', NULL, NULL, 182, NULL, NULL, 233235),
(263587, '4jklA01', NULL, NULL, 180, NULL, NULL, 233235),
(263588, '1i5pA01', NULL, NULL, 158, NULL, NULL, 233235),
(263589, '2yc2A00', NULL, NULL, 139, NULL, NULL, 233235),
(263590, '2bgoA00', NULL, NULL, 123, NULL, NULL, 233235),
(263591, '4arxA02', NULL, NULL, 159, NULL, NULL, 233235),
(263592, '2cdpA00', NULL, NULL, 138, NULL, NULL, 233235),
(263593, '5t99A01', NULL, NULL, 158, NULL, NULL, 233235),
(263594, '3d3aA02', NULL, NULL, 182, NULL, NULL, 233235),
(263595, '4ypjA01', NULL, NULL, 165, NULL, NULL, 233235),
(263596, '1w9sA00', NULL, NULL, 142, NULL, NULL, 233235),
(263597, '3d3aA03', NULL, NULL, 134, NULL, NULL, 233235),
(263598, '1o59A02', NULL, NULL, 150, NULL, NULL, 233235),
(263599, '1o59A01', NULL, NULL, 186, NULL, NULL, 233235),
(263600, '1yq2A01', NULL, NULL, 219, NULL, NULL, 233235),
(263601, '2r7eB03', NULL, NULL, 155, NULL, NULL, 233235),
(263602, '4oveA01', NULL, NULL, 284, NULL, NULL, 233235),
(263603, '2w91A02', NULL, NULL, 182, NULL, NULL, 233235),
(263604, '2w47A00', NULL, NULL, 144, NULL, NULL, 233235),
(263605, '4qb6A00', NULL, NULL, 129, NULL, NULL, 233235),
(263606, '2zezC00', NULL, NULL, 144, NULL, NULL, 233235),
(263607, '3eb7A02', NULL, NULL, 164, NULL, NULL, 233235),
(263608, '3lpfA01', NULL, NULL, 182, NULL, NULL, 233235),
(263609, '4jkmA01', NULL, NULL, 184, NULL, NULL, 233235),
(263610, '5uj6A01', NULL, NULL, 152, NULL, NULL, 233235),
(263611, '4p02B03', NULL, NULL, 143, NULL, NULL, 233235),
(263612, '1sddB04', NULL, NULL, 160, NULL, NULL, 233235),
(263613, '1gnyA00', NULL, NULL, 153, NULL, NULL, 233235),
(263614, '4p02B01', NULL, NULL, 133, NULL, NULL, 233235),
(263615, '1jhjA00', NULL, NULL, 171, NULL, NULL, 233235),
(263616, '1sddB03', NULL, NULL, 161, NULL, NULL, 233235),
(263617, '3abzA03', NULL, NULL, 165, NULL, NULL, 233235),
(263618, '5dmyA01', NULL, NULL, 161, NULL, NULL, 233235),
(263619, '4zz5A00', NULL, NULL, 138, NULL, NULL, 233235),
(263620, '3tbdA02', NULL, NULL, 246, NULL, NULL, 233235),
(263621, '5n6uA01', NULL, NULL, 185, NULL, NULL, 233235),
(263622, '1ji6A02', NULL, NULL, 162, NULL, NULL, 233235),
(263623, '3i2kA03', NULL, NULL, 231, NULL, NULL, 233235),
(263624, '6bycA01', NULL, NULL, 207, NULL, NULL, 233235),
(263625, '2yfuA00', NULL, NULL, 155, NULL, NULL, 233235),
(263626, '4l0pA00', NULL, NULL, 176, NULL, NULL, 233235),
(263627, '3fn9A01', NULL, NULL, 161, NULL, NULL, 233235);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(263628, '2waaA01', NULL, NULL, 129, NULL, NULL, 233235),
(263629, '4cu9A00', NULL, NULL, 186, NULL, NULL, 233235),
(263630, '2dduA03', NULL, NULL, 161, NULL, NULL, 233235),
(263631, '3p1iA00', NULL, NULL, 174, NULL, NULL, 233235),
(263632, '4xvhA01', NULL, NULL, 107, NULL, NULL, 233235),
(263633, '2vzpB00', NULL, NULL, 127, NULL, NULL, 233235),
(263634, '2qqiA02', NULL, NULL, 159, NULL, NULL, 233235),
(263635, '3hnmA00', NULL, NULL, 172, NULL, NULL, 233235),
(263636, '4cvuA01', NULL, NULL, 199, NULL, NULL, 233235),
(263637, '2w9xB01', NULL, NULL, 107, NULL, NULL, 233235),
(263638, '1uxxX00', NULL, NULL, 133, NULL, NULL, 233235),
(263639, '2kjgA00', NULL, NULL, 99, NULL, NULL, 233236),
(263640, '6c80A03', NULL, NULL, 236, NULL, NULL, 233237),
(263641, '5fxdA03', NULL, NULL, 233, NULL, NULL, 233237),
(263642, '4mlaA03', NULL, NULL, 233, NULL, NULL, 233237),
(263643, '3js8A03', NULL, NULL, 274, NULL, NULL, 233237),
(263644, '4o95A03', NULL, NULL, 240, NULL, NULL, 233237),
(263645, '1w1oA03', NULL, NULL, 244, NULL, NULL, 233237),
(263646, '2exrA03', NULL, NULL, 238, NULL, NULL, 233237),
(263647, '2i0kA03', NULL, NULL, 291, NULL, NULL, 233237),
(263648, '1e8gA03', NULL, NULL, 231, NULL, NULL, 233237),
(263649, '1wvfA03', NULL, NULL, 231, NULL, NULL, 233237),
(263650, '4izkA00', NULL, NULL, 210, NULL, NULL, 233238),
(263651, '2pnlA00', NULL, NULL, 203, NULL, NULL, 233238),
(263652, '3p06A00', NULL, NULL, 194, NULL, NULL, 233238),
(263653, '4lo4B02', NULL, NULL, 152, NULL, NULL, 233239),
(263654, '4en6B02', NULL, NULL, 152, NULL, NULL, 233239),
(263655, '5nnsA00', NULL, NULL, 225, NULL, NULL, 233240),
(263656, '3ejaA00', NULL, NULL, 208, NULL, NULL, 233240),
(263657, '5achA00', NULL, NULL, 235, NULL, NULL, 233240),
(263658, '5nltA00', NULL, NULL, 224, NULL, NULL, 233240),
(263659, '3zudA00', NULL, NULL, 228, NULL, NULL, 233240),
(263660, '4b5qA00', NULL, NULL, 217, NULL, NULL, 233240),
(263661, '2vtcA00', NULL, NULL, 230, NULL, NULL, 233240),
(263662, '4fmrB01', NULL, NULL, 156, NULL, NULL, 233240),
(263663, '4maiA00', NULL, NULL, 216, NULL, NULL, 233240),
(263664, '4qi8A00', NULL, NULL, 214, NULL, NULL, 233240),
(263665, '6haqA00', NULL, NULL, 229, NULL, NULL, 233240),
(263666, '5o2xA00', NULL, NULL, 248, NULL, NULL, 233240),
(263667, '5fohA00', NULL, NULL, 223, NULL, NULL, 233240),
(263668, '5ufvA00', NULL, NULL, 238, NULL, NULL, 233240),
(263669, '4d7uA00', NULL, NULL, 227, NULL, NULL, 233240),
(263670, '4eisA00', NULL, NULL, 225, NULL, NULL, 233240),
(263671, '4eirA00', NULL, NULL, 223, NULL, NULL, 233240),
(263672, '4hkhA00', NULL, NULL, 169, NULL, NULL, 233241),
(263673, '3eaaA00', NULL, NULL, 163, NULL, NULL, 233241),
(263674, '5xeuC00', NULL, NULL, 161, NULL, NULL, 233241),
(263675, '5xhhA00', NULL, NULL, 161, NULL, NULL, 233241),
(263676, '4w64B00', NULL, NULL, 171, NULL, NULL, 233241),
(263677, '5mxn100', NULL, NULL, 170, NULL, NULL, 233241),
(263678, '6a2vE00', NULL, NULL, 171, NULL, NULL, 233241),
(263679, '3v4hA00', NULL, NULL, 158, NULL, NULL, 233241),
(263680, '1y12B00', NULL, NULL, 165, NULL, NULL, 233241),
(263681, '3he1A00', NULL, NULL, 172, NULL, NULL, 233241),
(263682, '4tv4A00', NULL, NULL, 160, NULL, NULL, 233241),
(263683, '3f1iH00', NULL, NULL, 98, NULL, NULL, 233242),
(263684, '3f1iS00', NULL, NULL, 77, NULL, NULL, 233242),
(263685, '2pjwV00', NULL, NULL, 91, NULL, NULL, 233242),
(263686, '2pjwH00', NULL, NULL, 88, NULL, NULL, 233242),
(263687, '2jbvA02', NULL, NULL, 71, NULL, NULL, 233243),
(263688, '1gpeA02', NULL, NULL, 64, NULL, NULL, 233243),
(263689, '3qvpA02', NULL, NULL, 64, NULL, NULL, 233243),
(263690, '1ywyA00', NULL, NULL, 74, NULL, NULL, 233244),
(263691, '4q28A00', NULL, NULL, 113, NULL, NULL, 233245),
(263692, '3bc1B00', NULL, NULL, 59, NULL, NULL, 233246),
(263693, '3u52E01', NULL, NULL, 104, NULL, NULL, 233247),
(263694, '3fzeA00', NULL, NULL, 196, NULL, NULL, 233248),
(263695, '4ntqA00', NULL, NULL, 76, NULL, NULL, 233249),
(263696, '2uv8G03', NULL, NULL, 108, NULL, NULL, 233250),
(263697, '2uvaG03', NULL, NULL, 108, NULL, NULL, 233250),
(263698, '1hfeS00', NULL, NULL, 88, NULL, NULL, 233251);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(263699, '4wpyA01', NULL, NULL, 80, NULL, NULL, 233252),
(263700, '2fggA01', NULL, NULL, 89, NULL, NULL, 233252),
(263701, '4dhiB02', NULL, NULL, 145, NULL, NULL, 233253),
(263702, '2zfyA02', NULL, NULL, 144, NULL, NULL, 233253),
(263703, '4fjvA02', NULL, NULL, 144, NULL, NULL, 233253),
(263704, '2g5cB02', NULL, NULL, 110, NULL, NULL, 233254),
(263705, '3b1fA02', NULL, NULL, 111, NULL, NULL, 233254),
(263706, '2pv7A02', NULL, NULL, 127, NULL, NULL, 233254),
(263707, '3ktdD02', NULL, NULL, 109, NULL, NULL, 233254),
(263708, '3dzbB02', NULL, NULL, 109, NULL, NULL, 233254),
(263709, '2f1kC02', NULL, NULL, 114, NULL, NULL, 233254),
(263710, '3dzbA02', NULL, NULL, 115, NULL, NULL, 233254),
(263711, '4e0pA02', NULL, NULL, 226, NULL, NULL, 233255),
(263712, '2v6eA03', NULL, NULL, 225, NULL, NULL, 233255),
(263713, '2vwaA00', NULL, NULL, 101, NULL, NULL, 233256),
(263714, '2l1qA00', NULL, NULL, 40, NULL, NULL, 233257),
(263715, '2a7kH02', NULL, NULL, 34, NULL, NULL, 233258),
(263716, '2a7kE02', NULL, NULL, 53, NULL, NULL, 233258),
(263717, '5o34A02', NULL, NULL, 32, NULL, NULL, 233258),
(263718, '1ezjA01', NULL, NULL, 63, NULL, NULL, 233259),
(263719, '1xsqB00', NULL, NULL, 168, NULL, NULL, 233260),
(263720, '2bdrA00', NULL, NULL, 175, NULL, NULL, 233260),
(263721, '2k87A00', NULL, NULL, 116, NULL, NULL, 233261),
(263722, '3r72A00', NULL, NULL, 122, NULL, NULL, 233262),
(263723, '3k1eA01', NULL, NULL, 107, NULL, NULL, 233262),
(263724, '1ow4A00', NULL, NULL, 129, NULL, NULL, 233262),
(263725, '3cz1A00', NULL, NULL, 119, NULL, NULL, 233262),
(263726, '3l4aA00', NULL, NULL, 141, NULL, NULL, 233262),
(263727, '1qwvA00', NULL, NULL, 142, NULL, NULL, 233262),
(263728, '1c3yA00', NULL, NULL, 108, NULL, NULL, 233262),
(263729, '3dxlA02', NULL, NULL, 156, NULL, NULL, 233262),
(263730, '3dxlA01', NULL, NULL, 147, NULL, NULL, 233262),
(263731, '3nhiA02', NULL, NULL, 147, NULL, NULL, 233262),
(263732, '3nhiA01', NULL, NULL, 149, NULL, NULL, 233262),
(263733, '4jd9G00', NULL, NULL, 122, NULL, NULL, 233262),
(263734, '2qebA00', NULL, NULL, 145, NULL, NULL, 233262),
(263735, '3q8iA00', NULL, NULL, 124, NULL, NULL, 233262),
(263736, '1dqeA00', NULL, NULL, 137, NULL, NULL, 233262),
(263737, '3v2lA00', NULL, NULL, 120, NULL, NULL, 233262),
(263738, '1tujA00', NULL, NULL, 123, NULL, NULL, 233262),
(263739, '1oohA00', NULL, NULL, 126, NULL, NULL, 233262),
(263740, '4ozdA00', NULL, NULL, 122, NULL, NULL, 233262),
(263741, '3r1vA00', NULL, NULL, 127, NULL, NULL, 233262),
(263742, '4pt1B00', NULL, NULL, 131, NULL, NULL, 233262),
(263743, '4inwA00', NULL, NULL, 140, NULL, NULL, 233262),
(263744, '2wcjA00', NULL, NULL, 141, NULL, NULL, 233262),
(263745, '3ognA01', NULL, NULL, 107, NULL, NULL, 233262),
(263746, '2erbA01', NULL, NULL, 107, NULL, NULL, 233262),
(263747, '3s0aA00', NULL, NULL, 119, NULL, NULL, 233262),
(263748, '5dicA00', NULL, NULL, 117, NULL, NULL, 233262),
(263749, '3v46A00', NULL, NULL, 170, NULL, NULL, 233263),
(263750, '4bxfA03', NULL, NULL, 139, NULL, NULL, 233264),
(263751, '4cckA03', NULL, NULL, 157, NULL, NULL, 233264),
(263752, '3venA03', NULL, NULL, 205, NULL, NULL, 233265),
(263753, '1wxqA02', NULL, NULL, 90, NULL, NULL, 233266),
(263754, '3a5pA00', NULL, NULL, 104, NULL, NULL, 233267),
(263755, '1c3gA02', NULL, NULL, 81, NULL, NULL, 233268),
(263756, '3agxA02', NULL, NULL, 81, NULL, NULL, 233268),
(263757, '1c3gA01', NULL, NULL, 78, NULL, NULL, 233268),
(263758, '4j80A02', NULL, NULL, 66, NULL, NULL, 233268),
(263759, '3agxA01', NULL, NULL, 84, NULL, NULL, 233268),
(263760, '4j80A03', NULL, NULL, 111, NULL, NULL, 233268),
(263761, '2q2gB02', NULL, NULL, 81, NULL, NULL, 233268),
(263762, '1earA01', NULL, NULL, 73, NULL, NULL, 233268),
(263763, '1xaoA01', NULL, NULL, 80, NULL, NULL, 233268),
(263764, '1gmuA02', NULL, NULL, 71, NULL, NULL, 233268),
(263765, '3lz8A01', NULL, NULL, 86, NULL, NULL, 233268),
(263766, '1nltA01', NULL, NULL, 87, NULL, NULL, 233268),
(263767, '3tj8A01', NULL, NULL, 75, NULL, NULL, 233268),
(263768, '3i38A01', NULL, NULL, 79, NULL, NULL, 233268),
(263769, '2q2gA01', NULL, NULL, 84, NULL, NULL, 233268);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(263770, '3lz8B02', NULL, NULL, 91, NULL, NULL, 233268),
(263771, '4l3kA01', NULL, NULL, 73, NULL, NULL, 233268),
(263772, '2fztA00', NULL, NULL, 79, NULL, NULL, 233269),
(263773, '3gf6A00', NULL, NULL, 224, NULL, NULL, 233270),
(263774, '3lm3A01', NULL, NULL, 313, NULL, NULL, 233271),
(263775, '1qu3A05', NULL, NULL, 92, NULL, NULL, 233272),
(263776, '1wz2A04', NULL, NULL, 88, NULL, NULL, 233272),
(263777, '3vvvA00', NULL, NULL, 123, NULL, NULL, 233273),
(263778, '5z7lA00', NULL, NULL, 117, NULL, NULL, 233273),
(263779, '4nlhB00', NULL, NULL, 115, NULL, NULL, 233273),
(263780, '2lfeA00', NULL, NULL, 106, NULL, NULL, 233273),
(263781, '5z7gB00', NULL, NULL, 121, NULL, NULL, 233273),
(263782, '3rqsB01', NULL, NULL, 33, NULL, NULL, 233274),
(263783, '4o8sA02', NULL, NULL, 107, NULL, NULL, 233275),
(263784, '4ok0B02', NULL, NULL, 105, NULL, NULL, 233275),
(263785, '3mwbA04', NULL, NULL, 24, NULL, NULL, 233276),
(263786, '2lwxA00', NULL, NULL, 88, NULL, NULL, 233277),
(263787, '4gmqA00', NULL, NULL, 103, NULL, NULL, 233277),
(263788, '2c0nA00', NULL, NULL, 203, NULL, NULL, 233278),
(263789, '6blqA01', NULL, NULL, 80, NULL, NULL, 233279),
(263790, '2iadB01', NULL, NULL, 88, NULL, NULL, 233279),
(263791, '1ktdB01', NULL, NULL, 118, NULL, NULL, 233279),
(263792, '1mujB01', NULL, NULL, 95, NULL, NULL, 233279),
(263793, '5ujtB01', NULL, NULL, 90, NULL, NULL, 233279),
(263794, '1iakA01', NULL, NULL, 80, NULL, NULL, 233279),
(263795, '1fv1B01', NULL, NULL, 92, NULL, NULL, 233279),
(263796, '4p5kB01', NULL, NULL, 112, NULL, NULL, 233279),
(263797, '4mdjB01', NULL, NULL, 93, NULL, NULL, 233279),
(263798, '4p23D01', NULL, NULL, 118, NULL, NULL, 233279),
(263799, '1a6aB01', NULL, NULL, 89, NULL, NULL, 233279),
(263800, '3lqzB01', NULL, NULL, 112, NULL, NULL, 233279),
(263801, '5ksaA01', NULL, NULL, 79, NULL, NULL, 233279),
(263802, '6bgaB01', NULL, NULL, 116, NULL, NULL, 233279),
(263803, '5ksvB01', NULL, NULL, 92, NULL, NULL, 233279),
(263804, '4mayB01', NULL, NULL, 94, NULL, NULL, 233279),
(263805, '1fneB01', NULL, NULL, 88, NULL, NULL, 233279),
(263806, '2p24A01', NULL, NULL, 80, NULL, NULL, 233279),
(263807, '6atfB01', NULL, NULL, 93, NULL, NULL, 233279),
(263808, '1uvqB01', NULL, NULL, 90, NULL, NULL, 233279),
(263809, '4p5mB01', NULL, NULL, 112, NULL, NULL, 233279),
(263810, '1k8iB01', NULL, NULL, 91, NULL, NULL, 233279),
(263811, '4ah2B01', NULL, NULL, 122, NULL, NULL, 233279),
(263812, '4x5wA01', NULL, NULL, 82, NULL, NULL, 233279),
(263813, '2icwA01', NULL, NULL, 79, NULL, NULL, 233279),
(263814, '4i0pD01', NULL, NULL, 88, NULL, NULL, 233279),
(263815, '3wexB01', NULL, NULL, 109, NULL, NULL, 233279),
(263816, '2bc4B01', NULL, NULL, 92, NULL, NULL, 233279),
(263817, '4p57D01', NULL, NULL, 112, NULL, NULL, 233279),
(263818, '1mujA01', NULL, NULL, 80, NULL, NULL, 233279),
(263819, '6blqB01', NULL, NULL, 88, NULL, NULL, 233279),
(263820, '5ujtA01', NULL, NULL, 80, NULL, NULL, 233279),
(263821, '1iakB01', NULL, NULL, 87, NULL, NULL, 233279),
(263822, '3o6fB01', NULL, NULL, 120, NULL, NULL, 233279),
(263823, '6cpoB01', NULL, NULL, 91, NULL, NULL, 233279),
(263824, '1iebB01', NULL, NULL, 122, NULL, NULL, 233279),
(263825, '3c5jB01', NULL, NULL, 93, NULL, NULL, 233279),
(263826, '5ni9B01', NULL, NULL, 91, NULL, NULL, 233279),
(263827, '5v4nC01', NULL, NULL, 117, NULL, NULL, 233279),
(263828, '6cpnB01', NULL, NULL, 93, NULL, NULL, 233279),
(263829, '4i0pC01', NULL, NULL, 80, NULL, NULL, 233279),
(263830, '1uvqA01', NULL, NULL, 80, NULL, NULL, 233279),
(263831, '1fneA01', NULL, NULL, 79, NULL, NULL, 233279),
(263832, '4d8pB01', NULL, NULL, 124, NULL, NULL, 233279),
(263833, '2p24B01', NULL, NULL, 87, NULL, NULL, 233279),
(263834, '4p5mA01', NULL, NULL, 81, NULL, NULL, 233279),
(263835, '6mffC01', NULL, NULL, 117, NULL, NULL, 233279),
(263836, '4x5wB01', NULL, NULL, 93, NULL, NULL, 233279),
(263837, '2q6wB01', NULL, NULL, 93, NULL, NULL, 233279),
(263838, '1k8iA01', NULL, NULL, 87, NULL, NULL, 233279),
(263839, '2bc4C01', NULL, NULL, 91, NULL, NULL, 233279),
(263840, '5v4mC01', NULL, NULL, 117, NULL, NULL, 233279);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(263841, '3my2A00', NULL, NULL, 133, NULL, NULL, 233280),
(263842, '2r19A00', NULL, NULL, 138, NULL, NULL, 233280),
(263843, '4uu4A00', NULL, NULL, 150, NULL, NULL, 233280),
(263844, '6bq9A01', NULL, NULL, 278, NULL, NULL, 233281),
(263845, '3l4jA03', NULL, NULL, 184, NULL, NULL, 233281),
(263846, '4z4qA02', NULL, NULL, 286, NULL, NULL, 233281),
(263847, '4ddqF01', NULL, NULL, 282, NULL, NULL, 233281),
(263848, '3lpxA01', NULL, NULL, 278, NULL, NULL, 233281),
(263849, '2xcqA02', NULL, NULL, 274, NULL, NULL, 233281),
(263850, '4fm9A03', NULL, NULL, 184, NULL, NULL, 233281),
(263851, '1bjtA05', NULL, NULL, 249, NULL, NULL, 233281),
(263852, '4ckkB01', NULL, NULL, 271, NULL, NULL, 233281),
(263853, '3foeA01', NULL, NULL, 292, NULL, NULL, 233281),
(263854, '3qx3A02', NULL, NULL, 244, NULL, NULL, 233281),
(263855, '5tuuA00', NULL, NULL, 155, NULL, NULL, 233282),
(263856, '4hj1C03', NULL, NULL, 95, NULL, NULL, 233283),
(263857, '1nxiA00', NULL, NULL, 132, NULL, NULL, 233284),
(263858, '1djxA02', NULL, NULL, 289, NULL, NULL, 233285),
(263859, '3mz2A00', NULL, NULL, 292, NULL, NULL, 233285),
(263860, '3ks6A00', NULL, NULL, 250, NULL, NULL, 233285),
(263861, '2otdA01', NULL, NULL, 228, NULL, NULL, 233285),
(263862, '2zkmX03', NULL, NULL, 312, NULL, NULL, 233285),
(263863, '5t9cE00', NULL, NULL, 268, NULL, NULL, 233285),
(263864, '2plcA00', NULL, NULL, 274, NULL, NULL, 233285),
(263865, '3ea1A00', NULL, NULL, 298, NULL, NULL, 233285),
(263866, '4i90A00', NULL, NULL, 303, NULL, NULL, 233285),
(263867, '3rlgA00', NULL, NULL, 279, NULL, NULL, 233285),
(263868, '1ydyA00', NULL, NULL, 328, NULL, NULL, 233285),
(263869, '2o55A00', NULL, NULL, 258, NULL, NULL, 233285),
(263870, '3h4xA00', NULL, NULL, 315, NULL, NULL, 233285),
(263871, '2oogD00', NULL, NULL, 287, NULL, NULL, 233285),
(263872, '4oecA00', NULL, NULL, 248, NULL, NULL, 233285),
(263873, '3no3A00', NULL, NULL, 238, NULL, NULL, 233285),
(263874, '3qr0A03', NULL, NULL, 276, NULL, NULL, 233285),
(263875, '1xx1A00', NULL, NULL, 285, NULL, NULL, 233285),
(263876, '2pz0B00', NULL, NULL, 252, NULL, NULL, 233285),
(263877, '4q6xA00', NULL, NULL, 278, NULL, NULL, 233285),
(263878, '3qvqA00', NULL, NULL, 252, NULL, NULL, 233285),
(263879, '4r7oA00', NULL, NULL, 292, NULL, NULL, 233285),
(263880, '1vd6A00', NULL, NULL, 224, NULL, NULL, 233285),
(263881, '3ch0A00', NULL, NULL, 272, NULL, NULL, 233285),
(263882, '3ohmB03', NULL, NULL, 301, NULL, NULL, 233285),
(263883, '1zccA00', NULL, NULL, 248, NULL, NULL, 233285),
(263884, '3l12B00', NULL, NULL, 313, NULL, NULL, 233285),
(263885, '1o1zA00', NULL, NULL, 234, NULL, NULL, 233285),
(263886, '3i10A00', NULL, NULL, 278, NULL, NULL, 233285),
(263887, '2a6hC02', NULL, NULL, 339, NULL, NULL, 233286),
(263888, '1ynjC02', NULL, NULL, 337, NULL, NULL, 233286),
(263889, '4ljzI02', NULL, NULL, 333, NULL, NULL, 233286),
(263890, '1ou5A02', NULL, NULL, 204, NULL, NULL, 233287),
(263891, '3aqlA02', NULL, NULL, 252, NULL, NULL, 233287),
(263892, '3h38A02', NULL, NULL, 265, NULL, NULL, 233287),
(263893, '4wbyA02', NULL, NULL, 262, NULL, NULL, 233287),
(263894, '4wz8B02', NULL, NULL, 66, NULL, NULL, 233288),
(263895, '3tdcA02', NULL, NULL, 66, NULL, NULL, 233288),
(263896, '2x24A02', NULL, NULL, 66, NULL, NULL, 233288),
(263897, '4asiA02', NULL, NULL, 66, NULL, NULL, 233288),
(263898, '3nzpB03', NULL, NULL, 93, NULL, NULL, 233289),
(263899, '3n2oA03', NULL, NULL, 96, NULL, NULL, 233289),
(263900, '3nzqA03', NULL, NULL, 96, NULL, NULL, 233289),
(263901, '1lgpA00', NULL, NULL, 116, NULL, NULL, 233290),
(263902, '4a0eA00', NULL, NULL, 123, NULL, NULL, 233290),
(263903, '3gqsB00', NULL, NULL, 106, NULL, NULL, 233290),
(263904, '3va4A00', NULL, NULL, 113, NULL, NULL, 233290),
(263905, '2kklA00', NULL, NULL, 140, NULL, NULL, 233290),
(263906, '3fm8A00', NULL, NULL, 98, NULL, NULL, 233290),
(263907, '1g3gA00', NULL, NULL, 164, NULL, NULL, 233290),
(263908, '4h87A00', NULL, NULL, 130, NULL, NULL, 233290),
(263909, '6c4uD00', NULL, NULL, 134, NULL, NULL, 233290),
(263910, '2eh0A01', NULL, NULL, 111, NULL, NULL, 233290),
(263911, '1wv3A01', NULL, NULL, 77, NULL, NULL, 233290);
INSERT INTO "PUBLIC"."MODEL" VALUES
(263912, '2jpeA00', NULL, NULL, 140, NULL, NULL, 233290),
(263913, '3po8A00', NULL, NULL, 100, NULL, NULL, 233290),
(263914, '3uotA00', NULL, NULL, 122, NULL, NULL, 233290),
(263915, '3i0nA01', NULL, NULL, 116, NULL, NULL, 233290),
(263916, '3i0nB01', NULL, NULL, 116, NULL, NULL, 233290),
(263917, '3vpyA00', NULL, NULL, 145, NULL, NULL, 233290),
(263918, '1r21A00', NULL, NULL, 108, NULL, NULL, 233290),
(263919, '5a8iA00', NULL, NULL, 118, NULL, NULL, 233290),
(263920, '2jqjA01', NULL, NULL, 132, NULL, NULL, 233290),
(263921, '3elsA00', NULL, NULL, 158, NULL, NULL, 233290),
(263922, '2kfuA01', NULL, NULL, 93, NULL, NULL, 233290),
(263923, '1wlnA00', NULL, NULL, 120, NULL, NULL, 233290),
(263924, '2pieA01', NULL, NULL, 132, NULL, NULL, 233290),
(263925, '1yjmA00', NULL, NULL, 110, NULL, NULL, 233290),
(263926, '4qcjA01', NULL, NULL, 97, NULL, NULL, 233290),
(263927, '1g6gB00', NULL, NULL, 127, NULL, NULL, 233290),
(263928, '3hufA01', NULL, NULL, 116, NULL, NULL, 233290),
(263929, '5w7wT01', NULL, NULL, 102, NULL, NULL, 233290),
(263930, '4ejqA02', NULL, NULL, 117, NULL, NULL, 233290),
(263931, '2g1lA00', NULL, NULL, 104, NULL, NULL, 233290),
(263932, '1mzkA00', NULL, NULL, 139, NULL, NULL, 233290),
(263933, '1dmzA00', NULL, NULL, 158, NULL, NULL, 233290),
(263934, '4g2sA00', NULL, NULL, 111, NULL, NULL, 233290),
(263935, '2kb3A01', NULL, NULL, 120, NULL, NULL, 233290),
(263936, '2brfA00', NULL, NULL, 110, NULL, NULL, 233290),
(263937, '3kt9A00', NULL, NULL, 102, NULL, NULL, 233290),
(263938, '1uhtA00', NULL, NULL, 118, NULL, NULL, 233290),
(263939, '5djoA02', NULL, NULL, 109, NULL, NULL, 233290),
(263940, '2ff4A03', NULL, NULL, 100, NULL, NULL, 233290),
(263941, '1wv3A02', NULL, NULL, 109, NULL, NULL, 233290),
(263942, '4jonC00', NULL, NULL, 127, NULL, NULL, 233290),
(263943, '3hx1B00', NULL, NULL, 131, NULL, NULL, 233290),
(263944, '6i2sB01', NULL, NULL, 104, NULL, NULL, 233290),
(263945, '3uv0B00', NULL, NULL, 102, NULL, NULL, 233290),
(263946, '1gxcA00', NULL, NULL, 121, NULL, NULL, 233290),
(263947, '3b0zA00', NULL, NULL, 52, NULL, NULL, 233291),
(263948, '4bofA02', NULL, NULL, 87, NULL, NULL, 233292),
(263949, '2a9gA02', NULL, NULL, 85, NULL, NULL, 233292),
(263950, '4e4jA02', NULL, NULL, 77, NULL, NULL, 233292),
(263951, '1s9rA02', NULL, NULL, 78, NULL, NULL, 233292),
(263952, '4e1oA01', NULL, NULL, 86, NULL, NULL, 233293),
(263953, '1js3A01', NULL, NULL, 81, NULL, NULL, 233293),
(263954, '3rchA01', NULL, NULL, 81, NULL, NULL, 233293),
(263955, '3k40A01', NULL, NULL, 81, NULL, NULL, 233293),
(263956, '3iv6A02', NULL, NULL, 65, NULL, NULL, 233294),
(263957, '3hg9A01', NULL, NULL, 85, NULL, NULL, 233295),
(263958, '4zemA02', NULL, NULL, 197, NULL, NULL, 233296),
(263959, '2yvkA02', NULL, NULL, 205, NULL, NULL, 233296),
(263960, '1vb5B02', NULL, NULL, 181, NULL, NULL, 233296),
(263961, '1t5oA02', NULL, NULL, 209, NULL, NULL, 233296),
(263962, '5yfjA02', NULL, NULL, 201, NULL, NULL, 233296),
(263963, '6a34A02', NULL, NULL, 208, NULL, NULL, 233296),
(263964, '4zeoH02', NULL, NULL, 179, NULL, NULL, 233296),
(263965, '1w2wB00', NULL, NULL, 191, NULL, NULL, 233296),
(263966, '1t9kA02', NULL, NULL, 203, NULL, NULL, 233296),
(263967, '2a0uA02', NULL, NULL, 207, NULL, NULL, 233296),
(263968, '3ecsD02', NULL, NULL, 211, NULL, NULL, 233296),
(263969, '4ldrB02', NULL, NULL, 210, NULL, NULL, 233296),
(263970, '3a11B02', NULL, NULL, 201, NULL, NULL, 233296),
(263971, '1td6A03', NULL, NULL, 96, NULL, NULL, 233297),
(263972, '3l1nA01', NULL, NULL, 51, NULL, NULL, 233298),
(263973, '3gipA03', NULL, NULL, 57, NULL, NULL, 233299),
(263974, '1rk6A03', NULL, NULL, 57, NULL, NULL, 233299),
(263975, '4xotA03', NULL, NULL, 86, NULL, NULL, 233300),
(263976, '2q8vB00', NULL, NULL, 63, NULL, NULL, 233301),
(263977, '3cs5A00', NULL, NULL, 59, NULL, NULL, 233301),
(263978, '1ojhA00', NULL, NULL, 65, NULL, NULL, 233301),
(263979, '2wzpR01', NULL, NULL, 196, NULL, NULL, 233302),
(263980, '2jsxA01', NULL, NULL, 71, NULL, NULL, 233303),
(263981, '2zbcA01', NULL, NULL, 74, NULL, NULL, 233303),
(263982, '2pn6A02', NULL, NULL, 98, NULL, NULL, 233303);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(263983, '2zbcC01', NULL, NULL, 74, NULL, NULL, 233303),
(263984, '2zbcB01', NULL, NULL, 74, NULL, NULL, 233303),
(263985, '2zbcE01', NULL, NULL, 74, NULL, NULL, 233303),
(263986, '2zbcD01', NULL, NULL, 74, NULL, NULL, 233303),
(263987, '2zbcG01', NULL, NULL, 74, NULL, NULL, 233303),
(263988, '2zbcF01', NULL, NULL, 74, NULL, NULL, 233303),
(263989, '2cviA01', NULL, NULL, 74, NULL, NULL, 233303),
(263990, '2gqqA02', NULL, NULL, 85, NULL, NULL, 233303),
(263991, '3i4pA02', NULL, NULL, 84, NULL, NULL, 233303),
(263992, '2djwA01', NULL, NULL, 74, NULL, NULL, 233303),
(263993, '2ia0B02', NULL, NULL, 104, NULL, NULL, 233303),
(263994, '2cg4A02', NULL, NULL, 84, NULL, NULL, 233303),
(263995, '2p5vA02', NULL, NULL, 84, NULL, NULL, 233303),
(263996, '4pcqA02', NULL, NULL, 84, NULL, NULL, 233303),
(263997, '1i1gA02', NULL, NULL, 77, NULL, NULL, 233303),
(263998, '2zbcH01', NULL, NULL, 74, NULL, NULL, 233303),
(263999, '2w25A02', NULL, NULL, 81, NULL, NULL, 233303),
(264000, '2cyyA02', NULL, NULL, 95, NULL, NULL, 233303),
(264001, '2cfxA02', NULL, NULL, 94, NULL, NULL, 233303),
(264002, '2dbbA02', NULL, NULL, 93, NULL, NULL, 233303),
(264003, '1sd4A02', NULL, NULL, 54, NULL, NULL, 233304),
(264004, '1okrA02', NULL, NULL, 51, NULL, NULL, 233304),
(264005, '2lycA00', NULL, NULL, 130, NULL, NULL, 233305),
(264006, '4c9yA00', NULL, NULL, 123, NULL, NULL, 233305),
(264007, '3k1tA02', NULL, NULL, 139, NULL, NULL, 233306),
(264008, '6f7iB02', NULL, NULL, 148, NULL, NULL, 233307),
(264009, '3uoaB02', NULL, NULL, 148, NULL, NULL, 233307),
(264010, '2q2kA00', NULL, NULL, 48, NULL, NULL, 233308),
(264011, '4pn0C00', NULL, NULL, 264, NULL, NULL, 233309),
(264012, '1d8hA00', NULL, NULL, 311, NULL, NULL, 233309),
(264013, '3bgyA00', NULL, NULL, 237, NULL, NULL, 233309),
(264014, '1m55A00', NULL, NULL, 197, NULL, NULL, 233310),
(264015, '4fb3A00', NULL, NULL, 122, NULL, NULL, 233310),
(264016, '4kw3A00', NULL, NULL, 271, NULL, NULL, 233310),
(264017, '1l2mA00', NULL, NULL, 118, NULL, NULL, 233310),
(264018, '5bygD00', NULL, NULL, 213, NULL, NULL, 233310),
(264019, '6h8oA00', NULL, NULL, 95, NULL, NULL, 233310),
(264020, '2fufA00', NULL, NULL, 134, NULL, NULL, 233310),
(264021, '3qfqB00', NULL, NULL, 135, NULL, NULL, 233310),
(264022, '2iprA00', NULL, NULL, 133, NULL, NULL, 233310),
(264023, '4nbpA00', NULL, NULL, 132, NULL, NULL, 233310),
(264024, '5xorB00', NULL, NULL, 112, NULL, NULL, 233310),
(264025, '3amuA02', NULL, NULL, 150, NULL, NULL, 233311),
(264026, '3au7A02', NULL, NULL, 112, NULL, NULL, 233311),
(264027, '4gywC04', NULL, NULL, 134, NULL, NULL, 233312),
(264028, '5a01A03', NULL, NULL, 126, NULL, NULL, 233312),
(264029, '1q5zA00', NULL, NULL, 157, NULL, NULL, 233313),
(264030, '2jhpA03', NULL, NULL, 121, NULL, NULL, 233314),
(264031, '1q16B03', NULL, NULL, 77, NULL, NULL, 233315),
(264032, '1jfwA00', NULL, NULL, 86, NULL, NULL, 233316),
(264033, '1tacA00', NULL, NULL, 86, NULL, NULL, 233316),
(264034, '1k5kA00', NULL, NULL, 87, NULL, NULL, 233316),
(264035, '1tbcA00', NULL, NULL, 86, NULL, NULL, 233316),
(264036, '2k7iA01', NULL, NULL, 48, NULL, NULL, 233317),
(264037, '3bidA01', NULL, NULL, 47, NULL, NULL, 233317),
(264038, '3iu0A00', NULL, NULL, 382, NULL, NULL, 233318),
(264039, '4djbA00', NULL, NULL, 130, NULL, NULL, 233319),
(264040, '2haxA02', NULL, NULL, 23, NULL, NULL, 233320),
(264041, '3ighX03', NULL, NULL, 102, NULL, NULL, 233321),
(264042, '3icjA03', NULL, NULL, 102, NULL, NULL, 233321),
(264043, '1oqcA00', NULL, NULL, 125, NULL, NULL, 233322),
(264044, '3mbgA00', NULL, NULL, 112, NULL, NULL, 233322),
(264045, '1jr8A00', NULL, NULL, 117, NULL, NULL, 233322),
(264046, '3t58C04', NULL, NULL, 153, NULL, NULL, 233322),
(264047, '3gwnA00', NULL, NULL, 114, NULL, NULL, 233322),
(264048, '3llkA02', NULL, NULL, 156, NULL, NULL, 233322),
(264049, '3gwlA00', NULL, NULL, 106, NULL, NULL, 233322),
(264050, '4e0hA00', NULL, NULL, 106, NULL, NULL, 233322),
(264051, '2hj3A00', NULL, NULL, 107, NULL, NULL, 233322),
(264052, '2zrrA00', NULL, NULL, 89, NULL, NULL, 233323),
(264053, '2k19A00', NULL, NULL, 98, NULL, NULL, 233323);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(264054, '2ip6A00', NULL, NULL, 93, NULL, NULL, 233323),
(264055, '2k37A00', NULL, NULL, 59, NULL, NULL, 233324),
(264056, '4fhdA02', NULL, NULL, 227, NULL, NULL, 233325),
(264057, '4dglB01', NULL, NULL, 102, NULL, NULL, 233326),
(264058, '1qf8A01', NULL, NULL, 107, NULL, NULL, 233326),
(264059, '2h8eA00', NULL, NULL, 120, NULL, NULL, 233327),
(264060, '1cfrA00', NULL, NULL, 285, NULL, NULL, 233328),
(264061, '1dc1A01', NULL, NULL, 235, NULL, NULL, 233328),
(264062, '3dvoA00', NULL, NULL, 338, NULL, NULL, 233328),
(264063, '1knvB00', NULL, NULL, 293, NULL, NULL, 233328),
(264064, '5b1cA00', NULL, NULL, 107, NULL, NULL, 233329),
(264065, '3uypB00', NULL, NULL, 114, NULL, NULL, 233329),
(264066, '3muuA04', NULL, NULL, 100, NULL, NULL, 233329),
(264067, '6j5fA00', NULL, NULL, 101, NULL, NULL, 233329),
(264068, '6dfjE00', NULL, NULL, 99, NULL, NULL, 233329),
(264069, '5kvfE00', NULL, NULL, 110, NULL, NULL, 233329),
(264070, '5lbsB04', NULL, NULL, 114, NULL, NULL, 233329),
(264071, '5jhmB04', NULL, NULL, 115, NULL, NULL, 233329),
(264072, '3n40F03', NULL, NULL, 100, NULL, NULL, 233329),
(264073, '6a0pA04', NULL, NULL, 116, NULL, NULL, 233329),
(264074, '6j5dA00', NULL, NULL, 101, NULL, NULL, 233329),
(264075, '4bz2A00', NULL, NULL, 101, NULL, NULL, 233329),
(264076, '6iw4A04', NULL, NULL, 103, NULL, NULL, 233329),
(264077, '6ivzA04', NULL, NULL, 103, NULL, NULL, 233329),
(264078, '6epkA04', NULL, NULL, 115, NULL, NULL, 233329),
(264079, '4fg0A04', NULL, NULL, 110, NULL, NULL, 233329),
(264080, '4utaB04', NULL, NULL, 104, NULL, NULL, 233329),
(264081, '1ztxE00', NULL, NULL, 108, NULL, NULL, 233329),
(264082, '1ok8A04', NULL, NULL, 100, NULL, NULL, 233329),
(264083, '5lcvB04', NULL, NULL, 123, NULL, NULL, 233329),
(264084, '2v33A00', NULL, NULL, 91, NULL, NULL, 233329),
(264085, '1pjwA00', NULL, NULL, 111, NULL, NULL, 233329),
(264086, '1z66A00', NULL, NULL, 96, NULL, NULL, 233329),
(264087, '3vttA00', NULL, NULL, 107, NULL, NULL, 233329),
(264088, '5mv2A04', NULL, NULL, 110, NULL, NULL, 233329),
(264089, '6j5gA04', NULL, NULL, 104, NULL, NULL, 233329),
(264090, '2hg0A04', NULL, NULL, 111, NULL, NULL, 233329),
(264091, '3uzqB00', NULL, NULL, 114, NULL, NULL, 233329),
(264092, '4al8C00', NULL, NULL, 101, NULL, NULL, 233329),
(264093, '5n09A04', NULL, NULL, 100, NULL, NULL, 233329),
(264094, '2p5pA00', NULL, NULL, 117, NULL, NULL, 233329),
(264095, '1z3rA00', NULL, NULL, 99, NULL, NULL, 233329),
(264096, '4x42B00', NULL, NULL, 107, NULL, NULL, 233329),
(264097, '1zgwA01', NULL, NULL, 77, NULL, NULL, 233330),
(264098, '1wpkA01', NULL, NULL, 72, NULL, NULL, 233330),
(264099, '1u8bA01', NULL, NULL, 71, NULL, NULL, 233330),
(264100, '2hlyA00', NULL, NULL, 207, NULL, NULL, 233331),
(264101, '4gczA02', NULL, NULL, 26, NULL, NULL, 233332),
(264102, '3mkoA00', NULL, NULL, 121, NULL, NULL, 233333),
(264103, '1yvuA02', NULL, NULL, 93, NULL, NULL, 233334),
(264104, '1v5eA04', NULL, NULL, 48, NULL, NULL, 233335),
(264105, '5m59A10', NULL, NULL, 142, NULL, NULL, 233336),
(264106, '3im2A01', NULL, NULL, 133, NULL, NULL, 233336),
(264107, '5dcaA06', NULL, NULL, 130, NULL, NULL, 233336),
(264108, '4f92B04', NULL, NULL, 142, NULL, NULL, 233336),
(264109, '2q0zX01', NULL, NULL, 117, NULL, NULL, 233336),
(264110, '3im1A01', NULL, NULL, 141, NULL, NULL, 233336),
(264111, '5m59A04', NULL, NULL, 142, NULL, NULL, 233336),
(264112, '4l9bA02', NULL, NULL, 218, NULL, NULL, 233337),
(264113, '3ep6A00', NULL, NULL, 260, NULL, NULL, 233338),
(264114, '1i7mA00', NULL, NULL, 267, NULL, NULL, 233338),
(264115, '2iiiA00', NULL, NULL, 135, NULL, NULL, 233338),
(264116, '5tvoA00', NULL, NULL, 284, NULL, NULL, 233338),
(264117, '1vr7A00', NULL, NULL, 142, NULL, NULL, 233338),
(264118, '1mhmA00', NULL, NULL, 265, NULL, NULL, 233338),
(264119, '1jl0A00', NULL, NULL, 334, NULL, NULL, 233338),
(264120, '3n6rA03', NULL, NULL, 133, NULL, NULL, 233339),
(264121, '2ys0A00', NULL, NULL, 56, NULL, NULL, 233340),
(264122, '5dltA02', NULL, NULL, 46, NULL, NULL, 233340),
(264123, '3nkqA01', NULL, NULL, 59, NULL, NULL, 233340),
(264124, '1xtcC00', NULL, NULL, 46, NULL, NULL, 233341);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(264125, '1ltsC00', NULL, NULL, 41, NULL, NULL, 233341),
(264126, '4p04A01', NULL, NULL, 106, NULL, NULL, 233342),
(264127, '3fegA02', NULL, NULL, 272, NULL, NULL, 233343),
(264128, '1nw1A02', NULL, NULL, 298, NULL, NULL, 233343),
(264129, '3w0oA02', NULL, NULL, 225, NULL, NULL, 233343),
(264130, '4pdyA02', NULL, NULL, 240, NULL, NULL, 233343),
(264131, '4u98A02', NULL, NULL, 250, NULL, NULL, 233343),
(264132, '3dxpA02', NULL, NULL, 236, NULL, NULL, 233343),
(264133, '3lzhA02', NULL, NULL, 202, NULL, NULL, 233343),
(264134, '2olcA02', NULL, NULL, 278, NULL, NULL, 233343),
(264135, '3fi8A02', NULL, NULL, 273, NULL, NULL, 233343),
(264136, '2ppqA02', NULL, NULL, 214, NULL, NULL, 233343),
(264137, '2pywA02', NULL, NULL, 298, NULL, NULL, 233343),
(264138, '4h05A02', NULL, NULL, 180, NULL, NULL, 233343),
(264139, '1nd4A02', NULL, NULL, 169, NULL, NULL, 233343),
(264140, '4fevA02', NULL, NULL, 172, NULL, NULL, 233343),
(264141, '6cd7A02', NULL, NULL, 202, NULL, NULL, 233343),
(264142, '3mesA02', NULL, NULL, 300, NULL, NULL, 233343),
(264143, '3tm0A02', NULL, NULL, 173, NULL, NULL, 233343),
(264144, '5bylA02', NULL, NULL, 201, NULL, NULL, 233343),
(264145, '2qg7D02', NULL, NULL, 265, NULL, NULL, 233343),
(264146, '3csvA02', NULL, NULL, 240, NULL, NULL, 233343),
(264147, '4r78A02', NULL, NULL, 196, NULL, NULL, 233343),
(264148, '6ctzA02', NULL, NULL, 204, NULL, NULL, 233343),
(264149, '3dxqB02', NULL, NULL, 211, NULL, NULL, 233343),
(264150, '3atsA02', NULL, NULL, 241, NULL, NULL, 233343),
(264151, '3jr1A02', NULL, NULL, 200, NULL, NULL, 233343),
(264152, '2q83A02', NULL, NULL, 233, NULL, NULL, 233343),
(264153, '5jy7O00', NULL, NULL, 244, NULL, NULL, 233343),
(264154, '5ftgA02', NULL, NULL, 269, NULL, NULL, 233343),
(264155, '3c5iA02', NULL, NULL, 281, NULL, NULL, 233343),
(264156, '6fucA02', NULL, NULL, 184, NULL, NULL, 233343),
(264157, '4o7oA02', NULL, NULL, 240, NULL, NULL, 233343),
(264158, '4dcaA02', NULL, NULL, 210, NULL, NULL, 233343),
(264159, '4yrvA03', NULL, NULL, 115, NULL, NULL, 233344),
(264160, '4izzB03', NULL, NULL, 115, NULL, NULL, 233344),
(264161, '2o8sA01', NULL, NULL, 250, NULL, NULL, 233345),
(264162, '3c2gA02', NULL, NULL, 68, NULL, NULL, 233346),
(264163, '2o5hA00', NULL, NULL, 136, NULL, NULL, 233347),
(264164, '1yycA02', NULL, NULL, 135, NULL, NULL, 233348),
(264165, '1xo8A00', NULL, NULL, 151, NULL, NULL, 233348),
(264166, '3p8cD02', NULL, NULL, 163, NULL, NULL, 233349),
(264167, '2ipqX02', NULL, NULL, 79, NULL, NULL, 233350),
(264168, '2ztgA03', NULL, NULL, 98, NULL, NULL, 233351),
(264169, '3kewA01', NULL, NULL, 86, NULL, NULL, 233351),
(264170, '2zzeA03', NULL, NULL, 98, NULL, NULL, 233351),
(264171, '2zzfA03', NULL, NULL, 98, NULL, NULL, 233351),
(264172, '2zzeB03', NULL, NULL, 98, NULL, NULL, 233351),
(264173, '2e1bA01', NULL, NULL, 72, NULL, NULL, 233351),
(264174, '2q73C00', NULL, NULL, 100, NULL, NULL, 233352),
(264175, '3crcA01', NULL, NULL, 99, NULL, NULL, 233352),
(264176, '3craB01', NULL, NULL, 127, NULL, NULL, 233352),
(264177, '3craA02', NULL, NULL, 135, NULL, NULL, 233352),
(264178, '2gtaD00', NULL, NULL, 119, NULL, NULL, 233352),
(264179, '2a7wA00', NULL, NULL, 94, NULL, NULL, 233352),
(264180, '2gtaB00', NULL, NULL, 100, NULL, NULL, 233352),
(264181, '2p06B00', NULL, NULL, 98, NULL, NULL, 233352),
(264182, '4qgpB00', NULL, NULL, 118, NULL, NULL, 233352),
(264183, '1y6xA00', NULL, NULL, 93, NULL, NULL, 233352),
(264184, '2gtaC00', NULL, NULL, 99, NULL, NULL, 233352),
(264185, '2oieD00', NULL, NULL, 111, NULL, NULL, 233352),
(264186, '2a3qB00', NULL, NULL, 109, NULL, NULL, 233352),
(264187, '2gtaA00', NULL, NULL, 98, NULL, NULL, 233352),
(264188, '2yxhA00', NULL, NULL, 116, NULL, NULL, 233352),
(264189, '5ie9A00', NULL, NULL, 103, NULL, NULL, 233352),
(264190, '1yvwA00', NULL, NULL, 95, NULL, NULL, 233352),
(264191, '1yxbA00', NULL, NULL, 98, NULL, NULL, 233352),
(264192, '1vmgA00', NULL, NULL, 95, NULL, NULL, 233352),
(264193, '2an7A00', NULL, NULL, 83, NULL, NULL, 233353),
(264194, '3d9xA03', NULL, NULL, 24, NULL, NULL, 233354),
(264195, '3cqxC00', NULL, NULL, 88, NULL, NULL, 233355);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(264196, '4bbyA05', NULL, NULL, 108, NULL, NULL, 233356),
(264197, '4b6dB00', NULL, NULL, 61, NULL, NULL, 233357),
(264198, '4uxhB02', NULL, NULL, 47, NULL, NULL, 233357),
(264199, '2rowA01', NULL, NULL, 71, NULL, NULL, 233357),
(264200, '2vrwB03', NULL, NULL, 64, NULL, NULL, 233357),
(264201, '5fuwA02', NULL, NULL, 47, NULL, NULL, 233357),
(264202, '1rfhA01', NULL, NULL, 41, NULL, NULL, 233357),
(264203, '2ja1A02', NULL, NULL, 54, NULL, NULL, 233357),
(264204, '4l9mA04', NULL, NULL, 69, NULL, NULL, 233357),
(264205, '2orwB02', NULL, NULL, 48, NULL, NULL, 233357),
(264206, '3uejA01', NULL, NULL, 59, NULL, NULL, 233357),
(264207, '1xa6A02', NULL, NULL, 69, NULL, NULL, 233357),
(264208, '2eliA01', NULL, NULL, 58, NULL, NULL, 233357),
(264209, '2yuuA00', NULL, NULL, 83, NULL, NULL, 233357),
(264210, '2e73A01', NULL, NULL, 73, NULL, NULL, 233357),
(264211, '2j9rA02', NULL, NULL, 53, NULL, NULL, 233357),
(264212, '1r79A01', NULL, NULL, 55, NULL, NULL, 233357),
(264213, '2j87A02', NULL, NULL, 43, NULL, NULL, 233357),
(264214, '2b8tB02', NULL, NULL, 74, NULL, NULL, 233357),
(264215, '3cxlA02', NULL, NULL, 73, NULL, NULL, 233357),
(264216, '2db6A01', NULL, NULL, 60, NULL, NULL, 233357),
(264217, '1tbnA00', NULL, NULL, 82, NULL, NULL, 233357),
(264218, '1w4rA02', NULL, NULL, 45, NULL, NULL, 233357),
(264219, '3e2iA02', NULL, NULL, 58, NULL, NULL, 233357),
(264220, '4fkdA01', NULL, NULL, 60, NULL, NULL, 233357),
(264221, '2enzA01', NULL, NULL, 56, NULL, NULL, 233357),
(264222, '3ky9A04', NULL, NULL, 52, NULL, NULL, 233357),
(264223, '1xx6A02', NULL, NULL, 50, NULL, NULL, 233357),
(264224, '1faqA00', NULL, NULL, 52, NULL, NULL, 233357),
(264225, '2gviA03', NULL, NULL, 36, NULL, NULL, 233357),
(264226, '1y8fA00', NULL, NULL, 66, NULL, NULL, 233357),
(264227, '2ennA01', NULL, NULL, 70, NULL, NULL, 233357),
(264228, '1kbeA00', NULL, NULL, 49, NULL, NULL, 233357),
(264229, '3wcnA01', NULL, NULL, 189, NULL, NULL, 233358),
(264230, '1hfeL01', NULL, NULL, 202, NULL, NULL, 233359),
(264231, '6gm5A01', NULL, NULL, 187, NULL, NULL, 233359),
(264232, '4fxiA00', NULL, NULL, 95, NULL, NULL, 233360),
(264233, '4q2uL00', NULL, NULL, 102, NULL, NULL, 233360),
(264234, '3kxeA00', NULL, NULL, 110, NULL, NULL, 233360),
(264235, '3bpqD00', NULL, NULL, 88, NULL, NULL, 233360),
(264236, '3oeiC00', NULL, NULL, 96, NULL, NULL, 233360),
(264237, '5iwhA00', NULL, NULL, 98, NULL, NULL, 233360),
(264238, '5czfD00', NULL, NULL, 92, NULL, NULL, 233360),
(264239, '3g5oC00', NULL, NULL, 102, NULL, NULL, 233360),
(264240, '1wmiA00', NULL, NULL, 90, NULL, NULL, 233360),
(264241, '5cegD00', NULL, NULL, 101, NULL, NULL, 233360),
(264242, '4lttA00', NULL, NULL, 93, NULL, NULL, 233360),
(264243, '4ml2A00', NULL, NULL, 95, NULL, NULL, 233360),
(264244, '4ls4A00', NULL, NULL, 91, NULL, NULL, 233360),
(264245, '4nrnA00', NULL, NULL, 94, NULL, NULL, 233360),
(264246, '2a6sB00', NULL, NULL, 84, NULL, NULL, 233360),
(264247, '2kheA00', NULL, NULL, 89, NULL, NULL, 233360),
(264248, '3f9rA02', NULL, NULL, 102, NULL, NULL, 233361),
(264249, '4bndA02', NULL, NULL, 96, NULL, NULL, 233361),
(264250, '2fueA02', NULL, NULL, 102, NULL, NULL, 233361),
(264251, '2i54A02', NULL, NULL, 102, NULL, NULL, 233361),
(264252, '5ue7A02', NULL, NULL, 102, NULL, NULL, 233361),
(264253, '2amyA02', NULL, NULL, 102, NULL, NULL, 233361),
(264254, '3eoiA00', NULL, NULL, 124, NULL, NULL, 233362),
(264255, '2odyA00', NULL, NULL, 49, NULL, NULL, 233363),
(264256, '3e6pL02', NULL, NULL, 68, NULL, NULL, 233363),
(264257, '1a0hA02', NULL, NULL, 70, NULL, NULL, 233363),
(264258, '3b9fL00', NULL, NULL, 49, NULL, NULL, 233363),
(264259, '2puxA00', NULL, NULL, 44, NULL, NULL, 233363),
(264260, '3uitA02', NULL, NULL, 132, NULL, NULL, 233364),
(264261, '2jobA00', NULL, NULL, 102, NULL, NULL, 233365),
(264262, '3cxbA02', NULL, NULL, 111, NULL, NULL, 233366),
(264263, '2auaA02', NULL, NULL, 91, NULL, NULL, 233367),
(264264, '5luzA02', NULL, NULL, 378, NULL, NULL, 233368),
(264265, '2o36A02', NULL, NULL, 387, NULL, NULL, 233368),
(264266, '2o3eA02', NULL, NULL, 375, NULL, NULL, 233368);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(264267, '1sgfG02', NULL, NULL, 115, NULL, NULL, 233369),
(264268, '3nclA01', NULL, NULL, 126, NULL, NULL, 233369),
(264269, '3q3yA01', NULL, NULL, 122, NULL, NULL, 233369),
(264270, '3nclA02', NULL, NULL, 115, NULL, NULL, 233369),
(264271, '3q3yA02', NULL, NULL, 69, NULL, NULL, 233369),
(264272, '1sgfG01', NULL, NULL, 121, NULL, NULL, 233369),
(264273, '5yc6U02', NULL, NULL, 118, NULL, NULL, 233369),
(264274, '3r3gB01', NULL, NULL, 139, NULL, NULL, 233369),
(264275, '2fyqA01', NULL, NULL, 83, NULL, NULL, 233369),
(264276, '4ri0C01', NULL, NULL, 113, NULL, NULL, 233369),
(264277, '3pmaB02', NULL, NULL, 120, NULL, NULL, 233369),
(264278, '3pmaB01', NULL, NULL, 139, NULL, NULL, 233369),
(264279, '1lvoA01', NULL, NULL, 84, NULL, NULL, 233369),
(264280, '1tbs001', NULL, NULL, 120, NULL, NULL, 233369),
(264281, '3stiB01', NULL, NULL, 96, NULL, NULL, 233369),
(264282, '1lvoA02', NULL, NULL, 88, NULL, NULL, 233369),
(264283, '1tbs002', NULL, NULL, 101, NULL, NULL, 233369),
(264284, '1vcpA02', NULL, NULL, 85, NULL, NULL, 233369),
(264285, '4ic6A02', NULL, NULL, 114, NULL, NULL, 233369),
(264286, '4k1tA02', NULL, NULL, 94, NULL, NULL, 233369),
(264287, '1z8gA02', NULL, NULL, 129, NULL, NULL, 233369),
(264288, '1z8rA01', NULL, NULL, 42, NULL, NULL, 233369),
(264289, '6b6iA01', NULL, NULL, 70, NULL, NULL, 233369),
(264290, '1x7aC01', NULL, NULL, 127, NULL, NULL, 233369),
(264291, '4mg3A02', NULL, NULL, 95, NULL, NULL, 233369),
(264292, '1x7aC02', NULL, NULL, 108, NULL, NULL, 233369),
(264293, '1orfA02', NULL, NULL, 107, NULL, NULL, 233369),
(264294, '1orfA01', NULL, NULL, 127, NULL, NULL, 233369),
(264295, '4a1xB02', NULL, NULL, 94, NULL, NULL, 233369),
(264296, '2q6dC01', NULL, NULL, 116, NULL, NULL, 233369),
(264297, '4xfqA01', NULL, NULL, 98, NULL, NULL, 233369),
(264298, '1z8rA02', NULL, NULL, 98, NULL, NULL, 233369),
(264299, '5afyH01', NULL, NULL, 139, NULL, NULL, 233369),
(264300, '1mzaA02', NULL, NULL, 109, NULL, NULL, 233369),
(264301, '4ri0B02', NULL, NULL, 102, NULL, NULL, 233369),
(264302, '6fezA02', NULL, NULL, 94, NULL, NULL, 233369),
(264303, '1p3cA02', NULL, NULL, 110, NULL, NULL, 233369),
(264304, '5dj7A02', NULL, NULL, 108, NULL, NULL, 233369),
(264305, '5yofB02', NULL, NULL, 92, NULL, NULL, 233369),
(264306, '2o8lA01', NULL, NULL, 115, NULL, NULL, 233369),
(264307, '2o8lA02', NULL, NULL, 101, NULL, NULL, 233369),
(264308, '1p3cA01', NULL, NULL, 105, NULL, NULL, 233369),
(264309, '3stiA02', NULL, NULL, 118, NULL, NULL, 233369),
(264310, '5fcrA01', NULL, NULL, 122, NULL, NULL, 233369),
(264311, '1ky9A01', NULL, NULL, 92, NULL, NULL, 233369),
(264312, '4ue7H02', NULL, NULL, 118, NULL, NULL, 233369),
(264313, '5fcrA02', NULL, NULL, 112, NULL, NULL, 233369),
(264314, '2hrvA01', NULL, NULL, 44, NULL, NULL, 233369),
(264315, '2hrvA02', NULL, NULL, 98, NULL, NULL, 233369),
(264316, '2fomB02', NULL, NULL, 82, NULL, NULL, 233369),
(264317, '1mzaA01', NULL, NULL, 125, NULL, NULL, 233369),
(264318, '4wmfC02', NULL, NULL, 92, NULL, NULL, 233369),
(264319, '6b6iB02', NULL, NULL, 111, NULL, NULL, 233369),
(264320, '1shyA02', NULL, NULL, 108, NULL, NULL, 233369),
(264321, '4crgA01', NULL, NULL, 127, NULL, NULL, 233369),
(264322, '1wqsA02', NULL, NULL, 103, NULL, NULL, 233369),
(264323, '4crgA02', NULL, NULL, 111, NULL, NULL, 233369),
(264324, '1wqsA01', NULL, NULL, 70, NULL, NULL, 233369),
(264325, '2hntE00', NULL, NULL, 81, NULL, NULL, 233369),
(264326, '4in2A02', NULL, NULL, 110, NULL, NULL, 233369),
(264327, '5ms4A02', NULL, NULL, 104, NULL, NULL, 233369),
(264328, '5bpeA01', NULL, NULL, 111, NULL, NULL, 233369),
(264329, '4ag1A02', NULL, NULL, 108, NULL, NULL, 233369),
(264330, '4wmeA01', NULL, NULL, 112, NULL, NULL, 233369),
(264331, '1qtfA01', NULL, NULL, 120, NULL, NULL, 233369),
(264332, '1qtfA02', NULL, NULL, 122, NULL, NULL, 233369),
(264333, '4ag1A01', NULL, NULL, 118, NULL, NULL, 233369),
(264334, '1npmA02', NULL, NULL, 104, NULL, NULL, 233369),
(264335, '1npmA01', NULL, NULL, 120, NULL, NULL, 233369),
(264336, '4wmeA02', NULL, NULL, 88, NULL, NULL, 233369),
(264337, '5abwA01', NULL, NULL, 113, NULL, NULL, 233369);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(264338, '5abwA02', NULL, NULL, 105, NULL, NULL, 233369),
(264339, '2zchP01', NULL, NULL, 121, NULL, NULL, 233369),
(264340, '5mrtA01', NULL, NULL, 91, NULL, NULL, 233369),
(264341, '5mrtA02', NULL, NULL, 110, NULL, NULL, 233369),
(264342, '2zchP02', NULL, NULL, 115, NULL, NULL, 233369),
(264343, '3s69A01', NULL, NULL, 122, NULL, NULL, 233369),
(264344, '1si5H02', NULL, NULL, 114, NULL, NULL, 233369),
(264345, '1si5H01', NULL, NULL, 126, NULL, NULL, 233369),
(264346, '4h4fA01', NULL, NULL, 129, NULL, NULL, 233369),
(264347, '4h4fA02', NULL, NULL, 120, NULL, NULL, 233369),
(264348, '2b0fA01', NULL, NULL, 113, NULL, NULL, 233369),
(264349, '2b0fA02', NULL, NULL, 69, NULL, NULL, 233369),
(264350, '3dfjA02', NULL, NULL, 128, NULL, NULL, 233369),
(264351, '4xdeA01', NULL, NULL, 131, NULL, NULL, 233369),
(264352, '2jetB00', NULL, NULL, 128, NULL, NULL, 233369),
(264353, '3h7oB01', NULL, NULL, 116, NULL, NULL, 233369),
(264354, '4xdeA02', NULL, NULL, 126, NULL, NULL, 233369),
(264355, '3d23B02', NULL, NULL, 85, NULL, NULL, 233369),
(264356, '5xrfA02', NULL, NULL, 116, NULL, NULL, 233369),
(264357, '1cghA02', NULL, NULL, 106, NULL, NULL, 233369),
(264358, '5exnA02', NULL, NULL, 111, NULL, NULL, 233369),
(264359, '5xrfA01', NULL, NULL, 119, NULL, NULL, 233369),
(264360, '5hm2A02', NULL, NULL, 110, NULL, NULL, 233369),
(264361, '1cghA01', NULL, NULL, 118, NULL, NULL, 233369),
(264362, '5hm2A01', NULL, NULL, 99, NULL, NULL, 233369),
(264363, '1bruP01', NULL, NULL, 129, NULL, NULL, 233369),
(264364, '1bruP02', NULL, NULL, 112, NULL, NULL, 233369),
(264365, '1aksB00', NULL, NULL, 98, NULL, NULL, 233369),
(264366, '1j16A01', NULL, NULL, 120, NULL, NULL, 233369),
(264367, '1fiwA01', NULL, NULL, 131, NULL, NULL, 233369),
(264368, '1gj7B01', NULL, NULL, 128, NULL, NULL, 233369),
(264369, '2pfeA02', NULL, NULL, 99, NULL, NULL, 233369),
(264370, '2pfeA01', NULL, NULL, 87, NULL, NULL, 233369),
(264371, '2rdlA02', NULL, NULL, 108, NULL, NULL, 233369),
(264372, '2rdlA01', NULL, NULL, 118, NULL, NULL, 233369),
(264373, '3w94A01', NULL, NULL, 126, NULL, NULL, 233369),
(264374, '1kigH02', NULL, NULL, 108, NULL, NULL, 233369),
(264375, '1l1jA01', NULL, NULL, 120, NULL, NULL, 233369),
(264376, '1kigH01', NULL, NULL, 128, NULL, NULL, 233369),
(264377, '3w94A02', NULL, NULL, 109, NULL, NULL, 233369),
(264378, '1l1jA02', NULL, NULL, 119, NULL, NULL, 233369),
(264379, '5gvtA02', NULL, NULL, 123, NULL, NULL, 233369),
(264380, '2ynaA02', NULL, NULL, 88, NULL, NULL, 233369),
(264381, '2ynaA01', NULL, NULL, 112, NULL, NULL, 233369),
(264382, '3h7oA02', NULL, NULL, 112, NULL, NULL, 233369),
(264383, '1svpA02', NULL, NULL, 86, NULL, NULL, 233369),
(264384, '2qy0B01', NULL, NULL, 128, NULL, NULL, 233369),
(264385, '1svpA01', NULL, NULL, 65, NULL, NULL, 233369),
(264386, '1ezxC00', NULL, NULL, 199, NULL, NULL, 233369),
(264387, '3d23C01', NULL, NULL, 114, NULL, NULL, 233369),
(264388, '3s69A02', NULL, NULL, 105, NULL, NULL, 233369),
(264389, '1eufA02', NULL, NULL, 108, NULL, NULL, 233369),
(264390, '1ym0A01', NULL, NULL, 126, NULL, NULL, 233369),
(264391, '1elvA02', NULL, NULL, 136, NULL, NULL, 233369),
(264392, '1elvA01', NULL, NULL, 105, NULL, NULL, 233369),
(264393, '1eufA01', NULL, NULL, 119, NULL, NULL, 233369),
(264394, '1aksA00', NULL, NULL, 125, NULL, NULL, 233369),
(264395, '2hlcA02', NULL, NULL, 126, NULL, NULL, 233369),
(264396, '2hlcA01', NULL, NULL, 104, NULL, NULL, 233369),
(264397, '3beuA02', NULL, NULL, 99, NULL, NULL, 233369),
(264398, '1ym0A02', NULL, NULL, 112, NULL, NULL, 233369),
(264399, '5dgjA01', NULL, NULL, 77, NULL, NULL, 233369),
(264400, '2ea3A01', NULL, NULL, 90, NULL, NULL, 233369),
(264401, '3beuA01', NULL, NULL, 125, NULL, NULL, 233369),
(264402, '2ea3A02', NULL, NULL, 99, NULL, NULL, 233369),
(264403, '1fiwA02', NULL, NULL, 120, NULL, NULL, 233369),
(264404, '5y2dA02', NULL, NULL, 89, NULL, NULL, 233369),
(264405, '5y2dA01', NULL, NULL, 120, NULL, NULL, 233369),
(264406, '2q6fA01', NULL, NULL, 83, NULL, NULL, 233369),
(264407, '5m3nA01', NULL, NULL, 132, NULL, NULL, 233369),
(264408, '2f83A05', NULL, NULL, 247, NULL, NULL, 233369);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(264409, '2q6fA02', NULL, NULL, 88, NULL, NULL, 233369),
(264410, '6ahsA02', NULL, NULL, 101, NULL, NULL, 233369),
(264411, '3wy8A02', NULL, NULL, 106, NULL, NULL, 233369),
(264412, '1gpzA02', NULL, NULL, 19, NULL, NULL, 233369),
(264413, '3fp7E02', NULL, NULL, 103, NULL, NULL, 233369),
(264414, '2zgcA01', NULL, NULL, 126, NULL, NULL, 233369),
(264415, '2zgcA02', NULL, NULL, 114, NULL, NULL, 233369),
(264416, '1m9uA01', NULL, NULL, 132, NULL, NULL, 233369),
(264417, '1m9uA02', NULL, NULL, 109, NULL, NULL, 233369),
(264418, '1ddjA01', NULL, NULL, 126, NULL, NULL, 233369),
(264419, '3f6uH02', NULL, NULL, 106, NULL, NULL, 233369),
(264420, '4e7nA02', NULL, NULL, 116, NULL, NULL, 233369),
(264421, '3wy8A01', NULL, NULL, 113, NULL, NULL, 233369),
(264422, '4e7nA01', NULL, NULL, 115, NULL, NULL, 233369),
(264423, '5lpeA01', NULL, NULL, 123, NULL, NULL, 233369),
(264424, '1iauA02', NULL, NULL, 107, NULL, NULL, 233369),
(264425, '1iauA01', NULL, NULL, 120, NULL, NULL, 233369),
(264426, '5idkA02', NULL, NULL, 112, NULL, NULL, 233369),
(264427, '1fi8B02', NULL, NULL, 106, NULL, NULL, 233369),
(264428, '1hj8A01', NULL, NULL, 119, NULL, NULL, 233369),
(264429, '3tjoA02', NULL, NULL, 105, NULL, NULL, 233369),
(264430, '1ekbB01', NULL, NULL, 126, NULL, NULL, 233369),
(264431, '1ekbB02', NULL, NULL, 109, NULL, NULL, 233369),
(264432, '3tjoA01', NULL, NULL, 106, NULL, NULL, 233369),
(264433, '1hj8A02', NULL, NULL, 103, NULL, NULL, 233369),
(264434, '1ucyH00', NULL, NULL, 150, NULL, NULL, 233369),
(264435, '2od3B01', NULL, NULL, 139, NULL, NULL, 233369),
(264436, '1lvbA01', NULL, NULL, 137, NULL, NULL, 233369),
(264437, '1a0jA01', NULL, NULL, 120, NULL, NULL, 233369),
(264438, '1a0jA02', NULL, NULL, 103, NULL, NULL, 233369),
(264439, '5natA02', NULL, NULL, 110, NULL, NULL, 233369),
(264440, '5natA01', NULL, NULL, 122, NULL, NULL, 233369),
(264441, '5c5oA01', NULL, NULL, 112, NULL, NULL, 233369),
(264442, '2jetC00', NULL, NULL, 99, NULL, NULL, 233369),
(264443, '1eptA00', NULL, NULL, 43, NULL, NULL, 233369),
(264444, '5c5oA02', NULL, NULL, 85, NULL, NULL, 233369),
(264445, '1vr1H02', NULL, NULL, 118, NULL, NULL, 233369),
(264446, '3fanA01', NULL, NULL, 73, NULL, NULL, 233369),
(264447, '3fanA02', NULL, NULL, 74, NULL, NULL, 233369),
(264448, '5lpeB02', NULL, NULL, 108, NULL, NULL, 233369),
(264449, '1zyoA02', NULL, NULL, 85, NULL, NULL, 233369),
(264450, '1rtfB02', NULL, NULL, 116, NULL, NULL, 233369),
(264451, '1rtfB01', NULL, NULL, 134, NULL, NULL, 233369),
(264452, '1lvmA01', NULL, NULL, 108, NULL, NULL, 233369),
(264453, '1zyoA01', NULL, NULL, 106, NULL, NULL, 233369),
(264454, '1lvmA02', NULL, NULL, 106, NULL, NULL, 233369),
(264455, '1fi8A01', NULL, NULL, 120, NULL, NULL, 233369),
(264456, '1ao5A01', NULL, NULL, 121, NULL, NULL, 233369),
(264457, '4ic5A02', NULL, NULL, 114, NULL, NULL, 233369),
(264458, '1ao5A02', NULL, NULL, 115, NULL, NULL, 233369),
(264459, '3stjA01', NULL, NULL, 119, NULL, NULL, 233369),
(264460, '3stjA02', NULL, NULL, 83, NULL, NULL, 233369),
(264461, '4ic5A01', NULL, NULL, 123, NULL, NULL, 233369),
(264462, '1arbA02', NULL, NULL, 137, NULL, NULL, 233369),
(264463, '1sgfA01', NULL, NULL, 124, NULL, NULL, 233369),
(264464, '1ucyE00', NULL, NULL, 109, NULL, NULL, 233369),
(264465, '4jcnA02', NULL, NULL, 101, NULL, NULL, 233369),
(264466, '4lk4A02', NULL, NULL, 96, NULL, NULL, 233369),
(264467, '1arbA01', NULL, NULL, 122, NULL, NULL, 233369),
(264468, '4jcnA01', NULL, NULL, 115, NULL, NULL, 233369),
(264469, '4lk4A01', NULL, NULL, 149, NULL, NULL, 233369),
(264470, '1sgfA02', NULL, NULL, 116, NULL, NULL, 233369),
(264471, '2odpA02', NULL, NULL, 119, NULL, NULL, 233369),
(264472, '2odpA03', NULL, NULL, 172, NULL, NULL, 233369),
(264473, '2r0lA02', NULL, NULL, 122, NULL, NULL, 233369),
(264474, '4r8tB02', NULL, NULL, 73, NULL, NULL, 233369),
(264475, '3iwmB01', NULL, NULL, 99, NULL, NULL, 233369),
(264476, '5eqsA02', NULL, NULL, 85, NULL, NULL, 233369),
(264477, '1eptB00', NULL, NULL, 82, NULL, NULL, 233369),
(264478, '4inkA01', NULL, NULL, 112, NULL, NULL, 233369),
(264479, '4inkA02', NULL, NULL, 93, NULL, NULL, 233369);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(264480, '4ic6C01', NULL, NULL, 121, NULL, NULL, 233369),
(264481, '1ky9B01', NULL, NULL, 76, NULL, NULL, 233369),
(264482, '6jijA02', NULL, NULL, 83, NULL, NULL, 233369),
(264483, '5lhrA02', NULL, NULL, 119, NULL, NULL, 233369),
(264484, '6jijA01', NULL, NULL, 112, NULL, NULL, 233369),
(264485, '5pagB02', NULL, NULL, 110, NULL, NULL, 233369),
(264486, '5pagB01', NULL, NULL, 133, NULL, NULL, 233369),
(264487, '4wjg202', NULL, NULL, 155, NULL, NULL, 233369),
(264488, '4wjg203', NULL, NULL, 89, NULL, NULL, 233369),
(264489, '4q7zA02', NULL, NULL, 109, NULL, NULL, 233369),
(264490, '4q7zA01', NULL, NULL, 124, NULL, NULL, 233369),
(264491, '4igdA03', NULL, NULL, 132, NULL, NULL, 233369),
(264492, '5x45A01', NULL, NULL, 45, NULL, NULL, 233369),
(264493, '3mmgA02', NULL, NULL, 105, NULL, NULL, 233369),
(264494, '3mmgA01', NULL, NULL, 105, NULL, NULL, 233369),
(264495, '1a7sA02', NULL, NULL, 109, NULL, NULL, 233369),
(264496, '2j92A01', NULL, NULL, 99, NULL, NULL, 233369),
(264497, '1a7sA01', NULL, NULL, 112, NULL, NULL, 233369),
(264498, '5x45B02', NULL, NULL, 94, NULL, NULL, 233369),
(264499, '2j92A02', NULL, NULL, 110, NULL, NULL, 233369),
(264500, '3su6A02', NULL, NULL, 88, NULL, NULL, 233369),
(264501, '3mh7A01', NULL, NULL, 83, NULL, NULL, 233369),
(264502, '1dy9A02', NULL, NULL, 93, NULL, NULL, 233369),
(264503, '1os8A02', NULL, NULL, 97, NULL, NULL, 233369),
(264504, '3mh7A02', NULL, NULL, 112, NULL, NULL, 233369),
(264505, '2qa9E02', NULL, NULL, 95, NULL, NULL, 233369),
(264506, '2qa9E01', NULL, NULL, 90, NULL, NULL, 233369),
(264507, '3pv4A01', NULL, NULL, 123, NULL, NULL, 233369),
(264508, '3tk9A02', NULL, NULL, 107, NULL, NULL, 233369),
(264509, '5tjxA01', NULL, NULL, 142, NULL, NULL, 233369),
(264510, '3pv4A02', NULL, NULL, 117, NULL, NULL, 233369),
(264511, '3tk9A01', NULL, NULL, 119, NULL, NULL, 233369),
(264512, '4mpuA01', NULL, NULL, 134, NULL, NULL, 233369),
(264513, '2as9A01', NULL, NULL, 116, NULL, NULL, 233369),
(264514, '4mpuA02', NULL, NULL, 111, NULL, NULL, 233369),
(264515, '3sjiA01', NULL, NULL, 121, NULL, NULL, 233369),
(264516, '1fizA02', NULL, NULL, 120, NULL, NULL, 233369),
(264517, '2fp7B02', NULL, NULL, 85, NULL, NULL, 233369),
(264518, '2as9A02', NULL, NULL, 94, NULL, NULL, 233369),
(264519, '1fizA01', NULL, NULL, 131, NULL, NULL, 233369),
(264520, '3sjiA02', NULL, NULL, 69, NULL, NULL, 233369),
(264521, '1hj9A01', NULL, NULL, 120, NULL, NULL, 233369),
(264522, '2bhgB01', NULL, NULL, 100, NULL, NULL, 233369),
(264523, '2oq5A02', NULL, NULL, 104, NULL, NULL, 233369),
(264524, '2oq5A01', NULL, NULL, 128, NULL, NULL, 233369),
(264525, '2hntC00', NULL, NULL, 70, NULL, NULL, 233369),
(264526, '1os8A01', NULL, NULL, 126, NULL, NULL, 233369),
(264527, '6qfeA02', NULL, NULL, 105, NULL, NULL, 233369),
(264528, '2sgaA02', NULL, NULL, 100, NULL, NULL, 233369),
(264529, '1autC01', NULL, NULL, 134, NULL, NULL, 233369),
(264530, '4i8hA02', NULL, NULL, 102, NULL, NULL, 233369),
(264531, '2sgaA01', NULL, NULL, 81, NULL, NULL, 233369),
(264532, '4i8hA01', NULL, NULL, 120, NULL, NULL, 233369),
(264533, '1spjA01', NULL, NULL, 121, NULL, NULL, 233369),
(264534, '1spjA02', NULL, NULL, 116, NULL, NULL, 233369),
(264535, '3g01A01', NULL, NULL, 120, NULL, NULL, 233369),
(264536, '3zveA01', NULL, NULL, 121, NULL, NULL, 233369),
(264537, '3zveA02', NULL, NULL, 69, NULL, NULL, 233369),
(264538, '2eekA01', NULL, NULL, 119, NULL, NULL, 233369),
(264539, '4kkdB04', NULL, NULL, 135, NULL, NULL, 233369),
(264540, '2asuB01', NULL, NULL, 122, NULL, NULL, 233369),
(264541, '2eekA02', NULL, NULL, 101, NULL, NULL, 233369),
(264542, '2asuB02', NULL, NULL, 112, NULL, NULL, 233369),
(264543, '4m7gA01', NULL, NULL, 122, NULL, NULL, 233369),
(264544, '2bhgA01', NULL, NULL, 99, NULL, NULL, 233369),
(264545, '5zqgA02', NULL, NULL, 98, NULL, NULL, 233369),
(264546, '4nfeA01', NULL, NULL, 121, NULL, NULL, 233369),
(264547, '2bhgA02', NULL, NULL, 110, NULL, NULL, 233369),
(264548, '3nxpA02', NULL, NULL, 186, NULL, NULL, 233369),
(264549, '4agkA02', NULL, NULL, 86, NULL, NULL, 233369),
(264550, '2h5cA01', NULL, NULL, 87, NULL, NULL, 233369);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(264551, '4agkA01', NULL, NULL, 65, NULL, NULL, 233369),
(264552, '2h5cA02', NULL, NULL, 107, NULL, NULL, 233369),
(264553, '5fx6A02', NULL, NULL, 69, NULL, NULL, 233369),
(264554, '4d9qA01', NULL, NULL, 122, NULL, NULL, 233369),
(264555, '5fx6A01', NULL, NULL, 113, NULL, NULL, 233369),
(264556, '1yphE00', NULL, NULL, 97, NULL, NULL, 233369),
(264557, '4mvnA02', NULL, NULL, 91, NULL, NULL, 233369),
(264558, '4dcdA02', NULL, NULL, 69, NULL, NULL, 233369),
(264559, '3lkwA02', NULL, NULL, 111, NULL, NULL, 233369),
(264560, '4gsoA02', NULL, NULL, 111, NULL, NULL, 233369),
(264561, '4dcdA01', NULL, NULL, 121, NULL, NULL, 233369),
(264562, '4fvdA02', NULL, NULL, 100, NULL, NULL, 233369),
(264563, '4gsoA01', NULL, NULL, 121, NULL, NULL, 233369),
(264564, '6bidA02', NULL, NULL, 111, NULL, NULL, 233369),
(264565, '4fvdA01', NULL, NULL, 42, NULL, NULL, 233369),
(264566, '5jb9S01', NULL, NULL, 127, NULL, NULL, 233369),
(264567, '5jb9S02', NULL, NULL, 108, NULL, NULL, 233369),
(264568, '3i77A01', NULL, NULL, 126, NULL, NULL, 233369),
(264569, '3tloA02', NULL, NULL, 99, NULL, NULL, 233369),
(264570, '3tloA01', NULL, NULL, 98, NULL, NULL, 233369),
(264571, '3k2uA01', NULL, NULL, 126, NULL, NULL, 233369),
(264572, '4k8yA02', NULL, NULL, 101, NULL, NULL, 233369),
(264573, '4k8yA01', NULL, NULL, 116, NULL, NULL, 233369),
(264574, '3qzrA02', NULL, NULL, 69, NULL, NULL, 233369),
(264575, '3qzrA01', NULL, NULL, 118, NULL, NULL, 233369),
(264576, '1y8tB02', NULL, NULL, 124, NULL, NULL, 233369),
(264577, '1rrkA02', NULL, NULL, 119, NULL, NULL, 233369),
(264578, '3qo6C01', NULL, NULL, 117, NULL, NULL, 233369),
(264579, '1sotA01', NULL, NULL, 121, NULL, NULL, 233369),
(264580, '3h7tB01', NULL, NULL, 124, NULL, NULL, 233369),
(264581, '1agjA02', NULL, NULL, 108, NULL, NULL, 233369),
(264582, '2iphA02', NULL, NULL, 111, NULL, NULL, 233369),
(264583, '4nffA02', NULL, NULL, 115, NULL, NULL, 233369),
(264584, '5hxfA01', NULL, NULL, 115, NULL, NULL, 233369),
(264585, '2iphA01', NULL, NULL, 70, NULL, NULL, 233369),
(264586, '5hxfA02', NULL, NULL, 69, NULL, NULL, 233369),
(264587, '5avdA02', NULL, NULL, 112, NULL, NULL, 233369),
(264588, '5avdA01', NULL, NULL, 128, NULL, NULL, 233369),
(264589, '1bqyA01', NULL, NULL, 122, NULL, NULL, 233369),
(264590, '1bqyA02', NULL, NULL, 105, NULL, NULL, 233369),
(264591, '4f4oC02', NULL, NULL, 155, NULL, NULL, 233369),
(264592, '1agjA01', NULL, NULL, 134, NULL, NULL, 233369),
(264593, '4f4oC03', NULL, NULL, 89, NULL, NULL, 233369),
(264594, '1te0A02', NULL, NULL, 86, NULL, NULL, 233369),
(264595, '1te0A01', NULL, NULL, 97, NULL, NULL, 233369),
(264596, '1gvzA02', NULL, NULL, 115, NULL, NULL, 233369),
(264597, '1gvzA01', NULL, NULL, 121, NULL, NULL, 233369),
(264598, '5m3oA02', NULL, NULL, 93, NULL, NULL, 233369),
(264599, '2qf0B02', NULL, NULL, 115, NULL, NULL, 233369),
(264600, '1k28D01', NULL, NULL, 116, NULL, NULL, 233369),
(264601, '3lgiB01', NULL, NULL, 116, NULL, NULL, 233369),
(264602, '2aiqA01', NULL, NULL, 111, NULL, NULL, 233369),
(264603, '3s9cA01', NULL, NULL, 120, NULL, NULL, 233369),
(264604, '2aiqA02', NULL, NULL, 113, NULL, NULL, 233369),
(264605, '3s9cA02', NULL, NULL, 107, NULL, NULL, 233369),
(264606, '2halA01', NULL, NULL, 109, NULL, NULL, 233369),
(264607, '2halA02', NULL, NULL, 103, NULL, NULL, 233369),
(264608, '2ra3A02', NULL, NULL, 104, NULL, NULL, 233369),
(264609, '2ra3A01', NULL, NULL, 120, NULL, NULL, 233369),
(264610, '2xrcC04', NULL, NULL, 232, NULL, NULL, 233369),
(264611, '3h7tA02', NULL, NULL, 111, NULL, NULL, 233369),
(264612, '2f9nA01', NULL, NULL, 134, NULL, NULL, 233369),
(264613, '2qxiA02', NULL, NULL, 101, NULL, NULL, 233369),
(264614, '2f9nA02', NULL, NULL, 111, NULL, NULL, 233369),
(264615, '3gdvC01', NULL, NULL, 121, NULL, NULL, 233369),
(264616, '2olgA02', NULL, NULL, 115, NULL, NULL, 233369),
(264617, '2pkaB00', NULL, NULL, 152, NULL, NULL, 233369),
(264618, '2olgA01', NULL, NULL, 129, NULL, NULL, 233369),
(264619, '4dgjA01', NULL, NULL, 126, NULL, NULL, 233369),
(264620, '3fzzA02', NULL, NULL, 107, NULL, NULL, 233369),
(264621, '3mh5B01', NULL, NULL, 114, NULL, NULL, 233369);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(264622, '4zroA02', NULL, NULL, 88, NULL, NULL, 233369),
(264623, '3mh5B02', NULL, NULL, 114, NULL, NULL, 233369),
(264624, '3p8nA02', NULL, NULL, 92, NULL, NULL, 233369),
(264625, '5h23A02', NULL, NULL, 85, NULL, NULL, 233369),
(264626, '5h23A01', NULL, NULL, 71, NULL, NULL, 233369),
(264627, '4dgjA02', NULL, NULL, 109, NULL, NULL, 233369),
(264628, '2z9iC01', NULL, NULL, 102, NULL, NULL, 233369),
(264629, '1p57B02', NULL, NULL, 126, NULL, NULL, 233369),
(264630, '2b9lA01', NULL, NULL, 163, NULL, NULL, 233369),
(264631, '4kkdA03', NULL, NULL, 152, NULL, NULL, 233369),
(264632, '1fujA02', NULL, NULL, 108, NULL, NULL, 233369),
(264633, '1fujA01', NULL, NULL, 113, NULL, NULL, 233369),
(264634, '1pq7A02', NULL, NULL, 100, NULL, NULL, 233369),
(264635, '1fxyA02', NULL, NULL, 108, NULL, NULL, 233369),
(264636, '1pq7A01', NULL, NULL, 124, NULL, NULL, 233369),
(264637, '1fonA01', NULL, NULL, 126, NULL, NULL, 233369),
(264638, '1fonA02', NULL, NULL, 114, NULL, NULL, 233369),
(264639, '1ep5A02', NULL, NULL, 86, NULL, NULL, 233369),
(264640, '2b9lA03', NULL, NULL, 145, NULL, NULL, 233369),
(264641, '1ep5A01', NULL, NULL, 64, NULL, NULL, 233369),
(264642, '2w5eA02', NULL, NULL, 75, NULL, NULL, 233369),
(264643, '1a5iA01', NULL, NULL, 134, NULL, NULL, 233369),
(264644, '3lgiA02', NULL, NULL, 121, NULL, NULL, 233369),
(264645, '1a5iA02', NULL, NULL, 118, NULL, NULL, 233369),
(264646, '2w5eA01', NULL, NULL, 65, NULL, NULL, 233369),
(264647, '3tvjB02', NULL, NULL, 107, NULL, NULL, 233369),
(264648, '3tvjB01', NULL, NULL, 135, NULL, NULL, 233369),
(264649, '4zroA01', NULL, NULL, 84, NULL, NULL, 233369),
(264650, '1azzA02', NULL, NULL, 107, NULL, NULL, 233369),
(264651, '1azzA01', NULL, NULL, 119, NULL, NULL, 233369),
(264652, '3u1jB02', NULL, NULL, 82, NULL, NULL, 233369),
(264653, '2pkaA00', NULL, NULL, 80, NULL, NULL, 233369),
(264654, '1lo6A01', NULL, NULL, 119, NULL, NULL, 233369),
(264655, '1tonA01', NULL, NULL, 121, NULL, NULL, 233369),
(264656, '1lo6A02', NULL, NULL, 104, NULL, NULL, 233369),
(264657, '1tonA02', NULL, NULL, 113, NULL, NULL, 233369),
(264658, '3po1C00', NULL, NULL, 102, NULL, NULL, 233369),
(264659, '1op0A01', NULL, NULL, 122, NULL, NULL, 233369),
(264660, '1op0A02', NULL, NULL, 105, NULL, NULL, 233369),
(264661, '5tp0A02', NULL, NULL, 103, NULL, NULL, 233369),
(264662, '5mm8A01', NULL, NULL, 112, NULL, NULL, 233369),
(264663, '3cp7B02', NULL, NULL, 105, NULL, NULL, 233369),
(264664, '2psxA01', NULL, NULL, 122, NULL, NULL, 233369),
(264665, '5tp0A01', NULL, NULL, 120, NULL, NULL, 233369),
(264666, '3k6yA01', NULL, NULL, 92, NULL, NULL, 233369),
(264667, '5mm8A02', NULL, NULL, 92, NULL, NULL, 233369),
(264668, '4zkoU01', NULL, NULL, 128, NULL, NULL, 233369),
(264669, '3k6yA02', NULL, NULL, 107, NULL, NULL, 233369),
(264670, '2m5tA01', NULL, NULL, 43, NULL, NULL, 233369),
(264671, '2zu1A01', NULL, NULL, 114, NULL, NULL, 233369),
(264672, '2m5tA02', NULL, NULL, 99, NULL, NULL, 233369),
(264673, '1eltA01', NULL, NULL, 127, NULL, NULL, 233369),
(264674, '1eltA02', NULL, NULL, 109, NULL, NULL, 233369),
(264675, '5wdxA02', NULL, NULL, 92, NULL, NULL, 233369),
(264676, '2xxlA03', NULL, NULL, 130, NULL, NULL, 233369),
(264677, '4nsvA01', NULL, NULL, 122, NULL, NULL, 233369),
(264678, '4nsvA02', NULL, NULL, 138, NULL, NULL, 233369),
(264679, '1pytD02', NULL, NULL, 110, NULL, NULL, 233369),
(264680, '2xxlA02', NULL, NULL, 146, NULL, NULL, 233369),
(264681, '1pytD01', NULL, NULL, 128, NULL, NULL, 233369),
(264682, '2zu2A02', NULL, NULL, 98, NULL, NULL, 233369),
(264683, '1mbmA01', NULL, NULL, 76, NULL, NULL, 233369),
(264684, '2zu2A01', NULL, NULL, 98, NULL, NULL, 233369),
(264685, '3po1B00', NULL, NULL, 147, NULL, NULL, 233369),
(264686, '3plbA01', NULL, NULL, 120, NULL, NULL, 233369),
(264687, '6bqjC02', NULL, NULL, 110, NULL, NULL, 233369),
(264688, '1mbmA02', NULL, NULL, 72, NULL, NULL, 233369),
(264689, '1hpgA02', NULL, NULL, 99, NULL, NULL, 233369),
(264690, '1hpgA01', NULL, NULL, 88, NULL, NULL, 233369),
(264691, '3cp7A01', NULL, NULL, 113, NULL, NULL, 233369),
(264692, '2ouaA02', NULL, NULL, 100, NULL, NULL, 233369);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(264693, '2ouaA01', NULL, NULL, 88, NULL, NULL, 233369),
(264694, '3rp2A01', NULL, NULL, 118, NULL, NULL, 233369),
(264695, '3rp2A02', NULL, NULL, 104, NULL, NULL, 233369),
(264696, '5uggA02', NULL, NULL, 103, NULL, NULL, 233369),
(264697, '5fahA01', NULL, NULL, 123, NULL, NULL, 233369),
(264698, '3hk3B02', NULL, NULL, 118, NULL, NULL, 233369),
(264699, '3hk3B01', NULL, NULL, 139, NULL, NULL, 233369),
(264700, '2sfaA02', NULL, NULL, 100, NULL, NULL, 233369),
(264701, '2sfaA01', NULL, NULL, 91, NULL, NULL, 233369),
(264702, '2qy0D02', NULL, NULL, 114, NULL, NULL, 233369),
(264703, '1s83A02', NULL, NULL, 103, NULL, NULL, 233369),
(264704, '1s83A01', NULL, NULL, 120, NULL, NULL, 233369),
(264705, '4mvnB01', NULL, NULL, 109, NULL, NULL, 233369),
(264706, '6ieoA01', NULL, NULL, 97, NULL, NULL, 233369),
(264707, '6ieoA02', NULL, NULL, 118, NULL, NULL, 233369),
(264708, '2anyA02', NULL, NULL, 114, NULL, NULL, 233369),
(264709, '1f7zA01', NULL, NULL, 130, NULL, NULL, 233369),
(264710, '1ntpA02', NULL, NULL, 103, NULL, NULL, 233369),
(264711, '1k2i101', NULL, NULL, 122, NULL, NULL, 233369),
(264712, '3govB02', NULL, NULL, 123, NULL, NULL, 233369),
(264713, '4ylqH01', NULL, NULL, 128, NULL, NULL, 233369),
(264714, '3f1sB03', NULL, NULL, 128, NULL, NULL, 233369),
(264715, '1t8oA02', NULL, NULL, 104, NULL, NULL, 233369),
(264716, '4k1tC01', NULL, NULL, 112, NULL, NULL, 233369),
(264717, '5hmaA02', NULL, NULL, 104, NULL, NULL, 233369),
(264718, '5hmaA01', NULL, NULL, 87, NULL, NULL, 233369),
(264719, '2f91A01', NULL, NULL, 124, NULL, NULL, 233369),
(264720, '2f91A02', NULL, NULL, 113, NULL, NULL, 233369),
(264721, '3f1sB02', NULL, NULL, 102, NULL, NULL, 233369),
(264722, '3f9eA01', NULL, NULL, 89, NULL, NULL, 233369),
(264723, '3gylB01', NULL, NULL, 135, NULL, NULL, 233369),
(264724, '3gylB02', NULL, NULL, 126, NULL, NULL, 233369),
(264725, '1yphC00', NULL, NULL, 131, NULL, NULL, 233369),
(264726, '4ashA01', NULL, NULL, 72, NULL, NULL, 233369),
(264727, '5mrrA02', NULL, NULL, 108, NULL, NULL, 233369),
(264728, '5mrrA01', NULL, NULL, 87, NULL, NULL, 233369),
(264729, '4ashA02', NULL, NULL, 113, NULL, NULL, 233369),
(264730, '2jkhA01', NULL, NULL, 128, NULL, NULL, 233369),
(264731, '2jkhA02', NULL, NULL, 113, NULL, NULL, 233369),
(264732, '1dleB02', NULL, NULL, 149, NULL, NULL, 233369),
(264733, '4bxsA02', NULL, NULL, 228, NULL, NULL, 233369),
(264734, '3o8bA02', NULL, NULL, 92, NULL, NULL, 233369),
(264735, '1eq9A01', NULL, NULL, 117, NULL, NULL, 233369),
(264736, '2o8mA02', NULL, NULL, 95, NULL, NULL, 233369),
(264737, '1eq9A02', NULL, NULL, 105, NULL, NULL, 233369),
(264738, '3qo6A02', NULL, NULL, 115, NULL, NULL, 233369),
(264739, '5c2zA02', NULL, NULL, 121, NULL, NULL, 233369),
(264740, '5c2zA01', NULL, NULL, 122, NULL, NULL, 233369),
(264741, '2j42A03', NULL, NULL, 103, NULL, NULL, 233370),
(264742, '3tewA03', NULL, NULL, 119, NULL, NULL, 233370),
(264743, '3khkB01', NULL, NULL, 185, NULL, NULL, 233371),
(264744, '3lkdB01', NULL, NULL, 191, NULL, NULL, 233371),
(264745, '3ufbA01', NULL, NULL, 170, NULL, NULL, 233371),
(264746, '2okcB01', NULL, NULL, 127, NULL, NULL, 233371),
(264747, '2ar0A01', NULL, NULL, 155, NULL, NULL, 233371),
(264748, '1wsrA03', NULL, NULL, 46, NULL, NULL, 233372),
(264749, '1wosA03', NULL, NULL, 41, NULL, NULL, 233372),
(264750, '3a8kA03', NULL, NULL, 45, NULL, NULL, 233372),
(264751, '3girA03', NULL, NULL, 46, NULL, NULL, 233372),
(264752, '1yx2A03', NULL, NULL, 44, NULL, NULL, 233372),
(264753, '1vloA03', NULL, NULL, 45, NULL, NULL, 233372),
(264754, '2nsfA02', NULL, NULL, 82, NULL, NULL, 233373),
(264755, '3nrtB00', NULL, NULL, 103, NULL, NULL, 233374),
(264756, '4i1tA01', NULL, NULL, 78, NULL, NULL, 233375),
(264757, '3jsbA01', NULL, NULL, 87, NULL, NULL, 233375),
(264758, '2lpbA00', NULL, NULL, 81, NULL, NULL, 233376),
(264759, '1im3D00', NULL, NULL, 95, NULL, NULL, 233377),
(264760, '1xrdA01', NULL, NULL, 43, NULL, NULL, 233378),
(264761, '6et5300', NULL, NULL, 59, NULL, NULL, 233378),
(264762, '1nkzA00', NULL, NULL, 53, NULL, NULL, 233378),
(264763, '5y5s100', NULL, NULL, 61, NULL, NULL, 233378);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(264764, '1lghA00', NULL, NULL, 56, NULL, NULL, 233378),
(264765, '1ijdA00', NULL, NULL, 53, NULL, NULL, 233378),
(264766, '3rf1A02', NULL, NULL, 79, NULL, NULL, 233379),
(264767, '5f5wD02', NULL, NULL, 81, NULL, NULL, 233379),
(264768, '1j5wB02', NULL, NULL, 82, NULL, NULL, 233379),
(264769, '3nkuA00', NULL, NULL, 213, NULL, NULL, 233380),
(264770, '5jvlA02', NULL, NULL, 88, NULL, NULL, 233381),
(264771, '1vbgA02', NULL, NULL, 85, NULL, NULL, 233381),
(264772, '1kblA05', NULL, NULL, 89, NULL, NULL, 233381),
(264773, '2x0sA02', NULL, NULL, 95, NULL, NULL, 233381),
(264774, '4hudA01', NULL, NULL, 231, NULL, NULL, 233382),
(264775, '1t0fC00', NULL, NULL, 54, NULL, NULL, 233383),
(264776, '1j8rA00', NULL, NULL, 196, NULL, NULL, 233384),
(264777, '4z3gA00', NULL, NULL, 198, NULL, NULL, 233384),
(264778, '3kihD00', NULL, NULL, 97, NULL, NULL, 233385),
(264779, '3kifD00', NULL, NULL, 106, NULL, NULL, 233385),
(264780, '4ixjA02', NULL, NULL, 147, NULL, NULL, 233386),
(264781, '2l2lA00', NULL, NULL, 43, NULL, NULL, 233387),
(264782, '4fzmA01', NULL, NULL, 125, NULL, NULL, 233388),
(264783, '3suuA01', NULL, NULL, 365, NULL, NULL, 233389),
(264784, '1cgtA01', NULL, NULL, 400, NULL, NULL, 233389),
(264785, '6d5cA00', NULL, NULL, 350, NULL, NULL, 233389),
(264786, '5ns6A00', NULL, NULL, 439, NULL, NULL, 233389),
(264787, '4rl3A00', NULL, NULL, 272, NULL, NULL, 233389),
(264788, '4iugA01', NULL, NULL, 355, NULL, NULL, 233389),
(264789, '4lx4B00', NULL, NULL, 330, NULL, NULL, 233389),
(264790, '2e8yA03', NULL, NULL, 426, NULL, NULL, 233389),
(264791, '4yn5A00', NULL, NULL, 403, NULL, NULL, 233389),
(264792, '2y24A02', NULL, NULL, 276, NULL, NULL, 233389),
(264793, '1egzA00', NULL, NULL, 291, NULL, NULL, 233389),
(264794, '1vjzA00', NULL, NULL, 325, NULL, NULL, 233389),
(264795, '5bn7A01', NULL, NULL, 393, NULL, NULL, 233389),
(264796, '3pztB00', NULL, NULL, 297, NULL, NULL, 233389),
(264797, '6mvgA03', NULL, NULL, 299, NULL, NULL, 233389),
(264798, '3hjeA01', NULL, NULL, 295, NULL, NULL, 233389),
(264799, '5cpsB01', NULL, NULL, 499, NULL, NULL, 233389),
(264800, '4f66A00', NULL, NULL, 480, NULL, NULL, 233389),
(264801, '3cz8A01', NULL, NULL, 262, NULL, NULL, 233389),
(264802, '2f2hA02', NULL, NULL, 371, NULL, NULL, 233389),
(264803, '3thdA01', NULL, NULL, 282, NULL, NULL, 233389),
(264804, '3ayrA00', NULL, NULL, 376, NULL, NULL, 233389),
(264805, '4ee9A00', NULL, NULL, 321, NULL, NULL, 233389),
(264806, '6f8nB01', NULL, NULL, 317, NULL, NULL, 233389),
(264807, '5a6mA02', NULL, NULL, 283, NULL, NULL, 233389),
(264808, '4xx6B00', NULL, NULL, 321, NULL, NULL, 233389),
(264809, '4q7nA01', NULL, NULL, 293, NULL, NULL, 233389),
(264810, '3wn6A01', NULL, NULL, 346, NULL, NULL, 233389),
(264811, '3wdhA03', NULL, NULL, 421, NULL, NULL, 233389),
(264812, '2c0hA00', NULL, NULL, 353, NULL, NULL, 233389),
(264813, '6mvhA03', NULL, NULL, 299, NULL, NULL, 233389),
(264814, '4e2oA01', NULL, NULL, 366, NULL, NULL, 233389),
(264815, '4tufA00', NULL, NULL, 346, NULL, NULL, 233389),
(264816, '1v6yA00', NULL, NULL, 324, NULL, NULL, 233389),
(264817, '1gcyA01', NULL, NULL, 360, NULL, NULL, 233389),
(264818, '4hu8A02', NULL, NULL, 378, NULL, NULL, 233389),
(264819, '4d6gA01', NULL, NULL, 363, NULL, NULL, 233389),
(264820, '4qfuE01', NULL, NULL, 254, NULL, NULL, 233389),
(264821, '2wmfA01', NULL, NULL, 339, NULL, NULL, 233389),
(264822, '4qawA02', NULL, NULL, 283, NULL, NULL, 233389),
(264823, '5x7gA02', NULL, NULL, 343, NULL, NULL, 233389),
(264824, '4amcA03', NULL, NULL, 242, NULL, NULL, 233389),
(264825, '1pbgA00', NULL, NULL, 468, NULL, NULL, 233389),
(264826, '1uuqA00', NULL, NULL, 419, NULL, NULL, 233389),
(264827, '2xhyD00', NULL, NULL, 479, NULL, NULL, 233389),
(264828, '1hx0A01', NULL, NULL, 403, NULL, NULL, 233389),
(264829, '3wh7A00', NULL, NULL, 457, NULL, NULL, 233389),
(264830, '3mu7A00', NULL, NULL, 273, NULL, NULL, 233389),
(264831, '3k1dA02', NULL, NULL, 396, NULL, NULL, 233389),
(264832, '2g3mA02', NULL, NULL, 376, NULL, NULL, 233389),
(264833, '4fk9A00', NULL, NULL, 318, NULL, NULL, 233389),
(264834, '4w8lA00', NULL, NULL, 352, NULL, NULL, 233389);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(264835, '3rcnA02', NULL, NULL, 349, NULL, NULL, 233389),
(264836, '1yhtA00', NULL, NULL, 367, NULL, NULL, 233389),
(264837, '1qnrA00', NULL, NULL, 344, NULL, NULL, 233389),
(264838, '2wc7A01', NULL, NULL, 397, NULL, NULL, 233389),
(264839, '1itxA01', NULL, NULL, 346, NULL, NULL, 233389),
(264840, '3wdpP00', NULL, NULL, 473, NULL, NULL, 233389),
(264841, '3oa5B02', NULL, NULL, 382, NULL, NULL, 233389),
(264842, '4re2A00', NULL, NULL, 487, NULL, NULL, 233389),
(264843, '2x8rB00', NULL, NULL, 210, NULL, NULL, 233389),
(264844, '1ht6A01', NULL, NULL, 346, NULL, NULL, 233389),
(264845, '5y6tA00', NULL, NULL, 365, NULL, NULL, 233389),
(264846, '3obaA03', NULL, NULL, 312, NULL, NULL, 233389),
(264847, '1aq0A00', NULL, NULL, 306, NULL, NULL, 233389),
(264848, '3wdqA00', NULL, NULL, 330, NULL, NULL, 233389),
(264849, '3cbwA00', NULL, NULL, 353, NULL, NULL, 233389),
(264850, '1e4mM00', NULL, NULL, 501, NULL, NULL, 233389),
(264851, '5e6zA02', NULL, NULL, 383, NULL, NULL, 233389),
(264852, '4bzyA01', NULL, NULL, 443, NULL, NULL, 233389),
(264853, '2nw0A00', NULL, NULL, 189, NULL, NULL, 233389),
(264854, '4uzsB01', NULL, NULL, 406, NULL, NULL, 233389),
(264855, '6i6rA02', NULL, NULL, 354, NULL, NULL, 233389),
(264856, '5yhsA00', NULL, NULL, 475, NULL, NULL, 233389),
(264857, '3topA03', NULL, NULL, 379, NULL, NULL, 233389),
(264858, '2cygA00', NULL, NULL, 312, NULL, NULL, 233389),
(264859, '4w8bA00', NULL, NULL, 386, NULL, NULL, 233389),
(264860, '1i1wA00', NULL, NULL, 303, NULL, NULL, 233389),
(264861, '1jakA01', NULL, NULL, 321, NULL, NULL, 233389),
(264862, '4mdpA00', NULL, NULL, 477, NULL, NULL, 233389),
(264863, '2xvlA03', NULL, NULL, 365, NULL, NULL, 233389),
(264864, '2dh2A01', NULL, NULL, 333, NULL, NULL, 233389),
(264865, '5ndxA02', NULL, NULL, 358, NULL, NULL, 233389),
(264866, '1wcgA00', NULL, NULL, 464, NULL, NULL, 233389),
(264867, '1smaA02', NULL, NULL, 326, NULL, NULL, 233389),
(264868, '6fmeA01', NULL, NULL, 352, NULL, NULL, 233389),
(264869, '2uy2A00', NULL, NULL, 294, NULL, NULL, 233389),
(264870, '4bs0A00', NULL, NULL, 318, NULL, NULL, 233389),
(264871, '6d25A02', NULL, NULL, 361, NULL, NULL, 233389),
(264872, '3ndzA00', NULL, NULL, 345, NULL, NULL, 233389),
(264873, '5fipB00', NULL, NULL, 334, NULL, NULL, 233389),
(264874, '4h41B00', NULL, NULL, 340, NULL, NULL, 233389),
(264875, '3aieA02', NULL, NULL, 254, NULL, NULL, 233389),
(264876, '1uokA01', NULL, NULL, 410, NULL, NULL, 233389),
(264877, '1ceoA00', NULL, NULL, 343, NULL, NULL, 233389),
(264878, '1nowA02', NULL, NULL, 359, NULL, NULL, 233389),
(264879, '4yztA01', NULL, NULL, 314, NULL, NULL, 233389),
(264880, '3dc0A01', NULL, NULL, 344, NULL, NULL, 233389),
(264881, '5e0cA01', NULL, NULL, 339, NULL, NULL, 233389),
(264882, '2y2wC02', NULL, NULL, 382, NULL, NULL, 233389),
(264883, '5i0fB03', NULL, NULL, 363, NULL, NULL, 233389),
(264884, '4u33A03', NULL, NULL, 371, NULL, NULL, 233389),
(264885, '2aaaA01', NULL, NULL, 374, NULL, NULL, 233389),
(264886, '2e4tA02', NULL, NULL, 388, NULL, NULL, 233389),
(264887, '5mrjA00', NULL, NULL, 307, NULL, NULL, 233389),
(264888, '1wzaA01', NULL, NULL, 340, NULL, NULL, 233389),
(264889, '5i78A00', NULL, NULL, 305, NULL, NULL, 233389),
(264890, '3pzgA00', NULL, NULL, 357, NULL, NULL, 233389),
(264891, '5t9gB03', NULL, NULL, 326, NULL, NULL, 233389),
(264892, '3ahyA00', NULL, NULL, 473, NULL, NULL, 233389),
(264893, '5d9oA01', NULL, NULL, 338, NULL, NULL, 233389),
(264894, '3kl0A02', NULL, NULL, 283, NULL, NULL, 233389),
(264895, '4w88B00', NULL, NULL, 340, NULL, NULL, 233389),
(264896, '3gycA00', NULL, NULL, 393, NULL, NULL, 233389),
(264897, '4m29A02', NULL, NULL, 339, NULL, NULL, 233389),
(264898, '1m53A01', NULL, NULL, 423, NULL, NULL, 233389),
(264899, '4dwsA02', NULL, NULL, 421, NULL, NULL, 233389),
(264900, '4aeeA03', NULL, NULL, 324, NULL, NULL, 233389),
(264901, '4hpgA00', NULL, NULL, 316, NULL, NULL, 233389),
(264902, '1wzlA02', NULL, NULL, 326, NULL, NULL, 233389),
(264903, '5a57A02', NULL, NULL, 294, NULL, NULL, 233389),
(264904, '4w5zA00', NULL, NULL, 323, NULL, NULL, 233389),
(264905, '3zizA00', NULL, NULL, 359, NULL, NULL, 233389);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(264906, '1jz7A03', NULL, NULL, 291, NULL, NULL, 233389),
(264907, '4w7wA00', NULL, NULL, 313, NULL, NULL, 233389),
(264908, '4tx6B00', NULL, NULL, 310, NULL, NULL, 233389),
(264909, '2ddxA00', NULL, NULL, 333, NULL, NULL, 233389),
(264910, '1hjqA00', NULL, NULL, 332, NULL, NULL, 233389),
(264911, '2j78A00', NULL, NULL, 444, NULL, NULL, 233389),
(264912, '6gl2A00', NULL, NULL, 337, NULL, NULL, 233389),
(264913, '2yocB04', NULL, NULL, 580, NULL, NULL, 233389),
(264914, '4y7eA00', NULL, NULL, 311, NULL, NULL, 233389),
(264915, '6hpfA00', NULL, NULL, 312, NULL, NULL, 233389),
(264916, '4iplB00', NULL, NULL, 470, NULL, NULL, 233389),
(264917, '1g0cA00', NULL, NULL, 364, NULL, NULL, 233389),
(264918, '3clwA02', NULL, NULL, 391, NULL, NULL, 233389),
(264919, '1b31A00', NULL, NULL, 302, NULL, NULL, 233389),
(264920, '1tg7A01', NULL, NULL, 355, NULL, NULL, 233389),
(264921, '3edfA02', NULL, NULL, 419, NULL, NULL, 233389),
(264922, '3gnpA00', NULL, NULL, 488, NULL, NULL, 233389),
(264923, '4xb3A01', NULL, NULL, 399, NULL, NULL, 233389),
(264924, '1kfwA01', NULL, NULL, 372, NULL, NULL, 233389),
(264925, '3u7bA00', NULL, NULL, 327, NULL, NULL, 233389),
(264926, '2w5fA02', NULL, NULL, 361, NULL, NULL, 233389),
(264927, '2zxqA02', NULL, NULL, 296, NULL, NULL, 233389),
(264928, '6b6lA03', NULL, NULL, 281, NULL, NULL, 233389),
(264929, '3vgfA02', NULL, NULL, 362, NULL, NULL, 233389),
(264930, '2vzsA03', NULL, NULL, 339, NULL, NULL, 233389),
(264931, '4toqA00', NULL, NULL, 273, NULL, NULL, 233389),
(264932, '2w61A01', NULL, NULL, 324, NULL, NULL, 233389),
(264933, '3vupA00', NULL, NULL, 351, NULL, NULL, 233389),
(264934, '2v5cA02', NULL, NULL, 316, NULL, NULL, 233389),
(264935, '3gm8A03', NULL, NULL, 340, NULL, NULL, 233389),
(264936, '1gjwA01', NULL, NULL, 568, NULL, NULL, 233389),
(264937, '6q6nB01', NULL, NULL, 380, NULL, NULL, 233389),
(264938, '4j3vA03', NULL, NULL, 580, NULL, NULL, 233389),
(264939, '4e8dA01', NULL, NULL, 274, NULL, NULL, 233389),
(264940, '4ff5A00', NULL, NULL, 229, NULL, NULL, 233389),
(264941, '4jcmA01', NULL, NULL, 385, NULL, NULL, 233389),
(264942, '5ay7B00', NULL, NULL, 355, NULL, NULL, 233389),
(264943, '3viiA00', NULL, NULL, 487, NULL, NULL, 233389),
(264944, '3eypA01', NULL, NULL, 315, NULL, NULL, 233389),
(264945, '4cu7A03', NULL, NULL, 335, NULL, NULL, 233389),
(264946, '3nydA00', NULL, NULL, 316, NULL, NULL, 233389),
(264947, '1ll7A01', NULL, NULL, 329, NULL, NULL, 233389),
(264948, '4aysA02', NULL, NULL, 405, NULL, NULL, 233389),
(264949, '3ttyA01', NULL, NULL, 393, NULL, NULL, 233389),
(264950, '2wagA00', NULL, NULL, 220, NULL, NULL, 233389),
(264951, '1odzA00', NULL, NULL, 386, NULL, NULL, 233389),
(264952, '4aefA03', NULL, NULL, 385, NULL, NULL, 233389),
(264953, '1iv8A01', NULL, NULL, 305, NULL, NULL, 233389),
(264954, '2d1zA01', NULL, NULL, 300, NULL, NULL, 233389),
(264955, '5jbkA00', NULL, NULL, 466, NULL, NULL, 233389),
(264956, '2x1iA00', NULL, NULL, 500, NULL, NULL, 233389),
(264957, '1ghsA00', NULL, NULL, 306, NULL, NULL, 233389),
(264958, '5l9cA00', NULL, NULL, 314, NULL, NULL, 233389),
(264959, '5do8C01', NULL, NULL, 411, NULL, NULL, 233389),
(264960, '4jclA01', NULL, NULL, 401, NULL, NULL, 233389),
(264961, '2ebnA00', NULL, NULL, 289, NULL, NULL, 233389),
(264962, '4c7gA02', NULL, NULL, 321, NULL, NULL, 233389),
(264963, '3og2A01', NULL, NULL, 357, NULL, NULL, 233389),
(264964, '6gn6A01', NULL, NULL, 324, NULL, NULL, 233389),
(264965, '2ya0A02', NULL, NULL, 482, NULL, NULL, 233389),
(264966, '1v02A00', NULL, NULL, 484, NULL, NULL, 233389),
(264967, '5uhxA00', NULL, NULL, 323, NULL, NULL, 233389),
(264968, '3aj7A01', NULL, NULL, 436, NULL, NULL, 233389),
(264969, '1h4pA00', NULL, NULL, 408, NULL, NULL, 233389),
(264970, '5h2tA01', NULL, NULL, 393, NULL, NULL, 233389),
(264971, '5i0dA03', NULL, NULL, 381, NULL, NULL, 233389),
(264972, '3g6mA01', NULL, NULL, 325, NULL, NULL, 233389),
(264973, '2xfrA00', NULL, NULL, 489, NULL, NULL, 233389),
(264974, '2y8vA01', NULL, NULL, 273, NULL, NULL, 233389),
(264975, '4wf7A01', NULL, NULL, 395, NULL, NULL, 233389),
(264976, '5c71A03', NULL, NULL, 329, NULL, NULL, 233389);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(264977, '1ea9C02', NULL, NULL, 326, NULL, NULL, 233389),
(264978, '4zxoA00', NULL, NULL, 352, NULL, NULL, 233389),
(264979, '4nf7A00', NULL, NULL, 363, NULL, NULL, 233389),
(264980, '3tp4B01', NULL, NULL, 371, NULL, NULL, 233389),
(264981, '2y8kA01', NULL, NULL, 314, NULL, NULL, 233389),
(264982, '5okaA00', NULL, NULL, 485, NULL, NULL, 233389),
(264983, '4r27B00', NULL, NULL, 411, NULL, NULL, 233389),
(264984, '5xgzA00', NULL, NULL, 457, NULL, NULL, 233389),
(264985, '1gnxA00', NULL, NULL, 479, NULL, NULL, 233389),
(264986, '5idiA00', NULL, NULL, 452, NULL, NULL, 233389),
(264987, '6mvfA03', NULL, NULL, 301, NULL, NULL, 233389),
(264988, '1us2A02', NULL, NULL, 371, NULL, NULL, 233389),
(264989, '4lxfB01', NULL, NULL, 419, NULL, NULL, 233389),
(264990, '3wugA00', NULL, NULL, 313, NULL, NULL, 233389),
(264991, '3lppA03', NULL, NULL, 350, NULL, NULL, 233389),
(264992, '3emzA00', NULL, NULL, 331, NULL, NULL, 233389),
(264993, '3w53A00', NULL, NULL, 471, NULL, NULL, 233389),
(264994, '3qr3A00', NULL, NULL, 340, NULL, NULL, 233389),
(264995, '5gnxB00', NULL, NULL, 467, NULL, NULL, 233389),
(264996, '3zo9A01', NULL, NULL, 394, NULL, NULL, 233389),
(264997, '3hn3A03', NULL, NULL, 303, NULL, NULL, 233389),
(264998, '5z4tA00', NULL, NULL, 309, NULL, NULL, 233389),
(264999, '4bq2D02', NULL, NULL, 546, NULL, NULL, 233389),
(265000, '3ik2A02', NULL, NULL, 390, NULL, NULL, 233389),
(265001, '1rh9A00', NULL, NULL, 373, NULL, NULL, 233389),
(265002, '5un8C01', NULL, NULL, 281, NULL, NULL, 233389),
(265003, '2dieA01', NULL, NULL, 293, NULL, NULL, 233389),
(265004, '1ur1A00', NULL, NULL, 353, NULL, NULL, 233389),
(265005, '6ddtA03', NULL, NULL, 366, NULL, NULL, 233389),
(265006, '4im4A00', NULL, NULL, 336, NULL, NULL, 233389),
(265007, '3ii1A02', NULL, NULL, 402, NULL, NULL, 233389),
(265008, '3wh9A00', NULL, NULL, 345, NULL, NULL, 233389),
(265009, '2vr5A02', NULL, NULL, 445, NULL, NULL, 233389),
(265010, '4madA01', NULL, NULL, 284, NULL, NULL, 233389),
(265011, '2gsjA00', NULL, NULL, 271, NULL, NULL, 233389),
(265012, '4jklA03', NULL, NULL, 327, NULL, NULL, 233389),
(265013, '5l77A02', NULL, NULL, 325, NULL, NULL, 233389),
(265014, '4ypjA03', NULL, NULL, 320, NULL, NULL, 233389),
(265015, '3bmvA01', NULL, NULL, 400, NULL, NULL, 233389),
(265016, '4pmuB00', NULL, NULL, 356, NULL, NULL, 233389),
(265017, '3zssA03', NULL, NULL, 367, NULL, NULL, 233389),
(265018, '2osxA02', NULL, NULL, 350, NULL, NULL, 233389),
(265019, '1g5aA02', NULL, NULL, 385, NULL, NULL, 233389),
(265020, '3arxA02', NULL, NULL, 387, NULL, NULL, 233389),
(265021, '4jkmA03', NULL, NULL, 324, NULL, NULL, 233389),
(265022, '1j0hA02', NULL, NULL, 326, NULL, NULL, 233389),
(265023, '5brqA01', NULL, NULL, 414, NULL, NULL, 233389),
(265024, '3lpfA03', NULL, NULL, 330, NULL, NULL, 233389),
(265025, '5hosA00', NULL, NULL, 316, NULL, NULL, 233389),
(265026, '2c7fA02', NULL, NULL, 368, NULL, NULL, 233389),
(265027, '4atdA00', NULL, NULL, 513, NULL, NULL, 233389),
(265028, '5n6uA03', NULL, NULL, 338, NULL, NULL, 233389),
(265029, '4az6A01', NULL, NULL, 367, NULL, NULL, 233389),
(265030, '3u7vA01', NULL, NULL, 373, NULL, NULL, 233389),
(265031, '1h49A00', NULL, NULL, 512, NULL, NULL, 233389),
(265032, '2j8gA01', NULL, NULL, 188, NULL, NULL, 233389),
(265033, '2eplX02', NULL, NULL, 321, NULL, NULL, 233389),
(265034, '4p8vA01', NULL, NULL, 302, NULL, NULL, 233389),
(265035, '4ccdA01', NULL, NULL, 278, NULL, NULL, 233389),
(265036, '3wflA00', NULL, NULL, 342, NULL, NULL, 233389),
(265037, '1r85A00', NULL, NULL, 379, NULL, NULL, 233389),
(265038, '6bycA03', NULL, NULL, 354, NULL, NULL, 233389),
(265039, '4gxpC00', NULL, NULL, 467, NULL, NULL, 233389),
(265040, '2ww5A02', NULL, NULL, 202, NULL, NULL, 233389),
(265041, '3ahxC00', NULL, NULL, 453, NULL, NULL, 233389),
(265042, '5y3xA00', NULL, NULL, 329, NULL, NULL, 233389),
(265043, '1wpcA01', NULL, NULL, 293, NULL, NULL, 233389),
(265044, '1tz7B00', NULL, NULL, 487, NULL, NULL, 233389),
(265045, '2zuvA01', NULL, NULL, 328, NULL, NULL, 233389),
(265046, '4htyA00', NULL, NULL, 330, NULL, NULL, 233389),
(265047, '2zxdA01', NULL, NULL, 356, NULL, NULL, 233389);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(265048, '3alfA01', NULL, NULL, 283, NULL, NULL, 233389),
(265049, '4oouA00', NULL, NULL, 369, NULL, NULL, 233389),
(265050, '6epbA01', NULL, NULL, 326, NULL, NULL, 233389),
(265051, '5z6pA02', NULL, NULL, 543, NULL, NULL, 233389),
(265052, '5nn4A03', NULL, NULL, 344, NULL, NULL, 233389),
(265053, '3wq5B00', NULL, NULL, 474, NULL, NULL, 233389),
(265054, '3w0kA00', NULL, NULL, 330, NULL, NULL, 233389),
(265055, '5ihsA00', NULL, NULL, 306, NULL, NULL, 233389),
(265056, '3ebvA00', NULL, NULL, 302, NULL, NULL, 233389),
(265057, '5ifpA01', NULL, NULL, 354, NULL, NULL, 233389),
(265058, '2xsaA01', NULL, NULL, 277, NULL, NULL, 233389),
(265059, '3o2lA00', NULL, NULL, 317, NULL, NULL, 233389),
(265060, '1wkyA01', NULL, NULL, 304, NULL, NULL, 233389),
(265061, '4tvcA03', NULL, NULL, 248, NULL, NULL, 233389),
(265062, '2hvmA00', NULL, NULL, 273, NULL, NULL, 233389),
(265063, '3f5lA00', NULL, NULL, 481, NULL, NULL, 233389),
(265064, '1cbgA00', NULL, NULL, 490, NULL, NULL, 233389),
(265065, '1e4iA00', NULL, NULL, 447, NULL, NULL, 233389),
(265066, '1qoxA00', NULL, NULL, 449, NULL, NULL, 233389),
(265067, '3fawA03', NULL, NULL, 475, NULL, NULL, 233389),
(265068, '2jepB00', NULL, NULL, 362, NULL, NULL, 233389),
(265069, '6bjqA03', NULL, NULL, 324, NULL, NULL, 233389),
(265070, '4aw7A02', NULL, NULL, 331, NULL, NULL, 233389),
(265071, '5m17A00', NULL, NULL, 350, NULL, NULL, 233389),
(265072, '1l8nA02', NULL, NULL, 333, NULL, NULL, 233389),
(265073, '3qokA01', NULL, NULL, 323, NULL, NULL, 233389),
(265074, '4mb1A01', NULL, NULL, 412, NULL, NULL, 233389),
(265075, '1vemA01', NULL, NULL, 416, NULL, NULL, 233389),
(265076, '1ud2A01', NULL, NULL, 291, NULL, NULL, 233389),
(265077, '3aquA01', NULL, NULL, 289, NULL, NULL, 233389),
(265078, '3pohA02', NULL, NULL, 292, NULL, NULL, 233389),
(265079, '3weoA02', NULL, NULL, 342, NULL, NULL, 233389),
(265080, '3qgvA01', NULL, NULL, 337, NULL, NULL, 233389),
(265081, '4jz5A00', NULL, NULL, 206, NULL, NULL, 233389),
(265082, '1qw9A02', NULL, NULL, 364, NULL, NULL, 233389),
(265083, '5jawA01', NULL, NULL, 383, NULL, NULL, 233389),
(265084, '4bf7A00', NULL, NULL, 335, NULL, NULL, 233389),
(265085, '3zm8A02', NULL, NULL, 317, NULL, NULL, 233389),
(265086, '5a2bA01', NULL, NULL, 363, NULL, NULL, 233389),
(265087, '3oihA00', NULL, NULL, 272, NULL, NULL, 233389),
(265088, '3ucqA02', NULL, NULL, 400, NULL, NULL, 233389),
(265089, '4m82A00', NULL, NULL, 399, NULL, NULL, 233389),
(265090, '3w4rA01', NULL, NULL, 305, NULL, NULL, 233389),
(265091, '5ofkA00', NULL, NULL, 339, NULL, NULL, 233389),
(265092, '3dhpA01', NULL, NULL, 403, NULL, NULL, 233389),
(265093, '2gjxA02', NULL, NULL, 365, NULL, NULL, 233389),
(265094, '1gqiA02', NULL, NULL, 320, NULL, NULL, 233389),
(265095, '1eokA00', NULL, NULL, 290, NULL, NULL, 233389),
(265096, '4howA01', NULL, NULL, 410, NULL, NULL, 233389),
(265097, '4psrA01', NULL, NULL, 374, NULL, NULL, 233389),
(265098, '1c7sA03', NULL, NULL, 484, NULL, NULL, 233389),
(265099, '1hjxA01', NULL, NULL, 292, NULL, NULL, 233389),
(265100, '3vx0A01', NULL, NULL, 374, NULL, NULL, 233389),
(265101, '3bh4A01', NULL, NULL, 292, NULL, NULL, 233389),
(265102, '4s3jB02', NULL, NULL, 272, NULL, NULL, 233389),
(265103, '5fkyA02', NULL, NULL, 286, NULL, NULL, 233389),
(265104, '1fobA00', NULL, NULL, 334, NULL, NULL, 233389),
(265105, '1ug6A00', NULL, NULL, 431, NULL, NULL, 233389),
(265106, '6fheA00', NULL, NULL, 339, NULL, NULL, 233389),
(265107, '5a95A00', NULL, NULL, 338, NULL, NULL, 233389),
(265108, '5jouA03', NULL, NULL, 363, NULL, NULL, 233389),
(265109, '2wnwA02', NULL, NULL, 339, NULL, NULL, 233389),
(265110, '3bc9A02', NULL, NULL, 294, NULL, NULL, 233389),
(265111, '1n82A00', NULL, NULL, 331, NULL, NULL, 233389),
(265112, '4qp0A00', NULL, NULL, 359, NULL, NULL, 233389),
(265113, '5efdA00', NULL, NULL, 355, NULL, NULL, 233389),
(265114, '1kwgA01', NULL, NULL, 394, NULL, NULL, 233389),
(265115, '4lypB00', NULL, NULL, 417, NULL, NULL, 233389),
(265116, '1xyzA00', NULL, NULL, 322, NULL, NULL, 233389),
(265117, '6au1A00', NULL, NULL, 357, NULL, NULL, 233389),
(265118, '3niyA00', NULL, NULL, 341, NULL, NULL, 233389);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(265119, '3rdkB00', NULL, NULL, 341, NULL, NULL, 233389),
(265120, '3qomA00', NULL, NULL, 481, NULL, NULL, 233389),
(265121, '1eceA00', NULL, NULL, 358, NULL, NULL, 233389),
(265122, '3decA03', NULL, NULL, 281, NULL, NULL, 233389),
(265123, '5x7uA01', NULL, NULL, 390, NULL, NULL, 233389),
(265124, '5m0kA00', NULL, NULL, 299, NULL, NULL, 233389),
(265125, '4cd8A00', NULL, NULL, 320, NULL, NULL, 233389),
(265126, '3czgA02', NULL, NULL, 397, NULL, NULL, 233389),
(265127, '5axgA02', NULL, NULL, 340, NULL, NULL, 233389),
(265128, '3vmnA02', NULL, NULL, 380, NULL, NULL, 233389),
(265129, '1w32A00', NULL, NULL, 348, NULL, NULL, 233389),
(265130, '5cxpA02', NULL, NULL, 279, NULL, NULL, 233389),
(265131, '4aieA01', NULL, NULL, 398, NULL, NULL, 233389),
(265132, '3bxwA02', NULL, NULL, 273, NULL, NULL, 233389),
(265133, '5navA00', NULL, NULL, 461, NULL, NULL, 233389),
(265134, '1narA00', NULL, NULL, 290, NULL, NULL, 233389),
(265135, '1edqA02', NULL, NULL, 355, NULL, NULL, 233389),
(265136, '2vtfA01', NULL, NULL, 354, NULL, NULL, 233389),
(265137, '4uozA01', NULL, NULL, 410, NULL, NULL, 233389),
(265138, '4ba0A02', NULL, NULL, 378, NULL, NULL, 233389),
(265139, '4xuyA00', NULL, NULL, 302, NULL, NULL, 233389),
(265140, '4gklA01', NULL, NULL, 334, NULL, NULL, 233389),
(265141, '3zr5A02', NULL, NULL, 304, NULL, NULL, 233389),
(265142, '3hmcA00', NULL, NULL, 192, NULL, NULL, 233389),
(265143, '2je8A03', NULL, NULL, 347, NULL, NULL, 233389),
(265144, '2fhfA04', NULL, NULL, 580, NULL, NULL, 233389),
(265145, '5fooF00', NULL, NULL, 462, NULL, NULL, 233389),
(265146, '2dgaA00', NULL, NULL, 491, NULL, NULL, 233389),
(265147, '2wanA04', NULL, NULL, 422, NULL, NULL, 233389),
(265148, '1vffA00', NULL, NULL, 423, NULL, NULL, 233389),
(265149, '3vm7A01', NULL, NULL, 372, NULL, NULL, 233389),
(265150, '5a6sA01', NULL, NULL, 194, NULL, NULL, 233389),
(265151, '1np2A00', NULL, NULL, 436, NULL, NULL, 233389),
(265152, '4acyA00', NULL, NULL, 346, NULL, NULL, 233389),
(265153, '1ur4A00', NULL, NULL, 399, NULL, NULL, 233389),
(265154, '1edgA00', NULL, NULL, 380, NULL, NULL, 233389),
(265155, '1sfsA00', NULL, NULL, 213, NULL, NULL, 233389),
(265156, '5jbdA02', NULL, NULL, 254, NULL, NULL, 233389),
(265157, '5ecuA00', NULL, NULL, 351, NULL, NULL, 233389),
(265158, '5jiwA00', NULL, NULL, 500, NULL, NULL, 233389),
(265159, '4aziA01', NULL, NULL, 357, NULL, NULL, 233389),
(265160, '6gxvA01', NULL, NULL, 294, NULL, NULL, 233389),
(265161, '3n12A00', NULL, NULL, 333, NULL, NULL, 233389),
(265162, '1w9pA01', NULL, NULL, 332, NULL, NULL, 233389),
(265163, '1jaeA01', NULL, NULL, 379, NULL, NULL, 233389),
(265164, '3m07A02', NULL, NULL, 380, NULL, NULL, 233389),
(265165, '1zjaA01', NULL, NULL, 409, NULL, NULL, 233389),
(265166, '4eamA00', NULL, NULL, 489, NULL, NULL, 233389),
(265167, '4aweA00', NULL, NULL, 387, NULL, NULL, 233389),
(265168, '2ze0A01', NULL, NULL, 404, NULL, NULL, 233389),
(265169, '1h1nA00', NULL, NULL, 305, NULL, NULL, 233389),
(265170, '1qvbA00', NULL, NULL, 481, NULL, NULL, 233389),
(265171, '5bwiA02', NULL, NULL, 304, NULL, NULL, 233389),
(265172, '3aiuA00', NULL, NULL, 486, NULL, NULL, 233389),
(265173, '4uriB01', NULL, NULL, 278, NULL, NULL, 233389),
(265174, '5m7uB01', NULL, NULL, 284, NULL, NULL, 233389),
(265175, '2whlA00', NULL, NULL, 294, NULL, NULL, 233389),
(265176, '5zcrA01', NULL, NULL, 300, NULL, NULL, 233389),
(265177, '5xzoA00', NULL, NULL, 335, NULL, NULL, 233389),
(265178, '4j7rA02', NULL, NULL, 514, NULL, NULL, 233389),
(265179, '4w5uB01', NULL, NULL, 309, NULL, NULL, 233389),
(265180, '1cygA01', NULL, NULL, 396, NULL, NULL, 233389),
(265181, '4a4aA03', NULL, NULL, 331, NULL, NULL, 233389),
(265182, '5jboA00', NULL, NULL, 485, NULL, NULL, 233389),
(265183, '1jndA01', NULL, NULL, 326, NULL, NULL, 233389),
(265184, '5hbfA01', NULL, NULL, 390, NULL, NULL, 233389),
(265185, '4hz8A00', NULL, NULL, 444, NULL, NULL, 233389),
(265186, '4k68B00', NULL, NULL, 346, NULL, NULL, 233389),
(265187, '4ac1X01', NULL, NULL, 264, NULL, NULL, 233389),
(265188, '1mxgA01', NULL, NULL, 337, NULL, NULL, 233389),
(265189, '4s3kA02', NULL, NULL, 273, NULL, NULL, 233389);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(265190, '4mnkA01', NULL, NULL, 283, NULL, NULL, 233389),
(265191, '5gqbA02', NULL, NULL, 354, NULL, NULL, 233389),
(265192, '4xzwA00', NULL, NULL, 313, NULL, NULL, 233389),
(265193, '1w91A02', NULL, NULL, 345, NULL, NULL, 233389),
(265194, '4yheA00', NULL, NULL, 389, NULL, NULL, 233389),
(265195, '2depA00', NULL, NULL, 356, NULL, NULL, 233389),
(265196, '3l4yA03', NULL, NULL, 350, NULL, NULL, 233389),
(265197, '4xv0A00', NULL, NULL, 302, NULL, NULL, 233389),
(265198, '4pmxA00', NULL, NULL, 306, NULL, NULL, 233389),
(265199, '4v2xA01', NULL, NULL, 334, NULL, NULL, 233389),
(265200, '3qhoA00', NULL, NULL, 377, NULL, NULL, 233389),
(265201, '2wpgA02', NULL, NULL, 398, NULL, NULL, 233389),
(265202, '5cgmA03', NULL, NULL, 371, NULL, NULL, 233389),
(265203, '3cuiA00', NULL, NULL, 315, NULL, NULL, 233389),
(265204, '5cg0F00', NULL, NULL, 489, NULL, NULL, 233389),
(265205, '2yihA02', NULL, NULL, 389, NULL, NULL, 233389),
(265206, '3ur8A00', NULL, NULL, 323, NULL, NULL, 233389),
(265207, '3ug3A02', NULL, NULL, 341, NULL, NULL, 233389),
(265208, '1ta3A00', NULL, NULL, 274, NULL, NULL, 233389),
(265209, '4fmvA02', NULL, NULL, 280, NULL, NULL, 233389),
(265210, '1ua7A01', NULL, NULL, 344, NULL, NULL, 233389),
(265211, '5jipA01', NULL, NULL, 230, NULL, NULL, 233389),
(265212, '1v0lA00', NULL, NULL, 313, NULL, NULL, 233389),
(265213, '2bhuA02', NULL, NULL, 370, NULL, NULL, 233389),
(265214, '1bf2A02', NULL, NULL, 474, NULL, NULL, 233389),
(265215, '3bgaA03', NULL, NULL, 281, NULL, NULL, 233389),
(265216, '3ianA00', NULL, NULL, 321, NULL, NULL, 233389),
(265217, '4m1rA00', NULL, NULL, 296, NULL, NULL, 233389),
(265218, '1bqcA00', NULL, NULL, 302, NULL, NULL, 233389),
(265219, '1d3cA01', NULL, NULL, 400, NULL, NULL, 233389),
(265220, '3wnoA02', NULL, NULL, 343, NULL, NULL, 233389),
(265221, '4kruA00', NULL, NULL, 229, NULL, NULL, 233389),
(265222, '4f8xA00', NULL, NULL, 335, NULL, NULL, 233389),
(265223, '1tuxA00', NULL, NULL, 301, NULL, NULL, 233389),
(265224, '5gqwA03', NULL, NULL, 422, NULL, NULL, 233389),
(265225, '4ha4A00', NULL, NULL, 489, NULL, NULL, 233389),
(265226, '3aofA00', NULL, NULL, 317, NULL, NULL, 233389),
(265227, '2o9pA00', NULL, NULL, 454, NULL, NULL, 233389),
(265228, '6idnA00', NULL, NULL, 272, NULL, NULL, 233389),
(265229, '4n0rA02', NULL, NULL, 310, NULL, NULL, 233389),
(265230, '2dskA00', NULL, NULL, 311, NULL, NULL, 233389),
(265231, '5z1aA03', NULL, NULL, 308, NULL, NULL, 233389),
(265232, '1g94A01', NULL, NULL, 354, NULL, NULL, 233389),
(265233, '3ncoA00', NULL, NULL, 320, NULL, NULL, 233389),
(265234, '2gjpA01', NULL, NULL, 293, NULL, NULL, 233389),
(265235, '1avaA01', NULL, NULL, 345, NULL, NULL, 233389),
(265236, '3vocA00', NULL, NULL, 419, NULL, NULL, 233389),
(265237, '1e40A01', NULL, NULL, 396, NULL, NULL, 233389),
(265238, '5z0uA02', NULL, NULL, 412, NULL, NULL, 233389),
(265239, '2e3zB00', NULL, NULL, 465, NULL, NULL, 233389),
(265240, '3w25A00', NULL, NULL, 336, NULL, NULL, 233389),
(265241, '1tvnA00', NULL, NULL, 293, NULL, NULL, 233389),
(265242, '4wsjB01', NULL, NULL, 356, NULL, NULL, 233389),
(265243, '1goiA01', NULL, NULL, 358, NULL, NULL, 233389),
(265244, '4p7oB00', NULL, NULL, 367, NULL, NULL, 233389),
(265245, '2uwfA00', NULL, NULL, 356, NULL, NULL, 233389),
(265246, '7a3hA00', NULL, NULL, 303, NULL, NULL, 233389),
(265247, '1ta3B00', NULL, NULL, 303, NULL, NULL, 233389),
(265248, '5ot1A02', NULL, NULL, 357, NULL, NULL, 233389),
(265249, '3vm5A01', NULL, NULL, 404, NULL, NULL, 233389),
(265250, '2cksB00', NULL, NULL, 306, NULL, NULL, 233389),
(265251, '2jf7B00', NULL, NULL, 473, NULL, NULL, 233389),
(265252, '6ed1A03', NULL, NULL, 302, NULL, NULL, 233389),
(265253, '5d8zA00', NULL, NULL, 326, NULL, NULL, 233389),
(265254, '4oifB01', NULL, NULL, 407, NULL, NULL, 233389),
(265255, '4cd5A00', NULL, NULL, 367, NULL, NULL, 233389),
(265256, '3dhuA01', NULL, NULL, 353, NULL, NULL, 233389),
(265257, '1wdpA00', NULL, NULL, 495, NULL, NULL, 233389),
(265258, '5u3aA01', NULL, NULL, 403, NULL, NULL, 233389),
(265259, '2e9lA00', NULL, NULL, 469, NULL, NULL, 233389),
(265260, '4uzuA01', NULL, NULL, 292, NULL, NULL, 233389);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(265261, '3amlA01', NULL, NULL, 470, NULL, NULL, 233389),
(265262, '3ozoA02', NULL, NULL, 388, NULL, NULL, 233389),
(265263, '5h4rA00', NULL, NULL, 375, NULL, NULL, 233389),
(265264, '4b15A00', NULL, NULL, 266, NULL, NULL, 233389),
(265265, '4axnA00', NULL, NULL, 328, NULL, NULL, 233389),
(265266, '4wiwD01', NULL, NULL, 280, NULL, NULL, 233389),
(265267, '1nq6A00', NULL, NULL, 302, NULL, NULL, 233389),
(265268, '3wy1A01', NULL, NULL, 394, NULL, NULL, 233389),
(265269, '3simA00', NULL, NULL, 275, NULL, NULL, 233389),
(265270, '5dezA02', NULL, NULL, 356, NULL, NULL, 233389),
(265271, '5bxrA02', NULL, NULL, 345, NULL, NULL, 233389),
(265272, '5f7cA02', NULL, NULL, 315, NULL, NULL, 233389),
(265273, '1vjsA01', NULL, NULL, 294, NULL, NULL, 233389),
(265274, '4pysA02', NULL, NULL, 377, NULL, NULL, 233389),
(265275, '6c9xA02', NULL, NULL, 383, NULL, NULL, 233389),
(265276, '5dmyB03', NULL, NULL, 345, NULL, NULL, 233389),
(265277, '6bs6A02', NULL, NULL, 356, NULL, NULL, 233389),
(265278, '2vrqA02', NULL, NULL, 361, NULL, NULL, 233389),
(265279, '1hjsA00', NULL, NULL, 332, NULL, NULL, 233389),
(265280, '2v3gA00', NULL, NULL, 283, NULL, NULL, 233389),
(265281, '3uesB01', NULL, NULL, 356, NULL, NULL, 233389),
(265282, '1edtA00', NULL, NULL, 271, NULL, NULL, 233389),
(265283, '3d3aA01', NULL, NULL, 276, NULL, NULL, 233389),
(265284, '4ptxA00', NULL, NULL, 452, NULL, NULL, 233389),
(265285, '5e9aA01', NULL, NULL, 398, NULL, NULL, 233389),
(265286, '5bywE00', NULL, NULL, 323, NULL, NULL, 233389),
(265287, '5t99A03', NULL, NULL, 320, NULL, NULL, 233389),
(265288, '2pi6A01', NULL, NULL, 293, NULL, NULL, 233389),
(265289, '1yq2A03', NULL, NULL, 297, NULL, NULL, 233389),
(265290, '5wkaB00', NULL, NULL, 473, NULL, NULL, 233389),
(265291, '1x1nA01', NULL, NULL, 503, NULL, NULL, 233389),
(265292, '5i2uB00', NULL, NULL, 303, NULL, NULL, 233389),
(265293, '2w91A01', NULL, NULL, 355, NULL, NULL, 233389),
(265294, '2wskA02', NULL, NULL, 439, NULL, NULL, 233389),
(265295, '1lwjA01', NULL, NULL, 326, NULL, NULL, 233389),
(265296, '1vf8A01', NULL, NULL, 306, NULL, NULL, 233389),
(265297, '6fhfA00', NULL, NULL, 362, NULL, NULL, 233389),
(265298, '5wqsA00', NULL, NULL, 498, NULL, NULL, 233389),
(265299, '5uj6A03', NULL, NULL, 313, NULL, NULL, 233389),
(265300, '3fy1A01', NULL, NULL, 306, NULL, NULL, 233389),
(265301, '4pmdA00', NULL, NULL, 338, NULL, NULL, 233389),
(265302, '5zceA01', NULL, NULL, 406, NULL, NULL, 233389),
(265303, '5m99A01', NULL, NULL, 353, NULL, NULL, 233389),
(265304, '3gzaA01', NULL, NULL, 346, NULL, NULL, 233389),
(265305, '4tx8A02', NULL, NULL, 321, NULL, NULL, 233389),
(265306, '6cafA00', NULL, NULL, 299, NULL, NULL, 233389),
(265307, '2z1kA01', NULL, NULL, 390, NULL, NULL, 233389),
(265308, '1qhoA01', NULL, NULL, 401, NULL, NULL, 233389),
(265309, '4wkaA01', NULL, NULL, 308, NULL, NULL, 233389),
(265310, '1pamA01', NULL, NULL, 400, NULL, NULL, 233389),
(265311, '3kzsA01', NULL, NULL, 241, NULL, NULL, 233389),
(265312, '3fndA01', NULL, NULL, 268, NULL, NULL, 233389),
(265313, '1jfxA00', NULL, NULL, 217, NULL, NULL, 233389),
(265314, '3fn9A03', NULL, NULL, 302, NULL, NULL, 233389),
(265315, '6gerA00', NULL, NULL, 490, NULL, NULL, 233389),
(265316, '4pmoA00', NULL, NULL, 211, NULL, NULL, 233389),
(265317, '3zmrB02', NULL, NULL, 384, NULL, NULL, 233389),
(265318, '1uhvA02', NULL, NULL, 344, NULL, NULL, 233389),
(265319, '5ac5A02', NULL, NULL, 321, NULL, NULL, 233389),
(265320, '3ptmA00', NULL, NULL, 478, NULL, NULL, 233389),
(265321, '4xzbA00', NULL, NULL, 314, NULL, NULL, 233389),
(265322, '5dt7B00', NULL, NULL, 448, NULL, NULL, 233389),
(265323, '4cvuA03', NULL, NULL, 390, NULL, NULL, 233389),
(265324, '3gbeA01', NULL, NULL, 409, NULL, NULL, 233389),
(265325, '3rbyA01', NULL, NULL, 150, NULL, NULL, 233390),
(265326, '5j47A02', NULL, NULL, 118, NULL, NULL, 233391),
(265327, '1svmA02', NULL, NULL, 118, NULL, NULL, 233391),
(265328, '4bvaB01', NULL, NULL, 150, NULL, NULL, 233392),
(265329, '1x7dB01', NULL, NULL, 180, NULL, NULL, 233392),
(265330, '4mp8A01', NULL, NULL, 166, NULL, NULL, 233392),
(265331, '2i99A01', NULL, NULL, 150, NULL, NULL, 233392);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(265332, '1omoA01', NULL, NULL, 151, NULL, NULL, 233392),
(265333, '3hdjA01', NULL, NULL, 142, NULL, NULL, 233392),
(265334, '5gmkO00', NULL, NULL, 341, NULL, NULL, 233393),
(265335, '2hesX00', NULL, NULL, 330, NULL, NULL, 233393),
(265336, '4j82A01', NULL, NULL, 294, NULL, NULL, 233393),
(265337, '4nsxA02', NULL, NULL, 317, NULL, NULL, 233393),
(265338, '4yvdA01', NULL, NULL, 296, NULL, NULL, 233393),
(265339, '4nsxA01', NULL, NULL, 348, NULL, NULL, 233393),
(265340, '6fkkA01', NULL, NULL, 477, NULL, NULL, 233393),
(265341, '1pguB02', NULL, NULL, 325, NULL, NULL, 233393),
(265342, '1pguB01', NULL, NULL, 290, NULL, NULL, 233393),
(265343, '3sbqA01', NULL, NULL, 460, NULL, NULL, 233393),
(265344, '3a0fA02', NULL, NULL, 425, NULL, NULL, 233393),
(265345, '6mglA01', NULL, NULL, 340, NULL, NULL, 233393),
(265346, '3a0fA01', NULL, NULL, 338, NULL, NULL, 233393),
(265347, '3fm0A00', NULL, NULL, 345, NULL, NULL, 233393),
(265348, '4u7aA00', NULL, NULL, 356, NULL, NULL, 233393),
(265349, '4d0kA01', NULL, NULL, 322, NULL, NULL, 233393),
(265350, '6mglA02', NULL, NULL, 407, NULL, NULL, 233393),
(265351, '4aowA01', NULL, NULL, 310, NULL, NULL, 233393),
(265352, '4czxA00', NULL, NULL, 324, NULL, NULL, 233393),
(265353, '4ozuA01', NULL, NULL, 351, NULL, NULL, 233393),
(265354, '3okyB01', NULL, NULL, 499, NULL, NULL, 233393),
(265355, '4bh6D00', NULL, NULL, 308, NULL, NULL, 233393),
(265356, '5u69A00', NULL, NULL, 369, NULL, NULL, 233393),
(265357, '5fktA02', NULL, NULL, 414, NULL, NULL, 233393),
(265358, '5c2vB00', NULL, NULL, 352, NULL, NULL, 233393),
(265359, '5i5mA01', NULL, NULL, 454, NULL, NULL, 233393),
(265360, '3dwlH00', NULL, NULL, 377, NULL, NULL, 233393),
(265361, '4qrjA00', NULL, NULL, 353, NULL, NULL, 233393),
(265362, '2cn2A02', NULL, NULL, 411, NULL, NULL, 233393),
(265363, '3u4yA00', NULL, NULL, 331, NULL, NULL, 233393),
(265364, '1nr0A01', NULL, NULL, 299, NULL, NULL, 233393),
(265365, '2bbkH00', NULL, NULL, 355, NULL, NULL, 233393),
(265366, '4fwwA01', NULL, NULL, 481, NULL, NULL, 233393),
(265367, '5tf2A00', NULL, NULL, 344, NULL, NULL, 233393),
(265368, '2qc5A00', NULL, NULL, 300, NULL, NULL, 233393),
(265369, '5optp01', NULL, NULL, 313, NULL, NULL, 233393),
(265370, '1nr0A02', NULL, NULL, 312, NULL, NULL, 233393),
(265371, '4xyhA00', NULL, NULL, 414, NULL, NULL, 233393),
(265372, '3b7fA00', NULL, NULL, 394, NULL, NULL, 233393),
(265373, '4lg8A00', NULL, NULL, 310, NULL, NULL, 233393),
(265374, '1jofA00', NULL, NULL, 365, NULL, NULL, 233393),
(265375, '3bg1A00', NULL, NULL, 316, NULL, NULL, 233393),
(265376, '4zoxA00', NULL, NULL, 381, NULL, NULL, 233393),
(265377, '5h1mA01', NULL, NULL, 347, NULL, NULL, 233393),
(265378, '6fcvB00', NULL, NULL, 365, NULL, NULL, 233393),
(265379, '5wjcA00', NULL, NULL, 430, NULL, NULL, 233393),
(265380, '3v7dD02', NULL, NULL, 355, NULL, NULL, 233393),
(265381, '2ovrB02', NULL, NULL, 340, NULL, NULL, 233393),
(265382, '6m90A02', NULL, NULL, 295, NULL, NULL, 233393),
(265383, '2aq5A01', NULL, NULL, 352, NULL, NULL, 233393),
(265384, '4a2lB01', NULL, NULL, 311, NULL, NULL, 233393),
(265385, '4j0xA00', NULL, NULL, 451, NULL, NULL, 233393),
(265386, '5b4wA00', NULL, NULL, 456, NULL, NULL, 233393),
(265387, '1ri6A00', NULL, NULL, 343, NULL, NULL, 233393),
(265388, '5k19C00', NULL, NULL, 391, NULL, NULL, 233393),
(265389, '3nvxB00', NULL, NULL, 383, NULL, NULL, 233393),
(265390, '1sqjB01', NULL, NULL, 331, NULL, NULL, 233393),
(265391, '1sqjB02', NULL, NULL, 451, NULL, NULL, 233393),
(265392, '1jmxB00', NULL, NULL, 349, NULL, NULL, 233393),
(265393, '1erjB00', NULL, NULL, 393, NULL, NULL, 233393),
(265394, '4l9oA00', NULL, NULL, 349, NULL, NULL, 233393),
(265395, '3dm0A02', NULL, NULL, 324, NULL, NULL, 233393),
(265396, '3fgbA00', NULL, NULL, 361, NULL, NULL, 233393),
(265397, '4u1eI00', NULL, NULL, 347, NULL, NULL, 233393),
(265398, '4i79A00', NULL, NULL, 341, NULL, NULL, 233393),
(265399, '5fktB01', NULL, NULL, 319, NULL, NULL, 233393),
(265400, '2xzmR01', NULL, NULL, 330, NULL, NULL, 233393),
(265401, '3v9fA01', NULL, NULL, 342, NULL, NULL, 233393),
(265402, '4ql1A00', NULL, NULL, 312, NULL, NULL, 233393);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(265403, '3v9fA02', NULL, NULL, 313, NULL, NULL, 233393),
(265404, '3ei3B02', NULL, NULL, 318, NULL, NULL, 233393),
(265405, '3frxB01', NULL, NULL, 310, NULL, NULL, 233393),
(265406, '5gmkn00', NULL, NULL, 328, NULL, NULL, 233393),
(265407, '3jbtA06', NULL, NULL, 312, NULL, NULL, 233393),
(265408, '3jbtA05', NULL, NULL, 357, NULL, NULL, 233393),
(265409, '2z2nA00', NULL, NULL, 299, NULL, NULL, 233393),
(265410, '4hdjA00', NULL, NULL, 367, NULL, NULL, 233393),
(265411, '2pm9A01', NULL, NULL, 336, NULL, NULL, 233393),
(265412, '4h5iB00', NULL, NULL, 347, NULL, NULL, 233393),
(265413, '3mmyA00', NULL, NULL, 368, NULL, NULL, 233393),
(265414, '1mdaH00', NULL, NULL, 368, NULL, NULL, 233393),
(265415, '3c5mA00', NULL, NULL, 396, NULL, NULL, 233393),
(265416, '4wjvD00', NULL, NULL, 381, NULL, NULL, 233393),
(265417, '2iwkA01', NULL, NULL, 467, NULL, NULL, 233393),
(265418, '3pe7A00', NULL, NULL, 388, NULL, NULL, 233393),
(265419, '3f3fB01', NULL, NULL, 306, NULL, NULL, 233393),
(265420, '4j87A00', NULL, NULL, 327, NULL, NULL, 233393),
(265421, '5wbyC01', NULL, NULL, 313, NULL, NULL, 233393),
(265422, '1xksA00', NULL, NULL, 413, NULL, NULL, 233393),
(265423, '3dsmA00', NULL, NULL, 328, NULL, NULL, 233393),
(265424, '3w15A01', NULL, NULL, 365, NULL, NULL, 233393),
(265425, '2cn3A01', NULL, NULL, 326, NULL, NULL, 233393),
(265426, '4lg9A00', NULL, NULL, 363, NULL, NULL, 233393),
(265427, '4o9dA00', NULL, NULL, 428, NULL, NULL, 233393),
(265428, '3ottA01', NULL, NULL, 307, NULL, NULL, 233393),
(265429, '6nauA00', NULL, NULL, 334, NULL, NULL, 233393),
(265430, '3jamg01', NULL, NULL, 316, NULL, NULL, 233393),
(265431, '4aezA00', NULL, NULL, 343, NULL, NULL, 233393),
(265432, '4ui9R01', NULL, NULL, 303, NULL, NULL, 233393),
(265433, '3ei3A02', NULL, NULL, 342, NULL, NULL, 233393),
(265434, '3ei3A01', NULL, NULL, 385, NULL, NULL, 233393),
(265435, '4pxwB00', NULL, NULL, 322, NULL, NULL, 233393),
(265436, '1l0qA01', NULL, NULL, 301, NULL, NULL, 233393),
(265437, '4e54B02', NULL, NULL, 323, NULL, NULL, 233393),
(265438, '1gxrA00', NULL, NULL, 337, NULL, NULL, 233393),
(265439, '1vyhC01', NULL, NULL, 310, NULL, NULL, 233393),
(265440, '4zoyA00', NULL, NULL, 457, NULL, NULL, 233393),
(265441, '4gq1A00', NULL, NULL, 393, NULL, NULL, 233393),
(265442, '2ymuA01', NULL, NULL, 300, NULL, NULL, 233393),
(265443, '5ic7A00', NULL, NULL, 365, NULL, NULL, 233393),
(265444, '3ei3A03', NULL, NULL, 316, NULL, NULL, 233393),
(265445, '1xipA00', NULL, NULL, 388, NULL, NULL, 233393),
(265446, '3jb9L00', NULL, NULL, 299, NULL, NULL, 233393),
(265447, '3bwsA02', NULL, NULL, 323, NULL, NULL, 233393),
(265448, '6az1g01', NULL, NULL, 309, NULL, NULL, 233393),
(265449, '1k32A02', NULL, NULL, 350, NULL, NULL, 233393),
(265450, '6igbA00', NULL, NULL, 364, NULL, NULL, 233393),
(265451, '1fwxA01', NULL, NULL, 467, NULL, NULL, 233393),
(265452, '5cxbA02', NULL, NULL, 394, NULL, NULL, 233393),
(265453, '3odtA00', NULL, NULL, 313, NULL, NULL, 233393),
(265454, '2uzxB01', NULL, NULL, 490, NULL, NULL, 233393),
(265455, '4ggcA00', NULL, NULL, 318, NULL, NULL, 233393),
(265456, '5hqgA00', NULL, NULL, 341, NULL, NULL, 233393),
(265457, '1yfqA00', NULL, NULL, 342, NULL, NULL, 233393),
(265458, '1olzA01', NULL, NULL, 481, NULL, NULL, 233393),
(265459, '1s4uX00', NULL, NULL, 407, NULL, NULL, 233393),
(265460, '5kdoB00', NULL, NULL, 340, NULL, NULL, 233393),
(265461, '5kwnA00', NULL, NULL, 336, NULL, NULL, 233393),
(265462, '2oizA01', NULL, NULL, 344, NULL, NULL, 233393),
(265463, '3al9A01', NULL, NULL, 479, NULL, NULL, 233393),
(265464, '1k8kC00', NULL, NULL, 372, NULL, NULL, 233393),
(265465, '5teeA01', NULL, NULL, 369, NULL, NULL, 233393),
(265466, '4g56D00', NULL, NULL, 318, NULL, NULL, 233393),
(265467, '2xyiA00', NULL, NULL, 430, NULL, NULL, 233393),
(265468, '4a2lF02', NULL, NULL, 322, NULL, NULL, 233393),
(265469, '6e1zA00', NULL, NULL, 313, NULL, NULL, 233393),
(265470, '5teeA02', NULL, NULL, 351, NULL, NULL, 233393),
(265471, '2w18A00', NULL, NULL, 333, NULL, NULL, 233393),
(265472, '1pbyB00', NULL, NULL, 337, NULL, NULL, 233393),
(265473, '3hfqA00', NULL, NULL, 347, NULL, NULL, 233393);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(265474, '3ottB02', NULL, NULL, 317, NULL, NULL, 233393),
(265475, '3ow8C00', NULL, NULL, 301, NULL, NULL, 233393),
(265476, '3nvnA00', NULL, NULL, 389, NULL, NULL, 233393),
(265477, '4d6vA01', NULL, NULL, 307, NULL, NULL, 233393),
(265478, '4pswB00', NULL, NULL, 401, NULL, NULL, 233393),
(265479, '6id1E00', NULL, NULL, 304, NULL, NULL, 233393),
(265480, '3i2nA00', NULL, NULL, 357, NULL, NULL, 233393),
(265481, '4gqbB00', NULL, NULL, 322, NULL, NULL, 233393),
(265482, '5jwzA02', NULL, NULL, 411, NULL, NULL, 233393),
(265483, '5jwzA01', NULL, NULL, 313, NULL, NULL, 233393),
(265484, '2xu7A00', NULL, NULL, 425, NULL, NULL, 233393),
(265485, '1r5mA00', NULL, NULL, 392, NULL, NULL, 233393),
(265486, '5xyig01', NULL, NULL, 310, NULL, NULL, 233393),
(265487, '3jb9K01', NULL, NULL, 295, NULL, NULL, 233393),
(265488, '3sfzA05', NULL, NULL, 347, NULL, NULL, 233393),
(265489, '3sfzA06', NULL, NULL, 312, NULL, NULL, 233393),
(265490, '3cfsB00', NULL, NULL, 414, NULL, NULL, 233393),
(265491, '4j0wA00', NULL, NULL, 343, NULL, NULL, 233393),
(265492, '1q47A00', NULL, NULL, 495, NULL, NULL, 233393),
(265493, '5cxbB00', NULL, NULL, 369, NULL, NULL, 233393),
(265494, '4lgnA02', NULL, NULL, 414, NULL, NULL, 233393),
(265495, '3nvqA01', NULL, NULL, 448, NULL, NULL, 233393),
(265496, '4cy3A00', NULL, NULL, 316, NULL, NULL, 233393),
(265497, '2pm7D01', NULL, NULL, 288, NULL, NULL, 233393),
(265498, '3scyA00', NULL, NULL, 361, NULL, NULL, 233393),
(265499, '4lgnA01', NULL, NULL, 335, NULL, NULL, 233393),
(265500, '1qniF01', NULL, NULL, 439, NULL, NULL, 233393),
(265501, '4immA00', NULL, NULL, 355, NULL, NULL, 233393),
(265502, '4ci8A02', NULL, NULL, 313, NULL, NULL, 233393),
(265503, '3vgzC00', NULL, NULL, 323, NULL, NULL, 233393),
(265504, '2pbiB00', NULL, NULL, 354, NULL, NULL, 233393),
(265505, '4ci8A01', NULL, NULL, 342, NULL, NULL, 233393),
(265506, '3jrpA01', NULL, NULL, 363, NULL, NULL, 233393),
(265507, '3c75H00', NULL, NULL, 375, NULL, NULL, 233393),
(265508, '2mbyA00', NULL, NULL, 46, NULL, NULL, 233394),
(265509, '2yvsA02', NULL, NULL, 59, NULL, NULL, 233395),
(265510, '4lh9A00', NULL, NULL, 40, NULL, NULL, 233396),
(265511, '1r8iA00', NULL, NULL, 194, NULL, NULL, 233397),
(265512, '5b1aF00', NULL, NULL, 98, NULL, NULL, 233398),
(265513, '5z62F00', NULL, NULL, 98, NULL, NULL, 233398),
(265514, '4fxdA06', NULL, NULL, 172, NULL, NULL, 233399),
(265515, '3iayA07', NULL, NULL, 152, NULL, NULL, 233399),
(265516, '2gv9B06', NULL, NULL, 203, NULL, NULL, 233399),
(265517, '3k59A07', NULL, NULL, 145, NULL, NULL, 233399),
(265518, '1tgoA05', NULL, NULL, 167, NULL, NULL, 233399),
(265519, '4qclA05', NULL, NULL, 181, NULL, NULL, 233399),
(265520, '4ahcA05', NULL, NULL, 134, NULL, NULL, 233399),
(265521, '2mdfA00', NULL, NULL, 57, NULL, NULL, 233400),
(265522, '3i5pA03', NULL, NULL, 244, NULL, NULL, 233401),
(265523, '4i66A00', NULL, NULL, 209, NULL, NULL, 233402),
(265524, '2bpoA02', NULL, NULL, 145, NULL, NULL, 233403),
(265525, '2qtlA01', NULL, NULL, 179, NULL, NULL, 233403),
(265526, '1f20A02', NULL, NULL, 159, NULL, NULL, 233403),
(265527, '1ja1A03', NULL, NULL, 126, NULL, NULL, 233403),
(265528, '5gxuB02', NULL, NULL, 132, NULL, NULL, 233403),
(265529, '1ddgA02', NULL, NULL, 105, NULL, NULL, 233403),
(265530, '4dqlA02', NULL, NULL, 122, NULL, NULL, 233403),
(265531, '3qfsA02', NULL, NULL, 129, NULL, NULL, 233403),
(265532, '1e2tA02', NULL, NULL, 94, NULL, NULL, 233404),
(265533, '1wiwA01', NULL, NULL, 126, NULL, NULL, 233405),
(265534, '3d36C01', NULL, NULL, 34, NULL, NULL, 233406),
(265535, '1pv0A01', NULL, NULL, 34, NULL, NULL, 233406),
(265536, '1wr8A02', NULL, NULL, 69, NULL, NULL, 233407),
(265537, '1l6rA02', NULL, NULL, 64, NULL, NULL, 233407),
(265538, '1s2oA02', NULL, NULL, 71, NULL, NULL, 233407),
(265539, '3h09A03', NULL, NULL, 88, NULL, NULL, 233408),
(265540, '1wxrA03', NULL, NULL, 76, NULL, NULL, 233408),
(265541, '3dohA01', NULL, NULL, 140, NULL, NULL, 233409),
(265542, '1qu7A00', NULL, NULL, 227, NULL, NULL, 233410),
(265543, '2ch7B00', NULL, NULL, 309, NULL, NULL, 233410),
(265544, '3zx6A00', NULL, NULL, 305, NULL, NULL, 233410);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(265545, '3g67A00', NULL, NULL, 213, NULL, NULL, 233410),
(265546, '2xsbA02', NULL, NULL, 170, NULL, NULL, 233411),
(265547, '1uurA01', NULL, NULL, 117, NULL, NULL, 233411),
(265548, '4dixA02', NULL, NULL, 131, NULL, NULL, 233412),
(265549, '3n6yA01', NULL, NULL, 112, NULL, NULL, 233413),
(265550, '1nd9A00', NULL, NULL, 49, NULL, NULL, 233414),
(265551, '1odhA02', NULL, NULL, 59, NULL, NULL, 233415),
(265552, '2i06A01', NULL, NULL, 214, NULL, NULL, 233416),
(265553, '2o9xA01', NULL, NULL, 103, NULL, NULL, 233417),
(265554, '2xzm901', NULL, NULL, 72, NULL, NULL, 233418),
(265555, '2xzn901', NULL, NULL, 72, NULL, NULL, 233418),
(265556, '2k4xA01', NULL, NULL, 35, NULL, NULL, 233418),
(265557, '4bpe901', NULL, NULL, 69, NULL, NULL, 233418),
(265558, '4kbmB02', NULL, NULL, 102, NULL, NULL, 233419),
(265559, '4xaxB02', NULL, NULL, 99, NULL, NULL, 233419),
(265560, '2lt3A01', NULL, NULL, 100, NULL, NULL, 233419),
(265561, '4kmcA00', NULL, NULL, 80, NULL, NULL, 233419),
(265562, '2k9yA00', NULL, NULL, 41, NULL, NULL, 233420),
(265563, '6igzJ00', NULL, NULL, 41, NULL, NULL, 233420),
(265564, '4il6X00', NULL, NULL, 40, NULL, NULL, 233420),
(265565, '5l8rJ00', NULL, NULL, 42, NULL, NULL, 233420),
(265566, '5zjiJ00', NULL, NULL, 42, NULL, NULL, 233420),
(265567, '1zrtE01', NULL, NULL, 41, NULL, NULL, 233420),
(265568, '1vf5B01', NULL, NULL, 46, NULL, NULL, 233420),
(265569, '1jb0J00', NULL, NULL, 41, NULL, NULL, 233420),
(265570, '2lpfA01', NULL, NULL, 27, NULL, NULL, 233420),
(265571, '2qjyC01', NULL, NULL, 41, NULL, NULL, 233420),
(265572, '3c8vA04', NULL, NULL, 19, NULL, NULL, 233420),
(265573, '2o01J01', NULL, NULL, 25, NULL, NULL, 233420),
(265574, '1q90D01', NULL, NULL, 56, NULL, NULL, 233420),
(265575, '2wpvB01', NULL, NULL, 24, NULL, NULL, 233420),
(265576, '6ijjJ00', NULL, NULL, 41, NULL, NULL, 233420),
(265577, '4ogqB01', NULL, NULL, 58, NULL, NULL, 233420),
(265578, '5oy0700', NULL, NULL, 40, NULL, NULL, 233420),
(265579, '4i7zB01', NULL, NULL, 58, NULL, NULL, 233420),
(265580, '3lw5J00', NULL, NULL, 42, NULL, NULL, 233420),
(265581, '2yiuC01', NULL, NULL, 29, NULL, NULL, 233420),
(265582, '2qsiA02', NULL, NULL, 38, NULL, NULL, 233420),
(265583, '2qiwA02', NULL, NULL, 19, NULL, NULL, 233420),
(265584, '2wscJ00', NULL, NULL, 44, NULL, NULL, 233420),
(265585, '3d34B01', NULL, NULL, 176, NULL, NULL, 233421),
(265586, '3q13A01', NULL, NULL, 213, NULL, NULL, 233421),
(265587, '1mrzB02', NULL, NULL, 134, NULL, NULL, 233422),
(265588, '5trdA02', NULL, NULL, 140, NULL, NULL, 233422),
(265589, '1nb0A00', NULL, NULL, 147, NULL, NULL, 233422),
(265590, '5a89A00', NULL, NULL, 156, NULL, NULL, 233422),
(265591, '2vbuA01', NULL, NULL, 134, NULL, NULL, 233422),
(265592, '3bnwB00', NULL, NULL, 181, NULL, NULL, 233422),
(265593, '1n08A00', NULL, NULL, 163, NULL, NULL, 233422),
(265594, '3op1B02', NULL, NULL, 119, NULL, NULL, 233422),
(265595, '2ghjB02', NULL, NULL, 66, NULL, NULL, 233423),
(265596, '1vs9O02', NULL, NULL, 62, NULL, NULL, 233423),
(265597, '2memA00', NULL, NULL, 119, NULL, NULL, 233424),
(265598, '1m8oB00', NULL, NULL, 47, NULL, NULL, 233425),
(265599, '3qa8A04', NULL, NULL, 249, NULL, NULL, 233426),
(265600, '3qa8H03', NULL, NULL, 184, NULL, NULL, 233426),
(265601, '4kikA03', NULL, NULL, 276, NULL, NULL, 233426),
(265602, '3pstA01', NULL, NULL, 89, NULL, NULL, 233427),
(265603, '2k89A00', NULL, NULL, 80, NULL, NULL, 233427),
(265604, '3l3fX01', NULL, NULL, 64, NULL, NULL, 233427),
(265605, '4i0wB02', NULL, NULL, 142, NULL, NULL, 233428),
(265606, '1mzgB00', NULL, NULL, 146, NULL, NULL, 233429),
(265607, '1q48A00', NULL, NULL, 134, NULL, NULL, 233429),
(265608, '4eb5C00', NULL, NULL, 153, NULL, NULL, 233429),
(265609, '3g0mA00', NULL, NULL, 141, NULL, NULL, 233429),
(265610, '3lvlA01', NULL, NULL, 103, NULL, NULL, 233429),
(265611, '5wkpH01', NULL, NULL, 102, NULL, NULL, 233429),
(265612, '2z7eC00', NULL, NULL, 138, NULL, NULL, 233429),
(265613, '1su0B00', NULL, NULL, 141, NULL, NULL, 233429),
(265614, '5xt5C00', NULL, NULL, 155, NULL, NULL, 233429),
(265615, '2kqkA01', NULL, NULL, 102, NULL, NULL, 233429);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(265616, '4lw4D00', NULL, NULL, 150, NULL, NULL, 233429),
(265617, '2qq4I00', NULL, NULL, 138, NULL, NULL, 233429),
(265618, '1wloA00', NULL, NULL, 136, NULL, NULL, 233429),
(265619, '2yh6D00', NULL, NULL, 112, NULL, NULL, 233430),
(265620, '1krlA00', NULL, NULL, 44, NULL, NULL, 233431),
(265621, '1x9yA01', NULL, NULL, 176, NULL, NULL, 233432),
(265622, '3g4nA02', NULL, NULL, 173, NULL, NULL, 233433),
(265623, '3griB01', NULL, NULL, 111, NULL, NULL, 233434),
(265624, '4ub9A01', NULL, NULL, 100, NULL, NULL, 233434),
(265625, '1kcxA01', NULL, NULL, 110, NULL, NULL, 233434),
(265626, '2g3fA01', NULL, NULL, 123, NULL, NULL, 233434),
(265627, '2vhlB01', NULL, NULL, 95, NULL, NULL, 233434),
(265628, '3qgaC01', NULL, NULL, 187, NULL, NULL, 233434),
(265629, '4bknB01', NULL, NULL, 124, NULL, NULL, 233434),
(265630, '4m51A01', NULL, NULL, 102, NULL, NULL, 233434),
(265631, '1gkrB01', NULL, NULL, 137, NULL, NULL, 233434),
(265632, '1gkpA01', NULL, NULL, 81, NULL, NULL, 233434),
(265633, '3feqA01', NULL, NULL, 120, NULL, NULL, 233434),
(265634, '2gwnA01', NULL, NULL, 98, NULL, NULL, 233434),
(265635, '4yiwB01', NULL, NULL, 115, NULL, NULL, 233434),
(265636, '4c65B01', NULL, NULL, 120, NULL, NULL, 233434),
(265637, '3ooqF01', NULL, NULL, 105, NULL, NULL, 233434),
(265638, '2z00A01', NULL, NULL, 107, NULL, NULL, 233434),
(265639, '5nksA01', NULL, NULL, 123, NULL, NULL, 233434),
(265640, '4cqbA01', NULL, NULL, 101, NULL, NULL, 233434),
(265641, '2oodA01', NULL, NULL, 152, NULL, NULL, 233434),
(265642, '4r85A01', NULL, NULL, 96, NULL, NULL, 233434),
(265643, '3sfwA01', NULL, NULL, 133, NULL, NULL, 233434),
(265644, '1rk6A01', NULL, NULL, 87, NULL, NULL, 233434),
(265645, '2qs8A01', NULL, NULL, 111, NULL, NULL, 233434),
(265646, '3mkvA01', NULL, NULL, 120, NULL, NULL, 233434),
(265647, '4z42C01', NULL, NULL, 191, NULL, NULL, 233434),
(265648, '1gkqA01', NULL, NULL, 121, NULL, NULL, 233434),
(265649, '2q09A01', NULL, NULL, 117, NULL, NULL, 233434),
(265650, '2vunA01', NULL, NULL, 128, NULL, NULL, 233434),
(265651, '3mtwA01', NULL, NULL, 101, NULL, NULL, 233434),
(265652, '1p1mA01', NULL, NULL, 103, NULL, NULL, 233434),
(265653, '4dzhA01', NULL, NULL, 145, NULL, NULL, 233434),
(265654, '1nfgB01', NULL, NULL, 87, NULL, NULL, 233434),
(265655, '2icsA01', NULL, NULL, 112, NULL, NULL, 233434),
(265656, '5yz5A01', NULL, NULL, 132, NULL, NULL, 233434),
(265657, '3ggmA00', NULL, NULL, 81, NULL, NULL, 233434),
(265658, '1onwA01', NULL, NULL, 111, NULL, NULL, 233434),
(265659, '3ls9A01', NULL, NULL, 112, NULL, NULL, 233434),
(265660, '5ol4C01', NULL, NULL, 189, NULL, NULL, 233434),
(265661, '2p9bA01', NULL, NULL, 110, NULL, NULL, 233434),
(265662, '4f0lB01', NULL, NULL, 115, NULL, NULL, 233434),
(265663, '1k1dA01', NULL, NULL, 132, NULL, NULL, 233434),
(265664, '5x1cA01', NULL, NULL, 111, NULL, NULL, 233434),
(265665, '1ynyA01', NULL, NULL, 133, NULL, NULL, 233434),
(265666, '2puzA01', NULL, NULL, 120, NULL, NULL, 233434),
(265667, '4f0sA01', NULL, NULL, 144, NULL, NULL, 233434),
(265668, '5lxxA01', NULL, NULL, 104, NULL, NULL, 233434),
(265669, '1gkpB01', NULL, NULL, 129, NULL, NULL, 233434),
(265670, '1gkrA01', NULL, NULL, 87, NULL, NULL, 233434),
(265671, '3iv8A01', NULL, NULL, 94, NULL, NULL, 233434),
(265672, '2ftyA01', NULL, NULL, 94, NULL, NULL, 233434),
(265673, '1e9yB01', NULL, NULL, 187, NULL, NULL, 233434),
(265674, '4ep8C01', NULL, NULL, 185, NULL, NULL, 233434),
(265675, '3hm7B01', NULL, NULL, 96, NULL, NULL, 233434),
(265676, '3icjA01', NULL, NULL, 79, NULL, NULL, 233434),
(265677, '4aqlA01', NULL, NULL, 135, NULL, NULL, 233434),
(265678, '3hpaA01', NULL, NULL, 119, NULL, NULL, 233434),
(265679, '4b3zD01', NULL, NULL, 123, NULL, NULL, 233434),
(265680, '4gy7A02', NULL, NULL, 194, NULL, NULL, 233434),
(265681, '2gokA01', NULL, NULL, 114, NULL, NULL, 233434),
(265682, '2ogjC01', NULL, NULL, 131, NULL, NULL, 233434),
(265683, '2ogjA01', NULL, NULL, 130, NULL, NULL, 233434),
(265684, '1yrrA01', NULL, NULL, 92, NULL, NULL, 233434),
(265685, '5xgwA01', NULL, NULL, 112, NULL, NULL, 233434),
(265686, '4whbA01', NULL, NULL, 97, NULL, NULL, 233434);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(265687, '4g7eA02', NULL, NULL, 194, NULL, NULL, 233434),
(265688, '3be7A01', NULL, NULL, 108, NULL, NULL, 233434),
(265689, '3mduA01', NULL, NULL, 109, NULL, NULL, 233434),
(265690, '3ighX01', NULL, NULL, 90, NULL, NULL, 233434),
(265691, '3e74A01', NULL, NULL, 86, NULL, NULL, 233434),
(265692, '2pajA01', NULL, NULL, 128, NULL, NULL, 233434),
(265693, '1o12A01', NULL, NULL, 88, NULL, NULL, 233434),
(265694, '5mkvD01', NULL, NULL, 131, NULL, NULL, 233434),
(265695, '1xrtB01', NULL, NULL, 113, NULL, NULL, 233434),
(265696, '3lnpA01', NULL, NULL, 140, NULL, NULL, 233434),
(265697, '3nqbA01', NULL, NULL, 127, NULL, NULL, 233434),
(265698, '2i9uA01', NULL, NULL, 131, NULL, NULL, 233434),
(265699, '4v1xB01', NULL, NULL, 116, NULL, NULL, 233434),
(265700, '4gbdB01', NULL, NULL, 135, NULL, NULL, 233434),
(265701, '1ra0A01', NULL, NULL, 122, NULL, NULL, 233434),
(265702, '1nfgA01', NULL, NULL, 89, NULL, NULL, 233434),
(265703, '3gipA01', NULL, NULL, 90, NULL, NULL, 233434),
(265704, '2imrA01', NULL, NULL, 69, NULL, NULL, 233434),
(265705, '3u61A03', NULL, NULL, 84, NULL, NULL, 233435),
(265706, '2lyyA00', NULL, NULL, 96, NULL, NULL, 233436),
(265707, '2bs2A04', NULL, NULL, 94, NULL, NULL, 233437),
(265708, '2jqqA00', NULL, NULL, 154, NULL, NULL, 233438),
(265709, '1qksA02', NULL, NULL, 432, NULL, NULL, 233439),
(265710, '1nirA02', NULL, NULL, 427, NULL, NULL, 233439),
(265711, '2mm4A00', NULL, NULL, 58, NULL, NULL, 233440),
(265712, '3pieC02', NULL, NULL, 139, NULL, NULL, 233441),
(265713, '1k4tA04', NULL, NULL, 179, NULL, NULL, 233442),
(265714, '1rr8C04', NULL, NULL, 109, NULL, NULL, 233442),
(265715, '1a35A04', NULL, NULL, 97, NULL, NULL, 233442),
(265716, '2jn9A01', NULL, NULL, 91, NULL, NULL, 233443),
(265717, '4ipeB02', NULL, NULL, 173, NULL, NULL, 233444),
(265718, '3q6mA01', NULL, NULL, 138, NULL, NULL, 233444),
(265719, '2cgeA01', NULL, NULL, 136, NULL, NULL, 233444),
(265720, '3pryB01', NULL, NULL, 174, NULL, NULL, 233444),
(265721, '2gq0B01', NULL, NULL, 173, NULL, NULL, 233444),
(265722, '2o1uB02', NULL, NULL, 170, NULL, NULL, 233444),
(265723, '2iopC02', NULL, NULL, 159, NULL, NULL, 233444),
(265724, '1y6zA01', NULL, NULL, 176, NULL, NULL, 233444),
(265725, '3hjcA01', NULL, NULL, 136, NULL, NULL, 233444),
(265726, '1usuA01', NULL, NULL, 174, NULL, NULL, 233444),
(265727, '1l0sA00', NULL, NULL, 90, NULL, NULL, 233445),
(265728, '1m8nB00', NULL, NULL, 121, NULL, NULL, 233445),
(265729, '3sucA02', NULL, NULL, 134, NULL, NULL, 233445),
(265730, '3w0lD01', NULL, NULL, 122, NULL, NULL, 233446),
(265731, '4bb9A01', NULL, NULL, 124, NULL, NULL, 233446),
(265732, '4s12A02', NULL, NULL, 77, NULL, NULL, 233446),
(265733, '4lzjA02', NULL, NULL, 79, NULL, NULL, 233446),
(265734, '5intB00', NULL, NULL, 220, NULL, NULL, 233447),
(265735, '2gk4B00', NULL, NULL, 232, NULL, NULL, 233447),
(265736, '4qjiB00', NULL, NULL, 237, NULL, NULL, 233447),
(265737, '1p9oA00', NULL, NULL, 294, NULL, NULL, 233447),
(265738, '1u7zA00', NULL, NULL, 226, NULL, NULL, 233447),
(265739, '4x9rA01', NULL, NULL, 140, NULL, NULL, 233448),
(265740, '3p34A02', NULL, NULL, 97, NULL, NULL, 233448),
(265741, '3q1iA01', NULL, NULL, 136, NULL, NULL, 233448),
(265742, '4rs6A02', NULL, NULL, 95, NULL, NULL, 233448),
(265743, '4j7bB01', NULL, NULL, 140, NULL, NULL, 233448),
(265744, '4j7bB02', NULL, NULL, 97, NULL, NULL, 233448),
(265745, '4rs6A01', NULL, NULL, 121, NULL, NULL, 233448),
(265746, '5dmsC01', NULL, NULL, 140, NULL, NULL, 233448),
(265747, '5j19A01', NULL, NULL, 138, NULL, NULL, 233448),
(265748, '4yypA00', NULL, NULL, 87, NULL, NULL, 233448),
(265749, '4gpkB01', NULL, NULL, 107, NULL, NULL, 233449),
(265750, '3q23A05', NULL, NULL, 55, NULL, NULL, 233450),
(265751, '2xolB00', NULL, NULL, 176, NULL, NULL, 233451),
(265752, '1s9uA00', NULL, NULL, 207, NULL, NULL, 233451),
(265753, '3efpA00', NULL, NULL, 208, NULL, NULL, 233451),
(265754, '4xboA02', NULL, NULL, 64, NULL, NULL, 233452),
(265755, '3ilkA02', NULL, NULL, 71, NULL, NULL, 233452),
(265756, '4xboB02', NULL, NULL, 89, NULL, NULL, 233452),
(265757, '4es8B01', NULL, NULL, 196, NULL, NULL, 233453);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(265758, '3lmlA03', NULL, NULL, 85, NULL, NULL, 233454),
(265759, '3hxlA02', NULL, NULL, 90, NULL, NULL, 233454),
(265760, '2exuA01', NULL, NULL, 101, NULL, NULL, 233455),
(265761, '3h7hA01', NULL, NULL, 108, NULL, NULL, 233455),
(265762, '6ir9V00', NULL, NULL, 108, NULL, NULL, 233455),
(265763, '4e8uA00', NULL, NULL, 172, NULL, NULL, 233456),
(265764, '1lshB00', NULL, NULL, 174, NULL, NULL, 233457),
(265765, '2j1dG01', NULL, NULL, 408, NULL, NULL, 233458),
(265766, '3obvF03', NULL, NULL, 295, NULL, NULL, 233458),
(265767, '1v9dC02', NULL, NULL, 212, NULL, NULL, 233458),
(265768, '1v9dB00', NULL, NULL, 340, NULL, NULL, 233458),
(265769, '4eahA00', NULL, NULL, 386, NULL, NULL, 233458),
(265770, '1ux5A03', NULL, NULL, 239, NULL, NULL, 233458),
(265771, '3v0dA02', NULL, NULL, 144, NULL, NULL, 233459),
(265772, '2j43A02', NULL, NULL, 118, NULL, NULL, 233459),
(265773, '3n0aA02', NULL, NULL, 135, NULL, NULL, 233459),
(265774, '2yocB01', NULL, NULL, 132, NULL, NULL, 233459),
(265775, '2j44A02', NULL, NULL, 118, NULL, NULL, 233459),
(265776, '2j73A00', NULL, NULL, 103, NULL, NULL, 233459),
(265777, '2j43A01', NULL, NULL, 101, NULL, NULL, 233459),
(265778, '1d5rA02', NULL, NULL, 143, NULL, NULL, 233459),
(265779, '2ya1A01', NULL, NULL, 107, NULL, NULL, 233459),
(265780, '2fhfA01', NULL, NULL, 130, NULL, NULL, 233459),
(265781, '3bigA02', NULL, NULL, 167, NULL, NULL, 233460),
(265782, '6ayuA02', NULL, NULL, 155, NULL, NULL, 233460),
(265783, '3rojA02', NULL, NULL, 167, NULL, NULL, 233460),
(265784, '5a5lA02', NULL, NULL, 168, NULL, NULL, 233460),
(265785, '2ilxA00', NULL, NULL, 219, NULL, NULL, 233461),
(265786, '2i3eA00', NULL, NULL, 222, NULL, NULL, 233461),
(265787, '5ae0A00', NULL, NULL, 221, NULL, NULL, 233461),
(265788, '1wojA00', NULL, NULL, 214, NULL, NULL, 233461),
(265789, '4fzvA01', NULL, NULL, 132, NULL, NULL, 233462),
(265790, '1ukfA00', NULL, NULL, 188, NULL, NULL, 233463),
(265791, '3wnzA04', NULL, NULL, 96, NULL, NULL, 233464),
(265792, '4ojdH03', NULL, NULL, 104, NULL, NULL, 233465),
(265793, '1korC02', NULL, NULL, 229, NULL, NULL, 233466),
(265794, '1k92A02', NULL, NULL, 215, NULL, NULL, 233466),
(265795, '4xfjA02', NULL, NULL, 187, NULL, NULL, 233466),
(265796, '2nz2A02', NULL, NULL, 192, NULL, NULL, 233466),
(265797, '1j20A02', NULL, NULL, 213, NULL, NULL, 233466),
(265798, '4nzpA02', NULL, NULL, 214, NULL, NULL, 233466),
(265799, '6e5yA02', NULL, NULL, 215, NULL, NULL, 233466),
(265800, '1vl2D02', NULL, NULL, 233, NULL, NULL, 233466),
(265801, '3p4gD00', NULL, NULL, 323, NULL, NULL, 233467),
(265802, '1jztA00', NULL, NULL, 246, NULL, NULL, 233468),
(265803, '3rssA01', NULL, NULL, 218, NULL, NULL, 233468),
(265804, '2o8nA00', NULL, NULL, 239, NULL, NULL, 233468),
(265805, '3d3kA00', NULL, NULL, 259, NULL, NULL, 233468),
(265806, '3k5wA01', NULL, NULL, 211, NULL, NULL, 233468),
(265807, '3bxjA01', NULL, NULL, 35, NULL, NULL, 233469),
(265808, '3bxjB01', NULL, NULL, 37, NULL, NULL, 233469),
(265809, '3eh1A02', NULL, NULL, 73, NULL, NULL, 233470),
(265810, '3efoB02', NULL, NULL, 82, NULL, NULL, 233470),
(265811, '2qtvA02', NULL, NULL, 59, NULL, NULL, 233470),
(265812, '4xxbB00', NULL, NULL, 45, NULL, NULL, 233470),
(265813, '1m2vB03', NULL, NULL, 62, NULL, NULL, 233470),
(265814, '2yrcA00', NULL, NULL, 59, NULL, NULL, 233470),
(265815, '3eh2A02', NULL, NULL, 82, NULL, NULL, 233470),
(265816, '3p2aC01', NULL, NULL, 37, NULL, NULL, 233470),
(265817, '3p2aD01', NULL, NULL, 37, NULL, NULL, 233470),
(265818, '1pcxA02', NULL, NULL, 78, NULL, NULL, 233470),
(265819, '2pptA01', NULL, NULL, 37, NULL, NULL, 233470),
(265820, '3b08E00', NULL, NULL, 64, NULL, NULL, 233470),
(265821, '2nutB02', NULL, NULL, 73, NULL, NULL, 233470),
(265822, '2nutA02', NULL, NULL, 61, NULL, NULL, 233470),
(265823, '2j9uB00', NULL, NULL, 76, NULL, NULL, 233470),
(265824, '3p2aA01', NULL, NULL, 37, NULL, NULL, 233470),
(265825, '3p2aB01', NULL, NULL, 37, NULL, NULL, 233470),
(265826, '4h9nC00', NULL, NULL, 212, NULL, NULL, 233471),
(265827, '3o4hA01', NULL, NULL, 300, NULL, NULL, 233472),
(265828, '2i82B00', NULL, NULL, 217, NULL, NULL, 233473);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(265829, '1sgvA01', NULL, NULL, 221, NULL, NULL, 233473),
(265830, '3dh3A02', NULL, NULL, 181, NULL, NULL, 233473),
(265831, '3u28A02', NULL, NULL, 207, NULL, NULL, 233473),
(265832, '2ey4A02', NULL, NULL, 204, NULL, NULL, 233473),
(265833, '1r3eA01', NULL, NULL, 221, NULL, NULL, 233473),
(265834, '1v9kA00', NULL, NULL, 228, NULL, NULL, 233473),
(265835, '1r3fA01', NULL, NULL, 249, NULL, NULL, 233473),
(265836, '2ausC02', NULL, NULL, 204, NULL, NULL, 233473),
(265837, '4lgtA02', NULL, NULL, 190, NULL, NULL, 233473),
(265838, '1kskA02', NULL, NULL, 167, NULL, NULL, 233473),
(265839, '1v9fA01', NULL, NULL, 195, NULL, NULL, 233473),
(265840, '2e1qC07', NULL, NULL, 95, NULL, NULL, 233474),
(265841, '3nvwC01', NULL, NULL, 92, NULL, NULL, 233474),
(265842, '1t3qB01', NULL, NULL, 113, NULL, NULL, 233474),
(265843, '3zyvB07', NULL, NULL, 121, NULL, NULL, 233474),
(265844, '1rm6A02', NULL, NULL, 92, NULL, NULL, 233474),
(265845, '3unaB07', NULL, NULL, 123, NULL, NULL, 233474),
(265846, '1ffvB01', NULL, NULL, 141, NULL, NULL, 233474),
(265847, '3an1B07', NULL, NULL, 123, NULL, NULL, 233474),
(265848, '2w3sB01', NULL, NULL, 124, NULL, NULL, 233474),
(265849, '4usaA03', NULL, NULL, 101, NULL, NULL, 233474),
(265850, '1n62E01', NULL, NULL, 144, NULL, NULL, 233474),
(265851, '1dgjA03', NULL, NULL, 101, NULL, NULL, 233474),
(265852, '4zohA01', NULL, NULL, 106, NULL, NULL, 233474),
(265853, '3an1A07', NULL, NULL, 95, NULL, NULL, 233474),
(265854, '2giaB00', NULL, NULL, 154, NULL, NULL, 233475),
(265855, '2giaA00', NULL, NULL, 169, NULL, NULL, 233475),
(265856, '2c55A01', NULL, NULL, 41, NULL, NULL, 233476),
(265857, '4hubG02', NULL, NULL, 80, NULL, NULL, 233477),
(265858, '3jsyA02', NULL, NULL, 80, NULL, NULL, 233477),
(265859, '4nwbA02', NULL, NULL, 93, NULL, NULL, 233477),
(265860, '4he8F02', NULL, NULL, 77, NULL, NULL, 233478),
(265861, '3rkoB02', NULL, NULL, 77, NULL, NULL, 233478),
(265862, '4k35A03', NULL, NULL, 70, NULL, NULL, 233479),
(265863, '2jc2A01', NULL, NULL, 34, NULL, NULL, 233480),
(265864, '4ni6A00', NULL, NULL, 150, NULL, NULL, 233481),
(265865, '4mkmA02', NULL, NULL, 146, NULL, NULL, 233481),
(265866, '4mkmA01', NULL, NULL, 151, NULL, NULL, 233481),
(265867, '3qwlA02', NULL, NULL, 77, NULL, NULL, 233482),
(265868, '3h52A01', NULL, NULL, 21, NULL, NULL, 233483),
(265869, '3agcB00', NULL, NULL, 276, NULL, NULL, 233484),
(265870, '2x9oA00', NULL, NULL, 244, NULL, NULL, 233484),
(265871, '2g18I00', NULL, NULL, 253, NULL, NULL, 233484),
(265872, '2vclA00', NULL, NULL, 212, NULL, NULL, 233484),
(265873, '5b4jA00', NULL, NULL, 248, NULL, NULL, 233484),
(265874, '2rjiA00', NULL, NULL, 84, NULL, NULL, 233485),
(265875, '2orpA03', NULL, NULL, 48, NULL, NULL, 233486),
(265876, '1mjtA03', NULL, NULL, 89, NULL, NULL, 233486),
(265877, '6ngmA03', NULL, NULL, 89, NULL, NULL, 233486),
(265878, '1d0cA03', NULL, NULL, 89, NULL, NULL, 233486),
(265879, '2flqA03', NULL, NULL, 89, NULL, NULL, 233486),
(265880, '2ortA03', NULL, NULL, 46, NULL, NULL, 233486),
(265881, '4culA03', NULL, NULL, 87, NULL, NULL, 233486),
(265882, '3e7mA03', NULL, NULL, 89, NULL, NULL, 233486),
(265883, '3e7gA03', NULL, NULL, 89, NULL, NULL, 233486),
(265884, '4d3tA03', NULL, NULL, 89, NULL, NULL, 233486),
(265885, '4iumA00', NULL, NULL, 142, NULL, NULL, 233487),
(265886, '1t3qA02', NULL, NULL, 81, NULL, NULL, 233488),
(265887, '2e1qC02', NULL, NULL, 126, NULL, NULL, 233488),
(265888, '1rm6C02', NULL, NULL, 83, NULL, NULL, 233488),
(265889, '3zyvC02', NULL, NULL, 132, NULL, NULL, 233488),
(265890, '1ffvA02', NULL, NULL, 76, NULL, NULL, 233488),
(265891, '3nvwA02', NULL, NULL, 74, NULL, NULL, 233488),
(265892, '3unaB02', NULL, NULL, 130, NULL, NULL, 233488),
(265893, '2w3sA02', NULL, NULL, 86, NULL, NULL, 233488),
(265894, '3hrdD02', NULL, NULL, 81, NULL, NULL, 233488),
(265895, '5y6qA02', NULL, NULL, 82, NULL, NULL, 233488),
(265896, '5g5gA02', NULL, NULL, 93, NULL, NULL, 233488),
(265897, '4usaA02', NULL, NULL, 119, NULL, NULL, 233488),
(265898, '4zohC02', NULL, NULL, 84, NULL, NULL, 233488),
(265899, '2e3tA02', NULL, NULL, 78, NULL, NULL, 233488);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(265900, '3an1A02', NULL, NULL, 125, NULL, NULL, 233488),
(265901, '1n62A02', NULL, NULL, 82, NULL, NULL, 233488),
(265902, '1dgjA02', NULL, NULL, 119, NULL, NULL, 233488),
(265903, '4tuwA00', NULL, NULL, 75, NULL, NULL, 233489),
(265904, '4qozC00', NULL, NULL, 73, NULL, NULL, 233489),
(265905, '3mtvA02', NULL, NULL, 123, NULL, NULL, 233490),
(265906, '3fjuB00', NULL, NULL, 65, NULL, NULL, 233491),
(265907, '3pieC07', NULL, NULL, 65, NULL, NULL, 233492),
(265908, '3pifB07', NULL, NULL, 81, NULL, NULL, 233492),
(265909, '5reqB03', NULL, NULL, 43, NULL, NULL, 233493),
(265910, '3ec1A01', NULL, NULL, 169, NULL, NULL, 233494),
(265911, '2nzjB00', NULL, NULL, 175, NULL, NULL, 233494),
(265912, '2hjvA00', NULL, NULL, 163, NULL, NULL, 233494),
(265913, '2pzeB00', NULL, NULL, 229, NULL, NULL, 233494),
(265914, '4kbfA02', NULL, NULL, 158, NULL, NULL, 233494),
(265915, '2if2A00', NULL, NULL, 204, NULL, NULL, 233494),
(265916, '4lpsA00', NULL, NULL, 215, NULL, NULL, 233494),
(265917, '3ievA01', NULL, NULL, 192, NULL, NULL, 233494),
(265918, '3oaaA02', NULL, NULL, 289, NULL, NULL, 233494),
(265919, '2p65A00', NULL, NULL, 187, NULL, NULL, 233494),
(265920, '3geeA03', NULL, NULL, 171, NULL, NULL, 233494),
(265921, '3crmA01', NULL, NULL, 154, NULL, NULL, 233494),
(265922, '3dkpA00', NULL, NULL, 245, NULL, NULL, 233494),
(265923, '4zdjA01', NULL, NULL, 298, NULL, NULL, 233494),
(265924, '3p4xB02', NULL, NULL, 188, NULL, NULL, 233494),
(265925, '5l3sA02', NULL, NULL, 207, NULL, NULL, 233494),
(265926, '5jrjA01', NULL, NULL, 244, NULL, NULL, 233494),
(265927, '5lc9A00', NULL, NULL, 267, NULL, NULL, 233494),
(265928, '3q85B00', NULL, NULL, 169, NULL, NULL, 233494),
(265929, '1j99A00', NULL, NULL, 293, NULL, NULL, 233494),
(265930, '3lfuA03', NULL, NULL, 207, NULL, NULL, 233494),
(265931, '5y4zA02', NULL, NULL, 143, NULL, NULL, 233494),
(265932, '5y4zA01', NULL, NULL, 183, NULL, NULL, 233494),
(265933, '1texA00', NULL, NULL, 265, NULL, NULL, 233494),
(265934, '5ffmA01', NULL, NULL, 181, NULL, NULL, 233494),
(265935, '4ceiB01', NULL, NULL, 181, NULL, NULL, 233494),
(265936, '6mijA01', NULL, NULL, 205, NULL, NULL, 233494),
(265937, '2lkcA01', NULL, NULL, 176, NULL, NULL, 233494),
(265938, '3lfuA01', NULL, NULL, 202, NULL, NULL, 233494),
(265939, '2iutA02', NULL, NULL, 302, NULL, NULL, 233494),
(265940, '5mtvA02', NULL, NULL, 225, NULL, NULL, 233494),
(265941, '5tizA00', NULL, NULL, 263, NULL, NULL, 233494),
(265942, '6c6bB00', NULL, NULL, 211, NULL, NULL, 233494),
(265943, '3oiyB01', NULL, NULL, 222, NULL, NULL, 233494),
(265944, '3j81k01', NULL, NULL, 210, NULL, NULL, 233494),
(265945, '1ki9B00', NULL, NULL, 192, NULL, NULL, 233494),
(265946, '2wojC00', NULL, NULL, 354, NULL, NULL, 233494),
(265947, '5xz2A00', NULL, NULL, 196, NULL, NULL, 233494),
(265948, '2d62A01', NULL, NULL, 247, NULL, NULL, 233494),
(265949, '3eieA01', NULL, NULL, 205, NULL, NULL, 233494),
(265950, '5lj9B00', NULL, NULL, 231, NULL, NULL, 233494),
(265951, '2nq2D00', NULL, NULL, 253, NULL, NULL, 233494),
(265952, '5gjuA00', NULL, NULL, 205, NULL, NULL, 233494),
(265953, '5a4jB01', NULL, NULL, 326, NULL, NULL, 233494),
(265954, '4r7zN00', NULL, NULL, 338, NULL, NULL, 233494),
(265955, '4ileA00', NULL, NULL, 184, NULL, NULL, 233494),
(265956, '2qg6A00', NULL, NULL, 199, NULL, NULL, 233494),
(265957, '2qbyA02', NULL, NULL, 175, NULL, NULL, 233494),
(265958, '2grjA00', NULL, NULL, 192, NULL, NULL, 233494),
(265959, '5uf8A00', NULL, NULL, 165, NULL, NULL, 233494),
(265960, '3mfyA01', NULL, NULL, 302, NULL, NULL, 233494),
(265961, '2eryB00', NULL, NULL, 172, NULL, NULL, 233494),
(265962, '3neyA01', NULL, NULL, 134, NULL, NULL, 233494),
(265963, '1m2oB00', NULL, NULL, 167, NULL, NULL, 233494),
(265964, '3u4qA04', NULL, NULL, 290, NULL, NULL, 233494),
(265965, '4yonB00', NULL, NULL, 179, NULL, NULL, 233494),
(265966, '3ah8A01', NULL, NULL, 237, NULL, NULL, 233494),
(265967, '1zd1B00', NULL, NULL, 267, NULL, NULL, 233494),
(265968, '1znwA01', NULL, NULL, 126, NULL, NULL, 233494),
(265969, '2fg5A00', NULL, NULL, 172, NULL, NULL, 233494),
(265970, '3u4qA01', NULL, NULL, 240, NULL, NULL, 233494);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(265971, '1z0fA01', NULL, NULL, 167, NULL, NULL, 233494),
(265972, '1sulB00', NULL, NULL, 195, NULL, NULL, 233494),
(265973, '5ko2B03', NULL, NULL, 263, NULL, NULL, 233494),
(265974, '6g2gA01', NULL, NULL, 281, NULL, NULL, 233494),
(265975, '3ibgA00', NULL, NULL, 348, NULL, NULL, 233494),
(265976, '6hs3A00', NULL, NULL, 260, NULL, NULL, 233494),
(265977, '1mh1A00', NULL, NULL, 186, NULL, NULL, 233494),
(265978, '5d3qA00', NULL, NULL, 345, NULL, NULL, 233494),
(265979, '4dheA00', NULL, NULL, 223, NULL, NULL, 233494),
(265980, '2a5jA01', NULL, NULL, 173, NULL, NULL, 233494),
(265981, '2d74A01', NULL, NULL, 204, NULL, NULL, 233494),
(265982, '2vp4D00', NULL, NULL, 210, NULL, NULL, 233494),
(265983, '3cb4A01', NULL, NULL, 185, NULL, NULL, 233494),
(265984, '2rhdA00', NULL, NULL, 175, NULL, NULL, 233494),
(265985, '3vmfA01', NULL, NULL, 228, NULL, NULL, 233494),
(265986, '3sbdA00', NULL, NULL, 187, NULL, NULL, 233494),
(265987, '4c7oA02', NULL, NULL, 194, NULL, NULL, 233494),
(265988, '2gzaB02', NULL, NULL, 233, NULL, NULL, 233494),
(265989, '3ftqD00', NULL, NULL, 274, NULL, NULL, 233494),
(265990, '3ch4B00', NULL, NULL, 202, NULL, NULL, 233494),
(265991, '5h66A00', NULL, NULL, 199, NULL, NULL, 233494),
(265992, '1udxA02', NULL, NULL, 174, NULL, NULL, 233494),
(265993, '5dcaA10', NULL, NULL, 202, NULL, NULL, 233494),
(265994, '5xktA00', NULL, NULL, 200, NULL, NULL, 233494),
(265995, '5g3yA00', NULL, NULL, 226, NULL, NULL, 233494),
(265996, '1xwiA01', NULL, NULL, 196, NULL, NULL, 233494),
(265997, '2g0tA02', NULL, NULL, 193, NULL, NULL, 233494),
(265998, '3cr8A03', NULL, NULL, 191, NULL, NULL, 233494),
(265999, '1jjvA00', NULL, NULL, 206, NULL, NULL, 233494),
(266000, '1htwA00', NULL, NULL, 158, NULL, NULL, 233494),
(266001, '2x77A00', NULL, NULL, 189, NULL, NULL, 233494),
(266002, '2ygrF01', NULL, NULL, 309, NULL, NULL, 233494),
(266003, '2ocaA03', NULL, NULL, 215, NULL, NULL, 233494),
(266004, '6blbA01', NULL, NULL, 162, NULL, NULL, 233494),
(266005, '4r7zA00', NULL, NULL, 338, NULL, NULL, 233494),
(266006, '3m1iA00', NULL, NULL, 219, NULL, NULL, 233494),
(266007, '1tueD00', NULL, NULL, 212, NULL, NULL, 233494),
(266008, '5dcaA09', NULL, NULL, 210, NULL, NULL, 233494),
(266009, '4j0qB01', NULL, NULL, 198, NULL, NULL, 233494),
(266010, '6notA01', NULL, NULL, 293, NULL, NULL, 233494),
(266011, '3cklA00', NULL, NULL, 298, NULL, NULL, 233494),
(266012, '3bs4A00', NULL, NULL, 260, NULL, NULL, 233494),
(266013, '1z5zB01', NULL, NULL, 169, NULL, NULL, 233494),
(266014, '5dcaA04', NULL, NULL, 231, NULL, NULL, 233494),
(266015, '5dcaA03', NULL, NULL, 227, NULL, NULL, 233494),
(266016, '1g8fA03', NULL, NULL, 122, NULL, NULL, 233494),
(266017, '1u8zA00', NULL, NULL, 168, NULL, NULL, 233494),
(266018, '4cvnA00', NULL, NULL, 191, NULL, NULL, 233494),
(266019, '2xgjB02', NULL, NULL, 258, NULL, NULL, 233494),
(266020, '2xgjB01', NULL, NULL, 206, NULL, NULL, 233494),
(266021, '1oxxK01', NULL, NULL, 244, NULL, NULL, 233494),
(266022, '6gfuA01', NULL, NULL, 194, NULL, NULL, 233494),
(266023, '2ntyC00', NULL, NULL, 180, NULL, NULL, 233494),
(266024, '2j45A02', NULL, NULL, 191, NULL, NULL, 233494),
(266025, '2ze6A01', NULL, NULL, 124, NULL, NULL, 233494),
(266026, '2erxA00', NULL, NULL, 172, NULL, NULL, 233494),
(266027, '1sxjE01', NULL, NULL, 193, NULL, NULL, 233494),
(266028, '5mekA00', NULL, NULL, 322, NULL, NULL, 233494),
(266029, '2il1A00', NULL, NULL, 171, NULL, NULL, 233494),
(266030, '4dcuA02', NULL, NULL, 184, NULL, NULL, 233494),
(266031, '1zu4A02', NULL, NULL, 224, NULL, NULL, 233494),
(266032, '1qf9A00', NULL, NULL, 194, NULL, NULL, 233494),
(266033, '4jimB01', NULL, NULL, 326, NULL, NULL, 233494),
(266034, '3w6pA00', NULL, NULL, 364, NULL, NULL, 233494),
(266035, '3lw7A00', NULL, NULL, 179, NULL, NULL, 233494),
(266036, '1ak2A00', NULL, NULL, 233, NULL, NULL, 233494),
(266037, '1nijA01', NULL, NULL, 202, NULL, NULL, 233494),
(266038, '5ck4A00', NULL, NULL, 247, NULL, NULL, 233494),
(266039, '1n0wA00', NULL, NULL, 243, NULL, NULL, 233494),
(266040, '3auxA00', NULL, NULL, 371, NULL, NULL, 233494),
(266041, '5tnuA02', NULL, NULL, 176, NULL, NULL, 233494);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(266042, '5nt7B00', NULL, NULL, 163, NULL, NULL, 233494),
(266043, '5tnuA03', NULL, NULL, 207, NULL, NULL, 233494),
(266044, '3r7wB01', NULL, NULL, 176, NULL, NULL, 233494),
(266045, '2awnD01', NULL, NULL, 146, NULL, NULL, 233494),
(266046, '3be4A00', NULL, NULL, 217, NULL, NULL, 233494),
(266047, '4r7zP00', NULL, NULL, 338, NULL, NULL, 233494),
(266048, '4eq6B00', NULL, NULL, 256, NULL, NULL, 233494),
(266049, '3dl0A00', NULL, NULL, 216, NULL, NULL, 233494),
(266050, '2p67A02', NULL, NULL, 211, NULL, NULL, 233494),
(266051, '2r8rA00', NULL, NULL, 211, NULL, NULL, 233494),
(266052, '2it1B01', NULL, NULL, 238, NULL, NULL, 233494),
(266053, '3r8cB00', NULL, NULL, 228, NULL, NULL, 233494),
(266054, '2bbwA00', NULL, NULL, 221, NULL, NULL, 233494),
(266055, '1mkyA02', NULL, NULL, 169, NULL, NULL, 233494),
(266056, '1mkyA01', NULL, NULL, 170, NULL, NULL, 233494),
(266057, '5l3qA02', NULL, NULL, 206, NULL, NULL, 233494),
(266058, '2pjzA00', NULL, NULL, 263, NULL, NULL, 233494),
(266059, '3l82B00', NULL, NULL, 190, NULL, NULL, 233494),
(266060, '4cbgD02', NULL, NULL, 161, NULL, NULL, 233494),
(266061, '1ymfA01', NULL, NULL, 181, NULL, NULL, 233494),
(266062, '2gksB03', NULL, NULL, 182, NULL, NULL, 233494),
(266063, '6gcnB01', NULL, NULL, 196, NULL, NULL, 233494),
(266064, '2r2aA00', NULL, NULL, 199, NULL, NULL, 233494),
(266065, '1tevA00', NULL, NULL, 196, NULL, NULL, 233494),
(266066, '2q3hA00', NULL, NULL, 182, NULL, NULL, 233494),
(266067, '5fl3A02', NULL, NULL, 259, NULL, NULL, 233494),
(266068, '5x4bA00', NULL, NULL, 162, NULL, NULL, 233494),
(266069, '1u0lA02', NULL, NULL, 164, NULL, NULL, 233494),
(266070, '2yjtD00', NULL, NULL, 170, NULL, NULL, 233494),
(266071, '3vx4A00', NULL, NULL, 245, NULL, NULL, 233494),
(266072, '1r2qA00', NULL, NULL, 170, NULL, NULL, 233494),
(266073, '3hdtA00', NULL, NULL, 181, NULL, NULL, 233494),
(266074, '4ko8A03', NULL, NULL, 170, NULL, NULL, 233494),
(266075, '3r20A00', NULL, NULL, 233, NULL, NULL, 233494),
(266076, '4kaxA00', NULL, NULL, 169, NULL, NULL, 233494),
(266077, '3mgcA00', NULL, NULL, 272, NULL, NULL, 233494),
(266078, '2no7B00', NULL, NULL, 241, NULL, NULL, 233494),
(266079, '1uaaB03', NULL, NULL, 211, NULL, NULL, 233494),
(266080, '3gd7C01', NULL, NULL, 257, NULL, NULL, 233494),
(266081, '3igfA01', NULL, NULL, 260, NULL, NULL, 233494),
(266082, '1z6aA02', NULL, NULL, 152, NULL, NULL, 233494),
(266083, '5kutA00', NULL, NULL, 189, NULL, NULL, 233494),
(266084, '2efeB00', NULL, NULL, 181, NULL, NULL, 233494),
(266085, '1qdeA00', NULL, NULL, 224, NULL, NULL, 233494),
(266086, '3tk1B02', NULL, NULL, 211, NULL, NULL, 233494),
(266087, '2odeC01', NULL, NULL, 202, NULL, NULL, 233494),
(266088, '2jlqA02', NULL, NULL, 160, NULL, NULL, 233494),
(266089, '2gk6A01', NULL, NULL, 267, NULL, NULL, 233494),
(266090, '2jlqA01', NULL, NULL, 192, NULL, NULL, 233494),
(266091, '2kjqA01', NULL, NULL, 126, NULL, NULL, 233494),
(266092, '3mgbB00', NULL, NULL, 285, NULL, NULL, 233494),
(266093, '3ja8604', NULL, NULL, 331, NULL, NULL, 233494),
(266094, '1zd9A00', NULL, NULL, 170, NULL, NULL, 233494),
(266095, '1y63A00', NULL, NULL, 184, NULL, NULL, 233494),
(266096, '1zunB01', NULL, NULL, 238, NULL, NULL, 233494),
(266097, '2g9nA00', NULL, NULL, 221, NULL, NULL, 233494),
(266098, '6fkfB02', NULL, NULL, 277, NULL, NULL, 233494),
(266099, '3ephA01', NULL, NULL, 283, NULL, NULL, 233494),
(266100, '3l0oB02', NULL, NULL, 291, NULL, NULL, 233494),
(266101, '5oiuC02', NULL, NULL, 277, NULL, NULL, 233494),
(266102, '2z6vA00', NULL, NULL, 393, NULL, NULL, 233494),
(266103, '3tr5A02', NULL, NULL, 194, NULL, NULL, 233494),
(266104, '3tr5A01', NULL, NULL, 190, NULL, NULL, 233494),
(266105, '1wcv100', NULL, NULL, 257, NULL, NULL, 233494),
(266106, '2f7sA00', NULL, NULL, 197, NULL, NULL, 233494),
(266107, '5c4mA00', NULL, NULL, 193, NULL, NULL, 233494),
(266108, '5ucvA00', NULL, NULL, 217, NULL, NULL, 233494),
(266109, '4rkeA01', NULL, NULL, 169, NULL, NULL, 233494),
(266110, '5h68A00', NULL, NULL, 340, NULL, NULL, 233494),
(266111, '1ni3A01', NULL, NULL, 197, NULL, NULL, 233494),
(266112, '4v03A00', NULL, NULL, 257, NULL, NULL, 233494);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(266113, '1jalA01', NULL, NULL, 179, NULL, NULL, 233494),
(266114, '1q0uB00', NULL, NULL, 219, NULL, NULL, 233494),
(266115, '4nhoA02', NULL, NULL, 189, NULL, NULL, 233494),
(266116, '4r7zJ00', NULL, NULL, 338, NULL, NULL, 233494),
(266117, '4nhoA01', NULL, NULL, 280, NULL, NULL, 233494),
(266118, '1ls6A00', NULL, NULL, 295, NULL, NULL, 233494),
(266119, '3of5B00', NULL, NULL, 228, NULL, NULL, 233494),
(266120, '4a82A02', NULL, NULL, 252, NULL, NULL, 233494),
(266121, '2gf9A00', NULL, NULL, 189, NULL, NULL, 233494),
(266122, '5ee0A01', NULL, NULL, 181, NULL, NULL, 233494),
(266123, '4huqA00', NULL, NULL, 290, NULL, NULL, 233494),
(266124, '4fn5A01', NULL, NULL, 296, NULL, NULL, 233494),
(266125, '6q93D00', NULL, NULL, 273, NULL, NULL, 233494),
(266126, '4jmpA00', NULL, NULL, 250, NULL, NULL, 233494),
(266127, '4a8jB00', NULL, NULL, 232, NULL, NULL, 233494),
(266128, '4kfuA00', NULL, NULL, 212, NULL, NULL, 233494),
(266129, '3nkvA00', NULL, NULL, 175, NULL, NULL, 233494),
(266130, '4fidA01', NULL, NULL, 212, NULL, NULL, 233494),
(266131, '1dekA01', NULL, NULL, 118, NULL, NULL, 233494),
(266132, '5b57D00', NULL, NULL, 273, NULL, NULL, 233494),
(266133, '2ew1A00', NULL, NULL, 180, NULL, NULL, 233494),
(266134, '2ff7A00', NULL, NULL, 247, NULL, NULL, 233494),
(266135, '3d8bA01', NULL, NULL, 217, NULL, NULL, 233494),
(266136, '2va8A01', NULL, NULL, 192, NULL, NULL, 233494),
(266137, '4xd7B02', NULL, NULL, 271, NULL, NULL, 233494),
(266138, '1kgdA01', NULL, NULL, 117, NULL, NULL, 233494),
(266139, '1a7jA00', NULL, NULL, 290, NULL, NULL, 233494),
(266140, '3fhoB02', NULL, NULL, 156, NULL, NULL, 233494),
(266141, '4eunA00', NULL, NULL, 173, NULL, NULL, 233494),
(266142, '2yc4C00', NULL, NULL, 208, NULL, NULL, 233494),
(266143, '3thxB05', NULL, NULL, 289, NULL, NULL, 233494),
(266144, '4mkfA00', NULL, NULL, 217, NULL, NULL, 233494),
(266145, '5yt0A01', NULL, NULL, 237, NULL, NULL, 233494),
(266146, '2e9sA00', NULL, NULL, 171, NULL, NULL, 233494),
(266147, '3bxzA01', NULL, NULL, 272, NULL, NULL, 233494),
(266148, '2f9lA01', NULL, NULL, 174, NULL, NULL, 233494),
(266149, '1pjrA01', NULL, NULL, 202, NULL, NULL, 233494),
(266150, '3t61A00', NULL, NULL, 202, NULL, NULL, 233494),
(266151, '4ag5C01', NULL, NULL, 159, NULL, NULL, 233494),
(266152, '1pjrA03', NULL, NULL, 213, NULL, NULL, 233494),
(266153, '2ax4A00', NULL, NULL, 198, NULL, NULL, 233494),
(266154, '1odfA00', NULL, NULL, 290, NULL, NULL, 233494),
(266155, '1t8tA00', NULL, NULL, 271, NULL, NULL, 233494),
(266156, '5jajA01', NULL, NULL, 269, NULL, NULL, 233494),
(266157, '5jajA02', NULL, NULL, 151, NULL, NULL, 233494),
(266158, '1e94E01', NULL, NULL, 197, NULL, NULL, 233494),
(266159, '1vx4401', NULL, NULL, 238, NULL, NULL, 233494),
(266160, '4n3sA01', NULL, NULL, 232, NULL, NULL, 233494),
(266161, '4ihqC03', NULL, NULL, 289, NULL, NULL, 233494),
(266162, '4ydsA00', NULL, NULL, 228, NULL, NULL, 233494),
(266163, '1pujA01', NULL, NULL, 168, NULL, NULL, 233494),
(266164, '4n0dA01', NULL, NULL, 204, NULL, NULL, 233494),
(266165, '1ko7A02', NULL, NULL, 159, NULL, NULL, 233494),
(266166, '1kk1A01', NULL, NULL, 203, NULL, NULL, 233494),
(266167, '2g6bA00', NULL, NULL, 180, NULL, NULL, 233494),
(266168, '3vaaA00', NULL, NULL, 176, NULL, NULL, 233494),
(266169, '3llmA01', NULL, NULL, 225, NULL, NULL, 233494),
(266170, '1osnC00', NULL, NULL, 341, NULL, NULL, 233494),
(266171, '3kb2A00', NULL, NULL, 173, NULL, NULL, 233494),
(266172, '3hwsC01', NULL, NULL, 254, NULL, NULL, 233494),
(266173, '5xlvA00', NULL, NULL, 312, NULL, NULL, 233494),
(266174, '5tivA00', NULL, NULL, 253, NULL, NULL, 233494),
(266175, '2gnoA01', NULL, NULL, 139, NULL, NULL, 233494),
(266176, '1e6cA00', NULL, NULL, 173, NULL, NULL, 233494),
(266177, '3do6A01', NULL, NULL, 310, NULL, NULL, 233494),
(266178, '1ly1A00', NULL, NULL, 152, NULL, NULL, 233494),
(266179, '5m59A01', NULL, NULL, 231, NULL, NULL, 233494),
(266180, '5m59A02', NULL, NULL, 227, NULL, NULL, 233494),
(266181, '2pl3A00', NULL, NULL, 236, NULL, NULL, 233494),
(266182, '5m59A07', NULL, NULL, 230, NULL, NULL, 233494),
(266183, '5m59A08', NULL, NULL, 206, NULL, NULL, 233494);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(266184, '3ez2A02', NULL, NULL, 292, NULL, NULL, 233494),
(266185, '2xauA03', NULL, NULL, 183, NULL, NULL, 233494),
(266186, '1d9xA01', NULL, NULL, 248, NULL, NULL, 233494),
(266187, '4ak9A02', NULL, NULL, 211, NULL, NULL, 233494),
(266188, '4finB01', NULL, NULL, 285, NULL, NULL, 233494),
(266189, '4finB02', NULL, NULL, 270, NULL, NULL, 233494),
(266190, '2xauA02', NULL, NULL, 232, NULL, NULL, 233494),
(266191, '1d9xA04', NULL, NULL, 182, NULL, NULL, 233494),
(266192, '4a15A01', NULL, NULL, 188, NULL, NULL, 233494),
(266193, '2hupA00', NULL, NULL, 176, NULL, NULL, 233494),
(266194, '1viaA00', NULL, NULL, 175, NULL, NULL, 233494),
(266195, '1cjmA00', NULL, NULL, 249, NULL, NULL, 233494),
(266196, '2pcjA00', NULL, NULL, 224, NULL, NULL, 233494),
(266197, '4r7zL00', NULL, NULL, 338, NULL, NULL, 233494),
(266198, '5cb8B00', NULL, NULL, 176, NULL, NULL, 233494),
(266199, '4l4uA02', NULL, NULL, 173, NULL, NULL, 233494),
(266200, '4nh0B01', NULL, NULL, 309, NULL, NULL, 233494),
(266201, '2qu8A00', NULL, NULL, 207, NULL, NULL, 233494),
(266202, '3cm0A00', NULL, NULL, 186, NULL, NULL, 233494),
(266203, '1svmA03', NULL, NULL, 153, NULL, NULL, 233494),
(266204, '2zu6A02', NULL, NULL, 169, NULL, NULL, 233494),
(266205, '2zptX00', NULL, NULL, 295, NULL, NULL, 233494),
(266206, '2wwwD02', NULL, NULL, 216, NULL, NULL, 233494),
(266207, '2ixeD01', NULL, NULL, 241, NULL, NULL, 233494),
(266208, '3cpjB01', NULL, NULL, 197, NULL, NULL, 233494),
(266209, '4mqbB00', NULL, NULL, 208, NULL, NULL, 233494),
(266210, '2r62A01', NULL, NULL, 181, NULL, NULL, 233494),
(266211, '3a8tA01', NULL, NULL, 191, NULL, NULL, 233494),
(266212, '4rkfB00', NULL, NULL, 173, NULL, NULL, 233494),
(266213, '3f5fA02', NULL, NULL, 288, NULL, NULL, 233494),
(266214, '3cwqA00', NULL, NULL, 209, NULL, NULL, 233494),
(266215, '1skyE02', NULL, NULL, 269, NULL, NULL, 233494),
(266216, '2r9vA02', NULL, NULL, 278, NULL, NULL, 233494),
(266217, '2w0mA00', NULL, NULL, 235, NULL, NULL, 233494),
(266218, '5fpkA00', NULL, NULL, 231, NULL, NULL, 233494),
(266219, '2v3cD02', NULL, NULL, 207, NULL, NULL, 233494),
(266220, '3crvA01', NULL, NULL, 246, NULL, NULL, 233494),
(266221, '2fn4A00', NULL, NULL, 181, NULL, NULL, 233494),
(266222, '3e2iA01', NULL, NULL, 135, NULL, NULL, 233494),
(266223, '3d3qB01', NULL, NULL, 156, NULL, NULL, 233494),
(266224, '3fdiB00', NULL, NULL, 201, NULL, NULL, 233494),
(266225, '1e69A00', NULL, NULL, 322, NULL, NULL, 233494),
(266226, '5lstA02', NULL, NULL, 151, NULL, NULL, 233494),
(266227, '5lstA01', NULL, NULL, 215, NULL, NULL, 233494),
(266228, '2d2eA00', NULL, NULL, 250, NULL, NULL, 233494),
(266229, '4bzpA00', NULL, NULL, 174, NULL, NULL, 233494),
(266230, '5ik2A02', NULL, NULL, 278, NULL, NULL, 233494),
(266231, '3crvA03', NULL, NULL, 197, NULL, NULL, 233494),
(266232, '3zvlA02', NULL, NULL, 185, NULL, NULL, 233494),
(266233, '1zcaA01', NULL, NULL, 204, NULL, NULL, 233494),
(266234, '1w5sA02', NULL, NULL, 190, NULL, NULL, 233494),
(266235, '3sfzA01', NULL, NULL, 183, NULL, NULL, 233494),
(266236, '1darA01', NULL, NULL, 286, NULL, NULL, 233494),
(266237, '2b6hA00', NULL, NULL, 176, NULL, NULL, 233494),
(266238, '4tmkA00', NULL, NULL, 213, NULL, NULL, 233494),
(266239, '6hviA01', NULL, NULL, 211, NULL, NULL, 233494),
(266240, '4b3fX01', NULL, NULL, 331, NULL, NULL, 233494),
(266241, '4zkdA01', NULL, NULL, 270, NULL, NULL, 233494),
(266242, '5ck3F00', NULL, NULL, 227, NULL, NULL, 233494),
(266243, '4b3fX03', NULL, NULL, 207, NULL, NULL, 233494),
(266244, '1uptG00', NULL, NULL, 171, NULL, NULL, 233494),
(266245, '3kb1A01', NULL, NULL, 241, NULL, NULL, 233494),
(266246, '3b9qA02', NULL, NULL, 211, NULL, NULL, 233494),
(266247, '3tauA01', NULL, NULL, 148, NULL, NULL, 233494),
(266248, '3kjhA00', NULL, NULL, 254, NULL, NULL, 233494),
(266249, '4bloG01', NULL, NULL, 253, NULL, NULL, 233494),
(266250, '4tmvA01', NULL, NULL, 232, NULL, NULL, 233494),
(266251, '2qenA01', NULL, NULL, 202, NULL, NULL, 233494),
(266252, '2dpyB02', NULL, NULL, 269, NULL, NULL, 233494),
(266253, '3ja8204', NULL, NULL, 347, NULL, NULL, 233494),
(266254, '3uanB00', NULL, NULL, 269, NULL, NULL, 233494);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(266255, '1skyB02', NULL, NULL, 278, NULL, NULL, 233494),
(266256, '2ocpA00', NULL, NULL, 241, NULL, NULL, 233494),
(266257, '3qxcA00', NULL, NULL, 224, NULL, NULL, 233494),
(266258, '2w2tA00', NULL, NULL, 185, NULL, NULL, 233494),
(266259, '2c9oA01', NULL, NULL, 237, NULL, NULL, 233494),
(266260, '2atvA00', NULL, NULL, 170, NULL, NULL, 233494),
(266261, '1xp8A01', NULL, NULL, 243, NULL, NULL, 233494),
(266262, '5k9tA01', NULL, NULL, 266, NULL, NULL, 233494),
(266263, '4hutA00', NULL, NULL, 191, NULL, NULL, 233494),
(266264, '5do9A01', NULL, NULL, 196, NULL, NULL, 233494),
(266265, '1kagA00', NULL, NULL, 173, NULL, NULL, 233494),
(266266, '1akyA00', NULL, NULL, 220, NULL, NULL, 233494),
(266267, '5dgxA00', NULL, NULL, 256, NULL, NULL, 233494),
(266268, '4zv4A01', NULL, NULL, 206, NULL, NULL, 233494),
(266269, '6aibA00', NULL, NULL, 214, NULL, NULL, 233494),
(266270, '1s1mA01', NULL, NULL, 285, NULL, NULL, 233494),
(266271, '3io3A01', NULL, NULL, 238, NULL, NULL, 233494),
(266272, '2h92A00', NULL, NULL, 219, NULL, NULL, 233494),
(266273, '2zjoA02', NULL, NULL, 136, NULL, NULL, 233494),
(266274, '1d2nA01', NULL, NULL, 172, NULL, NULL, 233494),
(266275, '3ug7C00', NULL, NULL, 308, NULL, NULL, 233494),
(266276, '2qorA01', NULL, NULL, 139, NULL, NULL, 233494),
(266277, '1f2uB00', NULL, NULL, 148, NULL, NULL, 233494),
(266278, '1puiA00', NULL, NULL, 210, NULL, NULL, 233494),
(266279, '4a0gD01', NULL, NULL, 295, NULL, NULL, 233494),
(266280, '4crwB00', NULL, NULL, 163, NULL, NULL, 233494),
(266281, '3tuiD01', NULL, NULL, 232, NULL, NULL, 233494),
(266282, '5llbA00', NULL, NULL, 246, NULL, NULL, 233494),
(266283, '3c5cB00', NULL, NULL, 168, NULL, NULL, 233494),
(266284, '2px0A02', NULL, NULL, 185, NULL, NULL, 233494),
(266285, '4dzzA00', NULL, NULL, 206, NULL, NULL, 233494),
(266286, '4r7zF00', NULL, NULL, 338, NULL, NULL, 233494),
(266287, '2zu6C01', NULL, NULL, 220, NULL, NULL, 233494),
(266288, '4y0vA00', NULL, NULL, 178, NULL, NULL, 233494),
(266289, '3fe2A00', NULL, NULL, 242, NULL, NULL, 233494),
(266290, '4qbiB00', NULL, NULL, 217, NULL, NULL, 233494),
(266291, '4b3xA02', NULL, NULL, 172, NULL, NULL, 233494),
(266292, '4a8jF00', NULL, NULL, 280, NULL, NULL, 233494),
(266293, '2xj4A00', NULL, NULL, 286, NULL, NULL, 233494),
(266294, '3q3jB00', NULL, NULL, 188, NULL, NULL, 233494),
(266295, '3tszA03', NULL, NULL, 176, NULL, NULL, 233494),
(266296, '1nktA03', NULL, NULL, 218, NULL, NULL, 233494),
(266297, '5x40A00', NULL, NULL, 292, NULL, NULL, 233494),
(266298, '1nktA01', NULL, NULL, 305, NULL, NULL, 233494),
(266299, '4edhB00', NULL, NULL, 213, NULL, NULL, 233494),
(266300, '3vr4A02', NULL, NULL, 294, NULL, NULL, 233494),
(266301, '5supC01', NULL, NULL, 220, NULL, NULL, 233494),
(266302, '2xzlA05', NULL, NULL, 212, NULL, NULL, 233494),
(266303, '4ag6A01', NULL, NULL, 252, NULL, NULL, 233494),
(266304, '2xzlA03', NULL, NULL, 214, NULL, NULL, 233494),
(266305, '1gkuB02', NULL, NULL, 213, NULL, NULL, 233494),
(266306, '1gkuB03', NULL, NULL, 186, NULL, NULL, 233494),
(266307, '5f9fA02', NULL, NULL, 177, NULL, NULL, 233494),
(266308, '4loaA00', NULL, NULL, 173, NULL, NULL, 233494),
(266309, '6if3B00', NULL, NULL, 186, NULL, NULL, 233494),
(266310, '2xtmA00', NULL, NULL, 214, NULL, NULL, 233494),
(266311, '3tw4B00', NULL, NULL, 271, NULL, NULL, 233494),
(266312, '3tsoA00', NULL, NULL, 178, NULL, NULL, 233494),
(266313, '1nrjB00', NULL, NULL, 218, NULL, NULL, 233494),
(266314, '5xc5A00', NULL, NULL, 176, NULL, NULL, 233494),
(266315, '5cdfA02', NULL, NULL, 287, NULL, NULL, 233494),
(266316, '3dmnA00', NULL, NULL, 174, NULL, NULL, 233494),
(266317, '2qm8A02', NULL, NULL, 212, NULL, NULL, 233494),
(266318, '3n70A00', NULL, NULL, 145, NULL, NULL, 233494),
(266319, '4hseA02', NULL, NULL, 201, NULL, NULL, 233494),
(266320, '4hseA01', NULL, NULL, 196, NULL, NULL, 233494),
(266321, '1g3mB00', NULL, NULL, 294, NULL, NULL, 233494),
(266322, '1t9hA02', NULL, NULL, 165, NULL, NULL, 233494),
(266323, '1q3tA00', NULL, NULL, 236, NULL, NULL, 233494),
(266324, '4lv5B02', NULL, NULL, 183, NULL, NULL, 233494),
(266325, '2gj8D00', NULL, NULL, 172, NULL, NULL, 233494);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(266326, '4jlvA00', NULL, NULL, 269, NULL, NULL, 233494),
(266327, '2qnrA00', NULL, NULL, 284, NULL, NULL, 233494),
(266328, '3peyA02', NULL, NULL, 187, NULL, NULL, 233494),
(266329, '2d7cA00', NULL, NULL, 167, NULL, NULL, 233494),
(266330, '2fwrA03', NULL, NULL, 199, NULL, NULL, 233494),
(266331, '3peyA01', NULL, NULL, 208, NULL, NULL, 233494),
(266332, '5de3A00', NULL, NULL, 169, NULL, NULL, 233494),
(266333, '2fwrA02', NULL, NULL, 178, NULL, NULL, 233494),
(266334, '1cipA01', NULL, NULL, 204, NULL, NULL, 233494),
(266335, '1rifA02', NULL, NULL, 192, NULL, NULL, 233494),
(266336, '4wsiB03', NULL, NULL, 209, NULL, NULL, 233494),
(266337, '1yksA01', NULL, NULL, 181, NULL, NULL, 233494),
(266338, '1yksA02', NULL, NULL, 143, NULL, NULL, 233494),
(266339, '2zr9A01', NULL, NULL, 242, NULL, NULL, 233494),
(266340, '2gcoA01', NULL, NULL, 180, NULL, NULL, 233494),
(266341, '1wmsA00', NULL, NULL, 177, NULL, NULL, 233494),
(266342, '1njgA01', NULL, NULL, 184, NULL, NULL, 233494),
(266343, '3cbqA00', NULL, NULL, 174, NULL, NULL, 233494),
(266344, '2dy1A01', NULL, NULL, 280, NULL, NULL, 233494),
(266345, '2iyvA00', NULL, NULL, 184, NULL, NULL, 233494),
(266346, '2cvhA01', NULL, NULL, 214, NULL, NULL, 233494),
(266347, '3gj0A00', NULL, NULL, 221, NULL, NULL, 233494),
(266348, '5hciC00', NULL, NULL, 261, NULL, NULL, 233494),
(266349, '2bbsB00', NULL, NULL, 252, NULL, NULL, 233494),
(266350, '2a5yC01', NULL, NULL, 182, NULL, NULL, 233494),
(266351, '5xr6A00', NULL, NULL, 175, NULL, NULL, 233494),
(266352, '3l43C00', NULL, NULL, 251, NULL, NULL, 233494),
(266353, '3doeA00', NULL, NULL, 192, NULL, NULL, 233494),
(266354, '2c78A01', NULL, NULL, 213, NULL, NULL, 233494),
(266355, '5bn3A02', NULL, NULL, 292, NULL, NULL, 233494),
(266356, '5bykA00', NULL, NULL, 259, NULL, NULL, 233494),
(266357, '1xmvA01', NULL, NULL, 243, NULL, NULL, 233494),
(266358, '2yogA00', NULL, NULL, 210, NULL, NULL, 233494),
(266359, '1ofuX00', NULL, NULL, 119, NULL, NULL, 233494),
(266360, '3aq4A00', NULL, NULL, 184, NULL, NULL, 233494),
(266361, '3vfdA01', NULL, NULL, 209, NULL, NULL, 233494),
(266362, '1xzpA03', NULL, NULL, 167, NULL, NULL, 233494),
(266363, '4r7zH00', NULL, NULL, 338, NULL, NULL, 233494),
(266364, '4r98B01', NULL, NULL, 175, NULL, NULL, 233494),
(266365, '5c78A02', NULL, NULL, 226, NULL, NULL, 233494),
(266366, '2rb4A00', NULL, NULL, 175, NULL, NULL, 233494),
(266367, '4q03A00', NULL, NULL, 170, NULL, NULL, 233494),
(266368, '3pvsB01', NULL, NULL, 164, NULL, NULL, 233494),
(266369, '3zgxA01', NULL, NULL, 302, NULL, NULL, 233494),
(266370, '4mkgA00', NULL, NULL, 217, NULL, NULL, 233494),
(266371, '4hziB00', NULL, NULL, 263, NULL, NULL, 233494),
(266372, '3ozxA01', NULL, NULL, 253, NULL, NULL, 233494),
(266373, '5x86A00', NULL, NULL, 198, NULL, NULL, 233494),
(266374, '3ozxA02', NULL, NULL, 268, NULL, NULL, 233494),
(266375, '2z0mA01', NULL, NULL, 191, NULL, NULL, 233494),
(266376, '3rnlA00', NULL, NULL, 258, NULL, NULL, 233494),
(266377, '2z0mA02', NULL, NULL, 146, NULL, NULL, 233494),
(266378, '3ziaD02', NULL, NULL, 275, NULL, NULL, 233494),
(266379, '4abyD00', NULL, NULL, 378, NULL, NULL, 233494),
(266380, '2bdtA00', NULL, NULL, 189, NULL, NULL, 233494),
(266381, '3bd9A00', NULL, NULL, 262, NULL, NULL, 233494),
(266382, '4qm6A00', NULL, NULL, 171, NULL, NULL, 233494),
(266383, '3zh9B01', NULL, NULL, 143, NULL, NULL, 233494),
(266384, '5vh6A01', NULL, NULL, 288, NULL, NULL, 233494),
(266385, '5aunB01', NULL, NULL, 230, NULL, NULL, 233494),
(266386, '2wooA00', NULL, NULL, 329, NULL, NULL, 233494),
(266387, '3rabA00', NULL, NULL, 169, NULL, NULL, 233494),
(266388, '5w7qA01', NULL, NULL, 194, NULL, NULL, 233494),
(266389, '2j0vB00', NULL, NULL, 184, NULL, NULL, 233494),
(266390, '2j1lA00', NULL, NULL, 183, NULL, NULL, 233494),
(266391, '2wjiA00', NULL, NULL, 165, NULL, NULL, 233494),
(266392, '2atxA00', NULL, NULL, 194, NULL, NULL, 233494),
(266393, '3io5A00', NULL, NULL, 315, NULL, NULL, 233494),
(266394, '1xjcA00', NULL, NULL, 169, NULL, NULL, 233494),
(266395, '1q44A00', NULL, NULL, 326, NULL, NULL, 233494),
(266396, '4kj0V01', NULL, NULL, 303, NULL, NULL, 233494);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(266397, '2cdnA00', NULL, NULL, 201, NULL, NULL, 233494),
(266398, '6mjpA00', NULL, NULL, 241, NULL, NULL, 233494),
(266399, '2p5tF00', NULL, NULL, 253, NULL, NULL, 233494),
(266400, '4q7kA00', NULL, NULL, 226, NULL, NULL, 233494),
(266401, '2chgA01', NULL, NULL, 160, NULL, NULL, 233494),
(266402, '6n4lA00', NULL, NULL, 289, NULL, NULL, 233494),
(266403, '2v1xA02', NULL, NULL, 200, NULL, NULL, 233494),
(266404, '4ohxA02', NULL, NULL, 232, NULL, NULL, 233494),
(266405, '3trfA00', NULL, NULL, 185, NULL, NULL, 233494),
(266406, '2v1xA01', NULL, NULL, 235, NULL, NULL, 233494),
(266407, '3tlxA00', NULL, NULL, 243, NULL, NULL, 233494),
(266408, '3gehA03', NULL, NULL, 166, NULL, NULL, 233494),
(266409, '3nxsA02', NULL, NULL, 211, NULL, NULL, 233494),
(266410, '4zw2A02', NULL, NULL, 184, NULL, NULL, 233494),
(266411, '3p26A01', NULL, NULL, 256, NULL, NULL, 233494),
(266412, '5v2qA02', NULL, NULL, 199, NULL, NULL, 233494),
(266413, '2ov8A01', NULL, NULL, 189, NULL, NULL, 233494),
(266414, '3a58F00', NULL, NULL, 188, NULL, NULL, 233494),
(266415, '4gbmA00', NULL, NULL, 295, NULL, NULL, 233494),
(266416, '5h8wA04', NULL, NULL, 206, NULL, NULL, 233494),
(266417, '1dg3A02', NULL, NULL, 283, NULL, NULL, 233494),
(266418, '6aqeA00', NULL, NULL, 266, NULL, NULL, 233494),
(266419, '3pfiA01', NULL, NULL, 162, NULL, NULL, 233494),
(266420, '1u0jA02', NULL, NULL, 212, NULL, NULL, 233494),
(266421, '4z51A00', NULL, NULL, 271, NULL, NULL, 233494),
(266422, '4ppfA01', NULL, NULL, 242, NULL, NULL, 233494),
(266423, '2an9A01', NULL, NULL, 147, NULL, NULL, 233494),
(266424, '4r7yA04', NULL, NULL, 344, NULL, NULL, 233494),
(266425, '5ee5B00', NULL, NULL, 171, NULL, NULL, 233494),
(266426, '3gmtA00', NULL, NULL, 212, NULL, NULL, 233494),
(266427, '1vmaA02', NULL, NULL, 211, NULL, NULL, 233494),
(266428, '2qgnA01', NULL, NULL, 171, NULL, NULL, 233494),
(266429, '3sjbA00', NULL, NULL, 327, NULL, NULL, 233494),
(266430, '2fh5B00', NULL, NULL, 214, NULL, NULL, 233494),
(266431, '2bmfA02', NULL, NULL, 160, NULL, NULL, 233494),
(266432, '1lvgA02', NULL, NULL, 129, NULL, NULL, 233494),
(266433, '1mozA00', NULL, NULL, 183, NULL, NULL, 233494),
(266434, '2jaqA00', NULL, NULL, 205, NULL, NULL, 233494),
(266435, '3nbzC00', NULL, NULL, 176, NULL, NULL, 233494),
(266436, '1gotA01', NULL, NULL, 212, NULL, NULL, 233494),
(266437, '3wndA01', NULL, NULL, 172, NULL, NULL, 233494),
(266438, '4ad8A01', NULL, NULL, 300, NULL, NULL, 233494),
(266439, '3i5xA01', NULL, NULL, 247, NULL, NULL, 233494),
(266440, '3i5xA02', NULL, NULL, 260, NULL, NULL, 233494),
(266441, '3t34A00', NULL, NULL, 360, NULL, NULL, 233494),
(266442, '2yyzA01', NULL, NULL, 238, NULL, NULL, 233494),
(266443, '4o0mC02', NULL, NULL, 251, NULL, NULL, 233494),
(266444, '4lgmA01', NULL, NULL, 174, NULL, NULL, 233494),
(266445, '4r7zB00', NULL, NULL, 338, NULL, NULL, 233494),
(266446, '1z08C00', NULL, NULL, 170, NULL, NULL, 233494),
(266447, '2al7A00', NULL, NULL, 168, NULL, NULL, 233494),
(266448, '1pf4A02', NULL, NULL, 247, NULL, NULL, 233494),
(266449, '3clvA00', NULL, NULL, 177, NULL, NULL, 233494),
(266450, '4nkrE00', NULL, NULL, 166, NULL, NULL, 233494),
(266451, '2hcjB01', NULL, NULL, 144, NULL, NULL, 233494),
(266452, '6au6A01', NULL, NULL, 220, NULL, NULL, 233494),
(266453, '2vliB00', NULL, NULL, 183, NULL, NULL, 233494),
(266454, '4q4hB02', NULL, NULL, 255, NULL, NULL, 233494),
(266455, '1vg8A00', NULL, NULL, 190, NULL, NULL, 233494),
(266456, '3adkA00', NULL, NULL, 195, NULL, NULL, 233494),
(266457, '4tl9F00', NULL, NULL, 236, NULL, NULL, 233494),
(266458, '4pzlD00', NULL, NULL, 219, NULL, NULL, 233494),
(266459, '1yqtA02', NULL, NULL, 263, NULL, NULL, 233494),
(266460, '5upkC00', NULL, NULL, 185, NULL, NULL, 233494),
(266461, '1byiA00', NULL, NULL, 224, NULL, NULL, 233494),
(266462, '2j87D01', NULL, NULL, 134, NULL, NULL, 233494),
(266463, '3c7kC01', NULL, NULL, 202, NULL, NULL, 233494),
(266464, '2zq5A00', NULL, NULL, 384, NULL, NULL, 233494),
(266465, '1yqtA01', NULL, NULL, 251, NULL, NULL, 233494),
(266466, '2qtfA03', NULL, NULL, 186, NULL, NULL, 233494),
(266467, '3zqjA05', NULL, NULL, 203, NULL, NULL, 233494);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(266468, '4hatA00', NULL, NULL, 216, NULL, NULL, 233494),
(266469, '1ye8A00', NULL, NULL, 178, NULL, NULL, 233494),
(266470, '2ce2X00', NULL, NULL, 166, NULL, NULL, 233494),
(266471, '3zqjA01', NULL, NULL, 199, NULL, NULL, 233494),
(266472, '5mkkA02', NULL, NULL, 271, NULL, NULL, 233494),
(266473, '1sxjB01', NULL, NULL, 166, NULL, NULL, 233494),
(266474, '1yzqA00', NULL, NULL, 170, NULL, NULL, 233494),
(266475, '2ga8A00', NULL, NULL, 359, NULL, NULL, 233494),
(266476, '1m7bA00', NULL, NULL, 184, NULL, NULL, 233494),
(266477, '1aztB01', NULL, NULL, 220, NULL, NULL, 233494),
(266478, '3tlxC02', NULL, NULL, 148, NULL, NULL, 233494),
(266479, '6b5dA01', NULL, NULL, 221, NULL, NULL, 233494),
(266480, '4wxpA01', NULL, NULL, 147, NULL, NULL, 233494),
(266481, '2vf7B01', NULL, NULL, 335, NULL, NULL, 233494),
(266482, '3vkhA08', NULL, NULL, 354, NULL, NULL, 233494),
(266483, '1khtB00', NULL, NULL, 192, NULL, NULL, 233494),
(266484, '4wxpA02', NULL, NULL, 136, NULL, NULL, 233494),
(266485, '1z06A00', NULL, NULL, 171, NULL, NULL, 233494),
(266486, '3defA00', NULL, NULL, 262, NULL, NULL, 233494),
(266487, '5fuwA01', NULL, NULL, 135, NULL, NULL, 233494),
(266488, '2zejB02', NULL, NULL, 105, NULL, NULL, 233494),
(266489, '2yhsA02', NULL, NULL, 219, NULL, NULL, 233494),
(266490, '2zpaA02', NULL, NULL, 136, NULL, NULL, 233494),
(266491, '1hyqA00', NULL, NULL, 233, NULL, NULL, 233494),
(266492, '3ktaB00', NULL, NULL, 173, NULL, NULL, 233494),
(266493, '2fdcA01', NULL, NULL, 157, NULL, NULL, 233494),
(266494, '2vf7B03', NULL, NULL, 300, NULL, NULL, 233494),
(266495, '2wv9A02', NULL, NULL, 147, NULL, NULL, 233494),
(266496, '4ne2B00', NULL, NULL, 308, NULL, NULL, 233494),
(266497, '3qf7A01', NULL, NULL, 296, NULL, NULL, 233494),
(266498, '4lhwB00', NULL, NULL, 174, NULL, NULL, 233494),
(266499, '3k9gA00', NULL, NULL, 242, NULL, NULL, 233494),
(266500, '5ub8A01', NULL, NULL, 174, NULL, NULL, 233494),
(266501, '5jszA00', NULL, NULL, 282, NULL, NULL, 233494),
(266502, '3fwyA00', NULL, NULL, 268, NULL, NULL, 233494),
(266503, '4mitC00', NULL, NULL, 186, NULL, NULL, 233494),
(266504, '3ihlB00', NULL, NULL, 238, NULL, NULL, 233494),
(266505, '1ixsB01', NULL, NULL, 167, NULL, NULL, 233494),
(266506, '1ryhA00', NULL, NULL, 171, NULL, NULL, 233494),
(266507, '4ernA00', NULL, NULL, 237, NULL, NULL, 233494),
(266508, '2o8bB05', NULL, NULL, 263, NULL, NULL, 233494),
(266509, '5cyoB00', NULL, NULL, 274, NULL, NULL, 233494),
(266510, '5o8wA01', NULL, NULL, 236, NULL, NULL, 233494),
(266511, '2ohfA01', NULL, NULL, 189, NULL, NULL, 233494),
(266512, '3vkhA12', NULL, NULL, 174, NULL, NULL, 233494),
(266513, '2pt7A02', NULL, NULL, 187, NULL, NULL, 233494),
(266514, '3iuyA00', NULL, NULL, 228, NULL, NULL, 233494),
(266515, '3jvvB02', NULL, NULL, 256, NULL, NULL, 233494),
(266516, '2zj8A01', NULL, NULL, 193, NULL, NULL, 233494),
(266517, '5yk4B05', NULL, NULL, 225, NULL, NULL, 233494),
(266518, '5wriB00', NULL, NULL, 278, NULL, NULL, 233494),
(266519, '5jbqA01', NULL, NULL, 194, NULL, NULL, 233494),
(266520, '2zj8A02', NULL, NULL, 198, NULL, NULL, 233494),
(266521, '1v43A01', NULL, NULL, 246, NULL, NULL, 233494),
(266522, '2qt1A00', NULL, NULL, 207, NULL, NULL, 233494),
(266523, '1n0uA01', NULL, NULL, 212, NULL, NULL, 233494),
(266524, '1u9iA02', NULL, NULL, 248, NULL, NULL, 233494),
(266525, '3ea0A00', NULL, NULL, 245, NULL, NULL, 233494),
(266526, '1s2mA01', NULL, NULL, 205, NULL, NULL, 233494),
(266527, '3czpA02', NULL, NULL, 259, NULL, NULL, 233494),
(266528, '1fx0A02', NULL, NULL, 278, NULL, NULL, 233494),
(266529, '4uxhA01', NULL, NULL, 137, NULL, NULL, 233494),
(266530, '1s2mA02', NULL, NULL, 175, NULL, NULL, 233494),
(266531, '1kjwA02', NULL, NULL, 121, NULL, NULL, 233494),
(266532, '2iwrA00', NULL, NULL, 178, NULL, NULL, 233494),
(266533, '2z83A01', NULL, NULL, 194, NULL, NULL, 233494),
(266534, '3rwoA01', NULL, NULL, 178, NULL, NULL, 233494),
(266535, '1rz3A00', NULL, NULL, 201, NULL, NULL, 233494),
(266536, '1d5cA00', NULL, NULL, 162, NULL, NULL, 233494),
(266537, '4c9bA01', NULL, NULL, 222, NULL, NULL, 233494),
(266538, '4r7zD00', NULL, NULL, 338, NULL, NULL, 233494);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(266539, '4c9bA02', NULL, NULL, 169, NULL, NULL, 233494),
(266540, '1ji0A00', NULL, NULL, 240, NULL, NULL, 233494),
(266541, '4fw9A01', NULL, NULL, 283, NULL, NULL, 233494),
(266542, '5xu1A00', NULL, NULL, 245, NULL, NULL, 233494),
(266543, '3berA00', NULL, NULL, 220, NULL, NULL, 233494),
(266544, '2reoA01', NULL, NULL, 207, NULL, NULL, 233494),
(266545, '2i3bA00', NULL, NULL, 189, NULL, NULL, 233494),
(266546, '2ja1A01', NULL, NULL, 143, NULL, NULL, 233494),
(266547, '4b3bA00', NULL, NULL, 231, NULL, NULL, 233494),
(266548, '2f1rA00', NULL, NULL, 171, NULL, NULL, 233494),
(266549, '2oljA00', NULL, NULL, 242, NULL, NULL, 233494),
(266550, '2yz2B00', NULL, NULL, 266, NULL, NULL, 233494),
(266551, '5supA02', NULL, NULL, 170, NULL, NULL, 233494),
(266552, '2qagB00', NULL, NULL, 291, NULL, NULL, 233494),
(266553, '4qbgB00', NULL, NULL, 217, NULL, NULL, 233494),
(266554, '6mitE00', NULL, NULL, 241, NULL, NULL, 233494),
(266555, '4phtA03', NULL, NULL, 274, NULL, NULL, 233494),
(266556, '2ce7A01', NULL, NULL, 185, NULL, NULL, 233494),
(266557, '2w83E00', NULL, NULL, 165, NULL, NULL, 233494),
(266558, '4r2hA00', NULL, NULL, 210, NULL, NULL, 233494),
(266559, '2z83A02', NULL, NULL, 143, NULL, NULL, 233494),
(266560, '4blpB00', NULL, NULL, 270, NULL, NULL, 233494),
(266561, '3mcaA02', NULL, NULL, 164, NULL, NULL, 233494),
(266562, '3tqfA00', NULL, NULL, 181, NULL, NULL, 233494),
(266563, '4r7zO00', NULL, NULL, 338, NULL, NULL, 233494),
(266564, '3tifA00', NULL, NULL, 235, NULL, NULL, 233494),
(266565, '2db3A01', NULL, NULL, 267, NULL, NULL, 233494),
(266566, '3r7wA01', NULL, NULL, 182, NULL, NULL, 233494),
(266567, '5x5yA00', NULL, NULL, 247, NULL, NULL, 233494),
(266568, '1p72A00', NULL, NULL, 334, NULL, NULL, 233494),
(266569, '3w34A00', NULL, NULL, 211, NULL, NULL, 233494),
(266570, '2ynmA00', NULL, NULL, 268, NULL, NULL, 233494),
(266571, '1np6B01', NULL, NULL, 141, NULL, NULL, 233494),
(266572, '2dykA00', NULL, NULL, 161, NULL, NULL, 233494),
(266573, '3qi2A01', NULL, NULL, 191, NULL, NULL, 233494),
(266574, '1knxE02', NULL, NULL, 176, NULL, NULL, 233494),
(266575, '3e1sA03', NULL, NULL, 141, NULL, NULL, 233494),
(266576, '3e1sA02', NULL, NULL, 216, NULL, NULL, 233494),
(266577, '5ty0A01', NULL, NULL, 294, NULL, NULL, 233494),
(266578, '4cidA02', NULL, NULL, 245, NULL, NULL, 233494),
(266579, '5gvrA00', NULL, NULL, 234, NULL, NULL, 233494),
(266580, '3u4qB03', NULL, NULL, 218, NULL, NULL, 233494),
(266581, '3a1sB01', NULL, NULL, 169, NULL, NULL, 233494),
(266582, '2o0jA02', NULL, NULL, 254, NULL, NULL, 233494),
(266583, '5ko2A02', NULL, NULL, 249, NULL, NULL, 233494),
(266584, '6bk7A01', NULL, NULL, 288, NULL, NULL, 233494),
(266585, '4xjxA03', NULL, NULL, 191, NULL, NULL, 233494),
(266586, '4xjxA04', NULL, NULL, 270, NULL, NULL, 233494),
(266587, '2v1uA02', NULL, NULL, 180, NULL, NULL, 233494),
(266588, '2i4iA01', NULL, NULL, 241, NULL, NULL, 233494),
(266589, '1g8pA01', NULL, NULL, 199, NULL, NULL, 233494),
(266590, '4on9B01', NULL, NULL, 263, NULL, NULL, 233494),
(266591, '3fvqA01', NULL, NULL, 242, NULL, NULL, 233494),
(266592, '3a00A01', NULL, NULL, 92, NULL, NULL, 233494),
(266593, '5fl7D02', NULL, NULL, 275, NULL, NULL, 233494),
(266594, '5tshA02', NULL, NULL, 281, NULL, NULL, 233494),
(266595, '1wxqA01', NULL, NULL, 228, NULL, NULL, 233494),
(266596, '1e3mA05', NULL, NULL, 234, NULL, NULL, 233494),
(266597, '3gqbA02', NULL, NULL, 291, NULL, NULL, 233494),
(266598, '2fnaA01', NULL, NULL, 208, NULL, NULL, 233494),
(266599, '2r6fA01', NULL, NULL, 189, NULL, NULL, 233494),
(266600, '5h66B00', NULL, NULL, 188, NULL, NULL, 233494),
(266601, '4mycA02', NULL, NULL, 270, NULL, NULL, 233494),
(266602, '2r6fA05', NULL, NULL, 223, NULL, NULL, 233494),
(266603, '4zciA01', NULL, NULL, 198, NULL, NULL, 233494),
(266604, '1k6mA01', NULL, NULL, 205, NULL, NULL, 233494),
(266605, '4wbsA00', NULL, NULL, 246, NULL, NULL, 233494),
(266606, '4ry2B03', NULL, NULL, 244, NULL, NULL, 233494),
(266607, '2iusA02', NULL, NULL, 303, NULL, NULL, 233494),
(266608, '1ckeA00', NULL, NULL, 227, NULL, NULL, 233494),
(266609, '6bsxA00', NULL, NULL, 178, NULL, NULL, 233494);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(266610, '1e2kA00', NULL, NULL, 331, NULL, NULL, 233494),
(266611, '4blqA00', NULL, NULL, 280, NULL, NULL, 233494),
(266612, '5jxtD00', NULL, NULL, 308, NULL, NULL, 233494),
(266613, '3a4lB01', NULL, NULL, 188, NULL, NULL, 233494),
(266614, '1jqlB00', NULL, NULL, 140, NULL, NULL, 233494),
(266615, '5l3sB02', NULL, NULL, 210, NULL, NULL, 233494),
(266616, '3c5hA00', NULL, NULL, 255, NULL, NULL, 233494),
(266617, '2h17A00', NULL, NULL, 161, NULL, NULL, 233494),
(266618, '2vo1B00', NULL, NULL, 234, NULL, NULL, 233494),
(266619, '1kshA00', NULL, NULL, 170, NULL, NULL, 233494),
(266620, '2yweA01', NULL, NULL, 187, NULL, NULL, 233494),
(266621, '4o3mA02', NULL, NULL, 214, NULL, NULL, 233494),
(266622, '4o3mA01', NULL, NULL, 219, NULL, NULL, 233494),
(266623, '4i99A00', NULL, NULL, 337, NULL, NULL, 233494),
(266624, '3la6M00', NULL, NULL, 286, NULL, NULL, 233494),
(266625, '1hv8A02', NULL, NULL, 151, NULL, NULL, 233494),
(266626, '1hv8A01', NULL, NULL, 210, NULL, NULL, 233494),
(266627, '3bfxB00', NULL, NULL, 296, NULL, NULL, 233494),
(266628, '4d25A01', NULL, NULL, 267, NULL, NULL, 233494),
(266629, '2zu0C00', NULL, NULL, 248, NULL, NULL, 233494),
(266630, '1qhhA00', NULL, NULL, 167, NULL, NULL, 233494),
(266631, '1gvnD00', NULL, NULL, 287, NULL, NULL, 233494),
(266632, '4rz3A00', NULL, NULL, 244, NULL, NULL, 233494),
(266633, '3n2eA00', NULL, NULL, 168, NULL, NULL, 233494),
(266634, '4d25A02', NULL, NULL, 167, NULL, NULL, 233494),
(266635, '5l3rA02', NULL, NULL, 193, NULL, NULL, 233494),
(266636, '3k53A01', NULL, NULL, 170, NULL, NULL, 233494),
(266637, '3oesA00', NULL, NULL, 179, NULL, NULL, 233494),
(266638, '4l15A01', NULL, NULL, 226, NULL, NULL, 233494),
(266639, '3pxgC02', NULL, NULL, 171, NULL, NULL, 233494),
(266640, '4goxA00', NULL, NULL, 313, NULL, NULL, 233494),
(266641, '6cesA01', NULL, NULL, 184, NULL, NULL, 233494),
(266642, '3te6A01', NULL, NULL, 197, NULL, NULL, 233494),
(266643, '1vplA00', NULL, NULL, 256, NULL, NULL, 233494),
(266644, '2vl7A03', NULL, NULL, 193, NULL, NULL, 233494),
(266645, '2vl7A01', NULL, NULL, 179, NULL, NULL, 233494),
(266646, '2o52A01', NULL, NULL, 178, NULL, NULL, 233494),
(266647, '2wsmA00', NULL, NULL, 221, NULL, NULL, 233494),
(266648, '3lluA00', NULL, NULL, 177, NULL, NULL, 233494),
(266649, '2e87A02', NULL, NULL, 196, NULL, NULL, 233494),
(266650, '4f92B08', NULL, NULL, 206, NULL, NULL, 233494),
(266651, '4a8jA00', NULL, NULL, 296, NULL, NULL, 233494),
(266652, '1lv7A01', NULL, NULL, 180, NULL, NULL, 233494),
(266653, '4f92B07', NULL, NULL, 230, NULL, NULL, 233494),
(266654, '4f92B02', NULL, NULL, 228, NULL, NULL, 233494),
(266655, '1yrbA01', NULL, NULL, 258, NULL, NULL, 233494),
(266656, '4f92B01', NULL, NULL, 229, NULL, NULL, 233494),
(266657, '3fb4A00', NULL, NULL, 216, NULL, NULL, 233494),
(266658, '2x19A00', NULL, NULL, 172, NULL, NULL, 233494),
(266659, '2gxqA00', NULL, NULL, 207, NULL, NULL, 233494),
(266660, '1fqjA01', NULL, NULL, 191, NULL, NULL, 233494),
(266661, '3uatA02', NULL, NULL, 121, NULL, NULL, 233494),
(266662, '1z47B01', NULL, NULL, 250, NULL, NULL, 233494),
(266663, '5vcuA00', NULL, NULL, 208, NULL, NULL, 233494),
(266664, '2ipcB01', NULL, NULL, 276, NULL, NULL, 233494),
(266665, '3lrpA00', NULL, NULL, 181, NULL, NULL, 233494),
(266666, '2ck3D02', NULL, NULL, 276, NULL, NULL, 233494),
(266667, '2pezA00', NULL, NULL, 179, NULL, NULL, 233494),
(266668, '5g41A00', NULL, NULL, 223, NULL, NULL, 233494),
(266669, '4a9aA02', NULL, NULL, 172, NULL, NULL, 233494),
(266670, '6an9A00', NULL, NULL, 305, NULL, NULL, 233494),
(266671, '2c95A00', NULL, NULL, 196, NULL, NULL, 233494),
(266672, '4gl2A01', NULL, NULL, 284, NULL, NULL, 233494),
(266673, '5ik2D02', NULL, NULL, 268, NULL, NULL, 233494),
(266674, '4gl2A02', NULL, NULL, 154, NULL, NULL, 233494),
(266675, '4ymuA00', NULL, NULL, 240, NULL, NULL, 233494),
(266676, '2plrA00', NULL, NULL, 213, NULL, NULL, 233494),
(266677, '3oaaD02', NULL, NULL, 269, NULL, NULL, 233494),
(266678, '3qq5A01', NULL, NULL, 180, NULL, NULL, 233494),
(266679, '1uaaA01', NULL, NULL, 196, NULL, NULL, 233494),
(266680, '3nwjA00', NULL, NULL, 219, NULL, NULL, 233494);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(266681, '3regA00', NULL, NULL, 174, NULL, NULL, 233494),
(266682, '4u00A00', NULL, NULL, 244, NULL, NULL, 233494),
(266683, '2wblD00', NULL, NULL, 180, NULL, NULL, 233494),
(266684, '1kaoA00', NULL, NULL, 167, NULL, NULL, 233494),
(266685, '1aquB00', NULL, NULL, 297, NULL, NULL, 233494),
(266686, '2fshB01', NULL, NULL, 262, NULL, NULL, 233494),
(266687, '2qmhB00', NULL, NULL, 188, NULL, NULL, 233494),
(266688, '2dr3A00', NULL, NULL, 247, NULL, NULL, 233494),
(266689, '5he9A00', NULL, NULL, 174, NULL, NULL, 233494),
(266690, '1jbkA00', NULL, NULL, 195, NULL, NULL, 233494),
(266691, '3pg5A00', NULL, NULL, 327, NULL, NULL, 233494),
(266692, '1dpfA00', NULL, NULL, 180, NULL, NULL, 233494),
(266693, '3v9pB00', NULL, NULL, 205, NULL, NULL, 233494),
(266694, '2qi9C00', NULL, NULL, 249, NULL, NULL, 233494),
(266695, '1g3qA00', NULL, NULL, 237, NULL, NULL, 233494),
(266696, '5cm8B00', NULL, NULL, 181, NULL, NULL, 233494),
(266697, '4g1uD00', NULL, NULL, 266, NULL, NULL, 233494),
(266698, '5g53C00', NULL, NULL, 229, NULL, NULL, 233494),
(266699, '6b8dA01', NULL, NULL, 296, NULL, NULL, 233494),
(266700, '2ocbA00', NULL, NULL, 180, NULL, NULL, 233494),
(266701, '2g9nB00', NULL, NULL, 221, NULL, NULL, 233494),
(266702, '4qosA01', NULL, NULL, 179, NULL, NULL, 233494),
(266703, '4s35A00', NULL, NULL, 195, NULL, NULL, 233494),
(266704, '1sxjD01', NULL, NULL, 167, NULL, NULL, 233494),
(266705, '2xzpA01', NULL, NULL, 266, NULL, NULL, 233494),
(266706, '6f7uA00', NULL, NULL, 214, NULL, NULL, 233494),
(266707, '3b85A00', NULL, NULL, 208, NULL, NULL, 233494),
(266708, '3lxxA00', NULL, NULL, 193, NULL, NULL, 233494),
(266709, '5m7oA02', NULL, NULL, 173, NULL, NULL, 233494),
(266710, '2iezA00', NULL, NULL, 192, NULL, NULL, 233494),
(266711, '3q72B00', NULL, NULL, 166, NULL, NULL, 233494),
(266712, '4cz2B00', NULL, NULL, 179, NULL, NULL, 233494),
(266713, '4djtB00', NULL, NULL, 218, NULL, NULL, 233494),
(266714, '3vkwA02', NULL, NULL, 142, NULL, NULL, 233494),
(266715, '1um8A01', NULL, NULL, 271, NULL, NULL, 233494),
(266716, '2j7pD02', NULL, NULL, 208, NULL, NULL, 233494),
(266717, '3vkwA03', NULL, NULL, 148, NULL, NULL, 233494),
(266718, '5jedA00', NULL, NULL, 231, NULL, NULL, 233494),
(266719, '3t5gA00', NULL, NULL, 181, NULL, NULL, 233494),
(266720, '2z43C02', NULL, NULL, 240, NULL, NULL, 233494),
(266721, '5d0uA02', NULL, NULL, 185, NULL, NULL, 233494),
(266722, '4r7zK00', NULL, NULL, 338, NULL, NULL, 233494),
(266723, '3dz8A00', NULL, NULL, 191, NULL, NULL, 233494),
(266724, '5d0uA01', NULL, NULL, 215, NULL, NULL, 233494),
(266725, '1zakA00', NULL, NULL, 222, NULL, NULL, 233494),
(266726, '1l8qA01', NULL, NULL, 166, NULL, NULL, 233494),
(266727, '4q4lA02', NULL, NULL, 269, NULL, NULL, 233494),
(266728, '4ku4A00', NULL, NULL, 206, NULL, NULL, 233494),
(266729, '5x2bJ00', NULL, NULL, 282, NULL, NULL, 233494),
(266730, '5j4lA00', NULL, NULL, 231, NULL, NULL, 233494),
(266731, '4p32B00', NULL, NULL, 230, NULL, NULL, 233494),
(266732, '4tquS01', NULL, NULL, 239, NULL, NULL, 233494),
(266733, '2fsfB03', NULL, NULL, 204, NULL, NULL, 233494),
(266734, '2ht1A02', NULL, NULL, 225, NULL, NULL, 233494),
(266735, '3wmgA02', NULL, NULL, 260, NULL, NULL, 233494),
(266736, '4c0sA01', NULL, NULL, 238, NULL, NULL, 233494),
(266737, '1mv5D00', NULL, NULL, 243, NULL, NULL, 233494),
(266738, '3zd7A02', NULL, NULL, 152, NULL, NULL, 233494),
(266739, '2oap202', NULL, NULL, 281, NULL, NULL, 233494),
(266740, '3p32A02', NULL, NULL, 211, NULL, NULL, 233494),
(266741, '1fuuB01', NULL, NULL, 227, NULL, NULL, 233494),
(266742, '5lddC00', NULL, NULL, 180, NULL, NULL, 233494),
(266743, '1tf5A01', NULL, NULL, 277, NULL, NULL, 233494),
(266744, '6focE02', NULL, NULL, 268, NULL, NULL, 233494),
(266745, '4basA00', NULL, NULL, 199, NULL, NULL, 233494),
(266746, '1tf5A03', NULL, NULL, 202, NULL, NULL, 233494),
(266747, '2ihyA00', NULL, NULL, 279, NULL, NULL, 233494),
(266748, '4ejsA00', NULL, NULL, 239, NULL, NULL, 233494),
(266749, '3dm5A02', NULL, NULL, 194, NULL, NULL, 233494),
(266750, '3fhoA01', NULL, NULL, 192, NULL, NULL, 233494),
(266751, '2qz4A01', NULL, NULL, 176, NULL, NULL, 233494);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(266752, '3thxA05', NULL, NULL, 315, NULL, NULL, 233494),
(266753, '2qeqA02', NULL, NULL, 143, NULL, NULL, 233494),
(266754, '3d3qA01', NULL, NULL, 162, NULL, NULL, 233494),
(266755, '5jwoA00', NULL, NULL, 247, NULL, NULL, 233494),
(266756, '2qeqA01', NULL, NULL, 175, NULL, NULL, 233494),
(266757, '4lcbA01', NULL, NULL, 174, NULL, NULL, 233494),
(266758, '2ph1A00', NULL, NULL, 262, NULL, NULL, 233494),
(266759, '4qrhB01', NULL, NULL, 150, NULL, NULL, 233494),
(266760, '1w1wA00', NULL, NULL, 328, NULL, NULL, 233494),
(266761, '5m32h02', NULL, NULL, 190, NULL, NULL, 233494),
(266762, '4ag5D01', NULL, NULL, 173, NULL, NULL, 233494),
(266763, '3wy9A01', NULL, NULL, 213, NULL, NULL, 233494),
(266764, '1r0xD00', NULL, NULL, 286, NULL, NULL, 233494),
(266765, '2hxsA00', NULL, NULL, 178, NULL, NULL, 233494),
(266766, '2p5sB00', NULL, NULL, 172, NULL, NULL, 233494),
(266767, '3lncA01', NULL, NULL, 150, NULL, NULL, 233494),
(266768, '3h4mA01', NULL, NULL, 187, NULL, NULL, 233494),
(266769, '4p4sA00', NULL, NULL, 303, NULL, NULL, 233494),
(266770, '1yzlA00', NULL, NULL, 179, NULL, NULL, 233494),
(266771, '4rd4A01', NULL, NULL, 207, NULL, NULL, 233494),
(266772, '1gzsA00', NULL, NULL, 180, NULL, NULL, 233494),
(266773, '5idvA01', NULL, NULL, 236, NULL, NULL, 233494),
(266774, '4oi4A02', NULL, NULL, 240, NULL, NULL, 233494),
(266775, '4aytA02', NULL, NULL, 236, NULL, NULL, 233494),
(266776, '3ld9A00', NULL, NULL, 205, NULL, NULL, 233494),
(266777, '4aurA01', NULL, NULL, 279, NULL, NULL, 233494),
(266778, '1bifA01', NULL, NULL, 206, NULL, NULL, 233494),
(266779, '3mgbA01', NULL, NULL, 222, NULL, NULL, 233494),
(266780, '2cbzA00', NULL, NULL, 237, NULL, NULL, 233494),
(266781, '2kwiA00', NULL, NULL, 178, NULL, NULL, 233494),
(266782, '1sq5C00', NULL, NULL, 308, NULL, NULL, 233494),
(266783, '5wdrA00', NULL, NULL, 171, NULL, NULL, 233494),
(266784, '1vcnA01', NULL, NULL, 296, NULL, NULL, 233494),
(266785, '2z4sA01', NULL, NULL, 168, NULL, NULL, 233494),
(266786, '3rc3A03', NULL, NULL, 159, NULL, NULL, 233494),
(266787, '6g2zA01', NULL, NULL, 189, NULL, NULL, 233494),
(266788, '3rc3A04', NULL, NULL, 156, NULL, NULL, 233494),
(266789, '1vhtA00', NULL, NULL, 218, NULL, NULL, 233494),
(266790, '4kxfL01', NULL, NULL, 208, NULL, NULL, 233494),
(266791, '5j47A03', NULL, NULL, 153, NULL, NULL, 233494),
(266792, '3tjzA00', NULL, NULL, 164, NULL, NULL, 233494),
(266793, '3hr8A01', NULL, NULL, 243, NULL, NULL, 233494),
(266794, '3h1tA03', NULL, NULL, 230, NULL, NULL, 233494),
(266795, '2eyqA06', NULL, NULL, 240, NULL, NULL, 233494),
(266796, '5if9B00', NULL, NULL, 273, NULL, NULL, 233494),
(266797, '2eyqA04', NULL, NULL, 249, NULL, NULL, 233494),
(266798, '3h1tA02', NULL, NULL, 202, NULL, NULL, 233494),
(266799, '2ykgA01', NULL, NULL, 224, NULL, NULL, 233494),
(266800, '1o3yA00', NULL, NULL, 166, NULL, NULL, 233494),
(266801, '5cdfE02', NULL, NULL, 277, NULL, NULL, 233494),
(266802, '3fgnD00', NULL, NULL, 225, NULL, NULL, 233494),
(266803, '4r7zM00', NULL, NULL, 338, NULL, NULL, 233494),
(266804, '5l22A02', NULL, NULL, 242, NULL, NULL, 233494),
(266805, '1iqpA01', NULL, NULL, 169, NULL, NULL, 233494),
(266806, '3nvaA01', NULL, NULL, 289, NULL, NULL, 233494),
(266807, '2vhjA01', NULL, NULL, 238, NULL, NULL, 233494),
(266808, '3lv8A00', NULL, NULL, 211, NULL, NULL, 233494),
(266809, '2qbyB02', NULL, NULL, 175, NULL, NULL, 233494),
(266810, '5ocoB00', NULL, NULL, 187, NULL, NULL, 233494),
(266811, '1z6xA00', NULL, NULL, 180, NULL, NULL, 233494),
(266812, '3eccA01', NULL, NULL, 165, NULL, NULL, 233494),
(266813, '4nh0A02', NULL, NULL, 308, NULL, NULL, 233494),
(266814, '4nh0A03', NULL, NULL, 242, NULL, NULL, 233494),
(266815, '3l0iD00', NULL, NULL, 199, NULL, NULL, 233494),
(266816, '4w7sA01', NULL, NULL, 277, NULL, NULL, 233494),
(266817, '2ad1A00', NULL, NULL, 265, NULL, NULL, 233494),
(266818, '1wp9A02', NULL, NULL, 164, NULL, NULL, 233494),
(266819, '4huqB00', NULL, NULL, 279, NULL, NULL, 233494),
(266820, '1nstA00', NULL, NULL, 304, NULL, NULL, 233494),
(266821, '1wp9A01', NULL, NULL, 199, NULL, NULL, 233494),
(266822, '4w7sA02', NULL, NULL, 186, NULL, NULL, 233494);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(266823, '3hjnA00', NULL, NULL, 197, NULL, NULL, 233494),
(266824, '1jr6A00', NULL, NULL, 142, NULL, NULL, 233494),
(266825, '1d2eA01', NULL, NULL, 196, NULL, NULL, 233494),
(266826, '3d31A01', NULL, NULL, 231, NULL, NULL, 233494),
(266827, '3vqtA01', NULL, NULL, 196, NULL, NULL, 233494),
(266828, '3hr7B00', NULL, NULL, 168, NULL, NULL, 233494),
(266829, '5w75C01', NULL, NULL, 198, NULL, NULL, 233494),
(266830, '1lnzA02', NULL, NULL, 185, NULL, NULL, 233494),
(266831, '1heiA02', NULL, NULL, 138, NULL, NULL, 233494),
(266832, '2f6rA00', NULL, NULL, 254, NULL, NULL, 233494),
(266833, '3f8tA03', NULL, NULL, 319, NULL, NULL, 233494),
(266834, '3nbxX01', NULL, NULL, 223, NULL, NULL, 233494),
(266835, '5lbaD01', NULL, NULL, 212, NULL, NULL, 233494),
(266836, '2va8B02', NULL, NULL, 214, NULL, NULL, 233494),
(266837, '5hr5A01', NULL, NULL, 211, NULL, NULL, 233494),
(266838, '1heiA01', NULL, NULL, 135, NULL, NULL, 233494),
(266839, '1oixA00', NULL, NULL, 168, NULL, NULL, 233494),
(266840, '4a4zA02', NULL, NULL, 232, NULL, NULL, 233494),
(266841, '2qmeA00', NULL, NULL, 179, NULL, NULL, 233494),
(266842, '4a4zA01', NULL, NULL, 214, NULL, NULL, 233494),
(266843, '1uj2A00', NULL, NULL, 213, NULL, NULL, 233494),
(266844, '4fwiB00', NULL, NULL, 334, NULL, NULL, 233494),
(266845, '5lbaD02', NULL, NULL, 233, NULL, NULL, 233494),
(266846, '1zd8A00', NULL, NULL, 227, NULL, NULL, 233494),
(266847, '3dzdA02', NULL, NULL, 165, NULL, NULL, 233494),
(266848, '5m04A02', NULL, NULL, 182, NULL, NULL, 233494),
(266849, '1gtvA00', NULL, NULL, 214, NULL, NULL, 233494),
(266850, '3t15A01', NULL, NULL, 185, NULL, NULL, 233494),
(266851, '5ksoA00', NULL, NULL, 170, NULL, NULL, 233494),
(266852, '2heiB00', NULL, NULL, 179, NULL, NULL, 233494),
(266853, '1vytB02', NULL, NULL, 189, NULL, NULL, 233494),
(266854, '2gf0B00', NULL, NULL, 177, NULL, NULL, 233494),
(266855, '3kkqA00', NULL, NULL, 183, NULL, NULL, 233494),
(266856, '5x6lA00', NULL, NULL, 195, NULL, NULL, 233494),
(266857, '1rflA00', NULL, NULL, 172, NULL, NULL, 233494),
(266858, '3kfvA02', NULL, NULL, 149, NULL, NULL, 233494),
(266859, '2gedA00', NULL, NULL, 193, NULL, NULL, 233494),
(266860, '3uk6F01', NULL, NULL, 237, NULL, NULL, 233494),
(266861, '1uf9A00', NULL, NULL, 203, NULL, NULL, 233494),
(266862, '3vu9B00', NULL, NULL, 213, NULL, NULL, 233494),
(266863, '2orwB01', NULL, NULL, 136, NULL, NULL, 233494),
(266864, '2pjrA03', NULL, NULL, 106, NULL, NULL, 233494),
(266865, '3bh0A00', NULL, NULL, 290, NULL, NULL, 233494),
(266866, '4ag6C01', NULL, NULL, 170, NULL, NULL, 233494),
(266867, '1ionA00', NULL, NULL, 243, NULL, NULL, 233494),
(266868, '5expA01', NULL, NULL, 183, NULL, NULL, 233494),
(266869, '5kszA03', NULL, NULL, 103, NULL, NULL, 233494),
(266870, '2ghiD00', NULL, NULL, 260, NULL, NULL, 233494),
(266871, '1w4rA01', NULL, NULL, 132, NULL, NULL, 233494),
(266872, '1r6bX02', NULL, NULL, 182, NULL, NULL, 233494),
(266873, '3e70C02', NULL, NULL, 197, NULL, NULL, 233494),
(266874, '1r6bX04', NULL, NULL, 214, NULL, NULL, 233494),
(266875, '3akeA00', NULL, NULL, 208, NULL, NULL, 233494),
(266876, '3kqnA02', NULL, NULL, 136, NULL, NULL, 233494),
(266877, '2h5eA02', NULL, NULL, 187, NULL, NULL, 233494),
(266878, '1zrhA00', NULL, NULL, 274, NULL, NULL, 233494),
(266879, '1ewqB05', NULL, NULL, 224, NULL, NULL, 233494),
(266880, '3gfoA00', NULL, NULL, 254, NULL, NULL, 233494),
(266881, '2h5eA01', NULL, NULL, 171, NULL, NULL, 233494),
(266882, '4c2uA03', NULL, NULL, 210, NULL, NULL, 233494),
(266883, '4c2uA01', NULL, NULL, 202, NULL, NULL, 233494),
(266884, '4nckB01', NULL, NULL, 339, NULL, NULL, 233494),
(266885, '3bwdD00', NULL, NULL, 182, NULL, NULL, 233494),
(266886, '5eumB00', NULL, NULL, 258, NULL, NULL, 233494),
(266887, '1jj7A01', NULL, NULL, 241, NULL, NULL, 233494),
(266888, '1in4A01', NULL, NULL, 164, NULL, NULL, 233494),
(266889, '3tvtA02', NULL, NULL, 121, NULL, NULL, 233494),
(266890, '6d4gA00', NULL, NULL, 253, NULL, NULL, 233494),
(266891, '2jeoA00', NULL, NULL, 223, NULL, NULL, 233494),
(266892, '3rhfD00', NULL, NULL, 289, NULL, NULL, 233494),
(266893, '1g16C00', NULL, NULL, 170, NULL, NULL, 233494);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(266894, '4r7zG00', NULL, NULL, 338, NULL, NULL, 233494),
(266895, '4w5wA01', NULL, NULL, 185, NULL, NULL, 233494),
(266896, '6bzsA00', NULL, NULL, 238, NULL, NULL, 233494),
(266897, '1xtiA02', NULL, NULL, 166, NULL, NULL, 233494),
(266898, '1vyvB02', NULL, NULL, 168, NULL, NULL, 233494),
(266899, '1ex7A02', NULL, NULL, 126, NULL, NULL, 233494),
(266900, '5uhvA00', NULL, NULL, 166, NULL, NULL, 233494),
(266901, '4c0kA03', NULL, NULL, 103, NULL, NULL, 233494),
(266902, '5x6jA00', NULL, NULL, 217, NULL, NULL, 233494),
(266903, '1z6tA02', NULL, NULL, 177, NULL, NULL, 233494),
(266904, '1efhA00', NULL, NULL, 292, NULL, NULL, 233494),
(266905, '4i1sA02', NULL, NULL, 116, NULL, NULL, 233494),
(266906, '4zo4A00', NULL, NULL, 204, NULL, NULL, 233494),
(266907, '2rcnA02', NULL, NULL, 173, NULL, NULL, 233494),
(266908, '1ojlB01', NULL, NULL, 175, NULL, NULL, 233494),
(266909, '2dbyA01', NULL, NULL, 171, NULL, NULL, 233494),
(266910, '2obnA02', NULL, NULL, 214, NULL, NULL, 233494),
(266911, '2ztsA00', NULL, NULL, 251, NULL, NULL, 233494),
(266912, '3vqtD02', NULL, NULL, 191, NULL, NULL, 233494),
(266913, '2xexA01', NULL, NULL, 285, NULL, NULL, 233494),
(266914, '6n0iA01', NULL, NULL, 297, NULL, NULL, 233494),
(266915, '3fkqA02', NULL, NULL, 237, NULL, NULL, 233494),
(266916, '3l2oB02', NULL, NULL, 205, NULL, NULL, 233494),
(266917, '1h65B00', NULL, NULL, 270, NULL, NULL, 233494),
(266918, '2cjwA00', NULL, NULL, 192, NULL, NULL, 233494),
(266919, '3w9yA01', NULL, NULL, 139, NULL, NULL, 233494),
(266920, '1mr3F00', NULL, NULL, 181, NULL, NULL, 233494),
(266921, '4nphA01', NULL, NULL, 270, NULL, NULL, 233494),
(266922, '3cioA00', NULL, NULL, 275, NULL, NULL, 233494),
(266923, '1c4oA01', NULL, NULL, 153, NULL, NULL, 233494),
(266924, '4e22A00', NULL, NULL, 230, NULL, NULL, 233494),
(266925, '1c4oA03', NULL, NULL, 175, NULL, NULL, 233494),
(266926, '3ly5A00', NULL, NULL, 217, NULL, NULL, 233494),
(266927, '1qhxA00', NULL, NULL, 178, NULL, NULL, 233494),
(266928, '3h86A00', NULL, NULL, 192, NULL, NULL, 233494),
(266929, '1c9kB00', NULL, NULL, 180, NULL, NULL, 233494),
(266930, '4nu0A00', NULL, NULL, 217, NULL, NULL, 233494),
(266931, '4mkiB00', NULL, NULL, 298, NULL, NULL, 233494),
(266932, '3tauB01', NULL, NULL, 148, NULL, NULL, 233494),
(266933, '2a5dA00', NULL, NULL, 175, NULL, NULL, 233494),
(266934, '3t1oA00', NULL, NULL, 198, NULL, NULL, 233494),
(266935, '3ez9A02', NULL, NULL, 294, NULL, NULL, 233494),
(266936, '5eqtA01', NULL, NULL, 175, NULL, NULL, 233494),
(266937, '2h57B00', NULL, NULL, 171, NULL, NULL, 233494),
(266938, '4f4cA03', NULL, NULL, 254, NULL, NULL, 233494),
(266939, '1fmjA00', NULL, NULL, 351, NULL, NULL, 233494),
(266940, '4f4cA02', NULL, NULL, 253, NULL, NULL, 233494),
(266941, '2onkA00', NULL, NULL, 240, NULL, NULL, 233494),
(266942, '2d7dA01', NULL, NULL, 163, NULL, NULL, 233494),
(266943, '2fzlA01', NULL, NULL, 135, NULL, NULL, 233494),
(266944, '3b9pA01', NULL, NULL, 213, NULL, NULL, 233494),
(266945, '1vecA00', NULL, NULL, 206, NULL, NULL, 233494),
(266946, '5ep2A01', NULL, NULL, 174, NULL, NULL, 233494),
(266947, '1tadC01', NULL, NULL, 205, NULL, NULL, 233494),
(266948, '2d7dA04', NULL, NULL, 177, NULL, NULL, 233494),
(266949, '1ixzA01', NULL, NULL, 185, NULL, NULL, 233494),
(266950, '1z3iX02', NULL, NULL, 243, NULL, NULL, 233494),
(266951, '3iqwB00', NULL, NULL, 264, NULL, NULL, 233494),
(266952, '5szjA00', NULL, NULL, 177, NULL, NULL, 233494),
(266953, '3tbkA01', NULL, NULL, 247, NULL, NULL, 233494),
(266954, '3tbkA02', NULL, NULL, 166, NULL, NULL, 233494),
(266955, '1f2uA00', NULL, NULL, 149, NULL, NULL, 233494),
(266956, '1j8mF02', NULL, NULL, 194, NULL, NULL, 233494),
(266957, '1x3sA00', NULL, NULL, 195, NULL, NULL, 233494),
(266958, '5x7kB00', NULL, NULL, 241, NULL, NULL, 233494),
(266959, '4hluD00', NULL, NULL, 268, NULL, NULL, 233494),
(266960, '1nksA00', NULL, NULL, 194, NULL, NULL, 233494),
(266961, '4r7zI00', NULL, NULL, 338, NULL, NULL, 233494),
(266962, '4y0aA00', NULL, NULL, 179, NULL, NULL, 233494),
(266963, '2p6rA01', NULL, NULL, 197, NULL, NULL, 233494),
(266964, '2p6rA02', NULL, NULL, 196, NULL, NULL, 233494);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(266965, '1z29A00', NULL, NULL, 295, NULL, NULL, 233494),
(266966, '1ek0A00', NULL, NULL, 170, NULL, NULL, 233494),
(266967, '2zu6F01', NULL, NULL, 159, NULL, NULL, 233494),
(266968, '4hi0E00', NULL, NULL, 199, NULL, NULL, 233494),
(266969, '2q6tD02', NULL, NULL, 260, NULL, NULL, 233494),
(266970, '4p4uA00', NULL, NULL, 363, NULL, NULL, 233494),
(266971, '3pqcB00', NULL, NULL, 195, NULL, NULL, 233494),
(266972, '4jl5A00', NULL, NULL, 203, NULL, NULL, 233494),
(266973, '6b4kB02', NULL, NULL, 176, NULL, NULL, 233494),
(266974, '3tqcA00', NULL, NULL, 321, NULL, NULL, 233494),
(266975, '2bmeA01', NULL, NULL, 179, NULL, NULL, 233494),
(266976, '5ycdB00', NULL, NULL, 193, NULL, NULL, 233494),
(266977, '2yvuA00', NULL, NULL, 186, NULL, NULL, 233494),
(266978, '1d2mA01', NULL, NULL, 243, NULL, NULL, 233494),
(266979, '6f5dD02', NULL, NULL, 275, NULL, NULL, 233494),
(266980, '4zpxA01', NULL, NULL, 244, NULL, NULL, 233494),
(266981, '2o5vA01', NULL, NULL, 182, NULL, NULL, 233494),
(266982, '1jnyA01', NULL, NULL, 225, NULL, NULL, 233494),
(266983, '1t6nA00', NULL, NULL, 220, NULL, NULL, 233494),
(266984, '1cp2A00', NULL, NULL, 269, NULL, NULL, 233494),
(266985, '2pt5B00', NULL, NULL, 168, NULL, NULL, 233494),
(266986, '2rhmC00', NULL, NULL, 193, NULL, NULL, 233494),
(266987, '4mkhA00', NULL, NULL, 222, NULL, NULL, 233494),
(266988, '1fukA00', NULL, NULL, 165, NULL, NULL, 233494),
(266989, '5tv2A01', NULL, NULL, 293, NULL, NULL, 233494),
(266990, '2ngrA00', NULL, NULL, 191, NULL, NULL, 233494),
(266991, '6hufA00', NULL, NULL, 182, NULL, NULL, 233494),
(266992, '2vyfB02', NULL, NULL, 260, NULL, NULL, 233494),
(266993, '1e9rD01', NULL, NULL, 321, NULL, NULL, 233494),
(266994, '3ldaA02', NULL, NULL, 249, NULL, NULL, 233494),
(266995, '3mwyW04', NULL, NULL, 299, NULL, NULL, 233494),
(266996, '1wrbA00', NULL, NULL, 253, NULL, NULL, 233494),
(266997, '2wicA01', NULL, NULL, 174, NULL, NULL, 233494),
(266998, '2qgzA01', NULL, NULL, 195, NULL, NULL, 233494),
(266999, '3uieB00', NULL, NULL, 200, NULL, NULL, 233494),
(267000, '4akgA05', NULL, NULL, 150, NULL, NULL, 233494),
(267001, '4akgA07', NULL, NULL, 190, NULL, NULL, 233494),
(267002, '1a5tA01', NULL, NULL, 167, NULL, NULL, 233494),
(267003, '4idhA01', NULL, NULL, 208, NULL, NULL, 233494),
(267004, '3x1dA01', NULL, NULL, 316, NULL, NULL, 233494),
(267005, '4v0kB00', NULL, NULL, 169, NULL, NULL, 233494),
(267006, '6r3pA00', NULL, NULL, 261, NULL, NULL, 233494),
(267007, '2xb4A00', NULL, NULL, 223, NULL, NULL, 233494),
(267008, '2wwxA00', NULL, NULL, 175, NULL, NULL, 233494),
(267009, '4klzA00', NULL, NULL, 173, NULL, NULL, 233494),
(267010, '4ac9C01', NULL, NULL, 194, NULL, NULL, 233494),
(267011, '1oywA02', NULL, NULL, 132, NULL, NULL, 233494),
(267012, '1oywA01', NULL, NULL, 208, NULL, NULL, 233494),
(267013, '1m7gC00', NULL, NULL, 211, NULL, NULL, 233494),
(267014, '2r6aB02', NULL, NULL, 288, NULL, NULL, 233494),
(267015, '4akgA15', NULL, NULL, 128, NULL, NULL, 233494),
(267016, '2eyuA00', NULL, NULL, 261, NULL, NULL, 233494),
(267017, '3w5jA00', NULL, NULL, 204, NULL, NULL, 233494),
(267018, '2oblA01', NULL, NULL, 273, NULL, NULL, 233494),
(267019, '4akgA12', NULL, NULL, 117, NULL, NULL, 233494),
(267020, '3tmkD00', NULL, NULL, 216, NULL, NULL, 233494),
(267021, '4arzA01', NULL, NULL, 186, NULL, NULL, 233494),
(267022, '1gm5A05', NULL, NULL, 173, NULL, NULL, 233494),
(267023, '3h2yA01', NULL, NULL, 170, NULL, NULL, 233494),
(267024, '4pl0A02', NULL, NULL, 245, NULL, NULL, 233494),
(267025, '1gm5A04', NULL, NULL, 204, NULL, NULL, 233494),
(267026, '1w36F03', NULL, NULL, 276, NULL, NULL, 233494),
(267027, '1lw7A02', NULL, NULL, 169, NULL, NULL, 233494),
(267028, '4q48A02', NULL, NULL, 133, NULL, NULL, 233494),
(267029, '2zm5B01', NULL, NULL, 235, NULL, NULL, 233494),
(267030, '2xtzB01', NULL, NULL, 228, NULL, NULL, 233494),
(267031, '4q48A01', NULL, NULL, 207, NULL, NULL, 233494),
(267032, '5a5gA01', NULL, NULL, 325, NULL, NULL, 233494),
(267033, '2ak3B00', NULL, NULL, 226, NULL, NULL, 233494),
(267034, '2xszD01', NULL, NULL, 232, NULL, NULL, 233494),
(267035, '2v8oA02', NULL, NULL, 143, NULL, NULL, 233494);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(267036, '2yv5A02', NULL, NULL, 165, NULL, NULL, 233494),
(267037, '2wzqA02', NULL, NULL, 148, NULL, NULL, 233494),
(267038, '4qhsE01', NULL, NULL, 188, NULL, NULL, 233494),
(267039, '2v8oA01', NULL, NULL, 185, NULL, NULL, 233494),
(267040, '4akgA09', NULL, NULL, 354, NULL, NULL, 233494),
(267041, '2awnC01', NULL, NULL, 239, NULL, NULL, 233494),
(267042, '3nibA00', NULL, NULL, 276, NULL, NULL, 233494),
(267043, '4a2pA02', NULL, NULL, 167, NULL, NULL, 233494),
(267044, '1ky2A00', NULL, NULL, 182, NULL, NULL, 233494),
(267045, '5di3B00', NULL, NULL, 205, NULL, NULL, 233494),
(267046, '1g41A01', NULL, NULL, 198, NULL, NULL, 233494),
(267047, '4a2pA01', NULL, NULL, 249, NULL, NULL, 233494),
(267048, '2p6nA00', NULL, NULL, 164, NULL, NULL, 233494),
(267049, '3co5A00', NULL, NULL, 143, NULL, NULL, 233494),
(267050, '4nl4H03', NULL, NULL, 196, NULL, NULL, 233494),
(267051, '3c8uA00', NULL, NULL, 208, NULL, NULL, 233494),
(267052, '4r7zC00', NULL, NULL, 338, NULL, NULL, 233494),
(267053, '3dpuA02', NULL, NULL, 174, NULL, NULL, 233494),
(267054, '2waxC00', NULL, NULL, 177, NULL, NULL, 233494),
(267055, '3u61C01', NULL, NULL, 166, NULL, NULL, 233494),
(267056, '2akaB00', NULL, NULL, 299, NULL, NULL, 233494),
(267057, '5l3qB02', NULL, NULL, 237, NULL, NULL, 233494),
(267058, '2iw3A03', NULL, NULL, 219, NULL, NULL, 233494),
(267059, '1g29101', NULL, NULL, 244, NULL, NULL, 233494),
(267060, '6iubA00', NULL, NULL, 276, NULL, NULL, 233494),
(267061, '2iw3A04', NULL, NULL, 235, NULL, NULL, 233494),
(267062, '4ql3A00', NULL, NULL, 170, NULL, NULL, 233494),
(267063, '2v9pD02', NULL, NULL, 203, NULL, NULL, 233494),
(267064, '3fyhA02', NULL, NULL, 256, NULL, NULL, 233494),
(267065, '3vkgA07', NULL, NULL, 387, NULL, NULL, 233494),
(267066, '4d2iA02', NULL, NULL, 270, NULL, NULL, 233494),
(267067, '1s96A01', NULL, NULL, 159, NULL, NULL, 233494),
(267068, '3vkgA05', NULL, NULL, 152, NULL, NULL, 233494),
(267069, '1sxjC01', NULL, NULL, 169, NULL, NULL, 233494),
(267070, '4d81A01', NULL, NULL, 183, NULL, NULL, 233494),
(267071, '2bwjA00', NULL, NULL, 199, NULL, NULL, 233494),
(267072, '1z07A00', NULL, NULL, 166, NULL, NULL, 233494),
(267073, '3bk7A01', NULL, NULL, 344, NULL, NULL, 233494),
(267074, '3cx8A01', NULL, NULL, 212, NULL, NULL, 233494),
(267075, '3wp0A00', NULL, NULL, 187, NULL, NULL, 233494),
(267076, '5mkkB02', NULL, NULL, 250, NULL, NULL, 233494),
(267077, '5kh0A01', NULL, NULL, 174, NULL, NULL, 233494),
(267078, '1zp6A00', NULL, NULL, 191, NULL, NULL, 233494),
(267079, '3x1xA00', NULL, NULL, 167, NULL, NULL, 233494),
(267080, '1ukvY00', NULL, NULL, 206, NULL, NULL, 233494),
(267081, '2gaoB00', NULL, NULL, 185, NULL, NULL, 233494),
(267082, '5wdxA04', NULL, NULL, 158, NULL, NULL, 233494),
(267083, '5wdxA03', NULL, NULL, 149, NULL, NULL, 233494),
(267084, '3bk7A02', NULL, NULL, 263, NULL, NULL, 233494),
(267085, '1yzgA00', NULL, NULL, 179, NULL, NULL, 233494),
(267086, '1fzqA00', NULL, NULL, 181, NULL, NULL, 233494),
(267087, '4wiaC00', NULL, NULL, 233, NULL, NULL, 233494),
(267088, '3bc1A00', NULL, NULL, 195, NULL, NULL, 233494),
(267089, '1z2aA00', NULL, NULL, 168, NULL, NULL, 233494),
(267090, '3ihwA00', NULL, NULL, 184, NULL, NULL, 233494),
(267091, '3bfkB01', NULL, NULL, 177, NULL, NULL, 233494),
(267092, '2xzoA03', NULL, NULL, 213, NULL, NULL, 233494),
(267093, '4ttrA00', NULL, NULL, 215, NULL, NULL, 233494),
(267094, '1ihuA01', NULL, NULL, 274, NULL, NULL, 233494),
(267095, '2v6iA02', NULL, NULL, 143, NULL, NULL, 233494),
(267096, '4i1uA00', NULL, NULL, 210, NULL, NULL, 233494),
(267097, '3ihlA00', NULL, NULL, 242, NULL, NULL, 233494),
(267098, '1s0uA01', NULL, NULL, 201, NULL, NULL, 233494),
(267099, '3lxwA00', NULL, NULL, 228, NULL, NULL, 233494),
(267100, '1ihuA02', NULL, NULL, 296, NULL, NULL, 233494),
(267101, '1w36D03', NULL, NULL, 173, NULL, NULL, 233494),
(267102, '2v6iA01', NULL, NULL, 175, NULL, NULL, 233494),
(267103, '3ewaA02', NULL, NULL, 256, NULL, NULL, 233494),
(267104, '1w36D02', NULL, NULL, 245, NULL, NULL, 233494),
(267105, '1q1zA00', NULL, NULL, 299, NULL, NULL, 233494),
(267106, '1egaA01', NULL, NULL, 184, NULL, NULL, 233494);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(267107, '3bosB01', NULL, NULL, 173, NULL, NULL, 233494),
(267108, '5jszB00', NULL, NULL, 287, NULL, NULL, 233494),
(267109, '3fhtB01', NULL, NULL, 235, NULL, NULL, 233494),
(267110, '4q7lC00', NULL, NULL, 256, NULL, NULL, 233494),
(267111, '5fl7A02', NULL, NULL, 286, NULL, NULL, 233494),
(267112, '4yc7A00', NULL, NULL, 181, NULL, NULL, 233494),
(267113, '2f55A02', NULL, NULL, 136, NULL, NULL, 233494),
(267114, '3borA00', NULL, NULL, 211, NULL, NULL, 233494),
(267115, '1f6bB00', NULL, NULL, 198, NULL, NULL, 233494),
(267116, '6o62A00', NULL, NULL, 184, NULL, NULL, 233494),
(267117, '5mfxA01', NULL, NULL, 188, NULL, NULL, 233494),
(267118, '3iijA00', NULL, NULL, 180, NULL, NULL, 233494),
(267119, '3zq6C00', NULL, NULL, 324, NULL, NULL, 233494),
(267120, '6ff8A00', NULL, NULL, 181, NULL, NULL, 233494),
(267121, '3tahB01', NULL, NULL, 173, NULL, NULL, 233494),
(267122, '3tr0A01', NULL, NULL, 145, NULL, NULL, 233494),
(267123, '1fnnA02', NULL, NULL, 174, NULL, NULL, 233494),
(267124, '3ap1A01', NULL, NULL, 307, NULL, NULL, 233494),
(267125, '2r44A02', NULL, NULL, 167, NULL, NULL, 233494),
(267126, '1wf3A01', NULL, NULL, 184, NULL, NULL, 233494),
(267127, '2bmfB01', NULL, NULL, 192, NULL, NULL, 233494),
(267128, '2xszB01', NULL, NULL, 259, NULL, NULL, 233494),
(267129, '4p0tB00', NULL, NULL, 157, NULL, NULL, 233494),
(267130, '4np6B00', NULL, NULL, 217, NULL, NULL, 233494),
(267131, '4ljyA02', NULL, NULL, 202, NULL, NULL, 233494),
(267132, '1p9rA02', NULL, NULL, 280, NULL, NULL, 233494),
(267133, '3czpB01', NULL, NULL, 238, NULL, NULL, 233494),
(267134, '4ljyA01', NULL, NULL, 265, NULL, NULL, 233494),
(267135, '5bq5B00', NULL, NULL, 189, NULL, NULL, 233494),
(267136, '3i8sB01', NULL, NULL, 174, NULL, NULL, 233494),
(267137, '4r7zE00', NULL, NULL, 338, NULL, NULL, 233494),
(267138, '2cxxA00', NULL, NULL, 190, NULL, NULL, 233494),
(267139, '3v4rA01', NULL, NULL, 254, NULL, NULL, 233494),
(267140, '4mrsB02', NULL, NULL, 265, NULL, NULL, 233494),
(267141, '2x8aA01', NULL, NULL, 177, NULL, NULL, 233494),
(267142, '4o0mB01', NULL, NULL, 249, NULL, NULL, 233494),
(267143, '4u5xA00', NULL, NULL, 178, NULL, NULL, 233494),
(267144, '1shzD01', NULL, NULL, 214, NULL, NULL, 233494),
(267145, '3ibyB01', NULL, NULL, 172, NULL, NULL, 233494),
(267146, '2c9yA00', NULL, NULL, 242, NULL, NULL, 233494),
(267147, '5zbzA00', NULL, NULL, 220, NULL, NULL, 233494),
(267148, '3upuA02', NULL, NULL, 130, NULL, NULL, 233494),
(267149, '3sylA01', NULL, NULL, 202, NULL, NULL, 233494),
(267150, '1ukzA00', NULL, NULL, 203, NULL, NULL, 233494),
(267151, '5uivA00', NULL, NULL, 227, NULL, NULL, 233494),
(267152, '2o8bA05', NULL, NULL, 236, NULL, NULL, 233494),
(267153, '3upuA01', NULL, NULL, 176, NULL, NULL, 233494),
(267154, '6az0A01', NULL, NULL, 170, NULL, NULL, 233494),
(267155, '3ziaA02', NULL, NULL, 286, NULL, NULL, 233494),
(267156, '2q3fA00', NULL, NULL, 181, NULL, NULL, 233494),
(267157, '4idoA01', NULL, NULL, 311, NULL, NULL, 233494),
(267158, '4lyaA01', NULL, NULL, 288, NULL, NULL, 233494),
(267159, '1z0jA00', NULL, NULL, 170, NULL, NULL, 233494),
(267160, '2v54A00', NULL, NULL, 204, NULL, NULL, 233494),
(267161, '1m8pA03', NULL, NULL, 184, NULL, NULL, 233494),
(267162, '2b8tA01', NULL, NULL, 149, NULL, NULL, 233494),
(267163, '1knqA00', NULL, NULL, 175, NULL, NULL, 233494),
(267164, '4qjty01', NULL, NULL, 186, NULL, NULL, 233494),
(267165, '1cr2A00', NULL, NULL, 277, NULL, NULL, 233494),
(267166, '4kv9A00', NULL, NULL, 267, NULL, NULL, 233494),
(267167, '2jgnB00', NULL, NULL, 185, NULL, NULL, 233494),
(267168, '1sxjA01', NULL, NULL, 183, NULL, NULL, 233494),
(267169, '4k46A00', NULL, NULL, 214, NULL, NULL, 233494),
(267170, '3idqA01', NULL, NULL, 317, NULL, NULL, 233494),
(267171, '1g7sA01', NULL, NULL, 225, NULL, NULL, 233494),
(267172, '1z6gA01', NULL, NULL, 129, NULL, NULL, 233494),
(267173, '4q66F00', NULL, NULL, 175, NULL, NULL, 233494),
(267174, '3b6eA00', NULL, NULL, 199, NULL, NULL, 233494),
(267175, '1g6hA00', NULL, NULL, 257, NULL, NULL, 233494),
(267176, '3vkhB07', NULL, NULL, 189, NULL, NULL, 233494),
(267177, '3vkgA17', NULL, NULL, 126, NULL, NULL, 233494);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(267178, '3vkhB09', NULL, NULL, 183, NULL, NULL, 233494),
(267179, '2vf7A01', NULL, NULL, 221, NULL, NULL, 233494),
(267180, '1zinA00', NULL, NULL, 217, NULL, NULL, 233494),
(267181, '3vkgA13', NULL, NULL, 139, NULL, NULL, 233494),
(267182, '3vkgA10', NULL, NULL, 210, NULL, NULL, 233494),
(267183, '1b0uA00', NULL, NULL, 262, NULL, NULL, 233494),
(267184, '4rvcA00', NULL, NULL, 245, NULL, NULL, 233494),
(267185, '1w36B01', NULL, NULL, 248, NULL, NULL, 233494),
(267186, '3umfA00', NULL, NULL, 194, NULL, NULL, 233494),
(267187, '2fv8A00', NULL, NULL, 189, NULL, NULL, 233494),
(267188, '6bogA05', NULL, NULL, 209, NULL, NULL, 233494),
(267189, '2w58B01', NULL, NULL, 196, NULL, NULL, 233494),
(267190, '1w36B03', NULL, NULL, 299, NULL, NULL, 233494),
(267191, '5ar1A00', NULL, NULL, 278, NULL, NULL, 233494),
(267192, '3exaA01', NULL, NULL, 170, NULL, NULL, 233494),
(267193, '3ktaA00', NULL, NULL, 182, NULL, NULL, 233494),
(267194, '3m6aA02', NULL, NULL, 179, NULL, NULL, 233494),
(267195, '4lj9A01', NULL, NULL, 241, NULL, NULL, 233494),
(267196, '3nh6A01', NULL, NULL, 236, NULL, NULL, 233494),
(267197, '2ozeA00', NULL, NULL, 298, NULL, NULL, 233494),
(267198, '1sgwA00', NULL, NULL, 214, NULL, NULL, 233494),
(267199, '4ww0B01', NULL, NULL, 189, NULL, NULL, 233494),
(267200, '2c9oB01', NULL, NULL, 205, NULL, NULL, 233494),
(267201, '6bmfB01', NULL, NULL, 222, NULL, NULL, 233494),
(267202, '3czqC00', NULL, NULL, 287, NULL, NULL, 233494),
(267203, '1r5bA01', NULL, NULL, 249, NULL, NULL, 233494),
(267204, '5jjiF02', NULL, NULL, 288, NULL, NULL, 233494),
(267205, '2ck3A02', NULL, NULL, 286, NULL, NULL, 233494),
(267206, '4a1fB00', NULL, NULL, 319, NULL, NULL, 233494),
(267207, '6b5cA01', NULL, NULL, 221, NULL, NULL, 233494),
(267208, '1nlfA00', NULL, NULL, 279, NULL, NULL, 233494),
(267209, '3b60A02', NULL, NULL, 251, NULL, NULL, 233494),
(267210, '2oxcA00', NULL, NULL, 207, NULL, NULL, 233494),
(267211, '1nn3A00', NULL, NULL, 215, NULL, NULL, 233494),
(267212, '3o8bA03', NULL, NULL, 149, NULL, NULL, 233494),
(267213, '3o8bA04', NULL, NULL, 158, NULL, NULL, 233494),
(267214, '3q9lA00', NULL, NULL, 260, NULL, NULL, 233494),
(267215, '1xx6A01', NULL, NULL, 141, NULL, NULL, 233494),
(267216, '2y8eB00', NULL, NULL, 179, NULL, NULL, 233494),
(267217, '3cnlA01', NULL, NULL, 156, NULL, NULL, 233494),
(267218, '2vf8B04', NULL, NULL, 196, NULL, NULL, 233494),
(267219, '2hf9A00', NULL, NULL, 226, NULL, NULL, 233494),
(267220, '3mk7B01', NULL, NULL, 40, NULL, NULL, 233495),
(267221, '2icwG02', NULL, NULL, 89, NULL, NULL, 233496),
(267222, '4p22B02', NULL, NULL, 79, NULL, NULL, 233497),
(267223, '4ii2A03', NULL, NULL, 79, NULL, NULL, 233497),
(267224, '5tr4A03', NULL, NULL, 79, NULL, NULL, 233497),
(267225, '2v31A01', NULL, NULL, 97, NULL, NULL, 233497),
(267226, '2bo9B01', NULL, NULL, 97, NULL, NULL, 233498),
(267227, '2kxgA00', NULL, NULL, 95, NULL, NULL, 233498),
(267228, '1wnhA01', NULL, NULL, 100, NULL, NULL, 233498),
(267229, '1cewI00', NULL, NULL, 108, NULL, NULL, 233498),
(267230, '4ccvA00', NULL, NULL, 115, NULL, NULL, 233498),
(267231, '1wnhA02', NULL, NULL, 125, NULL, NULL, 233498),
(267232, '2bo9B02', NULL, NULL, 125, NULL, NULL, 233498),
(267233, '3l0rA00', NULL, NULL, 115, NULL, NULL, 233498),
(267234, '3mwzA00', NULL, NULL, 115, NULL, NULL, 233498),
(267235, '1eqkA00', NULL, NULL, 102, NULL, NULL, 233498),
(267236, '4lziA03', NULL, NULL, 93, NULL, NULL, 233498),
(267237, '4n6oB00', NULL, NULL, 131, NULL, NULL, 233498),
(267238, '4lziA02', NULL, NULL, 94, NULL, NULL, 233498),
(267239, '4lziA01', NULL, NULL, 95, NULL, NULL, 233498),
(267240, '1roaA00', NULL, NULL, 122, NULL, NULL, 233498),
(267241, '2mzvA01', NULL, NULL, 96, NULL, NULL, 233498),
(267242, '2l4vA00', NULL, NULL, 135, NULL, NULL, 233498),
(267243, '4eycB00', NULL, NULL, 107, NULL, NULL, 233498),
(267244, '5eljA00', NULL, NULL, 116, NULL, NULL, 233498),
(267245, '5lc7B00', NULL, NULL, 97, NULL, NULL, 233498),
(267246, '2octA00', NULL, NULL, 98, NULL, NULL, 233498),
(267247, '2w9qA00', NULL, NULL, 87, NULL, NULL, 233498),
(267248, '5a0oB00', NULL, NULL, 107, NULL, NULL, 233498);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(267249, '5eluA00', NULL, NULL, 118, NULL, NULL, 233498),
(267250, '2o9uX00', NULL, NULL, 97, NULL, NULL, 233498),
(267251, '4it7A00', NULL, NULL, 113, NULL, NULL, 233498),
(267252, '4tx4A00', NULL, NULL, 83, NULL, NULL, 233498),
(267253, '3kseD00', NULL, NULL, 98, NULL, NULL, 233498),
(267254, '3imaD00', NULL, NULL, 91, NULL, NULL, 233498),
(267255, '4n6tA00', NULL, NULL, 79, NULL, NULL, 233498),
(267256, '1kwiA00', NULL, NULL, 101, NULL, NULL, 233498),
(267257, '3ul5D00', NULL, NULL, 84, NULL, NULL, 233498),
(267258, '5mn2D00', NULL, NULL, 101, NULL, NULL, 233498),
(267259, '3gaxA00', NULL, NULL, 120, NULL, NULL, 233498),
(267260, '2ch9A01', NULL, NULL, 113, NULL, NULL, 233498),
(267261, '4zm8A00', NULL, NULL, 114, NULL, NULL, 233498),
(267262, '1f35A00', NULL, NULL, 162, NULL, NULL, 233499),
(267263, '2gttJ02', NULL, NULL, 215, NULL, NULL, 233500),
(267264, '3hhwK02', NULL, NULL, 200, NULL, NULL, 233500),
(267265, '3fsyA02', NULL, NULL, 40, NULL, NULL, 233501),
(267266, '5e3qA02', NULL, NULL, 40, NULL, NULL, 233501),
(267267, '2rijA02', NULL, NULL, 41, NULL, NULL, 233501),
(267268, '3r5dA02', NULL, NULL, 41, NULL, NULL, 233501),
(267269, '1b79B00', NULL, NULL, 103, NULL, NULL, 233502),
(267270, '2r5uC00', NULL, NULL, 144, NULL, NULL, 233502),
(267271, '3gxvB00', NULL, NULL, 123, NULL, NULL, 233502),
(267272, '4ehsA00', NULL, NULL, 130, NULL, NULL, 233502),
(267273, '4im9B00', NULL, NULL, 152, NULL, NULL, 233502),
(267274, '2r6aA01', NULL, NULL, 151, NULL, NULL, 233502),
(267275, '3bgwA01', NULL, NULL, 150, NULL, NULL, 233502),
(267276, '2vyfB01', NULL, NULL, 131, NULL, NULL, 233502),
(267277, '2r6aB01', NULL, NULL, 166, NULL, NULL, 233502),
(267278, '2lznA00', NULL, NULL, 143, NULL, NULL, 233502),
(267279, '2q6tB01', NULL, NULL, 149, NULL, NULL, 233502),
(267280, '6cbrB00', NULL, NULL, 166, NULL, NULL, 233502),
(267281, '2r6aC01', NULL, NULL, 96, NULL, NULL, 233502),
(267282, '6c9xA03', NULL, NULL, 127, NULL, NULL, 233503),
(267283, '2nv4A00', NULL, NULL, 147, NULL, NULL, 233504),
(267284, '1xqbA01', NULL, NULL, 132, NULL, NULL, 233504),
(267285, '3okxB00', NULL, NULL, 152, NULL, NULL, 233504),
(267286, '3bg1B01', NULL, NULL, 49, NULL, NULL, 233505),
(267287, '4o1gA00', NULL, NULL, 324, NULL, NULL, 233506),
(267288, '5b6aA00', NULL, NULL, 288, NULL, NULL, 233506),
(267289, '5zwbA00', NULL, NULL, 296, NULL, NULL, 233506),
(267290, '1l2lA01', NULL, NULL, 347, NULL, NULL, 233506),
(267291, '1vi9A00', NULL, NULL, 299, NULL, NULL, 233506),
(267292, '5trwA00', NULL, NULL, 296, NULL, NULL, 233506),
(267293, '4gm6A00', NULL, NULL, 327, NULL, NULL, 233506),
(267294, '3umoA00', NULL, NULL, 309, NULL, NULL, 233506),
(267295, '1esjA00', NULL, NULL, 284, NULL, NULL, 233506),
(267296, '2jg5A00', NULL, NULL, 306, NULL, NULL, 233506),
(267297, '3vasA01', NULL, NULL, 287, NULL, NULL, 233506),
(267298, '2v78A00', NULL, NULL, 313, NULL, NULL, 233506),
(267299, '3ry7A00', NULL, NULL, 304, NULL, NULL, 233506),
(267300, '4s1hA00', NULL, NULL, 287, NULL, NULL, 233506),
(267301, '4c5kD00', NULL, NULL, 276, NULL, NULL, 233506),
(267302, '3drwB01', NULL, NULL, 333, NULL, NULL, 233506),
(267303, '3looB01', NULL, NULL, 282, NULL, NULL, 233506),
(267304, '3rssA02', NULL, NULL, 284, NULL, NULL, 233506),
(267305, '2absA01', NULL, NULL, 284, NULL, NULL, 233506),
(267306, '4xdaA00', NULL, NULL, 309, NULL, NULL, 233506),
(267307, '3bgkA00', NULL, NULL, 276, NULL, NULL, 233506),
(267308, '2yxtA00', NULL, NULL, 312, NULL, NULL, 233506),
(267309, '1v1aA00', NULL, NULL, 309, NULL, NULL, 233506),
(267310, '4ywrA00', NULL, NULL, 246, NULL, NULL, 233506),
(267311, '2ajrA01', NULL, NULL, 265, NULL, NULL, 233506),
(267312, '5eynA00', NULL, NULL, 306, NULL, NULL, 233506),
(267313, '3dzvA00', NULL, NULL, 273, NULL, NULL, 233506),
(267314, '3ktnA00', NULL, NULL, 346, NULL, NULL, 233506),
(267315, '4wjmA00', NULL, NULL, 312, NULL, NULL, 233506),
(267316, '2ddmB00', NULL, NULL, 283, NULL, NULL, 233506),
(267317, '4jjpA00', NULL, NULL, 248, NULL, NULL, 233506),
(267318, '3b1nA00', NULL, NULL, 326, NULL, NULL, 233506),
(267319, '3bf5A01', NULL, NULL, 256, NULL, NULL, 233506);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(267320, '3ljsA00', NULL, NULL, 338, NULL, NULL, 233506),
(267321, '2c4eA00', NULL, NULL, 302, NULL, NULL, 233506),
(267322, '5cgeE00', NULL, NULL, 277, NULL, NULL, 233506),
(267323, '3rpzA00', NULL, NULL, 279, NULL, NULL, 233506),
(267324, '3ikhA00', NULL, NULL, 299, NULL, NULL, 233506),
(267325, '3go6A00', NULL, NULL, 292, NULL, NULL, 233506),
(267326, '2rbcA00', NULL, NULL, 316, NULL, NULL, 233506),
(267327, '1lhpA00', NULL, NULL, 312, NULL, NULL, 233506),
(267328, '5c40B00', NULL, NULL, 330, NULL, NULL, 233506),
(267329, '3iq0A00', NULL, NULL, 313, NULL, NULL, 233506),
(267330, '3hpdA00', NULL, NULL, 265, NULL, NULL, 233506),
(267331, '1tyyA00', NULL, NULL, 315, NULL, NULL, 233506),
(267332, '3w4sA00', NULL, NULL, 273, NULL, NULL, 233506),
(267333, '2afbB00', NULL, NULL, 351, NULL, NULL, 233506),
(267334, '4du5B00', NULL, NULL, 311, NULL, NULL, 233506),
(267335, '2i5bA00', NULL, NULL, 271, NULL, NULL, 233506),
(267336, '3otxB01', NULL, NULL, 284, NULL, NULL, 233506),
(267337, '3pzsA00', NULL, NULL, 289, NULL, NULL, 233506),
(267338, '2dcnA00', NULL, NULL, 311, NULL, NULL, 233506),
(267339, '3ie7A00', NULL, NULL, 320, NULL, NULL, 233506),
(267340, '2f02B00', NULL, NULL, 323, NULL, NULL, 233506),
(267341, '3mbhA00', NULL, NULL, 291, NULL, NULL, 233506),
(267342, '4b8rA01', NULL, NULL, 360, NULL, NULL, 233506),
(267343, '5k27B01', NULL, NULL, 333, NULL, NULL, 233506),
(267344, '1vm7B00', NULL, NULL, 311, NULL, NULL, 233506),
(267345, '2abqA00', NULL, NULL, 306, NULL, NULL, 233506),
(267346, '3kd6A00', NULL, NULL, 313, NULL, NULL, 233506),
(267347, '3nl6C02', NULL, NULL, 310, NULL, NULL, 233506),
(267348, '3k5wA02', NULL, NULL, 264, NULL, NULL, 233506),
(267349, '3lhxA00', NULL, NULL, 319, NULL, NULL, 233506),
(267350, '2qhpA00', NULL, NULL, 296, NULL, NULL, 233506),
(267351, '3rm5B01', NULL, NULL, 314, NULL, NULL, 233506),
(267352, '6ilsA00', NULL, NULL, 313, NULL, NULL, 233506),
(267353, '2qcvA01', NULL, NULL, 278, NULL, NULL, 233506),
(267354, '2hlzA00', NULL, NULL, 296, NULL, NULL, 233506),
(267355, '3h49B00', NULL, NULL, 325, NULL, NULL, 233506),
(267356, '1jxhA00', NULL, NULL, 266, NULL, NULL, 233506),
(267357, '5wbmA00', NULL, NULL, 296, NULL, NULL, 233506),
(267358, '5kb6A01', NULL, NULL, 280, NULL, NULL, 233506),
(267359, '3kzhB00', NULL, NULL, 328, NULL, NULL, 233506),
(267360, '1bx4A01', NULL, NULL, 282, NULL, NULL, 233506),
(267361, '1rkdA00', NULL, NULL, 309, NULL, NULL, 233506),
(267362, '1ua4A01', NULL, NULL, 343, NULL, NULL, 233506),
(267363, '3zs7A00', NULL, NULL, 300, NULL, NULL, 233506),
(267364, '5ysqB00', NULL, NULL, 286, NULL, NULL, 233506),
(267365, '3uboB00', NULL, NULL, 330, NULL, NULL, 233506),
(267366, '5tqiA00', NULL, NULL, 294, NULL, NULL, 233506),
(267367, '3ewmA00', NULL, NULL, 313, NULL, NULL, 233506),
(267368, '2r3bA01', NULL, NULL, 290, NULL, NULL, 233506),
(267369, '5od2A01', NULL, NULL, 340, NULL, NULL, 233506),
(267370, '3pl2A01', NULL, NULL, 268, NULL, NULL, 233506),
(267371, '4k8kB00', NULL, NULL, 329, NULL, NULL, 233506),
(267372, '3h74A00', NULL, NULL, 282, NULL, NULL, 233506),
(267373, '1ub0A00', NULL, NULL, 258, NULL, NULL, 233506),
(267374, '4e69A00', NULL, NULL, 328, NULL, NULL, 233506),
(267375, '2nwhA00', NULL, NULL, 317, NULL, NULL, 233506),
(267376, '6c8zA01', NULL, NULL, 366, NULL, NULL, 233506),
(267377, '4e84B00', NULL, NULL, 310, NULL, NULL, 233506),
(267378, '2jg1D00', NULL, NULL, 313, NULL, NULL, 233506),
(267379, '2feaA02', NULL, NULL, 98, NULL, NULL, 233507),
(267380, '2feaB02', NULL, NULL, 98, NULL, NULL, 233507),
(267381, '2j6bA00', NULL, NULL, 109, NULL, NULL, 233508),
(267382, '2j85B00', NULL, NULL, 122, NULL, NULL, 233508),
(267383, '2x4iA00', NULL, NULL, 114, NULL, NULL, 233508),
(267384, '4r4kA00', NULL, NULL, 154, NULL, NULL, 233509),
(267385, '2ml5A00', NULL, NULL, 155, NULL, NULL, 233509),
(267386, '2ml6A00', NULL, NULL, 148, NULL, NULL, 233509),
(267387, '2xljA02', NULL, NULL, 24, NULL, NULL, 233510),
(267388, '4b45A02', NULL, NULL, 126, NULL, NULL, 233511),
(267389, '4b46A02', NULL, NULL, 138, NULL, NULL, 233511),
(267390, '4e6eA02', NULL, NULL, 96, NULL, NULL, 233511);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(267391, '4u3jB02', NULL, NULL, 114, NULL, NULL, 233511),
(267392, '4ffbA02', NULL, NULL, 115, NULL, NULL, 233511),
(267393, '3cb2A02', NULL, NULL, 112, NULL, NULL, 233511),
(267394, '2r75102', NULL, NULL, 118, NULL, NULL, 233511),
(267395, '3c8lB00', NULL, NULL, 122, NULL, NULL, 233511),
(267396, '2rhjA02', NULL, NULL, 115, NULL, NULL, 233511),
(267397, '1rq2B02', NULL, NULL, 96, NULL, NULL, 233511),
(267398, '5n5nA02', NULL, NULL, 114, NULL, NULL, 233511),
(267399, '4i4tA02', NULL, NULL, 115, NULL, NULL, 233511),
(267400, '2vapA02', NULL, NULL, 115, NULL, NULL, 233511),
(267401, '1w5fA02', NULL, NULL, 121, NULL, NULL, 233511),
(267402, '5mn7A02', NULL, NULL, 139, NULL, NULL, 233511),
(267403, '2gviA02', NULL, NULL, 97, NULL, NULL, 233511),
(267404, '2btoB02', NULL, NULL, 106, NULL, NULL, 233511),
(267405, '4i4tD02', NULL, NULL, 114, NULL, NULL, 233511),
(267406, '4m8iA02', NULL, NULL, 101, NULL, NULL, 233511),
(267407, '6e7bB02', NULL, NULL, 114, NULL, NULL, 233511),
(267408, '1ofuA02', NULL, NULL, 96, NULL, NULL, 233511),
(267409, '2btqB02', NULL, NULL, 107, NULL, NULL, 233511),
(267410, '3seoA01', NULL, NULL, 140, NULL, NULL, 233512),
(267411, '3psfA03', NULL, NULL, 328, NULL, NULL, 233513),
(267412, '3bzcA02', NULL, NULL, 260, NULL, NULL, 233513),
(267413, '2f5tX01', NULL, NULL, 139, NULL, NULL, 233514),
(267414, '1jy1A02', NULL, NULL, 257, NULL, NULL, 233514),
(267415, '1jy1A01', NULL, NULL, 203, NULL, NULL, 233514),
(267416, '2o8rB04', NULL, NULL, 192, NULL, NULL, 233514),
(267417, '2o8rB03', NULL, NULL, 188, NULL, NULL, 233514),
(267418, '4h4aA00', NULL, NULL, 169, NULL, NULL, 233514),
(267419, '2o8rA03', NULL, NULL, 180, NULL, NULL, 233514),
(267420, '4rctA01', NULL, NULL, 185, NULL, NULL, 233514),
(267421, '4ggjA00', NULL, NULL, 180, NULL, NULL, 233514),
(267422, '4urjD00', NULL, NULL, 185, NULL, NULL, 233514),
(267423, '3sq7A01', NULL, NULL, 190, NULL, NULL, 233514),
(267424, '2ze9A01', NULL, NULL, 292, NULL, NULL, 233514),
(267425, '2ze9A02', NULL, NULL, 217, NULL, NULL, 233514),
(267426, '1v0wA02', NULL, NULL, 290, NULL, NULL, 233514),
(267427, '1v0uA01', NULL, NULL, 216, NULL, NULL, 233514),
(267428, '5bpdA02', NULL, NULL, 143, NULL, NULL, 233514),
(267429, '4gelB00', NULL, NULL, 220, NULL, NULL, 233514),
(267430, '3hsiA02', NULL, NULL, 212, NULL, NULL, 233514),
(267431, '5lzkA00', NULL, NULL, 180, NULL, NULL, 233514),
(267432, '4genA00', NULL, NULL, 169, NULL, NULL, 233514),
(267433, '3hsiA01', NULL, NULL, 246, NULL, NULL, 233514),
(267434, '1q32C02', NULL, NULL, 277, NULL, NULL, 233514),
(267435, '1xdpA04', NULL, NULL, 185, NULL, NULL, 233514),
(267436, '1xdpA03', NULL, NULL, 188, NULL, NULL, 233514),
(267437, '2c1lA01', NULL, NULL, 188, NULL, NULL, 233514),
(267438, '1byrA00', NULL, NULL, 155, NULL, NULL, 233514),
(267439, '1vjeB00', NULL, NULL, 166, NULL, NULL, 233515),
(267440, '1j6xB00', NULL, NULL, 160, NULL, NULL, 233515),
(267441, '4xchA00', NULL, NULL, 149, NULL, NULL, 233515),
(267442, '5e68A00', NULL, NULL, 179, NULL, NULL, 233515),
(267443, '1j98A00', NULL, NULL, 157, NULL, NULL, 233515),
(267444, '1j6wB00', NULL, NULL, 175, NULL, NULL, 233515),
(267445, '2o5nA02', NULL, NULL, 157, NULL, NULL, 233516),
(267446, '4g59C02', NULL, NULL, 158, NULL, NULL, 233516),
(267447, '2nykA01', NULL, NULL, 165, NULL, NULL, 233516),
(267448, '4jo8A01', NULL, NULL, 168, NULL, NULL, 233516),
(267449, '4mxuA02', NULL, NULL, 48, NULL, NULL, 233517),
(267450, '3nh4A02', NULL, NULL, 48, NULL, NULL, 233517),
(267451, '2q4zA02', NULL, NULL, 48, NULL, NULL, 233517),
(267452, '4wkyA02', NULL, NULL, 84, NULL, NULL, 233518),
(267453, '4z37A02', NULL, NULL, 99, NULL, NULL, 233518),
(267454, '4zdnA02', NULL, NULL, 123, NULL, NULL, 233518),
(267455, '4tktA02', NULL, NULL, 97, NULL, NULL, 233518),
(267456, '4qyrA02', NULL, NULL, 96, NULL, NULL, 233518),
(267457, '5e5nA02', NULL, NULL, 98, NULL, NULL, 233518),
(267458, '4na1B02', NULL, NULL, 99, NULL, NULL, 233518),
(267459, '3thxB01', NULL, NULL, 142, NULL, NULL, 233519),
(267460, '5yk4B01', NULL, NULL, 125, NULL, NULL, 233519),
(267461, '1e3mA01', NULL, NULL, 124, NULL, NULL, 233519);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(267462, '2o8bB01', NULL, NULL, 170, NULL, NULL, 233519),
(267463, '1ewqB01', NULL, NULL, 126, NULL, NULL, 233519),
(267464, '3zljB01', NULL, NULL, 99, NULL, NULL, 233519),
(267465, '2o8bA01', NULL, NULL, 124, NULL, NULL, 233519),
(267466, '4g29A00', NULL, NULL, 186, NULL, NULL, 233520),
(267467, '2ebfX01', NULL, NULL, 193, NULL, NULL, 233520),
(267468, '4ei0A01', NULL, NULL, 151, NULL, NULL, 233521),
(267469, '3igmA00', NULL, NULL, 59, NULL, NULL, 233522),
(267470, '3igmB00', NULL, NULL, 77, NULL, NULL, 233522),
(267471, '3t4lB01', NULL, NULL, 53, NULL, NULL, 233523),
(267472, '5yvdA01', NULL, NULL, 63, NULL, NULL, 233524),
(267473, '2h85A01', NULL, NULL, 65, NULL, NULL, 233524),
(267474, '2gtiA01', NULL, NULL, 64, NULL, NULL, 233524),
(267475, '4s1tA01', NULL, NULL, 64, NULL, NULL, 233524),
(267476, '3fkqA01', NULL, NULL, 116, NULL, NULL, 233525),
(267477, '4e40A00', NULL, NULL, 252, NULL, NULL, 233526),
(267478, '4x0jA00', NULL, NULL, 265, NULL, NULL, 233526),
(267479, '2y44A00', NULL, NULL, 184, NULL, NULL, 233526),
(267480, '2lw3A00', NULL, NULL, 90, NULL, NULL, 233527),
(267481, '1kn6A00', NULL, NULL, 90, NULL, NULL, 233528),
(267482, '4bhuA00', NULL, NULL, 130, NULL, NULL, 233529),
(267483, '5mkdD00', NULL, NULL, 124, NULL, NULL, 233529),
(267484, '1pyvA00', NULL, NULL, 54, NULL, NULL, 233530),
(267485, '2pd0D01', NULL, NULL, 119, NULL, NULL, 233531),
(267486, '4fbdA01', NULL, NULL, 124, NULL, NULL, 233531),
(267487, '2hepA00', NULL, NULL, 42, NULL, NULL, 233532),
(267488, '4cs4A01', NULL, NULL, 53, NULL, NULL, 233532),
(267489, '3rg0A03', NULL, NULL, 42, NULL, NULL, 233532),
(267490, '5zwlE02', NULL, NULL, 50, NULL, NULL, 233532),
(267491, '3dsqA01', NULL, NULL, 69, NULL, NULL, 233532),
(267492, '2yi9A02', NULL, NULL, 52, NULL, NULL, 233532),
(267493, '1o9gA02', NULL, NULL, 43, NULL, NULL, 233532),
(267494, '2pusA02', NULL, NULL, 53, NULL, NULL, 233532),
(267495, '2rjzA01', NULL, NULL, 37, NULL, NULL, 233532),
(267496, '3bhpA00', NULL, NULL, 60, NULL, NULL, 233532),
(267497, '1g6uA00', NULL, NULL, 48, NULL, NULL, 233532),
(267498, '4tqoA00', NULL, NULL, 573, NULL, NULL, 233533),
(267499, '1kv9A01', NULL, NULL, 561, NULL, NULL, 233533),
(267500, '4cvbA00', NULL, NULL, 572, NULL, NULL, 233533),
(267501, '2d0vI00', NULL, NULL, 597, NULL, NULL, 233533),
(267502, '1w6sA00', NULL, NULL, 599, NULL, NULL, 233533),
(267503, '1flgA00', NULL, NULL, 582, NULL, NULL, 233533),
(267504, '4mh1B00', NULL, NULL, 560, NULL, NULL, 233533),
(267505, '1yiqA01', NULL, NULL, 578, NULL, NULL, 233533),
(267506, '2ad6A00', NULL, NULL, 571, NULL, NULL, 233533),
(267507, '6damA00', NULL, NULL, 591, NULL, NULL, 233533),
(267508, '1kb0A01', NULL, NULL, 580, NULL, NULL, 233533),
(267509, '1lrwA00', NULL, NULL, 600, NULL, NULL, 233533),
(267510, '6fkwA00', NULL, NULL, 577, NULL, NULL, 233533),
(267511, '5xm3A00', NULL, NULL, 596, NULL, NULL, 233533),
(267512, '3tmaA01', NULL, NULL, 155, NULL, NULL, 233534),
(267513, '3tm4A01', NULL, NULL, 189, NULL, NULL, 233534),
(267514, '2c5sA01', NULL, NULL, 184, NULL, NULL, 233534),
(267515, '3v97B01', NULL, NULL, 211, NULL, NULL, 233534),
(267516, '3lduA01', NULL, NULL, 184, NULL, NULL, 233534),
(267517, '3ldgA01', NULL, NULL, 195, NULL, NULL, 233534),
(267518, '4kr6A01', NULL, NULL, 171, NULL, NULL, 233534),
(267519, '3k0bA01', NULL, NULL, 202, NULL, NULL, 233534),
(267520, '2znhA03', NULL, NULL, 47, NULL, NULL, 233535),
(267521, '3bqwA01', NULL, NULL, 214, NULL, NULL, 233536),
(267522, '3e2dA03', NULL, NULL, 61, NULL, NULL, 233537),
(267523, '3wbhA02', NULL, NULL, 61, NULL, NULL, 233537),
(267524, '4g1lA01', NULL, NULL, 195, NULL, NULL, 233538),
(267525, '3bxjA02', NULL, NULL, 104, NULL, NULL, 233539),
(267526, '4dczA00', NULL, NULL, 67, NULL, NULL, 233540),
(267527, '4nurA02', NULL, NULL, 141, NULL, NULL, 233541),
(267528, '2yheA02', NULL, NULL, 142, NULL, NULL, 233541),
(267529, '4pdxA02', NULL, NULL, 141, NULL, NULL, 233541),
(267530, '2cfuA02', NULL, NULL, 141, NULL, NULL, 233541),
(267531, '4m0mA02', NULL, NULL, 100, NULL, NULL, 233542),
(267532, '4apxB01', NULL, NULL, 120, NULL, NULL, 233543);
INSERT INTO "PUBLIC"."MODEL" VALUES
(267533, '4n75B00', NULL, NULL, 385, NULL, NULL, 233544),
(267534, '3njtA01', NULL, NULL, 389, NULL, NULL, 233544),
(267535, '4k3bA06', NULL, NULL, 370, NULL, NULL, 233544),
(267536, '5or1A00', NULL, NULL, 382, NULL, NULL, 233544),
(267537, '4c00A04', NULL, NULL, 314, NULL, NULL, 233544),
(267538, '4k3cA03', NULL, NULL, 374, NULL, NULL, 233544),
(267539, '3d2yA02', NULL, NULL, 84, NULL, NULL, 233545),
(267540, '1lbuA01', NULL, NULL, 84, NULL, NULL, 233545),
(267541, '1l6jA01', NULL, NULL, 65, NULL, NULL, 233545),
(267542, '4bolA02', NULL, NULL, 80, NULL, NULL, 233545),
(267543, '1eakA01', NULL, NULL, 63, NULL, NULL, 233545),
(267544, '4lpqA01', NULL, NULL, 78, NULL, NULL, 233545),
(267545, '4bxjA02', NULL, NULL, 83, NULL, NULL, 233545),
(267546, '3bkhA01', NULL, NULL, 86, NULL, NULL, 233545),
(267547, '4g54A02', NULL, NULL, 72, NULL, NULL, 233545),
(267548, '4fp5D00', NULL, NULL, 98, NULL, NULL, 233546),
(267549, '5uj1A02', NULL, NULL, 160, NULL, NULL, 233547),
(267550, '2o5cB02', NULL, NULL, 231, NULL, NULL, 233547),
(267551, '2gaiA02', NULL, NULL, 146, NULL, NULL, 233547),
(267552, '1mw9X02', NULL, NULL, 163, NULL, NULL, 233547),
(267553, '4cgyA02', NULL, NULL, 190, NULL, NULL, 233547),
(267554, '1gkuB06', NULL, NULL, 156, NULL, NULL, 233547),
(267555, '4dduA06', NULL, NULL, 160, NULL, NULL, 233547),
(267556, '1i7dA02', NULL, NULL, 180, NULL, NULL, 233547),
(267557, '5gvcA02', NULL, NULL, 186, NULL, NULL, 233547),
(267558, '3frnA01', NULL, NULL, 140, NULL, NULL, 233548),
(267559, '3i1aA03', NULL, NULL, 125, NULL, NULL, 233549),
(267560, '4y97D00', NULL, NULL, 180, NULL, NULL, 233550),
(267561, '3floB00', NULL, NULL, 190, NULL, NULL, 233550),
(267562, '1u8sA01', NULL, NULL, 87, NULL, NULL, 233551),
(267563, '3tuiC02', NULL, NULL, 111, NULL, NULL, 233551),
(267564, '1ygyA04', NULL, NULL, 76, NULL, NULL, 233551),
(267565, '3mtjA03', NULL, NULL, 83, NULL, NULL, 233551),
(267566, '1u8sA02', NULL, NULL, 104, NULL, NULL, 233551),
(267567, '4pwuC00', NULL, NULL, 81, NULL, NULL, 233551),
(267568, '2iq8B03', NULL, NULL, 77, NULL, NULL, 233551),
(267569, '3ibwA00', NULL, NULL, 88, NULL, NULL, 233551),
(267570, '3l7oA02', NULL, NULL, 72, NULL, NULL, 233551),
(267571, '5uf2A02', NULL, NULL, 71, NULL, NULL, 233551),
(267572, '2pc6A01', NULL, NULL, 81, NULL, NULL, 233551),
(267573, '1sc6A03', NULL, NULL, 82, NULL, NULL, 233551),
(267574, '2cdqA03', NULL, NULL, 84, NULL, NULL, 233551),
(267575, '2cdqA04', NULL, NULL, 76, NULL, NULL, 233551),
(267576, '3s1tA01', NULL, NULL, 81, NULL, NULL, 233551),
(267577, '5yppA00', NULL, NULL, 98, NULL, NULL, 233551),
(267578, '4nmlA02', NULL, NULL, 97, NULL, NULL, 233551),
(267579, '2lqjA00', NULL, NULL, 94, NULL, NULL, 233551),
(267580, '3k5pA03', NULL, NULL, 83, NULL, NULL, 233551),
(267581, '3s1tA02', NULL, NULL, 80, NULL, NULL, 233551),
(267582, '6j1kA02', NULL, NULL, 78, NULL, NULL, 233551),
(267583, '3ghfA00', NULL, NULL, 120, NULL, NULL, 233551),
(267584, '2qswA00', NULL, NULL, 100, NULL, NULL, 233551),
(267585, '4io1A02', NULL, NULL, 72, NULL, NULL, 233551),
(267586, '2dtjA02', NULL, NULL, 80, NULL, NULL, 233551),
(267587, '2jheA01', NULL, NULL, 81, NULL, NULL, 233551),
(267588, '3n0vA01', NULL, NULL, 90, NULL, NULL, 233551),
(267589, '2i9sA00', NULL, NULL, 97, NULL, NULL, 233551),
(267590, '3offA00', NULL, NULL, 90, NULL, NULL, 233551),
(267591, '3ofhB00', NULL, NULL, 89, NULL, NULL, 233551),
(267592, '2re1A02', NULL, NULL, 78, NULL, NULL, 233551),
(267593, '1uj6A02', NULL, NULL, 72, NULL, NULL, 233551),
(267594, '3luyA03', NULL, NULL, 89, NULL, NULL, 233551),
(267595, '2qmwB03', NULL, NULL, 77, NULL, NULL, 233551),
(267596, '3o1lB01', NULL, NULL, 88, NULL, NULL, 233551),
(267597, '2joqA01', NULL, NULL, 75, NULL, NULL, 233551),
(267598, '5fiiB00', NULL, NULL, 85, NULL, NULL, 233551),
(267599, '6eepA02', NULL, NULL, 72, NULL, NULL, 233551),
(267600, '3mahA01', NULL, NULL, 88, NULL, NULL, 233551),
(267601, '3ab4D01', NULL, NULL, 77, NULL, NULL, 233551),
(267602, '1o8bA02', NULL, NULL, 72, NULL, NULL, 233551),
(267603, '1lk5A02', NULL, NULL, 79, NULL, NULL, 233551);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(267604, '1xtzA02', NULL, NULL, 84, NULL, NULL, 233551),
(267605, '3mahA02', NULL, NULL, 69, NULL, NULL, 233551),
(267606, '2rqkA00', NULL, NULL, 109, NULL, NULL, 233551),
(267607, '3ixqA02', NULL, NULL, 78, NULL, NULL, 233551),
(267608, '3hheA02', NULL, NULL, 78, NULL, NULL, 233551),
(267609, '3w7bA01', NULL, NULL, 88, NULL, NULL, 233551),
(267610, '3ofgB00', NULL, NULL, 95, NULL, NULL, 233551),
(267611, '2iq8A03', NULL, NULL, 77, NULL, NULL, 233551),
(267612, '2j0wA03', NULL, NULL, 81, NULL, NULL, 233551),
(267613, '2j0wA04', NULL, NULL, 75, NULL, NULL, 233551),
(267614, '1zpvA00', NULL, NULL, 91, NULL, NULL, 233551),
(267615, '2qmxA03', NULL, NULL, 91, NULL, NULL, 233551),
(267616, '4l1cA00', NULL, NULL, 103, NULL, NULL, 233551),
(267617, '3mwbB03', NULL, NULL, 98, NULL, NULL, 233551),
(267618, '5yeiB02', NULL, NULL, 78, NULL, NULL, 233551),
(267619, '2p9cA03', NULL, NULL, 82, NULL, NULL, 233551),
(267620, '3nrbB01', NULL, NULL, 88, NULL, NULL, 233551),
(267621, '3louB01', NULL, NULL, 95, NULL, NULL, 233551),
(267622, '5yeiB01', NULL, NULL, 86, NULL, NULL, 233551),
(267623, '3obiA01', NULL, NULL, 89, NULL, NULL, 233551),
(267624, '4go7X01', NULL, NULL, 120, NULL, NULL, 233551),
(267625, '1y7pB01', NULL, NULL, 80, NULL, NULL, 233551),
(267626, '2qrrA00', NULL, NULL, 101, NULL, NULL, 233551),
(267627, '4gmkA02', NULL, NULL, 73, NULL, NULL, 233551),
(267628, '2dtjB01', NULL, NULL, 98, NULL, NULL, 233551),
(267629, '5is2A01', NULL, NULL, 91, NULL, NULL, 233551),
(267630, '2fgcA01', NULL, NULL, 76, NULL, NULL, 233551),
(267631, '3uw1A02', NULL, NULL, 77, NULL, NULL, 233551),
(267632, '1m0sA02', NULL, NULL, 72, NULL, NULL, 233551),
(267633, '2mdaA00', NULL, NULL, 95, NULL, NULL, 233551),
(267634, '2nyiA01', NULL, NULL, 82, NULL, NULL, 233551),
(267635, '2nyiA02', NULL, NULL, 90, NULL, NULL, 233551),
(267636, '2re1B01', NULL, NULL, 89, NULL, NULL, 233551),
(267637, '2dt9A01', NULL, NULL, 88, NULL, NULL, 233551),
(267638, '4lubB02', NULL, NULL, 91, NULL, NULL, 233551),
(267639, '3dhxA00', NULL, NULL, 106, NULL, NULL, 233551),
(267640, '5is2A02', NULL, NULL, 84, NULL, NULL, 233551),
(267641, '4x84A02', NULL, NULL, 72, NULL, NULL, 233551),
(267642, '2dt9A02', NULL, NULL, 79, NULL, NULL, 233551),
(267643, '2f8mA02', NULL, NULL, 79, NULL, NULL, 233551),
(267644, '3enqA02', NULL, NULL, 72, NULL, NULL, 233551),
(267645, '3cedA00', NULL, NULL, 98, NULL, NULL, 233551),
(267646, '2qmwA03', NULL, NULL, 77, NULL, NULL, 233551),
(267647, '1rwuA00', NULL, NULL, 87, NULL, NULL, 233551),
(267648, '2f1fA01', NULL, NULL, 80, NULL, NULL, 233551),
(267649, '1xmxA01', NULL, NULL, 142, NULL, NULL, 233552),
(267650, '3qyfA01', NULL, NULL, 165, NULL, NULL, 233552),
(267651, '2e1mA03', NULL, NULL, 80, NULL, NULL, 233553),
(267652, '2hg7A00', NULL, NULL, 60, NULL, NULL, 233554),
(267653, '2j9wB00', NULL, NULL, 102, NULL, NULL, 233555),
(267654, '2j9uA00', NULL, NULL, 96, NULL, NULL, 233555),
(267655, '2czsA01', NULL, NULL, 63, NULL, NULL, 233556),
(267656, '1yu0A01', NULL, NULL, 55, NULL, NULL, 233557),
(267657, '4bkxA01', NULL, NULL, 126, NULL, NULL, 233558),
(267658, '1hqiA00', NULL, NULL, 90, NULL, NULL, 233559),
(267659, '2innL00', NULL, NULL, 89, NULL, NULL, 233559),
(267660, '2mobA00', NULL, NULL, 104, NULL, NULL, 233559),
(267661, '4gamD00', NULL, NULL, 141, NULL, NULL, 233559),
(267662, '2inpL00', NULL, NULL, 89, NULL, NULL, 233559),
(267663, '3ge3E00', NULL, NULL, 103, NULL, NULL, 233559),
(267664, '2vdfA00', NULL, NULL, 253, NULL, NULL, 233560),
(267665, '3g0hA01', NULL, NULL, 31, NULL, NULL, 233561),
(267666, '2yguC00', NULL, NULL, 125, NULL, NULL, 233562),
(267667, '2ovsA00', NULL, NULL, 118, NULL, NULL, 233563),
(267668, '4kt5A00', NULL, NULL, 127, NULL, NULL, 233563),
(267669, '2mvtA00', NULL, NULL, 47, NULL, NULL, 233564),
(267670, '2munA00', NULL, NULL, 46, NULL, NULL, 233564),
(267671, '2m35A00', NULL, NULL, 52, NULL, NULL, 233564),
(267672, '5o6aD00', NULL, NULL, 75, NULL, NULL, 233565),
(267673, '6co8B00', NULL, NULL, 75, NULL, NULL, 233565),
(267674, '3j27B00', NULL, NULL, 75, NULL, NULL, 233565);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(267675, '1u6kA02', NULL, NULL, 103, NULL, NULL, 233566),
(267676, '3iqeA02', NULL, NULL, 103, NULL, NULL, 233566),
(267677, '1u6kB02', NULL, NULL, 103, NULL, NULL, 233566),
(267678, '1qv9C02', NULL, NULL, 103, NULL, NULL, 233566),
(267679, '1qv9A02', NULL, NULL, 103, NULL, NULL, 233566),
(267680, '1u6kC02', NULL, NULL, 103, NULL, NULL, 233566),
(267681, '1qv9B02', NULL, NULL, 103, NULL, NULL, 233566),
(267682, '2eplX01', NULL, NULL, 81, NULL, NULL, 233567),
(267683, '5a6bA01', NULL, NULL, 81, NULL, NULL, 233567),
(267684, '6at7B03', NULL, NULL, 120, NULL, NULL, 233568),
(267685, '1w27A03', NULL, NULL, 122, NULL, NULL, 233568),
(267686, '4c5sC03', NULL, NULL, 106, NULL, NULL, 233568),
(267687, '1y2mA03', NULL, NULL, 103, NULL, NULL, 233568),
(267688, '3axjA02', NULL, NULL, 102, NULL, NULL, 233569),
(267689, '3qb5K02', NULL, NULL, 86, NULL, NULL, 233569),
(267690, '3axjB02', NULL, NULL, 85, NULL, NULL, 233569),
(267691, '1j1jA02', NULL, NULL, 96, NULL, NULL, 233569),
(267692, '2cq7A00', NULL, NULL, 49, NULL, NULL, 233570),
(267693, '1wvrA02', NULL, NULL, 41, NULL, NULL, 233570),
(267694, '2a05A00', NULL, NULL, 57, NULL, NULL, 233570),
(267695, '2ddbA02', NULL, NULL, 41, NULL, NULL, 233570),
(267696, '1xtaA02', NULL, NULL, 41, NULL, NULL, 233570),
(267697, '1rc9A02', NULL, NULL, 41, NULL, NULL, 233570),
(267698, '4jpnA00', NULL, NULL, 79, NULL, NULL, 233571),
(267699, '2q8aA03', NULL, NULL, 27, NULL, NULL, 233572),
(267700, '2jspA01', NULL, NULL, 57, NULL, NULL, 233573),
(267701, '4locA03', NULL, NULL, 119, NULL, NULL, 233574),
(267702, '3hblA06', NULL, NULL, 125, NULL, NULL, 233574),
(267703, '2qf7A05', NULL, NULL, 131, NULL, NULL, 233574),
(267704, '3bg3B03', NULL, NULL, 121, NULL, NULL, 233574),
(267705, '4qshA05', NULL, NULL, 127, NULL, NULL, 233574),
(267706, '1aggA00', NULL, NULL, 48, NULL, NULL, 233575),
(267707, '1ivaA00', NULL, NULL, 48, NULL, NULL, 233575),
(267708, '2rooA00', NULL, NULL, 43, NULL, NULL, 233575),
(267709, '1qdpA00', NULL, NULL, 42, NULL, NULL, 233575),
(267710, '1vtxA00', NULL, NULL, 42, NULL, NULL, 233575),
(267711, '1g9pA00', NULL, NULL, 45, NULL, NULL, 233575),
(267712, '1vw4M01', NULL, NULL, 135, NULL, NULL, 233576),
(267713, '2rngA01', NULL, NULL, 39, NULL, NULL, 233577),
(267714, '1y0nA00', NULL, NULL, 78, NULL, NULL, 233578),
(267715, '2rhqB03', NULL, NULL, 202, NULL, NULL, 233579),
(267716, '2cxiA02', NULL, NULL, 198, NULL, NULL, 233579),
(267717, '1b7yB03', NULL, NULL, 214, NULL, NULL, 233579),
(267718, '4p72A03', NULL, NULL, 199, NULL, NULL, 233579),
(267719, '3l4gB02', NULL, NULL, 207, NULL, NULL, 233579),
(267720, '3pcoB03', NULL, NULL, 199, NULL, NULL, 233579),
(267721, '2glzA00', NULL, NULL, 153, NULL, NULL, 233580),
(267722, '3d00A01', NULL, NULL, 161, NULL, NULL, 233580),
(267723, '3ns4A00', NULL, NULL, 228, NULL, NULL, 233581),
(267724, '3gn5B01', NULL, NULL, 68, NULL, NULL, 233582),
(267725, '3ga8A00', NULL, NULL, 78, NULL, NULL, 233582),
(267726, '1r7lA00', NULL, NULL, 110, NULL, NULL, 233583),
(267727, '4ei7B01', NULL, NULL, 155, NULL, NULL, 233584),
(267728, '1xn8A00', NULL, NULL, 131, NULL, NULL, 233585),
(267729, '1xaxA00', NULL, NULL, 154, NULL, NULL, 233586),
(267730, '1tviA00', NULL, NULL, 150, NULL, NULL, 233586),
(267731, '1oz9A00', NULL, NULL, 150, NULL, NULL, 233586),
(267732, '1xm5C00', NULL, NULL, 155, NULL, NULL, 233586),
(267733, '1t11A01', NULL, NULL, 115, NULL, NULL, 233587),
(267734, '2nscA01', NULL, NULL, 78, NULL, NULL, 233587),
(267735, '2mlxA01', NULL, NULL, 121, NULL, NULL, 233587),
(267736, '3gtyX01', NULL, NULL, 125, NULL, NULL, 233587),
(267737, '2d3o100', NULL, NULL, 112, NULL, NULL, 233587),
(267738, '1omsA00', NULL, NULL, 121, NULL, NULL, 233587),
(267739, '1v9mA02', NULL, NULL, 101, NULL, NULL, 233588),
(267740, '1v9mA03', NULL, NULL, 96, NULL, NULL, 233588),
(267741, '1neiA00', NULL, NULL, 60, NULL, NULL, 233589),
(267742, '1wcuA00', NULL, NULL, 153, NULL, NULL, 233590),
(267743, '2q1fA01', NULL, NULL, 180, NULL, NULL, 233590),
(267744, '5z6pA01', NULL, NULL, 182, NULL, NULL, 233590),
(267745, '1hn0A01', NULL, NULL, 210, NULL, NULL, 233590); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(267746, '1wmxA00', NULL, NULL, 180, NULL, NULL, 233590),
(267747, '4ywaA00', NULL, NULL, 121, NULL, NULL, 233590),
(267748, '2jwpA00', NULL, NULL, 174, NULL, NULL, 233590),
(267749, '2o14A01', NULL, NULL, 161, NULL, NULL, 233590),
(267750, '1v0aA01', NULL, NULL, 171, NULL, NULL, 233590),
(267751, '1w8uA00', NULL, NULL, 149, NULL, NULL, 233590),
(267752, '4bq2D01', NULL, NULL, 197, NULL, NULL, 233590),
(267753, '3f95B00', NULL, NULL, 193, NULL, NULL, 233590),
(267754, '5oduA00', NULL, NULL, 122, NULL, NULL, 233590),
(267755, '4i9fA03', NULL, NULL, 93, NULL, NULL, 233591),
(267756, '5dzuB00', NULL, NULL, 188, NULL, NULL, 233592),
(267757, '4efpA02', NULL, NULL, 161, NULL, NULL, 233592),
(267758, '3im6A00', NULL, NULL, 217, NULL, NULL, 233592),
(267759, '1epwA04', NULL, NULL, 191, NULL, NULL, 233592),
(267760, '1wbaA00', NULL, NULL, 175, NULL, NULL, 233592),
(267761, '1qqkA00', NULL, NULL, 140, NULL, NULL, 233592),
(267762, '5fzuA00', NULL, NULL, 187, NULL, NULL, 233592),
(267763, '1pwaA00', NULL, NULL, 142, NULL, NULL, 233592),
(267764, '1abrB01', NULL, NULL, 139, NULL, NULL, 233592),
(267765, '5vi4A00', NULL, NULL, 158, NULL, NULL, 233592),
(267766, '3mppG02', NULL, NULL, 205, NULL, NULL, 233592),
(267767, '1wd3A02', NULL, NULL, 162, NULL, NULL, 233592),
(267768, '1abrB02', NULL, NULL, 124, NULL, NULL, 233592),
(267769, '1ggpB02', NULL, NULL, 125, NULL, NULL, 233592),
(267770, '2j3pA00', NULL, NULL, 134, NULL, NULL, 233592),
(267771, '1ggpB01', NULL, NULL, 129, NULL, NULL, 233592),
(267772, '2esuA00', NULL, NULL, 186, NULL, NULL, 233592),
(267773, '2yugA00', NULL, NULL, 155, NULL, NULL, 233592),
(267774, '4ekxB00', NULL, NULL, 157, NULL, NULL, 233592),
(267775, '1m2tB02', NULL, NULL, 124, NULL, NULL, 233592),
(267776, '1m2tB01', NULL, NULL, 139, NULL, NULL, 233592),
(267777, '3rsjB02', NULL, NULL, 186, NULL, NULL, 233592),
(267778, '3uj4A01', NULL, NULL, 232, NULL, NULL, 233592),
(267779, '2x2sC00', NULL, NULL, 153, NULL, NULL, 233592),
(267780, '3q7yA00', NULL, NULL, 132, NULL, NULL, 233592),
(267781, '3p6jA00', NULL, NULL, 142, NULL, NULL, 233592),
(267782, '1ilr100', NULL, NULL, 152, NULL, NULL, 233592),
(267783, '2ffuA02', NULL, NULL, 130, NULL, NULL, 233592),
(267784, '3aj6B01', NULL, NULL, 141, NULL, NULL, 233592),
(267785, '1md6A00', NULL, NULL, 154, NULL, NULL, 233592),
(267786, '3ffzA04', NULL, NULL, 178, NULL, NULL, 233592),
(267787, '1t9fA00', NULL, NULL, 187, NULL, NULL, 233592),
(267788, '5ec5A02', NULL, NULL, 139, NULL, NULL, 233592),
(267789, '4i4sA00', NULL, NULL, 146, NULL, NULL, 233592),
(267790, '3qr5A00', NULL, NULL, 185, NULL, NULL, 233592),
(267791, '4hr6C01', NULL, NULL, 136, NULL, NULL, 233592),
(267792, '4hr6C02', NULL, NULL, 128, NULL, NULL, 233592),
(267793, '3o44A03', NULL, NULL, 126, NULL, NULL, 233592),
(267794, '1ijtA00', NULL, NULL, 128, NULL, NULL, 233592),
(267795, '2zr1B01', NULL, NULL, 143, NULL, NULL, 233592),
(267796, '3c9zA01', NULL, NULL, 130, NULL, NULL, 233592),
(267797, '3iagC02', NULL, NULL, 158, NULL, NULL, 233592),
(267798, '2zr1B02', NULL, NULL, 124, NULL, NULL, 233592),
(267799, '3c9zA02', NULL, NULL, 125, NULL, NULL, 233592),
(267800, '5dvhA00', NULL, NULL, 193, NULL, NULL, 233592),
(267801, '3zx7A02', NULL, NULL, 146, NULL, NULL, 233592),
(267802, '4a7kA03', NULL, NULL, 165, NULL, NULL, 233592),
(267803, '2nyyA04', NULL, NULL, 195, NULL, NULL, 233592),
(267804, '4dckC00', NULL, NULL, 158, NULL, NULL, 233592),
(267805, '3o4dA00', NULL, NULL, 126, NULL, NULL, 233592),
(267806, '3tc2B00', NULL, NULL, 187, NULL, NULL, 233592),
(267807, '5e24E02', NULL, NULL, 158, NULL, NULL, 233592),
(267808, '4oeeA00', NULL, NULL, 135, NULL, NULL, 233592),
(267809, '2qn4A00', NULL, NULL, 178, NULL, NULL, 233592),
(267810, '3s8kB00', NULL, NULL, 184, NULL, NULL, 233592),
(267811, '3hsmB00', NULL, NULL, 213, NULL, NULL, 233592),
(267812, '3wmvB00', NULL, NULL, 153, NULL, NULL, 233592),
(267813, '1xg6A00', NULL, NULL, 187, NULL, NULL, 233592),
(267814, '5ehaA00', NULL, NULL, 153, NULL, NULL, 233592),
(267815, '2e4mA01', NULL, NULL, 141, NULL, NULL, 233592),
(267816, '1xhbA03', NULL, NULL, 134, NULL, NULL, 233592);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(267817, '3o49A00', NULL, NULL, 142, NULL, NULL, 233592),
(267818, '3pg0A00', NULL, NULL, 140, NULL, NULL, 233592),
(267819, '1jt7B00', NULL, NULL, 146, NULL, NULL, 233592),
(267820, '4xfsA00', NULL, NULL, 157, NULL, NULL, 233592),
(267821, '3q7xA00', NULL, NULL, 132, NULL, NULL, 233592),
(267822, '3h6rA00', NULL, NULL, 152, NULL, NULL, 233592),
(267823, '1barB00', NULL, NULL, 140, NULL, NULL, 233592),
(267824, '2vseA05', NULL, NULL, 146, NULL, NULL, 233592),
(267825, '1vclA01', NULL, NULL, 150, NULL, NULL, 233592),
(267826, '1dqgA00', NULL, NULL, 135, NULL, NULL, 233592),
(267827, '5yh4A00', NULL, NULL, 179, NULL, NULL, 233592),
(267828, '1vclA02', NULL, NULL, 134, NULL, NULL, 233592),
(267829, '4jp0A01', NULL, NULL, 143, NULL, NULL, 233592),
(267830, '1r8nA00', NULL, NULL, 185, NULL, NULL, 233592),
(267831, '2d7iA02', NULL, NULL, 150, NULL, NULL, 233592),
(267832, '2vxtI00', NULL, NULL, 157, NULL, NULL, 233592),
(267833, '3a07B00', NULL, NULL, 118, NULL, NULL, 233592),
(267834, '3jrrA00', NULL, NULL, 226, NULL, NULL, 233592),
(267835, '4izxA00', NULL, NULL, 140, NULL, NULL, 233592),
(267836, '2vseA03', NULL, NULL, 141, NULL, NULL, 233592),
(267837, '2vseA04', NULL, NULL, 143, NULL, NULL, 233592),
(267838, '4ow4A00', NULL, NULL, 123, NULL, NULL, 233592),
(267839, '2vseA02', NULL, NULL, 142, NULL, NULL, 233592),
(267840, '3snvA00', NULL, NULL, 125, NULL, NULL, 233592),
(267841, '4g9mB00', NULL, NULL, 143, NULL, NULL, 233592),
(267842, '1tfmB02', NULL, NULL, 120, NULL, NULL, 233592),
(267843, '3akhA02', NULL, NULL, 149, NULL, NULL, 233592),
(267844, '4i4oA00', NULL, NULL, 146, NULL, NULL, 233592),
(267845, '1ybiA01', NULL, NULL, 147, NULL, NULL, 233592),
(267846, '5uc6A00', NULL, NULL, 159, NULL, NULL, 233592),
(267847, '1ybiA02', NULL, NULL, 141, NULL, NULL, 233592),
(267848, '3r4sA02', NULL, NULL, 203, NULL, NULL, 233592),
(267849, '1nunA00', NULL, NULL, 145, NULL, NULL, 233592),
(267850, '2p39A00', NULL, NULL, 155, NULL, NULL, 233592),
(267851, '3hbwA00', NULL, NULL, 160, NULL, NULL, 233592),
(267852, '1qqlA00', NULL, NULL, 140, NULL, NULL, 233592),
(267853, '4x3aA00', NULL, NULL, 168, NULL, NULL, 233592),
(267854, '1fmmS00', NULL, NULL, 132, NULL, NULL, 233592),
(267855, '3brdA02', NULL, NULL, 162, NULL, NULL, 233592),
(267856, '1onkB01', NULL, NULL, 139, NULL, NULL, 233592),
(267857, '1onkB02', NULL, NULL, 124, NULL, NULL, 233592),
(267858, '5b2hA02', NULL, NULL, 144, NULL, NULL, 233592),
(267859, '4usoA00', NULL, NULL, 136, NULL, NULL, 233592),
(267860, '3aj6A02', NULL, NULL, 145, NULL, NULL, 233592),
(267861, '3malA00', NULL, NULL, 199, NULL, NULL, 233592),
(267862, '3zc8A00', NULL, NULL, 190, NULL, NULL, 233592),
(267863, '6f0oA02', NULL, NULL, 197, NULL, NULL, 233592),
(267864, '3e8lC00', NULL, NULL, 185, NULL, NULL, 233592),
(267865, '3vwcA00', NULL, NULL, 149, NULL, NULL, 233592),
(267866, '4l4hA02', NULL, NULL, 189, NULL, NULL, 233592),
(267867, '5v38B02', NULL, NULL, 197, NULL, NULL, 233592),
(267868, '8i1bA00', NULL, NULL, 152, NULL, NULL, 233592),
(267869, '1tieA00', NULL, NULL, 172, NULL, NULL, 233592),
(267870, '4i96A01', NULL, NULL, 182, NULL, NULL, 233592),
(267871, '1l2hA00', NULL, NULL, 153, NULL, NULL, 233592),
(267872, '1knmA00', NULL, NULL, 130, NULL, NULL, 233592),
(267873, '1jlxA01', NULL, NULL, 159, NULL, NULL, 233592),
(267874, '1jlxA02', NULL, NULL, 144, NULL, NULL, 233592),
(267875, '1hcdA00', NULL, NULL, 118, NULL, NULL, 233592),
(267876, '4j2kB00', NULL, NULL, 176, NULL, NULL, 233592),
(267877, '3oggA02', NULL, NULL, 189, NULL, NULL, 233592),
(267878, '2fdbN00', NULL, NULL, 164, NULL, NULL, 233592),
(267879, '1rzoB01', NULL, NULL, 138, NULL, NULL, 233592),
(267880, '1rzoB02', NULL, NULL, 124, NULL, NULL, 233592),
(267881, '5dssB00', NULL, NULL, 185, NULL, NULL, 233592),
(267882, '1upsA02', NULL, NULL, 135, NULL, NULL, 233592),
(267883, '3bx1C00', NULL, NULL, 181, NULL, NULL, 233592),
(267884, '1sr4A00', NULL, NULL, 167, NULL, NULL, 233592),
(267885, '3h6qA00', NULL, NULL, 169, NULL, NULL, 233592),
(267886, '2dryA00', NULL, NULL, 130, NULL, NULL, 233592),
(267887, '4cjmA00', NULL, NULL, 141, NULL, NULL, 233592);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(267888, '4eb2B02', NULL, NULL, 124, NULL, NULL, 233592),
(267889, '3v0aB04', NULL, NULL, 156, NULL, NULL, 233592),
(267890, '4iy9A02', NULL, NULL, 161, NULL, NULL, 233592),
(267891, '4owkE00', NULL, NULL, 138, NULL, NULL, 233592),
(267892, '5hpzA00', NULL, NULL, 179, NULL, NULL, 233592),
(267893, '3nbcA00', NULL, NULL, 148, NULL, NULL, 233592),
(267894, '3o3qC00', NULL, NULL, 140, NULL, NULL, 233592),
(267895, '3ojvA00', NULL, NULL, 136, NULL, NULL, 233592),
(267896, '2d1zA02', NULL, NULL, 122, NULL, NULL, 233592),
(267897, '5bowA00', NULL, NULL, 151, NULL, NULL, 233592),
(267898, '2mc2A00', NULL, NULL, 219, NULL, NULL, 233592),
(267899, '2vlcA04', NULL, NULL, 125, NULL, NULL, 233592),
(267900, '2vlcA03', NULL, NULL, 135, NULL, NULL, 233592),
(267901, '1avwB00', NULL, NULL, 177, NULL, NULL, 233592),
(267902, '3pokA00', NULL, NULL, 167, NULL, NULL, 233592),
(267903, '2f2fC00', NULL, NULL, 162, NULL, NULL, 233592),
(267904, '1q1uA00', NULL, NULL, 144, NULL, NULL, 233592),
(267905, '5mu9A01', NULL, NULL, 154, NULL, NULL, 233592),
(267906, '4xftA00', NULL, NULL, 157, NULL, NULL, 233592),
(267907, '1n4kA01', NULL, NULL, 180, NULL, NULL, 233592),
(267908, '1xzzA00', NULL, NULL, 225, NULL, NULL, 233592),
(267909, '4an7B00', NULL, NULL, 185, NULL, NULL, 233592),
(267910, '1hwmB02', NULL, NULL, 125, NULL, NULL, 233592),
(267911, '4jkxB02', NULL, NULL, 124, NULL, NULL, 233592),
(267912, '2aaiB02', NULL, NULL, 124, NULL, NULL, 233592),
(267913, '2aaiB01', NULL, NULL, 138, NULL, NULL, 233592),
(267914, '4i4qA00', NULL, NULL, 146, NULL, NULL, 233592),
(267915, '3kmvE00', NULL, NULL, 157, NULL, NULL, 233592),
(267916, '3p6iA00', NULL, NULL, 142, NULL, NULL, 233592),
(267917, '5muaB01', NULL, NULL, 148, NULL, NULL, 233592),
(267918, '4pc4A02', NULL, NULL, 163, NULL, NULL, 233592),
(267919, '3f1rA00', NULL, NULL, 160, NULL, NULL, 233592),
(267920, '4kc3A00', NULL, NULL, 159, NULL, NULL, 233592),
(267921, '3a21A04', NULL, NULL, 127, NULL, NULL, 233592),
(267922, '6f0pA02', NULL, NULL, 197, NULL, NULL, 233592),
(267923, '5xg5A00', NULL, NULL, 145, NULL, NULL, 233592),
(267924, '5bxrA03', NULL, NULL, 141, NULL, NULL, 233592),
(267925, '2y9fA00', NULL, NULL, 150, NULL, NULL, 233592),
(267926, '1ce7B02', NULL, NULL, 120, NULL, NULL, 233592),
(267927, '2dreA00', NULL, NULL, 180, NULL, NULL, 233592),
(267928, '3vsfA02', NULL, NULL, 140, NULL, NULL, 233592),
(267929, '4p0lA00', NULL, NULL, 154, NULL, NULL, 233592),
(267930, '1rg8A00', NULL, NULL, 146, NULL, NULL, 233592),
(267931, '1sr4C00', NULL, NULL, 166, NULL, NULL, 233592),
(267932, '3wa1A01', NULL, NULL, 160, NULL, NULL, 233592),
(267933, '4zotA00', NULL, NULL, 168, NULL, NULL, 233592),
(267934, '3vuoA04', NULL, NULL, 159, NULL, NULL, 233592),
(267935, '5f8sA00', NULL, NULL, 156, NULL, NULL, 233592),
(267936, '4izeA00', NULL, NULL, 152, NULL, NULL, 233592),
(267937, '4zktB04', NULL, NULL, 160, NULL, NULL, 233592),
(267938, '4oujA02', NULL, NULL, 152, NULL, NULL, 233592),
(267939, '4q9gA00', NULL, NULL, 146, NULL, NULL, 233592),
(267940, '4oujA01', NULL, NULL, 155, NULL, NULL, 233592),
(267941, '3pmeA02', NULL, NULL, 195, NULL, NULL, 233592),
(267942, '4lo0C00', NULL, NULL, 147, NULL, NULL, 233592),
(267943, '4gaiB00', NULL, NULL, 153, NULL, NULL, 233592),
(267944, '1oqlB02', NULL, NULL, 124, NULL, NULL, 233592),
(267945, '2gzbB00', NULL, NULL, 166, NULL, NULL, 233592),
(267946, '1hwnB01', NULL, NULL, 138, NULL, NULL, 233592),
(267947, '1a8dA02', NULL, NULL, 206, NULL, NULL, 233592),
(267948, '3n7lA02', NULL, NULL, 189, NULL, NULL, 233592),
(267949, '6i18A03', NULL, NULL, 125, NULL, NULL, 233592),
(267950, '6i18A04', NULL, NULL, 107, NULL, NULL, 233592),
(267951, '6i18A01', NULL, NULL, 138, NULL, NULL, 233592),
(267952, '6i18A02', NULL, NULL, 123, NULL, NULL, 233592),
(267953, '4za3B01', NULL, NULL, 134, NULL, NULL, 233592),
(267954, '4za3B02', NULL, NULL, 126, NULL, NULL, 233592),
(267955, '1ihkA00', NULL, NULL, 157, NULL, NULL, 233592),
(267956, '2e4mC00', NULL, NULL, 146, NULL, NULL, 233592),
(267957, '5xozA00', NULL, NULL, 189, NULL, NULL, 233592),
(267958, '3h6sE00', NULL, NULL, 152, NULL, NULL, 233592);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(267959, '4ihzA00', NULL, NULL, 165, NULL, NULL, 233592),
(267960, '3ungC02', NULL, NULL, 88, NULL, NULL, 233593),
(267961, '6as6A03', NULL, NULL, 157, NULL, NULL, 233594),
(267962, '1p7tA03', NULL, NULL, 144, NULL, NULL, 233594),
(267963, '3cuxA02', NULL, NULL, 122, NULL, NULL, 233594),
(267964, '4ex4A03', NULL, NULL, 139, NULL, NULL, 233594),
(267965, '5vfbA03', NULL, NULL, 140, NULL, NULL, 233594),
(267966, '3cuzA02', NULL, NULL, 122, NULL, NULL, 233594),
(267967, '6axeA03', NULL, NULL, 140, NULL, NULL, 233594),
(267968, '2cmrA00', NULL, NULL, 226, NULL, NULL, 233595),
(267969, '2lyxA00', NULL, NULL, 87, NULL, NULL, 233596),
(267970, '3fkyC01', NULL, NULL, 87, NULL, NULL, 233597),
(267971, '3ng0A01', NULL, NULL, 103, NULL, NULL, 233597),
(267972, '4s17A01', NULL, NULL, 103, NULL, NULL, 233597),
(267973, '4baxA01', NULL, NULL, 90, NULL, NULL, 233597),
(267974, '2ojwE01', NULL, NULL, 106, NULL, NULL, 233597),
(267975, '4is4A01', NULL, NULL, 103, NULL, NULL, 233597),
(267976, '1f52A02', NULL, NULL, 103, NULL, NULL, 233597),
(267977, '2uu7A01', NULL, NULL, 110, NULL, NULL, 233597),
(267978, '4hppA01', NULL, NULL, 101, NULL, NULL, 233597),
(267979, '2d3aA01', NULL, NULL, 103, NULL, NULL, 233597),
(267980, '4lniJ01', NULL, NULL, 106, NULL, NULL, 233597),
(267981, '5zliA01', NULL, NULL, 113, NULL, NULL, 233597),
(267982, '4acfA01', NULL, NULL, 103, NULL, NULL, 233597),
(267983, '1vq8P03', NULL, NULL, 60, NULL, NULL, 233598),
(267984, '1b4uA00', NULL, NULL, 139, NULL, NULL, 233599),
(267985, '3wrbB02', NULL, NULL, 113, NULL, NULL, 233599),
(267986, '4bwnA00', NULL, NULL, 86, NULL, NULL, 233600),
(267987, '2v4hB00', NULL, NULL, 91, NULL, NULL, 233600),
(267988, '4owfA00', NULL, NULL, 90, NULL, NULL, 233600),
(267989, '1vkyB02', NULL, NULL, 79, NULL, NULL, 233601),
(267990, '1wdiA02', NULL, NULL, 89, NULL, NULL, 233601),
(267991, '1yy3A02', NULL, NULL, 99, NULL, NULL, 233601),
(267992, '2wbnA00', NULL, NULL, 186, NULL, NULL, 233602),
(267993, '4dkwA00', NULL, NULL, 194, NULL, NULL, 233602),
(267994, '2outA01', NULL, NULL, 57, NULL, NULL, 233603),
(267995, '2uv9A05', NULL, NULL, 45, NULL, NULL, 233604),
(267996, '1vgjA00', NULL, NULL, 184, NULL, NULL, 233605),
(267997, '2fyhA00', NULL, NULL, 190, NULL, NULL, 233605),
(267998, '2fsqA00', NULL, NULL, 243, NULL, NULL, 233605),
(267999, '2d4gA00', NULL, NULL, 171, NULL, NULL, 233605),
(268000, '5ldqA00', NULL, NULL, 177, NULL, NULL, 233605),
(268001, '4h7wA00', NULL, NULL, 193, NULL, NULL, 233605),
(268002, '5h7eA00', NULL, NULL, 182, NULL, NULL, 233605),
(268003, '1iuhA00', NULL, NULL, 198, NULL, NULL, 233605),
(268004, '2vfkA00', NULL, NULL, 205, NULL, NULL, 233605),
(268005, '1jh6A00', NULL, NULL, 189, NULL, NULL, 233605),
(268006, '5jj2A00', NULL, NULL, 211, NULL, NULL, 233605),
(268007, '4riqN00', NULL, NULL, 56, NULL, NULL, 233606),
(268008, '5hvzB00', NULL, NULL, 50, NULL, NULL, 233606),
(268009, '3g36B00', NULL, NULL, 55, NULL, NULL, 233606),
(268010, '2l9uA00', NULL, NULL, 40, NULL, NULL, 233606),
(268011, '4f9kD00', NULL, NULL, 58, NULL, NULL, 233606),
(268012, '2hwnB00', NULL, NULL, 45, NULL, NULL, 233606),
(268013, '2izxB00', NULL, NULL, 41, NULL, NULL, 233606),
(268014, '3a7mA01', NULL, NULL, 111, NULL, NULL, 233607),
(268015, '5gnaA00', NULL, NULL, 96, NULL, NULL, 233607),
(268016, '3h3mA00', NULL, NULL, 89, NULL, NULL, 233607),
(268017, '3nkzA00', NULL, NULL, 97, NULL, NULL, 233607),
(268018, '1a0rP02', NULL, NULL, 83, NULL, NULL, 233608),
(268019, '2trcP02', NULL, NULL, 83, NULL, NULL, 233608),
(268020, '1b9xC02', NULL, NULL, 48, NULL, NULL, 233608),
(268021, '3nqiA02', NULL, NULL, 167, NULL, NULL, 233609),
(268022, '1g8lA04', NULL, NULL, 74, NULL, NULL, 233610),
(268023, '6fgdA04', NULL, NULL, 81, NULL, NULL, 233610),
(268024, '6gbcA04', NULL, NULL, 89, NULL, NULL, 233610),
(268025, '1xi8A03', NULL, NULL, 77, NULL, NULL, 233610),
(268026, '1wu2A04', NULL, NULL, 77, NULL, NULL, 233610),
(268027, '1uz5A04', NULL, NULL, 74, NULL, NULL, 233610),
(268028, '4ar2A02', NULL, NULL, 298, NULL, NULL, 233611),
(268029, '1x9tA02', NULL, NULL, 280, NULL, NULL, 233611);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(268030, '3rc3A02', NULL, NULL, 87, NULL, NULL, 233612),
(268031, '3d3uA03', NULL, NULL, 149, NULL, NULL, 233613),
(268032, '2oasA03', NULL, NULL, 152, NULL, NULL, 233613),
(268033, '3eh7A03', NULL, NULL, 141, NULL, NULL, 233613),
(268034, '3gk7A03', NULL, NULL, 159, NULL, NULL, 233613),
(268035, '5iq6A01', NULL, NULL, 99, NULL, NULL, 233614),
(268036, '5u0cF01', NULL, NULL, 97, NULL, NULL, 233614),
(268037, '4hdhA01', NULL, NULL, 96, NULL, NULL, 233614),
(268038, '5hmyA01', NULL, NULL, 92, NULL, NULL, 233614),
(268039, '5k5mA01', NULL, NULL, 83, NULL, NULL, 233614),
(268040, '4hhjA01', NULL, NULL, 91, NULL, NULL, 233614),
(268041, '2hfzA01', NULL, NULL, 96, NULL, NULL, 233614),
(268042, '4c11A01', NULL, NULL, 96, NULL, NULL, 233614),
(268043, '2kloA00', NULL, NULL, 138, NULL, NULL, 233615),
(268044, '3a4cA00', NULL, NULL, 106, NULL, NULL, 233615),
(268045, '2b1eA04', NULL, NULL, 127, NULL, NULL, 233616),
(268046, '2b7mA00', NULL, NULL, 566, NULL, NULL, 233616),
(268047, '2pftA00', NULL, NULL, 538, NULL, NULL, 233616),
(268048, '4rl5A00', NULL, NULL, 529, NULL, NULL, 233616),
(268049, '3cxbA01', NULL, NULL, 115, NULL, NULL, 233617),
(268050, '1u5eA01', NULL, NULL, 53, NULL, NULL, 233618),
(268051, '1go3F01', NULL, NULL, 60, NULL, NULL, 233619),
(268052, '2e1fA01', NULL, NULL, 89, NULL, NULL, 233619),
(268053, '3cymA03', NULL, NULL, 94, NULL, NULL, 233619),
(268054, '2rhfA00', NULL, NULL, 77, NULL, NULL, 233619),
(268055, '4nlcA02', NULL, NULL, 101, NULL, NULL, 233619),
(268056, '1wudB00', NULL, NULL, 89, NULL, NULL, 233619),
(268057, '1wudA00', NULL, NULL, 89, NULL, NULL, 233619),
(268058, '1wudD00', NULL, NULL, 89, NULL, NULL, 233619),
(268059, '4aybF02', NULL, NULL, 40, NULL, NULL, 233619),
(268060, '2ma1A00', NULL, NULL, 75, NULL, NULL, 233619),
(268061, '2pmzF02', NULL, NULL, 39, NULL, NULL, 233619),
(268062, '3cymA02', NULL, NULL, 119, NULL, NULL, 233619),
(268063, '4cdgA04', NULL, NULL, 85, NULL, NULL, 233619),
(268064, '4qjfB02', NULL, NULL, 68, NULL, NULL, 233619),
(268065, '5c0yA02', NULL, NULL, 96, NULL, NULL, 233619),
(268066, '1yt3A02', NULL, NULL, 99, NULL, NULL, 233619),
(268067, '1yt3A03', NULL, NULL, 82, NULL, NULL, 233619),
(268068, '1d8bA00', NULL, NULL, 81, NULL, NULL, 233619),
(268069, '3safA02', NULL, NULL, 100, NULL, NULL, 233619),
(268070, '4o3mA04', NULL, NULL, 92, NULL, NULL, 233619),
(268071, '4eogA01', NULL, NULL, 301, NULL, NULL, 233620),
(268072, '2i71A01', NULL, NULL, 223, NULL, NULL, 233620),
(268073, '1z47A02', NULL, NULL, 45, NULL, NULL, 233621),
(268074, '4wkzA01', NULL, NULL, 121, NULL, NULL, 233622),
(268075, '2aswA00', NULL, NULL, 56, NULL, NULL, 233623),
(268076, '2y0tA00', NULL, NULL, 54, NULL, NULL, 233623),
(268077, '4i5sA01', NULL, NULL, 65, NULL, NULL, 233623),
(268078, '2js3A01', NULL, NULL, 76, NULL, NULL, 233624),
(268079, '3wguA01', NULL, NULL, 161, NULL, NULL, 233625),
(268080, '2kijA00', NULL, NULL, 124, NULL, NULL, 233625),
(268081, '2dqsA01', NULL, NULL, 174, NULL, NULL, 233625),
(268082, '5mpmA01', NULL, NULL, 171, NULL, NULL, 233625),
(268083, '2hc8A00', NULL, NULL, 113, NULL, NULL, 233625),
(268084, '3ar4A01', NULL, NULL, 171, NULL, NULL, 233625),
(268085, '4umvA02', NULL, NULL, 106, NULL, NULL, 233625),
(268086, '4bbjA02', NULL, NULL, 113, NULL, NULL, 233625),
(268087, '1wpgA01', NULL, NULL, 153, NULL, NULL, 233625),
(268088, '1su4A01', NULL, NULL, 162, NULL, NULL, 233625),
(268089, '5ylvA01', NULL, NULL, 160, NULL, NULL, 233625),
(268090, '2zxeA01', NULL, NULL, 166, NULL, NULL, 233625),
(268091, '5ksdA02', NULL, NULL, 85, NULL, NULL, 233625),
(268092, '2hjjA00', NULL, NULL, 87, NULL, NULL, 233626),
(268093, '3i3lA02', NULL, NULL, 125, NULL, NULL, 233627),
(268094, '4ksfA02', NULL, NULL, 289, NULL, NULL, 233628),
(268095, '2ygwA02', NULL, NULL, 299, NULL, NULL, 233628),
(268096, '4ks9B02', NULL, NULL, 292, NULL, NULL, 233628),
(268097, '4ksaD02', NULL, NULL, 284, NULL, NULL, 233628),
(268098, '1zhxA01', NULL, NULL, 33, NULL, NULL, 233629),
(268099, '4p5nA00', NULL, NULL, 77, NULL, NULL, 233630),
(268100, '3na2D00', NULL, NULL, 148, NULL, NULL, 233631);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(268101, '3t69A01', NULL, NULL, 82, NULL, NULL, 233632),
(268102, '3r1xB01', NULL, NULL, 90, NULL, NULL, 233632),
(268103, '1s6lA02', NULL, NULL, 129, NULL, NULL, 233633),
(268104, '2hgsA03', NULL, NULL, 81, NULL, NULL, 233634),
(268105, '5oesA03', NULL, NULL, 80, NULL, NULL, 233634),
(268106, '3kalA03', NULL, NULL, 80, NULL, NULL, 233634),
(268107, '1m0wA03', NULL, NULL, 85, NULL, NULL, 233634),
(268108, '2wyoA03', NULL, NULL, 75, NULL, NULL, 233634),
(268109, '1s7zA01', NULL, NULL, 107, NULL, NULL, 233635),
(268110, '2kj5A00', NULL, NULL, 116, NULL, NULL, 233636),
(268111, '2keyA00', NULL, NULL, 112, NULL, NULL, 233636),
(268112, '2kobA01', NULL, NULL, 93, NULL, NULL, 233636),
(268113, '2oxoA00', NULL, NULL, 103, NULL, NULL, 233636),
(268114, '2kj8A00', NULL, NULL, 118, NULL, NULL, 233636),
(268115, '5u91F01', NULL, NULL, 109, NULL, NULL, 233636),
(268116, '2khvA01', NULL, NULL, 85, NULL, NULL, 233636),
(268117, '4a8eA01', NULL, NULL, 95, NULL, NULL, 233636),
(268118, '2kkpA00', NULL, NULL, 117, NULL, NULL, 233636),
(268119, '2kj9A00', NULL, NULL, 118, NULL, NULL, 233636),
(268120, '3nrwA00', NULL, NULL, 117, NULL, NULL, 233636),
(268121, '1xo0A01', NULL, NULL, 111, NULL, NULL, 233636),
(268122, '2a3vB01', NULL, NULL, 94, NULL, NULL, 233636),
(268123, '3lysD00', NULL, NULL, 112, NULL, NULL, 233636),
(268124, '2kkvA01', NULL, NULL, 83, NULL, NULL, 233636),
(268125, '2kiwA01', NULL, NULL, 86, NULL, NULL, 233636),
(268126, '4acoA01', NULL, NULL, 125, NULL, NULL, 233636),
(268127, '2khqA01', NULL, NULL, 102, NULL, NULL, 233636),
(268128, '2kd1A00', NULL, NULL, 118, NULL, NULL, 233636),
(268129, '1a0pA01', NULL, NULL, 98, NULL, NULL, 233636),
(268130, '1oruA00', NULL, NULL, 195, NULL, NULL, 233637),
(268131, '1o65B00', NULL, NULL, 246, NULL, NULL, 233637),
(268132, '1o67C00', NULL, NULL, 246, NULL, NULL, 233637),
(268133, '4jndA01', NULL, NULL, 146, NULL, NULL, 233638),
(268134, '4rlqA02', NULL, NULL, 75, NULL, NULL, 233639),
(268135, '4dguA02', NULL, NULL, 104, NULL, NULL, 233640),
(268136, '2z5bB01', NULL, NULL, 166, NULL, NULL, 233641),
(268137, '6jptA00', NULL, NULL, 122, NULL, NULL, 233641),
(268138, '1vs7S00', NULL, NULL, 92, NULL, NULL, 233642),
(268139, '1vx2P00', NULL, NULL, 99, NULL, NULL, 233642),
(268140, '5mmjs00', NULL, NULL, 92, NULL, NULL, 233642),
(268141, '3j7aX01', NULL, NULL, 99, NULL, NULL, 233642),
(268142, '5xyuS00', NULL, NULL, 93, NULL, NULL, 233642),
(268143, '3o30I00', NULL, NULL, 142, NULL, NULL, 233642),
(268144, '3a1pB00', NULL, NULL, 93, NULL, NULL, 233642),
(268145, '4mtmA01', NULL, NULL, 96, NULL, NULL, 233643),
(268146, '2ayaA00', NULL, NULL, 128, NULL, NULL, 233644),
(268147, '4nkpC00', NULL, NULL, 148, NULL, NULL, 233645),
(268148, '3fpwA01', NULL, NULL, 127, NULL, NULL, 233645),
(268149, '5cx7E00', NULL, NULL, 147, NULL, NULL, 233645),
(268150, '6bwsB00', NULL, NULL, 144, NULL, NULL, 233645),
(268151, '4clcA00', NULL, NULL, 179, NULL, NULL, 233645),
(268152, '2a2lC00', NULL, NULL, 145, NULL, NULL, 233645),
(268153, '3k2tA01', NULL, NULL, 47, NULL, NULL, 233646),
(268154, '3lyvB01', NULL, NULL, 55, NULL, NULL, 233646),
(268155, '5ooxA01', NULL, NULL, 55, NULL, NULL, 233646),
(268156, '2jubA02', NULL, NULL, 39, NULL, NULL, 233647),
(268157, '1w9zA01', NULL, NULL, 46, NULL, NULL, 233648),
(268158, '1vr4C00', NULL, NULL, 103, NULL, NULL, 233649),
(268159, '2gtcC00', NULL, NULL, 111, NULL, NULL, 233649),
(268160, '2gtcB00', NULL, NULL, 111, NULL, NULL, 233649),
(268161, '2gtcA00', NULL, NULL, 111, NULL, NULL, 233649),
(268162, '2l8yA00', NULL, NULL, 105, NULL, NULL, 233649),
(268163, '2y1bA00', NULL, NULL, 96, NULL, NULL, 233649),
(268164, '2gtcE00', NULL, NULL, 111, NULL, NULL, 233649),
(268165, '2gtcD00', NULL, NULL, 111, NULL, NULL, 233649),
(268166, '3qkbA00', NULL, NULL, 95, NULL, NULL, 233649),
(268167, '1y2iA00', NULL, NULL, 108, NULL, NULL, 233649),
(268168, '3zpeA00', NULL, NULL, 138, NULL, NULL, 233650),
(268169, '3gmfA02', NULL, NULL, 103, NULL, NULL, 233651),
(268170, '3kxrA01', NULL, NULL, 51, NULL, NULL, 233652),
(268171, '4g6vB00', NULL, NULL, 111, NULL, NULL, 233653);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(268172, '4kf8B00', NULL, NULL, 319, NULL, NULL, 233654),
(268173, '2kj1A00', NULL, NULL, 72, NULL, NULL, 233655),
(268174, '1c4kA01', NULL, NULL, 107, NULL, NULL, 233656),
(268175, '1vwxf00', NULL, NULL, 110, NULL, NULL, 233657),
(268176, '4a18H00', NULL, NULL, 113, NULL, NULL, 233657),
(268177, '6em3f00', NULL, NULL, 107, NULL, NULL, 233657),
(268178, '2lp6A00', NULL, NULL, 95, NULL, NULL, 233657),
(268179, '1vx7900', NULL, NULL, 106, NULL, NULL, 233657),
(268180, '4ac9C04', NULL, NULL, 80, NULL, NULL, 233657),
(268181, '2m1sA01', NULL, NULL, 35, NULL, NULL, 233658),
(268182, '4a8sC04', NULL, NULL, 53, NULL, NULL, 233659),
(268183, '4gucA00', NULL, NULL, 120, NULL, NULL, 233660),
(268184, '1uwyA02', NULL, NULL, 107, NULL, NULL, 233661),
(268185, '5m0yB01', NULL, NULL, 102, NULL, NULL, 233661),
(268186, '3kcpA02', NULL, NULL, 99, NULL, NULL, 233661),
(268187, '3mn8B02', NULL, NULL, 98, NULL, NULL, 233661),
(268188, '1h8lA02', NULL, NULL, 79, NULL, NULL, 233661),
(268189, '5aq0B00', NULL, NULL, 82, NULL, NULL, 233661),
(268190, '4u3sB01', NULL, NULL, 94, NULL, NULL, 233661),
(268191, '4yokA01', NULL, NULL, 99, NULL, NULL, 233661),
(268192, '1nkgA02', NULL, NULL, 85, NULL, NULL, 233661),
(268193, '4iykA01', NULL, NULL, 107, NULL, NULL, 233661),
(268194, '3e8vA00', NULL, NULL, 82, NULL, NULL, 233661),
(268195, '4fxtG01', NULL, NULL, 95, NULL, NULL, 233661),
(268196, '3hn5A01', NULL, NULL, 100, NULL, NULL, 233661),
(268197, '2nsmA02', NULL, NULL, 78, NULL, NULL, 233661),
(268198, '4eiuA01', NULL, NULL, 112, NULL, NULL, 233661),
(268199, '4fxkC01', NULL, NULL, 134, NULL, NULL, 233662),
(268200, '2b39A12', NULL, NULL, 157, NULL, NULL, 233662),
(268201, '4lnvA10', NULL, NULL, 151, NULL, NULL, 233662),
(268202, '2a74C01', NULL, NULL, 146, NULL, NULL, 233662),
(268203, '2pn5A10', NULL, NULL, 153, NULL, NULL, 233662),
(268204, '1ayoA00', NULL, NULL, 130, NULL, NULL, 233662),
(268205, '3cu7A12', NULL, NULL, 150, NULL, NULL, 233662),
(268206, '1edyA00', NULL, NULL, 134, NULL, NULL, 233662),
(268207, '1bv8A00', NULL, NULL, 138, NULL, NULL, 233662),
(268208, '3hrzC02', NULL, NULL, 142, NULL, NULL, 233662),
(268209, '4kt3B00', NULL, NULL, 137, NULL, NULL, 233663),
(268210, '2b5dX01', NULL, NULL, 404, NULL, NULL, 233664),
(268211, '5kbpA01', NULL, NULL, 290, NULL, NULL, 233664),
(268212, '1o7dA01', NULL, NULL, 285, NULL, NULL, 233664),
(268213, '3n98A01', NULL, NULL, 416, NULL, NULL, 233664),
(268214, '5wu7A01', NULL, NULL, 417, NULL, NULL, 233664),
(268215, '3p0bA01', NULL, NULL, 415, NULL, NULL, 233664),
(268216, '3bvxA01', NULL, NULL, 382, NULL, NULL, 233664),
(268217, '5d1pA02', NULL, NULL, 73, NULL, NULL, 233665),
(268218, '4ucsA02', NULL, NULL, 109, NULL, NULL, 233665),
(268219, '1v9pA02', NULL, NULL, 98, NULL, NULL, 233665),
(268220, '1b04A02', NULL, NULL, 99, NULL, NULL, 233665),
(268221, '4d05B01', NULL, NULL, 76, NULL, NULL, 233665),
(268222, '1x9nA02', NULL, NULL, 84, NULL, NULL, 233665),
(268223, '3l2pA02', NULL, NULL, 71, NULL, NULL, 233665),
(268224, '1dgsA02', NULL, NULL, 95, NULL, NULL, 233665),
(268225, '2hvqA01', NULL, NULL, 121, NULL, NULL, 233665),
(268226, '3jslA02', NULL, NULL, 107, NULL, NULL, 233665),
(268227, '1fviA01', NULL, NULL, 79, NULL, NULL, 233665),
(268228, '4glxA03', NULL, NULL, 104, NULL, NULL, 233665),
(268229, '1a0iA01', NULL, NULL, 83, NULL, NULL, 233665),
(268230, '1vs0A01', NULL, NULL, 79, NULL, NULL, 233665),
(268231, '1xdnA01', NULL, NULL, 122, NULL, NULL, 233665),
(268232, '1s68A01', NULL, NULL, 114, NULL, NULL, 233665),
(268233, '1ta8A02', NULL, NULL, 114, NULL, NULL, 233665),
(268234, '2vugA02', NULL, NULL, 72, NULL, NULL, 233665),
(268235, '2z5yA03', NULL, NULL, 52, NULL, NULL, 233666),
(268236, '1o5wC03', NULL, NULL, 54, NULL, NULL, 233666),
(268237, '3fd0A02', NULL, NULL, 214, NULL, NULL, 233667),
(268238, '3gzdA03', NULL, NULL, 206, NULL, NULL, 233667),
(268239, '5k8bA01', NULL, NULL, 250, NULL, NULL, 233667),
(268240, '6d0aA02', NULL, NULL, 238, NULL, NULL, 233667),
(268241, '1uu1A02', NULL, NULL, 203, NULL, NULL, 233667),
(268242, '4rj0A02', NULL, NULL, 244, NULL, NULL, 233667);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(268243, '2aeuA02', NULL, NULL, 217, NULL, NULL, 233667),
(268244, '2hoxA02', NULL, NULL, 210, NULL, NULL, 233667),
(268245, '5m4bA02', NULL, NULL, 259, NULL, NULL, 233667),
(268246, '3rchB02', NULL, NULL, 265, NULL, NULL, 233667),
(268247, '4zwvA01', NULL, NULL, 255, NULL, NULL, 233667),
(268248, '3cq5A02', NULL, NULL, 221, NULL, NULL, 233667),
(268249, '5xmvA02', NULL, NULL, 263, NULL, NULL, 233667),
(268250, '6dvsA02', NULL, NULL, 248, NULL, NULL, 233667),
(268251, '3frkA01', NULL, NULL, 239, NULL, NULL, 233667),
(268252, '5ax8A02', NULL, NULL, 273, NULL, NULL, 233667),
(268253, '2hufA02', NULL, NULL, 249, NULL, NULL, 233667),
(268254, '5viuA02', NULL, NULL, 252, NULL, NULL, 233667),
(268255, '4hvkA02', NULL, NULL, 241, NULL, NULL, 233667),
(268256, '4fl0A02', NULL, NULL, 256, NULL, NULL, 233667),
(268257, '5dj1A02', NULL, NULL, 235, NULL, NULL, 233667),
(268258, '6enzA02', NULL, NULL, 248, NULL, NULL, 233667),
(268259, '3ihjA03', NULL, NULL, 246, NULL, NULL, 233667),
(268260, '3n75A02', NULL, NULL, 295, NULL, NULL, 233667),
(268261, '2x5fA01', NULL, NULL, 325, NULL, NULL, 233667),
(268262, '3caiA02', NULL, NULL, 257, NULL, NULL, 233667),
(268263, '3piuA02', NULL, NULL, 245, NULL, NULL, 233667),
(268264, '2z67A00', NULL, NULL, 435, NULL, NULL, 233667),
(268265, '2ay1A02', NULL, NULL, 268, NULL, NULL, 233667),
(268266, '2ykyA02', NULL, NULL, 240, NULL, NULL, 233667),
(268267, '3fslA02', NULL, NULL, 242, NULL, NULL, 233667),
(268268, '4ffcA02', NULL, NULL, 264, NULL, NULL, 233667),
(268269, '3lvmA02', NULL, NULL, 247, NULL, NULL, 233667),
(268270, '3l8aA02', NULL, NULL, 225, NULL, NULL, 233667),
(268271, '1lw5A01', NULL, NULL, 250, NULL, NULL, 233667),
(268272, '5vwoA02', NULL, NULL, 250, NULL, NULL, 233667),
(268273, '3tcmA03', NULL, NULL, 247, NULL, NULL, 233667),
(268274, '4q6rA03', NULL, NULL, 260, NULL, NULL, 233667),
(268275, '4grxA02', NULL, NULL, 281, NULL, NULL, 233667),
(268276, '5lhaA02', NULL, NULL, 280, NULL, NULL, 233667),
(268277, '1vjoA02', NULL, NULL, 246, NULL, NULL, 233667),
(268278, '2okkA02', NULL, NULL, 249, NULL, NULL, 233667),
(268279, '1s0aA02', NULL, NULL, 270, NULL, NULL, 233667),
(268280, '4isyA02', NULL, NULL, 247, NULL, NULL, 233667),
(268281, '3fq8A02', NULL, NULL, 249, NULL, NULL, 233667),
(268282, '3m5uA01', NULL, NULL, 239, NULL, NULL, 233667),
(268283, '2cjgA02', NULL, NULL, 281, NULL, NULL, 233667),
(268284, '3zrpA01', NULL, NULL, 263, NULL, NULL, 233667),
(268285, '3ndnA01', NULL, NULL, 253, NULL, NULL, 233667),
(268286, '1sffA02', NULL, NULL, 260, NULL, NULL, 233667),
(268287, '1b9hA01', NULL, NULL, 234, NULL, NULL, 233667),
(268288, '6erkB02', NULL, NULL, 271, NULL, NULL, 233667),
(268289, '2fyfA01', NULL, NULL, 241, NULL, NULL, 233667),
(268290, '2cstA02', NULL, NULL, 279, NULL, NULL, 233667),
(268291, '4w91H02', NULL, NULL, 261, NULL, NULL, 233667),
(268292, '1jg8A01', NULL, NULL, 250, NULL, NULL, 233667),
(268293, '4lnjA01', NULL, NULL, 244, NULL, NULL, 233667),
(268294, '1c7nA02', NULL, NULL, 225, NULL, NULL, 233667),
(268295, '3tqxA02', NULL, NULL, 239, NULL, NULL, 233667),
(268296, '2cfbA02', NULL, NULL, 249, NULL, NULL, 233667),
(268297, '3g7qA02', NULL, NULL, 233, NULL, NULL, 233667),
(268298, '5ti8A02', NULL, NULL, 275, NULL, NULL, 233667),
(268299, '3op7A02', NULL, NULL, 214, NULL, NULL, 233667),
(268300, '4l0oA01', NULL, NULL, 245, NULL, NULL, 233667),
(268301, '1o69A01', NULL, NULL, 244, NULL, NULL, 233667),
(268302, '3rq1A02', NULL, NULL, 239, NULL, NULL, 233667),
(268303, '3pj0A01', NULL, NULL, 255, NULL, NULL, 233667),
(268304, '3b1dA02', NULL, NULL, 225, NULL, NULL, 233667),
(268305, '3ftbA02', NULL, NULL, 222, NULL, NULL, 233667),
(268306, '3i4jB02', NULL, NULL, 269, NULL, NULL, 233667),
(268307, '4lw2A02', NULL, NULL, 259, NULL, NULL, 233667),
(268308, '3bb8A01', NULL, NULL, 305, NULL, NULL, 233667),
(268309, '2po3A01', NULL, NULL, 216, NULL, NULL, 233667),
(268310, '3uwcA01', NULL, NULL, 241, NULL, NULL, 233667),
(268311, '4tv7A02', NULL, NULL, 370, NULL, NULL, 233667),
(268312, '3hmuA02', NULL, NULL, 273, NULL, NULL, 233667),
(268313, '2c0rA01', NULL, NULL, 242, NULL, NULL, 233667);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(268314, '2yrrA02', NULL, NULL, 241, NULL, NULL, 233667),
(268315, '5d95A02', NULL, NULL, 260, NULL, NULL, 233667),
(268316, '4nogA02', NULL, NULL, 251, NULL, NULL, 233667),
(268317, '1yaaA02', NULL, NULL, 280, NULL, NULL, 233667),
(268318, '1js3A02', NULL, NULL, 298, NULL, NULL, 233667),
(268319, '3mebA02', NULL, NULL, 287, NULL, NULL, 233667),
(268320, '1z7dA02', NULL, NULL, 250, NULL, NULL, 233667),
(268321, '4w5kA02', NULL, NULL, 268, NULL, NULL, 233667),
(268322, '4a0gC03', NULL, NULL, 328, NULL, NULL, 233667),
(268323, '4iy7A01', NULL, NULL, 247, NULL, NULL, 233667),
(268324, '3dydA02', NULL, NULL, 244, NULL, NULL, 233667),
(268325, '4bhdA01', NULL, NULL, 240, NULL, NULL, 233667),
(268326, '4cvqA02', NULL, NULL, 242, NULL, NULL, 233667),
(268327, '3a8uX02', NULL, NULL, 281, NULL, NULL, 233667),
(268328, '4lc3A01', NULL, NULL, 257, NULL, NULL, 233667),
(268329, '1w23A01', NULL, NULL, 242, NULL, NULL, 233667),
(268330, '6gioA02', NULL, NULL, 257, NULL, NULL, 233667),
(268331, '1n8pA01', NULL, NULL, 248, NULL, NULL, 233667),
(268332, '1wyuB03', NULL, NULL, 268, NULL, NULL, 233667),
(268333, '2vi8A02', NULL, NULL, 251, NULL, NULL, 233667),
(268334, '3e77A01', NULL, NULL, 241, NULL, NULL, 233667),
(268335, '1v72A02', NULL, NULL, 240, NULL, NULL, 233667),
(268336, '3f6tA03', NULL, NULL, 220, NULL, NULL, 233667),
(268337, '3hbxA02', NULL, NULL, 295, NULL, NULL, 233667),
(268338, '4h51A02', NULL, NULL, 272, NULL, NULL, 233667),
(268339, '5toqA02', NULL, NULL, 279, NULL, NULL, 233667),
(268340, '2o7cA01', NULL, NULL, 255, NULL, NULL, 233667),
(268341, '6onnB02', NULL, NULL, 234, NULL, NULL, 233667),
(268342, '1eluA02', NULL, NULL, 264, NULL, NULL, 233667),
(268343, '4wydA02', NULL, NULL, 267, NULL, NULL, 233667),
(268344, '2epjA02', NULL, NULL, 250, NULL, NULL, 233667),
(268345, '4obvA02', NULL, NULL, 241, NULL, NULL, 233667),
(268346, '5g0aA02', NULL, NULL, 284, NULL, NULL, 233667),
(268347, '1m32A02', NULL, NULL, 246, NULL, NULL, 233667),
(268348, '1dfoA01', NULL, NULL, 241, NULL, NULL, 233667),
(268349, '2cb1A01', NULL, NULL, 277, NULL, NULL, 233667),
(268350, '1bs0A02', NULL, NULL, 228, NULL, NULL, 233667),
(268351, '2dkjA02', NULL, NULL, 252, NULL, NULL, 233667),
(268352, '3qm2B02', NULL, NULL, 244, NULL, NULL, 233667),
(268353, '4ixoA02', NULL, NULL, 238, NULL, NULL, 233667),
(268354, '3fkdA02', NULL, NULL, 214, NULL, NULL, 233667),
(268355, '5kr5A02', NULL, NULL, 279, NULL, NULL, 233667),
(268356, '5u23D01', NULL, NULL, 259, NULL, NULL, 233667),
(268357, '3ruyA02', NULL, NULL, 249, NULL, NULL, 233667),
(268358, '7aatA02', NULL, NULL, 273, NULL, NULL, 233667),
(268359, '3dr4C01', NULL, NULL, 237, NULL, NULL, 233667),
(268360, '2ogaA01', NULL, NULL, 240, NULL, NULL, 233667),
(268361, '5uc7A02', NULL, NULL, 270, NULL, NULL, 233667),
(268362, '6gwiA02', NULL, NULL, 276, NULL, NULL, 233667),
(268363, '2w8tA02', NULL, NULL, 235, NULL, NULL, 233667),
(268364, '4e3qA02', NULL, NULL, 281, NULL, NULL, 233667),
(268365, '4n0wA01', NULL, NULL, 238, NULL, NULL, 233667),
(268366, '3ffhB02', NULL, NULL, 213, NULL, NULL, 233667),
(268367, '3ffrA02', NULL, NULL, 247, NULL, NULL, 233667),
(268368, '1pffA01', NULL, NULL, 196, NULL, NULL, 233667),
(268369, '3n5mA02', NULL, NULL, 274, NULL, NULL, 233667),
(268370, '1wyuA02', NULL, NULL, 262, NULL, NULL, 233667),
(268371, '3eleA02', NULL, NULL, 232, NULL, NULL, 233667),
(268372, '3asaA02', NULL, NULL, 246, NULL, NULL, 233667),
(268373, '3lwsC01', NULL, NULL, 253, NULL, NULL, 233667),
(268374, '3kkiA02', NULL, NULL, 232, NULL, NULL, 233667),
(268375, '2douA02', NULL, NULL, 219, NULL, NULL, 233667),
(268376, '2eh6A02', NULL, NULL, 245, NULL, NULL, 233667),
(268377, '5x5hA01', NULL, NULL, 254, NULL, NULL, 233667),
(268378, '3vp6A02', NULL, NULL, 249, NULL, NULL, 233667),
(268379, '5kr6A02', NULL, NULL, 279, NULL, NULL, 233667),
(268380, '2gb3A02', NULL, NULL, 234, NULL, NULL, 233667),
(268381, '5o5cE03', NULL, NULL, 277, NULL, NULL, 233667),
(268382, '2q7wA02', NULL, NULL, 271, NULL, NULL, 233667),
(268383, '2oqxA02', NULL, NULL, 266, NULL, NULL, 233667),
(268384, '3dodA02', NULL, NULL, 277, NULL, NULL, 233667);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(268385, '6dnbA02', NULL, NULL, 279, NULL, NULL, 233667),
(268386, '1c4kA02', NULL, NULL, 313, NULL, NULL, 233667),
(268387, '3q8nA02', NULL, NULL, 262, NULL, NULL, 233667),
(268388, '6blgA01', NULL, NULL, 252, NULL, NULL, 233667),
(268389, '4e1oA02', NULL, NULL, 297, NULL, NULL, 233667),
(268390, '5f8vA01', NULL, NULL, 247, NULL, NULL, 233667),
(268391, '3f0hA02', NULL, NULL, 266, NULL, NULL, 233667),
(268392, '3bc8A02', NULL, NULL, 237, NULL, NULL, 233667),
(268393, '1e5eA01', NULL, NULL, 255, NULL, NULL, 233667),
(268394, '4zm3A02', NULL, NULL, 256, NULL, NULL, 233667),
(268395, '1ejiA02', NULL, NULL, 275, NULL, NULL, 233667),
(268396, '4wbtA02', NULL, NULL, 225, NULL, NULL, 233667),
(268397, '2ordA02', NULL, NULL, 244, NULL, NULL, 233667),
(268398, '3n0lA01', NULL, NULL, 239, NULL, NULL, 233667),
(268399, '3qguA02', NULL, NULL, 255, NULL, NULL, 233667),
(268400, '3gbxA01', NULL, NULL, 240, NULL, NULL, 233667),
(268401, '5kquA02', NULL, NULL, 279, NULL, NULL, 233667),
(268402, '3hvyA02', NULL, NULL, 216, NULL, NULL, 233667),
(268403, '5vyeA02', NULL, NULL, 239, NULL, NULL, 233667),
(268404, '2bkwA02', NULL, NULL, 261, NULL, NULL, 233667),
(268405, '4j5uA02', NULL, NULL, 252, NULL, NULL, 233667),
(268406, '1eg5A02', NULL, NULL, 244, NULL, NULL, 233667),
(268407, '5wmkA02', NULL, NULL, 223, NULL, NULL, 233667),
(268408, '3lg0D02', NULL, NULL, 250, NULL, NULL, 233667),
(268409, '5z0qA02', NULL, NULL, 222, NULL, NULL, 233667),
(268410, '1wstA02', NULL, NULL, 226, NULL, NULL, 233667),
(268411, '3elpA01', NULL, NULL, 228, NULL, NULL, 233667),
(268412, '3ri6A01', NULL, NULL, 231, NULL, NULL, 233667),
(268413, '3jzlA02', NULL, NULL, 214, NULL, NULL, 233667),
(268414, '5vnxA02', NULL, NULL, 234, NULL, NULL, 233667),
(268415, '4rkcA02', NULL, NULL, 242, NULL, NULL, 233667),
(268416, '2o1bA02', NULL, NULL, 221, NULL, NULL, 233667),
(268417, '4dq6A02', NULL, NULL, 222, NULL, NULL, 233667),
(268418, '1bw0A02', NULL, NULL, 254, NULL, NULL, 233667),
(268419, '4zdoB00', NULL, NULL, 463, NULL, NULL, 233667),
(268420, '6f35A02', NULL, NULL, 224, NULL, NULL, 233667),
(268421, '3aowA02', NULL, NULL, 225, NULL, NULL, 233667),
(268422, '5vehA02', NULL, NULL, 257, NULL, NULL, 233667),
(268423, '1lc5A02', NULL, NULL, 225, NULL, NULL, 233667),
(268424, '3qboA01', NULL, NULL, 241, NULL, NULL, 233667),
(268425, '4wb0A02', NULL, NULL, 272, NULL, NULL, 233667),
(268426, '4uoyA02', NULL, NULL, 254, NULL, NULL, 233667),
(268427, '1iugA02', NULL, NULL, 237, NULL, NULL, 233667),
(268428, '4ix8A02', NULL, NULL, 249, NULL, NULL, 233667),
(268429, '4my5A02', NULL, NULL, 225, NULL, NULL, 233667),
(268430, '3bs8A02', NULL, NULL, 248, NULL, NULL, 233667),
(268431, '3k40A02', NULL, NULL, 295, NULL, NULL, 233667),
(268432, '4w8iB02', NULL, NULL, 259, NULL, NULL, 233667),
(268433, '5jayA02', NULL, NULL, 234, NULL, NULL, 233667),
(268434, '4ao9A02', NULL, NULL, 239, NULL, NULL, 233667),
(268435, '1lw4D01', NULL, NULL, 250, NULL, NULL, 233667),
(268436, '4zahA01', NULL, NULL, 250, NULL, NULL, 233667),
(268437, '3fcrA02', NULL, NULL, 279, NULL, NULL, 233667),
(268438, '6g4bA02', NULL, NULL, 280, NULL, NULL, 233667),
(268439, '4kamA01', NULL, NULL, 226, NULL, NULL, 233667),
(268440, '2e7uA02', NULL, NULL, 249, NULL, NULL, 233667),
(268441, '3b46A02', NULL, NULL, 255, NULL, NULL, 233667),
(268442, '2o0rA02', NULL, NULL, 242, NULL, NULL, 233667),
(268443, '3oksA02', NULL, NULL, 268, NULL, NULL, 233667),
(268444, '3pd6B02', NULL, NULL, 273, NULL, NULL, 233667),
(268445, '1qgnG01', NULL, NULL, 259, NULL, NULL, 233667),
(268446, '4uhoA02', NULL, NULL, 280, NULL, NULL, 233667),
(268447, '1svvA01', NULL, NULL, 264, NULL, NULL, 233667),
(268448, '3ke3A02', NULL, NULL, 259, NULL, NULL, 233667),
(268449, '2qmaA03', NULL, NULL, 269, NULL, NULL, 233667),
(268450, '5f9sA02', NULL, NULL, 249, NULL, NULL, 233667),
(268451, '3hdoA02', NULL, NULL, 220, NULL, NULL, 233667),
(268452, '3k28A02', NULL, NULL, 248, NULL, NULL, 233667),
(268453, '4e77A02', NULL, NULL, 249, NULL, NULL, 233667),
(268454, '3kgwA02', NULL, NULL, 249, NULL, NULL, 233667),
(268455, '5hdmA02', NULL, NULL, 249, NULL, NULL, 233667);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(268456, '2jisB02', NULL, NULL, 248, NULL, NULL, 233667),
(268457, '4y0hA02', NULL, NULL, 295, NULL, NULL, 233667),
(268458, '4m2mA02', NULL, NULL, 216, NULL, NULL, 233667),
(268459, '4atqA02', NULL, NULL, 265, NULL, NULL, 233667),
(268460, '4jf1B02', NULL, NULL, 246, NULL, NULL, 233667),
(268461, '1d2fA02', NULL, NULL, 243, NULL, NULL, 233667),
(268462, '3uakA02', NULL, NULL, 271, NULL, NULL, 233667),
(268463, '1ax4A02', NULL, NULL, 262, NULL, NULL, 233667),
(268464, '3nytA01', NULL, NULL, 238, NULL, NULL, 233667),
(268465, '3i16A02', NULL, NULL, 217, NULL, NULL, 233667),
(268466, '5vmbA01', NULL, NULL, 241, NULL, NULL, 233667),
(268467, '5w70A01', NULL, NULL, 267, NULL, NULL, 233667),
(268468, '3dxvB02', NULL, NULL, 259, NULL, NULL, 233667),
(268469, '3cogB01', NULL, NULL, 247, NULL, NULL, 233667),
(268470, '5kqtA02', NULL, NULL, 279, NULL, NULL, 233667),
(268471, '3wgcA01', NULL, NULL, 249, NULL, NULL, 233667),
(268472, '4p3mB01', NULL, NULL, 241, NULL, NULL, 233667),
(268473, '1lw4C01', NULL, NULL, 250, NULL, NULL, 233667),
(268474, '4wxgA02', NULL, NULL, 252, NULL, NULL, 233667),
(268475, '1v2dA02', NULL, NULL, 231, NULL, NULL, 233667),
(268476, '3f9tA02', NULL, NULL, 261, NULL, NULL, 233667),
(268477, '2dgmA02', NULL, NULL, 294, NULL, NULL, 233667),
(268478, '3d6kA02', NULL, NULL, 244, NULL, NULL, 233667),
(268479, '3aczA01', NULL, NULL, 252, NULL, NULL, 233667),
(268480, '1j32A02', NULL, NULL, 223, NULL, NULL, 233667),
(268481, '3pplA02', NULL, NULL, 244, NULL, NULL, 233667),
(268482, '5v7iA01', NULL, NULL, 263, NULL, NULL, 233667),
(268483, '4je5C00', NULL, NULL, 503, NULL, NULL, 233667),
(268484, '3l44B02', NULL, NULL, 249, NULL, NULL, 233667),
(268485, '1vefA02', NULL, NULL, 242, NULL, NULL, 233667),
(268486, '1fc4A01', NULL, NULL, 238, NULL, NULL, 233667),
(268487, '3g0tA03', NULL, NULL, 207, NULL, NULL, 233667),
(268488, '4iw7A02', NULL, NULL, 228, NULL, NULL, 233667),
(268489, '6czxA01', NULL, NULL, 240, NULL, NULL, 233667),
(268490, '4xk1A01', NULL, NULL, 240, NULL, NULL, 233667),
(268491, '4k2mB01', NULL, NULL, 305, NULL, NULL, 233667),
(268492, '3ez1A02', NULL, NULL, 246, NULL, NULL, 233667),
(268493, '5c6uA02', NULL, NULL, 246, NULL, NULL, 233667),
(268494, '1u08A02', NULL, NULL, 240, NULL, NULL, 233667),
(268495, '5uidA01', NULL, NULL, 261, NULL, NULL, 233667),
(268496, '3vaxA01', NULL, NULL, 263, NULL, NULL, 233667),
(268497, '3ju7A00', NULL, NULL, 377, NULL, NULL, 233667),
(268498, '4b9bA02', NULL, NULL, 280, NULL, NULL, 233667),
(268499, '6hnuA00', NULL, NULL, 491, NULL, NULL, 233667),
(268500, '3wcoA02', NULL, NULL, 263, NULL, NULL, 233667),
(268501, '2ez2A02', NULL, NULL, 253, NULL, NULL, 233667),
(268502, '3nnkL01', NULL, NULL, 287, NULL, NULL, 233667),
(268503, '3gjuA02', NULL, NULL, 279, NULL, NULL, 233667),
(268504, '2ctzA01', NULL, NULL, 285, NULL, NULL, 233667),
(268505, '1lw5D01', NULL, NULL, 250, NULL, NULL, 233667),
(268506, '4r5zA02', NULL, NULL, 227, NULL, NULL, 233667),
(268507, '5yb0A01', NULL, NULL, 235, NULL, NULL, 233667),
(268508, '2ch1A02', NULL, NULL, 249, NULL, NULL, 233667),
(268509, '2x3lB02', NULL, NULL, 244, NULL, NULL, 233667),
(268510, '1jf9A02', NULL, NULL, 260, NULL, NULL, 233667),
(268511, '3r4tA02', NULL, NULL, 268, NULL, NULL, 233667),
(268512, '1mdoA01', NULL, NULL, 252, NULL, NULL, 233667),
(268513, '2z9vA02', NULL, NULL, 246, NULL, NULL, 233667),
(268514, '1cs1A01', NULL, NULL, 247, NULL, NULL, 233667),
(268515, '4wd2A02', NULL, NULL, 241, NULL, NULL, 233667),
(268516, '4q75A02', NULL, NULL, 261, NULL, NULL, 233667),
(268517, '3bwnB02', NULL, NULL, 221, NULL, NULL, 233667),
(268518, '2x5dD02', NULL, NULL, 240, NULL, NULL, 233667),
(268519, '6fyqA02', NULL, NULL, 267, NULL, NULL, 233667),
(268520, '3fdbA02', NULL, NULL, 217, NULL, NULL, 233667),
(268521, '1gd9A02', NULL, NULL, 223, NULL, NULL, 233667),
(268522, '1lw4B01', NULL, NULL, 250, NULL, NULL, 233667),
(268523, '3a9zA03', NULL, NULL, 206, NULL, NULL, 233667),
(268524, '4oc9A01', NULL, NULL, 287, NULL, NULL, 233667),
(268525, '2c81A01', NULL, NULL, 248, NULL, NULL, 233667),
(268526, '2dr1A02', NULL, NULL, 246, NULL, NULL, 233667);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(268527, '6f77A02', NULL, NULL, 224, NULL, NULL, 233667),
(268528, '2eo5A02', NULL, NULL, 270, NULL, NULL, 233667),
(268529, '3e9kA02', NULL, NULL, 273, NULL, NULL, 233667),
(268530, '4emyA02', NULL, NULL, 238, NULL, NULL, 233667),
(268531, '3h7fA02', NULL, NULL, 242, NULL, NULL, 233667),
(268532, '3a2bA02', NULL, NULL, 235, NULL, NULL, 233667),
(268533, '1rv3A02', NULL, NULL, 275, NULL, NULL, 233667),
(268534, '5gp4A02', NULL, NULL, 295, NULL, NULL, 233667),
(268535, '2zc0A02', NULL, NULL, 226, NULL, NULL, 233667),
(268536, '4f4eA02', NULL, NULL, 241, NULL, NULL, 233667),
(268537, '2vycA02', NULL, NULL, 301, NULL, NULL, 233667),
(268538, '3ht4A02', NULL, NULL, 214, NULL, NULL, 233667),
(268539, '3if2A00', NULL, NULL, 444, NULL, NULL, 233667),
(268540, '3dzzA02', NULL, NULL, 244, NULL, NULL, 233667),
(268541, '5j8qA02', NULL, NULL, 261, NULL, NULL, 233667),
(268542, '5vc2A01', NULL, NULL, 239, NULL, NULL, 233667),
(268543, '3islA02', NULL, NULL, 264, NULL, NULL, 233667),
(268544, '3p1tA02', NULL, NULL, 200, NULL, NULL, 233667),
(268545, '3ecdB01', NULL, NULL, 240, NULL, NULL, 233667),
(268546, '3h14A00', NULL, NULL, 391, NULL, NULL, 233667),
(268547, '1lw5C01', NULL, NULL, 250, NULL, NULL, 233667),
(268548, '2fnuA01', NULL, NULL, 245, NULL, NULL, 233667),
(268549, '2bwnA02', NULL, NULL, 236, NULL, NULL, 233667),
(268550, '5dx5A01', NULL, NULL, 257, NULL, NULL, 233667),
(268551, '4j8lA01', NULL, NULL, 246, NULL, NULL, 233667),
(268552, '1xi9A02', NULL, NULL, 242, NULL, NULL, 233667),
(268553, '4f5lA02', NULL, NULL, 271, NULL, NULL, 233667),
(268554, '3eucA02', NULL, NULL, 207, NULL, NULL, 233667),
(268555, '3qhxA01', NULL, NULL, 262, NULL, NULL, 233667),
(268556, '1ibjA01', NULL, NULL, 244, NULL, NULL, 233667),
(268557, '5kqwA02', NULL, NULL, 279, NULL, NULL, 233667),
(268558, '3k7yA02', NULL, NULL, 271, NULL, NULL, 233667),
(268559, '3getA01', NULL, NULL, 228, NULL, NULL, 233667),
(268560, '5usrA02', NULL, NULL, 245, NULL, NULL, 233667),
(268561, '1iayA02', NULL, NULL, 254, NULL, NULL, 233667),
(268562, '3nraA02', NULL, NULL, 228, NULL, NULL, 233667),
(268563, '4adbA02', NULL, NULL, 246, NULL, NULL, 233667),
(268564, '3madA03', NULL, NULL, 263, NULL, NULL, 233667),
(268565, '3i5tA02', NULL, NULL, 278, NULL, NULL, 233667),
(268566, '1lw4A01', NULL, NULL, 250, NULL, NULL, 233667),
(268567, '4r8dA02', NULL, NULL, 221, NULL, NULL, 233667),
(268568, '1vp4A02', NULL, NULL, 229, NULL, NULL, 233667),
(268569, '1o4sA02', NULL, NULL, 221, NULL, NULL, 233667),
(268570, '2zyjA02', NULL, NULL, 217, NULL, NULL, 233667),
(268571, '5x6bJ02', NULL, NULL, 252, NULL, NULL, 233667),
(268572, '4a6rB02', NULL, NULL, 275, NULL, NULL, 233667),
(268573, '1zodA02', NULL, NULL, 264, NULL, NULL, 233667),
(268574, '3jtxB02', NULL, NULL, 248, NULL, NULL, 233667),
(268575, '6ezlA02', NULL, NULL, 271, NULL, NULL, 233667),
(268576, '4wlhA02', NULL, NULL, 258, NULL, NULL, 233667),
(268577, '4zdlA02', NULL, NULL, 237, NULL, NULL, 233667),
(268578, '5kr3A02', NULL, NULL, 279, NULL, NULL, 233667),
(268579, '1c7gA02', NULL, NULL, 253, NULL, NULL, 233667),
(268580, '2z61A02', NULL, NULL, 208, NULL, NULL, 233667),
(268581, '3ei9A02', NULL, NULL, 256, NULL, NULL, 233667),
(268582, '1bjnA01', NULL, NULL, 242, NULL, NULL, 233667),
(268583, '3ly1A02', NULL, NULL, 225, NULL, NULL, 233667),
(268584, '4itxA01', NULL, NULL, 258, NULL, NULL, 233667),
(268585, '5i92A02', NULL, NULL, 249, NULL, NULL, 233667),
(268586, '3e2yA02', NULL, NULL, 256, NULL, NULL, 233667),
(268587, '5ghfA02', NULL, NULL, 280, NULL, NULL, 233667),
(268588, '4ysnA02', NULL, NULL, 268, NULL, NULL, 233667),
(268589, '5g4iA02', NULL, NULL, 262, NULL, NULL, 233667),
(268590, '2rfvA01', NULL, NULL, 255, NULL, NULL, 233667),
(268591, '1lw5B01', NULL, NULL, 250, NULL, NULL, 233667),
(268592, '2x8uA02', NULL, NULL, 235, NULL, NULL, 233667),
(268593, '1t3iB02', NULL, NULL, 261, NULL, NULL, 233667),
(268594, '3nx3A02', NULL, NULL, 247, NULL, NULL, 233667),
(268595, '4qgrA01', NULL, NULL, 253, NULL, NULL, 233667),
(268596, '3wy7A02', NULL, NULL, 235, NULL, NULL, 233667),
(268597, '3eucB02', NULL, NULL, 203, NULL, NULL, 233667);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(268598, '1qz9A02', NULL, NULL, 261, NULL, NULL, 233667),
(268599, '4u2hE01', NULL, NULL, 247, NULL, NULL, 233667),
(268600, '2e7jA02', NULL, NULL, 252, NULL, NULL, 233667),
(268601, '4zasA01', NULL, NULL, 259, NULL, NULL, 233667),
(268602, '3t32A02', NULL, NULL, 224, NULL, NULL, 233667),
(268603, '3pgyB02', NULL, NULL, 251, NULL, NULL, 233667),
(268604, '3b8xA01', NULL, NULL, 266, NULL, NULL, 233667),
(268605, '1fg7A01', NULL, NULL, 205, NULL, NULL, 233667),
(268606, '3ezsA02', NULL, NULL, 241, NULL, NULL, 233667),
(268607, '4o6zA02', NULL, NULL, 263, NULL, NULL, 233667),
(268608, '1b5pA02', NULL, NULL, 219, NULL, NULL, 233667),
(268609, '3mc6A03', NULL, NULL, 263, NULL, NULL, 233667),
(268610, '6io1A02', NULL, NULL, 276, NULL, NULL, 233667),
(268611, '1iuzA00', NULL, NULL, 98, NULL, NULL, 233668),
(268612, '1aozA02', NULL, NULL, 206, NULL, NULL, 233668),
(268613, '1aozA03', NULL, NULL, 216, NULL, NULL, 233668),
(268614, '2wo3B00', NULL, NULL, 157, NULL, NULL, 233668),
(268615, '2hzhA02', NULL, NULL, 177, NULL, NULL, 233668),
(268616, '1v10A01', NULL, NULL, 129, NULL, NULL, 233668),
(268617, '2hzhA01', NULL, NULL, 132, NULL, NULL, 233668),
(268618, '1v10A02', NULL, NULL, 184, NULL, NULL, 233668),
(268619, '1aozA01', NULL, NULL, 130, NULL, NULL, 233668),
(268620, '2xu9A01', NULL, NULL, 134, NULL, NULL, 233668),
(268621, '2xu9A02', NULL, NULL, 177, NULL, NULL, 233668),
(268622, '1joiA00', NULL, NULL, 128, NULL, NULL, 233668),
(268623, '2xu9A03', NULL, NULL, 128, NULL, NULL, 233668),
(268624, '7pcyA00', NULL, NULL, 98, NULL, NULL, 233668),
(268625, '2hrgA03', NULL, NULL, 188, NULL, NULL, 233668),
(268626, '3erxA00', NULL, NULL, 123, NULL, NULL, 233668),
(268627, '2hrgA02', NULL, NULL, 176, NULL, NULL, 233668),
(268628, '2ov0A00', NULL, NULL, 105, NULL, NULL, 233668),
(268629, '4e9sA01', NULL, NULL, 146, NULL, NULL, 233668),
(268630, '1plaA00', NULL, NULL, 97, NULL, NULL, 233668),
(268631, '5i5mA02', NULL, NULL, 120, NULL, NULL, 233668),
(268632, '2wsdA02', NULL, NULL, 181, NULL, NULL, 233668),
(268633, '2wsdA01', NULL, NULL, 175, NULL, NULL, 233668),
(268634, '1ibyA00', NULL, NULL, 112, NULL, NULL, 233668),
(268635, '4e9sA03', NULL, NULL, 173, NULL, NULL, 233668),
(268636, '4e9sA02', NULL, NULL, 152, NULL, NULL, 233668),
(268637, '3fsaA00', NULL, NULL, 125, NULL, NULL, 233668),
(268638, '2i7sA00', NULL, NULL, 128, NULL, NULL, 233668),
(268639, '5nq8A01', NULL, NULL, 132, NULL, NULL, 233668),
(268640, '5nq8A02', NULL, NULL, 177, NULL, NULL, 233668),
(268641, '5nq8A03', NULL, NULL, 188, NULL, NULL, 233668),
(268642, '2hzhA03', NULL, NULL, 190, NULL, NULL, 233668),
(268643, '3heiB00', NULL, NULL, 132, NULL, NULL, 233668),
(268644, '3nsyA03', NULL, NULL, 178, NULL, NULL, 233668),
(268645, '3cvbA00', NULL, NULL, 105, NULL, NULL, 233668),
(268646, '3gdcA02', NULL, NULL, 130, NULL, NULL, 233668),
(268647, '1ndtA01', NULL, NULL, 151, NULL, NULL, 233668),
(268648, '3gyrA02', NULL, NULL, 204, NULL, NULL, 233668),
(268649, '3gyrA03', NULL, NULL, 215, NULL, NULL, 233668),
(268650, '3n2jA00', NULL, NULL, 128, NULL, NULL, 233668),
(268651, '1pcsA00', NULL, NULL, 98, NULL, NULL, 233668),
(268652, '4e9xA02', NULL, NULL, 162, NULL, NULL, 233668),
(268653, '3gyrA01', NULL, NULL, 193, NULL, NULL, 233668),
(268654, '2ve0A03', NULL, NULL, 185, NULL, NULL, 233668),
(268655, '3hb3B01', NULL, NULL, 171, NULL, NULL, 233668),
(268656, '4f2fA00', NULL, NULL, 100, NULL, NULL, 233668),
(268657, '4zk8A00', NULL, NULL, 306, NULL, NULL, 233668),
(268658, '2dv6A01', NULL, NULL, 113, NULL, NULL, 233668),
(268659, '2dv6A02', NULL, NULL, 311, NULL, NULL, 233668),
(268660, '6im8A03', NULL, NULL, 175, NULL, NULL, 233668),
(268661, '5o4iB02', NULL, NULL, 137, NULL, NULL, 233668),
(268662, '1v10A03', NULL, NULL, 187, NULL, NULL, 233668),
(268663, '2iwkA02', NULL, NULL, 124, NULL, NULL, 233668),
(268664, '2yxwB03', NULL, NULL, 139, NULL, NULL, 233668),
(268665, '2yevB02', NULL, NULL, 226, NULL, NULL, 233668),
(268666, '3ziyA02', NULL, NULL, 173, NULL, NULL, 233668),
(268667, '6ri6A02', NULL, NULL, 180, NULL, NULL, 233668),
(268668, '6ri6A01', NULL, NULL, 133, NULL, NULL, 233668);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(268669, '5n0kA04', NULL, NULL, 152, NULL, NULL, 233668),
(268670, '5n0kA03', NULL, NULL, 206, NULL, NULL, 233668),
(268671, '5n0kA06', NULL, NULL, 158, NULL, NULL, 233668),
(268672, '1ws8A00', NULL, NULL, 109, NULL, NULL, 233668),
(268673, '3ziyA01', NULL, NULL, 159, NULL, NULL, 233668),
(268674, '1mzyA01', NULL, NULL, 152, NULL, NULL, 233668),
(268675, '5n0kA05', NULL, NULL, 183, NULL, NULL, 233668),
(268676, '1gycA02', NULL, NULL, 177, NULL, NULL, 233668),
(268677, '1mzyA02', NULL, NULL, 181, NULL, NULL, 233668),
(268678, '1gycA01', NULL, NULL, 132, NULL, NULL, 233668),
(268679, '5a7eA03', NULL, NULL, 188, NULL, NULL, 233668),
(268680, '3ef4A00', NULL, NULL, 124, NULL, NULL, 233668),
(268681, '5a7eA01', NULL, NULL, 132, NULL, NULL, 233668),
(268682, '1gycA03', NULL, NULL, 190, NULL, NULL, 233668),
(268683, '5a7eA02', NULL, NULL, 176, NULL, NULL, 233668),
(268684, '1bxvA00', NULL, NULL, 91, NULL, NULL, 233668),
(268685, '4dp9X00', NULL, NULL, 99, NULL, NULL, 233668),
(268686, '4uf7E00', NULL, NULL, 153, NULL, NULL, 233668),
(268687, '1cyxA00', NULL, NULL, 172, NULL, NULL, 233668),
(268688, '5nq7A03', NULL, NULL, 188, NULL, NULL, 233668),
(268689, '2gsmB02', NULL, NULL, 153, NULL, NULL, 233668),
(268690, '5nq7A02', NULL, NULL, 177, NULL, NULL, 233668),
(268691, '5ehfA01', NULL, NULL, 132, NULL, NULL, 233668),
(268692, '5ehfA02', NULL, NULL, 179, NULL, NULL, 233668),
(268693, '5ehfA03', NULL, NULL, 186, NULL, NULL, 233668),
(268694, '5n0kA02', NULL, NULL, 150, NULL, NULL, 233668),
(268695, '5n0kA01', NULL, NULL, 191, NULL, NULL, 233668),
(268696, '1kyaA03', NULL, NULL, 190, NULL, NULL, 233668),
(268697, '5fc9A00', NULL, NULL, 95, NULL, NULL, 233668),
(268698, '1kyaA01', NULL, NULL, 132, NULL, NULL, 233668),
(268699, '3ay2A00', NULL, NULL, 126, NULL, NULL, 233668),
(268700, '1kyaA02', NULL, NULL, 177, NULL, NULL, 233668),
(268701, '2cbpA00', NULL, NULL, 96, NULL, NULL, 233668),
(268702, '2cakA00', NULL, NULL, 154, NULL, NULL, 233668),
(268703, '1fwxA02', NULL, NULL, 121, NULL, NULL, 233668),
(268704, '4rh4A00', NULL, NULL, 123, NULL, NULL, 233668),
(268705, '4jhvA02', NULL, NULL, 176, NULL, NULL, 233668),
(268706, '4jhvA01', NULL, NULL, 132, NULL, NULL, 233668),
(268707, '2ccwA00', NULL, NULL, 129, NULL, NULL, 233668),
(268708, '5o4iA01', NULL, NULL, 146, NULL, NULL, 233668),
(268709, '5z1xA02', NULL, NULL, 177, NULL, NULL, 233668),
(268710, '5z1xA01', NULL, NULL, 132, NULL, NULL, 233668),
(268711, '5akrA02', NULL, NULL, 167, NULL, NULL, 233668),
(268712, '5z1xA03', NULL, NULL, 186, NULL, NULL, 233668),
(268713, '1pmyA00', NULL, NULL, 123, NULL, NULL, 233668),
(268714, '4bxsV02', NULL, NULL, 128, NULL, NULL, 233668),
(268715, '4bxsV01', NULL, NULL, 178, NULL, NULL, 233668),
(268716, '3t9wA01', NULL, NULL, 139, NULL, NULL, 233668),
(268717, '1nwpA00', NULL, NULL, 128, NULL, NULL, 233668),
(268718, '3t9wA02', NULL, NULL, 134, NULL, NULL, 233668),
(268719, '3kw7A02', NULL, NULL, 177, NULL, NULL, 233668),
(268720, '3aw5A03', NULL, NULL, 145, NULL, NULL, 233668),
(268721, '3kw7A01', NULL, NULL, 132, NULL, NULL, 233668),
(268722, '4jhvA03', NULL, NULL, 188, NULL, NULL, 233668),
(268723, '3kw7A03', NULL, NULL, 193, NULL, NULL, 233668),
(268724, '9pcyA00', NULL, NULL, 99, NULL, NULL, 233668),
(268725, '3zx1A03', NULL, NULL, 150, NULL, NULL, 233668),
(268726, '4gybA01', NULL, NULL, 149, NULL, NULL, 233668),
(268727, '3zx1A02', NULL, NULL, 161, NULL, NULL, 233668),
(268728, '4bxsV05', NULL, NULL, 149, NULL, NULL, 233668),
(268729, '3zx1A01', NULL, NULL, 170, NULL, NULL, 233668),
(268730, '3aw5A02', NULL, NULL, 178, NULL, NULL, 233668),
(268731, '4bxsV04', NULL, NULL, 173, NULL, NULL, 233668),
(268732, '3aw5A01', NULL, NULL, 125, NULL, NULL, 233668),
(268733, '4bxsV03', NULL, NULL, 354, NULL, NULL, 233668),
(268734, '5u7nB00', NULL, NULL, 124, NULL, NULL, 233668),
(268735, '5zlmA03', NULL, NULL, 157, NULL, NULL, 233668),
(268736, '2iaaC00', NULL, NULL, 128, NULL, NULL, 233668),
(268737, '5e9nA03', NULL, NULL, 182, NULL, NULL, 233668),
(268738, '2q9oA01', NULL, NULL, 158, NULL, NULL, 233668),
(268739, '2q9oA03', NULL, NULL, 217, NULL, NULL, 233668);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(268740, '2q9oA02', NULL, NULL, 184, NULL, NULL, 233668),
(268741, '4n8uA01', NULL, NULL, 149, NULL, NULL, 233668),
(268742, '4kocA00', NULL, NULL, 128, NULL, NULL, 233668),
(268743, '4f7kA03', NULL, NULL, 151, NULL, NULL, 233668),
(268744, '4f7kA02', NULL, NULL, 148, NULL, NULL, 233668),
(268745, '4f7kA01', NULL, NULL, 126, NULL, NULL, 233668),
(268746, '4f2eA00', NULL, NULL, 98, NULL, NULL, 233668),
(268747, '2xybA01', NULL, NULL, 132, NULL, NULL, 233668),
(268748, '2r7eA02', NULL, NULL, 144, NULL, NULL, 233668),
(268749, '3sbqA02', NULL, NULL, 120, NULL, NULL, 233668),
(268750, '2r7eA04', NULL, NULL, 159, NULL, NULL, 233668),
(268751, '2r7eA03', NULL, NULL, 189, NULL, NULL, 233668),
(268752, '5b1aB02', NULL, NULL, 136, NULL, NULL, 233668),
(268753, '2xybA03', NULL, NULL, 188, NULL, NULL, 233668),
(268754, '2xybA02', NULL, NULL, 177, NULL, NULL, 233668),
(268755, '2ft6A00', NULL, NULL, 124, NULL, NULL, 233668),
(268756, '4yseA01', NULL, NULL, 148, NULL, NULL, 233668),
(268757, '3x1bA03', NULL, NULL, 190, NULL, NULL, 233668),
(268758, '4yseA02', NULL, NULL, 167, NULL, NULL, 233668),
(268759, '2bw4A01', NULL, NULL, 158, NULL, NULL, 233668),
(268760, '3g5wA01', NULL, NULL, 155, NULL, NULL, 233668),
(268761, '3x1bA02', NULL, NULL, 178, NULL, NULL, 233668),
(268762, '3g5wA02', NULL, NULL, 163, NULL, NULL, 233668),
(268763, '3x1bA01', NULL, NULL, 132, NULL, NULL, 233668),
(268764, '5tb7B00', NULL, NULL, 337, NULL, NULL, 233668),
(268765, '3njnA00', NULL, NULL, 119, NULL, NULL, 233668),
(268766, '4knuA01', NULL, NULL, 126, NULL, NULL, 233668),
(268767, '4knuA02', NULL, NULL, 159, NULL, NULL, 233668),
(268768, '5tk4A00', NULL, NULL, 100, NULL, NULL, 233668),
(268769, '3u25A00', NULL, NULL, 127, NULL, NULL, 233668),
(268770, '2qt6A03', NULL, NULL, 190, NULL, NULL, 233668),
(268771, '2qt6A02', NULL, NULL, 176, NULL, NULL, 233668),
(268772, '2qt6A01', NULL, NULL, 132, NULL, NULL, 233668),
(268773, '3abgA02', NULL, NULL, 153, NULL, NULL, 233668),
(268774, '5z62B02', NULL, NULL, 136, NULL, NULL, 233668),
(268775, '4n8uB02', NULL, NULL, 132, NULL, NULL, 233668),
(268776, '3sqrA01', NULL, NULL, 151, NULL, NULL, 233668),
(268777, '3sqrA02', NULL, NULL, 192, NULL, NULL, 233668),
(268778, '1qhqA00', NULL, NULL, 140, NULL, NULL, 233668),
(268779, '3sqrA03', NULL, NULL, 200, NULL, NULL, 233668),
(268780, '4w9zA00', NULL, NULL, 139, NULL, NULL, 233668),
(268781, '1x9uA00', NULL, NULL, 116, NULL, NULL, 233668),
(268782, '3kw8A02', NULL, NULL, 133, NULL, NULL, 233668),
(268783, '6giqb02', NULL, NULL, 140, NULL, NULL, 233668),
(268784, '3divA01', NULL, NULL, 132, NULL, NULL, 233668),
(268785, '6iqxA02', NULL, NULL, 198, NULL, NULL, 233668),
(268786, '3divA02', NULL, NULL, 177, NULL, NULL, 233668),
(268787, '6iqxA01', NULL, NULL, 203, NULL, NULL, 233668),
(268788, '3divA03', NULL, NULL, 190, NULL, NULL, 233668),
(268789, '6iqxA03', NULL, NULL, 137, NULL, NULL, 233668),
(268790, '1id2A00', NULL, NULL, 106, NULL, NULL, 233668),
(268791, '2calA00', NULL, NULL, 154, NULL, NULL, 233668),
(268792, '1kbvA02', NULL, NULL, 167, NULL, NULL, 233668),
(268793, '1kbvA01', NULL, NULL, 156, NULL, NULL, 233668),
(268794, '1oe1A02', NULL, NULL, 167, NULL, NULL, 233668),
(268795, '1oe1A01', NULL, NULL, 152, NULL, NULL, 233668),
(268796, '3d12B00', NULL, NULL, 141, NULL, NULL, 233668),
(268797, '4w1tA01', NULL, NULL, 150, NULL, NULL, 233668),
(268798, '2cuaB00', NULL, NULL, 135, NULL, NULL, 233668),
(268799, '3abgB01', NULL, NULL, 162, NULL, NULL, 233668),
(268800, '3abgB03', NULL, NULL, 186, NULL, NULL, 233668),
(268801, '1aizA00', NULL, NULL, 129, NULL, NULL, 233668),
(268802, '1hfuA01', NULL, NULL, 132, NULL, NULL, 233668),
(268803, '3gdcB01', NULL, NULL, 158, NULL, NULL, 233668),
(268804, '1hfuA02', NULL, NULL, 180, NULL, NULL, 233668),
(268805, '1hfuA03', NULL, NULL, 190, NULL, NULL, 233668),
(268806, '2pltA00', NULL, NULL, 98, NULL, NULL, 233668),
(268807, '2uxtA03', NULL, NULL, 133, NULL, NULL, 233668),
(268808, '2uxtA02', NULL, NULL, 181, NULL, NULL, 233668),
(268809, '4e9xB01', NULL, NULL, 155, NULL, NULL, 233668),
(268810, '2uxtA01', NULL, NULL, 137, NULL, NULL, 233668);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(268811, '3cdzA01', NULL, NULL, 190, NULL, NULL, 233668),
(268812, '1sddA01', NULL, NULL, 181, NULL, NULL, 233668),
(268813, '1sddA02', NULL, NULL, 125, NULL, NULL, 233668),
(268814, '2aanA00', NULL, NULL, 123, NULL, NULL, 233668),
(268815, '3tu6A00', NULL, NULL, 127, NULL, NULL, 233668),
(268816, '5ztdA00', NULL, NULL, 124, NULL, NULL, 233668),
(268817, '1f56A00', NULL, NULL, 91, NULL, NULL, 233668),
(268818, '1cuoA00', NULL, NULL, 129, NULL, NULL, 233668),
(268819, '5lwxA01', NULL, NULL, 149, NULL, NULL, 233668),
(268820, '5lwxA02', NULL, NULL, 191, NULL, NULL, 233668),
(268821, '1b3iA00', NULL, NULL, 97, NULL, NULL, 233668),
(268822, '1zpuA02', NULL, NULL, 180, NULL, NULL, 233668),
(268823, '4bdvB01', NULL, NULL, 179, NULL, NULL, 233668),
(268824, '1zpuA01', NULL, NULL, 126, NULL, NULL, 233668),
(268825, '5lwxA03', NULL, NULL, 214, NULL, NULL, 233668),
(268826, '1zpuA03', NULL, NULL, 198, NULL, NULL, 233668),
(268827, '6evgA01', NULL, NULL, 132, NULL, NULL, 233668),
(268828, '6evgA02', NULL, NULL, 166, NULL, NULL, 233668),
(268829, '6evgA03', NULL, NULL, 146, NULL, NULL, 233668),
(268830, '2gimA00', NULL, NULL, 106, NULL, NULL, 233668),
(268831, '1pf3A03', NULL, NULL, 182, NULL, NULL, 233668),
(268832, '4enzA01', NULL, NULL, 192, NULL, NULL, 233668),
(268833, '4enzA02', NULL, NULL, 150, NULL, NULL, 233668),
(268834, '2r7eB02', NULL, NULL, 146, NULL, NULL, 233668),
(268835, '4enzA03', NULL, NULL, 211, NULL, NULL, 233668),
(268836, '6f5kA03', NULL, NULL, 217, NULL, NULL, 233668),
(268837, '2vmjA01', NULL, NULL, 145, NULL, NULL, 233668),
(268838, '6f5kA02', NULL, NULL, 184, NULL, NULL, 233668),
(268839, '6f5kA01', NULL, NULL, 158, NULL, NULL, 233668),
(268840, '1rkrA00', NULL, NULL, 129, NULL, NULL, 233668),
(268841, '3tasA02', NULL, NULL, 161, NULL, NULL, 233668),
(268842, '4enzA04', NULL, NULL, 152, NULL, NULL, 233668),
(268843, '1jerA00', NULL, NULL, 110, NULL, NULL, 233668),
(268844, '4enzA05', NULL, NULL, 185, NULL, NULL, 233668),
(268845, '4enzA06', NULL, NULL, 156, NULL, NULL, 233668),
(268846, '3tasA01', NULL, NULL, 152, NULL, NULL, 233668),
(268847, '5anhA02', NULL, NULL, 176, NULL, NULL, 233668),
(268848, '3pxlA01', NULL, NULL, 132, NULL, NULL, 233668),
(268849, '3pxlA03', NULL, NULL, 190, NULL, NULL, 233668),
(268850, '3pxlA02', NULL, NULL, 177, NULL, NULL, 233668),
(268851, '1sddB02', NULL, NULL, 140, NULL, NULL, 233668),
(268852, '1sddB01', NULL, NULL, 186, NULL, NULL, 233668),
(268853, '4w1tC02', NULL, NULL, 143, NULL, NULL, 233668),
(268854, '2zooA01', NULL, NULL, 319, NULL, NULL, 233668),
(268855, '4dp1X00', NULL, NULL, 99, NULL, NULL, 233668),
(268856, '1qniF02', NULL, NULL, 130, NULL, NULL, 233668),
(268857, '1shxA00', NULL, NULL, 138, NULL, NULL, 233668),
(268858, '1bypA00', NULL, NULL, 99, NULL, NULL, 233668),
(268859, '3ppsA03', NULL, NULL, 222, NULL, NULL, 233668),
(268860, '1kdjA00', NULL, NULL, 102, NULL, NULL, 233668),
(268861, '3t6vA03', NULL, NULL, 182, NULL, NULL, 233668),
(268862, '2h5uA02', NULL, NULL, 177, NULL, NULL, 233668),
(268863, '3t6vA02', NULL, NULL, 180, NULL, NULL, 233668),
(268864, '1ag6A00', NULL, NULL, 99, NULL, NULL, 233668),
(268865, '3ppsA01', NULL, NULL, 159, NULL, NULL, 233668),
(268866, '3t6vA01', NULL, NULL, 133, NULL, NULL, 233668),
(268867, '3ppsA02', NULL, NULL, 183, NULL, NULL, 233668),
(268868, '3owrB00', NULL, NULL, 134, NULL, NULL, 233669),
(268869, '3clqA04', NULL, NULL, 168, NULL, NULL, 233670),
(268870, '6amgA00', NULL, NULL, 160, NULL, NULL, 233671),
(268871, '2je2A00', NULL, NULL, 186, NULL, NULL, 233671),
(268872, '2ygqA01', NULL, NULL, 150, NULL, NULL, 233672),
(268873, '2ygnA00', NULL, NULL, 156, NULL, NULL, 233672),
(268874, '2ygoA01', NULL, NULL, 150, NULL, NULL, 233672),
(268875, '4bkwA02', NULL, NULL, 118, NULL, NULL, 233673),
(268876, '3ajwA00', NULL, NULL, 150, NULL, NULL, 233674),
(268877, '3etzB00', NULL, NULL, 119, NULL, NULL, 233674),
(268878, '4mh6A00', NULL, NULL, 177, NULL, NULL, 233674),
(268879, '3k29A00', NULL, NULL, 169, NULL, NULL, 233674),
(268880, '1qa4A00', NULL, NULL, 57, NULL, NULL, 233675),
(268881, '4hn9A02', NULL, NULL, 68, NULL, NULL, 233676);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(268882, '4pagA02', NULL, NULL, 82, NULL, NULL, 233676),
(268883, '4ihqA01', NULL, NULL, 160, NULL, NULL, 233677),
(268884, '1uaaA02', NULL, NULL, 74, NULL, NULL, 233678),
(268885, '1w36F02', NULL, NULL, 100, NULL, NULL, 233678),
(268886, '1pjrA02', NULL, NULL, 75, NULL, NULL, 233678),
(268887, '3lfuA02', NULL, NULL, 74, NULL, NULL, 233678),
(268888, '4c2uA02', NULL, NULL, 84, NULL, NULL, 233678),
(268889, '1wleA01', NULL, NULL, 114, NULL, NULL, 233679),
(268890, '1serA01', NULL, NULL, 53, NULL, NULL, 233679),
(268891, '1sesA01', NULL, NULL, 102, NULL, NULL, 233679),
(268892, '6h9xA01', NULL, NULL, 104, NULL, NULL, 233679),
(268893, '2dq3A01', NULL, NULL, 106, NULL, NULL, 233679),
(268894, '3qneA01', NULL, NULL, 109, NULL, NULL, 233679),
(268895, '2dq0A01', NULL, NULL, 107, NULL, NULL, 233679),
(268896, '3lssA01', NULL, NULL, 142, NULL, NULL, 233679),
(268897, '3vbbE01', NULL, NULL, 136, NULL, NULL, 233679),
(268898, '4cy8A03', NULL, NULL, 159, NULL, NULL, 233680),
(268899, '5koxA03', NULL, NULL, 95, NULL, NULL, 233680),
(268900, '5xgvA03', NULL, NULL, 89, NULL, NULL, 233680),
(268901, '2r0cA03', NULL, NULL, 125, NULL, NULL, 233680),
(268902, '4k2xA03', NULL, NULL, 113, NULL, NULL, 233680),
(268903, '4k5sA03', NULL, NULL, 115, NULL, NULL, 233680),
(268904, '6brdA03', NULL, NULL, 97, NULL, NULL, 233680),
(268905, '6j0zC03', NULL, NULL, 109, NULL, NULL, 233680),
(268906, '3ihgA03', NULL, NULL, 142, NULL, NULL, 233680),
(268907, '2qa1A03', NULL, NULL, 114, NULL, NULL, 233680),
(268908, '2qa2A03', NULL, NULL, 112, NULL, NULL, 233680),
(268909, '4x4jA03', NULL, NULL, 110, NULL, NULL, 233680),
(268910, '1neeA01', NULL, NULL, 91, NULL, NULL, 233681),
(268911, '2nxuA01', NULL, NULL, 73, NULL, NULL, 233681),
(268912, '2d74B01', NULL, NULL, 91, NULL, NULL, 233681),
(268913, '2arhA02', NULL, NULL, 45, NULL, NULL, 233682),
(268914, '3j7a400', NULL, NULL, 82, NULL, NULL, 233683),
(268915, '5optS00', NULL, NULL, 86, NULL, NULL, 233683),
(268916, '6g5ib00', NULL, NULL, 84, NULL, NULL, 233683),
(268917, '5xxub00', NULL, NULL, 82, NULL, NULL, 233683),
(268918, '6az1c00', NULL, NULL, 86, NULL, NULL, 233683),
(268919, '5xyib00', NULL, NULL, 86, NULL, NULL, 233683),
(268920, '2xzm600', NULL, NULL, 81, NULL, NULL, 233683),
(268921, '6faib00', NULL, NULL, 82, NULL, NULL, 233683),
(268922, '1qxfA00', NULL, NULL, 66, NULL, NULL, 233683),
(268923, '2jbwB01', NULL, NULL, 105, NULL, NULL, 233684),
(268924, '3fnbB01', NULL, NULL, 114, NULL, NULL, 233684),
(268925, '3fnbA01', NULL, NULL, 114, NULL, NULL, 233684),
(268926, '1iwpG02', NULL, NULL, 93, NULL, NULL, 233685),
(268927, '5yrvC02', NULL, NULL, 93, NULL, NULL, 233685),
(268928, '4g6qA02', NULL, NULL, 90, NULL, NULL, 233686),
(268929, '1g5gA03', NULL, NULL, 60, NULL, NULL, 233687),
(268930, '1ztmA03', NULL, NULL, 53, NULL, NULL, 233687),
(268931, '4gipD03', NULL, NULL, 57, NULL, NULL, 233687),
(268932, '4mhcA01', NULL, NULL, 298, NULL, NULL, 233688),
(268933, '5haxA01', NULL, NULL, 276, NULL, NULL, 233688),
(268934, '1h54B01', NULL, NULL, 269, NULL, NULL, 233689),
(268935, '3qdeA01', NULL, NULL, 277, NULL, NULL, 233689),
(268936, '3rrsA01', NULL, NULL, 282, NULL, NULL, 233689),
(268937, '1v7wA01', NULL, NULL, 302, NULL, NULL, 233689),
(268938, '4ktpA01', NULL, NULL, 250, NULL, NULL, 233689),
(268939, '3wirA01', NULL, NULL, 255, NULL, NULL, 233689),
(268940, '3actA01', NULL, NULL, 282, NULL, NULL, 233689),
(268941, '4kzsA02', NULL, NULL, 70, NULL, NULL, 233690),
(268942, '3x27A01', NULL, NULL, 148, NULL, NULL, 233691),
(268943, '2nnzA01', NULL, NULL, 124, NULL, NULL, 233691),
(268944, '3kopF01', NULL, NULL, 168, NULL, NULL, 233691),
(268945, '1zx8A01', NULL, NULL, 128, NULL, NULL, 233691),
(268946, '2jhnA01', NULL, NULL, 113, NULL, NULL, 233692),
(268947, '1mpgA01', NULL, NULL, 112, NULL, NULL, 233692),
(268948, '3ubtA02', NULL, NULL, 151, NULL, NULL, 233693),
(268949, '4h0nA02', NULL, NULL, 134, NULL, NULL, 233693),
(268950, '2c7rA02', NULL, NULL, 116, NULL, NULL, 233693),
(268951, '1g55A01', NULL, NULL, 144, NULL, NULL, 233693),
(268952, '3ptaA01', NULL, NULL, 141, NULL, NULL, 233693);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(268953, '5gutA04', NULL, NULL, 186, NULL, NULL, 233693),
(268954, '4dkjA02', NULL, NULL, 92, NULL, NULL, 233693),
(268955, '3qv2A02', NULL, NULL, 120, NULL, NULL, 233693),
(268956, '3g7uA02', NULL, NULL, 178, NULL, NULL, 233693),
(268957, '4ft4A03', NULL, NULL, 175, NULL, NULL, 233693),
(268958, '2ifyA02', NULL, NULL, 236, NULL, NULL, 233694),
(268959, '3nvlA02', NULL, NULL, 244, NULL, NULL, 233694),
(268960, '3igzB02', NULL, NULL, 244, NULL, NULL, 233694),
(268961, '5kgnB02', NULL, NULL, 235, NULL, NULL, 233694),
(268962, '4my4A02', NULL, NULL, 230, NULL, NULL, 233694),
(268963, '1o98A01', NULL, NULL, 236, NULL, NULL, 233694),
(268964, '4m5dA03', NULL, NULL, 136, NULL, NULL, 233695),
(268965, '3f7cA00', NULL, NULL, 200, NULL, NULL, 233696),
(268966, '2q9rA01', NULL, NULL, 199, NULL, NULL, 233696),
(268967, '5a0yA02', NULL, NULL, 175, NULL, NULL, 233697),
(268968, '5a0yB02', NULL, NULL, 147, NULL, NULL, 233697),
(268969, '5a8wA02', NULL, NULL, 175, NULL, NULL, 233697),
(268970, '5a8wB02', NULL, NULL, 147, NULL, NULL, 233697),
(268971, '5n1qA02', NULL, NULL, 175, NULL, NULL, 233697),
(268972, '3sqgB02', NULL, NULL, 145, NULL, NULL, 233697),
(268973, '5n1qB02', NULL, NULL, 147, NULL, NULL, 233697),
(268974, '3sqgA02', NULL, NULL, 181, NULL, NULL, 233697),
(268975, '1e6vA02', NULL, NULL, 175, NULL, NULL, 233697),
(268976, '1e6vB01', NULL, NULL, 147, NULL, NULL, 233697),
(268977, '1e6yA02', NULL, NULL, 175, NULL, NULL, 233697),
(268978, '1e6yB01', NULL, NULL, 147, NULL, NULL, 233697),
(268979, '5n28A02', NULL, NULL, 175, NULL, NULL, 233697),
(268980, '5n28B02', NULL, NULL, 147, NULL, NULL, 233697),
(268981, '1nijA02', NULL, NULL, 116, NULL, NULL, 233698),
(268982, '3gd0A02', NULL, NULL, 115, NULL, NULL, 233699),
(268983, '2v7qI00', NULL, NULL, 50, NULL, NULL, 233700),
(268984, '3oeeI00', NULL, NULL, 61, NULL, NULL, 233700),
(268985, '3qi7A03', NULL, NULL, 45, NULL, NULL, 233701),
(268986, '4ceiA03', NULL, NULL, 112, NULL, NULL, 233702),
(268987, '2ganA02', NULL, NULL, 45, NULL, NULL, 233703),
(268988, '2hc0A00', NULL, NULL, 99, NULL, NULL, 233704),
(268989, '1hvcA01', NULL, NULL, 99, NULL, NULL, 233704),
(268990, '2rspA00', NULL, NULL, 124, NULL, NULL, 233704),
(268991, '3hboB00', NULL, NULL, 99, NULL, NULL, 233704),
(268992, '4belB02', NULL, NULL, 236, NULL, NULL, 233704),
(268993, '4ehcA00', NULL, NULL, 296, NULL, NULL, 233704),
(268994, '2h6tA01', NULL, NULL, 171, NULL, NULL, 233704),
(268995, '2h6tA02', NULL, NULL, 169, NULL, NULL, 233704),
(268996, '1sipA00', NULL, NULL, 99, NULL, NULL, 233704),
(268997, '5kr1A00', NULL, NULL, 99, NULL, NULL, 233704),
(268998, '3nygA00', NULL, NULL, 99, NULL, NULL, 233704),
(268999, '2i4dA00', NULL, NULL, 99, NULL, NULL, 233704),
(269000, '3gi0B02', NULL, NULL, 101, NULL, NULL, 233704),
(269001, '3gi0B01', NULL, NULL, 102, NULL, NULL, 233704),
(269002, '1t7iA00', NULL, NULL, 99, NULL, NULL, 233704),
(269003, '5yq8A00', NULL, NULL, 130, NULL, NULL, 233704),
(269004, '1j71A02', NULL, NULL, 161, NULL, NULL, 233704),
(269005, '2hahA00', NULL, NULL, 116, NULL, NULL, 233704),
(269006, '2je4A00', NULL, NULL, 99, NULL, NULL, 233704),
(269007, '2qzwA02', NULL, NULL, 169, NULL, NULL, 233704),
(269008, '1j71A01', NULL, NULL, 173, NULL, NULL, 233704),
(269009, '2qzwA01', NULL, NULL, 172, NULL, NULL, 233704),
(269010, '2r8nA00', NULL, NULL, 99, NULL, NULL, 233704),
(269011, '1dpjA01', NULL, NULL, 174, NULL, NULL, 233704),
(269012, '1dpjA02', NULL, NULL, 154, NULL, NULL, 233704),
(269013, '3d3tA00', NULL, NULL, 99, NULL, NULL, 233704),
(269014, '3dckB00', NULL, NULL, 99, NULL, NULL, 233704),
(269015, '3qrvA01', NULL, NULL, 182, NULL, NULL, 233704),
(269016, '3ia9A00', NULL, NULL, 99, NULL, NULL, 233704),
(269017, '3qrvA02', NULL, NULL, 154, NULL, NULL, 233704),
(269018, '3nygB00', NULL, NULL, 99, NULL, NULL, 233704),
(269019, '2bjuA02', NULL, NULL, 154, NULL, NULL, 233704),
(269020, '2qzxA01', NULL, NULL, 173, NULL, NULL, 233704),
(269021, '2qzxA02', NULL, NULL, 169, NULL, NULL, 233704),
(269022, '3ttpA00', NULL, NULL, 99, NULL, NULL, 233704),
(269023, '3nxeA01', NULL, NULL, 102, NULL, NULL, 233704);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(269024, '3nxeA02', NULL, NULL, 101, NULL, NULL, 233704),
(269025, '5c9fA00', NULL, NULL, 139, NULL, NULL, 233704),
(269026, '1nh0A00', NULL, NULL, 99, NULL, NULL, 233704),
(269027, '2fxdA00', NULL, NULL, 99, NULL, NULL, 233704),
(269028, '5cokA00', NULL, NULL, 99, NULL, NULL, 233704),
(269029, '3bxrA00', NULL, NULL, 99, NULL, NULL, 233704),
(269030, '2pmaA01', NULL, NULL, 136, NULL, NULL, 233704),
(269031, '2j9jB00', NULL, NULL, 99, NULL, NULL, 233704),
(269032, '1pfzB01', NULL, NULL, 161, NULL, NULL, 233704),
(269033, '3hawA00', NULL, NULL, 99, NULL, NULL, 233704),
(269034, '3fv3D01', NULL, NULL, 175, NULL, NULL, 233704),
(269035, '3ogpA00', NULL, NULL, 116, NULL, NULL, 233704),
(269036, '4od9A00', NULL, NULL, 103, NULL, NULL, 233704),
(269037, '5b18A00', NULL, NULL, 99, NULL, NULL, 233704),
(269038, '1kzkA00', NULL, NULL, 99, NULL, NULL, 233704),
(269039, '5jodA01', NULL, NULL, 175, NULL, NULL, 233704),
(269040, '5jodA02', NULL, NULL, 153, NULL, NULL, 233704),
(269041, '3dckA00', NULL, NULL, 99, NULL, NULL, 233704),
(269042, '4fivA00', NULL, NULL, 113, NULL, NULL, 233704),
(269043, '2j9kB00', NULL, NULL, 99, NULL, NULL, 233704),
(269044, '1c6xA00', NULL, NULL, 99, NULL, NULL, 233704),
(269045, '2p3cA00', NULL, NULL, 99, NULL, NULL, 233704),
(269046, '3ec0A00', NULL, NULL, 99, NULL, NULL, 233704),
(269047, '4y9wA01', NULL, NULL, 166, NULL, NULL, 233704),
(269048, '4rghA00', NULL, NULL, 129, NULL, NULL, 233704),
(269049, '1htrB01', NULL, NULL, 171, NULL, NULL, 233704),
(269050, '1htrB02', NULL, NULL, 157, NULL, NULL, 233704),
(269051, '3zkqA01', NULL, NULL, 133, NULL, NULL, 233704),
(269052, '1az5A00', NULL, NULL, 99, NULL, NULL, 233704),
(269053, '3hawB00', NULL, NULL, 99, NULL, NULL, 233704),
(269054, '1pfzA02', NULL, NULL, 218, NULL, NULL, 233704),
(269055, '2j9jA00', NULL, NULL, 99, NULL, NULL, 233704),
(269056, '2hs1A00', NULL, NULL, 99, NULL, NULL, 233704),
(269057, '4od9B00', NULL, NULL, 243, NULL, NULL, 233704),
(269058, '3nwqB00', NULL, NULL, 99, NULL, NULL, 233704),
(269059, '4aucA02', NULL, NULL, 152, NULL, NULL, 233704),
(269060, '3u7sA00', NULL, NULL, 99, NULL, NULL, 233704),
(269061, '3fsmA02', NULL, NULL, 101, NULL, NULL, 233704),
(269062, '3fsmA01', NULL, NULL, 102, NULL, NULL, 233704),
(269063, '2anlA01', NULL, NULL, 175, NULL, NULL, 233704),
(269064, '2anlA02', NULL, NULL, 152, NULL, NULL, 233704),
(269065, '5n7nA01', NULL, NULL, 139, NULL, NULL, 233704),
(269066, '4aucA01', NULL, NULL, 169, NULL, NULL, 233704),
(269067, '4epjA01', NULL, NULL, 99, NULL, NULL, 233704),
(269068, '3gi0A02', NULL, NULL, 101, NULL, NULL, 233704),
(269069, '4z2zB00', NULL, NULL, 146, NULL, NULL, 233704),
(269070, '4y9wA02', NULL, NULL, 168, NULL, NULL, 233704),
(269071, '3gi0A01', NULL, NULL, 102, NULL, NULL, 233704),
(269072, '2j9kA00', NULL, NULL, 99, NULL, NULL, 233704),
(269073, '2i4vA00', NULL, NULL, 99, NULL, NULL, 233704),
(269074, '1qdmA01', NULL, NULL, 212, NULL, NULL, 233704),
(269075, '5ux4A01', NULL, NULL, 181, NULL, NULL, 233704),
(269076, '1qdmA02', NULL, NULL, 162, NULL, NULL, 233704),
(269077, '5ux4A02', NULL, NULL, 159, NULL, NULL, 233704),
(269078, '1miqA02', NULL, NULL, 152, NULL, NULL, 233704),
(269079, '3vlaA01', NULL, NULL, 196, NULL, NULL, 233704),
(269080, '1miqA01', NULL, NULL, 175, NULL, NULL, 233704),
(269081, '3vlaA02', NULL, NULL, 217, NULL, NULL, 233704),
(269082, '3aupD01', NULL, NULL, 200, NULL, NULL, 233704),
(269083, '3aupD02', NULL, NULL, 203, NULL, NULL, 233704),
(269084, '1qrpE02', NULL, NULL, 155, NULL, NULL, 233704),
(269085, '1qrpE01', NULL, NULL, 170, NULL, NULL, 233704),
(269086, '1yg9A03', NULL, NULL, 117, NULL, NULL, 233704),
(269087, '1am5A01', NULL, NULL, 170, NULL, NULL, 233704),
(269088, '3lzuA00', NULL, NULL, 99, NULL, NULL, 233704),
(269089, '1am5A02', NULL, NULL, 152, NULL, NULL, 233704),
(269090, '1yg9A02', NULL, NULL, 130, NULL, NULL, 233704),
(269091, '2o40A01', NULL, NULL, 102, NULL, NULL, 233704),
(269092, '3hzcA01', NULL, NULL, 102, NULL, NULL, 233704),
(269093, '3hzcA02', NULL, NULL, 101, NULL, NULL, 233704),
(269094, '1sguA00', NULL, NULL, 99, NULL, NULL, 233704);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(269095, '2p3dA00', NULL, NULL, 99, NULL, NULL, 233704),
(269096, '5mlgA01', NULL, NULL, 140, NULL, NULL, 233704),
(269097, '3qvcA02', NULL, NULL, 161, NULL, NULL, 233704),
(269098, '5nfgB02', NULL, NULL, 161, NULL, NULL, 233704),
(269099, '1b5fC00', NULL, NULL, 239, NULL, NULL, 233704),
(269100, '3qvcA01', NULL, NULL, 214, NULL, NULL, 233704),
(269101, '3ixoA00', NULL, NULL, 99, NULL, NULL, 233704),
(269102, '3k1wA02', NULL, NULL, 158, NULL, NULL, 233704),
(269103, '3k1wA01', NULL, NULL, 175, NULL, NULL, 233704),
(269104, '5mlgA02', NULL, NULL, 193, NULL, NULL, 233704),
(269105, '3pvkA02', NULL, NULL, 170, NULL, NULL, 233704),
(269106, '3pvkA01', NULL, NULL, 172, NULL, NULL, 233704),
(269107, '3dcrB00', NULL, NULL, 99, NULL, NULL, 233704),
(269108, '1ibqA02', NULL, NULL, 155, NULL, NULL, 233704),
(269109, '1ibqA01', NULL, NULL, 165, NULL, NULL, 233704),
(269110, '3oadA00', NULL, NULL, 166, NULL, NULL, 233704),
(269111, '3fv3A02', NULL, NULL, 164, NULL, NULL, 233704),
(269112, '3psgA01', NULL, NULL, 170, NULL, NULL, 233704),
(269113, '1oewA02', NULL, NULL, 155, NULL, NULL, 233704),
(269114, '3psgA02', NULL, NULL, 155, NULL, NULL, 233704),
(269115, '4rvjA00', NULL, NULL, 99, NULL, NULL, 233704),
(269116, '2rkgA00', NULL, NULL, 100, NULL, NULL, 233704),
(269117, '2fddA00', NULL, NULL, 100, NULL, NULL, 233704),
(269118, '3ka2A02', NULL, NULL, 101, NULL, NULL, 233704),
(269119, '3hauA00', NULL, NULL, 99, NULL, NULL, 233704),
(269120, '3ka2A01', NULL, NULL, 102, NULL, NULL, 233704),
(269121, '5nfgA01', NULL, NULL, 177, NULL, NULL, 233704),
(269122, '1tcxA00', NULL, NULL, 99, NULL, NULL, 233704),
(269123, '1tzsA02', NULL, NULL, 158, NULL, NULL, 233704),
(269124, '1mppA02', NULL, NULL, 175, NULL, NULL, 233704),
(269125, '1tzsA01', NULL, NULL, 183, NULL, NULL, 233704),
(269126, '1mppA01', NULL, NULL, 181, NULL, NULL, 233704),
(269127, '3hloA02', NULL, NULL, 101, NULL, NULL, 233704),
(269128, '3hloA01', NULL, NULL, 102, NULL, NULL, 233704),
(269129, '3slzA00', NULL, NULL, 115, NULL, NULL, 233704),
(269130, '1fmbA00', NULL, NULL, 104, NULL, NULL, 233704),
(269131, '4qj6A00', NULL, NULL, 99, NULL, NULL, 233704),
(269132, '1izdA02', NULL, NULL, 152, NULL, NULL, 233704),
(269133, '1izdA01', NULL, NULL, 165, NULL, NULL, 233704),
(269134, '1qdmC02', NULL, NULL, 129, NULL, NULL, 233704),
(269135, '3dcrA00', NULL, NULL, 99, NULL, NULL, 233704),
(269136, '2aprA01', NULL, NULL, 169, NULL, NULL, 233704),
(269137, '2aprA02', NULL, NULL, 149, NULL, NULL, 233704),
(269138, '3hdkB00', NULL, NULL, 99, NULL, NULL, 233704),
(269139, '4dqeA00', NULL, NULL, 99, NULL, NULL, 233704),
(269140, '3nwqA00', NULL, NULL, 99, NULL, NULL, 233704),
(269141, '3hauB00', NULL, NULL, 99, NULL, NULL, 233704),
(269142, '4l7gA02', NULL, NULL, 255, NULL, NULL, 233704),
(269143, '6eqmA01', NULL, NULL, 133, NULL, NULL, 233704),
(269144, '3ia9B00', NULL, NULL, 99, NULL, NULL, 233704),
(269145, '3i2lA00', NULL, NULL, 99, NULL, NULL, 233704),
(269146, '5yojA00', NULL, NULL, 100, NULL, NULL, 233704),
(269147, '3ekwA00', NULL, NULL, 99, NULL, NULL, 233704),
(269148, '3nwxA00', NULL, NULL, 99, NULL, NULL, 233704),
(269149, '3s43A00', NULL, NULL, 99, NULL, NULL, 233704),
(269150, '1smrA01', NULL, NULL, 172, NULL, NULL, 233704),
(269151, '2jysA00', NULL, NULL, 107, NULL, NULL, 233704),
(269152, '3c9xA01', NULL, NULL, 170, NULL, NULL, 233704),
(269153, '3c9xA02', NULL, NULL, 155, NULL, NULL, 233704),
(269154, '1smrA02', NULL, NULL, 159, NULL, NULL, 233704),
(269155, '4yhqA00', NULL, NULL, 99, NULL, NULL, 233704),
(269156, '1bdqA00', NULL, NULL, 99, NULL, NULL, 233704),
(269157, '3q6yA01', NULL, NULL, 170, NULL, NULL, 233704),
(269158, '1t6eX02', NULL, NULL, 201, NULL, NULL, 233704),
(269159, '5t2eA00', NULL, NULL, 99, NULL, NULL, 233704),
(269160, '5ivtA00', NULL, NULL, 99, NULL, NULL, 233704),
(269161, '1wkrA02', NULL, NULL, 170, NULL, NULL, 233704),
(269162, '1t6eX01', NULL, NULL, 180, NULL, NULL, 233704),
(269163, '3hdkA00', NULL, NULL, 99, NULL, NULL, 233704),
(269164, '3iawA01', NULL, NULL, 102, NULL, NULL, 233704),
(269165, '3sqfA00', NULL, NULL, 114, NULL, NULL, 233704);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(269166, '1wkrA01', NULL, NULL, 170, NULL, NULL, 233704),
(269167, '3iawA02', NULL, NULL, 101, NULL, NULL, 233704),
(269168, '4npuA00', NULL, NULL, 99, NULL, NULL, 233704),
(269169, '3t3cA00', NULL, NULL, 99, NULL, NULL, 233704),
(269170, '3gguA00', NULL, NULL, 99, NULL, NULL, 233704),
(269171, '4aa9A02', NULL, NULL, 152, NULL, NULL, 233704),
(269172, '4aa9A01', NULL, NULL, 168, NULL, NULL, 233704),
(269173, '1b5fB00', NULL, NULL, 87, NULL, NULL, 233704),
(269174, '3hd8C01', NULL, NULL, 182, NULL, NULL, 233704),
(269175, '3hd8C02', NULL, NULL, 207, NULL, NULL, 233704),
(269176, '2fntA00', NULL, NULL, 99, NULL, NULL, 233704),
(269177, '3i2lB00', NULL, NULL, 99, NULL, NULL, 233704),
(269178, '3nwxB00', NULL, NULL, 99, NULL, NULL, 233704),
(269179, '2o4nA00', NULL, NULL, 99, NULL, NULL, 233704),
(269180, '2asiA02', NULL, NULL, 174, NULL, NULL, 233704),
(269181, '2asiA01', NULL, NULL, 181, NULL, NULL, 233704),
(269182, '1bxoA01', NULL, NULL, 165, NULL, NULL, 233704),
(269183, '1bxoA02', NULL, NULL, 152, NULL, NULL, 233704),
(269184, '5mktA02', NULL, NULL, 193, NULL, NULL, 233704),
(269185, '2p3aA00', NULL, NULL, 99, NULL, NULL, 233704),
(269186, '5n7qA02', NULL, NULL, 161, NULL, NULL, 233704),
(269187, '3mwsA00', NULL, NULL, 99, NULL, NULL, 233704),
(269188, '3liyA00', NULL, NULL, 116, NULL, NULL, 233704),
(269189, '3s8iA00', NULL, NULL, 127, NULL, NULL, 233704),
(269190, '3nxnA01', NULL, NULL, 102, NULL, NULL, 233704),
(269191, '3hboA00', NULL, NULL, 99, NULL, NULL, 233704),
(269192, '3spkA00', NULL, NULL, 99, NULL, NULL, 233704),
(269193, '3qviA02', NULL, NULL, 153, NULL, NULL, 233704),
(269194, '3nxnA02', NULL, NULL, 101, NULL, NULL, 233704),
(269195, '4pphA02', NULL, NULL, 212, NULL, NULL, 233704),
(269196, '4pphA01', NULL, NULL, 205, NULL, NULL, 233704),
(269197, '5n7qA01', NULL, NULL, 177, NULL, NULL, 233704),
(269198, '5agzA00', NULL, NULL, 99, NULL, NULL, 233704),
(269199, '1baiA00', NULL, NULL, 124, NULL, NULL, 233704),
(269200, '2pynA00', NULL, NULL, 99, NULL, NULL, 233704),
(269201, '3o4xE02', NULL, NULL, 108, NULL, NULL, 233705),
(269202, '1v9dA01', NULL, NULL, 91, NULL, NULL, 233705),
(269203, '1y1uA02', NULL, NULL, 139, NULL, NULL, 233706),
(269204, '1bg1A02', NULL, NULL, 145, NULL, NULL, 233706),
(269205, '1yvlA03', NULL, NULL, 145, NULL, NULL, 233706),
(269206, '2pffB06', NULL, NULL, 30, NULL, NULL, 233707),
(269207, '2l6uA00', NULL, NULL, 163, NULL, NULL, 233708),
(269208, '2ky6A00', NULL, NULL, 166, NULL, NULL, 233708),
(269209, '2l23A00', NULL, NULL, 167, NULL, NULL, 233708),
(269210, '1iqoA00', NULL, NULL, 88, NULL, NULL, 233709),
(269211, '4rzlA00', NULL, NULL, 232, NULL, NULL, 233710),
(269212, '4f0qD01', NULL, NULL, 264, NULL, NULL, 233710),
(269213, '4oc8A01', NULL, NULL, 216, NULL, NULL, 233710),
(269214, '5wm1A01', NULL, NULL, 39, NULL, NULL, 233711),
(269215, '3bh1A03', NULL, NULL, 146, NULL, NULL, 233712),
(269216, '3um7A02', NULL, NULL, 51, NULL, NULL, 233713),
(269217, '1t6aA01', NULL, NULL, 46, NULL, NULL, 233714),
(269218, '1h5wB01', NULL, NULL, 87, NULL, NULL, 233715),
(269219, '5ly3A02', NULL, NULL, 224, NULL, NULL, 233716),
(269220, '1xrhH02', NULL, NULL, 239, NULL, NULL, 233717),
(269221, '1xrhG02', NULL, NULL, 239, NULL, NULL, 233717),
(269222, '1xrhD02', NULL, NULL, 239, NULL, NULL, 233717),
(269223, '3uoeA02', NULL, NULL, 164, NULL, NULL, 233717),
(269224, '1xrhC02', NULL, NULL, 239, NULL, NULL, 233717),
(269225, '1xrhF02', NULL, NULL, 239, NULL, NULL, 233717),
(269226, '1xrhE02', NULL, NULL, 239, NULL, NULL, 233717),
(269227, '1xrhB02', NULL, NULL, 239, NULL, NULL, 233717),
(269228, '2g8yA02', NULL, NULL, 218, NULL, NULL, 233717),
(269229, '1v9nA02', NULL, NULL, 245, NULL, NULL, 233717),
(269230, '1xrhA02', NULL, NULL, 239, NULL, NULL, 233717),
(269231, '2x06A02', NULL, NULL, 211, NULL, NULL, 233717),
(269232, '3i0pA02', NULL, NULL, 253, NULL, NULL, 233717),
(269233, '1z2iA02', NULL, NULL, 157, NULL, NULL, 233717),
(269234, '1wtjA02', NULL, NULL, 191, NULL, NULL, 233717),
(269235, '1vbiA02', NULL, NULL, 237, NULL, NULL, 233717),
(269236, '4h8aA02', NULL, NULL, 239, NULL, NULL, 233717);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(269237, '1nxuB02', NULL, NULL, 159, NULL, NULL, 233717),
(269238, '2xmoA02', NULL, NULL, 86, NULL, NULL, 233718),
(269239, '3h35C00', NULL, NULL, 150, NULL, NULL, 233719),
(269240, '3vtoQ02', NULL, NULL, 61, NULL, NULL, 233720),
(269241, '5llkA02', NULL, NULL, 135, NULL, NULL, 233721),
(269242, '4wiqA02', NULL, NULL, 135, NULL, NULL, 233721),
(269243, '1f6vA00', NULL, NULL, 91, NULL, NULL, 233722),
(269244, '3c1yA02', NULL, NULL, 148, NULL, NULL, 233723),
(269245, '1vvmI02', NULL, NULL, 89, NULL, NULL, 233724),
(269246, '1divA02', NULL, NULL, 90, NULL, NULL, 233724),
(269247, '1vs8H02', NULL, NULL, 89, NULL, NULL, 233724),
(269248, '3t30C00', NULL, NULL, 110, NULL, NULL, 233725),
(269249, '1k5jB00', NULL, NULL, 124, NULL, NULL, 233725),
(269250, '4n8mD00', NULL, NULL, 117, NULL, NULL, 233725),
(269251, '2vtxB00', NULL, NULL, 104, NULL, NULL, 233725),
(269252, '1xe0C00', NULL, NULL, 114, NULL, NULL, 233725),
(269253, '5ehdB00', NULL, NULL, 116, NULL, NULL, 233725),
(269254, '4ca9A00', NULL, NULL, 98, NULL, NULL, 233725),
(269255, '1nlqE00', NULL, NULL, 108, NULL, NULL, 233725),
(269256, '2ynzC02', NULL, NULL, 26, NULL, NULL, 233726),
(269257, '4o6mA01', NULL, NULL, 135, NULL, NULL, 233727),
(269258, '1x0tA02', NULL, NULL, 56, NULL, NULL, 233728),
(269259, '2k3rA02', NULL, NULL, 46, NULL, NULL, 233728),
(269260, '3rc3A01', NULL, NULL, 129, NULL, NULL, 233729),
(269261, '1sedA00', NULL, NULL, 117, NULL, NULL, 233730),
(269262, '3lpeB00', NULL, NULL, 59, NULL, NULL, 233731),
(269263, '1ryqA00', NULL, NULL, 69, NULL, NULL, 233731),
(269264, '4adiA01', NULL, NULL, 78, NULL, NULL, 233732),
(269265, '1o75A01', NULL, NULL, 83, NULL, NULL, 233733),
(269266, '3i0wA01', NULL, NULL, 113, NULL, NULL, 233734),
(269267, '4ejyA01', NULL, NULL, 126, NULL, NULL, 233734),
(269268, '2crqA01', NULL, NULL, 86, NULL, NULL, 233735),
(269269, '2m71A00', NULL, NULL, 101, NULL, NULL, 233735),
(269270, '1tigA00', NULL, NULL, 94, NULL, NULL, 233735),
(269271, '2ifeA00', NULL, NULL, 100, NULL, NULL, 233735),
(269272, '1n7vA02', NULL, NULL, 123, NULL, NULL, 233736),
(269273, '3tutA02', NULL, NULL, 91, NULL, NULL, 233737),
(269274, '4clqA02', NULL, NULL, 97, NULL, NULL, 233737),
(269275, '4o89A02', NULL, NULL, 94, NULL, NULL, 233737),
(269276, '3pqvA02', NULL, NULL, 96, NULL, NULL, 233737),
(269277, '2l0zA00', NULL, NULL, 42, NULL, NULL, 233738),
(269278, '3cxbA03', NULL, NULL, 90, NULL, NULL, 233739),
(269279, '2qi2A01', NULL, NULL, 126, NULL, NULL, 233740),
(269280, '3obwA01', NULL, NULL, 104, NULL, NULL, 233740),
(269281, '3wxmF01', NULL, NULL, 127, NULL, NULL, 233740),
(269282, '3mcaB01', NULL, NULL, 132, NULL, NULL, 233740),
(269283, '2vgnB01', NULL, NULL, 140, NULL, NULL, 233740),
(269284, '3obyA01', NULL, NULL, 128, NULL, NULL, 233740),
(269285, '4tkzA00', NULL, NULL, 130, NULL, NULL, 233741),
(269286, '5t3uB00', NULL, NULL, 148, NULL, NULL, 233741),
(269287, '3iprA00', NULL, NULL, 150, NULL, NULL, 233741),
(269288, '2iacB00', NULL, NULL, 142, NULL, NULL, 233741),
(269289, '2iacA00', NULL, NULL, 142, NULL, NULL, 233741),
(269290, '3gdwB00', NULL, NULL, 139, NULL, NULL, 233741),
(269291, '3bedB00', NULL, NULL, 142, NULL, NULL, 233741),
(269292, '3gdwA00', NULL, NULL, 139, NULL, NULL, 233741),
(269293, '3b48F00', NULL, NULL, 135, NULL, NULL, 233741),
(269294, '5im4F00', NULL, NULL, 138, NULL, NULL, 233741),
(269295, '3bedA00', NULL, NULL, 142, NULL, NULL, 233741),
(269296, '3ct6A00', NULL, NULL, 131, NULL, NULL, 233741),
(269297, '3gx1B00', NULL, NULL, 130, NULL, NULL, 233741),
(269298, '3gx1A00', NULL, NULL, 130, NULL, NULL, 233741),
(269299, '3lfhA00', NULL, NULL, 144, NULL, NULL, 233741),
(269300, '1pdoA00', NULL, NULL, 135, NULL, NULL, 233741),
(269301, '3mtqB00', NULL, NULL, 159, NULL, NULL, 233741),
(269302, '2k0sA00', NULL, NULL, 130, NULL, NULL, 233742),
(269303, '3doeB00', NULL, NULL, 116, NULL, NULL, 233742),
(269304, '4zi3D00', NULL, NULL, 133, NULL, NULL, 233742),
(269305, '1ohfA01', NULL, NULL, 102, NULL, NULL, 233743),
(269306, '1ohfB01', NULL, NULL, 114, NULL, NULL, 233743),
(269307, '3s6pD01', NULL, NULL, 97, NULL, NULL, 233743);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(269308, '2qqpG01', NULL, NULL, 92, NULL, NULL, 233743),
(269309, '1s7mB01', NULL, NULL, 47, NULL, NULL, 233744),
(269310, '3d9xA02', NULL, NULL, 40, NULL, NULL, 233744),
(269311, '2jlnA00', NULL, NULL, 471, NULL, NULL, 233745),
(269312, '4innA00', NULL, NULL, 146, NULL, NULL, 233746),
(269313, '2bkrA00', NULL, NULL, 212, NULL, NULL, 233747),
(269314, '2xphB00', NULL, NULL, 238, NULL, NULL, 233747),
(269315, '1th0B00', NULL, NULL, 226, NULL, NULL, 233747),
(269316, '4ekfA00', NULL, NULL, 204, NULL, NULL, 233747),
(269317, '5jp1A00', NULL, NULL, 199, NULL, NULL, 233747),
(269318, '4wx4A00', NULL, NULL, 205, NULL, NULL, 233747),
(269319, '3e0jA02', NULL, NULL, 127, NULL, NULL, 233748),
(269320, '1lkxA02', NULL, NULL, 58, NULL, NULL, 233749),
(269321, '1br2A02', NULL, NULL, 56, NULL, NULL, 233749),
(269322, '1lvkA03', NULL, NULL, 60, NULL, NULL, 233749),
(269323, '2mysA03', NULL, NULL, 60, NULL, NULL, 233749),
(269324, '2x51A03', NULL, NULL, 57, NULL, NULL, 233749),
(269325, '3e2tA00', NULL, NULL, 314, NULL, NULL, 233750),
(269326, '4bptA00', NULL, NULL, 272, NULL, NULL, 233750),
(269327, '1phzA00', NULL, NULL, 411, NULL, NULL, 233750),
(269328, '3tk2A00', NULL, NULL, 302, NULL, NULL, 233750),
(269329, '1j8uA00', NULL, NULL, 325, NULL, NULL, 233750),
(269330, '2xsnC00', NULL, NULL, 343, NULL, NULL, 233750),
(269331, '2v27B00', NULL, NULL, 275, NULL, NULL, 233750),
(269332, '4v06B00', NULL, NULL, 349, NULL, NULL, 233750),
(269333, '1tohA00', NULL, NULL, 343, NULL, NULL, 233750),
(269334, '6n1kD00', NULL, NULL, 433, NULL, NULL, 233750),
(269335, '5jk6B00', NULL, NULL, 401, NULL, NULL, 233750),
(269336, '5tpgA00', NULL, NULL, 291, NULL, NULL, 233750),
(269337, '1g43A00', NULL, NULL, 160, NULL, NULL, 233751),
(269338, '3zucA00', NULL, NULL, 153, NULL, NULL, 233751),
(269339, '4b97A00', NULL, NULL, 151, NULL, NULL, 233751),
(269340, '4b9pA00', NULL, NULL, 166, NULL, NULL, 233751),
(269341, '6d5bA00', NULL, NULL, 170, NULL, NULL, 233751),
(269342, '1tf4A02', NULL, NULL, 147, NULL, NULL, 233751),
(269343, '1g87A02', NULL, NULL, 160, NULL, NULL, 233751),
(269344, '4b96A00', NULL, NULL, 151, NULL, NULL, 233751),
(269345, '5gxxA02', NULL, NULL, 157, NULL, NULL, 233751),
(269346, '3zqxA00', NULL, NULL, 146, NULL, NULL, 233751),
(269347, '2xfgB01', NULL, NULL, 163, NULL, NULL, 233751),
(269348, '4b9fA00', NULL, NULL, 152, NULL, NULL, 233751),
(269349, '4b9cA00', NULL, NULL, 150, NULL, NULL, 233751),
(269350, '2l8aA00', NULL, NULL, 149, NULL, NULL, 233751),
(269351, '2xbtA00', NULL, NULL, 160, NULL, NULL, 233751),
(269352, '2wnxA00', NULL, NULL, 170, NULL, NULL, 233751),
(269353, '3f6kA02', NULL, NULL, 57, NULL, NULL, 233752),
(269354, '1ib8A01', NULL, NULL, 83, NULL, NULL, 233753),
(269355, '1wn2A00', NULL, NULL, 121, NULL, NULL, 233754),
(269356, '2zv3B00', NULL, NULL, 115, NULL, NULL, 233754),
(269357, '1q7sA00', NULL, NULL, 117, NULL, NULL, 233754),
(269358, '1xtyA00', NULL, NULL, 120, NULL, NULL, 233754),
(269359, '3erjA00', NULL, NULL, 123, NULL, NULL, 233754),
(269360, '2gaxA00', NULL, NULL, 135, NULL, NULL, 233754),
(269361, '1rlkA00', NULL, NULL, 117, NULL, NULL, 233754),
(269362, '1xezA01', NULL, NULL, 85, NULL, NULL, 233755),
(269363, '3c8vA01', NULL, NULL, 60, NULL, NULL, 233756),
(269364, '2x49A02', NULL, NULL, 48, NULL, NULL, 233757),
(269365, '3wajA03', NULL, NULL, 100, NULL, NULL, 233758),
(269366, '4h63Q04', NULL, NULL, 128, NULL, NULL, 233759),
(269367, '4ogqA00', NULL, NULL, 215, NULL, NULL, 233760),
(269368, '2yiuA00', NULL, NULL, 430, NULL, NULL, 233760),
(269369, '1zrtC00', NULL, NULL, 437, NULL, NULL, 233760),
(269370, '1q90B00', NULL, NULL, 215, NULL, NULL, 233760),
(269371, '3tguC00', NULL, NULL, 380, NULL, NULL, 233760),
(269372, '3cx5C00', NULL, NULL, 385, NULL, NULL, 233760),
(269373, '5xteJ00', NULL, NULL, 378, NULL, NULL, 233760),
(269374, '2qjyA00', NULL, NULL, 445, NULL, NULL, 233760),
(269375, '1pp9P00', NULL, NULL, 379, NULL, NULL, 233760),
(269376, '3if4A01', NULL, NULL, 50, NULL, NULL, 233761),
(269377, '3n05A03', NULL, NULL, 81, NULL, NULL, 233762),
(269378, '1v74A00', NULL, NULL, 107, NULL, NULL, 233763);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(269379, '5bwaB00', NULL, NULL, 136, NULL, NULL, 233764),
(269380, '1zo0A00', NULL, NULL, 126, NULL, NULL, 233764),
(269381, '4zgyB00', NULL, NULL, 135, NULL, NULL, 233764),
(269382, '2ioiA00', NULL, NULL, 201, NULL, NULL, 233765),
(269383, '4mziA00', NULL, NULL, 200, NULL, NULL, 233765),
(269384, '2xwcA00', NULL, NULL, 208, NULL, NULL, 233765),
(269385, '1eaqB00', NULL, NULL, 140, NULL, NULL, 233765),
(269386, '6ggcA00', NULL, NULL, 199, NULL, NULL, 233765),
(269387, '1t4wA00', NULL, NULL, 196, NULL, NULL, 233765),
(269388, '3qynD00', NULL, NULL, 203, NULL, NULL, 233765),
(269389, '5kbdA00', NULL, NULL, 207, NULL, NULL, 233765),
(269390, '4l18A01', NULL, NULL, 142, NULL, NULL, 233765),
(269391, '2yvyA01', NULL, NULL, 132, NULL, NULL, 233766),
(269392, '2ouxB01', NULL, NULL, 134, NULL, NULL, 233766),
(269393, '2ouxA01', NULL, NULL, 134, NULL, NULL, 233766),
(269394, '3cwzB02', NULL, NULL, 65, NULL, NULL, 233767),
(269395, '3u07A02', NULL, NULL, 129, NULL, NULL, 233768),
(269396, '2xclA04', NULL, NULL, 98, NULL, NULL, 233769),
(269397, '2yw2A04', NULL, NULL, 96, NULL, NULL, 233769),
(269398, '2yrxA04', NULL, NULL, 106, NULL, NULL, 233769),
(269399, '5vevB04', NULL, NULL, 96, NULL, NULL, 233769),
(269400, '1vkzA04', NULL, NULL, 86, NULL, NULL, 233769),
(269401, '3lp8A04', NULL, NULL, 95, NULL, NULL, 233769),
(269402, '2qk4A04', NULL, NULL, 95, NULL, NULL, 233769),
(269403, '3mjfA04', NULL, NULL, 96, NULL, NULL, 233769),
(269404, '2ip4A04', NULL, NULL, 93, NULL, NULL, 233769),
(269405, '1gsoA04', NULL, NULL, 96, NULL, NULL, 233769),
(269406, '2wyhB01', NULL, NULL, 96, NULL, NULL, 233770),
(269407, '1w26A02', NULL, NULL, 225, NULL, NULL, 233771),
(269408, '3gtyX03', NULL, NULL, 186, NULL, NULL, 233771),
(269409, '2nsaA00', NULL, NULL, 170, NULL, NULL, 233771),
(269410, '1zxjA01', NULL, NULL, 198, NULL, NULL, 233771),
(269411, '1t11A02', NULL, NULL, 180, NULL, NULL, 233771),
(269412, '2jr3A00', NULL, NULL, 42, NULL, NULL, 233772),
(269413, '3if8B03', NULL, NULL, 75, NULL, NULL, 233773),
(269414, '3uwpA01', NULL, NULL, 121, NULL, NULL, 233774),
(269415, '4e6zA02', NULL, NULL, 89, NULL, NULL, 233775),
(269416, '4e6zA01', NULL, NULL, 123, NULL, NULL, 233775),
(269417, '2jh3A03', NULL, NULL, 112, NULL, NULL, 233776),
(269418, '1e0aB00', NULL, NULL, 46, NULL, NULL, 233777),
(269419, '4mitG00', NULL, NULL, 43, NULL, NULL, 233777),
(269420, '1f3mA00', NULL, NULL, 80, NULL, NULL, 233777),
(269421, '2k42A00', NULL, NULL, 72, NULL, NULL, 233777),
(269422, '1ej5A00', NULL, NULL, 107, NULL, NULL, 233777),
(269423, '2lnhA00', NULL, NULL, 65, NULL, NULL, 233777),
(269424, '1eesB00', NULL, NULL, 46, NULL, NULL, 233777),
(269425, '1ceeB00', NULL, NULL, 59, NULL, NULL, 233777),
(269426, '2kswA01', NULL, NULL, 46, NULL, NULL, 233778),
(269427, '2ih2A02', NULL, NULL, 169, NULL, NULL, 233779),
(269428, '3bwuF00', NULL, NULL, 142, NULL, NULL, 233780),
(269429, '2uy6C01', NULL, NULL, 142, NULL, NULL, 233780),
(269430, '3jwnE00', NULL, NULL, 154, NULL, NULL, 233780),
(269431, '4x5pA00', NULL, NULL, 160, NULL, NULL, 233780),
(269432, '6arnA00', NULL, NULL, 166, NULL, NULL, 233780),
(269433, '2xg5B01', NULL, NULL, 138, NULL, NULL, 233780),
(269434, '3sqbB00', NULL, NULL, 152, NULL, NULL, 233780),
(269435, '2w07B01', NULL, NULL, 134, NULL, NULL, 233780),
(269436, '5iqnA00', NULL, NULL, 132, NULL, NULL, 233780),
(269437, '1p5vB00', NULL, NULL, 147, NULL, NULL, 233780),
(269438, '1n12A00', NULL, NULL, 138, NULL, NULL, 233780),
(269439, '4xo9A02', NULL, NULL, 122, NULL, NULL, 233780),
(269440, '3me0B00', NULL, NULL, 128, NULL, NULL, 233780),
(269441, '1pdkB00', NULL, NULL, 157, NULL, NULL, 233780),
(269442, '2qyuA04', NULL, NULL, 193, NULL, NULL, 233781),
(269443, '3nb2A04', NULL, NULL, 177, NULL, NULL, 233781),
(269444, '2uvaG01', NULL, NULL, 136, NULL, NULL, 233782),
(269445, '2uv8G01', NULL, NULL, 141, NULL, NULL, 233782),
(269446, '2l92A01', NULL, NULL, 26, NULL, NULL, 233783),
(269447, '2yzvA00', NULL, NULL, 303, NULL, NULL, 233784),
(269448, '6g28A00', NULL, NULL, 367, NULL, NULL, 233784),
(269449, '2woeA00', NULL, NULL, 299, NULL, NULL, 233784);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(269450, '6d3aB00', NULL, NULL, 350, NULL, NULL, 233784),
(269451, '1t5jA00', NULL, NULL, 313, NULL, NULL, 233784),
(269452, '6g1pB00', NULL, NULL, 350, NULL, NULL, 233784),
(269453, '5ovoA00', NULL, NULL, 297, NULL, NULL, 233784),
(269454, '2qtyA00', NULL, NULL, 347, NULL, NULL, 233784),
(269455, '4fe9A01', NULL, NULL, 120, NULL, NULL, 233785),
(269456, '4oi4A03', NULL, NULL, 103, NULL, NULL, 233786),
(269457, '4ohxA03', NULL, NULL, 114, NULL, NULL, 233786),
(269458, '2gnxA02', NULL, NULL, 135, NULL, NULL, 233787),
(269459, '3sqnA02', NULL, NULL, 118, NULL, NULL, 233788),
(269460, '2vk9A04', NULL, NULL, 104, NULL, NULL, 233789),
(269461, '1r71A02', NULL, NULL, 58, NULL, NULL, 233790),
(269462, '2bnxA02', NULL, NULL, 130, NULL, NULL, 233791),
(269463, '2bnxB02', NULL, NULL, 99, NULL, NULL, 233791),
(269464, '3obvB02', NULL, NULL, 90, NULL, NULL, 233791),
(269465, '2bapA02', NULL, NULL, 68, NULL, NULL, 233791),
(269466, '3eg5B03', NULL, NULL, 90, NULL, NULL, 233791),
(269467, '1hufA00', NULL, NULL, 140, NULL, NULL, 233792),
(269468, '3ip0A00', NULL, NULL, 158, NULL, NULL, 233793),
(269469, '1cbkA00', NULL, NULL, 160, NULL, NULL, 233793),
(269470, '2qx0A00', NULL, NULL, 159, NULL, NULL, 233793),
(269471, '5etrA00', NULL, NULL, 161, NULL, NULL, 233793),
(269472, '4pzvA01', NULL, NULL, 164, NULL, NULL, 233793),
(269473, '2bmbA01', NULL, NULL, 207, NULL, NULL, 233793),
(269474, '2cg8B02', NULL, NULL, 151, NULL, NULL, 233793),
(269475, '3f4sA02', NULL, NULL, 64, NULL, NULL, 233794),
(269476, '3oosA02', NULL, NULL, 56, NULL, NULL, 233795),
(269477, '1vq0A01', NULL, NULL, 242, NULL, NULL, 233796),
(269478, '1vzyA01', NULL, NULL, 234, NULL, NULL, 233796),
(269479, '1hw7A01', NULL, NULL, 178, NULL, NULL, 233796),
(269480, '2msbB00', NULL, NULL, 115, NULL, NULL, 233797),
(269481, '1sb2A00', NULL, NULL, 133, NULL, NULL, 233797),
(269482, '1byfA00', NULL, NULL, 125, NULL, NULL, 233797),
(269483, '1afb100', NULL, NULL, 154, NULL, NULL, 233797),
(269484, '1oz7A00', NULL, NULL, 131, NULL, NULL, 233797),
(269485, '1f00I03', NULL, NULL, 98, NULL, NULL, 233797),
(269486, '1sl6A00', NULL, NULL, 184, NULL, NULL, 233797),
(269487, '1ypqA00', NULL, NULL, 135, NULL, NULL, 233797),
(269488, '2bphA00', NULL, NULL, 140, NULL, NULL, 233797),
(269489, '3bx4D00', NULL, NULL, 123, NULL, NULL, 233797),
(269490, '6nd8B00', NULL, NULL, 124, NULL, NULL, 233797),
(269491, '2py2A00', NULL, NULL, 136, NULL, NULL, 233797),
(269492, '1litA00', NULL, NULL, 144, NULL, NULL, 233797),
(269493, '1wt9B00', NULL, NULL, 123, NULL, NULL, 233797),
(269494, '1tdqB00', NULL, NULL, 130, NULL, NULL, 233797),
(269495, '2h2tB01', NULL, NULL, 121, NULL, NULL, 233797),
(269496, '4uwwA00', NULL, NULL, 132, NULL, NULL, 233797),
(269497, '3ubuB00', NULL, NULL, 126, NULL, NULL, 233797),
(269498, '1xphA00', NULL, NULL, 150, NULL, NULL, 233797),
(269499, '2ls8A00', NULL, NULL, 156, NULL, NULL, 233797),
(269500, '1pwbC00', NULL, NULL, 150, NULL, NULL, 233797),
(269501, '3rs1A00', NULL, NULL, 122, NULL, NULL, 233797),
(269502, '1umrC00', NULL, NULL, 125, NULL, NULL, 233797),
(269503, '1rtm100', NULL, NULL, 149, NULL, NULL, 233797),
(269504, '3ff7C00', NULL, NULL, 112, NULL, NULL, 233797),
(269505, '2e3xB00', NULL, NULL, 134, NULL, NULL, 233797),
(269506, '3g8kA00', NULL, NULL, 130, NULL, NULL, 233797),
(269507, '4wreA00', NULL, NULL, 148, NULL, NULL, 233797),
(269508, '5b1xA00', NULL, NULL, 134, NULL, NULL, 233797),
(269509, '5vc1A01', NULL, NULL, 119, NULL, NULL, 233797),
(269510, '2vuvA00', NULL, NULL, 129, NULL, NULL, 233797),
(269511, '2yhfA00', NULL, NULL, 118, NULL, NULL, 233797),
(269512, '1jwiB00', NULL, NULL, 125, NULL, NULL, 233797),
(269513, '3wbpA00', NULL, NULL, 129, NULL, NULL, 233797),
(269514, '5tznA00', NULL, NULL, 137, NULL, NULL, 233797),
(269515, '1jznA00', NULL, NULL, 135, NULL, NULL, 233797),
(269516, '1oz7B00', NULL, NULL, 123, NULL, NULL, 233797),
(269517, '4qkhA00', NULL, NULL, 135, NULL, NULL, 233797),
(269518, '1egiA00', NULL, NULL, 147, NULL, NULL, 233797),
(269519, '6bbdA00', NULL, NULL, 154, NULL, NULL, 233797),
(269520, '3c8jD00', NULL, NULL, 130, NULL, NULL, 233797);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(269521, '2ox9A00', NULL, NULL, 140, NULL, NULL, 233797),
(269522, '2bpdB00', NULL, NULL, 142, NULL, NULL, 233797),
(269523, '6e7dE00', NULL, NULL, 124, NULL, NULL, 233797),
(269524, '5m62A00', NULL, NULL, 151, NULL, NULL, 233797),
(269525, '3bx4A00', NULL, NULL, 136, NULL, NULL, 233797),
(269526, '1sb2B00', NULL, NULL, 129, NULL, NULL, 233797),
(269527, '2pf5D00', NULL, NULL, 98, NULL, NULL, 233797),
(269528, '5f2qA00', NULL, NULL, 135, NULL, NULL, 233797),
(269529, '1c3aA00', NULL, NULL, 135, NULL, NULL, 233797),
(269530, '1bnlA00', NULL, NULL, 178, NULL, NULL, 233797),
(269531, '1dy2A00', NULL, NULL, 180, NULL, NULL, 233797),
(269532, '3vppB00', NULL, NULL, 132, NULL, NULL, 233797),
(269533, '5ffsA00', NULL, NULL, 148, NULL, NULL, 233797),
(269534, '1wt9A00', NULL, NULL, 129, NULL, NULL, 233797),
(269535, '1wk1A01', NULL, NULL, 120, NULL, NULL, 233797),
(269536, '1v7pB00', NULL, NULL, 128, NULL, NULL, 233797),
(269537, '4ak8A00', NULL, NULL, 133, NULL, NULL, 233797),
(269538, '1cwvA05', NULL, NULL, 100, NULL, NULL, 233797),
(269539, '3ubuA00', NULL, NULL, 131, NULL, NULL, 233797),
(269540, '4m1gA00', NULL, NULL, 97, NULL, NULL, 233797),
(269541, '1ja3A00', NULL, NULL, 127, NULL, NULL, 233797),
(269542, '1g1sA01', NULL, NULL, 119, NULL, NULL, 233797),
(269543, '4pdcA00', NULL, NULL, 123, NULL, NULL, 233797),
(269544, '1fvuA00', NULL, NULL, 133, NULL, NULL, 233797),
(269545, '3fd4A00', NULL, NULL, 141, NULL, NULL, 233797),
(269546, '2e3xC00', NULL, NULL, 122, NULL, NULL, 233797),
(269547, '3cadB00', NULL, NULL, 125, NULL, NULL, 233797),
(269548, '3ff9A00', NULL, NULL, 115, NULL, NULL, 233797),
(269549, '3aluA00', NULL, NULL, 157, NULL, NULL, 233797),
(269550, '1jwiA00', NULL, NULL, 131, NULL, NULL, 233797),
(269551, '3ncxA02', NULL, NULL, 93, NULL, NULL, 233797),
(269552, '5mgsH00', NULL, NULL, 146, NULL, NULL, 233797),
(269553, '3bdwA00', NULL, NULL, 123, NULL, NULL, 233797),
(269554, '1g1tA01', NULL, NULL, 119, NULL, NULL, 233797),
(269555, '1j34A00', NULL, NULL, 129, NULL, NULL, 233797),
(269556, '1c3aB00', NULL, NULL, 125, NULL, NULL, 233797),
(269557, '5b1rA00', NULL, NULL, 127, NULL, NULL, 233797),
(269558, '3m9zA00', NULL, NULL, 139, NULL, NULL, 233797),
(269559, '4yliE00', NULL, NULL, 155, NULL, NULL, 233797),
(269560, '1hupA00', NULL, NULL, 141, NULL, NULL, 233797),
(269561, '1koeA00', NULL, NULL, 172, NULL, NULL, 233797),
(269562, '4mthA00', NULL, NULL, 139, NULL, NULL, 233797),
(269563, '4kzvA00', NULL, NULL, 134, NULL, NULL, 233797),
(269564, '2afpA00', NULL, NULL, 129, NULL, NULL, 233797),
(269565, '5j2sA00', NULL, NULL, 131, NULL, NULL, 233797),
(269566, '2xr6A00', NULL, NULL, 130, NULL, NULL, 233797),
(269567, '4iopA00', NULL, NULL, 142, NULL, NULL, 233797),
(269568, '3zhgA00', NULL, NULL, 135, NULL, NULL, 233797),
(269569, '2kv3A00', NULL, NULL, 131, NULL, NULL, 233797),
(269570, '1ukmA00', NULL, NULL, 134, NULL, NULL, 233797),
(269571, '1umrA00', NULL, NULL, 135, NULL, NULL, 233797),
(269572, '3whdA00', NULL, NULL, 156, NULL, NULL, 233797),
(269573, '5jq1A00', NULL, NULL, 145, NULL, NULL, 233797),
(269574, '1v4lB00', NULL, NULL, 125, NULL, NULL, 233797),
(269575, '1ixxA00', NULL, NULL, 129, NULL, NULL, 233797),
(269576, '1fvuB00', NULL, NULL, 125, NULL, NULL, 233797),
(269577, '1h8uB00', NULL, NULL, 117, NULL, NULL, 233797),
(269578, '1eslA00', NULL, NULL, 162, NULL, NULL, 233797),
(269579, '2c6uA00', NULL, NULL, 122, NULL, NULL, 233797),
(269580, '5vybA00', NULL, NULL, 147, NULL, NULL, 233797),
(269581, '1sl4A00', NULL, NULL, 135, NULL, NULL, 233797),
(269582, '1gz2A00', NULL, NULL, 142, NULL, NULL, 233797),
(269583, '1j34B00', NULL, NULL, 123, NULL, NULL, 233797),
(269584, '6nd8A00', NULL, NULL, 135, NULL, NULL, 233797),
(269585, '1wmzA00', NULL, NULL, 140, NULL, NULL, 233797),
(269586, '4pp8A00', NULL, NULL, 125, NULL, NULL, 233797),
(269587, '1kza100', NULL, NULL, 115, NULL, NULL, 233797),
(269588, '2zibA00', NULL, NULL, 133, NULL, NULL, 233797),
(269589, '1rjhA00', NULL, NULL, 118, NULL, NULL, 233797),
(269590, '3l9jC00', NULL, NULL, 134, NULL, NULL, 233797),
(269591, '1qo3C00', NULL, NULL, 137, NULL, NULL, 233797);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(269592, '3hupA00', NULL, NULL, 130, NULL, NULL, 233797),
(269593, '1y17A00', NULL, NULL, 129, NULL, NULL, 233797),
(269594, '4iopB00', NULL, NULL, 121, NULL, NULL, 233797),
(269595, '3bdwB00', NULL, NULL, 120, NULL, NULL, 233797),
(269596, '1tn3A00', NULL, NULL, 137, NULL, NULL, 233797),
(269597, '3wh3A00', NULL, NULL, 147, NULL, NULL, 233797),
(269598, '2ox8A00', NULL, NULL, 140, NULL, NULL, 233797),
(269599, '3vykA00', NULL, NULL, 129, NULL, NULL, 233797),
(269600, '2lc3A00', NULL, NULL, 88, NULL, NULL, 233798),
(269601, '2mphA01', NULL, NULL, 87, NULL, NULL, 233798),
(269602, '3wajA02', NULL, NULL, 168, NULL, NULL, 233799),
(269603, '3vu1A01', NULL, NULL, 164, NULL, NULL, 233799),
(269604, '3vu0B00', NULL, NULL, 162, NULL, NULL, 233799),
(269605, '3wovA01', NULL, NULL, 154, NULL, NULL, 233799),
(269606, '2zaiA01', NULL, NULL, 156, NULL, NULL, 233799),
(269607, '3vgpA00', NULL, NULL, 164, NULL, NULL, 233799),
(269608, '4h40A01', NULL, NULL, 182, NULL, NULL, 233800),
(269609, '1bcoA02', NULL, NULL, 68, NULL, NULL, 233801),
(269610, '2fokB01', NULL, NULL, 292, NULL, NULL, 233802),
(269611, '1lshA04', NULL, NULL, 251, NULL, NULL, 233803),
(269612, '2c0gA02', NULL, NULL, 112, NULL, NULL, 233804),
(269613, '5v8zC00', NULL, NULL, 106, NULL, NULL, 233804),
(269614, '1g7dA00', NULL, NULL, 106, NULL, NULL, 233804),
(269615, '1bpoA02', NULL, NULL, 162, NULL, NULL, 233805),
(269616, '3o2iA00', NULL, NULL, 101, NULL, NULL, 233806),
(269617, '3ihmA02', NULL, NULL, 144, NULL, NULL, 233807),
(269618, '2vqeP00', NULL, NULL, 88, NULL, NULL, 233808),
(269619, '1vs5P00', NULL, NULL, 82, NULL, NULL, 233808),
(269620, '5aj3P00', NULL, NULL, 135, NULL, NULL, 233808),
(269621, '6neqP00', NULL, NULL, 135, NULL, NULL, 233808),
(269622, '5mmjp00', NULL, NULL, 88, NULL, NULL, 233808),
(269623, '3bn0A00', NULL, NULL, 112, NULL, NULL, 233808),
(269624, '1fn9A01', NULL, NULL, 140, NULL, NULL, 233809),
(269625, '4tkdC00', NULL, NULL, 141, NULL, NULL, 233810),
(269626, '4qboA00', NULL, NULL, 92, NULL, NULL, 233810),
(269627, '1r0vA03', NULL, NULL, 92, NULL, NULL, 233810),
(269628, '2fcoA00', NULL, NULL, 171, NULL, NULL, 233810),
(269629, '2ostD00', NULL, NULL, 151, NULL, NULL, 233810),
(269630, '1r0vA01', NULL, NULL, 77, NULL, NULL, 233810),
(269631, '1rznA00', NULL, NULL, 173, NULL, NULL, 233810),
(269632, '2gw6A01', NULL, NULL, 116, NULL, NULL, 233810),
(269633, '2inbA00', NULL, NULL, 140, NULL, NULL, 233810),
(269634, '3ajvB02', NULL, NULL, 93, NULL, NULL, 233810),
(269635, '2wcwB00', NULL, NULL, 139, NULL, NULL, 233810),
(269636, '4f0qA02', NULL, NULL, 192, NULL, NULL, 233810),
(269637, '3ajvC02', NULL, NULL, 91, NULL, NULL, 233810),
(269638, '2okfA00', NULL, NULL, 140, NULL, NULL, 233810),
(269639, '1t0fA01', NULL, NULL, 162, NULL, NULL, 233810),
(269640, '1y88A01', NULL, NULL, 140, NULL, NULL, 233810),
(269641, '4oc8A02', NULL, NULL, 172, NULL, NULL, 233810),
(269642, '3ieyA02', NULL, NULL, 100, NULL, NULL, 233810),
(269643, '1a79A01', NULL, NULL, 100, NULL, NULL, 233810),
(269644, '2eo0B00', NULL, NULL, 147, NULL, NULL, 233810),
(269645, '4qblE00', NULL, NULL, 145, NULL, NULL, 233810),
(269646, '2cv8B02', NULL, NULL, 95, NULL, NULL, 233810),
(269647, '2zyzC00', NULL, NULL, 96, NULL, NULL, 233810),
(269648, '2zyzB02', NULL, NULL, 95, NULL, NULL, 233810),
(269649, '2vldA02', NULL, NULL, 114, NULL, NULL, 233810),
(269650, '1ob8B00', NULL, NULL, 135, NULL, NULL, 233810),
(269651, '4qbnA00', NULL, NULL, 93, NULL, NULL, 233810),
(269652, '3fovA00', NULL, NULL, 110, NULL, NULL, 233810),
(269653, '1gefA00', NULL, NULL, 123, NULL, NULL, 233810),
(269654, '5x89A03', NULL, NULL, 97, NULL, NULL, 233810),
(269655, '1xmxA02', NULL, NULL, 154, NULL, NULL, 233810),
(269656, '3k8pC01', NULL, NULL, 108, NULL, NULL, 233811),
(269657, '3efoB01', NULL, NULL, 154, NULL, NULL, 233812),
(269658, '3eh2C01', NULL, NULL, 151, NULL, NULL, 233812),
(269659, '1pcxA01', NULL, NULL, 164, NULL, NULL, 233812),
(269660, '1m2oA04', NULL, NULL, 151, NULL, NULL, 233812),
(269661, '2nutA04', NULL, NULL, 134, NULL, NULL, 233812),
(269662, '2nutB01', NULL, NULL, 163, NULL, NULL, 233812);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(269663, '3eh1A01', NULL, NULL, 160, NULL, NULL, 233812),
(269664, '1yqeA01', NULL, NULL, 186, NULL, NULL, 233813),
(269665, '2gfqB01', NULL, NULL, 192, NULL, NULL, 233813),
(269666, '3mzlB01', NULL, NULL, 46, NULL, NULL, 233814),
(269667, '2pm9A02', NULL, NULL, 31, NULL, NULL, 233814),
(269668, '1f2lA00', NULL, NULL, 76, NULL, NULL, 233815),
(269669, '2hdmA00', NULL, NULL, 74, NULL, NULL, 233815),
(269670, '5e4wC02', NULL, NULL, 58, NULL, NULL, 233815),
(269671, '2d9uA00', NULL, NULL, 74, NULL, NULL, 233815),
(269672, '3tn2A00', NULL, NULL, 68, NULL, NULL, 233815),
(269673, '3f2uA00', NULL, NULL, 55, NULL, NULL, 233815),
(269674, '1ha6A00', NULL, NULL, 70, NULL, NULL, 233815),
(269675, '4cj0B00', NULL, NULL, 81, NULL, NULL, 233815),
(269676, '1rjtA00', NULL, NULL, 73, NULL, NULL, 233815),
(269677, '5eplB00', NULL, NULL, 60, NULL, NULL, 233815),
(269678, '3n52A00', NULL, NULL, 73, NULL, NULL, 233815),
(269679, '3fdtA00', NULL, NULL, 59, NULL, NULL, 233815),
(269680, '1nr4C00', NULL, NULL, 71, NULL, NULL, 233815),
(269681, '2mgsA00', NULL, NULL, 78, NULL, NULL, 233815),
(269682, '4zltF00', NULL, NULL, 70, NULL, NULL, 233815),
(269683, '3tzdA00', NULL, NULL, 58, NULL, NULL, 233815),
(269684, '4iupB01', NULL, NULL, 62, NULL, NULL, 233815),
(269685, '4rwsC00', NULL, NULL, 80, NULL, NULL, 233815),
(269686, '5wb2B00', NULL, NULL, 76, NULL, NULL, 233815),
(269687, '5coyA00', NULL, NULL, 65, NULL, NULL, 233815),
(269688, '2h1eA02', NULL, NULL, 56, NULL, NULL, 233815),
(269689, '1ap0A00', NULL, NULL, 73, NULL, NULL, 233815),
(269690, '1eigA00', NULL, NULL, 73, NULL, NULL, 233815),
(269691, '2rvlA00', NULL, NULL, 83, NULL, NULL, 233815),
(269692, '2mp1A00', NULL, NULL, 77, NULL, NULL, 233815),
(269693, '2ffkB00', NULL, NULL, 69, NULL, NULL, 233815),
(269694, '1pfbA00', NULL, NULL, 55, NULL, NULL, 233815),
(269695, '5izbA00', NULL, NULL, 89, NULL, NULL, 233815),
(269696, '5afwA01', NULL, NULL, 93, NULL, NULL, 233815),
(269697, '2ra4A00', NULL, NULL, 76, NULL, NULL, 233815),
(269698, '5afwA02', NULL, NULL, 70, NULL, NULL, 233815),
(269699, '3kbxA00', NULL, NULL, 70, NULL, NULL, 233815),
(269700, '4oijA00', NULL, NULL, 74, NULL, NULL, 233815),
(269701, '1x3qA00', NULL, NULL, 57, NULL, NULL, 233815),
(269702, '2m2lA00', NULL, NULL, 67, NULL, NULL, 233815),
(269703, '4hsvA00', NULL, NULL, 71, NULL, NULL, 233815),
(269704, '1j8iA00', NULL, NULL, 93, NULL, NULL, 233815),
(269705, '3gv6A00', NULL, NULL, 58, NULL, NULL, 233815),
(269706, '5t1iA00', NULL, NULL, 68, NULL, NULL, 233815),
(269707, '1plfB00', NULL, NULL, 72, NULL, NULL, 233815),
(269708, '1xyiA00', NULL, NULL, 66, NULL, NULL, 233815),
(269709, '3i3cB00', NULL, NULL, 75, NULL, NULL, 233815),
(269710, '1g91A00', NULL, NULL, 77, NULL, NULL, 233815),
(269711, '5yamA00', NULL, NULL, 69, NULL, NULL, 233815),
(269712, '4zkcB00', NULL, NULL, 82, NULL, NULL, 233815),
(269713, '3deoA01', NULL, NULL, 37, NULL, NULL, 233815),
(269714, '3g7lA00', NULL, NULL, 61, NULL, NULL, 233815),
(269715, '3p7jB00', NULL, NULL, 68, NULL, NULL, 233815),
(269716, '3gv3A00', NULL, NULL, 63, NULL, NULL, 233815),
(269717, '4mheA00', NULL, NULL, 70, NULL, NULL, 233815),
(269718, '2h1eB01', NULL, NULL, 121, NULL, NULL, 233815),
(269719, '2dy7A00', NULL, NULL, 81, NULL, NULL, 233815),
(269720, '2fhtA00', NULL, NULL, 71, NULL, NULL, 233815),
(269721, '2ee1A00', NULL, NULL, 64, NULL, NULL, 233815),
(269722, '2q8rE00', NULL, NULL, 66, NULL, NULL, 233815),
(269723, '2b2tC00', NULL, NULL, 97, NULL, NULL, 233815),
(269724, '3ifdA00', NULL, NULL, 76, NULL, NULL, 233815),
(269725, '3ui2A03', NULL, NULL, 60, NULL, NULL, 233815),
(269726, '2mj8A00', NULL, NULL, 64, NULL, NULL, 233815),
(269727, '1g2sA00', NULL, NULL, 71, NULL, NULL, 233815),
(269728, '6ftoA00', NULL, NULL, 66, NULL, NULL, 233815),
(269729, '3d6wB01', NULL, NULL, 71, NULL, NULL, 233815),
(269730, '1x32A00', NULL, NULL, 47, NULL, NULL, 233815),
(269731, '1e0bA00', NULL, NULL, 68, NULL, NULL, 233815),
(269732, '2fmmD00', NULL, NULL, 74, NULL, NULL, 233815),
(269733, '1q3lA00', NULL, NULL, 69, NULL, NULL, 233815),
(269734, '5ekiC00', NULL, NULL, 79, NULL, NULL, 233815);
INSERT INTO "PUBLIC"."MODEL" VALUES
(269735, '4cj2C00', NULL, NULL, 78, NULL, NULL, 233815),
(269736, '1eotA00', NULL, NULL, 74, NULL, NULL, 233815),
(269737, '2epbA00', NULL, NULL, 68, NULL, NULL, 233815),
(269738, '5ltlA00', NULL, NULL, 78, NULL, NULL, 233815),
(269739, '1esrA00', NULL, NULL, 76, NULL, NULL, 233815),
(269740, '5ufqD00', NULL, NULL, 61, NULL, NULL, 233815),
(269741, '1qe6C00', NULL, NULL, 72, NULL, NULL, 233815),
(269742, '3lweA00', NULL, NULL, 62, NULL, NULL, 233815),
(269743, '1c8cA00', NULL, NULL, 64, NULL, NULL, 233815),
(269744, '2kumA01', NULL, NULL, 57, NULL, NULL, 233815),
(269745, '4u68A00', NULL, NULL, 75, NULL, NULL, 233815),
(269746, '5eq0A00', NULL, NULL, 55, NULL, NULL, 233815),
(269747, '1f9rA00', NULL, NULL, 70, NULL, NULL, 233815),
(269748, '3fpuB00', NULL, NULL, 70, NULL, NULL, 233815),
(269749, '3dm1E00', NULL, NULL, 58, NULL, NULL, 233815),
(269750, '1u4rB00', NULL, NULL, 68, NULL, NULL, 233815),
(269751, '4cj1B00', NULL, NULL, 81, NULL, NULL, 233815),
(269752, '4x3kA00', NULL, NULL, 64, NULL, NULL, 233815),
(269753, '1zxtA01', NULL, NULL, 61, NULL, NULL, 233815),
(269754, '2rsoA00', NULL, NULL, 92, NULL, NULL, 233815),
(269755, '1rodA00', NULL, NULL, 72, NULL, NULL, 233815),
(269756, '2xiwB00', NULL, NULL, 79, NULL, NULL, 233815),
(269757, '5cbeF00', NULL, NULL, 88, NULL, NULL, 233815),
(269758, '4hcsA00', NULL, NULL, 81, NULL, NULL, 233815),
(269759, '5uiwB00', NULL, NULL, 75, NULL, NULL, 233815),
(269760, '2vxwA00', NULL, NULL, 69, NULL, NULL, 233815),
(269761, '2r3zB00', NULL, NULL, 68, NULL, NULL, 233815),
(269762, '3mtsA00', NULL, NULL, 64, NULL, NULL, 233815),
(269763, '1f9qD00', NULL, NULL, 70, NULL, NULL, 233815),
(269764, '1msgA00', NULL, NULL, 72, NULL, NULL, 233815),
(269765, '1tvxA00', NULL, NULL, 75, NULL, NULL, 233815),
(269766, '2nyzE00', NULL, NULL, 72, NULL, NULL, 233815),
(269767, '2k01A00', NULL, NULL, 70, NULL, NULL, 233815),
(269768, '5ejwA00', NULL, NULL, 91, NULL, NULL, 233815),
(269769, '2n55A00', NULL, NULL, 70, NULL, NULL, 233815),
(269770, '3q6sA00', NULL, NULL, 78, NULL, NULL, 233815),
(269771, '2n88A00', NULL, NULL, 58, NULL, NULL, 233815),
(269772, '1o7zA00', NULL, NULL, 77, NULL, NULL, 233815),
(269773, '1pfmA00', NULL, NULL, 68, NULL, NULL, 233815),
(269774, '2hdlA00', NULL, NULL, 78, NULL, NULL, 233815),
(269775, '1g6zA00', NULL, NULL, 70, NULL, NULL, 233815),
(269776, '3h91A00', NULL, NULL, 54, NULL, NULL, 233815),
(269777, '5ob5A00', NULL, NULL, 63, NULL, NULL, 233815),
(269778, '4haeA00', NULL, NULL, 81, NULL, NULL, 233815),
(269779, '4xdxA00', NULL, NULL, 70, NULL, NULL, 233815),
(269780, '1eqtA00', NULL, NULL, 68, NULL, NULL, 233815),
(269781, '2hciB00', NULL, NULL, 69, NULL, NULL, 233815),
(269782, '5cbeE00', NULL, NULL, 69, NULL, NULL, 233815),
(269783, '2hccA00', NULL, NULL, 66, NULL, NULL, 233815),
(269784, '2qeaB00', NULL, NULL, 160, NULL, NULL, 233816),
(269785, '1rz1A00', NULL, NULL, 161, NULL, NULL, 233816),
(269786, '2iabA01', NULL, NULL, 143, NULL, NULL, 233816),
(269787, '3tgvA00', NULL, NULL, 148, NULL, NULL, 233816),
(269788, '4ybnB00', NULL, NULL, 224, NULL, NULL, 233816),
(269789, '3r5lA00', NULL, NULL, 122, NULL, NULL, 233816),
(269790, '3k86A00', NULL, NULL, 185, NULL, NULL, 233816),
(269791, '3bpkA01', NULL, NULL, 183, NULL, NULL, 233816),
(269792, '6h00A00', NULL, NULL, 211, NULL, NULL, 233816),
(269793, '4hmwA00', NULL, NULL, 215, NULL, NULL, 233816),
(269794, '3u35A00', NULL, NULL, 142, NULL, NULL, 233816),
(269795, '2rdeB01', NULL, NULL, 114, NULL, NULL, 233816),
(269796, '3gasB02', NULL, NULL, 179, NULL, NULL, 233816),
(269797, '3fkhD00', NULL, NULL, 138, NULL, NULL, 233816),
(269798, '2qckA01', NULL, NULL, 159, NULL, NULL, 233816),
(269799, '2a2jA00', NULL, NULL, 203, NULL, NULL, 233816),
(269800, '6eciP00', NULL, NULL, 132, NULL, NULL, 233816),
(269801, '4hmsA00', NULL, NULL, 202, NULL, NULL, 233816),
(269802, '2fhqA00', NULL, NULL, 141, NULL, NULL, 233816),
(269803, '3in6A02', NULL, NULL, 118, NULL, NULL, 233816),
(269804, '4ywnB00', NULL, NULL, 165, NULL, NULL, 233816),
(269805, '2hhzA00', NULL, NULL, 150, NULL, NULL, 233816);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(269806, '5jabA00', NULL, NULL, 135, NULL, NULL, 233816),
(269807, '2htdB00', NULL, NULL, 124, NULL, NULL, 233816),
(269808, '4y9iA00', NULL, NULL, 114, NULL, NULL, 233816),
(269809, '2aq6A00', NULL, NULL, 147, NULL, NULL, 233816),
(269810, '3f7eA00', NULL, NULL, 131, NULL, NULL, 233816),
(269811, '3a6rA00', NULL, NULL, 122, NULL, NULL, 233816),
(269812, '2hq7B00', NULL, NULL, 146, NULL, NULL, 233816),
(269813, '3r5yD00', NULL, NULL, 147, NULL, NULL, 233816),
(269814, '2i51B00', NULL, NULL, 195, NULL, NULL, 233816),
(269815, '5jv4A00', NULL, NULL, 154, NULL, NULL, 233816),
(269816, '2r6vA01', NULL, NULL, 164, NULL, NULL, 233816),
(269817, '3bnkA00', NULL, NULL, 196, NULL, NULL, 233816),
(269818, '3cb0D00', NULL, NULL, 173, NULL, NULL, 233816),
(269819, '2ou5A00', NULL, NULL, 175, NULL, NULL, 233816),
(269820, '1i0rA00', NULL, NULL, 169, NULL, NULL, 233816),
(269821, '3hmzA00', NULL, NULL, 199, NULL, NULL, 233816),
(269822, '2ig6A00', NULL, NULL, 150, NULL, NULL, 233816),
(269823, '3nfwA00', NULL, NULL, 186, NULL, NULL, 233816),
(269824, '4l82A00', NULL, NULL, 168, NULL, NULL, 233816),
(269825, '3r5zA00', NULL, NULL, 145, NULL, NULL, 233816),
(269826, '2htiA00', NULL, NULL, 166, NULL, NULL, 233816),
(269827, '1ci0B00', NULL, NULL, 204, NULL, NULL, 233816),
(269828, '3pftA00', NULL, NULL, 157, NULL, NULL, 233816),
(269829, '2ptfA01', NULL, NULL, 149, NULL, NULL, 233816),
(269830, '2imlA01', NULL, NULL, 115, NULL, NULL, 233816),
(269831, '2furB00', NULL, NULL, 190, NULL, NULL, 233816),
(269832, '4f07E00', NULL, NULL, 156, NULL, NULL, 233816),
(269833, '3h96C00', NULL, NULL, 143, NULL, NULL, 233816),
(269834, '1rfeA01', NULL, NULL, 136, NULL, NULL, 233816),
(269835, '2vpaA00', NULL, NULL, 216, NULL, NULL, 233816),
(269836, '2ecuA00', NULL, NULL, 149, NULL, NULL, 233816),
(269837, '2i02A00', NULL, NULL, 148, NULL, NULL, 233816),
(269838, '3b5mA01', NULL, NULL, 120, NULL, NULL, 233816),
(269839, '2d5mA00', NULL, NULL, 190, NULL, NULL, 233816),
(269840, '2nr4A01', NULL, NULL, 134, NULL, NULL, 233816),
(269841, '2fg9A01', NULL, NULL, 165, NULL, NULL, 233816),
(269842, '1yoaA00', NULL, NULL, 159, NULL, NULL, 233816),
(269843, '3in6B00', NULL, NULL, 148, NULL, NULL, 233816),
(269844, '5choF00', NULL, NULL, 164, NULL, NULL, 233816),
(269845, '2ol5A00', NULL, NULL, 202, NULL, NULL, 233816),
(269846, '3dnhA01', NULL, NULL, 173, NULL, NULL, 233816),
(269847, '2arzA01', NULL, NULL, 154, NULL, NULL, 233816),
(269848, '3u5wA00', NULL, NULL, 148, NULL, NULL, 233816),
(269849, '3cp3A00', NULL, NULL, 148, NULL, NULL, 233816),
(269850, '3ec6A00', NULL, NULL, 139, NULL, NULL, 233816),
(269851, '5bncB01', NULL, NULL, 159, NULL, NULL, 233816),
(269852, '2r0xA00', NULL, NULL, 158, NULL, NULL, 233816),
(269853, '3e4vA01', NULL, NULL, 177, NULL, NULL, 233816),
(269854, '2re7A00', NULL, NULL, 134, NULL, NULL, 233816),
(269855, '2hq9B00', NULL, NULL, 149, NULL, NULL, 233816),
(269856, '3ba3B00', NULL, NULL, 145, NULL, NULL, 233816),
(269857, '1dnlA00', NULL, NULL, 199, NULL, NULL, 233816),
(269858, '5escA00', NULL, NULL, 133, NULL, NULL, 233816),
(269859, '1wv4B00', NULL, NULL, 154, NULL, NULL, 233816),
(269860, '1vl7A00', NULL, NULL, 135, NULL, NULL, 233816),
(269861, '3swjA02', NULL, NULL, 171, NULL, NULL, 233816),
(269862, '3rh7B01', NULL, NULL, 171, NULL, NULL, 233816),
(269863, '2d37A00', NULL, NULL, 156, NULL, NULL, 233816),
(269864, '2q9kA00', NULL, NULL, 151, NULL, NULL, 233816),
(269865, '3kyfA01', NULL, NULL, 114, NULL, NULL, 233816),
(269866, '4r82B00', NULL, NULL, 185, NULL, NULL, 233816),
(269867, '5yjlD01', NULL, NULL, 142, NULL, NULL, 233816),
(269868, '1t9mA00', NULL, NULL, 214, NULL, NULL, 233816),
(269869, '3dmbA00', NULL, NULL, 147, NULL, NULL, 233816),
(269870, '1xhnA01', NULL, NULL, 168, NULL, NULL, 233816),
(269871, '3fgeA01', NULL, NULL, 175, NULL, NULL, 233816),
(269872, '1uscA00', NULL, NULL, 178, NULL, NULL, 233816),
(269873, '4xhyA00', NULL, NULL, 188, NULL, NULL, 233816),
(269874, '1ejeA00', NULL, NULL, 192, NULL, NULL, 233816),
(269875, '3db0B00', NULL, NULL, 128, NULL, NULL, 233816),
(269876, '4z85A00', NULL, NULL, 216, NULL, NULL, 233816);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(269877, '3vthA03', NULL, NULL, 119, NULL, NULL, 233817),
(269878, '3vtiA05', NULL, NULL, 119, NULL, NULL, 233817),
(269879, '3ttcA03', NULL, NULL, 121, NULL, NULL, 233817),
(269880, '2dlvA02', NULL, NULL, 80, NULL, NULL, 233818),
(269881, '1htjF00', NULL, NULL, 185, NULL, NULL, 233818),
(269882, '3v5wA02', NULL, NULL, 80, NULL, NULL, 233818),
(269883, '4pniA01', NULL, NULL, 211, NULL, NULL, 233818),
(269884, '2pbiA04', NULL, NULL, 157, NULL, NULL, 233818),
(269885, '2es0A00', NULL, NULL, 130, NULL, NULL, 233818),
(269886, '3c4zA01', NULL, NULL, 220, NULL, NULL, 233818),
(269887, '4gouA01', NULL, NULL, 152, NULL, NULL, 233818),
(269888, '2d9jA02', NULL, NULL, 79, NULL, NULL, 233818),
(269889, '2oj4A02', NULL, NULL, 80, NULL, NULL, 233818),
(269890, '2crpA02', NULL, NULL, 80, NULL, NULL, 233818),
(269891, '3pvuA02', NULL, NULL, 80, NULL, NULL, 233818),
(269892, '4wnkA01', NULL, NULL, 191, NULL, NULL, 233818),
(269893, '1agrE02', NULL, NULL, 80, NULL, NULL, 233818),
(269894, '2af0A02', NULL, NULL, 80, NULL, NULL, 233818),
(269895, '1cmzA02', NULL, NULL, 80, NULL, NULL, 233818),
(269896, '1fqjB02', NULL, NULL, 79, NULL, NULL, 233818),
(269897, '3ab3D00', NULL, NULL, 212, NULL, NULL, 233818),
(269898, '6n9gA04', NULL, NULL, 149, NULL, NULL, 233818),
(269899, '2a72A00', NULL, NULL, 146, NULL, NULL, 233818),
(269900, '4iguA00', NULL, NULL, 148, NULL, NULL, 233818),
(269901, '2i59A00', NULL, NULL, 138, NULL, NULL, 233818),
(269902, '2bv1A02', NULL, NULL, 79, NULL, NULL, 233818),
(269903, '3c4wB01', NULL, NULL, 213, NULL, NULL, 233818),
(269904, '3cx8B00', NULL, NULL, 203, NULL, NULL, 233818),
(269905, '4yhjB01', NULL, NULL, 213, NULL, NULL, 233818),
(269906, '2ebzA02', NULL, NULL, 81, NULL, NULL, 233818),
(269907, '2acxA01', NULL, NULL, 242, NULL, NULL, 233818),
(269908, '1dk8A02', NULL, NULL, 85, NULL, NULL, 233818),
(269909, '2ihbB02', NULL, NULL, 79, NULL, NULL, 233818),
(269910, '3c7lA02', NULL, NULL, 80, NULL, NULL, 233818),
(269911, '2jnuA02', NULL, NULL, 81, NULL, NULL, 233818),
(269912, '2bt2A02', NULL, NULL, 80, NULL, NULL, 233818),
(269913, '3nynA03', NULL, NULL, 81, NULL, NULL, 233818),
(269914, '2ihdA02', NULL, NULL, 80, NULL, NULL, 233818),
(269915, '6am3A00', NULL, NULL, 137, NULL, NULL, 233818),
(269916, '4tndA02', NULL, NULL, 80, NULL, NULL, 233818),
(269917, '4ak1A02', NULL, NULL, 121, NULL, NULL, 233819),
(269918, '5cqgA04', NULL, NULL, 106, NULL, NULL, 233820),
(269919, '4iyaA00', NULL, NULL, 292, NULL, NULL, 233821),
(269920, '1lkfA00', NULL, NULL, 299, NULL, NULL, 233821),
(269921, '4i0nA00', NULL, NULL, 289, NULL, NULL, 233821),
(269922, '4p1xH00', NULL, NULL, 275, NULL, NULL, 233821),
(269923, '1pvlA00', NULL, NULL, 301, NULL, NULL, 233821),
(269924, '7ahlF01', NULL, NULL, 292, NULL, NULL, 233821),
(269925, '4tw1B00', NULL, NULL, 290, NULL, NULL, 233821),
(269926, '4q7gA00', NULL, NULL, 301, NULL, NULL, 233821),
(269927, '3o44A01', NULL, NULL, 284, NULL, NULL, 233821),
(269928, '3b07B00', NULL, NULL, 270, NULL, NULL, 233821),
(269929, '3rohA00', NULL, NULL, 282, NULL, NULL, 233821),
(269930, '4tw1A00', NULL, NULL, 294, NULL, NULL, 233821),
(269931, '2ygtA00', NULL, NULL, 298, NULL, NULL, 233821),
(269932, '3pubA01', NULL, NULL, 79, NULL, NULL, 233822),
(269933, '1yueA02', NULL, NULL, 80, NULL, NULL, 233823),
(269934, '3oqgB00', NULL, NULL, 180, NULL, NULL, 233824),
(269935, '3hpxA02', NULL, NULL, 67, NULL, NULL, 233825),
(269936, '3hq1B02', NULL, NULL, 61, NULL, NULL, 233825),
(269937, '2zf8A01', NULL, NULL, 154, NULL, NULL, 233826),
(269938, '1y9lA00', NULL, NULL, 115, NULL, NULL, 233827),
(269939, '3f6gA01', NULL, NULL, 58, NULL, NULL, 233828),
(269940, '3tqnB02', NULL, NULL, 38, NULL, NULL, 233829),
(269941, '1av1A00', NULL, NULL, 201, NULL, NULL, 233830),
(269942, '4fcaA04', NULL, NULL, 78, NULL, NULL, 233831),
(269943, '2llvA00', NULL, NULL, 71, NULL, NULL, 233832),
(269944, '2llwA00', NULL, NULL, 71, NULL, NULL, 233832),
(269945, '2lnmA00', NULL, NULL, 62, NULL, NULL, 233832),
(269946, '4eqaC00', NULL, NULL, 153, NULL, NULL, 233833),
(269947, '3ckdA02', NULL, NULL, 134, NULL, NULL, 233834);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(269948, '3ub0A02', NULL, NULL, 95, NULL, NULL, 233835),
(269949, '2ahmH02', NULL, NULL, 99, NULL, NULL, 233835),
(269950, '4fxkB02', NULL, NULL, 58, NULL, NULL, 233836),
(269951, '3hrzB01', NULL, NULL, 80, NULL, NULL, 233836),
(269952, '2qkiE01', NULL, NULL, 79, NULL, NULL, 233836),
(269953, '5fo8B01', NULL, NULL, 62, NULL, NULL, 233836),
(269954, '2b39A06', NULL, NULL, 124, NULL, NULL, 233836),
(269955, '3cu7A06', NULL, NULL, 111, NULL, NULL, 233836),
(269956, '2pn5A06', NULL, NULL, 94, NULL, NULL, 233836),
(269957, '4p02B04', NULL, NULL, 171, NULL, NULL, 233837),
(269958, '1xneA00', NULL, NULL, 113, NULL, NULL, 233838),
(269959, '1s04A00', NULL, NULL, 110, NULL, NULL, 233838),
(269960, '1te7A00', NULL, NULL, 103, NULL, NULL, 233838),
(269961, '2z0tB00', NULL, NULL, 109, NULL, NULL, 233838),
(269962, '2dp9A01', NULL, NULL, 100, NULL, NULL, 233838),
(269963, '2kkuA00', NULL, NULL, 139, NULL, NULL, 233838),
(269964, '3iuwB00', NULL, NULL, 83, NULL, NULL, 233838),
(269965, '1nr3A00', NULL, NULL, 122, NULL, NULL, 233839),
(269966, '1p65A00', NULL, NULL, 73, NULL, NULL, 233840),
(269967, '2i9fB00', NULL, NULL, 69, NULL, NULL, 233840),
(269968, '3i2kA02', NULL, NULL, 95, NULL, NULL, 233841),
(269969, '2b9vA02', NULL, NULL, 76, NULL, NULL, 233841),
(269970, '4pf1A02', NULL, NULL, 68, NULL, NULL, 233841),
(269971, '1mpxA02', NULL, NULL, 67, NULL, NULL, 233841),
(269972, '1bg5A03', NULL, NULL, 41, NULL, NULL, 233842),
(269973, '1rajA01', NULL, NULL, 44, NULL, NULL, 233843),
(269974, '1rdrA01', NULL, NULL, 71, NULL, NULL, 233843),
(269975, '2retC00', NULL, NULL, 103, NULL, NULL, 233844),
(269976, '2retE00', NULL, NULL, 103, NULL, NULL, 233844),
(269977, '2retA00', NULL, NULL, 103, NULL, NULL, 233844),
(269978, '5bw0F00', NULL, NULL, 94, NULL, NULL, 233844),
(269979, '3ci0K01', NULL, NULL, 115, NULL, NULL, 233844),
(269980, '2gr7A00', NULL, NULL, 101, NULL, NULL, 233844),
(269981, '3cfiJ00', NULL, NULL, 84, NULL, NULL, 233844),
(269982, '2retG00', NULL, NULL, 87, NULL, NULL, 233844),
(269983, '2gr8A00', NULL, NULL, 78, NULL, NULL, 233844),
(269984, '2lmeA00', NULL, NULL, 105, NULL, NULL, 233844),
(269985, '3ci0I00', NULL, NULL, 89, NULL, NULL, 233844),
(269986, '4d8mA03', NULL, NULL, 199, NULL, NULL, 233845),
(269987, '3l7iA01', NULL, NULL, 232, NULL, NULL, 233846),
(269988, '2l7xA00', NULL, NULL, 77, NULL, NULL, 233847),
(269989, '2k9hA00', NULL, NULL, 57, NULL, NULL, 233847),
(269990, '2cjaA01', NULL, NULL, 182, NULL, NULL, 233848),
(269991, '3w3sA01', NULL, NULL, 169, NULL, NULL, 233848),
(269992, '3tquA00', NULL, NULL, 203, NULL, NULL, 233849),
(269993, '1b78A00', NULL, NULL, 193, NULL, NULL, 233849),
(269994, '4oo0B00', NULL, NULL, 204, NULL, NULL, 233849),
(269995, '4p0eB00', NULL, NULL, 189, NULL, NULL, 233849),
(269996, '1u5wC00', NULL, NULL, 184, NULL, NULL, 233849),
(269997, '1v7rA00', NULL, NULL, 186, NULL, NULL, 233849),
(269998, '1ex2A00', NULL, NULL, 189, NULL, NULL, 233849),
(269999, '4bnqB00', NULL, NULL, 195, NULL, NULL, 233849),
(270000, '2carB00', NULL, NULL, 196, NULL, NULL, 233849),
(270001, '1k7kA00', NULL, NULL, 221, NULL, NULL, 233849),
(270002, '1vp2A00', NULL, NULL, 208, NULL, NULL, 233849),
(270003, '2p5xB00', NULL, NULL, 204, NULL, NULL, 233849),
(270004, '1u14A00', NULL, NULL, 172, NULL, NULL, 233849),
(270005, '2amhA00', NULL, NULL, 207, NULL, NULL, 233849),
(270006, '1zwyD00', NULL, NULL, 185, NULL, NULL, 233849),
(270007, '4jhcB00', NULL, NULL, 193, NULL, NULL, 233849),
(270008, '1n7vA03', NULL, NULL, 254, NULL, NULL, 233850),
(270009, '1d7cA00', NULL, NULL, 190, NULL, NULL, 233851),
(270010, '4qi3A00', NULL, NULL, 208, NULL, NULL, 233851),
(270011, '4cfsA02', NULL, NULL, 70, NULL, NULL, 233852),
(270012, '3ibtA02', NULL, NULL, 69, NULL, NULL, 233852),
(270013, '3nbhA01', NULL, NULL, 84, NULL, NULL, 233853),
(270014, '3mxnA01', NULL, NULL, 86, NULL, NULL, 233853),
(270015, '2pfdA01', NULL, NULL, 181, NULL, NULL, 233854),
(270016, '1qd1A01', NULL, NULL, 180, NULL, NULL, 233854),
(270017, '2d42A02', NULL, NULL, 65, NULL, NULL, 233855),
(270018, '1dc1A02', NULL, NULL, 88, NULL, NULL, 233856);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(270019, '3e8tA00', NULL, NULL, 220, NULL, NULL, 233857),
(270020, '3aosA00', NULL, NULL, 227, NULL, NULL, 233857),
(270021, '2rckA01', NULL, NULL, 222, NULL, NULL, 233857),
(270022, '4bk0A01', NULL, NULL, 64, NULL, NULL, 233858),
(270023, '4iajC00', NULL, NULL, 78, NULL, NULL, 233859),
(270024, '2iqcA00', NULL, NULL, 210, NULL, NULL, 233860),
(270025, '1ciiA01', NULL, NULL, 344, NULL, NULL, 233861),
(270026, '1vjqA00', NULL, NULL, 79, NULL, NULL, 233862),
(270027, '3dgvA01', NULL, NULL, 92, NULL, NULL, 233862),
(270028, '1jqgA01', NULL, NULL, 91, NULL, NULL, 233862),
(270029, '1pytA00', NULL, NULL, 94, NULL, NULL, 233862),
(270030, '1ayeA01', NULL, NULL, 99, NULL, NULL, 233862),
(270031, '1o6xA00', NULL, NULL, 81, NULL, NULL, 233862),
(270032, '4p10A01', NULL, NULL, 92, NULL, NULL, 233862),
(270033, '2gjfA00', NULL, NULL, 78, NULL, NULL, 233862),
(270034, '4uf4A01', NULL, NULL, 89, NULL, NULL, 233862),
(270035, '3gljA01', NULL, NULL, 98, NULL, NULL, 233862),
(270036, '1pcaA01', NULL, NULL, 93, NULL, NULL, 233862),
(270037, '1kwmA01', NULL, NULL, 88, NULL, NULL, 233862),
(270038, '2boaA01', NULL, NULL, 100, NULL, NULL, 233862),
(270039, '1nsaA01', NULL, NULL, 92, NULL, NULL, 233862),
(270040, '2hzmG01', NULL, NULL, 123, NULL, NULL, 233863),
(270041, '4xbmA01', NULL, NULL, 159, NULL, NULL, 233864),
(270042, '4cc0A01', NULL, NULL, 156, NULL, NULL, 233864),
(270043, '2a3lA02', NULL, NULL, 91, NULL, NULL, 233865),
(270044, '5uz0A04', NULL, NULL, 43, NULL, NULL, 233866),
(270045, '1thzA01', NULL, NULL, 43, NULL, NULL, 233866),
(270046, '1b25A03', NULL, NULL, 221, NULL, NULL, 233867),
(270047, '1aorA03', NULL, NULL, 207, NULL, NULL, 233867),
(270048, '2o2zB00', NULL, NULL, 323, NULL, NULL, 233868),
(270049, '2p0yA00', NULL, NULL, 341, NULL, NULL, 233868),
(270050, '2q7xA00', NULL, NULL, 326, NULL, NULL, 233868),
(270051, '2ppvA00', NULL, NULL, 332, NULL, NULL, 233868),
(270052, '3c3dA01', NULL, NULL, 223, NULL, NULL, 233868),
(270053, '2q7xB00', NULL, NULL, 326, NULL, NULL, 233868),
(270054, '1m9oA00', NULL, NULL, 43, NULL, NULL, 233869),
(270055, '2d9nA00', NULL, NULL, 77, NULL, NULL, 233869),
(270056, '2rhkD00', NULL, NULL, 72, NULL, NULL, 233869),
(270057, '4kisA01', NULL, NULL, 124, NULL, NULL, 233870),
(270058, '4bqqB02', NULL, NULL, 221, NULL, NULL, 233870),
(270059, '6qv7A00', NULL, NULL, 318, NULL, NULL, 233871),
(270060, '1pzwA00', NULL, NULL, 80, NULL, NULL, 233872),
(270061, '3thtA02', NULL, NULL, 146, NULL, NULL, 233873),
(270062, '1q4gA02', NULL, NULL, 510, NULL, NULL, 233874),
(270063, '5fiwC00', NULL, NULL, 466, NULL, NULL, 233874),
(270064, '3q9kA00', NULL, NULL, 595, NULL, NULL, 233874),
(270065, '3nt1A02', NULL, NULL, 511, NULL, NULL, 233874),
(270066, '5mfaA00', NULL, NULL, 589, NULL, NULL, 233874),
(270067, '4hhrA01', NULL, NULL, 614, NULL, NULL, 233874),
(270068, '5f19A02', NULL, NULL, 511, NULL, NULL, 233874),
(270069, '4kvlA00', NULL, NULL, 621, NULL, NULL, 233874),
(270070, '3f2bA05', NULL, NULL, 48, NULL, NULL, 233875),
(270071, '2va0B00', NULL, NULL, 131, NULL, NULL, 233876),
(270072, '2va0A00', NULL, NULL, 105, NULL, NULL, 233876),
(270073, '3lmmC03', NULL, NULL, 171, NULL, NULL, 233877),
(270074, '3i0nA03', NULL, NULL, 107, NULL, NULL, 233878),
(270075, '3i0nB03', NULL, NULL, 107, NULL, NULL, 233878),
(270076, '3hufB03', NULL, NULL, 108, NULL, NULL, 233878),
(270077, '4pwqA01', NULL, NULL, 107, NULL, NULL, 233879),
(270078, '2de3A02', NULL, NULL, 153, NULL, NULL, 233880),
(270079, '1ybkA00', NULL, NULL, 52, NULL, NULL, 233881),
(270080, '4o8uA00', NULL, NULL, 229, NULL, NULL, 233882),
(270081, '4yorB00', NULL, NULL, 229, NULL, NULL, 233882),
(270082, '1t23A00', NULL, NULL, 93, NULL, NULL, 233883),
(270083, '4dt4A02', NULL, NULL, 57, NULL, NULL, 233884),
(270084, '5i7pA02', NULL, NULL, 48, NULL, NULL, 233884),
(270085, '3prbA02', NULL, NULL, 44, NULL, NULL, 233884),
(270086, '2kr7A02', NULL, NULL, 57, NULL, NULL, 233884),
(270087, '5jzeA00', NULL, NULL, 159, NULL, NULL, 233885),
(270088, '4hxdB00', NULL, NULL, 157, NULL, NULL, 233885),
(270089, '4bopB00', NULL, NULL, 151, NULL, NULL, 233885);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(270090, '5v5hA00', NULL, NULL, 174, NULL, NULL, 233885),
(270091, '4bouA00', NULL, NULL, 141, NULL, NULL, 233885),
(270092, '3prmA00', NULL, NULL, 162, NULL, NULL, 233885),
(270093, '3tmpA01', NULL, NULL, 160, NULL, NULL, 233885),
(270094, '3by4A00', NULL, NULL, 174, NULL, NULL, 233885),
(270095, '4boqA00', NULL, NULL, 183, NULL, NULL, 233885),
(270096, '2cwoA01', NULL, NULL, 86, NULL, NULL, 233886),
(270097, '3emfB00', NULL, NULL, 116, NULL, NULL, 233887),
(270098, '1s7mA02', NULL, NULL, 90, NULL, NULL, 233887),
(270099, '3emiA00', NULL, NULL, 116, NULL, NULL, 233887),
(270100, '1j09A04', NULL, NULL, 48, NULL, NULL, 233888),
(270101, '2cfoA04', NULL, NULL, 54, NULL, NULL, 233888),
(270102, '3afhA04', NULL, NULL, 50, NULL, NULL, 233888),
(270103, '4griA04', NULL, NULL, 53, NULL, NULL, 233888),
(270104, '2o5rA04', NULL, NULL, 48, NULL, NULL, 233888),
(270105, '2ja2A04', NULL, NULL, 52, NULL, NULL, 233888),
(270106, '2ls0101', NULL, NULL, 114, NULL, NULL, 233889),
(270107, '2yadA00', NULL, NULL, 76, NULL, NULL, 233890),
(270108, '2yadD00', NULL, NULL, 79, NULL, NULL, 233890),
(270109, '2yadB00', NULL, NULL, 109, NULL, NULL, 233890),
(270110, '1mkcA00', NULL, NULL, 43, NULL, NULL, 233891),
(270111, '4gnsA01', NULL, NULL, 27, NULL, NULL, 233892),
(270112, '3kyqA02', NULL, NULL, 58, NULL, NULL, 233892),
(270113, '1t3jA00', NULL, NULL, 62, NULL, NULL, 233892),
(270114, '4jf7A01', NULL, NULL, 50, NULL, NULL, 233892),
(270115, '4w7zC00', NULL, NULL, 64, NULL, NULL, 233892),
(270116, '2kogA00', NULL, NULL, 119, NULL, NULL, 233892),
(270117, '1urqB00', NULL, NULL, 75, NULL, NULL, 233892),
(270118, '3zdoC00', NULL, NULL, 84, NULL, NULL, 233892),
(270119, '1jthB00', NULL, NULL, 77, NULL, NULL, 233892),
(270120, '3b5nL00', NULL, NULL, 64, NULL, NULL, 233892),
(270121, '3b5nJ00', NULL, NULL, 69, NULL, NULL, 233892),
(270122, '4oh8B00', NULL, NULL, 55, NULL, NULL, 233892),
(270123, '1l4aD00', NULL, NULL, 87, NULL, NULL, 233892),
(270124, '3htkB00', NULL, NULL, 73, NULL, NULL, 233892),
(270125, '1l4aB00', NULL, NULL, 88, NULL, NULL, 233892),
(270126, '3pp5A01', NULL, NULL, 68, NULL, NULL, 233892),
(270127, '2npsC00', NULL, NULL, 81, NULL, NULL, 233892),
(270128, '1n7sA00', NULL, NULL, 63, NULL, NULL, 233892),
(270129, '3hd7E00', NULL, NULL, 91, NULL, NULL, 233892),
(270130, '2npsA00', NULL, NULL, 74, NULL, NULL, 233892),
(270131, '4w7yA00', NULL, NULL, 64, NULL, NULL, 233892),
(270132, '4wy4D00', NULL, NULL, 65, NULL, NULL, 233892),
(270133, '4wy4B00', NULL, NULL, 58, NULL, NULL, 233892),
(270134, '1urqC00', NULL, NULL, 80, NULL, NULL, 233892),
(270135, '3vopC00', NULL, NULL, 43, NULL, NULL, 233892),
(270136, '3u5iL02', NULL, NULL, 44, NULL, NULL, 233892),
(270137, '1gl2C00', NULL, NULL, 65, NULL, NULL, 233892),
(270138, '1vwxL02', NULL, NULL, 46, NULL, NULL, 233892),
(270139, '1gl2A00', NULL, NULL, 65, NULL, NULL, 233892),
(270140, '3p8cE01', NULL, NULL, 68, NULL, NULL, 233892),
(270141, '4jf7B01', NULL, NULL, 65, NULL, NULL, 233892),
(270142, '3m0dC00', NULL, NULL, 65, NULL, NULL, 233892),
(270143, '2ymyB00', NULL, NULL, 46, NULL, NULL, 233892),
(270144, '1urqA00', NULL, NULL, 63, NULL, NULL, 233892),
(270145, '3zdoB00', NULL, NULL, 67, NULL, NULL, 233892),
(270146, '1jthA00', NULL, NULL, 82, NULL, NULL, 233892),
(270147, '1sfcH00', NULL, NULL, 87, NULL, NULL, 233892),
(270148, '2xdjF00', NULL, NULL, 64, NULL, NULL, 233892),
(270149, '3b5nK00', NULL, NULL, 70, NULL, NULL, 233892),
(270150, '2xdjB00', NULL, NULL, 83, NULL, NULL, 233892),
(270151, '3ojaB02', NULL, NULL, 49, NULL, NULL, 233892),
(270152, '3rk2C00', NULL, NULL, 81, NULL, NULL, 233892),
(270153, '1l4aC00', NULL, NULL, 83, NULL, NULL, 233892),
(270154, '1l4aA00', NULL, NULL, 80, NULL, NULL, 233892),
(270155, '2pp6A01', NULL, NULL, 24, NULL, NULL, 233892),
(270156, '2npsD00', NULL, NULL, 65, NULL, NULL, 233892),
(270157, '1n7sD00', NULL, NULL, 66, NULL, NULL, 233892),
(270158, '3hd7B00', NULL, NULL, 109, NULL, NULL, 233892),
(270159, '1n7sB00', NULL, NULL, 68, NULL, NULL, 233892),
(270160, '3b5nE00', NULL, NULL, 61, NULL, NULL, 233892),
(270161, '2h8pD00', NULL, NULL, 43, NULL, NULL, 233892);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(270162, '4w7yB00', NULL, NULL, 64, NULL, NULL, 233892),
(270163, '2npsB00', NULL, NULL, 71, NULL, NULL, 233892),
(270164, '1nhlA00', NULL, NULL, 54, NULL, NULL, 233892),
(270165, '1urqD00', NULL, NULL, 69, NULL, NULL, 233892),
(270166, '4wy4C00', NULL, NULL, 78, NULL, NULL, 233892),
(270167, '4wy4A00', NULL, NULL, 64, NULL, NULL, 233892),
(270168, '1gl2D00', NULL, NULL, 65, NULL, NULL, 233892),
(270169, '1gl2B00', NULL, NULL, 65, NULL, NULL, 233892),
(270170, '4fqgA01', NULL, NULL, 62, NULL, NULL, 233893),
(270171, '4fqgA02', NULL, NULL, 61, NULL, NULL, 233893),
(270172, '2cqnA00', NULL, NULL, 77, NULL, NULL, 233893),
(270173, '2lksA00', NULL, NULL, 50, NULL, NULL, 233893),
(270174, '4fqgB03', NULL, NULL, 67, NULL, NULL, 233893),
(270175, '1uzcA00', NULL, NULL, 71, NULL, NULL, 233893),
(270176, '2kiqA00', NULL, NULL, 62, NULL, NULL, 233893),
(270177, '2b7eA00', NULL, NULL, 59, NULL, NULL, 233893),
(270178, '2jucA00', NULL, NULL, 59, NULL, NULL, 233893),
(270179, '2kfdA00', NULL, NULL, 69, NULL, NULL, 233893),
(270180, '2kisA00', NULL, NULL, 71, NULL, NULL, 233893),
(270181, '2k85A00', NULL, NULL, 69, NULL, NULL, 233893),
(270182, '2e71A00', NULL, NULL, 83, NULL, NULL, 233893),
(270183, '2dodA00', NULL, NULL, 82, NULL, NULL, 233893),
(270184, '2doeA00', NULL, NULL, 83, NULL, NULL, 233893),
(270185, '2dofA00', NULL, NULL, 85, NULL, NULL, 233893),
(270186, '3c8iA00', NULL, NULL, 141, NULL, NULL, 233894),
(270187, '3v0rA01', NULL, NULL, 120, NULL, NULL, 233895),
(270188, '2id0A02', NULL, NULL, 73, NULL, NULL, 233896),
(270189, '4ia6A02', NULL, NULL, 145, NULL, NULL, 233897),
(270190, '4uirA02', NULL, NULL, 141, NULL, NULL, 233897),
(270191, '4v19700', NULL, NULL, 46, NULL, NULL, 233898),
(270192, '5xym200', NULL, NULL, 47, NULL, NULL, 233898),
(270193, '5dm6200', NULL, NULL, 47, NULL, NULL, 233898),
(270194, '1vw4Y00', NULL, NULL, 45, NULL, NULL, 233898),
(270195, '6quld00', NULL, NULL, 46, NULL, NULL, 233898),
(270196, '3kir700', NULL, NULL, 49, NULL, NULL, 233898),
(270197, '5v7q200', NULL, NULL, 47, NULL, NULL, 233898),
(270198, '6hma200', NULL, NULL, 43, NULL, NULL, 233898),
(270199, '5ool200', NULL, NULL, 45, NULL, NULL, 233898),
(270200, '5x8t300', NULL, NULL, 61, NULL, NULL, 233898),
(270201, '4fvmA04', NULL, NULL, 46, NULL, NULL, 233899),
(270202, '3l2dB01', NULL, NULL, 113, NULL, NULL, 233900),
(270203, '1qh4A01', NULL, NULL, 97, NULL, NULL, 233900),
(270204, '3ju5A01', NULL, NULL, 93, NULL, NULL, 233900),
(270205, '4z9mC01', NULL, NULL, 96, NULL, NULL, 233900),
(270206, '3jpzA01', NULL, NULL, 89, NULL, NULL, 233900),
(270207, '1u6rA01', NULL, NULL, 101, NULL, NULL, 233900),
(270208, '1i0eA01', NULL, NULL, 102, NULL, NULL, 233900),
(270209, '5u92A01', NULL, NULL, 95, NULL, NULL, 233900),
(270210, '1vrpB01', NULL, NULL, 102, NULL, NULL, 233900),
(270211, '4q2rA01', NULL, NULL, 102, NULL, NULL, 233900),
(270212, '2j1qA01', NULL, NULL, 95, NULL, NULL, 233900),
(270213, '1crkA01', NULL, NULL, 98, NULL, NULL, 233900),
(270214, '3l2eA01', NULL, NULL, 97, NULL, NULL, 233900),
(270215, '3l2dA01', NULL, NULL, 90, NULL, NULL, 233900),
(270216, '4am1A01', NULL, NULL, 95, NULL, NULL, 233900),
(270217, '3b6rA01', NULL, NULL, 102, NULL, NULL, 233900),
(270218, '5zhqA01', NULL, NULL, 95, NULL, NULL, 233900),
(270219, '4rf6A03', NULL, NULL, 86, NULL, NULL, 233900),
(270220, '4rf6A01', NULL, NULL, 105, NULL, NULL, 233900),
(270221, '1qk1A01', NULL, NULL, 98, NULL, NULL, 233900),
(270222, '1m15A01', NULL, NULL, 95, NULL, NULL, 233900),
(270223, '3k93A00', NULL, NULL, 223, NULL, NULL, 233901),
(270224, '1w36B05', NULL, NULL, 292, NULL, NULL, 233901),
(270225, '3h4rA00', NULL, NULL, 231, NULL, NULL, 233901),
(270226, '3sm4A00', NULL, NULL, 229, NULL, NULL, 233901),
(270227, '4ic1D00', NULL, NULL, 206, NULL, NULL, 233901),
(270228, '5ld2B05', NULL, NULL, 291, NULL, NULL, 233901),
(270229, '4r5qA00', NULL, NULL, 216, NULL, NULL, 233901),
(270230, '3l0aA00', NULL, NULL, 266, NULL, NULL, 233901),
(270231, '3syyA00', NULL, NULL, 216, NULL, NULL, 233901),
(270232, '3u4qA06', NULL, NULL, 244, NULL, NULL, 233901);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(270233, '3fbxA00', NULL, NULL, 543, NULL, NULL, 233902),
(270234, '1o5yA00', NULL, NULL, 162, NULL, NULL, 233903),
(270235, '1vjlA00', NULL, NULL, 164, NULL, NULL, 233903),
(270236, '1tulA00', NULL, NULL, 108, NULL, NULL, 233904),
(270237, '1jyoE00', NULL, NULL, 105, NULL, NULL, 233905),
(270238, '2endA00', NULL, NULL, 138, NULL, NULL, 233906),
(270239, '3c9iA02', NULL, NULL, 77, NULL, NULL, 233907),
(270240, '5bu5A02', NULL, NULL, 77, NULL, NULL, 233907),
(270241, '4by6A01', NULL, NULL, 280, NULL, NULL, 233908),
(270242, '4c0eB01', NULL, NULL, 299, NULL, NULL, 233908),
(270243, '2zwsA02', NULL, NULL, 135, NULL, NULL, 233909),
(270244, '4wgkA02', NULL, NULL, 145, NULL, NULL, 233909),
(270245, '2jx4A01', NULL, NULL, 50, NULL, NULL, 233910),
(270246, '2in5A00', NULL, NULL, 207, NULL, NULL, 233911),
(270247, '3tbiA00', NULL, NULL, 81, NULL, NULL, 233912),
(270248, '6hr7A02', NULL, NULL, 211, NULL, NULL, 233913),
(270249, '3qaeA01', NULL, NULL, 260, NULL, NULL, 233913),
(270250, '4i6yB01', NULL, NULL, 260, NULL, NULL, 233913),
(270251, '2r4fA02', NULL, NULL, 221, NULL, NULL, 233913),
(270252, '1kyqA02', NULL, NULL, 37, NULL, NULL, 233914),
(270253, '3c6mC01', NULL, NULL, 57, NULL, NULL, 233914),
(270254, '3c6kA01', NULL, NULL, 114, NULL, NULL, 233914),
(270255, '1pjqA02', NULL, NULL, 36, NULL, NULL, 233914),
(270256, '3c6mD01', NULL, NULL, 35, NULL, NULL, 233914),
(270257, '1k1fD00', NULL, NULL, 72, NULL, NULL, 233915),
(270258, '2w9rA00', NULL, NULL, 108, NULL, NULL, 233916),
(270259, '3dnjA00', NULL, NULL, 85, NULL, NULL, 233916),
(270260, '3o1fA00', NULL, NULL, 81, NULL, NULL, 233916),
(270261, '4kbue02', NULL, NULL, 63, NULL, NULL, 233916),
(270262, '4yjmC00', NULL, NULL, 84, NULL, NULL, 233916),
(270263, '1dd3A02', NULL, NULL, 71, NULL, NULL, 233916),
(270264, '1ctfA00', NULL, NULL, 74, NULL, NULL, 233916),
(270265, '1ng7A00', NULL, NULL, 60, NULL, NULL, 233917),
(270266, '3vejB00', NULL, NULL, 41, NULL, NULL, 233918),
(270267, '2lo0A00', NULL, NULL, 45, NULL, NULL, 233918),
(270268, '1p32B00', NULL, NULL, 209, NULL, NULL, 233919),
(270269, '1yqfB00', NULL, NULL, 182, NULL, NULL, 233919),
(270270, '3jv1A00', NULL, NULL, 182, NULL, NULL, 233919),
(270271, '3qv0A00', NULL, NULL, 227, NULL, NULL, 233919),
(270272, '1tkeA03', NULL, NULL, 58, NULL, NULL, 233920),
(270273, '2ztgA05', NULL, NULL, 55, NULL, NULL, 233920),
(270274, '2zzeB05', NULL, NULL, 56, NULL, NULL, 233920),
(270275, '2zzfA05', NULL, NULL, 56, NULL, NULL, 233920),
(270276, '1v4pA02', NULL, NULL, 47, NULL, NULL, 233920),
(270277, '2zzeA05', NULL, NULL, 56, NULL, NULL, 233920),
(270278, '1bk4A01', NULL, NULL, 193, NULL, NULL, 233921),
(270279, '1dcuB01', NULL, NULL, 208, NULL, NULL, 233921),
(270280, '2gq1A01', NULL, NULL, 193, NULL, NULL, 233921),
(270281, '5oezA01', NULL, NULL, 205, NULL, NULL, 233921),
(270282, '2pcrC01', NULL, NULL, 142, NULL, NULL, 233921),
(270283, '4n81A01', NULL, NULL, 142, NULL, NULL, 233921),
(270284, '2bjiA01', NULL, NULL, 146, NULL, NULL, 233921),
(270285, '1lbvA01', NULL, NULL, 138, NULL, NULL, 233921),
(270286, '2q74A01', NULL, NULL, 164, NULL, NULL, 233921),
(270287, '1nuwA01', NULL, NULL, 191, NULL, NULL, 233921),
(270288, '2p3nA01', NULL, NULL, 135, NULL, NULL, 233921),
(270289, '5i3sB01', NULL, NULL, 139, NULL, NULL, 233921),
(270290, '6giuA01', NULL, NULL, 146, NULL, NULL, 233921),
(270291, '1xi6A01', NULL, NULL, 148, NULL, NULL, 233921),
(270292, '5zonA01', NULL, NULL, 151, NULL, NULL, 233921),
(270293, '4qxdA01', NULL, NULL, 158, NULL, NULL, 233921),
(270294, '2wefA01', NULL, NULL, 175, NULL, NULL, 233921),
(270295, '5eq7A01', NULL, NULL, 153, NULL, NULL, 233921),
(270296, '5esyA01', NULL, NULL, 214, NULL, NULL, 233921),
(270297, '1g0hA01', NULL, NULL, 137, NULL, NULL, 233921),
(270298, '4he2A01', NULL, NULL, 200, NULL, NULL, 233921),
(270299, '4as5A01', NULL, NULL, 146, NULL, NULL, 233921),
(270300, '3bigA01', NULL, NULL, 171, NULL, NULL, 233921),
(270301, '5pzrB01', NULL, NULL, 200, NULL, NULL, 233921),
(270302, '6ib8B01', NULL, NULL, 144, NULL, NULL, 233921),
(270303, '1inpA02', NULL, NULL, 187, NULL, NULL, 233921);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(270304, '6ayuA01', NULL, NULL, 174, NULL, NULL, 233921),
(270305, '1ka1A01', NULL, NULL, 220, NULL, NULL, 233921),
(270306, '1spiA01', NULL, NULL, 209, NULL, NULL, 233921),
(270307, '1vdwA01', NULL, NULL, 140, NULL, NULL, 233921),
(270308, '4o7iA01', NULL, NULL, 182, NULL, NULL, 233921),
(270309, '4i3yA01', NULL, NULL, 151, NULL, NULL, 233921),
(270310, '1jp4A01', NULL, NULL, 179, NULL, NULL, 233921),
(270311, '3lv0A01', NULL, NULL, 146, NULL, NULL, 233921),
(270312, '3b8bA01', NULL, NULL, 163, NULL, NULL, 233921),
(270313, '5a5lA01', NULL, NULL, 180, NULL, NULL, 233921),
(270314, '5iz1A01', NULL, NULL, 204, NULL, NULL, 233921),
(270315, '5iz3A01', NULL, NULL, 174, NULL, NULL, 233921),
(270316, '4ir8A01', NULL, NULL, 192, NULL, NULL, 233921),
(270317, '2fvzA01', NULL, NULL, 142, NULL, NULL, 233921),
(270318, '3rojB01', NULL, NULL, 178, NULL, NULL, 233921),
(270319, '5zhhA01', NULL, NULL, 143, NULL, NULL, 233921),
(270320, '3u97A00', NULL, NULL, 94, NULL, NULL, 233922),
(270321, '2fdoA00', NULL, NULL, 94, NULL, NULL, 233923),
(270322, '2jmbA00', NULL, NULL, 79, NULL, NULL, 233924),
(270323, '1u57A00', NULL, NULL, 48, NULL, NULL, 233925),
(270324, '4x9tA01', NULL, NULL, 171, NULL, NULL, 233926),
(270325, '2f5xA01', NULL, NULL, 188, NULL, NULL, 233926),
(270326, '2qpqA01', NULL, NULL, 177, NULL, NULL, 233926),
(270327, '2dvzA01', NULL, NULL, 190, NULL, NULL, 233926),
(270328, '2ynmD04', NULL, NULL, 52, NULL, NULL, 233927),
(270329, '2kruA01', NULL, NULL, 52, NULL, NULL, 233927),
(270330, '2l09A01', NULL, NULL, 52, NULL, NULL, 233927),
(270331, '2fphX01', NULL, NULL, 77, NULL, NULL, 233928),
(270332, '4go6A00', NULL, NULL, 45, NULL, NULL, 233929),
(270333, '3g3sA01', NULL, NULL, 116, NULL, NULL, 233930),
(270334, '3eq2A02', NULL, NULL, 53, NULL, NULL, 233931),
(270335, '1jocA01', NULL, NULL, 62, NULL, NULL, 233931),
(270336, '3cl3E00', NULL, NULL, 58, NULL, NULL, 233931),
(270337, '3brvB00', NULL, NULL, 70, NULL, NULL, 233931),
(270338, '3l4fC00', NULL, NULL, 61, NULL, NULL, 233931),
(270339, '2ykoA01', NULL, NULL, 50, NULL, NULL, 233931),
(270340, '2w6bA00', NULL, NULL, 56, NULL, NULL, 233931),
(270341, '3c9aA03', NULL, NULL, 77, NULL, NULL, 233932),
(270342, '3c9aA01', NULL, NULL, 85, NULL, NULL, 233932),
(270343, '1x74A03', NULL, NULL, 23, NULL, NULL, 233933),
(270344, '4rlzA01', NULL, NULL, 206, NULL, NULL, 233934),
(270345, '5lkkA01', NULL, NULL, 198, NULL, NULL, 233934),
(270346, '2zl7B01', NULL, NULL, 204, NULL, NULL, 233934),
(270347, '5iypA01', NULL, NULL, 199, NULL, NULL, 233934),
(270348, '4rdlA01', NULL, NULL, 201, NULL, NULL, 233934),
(270349, '3q39A01', NULL, NULL, 201, NULL, NULL, 233934),
(270350, '6jyrA01', NULL, NULL, 198, NULL, NULL, 233934),
(270351, '5e6tA01', NULL, NULL, 194, NULL, NULL, 233934),
(270352, '4qv2A01', NULL, NULL, 193, NULL, NULL, 233934),
(270353, '5ysxA01', NULL, NULL, 194, NULL, NULL, 233934),
(270354, '6gw4A01', NULL, NULL, 193, NULL, NULL, 233934),
(270355, '6e48A01', NULL, NULL, 173, NULL, NULL, 233934),
(270356, '2obsA01', NULL, NULL, 220, NULL, NULL, 233934),
(270357, '6gw0A01', NULL, NULL, 207, NULL, NULL, 233934),
(270358, '3pvdB01', NULL, NULL, 209, NULL, NULL, 233934),
(270359, '4rpdB01', NULL, NULL, 197, NULL, NULL, 233934),
(270360, '6jyoD01', NULL, NULL, 198, NULL, NULL, 233934),
(270361, '3sjpA01', NULL, NULL, 204, NULL, NULL, 233934),
(270362, '3astB01', NULL, NULL, 225, NULL, NULL, 233934),
(270363, '4p25D01', NULL, NULL, 202, NULL, NULL, 233934),
(270364, '5f4jA01', NULL, NULL, 195, NULL, NULL, 233934),
(270365, '3r6kA01', NULL, NULL, 197, NULL, NULL, 233934),
(270366, '4ooxA01', NULL, NULL, 195, NULL, NULL, 233934),
(270367, '1xteA00', NULL, NULL, 119, NULL, NULL, 233935),
(270368, '6bubA00', NULL, NULL, 143, NULL, NULL, 233935),
(270369, '4oxwA00', NULL, NULL, 119, NULL, NULL, 233935),
(270370, '2ettA00', NULL, NULL, 128, NULL, NULL, 233935),
(270371, '2l73A00', NULL, NULL, 149, NULL, NULL, 233935),
(270372, '5gw1C01', NULL, NULL, 128, NULL, NULL, 233935),
(270373, '6e8rB00', NULL, NULL, 150, NULL, NULL, 233935),
(270374, '4az9B00', NULL, NULL, 129, NULL, NULL, 233935);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(270375, '2czoA00', NULL, NULL, 139, NULL, NULL, 233935),
(270376, '4bgjA00', NULL, NULL, 147, NULL, NULL, 233935),
(270377, '2wweA01', NULL, NULL, 104, NULL, NULL, 233935),
(270378, '3fogA00', NULL, NULL, 115, NULL, NULL, 233935),
(270379, '4akvB01', NULL, NULL, 136, NULL, NULL, 233935),
(270380, '1ocsA00', NULL, NULL, 133, NULL, NULL, 233935),
(270381, '2ar5A00', NULL, NULL, 121, NULL, NULL, 233935),
(270382, '4hasA00', NULL, NULL, 104, NULL, NULL, 233935),
(270383, '4on3A00', NULL, NULL, 157, NULL, NULL, 233935),
(270384, '5tgiA00', NULL, NULL, 152, NULL, NULL, 233935),
(270385, '1kq6A00', NULL, NULL, 141, NULL, NULL, 233935),
(270386, '5wy2A00', NULL, NULL, 163, NULL, NULL, 233935),
(270387, '2i4kA00', NULL, NULL, 128, NULL, NULL, 233935),
(270388, '2v14A00', NULL, NULL, 134, NULL, NULL, 233935),
(270389, '1kmdA00', NULL, NULL, 117, NULL, NULL, 233935),
(270390, '2ypsA00', NULL, NULL, 134, NULL, NULL, 233935),
(270391, '1h6hA00', NULL, NULL, 143, NULL, NULL, 233935),
(270392, '4ikdA00', NULL, NULL, 154, NULL, NULL, 233935),
(270393, '3iq2A00', NULL, NULL, 138, NULL, NULL, 233935),
(270394, '2rajA02', NULL, NULL, 126, NULL, NULL, 233935),
(270395, '4ikbB00', NULL, NULL, 144, NULL, NULL, 233935),
(270396, '2cskA00', NULL, NULL, 146, NULL, NULL, 233935),
(270397, '3dytA01', NULL, NULL, 134, NULL, NULL, 233935),
(270398, '4p2iA00', NULL, NULL, 137, NULL, NULL, 233935),
(270399, '1o7kA00', NULL, NULL, 131, NULL, NULL, 233935),
(270400, '3luiC00', NULL, NULL, 115, NULL, NULL, 233935),
(270401, '3p0cA00', NULL, NULL, 114, NULL, NULL, 233935),
(270402, '2v6vA00', NULL, NULL, 156, NULL, NULL, 233935),
(270403, '2vrsA03', NULL, NULL, 132, NULL, NULL, 233936),
(270404, '2h7oA02', NULL, NULL, 148, NULL, NULL, 233937),
(270405, '3u9sE04', NULL, NULL, 125, NULL, NULL, 233938),
(270406, '3u9tA04', NULL, NULL, 118, NULL, NULL, 233938),
(270407, '4ne3B02', NULL, NULL, 42, NULL, NULL, 233939),
(270408, '3b0bC02', NULL, NULL, 43, NULL, NULL, 233939),
(270409, '1zboA02', NULL, NULL, 96, NULL, NULL, 233940),
(270410, '4mjgA00', NULL, NULL, 183, NULL, NULL, 233941),
(270411, '3v6iX00', NULL, NULL, 105, NULL, NULL, 233942),
(270412, '4efaG00', NULL, NULL, 119, NULL, NULL, 233942),
(270413, '4ddpA00', NULL, NULL, 210, NULL, NULL, 233943),
(270414, '3vp7A00', NULL, NULL, 220, NULL, NULL, 233943),
(270415, '3whjA00', NULL, NULL, 122, NULL, NULL, 233944),
(270416, '3ux3A02', NULL, NULL, 33, NULL, NULL, 233945),
(270417, '3gcgB00', NULL, NULL, 172, NULL, NULL, 233946),
(270418, '3lxrF00', NULL, NULL, 192, NULL, NULL, 233946),
(270419, '2lxnA00', NULL, NULL, 188, NULL, NULL, 233947),
(270420, '4l8fA00', NULL, NULL, 287, NULL, NULL, 233947),
(270421, '3bhnA00', NULL, NULL, 216, NULL, NULL, 233947),
(270422, '2nv0A00', NULL, NULL, 196, NULL, NULL, 233947),
(270423, '3m3pA00', NULL, NULL, 250, NULL, NULL, 233947),
(270424, '4p5pA00', NULL, NULL, 225, NULL, NULL, 233947),
(270425, '5xr2F00', NULL, NULL, 300, NULL, NULL, 233947),
(270426, '4e5vB00', NULL, NULL, 281, NULL, NULL, 233947),
(270427, '3efeC00', NULL, NULL, 212, NULL, NULL, 233947),
(270428, '4zdjA02', NULL, NULL, 255, NULL, NULL, 233947),
(270429, '2ywjA00', NULL, NULL, 186, NULL, NULL, 233947),
(270430, '2w7tA00', NULL, NULL, 273, NULL, NULL, 233947),
(270431, '3f5dA00', NULL, NULL, 206, NULL, NULL, 233947),
(270432, '2ywbA01', NULL, NULL, 188, NULL, NULL, 233947),
(270433, '4qytA00', NULL, NULL, 194, NULL, NULL, 233947),
(270434, '2rk3A00', NULL, NULL, 197, NULL, NULL, 233947),
(270435, '4gudB00', NULL, NULL, 211, NULL, NULL, 233947),
(270436, '3ttvA03', NULL, NULL, 154, NULL, NULL, 233947),
(270437, '1n57A00', NULL, NULL, 291, NULL, NULL, 233947),
(270438, '1i1qB00', NULL, NULL, 192, NULL, NULL, 233947),
(270439, '1ka9H00', NULL, NULL, 200, NULL, NULL, 233947),
(270440, '2gk3A00', NULL, NULL, 256, NULL, NULL, 233947),
(270441, '5lirA00', NULL, NULL, 219, NULL, NULL, 233947),
(270442, '3en0C00', NULL, NULL, 268, NULL, NULL, 233947),
(270443, '4e08A00', NULL, NULL, 190, NULL, NULL, 233947),
(270444, '1jvnA01', NULL, NULL, 240, NULL, NULL, 233947),
(270445, '1s1mA02', NULL, NULL, 260, NULL, NULL, 233947);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(270446, '1oy1C00', NULL, NULL, 228, NULL, NULL, 233947),
(270447, '3ttyA02', NULL, NULL, 220, NULL, NULL, 233947),
(270448, '3l3bA00', NULL, NULL, 219, NULL, NULL, 233947),
(270449, '1qdlB00', NULL, NULL, 195, NULL, NULL, 233947),
(270450, '1a9xB02', NULL, NULL, 228, NULL, NULL, 233947),
(270451, '3ot1A00', NULL, NULL, 208, NULL, NULL, 233947),
(270452, '3graA00', NULL, NULL, 202, NULL, NULL, 233947),
(270453, '5txwA00', NULL, NULL, 166, NULL, NULL, 233947),
(270454, '4oggA01', NULL, NULL, 190, NULL, NULL, 233947),
(270455, '3cneA00', NULL, NULL, 175, NULL, NULL, 233947),
(270456, '1sy7A03', NULL, NULL, 195, NULL, NULL, 233947),
(270457, '1vcnA02', NULL, NULL, 254, NULL, NULL, 233947),
(270458, '2issD00', NULL, NULL, 189, NULL, NULL, 233947),
(270459, '3rhtA00', NULL, NULL, 259, NULL, NULL, 233947),
(270460, '2abwA00', NULL, NULL, 227, NULL, NULL, 233947),
(270461, '1i7qB00', NULL, NULL, 193, NULL, NULL, 233947),
(270462, '2a9vD00', NULL, NULL, 212, NULL, NULL, 233947),
(270463, '1l9xA00', NULL, NULL, 288, NULL, NULL, 233947),
(270464, '4i4nA00', NULL, NULL, 281, NULL, NULL, 233947),
(270465, '3l18A00', NULL, NULL, 168, NULL, NULL, 233947),
(270466, '2iufA03', NULL, NULL, 162, NULL, NULL, 233947),
(270467, '1kwgA02', NULL, NULL, 200, NULL, NULL, 233947),
(270468, '1gpmA01', NULL, NULL, 198, NULL, NULL, 233947),
(270469, '4y1rA00', NULL, NULL, 179, NULL, NULL, 233947),
(270470, '5sy4A00', NULL, NULL, 199, NULL, NULL, 233947),
(270471, '3nvaA02', NULL, NULL, 246, NULL, NULL, 233947),
(270472, '3l4eA00', NULL, NULL, 206, NULL, NULL, 233947),
(270473, '1q7rA00', NULL, NULL, 202, NULL, NULL, 233947),
(270474, '2vrnA00', NULL, NULL, 190, NULL, NULL, 233947),
(270475, '3ewnA00', NULL, NULL, 253, NULL, NULL, 233947),
(270476, '1vhqB00', NULL, NULL, 232, NULL, NULL, 233947),
(270477, '4xllA00', NULL, NULL, 188, NULL, NULL, 233947),
(270478, '4pxyA00', NULL, NULL, 250, NULL, NULL, 233947),
(270479, '6f2fA00', NULL, NULL, 166, NULL, NULL, 233947),
(270480, '2vktA00', NULL, NULL, 268, NULL, NULL, 233947),
(270481, '1u9cA00', NULL, NULL, 224, NULL, NULL, 233947),
(270482, '4uzsB02', NULL, NULL, 221, NULL, NULL, 233947),
(270483, '4qyxA00', NULL, NULL, 245, NULL, NULL, 233947),
(270484, '1o1yA00', NULL, NULL, 239, NULL, NULL, 233947),
(270485, '3r75A02', NULL, NULL, 199, NULL, NULL, 233947),
(270486, '1wl8A00', NULL, NULL, 189, NULL, NULL, 233947),
(270487, '3uowB01', NULL, NULL, 233, NULL, NULL, 233947),
(270488, '4uozA02', NULL, NULL, 223, NULL, NULL, 233947),
(270489, '4lruA00', NULL, NULL, 239, NULL, NULL, 233947),
(270490, '4aj9C03', NULL, NULL, 154, NULL, NULL, 233947),
(270491, '1fy2A00', NULL, NULL, 229, NULL, NULL, 233947),
(270492, '2fexA00', NULL, NULL, 188, NULL, NULL, 233947),
(270493, '3er6A00', NULL, NULL, 209, NULL, NULL, 233947),
(270494, '2vdjA01', NULL, NULL, 268, NULL, NULL, 233947),
(270495, '5e9aA02', NULL, NULL, 224, NULL, NULL, 233947),
(270496, '2ywdA00', NULL, NULL, 191, NULL, NULL, 233947),
(270497, '2h2wA00', NULL, NULL, 312, NULL, NULL, 233947),
(270498, '1oi4A00', NULL, NULL, 193, NULL, NULL, 233947),
(270499, '4oggC02', NULL, NULL, 198, NULL, NULL, 233947),
(270500, '3n7tA00', NULL, NULL, 247, NULL, NULL, 233947),
(270501, '3noqA00', NULL, NULL, 231, NULL, NULL, 233947),
(270502, '2vpiA00', NULL, NULL, 196, NULL, NULL, 233947),
(270503, '4oifA02', NULL, NULL, 217, NULL, NULL, 233947),
(270504, '3tqiA01', NULL, NULL, 198, NULL, NULL, 233947),
(270505, '3d54D00', NULL, NULL, 213, NULL, NULL, 233947),
(270506, '3fseA01', NULL, NULL, 207, NULL, NULL, 233947),
(270507, '1t0bA00', NULL, NULL, 252, NULL, NULL, 233947),
(270508, '3kklA00', NULL, NULL, 244, NULL, NULL, 233947),
(270509, '4wxyF00', NULL, NULL, 196, NULL, NULL, 233947),
(270510, '4hcjA00', NULL, NULL, 177, NULL, NULL, 233947),
(270511, '4lgyA04', NULL, NULL, 318, NULL, NULL, 233947),
(270512, '3fijC00', NULL, NULL, 254, NULL, NULL, 233947),
(270513, '1gpwB00', NULL, NULL, 200, NULL, NULL, 233947),
(270514, '3l7nA00', NULL, NULL, 236, NULL, NULL, 233947),
(270515, '2zuvA03', NULL, NULL, 261, NULL, NULL, 233947),
(270516, '5xzmB03', NULL, NULL, 152, NULL, NULL, 233947);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(270517, '3mgkA00', NULL, NULL, 211, NULL, NULL, 233947),
(270518, '3sozA00', NULL, NULL, 248, NULL, NULL, 233947),
(270519, '4k2hD00', NULL, NULL, 188, NULL, NULL, 233947),
(270520, '2pqrC00', NULL, NULL, 44, NULL, NULL, 233948),
(270521, '6gvdA03', NULL, NULL, 43, NULL, NULL, 233949),
(270522, '1vsaa00', NULL, NULL, 65, NULL, NULL, 233950),
(270523, '5dm6300', NULL, NULL, 65, NULL, NULL, 233950),
(270524, '1vw4Z00', NULL, NULL, 62, NULL, NULL, 233950),
(270525, '3uitA01', NULL, NULL, 133, NULL, NULL, 233951),
(270526, '3cxnB00', NULL, NULL, 209, NULL, NULL, 233952),
(270527, '5uv8A01', NULL, NULL, 81, NULL, NULL, 233953),
(270528, '2wb0X01', NULL, NULL, 120, NULL, NULL, 233954),
(270529, '3fo8D03', NULL, NULL, 20, NULL, NULL, 233955),
(270530, '2e8gA01', NULL, NULL, 124, NULL, NULL, 233956),
(270531, '1nu7D01', NULL, NULL, 135, NULL, NULL, 233957),
(270532, '3ibpA01', NULL, NULL, 91, NULL, NULL, 233958),
(270533, '5tz6B02', NULL, NULL, 158, NULL, NULL, 233959),
(270534, '4fasA01', NULL, NULL, 240, NULL, NULL, 233960),
(270535, '3dfuA02', NULL, NULL, 101, NULL, NULL, 233961),
(270536, '4bbyA02', NULL, NULL, 44, NULL, NULL, 233962),
(270537, '4z6mA03', NULL, NULL, 75, NULL, NULL, 233963),
(270538, '5grmB01', NULL, NULL, 43, NULL, NULL, 233964),
(270539, '4ksyA01', NULL, NULL, 57, NULL, NULL, 233964),
(270540, '6mx3A01', NULL, NULL, 41, NULL, NULL, 233964),
(270541, '5cflA01', NULL, NULL, 40, NULL, NULL, 233964),
(270542, '4kc0A01', NULL, NULL, 56, NULL, NULL, 233964),
(270543, '3goxA02', NULL, NULL, 54, NULL, NULL, 233965),
(270544, '1f3vA00', NULL, NULL, 179, NULL, NULL, 233966),
(270545, '2j49A00', NULL, NULL, 148, NULL, NULL, 233967),
(270546, '2nxpB00', NULL, NULL, 156, NULL, NULL, 233967),
(270547, '2j4bB00', NULL, NULL, 138, NULL, NULL, 233967),
(270548, '4a9aC01', NULL, NULL, 79, NULL, NULL, 233968),
(270549, '3n28A02', NULL, NULL, 116, NULL, NULL, 233969),
(270550, '4qncB00', NULL, NULL, 93, NULL, NULL, 233970),
(270551, '4x5mA00', NULL, NULL, 100, NULL, NULL, 233970),
(270552, '4rngC00', NULL, NULL, 94, NULL, NULL, 233970),
(270553, '4qndA00', NULL, NULL, 101, NULL, NULL, 233970),
(270554, '3zx3A02', NULL, NULL, 265, NULL, NULL, 233971),
(270555, '1u6zA02', NULL, NULL, 179, NULL, NULL, 233971),
(270556, '3hi0A02', NULL, NULL, 187, NULL, NULL, 233971),
(270557, '3cj1A02', NULL, NULL, 270, NULL, NULL, 233971),
(270558, '4brcA02', NULL, NULL, 228, NULL, NULL, 233971),
(270559, '3cerA02', NULL, NULL, 204, NULL, NULL, 233971),
(270560, '1t6cA02', NULL, NULL, 181, NULL, NULL, 233971),
(270561, '3mdqA02', NULL, NULL, 189, NULL, NULL, 233971),
(270562, '1ocyA02', NULL, NULL, 122, NULL, NULL, 233972),
(270563, '4id9B02', NULL, NULL, 116, NULL, NULL, 233973),
(270564, '2z3qA00', NULL, NULL, 119, NULL, NULL, 233974),
(270565, '3tgxB00', NULL, NULL, 134, NULL, NULL, 233974),
(270566, '2psmA00', NULL, NULL, 121, NULL, NULL, 233974),
(270567, '4gs7A00', NULL, NULL, 116, NULL, NULL, 233974),
(270568, '2zejB01', NULL, NULL, 79, NULL, NULL, 233975),
(270569, '2zejA01', NULL, NULL, 79, NULL, NULL, 233975),
(270570, '3d6tB01', NULL, NULL, 77, NULL, NULL, 233975),
(270571, '5hjmA02', NULL, NULL, 79, NULL, NULL, 233976),
(270572, '2yx1A02', NULL, NULL, 89, NULL, NULL, 233976),
(270573, '3k6rA01', NULL, NULL, 86, NULL, NULL, 233976),
(270574, '2frnA01', NULL, NULL, 68, NULL, NULL, 233976),
(270575, '3s6xC02', NULL, NULL, 29, NULL, NULL, 233977),
(270576, '2iirA01', NULL, NULL, 195, NULL, NULL, 233978),
(270577, '2iirA02', NULL, NULL, 208, NULL, NULL, 233978),
(270578, '6eofA02', NULL, NULL, 91, NULL, NULL, 233978),
(270579, '6eofA01', NULL, NULL, 215, NULL, NULL, 233978),
(270580, '5b8hA02', NULL, NULL, 123, NULL, NULL, 233978),
(270581, '2v7yA01', NULL, NULL, 180, NULL, NULL, 233978),
(270582, '2v7yA02', NULL, NULL, 97, NULL, NULL, 233978),
(270583, '5b8hA01', NULL, NULL, 142, NULL, NULL, 233978),
(270584, '3ll3B01', NULL, NULL, 247, NULL, NULL, 233978),
(270585, '3h1qA01', NULL, NULL, 157, NULL, NULL, 233978),
(270586, '3h1qA02', NULL, NULL, 115, NULL, NULL, 233978),
(270587, '1bdgA02', NULL, NULL, 165, NULL, NULL, 233978);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(270588, '4jneA02', NULL, NULL, 98, NULL, NULL, 233978),
(270589, '2nztA02', NULL, NULL, 187, NULL, NULL, 233978),
(270590, '4jneA01', NULL, NULL, 206, NULL, NULL, 233978),
(270591, '3ll3B02', NULL, NULL, 257, NULL, NULL, 233978),
(270592, '4c23B02', NULL, NULL, 235, NULL, NULL, 233978),
(270593, '5f0xA01', NULL, NULL, 154, NULL, NULL, 233978),
(270594, '4c23B01', NULL, NULL, 238, NULL, NULL, 233978),
(270595, '3cipA01', NULL, NULL, 172, NULL, NULL, 233978),
(270596, '4h0oA02', NULL, NULL, 205, NULL, NULL, 233978),
(270597, '4ijaA02', NULL, NULL, 157, NULL, NULL, 233978),
(270598, '2fxuA02', NULL, NULL, 109, NULL, NULL, 233978),
(270599, '3cipA02', NULL, NULL, 109, NULL, NULL, 233978),
(270600, '2fxuA01', NULL, NULL, 174, NULL, NULL, 233978),
(270601, '4xh4A02', NULL, NULL, 211, NULL, NULL, 233978),
(270602, '4xh4A01', NULL, NULL, 188, NULL, NULL, 233978),
(270603, '3l0qA01', NULL, NULL, 366, NULL, NULL, 233978),
(270604, '4m7xA01', NULL, NULL, 91, NULL, NULL, 233978),
(270605, '1zc6B01', NULL, NULL, 149, NULL, NULL, 233978),
(270606, '4ijaA03', NULL, NULL, 150, NULL, NULL, 233978),
(270607, '2itmB02', NULL, NULL, 243, NULL, NULL, 233978),
(270608, '4brcA01', NULL, NULL, 140, NULL, NULL, 233978),
(270609, '1nbwA04', NULL, NULL, 132, NULL, NULL, 233978),
(270610, '1nbwA01', NULL, NULL, 133, NULL, NULL, 233978),
(270611, '3hm8A02', NULL, NULL, 163, NULL, NULL, 233978),
(270612, '3hz6A02', NULL, NULL, 260, NULL, NULL, 233978),
(270613, '3vovB01', NULL, NULL, 148, NULL, NULL, 233978),
(270614, '5br9C01', NULL, NULL, 143, NULL, NULL, 233978),
(270615, '3hz6A01', NULL, NULL, 251, NULL, NULL, 233978),
(270616, '3g25C01', NULL, NULL, 255, NULL, NULL, 233978),
(270617, '1k8kA03', NULL, NULL, 133, NULL, NULL, 233978),
(270618, '4e1jD01', NULL, NULL, 249, NULL, NULL, 233978),
(270619, '5eoxB03', NULL, NULL, 128, NULL, NULL, 233978),
(270620, '1k8kA01', NULL, NULL, 132, NULL, NULL, 233978),
(270621, '4h0oA01', NULL, NULL, 199, NULL, NULL, 233978),
(270622, '3ifrA01', NULL, NULL, 244, NULL, NULL, 233978),
(270623, '3f9mA02', NULL, NULL, 169, NULL, NULL, 233978),
(270624, '4e1jD02', NULL, NULL, 246, NULL, NULL, 233978),
(270625, '4a2bA01', NULL, NULL, 144, NULL, NULL, 233978),
(270626, '4a2bA03', NULL, NULL, 95, NULL, NULL, 233978),
(270627, '2d0oA04', NULL, NULL, 132, NULL, NULL, 233978),
(270628, '2ychA01', NULL, NULL, 167, NULL, NULL, 233978),
(270629, '4h0pB02', NULL, NULL, 230, NULL, NULL, 233978),
(270630, '2d0oA01', NULL, NULL, 139, NULL, NULL, 233978),
(270631, '2p9uB01', NULL, NULL, 161, NULL, NULL, 233978),
(270632, '4rtfD02', NULL, NULL, 89, NULL, NULL, 233978),
(270633, '4fo0A01', NULL, NULL, 166, NULL, NULL, 233978),
(270634, '4rtfD01', NULL, NULL, 175, NULL, NULL, 233978),
(270635, '2ychA03', NULL, NULL, 149, NULL, NULL, 233978),
(270636, '4fo0A04', NULL, NULL, 116, NULL, NULL, 233978),
(270637, '1t6cA01', NULL, NULL, 134, NULL, NULL, 233978),
(270638, '2w40A02', NULL, NULL, 247, NULL, NULL, 233978),
(270639, '6ioyC02', NULL, NULL, 202, NULL, NULL, 233978),
(270640, '3qdkA02', NULL, NULL, 271, NULL, NULL, 233978),
(270641, '2w40A01', NULL, NULL, 256, NULL, NULL, 233978),
(270642, '3dwlA02', NULL, NULL, 131, NULL, NULL, 233978),
(270643, '3dwlA01', NULL, NULL, 195, NULL, NULL, 233978),
(270644, '5nckA01', NULL, NULL, 105, NULL, NULL, 233978),
(270645, '5nckA02', NULL, NULL, 186, NULL, NULL, 233978),
(270646, '6f1uB01', NULL, NULL, 177, NULL, NULL, 233978),
(270647, '3mdqA01', NULL, NULL, 126, NULL, NULL, 233978),
(270648, '2itmA01', NULL, NULL, 241, NULL, NULL, 233978),
(270649, '3d2fA03', NULL, NULL, 93, NULL, NULL, 233978),
(270650, '4bc3A01', NULL, NULL, 324, NULL, NULL, 233978),
(270651, '3d2fA01', NULL, NULL, 134, NULL, NULL, 233978),
(270652, '4bc3A02', NULL, NULL, 213, NULL, NULL, 233978),
(270653, '3r9pB01', NULL, NULL, 189, NULL, NULL, 233978),
(270654, '3qfuA01', NULL, NULL, 167, NULL, NULL, 233978),
(270655, '4pl7A02', NULL, NULL, 109, NULL, NULL, 233978),
(270656, '1u6zA01', NULL, NULL, 131, NULL, NULL, 233978),
(270657, '3qfuA03', NULL, NULL, 88, NULL, NULL, 233978),
(270658, '5jicA02', NULL, NULL, 182, NULL, NULL, 233978);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(270659, '3vovA02', NULL, NULL, 154, NULL, NULL, 233978),
(270660, '4dq8B02', NULL, NULL, 202, NULL, NULL, 233978),
(270661, '6f1uB02', NULL, NULL, 109, NULL, NULL, 233978),
(270662, '4dq8B01', NULL, NULL, 189, NULL, NULL, 233978),
(270663, '1k8kB01', NULL, NULL, 102, NULL, NULL, 233978),
(270664, '5brhB01', NULL, NULL, 175, NULL, NULL, 233978),
(270665, '3ifrB02', NULL, NULL, 264, NULL, NULL, 233978),
(270666, '5bn8A03', NULL, NULL, 90, NULL, NULL, 233978),
(270667, '4jd2B01', NULL, NULL, 185, NULL, NULL, 233978),
(270668, '3h6eB01', NULL, NULL, 101, NULL, NULL, 233978),
(270669, '5vm1B01', NULL, NULL, 251, NULL, NULL, 233978),
(270670, '3djcJ02', NULL, NULL, 177, NULL, NULL, 233978),
(270671, '4htlA01', NULL, NULL, 104, NULL, NULL, 233978),
(270672, '5bn8A01', NULL, NULL, 160, NULL, NULL, 233978),
(270673, '4b1yB02', NULL, NULL, 109, NULL, NULL, 233978),
(270674, '4htlA02', NULL, NULL, 193, NULL, NULL, 233978),
(270675, '5aqmA03', NULL, NULL, 89, NULL, NULL, 233978),
(270676, '5i9eB01', NULL, NULL, 172, NULL, NULL, 233978),
(270677, '4br4A01', NULL, NULL, 137, NULL, NULL, 233978),
(270678, '5i9eB02', NULL, NULL, 109, NULL, NULL, 233978),
(270679, '4bgbA02', NULL, NULL, 185, NULL, NULL, 233978),
(270680, '6n9aD01', NULL, NULL, 166, NULL, NULL, 233978),
(270681, '1jcfA02', NULL, NULL, 89, NULL, NULL, 233978),
(270682, '1zbsA01', NULL, NULL, 97, NULL, NULL, 233978),
(270683, '6n9aD02', NULL, NULL, 164, NULL, NULL, 233978),
(270684, '1zbsA02', NULL, NULL, 104, NULL, NULL, 233978),
(270685, '4h0pA01', NULL, NULL, 208, NULL, NULL, 233978),
(270686, '2q2rA01', NULL, NULL, 167, NULL, NULL, 233978),
(270687, '1yagA03', NULL, NULL, 108, NULL, NULL, 233978),
(270688, '1yagA01', NULL, NULL, 135, NULL, NULL, 233978),
(270689, '5br9A02', NULL, NULL, 91, NULL, NULL, 233978),
(270690, '3ohrA01', NULL, NULL, 106, NULL, NULL, 233978),
(270691, '3ohrA02', NULL, NULL, 197, NULL, NULL, 233978),
(270692, '1hkgA02', NULL, NULL, 130, NULL, NULL, 233978),
(270693, '3ub5A02', NULL, NULL, 108, NULL, NULL, 233978),
(270694, '3smpA02', NULL, NULL, 155, NULL, NULL, 233978),
(270695, '5e26A02', NULL, NULL, 155, NULL, NULL, 233978),
(270696, '4pl7B01', NULL, NULL, 242, NULL, NULL, 233978),
(270697, '3ezwD02', NULL, NULL, 247, NULL, NULL, 233978),
(270698, '3ezwD01', NULL, NULL, 253, NULL, NULL, 233978),
(270699, '4kboA03', NULL, NULL, 86, NULL, NULL, 233978),
(270700, '3cetB01', NULL, NULL, 111, NULL, NULL, 233978),
(270701, '3g25A02', NULL, NULL, 246, NULL, NULL, 233978),
(270702, '1huxA02', NULL, NULL, 140, NULL, NULL, 233978),
(270703, '1huxA01', NULL, NULL, 130, NULL, NULL, 233978),
(270704, '4k25A01', NULL, NULL, 193, NULL, NULL, 233978),
(270705, '5hg1A02', NULL, NULL, 185, NULL, NULL, 233978),
(270706, '5vm1A02', NULL, NULL, 240, NULL, NULL, 233978),
(270707, '3mn5A01', NULL, NULL, 161, NULL, NULL, 233978),
(270708, '2zf5O01', NULL, NULL, 247, NULL, NULL, 233978),
(270709, '2zf5O02', NULL, NULL, 250, NULL, NULL, 233978),
(270710, '5ly3A01', NULL, NULL, 208, NULL, NULL, 233978),
(270711, '4ehuA02', NULL, NULL, 143, NULL, NULL, 233978),
(270712, '2nztB04', NULL, NULL, 181, NULL, NULL, 233978),
(270713, '4ehuA01', NULL, NULL, 133, NULL, NULL, 233978),
(270714, '5nblA01', NULL, NULL, 180, NULL, NULL, 233978),
(270715, '5i9eA02', NULL, NULL, 112, NULL, NULL, 233978),
(270716, '4kboA01', NULL, NULL, 154, NULL, NULL, 233978),
(270717, '4cbuA01', NULL, NULL, 177, NULL, NULL, 233978),
(270718, '4cbuA02', NULL, NULL, 109, NULL, NULL, 233978),
(270719, '1czaN01', NULL, NULL, 187, NULL, NULL, 233978),
(270720, '6ioyA01', NULL, NULL, 201, NULL, NULL, 233978),
(270721, '3zeuA01', NULL, NULL, 136, NULL, NULL, 233978),
(270722, '5ljwB01', NULL, NULL, 177, NULL, NULL, 233978),
(270723, '1czaN03', NULL, NULL, 182, NULL, NULL, 233978),
(270724, '3zeuA02', NULL, NULL, 95, NULL, NULL, 233978),
(270725, '2qm1A02', NULL, NULL, 173, NULL, NULL, 233978),
(270726, '2ivnA02', NULL, NULL, 157, NULL, NULL, 233978),
(270727, '2ivnA01', NULL, NULL, 173, NULL, NULL, 233978),
(270728, '1bg3B01', NULL, NULL, 187, NULL, NULL, 233978),
(270729, '3fe1A01', NULL, NULL, 150, NULL, NULL, 233978);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(270730, '3h3nO02', NULL, NULL, 252, NULL, NULL, 233978),
(270731, '3fe1A03', NULL, NULL, 89, NULL, NULL, 233978),
(270732, '4fl9A01', NULL, NULL, 158, NULL, NULL, 233978),
(270733, '4czgA01', NULL, NULL, 155, NULL, NULL, 233978),
(270734, '4czgA02', NULL, NULL, 89, NULL, NULL, 233978),
(270735, '4o5fA01', NULL, NULL, 132, NULL, NULL, 233978),
(270736, '4o5fA02', NULL, NULL, 127, NULL, NULL, 233978),
(270737, '2hoeA03', NULL, NULL, 146, NULL, NULL, 233978),
(270738, '3lm2B01', NULL, NULL, 99, NULL, NULL, 233978),
(270739, '6gfaA03', NULL, NULL, 89, NULL, NULL, 233978),
(270740, '5aqmC01', NULL, NULL, 158, NULL, NULL, 233978),
(270741, '6gfaA01', NULL, NULL, 151, NULL, NULL, 233978),
(270742, '4i6mA01', NULL, NULL, 183, NULL, NULL, 233978),
(270743, '4i6mA02', NULL, NULL, 118, NULL, NULL, 233978),
(270744, '3venA02', NULL, NULL, 228, NULL, NULL, 233978),
(270745, '2hoeA02', NULL, NULL, 151, NULL, NULL, 233978),
(270746, '3venA01', NULL, NULL, 138, NULL, NULL, 233978),
(270747, '2yhwA01', NULL, NULL, 148, NULL, NULL, 233978),
(270748, '4am6A01', NULL, NULL, 210, NULL, NULL, 233978),
(270749, '2yhwA02', NULL, NULL, 168, NULL, NULL, 233978),
(270750, '3h46O01', NULL, NULL, 254, NULL, NULL, 233978),
(270751, '3gdqA03', NULL, NULL, 89, NULL, NULL, 233978),
(270752, '3gdqA01', NULL, NULL, 150, NULL, NULL, 233978),
(270753, '2uytA02', NULL, NULL, 253, NULL, NULL, 233978),
(270754, '2uytA01', NULL, NULL, 236, NULL, NULL, 233978),
(270755, '3o8mA02', NULL, NULL, 133, NULL, NULL, 233978),
(270756, '5ljwA02', NULL, NULL, 170, NULL, NULL, 233978),
(270757, '3zeuB01', NULL, NULL, 172, NULL, NULL, 233978),
(270758, '3zeuB02', NULL, NULL, 165, NULL, NULL, 233978),
(270759, '3gl1A03', NULL, NULL, 90, NULL, NULL, 233978),
(270760, '2qm1B01', NULL, NULL, 153, NULL, NULL, 233978),
(270761, '3htvA02', NULL, NULL, 196, NULL, NULL, 233978),
(270762, '3htvA01', NULL, NULL, 114, NULL, NULL, 233978),
(270763, '3en9A02', NULL, NULL, 158, NULL, NULL, 233978),
(270764, '4qs8A02', NULL, NULL, 171, NULL, NULL, 233978),
(270765, '3enoA02', NULL, NULL, 156, NULL, NULL, 233978),
(270766, '1bg3A03', NULL, NULL, 174, NULL, NULL, 233978),
(270767, '3sk3A02', NULL, NULL, 202, NULL, NULL, 233978),
(270768, '3vglA02', NULL, NULL, 173, NULL, NULL, 233978),
(270769, '2ap1A02', NULL, NULL, 166, NULL, NULL, 233978),
(270770, '3sk3A01', NULL, NULL, 196, NULL, NULL, 233978),
(270771, '3vglA01', NULL, NULL, 148, NULL, NULL, 233978),
(270772, '2ap1A01', NULL, NULL, 139, NULL, NULL, 233978),
(270773, '1dkgD03', NULL, NULL, 90, NULL, NULL, 233978),
(270774, '4ci6A01', NULL, NULL, 173, NULL, NULL, 233978),
(270775, '1jceA01', NULL, NULL, 156, NULL, NULL, 233978),
(270776, '4ci6A02', NULL, NULL, 109, NULL, NULL, 233978),
(270777, '3cqyB01', NULL, NULL, 186, NULL, NULL, 233978),
(270778, '1okjA02', NULL, NULL, 95, NULL, NULL, 233978),
(270779, '3b8aX02', NULL, NULL, 134, NULL, NULL, 233978),
(270780, '3kvgA03', NULL, NULL, 89, NULL, NULL, 233978),
(270781, '3kvgA01', NULL, NULL, 150, NULL, NULL, 233978),
(270782, '3h6eA03', NULL, NULL, 252, NULL, NULL, 233978),
(270783, '3i33A01', NULL, NULL, 152, NULL, NULL, 233978),
(270784, '1dkgD01', NULL, NULL, 150, NULL, NULL, 233978),
(270785, '3i33A03', NULL, NULL, 91, NULL, NULL, 233978),
(270786, '2zgyA01', NULL, NULL, 180, NULL, NULL, 233978),
(270787, '2zgyA02', NULL, NULL, 140, NULL, NULL, 233978),
(270788, '3wt0A02', NULL, NULL, 160, NULL, NULL, 233978),
(270789, '4db3A01', NULL, NULL, 145, NULL, NULL, 233978),
(270790, '4db3A02', NULL, NULL, 166, NULL, NULL, 233978),
(270791, '1woqA01', NULL, NULL, 122, NULL, NULL, 233978),
(270792, '1woqA02', NULL, NULL, 145, NULL, NULL, 233978),
(270793, '4gniA03', NULL, NULL, 87, NULL, NULL, 233978),
(270794, '4ijnA02', NULL, NULL, 200, NULL, NULL, 233978),
(270795, '3ttcA04', NULL, NULL, 250, NULL, NULL, 233978),
(270796, '6ediA01', NULL, NULL, 187, NULL, NULL, 233978),
(270797, '4yduC01', NULL, NULL, 142, NULL, NULL, 233978),
(270798, '1ig8A02', NULL, NULL, 134, NULL, NULL, 233978),
(270799, '1g99A01', NULL, NULL, 196, NULL, NULL, 233978),
(270800, '1g99A02', NULL, NULL, 212, NULL, NULL, 233978); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(270801, '3en9B01', NULL, NULL, 164, NULL, NULL, 233978),
(270802, '3enoB01', NULL, NULL, 178, NULL, NULL, 233978),
(270803, '3vpzA01', NULL, NULL, 131, NULL, NULL, 233978),
(270804, '2pbdA01', NULL, NULL, 136, NULL, NULL, 233978),
(270805, '2gupA02', NULL, NULL, 191, NULL, NULL, 233978),
(270806, '2gupA01', NULL, NULL, 101, NULL, NULL, 233978),
(270807, '4cbwA01', NULL, NULL, 174, NULL, NULL, 233978),
(270808, '3hi0A01', NULL, NULL, 120, NULL, NULL, 233978),
(270809, '1qz5A01', NULL, NULL, 130, NULL, NULL, 233978),
(270810, '3cqyA02', NULL, NULL, 184, NULL, NULL, 233978),
(270811, '5zqtA02', NULL, NULL, 171, NULL, NULL, 233978),
(270812, '3djcB01', NULL, NULL, 89, NULL, NULL, 233978),
(270813, '3vthA04', NULL, NULL, 249, NULL, NULL, 233978),
(270814, '2hf3A02', NULL, NULL, 109, NULL, NULL, 233978),
(270815, '1d4xA02', NULL, NULL, 109, NULL, NULL, 233978),
(270816, '2a6aA01', NULL, NULL, 149, NULL, NULL, 233978),
(270817, '3i8bA02', NULL, NULL, 233, NULL, NULL, 233978),
(270818, '3i8bA01', NULL, NULL, 282, NULL, NULL, 233978),
(270819, '2f9wA01', NULL, NULL, 153, NULL, NULL, 233978),
(270820, '2f9wA02', NULL, NULL, 118, NULL, NULL, 233978),
(270821, '3weeA01', NULL, NULL, 209, NULL, NULL, 233978),
(270822, '4gniB01', NULL, NULL, 160, NULL, NULL, 233978),
(270823, '3weeA02', NULL, NULL, 155, NULL, NULL, 233978),
(270824, '4ijnB01', NULL, NULL, 176, NULL, NULL, 233978),
(270825, '2e2oA02', NULL, NULL, 168, NULL, NULL, 233978),
(270826, '2e2oA01', NULL, NULL, 131, NULL, NULL, 233978),
(270827, '3mcpA02', NULL, NULL, 251, NULL, NULL, 233978),
(270828, '3qdkB01', NULL, NULL, 282, NULL, NULL, 233978),
(270829, '3epqA01', NULL, NULL, 105, NULL, NULL, 233978),
(270830, '2d4wA01', NULL, NULL, 253, NULL, NULL, 233978),
(270831, '3mcpA01', NULL, NULL, 115, NULL, NULL, 233978),
(270832, '3bexA02', NULL, NULL, 112, NULL, NULL, 233978),
(270833, '2d4wA02', NULL, NULL, 251, NULL, NULL, 233978),
(270834, '2p9iA01', NULL, NULL, 179, NULL, NULL, 233978),
(270835, '3bexA01', NULL, NULL, 137, NULL, NULL, 233978),
(270836, '1xc3A01', NULL, NULL, 105, NULL, NULL, 233978),
(270837, '3weeB02', NULL, NULL, 153, NULL, NULL, 233978),
(270838, '1zxoB01', NULL, NULL, 95, NULL, NULL, 233978),
(270839, '5tkyB01', NULL, NULL, 225, NULL, NULL, 233978),
(270840, '2yhxA02', NULL, NULL, 130, NULL, NULL, 233978),
(270841, '3r9pA02', NULL, NULL, 202, NULL, NULL, 233978),
(270842, '3cj1A01', NULL, NULL, 156, NULL, NULL, 233978),
(270843, '1sz2B01', NULL, NULL, 132, NULL, NULL, 233978),
(270844, '3cerC01', NULL, NULL, 139, NULL, NULL, 233978),
(270845, '2hf3A01', NULL, NULL, 171, NULL, NULL, 233978),
(270846, '2ch5B02', NULL, NULL, 205, NULL, NULL, 233978),
(270847, '3lm2A01', NULL, NULL, 99, NULL, NULL, 233978),
(270848, '6b3vA02', NULL, NULL, 155, NULL, NULL, 233978),
(270849, '4dchA02', NULL, NULL, 168, NULL, NULL, 233978),
(270850, '3lm2A02', NULL, NULL, 127, NULL, NULL, 233978),
(270851, '2aa4A02', NULL, NULL, 152, NULL, NULL, 233978),
(270852, '2aa4A01', NULL, NULL, 137, NULL, NULL, 233978),
(270853, '4cbxA01', NULL, NULL, 176, NULL, NULL, 233978),
(270854, '4cbxA02', NULL, NULL, 109, NULL, NULL, 233978),
(270855, '1z6rA02', NULL, NULL, 155, NULL, NULL, 233978),
(270856, '3wxlA02', NULL, NULL, 250, NULL, NULL, 233978),
(270857, '3wxlA01', NULL, NULL, 268, NULL, NULL, 233978),
(270858, '1z6rA03', NULL, NULL, 169, NULL, NULL, 233978),
(270859, '2fsjA02', NULL, NULL, 138, NULL, NULL, 233978),
(270860, '1sazA02', NULL, NULL, 197, NULL, NULL, 233978),
(270861, '1sazA01', NULL, NULL, 183, NULL, NULL, 233978),
(270862, '3khyA01', NULL, NULL, 190, NULL, NULL, 233978),
(270863, '3r8eA01', NULL, NULL, 160, NULL, NULL, 233978),
(270864, '4mo4A02', NULL, NULL, 184, NULL, NULL, 233978),
(270865, '2fsjA01', NULL, NULL, 188, NULL, NULL, 233978),
(270866, '3r8eA02', NULL, NULL, 161, NULL, NULL, 233978),
(270867, '4mo4A01', NULL, NULL, 187, NULL, NULL, 233978),
(270868, '3khyA02', NULL, NULL, 194, NULL, NULL, 233978),
(270869, '2p9iB01', NULL, NULL, 107, NULL, NULL, 233978),
(270870, '3zx3A01', NULL, NULL, 156, NULL, NULL, 233978),
(270871, '3gl1B01', NULL, NULL, 158, NULL, NULL, 233978);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(270872, '2h3gX01', NULL, NULL, 88, NULL, NULL, 233978),
(270873, '3wuhA02', NULL, NULL, 190, NULL, NULL, 233978),
(270874, '3js6A02', NULL, NULL, 140, NULL, NULL, 233978),
(270875, '3js6A01', NULL, NULL, 215, NULL, NULL, 233978),
(270876, '3w0lA02', NULL, NULL, 179, NULL, NULL, 233978),
(270877, '1z05A03', NULL, NULL, 170, NULL, NULL, 233978),
(270878, '2dpnA02', NULL, NULL, 245, NULL, NULL, 233978),
(270879, '1zc6A02', NULL, NULL, 156, NULL, NULL, 233978),
(270880, '1z05A02', NULL, NULL, 154, NULL, NULL, 233978),
(270881, '2dpnA01', NULL, NULL, 250, NULL, NULL, 233978),
(270882, '1zxoA02', NULL, NULL, 106, NULL, NULL, 233978),
(270883, '3uleB01', NULL, NULL, 131, NULL, NULL, 233978),
(270884, '5tkyA02', NULL, NULL, 97, NULL, NULL, 233978),
(270885, '2nrhB02', NULL, NULL, 159, NULL, NULL, 233978),
(270886, '2nrhB01', NULL, NULL, 60, NULL, NULL, 233978),
(270887, '4j8fA01', NULL, NULL, 231, NULL, NULL, 233978),
(270888, '3r6mA02', NULL, NULL, 95, NULL, NULL, 233978),
(270889, '3r6mA01', NULL, NULL, 118, NULL, NULL, 233978),
(270890, '2ch5A01', NULL, NULL, 142, NULL, NULL, 233978),
(270891, '2h3gX02', NULL, NULL, 180, NULL, NULL, 233978),
(270892, '3ipfA01', NULL, NULL, 58, NULL, NULL, 233979),
(270893, '2zjtB01', NULL, NULL, 143, NULL, NULL, 233980),
(270894, '5bs8B00', NULL, NULL, 253, NULL, NULL, 233980),
(270895, '3l4jA01', NULL, NULL, 216, NULL, NULL, 233980),
(270896, '2xcsB01', NULL, NULL, 195, NULL, NULL, 233980),
(270897, '4fm9A01', NULL, NULL, 230, NULL, NULL, 233980),
(270898, '2xcqA01', NULL, NULL, 200, NULL, NULL, 233980),
(270899, '2xcrB01', NULL, NULL, 248, NULL, NULL, 233980),
(270900, '1bgwA02', NULL, NULL, 181, NULL, NULL, 233980),
(270901, '3qx3A01', NULL, NULL, 233, NULL, NULL, 233980),
(270902, '5eixJ01', NULL, NULL, 236, NULL, NULL, 233980),
(270903, '2xkjE01', NULL, NULL, 234, NULL, NULL, 233980),
(270904, '3k9fC00', NULL, NULL, 233, NULL, NULL, 233980),
(270905, '1bjtA02', NULL, NULL, 218, NULL, NULL, 233980),
(270906, '4i8oA02', NULL, NULL, 90, NULL, NULL, 233981),
(270907, '3udcA02', NULL, NULL, 50, NULL, NULL, 233982),
(270908, '2rh2A00', NULL, NULL, 62, NULL, NULL, 233982),
(270909, '5ajiB02', NULL, NULL, 50, NULL, NULL, 233982),
(270910, '1e6yA01', NULL, NULL, 110, NULL, NULL, 233983),
(270911, '5a0yA01', NULL, NULL, 99, NULL, NULL, 233983),
(270912, '1e6vA01', NULL, NULL, 104, NULL, NULL, 233983),
(270913, '5a8rA01', NULL, NULL, 104, NULL, NULL, 233983),
(270914, '5a8wA01', NULL, NULL, 105, NULL, NULL, 233983),
(270915, '5n28D01', NULL, NULL, 104, NULL, NULL, 233983),
(270916, '3sqgA01', NULL, NULL, 103, NULL, NULL, 233983),
(270917, '5n1qA01', NULL, NULL, 105, NULL, NULL, 233983),
(270918, '6gfxC02', NULL, NULL, 52, NULL, NULL, 233984),
(270919, '1gxlA02', NULL, NULL, 86, NULL, NULL, 233985),
(270920, '3dpuB03', NULL, NULL, 111, NULL, NULL, 233986),
(270921, '2x3aA01', NULL, NULL, 139, NULL, NULL, 233987),
(270922, '2bwqA00', NULL, NULL, 129, NULL, NULL, 233988),
(270923, '3jzyA00', NULL, NULL, 125, NULL, NULL, 233988),
(270924, '5dxtA02', NULL, NULL, 152, NULL, NULL, 233988),
(270925, '6cxwA00', NULL, NULL, 128, NULL, NULL, 233988),
(270926, '3w57A00', NULL, NULL, 111, NULL, NULL, 233988),
(270927, '2jqzA00', NULL, NULL, 131, NULL, NULL, 233988),
(270928, '2r83A01', NULL, NULL, 136, NULL, NULL, 233988),
(270929, '4lcvB00', NULL, NULL, 138, NULL, NULL, 233988),
(270930, '2zkmX04', NULL, NULL, 130, NULL, NULL, 233988),
(270931, '4f92B06', NULL, NULL, 109, NULL, NULL, 233988),
(270932, '6fljA00', NULL, NULL, 137, NULL, NULL, 233988),
(270933, '5ccjA00', NULL, NULL, 152, NULL, NULL, 233988),
(270934, '5dcaA08', NULL, NULL, 110, NULL, NULL, 233988),
(270935, '2z0uA00', NULL, NULL, 128, NULL, NULL, 233988),
(270936, '5m59A12', NULL, NULL, 121, NULL, NULL, 233988),
(270937, '1rlwA00', NULL, NULL, 126, NULL, NULL, 233988),
(270938, '4bfrA02', NULL, NULL, 172, NULL, NULL, 233988),
(270939, '2q0zX03', NULL, NULL, 122, NULL, NULL, 233988),
(270940, '4ts6A00', NULL, NULL, 132, NULL, NULL, 233988),
(270941, '2fk9A00', NULL, NULL, 157, NULL, NULL, 233988),
(270942, '2qz5A00', NULL, NULL, 155, NULL, NULL, 233988);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(270943, '4y1sA00', NULL, NULL, 126, NULL, NULL, 233988),
(270944, '1rh8A00', NULL, NULL, 142, NULL, NULL, 233988),
(270945, '5h4yA00', NULL, NULL, 150, NULL, NULL, 233988),
(270946, '1bdyA00', NULL, NULL, 123, NULL, NULL, 233988),
(270947, '2nq3A00', NULL, NULL, 143, NULL, NULL, 233988),
(270948, '2enjA00', NULL, NULL, 138, NULL, NULL, 233988),
(270949, '2b3rA00', NULL, NULL, 134, NULL, NULL, 233988),
(270950, '3b7yA00', NULL, NULL, 153, NULL, NULL, 233988),
(270951, '6nytA00', NULL, NULL, 148, NULL, NULL, 233988),
(270952, '1ugkA00', NULL, NULL, 138, NULL, NULL, 233988),
(270953, '4iqhA00', NULL, NULL, 130, NULL, NULL, 233988),
(270954, '4ihbD00', NULL, NULL, 133, NULL, NULL, 233988),
(270955, '4ns0A00', NULL, NULL, 133, NULL, NULL, 233988),
(270956, '3ohmB04', NULL, NULL, 169, NULL, NULL, 233988),
(270957, '5m59A06', NULL, NULL, 112, NULL, NULL, 233988),
(270958, '2dmgA00', NULL, NULL, 142, NULL, NULL, 233988),
(270959, '6eelA00', NULL, NULL, 129, NULL, NULL, 233988),
(270960, '1djxA03', NULL, NULL, 131, NULL, NULL, 233988),
(270961, '4icxC00', NULL, NULL, 146, NULL, NULL, 233988),
(270962, '1yrkA00', NULL, NULL, 126, NULL, NULL, 233988),
(270963, '4npjB02', NULL, NULL, 150, NULL, NULL, 233988),
(270964, '1wfmA00', NULL, NULL, 138, NULL, NULL, 233988),
(270965, '3qr1A04', NULL, NULL, 139, NULL, NULL, 233988),
(270966, '2cm5A00', NULL, NULL, 166, NULL, NULL, 233988),
(270967, '3l4cA00', NULL, NULL, 195, NULL, NULL, 233988),
(270968, '1gmiA00', NULL, NULL, 136, NULL, NULL, 233988),
(270969, '3twyA00', NULL, NULL, 137, NULL, NULL, 233988),
(270970, '2q3xA00', NULL, NULL, 150, NULL, NULL, 233988),
(270971, '2yrbA01', NULL, NULL, 135, NULL, NULL, 233988),
(270972, '3n5aA00', NULL, NULL, 138, NULL, NULL, 233988),
(270973, '2nsqA00', NULL, NULL, 155, NULL, NULL, 233988),
(270974, '4ldcA00', NULL, NULL, 149, NULL, NULL, 233988),
(270975, '6iejA00', NULL, NULL, 127, NULL, NULL, 233988),
(270976, '6ewlA00', NULL, NULL, 139, NULL, NULL, 233988),
(270977, '6btyB00', NULL, NULL, 131, NULL, NULL, 233988),
(270978, '5dxuA02', NULL, NULL, 160, NULL, NULL, 233988),
(270979, '4qamB00', NULL, NULL, 201, NULL, NULL, 233988),
(270980, '1w15A00', NULL, NULL, 153, NULL, NULL, 233988),
(270981, '2cjtC00', NULL, NULL, 131, NULL, NULL, 233988),
(270982, '4npjB01', NULL, NULL, 149, NULL, NULL, 233988),
(270983, '2d8kA00', NULL, NULL, 141, NULL, NULL, 233988),
(270984, '1tjxA00', NULL, NULL, 159, NULL, NULL, 233988),
(270985, '2uzpA00', NULL, NULL, 144, NULL, NULL, 233988),
(270986, '4mjjA00', NULL, NULL, 138, NULL, NULL, 233988),
(270987, '3l9bA00', NULL, NULL, 126, NULL, NULL, 233988),
(270988, '3fbkA00', NULL, NULL, 153, NULL, NULL, 233988),
(270989, '3qr0A04', NULL, NULL, 137, NULL, NULL, 233988),
(270990, '1wfjA01', NULL, NULL, 124, NULL, NULL, 233988),
(270991, '3pycA00', NULL, NULL, 132, NULL, NULL, 233988),
(270992, '3im1A03', NULL, NULL, 115, NULL, NULL, 233988),
(270993, '4weeA01', NULL, NULL, 127, NULL, NULL, 233988),
(270994, '3m7fB00', NULL, NULL, 176, NULL, NULL, 233988),
(270995, '1dqvA01', NULL, NULL, 131, NULL, NULL, 233988),
(270996, '6anjA00', NULL, NULL, 148, NULL, NULL, 233988),
(270997, '1dqvA02', NULL, NULL, 146, NULL, NULL, 233988),
(270998, '4npkA01', NULL, NULL, 143, NULL, NULL, 233988),
(270999, '1e7uA02', NULL, NULL, 166, NULL, NULL, 233988),
(271000, '1e8yA02', NULL, NULL, 166, NULL, NULL, 233988),
(271001, '2qzqA00', NULL, NULL, 152, NULL, NULL, 233988),
(271002, '2ep6A01', NULL, NULL, 122, NULL, NULL, 233988),
(271003, '5nczA03', NULL, NULL, 168, NULL, NULL, 233988),
(271004, '3fdwA00', NULL, NULL, 148, NULL, NULL, 233988),
(271005, '1a25A00', NULL, NULL, 133, NULL, NULL, 233988),
(271006, '2enpA00', NULL, NULL, 147, NULL, NULL, 233988),
(271007, '1njhA00', NULL, NULL, 119, NULL, NULL, 233989),
(271008, '1zylA03', NULL, NULL, 103, NULL, NULL, 233990),
(271009, '3qyfA02', NULL, NULL, 45, NULL, NULL, 233991),
(271010, '3p3kA00', NULL, NULL, 183, NULL, NULL, 233992),
(271011, '2fu5A00', NULL, NULL, 117, NULL, NULL, 233992),
(271012, '1txjA00', NULL, NULL, 171, NULL, NULL, 233992),
(271013, '2kwbA00', NULL, NULL, 189, NULL, NULL, 233992);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(271014, '1hxrB00', NULL, NULL, 115, NULL, NULL, 233992),
(271015, '1h6qA00', NULL, NULL, 168, NULL, NULL, 233992),
(271016, '5o9mA00', NULL, NULL, 180, NULL, NULL, 233992),
(271017, '3ebmA00', NULL, NULL, 180, NULL, NULL, 233992),
(271018, '3a2kA03', NULL, NULL, 86, NULL, NULL, 233993),
(271019, '4ag1C00', NULL, NULL, 68, NULL, NULL, 233994),
(271020, '2cubA00', NULL, NULL, 88, NULL, NULL, 233994),
(271021, '3tvtA01', NULL, NULL, 98, NULL, NULL, 233994),
(271022, '1wx6A01', NULL, NULL, 66, NULL, NULL, 233994),
(271023, '3zl7C00', NULL, NULL, 67, NULL, NULL, 233994),
(271024, '2kxcA00', NULL, NULL, 67, NULL, NULL, 233994),
(271025, '1e6gA00', NULL, NULL, 62, NULL, NULL, 233994),
(271026, '4f14A00', NULL, NULL, 64, NULL, NULL, 233994),
(271027, '2jteA00', NULL, NULL, 64, NULL, NULL, 233994),
(271028, '3a98A01', NULL, NULL, 76, NULL, NULL, 233994),
(271029, '5o99A00', NULL, NULL, 60, NULL, NULL, 233994),
(271030, '1bb9A00', NULL, NULL, 83, NULL, NULL, 233994),
(271031, '4lnpA00', NULL, NULL, 61, NULL, NULL, 233994),
(271032, '2i0nA01', NULL, NULL, 57, NULL, NULL, 233994),
(271033, '3ua7A00', NULL, NULL, 64, NULL, NULL, 233994),
(271034, '1wfwA00', NULL, NULL, 74, NULL, NULL, 233994),
(271035, '5gjvB00', NULL, NULL, 106, NULL, NULL, 233994),
(271036, '4rugB00', NULL, NULL, 92, NULL, NULL, 233994),
(271037, '2rn8A00', NULL, NULL, 64, NULL, NULL, 233994),
(271038, '2gncA00', NULL, NULL, 60, NULL, NULL, 233994),
(271039, '2dmoA00', NULL, NULL, 68, NULL, NULL, 233994),
(271040, '2qdlA01', NULL, NULL, 62, NULL, NULL, 233994),
(271041, '5np2B00', NULL, NULL, 61, NULL, NULL, 233994),
(271042, '6edfA00', NULL, NULL, 79, NULL, NULL, 233994),
(271043, '2vvkA00', NULL, NULL, 56, NULL, NULL, 233994),
(271044, '2frwA00', NULL, NULL, 57, NULL, NULL, 233994),
(271045, '2feiA00', NULL, NULL, 65, NULL, NULL, 233994),
(271046, '2rqrA00', NULL, NULL, 119, NULL, NULL, 233994),
(271047, '2lj0A00', NULL, NULL, 65, NULL, NULL, 233994),
(271048, '6gbuD00', NULL, NULL, 65, NULL, NULL, 233994),
(271049, '6ghmC02', NULL, NULL, 64, NULL, NULL, 233994),
(271050, '2egcA00', NULL, NULL, 75, NULL, NULL, 233994),
(271051, '1g2bA00', NULL, NULL, 62, NULL, NULL, 233994),
(271052, '6h5tA00', NULL, NULL, 65, NULL, NULL, 233994),
(271053, '4krtB03', NULL, NULL, 67, NULL, NULL, 233994),
(271054, '1fmkA01', NULL, NULL, 64, NULL, NULL, 233994),
(271055, '2oawA00', NULL, NULL, 65, NULL, NULL, 233994),
(271056, '3reaB00', NULL, NULL, 61, NULL, NULL, 233994),
(271057, '3iqlA00', NULL, NULL, 71, NULL, NULL, 233994),
(271058, '2keaA00', NULL, NULL, 63, NULL, NULL, 233994),
(271059, '1ug1A00', NULL, NULL, 92, NULL, NULL, 233994),
(271060, '2dnuA00', NULL, NULL, 71, NULL, NULL, 233994),
(271061, '1ue9A00', NULL, NULL, 80, NULL, NULL, 233994),
(271062, '2k2mA00', NULL, NULL, 68, NULL, NULL, 233994),
(271063, '2js2A00', NULL, NULL, 63, NULL, NULL, 233994),
(271064, '4afqC00', NULL, NULL, 66, NULL, NULL, 233994),
(271065, '2lqwA02', NULL, NULL, 67, NULL, NULL, 233994),
(271066, '1s1nA00', NULL, NULL, 68, NULL, NULL, 233994),
(271067, '2iimA00', NULL, NULL, 62, NULL, NULL, 233994),
(271068, '1k9aA01', NULL, NULL, 67, NULL, NULL, 233994),
(271069, '5veiA00', NULL, NULL, 80, NULL, NULL, 233994),
(271070, '6ipyA00', NULL, NULL, 81, NULL, NULL, 233994),
(271071, '6ipzZ00', NULL, NULL, 70, NULL, NULL, 233994),
(271072, '1gl5A00', NULL, NULL, 67, NULL, NULL, 233994),
(271073, '5ixfA00', NULL, NULL, 70, NULL, NULL, 233994),
(271074, '1y0mA00', NULL, NULL, 61, NULL, NULL, 233994),
(271075, '1efnA00', NULL, NULL, 59, NULL, NULL, 233994),
(271076, '2eyyA02', NULL, NULL, 80, NULL, NULL, 233994),
(271077, '6nmwA00', NULL, NULL, 69, NULL, NULL, 233994),
(271078, '4ag2C00', NULL, NULL, 63, NULL, NULL, 233994),
(271079, '4j9fA00', NULL, NULL, 63, NULL, NULL, 233994),
(271080, '1negA00', NULL, NULL, 67, NULL, NULL, 233994),
(271081, '3tszA02', NULL, NULL, 71, NULL, NULL, 233994),
(271082, '4iioA00', NULL, NULL, 66, NULL, NULL, 233994),
(271083, '1vyuA01', NULL, NULL, 104, NULL, NULL, 233994),
(271084, '2kt8A00', NULL, NULL, 76, NULL, NULL, 233994),
(271085, '1zlmA00', NULL, NULL, 58, NULL, NULL, 233994);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(271086, '4orzA00', NULL, NULL, 67, NULL, NULL, 233994),
(271087, '1x6bA01', NULL, NULL, 64, NULL, NULL, 233994),
(271088, '2kgtA00', NULL, NULL, 72, NULL, NULL, 233994),
(271089, '2csiA00', NULL, NULL, 76, NULL, NULL, 233994),
(271090, '1yn8A00', NULL, NULL, 59, NULL, NULL, 233994),
(271091, '3i35A00', NULL, NULL, 60, NULL, NULL, 233994),
(271092, '2lmjA00', NULL, NULL, 66, NULL, NULL, 233994),
(271093, '1zuuA00', NULL, NULL, 58, NULL, NULL, 233994),
(271094, '2eyzA03', NULL, NULL, 91, NULL, NULL, 233994),
(271095, '6c4sA00', NULL, NULL, 74, NULL, NULL, 233994),
(271096, '2ebpA00', NULL, NULL, 73, NULL, NULL, 233994),
(271097, '1awwA00', NULL, NULL, 67, NULL, NULL, 233994),
(271098, '3qwxX02', NULL, NULL, 59, NULL, NULL, 233994),
(271099, '3m0rA00', NULL, NULL, 62, NULL, NULL, 233994),
(271100, '1tucA00', NULL, NULL, 63, NULL, NULL, 233994),
(271101, '1x6gA00', NULL, NULL, 81, NULL, NULL, 233994),
(271102, '4esrA00', NULL, NULL, 69, NULL, NULL, 233994),
(271103, '5nuhD00', NULL, NULL, 60, NULL, NULL, 233994),
(271104, '2dybB02', NULL, NULL, 59, NULL, NULL, 233994),
(271105, '3uatA01', NULL, NULL, 105, NULL, NULL, 233994),
(271106, '1t0hA00', NULL, NULL, 105, NULL, NULL, 233994),
(271107, '2drmA00', NULL, NULL, 58, NULL, NULL, 233994),
(271108, '1k4uS00', NULL, NULL, 62, NULL, NULL, 233994),
(271109, '2ew3A00', NULL, NULL, 68, NULL, NULL, 233994),
(271110, '4glmA00', NULL, NULL, 72, NULL, NULL, 233994),
(271111, '2v1qA00', NULL, NULL, 60, NULL, NULL, 233994),
(271112, '2fpeA00', NULL, NULL, 62, NULL, NULL, 233994),
(271113, '2m0yA00', NULL, NULL, 74, NULL, NULL, 233994),
(271114, '1wi7A00', NULL, NULL, 68, NULL, NULL, 233994),
(271115, '3ulrB00', NULL, NULL, 65, NULL, NULL, 233994),
(271116, '3i9qA00', NULL, NULL, 57, NULL, NULL, 233994),
(271117, '2b86A00', NULL, NULL, 67, NULL, NULL, 233994),
(271118, '1ng2A02', NULL, NULL, 68, NULL, NULL, 233994),
(271119, '1ng2A01', NULL, NULL, 53, NULL, NULL, 233994),
(271120, '2yunA00', NULL, NULL, 79, NULL, NULL, 233994),
(271121, '2e5kA01', NULL, NULL, 64, NULL, NULL, 233994),
(271122, '2gqiA00', NULL, NULL, 71, NULL, NULL, 233994),
(271123, '3h41A02', NULL, NULL, 68, NULL, NULL, 233994),
(271124, '1u3oA01', NULL, NULL, 75, NULL, NULL, 233994),
(271125, '1sshA00', NULL, NULL, 60, NULL, NULL, 233994),
(271126, '2kbtA00', NULL, NULL, 69, NULL, NULL, 233994),
(271127, '1i07A00', NULL, NULL, 60, NULL, NULL, 233994),
(271128, '3pvlA05', NULL, NULL, 82, NULL, NULL, 233994),
(271129, '2d8jA00', NULL, NULL, 77, NULL, NULL, 233994),
(271130, '1gcqC00', NULL, NULL, 70, NULL, NULL, 233994),
(271131, '2v1rA00', NULL, NULL, 80, NULL, NULL, 233994),
(271132, '2a36A00', NULL, NULL, 59, NULL, NULL, 233994),
(271133, '5ul6A00', NULL, NULL, 58, NULL, NULL, 233994),
(271134, '1wxuA01', NULL, NULL, 66, NULL, NULL, 233994),
(271135, '1vyvA01', NULL, NULL, 108, NULL, NULL, 233994),
(271136, '5xhzA00', NULL, NULL, 66, NULL, NULL, 233994),
(271137, '1x2qA00', NULL, NULL, 88, NULL, NULL, 233994),
(271138, '2rqvA01', NULL, NULL, 86, NULL, NULL, 233994),
(271139, '2bzyA00', NULL, NULL, 67, NULL, NULL, 233994),
(271140, '1ov3A01', NULL, NULL, 55, NULL, NULL, 233994),
(271141, '2a08A00', NULL, NULL, 60, NULL, NULL, 233994),
(271142, '2bz8A00', NULL, NULL, 58, NULL, NULL, 233994),
(271143, '1x43A01', NULL, NULL, 62, NULL, NULL, 233994),
(271144, '1arkA00', NULL, NULL, 60, NULL, NULL, 233994),
(271145, '1uffA00', NULL, NULL, 93, NULL, NULL, 233994),
(271146, '1qcfA01', NULL, NULL, 63, NULL, NULL, 233994),
(271147, '2da9A00', NULL, NULL, 70, NULL, NULL, 233994),
(271148, '1ov3A02', NULL, NULL, 57, NULL, NULL, 233994),
(271149, '1r77A00', NULL, NULL, 103, NULL, NULL, 233994),
(271150, '2hbwA01', NULL, NULL, 87, NULL, NULL, 233994),
(271151, '1uhcA00', NULL, NULL, 79, NULL, NULL, 233994),
(271152, '2enmA00', NULL, NULL, 77, NULL, NULL, 233994),
(271153, '5yprA01', NULL, NULL, 109, NULL, NULL, 233994),
(271154, '3u23A00', NULL, NULL, 65, NULL, NULL, 233994),
(271155, '1b07A00', NULL, NULL, 65, NULL, NULL, 233994),
(271156, '1w1fA00', NULL, NULL, 65, NULL, NULL, 233994),
(271157, '1x27B01', NULL, NULL, 62, NULL, NULL, 233994);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(271158, '3lh5A01', NULL, NULL, 98, NULL, NULL, 233994),
(271159, '2xmfA00', NULL, NULL, 60, NULL, NULL, 233994),
(271160, '1ad5A01', NULL, NULL, 63, NULL, NULL, 233994),
(271161, '1j3tA00', NULL, NULL, 74, NULL, NULL, 233994),
(271162, '2j05A00', NULL, NULL, 65, NULL, NULL, 233994),
(271163, '5k26B00', NULL, NULL, 86, NULL, NULL, 233994),
(271164, '1uj0A00', NULL, NULL, 62, NULL, NULL, 233994),
(271165, '2pqhB00', NULL, NULL, 80, NULL, NULL, 233994),
(271166, '1pwtA00', NULL, NULL, 61, NULL, NULL, 233994),
(271167, '1b3qB03', NULL, NULL, 69, NULL, NULL, 233994),
(271168, '2egeA00', NULL, NULL, 75, NULL, NULL, 233994),
(271169, '5o1qA00', NULL, NULL, 106, NULL, NULL, 233994),
(271170, '1zuyA00', NULL, NULL, 58, NULL, NULL, 233994),
(271171, '1hsqA00', NULL, NULL, 71, NULL, NULL, 233994),
(271172, '2akkA00', NULL, NULL, 74, NULL, NULL, 233994),
(271173, '4wciC00', NULL, NULL, 65, NULL, NULL, 233994),
(271174, '3ehrB01', NULL, NULL, 74, NULL, NULL, 233994),
(271175, '2nwmA00', NULL, NULL, 65, NULL, NULL, 233994),
(271176, '3pvqB01', NULL, NULL, 75, NULL, NULL, 233994),
(271177, '3i5rA00', NULL, NULL, 83, NULL, NULL, 233994),
(271178, '4z8aA00', NULL, NULL, 75, NULL, NULL, 233994),
(271179, '2js0A00', NULL, NULL, 61, NULL, NULL, 233994),
(271180, '1nloC00', NULL, NULL, 64, NULL, NULL, 233994),
(271181, '2pz1A01', NULL, NULL, 87, NULL, NULL, 233994),
(271182, '2dlpA00', NULL, NULL, 85, NULL, NULL, 233994),
(271183, '2ke9A00', NULL, NULL, 67, NULL, NULL, 233994),
(271184, '2heqA01', NULL, NULL, 54, NULL, NULL, 233994),
(271185, '2yuoA00', NULL, NULL, 78, NULL, NULL, 233994),
(271186, '4zw2A01', NULL, NULL, 145, NULL, NULL, 233994),
(271187, '5leoA00', NULL, NULL, 94, NULL, NULL, 233994),
(271188, '5v2qA01', NULL, NULL, 115, NULL, NULL, 233994),
(271189, '2kybA00', NULL, NULL, 60, NULL, NULL, 233994),
(271190, '4cc2A00', NULL, NULL, 67, NULL, NULL, 233994),
(271191, '1ruwA01', NULL, NULL, 60, NULL, NULL, 233994),
(271192, '6cpjA00', NULL, NULL, 61, NULL, NULL, 233994),
(271193, '2dl4A00', NULL, NULL, 68, NULL, NULL, 233994),
(271194, '3rnjA00', NULL, NULL, 67, NULL, NULL, 233994),
(271195, '4iimA00', NULL, NULL, 70, NULL, NULL, 233994),
(271196, '1semA00', NULL, NULL, 58, NULL, NULL, 233994),
(271197, '1x2kA00', NULL, NULL, 68, NULL, NULL, 233994),
(271198, '1ri9A00', NULL, NULL, 83, NULL, NULL, 233994),
(271199, '1wxtA00', NULL, NULL, 68, NULL, NULL, 233994),
(271200, '4deyA01', NULL, NULL, 121, NULL, NULL, 233994),
(271201, '2ak5B00', NULL, NULL, 64, NULL, NULL, 233994),
(271202, '2jmcA00', NULL, NULL, 77, NULL, NULL, 233994),
(271203, '2evrA01', NULL, NULL, 74, NULL, NULL, 233994),
(271204, '2dx1A01', NULL, NULL, 69, NULL, NULL, 233994),
(271205, '2gtjA01', NULL, NULL, 74, NULL, NULL, 233994),
(271206, '4e6rA00', NULL, NULL, 58, NULL, NULL, 233994),
(271207, '2dk3A00', NULL, NULL, 86, NULL, NULL, 233994),
(271208, '6cpiA00', NULL, NULL, 61, NULL, NULL, 233994),
(271209, '2dl5A00', NULL, NULL, 78, NULL, NULL, 233994),
(271210, '2creA00', NULL, NULL, 71, NULL, NULL, 233994),
(271211, '2krsA01', NULL, NULL, 60, NULL, NULL, 233994),
(271212, '5np5A00', NULL, NULL, 61, NULL, NULL, 233994),
(271213, '3pvqA01', NULL, NULL, 75, NULL, NULL, 233994),
(271214, '2ysqA00', NULL, NULL, 81, NULL, NULL, 233994),
(271215, '2rolA00', NULL, NULL, 64, NULL, NULL, 233994),
(271216, '2ed0A00', NULL, NULL, 78, NULL, NULL, 233994),
(271217, '1k1zA00', NULL, NULL, 78, NULL, NULL, 233994),
(271218, '1zx6A00', NULL, NULL, 58, NULL, NULL, 233994),
(271219, '1i1jB00', NULL, NULL, 108, NULL, NULL, 233994),
(271220, '2o2oA00', NULL, NULL, 92, NULL, NULL, 233994),
(271221, '2epdA00', NULL, NULL, 76, NULL, NULL, 233994),
(271222, '4wsiA02', NULL, NULL, 66, NULL, NULL, 233994),
(271223, '1ugvA00', NULL, NULL, 72, NULL, NULL, 233994),
(271224, '3cqtA00', NULL, NULL, 62, NULL, NULL, 233994),
(271225, '5fwbA00', NULL, NULL, 62, NULL, NULL, 233994),
(271226, '2dm1A00', NULL, NULL, 73, NULL, NULL, 233994),
(271227, '2dilA00', NULL, NULL, 69, NULL, NULL, 233994),
(271228, '2dybA02', NULL, NULL, 79, NULL, NULL, 233994),
(271229, '5sxpA00', NULL, NULL, 62, NULL, NULL, 233994);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(271230, '1opkA01', NULL, NULL, 63, NULL, NULL, 233994),
(271231, '2lx7A00', NULL, NULL, 60, NULL, NULL, 233994),
(271232, '3r6nA03', NULL, NULL, 69, NULL, NULL, 233994),
(271233, '2aklA02', NULL, NULL, 73, NULL, NULL, 233994),
(271234, '2csqA01', NULL, NULL, 65, NULL, NULL, 233994),
(271235, '1v1cA00', NULL, NULL, 71, NULL, NULL, 233994),
(271236, '5xggE00', NULL, NULL, 66, NULL, NULL, 233994),
(271237, '2eczA00', NULL, NULL, 70, NULL, NULL, 233994),
(271238, '2krnA00', NULL, NULL, 60, NULL, NULL, 233994),
(271239, '2l3sA01', NULL, NULL, 57, NULL, NULL, 233994),
(271240, '2l3sA02', NULL, NULL, 76, NULL, NULL, 233994),
(271241, '4ln2A00', NULL, NULL, 68, NULL, NULL, 233994),
(271242, '2mioA00', NULL, NULL, 70, NULL, NULL, 233994),
(271243, '2yupA01', NULL, NULL, 65, NULL, NULL, 233994),
(271244, '4j9cA00', NULL, NULL, 63, NULL, NULL, 233994),
(271245, '2ydlA00', NULL, NULL, 69, NULL, NULL, 233994),
(271246, '6b26A01', NULL, NULL, 54, NULL, NULL, 233994),
(271247, '1z9qA00', NULL, NULL, 79, NULL, NULL, 233994),
(271248, '3jv3A01', NULL, NULL, 64, NULL, NULL, 233994),
(271249, '5v2pA01', NULL, NULL, 130, NULL, NULL, 233994),
(271250, '2ggrA00', NULL, NULL, 76, NULL, NULL, 233994),
(271251, '3npfA01', NULL, NULL, 75, NULL, NULL, 233994),
(271252, '2egaA00', NULL, NULL, 70, NULL, NULL, 233994),
(271253, '3h0hA00', NULL, NULL, 73, NULL, NULL, 233994),
(271254, '4e6rB00', NULL, NULL, 58, NULL, NULL, 233994),
(271255, '2d8hA00', NULL, NULL, 80, NULL, NULL, 233994),
(271256, '3npfA02', NULL, NULL, 70, NULL, NULL, 233994),
(271257, '2rf0A00', NULL, NULL, 62, NULL, NULL, 233994),
(271258, '4r0kB01', NULL, NULL, 75, NULL, NULL, 233994),
(271259, '4jpbW01', NULL, NULL, 72, NULL, NULL, 233994),
(271260, '1awoA00', NULL, NULL, 62, NULL, NULL, 233994),
(271261, '2djqA00', NULL, NULL, 68, NULL, NULL, 233994),
(271262, '2dl3A00', NULL, NULL, 68, NULL, NULL, 233994),
(271263, '1vytA01', NULL, NULL, 138, NULL, NULL, 233994),
(271264, '2rqtA00', NULL, NULL, 61, NULL, NULL, 233994),
(271265, '2ct4A00', NULL, NULL, 70, NULL, NULL, 233994),
(271266, '6gbuA00', NULL, NULL, 63, NULL, NULL, 233994),
(271267, '2ekhA00', NULL, NULL, 80, NULL, NULL, 233994),
(271268, '2dbmA00', NULL, NULL, 73, NULL, NULL, 233994),
(271269, '2x3wD00', NULL, NULL, 60, NULL, NULL, 233994),
(271270, '1m3cA00', NULL, NULL, 60, NULL, NULL, 233994),
(271271, '5nvjA00', NULL, NULL, 60, NULL, NULL, 233994),
(271272, '1xovA02', NULL, NULL, 66, NULL, NULL, 233994),
(271273, '2de0X03', NULL, NULL, 58, NULL, NULL, 233994),
(271274, '4hvwA00', NULL, NULL, 61, NULL, NULL, 233994),
(271275, '1griA01', NULL, NULL, 54, NULL, NULL, 233994),
(271276, '3pe0A03', NULL, NULL, 67, NULL, NULL, 233994),
(271277, '1xovA03', NULL, NULL, 72, NULL, NULL, 233994),
(271278, '2d0nA00', NULL, NULL, 59, NULL, NULL, 233994),
(271279, '1ujyA00', NULL, NULL, 76, NULL, NULL, 233994),
(271280, '1awjA00', NULL, NULL, 77, NULL, NULL, 233994),
(271281, '2dl8A00', NULL, NULL, 72, NULL, NULL, 233994),
(271282, '1spkA00', NULL, NULL, 72, NULL, NULL, 233994),
(271283, '5ecaA00', NULL, NULL, 60, NULL, NULL, 233994),
(271284, '2hdaA00', NULL, NULL, 64, NULL, NULL, 233994),
(271285, '2o9sA00', NULL, NULL, 67, NULL, NULL, 233994),
(271286, '2a28A00', NULL, NULL, 54, NULL, NULL, 233994),
(271287, '1uecA01', NULL, NULL, 53, NULL, NULL, 233994),
(271288, '2yt6A01', NULL, NULL, 89, NULL, NULL, 233994),
(271289, '4m4zA01', NULL, NULL, 65, NULL, NULL, 233994),
(271290, '1x69A00', NULL, NULL, 79, NULL, NULL, 233994),
(271291, '3npfB01', NULL, NULL, 75, NULL, NULL, 233994),
(271292, '2vwfA00', NULL, NULL, 58, NULL, NULL, 233994),
(271293, '3c0cA00', NULL, NULL, 73, NULL, NULL, 233994),
(271294, '1utiA00', NULL, NULL, 58, NULL, NULL, 233994),
(271295, '2kt1A00', NULL, NULL, 88, NULL, NULL, 233994),
(271296, '2cudA00', NULL, NULL, 79, NULL, NULL, 233994),
(271297, '4r0kA02', NULL, NULL, 70, NULL, NULL, 233994),
(271298, '3o5zB00', NULL, NULL, 90, NULL, NULL, 233994),
(271299, '4r0kA01', NULL, NULL, 75, NULL, NULL, 233994),
(271300, '2k6dA00', NULL, NULL, 62, NULL, NULL, 233994),
(271301, '3ngpA00', NULL, NULL, 62, NULL, NULL, 233994);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(271302, '5f3yA05', NULL, NULL, 78, NULL, NULL, 233994),
(271303, '2vknA00', NULL, NULL, 70, NULL, NULL, 233994),
(271304, '1gbqA00', NULL, NULL, 74, NULL, NULL, 233994),
(271305, '3kfvA01', NULL, NULL, 124, NULL, NULL, 233994),
(271306, '6f55A00', NULL, NULL, 67, NULL, NULL, 233994),
(271307, '1jegA00', NULL, NULL, 83, NULL, NULL, 233994),
(271308, '6b25A01', NULL, NULL, 54, NULL, NULL, 233994),
(271309, '1jo8A00', NULL, NULL, 58, NULL, NULL, 233994),
(271310, '1wieA01', NULL, NULL, 64, NULL, NULL, 233994),
(271311, '4z88A00', NULL, NULL, 73, NULL, NULL, 233994),
(271312, '1wxbA00', NULL, NULL, 68, NULL, NULL, 233994),
(271313, '1w70A00', NULL, NULL, 60, NULL, NULL, 233994),
(271314, '1wyxA00', NULL, NULL, 69, NULL, NULL, 233994),
(271315, '2l0aA00', NULL, NULL, 72, NULL, NULL, 233994),
(271316, '2eqiA00', NULL, NULL, 69, NULL, NULL, 233994),
(271317, '4le9A00', NULL, NULL, 59, NULL, NULL, 233994),
(271318, '1tg0A00', NULL, NULL, 68, NULL, NULL, 233994),
(271319, '2g6fX00', NULL, NULL, 59, NULL, NULL, 233994),
(271320, '2ct3A00', NULL, NULL, 70, NULL, NULL, 233994),
(271321, '1jxmA01', NULL, NULL, 100, NULL, NULL, 233994),
(271322, '3dkmA00', NULL, NULL, 89, NULL, NULL, 233994),
(271323, '1nm7A00', NULL, NULL, 69, NULL, NULL, 233994),
(271324, '4krtA02', NULL, NULL, 68, NULL, NULL, 233994),
(271325, '2kymA01', NULL, NULL, 93, NULL, NULL, 233994),
(271326, '5k28A00', NULL, NULL, 64, NULL, NULL, 233994),
(271327, '1uhfA00', NULL, NULL, 69, NULL, NULL, 233994),
(271328, '1udlA00', NULL, NULL, 98, NULL, NULL, 233994),
(271329, '2jxbA00', NULL, NULL, 86, NULL, NULL, 233994),
(271330, '3bwsA01', NULL, NULL, 84, NULL, NULL, 233995),
(271331, '4ebrA00', NULL, NULL, 169, NULL, NULL, 233996),
(271332, '3vx7B00', NULL, NULL, 152, NULL, NULL, 233996),
(271333, '3khnB00', NULL, NULL, 174, NULL, NULL, 233997),
(271334, '2kgwA00', NULL, NULL, 129, NULL, NULL, 233997),
(271335, '2zvyB00', NULL, NULL, 183, NULL, NULL, 233997),
(271336, '2zovA00', NULL, NULL, 190, NULL, NULL, 233997),
(271337, '2aizP01', NULL, NULL, 109, NULL, NULL, 233997),
(271338, '4zhvB00', NULL, NULL, 135, NULL, NULL, 233997),
(271339, '2mqeA00', NULL, NULL, 146, NULL, NULL, 233997),
(271340, '3s0yB00', NULL, NULL, 165, NULL, NULL, 233997),
(271341, '4b5cB00', NULL, NULL, 121, NULL, NULL, 233997),
(271342, '3cypB00', NULL, NULL, 138, NULL, NULL, 233997),
(271343, '5u1hC00', NULL, NULL, 123, NULL, NULL, 233997),
(271344, '4b62A00', NULL, NULL, 157, NULL, NULL, 233997),
(271345, '3ldtA00', NULL, NULL, 153, NULL, NULL, 233997),
(271346, '4rhaA00', NULL, NULL, 146, NULL, NULL, 233997),
(271347, '1r1mA00', NULL, NULL, 143, NULL, NULL, 233997),
(271348, '6jfwA00', NULL, NULL, 141, NULL, NULL, 233997),
(271349, '5nhxA00', NULL, NULL, 126, NULL, NULL, 233997),
(271350, '4pwtC00', NULL, NULL, 131, NULL, NULL, 233997),
(271351, '4zhwA00', NULL, NULL, 111, NULL, NULL, 233997),
(271352, '3oonA00', NULL, NULL, 123, NULL, NULL, 233997),
(271353, '4g4xA00', NULL, NULL, 114, NULL, NULL, 233997),
(271354, '2hqsG00', NULL, NULL, 118, NULL, NULL, 233997),
(271355, '5wtpA00', NULL, NULL, 125, NULL, NULL, 233997),
(271356, '2k1sA00', NULL, NULL, 149, NULL, NULL, 233997),
(271357, '2zf8A02', NULL, NULL, 124, NULL, NULL, 233997),
(271358, '3wpwA00', NULL, NULL, 149, NULL, NULL, 233997),
(271359, '5n2cA00', NULL, NULL, 119, NULL, NULL, 233997),
(271360, '3td3D00', NULL, NULL, 123, NULL, NULL, 233997),
(271361, '5m3gB00', NULL, NULL, 115, NULL, NULL, 233997),
(271362, '4bqnB01', NULL, NULL, 185, NULL, NULL, 233998),
(271363, '2l6mA00', NULL, NULL, 101, NULL, NULL, 233999),
(271364, '3c8yA01', NULL, NULL, 124, NULL, NULL, 234000),
(271365, '1y56A01', NULL, NULL, 96, NULL, NULL, 234001),
(271366, '1u0jA01', NULL, NULL, 55, NULL, NULL, 234002),
(271367, '3p5nA00', NULL, NULL, 189, NULL, NULL, 234003),
(271368, '5d0yA00', NULL, NULL, 164, NULL, NULL, 234003),
(271369, '4huqS00', NULL, NULL, 174, NULL, NULL, 234003),
(271370, '4dveC00', NULL, NULL, 198, NULL, NULL, 234003),
(271371, '4z7fB00', NULL, NULL, 174, NULL, NULL, 234003),
(271372, '4tkrA00', NULL, NULL, 184, NULL, NULL, 234003);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(271373, '4m5bA00', NULL, NULL, 217, NULL, NULL, 234003),
(271374, '4rfsS00', NULL, NULL, 203, NULL, NULL, 234003),
(271375, '3rlbA00', NULL, NULL, 176, NULL, NULL, 234003),
(271376, '5kbwB00', NULL, NULL, 181, NULL, NULL, 234003),
(271377, '4hzuS00', NULL, NULL, 166, NULL, NULL, 234003),
(271378, '5jszC00', NULL, NULL, 184, NULL, NULL, 234003),
(271379, '3fdsD00', NULL, NULL, 245, NULL, NULL, 234004),
(271380, '3fdsC01', NULL, NULL, 244, NULL, NULL, 234004),
(271381, '1iz5A00', NULL, NULL, 249, NULL, NULL, 234004),
(271382, '3aizA01', NULL, NULL, 243, NULL, NULL, 234004),
(271383, '2z0lA00', NULL, NULL, 318, NULL, NULL, 234004),
(271384, '3ifvC00', NULL, NULL, 247, NULL, NULL, 234004),
(271385, '2avtA02', NULL, NULL, 200, NULL, NULL, 234004),
(271386, '5tupA00', NULL, NULL, 259, NULL, NULL, 234004),
(271387, '3aizC00', NULL, NULL, 246, NULL, NULL, 234004),
(271388, '5a6dA00', NULL, NULL, 249, NULL, NULL, 234004),
(271389, '4hk1A00', NULL, NULL, 263, NULL, NULL, 234004),
(271390, '3lx2A00', NULL, NULL, 259, NULL, NULL, 234004),
(271391, '5v7mA00', NULL, NULL, 265, NULL, NULL, 234004),
(271392, '3i2mX00', NULL, NULL, 309, NULL, NULL, 234004),
(271393, '3p91A00', NULL, NULL, 265, NULL, NULL, 234004),
(271394, '1b77A00', NULL, NULL, 228, NULL, NULL, 234004),
(271395, '2awaA02', NULL, NULL, 200, NULL, NULL, 234004),
(271396, '1u7bA00', NULL, NULL, 261, NULL, NULL, 234004),
(271397, '6drtA00', NULL, NULL, 236, NULL, NULL, 234004),
(271398, '1rwzA00', NULL, NULL, 245, NULL, NULL, 234004),
(271399, '1t6lA00', NULL, NULL, 270, NULL, NULL, 234004),
(271400, '1dmlA00', NULL, NULL, 291, NULL, NULL, 234004),
(271401, '4tr6A02', NULL, NULL, 200, NULL, NULL, 234004),
(271402, '2ijxA00', NULL, NULL, 244, NULL, NULL, 234004),
(271403, '6o09K00', NULL, NULL, 268, NULL, NULL, 234004),
(271404, '4cs5B00', NULL, NULL, 260, NULL, NULL, 234004),
(271405, '5h0tA00', NULL, NULL, 251, NULL, NULL, 234004),
(271406, '3a1jC00', NULL, NULL, 263, NULL, NULL, 234004),
(271407, '3a1jB00', NULL, NULL, 281, NULL, NULL, 234004),
(271408, '1ud9A00', NULL, NULL, 245, NULL, NULL, 234004),
(271409, '5daiA00', NULL, NULL, 255, NULL, NULL, 234004),
(271410, '3a1jA00', NULL, NULL, 266, NULL, NULL, 234004),
(271411, '1avyA00', NULL, NULL, 74, NULL, NULL, 234005),
(271412, '1avyB00', NULL, NULL, 55, NULL, NULL, 234005),
(271413, '6fqzA03', NULL, NULL, 32, NULL, NULL, 234005),
(271414, '2iz1A03', NULL, NULL, 36, NULL, NULL, 234005),
(271415, '1ox3A00', NULL, NULL, 109, NULL, NULL, 234005),
(271416, '1aa0A00', NULL, NULL, 113, NULL, NULL, 234005),
(271417, '2w90A03', NULL, NULL, 34, NULL, NULL, 234005),
(271418, '1pgjA03', NULL, NULL, 34, NULL, NULL, 234005),
(271419, '2zygA03', NULL, NULL, 34, NULL, NULL, 234005),
(271420, '3fwnA03', NULL, NULL, 34, NULL, NULL, 234005),
(271421, '1nayB00', NULL, NULL, 56, NULL, NULL, 234005),
(271422, '2pgdA03', NULL, NULL, 47, NULL, NULL, 234005),
(271423, '1pgd003', NULL, NULL, 34, NULL, NULL, 234005),
(271424, '2jd3A01', NULL, NULL, 79, NULL, NULL, 234006),
(271425, '3bt3A01', NULL, NULL, 88, NULL, NULL, 234007),
(271426, '2opcA00', NULL, NULL, 127, NULL, NULL, 234008),
(271427, '2qvtA00', NULL, NULL, 114, NULL, NULL, 234008),
(271428, '4injA02', NULL, NULL, 166, NULL, NULL, 234009),
(271429, '4eysA02', NULL, NULL, 185, NULL, NULL, 234009),
(271430, '3tlaA02', NULL, NULL, 174, NULL, NULL, 234009),
(271431, '4jvoA02', NULL, NULL, 169, NULL, NULL, 234009),
(271432, '5jybA02', NULL, NULL, 178, NULL, NULL, 234009),
(271433, '3g23A02', NULL, NULL, 107, NULL, NULL, 234009),
(271434, '4e5sA02', NULL, NULL, 170, NULL, NULL, 234009),
(271435, '1zl0B02', NULL, NULL, 139, NULL, NULL, 234009),
(271436, '3hl1A02', NULL, NULL, 65, NULL, NULL, 234010),
(271437, '3w9aB00', NULL, NULL, 245, NULL, NULL, 234011),
(271438, '4le3C00', NULL, NULL, 252, NULL, NULL, 234011),
(271439, '2vdwB02', NULL, NULL, 131, NULL, NULL, 234012),
(271440, '3oh3A02', NULL, NULL, 138, NULL, NULL, 234013),
(271441, '2xsjA02', NULL, NULL, 101, NULL, NULL, 234014),
(271442, '3mm5A02', NULL, NULL, 102, NULL, NULL, 234014),
(271443, '2v4jA02', NULL, NULL, 101, NULL, NULL, 234014);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(271444, '3or1A02', NULL, NULL, 101, NULL, NULL, 234014),
(271445, '3omlA02', NULL, NULL, 55, NULL, NULL, 234015),
(271446, '1zbqA02', NULL, NULL, 60, NULL, NULL, 234015),
(271447, '1gz6A02', NULL, NULL, 73, NULL, NULL, 234015),
(271448, '2xppA00', NULL, NULL, 145, NULL, NULL, 234016),
(271449, '1eo0A00', NULL, NULL, 77, NULL, NULL, 234016),
(271450, '3nfqB02', NULL, NULL, 108, NULL, NULL, 234016),
(271451, '3hphH00', NULL, NULL, 94, NULL, NULL, 234016),
(271452, '1wjtA00', NULL, NULL, 103, NULL, NULL, 234016),
(271453, '2b4jC00', NULL, NULL, 82, NULL, NULL, 234016),
(271454, '2waqB05', NULL, NULL, 93, NULL, NULL, 234017),
(271455, '3h0gB05', NULL, NULL, 82, NULL, NULL, 234017),
(271456, '2pmzB05', NULL, NULL, 93, NULL, NULL, 234017),
(271457, '4qiwB05', NULL, NULL, 82, NULL, NULL, 234017),
(271458, '1twfB05', NULL, NULL, 82, NULL, NULL, 234017),
(271459, '4c2mB05', NULL, NULL, 92, NULL, NULL, 234017),
(271460, '3d8lA00', NULL, NULL, 91, NULL, NULL, 234018),
(271461, '6nsjA00', NULL, NULL, 201, NULL, NULL, 234019),
(271462, '4lqzA00', NULL, NULL, 146, NULL, NULL, 234020),
(271463, '2etdA00', NULL, NULL, 171, NULL, NULL, 234021),
(271464, '3rmrB01', NULL, NULL, 54, NULL, NULL, 234022),
(271465, '3rmrC01', NULL, NULL, 70, NULL, NULL, 234022),
(271466, '2qqpA01', NULL, NULL, 58, NULL, NULL, 234023),
(271467, '2ocyA00', NULL, NULL, 154, NULL, NULL, 234024),
(271468, '2f42A01', NULL, NULL, 78, NULL, NULL, 234025),
(271469, '2a4hA01', NULL, NULL, 75, NULL, NULL, 234026),
(271470, '2a2pA01', NULL, NULL, 101, NULL, NULL, 234026),
(271471, '3me5A01', NULL, NULL, 71, NULL, NULL, 234027),
(271472, '4jc0A03', NULL, NULL, 120, NULL, NULL, 234028),
(271473, '2etxA01', NULL, NULL, 111, NULL, NULL, 234029),
(271474, '3olcX02', NULL, NULL, 98, NULL, NULL, 234029),
(271475, '3olcX01', NULL, NULL, 101, NULL, NULL, 234029),
(271476, '2e2wA01', NULL, NULL, 104, NULL, NULL, 234029),
(271477, '3pa6A00', NULL, NULL, 107, NULL, NULL, 234029),
(271478, '1gzhB01', NULL, NULL, 127, NULL, NULL, 234029),
(271479, '4gnsA03', NULL, NULL, 133, NULL, NULL, 234029),
(271480, '1l7bA00', NULL, NULL, 92, NULL, NULL, 234029),
(271481, '3olcX03', NULL, NULL, 99, NULL, NULL, 234029),
(271482, '3uenA01', NULL, NULL, 96, NULL, NULL, 234029),
(271483, '3u3zA02', NULL, NULL, 89, NULL, NULL, 234029),
(271484, '3u3zA01', NULL, NULL, 97, NULL, NULL, 234029),
(271485, '3ii6X03', NULL, NULL, 104, NULL, NULL, 234029),
(271486, '2ebwA00', NULL, NULL, 97, NULL, NULL, 234029),
(271487, '1wf6A01', NULL, NULL, 118, NULL, NULL, 234029),
(271488, '1t15A01', NULL, NULL, 110, NULL, NULL, 234029),
(271489, '2le0A00', NULL, NULL, 106, NULL, NULL, 234029),
(271490, '3l46B01', NULL, NULL, 89, NULL, NULL, 234029),
(271491, '2d8mA01', NULL, NULL, 92, NULL, NULL, 234029),
(271492, '2htfA00', NULL, NULL, 105, NULL, NULL, 234029),
(271493, '3ii6X01', NULL, NULL, 105, NULL, NULL, 234029),
(271494, '4xpzA03', NULL, NULL, 91, NULL, NULL, 234029),
(271495, '2xnkA02', NULL, NULL, 98, NULL, NULL, 234029),
(271496, '2xnkC02', NULL, NULL, 98, NULL, NULL, 234029),
(271497, '3uenA02', NULL, NULL, 107, NULL, NULL, 234029),
(271498, '2k6gA00', NULL, NULL, 109, NULL, NULL, 234029),
(271499, '1cdzA00', NULL, NULL, 96, NULL, NULL, 234029),
(271500, '2coeA01', NULL, NULL, 93, NULL, NULL, 234029),
(271501, '4bmdA01', NULL, NULL, 99, NULL, NULL, 234029),
(271502, '3sqdB01', NULL, NULL, 121, NULL, NULL, 234029),
(271503, '2ep8A01', NULL, NULL, 77, NULL, NULL, 234029),
(271504, '2couA01', NULL, NULL, 89, NULL, NULL, 234029),
(271505, '4bmdA02', NULL, NULL, 105, NULL, NULL, 234029),
(271506, '3k05B02', NULL, NULL, 98, NULL, NULL, 234029),
(271507, '2xnhA02', NULL, NULL, 98, NULL, NULL, 234029),
(271508, '1l0bA02', NULL, NULL, 98, NULL, NULL, 234029),
(271509, '1l0bA01', NULL, NULL, 107, NULL, NULL, 234029),
(271510, '2l42A00', NULL, NULL, 106, NULL, NULL, 234029),
(271511, '1z56C01', NULL, NULL, 130, NULL, NULL, 234029),
(271512, '3oq4E00', NULL, NULL, 100, NULL, NULL, 234029),
(271513, '3al2A02', NULL, NULL, 105, NULL, NULL, 234029),
(271514, '3al2A01', NULL, NULL, 130, NULL, NULL, 234029);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(271515, '3pd7A00', NULL, NULL, 107, NULL, NULL, 234029),
(271516, '4igkA02', NULL, NULL, 104, NULL, NULL, 234029),
(271517, '6hm5A02', NULL, NULL, 97, NULL, NULL, 234029),
(271518, '2nteA02', NULL, NULL, 104, NULL, NULL, 234029),
(271519, '6hm5A01', NULL, NULL, 101, NULL, NULL, 234029),
(271520, '2nteA01', NULL, NULL, 100, NULL, NULL, 234029),
(271521, '3i0nA02', NULL, NULL, 101, NULL, NULL, 234029),
(271522, '2vxbA02', NULL, NULL, 93, NULL, NULL, 234029),
(271523, '2vxbA01', NULL, NULL, 148, NULL, NULL, 234029),
(271524, '2ebuA01', NULL, NULL, 74, NULL, NULL, 234029),
(271525, '2jw5A00', NULL, NULL, 106, NULL, NULL, 234029),
(271526, '3jveA00', NULL, NULL, 109, NULL, NULL, 234029),
(271527, '3pc7A00', NULL, NULL, 88, NULL, NULL, 234029),
(271528, '4bu0A02', NULL, NULL, 85, NULL, NULL, 234029),
(271529, '2xnkB02', NULL, NULL, 98, NULL, NULL, 234029),
(271530, '1dgtB07', NULL, NULL, 86, NULL, NULL, 234029),
(271531, '5umvA00', NULL, NULL, 93, NULL, NULL, 234029),
(271532, '2xnkD02', NULL, NULL, 98, NULL, NULL, 234029),
(271533, '4bu0A01', NULL, NULL, 101, NULL, NULL, 234029),
(271534, '4n40A01', NULL, NULL, 100, NULL, NULL, 234029),
(271535, '2cokA00', NULL, NULL, 113, NULL, NULL, 234029),
(271536, '4n40A02', NULL, NULL, 90, NULL, NULL, 234029),
(271537, '4n40A03', NULL, NULL, 89, NULL, NULL, 234029),
(271538, '3t7kA01', NULL, NULL, 132, NULL, NULL, 234029),
(271539, '3t7kA02', NULL, NULL, 124, NULL, NULL, 234029),
(271540, '5u6kE01', NULL, NULL, 97, NULL, NULL, 234029),
(271541, '3hufB02', NULL, NULL, 101, NULL, NULL, 234029),
(271542, '3l41A02', NULL, NULL, 113, NULL, NULL, 234029),
(271543, '3sqdA02', NULL, NULL, 98, NULL, NULL, 234029),
(271544, '3l41A01', NULL, NULL, 107, NULL, NULL, 234029),
(271545, '3qvgB00', NULL, NULL, 106, NULL, NULL, 234029),
(271546, '5u6kA02', NULL, NULL, 103, NULL, NULL, 234029),
(271547, '3pc6A00', NULL, NULL, 104, NULL, NULL, 234029),
(271548, '1gzhD02', NULL, NULL, 119, NULL, NULL, 234029),
(271549, '3beyD00', NULL, NULL, 96, NULL, NULL, 234030),
(271550, '3d7iB00', NULL, NULL, 105, NULL, NULL, 234030),
(271551, '2q0tB01', NULL, NULL, 254, NULL, NULL, 234030),
(271552, '4g9qA00', NULL, NULL, 238, NULL, NULL, 234030),
(271553, '3c1lC02', NULL, NULL, 124, NULL, NULL, 234030),
(271554, '3c1lD02', NULL, NULL, 124, NULL, NULL, 234030),
(271555, '2ouwB00', NULL, NULL, 138, NULL, NULL, 234030),
(271556, '3lvyE01', NULL, NULL, 173, NULL, NULL, 234030),
(271557, '3c1lA02', NULL, NULL, 124, NULL, NULL, 234030),
(271558, '3c1lB02', NULL, NULL, 124, NULL, NULL, 234030),
(271559, '3c1lG02', NULL, NULL, 124, NULL, NULL, 234030),
(271560, '3c1lH02', NULL, NULL, 124, NULL, NULL, 234030),
(271561, '3c1lE02', NULL, NULL, 124, NULL, NULL, 234030),
(271562, '3c1lF02', NULL, NULL, 124, NULL, NULL, 234030),
(271563, '2prrA02', NULL, NULL, 129, NULL, NULL, 234030),
(271564, '2pfxA02', NULL, NULL, 125, NULL, NULL, 234030),
(271565, '2o4dA00', NULL, NULL, 144, NULL, NULL, 234030),
(271566, '1vkeE00', NULL, NULL, 133, NULL, NULL, 234030),
(271567, '1vkeB00', NULL, NULL, 101, NULL, NULL, 234030),
(271568, '2pfxB02', NULL, NULL, 125, NULL, NULL, 234030),
(271569, '2qeuB00', NULL, NULL, 141, NULL, NULL, 234030),
(271570, '1gu9C00', NULL, NULL, 177, NULL, NULL, 234030),
(271571, '2oyoA02', NULL, NULL, 125, NULL, NULL, 234030),
(271572, '3c1lK02', NULL, NULL, 124, NULL, NULL, 234030),
(271573, '2gmyD00', NULL, NULL, 153, NULL, NULL, 234030),
(271574, '2af7D00', NULL, NULL, 125, NULL, NULL, 234030),
(271575, '3c1lL02', NULL, NULL, 124, NULL, NULL, 234030),
(271576, '3c1lI02', NULL, NULL, 124, NULL, NULL, 234030),
(271577, '3c1lJ02', NULL, NULL, 124, NULL, NULL, 234030),
(271578, '5dikA00', NULL, NULL, 121, NULL, NULL, 234030),
(271579, '2cwqA00', NULL, NULL, 137, NULL, NULL, 234030),
(271580, '1xutA01', NULL, NULL, 35, NULL, NULL, 234031),
(271581, '2kn1A00', NULL, NULL, 51, NULL, NULL, 234031),
(271582, '1xk5A01', NULL, NULL, 199, NULL, NULL, 234032),
(271583, '1p16A02', NULL, NULL, 238, NULL, NULL, 234032),
(271584, '1b04A01', NULL, NULL, 130, NULL, NULL, 234032),
(271585, '3vnnA00', NULL, NULL, 139, NULL, NULL, 234032);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(271586, '4d05B02', NULL, NULL, 101, NULL, NULL, 234032),
(271587, '1zauA02', NULL, NULL, 251, NULL, NULL, 234032),
(271588, '3uq8A03', NULL, NULL, 134, NULL, NULL, 234032),
(271589, '1v9pA03', NULL, NULL, 132, NULL, NULL, 234032),
(271590, '3gjxB00', NULL, NULL, 304, NULL, NULL, 234032),
(271591, '3l2pA03', NULL, NULL, 120, NULL, NULL, 234032),
(271592, '3jslA03', NULL, NULL, 130, NULL, NULL, 234032),
(271593, '4glxA02', NULL, NULL, 143, NULL, NULL, 234032),
(271594, '4pz7A02', NULL, NULL, 236, NULL, NULL, 234032),
(271595, '1ckmA01', NULL, NULL, 165, NULL, NULL, 234032),
(271596, '1vs0A02', NULL, NULL, 110, NULL, NULL, 234032),
(271597, '4lh6A03', NULL, NULL, 130, NULL, NULL, 234032),
(271598, '2vugA03', NULL, NULL, 102, NULL, NULL, 234032),
(271599, '3gdeA02', NULL, NULL, 197, NULL, NULL, 234032),
(271600, '3nbzB00', NULL, NULL, 313, NULL, NULL, 234032),
(271601, '4eq5A02', NULL, NULL, 201, NULL, NULL, 234032),
(271602, '3w1bA02', NULL, NULL, 213, NULL, NULL, 234032),
(271603, '5d1pA03', NULL, NULL, 103, NULL, NULL, 234032),
(271604, '3rr5A02', NULL, NULL, 202, NULL, NULL, 234032),
(271605, '1x9nA03', NULL, NULL, 126, NULL, NULL, 234032),
(271606, '3bacA01', NULL, NULL, 232, NULL, NULL, 234032),
(271607, '2hivA02', NULL, NULL, 206, NULL, NULL, 234032),
(271608, '4e6nA01', NULL, NULL, 350, NULL, NULL, 234032),
(271609, '3kyhC01', NULL, NULL, 252, NULL, NULL, 234032),
(271610, '3qwuA02', NULL, NULL, 180, NULL, NULL, 234032),
(271611, '1fviA03', NULL, NULL, 107, NULL, NULL, 234032),
(271612, '1dgsA03', NULL, NULL, 132, NULL, NULL, 234032),
(271613, '3ty5B01', NULL, NULL, 319, NULL, NULL, 234032),
(271614, '4glwA01', NULL, NULL, 222, NULL, NULL, 234032),
(271615, '1a0iA03', NULL, NULL, 156, NULL, NULL, 234032),
(271616, '1xdnA02', NULL, NULL, 155, NULL, NULL, 234032),
(271617, '5tt5A02', NULL, NULL, 254, NULL, NULL, 234032),
(271618, '2cfmA02', NULL, NULL, 201, NULL, NULL, 234032),
(271619, '1s68A02', NULL, NULL, 113, NULL, NULL, 234032),
(271620, '3rtxA01', NULL, NULL, 165, NULL, NULL, 234032),
(271621, '1a41A02', NULL, NULL, 98, NULL, NULL, 234033),
(271622, '1g4mA01', NULL, NULL, 171, NULL, NULL, 234034),
(271623, '3uguA01', NULL, NULL, 172, NULL, NULL, 234034),
(271624, '3p2dA01', NULL, NULL, 177, NULL, NULL, 234034),
(271625, '1sujA01', NULL, NULL, 171, NULL, NULL, 234034),
(271626, '3cu7A07', NULL, NULL, 60, NULL, NULL, 234035),
(271627, '4akgA02', NULL, NULL, 168, NULL, NULL, 234036),
(271628, '3vkgA02', NULL, NULL, 152, NULL, NULL, 234036),
(271629, '4bl0B00', NULL, NULL, 58, NULL, NULL, 234037),
(271630, '4iikA00', NULL, NULL, 319, NULL, NULL, 234038),
(271631, '4zadA03', NULL, NULL, 36, NULL, NULL, 234039),
(271632, '4zacA03', NULL, NULL, 37, NULL, NULL, 234039),
(271633, '4ip2A03', NULL, NULL, 39, NULL, NULL, 234039),
(271634, '1n7zD01', NULL, NULL, 165, NULL, NULL, 234040),
(271635, '1n7zC01', NULL, NULL, 165, NULL, NULL, 234040),
(271636, '1n7zB01', NULL, NULL, 165, NULL, NULL, 234040),
(271637, '1n7zA01', NULL, NULL, 165, NULL, NULL, 234040),
(271638, '1n80A01', NULL, NULL, 165, NULL, NULL, 234040),
(271639, '2ahmG01', NULL, NULL, 104, NULL, NULL, 234041),
(271640, '2psbA00', NULL, NULL, 320, NULL, NULL, 234042),
(271641, '4ifdI01', NULL, NULL, 122, NULL, NULL, 234043),
(271642, '4oo1I01', NULL, NULL, 83, NULL, NULL, 234043),
(271643, '3k79A00', NULL, NULL, 63, NULL, NULL, 234044),
(271644, '4do2A00', NULL, NULL, 70, NULL, NULL, 234044),
(271645, '1nkdA00', NULL, NULL, 65, NULL, NULL, 234044),
(271646, '1pd3A00', NULL, NULL, 58, NULL, NULL, 234044),
(271647, '1f4nA00', NULL, NULL, 63, NULL, NULL, 234044),
(271648, '2v0pB00', NULL, NULL, 234, NULL, NULL, 234045),
(271649, '4iypA01', NULL, NULL, 211, NULL, NULL, 234045),
(271650, '3qc1A01', NULL, NULL, 175, NULL, NULL, 234045),
(271651, '3cjsA00', NULL, NULL, 59, NULL, NULL, 234046),
(271652, '3ajdA01', NULL, NULL, 68, NULL, NULL, 234046),
(271653, '2b9eA01', NULL, NULL, 86, NULL, NULL, 234046),
(271654, '3m6uA01', NULL, NULL, 90, NULL, NULL, 234046),
(271655, '2yxlA03', NULL, NULL, 58, NULL, NULL, 234046),
(271656, '3m4xA01', NULL, NULL, 94, NULL, NULL, 234046);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(271657, '1sqgA03', NULL, NULL, 58, NULL, NULL, 234046),
(271658, '1ixkA01', NULL, NULL, 107, NULL, NULL, 234046),
(271659, '1kp0B02', NULL, NULL, 246, NULL, NULL, 234047),
(271660, '1wy2A02', NULL, NULL, 226, NULL, NULL, 234047),
(271661, '2zsgA02', NULL, NULL, 228, NULL, NULL, 234047),
(271662, '4fukB01', NULL, NULL, 256, NULL, NULL, 234047),
(271663, '3cb6A02', NULL, NULL, 269, NULL, NULL, 234047),
(271664, '4zngA02', NULL, NULL, 230, NULL, NULL, 234047),
(271665, '4fo7B00', NULL, NULL, 261, NULL, NULL, 234047),
(271666, '1chmA02', NULL, NULL, 246, NULL, NULL, 234047),
(271667, '2v3zA02', NULL, NULL, 267, NULL, NULL, 234047),
(271668, '4egeA02', NULL, NULL, 231, NULL, NULL, 234047),
(271669, '5ce6A02', NULL, NULL, 262, NULL, NULL, 234047),
(271670, '3rvaA02', NULL, NULL, 294, NULL, NULL, 234047),
(271671, '3fm3A01', NULL, NULL, 232, NULL, NULL, 234047),
(271672, '3ig4A02', NULL, NULL, 256, NULL, NULL, 234047),
(271673, '3q6dA02', NULL, NULL, 228, NULL, NULL, 234047),
(271674, '6mrfA00', NULL, NULL, 270, NULL, NULL, 234047),
(271675, '5d6eA01', NULL, NULL, 231, NULL, NULL, 234047),
(271676, '5cnxA02', NULL, NULL, 236, NULL, NULL, 234047),
(271677, '1qxyA00', NULL, NULL, 252, NULL, NULL, 234047),
(271678, '4km3B00', NULL, NULL, 286, NULL, NULL, 234047),
(271679, '3s6bA01', NULL, NULL, 264, NULL, NULL, 234047),
(271680, '3biqA02', NULL, NULL, 274, NULL, NULL, 234047),
(271681, '1xgsA01', NULL, NULL, 218, NULL, NULL, 234047),
(271682, '1wn1A02', NULL, NULL, 227, NULL, NULL, 234047),
(271683, '2q8kA01', NULL, NULL, 307, NULL, NULL, 234047),
(271684, '1kp0A02', NULL, NULL, 246, NULL, NULL, 234047),
(271685, '3tb5A00', NULL, NULL, 264, NULL, NULL, 234047),
(271686, '4s2rQ03', NULL, NULL, 301, NULL, NULL, 234047),
(271687, '3ctzA03', NULL, NULL, 304, NULL, NULL, 234047),
(271688, '3l24B02', NULL, NULL, 283, NULL, NULL, 234047),
(271689, '1o0xA00', NULL, NULL, 262, NULL, NULL, 234047),
(271690, '6a9tA02', NULL, NULL, 269, NULL, NULL, 234047),
(271691, '4b28A02', NULL, NULL, 240, NULL, NULL, 234047),
(271692, '4ipaD01', NULL, NULL, 312, NULL, NULL, 234047),
(271693, '1qzyA01', NULL, NULL, 290, NULL, NULL, 234047),
(271694, '4r60A02', NULL, NULL, 235, NULL, NULL, 234047),
(271695, '4qr8A02', NULL, NULL, 284, NULL, NULL, 234047),
(271696, '5e5bA02', NULL, NULL, 260, NULL, NULL, 234047),
(271697, '2gg2A00', NULL, NULL, 263, NULL, NULL, 234047),
(271698, '4rzyA02', NULL, NULL, 240, NULL, NULL, 234047),
(271699, '4fkcA02', NULL, NULL, 229, NULL, NULL, 234047),
(271700, '5jr6B02', NULL, NULL, 298, NULL, NULL, 234047),
(271701, '3pkaA01', NULL, NULL, 244, NULL, NULL, 234047),
(271702, '1pv9A02', NULL, NULL, 226, NULL, NULL, 234047),
(271703, '2b3hA00', NULL, NULL, 304, NULL, NULL, 234047),
(271704, '6h2pA02', NULL, NULL, 307, NULL, NULL, 234047),
(271705, '5cdvA02', NULL, NULL, 225, NULL, NULL, 234047),
(271706, '4pv4A02', NULL, NULL, 274, NULL, NULL, 234047),
(271707, '3tavA00', NULL, NULL, 264, NULL, NULL, 234047),
(271708, '5wzeA02', NULL, NULL, 279, NULL, NULL, 234047),
(271709, '3mx6B00', NULL, NULL, 262, NULL, NULL, 234047),
(271710, '6a8mA02', NULL, NULL, 271, NULL, NULL, 234047),
(271711, '3n6xA02', NULL, NULL, 99, NULL, NULL, 234048),
(271712, '3bpjB00', NULL, NULL, 80, NULL, NULL, 234049),
(271713, '4u8uM01', NULL, NULL, 58, NULL, NULL, 234050),
(271714, '2gtlM01', NULL, NULL, 51, NULL, NULL, 234050),
(271715, '3af5A04', NULL, NULL, 188, NULL, NULL, 234051),
(271716, '6i1dA02', NULL, NULL, 187, NULL, NULL, 234051),
(271717, '2i7xA02', NULL, NULL, 203, NULL, NULL, 234051),
(271718, '2xr1B04', NULL, NULL, 189, NULL, NULL, 234051),
(271719, '3iekA02', NULL, NULL, 182, NULL, NULL, 234051),
(271720, '2ycbA04', NULL, NULL, 188, NULL, NULL, 234051),
(271721, '2i7vA02', NULL, NULL, 180, NULL, NULL, 234051),
(271722, '4twjA02', NULL, NULL, 99, NULL, NULL, 234052),
(271723, '6enxA02', NULL, NULL, 114, NULL, NULL, 234052),
(271724, '6eqsA02', NULL, NULL, 114, NULL, NULL, 234052),
(271725, '4rmhA02', NULL, NULL, 110, NULL, NULL, 234052),
(271726, '1q1aA02', NULL, NULL, 111, NULL, NULL, 234052),
(271727, '3u31A02', NULL, NULL, 99, NULL, NULL, 234052);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(271728, '4kxqA02', NULL, NULL, 114, NULL, NULL, 234052),
(271729, '4bn4A02', NULL, NULL, 108, NULL, NULL, 234052),
(271730, '2hjhA02', NULL, NULL, 139, NULL, NULL, 234052),
(271731, '1s5pA02', NULL, NULL, 95, NULL, NULL, 234052),
(271732, '1m2kA02', NULL, NULL, 93, NULL, NULL, 234052),
(271733, '1yc5A02', NULL, NULL, 95, NULL, NULL, 234052),
(271734, '2p84A01', NULL, NULL, 62, NULL, NULL, 234053),
(271735, '2fc6A00', NULL, NULL, 50, NULL, NULL, 234054),
(271736, '3lq9A00', NULL, NULL, 134, NULL, NULL, 234055),
(271737, '2jxmB01', NULL, NULL, 191, NULL, NULL, 234056),
(271738, '1hczA01', NULL, NULL, 193, NULL, NULL, 234056),
(271739, '4ogqC01', NULL, NULL, 192, NULL, NULL, 234056),
(271740, '1ci3M01', NULL, NULL, 190, NULL, NULL, 234056),
(271741, '1e2wA01', NULL, NULL, 191, NULL, NULL, 234056),
(271742, '4i7zC01', NULL, NULL, 192, NULL, NULL, 234056),
(271743, '1sluA00', NULL, NULL, 142, NULL, NULL, 234057),
(271744, '1ezsA00', NULL, NULL, 142, NULL, NULL, 234057),
(271745, '2y6tH00', NULL, NULL, 148, NULL, NULL, 234057),
(271746, '1fi8C00', NULL, NULL, 84, NULL, NULL, 234057),
(271747, '1xxfC00', NULL, NULL, 142, NULL, NULL, 234057),
(271748, '4nnqA02', NULL, NULL, 58, NULL, NULL, 234058),
(271749, '3lycD00', NULL, NULL, 241, NULL, NULL, 234059),
(271750, '3petA00', NULL, NULL, 221, NULL, NULL, 234059),
(271751, '3jx8D00', NULL, NULL, 250, NULL, NULL, 234059),
(271752, '3ljyB00', NULL, NULL, 243, NULL, NULL, 234059),
(271753, '4opwB00', NULL, NULL, 241, NULL, NULL, 234059),
(271754, '3agkA01', NULL, NULL, 139, NULL, NULL, 234060),
(271755, '1dt9A01', NULL, NULL, 105, NULL, NULL, 234060),
(271756, '3e1yA01', NULL, NULL, 136, NULL, NULL, 234060),
(271757, '3e20B01', NULL, NULL, 145, NULL, NULL, 234060),
(271758, '3od1A02', NULL, NULL, 72, NULL, NULL, 234061),
(271759, '2diiA01', NULL, NULL, 42, NULL, NULL, 234062),
(271760, '3rr2A02', NULL, NULL, 102, NULL, NULL, 234063),
(271761, '5z5cD01', NULL, NULL, 197, NULL, NULL, 234063),
(271762, '5z5cD02', NULL, NULL, 108, NULL, NULL, 234063),
(271763, '2o2eA01', NULL, NULL, 163, NULL, NULL, 234063),
(271764, '3rr2A01', NULL, NULL, 212, NULL, NULL, 234063),
(271765, '4lmaA01', NULL, NULL, 197, NULL, NULL, 234063),
(271766, '4lmaA02', NULL, NULL, 108, NULL, NULL, 234063),
(271767, '1kl7A03', NULL, NULL, 161, NULL, NULL, 234063),
(271768, '1kl7A02', NULL, NULL, 259, NULL, NULL, 234063),
(271769, '5b53A02', NULL, NULL, 108, NULL, NULL, 234063),
(271770, '1f2dA02', NULL, NULL, 102, NULL, NULL, 234063),
(271771, '2v03A02', NULL, NULL, 106, NULL, NULL, 234063),
(271772, '5ygrD02', NULL, NULL, 123, NULL, NULL, 234063),
(271773, '4ofxA02', NULL, NULL, 123, NULL, NULL, 234063),
(271774, '2v03A01', NULL, NULL, 184, NULL, NULL, 234063),
(271775, '1f2dA01', NULL, NULL, 219, NULL, NULL, 234063),
(271776, '1jbqA01', NULL, NULL, 194, NULL, NULL, 234063),
(271777, '4ofxA01', NULL, NULL, 196, NULL, NULL, 234063),
(271778, '5hbgA02', NULL, NULL, 102, NULL, NULL, 234063),
(271779, '5hbgA01', NULL, NULL, 211, NULL, NULL, 234063),
(271780, '5xoqA01', NULL, NULL, 208, NULL, NULL, 234063),
(271781, '5xoqA02', NULL, NULL, 101, NULL, NULL, 234063),
(271782, '5b53A01', NULL, NULL, 197, NULL, NULL, 234063),
(271783, '4aecA02', NULL, NULL, 108, NULL, NULL, 234063),
(271784, '1x1qA02', NULL, NULL, 217, NULL, NULL, 234063),
(271785, '2d1fA02', NULL, NULL, 98, NULL, NULL, 234063),
(271786, '2d1fA01', NULL, NULL, 262, NULL, NULL, 234063),
(271787, '1x1qA01', NULL, NULL, 164, NULL, NULL, 234063),
(271788, '1v71A01', NULL, NULL, 226, NULL, NULL, 234063),
(271789, '2pqmA02', NULL, NULL, 101, NULL, NULL, 234063),
(271790, '5xemB01', NULL, NULL, 208, NULL, NULL, 234063),
(271791, '3aeyA02', NULL, NULL, 97, NULL, NULL, 234063),
(271792, '4airB01', NULL, NULL, 188, NULL, NULL, 234063),
(271793, '2dh6A02', NULL, NULL, 169, NULL, NULL, 234063),
(271794, '2dh6A01', NULL, NULL, 162, NULL, NULL, 234063),
(271795, '1wkvA02', NULL, NULL, 211, NULL, NULL, 234063),
(271796, '1v71A02', NULL, NULL, 97, NULL, NULL, 234063),
(271797, '1wkvA03', NULL, NULL, 100, NULL, NULL, 234063),
(271798, '5b54C01', NULL, NULL, 196, NULL, NULL, 234063);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(271799, '5b54C02', NULL, NULL, 108, NULL, NULL, 234063),
(271800, '2q3bA02', NULL, NULL, 102, NULL, NULL, 234063),
(271801, '2q3bA01', NULL, NULL, 210, NULL, NULL, 234063),
(271802, '2gn0A02', NULL, NULL, 97, NULL, NULL, 234063),
(271803, '3r0xA01', NULL, NULL, 325, NULL, NULL, 234063),
(271804, '1tzjC02', NULL, NULL, 99, NULL, NULL, 234063),
(271805, '3r0xA02', NULL, NULL, 123, NULL, NULL, 234063),
(271806, '2jc3A01', NULL, NULL, 184, NULL, NULL, 234063),
(271807, '5i6dB01', NULL, NULL, 190, NULL, NULL, 234063),
(271808, '6am7B02', NULL, NULL, 230, NULL, NULL, 234063),
(271809, '4f4fA02', NULL, NULL, 228, NULL, NULL, 234063),
(271810, '5z5cA02', NULL, NULL, 108, NULL, NULL, 234063),
(271811, '2o2eB02', NULL, NULL, 159, NULL, NULL, 234063),
(271812, '5ey5B01', NULL, NULL, 164, NULL, NULL, 234063),
(271813, '4d9bC01', NULL, NULL, 212, NULL, NULL, 234063),
(271814, '5kinB02', NULL, NULL, 232, NULL, NULL, 234063),
(271815, '5kinB01', NULL, NULL, 163, NULL, NULL, 234063),
(271816, '5b1hA02', NULL, NULL, 102, NULL, NULL, 234063),
(271817, '5b1hA01', NULL, NULL, 208, NULL, NULL, 234063),
(271818, '5i7wB01', NULL, NULL, 201, NULL, NULL, 234063),
(271819, '2rkbA01', NULL, NULL, 227, NULL, NULL, 234063),
(271820, '1ve5A02', NULL, NULL, 94, NULL, NULL, 234063),
(271821, '5b55A01', NULL, NULL, 196, NULL, NULL, 234063),
(271822, '5ohxA02', NULL, NULL, 114, NULL, NULL, 234063),
(271823, '5ey5B02', NULL, NULL, 217, NULL, NULL, 234063),
(271824, '5ohxA01', NULL, NULL, 204, NULL, NULL, 234063),
(271825, '2rkbA02', NULL, NULL, 91, NULL, NULL, 234063),
(271826, '5z5cA01', NULL, NULL, 197, NULL, NULL, 234063),
(271827, '5b55A02', NULL, NULL, 108, NULL, NULL, 234063),
(271828, '4negB01', NULL, NULL, 157, NULL, NULL, 234063),
(271829, '1o58A02', NULL, NULL, 104, NULL, NULL, 234063),
(271830, '1z7wA02', NULL, NULL, 108, NULL, NULL, 234063),
(271831, '5d84A02', NULL, NULL, 111, NULL, NULL, 234063),
(271832, '3x44A01', NULL, NULL, 187, NULL, NULL, 234063),
(271833, '3x44A02', NULL, NULL, 106, NULL, NULL, 234063),
(271834, '1z7wA01', NULL, NULL, 190, NULL, NULL, 234063),
(271835, '2zsjA02', NULL, NULL, 97, NULL, NULL, 234063),
(271836, '5xemA02', NULL, NULL, 102, NULL, NULL, 234063),
(271837, '6cgqA01', NULL, NULL, 257, NULL, NULL, 234063),
(271838, '5d84A01', NULL, NULL, 189, NULL, NULL, 234063),
(271839, '5cvcA02', NULL, NULL, 97, NULL, NULL, 234063),
(271840, '2zsjA01', NULL, NULL, 255, NULL, NULL, 234063),
(271841, '5b54D01', NULL, NULL, 197, NULL, NULL, 234063),
(271842, '5b54D02', NULL, NULL, 108, NULL, NULL, 234063),
(271843, '2gn0B01', NULL, NULL, 227, NULL, NULL, 234063),
(271844, '4qysA02', NULL, NULL, 121, NULL, NULL, 234063),
(271845, '4h27A02', NULL, NULL, 95, NULL, NULL, 234063),
(271846, '6am7A01', NULL, NULL, 163, NULL, NULL, 234063),
(271847, '5tchD02', NULL, NULL, 225, NULL, NULL, 234063),
(271848, '3dwgA02', NULL, NULL, 107, NULL, NULL, 234063),
(271849, '4f4fA03', NULL, NULL, 149, NULL, NULL, 234063),
(271850, '1pwhA02', NULL, NULL, 92, NULL, NULL, 234063),
(271851, '4h27A01', NULL, NULL, 228, NULL, NULL, 234063),
(271852, '5z5cB01', NULL, NULL, 196, NULL, NULL, 234063),
(271853, '5z5cB02', NULL, NULL, 108, NULL, NULL, 234063),
(271854, '5c3uA01', NULL, NULL, 234, NULL, NULL, 234063),
(271855, '1tdjA01', NULL, NULL, 227, NULL, NULL, 234063),
(271856, '5c3uA02', NULL, NULL, 96, NULL, NULL, 234063),
(271857, '1tdjA02', NULL, NULL, 92, NULL, NULL, 234063),
(271858, '5ygrB01', NULL, NULL, 289, NULL, NULL, 234063),
(271859, '2c2bC01', NULL, NULL, 348, NULL, NULL, 234063),
(271860, '4cooB01', NULL, NULL, 205, NULL, NULL, 234063),
(271861, '5i7wA02', NULL, NULL, 114, NULL, NULL, 234063),
(271862, '6hteB02', NULL, NULL, 187, NULL, NULL, 234063),
(271863, '3ss7X01', NULL, NULL, 319, NULL, NULL, 234063),
(271864, '5b55B02', NULL, NULL, 108, NULL, NULL, 234063),
(271865, '1pweA01', NULL, NULL, 235, NULL, NULL, 234063),
(271866, '5b55B01', NULL, NULL, 196, NULL, NULL, 234063),
(271867, '4negA02', NULL, NULL, 177, NULL, NULL, 234063),
(271868, '3ss7X02', NULL, NULL, 123, NULL, NULL, 234063),
(271869, '1y7lA01', NULL, NULL, 212, NULL, NULL, 234063);
INSERT INTO "PUBLIC"."MODEL" VALUES
(271870, '1e5xB01', NULL, NULL, 316, NULL, NULL, 234063),
(271871, '1y7lA02', NULL, NULL, 103, NULL, NULL, 234063),
(271872, '3hmkA01', NULL, NULL, 223, NULL, NULL, 234063),
(271873, '4lmbA01', NULL, NULL, 219, NULL, NULL, 234063),
(271874, '4lmbA02', NULL, NULL, 103, NULL, NULL, 234063),
(271875, '5cvcB01', NULL, NULL, 249, NULL, NULL, 234063),
(271876, '3iauB01', NULL, NULL, 244, NULL, NULL, 234063),
(271877, '6hulB02', NULL, NULL, 190, NULL, NULL, 234063),
(271878, '5kzmB01', NULL, NULL, 163, NULL, NULL, 234063),
(271879, '6hulB01', NULL, NULL, 235, NULL, NULL, 234063),
(271880, '5kzmB02', NULL, NULL, 225, NULL, NULL, 234063),
(271881, '3hmkA02', NULL, NULL, 100, NULL, NULL, 234063),
(271882, '3v7nA03', NULL, NULL, 149, NULL, NULL, 234063),
(271883, '4qysB01', NULL, NULL, 255, NULL, NULL, 234063),
(271884, '3v7nA02', NULL, NULL, 238, NULL, NULL, 234063),
(271885, '1j0aA01', NULL, NULL, 220, NULL, NULL, 234063),
(271886, '1j0aA02', NULL, NULL, 104, NULL, NULL, 234063),
(271887, '4d9gB02', NULL, NULL, 119, NULL, NULL, 234063),
(271888, '5b54A01', NULL, NULL, 197, NULL, NULL, 234063),
(271889, '4d9iA02', NULL, NULL, 119, NULL, NULL, 234063),
(271890, '5b54A02', NULL, NULL, 108, NULL, NULL, 234063),
(271891, '5z5cC02', NULL, NULL, 108, NULL, NULL, 234063),
(271892, '1ve1A02', NULL, NULL, 108, NULL, NULL, 234063),
(271893, '1ve1A01', NULL, NULL, 183, NULL, NULL, 234063),
(271894, '5z5cC01', NULL, NULL, 196, NULL, NULL, 234063),
(271895, '1fcjA02', NULL, NULL, 108, NULL, NULL, 234063),
(271896, '1ve5C02', NULL, NULL, 58, NULL, NULL, 234063),
(271897, '1fcjA01', NULL, NULL, 181, NULL, NULL, 234063),
(271898, '3vc3A01', NULL, NULL, 189, NULL, NULL, 234063),
(271899, '3l6bA02', NULL, NULL, 100, NULL, NULL, 234063),
(271900, '3pc3A02', NULL, NULL, 114, NULL, NULL, 234063),
(271901, '3l6bA01', NULL, NULL, 229, NULL, NULL, 234063),
(271902, '3pc3A01', NULL, NULL, 205, NULL, NULL, 234063),
(271903, '4d9bA02', NULL, NULL, 109, NULL, NULL, 234063),
(271904, '6c2zA01', NULL, NULL, 206, NULL, NULL, 234063),
(271905, '3vc3A02', NULL, NULL, 108, NULL, NULL, 234063),
(271906, '4cooA02', NULL, NULL, 114, NULL, NULL, 234063),
(271907, '6c2zA02', NULL, NULL, 111, NULL, NULL, 234063),
(271908, '1ve5C01', NULL, NULL, 211, NULL, NULL, 234063),
(271909, '1tzkC01', NULL, NULL, 219, NULL, NULL, 234063),
(271910, '4aecB01', NULL, NULL, 189, NULL, NULL, 234063),
(271911, '1x1qB02', NULL, NULL, 189, NULL, NULL, 234063),
(271912, '1x1qB01', NULL, NULL, 189, NULL, NULL, 234063),
(271913, '1e5xA02', NULL, NULL, 102, NULL, NULL, 234063),
(271914, '1o58C01', NULL, NULL, 172, NULL, NULL, 234063),
(271915, '1vb3A03', NULL, NULL, 146, NULL, NULL, 234063),
(271916, '1vb3A02', NULL, NULL, 201, NULL, NULL, 234063),
(271917, '2pqmB01', NULL, NULL, 242, NULL, NULL, 234063),
(271918, '5ybwA01', NULL, NULL, 231, NULL, NULL, 234063),
(271919, '5ybwA02', NULL, NULL, 98, NULL, NULL, 234063),
(271920, '3aeyB01', NULL, NULL, 254, NULL, NULL, 234063),
(271921, '4airA02', NULL, NULL, 121, NULL, NULL, 234063),
(271922, '3iauA02', NULL, NULL, 97, NULL, NULL, 234063),
(271923, '5xw3A02', NULL, NULL, 120, NULL, NULL, 234063),
(271924, '5b54B02', NULL, NULL, 108, NULL, NULL, 234063),
(271925, '2eguA02', NULL, NULL, 119, NULL, NULL, 234063),
(271926, '5cgqB01', NULL, NULL, 164, NULL, NULL, 234063),
(271927, '2eguA01', NULL, NULL, 189, NULL, NULL, 234063),
(271928, '5cgqB02', NULL, NULL, 225, NULL, NULL, 234063),
(271929, '5xw3A01', NULL, NULL, 174, NULL, NULL, 234063),
(271930, '6nmxA02', NULL, NULL, 97, NULL, NULL, 234063),
(271931, '4d9gA02', NULL, NULL, 119, NULL, NULL, 234063),
(271932, '4d9kC01', NULL, NULL, 247, NULL, NULL, 234063),
(271933, '5b54B01', NULL, NULL, 196, NULL, NULL, 234063),
(271934, '2ou2A01', NULL, NULL, 58, NULL, NULL, 234064),
(271935, '2ozuA01', NULL, NULL, 65, NULL, NULL, 234064),
(271936, '2pq8A01', NULL, NULL, 60, NULL, NULL, 234064),
(271937, '3to7A01', NULL, NULL, 53, NULL, NULL, 234064),
(271938, '5k8bA02', NULL, NULL, 153, NULL, NULL, 234065),
(271939, '3gzdA01', NULL, NULL, 119, NULL, NULL, 234065),
(271940, '6d0aA03', NULL, NULL, 115, NULL, NULL, 234065);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(271941, '2hoxA03', NULL, NULL, 113, NULL, NULL, 234065),
(271942, '3bwnD01', NULL, NULL, 152, NULL, NULL, 234065),
(271943, '4zwvA02', NULL, NULL, 117, NULL, NULL, 234065),
(271944, '6f77C01', NULL, NULL, 171, NULL, NULL, 234065),
(271945, '3ii0A01', NULL, NULL, 117, NULL, NULL, 234065),
(271946, '5xmvA01', NULL, NULL, 169, NULL, NULL, 234065),
(271947, '3cq5A01', NULL, NULL, 148, NULL, NULL, 234065),
(271948, '3frkA02', NULL, NULL, 128, NULL, NULL, 234065),
(271949, '2hufA01', NULL, NULL, 144, NULL, NULL, 234065),
(271950, '4l0oH02', NULL, NULL, 143, NULL, NULL, 234065),
(271951, '4hvkA01', NULL, NULL, 128, NULL, NULL, 234065),
(271952, '5viuA01', NULL, NULL, 167, NULL, NULL, 234065),
(271953, '4fl0A01', NULL, NULL, 144, NULL, NULL, 234065),
(271954, '5dj1A01', NULL, NULL, 119, NULL, NULL, 234065),
(271955, '3n75A03', NULL, NULL, 170, NULL, NULL, 234065),
(271956, '2x5fA02', NULL, NULL, 104, NULL, NULL, 234065),
(271957, '6dvsA01', NULL, NULL, 205, NULL, NULL, 234065),
(271958, '3caiA01', NULL, NULL, 149, NULL, NULL, 234065),
(271959, '3ihjA01', NULL, NULL, 178, NULL, NULL, 234065),
(271960, '3tcmA01', NULL, NULL, 182, NULL, NULL, 234065),
(271961, '1uu2B01', NULL, NULL, 118, NULL, NULL, 234065),
(271962, '3piuA01', NULL, NULL, 173, NULL, NULL, 234065),
(271963, '3fslA01', NULL, NULL, 155, NULL, NULL, 234065),
(271964, '2ay1A01', NULL, NULL, 115, NULL, NULL, 234065),
(271965, '3bc8A03', NULL, NULL, 139, NULL, NULL, 234065),
(271966, '3lvmA01', NULL, NULL, 127, NULL, NULL, 234065),
(271967, '3pj0A02', NULL, NULL, 104, NULL, NULL, 234065),
(271968, '3l8aA01', NULL, NULL, 156, NULL, NULL, 234065),
(271969, '3lg0A01', NULL, NULL, 172, NULL, NULL, 234065),
(271970, '1t3iA01', NULL, NULL, 153, NULL, NULL, 234065),
(271971, '4grxA01', NULL, NULL, 168, NULL, NULL, 234065),
(271972, '3hmuB01', NULL, NULL, 199, NULL, NULL, 234065),
(271973, '1vjoA01', NULL, NULL, 131, NULL, NULL, 234065),
(271974, '5vwoA01', NULL, NULL, 154, NULL, NULL, 234065),
(271975, '1s0aA01', NULL, NULL, 158, NULL, NULL, 234065),
(271976, '4q6rA02', NULL, NULL, 131, NULL, NULL, 234065),
(271977, '3dr4A02', NULL, NULL, 125, NULL, NULL, 234065),
(271978, '3wy7D01', NULL, NULL, 120, NULL, NULL, 234065),
(271979, '1bj4A02', NULL, NULL, 160, NULL, NULL, 234065),
(271980, '5d95B01', NULL, NULL, 194, NULL, NULL, 234065),
(271981, '3op7A01', NULL, NULL, 153, NULL, NULL, 234065),
(271982, '3fq8A01', NULL, NULL, 178, NULL, NULL, 234065),
(271983, '3m5uA02', NULL, NULL, 105, NULL, NULL, 234065),
(271984, '2cjgA01', NULL, NULL, 168, NULL, NULL, 234065),
(271985, '3zrpA02', NULL, NULL, 121, NULL, NULL, 234065),
(271986, '3ndnA02', NULL, NULL, 137, NULL, NULL, 234065),
(271987, '1sffA01', NULL, NULL, 166, NULL, NULL, 234065),
(271988, '2fyfA02', NULL, NULL, 105, NULL, NULL, 234065),
(271989, '1b9hA02', NULL, NULL, 139, NULL, NULL, 234065),
(271990, '2cstA01', NULL, NULL, 115, NULL, NULL, 234065),
(271991, '4lnjA02', NULL, NULL, 89, NULL, NULL, 234065),
(271992, '3eleC01', NULL, NULL, 166, NULL, NULL, 234065),
(271993, '4adbC01', NULL, NULL, 160, NULL, NULL, 234065),
(271994, '1jg8A02', NULL, NULL, 96, NULL, NULL, 234065),
(271995, '1c7nA01', NULL, NULL, 164, NULL, NULL, 234065),
(271996, '1uu1B01', NULL, NULL, 132, NULL, NULL, 234065),
(271997, '3tqxA01', NULL, NULL, 135, NULL, NULL, 234065),
(271998, '5ghgA01', NULL, NULL, 145, NULL, NULL, 234065),
(271999, '2cfbA01', NULL, NULL, 144, NULL, NULL, 234065),
(272000, '3g7qA01', NULL, NULL, 176, NULL, NULL, 234065),
(272001, '3rchA03', NULL, NULL, 101, NULL, NULL, 234065),
(272002, '5ti8A01', NULL, NULL, 144, NULL, NULL, 234065),
(272003, '1o69A02', NULL, NULL, 150, NULL, NULL, 234065),
(272004, '4my5D01', NULL, NULL, 161, NULL, NULL, 234065),
(272005, '3qm2A01', NULL, NULL, 116, NULL, NULL, 234065),
(272006, '1tplA01', NULL, NULL, 202, NULL, NULL, 234065),
(272007, '3ftbA01', NULL, NULL, 112, NULL, NULL, 234065),
(272008, '3bb8A02', NULL, NULL, 132, NULL, NULL, 234065),
(272009, '2zy4B01', NULL, NULL, 158, NULL, NULL, 234065),
(272010, '3lvmB01', NULL, NULL, 176, NULL, NULL, 234065),
(272011, '3uwcA02', NULL, NULL, 128, NULL, NULL, 234065);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(272012, '2po3A02', NULL, NULL, 151, NULL, NULL, 234065),
(272013, '5torB01', NULL, NULL, 115, NULL, NULL, 234065),
(272014, '3i4jB01', NULL, NULL, 161, NULL, NULL, 234065),
(272015, '2c0rA02', NULL, NULL, 104, NULL, NULL, 234065),
(272016, '3mebA01', NULL, NULL, 121, NULL, NULL, 234065),
(272017, '4zm4D01', NULL, NULL, 192, NULL, NULL, 234065),
(272018, '4e3qB01', NULL, NULL, 169, NULL, NULL, 234065),
(272019, '1js3A03', NULL, NULL, 107, NULL, NULL, 234065),
(272020, '1xi9B01', NULL, NULL, 164, NULL, NULL, 234065),
(272021, '4nogA01', NULL, NULL, 173, NULL, NULL, 234065),
(272022, '1yaaA01', NULL, NULL, 115, NULL, NULL, 234065),
(272023, '2yrrA01', NULL, NULL, 112, NULL, NULL, 234065),
(272024, '4w5kA01', NULL, NULL, 111, NULL, NULL, 234065),
(272025, '1z7dA01', NULL, NULL, 157, NULL, NULL, 234065),
(272026, '4lw2A01', NULL, NULL, 133, NULL, NULL, 234065),
(272027, '4cvqA01', NULL, NULL, 163, NULL, NULL, 234065),
(272028, '3dydA01', NULL, NULL, 137, NULL, NULL, 234065),
(272029, '4a0gC02', NULL, NULL, 182, NULL, NULL, 234065),
(272030, '3n5mB01', NULL, NULL, 178, NULL, NULL, 234065),
(272031, '1n8pA02', NULL, NULL, 140, NULL, NULL, 234065),
(272032, '3a8uX01', NULL, NULL, 168, NULL, NULL, 234065),
(272033, '4lc3A02', NULL, NULL, 134, NULL, NULL, 234065),
(272034, '1wyuB02', NULL, NULL, 128, NULL, NULL, 234065),
(272035, '6gioA01', NULL, NULL, 182, NULL, NULL, 234065),
(272036, '1w23A02', NULL, NULL, 103, NULL, NULL, 234065),
(272037, '3e77A02', NULL, NULL, 108, NULL, NULL, 234065),
(272038, '1v72A01', NULL, NULL, 107, NULL, NULL, 234065),
(272039, '5xx1A03', NULL, NULL, 190, NULL, NULL, 234065),
(272040, '3f6tA01', NULL, NULL, 166, NULL, NULL, 234065),
(272041, '2o7cA02', NULL, NULL, 134, NULL, NULL, 234065),
(272042, '4h51A01', NULL, NULL, 113, NULL, NULL, 234065),
(272043, '6gwiA01', NULL, NULL, 186, NULL, NULL, 234065),
(272044, '1m32A01', NULL, NULL, 115, NULL, NULL, 234065),
(272045, '4r5zA01', NULL, NULL, 140, NULL, NULL, 234065),
(272046, '3ruyA01', NULL, NULL, 143, NULL, NULL, 234065),
(272047, '3pplB01', NULL, NULL, 183, NULL, NULL, 234065),
(272048, '3rq1D01', NULL, NULL, 179, NULL, NULL, 234065),
(272049, '2yobA01', NULL, NULL, 139, NULL, NULL, 234065),
(272050, '1eluA01', NULL, NULL, 124, NULL, NULL, 234065),
(272051, '4wydA01', NULL, NULL, 163, NULL, NULL, 234065),
(272052, '2epjA01', NULL, NULL, 184, NULL, NULL, 234065),
(272053, '2vi8A01', NULL, NULL, 154, NULL, NULL, 234065),
(272054, '4zm3B01', NULL, NULL, 150, NULL, NULL, 234065),
(272055, '3ly1D01', NULL, NULL, 129, NULL, NULL, 234065),
(272056, '2cb1A02', NULL, NULL, 135, NULL, NULL, 234065),
(272057, '2dkjA01', NULL, NULL, 155, NULL, NULL, 234065),
(272058, '5g0aA01', NULL, NULL, 199, NULL, NULL, 234065),
(272059, '1dfoA02', NULL, NULL, 137, NULL, NULL, 234065),
(272060, '4b9bB01', NULL, NULL, 168, NULL, NULL, 234065),
(272061, '1bs0A01', NULL, NULL, 132, NULL, NULL, 234065),
(272062, '4iy7D02', NULL, NULL, 136, NULL, NULL, 234065),
(272063, '3fkdA01', NULL, NULL, 136, NULL, NULL, 234065),
(272064, '4u2hH02', NULL, NULL, 142, NULL, NULL, 234065),
(272065, '5i92F01', NULL, NULL, 186, NULL, NULL, 234065),
(272066, '4ixoA01', NULL, NULL, 136, NULL, NULL, 234065),
(272067, '7aatA01', NULL, NULL, 115, NULL, NULL, 234065),
(272068, '1eg5B01', NULL, NULL, 121, NULL, NULL, 234065),
(272069, '5uc7A01', NULL, NULL, 159, NULL, NULL, 234065),
(272070, '2w8tA01', NULL, NULL, 149, NULL, NULL, 234065),
(272071, '2ogaA02', NULL, NULL, 127, NULL, NULL, 234065),
(272072, '1pffA02', NULL, NULL, 135, NULL, NULL, 234065),
(272073, '4uqvF02', NULL, NULL, 155, NULL, NULL, 234065),
(272074, '3nnkA02', NULL, NULL, 124, NULL, NULL, 234065),
(272075, '3ffrA01', NULL, NULL, 115, NULL, NULL, 234065),
(272076, '1wyuA01', NULL, NULL, 119, NULL, NULL, 234065),
(272077, '3asaA01', NULL, NULL, 151, NULL, NULL, 234065),
(272078, '3kkiA01', NULL, NULL, 154, NULL, NULL, 234065),
(272079, '3pdxA01', NULL, NULL, 135, NULL, NULL, 234065),
(272080, '2eh6A01', NULL, NULL, 130, NULL, NULL, 234065),
(272081, '5x5hA02', NULL, NULL, 138, NULL, NULL, 234065),
(272082, '5kr6A01', NULL, NULL, 179, NULL, NULL, 234065);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(272083, '2gb3A01', NULL, NULL, 175, NULL, NULL, 234065),
(272084, '2oqxA01', NULL, NULL, 201, NULL, NULL, 234065),
(272085, '3cbfA01', NULL, NULL, 180, NULL, NULL, 234065),
(272086, '5f8vA02', NULL, NULL, 115, NULL, NULL, 234065),
(272087, '6blgA02', NULL, NULL, 127, NULL, NULL, 234065),
(272088, '6onnA01', NULL, NULL, 136, NULL, NULL, 234065),
(272089, '1c4kA03', NULL, NULL, 180, NULL, NULL, 234065),
(272090, '4e1oA03', NULL, NULL, 98, NULL, NULL, 234065),
(272091, '3f0hA01', NULL, NULL, 110, NULL, NULL, 234065),
(272092, '3q8nA01', NULL, NULL, 191, NULL, NULL, 234065),
(272093, '5bj4A01', NULL, NULL, 162, NULL, NULL, 234065),
(272094, '1e5eA02', NULL, NULL, 144, NULL, NULL, 234065),
(272095, '3b1dC01', NULL, NULL, 164, NULL, NULL, 234065),
(272096, '2x5dA01', NULL, NULL, 128, NULL, NULL, 234065),
(272097, '1kkpA01', NULL, NULL, 161, NULL, NULL, 234065),
(272098, '4wbtA01', NULL, NULL, 151, NULL, NULL, 234065),
(272099, '2ykyB01', NULL, NULL, 190, NULL, NULL, 234065),
(272100, '1djuB01', NULL, NULL, 158, NULL, NULL, 234065),
(272101, '3gbxA02', NULL, NULL, 137, NULL, NULL, 234065),
(272102, '3n0lA02', NULL, NULL, 141, NULL, NULL, 234065),
(272103, '2ordA01', NULL, NULL, 153, NULL, NULL, 234065),
(272104, '3qguA01', NULL, NULL, 155, NULL, NULL, 234065),
(272105, '1svvB02', NULL, NULL, 95, NULL, NULL, 234065),
(272106, '2zy2A01', NULL, NULL, 176, NULL, NULL, 234065),
(272107, '5kquA01', NULL, NULL, 178, NULL, NULL, 234065),
(272108, '5f9sB01', NULL, NULL, 137, NULL, NULL, 234065),
(272109, '4ffcB01', NULL, NULL, 189, NULL, NULL, 234065),
(272110, '4j5uA01', NULL, NULL, 168, NULL, NULL, 234065),
(272111, '2zy4D01', NULL, NULL, 152, NULL, NULL, 234065),
(272112, '5vyeA01', NULL, NULL, 102, NULL, NULL, 234065),
(272113, '2bkwA01', NULL, NULL, 124, NULL, NULL, 234065),
(272114, '5wmkA01', NULL, NULL, 172, NULL, NULL, 234065),
(272115, '3ri6A02', NULL, NULL, 131, NULL, NULL, 234065),
(272116, '3qboA02', NULL, NULL, 104, NULL, NULL, 234065),
(272117, '4rkcA01', NULL, NULL, 156, NULL, NULL, 234065),
(272118, '3ffhA01', NULL, NULL, 136, NULL, NULL, 234065),
(272119, '2o1bA01', NULL, NULL, 157, NULL, NULL, 234065),
(272120, '6f35A01', NULL, NULL, 181, NULL, NULL, 234065),
(272121, '1wstA01', NULL, NULL, 191, NULL, NULL, 234065),
(272122, '4dq6A01', NULL, NULL, 167, NULL, NULL, 234065),
(272123, '6erkA01', NULL, NULL, 160, NULL, NULL, 234065),
(272124, '3aowA01', NULL, NULL, 179, NULL, NULL, 234065),
(272125, '5vnxA01', NULL, NULL, 135, NULL, NULL, 234065),
(272126, '1lc5A01', NULL, NULL, 132, NULL, NULL, 234065),
(272127, '1ejiA01', NULL, NULL, 180, NULL, NULL, 234065),
(272128, '4wb0A01', NULL, NULL, 113, NULL, NULL, 234065),
(272129, '3cogC02', NULL, NULL, 140, NULL, NULL, 234065),
(272130, '2douB01', NULL, NULL, 157, NULL, NULL, 234065),
(272131, '1iugA01', NULL, NULL, 115, NULL, NULL, 234065),
(272132, '3dxvA01', NULL, NULL, 152, NULL, NULL, 234065),
(272133, '3nuiA01', NULL, NULL, 156, NULL, NULL, 234065),
(272134, '4uoyA01', NULL, NULL, 213, NULL, NULL, 234065),
(272135, '3bs8A01', NULL, NULL, 190, NULL, NULL, 234065),
(272136, '4ao9A01', NULL, NULL, 194, NULL, NULL, 234065),
(272137, '4ix8A01', NULL, NULL, 145, NULL, NULL, 234065),
(272138, '4zahA02', NULL, NULL, 127, NULL, NULL, 234065),
(272139, '5jayA01', NULL, NULL, 136, NULL, NULL, 234065),
(272140, '3dodB01', NULL, NULL, 171, NULL, NULL, 234065),
(272141, '3fcrA01', NULL, NULL, 179, NULL, NULL, 234065),
(272142, '4w8iB01', NULL, NULL, 152, NULL, NULL, 234065),
(272143, '3k40A03', NULL, NULL, 99, NULL, NULL, 234065),
(272144, '2o0rA01', NULL, NULL, 152, NULL, NULL, 234065),
(272145, '4k2mA02', NULL, NULL, 132, NULL, NULL, 234065),
(272146, '6g4bA01', NULL, NULL, 184, NULL, NULL, 234065),
(272147, '3oksA01', NULL, NULL, 183, NULL, NULL, 234065),
(272148, '3b46A01', NULL, NULL, 172, NULL, NULL, 234065),
(272149, '2e7uA01', NULL, NULL, 175, NULL, NULL, 234065),
(272150, '4uhoA01', NULL, NULL, 155, NULL, NULL, 234065),
(272151, '5g4iB01', NULL, NULL, 167, NULL, NULL, 234065),
(272152, '5m49A01', NULL, NULL, 177, NULL, NULL, 234065),
(272153, '3ke3A01', NULL, NULL, 120, NULL, NULL, 234065);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(272154, '2qmaA02', NULL, NULL, 126, NULL, NULL, 234065),
(272155, '3hdoA01', NULL, NULL, 140, NULL, NULL, 234065),
(272156, '1bw0B01', NULL, NULL, 144, NULL, NULL, 234065),
(272157, '3k28A01', NULL, NULL, 181, NULL, NULL, 234065),
(272158, '5z0qD01', NULL, NULL, 162, NULL, NULL, 234065),
(272159, '4e77A01', NULL, NULL, 180, NULL, NULL, 234065),
(272160, '5hdmA01', NULL, NULL, 185, NULL, NULL, 234065),
(272161, '4y0hA01', NULL, NULL, 168, NULL, NULL, 234065),
(272162, '4jf1B01', NULL, NULL, 144, NULL, NULL, 234065),
(272163, '4m2mA01', NULL, NULL, 157, NULL, NULL, 234065),
(272164, '5vehB01', NULL, NULL, 170, NULL, NULL, 234065),
(272165, '3uakA01', NULL, NULL, 125, NULL, NULL, 234065),
(272166, '3nytA02', NULL, NULL, 123, NULL, NULL, 234065),
(272167, '1ax4A01', NULL, NULL, 201, NULL, NULL, 234065),
(272168, '5vmbA02', NULL, NULL, 138, NULL, NULL, 234065),
(272169, '5kqtA01', NULL, NULL, 178, NULL, NULL, 234065),
(272170, '4pvfB02', NULL, NULL, 161, NULL, NULL, 234065),
(272171, '3fddA03', NULL, NULL, 120, NULL, NULL, 234065),
(272172, '4p3mB02', NULL, NULL, 149, NULL, NULL, 234065),
(272173, '4wxgA01', NULL, NULL, 158, NULL, NULL, 234065),
(272174, '3d6kA01', NULL, NULL, 161, NULL, NULL, 234065),
(272175, '3f9tA01', NULL, NULL, 136, NULL, NULL, 234065),
(272176, '3aczA02', NULL, NULL, 134, NULL, NULL, 234065),
(272177, '1j32A01', NULL, NULL, 160, NULL, NULL, 234065),
(272178, '4w8iA01', NULL, NULL, 123, NULL, NULL, 234065),
(272179, '1fc4A02', NULL, NULL, 136, NULL, NULL, 234065),
(272180, '6czxA02', NULL, NULL, 105, NULL, NULL, 234065),
(272181, '1v2dA01', NULL, NULL, 150, NULL, NULL, 234065),
(272182, '1vefA01', NULL, NULL, 153, NULL, NULL, 234065),
(272183, '4iw7A01', NULL, NULL, 122, NULL, NULL, 234065),
(272184, '3ez1A01', NULL, NULL, 177, NULL, NULL, 234065),
(272185, '5c6uA01', NULL, NULL, 189, NULL, NULL, 234065),
(272186, '4xk1A02', NULL, NULL, 104, NULL, NULL, 234065),
(272187, '1u08A01', NULL, NULL, 146, NULL, NULL, 234065),
(272188, '3vaxA02', NULL, NULL, 95, NULL, NULL, 234065),
(272189, '4kamC02', NULL, NULL, 148, NULL, NULL, 234065),
(272190, '3ecdA02', NULL, NULL, 141, NULL, NULL, 234065),
(272191, '5u23A02', NULL, NULL, 117, NULL, NULL, 234065),
(272192, '3kgwB01', NULL, NULL, 145, NULL, NULL, 234065),
(272193, '2ctzA02', NULL, NULL, 136, NULL, NULL, 234065),
(272194, '3gjuA01', NULL, NULL, 180, NULL, NULL, 234065),
(272195, '4q75A01', NULL, NULL, 146, NULL, NULL, 234065),
(272196, '2ch1A01', NULL, NULL, 147, NULL, NULL, 234065),
(272197, '5yb0A02', NULL, NULL, 106, NULL, NULL, 234065),
(272198, '1mdoA02', NULL, NULL, 135, NULL, NULL, 234065),
(272199, '3r4tA01', NULL, NULL, 176, NULL, NULL, 234065),
(272200, '4wd2A01', NULL, NULL, 167, NULL, NULL, 234065),
(272201, '2z9vA01', NULL, NULL, 137, NULL, NULL, 234065),
(272202, '1jf9A01', NULL, NULL, 139, NULL, NULL, 234065),
(272203, '1cs1A02', NULL, NULL, 139, NULL, NULL, 234065),
(272204, '4msoB02', NULL, NULL, 137, NULL, NULL, 234065),
(272205, '3wgcB02', NULL, NULL, 92, NULL, NULL, 234065),
(272206, '3getA02', NULL, NULL, 94, NULL, NULL, 234065),
(272207, '3i5tB01', NULL, NULL, 182, NULL, NULL, 234065),
(272208, '6fyqA01', NULL, NULL, 180, NULL, NULL, 234065),
(272209, '2dr1A01', NULL, NULL, 140, NULL, NULL, 234065),
(272210, '4oc9A02', NULL, NULL, 137, NULL, NULL, 234065),
(272211, '4r8dB01', NULL, NULL, 151, NULL, NULL, 234065),
(272212, '4dbcA01', NULL, NULL, 115, NULL, NULL, 234065),
(272213, '2c81A02', NULL, NULL, 156, NULL, NULL, 234065),
(272214, '1vp4B01', NULL, NULL, 196, NULL, NULL, 234065),
(272215, '3fdbA01', NULL, NULL, 155, NULL, NULL, 234065),
(272216, '3a9zA01', NULL, NULL, 119, NULL, NULL, 234065),
(272217, '4a6rA01', NULL, NULL, 151, NULL, NULL, 234065),
(272218, '2eo5A01', NULL, NULL, 149, NULL, NULL, 234065),
(272219, '4emyA01', NULL, NULL, 175, NULL, NULL, 234065),
(272220, '3e9kA01', NULL, NULL, 192, NULL, NULL, 234065),
(272221, '3h7fA01', NULL, NULL, 186, NULL, NULL, 234065),
(272222, '5kr3B01', NULL, NULL, 179, NULL, NULL, 234065),
(272223, '1m7yA01', NULL, NULL, 172, NULL, NULL, 234065),
(272224, '1rv3A01', NULL, NULL, 170, NULL, NULL, 234065);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(272225, '3a2bA01', NULL, NULL, 138, NULL, NULL, 234065),
(272226, '3l44A01', NULL, NULL, 185, NULL, NULL, 234065),
(272227, '3lwsF02', NULL, NULL, 104, NULL, NULL, 234065),
(272228, '3ei9B01', NULL, NULL, 150, NULL, NULL, 234065),
(272229, '2vycA03', NULL, NULL, 190, NULL, NULL, 234065),
(272230, '2zc0A01', NULL, NULL, 181, NULL, NULL, 234065),
(272231, '5veqB01', NULL, NULL, 155, NULL, NULL, 234065),
(272232, '1qgnA02', NULL, NULL, 138, NULL, NULL, 234065),
(272233, '5j8qA01', NULL, NULL, 147, NULL, NULL, 234065),
(272234, '3islA01', NULL, NULL, 135, NULL, NULL, 234065),
(272235, '3dzzA01', NULL, NULL, 147, NULL, NULL, 234065),
(272236, '5vc2A02', NULL, NULL, 141, NULL, NULL, 234065),
(272237, '3p1tA01', NULL, NULL, 137, NULL, NULL, 234065),
(272238, '5o5cB02', NULL, NULL, 140, NULL, NULL, 234065),
(272239, '3cq4A01', NULL, NULL, 142, NULL, NULL, 234065),
(272240, '4isyC01', NULL, NULL, 157, NULL, NULL, 234065),
(272241, '5dx5A02', NULL, NULL, 133, NULL, NULL, 234065),
(272242, '5kqwA01', NULL, NULL, 178, NULL, NULL, 234065),
(272243, '4f5lA01', NULL, NULL, 115, NULL, NULL, 234065),
(272244, '3eucA01', NULL, NULL, 137, NULL, NULL, 234065),
(272245, '1ibjA02', NULL, NULL, 136, NULL, NULL, 234065),
(272246, '3qhxA02', NULL, NULL, 130, NULL, NULL, 234065),
(272247, '5usrA01', NULL, NULL, 131, NULL, NULL, 234065),
(272248, '3k7yA01', NULL, NULL, 134, NULL, NULL, 234065),
(272249, '3nraA01', NULL, NULL, 177, NULL, NULL, 234065),
(272250, '1iayA01', NULL, NULL, 170, NULL, NULL, 234065),
(272251, '4atqL01', NULL, NULL, 191, NULL, NULL, 234065),
(272252, '3madA02', NULL, NULL, 131, NULL, NULL, 234065),
(272253, '4w91B01', NULL, NULL, 138, NULL, NULL, 234065),
(272254, '1o4sA01', NULL, NULL, 164, NULL, NULL, 234065),
(272255, '5x6bJ01', NULL, NULL, 132, NULL, NULL, 234065),
(272256, '1zodA01', NULL, NULL, 141, NULL, NULL, 234065),
(272257, '4zdlA03', NULL, NULL, 133, NULL, NULL, 234065),
(272258, '3jtxB01', NULL, NULL, 148, NULL, NULL, 234065),
(272259, '2d5yA01', NULL, NULL, 115, NULL, NULL, 234065),
(272260, '4wlhA01', NULL, NULL, 164, NULL, NULL, 234065),
(272261, '2x8uA01', NULL, NULL, 154, NULL, NULL, 234065),
(272262, '1c7gA01', NULL, NULL, 199, NULL, NULL, 234065),
(272263, '1bjnA02', NULL, NULL, 104, NULL, NULL, 234065),
(272264, '4effA01', NULL, NULL, 113, NULL, NULL, 234065),
(272265, '4f4eA01', NULL, NULL, 158, NULL, NULL, 234065),
(272266, '4itxA02', NULL, NULL, 137, NULL, NULL, 234065),
(272267, '2fnuB02', NULL, NULL, 130, NULL, NULL, 234065),
(272268, '2rfvA02', NULL, NULL, 133, NULL, NULL, 234065),
(272269, '2z61A01', NULL, NULL, 159, NULL, NULL, 234065),
(272270, '3nx3A01', NULL, NULL, 148, NULL, NULL, 234065),
(272271, '4qgrA02', NULL, NULL, 123, NULL, NULL, 234065),
(272272, '2bwnB01', NULL, NULL, 165, NULL, NULL, 234065),
(272273, '3b8xA02', NULL, NULL, 124, NULL, NULL, 234065),
(272274, '4zasA02', NULL, NULL, 117, NULL, NULL, 234065),
(272275, '3ezsA01', NULL, NULL, 135, NULL, NULL, 234065),
(272276, '3t32A01', NULL, NULL, 134, NULL, NULL, 234065),
(272277, '1qz9A01', NULL, NULL, 155, NULL, NULL, 234065),
(272278, '3pgyB01', NULL, NULL, 164, NULL, NULL, 234065),
(272279, '2e7jA01', NULL, NULL, 119, NULL, NULL, 234065),
(272280, '1d2fB01', NULL, NULL, 146, NULL, NULL, 234065),
(272281, '1fg7A02', NULL, NULL, 129, NULL, NULL, 234065),
(272282, '3mc6A02', NULL, NULL, 131, NULL, NULL, 234065),
(272283, '4o6zA01', NULL, NULL, 169, NULL, NULL, 234065),
(272284, '2hcnA03', NULL, NULL, 96, NULL, NULL, 234066),
(272285, '2j7uA04', NULL, NULL, 73, NULL, NULL, 234066),
(272286, '2ojrA01', NULL, NULL, 33, NULL, NULL, 234067),
(272287, '3vdzA01', NULL, NULL, 33, NULL, NULL, 234067),
(272288, '2jvnA00', NULL, NULL, 126, NULL, NULL, 234068),
(272289, '1x0cA01', NULL, NULL, 171, NULL, NULL, 234069),
(272290, '1ogoX01', NULL, NULL, 203, NULL, NULL, 234069),
(272291, '3ug9A01', NULL, NULL, 36, NULL, NULL, 234070),
(272292, '4dt5A00', NULL, NULL, 143, NULL, NULL, 234071),
(272293, '3df7A01', NULL, NULL, 98, NULL, NULL, 234072),
(272294, '2wjvD01', NULL, NULL, 27, NULL, NULL, 234073),
(272295, '2qm4D02', NULL, NULL, 91, NULL, NULL, 234074);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(272296, '1ku9A02', NULL, NULL, 65, NULL, NULL, 234074),
(272297, '2r9aA02', NULL, NULL, 88, NULL, NULL, 234074),
(272298, '1m5iA00', NULL, NULL, 125, NULL, NULL, 234074),
(272299, '3a9sA02', NULL, NULL, 165, NULL, NULL, 234075),
(272300, '1fuiA02', NULL, NULL, 165, NULL, NULL, 234075),
(272301, '4c20A02', NULL, NULL, 165, NULL, NULL, 234075),
(272302, '5cyuA03', NULL, NULL, 83, NULL, NULL, 234076),
(272303, '4kk7A03', NULL, NULL, 83, NULL, NULL, 234076),
(272304, '3kv5A02', NULL, NULL, 286, NULL, NULL, 234077),
(272305, '6fqcA01', NULL, NULL, 290, NULL, NULL, 234077),
(272306, '3optA01', NULL, NULL, 328, NULL, NULL, 234077),
(272307, '3kv9A01', NULL, NULL, 285, NULL, NULL, 234077),
(272308, '5fyzA01', NULL, NULL, 334, NULL, NULL, 234077),
(272309, '4lxlA01', NULL, NULL, 334, NULL, NULL, 234077),
(272310, '6bgyA00', NULL, NULL, 330, NULL, NULL, 234077),
(272311, '5fjkA01', NULL, NULL, 332, NULL, NULL, 234077),
(272312, '4igqA00', NULL, NULL, 322, NULL, NULL, 234077),
(272313, '6g5xA01', NULL, NULL, 346, NULL, NULL, 234077),
(272314, '6f4qA00', NULL, NULL, 235, NULL, NULL, 234077),
(272315, '4qxbA01', NULL, NULL, 293, NULL, NULL, 234077),
(272316, '6fulA02', NULL, NULL, 344, NULL, NULL, 234077),
(272317, '5fzoA01', NULL, NULL, 351, NULL, NULL, 234077),
(272318, '6f6dA01', NULL, NULL, 301, NULL, NULL, 234077),
(272319, '3al5B01', NULL, NULL, 263, NULL, NULL, 234077),
(272320, '3puaA01', NULL, NULL, 286, NULL, NULL, 234077),
(272321, '3kv4A01', NULL, NULL, 361, NULL, NULL, 234077),
(272322, '5fwjA01', NULL, NULL, 312, NULL, NULL, 234077),
(272323, '2xxzA00', NULL, NULL, 332, NULL, NULL, 234077),
(272324, '3purA02', NULL, NULL, 299, NULL, NULL, 234077),
(272325, '4bxfA01', NULL, NULL, 240, NULL, NULL, 234077),
(272326, '4cswA01', NULL, NULL, 227, NULL, NULL, 234077),
(272327, '1vrbD01', NULL, NULL, 220, NULL, NULL, 234077),
(272328, '4c8dA00', NULL, NULL, 349, NULL, NULL, 234077),
(272329, '4litA01', NULL, NULL, 203, NULL, NULL, 234077),
(272330, '2wwuA01', NULL, NULL, 287, NULL, NULL, 234077),
(272331, '4ccjA01', NULL, NULL, 246, NULL, NULL, 234077),
(272332, '5phlA00', NULL, NULL, 332, NULL, NULL, 234077),
(272333, '2w2iC00', NULL, NULL, 324, NULL, NULL, 234077),
(272334, '1lshA02', NULL, NULL, 335, NULL, NULL, 234078),
(272335, '2o8rB02', NULL, NULL, 194, NULL, NULL, 234079),
(272336, '1xdpA02', NULL, NULL, 202, NULL, NULL, 234079),
(272337, '2g5gX02', NULL, NULL, 59, NULL, NULL, 234080),
(272338, '2cs7A00', NULL, NULL, 55, NULL, NULL, 234081),
(272339, '3d4rB01', NULL, NULL, 101, NULL, NULL, 234082),
(272340, '1mj4A00', NULL, NULL, 82, NULL, NULL, 234083),
(272341, '1cyoA00', NULL, NULL, 93, NULL, NULL, 234083),
(272342, '3lf5A00', NULL, NULL, 88, NULL, NULL, 234083),
(272343, '1x3xA00', NULL, NULL, 82, NULL, NULL, 234083),
(272344, '1do9A00', NULL, NULL, 94, NULL, NULL, 234083),
(272345, '1ib7A00', NULL, NULL, 94, NULL, NULL, 234083),
(272346, '1j03A00', NULL, NULL, 102, NULL, NULL, 234083),
(272347, '1lj0C00', NULL, NULL, 92, NULL, NULL, 234083),
(272348, '4x8yB00', NULL, NULL, 110, NULL, NULL, 234083),
(272349, '1m2iA00', NULL, NULL, 82, NULL, NULL, 234083),
(272350, '2keoA00', NULL, NULL, 92, NULL, NULL, 234083),
(272351, '3nerA00', NULL, NULL, 92, NULL, NULL, 234083),
(272352, '2i96A01', NULL, NULL, 76, NULL, NULL, 234083),
(272353, '3x34A00', NULL, NULL, 94, NULL, NULL, 234083),
(272354, '3ozzB00', NULL, NULL, 82, NULL, NULL, 234083),
(272355, '3ks0A00', NULL, NULL, 95, NULL, NULL, 234083),
(272356, '1soxA01', NULL, NULL, 88, NULL, NULL, 234083),
(272357, '2ibjA00', NULL, NULL, 88, NULL, NULL, 234083),
(272358, '4b8nB00', NULL, NULL, 91, NULL, NULL, 234083),
(272359, '1cxyA00', NULL, NULL, 90, NULL, NULL, 234083),
(272360, '4hilA00', NULL, NULL, 87, NULL, NULL, 234083),
(272361, '2yicA04', NULL, NULL, 162, NULL, NULL, 234084),
(272362, '2jgdA04', NULL, NULL, 159, NULL, NULL, 234084),
(272363, '3ndhA00', NULL, NULL, 225, NULL, NULL, 234085),
(272364, '1vtmP00', NULL, NULL, 158, NULL, NULL, 234086),
(272365, '1cgmE00', NULL, NULL, 161, NULL, NULL, 234086),
(272366, '6i5aA00', NULL, NULL, 159, NULL, NULL, 234086);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(272367, '1rmvA00', NULL, NULL, 157, NULL, NULL, 234086),
(272368, '3pdmP00', NULL, NULL, 162, NULL, NULL, 234086),
(272369, '2m5yA01', NULL, NULL, 90, NULL, NULL, 234087),
(272370, '3tzgA00', NULL, NULL, 252, NULL, NULL, 234088),
(272371, '3b2vA01', NULL, NULL, 66, NULL, NULL, 234089),
(272372, '4uv7A04', NULL, NULL, 141, NULL, NULL, 234089),
(272373, '3mzwA04', NULL, NULL, 87, NULL, NULL, 234089),
(272374, '4uv7A02', NULL, NULL, 115, NULL, NULL, 234089),
(272375, '1m6bA02', NULL, NULL, 110, NULL, NULL, 234089),
(272376, '4kroA04', NULL, NULL, 91, NULL, NULL, 234089),
(272377, '1m6bA04', NULL, NULL, 100, NULL, NULL, 234089),
(272378, '1m6bB04', NULL, NULL, 108, NULL, NULL, 234089),
(272379, '3u7uA04', NULL, NULL, 57, NULL, NULL, 234089),
(272380, '2ahxB04', NULL, NULL, 140, NULL, NULL, 234089),
(272381, '2ahxA02', NULL, NULL, 111, NULL, NULL, 234089),
(272382, '4bspA00', NULL, NULL, 99, NULL, NULL, 234089),
(272383, '1n8zC02', NULL, NULL, 124, NULL, NULL, 234089),
(272384, '4c9uD00', NULL, NULL, 93, NULL, NULL, 234089),
(272385, '4qxfC00', NULL, NULL, 84, NULL, NULL, 234089),
(272386, '1n8zC04', NULL, NULL, 123, NULL, NULL, 234089),
(272387, '3b2vA04', NULL, NULL, 66, NULL, NULL, 234089),
(272388, '3wlwA04', NULL, NULL, 54, NULL, NULL, 234089),
(272389, '4hrnC00', NULL, NULL, 79, NULL, NULL, 234089),
(272390, '4ufrB00', NULL, NULL, 120, NULL, NULL, 234089),
(272391, '3i2tA02', NULL, NULL, 120, NULL, NULL, 234089),
(272392, '3i2tA04', NULL, NULL, 76, NULL, NULL, 234089),
(272393, '4bsoA00', NULL, NULL, 126, NULL, NULL, 234089),
(272394, '1n8yC02', NULL, NULL, 124, NULL, NULL, 234089),
(272395, '4c9rD00', NULL, NULL, 121, NULL, NULL, 234089),
(272396, '4leoC04', NULL, NULL, 142, NULL, NULL, 234089),
(272397, '2hr7A02', NULL, NULL, 118, NULL, NULL, 234089),
(272398, '2hr7B02', NULL, NULL, 69, NULL, NULL, 234089),
(272399, '1n8yC04', NULL, NULL, 123, NULL, NULL, 234089),
(272400, '4krpA03', NULL, NULL, 67, NULL, NULL, 234089),
(272401, '1igrA02', NULL, NULL, 76, NULL, NULL, 234089),
(272402, '3hgfB00', NULL, NULL, 107, NULL, NULL, 234090),
(272403, '4d3zA02', NULL, NULL, 127, NULL, NULL, 234091),
(272404, '4fguB02', NULL, NULL, 135, NULL, NULL, 234091),
(272405, '4nomA02', NULL, NULL, 133, NULL, NULL, 234091),
(272406, '2ehoG02', NULL, NULL, 119, NULL, NULL, 234092),
(272407, '2ehoC02', NULL, NULL, 119, NULL, NULL, 234092),
(272408, '2e9xB02', NULL, NULL, 119, NULL, NULL, 234092),
(272409, '2ehoK02', NULL, NULL, 119, NULL, NULL, 234092),
(272410, '4kvmA02', NULL, NULL, 228, NULL, NULL, 234093),
(272411, '1cpyA02', NULL, NULL, 72, NULL, NULL, 234094),
(272412, '3fidA00', NULL, NULL, 296, NULL, NULL, 234095),
(272413, '4uqfG01', NULL, NULL, 67, NULL, NULL, 234096),
(272414, '4du6E01', NULL, NULL, 87, NULL, NULL, 234096),
(272415, '1wurA01', NULL, NULL, 54, NULL, NULL, 234096),
(272416, '1is8A01', NULL, NULL, 60, NULL, NULL, 234096),
(272417, '1a8rA01', NULL, NULL, 85, NULL, NULL, 234096),
(272418, '2vpzA03', NULL, NULL, 241, NULL, NULL, 234097),
(272419, '1g8kA03', NULL, NULL, 247, NULL, NULL, 234097),
(272420, '1dmrA02', NULL, NULL, 246, NULL, NULL, 234097),
(272421, '1eu1A02', NULL, NULL, 246, NULL, NULL, 234097),
(272422, '3ml1A03', NULL, NULL, 275, NULL, NULL, 234097),
(272423, '2nyaA03', NULL, NULL, 274, NULL, NULL, 234097),
(272424, '1tmoA02', NULL, NULL, 250, NULL, NULL, 234097),
(272425, '1ogyA03', NULL, NULL, 275, NULL, NULL, 234097),
(272426, '1h0hA03', NULL, NULL, 269, NULL, NULL, 234097),
(272427, '2napA03', NULL, NULL, 238, NULL, NULL, 234097),
(272428, '2iv2X03', NULL, NULL, 195, NULL, NULL, 234097),
(272429, '1q16A07', NULL, NULL, 128, NULL, NULL, 234097),
(272430, '1kqfA03', NULL, NULL, 267, NULL, NULL, 234097),
(272431, '1ti2A03', NULL, NULL, 292, NULL, NULL, 234097),
(272432, '2e7zA03', NULL, NULL, 205, NULL, NULL, 234097),
(272433, '5nqdA03', NULL, NULL, 271, NULL, NULL, 234097),
(272434, '1ho8A02', NULL, NULL, 112, NULL, NULL, 234098),
(272435, '5v75A02', NULL, NULL, 108, NULL, NULL, 234099),
(272436, '4qivA00', NULL, NULL, 92, NULL, NULL, 234099),
(272437, '3gfhA01', NULL, NULL, 121, NULL, NULL, 234099);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(272438, '3fchA02', NULL, NULL, 101, NULL, NULL, 234099),
(272439, '4ox8A01', NULL, NULL, 86, NULL, NULL, 234099),
(272440, '5v75A01', NULL, NULL, 104, NULL, NULL, 234099),
(272441, '3ssrA00', NULL, NULL, 110, NULL, NULL, 234099),
(272442, '3cimC00', NULL, NULL, 99, NULL, NULL, 234099),
(272443, '5djbA01', NULL, NULL, 85, NULL, NULL, 234099),
(272444, '4ox6A00', NULL, NULL, 127, NULL, NULL, 234099),
(272445, '4ox6B00', NULL, NULL, 93, NULL, NULL, 234099),
(272446, '3n79A01', NULL, NULL, 79, NULL, NULL, 234099),
(272447, '3n79A02', NULL, NULL, 113, NULL, NULL, 234099),
(272448, '4liwA00', NULL, NULL, 99, NULL, NULL, 234099),
(272449, '4axjB00', NULL, NULL, 104, NULL, NULL, 234099),
(272450, '4p7tB00', NULL, NULL, 91, NULL, NULL, 234099),
(272451, '4oloB00', NULL, NULL, 109, NULL, NULL, 234099),
(272452, '6fdbA01', NULL, NULL, 79, NULL, NULL, 234099),
(272453, '5lt5A02', NULL, NULL, 102, NULL, NULL, 234099),
(272454, '5lt5A01', NULL, NULL, 104, NULL, NULL, 234099),
(272455, '3vcdB02', NULL, NULL, 113, NULL, NULL, 234099),
(272456, '5l38A00', NULL, NULL, 101, NULL, NULL, 234099),
(272457, '3f56D01', NULL, NULL, 103, NULL, NULL, 234099),
(272458, '3pacA01', NULL, NULL, 78, NULL, NULL, 234099),
(272459, '3u27A02', NULL, NULL, 104, NULL, NULL, 234099),
(272460, '3u27A01', NULL, NULL, 116, NULL, NULL, 234099),
(272461, '5v76A01', NULL, NULL, 102, NULL, NULL, 234099),
(272462, '4ox7A00', NULL, NULL, 116, NULL, NULL, 234099),
(272463, '5v76A02', NULL, NULL, 104, NULL, NULL, 234099),
(272464, '3cgiA00', NULL, NULL, 124, NULL, NULL, 234099),
(272465, '3sssB00', NULL, NULL, 110, NULL, NULL, 234099),
(272466, '4qifA00', NULL, NULL, 102, NULL, NULL, 234099),
(272467, '3i96A00', NULL, NULL, 119, NULL, NULL, 234099),
(272468, '4ppdA00', NULL, NULL, 100, NULL, NULL, 234099),
(272469, '2ewhA01', NULL, NULL, 90, NULL, NULL, 234099),
(272470, '2a10D00', NULL, NULL, 105, NULL, NULL, 234099),
(272471, '4olpB00', NULL, NULL, 107, NULL, NULL, 234099),
(272472, '4axiB00', NULL, NULL, 125, NULL, NULL, 234099),
(272473, '5vguB00', NULL, NULL, 102, NULL, NULL, 234099),
(272474, '5diiA01', NULL, NULL, 79, NULL, NULL, 234099),
(272475, '5l39E02', NULL, NULL, 97, NULL, NULL, 234099),
(272476, '3i87A02', NULL, NULL, 104, NULL, NULL, 234099),
(272477, '3nwgA02', NULL, NULL, 103, NULL, NULL, 234099),
(272478, '3nwgA01', NULL, NULL, 79, NULL, NULL, 234099),
(272479, '5l39C01', NULL, NULL, 102, NULL, NULL, 234099),
(272480, '5suhB01', NULL, NULL, 106, NULL, NULL, 234099),
(272481, '5suhA02', NULL, NULL, 103, NULL, NULL, 234099),
(272482, '3mpyA00', NULL, NULL, 103, NULL, NULL, 234099),
(272483, '1g71A01', NULL, NULL, 239, NULL, NULL, 234100),
(272484, '2faoA01', NULL, NULL, 285, NULL, NULL, 234100),
(272485, '5of3A00', NULL, NULL, 330, NULL, NULL, 234100),
(272486, '1v33A01', NULL, NULL, 243, NULL, NULL, 234100),
(272487, '4limA00', NULL, NULL, 391, NULL, NULL, 234100),
(272488, '4likA00', NULL, NULL, 392, NULL, NULL, 234100),
(272489, '5d1pA01', NULL, NULL, 70, NULL, NULL, 234101),
(272490, '3qwuA01', NULL, NULL, 51, NULL, NULL, 234101),
(272491, '2vugA01', NULL, NULL, 61, NULL, NULL, 234101),
(272492, '1mw7A03', NULL, NULL, 75, NULL, NULL, 234102),
(272493, '4f3qA03', NULL, NULL, 76, NULL, NULL, 234102),
(272494, '1lfpA03', NULL, NULL, 73, NULL, NULL, 234102),
(272495, '1lfpA02', NULL, NULL, 95, NULL, NULL, 234102),
(272496, '4f3qA02', NULL, NULL, 87, NULL, NULL, 234102),
(272497, '1konA03', NULL, NULL, 75, NULL, NULL, 234102),
(272498, '1konA02', NULL, NULL, 90, NULL, NULL, 234102),
(272499, '1mw7A02', NULL, NULL, 87, NULL, NULL, 234102),
(272500, '2rbgA00', NULL, NULL, 126, NULL, NULL, 234103),
(272501, '3hxlA04', NULL, NULL, 79, NULL, NULL, 234104),
(272502, '1h7dA00', NULL, NULL, 49, NULL, NULL, 234105),
(272503, '2mekA00', NULL, NULL, 110, NULL, NULL, 234106),
(272504, '2gumB03', NULL, NULL, 150, NULL, NULL, 234107),
(272505, '2gumC03', NULL, NULL, 119, NULL, NULL, 234107),
(272506, '6escA03', NULL, NULL, 124, NULL, NULL, 234107),
(272507, '3fvcA03', NULL, NULL, 110, NULL, NULL, 234107),
(272508, '5cxfC02', NULL, NULL, 110, NULL, NULL, 234107);
INSERT INTO "PUBLIC"."MODEL" VALUES
(272509, '4osnA00', NULL, NULL, 129, NULL, NULL, 234107),
(272510, '3vw4A01', NULL, NULL, 95, NULL, NULL, 234108),
(272511, '4bjjB00', NULL, NULL, 100, NULL, NULL, 234109),
(272512, '1hj0A00', NULL, NULL, 41, NULL, NULL, 234110),
(272513, '4i1oF01', NULL, NULL, 150, NULL, NULL, 234111),
(272514, '4jvsA01', NULL, NULL, 131, NULL, NULL, 234111),
(272515, '4iruA01', NULL, NULL, 135, NULL, NULL, 234111),
(272516, '2yq3A03', NULL, NULL, 44, NULL, NULL, 234112),
(272517, '1us7B02', NULL, NULL, 53, NULL, NULL, 234113),
(272518, '4zdlA01', NULL, NULL, 74, NULL, NULL, 234114),
(272519, '3bc8A01', NULL, NULL, 74, NULL, NULL, 234114),
(272520, '4ja3A02', NULL, NULL, 43, NULL, NULL, 234115),
(272521, '1o5hA00', NULL, NULL, 214, NULL, NULL, 234116),
(272522, '1o5hB00', NULL, NULL, 214, NULL, NULL, 234116),
(272523, '2pfdA03', NULL, NULL, 203, NULL, NULL, 234116),
(272524, '1zeeA01', NULL, NULL, 123, NULL, NULL, 234117),
(272525, '4v19F00', NULL, NULL, 250, NULL, NULL, 234118),
(272526, '1vw3D00', NULL, NULL, 256, NULL, NULL, 234118),
(272527, '1vx7F01', NULL, NULL, 303, NULL, NULL, 234118),
(272528, '1dmgA00', NULL, NULL, 172, NULL, NULL, 234118),
(272529, '5dm7C00', NULL, NULL, 197, NULL, NULL, 234118),
(272530, '1vs6E00', NULL, NULL, 201, NULL, NULL, 234118),
(272531, '1vq8C00', NULL, NULL, 246, NULL, NULL, 234118),
(272532, '4a17C01', NULL, NULL, 309, NULL, NULL, 234118),
(272533, '3o58D00', NULL, NULL, 275, NULL, NULL, 234118),
(272534, '2j01F00', NULL, NULL, 210, NULL, NULL, 234118),
(272535, '5oomF00', NULL, NULL, 250, NULL, NULL, 234118),
(272536, '1vwxC01', NULL, NULL, 303, NULL, NULL, 234118),
(272537, '3seoB02', NULL, NULL, 101, NULL, NULL, 234119),
(272538, '2wzpP01', NULL, NULL, 109, NULL, NULL, 234120),
(272539, '3jstA00', NULL, NULL, 97, NULL, NULL, 234121),
(272540, '4wilB00', NULL, NULL, 105, NULL, NULL, 234121),
(272541, '4lowA00', NULL, NULL, 89, NULL, NULL, 234121),
(272542, '3hxaC00', NULL, NULL, 104, NULL, NULL, 234121),
(272543, '4c45A00', NULL, NULL, 104, NULL, NULL, 234121),
(272544, '1usmA00', NULL, NULL, 80, NULL, NULL, 234121),
(272545, '2ebbA00', NULL, NULL, 101, NULL, NULL, 234121),
(272546, '2v6uB00', NULL, NULL, 104, NULL, NULL, 234121),
(272547, '6fxwA00', NULL, NULL, 156, NULL, NULL, 234122),
(272548, '2vvpC00', NULL, NULL, 162, NULL, NULL, 234122),
(272549, '3he8A00', NULL, NULL, 149, NULL, NULL, 234122),
(272550, '2ppwB00', NULL, NULL, 216, NULL, NULL, 234122),
(272551, '3sgwA00', NULL, NULL, 158, NULL, NULL, 234122),
(272552, '3onoA00', NULL, NULL, 214, NULL, NULL, 234122),
(272553, '4em8A00', NULL, NULL, 148, NULL, NULL, 234122),
(272554, '1nn4A00', NULL, NULL, 162, NULL, NULL, 234122),
(272555, '5ifzA00', NULL, NULL, 129, NULL, NULL, 234122),
(272556, '6mu0A00', NULL, NULL, 160, NULL, NULL, 234122),
(272557, '6fxsB00', NULL, NULL, 154, NULL, NULL, 234122),
(272558, '1o1xA00', NULL, NULL, 155, NULL, NULL, 234122),
(272559, '4lflB00', NULL, NULL, 172, NULL, NULL, 234122),
(272560, '4u8fB00', NULL, NULL, 220, NULL, NULL, 234122),
(272561, '3c5yA00', NULL, NULL, 231, NULL, NULL, 234122),
(272562, '4lflA00', NULL, NULL, 142, NULL, NULL, 234122),
(272563, '3s5pA00', NULL, NULL, 148, NULL, NULL, 234122),
(272564, '3k7pA00', NULL, NULL, 159, NULL, NULL, 234122),
(272565, '3eipA00', NULL, NULL, 84, NULL, NULL, 234123),
(272566, '2zxrA01', NULL, NULL, 158, NULL, NULL, 234124),
(272567, '3zymA02', NULL, NULL, 157, NULL, NULL, 234125),
(272568, '3zylA02', NULL, NULL, 118, NULL, NULL, 234125),
(272569, '1hx8A02', NULL, NULL, 122, NULL, NULL, 234125),
(272570, '3zykB02', NULL, NULL, 130, NULL, NULL, 234125),
(272571, '4mi7A00', NULL, NULL, 140, NULL, NULL, 234126),
(272572, '1xhhA00', NULL, NULL, 91, NULL, NULL, 234127),
(272573, '3u1jB01', NULL, NULL, 94, NULL, NULL, 234128),
(272574, '5idkB01', NULL, NULL, 90, NULL, NULL, 234128),
(272575, '2ggvB01', NULL, NULL, 84, NULL, NULL, 234128),
(272576, '2f4lA02', NULL, NULL, 43, NULL, NULL, 234128),
(272577, '3syjA01', NULL, NULL, 298, NULL, NULL, 234128),
(272578, '3su0A01', NULL, NULL, 112, NULL, NULL, 234128),
(272579, '2ijd101', NULL, NULL, 180, NULL, NULL, 234128);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(272580, '3p8nA01', NULL, NULL, 88, NULL, NULL, 234128),
(272581, '5t69A01', NULL, NULL, 194, NULL, NULL, 234128),
(272582, '1wxrA01', NULL, NULL, 257, NULL, NULL, 234128),
(272583, '5gpiF01', NULL, NULL, 67, NULL, NULL, 234128),
(272584, '3szeA01', NULL, NULL, 321, NULL, NULL, 234128),
(272585, '4ri0A01', NULL, NULL, 222, NULL, NULL, 234128),
(272586, '5yofB01', NULL, NULL, 70, NULL, NULL, 234128),
(272587, '3lkwA01', NULL, NULL, 84, NULL, NULL, 234128),
(272588, '1befA01', NULL, NULL, 96, NULL, NULL, 234128),
(272589, '4a1xB01', NULL, NULL, 109, NULL, NULL, 234128),
(272590, '2wv9A01', NULL, NULL, 172, NULL, NULL, 234128),
(272591, '4r8tB01', NULL, NULL, 68, NULL, NULL, 234128),
(272592, '3pv2D01', NULL, NULL, 235, NULL, NULL, 234128),
(272593, '4b6eB01', NULL, NULL, 206, NULL, NULL, 234128),
(272594, '2ok5A02', NULL, NULL, 219, NULL, NULL, 234128),
(272595, '2fp7B01', NULL, NULL, 70, NULL, NULL, 234128),
(272596, '2fomB01', NULL, NULL, 68, NULL, NULL, 234128),
(272597, '1bt7A01', NULL, NULL, 73, NULL, NULL, 234128),
(272598, '4m9fA00', NULL, NULL, 247, NULL, NULL, 234128),
(272599, '3h09A01', NULL, NULL, 314, NULL, NULL, 234128),
(272600, '4om9A01', NULL, NULL, 316, NULL, NULL, 234128),
(272601, '3otpA01', NULL, NULL, 211, NULL, NULL, 234128),
(272602, '2whxA01', NULL, NULL, 157, NULL, NULL, 234128),
(272603, '5tfoB00', NULL, NULL, 161, NULL, NULL, 234128),
(272604, '2o8mB01', NULL, NULL, 66, NULL, NULL, 234128),
(272605, '2o8mA01', NULL, NULL, 105, NULL, NULL, 234128),
(272606, '5wdxA01', NULL, NULL, 112, NULL, NULL, 234128),
(272607, '2j8gA03', NULL, NULL, 58, NULL, NULL, 234129),
(272608, '2aqxB01', NULL, NULL, 265, NULL, NULL, 234130),
(272609, '2iewB00', NULL, NULL, 304, NULL, NULL, 234130),
(272610, '4frfA00', NULL, NULL, 246, NULL, NULL, 234130),
(272611, '2a98A00', NULL, NULL, 259, NULL, NULL, 234130),
(272612, '1w2dB00', NULL, NULL, 265, NULL, NULL, 234130),
(272613, '1tzdA00', NULL, NULL, 257, NULL, NULL, 234130),
(272614, '4o4fA00', NULL, NULL, 248, NULL, NULL, 234130),
(272615, '2y8yA01', NULL, NULL, 91, NULL, NULL, 234131),
(272616, '4dzdA01', NULL, NULL, 76, NULL, NULL, 234131),
(272617, '4od4A01', NULL, NULL, 156, NULL, NULL, 234132),
(272618, '1qpoA01', NULL, NULL, 119, NULL, NULL, 234133),
(272619, '1x1oA01', NULL, NULL, 143, NULL, NULL, 234133),
(272620, '3tqvA01', NULL, NULL, 140, NULL, NULL, 234133),
(272621, '3c2eA01', NULL, NULL, 145, NULL, NULL, 234133),
(272622, '4i9aA01', NULL, NULL, 142, NULL, NULL, 234133),
(272623, '2i1oA01', NULL, NULL, 116, NULL, NULL, 234133),
(272624, '2i14A01', NULL, NULL, 112, NULL, NULL, 234133),
(272625, '3gnnA01', NULL, NULL, 144, NULL, NULL, 234133),
(272626, '1o4uA01', NULL, NULL, 130, NULL, NULL, 234133),
(272627, '3l0gB01', NULL, NULL, 122, NULL, NULL, 234133),
(272628, '2jbmD01', NULL, NULL, 153, NULL, NULL, 234133),
(272629, '2b7nA01', NULL, NULL, 127, NULL, NULL, 234133),
(272630, '3pajB01', NULL, NULL, 152, NULL, NULL, 234133),
(272631, '1qapA01', NULL, NULL, 122, NULL, NULL, 234133),
(272632, '5huoE01', NULL, NULL, 141, NULL, NULL, 234133),
(272633, '2fkcA01', NULL, NULL, 110, NULL, NULL, 234134),
(272634, '3pieC08', NULL, NULL, 22, NULL, NULL, 234135),
(272635, '3sb1A02', NULL, NULL, 20, NULL, NULL, 234135),
(272636, '2mi6A00', NULL, NULL, 62, NULL, NULL, 234136),
(272637, '3pieC06', NULL, NULL, 61, NULL, NULL, 234136),
(272638, '4a17A02', NULL, NULL, 80, NULL, NULL, 234136),
(272639, '1vq8T00', NULL, NULL, 120, NULL, NULL, 234136),
(272640, '1vwxA02', NULL, NULL, 80, NULL, NULL, 234136),
(272641, '2l3rA02', NULL, NULL, 73, NULL, NULL, 234136),
(272642, '1ybyB01', NULL, NULL, 62, NULL, NULL, 234136),
(272643, '6g5iE03', NULL, NULL, 71, NULL, NULL, 234136),
(272644, '3kbgA03', NULL, NULL, 58, NULL, NULL, 234136),
(272645, '2g3rA02', NULL, NULL, 65, NULL, NULL, 234136),
(272646, '1uebA01', NULL, NULL, 63, NULL, NULL, 234136),
(272647, '3cpfA01', NULL, NULL, 70, NULL, NULL, 234136),
(272648, '2e70A00', NULL, NULL, 71, NULL, NULL, 234136),
(272649, '3db3A02', NULL, NULL, 76, NULL, NULL, 234136),
(272650, '1rl2A02', NULL, NULL, 80, NULL, NULL, 234136);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(272651, '1iz6A01', NULL, NULL, 70, NULL, NULL, 234136),
(272652, '1m1gB03', NULL, NULL, 63, NULL, NULL, 234136),
(272653, '2jufA00', NULL, NULL, 77, NULL, NULL, 234136),
(272654, '2jngA00', NULL, NULL, 80, NULL, NULL, 234136),
(272655, '5xxuE03', NULL, NULL, 71, NULL, NULL, 234136),
(272656, '3treA01', NULL, NULL, 68, NULL, NULL, 234136),
(272657, '2ckkA02', NULL, NULL, 57, NULL, NULL, 234136),
(272658, '1vs9S01', NULL, NULL, 72, NULL, NULL, 234136),
(272659, '4ytlA02', NULL, NULL, 49, NULL, NULL, 234136),
(272660, '4a17S00', NULL, NULL, 135, NULL, NULL, 234136),
(272661, '4ytlA01', NULL, NULL, 50, NULL, NULL, 234136),
(272662, '2j01D02', NULL, NULL, 78, NULL, NULL, 234136),
(272663, '3j7aF03', NULL, NULL, 71, NULL, NULL, 234136),
(272664, '5xyiE03', NULL, NULL, 71, NULL, NULL, 234136),
(272665, '1vx7D02', NULL, NULL, 80, NULL, NULL, 234136),
(272666, '4zn3A02', NULL, NULL, 62, NULL, NULL, 234136),
(272667, '6az1E03', NULL, NULL, 72, NULL, NULL, 234136),
(272668, '5optL03', NULL, NULL, 72, NULL, NULL, 234136),
(272669, '2xhcA03', NULL, NULL, 56, NULL, NULL, 234136),
(272670, '2jvvA00', NULL, NULL, 59, NULL, NULL, 234136),
(272671, '1bkbA01', NULL, NULL, 71, NULL, NULL, 234136),
(272672, '1vq8A02', NULL, NULL, 78, NULL, NULL, 234136),
(272673, '1vx7N01', NULL, NULL, 85, NULL, NULL, 234136),
(272674, '3hksA01', NULL, NULL, 69, NULL, NULL, 234136),
(272675, '5dm7R00', NULL, NULL, 110, NULL, NULL, 234136),
(272676, '3j7yD02', NULL, NULL, 81, NULL, NULL, 234136),
(272677, '1vx7Z00', NULL, NULL, 126, NULL, NULL, 234136),
(272678, '1khiA01', NULL, NULL, 75, NULL, NULL, 234136),
(272679, '2lclA00', NULL, NULL, 66, NULL, NULL, 234136),
(272680, '6faiE03', NULL, NULL, 71, NULL, NULL, 234136),
(272681, '5j3bA01', NULL, NULL, 73, NULL, NULL, 234136),
(272682, '3pioA02', NULL, NULL, 78, NULL, NULL, 234136),
(272683, '6em3M01', NULL, NULL, 83, NULL, NULL, 234136),
(272684, '1x6oA01', NULL, NULL, 68, NULL, NULL, 234136),
(272685, '3p8bB02', NULL, NULL, 66, NULL, NULL, 234136),
(272686, '1vwxY00', NULL, NULL, 145, NULL, NULL, 234136),
(272687, '6b9mC02', NULL, NULL, 79, NULL, NULL, 234136),
(272688, '3er0A01', NULL, NULL, 73, NULL, NULL, 234136),
(272689, '6em3Y00', NULL, NULL, 127, NULL, NULL, 234136),
(272690, '2xzmW03', NULL, NULL, 71, NULL, NULL, 234136),
(272691, '1vs6C02', NULL, NULL, 81, NULL, NULL, 234136),
(272692, '3o58B02', NULL, NULL, 80, NULL, NULL, 234136),
(272693, '2e6zA00', NULL, NULL, 59, NULL, NULL, 234136),
(272694, '2aw4U00', NULL, NULL, 103, NULL, NULL, 234136),
(272695, '5yyaA02', NULL, NULL, 76, NULL, NULL, 234136),
(272696, '3jamE03', NULL, NULL, 71, NULL, NULL, 234136),
(272697, '3oyyA01', NULL, NULL, 66, NULL, NULL, 234136),
(272698, '4tvrA02', NULL, NULL, 74, NULL, NULL, 234136),
(272699, '3a5zF01', NULL, NULL, 46, NULL, NULL, 234136),
(272700, '5hy6A01', NULL, NULL, 85, NULL, NULL, 234136),
(272701, '3a5zB01', NULL, NULL, 68, NULL, NULL, 234136),
(272702, '1vwxM01', NULL, NULL, 86, NULL, NULL, 234136),
(272703, '2eifA01', NULL, NULL, 70, NULL, NULL, 234136),
(272704, '2do3A01', NULL, NULL, 51, NULL, NULL, 234136),
(272705, '1nz9A00', NULL, NULL, 58, NULL, NULL, 234136),
(272706, '2kdsA01', NULL, NULL, 86, NULL, NULL, 234136),
(272707, '1jmuB02', NULL, NULL, 124, NULL, NULL, 234137),
(272708, '4i4tE01', NULL, NULL, 102, NULL, NULL, 234138),
(272709, '5jcbE01', NULL, NULL, 112, NULL, NULL, 234138),
(272710, '3bl4A01', NULL, NULL, 76, NULL, NULL, 234139),
(272711, '3bl4B01', NULL, NULL, 76, NULL, NULL, 234139),
(272712, '4l74A02', NULL, NULL, 30, NULL, NULL, 234140),
(272713, '1n1cA01', NULL, NULL, 126, NULL, NULL, 234141),
(272714, '3j27A05', NULL, NULL, 100, NULL, NULL, 234142),
(272715, '6co8A05', NULL, NULL, 100, NULL, NULL, 234142),
(272716, '5o6aA05', NULL, NULL, 100, NULL, NULL, 234142),
(272717, '4bxoA01', NULL, NULL, 145, NULL, NULL, 234143),
(272718, '4bxoB01', NULL, NULL, 145, NULL, NULL, 234143),
(272719, '2bgwB01', NULL, NULL, 138, NULL, NULL, 234143),
(272720, '2ziwB01', NULL, NULL, 176, NULL, NULL, 234143),
(272721, '1j24A00', NULL, NULL, 143, NULL, NULL, 234143);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(272722, '2ziuB01', NULL, NULL, 173, NULL, NULL, 234143),
(272723, '2a1iA01', NULL, NULL, 117, NULL, NULL, 234143),
(272724, '4o8sA01', NULL, NULL, 125, NULL, NULL, 234144),
(272725, '2zixA01', NULL, NULL, 55, NULL, NULL, 234145),
(272726, '4bbyB04', NULL, NULL, 125, NULL, NULL, 234146),
(272727, '2ra1A05', NULL, NULL, 86, NULL, NULL, 234147),
(272728, '2gd7B00', NULL, NULL, 107, NULL, NULL, 234148),
(272729, '4ba6A00', NULL, NULL, 144, NULL, NULL, 234149),
(272730, '4afmA00', NULL, NULL, 134, NULL, NULL, 234149),
(272731, '2jubA01', NULL, NULL, 37, NULL, NULL, 234150),
(272732, '2ddhA02', NULL, NULL, 133, NULL, NULL, 234151),
(272733, '3sf6A02', NULL, NULL, 104, NULL, NULL, 234151),
(272734, '2fonA02', NULL, NULL, 137, NULL, NULL, 234151),
(272735, '2rfqA02', NULL, NULL, 95, NULL, NULL, 234151),
(272736, '4n5fA02', NULL, NULL, 107, NULL, NULL, 234151),
(272737, '5iduC02', NULL, NULL, 108, NULL, NULL, 234151),
(272738, '4kcfA02', NULL, NULL, 111, NULL, NULL, 234151),
(272739, '4doyA02', NULL, NULL, 108, NULL, NULL, 234151),
(272740, '2dvlA02', NULL, NULL, 102, NULL, NULL, 234151),
(272741, '1w07A02', NULL, NULL, 137, NULL, NULL, 234151),
(272742, '2z1qA02', NULL, NULL, 106, NULL, NULL, 234151),
(272743, '2or0B02', NULL, NULL, 99, NULL, NULL, 234151),
(272744, '1udyA02', NULL, NULL, 121, NULL, NULL, 234151),
(272745, '2jifA02', NULL, NULL, 109, NULL, NULL, 234151),
(272746, '5zw7A02', NULL, NULL, 107, NULL, NULL, 234151),
(272747, '3mxlA02', NULL, NULL, 104, NULL, NULL, 234151),
(272748, '4u83A02', NULL, NULL, 107, NULL, NULL, 234151),
(272749, '4ktoC02', NULL, NULL, 118, NULL, NULL, 234151),
(272750, '2pg0A02', NULL, NULL, 109, NULL, NULL, 234151),
(272751, '1u8vA02', NULL, NULL, 133, NULL, NULL, 234151),
(272752, '2wbiB02', NULL, NULL, 117, NULL, NULL, 234151),
(272753, '4l1fA02', NULL, NULL, 118, NULL, NULL, 234151),
(272754, '4w9uD02', NULL, NULL, 107, NULL, NULL, 234151),
(272755, '3mpiA02', NULL, NULL, 107, NULL, NULL, 234151),
(272756, '6cxtB02', NULL, NULL, 107, NULL, NULL, 234151),
(272757, '6fahC02', NULL, NULL, 118, NULL, NULL, 234151),
(272758, '5mr6A02', NULL, NULL, 96, NULL, NULL, 234151),
(272759, '3r7kA02', NULL, NULL, 106, NULL, NULL, 234151),
(272760, '3nf4A02', NULL, NULL, 116, NULL, NULL, 234151),
(272761, '2ebaA02', NULL, NULL, 106, NULL, NULL, 234151),
(272762, '4hr3A02', NULL, NULL, 115, NULL, NULL, 234151),
(272763, '4rm7A02', NULL, NULL, 118, NULL, NULL, 234151),
(272764, '5xdcA02', NULL, NULL, 108, NULL, NULL, 234151),
(272765, '2c12A02', NULL, NULL, 134, NULL, NULL, 234151),
(272766, '3pfdA02', NULL, NULL, 107, NULL, NULL, 234151),
(272767, '4g5eA02', NULL, NULL, 125, NULL, NULL, 234151),
(272768, '4xvxB02', NULL, NULL, 107, NULL, NULL, 234151),
(272769, '1r2jA02', NULL, NULL, 106, NULL, NULL, 234151),
(272770, '1rx0A02', NULL, NULL, 105, NULL, NULL, 234151),
(272771, '4zyjD02', NULL, NULL, 106, NULL, NULL, 234151),
(272772, '3affA02', NULL, NULL, 95, NULL, NULL, 234151),
(272773, '2yykA02', NULL, NULL, 128, NULL, NULL, 234151),
(272774, '5k3hB02', NULL, NULL, 135, NULL, NULL, 234151),
(272775, '2jbrA02', NULL, NULL, 95, NULL, NULL, 234151),
(272776, '4p13A02', NULL, NULL, 121, NULL, NULL, 234151),
(272777, '3p4tA02', NULL, NULL, 106, NULL, NULL, 234151),
(272778, '3swoA02', NULL, NULL, 104, NULL, NULL, 234151),
(272779, '3ii9C02', NULL, NULL, 108, NULL, NULL, 234151),
(272780, '3hwcA02', NULL, NULL, 125, NULL, NULL, 234151),
(272781, '1ivhA02', NULL, NULL, 120, NULL, NULL, 234151),
(272782, '2ix5A02', NULL, NULL, 107, NULL, NULL, 234151),
(272783, '4o5mD02', NULL, NULL, 111, NULL, NULL, 234151),
(272784, '4irnA02', NULL, NULL, 107, NULL, NULL, 234151),
(272785, '3owaA02', NULL, NULL, 106, NULL, NULL, 234151),
(272786, '2d29A02', NULL, NULL, 111, NULL, NULL, 234151),
(272787, '4x28A02', NULL, NULL, 111, NULL, NULL, 234151),
(272788, '3mkhA02', NULL, NULL, 131, NULL, NULL, 234151),
(272789, '4x28C02', NULL, NULL, 101, NULL, NULL, 234151),
(272790, '1ukwA02', NULL, NULL, 110, NULL, NULL, 234151),
(272791, '4iv6A02', NULL, NULL, 109, NULL, NULL, 234151),
(272792, '2vigC02', NULL, NULL, 118, NULL, NULL, 234151);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(272793, '1jqiA02', NULL, NULL, 118, NULL, NULL, 234151),
(272794, '1bucA02', NULL, NULL, 119, NULL, NULL, 234151),
(272795, '5jscA02', NULL, NULL, 116, NULL, NULL, 234151),
(272796, '2uxwA03', NULL, NULL, 115, NULL, NULL, 234151),
(272797, '1siqA02', NULL, NULL, 107, NULL, NULL, 234151),
(272798, '5k3jB02', NULL, NULL, 139, NULL, NULL, 234151),
(272799, '4m9aB02', NULL, NULL, 107, NULL, NULL, 234151),
(272800, '5lnxF02', NULL, NULL, 118, NULL, NULL, 234151),
(272801, '3ujzA03', NULL, NULL, 100, NULL, NULL, 234152),
(272802, '4ex8A00', NULL, NULL, 316, NULL, NULL, 234153),
(272803, '1vkmA00', NULL, NULL, 297, NULL, NULL, 234153),
(272804, '4gimC00', NULL, NULL, 307, NULL, NULL, 234153),
(272805, '3rlfF02', NULL, NULL, 86, NULL, NULL, 234154),
(272806, '1irxA04', NULL, NULL, 113, NULL, NULL, 234155),
(272807, '3gcmA02', NULL, NULL, 80, NULL, NULL, 234156),
(272808, '3h36A00', NULL, NULL, 93, NULL, NULL, 234156),
(272809, '4nbqB02', NULL, NULL, 88, NULL, NULL, 234156),
(272810, '4aidA02', NULL, NULL, 82, NULL, NULL, 234156),
(272811, '1e3pA02', NULL, NULL, 83, NULL, NULL, 234156),
(272812, '3u1kA02', NULL, NULL, 86, NULL, NULL, 234156),
(272813, '1whuA00', NULL, NULL, 104, NULL, NULL, 234156),
(272814, '2gs8A02', NULL, NULL, 140, NULL, NULL, 234157),
(272815, '3gonA02', NULL, NULL, 140, NULL, NULL, 234157),
(272816, '1uekA02', NULL, NULL, 127, NULL, NULL, 234157),
(272817, '3k17A02', NULL, NULL, 140, NULL, NULL, 234157),
(272818, '2r3vA02', NULL, NULL, 148, NULL, NULL, 234157),
(272819, '1kvkA02', NULL, NULL, 148, NULL, NULL, 234157),
(272820, '2ww4A02', NULL, NULL, 119, NULL, NULL, 234157),
(272821, '3pyfA02', NULL, NULL, 143, NULL, NULL, 234157),
(272822, '3d4jA02', NULL, NULL, 195, NULL, NULL, 234157),
(272823, '1s4eG02', NULL, NULL, 166, NULL, NULL, 234157),
(272824, '1pieA02', NULL, NULL, 177, NULL, NULL, 234157),
(272825, '3ltoA02', NULL, NULL, 142, NULL, NULL, 234157),
(272826, '3f0nB02', NULL, NULL, 195, NULL, NULL, 234157),
(272827, '1kkhA02', NULL, NULL, 131, NULL, NULL, 234157),
(272828, '2v8pA02', NULL, NULL, 115, NULL, NULL, 234157),
(272829, '2oi2A02', NULL, NULL, 134, NULL, NULL, 234157),
(272830, '5v2mA02', NULL, NULL, 151, NULL, NULL, 234157),
(272831, '2x7iA02', NULL, NULL, 138, NULL, NULL, 234157),
(272832, '5gmdA02', NULL, NULL, 142, NULL, NULL, 234157),
(272833, '2hfsA02', NULL, NULL, 149, NULL, NULL, 234157),
(272834, '4rpfA02', NULL, NULL, 133, NULL, NULL, 234157),
(272835, '3qt5A02', NULL, NULL, 146, NULL, NULL, 234157),
(272836, '2cz9A02', NULL, NULL, 175, NULL, NULL, 234157),
(272837, '6q3wB02', NULL, NULL, 170, NULL, NULL, 234157),
(272838, '2hk2A02', NULL, NULL, 146, NULL, NULL, 234157),
(272839, '4hacA02', NULL, NULL, 129, NULL, NULL, 234157),
(272840, '3hulA02', NULL, NULL, 129, NULL, NULL, 234157),
(272841, '4p52A02', NULL, NULL, 135, NULL, NULL, 234157),
(272842, '4emdA02', NULL, NULL, 143, NULL, NULL, 234157),
(272843, '2hkeA02', NULL, NULL, 196, NULL, NULL, 234157),
(272844, '1h72C02', NULL, NULL, 135, NULL, NULL, 234157),
(272845, '4uskA02', NULL, NULL, 154, NULL, NULL, 234157),
(272846, '1fi4A02', NULL, NULL, 198, NULL, NULL, 234157),
(272847, '1u34A00', NULL, NULL, 119, NULL, NULL, 234158),
(272848, '3ehuA03', NULL, NULL, 84, NULL, NULL, 234158),
(272849, '4dlqA01', NULL, NULL, 60, NULL, NULL, 234158),
(272850, '4zgmA00', NULL, NULL, 105, NULL, NULL, 234158),
(272851, '3n7sA00', NULL, NULL, 115, NULL, NULL, 234158),
(272852, '2jndA00', NULL, NULL, 90, NULL, NULL, 234158),
(272853, '3c4mA03', NULL, NULL, 96, NULL, NULL, 234158),
(272854, '5ii0A00', NULL, NULL, 105, NULL, NULL, 234158),
(272855, '3aqfB00', NULL, NULL, 101, NULL, NULL, 234158),
(272856, '2jodA01', NULL, NULL, 87, NULL, NULL, 234158),
(272857, '4ersA00', NULL, NULL, 96, NULL, NULL, 234158),
(272858, '2xdgA01', NULL, NULL, 71, NULL, NULL, 234158),
(272859, '2qkhA00', NULL, NULL, 94, NULL, NULL, 234158),
(272860, '4dloB01', NULL, NULL, 72, NULL, NULL, 234158),
(272861, '3n93B04', NULL, NULL, 74, NULL, NULL, 234158),
(272862, '1ccwB02', NULL, NULL, 66, NULL, NULL, 234159),
(272863, '1pvtA00', NULL, NULL, 238, NULL, NULL, 234160);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(272864, '2fk5A00', NULL, NULL, 200, NULL, NULL, 234160),
(272865, '2v9lA00', NULL, NULL, 274, NULL, NULL, 234160),
(272866, '1k0wA00', NULL, NULL, 231, NULL, NULL, 234160),
(272867, '3m4rA01', NULL, NULL, 208, NULL, NULL, 234160),
(272868, '2opiB00', NULL, NULL, 212, NULL, NULL, 234160),
(272869, '2irpA00', NULL, NULL, 208, NULL, NULL, 234160),
(272870, '2z7bA00', NULL, NULL, 237, NULL, NULL, 234160),
(272871, '1e4cP00', NULL, NULL, 215, NULL, NULL, 234160),
(272872, '3ocrB00', NULL, NULL, 253, NULL, NULL, 234160),
(272873, '6btdA00', NULL, NULL, 203, NULL, NULL, 234160),
(272874, '2pb9A00', NULL, NULL, 195, NULL, NULL, 234160),
(272875, '4xxfA00', NULL, NULL, 258, NULL, NULL, 234160),
(272876, '4c24A00', NULL, NULL, 217, NULL, NULL, 234160),
(272877, '4m6rA00', NULL, NULL, 224, NULL, NULL, 234160),
(272878, '2phpB00', NULL, NULL, 192, NULL, NULL, 234160),
(272879, '4bs9A04', NULL, NULL, 90, NULL, NULL, 234161),
(272880, '3bt3A02', NULL, NULL, 60, NULL, NULL, 234162),
(272881, '2kjzA02', NULL, NULL, 57, NULL, NULL, 234162),
(272882, '3sk1A02', NULL, NULL, 59, NULL, NULL, 234162),
(272883, '3omsA02', NULL, NULL, 61, NULL, NULL, 234162),
(272884, '1u7iA02', NULL, NULL, 62, NULL, NULL, 234162),
(272885, '3itwA02', NULL, NULL, 70, NULL, NULL, 234162),
(272886, '3vcxA02', NULL, NULL, 55, NULL, NULL, 234162),
(272887, '1nh1A01', NULL, NULL, 209, NULL, NULL, 234163),
(272888, '2lm0A01', NULL, NULL, 96, NULL, NULL, 234164),
(272889, '3k1rA01', NULL, NULL, 81, NULL, NULL, 234165),
(272890, '4ykdA00', NULL, NULL, 96, NULL, NULL, 234165),
(272891, '4ykcA00', NULL, NULL, 104, NULL, NULL, 234165),
(272892, '4fqnC00', NULL, NULL, 98, NULL, NULL, 234165),
(272893, '2mhgA00', NULL, NULL, 75, NULL, NULL, 234166),
(272894, '2mctA00', NULL, NULL, 102, NULL, NULL, 234167),
(272895, '2r7rA04', NULL, NULL, 157, NULL, NULL, 234168),
(272896, '3o6wA01', NULL, NULL, 58, NULL, NULL, 234169),
(272897, '1hkgA01', NULL, NULL, 57, NULL, NULL, 234169),
(272898, '2yhxA01', NULL, NULL, 57, NULL, NULL, 234169),
(272899, '3b8aX01', NULL, NULL, 76, NULL, NULL, 234169),
(272900, '1ig8A01', NULL, NULL, 59, NULL, NULL, 234169),
(272901, '3o8mA01', NULL, NULL, 76, NULL, NULL, 234169),
(272902, '2ba2A00', NULL, NULL, 85, NULL, NULL, 234170),
(272903, '2lonA01', NULL, NULL, 65, NULL, NULL, 234171),
(272904, '5xo1F00', NULL, NULL, 219, NULL, NULL, 234172),
(272905, '2a67B00', NULL, NULL, 167, NULL, NULL, 234172),
(272906, '3hb7A00', NULL, NULL, 188, NULL, NULL, 234172),
(272907, '1x9gA00', NULL, NULL, 200, NULL, NULL, 234172),
(272908, '2b34A00', NULL, NULL, 199, NULL, NULL, 234172),
(272909, '3v8eA00', NULL, NULL, 216, NULL, NULL, 234172),
(272910, '3s2sA00', NULL, NULL, 182, NULL, NULL, 234172),
(272911, '3r2jC00', NULL, NULL, 202, NULL, NULL, 234172),
(272912, '3kl2I00', NULL, NULL, 207, NULL, NULL, 234172),
(272913, '3oqpA00', NULL, NULL, 211, NULL, NULL, 234172),
(272914, '1im5A00', NULL, NULL, 180, NULL, NULL, 234172),
(272915, '3pl1A00', NULL, NULL, 186, NULL, NULL, 234172),
(272916, '3eefA00', NULL, NULL, 182, NULL, NULL, 234172),
(272917, '6a8lA00', NULL, NULL, 183, NULL, NULL, 234172),
(272918, '5xo0A00', NULL, NULL, 218, NULL, NULL, 234172),
(272919, '1j2rA00', NULL, NULL, 199, NULL, NULL, 234172),
(272920, '1yzvA00', NULL, NULL, 204, NULL, NULL, 234172),
(272921, '3r77A00', NULL, NULL, 209, NULL, NULL, 234172),
(272922, '3tg2A00', NULL, NULL, 206, NULL, NULL, 234172),
(272923, '3ot4A00', NULL, NULL, 210, NULL, NULL, 234172),
(272924, '1yacA00', NULL, NULL, 208, NULL, NULL, 234172),
(272925, '3o94B00', NULL, NULL, 191, NULL, NULL, 234172),
(272926, '4h17A00', NULL, NULL, 197, NULL, NULL, 234172),
(272927, '4l07A00', NULL, NULL, 208, NULL, NULL, 234172),
(272928, '1nf9A00', NULL, NULL, 207, NULL, NULL, 234172),
(272929, '3irvA01', NULL, NULL, 216, NULL, NULL, 234172),
(272930, '4wgfA00', NULL, NULL, 205, NULL, NULL, 234172),
(272931, '2wt9A00', NULL, NULL, 210, NULL, NULL, 234172),
(272932, '3hu5A00', NULL, NULL, 204, NULL, NULL, 234172),
(272933, '3lqyA00', NULL, NULL, 190, NULL, NULL, 234172),
(272934, '3mcwA00', NULL, NULL, 198, NULL, NULL, 234172);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(272935, '2fq1A01', NULL, NULL, 209, NULL, NULL, 234172),
(272936, '3txyA00', NULL, NULL, 199, NULL, NULL, 234172),
(272937, '1nbaB00', NULL, NULL, 264, NULL, NULL, 234172),
(272938, '2gv1A00', NULL, NULL, 92, NULL, NULL, 234173),
(272939, '2bycB00', NULL, NULL, 137, NULL, NULL, 234173),
(272940, '1kviA00', NULL, NULL, 79, NULL, NULL, 234173),
(272941, '2pgcA02', NULL, NULL, 106, NULL, NULL, 234173),
(272942, '6fu9A00', NULL, NULL, 81, NULL, NULL, 234173),
(272943, '2rilA00', NULL, NULL, 99, NULL, NULL, 234173),
(272944, '1ulrA00', NULL, NULL, 88, NULL, NULL, 234173),
(272945, '2kyzA00', NULL, NULL, 67, NULL, NULL, 234173),
(272946, '2ftrB00', NULL, NULL, 108, NULL, NULL, 234173),
(272947, '2kkhA01', NULL, NULL, 75, NULL, NULL, 234173),
(272948, '1q8bA00', NULL, NULL, 105, NULL, NULL, 234173),
(272949, '5xztJ00', NULL, NULL, 107, NULL, NULL, 234173),
(272950, '2kb2A00', NULL, NULL, 148, NULL, NULL, 234173),
(272951, '1cc8A00', NULL, NULL, 73, NULL, NULL, 234173),
(272952, '1x0pA01', NULL, NULL, 97, NULL, NULL, 234173),
(272953, '2lxfA00', NULL, NULL, 121, NULL, NULL, 234173),
(272954, '1iujA00', NULL, NULL, 106, NULL, NULL, 234173),
(272955, '3kg0A00', NULL, NULL, 108, NULL, NULL, 234173),
(272956, '3qmqA00', NULL, NULL, 99, NULL, NULL, 234173),
(272957, '1u7lA03', NULL, NULL, 90, NULL, NULL, 234173),
(272958, '3bm7A00', NULL, NULL, 115, NULL, NULL, 234173),
(272959, '6cbuA00', NULL, NULL, 100, NULL, NULL, 234173),
(272960, '4zosB00', NULL, NULL, 106, NULL, NULL, 234173),
(272961, '1yg0A00', NULL, NULL, 66, NULL, NULL, 234173),
(272962, '1yrxC01', NULL, NULL, 106, NULL, NULL, 234173),
(272963, '2iygB00', NULL, NULL, 124, NULL, NULL, 234173),
(272964, '2roeA00', NULL, NULL, 66, NULL, NULL, 234173),
(272965, '2ifxA01', NULL, NULL, 88, NULL, NULL, 234173),
(272966, '4q2lA00', NULL, NULL, 70, NULL, NULL, 234173),
(272967, '2bjdA00', NULL, NULL, 101, NULL, NULL, 234173),
(272968, '2kt2A00', NULL, NULL, 69, NULL, NULL, 234173),
(272969, '2qlxA01', NULL, NULL, 101, NULL, NULL, 234173),
(272970, '2op5B01', NULL, NULL, 109, NULL, NULL, 234173),
(272971, '4hl9A00', NULL, NULL, 95, NULL, NULL, 234173),
(272972, '1y3jA00', NULL, NULL, 77, NULL, NULL, 234173),
(272973, '4u9rA02', NULL, NULL, 65, NULL, NULL, 234173),
(272974, '4u9rA01', NULL, NULL, 82, NULL, NULL, 234173),
(272975, '3tnvA00', NULL, NULL, 91, NULL, NULL, 234173),
(272976, '2od6B00', NULL, NULL, 110, NULL, NULL, 234173),
(272977, '3f44A00', NULL, NULL, 220, NULL, NULL, 234173),
(272978, '4efaC00', NULL, NULL, 130, NULL, NULL, 234173),
(272979, '4y2mA00', NULL, NULL, 65, NULL, NULL, 234173),
(272980, '1lq9A00', NULL, NULL, 112, NULL, NULL, 234173),
(272981, '3fgvA00', NULL, NULL, 106, NULL, NULL, 234173),
(272982, '3bb5F00', NULL, NULL, 121, NULL, NULL, 234173),
(272983, '5zneA00', NULL, NULL, 73, NULL, NULL, 234173),
(272984, '1xbwB00', NULL, NULL, 109, NULL, NULL, 234173),
(272985, '4dn9B00', NULL, NULL, 122, NULL, NULL, 234173),
(272986, '3bb5B00', NULL, NULL, 121, NULL, NULL, 234173),
(272987, '1apsA00', NULL, NULL, 98, NULL, NULL, 234173),
(272988, '5ixuA00', NULL, NULL, 117, NULL, NULL, 234173),
(272989, '2qycA00', NULL, NULL, 103, NULL, NULL, 234173),
(272990, '1s6oA00', NULL, NULL, 76, NULL, NULL, 234173),
(272991, '1y0hB00', NULL, NULL, 102, NULL, NULL, 234173),
(272992, '1aw0A00', NULL, NULL, 72, NULL, NULL, 234173),
(272993, '2okqB00', NULL, NULL, 141, NULL, NULL, 234173),
(272994, '2aj0A00', NULL, NULL, 71, NULL, NULL, 234173),
(272995, '2n7yA00', NULL, NULL, 76, NULL, NULL, 234173),
(272996, '2hiqA00', NULL, NULL, 113, NULL, NULL, 234173),
(272997, '5kakA00', NULL, NULL, 126, NULL, NULL, 234173),
(272998, '3bb5A00', NULL, NULL, 121, NULL, NULL, 234173),
(272999, '3hhlA00', NULL, NULL, 143, NULL, NULL, 234173),
(273000, '3bf4A01', NULL, NULL, 99, NULL, NULL, 234173),
(273001, '4a47A00', NULL, NULL, 63, NULL, NULL, 234173),
(273002, '2ftrA00', NULL, NULL, 108, NULL, NULL, 234173),
(273003, '1x8dA01', NULL, NULL, 97, NULL, NULL, 234173),
(273004, '6ff2A00', NULL, NULL, 68, NULL, NULL, 234173),
(273005, '1tz0B00', NULL, NULL, 114, NULL, NULL, 234173);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(273006, '2fiuA00', NULL, NULL, 99, NULL, NULL, 234173),
(273007, '3vtiA01', NULL, NULL, 103, NULL, NULL, 234173),
(273008, '2qifA00', NULL, NULL, 69, NULL, NULL, 234173),
(273009, '2k2pA00', NULL, NULL, 64, NULL, NULL, 234173),
(273010, '2od6C00', NULL, NULL, 110, NULL, NULL, 234173),
(273011, '2rsqA00', NULL, NULL, 89, NULL, NULL, 234173),
(273012, '2gffA00', NULL, NULL, 106, NULL, NULL, 234173),
(273013, '1afiA00', NULL, NULL, 72, NULL, NULL, 234173),
(273014, '2qlxB01', NULL, NULL, 101, NULL, NULL, 234173),
(273015, '1x7vA00', NULL, NULL, 99, NULL, NULL, 234173),
(273016, '4ae5C00', NULL, NULL, 167, NULL, NULL, 234173),
(273017, '3br8A00', NULL, NULL, 91, NULL, NULL, 234173),
(273018, '4dpoB00', NULL, NULL, 102, NULL, NULL, 234173),
(273019, '3bb5E00', NULL, NULL, 104, NULL, NULL, 234173),
(273020, '2ew9A01', NULL, NULL, 77, NULL, NULL, 234173),
(273021, '2ew9A02', NULL, NULL, 72, NULL, NULL, 234173),
(273022, '2pd1A01', NULL, NULL, 95, NULL, NULL, 234173),
(273023, '1vqsA00', NULL, NULL, 116, NULL, NULL, 234173),
(273024, '3fmbA01', NULL, NULL, 100, NULL, NULL, 234173),
(273025, '2pgcC01', NULL, NULL, 101, NULL, NULL, 234173),
(273026, '3cjkB00', NULL, NULL, 75, NULL, NULL, 234173),
(273027, '2g9oA00', NULL, NULL, 90, NULL, NULL, 234173),
(273028, '3bf4B01', NULL, NULL, 99, NULL, NULL, 234173),
(273029, '1vqyB01', NULL, NULL, 95, NULL, NULL, 234173),
(273030, '1osdA00', NULL, NULL, 72, NULL, NULL, 234173),
(273031, '2qlwA01', NULL, NULL, 101, NULL, NULL, 234173),
(273032, '2xmjA00', NULL, NULL, 64, NULL, NULL, 234173),
(273033, '2omoD01', NULL, NULL, 103, NULL, NULL, 234173),
(273034, '2acyA00', NULL, NULL, 98, NULL, NULL, 234173),
(273035, '2go8A01', NULL, NULL, 93, NULL, NULL, 234173),
(273036, '1tuvA00', NULL, NULL, 114, NULL, NULL, 234173),
(273037, '1w2iA00', NULL, NULL, 91, NULL, NULL, 234173),
(273038, '3fj2A00', NULL, NULL, 186, NULL, NULL, 234173),
(273039, '1tr0A00', NULL, NULL, 108, NULL, NULL, 234173),
(273040, '1rjjA00', NULL, NULL, 111, NULL, NULL, 234173),
(273041, '3kngA00', NULL, NULL, 109, NULL, NULL, 234173),
(273042, '4a4jA00', NULL, NULL, 69, NULL, NULL, 234173),
(273043, '3e8oB00', NULL, NULL, 100, NULL, NULL, 234173),
(273044, '2bbeA00', NULL, NULL, 108, NULL, NULL, 234173),
(273045, '3kkfA00', NULL, NULL, 105, NULL, NULL, 234173),
(273046, '2od6D00', NULL, NULL, 110, NULL, NULL, 234173),
(273047, '2l3mA00', NULL, NULL, 71, NULL, NULL, 234173),
(273048, '2ap6A00', NULL, NULL, 112, NULL, NULL, 234173),
(273049, '1qupA01', NULL, NULL, 70, NULL, NULL, 234173),
(273050, '3mcsA00', NULL, NULL, 219, NULL, NULL, 234173),
(273051, '3bb5D00', NULL, NULL, 121, NULL, NULL, 234173),
(273052, '3lo3A00', NULL, NULL, 94, NULL, NULL, 234173),
(273053, '3bdeB00', NULL, NULL, 120, NULL, NULL, 234173),
(273054, '2hfnA01', NULL, NULL, 100, NULL, NULL, 234173),
(273055, '2fb0A00', NULL, NULL, 94, NULL, NULL, 234173),
(273056, '2lqbA00', NULL, NULL, 76, NULL, NULL, 234173),
(273057, '4ydxA00', NULL, NULL, 67, NULL, NULL, 234173),
(273058, '1q8lA00', NULL, NULL, 84, NULL, NULL, 234173),
(273059, '3fryA01', NULL, NULL, 64, NULL, NULL, 234173),
(273060, '1opzA00', NULL, NULL, 76, NULL, NULL, 234173),
(273061, '1cpzA00', NULL, NULL, 68, NULL, NULL, 234173),
(273062, '1yjrA00', NULL, NULL, 75, NULL, NULL, 234173),
(273063, '2jdjA00', NULL, NULL, 105, NULL, NULL, 234173),
(273064, '3fezA00', NULL, NULL, 186, NULL, NULL, 234173),
(273065, '4f67A01', NULL, NULL, 107, NULL, NULL, 234173),
(273066, '3hhlC00', NULL, NULL, 143, NULL, NULL, 234173),
(273067, '2qlwB01', NULL, NULL, 101, NULL, NULL, 234173),
(273068, '3dcaA00', NULL, NULL, 142, NULL, NULL, 234173),
(273069, '2ropA01', NULL, NULL, 71, NULL, NULL, 234173),
(273070, '1q4rA00', NULL, NULL, 112, NULL, NULL, 234173),
(273071, '1mwyA00', NULL, NULL, 73, NULL, NULL, 234173),
(273072, '2ldiA00', NULL, NULL, 71, NULL, NULL, 234173),
(273073, '2ofhX00', NULL, NULL, 76, NULL, NULL, 234173),
(273074, '3wdoA02', NULL, NULL, 61, NULL, NULL, 234173),
(273075, '4kiaA00', NULL, NULL, 167, NULL, NULL, 234173),
(273076, '3bguA01', NULL, NULL, 96, NULL, NULL, 234173);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(273077, '3dxsX00', NULL, NULL, 74, NULL, NULL, 234173),
(273078, '1jwwA00', NULL, NULL, 80, NULL, NULL, 234173),
(273079, '3gz7B00', NULL, NULL, 98, NULL, NULL, 234173),
(273080, '1fvqA00', NULL, NULL, 72, NULL, NULL, 234173),
(273081, '3hx9B00', NULL, NULL, 99, NULL, NULL, 234173),
(273082, '2crlA01', NULL, NULL, 69, NULL, NULL, 234173),
(273083, '5b08A00', NULL, NULL, 104, NULL, NULL, 234173),
(273084, '6a71A00', NULL, NULL, 72, NULL, NULL, 234173),
(273085, '2vh7A00', NULL, NULL, 99, NULL, NULL, 234173),
(273086, '3bn7A00', NULL, NULL, 120, NULL, NULL, 234173),
(273087, '1gxuA00', NULL, NULL, 91, NULL, NULL, 234173),
(273088, '3gfzA01', NULL, NULL, 148, NULL, NULL, 234173),
(273089, '5ajiB03', NULL, NULL, 95, NULL, NULL, 234173),
(273090, '4za1C00', NULL, NULL, 103, NULL, NULL, 234173),
(273091, '2od4B01', NULL, NULL, 89, NULL, NULL, 234173),
(273092, '5k9fA00', NULL, NULL, 112, NULL, NULL, 234173),
(273093, '3hf5D01', NULL, NULL, 113, NULL, NULL, 234173),
(273094, '3trgA00', NULL, NULL, 98, NULL, NULL, 234173),
(273095, '2od6A00', NULL, NULL, 110, NULL, NULL, 234173),
(273096, '1urrA00', NULL, NULL, 102, NULL, NULL, 234173),
(273097, '6g10B00', NULL, NULL, 80, NULL, NULL, 234173),
(273098, '3udcA03', NULL, NULL, 88, NULL, NULL, 234173),
(273099, '2k7jA00', NULL, NULL, 99, NULL, NULL, 234173),
(273100, '3bb5C00', NULL, NULL, 121, NULL, NULL, 234173),
(273101, '3tvzB00', NULL, NULL, 172, NULL, NULL, 234173),
(273102, '2qycB00', NULL, NULL, 103, NULL, NULL, 234173),
(273103, '1sqeA00', NULL, NULL, 109, NULL, NULL, 234173),
(273104, '3toqA00', NULL, NULL, 99, NULL, NULL, 234173),
(273105, '4hi1A00', NULL, NULL, 91, NULL, NULL, 234173),
(273106, '3mopG00', NULL, NULL, 113, NULL, NULL, 234174),
(273107, '4ewiA00', NULL, NULL, 97, NULL, NULL, 234174),
(273108, '4zbwA02', NULL, NULL, 91, NULL, NULL, 234174),
(273109, '4zbwA01', NULL, NULL, 99, NULL, NULL, 234174),
(273110, '3mopA00', NULL, NULL, 110, NULL, NULL, 234174),
(273111, '1a1wA00', NULL, NULL, 91, NULL, NULL, 234174),
(273112, '2bbrA01', NULL, NULL, 90, NULL, NULL, 234174),
(273113, '4d8oA04', NULL, NULL, 76, NULL, NULL, 234174),
(273114, '2bbrA02', NULL, NULL, 105, NULL, NULL, 234174),
(273115, '4n1lA00', NULL, NULL, 105, NULL, NULL, 234174),
(273116, '4uz0A00', NULL, NULL, 95, NULL, NULL, 234174),
(273117, '2l6aA00', NULL, NULL, 102, NULL, NULL, 234174),
(273118, '1wxpA01', NULL, NULL, 84, NULL, NULL, 234174),
(273119, '2nz7A00', NULL, NULL, 98, NULL, NULL, 234174),
(273120, '4f42A00', NULL, NULL, 94, NULL, NULL, 234174),
(273121, '2mb9A00', NULL, NULL, 118, NULL, NULL, 234174),
(273122, '6bzhC02', NULL, NULL, 92, NULL, NULL, 234174),
(273123, '4i16A00', NULL, NULL, 93, NULL, NULL, 234174),
(273124, '3cl3A02', NULL, NULL, 93, NULL, NULL, 234174),
(273125, '3cl3A01', NULL, NULL, 90, NULL, NULL, 234174),
(273126, '2n1fA00', NULL, NULL, 89, NULL, NULL, 234174),
(273127, '3mopK00', NULL, NULL, 93, NULL, NULL, 234174),
(273128, '2lwdA00', NULL, NULL, 100, NULL, NULL, 234174),
(273129, '4rhwE00', NULL, NULL, 108, NULL, NULL, 234174),
(273130, '4o7qA00', NULL, NULL, 94, NULL, NULL, 234174),
(273131, '1d2zA00', NULL, NULL, 108, NULL, NULL, 234174),
(273132, '4a2qA02', NULL, NULL, 93, NULL, NULL, 234174),
(273133, '4a2qA01', NULL, NULL, 96, NULL, NULL, 234174),
(273134, '6aciH00', NULL, NULL, 92, NULL, NULL, 234174),
(273135, '4e9mB00', NULL, NULL, 95, NULL, NULL, 234174),
(273136, '3t6pA03', NULL, NULL, 128, NULL, NULL, 234174),
(273137, '2do9A01', NULL, NULL, 84, NULL, NULL, 234174),
(273138, '2km6A00', NULL, NULL, 106, NULL, NULL, 234174),
(273139, '3ezqA00', NULL, NULL, 115, NULL, NULL, 234174),
(273140, '4p4hB02', NULL, NULL, 104, NULL, NULL, 234174),
(273141, '2dbfA01', NULL, NULL, 91, NULL, NULL, 234174),
(273142, '3crdA00', NULL, NULL, 100, NULL, NULL, 234174),
(273143, '3j63A00', NULL, NULL, 91, NULL, NULL, 234174),
(273144, '2mn4A00', NULL, NULL, 106, NULL, NULL, 234174),
(273145, '2mpcA00', NULL, NULL, 100, NULL, NULL, 234174),
(273146, '1ichA00', NULL, NULL, 112, NULL, NULL, 234174),
(273147, '2g7rA00', NULL, NULL, 98, NULL, NULL, 234174);
INSERT INTO "PUBLIC"."MODEL" VALUES
(273148, '2d96A01', NULL, NULL, 91, NULL, NULL, 234174),
(273149, '1pn5A00', NULL, NULL, 101, NULL, NULL, 234174),
(273150, '2gf5A01', NULL, NULL, 86, NULL, NULL, 234174),
(273151, '4qobA00', NULL, NULL, 97, NULL, NULL, 234174),
(273152, '1wmgA00', NULL, NULL, 103, NULL, NULL, 234174),
(273153, '1cy5A00', NULL, NULL, 97, NULL, NULL, 234174),
(273154, '4e9mE00', NULL, NULL, 87, NULL, NULL, 234174),
(273155, '1dgnA00', NULL, NULL, 89, NULL, NULL, 234174),
(273156, '4iz5E00', NULL, NULL, 98, NULL, NULL, 234174),
(273157, '2n80A00', NULL, NULL, 94, NULL, NULL, 234174),
(273158, '3katA00', NULL, NULL, 89, NULL, NULL, 234174),
(273159, '6ncvA00', NULL, NULL, 106, NULL, NULL, 234174),
(273160, '6bzhD01', NULL, NULL, 102, NULL, NULL, 234174),
(273161, '2dbgA00', NULL, NULL, 103, NULL, NULL, 234174),
(273162, '2ib1A00', NULL, NULL, 91, NULL, NULL, 234174),
(273163, '2n00A00', NULL, NULL, 95, NULL, NULL, 234174),
(273164, '2of5H00', NULL, NULL, 100, NULL, NULL, 234174),
(273165, '2vgqA03', NULL, NULL, 89, NULL, NULL, 234174),
(273166, '4fh0A00', NULL, NULL, 102, NULL, NULL, 234174),
(273167, '2yu0A00', NULL, NULL, 94, NULL, NULL, 234174),
(273168, '2yviA00', NULL, NULL, 111, NULL, NULL, 234174),
(273169, '1d2zB00', NULL, NULL, 153, NULL, NULL, 234174),
(273170, '1n3kA00', NULL, NULL, 130, NULL, NULL, 234174),
(273171, '2l9mA00', NULL, NULL, 132, NULL, NULL, 234174),
(273172, '1fadA00', NULL, NULL, 99, NULL, NULL, 234174),
(273173, '2n7zA00', NULL, NULL, 106, NULL, NULL, 234174),
(273174, '4o9lA00', NULL, NULL, 97, NULL, NULL, 234174),
(273175, '2a5yB01', NULL, NULL, 109, NULL, NULL, 234174),
(273176, '3qf2A00', NULL, NULL, 92, NULL, NULL, 234174),
(273177, '4izaB00', NULL, NULL, 97, NULL, NULL, 234174),
(273178, '2a9iA00', NULL, NULL, 113, NULL, NULL, 234174),
(273179, '2o71A00', NULL, NULL, 115, NULL, NULL, 234174),
(273180, '6n1hA00', NULL, NULL, 83, NULL, NULL, 234174),
(273181, '2dbhA01', NULL, NULL, 79, NULL, NULL, 234174),
(273182, '4o6xB00', NULL, NULL, 101, NULL, NULL, 234174),
(273183, '2m5vA00', NULL, NULL, 102, NULL, NULL, 234174),
(273184, '4p4hA01', NULL, NULL, 101, NULL, NULL, 234174),
(273185, '2nsnA00', NULL, NULL, 95, NULL, NULL, 234174),
(273186, '2l7kA00', NULL, NULL, 76, NULL, NULL, 234175),
(273187, '4bjjA00', NULL, NULL, 112, NULL, NULL, 234176),
(273188, '3bmzA00', NULL, NULL, 199, NULL, NULL, 234177),
(273189, '5lewA03', NULL, NULL, 81, NULL, NULL, 234178),
(273190, '2hnhA03', NULL, NULL, 78, NULL, NULL, 234178),
(273191, '2hpiA03', NULL, NULL, 76, NULL, NULL, 234178),
(273192, '4ceiA05', NULL, NULL, 162, NULL, NULL, 234179),
(273193, '3lfuA04', NULL, NULL, 156, NULL, NULL, 234179),
(273194, '1w36C04', NULL, NULL, 209, NULL, NULL, 234179),
(273195, '1pjrA04', NULL, NULL, 152, NULL, NULL, 234179),
(273196, '1w36B04', NULL, NULL, 146, NULL, NULL, 234179),
(273197, '4c2uA04', NULL, NULL, 169, NULL, NULL, 234179),
(273198, '1uaaA04', NULL, NULL, 162, NULL, NULL, 234179),
(273199, '1qhhC00', NULL, NULL, 115, NULL, NULL, 234179),
(273200, '3l7yA02', NULL, NULL, 110, NULL, NULL, 234180),
(273201, '1nf2A02', NULL, NULL, 106, NULL, NULL, 234180),
(273202, '2b30A02', NULL, NULL, 109, NULL, NULL, 234180),
(273203, '4dw8A02', NULL, NULL, 106, NULL, NULL, 234180),
(273204, '1nrwA02', NULL, NULL, 130, NULL, NULL, 234180),
(273205, '2pq0A02', NULL, NULL, 100, NULL, NULL, 234180),
(273206, '3r4cA02', NULL, NULL, 101, NULL, NULL, 234180),
(273207, '2hf2B02', NULL, NULL, 107, NULL, NULL, 234180),
(273208, '3daoB02', NULL, NULL, 107, NULL, NULL, 234180),
(273209, '3pgvA02', NULL, NULL, 106, NULL, NULL, 234180),
(273210, '2rbkA02', NULL, NULL, 101, NULL, NULL, 234180),
(273211, '1rkqA02', NULL, NULL, 107, NULL, NULL, 234180),
(273212, '3fzqB02', NULL, NULL, 115, NULL, NULL, 234180),
(273213, '3mpoA02', NULL, NULL, 107, NULL, NULL, 234180),
(273214, '3dnpA02', NULL, NULL, 113, NULL, NULL, 234180),
(273215, '4zevA02', NULL, NULL, 107, NULL, NULL, 234180),
(273216, '2cb9A02', NULL, NULL, 43, NULL, NULL, 234181),
(273217, '6bogA08', NULL, NULL, 80, NULL, NULL, 234182),
(273218, '1wj5A01', NULL, NULL, 98, NULL, NULL, 234183); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(273219, '4jqfA01', NULL, NULL, 106, NULL, NULL, 234183),
(273220, '3mxaA02', NULL, NULL, 150, NULL, NULL, 234184),
(273221, '3e54A00', NULL, NULL, 169, NULL, NULL, 234184),
(273222, '4yisB02', NULL, NULL, 147, NULL, NULL, 234184),
(273223, '2xe0A00', NULL, NULL, 152, NULL, NULL, 234184),
(273224, '2ex5A00', NULL, NULL, 207, NULL, NULL, 234184),
(273225, '2qojZ01', NULL, NULL, 119, NULL, NULL, 234184),
(273226, '2vblA00', NULL, NULL, 153, NULL, NULL, 234184),
(273227, '2qojZ02', NULL, NULL, 135, NULL, NULL, 234184),
(273228, '2vs7A02', NULL, NULL, 78, NULL, NULL, 234184),
(273229, '2vs7A01', NULL, NULL, 101, NULL, NULL, 234184),
(273230, '2dchX02', NULL, NULL, 111, NULL, NULL, 234184),
(273231, '2dchX01', NULL, NULL, 105, NULL, NULL, 234184),
(273232, '6fb0B00', NULL, NULL, 154, NULL, NULL, 234184),
(273233, '1jvaB02', NULL, NULL, 121, NULL, NULL, 234184),
(273234, '4loxA02', NULL, NULL, 148, NULL, NULL, 234184),
(273235, '1mowG02', NULL, NULL, 143, NULL, NULL, 234184),
(273236, '4loxA01', NULL, NULL, 147, NULL, NULL, 234184),
(273237, '3r7pA02', NULL, NULL, 156, NULL, NULL, 234184),
(273238, '3r7pA01', NULL, NULL, 152, NULL, NULL, 234184),
(273239, '2fldA00', NULL, NULL, 165, NULL, NULL, 234184),
(273240, '1ef0B02', NULL, NULL, 236, NULL, NULL, 234184),
(273241, '2ab5B02', NULL, NULL, 134, NULL, NULL, 234184),
(273242, '3mxaA01', NULL, NULL, 153, NULL, NULL, 234184),
(273243, '4efjA01', NULL, NULL, 145, NULL, NULL, 234184),
(273244, '3uvfA01', NULL, NULL, 120, NULL, NULL, 234184),
(273245, '3uvfA02', NULL, NULL, 135, NULL, NULL, 234184),
(273246, '4yisA01', NULL, NULL, 139, NULL, NULL, 234184),
(273247, '3hyiA01', NULL, NULL, 201, NULL, NULL, 234184),
(273248, '4lq0A02', NULL, NULL, 147, NULL, NULL, 234184),
(273249, '2xe0B00', NULL, NULL, 152, NULL, NULL, 234184),
(273250, '4lq0A01', NULL, NULL, 150, NULL, NULL, 234184),
(273251, '6fb0A00', NULL, NULL, 153, NULL, NULL, 234184),
(273252, '1mowA01', NULL, NULL, 117, NULL, NULL, 234184),
(273253, '3qqyA02', NULL, NULL, 149, NULL, NULL, 234184),
(273254, '2vs7D02', NULL, NULL, 98, NULL, NULL, 234184),
(273255, '3qqyA01', NULL, NULL, 151, NULL, NULL, 234184),
(273256, '2vblB00', NULL, NULL, 153, NULL, NULL, 234184),
(273257, '4yhxA02', NULL, NULL, 153, NULL, NULL, 234184),
(273258, '3c0wA01', NULL, NULL, 122, NULL, NULL, 234184),
(273259, '4yhxA01', NULL, NULL, 144, NULL, NULL, 234184),
(273260, '3c0wA02', NULL, NULL, 113, NULL, NULL, 234184),
(273261, '5a74A00', NULL, NULL, 172, NULL, NULL, 234184),
(273262, '4yitA02', NULL, NULL, 144, NULL, NULL, 234184),
(273263, '4yitA01', NULL, NULL, 137, NULL, NULL, 234184),
(273264, '1dq3A03', NULL, NULL, 87, NULL, NULL, 234184),
(273265, '4z1xA02', NULL, NULL, 147, NULL, NULL, 234184),
(273266, '1dq3A04', NULL, NULL, 114, NULL, NULL, 234184),
(273267, '1dfaA03', NULL, NULL, 95, NULL, NULL, 234184),
(273268, '1t9iA00', NULL, NULL, 163, NULL, NULL, 234184),
(273269, '2ab5A02', NULL, NULL, 134, NULL, NULL, 234184),
(273270, '2ab5A01', NULL, NULL, 135, NULL, NULL, 234184),
(273271, '2cw8A03', NULL, NULL, 169, NULL, NULL, 234184),
(273272, '2ymaA00', NULL, NULL, 136, NULL, NULL, 234185),
(273273, '2lh0A00', NULL, NULL, 70, NULL, NULL, 234186),
(273274, '2au5A00', NULL, NULL, 139, NULL, NULL, 234187),
(273275, '2p4bB02', NULL, NULL, 101, NULL, NULL, 234188),
(273276, '1i6uB02', NULL, NULL, 59, NULL, NULL, 234189),
(273277, '3rf2A02', NULL, NULL, 58, NULL, NULL, 234189),
(273278, '6faiW02', NULL, NULL, 61, NULL, NULL, 234189),
(273279, '2vqeH02', NULL, NULL, 58, NULL, NULL, 234189),
(273280, '5mmjh02', NULL, NULL, 58, NULL, NULL, 234189),
(273281, '5o5jH02', NULL, NULL, 58, NULL, NULL, 234189),
(273282, '1i94H02', NULL, NULL, 58, NULL, NULL, 234189),
(273283, '6az1J02', NULL, NULL, 61, NULL, NULL, 234189),
(273284, '5xyiW02', NULL, NULL, 61, NULL, NULL, 234189),
(273285, '1s03G02', NULL, NULL, 58, NULL, NULL, 234189),
(273286, '1seiA02', NULL, NULL, 58, NULL, NULL, 234189),
(273287, '2xzmH02', NULL, NULL, 61, NULL, NULL, 234189),
(273288, '4pdbA02', NULL, NULL, 58, NULL, NULL, 234189),
(273289, '5xxuW02', NULL, NULL, 61, NULL, NULL, 234189);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(273290, '6g5iW02', NULL, NULL, 61, NULL, NULL, 234189),
(273291, '5opte02', NULL, NULL, 61, NULL, NULL, 234189),
(273292, '3j7aK02', NULL, NULL, 61, NULL, NULL, 234189),
(273293, '1s4cC00', NULL, NULL, 155, NULL, NULL, 234190),
(273294, '3rbyA02', NULL, NULL, 95, NULL, NULL, 234191),
(273295, '3smpA01', NULL, NULL, 167, NULL, NULL, 234192),
(273296, '5e26A01', NULL, NULL, 167, NULL, NULL, 234192),
(273297, '6b3vA01', NULL, NULL, 164, NULL, NULL, 234192),
(273298, '1mkmA02', NULL, NULL, 14, NULL, NULL, 234193),
(273299, '3r4yA01', NULL, NULL, 21, NULL, NULL, 234193),
(273300, '1d66B02', NULL, NULL, 17, NULL, NULL, 234193),
(273301, '2j01501', NULL, NULL, 25, NULL, NULL, 234193),
(273302, '4mbqC00', NULL, NULL, 64, NULL, NULL, 234194),
(273303, '1kg1A02', NULL, NULL, 32, NULL, NULL, 234195),
(273304, '1ei5A02', NULL, NULL, 82, NULL, NULL, 234196),
(273305, '5cybA00', NULL, NULL, 89, NULL, NULL, 234196),
(273306, '1ei5A03', NULL, NULL, 102, NULL, NULL, 234196),
(273307, '3i08B01', NULL, NULL, 29, NULL, NULL, 234197),
(273308, '3bs1A00', NULL, NULL, 103, NULL, NULL, 234198),
(273309, '4cbvC02', NULL, NULL, 123, NULL, NULL, 234198),
(273310, '4kh9A03', NULL, NULL, 113, NULL, NULL, 234199),
(273311, '1o22A00', NULL, NULL, 153, NULL, NULL, 234200),
(273312, '1zmbA02', NULL, NULL, 42, NULL, NULL, 234201),
(273313, '4jwhA00', NULL, NULL, 189, NULL, NULL, 234202),
(273314, '4jwjA00', NULL, NULL, 202, NULL, NULL, 234202),
(273315, '4fmwA00', NULL, NULL, 197, NULL, NULL, 234202),
(273316, '1q2zA00', NULL, NULL, 120, NULL, NULL, 234203),
(273317, '3ismC02', NULL, NULL, 141, NULL, NULL, 234203),
(273318, '3ismC01', NULL, NULL, 154, NULL, NULL, 234203),
(273319, '1rw2A00', NULL, NULL, 152, NULL, NULL, 234203),
(273320, '1ynfA00', NULL, NULL, 458, NULL, NULL, 234204),
(273321, '2ywqC00', NULL, NULL, 105, NULL, NULL, 234205),
(273322, '1imuA00', NULL, NULL, 107, NULL, NULL, 234205),
(273323, '4heiB00', NULL, NULL, 95, NULL, NULL, 234205),
(273324, '1l4sA01', NULL, NULL, 91, NULL, NULL, 234205),
(273325, '2rqlA00', NULL, NULL, 95, NULL, NULL, 234205),
(273326, '3tqmC00', NULL, NULL, 96, NULL, NULL, 234205),
(273327, '2nwlC00', NULL, NULL, 422, NULL, NULL, 234206),
(273328, '5lm4A00', NULL, NULL, 448, NULL, NULL, 234206),
(273329, '6r7rB00', NULL, NULL, 422, NULL, NULL, 234206),
(273330, '1t72D01', NULL, NULL, 106, NULL, NULL, 234207),
(273331, '1t72A01', NULL, NULL, 117, NULL, NULL, 234207),
(273332, '1t72B01', NULL, NULL, 116, NULL, NULL, 234207),
(273333, '1t72G01', NULL, NULL, 116, NULL, NULL, 234207),
(273334, '1t72D02', NULL, NULL, 121, NULL, NULL, 234207),
(273335, '1t72E01', NULL, NULL, 116, NULL, NULL, 234207),
(273336, '1t72F01', NULL, NULL, 117, NULL, NULL, 234207),
(273337, '3l39A01', NULL, NULL, 200, NULL, NULL, 234207),
(273338, '1xwmA00', NULL, NULL, 217, NULL, NULL, 234207),
(273339, '4q25A02', NULL, NULL, 98, NULL, NULL, 234207),
(273340, '4q25A01', NULL, NULL, 124, NULL, NULL, 234207),
(273341, '1t8bA01', NULL, NULL, 117, NULL, NULL, 234207),
(273342, '2i0mA02', NULL, NULL, 105, NULL, NULL, 234207),
(273343, '2oltB00', NULL, NULL, 227, NULL, NULL, 234207),
(273344, '2i0mA01', NULL, NULL, 111, NULL, NULL, 234207),
(273345, '1sumB01', NULL, NULL, 108, NULL, NULL, 234207),
(273346, '1vctA01', NULL, NULL, 117, NULL, NULL, 234207),
(273347, '1sumB02', NULL, NULL, 127, NULL, NULL, 234207),
(273348, '5bnzA03', NULL, NULL, 79, NULL, NULL, 234208),
(273349, '4griA03', NULL, NULL, 84, NULL, NULL, 234208),
(273350, '3afhA03', NULL, NULL, 83, NULL, NULL, 234208),
(273351, '6b1pA03', NULL, NULL, 83, NULL, NULL, 234208),
(273352, '4p2bA03', NULL, NULL, 79, NULL, NULL, 234208),
(273353, '2o5rA03', NULL, NULL, 83, NULL, NULL, 234208),
(273354, '2hz7A03', NULL, NULL, 79, NULL, NULL, 234208),
(273355, '2cfoA03', NULL, NULL, 85, NULL, NULL, 234208),
(273356, '1j09A02', NULL, NULL, 85, NULL, NULL, 234208),
(273357, '6b1zA03', NULL, NULL, 102, NULL, NULL, 234208),
(273358, '5h4vA03', NULL, NULL, 83, NULL, NULL, 234208),
(273359, '2ja2A03', NULL, NULL, 84, NULL, NULL, 234208),
(273360, '1qtqA03', NULL, NULL, 79, NULL, NULL, 234208);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(273361, '3mq1A01', NULL, NULL, 92, NULL, NULL, 234209),
(273362, '2jmhA01', NULL, NULL, 101, NULL, NULL, 234209),
(273363, '2lm9A00', NULL, NULL, 96, NULL, NULL, 234209),
(273364, '4ts4A02', NULL, NULL, 113, NULL, NULL, 234210),
(273365, '4iqfA02', NULL, NULL, 108, NULL, NULL, 234210),
(273366, '1fmtA02', NULL, NULL, 105, NULL, NULL, 234210),
(273367, '5uaiA02', NULL, NULL, 103, NULL, NULL, 234210),
(273368, '1s3iA02', NULL, NULL, 105, NULL, NULL, 234210),
(273369, '3r8xA02', NULL, NULL, 106, NULL, NULL, 234210),
(273370, '2blnA02', NULL, NULL, 103, NULL, NULL, 234210),
(273371, '3q0iA02', NULL, NULL, 105, NULL, NULL, 234210),
(273372, '2bw0A02', NULL, NULL, 102, NULL, NULL, 234210),
(273373, '3tqqA02', NULL, NULL, 106, NULL, NULL, 234210),
(273374, '4nv0A02', NULL, NULL, 82, NULL, NULL, 234211),
(273375, '2vkqA02', NULL, NULL, 85, NULL, NULL, 234211),
(273376, '4fe3A02', NULL, NULL, 74, NULL, NULL, 234211),
(273377, '2kdxA00', NULL, NULL, 119, NULL, NULL, 234212),
(273378, '4cguB00', NULL, NULL, 81, NULL, NULL, 234213),
(273379, '3cfuA00', NULL, NULL, 159, NULL, NULL, 234214),
(273380, '1lmiA00', NULL, NULL, 131, NULL, NULL, 234214),
(273381, '2llgA00', NULL, NULL, 143, NULL, NULL, 234214),
(273382, '4lesA00', NULL, NULL, 142, NULL, NULL, 234214),
(273383, '3qfgB00', NULL, NULL, 142, NULL, NULL, 234214),
(273384, '3gygC02', NULL, NULL, 86, NULL, NULL, 234215),
(273385, '1odhA01', NULL, NULL, 71, NULL, NULL, 234216),
(273386, '1jflA01', NULL, NULL, 119, NULL, NULL, 234217),
(273387, '3ojcA02', NULL, NULL, 112, NULL, NULL, 234217),
(273388, '3ojcA01', NULL, NULL, 119, NULL, NULL, 234217),
(273389, '1jflA02', NULL, NULL, 109, NULL, NULL, 234217),
(273390, '2vvtB01', NULL, NULL, 155, NULL, NULL, 234217),
(273391, '3outA02', NULL, NULL, 108, NULL, NULL, 234217),
(273392, '2vvtA02', NULL, NULL, 113, NULL, NULL, 234217),
(273393, '3outA01', NULL, NULL, 160, NULL, NULL, 234217),
(273394, '2jfqA02', NULL, NULL, 114, NULL, NULL, 234217),
(273395, '3s81D01', NULL, NULL, 135, NULL, NULL, 234217),
(273396, '3uhfA02', NULL, NULL, 112, NULL, NULL, 234217),
(273397, '3uhfB01', NULL, NULL, 139, NULL, NULL, 234217),
(273398, '2zskA01', NULL, NULL, 116, NULL, NULL, 234217),
(273399, '2ohoB02', NULL, NULL, 112, NULL, NULL, 234217),
(273400, '2zskA02', NULL, NULL, 110, NULL, NULL, 234217),
(273401, '5evcA02', NULL, NULL, 109, NULL, NULL, 234217),
(273402, '2jfvA01', NULL, NULL, 160, NULL, NULL, 234217),
(273403, '2jfzB01', NULL, NULL, 137, NULL, NULL, 234217),
(273404, '2jfzA02', NULL, NULL, 118, NULL, NULL, 234217),
(273405, '5w16A02', NULL, NULL, 102, NULL, NULL, 234217),
(273406, '5hqtA01', NULL, NULL, 123, NULL, NULL, 234217),
(273407, '1b73A02', NULL, NULL, 109, NULL, NULL, 234217),
(273408, '5w16A01', NULL, NULL, 154, NULL, NULL, 234217),
(273409, '5hqtA02', NULL, NULL, 112, NULL, NULL, 234217),
(273410, '1b73A01', NULL, NULL, 145, NULL, NULL, 234217),
(273411, '5w1qA02', NULL, NULL, 118, NULL, NULL, 234217),
(273412, '5w1qA01', NULL, NULL, 137, NULL, NULL, 234217),
(273413, '5ijwA02', NULL, NULL, 112, NULL, NULL, 234217),
(273414, '2dgdA02', NULL, NULL, 129, NULL, NULL, 234217),
(273415, '5ijwA01', NULL, NULL, 167, NULL, NULL, 234217),
(273416, '2dgdA01', NULL, NULL, 93, NULL, NULL, 234217),
(273417, '2jfnA02', NULL, NULL, 114, NULL, NULL, 234217),
(273418, '2jfnA01', NULL, NULL, 152, NULL, NULL, 234217),
(273419, '2dwuA02', NULL, NULL, 113, NULL, NULL, 234217),
(273420, '2dwuA01', NULL, NULL, 163, NULL, NULL, 234217),
(273421, '2eq5A02', NULL, NULL, 101, NULL, NULL, 234217),
(273422, '2eq5B01', NULL, NULL, 127, NULL, NULL, 234217),
(273423, '2jfuA02', NULL, NULL, 113, NULL, NULL, 234217),
(273424, '1zuwA02', NULL, NULL, 113, NULL, NULL, 234217),
(273425, '1zuwB01', NULL, NULL, 159, NULL, NULL, 234217),
(273426, '2ohoB01', NULL, NULL, 161, NULL, NULL, 234217),
(273427, '5hj7A02', NULL, NULL, 112, NULL, NULL, 234217),
(273428, '5hj7A01', NULL, NULL, 145, NULL, NULL, 234217),
(273429, '2jfqA01', NULL, NULL, 152, NULL, NULL, 234217),
(273430, '3istA02', NULL, NULL, 113, NULL, NULL, 234217),
(273431, '3istB01', NULL, NULL, 156, NULL, NULL, 234217);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(273432, '2gzmB01', NULL, NULL, 154, NULL, NULL, 234217),
(273433, '2gzmA02', NULL, NULL, 113, NULL, NULL, 234217),
(273434, '2ntxA02', NULL, NULL, 117, NULL, NULL, 234218),
(273435, '3veaA01', NULL, NULL, 89, NULL, NULL, 234219),
(273436, '4d8jA01', NULL, NULL, 89, NULL, NULL, 234219),
(273437, '1x31D00', NULL, NULL, 99, NULL, NULL, 234220),
(273438, '2gagD00', NULL, NULL, 99, NULL, NULL, 234220),
(273439, '3w15B00', NULL, NULL, 101, NULL, NULL, 234221),
(273440, '1nthA00', NULL, NULL, 458, NULL, NULL, 234222),
(273441, '1jv1B02', NULL, NULL, 68, NULL, NULL, 234223),
(273442, '3dzyD01', NULL, NULL, 94, NULL, NULL, 234224),
(273443, '1dszA00', NULL, NULL, 86, NULL, NULL, 234224),
(273444, '1a6yA00', NULL, NULL, 94, NULL, NULL, 234224),
(273445, '2hanA00', NULL, NULL, 93, NULL, NULL, 234224),
(273446, '4gatA00', NULL, NULL, 66, NULL, NULL, 234224),
(273447, '5krbB00', NULL, NULL, 84, NULL, NULL, 234224),
(273448, '6bquA00', NULL, NULL, 72, NULL, NULL, 234224),
(273449, '1dszB00', NULL, NULL, 85, NULL, NULL, 234224),
(273450, '1r4iB00', NULL, NULL, 78, NULL, NULL, 234224),
(273451, '2eblA00', NULL, NULL, 89, NULL, NULL, 234224),
(273452, '5uanB01', NULL, NULL, 67, NULL, NULL, 234224),
(273453, '1r4oA00', NULL, NULL, 92, NULL, NULL, 234224),
(273454, '3cbbA00', NULL, NULL, 78, NULL, NULL, 234224),
(273455, '4hc7A02', NULL, NULL, 65, NULL, NULL, 234224),
(273456, '4hc9A01', NULL, NULL, 52, NULL, NULL, 234224),
(273457, '1r0oB00', NULL, NULL, 83, NULL, NULL, 234224),
(273458, '4hc9A02', NULL, NULL, 52, NULL, NULL, 234224),
(273459, '2nllA00', NULL, NULL, 66, NULL, NULL, 234224),
(273460, '4tmaJ00', NULL, NULL, 65, NULL, NULL, 234224),
(273461, '2nllB00', NULL, NULL, 103, NULL, NULL, 234224),
(273462, '2kaeA00', NULL, NULL, 71, NULL, NULL, 234224),
(273463, '5e69A00', NULL, NULL, 73, NULL, NULL, 234224),
(273464, '1latA00', NULL, NULL, 82, NULL, NULL, 234224),
(273465, '6fbqA00', NULL, NULL, 87, NULL, NULL, 234224),
(273466, '1citA00', NULL, NULL, 89, NULL, NULL, 234224),
(273467, '2m9wA00', NULL, NULL, 63, NULL, NULL, 234224),
(273468, '4ondB00', NULL, NULL, 82, NULL, NULL, 234224),
(273469, '3fylA00', NULL, NULL, 90, NULL, NULL, 234224),
(273470, '4nqaI01', NULL, NULL, 93, NULL, NULL, 234224),
(273471, '2gatA00', NULL, NULL, 66, NULL, NULL, 234224),
(273472, '2a66A00', NULL, NULL, 113, NULL, NULL, 234224),
(273473, '5cc1B00', NULL, NULL, 73, NULL, NULL, 234224),
(273474, '3vd6C02', NULL, NULL, 45, NULL, NULL, 234224),
(273475, '5cbxA00', NULL, NULL, 77, NULL, NULL, 234224),
(273476, '5cbzA00', NULL, NULL, 78, NULL, NULL, 234224),
(273477, '1hcqB00', NULL, NULL, 84, NULL, NULL, 234224),
(273478, '2envA00', NULL, NULL, 88, NULL, NULL, 234224),
(273479, '1lo1A00', NULL, NULL, 98, NULL, NULL, 234224),
(273480, '4olnA00', NULL, NULL, 82, NULL, NULL, 234224),
(273481, '2ff0A00', NULL, NULL, 102, NULL, NULL, 234224),
(273482, '3vd6C01', NULL, NULL, 42, NULL, NULL, 234224),
(273483, '1kb2B00', NULL, NULL, 91, NULL, NULL, 234224),
(273484, '2c7aB00', NULL, NULL, 78, NULL, NULL, 234224),
(273485, '2vutI00', NULL, NULL, 43, NULL, NULL, 234224),
(273486, '1on2A02', NULL, NULL, 69, NULL, NULL, 234225),
(273487, '2qq9A02', NULL, NULL, 66, NULL, NULL, 234225),
(273488, '1fx7B02', NULL, NULL, 67, NULL, NULL, 234225),
(273489, '4o5vA02', NULL, NULL, 66, NULL, NULL, 234225),
(273490, '2h09A02', NULL, NULL, 61, NULL, NULL, 234225),
(273491, '1f5tA02', NULL, NULL, 46, NULL, NULL, 234225),
(273492, '4c1nA01', NULL, NULL, 57, NULL, NULL, 234226),
(273493, '3myvA03', NULL, NULL, 117, NULL, NULL, 234227),
(273494, '3ihvA03', NULL, NULL, 139, NULL, NULL, 234227),
(273495, '3kezA03', NULL, NULL, 117, NULL, NULL, 234227),
(273496, '3mcxA03', NULL, NULL, 127, NULL, NULL, 234227),
(273497, '3qi7A01', NULL, NULL, 158, NULL, NULL, 234228),
(273498, '2yo3A03', NULL, NULL, 58, NULL, NULL, 234229),
(273499, '1xhbA02', NULL, NULL, 66, NULL, NULL, 234230),
(273500, '3fs8A02', NULL, NULL, 50, NULL, NULL, 234231),
(273501, '2yqpA00', NULL, NULL, 60, NULL, NULL, 234232),
(273502, '2l0jA00', NULL, NULL, 44, NULL, NULL, 234233),
(273503, '2n70A00', NULL, NULL, 43, NULL, NULL, 234233);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(273504, '1k7bA00', NULL, NULL, 47, NULL, NULL, 234234),
(273505, '1n7dA04', NULL, NULL, 42, NULL, NULL, 234234),
(273506, '2i1pA00', NULL, NULL, 48, NULL, NULL, 234234),
(273507, '1n7dA03', NULL, NULL, 40, NULL, NULL, 234234),
(273508, '1n7dA01', NULL, NULL, 53, NULL, NULL, 234234),
(273509, '1n7dA06', NULL, NULL, 40, NULL, NULL, 234234),
(273510, '1n7dA05', NULL, NULL, 42, NULL, NULL, 234234),
(273511, '1f5yA02', NULL, NULL, 41, NULL, NULL, 234234),
(273512, '1cr8A00', NULL, NULL, 42, NULL, NULL, 234234),
(273513, '2fcwB01', NULL, NULL, 36, NULL, NULL, 234234),
(273514, '1f5yA01', NULL, NULL, 44, NULL, NULL, 234234),
(273515, '1j8eA00', NULL, NULL, 44, NULL, NULL, 234234),
(273516, '2fcwB02', NULL, NULL, 44, NULL, NULL, 234234),
(273517, '2knxA00', NULL, NULL, 50, NULL, NULL, 234234),
(273518, '2jm4A00', NULL, NULL, 43, NULL, NULL, 234234),
(273519, '2m0pA00', NULL, NULL, 52, NULL, NULL, 234234),
(273520, '5oylD00', NULL, NULL, 46, NULL, NULL, 234234),
(273521, '1jrfA00', NULL, NULL, 47, NULL, NULL, 234234),
(273522, '1d2lA00', NULL, NULL, 45, NULL, NULL, 234234),
(273523, '2m96A00', NULL, NULL, 44, NULL, NULL, 234234),
(273524, '1xfeA01', NULL, NULL, 38, NULL, NULL, 234234),
(273525, '2m7pA00', NULL, NULL, 42, NULL, NULL, 234234),
(273526, '1v7zA00', NULL, NULL, 260, NULL, NULL, 234235),
(273527, '3no4B00', NULL, NULL, 267, NULL, NULL, 234235),
(273528, '3lubA01', NULL, NULL, 239, NULL, NULL, 234235),
(273529, '4v19W00', NULL, NULL, 166, NULL, NULL, 234236),
(273530, '6qulT00', NULL, NULL, 110, NULL, NULL, 234236),
(273531, '1vq8R00', NULL, NULL, 155, NULL, NULL, 234236),
(273532, '4a17Q00', NULL, NULL, 158, NULL, NULL, 234236),
(273533, '5x8tT00', NULL, NULL, 144, NULL, NULL, 234236),
(273534, '5dm6P00', NULL, NULL, 127, NULL, NULL, 234236),
(273535, '1vx7W00', NULL, NULL, 203, NULL, NULL, 234236),
(273536, '5xymS00', NULL, NULL, 117, NULL, NULL, 234236),
(273537, '5v7qS00', NULL, NULL, 121, NULL, NULL, 234236),
(273538, '1vwxP00', NULL, NULL, 153, NULL, NULL, 234236),
(273539, '6hmaQ00', NULL, NULL, 112, NULL, NULL, 234236),
(273540, '5oomT00', NULL, NULL, 166, NULL, NULL, 234236),
(273541, '3o58Q00', NULL, NULL, 156, NULL, NULL, 234236),
(273542, '1i4jA00', NULL, NULL, 110, NULL, NULL, 234236),
(273543, '5lz6A00', NULL, NULL, 129, NULL, NULL, 234237),
(273544, '4uybA02', NULL, NULL, 110, NULL, NULL, 234237),
(273545, '1olmA02', NULL, NULL, 110, NULL, NULL, 234237),
(273546, '4tlgB02', NULL, NULL, 110, NULL, NULL, 234237),
(273547, '2vugA05', NULL, NULL, 48, NULL, NULL, 234238),
(273548, '2qgmA02', NULL, NULL, 72, NULL, NULL, 234239),
(273549, '3b55A02', NULL, NULL, 72, NULL, NULL, 234239),
(273550, '3ojaA02', NULL, NULL, 105, NULL, NULL, 234240),
(273551, '3e9lA02', NULL, NULL, 95, NULL, NULL, 234241),
(273552, '4jk8A02', NULL, NULL, 69, NULL, NULL, 234241),
(273553, '3sbtA02', NULL, NULL, 99, NULL, NULL, 234241),
(273554, '2lxwA00', NULL, NULL, 55, NULL, NULL, 234242),
(273555, '2w2gB01', NULL, NULL, 131, NULL, NULL, 234243),
(273556, '3ov5A00', NULL, NULL, 85, NULL, NULL, 234244),
(273557, '3ne5B04', NULL, NULL, 51, NULL, NULL, 234245),
(273558, '2ko6A00', NULL, NULL, 89, NULL, NULL, 234246),
(273559, '5wtuC00', NULL, NULL, 110, NULL, NULL, 234247),
(273560, '4lrvF00', NULL, NULL, 109, NULL, NULL, 234247),
(273561, '2zi0B00', NULL, NULL, 58, NULL, NULL, 234248),
(273562, '2zi0A00', NULL, NULL, 75, NULL, NULL, 234248),
(273563, '3hrzC01', NULL, NULL, 57, NULL, NULL, 234249),
(273564, '1rq0A01', NULL, NULL, 83, NULL, NULL, 234250),
(273565, '3h4zB03', NULL, NULL, 196, NULL, NULL, 234251),
(273566, '3uv1A00', NULL, NULL, 196, NULL, NULL, 234251),
(273567, '4h63H02', NULL, NULL, 44, NULL, NULL, 234252),
(273568, '1qexA02', NULL, NULL, 103, NULL, NULL, 234253),
(273569, '2kslA00', NULL, NULL, 51, NULL, NULL, 234254),
(273570, '3no7A00', NULL, NULL, 80, NULL, NULL, 234255),
(273571, '3sp1A02', NULL, NULL, 162, NULL, NULL, 234256),
(273572, '1pl5A00', NULL, NULL, 87, NULL, NULL, 234257),
(273573, '3fgaD00', NULL, NULL, 47, NULL, NULL, 234257),
(273574, '2kwyA00', NULL, NULL, 43, NULL, NULL, 234257);
INSERT INTO "PUBLIC"."MODEL" VALUES
(273575, '1tu3J00', NULL, NULL, 61, NULL, NULL, 234257),
(273576, '1uixB00', NULL, NULL, 71, NULL, NULL, 234257),
(273577, '1s1cX00', NULL, NULL, 71, NULL, NULL, 234257),
(273578, '5c5oA03', NULL, NULL, 109, NULL, NULL, 234258),
(273579, '2q6fB03', NULL, NULL, 112, NULL, NULL, 234258),
(273580, '2ynaB03', NULL, NULL, 106, NULL, NULL, 234258),
(273581, '5zqgA03', NULL, NULL, 111, NULL, NULL, 234258),
(273582, '3d23A03', NULL, NULL, 103, NULL, NULL, 234258),
(273583, '4wmeB03', NULL, NULL, 106, NULL, NULL, 234258),
(273584, '4zroA03', NULL, NULL, 103, NULL, NULL, 234258),
(273585, '2zu2A03', NULL, NULL, 106, NULL, NULL, 234258),
(273586, '3ea8A03', NULL, NULL, 104, NULL, NULL, 234258),
(273587, '3tloA03', NULL, NULL, 106, NULL, NULL, 234258),
(273588, '2qcyA03', NULL, NULL, 107, NULL, NULL, 234258),
(273589, '6jijC03', NULL, NULL, 106, NULL, NULL, 234258),
(273590, '5gwzA03', NULL, NULL, 106, NULL, NULL, 234258),
(273591, '1lvoA03', NULL, NULL, 106, NULL, NULL, 234258),
(273592, '1s0pA01', NULL, NULL, 171, NULL, NULL, 234259),
(273593, '3duzA03', NULL, NULL, 77, NULL, NULL, 234260),
(273594, '1k1xB01', NULL, NULL, 381, NULL, NULL, 234261),
(273595, '2k5dA01', NULL, NULL, 115, NULL, NULL, 234262),
(273596, '3o0pA00', NULL, NULL, 216, NULL, NULL, 234263),
(273597, '5uttA00', NULL, NULL, 190, NULL, NULL, 234263),
(273598, '2w1jA00', NULL, NULL, 212, NULL, NULL, 234263),
(273599, '2oqzA00', NULL, NULL, 223, NULL, NULL, 234263),
(273600, '5jcvA00', NULL, NULL, 183, NULL, NULL, 234263),
(273601, '5b23A00', NULL, NULL, 191, NULL, NULL, 234263),
(273602, '6bweB00', NULL, NULL, 193, NULL, NULL, 234263),
(273603, '5cuwA00', NULL, NULL, 195, NULL, NULL, 234263),
(273604, '2kw8A00', NULL, NULL, 158, NULL, NULL, 234263),
(273605, '4o8tA00', NULL, NULL, 187, NULL, NULL, 234263),
(273606, '2xwgC00', NULL, NULL, 182, NULL, NULL, 234263),
(273607, '4d7wA00', NULL, NULL, 208, NULL, NULL, 234263),
(273608, '4g1jB00', NULL, NULL, 205, NULL, NULL, 234263),
(273609, '1ng5B00', NULL, NULL, 215, NULL, NULL, 234263),
(273610, '3g66A00', NULL, NULL, 212, NULL, NULL, 234263),
(273611, '3re9A00', NULL, NULL, 187, NULL, NULL, 234263),
(273612, '4d70A00', NULL, NULL, 160, NULL, NULL, 234263),
(273613, '4g1hA00', NULL, NULL, 195, NULL, NULL, 234263),
(273614, '3psqB00', NULL, NULL, 186, NULL, NULL, 234263),
(273615, '1t2wA00', NULL, NULL, 145, NULL, NULL, 234263),
(273616, '3rccN00', NULL, NULL, 160, NULL, NULL, 234263),
(273617, '5go5A00', NULL, NULL, 157, NULL, NULL, 234263),
(273618, '2w1kA00', NULL, NULL, 212, NULL, NULL, 234263),
(273619, '4y4qA00', NULL, NULL, 185, NULL, NULL, 234263),
(273620, '2ln7A00', NULL, NULL, 147, NULL, NULL, 234263),
(273621, '5gyjA00', NULL, NULL, 196, NULL, NULL, 234263),
(273622, '3fn5B00', NULL, NULL, 163, NULL, NULL, 234263),
(273623, '1vk9A00', NULL, NULL, 151, NULL, NULL, 234264),
(273624, '6gzlA00', NULL, NULL, 90, NULL, NULL, 234265),
(273625, '2xqqC00', NULL, NULL, 89, NULL, NULL, 234265),
(273626, '4ds1A00', NULL, NULL, 97, NULL, NULL, 234265),
(273627, '3rjsA00', NULL, NULL, 89, NULL, NULL, 234265),
(273628, '5wofB00', NULL, NULL, 85, NULL, NULL, 234265),
(273629, '5e0lA00', NULL, NULL, 89, NULL, NULL, 234265),
(273630, '2wyhA05', NULL, NULL, 134, NULL, NULL, 234266),
(273631, '5kbpA03', NULL, NULL, 134, NULL, NULL, 234266),
(273632, '3p12A01', NULL, NULL, 124, NULL, NULL, 234267),
(273633, '1ogdA01', NULL, NULL, 121, NULL, NULL, 234267),
(273634, '4a34A01', NULL, NULL, 129, NULL, NULL, 234267),
(273635, '3e7nA01', NULL, NULL, 129, NULL, NULL, 234267),
(273636, '3mvkD01', NULL, NULL, 133, NULL, NULL, 234267),
(273637, '2wcuA01', NULL, NULL, 135, NULL, NULL, 234267),
(273638, '2wcvA01', NULL, NULL, 128, NULL, NULL, 234267),
(273639, '2ob5A00', NULL, NULL, 153, NULL, NULL, 234267),
(273640, '3no0A00', NULL, NULL, 276, NULL, NULL, 234268),
(273641, '3l6vB00', NULL, NULL, 311, NULL, NULL, 234268),
(273642, '1wp5A00', NULL, NULL, 323, NULL, NULL, 234268),
(273643, '1suuA00', NULL, NULL, 312, NULL, NULL, 234268),
(273644, '4g3nA00', NULL, NULL, 309, NULL, NULL, 234268),
(273645, '5ztjA00', NULL, NULL, 312, NULL, NULL, 234268);
INSERT INTO "PUBLIC"."MODEL" VALUES
(273646, '1zi0B00', NULL, NULL, 307, NULL, NULL, 234268),
(273647, '5z29A00', NULL, NULL, 312, NULL, NULL, 234269),
(273648, '4mb8D00', NULL, NULL, 304, NULL, NULL, 234269),
(273649, '2yzcA00', NULL, NULL, 302, NULL, NULL, 234269),
(273650, '2r5rA00', NULL, NULL, 249, NULL, NULL, 234269),
(273651, '5ll1A00', NULL, NULL, 298, NULL, NULL, 234269),
(273652, '3l8wA00', NULL, NULL, 296, NULL, NULL, 234269),
(273653, '4r8xC00', NULL, NULL, 322, NULL, NULL, 234269),
(273654, '5k9gA00', NULL, NULL, 257, NULL, NULL, 234269),
(273655, '4dzaA02', NULL, NULL, 217, NULL, NULL, 234270),
(273656, '6a2fA02', NULL, NULL, 208, NULL, NULL, 234270),
(273657, '4aibA02', NULL, NULL, 229, NULL, NULL, 234270),
(273658, '2vd8B02', NULL, NULL, 214, NULL, NULL, 234270),
(273659, '7odcA02', NULL, NULL, 232, NULL, NULL, 234270),
(273660, '5nlcA00', NULL, NULL, 228, NULL, NULL, 234270),
(273661, '4y2wA02', NULL, NULL, 215, NULL, NULL, 234270),
(273662, '5fagB02', NULL, NULL, 222, NULL, NULL, 234270),
(273663, '4bf5A02', NULL, NULL, 218, NULL, NULL, 234270),
(273664, '4bhyC02', NULL, NULL, 208, NULL, NULL, 234270),
(273665, '3n2bB02', NULL, NULL, 243, NULL, NULL, 234270),
(273666, '2yxxA02', NULL, NULL, 229, NULL, NULL, 234270),
(273667, '4qhrA02', NULL, NULL, 208, NULL, NULL, 234270),
(273668, '3e5pA02', NULL, NULL, 222, NULL, NULL, 234270),
(273669, '5x7nA02', NULL, NULL, 257, NULL, NULL, 234270),
(273670, '2j66A02', NULL, NULL, 255, NULL, NULL, 234270),
(273671, '4beuA02', NULL, NULL, 217, NULL, NULL, 234270),
(273672, '2vd9B02', NULL, NULL, 214, NULL, NULL, 234270),
(273673, '2nvaC02', NULL, NULL, 233, NULL, NULL, 234270),
(273674, '3anuA02', NULL, NULL, 226, NULL, NULL, 234270),
(273675, '3r79A00', NULL, NULL, 244, NULL, NULL, 234270),
(273676, '1f3tA02', NULL, NULL, 234, NULL, NULL, 234270),
(273677, '3hurA02', NULL, NULL, 223, NULL, NULL, 234270),
(273678, '4eclA02', NULL, NULL, 221, NULL, NULL, 234270),
(273679, '3llxA02', NULL, NULL, 219, NULL, NULL, 234270),
(273680, '2odoA02', NULL, NULL, 207, NULL, NULL, 234270),
(273681, '3n2oA02', NULL, NULL, 282, NULL, NULL, 234270),
(273682, '5yycA02', NULL, NULL, 216, NULL, NULL, 234270),
(273683, '3co8A02', NULL, NULL, 221, NULL, NULL, 234270),
(273684, '1twiA02', NULL, NULL, 256, NULL, NULL, 234270),
(273685, '3s46A02', NULL, NULL, 218, NULL, NULL, 234270),
(273686, '3btnA02', NULL, NULL, 231, NULL, NULL, 234270),
(273687, '4v15A02', NULL, NULL, 223, NULL, NULL, 234270),
(273688, '3gwqA02', NULL, NULL, 233, NULL, NULL, 234270),
(273689, '3cpgA00', NULL, NULL, 282, NULL, NULL, 234270),
(273690, '2pljA02', NULL, NULL, 238, NULL, NULL, 234270),
(273691, '3vabA02', NULL, NULL, 244, NULL, NULL, 234270),
(273692, '1xfcB02', NULL, NULL, 216, NULL, NULL, 234270),
(273693, '2vd8A02', NULL, NULL, 214, NULL, NULL, 234270),
(273694, '2qghA02', NULL, NULL, 242, NULL, NULL, 234270),
(273695, '3uw6B02', NULL, NULL, 210, NULL, NULL, 234270),
(273696, '6q71A02', NULL, NULL, 217, NULL, NULL, 234270),
(273697, '4wr3A02', NULL, NULL, 208, NULL, NULL, 234270),
(273698, '6n2aB02', NULL, NULL, 244, NULL, NULL, 234270),
(273699, '3nzqA02', NULL, NULL, 277, NULL, NULL, 234270),
(273700, '3n29A02', NULL, NULL, 226, NULL, NULL, 234270),
(273701, '3sy1A00', NULL, NULL, 229, NULL, NULL, 234270),
(273702, '4xg1D02', NULL, NULL, 242, NULL, NULL, 234270),
(273703, '1rcqA02', NULL, NULL, 207, NULL, NULL, 234270),
(273704, '3kw3A02', NULL, NULL, 212, NULL, NULL, 234270),
(273705, '4lusA02', NULL, NULL, 215, NULL, NULL, 234270),
(273706, '2o0tA02', NULL, NULL, 261, NULL, NULL, 234270),
(273707, '3wqcA02', NULL, NULL, 223, NULL, NULL, 234270),
(273708, '3mt1B02', NULL, NULL, 227, NULL, NULL, 234270),
(273709, '3ha1A02', NULL, NULL, 214, NULL, NULL, 234270),
(273710, '2p3eA02', NULL, NULL, 241, NULL, NULL, 234270),
(273711, '4dyjA02', NULL, NULL, 217, NULL, NULL, 234270),
(273712, '1bd0A01', NULL, NULL, 211, NULL, NULL, 234270),
(273713, '2dy3C02', NULL, NULL, 210, NULL, NULL, 234270),
(273714, '2vd9A02', NULL, NULL, 214, NULL, NULL, 234270),
(273715, '1knwA02', NULL, NULL, 245, NULL, NULL, 234270),
(273716, '1vfsA02', NULL, NULL, 216, NULL, NULL, 234270);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(273717, '3nzpB02', NULL, NULL, 278, NULL, NULL, 234270),
(273718, '2oo0A02', NULL, NULL, 234, NULL, NULL, 234270),
(273719, '1ct5A00', NULL, NULL, 256, NULL, NULL, 234270),
(273720, '6g58A02', NULL, NULL, 210, NULL, NULL, 234270),
(273721, '5gjoA02', NULL, NULL, 235, NULL, NULL, 234270),
(273722, '2auwA01', NULL, NULL, 87, NULL, NULL, 234271),
(273723, '1td6A01', NULL, NULL, 102, NULL, NULL, 234272),
(273724, '2oo4A01', NULL, NULL, 118, NULL, NULL, 234273),
(273725, '3etoA01', NULL, NULL, 122, NULL, NULL, 234273),
(273726, '5czxA01', NULL, NULL, 128, NULL, NULL, 234273),
(273727, '1n7vA01', NULL, NULL, 177, NULL, NULL, 234274),
(273728, '5ft9A02', NULL, NULL, 185, NULL, NULL, 234275),
(273729, '4g26A02', NULL, NULL, 176, NULL, NULL, 234275),
(273730, '3v33A00', NULL, NULL, 163, NULL, NULL, 234275),
(273731, '3m1cA04', NULL, NULL, 149, NULL, NULL, 234276),
(273732, '2xqyA03', NULL, NULL, 142, NULL, NULL, 234276),
(273733, '5dayB02', NULL, NULL, 147, NULL, NULL, 234277),
(273734, '3gywA02', NULL, NULL, 189, NULL, NULL, 234277),
(273735, '2e50B02', NULL, NULL, 146, NULL, NULL, 234277),
(273736, '5x7vF02', NULL, NULL, 147, NULL, NULL, 234277),
(273737, '2ejbA00', NULL, NULL, 189, NULL, NULL, 234278),
(273738, '1sbzB00', NULL, NULL, 176, NULL, NULL, 234278),
(273739, '1sbzC00', NULL, NULL, 176, NULL, NULL, 234278),
(273740, '1sbzD00', NULL, NULL, 197, NULL, NULL, 234278),
(273741, '4zavA00', NULL, NULL, 209, NULL, NULL, 234278),
(273742, '1g63B00', NULL, NULL, 181, NULL, NULL, 234278),
(273743, '1sbzA00', NULL, NULL, 197, NULL, NULL, 234278),
(273744, '1mvlA00', NULL, NULL, 191, NULL, NULL, 234278),
(273745, '4rhfA00', NULL, NULL, 209, NULL, NULL, 234278),
(273746, '3qjgA00', NULL, NULL, 175, NULL, NULL, 234278),
(273747, '3mcuC00', NULL, NULL, 207, NULL, NULL, 234278),
(273748, '3mcuB00', NULL, NULL, 207, NULL, NULL, 234278),
(273749, '3mcuA00', NULL, NULL, 207, NULL, NULL, 234278),
(273750, '1qzuA00', NULL, NULL, 206, NULL, NULL, 234278),
(273751, '3wisA00', NULL, NULL, 181, NULL, NULL, 234278),
(273752, '1p3y100', NULL, NULL, 194, NULL, NULL, 234278),
(273753, '3lqkA00', NULL, NULL, 201, NULL, NULL, 234278),
(273754, '3mcuF00', NULL, NULL, 207, NULL, NULL, 234278),
(273755, '3mcuE00', NULL, NULL, 207, NULL, NULL, 234278),
(273756, '3mcuD00', NULL, NULL, 207, NULL, NULL, 234278),
(273757, '3ifuA01', NULL, NULL, 51, NULL, NULL, 234279),
(273758, '2uv8A07', NULL, NULL, 85, NULL, NULL, 234280),
(273759, '2uv9A08', NULL, NULL, 92, NULL, NULL, 234280),
(273760, '2jn6A01', NULL, NULL, 85, NULL, NULL, 234281),
(273761, '4mxmB01', NULL, NULL, 61, NULL, NULL, 234281),
(273762, '1zkgA01', NULL, NULL, 58, NULL, NULL, 234281),
(273763, '1hcrA00', NULL, NULL, 52, NULL, NULL, 234281),
(273764, '3e7lA00', NULL, NULL, 63, NULL, NULL, 234281),
(273765, '5k7fA01', NULL, NULL, 41, NULL, NULL, 234281),
(273766, '1a5jA02', NULL, NULL, 49, NULL, NULL, 234281),
(273767, '2pmzN00', NULL, NULL, 66, NULL, NULL, 234281),
(273768, '1a5jA01', NULL, NULL, 56, NULL, NULL, 234281),
(273769, '3lnqA00', NULL, NULL, 58, NULL, NULL, 234281),
(273770, '4b4cA02', NULL, NULL, 111, NULL, NULL, 234281),
(273771, '2eqrA01', NULL, NULL, 46, NULL, NULL, 234281),
(273772, '2ltpA00', NULL, NULL, 71, NULL, NULL, 234281),
(273773, '2da7A00', NULL, NULL, 71, NULL, NULL, 234281),
(273774, '2ys9A00', NULL, NULL, 70, NULL, NULL, 234281),
(273775, '1umqA00', NULL, NULL, 60, NULL, NULL, 234281),
(273776, '4iejA00', NULL, NULL, 93, NULL, NULL, 234281),
(273777, '2dmtA00', NULL, NULL, 80, NULL, NULL, 234281),
(273778, '3zqcA02', NULL, NULL, 77, NULL, NULL, 234281),
(273779, '3zqcA01', NULL, NULL, 54, NULL, NULL, 234281),
(273780, '2lvsA02', NULL, NULL, 49, NULL, NULL, 234281),
(273781, '2lvsA01', NULL, NULL, 56, NULL, NULL, 234281),
(273782, '2fq4A01', NULL, NULL, 55, NULL, NULL, 234281),
(273783, '2mg4A00', NULL, NULL, 66, NULL, NULL, 234281),
(273784, '3bqyA01', NULL, NULL, 56, NULL, NULL, 234281),
(273785, '2optB01', NULL, NULL, 66, NULL, NULL, 234281),
(273786, '4fcyA01', NULL, NULL, 89, NULL, NULL, 234281),
(273787, '1nk3P00', NULL, NULL, 77, NULL, NULL, 234281);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(273788, '1etxA00', NULL, NULL, 98, NULL, NULL, 234281),
(273789, '3sdgA01', NULL, NULL, 42, NULL, NULL, 234281),
(273790, '1au7A02', NULL, NULL, 57, NULL, NULL, 234281),
(273791, '2k9qA01', NULL, NULL, 40, NULL, NULL, 234281),
(273792, '2da2A01', NULL, NULL, 55, NULL, NULL, 234281),
(273793, '1x2nA01', NULL, NULL, 60, NULL, NULL, 234281),
(273794, '3k2aB00', NULL, NULL, 67, NULL, NULL, 234281),
(273795, '4jykA01', NULL, NULL, 69, NULL, NULL, 234281),
(273796, '1ftzA00', NULL, NULL, 70, NULL, NULL, 234281),
(273797, '3mvpA01', NULL, NULL, 47, NULL, NULL, 234281),
(273798, '4g12A01', NULL, NULL, 43, NULL, NULL, 234281),
(273799, '2dmnA00', NULL, NULL, 83, NULL, NULL, 234281),
(273800, '2ecbA01', NULL, NULL, 51, NULL, NULL, 234281),
(273801, '2cqqA01', NULL, NULL, 67, NULL, NULL, 234281),
(273802, '2y30B01', NULL, NULL, 82, NULL, NULL, 234281),
(273803, '5k7fB01', NULL, NULL, 57, NULL, NULL, 234281),
(273804, '4a69D00', NULL, NULL, 73, NULL, NULL, 234281),
(273805, '1sanA00', NULL, NULL, 62, NULL, NULL, 234281),
(273806, '1u8bA02', NULL, NULL, 62, NULL, NULL, 234281),
(273807, '4w97A01', NULL, NULL, 51, NULL, NULL, 234281),
(273808, '5zjtE00', NULL, NULL, 64, NULL, NULL, 234281),
(273809, '5jlwA00', NULL, NULL, 61, NULL, NULL, 234281),
(273810, '3dewA01', NULL, NULL, 59, NULL, NULL, 234281),
(273811, '2e19A01', NULL, NULL, 47, NULL, NULL, 234281),
(273812, '3ukgA02', NULL, NULL, 131, NULL, NULL, 234281),
(273813, '6g8hD01', NULL, NULL, 54, NULL, NULL, 234281),
(273814, '1fipA00', NULL, NULL, 73, NULL, NULL, 234281),
(273815, '4mloA03', NULL, NULL, 65, NULL, NULL, 234281),
(273816, '4fcyB02', NULL, NULL, 65, NULL, NULL, 234281),
(273817, '3vprA01', NULL, NULL, 44, NULL, NULL, 234281),
(273818, '4xrsG00', NULL, NULL, 56, NULL, NULL, 234281),
(273819, '2e1oA01', NULL, NULL, 57, NULL, NULL, 234281),
(273820, '1ojlA03', NULL, NULL, 47, NULL, NULL, 234281),
(273821, '1x2mA01', NULL, NULL, 54, NULL, NULL, 234281),
(273822, '2hosB00', NULL, NULL, 63, NULL, NULL, 234281),
(273823, '2yusA01', NULL, NULL, 53, NULL, NULL, 234281),
(273824, '2h8rA02', NULL, NULL, 76, NULL, NULL, 234281),
(273825, '1lfbA00', NULL, NULL, 99, NULL, NULL, 234281),
(273826, '4rboA00', NULL, NULL, 70, NULL, NULL, 234281),
(273827, '5hodA00', NULL, NULL, 61, NULL, NULL, 234281),
(273828, '3bg3A04', NULL, NULL, 47, NULL, NULL, 234281),
(273829, '5ojxA01', NULL, NULL, 88, NULL, NULL, 234281),
(273830, '2id3A01', NULL, NULL, 49, NULL, NULL, 234281),
(273831, '3f0cA01', NULL, NULL, 58, NULL, NULL, 234281),
(273832, '2x48A00', NULL, NULL, 55, NULL, NULL, 234281),
(273833, '3d1nL02', NULL, NULL, 67, NULL, NULL, 234281),
(273834, '1rktA01', NULL, NULL, 54, NULL, NULL, 234281),
(273835, '3nauA00', NULL, NULL, 66, NULL, NULL, 234281),
(273836, '2xsdC02', NULL, NULL, 68, NULL, NULL, 234281),
(273837, '3tedA02', NULL, NULL, 113, NULL, NULL, 234281),
(273838, '2llkA01', NULL, NULL, 41, NULL, NULL, 234281),
(273839, '2hddB00', NULL, NULL, 61, NULL, NULL, 234281),
(273840, '3h0gJ00', NULL, NULL, 71, NULL, NULL, 234281),
(273841, '1uhsA01', NULL, NULL, 54, NULL, NULL, 234281),
(273842, '2da3A01', NULL, NULL, 47, NULL, NULL, 234281),
(273843, '4uusE00', NULL, NULL, 77, NULL, NULL, 234281),
(273844, '1s7eA02', NULL, NULL, 74, NULL, NULL, 234281),
(273845, '3lsgA01', NULL, NULL, 55, NULL, NULL, 234281),
(273846, '2m0cA00', NULL, NULL, 75, NULL, NULL, 234281),
(273847, '3lsgA02', NULL, NULL, 48, NULL, NULL, 234281),
(273848, '4fe7A03', NULL, NULL, 112, NULL, NULL, 234281),
(273849, '1ic8A02', NULL, NULL, 76, NULL, NULL, 234281),
(273850, '1ntcA00', NULL, NULL, 91, NULL, NULL, 234281),
(273851, '1bw6A00', NULL, NULL, 56, NULL, NULL, 234281),
(273852, '1jggA00', NULL, NULL, 60, NULL, NULL, 234281),
(273853, '1twfJ00', NULL, NULL, 70, NULL, NULL, 234281),
(273854, '4jp0A03', NULL, NULL, 38, NULL, NULL, 234281),
(273855, '2djnA01', NULL, NULL, 57, NULL, NULL, 234281),
(273856, '2gloA00', NULL, NULL, 59, NULL, NULL, 234281),
(273857, '1guuA00', NULL, NULL, 52, NULL, NULL, 234281),
(273858, '2jmwA01', NULL, NULL, 63, NULL, NULL, 234281),
(273859, '2y9yA02', NULL, NULL, 56, NULL, NULL, 234281); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(273860, '2y9yA04', NULL, NULL, 96, NULL, NULL, 234281),
(273861, '1jusD01', NULL, NULL, 49, NULL, NULL, 234281),
(273862, '3c2bA01', NULL, NULL, 65, NULL, NULL, 234281),
(273863, '5nioA01', NULL, NULL, 46, NULL, NULL, 234281),
(273864, '4mo7A01', NULL, NULL, 46, NULL, NULL, 234281),
(273865, '3oioA00', NULL, NULL, 113, NULL, NULL, 234281),
(273866, '2fd5A01', NULL, NULL, 48, NULL, NULL, 234281),
(273867, '2r5yA00', NULL, NULL, 88, NULL, NULL, 234281),
(273868, '1hdpA00', NULL, NULL, 63, NULL, NULL, 234281),
(273869, '3w6vA00', NULL, NULL, 111, NULL, NULL, 234281),
(273870, '2np3B01', NULL, NULL, 61, NULL, NULL, 234281),
(273871, '1du6A00', NULL, NULL, 64, NULL, NULL, 234281),
(273872, '2djoA00', NULL, NULL, 89, NULL, NULL, 234281),
(273873, '4rduA01', NULL, NULL, 55, NULL, NULL, 234281),
(273874, '1zk8A01', NULL, NULL, 51, NULL, NULL, 234281),
(273875, '1q1vA00', NULL, NULL, 70, NULL, NULL, 234281),
(273876, '5z2sA00', NULL, NULL, 55, NULL, NULL, 234281),
(273877, '3zqiA01', NULL, NULL, 66, NULL, NULL, 234281),
(273878, '1wh7A01', NULL, NULL, 53, NULL, NULL, 234281),
(273879, '1mnmC00', NULL, NULL, 87, NULL, NULL, 234281),
(273880, '3oouA01', NULL, NULL, 58, NULL, NULL, 234281),
(273881, '3oouA02', NULL, NULL, 50, NULL, NULL, 234281),
(273882, '1irzA00', NULL, NULL, 64, NULL, NULL, 234281),
(273883, '2vkvA01', NULL, NULL, 66, NULL, NULL, 234281),
(273884, '2l7fP00', NULL, NULL, 68, NULL, NULL, 234281),
(273885, '1fexA00', NULL, NULL, 59, NULL, NULL, 234281),
(273886, '2ly9A00', NULL, NULL, 74, NULL, NULL, 234281),
(273887, '1rr7A01', NULL, NULL, 46, NULL, NULL, 234281),
(273888, '1rr7A02', NULL, NULL, 57, NULL, NULL, 234281),
(273889, '1ug2A01', NULL, NULL, 52, NULL, NULL, 234281),
(273890, '3dcfA01', NULL, NULL, 43, NULL, NULL, 234281),
(273891, '1xc5A01', NULL, NULL, 48, NULL, NULL, 234281),
(273892, '2d5vA02', NULL, NULL, 65, NULL, NULL, 234281),
(273893, '1z0xA01', NULL, NULL, 69, NULL, NULL, 234281),
(273894, '3a02A00', NULL, NULL, 60, NULL, NULL, 234281),
(273895, '1le8B00', NULL, NULL, 83, NULL, NULL, 234281),
(273896, '1zq3P00', NULL, NULL, 68, NULL, NULL, 234281),
(273897, '2m2eA00', NULL, NULL, 73, NULL, NULL, 234281),
(273898, '1fttA00', NULL, NULL, 68, NULL, NULL, 234281),
(273899, '1k61A00', NULL, NULL, 60, NULL, NULL, 234281),
(273900, '2da4A01', NULL, NULL, 66, NULL, NULL, 234281),
(273901, '6azhA01', NULL, NULL, 54, NULL, NULL, 234281),
(273902, '1e3oC02', NULL, NULL, 48, NULL, NULL, 234281),
(273903, '1ig7A00', NULL, NULL, 58, NULL, NULL, 234281),
(273904, '4jykB01', NULL, NULL, 53, NULL, NULL, 234281),
(273905, '2elkA00', NULL, NULL, 58, NULL, NULL, 234281),
(273906, '2cu7A01', NULL, NULL, 50, NULL, NULL, 234281),
(273907, '2cqxA01', NULL, NULL, 54, NULL, NULL, 234281),
(273908, '1ef4A00', NULL, NULL, 55, NULL, NULL, 234281),
(273909, '1wpkA02', NULL, NULL, 67, NULL, NULL, 234281),
(273910, '1bw5A00', NULL, NULL, 66, NULL, NULL, 234281),
(273911, '1pufA00', NULL, NULL, 77, NULL, NULL, 234281),
(273912, '3qqaA01', NULL, NULL, 70, NULL, NULL, 234281),
(273913, '2nogB02', NULL, NULL, 84, NULL, NULL, 234281),
(273914, '3fiwC01', NULL, NULL, 57, NULL, NULL, 234281),
(273915, '2ld5A00', NULL, NULL, 71, NULL, NULL, 234281),
(273916, '1h8aC01', NULL, NULL, 56, NULL, NULL, 234281),
(273917, '2m8gX00', NULL, NULL, 70, NULL, NULL, 234281),
(273918, '1gdtB03', NULL, NULL, 45, NULL, NULL, 234281),
(273919, '5eeaB00', NULL, NULL, 63, NULL, NULL, 234281),
(273920, '5icnA02', NULL, NULL, 50, NULL, NULL, 234281),
(273921, '1gv2A02', NULL, NULL, 46, NULL, NULL, 234281),
(273922, '6a8rA00', NULL, NULL, 60, NULL, NULL, 234281),
(273923, '3sjmA00', NULL, NULL, 64, NULL, NULL, 234281),
(273924, '2cjjA00', NULL, NULL, 70, NULL, NULL, 234281),
(273925, '5mruA01', NULL, NULL, 66, NULL, NULL, 234281),
(273926, '2h1kB00', NULL, NULL, 63, NULL, NULL, 234281),
(273927, '1ztrA00', NULL, NULL, 61, NULL, NULL, 234281),
(273928, '2cueA01', NULL, NULL, 57, NULL, NULL, 234281),
(273929, '4eefH00', NULL, NULL, 55, NULL, NULL, 234281),
(273930, '1wi3A00', NULL, NULL, 71, NULL, NULL, 234281),
(273931, '1ignB02', NULL, NULL, 100, NULL, NULL, 234281); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(273932, '1vi0A01', NULL, NULL, 51, NULL, NULL, 234281),
(273933, '3cmyA00', NULL, NULL, 61, NULL, NULL, 234281),
(273934, '1pufB00', NULL, NULL, 73, NULL, NULL, 234281),
(273935, '3l1pA02', NULL, NULL, 56, NULL, NULL, 234281),
(273936, '3ccyA01', NULL, NULL, 56, NULL, NULL, 234281),
(273937, '4d5cA01', NULL, NULL, 65, NULL, NULL, 234281),
(273938, '2cobA01', NULL, NULL, 44, NULL, NULL, 234281),
(273939, '4l5eA00', NULL, NULL, 46, NULL, NULL, 234281),
(273940, '2k9nA01', NULL, NULL, 53, NULL, NULL, 234281),
(273941, '3zobA00', NULL, NULL, 67, NULL, NULL, 234281),
(273942, '2k9nA02', NULL, NULL, 54, NULL, NULL, 234281),
(273943, '2l9rA00', NULL, NULL, 69, NULL, NULL, 234281),
(273944, '5xogJ00', NULL, NULL, 72, NULL, NULL, 234281),
(273945, '3mklA00', NULL, NULL, 120, NULL, NULL, 234281),
(273946, '5zjtA00', NULL, NULL, 84, NULL, NULL, 234281),
(273947, '2da5A00', NULL, NULL, 75, NULL, NULL, 234281),
(273948, '1tc3C00', NULL, NULL, 51, NULL, NULL, 234281),
(273949, '6fqpB01', NULL, NULL, 59, NULL, NULL, 234281),
(273950, '3rqiA02', NULL, NULL, 51, NULL, NULL, 234281),
(273951, '2k9sA00', NULL, NULL, 107, NULL, NULL, 234281),
(273952, '2kt0A01', NULL, NULL, 47, NULL, NULL, 234281),
(273953, '3cdlA01', NULL, NULL, 59, NULL, NULL, 234281),
(273954, '1w0tA00', NULL, NULL, 53, NULL, NULL, 234281),
(273955, '3narA00', NULL, NULL, 70, NULL, NULL, 234281),
(273956, '2of7A01', NULL, NULL, 51, NULL, NULL, 234281),
(273957, '2iaiA01', NULL, NULL, 81, NULL, NULL, 234281),
(273958, '3a03A00', NULL, NULL, 56, NULL, NULL, 234281),
(273959, '3tw6A06', NULL, NULL, 54, NULL, NULL, 234281),
(273960, '6mj1A01', NULL, NULL, 47, NULL, NULL, 234281),
(273961, '6gmhJ00', NULL, NULL, 67, NULL, NULL, 234281),
(273962, '2r0qC02', NULL, NULL, 64, NULL, NULL, 234281),
(273963, '1gvdA00', NULL, NULL, 52, NULL, NULL, 234281),
(273964, '4dyqA01', NULL, NULL, 112, NULL, NULL, 234281),
(273965, '2dmqA01', NULL, NULL, 57, NULL, NULL, 234281),
(273966, '1gt0C02', NULL, NULL, 56, NULL, NULL, 234281),
(273967, '1ignA01', NULL, NULL, 100, NULL, NULL, 234281),
(273968, '2hxiA01', NULL, NULL, 64, NULL, NULL, 234281),
(273969, '2i10A01', NULL, NULL, 71, NULL, NULL, 234281),
(273970, '2lp0A00', NULL, NULL, 60, NULL, NULL, 234281),
(273971, '3bqzA01', NULL, NULL, 50, NULL, NULL, 234281),
(273972, '2crgA00', NULL, NULL, 70, NULL, NULL, 234281),
(273973, '4qtrC00', NULL, NULL, 72, NULL, NULL, 234281),
(273974, '3a01E00', NULL, NULL, 93, NULL, NULL, 234281),
(273975, '4bkxA02', NULL, NULL, 50, NULL, NULL, 234281),
(273976, '6fqpA00', NULL, NULL, 81, NULL, NULL, 234281),
(273977, '1ofcX02', NULL, NULL, 55, NULL, NULL, 234281),
(273978, '1wh5A00', NULL, NULL, 80, NULL, NULL, 234281),
(273979, '2dmpA01', NULL, NULL, 55, NULL, NULL, 234281),
(273980, '1mh3A03', NULL, NULL, 51, NULL, NULL, 234281),
(273981, '3mn2A00', NULL, NULL, 108, NULL, NULL, 234281),
(273982, '4xrmA00', NULL, NULL, 64, NULL, NULL, 234281),
(273983, '2lr8A00', NULL, NULL, 70, NULL, NULL, 234281),
(273984, '4cycB00', NULL, NULL, 76, NULL, NULL, 234281),
(273985, '1x58A01', NULL, NULL, 48, NULL, NULL, 234281),
(273986, '1iufA02', NULL, NULL, 64, NULL, NULL, 234281),
(273987, '2w48B01', NULL, NULL, 54, NULL, NULL, 234281),
(273988, '2ao9I01', NULL, NULL, 99, NULL, NULL, 234281),
(273989, '2zb9A01', NULL, NULL, 50, NULL, NULL, 234281),
(273990, '1iufA01', NULL, NULL, 77, NULL, NULL, 234281),
(273991, '1ofcX04', NULL, NULL, 108, NULL, NULL, 234281),
(273992, '5lxuA00', NULL, NULL, 57, NULL, NULL, 234281),
(273993, '2k40A00', NULL, NULL, 67, NULL, NULL, 234281),
(273994, '1o4xA02', NULL, NULL, 84, NULL, NULL, 234281),
(273995, '5gp9A01', NULL, NULL, 49, NULL, NULL, 234281),
(273996, '2da6A00', NULL, NULL, 102, NULL, NULL, 234281),
(273997, '4aybN00', NULL, NULL, 66, NULL, NULL, 234281),
(273998, '2m34A00', NULL, NULL, 71, NULL, NULL, 234281),
(273999, '2mw8A00', NULL, NULL, 71, NULL, NULL, 234281),
(274000, '2vi6A00', NULL, NULL, 62, NULL, NULL, 234281),
(274001, '2hxoA01', NULL, NULL, 78, NULL, NULL, 234281),
(274002, '2xpwA01', NULL, NULL, 65, NULL, NULL, 234281),
(274003, '2dn0A00', NULL, NULL, 76, NULL, NULL, 234281);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(274004, '5luxL00', NULL, NULL, 63, NULL, NULL, 234281),
(274005, '1wgxA00', NULL, NULL, 73, NULL, NULL, 234281),
(274006, '2hyjA01', NULL, NULL, 53, NULL, NULL, 234281),
(274007, '4qiwN00', NULL, NULL, 65, NULL, NULL, 234281),
(274008, '2jj7B01', NULL, NULL, 50, NULL, NULL, 234281),
(274009, '4j19B01', NULL, NULL, 72, NULL, NULL, 234281),
(274010, '1bl0A01', NULL, NULL, 64, NULL, NULL, 234281),
(274011, '1bl0A02', NULL, NULL, 65, NULL, NULL, 234281),
(274012, '2raeA01', NULL, NULL, 43, NULL, NULL, 234281),
(274013, '6el2B01', NULL, NULL, 61, NULL, NULL, 234281),
(274014, '2ibdA01', NULL, NULL, 55, NULL, NULL, 234281),
(274015, '3osgA01', NULL, NULL, 62, NULL, NULL, 234281),
(274016, '3osgA02', NULL, NULL, 64, NULL, NULL, 234281),
(274017, '2fx0A01', NULL, NULL, 50, NULL, NULL, 234281),
(274018, '3rkqA00', NULL, NULL, 58, NULL, NULL, 234281),
(274019, '2eh3A01', NULL, NULL, 50, NULL, NULL, 234281),
(274020, '5flvA01', NULL, NULL, 87, NULL, NULL, 234281),
(274021, '2id6A01', NULL, NULL, 48, NULL, NULL, 234281),
(274022, '1vfcA00', NULL, NULL, 63, NULL, NULL, 234281),
(274023, '2da1A01', NULL, NULL, 55, NULL, NULL, 234281),
(274024, '2mgqA00', NULL, NULL, 68, NULL, NULL, 234281),
(274025, '1fjlC00', NULL, NULL, 65, NULL, NULL, 234281),
(274026, '4ndlB00', NULL, NULL, 49, NULL, NULL, 234281),
(274027, '1b8iA00', NULL, NULL, 81, NULL, NULL, 234281),
(274028, '1hlvA01', NULL, NULL, 58, NULL, NULL, 234281),
(274029, '1g2hA00', NULL, NULL, 61, NULL, NULL, 234281),
(274030, '1hlvA02', NULL, NULL, 60, NULL, NULL, 234281),
(274031, '1d5yA01', NULL, NULL, 53, NULL, NULL, 234281),
(274032, '5ui5I04', NULL, NULL, 67, NULL, NULL, 234281),
(274033, '1d5yA02', NULL, NULL, 66, NULL, NULL, 234281),
(274034, '1t33A01', NULL, NULL, 62, NULL, NULL, 234281),
(274035, '3d1nI02', NULL, NULL, 53, NULL, NULL, 234281),
(274036, '6j4kA00', NULL, NULL, 60, NULL, NULL, 234281),
(274037, '2dmuA01', NULL, NULL, 57, NULL, NULL, 234281),
(274038, '3lsjA01', NULL, NULL, 53, NULL, NULL, 234281),
(274039, '2eccA00', NULL, NULL, 76, NULL, NULL, 234281),
(274040, '1b72A00', NULL, NULL, 97, NULL, NULL, 234281),
(274041, '1iv6A00', NULL, NULL, 70, NULL, NULL, 234281),
(274042, '3pdiA02', NULL, NULL, 273, NULL, NULL, 234282),
(274043, '2x3lA01', NULL, NULL, 109, NULL, NULL, 234283),
(274044, '1mkfA01', NULL, NULL, 210, NULL, NULL, 234284),
(274045, '1l1lA02', NULL, NULL, 112, NULL, NULL, 234285),
(274046, '3lmmA01', NULL, NULL, 159, NULL, NULL, 234286),
(274047, '2kyyA00', NULL, NULL, 153, NULL, NULL, 234286),
(274048, '5klaA00', NULL, NULL, 337, NULL, NULL, 234287),
(274049, '4rv1D00', NULL, NULL, 420, NULL, NULL, 234287),
(274050, '2w3cA01', NULL, NULL, 290, NULL, NULL, 234287),
(274051, '3dadA00', NULL, NULL, 339, NULL, NULL, 234287),
(274052, '2w3cA02', NULL, NULL, 287, NULL, NULL, 234287),
(274053, '4i2zA03', NULL, NULL, 429, NULL, NULL, 234287),
(274054, '3bwtA00', NULL, NULL, 333, NULL, NULL, 234287),
(274055, '3w3uA01', NULL, NULL, 1047, NULL, NULL, 234287),
(274056, '4i2zA02', NULL, NULL, 368, NULL, NULL, 234287),
(274057, '4bqkB00', NULL, NULL, 424, NULL, NULL, 234287),
(274058, '4p6zB00', NULL, NULL, 571, NULL, NULL, 234287),
(274059, '1lrvA00', NULL, NULL, 244, NULL, NULL, 234287),
(274060, '1te4A01', NULL, NULL, 89, NULL, NULL, 234287),
(274061, '3o2tA00', NULL, NULL, 311, NULL, NULL, 234287),
(274062, '5owuA00', NULL, NULL, 861, NULL, NULL, 234287),
(274063, '4c0qB00', NULL, NULL, 923, NULL, NULL, 234287),
(274064, '5dn7A00', NULL, NULL, 250, NULL, NULL, 234287),
(274065, '1g3jC00', NULL, NULL, 442, NULL, NULL, 234287),
(274066, '3c2gB01', NULL, NULL, 551, NULL, NULL, 234287),
(274067, '4g3aB00', NULL, NULL, 237, NULL, NULL, 234287),
(274068, '4xriA00', NULL, NULL, 882, NULL, NULL, 234287),
(274069, '3opbA02', NULL, NULL, 483, NULL, NULL, 234287),
(274070, '4uadA00', NULL, NULL, 425, NULL, NULL, 234287),
(274071, '4qmhA00', NULL, NULL, 241, NULL, NULL, 234287),
(274072, '3fgaB00', NULL, NULL, 403, NULL, NULL, 234287),
(274073, '3gb8A01', NULL, NULL, 651, NULL, NULL, 234287),
(274074, '4rzpA00', NULL, NULL, 252, NULL, NULL, 234287);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(274075, '2qk1A01', NULL, NULL, 240, NULL, NULL, 234287),
(274076, '4l7mA00', NULL, NULL, 269, NULL, NULL, 234287),
(274077, '5jjaA00', NULL, NULL, 352, NULL, NULL, 234287),
(274078, '4jw3C00', NULL, NULL, 104, NULL, NULL, 234287),
(274079, '4u2xF00', NULL, NULL, 175, NULL, NULL, 234287),
(274080, '4y5jA00', NULL, NULL, 248, NULL, NULL, 234287),
(274081, '5mfiB00', NULL, NULL, 243, NULL, NULL, 234287),
(274082, '1b3uA00', NULL, NULL, 588, NULL, NULL, 234287),
(274083, '4v3oA00', NULL, NULL, 289, NULL, NULL, 234287),
(274084, '1ibrD00', NULL, NULL, 439, NULL, NULL, 234287),
(274085, '4ffbC00', NULL, NULL, 278, NULL, NULL, 234287),
(274086, '3zkvA00', NULL, NULL, 918, NULL, NULL, 234287),
(274087, '2qnaA00', NULL, NULL, 762, NULL, NULL, 234287),
(274088, '1ee4A00', NULL, NULL, 423, NULL, NULL, 234287),
(274089, '5bz1A00', NULL, NULL, 400, NULL, NULL, 234287),
(274090, '4r0zA00', NULL, NULL, 563, NULL, NULL, 234287),
(274091, '3ltmA00', NULL, NULL, 211, NULL, NULL, 234287),
(274092, '2jdqA00', NULL, NULL, 429, NULL, NULL, 234287),
(274093, '1upkA01', NULL, NULL, 333, NULL, NULL, 234287),
(274094, '2iw3B01', NULL, NULL, 333, NULL, NULL, 234287),
(274095, '4cv5D00', NULL, NULL, 272, NULL, NULL, 234287),
(274096, '4hxtA00', NULL, NULL, 252, NULL, NULL, 234287),
(274097, '2x19B00', NULL, NULL, 946, NULL, NULL, 234287),
(274098, '4cruB00', NULL, NULL, 273, NULL, NULL, 234287),
(274099, '4k92A00', NULL, NULL, 257, NULL, NULL, 234287),
(274100, '3a6pA00', NULL, NULL, 1136, NULL, NULL, 234287),
(274101, '3grlA00', NULL, NULL, 615, NULL, NULL, 234287),
(274102, '3ltjA00', NULL, NULL, 201, NULL, NULL, 234287),
(274103, '3gaeA00', NULL, NULL, 253, NULL, NULL, 234287),
(274104, '4uwxA00', NULL, NULL, 239, NULL, NULL, 234287),
(274105, '4imiA00', NULL, NULL, 339, NULL, NULL, 234287),
(274106, '4k6jB00', NULL, NULL, 516, NULL, NULL, 234287),
(274107, '3v71A00', NULL, NULL, 382, NULL, NULL, 234287),
(274108, '4d4eA00', NULL, NULL, 251, NULL, NULL, 234287),
(274109, '4plrA00', NULL, NULL, 289, NULL, NULL, 234287),
(274110, '1gw5A00', NULL, NULL, 592, NULL, NULL, 234287),
(274111, '5ewpA00', NULL, NULL, 252, NULL, NULL, 234287),
(274112, '1ho8A01', NULL, NULL, 356, NULL, NULL, 234287),
(274113, '1xqrA00', NULL, NULL, 276, NULL, NULL, 234287),
(274114, '4qmiA00', NULL, NULL, 240, NULL, NULL, 234287),
(274115, '3qmlD00', NULL, NULL, 297, NULL, NULL, 234287),
(274116, '3nowA02', NULL, NULL, 428, NULL, NULL, 234287),
(274117, '2vglB00', NULL, NULL, 591, NULL, NULL, 234287),
(274118, '3gjxD00', NULL, NULL, 1057, NULL, NULL, 234287),
(274119, '4fddA00', NULL, NULL, 852, NULL, NULL, 234287),
(274120, '3zhpB01', NULL, NULL, 318, NULL, NULL, 234287),
(274121, '3wozB00', NULL, NULL, 232, NULL, NULL, 234287),
(274122, '3sl9B00', NULL, NULL, 167, NULL, NULL, 234287),
(274123, '4db8A00', NULL, NULL, 252, NULL, NULL, 234287),
(274124, '2qk2A01', NULL, NULL, 234, NULL, NULL, 234287),
(274125, '5izaA00', NULL, NULL, 354, NULL, NULL, 234287),
(274126, '3ifqB00', NULL, NULL, 553, NULL, NULL, 234287),
(274127, '3l6xA01', NULL, NULL, 447, NULL, NULL, 234287),
(274128, '4kzgC00', NULL, NULL, 327, NULL, NULL, 234287),
(274129, '4neeB00', NULL, NULL, 398, NULL, NULL, 234287),
(274130, '3c5wA00', NULL, NULL, 232, NULL, NULL, 234287),
(274131, '5aeiB00', NULL, NULL, 286, NULL, NULL, 234287),
(274132, '1w9cA00', NULL, NULL, 321, NULL, NULL, 234287),
(274133, '3ebbA00', NULL, NULL, 264, NULL, NULL, 234287),
(274134, '3k62A00', NULL, NULL, 412, NULL, NULL, 234287),
(274135, '3k49A00', NULL, NULL, 369, NULL, NULL, 234287),
(274136, '4uafB00', NULL, NULL, 433, NULL, NULL, 234287),
(274137, '3tjzB00', NULL, NULL, 292, NULL, NULL, 234287),
(274138, '3nmzA00', NULL, NULL, 414, NULL, NULL, 234287),
(274139, '1gw5B00', NULL, NULL, 591, NULL, NULL, 234287),
(274140, '3nowA01', NULL, NULL, 358, NULL, NULL, 234287),
(274141, '3ibvB00', NULL, NULL, 957, NULL, NULL, 234287),
(274142, '3gs3A00', NULL, NULL, 257, NULL, NULL, 234287),
(274143, '4adyA02', NULL, NULL, 449, NULL, NULL, 234287),
(274144, '4rxhB00', NULL, NULL, 426, NULL, NULL, 234287),
(274145, '3vwaA03', NULL, NULL, 307, NULL, NULL, 234287);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(274146, '3gvoA00', NULL, NULL, 351, NULL, NULL, 234287),
(274147, '2vglA00', NULL, NULL, 621, NULL, NULL, 234287),
(274148, '4uaeA00', NULL, NULL, 421, NULL, NULL, 234287),
(274149, '4hnmA00', NULL, NULL, 489, NULL, NULL, 234287),
(274150, '4p6zG00', NULL, NULL, 602, NULL, NULL, 234287),
(274151, '4tnmA00', NULL, NULL, 421, NULL, NULL, 234287),
(274152, '2db0B00', NULL, NULL, 253, NULL, NULL, 234287),
(274153, '3tt9A00', NULL, NULL, 233, NULL, NULL, 234287),
(274154, '4dvgB00', NULL, NULL, 312, NULL, NULL, 234287),
(274155, '4jw2A00', NULL, NULL, 85, NULL, NULL, 234287),
(274156, '1gcjA00', NULL, NULL, 460, NULL, NULL, 234287),
(274157, '2of3A00', NULL, NULL, 266, NULL, NULL, 234287),
(274158, '1jdhA00', NULL, NULL, 529, NULL, NULL, 234287),
(274159, '5vgzU02', NULL, NULL, 440, NULL, NULL, 234287),
(274160, '5vjcA00', NULL, NULL, 271, NULL, NULL, 234287),
(274161, '1u6gC00', NULL, NULL, 1174, NULL, NULL, 234287),
(274162, '3woyA00', NULL, NULL, 251, NULL, NULL, 234287),
(274163, '3wyfC02', NULL, NULL, 370, NULL, NULL, 234287),
(274164, '4wv6A00', NULL, NULL, 439, NULL, NULL, 234287),
(274165, '3wyfC01', NULL, NULL, 679, NULL, NULL, 234287),
(274166, '4gmoA00', NULL, NULL, 578, NULL, NULL, 234287),
(274167, '3au3A00', NULL, NULL, 318, NULL, NULL, 234287),
(274168, '1wa5C00', NULL, NULL, 960, NULL, NULL, 234287),
(274169, '1m8zA00', NULL, NULL, 349, NULL, NULL, 234287),
(274170, '1oyzA00', NULL, NULL, 280, NULL, NULL, 234287),
(274171, '1xm9A01', NULL, NULL, 447, NULL, NULL, 234287),
(274172, '5mfoF00', NULL, NULL, 202, NULL, NULL, 234287),
(274173, '1a9xA01', NULL, NULL, 116, NULL, NULL, 234288),
(274174, '3tqtB01', NULL, NULL, 128, NULL, NULL, 234288),
(274175, '2w70A01', NULL, NULL, 85, NULL, NULL, 234288),
(274176, '2pvpA01', NULL, NULL, 119, NULL, NULL, 234288),
(274177, '3orqA01', NULL, NULL, 100, NULL, NULL, 234288),
(274178, '1a9xA05', NULL, NULL, 110, NULL, NULL, 234288),
(274179, '5mlkA01', NULL, NULL, 86, NULL, NULL, 234288),
(274180, '5i47A01', NULL, NULL, 106, NULL, NULL, 234288),
(274181, '1bxrA05', NULL, NULL, 140, NULL, NULL, 234288),
(274182, '3r5xA01', NULL, NULL, 85, NULL, NULL, 234288),
(274183, '1gsaA01', NULL, NULL, 130, NULL, NULL, 234288),
(274184, '3r5xC01', NULL, NULL, 85, NULL, NULL, 234288),
(274185, '4egjD01', NULL, NULL, 107, NULL, NULL, 234288),
(274186, '3n6rA01', NULL, NULL, 130, NULL, NULL, 234288),
(274187, '4fu0A01', NULL, NULL, 128, NULL, NULL, 234288),
(274188, '3mjfA01', NULL, NULL, 94, NULL, NULL, 234288),
(274189, '2w6pB01', NULL, NULL, 131, NULL, NULL, 234288),
(274190, '2fb9A01', NULL, NULL, 107, NULL, NULL, 234288),
(274191, '2p0aA01', NULL, NULL, 117, NULL, NULL, 234288),
(274192, '2z04A01', NULL, NULL, 91, NULL, NULL, 234288),
(274193, '3r23B01', NULL, NULL, 85, NULL, NULL, 234288),
(274194, '3vpbA01', NULL, NULL, 101, NULL, NULL, 234288),
(274195, '4wd3A01', NULL, NULL, 121, NULL, NULL, 234288),
(274196, '2i87B01', NULL, NULL, 117, NULL, NULL, 234288),
(274197, '3q2oA01', NULL, NULL, 121, NULL, NULL, 234288),
(274198, '5k2mA01', NULL, NULL, 96, NULL, NULL, 234288),
(274199, '3va7A01', NULL, NULL, 134, NULL, NULL, 234288),
(274200, '3wnzA01', NULL, NULL, 138, NULL, NULL, 234288),
(274201, '3hblB01', NULL, NULL, 134, NULL, NULL, 234288),
(274202, '1e4eA03', NULL, NULL, 121, NULL, NULL, 234288),
(274203, '3hblD01', NULL, NULL, 106, NULL, NULL, 234288),
(274204, '3lp8A01', NULL, NULL, 92, NULL, NULL, 234288),
(274205, '5zctA01', NULL, NULL, 114, NULL, NULL, 234288),
(274206, '3ax6A01', NULL, NULL, 109, NULL, NULL, 234288),
(274207, '2yl2A01', NULL, NULL, 141, NULL, NULL, 234288),
(274208, '3votA01', NULL, NULL, 102, NULL, NULL, 234288),
(274209, '2vqdA01', NULL, NULL, 85, NULL, NULL, 234288),
(274210, '1ulzA01', NULL, NULL, 129, NULL, NULL, 234288),
(274211, '3se7D01', NULL, NULL, 121, NULL, NULL, 234288),
(274212, '3u9tA01', NULL, NULL, 90, NULL, NULL, 234288),
(274213, '4egqA01', NULL, NULL, 95, NULL, NULL, 234288),
(274214, '2yrxA01', NULL, NULL, 92, NULL, NULL, 234288),
(274215, '5vevA01', NULL, NULL, 92, NULL, NULL, 234288),
(274216, '3lwbA01', NULL, NULL, 126, NULL, NULL, 234288);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(274217, '2ip4A01', NULL, NULL, 92, NULL, NULL, 234288),
(274218, '5mlkB01', NULL, NULL, 132, NULL, NULL, 234288),
(274219, '4izoA01', NULL, NULL, 113, NULL, NULL, 234288),
(274220, '3r5xB01', NULL, NULL, 85, NULL, NULL, 234288),
(274221, '4m9cA01', NULL, NULL, 91, NULL, NULL, 234288),
(274222, '2r85A01', NULL, NULL, 87, NULL, NULL, 234288),
(274223, '3glkA01', NULL, NULL, 144, NULL, NULL, 234288),
(274224, '3r5xD01', NULL, NULL, 85, NULL, NULL, 234288),
(274225, '1gsoA01', NULL, NULL, 94, NULL, NULL, 234288),
(274226, '4dimA01', NULL, NULL, 124, NULL, NULL, 234288),
(274227, '1i7nA02', NULL, NULL, 116, NULL, NULL, 234288),
(274228, '2xclA01', NULL, NULL, 93, NULL, NULL, 234288),
(274229, '3ouzA01', NULL, NULL, 89, NULL, NULL, 234288),
(274230, '2dwcA01', NULL, NULL, 131, NULL, NULL, 234288),
(274231, '3tw7B01', NULL, NULL, 118, NULL, NULL, 234288),
(274232, '3u9sC01', NULL, NULL, 135, NULL, NULL, 234288),
(274233, '1pk8B02', NULL, NULL, 115, NULL, NULL, 234288),
(274234, '2r7kA01', NULL, NULL, 111, NULL, NULL, 234288),
(274235, '3k5iD01', NULL, NULL, 112, NULL, NULL, 234288),
(274236, '1ehiA01', NULL, NULL, 122, NULL, NULL, 234288),
(274237, '3q1kD01', NULL, NULL, 131, NULL, NULL, 234288),
(274238, '5h80A01', NULL, NULL, 128, NULL, NULL, 234288),
(274239, '3vpdA01', NULL, NULL, 103, NULL, NULL, 234288),
(274240, '2pn1A01', NULL, NULL, 123, NULL, NULL, 234288),
(274241, '2vheA01', NULL, NULL, 75, NULL, NULL, 234288),
(274242, '3k3pA01', NULL, NULL, 113, NULL, NULL, 234288),
(274243, '4e4tB01', NULL, NULL, 113, NULL, NULL, 234288),
(274244, '3r23A01', NULL, NULL, 85, NULL, NULL, 234288),
(274245, '2qk4A01', NULL, NULL, 94, NULL, NULL, 234288),
(274246, '2pbzA01', NULL, NULL, 85, NULL, NULL, 234288),
(274247, '5bphA01', NULL, NULL, 84, NULL, NULL, 234288),
(274248, '3e5nA01', NULL, NULL, 127, NULL, NULL, 234288),
(274249, '1vkzA01', NULL, NULL, 97, NULL, NULL, 234288),
(274250, '2dzdA01', NULL, NULL, 135, NULL, NULL, 234288),
(274251, '4c5cA01', NULL, NULL, 84, NULL, NULL, 234288),
(274252, '4m98A01', NULL, NULL, 91, NULL, NULL, 234288),
(274253, '4qshA01', NULL, NULL, 136, NULL, NULL, 234288),
(274254, '2vpqA01', NULL, NULL, 84, NULL, NULL, 234288),
(274255, '4j6eA01', NULL, NULL, 132, NULL, NULL, 234288),
(274256, '1kjqA01', NULL, NULL, 121, NULL, NULL, 234288),
(274257, '4mamA01', NULL, NULL, 96, NULL, NULL, 234288),
(274258, '4mv4A01', NULL, NULL, 85, NULL, NULL, 234288),
(274259, '2qf7B01', NULL, NULL, 150, NULL, NULL, 234288),
(274260, '5d8dA01', NULL, NULL, 87, NULL, NULL, 234288),
(274261, '4ea9A01', NULL, NULL, 99, NULL, NULL, 234288),
(274262, '2yw2A01', NULL, NULL, 92, NULL, NULL, 234288),
(274263, '3ethA01', NULL, NULL, 70, NULL, NULL, 234288),
(274264, '4eg0A01', NULL, NULL, 95, NULL, NULL, 234288),
(274265, '3aw8A01', NULL, NULL, 95, NULL, NULL, 234288),
(274266, '1w96C01', NULL, NULL, 165, NULL, NULL, 234288),
(274267, '3ho1A03', NULL, NULL, 89, NULL, NULL, 234289),
(274268, '2honA02', NULL, NULL, 178, NULL, NULL, 234290),
(274269, '4lrlB02', NULL, NULL, 166, NULL, NULL, 234290),
(274270, '2q14H02', NULL, NULL, 172, NULL, NULL, 234290),
(274271, '2m6pA00', NULL, NULL, 46, NULL, NULL, 234291),
(274272, '2m6oA00', NULL, NULL, 48, NULL, NULL, 234291),
(274273, '2m4vA00', NULL, NULL, 80, NULL, NULL, 234291),
(274274, '2j0aA00', NULL, NULL, 280, NULL, NULL, 234292),
(274275, '2zxqA06', NULL, NULL, 72, NULL, NULL, 234293),
(274276, '1lq7A00', NULL, NULL, 67, NULL, NULL, 234293),
(274277, '2pofA00', NULL, NULL, 227, NULL, NULL, 234294),
(274278, '2jl8102', NULL, NULL, 45, NULL, NULL, 234295),
(274279, '2yweA05', NULL, NULL, 68, NULL, NULL, 234296),
(274280, '3cb4A05', NULL, NULL, 75, NULL, NULL, 234296),
(274281, '2kk9A00', NULL, NULL, 56, NULL, NULL, 234297),
(274282, '1vryA00', NULL, NULL, 76, NULL, NULL, 234298),
(274283, '3pjyB00', NULL, NULL, 136, NULL, NULL, 234299),
(274284, '3m7aA01', NULL, NULL, 136, NULL, NULL, 234299),
(274285, '3pjyA00', NULL, NULL, 136, NULL, NULL, 234299),
(274286, '1oenA02', NULL, NULL, 79, NULL, NULL, 234300),
(274287, '1khbA02', NULL, NULL, 102, NULL, NULL, 234300);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(274288, '1ylhA02', NULL, NULL, 79, NULL, NULL, 234300),
(274289, '1ytmA02', NULL, NULL, 76, NULL, NULL, 234300),
(274290, '1j3bA02', NULL, NULL, 77, NULL, NULL, 234300),
(274291, '4gmuA02', NULL, NULL, 108, NULL, NULL, 234300),
(274292, '2fafA02', NULL, NULL, 102, NULL, NULL, 234300),
(274293, '4wptA02', NULL, NULL, 109, NULL, NULL, 234300),
(274294, '6at4A02', NULL, NULL, 79, NULL, NULL, 234300),
(274295, '2zciA02', NULL, NULL, 110, NULL, NULL, 234300),
(274296, '1ii2A02', NULL, NULL, 79, NULL, NULL, 234300),
(274297, '2vj5A01', NULL, NULL, 92, NULL, NULL, 234301),
(274298, '2vixB01', NULL, NULL, 92, NULL, NULL, 234301),
(274299, '2vixC01', NULL, NULL, 92, NULL, NULL, 234301),
(274300, '2vj4B01', NULL, NULL, 92, NULL, NULL, 234301),
(274301, '2vj4A01', NULL, NULL, 92, NULL, NULL, 234301),
(274302, '2vixA01', NULL, NULL, 92, NULL, NULL, 234301),
(274303, '1l6tA00', NULL, NULL, 79, NULL, NULL, 234302),
(274304, '4cbkA00', NULL, NULL, 69, NULL, NULL, 234302),
(274305, '5dn6J00', NULL, NULL, 77, NULL, NULL, 234302),
(274306, '1a91A00', NULL, NULL, 79, NULL, NULL, 234302),
(274307, '1wu0A00', NULL, NULL, 72, NULL, NULL, 234302),
(274308, '6f36A00', NULL, NULL, 74, NULL, NULL, 234302),
(274309, '4v1gA00', NULL, NULL, 86, NULL, NULL, 234302),
(274310, '4bemA01', NULL, NULL, 79, NULL, NULL, 234302),
(274311, '6fkfG01', NULL, NULL, 78, NULL, NULL, 234302),
(274312, '2wgmA01', NULL, NULL, 82, NULL, NULL, 234302),
(274313, '5fl7Q00', NULL, NULL, 76, NULL, NULL, 234302),
(274314, '2xquA01', NULL, NULL, 79, NULL, NULL, 234302),
(274315, '4f4sB00', NULL, NULL, 76, NULL, NULL, 234302),
(274316, '2xndJ00', NULL, NULL, 72, NULL, NULL, 234302),
(274317, '3zk1A01', NULL, NULL, 82, NULL, NULL, 234302),
(274318, '1t60O00', NULL, NULL, 227, NULL, NULL, 234303),
(274319, '1t60D00', NULL, NULL, 229, NULL, NULL, 234303),
(274320, '5nb0D00', NULL, NULL, 230, NULL, NULL, 234303),
(274321, '3cqfA04', NULL, NULL, 109, NULL, NULL, 234304),
(274322, '4hscX04', NULL, NULL, 110, NULL, NULL, 234304),
(274323, '1s3rA04', NULL, NULL, 115, NULL, NULL, 234304),
(274324, '5cr8A00', NULL, NULL, 113, NULL, NULL, 234304),
(274325, '1pfoA04', NULL, NULL, 110, NULL, NULL, 234304),
(274326, '3hvnA04', NULL, NULL, 117, NULL, NULL, 234304),
(274327, '2xu8A00', NULL, NULL, 116, NULL, NULL, 234305),
(274328, '3lnbA00', NULL, NULL, 279, NULL, NULL, 234306),
(274329, '2pfrB00', NULL, NULL, 294, NULL, NULL, 234306),
(274330, '4dmoA00', NULL, NULL, 265, NULL, NULL, 234306),
(274331, '2ijaA00', NULL, NULL, 295, NULL, NULL, 234306),
(274332, '2oj5B01', NULL, NULL, 24, NULL, NULL, 234307),
(274333, '4mjkA00', NULL, NULL, 265, NULL, NULL, 234308),
(274334, '2jqtA00', NULL, NULL, 71, NULL, NULL, 234309),
(274335, '2k5sA00', NULL, NULL, 73, NULL, NULL, 234309),
(274336, '2mw2A00', NULL, NULL, 72, NULL, NULL, 234309),
(274337, '4icgD00', NULL, NULL, 75, NULL, NULL, 234309),
(274338, '2kzyA00', NULL, NULL, 62, NULL, NULL, 234310),
(274339, '2c7nA01', NULL, NULL, 48, NULL, NULL, 234310),
(274340, '4ncbA01', NULL, NULL, 155, NULL, NULL, 234311),
(274341, '3mayB00', NULL, NULL, 101, NULL, NULL, 234312),
(274342, '3rrrG02', NULL, NULL, 44, NULL, NULL, 234313),
(274343, '3tcqA02', NULL, NULL, 105, NULL, NULL, 234314),
(274344, '1es6A02', NULL, NULL, 111, NULL, NULL, 234314),
(274345, '3rdeA01', NULL, NULL, 467, NULL, NULL, 234315),
(274346, '3v99B02', NULL, NULL, 440, NULL, NULL, 234315),
(274347, '4nreA02', NULL, NULL, 436, NULL, NULL, 234315),
(274348, '3fg1A02', NULL, NULL, 442, NULL, NULL, 234315),
(274349, '3vf1A02', NULL, NULL, 443, NULL, NULL, 234315),
(274350, '3d3lA01', NULL, NULL, 402, NULL, NULL, 234315),
(274351, '2iujA05', NULL, NULL, 367, NULL, NULL, 234315),
(274352, '1ik3A05', NULL, NULL, 366, NULL, NULL, 234315),
(274353, '1loxA01', NULL, NULL, 435, NULL, NULL, 234315),
(274354, '2iukA05', NULL, NULL, 366, NULL, NULL, 234315),
(274355, '4wfoA05', NULL, NULL, 347, NULL, NULL, 234315),
(274356, '1jvrA00', NULL, NULL, 137, NULL, NULL, 234316),
(274357, '1ru3A01', NULL, NULL, 124, NULL, NULL, 234317),
(274358, '1oaoC01', NULL, NULL, 120, NULL, NULL, 234317);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(274359, '1wiiA01', NULL, NULL, 62, NULL, NULL, 234318),
(274360, '5xogM00', NULL, NULL, 68, NULL, NULL, 234318),
(274361, '1yx5A01', NULL, NULL, 35, NULL, NULL, 234319),
(274362, '2lc0A00', NULL, NULL, 132, NULL, NULL, 234320),
(274363, '4a17C02', NULL, NULL, 85, NULL, NULL, 234321),
(274364, '3u4qB04', NULL, NULL, 69, NULL, NULL, 234322),
(274365, '2ekdA00', NULL, NULL, 207, NULL, NULL, 234323),
(274366, '4ncdA02', NULL, NULL, 95, NULL, NULL, 234324),
(274367, '4y2oA02', NULL, NULL, 97, NULL, NULL, 234324),
(274368, '3o1lA02', NULL, NULL, 198, NULL, NULL, 234325),
(274369, '3aufA00', NULL, NULL, 229, NULL, NULL, 234325),
(274370, '3tqrA00', NULL, NULL, 215, NULL, NULL, 234325),
(274371, '4s1nA00', NULL, NULL, 184, NULL, NULL, 234325),
(274372, '1s3iA01', NULL, NULL, 205, NULL, NULL, 234325),
(274373, '2blnA01', NULL, NULL, 202, NULL, NULL, 234325),
(274374, '3da8B00', NULL, NULL, 215, NULL, NULL, 234325),
(274375, '5vyqA01', NULL, NULL, 177, NULL, NULL, 234325),
(274376, '3q0iA01', NULL, NULL, 212, NULL, NULL, 234325),
(274377, '2bw0A01', NULL, NULL, 207, NULL, NULL, 234325),
(274378, '3p9xA00', NULL, NULL, 211, NULL, NULL, 234325),
(274379, '1fmtB01', NULL, NULL, 208, NULL, NULL, 234325),
(274380, '5cjjB00', NULL, NULL, 191, NULL, NULL, 234325),
(274381, '3w7bA02', NULL, NULL, 197, NULL, NULL, 234325),
(274382, '3obiA02', NULL, NULL, 199, NULL, NULL, 234325),
(274383, '3tqqA01', NULL, NULL, 207, NULL, NULL, 234325),
(274384, '3nrbA02', NULL, NULL, 199, NULL, NULL, 234325),
(274385, '4yfvA01', NULL, NULL, 186, NULL, NULL, 234325),
(274386, '3louA02', NULL, NULL, 197, NULL, NULL, 234325),
(274387, '4iqfB01', NULL, NULL, 209, NULL, NULL, 234325),
(274388, '6nbpA01', NULL, NULL, 206, NULL, NULL, 234325),
(274389, '4ts4A01', NULL, NULL, 205, NULL, NULL, 234325),
(274390, '5uaiA01', NULL, NULL, 217, NULL, NULL, 234325),
(274391, '1zghA01', NULL, NULL, 194, NULL, NULL, 234325),
(274392, '4ds3A00', NULL, NULL, 209, NULL, NULL, 234325),
(274393, '4zz1A00', NULL, NULL, 210, NULL, NULL, 234325),
(274394, '3kcqB00', NULL, NULL, 215, NULL, NULL, 234325),
(274395, '3av3A00', NULL, NULL, 189, NULL, NULL, 234325),
(274396, '2ywrA00', NULL, NULL, 216, NULL, NULL, 234325),
(274397, '3n0vA02', NULL, NULL, 196, NULL, NULL, 234325),
(274398, '3r8xA01', NULL, NULL, 212, NULL, NULL, 234325),
(274399, '1jkxA00', NULL, NULL, 212, NULL, NULL, 234325),
(274400, '4nv1E01', NULL, NULL, 186, NULL, NULL, 234325),
(274401, '3pviA00', NULL, NULL, 157, NULL, NULL, 234326),
(274402, '6dc6A02', NULL, NULL, 220, NULL, NULL, 234327),
(274403, '4ii2A02', NULL, NULL, 217, NULL, NULL, 234327),
(274404, '5tr4A02', NULL, NULL, 224, NULL, NULL, 234327),
(274405, '4n45A02', NULL, NULL, 156, NULL, NULL, 234328),
(274406, '4n45A01', NULL, NULL, 205, NULL, NULL, 234328),
(274407, '3v4nA02', NULL, NULL, 148, NULL, NULL, 234328),
(274408, '5by7A02', NULL, NULL, 147, NULL, NULL, 234328),
(274409, '3sqzA02', NULL, NULL, 149, NULL, NULL, 234328),
(274410, '3sqzA01', NULL, NULL, 242, NULL, NULL, 234328),
(274411, '4z19A01', NULL, NULL, 170, NULL, NULL, 234328),
(274412, '4z19A02', NULL, NULL, 146, NULL, NULL, 234328),
(274413, '4v2pB01', NULL, NULL, 174, NULL, NULL, 234328),
(274414, '5e5nC01', NULL, NULL, 425, NULL, NULL, 234328),
(274415, '5byvF02', NULL, NULL, 181, NULL, NULL, 234328),
(274416, '4b3hC01', NULL, NULL, 226, NULL, NULL, 234328),
(274417, '5by7A01', NULL, NULL, 191, NULL, NULL, 234328),
(274418, '5lp7B02', NULL, NULL, 156, NULL, NULL, 234328),
(274419, '4b3hC02', NULL, NULL, 167, NULL, NULL, 234328),
(274420, '4xs9A02', NULL, NULL, 160, NULL, NULL, 234328),
(274421, '4xs9A01', NULL, NULL, 172, NULL, NULL, 234328),
(274422, '3wd7A01', NULL, NULL, 247, NULL, NULL, 234328),
(274423, '1wdkC01', NULL, NULL, 213, NULL, NULL, 234328),
(274424, '1tqyA01', NULL, NULL, 263, NULL, NULL, 234328),
(274425, '3wd7A02', NULL, NULL, 156, NULL, NULL, 234328),
(274426, '1ulqC01', NULL, NULL, 208, NULL, NULL, 234328),
(274427, '1afwA02', NULL, NULL, 161, NULL, NULL, 234328),
(274428, '1afwA01', NULL, NULL, 213, NULL, NULL, 234328),
(274429, '1tqyA02', NULL, NULL, 161, NULL, NULL, 234328);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(274430, '1wdkC02', NULL, NULL, 167, NULL, NULL, 234328),
(274431, '4nhdD01', NULL, NULL, 173, NULL, NULL, 234328),
(274432, '3kzuA01', NULL, NULL, 263, NULL, NULL, 234328),
(274433, '1u6eA01', NULL, NULL, 182, NULL, NULL, 234328),
(274434, '1u6eA02', NULL, NULL, 150, NULL, NULL, 234328),
(274435, '3s21A01', NULL, NULL, 205, NULL, NULL, 234328),
(274436, '3kzuA02', NULL, NULL, 153, NULL, NULL, 234328),
(274437, '6bjaA01', NULL, NULL, 214, NULL, NULL, 234328),
(274438, '4qavA02', NULL, NULL, 154, NULL, NULL, 234328),
(274439, '2ib8C01', NULL, NULL, 212, NULL, NULL, 234328),
(274440, '4qavA01', NULL, NULL, 255, NULL, NULL, 234328),
(274441, '4ls6A02', NULL, NULL, 145, NULL, NULL, 234328),
(274442, '2wuaA00', NULL, NULL, 392, NULL, NULL, 234328),
(274443, '1wl4A01', NULL, NULL, 211, NULL, NULL, 234328),
(274444, '1wl4A02', NULL, NULL, 156, NULL, NULL, 234328),
(274445, '4ls6A01', NULL, NULL, 268, NULL, NULL, 234328),
(274446, '3svkA02', NULL, NULL, 156, NULL, NULL, 234328),
(274447, '6co0A02', NULL, NULL, 161, NULL, NULL, 234328),
(274448, '3svkA01', NULL, NULL, 241, NULL, NULL, 234328),
(274449, '6arfC01', NULL, NULL, 212, NULL, NULL, 234328),
(274450, '2wyaA00', NULL, NULL, 460, NULL, NULL, 234328),
(274451, '1u0mA02', NULL, NULL, 146, NULL, NULL, 234328),
(274452, '1u0mA01', NULL, NULL, 211, NULL, NULL, 234328),
(274453, '4v2pA02', NULL, NULL, 155, NULL, NULL, 234328),
(274454, '5elpD01', NULL, NULL, 434, NULL, NULL, 234328),
(274455, '5yptB01', NULL, NULL, 227, NULL, NULL, 234328),
(274456, '4w61A01', NULL, NULL, 208, NULL, NULL, 234328),
(274457, '4dd5A02', NULL, NULL, 156, NULL, NULL, 234328),
(274458, '4w61A02', NULL, NULL, 156, NULL, NULL, 234328),
(274459, '6cqbA01', NULL, NULL, 236, NULL, NULL, 234328),
(274460, '4dd5A01', NULL, NULL, 210, NULL, NULL, 234328),
(274461, '6cqbA02', NULL, NULL, 158, NULL, NULL, 234328),
(274462, '4f32A01', NULL, NULL, 264, NULL, NULL, 234328),
(274463, '1tqyB02', NULL, NULL, 152, NULL, NULL, 234328),
(274464, '1tqyB01', NULL, NULL, 263, NULL, NULL, 234328),
(274465, '2hg4F01', NULL, NULL, 437, NULL, NULL, 234328),
(274466, '4rybA01', NULL, NULL, 172, NULL, NULL, 234328),
(274467, '3h78A02', NULL, NULL, 162, NULL, NULL, 234328),
(274468, '4rybA02', NULL, NULL, 148, NULL, NULL, 234328),
(274469, '1ox0A02', NULL, NULL, 145, NULL, NULL, 234328),
(274470, '1ox0A01', NULL, NULL, 254, NULL, NULL, 234328),
(274471, '5w8qA01', NULL, NULL, 232, NULL, NULL, 234328),
(274472, '2p8uA00', NULL, NULL, 462, NULL, NULL, 234328),
(274473, '5wx4B01', NULL, NULL, 237, NULL, NULL, 234328),
(274474, '4jgaA01', NULL, NULL, 264, NULL, NULL, 234328),
(274475, '5w8qA02', NULL, NULL, 155, NULL, NULL, 234328),
(274476, '4jgaA02', NULL, NULL, 155, NULL, NULL, 234328),
(274477, '1xesC01', NULL, NULL, 233, NULL, NULL, 234328),
(274478, '4zdnA01', NULL, NULL, 512, NULL, NULL, 234328),
(274479, '2uv8A05', NULL, NULL, 617, NULL, NULL, 234328),
(274480, '6dx9A01', NULL, NULL, 240, NULL, NULL, 234328),
(274481, '2gqdA02', NULL, NULL, 145, NULL, NULL, 234328),
(274482, '2gqdA01', NULL, NULL, 253, NULL, NULL, 234328),
(274483, '3v7iA01', NULL, NULL, 209, NULL, NULL, 234328),
(274484, '4o9aA02', NULL, NULL, 156, NULL, NULL, 234328),
(274485, '3v7iA02', NULL, NULL, 147, NULL, NULL, 234328),
(274486, '6dx9A02', NULL, NULL, 165, NULL, NULL, 234328),
(274487, '4yzoC00', NULL, NULL, 373, NULL, NULL, 234328),
(274488, '5bqsA01', NULL, NULL, 169, NULL, NULL, 234328),
(274489, '4o9aA01', NULL, NULL, 211, NULL, NULL, 234328),
(274490, '4efiA00', NULL, NULL, 354, NULL, NULL, 234328),
(274491, '5bqsA02', NULL, NULL, 154, NULL, NULL, 234328),
(274492, '4jpfA02', NULL, NULL, 154, NULL, NULL, 234328),
(274493, '5wx3A02', NULL, NULL, 153, NULL, NULL, 234328),
(274494, '4jpfA01', NULL, NULL, 254, NULL, NULL, 234328),
(274495, '3il6A01', NULL, NULL, 171, NULL, NULL, 234328),
(274496, '3a5rA01', NULL, NULL, 231, NULL, NULL, 234328),
(274497, '3il6A02', NULL, NULL, 150, NULL, NULL, 234328),
(274498, '2vbaA01', NULL, NULL, 254, NULL, NULL, 234328),
(274499, '3a5rA02', NULL, NULL, 153, NULL, NULL, 234328),
(274500, '3gwaA01', NULL, NULL, 176, NULL, NULL, 234328);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(274501, '4na1B01', NULL, NULL, 517, NULL, NULL, 234328),
(274502, '3gwaA02', NULL, NULL, 161, NULL, NULL, 234328),
(274503, '2iwzA02', NULL, NULL, 156, NULL, NULL, 234328),
(274504, '4dfeB01', NULL, NULL, 185, NULL, NULL, 234328),
(274505, '2iwzA01', NULL, NULL, 282, NULL, NULL, 234328),
(274506, '1zowA02', NULL, NULL, 140, NULL, NULL, 234328),
(274507, '1zowA01', NULL, NULL, 173, NULL, NULL, 234328),
(274508, '3awkA01', NULL, NULL, 226, NULL, NULL, 234328),
(274509, '3awkA02', NULL, NULL, 154, NULL, NULL, 234328),
(274510, '6co0C01', NULL, NULL, 236, NULL, NULL, 234328),
(274511, '4yucA02', NULL, NULL, 155, NULL, NULL, 234328),
(274512, '4yucA01', NULL, NULL, 180, NULL, NULL, 234328),
(274513, '3ss6A01', NULL, NULL, 210, NULL, NULL, 234328),
(274514, '3oitB02', NULL, NULL, 159, NULL, NULL, 234328),
(274515, '3oitB01', NULL, NULL, 228, NULL, NULL, 234328),
(274516, '5my2A01', NULL, NULL, 447, NULL, NULL, 234328),
(274517, '4c2jD01', NULL, NULL, 214, NULL, NULL, 234328),
(274518, '1ub7A02', NULL, NULL, 151, NULL, NULL, 234328),
(274519, '1ub7A01', NULL, NULL, 171, NULL, NULL, 234328),
(274520, '1hnkA02', NULL, NULL, 113, NULL, NULL, 234328),
(274521, '3vs8H00', NULL, NULL, 410, NULL, NULL, 234328),
(274522, '4xoxA01', NULL, NULL, 252, NULL, NULL, 234328),
(274523, '3ss6A02', NULL, NULL, 170, NULL, NULL, 234328),
(274524, '4xoxA02', NULL, NULL, 144, NULL, NULL, 234328),
(274525, '4jrmA02', NULL, NULL, 154, NULL, NULL, 234328),
(274526, '4jrmA01', NULL, NULL, 254, NULL, NULL, 234328),
(274527, '3e60A02', NULL, NULL, 153, NULL, NULL, 234328),
(274528, '3mqdA01', NULL, NULL, 252, NULL, NULL, 234328),
(274529, '3e60A01', NULL, NULL, 263, NULL, NULL, 234328),
(274530, '3mqdA02', NULL, NULL, 148, NULL, NULL, 234328),
(274531, '6dxcA02', NULL, NULL, 157, NULL, NULL, 234328),
(274532, '3zbgA00', NULL, NULL, 431, NULL, NULL, 234328),
(274533, '6dxcA01', NULL, NULL, 229, NULL, NULL, 234328),
(274534, '4opfA00', NULL, NULL, 438, NULL, NULL, 234328),
(274535, '2vu1A02', NULL, NULL, 156, NULL, NULL, 234328),
(274536, '4ewgA02', NULL, NULL, 149, NULL, NULL, 234328),
(274537, '2vu1A01', NULL, NULL, 203, NULL, NULL, 234328),
(274538, '4u4eA00', NULL, NULL, 383, NULL, NULL, 234328),
(274539, '4ewgA01', NULL, NULL, 255, NULL, NULL, 234328),
(274540, '3wxyA01', NULL, NULL, 222, NULL, NULL, 234328),
(274541, '3wxyA02', NULL, NULL, 162, NULL, NULL, 234328),
(274542, '4dfeA02', NULL, NULL, 148, NULL, NULL, 234328),
(274543, '4wkyA01', NULL, NULL, 511, NULL, NULL, 234328),
(274544, '5xyjA01', NULL, NULL, 220, NULL, NULL, 234328),
(274545, '4bi9B00', NULL, NULL, 427, NULL, NULL, 234328),
(274546, '5xyjA02', NULL, NULL, 157, NULL, NULL, 234328),
(274547, '2vbaC02', NULL, NULL, 147, NULL, NULL, 234328),
(274548, '1hnjA01', NULL, NULL, 171, NULL, NULL, 234328),
(274549, '2ebdA01', NULL, NULL, 169, NULL, NULL, 234328),
(274550, '2ebdA02', NULL, NULL, 140, NULL, NULL, 234328),
(274551, '3euoA02', NULL, NULL, 157, NULL, NULL, 234328),
(274552, '3euoA01', NULL, NULL, 222, NULL, NULL, 234328),
(274553, '1mzjA02', NULL, NULL, 166, NULL, NULL, 234328),
(274554, '2p0uA02', NULL, NULL, 160, NULL, NULL, 234328),
(274555, '1hnjA02', NULL, NULL, 146, NULL, NULL, 234328),
(274556, '4egvD01', NULL, NULL, 407, NULL, NULL, 234328),
(274557, '4kc5B01', NULL, NULL, 490, NULL, NULL, 234328),
(274558, '5byvB01', NULL, NULL, 212, NULL, NULL, 234328),
(274559, '4yjyB01', NULL, NULL, 238, NULL, NULL, 234328),
(274560, '4r8eA01', NULL, NULL, 254, NULL, NULL, 234328),
(274561, '4r8eA02', NULL, NULL, 153, NULL, NULL, 234328),
(274562, '3ho9A02', NULL, NULL, 153, NULL, NULL, 234328),
(274563, '2d3mB01', NULL, NULL, 248, NULL, NULL, 234328),
(274564, '4c72A01', NULL, NULL, 263, NULL, NULL, 234328),
(274565, '4c72A02', NULL, NULL, 150, NULL, NULL, 234328),
(274566, '3hhdA01', NULL, NULL, 449, NULL, NULL, 234328),
(274567, '5yo9B01', NULL, NULL, 215, NULL, NULL, 234328),
(274568, '3ho9A01', NULL, NULL, 254, NULL, NULL, 234328),
(274569, '3s3lA02', NULL, NULL, 159, NULL, NULL, 234328),
(274570, '3s3lA01', NULL, NULL, 179, NULL, NULL, 234328),
(274571, '3ov2A01', NULL, NULL, 235, NULL, NULL, 234328);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(274572, '3ov2A02', NULL, NULL, 153, NULL, NULL, 234328),
(274573, '3goaA01', NULL, NULL, 209, NULL, NULL, 234328),
(274574, '3goaA02', NULL, NULL, 167, NULL, NULL, 234328),
(274575, '5sxoA02', NULL, NULL, 145, NULL, NULL, 234328),
(274576, '2uv9A06', NULL, NULL, 603, NULL, NULL, 234328),
(274577, '1j3nA01', NULL, NULL, 254, NULL, NULL, 234328),
(274578, '5sxoA01', NULL, NULL, 255, NULL, NULL, 234328),
(274579, '1j3nA02', NULL, NULL, 145, NULL, NULL, 234328),
(274580, '2qo3A01', NULL, NULL, 442, NULL, NULL, 234328),
(274581, '5kp7A01', NULL, NULL, 266, NULL, NULL, 234328),
(274582, '1tedA02', NULL, NULL, 149, NULL, NULL, 234328),
(274583, '5kp7A02', NULL, NULL, 152, NULL, NULL, 234328),
(274584, '1z1eA01', NULL, NULL, 236, NULL, NULL, 234328),
(274585, '1z1eA02', NULL, NULL, 154, NULL, NULL, 234328),
(274586, '1xesD02', NULL, NULL, 155, NULL, NULL, 234328),
(274587, '1u0vB01', NULL, NULL, 239, NULL, NULL, 234328),
(274588, '5wx4A02', NULL, NULL, 153, NULL, NULL, 234328),
(274589, '2h84A02', NULL, NULL, 148, NULL, NULL, 234328),
(274590, '2h84A01', NULL, NULL, 226, NULL, NULL, 234328),
(274591, '1mzjB01', NULL, NULL, 173, NULL, NULL, 234328),
(274592, '2p0uB01', NULL, NULL, 253, NULL, NULL, 234328),
(274593, '5lp7E01', NULL, NULL, 206, NULL, NULL, 234328),
(274594, '6dxbA02', NULL, NULL, 154, NULL, NULL, 234328),
(274595, '5f0vA01', NULL, NULL, 207, NULL, NULL, 234328),
(274596, '6et0C02', NULL, NULL, 158, NULL, NULL, 234328),
(274597, '6et0C01', NULL, NULL, 207, NULL, NULL, 234328),
(274598, '6dx7A02', NULL, NULL, 156, NULL, NULL, 234328),
(274599, '5f0vA02', NULL, NULL, 156, NULL, NULL, 234328),
(274600, '6dx7A01', NULL, NULL, 241, NULL, NULL, 234328),
(274601, '6bn2A02', NULL, NULL, 156, NULL, NULL, 234328),
(274602, '6bn2A01', NULL, NULL, 214, NULL, NULL, 234328),
(274603, '2vz8A01', NULL, NULL, 407, NULL, NULL, 234328),
(274604, '2ix4A02', NULL, NULL, 155, NULL, NULL, 234328),
(274605, '2d3mA02', NULL, NULL, 158, NULL, NULL, 234328),
(274606, '4nhdA02', NULL, NULL, 146, NULL, NULL, 234328),
(274607, '5uc5A02', NULL, NULL, 153, NULL, NULL, 234328),
(274608, '5uc5A01', NULL, NULL, 237, NULL, NULL, 234328),
(274609, '3goaB02', NULL, NULL, 167, NULL, NULL, 234328),
(274610, '4e1lB01', NULL, NULL, 211, NULL, NULL, 234328),
(274611, '2ix4A01', NULL, NULL, 273, NULL, NULL, 234328),
(274612, '3tsyA02', NULL, NULL, 234, NULL, NULL, 234328),
(274613, '3wd8A01', NULL, NULL, 247, NULL, NULL, 234328),
(274614, '1tedB01', NULL, NULL, 214, NULL, NULL, 234328),
(274615, '3tsyA03', NULL, NULL, 157, NULL, NULL, 234328),
(274616, '3wd8A02', NULL, NULL, 153, NULL, NULL, 234328),
(274617, '6qspA02', NULL, NULL, 147, NULL, NULL, 234328),
(274618, '3oytB02', NULL, NULL, 147, NULL, NULL, 234328),
(274619, '5wx6A01', NULL, NULL, 221, NULL, NULL, 234328),
(274620, '3v4nC01', NULL, NULL, 240, NULL, NULL, 234328),
(274621, '6bjbA01', NULL, NULL, 210, NULL, NULL, 234328),
(274622, '2f9aA01', NULL, NULL, 404, NULL, NULL, 234328),
(274623, '3il3A01', NULL, NULL, 177, NULL, NULL, 234328),
(274624, '6bjbA02', NULL, NULL, 154, NULL, NULL, 234328),
(274625, '3il3A02', NULL, NULL, 146, NULL, NULL, 234328),
(274626, '4ubtD00', NULL, NULL, 399, NULL, NULL, 234328),
(274627, '2iikA00', NULL, NULL, 392, NULL, NULL, 234328),
(274628, '4c2jA02', NULL, NULL, 159, NULL, NULL, 234328),
(274629, '5yptA02', NULL, NULL, 156, NULL, NULL, 234328),
(274630, '1ulqA02', NULL, NULL, 179, NULL, NULL, 234328),
(274631, '4ewpA01', NULL, NULL, 183, NULL, NULL, 234328),
(274632, '4ewpA02', NULL, NULL, 166, NULL, NULL, 234328),
(274633, '4yxtB01', NULL, NULL, 268, NULL, NULL, 234328),
(274634, '5hwrA00', NULL, NULL, 420, NULL, NULL, 234328),
(274635, '6dxaA02', NULL, NULL, 156, NULL, NULL, 234328),
(274636, '2ib8A02', NULL, NULL, 154, NULL, NULL, 234328),
(274637, '4e1lA02', NULL, NULL, 153, NULL, NULL, 234328),
(274638, '6dxaA01', NULL, NULL, 240, NULL, NULL, 234328),
(274639, '3h78B01', NULL, NULL, 181, NULL, NULL, 234328),
(274640, '4b0nA01', NULL, NULL, 227, NULL, NULL, 234328),
(274641, '5ucoA02', NULL, NULL, 153, NULL, NULL, 234328),
(274642, '4b0nA02', NULL, NULL, 152, NULL, NULL, 234328);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(274643, '5ucoA01', NULL, NULL, 222, NULL, NULL, 234328),
(274644, '4z37A01', NULL, NULL, 517, NULL, NULL, 234328),
(274645, '5vxfA02', NULL, NULL, 140, NULL, NULL, 234328),
(274646, '1i88A02', NULL, NULL, 153, NULL, NULL, 234328),
(274647, '1i88A01', NULL, NULL, 234, NULL, NULL, 234328),
(274648, '6arfA02', NULL, NULL, 157, NULL, NULL, 234328),
(274649, '3oytA02', NULL, NULL, 147, NULL, NULL, 234328),
(274650, '3oytA01', NULL, NULL, 255, NULL, NULL, 234328),
(274651, '5ab4A00', NULL, NULL, 407, NULL, NULL, 234328),
(274652, '6bjaA02', NULL, NULL, 154, NULL, NULL, 234328),
(274653, '2x3eA01', NULL, NULL, 174, NULL, NULL, 234328),
(274654, '6dxbC01', NULL, NULL, 241, NULL, NULL, 234328),
(274655, '2x3eA02', NULL, NULL, 157, NULL, NULL, 234328),
(274656, '4opeD01', NULL, NULL, 512, NULL, NULL, 234328),
(274657, '2gp6A02', NULL, NULL, 151, NULL, NULL, 234328),
(274658, '2gp6A01', NULL, NULL, 264, NULL, NULL, 234328),
(274659, '4qyrA01', NULL, NULL, 519, NULL, NULL, 234328),
(274660, '1e5mA01', NULL, NULL, 259, NULL, NULL, 234328),
(274661, '1e5mA02', NULL, NULL, 145, NULL, NULL, 234328),
(274662, '4yjyA02', NULL, NULL, 153, NULL, NULL, 234328),
(274663, '2wu9B00', NULL, NULL, 416, NULL, NULL, 234328),
(274664, '1xpmA02', NULL, NULL, 147, NULL, NULL, 234328),
(274665, '4jaqA01', NULL, NULL, 208, NULL, NULL, 234328),
(274666, '3ledA01', NULL, NULL, 219, NULL, NULL, 234328),
(274667, '4yxtA02', NULL, NULL, 152, NULL, NULL, 234328),
(274668, '1xpmA01', NULL, NULL, 249, NULL, NULL, 234328),
(274669, '4jaqA02', NULL, NULL, 145, NULL, NULL, 234328),
(274670, '3ledA02', NULL, NULL, 156, NULL, NULL, 234328),
(274671, '5yo9A02', NULL, NULL, 156, NULL, NULL, 234328),
(274672, '4wumA01', NULL, NULL, 235, NULL, NULL, 234328),
(274673, '1ee0A01', NULL, NULL, 221, NULL, NULL, 234328),
(274674, '1ee0A02', NULL, NULL, 153, NULL, NULL, 234328),
(274675, '4x9kA00', NULL, NULL, 362, NULL, NULL, 234328),
(274676, '4ddoA02', NULL, NULL, 161, NULL, NULL, 234328),
(274677, '4tktA01', NULL, NULL, 527, NULL, NULL, 234328),
(274678, '4oqjA01', NULL, NULL, 436, NULL, NULL, 234328),
(274679, '4wumA02', NULL, NULL, 153, NULL, NULL, 234328),
(274680, '3floA02', NULL, NULL, 242, NULL, NULL, 234329),
(274681, '5mlc900', NULL, NULL, 107, NULL, NULL, 234330),
(274682, '5wp3B00', NULL, NULL, 121, NULL, NULL, 234330),
(274683, '4kddA01', NULL, NULL, 110, NULL, NULL, 234330),
(274684, '5jsnB00', NULL, NULL, 118, NULL, NULL, 234330),
(274685, '1is1A01', NULL, NULL, 109, NULL, NULL, 234330),
(274686, '3lhpT00', NULL, NULL, 123, NULL, NULL, 234330),
(274687, '1ge9A01', NULL, NULL, 106, NULL, NULL, 234330),
(274688, '4jlrC00', NULL, NULL, 123, NULL, NULL, 234330),
(274689, '4l8iB00', NULL, NULL, 115, NULL, NULL, 234330),
(274690, '1dd5A01', NULL, NULL, 110, NULL, NULL, 234330),
(274691, '5jsbB00', NULL, NULL, 116, NULL, NULL, 234330),
(274692, '3lf9A00', NULL, NULL, 121, NULL, NULL, 234330),
(274693, '1iseA01', NULL, NULL, 110, NULL, NULL, 234330),
(274694, '4oydB00', NULL, NULL, 117, NULL, NULL, 234330),
(274695, '4gfqA01', NULL, NULL, 109, NULL, NULL, 234330),
(274696, '1eh1A01', NULL, NULL, 108, NULL, NULL, 234330),
(274697, '2azeB00', NULL, NULL, 106, NULL, NULL, 234331),
(274698, '4l9uA00', NULL, NULL, 56, NULL, NULL, 234332),
(274699, '4qq1C01', NULL, NULL, 120, NULL, NULL, 234333),
(274700, '3uaqB01', NULL, NULL, 110, NULL, NULL, 234333),
(274701, '3ve2A01', NULL, NULL, 137, NULL, NULL, 234333),
(274702, '3holA01', NULL, NULL, 83, NULL, NULL, 234333),
(274703, '3v8uA01', NULL, NULL, 135, NULL, NULL, 234333),
(274704, '4o4uA01', NULL, NULL, 88, NULL, NULL, 234333),
(274705, '3pqsA01', NULL, NULL, 88, NULL, NULL, 234333),
(274706, '3pquA01', NULL, NULL, 119, NULL, NULL, 234333),
(274707, '4u9cA01', NULL, NULL, 133, NULL, NULL, 234333),
(274708, '3v96A01', NULL, NULL, 91, NULL, NULL, 234334),
(274709, '2e2dC01', NULL, NULL, 85, NULL, NULL, 234334),
(274710, '2rvhA00', NULL, NULL, 108, NULL, NULL, 234335),
(274711, '1d1rA00', NULL, NULL, 89, NULL, NULL, 234335),
(274712, '4mo0A00', NULL, NULL, 79, NULL, NULL, 234335),
(274713, '5zcyA00', NULL, NULL, 83, NULL, NULL, 234335);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(274714, '2if1A00', NULL, NULL, 126, NULL, NULL, 234335),
(274715, '1vw4700', NULL, NULL, 106, NULL, NULL, 234335),
(274716, '4v1al00', NULL, NULL, 133, NULL, NULL, 234335),
(274717, '2xzmF00', NULL, NULL, 101, NULL, NULL, 234335),
(274718, '5oomg00', NULL, NULL, 129, NULL, NULL, 234335),
(274719, '3jamj00', NULL, NULL, 86, NULL, NULL, 234335),
(274720, '2cn4A01', NULL, NULL, 127, NULL, NULL, 234336),
(274721, '4jerA00', NULL, NULL, 193, NULL, NULL, 234336),
(274722, '1dk0A00', NULL, NULL, 188, NULL, NULL, 234336),
(274723, '4o6uA00', NULL, NULL, 184, NULL, NULL, 234336),
(274724, '4xzdA00', NULL, NULL, 192, NULL, NULL, 234336),
(274725, '2kjwA00', NULL, NULL, 96, NULL, NULL, 234337),
(274726, '6neqF00', NULL, NULL, 124, NULL, NULL, 234337),
(274727, '3r3tA00', NULL, NULL, 99, NULL, NULL, 234337),
(274728, '2j5aA00', NULL, NULL, 110, NULL, NULL, 234337),
(274729, '1louA00', NULL, NULL, 101, NULL, NULL, 234337),
(274730, '5aj3F00', NULL, NULL, 124, NULL, NULL, 234337),
(274731, '1b64A00', NULL, NULL, 91, NULL, NULL, 234337),
(274732, '2yy3A00', NULL, NULL, 91, NULL, NULL, 234337),
(274733, '1gh8A00', NULL, NULL, 89, NULL, NULL, 234337),
(274734, '1vs5F01', NULL, NULL, 92, NULL, NULL, 234337),
(274735, '1f60B00', NULL, NULL, 94, NULL, NULL, 234337),
(274736, '3zzpA00', NULL, NULL, 77, NULL, NULL, 234337),
(274737, '2rjzA02', NULL, NULL, 110, NULL, NULL, 234337),
(274738, '1vmbA00', NULL, NULL, 107, NULL, NULL, 234337),
(274739, '1cqmA00', NULL, NULL, 101, NULL, NULL, 234337),
(274740, '2d56A00', NULL, NULL, 53, NULL, NULL, 234338),
(274741, '1z4hA01', NULL, NULL, 58, NULL, NULL, 234339),
(274742, '1jmkC02', NULL, NULL, 55, NULL, NULL, 234340),
(274743, '3if8B02', NULL, NULL, 100, NULL, NULL, 234341),
(274744, '3rkgA01', NULL, NULL, 94, NULL, NULL, 234342),
(274745, '2k3nA00', NULL, NULL, 160, NULL, NULL, 234343),
(274746, '2lyiA01', NULL, NULL, 148, NULL, NULL, 234343),
(274747, '2mqaA00', NULL, NULL, 132, NULL, NULL, 234343),
(274748, '2k3oA00', NULL, NULL, 129, NULL, NULL, 234343),
(274749, '1d4uA00', NULL, NULL, 111, NULL, NULL, 234344),
(274750, '3cjlB00', NULL, NULL, 88, NULL, NULL, 234345),
(274751, '3cjlA00', NULL, NULL, 88, NULL, NULL, 234345),
(274752, '5yrvA00', NULL, NULL, 554, NULL, NULL, 234346),
(274753, '1iwpA00', NULL, NULL, 555, NULL, NULL, 234346),
(274754, '2gnoA02', NULL, NULL, 60, NULL, NULL, 234347),
(274755, '2yg9B01', NULL, NULL, 94, NULL, NULL, 234348),
(274756, '4b21A01', NULL, NULL, 95, NULL, NULL, 234348),
(274757, '3s6iD01', NULL, NULL, 112, NULL, NULL, 234348),
(274758, '2h56B01', NULL, NULL, 119, NULL, NULL, 234348),
(274759, '4d4oC00', NULL, NULL, 83, NULL, NULL, 234349),
(274760, '1wgeA00', NULL, NULL, 83, NULL, NULL, 234349),
(274761, '5ax2A00', NULL, NULL, 89, NULL, NULL, 234349),
(274762, '2jr7A01', NULL, NULL, 75, NULL, NULL, 234349),
(274763, '4x33A00', NULL, NULL, 63, NULL, NULL, 234349),
(274764, '2l6lA02', NULL, NULL, 65, NULL, NULL, 234349),
(274765, '5eb4B02', NULL, NULL, 181, NULL, NULL, 234350),
(274766, '4udqA02', NULL, NULL, 180, NULL, NULL, 234350),
(274767, '3redA02', NULL, NULL, 181, NULL, NULL, 234350),
(274768, '1ju2A02', NULL, NULL, 181, NULL, NULL, 234350),
(274769, '2jbvA04', NULL, NULL, 174, NULL, NULL, 234350),
(274770, '5nbsA02', NULL, NULL, 272, NULL, NULL, 234351),
(274771, '3u48A02', NULL, NULL, 272, NULL, NULL, 234351),
(274772, '1x38A02', NULL, NULL, 229, NULL, NULL, 234351),
(274773, '5tf0A02', NULL, NULL, 278, NULL, NULL, 234351),
(274774, '5fjiA02', NULL, NULL, 272, NULL, NULL, 234351),
(274775, '5fjjA02', NULL, NULL, 272, NULL, NULL, 234351),
(274776, '5xxlA02', NULL, NULL, 282, NULL, NULL, 234351),
(274777, '2x41A02', NULL, NULL, 283, NULL, NULL, 234351),
(274778, '4iibA02', NULL, NULL, 272, NULL, NULL, 234351),
(274779, '4zocA02', NULL, NULL, 247, NULL, NULL, 234351),
(274780, '3zyzA02', NULL, NULL, 266, NULL, NULL, 234351),
(274781, '4i3gA02', NULL, NULL, 203, NULL, NULL, 234351),
(274782, '3bmxA02', NULL, NULL, 223, NULL, NULL, 234351),
(274783, '3rrxA02', NULL, NULL, 229, NULL, NULL, 234351),
(274784, '5ju6A02', NULL, NULL, 271, NULL, NULL, 234351);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(274785, '3abzA02', NULL, NULL, 177, NULL, NULL, 234351),
(274786, '1k4tA01', NULL, NULL, 143, NULL, NULL, 234352),
(274787, '2b9sA01', NULL, NULL, 128, NULL, NULL, 234352),
(274788, '1oisA02', NULL, NULL, 128, NULL, NULL, 234352),
(274789, '1a31A02', NULL, NULL, 111, NULL, NULL, 234352),
(274790, '1ghhA00', NULL, NULL, 81, NULL, NULL, 234353),
(274791, '5ot0A01', NULL, NULL, 200, NULL, NULL, 234354),
(274792, '1o7jA01', NULL, NULL, 218, NULL, NULL, 234354),
(274793, '2d6fA02', NULL, NULL, 212, NULL, NULL, 234354),
(274794, '4q0mA01', NULL, NULL, 199, NULL, NULL, 234354),
(274795, '2ocdB01', NULL, NULL, 209, NULL, NULL, 234354),
(274796, '3nxkD01', NULL, NULL, 221, NULL, NULL, 234354),
(274797, '1zq1A02', NULL, NULL, 222, NULL, NULL, 234354),
(274798, '3ntxA01', NULL, NULL, 211, NULL, NULL, 234354),
(274799, '2p2dD01', NULL, NULL, 208, NULL, NULL, 234354),
(274800, '5dncA01', NULL, NULL, 228, NULL, NULL, 234354),
(274801, '5k4gA01', NULL, NULL, 216, NULL, NULL, 234354),
(274802, '4pgaA01', NULL, NULL, 214, NULL, NULL, 234354),
(274803, '2gvnA01', NULL, NULL, 218, NULL, NULL, 234354),
(274804, '2wltA01', NULL, NULL, 219, NULL, NULL, 234354),
(274805, '1agxA01', NULL, NULL, 216, NULL, NULL, 234354),
(274806, '5mq5B01', NULL, NULL, 218, NULL, NULL, 234354),
(274807, '1wlsA01', NULL, NULL, 198, NULL, NULL, 234354),
(274808, '3znuA00', NULL, NULL, 94, NULL, NULL, 234355),
(274809, '4lbhA00', NULL, NULL, 100, NULL, NULL, 234355),
(274810, '1mwqA00', NULL, NULL, 101, NULL, NULL, 234355),
(274811, '1s7iA00', NULL, NULL, 124, NULL, NULL, 234355),
(274812, '5b3pA00', NULL, NULL, 134, NULL, NULL, 234356),
(274813, '3mcrA00', NULL, NULL, 155, NULL, NULL, 234356),
(274814, '3fcgB00', NULL, NULL, 90, NULL, NULL, 234357),
(274815, '3rfzB03', NULL, NULL, 66, NULL, NULL, 234357),
(274816, '3kfuG01', NULL, NULL, 38, NULL, NULL, 234358),
(274817, '3ip4C01', NULL, NULL, 46, NULL, NULL, 234358),
(274818, '4wj3C01', NULL, NULL, 53, NULL, NULL, 234358),
(274819, '3kfuJ01', NULL, NULL, 48, NULL, NULL, 234358),
(274820, '3a1kA01', NULL, NULL, 55, NULL, NULL, 234358),
(274821, '3h0lC01', NULL, NULL, 44, NULL, NULL, 234358),
(274822, '3hvnA03', NULL, NULL, 129, NULL, NULL, 234359),
(274823, '1s3rA03', NULL, NULL, 129, NULL, NULL, 234359),
(274824, '4hscX03', NULL, NULL, 125, NULL, NULL, 234359),
(274825, '3cqfA03', NULL, NULL, 125, NULL, NULL, 234359),
(274826, '1pfoA03', NULL, NULL, 125, NULL, NULL, 234359),
(274827, '3ikmA02', NULL, NULL, 255, NULL, NULL, 234360),
(274828, '3zn6A01', NULL, NULL, 139, NULL, NULL, 234361),
(274829, '3e1sA01', NULL, NULL, 105, NULL, NULL, 234362),
(274830, '4dciD00', NULL, NULL, 150, NULL, NULL, 234363),
(274831, '3pjvD02', NULL, NULL, 51, NULL, NULL, 234364),
(274832, '1tuzA00', NULL, NULL, 118, NULL, NULL, 234365),
(274833, '1td4A00', NULL, NULL, 115, NULL, NULL, 234366),
(274834, '1c5eA00', NULL, NULL, 95, NULL, NULL, 234366),
(274835, '5mfdB00', NULL, NULL, 109, NULL, NULL, 234366),
(274836, '3gqhA01', NULL, NULL, 123, NULL, NULL, 234366),
(274837, '2h88C02', NULL, NULL, 108, NULL, NULL, 234367),
(274838, '4ysxD00', NULL, NULL, 129, NULL, NULL, 234367),
(274839, '2h88D00', NULL, NULL, 103, NULL, NULL, 234367),
(274840, '4ysxC00', NULL, NULL, 155, NULL, NULL, 234367),
(274841, '1kf6D00', NULL, NULL, 119, NULL, NULL, 234367),
(274842, '1zoyD00', NULL, NULL, 103, NULL, NULL, 234367),
(274843, '1zoyC02', NULL, NULL, 108, NULL, NULL, 234367),
(274844, '1kf6C00', NULL, NULL, 130, NULL, NULL, 234367),
(274845, '2bs2C00', NULL, NULL, 256, NULL, NULL, 234367),
(274846, '2wdqC00', NULL, NULL, 129, NULL, NULL, 234367),
(274847, '2wdqD00', NULL, NULL, 115, NULL, NULL, 234367),
(274848, '2e0gA00', NULL, NULL, 107, NULL, NULL, 234368),
(274849, '4tpsD00', NULL, NULL, 85, NULL, NULL, 234368),
(274850, '2wp0D00', NULL, NULL, 91, NULL, NULL, 234368),
(274851, '3js8A04', NULL, NULL, 50, NULL, NULL, 234369),
(274852, '3pm9C05', NULL, NULL, 41, NULL, NULL, 234369),
(274853, '3pm9B05', NULL, NULL, 41, NULL, NULL, 234369),
(274854, '2i0kA04', NULL, NULL, 50, NULL, NULL, 234369),
(274855, '5fxdA04', NULL, NULL, 55, NULL, NULL, 234369);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(274856, '3pm9A05', NULL, NULL, 41, NULL, NULL, 234369),
(274857, '1e8gA04', NULL, NULL, 53, NULL, NULL, 234369),
(274858, '2vfrA05', NULL, NULL, 39, NULL, NULL, 234369),
(274859, '3pm9F05', NULL, NULL, 41, NULL, NULL, 234369),
(274860, '3pm9E05', NULL, NULL, 41, NULL, NULL, 234369),
(274861, '3pm9D05', NULL, NULL, 41, NULL, NULL, 234369),
(274862, '4bbyA06', NULL, NULL, 41, NULL, NULL, 234369),
(274863, '1wvfA04', NULL, NULL, 48, NULL, NULL, 234369),
(274864, '1dekA02', NULL, NULL, 122, NULL, NULL, 234370),
(274865, '4ewcA01', NULL, NULL, 82, NULL, NULL, 234371),
(274866, '3bywB00', NULL, NULL, 177, NULL, NULL, 234372),
(274867, '1y71A00', NULL, NULL, 130, NULL, NULL, 234373),
(274868, '2lf0A02', NULL, NULL, 60, NULL, NULL, 234374),
(274869, '3rgbC00', NULL, NULL, 245, NULL, NULL, 234375),
(274870, '4phzG00', NULL, NULL, 256, NULL, NULL, 234375),
(274871, '3chxC00', NULL, NULL, 159, NULL, NULL, 234375),
(274872, '3e7kA00', NULL, NULL, 56, NULL, NULL, 234376),
(274873, '4n7bA02', NULL, NULL, 111, NULL, NULL, 234377),
(274874, '3dnfA02', NULL, NULL, 83, NULL, NULL, 234377),
(274875, '4h4dA02', NULL, NULL, 102, NULL, NULL, 234377),
(274876, '2hwjE01', NULL, NULL, 134, NULL, NULL, 234378),
(274877, '5x0jA01', NULL, NULL, 112, NULL, NULL, 234378),
(274878, '1xw3A01', NULL, NULL, 96, NULL, NULL, 234378),
(274879, '1vk1A01', NULL, NULL, 112, NULL, NULL, 234378),
(274880, '5graA01', NULL, NULL, 160, NULL, NULL, 234379),
(274881, '4h3zA01', NULL, NULL, 166, NULL, NULL, 234379),
(274882, '1vhkC02', NULL, NULL, 192, NULL, NULL, 234379),
(274883, '3o7bA00', NULL, NULL, 219, NULL, NULL, 234379),
(274884, '3ktyB01', NULL, NULL, 168, NULL, NULL, 234379),
(274885, '4l69A02', NULL, NULL, 190, NULL, NULL, 234379),
(274886, '4x3lA02', NULL, NULL, 157, NULL, NULL, 234379),
(274887, '3ic6A01', NULL, NULL, 203, NULL, NULL, 234379),
(274888, '1ipaA02', NULL, NULL, 164, NULL, NULL, 234379),
(274889, '4kgnF00', NULL, NULL, 160, NULL, NULL, 234379),
(274890, '5wyqB01', NULL, NULL, 172, NULL, NULL, 234379),
(274891, '2egvA02', NULL, NULL, 163, NULL, NULL, 234379),
(274892, '1v2xA00', NULL, NULL, 194, NULL, NULL, 234379),
(274893, '3dcmX00', NULL, NULL, 192, NULL, NULL, 234379),
(274894, '4rg1A01', NULL, NULL, 223, NULL, NULL, 234379),
(274895, '1ns5B00', NULL, NULL, 155, NULL, NULL, 234379),
(274896, '1o6dA00', NULL, NULL, 163, NULL, NULL, 234379),
(274897, '5vm8B02', NULL, NULL, 171, NULL, NULL, 234379),
(274898, '5o95A02', NULL, NULL, 169, NULL, NULL, 234379),
(274899, '5gmbA01', NULL, NULL, 168, NULL, NULL, 234379),
(274900, '5co4B00', NULL, NULL, 162, NULL, NULL, 234379),
(274901, '3iefA01', NULL, NULL, 168, NULL, NULL, 234379),
(274902, '1v6zA02', NULL, NULL, 162, NULL, NULL, 234379),
(274903, '4cngA00', NULL, NULL, 156, NULL, NULL, 234379),
(274904, '3gyqA02', NULL, NULL, 165, NULL, NULL, 234379),
(274905, '3kw2B02', NULL, NULL, 185, NULL, NULL, 234379),
(274906, '2qwvA00', NULL, NULL, 208, NULL, NULL, 234379),
(274907, '2yy8A00', NULL, NULL, 175, NULL, NULL, 234379),
(274908, '4jalA00', NULL, NULL, 167, NULL, NULL, 234379),
(274909, '1z85B02', NULL, NULL, 154, NULL, NULL, 234379),
(274910, '5kzkA02', NULL, NULL, 160, NULL, NULL, 234379),
(274911, '1to0D00', NULL, NULL, 167, NULL, NULL, 234379),
(274912, '3quvA01', NULL, NULL, 167, NULL, NULL, 234379),
(274913, '1zjrA00', NULL, NULL, 211, NULL, NULL, 234379),
(274914, '5zhjA01', NULL, NULL, 159, NULL, NULL, 234379),
(274915, '4pzkA00', NULL, NULL, 170, NULL, NULL, 234379),
(274916, '2qmmA00', NULL, NULL, 197, NULL, NULL, 234379),
(274917, '1vhkB00', NULL, NULL, 268, NULL, NULL, 234379),
(274918, '1k3rA01', NULL, NULL, 191, NULL, NULL, 234379),
(274919, '3aiaA00', NULL, NULL, 211, NULL, NULL, 234379),
(274920, '3oiiB01', NULL, NULL, 212, NULL, NULL, 234379),
(274921, '1mxiA00', NULL, NULL, 160, NULL, NULL, 234379),
(274922, '2o3aB00', NULL, NULL, 178, NULL, NULL, 234379),
(274923, '1p9pA01', NULL, NULL, 166, NULL, NULL, 234379),
(274924, '4cndA01', NULL, NULL, 165, NULL, NULL, 234379),
(274925, '4yqdA01', NULL, NULL, 164, NULL, NULL, 234379),
(274926, '1vhyA02', NULL, NULL, 182, NULL, NULL, 234379);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(274927, '2ha8B01', NULL, NULL, 158, NULL, NULL, 234379),
(274928, '1gz0B02', NULL, NULL, 167, NULL, NULL, 234379),
(274929, '4j3cA02', NULL, NULL, 169, NULL, NULL, 234379),
(274930, '3l8uA00', NULL, NULL, 182, NULL, NULL, 234379),
(274931, '3ilkA01', NULL, NULL, 172, NULL, NULL, 234379),
(274932, '4e8bA02', NULL, NULL, 178, NULL, NULL, 234379),
(274933, '5faiA01', NULL, NULL, 202, NULL, NULL, 234379),
(274934, '3onpA00', NULL, NULL, 161, NULL, NULL, 234379),
(274935, '3nk6B02', NULL, NULL, 170, NULL, NULL, 234379),
(274936, '3n4jA00', NULL, NULL, 165, NULL, NULL, 234379),
(274937, '1oy5B01', NULL, NULL, 179, NULL, NULL, 234379),
(274938, '2i6dA02', NULL, NULL, 161, NULL, NULL, 234379),
(274939, '1x7oA02', NULL, NULL, 171, NULL, NULL, 234379),
(274940, '3ky7A01', NULL, NULL, 156, NULL, NULL, 234379),
(274941, '3bbdA00', NULL, NULL, 205, NULL, NULL, 234379),
(274942, '3knuC01', NULL, NULL, 176, NULL, NULL, 234379),
(274943, '4fakA00', NULL, NULL, 163, NULL, NULL, 234379),
(274944, '2ot3A02', NULL, NULL, 170, NULL, NULL, 234380),
(274945, '2efeA02', NULL, NULL, 168, NULL, NULL, 234380),
(274946, '3tdgA01', NULL, NULL, 66, NULL, NULL, 234381),
(274947, '2kwzA00', NULL, NULL, 40, NULL, NULL, 234382),
(274948, '1ro2A01', NULL, NULL, 70, NULL, NULL, 234383),
(274949, '3m1mA01', NULL, NULL, 67, NULL, NULL, 234383),
(274950, '2ihr101', NULL, NULL, 111, NULL, NULL, 234384),
(274951, '1gqeA01', NULL, NULL, 116, NULL, NULL, 234384),
(274952, '3f1eX01', NULL, NULL, 108, NULL, NULL, 234384),
(274953, '3zc4A01', NULL, NULL, 97, NULL, NULL, 234385),
(274954, '2itaA01', NULL, NULL, 56, NULL, NULL, 234386),
(274955, '4aukA02', NULL, NULL, 96, NULL, NULL, 234387),
(274956, '5dqvA02', NULL, NULL, 105, NULL, NULL, 234388),
(274957, '2qgsA02', NULL, NULL, 117, NULL, NULL, 234388),
(274958, '2pjqA02', NULL, NULL, 126, NULL, NULL, 234388),
(274959, '3dtoA02', NULL, NULL, 113, NULL, NULL, 234388),
(274960, '3b57A02', NULL, NULL, 109, NULL, NULL, 234388),
(274961, '3djbA02', NULL, NULL, 112, NULL, NULL, 234388),
(274962, '4xotA01', NULL, NULL, 78, NULL, NULL, 234389),
(274963, '1eqnC03', NULL, NULL, 52, NULL, NULL, 234390),
(274964, '4edgA03', NULL, NULL, 60, NULL, NULL, 234390),
(274965, '1dd9A03', NULL, NULL, 59, NULL, NULL, 234390),
(274966, '5vazA03', NULL, NULL, 58, NULL, NULL, 234390),
(274967, '1vs6X01', NULL, NULL, 46, NULL, NULL, 234391),
(274968, '2hq4A00', NULL, NULL, 161, NULL, NULL, 234392),
(274969, '2pkhB01', NULL, NULL, 137, NULL, NULL, 234393),
(274970, '2ooiA01', NULL, NULL, 158, NULL, NULL, 234393),
(274971, '3l5zA01', NULL, NULL, 142, NULL, NULL, 234393),
(274972, '2fa1A00', NULL, NULL, 160, NULL, NULL, 234393),
(274973, '3edpA02', NULL, NULL, 151, NULL, NULL, 234393),
(274974, '3hfiA00', NULL, NULL, 146, NULL, NULL, 234393),
(274975, '3f8mB02', NULL, NULL, 170, NULL, NULL, 234393),
(274976, '3bwgC02', NULL, NULL, 166, NULL, NULL, 234393),
(274977, '2ikkA00', NULL, NULL, 173, NULL, NULL, 234393),
(274978, '3cnvA01', NULL, NULL, 161, NULL, NULL, 234393),
(274979, '2oggA01', NULL, NULL, 142, NULL, NULL, 234393),
(274980, '3ddvB01', NULL, NULL, 143, NULL, NULL, 234393),
(274981, '1tt8A00', NULL, NULL, 164, NULL, NULL, 234393),
(274982, '3lheA00', NULL, NULL, 143, NULL, NULL, 234393),
(274983, '4u0wA02', NULL, NULL, 167, NULL, NULL, 234393),
(274984, '2ra5A01', NULL, NULL, 160, NULL, NULL, 234393),
(274985, '4zsiB00', NULL, NULL, 171, NULL, NULL, 234393),
(274986, '2nwiB00', NULL, NULL, 172, NULL, NULL, 234393),
(274987, '3eetB02', NULL, NULL, 169, NULL, NULL, 234393),
(274988, '2p19A01', NULL, NULL, 130, NULL, NULL, 234393),
(274989, '2ynkA00', NULL, NULL, 456, NULL, NULL, 234394),
(274990, '2x49A03', NULL, NULL, 90, NULL, NULL, 234395),
(274991, '2p9bA02', NULL, NULL, 115, NULL, NULL, 234396),
(274992, '1a9xB01', NULL, NULL, 150, NULL, NULL, 234397),
(274993, '1wthD04', NULL, NULL, 80, NULL, NULL, 234398),
(274994, '3i16A01', NULL, NULL, 210, NULL, NULL, 234399),
(274995, '3jzlA01', NULL, NULL, 195, NULL, NULL, 234399),
(274996, '3hvyA01', NULL, NULL, 211, NULL, NULL, 234399),
(274997, '3fd0A01', NULL, NULL, 195, NULL, NULL, 234399);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(274998, '3ht4C01', NULL, NULL, 201, NULL, NULL, 234399),
(274999, '1el6A01', NULL, NULL, 63, NULL, NULL, 234400),
(275000, '1mk0A00', NULL, NULL, 97, NULL, NULL, 234401),
(275001, '1zg2A00', NULL, NULL, 107, NULL, NULL, 234401),
(275002, '1yd0A00', NULL, NULL, 96, NULL, NULL, 234401),
(275003, '1ywlA00', NULL, NULL, 96, NULL, NULL, 234401),
(275004, '1yd6C00', NULL, NULL, 99, NULL, NULL, 234401),
(275005, '1jmuB01', NULL, NULL, 145, NULL, NULL, 234402),
(275006, '3a6mB01', NULL, NULL, 114, NULL, NULL, 234403),
(275007, '1dkgA01', NULL, NULL, 104, NULL, NULL, 234403),
(275008, '2r7rA08', NULL, NULL, 86, NULL, NULL, 234404),
(275009, '3suuA02', NULL, NULL, 145, NULL, NULL, 234405),
(275010, '4zmhA01', NULL, NULL, 169, NULL, NULL, 234405),
(275011, '3ozoA01', NULL, NULL, 184, NULL, NULL, 234405),
(275012, '1nowA01', NULL, NULL, 148, NULL, NULL, 234405),
(275013, '1c7sA02', NULL, NULL, 127, NULL, NULL, 234405),
(275014, '4c7gA01', NULL, NULL, 136, NULL, NULL, 234405),
(275015, '1gqiA01', NULL, NULL, 131, NULL, NULL, 234405),
(275016, '4pysA01', NULL, NULL, 128, NULL, NULL, 234405),
(275017, '5bxrA01', NULL, NULL, 137, NULL, NULL, 234405),
(275018, '5fkyB01', NULL, NULL, 124, NULL, NULL, 234405),
(275019, '3rcnA01', NULL, NULL, 135, NULL, NULL, 234405),
(275020, '1l8nA01', NULL, NULL, 125, NULL, NULL, 234405),
(275021, '4c91A01', NULL, NULL, 165, NULL, NULL, 234405),
(275022, '2gjxA01', NULL, NULL, 142, NULL, NULL, 234405),
(275023, '4a4aA02', NULL, NULL, 130, NULL, NULL, 234405),
(275024, '1jakA02', NULL, NULL, 154, NULL, NULL, 234405),
(275025, '2v5cA01', NULL, NULL, 146, NULL, NULL, 234405),
(275026, '3n5bB01', NULL, NULL, 50, NULL, NULL, 234406),
(275027, '2xkoC01', NULL, NULL, 52, NULL, NULL, 234406),
(275028, '3u61A02', NULL, NULL, 74, NULL, NULL, 234407),
(275029, '1ru3A05', NULL, NULL, 130, NULL, NULL, 234408),
(275030, '1oaoD05', NULL, NULL, 130, NULL, NULL, 234408),
(275031, '3u21A00', NULL, NULL, 127, NULL, NULL, 234409),
(275032, '3u21B00', NULL, NULL, 127, NULL, NULL, 234409),
(275033, '3rrwA02', NULL, NULL, 70, NULL, NULL, 234410),
(275034, '4qiwP00', NULL, NULL, 49, NULL, NULL, 234411),
(275035, '6gmhL00', NULL, NULL, 58, NULL, NULL, 234411),
(275036, '1twfL00', NULL, NULL, 46, NULL, NULL, 234411),
(275037, '4aybP00', NULL, NULL, 48, NULL, NULL, 234411),
(275038, '5xogL00', NULL, NULL, 45, NULL, NULL, 234411),
(275039, '3h0gL00', NULL, NULL, 45, NULL, NULL, 234411),
(275040, '2jbvA03', NULL, NULL, 57, NULL, NULL, 234412),
(275041, '4c98A02', NULL, NULL, 141, NULL, NULL, 234413),
(275042, '5yi6A02', NULL, NULL, 118, NULL, NULL, 234413),
(275043, '4c97A02', NULL, NULL, 134, NULL, NULL, 234413),
(275044, '3i4hX02', NULL, NULL, 115, NULL, NULL, 234413),
(275045, '3qjlA02', NULL, NULL, 119, NULL, NULL, 234413),
(275046, '4illA02', NULL, NULL, 168, NULL, NULL, 234413),
(275047, '3ufcX02', NULL, NULL, 121, NULL, NULL, 234413),
(275048, '3zfvA02', NULL, NULL, 167, NULL, NULL, 234413),
(275049, '4lzkC00', NULL, NULL, 187, NULL, NULL, 234414),
(275050, '4q52B00', NULL, NULL, 184, NULL, NULL, 234414),
(275051, '4pibJ00', NULL, NULL, 176, NULL, NULL, 234414),
(275052, '3sf6A01', NULL, NULL, 129, NULL, NULL, 234415),
(275053, '2ddhA01', NULL, NULL, 119, NULL, NULL, 234415),
(275054, '4xvxA01', NULL, NULL, 118, NULL, NULL, 234415),
(275055, '4n5fA01', NULL, NULL, 128, NULL, NULL, 234415),
(275056, '4zyjA01', NULL, NULL, 127, NULL, NULL, 234415),
(275057, '5k3hA01', NULL, NULL, 121, NULL, NULL, 234415),
(275058, '3ii9B01', NULL, NULL, 134, NULL, NULL, 234415),
(275059, '4u83C01', NULL, NULL, 125, NULL, NULL, 234415),
(275060, '3swoB01', NULL, NULL, 140, NULL, NULL, 234415),
(275061, '4doyA01', NULL, NULL, 109, NULL, NULL, 234415),
(275062, '1w07A01', NULL, NULL, 116, NULL, NULL, 234415),
(275063, '2or0B01', NULL, NULL, 127, NULL, NULL, 234415),
(275064, '2dvlA01', NULL, NULL, 118, NULL, NULL, 234415),
(275065, '2z1qA01', NULL, NULL, 143, NULL, NULL, 234415),
(275066, '1udyA01', NULL, NULL, 130, NULL, NULL, 234415),
(275067, '2fonA01', NULL, NULL, 116, NULL, NULL, 234415),
(275068, '3m9vA01', NULL, NULL, 127, NULL, NULL, 234415);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(275069, '2jifA01', NULL, NULL, 118, NULL, NULL, 234415),
(275070, '3mxlA01', NULL, NULL, 127, NULL, NULL, 234415),
(275071, '4ktoA01', NULL, NULL, 120, NULL, NULL, 234415),
(275072, '2pg0A01', NULL, NULL, 117, NULL, NULL, 234415),
(275073, '4l1fA01', NULL, NULL, 120, NULL, NULL, 234415),
(275074, '4iv6B01', NULL, NULL, 121, NULL, NULL, 234415),
(275075, '6fahC01', NULL, NULL, 119, NULL, NULL, 234415),
(275076, '6cxtB01', NULL, NULL, 120, NULL, NULL, 234415),
(275077, '3r7kA01', NULL, NULL, 119, NULL, NULL, 234415),
(275078, '3nf4A01', NULL, NULL, 119, NULL, NULL, 234415),
(275079, '2ebaA01', NULL, NULL, 126, NULL, NULL, 234415),
(275080, '5k3jA01', NULL, NULL, 121, NULL, NULL, 234415),
(275081, '4m9aA01', NULL, NULL, 128, NULL, NULL, 234415),
(275082, '3mpiA01', NULL, NULL, 121, NULL, NULL, 234415),
(275083, '4hr3A01', NULL, NULL, 143, NULL, NULL, 234415),
(275084, '4rm7A01', NULL, NULL, 123, NULL, NULL, 234415),
(275085, '1rx0C01', NULL, NULL, 133, NULL, NULL, 234415),
(275086, '2c12A01', NULL, NULL, 128, NULL, NULL, 234415),
(275087, '1r2jA01', NULL, NULL, 106, NULL, NULL, 234415),
(275088, '3affA01', NULL, NULL, 114, NULL, NULL, 234415),
(275089, '2jbrA01', NULL, NULL, 119, NULL, NULL, 234415),
(275090, '4p13A01', NULL, NULL, 119, NULL, NULL, 234415),
(275091, '2rfqB01', NULL, NULL, 114, NULL, NULL, 234415),
(275092, '3p4tA01', NULL, NULL, 119, NULL, NULL, 234415),
(275093, '3pfdA01', NULL, NULL, 112, NULL, NULL, 234415),
(275094, '1ivhA01', NULL, NULL, 122, NULL, NULL, 234415),
(275095, '2ix5A01', NULL, NULL, 134, NULL, NULL, 234415),
(275096, '3mkhA01', NULL, NULL, 129, NULL, NULL, 234415),
(275097, '4o5mB01', NULL, NULL, 128, NULL, NULL, 234415),
(275098, '4irnA01', NULL, NULL, 119, NULL, NULL, 234415),
(275099, '4x28A01', NULL, NULL, 121, NULL, NULL, 234415),
(275100, '3owaA01', NULL, NULL, 148, NULL, NULL, 234415),
(275101, '4x28C01', NULL, NULL, 120, NULL, NULL, 234415),
(275102, '2d29A01', NULL, NULL, 118, NULL, NULL, 234415),
(275103, '1ukwA01', NULL, NULL, 116, NULL, NULL, 234415),
(275104, '1bucA01', NULL, NULL, 123, NULL, NULL, 234415),
(275105, '2vigA01', NULL, NULL, 121, NULL, NULL, 234415),
(275106, '2wbiA01', NULL, NULL, 128, NULL, NULL, 234415),
(275107, '1jqiA01', NULL, NULL, 120, NULL, NULL, 234415),
(275108, '4w9uA01', NULL, NULL, 134, NULL, NULL, 234415),
(275109, '2uxwA02', NULL, NULL, 121, NULL, NULL, 234415),
(275110, '1siqA01', NULL, NULL, 128, NULL, NULL, 234415),
(275111, '5iduA01', NULL, NULL, 120, NULL, NULL, 234415),
(275112, '5jscA01', NULL, NULL, 120, NULL, NULL, 234415),
(275113, '5lnxF01', NULL, NULL, 118, NULL, NULL, 234415),
(275114, '5xdcB01', NULL, NULL, 123, NULL, NULL, 234415),
(275115, '4i3mA00', NULL, NULL, 159, NULL, NULL, 234416),
(275116, '4n0hA00', NULL, NULL, 464, NULL, NULL, 234417),
(275117, '3al0A00', NULL, NULL, 475, NULL, NULL, 234417),
(275118, '2dc0A00', NULL, NULL, 434, NULL, NULL, 234417),
(275119, '6c62A00', NULL, NULL, 457, NULL, NULL, 234417),
(275120, '3ip4A00', NULL, NULL, 485, NULL, NULL, 234417),
(275121, '1m22A00', NULL, NULL, 503, NULL, NULL, 234417),
(275122, '3a2qA00', NULL, NULL, 493, NULL, NULL, 234417),
(275123, '3ppmB00', NULL, NULL, 547, NULL, NULL, 234417),
(275124, '4gysB01', NULL, NULL, 387, NULL, NULL, 234417),
(275125, '4cp8E00', NULL, NULL, 450, NULL, NULL, 234417),
(275126, '4wj3A00', NULL, NULL, 484, NULL, NULL, 234417),
(275127, '4issA01', NULL, NULL, 400, NULL, NULL, 234417),
(275128, '2gi3A01', NULL, NULL, 380, NULL, NULL, 234417),
(275129, '3kfuE00', NULL, NULL, 471, NULL, NULL, 234417),
(275130, '3h0lA00', NULL, NULL, 478, NULL, NULL, 234417),
(275131, '5ewqC00', NULL, NULL, 513, NULL, NULL, 234417),
(275132, '3a1kA02', NULL, NULL, 466, NULL, NULL, 234417),
(275133, '4yj6A00', NULL, NULL, 501, NULL, NULL, 234417),
(275134, '1o9pA00', NULL, NULL, 414, NULL, NULL, 234417),
(275135, '4ojdH01', NULL, NULL, 206, NULL, NULL, 234418),
(275136, '2l8tB01', NULL, NULL, 38, NULL, NULL, 234419),
(275137, '2x3mA00', NULL, NULL, 169, NULL, NULL, 234420),
(275138, '3bg5B07', NULL, NULL, 46, NULL, NULL, 234421),
(275139, '3hblC07', NULL, NULL, 36, NULL, NULL, 234421);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(275140, '4qshA06', NULL, NULL, 52, NULL, NULL, 234421),
(275141, '4qslA07', NULL, NULL, 36, NULL, NULL, 234421),
(275142, '3grzA01', NULL, NULL, 36, NULL, NULL, 234422),
(275143, '4ecnA02', NULL, NULL, 138, NULL, NULL, 234423),
(275144, '4ecnA01', NULL, NULL, 125, NULL, NULL, 234423),
(275145, '2i74A00', NULL, NULL, 189, NULL, NULL, 234424),
(275146, '2x5hA00', NULL, NULL, 97, NULL, NULL, 234425),
(275147, '1ka2A00', NULL, NULL, 499, NULL, NULL, 234426),
(275148, '3hoaA00', NULL, NULL, 509, NULL, NULL, 234426),
(275149, '5e3xA00', NULL, NULL, 489, NULL, NULL, 234426),
(275150, '5givB00', NULL, NULL, 503, NULL, NULL, 234426),
(275151, '3dwcB00', NULL, NULL, 505, NULL, NULL, 234426),
(275152, '3hq2B00', NULL, NULL, 501, NULL, NULL, 234426),
(275153, '2h1nA00', NULL, NULL, 567, NULL, NULL, 234426),
(275154, '3sksA00', NULL, NULL, 567, NULL, NULL, 234426),
(275155, '3ahnB00', NULL, NULL, 564, NULL, NULL, 234426),
(275156, '2kesA00', NULL, NULL, 48, NULL, NULL, 234427),
(275157, '6bscB00', NULL, NULL, 55, NULL, NULL, 234428),
(275158, '2nojB00', NULL, NULL, 58, NULL, NULL, 234429),
(275159, '2wy7Q00', NULL, NULL, 80, NULL, NULL, 234429),
(275160, '2gomA00', NULL, NULL, 61, NULL, NULL, 234429),
(275161, '4dgwC00', NULL, NULL, 154, NULL, NULL, 234430),
(275162, '4anrA01', NULL, NULL, 114, NULL, NULL, 234431),
(275163, '1qusA01', NULL, NULL, 113, NULL, NULL, 234431),
(275164, '3fyfA00', NULL, NULL, 176, NULL, NULL, 234432),
(275165, '4gdzA00', NULL, NULL, 149, NULL, NULL, 234432),
(275166, '5xyiL00', NULL, NULL, 155, NULL, NULL, 234433),
(275167, '3jamL00', NULL, NULL, 156, NULL, NULL, 234433),
(275168, '6faiL00', NULL, NULL, 156, NULL, NULL, 234433),
(275169, '6az1U00', NULL, NULL, 173, NULL, NULL, 234433),
(275170, '3j7aV00', NULL, NULL, 161, NULL, NULL, 234433),
(275171, '4bpeQ00', NULL, NULL, 157, NULL, NULL, 234433),
(275172, '6g5iL00', NULL, NULL, 158, NULL, NULL, 234433),
(275173, '5xxuL00', NULL, NULL, 161, NULL, NULL, 234433),
(275174, '5optX00', NULL, NULL, 173, NULL, NULL, 234433),
(275175, '3lm3A02', NULL, NULL, 108, NULL, NULL, 234434),
(275176, '2gujA01', NULL, NULL, 142, NULL, NULL, 234435),
(275177, '3py9A04', NULL, NULL, 78, NULL, NULL, 234436),
(275178, '5jm6A02', NULL, NULL, 152, NULL, NULL, 234437),
(275179, '4emeD02', NULL, NULL, 139, NULL, NULL, 234437),
(275180, '3wt4A02', NULL, NULL, 133, NULL, NULL, 234437),
(275181, '4dyoA02', NULL, NULL, 149, NULL, NULL, 234437),
(275182, '5jgfA02', NULL, NULL, 150, NULL, NULL, 234437),
(275183, '3vatA02', NULL, NULL, 149, NULL, NULL, 234437),
(275184, '1y7eA02', NULL, NULL, 138, NULL, NULL, 234437),
(275185, '2gljA02', NULL, NULL, 138, NULL, NULL, 234437),
(275186, '2glfA02', NULL, NULL, 135, NULL, NULL, 234437),
(275187, '2e9hA02', NULL, NULL, 44, NULL, NULL, 234438),
(275188, '2g2kA02', NULL, NULL, 46, NULL, NULL, 234438),
(275189, '4f3nA00', NULL, NULL, 387, NULL, NULL, 234439),
(275190, '1deeG00', NULL, NULL, 54, NULL, NULL, 234440),
(275191, '1x0tA01', NULL, NULL, 64, NULL, NULL, 234440),
(275192, '2jwdA00', NULL, NULL, 59, NULL, NULL, 234440),
(275193, '1bdcA00', NULL, NULL, 60, NULL, NULL, 234440),
(275194, '1jm0A00', NULL, NULL, 50, NULL, NULL, 234440),
(275195, '3zdmB00', NULL, NULL, 51, NULL, NULL, 234440),
(275196, '2b87B00', NULL, NULL, 58, NULL, NULL, 234440),
(275197, '5djtB00', NULL, NULL, 61, NULL, NULL, 234440),
(275198, '1ediA00', NULL, NULL, 56, NULL, NULL, 234440),
(275199, '1fc2C00', NULL, NULL, 58, NULL, NULL, 234440),
(275200, '3mhvA00', NULL, NULL, 42, NULL, NULL, 234440),
(275201, '5cbnA02', NULL, NULL, 52, NULL, NULL, 234440),
(275202, '2otkE00', NULL, NULL, 47, NULL, NULL, 234440),
(275203, '2q1kD00', NULL, NULL, 67, NULL, NULL, 234440),
(275204, '4gofA00', NULL, NULL, 52, NULL, NULL, 234440),
(275205, '2q1kB00', NULL, NULL, 67, NULL, NULL, 234440),
(275206, '2i8dA02', NULL, NULL, 32, NULL, NULL, 234440),
(275207, '1s3jA01', NULL, NULL, 34, NULL, NULL, 234440),
(275208, '4kjmB01', NULL, NULL, 73, NULL, NULL, 234440),
(275209, '2qvaA02', NULL, NULL, 53, NULL, NULL, 234440),
(275210, '5u6aC00', NULL, NULL, 54, NULL, NULL, 234440);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(275211, '1y47A00', NULL, NULL, 46, NULL, NULL, 234440),
(275212, '3s1kA00', NULL, NULL, 59, NULL, NULL, 234440),
(275213, '5cboA02', NULL, NULL, 52, NULL, NULL, 234440),
(275214, '1lp1A00', NULL, NULL, 58, NULL, NULL, 234440),
(275215, '3qwoC00', NULL, NULL, 57, NULL, NULL, 234440),
(275216, '2kikA00', NULL, NULL, 50, NULL, NULL, 234440),
(275217, '5k5gB00', NULL, NULL, 47, NULL, NULL, 234440),
(275218, '4npdA00', NULL, NULL, 58, NULL, NULL, 234440),
(275219, '3mzwB00', NULL, NULL, 58, NULL, NULL, 234440),
(275220, '2wmmA01', NULL, NULL, 49, NULL, NULL, 234440),
(275221, '1ec5A00', NULL, NULL, 50, NULL, NULL, 234440),
(275222, '5c39A00', NULL, NULL, 51, NULL, NULL, 234440),
(275223, '4k35A04', NULL, NULL, 50, NULL, NULL, 234440),
(275224, '4mn4C01', NULL, NULL, 50, NULL, NULL, 234440),
(275225, '6fgoE00', NULL, NULL, 69, NULL, NULL, 234440),
(275226, '3zdmA00', NULL, NULL, 72, NULL, NULL, 234440),
(275227, '3rguC00', NULL, NULL, 85, NULL, NULL, 234440),
(275228, '3fxdC00', NULL, NULL, 57, NULL, NULL, 234440),
(275229, '2rklF00', NULL, NULL, 53, NULL, NULL, 234440),
(275230, '2b87A00', NULL, NULL, 58, NULL, NULL, 234440),
(275231, '4bxlA00', NULL, NULL, 46, NULL, NULL, 234440),
(275232, '2ki7B01', NULL, NULL, 59, NULL, NULL, 234440),
(275233, '2m5aB00', NULL, NULL, 58, NULL, NULL, 234440),
(275234, '4cpgA00', NULL, NULL, 83, NULL, NULL, 234440),
(275235, '5u4yC00', NULL, NULL, 55, NULL, NULL, 234440),
(275236, '5efwB00', NULL, NULL, 60, NULL, NULL, 234440),
(275237, '2p58A00', NULL, NULL, 65, NULL, NULL, 234440),
(275238, '1zxgA00', NULL, NULL, 59, NULL, NULL, 234440),
(275239, '1s3jB01', NULL, NULL, 34, NULL, NULL, 234440),
(275240, '4asvA00', NULL, NULL, 92, NULL, NULL, 234440),
(275241, '2q1kC00', NULL, NULL, 67, NULL, NULL, 234440),
(275242, '2hr3A01', NULL, NULL, 31, NULL, NULL, 234440),
(275243, '1zw0C00', NULL, NULL, 66, NULL, NULL, 234440),
(275244, '4hb1A00', NULL, NULL, 50, NULL, NULL, 234440),
(275245, '2lr2A00', NULL, NULL, 88, NULL, NULL, 234440),
(275246, '2q1kA00', NULL, NULL, 67, NULL, NULL, 234440),
(275247, '4kjmA02', NULL, NULL, 56, NULL, NULL, 234440),
(275248, '3ph0A00', NULL, NULL, 67, NULL, NULL, 234440),
(275249, '5djuB00', NULL, NULL, 61, NULL, NULL, 234440),
(275250, '2uwjE00', NULL, NULL, 70, NULL, NULL, 234440),
(275251, '2ks1B01', NULL, NULL, 23, NULL, NULL, 234440),
(275252, '4jbzA03', NULL, NULL, 32, NULL, NULL, 234440),
(275253, '2r44A01', NULL, NULL, 28, NULL, NULL, 234440),
(275254, '1lp1B00', NULL, NULL, 58, NULL, NULL, 234440),
(275255, '4npfX01', NULL, NULL, 56, NULL, NULL, 234440),
(275256, '1lt1A00', NULL, NULL, 50, NULL, NULL, 234440),
(275257, '4zpcA03', NULL, NULL, 87, NULL, NULL, 234441),
(275258, '5ziuA03', NULL, NULL, 87, NULL, NULL, 234441),
(275259, '1ra6A03', NULL, NULL, 87, NULL, NULL, 234441),
(275260, '1khvA05', NULL, NULL, 97, NULL, NULL, 234441),
(275261, '5y6zA03', NULL, NULL, 93, NULL, NULL, 234441),
(275262, '2ckwA04', NULL, NULL, 107, NULL, NULL, 234441),
(275263, '1xr5A03', NULL, NULL, 93, NULL, NULL, 234441),
(275264, '1xr6A03', NULL, NULL, 87, NULL, NULL, 234441),
(275265, '1xr7A03', NULL, NULL, 87, NULL, NULL, 234441),
(275266, '4nyzA03', NULL, NULL, 65, NULL, NULL, 234441),
(275267, '3uqsA04', NULL, NULL, 101, NULL, NULL, 234441),
(275268, '4lq3A04', NULL, NULL, 138, NULL, NULL, 234441),
(275269, '3h5xA04', NULL, NULL, 101, NULL, NULL, 234441),
(275270, '4wywA03', NULL, NULL, 78, NULL, NULL, 234441),
(275271, '5f8hA03', NULL, NULL, 93, NULL, NULL, 234441),
(275272, '2mheA00', NULL, NULL, 74, NULL, NULL, 234442),
(275273, '4pmwA02', NULL, NULL, 85, NULL, NULL, 234443),
(275274, '2vnuD02', NULL, NULL, 77, NULL, NULL, 234443),
(275275, '4pj2A00', NULL, NULL, 135, NULL, NULL, 234444),
(275276, '1oryB00', NULL, NULL, 55, NULL, NULL, 234445),
(275277, '4h63F02', NULL, NULL, 39, NULL, NULL, 234446),
(275278, '5wlzC01', NULL, NULL, 120, NULL, NULL, 234447),
(275279, '5cj4A01', NULL, NULL, 121, NULL, NULL, 234447),
(275280, '5cj4B01', NULL, NULL, 121, NULL, NULL, 234447),
(275281, '5cj4C01', NULL, NULL, 121, NULL, NULL, 234447),
(275282, '3mudA01', NULL, NULL, 121, NULL, NULL, 234447);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(275283, '5cj4D01', NULL, NULL, 121, NULL, NULL, 234447),
(275284, '2qm4D01', NULL, NULL, 142, NULL, NULL, 234447),
(275285, '5chxB01', NULL, NULL, 121, NULL, NULL, 234447),
(275286, '5chxA01', NULL, NULL, 121, NULL, NULL, 234447),
(275287, '3ghmA03', NULL, NULL, 154, NULL, NULL, 234448),
(275288, '4dgwB02', NULL, NULL, 44, NULL, NULL, 234449),
(275289, '3go5A01', NULL, NULL, 71, NULL, NULL, 234450),
(275290, '1vmjA00', NULL, NULL, 151, NULL, NULL, 234451),
(275291, '2cu5A00', NULL, NULL, 129, NULL, NULL, 234451),
(275292, '1vphB00', NULL, NULL, 149, NULL, NULL, 234451),
(275293, '1ve0A00', NULL, NULL, 134, NULL, NULL, 234451),
(275294, '1vmfC00', NULL, NULL, 145, NULL, NULL, 234451),
(275295, '2p6cA00', NULL, NULL, 137, NULL, NULL, 234451),
(275296, '1vmhA00', NULL, NULL, 144, NULL, NULL, 234451),
(275297, '1xbfA00', NULL, NULL, 140, NULL, NULL, 234451),
(275298, '2p6hA00', NULL, NULL, 134, NULL, NULL, 234451),
(275299, '3ifuA02', NULL, NULL, 116, NULL, NULL, 234452),
(275300, '5kxhA02', NULL, NULL, 165, NULL, NULL, 234453),
(275301, '5ux6B02', NULL, NULL, 176, NULL, NULL, 234453),
(275302, '2hhcA02', NULL, NULL, 180, NULL, NULL, 234453),
(275303, '4ap5A02', NULL, NULL, 172, NULL, NULL, 234453),
(275304, '3zy2A02', NULL, NULL, 169, NULL, NULL, 234453),
(275305, '3ztaA00', NULL, NULL, 146, NULL, NULL, 234454),
(275306, '4n8nC00', NULL, NULL, 115, NULL, NULL, 234455),
(275307, '1kg1A01', NULL, NULL, 28, NULL, NULL, 234456),
(275308, '3fewX01', NULL, NULL, 52, NULL, NULL, 234457),
(275309, '4bx8B02', NULL, NULL, 247, NULL, NULL, 234458),
(275310, '2xheA02', NULL, NULL, 198, NULL, NULL, 234458),
(275311, '4ccaA02', NULL, NULL, 228, NULL, NULL, 234458),
(275312, '1epuA04', NULL, NULL, 199, NULL, NULL, 234458),
(275313, '1mqsA02', NULL, NULL, 224, NULL, NULL, 234458),
(275314, '4jc8B02', NULL, NULL, 296, NULL, NULL, 234458),
(275315, '3pukB02', NULL, NULL, 230, NULL, NULL, 234458),
(275316, '4jehA02', NULL, NULL, 226, NULL, NULL, 234458),
(275317, '4hpsB00', NULL, NULL, 209, NULL, NULL, 234459),
(275318, '2ebjA00', NULL, NULL, 192, NULL, NULL, 234459),
(275319, '3lacA00', NULL, NULL, 215, NULL, NULL, 234459),
(275320, '5z48A00', NULL, NULL, 220, NULL, NULL, 234459),
(275321, '3ro0A00', NULL, NULL, 223, NULL, NULL, 234459),
(275322, '1a2zA00', NULL, NULL, 220, NULL, NULL, 234459),
(275323, '1x10A00', NULL, NULL, 208, NULL, NULL, 234459),
(275324, '1iu8A00', NULL, NULL, 206, NULL, NULL, 234459),
(275325, '3giuA00', NULL, NULL, 215, NULL, NULL, 234459),
(275326, '2fji101', NULL, NULL, 209, NULL, NULL, 234460),
(275327, '3swhA01', NULL, NULL, 173, NULL, NULL, 234460),
(275328, '1z67A00', NULL, NULL, 135, NULL, NULL, 234461),
(275329, '5ycqA00', NULL, NULL, 105, NULL, NULL, 234462),
(275330, '3g27A01', NULL, NULL, 75, NULL, NULL, 234463),
(275331, '1y8qD02', NULL, NULL, 215, NULL, NULL, 234464),
(275332, '3kydB02', NULL, NULL, 174, NULL, NULL, 234464),
(275333, '1tt5B02', NULL, NULL, 77, NULL, NULL, 234464),
(275334, '4aj5H00', NULL, NULL, 91, NULL, NULL, 234465),
(275335, '4z3xA03', NULL, NULL, 186, NULL, NULL, 234466),
(275336, '1aorA02', NULL, NULL, 186, NULL, NULL, 234466),
(275337, '1b25A02', NULL, NULL, 178, NULL, NULL, 234466),
(275338, '4n49A00', NULL, NULL, 410, NULL, NULL, 234467),
(275339, '2uv8A06', NULL, NULL, 67, NULL, NULL, 234468),
(275340, '2uv9A07', NULL, NULL, 67, NULL, NULL, 234468),
(275341, '2i06A02', NULL, NULL, 77, NULL, NULL, 234469),
(275342, '3zieD00', NULL, NULL, 86, NULL, NULL, 234470),
(275343, '3zihB00', NULL, NULL, 95, NULL, NULL, 234470),
(275344, '3zigA00', NULL, NULL, 86, NULL, NULL, 234470),
(275345, '3p04A00', NULL, NULL, 87, NULL, NULL, 234470),
(275346, '2zp9H00', NULL, NULL, 53, NULL, NULL, 234471),
(275347, '2jopA00', NULL, NULL, 110, NULL, NULL, 234472),
(275348, '5a2eA03', NULL, NULL, 110, NULL, NULL, 234472),
(275349, '6h8mA00', NULL, NULL, 114, NULL, NULL, 234472),
(275350, '1by2A00', NULL, NULL, 119, NULL, NULL, 234472),
(275351, '2oyaA00', NULL, NULL, 102, NULL, NULL, 234472),
(275352, '5a2eA02', NULL, NULL, 104, NULL, NULL, 234472),
(275353, '2ja4A00', NULL, NULL, 101, NULL, NULL, 234472);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(275354, '2xrcB03', NULL, NULL, 106, NULL, NULL, 234472),
(275355, '1z8gA01', NULL, NULL, 107, NULL, NULL, 234472),
(275356, '5hrjA00', NULL, NULL, 109, NULL, NULL, 234472),
(275357, '4jdxF00', NULL, NULL, 115, NULL, NULL, 234473),
(275358, '3irpX01', NULL, NULL, 153, NULL, NULL, 234474),
(275359, '4mboA01', NULL, NULL, 158, NULL, NULL, 234474),
(275360, '4lebA01', NULL, NULL, 161, NULL, NULL, 234474),
(275361, '3v10A01', NULL, NULL, 171, NULL, NULL, 234474),
(275362, '4f27A01', NULL, NULL, 149, NULL, NULL, 234474),
(275363, '4mbrA01', NULL, NULL, 150, NULL, NULL, 234474),
(275364, '4je0B01', NULL, NULL, 155, NULL, NULL, 234474),
(275365, '2y7lA01', NULL, NULL, 161, NULL, NULL, 234474),
(275366, '3au0A01', NULL, NULL, 149, NULL, NULL, 234474),
(275367, '4b60A01', NULL, NULL, 153, NULL, NULL, 234474),
(275368, '2z1pA01', NULL, NULL, 152, NULL, NULL, 234474),
(275369, '5ihwA01', NULL, NULL, 148, NULL, NULL, 234474),
(275370, '1r17B01', NULL, NULL, 165, NULL, NULL, 234474),
(275371, '2f68X01', NULL, NULL, 143, NULL, NULL, 234474),
(275372, '5cfaA01', NULL, NULL, 165, NULL, NULL, 234474),
(275373, '1n67A01', NULL, NULL, 141, NULL, NULL, 234474),
(275374, '3egrA00', NULL, NULL, 66, NULL, NULL, 234475),
(275375, '4fcaA01', NULL, NULL, 123, NULL, NULL, 234476),
(275376, '3sxqA01', NULL, NULL, 62, NULL, NULL, 234477),
(275377, '3fo3A01', NULL, NULL, 62, NULL, NULL, 234477),
(275378, '4ppuA00', NULL, NULL, 262, NULL, NULL, 234478),
(275379, '6hjwB00', NULL, NULL, 258, NULL, NULL, 234478),
(275380, '5w6yA00', NULL, NULL, 244, NULL, NULL, 234478),
(275381, '5csmA00', NULL, NULL, 256, NULL, NULL, 234478),
(275382, '6h3pA00', NULL, NULL, 253, NULL, NULL, 234478),
(275383, '3oc8A00', NULL, NULL, 137, NULL, NULL, 234479),
(275384, '1vdhA02', NULL, NULL, 126, NULL, NULL, 234480),
(275385, '5t2kA01', NULL, NULL, 137, NULL, NULL, 234480),
(275386, '1vdhA01', NULL, NULL, 123, NULL, NULL, 234480),
(275387, '5loqB01', NULL, NULL, 139, NULL, NULL, 234480),
(275388, '1t0tV02', NULL, NULL, 111, NULL, NULL, 234480),
(275389, '5loqA02', NULL, NULL, 111, NULL, NULL, 234480),
(275390, '3bqwA02', NULL, NULL, 137, NULL, NULL, 234481),
(275391, '2pp6A02', NULL, NULL, 77, NULL, NULL, 234482),
(275392, '1v5vA02', NULL, NULL, 92, NULL, NULL, 234483),
(275393, '1wsrA02', NULL, NULL, 91, NULL, NULL, 234483),
(275394, '1pj5A04', NULL, NULL, 120, NULL, NULL, 234483),
(275395, '1vlyA02', NULL, NULL, 87, NULL, NULL, 234483),
(275396, '5l46A04', NULL, NULL, 117, NULL, NULL, 234483),
(275397, '1vloA02', NULL, NULL, 88, NULL, NULL, 234483),
(275398, '1wosA02', NULL, NULL, 87, NULL, NULL, 234483),
(275399, '3girA02', NULL, NULL, 86, NULL, NULL, 234483),
(275400, '1yx2A02', NULL, NULL, 86, NULL, NULL, 234483),
(275401, '4pabA04', NULL, NULL, 120, NULL, NULL, 234483),
(275402, '3hrgA02', NULL, NULL, 114, NULL, NULL, 234484),
(275403, '4okvE00', NULL, NULL, 66, NULL, NULL, 234485),
(275404, '4nkgB00', NULL, NULL, 82, NULL, NULL, 234486),
(275405, '4nb5B02', NULL, NULL, 74, NULL, NULL, 234486),
(275406, '4iggA01', NULL, NULL, 67, NULL, NULL, 234486),
(275407, '1rfyB00', NULL, NULL, 102, NULL, NULL, 234486),
(275408, '2hjdA00', NULL, NULL, 102, NULL, NULL, 234486),
(275409, '4dylA02', NULL, NULL, 94, NULL, NULL, 234486),
(275410, '2q0oC00', NULL, NULL, 91, NULL, NULL, 234486),
(275411, '1cxzB00', NULL, NULL, 86, NULL, NULL, 234486),
(275412, '4l23B02', NULL, NULL, 159, NULL, NULL, 234487),
(275413, '2y3aB01', NULL, NULL, 130, NULL, NULL, 234487),
(275414, '3na7A00', NULL, NULL, 237, NULL, NULL, 234487),
(275415, '3l4qC00', NULL, NULL, 170, NULL, NULL, 234487),
(275416, '5dxhB00', NULL, NULL, 121, NULL, NULL, 234487),
(275417, '2v1yB00', NULL, NULL, 170, NULL, NULL, 234487),
(275418, '4jpsB02', NULL, NULL, 160, NULL, NULL, 234487),
(275419, '4iloA00', NULL, NULL, 236, NULL, NULL, 234487),
(275420, '3v7oA00', NULL, NULL, 132, NULL, NULL, 234488),
(275421, '6e5xA00', NULL, NULL, 127, NULL, NULL, 234488),
(275422, '5dvwA00', NULL, NULL, 134, NULL, NULL, 234488),
(275423, '5t3tJ00', NULL, NULL, 152, NULL, NULL, 234488),
(275424, '5t3wA00', NULL, NULL, 161, NULL, NULL, 234488);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(275425, '3f2bA06', NULL, NULL, 105, NULL, NULL, 234489),
(275426, '4jqrA00', NULL, NULL, 229, NULL, NULL, 234490),
(275427, '4e9kA00', NULL, NULL, 241, NULL, NULL, 234490),
(275428, '2p1gA02', NULL, NULL, 110, NULL, NULL, 234491),
(275429, '2im9A02', NULL, NULL, 147, NULL, NULL, 234491),
(275430, '4q68A02', NULL, NULL, 102, NULL, NULL, 234491),
(275431, '3vthB01', NULL, NULL, 205, NULL, NULL, 234492),
(275432, '3ttcA01', NULL, NULL, 216, NULL, NULL, 234492),
(275433, '4tpsA00', NULL, NULL, 154, NULL, NULL, 234493),
(275434, '3f75P00', NULL, NULL, 90, NULL, NULL, 234494),
(275435, '2l95A00', NULL, NULL, 80, NULL, NULL, 234494),
(275436, '1ygsA00', NULL, NULL, 199, NULL, NULL, 234495),
(275437, '3gmjA00', NULL, NULL, 199, NULL, NULL, 234495),
(275438, '5xodA00', NULL, NULL, 199, NULL, NULL, 234495),
(275439, '5bviA00', NULL, NULL, 185, NULL, NULL, 234495),
(275440, '5jelA00', NULL, NULL, 242, NULL, NULL, 234495),
(275441, '5jemA00', NULL, NULL, 213, NULL, NULL, 234495),
(275442, '1u7vB00', NULL, NULL, 236, NULL, NULL, 234495),
(275443, '3dshA01', NULL, NULL, 202, NULL, NULL, 234495),
(275444, '1khuA00', NULL, NULL, 198, NULL, NULL, 234495),
(275445, '1khxA00', NULL, NULL, 203, NULL, NULL, 234495),
(275446, '4r9pA00', NULL, NULL, 214, NULL, NULL, 234495),
(275447, '3ib5A00', NULL, NULL, 348, NULL, NULL, 234496),
(275448, '2qx2A00', NULL, NULL, 344, NULL, NULL, 234496),
(275449, '4hn3D00', NULL, NULL, 333, NULL, NULL, 234496),
(275450, '5bncA02', NULL, NULL, 93, NULL, NULL, 234497),
(275451, '2arzA02', NULL, NULL, 93, NULL, NULL, 234497),
(275452, '3gasA01', NULL, NULL, 80, NULL, NULL, 234497),
(275453, '5yjlC02', NULL, NULL, 122, NULL, NULL, 234497),
(275454, '3swjA01', NULL, NULL, 80, NULL, NULL, 234497),
(275455, '3dnhA02', NULL, NULL, 85, NULL, NULL, 234497),
(275456, '3t15A02', NULL, NULL, 108, NULL, NULL, 234498),
(275457, '4w5wA02', NULL, NULL, 113, NULL, NULL, 234498),
(275458, '3thgA00', NULL, NULL, 107, NULL, NULL, 234498),
(275459, '1dj7A00', NULL, NULL, 117, NULL, NULL, 234499),
(275460, '3epnB01', NULL, NULL, 317, NULL, NULL, 234500),
(275461, '4n7qA02', NULL, NULL, 303, NULL, NULL, 234500),
(275462, '5gipA02', NULL, NULL, 127, NULL, NULL, 234501),
(275463, '3nviA01', NULL, NULL, 129, NULL, NULL, 234501),
(275464, '2ozbB01', NULL, NULL, 142, NULL, NULL, 234501),
(275465, '3id6A02', NULL, NULL, 161, NULL, NULL, 234501),
(275466, '2ka6B00', NULL, NULL, 45, NULL, NULL, 234502),
(275467, '4aybA08', NULL, NULL, 59, NULL, NULL, 234503),
(275468, '2b4nA00', NULL, NULL, 42, NULL, NULL, 234504),
(275469, '1ss3A00', NULL, NULL, 50, NULL, NULL, 234505),
(275470, '5yjlB01', NULL, NULL, 161, NULL, NULL, 234506),
(275471, '1gpjA01', NULL, NULL, 145, NULL, NULL, 234506),
(275472, '2kvoA01', NULL, NULL, 104, NULL, NULL, 234507),
(275473, '3zpnC00', NULL, NULL, 113, NULL, NULL, 234507),
(275474, '2iutA01', NULL, NULL, 105, NULL, NULL, 234508),
(275475, '2iusD01', NULL, NULL, 105, NULL, NULL, 234508),
(275476, '1zxuA00', NULL, NULL, 194, NULL, NULL, 234509),
(275477, '2kgyA00', NULL, NULL, 102, NULL, NULL, 234510),
(275478, '2lraA00', NULL, NULL, 81, NULL, NULL, 234510),
(275479, '3hxlA03', NULL, NULL, 103, NULL, NULL, 234511),
(275480, '4e6nB00', NULL, NULL, 230, NULL, NULL, 234512),
(275481, '3b0gA01', NULL, NULL, 227, NULL, NULL, 234513),
(275482, '3b0hA01', NULL, NULL, 226, NULL, NULL, 234513),
(275483, '2akjA01', NULL, NULL, 224, NULL, NULL, 234513),
(275484, '2fipA00', NULL, NULL, 115, NULL, NULL, 234514),
(275485, '2ra1A02', NULL, NULL, 68, NULL, NULL, 234515),
(275486, '4f9cB02', NULL, NULL, 41, NULL, NULL, 234516),
(275487, '3kdjB00', NULL, NULL, 316, NULL, NULL, 234517),
(275488, '3ke6B01', NULL, NULL, 230, NULL, NULL, 234517),
(275489, '2j4oA00', NULL, NULL, 371, NULL, NULL, 234517),
(275490, '3d8kD00', NULL, NULL, 357, NULL, NULL, 234517),
(275491, '2j82A00', NULL, NULL, 240, NULL, NULL, 234517),
(275492, '4ragA01', NULL, NULL, 294, NULL, NULL, 234517),
(275493, '2irmA00', NULL, NULL, 358, NULL, NULL, 234517),
(275494, '3rnrB00', NULL, NULL, 211, NULL, NULL, 234517),
(275495, '2jfrA00', NULL, NULL, 234, NULL, NULL, 234517);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(275496, '3qn1B00', NULL, NULL, 337, NULL, NULL, 234517),
(275497, '2isnB00', NULL, NULL, 347, NULL, NULL, 234517),
(275498, '3zt9A00', NULL, NULL, 193, NULL, NULL, 234517),
(275499, '3t91B00', NULL, NULL, 242, NULL, NULL, 234517),
(275500, '5zcgA00', NULL, NULL, 328, NULL, NULL, 234517),
(275501, '3pu9A00', NULL, NULL, 242, NULL, NULL, 234517),
(275502, '5f1mA00', NULL, NULL, 268, NULL, NULL, 234517),
(275503, '4yzgA00', NULL, NULL, 302, NULL, NULL, 234517),
(275504, '2p8eA00', NULL, NULL, 307, NULL, NULL, 234517),
(275505, '4oicB00', NULL, NULL, 328, NULL, NULL, 234517),
(275506, '2pk0A00', NULL, NULL, 250, NULL, NULL, 234517),
(275507, '2i44B00', NULL, NULL, 324, NULL, NULL, 234517),
(275508, '4jndA02', NULL, NULL, 291, NULL, NULL, 234517),
(275509, '2i0oA00', NULL, NULL, 304, NULL, NULL, 234517),
(275510, '3nmvB00', NULL, NULL, 324, NULL, NULL, 234517),
(275511, '2pnqA00', NULL, NULL, 436, NULL, NULL, 234517),
(275512, '1txoB00', NULL, NULL, 237, NULL, NULL, 234517),
(275513, '4n0gA00', NULL, NULL, 302, NULL, NULL, 234517),
(275514, '3w42A00', NULL, NULL, 199, NULL, NULL, 234517),
(275515, '3f79E00', NULL, NULL, 255, NULL, NULL, 234517),
(275516, '2iq1A00', NULL, NULL, 274, NULL, NULL, 234517),
(275517, '3p01B01', NULL, NULL, 89, NULL, NULL, 234518),
(275518, '3ufeB01', NULL, NULL, 58, NULL, NULL, 234519),
(275519, '3buxB01', NULL, NULL, 129, NULL, NULL, 234520),
(275520, '4btfA01', NULL, NULL, 122, NULL, NULL, 234520),
(275521, '3zniI01', NULL, NULL, 134, NULL, NULL, 234520),
(275522, '3vrpA01', NULL, NULL, 134, NULL, NULL, 234520),
(275523, '4kt6A01', NULL, NULL, 78, NULL, NULL, 234521),
(275524, '3pntA01', NULL, NULL, 87, NULL, NULL, 234521),
(275525, '3h02F02', NULL, NULL, 37, NULL, NULL, 234522),
(275526, '1mj3A02', NULL, NULL, 57, NULL, NULL, 234522),
(275527, '6ojmA02', NULL, NULL, 51, NULL, NULL, 234522),
(275528, '3trrA02', NULL, NULL, 58, NULL, NULL, 234522),
(275529, '5c9gA02', NULL, NULL, 57, NULL, NULL, 234522),
(275530, '2vx2G02', NULL, NULL, 57, NULL, NULL, 234522),
(275531, '5jbxA02', NULL, NULL, 60, NULL, NULL, 234522),
(275532, '4izdB02', NULL, NULL, 67, NULL, NULL, 234522),
(275533, '4mouB02', NULL, NULL, 60, NULL, NULL, 234522),
(275534, '2pbpA02', NULL, NULL, 57, NULL, NULL, 234522),
(275535, '4nekA02', NULL, NULL, 56, NULL, NULL, 234522),
(275536, '3hinA02', NULL, NULL, 64, NULL, NULL, 234522),
(275537, '4jylA02', NULL, NULL, 49, NULL, NULL, 234522),
(275538, '3r0oA02', NULL, NULL, 61, NULL, NULL, 234522),
(275539, '3h02B02', NULL, NULL, 51, NULL, NULL, 234522),
(275540, '3t89A02', NULL, NULL, 51, NULL, NULL, 234522),
(275541, '3h02D02', NULL, NULL, 51, NULL, NULL, 234522),
(275542, '2gtrA02', NULL, NULL, 57, NULL, NULL, 234522),
(275543, '2vreA02', NULL, NULL, 57, NULL, NULL, 234522),
(275544, '5wydB02', NULL, NULL, 68, NULL, NULL, 234522),
(275545, '4jwvA02', NULL, NULL, 58, NULL, NULL, 234522),
(275546, '4k3wB02', NULL, NULL, 61, NULL, NULL, 234522),
(275547, '3t8aC02', NULL, NULL, 39, NULL, NULL, 234522),
(275548, '4di1C02', NULL, NULL, 41, NULL, NULL, 234522),
(275549, '5kjpA02', NULL, NULL, 58, NULL, NULL, 234522),
(275550, '4lk5B02', NULL, NULL, 57, NULL, NULL, 234522),
(275551, '2uzfA02', NULL, NULL, 51, NULL, NULL, 234522),
(275552, '2iexA02', NULL, NULL, 51, NULL, NULL, 234522),
(275553, '1dciA02', NULL, NULL, 63, NULL, NULL, 234522),
(275554, '3r9tC02', NULL, NULL, 61, NULL, NULL, 234522),
(275555, '3h81B02', NULL, NULL, 58, NULL, NULL, 234522),
(275556, '3qk8B02', NULL, NULL, 62, NULL, NULL, 234522),
(275557, '3p5mA02', NULL, NULL, 57, NULL, NULL, 234522),
(275558, '3tlfA02', NULL, NULL, 58, NULL, NULL, 234522),
(275559, '2ej5A02', NULL, NULL, 58, NULL, NULL, 234522),
(275560, '3fduA02', NULL, NULL, 46, NULL, NULL, 234522),
(275561, '3swxA02', NULL, NULL, 58, NULL, NULL, 234522),
(275562, '4jfcA02', NULL, NULL, 56, NULL, NULL, 234522),
(275563, '3h02E02', NULL, NULL, 51, NULL, NULL, 234522),
(275564, '4mi2A02', NULL, NULL, 58, NULL, NULL, 234522),
(275565, '3g64A02', NULL, NULL, 61, NULL, NULL, 234522),
(275566, '4u19B02', NULL, NULL, 52, NULL, NULL, 234522);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(275567, '3rsiA02', NULL, NULL, 58, NULL, NULL, 234522),
(275568, '4elsC02', NULL, NULL, 40, NULL, NULL, 234522),
(275569, '4wczA02', NULL, NULL, 54, NULL, NULL, 234522),
(275570, '3i47A02', NULL, NULL, 65, NULL, NULL, 234522),
(275571, '1hzdA02', NULL, NULL, 60, NULL, NULL, 234522),
(275572, '1jxzC02', NULL, NULL, 65, NULL, NULL, 234522),
(275573, '3moyA02', NULL, NULL, 58, NULL, NULL, 234522),
(275574, '4og1A02', NULL, NULL, 58, NULL, NULL, 234522),
(275575, '4mouC02', NULL, NULL, 60, NULL, NULL, 234522),
(275576, '4mouA02', NULL, NULL, 60, NULL, NULL, 234522),
(275577, '4izbB02', NULL, NULL, 43, NULL, NULL, 234522),
(275578, '6n92A02', NULL, NULL, 59, NULL, NULL, 234522),
(275579, '4jcsA02', NULL, NULL, 62, NULL, NULL, 234522),
(275580, '4jvtA02', NULL, NULL, 48, NULL, NULL, 234522),
(275581, '4qiiA02', NULL, NULL, 51, NULL, NULL, 234522),
(275582, '5z7rA02', NULL, NULL, 65, NULL, NULL, 234522),
(275583, '1uiyA02', NULL, NULL, 55, NULL, NULL, 234522),
(275584, '3hrxA02', NULL, NULL, 58, NULL, NULL, 234522),
(275585, '3sllA02', NULL, NULL, 61, NULL, NULL, 234522),
(275586, '3h02A02', NULL, NULL, 51, NULL, NULL, 234522),
(275587, '3h02C02', NULL, NULL, 51, NULL, NULL, 234522),
(275588, '2ppyA02', NULL, NULL, 60, NULL, NULL, 234522),
(275589, '3qxzA02', NULL, NULL, 61, NULL, NULL, 234522),
(275590, '4f47A02', NULL, NULL, 58, NULL, NULL, 234522),
(275591, '3oc7A02', NULL, NULL, 56, NULL, NULL, 234522),
(275592, '3qxiA02', NULL, NULL, 58, NULL, NULL, 234522),
(275593, '3kqfA02', NULL, NULL, 60, NULL, NULL, 234522),
(275594, '1wz8A02', NULL, NULL, 57, NULL, NULL, 234522),
(275595, '4i4zA02', NULL, NULL, 51, NULL, NULL, 234522),
(275596, '4fzwA02', NULL, NULL, 58, NULL, NULL, 234522),
(275597, '3mybB02', NULL, NULL, 63, NULL, NULL, 234522),
(275598, '4fzwC02', NULL, NULL, 58, NULL, NULL, 234522),
(275599, '2hw5A02', NULL, NULL, 57, NULL, NULL, 234522),
(275600, '4zu2A02', NULL, NULL, 65, NULL, NULL, 234522),
(275601, '2fw2D02', NULL, NULL, 57, NULL, NULL, 234522),
(275602, '3q1tC02', NULL, NULL, 62, NULL, NULL, 234522),
(275603, '4k2nA02', NULL, NULL, 56, NULL, NULL, 234522),
(275604, '3f6zB01', NULL, NULL, 87, NULL, NULL, 234523),
(275605, '2f09A00', NULL, NULL, 82, NULL, NULL, 234523),
(275606, '3oe3F00', NULL, NULL, 98, NULL, NULL, 234523),
(275607, '3oe3E00', NULL, NULL, 98, NULL, NULL, 234523),
(275608, '3oe3D00', NULL, NULL, 98, NULL, NULL, 234523),
(275609, '3oe3C00', NULL, NULL, 98, NULL, NULL, 234523),
(275610, '3oe3B00', NULL, NULL, 98, NULL, NULL, 234523),
(275611, '3oe3A00', NULL, NULL, 98, NULL, NULL, 234523),
(275612, '4ml7B01', NULL, NULL, 85, NULL, NULL, 234523),
(275613, '3jqqC01', NULL, NULL, 121, NULL, NULL, 234524),
(275614, '4n3gA02', NULL, NULL, 101, NULL, NULL, 234524),
(275615, '1tvcA01', NULL, NULL, 109, NULL, NULL, 234524),
(275616, '5kswB01', NULL, NULL, 100, NULL, NULL, 234524),
(275617, '4yhbA01', NULL, NULL, 135, NULL, NULL, 234524),
(275618, '2crvA01', NULL, NULL, 93, NULL, NULL, 234524),
(275619, '4kiyV02', NULL, NULL, 108, NULL, NULL, 234524),
(275620, '5hxbA02', NULL, NULL, 109, NULL, NULL, 234524),
(275621, '5hxbA01', NULL, NULL, 90, NULL, NULL, 234524),
(275622, '5ty0A02', NULL, NULL, 128, NULL, NULL, 234524),
(275623, '3qftA01', NULL, NULL, 118, NULL, NULL, 234524),
(275624, '1gawA01', NULL, NULL, 133, NULL, NULL, 234524),
(275625, '5an9A02', NULL, NULL, 182, NULL, NULL, 234524),
(275626, '3p26A03', NULL, NULL, 116, NULL, NULL, 234524),
(275627, '2bm0A02', NULL, NULL, 103, NULL, NULL, 234524),
(275628, '1skqB03', NULL, NULL, 109, NULL, NULL, 234524),
(275629, '1cqxA02', NULL, NULL, 111, NULL, NULL, 234524),
(275630, '4c0sA02', NULL, NULL, 93, NULL, NULL, 234524),
(275631, '5w75A03', NULL, NULL, 95, NULL, NULL, 234524),
(275632, '6bk7A02', NULL, NULL, 119, NULL, NULL, 234524),
(275633, '6mijA02', NULL, NULL, 95, NULL, NULL, 234524),
(275634, '3w5hA01', NULL, NULL, 117, NULL, NULL, 234524),
(275635, '6mijA03', NULL, NULL, 93, NULL, NULL, 234524),
(275636, '1zunB02', NULL, NULL, 90, NULL, NULL, 234524),
(275637, '1f20A03', NULL, NULL, 113, NULL, NULL, 234524);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(275638, '2piaA01', NULL, NULL, 104, NULL, NULL, 234524),
(275639, '1zunB03', NULL, NULL, 106, NULL, NULL, 234524),
(275640, '2b5oA01', NULL, NULL, 129, NULL, NULL, 234524),
(275641, '1umkA01', NULL, NULL, 115, NULL, NULL, 234524),
(275642, '2xexA02', NULL, NULL, 119, NULL, NULL, 234524),
(275643, '5gxuB01', NULL, NULL, 122, NULL, NULL, 234524),
(275644, '1kjzA03', NULL, NULL, 92, NULL, NULL, 234524),
(275645, '3vo1A01', NULL, NULL, 132, NULL, NULL, 234524),
(275646, '3j81k02', NULL, NULL, 116, NULL, NULL, 234524),
(275647, '1vw3C01', NULL, NULL, 131, NULL, NULL, 234524),
(275648, '2qtlA02', NULL, NULL, 121, NULL, NULL, 234524),
(275649, '4zv4A02', NULL, NULL, 95, NULL, NULL, 234524),
(275650, '3fpkA01', NULL, NULL, 99, NULL, NULL, 234524),
(275651, '6gehA01', NULL, NULL, 113, NULL, NULL, 234524),
(275652, '4zciA02', NULL, NULL, 101, NULL, NULL, 234524),
(275653, '3wndA03', NULL, NULL, 94, NULL, NULL, 234524),
(275654, '3wndA02', NULL, NULL, 85, NULL, NULL, 234524),
(275655, '4a17B02', NULL, NULL, 180, NULL, NULL, 234524),
(275656, '1ddgA01', NULL, NULL, 114, NULL, NULL, 234524),
(275657, '4zv4A03', NULL, NULL, 93, NULL, NULL, 234524),
(275658, '2qdxA01', NULL, NULL, 95, NULL, NULL, 234524),
(275659, '3wy9A02', NULL, NULL, 95, NULL, NULL, 234524),
(275660, '4rd4A03', NULL, NULL, 93, NULL, NULL, 234524),
(275661, '4j0qA02', NULL, NULL, 95, NULL, NULL, 234524),
(275662, '4fn5A02', NULL, NULL, 114, NULL, NULL, 234524),
(275663, '4rd4A02', NULL, NULL, 115, NULL, NULL, 234524),
(275664, '4j0qA03', NULL, NULL, 93, NULL, NULL, 234524),
(275665, '1s0uA03', NULL, NULL, 92, NULL, NULL, 234524),
(275666, '4tmxA02', NULL, NULL, 113, NULL, NULL, 234524),
(275667, '3p26B02', NULL, NULL, 106, NULL, NULL, 234524),
(275668, '1s0uA02', NULL, NULL, 115, NULL, NULL, 234524),
(275669, '2bn4B03', NULL, NULL, 162, NULL, NULL, 234524),
(275670, '4he6A00', NULL, NULL, 89, NULL, NULL, 234524),
(275671, '3v76A02', NULL, NULL, 90, NULL, NULL, 234524),
(275672, '2gqfA02', NULL, NULL, 90, NULL, NULL, 234524),
(275673, '5w75B02', NULL, NULL, 96, NULL, NULL, 234524),
(275674, '3vmfA03', NULL, NULL, 108, NULL, NULL, 234524),
(275675, '2yweA02', NULL, NULL, 100, NULL, NULL, 234524),
(275676, '2derA03', NULL, NULL, 87, NULL, NULL, 234524),
(275677, '2gpjA01', NULL, NULL, 105, NULL, NULL, 234524),
(275678, '4eh1A01', NULL, NULL, 110, NULL, NULL, 234524),
(275679, '3cb4A02', NULL, NULL, 100, NULL, NULL, 234524),
(275680, '4n3nA04', NULL, NULL, 137, NULL, NULL, 234524),
(275681, '4b4dA01', NULL, NULL, 100, NULL, NULL, 234524),
(275682, '2d74A03', NULL, NULL, 100, NULL, NULL, 234524),
(275683, '3vmfA02', NULL, NULL, 94, NULL, NULL, 234524),
(275684, '1xe1A00', NULL, NULL, 91, NULL, NULL, 234524),
(275685, '5yt0A02', NULL, NULL, 127, NULL, NULL, 234524),
(275686, '2bgiA01', NULL, NULL, 87, NULL, NULL, 234524),
(275687, '1sm4A01', NULL, NULL, 133, NULL, NULL, 234524),
(275688, '1vx7E02', NULL, NULL, 176, NULL, NULL, 234524),
(275689, '1d1nA00', NULL, NULL, 99, NULL, NULL, 234524),
(275690, '6notA02', NULL, NULL, 97, NULL, NULL, 234524),
(275691, '4yalA02', NULL, NULL, 122, NULL, NULL, 234524),
(275692, '4n3sA02', NULL, NULL, 119, NULL, NULL, 234524),
(275693, '1vx4404', NULL, NULL, 140, NULL, NULL, 234524),
(275694, '1d2eA02', NULL, NULL, 91, NULL, NULL, 234524),
(275695, '2cndA01', NULL, NULL, 116, NULL, NULL, 234524),
(275696, '1a8pA01', NULL, NULL, 96, NULL, NULL, 234524),
(275697, '1d2eA03', NULL, NULL, 94, NULL, NULL, 234524),
(275698, '3lo8A01', NULL, NULL, 139, NULL, NULL, 234524),
(275699, '1kk1A02', NULL, NULL, 115, NULL, NULL, 234524),
(275700, '1aipE03', NULL, NULL, 56, NULL, NULL, 234524),
(275701, '6gfuA03', NULL, NULL, 100, NULL, NULL, 234524),
(275702, '1aipE02', NULL, NULL, 130, NULL, NULL, 234524),
(275703, '6gfuA02', NULL, NULL, 95, NULL, NULL, 234524),
(275704, '4zgnB00', NULL, NULL, 118, NULL, NULL, 234524),
(275705, '2dy1A02', NULL, NULL, 97, NULL, NULL, 234524),
(275706, '2hmaA03', NULL, NULL, 91, NULL, NULL, 234524),
(275707, '1jnyA02', NULL, NULL, 89, NULL, NULL, 234524),
(275708, '5o8wA02', NULL, NULL, 95, NULL, NULL, 234524);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(275709, '3mhpB01', NULL, NULL, 132, NULL, NULL, 234524),
(275710, '3o58C02', NULL, NULL, 153, NULL, NULL, 234524),
(275711, '2eixA01', NULL, NULL, 106, NULL, NULL, 234524),
(275712, '3wy9A03', NULL, NULL, 111, NULL, NULL, 234524),
(275713, '4qjty02', NULL, NULL, 101, NULL, NULL, 234524),
(275714, '2c78A02', NULL, NULL, 92, NULL, NULL, 234524),
(275715, '2c78A03', NULL, NULL, 94, NULL, NULL, 234524),
(275716, '5tv2A02', NULL, NULL, 112, NULL, NULL, 234524),
(275717, '4wqmA02', NULL, NULL, 98, NULL, NULL, 234524),
(275718, '3wbiA04', NULL, NULL, 145, NULL, NULL, 234524),
(275719, '1xb2A03', NULL, NULL, 102, NULL, NULL, 234524),
(275720, '5ylyA01', NULL, NULL, 118, NULL, NULL, 234524),
(275721, '4u9uA01', NULL, NULL, 138, NULL, NULL, 234524),
(275722, '1g7sA02', NULL, NULL, 112, NULL, NULL, 234524),
(275723, '2bmwA01', NULL, NULL, 137, NULL, NULL, 234524),
(275724, '1fnbA01', NULL, NULL, 133, NULL, NULL, 234524),
(275725, '1g7sA04', NULL, NULL, 89, NULL, NULL, 234524),
(275726, '4b43A03', NULL, NULL, 123, NULL, NULL, 234524),
(275727, '4dqlB01', NULL, NULL, 110, NULL, NULL, 234524),
(275728, '1vwxB02', NULL, NULL, 180, NULL, NULL, 234524),
(275729, '3vo2A01', NULL, NULL, 147, NULL, NULL, 234524),
(275730, '4fk8B01', NULL, NULL, 95, NULL, NULL, 234524),
(275731, '4ac9C02', NULL, NULL, 93, NULL, NULL, 234524),
(275732, '4g1vA02', NULL, NULL, 118, NULL, NULL, 234524),
(275733, '4ac9C03', NULL, NULL, 115, NULL, NULL, 234524),
(275734, '2rc5B01', NULL, NULL, 153, NULL, NULL, 234524),
(275735, '3b82A03', NULL, NULL, 137, NULL, NULL, 234524),
(275736, '4c0sB03', NULL, NULL, 108, NULL, NULL, 234524),
(275737, '1ep3B01', NULL, NULL, 100, NULL, NULL, 234524),
(275738, '5tr9A01', NULL, NULL, 109, NULL, NULL, 234524),
(275739, '1r5bA03', NULL, NULL, 110, NULL, NULL, 234524),
(275740, '6b8dA02', NULL, NULL, 112, NULL, NULL, 234524),
(275741, '1r5bA02', NULL, NULL, 89, NULL, NULL, 234524),
(275742, '6n0iB02', NULL, NULL, 116, NULL, NULL, 234524),
(275743, '1qfjA01', NULL, NULL, 97, NULL, NULL, 234524),
(275744, '5vh6A02', NULL, NULL, 121, NULL, NULL, 234524),
(275745, '1krhA02', NULL, NULL, 97, NULL, NULL, 234524),
(275746, '5w7qA02', NULL, NULL, 82, NULL, NULL, 234524),
(275747, '3mcaA03', NULL, NULL, 102, NULL, NULL, 234524),
(275748, '3mcaA01', NULL, NULL, 118, NULL, NULL, 234524),
(275749, '4pc3A03', NULL, NULL, 93, NULL, NULL, 234524),
(275750, '1vq8B02', NULL, NULL, 137, NULL, NULL, 234524),
(275751, '1gvhA02', NULL, NULL, 106, NULL, NULL, 234524),
(275752, '4pc3A02', NULL, NULL, 95, NULL, NULL, 234524),
(275753, '2r6hA01', NULL, NULL, 148, NULL, NULL, 234524),
(275754, '1f60A03', NULL, NULL, 108, NULL, NULL, 234524),
(275755, '2xnjA01', NULL, NULL, 115, NULL, NULL, 234524),
(275756, '5thxA01', NULL, NULL, 104, NULL, NULL, 234524),
(275757, '5w7qA03', NULL, NULL, 93, NULL, NULL, 234524),
(275758, '1qx4A01', NULL, NULL, 106, NULL, NULL, 234524),
(275759, '3jvoA00', NULL, NULL, 108, NULL, NULL, 234525),
(275760, '5u7aA00', NULL, NULL, 212, NULL, NULL, 234526),
(275761, '5c17A00', NULL, NULL, 209, NULL, NULL, 234526),
(275762, '4oj5C04', NULL, NULL, 193, NULL, NULL, 234527),
(275763, '3c5nA00', NULL, NULL, 246, NULL, NULL, 234528),
(275764, '1i7eA00', NULL, NULL, 265, NULL, NULL, 234528),
(275765, '1s7mA03', NULL, NULL, 37, NULL, NULL, 234529),
(275766, '2jwgA00', NULL, NULL, 46, NULL, NULL, 234530),
(275767, '1vlyA03', NULL, NULL, 122, NULL, NULL, 234531),
(275768, '4e1pA00', NULL, NULL, 61, NULL, NULL, 234532),
(275769, '4abxC01', NULL, NULL, 82, NULL, NULL, 234533),
(275770, '5an3D00', NULL, NULL, 131, NULL, NULL, 234534),
(275771, '5bxdB00', NULL, NULL, 107, NULL, NULL, 234534),
(275772, '3fkcA00', NULL, NULL, 116, NULL, NULL, 234534),
(275773, '5ftaA00', NULL, NULL, 112, NULL, NULL, 234534),
(275774, '3ohuC01', NULL, NULL, 112, NULL, NULL, 234534),
(275775, '2vpkA00', NULL, NULL, 116, NULL, NULL, 234534),
(275776, '3drxE01', NULL, NULL, 76, NULL, NULL, 234534),
(275777, '3b84A00', NULL, NULL, 119, NULL, NULL, 234534),
(275778, '4uyiA00', NULL, NULL, 135, NULL, NULL, 234534),
(275779, '4crhA00', NULL, NULL, 104, NULL, NULL, 234534);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(275780, '5dafA00', NULL, NULL, 140, NULL, NULL, 234534),
(275781, '2p1mA00', NULL, NULL, 118, NULL, NULL, 234534),
(275782, '3htmC01', NULL, NULL, 111, NULL, NULL, 234534),
(275783, '3htmA01', NULL, NULL, 111, NULL, NULL, 234534),
(275784, '2p1qA00', NULL, NULL, 160, NULL, NULL, 234534),
(275785, '2if5A00', NULL, NULL, 120, NULL, NULL, 234534),
(275786, '1cs3A00', NULL, NULL, 116, NULL, NULL, 234534),
(275787, '1fs1B00', NULL, NULL, 141, NULL, NULL, 234534),
(275788, '2z8hA01', NULL, NULL, 131, NULL, NULL, 234534),
(275789, '6i5nC00', NULL, NULL, 97, NULL, NULL, 234534),
(275790, '1t1dA00', NULL, NULL, 100, NULL, NULL, 234534),
(275791, '1exbE00', NULL, NULL, 103, NULL, NULL, 234534),
(275792, '2i2rD01', NULL, NULL, 128, NULL, NULL, 234534),
(275793, '4hxiA01', NULL, NULL, 112, NULL, NULL, 234534),
(275794, '5zb2B00', NULL, NULL, 86, NULL, NULL, 234534),
(275795, '4u2nA01', NULL, NULL, 156, NULL, NULL, 234534),
(275796, '1nexA00', NULL, NULL, 169, NULL, NULL, 234534),
(275797, '3i3nA01', NULL, NULL, 150, NULL, NULL, 234534),
(275798, '2q81A00', NULL, NULL, 119, NULL, NULL, 234534),
(275799, '3kvtA00', NULL, NULL, 115, NULL, NULL, 234534),
(275800, '3lnmD01', NULL, NULL, 101, NULL, NULL, 234534),
(275801, '3hqiA02', NULL, NULL, 153, NULL, NULL, 234534),
(275802, '3drzA00', NULL, NULL, 107, NULL, NULL, 234534),
(275803, '3m5bA00', NULL, NULL, 119, NULL, NULL, 234534),
(275804, '2yy9A00', NULL, NULL, 116, NULL, NULL, 234534),
(275805, '2vkpB00', NULL, NULL, 109, NULL, NULL, 234534),
(275806, '1qdvA00', NULL, NULL, 99, NULL, NULL, 234534),
(275807, '6er1A00', NULL, NULL, 131, NULL, NULL, 234534),
(275808, '5bxhA00', NULL, NULL, 106, NULL, NULL, 234534),
(275809, '4eozA00', NULL, NULL, 118, NULL, NULL, 234534),
(275810, '4u2mA01', NULL, NULL, 155, NULL, NULL, 234534),
(275811, '3e4uF00', NULL, NULL, 130, NULL, NULL, 234534),
(275812, '4u2mA02', NULL, NULL, 101, NULL, NULL, 234534),
(275813, '2ihcB01', NULL, NULL, 114, NULL, NULL, 234534),
(275814, '2ppiA01', NULL, NULL, 116, NULL, NULL, 234534),
(275815, '3htmD01', NULL, NULL, 111, NULL, NULL, 234534),
(275816, '4yy8B01', NULL, NULL, 90, NULL, NULL, 234534),
(275817, '3htmB01', NULL, NULL, 111, NULL, NULL, 234534),
(275818, '5a6rA00', NULL, NULL, 103, NULL, NULL, 234534),
(275819, '1r29A00', NULL, NULL, 127, NULL, NULL, 234534),
(275820, '4bgcA00', NULL, NULL, 102, NULL, NULL, 234534),
(275821, '3ga1A00', NULL, NULL, 129, NULL, NULL, 234534),
(275822, '1nn7A00', NULL, NULL, 105, NULL, NULL, 234534),
(275823, '2p1pA00', NULL, NULL, 109, NULL, NULL, 234534),
(275824, '1s1gA00', NULL, NULL, 124, NULL, NULL, 234534),
(275825, '4u2nB02', NULL, NULL, 99, NULL, NULL, 234534),
(275826, '4j8zA01', NULL, NULL, 166, NULL, NULL, 234534),
(275827, '4uijA00', NULL, NULL, 105, NULL, NULL, 234534),
(275828, '2ovrA00', NULL, NULL, 149, NULL, NULL, 234534),
(275829, '6ocrE00', NULL, NULL, 113, NULL, NULL, 234534),
(275830, '4uelA02', NULL, NULL, 79, NULL, NULL, 234535),
(275831, '3ihrA02', NULL, NULL, 78, NULL, NULL, 234535),
(275832, '3mzkB03', NULL, NULL, 70, NULL, NULL, 234536),
(275833, '4dlqA03', NULL, NULL, 198, NULL, NULL, 234537),
(275834, '4dloA03', NULL, NULL, 186, NULL, NULL, 234537),
(275835, '3hr4C01', NULL, NULL, 39, NULL, NULL, 234538),
(275836, '3mvnA00', NULL, NULL, 137, NULL, NULL, 234539),
(275837, '4hv4A03', NULL, NULL, 167, NULL, NULL, 234539),
(275838, '4cvkA03', NULL, NULL, 133, NULL, NULL, 234539),
(275839, '1gg4A01', NULL, NULL, 141, NULL, NULL, 234539),
(275840, '3zl8A03', NULL, NULL, 149, NULL, NULL, 234539),
(275841, '3nrsA02', NULL, NULL, 135, NULL, NULL, 234539),
(275842, '4c12A03', NULL, NULL, 165, NULL, NULL, 234539),
(275843, '4qdiA03', NULL, NULL, 144, NULL, NULL, 234539),
(275844, '1e8cB03', NULL, NULL, 142, NULL, NULL, 234539),
(275845, '1j6uA03', NULL, NULL, 160, NULL, NULL, 234539),
(275846, '2f00A03', NULL, NULL, 167, NULL, NULL, 234539),
(275847, '3zm6A03', NULL, NULL, 162, NULL, NULL, 234539),
(275848, '4bubA03', NULL, NULL, 170, NULL, NULL, 234539),
(275849, '2xjaD03', NULL, NULL, 160, NULL, NULL, 234539),
(275850, '4bucA03', NULL, NULL, 136, NULL, NULL, 234539);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(275851, '1p3dA03', NULL, NULL, 152, NULL, NULL, 234539),
(275852, '3lk7A03', NULL, NULL, 134, NULL, NULL, 234539),
(275853, '1jbwA02', NULL, NULL, 130, NULL, NULL, 234539),
(275854, '3hn7A03', NULL, NULL, 148, NULL, NULL, 234539),
(275855, '1o5zA02', NULL, NULL, 137, NULL, NULL, 234539),
(275856, '1w78A02', NULL, NULL, 135, NULL, NULL, 234539),
(275857, '2x5oA03', NULL, NULL, 135, NULL, NULL, 234539),
(275858, '2vosA02', NULL, NULL, 151, NULL, NULL, 234539),
(275859, '3errA01', NULL, NULL, 210, NULL, NULL, 234540),
(275860, '5grqA00', NULL, NULL, 90, NULL, NULL, 234541),
(275861, '2qdjA03', NULL, NULL, 151, NULL, NULL, 234542),
(275862, '3gi7A00', NULL, NULL, 122, NULL, NULL, 234543),
(275863, '2xocA01', NULL, NULL, 105, NULL, NULL, 234544),
(275864, '5a0yC00', NULL, NULL, 249, NULL, NULL, 234545),
(275865, '5a8wC00', NULL, NULL, 265, NULL, NULL, 234545),
(275866, '1e6vC00', NULL, NULL, 258, NULL, NULL, 234545),
(275867, '1e6yC00', NULL, NULL, 247, NULL, NULL, 234545),
(275868, '5n1qC00', NULL, NULL, 261, NULL, NULL, 234545),
(275869, '5n28F00', NULL, NULL, 260, NULL, NULL, 234545),
(275870, '3sqgC00', NULL, NULL, 279, NULL, NULL, 234545),
(275871, '3r1jA00', NULL, NULL, 301, NULL, NULL, 234546),
(275872, '2q4aA00', NULL, NULL, 330, NULL, NULL, 234546),
(275873, '4c5wA02', NULL, NULL, 290, NULL, NULL, 234546),
(275874, '4oj8B00', NULL, NULL, 272, NULL, NULL, 234546),
(275875, '2wbqA00', NULL, NULL, 338, NULL, NULL, 234546),
(275876, '2og5A00', NULL, NULL, 324, NULL, NULL, 234546),
(275877, '1ds1A00', NULL, NULL, 324, NULL, NULL, 234546),
(275878, '5j92B00', NULL, NULL, 278, NULL, NULL, 234546),
(275879, '4m23B00', NULL, NULL, 336, NULL, NULL, 234546),
(275880, '5vn6A00', NULL, NULL, 290, NULL, NULL, 234546),
(275881, '1oihB00', NULL, NULL, 301, NULL, NULL, 234546),
(275882, '4y0eB00', NULL, NULL, 315, NULL, NULL, 234546),
(275883, '6dawB00', NULL, NULL, 342, NULL, NULL, 234546),
(275884, '6d3hM00', NULL, NULL, 295, NULL, NULL, 234546),
(275885, '1otjA00', NULL, NULL, 283, NULL, NULL, 234546),
(275886, '5hsxB00', NULL, NULL, 305, NULL, NULL, 234546),
(275887, '4cvyA00', NULL, NULL, 295, NULL, NULL, 234546),
(275888, '6d1oH00', NULL, NULL, 301, NULL, NULL, 234546),
(275889, '1jr7A00', NULL, NULL, 311, NULL, NULL, 234546),
(275890, '4ylmX00', NULL, NULL, 293, NULL, NULL, 234546),
(275891, '3swtB00', NULL, NULL, 302, NULL, NULL, 234546),
(275892, '4j5iB00', NULL, NULL, 304, NULL, NULL, 234546),
(275893, '6d0oD00', NULL, NULL, 301, NULL, NULL, 234546),
(275894, '5keuB00', NULL, NULL, 306, NULL, NULL, 234546),
(275895, '3pvjB00', NULL, NULL, 277, NULL, NULL, 234546),
(275896, '4d6wA03', NULL, NULL, 95, NULL, NULL, 234547),
(275897, '5i2mA03', NULL, NULL, 93, NULL, NULL, 234547),
(275898, '4eyyQ02', NULL, NULL, 117, NULL, NULL, 234548),
(275899, '3rrkA02', NULL, NULL, 155, NULL, NULL, 234549),
(275900, '2nydA02', NULL, NULL, 46, NULL, NULL, 234550),
(275901, '3dd7C00', NULL, NULL, 135, NULL, NULL, 234551),
(275902, '2xc8A00', NULL, NULL, 121, NULL, NULL, 234552),
(275903, '2bw2A02', NULL, NULL, 78, NULL, NULL, 234553),
(275904, '3a6mA02', NULL, NULL, 63, NULL, NULL, 234554),
(275905, '1dkgB02', NULL, NULL, 57, NULL, NULL, 234554),
(275906, '3wttB00', NULL, NULL, 142, NULL, NULL, 234555),
(275907, '1e50B00', NULL, NULL, 134, NULL, NULL, 234555),
(275908, '3aqbA00', NULL, NULL, 147, NULL, NULL, 234556),
(275909, '4wkzA02', NULL, NULL, 122, NULL, NULL, 234557),
(275910, '4uyqB00', NULL, NULL, 75, NULL, NULL, 234557),
(275911, '4uypB00', NULL, NULL, 75, NULL, NULL, 234557),
(275912, '2cclB00', NULL, NULL, 63, NULL, NULL, 234557),
(275913, '3kcpA03', NULL, NULL, 69, NULL, NULL, 234557),
(275914, '5m0yB02', NULL, NULL, 62, NULL, NULL, 234557),
(275915, '5nrkD00', NULL, NULL, 68, NULL, NULL, 234557),
(275916, '5lxvB00', NULL, NULL, 65, NULL, NULL, 234557),
(275917, '2vn5B00', NULL, NULL, 66, NULL, NULL, 234557),
(275918, '4u3sB02', NULL, NULL, 62, NULL, NULL, 234557),
(275919, '2vn6B00', NULL, NULL, 64, NULL, NULL, 234557),
(275920, '4fl4G00', NULL, NULL, 68, NULL, NULL, 234557),
(275921, '2y3nB00', NULL, NULL, 71, NULL, NULL, 234557);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(275922, '4dh2D00', NULL, NULL, 82, NULL, NULL, 234557),
(275923, '5nrmB00', NULL, NULL, 66, NULL, NULL, 234557),
(275924, '3ul4B00', NULL, NULL, 65, NULL, NULL, 234557),
(275925, '2oznB02', NULL, NULL, 59, NULL, NULL, 234557),
(275926, '2mteA00', NULL, NULL, 69, NULL, NULL, 234557),
(275927, '1nnxA00', NULL, NULL, 109, NULL, NULL, 234558),
(275928, '2zjsE00', NULL, NULL, 60, NULL, NULL, 234559),
(275929, '1s5jA03', NULL, NULL, 161, NULL, NULL, 234560),
(275930, '1d5aA03', NULL, NULL, 164, NULL, NULL, 234560),
(275931, '3qexA03', NULL, NULL, 243, NULL, NULL, 234560),
(275932, '5omvA03', NULL, NULL, 164, NULL, NULL, 234560),
(275933, '4ahcB03', NULL, NULL, 185, NULL, NULL, 234560),
(275934, '2py5A02', NULL, NULL, 179, NULL, NULL, 234560),
(275935, '4fxdA05', NULL, NULL, 117, NULL, NULL, 234560),
(275936, '3k59A04', NULL, NULL, 211, NULL, NULL, 234560),
(275937, '2gv9B04', NULL, NULL, 197, NULL, NULL, 234560),
(275938, '1tgoA03', NULL, NULL, 185, NULL, NULL, 234560),
(275939, '4fxdA04', NULL, NULL, 153, NULL, NULL, 234560),
(275940, '4flwA03', NULL, NULL, 164, NULL, NULL, 234560),
(275941, '5h12A03', NULL, NULL, 185, NULL, NULL, 234560),
(275942, '4fvmA05', NULL, NULL, 178, NULL, NULL, 234560),
(275943, '6q4tA03', NULL, NULL, 164, NULL, NULL, 234560),
(275944, '2llzA01', NULL, NULL, 90, NULL, NULL, 234561),
(275945, '2b5uA03', NULL, NULL, 98, NULL, NULL, 234562),
(275946, '4kp2A01', NULL, NULL, 271, NULL, NULL, 234563),
(275947, '2b3yA01', NULL, NULL, 239, NULL, NULL, 234563),
(275948, '4kp2A02', NULL, NULL, 146, NULL, NULL, 234563),
(275949, '4kp1A01', NULL, NULL, 271, NULL, NULL, 234563),
(275950, '2b3yA03', NULL, NULL, 224, NULL, NULL, 234563),
(275951, '4kp1A02', NULL, NULL, 148, NULL, NULL, 234563),
(275952, '1c96A03', NULL, NULL, 175, NULL, NULL, 234563),
(275953, '3snpA02', NULL, NULL, 254, NULL, NULL, 234563),
(275954, '1l5jA04', NULL, NULL, 128, NULL, NULL, 234563),
(275955, '3snpA01', NULL, NULL, 367, NULL, NULL, 234563),
(275956, '1l5jA05', NULL, NULL, 183, NULL, NULL, 234563),
(275957, '1c96A01', NULL, NULL, 201, NULL, NULL, 234563),
(275958, '1mngA02', NULL, NULL, 112, NULL, NULL, 234564),
(275959, '4yioA02', NULL, NULL, 119, NULL, NULL, 234564),
(275960, '1pl4A02', NULL, NULL, 116, NULL, NULL, 234564),
(275961, '1b06A02', NULL, NULL, 118, NULL, NULL, 234564),
(275962, '4e4eA02', NULL, NULL, 118, NULL, NULL, 234564),
(275963, '1idsA02', NULL, NULL, 123, NULL, NULL, 234564),
(275964, '1ma1A02', NULL, NULL, 116, NULL, NULL, 234564),
(275965, '6ex5A02', NULL, NULL, 110, NULL, NULL, 234564),
(275966, '1wb7A02', NULL, NULL, 118, NULL, NULL, 234564),
(275967, '4e4eC02', NULL, NULL, 118, NULL, NULL, 234564),
(275968, '4e4eB02', NULL, NULL, 118, NULL, NULL, 234564),
(275969, '4br6B02', NULL, NULL, 115, NULL, NULL, 234564),
(275970, '4ffkA02', NULL, NULL, 123, NULL, NULL, 234564),
(275971, '4e4eD02', NULL, NULL, 118, NULL, NULL, 234564),
(275972, '6elkA02', NULL, NULL, 112, NULL, NULL, 234564),
(275973, '3lsuD02', NULL, NULL, 118, NULL, NULL, 234564),
(275974, '6bejA02', NULL, NULL, 114, NULL, NULL, 234564),
(275975, '3lsuC02', NULL, NULL, 118, NULL, NULL, 234564),
(275976, '2rcvA02', NULL, NULL, 112, NULL, NULL, 234564),
(275977, '3lsuB02', NULL, NULL, 118, NULL, NULL, 234564),
(275978, '3lsuA02', NULL, NULL, 118, NULL, NULL, 234564),
(275979, '1xuqA02', NULL, NULL, 112, NULL, NULL, 234564),
(275980, '1p7gH02', NULL, NULL, 124, NULL, NULL, 234564),
(275981, '3ceiB02', NULL, NULL, 132, NULL, NULL, 234564),
(275982, '4gunA02', NULL, NULL, 118, NULL, NULL, 234564),
(275983, '1y67C02', NULL, NULL, 131, NULL, NULL, 234564),
(275984, '3tjtA02', NULL, NULL, 115, NULL, NULL, 234564),
(275985, '5tirB02', NULL, NULL, 126, NULL, NULL, 234564),
(275986, '1xreA02', NULL, NULL, 117, NULL, NULL, 234564),
(275987, '4c7uB02', NULL, NULL, 120, NULL, NULL, 234564),
(275988, '1kkcA02', NULL, NULL, 125, NULL, NULL, 234564),
(275989, '1xilA02', NULL, NULL, 116, NULL, NULL, 234564),
(275990, '5x2jA02', NULL, NULL, 110, NULL, NULL, 234564),
(275991, '5n56A02', NULL, NULL, 110, NULL, NULL, 234564),
(275992, '1bsmA02', NULL, NULL, 118, NULL, NULL, 234564);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(275993, '3kkyA02', NULL, NULL, 122, NULL, NULL, 234564),
(275994, '4yipA02', NULL, NULL, 121, NULL, NULL, 234564),
(275995, '3ak2C02', NULL, NULL, 127, NULL, NULL, 234564),
(275996, '3dc6A02', NULL, NULL, 115, NULL, NULL, 234564),
(275997, '3rn4A02', NULL, NULL, 118, NULL, NULL, 234564),
(275998, '6gscA02', NULL, NULL, 117, NULL, NULL, 234564),
(275999, '1jr9A02', NULL, NULL, 112, NULL, NULL, 234564),
(276000, '4f6eA02', NULL, NULL, 118, NULL, NULL, 234564),
(276001, '4f6eB02', NULL, NULL, 118, NULL, NULL, 234564),
(276002, '4f6eC02', NULL, NULL, 118, NULL, NULL, 234564),
(276003, '1ix9A02', NULL, NULL, 116, NULL, NULL, 234564),
(276004, '4f6eD02', NULL, NULL, 118, NULL, NULL, 234564),
(276005, '3i9v101', NULL, NULL, 61, NULL, NULL, 234565),
(276006, '3t7aA01', NULL, NULL, 128, NULL, NULL, 234566),
(276007, '2aj4A02', NULL, NULL, 95, NULL, NULL, 234567),
(276008, '3v2uC02', NULL, NULL, 95, NULL, NULL, 234567),
(276009, '2a2cA02', NULL, NULL, 93, NULL, NULL, 234567),
(276010, '4r3jA01', NULL, NULL, 105, NULL, NULL, 234568),
(276011, '4mnrA01', NULL, NULL, 93, NULL, NULL, 234568),
(276012, '4ovdA01', NULL, NULL, 102, NULL, NULL, 234568),
(276013, '1k25A01', NULL, NULL, 77, NULL, NULL, 234568),
(276014, '3oc2A01', NULL, NULL, 173, NULL, NULL, 234568),
(276015, '4r23A01', NULL, NULL, 91, NULL, NULL, 234568),
(276016, '1vqqA02', NULL, NULL, 121, NULL, NULL, 234568),
(276017, '1k25B01', NULL, NULL, 164, NULL, NULL, 234568),
(276018, '5u47A02', NULL, NULL, 68, NULL, NULL, 234568),
(276019, '3equA01', NULL, NULL, 105, NULL, NULL, 234568),
(276020, '1k25D01', NULL, NULL, 125, NULL, NULL, 234568),
(276021, '3eqvA01', NULL, NULL, 129, NULL, NULL, 234568),
(276022, '1pyyA01', NULL, NULL, 87, NULL, NULL, 234568),
(276023, '2wadA02', NULL, NULL, 148, NULL, NULL, 234568),
(276024, '2wafA01', NULL, NULL, 177, NULL, NULL, 234568),
(276025, '3vskA01', NULL, NULL, 133, NULL, NULL, 234568),
(276026, '1qmeA01', NULL, NULL, 117, NULL, NULL, 234568),
(276027, '2z2mD01', NULL, NULL, 59, NULL, NULL, 234568),
(276028, '3lo7B01', NULL, NULL, 116, NULL, NULL, 234568),
(276029, '3ue3A01', NULL, NULL, 119, NULL, NULL, 234568),
(276030, '3lo7A01', NULL, NULL, 130, NULL, NULL, 234568),
(276031, '2zc3D01', NULL, NULL, 78, NULL, NULL, 234568),
(276032, '3c2qA01', NULL, NULL, 90, NULL, NULL, 234569),
(276033, '2pkeA02', NULL, NULL, 83, NULL, NULL, 234570),
(276034, '3u26A02', NULL, NULL, 83, NULL, NULL, 234570),
(276035, '2b0cA02', NULL, NULL, 66, NULL, NULL, 234570),
(276036, '3sd7A02', NULL, NULL, 66, NULL, NULL, 234570),
(276037, '4uasA02', NULL, NULL, 77, NULL, NULL, 234570),
(276038, '1qq5A02', NULL, NULL, 75, NULL, NULL, 234570),
(276039, '4gibA02', NULL, NULL, 79, NULL, NULL, 234570),
(276040, '3iruA02', NULL, NULL, 78, NULL, NULL, 234570),
(276041, '4g9bA02', NULL, NULL, 79, NULL, NULL, 234570),
(276042, '3ed5A02', NULL, NULL, 84, NULL, NULL, 234570),
(276043, '4uw9A02', NULL, NULL, 83, NULL, NULL, 234570),
(276044, '3e58A02', NULL, NULL, 66, NULL, NULL, 234570),
(276045, '2ymmA02', NULL, NULL, 73, NULL, NULL, 234570),
(276046, '1cqzB02', NULL, NULL, 80, NULL, NULL, 234570),
(276047, '2hcfA02', NULL, NULL, 68, NULL, NULL, 234570),
(276048, '2no4A02', NULL, NULL, 75, NULL, NULL, 234570),
(276049, '4ex6A02', NULL, NULL, 67, NULL, NULL, 234570),
(276050, '3s6jA02', NULL, NULL, 69, NULL, NULL, 234570),
(276051, '3um9A02', NULL, NULL, 75, NULL, NULL, 234570),
(276052, '3kbbA02', NULL, NULL, 70, NULL, NULL, 234570),
(276053, '2qltA02', NULL, NULL, 62, NULL, NULL, 234570),
(276054, '1swvA02', NULL, NULL, 78, NULL, NULL, 234570),
(276055, '3l5kA02', NULL, NULL, 68, NULL, NULL, 234570),
(276056, '3cnhB02', NULL, NULL, 68, NULL, NULL, 234570),
(276057, '3d6jA02', NULL, NULL, 67, NULL, NULL, 234570),
(276058, '3dv9A02', NULL, NULL, 70, NULL, NULL, 234570),
(276059, '3s6jC02', NULL, NULL, 69, NULL, NULL, 234570),
(276060, '3s6jE02', NULL, NULL, 69, NULL, NULL, 234570),
(276061, '3umcD02', NULL, NULL, 82, NULL, NULL, 234570),
(276062, '3ddhA02', NULL, NULL, 81, NULL, NULL, 234570),
(276063, '2w43A02', NULL, NULL, 57, NULL, NULL, 234570); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(276064, '2fi1A02', NULL, NULL, 64, NULL, NULL, 234570),
(276065, '1zrnA02', NULL, NULL, 75, NULL, NULL, 234570),
(276066, '2nyvA02', NULL, NULL, 64, NULL, NULL, 234570),
(276067, '2hdoA02', NULL, NULL, 64, NULL, NULL, 234570),
(276068, '2hi0A02', NULL, NULL, 89, NULL, NULL, 234570),
(276069, '3nasA02', NULL, NULL, 79, NULL, NULL, 234570),
(276070, '2wf7A02', NULL, NULL, 78, NULL, NULL, 234570),
(276071, '4eekA02', NULL, NULL, 66, NULL, NULL, 234570),
(276072, '3mc1A02', NULL, NULL, 67, NULL, NULL, 234570),
(276073, '2ah5A02', NULL, NULL, 65, NULL, NULL, 234570),
(276074, '1te2A02', NULL, NULL, 72, NULL, NULL, 234570),
(276075, '3umbA02', NULL, NULL, 79, NULL, NULL, 234570),
(276076, '2mu2A00', NULL, NULL, 86, NULL, NULL, 234570),
(276077, '3s6jF02', NULL, NULL, 69, NULL, NULL, 234570),
(276078, '3umgA02', NULL, NULL, 71, NULL, NULL, 234570),
(276079, '3qnmA02', NULL, NULL, 90, NULL, NULL, 234570),
(276080, '1x42A02', NULL, NULL, 83, NULL, NULL, 234570),
(276081, '3s6jB02', NULL, NULL, 69, NULL, NULL, 234570),
(276082, '4uavA02', NULL, NULL, 85, NULL, NULL, 234570),
(276083, '2go7A02', NULL, NULL, 67, NULL, NULL, 234570),
(276084, '3s6jD02', NULL, NULL, 69, NULL, NULL, 234570),
(276085, '5am2A02', NULL, NULL, 80, NULL, NULL, 234570),
(276086, '2fdrA02', NULL, NULL, 67, NULL, NULL, 234570),
(276087, '4dccA02', NULL, NULL, 74, NULL, NULL, 234570),
(276088, '2hszA02', NULL, NULL, 75, NULL, NULL, 234570),
(276089, '3qu5A02', NULL, NULL, 70, NULL, NULL, 234570),
(276090, '4jb3A02', NULL, NULL, 72, NULL, NULL, 234570),
(276091, '2i6xA02', NULL, NULL, 74, NULL, NULL, 234570),
(276092, '4mt2A00', NULL, NULL, 62, NULL, NULL, 234571),
(276093, '3os4A00', NULL, NULL, 407, NULL, NULL, 234572),
(276094, '4hl7A00', NULL, NULL, 428, NULL, NULL, 234572),
(276095, '1ybeB01', NULL, NULL, 416, NULL, NULL, 234572),
(276096, '1vlpD00', NULL, NULL, 441, NULL, NULL, 234572),
(276097, '1yirA00', NULL, NULL, 408, NULL, NULL, 234572),
(276098, '4mzyA01', NULL, NULL, 326, NULL, NULL, 234572),
(276099, '4yubB01', NULL, NULL, 310, NULL, NULL, 234572),
(276100, '2im5A00', NULL, NULL, 394, NULL, NULL, 234572),
(276101, '2uvaG12', NULL, NULL, 128, NULL, NULL, 234573),
(276102, '2uv8G12', NULL, NULL, 128, NULL, NULL, 234573),
(276103, '2xqhA02', NULL, NULL, 56, NULL, NULL, 234574),
(276104, '2w7qB00', NULL, NULL, 185, NULL, NULL, 234575),
(276105, '4ki3I00', NULL, NULL, 184, NULL, NULL, 234575),
(276106, '3m4wC01', NULL, NULL, 186, NULL, NULL, 234575),
(276107, '4mxtA00', NULL, NULL, 190, NULL, NULL, 234575),
(276108, '1iwlA00', NULL, NULL, 182, NULL, NULL, 234575),
(276109, '3wjtA00', NULL, NULL, 178, NULL, NULL, 234575),
(276110, '2yzyA00', NULL, NULL, 200, NULL, NULL, 234575),
(276111, '3buuB00', NULL, NULL, 229, NULL, NULL, 234575),
(276112, '3bk5A00', NULL, NULL, 237, NULL, NULL, 234575),
(276113, '4z48A00', NULL, NULL, 246, NULL, NULL, 234575),
(276114, '3vm9A01', NULL, NULL, 96, NULL, NULL, 234576),
(276115, '3alrB00', NULL, NULL, 72, NULL, NULL, 234577),
(276116, '5kl1B00', NULL, NULL, 70, NULL, NULL, 234577),
(276117, '4gysA02', NULL, NULL, 73, NULL, NULL, 234578),
(276118, '4issA02', NULL, NULL, 76, NULL, NULL, 234578),
(276119, '3ssoA01', NULL, NULL, 154, NULL, NULL, 234579),
(276120, '4griA05', NULL, NULL, 108, NULL, NULL, 234580),
(276121, '1irxA05', NULL, NULL, 93, NULL, NULL, 234580),
(276122, '2cfoA05', NULL, NULL, 112, NULL, NULL, 234580),
(276123, '1j09A05', NULL, NULL, 98, NULL, NULL, 234580),
(276124, '3afhA05', NULL, NULL, 106, NULL, NULL, 234580),
(276125, '5tgtA02', NULL, NULL, 124, NULL, NULL, 234580),
(276126, '2ja2A05', NULL, NULL, 111, NULL, NULL, 234580),
(276127, '2o5rA05', NULL, NULL, 93, NULL, NULL, 234580),
(276128, '2jkgA00', NULL, NULL, 179, NULL, NULL, 234581),
(276129, '3cptB00', NULL, NULL, 131, NULL, NULL, 234581),
(276130, '1pneA00', NULL, NULL, 140, NULL, NULL, 234581),
(276131, '5fdsA00', NULL, NULL, 131, NULL, NULL, 234581),
(276132, '2hz5A00', NULL, NULL, 106, NULL, NULL, 234581),
(276133, '1d1jB00', NULL, NULL, 139, NULL, NULL, 234581),
(276134, '3kyeB00', NULL, NULL, 128, NULL, NULL, 234581);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(276135, '4qwoB00', NULL, NULL, 132, NULL, NULL, 234581),
(276136, '4espA00', NULL, NULL, 130, NULL, NULL, 234581),
(276137, '5em1A00', NULL, NULL, 135, NULL, NULL, 234581),
(276138, '1acfA00', NULL, NULL, 125, NULL, NULL, 234581),
(276139, '2v8fA00', NULL, NULL, 140, NULL, NULL, 234581),
(276140, '1j3wC00', NULL, NULL, 138, NULL, NULL, 234581),
(276141, '4ftxB01', NULL, NULL, 140, NULL, NULL, 234581),
(276142, '5ev0B00', NULL, NULL, 134, NULL, NULL, 234581),
(276143, '1f2kA00', NULL, NULL, 125, NULL, NULL, 234581),
(276144, '5nzbA00', NULL, NULL, 132, NULL, NULL, 234581),
(276145, '1y4oA00', NULL, NULL, 104, NULL, NULL, 234581),
(276146, '3ms6A00', NULL, NULL, 99, NULL, NULL, 234581),
(276147, '3t1sA00', NULL, NULL, 136, NULL, NULL, 234581),
(276148, '3d9yA00', NULL, NULL, 127, NULL, NULL, 234581),
(276149, '3leqA00', NULL, NULL, 126, NULL, NULL, 234581),
(276150, '6b9xB00', NULL, NULL, 126, NULL, NULL, 234581),
(276151, '5em0A00', NULL, NULL, 135, NULL, NULL, 234581),
(276152, '5fefA00', NULL, NULL, 132, NULL, NULL, 234581),
(276153, '3necA00', NULL, NULL, 166, NULL, NULL, 234581),
(276154, '3l7hB00', NULL, NULL, 97, NULL, NULL, 234581),
(276155, '2pbdP00', NULL, NULL, 139, NULL, NULL, 234581),
(276156, '3nulA00', NULL, NULL, 130, NULL, NULL, 234581),
(276157, '6b9xE00', NULL, NULL, 91, NULL, NULL, 234581),
(276158, '1yprA00', NULL, NULL, 125, NULL, NULL, 234581),
(276159, '6b9xC00', NULL, NULL, 124, NULL, NULL, 234581),
(276160, '1g5uA00', NULL, NULL, 131, NULL, NULL, 234581),
(276161, '1veuB00', NULL, NULL, 126, NULL, NULL, 234581),
(276162, '5mmiO00', NULL, NULL, 126, NULL, NULL, 234582),
(276163, '5v7qN00', NULL, NULL, 117, NULL, NULL, 234582),
(276164, '6hmaL00', NULL, NULL, 120, NULL, NULL, 234582),
(276165, '1gd8A00', NULL, NULL, 118, NULL, NULL, 234582),
(276166, '2cqmA01', NULL, NULL, 108, NULL, NULL, 234582),
(276167, '6qulO01', NULL, NULL, 104, NULL, NULL, 234582),
(276168, '1vw4L01', NULL, NULL, 136, NULL, NULL, 234582),
(276169, '5dm6K00', NULL, NULL, 113, NULL, NULL, 234582),
(276170, '5xymN00', NULL, NULL, 117, NULL, NULL, 234582),
(276171, '1gnlA01', NULL, NULL, 139, NULL, NULL, 234583),
(276172, '1gnlA02', NULL, NULL, 84, NULL, NULL, 234583),
(276173, '1gntA01', NULL, NULL, 139, NULL, NULL, 234583),
(276174, '1gntA02', NULL, NULL, 84, NULL, NULL, 234583),
(276175, '5z62G00', NULL, NULL, 75, NULL, NULL, 234584),
(276176, '5b1aG00', NULL, NULL, 85, NULL, NULL, 234584),
(276177, '2p62A02', NULL, NULL, 93, NULL, NULL, 234585),
(276178, '3p42D01', NULL, NULL, 92, NULL, NULL, 234586),
(276179, '1opaA00', NULL, NULL, 134, NULL, NULL, 234587),
(276180, '1n0sA00', NULL, NULL, 184, NULL, NULL, 234587),
(276181, '2fwvA00', NULL, NULL, 200, NULL, NULL, 234587),
(276182, '3zuiA00', NULL, NULL, 150, NULL, NULL, 234587),
(276183, '3apuB00', NULL, NULL, 174, NULL, NULL, 234587),
(276184, '5n48C00', NULL, NULL, 188, NULL, NULL, 234587),
(276185, '1yupE00', NULL, NULL, 162, NULL, NULL, 234587),
(276186, '1kqwA00', NULL, NULL, 134, NULL, NULL, 234587),
(276187, '2o62A02', NULL, NULL, 137, NULL, NULL, 234587),
(276188, '3bx8F00', NULL, NULL, 178, NULL, NULL, 234587),
(276189, '2hlvA00', NULL, NULL, 160, NULL, NULL, 234587),
(276190, '2o62A01', NULL, NULL, 133, NULL, NULL, 234587),
(276191, '1pmpA00', NULL, NULL, 131, NULL, NULL, 234587),
(276192, '3nadB00', NULL, NULL, 161, NULL, NULL, 234587),
(276193, '1ew3A00', NULL, NULL, 159, NULL, NULL, 234587),
(276194, '5xm5A00', NULL, NULL, 193, NULL, NULL, 234587),
(276195, '2ra6C00', NULL, NULL, 143, NULL, NULL, 234587),
(276196, '2k23A00', NULL, NULL, 178, NULL, NULL, 234587),
(276197, '5bvqA00', NULL, NULL, 132, NULL, NULL, 234587),
(276198, '4a60A00', NULL, NULL, 154, NULL, NULL, 234587),
(276199, '1dzkA00', NULL, NULL, 157, NULL, NULL, 234587),
(276200, '6gqzA00', NULL, NULL, 174, NULL, NULL, 234587),
(276201, '2yg2B00', NULL, NULL, 172, NULL, NULL, 234587),
(276202, '4ykoA00', NULL, NULL, 137, NULL, NULL, 234587),
(276203, '1avgI00', NULL, NULL, 142, NULL, NULL, 234587),
(276204, '2g7bA00', NULL, NULL, 137, NULL, NULL, 234587),
(276205, '1lfoA00', NULL, NULL, 128, NULL, NULL, 234587);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(276206, '1pm1X00', NULL, NULL, 180, NULL, NULL, 234587),
(276207, '1xkiA00', NULL, NULL, 146, NULL, NULL, 234587),
(276208, '4boeA00', NULL, NULL, 160, NULL, NULL, 234587),
(276209, '2w2aA00', NULL, NULL, 177, NULL, NULL, 234587),
(276210, '4nyqA00', NULL, NULL, 164, NULL, NULL, 234587),
(276211, '4zhcB00', NULL, NULL, 180, NULL, NULL, 234587),
(276212, '2gc9B00', NULL, NULL, 160, NULL, NULL, 234587),
(276213, '5n47E00', NULL, NULL, 188, NULL, NULL, 234587),
(276214, '1bwyA00', NULL, NULL, 132, NULL, NULL, 234587),
(276215, '6c1zA00', NULL, NULL, 138, NULL, NULL, 234587),
(276216, '1kt6A00', NULL, NULL, 183, NULL, NULL, 234587),
(276217, '1lf7A00', NULL, NULL, 182, NULL, NULL, 234587),
(276218, '5l8iB00', NULL, NULL, 128, NULL, NULL, 234587),
(276219, '2n93A00', NULL, NULL, 130, NULL, NULL, 234587),
(276220, '4ymyA00', NULL, NULL, 153, NULL, NULL, 234587),
(276221, '3dszA00', NULL, NULL, 186, NULL, NULL, 234587),
(276222, '2hzrA00', NULL, NULL, 174, NULL, NULL, 234587),
(276223, '2ftbA00', NULL, NULL, 125, NULL, NULL, 234587),
(276224, '3ebkB00', NULL, NULL, 176, NULL, NULL, 234587),
(276225, '3bdrA00', NULL, NULL, 190, NULL, NULL, 234587),
(276226, '4bvmA00', NULL, NULL, 133, NULL, NULL, 234587),
(276227, '4tkbA00', NULL, NULL, 133, NULL, NULL, 234587),
(276228, '4gkcA00', NULL, NULL, 133, NULL, NULL, 234587),
(276229, '4gnyA00', NULL, NULL, 162, NULL, NULL, 234587),
(276230, '5bvtA00', NULL, NULL, 134, NULL, NULL, 234587),
(276231, '1tvqA00', NULL, NULL, 125, NULL, NULL, 234587),
(276232, '4albA00', NULL, NULL, 161, NULL, NULL, 234587),
(276233, '1i4uB00', NULL, NULL, 181, NULL, NULL, 234587),
(276234, '4ck4A00', NULL, NULL, 162, NULL, NULL, 234587),
(276235, '3pptA00', NULL, NULL, 133, NULL, NULL, 234587),
(276236, '1epaA00', NULL, NULL, 164, NULL, NULL, 234587),
(276237, '4qaeC00', NULL, NULL, 188, NULL, NULL, 234587),
(276238, '2cztA00', NULL, NULL, 167, NULL, NULL, 234587),
(276239, '2nndA00', NULL, NULL, 178, NULL, NULL, 234587),
(276240, '1ftpA00', NULL, NULL, 133, NULL, NULL, 234587),
(276241, '4mvkA00', NULL, NULL, 188, NULL, NULL, 234587),
(276242, '3s26A00', NULL, NULL, 190, NULL, NULL, 234587),
(276243, '2fr2A00', NULL, NULL, 172, NULL, NULL, 234587),
(276244, '1exsA00', NULL, NULL, 160, NULL, NULL, 234587),
(276245, '5jr8A00', NULL, NULL, 178, NULL, NULL, 234587),
(276246, '1qftB00', NULL, NULL, 175, NULL, NULL, 234587),
(276247, '3mbtA00', NULL, NULL, 168, NULL, NULL, 234587),
(276248, '2l5pA00', NULL, NULL, 184, NULL, NULL, 234587),
(276249, '2a0aA00', NULL, NULL, 131, NULL, NULL, 234587),
(276250, '4uu3B00', NULL, NULL, 168, NULL, NULL, 234587),
(276251, '5x7yD00', NULL, NULL, 177, NULL, NULL, 234587),
(276252, '3vg7A00', NULL, NULL, 132, NULL, NULL, 234587),
(276253, '2rcqA00', NULL, NULL, 141, NULL, NULL, 234587),
(276254, '4runB00', NULL, NULL, 161, NULL, NULL, 234587),
(276255, '2qo5A00', NULL, NULL, 129, NULL, NULL, 234587),
(276256, '5nghA00', NULL, NULL, 168, NULL, NULL, 234587),
(276257, '2xstA00', NULL, NULL, 161, NULL, NULL, 234587),
(276258, '1lkeA00', NULL, NULL, 166, NULL, NULL, 234587),
(276259, '3brnA00', NULL, NULL, 157, NULL, NULL, 234587),
(276260, '3o22A00', NULL, NULL, 162, NULL, NULL, 234587),
(276261, '4iawC00', NULL, NULL, 188, NULL, NULL, 234587),
(276262, '1mdcA00', NULL, NULL, 132, NULL, NULL, 234587),
(276263, '1gm6A00', NULL, NULL, 165, NULL, NULL, 234587),
(276264, '4r0bA00', NULL, NULL, 169, NULL, NULL, 234587),
(276265, '3saoB01', NULL, NULL, 145, NULL, NULL, 234587),
(276266, '4i3bA00', NULL, NULL, 139, NULL, NULL, 234587),
(276267, '2jozA01', NULL, NULL, 96, NULL, NULL, 234587),
(276268, '1p6pA00', NULL, NULL, 125, NULL, NULL, 234587),
(276269, '5ggeA00', NULL, NULL, 130, NULL, NULL, 234587),
(276270, '5uraB00', NULL, NULL, 135, NULL, NULL, 234587),
(276271, '4xmeA00', NULL, NULL, 184, NULL, NULL, 234587),
(276272, '6at8A00', NULL, NULL, 137, NULL, NULL, 234587),
(276273, '5hbsA00', NULL, NULL, 140, NULL, NULL, 234587),
(276274, '1o8vA00', NULL, NULL, 134, NULL, NULL, 234587),
(276275, '5hz8A00', NULL, NULL, 135, NULL, NULL, 234587),
(276276, '4gh7A00', NULL, NULL, 188, NULL, NULL, 234587);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(276277, '1bbpA00', NULL, NULL, 173, NULL, NULL, 234587),
(276278, '2l9cA01', NULL, NULL, 155, NULL, NULL, 234587),
(276279, '4iaxA00', NULL, NULL, 188, NULL, NULL, 234587),
(276280, '5nu2A00', NULL, NULL, 182, NULL, NULL, 234587),
(276281, '1z24A00', NULL, NULL, 189, NULL, NULL, 234587),
(276282, '3ia8A00', NULL, NULL, 163, NULL, NULL, 234587),
(276283, '1r0uA00', NULL, NULL, 148, NULL, NULL, 234587),
(276284, '3l4rA00', NULL, NULL, 170, NULL, NULL, 234587),
(276285, '1vprA03', NULL, NULL, 157, NULL, NULL, 234587),
(276286, '1u17A00', NULL, NULL, 185, NULL, NULL, 234587),
(276287, '4oddB00', NULL, NULL, 158, NULL, NULL, 234587),
(276288, '3kzaA00', NULL, NULL, 162, NULL, NULL, 234587),
(276289, '5mhhA00', NULL, NULL, 188, NULL, NULL, 234587),
(276290, '1zndA00', NULL, NULL, 174, NULL, NULL, 234587),
(276291, '4mvlD00', NULL, NULL, 188, NULL, NULL, 234587),
(276292, '4es7A00', NULL, NULL, 166, NULL, NULL, 234587),
(276293, '5hz5A00', NULL, NULL, 134, NULL, NULL, 234587),
(276294, '4aw8A00', NULL, NULL, 186, NULL, NULL, 234587),
(276295, '3elxA00', NULL, NULL, 138, NULL, NULL, 234587),
(276296, '1ifcA00', NULL, NULL, 132, NULL, NULL, 234587),
(276297, '3zq3A00', NULL, NULL, 173, NULL, NULL, 234587),
(276298, '1yivA00', NULL, NULL, 131, NULL, NULL, 234587),
(276299, '4tq2A00', NULL, NULL, 189, NULL, NULL, 234587),
(276300, '1iiuA00', NULL, NULL, 174, NULL, NULL, 234587),
(276301, '2x46A00', NULL, NULL, 144, NULL, NULL, 234587),
(276302, '1crbA00', NULL, NULL, 134, NULL, NULL, 234587),
(276303, '1vyfA00', NULL, NULL, 135, NULL, NULL, 234587),
(276304, '1jzuA00', NULL, NULL, 157, NULL, NULL, 234587),
(276305, '3cqnB00', NULL, NULL, 185, NULL, NULL, 234587),
(276306, '3fiqA00', NULL, NULL, 157, NULL, NULL, 234587),
(276307, '1ealA00', NULL, NULL, 127, NULL, NULL, 234587),
(276308, '1gglA00', NULL, NULL, 134, NULL, NULL, 234587),
(276309, '1qwdB00', NULL, NULL, 177, NULL, NULL, 234587),
(276310, '3bs2A00', NULL, NULL, 148, NULL, NULL, 234587),
(276311, '1x8pA00', NULL, NULL, 184, NULL, NULL, 234587),
(276312, '1cbiA00', NULL, NULL, 136, NULL, NULL, 234587),
(276313, '5h9nA00', NULL, NULL, 156, NULL, NULL, 234587),
(276314, '4wfvA00', NULL, NULL, 156, NULL, NULL, 234587),
(276315, '3kffA00', NULL, NULL, 162, NULL, NULL, 234587),
(276316, '4azqA00', NULL, NULL, 138, NULL, NULL, 234587),
(276317, '3ebwA01', NULL, NULL, 148, NULL, NULL, 234587),
(276318, '3kq0A00', NULL, NULL, 175, NULL, NULL, 234587),
(276319, '4ge1C00', NULL, NULL, 197, NULL, NULL, 234587),
(276320, '2xklA00', NULL, NULL, 171, NULL, NULL, 234587),
(276321, '3akmA00', NULL, NULL, 131, NULL, NULL, 234587),
(276322, '5ez2A00', NULL, NULL, 183, NULL, NULL, 234587),
(276323, '2p8gA00', NULL, NULL, 162, NULL, NULL, 234587),
(276324, '1ab0A00', NULL, NULL, 131, NULL, NULL, 234587),
(276325, '1gkaB00', NULL, NULL, 174, NULL, NULL, 234587),
(276326, '5nknA00', NULL, NULL, 174, NULL, NULL, 234587),
(276327, '3p6dA00', NULL, NULL, 139, NULL, NULL, 234587),
(276328, '1g7nA00', NULL, NULL, 131, NULL, NULL, 234587),
(276329, '2a2uA00', NULL, NULL, 162, NULL, NULL, 234587),
(276330, '1e5pA00', NULL, NULL, 151, NULL, NULL, 234587),
(276331, '2lbaA00', NULL, NULL, 136, NULL, NULL, 234587),
(276332, '3cf2A06', NULL, NULL, 109, NULL, NULL, 234588),
(276333, '2rreA00', NULL, NULL, 78, NULL, NULL, 234589),
(276334, '2w6kA00', NULL, NULL, 145, NULL, NULL, 234590),
(276335, '3by5A00', NULL, NULL, 132, NULL, NULL, 234590),
(276336, '3eeqB03', NULL, NULL, 112, NULL, NULL, 234590),
(276337, '2l9bB00', NULL, NULL, 53, NULL, NULL, 234591),
(276338, '1z6mA02', NULL, NULL, 61, NULL, NULL, 234592),
(276339, '4bgoA00', NULL, NULL, 251, NULL, NULL, 234593),
(276340, '3pf0A00', NULL, NULL, 324, NULL, NULL, 234593),
(276341, '4ecgA00', NULL, NULL, 381, NULL, NULL, 234593),
(276342, '3wscA00', NULL, NULL, 258, NULL, NULL, 234593),
(276343, '4i4tF01', NULL, NULL, 63, NULL, NULL, 234594),
(276344, '3tigA01', NULL, NULL, 66, NULL, NULL, 234594),
(276345, '1hn6A00', NULL, NULL, 110, NULL, NULL, 234595),
(276346, '1a87A02', NULL, NULL, 200, NULL, NULL, 234596),
(276347, '1rh1A02', NULL, NULL, 221, NULL, NULL, 234596);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(276348, '3fewX04', NULL, NULL, 211, NULL, NULL, 234596),
(276349, '2i88A00', NULL, NULL, 191, NULL, NULL, 234596),
(276350, '1ciiA03', NULL, NULL, 157, NULL, NULL, 234596),
(276351, '1colA00', NULL, NULL, 204, NULL, NULL, 234596),
(276352, '1ftrA02', NULL, NULL, 149, NULL, NULL, 234597),
(276353, '1ftrA01', NULL, NULL, 147, NULL, NULL, 234597),
(276354, '1m5sA02', NULL, NULL, 146, NULL, NULL, 234597),
(276355, '1m5hA02', NULL, NULL, 146, NULL, NULL, 234597),
(276356, '1m5sA01', NULL, NULL, 151, NULL, NULL, 234597),
(276357, '1m5hA01', NULL, NULL, 151, NULL, NULL, 234597),
(276358, '2yqlA00', NULL, NULL, 56, NULL, NULL, 234598),
(276359, '2zetC00', NULL, NULL, 153, NULL, NULL, 234598),
(276360, '2lriC00', NULL, NULL, 66, NULL, NULL, 234598),
(276361, '3eb5A00', NULL, NULL, 74, NULL, NULL, 234598),
(276362, '2yurA00', NULL, NULL, 74, NULL, NULL, 234598),
(276363, '4s3oC00', NULL, NULL, 101, NULL, NULL, 234598),
(276364, '1borA00', NULL, NULL, 56, NULL, NULL, 234598),
(276365, '4n4fA02', NULL, NULL, 44, NULL, NULL, 234598),
(276366, '2yt5A00', NULL, NULL, 66, NULL, NULL, 234598),
(276367, '4qf2A00', NULL, NULL, 58, NULL, NULL, 234598),
(276368, '3l11A00', NULL, NULL, 115, NULL, NULL, 234598),
(276369, '1xwhA00', NULL, NULL, 66, NULL, NULL, 234598),
(276370, '2cszA00', NULL, NULL, 76, NULL, NULL, 234598),
(276371, '2ku3A00', NULL, NULL, 71, NULL, NULL, 234598),
(276372, '2g43B01', NULL, NULL, 108, NULL, NULL, 234598),
(276373, '6nftB01', NULL, NULL, 101, NULL, NULL, 234598),
(276374, '2m6mA00', NULL, NULL, 83, NULL, NULL, 234598),
(276375, '1wepA00', NULL, NULL, 79, NULL, NULL, 234598),
(276376, '2y1nA04', NULL, NULL, 74, NULL, NULL, 234598),
(276377, '5g0fA00', NULL, NULL, 110, NULL, NULL, 234598),
(276378, '2g6qA00', NULL, NULL, 62, NULL, NULL, 234598),
(276379, '2ma6A00', NULL, NULL, 61, NULL, NULL, 234598),
(276380, '5i8gA02', NULL, NULL, 47, NULL, NULL, 234598),
(276381, '2vp7A00', NULL, NULL, 71, NULL, NULL, 234598),
(276382, '2l0bA00', NULL, NULL, 91, NULL, NULL, 234598),
(276383, '5trbA00', NULL, NULL, 75, NULL, NULL, 234598),
(276384, '1wilA00', NULL, NULL, 89, NULL, NULL, 234598),
(276385, '2qicA00', NULL, NULL, 62, NULL, NULL, 234598),
(276386, '2i50A00', NULL, NULL, 126, NULL, NULL, 234598),
(276387, '1vfyA00', NULL, NULL, 73, NULL, NULL, 234598),
(276388, '1weuA00', NULL, NULL, 91, NULL, NULL, 234598),
(276389, '1jm7B00', NULL, NULL, 97, NULL, NULL, 234598),
(276390, '6asbC01', NULL, NULL, 82, NULL, NULL, 234598),
(276391, '5vdcA00', NULL, NULL, 126, NULL, NULL, 234598),
(276392, '4mvtB02', NULL, NULL, 129, NULL, NULL, 234598),
(276393, '2lxhC00', NULL, NULL, 81, NULL, NULL, 234598),
(276394, '2vnfC00', NULL, NULL, 60, NULL, NULL, 234598),
(276395, '1weeA00', NULL, NULL, 72, NULL, NULL, 234598),
(276396, '5d0iB00', NULL, NULL, 55, NULL, NULL, 234598),
(276397, '2puyB00', NULL, NULL, 60, NULL, NULL, 234598),
(276398, '3zniI04', NULL, NULL, 87, NULL, NULL, 234598),
(276399, '1x4jA00', NULL, NULL, 75, NULL, NULL, 234598),
(276400, '4gb0A00', NULL, NULL, 103, NULL, NULL, 234598),
(276401, '2pnxA00', NULL, NULL, 55, NULL, NULL, 234598),
(276402, '5y20A00', NULL, NULL, 52, NULL, NULL, 234598),
(276403, '6g8rB01', NULL, NULL, 54, NULL, NULL, 234598),
(276404, '5tdrA00', NULL, NULL, 70, NULL, NULL, 234598),
(276405, '3purA01', NULL, NULL, 101, NULL, NULL, 234598),
(276406, '4p5oB00', NULL, NULL, 86, NULL, NULL, 234598),
(276407, '2yyrA00', NULL, NULL, 67, NULL, NULL, 234598),
(276408, '5mr8A01', NULL, NULL, 78, NULL, NULL, 234598),
(276409, '2m85A00', NULL, NULL, 73, NULL, NULL, 234598),
(276410, '3v43A00', NULL, NULL, 112, NULL, NULL, 234598),
(276411, '1x4uA01', NULL, NULL, 69, NULL, NULL, 234598),
(276412, '2csyA01', NULL, NULL, 60, NULL, NULL, 234598),
(276413, '5wlfA00', NULL, NULL, 62, NULL, NULL, 234598),
(276414, '5b8dA00', NULL, NULL, 107, NULL, NULL, 234598),
(276415, '2ldrA00', NULL, NULL, 82, NULL, NULL, 234598),
(276416, '4ic3B00', NULL, NULL, 74, NULL, NULL, 234598),
(276417, '2ecwA00', NULL, NULL, 85, NULL, NULL, 234598),
(276418, '3i2dA02', NULL, NULL, 130, NULL, NULL, 234598);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(276419, '2l5uA00', NULL, NULL, 61, NULL, NULL, 234598),
(276420, '2vpgC00', NULL, NULL, 63, NULL, NULL, 234598),
(276421, '3hctA00', NULL, NULL, 118, NULL, NULL, 234598),
(276422, '1wfkA01', NULL, NULL, 77, NULL, NULL, 234598),
(276423, '4up0A00', NULL, NULL, 99, NULL, NULL, 234598),
(276424, '2e6rA00', NULL, NULL, 92, NULL, NULL, 234598),
(276425, '3lrqB00', NULL, NULL, 100, NULL, NULL, 234598),
(276426, '1jm7A00', NULL, NULL, 112, NULL, NULL, 234598),
(276427, '2uzgA00', NULL, NULL, 97, NULL, NULL, 234598),
(276428, '1weoA00', NULL, NULL, 93, NULL, NULL, 234598),
(276429, '3gv4A00', NULL, NULL, 107, NULL, NULL, 234598),
(276430, '5mnjG00', NULL, NULL, 65, NULL, NULL, 234598),
(276431, '2bayE00', NULL, NULL, 61, NULL, NULL, 234598),
(276432, '5wleA00', NULL, NULL, 63, NULL, NULL, 234598),
(276433, '2yucA01', NULL, NULL, 66, NULL, NULL, 234598),
(276434, '2y43A00', NULL, NULL, 99, NULL, NULL, 234598),
(276435, '1zbdB00', NULL, NULL, 134, NULL, NULL, 234598),
(276436, '1wimA00', NULL, NULL, 94, NULL, NULL, 234598),
(276437, '1we9A00', NULL, NULL, 64, NULL, NULL, 234598),
(276438, '5c11A00', NULL, NULL, 52, NULL, NULL, 234598),
(276439, '4ccgY00', NULL, NULL, 88, NULL, NULL, 234598),
(276440, '1e4uA00', NULL, NULL, 78, NULL, NULL, 234598),
(276441, '4gnfA00', NULL, NULL, 107, NULL, NULL, 234598),
(276442, '2ri7A01', NULL, NULL, 63, NULL, NULL, 234598),
(276443, '1z6uA00', NULL, NULL, 115, NULL, NULL, 234598),
(276444, '4r7eA00', NULL, NULL, 69, NULL, NULL, 234598),
(276445, '2ysmA00', NULL, NULL, 111, NULL, NULL, 234598),
(276446, '2k16A00', NULL, NULL, 75, NULL, NULL, 234598),
(276447, '2oxqC00', NULL, NULL, 80, NULL, NULL, 234598),
(276448, '1x4iA00', NULL, NULL, 70, NULL, NULL, 234598),
(276449, '5yc3A00', NULL, NULL, 60, NULL, NULL, 234598),
(276450, '3puqA01', NULL, NULL, 70, NULL, NULL, 234598),
(276451, '4wz0A00', NULL, NULL, 109, NULL, NULL, 234598),
(276452, '2miqA00', NULL, NULL, 94, NULL, NULL, 234598),
(276453, '5o85D00', NULL, NULL, 70, NULL, NULL, 234598),
(276454, '3aslA00', NULL, NULL, 70, NULL, NULL, 234598),
(276455, '4l58A00', NULL, NULL, 69, NULL, NULL, 234598),
(276456, '2cklA00', NULL, NULL, 108, NULL, NULL, 234598),
(276457, '2egpA00', NULL, NULL, 79, NULL, NULL, 234598),
(276458, '2naaA00', NULL, NULL, 94, NULL, NULL, 234598),
(276459, '5szcA00', NULL, NULL, 115, NULL, NULL, 234598),
(276460, '5mnjH00', NULL, NULL, 64, NULL, NULL, 234598),
(276461, '2c2vV00', NULL, NULL, 78, NULL, NULL, 234598),
(276462, '2l43A00', NULL, NULL, 88, NULL, NULL, 234598),
(276463, '3hcsA02', NULL, NULL, 61, NULL, NULL, 234598),
(276464, '2yu4A00', NULL, NULL, 94, NULL, NULL, 234598),
(276465, '2ecvA00', NULL, NULL, 85, NULL, NULL, 234598),
(276466, '2kyuA00', NULL, NULL, 67, NULL, NULL, 234598),
(276467, '2eodA00', NULL, NULL, 66, NULL, NULL, 234598),
(276468, '1g25A00', NULL, NULL, 65, NULL, NULL, 234598),
(276469, '4ybmA01', NULL, NULL, 61, NULL, NULL, 234598),
(276470, '5wxhA00', NULL, NULL, 63, NULL, NULL, 234598),
(276471, '3zvzB00', NULL, NULL, 57, NULL, NULL, 234598),
(276472, '1wenA00', NULL, NULL, 71, NULL, NULL, 234598),
(276473, '3ztgA00', NULL, NULL, 92, NULL, NULL, 234598),
(276474, '4qf3A00', NULL, NULL, 58, NULL, NULL, 234598),
(276475, '1chcA00', NULL, NULL, 68, NULL, NULL, 234598),
(276476, '5vo0D02', NULL, NULL, 62, NULL, NULL, 234598),
(276477, '4bbqA01', NULL, NULL, 76, NULL, NULL, 234598),
(276478, '4xi1B00', NULL, NULL, 79, NULL, NULL, 234598),
(276479, '2jrjA00', NULL, NULL, 52, NULL, NULL, 234598),
(276480, '3vk6A01', NULL, NULL, 59, NULL, NULL, 234598),
(276481, '3lqhA01', NULL, NULL, 52, NULL, NULL, 234598),
(276482, '5dinA00', NULL, NULL, 130, NULL, NULL, 234598),
(276483, '5h7rD00', NULL, NULL, 128, NULL, NULL, 234598),
(276484, '2xeuA00', NULL, NULL, 64, NULL, NULL, 234598),
(276485, '3o70A00', NULL, NULL, 68, NULL, NULL, 234598),
(276486, '1wesA00', NULL, NULL, 71, NULL, NULL, 234598),
(276487, '2cklB01', NULL, NULL, 71, NULL, NULL, 234598),
(276488, '1iymA00', NULL, NULL, 55, NULL, NULL, 234598),
(276489, '4aycA02', NULL, NULL, 85, NULL, NULL, 234598),
(276490, '3jb9V01', NULL, NULL, 60, NULL, NULL, 234598);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(276491, '3knvA00', NULL, NULL, 141, NULL, NULL, 234598),
(276492, '1t1hA00', NULL, NULL, 78, NULL, NULL, 234598),
(276493, '5dkaA00', NULL, NULL, 96, NULL, NULL, 234598),
(276494, '3nw0A03', NULL, NULL, 58, NULL, NULL, 234598),
(276495, '5aiuA00', NULL, NULL, 133, NULL, NULL, 234598),
(276496, '2yhoE00', NULL, NULL, 79, NULL, NULL, 234598),
(276497, '5u2jB00', NULL, NULL, 111, NULL, NULL, 234598),
(276498, '2f42A02', NULL, NULL, 80, NULL, NULL, 234598),
(276499, '2e6sA00', NULL, NULL, 77, NULL, NULL, 234598),
(276500, '4msxA01', NULL, NULL, 93, NULL, NULL, 234598),
(276501, '5eyaF00', NULL, NULL, 86, NULL, NULL, 234598),
(276502, '5vnzA00', NULL, NULL, 118, NULL, NULL, 234598),
(276503, '2kwjA00', NULL, NULL, 114, NULL, NULL, 234598),
(276504, '2lxpC00', NULL, NULL, 58, NULL, NULL, 234598),
(276505, '5h9mA01', NULL, NULL, 59, NULL, NULL, 234598),
(276506, '4zdtC00', NULL, NULL, 73, NULL, NULL, 234598),
(276507, '5d1mB01', NULL, NULL, 97, NULL, NULL, 234598),
(276508, '3zyqA02', NULL, NULL, 71, NULL, NULL, 234598),
(276509, '1wemA00', NULL, NULL, 76, NULL, NULL, 234598),
(276510, '2ecjA00', NULL, NULL, 58, NULL, NULL, 234598),
(276511, '2d8sA00', NULL, NULL, 80, NULL, NULL, 234598),
(276512, '2ct2A00', NULL, NULL, 88, NULL, NULL, 234598),
(276513, '2mumA00', NULL, NULL, 50, NULL, NULL, 234598),
(276514, '4o64B01', NULL, NULL, 77, NULL, NULL, 234598),
(276515, '2lgvA00', NULL, NULL, 100, NULL, NULL, 234598),
(276516, '2jmiA00', NULL, NULL, 67, NULL, NULL, 234598),
(276517, '6hprA00', NULL, NULL, 65, NULL, NULL, 234598),
(276518, '1vd4A00', NULL, NULL, 62, NULL, NULL, 234598),
(276519, '1z2qA00', NULL, NULL, 84, NULL, NULL, 234598),
(276520, '1fp0A00', NULL, NULL, 88, NULL, NULL, 234598),
(276521, '1vyxA00', NULL, NULL, 60, NULL, NULL, 234598),
(276522, '3mhsA01', NULL, NULL, 131, NULL, NULL, 234598),
(276523, '5vabA00', NULL, NULL, 58, NULL, NULL, 234598),
(276524, '3t6rA00', NULL, NULL, 72, NULL, NULL, 234598),
(276525, '2yw8A00', NULL, NULL, 82, NULL, NULL, 234598),
(276526, '1wewA00', NULL, NULL, 78, NULL, NULL, 234598),
(276527, '5z4iA00', NULL, NULL, 99, NULL, NULL, 234598),
(276528, '1rmdA01', NULL, NULL, 86, NULL, NULL, 234598),
(276529, '5tbnA00', NULL, NULL, 57, NULL, NULL, 234598),
(276530, '3m62A02', NULL, NULL, 82, NULL, NULL, 234598),
(276531, '3u5nA01', NULL, NULL, 77, NULL, NULL, 234598),
(276532, '2mnyA00', NULL, NULL, 55, NULL, NULL, 234598),
(276533, '1mm2A00', NULL, NULL, 61, NULL, NULL, 234598),
(276534, '3zpv100', NULL, NULL, 62, NULL, NULL, 234598),
(276535, '5lktA03', NULL, NULL, 46, NULL, NULL, 234598),
(276536, '3kqiA00', NULL, NULL, 75, NULL, NULL, 234598),
(276537, '2rsdA00', NULL, NULL, 68, NULL, NULL, 234598),
(276538, '4ladB00', NULL, NULL, 70, NULL, NULL, 234598),
(276539, '2jmdA00', NULL, NULL, 63, NULL, NULL, 234598),
(276540, '2ma5A00', NULL, NULL, 61, NULL, NULL, 234598),
(276541, '2idaA01', NULL, NULL, 88, NULL, NULL, 234598),
(276542, '1f62A00', NULL, NULL, 51, NULL, NULL, 234598),
(276543, '2ectA00', NULL, NULL, 78, NULL, NULL, 234598),
(276544, '4fo9A02', NULL, NULL, 128, NULL, NULL, 234598),
(276545, '3c6wC00', NULL, NULL, 59, NULL, NULL, 234598),
(276546, '4tkpB00', NULL, NULL, 93, NULL, NULL, 234598),
(276547, '5fb0C01', NULL, NULL, 65, NULL, NULL, 234598),
(276548, '1wgmA01', NULL, NULL, 73, NULL, NULL, 234598),
(276549, '2lv9A00', NULL, NULL, 80, NULL, NULL, 234598),
(276550, '5hkxA04', NULL, NULL, 50, NULL, NULL, 234598),
(276551, '2eciA01', NULL, NULL, 45, NULL, NULL, 234598),
(276552, '3fl2A00', NULL, NULL, 124, NULL, NULL, 234598),
(276553, '2l80A01', NULL, NULL, 97, NULL, NULL, 234598),
(276554, '1v87A01', NULL, NULL, 85, NULL, NULL, 234598),
(276555, '5pxlB01', NULL, NULL, 60, NULL, NULL, 234598),
(276556, '3kv5D01', NULL, NULL, 64, NULL, NULL, 234598),
(276557, '3t7lA00', NULL, NULL, 90, NULL, NULL, 234598),
(276558, '4l7xA00', NULL, NULL, 63, NULL, NULL, 234598),
(276559, '1weqA00', NULL, NULL, 85, NULL, NULL, 234598),
(276560, '4b7yD00', NULL, NULL, 116, NULL, NULL, 234598),
(276561, '1jocA02', NULL, NULL, 63, NULL, NULL, 234598),
(276562, '3htkC02', NULL, NULL, 54, NULL, NULL, 234598);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(276563, '2ecnA01', NULL, NULL, 46, NULL, NULL, 234598),
(276564, '2ysjA00', NULL, NULL, 63, NULL, NULL, 234598),
(276565, '1mm3A00', NULL, NULL, 61, NULL, NULL, 234598),
(276566, '5xfoA02', NULL, NULL, 56, NULL, NULL, 234598),
(276567, '4nn2B00', NULL, NULL, 129, NULL, NULL, 234598),
(276568, '4r2yC00', NULL, NULL, 68, NULL, NULL, 234598),
(276569, '3ihpA01', NULL, NULL, 116, NULL, NULL, 234598),
(276570, '3o7aA00', NULL, NULL, 52, NULL, NULL, 234598),
(276571, '5tabA00', NULL, NULL, 53, NULL, NULL, 234598),
(276572, '4ca1A01', NULL, NULL, 61, NULL, NULL, 234598),
(276573, '2yqmA01', NULL, NULL, 58, NULL, NULL, 234598),
(276574, '5feyA00', NULL, NULL, 94, NULL, NULL, 234598),
(276575, '4v3lC00', NULL, NULL, 79, NULL, NULL, 234598),
(276576, '5o6tA00', NULL, NULL, 66, NULL, NULL, 234598),
(276577, '1wevA01', NULL, NULL, 64, NULL, NULL, 234598),
(276578, '4wz3B02', NULL, NULL, 71, NULL, NULL, 234598),
(276579, '4auqB00', NULL, NULL, 62, NULL, NULL, 234598),
(276580, '5o75A00', NULL, NULL, 78, NULL, NULL, 234598),
(276581, '1dvpA02', NULL, NULL, 66, NULL, NULL, 234598),
(276582, '1h6wA02', NULL, NULL, 43, NULL, NULL, 234599),
(276583, '5bq1A00', NULL, NULL, 209, NULL, NULL, 234600),
(276584, '3lasA00', NULL, NULL, 166, NULL, NULL, 234600),
(276585, '1i6pA00', NULL, NULL, 220, NULL, NULL, 234600),
(276586, '3teoA01', NULL, NULL, 180, NULL, NULL, 234600),
(276587, '3vqjA00', NULL, NULL, 219, NULL, NULL, 234600),
(276588, '5cxkA00', NULL, NULL, 222, NULL, NULL, 234600),
(276589, '3eyxA00', NULL, NULL, 216, NULL, NULL, 234600),
(276590, '2w3qA02', NULL, NULL, 178, NULL, NULL, 234600),
(276591, '1ym3A00', NULL, NULL, 215, NULL, NULL, 234600),
(276592, '1g5cA00', NULL, NULL, 170, NULL, NULL, 234600),
(276593, '5ztpA00', NULL, NULL, 169, NULL, NULL, 234600),
(276594, '3ucjA00', NULL, NULL, 227, NULL, NULL, 234600),
(276595, '1ekjA00', NULL, NULL, 221, NULL, NULL, 234600),
(276596, '3e3iJ00', NULL, NULL, 229, NULL, NULL, 234600),
(276597, '1ddzA02', NULL, NULL, 223, NULL, NULL, 234600),
(276598, '1ddzA01', NULL, NULL, 242, NULL, NULL, 234600),
(276599, '5swcD00', NULL, NULL, 206, NULL, NULL, 234600),
(276600, '4yf4A00', NULL, NULL, 172, NULL, NULL, 234600),
(276601, '3qy1A00', NULL, NULL, 223, NULL, NULL, 234600),
(276602, '4o1jA00', NULL, NULL, 211, NULL, NULL, 234600),
(276603, '3e24A00', NULL, NULL, 195, NULL, NULL, 234600),
(276604, '4o1kA00', NULL, NULL, 233, NULL, NULL, 234600),
(276605, '5swcF00', NULL, NULL, 223, NULL, NULL, 234600),
(276606, '2b25A01', NULL, NULL, 73, NULL, NULL, 234601),
(276607, '2yvlA01', NULL, NULL, 59, NULL, NULL, 234601),
(276608, '5eqjB01', NULL, NULL, 79, NULL, NULL, 234601),
(276609, '3mb5A01', NULL, NULL, 62, NULL, NULL, 234601),
(276610, '2pwyA01', NULL, NULL, 64, NULL, NULL, 234601),
(276611, '1o54A01', NULL, NULL, 81, NULL, NULL, 234601),
(276612, '1i9gA01', NULL, NULL, 67, NULL, NULL, 234601),
(276613, '5ccbA01', NULL, NULL, 72, NULL, NULL, 234601),
(276614, '4da2A02', NULL, NULL, 152, NULL, NULL, 234602),
(276615, '4dapA02', NULL, NULL, 154, NULL, NULL, 234602),
(276616, '4u8uN01', NULL, NULL, 49, NULL, NULL, 234603),
(276617, '2gtlN01', NULL, NULL, 50, NULL, NULL, 234603),
(276618, '2hfqA00', NULL, NULL, 87, NULL, NULL, 234604),
(276619, '2e2dC02', NULL, NULL, 94, NULL, NULL, 234605),
(276620, '2tmpA00', NULL, NULL, 127, NULL, NULL, 234605),
(276621, '1br9A02', NULL, NULL, 96, NULL, NULL, 234605),
(276622, '1jb3A00', NULL, NULL, 131, NULL, NULL, 234605),
(276623, '3cu7A13', NULL, NULL, 155, NULL, NULL, 234605),
(276624, '1uapA00', NULL, NULL, 131, NULL, NULL, 234605),
(276625, '2b39A13', NULL, NULL, 136, NULL, NULL, 234605),
(276626, '3ma2C00', NULL, NULL, 125, NULL, NULL, 234605),
(276627, '3v96A02', NULL, NULL, 92, NULL, NULL, 234605),
(276628, '3ckiB00', NULL, NULL, 121, NULL, NULL, 234605),
(276629, '2qkiC02', NULL, NULL, 161, NULL, NULL, 234605),
(276630, '3hrzC03', NULL, NULL, 160, NULL, NULL, 234605),
(276631, '4fxkC02', NULL, NULL, 157, NULL, NULL, 234605),
(276632, '2hjeA02', NULL, NULL, 64, NULL, NULL, 234606),
(276633, '3c38A02', NULL, NULL, 64, NULL, NULL, 234606);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(276634, '1yduA01', NULL, NULL, 139, NULL, NULL, 234607),
(276635, '6bogA06', NULL, NULL, 52, NULL, NULL, 234608),
(276636, '2edmA00', NULL, NULL, 161, NULL, NULL, 234609),
(276637, '2ed6A01', NULL, NULL, 154, NULL, NULL, 234609),
(276638, '4pf3A00', NULL, NULL, 250, NULL, NULL, 234610),
(276639, '4j5xC00', NULL, NULL, 264, NULL, NULL, 234610),
(276640, '4n1yB00', NULL, NULL, 240, NULL, NULL, 234610),
(276641, '3f5cB00', NULL, NULL, 183, NULL, NULL, 234610),
(276642, '3mnpA00', NULL, NULL, 261, NULL, NULL, 234610),
(276643, '2q1hA00', NULL, NULL, 250, NULL, NULL, 234610),
(276644, '1nq7A00', NULL, NULL, 244, NULL, NULL, 234610),
(276645, '4lsjA01', NULL, NULL, 247, NULL, NULL, 234610),
(276646, '5hjsA00', NULL, NULL, 243, NULL, NULL, 234610),
(276647, '3n00A00', NULL, NULL, 213, NULL, NULL, 234610),
(276648, '1pzlA00', NULL, NULL, 237, NULL, NULL, 234610),
(276649, '1mznA00', NULL, NULL, 240, NULL, NULL, 234610),
(276650, '4dm6B00', NULL, NULL, 244, NULL, NULL, 234610),
(276651, '3eybA00', NULL, NULL, 219, NULL, NULL, 234610),
(276652, '4n8rB00', NULL, NULL, 202, NULL, NULL, 234610),
(276653, '3kmrA00', NULL, NULL, 240, NULL, NULL, 234610),
(276654, '3gytA00', NULL, NULL, 244, NULL, NULL, 234610),
(276655, '3ollA00', NULL, NULL, 240, NULL, NULL, 234610),
(276656, '3k6pA00', NULL, NULL, 248, NULL, NULL, 234610),
(276657, '3cqvA00', NULL, NULL, 199, NULL, NULL, 234610),
(276658, '3nspB00', NULL, NULL, 193, NULL, NULL, 234610),
(276659, '6chtV00', NULL, NULL, 217, NULL, NULL, 234610),
(276660, '3uudA00', NULL, NULL, 251, NULL, NULL, 234610),
(276661, '5ufwA00', NULL, NULL, 249, NULL, NULL, 234610),
(276662, '5ufsA00', NULL, NULL, 248, NULL, NULL, 234610),
(276663, '5u3qA00', NULL, NULL, 272, NULL, NULL, 234610),
(276664, '5y41A00', NULL, NULL, 237, NULL, NULL, 234610),
(276665, '4ozrU00', NULL, NULL, 196, NULL, NULL, 234610),
(276666, '1sqnA00', NULL, NULL, 261, NULL, NULL, 234610),
(276667, '4ohaA00', NULL, NULL, 250, NULL, NULL, 234610),
(276668, '1z5xE00', NULL, NULL, 238, NULL, NULL, 234610),
(276669, '5i4vF00', NULL, NULL, 255, NULL, NULL, 234610),
(276670, '1n83A00', NULL, NULL, 270, NULL, NULL, 234610),
(276671, '6hl0A00', NULL, NULL, 232, NULL, NULL, 234610),
(276672, '3u9qA00', NULL, NULL, 269, NULL, NULL, 234610),
(276673, '5ntwA00', NULL, NULL, 257, NULL, NULL, 234610),
(276674, '1zdtB00', NULL, NULL, 241, NULL, NULL, 234610),
(276675, '5c4tA00', NULL, NULL, 241, NULL, NULL, 234610),
(276676, '4x1fA00', NULL, NULL, 293, NULL, NULL, 234610),
(276677, '3vtcA00', NULL, NULL, 254, NULL, NULL, 234610),
(276678, '1osvA00', NULL, NULL, 230, NULL, NULL, 234610),
(276679, '1g2nA00', NULL, NULL, 264, NULL, NULL, 234610),
(276680, '2e2rA00', NULL, NULL, 228, NULL, NULL, 234610),
(276681, '5a86A00', NULL, NULL, 290, NULL, NULL, 234610),
(276682, '3d57A00', NULL, NULL, 266, NULL, NULL, 234610),
(276683, '4oztE00', NULL, NULL, 238, NULL, NULL, 234610),
(276684, '4iqrF02', NULL, NULL, 238, NULL, NULL, 234610),
(276685, '2q60C00', NULL, NULL, 233, NULL, NULL, 234610),
(276686, '3l0lA00', NULL, NULL, 248, NULL, NULL, 234610),
(276687, '4n73A00', NULL, NULL, 199, NULL, NULL, 234610),
(276688, '4lnwA00', NULL, NULL, 267, NULL, NULL, 234610),
(276689, '1pduA00', NULL, NULL, 244, NULL, NULL, 234610),
(276690, '5aphA00', NULL, NULL, 266, NULL, NULL, 234610),
(276691, '2nxxB00', NULL, NULL, 235, NULL, NULL, 234610),
(276692, '3up3A00', NULL, NULL, 243, NULL, NULL, 234610),
(276693, '2r40D00', NULL, NULL, 246, NULL, NULL, 234610),
(276694, '5q0lA00', NULL, NULL, 233, NULL, NULL, 234610),
(276695, '2j7yA00', NULL, NULL, 255, NULL, NULL, 234610),
(276696, '4nufA02', NULL, NULL, 206, NULL, NULL, 234610),
(276697, '3ry9A00', NULL, NULL, 250, NULL, NULL, 234610),
(276698, '3p0uA00', NULL, NULL, 249, NULL, NULL, 234610),
(276699, '1xvpB00', NULL, NULL, 246, NULL, NULL, 234610),
(276700, '1m7wA00', NULL, NULL, 250, NULL, NULL, 234610),
(276701, '4rakA00', NULL, NULL, 244, NULL, NULL, 234610),
(276702, '4pldA00', NULL, NULL, 245, NULL, NULL, 234610),
(276703, '4ltwA00', NULL, NULL, 252, NULL, NULL, 234610),
(276704, '3l0eA00', NULL, NULL, 253, NULL, NULL, 234610);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(276705, '3plzB00', NULL, NULL, 257, NULL, NULL, 234610),
(276706, '1ymtA00', NULL, NULL, 246, NULL, NULL, 234610),
(276707, '5apkA00', NULL, NULL, 244, NULL, NULL, 234610),
(276708, '1xiuB00', NULL, NULL, 230, NULL, NULL, 234610),
(276709, '1fcyA00', NULL, NULL, 236, NULL, NULL, 234610),
(276710, '3cjwA00', NULL, NULL, 244, NULL, NULL, 234610),
(276711, '4rzfA00', NULL, NULL, 256, NULL, NULL, 234610),
(276712, '2gl8D00', NULL, NULL, 241, NULL, NULL, 234610),
(276713, '3uvvA00', NULL, NULL, 265, NULL, NULL, 234610),
(276714, '5a86B00', NULL, NULL, 292, NULL, NULL, 234610),
(276715, '5uc1A00', NULL, NULL, 222, NULL, NULL, 234610),
(276716, '4logB00', NULL, NULL, 244, NULL, NULL, 234610),
(276717, '1z5xU00', NULL, NULL, 197, NULL, NULL, 234610),
(276718, '1xnxA00', NULL, NULL, 256, NULL, NULL, 234610),
(276719, '1yjeA00', NULL, NULL, 236, NULL, NULL, 234610),
(276720, '5ysoC00', NULL, NULL, 218, NULL, NULL, 234610),
(276721, '1hg4C00', NULL, NULL, 279, NULL, NULL, 234610),
(276722, '2q5gB00', NULL, NULL, 265, NULL, NULL, 234610),
(276723, '3vi8A00', NULL, NULL, 273, NULL, NULL, 234610),
(276724, '1pk5B00', NULL, NULL, 248, NULL, NULL, 234610),
(276725, '5kyaA00', NULL, NULL, 263, NULL, NULL, 234610),
(276726, '2nxxE00', NULL, NULL, 248, NULL, NULL, 234610),
(276727, '1lv2A00', NULL, NULL, 229, NULL, NULL, 234610),
(276728, '4uddA00', NULL, NULL, 249, NULL, NULL, 234610),
(276729, '2xhsA00', NULL, NULL, 245, NULL, NULL, 234610),
(276730, '6eu9A00', NULL, NULL, 241, NULL, NULL, 234610),
(276731, '3b0tA00', NULL, NULL, 254, NULL, NULL, 234610),
(276732, '4q0aC00', NULL, NULL, 242, NULL, NULL, 234610),
(276733, '1n46B00', NULL, NULL, 258, NULL, NULL, 234610),
(276734, '2xwxA02', NULL, NULL, 108, NULL, NULL, 234611),
(276735, '4aj5100', NULL, NULL, 101, NULL, NULL, 234612),
(276736, '2mcmA00', NULL, NULL, 112, NULL, NULL, 234613),
(276737, '2cbqC00', NULL, NULL, 114, NULL, NULL, 234613),
(276738, '1akpA00', NULL, NULL, 114, NULL, NULL, 234613),
(276739, '2cbtA00', NULL, NULL, 112, NULL, NULL, 234613),
(276740, '2cboA00', NULL, NULL, 115, NULL, NULL, 234613),
(276741, '1noaA00', NULL, NULL, 113, NULL, NULL, 234613),
(276742, '1acxA00', NULL, NULL, 108, NULL, NULL, 234613),
(276743, '1j48A00', NULL, NULL, 110, NULL, NULL, 234613),
(276744, '2kt9A01', NULL, NULL, 99, NULL, NULL, 234614),
(276745, '2peoB00', NULL, NULL, 114, NULL, NULL, 234615),
(276746, '5bs2A00', NULL, NULL, 113, NULL, NULL, 234615),
(276747, '2z44A00', NULL, NULL, 111, NULL, NULL, 234615),
(276748, '5bs1B00', NULL, NULL, 123, NULL, NULL, 234615),
(276749, '5bs1A00', NULL, NULL, 123, NULL, NULL, 234615),
(276750, '5bs1D00', NULL, NULL, 123, NULL, NULL, 234615),
(276751, '5bs1C00', NULL, NULL, 123, NULL, NULL, 234615),
(276752, '4gr2A00', NULL, NULL, 128, NULL, NULL, 234615),
(276753, '4gr6B00', NULL, NULL, 126, NULL, NULL, 234615),
(276754, '3q20B00', NULL, NULL, 107, NULL, NULL, 234615),
(276755, '2peqA00', NULL, NULL, 109, NULL, NULL, 234615),
(276756, '3hybA00', NULL, NULL, 125, NULL, NULL, 234615),
(276757, '2py8B00', NULL, NULL, 115, NULL, NULL, 234615),
(276758, '1ib8A02', NULL, NULL, 67, NULL, NULL, 234616),
(276759, '5t6jA00', NULL, NULL, 59, NULL, NULL, 234617),
(276760, '4geqB00', NULL, NULL, 66, NULL, NULL, 234617),
(276761, '3c9aA02', NULL, NULL, 61, NULL, NULL, 234618),
(276762, '1j7gA00', NULL, NULL, 144, NULL, NULL, 234619),
(276763, '1tc5C00', NULL, NULL, 194, NULL, NULL, 234619),
(276764, '2okvA00', NULL, NULL, 149, NULL, NULL, 234619),
(276765, '4rrfA01', NULL, NULL, 136, NULL, NULL, 234619),
(276766, '4rrqA01', NULL, NULL, 139, NULL, NULL, 234619),
(276767, '2dboA00', NULL, NULL, 148, NULL, NULL, 234619),
(276768, '1jkeA00', NULL, NULL, 145, NULL, NULL, 234619),
(276769, '4s02A01', NULL, NULL, 139, NULL, NULL, 234619),
(276770, '4rriA01', NULL, NULL, 134, NULL, NULL, 234619),
(276771, '4nbiB00', NULL, NULL, 164, NULL, NULL, 234619),
(276772, '1r9lA02', NULL, NULL, 141, NULL, NULL, 234620),
(276773, '2rinA02', NULL, NULL, 110, NULL, NULL, 234620),
(276774, '3tmgA02', NULL, NULL, 109, NULL, NULL, 234620),
(276775, '3l6gA02', NULL, NULL, 99, NULL, NULL, 234620);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(276776, '2b4lA01', NULL, NULL, 111, NULL, NULL, 234620),
(276777, '1ntyA01', NULL, NULL, 187, NULL, NULL, 234621),
(276778, '2rgnB01', NULL, NULL, 204, NULL, NULL, 234621),
(276779, '1dbhA01', NULL, NULL, 224, NULL, NULL, 234621),
(276780, '3gf9A00', NULL, NULL, 201, NULL, NULL, 234621),
(276781, '2dfkC01', NULL, NULL, 212, NULL, NULL, 234621),
(276782, '2z0qA01', NULL, NULL, 216, NULL, NULL, 234621),
(276783, '3eo2A00', NULL, NULL, 187, NULL, NULL, 234621),
(276784, '2pz1A02', NULL, NULL, 237, NULL, NULL, 234621),
(276785, '2vrwB01', NULL, NULL, 193, NULL, NULL, 234621),
(276786, '3bjiA01', NULL, NULL, 194, NULL, NULL, 234621),
(276787, '1kz7A01', NULL, NULL, 195, NULL, NULL, 234621),
(276788, '4gouA03', NULL, NULL, 197, NULL, NULL, 234621),
(276789, '5o33B00', NULL, NULL, 180, NULL, NULL, 234621),
(276790, '4yonA01', NULL, NULL, 216, NULL, NULL, 234621),
(276791, '4gyvE00', NULL, NULL, 218, NULL, NULL, 234621),
(276792, '1by1A00', NULL, NULL, 209, NULL, NULL, 234621),
(276793, '4d0nB01', NULL, NULL, 245, NULL, NULL, 234621),
(276794, '3p6aA01', NULL, NULL, 213, NULL, NULL, 234621),
(276795, '5jhhA01', NULL, NULL, 230, NULL, NULL, 234621),
(276796, '3jv3A02', NULL, NULL, 217, NULL, NULL, 234621),
(276797, '1foeA01', NULL, NULL, 204, NULL, NULL, 234621),
(276798, '3mpxA01', NULL, NULL, 214, NULL, NULL, 234621),
(276799, '1txdA01', NULL, NULL, 233, NULL, NULL, 234621),
(276800, '4a15A02', NULL, NULL, 81, NULL, NULL, 234622),
(276801, '3gn4A00', NULL, NULL, 148, NULL, NULL, 234623),
(276802, '1yi9A01', NULL, NULL, 156, NULL, NULL, 234624),
(276803, '2o0qA00', NULL, NULL, 115, NULL, NULL, 234625),
(276804, '2yrtA00', NULL, NULL, 75, NULL, NULL, 234626),
(276805, '4n7qA03', NULL, NULL, 33, NULL, NULL, 234627),
(276806, '3epoA03', NULL, NULL, 35, NULL, NULL, 234627),
(276807, '6az1V01', NULL, NULL, 62, NULL, NULL, 234628),
(276808, '1rq6A00', NULL, NULL, 62, NULL, NULL, 234628),
(276809, '5xxuR01', NULL, NULL, 62, NULL, NULL, 234628),
(276810, '3j7aW01', NULL, NULL, 62, NULL, NULL, 234628),
(276811, '2xzmV01', NULL, NULL, 62, NULL, NULL, 234628),
(276812, '3jamR01', NULL, NULL, 62, NULL, NULL, 234628),
(276813, '5xyiR01', NULL, NULL, 62, NULL, NULL, 234628),
(276814, '5optk01', NULL, NULL, 60, NULL, NULL, 234628),
(276815, '5a2qR01', NULL, NULL, 62, NULL, NULL, 234628),
(276816, '6gcfA00', NULL, NULL, 170, NULL, NULL, 234629),
(276817, '1aq5A00', NULL, NULL, 47, NULL, NULL, 234630),
(276818, '4adiB04', NULL, NULL, 94, NULL, NULL, 234631),
(276819, '1lmlA01', NULL, NULL, 170, NULL, NULL, 234632),
(276820, '4mndA02', NULL, NULL, 195, NULL, NULL, 234633),
(276821, '5d91A02', NULL, NULL, 199, NULL, NULL, 234633),
(276822, '4o6mB02', NULL, NULL, 203, NULL, NULL, 234633),
(276823, '5ntfA01', NULL, NULL, 189, NULL, NULL, 234634),
(276824, '5nthA01', NULL, NULL, 193, NULL, NULL, 234634),
(276825, '5ntdC01', NULL, NULL, 191, NULL, NULL, 234634),
(276826, '2hc9A01', NULL, NULL, 155, NULL, NULL, 234634),
(276827, '3tw8A01', NULL, NULL, 144, NULL, NULL, 234635),
(276828, '1prxA02', NULL, NULL, 69, NULL, NULL, 234636),
(276829, '6feuA02', NULL, NULL, 67, NULL, NULL, 234636),
(276830, '5xbrA02', NULL, NULL, 72, NULL, NULL, 234636),
(276831, '2v2gA02', NULL, NULL, 82, NULL, NULL, 234636),
(276832, '1xccA02', NULL, NULL, 68, NULL, NULL, 234636),
(276833, '3a2vD02', NULL, NULL, 104, NULL, NULL, 234636),
(276834, '1kyqA03', NULL, NULL, 85, NULL, NULL, 234637),
(276835, '6im5A00', NULL, NULL, 233, NULL, NULL, 234638),
(276836, '6gecA00', NULL, NULL, 219, NULL, NULL, 234638),
(276837, '5emvB00', NULL, NULL, 236, NULL, NULL, 234638),
(276838, '5xjdA00', NULL, NULL, 220, NULL, NULL, 234638),
(276839, '5emwA00', NULL, NULL, 217, NULL, NULL, 234638),
(276840, '6f2mA02', NULL, NULL, 87, NULL, NULL, 234639),
(276841, '1xkpA01', NULL, NULL, 38, NULL, NULL, 234640),
(276842, '2adlA01', NULL, NULL, 30, NULL, NULL, 234641),
(276843, '6on6A00', NULL, NULL, 118, NULL, NULL, 234642),
(276844, '4npyA01', NULL, NULL, 110, NULL, NULL, 234642),
(276845, '4j6rH01', NULL, NULL, 121, NULL, NULL, 234642),
(276846, '5dzoA00', NULL, NULL, 107, NULL, NULL, 234642);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(276847, '4jg1L01', NULL, NULL, 108, NULL, NULL, 234642),
(276848, '4jg1L02', NULL, NULL, 106, NULL, NULL, 234642),
(276849, '2edoA00', NULL, NULL, 121, NULL, NULL, 234642),
(276850, '5xlia01', NULL, NULL, 107, NULL, NULL, 234642),
(276851, '3e0gA03', NULL, NULL, 80, NULL, NULL, 234642),
(276852, '3e0gA02', NULL, NULL, 110, NULL, NULL, 234642),
(276853, '1dqqB01', NULL, NULL, 113, NULL, NULL, 234642),
(276854, '3e0gA01', NULL, NULL, 84, NULL, NULL, 234642),
(276855, '5ibtH01', NULL, NULL, 125, NULL, NULL, 234642),
(276856, '1bquA02', NULL, NULL, 111, NULL, NULL, 234642),
(276857, '4grwH00', NULL, NULL, 123, NULL, NULL, 234642),
(276858, '4unuA00', NULL, NULL, 111, NULL, NULL, 234642),
(276859, '3e0gA05', NULL, NULL, 98, NULL, NULL, 234642),
(276860, '3e0gA04', NULL, NULL, 101, NULL, NULL, 234642),
(276861, '1bquA01', NULL, NULL, 104, NULL, NULL, 234642),
(276862, '6mtpB01', NULL, NULL, 109, NULL, NULL, 234642),
(276863, '1my5A00', NULL, NULL, 114, NULL, NULL, 234642),
(276864, '2wzpD00', NULL, NULL, 123, NULL, NULL, 234642),
(276865, '2bnuA02', NULL, NULL, 90, NULL, NULL, 234642),
(276866, '4pb0L01', NULL, NULL, 113, NULL, NULL, 234642),
(276867, '2bnuA01', NULL, NULL, 113, NULL, NULL, 234642),
(276868, '1t2qH01', NULL, NULL, 119, NULL, NULL, 234642),
(276869, '1blnB01', NULL, NULL, 119, NULL, NULL, 234642),
(276870, '4wnqB01', NULL, NULL, 116, NULL, NULL, 234642),
(276871, '2zuqC01', NULL, NULL, 119, NULL, NULL, 234642),
(276872, '6nrqC00', NULL, NULL, 113, NULL, NULL, 234642),
(276873, '1kcuH01', NULL, NULL, 116, NULL, NULL, 234642),
(276874, '1kcuH02', NULL, NULL, 99, NULL, NULL, 234642),
(276875, '3pl6D01', NULL, NULL, 138, NULL, NULL, 234642),
(276876, '5tjwK00', NULL, NULL, 137, NULL, NULL, 234642),
(276877, '5b71A01', NULL, NULL, 110, NULL, NULL, 234642),
(276878, '5jdjA00', NULL, NULL, 91, NULL, NULL, 234642),
(276879, '3ab0C00', NULL, NULL, 106, NULL, NULL, 234642),
(276880, '6d4aA00', NULL, NULL, 127, NULL, NULL, 234642),
(276881, '4p2yA03', NULL, NULL, 90, NULL, NULL, 234642),
(276882, '5dtfB01', NULL, NULL, 111, NULL, NULL, 234642),
(276883, '6c6zD01', NULL, NULL, 111, NULL, NULL, 234642),
(276884, '3fruA02', NULL, NULL, 92, NULL, NULL, 234642),
(276885, '6b14L01', NULL, NULL, 109, NULL, NULL, 234642),
(276886, '3o2dL01', NULL, NULL, 112, NULL, NULL, 234642),
(276887, '4ydkH01', NULL, NULL, 129, NULL, NULL, 234642),
(276888, '1kgcD01', NULL, NULL, 112, NULL, NULL, 234642),
(276889, '5jmoC00', NULL, NULL, 117, NULL, NULL, 234642),
(276890, '5v7rL01', NULL, NULL, 109, NULL, NULL, 234642),
(276891, '3iagC03', NULL, NULL, 94, NULL, NULL, 234642),
(276892, '5vi4B02', NULL, NULL, 94, NULL, NULL, 234642),
(276893, '4qhlA01', NULL, NULL, 121, NULL, NULL, 234642),
(276894, '2pkdA00', NULL, NULL, 111, NULL, NULL, 234642),
(276895, '6aodA01', NULL, NULL, 108, NULL, NULL, 234642),
(276896, '4j1uF01', NULL, NULL, 116, NULL, NULL, 234642),
(276897, '1kb5L01', NULL, NULL, 108, NULL, NULL, 234642),
(276898, '5f9wB01', NULL, NULL, 122, NULL, NULL, 234642),
(276899, '5b6fA01', NULL, NULL, 113, NULL, NULL, 234642),
(276900, '6r2sA01', NULL, NULL, 108, NULL, NULL, 234642),
(276901, '6ddrA01', NULL, NULL, 108, NULL, NULL, 234642),
(276902, '5kanI01', NULL, NULL, 107, NULL, NULL, 234642),
(276903, '2zkhL01', NULL, NULL, 107, NULL, NULL, 234642),
(276904, '3rkdD01', NULL, NULL, 124, NULL, NULL, 234642),
(276905, '2ed8A01', NULL, NULL, 86, NULL, NULL, 234642),
(276906, '2x89A00', NULL, NULL, 128, NULL, NULL, 234642),
(276907, '3c5sB01', NULL, NULL, 115, NULL, NULL, 234642),
(276908, '3iduB00', NULL, NULL, 127, NULL, NULL, 234642),
(276909, '5ivnA00', NULL, NULL, 131, NULL, NULL, 234642),
(276910, '5hsfA00', NULL, NULL, 108, NULL, NULL, 234642),
(276911, '3p0gB00', NULL, NULL, 126, NULL, NULL, 234642),
(276912, '2e27L00', NULL, NULL, 119, NULL, NULL, 234642),
(276913, '5drxB01', NULL, NULL, 114, NULL, NULL, 234642),
(276914, '4ll9B01', NULL, NULL, 98, NULL, NULL, 234642),
(276915, '3oazH01', NULL, NULL, 124, NULL, NULL, 234642),
(276916, '2fb4L01', NULL, NULL, 111, NULL, NULL, 234642),
(276917, '3up1A02', NULL, NULL, 111, NULL, NULL, 234642);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(276918, '2oz4L01', NULL, NULL, 108, NULL, NULL, 234642),
(276919, '2ck2B00', NULL, NULL, 96, NULL, NULL, 234642),
(276920, '1kenH01', NULL, NULL, 120, NULL, NULL, 234642),
(276921, '3pdgA00', NULL, NULL, 98, NULL, NULL, 234642),
(276922, '4pjxF01', NULL, NULL, 117, NULL, NULL, 234642),
(276923, '4lsdF00', NULL, NULL, 99, NULL, NULL, 234642),
(276924, '4xnyL01', NULL, NULL, 105, NULL, NULL, 234642),
(276925, '2bmkB01', NULL, NULL, 125, NULL, NULL, 234642),
(276926, '3obaA02', NULL, NULL, 126, NULL, NULL, 234642),
(276927, '4lkcB01', NULL, NULL, 128, NULL, NULL, 234642),
(276928, '4gg8A01', NULL, NULL, 113, NULL, NULL, 234642),
(276929, '3obaA04', NULL, NULL, 89, NULL, NULL, 234642),
(276930, '2r15A02', NULL, NULL, 96, NULL, NULL, 234642),
(276931, '2r15A01', NULL, NULL, 116, NULL, NULL, 234642),
(276932, '1svzA02', NULL, NULL, 99, NULL, NULL, 234642),
(276933, '6db5L01', NULL, NULL, 109, NULL, NULL, 234642),
(276934, '5kjrH01', NULL, NULL, 122, NULL, NULL, 234642),
(276935, '4gafB03', NULL, NULL, 116, NULL, NULL, 234642),
(276936, '4gafB02', NULL, NULL, 106, NULL, NULL, 234642),
(276937, '3tt1H01', NULL, NULL, 121, NULL, NULL, 234642),
(276938, '3mbxH01', NULL, NULL, 121, NULL, NULL, 234642),
(276939, '5fgcB01', NULL, NULL, 110, NULL, NULL, 234642),
(276940, '4gafB01', NULL, NULL, 92, NULL, NULL, 234642),
(276941, '5b22A01', NULL, NULL, 113, NULL, NULL, 234642),
(276942, '5ewiL01', NULL, NULL, 113, NULL, NULL, 234642),
(276943, '6cmgB01', NULL, NULL, 108, NULL, NULL, 234642),
(276944, '4wv1A01', NULL, NULL, 108, NULL, NULL, 234642),
(276945, '4xmlL01', NULL, NULL, 111, NULL, NULL, 234642),
(276946, '6gsiF01', NULL, NULL, 99, NULL, NULL, 234642),
(276947, '1aifB01', NULL, NULL, 121, NULL, NULL, 234642),
(276948, '4fa8B02', NULL, NULL, 98, NULL, NULL, 234642),
(276949, '5ks9E01', NULL, NULL, 113, NULL, NULL, 234642),
(276950, '1fbiP01', NULL, NULL, 107, NULL, NULL, 234642),
(276951, '6meeB01', NULL, NULL, 108, NULL, NULL, 234642),
(276952, '4g8fB01', NULL, NULL, 114, NULL, NULL, 234642),
(276953, '1ktrL00', NULL, NULL, 152, NULL, NULL, 234642),
(276954, '4jgjA01', NULL, NULL, 116, NULL, NULL, 234642),
(276955, '1t3fB01', NULL, NULL, 117, NULL, NULL, 234642),
(276956, '4z7wE01', NULL, NULL, 112, NULL, NULL, 234642),
(276957, '4z5rB01', NULL, NULL, 117, NULL, NULL, 234642),
(276958, '5tezI01', NULL, NULL, 114, NULL, NULL, 234642),
(276959, '3ietA01', NULL, NULL, 112, NULL, NULL, 234642),
(276960, '1i8kB00', NULL, NULL, 124, NULL, NULL, 234642),
(276961, '1wwcA00', NULL, NULL, 118, NULL, NULL, 234642),
(276962, '2fatL01', NULL, NULL, 106, NULL, NULL, 234642),
(276963, '1wfuA01', NULL, NULL, 95, NULL, NULL, 234642),
(276964, '4jguA00', NULL, NULL, 95, NULL, NULL, 234642),
(276965, '4fqlL01', NULL, NULL, 109, NULL, NULL, 234642),
(276966, '6i6rB03', NULL, NULL, 108, NULL, NULL, 234642),
(276967, '3ntcL01', NULL, NULL, 114, NULL, NULL, 234642),
(276968, '1jpsL01', NULL, NULL, 108, NULL, NULL, 234642),
(276969, '4nugH01', NULL, NULL, 136, NULL, NULL, 234642),
(276970, '3ntcL02', NULL, NULL, 103, NULL, NULL, 234642),
(276971, '2nplX00', NULL, NULL, 96, NULL, NULL, 234642),
(276972, '5lmjA00', NULL, NULL, 131, NULL, NULL, 234642),
(276973, '4hpyL01', NULL, NULL, 110, NULL, NULL, 234642),
(276974, '5t5fH01', NULL, NULL, 122, NULL, NULL, 234642),
(276975, '3x3fH01', NULL, NULL, 126, NULL, NULL, 234642),
(276976, '3p73B00', NULL, NULL, 99, NULL, NULL, 234642),
(276977, '1jrhH01', NULL, NULL, 122, NULL, NULL, 234642),
(276978, '1d9kA00', NULL, NULL, 110, NULL, NULL, 234642),
(276979, '5w6gL01', NULL, NULL, 113, NULL, NULL, 234642),
(276980, '4y5xA00', NULL, NULL, 136, NULL, NULL, 234642),
(276981, '2ok0H01', NULL, NULL, 117, NULL, NULL, 234642),
(276982, '3gnmL01', NULL, NULL, 113, NULL, NULL, 234642),
(276983, '3ncjL01', NULL, NULL, 107, NULL, NULL, 234642),
(276984, '3hi6L01', NULL, NULL, 107, NULL, NULL, 234642),
(276985, '3p9wD00', NULL, NULL, 123, NULL, NULL, 234642),
(276986, '1cidA02', NULL, NULL, 71, NULL, NULL, 234642),
(276987, '4r96B01', NULL, NULL, 119, NULL, NULL, 234642),
(276988, '1cidA01', NULL, NULL, 106, NULL, NULL, 234642);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(276989, '1ob1A01', NULL, NULL, 109, NULL, NULL, 234642),
(276990, '5jo4D01', NULL, NULL, 107, NULL, NULL, 234642),
(276991, '1x5zA01', NULL, NULL, 105, NULL, NULL, 234642),
(276992, '6b6lA05', NULL, NULL, 109, NULL, NULL, 234642),
(276993, '1uywL01', NULL, NULL, 108, NULL, NULL, 234642),
(276994, '5o05C00', NULL, NULL, 120, NULL, NULL, 234642),
(276995, '2qhlD00', NULL, NULL, 111, NULL, NULL, 234642),
(276996, '5ggvL01', NULL, NULL, 107, NULL, NULL, 234642),
(276997, '1xauA00', NULL, NULL, 122, NULL, NULL, 234642),
(276998, '3kyaA01', NULL, NULL, 85, NULL, NULL, 234642),
(276999, '5tdpA02', NULL, NULL, 103, NULL, NULL, 234642),
(277000, '4ut9H00', NULL, NULL, 144, NULL, NULL, 234642),
(277001, '4jcmA04', NULL, NULL, 104, NULL, NULL, 234642),
(277002, '2d7mA01', NULL, NULL, 98, NULL, NULL, 234642),
(277003, '4jcmA03', NULL, NULL, 84, NULL, NULL, 234642),
(277004, '5weuA02', NULL, NULL, 96, NULL, NULL, 234642),
(277005, '2r39A00', NULL, NULL, 118, NULL, NULL, 234642),
(277006, '4j7rB01', NULL, NULL, 161, NULL, NULL, 234642),
(277007, '3durB00', NULL, NULL, 121, NULL, NULL, 234642),
(277008, '6a76L01', NULL, NULL, 108, NULL, NULL, 234642),
(277009, '4m6mH01', NULL, NULL, 117, NULL, NULL, 234642),
(277010, '4h1lG00', NULL, NULL, 113, NULL, NULL, 234642),
(277011, '1ry7B02', NULL, NULL, 118, NULL, NULL, 234642),
(277012, '1tqbC01', NULL, NULL, 113, NULL, NULL, 234642),
(277013, '5yxkA00', NULL, NULL, 111, NULL, NULL, 234642),
(277014, '1jelH01', NULL, NULL, 119, NULL, NULL, 234642),
(277015, '1jelH02', NULL, NULL, 96, NULL, NULL, 234642),
(277016, '1dr9A02', NULL, NULL, 96, NULL, NULL, 234642),
(277017, '1dr9A01', NULL, NULL, 105, NULL, NULL, 234642),
(277018, '4ebqH01', NULL, NULL, 119, NULL, NULL, 234642),
(277019, '5i8oH01', NULL, NULL, 116, NULL, NULL, 234642),
(277020, '6dfxG01', NULL, NULL, 113, NULL, NULL, 234642),
(277021, '3sqoL01', NULL, NULL, 108, NULL, NULL, 234642),
(277022, '3opzH01', NULL, NULL, 118, NULL, NULL, 234642),
(277023, '3eyfB01', NULL, NULL, 125, NULL, NULL, 234642),
(277024, '5f7kC00', NULL, NULL, 120, NULL, NULL, 234642),
(277025, '5uwcG02', NULL, NULL, 107, NULL, NULL, 234642),
(277026, '5uwcG03', NULL, NULL, 100, NULL, NULL, 234642),
(277027, '2ya0A01', NULL, NULL, 128, NULL, NULL, 234642),
(277028, '1ggbH01', NULL, NULL, 115, NULL, NULL, 234642),
(277029, '5dr5H01', NULL, NULL, 115, NULL, NULL, 234642),
(277030, '1mjuL01', NULL, NULL, 113, NULL, NULL, 234642),
(277031, '3cviH01', NULL, NULL, 120, NULL, NULL, 234642),
(277032, '1x4xA00', NULL, NULL, 106, NULL, NULL, 234642),
(277033, '3vxsE01', NULL, NULL, 115, NULL, NULL, 234642),
(277034, '5esvA01', NULL, NULL, 133, NULL, NULL, 234642),
(277035, '5f6iC01', NULL, NULL, 111, NULL, NULL, 234642),
(277036, '2dn7A00', NULL, NULL, 107, NULL, NULL, 234642),
(277037, '1ejoH01', NULL, NULL, 120, NULL, NULL, 234642),
(277038, '4wukH02', NULL, NULL, 109, NULL, NULL, 234642),
(277039, '1djsA01', NULL, NULL, 104, NULL, NULL, 234642),
(277040, '5jhlH01', NULL, NULL, 122, NULL, NULL, 234642),
(277041, '4wukH01', NULL, NULL, 126, NULL, NULL, 234642),
(277042, '5dfvC01', NULL, NULL, 121, NULL, NULL, 234642),
(277043, '1ai1H01', NULL, NULL, 121, NULL, NULL, 234642),
(277044, '2q7nA02', NULL, NULL, 110, NULL, NULL, 234642),
(277045, '2q7nA01', NULL, NULL, 89, NULL, NULL, 234642),
(277046, '2q7nA04', NULL, NULL, 101, NULL, NULL, 234642),
(277047, '2q7nA03', NULL, NULL, 80, NULL, NULL, 234642),
(277048, '4udtA01', NULL, NULL, 112, NULL, NULL, 234642),
(277049, '5lbsL00', NULL, NULL, 112, NULL, NULL, 234642),
(277050, '2q7nA05', NULL, NULL, 98, NULL, NULL, 234642),
(277051, '3twcH01', NULL, NULL, 135, NULL, NULL, 234642),
(277052, '4i0pC02', NULL, NULL, 100, NULL, NULL, 234642),
(277053, '5ldyA02', NULL, NULL, 106, NULL, NULL, 234642),
(277054, '3m8oL01', NULL, NULL, 112, NULL, NULL, 234642),
(277055, '1nezA02', NULL, NULL, 93, NULL, NULL, 234642),
(277056, '2v17H01', NULL, NULL, 123, NULL, NULL, 234642),
(277057, '4ojfH01', NULL, NULL, 118, NULL, NULL, 234642),
(277058, '5gz0A01', NULL, NULL, 108, NULL, NULL, 234642),
(277059, '4lk4A03', NULL, NULL, 112, NULL, NULL, 234642);
INSERT INTO "PUBLIC"."MODEL" VALUES
(277060, '5swzE01', NULL, NULL, 114, NULL, NULL, 234642),
(277061, '4xhjC01', NULL, NULL, 109, NULL, NULL, 234642),
(277062, '4jpvH01', NULL, NULL, 123, NULL, NULL, 234642),
(277063, '3lrsA01', NULL, NULL, 137, NULL, NULL, 234642),
(277064, '2hazA00', NULL, NULL, 105, NULL, NULL, 234642),
(277065, '1k6qL01', NULL, NULL, 108, NULL, NULL, 234642),
(277066, '1opgL01', NULL, NULL, 107, NULL, NULL, 234642),
(277067, '4py7A01', NULL, NULL, 122, NULL, NULL, 234642),
(277068, '3jbg700', NULL, NULL, 126, NULL, NULL, 234642),
(277069, '3ra7L01', NULL, NULL, 107, NULL, NULL, 234642),
(277070, '4zfoB01', NULL, NULL, 108, NULL, NULL, 234642),
(277071, '1l0qA02', NULL, NULL, 90, NULL, NULL, 234642),
(277072, '1c5dB01', NULL, NULL, 117, NULL, NULL, 234642),
(277073, '4kq4L01', NULL, NULL, 108, NULL, NULL, 234642),
(277074, '1c5dB02', NULL, NULL, 97, NULL, NULL, 234642),
(277075, '3omzA01', NULL, NULL, 138, NULL, NULL, 234642),
(277076, '4hjjL01', NULL, NULL, 111, NULL, NULL, 234642),
(277077, '4m61A01', NULL, NULL, 113, NULL, NULL, 234642),
(277078, '3omzA02', NULL, NULL, 102, NULL, NULL, 234642),
(277079, '4ouoA02', NULL, NULL, 118, NULL, NULL, 234642),
(277080, '5cusH01', NULL, NULL, 118, NULL, NULL, 234642),
(277081, '1u3hB00', NULL, NULL, 111, NULL, NULL, 234642),
(277082, '4ouoA01', NULL, NULL, 119, NULL, NULL, 234642),
(277083, '4zfzB00', NULL, NULL, 100, NULL, NULL, 234642),
(277084, '2c4fU00', NULL, NULL, 116, NULL, NULL, 234642),
(277085, '5e8eA01', NULL, NULL, 109, NULL, NULL, 234642),
(277086, '3piqA01', NULL, NULL, 130, NULL, NULL, 234642),
(277087, '2ocfD00', NULL, NULL, 93, NULL, NULL, 234642),
(277088, '3of6E00', NULL, NULL, 114, NULL, NULL, 234642),
(277089, '2cdfB01', NULL, NULL, 115, NULL, NULL, 234642),
(277090, '3rajH01', NULL, NULL, 120, NULL, NULL, 234642),
(277091, '3effB01', NULL, NULL, 124, NULL, NULL, 234642),
(277092, '4qf1A01', NULL, NULL, 120, NULL, NULL, 234642),
(277093, '4m1gL01', NULL, NULL, 109, NULL, NULL, 234642),
(277094, '2adgA01', NULL, NULL, 107, NULL, NULL, 234642),
(277095, '6h5nB02', NULL, NULL, 101, NULL, NULL, 234642),
(277096, '5b3jF01', NULL, NULL, 107, NULL, NULL, 234642),
(277097, '4l4jA02', NULL, NULL, 106, NULL, NULL, 234642),
(277098, '4f8tA02', NULL, NULL, 107, NULL, NULL, 234642),
(277099, '3es6B00', NULL, NULL, 118, NULL, NULL, 234642),
(277100, '5jtwA04', NULL, NULL, 102, NULL, NULL, 234642),
(277101, '5kveL00', NULL, NULL, 129, NULL, NULL, 234642),
(277102, '4l4jA01', NULL, NULL, 111, NULL, NULL, 234642),
(277103, '5ueaB01', NULL, NULL, 109, NULL, NULL, 234642),
(277104, '4mauL01', NULL, NULL, 112, NULL, NULL, 234642),
(277105, '3qumA01', NULL, NULL, 112, NULL, NULL, 234642),
(277106, '3qwrD00', NULL, NULL, 109, NULL, NULL, 234642),
(277107, '5trpH01', NULL, NULL, 122, NULL, NULL, 234642),
(277108, '4g9fD01', NULL, NULL, 114, NULL, NULL, 234642),
(277109, '1ivlA00', NULL, NULL, 107, NULL, NULL, 234642),
(277110, '1p4bH00', NULL, NULL, 124, NULL, NULL, 234642),
(277111, '4x6bA01', NULL, NULL, 113, NULL, NULL, 234642),
(277112, '5l0qC01', NULL, NULL, 121, NULL, NULL, 234642),
(277113, '4qrpK01', NULL, NULL, 111, NULL, NULL, 234642),
(277114, '3g6aA01', NULL, NULL, 108, NULL, NULL, 234642),
(277115, '4jdzA03', NULL, NULL, 115, NULL, NULL, 234642),
(277116, '2mcg101', NULL, NULL, 111, NULL, NULL, 234642),
(277117, '1bbjA01', NULL, NULL, 108, NULL, NULL, 234642),
(277118, '5tbdB00', NULL, NULL, 112, NULL, NULL, 234642),
(277119, '1lk3L01', NULL, NULL, 107, NULL, NULL, 234642),
(277120, '1lk3L02', NULL, NULL, 103, NULL, NULL, 234642),
(277121, '2zuvA02', NULL, NULL, 106, NULL, NULL, 234642),
(277122, '5wcdL01', NULL, NULL, 112, NULL, NULL, 234642),
(277123, '2qsvA01', NULL, NULL, 112, NULL, NULL, 234642),
(277124, '2qsvA02', NULL, NULL, 108, NULL, NULL, 234642),
(277125, '3vh8G01', NULL, NULL, 93, NULL, NULL, 234642),
(277126, '4wuuE01', NULL, NULL, 121, NULL, NULL, 234642),
(277127, '2eysB01', NULL, NULL, 114, NULL, NULL, 234642),
(277128, '3vh8G03', NULL, NULL, 101, NULL, NULL, 234642),
(277129, '3vh8G02', NULL, NULL, 99, NULL, NULL, 234642),
(277130, '5ivxF01', NULL, NULL, 111, NULL, NULL, 234642);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(277131, '1dqlL00', NULL, NULL, 106, NULL, NULL, 234642),
(277132, '5tp3A00', NULL, NULL, 125, NULL, NULL, 234642),
(277133, '1il1A01', NULL, NULL, 119, NULL, NULL, 234642),
(277134, '6bzuD01', NULL, NULL, 113, NULL, NULL, 234642),
(277135, '4ay0B02', NULL, NULL, 82, NULL, NULL, 234642),
(277136, '4xp4H01', NULL, NULL, 119, NULL, NULL, 234642),
(277137, '2uylA01', NULL, NULL, 113, NULL, NULL, 234642),
(277138, '5uekH02', NULL, NULL, 107, NULL, NULL, 234642),
(277139, '3s9dD01', NULL, NULL, 100, NULL, NULL, 234642),
(277140, '3s9dD02', NULL, NULL, 99, NULL, NULL, 234642),
(277141, '4zd3H01', NULL, NULL, 121, NULL, NULL, 234642),
(277142, '1l4iB01', NULL, NULL, 117, NULL, NULL, 234642),
(277143, '5y91B00', NULL, NULL, 97, NULL, NULL, 234642),
(277144, '6bhyB02', NULL, NULL, 110, NULL, NULL, 234642),
(277145, '3e8uL01', NULL, NULL, 112, NULL, NULL, 234642),
(277146, '5eh1A01', NULL, NULL, 108, NULL, NULL, 234642),
(277147, '5eh1A02', NULL, NULL, 97, NULL, NULL, 234642),
(277148, '1l4iB02', NULL, NULL, 82, NULL, NULL, 234642),
(277149, '2kutA01', NULL, NULL, 106, NULL, NULL, 234642),
(277150, '4g9fE01', NULL, NULL, 114, NULL, NULL, 234642),
(277151, '5m76A01', NULL, NULL, 110, NULL, NULL, 234642),
(277152, '1jfqH01', NULL, NULL, 121, NULL, NULL, 234642),
(277153, '1jfqH02', NULL, NULL, 101, NULL, NULL, 234642),
(277154, '4kvcH01', NULL, NULL, 121, NULL, NULL, 234642),
(277155, '5y9cL01', NULL, NULL, 107, NULL, NULL, 234642),
(277156, '1ncbH01', NULL, NULL, 120, NULL, NULL, 234642),
(277157, '3v6fA01', NULL, NULL, 124, NULL, NULL, 234642),
(277158, '4f15B01', NULL, NULL, 120, NULL, NULL, 234642),
(277159, '5tqaB01', NULL, NULL, 111, NULL, NULL, 234642),
(277160, '6bkdL01', NULL, NULL, 106, NULL, NULL, 234642),
(277161, '4kvnH01', NULL, NULL, 124, NULL, NULL, 234642),
(277162, '5fuzL01', NULL, NULL, 110, NULL, NULL, 234642),
(277163, '3ux9B01', NULL, NULL, 137, NULL, NULL, 234642),
(277164, '3ux9B02', NULL, NULL, 106, NULL, NULL, 234642),
(277165, '1wejH01', NULL, NULL, 117, NULL, NULL, 234642),
(277166, '1qa9B00', NULL, NULL, 95, NULL, NULL, 234642),
(277167, '4xmpH01', NULL, NULL, 132, NULL, NULL, 234642),
(277168, '1h3gB01', NULL, NULL, 92, NULL, NULL, 234642),
(277169, '1u6aL01', NULL, NULL, 109, NULL, NULL, 234642),
(277170, '5c6tL00', NULL, NULL, 107, NULL, NULL, 234642),
(277171, '1nbqA02', NULL, NULL, 105, NULL, NULL, 234642),
(277172, '1nbqA01', NULL, NULL, 104, NULL, NULL, 234642),
(277173, '4uu9B00', NULL, NULL, 111, NULL, NULL, 234642),
(277174, '1a7qH00', NULL, NULL, 116, NULL, NULL, 234642),
(277175, '5xajC01', NULL, NULL, 110, NULL, NULL, 234642),
(277176, '5vstA01', NULL, NULL, 107, NULL, NULL, 234642),
(277177, '3dvfA00', NULL, NULL, 107, NULL, NULL, 234642),
(277178, '1kxtB00', NULL, NULL, 127, NULL, NULL, 234642),
(277179, '1nbvH01', NULL, NULL, 121, NULL, NULL, 234642),
(277180, '5yxnB01', NULL, NULL, 112, NULL, NULL, 234642),
(277181, '4ydlB01', NULL, NULL, 121, NULL, NULL, 234642),
(277182, '5ushE01', NULL, NULL, 112, NULL, NULL, 234642),
(277183, '1kjvB00', NULL, NULL, 100, NULL, NULL, 234642),
(277184, '3o6kH01', NULL, NULL, 117, NULL, NULL, 234642),
(277185, '5f3hB01', NULL, NULL, 108, NULL, NULL, 234642),
(277186, '3cfbB01', NULL, NULL, 113, NULL, NULL, 234642),
(277187, '4hweH01', NULL, NULL, 119, NULL, NULL, 234642),
(277188, '2rgsA01', NULL, NULL, 100, NULL, NULL, 234642),
(277189, '2rgsA02', NULL, NULL, 109, NULL, NULL, 234642),
(277190, '3uzqA01', NULL, NULL, 121, NULL, NULL, 234642),
(277191, '3uzqA02', NULL, NULL, 114, NULL, NULL, 234642),
(277192, '4z0xA00', NULL, NULL, 105, NULL, NULL, 234642),
(277193, '4nzdB01', NULL, NULL, 99, NULL, NULL, 234642),
(277194, '5v6mL01', NULL, NULL, 114, NULL, NULL, 234642),
(277195, '5fb8B01', NULL, NULL, 121, NULL, NULL, 234642),
(277196, '1ad0B01', NULL, NULL, 121, NULL, NULL, 234642),
(277197, '6b70D01', NULL, NULL, 108, NULL, NULL, 234642),
(277198, '1sjxA00', NULL, NULL, 122, NULL, NULL, 234642),
(277199, '4jryD01', NULL, NULL, 111, NULL, NULL, 234642),
(277200, '6b0aL01', NULL, NULL, 106, NULL, NULL, 234642),
(277201, '4x83D01', NULL, NULL, 106, NULL, NULL, 234642);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(277202, '4k3dL02', NULL, NULL, 101, NULL, NULL, 234642),
(277203, '5ag8A01', NULL, NULL, 87, NULL, NULL, 234642),
(277204, '3v7aE01', NULL, NULL, 121, NULL, NULL, 234642),
(277205, '1pkqA01', NULL, NULL, 114, NULL, NULL, 234642),
(277206, '4nikB01', NULL, NULL, 119, NULL, NULL, 234642),
(277207, '5nbiL01', NULL, NULL, 112, NULL, NULL, 234642),
(277208, '4nikB02', NULL, NULL, 104, NULL, NULL, 234642),
(277209, '6b0wL01', NULL, NULL, 108, NULL, NULL, 234642),
(277210, '5kvmC00', NULL, NULL, 95, NULL, NULL, 234642),
(277211, '5th9J00', NULL, NULL, 106, NULL, NULL, 234642),
(277212, '4r26L01', NULL, NULL, 109, NULL, NULL, 234642),
(277213, '6atfB02', NULL, NULL, 107, NULL, NULL, 234642),
(277214, '3pnwV01', NULL, NULL, 111, NULL, NULL, 234642),
(277215, '4z18A02', NULL, NULL, 107, NULL, NULL, 234642),
(277216, '4cffD01', NULL, NULL, 96, NULL, NULL, 234642),
(277217, '4lasL00', NULL, NULL, 115, NULL, NULL, 234642),
(277218, '6nb8L01', NULL, NULL, 112, NULL, NULL, 234642),
(277219, '4nzdB02', NULL, NULL, 120, NULL, NULL, 234642),
(277220, '3nfsL01', NULL, NULL, 107, NULL, NULL, 234642),
(277221, '2wanA03', NULL, NULL, 102, NULL, NULL, 234642),
(277222, '4hieB01', NULL, NULL, 120, NULL, NULL, 234642),
(277223, '4zs7L01', NULL, NULL, 111, NULL, NULL, 234642),
(277224, '5j7cD00', NULL, NULL, 102, NULL, NULL, 234642),
(277225, '2wanA02', NULL, NULL, 103, NULL, NULL, 234642),
(277226, '1iakB02', NULL, NULL, 98, NULL, NULL, 234642),
(277227, '3v4vL01', NULL, NULL, 113, NULL, NULL, 234642),
(277228, '3fn0H01', NULL, NULL, 126, NULL, NULL, 234642),
(277229, '4hieB02', NULL, NULL, 111, NULL, NULL, 234642),
(277230, '4eigB00', NULL, NULL, 123, NULL, NULL, 234642),
(277231, '2dlgA01', NULL, NULL, 80, NULL, NULL, 234642),
(277232, '5fcsH02', NULL, NULL, 137, NULL, NULL, 234642),
(277233, '2ekjA00', NULL, NULL, 105, NULL, NULL, 234642),
(277234, '5fcsH01', NULL, NULL, 111, NULL, NULL, 234642),
(277235, '1dlfH00', NULL, NULL, 124, NULL, NULL, 234642),
(277236, '5aumA01', NULL, NULL, 116, NULL, NULL, 234642),
(277237, '3mj6A02', NULL, NULL, 115, NULL, NULL, 234642),
(277238, '1b6dA01', NULL, NULL, 107, NULL, NULL, 234642),
(277239, '6ek2H02', NULL, NULL, 100, NULL, NULL, 234642),
(277240, '3qehA01', NULL, NULL, 125, NULL, NULL, 234642),
(277241, '3mj6A01', NULL, NULL, 123, NULL, NULL, 234642),
(277242, '4bsjA01', NULL, NULL, 90, NULL, NULL, 234642),
(277243, '5d2nE01', NULL, NULL, 118, NULL, NULL, 234642),
(277244, '4bsjA02', NULL, NULL, 142, NULL, NULL, 234642),
(277245, '4o02L01', NULL, NULL, 107, NULL, NULL, 234642),
(277246, '1wwbX00', NULL, NULL, 103, NULL, NULL, 234642),
(277247, '4k7pX01', NULL, NULL, 106, NULL, NULL, 234642),
(277248, '4nzuL01', NULL, NULL, 107, NULL, NULL, 234642),
(277249, '4nzuL02', NULL, NULL, 104, NULL, NULL, 234642),
(277250, '1ce1L01', NULL, NULL, 108, NULL, NULL, 234642),
(277251, '3kvqA00', NULL, NULL, 108, NULL, NULL, 234642),
(277252, '5t33H01', NULL, NULL, 120, NULL, NULL, 234642),
(277253, '2bdnH01', NULL, NULL, 117, NULL, NULL, 234642),
(277254, '5fehD01', NULL, NULL, 134, NULL, NULL, 234642),
(277255, '4l8sC03', NULL, NULL, 101, NULL, NULL, 234642),
(277256, '2esvE01', NULL, NULL, 111, NULL, NULL, 234642),
(277257, '5f1oB00', NULL, NULL, 128, NULL, NULL, 234642),
(277258, '4zxbC01', NULL, NULL, 114, NULL, NULL, 234642),
(277259, '3t0wA00', NULL, NULL, 123, NULL, NULL, 234642),
(277260, '1k8iA02', NULL, NULL, 104, NULL, NULL, 234642),
(277261, '5i8kL01', NULL, NULL, 111, NULL, NULL, 234642),
(277262, '2dm2A00', NULL, NULL, 110, NULL, NULL, 234642),
(277263, '3mv7E01', NULL, NULL, 112, NULL, NULL, 234642),
(277264, '6mtsL01', NULL, NULL, 110, NULL, NULL, 234642),
(277265, '4c54A01', NULL, NULL, 104, NULL, NULL, 234642),
(277266, '5m02G01', NULL, NULL, 118, NULL, NULL, 234642),
(277267, '4r7nA01', NULL, NULL, 118, NULL, NULL, 234642),
(277268, '1mfaH01', NULL, NULL, 97, NULL, NULL, 234642),
(277269, '4rx4L01', NULL, NULL, 107, NULL, NULL, 234642),
(277270, '2p4aB00', NULL, NULL, 121, NULL, NULL, 234642),
(277271, '4p48A01', NULL, NULL, 131, NULL, NULL, 234642),
(277272, '4p48A02', NULL, NULL, 111, NULL, NULL, 234642);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(277273, '1dfbH01', NULL, NULL, 126, NULL, NULL, 234642),
(277274, '4zdhB01', NULL, NULL, 112, NULL, NULL, 234642),
(277275, '4zdhB02', NULL, NULL, 129, NULL, NULL, 234642),
(277276, '5u3oH01', NULL, NULL, 132, NULL, NULL, 234642),
(277277, '3mxwL01', NULL, NULL, 108, NULL, NULL, 234642),
(277278, '4dkfH01', NULL, NULL, 118, NULL, NULL, 234642),
(277279, '4zfgL01', NULL, NULL, 108, NULL, NULL, 234642),
(277280, '2if7D01', NULL, NULL, 106, NULL, NULL, 234642),
(277281, '2edrA01', NULL, NULL, 88, NULL, NULL, 234642),
(277282, '2gy5A04', NULL, NULL, 99, NULL, NULL, 234642),
(277283, '4gg6D02', NULL, NULL, 108, NULL, NULL, 234642),
(277284, '2diaA01', NULL, NULL, 96, NULL, NULL, 234642),
(277285, '3lpwA01', NULL, NULL, 99, NULL, NULL, 234642),
(277286, '6hkgB01', NULL, NULL, 109, NULL, NULL, 234642),
(277287, '3lpwA02', NULL, NULL, 98, NULL, NULL, 234642),
(277288, '4lqfH01', NULL, NULL, 117, NULL, NULL, 234642),
(277289, '2gy5A01', NULL, NULL, 99, NULL, NULL, 234642),
(277290, '1kcrH02', NULL, NULL, 99, NULL, NULL, 234642),
(277291, '2gy5A02', NULL, NULL, 90, NULL, NULL, 234642),
(277292, '3vfgL01', NULL, NULL, 105, NULL, NULL, 234642),
(277293, '1kcrH01', NULL, NULL, 116, NULL, NULL, 234642),
(277294, '3fkuS01', NULL, NULL, 139, NULL, NULL, 234642),
(277295, '1fgnH01', NULL, NULL, 117, NULL, NULL, 234642),
(277296, '2g60L01', NULL, NULL, 113, NULL, NULL, 234642),
(277297, '5dhvH00', NULL, NULL, 117, NULL, NULL, 234642),
(277298, '5cgyC01', NULL, NULL, 127, NULL, NULL, 234642),
(277299, '3fkuS02', NULL, NULL, 103, NULL, NULL, 234642),
(277300, '4ktyB04', NULL, NULL, 101, NULL, NULL, 234642),
(277301, '1t7vA02', NULL, NULL, 90, NULL, NULL, 234642),
(277302, '4dkaA00', NULL, NULL, 127, NULL, NULL, 234642),
(277303, '2yd6A01', NULL, NULL, 101, NULL, NULL, 234642),
(277304, '5f6hI01', NULL, NULL, 117, NULL, NULL, 234642),
(277305, '2yd6A02', NULL, NULL, 111, NULL, NULL, 234642),
(277306, '3mlyH01', NULL, NULL, 127, NULL, NULL, 234642),
(277307, '1e6oH01', NULL, NULL, 120, NULL, NULL, 234642),
(277308, '4lpuA00', NULL, NULL, 98, NULL, NULL, 234642),
(277309, '4jqiL02', NULL, NULL, 81, NULL, NULL, 234642),
(277310, '5ebgA00', NULL, NULL, 115, NULL, NULL, 234642),
(277311, '5fm8A01', NULL, NULL, 97, NULL, NULL, 234642),
(277312, '2co7B02', NULL, NULL, 83, NULL, NULL, 234642),
(277313, '2co7B01', NULL, NULL, 120, NULL, NULL, 234642),
(277314, '3gsnB01', NULL, NULL, 114, NULL, NULL, 234642),
(277315, '6crkH02', NULL, NULL, 121, NULL, NULL, 234642),
(277316, '4m7kL01', NULL, NULL, 114, NULL, NULL, 234642),
(277317, '1jglL01', NULL, NULL, 108, NULL, NULL, 234642),
(277318, '4mmzC00', NULL, NULL, 98, NULL, NULL, 234642),
(277319, '5cmaB01', NULL, NULL, 118, NULL, NULL, 234642),
(277320, '6cseB01', NULL, NULL, 108, NULL, NULL, 234642),
(277321, '5lhnB00', NULL, NULL, 135, NULL, NULL, 234642),
(277322, '3idgA01', NULL, NULL, 107, NULL, NULL, 234642),
(277323, '1qokA01', NULL, NULL, 120, NULL, NULL, 234642),
(277324, '2bk8A00', NULL, NULL, 97, NULL, NULL, 234642),
(277325, '4ocrL01', NULL, NULL, 112, NULL, NULL, 234642),
(277326, '2g5rA00', NULL, NULL, 127, NULL, NULL, 234642),
(277327, '4lsuH01', NULL, NULL, 122, NULL, NULL, 234642),
(277328, '5cd3A01', NULL, NULL, 120, NULL, NULL, 234642),
(277329, '3g04B01', NULL, NULL, 121, NULL, NULL, 234642),
(277330, '4ki5E01', NULL, NULL, 122, NULL, NULL, 234642),
(277331, '2xfxB00', NULL, NULL, 99, NULL, NULL, 234642),
(277332, '3ls5H01', NULL, NULL, 117, NULL, NULL, 234642),
(277333, '1q9wB01', NULL, NULL, 124, NULL, NULL, 234642),
(277334, '1ollA02', NULL, NULL, 93, NULL, NULL, 234642),
(277335, '1ollA01', NULL, NULL, 95, NULL, NULL, 234642),
(277336, '5ks9F01', NULL, NULL, 113, NULL, NULL, 234642),
(277337, '3ggwA01', NULL, NULL, 113, NULL, NULL, 234642),
(277338, '4uaoC01', NULL, NULL, 121, NULL, NULL, 234642),
(277339, '2e6jA00', NULL, NULL, 112, NULL, NULL, 234642),
(277340, '5ksbE01', NULL, NULL, 112, NULL, NULL, 234642),
(277341, '1flrH01', NULL, NULL, 118, NULL, NULL, 234642),
(277342, '5vf6A01', NULL, NULL, 126, NULL, NULL, 234642),
(277343, '5wk2L01', NULL, NULL, 113, NULL, NULL, 234642);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(277344, '3t2nL01', NULL, NULL, 110, NULL, NULL, 234642),
(277345, '4m00A04', NULL, NULL, 91, NULL, NULL, 234642),
(277346, '4pjeF01', NULL, NULL, 116, NULL, NULL, 234642),
(277347, '6brbD00', NULL, NULL, 87, NULL, NULL, 234642),
(277348, '4r7dD01', NULL, NULL, 107, NULL, NULL, 234642),
(277349, '5tlkC01', NULL, NULL, 111, NULL, NULL, 234642),
(277350, '4ncdA01', NULL, NULL, 127, NULL, NULL, 234642),
(277351, '3amlA02', NULL, NULL, 115, NULL, NULL, 234642),
(277352, '4x80L01', NULL, NULL, 108, NULL, NULL, 234642),
(277353, '6g8rA02', NULL, NULL, 115, NULL, NULL, 234642),
(277354, '2orbI01', NULL, NULL, 127, NULL, NULL, 234642),
(277355, '3mlrL01', NULL, NULL, 117, NULL, NULL, 234642),
(277356, '5uxqA01', NULL, NULL, 139, NULL, NULL, 234642),
(277357, '5gmqB01', NULL, NULL, 124, NULL, NULL, 234642),
(277358, '3pucA00', NULL, NULL, 99, NULL, NULL, 234642),
(277359, '3p30H01', NULL, NULL, 126, NULL, NULL, 234642),
(277360, '3s34L01', NULL, NULL, 107, NULL, NULL, 234642),
(277361, '4hcrL01', NULL, NULL, 112, NULL, NULL, 234642),
(277362, '2rblB00', NULL, NULL, 104, NULL, NULL, 234642),
(277363, '1kcvL02', NULL, NULL, 103, NULL, NULL, 234642),
(277364, '1kcvL01', NULL, NULL, 108, NULL, NULL, 234642),
(277365, '5ghlA00', NULL, NULL, 108, NULL, NULL, 234642),
(277366, '4e9lA03', NULL, NULL, 106, NULL, NULL, 234642),
(277367, '1c5cH01', NULL, NULL, 112, NULL, NULL, 234642),
(277368, '1orsB01', NULL, NULL, 118, NULL, NULL, 234642),
(277369, '4of8A02', NULL, NULL, 112, NULL, NULL, 234642),
(277370, '3gfuA02', NULL, NULL, 84, NULL, NULL, 234642),
(277371, '1k5nA02', NULL, NULL, 95, NULL, NULL, 234642),
(277372, '4jvuA00', NULL, NULL, 117, NULL, NULL, 234642),
(277373, '5w3mG00', NULL, NULL, 107, NULL, NULL, 234642),
(277374, '2k7pA01', NULL, NULL, 78, NULL, NULL, 234642),
(277375, '1ac6A00', NULL, NULL, 110, NULL, NULL, 234642),
(277376, '3jtsA02', NULL, NULL, 91, NULL, NULL, 234642),
(277377, '1mlbA01', NULL, NULL, 108, NULL, NULL, 234642),
(277378, '2d7pA00', NULL, NULL, 112, NULL, NULL, 234642),
(277379, '3d9aH01', NULL, NULL, 113, NULL, NULL, 234642),
(277380, '3d9aH02', NULL, NULL, 97, NULL, NULL, 234642),
(277381, '1h8nA01', NULL, NULL, 131, NULL, NULL, 234642),
(277382, '2yz1A01', NULL, NULL, 112, NULL, NULL, 234642),
(277383, '2w91A03', NULL, NULL, 116, NULL, NULL, 234642),
(277384, '1h8nA02', NULL, NULL, 99, NULL, NULL, 234642),
(277385, '3gfuA01', NULL, NULL, 113, NULL, NULL, 234642),
(277386, '4e9lA01', NULL, NULL, 106, NULL, NULL, 234642),
(277387, '4e9lA02', NULL, NULL, 102, NULL, NULL, 234642),
(277388, '4idjH01', NULL, NULL, 125, NULL, NULL, 234642),
(277389, '4ersH01', NULL, NULL, 128, NULL, NULL, 234642),
(277390, '7fabH01', NULL, NULL, 117, NULL, NULL, 234642),
(277391, '4y89A01', NULL, NULL, 108, NULL, NULL, 234642),
(277392, '4wtwA00', NULL, NULL, 96, NULL, NULL, 234642),
(277393, '2ck0L01', NULL, NULL, 113, NULL, NULL, 234642),
(277394, '5k9jH01', NULL, NULL, 126, NULL, NULL, 234642),
(277395, '4d9lH01', NULL, NULL, 121, NULL, NULL, 234642),
(277396, '1imhC02', NULL, NULL, 106, NULL, NULL, 234642),
(277397, '2q86A01', NULL, NULL, 110, NULL, NULL, 234642),
(277398, '4onfH01', NULL, NULL, 119, NULL, NULL, 234642),
(277399, '1mieL01', NULL, NULL, 113, NULL, NULL, 234642),
(277400, '1p7kH01', NULL, NULL, 119, NULL, NULL, 234642),
(277401, '5gs2H01', NULL, NULL, 127, NULL, NULL, 234642),
(277402, '4ag4H01', NULL, NULL, 116, NULL, NULL, 234642),
(277403, '4hihC01', NULL, NULL, 111, NULL, NULL, 234642),
(277404, '2uvfA01', NULL, NULL, 116, NULL, NULL, 234642),
(277405, '3cmoX01', NULL, NULL, 106, NULL, NULL, 234642),
(277406, '3u9pL01', NULL, NULL, 108, NULL, NULL, 234642),
(277407, '3nvqA03', NULL, NULL, 85, NULL, NULL, 234642),
(277408, '5durH01', NULL, NULL, 121, NULL, NULL, 234642),
(277409, '3u9pL02', NULL, NULL, 104, NULL, NULL, 234642),
(277410, '1pz5B01', NULL, NULL, 120, NULL, NULL, 234642),
(277411, '1pz5B02', NULL, NULL, 99, NULL, NULL, 234642),
(277412, '4cvuA05', NULL, NULL, 89, NULL, NULL, 234642),
(277413, '1sy6A01', NULL, NULL, 82, NULL, NULL, 234642),
(277414, '3tnmA01', NULL, NULL, 123, NULL, NULL, 234642);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(277415, '3noiA00', NULL, NULL, 120, NULL, NULL, 234642),
(277416, '5n4jL01', NULL, NULL, 111, NULL, NULL, 234642),
(277417, '4nkoB00', NULL, NULL, 131, NULL, NULL, 234642),
(277418, '6aq7L01', NULL, NULL, 106, NULL, NULL, 234642),
(277419, '5tr8L01', NULL, NULL, 108, NULL, NULL, 234642),
(277420, '3ejjX02', NULL, NULL, 99, NULL, NULL, 234642),
(277421, '3ejjX03', NULL, NULL, 104, NULL, NULL, 234642),
(277422, '6mjjD02', NULL, NULL, 128, NULL, NULL, 234642),
(277423, '4w6yB00', NULL, NULL, 135, NULL, NULL, 234642),
(277424, '3ejjX01', NULL, NULL, 86, NULL, NULL, 234642),
(277425, '6mjjD01', NULL, NULL, 113, NULL, NULL, 234642),
(277426, '4cvuA02', NULL, NULL, 123, NULL, NULL, 234642),
(277427, '3sgeH01', NULL, NULL, 115, NULL, NULL, 234642),
(277428, '5ikcB01', NULL, NULL, 115, NULL, NULL, 234642),
(277429, '4cvuA04', NULL, NULL, 116, NULL, NULL, 234642),
(277430, '5dtfA01', NULL, NULL, 126, NULL, NULL, 234642),
(277431, '5da4A00', NULL, NULL, 125, NULL, NULL, 234642),
(277432, '5e6zC01', NULL, NULL, 107, NULL, NULL, 234642),
(277433, '3wxwL00', NULL, NULL, 107, NULL, NULL, 234642),
(277434, '4edxA01', NULL, NULL, 107, NULL, NULL, 234642),
(277435, '2ialB01', NULL, NULL, 111, NULL, NULL, 234642),
(277436, '2rheA00', NULL, NULL, 114, NULL, NULL, 234642),
(277437, '2yc1A00', NULL, NULL, 117, NULL, NULL, 234642),
(277438, '1i8kA00', NULL, NULL, 107, NULL, NULL, 234642),
(277439, '5vclA02', NULL, NULL, 93, NULL, NULL, 234642),
(277440, '2c4xA01', NULL, NULL, 98, NULL, NULL, 234642),
(277441, '1bm3H01', NULL, NULL, 125, NULL, NULL, 234642),
(277442, '1x5gA01', NULL, NULL, 86, NULL, NULL, 234642),
(277443, '1iilG02', NULL, NULL, 107, NULL, NULL, 234642),
(277444, '1ub5A02', NULL, NULL, 95, NULL, NULL, 234642),
(277445, '5eu7E01', NULL, NULL, 130, NULL, NULL, 234642),
(277446, '1g0dA04', NULL, NULL, 97, NULL, NULL, 234642),
(277447, '5xhvL01', NULL, NULL, 108, NULL, NULL, 234642),
(277448, '1g0dA03', NULL, NULL, 113, NULL, NULL, 234642),
(277449, '1g0dA01', NULL, NULL, 142, NULL, NULL, 234642),
(277450, '4fhbD00', NULL, NULL, 135, NULL, NULL, 234642),
(277451, '2yd3A02', NULL, NULL, 101, NULL, NULL, 234642),
(277452, '2yd3A01', NULL, NULL, 101, NULL, NULL, 234642),
(277453, '1pz5A01', NULL, NULL, 112, NULL, NULL, 234642),
(277454, '3it8D02', NULL, NULL, 119, NULL, NULL, 234642),
(277455, '3nz8B01', NULL, NULL, 113, NULL, NULL, 234642),
(277456, '1q72L02', NULL, NULL, 105, NULL, NULL, 234642),
(277457, '1q72L01', NULL, NULL, 113, NULL, NULL, 234642),
(277458, '1ospL01', NULL, NULL, 108, NULL, NULL, 234642),
(277459, '4g7vH01', NULL, NULL, 119, NULL, NULL, 234642),
(277460, '3iylW05', NULL, NULL, 96, NULL, NULL, 234642),
(277461, '5wl1A02', NULL, NULL, 101, NULL, NULL, 234642),
(277462, '4hzlB01', NULL, NULL, 113, NULL, NULL, 234642),
(277463, '1nlbL01', NULL, NULL, 114, NULL, NULL, 234642),
(277464, '5wjoA01', NULL, NULL, 110, NULL, NULL, 234642),
(277465, '5drxA01', NULL, NULL, 126, NULL, NULL, 234642),
(277466, '4o9hL01', NULL, NULL, 110, NULL, NULL, 234642),
(277467, '4yhyB01', NULL, NULL, 121, NULL, NULL, 234642),
(277468, '5jp0A03', NULL, NULL, 136, NULL, NULL, 234642),
(277469, '5d1qD01', NULL, NULL, 110, NULL, NULL, 234642),
(277470, '2j8hA01', NULL, NULL, 99, NULL, NULL, 234642),
(277471, '2j8hA02', NULL, NULL, 98, NULL, NULL, 234642),
(277472, '3u7yH01', NULL, NULL, 125, NULL, NULL, 234642),
(277473, '4jmhA02', NULL, NULL, 97, NULL, NULL, 234642),
(277474, '4cadB01', NULL, NULL, 125, NULL, NULL, 234642),
(277475, '3lrsB01', NULL, NULL, 109, NULL, NULL, 234642),
(277476, '2xg5A02', NULL, NULL, 92, NULL, NULL, 234642),
(277477, '2bnuB01', NULL, NULL, 112, NULL, NULL, 234642),
(277478, '1mamH01', NULL, NULL, 120, NULL, NULL, 234642),
(277479, '2bnuB02', NULL, NULL, 126, NULL, NULL, 234642),
(277480, '2r0lH01', NULL, NULL, 117, NULL, NULL, 234642),
(277481, '4i18A01', NULL, NULL, 128, NULL, NULL, 234642),
(277482, '4tprL01', NULL, NULL, 113, NULL, NULL, 234642),
(277483, '6iscB00', NULL, NULL, 118, NULL, NULL, 234642),
(277484, '5joeA00', NULL, NULL, 92, NULL, NULL, 234642),
(277485, '4qlrB00', NULL, NULL, 130, NULL, NULL, 234642);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(277486, '6mlkL01', NULL, NULL, 128, NULL, NULL, 234642),
(277487, '3ojdB01', NULL, NULL, 124, NULL, NULL, 234642),
(277488, '1dl7H00', NULL, NULL, 112, NULL, NULL, 234642),
(277489, '1i9rH01', NULL, NULL, 112, NULL, NULL, 234642),
(277490, '5gmqC01', NULL, NULL, 109, NULL, NULL, 234642),
(277491, '3qpxH01', NULL, NULL, 119, NULL, NULL, 234642),
(277492, '2c1pL01', NULL, NULL, 113, NULL, NULL, 234642),
(277493, '3s3jA01', NULL, NULL, 148, NULL, NULL, 234642),
(277494, '5bmfH01', NULL, NULL, 116, NULL, NULL, 234642),
(277495, '6gsiE02', NULL, NULL, 103, NULL, NULL, 234642),
(277496, '1b4jH01', NULL, NULL, 117, NULL, NULL, 234642),
(277497, '2r29H01', NULL, NULL, 116, NULL, NULL, 234642),
(277498, '4npyB01', NULL, NULL, 132, NULL, NULL, 234642),
(277499, '3qhzM01', NULL, NULL, 112, NULL, NULL, 234642),
(277500, '4h88H02', NULL, NULL, 99, NULL, NULL, 234642),
(277501, '4h88H01', NULL, NULL, 119, NULL, NULL, 234642),
(277502, '2hrpH01', NULL, NULL, 125, NULL, NULL, 234642),
(277503, '1axiB02', NULL, NULL, 101, NULL, NULL, 234642),
(277504, '1axiB01', NULL, NULL, 100, NULL, NULL, 234642),
(277505, '4lspH01', NULL, NULL, 131, NULL, NULL, 234642),
(277506, '1mvfB00', NULL, NULL, 135, NULL, NULL, 234642),
(277507, '1r6vA04', NULL, NULL, 112, NULL, NULL, 234642),
(277508, '5ywfA01', NULL, NULL, 103, NULL, NULL, 234642),
(277509, '4z7wF01', NULL, NULL, 112, NULL, NULL, 234642),
(277510, '3bd3A00', NULL, NULL, 112, NULL, NULL, 234642),
(277511, '4okvA01', NULL, NULL, 113, NULL, NULL, 234642),
(277512, '5e9dJ00', NULL, NULL, 114, NULL, NULL, 234642),
(277513, '6dkjB01', NULL, NULL, 108, NULL, NULL, 234642),
(277514, '4g3yH01', NULL, NULL, 120, NULL, NULL, 234642),
(277515, '5vi4C01', NULL, NULL, 118, NULL, NULL, 234642),
(277516, '5vi4C02', NULL, NULL, 102, NULL, NULL, 234642),
(277517, '4wemB00', NULL, NULL, 127, NULL, NULL, 234642),
(277518, '4f8qA02', NULL, NULL, 100, NULL, NULL, 234642),
(277519, '1lmkA02', NULL, NULL, 116, NULL, NULL, 234642),
(277520, '4wfeE01', NULL, NULL, 116, NULL, NULL, 234642),
(277521, '4ybqF00', NULL, NULL, 120, NULL, NULL, 234642),
(277522, '1iqwH01', NULL, NULL, 121, NULL, NULL, 234642),
(277523, '1lmkA01', NULL, NULL, 122, NULL, NULL, 234642),
(277524, '2z4qA01', NULL, NULL, 113, NULL, NULL, 234642),
(277525, '6bj8H02', NULL, NULL, 126, NULL, NULL, 234642),
(277526, '4x7sL01', NULL, NULL, 111, NULL, NULL, 234642),
(277527, '2cmrH01', NULL, NULL, 119, NULL, NULL, 234642),
(277528, '2hffA01', NULL, NULL, 108, NULL, NULL, 234642),
(277529, '6c09A02', NULL, NULL, 101, NULL, NULL, 234642),
(277530, '5yfiL01', NULL, NULL, 108, NULL, NULL, 234642),
(277531, '6bj8H01', NULL, NULL, 113, NULL, NULL, 234642),
(277532, '6azxB01', NULL, NULL, 111, NULL, NULL, 234642),
(277533, '4ll9A02', NULL, NULL, 98, NULL, NULL, 234642),
(277534, '3kyoA02', NULL, NULL, 91, NULL, NULL, 234642),
(277535, '4yueL01', NULL, NULL, 111, NULL, NULL, 234642),
(277536, '3kr3L01', NULL, NULL, 108, NULL, NULL, 234642),
(277537, '5immB00', NULL, NULL, 131, NULL, NULL, 234642),
(277538, '4uzgA02', NULL, NULL, 126, NULL, NULL, 234642),
(277539, '5xrqB01', NULL, NULL, 108, NULL, NULL, 234642),
(277540, '5yslB01', NULL, NULL, 109, NULL, NULL, 234642),
(277541, '3u30C01', NULL, NULL, 119, NULL, NULL, 234642),
(277542, '6bp2L01', NULL, NULL, 112, NULL, NULL, 234642),
(277543, '5umiL01', NULL, NULL, 105, NULL, NULL, 234642),
(277544, '4lkcA01', NULL, NULL, 107, NULL, NULL, 234642),
(277545, '3npsB02', NULL, NULL, 101, NULL, NULL, 234642),
(277546, '3npsB01', NULL, NULL, 125, NULL, NULL, 234642),
(277547, '6i8sI01', NULL, NULL, 107, NULL, NULL, 234642),
(277548, '2c9aA02', NULL, NULL, 97, NULL, NULL, 234642),
(277549, '2x1pA00', NULL, NULL, 127, NULL, NULL, 234642),
(277550, '4ut9O00', NULL, NULL, 116, NULL, NULL, 234642),
(277551, '2hwzH01', NULL, NULL, 120, NULL, NULL, 234642),
(277552, '5bopA00', NULL, NULL, 135, NULL, NULL, 234642),
(277553, '4tsbL01', NULL, NULL, 112, NULL, NULL, 234642),
(277554, '5jz7C00', NULL, NULL, 130, NULL, NULL, 234642),
(277555, '5mtmB00', NULL, NULL, 95, NULL, NULL, 234642),
(277556, '2p45B00', NULL, NULL, 123, NULL, NULL, 234642);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(277557, '2omnA01', NULL, NULL, 112, NULL, NULL, 234642),
(277558, '5ds8A01', NULL, NULL, 118, NULL, NULL, 234642),
(277559, '2xqbL01', NULL, NULL, 107, NULL, NULL, 234642),
(277560, '3bszH01', NULL, NULL, 118, NULL, NULL, 234642),
(277561, '4jr9L01', NULL, NULL, 107, NULL, NULL, 234642),
(277562, '4jpwL01', NULL, NULL, 104, NULL, NULL, 234642),
(277563, '5az2H01', NULL, NULL, 118, NULL, NULL, 234642),
(277564, '1f2qA01', NULL, NULL, 84, NULL, NULL, 234642),
(277565, '1f2qA02', NULL, NULL, 92, NULL, NULL, 234642),
(277566, '1blnA01', NULL, NULL, 113, NULL, NULL, 234642),
(277567, '2q6wB02', NULL, NULL, 97, NULL, NULL, 234642),
(277568, '3lcyA02', NULL, NULL, 97, NULL, NULL, 234642),
(277569, '1wfoA01', NULL, NULL, 104, NULL, NULL, 234642),
(277570, '6dfxH01', NULL, NULL, 109, NULL, NULL, 234642),
(277571, '6dc8H02', NULL, NULL, 100, NULL, NULL, 234642),
(277572, '3dmmD00', NULL, NULL, 126, NULL, NULL, 234642),
(277573, '1p7kA01', NULL, NULL, 108, NULL, NULL, 234642),
(277574, '4hdiB01', NULL, NULL, 121, NULL, NULL, 234642),
(277575, '5u4rB01', NULL, NULL, 107, NULL, NULL, 234642),
(277576, '3lcyA01', NULL, NULL, 100, NULL, NULL, 234642),
(277577, '3o6fC01', NULL, NULL, 111, NULL, NULL, 234642),
(277578, '4h20L01', NULL, NULL, 108, NULL, NULL, 234642),
(277579, '5wkzL01', NULL, NULL, 113, NULL, NULL, 234642),
(277580, '3s35X00', NULL, NULL, 122, NULL, NULL, 234642),
(277581, '2vzsA05', NULL, NULL, 102, NULL, NULL, 234642),
(277582, '2vzsA04', NULL, NULL, 123, NULL, NULL, 234642),
(277583, '3qumB01', NULL, NULL, 116, NULL, NULL, 234642),
(277584, '2vzsA02', NULL, NULL, 110, NULL, NULL, 234642),
(277585, '2ee2A01', NULL, NULL, 87, NULL, NULL, 234642),
(277586, '2znxA01', NULL, NULL, 125, NULL, NULL, 234642),
(277587, '2znxA02', NULL, NULL, 99, NULL, NULL, 234642),
(277588, '1xmwA02', NULL, NULL, 65, NULL, NULL, 234642),
(277589, '1figH01', NULL, NULL, 120, NULL, NULL, 234642),
(277590, '4f57H01', NULL, NULL, 125, NULL, NULL, 234642),
(277591, '5t3zE01', NULL, NULL, 109, NULL, NULL, 234642),
(277592, '1wlhA01', NULL, NULL, 108, NULL, NULL, 234642),
(277593, '1jnlL01', NULL, NULL, 108, NULL, NULL, 234642),
(277594, '5vzrL01', NULL, NULL, 112, NULL, NULL, 234642),
(277595, '5c0bJ01', NULL, NULL, 118, NULL, NULL, 234642),
(277596, '1ndmB01', NULL, NULL, 113, NULL, NULL, 234642),
(277597, '1z0nA00', NULL, NULL, 96, NULL, NULL, 234642),
(277598, '5e5uB02', NULL, NULL, 95, NULL, NULL, 234642),
(277599, '3p73A02', NULL, NULL, 90, NULL, NULL, 234642),
(277600, '4lriA01', NULL, NULL, 112, NULL, NULL, 234642),
(277601, '5awnH01', NULL, NULL, 128, NULL, NULL, 234642),
(277602, '2b1hH01', NULL, NULL, 124, NULL, NULL, 234642),
(277603, '5e5uB01', NULL, NULL, 104, NULL, NULL, 234642),
(277604, '2coqA00', NULL, NULL, 108, NULL, NULL, 234642),
(277605, '5ldyB01', NULL, NULL, 100, NULL, NULL, 234642),
(277606, '3rgvA01', NULL, NULL, 108, NULL, NULL, 234642),
(277607, '5ivxE01', NULL, NULL, 113, NULL, NULL, 234642),
(277608, '4d9qE01', NULL, NULL, 115, NULL, NULL, 234642),
(277609, '1ob1B01', NULL, NULL, 120, NULL, NULL, 234642),
(277610, '4njaH02', NULL, NULL, 112, NULL, NULL, 234642),
(277611, '4h0hB01', NULL, NULL, 129, NULL, NULL, 234642),
(277612, '3v6oC01', NULL, NULL, 118, NULL, NULL, 234642),
(277613, '3qeqD01', NULL, NULL, 107, NULL, NULL, 234642),
(277614, '4r96A01', NULL, NULL, 114, NULL, NULL, 234642),
(277615, '1u2hA00', NULL, NULL, 99, NULL, NULL, 234642),
(277616, '5y2kB01', NULL, NULL, 107, NULL, NULL, 234642),
(277617, '1ujtA00', NULL, NULL, 120, NULL, NULL, 234642),
(277618, '2g5bB01', NULL, NULL, 123, NULL, NULL, 234642),
(277619, '4r90H01', NULL, NULL, 122, NULL, NULL, 234642),
(277620, '4qt5B01', NULL, NULL, 112, NULL, NULL, 234642),
(277621, '4qrsB00', NULL, NULL, 100, NULL, NULL, 234642),
(277622, '4zfoA01', NULL, NULL, 120, NULL, NULL, 234642),
(277623, '4lrnH00', NULL, NULL, 127, NULL, NULL, 234642),
(277624, '5f6iB01', NULL, NULL, 117, NULL, NULL, 234642),
(277625, '2r2cB00', NULL, NULL, 131, NULL, NULL, 234642),
(277626, '4zfzA02', NULL, NULL, 91, NULL, NULL, 234642),
(277627, '2zpkH01', NULL, NULL, 116, NULL, NULL, 234642);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(277628, '3mclH01', NULL, NULL, 119, NULL, NULL, 234642),
(277629, '4tnwF01', NULL, NULL, 122, NULL, NULL, 234642),
(277630, '4ylqT02', NULL, NULL, 114, NULL, NULL, 234642),
(277631, '4ylqT01', NULL, NULL, 105, NULL, NULL, 234642),
(277632, '4fq2L01', NULL, NULL, 109, NULL, NULL, 234642),
(277633, '2dquL01', NULL, NULL, 113, NULL, NULL, 234642),
(277634, '4qhuB01', NULL, NULL, 115, NULL, NULL, 234642),
(277635, '2adgB01', NULL, NULL, 120, NULL, NULL, 234642),
(277636, '1qfwI00', NULL, NULL, 122, NULL, NULL, 234642),
(277637, '1x9qA02', NULL, NULL, 120, NULL, NULL, 234642),
(277638, '2zchL01', NULL, NULL, 112, NULL, NULL, 234642),
(277639, '5bv7B01', NULL, NULL, 108, NULL, NULL, 234642),
(277640, '3eyfA01', NULL, NULL, 110, NULL, NULL, 234642),
(277641, '5a16A01', NULL, NULL, 123, NULL, NULL, 234642),
(277642, '1x9qA01', NULL, NULL, 124, NULL, NULL, 234642),
(277643, '3mlwL01', NULL, NULL, 113, NULL, NULL, 234642),
(277644, '1bihA03', NULL, NULL, 100, NULL, NULL, 234642),
(277645, '1bihA04', NULL, NULL, 88, NULL, NULL, 234642),
(277646, '1eo8L01', NULL, NULL, 106, NULL, NULL, 234642),
(277647, '1bihA01', NULL, NULL, 101, NULL, NULL, 234642),
(277648, '1bihA02', NULL, NULL, 106, NULL, NULL, 234642),
(277649, '4zocA03', NULL, NULL, 125, NULL, NULL, 234642),
(277650, '3t3pE01', NULL, NULL, 119, NULL, NULL, 234642),
(277651, '4rwhA00', NULL, NULL, 106, NULL, NULL, 234642),
(277652, '2wv3A02', NULL, NULL, 100, NULL, NULL, 234642),
(277653, '5a40E00', NULL, NULL, 90, NULL, NULL, 234642),
(277654, '2wv3A01', NULL, NULL, 90, NULL, NULL, 234642),
(277655, '3i75A01', NULL, NULL, 108, NULL, NULL, 234642),
(277656, '5l0qB01', NULL, NULL, 108, NULL, NULL, 234642),
(277657, '3lizL01', NULL, NULL, 108, NULL, NULL, 234642),
(277658, '3l5wA01', NULL, NULL, 108, NULL, NULL, 234642),
(277659, '5dumH01', NULL, NULL, 127, NULL, NULL, 234642),
(277660, '3ubxI01', NULL, NULL, 108, NULL, NULL, 234642),
(277661, '1mhcA02', NULL, NULL, 101, NULL, NULL, 234642),
(277662, '3qwqB00', NULL, NULL, 114, NULL, NULL, 234642),
(277663, '4eskC00', NULL, NULL, 102, NULL, NULL, 234642),
(277664, '2xy2A02', NULL, NULL, 95, NULL, NULL, 234642),
(277665, '3k74B00', NULL, NULL, 115, NULL, NULL, 234642),
(277666, '3qhtC00', NULL, NULL, 97, NULL, NULL, 234642),
(277667, '3r1gH01', NULL, NULL, 119, NULL, NULL, 234642),
(277668, '1y0lA01', NULL, NULL, 110, NULL, NULL, 234642),
(277669, '2xy2A01', NULL, NULL, 94, NULL, NULL, 234642),
(277670, '4k2uL01', NULL, NULL, 107, NULL, NULL, 234642),
(277671, '4k2uL02', NULL, NULL, 103, NULL, NULL, 234642),
(277672, '5swzD01', NULL, NULL, 113, NULL, NULL, 234642),
(277673, '4nujA01', NULL, NULL, 112, NULL, NULL, 234642),
(277674, '4rgmC01', NULL, NULL, 121, NULL, NULL, 234642),
(277675, '4xhjD01', NULL, NULL, 120, NULL, NULL, 234642),
(277676, '6dfvB01', NULL, NULL, 112, NULL, NULL, 234642),
(277677, '4gmtL01', NULL, NULL, 108, NULL, NULL, 234642),
(277678, '3drqB01', NULL, NULL, 132, NULL, NULL, 234642),
(277679, '3ln9A00', NULL, NULL, 139, NULL, NULL, 234642),
(277680, '6ca6A01', NULL, NULL, 108, NULL, NULL, 234642),
(277681, '1j0hA01', NULL, NULL, 125, NULL, NULL, 234642),
(277682, '3oz9H01', NULL, NULL, 119, NULL, NULL, 234642),
(277683, '5wymC02', NULL, NULL, 108, NULL, NULL, 234642),
(277684, '4ei6D01', NULL, NULL, 116, NULL, NULL, 234642),
(277685, '3okyA02', NULL, NULL, 137, NULL, NULL, 234642),
(277686, '1c5dA01', NULL, NULL, 107, NULL, NULL, 234642),
(277687, '4m61B01', NULL, NULL, 120, NULL, NULL, 234642),
(277688, '5tihL01', NULL, NULL, 108, NULL, NULL, 234642),
(277689, '2p1yA01', NULL, NULL, 113, NULL, NULL, 234642),
(277690, '2p1yA02', NULL, NULL, 110, NULL, NULL, 234642),
(277691, '1dbbH01', NULL, NULL, 119, NULL, NULL, 234642),
(277692, '3abzA04', NULL, NULL, 124, NULL, NULL, 234642),
(277693, '1uwgH01', NULL, NULL, 117, NULL, NULL, 234642),
(277694, '5e8eB01', NULL, NULL, 125, NULL, NULL, 234642),
(277695, '1tqbB01', NULL, NULL, 113, NULL, NULL, 234642),
(277696, '3qcuL01', NULL, NULL, 112, NULL, NULL, 234642),
(277697, '2v5yA05', NULL, NULL, 100, NULL, NULL, 234642),
(277698, '2rq8A00', NULL, NULL, 98, NULL, NULL, 234642);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(277699, '5cckL01', NULL, NULL, 111, NULL, NULL, 234642),
(277700, '2v5yA03', NULL, NULL, 95, NULL, NULL, 234642),
(277701, '4r0lC00', NULL, NULL, 129, NULL, NULL, 234642),
(277702, '3ztnH01', NULL, NULL, 130, NULL, NULL, 234642),
(277703, '2v5yA04', NULL, NULL, 102, NULL, NULL, 234642),
(277704, '1ktkF02', NULL, NULL, 90, NULL, NULL, 234642),
(277705, '1bfvL00', NULL, NULL, 113, NULL, NULL, 234642),
(277706, '5yotA03', NULL, NULL, 125, NULL, NULL, 234642),
(277707, '5x2nK01', NULL, NULL, 112, NULL, NULL, 234642),
(277708, '3effA01', NULL, NULL, 110, NULL, NULL, 234642),
(277709, '4fqiL01', NULL, NULL, 111, NULL, NULL, 234642),
(277710, '1zanH01', NULL, NULL, 122, NULL, NULL, 234642),
(277711, '3ab0B00', NULL, NULL, 117, NULL, NULL, 234642),
(277712, '1zanH02', NULL, NULL, 99, NULL, NULL, 234642),
(277713, '3ijhB01', NULL, NULL, 126, NULL, NULL, 234642),
(277714, '4xi5D01', NULL, NULL, 121, NULL, NULL, 234642),
(277715, '5xajB01', NULL, NULL, 108, NULL, NULL, 234642),
(277716, '1mexH01', NULL, NULL, 114, NULL, NULL, 234642),
(277717, '1mexH02', NULL, NULL, 99, NULL, NULL, 234642),
(277718, '1fe8H01', NULL, NULL, 115, NULL, NULL, 234642),
(277719, '2uzyB04', NULL, NULL, 94, NULL, NULL, 234642),
(277720, '4l5fH01', NULL, NULL, 117, NULL, NULL, 234642),
(277721, '4uu9A00', NULL, NULL, 123, NULL, NULL, 234642),
(277722, '1fe8H02', NULL, NULL, 93, NULL, NULL, 234642),
(277723, '2uzyB03', NULL, NULL, 93, NULL, NULL, 234642),
(277724, '6bdzL01', NULL, NULL, 109, NULL, NULL, 234642),
(277725, '5wb9L01', NULL, NULL, 102, NULL, NULL, 234642),
(277726, '1fnlA02', NULL, NULL, 86, NULL, NULL, 234642),
(277727, '1fnlA01', NULL, NULL, 85, NULL, NULL, 234642),
(277728, '5fojA00', NULL, NULL, 137, NULL, NULL, 234642),
(277729, '3upcA00', NULL, NULL, 113, NULL, NULL, 234642),
(277730, '3tcxA00', NULL, NULL, 85, NULL, NULL, 234642),
(277731, '2gcyA01', NULL, NULL, 112, NULL, NULL, 234642),
(277732, '1iqdA01', NULL, NULL, 108, NULL, NULL, 234642),
(277733, '2cknA00', NULL, NULL, 95, NULL, NULL, 234642),
(277734, '2oypA00', NULL, NULL, 109, NULL, NULL, 234642),
(277735, '1i7zB01', NULL, NULL, 117, NULL, NULL, 234642),
(277736, '4ptuB01', NULL, NULL, 125, NULL, NULL, 234642),
(277737, '3lb6D02', NULL, NULL, 96, NULL, NULL, 234642),
(277738, '2q86B01', NULL, NULL, 111, NULL, NULL, 234642),
(277739, '1qkzL01', NULL, NULL, 112, NULL, NULL, 234642),
(277740, '4kaqL01', NULL, NULL, 107, NULL, NULL, 234642),
(277741, '4aqoA00', NULL, NULL, 92, NULL, NULL, 234642),
(277742, '3u0wL01', NULL, NULL, 108, NULL, NULL, 234642),
(277743, '1t0pB00', NULL, NULL, 86, NULL, NULL, 234642),
(277744, '4ocsH01', NULL, NULL, 144, NULL, NULL, 234642),
(277745, '5lspH01', NULL, NULL, 116, NULL, NULL, 234642),
(277746, '2edjA00', NULL, NULL, 100, NULL, NULL, 234642),
(277747, '5tf0B03', NULL, NULL, 115, NULL, NULL, 234642),
(277748, '4lpxA00', NULL, NULL, 100, NULL, NULL, 234642),
(277749, '4nrxD01', NULL, NULL, 130, NULL, NULL, 234642),
(277750, '1iamA02', NULL, NULL, 102, NULL, NULL, 234642),
(277751, '1iamA01', NULL, NULL, 83, NULL, NULL, 234642),
(277752, '3zo0A01', NULL, NULL, 100, NULL, NULL, 234642),
(277753, '6ca7L01', NULL, NULL, 108, NULL, NULL, 234642),
(277754, '4eupG01', NULL, NULL, 112, NULL, NULL, 234642),
(277755, '4djmA02', NULL, NULL, 83, NULL, NULL, 234642),
(277756, '5u68E02', NULL, NULL, 101, NULL, NULL, 234642),
(277757, '1il1B01', NULL, NULL, 113, NULL, NULL, 234642),
(277758, '3q6gI01', NULL, NULL, 134, NULL, NULL, 234642),
(277759, '1lp9F01', NULL, NULL, 111, NULL, NULL, 234642),
(277760, '1yuhH02', NULL, NULL, 99, NULL, NULL, 234642),
(277761, '1pskH01', NULL, NULL, 114, NULL, NULL, 234642),
(277762, '5sy8H01', NULL, NULL, 131, NULL, NULL, 234642),
(277763, '2e6pA01', NULL, NULL, 87, NULL, NULL, 234642),
(277764, '1hilB01', NULL, NULL, 120, NULL, NULL, 234642),
(277765, '5ibuB01', NULL, NULL, 109, NULL, NULL, 234642),
(277766, '5x4gB01', NULL, NULL, 108, NULL, NULL, 234642),
(277767, '6qn8B01', NULL, NULL, 111, NULL, NULL, 234642),
(277768, '2uylB01', NULL, NULL, 119, NULL, NULL, 234642),
(277769, '3gbnL01', NULL, NULL, 132, NULL, NULL, 234642);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(277770, '3gbnL02', NULL, NULL, 71, NULL, NULL, 234642),
(277771, '3pwuA02', NULL, NULL, 91, NULL, NULL, 234642),
(277772, '1zs8A02', NULL, NULL, 94, NULL, NULL, 234642),
(277773, '2g2rB01', NULL, NULL, 118, NULL, NULL, 234642),
(277774, '4djmA01', NULL, NULL, 127, NULL, NULL, 234642),
(277775, '1pg7X01', NULL, NULL, 120, NULL, NULL, 234642),
(277776, '1fnaA00', NULL, NULL, 91, NULL, NULL, 234642),
(277777, '1sm3H02', NULL, NULL, 99, NULL, NULL, 234642),
(277778, '4mxvF01', NULL, NULL, 118, NULL, NULL, 234642),
(277779, '1yqvH01', NULL, NULL, 116, NULL, NULL, 234642),
(277780, '1c7sA04', NULL, NULL, 66, NULL, NULL, 234642),
(277781, '6bfsL01', NULL, NULL, 108, NULL, NULL, 234642),
(277782, '5kvfH01', NULL, NULL, 119, NULL, NULL, 234642),
(277783, '1h3gA01', NULL, NULL, 92, NULL, NULL, 234642),
(277784, '3bkjH02', NULL, NULL, 99, NULL, NULL, 234642),
(277785, '5e6iA01', NULL, NULL, 114, NULL, NULL, 234642),
(277786, '1zmyA00', NULL, NULL, 142, NULL, NULL, 234642),
(277787, '3rhwN02', NULL, NULL, 74, NULL, NULL, 234642),
(277788, '4hsqA02', NULL, NULL, 128, NULL, NULL, 234642),
(277789, '2w59A01', NULL, NULL, 111, NULL, NULL, 234642),
(277790, '4od3H01', NULL, NULL, 144, NULL, NULL, 234642),
(277791, '3vrlE01', NULL, NULL, 122, NULL, NULL, 234642),
(277792, '4hs8L01', NULL, NULL, 111, NULL, NULL, 234642),
(277793, '6dw2A01', NULL, NULL, 108, NULL, NULL, 234642),
(277794, '6df3H01', NULL, NULL, 104, NULL, NULL, 234642),
(277795, '6df3H02', NULL, NULL, 86, NULL, NULL, 234642),
(277796, '2ajuH01', NULL, NULL, 119, NULL, NULL, 234642),
(277797, '2qv2A01', NULL, NULL, 130, NULL, NULL, 234642),
(277798, '5jo4B01', NULL, NULL, 109, NULL, NULL, 234642),
(277799, '4pp1D01', NULL, NULL, 120, NULL, NULL, 234642),
(277800, '2qteA00', NULL, NULL, 111, NULL, NULL, 234642),
(277801, '3tc9B01', NULL, NULL, 106, NULL, NULL, 234642),
(277802, '5j3hC00', NULL, NULL, 123, NULL, NULL, 234642),
(277803, '4mngE01', NULL, NULL, 119, NULL, NULL, 234642),
(277804, '4mngE02', NULL, NULL, 116, NULL, NULL, 234642),
(277805, '2ajuH02', NULL, NULL, 100, NULL, NULL, 234642),
(277806, '2uziL00', NULL, NULL, 104, NULL, NULL, 234642),
(277807, '4nm4L01', NULL, NULL, 113, NULL, NULL, 234642),
(277808, '5dc0A00', NULL, NULL, 93, NULL, NULL, 234642),
(277809, '4k7pY01', NULL, NULL, 122, NULL, NULL, 234642),
(277810, '1edqA01', NULL, NULL, 107, NULL, NULL, 234642),
(277811, '4p0dA03', NULL, NULL, 121, NULL, NULL, 234642),
(277812, '4m1dL01', NULL, NULL, 111, NULL, NULL, 234642),
(277813, '4j4pD01', NULL, NULL, 112, NULL, NULL, 234642),
(277814, '4ydlC01', NULL, NULL, 105, NULL, NULL, 234642),
(277815, '4k7pH01', NULL, NULL, 124, NULL, NULL, 234642),
(277816, '4ov6F00', NULL, NULL, 99, NULL, NULL, 234642),
(277817, '4k7pH02', NULL, NULL, 102, NULL, NULL, 234642),
(277818, '2esvD01', NULL, NULL, 109, NULL, NULL, 234642),
(277819, '1sq2N00', NULL, NULL, 113, NULL, NULL, 234642),
(277820, '2xqyG01', NULL, NULL, 124, NULL, NULL, 234642),
(277821, '2xfxA02', NULL, NULL, 91, NULL, NULL, 234642),
(277822, '2jjuA01', NULL, NULL, 123, NULL, NULL, 234642),
(277823, '2w60A01', NULL, NULL, 118, NULL, NULL, 234642),
(277824, '4z0xB00', NULL, NULL, 121, NULL, NULL, 234642),
(277825, '4fz8H01', NULL, NULL, 131, NULL, NULL, 234642),
(277826, '1v05A00', NULL, NULL, 96, NULL, NULL, 234642),
(277827, '5dmiL01', NULL, NULL, 108, NULL, NULL, 234642),
(277828, '3rrqA00', NULL, NULL, 129, NULL, NULL, 234642),
(277829, '2vn4A02', NULL, NULL, 114, NULL, NULL, 234642),
(277830, '3bkyL01', NULL, NULL, 107, NULL, NULL, 234642),
(277831, '5hi4C01', NULL, NULL, 118, NULL, NULL, 234642),
(277832, '1mimL01', NULL, NULL, 105, NULL, NULL, 234642),
(277833, '3lexB01', NULL, NULL, 113, NULL, NULL, 234642),
(277834, '6bynM00', NULL, NULL, 98, NULL, NULL, 234642),
(277835, '4orzC00', NULL, NULL, 120, NULL, NULL, 234642),
(277836, '2ww8A05', NULL, NULL, 123, NULL, NULL, 234642),
(277837, '4k3dM01', NULL, NULL, 111, NULL, NULL, 234642),
(277838, '4hf5H01', NULL, NULL, 130, NULL, NULL, 234642),
(277839, '3qpqD01', NULL, NULL, 119, NULL, NULL, 234642),
(277840, '5ou7C02', NULL, NULL, 91, NULL, NULL, 234642);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(277841, '1f6fB02', NULL, NULL, 101, NULL, NULL, 234642),
(277842, '1fbiH01', NULL, NULL, 122, NULL, NULL, 234642),
(277843, '1nfdE01', NULL, NULL, 108, NULL, NULL, 234642),
(277844, '2z35A00', NULL, NULL, 112, NULL, NULL, 234642),
(277845, '1f6fB01', NULL, NULL, 101, NULL, NULL, 234642),
(277846, '3tf7K02', NULL, NULL, 118, NULL, NULL, 234642),
(277847, '1nfdE02', NULL, NULL, 104, NULL, NULL, 234642),
(277848, '3mpcA00', NULL, NULL, 103, NULL, NULL, 234642),
(277849, '5ud8B00', NULL, NULL, 112, NULL, NULL, 234642),
(277850, '5w08H01', NULL, NULL, 109, NULL, NULL, 234642),
(277851, '5tpnL01', NULL, NULL, 108, NULL, NULL, 234642),
(277852, '5tzmA00', NULL, NULL, 100, NULL, NULL, 234642),
(277853, '1kfaL02', NULL, NULL, 102, NULL, NULL, 234642),
(277854, '4m43L01', NULL, NULL, 108, NULL, NULL, 234642),
(277855, '5n4gL01', NULL, NULL, 112, NULL, NULL, 234642),
(277856, '4n1cB00', NULL, NULL, 109, NULL, NULL, 234642),
(277857, '3l5iA01', NULL, NULL, 87, NULL, NULL, 234642),
(277858, '3l5iA02', NULL, NULL, 88, NULL, NULL, 234642),
(277859, '2ww8A01', NULL, NULL, 106, NULL, NULL, 234642),
(277860, '3l5iA03', NULL, NULL, 88, NULL, NULL, 234642),
(277861, '4h1lH00', NULL, NULL, 111, NULL, NULL, 234642),
(277862, '2kdgA00', NULL, NULL, 100, NULL, NULL, 234642),
(277863, '2vweC01', NULL, NULL, 107, NULL, NULL, 234642),
(277864, '2imnA00', NULL, NULL, 113, NULL, NULL, 234642),
(277865, '2di8A01', NULL, NULL, 94, NULL, NULL, 234642),
(277866, '1adqH01', NULL, NULL, 123, NULL, NULL, 234642),
(277867, '1l9mA01', NULL, NULL, 142, NULL, NULL, 234642),
(277868, '2x1wO01', NULL, NULL, 102, NULL, NULL, 234642),
(277869, '3inuH01', NULL, NULL, 125, NULL, NULL, 234642),
(277870, '4qxgL01', NULL, NULL, 109, NULL, NULL, 234642),
(277871, '1l9mA04', NULL, NULL, 97, NULL, NULL, 234642),
(277872, '4iosD00', NULL, NULL, 123, NULL, NULL, 234642),
(277873, '5czvL01', NULL, NULL, 107, NULL, NULL, 234642),
(277874, '2op4H01', NULL, NULL, 123, NULL, NULL, 234642),
(277875, '2op4H02', NULL, NULL, 99, NULL, NULL, 234642),
(277876, '2eizB00', NULL, NULL, 113, NULL, NULL, 234642),
(277877, '2x41A03', NULL, NULL, 119, NULL, NULL, 234642),
(277878, '3ietB01', NULL, NULL, 118, NULL, NULL, 234642),
(277879, '1yedB01', NULL, NULL, 124, NULL, NULL, 234642),
(277880, '1h3pL01', NULL, NULL, 113, NULL, NULL, 234642),
(277881, '6ehyA02', NULL, NULL, 116, NULL, NULL, 234642),
(277882, '3u9uA01', NULL, NULL, 119, NULL, NULL, 234642),
(277883, '5d4kA02', NULL, NULL, 106, NULL, NULL, 234642),
(277884, '1ggiL01', NULL, NULL, 111, NULL, NULL, 234642),
(277885, '2yhgA02', NULL, NULL, 110, NULL, NULL, 234642),
(277886, '4nbxB00', NULL, NULL, 130, NULL, NULL, 234642),
(277887, '1bpvA00', NULL, NULL, 112, NULL, NULL, 234642),
(277888, '6ewbF01', NULL, NULL, 108, NULL, NULL, 234642),
(277889, '2qlvB01', NULL, NULL, 87, NULL, NULL, 234642),
(277890, '1uvqB02', NULL, NULL, 108, NULL, NULL, 234642),
(277891, '4kuzH01', NULL, NULL, 120, NULL, NULL, 234642),
(277892, '3idgB02', NULL, NULL, 105, NULL, NULL, 234642),
(277893, '4aehL01', NULL, NULL, 108, NULL, NULL, 234642),
(277894, '1k8iB02', NULL, NULL, 100, NULL, NULL, 234642),
(277895, '5cd3B01', NULL, NULL, 104, NULL, NULL, 234642),
(277896, '3g04A01', NULL, NULL, 111, NULL, NULL, 234642),
(277897, '5b3nA01', NULL, NULL, 125, NULL, NULL, 234642),
(277898, '5b3nA02', NULL, NULL, 120, NULL, NULL, 234642),
(277899, '4ki5F01', NULL, NULL, 108, NULL, NULL, 234642),
(277900, '5fhbH01', NULL, NULL, 125, NULL, NULL, 234642),
(277901, '1igtB01', NULL, NULL, 119, NULL, NULL, 234642),
(277902, '6blqB02', NULL, NULL, 105, NULL, NULL, 234642),
(277903, '1h0dB01', NULL, NULL, 121, NULL, NULL, 234642),
(277904, '1h0dB02', NULL, NULL, 99, NULL, NULL, 234642),
(277905, '5obfL01', NULL, NULL, 112, NULL, NULL, 234642),
(277906, '5c0nD01', NULL, NULL, 113, NULL, NULL, 234642),
(277907, '5m02H01', NULL, NULL, 112, NULL, NULL, 234642),
(277908, '5vicL01', NULL, NULL, 108, NULL, NULL, 234642),
(277909, '3l95B01', NULL, NULL, 119, NULL, NULL, 234642),
(277910, '2arjA01', NULL, NULL, 108, NULL, NULL, 234642),
(277911, '5dwuL01', NULL, NULL, 107, NULL, NULL, 234642);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(277912, '3m45A00', NULL, NULL, 108, NULL, NULL, 234642),
(277913, '1frgL01', NULL, NULL, 114, NULL, NULL, 234642),
(277914, '2adfH01', NULL, NULL, 119, NULL, NULL, 234642),
(277915, '3u6rB00', NULL, NULL, 105, NULL, NULL, 234642),
(277916, '1tziB01', NULL, NULL, 120, NULL, NULL, 234642),
(277917, '5jdsB00', NULL, NULL, 129, NULL, NULL, 234642),
(277918, '5nmvH02', NULL, NULL, 99, NULL, NULL, 234642),
(277919, '3ncyP01', NULL, NULL, 121, NULL, NULL, 234642),
(277920, '5n2kC01', NULL, NULL, 111, NULL, NULL, 234642),
(277921, '1a3rL01', NULL, NULL, 114, NULL, NULL, 234642),
(277922, '4f80A01', NULL, NULL, 119, NULL, NULL, 234642),
(277923, '1gpoH01', NULL, NULL, 113, NULL, NULL, 234642),
(277924, '5febA00', NULL, NULL, 125, NULL, NULL, 234642),
(277925, '4f80A02', NULL, NULL, 107, NULL, NULL, 234642),
(277926, '4jy6A01', NULL, NULL, 106, NULL, NULL, 234642),
(277927, '3vxmD01', NULL, NULL, 117, NULL, NULL, 234642),
(277928, '5uxqB01', NULL, NULL, 111, NULL, NULL, 234642),
(277929, '1yejL01', NULL, NULL, 113, NULL, NULL, 234642),
(277930, '4d3cH01', NULL, NULL, 116, NULL, NULL, 234642),
(277931, '3cfdA01', NULL, NULL, 107, NULL, NULL, 234642),
(277932, '4hwnA00', NULL, NULL, 108, NULL, NULL, 234642),
(277933, '5uelL01', NULL, NULL, 110, NULL, NULL, 234642),
(277934, '5alcH01', NULL, NULL, 129, NULL, NULL, 234642),
(277935, '5hvwA02', NULL, NULL, 107, NULL, NULL, 234642),
(277936, '5cgyD01', NULL, NULL, 112, NULL, NULL, 234642),
(277937, '5xs7L00', NULL, NULL, 108, NULL, NULL, 234642),
(277938, '5hggT00', NULL, NULL, 128, NULL, NULL, 234642),
(277939, '6c9uL01', NULL, NULL, 113, NULL, NULL, 234642),
(277940, '3q3gB01', NULL, NULL, 122, NULL, NULL, 234642),
(277941, '5fwoA00', NULL, NULL, 137, NULL, NULL, 234642),
(277942, '1mlbB01', NULL, NULL, 116, NULL, NULL, 234642),
(277943, '1mlbB02', NULL, NULL, 99, NULL, NULL, 234642),
(277944, '5mtjB00', NULL, NULL, 98, NULL, NULL, 234642),
(277945, '2vxqH01', NULL, NULL, 117, NULL, NULL, 234642),
(277946, '5iszE01', NULL, NULL, 113, NULL, NULL, 234642),
(277947, '4g6mL01', NULL, NULL, 108, NULL, NULL, 234642),
(277948, '4ofdB02', NULL, NULL, 106, NULL, NULL, 234642),
(277949, '4ofdB01', NULL, NULL, 108, NULL, NULL, 234642),
(277950, '3gzkA01', NULL, NULL, 85, NULL, NULL, 234642),
(277951, '4crpA00', NULL, NULL, 107, NULL, NULL, 234642),
(277952, '3n1mC01', NULL, NULL, 101, NULL, NULL, 234642),
(277953, '1dsfH00', NULL, NULL, 119, NULL, NULL, 234642),
(277954, '3thmL01', NULL, NULL, 111, NULL, NULL, 234642),
(277955, '3gkzA02', NULL, NULL, 103, NULL, NULL, 234642),
(277956, '3idxL01', NULL, NULL, 108, NULL, NULL, 234642),
(277957, '5ksaC01', NULL, NULL, 112, NULL, NULL, 234642),
(277958, '3gkzA01', NULL, NULL, 138, NULL, NULL, 234642),
(277959, '6blaL01', NULL, NULL, 111, NULL, NULL, 234642),
(277960, '3u9pK02', NULL, NULL, 97, NULL, NULL, 234642),
(277961, '5j6hA02', NULL, NULL, 87, NULL, NULL, 234642),
(277962, '1kjvA02', NULL, NULL, 91, NULL, NULL, 234642),
(277963, '5f3hA01', NULL, NULL, 116, NULL, NULL, 234642),
(277964, '4orgD01', NULL, NULL, 112, NULL, NULL, 234642),
(277965, '4n0yH01', NULL, NULL, 126, NULL, NULL, 234642),
(277966, '4qycB02', NULL, NULL, 103, NULL, NULL, 234642),
(277967, '5dt1H01', NULL, NULL, 145, NULL, NULL, 234642),
(277968, '5sv3C00', NULL, NULL, 139, NULL, NULL, 234642),
(277969, '3ma9H01', NULL, NULL, 121, NULL, NULL, 234642),
(277970, '3qq9C01', NULL, NULL, 112, NULL, NULL, 234642),
(277971, '1q9wA01', NULL, NULL, 113, NULL, NULL, 234642),
(277972, '4l9lB01', NULL, NULL, 115, NULL, NULL, 234642),
(277973, '3f7pE02', NULL, NULL, 132, NULL, NULL, 234642),
(277974, '1owwA00', NULL, NULL, 98, NULL, NULL, 234642),
(277975, '5ikcA01', NULL, NULL, 107, NULL, NULL, 234642),
(277976, '1fgvH00', NULL, NULL, 124, NULL, NULL, 234642),
(277977, '3p4lA02', NULL, NULL, 107, NULL, NULL, 234642),
(277978, '6bb4L01', NULL, NULL, 108, NULL, NULL, 234642),
(277979, '3p4lA01', NULL, NULL, 104, NULL, NULL, 234642),
(277980, '2xraL01', NULL, NULL, 108, NULL, NULL, 234642),
(277981, '4i77L01', NULL, NULL, 111, NULL, NULL, 234642),
(277982, '4ozgE01', NULL, NULL, 108, NULL, NULL, 234642);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(277983, '3hntL01', NULL, NULL, 107, NULL, NULL, 234642),
(277984, '4ba8A00', NULL, NULL, 102, NULL, NULL, 234642),
(277985, '1s9vA02', NULL, NULL, 110, NULL, NULL, 234642),
(277986, '1moeA02', NULL, NULL, 99, NULL, NULL, 234642),
(277987, '2qsqB01', NULL, NULL, 110, NULL, NULL, 234642),
(277988, '4grmB01', NULL, NULL, 116, NULL, NULL, 234642),
(277989, '3cmoH01', NULL, NULL, 123, NULL, NULL, 234642),
(277990, '1jvkA01', NULL, NULL, 112, NULL, NULL, 234642),
(277991, '3skjH01', NULL, NULL, 128, NULL, NULL, 234642),
(277992, '5tlkB01', NULL, NULL, 120, NULL, NULL, 234642),
(277993, '5k6xA04', NULL, NULL, 92, NULL, NULL, 234642),
(277994, '1r0aH01', NULL, NULL, 123, NULL, NULL, 234642),
(277995, '1k5nB00', NULL, NULL, 100, NULL, NULL, 234642),
(277996, '3clfL01', NULL, NULL, 107, NULL, NULL, 234642),
(277997, '1seqL01', NULL, NULL, 107, NULL, NULL, 234642),
(277998, '2rblA02', NULL, NULL, 74, NULL, NULL, 234642),
(277999, '5eorL01', NULL, NULL, 116, NULL, NULL, 234642),
(278000, '5kanG01', NULL, NULL, 128, NULL, NULL, 234642),
(278001, '1egjL02', NULL, NULL, 103, NULL, NULL, 234642),
(278002, '3fn9A02', NULL, NULL, 120, NULL, NULL, 234642),
(278003, '2y07L02', NULL, NULL, 101, NULL, NULL, 234642),
(278004, '1egjL01', NULL, NULL, 112, NULL, NULL, 234642),
(278005, '4of8B01', NULL, NULL, 116, NULL, NULL, 234642),
(278006, '4oqtH01', NULL, NULL, 118, NULL, NULL, 234642),
(278007, '5nb5L01', NULL, NULL, 112, NULL, NULL, 234642),
(278008, '4rfeA01', NULL, NULL, 125, NULL, NULL, 234642),
(278009, '6b0hA01', NULL, NULL, 108, NULL, NULL, 234642),
(278010, '4nzrL01', NULL, NULL, 108, NULL, NULL, 234642),
(278011, '4bfiB02', NULL, NULL, 98, NULL, NULL, 234642),
(278012, '4bfiB01', NULL, NULL, 113, NULL, NULL, 234642),
(278013, '4yhyC01', NULL, NULL, 109, NULL, NULL, 234642),
(278014, '3rghA01', NULL, NULL, 96, NULL, NULL, 234642),
(278015, '5dd5L01', NULL, NULL, 107, NULL, NULL, 234642),
(278016, '1cgtA04', NULL, NULL, 104, NULL, NULL, 234642),
(278017, '1cgtA03', NULL, NULL, 86, NULL, NULL, 234642),
(278018, '3v6oF01', NULL, NULL, 109, NULL, NULL, 234642),
(278019, '3r8bP00', NULL, NULL, 125, NULL, NULL, 234642),
(278020, '1f00I01', NULL, NULL, 95, NULL, NULL, 234642),
(278021, '6c08A02', NULL, NULL, 98, NULL, NULL, 234642),
(278022, '3whxA01', NULL, NULL, 118, NULL, NULL, 234642),
(278023, '5f3bB01', NULL, NULL, 108, NULL, NULL, 234642),
(278024, '5uy3A01', NULL, NULL, 138, NULL, NULL, 234642),
(278025, '3ojdA01', NULL, NULL, 108, NULL, NULL, 234642),
(278026, '1um5H01', NULL, NULL, 117, NULL, NULL, 234642),
(278027, '4ploB01', NULL, NULL, 102, NULL, NULL, 234642),
(278028, '5gsbA02', NULL, NULL, 91, NULL, NULL, 234642),
(278029, '5m63H01', NULL, NULL, 125, NULL, NULL, 234642),
(278030, '2yocA03', NULL, NULL, 108, NULL, NULL, 234642),
(278031, '3nh7H01', NULL, NULL, 120, NULL, NULL, 234642),
(278032, '1sy6H01', NULL, NULL, 119, NULL, NULL, 234642),
(278033, '3qrgL01', NULL, NULL, 111, NULL, NULL, 234642),
(278034, '3jz7A01', NULL, NULL, 120, NULL, NULL, 234642),
(278035, '3jz7A02', NULL, NULL, 94, NULL, NULL, 234642),
(278036, '1kelH01', NULL, NULL, 119, NULL, NULL, 234642),
(278037, '1f4wH01', NULL, NULL, 117, NULL, NULL, 234642),
(278038, '1ghfH01', NULL, NULL, 114, NULL, NULL, 234642),
(278039, '4edxB01', NULL, NULL, 121, NULL, NULL, 234642),
(278040, '5dfwH02', NULL, NULL, 99, NULL, NULL, 234642),
(278041, '5dfwH01', NULL, NULL, 116, NULL, NULL, 234642),
(278042, '2ialA01', NULL, NULL, 108, NULL, NULL, 234642),
(278043, '4wcyH01', NULL, NULL, 116, NULL, NULL, 234642),
(278044, '5ifhL01', NULL, NULL, 110, NULL, NULL, 234642),
(278045, '5ubyL01', NULL, NULL, 109, NULL, NULL, 234642),
(278046, '4ekxA00', NULL, NULL, 116, NULL, NULL, 234642),
(278047, '4qthA01', NULL, NULL, 122, NULL, NULL, 234642),
(278048, '4qwwC01', NULL, NULL, 107, NULL, NULL, 234642),
(278049, '5jxaH01', NULL, NULL, 130, NULL, NULL, 234642),
(278050, '3hrpA01', NULL, NULL, 104, NULL, NULL, 234642),
(278051, '1a3rH01', NULL, NULL, 118, NULL, NULL, 234642),
(278052, '4hs6A01', NULL, NULL, 111, NULL, NULL, 234642),
(278053, '5u15A01', NULL, NULL, 127, NULL, NULL, 234642); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(278054, '5c8jA01', NULL, NULL, 131, NULL, NULL, 234642),
(278055, '3o4lE01', NULL, NULL, 114, NULL, NULL, 234642),
(278056, '4llyB01', NULL, NULL, 109, NULL, NULL, 234642),
(278057, '4dohE01', NULL, NULL, 108, NULL, NULL, 234642),
(278058, '5gznC01', NULL, NULL, 127, NULL, NULL, 234642),
(278059, '4lmqE01', NULL, NULL, 120, NULL, NULL, 234642),
(278060, '4dohE02', NULL, NULL, 113, NULL, NULL, 234642),
(278061, '3juzA00', NULL, NULL, 101, NULL, NULL, 234642),
(278062, '1cwvA01', NULL, NULL, 101, NULL, NULL, 234642),
(278063, '1cwvA02', NULL, NULL, 97, NULL, NULL, 234642),
(278064, '1cwvA03', NULL, NULL, 102, NULL, NULL, 234642),
(278065, '4olzH01', NULL, NULL, 125, NULL, NULL, 234642),
(278066, '5fhbL01', NULL, NULL, 105, NULL, NULL, 234642),
(278067, '2yd4A01', NULL, NULL, 101, NULL, NULL, 234642),
(278068, '4ffyL00', NULL, NULL, 126, NULL, NULL, 234642),
(278069, '2c3vB00', NULL, NULL, 102, NULL, NULL, 234642),
(278070, '3qumL01', NULL, NULL, 113, NULL, NULL, 234642),
(278071, '6flcA01', NULL, NULL, 108, NULL, NULL, 234642),
(278072, '3wkmH01', NULL, NULL, 123, NULL, NULL, 234642),
(278073, '2yd4A02', NULL, NULL, 109, NULL, NULL, 234642),
(278074, '5fgbA01', NULL, NULL, 110, NULL, NULL, 234642),
(278075, '1jbjA01', NULL, NULL, 89, NULL, NULL, 234642),
(278076, '3qeqE01', NULL, NULL, 114, NULL, NULL, 234642),
(278077, '1e4xM01', NULL, NULL, 107, NULL, NULL, 234642),
(278078, '1ri8A00', NULL, NULL, 134, NULL, NULL, 234642),
(278079, '5dd1H01', NULL, NULL, 128, NULL, NULL, 234642),
(278080, '1jbjA02', NULL, NULL, 75, NULL, NULL, 234642),
(278081, '32c2B02', NULL, NULL, 99, NULL, NULL, 234642),
(278082, '4fqqD01', NULL, NULL, 132, NULL, NULL, 234642),
(278083, '4f37K01', NULL, NULL, 113, NULL, NULL, 234642),
(278084, '32c2B01', NULL, NULL, 119, NULL, NULL, 234642),
(278085, '2dm7A01', NULL, NULL, 88, NULL, NULL, 234642),
(278086, '2dkuA01', NULL, NULL, 89, NULL, NULL, 234642),
(278087, '5u0uA02', NULL, NULL, 102, NULL, NULL, 234642),
(278088, '5u0uA01', NULL, NULL, 126, NULL, NULL, 234642),
(278089, '5dyoA01', NULL, NULL, 112, NULL, NULL, 234642),
(278090, '2qscH01', NULL, NULL, 123, NULL, NULL, 234642),
(278091, '4tnwK01', NULL, NULL, 110, NULL, NULL, 234642),
(278092, '4bzyA02', NULL, NULL, 113, NULL, NULL, 234642),
(278093, '4lhqB00', NULL, NULL, 128, NULL, NULL, 234642),
(278094, '3wbdB01', NULL, NULL, 130, NULL, NULL, 234642),
(278095, '6d4nA02', NULL, NULL, 106, NULL, NULL, 234642),
(278096, '1tvdA00', NULL, NULL, 116, NULL, NULL, 234642),
(278097, '1cdcA00', NULL, NULL, 99, NULL, NULL, 234642),
(278098, '5wkfD01', NULL, NULL, 108, NULL, NULL, 234642),
(278099, '2edfA00', NULL, NULL, 103, NULL, NULL, 234642),
(278100, '5nhtB01', NULL, NULL, 114, NULL, NULL, 234642),
(278101, '2dmcA01', NULL, NULL, 74, NULL, NULL, 234642),
(278102, '1wf5A00', NULL, NULL, 121, NULL, NULL, 234642),
(278103, '2gfbB01', NULL, NULL, 119, NULL, NULL, 234642),
(278104, '5eu6E01', NULL, NULL, 115, NULL, NULL, 234642),
(278105, '6df0L01', NULL, NULL, 108, NULL, NULL, 234642),
(278106, '2vq1A01', NULL, NULL, 113, NULL, NULL, 234642),
(278107, '2x1oA00', NULL, NULL, 122, NULL, NULL, 234642),
(278108, '4r4bA01', NULL, NULL, 106, NULL, NULL, 234642),
(278109, '1qfwL00', NULL, NULL, 114, NULL, NULL, 234642),
(278110, '2edqA01', NULL, NULL, 88, NULL, NULL, 234642),
(278111, '2xraH01', NULL, NULL, 120, NULL, NULL, 234642),
(278112, '3gi9H01', NULL, NULL, 124, NULL, NULL, 234642),
(278113, '6b3mP01', NULL, NULL, 109, NULL, NULL, 234642),
(278114, '2qqnL01', NULL, NULL, 107, NULL, NULL, 234642),
(278115, '4bz1H02', NULL, NULL, 99, NULL, NULL, 234642),
(278116, '4bz1H01', NULL, NULL, 117, NULL, NULL, 234642),
(278117, '5cszB01', NULL, NULL, 109, NULL, NULL, 234642),
(278118, '4u33A01', NULL, NULL, 131, NULL, NULL, 234642),
(278119, '6dcaL01', NULL, NULL, 113, NULL, NULL, 234642),
(278120, '5vqmC01', NULL, NULL, 108, NULL, NULL, 234642),
(278121, '2fjhB01', NULL, NULL, 121, NULL, NULL, 234642),
(278122, '1fltX00', NULL, NULL, 95, NULL, NULL, 234642),
(278123, '1sbsH01', NULL, NULL, 123, NULL, NULL, 234642),
(278124, '5drwA01', NULL, NULL, 126, NULL, NULL, 234642); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(278125, '3s88L01', NULL, NULL, 108, NULL, NULL, 234642),
(278126, '5ja9B00', NULL, NULL, 123, NULL, NULL, 234642),
(278127, '5wi9E01', NULL, NULL, 109, NULL, NULL, 234642),
(278128, '6ii9L01', NULL, NULL, 110, NULL, NULL, 234642),
(278129, '4uv4L01', NULL, NULL, 112, NULL, NULL, 234642),
(278130, '3nz8A01', NULL, NULL, 121, NULL, NULL, 234642),
(278131, '5czxC01', NULL, NULL, 119, NULL, NULL, 234642),
(278132, '1rurL01', NULL, NULL, 113, NULL, NULL, 234642),
(278133, '1t2jA00', NULL, NULL, 116, NULL, NULL, 234642),
(278134, '4pb9H01', NULL, NULL, 122, NULL, NULL, 234642),
(278135, '2fl5B01', NULL, NULL, 120, NULL, NULL, 234642),
(278136, '2ih3B01', NULL, NULL, 108, NULL, NULL, 234642),
(278137, '3r0nA00', NULL, NULL, 128, NULL, NULL, 234642),
(278138, '4nrzB01', NULL, NULL, 107, NULL, NULL, 234642),
(278139, '3qegH01', NULL, NULL, 132, NULL, NULL, 234642),
(278140, '5wjoD01', NULL, NULL, 120, NULL, NULL, 234642),
(278141, '4p59H01', NULL, NULL, 117, NULL, NULL, 234642),
(278142, '5girB01', NULL, NULL, 108, NULL, NULL, 234642),
(278143, '3s35H01', NULL, NULL, 118, NULL, NULL, 234642),
(278144, '3tesA00', NULL, NULL, 98, NULL, NULL, 234642),
(278145, '6bpbB01', NULL, NULL, 108, NULL, NULL, 234642),
(278146, '5kvgL01', NULL, NULL, 107, NULL, NULL, 234642),
(278147, '2yuzA00', NULL, NULL, 100, NULL, NULL, 234642),
(278148, '1uemA00', NULL, NULL, 117, NULL, NULL, 234642),
(278149, '3q5yA01', NULL, NULL, 111, NULL, NULL, 234642),
(278150, '1xiwB00', NULL, NULL, 79, NULL, NULL, 234642),
(278151, '2gsiB01', NULL, NULL, 121, NULL, NULL, 234642),
(278152, '4s0sD00', NULL, NULL, 120, NULL, NULL, 234642),
(278153, '1a2yB00', NULL, NULL, 116, NULL, NULL, 234642),
(278154, '5t3zD01', NULL, NULL, 126, NULL, NULL, 234642),
(278155, '6mttL01', NULL, NULL, 107, NULL, NULL, 234642),
(278156, '5nstA01', NULL, NULL, 108, NULL, NULL, 234642),
(278157, '5u3jH01', NULL, NULL, 133, NULL, NULL, 234642),
(278158, '2xa3A00', NULL, NULL, 127, NULL, NULL, 234642),
(278159, '4cu7A02', NULL, NULL, 121, NULL, NULL, 234642),
(278160, '3i9gH01', NULL, NULL, 121, NULL, NULL, 234642),
(278161, '4cucA05', NULL, NULL, 118, NULL, NULL, 234642),
(278162, '2djsA01', NULL, NULL, 88, NULL, NULL, 234642),
(278163, '4gq9L01', NULL, NULL, 107, NULL, NULL, 234642),
(278164, '1bqsA02', NULL, NULL, 119, NULL, NULL, 234642),
(278165, '3q48B01', NULL, NULL, 120, NULL, NULL, 234642),
(278166, '1xt5A00', NULL, NULL, 135, NULL, NULL, 234642),
(278167, '6o3bA01', NULL, NULL, 108, NULL, NULL, 234642),
(278168, '4lfhD02', NULL, NULL, 85, NULL, NULL, 234642),
(278169, '1my7A00', NULL, NULL, 114, NULL, NULL, 234642),
(278170, '4lfhD01', NULL, NULL, 121, NULL, NULL, 234642),
(278171, '5te7L01', NULL, NULL, 104, NULL, NULL, 234642),
(278172, '2oz4A01', NULL, NULL, 97, NULL, NULL, 234642),
(278173, '2oz4A03', NULL, NULL, 83, NULL, NULL, 234642),
(278174, '5ye4B01', NULL, NULL, 107, NULL, NULL, 234642),
(278175, '2oz4A02', NULL, NULL, 85, NULL, NULL, 234642),
(278176, '1c16A02', NULL, NULL, 97, NULL, NULL, 234642),
(278177, '4z8fH01', NULL, NULL, 127, NULL, NULL, 234642),
(278178, '5c71A02', NULL, NULL, 96, NULL, NULL, 234642),
(278179, '3i75B01', NULL, NULL, 125, NULL, NULL, 234642),
(278180, '3whe101', NULL, NULL, 126, NULL, NULL, 234642),
(278181, '2xknB01', NULL, NULL, 116, NULL, NULL, 234642),
(278182, '1uctA01', NULL, NULL, 95, NULL, NULL, 234642),
(278183, '2yn5A01', NULL, NULL, 79, NULL, NULL, 234642),
(278184, '2pttA00', NULL, NULL, 110, NULL, NULL, 234642),
(278185, '4ktdL01', NULL, NULL, 116, NULL, NULL, 234642),
(278186, '3tp4B02', NULL, NULL, 104, NULL, NULL, 234642),
(278187, '1uctA02', NULL, NULL, 95, NULL, NULL, 234642),
(278188, '2oxgA00', NULL, NULL, 108, NULL, NULL, 234642),
(278189, '2zg1A01', NULL, NULL, 124, NULL, NULL, 234642),
(278190, '5opyL01', NULL, NULL, 108, NULL, NULL, 234642),
(278191, '5eo9A00', NULL, NULL, 110, NULL, NULL, 234642),
(278192, '5vsiL01', NULL, NULL, 107, NULL, NULL, 234642),
(278193, '4ofiA00', NULL, NULL, 115, NULL, NULL, 234642),
(278194, '5wtgB02', NULL, NULL, 98, NULL, NULL, 234642),
(278195, '5wtgB01', NULL, NULL, 121, NULL, NULL, 234642);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(278196, '6dhbA00', NULL, NULL, 108, NULL, NULL, 234642),
(278197, '2hh0H01', NULL, NULL, 118, NULL, NULL, 234642),
(278198, '5lmwA00', NULL, NULL, 129, NULL, NULL, 234642),
(278199, '4x9fA02', NULL, NULL, 104, NULL, NULL, 234642),
(278200, '4jegB00', NULL, NULL, 94, NULL, NULL, 234642),
(278201, '4x9fA03', NULL, NULL, 102, NULL, NULL, 234642),
(278202, '4nujB01', NULL, NULL, 136, NULL, NULL, 234642),
(278203, '5dupL01', NULL, NULL, 109, NULL, NULL, 234642),
(278204, '1i9jL01', NULL, NULL, 113, NULL, NULL, 234642),
(278205, '4grwJ00', NULL, NULL, 126, NULL, NULL, 234642),
(278206, '6ns1A02', NULL, NULL, 102, NULL, NULL, 234642),
(278207, '5d96B01', NULL, NULL, 108, NULL, NULL, 234642),
(278208, '6ns1A01', NULL, NULL, 111, NULL, NULL, 234642),
(278209, '3o3uN02', NULL, NULL, 98, NULL, NULL, 234642),
(278210, '3sobL01', NULL, NULL, 108, NULL, NULL, 234642),
(278211, '5xkuB01', NULL, NULL, 112, NULL, NULL, 234642),
(278212, '3o3uN03', NULL, NULL, 111, NULL, NULL, 234642),
(278213, '5itbH01', NULL, NULL, 117, NULL, NULL, 234642),
(278214, '5f7eL01', NULL, NULL, 103, NULL, NULL, 234642),
(278215, '5u3nL01', NULL, NULL, 109, NULL, NULL, 234642),
(278216, '6ffjA02', NULL, NULL, 101, NULL, NULL, 234642),
(278217, '4uikH01', NULL, NULL, 122, NULL, NULL, 234642),
(278218, '4uikH02', NULL, NULL, 100, NULL, NULL, 234642),
(278219, '4ocwL01', NULL, NULL, 109, NULL, NULL, 234642),
(278220, '4n90E01', NULL, NULL, 109, NULL, NULL, 234642),
(278221, '1qd0A00', NULL, NULL, 128, NULL, NULL, 234642),
(278222, '3bn9C01', NULL, NULL, 107, NULL, NULL, 234642),
(278223, '5iq9B01', NULL, NULL, 109, NULL, NULL, 234642),
(278224, '1xgyL01', NULL, NULL, 113, NULL, NULL, 234642),
(278225, '4n9gE01', NULL, NULL, 125, NULL, NULL, 234642),
(278226, '4i3gA04', NULL, NULL, 114, NULL, NULL, 234642),
(278227, '4krpB00', NULL, NULL, 136, NULL, NULL, 234642),
(278228, '5kw9H01', NULL, NULL, 124, NULL, NULL, 234642),
(278229, '5a41G00', NULL, NULL, 91, NULL, NULL, 234642),
(278230, '4mxvE01', NULL, NULL, 108, NULL, NULL, 234642),
(278231, '1txkB02', NULL, NULL, 122, NULL, NULL, 234642),
(278232, '2or7A00', NULL, NULL, 115, NULL, NULL, 234642),
(278233, '1fn4A01', NULL, NULL, 107, NULL, NULL, 234642),
(278234, '5drzB01', NULL, NULL, 125, NULL, NULL, 234642),
(278235, '4oleC00', NULL, NULL, 122, NULL, NULL, 234642),
(278236, '2ec8A03', NULL, NULL, 104, NULL, NULL, 234642),
(278237, '1yuhB01', NULL, NULL, 118, NULL, NULL, 234642),
(278238, '2ec8A01', NULL, NULL, 116, NULL, NULL, 234642),
(278239, '4p4kG01', NULL, NULL, 114, NULL, NULL, 234642),
(278240, '3cxdL02', NULL, NULL, 103, NULL, NULL, 234642),
(278241, '2ec8A02', NULL, NULL, 91, NULL, NULL, 234642),
(278242, '3cxdL01', NULL, NULL, 108, NULL, NULL, 234642),
(278243, '5c9kF00', NULL, NULL, 111, NULL, NULL, 234642),
(278244, '4rx4A01', NULL, NULL, 120, NULL, NULL, 234642),
(278245, '5bv7C01', NULL, NULL, 126, NULL, NULL, 234642),
(278246, '5bv7C02', NULL, NULL, 112, NULL, NULL, 234642),
(278247, '4pljD01', NULL, NULL, 121, NULL, NULL, 234642),
(278248, '1x5xA00', NULL, NULL, 109, NULL, NULL, 234642),
(278249, '6cjkA01', NULL, NULL, 114, NULL, NULL, 234642),
(278250, '5oyjC01', NULL, NULL, 95, NULL, NULL, 234642),
(278251, '4jdvL01', NULL, NULL, 104, NULL, NULL, 234642),
(278252, '4mjiJ01', NULL, NULL, 113, NULL, NULL, 234642),
(278253, '5fv2B00', NULL, NULL, 116, NULL, NULL, 234642),
(278254, '3t3pF01', NULL, NULL, 107, NULL, NULL, 234642),
(278255, '4g5zH01', NULL, NULL, 118, NULL, NULL, 234642),
(278256, '4pubH01', NULL, NULL, 122, NULL, NULL, 234642),
(278257, '3wiiH01', NULL, NULL, 119, NULL, NULL, 234642),
(278258, '4ut7H00', NULL, NULL, 150, NULL, NULL, 234642),
(278259, '2h3nB01', NULL, NULL, 100, NULL, NULL, 234642),
(278260, '3tt3H01', NULL, NULL, 120, NULL, NULL, 234642),
(278261, '4gxvL01', NULL, NULL, 112, NULL, NULL, 234642),
(278262, '5azeH01', NULL, NULL, 121, NULL, NULL, 234642),
(278263, '4ffvC01', NULL, NULL, 107, NULL, NULL, 234642),
(278264, '5wnaD01', NULL, NULL, 107, NULL, NULL, 234642),
(278265, '5t1dH01', NULL, NULL, 116, NULL, NULL, 234642),
(278266, '3g5vB01', NULL, NULL, 116, NULL, NULL, 234642);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(278267, '4xvjL00', NULL, NULL, 115, NULL, NULL, 234642),
(278268, '3g5vB02', NULL, NULL, 97, NULL, NULL, 234642),
(278269, '3aazB01', NULL, NULL, 112, NULL, NULL, 234642),
(278270, '6b9jL01', NULL, NULL, 110, NULL, NULL, 234642),
(278271, '2gjjB01', NULL, NULL, 137, NULL, NULL, 234642),
(278272, '1mspB00', NULL, NULL, 126, NULL, NULL, 234642),
(278273, '5d1xA01', NULL, NULL, 112, NULL, NULL, 234642),
(278274, '4x5wB02', NULL, NULL, 106, NULL, NULL, 234642),
(278275, '5n7wB01', NULL, NULL, 110, NULL, NULL, 234642),
(278276, '1becA01', NULL, NULL, 113, NULL, NULL, 234642),
(278277, '5j13B01', NULL, NULL, 109, NULL, NULL, 234642),
(278278, '2hftA02', NULL, NULL, 111, NULL, NULL, 234642),
(278279, '1becA02', NULL, NULL, 125, NULL, NULL, 234642),
(278280, '1y0lB01', NULL, NULL, 123, NULL, NULL, 234642),
(278281, '4h8wH01', NULL, NULL, 119, NULL, NULL, 234642),
(278282, '6bqbL01', NULL, NULL, 113, NULL, NULL, 234642),
(278283, '1indH01', NULL, NULL, 114, NULL, NULL, 234642),
(278284, '4p9mH01', NULL, NULL, 132, NULL, NULL, 234642),
(278285, '6dezA01', NULL, NULL, 108, NULL, NULL, 234642),
(278286, '2p5eB00', NULL, NULL, 100, NULL, NULL, 234642),
(278287, '5eziL01', NULL, NULL, 108, NULL, NULL, 234642),
(278288, '5w1gL01', NULL, NULL, 115, NULL, NULL, 234642),
(278289, '4qhkI01', NULL, NULL, 121, NULL, NULL, 234642),
(278290, '1yeeH01', NULL, NULL, 123, NULL, NULL, 234642),
(278291, '3g9vC01', NULL, NULL, 107, NULL, NULL, 234642),
(278292, '5vkdL01', NULL, NULL, 109, NULL, NULL, 234642),
(278293, '3tpkA00', NULL, NULL, 136, NULL, NULL, 234642),
(278294, '1m4kA02', NULL, NULL, 98, NULL, NULL, 234642),
(278295, '1m4kA01', NULL, NULL, 102, NULL, NULL, 234642),
(278296, '4edwH01', NULL, NULL, 121, NULL, NULL, 234642),
(278297, '5wlgJ01', NULL, NULL, 114, NULL, NULL, 234642),
(278298, '1dn0A01', NULL, NULL, 109, NULL, NULL, 234642),
(278299, '5xmfB00', NULL, NULL, 99, NULL, NULL, 234642),
(278300, '4bsvB02', NULL, NULL, 110, NULL, NULL, 234642),
(278301, '3oq3B01', NULL, NULL, 126, NULL, NULL, 234642),
(278302, '3oq3B02', NULL, NULL, 100, NULL, NULL, 234642),
(278303, '3oq3B03', NULL, NULL, 103, NULL, NULL, 234642),
(278304, '4irzL01', NULL, NULL, 107, NULL, NULL, 234642),
(278305, '3fawA02', NULL, NULL, 113, NULL, NULL, 234642),
(278306, '4liqE05', NULL, NULL, 100, NULL, NULL, 234642),
(278307, '1forH01', NULL, NULL, 120, NULL, NULL, 234642),
(278308, '5ljyH00', NULL, NULL, 119, NULL, NULL, 234642),
(278309, '6a77A00', NULL, NULL, 91, NULL, NULL, 234642),
(278310, '4liqE04', NULL, NULL, 102, NULL, NULL, 234642),
(278311, '3s8wC00', NULL, NULL, 105, NULL, NULL, 234642),
(278312, '4liqE03', NULL, NULL, 97, NULL, NULL, 234642),
(278313, '6bjqA02', NULL, NULL, 97, NULL, NULL, 234642),
(278314, '1nunB01', NULL, NULL, 111, NULL, NULL, 234642),
(278315, '4liqE02', NULL, NULL, 99, NULL, NULL, 234642),
(278316, '4hw6A01', NULL, NULL, 106, NULL, NULL, 234642),
(278317, '4liqE01', NULL, NULL, 83, NULL, NULL, 234642),
(278318, '2erjB02', NULL, NULL, 109, NULL, NULL, 234642),
(278319, '2w59B02', NULL, NULL, 120, NULL, NULL, 234642),
(278320, '4jhaH01', NULL, NULL, 126, NULL, NULL, 234642),
(278321, '4jhaH02', NULL, NULL, 105, NULL, NULL, 234642),
(278322, '4rwyH01', NULL, NULL, 120, NULL, NULL, 234642),
(278323, '6mtqL01', NULL, NULL, 109, NULL, NULL, 234642),
(278324, '4ye4L01', NULL, NULL, 114, NULL, NULL, 234642),
(278325, '3oskA00', NULL, NULL, 130, NULL, NULL, 234642),
(278326, '1ugnA01', NULL, NULL, 95, NULL, NULL, 234642),
(278327, '5hbtC01', NULL, NULL, 107, NULL, NULL, 234642),
(278328, '1afvH01', NULL, NULL, 120, NULL, NULL, 234642),
(278329, '5d7iC02', NULL, NULL, 92, NULL, NULL, 234642),
(278330, '6ddmA01', NULL, NULL, 109, NULL, NULL, 234642),
(278331, '2xzqH01', NULL, NULL, 120, NULL, NULL, 234642),
(278332, '2xzqH02', NULL, NULL, 99, NULL, NULL, 234642),
(278333, '4odvL01', NULL, NULL, 108, NULL, NULL, 234642),
(278334, '3hzmA01', NULL, NULL, 113, NULL, NULL, 234642),
(278335, '1sjvA00', NULL, NULL, 114, NULL, NULL, 234642),
(278336, '5gksB02', NULL, NULL, 103, NULL, NULL, 234642),
(278337, '4rgoL01', NULL, NULL, 108, NULL, NULL, 234642); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(278338, '4nfdA00', NULL, NULL, 120, NULL, NULL, 234642),
(278339, '5iszD01', NULL, NULL, 110, NULL, NULL, 234642),
(278340, '5iszD02', NULL, NULL, 90, NULL, NULL, 234642),
(278341, '2yk1H01', NULL, NULL, 117, NULL, NULL, 234642),
(278342, '5d96C01', NULL, NULL, 118, NULL, NULL, 234642),
(278343, '2jelL01', NULL, NULL, 113, NULL, NULL, 234642),
(278344, '4jznC01', NULL, NULL, 119, NULL, NULL, 234642),
(278345, '2jelL02', NULL, NULL, 103, NULL, NULL, 234642),
(278346, '4dagL01', NULL, NULL, 107, NULL, NULL, 234642),
(278347, '3bj9100', NULL, NULL, 116, NULL, NULL, 234642),
(278348, '3s97C01', NULL, NULL, 108, NULL, NULL, 234642),
(278349, '2di7A01', NULL, NULL, 107, NULL, NULL, 234642),
(278350, '6dcvA01', NULL, NULL, 113, NULL, NULL, 234642),
(278351, '3s97C02', NULL, NULL, 93, NULL, NULL, 234642),
(278352, '5f21B00', NULL, NULL, 120, NULL, NULL, 234642),
(278353, '5kn5A01', NULL, NULL, 118, NULL, NULL, 234642),
(278354, '3hmwL01', NULL, NULL, 107, NULL, NULL, 234642),
(278355, '4hj0D01', NULL, NULL, 110, NULL, NULL, 234642),
(278356, '1n0xH01', NULL, NULL, 123, NULL, NULL, 234642),
(278357, '5c3lD00', NULL, NULL, 119, NULL, NULL, 234642),
(278358, '6gh1A02', NULL, NULL, 91, NULL, NULL, 234642),
(278359, '6n7uB01', NULL, NULL, 109, NULL, NULL, 234642),
(278360, '4y19D01', NULL, NULL, 116, NULL, NULL, 234642),
(278361, '2jtdA00', NULL, NULL, 122, NULL, NULL, 234642),
(278362, '4osuH01', NULL, NULL, 131, NULL, NULL, 234642),
(278363, '1t4kA01', NULL, NULL, 113, NULL, NULL, 234642),
(278364, '2w60B01', NULL, NULL, 113, NULL, NULL, 234642),
(278365, '4ydvA01', NULL, NULL, 112, NULL, NULL, 234642),
(278366, '5i8cB01', NULL, NULL, 108, NULL, NULL, 234642),
(278367, '3mlwH01', NULL, NULL, 126, NULL, NULL, 234642),
(278368, '1rmfH01', NULL, NULL, 119, NULL, NULL, 234642),
(278369, '3zkxC00', NULL, NULL, 122, NULL, NULL, 234642),
(278370, '5faaA00', NULL, NULL, 135, NULL, NULL, 234642),
(278371, '1i1rA01', NULL, NULL, 101, NULL, NULL, 234642),
(278372, '5kaqG01', NULL, NULL, 107, NULL, NULL, 234642),
(278373, '5h2bA01', NULL, NULL, 116, NULL, NULL, 234642),
(278374, '3so3C01', NULL, NULL, 125, NULL, NULL, 234642),
(278375, '1kb5B00', NULL, NULL, 117, NULL, NULL, 234642),
(278376, '4isvB01', NULL, NULL, 121, NULL, NULL, 234642),
(278377, '5bq7A01', NULL, NULL, 118, NULL, NULL, 234642),
(278378, '6cphE01', NULL, NULL, 116, NULL, NULL, 234642),
(278379, '1nfdF01', NULL, NULL, 120, NULL, NULL, 234642),
(278380, '6a8pA03', NULL, NULL, 115, NULL, NULL, 234642),
(278381, '1nfdF02', NULL, NULL, 100, NULL, NULL, 234642),
(278382, '1l9nA03', NULL, NULL, 114, NULL, NULL, 234642),
(278383, '2if7B02', NULL, NULL, 87, NULL, NULL, 234642),
(278384, '1w72H01', NULL, NULL, 122, NULL, NULL, 234642),
(278385, '3dggB01', NULL, NULL, 119, NULL, NULL, 234642),
(278386, '3dvgB01', NULL, NULL, 123, NULL, NULL, 234642),
(278387, '2b5iB01', NULL, NULL, 105, NULL, NULL, 234642),
(278388, '4x9iA02', NULL, NULL, 106, NULL, NULL, 234642),
(278389, '1z9mB00', NULL, NULL, 109, NULL, NULL, 234642),
(278390, '4l3aB03', NULL, NULL, 79, NULL, NULL, 234642),
(278391, '4xvtH02', NULL, NULL, 103, NULL, NULL, 234642),
(278392, '1x44A00', NULL, NULL, 103, NULL, NULL, 234642),
(278393, '3zkmC01', NULL, NULL, 116, NULL, NULL, 234642),
(278394, '6e4xY01', NULL, NULL, 103, NULL, NULL, 234642),
(278395, '4xvtH01', NULL, NULL, 125, NULL, NULL, 234642),
(278396, '3q3gA01', NULL, NULL, 114, NULL, NULL, 234642),
(278397, '4at6G01', NULL, NULL, 117, NULL, NULL, 234642),
(278398, '1s3kH01', NULL, NULL, 119, NULL, NULL, 234642),
(278399, '2a77L01', NULL, NULL, 113, NULL, NULL, 234642),
(278400, '2ospA02', NULL, NULL, 103, NULL, NULL, 234642),
(278401, '4nylA01', NULL, NULL, 121, NULL, NULL, 234642),
(278402, '5en2B01', NULL, NULL, 107, NULL, NULL, 234642),
(278403, '4pjgF01', NULL, NULL, 117, NULL, NULL, 234642),
(278404, '3l5xH01', NULL, NULL, 121, NULL, NULL, 234642),
(278405, '2d9qB03', NULL, NULL, 110, NULL, NULL, 234642),
(278406, '2d9qB02', NULL, NULL, 108, NULL, NULL, 234642),
(278407, '2d9qB01', NULL, NULL, 95, NULL, NULL, 234642),
(278408, '6c61B01', NULL, NULL, 116, NULL, NULL, 234642);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(278409, '5f1nA02', NULL, NULL, 93, NULL, NULL, 234642),
(278410, '5mheL01', NULL, NULL, 107, NULL, NULL, 234642),
(278411, '4rnrC01', NULL, NULL, 129, NULL, NULL, 234642),
(278412, '3ulsB01', NULL, NULL, 122, NULL, NULL, 234642),
(278413, '4yflI01', NULL, NULL, 108, NULL, NULL, 234642),
(278414, '4nofB00', NULL, NULL, 125, NULL, NULL, 234642),
(278415, '1xiwA00', NULL, NULL, 105, NULL, NULL, 234642),
(278416, '2e9jA01', NULL, NULL, 98, NULL, NULL, 234642),
(278417, '3fmgL01', NULL, NULL, 108, NULL, NULL, 234642),
(278418, '3m07A01', NULL, NULL, 96, NULL, NULL, 234642),
(278419, '6eluC01', NULL, NULL, 112, NULL, NULL, 234642),
(278420, '2j4wL01', NULL, NULL, 107, NULL, NULL, 234642),
(278421, '2w9dH02', NULL, NULL, 99, NULL, NULL, 234642),
(278422, '2w9dH01', NULL, NULL, 116, NULL, NULL, 234642),
(278423, '2z92B01', NULL, NULL, 107, NULL, NULL, 234642),
(278424, '4u6hB01', NULL, NULL, 113, NULL, NULL, 234642),
(278425, '2dicA01', NULL, NULL, 94, NULL, NULL, 234642),
(278426, '1jmxA03', NULL, NULL, 79, NULL, NULL, 234642),
(278427, '4hxbL01', NULL, NULL, 113, NULL, NULL, 234642),
(278428, '1jmxA04', NULL, NULL, 124, NULL, NULL, 234642),
(278429, '4jzoF01', NULL, NULL, 109, NULL, NULL, 234642),
(278430, '2petA02', NULL, NULL, 116, NULL, NULL, 234642),
(278431, '1nakH01', NULL, NULL, 113, NULL, NULL, 234642),
(278432, '2petA01', NULL, NULL, 115, NULL, NULL, 234642),
(278433, '1fptH01', NULL, NULL, 120, NULL, NULL, 234642),
(278434, '2aepH01', NULL, NULL, 120, NULL, NULL, 234642),
(278435, '3gkwH02', NULL, NULL, 105, NULL, NULL, 234642),
(278436, '1zanL02', NULL, NULL, 103, NULL, NULL, 234642),
(278437, '3gkwH01', NULL, NULL, 117, NULL, NULL, 234642),
(278438, '3i50H01', NULL, NULL, 121, NULL, NULL, 234642),
(278439, '2zchH01', NULL, NULL, 122, NULL, NULL, 234642),
(278440, '3wo4B01', NULL, NULL, 97, NULL, NULL, 234642),
(278441, '3ifpA01', NULL, NULL, 123, NULL, NULL, 234642),
(278442, '2yxmA00', NULL, NULL, 100, NULL, NULL, 234642),
(278443, '5muhA01', NULL, NULL, 108, NULL, NULL, 234642),
(278444, '1zanL01', NULL, NULL, 108, NULL, NULL, 234642),
(278445, '4d9qD01', NULL, NULL, 107, NULL, NULL, 234642),
(278446, '6cdmB01', NULL, NULL, 113, NULL, NULL, 234642),
(278447, '1cygA03', NULL, NULL, 84, NULL, NULL, 234642),
(278448, '1cygA04', NULL, NULL, 104, NULL, NULL, 234642),
(278449, '4v2bA00', NULL, NULL, 115, NULL, NULL, 234642),
(278450, '5bv7L01', NULL, NULL, 109, NULL, NULL, 234642),
(278451, '3qeuA01', NULL, NULL, 110, NULL, NULL, 234642),
(278452, '5noiA01', NULL, NULL, 102, NULL, NULL, 234642),
(278453, '3mffB01', NULL, NULL, 113, NULL, NULL, 234642),
(278454, '3fo9B01', NULL, NULL, 118, NULL, NULL, 234642),
(278455, '3wxwH00', NULL, NULL, 119, NULL, NULL, 234642),
(278456, '5c0nC01', NULL, NULL, 120, NULL, NULL, 234642),
(278457, '5cszA01', NULL, NULL, 126, NULL, NULL, 234642),
(278458, '4hfwB01', NULL, NULL, 120, NULL, NULL, 234642),
(278459, '5eoqL01', NULL, NULL, 113, NULL, NULL, 234642),
(278460, '4s1dC01', NULL, NULL, 120, NULL, NULL, 234642),
(278461, '5do2C01', NULL, NULL, 116, NULL, NULL, 234642),
(278462, '4rsvA00', NULL, NULL, 102, NULL, NULL, 234642),
(278463, '5ghuA02', NULL, NULL, 94, NULL, NULL, 234642),
(278464, '5vxrH02', NULL, NULL, 99, NULL, NULL, 234642),
(278465, '1tziA01', NULL, NULL, 108, NULL, NULL, 234642),
(278466, '5noiA02', NULL, NULL, 99, NULL, NULL, 234642),
(278467, '1mh5B01', NULL, NULL, 119, NULL, NULL, 234642),
(278468, '5jdsA00', NULL, NULL, 124, NULL, NULL, 234642),
(278469, '1mh5B02', NULL, NULL, 68, NULL, NULL, 234642),
(278470, '3ujjL01', NULL, NULL, 109, NULL, NULL, 234642),
(278471, '1nkrA02', NULL, NULL, 98, NULL, NULL, 234642),
(278472, '1nkrA01', NULL, NULL, 103, NULL, NULL, 234642),
(278473, '2aj3A01', NULL, NULL, 107, NULL, NULL, 234642),
(278474, '4im8A02', NULL, NULL, 92, NULL, NULL, 234642),
(278475, '4im8A01', NULL, NULL, 98, NULL, NULL, 234642),
(278476, '5f96H01', NULL, NULL, 122, NULL, NULL, 234642),
(278477, '3wcyA02', NULL, NULL, 90, NULL, NULL, 234642),
(278478, '4fmkA02', NULL, NULL, 104, NULL, NULL, 234642),
(278479, '4fmkA01', NULL, NULL, 121, NULL, NULL, 234642);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(278480, '1f8tH01', NULL, NULL, 118, NULL, NULL, 234642),
(278481, '3wcyA04', NULL, NULL, 100, NULL, NULL, 234642),
(278482, '3wcyA03', NULL, NULL, 102, NULL, NULL, 234642),
(278483, '2xotA02', NULL, NULL, 86, NULL, NULL, 234642),
(278484, '4w6wB00', NULL, NULL, 131, NULL, NULL, 234642),
(278485, '2om5A04', NULL, NULL, 90, NULL, NULL, 234642),
(278486, '4o51A01', NULL, NULL, 110, NULL, NULL, 234642),
(278487, '1wftA01', NULL, NULL, 104, NULL, NULL, 234642),
(278488, '3qdhA02', NULL, NULL, 131, NULL, NULL, 234642),
(278489, '2om5A02', NULL, NULL, 105, NULL, NULL, 234642),
(278490, '2om5A03', NULL, NULL, 89, NULL, NULL, 234642),
(278491, '2q20A00', NULL, NULL, 109, NULL, NULL, 234642),
(278492, '2om5A01', NULL, NULL, 97, NULL, NULL, 234642),
(278493, '5dgqA01', NULL, NULL, 92, NULL, NULL, 234642),
(278494, '4jo4L01', NULL, NULL, 111, NULL, NULL, 234642),
(278495, '5ggsA01', NULL, NULL, 120, NULL, NULL, 234642),
(278496, '5jq6L01', NULL, NULL, 112, NULL, NULL, 234642),
(278497, '2ywyB00', NULL, NULL, 113, NULL, NULL, 234642),
(278498, '4v1dE00', NULL, NULL, 126, NULL, NULL, 234642),
(278499, '5n48D00', NULL, NULL, 106, NULL, NULL, 234642),
(278500, '4tprH01', NULL, NULL, 121, NULL, NULL, 234642),
(278501, '2rb8A00', NULL, NULL, 104, NULL, NULL, 234642),
(278502, '1ndgB01', NULL, NULL, 113, NULL, NULL, 234642),
(278503, '5ucbL01', NULL, NULL, 106, NULL, NULL, 234642),
(278504, '1rzfL01', NULL, NULL, 110, NULL, NULL, 234642),
(278505, '4zxbE06', NULL, NULL, 111, NULL, NULL, 234642),
(278506, '4zxbE05', NULL, NULL, 120, NULL, NULL, 234642),
(278507, '6r8xB01', NULL, NULL, 111, NULL, NULL, 234642),
(278508, '4u0rB01', NULL, NULL, 122, NULL, NULL, 234642),
(278509, '1fhgA00', NULL, NULL, 102, NULL, NULL, 234642),
(278510, '4fzeL01', NULL, NULL, 107, NULL, NULL, 234642),
(278511, '4oiiH01', NULL, NULL, 117, NULL, NULL, 234642),
(278512, '3kdmA01', NULL, NULL, 112, NULL, NULL, 234642),
(278513, '1mqkH00', NULL, NULL, 127, NULL, NULL, 234642),
(278514, '2jb6H01', NULL, NULL, 120, NULL, NULL, 234642),
(278515, '1g1cA00', NULL, NULL, 99, NULL, NULL, 234642),
(278516, '5cgmB01', NULL, NULL, 142, NULL, NULL, 234642),
(278517, '4n8cH01', NULL, NULL, 119, NULL, NULL, 234642),
(278518, '1bjmA01', NULL, NULL, 111, NULL, NULL, 234642),
(278519, '3qq9D01', NULL, NULL, 120, NULL, NULL, 234642),
(278520, '2vq1B01', NULL, NULL, 118, NULL, NULL, 234642),
(278521, '1a21A01', NULL, NULL, 103, NULL, NULL, 234642),
(278522, '3wsqL01', NULL, NULL, 109, NULL, NULL, 234642),
(278523, '3cafA01', NULL, NULL, 96, NULL, NULL, 234642),
(278524, '2xwtB02', NULL, NULL, 101, NULL, NULL, 234642),
(278525, '2xwtB01', NULL, NULL, 111, NULL, NULL, 234642),
(278526, '1h5bB00', NULL, NULL, 111, NULL, NULL, 234642),
(278527, '3mckB01', NULL, NULL, 123, NULL, NULL, 234642),
(278528, '1lp9E01', NULL, NULL, 113, NULL, NULL, 234642),
(278529, '4jamL01', NULL, NULL, 104, NULL, NULL, 234642),
(278530, '2j6eL01', NULL, NULL, 111, NULL, NULL, 234642),
(278531, '2arjB02', NULL, NULL, 97, NULL, NULL, 234642),
(278532, '2arjB01', NULL, NULL, 117, NULL, NULL, 234642),
(278533, '2fgwH01', NULL, NULL, 125, NULL, NULL, 234642),
(278534, '3tclA01', NULL, NULL, 133, NULL, NULL, 234642),
(278535, '4jy5L01', NULL, NULL, 104, NULL, NULL, 234642),
(278536, '4q9bA00', NULL, NULL, 103, NULL, NULL, 234642),
(278537, '1uwxH01', NULL, NULL, 124, NULL, NULL, 234642),
(278538, '4gagH01', NULL, NULL, 118, NULL, NULL, 234642),
(278539, '4hlzH01', NULL, NULL, 108, NULL, NULL, 234642),
(278540, '5ldnL01', NULL, NULL, 108, NULL, NULL, 234642),
(278541, '4lu5H01', NULL, NULL, 114, NULL, NULL, 234642),
(278542, '4bz2L01', NULL, NULL, 108, NULL, NULL, 234642),
(278543, '5y32B03', NULL, NULL, 122, NULL, NULL, 234642),
(278544, '5y32B02', NULL, NULL, 98, NULL, NULL, 234642),
(278545, '2o5xH01', NULL, NULL, 119, NULL, NULL, 234642),
(278546, '3so5A00', NULL, NULL, 112, NULL, NULL, 234642),
(278547, '3ks0H01', NULL, NULL, 117, NULL, NULL, 234642),
(278548, '2cmrL01', NULL, NULL, 108, NULL, NULL, 234642),
(278549, '5y32B01', NULL, NULL, 109, NULL, NULL, 234642),
(278550, '1ae6L01', NULL, NULL, 113, NULL, NULL, 234642);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(278551, '1igjB01', NULL, NULL, 119, NULL, NULL, 234642),
(278552, '5d7sH01', NULL, NULL, 117, NULL, NULL, 234642),
(278553, '5epmB01', NULL, NULL, 113, NULL, NULL, 234642),
(278554, '5gjsH01', NULL, NULL, 121, NULL, NULL, 234642),
(278555, '5gjyA02', NULL, NULL, 90, NULL, NULL, 234642),
(278556, '2otuB00', NULL, NULL, 118, NULL, NULL, 234642),
(278557, '4x8jB01', NULL, NULL, 107, NULL, NULL, 234642),
(278558, '6bzwD01', NULL, NULL, 113, NULL, NULL, 234642),
(278559, '2ys4A01', NULL, NULL, 103, NULL, NULL, 234642),
(278560, '3tv3L01', NULL, NULL, 106, NULL, NULL, 234642),
(278561, '4hg4J00', NULL, NULL, 115, NULL, NULL, 234642),
(278562, '3pf2A02', NULL, NULL, 142, NULL, NULL, 234642),
(278563, '4aq1B00', NULL, NULL, 130, NULL, NULL, 234642),
(278564, '1ad9B01', NULL, NULL, 120, NULL, NULL, 234642),
(278565, '4hljA02', NULL, NULL, 127, NULL, NULL, 234642),
(278566, '2qr0B01', NULL, NULL, 118, NULL, NULL, 234642),
(278567, '4hljA01', NULL, NULL, 113, NULL, NULL, 234642),
(278568, '6c08B02', NULL, NULL, 104, NULL, NULL, 234642),
(278569, '6c08B01', NULL, NULL, 111, NULL, NULL, 234642),
(278570, '1jhlL00', NULL, NULL, 108, NULL, NULL, 234642),
(278571, '3k80A00', NULL, NULL, 130, NULL, NULL, 234642),
(278572, '5e5rB02', NULL, NULL, 95, NULL, NULL, 234642),
(278573, '4hwbA00', NULL, NULL, 122, NULL, NULL, 234642),
(278574, '3tv3L02', NULL, NULL, 105, NULL, NULL, 234642),
(278575, '2edtA01', NULL, NULL, 88, NULL, NULL, 234642),
(278576, '5fhaH01', NULL, NULL, 119, NULL, NULL, 234642),
(278577, '1nj9A01', NULL, NULL, 111, NULL, NULL, 234642),
(278578, '2qqkL01', NULL, NULL, 108, NULL, NULL, 234642),
(278579, '3dbxA02', NULL, NULL, 103, NULL, NULL, 234642),
(278580, '5ksaD01', NULL, NULL, 114, NULL, NULL, 234642),
(278581, '3tjeL01', NULL, NULL, 111, NULL, NULL, 234642),
(278582, '1yjdH01', NULL, NULL, 121, NULL, NULL, 234642),
(278583, '3b9kD01', NULL, NULL, 117, NULL, NULL, 234642),
(278584, '2vxtL01', NULL, NULL, 108, NULL, NULL, 234642),
(278585, '4ravC00', NULL, NULL, 126, NULL, NULL, 234642),
(278586, '3leyH01', NULL, NULL, 116, NULL, NULL, 234642),
(278587, '1uvqA02', NULL, NULL, 113, NULL, NULL, 234642),
(278588, '1tenA00', NULL, NULL, 90, NULL, NULL, 234642),
(278589, '4ydiL01', NULL, NULL, 104, NULL, NULL, 234642),
(278590, '2z0bE00', NULL, NULL, 131, NULL, NULL, 234642),
(278591, '3auvA01', NULL, NULL, 137, NULL, NULL, 234642),
(278592, '3x17A01', NULL, NULL, 113, NULL, NULL, 234642),
(278593, '4ki5C01', NULL, NULL, 117, NULL, NULL, 234642),
(278594, '4hbcH01', NULL, NULL, 115, NULL, NULL, 234642),
(278595, '5ifaH01', NULL, NULL, 118, NULL, NULL, 234642),
(278596, '5d8jH01', NULL, NULL, 119, NULL, NULL, 234642),
(278597, '5c86A02', NULL, NULL, 106, NULL, NULL, 234642),
(278598, '3auvA02', NULL, NULL, 107, NULL, NULL, 234642),
(278599, '5jofB01', NULL, NULL, 105, NULL, NULL, 234642),
(278600, '2wngA03', NULL, NULL, 94, NULL, NULL, 234642),
(278601, '4ocxH01', NULL, NULL, 116, NULL, NULL, 234642),
(278602, '2wngA02', NULL, NULL, 107, NULL, NULL, 234642),
(278603, '4dgvL01', NULL, NULL, 107, NULL, NULL, 234642),
(278604, '1rz7L01', NULL, NULL, 106, NULL, NULL, 234642),
(278605, '2r56L01', NULL, NULL, 107, NULL, NULL, 234642),
(278606, '2dj4A01', NULL, NULL, 97, NULL, NULL, 234642),
(278607, '4kteH01', NULL, NULL, 126, NULL, NULL, 234642),
(278608, '2e8yA02', NULL, NULL, 95, NULL, NULL, 234642),
(278609, '1rz7L02', NULL, NULL, 104, NULL, NULL, 234642),
(278610, '4eowH01', NULL, NULL, 127, NULL, NULL, 234642),
(278611, '1vgeH01', NULL, NULL, 121, NULL, NULL, 234642),
(278612, '3u1sL01', NULL, NULL, 111, NULL, NULL, 234642),
(278613, '5f9wC01', NULL, NULL, 107, NULL, NULL, 234642),
(278614, '5kvdL01', NULL, NULL, 114, NULL, NULL, 234642),
(278615, '3v8oA01', NULL, NULL, 97, NULL, NULL, 234642),
(278616, '3v8oA02', NULL, NULL, 97, NULL, NULL, 234642),
(278617, '4m5yH01', NULL, NULL, 124, NULL, NULL, 234642),
(278618, '4ygvA01', NULL, NULL, 115, NULL, NULL, 234642),
(278619, '1fgnL01', NULL, NULL, 108, NULL, NULL, 234642),
(278620, '3zhkA00', NULL, NULL, 127, NULL, NULL, 234642),
(278621, '4ywgH01', NULL, NULL, 126, NULL, NULL, 234642);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(278622, '6c09C01', NULL, NULL, 111, NULL, NULL, 234642),
(278623, '1gafH01', NULL, NULL, 114, NULL, NULL, 234642),
(278624, '5uk4a00', NULL, NULL, 139, NULL, NULL, 234642),
(278625, '1mcoH01', NULL, NULL, 118, NULL, NULL, 234642),
(278626, '1op9A00', NULL, NULL, 121, NULL, NULL, 234642),
(278627, '1mcoH02', NULL, NULL, 102, NULL, NULL, 234642),
(278628, '5k64A02', NULL, NULL, 115, NULL, NULL, 234642),
(278629, '5wtgA01', NULL, NULL, 106, NULL, NULL, 234642),
(278630, '5ug0C01', NULL, NULL, 110, NULL, NULL, 234642),
(278631, '1fnfA01', NULL, NULL, 94, NULL, NULL, 234642),
(278632, '3i84B00', NULL, NULL, 98, NULL, NULL, 234642),
(278633, '3dx9B01', NULL, NULL, 115, NULL, NULL, 234642),
(278634, '1fnfA03', NULL, NULL, 89, NULL, NULL, 234642),
(278635, '6qn9L01', NULL, NULL, 109, NULL, NULL, 234642),
(278636, '2vl5A01', NULL, NULL, 119, NULL, NULL, 234642),
(278637, '4py7B01', NULL, NULL, 107, NULL, NULL, 234642),
(278638, '5uknH02', NULL, NULL, 105, NULL, NULL, 234642),
(278639, '3whxB01', NULL, NULL, 113, NULL, NULL, 234642),
(278640, '1igmL00', NULL, NULL, 115, NULL, NULL, 234642),
(278641, '5f3bA01', NULL, NULL, 116, NULL, NULL, 234642),
(278642, '3v9fA03', NULL, NULL, 126, NULL, NULL, 234642),
(278643, '4kucD02', NULL, NULL, 104, NULL, NULL, 234642),
(278644, '4kucD01', NULL, NULL, 107, NULL, NULL, 234642),
(278645, '5ea0H01', NULL, NULL, 119, NULL, NULL, 234642),
(278646, '5t29L01', NULL, NULL, 110, NULL, NULL, 234642),
(278647, '5l21B00', NULL, NULL, 119, NULL, NULL, 234642),
(278648, '3b9vB00', NULL, NULL, 120, NULL, NULL, 234642),
(278649, '3n9gH01', NULL, NULL, 123, NULL, NULL, 234642),
(278650, '4liqL01', NULL, NULL, 107, NULL, NULL, 234642),
(278651, '3n9gH02', NULL, NULL, 107, NULL, NULL, 234642),
(278652, '6attL01', NULL, NULL, 113, NULL, NULL, 234642),
(278653, '5epmA01', NULL, NULL, 119, NULL, NULL, 234642),
(278654, '5uslC01', NULL, NULL, 109, NULL, NULL, 234642),
(278655, '1ub6B01', NULL, NULL, 112, NULL, NULL, 234642),
(278656, '6avzA00', NULL, NULL, 109, NULL, NULL, 234642),
(278657, '1zv5A00', NULL, NULL, 130, NULL, NULL, 234642),
(278658, '1jtpB00', NULL, NULL, 148, NULL, NULL, 234642),
(278659, '3q48A02', NULL, NULL, 107, NULL, NULL, 234642),
(278660, '1bj1J01', NULL, NULL, 108, NULL, NULL, 234642),
(278661, '5ggsB01', NULL, NULL, 112, NULL, NULL, 234642),
(278662, '1kcvH02', NULL, NULL, 99, NULL, NULL, 234642),
(278663, '1kcvH01', NULL, NULL, 116, NULL, NULL, 234642),
(278664, '5m02A02', NULL, NULL, 91, NULL, NULL, 234642),
(278665, '5ayqA00', NULL, NULL, 138, NULL, NULL, 234642),
(278666, '1eapB02', NULL, NULL, 97, NULL, NULL, 234642),
(278667, '1eapB01', NULL, NULL, 119, NULL, NULL, 234642),
(278668, '5j1aA02', NULL, NULL, 102, NULL, NULL, 234642),
(278669, '2zuyA01', NULL, NULL, 93, NULL, NULL, 234642),
(278670, '3i2cH01', NULL, NULL, 120, NULL, NULL, 234642),
(278671, '1lo4L01', NULL, NULL, 113, NULL, NULL, 234642),
(278672, '3rvvC01', NULL, NULL, 108, NULL, NULL, 234642),
(278673, '5umnD01', NULL, NULL, 107, NULL, NULL, 234642),
(278674, '1uweH01', NULL, NULL, 115, NULL, NULL, 234642),
(278675, '4llyA01', NULL, NULL, 119, NULL, NULL, 234642),
(278676, '4k3jL01', NULL, NULL, 113, NULL, NULL, 234642),
(278677, '4u0rC01', NULL, NULL, 112, NULL, NULL, 234642),
(278678, '4k94C02', NULL, NULL, 107, NULL, NULL, 234642),
(278679, '1ztxH01', NULL, NULL, 119, NULL, NULL, 234642),
(278680, '5c1mB00', NULL, NULL, 125, NULL, NULL, 234642),
(278681, '4depF01', NULL, NULL, 117, NULL, NULL, 234642),
(278682, '5it2L01', NULL, NULL, 108, NULL, NULL, 234642),
(278683, '3mlpE02', NULL, NULL, 97, NULL, NULL, 234642),
(278684, '2k9uA00', NULL, NULL, 119, NULL, NULL, 234642),
(278685, '6ejmI02', NULL, NULL, 126, NULL, NULL, 234642),
(278686, '4jo1L01', NULL, NULL, 113, NULL, NULL, 234642),
(278687, '5czxD01', NULL, NULL, 107, NULL, NULL, 234642),
(278688, '4dtgL01', NULL, NULL, 112, NULL, NULL, 234642),
(278689, '4nkqB01', NULL, NULL, 98, NULL, NULL, 234642),
(278690, '2ypvL01', NULL, NULL, 108, NULL, NULL, 234642),
(278691, '2ih3A01', NULL, NULL, 118, NULL, NULL, 234642),
(278692, '2ih3A02', NULL, NULL, 99, NULL, NULL, 234642);
INSERT INTO "PUBLIC"."MODEL" VALUES
(278693, '4nc2B00', NULL, NULL, 122, NULL, NULL, 234642),
(278694, '5xqwL01', NULL, NULL, 107, NULL, NULL, 234642),
(278695, '4nn5B02', NULL, NULL, 111, NULL, NULL, 234642),
(278696, '4kzdH01', NULL, NULL, 125, NULL, NULL, 234642),
(278697, '2q8bH01', NULL, NULL, 112, NULL, NULL, 234642),
(278698, '5mwnN00', NULL, NULL, 125, NULL, NULL, 234642),
(278699, '5wcaL02', NULL, NULL, 101, NULL, NULL, 234642),
(278700, '1fh5H01', NULL, NULL, 108, NULL, NULL, 234642),
(278701, '1lwrA00', NULL, NULL, 96, NULL, NULL, 234642),
(278702, '1k8dA02', NULL, NULL, 91, NULL, NULL, 234642),
(278703, '2r4rH01', NULL, NULL, 114, NULL, NULL, 234642),
(278704, '4aeeA01', NULL, NULL, 117, NULL, NULL, 234642),
(278705, '4aeeA02', NULL, NULL, 97, NULL, NULL, 234642),
(278706, '3hc4L01', NULL, NULL, 108, NULL, NULL, 234642),
(278707, '1ikfH01', NULL, NULL, 127, NULL, NULL, 234642),
(278708, '1jz7A02', NULL, NULL, 115, NULL, NULL, 234642),
(278709, '1xedC00', NULL, NULL, 117, NULL, NULL, 234642),
(278710, '1jz7A04', NULL, NULL, 106, NULL, NULL, 234642),
(278711, '5jqhD00', NULL, NULL, 125, NULL, NULL, 234642),
(278712, '1p2cA01', NULL, NULL, 108, NULL, NULL, 234642),
(278713, '4lgpD00', NULL, NULL, 116, NULL, NULL, 234642),
(278714, '3pv7A02', NULL, NULL, 104, NULL, NULL, 234642),
(278715, '3pv7A01', NULL, NULL, 118, NULL, NULL, 234642),
(278716, '5eu6D01', NULL, NULL, 115, NULL, NULL, 234642),
(278717, '1rjcA00', NULL, NULL, 137, NULL, NULL, 234642),
(278718, '1aifA01', NULL, NULL, 109, NULL, NULL, 234642),
(278719, '3f8uD03', NULL, NULL, 111, NULL, NULL, 234642),
(278720, '2ospB02', NULL, NULL, 99, NULL, NULL, 234642),
(278721, '3rnkB00', NULL, NULL, 104, NULL, NULL, 234642),
(278722, '5k9qI01', NULL, NULL, 108, NULL, NULL, 234642),
(278723, '5f7uA01', NULL, NULL, 115, NULL, NULL, 234642),
(278724, '6axkB01', NULL, NULL, 113, NULL, NULL, 234642),
(278725, '1l7tH01', NULL, NULL, 118, NULL, NULL, 234642),
(278726, '5f9oL01', NULL, NULL, 107, NULL, NULL, 234642),
(278727, '6b5rL01', NULL, NULL, 111, NULL, NULL, 234642),
(278728, '4z0bL01', NULL, NULL, 105, NULL, NULL, 234642),
(278729, '3b5hA02', NULL, NULL, 101, NULL, NULL, 234642),
(278730, '4z0bL02', NULL, NULL, 103, NULL, NULL, 234642),
(278731, '3vgfA01', NULL, NULL, 87, NULL, NULL, 234642),
(278732, '2xzcH01', NULL, NULL, 119, NULL, NULL, 234642),
(278733, '1xf1A05', NULL, NULL, 101, NULL, NULL, 234642),
(278734, '2eecA01', NULL, NULL, 94, NULL, NULL, 234642),
(278735, '4x5lA00', NULL, NULL, 102, NULL, NULL, 234642),
(278736, '5dfvD01', NULL, NULL, 106, NULL, NULL, 234642),
(278737, '1qr4A01', NULL, NULL, 94, NULL, NULL, 234642),
(278738, '1qr4A02', NULL, NULL, 92, NULL, NULL, 234642),
(278739, '2xknA01', NULL, NULL, 107, NULL, NULL, 234642),
(278740, '2pttB00', NULL, NULL, 112, NULL, NULL, 234642),
(278741, '4cniB01', NULL, NULL, 108, NULL, NULL, 234642),
(278742, '3ry4A02', NULL, NULL, 84, NULL, NULL, 234642),
(278743, '4hpoH01', NULL, NULL, 125, NULL, NULL, 234642),
(278744, '3ry4A01', NULL, NULL, 86, NULL, NULL, 234642),
(278745, '5tppH01', NULL, NULL, 127, NULL, NULL, 234642),
(278746, '4x5wA02', NULL, NULL, 111, NULL, NULL, 234642),
(278747, '1it9H01', NULL, NULL, 121, NULL, NULL, 234642),
(278748, '3k7uA00', NULL, NULL, 128, NULL, NULL, 234642),
(278749, '5esvB01', NULL, NULL, 109, NULL, NULL, 234642),
(278750, '4zykH01', NULL, NULL, 123, NULL, NULL, 234642),
(278751, '2k1mA00', NULL, NULL, 95, NULL, NULL, 234642),
(278752, '4a2lB03', NULL, NULL, 135, NULL, NULL, 234642),
(278753, '4fnlH01', NULL, NULL, 138, NULL, NULL, 234642),
(278754, '2axhA01', NULL, NULL, 113, NULL, NULL, 234642),
(278755, '3dviA00', NULL, NULL, 109, NULL, NULL, 234642),
(278756, '4kphH01', NULL, NULL, 113, NULL, NULL, 234642),
(278757, '4x7fD00', NULL, NULL, 119, NULL, NULL, 234642),
(278758, '4jzjA01', NULL, NULL, 120, NULL, NULL, 234642),
(278759, '5bk1L01', NULL, NULL, 110, NULL, NULL, 234642),
(278760, '1xiwC00', NULL, NULL, 108, NULL, NULL, 234642),
(278761, '5mykA01', NULL, NULL, 113, NULL, NULL, 234642),
(278762, '3n1fD00', NULL, NULL, 102, NULL, NULL, 234642),
(278763, '5tq0H01', NULL, NULL, 119, NULL, NULL, 234642); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(278764, '1bwwA00', NULL, NULL, 109, NULL, NULL, 234642),
(278765, '1wioA04', NULL, NULL, 72, NULL, NULL, 234642),
(278766, '2a74A04', NULL, NULL, 102, NULL, NULL, 234642),
(278767, '2yd1A01', NULL, NULL, 103, NULL, NULL, 234642),
(278768, '1ex0A03', NULL, NULL, 114, NULL, NULL, 234642),
(278769, '1wioA03', NULL, NULL, 111, NULL, NULL, 234642),
(278770, '2yd1A02', NULL, NULL, 109, NULL, NULL, 234642),
(278771, '4g8eB01', NULL, NULL, 118, NULL, NULL, 234642),
(278772, '4toyL01', NULL, NULL, 111, NULL, NULL, 234642),
(278773, '4xh2C01', NULL, NULL, 120, NULL, NULL, 234642),
(278774, '5iusB00', NULL, NULL, 129, NULL, NULL, 234642),
(278775, '4k94L01', NULL, NULL, 109, NULL, NULL, 234642),
(278776, '3qp3A00', NULL, NULL, 103, NULL, NULL, 234642),
(278777, '3durA00', NULL, NULL, 112, NULL, NULL, 234642),
(278778, '6c83C00', NULL, NULL, 93, NULL, NULL, 234642),
(278779, '5w5zL01', NULL, NULL, 107, NULL, NULL, 234642),
(278780, '5w5zL02', NULL, NULL, 103, NULL, NULL, 234642),
(278781, '4kq3H01', NULL, NULL, 117, NULL, NULL, 234642),
(278782, '5e7bA00', NULL, NULL, 131, NULL, NULL, 234642),
(278783, '4l9dA00', NULL, NULL, 88, NULL, NULL, 234642),
(278784, '5albL01', NULL, NULL, 112, NULL, NULL, 234642),
(278785, '5drzA01', NULL, NULL, 113, NULL, NULL, 234642),
(278786, '4hxaH01', NULL, NULL, 119, NULL, NULL, 234642),
(278787, '5gs3A01', NULL, NULL, 119, NULL, NULL, 234642),
(278788, '4jvpB00', NULL, NULL, 143, NULL, NULL, 234642),
(278789, '3uc0L01', NULL, NULL, 109, NULL, NULL, 234642),
(278790, '1uj3B01', NULL, NULL, 117, NULL, NULL, 234642),
(278791, '2fbjH01', NULL, NULL, 118, NULL, NULL, 234642),
(278792, '2fbjH02', NULL, NULL, 73, NULL, NULL, 234642),
(278793, '2q3aB00', NULL, NULL, 120, NULL, NULL, 234642),
(278794, '4ygaD00', NULL, NULL, 124, NULL, NULL, 234642),
(278795, '5zv3L01', NULL, NULL, 113, NULL, NULL, 234642),
(278796, '3pnwB01', NULL, NULL, 129, NULL, NULL, 234642),
(278797, '1nsnH01', NULL, NULL, 113, NULL, NULL, 234642),
(278798, '5kn5B01', NULL, NULL, 111, NULL, NULL, 234642),
(278799, '2vxvH01', NULL, NULL, 121, NULL, NULL, 234642),
(278800, '6avgB01', NULL, NULL, 108, NULL, NULL, 234642),
(278801, '2eh7H01', NULL, NULL, 115, NULL, NULL, 234642),
(278802, '5tqqL00', NULL, NULL, 107, NULL, NULL, 234642),
(278803, '4ffvD01', NULL, NULL, 117, NULL, NULL, 234642),
(278804, '3aazA01', NULL, NULL, 125, NULL, NULL, 234642),
(278805, '1f97A02', NULL, NULL, 110, NULL, NULL, 234642),
(278806, '3vxsD01', NULL, NULL, 113, NULL, NULL, 234642),
(278807, '3g5vA01', NULL, NULL, 107, NULL, NULL, 234642),
(278808, '5anmH01', NULL, NULL, 117, NULL, NULL, 234642),
(278809, '1f58L01', NULL, NULL, 112, NULL, NULL, 234642),
(278810, '3pp4L01', NULL, NULL, 112, NULL, NULL, 234642),
(278811, '1f97A01', NULL, NULL, 102, NULL, NULL, 234642),
(278812, '1cczA01', NULL, NULL, 93, NULL, NULL, 234642),
(278813, '1z9oA00', NULL, NULL, 128, NULL, NULL, 234642),
(278814, '5d1xB01', NULL, NULL, 117, NULL, NULL, 234642),
(278815, '1cczA02', NULL, NULL, 78, NULL, NULL, 234642),
(278816, '1ulvA03', NULL, NULL, 86, NULL, NULL, 234642),
(278817, '1b2wH01', NULL, NULL, 117, NULL, NULL, 234642),
(278818, '3qskB00', NULL, NULL, 123, NULL, NULL, 234642),
(278819, '4trpH01', NULL, NULL, 113, NULL, NULL, 234642),
(278820, '1ad9L01', NULL, NULL, 111, NULL, NULL, 234642),
(278821, '3hr6A01', NULL, NULL, 143, NULL, NULL, 234642),
(278822, '4ypjA02', NULL, NULL, 119, NULL, NULL, 234642),
(278823, '3uo1H01', NULL, NULL, 116, NULL, NULL, 234642),
(278824, '4ypjA05', NULL, NULL, 111, NULL, NULL, 234642),
(278825, '3hr6A03', NULL, NULL, 133, NULL, NULL, 234642),
(278826, '3bmvA04', NULL, NULL, 103, NULL, NULL, 234642),
(278827, '4ztpL01', NULL, NULL, 113, NULL, NULL, 234642),
(278828, '3bmvA03', NULL, NULL, 84, NULL, NULL, 234642),
(278829, '1l6xA01', NULL, NULL, 100, NULL, NULL, 234642),
(278830, '3v0wH01', NULL, NULL, 121, NULL, NULL, 234642),
(278831, '3lmjL01', NULL, NULL, 111, NULL, NULL, 234642),
(278832, '1emtH01', NULL, NULL, 113, NULL, NULL, 234642),
(278833, '4lgrB00', NULL, NULL, 122, NULL, NULL, 234642),
(278834, '3do7A02', NULL, NULL, 105, NULL, NULL, 234642);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(278835, '3ojmB02', NULL, NULL, 105, NULL, NULL, 234642),
(278836, '4jkmA02', NULL, NULL, 94, NULL, NULL, 234642),
(278837, '4kc3B02', NULL, NULL, 95, NULL, NULL, 234642),
(278838, '4kc3B01', NULL, NULL, 94, NULL, NULL, 234642),
(278839, '4kc3B03', NULL, NULL, 120, NULL, NULL, 234642),
(278840, '2j88L01', NULL, NULL, 107, NULL, NULL, 234642),
(278841, '1cf8H01', NULL, NULL, 116, NULL, NULL, 234642),
(278842, '1verA00', NULL, NULL, 111, NULL, NULL, 234642),
(278843, '6cdpB01', NULL, NULL, 113, NULL, NULL, 234642),
(278844, '1u3hA00', NULL, NULL, 110, NULL, NULL, 234642),
(278845, '5i1kL01', NULL, NULL, 109, NULL, NULL, 234642),
(278846, '4n90D01', NULL, NULL, 122, NULL, NULL, 234642),
(278847, '4c4kO00', NULL, NULL, 98, NULL, NULL, 234642),
(278848, '5iq9A01', NULL, NULL, 131, NULL, NULL, 234642),
(278849, '4xcfH01', NULL, NULL, 123, NULL, NULL, 234642),
(278850, '4xcfH02', NULL, NULL, 105, NULL, NULL, 234642),
(278851, '4c83D01', NULL, NULL, 108, NULL, NULL, 234642),
(278852, '6i9iL01', NULL, NULL, 113, NULL, NULL, 234642),
(278853, '5t93A00', NULL, NULL, 110, NULL, NULL, 234642),
(278854, '4xgzC01', NULL, NULL, 121, NULL, NULL, 234642),
(278855, '2d7tH00', NULL, NULL, 116, NULL, NULL, 234642),
(278856, '3t65A01', NULL, NULL, 113, NULL, NULL, 234642),
(278857, '4rcaA03', NULL, NULL, 99, NULL, NULL, 234642),
(278858, '3hzmB01', NULL, NULL, 126, NULL, NULL, 234642),
(278859, '6bckH01', NULL, NULL, 127, NULL, NULL, 234642),
(278860, '1rhhD01', NULL, NULL, 132, NULL, NULL, 234642),
(278861, '1iaiL01', NULL, NULL, 108, NULL, NULL, 234642),
(278862, '6c61A01', NULL, NULL, 115, NULL, NULL, 234642),
(278863, '4rnrB01', NULL, NULL, 111, NULL, NULL, 234642),
(278864, '4pljC01', NULL, NULL, 108, NULL, NULL, 234642),
(278865, '4uv7L01', NULL, NULL, 112, NULL, NULL, 234642),
(278866, '3ulsA01', NULL, NULL, 108, NULL, NULL, 234642),
(278867, '5yxnA01', NULL, NULL, 112, NULL, NULL, 234642),
(278868, '1k85A00', NULL, NULL, 88, NULL, NULL, 234642),
(278869, '1uywH01', NULL, NULL, 118, NULL, NULL, 234642),
(278870, '1u58A02', NULL, NULL, 111, NULL, NULL, 234642),
(278871, '2agjL01', NULL, NULL, 109, NULL, NULL, 234642),
(278872, '4n1eF00', NULL, NULL, 109, NULL, NULL, 234642),
(278873, '5jueL01', NULL, NULL, 114, NULL, NULL, 234642),
(278874, '5swsE01', NULL, NULL, 113, NULL, NULL, 234642),
(278875, '4lexH01', NULL, NULL, 117, NULL, NULL, 234642),
(278876, '6fs0L01', NULL, NULL, 110, NULL, NULL, 234642),
(278877, '2ghwD01', NULL, NULL, 119, NULL, NULL, 234642),
(278878, '4mauH01', NULL, NULL, 117, NULL, NULL, 234642),
(278879, '2ymxL01', NULL, NULL, 108, NULL, NULL, 234642),
(278880, '4ay0A01', NULL, NULL, 115, NULL, NULL, 234642),
(278881, '1t4kB01', NULL, NULL, 117, NULL, NULL, 234642),
(278882, '4nkiL01', NULL, NULL, 111, NULL, NULL, 234642),
(278883, '4webH01', NULL, NULL, 118, NULL, NULL, 234642),
(278884, '2eysA01', NULL, NULL, 116, NULL, NULL, 234642),
(278885, '4y5vG00', NULL, NULL, 130, NULL, NULL, 234642),
(278886, '3mjgX02', NULL, NULL, 87, NULL, NULL, 234642),
(278887, '3mjgX01', NULL, NULL, 92, NULL, NULL, 234642),
(278888, '5tl5L01', NULL, NULL, 112, NULL, NULL, 234642),
(278889, '2v17L01', NULL, NULL, 108, NULL, NULL, 234642),
(278890, '3mjgX03', NULL, NULL, 110, NULL, NULL, 234642),
(278891, '5bq7B01', NULL, NULL, 113, NULL, NULL, 234642),
(278892, '6ao0L01', NULL, NULL, 109, NULL, NULL, 234642),
(278893, '1faiH01', NULL, NULL, 124, NULL, NULL, 234642),
(278894, '5kaqF01', NULL, NULL, 131, NULL, NULL, 234642),
(278895, '2aeqL00', NULL, NULL, 107, NULL, NULL, 234642),
(278896, '4x83A04', NULL, NULL, 82, NULL, NULL, 234642),
(278897, '1fskC01', NULL, NULL, 118, NULL, NULL, 234642),
(278898, '4x83A02', NULL, NULL, 104, NULL, NULL, 234642),
(278899, '4x83A03', NULL, NULL, 102, NULL, NULL, 234642),
(278900, '1dn0B01', NULL, NULL, 120, NULL, NULL, 234642),
(278901, '5xmfA02', NULL, NULL, 94, NULL, NULL, 234642),
(278902, '4bsvA02', NULL, NULL, 110, NULL, NULL, 234642),
(278903, '1ngzA01', NULL, NULL, 108, NULL, NULL, 234642),
(278904, '4r7dE01', NULL, NULL, 118, NULL, NULL, 234642),
(278905, '6cphD01', NULL, NULL, 111, NULL, NULL, 234642);
INSERT INTO "PUBLIC"."MODEL" VALUES
(278906, '2f54D01', NULL, NULL, 114, NULL, NULL, 234642),
(278907, '4p23A02', NULL, NULL, 88, NULL, NULL, 234642),
(278908, '4p23A01', NULL, NULL, 109, NULL, NULL, 234642),
(278909, '1ibgH01', NULL, NULL, 121, NULL, NULL, 234642),
(278910, '2d7oA00', NULL, NULL, 111, NULL, NULL, 234642),
(278911, '25c8L01', NULL, NULL, 109, NULL, NULL, 234642),
(278912, '1q0xL01', NULL, NULL, 110, NULL, NULL, 234642),
(278913, '2yd9A03', NULL, NULL, 87, NULL, NULL, 234642),
(278914, '5v6lL01', NULL, NULL, 112, NULL, NULL, 234642),
(278915, '1q0xL02', NULL, NULL, 100, NULL, NULL, 234642),
(278916, '1ncwH01', NULL, NULL, 119, NULL, NULL, 234642),
(278917, '1a0qH01', NULL, NULL, 119, NULL, NULL, 234642),
(278918, '2b39A09', NULL, NULL, 113, NULL, NULL, 234642),
(278919, '5v7uH01', NULL, NULL, 121, NULL, NULL, 234642),
(278920, '1ncwH02', NULL, NULL, 99, NULL, NULL, 234642),
(278921, '1tdqA02', NULL, NULL, 90, NULL, NULL, 234642),
(278922, '1tdqA01', NULL, NULL, 105, NULL, NULL, 234642),
(278923, '1tdqA03', NULL, NULL, 88, NULL, NULL, 234642),
(278924, '3irzA03', NULL, NULL, 128, NULL, NULL, 234642),
(278925, '3phsA02', NULL, NULL, 109, NULL, NULL, 234642),
(278926, '3phsA01', NULL, NULL, 132, NULL, NULL, 234642),
(278927, '3s96A01', NULL, NULL, 119, NULL, NULL, 234642),
(278928, '5xxlB03', NULL, NULL, 123, NULL, NULL, 234642),
(278929, '5ip4A00', NULL, NULL, 121, NULL, NULL, 234642),
(278930, '2b39A04', NULL, NULL, 97, NULL, NULL, 234642),
(278931, '2geeA01', NULL, NULL, 112, NULL, NULL, 234642),
(278932, '5aeaA00', NULL, NULL, 100, NULL, NULL, 234642),
(278933, '2k3tA00', NULL, NULL, 99, NULL, NULL, 234642),
(278934, '3gk8H02', NULL, NULL, 100, NULL, NULL, 234642),
(278935, '2geeA02', NULL, NULL, 91, NULL, NULL, 234642),
(278936, '3gk8H01', NULL, NULL, 120, NULL, NULL, 234642),
(278937, '1oaqL00', NULL, NULL, 120, NULL, NULL, 234642),
(278938, '1cfbA01', NULL, NULL, 99, NULL, NULL, 234642),
(278939, '12e8H01', NULL, NULL, 120, NULL, NULL, 234642),
(278940, '1cfbA02', NULL, NULL, 106, NULL, NULL, 234642),
(278941, '2vweE01', NULL, NULL, 120, NULL, NULL, 234642),
(278942, '5hbtD02', NULL, NULL, 99, NULL, NULL, 234642),
(278943, '5w6cL01', NULL, NULL, 113, NULL, NULL, 234642),
(278944, '5gruH01', NULL, NULL, 132, NULL, NULL, 234642),
(278945, '5gruH02', NULL, NULL, 117, NULL, NULL, 234642),
(278946, '3zkmD01', NULL, NULL, 112, NULL, NULL, 234642),
(278947, '4hd9A02', NULL, NULL, 119, NULL, NULL, 234642),
(278948, '4uinH01', NULL, NULL, 122, NULL, NULL, 234642),
(278949, '1iakA02', NULL, NULL, 114, NULL, NULL, 234642),
(278950, '3g5yB01', NULL, NULL, 116, NULL, NULL, 234642),
(278951, '5i16B01', NULL, NULL, 119, NULL, NULL, 234642),
(278952, '4oziE01', NULL, NULL, 113, NULL, NULL, 234642),
(278953, '5e03A00', NULL, NULL, 129, NULL, NULL, 234642),
(278954, '4aj0A00', NULL, NULL, 107, NULL, NULL, 234642),
(278955, '4hj0C01', NULL, NULL, 119, NULL, NULL, 234642),
(278956, '4u6hC01', NULL, NULL, 119, NULL, NULL, 234642),
(278957, '4jjhA00', NULL, NULL, 133, NULL, NULL, 234642),
(278958, '5bozI00', NULL, NULL, 127, NULL, NULL, 234642),
(278959, '1igfH01', NULL, NULL, 119, NULL, NULL, 234642),
(278960, '2vtfA03', NULL, NULL, 95, NULL, NULL, 234642),
(278961, '4zxbD01', NULL, NULL, 108, NULL, NULL, 234642),
(278962, '5ur8B01', NULL, NULL, 109, NULL, NULL, 234642),
(278963, '3so3B01', NULL, NULL, 111, NULL, NULL, 234642),
(278964, '5e08H01', NULL, NULL, 126, NULL, NULL, 234642),
(278965, '3vw3H01', NULL, NULL, 120, NULL, NULL, 234642),
(278966, '6id4D01', NULL, NULL, 116, NULL, NULL, 234642),
(278967, '1a21B02', NULL, NULL, 103, NULL, NULL, 234642),
(278968, '4ydvB01', NULL, NULL, 126, NULL, NULL, 234642),
(278969, '3mv7D01', NULL, NULL, 110, NULL, NULL, 234642),
(278970, '3wo4C03', NULL, NULL, 111, NULL, NULL, 234642),
(278971, '3wo4C02', NULL, NULL, 91, NULL, NULL, 234642),
(278972, '4m7jH01', NULL, NULL, 118, NULL, NULL, 234642),
(278973, '3ujiH01', NULL, NULL, 123, NULL, NULL, 234642),
(278974, '3mreA02', NULL, NULL, 89, NULL, NULL, 234642),
(278975, '5ijvD01', NULL, NULL, 152, NULL, NULL, 234642),
(278976, '1shmD00', NULL, NULL, 127, NULL, NULL, 234642);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(278977, '1ad0A01', NULL, NULL, 107, NULL, NULL, 234642),
(278978, '4o4yH01', NULL, NULL, 114, NULL, NULL, 234642),
(278979, '3ujtH01', NULL, NULL, 113, NULL, NULL, 234642),
(278980, '1kb5A00', NULL, NULL, 115, NULL, NULL, 234642),
(278981, '1lilA01', NULL, NULL, 107, NULL, NULL, 234642),
(278982, '4m3kB00', NULL, NULL, 126, NULL, NULL, 234642),
(278983, '2fgzA02', NULL, NULL, 108, NULL, NULL, 234642),
(278984, '1pkqB01', NULL, NULL, 118, NULL, NULL, 234642),
(278985, '4lciH00', NULL, NULL, 120, NULL, NULL, 234642),
(278986, '2vsdA00', NULL, NULL, 105, NULL, NULL, 234642),
(278987, '2cspA01', NULL, NULL, 98, NULL, NULL, 234642),
(278988, '5dvlA02', NULL, NULL, 110, NULL, NULL, 234642),
(278989, '4hc1H01', NULL, NULL, 118, NULL, NULL, 234642),
(278990, '2edlA01', NULL, NULL, 88, NULL, NULL, 234642),
(278991, '3qi9D01', NULL, NULL, 114, NULL, NULL, 234642),
(278992, '5eocJ01', NULL, NULL, 119, NULL, NULL, 234642),
(278993, '4mlsA00', NULL, NULL, 95, NULL, NULL, 234642),
(278994, '2cryA01', NULL, NULL, 102, NULL, NULL, 234642),
(278995, '2hffH01', NULL, NULL, 125, NULL, NULL, 234642),
(278996, '2jllA04', NULL, NULL, 97, NULL, NULL, 234642),
(278997, '2jllA03', NULL, NULL, 98, NULL, NULL, 234642),
(278998, '3rugE01', NULL, NULL, 110, NULL, NULL, 234642),
(278999, '2edwA01', NULL, NULL, 88, NULL, NULL, 234642),
(279000, '2jllA02', NULL, NULL, 95, NULL, NULL, 234642),
(279001, '4jb9H01', NULL, NULL, 131, NULL, NULL, 234642),
(279002, '3oklB02', NULL, NULL, 100, NULL, NULL, 234642),
(279003, '1lk3H01', NULL, NULL, 119, NULL, NULL, 234642),
(279004, '1qz1A03', NULL, NULL, 97, NULL, NULL, 234642),
(279005, '1lo0H01', NULL, NULL, 118, NULL, NULL, 234642),
(279006, '5en2A01', NULL, NULL, 124, NULL, NULL, 234642),
(279007, '5vebB01', NULL, NULL, 108, NULL, NULL, 234642),
(279008, '6iebL01', NULL, NULL, 106, NULL, NULL, 234642),
(279009, '4ht1L01', NULL, NULL, 112, NULL, NULL, 234642),
(279010, '4nwuH01', NULL, NULL, 137, NULL, NULL, 234642),
(279011, '1t3fA01', NULL, NULL, 107, NULL, NULL, 234642),
(279012, '4nwuH02', NULL, NULL, 105, NULL, NULL, 234642),
(279013, '1qfoC00', NULL, NULL, 119, NULL, NULL, 234642),
(279014, '3wfdL01', NULL, NULL, 108, NULL, NULL, 234642),
(279015, '1ohqB00', NULL, NULL, 120, NULL, NULL, 234642),
(279016, '1t66D01', NULL, NULL, 118, NULL, NULL, 234642),
(279017, '2iqaB01', NULL, NULL, 123, NULL, NULL, 234642),
(279018, '1t66D02', NULL, NULL, 98, NULL, NULL, 234642),
(279019, '5e95B00', NULL, NULL, 97, NULL, NULL, 234642),
(279020, '2k7qA02', NULL, NULL, 78, NULL, NULL, 234642),
(279021, '5vi4E03', NULL, NULL, 120, NULL, NULL, 234642),
(279022, '5vi4E01', NULL, NULL, 95, NULL, NULL, 234642),
(279023, '5vigA01', NULL, NULL, 120, NULL, NULL, 234642),
(279024, '3omzG00', NULL, NULL, 135, NULL, NULL, 234642),
(279025, '5nivA01', NULL, NULL, 107, NULL, NULL, 234642),
(279026, '5e2wL01', NULL, NULL, 112, NULL, NULL, 234642),
(279027, '4kdwA00', NULL, NULL, 102, NULL, NULL, 234642),
(279028, '4fqjH01', NULL, NULL, 125, NULL, NULL, 234642),
(279029, '3alxC02', NULL, NULL, 119, NULL, NULL, 234642),
(279030, '5y9kL01', NULL, NULL, 109, NULL, NULL, 234642),
(279031, '5kvlL01', NULL, NULL, 107, NULL, NULL, 234642),
(279032, '5d93C01', NULL, NULL, 116, NULL, NULL, 234642),
(279033, '4y88A00', NULL, NULL, 108, NULL, NULL, 234642),
(279034, '6mjjC01', NULL, NULL, 115, NULL, NULL, 234642),
(279035, '4uaoB01', NULL, NULL, 108, NULL, NULL, 234642),
(279036, '6d4iA02', NULL, NULL, 106, NULL, NULL, 234642),
(279037, '3r8qA03', NULL, NULL, 89, NULL, NULL, 234642),
(279038, '3qeuB01', NULL, NULL, 114, NULL, NULL, 234642),
(279039, '4q66D02', NULL, NULL, 90, NULL, NULL, 234642),
(279040, '3c6lA01', NULL, NULL, 108, NULL, NULL, 234642),
(279041, '3r8qA02', NULL, NULL, 90, NULL, NULL, 234642),
(279042, '3r8qA01', NULL, NULL, 92, NULL, NULL, 234642),
(279043, '3fo9A01', NULL, NULL, 113, NULL, NULL, 234642),
(279044, '5c2bL00', NULL, NULL, 112, NULL, NULL, 234642),
(279045, '1h3tA01', NULL, NULL, 113, NULL, NULL, 234642),
(279046, '1fnsH01', NULL, NULL, 122, NULL, NULL, 234642),
(279047, '2x44D01', NULL, NULL, 97, NULL, NULL, 234642);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(279048, '4q2zA01', NULL, NULL, 124, NULL, NULL, 234642),
(279049, '4hfwA01', NULL, NULL, 106, NULL, NULL, 234642),
(279050, '5dqdH01', NULL, NULL, 122, NULL, NULL, 234642),
(279051, '1d5iH01', NULL, NULL, 120, NULL, NULL, 234642),
(279052, '4n0rA01', NULL, NULL, 86, NULL, NULL, 234642),
(279053, '6bgaC01', NULL, NULL, 116, NULL, NULL, 234642),
(279054, '2aj3B01', NULL, NULL, 121, NULL, NULL, 234642),
(279055, '2mq0A00', NULL, NULL, 95, NULL, NULL, 234642),
(279056, '4s1qH01', NULL, NULL, 131, NULL, NULL, 234642),
(279057, '3eo9H01', NULL, NULL, 121, NULL, NULL, 234642),
(279058, '3bwuC02', NULL, NULL, 84, NULL, NULL, 234642),
(279059, '6i0yz00', NULL, NULL, 89, NULL, NULL, 234642),
(279060, '4odsL01', NULL, NULL, 112, NULL, NULL, 234642),
(279061, '1he7A00', NULL, NULL, 107, NULL, NULL, 234642),
(279062, '5e4eC02', NULL, NULL, 107, NULL, NULL, 234642),
(279063, '3bwuC01', NULL, NULL, 117, NULL, NULL, 234642),
(279064, '3a0oB01', NULL, NULL, 127, NULL, NULL, 234642),
(279065, '2e7lB00', NULL, NULL, 113, NULL, NULL, 234642),
(279066, '4f9pC01', NULL, NULL, 113, NULL, NULL, 234642),
(279067, '5nhtA01', NULL, NULL, 112, NULL, NULL, 234642),
(279068, '6dznL01', NULL, NULL, 107, NULL, NULL, 234642),
(279069, '3u83A02', NULL, NULL, 101, NULL, NULL, 234642),
(279070, '3u83A03', NULL, NULL, 101, NULL, NULL, 234642),
(279071, '3u83A01', NULL, NULL, 109, NULL, NULL, 234642),
(279072, '1m1sA00', NULL, NULL, 116, NULL, NULL, 234642),
(279073, '2aabH01', NULL, NULL, 123, NULL, NULL, 234642),
(279074, '6azzB01', NULL, NULL, 110, NULL, NULL, 234642),
(279075, '5hdqH01', NULL, NULL, 120, NULL, NULL, 234642),
(279076, '3eotL01', NULL, NULL, 109, NULL, NULL, 234642),
(279077, '3go1L01', NULL, NULL, 108, NULL, NULL, 234642),
(279078, '2vl5B01', NULL, NULL, 112, NULL, NULL, 234642),
(279079, '5f6hJ01', NULL, NULL, 111, NULL, NULL, 234642),
(279080, '1ut9A01', NULL, NULL, 98, NULL, NULL, 234642),
(279081, '6al4A01', NULL, NULL, 111, NULL, NULL, 234642),
(279082, '4whtB01', NULL, NULL, 114, NULL, NULL, 234642),
(279083, '2xi9B01', NULL, NULL, 112, NULL, NULL, 234642),
(279084, '2cuiA00', NULL, NULL, 112, NULL, NULL, 234642),
(279085, '1aqkH01', NULL, NULL, 123, NULL, NULL, 234642),
(279086, '2dkmA00', NULL, NULL, 104, NULL, NULL, 234642),
(279087, '1nj9B01', NULL, NULL, 116, NULL, NULL, 234642),
(279088, '1jv5B00', NULL, NULL, 117, NULL, NULL, 234642),
(279089, '1je6A02', NULL, NULL, 89, NULL, NULL, 234642),
(279090, '1nmbH00', NULL, NULL, 122, NULL, NULL, 234642),
(279091, '5kjrL01', NULL, NULL, 116, NULL, NULL, 234642),
(279092, '5a2jH01', NULL, NULL, 116, NULL, NULL, 234642),
(279093, '2xt1B00', NULL, NULL, 121, NULL, NULL, 234642),
(279094, '5tplL01', NULL, NULL, 111, NULL, NULL, 234642),
(279095, '3cfbA01', NULL, NULL, 113, NULL, NULL, 234642),
(279096, '3b9kC01', NULL, NULL, 107, NULL, NULL, 234642),
(279097, '4fqcL01', NULL, NULL, 106, NULL, NULL, 234642),
(279098, '4odhL01', NULL, NULL, 113, NULL, NULL, 234642),
(279099, '3tnmB01', NULL, NULL, 111, NULL, NULL, 234642),
(279100, '4ravB00', NULL, NULL, 117, NULL, NULL, 234642),
(279101, '1x5hA00', NULL, NULL, 132, NULL, NULL, 234642),
(279102, '1cr9L01', NULL, NULL, 113, NULL, NULL, 234642),
(279103, '4ki5D01', NULL, NULL, 107, NULL, NULL, 234642),
(279104, '2a9mL00', NULL, NULL, 110, NULL, NULL, 234642),
(279105, '4od1L01', NULL, NULL, 113, NULL, NULL, 234642),
(279106, '2pcpB01', NULL, NULL, 117, NULL, NULL, 234642),
(279107, '5ecjE00', NULL, NULL, 95, NULL, NULL, 234642),
(279108, '5k59F01', NULL, NULL, 107, NULL, NULL, 234642),
(279109, '5y11B01', NULL, NULL, 109, NULL, NULL, 234642),
(279110, '4pljL02', NULL, NULL, 104, NULL, NULL, 234642),
(279111, '6e56I01', NULL, NULL, 109, NULL, NULL, 234642),
(279112, '6fgbL01', NULL, NULL, 113, NULL, NULL, 234642),
(279113, '5l6yL01', NULL, NULL, 109, NULL, NULL, 234642),
(279114, '1iehA00', NULL, NULL, 135, NULL, NULL, 234642),
(279115, '1pamA03', NULL, NULL, 87, NULL, NULL, 234642),
(279116, '2yuwA01', NULL, NULL, 98, NULL, NULL, 234642),
(279117, '1pamA04', NULL, NULL, 103, NULL, NULL, 234642),
(279118, '4pyhA02', NULL, NULL, 91, NULL, NULL, 234642);
INSERT INTO "PUBLIC"."MODEL" VALUES
(279119, '6nrwC00', NULL, NULL, 114, NULL, NULL, 234642),
(279120, '4hfuL01', NULL, NULL, 109, NULL, NULL, 234642),
(279121, '2zjsH01', NULL, NULL, 119, NULL, NULL, 234642),
(279122, '2mklC00', NULL, NULL, 105, NULL, NULL, 234642),
(279123, '5y32A02', NULL, NULL, 111, NULL, NULL, 234642),
(279124, '4u3xC00', NULL, NULL, 121, NULL, NULL, 234642),
(279125, '3zyjA02', NULL, NULL, 106, NULL, NULL, 234642),
(279126, '1vhpA00', NULL, NULL, 117, NULL, NULL, 234642),
(279127, '6c09D01', NULL, NULL, 118, NULL, NULL, 234642),
(279128, '3b4nA01', NULL, NULL, 88, NULL, NULL, 234642),
(279129, '4lpvA00', NULL, NULL, 99, NULL, NULL, 234642),
(279130, '3gnmH01', NULL, NULL, 118, NULL, NULL, 234642),
(279131, '4cagA01', NULL, NULL, 96, NULL, NULL, 234642),
(279132, '5gjyB00', NULL, NULL, 104, NULL, NULL, 234642),
(279133, '2vyrG00', NULL, NULL, 123, NULL, NULL, 234642),
(279134, '6gfeL01', NULL, NULL, 109, NULL, NULL, 234642),
(279135, '3hg1D01', NULL, NULL, 108, NULL, NULL, 234642),
(279136, '2q87C00', NULL, NULL, 110, NULL, NULL, 234642),
(279137, '5u3pH01', NULL, NULL, 132, NULL, NULL, 234642),
(279138, '1f3dH01', NULL, NULL, 115, NULL, NULL, 234642),
(279139, '1dqdH01', NULL, NULL, 122, NULL, NULL, 234642),
(279140, '4wenB00', NULL, NULL, 127, NULL, NULL, 234642),
(279141, '5k9oB01', NULL, NULL, 111, NULL, NULL, 234642),
(279142, '1qfuH01', NULL, NULL, 122, NULL, NULL, 234642),
(279143, '6c6xB01', NULL, NULL, 107, NULL, NULL, 234642),
(279144, '5gzoD01', NULL, NULL, 108, NULL, NULL, 234642),
(279145, '5h8dA00', NULL, NULL, 114, NULL, NULL, 234642),
(279146, '2djuA00', NULL, NULL, 106, NULL, NULL, 234642),
(279147, '5bk3B01', NULL, NULL, 113, NULL, NULL, 234642),
(279148, '1mnuH01', NULL, NULL, 121, NULL, NULL, 234642),
(279149, '2gqhA01', NULL, NULL, 88, NULL, NULL, 234642),
(279150, '2xtjD00', NULL, NULL, 131, NULL, NULL, 234642),
(279151, '5ud9H02', NULL, NULL, 111, NULL, NULL, 234642),
(279152, '1h3pH01', NULL, NULL, 116, NULL, NULL, 234642),
(279153, '1x3dA00', NULL, NULL, 118, NULL, NULL, 234642),
(279154, '3utoB01', NULL, NULL, 107, NULL, NULL, 234642),
(279155, '3biaX00', NULL, NULL, 116, NULL, NULL, 234642),
(279156, '5yc5C01', NULL, NULL, 89, NULL, NULL, 234642),
(279157, '5drnA01', NULL, NULL, 120, NULL, NULL, 234642),
(279158, '3inuL01', NULL, NULL, 113, NULL, NULL, 234642),
(279159, '5yc5C02', NULL, NULL, 93, NULL, NULL, 234642),
(279160, '3mxwH01', NULL, NULL, 119, NULL, NULL, 234642),
(279161, '1kxqE00', NULL, NULL, 120, NULL, NULL, 234642),
(279162, '3k2uH01', NULL, NULL, 118, NULL, NULL, 234642),
(279163, '5ggvH01', NULL, NULL, 125, NULL, NULL, 234642),
(279164, '5ziaB01', NULL, NULL, 113, NULL, NULL, 234642),
(279165, '1frgH01', NULL, NULL, 120, NULL, NULL, 234642),
(279166, '4wvrB00', NULL, NULL, 102, NULL, NULL, 234642),
(279167, '6bfqB01', NULL, NULL, 108, NULL, NULL, 234642),
(279168, '3fjtA01', NULL, NULL, 100, NULL, NULL, 234642),
(279169, '4jqiH01', NULL, NULL, 123, NULL, NULL, 234642),
(279170, '6nypC00', NULL, NULL, 107, NULL, NULL, 234642),
(279171, '1nqbA02', NULL, NULL, 99, NULL, NULL, 234642),
(279172, '4ebqL01', NULL, NULL, 107, NULL, NULL, 234642),
(279173, '4qyoB00', NULL, NULL, 111, NULL, NULL, 234642),
(279174, '1a6vH00', NULL, NULL, 120, NULL, NULL, 234642),
(279175, '4u3hA00', NULL, NULL, 100, NULL, NULL, 234642),
(279176, '2yuxA01', NULL, NULL, 108, NULL, NULL, 234642),
(279177, '6e62C01', NULL, NULL, 111, NULL, NULL, 234642),
(279178, '5imkA00', NULL, NULL, 125, NULL, NULL, 234642),
(279179, '1aj7H01', NULL, NULL, 114, NULL, NULL, 234642),
(279180, '4jamA01', NULL, NULL, 121, NULL, NULL, 234642),
(279181, '1yejH01', NULL, NULL, 123, NULL, NULL, 234642),
(279182, '1iarB02', NULL, NULL, 111, NULL, NULL, 234642),
(279183, '1iarB01', NULL, NULL, 96, NULL, NULL, 234642),
(279184, '6h3tL00', NULL, NULL, 123, NULL, NULL, 234642),
(279185, '3qiuC01', NULL, NULL, 111, NULL, NULL, 234642),
(279186, '5dr5L01', NULL, NULL, 109, NULL, NULL, 234642),
(279187, '1wtlA00', NULL, NULL, 108, NULL, NULL, 234642),
(279188, '1xfpA00', NULL, NULL, 142, NULL, NULL, 234642),
(279189, '1jglH01', NULL, NULL, 116, NULL, NULL, 234642);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(279190, '1ti2B03', NULL, NULL, 84, NULL, NULL, 234642),
(279191, '4rqqA01', NULL, NULL, 112, NULL, NULL, 234642),
(279192, '3rvvD01', NULL, NULL, 121, NULL, NULL, 234642),
(279193, '4zs6D01', NULL, NULL, 106, NULL, NULL, 234642),
(279194, '4z9kB00', NULL, NULL, 116, NULL, NULL, 234642),
(279195, '5jhlL01', NULL, NULL, 108, NULL, NULL, 234642),
(279196, '4wukL01', NULL, NULL, 109, NULL, NULL, 234642),
(279197, '4lsuL01', NULL, NULL, 100, NULL, NULL, 234642),
(279198, '5lbsH00', NULL, NULL, 121, NULL, NULL, 234642),
(279199, '4o5lL01', NULL, NULL, 111, NULL, NULL, 234642),
(279200, '4o5lL02', NULL, NULL, 119, NULL, NULL, 234642),
(279201, '2x1qA00', NULL, NULL, 127, NULL, NULL, 234642),
(279202, '4qrrD01', NULL, NULL, 117, NULL, NULL, 234642),
(279203, '5i8oL01', NULL, NULL, 111, NULL, NULL, 234642),
(279204, '3m8oH01', NULL, NULL, 119, NULL, NULL, 234642),
(279205, '3m8oH02', NULL, NULL, 74, NULL, NULL, 234642),
(279206, '1k6qH01', NULL, NULL, 117, NULL, NULL, 234642),
(279207, '4nn5C01', NULL, NULL, 99, NULL, NULL, 234642),
(279208, '3ra7H01', NULL, NULL, 125, NULL, NULL, 234642),
(279209, '4nn5C02', NULL, NULL, 113, NULL, NULL, 234642),
(279210, '4kq4H01', NULL, NULL, 117, NULL, NULL, 234642),
(279211, '4ojfL01', NULL, NULL, 112, NULL, NULL, 234642),
(279212, '2gysB04', NULL, NULL, 100, NULL, NULL, 234642),
(279213, '3t2nH01', NULL, NULL, 113, NULL, NULL, 234642),
(279214, '5f1sA01', NULL, NULL, 112, NULL, NULL, 234642),
(279215, '5f1sA02', NULL, NULL, 107, NULL, NULL, 234642),
(279216, '3gheL01', NULL, NULL, 112, NULL, NULL, 234642),
(279217, '1zeaH01', NULL, NULL, 116, NULL, NULL, 234642),
(279218, '6at6B01', NULL, NULL, 116, NULL, NULL, 234642),
(279219, '5fo8B02', NULL, NULL, 106, NULL, NULL, 234642),
(279220, '1uz8B01', NULL, NULL, 116, NULL, NULL, 234642),
(279221, '1p2cB01', NULL, NULL, 116, NULL, NULL, 234642),
(279222, '3mlrH01', NULL, NULL, 124, NULL, NULL, 234642),
(279223, '4l4vH01', NULL, NULL, 116, NULL, NULL, 234642),
(279224, '2kzwA01', NULL, NULL, 87, NULL, NULL, 234642),
(279225, '5d1zA01', NULL, NULL, 107, NULL, NULL, 234642),
(279226, '1smaA01', NULL, NULL, 125, NULL, NULL, 234642),
(279227, '4x80H01', NULL, NULL, 124, NULL, NULL, 234642),
(279228, '3g08A02', NULL, NULL, 101, NULL, NULL, 234642),
(279229, '4m1gH01', NULL, NULL, 118, NULL, NULL, 234642),
(279230, '1ub6A01', NULL, NULL, 113, NULL, NULL, 234642),
(279231, '2kh2B02', NULL, NULL, 119, NULL, NULL, 234642),
(279232, '2kh2B01', NULL, NULL, 108, NULL, NULL, 234642),
(279233, '1q0yH02', NULL, NULL, 101, NULL, NULL, 234642),
(279234, '4u1gB01', NULL, NULL, 120, NULL, NULL, 234642),
(279235, '4ersL01', NULL, NULL, 108, NULL, NULL, 234642),
(279236, '4jn2A01', NULL, NULL, 112, NULL, NULL, 234642),
(279237, '3teuA00', NULL, NULL, 98, NULL, NULL, 234642),
(279238, '5trpL01', NULL, NULL, 112, NULL, NULL, 234642),
(279239, '2h41A00', NULL, NULL, 95, NULL, NULL, 234642),
(279240, '6dg5B02', NULL, NULL, 103, NULL, NULL, 234642),
(279241, '1q38A00', NULL, NULL, 89, NULL, NULL, 234642),
(279242, '5k9jL01', NULL, NULL, 109, NULL, NULL, 234642),
(279243, '7fabL01', NULL, NULL, 103, NULL, NULL, 234642),
(279244, '4hemE00', NULL, NULL, 123, NULL, NULL, 234642),
(279245, '3sgjC01', NULL, NULL, 89, NULL, NULL, 234642),
(279246, '3c8dA01', NULL, NULL, 147, NULL, NULL, 234642),
(279247, '6dg5B01', NULL, NULL, 106, NULL, NULL, 234642),
(279248, '1ie5A00', NULL, NULL, 107, NULL, NULL, 234642),
(279249, '4kmlB00', NULL, NULL, 130, NULL, NULL, 234642),
(279250, '1wt5A00', NULL, NULL, 127, NULL, NULL, 234642),
(279251, '4lptB00', NULL, NULL, 103, NULL, NULL, 234642),
(279252, '4cniA01', NULL, NULL, 120, NULL, NULL, 234642),
(279253, '3lrgB00', NULL, NULL, 121, NULL, NULL, 234642),
(279254, '3rpiA01', NULL, NULL, 123, NULL, NULL, 234642),
(279255, '1etzA01', NULL, NULL, 110, NULL, NULL, 234642),
(279256, '5wttB01', NULL, NULL, 113, NULL, NULL, 234642),
(279257, '3u4bL01', NULL, NULL, 109, NULL, NULL, 234642),
(279258, '1dqlH00', NULL, NULL, 123, NULL, NULL, 234642),
(279259, '1cloL01', NULL, NULL, 107, NULL, NULL, 234642),
(279260, '1wejL01', NULL, NULL, 108, NULL, NULL, 234642);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(279261, '4grlD01', NULL, NULL, 138, NULL, NULL, 234642),
(279262, '5i66A01', NULL, NULL, 119, NULL, NULL, 234642),
(279263, '5jw5L01', NULL, NULL, 103, NULL, NULL, 234642),
(279264, '3edfA01', NULL, NULL, 92, NULL, NULL, 234642),
(279265, '5sx5K01', NULL, NULL, 107, NULL, NULL, 234642),
(279266, '4l5fL01', NULL, NULL, 107, NULL, NULL, 234642),
(279267, '4zd3L01', NULL, NULL, 110, NULL, NULL, 234642),
(279268, '3ifoA01', NULL, NULL, 123, NULL, NULL, 234642),
(279269, '2xy1A02', NULL, NULL, 97, NULL, NULL, 234642),
(279270, '2xy1A01', NULL, NULL, 95, NULL, NULL, 234642),
(279271, '3gjfK01', NULL, NULL, 110, NULL, NULL, 234642),
(279272, '1kb5H01', NULL, NULL, 119, NULL, NULL, 234642),
(279273, '2cd0A00', NULL, NULL, 111, NULL, NULL, 234642),
(279274, '3p3yA01', NULL, NULL, 112, NULL, NULL, 234642),
(279275, '4j3vA02', NULL, NULL, 105, NULL, NULL, 234642),
(279276, '3p3yA04', NULL, NULL, 92, NULL, NULL, 234642),
(279277, '3p3yA03', NULL, NULL, 94, NULL, NULL, 234642),
(279278, '3p3yA02', NULL, NULL, 106, NULL, NULL, 234642),
(279279, '5dftA00', NULL, NULL, 101, NULL, NULL, 234642),
(279280, '5nq0A02', NULL, NULL, 91, NULL, NULL, 234642),
(279281, '5lspL01', NULL, NULL, 109, NULL, NULL, 234642),
(279282, '5iwlA02', NULL, NULL, 116, NULL, NULL, 234642),
(279283, '4g43A02', NULL, NULL, 90, NULL, NULL, 234642),
(279284, '5iwlA01', NULL, NULL, 118, NULL, NULL, 234642),
(279285, '4kvnL01', NULL, NULL, 109, NULL, NULL, 234642),
(279286, '4pgzA02', NULL, NULL, 101, NULL, NULL, 234642),
(279287, '2ntsP01', NULL, NULL, 113, NULL, NULL, 234642),
(279288, '5gxbB00', NULL, NULL, 140, NULL, NULL, 234642),
(279289, '4pgzA01', NULL, NULL, 107, NULL, NULL, 234642),
(279290, '4c83A01', NULL, NULL, 119, NULL, NULL, 234642),
(279291, '5vkkB01', NULL, NULL, 112, NULL, NULL, 234642),
(279292, '1smoB00', NULL, NULL, 119, NULL, NULL, 234642),
(279293, '4aefA01', NULL, NULL, 103, NULL, NULL, 234642),
(279294, '4aefA02', NULL, NULL, 95, NULL, NULL, 234642),
(279295, '3c08H01', NULL, NULL, 117, NULL, NULL, 234642),
(279296, '5xovH01', NULL, NULL, 116, NULL, NULL, 234642),
(279297, '2ymxH01', NULL, NULL, 124, NULL, NULL, 234642),
(279298, '5zs0A01', NULL, NULL, 107, NULL, NULL, 234642),
(279299, '2wbjC01', NULL, NULL, 112, NULL, NULL, 234642),
(279300, '3o2dH01', NULL, NULL, 122, NULL, NULL, 234642),
(279301, '2otpA02', NULL, NULL, 100, NULL, NULL, 234642),
(279302, '1za6B01', NULL, NULL, 115, NULL, NULL, 234642),
(279303, '1j05B00', NULL, NULL, 121, NULL, NULL, 234642),
(279304, '4hkxB01', NULL, NULL, 109, NULL, NULL, 234642),
(279305, '2v5mA02', NULL, NULL, 104, NULL, NULL, 234642),
(279306, '2v5mA03', NULL, NULL, 101, NULL, NULL, 234642),
(279307, '1zglM01', NULL, NULL, 112, NULL, NULL, 234642),
(279308, '4glrI01', NULL, NULL, 107, NULL, NULL, 234642),
(279309, '4mhhI01', NULL, NULL, 112, NULL, NULL, 234642),
(279310, '4mayC01', NULL, NULL, 114, NULL, NULL, 234642),
(279311, '5mjeB00', NULL, NULL, 131, NULL, NULL, 234642),
(279312, '4yhzH01', NULL, NULL, 121, NULL, NULL, 234642),
(279313, '6e65L01', NULL, NULL, 111, NULL, NULL, 234642),
(279314, '4frwA02', NULL, NULL, 99, NULL, NULL, 234642),
(279315, '1ea9C01', NULL, NULL, 121, NULL, NULL, 234642),
(279316, '3r06D02', NULL, NULL, 100, NULL, NULL, 234642),
(279317, '1wfnA01', NULL, NULL, 88, NULL, NULL, 234642),
(279318, '4dzbA01', NULL, NULL, 109, NULL, NULL, 234642),
(279319, '5mtnB00', NULL, NULL, 95, NULL, NULL, 234642),
(279320, '1a7qL00', NULL, NULL, 106, NULL, NULL, 234642),
(279321, '1a6tB01', NULL, NULL, 117, NULL, NULL, 234642),
(279322, '5ibuG01', NULL, NULL, 125, NULL, NULL, 234642),
(279323, '1mcwW01', NULL, NULL, 112, NULL, NULL, 234642),
(279324, '5d1xC00', NULL, NULL, 132, NULL, NULL, 234642),
(279325, '5di8A02', NULL, NULL, 110, NULL, NULL, 234642),
(279326, '2vscA01', NULL, NULL, 104, NULL, NULL, 234642),
(279327, '2e27H00', NULL, NULL, 126, NULL, NULL, 234642),
(279328, '4jfhE01', NULL, NULL, 115, NULL, NULL, 234642),
(279329, '4rmtA00', NULL, NULL, 100, NULL, NULL, 234642),
(279330, '2fb4H01', NULL, NULL, 126, NULL, NULL, 234642),
(279331, '3bfoA00', NULL, NULL, 91, NULL, NULL, 234642);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(279332, '2kpnA01', NULL, NULL, 77, NULL, NULL, 234642),
(279333, '5my6B00', NULL, NULL, 115, NULL, NULL, 234642),
(279334, '4onhB01', NULL, NULL, 114, NULL, NULL, 234642),
(279335, '5i1hH01', NULL, NULL, 118, NULL, NULL, 234642),
(279336, '4p5tE01', NULL, NULL, 112, NULL, NULL, 234642),
(279337, '2n4iA00', NULL, NULL, 119, NULL, NULL, 234642),
(279338, '3csbA03', NULL, NULL, 94, NULL, NULL, 234642),
(279339, '4oawA01', NULL, NULL, 108, NULL, NULL, 234642),
(279340, '3twcL01', NULL, NULL, 106, NULL, NULL, 234642),
(279341, '3k0wA02', NULL, NULL, 92, NULL, NULL, 234642),
(279342, '3k0wA01', NULL, NULL, 92, NULL, NULL, 234642),
(279343, '3hn3A02', NULL, NULL, 104, NULL, NULL, 234642),
(279344, '1xiwD00', NULL, NULL, 122, NULL, NULL, 234642),
(279345, '3vj6A02', NULL, NULL, 93, NULL, NULL, 234642),
(279346, '3ntcH01', NULL, NULL, 114, NULL, NULL, 234642),
(279347, '6andL01', NULL, NULL, 113, NULL, NULL, 234642),
(279348, '1cicB01', NULL, NULL, 117, NULL, NULL, 234642),
(279349, '2y6sD01', NULL, NULL, 114, NULL, NULL, 234642),
(279350, '3h0tB01', NULL, NULL, 122, NULL, NULL, 234642),
(279351, '5ewiH01', NULL, NULL, 124, NULL, NULL, 234642),
(279352, '3mbxL01', NULL, NULL, 114, NULL, NULL, 234642),
(279353, '1za3A01', NULL, NULL, 107, NULL, NULL, 234642),
(279354, '2vraA01', NULL, NULL, 105, NULL, NULL, 234642),
(279355, '4imkC01', NULL, NULL, 109, NULL, NULL, 234642),
(279356, '5mhrL00', NULL, NULL, 107, NULL, NULL, 234642),
(279357, '4s2sB01', NULL, NULL, 114, NULL, NULL, 234642),
(279358, '5c6tH00', NULL, NULL, 118, NULL, NULL, 234642),
(279359, '43c9A00', NULL, NULL, 113, NULL, NULL, 234642),
(279360, '2jb5L01', NULL, NULL, 112, NULL, NULL, 234642),
(279361, '2lqrA00', NULL, NULL, 108, NULL, NULL, 234642),
(279362, '2vraA02', NULL, NULL, 103, NULL, NULL, 234642),
(279363, '5ks9A02', NULL, NULL, 108, NULL, NULL, 234642),
(279364, '5yaxA02', NULL, NULL, 101, NULL, NULL, 234642),
(279365, '5ye3A01', NULL, NULL, 107, NULL, NULL, 234642),
(279366, '2f53E01', NULL, NULL, 114, NULL, NULL, 234642),
(279367, '2cqvA00', NULL, NULL, 114, NULL, NULL, 234642),
(279368, '2e3vA00', NULL, NULL, 122, NULL, NULL, 234642),
(279369, '6cdoB01', NULL, NULL, 113, NULL, NULL, 234642),
(279370, '1gxeA00', NULL, NULL, 139, NULL, NULL, 234642),
(279371, '5jofA01', NULL, NULL, 123, NULL, NULL, 234642),
(279372, '5c2uB00', NULL, NULL, 131, NULL, NULL, 234642),
(279373, '3nfsH01', NULL, NULL, 112, NULL, NULL, 234642),
(279374, '6d4eA02', NULL, NULL, 106, NULL, NULL, 234642),
(279375, '6bpdB01', NULL, NULL, 114, NULL, NULL, 234642),
(279376, '1dlfL00', NULL, NULL, 113, NULL, NULL, 234642),
(279377, '2fatH01', NULL, NULL, 119, NULL, NULL, 234642),
(279378, '2fatH02', NULL, NULL, 95, NULL, NULL, 234642),
(279379, '1uj3A01', NULL, NULL, 108, NULL, NULL, 234642),
(279380, '5ihzB01', NULL, NULL, 112, NULL, NULL, 234642),
(279381, '6eh4D01', NULL, NULL, 110, NULL, NULL, 234642),
(279382, '1pfcA00', NULL, NULL, 113, NULL, NULL, 234642),
(279383, '3c5zB01', NULL, NULL, 111, NULL, NULL, 234642),
(279384, '4zg1D00', NULL, NULL, 117, NULL, NULL, 234642),
(279385, '3wn5A01', NULL, NULL, 102, NULL, NULL, 234642),
(279386, '1pewA00', NULL, NULL, 109, NULL, NULL, 234642),
(279387, '2cr6A01', NULL, NULL, 91, NULL, NULL, 234642),
(279388, '6g1eA02', NULL, NULL, 116, NULL, NULL, 234642),
(279389, '3difB01', NULL, NULL, 119, NULL, NULL, 234642),
(279390, '5t33L01', NULL, NULL, 109, NULL, NULL, 234642),
(279391, '5eiiA01', NULL, NULL, 127, NULL, NULL, 234642),
(279392, '2xknD02', NULL, NULL, 100, NULL, NULL, 234642),
(279393, '4ygvB01', NULL, NULL, 112, NULL, NULL, 234642),
(279394, '4hpyH01', NULL, NULL, 120, NULL, NULL, 234642),
(279395, '1jrhL01', NULL, NULL, 107, NULL, NULL, 234642),
(279396, '1ypzF02', NULL, NULL, 107, NULL, NULL, 234642),
(279397, '1p7hL02', NULL, NULL, 107, NULL, NULL, 234642),
(279398, '3eakA00', NULL, NULL, 137, NULL, NULL, 234642),
(279399, '1ypzF01', NULL, NULL, 123, NULL, NULL, 234642),
(279400, '6cr1L02', NULL, NULL, 101, NULL, NULL, 234642),
(279401, '6cr1L01', NULL, NULL, 108, NULL, NULL, 234642),
(279402, '4ej1C00', NULL, NULL, 134, NULL, NULL, 234642);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(279403, '5u3oL01', NULL, NULL, 109, NULL, NULL, 234642),
(279404, '3u2sA01', NULL, NULL, 136, NULL, NULL, 234642),
(279405, '3d85B01', NULL, NULL, 115, NULL, NULL, 234642),
(279406, '4pjiF01', NULL, NULL, 116, NULL, NULL, 234642),
(279407, '6bpdA01', NULL, NULL, 118, NULL, NULL, 234642),
(279408, '4q0xH01', NULL, NULL, 120, NULL, NULL, 234642),
(279409, '1ngzB01', NULL, NULL, 114, NULL, NULL, 234642),
(279410, '4p23B01', NULL, NULL, 111, NULL, NULL, 234642),
(279411, '4pirF00', NULL, NULL, 124, NULL, NULL, 234642),
(279412, '1dfbL01', NULL, NULL, 106, NULL, NULL, 234642),
(279413, '5u6aA01', NULL, NULL, 108, NULL, NULL, 234642),
(279414, '3umtA02', NULL, NULL, 99, NULL, NULL, 234642),
(279415, '5bzdA01', NULL, NULL, 108, NULL, NULL, 234642),
(279416, '3umtA01', NULL, NULL, 137, NULL, NULL, 234642),
(279417, '3vfgH01', NULL, NULL, 120, NULL, NULL, 234642),
(279418, '4xnzC01', NULL, NULL, 103, NULL, NULL, 234642),
(279419, '4jrxE01', NULL, NULL, 109, NULL, NULL, 234642),
(279420, '1kcrL01', NULL, NULL, 107, NULL, NULL, 234642),
(279421, '1fj1B01', NULL, NULL, 113, NULL, NULL, 234642),
(279422, '2gw5A01', NULL, NULL, 95, NULL, NULL, 234642),
(279423, '2gw5A02', NULL, NULL, 102, NULL, NULL, 234642),
(279424, '2g60H01', NULL, NULL, 117, NULL, NULL, 234642),
(279425, '2oi9B00', NULL, NULL, 113, NULL, NULL, 234642),
(279426, '4m6mL01', NULL, NULL, 112, NULL, NULL, 234642),
(279427, '2e7hA01', NULL, NULL, 89, NULL, NULL, 234642),
(279428, '2cuhA01', NULL, NULL, 88, NULL, NULL, 234642),
(279429, '3iflH01', NULL, NULL, 120, NULL, NULL, 234642),
(279430, '1vemA02', NULL, NULL, 100, NULL, NULL, 234642),
(279431, '5tzuL01', NULL, NULL, 108, NULL, NULL, 234642),
(279432, '4qciB01', NULL, NULL, 120, NULL, NULL, 234642),
(279433, '3t65B01', NULL, NULL, 122, NULL, NULL, 234642),
(279434, '4onhA01', NULL, NULL, 111, NULL, NULL, 234642),
(279435, '5m2iG00', NULL, NULL, 121, NULL, NULL, 234642),
(279436, '5o4eD02', NULL, NULL, 115, NULL, NULL, 234642),
(279437, '4oziF01', NULL, NULL, 114, NULL, NULL, 234642),
(279438, '3g5yA01', NULL, NULL, 107, NULL, NULL, 234642),
(279439, '4oawB01', NULL, NULL, 130, NULL, NULL, 234642),
(279440, '5vyfA01', NULL, NULL, 107, NULL, NULL, 234642),
(279441, '4ocrH01', NULL, NULL, 144, NULL, NULL, 234642),
(279442, '3sqoH01', NULL, NULL, 118, NULL, NULL, 234642),
(279443, '3mlyL01', NULL, NULL, 109, NULL, NULL, 234642),
(279444, '2p49B00', NULL, NULL, 123, NULL, NULL, 234642),
(279445, '2orbM01', NULL, NULL, 112, NULL, NULL, 234642),
(279446, '5w1kA01', NULL, NULL, 102, NULL, NULL, 234642),
(279447, '2jjvA01', NULL, NULL, 123, NULL, NULL, 234642),
(279448, '1mjuH02', NULL, NULL, 99, NULL, NULL, 234642),
(279449, '2yz8A01', NULL, NULL, 96, NULL, NULL, 234642),
(279450, '1mjuH01', NULL, NULL, 116, NULL, NULL, 234642),
(279451, '2yn3B03', NULL, NULL, 108, NULL, NULL, 234642),
(279452, '4m7kH01', NULL, NULL, 120, NULL, NULL, 234642),
(279453, '1ai1L01', NULL, NULL, 112, NULL, NULL, 234642),
(279454, '2r8sH01', NULL, NULL, 121, NULL, NULL, 234642),
(279455, '1za3B01', NULL, NULL, 129, NULL, NULL, 234642),
(279456, '5iueA02', NULL, NULL, 103, NULL, NULL, 234642),
(279457, '3mclL01', NULL, NULL, 106, NULL, NULL, 234642),
(279458, '6bj2D01', NULL, NULL, 116, NULL, NULL, 234642),
(279459, '5jo5B01', NULL, NULL, 109, NULL, NULL, 234642),
(279460, '2yplD01', NULL, NULL, 109, NULL, NULL, 234642),
(279461, '5mesH01', NULL, NULL, 119, NULL, NULL, 234642),
(279462, '3ld8C01', NULL, NULL, 118, NULL, NULL, 234642),
(279463, '2crmA01', NULL, NULL, 79, NULL, NULL, 234642),
(279464, '5w38A02', NULL, NULL, 110, NULL, NULL, 234642),
(279465, '2dquH01', NULL, NULL, 122, NULL, NULL, 234642),
(279466, '8fabB01', NULL, NULL, 121, NULL, NULL, 234642),
(279467, '2bc4A02', NULL, NULL, 120, NULL, NULL, 234642),
(279468, '3cu7A09', NULL, NULL, 109, NULL, NULL, 234642),
(279469, '1bafH01', NULL, NULL, 115, NULL, NULL, 234642),
(279470, '3kj4B01', NULL, NULL, 113, NULL, NULL, 234642),
(279471, '2edkA00', NULL, NULL, 101, NULL, NULL, 234642),
(279472, '3cu7A04', NULL, NULL, 108, NULL, NULL, 234642),
(279473, '5tdoB02', NULL, NULL, 103, NULL, NULL, 234642);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(279474, '1z9lA00', NULL, NULL, 128, NULL, NULL, 234642),
(279475, '1flrL01', NULL, NULL, 113, NULL, NULL, 234642),
(279476, '2bp3A00', NULL, NULL, 97, NULL, NULL, 234642),
(279477, '1igyD03', NULL, NULL, 108, NULL, NULL, 234642),
(279478, '2di9A01', NULL, NULL, 95, NULL, NULL, 234642),
(279479, '1igyD04', NULL, NULL, 106, NULL, NULL, 234642),
(279480, '5cusL01', NULL, NULL, 111, NULL, NULL, 234642),
(279481, '4p3cH01', NULL, NULL, 118, NULL, NULL, 234642),
(279482, '4hcrH01', NULL, NULL, 124, NULL, NULL, 234642),
(279483, '4hcrH02', NULL, NULL, 105, NULL, NULL, 234642),
(279484, '5usfC00', NULL, NULL, 128, NULL, NULL, 234642),
(279485, '4j1uA01', NULL, NULL, 113, NULL, NULL, 234642),
(279486, '3s34H01', NULL, NULL, 116, NULL, NULL, 234642),
(279487, '3s34H02', NULL, NULL, 105, NULL, NULL, 234642),
(279488, '1w8oA02', NULL, NULL, 102, NULL, NULL, 234642),
(279489, '5f7lB00', NULL, NULL, 129, NULL, NULL, 234642),
(279490, '1u0qA00', NULL, NULL, 125, NULL, NULL, 234642),
(279491, '2uzxB02', NULL, NULL, 127, NULL, NULL, 234642),
(279492, '2vxvL01', NULL, NULL, 109, NULL, NULL, 234642),
(279493, '1d3cA04', NULL, NULL, 103, NULL, NULL, 234642),
(279494, '1d3cA03', NULL, NULL, 87, NULL, NULL, 234642),
(279495, '1c5cL01', NULL, NULL, 108, NULL, NULL, 234642),
(279496, '6cwtB01', NULL, NULL, 110, NULL, NULL, 234642),
(279497, '3uxfA03', NULL, NULL, 141, NULL, NULL, 234642),
(279498, '2eebA00', NULL, NULL, 106, NULL, NULL, 234642),
(279499, '3b2uD01', NULL, NULL, 108, NULL, NULL, 234642),
(279500, '5cbeB00', NULL, NULL, 122, NULL, NULL, 234642),
(279501, '3uxfA01', NULL, NULL, 150, NULL, NULL, 234642),
(279502, '1mvuA00', NULL, NULL, 114, NULL, NULL, 234642),
(279503, '4bklB01', NULL, NULL, 112, NULL, NULL, 234642),
(279504, '2i9lA01', NULL, NULL, 113, NULL, NULL, 234642),
(279505, '1deeB01', NULL, NULL, 121, NULL, NULL, 234642),
(279506, '1rumL02', NULL, NULL, 106, NULL, NULL, 234642),
(279507, '2o26U03', NULL, NULL, 108, NULL, NULL, 234642),
(279508, '5kveH00', NULL, NULL, 116, NULL, NULL, 234642),
(279509, '2o26U02', NULL, NULL, 88, NULL, NULL, 234642),
(279510, '2o26U01', NULL, NULL, 94, NULL, NULL, 234642),
(279511, '2ck0H01', NULL, NULL, 120, NULL, NULL, 234642),
(279512, '4onfL01', NULL, NULL, 113, NULL, NULL, 234642),
(279513, '4lpyA00', NULL, NULL, 101, NULL, NULL, 234642),
(279514, '4ms8D01', NULL, NULL, 114, NULL, NULL, 234642),
(279515, '1hi6B01', NULL, NULL, 112, NULL, NULL, 234642),
(279516, '5nyxL01', NULL, NULL, 106, NULL, NULL, 234642),
(279517, '1eajB00', NULL, NULL, 126, NULL, NULL, 234642),
(279518, '5w1wD01', NULL, NULL, 113, NULL, NULL, 234642),
(279519, '3me0A01', NULL, NULL, 121, NULL, NULL, 234642),
(279520, '3cx5J00', NULL, NULL, 127, NULL, NULL, 234642),
(279521, '3bpnC01', NULL, NULL, 94, NULL, NULL, 234642),
(279522, '5myxB01', NULL, NULL, 115, NULL, NULL, 234642),
(279523, '2wqrB01', NULL, NULL, 105, NULL, NULL, 234642),
(279524, '2e6qA00', NULL, NULL, 112, NULL, NULL, 234642),
(279525, '5gs2D01', NULL, NULL, 121, NULL, NULL, 234642),
(279526, '4hh8A01', NULL, NULL, 129, NULL, NULL, 234642),
(279527, '3bpnC03', NULL, NULL, 113, NULL, NULL, 234642),
(279528, '4hh8A02', NULL, NULL, 95, NULL, NULL, 234642),
(279529, '3w9dA01', NULL, NULL, 122, NULL, NULL, 234642),
(279530, '5eiqA02', NULL, NULL, 91, NULL, NULL, 234642),
(279531, '5eiqA01', NULL, NULL, 97, NULL, NULL, 234642),
(279532, '5i9qC01', NULL, NULL, 101, NULL, NULL, 234642),
(279533, '2uv3A01', NULL, NULL, 111, NULL, NULL, 234642),
(279534, '6bzyL01', NULL, NULL, 112, NULL, NULL, 234642),
(279535, '4mwfB01', NULL, NULL, 108, NULL, NULL, 234642),
(279536, '5xovG01', NULL, NULL, 116, NULL, NULL, 234642),
(279537, '4ag4L01', NULL, NULL, 107, NULL, NULL, 234642),
(279538, '4ncc101', NULL, NULL, 107, NULL, NULL, 234642),
(279539, '4jg1H01', NULL, NULL, 124, NULL, NULL, 234642),
(279540, '5udcB01', NULL, NULL, 126, NULL, NULL, 234642),
(279541, '3h8nA02', NULL, NULL, 98, NULL, NULL, 234642),
(279542, '1cl7H00', NULL, NULL, 135, NULL, NULL, 234642),
(279543, '4j6rL01', NULL, NULL, 104, NULL, NULL, 234642),
(279544, '4xp4L01', NULL, NULL, 109, NULL, NULL, 234642);
INSERT INTO "PUBLIC"."MODEL" VALUES
(279545, '3h8nA01', NULL, NULL, 97, NULL, NULL, 234642),
(279546, '1j8kA00', NULL, NULL, 94, NULL, NULL, 234642),
(279547, '4q2zB01', NULL, NULL, 111, NULL, NULL, 234642),
(279548, '4en3A01', NULL, NULL, 116, NULL, NULL, 234642),
(279549, '2flbT00', NULL, NULL, 218, NULL, NULL, 234642),
(279550, '6dg5C02', NULL, NULL, 103, NULL, NULL, 234642),
(279551, '3esuF01', NULL, NULL, 111, NULL, NULL, 234642),
(279552, '6dg5C01', NULL, NULL, 96, NULL, NULL, 234642),
(279553, '6eleB01', NULL, NULL, 108, NULL, NULL, 234642),
(279554, '4yjzL01', NULL, NULL, 130, NULL, NULL, 234642),
(279555, '4yjzL02', NULL, NULL, 115, NULL, NULL, 234642),
(279556, '3esuF02', NULL, NULL, 106, NULL, NULL, 234642),
(279557, '5hyfA02', NULL, NULL, 110, NULL, NULL, 234642),
(279558, '6ba5A00', NULL, NULL, 114, NULL, NULL, 234642),
(279559, '1rjlA01', NULL, NULL, 108, NULL, NULL, 234642),
(279560, '1fo0B00', NULL, NULL, 112, NULL, NULL, 234642),
(279561, '3sdyH01', NULL, NULL, 122, NULL, NULL, 234642),
(279562, '1kfaI02', NULL, NULL, 98, NULL, NULL, 234642),
(279563, '1fneB02', NULL, NULL, 105, NULL, NULL, 234642),
(279564, '1kfaI01', NULL, NULL, 120, NULL, NULL, 234642),
(279565, '4ydkL01', NULL, NULL, 107, NULL, NULL, 234642),
(279566, '5fuzH01', NULL, NULL, 121, NULL, NULL, 234642),
(279567, '4nhuA01', NULL, NULL, 115, NULL, NULL, 234642),
(279568, '4dvbA01', NULL, NULL, 117, NULL, NULL, 234642),
(279569, '5tkjB01', NULL, NULL, 113, NULL, NULL, 234642),
(279570, '3q5tA01', NULL, NULL, 112, NULL, NULL, 234642),
(279571, '4f9pD02', NULL, NULL, 100, NULL, NULL, 234642),
(279572, '1a5fH02', NULL, NULL, 96, NULL, NULL, 234642),
(279573, '5ir3A00', NULL, NULL, 112, NULL, NULL, 234642),
(279574, '1a5fH01', NULL, NULL, 120, NULL, NULL, 234642),
(279575, '4x0kB01', NULL, NULL, 114, NULL, NULL, 234642),
(279576, '4gftB00', NULL, NULL, 135, NULL, NULL, 234642),
(279577, '4xmpL01', NULL, NULL, 105, NULL, NULL, 234642),
(279578, '3kptA03', NULL, NULL, 106, NULL, NULL, 234642),
(279579, '4hgmA00', NULL, NULL, 112, NULL, NULL, 234642),
(279580, '4o9hH01', NULL, NULL, 118, NULL, NULL, 234642),
(279581, '5jipA02', NULL, NULL, 102, NULL, NULL, 234642),
(279582, '1u6aH01', NULL, NULL, 123, NULL, NULL, 234642),
(279583, '1ehxA00', NULL, NULL, 94, NULL, NULL, 234642),
(279584, '3wnoA01', NULL, NULL, 105, NULL, NULL, 234642),
(279585, '4ut6L00', NULL, NULL, 111, NULL, NULL, 234642),
(279586, '1witA00', NULL, NULL, 93, NULL, NULL, 234642),
(279587, '4whtA01', NULL, NULL, 112, NULL, NULL, 234642),
(279588, '2davA01', NULL, NULL, 103, NULL, NULL, 234642),
(279589, '4q6iA01', NULL, NULL, 112, NULL, NULL, 234642),
(279590, '5vigB01', NULL, NULL, 107, NULL, NULL, 234642),
(279591, '5e5rD01', NULL, NULL, 98, NULL, NULL, 234642),
(279592, '5vi4F03', NULL, NULL, 119, NULL, NULL, 234642),
(279593, '4mz2A00', NULL, NULL, 129, NULL, NULL, 234642),
(279594, '3h6jA02', NULL, NULL, 104, NULL, NULL, 234642),
(279595, '5jhdD01', NULL, NULL, 119, NULL, NULL, 234642),
(279596, '4zptB01', NULL, NULL, 107, NULL, NULL, 234642),
(279597, '1dl7L00', NULL, NULL, 109, NULL, NULL, 234642),
(279598, '3se9H01', NULL, NULL, 125, NULL, NULL, 234642),
(279599, '6mtoL01', NULL, NULL, 109, NULL, NULL, 234642),
(279600, '1mrdH01', NULL, NULL, 116, NULL, NULL, 234642),
(279601, '2je8B05', NULL, NULL, 93, NULL, NULL, 234642),
(279602, '1pbyA04', NULL, NULL, 131, NULL, NULL, 234642),
(279603, '1pbyA03', NULL, NULL, 76, NULL, NULL, 234642),
(279604, '2oz4H01', NULL, NULL, 114, NULL, NULL, 234642),
(279605, '2p5eD01', NULL, NULL, 115, NULL, NULL, 234642),
(279606, '3g9vA02', NULL, NULL, 104, NULL, NULL, 234642),
(279607, '5k59E01', NULL, NULL, 119, NULL, NULL, 234642),
(279608, '3q2cA00', NULL, NULL, 97, NULL, NULL, 234642),
(279609, '4llqA00', NULL, NULL, 113, NULL, NULL, 234642),
(279610, '4xnyH01', NULL, NULL, 132, NULL, NULL, 234642),
(279611, '4k3dH01', NULL, NULL, 169, NULL, NULL, 234642),
(279612, '6aemA00', NULL, NULL, 87, NULL, NULL, 234642),
(279613, '3cnkA00', NULL, NULL, 89, NULL, NULL, 234642),
(279614, '1a4jA01', NULL, NULL, 112, NULL, NULL, 234642),
(279615, '4zsoB01', NULL, NULL, 122, NULL, NULL, 234642);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(279616, '3x2dD01', NULL, NULL, 125, NULL, NULL, 234642),
(279617, '2gi7A02', NULL, NULL, 95, NULL, NULL, 234642),
(279618, '4r26H01', NULL, NULL, 132, NULL, NULL, 234642),
(279619, '1clyH01', NULL, NULL, 119, NULL, NULL, 234642),
(279620, '2ee6A00', NULL, NULL, 105, NULL, NULL, 234642),
(279621, '6d7gE01', NULL, NULL, 124, NULL, NULL, 234642),
(279622, '5fm5M00', NULL, NULL, 124, NULL, NULL, 234642),
(279623, '5chnA01', NULL, NULL, 122, NULL, NULL, 234642),
(279624, '5dezA01', NULL, NULL, 104, NULL, NULL, 234642),
(279625, '5th9N00', NULL, NULL, 106, NULL, NULL, 234642),
(279626, '2y23A01', NULL, NULL, 109, NULL, NULL, 234642),
(279627, '5wt9G00', NULL, NULL, 118, NULL, NULL, 234642),
(279628, '4xmlH01', NULL, NULL, 123, NULL, NULL, 234642),
(279629, '3hg1E01', NULL, NULL, 115, NULL, NULL, 234642),
(279630, '1rhhA01', NULL, NULL, 109, NULL, NULL, 234642),
(279631, '3utzC01', NULL, NULL, 119, NULL, NULL, 234642),
(279632, '4o02H01', NULL, NULL, 118, NULL, NULL, 234642),
(279633, '4m9oA00', NULL, NULL, 107, NULL, NULL, 234642),
(279634, '4rauB01', NULL, NULL, 120, NULL, NULL, 234642),
(279635, '3v4vH01', NULL, NULL, 121, NULL, NULL, 234642),
(279636, '4exkA03', NULL, NULL, 113, NULL, NULL, 234642),
(279637, '5fucE00', NULL, NULL, 132, NULL, NULL, 234642),
(279638, '3h7lA01', NULL, NULL, 94, NULL, NULL, 234642),
(279639, '1fyhB02', NULL, NULL, 114, NULL, NULL, 234642),
(279640, '1jn6A01', NULL, NULL, 113, NULL, NULL, 234642),
(279641, '4xt1C00', NULL, NULL, 134, NULL, NULL, 234642),
(279642, '1fyhB01', NULL, NULL, 108, NULL, NULL, 234642),
(279643, '3wyrA01', NULL, NULL, 91, NULL, NULL, 234642),
(279644, '3wyrA02', NULL, NULL, 98, NULL, NULL, 234642),
(279645, '1ce1H01', NULL, NULL, 121, NULL, NULL, 234642),
(279646, '4p5mA02', NULL, NULL, 102, NULL, NULL, 234642),
(279647, '3hi6H01', NULL, NULL, 120, NULL, NULL, 234642),
(279648, '6dg2B01', NULL, NULL, 109, NULL, NULL, 234642),
(279649, '1ucbL01', NULL, NULL, 113, NULL, NULL, 234642),
(279650, '5d6cA01', NULL, NULL, 113, NULL, NULL, 234642),
(279651, '4w68A00', NULL, NULL, 133, NULL, NULL, 234642),
(279652, '2bdnL01', NULL, NULL, 108, NULL, NULL, 234642),
(279653, '2r0kH01', NULL, NULL, 117, NULL, NULL, 234642),
(279654, '2c3gA00', NULL, NULL, 98, NULL, NULL, 234642),
(279655, '2e9wA01', NULL, NULL, 91, NULL, NULL, 234642),
(279656, '5i8kH01', NULL, NULL, 116, NULL, NULL, 234642),
(279657, '4u1gC01', NULL, NULL, 112, NULL, NULL, 234642),
(279658, '5vh3B01', NULL, NULL, 108, NULL, NULL, 234642),
(279659, '6apcL01', NULL, NULL, 113, NULL, NULL, 234642),
(279660, '5cexA01', NULL, NULL, 113, NULL, NULL, 234642),
(279661, '4r4bB01', NULL, NULL, 119, NULL, NULL, 234642),
(279662, '5vxrL01', NULL, NULL, 112, NULL, NULL, 234642),
(279663, '4h20H01', NULL, NULL, 119, NULL, NULL, 234642),
(279664, '6dc8L01', NULL, NULL, 113, NULL, NULL, 234642),
(279665, '1mfaL01', NULL, NULL, 110, NULL, NULL, 234642),
(279666, '5mtlC01', NULL, NULL, 111, NULL, NULL, 234642),
(279667, '3zyoA02', NULL, NULL, 109, NULL, NULL, 234642),
(279668, '3zyzA03', NULL, NULL, 132, NULL, NULL, 234642),
(279669, '4nobA00', NULL, NULL, 126, NULL, NULL, 234642),
(279670, '5lz0A00', NULL, NULL, 134, NULL, NULL, 234642),
(279671, '4qthB01', NULL, NULL, 108, NULL, NULL, 234642),
(279672, '4dkfL01', NULL, NULL, 107, NULL, NULL, 234642),
(279673, '4zs6C01', NULL, NULL, 121, NULL, NULL, 234642),
(279674, '3qbtB00', NULL, NULL, 140, NULL, NULL, 234642),
(279675, '1jnlH01', NULL, NULL, 114, NULL, NULL, 234642),
(279676, '4x6bD01', NULL, NULL, 116, NULL, NULL, 234642),
(279677, '4hs6B01', NULL, NULL, 118, NULL, NULL, 234642),
(279678, '3o4lD01', NULL, NULL, 104, NULL, NULL, 234642),
(279679, '4ioiB01', NULL, NULL, 120, NULL, NULL, 234642),
(279680, '6avgD01', NULL, NULL, 116, NULL, NULL, 234642),
(279681, '1figL01', NULL, NULL, 109, NULL, NULL, 234642),
(279682, '3hujA02', NULL, NULL, 101, NULL, NULL, 234642),
(279683, '4aehH01', NULL, NULL, 119, NULL, NULL, 234642),
(279684, '3p2tA01', NULL, NULL, 95, NULL, NULL, 234642),
(279685, '3t04D00', NULL, NULL, 103, NULL, NULL, 234642),
(279686, '4z7vG01', NULL, NULL, 110, NULL, NULL, 234642);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(279687, '4r8wH00', NULL, NULL, 127, NULL, NULL, 234642),
(279688, '4oq1A03', NULL, NULL, 113, NULL, NULL, 234642),
(279689, '4oq1A02', NULL, NULL, 109, NULL, NULL, 234642),
(279690, '3p2tA02', NULL, NULL, 101, NULL, NULL, 234642),
(279691, '6db6L01', NULL, NULL, 109, NULL, NULL, 234642),
(279692, '4h8wC01', NULL, NULL, 98, NULL, NULL, 234642),
(279693, '4h8wC02', NULL, NULL, 75, NULL, NULL, 234642),
(279694, '2ddqH01', NULL, NULL, 113, NULL, NULL, 234642),
(279695, '3p0yL01', NULL, NULL, 108, NULL, NULL, 234642),
(279696, '2rr3A00', NULL, NULL, 130, NULL, NULL, 234642),
(279697, '4qxgH01', NULL, NULL, 117, NULL, NULL, 234642),
(279698, '5k9oA01', NULL, NULL, 119, NULL, NULL, 234642),
(279699, '3wdhA02', NULL, NULL, 97, NULL, NULL, 234642),
(279700, '5jihA02', NULL, NULL, 114, NULL, NULL, 234642),
(279701, '5c6wH02', NULL, NULL, 119, NULL, NULL, 234642),
(279702, '4lkxB01', NULL, NULL, 112, NULL, NULL, 234642),
(279703, '5dyoB01', NULL, NULL, 113, NULL, NULL, 234642),
(279704, '3pgfH01', NULL, NULL, 123, NULL, NULL, 234642),
(279705, '5nmvL01', NULL, NULL, 107, NULL, NULL, 234642),
(279706, '4r90L01', NULL, NULL, 111, NULL, NULL, 234642),
(279707, '5ceyD01', NULL, NULL, 132, NULL, NULL, 234642),
(279708, '5d2lL01', NULL, NULL, 116, NULL, NULL, 234642),
(279709, '2e7cA01', NULL, NULL, 100, NULL, NULL, 234642),
(279710, '3ffdA01', NULL, NULL, 118, NULL, NULL, 234642),
(279711, '1kacB00', NULL, NULL, 124, NULL, NULL, 234642),
(279712, '4gmsM02', NULL, NULL, 72, NULL, NULL, 234642),
(279713, '6d7gD01', NULL, NULL, 120, NULL, NULL, 234642),
(279714, '1orqB01', NULL, NULL, 118, NULL, NULL, 234642),
(279715, '5d1zB01', NULL, NULL, 122, NULL, NULL, 234642),
(279716, '4fq2H01', NULL, NULL, 132, NULL, NULL, 234642),
(279717, '6dfqH01', NULL, NULL, 113, NULL, NULL, 234642),
(279718, '4bfgA02', NULL, NULL, 93, NULL, NULL, 234642),
(279719, '4bfgA01', NULL, NULL, 123, NULL, NULL, 234642),
(279720, '1fv1B02', NULL, NULL, 98, NULL, NULL, 234642),
(279721, '5k9qG01', NULL, NULL, 128, NULL, NULL, 234642),
(279722, '4fqiH01', NULL, NULL, 121, NULL, NULL, 234642),
(279723, '4b41A00', NULL, NULL, 118, NULL, NULL, 234642),
(279724, '6obzB01', NULL, NULL, 107, NULL, NULL, 234642),
(279725, '1qfwM00', NULL, NULL, 108, NULL, NULL, 234642),
(279726, '6d11B01', NULL, NULL, 107, NULL, NULL, 234642),
(279727, '2y07H02', NULL, NULL, 99, NULL, NULL, 234642),
(279728, '4pj7F01', NULL, NULL, 114, NULL, NULL, 234642),
(279729, '1b0wA00', NULL, NULL, 108, NULL, NULL, 234642),
(279730, '2vxqL01', NULL, NULL, 107, NULL, NULL, 234642),
(279731, '1j05A00', NULL, NULL, 111, NULL, NULL, 234642),
(279732, '4y0gB00', NULL, NULL, 90, NULL, NULL, 234642),
(279733, '1za6A01', NULL, NULL, 113, NULL, NULL, 234642),
(279734, '3og6B02', NULL, NULL, 99, NULL, NULL, 234642),
(279735, '3dlqR01', NULL, NULL, 103, NULL, NULL, 234642),
(279736, '3dlqR02', NULL, NULL, 108, NULL, NULL, 234642),
(279737, '4y5yA00', NULL, NULL, 130, NULL, NULL, 234642),
(279738, '4umgA00', NULL, NULL, 133, NULL, NULL, 234642),
(279739, '3hrzA04', NULL, NULL, 101, NULL, NULL, 234642),
(279740, '3idxH01', NULL, NULL, 128, NULL, NULL, 234642),
(279741, '1dsfL00', NULL, NULL, 112, NULL, NULL, 234642),
(279742, '1rihL01', NULL, NULL, 108, NULL, NULL, 234642),
(279743, '5w0dC01', NULL, NULL, 109, NULL, NULL, 234642),
(279744, '4dzbB01', NULL, NULL, 115, NULL, NULL, 234642),
(279745, '1ehlH01', NULL, NULL, 120, NULL, NULL, 234642),
(279746, '4u7mA02', NULL, NULL, 95, NULL, NULL, 234642),
(279747, '1ynlH02', NULL, NULL, 103, NULL, NULL, 234642),
(279748, '4u7mA03', NULL, NULL, 94, NULL, NULL, 234642),
(279749, '4bz2H02', NULL, NULL, 98, NULL, NULL, 234642),
(279750, '1etzB01', NULL, NULL, 126, NULL, NULL, 234642),
(279751, '4bz2H01', NULL, NULL, 121, NULL, NULL, 234642),
(279752, '1ynlH01', NULL, NULL, 116, NULL, NULL, 234642),
(279753, '4u7mA01', NULL, NULL, 104, NULL, NULL, 234642),
(279754, '1f3rB02', NULL, NULL, 99, NULL, NULL, 234642),
(279755, '5dumL01', NULL, NULL, 108, NULL, NULL, 234642),
(279756, '3ma9L01', NULL, NULL, 109, NULL, NULL, 234642),
(279757, '2ij0C00', NULL, NULL, 118, NULL, NULL, 234642);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(279758, '5dhvB00', NULL, NULL, 110, NULL, NULL, 234642),
(279759, '4lldB00', NULL, NULL, 102, NULL, NULL, 234642),
(279760, '1mfnA02', NULL, NULL, 93, NULL, NULL, 234642),
(279761, '1mfnA01', NULL, NULL, 91, NULL, NULL, 234642),
(279762, '4n0yL01', NULL, NULL, 113, NULL, NULL, 234642),
(279763, '2cjuH00', NULL, NULL, 121, NULL, NULL, 234642),
(279764, '5vgeA02', NULL, NULL, 91, NULL, NULL, 234642),
(279765, '5ujtA02', NULL, NULL, 100, NULL, NULL, 234642),
(279766, '2iepB02', NULL, NULL, 93, NULL, NULL, 234642),
(279767, '3d9aL01', NULL, NULL, 108, NULL, NULL, 234642),
(279768, '3d9aL02', NULL, NULL, 103, NULL, NULL, 234642),
(279769, '5e94B01', NULL, NULL, 123, NULL, NULL, 234642),
(279770, '3mqiA00', NULL, NULL, 96, NULL, NULL, 234642),
(279771, '4hbqA01', NULL, NULL, 90, NULL, NULL, 234642),
(279772, '5b4mD01', NULL, NULL, 112, NULL, NULL, 234642),
(279773, '3oz9L01', NULL, NULL, 106, NULL, NULL, 234642),
(279774, '4yqxO00', NULL, NULL, 118, NULL, NULL, 234642),
(279775, '4o00A01', NULL, NULL, 97, NULL, NULL, 234642),
(279776, '1r0aL01', NULL, NULL, 107, NULL, NULL, 234642),
(279777, '4idjL01', NULL, NULL, 109, NULL, NULL, 234642),
(279778, '1dbbL01', NULL, NULL, 113, NULL, NULL, 234642),
(279779, '4xnqA01', NULL, NULL, 106, NULL, NULL, 234642),
(279780, '2ed7A00', NULL, NULL, 119, NULL, NULL, 234642),
(279781, '6dfjL01', NULL, NULL, 110, NULL, NULL, 234642),
(279782, '1mieH01', NULL, NULL, 117, NULL, NULL, 234642),
(279783, '2hkfH01', NULL, NULL, 119, NULL, NULL, 234642),
(279784, '3wbdA02', NULL, NULL, 99, NULL, NULL, 234642),
(279785, '5tihH01', NULL, NULL, 114, NULL, NULL, 234642),
(279786, '4w4oC01', NULL, NULL, 86, NULL, NULL, 234642),
(279787, '5eorH01', NULL, NULL, 115, NULL, NULL, 234642),
(279788, '6cezL01', NULL, NULL, 110, NULL, NULL, 234642),
(279789, '6nz7I01', NULL, NULL, 107, NULL, NULL, 234642),
(279790, '4w4oC02', NULL, NULL, 89, NULL, NULL, 234642),
(279791, '2qqkH01', NULL, NULL, 124, NULL, NULL, 234642),
(279792, '5wkfE01', NULL, NULL, 115, NULL, NULL, 234642),
(279793, '1bfvH00', NULL, NULL, 119, NULL, NULL, 234642),
(279794, '6at6A01', NULL, NULL, 114, NULL, NULL, 234642),
(279795, '1seqH01', NULL, NULL, 123, NULL, NULL, 234642),
(279796, '3haeH01', NULL, NULL, 119, NULL, NULL, 234642),
(279797, '3ikkA00', NULL, NULL, 127, NULL, NULL, 234642),
(279798, '1uwgL01', NULL, NULL, 108, NULL, NULL, 234642),
(279799, '4w4oC03', NULL, NULL, 105, NULL, NULL, 234642),
(279800, '5l9dL01', NULL, NULL, 109, NULL, NULL, 234642),
(279801, '3q6fA01', NULL, NULL, 109, NULL, NULL, 234642),
(279802, '4tvsa00', NULL, NULL, 134, NULL, NULL, 234642),
(279803, '3ztnL01', NULL, NULL, 112, NULL, NULL, 234642),
(279804, '1seqH02', NULL, NULL, 102, NULL, NULL, 234642),
(279805, '2gfbA01', NULL, NULL, 108, NULL, NULL, 234642),
(279806, '4hbqA02', NULL, NULL, 116, NULL, NULL, 234642),
(279807, '1egjH01', NULL, NULL, 119, NULL, NULL, 234642),
(279808, '4n9gB01', NULL, NULL, 108, NULL, NULL, 234642),
(279809, '4qyoA00', NULL, NULL, 114, NULL, NULL, 234642),
(279810, '4buhB01', NULL, NULL, 125, NULL, NULL, 234642),
(279811, '4ofkB00', NULL, NULL, 108, NULL, NULL, 234642),
(279812, '4xxdA01', NULL, NULL, 112, NULL, NULL, 234642),
(279813, '1mvuB00', NULL, NULL, 121, NULL, NULL, 234642),
(279814, '2y1vA04', NULL, NULL, 185, NULL, NULL, 234642),
(279815, '4jn2B01', NULL, NULL, 122, NULL, NULL, 234642),
(279816, '4eneC02', NULL, NULL, 99, NULL, NULL, 234642),
(279817, '5b21A00', NULL, NULL, 114, NULL, NULL, 234642),
(279818, '6blhL01', NULL, NULL, 109, NULL, NULL, 234642),
(279819, '5dlmI01', NULL, NULL, 115, NULL, NULL, 234642),
(279820, '5hvhB00', NULL, NULL, 128, NULL, NULL, 234642),
(279821, '2y1vA01', NULL, NULL, 159, NULL, NULL, 234642),
(279822, '6bqoC00', NULL, NULL, 95, NULL, NULL, 234642),
(279823, '1fn4B01', NULL, NULL, 116, NULL, NULL, 234642),
(279824, '1fn4B02', NULL, NULL, 99, NULL, NULL, 234642),
(279825, '1qfhA01', NULL, NULL, 111, NULL, NULL, 234642),
(279826, '1qfhA02', NULL, NULL, 101, NULL, NULL, 234642),
(279827, '4ms8C01', NULL, NULL, 118, NULL, NULL, 234642),
(279828, '2apbA00', NULL, NULL, 110, NULL, NULL, 234642);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(279829, '4hkxA01', NULL, NULL, 126, NULL, NULL, 234642),
(279830, '2cdgB01', NULL, NULL, 115, NULL, NULL, 234642),
(279831, '5wccL01', NULL, NULL, 112, NULL, NULL, 234642),
(279832, '3e8uH01', NULL, NULL, 117, NULL, NULL, 234642),
(279833, '3e8uH02', NULL, NULL, 99, NULL, NULL, 234642),
(279834, '1va9A00', NULL, NULL, 122, NULL, NULL, 234642),
(279835, '1qkzH01', NULL, NULL, 119, NULL, NULL, 234642),
(279836, '5jikB02', NULL, NULL, 114, NULL, NULL, 234642),
(279837, '4ydjB01', NULL, NULL, 101, NULL, NULL, 234642),
(279838, '3q0hB00', NULL, NULL, 117, NULL, NULL, 234642),
(279839, '6gdtA01', NULL, NULL, 93, NULL, NULL, 234642),
(279840, '1q72H02', NULL, NULL, 92, NULL, NULL, 234642),
(279841, '1ospH01', NULL, NULL, 120, NULL, NULL, 234642),
(279842, '1q72H01', NULL, NULL, 121, NULL, NULL, 234642),
(279843, '5eo9B02', NULL, NULL, 96, NULL, NULL, 234642),
(279844, '4mnhD02', NULL, NULL, 101, NULL, NULL, 234642),
(279845, '5eo9B01', NULL, NULL, 110, NULL, NULL, 234642),
(279846, '2apxA00', NULL, NULL, 112, NULL, NULL, 234642),
(279847, '5d1xD01', NULL, NULL, 110, NULL, NULL, 234642),
(279848, '4idlA00', NULL, NULL, 136, NULL, NULL, 234642),
(279849, '1a2yA00', NULL, NULL, 107, NULL, NULL, 234642),
(279850, '5i66B01', NULL, NULL, 108, NULL, NULL, 234642),
(279851, '6bjzL01', NULL, NULL, 112, NULL, NULL, 234642),
(279852, '2a38B01', NULL, NULL, 99, NULL, NULL, 234642),
(279853, '5tdoA01', NULL, NULL, 108, NULL, NULL, 234642),
(279854, '4g80B01', NULL, NULL, 108, NULL, NULL, 234642),
(279855, '5e4iA01', NULL, NULL, 98, NULL, NULL, 234642),
(279856, '5e4iA03', NULL, NULL, 91, NULL, NULL, 234642),
(279857, '5e4iA02', NULL, NULL, 104, NULL, NULL, 234642),
(279858, '3gbnH01', NULL, NULL, 121, NULL, NULL, 234642),
(279859, '3gbnH02', NULL, NULL, 66, NULL, NULL, 234642),
(279860, '1hkfA00', NULL, NULL, 122, NULL, NULL, 234642),
(279861, '3dwtA00', NULL, NULL, 137, NULL, NULL, 234642),
(279862, '1yqvL01', NULL, NULL, 107, NULL, NULL, 234642),
(279863, '4x8jH01', NULL, NULL, 115, NULL, NULL, 234642),
(279864, '4cmhC01', NULL, NULL, 108, NULL, NULL, 234642),
(279865, '3ifoB01', NULL, NULL, 113, NULL, NULL, 234642),
(279866, '4l1hA00', NULL, NULL, 107, NULL, NULL, 234642),
(279867, '1cicA01', NULL, NULL, 108, NULL, NULL, 234642),
(279868, '1zvyA00', NULL, NULL, 136, NULL, NULL, 234642),
(279869, '3r4dA01', NULL, NULL, 107, NULL, NULL, 234642),
(279870, '4m4pA04', NULL, NULL, 113, NULL, NULL, 234642),
(279871, '3r4dA02', NULL, NULL, 101, NULL, NULL, 234642),
(279872, '4m4pA05', NULL, NULL, 105, NULL, NULL, 234642),
(279873, '5kvfL01', NULL, NULL, 114, NULL, NULL, 234642),
(279874, '4osuL01', NULL, NULL, 109, NULL, NULL, 234642),
(279875, '2mspA00', NULL, NULL, 126, NULL, NULL, 234642),
(279876, '1x5yA01', NULL, NULL, 97, NULL, NULL, 234642),
(279877, '5e4iA04', NULL, NULL, 91, NULL, NULL, 234642),
(279878, '4h88L01', NULL, NULL, 108, NULL, NULL, 234642),
(279879, '5bmfL01', NULL, NULL, 112, NULL, NULL, 234642),
(279880, '3qpxL01', NULL, NULL, 107, NULL, NULL, 234642),
(279881, '4s2sA01', NULL, NULL, 119, NULL, NULL, 234642),
(279882, '3phqB01', NULL, NULL, 122, NULL, NULL, 234642),
(279883, '3qhzI01', NULL, NULL, 127, NULL, NULL, 234642),
(279884, '2vkwA02', NULL, NULL, 102, NULL, NULL, 234642),
(279885, '4lspL01', NULL, NULL, 103, NULL, NULL, 234642),
(279886, '3f8uB02', NULL, NULL, 132, NULL, NULL, 234642),
(279887, '2dltA00', NULL, NULL, 106, NULL, NULL, 234642),
(279888, '3f8uB01', NULL, NULL, 138, NULL, NULL, 234642),
(279889, '4xakD01', NULL, NULL, 125, NULL, NULL, 234642),
(279890, '5c0cI01', NULL, NULL, 110, NULL, NULL, 234642),
(279891, '2axjA01', NULL, NULL, 113, NULL, NULL, 234642),
(279892, '6cxyL01', NULL, NULL, 114, NULL, NULL, 234642),
(279893, '2uziH00', NULL, NULL, 114, NULL, NULL, 234642),
(279894, '6eh4E02', NULL, NULL, 129, NULL, NULL, 234642),
(279895, '2otpB01', NULL, NULL, 96, NULL, NULL, 234642),
(279896, '1ueyA00', NULL, NULL, 127, NULL, NULL, 234642),
(279897, '6eh4E01', NULL, NULL, 115, NULL, NULL, 234642),
(279898, '4llaA02', NULL, NULL, 101, NULL, NULL, 234642),
(279899, '6flbL01', NULL, NULL, 112, NULL, NULL, 234642); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(279900, '2ajuL01', NULL, NULL, 113, NULL, NULL, 234642),
(279901, '4llaA01', NULL, NULL, 97, NULL, NULL, 234642),
(279902, '3c5zA01', NULL, NULL, 110, NULL, NULL, 234642),
(279903, '2ednA00', NULL, NULL, 118, NULL, NULL, 234642),
(279904, '5edxA00', NULL, NULL, 114, NULL, NULL, 234642),
(279905, '4al8L01', NULL, NULL, 107, NULL, NULL, 234642),
(279906, '5eocM01', NULL, NULL, 106, NULL, NULL, 234642),
(279907, '4k7pL01', NULL, NULL, 109, NULL, NULL, 234642),
(279908, '2gsiA01', NULL, NULL, 106, NULL, NULL, 234642),
(279909, '6g1eB02', NULL, NULL, 110, NULL, NULL, 234642),
(279910, '4x7sH01', NULL, NULL, 121, NULL, NULL, 234642),
(279911, '2v9rA02', NULL, NULL, 104, NULL, NULL, 234642),
(279912, '3wn5B01', NULL, NULL, 100, NULL, NULL, 234642),
(279913, '1uenA00', NULL, NULL, 125, NULL, NULL, 234642),
(279914, '2gjjA02', NULL, NULL, 107, NULL, NULL, 234642),
(279915, '4xvtL02', NULL, NULL, 102, NULL, NULL, 234642),
(279916, '2xqyK01', NULL, NULL, 106, NULL, NULL, 234642),
(279917, '2edyA00', NULL, NULL, 103, NULL, NULL, 234642),
(279918, '4b53A00', NULL, NULL, 106, NULL, NULL, 234642),
(279919, '4xvtL01', NULL, NULL, 108, NULL, NULL, 234642),
(279920, '2hp4A00', NULL, NULL, 114, NULL, NULL, 234642),
(279921, '1ypzE01', NULL, NULL, 120, NULL, NULL, 234642),
(279922, '1pd6A00', NULL, NULL, 104, NULL, NULL, 234642),
(279923, '6fy2L01', NULL, NULL, 108, NULL, NULL, 234642),
(279924, '1ypzE02', NULL, NULL, 87, NULL, NULL, 234642),
(279925, '4bfeC01', NULL, NULL, 106, NULL, NULL, 234642),
(279926, '5w24L01', NULL, NULL, 112, NULL, NULL, 234642),
(279927, '2dm4A01', NULL, NULL, 94, NULL, NULL, 234642),
(279928, '2dmkA01', NULL, NULL, 103, NULL, NULL, 234642),
(279929, '3kr3H01', NULL, NULL, 122, NULL, NULL, 234642),
(279930, '2a77H01', NULL, NULL, 122, NULL, NULL, 234642),
(279931, '6b08B01', NULL, NULL, 108, NULL, NULL, 234642),
(279932, '3fn0L01', NULL, NULL, 106, NULL, NULL, 234642),
(279933, '1eerC01', NULL, NULL, 97, NULL, NULL, 234642),
(279934, '5girA01', NULL, NULL, 112, NULL, NULL, 234642),
(279935, '3arxA01', NULL, NULL, 111, NULL, NULL, 234642),
(279936, '4nzuH01', NULL, NULL, 126, NULL, NULL, 234642),
(279937, '4nzuH02', NULL, NULL, 99, NULL, NULL, 234642),
(279938, '5m5eB02', NULL, NULL, 103, NULL, NULL, 234642),
(279939, '3bkyH01', NULL, NULL, 122, NULL, NULL, 234642),
(279940, '1ogaD02', NULL, NULL, 90, NULL, NULL, 234642),
(279941, '1ogaD01', NULL, NULL, 110, NULL, NULL, 234642),
(279942, '5m5eB01', NULL, NULL, 105, NULL, NULL, 234642),
(279943, '1qg3A02', NULL, NULL, 104, NULL, NULL, 234642),
(279944, '2y6sC01', NULL, NULL, 106, NULL, NULL, 234642),
(279945, '2hwzL01', NULL, NULL, 107, NULL, NULL, 234642),
(279946, '5lhrB00', NULL, NULL, 121, NULL, NULL, 234642),
(279947, '2jixD01', NULL, NULL, 116, NULL, NULL, 234642),
(279948, '4m43H01', NULL, NULL, 119, NULL, NULL, 234642),
(279949, '3bn9D01', NULL, NULL, 128, NULL, NULL, 234642),
(279950, '5fgcE01', NULL, NULL, 127, NULL, NULL, 234642),
(279951, '4jr9H01', NULL, NULL, 119, NULL, NULL, 234642),
(279952, '4jpwH01', NULL, NULL, 122, NULL, NULL, 234642),
(279953, '2xqbH01', NULL, NULL, 125, NULL, NULL, 234642),
(279954, '4hgkC00', NULL, NULL, 109, NULL, NULL, 234642),
(279955, '43c9B00', NULL, NULL, 118, NULL, NULL, 234642),
(279956, '5az2L01', NULL, NULL, 107, NULL, NULL, 234642),
(279957, '3cx2A00', NULL, NULL, 108, NULL, NULL, 234642),
(279958, '1cqkA00', NULL, NULL, 101, NULL, NULL, 234642),
(279959, '2i9lB01', NULL, NULL, 119, NULL, NULL, 234642),
(279960, '4ky1H01', NULL, NULL, 116, NULL, NULL, 234642),
(279961, '3ch8A02', NULL, NULL, 91, NULL, NULL, 234642),
(279962, '5mybA02', NULL, NULL, 96, NULL, NULL, 234642),
(279963, '4qciA01', NULL, NULL, 105, NULL, NULL, 234642),
(279964, '4nj9H02', NULL, NULL, 81, NULL, NULL, 234642),
(279965, '2op4L01', NULL, NULL, 110, NULL, NULL, 234642),
(279966, '4nj9H01', NULL, NULL, 129, NULL, NULL, 234642),
(279967, '5iblD01', NULL, NULL, 109, NULL, NULL, 234642),
(279968, '5bs0D01', NULL, NULL, 114, NULL, NULL, 234642),
(279969, '3qt2A02', NULL, NULL, 113, NULL, NULL, 234642),
(279970, '4ndmB01', NULL, NULL, 132, NULL, NULL, 234642);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(279971, '1eerB02', NULL, NULL, 108, NULL, NULL, 234642),
(279972, '3qt2A01', NULL, NULL, 105, NULL, NULL, 234642),
(279973, '2q3zA04', NULL, NULL, 100, NULL, NULL, 234642),
(279974, '3orjA02', NULL, NULL, 85, NULL, NULL, 234642),
(279975, '3orjA01', NULL, NULL, 111, NULL, NULL, 234642),
(279976, '4gosA00', NULL, NULL, 125, NULL, NULL, 234642),
(279977, '2lvcA01', NULL, NULL, 86, NULL, NULL, 234642),
(279978, '5oyjD02', NULL, NULL, 139, NULL, NULL, 234642),
(279979, '3hr5A01', NULL, NULL, 113, NULL, NULL, 234642),
(279980, '3mtrA01', NULL, NULL, 111, NULL, NULL, 234642),
(279981, '5myxA01', NULL, NULL, 113, NULL, NULL, 234642),
(279982, '4k23H01', NULL, NULL, 119, NULL, NULL, 234642),
(279983, '5vlpL01', NULL, NULL, 107, NULL, NULL, 234642),
(279984, '5jo5A01', NULL, NULL, 131, NULL, NULL, 234642),
(279985, '6bpeC01', NULL, NULL, 106, NULL, NULL, 234642),
(279986, '5dwuH01', NULL, NULL, 117, NULL, NULL, 234642),
(279987, '4f57L01', NULL, NULL, 111, NULL, NULL, 234642),
(279988, '3ld8B01', NULL, NULL, 114, NULL, NULL, 234642),
(279989, '4f2mB01', NULL, NULL, 108, NULL, NULL, 234642),
(279990, '2b1hL01', NULL, NULL, 112, NULL, NULL, 234642),
(279991, '5irbA02', NULL, NULL, 103, NULL, NULL, 234642),
(279992, '5irbA01', NULL, NULL, 104, NULL, NULL, 234642),
(279993, '4mwfA01', NULL, NULL, 128, NULL, NULL, 234642),
(279994, '5awnL01', NULL, NULL, 111, NULL, NULL, 234642),
(279995, '5awnL02', NULL, NULL, 105, NULL, NULL, 234642),
(279996, '8fabA01', NULL, NULL, 107, NULL, NULL, 234642),
(279997, '2bc4B02', NULL, NULL, 101, NULL, NULL, 234642),
(279998, '1f11A01', NULL, NULL, 112, NULL, NULL, 234642),
(279999, '3d85A01', NULL, NULL, 108, NULL, NULL, 234642),
(280000, '5dt1L01', NULL, NULL, 113, NULL, NULL, 234642),
(280001, '4rrpG01', NULL, NULL, 122, NULL, NULL, 234642),
(280002, '3s5lH01', NULL, NULL, 102, NULL, NULL, 234642),
(280003, '3opzL01', NULL, NULL, 107, NULL, NULL, 234642),
(280004, '5szfL01', NULL, NULL, 107, NULL, NULL, 234642),
(280005, '3lizH01', NULL, NULL, 119, NULL, NULL, 234642),
(280006, '1a4jB01', NULL, NULL, 119, NULL, NULL, 234642),
(280007, '2rikA02', NULL, NULL, 95, NULL, NULL, 234642),
(280008, '4m1dH01', NULL, NULL, 131, NULL, NULL, 234642),
(280009, '2rikA01', NULL, NULL, 97, NULL, NULL, 234642),
(280010, '2n7aA00', NULL, NULL, 145, NULL, NULL, 234642),
(280011, '2rikA03', NULL, NULL, 92, NULL, NULL, 234642),
(280012, '4zsoA01', NULL, NULL, 108, NULL, NULL, 234642),
(280013, '4m1dH02', NULL, NULL, 98, NULL, NULL, 234642),
(280014, '5j56B00', NULL, NULL, 129, NULL, NULL, 234642),
(280015, '6o39A01', NULL, NULL, 107, NULL, NULL, 234642),
(280016, '5bzdB01', NULL, NULL, 128, NULL, NULL, 234642),
(280017, '1nc2A01', NULL, NULL, 110, NULL, NULL, 234642),
(280018, '4d3cL01', NULL, NULL, 109, NULL, NULL, 234642),
(280019, '2zpkL01', NULL, NULL, 110, NULL, NULL, 234642),
(280020, '2zpkL02', NULL, NULL, 102, NULL, NULL, 234642),
(280021, '5chnB01', NULL, NULL, 112, NULL, NULL, 234642),
(280022, '1fj1A01', NULL, NULL, 108, NULL, NULL, 234642),
(280023, '1gpoL01', NULL, NULL, 113, NULL, NULL, 234642),
(280024, '3tvmE02', NULL, NULL, 58, NULL, NULL, 234642),
(280025, '5uelH01', NULL, NULL, 129, NULL, NULL, 234642),
(280026, '5mhrM00', NULL, NULL, 119, NULL, NULL, 234642),
(280027, '2oi9C00', NULL, NULL, 121, NULL, NULL, 234642),
(280028, '4mqsB00', NULL, NULL, 125, NULL, NULL, 234642),
(280029, '1rziL01', NULL, NULL, 129, NULL, NULL, 234642),
(280030, '6btjB01', NULL, NULL, 107, NULL, NULL, 234642),
(280031, '6a0xB01', NULL, NULL, 108, NULL, NULL, 234642),
(280032, '5i99A03', NULL, NULL, 100, NULL, NULL, 234642),
(280033, '3decA04', NULL, NULL, 105, NULL, NULL, 234642),
(280034, '2ipuH02', NULL, NULL, 100, NULL, NULL, 234642),
(280035, '5f1nB00', NULL, NULL, 99, NULL, NULL, 234642),
(280036, '3decA02', NULL, NULL, 111, NULL, NULL, 234642),
(280037, '2yrlA01', NULL, NULL, 83, NULL, NULL, 234642),
(280038, '2h1pL01', NULL, NULL, 113, NULL, NULL, 234642),
(280039, '3wuzA00', NULL, NULL, 120, NULL, NULL, 234642),
(280040, '1vcaA01', NULL, NULL, 89, NULL, NULL, 234642),
(280041, '5ggsZ00', NULL, NULL, 123, NULL, NULL, 234642);
INSERT INTO "PUBLIC"."MODEL" VALUES
(280042, '1hi6A01', NULL, NULL, 108, NULL, NULL, 234642),
(280043, '1hi6A02', NULL, NULL, 103, NULL, NULL, 234642),
(280044, '4b50A00', NULL, NULL, 122, NULL, NULL, 234642),
(280045, '5otjA01', NULL, NULL, 112, NULL, NULL, 234642),
(280046, '5w1wE01', NULL, NULL, 117, NULL, NULL, 234642),
(280047, '5i99A01', NULL, NULL, 95, NULL, NULL, 234642),
(280048, '4glrH01', NULL, NULL, 127, NULL, NULL, 234642),
(280049, '3cx5K00', NULL, NULL, 107, NULL, NULL, 234642),
(280050, '2nqcA00', NULL, NULL, 97, NULL, NULL, 234642),
(280051, '2z92A01', NULL, NULL, 114, NULL, NULL, 234642),
(280052, '5xj4L00', NULL, NULL, 114, NULL, NULL, 234642),
(280053, '4s1sH01', NULL, NULL, 125, NULL, NULL, 234642),
(280054, '2wqrA02', NULL, NULL, 107, NULL, NULL, 234642),
(280055, '2yplE02', NULL, NULL, 129, NULL, NULL, 234642),
(280056, '2wqrA03', NULL, NULL, 111, NULL, NULL, 234642),
(280057, '2yplE01', NULL, NULL, 109, NULL, NULL, 234642),
(280058, '1vcaA02', NULL, NULL, 113, NULL, NULL, 234642),
(280059, '4g6mH01', NULL, NULL, 120, NULL, NULL, 234642),
(280060, '1x7qA02', NULL, NULL, 94, NULL, NULL, 234642),
(280061, '2je8A04', NULL, NULL, 102, NULL, NULL, 234642),
(280062, '2f15A00', NULL, NULL, 96, NULL, NULL, 234642),
(280063, '5i8cA01', NULL, NULL, 122, NULL, NULL, 234642),
(280064, '2je8A02', NULL, NULL, 110, NULL, NULL, 234642),
(280065, '3s98A01', NULL, NULL, 100, NULL, NULL, 234642),
(280066, '3s98A02', NULL, NULL, 103, NULL, NULL, 234642),
(280067, '3s98A03', NULL, NULL, 103, NULL, NULL, 234642),
(280068, '5u3nH01', NULL, NULL, 132, NULL, NULL, 234642),
(280069, '4qnpE01', NULL, NULL, 124, NULL, NULL, 234642),
(280070, '1bvkB00', NULL, NULL, 117, NULL, NULL, 234642),
(280071, '4ncc201', NULL, NULL, 119, NULL, NULL, 234642),
(280072, '2labA00', NULL, NULL, 104, NULL, NULL, 234642),
(280073, '4mhhG01', NULL, NULL, 120, NULL, NULL, 234642),
(280074, '4i77H01', NULL, NULL, 118, NULL, NULL, 234642),
(280075, '1fgvL00', NULL, NULL, 109, NULL, NULL, 234642),
(280076, '1dn0D02', NULL, NULL, 102, NULL, NULL, 234642),
(280077, '3pqyD01', NULL, NULL, 108, NULL, NULL, 234642),
(280078, '4gmtH02', NULL, NULL, 107, NULL, NULL, 234642),
(280079, '1pvhA02', NULL, NULL, 101, NULL, NULL, 234642),
(280080, '5yoyD00', NULL, NULL, 119, NULL, NULL, 234642),
(280081, '1fl5A01', NULL, NULL, 111, NULL, NULL, 234642),
(280082, '4k3gA00', NULL, NULL, 118, NULL, NULL, 234642),
(280083, '4hwuA00', NULL, NULL, 95, NULL, NULL, 234642),
(280084, '4gmtH01', NULL, NULL, 118, NULL, NULL, 234642),
(280085, '1kxvC00', NULL, NULL, 121, NULL, NULL, 234642),
(280086, '3rbsA01', NULL, NULL, 118, NULL, NULL, 234642),
(280087, '3rbsA02', NULL, NULL, 89, NULL, NULL, 234642),
(280088, '4ocsL01', NULL, NULL, 112, NULL, NULL, 234642),
(280089, '4kjyB01', NULL, NULL, 125, NULL, NULL, 234642),
(280090, '3hntH02', NULL, NULL, 102, NULL, NULL, 234642),
(280091, '3hntH01', NULL, NULL, 118, NULL, NULL, 234642),
(280092, '6funB01', NULL, NULL, 110, NULL, NULL, 234642),
(280093, '1nctA00', NULL, NULL, 106, NULL, NULL, 234642),
(280094, '3skjL01', NULL, NULL, 108, NULL, NULL, 234642),
(280095, '4g5zL01', NULL, NULL, 107, NULL, NULL, 234642),
(280096, '3qcuH01', NULL, NULL, 122, NULL, NULL, 234642),
(280097, '4md5B02', NULL, NULL, 107, NULL, NULL, 234642),
(280098, '5j11C02', NULL, NULL, 110, NULL, NULL, 234642),
(280099, '4ydjA01', NULL, NULL, 135, NULL, NULL, 234642),
(280100, '3baeH01', NULL, NULL, 125, NULL, NULL, 234642),
(280101, '3brdA03', NULL, NULL, 101, NULL, NULL, 234642),
(280102, '4nzrH01', NULL, NULL, 133, NULL, NULL, 234642),
(280103, '4dvbB01', NULL, NULL, 109, NULL, NULL, 234642),
(280104, '4oqtL01', NULL, NULL, 109, NULL, NULL, 234642),
(280105, '2pyfA02', NULL, NULL, 91, NULL, NULL, 234642),
(280106, '4gs7C01', NULL, NULL, 100, NULL, NULL, 234642),
(280107, '6eynA01', NULL, NULL, 112, NULL, NULL, 234642),
(280108, '5czvH01', NULL, NULL, 116, NULL, NULL, 234642),
(280109, '3wexA02', NULL, NULL, 112, NULL, NULL, 234642),
(280110, '4gs7C02', NULL, NULL, 103, NULL, NULL, 234642),
(280111, '2w0pB00', NULL, NULL, 94, NULL, NULL, 234642),
(280112, '3b2uC01', NULL, NULL, 121, NULL, NULL, 234642);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(280113, '4od3L01', NULL, NULL, 113, NULL, NULL, 234642),
(280114, '1mexL01', NULL, NULL, 108, NULL, NULL, 234642),
(280115, '1mexL02', NULL, NULL, 103, NULL, NULL, 234642),
(280116, '4bklA01', NULL, NULL, 116, NULL, NULL, 234642),
(280117, '5e94A01', NULL, NULL, 108, NULL, NULL, 234642),
(280118, '1bj1H01', NULL, NULL, 123, NULL, NULL, 234642),
(280119, '4lstH01', NULL, NULL, 121, NULL, NULL, 234642),
(280120, '4pj9C01', NULL, NULL, 109, NULL, NULL, 234642),
(280121, '4l3aA05', NULL, NULL, 80, NULL, NULL, 234642),
(280122, '1fe8L01', NULL, NULL, 107, NULL, NULL, 234642),
(280123, '5jopE01', NULL, NULL, 112, NULL, NULL, 234642),
(280124, '3clfH01', NULL, NULL, 118, NULL, NULL, 234642),
(280125, '5n4gH01', NULL, NULL, 115, NULL, NULL, 234642),
(280126, '3qycB00', NULL, NULL, 127, NULL, NULL, 234642),
(280127, '5e99H01', NULL, NULL, 171, NULL, NULL, 234642),
(280128, '5mj3A01', NULL, NULL, 84, NULL, NULL, 234642),
(280129, '5mj3A02', NULL, NULL, 108, NULL, NULL, 234642),
(280130, '2fjhA01', NULL, NULL, 108, NULL, NULL, 234642),
(280131, '5mj3A03', NULL, NULL, 91, NULL, NULL, 234642),
(280132, '1rjlB02', NULL, NULL, 99, NULL, NULL, 234642),
(280133, '3u0wH01', NULL, NULL, 113, NULL, NULL, 234642),
(280134, '5gryA02', NULL, NULL, 108, NULL, NULL, 234642),
(280135, '1rjlB01', NULL, NULL, 120, NULL, NULL, 234642),
(280136, '5m63L01', NULL, NULL, 112, NULL, NULL, 234642),
(280137, '1cd9D01', NULL, NULL, 108, NULL, NULL, 234642),
(280138, '4kaqH01', NULL, NULL, 121, NULL, NULL, 234642),
(280139, '4pjfF01', NULL, NULL, 117, NULL, NULL, 234642),
(280140, '1bgxH01', NULL, NULL, 119, NULL, NULL, 234642),
(280141, '3rpiB01', NULL, NULL, 100, NULL, NULL, 234642),
(280142, '3kdmB01', NULL, NULL, 122, NULL, NULL, 234642),
(280143, '3kdmB02', NULL, NULL, 100, NULL, NULL, 234642),
(280144, '4zptA01', NULL, NULL, 117, NULL, NULL, 234642),
(280145, '5bzwA01', NULL, NULL, 108, NULL, NULL, 234642),
(280146, '4yk4C01', NULL, NULL, 125, NULL, NULL, 234642),
(280147, '5d6cB01', NULL, NULL, 116, NULL, NULL, 234642),
(280148, '1nlbH01', NULL, NULL, 118, NULL, NULL, 234642),
(280149, '6dwiE01', NULL, NULL, 108, NULL, NULL, 234642),
(280150, '6frjH02', NULL, NULL, 100, NULL, NULL, 234642),
(280151, '2fl5A01', NULL, NULL, 107, NULL, NULL, 234642),
(280152, '2h9gB01', NULL, NULL, 120, NULL, NULL, 234642),
(280153, '5vk2E01', NULL, NULL, 112, NULL, NULL, 234642),
(280154, '1pskL01', NULL, NULL, 107, NULL, NULL, 234642),
(280155, '2xwtA01', NULL, NULL, 119, NULL, NULL, 234642),
(280156, '3mffA01', NULL, NULL, 110, NULL, NULL, 234642),
(280157, '5cp3H01', NULL, NULL, 113, NULL, NULL, 234642),
(280158, '2bhuA01', NULL, NULL, 109, NULL, NULL, 234642),
(280159, '3bgaA02', NULL, NULL, 111, NULL, NULL, 234642),
(280160, '3bgaA04', NULL, NULL, 105, NULL, NULL, 234642),
(280161, '4en3B01', NULL, NULL, 120, NULL, NULL, 234642),
(280162, '4s1dD01', NULL, NULL, 108, NULL, NULL, 234642),
(280163, '3pxhA02', NULL, NULL, 99, NULL, NULL, 234642),
(280164, '3pxhA01', NULL, NULL, 102, NULL, NULL, 234642),
(280165, '4isvA01', NULL, NULL, 116, NULL, NULL, 234642),
(280166, '2xzzA00', NULL, NULL, 102, NULL, NULL, 234642),
(280167, '4isvA02', NULL, NULL, 100, NULL, NULL, 234642),
(280168, '5z1aA02', NULL, NULL, 118, NULL, NULL, 234642),
(280169, '5gqwA02', NULL, NULL, 121, NULL, NULL, 234642),
(280170, '6iutL01', NULL, NULL, 110, NULL, NULL, 234642),
(280171, '4ypgB01', NULL, NULL, 116, NULL, NULL, 234642),
(280172, '1yuhL02', NULL, NULL, 100, NULL, NULL, 234642),
(280173, '3kldA03', NULL, NULL, 92, NULL, NULL, 234642),
(280174, '3kldA04', NULL, NULL, 91, NULL, NULL, 234642),
(280175, '4depC02', NULL, NULL, 102, NULL, NULL, 234642),
(280176, '4pb0H01', NULL, NULL, 121, NULL, NULL, 234642),
(280177, '6n4qI01', NULL, NULL, 109, NULL, NULL, 234642),
(280178, '3qg6A01', NULL, NULL, 113, NULL, NULL, 234642),
(280179, '4nbzD00', NULL, NULL, 124, NULL, NULL, 234642),
(280180, '3kldA01', NULL, NULL, 99, NULL, NULL, 234642),
(280181, '3kldA02', NULL, NULL, 102, NULL, NULL, 234642),
(280182, '3lafA04', NULL, NULL, 93, NULL, NULL, 234642),
(280183, '3lafA03', NULL, NULL, 94, NULL, NULL, 234642);
INSERT INTO "PUBLIC"."MODEL" VALUES
(280184, '3lafA02', NULL, NULL, 97, NULL, NULL, 234642),
(280185, '3lafA01', NULL, NULL, 101, NULL, NULL, 234642),
(280186, '3dggA01', NULL, NULL, 105, NULL, NULL, 234642),
(280187, '5z0uA01', NULL, NULL, 124, NULL, NULL, 234642),
(280188, '4qrpE01', NULL, NULL, 116, NULL, NULL, 234642),
(280189, '2otuA00', NULL, NULL, 115, NULL, NULL, 234642),
(280190, '3efdH01', NULL, NULL, 122, NULL, NULL, 234642),
(280191, '4hs8H01', NULL, NULL, 122, NULL, NULL, 234642),
(280192, '2frgP00', NULL, NULL, 106, NULL, NULL, 234642),
(280193, '2r29L01', NULL, NULL, 112, NULL, NULL, 234642),
(280194, '2zkhH01', NULL, NULL, 116, NULL, NULL, 234642),
(280195, '1kenL01', NULL, NULL, 109, NULL, NULL, 234642),
(280196, '3cfiL00', NULL, NULL, 116, NULL, NULL, 234642),
(280197, '3utzD01', NULL, NULL, 113, NULL, NULL, 234642),
(280198, '2giyB00', NULL, NULL, 191, NULL, NULL, 234642),
(280199, '4rauA01', NULL, NULL, 107, NULL, NULL, 234642),
(280200, '5ty6L02', NULL, NULL, 104, NULL, NULL, 234642),
(280201, '5ty6L01', NULL, NULL, 108, NULL, NULL, 234642),
(280202, '4v1dD00', NULL, NULL, 124, NULL, NULL, 234642),
(280203, '4q6iB01', NULL, NULL, 120, NULL, NULL, 234642),
(280204, '4qwwD01', NULL, NULL, 125, NULL, NULL, 234642),
(280205, '4jznB01', NULL, NULL, 109, NULL, NULL, 234642),
(280206, '1jn6B01', NULL, NULL, 122, NULL, NULL, 234642),
(280207, '4w6xB00', NULL, NULL, 131, NULL, NULL, 234642),
(280208, '4nm4H01', NULL, NULL, 121, NULL, NULL, 234642),
(280209, '1jn6B02', NULL, NULL, 95, NULL, NULL, 234642),
(280210, '1mj8H01', NULL, NULL, 119, NULL, NULL, 234642),
(280211, '1n26A01', NULL, NULL, 107, NULL, NULL, 234642),
(280212, '1n26A02', NULL, NULL, 78, NULL, NULL, 234642),
(280213, '1n26A03', NULL, NULL, 104, NULL, NULL, 234642),
(280214, '5fhxL02', NULL, NULL, 112, NULL, NULL, 234642),
(280215, '4zykB01', NULL, NULL, 108, NULL, NULL, 234642),
(280216, '5fhxL01', NULL, NULL, 115, NULL, NULL, 234642),
(280217, '3wjlA01', NULL, NULL, 102, NULL, NULL, 234642),
(280218, '2ghwB02', NULL, NULL, 101, NULL, NULL, 234642),
(280219, '3w2dH01', NULL, NULL, 121, NULL, NULL, 234642),
(280220, '6bs6A04', NULL, NULL, 116, NULL, NULL, 234642),
(280221, '4p5mB02', NULL, NULL, 100, NULL, NULL, 234642),
(280222, '6bj8D01', NULL, NULL, 113, NULL, NULL, 234642),
(280223, '4y8dC00', NULL, NULL, 120, NULL, NULL, 234642),
(280224, '2druA01', NULL, NULL, 103, NULL, NULL, 234642),
(280225, '4jvwD00', NULL, NULL, 115, NULL, NULL, 234642),
(280226, '3zmrA01', NULL, NULL, 91, NULL, NULL, 234642),
(280227, '4fz8L01', NULL, NULL, 111, NULL, NULL, 234642),
(280228, '5y2lJ01', NULL, NULL, 108, NULL, NULL, 234642),
(280229, '5t99A05', NULL, NULL, 111, NULL, NULL, 234642),
(280230, '5dmiH01', NULL, NULL, 122, NULL, NULL, 234642),
(280231, '3mckA01', NULL, NULL, 113, NULL, NULL, 234642),
(280232, '1mimH01', NULL, NULL, 115, NULL, NULL, 234642),
(280233, '3ottB03', NULL, NULL, 133, NULL, NULL, 234642),
(280234, '4pbxA06', NULL, NULL, 101, NULL, NULL, 234642),
(280235, '2wskA01', NULL, NULL, 133, NULL, NULL, 234642),
(280236, '4pbxA05', NULL, NULL, 100, NULL, NULL, 234642),
(280237, '4pbxA04', NULL, NULL, 92, NULL, NULL, 234642),
(280238, '4p3wC01', NULL, NULL, 86, NULL, NULL, 234642),
(280239, '3tclB01', NULL, NULL, 109, NULL, NULL, 234642),
(280240, '3bn3B02', NULL, NULL, 110, NULL, NULL, 234642),
(280241, '3bn3B01', NULL, NULL, 86, NULL, NULL, 234642),
(280242, '1kcuL01', NULL, NULL, 108, NULL, NULL, 234642),
(280243, '1kcuL02', NULL, NULL, 103, NULL, NULL, 234642),
(280244, '4lpwB00', NULL, NULL, 100, NULL, NULL, 234642),
(280245, '4k3dI01', NULL, NULL, 125, NULL, NULL, 234642),
(280246, '4hf5L01', NULL, NULL, 113, NULL, NULL, 234642),
(280247, '1fo0A00', NULL, NULL, 116, NULL, NULL, 234642),
(280248, '4fqlH01', NULL, NULL, 127, NULL, NULL, 234642),
(280249, '5l8jB00', NULL, NULL, 117, NULL, NULL, 234642),
(280250, '3u48A03', NULL, NULL, 118, NULL, NULL, 234642),
(280251, '5f3jC01', NULL, NULL, 113, NULL, NULL, 234642),
(280252, '1kfaH02', NULL, NULL, 99, NULL, NULL, 234642),
(280253, '5vvfL01', NULL, NULL, 107, NULL, NULL, 234642),
(280254, '2fcbA01', NULL, NULL, 86, NULL, NULL, 234642);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(280255, '3besR02', NULL, NULL, 111, NULL, NULL, 234642),
(280256, '1fneA02', NULL, NULL, 100, NULL, NULL, 234642),
(280257, '3besR01', NULL, NULL, 83, NULL, NULL, 234642),
(280258, '1qhoA03', NULL, NULL, 82, NULL, NULL, 234642),
(280259, '3so5B00', NULL, NULL, 112, NULL, NULL, 234642),
(280260, '4hlzI01', NULL, NULL, 123, NULL, NULL, 234642),
(280261, '1qhoA04', NULL, NULL, 108, NULL, NULL, 234642),
(280262, '3ncjH01', NULL, NULL, 121, NULL, NULL, 234642),
(280263, '3csgA03', NULL, NULL, 87, NULL, NULL, 234642),
(280264, '2fcbA02', NULL, NULL, 87, NULL, NULL, 234642),
(280265, '5u3lB01', NULL, NULL, 109, NULL, NULL, 234642),
(280266, '3qqnA00', NULL, NULL, 116, NULL, NULL, 234642),
(280267, '2n1kA00', NULL, NULL, 106, NULL, NULL, 234642),
(280268, '4x0kA01', NULL, NULL, 122, NULL, NULL, 234642),
(280269, '1igjA01', NULL, NULL, 113, NULL, NULL, 234642),
(280270, '6ehxB02', NULL, NULL, 101, NULL, NULL, 234642),
(280271, '3ncjH02', NULL, NULL, 104, NULL, NULL, 234642),
(280272, '1jpsH01', NULL, NULL, 117, NULL, NULL, 234642),
(280273, '5eoqH01', NULL, NULL, 119, NULL, NULL, 234642),
(280274, '5cwsB01', NULL, NULL, 123, NULL, NULL, 234642),
(280275, '4p59L01', NULL, NULL, 107, NULL, NULL, 234642),
(280276, '5ujtB02', NULL, NULL, 99, NULL, NULL, 234642),
(280277, '2cumA00', NULL, NULL, 105, NULL, NULL, 234642),
(280278, '4z7uE01', NULL, NULL, 109, NULL, NULL, 234642),
(280279, '2e7mA01', NULL, NULL, 103, NULL, NULL, 234642),
(280280, '1r3hA02', NULL, NULL, 93, NULL, NULL, 234642),
(280281, '4i0cC00', NULL, NULL, 132, NULL, NULL, 234642),
(280282, '5m5eC01', NULL, NULL, 97, NULL, NULL, 234642),
(280283, '1yntB01', NULL, NULL, 118, NULL, NULL, 234642),
(280284, '4fqjL01', NULL, NULL, 111, NULL, NULL, 234642),
(280285, '5nmdB01', NULL, NULL, 113, NULL, NULL, 234642),
(280286, '2ywzA00', NULL, NULL, 111, NULL, NULL, 234642),
(280287, '5u3jL01', NULL, NULL, 109, NULL, NULL, 234642),
(280288, '4m9pA02', NULL, NULL, 91, NULL, NULL, 234642),
(280289, '4m9pA01', NULL, NULL, 100, NULL, NULL, 234642),
(280290, '4cbpB02', NULL, NULL, 105, NULL, NULL, 234642),
(280291, '5ukqL01', NULL, NULL, 111, NULL, NULL, 234642),
(280292, '1yjdC00', NULL, NULL, 120, NULL, NULL, 234642),
(280293, '4m9pA03', NULL, NULL, 100, NULL, NULL, 234642),
(280294, '3i9gL01', NULL, NULL, 107, NULL, NULL, 234642),
(280295, '4rgmB01', NULL, NULL, 108, NULL, NULL, 234642),
(280296, '1rzgB01', NULL, NULL, 108, NULL, NULL, 234642),
(280297, '5d1zC01', NULL, NULL, 108, NULL, NULL, 234642),
(280298, '1f8tL01', NULL, NULL, 113, NULL, NULL, 234642),
(280299, '5eb9A00', NULL, NULL, 118, NULL, NULL, 234642),
(280300, '3hkfA01', NULL, NULL, 103, NULL, NULL, 234642),
(280301, '3hkfA02', NULL, NULL, 111, NULL, NULL, 234642),
(280302, '4buhA02', NULL, NULL, 119, NULL, NULL, 234642),
(280303, '4ww1A01', NULL, NULL, 113, NULL, NULL, 234642),
(280304, '4ww1A02', NULL, NULL, 94, NULL, NULL, 234642),
(280305, '5cexB01', NULL, NULL, 132, NULL, NULL, 234642),
(280306, '5tztB01', NULL, NULL, 112, NULL, NULL, 234642),
(280307, '4nn7C02', NULL, NULL, 89, NULL, NULL, 234642),
(280308, '3mj9L01', NULL, NULL, 109, NULL, NULL, 234642),
(280309, '4cj0A01', NULL, NULL, 95, NULL, NULL, 234642),
(280310, '1uc6A00', NULL, NULL, 109, NULL, NULL, 234642),
(280311, '2yc1B00', NULL, NULL, 122, NULL, NULL, 234642),
(280312, '6fr7B01', NULL, NULL, 112, NULL, NULL, 234642),
(280313, '1mcpH01', NULL, NULL, 123, NULL, NULL, 234642),
(280314, '5dmjE00', NULL, NULL, 121, NULL, NULL, 234642),
(280315, '1mcpH02', NULL, NULL, 99, NULL, NULL, 234642),
(280316, '2qhrH01', NULL, NULL, 123, NULL, NULL, 234642),
(280317, '5te7H01', NULL, NULL, 122, NULL, NULL, 234642),
(280318, '3ezjB00', NULL, NULL, 126, NULL, NULL, 234642),
(280319, '1ek3A00', NULL, NULL, 114, NULL, NULL, 234642),
(280320, '5fm5P00', NULL, NULL, 98, NULL, NULL, 234642),
(280321, '6c68B01', NULL, NULL, 111, NULL, NULL, 234642),
(280322, '4m6oH01', NULL, NULL, 123, NULL, NULL, 234642),
(280323, '4ktdH01', NULL, NULL, 125, NULL, NULL, 234642),
(280324, '2z4qB01', NULL, NULL, 118, NULL, NULL, 234642),
(280325, '4qxwA00', NULL, NULL, 107, NULL, NULL, 234642);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(280326, '3i02B01', NULL, NULL, 124, NULL, NULL, 234642),
(280327, '4z8fL01', NULL, NULL, 107, NULL, NULL, 234642),
(280328, '4of6A00', NULL, NULL, 120, NULL, NULL, 234642),
(280329, '6h3uM00', NULL, NULL, 117, NULL, NULL, 234642),
(280330, '4n8cL01', NULL, NULL, 114, NULL, NULL, 234642),
(280331, '4wtxA00', NULL, NULL, 99, NULL, NULL, 234642),
(280332, '4qycA01', NULL, NULL, 134, NULL, NULL, 234642),
(280333, '5m7qB00', NULL, NULL, 119, NULL, NULL, 234642),
(280334, '1x5fA00', NULL, NULL, 120, NULL, NULL, 234642),
(280335, '3mnzA01', NULL, NULL, 116, NULL, NULL, 234642),
(280336, '5vsiH02', NULL, NULL, 104, NULL, NULL, 234642),
(280337, '4k3eH01', NULL, NULL, 164, NULL, NULL, 234642),
(280338, '4hzlA01', NULL, NULL, 122, NULL, NULL, 234642),
(280339, '2ifgA02', NULL, NULL, 90, NULL, NULL, 234642),
(280340, '5alcL01', NULL, NULL, 112, NULL, NULL, 234642),
(280341, '3eotH01', NULL, NULL, 118, NULL, NULL, 234642),
(280342, '1vesA00', NULL, NULL, 113, NULL, NULL, 234642),
(280343, '6e0pM02', NULL, NULL, 100, NULL, NULL, 234642),
(280344, '4dkeH01', NULL, NULL, 122, NULL, NULL, 234642),
(280345, '2iepA01', NULL, NULL, 99, NULL, NULL, 234642),
(280346, '5b4mC01', NULL, NULL, 121, NULL, NULL, 234642),
(280347, '4n8pA00', NULL, NULL, 135, NULL, NULL, 234642),
(280348, '2hh0L01', NULL, NULL, 107, NULL, NULL, 234642),
(280349, '3qjhA01', NULL, NULL, 111, NULL, NULL, 234642),
(280350, '4aeiH01', NULL, NULL, 120, NULL, NULL, 234642),
(280351, '2xtjB00', NULL, NULL, 107, NULL, NULL, 234642),
(280352, '4hg4W00', NULL, NULL, 105, NULL, NULL, 234642),
(280353, '4lkxA01', NULL, NULL, 117, NULL, NULL, 234642),
(280354, '1x4zA01', NULL, NULL, 100, NULL, NULL, 234642),
(280355, '4jy5H01', NULL, NULL, 132, NULL, NULL, 234642),
(280356, '5n40A01', NULL, NULL, 103, NULL, NULL, 234642),
(280357, '4ocwH01', NULL, NULL, 145, NULL, NULL, 234642),
(280358, '6bpaC01', NULL, NULL, 107, NULL, NULL, 234642),
(280359, '4x99B02', NULL, NULL, 106, NULL, NULL, 234642),
(280360, '2o5xL01', NULL, NULL, 112, NULL, NULL, 234642),
(280361, '3w2dL01', NULL, NULL, 109, NULL, NULL, 234642),
(280362, '5gjsL01', NULL, NULL, 108, NULL, NULL, 234642),
(280363, '4c57D00', NULL, NULL, 122, NULL, NULL, 234642),
(280364, '3moqA00', NULL, NULL, 126, NULL, NULL, 234642),
(280365, '4h5sB00', NULL, NULL, 101, NULL, NULL, 234642),
(280366, '3fo2B01', NULL, NULL, 120, NULL, NULL, 234642),
(280367, '4uikL01', NULL, NULL, 107, NULL, NULL, 234642),
(280368, '1zxqA02', NULL, NULL, 107, NULL, NULL, 234642),
(280369, '1zxqA01', NULL, NULL, 85, NULL, NULL, 234642),
(280370, '4je4B00', NULL, NULL, 94, NULL, NULL, 234642),
(280371, '5j7kF00', NULL, NULL, 99, NULL, NULL, 234642),
(280372, '5tgbA01', NULL, NULL, 121, NULL, NULL, 234642),
(280373, '5kw9L01', NULL, NULL, 113, NULL, NULL, 234642),
(280374, '4qhuA01', NULL, NULL, 109, NULL, NULL, 234642),
(280375, '6ffjE01', NULL, NULL, 124, NULL, NULL, 234642),
(280376, '6nrxA00', NULL, NULL, 112, NULL, NULL, 234642),
(280377, '3kg5A00', NULL, NULL, 117, NULL, NULL, 234642),
(280378, '2v7hA01', NULL, NULL, 107, NULL, NULL, 234642),
(280379, '5d7sL01', NULL, NULL, 105, NULL, NULL, 234642),
(280380, '2nr6D01', NULL, NULL, 116, NULL, NULL, 234642),
(280381, '4f7eA02', NULL, NULL, 101, NULL, NULL, 234642),
(280382, '3tv3H01', NULL, NULL, 135, NULL, NULL, 234642),
(280383, '5dlmL01', NULL, NULL, 113, NULL, NULL, 234642),
(280384, '4yiqB00', NULL, NULL, 108, NULL, NULL, 234642),
(280385, '1um5L01', NULL, NULL, 108, NULL, NULL, 234642),
(280386, '5ywfB02', NULL, NULL, 97, NULL, NULL, 234642),
(280387, '6cyfC01', NULL, NULL, 108, NULL, NULL, 234642),
(280388, '5jopD01', NULL, NULL, 113, NULL, NULL, 234642),
(280389, '3hrzB02', NULL, NULL, 105, NULL, NULL, 234642),
(280390, '1jhlH00', NULL, NULL, 116, NULL, NULL, 234642),
(280391, '4ozfH01', NULL, NULL, 115, NULL, NULL, 234642),
(280392, '4y5yB00', NULL, NULL, 117, NULL, NULL, 234642),
(280393, '3cxdH02', NULL, NULL, 98, NULL, NULL, 234642),
(280394, '3cxdH01', NULL, NULL, 116, NULL, NULL, 234642),
(280395, '4od2A01', NULL, NULL, 108, NULL, NULL, 234642),
(280396, '6e3hL01', NULL, NULL, 112, NULL, NULL, 234642);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(280397, '5azeL01', NULL, NULL, 112, NULL, NULL, 234642),
(280398, '4gxvH01', NULL, NULL, 126, NULL, NULL, 234642),
(280399, '3wlwC01', NULL, NULL, 117, NULL, NULL, 234642),
(280400, '4pubL01', NULL, NULL, 107, NULL, NULL, 234642),
(280401, '5t1dL01', NULL, NULL, 113, NULL, NULL, 234642),
(280402, '3tt3L01', NULL, NULL, 112, NULL, NULL, 234642),
(280403, '1a6zA02', NULL, NULL, 91, NULL, NULL, 234642),
(280404, '2i27O00', NULL, NULL, 121, NULL, NULL, 234642),
(280405, '2nziA03', NULL, NULL, 94, NULL, NULL, 234642),
(280406, '3wiiL01', NULL, NULL, 107, NULL, NULL, 234642),
(280407, '5wkoB01', NULL, NULL, 109, NULL, NULL, 234642),
(280408, '4ut7L00', NULL, NULL, 114, NULL, NULL, 234642),
(280409, '3bquD01', NULL, NULL, 122, NULL, NULL, 234642),
(280410, '4hbcL02', NULL, NULL, 100, NULL, NULL, 234642),
(280411, '4hbcL01', NULL, NULL, 110, NULL, NULL, 234642),
(280412, '4p49A02', NULL, NULL, 111, NULL, NULL, 234642),
(280413, '5d8jL01', NULL, NULL, 109, NULL, NULL, 234642),
(280414, '5djyB02', NULL, NULL, 110, NULL, NULL, 234642),
(280415, '4p49A01', NULL, NULL, 123, NULL, NULL, 234642),
(280416, '4lldA00', NULL, NULL, 111, NULL, NULL, 234642),
(280417, '2x7lA02', NULL, NULL, 114, NULL, NULL, 234642),
(280418, '5w05L01', NULL, NULL, 113, NULL, NULL, 234642),
(280419, '6eayL01', NULL, NULL, 108, NULL, NULL, 234642),
(280420, '3juyB02', NULL, NULL, 113, NULL, NULL, 234642),
(280421, '3v6oB01', NULL, NULL, 108, NULL, NULL, 234642),
(280422, '2d7tL00', NULL, NULL, 116, NULL, NULL, 234642),
(280423, '4uv7H01', NULL, NULL, 122, NULL, NULL, 234642),
(280424, '3nh7L01', NULL, NULL, 109, NULL, NULL, 234642),
(280425, '2qbwA02', NULL, NULL, 92, NULL, NULL, 234642),
(280426, '2a38A02', NULL, NULL, 96, NULL, NULL, 234642),
(280427, '4g80C01', NULL, NULL, 124, NULL, NULL, 234642),
(280428, '5v7pD00', NULL, NULL, 95, NULL, NULL, 234642),
(280429, '1wk0A01', NULL, NULL, 119, NULL, NULL, 234642),
(280430, '5t4zB01', NULL, NULL, 111, NULL, NULL, 234642),
(280431, '4xnqB01', NULL, NULL, 123, NULL, NULL, 234642),
(280432, '2g5bA01', NULL, NULL, 113, NULL, NULL, 234642),
(280433, '3npsC01', NULL, NULL, 107, NULL, NULL, 234642),
(280434, '1wicA01', NULL, NULL, 122, NULL, NULL, 234642),
(280435, '5nluA00', NULL, NULL, 125, NULL, NULL, 234642),
(280436, '1fskH01', NULL, NULL, 105, NULL, NULL, 234642),
(280437, '4ei6A01', NULL, NULL, 114, NULL, NULL, 234642),
(280438, '1ol0A00', NULL, NULL, 121, NULL, NULL, 234642),
(280439, '4edwL01', NULL, NULL, 108, NULL, NULL, 234642),
(280440, '1ogaE02', NULL, NULL, 129, NULL, NULL, 234642),
(280441, '3gm8A05', NULL, NULL, 113, NULL, NULL, 234642),
(280442, '2ny1D01', NULL, NULL, 128, NULL, NULL, 234642),
(280443, '3gm8A04', NULL, NULL, 78, NULL, NULL, 234642),
(280444, '1ogaE01', NULL, NULL, 115, NULL, NULL, 234642),
(280445, '4cmhB01', NULL, NULL, 120, NULL, NULL, 234642),
(280446, '4wwkB01', NULL, NULL, 114, NULL, NULL, 234642),
(280447, '3gm8A02', NULL, NULL, 110, NULL, NULL, 234642),
(280448, '4r97C01', NULL, NULL, 119, NULL, NULL, 234642),
(280449, '1forL01', NULL, NULL, 107, NULL, NULL, 234642),
(280450, '5m2wA00', NULL, NULL, 125, NULL, NULL, 234642),
(280451, '4wiqA01', NULL, NULL, 114, NULL, NULL, 234642),
(280452, '2yrpA00', NULL, NULL, 114, NULL, NULL, 234642),
(280453, '3rzwA00', NULL, NULL, 95, NULL, NULL, 234642),
(280454, '4lhjB00', NULL, NULL, 120, NULL, NULL, 234642),
(280455, '1ow0A02', NULL, NULL, 113, NULL, NULL, 234642),
(280456, '1ow0A01', NULL, NULL, 101, NULL, NULL, 234642),
(280457, '3phqA01', NULL, NULL, 105, NULL, NULL, 234642),
(280458, '2zuxA01', NULL, NULL, 89, NULL, NULL, 234642),
(280459, '4rwyL01', NULL, NULL, 107, NULL, NULL, 234642),
(280460, '4n5uA00', NULL, NULL, 117, NULL, NULL, 234642),
(280461, '3qwoA01', NULL, NULL, 120, NULL, NULL, 234642),
(280462, '1v8hA00', NULL, NULL, 107, NULL, NULL, 234642),
(280463, '1sy6L01', NULL, NULL, 107, NULL, NULL, 234642),
(280464, '4xxdB01', NULL, NULL, 112, NULL, NULL, 234642),
(280465, '6avnL01', NULL, NULL, 105, NULL, NULL, 234642),
(280466, '1ghfL01', NULL, NULL, 107, NULL, NULL, 234642),
(280467, '1f4wL01', NULL, NULL, 110, NULL, NULL, 234642);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(280468, '4eneD01', NULL, NULL, 107, NULL, NULL, 234642),
(280469, '4rgoH01', NULL, NULL, 120, NULL, NULL, 234642),
(280470, '3o6fD01', NULL, NULL, 115, NULL, NULL, 234642),
(280471, '1adqA01', NULL, NULL, 100, NULL, NULL, 234642),
(280472, '4xakE01', NULL, NULL, 108, NULL, NULL, 234642),
(280473, '4wcyL01', NULL, NULL, 112, NULL, NULL, 234642),
(280474, '2jelH01', NULL, NULL, 118, NULL, NULL, 234642),
(280475, '2jelH02', NULL, NULL, 99, NULL, NULL, 234642),
(280476, '5dc4B00', NULL, NULL, 95, NULL, NULL, 234642),
(280477, '2xzqL02', NULL, NULL, 101, NULL, NULL, 234642),
(280478, '1igyA01', NULL, NULL, 107, NULL, NULL, 234642),
(280479, '3eo0B01', NULL, NULL, 120, NULL, NULL, 234642),
(280480, '5mp6Q01', NULL, NULL, 120, NULL, NULL, 234642),
(280481, '3qrfM02', NULL, NULL, 109, NULL, NULL, 234642),
(280482, '5sy8L01', NULL, NULL, 110, NULL, NULL, 234642),
(280483, '5jxaL01', NULL, NULL, 103, NULL, NULL, 234642),
(280484, '2pn5A04', NULL, NULL, 92, NULL, NULL, 234642),
(280485, '2pn5A07', NULL, NULL, 106, NULL, NULL, 234642),
(280486, '2eedA00', NULL, NULL, 101, NULL, NULL, 234642),
(280487, '1wt5C00', NULL, NULL, 122, NULL, NULL, 234642),
(280488, '2bhzA01', NULL, NULL, 96, NULL, NULL, 234642),
(280489, '3cmgA04', NULL, NULL, 92, NULL, NULL, 234642),
(280490, '5tbdD00', NULL, NULL, 114, NULL, NULL, 234642),
(280491, '4lmqI01', NULL, NULL, 107, NULL, NULL, 234642),
(280492, '4lgsB00', NULL, NULL, 129, NULL, NULL, 234642),
(280493, '4mnhC01', NULL, NULL, 120, NULL, NULL, 234642),
(280494, '3to4D01', NULL, NULL, 116, NULL, NULL, 234642),
(280495, '5t6pA01', NULL, NULL, 113, NULL, NULL, 234642),
(280496, '5mu0B01', NULL, NULL, 112, NULL, NULL, 234642),
(280497, '2h1pH01', NULL, NULL, 120, NULL, NULL, 234642),
(280498, '5tokD00', NULL, NULL, 131, NULL, NULL, 234642),
(280499, '5i1dB01', NULL, NULL, 119, NULL, NULL, 234642),
(280500, '4ffyH00', NULL, NULL, 130, NULL, NULL, 234642),
(280501, '2uudH00', NULL, NULL, 121, NULL, NULL, 234642),
(280502, '1hilA01', NULL, NULL, 114, NULL, NULL, 234642),
(280503, '5fgbE01', NULL, NULL, 127, NULL, NULL, 234642),
(280504, '5e0qA00', NULL, NULL, 128, NULL, NULL, 234642),
(280505, '5m2mD00', NULL, NULL, 129, NULL, NULL, 234642),
(280506, '5cp3A01', NULL, NULL, 113, NULL, NULL, 234642),
(280507, '5uixL01', NULL, NULL, 107, NULL, NULL, 234642),
(280508, '6dfvC01', NULL, NULL, 117, NULL, NULL, 234642),
(280509, '5dd1L02', NULL, NULL, 107, NULL, NULL, 234642),
(280510, '5dd1L01', NULL, NULL, 107, NULL, NULL, 234642),
(280511, '4qt5A01', NULL, NULL, 113, NULL, NULL, 234642),
(280512, '4ij3C01', NULL, NULL, 118, NULL, NULL, 234642),
(280513, '3r06B01', NULL, NULL, 116, NULL, NULL, 234642),
(280514, '1rmfL01', NULL, NULL, 113, NULL, NULL, 234642),
(280515, '2g2rA01', NULL, NULL, 113, NULL, NULL, 234642),
(280516, '4eq3A01', NULL, NULL, 107, NULL, NULL, 234642),
(280517, '2kkqA00', NULL, NULL, 116, NULL, NULL, 234642),
(280518, '5dwuB01', NULL, NULL, 92, NULL, NULL, 234642),
(280519, '4x7dC00', NULL, NULL, 126, NULL, NULL, 234642),
(280520, '5aamA02', NULL, NULL, 102, NULL, NULL, 234642),
(280521, '5aamA01', NULL, NULL, 131, NULL, NULL, 234642),
(280522, '1bfoB01', NULL, NULL, 121, NULL, NULL, 234642),
(280523, '1rowA00', NULL, NULL, 109, NULL, NULL, 234642),
(280524, '4jklA02', NULL, NULL, 95, NULL, NULL, 234642),
(280525, '1bwmA02', NULL, NULL, 118, NULL, NULL, 234642),
(280526, '5j57B00', NULL, NULL, 127, NULL, NULL, 234642),
(280527, '4j8rB01', NULL, NULL, 122, NULL, NULL, 234642),
(280528, '5c6pB00', NULL, NULL, 99, NULL, NULL, 234642),
(280529, '4eq3A02', NULL, NULL, 111, NULL, NULL, 234642),
(280530, '3ffcE01', NULL, NULL, 118, NULL, NULL, 234642),
(280531, '5d7kD01', NULL, NULL, 110, NULL, NULL, 234642),
(280532, '4zuuA02', NULL, NULL, 91, NULL, NULL, 234642),
(280533, '4rzcB00', NULL, NULL, 112, NULL, NULL, 234642),
(280534, '3gi9L01', NULL, NULL, 114, NULL, NULL, 234642),
(280535, '3zssA01', NULL, NULL, 113, NULL, NULL, 234642),
(280536, '5a16B01', NULL, NULL, 112, NULL, NULL, 234642),
(280537, '1qfwH00', NULL, NULL, 117, NULL, NULL, 234642),
(280538, '3grwH01', NULL, NULL, 127, NULL, NULL, 234642);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(280539, '5mx3A01', NULL, NULL, 121, NULL, NULL, 234642),
(280540, '1sbsL01', NULL, NULL, 114, NULL, NULL, 234642),
(280541, '4lvnC02', NULL, NULL, 98, NULL, NULL, 234642),
(280542, '1nfdA01', NULL, NULL, 112, NULL, NULL, 234642),
(280543, '4lvnC01', NULL, NULL, 120, NULL, NULL, 234642),
(280544, '3lpfA02', NULL, NULL, 93, NULL, NULL, 234642),
(280545, '1py9A00', NULL, NULL, 116, NULL, NULL, 234642),
(280546, '3kymB01', NULL, NULL, 119, NULL, NULL, 234642),
(280547, '2qqnH01', NULL, NULL, 123, NULL, NULL, 234642),
(280548, '5tkkL01', NULL, NULL, 107, NULL, NULL, 234642),
(280549, '3lohE04', NULL, NULL, 117, NULL, NULL, 234642),
(280550, '3sn6N00', NULL, NULL, 138, NULL, NULL, 234642),
(280551, '5ggtH01', NULL, NULL, 123, NULL, NULL, 234642),
(280552, '3baeL01', NULL, NULL, 113, NULL, NULL, 234642),
(280553, '3bgfC01', NULL, NULL, 108, NULL, NULL, 234642),
(280554, '4hxbH02', NULL, NULL, 100, NULL, NULL, 234642),
(280555, '5vaaB02', NULL, NULL, 110, NULL, NULL, 234642),
(280556, '6dc9L01', NULL, NULL, 109, NULL, NULL, 234642),
(280557, '4rgnE01', NULL, NULL, 114, NULL, NULL, 234642),
(280558, '3u7aA00', NULL, NULL, 110, NULL, NULL, 234642),
(280559, '3lohE05', NULL, NULL, 127, NULL, NULL, 234642),
(280560, '4hxbH01', NULL, NULL, 115, NULL, NULL, 234642),
(280561, '5o6vL01', NULL, NULL, 108, NULL, NULL, 234642),
(280562, '4f2mA01', NULL, NULL, 123, NULL, NULL, 234642),
(280563, '3i50L01', NULL, NULL, 107, NULL, NULL, 234642),
(280564, '2aepL01', NULL, NULL, 141, NULL, NULL, 234642),
(280565, '4leoB01', NULL, NULL, 113, NULL, NULL, 234642),
(280566, '6e3kD02', NULL, NULL, 113, NULL, NULL, 234642),
(280567, '5nigB02', NULL, NULL, 107, NULL, NULL, 234642),
(280568, '5j1tC00', NULL, NULL, 123, NULL, NULL, 234642),
(280569, '3vi3E01', NULL, NULL, 113, NULL, NULL, 234642),
(280570, '1rhfA01', NULL, NULL, 97, NULL, NULL, 234642),
(280571, '5bv7H01', NULL, NULL, 126, NULL, NULL, 234642),
(280572, '2yd8A02', NULL, NULL, 113, NULL, NULL, 234642),
(280573, '1rhfA02', NULL, NULL, 85, NULL, NULL, 234642),
(280574, '5fcuL01', NULL, NULL, 112, NULL, NULL, 234642),
(280575, '5kvgH02', NULL, NULL, 103, NULL, NULL, 234642),
(280576, '6arqD03', NULL, NULL, 101, NULL, NULL, 234642),
(280577, '6arqD02', NULL, NULL, 97, NULL, NULL, 234642),
(280578, '5kvgH01', NULL, NULL, 116, NULL, NULL, 234642),
(280579, '3vg9B01', NULL, NULL, 108, NULL, NULL, 234642),
(280580, '1gjiA02', NULL, NULL, 94, NULL, NULL, 234642),
(280581, '4grmA01', NULL, NULL, 110, NULL, NULL, 234642),
(280582, '3mj8A02', NULL, NULL, 104, NULL, NULL, 234642),
(280583, '4kknA00', NULL, NULL, 133, NULL, NULL, 234642),
(280584, '1waaC00', NULL, NULL, 93, NULL, NULL, 234642),
(280585, '3qjfD01', NULL, NULL, 115, NULL, NULL, 234642),
(280586, '6b0gC01', NULL, NULL, 112, NULL, NULL, 234642),
(280587, '1pg7W02', NULL, NULL, 100, NULL, NULL, 234642),
(280588, '5l7xH01', NULL, NULL, 118, NULL, NULL, 234642),
(280589, '4m02A02', NULL, NULL, 88, NULL, NULL, 234642),
(280590, '4ozhE01', NULL, NULL, 109, NULL, NULL, 234642),
(280591, '4p2cH00', NULL, NULL, 128, NULL, NULL, 234642),
(280592, '5f96L01', NULL, NULL, 107, NULL, NULL, 234642),
(280593, '1it9L01', NULL, NULL, 112, NULL, NULL, 234642),
(280594, '4weuD00', NULL, NULL, 127, NULL, NULL, 234642),
(280595, '3ujjH01', NULL, NULL, 124, NULL, NULL, 234642),
(280596, '4imkA01', NULL, NULL, 129, NULL, NULL, 234642),
(280597, '6jepI01', NULL, NULL, 112, NULL, NULL, 234642),
(280598, '2ibgA02', NULL, NULL, 102, NULL, NULL, 234642),
(280599, '4yr6A01', NULL, NULL, 122, NULL, NULL, 234642),
(280600, '3zyiA02', NULL, NULL, 103, NULL, NULL, 234642),
(280601, '5bs0E01', NULL, NULL, 112, NULL, NULL, 234642),
(280602, '4mnqE01', NULL, NULL, 111, NULL, NULL, 234642),
(280603, '5h5zA02', NULL, NULL, 88, NULL, NULL, 234642),
(280604, '1e4xH01', NULL, NULL, 114, NULL, NULL, 234642),
(280605, '3lb6C01', NULL, NULL, 94, NULL, NULL, 234642),
(280606, '2q86C02', NULL, NULL, 83, NULL, NULL, 234642),
(280607, '3bp6B02', NULL, NULL, 99, NULL, NULL, 234642),
(280608, '4jo4H01', NULL, NULL, 130, NULL, NULL, 234642),
(280609, '6bliB01', NULL, NULL, 108, NULL, NULL, 234642);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(280610, '2enyA00', NULL, NULL, 104, NULL, NULL, 234642),
(280611, '4gq9H01', NULL, NULL, 118, NULL, NULL, 234642),
(280612, '1pkoA00', NULL, NULL, 139, NULL, NULL, 234642),
(280613, '2x5pA00', NULL, NULL, 121, NULL, NULL, 234642),
(280614, '1rzfH01', NULL, NULL, 131, NULL, NULL, 234642),
(280615, '4lajL00', NULL, NULL, 129, NULL, NULL, 234642),
(280616, '2gcyB01', NULL, NULL, 118, NULL, NULL, 234642),
(280617, '3lsoB02', NULL, NULL, 92, NULL, NULL, 234642),
(280618, '3revA01', NULL, NULL, 114, NULL, NULL, 234642),
(280619, '2x9xA03', NULL, NULL, 122, NULL, NULL, 234642),
(280620, '3butA00', NULL, NULL, 136, NULL, NULL, 234642),
(280621, '4yo0A02', NULL, NULL, 98, NULL, NULL, 234642),
(280622, '4yo0A01', NULL, NULL, 117, NULL, NULL, 234642),
(280623, '1mqkL00', NULL, NULL, 120, NULL, NULL, 234642),
(280624, '5n7eA00', NULL, NULL, 95, NULL, NULL, 234642),
(280625, '3wsqH01', NULL, NULL, 118, NULL, NULL, 234642),
(280626, '4i13B00', NULL, NULL, 133, NULL, NULL, 234642),
(280627, '4fzeH01', NULL, NULL, 125, NULL, NULL, 234642),
(280628, '5lqbH01', NULL, NULL, 121, NULL, NULL, 234642),
(280629, '5f44C01', NULL, NULL, 148, NULL, NULL, 234642),
(280630, '2id5D02', NULL, NULL, 95, NULL, NULL, 234642),
(280631, '4y5xH00', NULL, NULL, 116, NULL, NULL, 234642),
(280632, '2j6eH01', NULL, NULL, 134, NULL, NULL, 234642),
(280633, '5m6iA01', NULL, NULL, 113, NULL, NULL, 234642),
(280634, '4eneE01', NULL, NULL, 121, NULL, NULL, 234642),
(280635, '5hi4D01', NULL, NULL, 111, NULL, NULL, 234642),
(280636, '1u9kA00', NULL, NULL, 114, NULL, NULL, 234642),
(280637, '1f11B01', NULL, NULL, 119, NULL, NULL, 234642),
(280638, '1bvkA00', NULL, NULL, 108, NULL, NULL, 234642),
(280639, '3mujA01', NULL, NULL, 92, NULL, NULL, 234642),
(280640, '1eo8H01', NULL, NULL, 118, NULL, NULL, 234642),
(280641, '2crzA00', NULL, NULL, 110, NULL, NULL, 234642),
(280642, '2d7nA01', NULL, NULL, 77, NULL, NULL, 234642),
(280643, '3sobH01', NULL, NULL, 126, NULL, NULL, 234642),
(280644, '3vmnA01', NULL, NULL, 115, NULL, NULL, 234642),
(280645, '1ct8B01', NULL, NULL, 118, NULL, NULL, 234642),
(280646, '3w9eB01', NULL, NULL, 108, NULL, NULL, 234642),
(280647, '2z35B00', NULL, NULL, 111, NULL, NULL, 234642),
(280648, '4bh8A01', NULL, NULL, 107, NULL, NULL, 234642),
(280649, '3lexA01', NULL, NULL, 116, NULL, NULL, 234642),
(280650, '4gagL01', NULL, NULL, 112, NULL, NULL, 234642),
(280651, '6funA01', NULL, NULL, 112, NULL, NULL, 234642),
(280652, '6n35L01', NULL, NULL, 107, NULL, NULL, 234642),
(280653, '2pndA00', NULL, NULL, 119, NULL, NULL, 234642),
(280654, '1neuA00', NULL, NULL, 124, NULL, NULL, 234642),
(280655, '1hxmA01', NULL, NULL, 121, NULL, NULL, 234642),
(280656, '3qg6B01', NULL, NULL, 113, NULL, NULL, 234642),
(280657, '3khqA00', NULL, NULL, 100, NULL, NULL, 234642),
(280658, '1bd2E01', NULL, NULL, 115, NULL, NULL, 234642),
(280659, '5f7eH01', NULL, NULL, 119, NULL, NULL, 234642),
(280660, '4xnzE01', NULL, NULL, 131, NULL, NULL, 234642),
(280661, '4al8H01', NULL, NULL, 117, NULL, NULL, 234642),
(280662, '4md5A02', NULL, NULL, 108, NULL, NULL, 234642),
(280663, '6axlB01', NULL, NULL, 108, NULL, NULL, 234642),
(280664, '1ae6H01', NULL, NULL, 121, NULL, NULL, 234642),
(280665, '5dupH01', NULL, NULL, 128, NULL, NULL, 234642),
(280666, '6mtmD01', NULL, NULL, 110, NULL, NULL, 234642),
(280667, '3n85H01', NULL, NULL, 117, NULL, NULL, 234642),
(280668, '4jy6B01', NULL, NULL, 132, NULL, NULL, 234642),
(280669, '1nezH00', NULL, NULL, 128, NULL, NULL, 234642),
(280670, '5ggqH01', NULL, NULL, 113, NULL, NULL, 234642),
(280671, '1mujA02', NULL, NULL, 100, NULL, NULL, 234642),
(280672, '2ipuG01', NULL, NULL, 123, NULL, NULL, 234642),
(280673, '5iblC01', NULL, NULL, 125, NULL, NULL, 234642),
(280674, '3vxtA01', NULL, NULL, 111, NULL, NULL, 234642),
(280675, '3zhdA00', NULL, NULL, 127, NULL, NULL, 234642),
(280676, '1a3qA02', NULL, NULL, 98, NULL, NULL, 234642),
(280677, '3sknB01', NULL, NULL, 115, NULL, NULL, 234642),
(280678, '3f7qA01', NULL, NULL, 95, NULL, NULL, 234642),
(280679, '1p5vA01', NULL, NULL, 132, NULL, NULL, 234642),
(280680, '5w1kC01', NULL, NULL, 108, NULL, NULL, 234642);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(280681, '4ak1A04', NULL, NULL, 91, NULL, NULL, 234642),
(280682, '5vxzC00', NULL, NULL, 102, NULL, NULL, 234642),
(280683, '1i7zA01', NULL, NULL, 113, NULL, NULL, 234642),
(280684, '4r6uA03', NULL, NULL, 109, NULL, NULL, 234642),
(280685, '4r6uA02', NULL, NULL, 95, NULL, NULL, 234642),
(280686, '1iqdB01', NULL, NULL, 117, NULL, NULL, 234642),
(280687, '3hr5B01', NULL, NULL, 117, NULL, NULL, 234642),
(280688, '4ptuA01', NULL, NULL, 111, NULL, NULL, 234642),
(280689, '3he7D01', NULL, NULL, 111, NULL, NULL, 234642),
(280690, '4j4pC01', NULL, NULL, 127, NULL, NULL, 234642),
(280691, '1c12A01', NULL, NULL, 107, NULL, NULL, 234642),
(280692, '6nnfU00', NULL, NULL, 126, NULL, NULL, 234642),
(280693, '5occL01', NULL, NULL, 112, NULL, NULL, 234642),
(280694, '4xcfL01', NULL, NULL, 109, NULL, NULL, 234642),
(280695, '5cckH01', NULL, NULL, 128, NULL, NULL, 234642),
(280696, '2vxtH01', NULL, NULL, 113, NULL, NULL, 234642),
(280697, '5nbwB01', NULL, NULL, 114, NULL, NULL, 234642),
(280698, '4h8wL01', NULL, NULL, 112, NULL, NULL, 234642),
(280699, '2ic2A00', NULL, NULL, 115, NULL, NULL, 234642),
(280700, '2fboJ02', NULL, NULL, 113, NULL, NULL, 234642),
(280701, '4cmmA01', NULL, NULL, 123, NULL, NULL, 234642),
(280702, '6bkbL01', NULL, NULL, 108, NULL, NULL, 234642),
(280703, '3tjeH01', NULL, NULL, 132, NULL, NULL, 234642),
(280704, '4laqH00', NULL, NULL, 104, NULL, NULL, 234642),
(280705, '1yjdL01', NULL, NULL, 108, NULL, NULL, 234642),
(280706, '5ifaL01', NULL, NULL, 109, NULL, NULL, 234642),
(280707, '4dgvH01', NULL, NULL, 123, NULL, NULL, 234642),
(280708, '4s1rH01', NULL, NULL, 132, NULL, NULL, 234642),
(280709, '5eziH01', NULL, NULL, 120, NULL, NULL, 234642),
(280710, '4irzH01', NULL, NULL, 123, NULL, NULL, 234642),
(280711, '6blqA02', NULL, NULL, 100, NULL, NULL, 234642),
(280712, '3q6gL01', NULL, NULL, 108, NULL, NULL, 234642),
(280713, '5mp6H01', NULL, NULL, 126, NULL, NULL, 234642),
(280714, '3q6gL02', NULL, NULL, 101, NULL, NULL, 234642),
(280715, '4z5rY00', NULL, NULL, 110, NULL, NULL, 234642),
(280716, '4p9mL01', NULL, NULL, 108, NULL, NULL, 234642),
(280717, '2ds4A01', NULL, NULL, 105, NULL, NULL, 234642),
(280718, '5d1qA01', NULL, NULL, 107, NULL, NULL, 234642),
(280719, '1f2xK00', NULL, NULL, 135, NULL, NULL, 234642),
(280720, '2brrX01', NULL, NULL, 109, NULL, NULL, 234642),
(280721, '5cezH01', NULL, NULL, 132, NULL, NULL, 234642),
(280722, '2nr6C01', NULL, NULL, 108, NULL, NULL, 234642),
(280723, '6c98A02', NULL, NULL, 91, NULL, NULL, 234642),
(280724, '2dleA01', NULL, NULL, 86, NULL, NULL, 234642),
(280725, '1h0dA01', NULL, NULL, 112, NULL, NULL, 234642),
(280726, '4x9bA02', NULL, NULL, 107, NULL, NULL, 234642),
(280727, '5tf1H01', NULL, NULL, 119, NULL, NULL, 234642),
(280728, '4ydiH01', NULL, NULL, 122, NULL, NULL, 234642),
(280729, '4ozfG01', NULL, NULL, 108, NULL, NULL, 234642),
(280730, '2nw2B01', NULL, NULL, 114, NULL, NULL, 234642),
(280731, '4ofpB02', NULL, NULL, 107, NULL, NULL, 234642),
(280732, '3vxmE01', NULL, NULL, 115, NULL, NULL, 234642),
(280733, '6dfqE01', NULL, NULL, 116, NULL, NULL, 234642),
(280734, '3cfdB01', NULL, NULL, 120, NULL, NULL, 234642),
(280735, '4ocmC00', NULL, NULL, 133, NULL, NULL, 234642),
(280736, '2yk1L01', NULL, NULL, 111, NULL, NULL, 234642),
(280737, '6mg9A00', NULL, NULL, 102, NULL, NULL, 234642),
(280738, '3esvG01', NULL, NULL, 136, NULL, NULL, 234642),
(280739, '3qrgH01', NULL, NULL, 120, NULL, NULL, 234642),
(280740, '4jhaL01', NULL, NULL, 107, NULL, NULL, 234642),
(280741, '4ye4H01', NULL, NULL, 127, NULL, NULL, 234642),
(280742, '1jguH01', NULL, NULL, 118, NULL, NULL, 234642),
(280743, '4r8wL00', NULL, NULL, 110, NULL, NULL, 234642),
(280744, '4nzjA01', NULL, NULL, 94, NULL, NULL, 234642),
(280745, '3p0yH01', NULL, NULL, 121, NULL, NULL, 234642),
(280746, '3tyfB01', NULL, NULL, 120, NULL, NULL, 234642),
(280747, '5w59B01', NULL, NULL, 110, NULL, NULL, 234642),
(280748, '5w59B02', NULL, NULL, 116, NULL, NULL, 234642),
(280749, '3b83C00', NULL, NULL, 100, NULL, NULL, 234642),
(280750, '6hyfC00', NULL, NULL, 91, NULL, NULL, 234642),
(280751, '1bf2A01', NULL, NULL, 162, NULL, NULL, 234642);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(280752, '5t6zG01', NULL, NULL, 99, NULL, NULL, 234642),
(280753, '4e41E01', NULL, NULL, 110, NULL, NULL, 234642),
(280754, '6bf4C01', NULL, NULL, 112, NULL, NULL, 234642),
(280755, '1v5jA00', NULL, NULL, 108, NULL, NULL, 234642),
(280756, '5j3hD00', NULL, NULL, 118, NULL, NULL, 234642),
(280757, '3qjhB01', NULL, NULL, 114, NULL, NULL, 234642),
(280758, '1z3gH01', NULL, NULL, 115, NULL, NULL, 234642),
(280759, '4k55A00', NULL, NULL, 124, NULL, NULL, 234642),
(280760, '4dagH01', NULL, NULL, 122, NULL, NULL, 234642),
(280761, '3n9gL01', NULL, NULL, 113, NULL, NULL, 234642),
(280762, '6ieaL01', NULL, NULL, 116, NULL, NULL, 234642),
(280763, '4l1dC00', NULL, NULL, 127, NULL, NULL, 234642),
(280764, '5m2jD00', NULL, NULL, 115, NULL, NULL, 234642),
(280765, '5bzwB01', NULL, NULL, 128, NULL, NULL, 234642),
(280766, '5gqbA01', NULL, NULL, 123, NULL, NULL, 234642),
(280767, '4h5sA00', NULL, NULL, 101, NULL, NULL, 234642),
(280768, '2hrpL01', NULL, NULL, 112, NULL, NULL, 234642),
(280769, '2j3sB01', NULL, NULL, 96, NULL, NULL, 234642),
(280770, '4olzL01', NULL, NULL, 108, NULL, NULL, 234642),
(280771, '1hcvA00', NULL, NULL, 117, NULL, NULL, 234642),
(280772, '3qumH01', NULL, NULL, 119, NULL, NULL, 234642),
(280773, '5a3iD01', NULL, NULL, 112, NULL, NULL, 234642),
(280774, '5l6qA00', NULL, NULL, 115, NULL, NULL, 234642),
(280775, '5iltH02', NULL, NULL, 102, NULL, NULL, 234642),
(280776, '5myoB02', NULL, NULL, 109, NULL, NULL, 234642),
(280777, '5myoB01', NULL, NULL, 119, NULL, NULL, 234642),
(280778, '5iltH01', NULL, NULL, 169, NULL, NULL, 234642),
(280779, '5z9sA03', NULL, NULL, 131, NULL, NULL, 234642),
(280780, '3g9aB00', NULL, NULL, 139, NULL, NULL, 234642),
(280781, '1lk2B00', NULL, NULL, 99, NULL, NULL, 234642),
(280782, '3fmgH01', NULL, NULL, 121, NULL, NULL, 234642),
(280783, '1uadC00', NULL, NULL, 99, NULL, NULL, 234642),
(280784, '1nc2B01', NULL, NULL, 119, NULL, NULL, 234642),
(280785, '6c74A00', NULL, NULL, 111, NULL, NULL, 234642),
(280786, '1ynlL01', NULL, NULL, 113, NULL, NULL, 234642),
(280787, '3fzuD01', NULL, NULL, 107, NULL, NULL, 234642),
(280788, '2l7jA00', NULL, NULL, 95, NULL, NULL, 234642),
(280789, '5tfsH01', NULL, NULL, 117, NULL, NULL, 234642),
(280790, '4ofyD01', NULL, NULL, 103, NULL, NULL, 234642),
(280791, '1tzhB01', NULL, NULL, 122, NULL, NULL, 234642),
(280792, '4ofyD03', NULL, NULL, 99, NULL, NULL, 234642),
(280793, '4ofyD02', NULL, NULL, 107, NULL, NULL, 234642),
(280794, '3bdyL01', NULL, NULL, 112, NULL, NULL, 234642),
(280795, '4dtgH01', NULL, NULL, 121, NULL, NULL, 234642),
(280796, '1yq2A02', NULL, NULL, 93, NULL, NULL, 234642),
(280797, '3qt2B03', NULL, NULL, 99, NULL, NULL, 234642),
(280798, '2j4wH01', NULL, NULL, 123, NULL, NULL, 234642),
(280799, '3u0tB01', NULL, NULL, 116, NULL, NULL, 234642),
(280800, '4y5vB00', NULL, NULL, 117, NULL, NULL, 234642),
(280801, '4i2xE03', NULL, NULL, 107, NULL, NULL, 234642),
(280802, '5i30H01', NULL, NULL, 117, NULL, NULL, 234642),
(280803, '4i2xE02', NULL, NULL, 105, NULL, NULL, 234642),
(280804, '3qxwC00', NULL, NULL, 126, NULL, NULL, 234642),
(280805, '1yq2A04', NULL, NULL, 115, NULL, NULL, 234642),
(280806, '2i24N00', NULL, NULL, 121, NULL, NULL, 234642),
(280807, '4yueH01', NULL, NULL, 127, NULL, NULL, 234642),
(280808, '4f37F01', NULL, NULL, 125, NULL, NULL, 234642),
(280809, '2eizA00', NULL, NULL, 107, NULL, NULL, 234642),
(280810, '6foeB01', NULL, NULL, 107, NULL, NULL, 234642),
(280811, '5uemL01', NULL, NULL, 110, NULL, NULL, 234642),
(280812, '3d2uA02', NULL, NULL, 92, NULL, NULL, 234642),
(280813, '5dscF01', NULL, NULL, 112, NULL, NULL, 234642),
(280814, '3l5xL01', NULL, NULL, 108, NULL, NULL, 234642),
(280815, '1s3kL01', NULL, NULL, 113, NULL, NULL, 234642),
(280816, '1hdmA02', NULL, NULL, 112, NULL, NULL, 234642),
(280817, '5jw5A01', NULL, NULL, 128, NULL, NULL, 234642),
(280818, '6ad0H00', NULL, NULL, 115, NULL, NULL, 234642),
(280819, '4rdqG01', NULL, NULL, 116, NULL, NULL, 234642),
(280820, '6nb5M01', NULL, NULL, 110, NULL, NULL, 234642),
(280821, '2db8A00', NULL, NULL, 110, NULL, NULL, 234642),
(280822, '5a2fA01', NULL, NULL, 106, NULL, NULL, 234642);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(280823, '6cuhA01', NULL, NULL, 112, NULL, NULL, 234642),
(280824, '5a2fA02', NULL, NULL, 112, NULL, NULL, 234642),
(280825, '3s88H01', NULL, NULL, 119, NULL, NULL, 234642),
(280826, '2w9dL01', NULL, NULL, 107, NULL, NULL, 234642),
(280827, '1bz7B01', NULL, NULL, 122, NULL, NULL, 234642),
(280828, '4uv4H01', NULL, NULL, 135, NULL, NULL, 234642),
(280829, '1nakL01', NULL, NULL, 113, NULL, NULL, 234642),
(280830, '5npjB02', NULL, NULL, 117, NULL, NULL, 234642),
(280831, '5dmyA05', NULL, NULL, 112, NULL, NULL, 234642),
(280832, '5dmyA02', NULL, NULL, 121, NULL, NULL, 234642),
(280833, '3g6jF01', NULL, NULL, 123, NULL, NULL, 234642),
(280834, '1rurH01', NULL, NULL, 119, NULL, NULL, 234642),
(280835, '4z7vH01', NULL, NULL, 115, NULL, NULL, 234642),
(280836, '4ogzB01', NULL, NULL, 94, NULL, NULL, 234642),
(280837, '4n68A00', NULL, NULL, 113, NULL, NULL, 234642),
(280838, '4nwuL01', NULL, NULL, 112, NULL, NULL, 234642),
(280839, '2x6mA00', NULL, NULL, 126, NULL, NULL, 234642),
(280840, '5f9oH01', NULL, NULL, 122, NULL, NULL, 234642),
(280841, '3w5mA01', NULL, NULL, 111, NULL, NULL, 234642),
(280842, '4ht1H01', NULL, NULL, 120, NULL, NULL, 234642),
(280843, '1kgcE01', NULL, NULL, 113, NULL, NULL, 234642),
(280844, '4lfhG02', NULL, NULL, 124, NULL, NULL, 234642),
(280845, '6fr7A01', NULL, NULL, 115, NULL, NULL, 234642),
(280846, '3n06B01', NULL, NULL, 101, NULL, NULL, 234642),
(280847, '4lfhG01', NULL, NULL, 127, NULL, NULL, 234642),
(280848, '5tezJ01', NULL, NULL, 114, NULL, NULL, 234642),
(280849, '5dxwA00', NULL, NULL, 130, NULL, NULL, 234642),
(280850, '3n06B02', NULL, NULL, 109, NULL, NULL, 234642),
(280851, '4z0bH01', NULL, NULL, 123, NULL, NULL, 234642),
(280852, '3s6cA03', NULL, NULL, 101, NULL, NULL, 234642),
(280853, '4z0bH02', NULL, NULL, 99, NULL, NULL, 234642),
(280854, '2ed9A01', NULL, NULL, 105, NULL, NULL, 234642),
(280855, '1gigH01', NULL, NULL, 123, NULL, NULL, 234642),
(280856, '5fhaL01', NULL, NULL, 107, NULL, NULL, 234642),
(280857, '2xzcL01', NULL, NULL, 110, NULL, NULL, 234642),
(280858, '4rqqB01', NULL, NULL, 141, NULL, NULL, 234642),
(280859, '3wfdH01', NULL, NULL, 124, NULL, NULL, 234642),
(280860, '6db7M01', NULL, NULL, 109, NULL, NULL, 234642),
(280861, '3g6aB01', NULL, NULL, 122, NULL, NULL, 234642),
(280862, '4xtrC01', NULL, NULL, 122, NULL, NULL, 234642),
(280863, '4hpoL01', NULL, NULL, 111, NULL, NULL, 234642),
(280864, '5f1kC00', NULL, NULL, 124, NULL, NULL, 234642),
(280865, '1bbjB01', NULL, NULL, 114, NULL, NULL, 234642),
(280866, '1bz7A01', NULL, NULL, 107, NULL, NULL, 234642),
(280867, '4rgnD01', NULL, NULL, 119, NULL, NULL, 234642),
(280868, '5b6fB01', NULL, NULL, 117, NULL, NULL, 234642),
(280869, '3sdyL01', NULL, NULL, 110, NULL, NULL, 234642),
(280870, '5e2wH01', NULL, NULL, 113, NULL, NULL, 234642),
(280871, '3ubxG01', NULL, NULL, 121, NULL, NULL, 234642),
(280872, '1k3iA03', NULL, NULL, 97, NULL, NULL, 234642),
(280873, '3rkdC01', NULL, NULL, 108, NULL, NULL, 234642),
(280874, '3bquC01', NULL, NULL, 104, NULL, NULL, 234642),
(280875, '4hepG00', NULL, NULL, 131, NULL, NULL, 234642),
(280876, '3mnzB01', NULL, NULL, 114, NULL, NULL, 234642),
(280877, '4qrrE01', NULL, NULL, 113, NULL, NULL, 234642),
(280878, '4ut6H00', NULL, NULL, 131, NULL, NULL, 234642),
(280879, '5dmgC01', NULL, NULL, 108, NULL, NULL, 234642),
(280880, '6bx5C00', NULL, NULL, 97, NULL, NULL, 234642),
(280881, '4f33B01', NULL, NULL, 119, NULL, NULL, 234642),
(280882, '2mqcA00', NULL, NULL, 105, NULL, NULL, 234642),
(280883, '4hafA01', NULL, NULL, 113, NULL, NULL, 234642),
(280884, '5drnB01', NULL, NULL, 112, NULL, NULL, 234642),
(280885, '3utoA04', NULL, NULL, 92, NULL, NULL, 234642),
(280886, '4toyH01', NULL, NULL, 131, NULL, NULL, 234642),
(280887, '1d5iL01', NULL, NULL, 108, NULL, NULL, 234642),
(280888, '3r0mA00', NULL, NULL, 127, NULL, NULL, 234642),
(280889, '3eifA05', NULL, NULL, 102, NULL, NULL, 234642),
(280890, '1lk2A02', NULL, NULL, 93, NULL, NULL, 234642),
(280891, '5ucbH02', NULL, NULL, 100, NULL, NULL, 234642),
(280892, '6gffK01', NULL, NULL, 108, NULL, NULL, 234642),
(280893, '5nmdA01', NULL, NULL, 110, NULL, NULL, 234642);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(280894, '6medB01', NULL, NULL, 107, NULL, NULL, 234642),
(280895, '5w4lE01', NULL, NULL, 109, NULL, NULL, 234642),
(280896, '4toyH02', NULL, NULL, 112, NULL, NULL, 234642),
(280897, '5e24E03', NULL, NULL, 94, NULL, NULL, 234642),
(280898, '4wnqA01', NULL, NULL, 113, NULL, NULL, 234642),
(280899, '2vr5B01', NULL, NULL, 153, NULL, NULL, 234642),
(280900, '1wgoA01', NULL, NULL, 99, NULL, NULL, 234642),
(280901, '5w6aA02', NULL, NULL, 91, NULL, NULL, 234642),
(280902, '5x83B01', NULL, NULL, 101, NULL, NULL, 234642),
(280903, '5x83B02', NULL, NULL, 106, NULL, NULL, 234642),
(280904, '3k3qA00', NULL, NULL, 151, NULL, NULL, 234642),
(280905, '3se9L01', NULL, NULL, 102, NULL, NULL, 234642),
(280906, '4ww1B01', NULL, NULL, 114, NULL, NULL, 234642),
(280907, '5f72S01', NULL, NULL, 140, NULL, NULL, 234642),
(280908, '2v7hB01', NULL, NULL, 119, NULL, NULL, 234642),
(280909, '4g8fA01', NULL, NULL, 110, NULL, NULL, 234642),
(280910, '5e6iH01', NULL, NULL, 114, NULL, NULL, 234642),
(280911, '2fbjL01', NULL, NULL, 107, NULL, NULL, 234642),
(280912, '5f7fA00', NULL, NULL, 113, NULL, NULL, 234642),
(280913, '1b4rA00', NULL, NULL, 80, NULL, NULL, 234642),
(280914, '3l9rA02', NULL, NULL, 101, NULL, NULL, 234642),
(280915, '5i0zA00', NULL, NULL, 121, NULL, NULL, 234642),
(280916, '3uc0H01', NULL, NULL, 123, NULL, NULL, 234642),
(280917, '1ncaL01', NULL, NULL, 108, NULL, NULL, 234642),
(280918, '4i0kA01', NULL, NULL, 106, NULL, NULL, 234642),
(280919, '5oc7C00', NULL, NULL, 92, NULL, NULL, 234642),
(280920, '5wlgD01', NULL, NULL, 104, NULL, NULL, 234642),
(280921, '4i0kA02', NULL, NULL, 100, NULL, NULL, 234642),
(280922, '1g0xA02', NULL, NULL, 102, NULL, NULL, 234642),
(280923, '3qehH01', NULL, NULL, 111, NULL, NULL, 234642),
(280924, '1nsnL01', NULL, NULL, 112, NULL, NULL, 234642),
(280925, '3ncyS01', NULL, NULL, 107, NULL, NULL, 234642),
(280926, '1cd9B02', NULL, NULL, 107, NULL, NULL, 234642),
(280927, '5eulV00', NULL, NULL, 131, NULL, NULL, 234642),
(280928, '1u3zA00', NULL, NULL, 106, NULL, NULL, 234642),
(280929, '1nmbL00', NULL, NULL, 109, NULL, NULL, 234642),
(280930, '6cbvL01', NULL, NULL, 110, NULL, NULL, 234642),
(280931, '1axsA01', NULL, NULL, 108, NULL, NULL, 234642),
(280932, '3p30L01', NULL, NULL, 112, NULL, NULL, 234642),
(280933, '1f58H01', NULL, NULL, 126, NULL, NULL, 234642),
(280934, '3pp4H01', NULL, NULL, 119, NULL, NULL, 234642),
(280935, '1d9kB00', NULL, NULL, 112, NULL, NULL, 234642),
(280936, '2dbjA01', NULL, NULL, 109, NULL, NULL, 234642),
(280937, '4i0pH02', NULL, NULL, 101, NULL, NULL, 234642),
(280938, '1wj3A01', NULL, NULL, 93, NULL, NULL, 234642),
(280939, '1epfA01', NULL, NULL, 98, NULL, NULL, 234642),
(280940, '1epfA02', NULL, NULL, 93, NULL, NULL, 234642),
(280941, '5g5rB00', NULL, NULL, 123, NULL, NULL, 234642),
(280942, '5d1qB01', NULL, NULL, 119, NULL, NULL, 234642),
(280943, '4ztpH02', NULL, NULL, 99, NULL, NULL, 234642),
(280944, '3gizH01', NULL, NULL, 122, NULL, NULL, 234642),
(280945, '4grwE00', NULL, NULL, 125, NULL, NULL, 234642),
(280946, '2gysA01', NULL, NULL, 95, NULL, NULL, 234642),
(280947, '4n1hB00', NULL, NULL, 133, NULL, NULL, 234642),
(280948, '5ihbA02', NULL, NULL, 99, NULL, NULL, 234642),
(280949, '2gysA03', NULL, NULL, 91, NULL, NULL, 234642),
(280950, '2gysA02', NULL, NULL, 107, NULL, NULL, 234642),
(280951, '4ztpH01', NULL, NULL, 124, NULL, NULL, 234642),
(280952, '1cf8L01', NULL, NULL, 109, NULL, NULL, 234642),
(280953, '1emtL01', NULL, NULL, 108, NULL, NULL, 234642),
(280954, '4fomA02', NULL, NULL, 99, NULL, NULL, 234642),
(280955, '2dmbA00', NULL, NULL, 124, NULL, NULL, 234642),
(280956, '4fomA03', NULL, NULL, 98, NULL, NULL, 234642),
(280957, '2cr3A01', NULL, NULL, 95, NULL, NULL, 234642),
(280958, '2j88H01', NULL, NULL, 117, NULL, NULL, 234642),
(280959, '3nzhH01', NULL, NULL, 117, NULL, NULL, 234642),
(280960, '2j88H02', NULL, NULL, 74, NULL, NULL, 234642),
(280961, '3gjfH01', NULL, NULL, 119, NULL, NULL, 234642),
(280962, '1y6kR01', NULL, NULL, 103, NULL, NULL, 234642),
(280963, '5i1kH01', NULL, NULL, 119, NULL, NULL, 234642),
(280964, '1wzlA01', NULL, NULL, 121, NULL, NULL, 234642);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(280965, '1y6kR02', NULL, NULL, 111, NULL, NULL, 234642),
(280966, '4kfzC00', NULL, NULL, 129, NULL, NULL, 234642),
(280967, '4hfuH01', NULL, NULL, 123, NULL, NULL, 234642),
(280968, '4cbpA01', NULL, NULL, 120, NULL, NULL, 234642),
(280969, '3fo2A01', NULL, NULL, 111, NULL, NULL, 234642),
(280970, '1wisA01', NULL, NULL, 101, NULL, NULL, 234642),
(280971, '3u9pH01', NULL, NULL, 119, NULL, NULL, 234642),
(280972, '5durD01', NULL, NULL, 113, NULL, NULL, 234642),
(280973, '6aq7H02', NULL, NULL, 98, NULL, NULL, 234642),
(280974, '3v0wL02', NULL, NULL, 104, NULL, NULL, 234642),
(280975, '1rzgC01', NULL, NULL, 126, NULL, NULL, 234642),
(280976, '3v0wL01', NULL, NULL, 108, NULL, NULL, 234642),
(280977, '1f3dL01', NULL, NULL, 112, NULL, NULL, 234642),
(280978, '1dqdL01', NULL, NULL, 114, NULL, NULL, 234642),
(280979, '6anaL01', NULL, NULL, 112, NULL, NULL, 234642),
(280980, '6oe4C01', NULL, NULL, 107, NULL, NULL, 234642),
(280981, '3ffcD01', NULL, NULL, 112, NULL, NULL, 234642),
(280982, '4p4kD01', NULL, NULL, 113, NULL, NULL, 234642),
(280983, '3eo0A01', NULL, NULL, 109, NULL, NULL, 234642),
(280984, '4ocxL01', NULL, NULL, 113, NULL, NULL, 234642),
(280985, '1i1cA01', NULL, NULL, 99, NULL, NULL, 234642),
(280986, '2l0dA00', NULL, NULL, 114, NULL, NULL, 234642),
(280987, '1i1cA02', NULL, NULL, 106, NULL, NULL, 234642),
(280988, '2eo1A00', NULL, NULL, 102, NULL, NULL, 234642),
(280989, '6nrrA00', NULL, NULL, 114, NULL, NULL, 234642),
(280990, '4kteL01', NULL, NULL, 116, NULL, NULL, 234642),
(280991, '2r56H01', NULL, NULL, 121, NULL, NULL, 234642),
(280992, '4y1aE01', NULL, NULL, 114, NULL, NULL, 234642),
(280993, '2hmiC02', NULL, NULL, 104, NULL, NULL, 234642),
(280994, '5vobL01', NULL, NULL, 109, NULL, NULL, 234642),
(280995, '1igyB01', NULL, NULL, 114, NULL, NULL, 234642),
(280996, '2zg2A02', NULL, NULL, 91, NULL, NULL, 234642),
(280997, '4q0xL01', NULL, NULL, 113, NULL, NULL, 234642),
(280998, '2or8A00', NULL, NULL, 116, NULL, NULL, 234642),
(280999, '4od2B01', NULL, NULL, 121, NULL, NULL, 234642),
(281000, '6fbjL01', NULL, NULL, 112, NULL, NULL, 234642),
(281001, '3rjdA01', NULL, NULL, 81, NULL, NULL, 234642),
(281002, '4ywgL01', NULL, NULL, 105, NULL, NULL, 234642),
(281003, '4amkH01', NULL, NULL, 117, NULL, NULL, 234642),
(281004, '3u1sH01', NULL, NULL, 140, NULL, NULL, 234642),
(281005, '5kvdH01', NULL, NULL, 120, NULL, NULL, 234642),
(281006, '3iflL01', NULL, NULL, 113, NULL, NULL, 234642),
(281007, '2atpD00', NULL, NULL, 115, NULL, NULL, 234642),
(281008, '1vgeL01', NULL, NULL, 108, NULL, NULL, 234642),
(281009, '1jfqL01', NULL, NULL, 107, NULL, NULL, 234642),
(281010, '5jueH01', NULL, NULL, 122, NULL, NULL, 234642),
(281011, '1a6tA01', NULL, NULL, 107, NULL, NULL, 234642),
(281012, '4udtB01', NULL, NULL, 114, NULL, NULL, 234642),
(281013, '5fehA01', NULL, NULL, 108, NULL, NULL, 234642),
(281014, '5di8B02', NULL, NULL, 110, NULL, NULL, 234642),
(281015, '4m5yL01', NULL, NULL, 109, NULL, NULL, 234642),
(281016, '4np4H01', NULL, NULL, 119, NULL, NULL, 234642),
(281017, '4bfeA02', NULL, NULL, 81, NULL, NULL, 234642),
(281018, '4jfhD01', NULL, NULL, 109, NULL, NULL, 234642),
(281019, '5uknL01', NULL, NULL, 111, NULL, NULL, 234642),
(281020, '5uknL02', NULL, NULL, 105, NULL, NULL, 234642),
(281021, '1ibgL01', NULL, NULL, 111, NULL, NULL, 234642),
(281022, '4qo1A00', NULL, NULL, 129, NULL, NULL, 234642),
(281023, '4s11A00', NULL, NULL, 130, NULL, NULL, 234642),
(281024, '5ja8B00', NULL, NULL, 127, NULL, NULL, 234642),
(281025, '4jclA04', NULL, NULL, 103, NULL, NULL, 234642),
(281026, '5o45A00', NULL, NULL, 129, NULL, NULL, 234642),
(281027, '4jclA03', NULL, NULL, 87, NULL, NULL, 234642),
(281028, '2bmkA01', NULL, NULL, 107, NULL, NULL, 234642),
(281029, '5ob5L01', NULL, NULL, 108, NULL, NULL, 234642),
(281030, '1ct8A01', NULL, NULL, 108, NULL, NULL, 234642),
(281031, '4ldeB00', NULL, NULL, 120, NULL, NULL, 234642),
(281032, '3knbB00', NULL, NULL, 107, NULL, NULL, 234642),
(281033, '4iihB04', NULL, NULL, 107, NULL, NULL, 234642),
(281034, '4ij3B01', NULL, NULL, 108, NULL, NULL, 234642),
(281035, '5d2nC01', NULL, NULL, 109, NULL, NULL, 234642);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(281036, '4kucH01', NULL, NULL, 117, NULL, NULL, 234642),
(281037, '5ea0L01', NULL, NULL, 113, NULL, NULL, 234642),
(281038, '2laaA00', NULL, NULL, 104, NULL, NULL, 234642),
(281039, '1q0xH01', NULL, NULL, 119, NULL, NULL, 234642),
(281040, '2c4fT00', NULL, NULL, 75, NULL, NULL, 234642),
(281041, '1q0xH02', NULL, NULL, 101, NULL, NULL, 234642),
(281042, '3hmwH01', NULL, NULL, 119, NULL, NULL, 234642),
(281043, '5mo9H01', NULL, NULL, 116, NULL, NULL, 234642),
(281044, '5tdpB02', NULL, NULL, 103, NULL, NULL, 234642),
(281045, '5b22B02', NULL, NULL, 98, NULL, NULL, 234642),
(281046, '1n0xL01', NULL, NULL, 108, NULL, NULL, 234642),
(281047, '1a0qL01', NULL, NULL, 106, NULL, NULL, 234642),
(281048, '3uyoD00', NULL, NULL, 95, NULL, NULL, 234642),
(281049, '5v7uL01', NULL, NULL, 112, NULL, NULL, 234642),
(281050, '2v9tA00', NULL, NULL, 117, NULL, NULL, 234642),
(281051, '3o6kL01', NULL, NULL, 113, NULL, NULL, 234642),
(281052, '4r97B01', NULL, NULL, 108, NULL, NULL, 234642),
(281053, '1ay1L01', NULL, NULL, 107, NULL, NULL, 234642),
(281054, '1kv3A01', NULL, NULL, 147, NULL, NULL, 234642),
(281055, '3mbeC01', NULL, NULL, 110, NULL, NULL, 234642),
(281056, '4dn3L01', NULL, NULL, 110, NULL, NULL, 234642),
(281057, '4odvH01', NULL, NULL, 123, NULL, NULL, 234642),
(281058, '4fa8A01', NULL, NULL, 105, NULL, NULL, 234642),
(281059, '3qwoB01', NULL, NULL, 107, NULL, NULL, 234642),
(281060, '1oaqH00', NULL, NULL, 121, NULL, NULL, 234642),
(281061, '4m1cC01', NULL, NULL, 128, NULL, NULL, 234642),
(281062, '4uinL01', NULL, NULL, 107, NULL, NULL, 234642),
(281063, '4ra0C02', NULL, NULL, 90, NULL, NULL, 234642),
(281064, '5d7kE01', NULL, NULL, 115, NULL, NULL, 234642),
(281065, '1nl0H01', NULL, NULL, 120, NULL, NULL, 234642),
(281066, '5jtwB02', NULL, NULL, 106, NULL, NULL, 234642),
(281067, '4rzcC00', NULL, NULL, 119, NULL, NULL, 234642),
(281068, '5h5zB00', NULL, NULL, 98, NULL, NULL, 234642),
(281069, '4yflF01', NULL, NULL, 125, NULL, NULL, 234642),
(281070, '4lvnB01', NULL, NULL, 109, NULL, NULL, 234642),
(281071, '6iuvD01', NULL, NULL, 111, NULL, NULL, 234642),
(281072, '2xtlA03', NULL, NULL, 121, NULL, NULL, 234642),
(281073, '3o4oC03', NULL, NULL, 116, NULL, NULL, 234642),
(281074, '1lo4H01', NULL, NULL, 118, NULL, NULL, 234642),
(281075, '3o4oC02', NULL, NULL, 107, NULL, NULL, 234642),
(281076, '3kymA01', NULL, NULL, 108, NULL, NULL, 234642),
(281077, '3o4oC01', NULL, NULL, 99, NULL, NULL, 234642),
(281078, '3i2cL01', NULL, NULL, 106, NULL, NULL, 234642),
(281079, '6c68A01', NULL, NULL, 114, NULL, NULL, 234642),
(281080, '4k3jH01', NULL, NULL, 119, NULL, NULL, 234642),
(281081, '5bo1H01', NULL, NULL, 116, NULL, NULL, 234642),
(281082, '3mlpA02', NULL, NULL, 145, NULL, NULL, 234642),
(281083, '3bgfB01', NULL, NULL, 121, NULL, NULL, 234642),
(281084, '1w72L01', NULL, NULL, 109, NULL, NULL, 234642),
(281085, '4leoA01', NULL, NULL, 120, NULL, NULL, 234642),
(281086, '4lriC01', NULL, NULL, 130, NULL, NULL, 234642),
(281087, '4gjtC00', NULL, NULL, 123, NULL, NULL, 234642),
(281088, '4cdgC00', NULL, NULL, 125, NULL, NULL, 234642),
(281089, '5llkA01', NULL, NULL, 113, NULL, NULL, 234642),
(281090, '6idgL01', NULL, NULL, 112, NULL, NULL, 234642),
(281091, '5nigA02', NULL, NULL, 108, NULL, NULL, 234642),
(281092, '4u6tA00', NULL, NULL, 86, NULL, NULL, 234642),
(281093, '1olzA03', NULL, NULL, 90, NULL, NULL, 234642),
(281094, '5tz2L01', NULL, NULL, 108, NULL, NULL, 234642),
(281095, '3v6oA02', NULL, NULL, 98, NULL, NULL, 234642),
(281096, '5i76B01', NULL, NULL, 118, NULL, NULL, 234642),
(281097, '4f9lC02', NULL, NULL, 108, NULL, NULL, 234642),
(281098, '2q8bL01', NULL, NULL, 108, NULL, NULL, 234642),
(281099, '2w1nA02', NULL, NULL, 83, NULL, NULL, 234642),
(281100, '5hvfB00', NULL, NULL, 119, NULL, NULL, 234642),
(281101, '3juyA01', NULL, NULL, 132, NULL, NULL, 234642),
(281102, '3og4B01', NULL, NULL, 106, NULL, NULL, 234642),
(281103, '2vuoA02', NULL, NULL, 106, NULL, NULL, 234642),
(281104, '2vuoA01', NULL, NULL, 100, NULL, NULL, 234642),
(281105, '4hhaB01', NULL, NULL, 125, NULL, NULL, 234642),
(281106, '1fh5L01', NULL, NULL, 108, NULL, NULL, 234642);
INSERT INTO "PUBLIC"."MODEL" VALUES
(281107, '4b7lA03', NULL, NULL, 100, NULL, NULL, 234642),
(281108, '3r06A01', NULL, NULL, 108, NULL, NULL, 234642),
(281109, '3r06A02', NULL, NULL, 105, NULL, NULL, 234642),
(281110, '3h42H01', NULL, NULL, 123, NULL, NULL, 234642),
(281111, '2ny1C01', NULL, NULL, 110, NULL, NULL, 234642),
(281112, '5e1hB00', NULL, NULL, 128, NULL, NULL, 234642),
(281113, '4lciL00', NULL, NULL, 117, NULL, NULL, 234642),
(281114, '5wl2B01', NULL, NULL, 111, NULL, NULL, 234642),
(281115, '3hc4H01', NULL, NULL, 116, NULL, NULL, 234642),
(281116, '5nq0B00', NULL, NULL, 99, NULL, NULL, 234642),
(281117, '5d7jB01', NULL, NULL, 116, NULL, NULL, 234642),
(281118, '2lu7A00', NULL, NULL, 84, NULL, NULL, 234642),
(281119, '1ikfL01', NULL, NULL, 108, NULL, NULL, 234642),
(281120, '3f62A00', NULL, NULL, 109, NULL, NULL, 234642),
(281121, '5d1zD01', NULL, NULL, 128, NULL, NULL, 234642),
(281122, '3b43A06', NULL, NULL, 95, NULL, NULL, 234642),
(281123, '1bfoA02', NULL, NULL, 103, NULL, NULL, 234642),
(281124, '1bfoA01', NULL, NULL, 108, NULL, NULL, 234642),
(281125, '4f9lC01', NULL, NULL, 135, NULL, NULL, 234642),
(281126, '3b43A02', NULL, NULL, 97, NULL, NULL, 234642),
(281127, '2cdfA01', NULL, NULL, 112, NULL, NULL, 234642),
(281128, '5e56A00', NULL, NULL, 117, NULL, NULL, 234642),
(281129, '3mgaB01', NULL, NULL, 152, NULL, NULL, 234642),
(281130, '3b43A01', NULL, NULL, 95, NULL, NULL, 234642),
(281131, '5ubzL01', NULL, NULL, 111, NULL, NULL, 234642),
(281132, '2jjwA01', NULL, NULL, 123, NULL, NULL, 234642),
(281133, '5wawL01', NULL, NULL, 112, NULL, NULL, 234642),
(281134, '1ej6A05', NULL, NULL, 95, NULL, NULL, 234642),
(281135, '4zs7H01', NULL, NULL, 122, NULL, NULL, 234642),
(281136, '5u66A02', NULL, NULL, 106, NULL, NULL, 234642),
(281137, '4tscH01', NULL, NULL, 117, NULL, NULL, 234642),
(281138, '4yr6B01', NULL, NULL, 108, NULL, NULL, 234642),
(281139, '5wuvL01', NULL, NULL, 108, NULL, NULL, 234642),
(281140, '4pozD01', NULL, NULL, 122, NULL, NULL, 234642),
(281141, '3k1kC00', NULL, NULL, 123, NULL, NULL, 234642),
(281142, '1l7tL01', NULL, NULL, 113, NULL, NULL, 234642),
(281143, '3bp6A00', NULL, NULL, 117, NULL, NULL, 234642),
(281144, '1evuA01', NULL, NULL, 185, NULL, NULL, 234642),
(281145, '1hzhH01', NULL, NULL, 119, NULL, NULL, 234642),
(281146, '4hhaA01', NULL, NULL, 109, NULL, NULL, 234642),
(281147, '5k6zA04', NULL, NULL, 92, NULL, NULL, 234642),
(281148, '6hf1B01', NULL, NULL, 107, NULL, NULL, 234642),
(281149, '2dm3A00', NULL, NULL, 110, NULL, NULL, 234642),
(281150, '4rdqF01', NULL, NULL, 108, NULL, NULL, 234642),
(281151, '1lo0L01', NULL, NULL, 113, NULL, NULL, 234642),
(281152, '3revB01', NULL, NULL, 112, NULL, NULL, 234642),
(281153, '4wgvB00', NULL, NULL, 124, NULL, NULL, 234642),
(281154, '6bj2E01', NULL, NULL, 112, NULL, NULL, 234642),
(281155, '3g5zA01', NULL, NULL, 107, NULL, NULL, 234642),
(281156, '4aizB00', NULL, NULL, 108, NULL, NULL, 234642),
(281157, '6ct7B01', NULL, NULL, 109, NULL, NULL, 234642),
(281158, '1eeqA00', NULL, NULL, 114, NULL, NULL, 234642),
(281159, '5m6aC01', NULL, NULL, 111, NULL, NULL, 234642),
(281160, '4yfeA01', NULL, NULL, 93, NULL, NULL, 234642),
(281161, '5tppL01', NULL, NULL, 111, NULL, NULL, 234642),
(281162, '4yfeA02', NULL, NULL, 107, NULL, NULL, 234642),
(281163, '1x5lA01', NULL, NULL, 88, NULL, NULL, 234642),
(281164, '4krnA00', NULL, NULL, 138, NULL, NULL, 234642),
(281165, '3u2sB01', NULL, NULL, 111, NULL, NULL, 234642),
(281166, '5b3jH01', NULL, NULL, 122, NULL, NULL, 234642),
(281167, '1x5aA01', NULL, NULL, 91, NULL, NULL, 234642),
(281168, '5c2bH00', NULL, NULL, 142, NULL, NULL, 234642),
(281169, '4mjiD01', NULL, NULL, 108, NULL, NULL, 234642),
(281170, '4kphL01', NULL, NULL, 106, NULL, NULL, 234642),
(281171, '6mtrL01', NULL, NULL, 110, NULL, NULL, 234642),
(281172, '1fnsL01', NULL, NULL, 107, NULL, NULL, 234642),
(281173, '3mj8B01', NULL, NULL, 116, NULL, NULL, 234642),
(281174, '3cviL01', NULL, NULL, 107, NULL, NULL, 234642),
(281175, '5ou7A01', NULL, NULL, 90, NULL, NULL, 234642),
(281176, '3o4oB03', NULL, NULL, 119, NULL, NULL, 234642),
(281177, '4b5eA00', NULL, NULL, 127, NULL, NULL, 234642); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(281178, '6igwA00', NULL, NULL, 135, NULL, NULL, 234642),
(281179, '4k94H01', NULL, NULL, 117, NULL, NULL, 234642),
(281180, '1bd2D01', NULL, NULL, 110, NULL, NULL, 234642),
(281181, '5tq0L01', NULL, NULL, 108, NULL, NULL, 234642),
(281182, '4jdvA01', NULL, NULL, 125, NULL, NULL, 234642),
(281183, '4jrxD02', NULL, NULL, 87, NULL, NULL, 234642),
(281184, '4jrxD01', NULL, NULL, 114, NULL, NULL, 234642),
(281185, '2dlhA00', NULL, NULL, 121, NULL, NULL, 234642),
(281186, '3shsA03', NULL, NULL, 123, NULL, NULL, 234642),
(281187, '3shsA02', NULL, NULL, 92, NULL, NULL, 234642),
(281188, '5tqaA01', NULL, NULL, 127, NULL, NULL, 234642),
(281189, '1nldH01', NULL, NULL, 113, NULL, NULL, 234642),
(281190, '6mtmE01', NULL, NULL, 110, NULL, NULL, 234642),
(281191, '1nldH02', NULL, NULL, 99, NULL, NULL, 234642),
(281192, '5vzrA02', NULL, NULL, 111, NULL, NULL, 234642),
(281193, '5dmgL01', NULL, NULL, 113, NULL, NULL, 234642),
(281194, '3shsA01', NULL, NULL, 89, NULL, NULL, 234642),
(281195, '4kq3L01', NULL, NULL, 106, NULL, NULL, 234642),
(281196, '2aabL01', NULL, NULL, 112, NULL, NULL, 234642),
(281197, '3eo9L01', NULL, NULL, 108, NULL, NULL, 234642),
(281198, '1cs6A03', NULL, NULL, 98, NULL, NULL, 234642),
(281199, '1mujB02', NULL, NULL, 102, NULL, NULL, 234642),
(281200, '1cs6A02', NULL, NULL, 89, NULL, NULL, 234642),
(281201, '1cs6A01', NULL, NULL, 105, NULL, NULL, 234642),
(281202, '1i3uA00', NULL, NULL, 127, NULL, NULL, 234642),
(281203, '2dibA01', NULL, NULL, 97, NULL, NULL, 234642),
(281204, '3go1H01', NULL, NULL, 122, NULL, NULL, 234642),
(281205, '3vxtB01', NULL, NULL, 113, NULL, NULL, 234642),
(281206, '3arbD01', NULL, NULL, 115, NULL, NULL, 234642),
(281207, '1hnfA02', NULL, NULL, 79, NULL, NULL, 234642),
(281208, '5anmL01', NULL, NULL, 110, NULL, NULL, 234642),
(281209, '4hxaL01', NULL, NULL, 107, NULL, NULL, 234642),
(281210, '1hnfA01', NULL, NULL, 103, NULL, NULL, 234642),
(281211, '4hjjH01', NULL, NULL, 122, NULL, NULL, 234642),
(281212, '3stbA00', NULL, NULL, 132, NULL, NULL, 234642),
(281213, '3knbA00', NULL, NULL, 100, NULL, NULL, 234642),
(281214, '6megL01', NULL, NULL, 112, NULL, NULL, 234642),
(281215, '4odsH01', NULL, NULL, 123, NULL, NULL, 234642),
(281216, '1cs6A04', NULL, NULL, 90, NULL, NULL, 234642),
(281217, '1aqkL01', NULL, NULL, 111, NULL, NULL, 234642),
(281218, '2nyyD01', NULL, NULL, 118, NULL, NULL, 234642),
(281219, '5nphL01', NULL, NULL, 110, NULL, NULL, 234642),
(281220, '1xgyH01', NULL, NULL, 118, NULL, NULL, 234642),
(281221, '3mfgB00', NULL, NULL, 118, NULL, NULL, 234642),
(281222, '4poyA00', NULL, NULL, 121, NULL, NULL, 234642),
(281223, '5nbwA01', NULL, NULL, 108, NULL, NULL, 234642),
(281224, '2eh7L01', NULL, NULL, 112, NULL, NULL, 234642),
(281225, '4yqxH00', NULL, NULL, 123, NULL, NULL, 234642),
(281226, '1cr9H01', NULL, NULL, 114, NULL, NULL, 234642),
(281227, '4u6vH01', NULL, NULL, 122, NULL, NULL, 234642),
(281228, '4odhH01', NULL, NULL, 144, NULL, NULL, 234642),
(281229, '5tplH01', NULL, NULL, 127, NULL, NULL, 234642),
(281230, '2a9mH00', NULL, NULL, 126, NULL, NULL, 234642),
(281231, '3wihA00', NULL, NULL, 97, NULL, NULL, 234642),
(281232, '2ee3A00', NULL, NULL, 108, NULL, NULL, 234642),
(281233, '2bc4D02', NULL, NULL, 119, NULL, NULL, 234642),
(281234, '4of0A02', NULL, NULL, 143, NULL, NULL, 234642),
(281235, '4fqcH01', NULL, NULL, 132, NULL, NULL, 234642),
(281236, '4hk0A01', NULL, NULL, 126, NULL, NULL, 234642),
(281237, '4trpL01', NULL, NULL, 114, NULL, NULL, 234642),
(281238, '3kj4C01', NULL, NULL, 121, NULL, NULL, 234642),
(281239, '5zmjL01', NULL, NULL, 110, NULL, NULL, 234642),
(281240, '4od1H01', NULL, NULL, 143, NULL, NULL, 234642),
(281241, '5l6yH01', NULL, NULL, 122, NULL, NULL, 234642),
(281242, '3lmjH01', NULL, NULL, 125, NULL, NULL, 234642),
(281243, '4x9hA03', NULL, NULL, 105, NULL, NULL, 234642),
(281244, '4x9hA02', NULL, NULL, 107, NULL, NULL, 234642),
(281245, '3eyqD01', NULL, NULL, 125, NULL, NULL, 234642),
(281246, '5fv1M00', NULL, NULL, 108, NULL, NULL, 234642),
(281247, '3upaA00', NULL, NULL, 107, NULL, NULL, 234642),
(281248, '4lexL01', NULL, NULL, 112, NULL, NULL, 234642);
INSERT INTO "PUBLIC"."MODEL" VALUES
(281249, '2g75A01', NULL, NULL, 118, NULL, NULL, 234642),
(281250, '4bh8B01', NULL, NULL, 121, NULL, NULL, 234642),
(281251, '3u6rH00', NULL, NULL, 128, NULL, NULL, 234642),
(281252, '6bitK01', NULL, NULL, 108, NULL, NULL, 234642),
(281253, '1hxmB01', NULL, NULL, 125, NULL, NULL, 234642),
(281254, '5u3pL01', NULL, NULL, 109, NULL, NULL, 234642),
(281255, '3v0aC00', NULL, NULL, 127, NULL, NULL, 234642),
(281256, '4xvjH00', NULL, NULL, 141, NULL, NULL, 234642),
(281257, '2cxkA00', NULL, NULL, 95, NULL, NULL, 234642),
(281258, '1dzbA02', NULL, NULL, 99, NULL, NULL, 234642),
(281259, '5dcpA02', NULL, NULL, 91, NULL, NULL, 234642),
(281260, '5dcpA01', NULL, NULL, 84, NULL, NULL, 234642),
(281261, '4f15C01', NULL, NULL, 112, NULL, NULL, 234642),
(281262, '3k2mC00', NULL, NULL, 101, NULL, NULL, 234642),
(281263, '1dzbA01', NULL, NULL, 116, NULL, NULL, 234642),
(281264, '1rz7H01', NULL, NULL, 115, NULL, NULL, 234642),
(281265, '5dd5H01', NULL, NULL, 128, NULL, NULL, 234642),
(281266, '6bckL01', NULL, NULL, 100, NULL, NULL, 234642),
(281267, '5aumB01', NULL, NULL, 113, NULL, NULL, 234642),
(281268, '1iaiH01', NULL, NULL, 121, NULL, NULL, 234642),
(281269, '4nylF00', NULL, NULL, 124, NULL, NULL, 234642),
(281270, '6d9gB01', NULL, NULL, 112, NULL, NULL, 234642),
(281271, '1n4xL00', NULL, NULL, 113, NULL, NULL, 234642),
(281272, '1t2qL01', NULL, NULL, 113, NULL, NULL, 234642),
(281273, '5ud9L02', NULL, NULL, 104, NULL, NULL, 234642),
(281274, '5x5xL01', NULL, NULL, 114, NULL, NULL, 234642),
(281275, '5ud9L01', NULL, NULL, 111, NULL, NULL, 234642),
(281276, '5x5xL02', NULL, NULL, 118, NULL, NULL, 234642),
(281277, '5ksaA02', NULL, NULL, 108, NULL, NULL, 234642),
(281278, '1mnuL01', NULL, NULL, 113, NULL, NULL, 234642),
(281279, '3iu4H01', NULL, NULL, 121, NULL, NULL, 234642),
(281280, '4yefB00', NULL, NULL, 89, NULL, NULL, 234642),
(281281, '3iu4H02', NULL, NULL, 98, NULL, NULL, 234642),
(281282, '2agjH02', NULL, NULL, 101, NULL, NULL, 234642),
(281283, '4oi9A03', NULL, NULL, 93, NULL, NULL, 234642),
(281284, '4oi9A04', NULL, NULL, 88, NULL, NULL, 234642),
(281285, '2agjH01', NULL, NULL, 120, NULL, NULL, 234642),
(281286, '3sknA01', NULL, NULL, 109, NULL, NULL, 234642),
(281287, '2j3sA03', NULL, NULL, 62, NULL, NULL, 234642),
(281288, '4q9cA00', NULL, NULL, 111, NULL, NULL, 234642),
(281289, '1rziA01', NULL, NULL, 106, NULL, NULL, 234642),
(281290, '2brrH01', NULL, NULL, 123, NULL, NULL, 234642),
(281291, '2j3sA02', NULL, NULL, 107, NULL, NULL, 234642),
(281292, '5i9qB01', NULL, NULL, 119, NULL, NULL, 234642),
(281293, '1c12B02', NULL, NULL, 97, NULL, NULL, 234642),
(281294, '1gl4B00', NULL, NULL, 98, NULL, NULL, 234642),
(281295, '1c12B01', NULL, NULL, 121, NULL, NULL, 234642),
(281296, '4nkiH01', NULL, NULL, 120, NULL, NULL, 234642),
(281297, '1kelL01', NULL, NULL, 113, NULL, NULL, 234642),
(281298, '1dvfD00', NULL, NULL, 121, NULL, NULL, 234642),
(281299, '3sdxH01', NULL, NULL, 118, NULL, NULL, 234642),
(281300, '2p5eE01', NULL, NULL, 112, NULL, NULL, 234642),
(281301, '4q97A00', NULL, NULL, 111, NULL, NULL, 234642),
(281302, '6mtjD00', NULL, NULL, 134, NULL, NULL, 234642),
(281303, '1grwA00', NULL, NULL, 126, NULL, NULL, 234642),
(281304, '4go6B01', NULL, NULL, 85, NULL, NULL, 234642),
(281305, '1igmH00', NULL, NULL, 129, NULL, NULL, 234642),
(281306, '4go6B02', NULL, NULL, 129, NULL, NULL, 234642),
(281307, '4w70A00', NULL, NULL, 142, NULL, NULL, 234642),
(281308, '1uwxK01', NULL, NULL, 108, NULL, NULL, 234642),
(281309, '2cpcA01', NULL, NULL, 87, NULL, NULL, 234642),
(281310, '4liqH01', NULL, NULL, 116, NULL, NULL, 234642),
(281311, '25c8H01', NULL, NULL, 119, NULL, NULL, 234642),
(281312, '2edhA01', NULL, NULL, 85, NULL, NULL, 234642),
(281313, '5gkrD01', NULL, NULL, 111, NULL, NULL, 234642),
(281314, '1ncwL01', NULL, NULL, 113, NULL, NULL, 234642),
(281315, '3fzuC01', NULL, NULL, 118, NULL, NULL, 234642),
(281316, '3k81A00', NULL, NULL, 127, NULL, NULL, 234642),
(281317, '3gk8L02', NULL, NULL, 103, NULL, NULL, 234642),
(281318, '5gruL01', NULL, NULL, 118, NULL, NULL, 234642),
(281319, '3gk8L01', NULL, NULL, 108, NULL, NULL, 234642);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(281320, '3kptB01', NULL, NULL, 108, NULL, NULL, 234642),
(281321, '1zk9A00', NULL, NULL, 110, NULL, NULL, 234642),
(281322, '1orsA01', NULL, NULL, 108, NULL, NULL, 234642),
(281323, '5kbnC00', NULL, NULL, 97, NULL, NULL, 234642),
(281324, '1tzhA01', NULL, NULL, 107, NULL, NULL, 234642),
(281325, '4o5lH01', NULL, NULL, 131, NULL, NULL, 234642),
(281326, '3fn9C04', NULL, NULL, 92, NULL, NULL, 234642),
(281327, '2nmsA00', NULL, NULL, 124, NULL, NULL, 234642),
(281328, '4plnC02', NULL, NULL, 104, NULL, NULL, 234642),
(281329, '4plnC01', NULL, NULL, 101, NULL, NULL, 234642),
(281330, '3u0tA01', NULL, NULL, 112, NULL, NULL, 234642),
(281331, '4e41D01', NULL, NULL, 109, NULL, NULL, 234642),
(281332, '4krmF00', NULL, NULL, 133, NULL, NULL, 234642),
(281333, '4qgyB00', NULL, NULL, 135, NULL, NULL, 234642),
(281334, '4f33A01', NULL, NULL, 107, NULL, NULL, 234642),
(281335, '2ypvH01', NULL, NULL, 119, NULL, NULL, 234642),
(281336, '3gheH01', NULL, NULL, 129, NULL, NULL, 234642),
(281337, '2qscL01', NULL, NULL, 108, NULL, NULL, 234642),
(281338, '3grwA02', NULL, NULL, 106, NULL, NULL, 234642),
(281339, '3grwA01', NULL, NULL, 110, NULL, NULL, 234642),
(281340, '3gsnA01', NULL, NULL, 109, NULL, NULL, 234642),
(281341, '4u49B01', NULL, NULL, 98, NULL, NULL, 234642),
(281342, '4otxH01', NULL, NULL, 113, NULL, NULL, 234642),
(281343, '6cuhB01', NULL, NULL, 116, NULL, NULL, 234642),
(281344, '5xmhC00', NULL, NULL, 108, NULL, NULL, 234642),
(281345, '5it2H01', NULL, NULL, 123, NULL, NULL, 234642),
(281346, '1uweL02', NULL, NULL, 104, NULL, NULL, 234642),
(281347, '4jo1H01', NULL, NULL, 113, NULL, NULL, 234642),
(281348, '1zvhA00', NULL, NULL, 134, NULL, NULL, 234642),
(281349, '3pddA02', NULL, NULL, 101, NULL, NULL, 234642),
(281350, '4yo0B01', NULL, NULL, 109, NULL, NULL, 234642),
(281351, '4yo0B02', NULL, NULL, 104, NULL, NULL, 234642),
(281352, '1uweL01', NULL, NULL, 108, NULL, NULL, 234642),
(281353, '1igfL01', NULL, NULL, 113, NULL, NULL, 234642),
(281354, '1hyrC02', NULL, NULL, 93, NULL, NULL, 234642),
(281355, '4nrxB01', NULL, NULL, 107, NULL, NULL, 234642),
(281356, '1qnzH00', NULL, NULL, 119, NULL, NULL, 234642),
(281357, '6ev2B01', NULL, NULL, 107, NULL, NULL, 234642),
(281358, '4m7jL01', NULL, NULL, 113, NULL, NULL, 234642),
(281359, '3vi3F01', NULL, NULL, 118, NULL, NULL, 234642),
(281360, '4bz1L01', NULL, NULL, 114, NULL, NULL, 234642),
(281361, '4jb9L01', NULL, NULL, 103, NULL, NULL, 234642),
(281362, '3ujiL01', NULL, NULL, 108, NULL, NULL, 234642),
(281363, '3kgrA00', NULL, NULL, 106, NULL, NULL, 234642),
(281364, '5a3iC01', NULL, NULL, 125, NULL, NULL, 234642),
(281365, '4o4yL01', NULL, NULL, 114, NULL, NULL, 234642),
(281366, '3vg9C01', NULL, NULL, 124, NULL, NULL, 234642),
(281367, '3fl7A05', NULL, NULL, 95, NULL, NULL, 234642),
(281368, '6mi2B01', NULL, NULL, 109, NULL, NULL, 234642),
(281369, '4z7uF01', NULL, NULL, 116, NULL, NULL, 234642),
(281370, '4mb4A03', NULL, NULL, 84, NULL, NULL, 234642),
(281371, '4mb4A02', NULL, NULL, 79, NULL, NULL, 234642),
(281372, '2h32A00', NULL, NULL, 126, NULL, NULL, 234642),
(281373, '2nw2A01', NULL, NULL, 110, NULL, NULL, 234642),
(281374, '2r4rL01', NULL, NULL, 108, NULL, NULL, 234642),
(281375, '3fl7A04', NULL, NULL, 108, NULL, NULL, 234642),
(281376, '2yr3A00', NULL, NULL, 99, NULL, NULL, 234642),
(281377, '2d3vA01', NULL, NULL, 95, NULL, NULL, 234642),
(281378, '4hc1L01', NULL, NULL, 107, NULL, NULL, 234642),
(281379, '2d3vA02', NULL, NULL, 101, NULL, NULL, 234642),
(281380, '6a67D01', NULL, NULL, 112, NULL, NULL, 234642),
(281381, '3ujtL01', NULL, NULL, 114, NULL, NULL, 234642),
(281382, '6aniL01', NULL, NULL, 105, NULL, NULL, 234642),
(281383, '3zkqD00', NULL, NULL, 122, NULL, NULL, 234642),
(281384, '1cloH01', NULL, NULL, 121, NULL, NULL, 234642),
(281385, '2ok0L01', NULL, NULL, 113, NULL, NULL, 234642),
(281386, '3lqmA01', NULL, NULL, 90, NULL, NULL, 234642),
(281387, '3lqmA02', NULL, NULL, 102, NULL, NULL, 234642),
(281388, '1yc7A00', NULL, NULL, 124, NULL, NULL, 234642),
(281389, '2c1pB01', NULL, NULL, 115, NULL, NULL, 234642),
(281390, '2hgsA01', NULL, NULL, 89, NULL, NULL, 234643); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(281391, '5oesA01', NULL, NULL, 102, NULL, NULL, 234643),
(281392, '1m0wA01', NULL, NULL, 85, NULL, NULL, 234643),
(281393, '3kajA01', NULL, NULL, 90, NULL, NULL, 234643),
(281394, '5bnyA02', NULL, NULL, 233, NULL, NULL, 234644),
(281395, '6myaA02', NULL, NULL, 223, NULL, NULL, 234644),
(281396, '5xl2A02', NULL, NULL, 218, NULL, NULL, 234644),
(281397, '6d7uA02', NULL, NULL, 216, NULL, NULL, 234644),
(281398, '4k3xA02', NULL, NULL, 221, NULL, NULL, 234644),
(281399, '6n08A02', NULL, NULL, 216, NULL, NULL, 234644),
(281400, '5vliA02', NULL, NULL, 231, NULL, NULL, 234644),
(281401, '2wrfA02', NULL, NULL, 221, NULL, NULL, 234644),
(281402, '4f23A02', NULL, NULL, 219, NULL, NULL, 234644),
(281403, '4k62A02', NULL, NULL, 222, NULL, NULL, 234644),
(281404, '4junA02', NULL, NULL, 222, NULL, NULL, 234644),
(281405, '5e32A02', NULL, NULL, 221, NULL, NULL, 234644),
(281406, '4nrjA02', NULL, NULL, 241, NULL, NULL, 234644),
(281407, '4fnkA01', NULL, NULL, 216, NULL, NULL, 234644),
(281408, '5umnB00', NULL, NULL, 274, NULL, NULL, 234644),
(281409, '2rftA02', NULL, NULL, 239, NULL, NULL, 234644),
(281410, '4cqyA02', NULL, NULL, 221, NULL, NULL, 234644),
(281411, '6bkrA01', NULL, NULL, 216, NULL, NULL, 234644),
(281412, '4f15J01', NULL, NULL, 222, NULL, NULL, 234644),
(281413, '6onaC02', NULL, NULL, 223, NULL, NULL, 234644),
(281414, '6mxuA02', NULL, NULL, 216, NULL, NULL, 234644),
(281415, '1jsdA01', NULL, NULL, 216, NULL, NULL, 234644),
(281416, '5e2yA02', NULL, NULL, 221, NULL, NULL, 234644),
(281417, '3ku3A02', NULL, NULL, 221, NULL, NULL, 234644),
(281418, '4h32A02', NULL, NULL, 220, NULL, NULL, 234644),
(281419, '4kpqA02', NULL, NULL, 221, NULL, NULL, 234644),
(281420, '6d8wA02', NULL, NULL, 223, NULL, NULL, 234644),
(281421, '6ml8A02', NULL, NULL, 231, NULL, NULL, 234644),
(281422, '4jumA02', NULL, NULL, 222, NULL, NULL, 234644),
(281423, '4uo0A01', NULL, NULL, 216, NULL, NULL, 234644),
(281424, '4wsrA02', NULL, NULL, 224, NULL, NULL, 234644),
(281425, '4fqiA02', NULL, NULL, 222, NULL, NULL, 234644),
(281426, '4bsgA02', NULL, NULL, 216, NULL, NULL, 234644),
(281427, '3uyxA00', NULL, NULL, 214, NULL, NULL, 234644),
(281428, '4unwA01', NULL, NULL, 216, NULL, NULL, 234644),
(281429, '5xl8A02', NULL, NULL, 218, NULL, NULL, 234644),
(281430, '6n4fA01', NULL, NULL, 216, NULL, NULL, 234644),
(281431, '6fywA02', NULL, NULL, 242, NULL, NULL, 234644),
(281432, '3eykA01', NULL, NULL, 218, NULL, NULL, 234644),
(281433, '4we5A01', NULL, NULL, 216, NULL, NULL, 234644),
(281434, '4m44A02', NULL, NULL, 241, NULL, NULL, 234644),
(281435, '6aorA01', NULL, NULL, 216, NULL, NULL, 234644),
(281436, '4f3zA02', NULL, NULL, 232, NULL, NULL, 234644),
(281437, '4kthA02', NULL, NULL, 222, NULL, NULL, 234644),
(281438, '6chxA00', NULL, NULL, 215, NULL, NULL, 234644),
(281439, '1jsmA01', NULL, NULL, 222, NULL, NULL, 234644),
(281440, '6n41A02', NULL, NULL, 223, NULL, NULL, 234644),
(281441, '3htoA02', NULL, NULL, 232, NULL, NULL, 234644),
(281442, '2wr1A02', NULL, NULL, 221, NULL, NULL, 234644),
(281443, '4wswA02', NULL, NULL, 218, NULL, NULL, 234644),
(281444, '5xkuA00', NULL, NULL, 208, NULL, NULL, 234644),
(281445, '5hu8A02', NULL, NULL, 222, NULL, NULL, 234644),
(281446, '1rv0H02', NULL, NULL, 232, NULL, NULL, 234644),
(281447, '6mzkA02', NULL, NULL, 216, NULL, NULL, 234644),
(281448, '4fqjA02', NULL, NULL, 241, NULL, NULL, 234644),
(281449, '4cyvA02', NULL, NULL, 218, NULL, NULL, 234644),
(281450, '4o5nA01', NULL, NULL, 216, NULL, NULL, 234644),
(281451, '5dutA00', NULL, NULL, 233, NULL, NULL, 234644),
(281452, '6osrA02', NULL, NULL, 223, NULL, NULL, 234644),
(281453, '4lvhA00', NULL, NULL, 236, NULL, NULL, 234644),
(281454, '4gxxA02', NULL, NULL, 232, NULL, NULL, 234644),
(281455, '3mlhB00', NULL, NULL, 235, NULL, NULL, 234644),
(281456, '3m5gA02', NULL, NULL, 208, NULL, NULL, 234644),
(281457, '5tg9A02', NULL, NULL, 226, NULL, NULL, 234644),
(281458, '4wa1A02', NULL, NULL, 216, NULL, NULL, 234644),
(281459, '4we6A02', NULL, NULL, 216, NULL, NULL, 234644),
(281460, '5th1A02', NULL, NULL, 218, NULL, NULL, 234644),
(281461, '1mqmA01', NULL, NULL, 216, NULL, NULL, 234644);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(281462, '4edbA02', NULL, NULL, 231, NULL, NULL, 234644),
(281463, '6oc3E00', NULL, NULL, 227, NULL, NULL, 234644),
(281464, '5yt8A02', NULL, NULL, 222, NULL, NULL, 234644),
(281465, '5t0bC02', NULL, NULL, 234, NULL, NULL, 234644),
(281466, '2hl7A00', NULL, NULL, 84, NULL, NULL, 234645),
(281467, '2kw0A00', NULL, NULL, 90, NULL, NULL, 234645),
(281468, '1wpbB02', NULL, NULL, 112, NULL, NULL, 234646),
(281469, '2hu9A01', NULL, NULL, 61, NULL, NULL, 234647),
(281470, '1ohfC01', NULL, NULL, 166, NULL, NULL, 234648),
(281471, '6f6dA03', NULL, NULL, 67, NULL, NULL, 234649),
(281472, '4uf0A03', NULL, NULL, 65, NULL, NULL, 234649),
(281473, '6fulA03', NULL, NULL, 67, NULL, NULL, 234649),
(281474, '3pbtA02', NULL, NULL, 146, NULL, NULL, 234650),
(281475, '4bjpA02', NULL, NULL, 148, NULL, NULL, 234650),
(281476, '3eqvA02', NULL, NULL, 149, NULL, NULL, 234650),
(281477, '3ue3A02', NULL, NULL, 149, NULL, NULL, 234650),
(281478, '2c42A07', NULL, NULL, 62, NULL, NULL, 234651),
(281479, '2o0bA01', NULL, NULL, 209, NULL, NULL, 234652),
(281480, '3sweA02', NULL, NULL, 210, NULL, NULL, 234652),
(281481, '2o0bA02', NULL, NULL, 215, NULL, NULL, 234652),
(281482, '2pqcA01', NULL, NULL, 231, NULL, NULL, 234652),
(281483, '2pqcA02', NULL, NULL, 214, NULL, NULL, 234652),
(281484, '6nkjA01', NULL, NULL, 216, NULL, NULL, 234652),
(281485, '2rl1A01', NULL, NULL, 211, NULL, NULL, 234652),
(281486, '6nkjA02', NULL, NULL, 211, NULL, NULL, 234652),
(281487, '5bufA02', NULL, NULL, 211, NULL, NULL, 234652),
(281488, '5bufA01', NULL, NULL, 247, NULL, NULL, 234652),
(281489, '4r7uC01', NULL, NULL, 211, NULL, NULL, 234652),
(281490, '3sg1A02', NULL, NULL, 210, NULL, NULL, 234652),
(281491, '4fqdA01', NULL, NULL, 226, NULL, NULL, 234652),
(281492, '3sg1A01', NULL, NULL, 221, NULL, NULL, 234652),
(281493, '3rmtA02', NULL, NULL, 209, NULL, NULL, 234652),
(281494, '3nvsA01', NULL, NULL, 203, NULL, NULL, 234652),
(281495, '3nvsA02', NULL, NULL, 205, NULL, NULL, 234652),
(281496, '4r7uA02', NULL, NULL, 208, NULL, NULL, 234652),
(281497, '3zh4A02', NULL, NULL, 210, NULL, NULL, 234652),
(281498, '3zh4A01', NULL, NULL, 206, NULL, NULL, 234652),
(281499, '5u4hA01', NULL, NULL, 209, NULL, NULL, 234652),
(281500, '5u4hA02', NULL, NULL, 209, NULL, NULL, 234652),
(281501, '4n3pA02', NULL, NULL, 210, NULL, NULL, 234652),
(281502, '3swgA01', NULL, NULL, 216, NULL, NULL, 234652),
(281503, '1g6sA01', NULL, NULL, 205, NULL, NULL, 234652),
(281504, '1g6sA02', NULL, NULL, 204, NULL, NULL, 234652),
(281505, '1ejdA01', NULL, NULL, 207, NULL, NULL, 234652),
(281506, '3slhA02', NULL, NULL, 210, NULL, NULL, 234652),
(281507, '1ejdA02', NULL, NULL, 208, NULL, NULL, 234652),
(281508, '3slhA01', NULL, NULL, 231, NULL, NULL, 234652),
(281509, '2yvwA02', NULL, NULL, 206, NULL, NULL, 234652),
(281510, '5bq2A02', NULL, NULL, 211, NULL, NULL, 234652),
(281511, '5bq2A01', NULL, NULL, 215, NULL, NULL, 234652),
(281512, '1rf6A01', NULL, NULL, 217, NULL, NULL, 234652),
(281513, '1rf6A02', NULL, NULL, 210, NULL, NULL, 234652),
(281514, '5ujsA01', NULL, NULL, 208, NULL, NULL, 234652),
(281515, '3rmtB01', NULL, NULL, 229, NULL, NULL, 234652),
(281516, '4fqdB02', NULL, NULL, 229, NULL, NULL, 234652),
(281517, '5ujsA02', NULL, NULL, 209, NULL, NULL, 234652),
(281518, '3kqjA01', NULL, NULL, 208, NULL, NULL, 234652),
(281519, '3vcyA01', NULL, NULL, 219, NULL, NULL, 234652),
(281520, '3vcyA02', NULL, NULL, 208, NULL, NULL, 234652),
(281521, '3kqjA02', NULL, NULL, 208, NULL, NULL, 234652),
(281522, '3r38A02', NULL, NULL, 211, NULL, NULL, 234652),
(281523, '3r38A01', NULL, NULL, 243, NULL, NULL, 234652),
(281524, '6cn1A02', NULL, NULL, 211, NULL, NULL, 234652),
(281525, '6cn1A01', NULL, NULL, 210, NULL, NULL, 234652),
(281526, '5xwbA01', NULL, NULL, 203, NULL, NULL, 234652),
(281527, '5xwbA02', NULL, NULL, 205, NULL, NULL, 234652),
(281528, '1jbiA00', NULL, NULL, 100, NULL, NULL, 234653),
(281529, '2m86A00', NULL, NULL, 51, NULL, NULL, 234654),
(281530, '1nnvA01', NULL, NULL, 100, NULL, NULL, 234655),
(281531, '3s5wA00', NULL, NULL, 435, NULL, NULL, 234656),
(281532, '5jciA02', NULL, NULL, 132, NULL, NULL, 234656);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(281533, '5jciA01', NULL, NULL, 211, NULL, NULL, 234656),
(281534, '3icsA01', NULL, NULL, 195, NULL, NULL, 234656),
(281535, '3icsA02', NULL, NULL, 258, NULL, NULL, 234656),
(281536, '3pvcA02', NULL, NULL, 287, NULL, NULL, 234656),
(281537, '4udqA01', NULL, NULL, 351, NULL, NULL, 234656),
(281538, '1cjcA02', NULL, NULL, 241, NULL, NULL, 234656),
(281539, '5eowA00', NULL, NULL, 378, NULL, NULL, 234656),
(281540, '3vrdB01', NULL, NULL, 188, NULL, NULL, 234656),
(281541, '3vrdB02', NULL, NULL, 139, NULL, NULL, 234656),
(281542, '4cnkA01', NULL, NULL, 256, NULL, NULL, 234656),
(281543, '1gesB01', NULL, NULL, 219, NULL, NULL, 234656),
(281544, '4la1A02', NULL, NULL, 232, NULL, NULL, 234656),
(281545, '5u25A02', NULL, NULL, 122, NULL, NULL, 234656),
(281546, '5vn0A02', NULL, NULL, 148, NULL, NULL, 234656),
(281547, '4yshA01', NULL, NULL, 230, NULL, NULL, 234656),
(281548, '1w4xA01', NULL, NULL, 311, NULL, NULL, 234656),
(281549, '1rsgB01', NULL, NULL, 200, NULL, NULL, 234656),
(281550, '1jnrA01', NULL, NULL, 364, NULL, NULL, 234656),
(281551, '4usqA00', NULL, NULL, 361, NULL, NULL, 234656),
(281552, '1chuA01', NULL, NULL, 257, NULL, NULL, 234656),
(281553, '2pyxA01', NULL, NULL, 212, NULL, NULL, 234656),
(281554, '2a87A01', NULL, NULL, 212, NULL, NULL, 234656),
(281555, '1gerA02', NULL, NULL, 118, NULL, NULL, 234656),
(281556, '2a87A02', NULL, NULL, 123, NULL, NULL, 234656),
(281557, '5ipyA01', NULL, NULL, 353, NULL, NULL, 234656),
(281558, '5niiB01', NULL, NULL, 198, NULL, NULL, 234656),
(281559, '5ttjB01', NULL, NULL, 232, NULL, NULL, 234656),
(281560, '5ipyA02', NULL, NULL, 100, NULL, NULL, 234656),
(281561, '5vdnA02', NULL, NULL, 118, NULL, NULL, 234656),
(281562, '1gv4A02', NULL, NULL, 166, NULL, NULL, 234656),
(281563, '3qj4A01', NULL, NULL, 161, NULL, NULL, 234656),
(281564, '5vdnA01', NULL, NULL, 232, NULL, NULL, 234656),
(281565, '3qvpA01', NULL, NULL, 206, NULL, NULL, 234656),
(281566, '5u8uA02', NULL, NULL, 122, NULL, NULL, 234656),
(281567, '3v76A01', NULL, NULL, 239, NULL, NULL, 234656),
(281568, '4ap3A01', NULL, NULL, 299, NULL, NULL, 234656),
(281569, '2i0zA01', NULL, NULL, 263, NULL, NULL, 234656),
(281570, '4j56A01', NULL, NULL, 234, NULL, NULL, 234656),
(281571, '2olnA01', NULL, NULL, 231, NULL, NULL, 234656),
(281572, '1gesA02', NULL, NULL, 118, NULL, NULL, 234656),
(281573, '4j56A02', NULL, NULL, 118, NULL, NULL, 234656),
(281574, '3lxdA02', NULL, NULL, 127, NULL, NULL, 234656),
(281575, '3lxdA01', NULL, NULL, 202, NULL, NULL, 234656),
(281576, '3aljA01', NULL, NULL, 227, NULL, NULL, 234656),
(281577, '3djeA01', NULL, NULL, 232, NULL, NULL, 234656),
(281578, '3e1tA01', NULL, NULL, 253, NULL, NULL, 234656),
(281579, '1rsgA01', NULL, NULL, 257, NULL, NULL, 234656),
(281580, '4wctA01', NULL, NULL, 236, NULL, NULL, 234656),
(281581, '4fx9B01', NULL, NULL, 171, NULL, NULL, 234656),
(281582, '4o5qA02', NULL, NULL, 197, NULL, NULL, 234656),
(281583, '6ib5B00', NULL, NULL, 534, NULL, NULL, 234656),
(281584, '3nrnA01', NULL, NULL, 224, NULL, NULL, 234656),
(281585, '4h7uA01', NULL, NULL, 266, NULL, NULL, 234656),
(281586, '5j60B02', NULL, NULL, 123, NULL, NULL, 234656),
(281587, '3g5sA01', NULL, NULL, 288, NULL, NULL, 234656),
(281588, '4rekA01', NULL, NULL, 332, NULL, NULL, 234656),
(281589, '3nycA01', NULL, NULL, 231, NULL, NULL, 234656),
(281590, '5u8uD01', NULL, NULL, 232, NULL, NULL, 234656),
(281591, '3fbsB01', NULL, NULL, 190, NULL, NULL, 234656),
(281592, '2e5vA01', NULL, NULL, 279, NULL, NULL, 234656),
(281593, '6a6sA01', NULL, NULL, 228, NULL, NULL, 234656),
(281594, '3dk9A01', NULL, NULL, 220, NULL, NULL, 234656),
(281595, '3dk9A02', NULL, NULL, 129, NULL, NULL, 234656),
(281596, '3rhaB01', NULL, NULL, 197, NULL, NULL, 234656),
(281597, '1fecA02', NULL, NULL, 121, NULL, NULL, 234656),
(281598, '2culA00', NULL, NULL, 232, NULL, NULL, 234656),
(281599, '4z24A01', NULL, NULL, 368, NULL, NULL, 234656),
(281600, '3ng7X01', NULL, NULL, 225, NULL, NULL, 234656),
(281601, '1ju2A01', NULL, NULL, 347, NULL, NULL, 234656),
(281602, '2jaeA01', NULL, NULL, 196, NULL, NULL, 234656),
(281603, '3nlcA02', NULL, NULL, 243, NULL, NULL, 234656);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(281604, '5j60A01', NULL, NULL, 197, NULL, NULL, 234656),
(281605, '4y4mC00', NULL, NULL, 258, NULL, NULL, 234656),
(281606, '2eq6A01', NULL, NULL, 216, NULL, NULL, 234656),
(281607, '6j0zC01', NULL, NULL, 299, NULL, NULL, 234656),
(281608, '2eq6A02', NULL, NULL, 124, NULL, NULL, 234656),
(281609, '4bjzA01', NULL, NULL, 170, NULL, NULL, 234656),
(281610, '2gagB01', NULL, NULL, 233, NULL, NULL, 234656),
(281611, '3fbsA02', NULL, NULL, 107, NULL, NULL, 234656),
(281612, '1kdgA01', NULL, NULL, 342, NULL, NULL, 234656),
(281613, '2aqjA00', NULL, NULL, 518, NULL, NULL, 234656),
(281614, '1o5wA01', NULL, NULL, 197, NULL, NULL, 234656),
(281615, '2bcgG01', NULL, NULL, 191, NULL, NULL, 234656),
(281616, '4m52A01', NULL, NULL, 223, NULL, NULL, 234656),
(281617, '4m52A02', NULL, NULL, 121, NULL, NULL, 234656),
(281618, '2iidA02', NULL, NULL, 160, NULL, NULL, 234656),
(281619, '1fecB01', NULL, NULL, 238, NULL, NULL, 234656),
(281620, '3gyxA01', NULL, NULL, 531, NULL, NULL, 234656),
(281621, '3ihmA01', NULL, NULL, 215, NULL, NULL, 234656),
(281622, '3oz2A01', NULL, NULL, 237, NULL, NULL, 234656),
(281623, '4b1bA00', NULL, NULL, 468, NULL, NULL, 234656),
(281624, '4eqsA01', NULL, NULL, 170, NULL, NULL, 234656),
(281625, '2zbwB01', NULL, NULL, 212, NULL, NULL, 234656),
(281626, '1kf6A01', NULL, NULL, 306, NULL, NULL, 234656),
(281627, '1hyuA01', NULL, NULL, 182, NULL, NULL, 234656),
(281628, '4eqsA02', NULL, NULL, 143, NULL, NULL, 234656),
(281629, '2e57B01', NULL, NULL, 321, NULL, NULL, 234656),
(281630, '1lvlA01', NULL, NULL, 217, NULL, NULL, 234656),
(281631, '4dnaA01', NULL, NULL, 220, NULL, NULL, 234656),
(281632, '3d1cA01', NULL, NULL, 245, NULL, NULL, 234656),
(281633, '1lvlA02', NULL, NULL, 118, NULL, NULL, 234656),
(281634, '5u63A02', NULL, NULL, 127, NULL, NULL, 234656),
(281635, '3ab1A02', NULL, NULL, 126, NULL, NULL, 234656),
(281636, '4b63A00', NULL, NULL, 473, NULL, NULL, 234656),
(281637, '1trbA02', NULL, NULL, 128, NULL, NULL, 234656),
(281638, '5ts5A02', NULL, NULL, 146, NULL, NULL, 234656),
(281639, '1zmdE01', NULL, NULL, 224, NULL, NULL, 234656),
(281640, '4y4nA00', NULL, NULL, 260, NULL, NULL, 234656),
(281641, '3rp7A01', NULL, NULL, 183, NULL, NULL, 234656),
(281642, '4k2xA01', NULL, NULL, 296, NULL, NULL, 234656),
(281643, '1trbA01', NULL, NULL, 187, NULL, NULL, 234656),
(281644, '5bukB00', NULL, NULL, 450, NULL, NULL, 234656),
(281645, '3ihgA01', NULL, NULL, 248, NULL, NULL, 234656),
(281646, '4c5oA00', NULL, NULL, 357, NULL, NULL, 234656),
(281647, '3urhA02', NULL, NULL, 126, NULL, NULL, 234656),
(281648, '3urhA01', NULL, NULL, 219, NULL, NULL, 234656),
(281649, '1ebdA01', NULL, NULL, 219, NULL, NULL, 234656),
(281650, '1ebdA02', NULL, NULL, 121, NULL, NULL, 234656),
(281651, '4c3xA01', NULL, NULL, 362, NULL, NULL, 234656),
(281652, '5bvaA00', NULL, NULL, 409, NULL, NULL, 234656),
(281653, '2gqfA01', NULL, NULL, 250, NULL, NULL, 234656),
(281654, '2yg5A01', NULL, NULL, 196, NULL, NULL, 234656),
(281655, '5z2gA02', NULL, NULL, 151, NULL, NULL, 234656),
(281656, '2xdoD00', NULL, NULL, 376, NULL, NULL, 234656),
(281657, '4dnaA02', NULL, NULL, 119, NULL, NULL, 234656),
(281658, '5u63B01', NULL, NULL, 191, NULL, NULL, 234656),
(281659, '6brdA01', NULL, NULL, 292, NULL, NULL, 234656),
(281660, '3rhaA00', NULL, NULL, 461, NULL, NULL, 234656),
(281661, '3ab1B01', NULL, NULL, 236, NULL, NULL, 234656),
(281662, '4fk1A02', NULL, NULL, 112, NULL, NULL, 234656),
(281663, '4fk1A01', NULL, NULL, 192, NULL, NULL, 234656),
(281664, '5dbjD00', NULL, NULL, 455, NULL, NULL, 234656),
(281665, '3itjA02', NULL, NULL, 126, NULL, NULL, 234656),
(281666, '2hqmA01', NULL, NULL, 237, NULL, NULL, 234656),
(281667, '2hqmA02', NULL, NULL, 121, NULL, NULL, 234656),
(281668, '3o0hB02', NULL, NULL, 118, NULL, NULL, 234656),
(281669, '4dshB00', NULL, NULL, 484, NULL, NULL, 234656),
(281670, '3jskB02', NULL, NULL, 266, NULL, NULL, 234656),
(281671, '3o0hB01', NULL, NULL, 218, NULL, NULL, 234656),
(281672, '6bz0A02', NULL, NULL, 122, NULL, NULL, 234656),
(281673, '1gpeA01', NULL, NULL, 204, NULL, NULL, 234656),
(281674, '4at0A01', NULL, NULL, 357, NULL, NULL, 234656);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(281675, '5x68A00', NULL, NULL, 375, NULL, NULL, 234656),
(281676, '6frlA00', NULL, NULL, 511, NULL, NULL, 234656),
(281677, '4jnqA01', NULL, NULL, 186, NULL, NULL, 234656),
(281678, '4jnqA02', NULL, NULL, 130, NULL, NULL, 234656),
(281679, '1d5tA01', NULL, NULL, 175, NULL, NULL, 234656),
(281680, '1lqtB02', NULL, NULL, 232, NULL, NULL, 234656),
(281681, '2bs2A01', NULL, NULL, 329, NULL, NULL, 234656),
(281682, '5v36A01', NULL, NULL, 222, NULL, NULL, 234656),
(281683, '5v36A02', NULL, NULL, 118, NULL, NULL, 234656),
(281684, '5hy5B00', NULL, NULL, 523, NULL, NULL, 234656),
(281685, '1dxlA01', NULL, NULL, 225, NULL, NULL, 234656),
(281686, '1zoyA01', NULL, NULL, 336, NULL, NULL, 234656),
(281687, '1dxlA02', NULL, NULL, 124, NULL, NULL, 234656),
(281688, '3c4nA01', NULL, NULL, 247, NULL, NULL, 234656),
(281689, '3ctyA02', NULL, NULL, 123, NULL, NULL, 234656),
(281690, '5fs8A02', NULL, NULL, 166, NULL, NULL, 234656),
(281691, '5fs8A01', NULL, NULL, 165, NULL, NULL, 234656),
(281692, '5kxjA01', NULL, NULL, 262, NULL, NULL, 234656),
(281693, '3k30A03', NULL, NULL, 133, NULL, NULL, 234656),
(281694, '2gv8A01', NULL, NULL, 342, NULL, NULL, 234656),
(281695, '6bz0D01', NULL, NULL, 231, NULL, NULL, 234656),
(281696, '3ayjA01', NULL, NULL, 412, NULL, NULL, 234656),
(281697, '4uirB01', NULL, NULL, 358, NULL, NULL, 234656),
(281698, '2gv8A02', NULL, NULL, 105, NULL, NULL, 234656),
(281699, '2xveC01', NULL, NULL, 345, NULL, NULL, 234656),
(281700, '5uthA01', NULL, NULL, 196, NULL, NULL, 234656),
(281701, '5uthA02', NULL, NULL, 123, NULL, NULL, 234656),
(281702, '6cmzA01', NULL, NULL, 221, NULL, NULL, 234656),
(281703, '6cmzA02', NULL, NULL, 119, NULL, NULL, 234656),
(281704, '3da1A01', NULL, NULL, 254, NULL, NULL, 234656),
(281705, '2whdA02', NULL, NULL, 128, NULL, NULL, 234656),
(281706, '5vn0A01', NULL, NULL, 168, NULL, NULL, 234656),
(281707, '4usrA00', NULL, NULL, 361, NULL, NULL, 234656),
(281708, '1o94A03', NULL, NULL, 152, NULL, NULL, 234656),
(281709, '4x4jA01', NULL, NULL, 293, NULL, NULL, 234656),
(281710, '1fl2A02', NULL, NULL, 124, NULL, NULL, 234656),
(281711, '3d1cA02', NULL, NULL, 124, NULL, NULL, 234656),
(281712, '2dkhA01', NULL, NULL, 257, NULL, NULL, 234656),
(281713, '3itjC01', NULL, NULL, 192, NULL, NULL, 234656),
(281714, '3iwaA01', NULL, NULL, 160, NULL, NULL, 234656),
(281715, '3ctyB01', NULL, NULL, 196, NULL, NULL, 234656),
(281716, '3iwaA02', NULL, NULL, 256, NULL, NULL, 234656),
(281717, '1v59A02', NULL, NULL, 126, NULL, NULL, 234656),
(281718, '1v59A01', NULL, NULL, 229, NULL, NULL, 234656),
(281719, '4hb9A01', NULL, NULL, 389, NULL, NULL, 234656),
(281720, '6a37A01', NULL, NULL, 297, NULL, NULL, 234656),
(281721, '5u1oB01', NULL, NULL, 227, NULL, NULL, 234656),
(281722, '2v3aA02', NULL, NULL, 135, NULL, NULL, 234656),
(281723, '2v3aA01', NULL, NULL, 170, NULL, NULL, 234656),
(281724, '3uoxB01', NULL, NULL, 300, NULL, NULL, 234656),
(281725, '5x1yB01', NULL, NULL, 217, NULL, NULL, 234656),
(281726, '2jbvB01', NULL, NULL, 228, NULL, NULL, 234656),
(281727, '3oc4B01', NULL, NULL, 198, NULL, NULL, 234656),
(281728, '2wpfC01', NULL, NULL, 242, NULL, NULL, 234656),
(281729, '1nhpA02', NULL, NULL, 150, NULL, NULL, 234656),
(281730, '1nhpA01', NULL, NULL, 167, NULL, NULL, 234656),
(281731, '3cgbA01', NULL, NULL, 168, NULL, NULL, 234656),
(281732, '4ysxA01', NULL, NULL, 330, NULL, NULL, 234656),
(281733, '2whdB01', NULL, NULL, 190, NULL, NULL, 234656),
(281734, '4ntdA01', NULL, NULL, 208, NULL, NULL, 234656),
(281735, '4ntdA02', NULL, NULL, 110, NULL, NULL, 234656),
(281736, '1onfA01', NULL, NULL, 261, NULL, NULL, 234656),
(281737, '4ha6A01', NULL, NULL, 245, NULL, NULL, 234656),
(281738, '1onfA02', NULL, NULL, 118, NULL, NULL, 234656),
(281739, '3r9uB01', NULL, NULL, 190, NULL, NULL, 234656),
(281740, '4n9xA01', NULL, NULL, 327, NULL, NULL, 234656),
(281741, '1sezA01', NULL, NULL, 199, NULL, NULL, 234656),
(281742, '3cgbA02', NULL, NULL, 149, NULL, NULL, 234656),
(281743, '3ic9C01', NULL, NULL, 155, NULL, NULL, 234656),
(281744, '5eb4B01', NULL, NULL, 343, NULL, NULL, 234656),
(281745, '6fhoA01', NULL, NULL, 206, NULL, NULL, 234656);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(281746, '2weuA00', NULL, NULL, 511, NULL, NULL, 234656),
(281747, '3kkjA01', NULL, NULL, 161, NULL, NULL, 234656),
(281748, '6hnsA02', NULL, NULL, 100, NULL, NULL, 234656),
(281749, '4zcdB01', NULL, NULL, 161, NULL, NULL, 234656),
(281750, '1zmdA02', NULL, NULL, 126, NULL, NULL, 234656),
(281751, '5u1oA02', NULL, NULL, 118, NULL, NULL, 234656),
(281752, '2r0cA01', NULL, NULL, 265, NULL, NULL, 234656),
(281753, '6awaA01', NULL, NULL, 232, NULL, NULL, 234656),
(281754, '6awaA02', NULL, NULL, 122, NULL, NULL, 234656),
(281755, '1ryiA01', NULL, NULL, 242, NULL, NULL, 234656),
(281756, '2xveA02', NULL, NULL, 100, NULL, NULL, 234656),
(281757, '3h8lA01', NULL, NULL, 206, NULL, NULL, 234656),
(281758, '5j7xA01', NULL, NULL, 312, NULL, NULL, 234656),
(281759, '3h8lA02', NULL, NULL, 151, NULL, NULL, 234656),
(281760, '2jk6A02', NULL, NULL, 121, NULL, NULL, 234656),
(281761, '3r9uA02', NULL, NULL, 123, NULL, NULL, 234656),
(281762, '1rp0A02', NULL, NULL, 236, NULL, NULL, 234656),
(281763, '3dgzA01', NULL, NULL, 236, NULL, NULL, 234656),
(281764, '3r9uA01', NULL, NULL, 190, NULL, NULL, 234656),
(281765, '2r9zA02', NULL, NULL, 118, NULL, NULL, 234656),
(281766, '3dgzA02', NULL, NULL, 124, NULL, NULL, 234656),
(281767, '2rghA01', NULL, NULL, 273, NULL, NULL, 234656),
(281768, '1vg0A01', NULL, NULL, 217, NULL, NULL, 234656),
(281769, '4pabA01', NULL, NULL, 245, NULL, NULL, 234656),
(281770, '6hnsB01', NULL, NULL, 354, NULL, NULL, 234656),
(281771, '4gcmB01', NULL, NULL, 187, NULL, NULL, 234656),
(281772, '2qa2A01', NULL, NULL, 303, NULL, NULL, 234656),
(281773, '4jn9A02', NULL, NULL, 107, NULL, NULL, 234656),
(281774, '2q7vA01', NULL, NULL, 202, NULL, NULL, 234656),
(281775, '2q7vA02', NULL, NULL, 123, NULL, NULL, 234656),
(281776, '1q1rA01', NULL, NULL, 196, NULL, NULL, 234656),
(281777, '2uzzB01', NULL, NULL, 174, NULL, NULL, 234656),
(281778, '1q1rA02', NULL, NULL, 131, NULL, NULL, 234656),
(281779, '4jn9A01', NULL, NULL, 192, NULL, NULL, 234656),
(281780, '3c4aA01', NULL, NULL, 233, NULL, NULL, 234656),
(281781, '1k0iA01', NULL, NULL, 240, NULL, NULL, 234656),
(281782, '3nksA00', NULL, NULL, 477, NULL, NULL, 234656),
(281783, '4k5sA01', NULL, NULL, 311, NULL, NULL, 234656),
(281784, '3kveA02', NULL, NULL, 148, NULL, NULL, 234656),
(281785, '1ps9A03', NULL, NULL, 157, NULL, NULL, 234656),
(281786, '6jdkA01', NULL, NULL, 310, NULL, NULL, 234656),
(281787, '5mitA02', NULL, NULL, 124, NULL, NULL, 234656),
(281788, '2wpfA02', NULL, NULL, 121, NULL, NULL, 234656),
(281789, '3fpzB02', NULL, NULL, 262, NULL, NULL, 234656),
(281790, '2r9zB01', NULL, NULL, 218, NULL, NULL, 234656),
(281791, '6fw0A01', NULL, NULL, 197, NULL, NULL, 234656),
(281792, '4u8iA01', NULL, NULL, 502, NULL, NULL, 234656),
(281793, '5lv9A00', NULL, NULL, 513, NULL, NULL, 234656),
(281794, '2jk6A01', NULL, NULL, 239, NULL, NULL, 234656),
(281795, '4gcmA02', NULL, NULL, 124, NULL, NULL, 234656),
(281796, '4dgkA01', NULL, NULL, 181, NULL, NULL, 234656),
(281797, '2vvmB01', NULL, NULL, 273, NULL, NULL, 234656),
(281798, '6fmuA03', NULL, NULL, 130, NULL, NULL, 234656),
(281799, '5mitA01', NULL, NULL, 178, NULL, NULL, 234656),
(281800, '3p1wA01', NULL, NULL, 192, NULL, NULL, 234656),
(281801, '3kljA02', NULL, NULL, 110, NULL, NULL, 234656),
(281802, '3kljA01', NULL, NULL, 192, NULL, NULL, 234656),
(281803, '3fg2P02', NULL, NULL, 126, NULL, NULL, 234656),
(281804, '3fg2P01', NULL, NULL, 192, NULL, NULL, 234656),
(281805, '2vouB01', NULL, NULL, 250, NULL, NULL, 234656),
(281806, '6fmuA02', NULL, NULL, 232, NULL, NULL, 234656),
(281807, '5cqfA00', NULL, NULL, 443, NULL, NULL, 234656),
(281808, '1vdcA01', NULL, NULL, 192, NULL, NULL, 234656),
(281809, '5x1yA02', NULL, NULL, 122, NULL, NULL, 234656),
(281810, '1vdcA02', NULL, NULL, 132, NULL, NULL, 234656),
(281811, '2zbwA02', NULL, NULL, 123, NULL, NULL, 234656),
(281812, '3nt6A02', NULL, NULL, 274, NULL, NULL, 234656),
(281813, '3ps9A02', NULL, NULL, 265, NULL, NULL, 234656),
(281814, '4tm3A00', NULL, NULL, 415, NULL, NULL, 234656),
(281815, '2ywlA01', NULL, NULL, 173, NULL, NULL, 234656),
(281816, '2yquA01', NULL, NULL, 215, NULL, NULL, 234656);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(281817, '4rslA01', NULL, NULL, 227, NULL, NULL, 234656),
(281818, '2yquA02', NULL, NULL, 119, NULL, NULL, 234656),
(281819, '3gwfA01', NULL, NULL, 309, NULL, NULL, 234656),
(281820, '3q9tA01', NULL, NULL, 255, NULL, NULL, 234656),
(281821, '5oc1A01', NULL, NULL, 255, NULL, NULL, 234656),
(281822, '2ivdB01', NULL, NULL, 169, NULL, NULL, 234656),
(281823, '5w1jA02', NULL, NULL, 229, NULL, NULL, 234656),
(281824, '5w1jA03', NULL, NULL, 130, NULL, NULL, 234656),
(281825, '5koxA01', NULL, NULL, 295, NULL, NULL, 234656),
(281826, '2b9wA01', NULL, NULL, 211, NULL, NULL, 234656),
(281827, '4cy8A01', NULL, NULL, 256, NULL, NULL, 234656),
(281828, '1reoA02', NULL, NULL, 148, NULL, NULL, 234656),
(281829, '1pj5A01', NULL, NULL, 243, NULL, NULL, 234656),
(281830, '3we0A01', NULL, NULL, 270, NULL, NULL, 234656),
(281831, '1fcdA02', NULL, NULL, 139, NULL, NULL, 234656),
(281832, '1fcdA01', NULL, NULL, 188, NULL, NULL, 234656),
(281833, '6dllA01', NULL, NULL, 243, NULL, NULL, 234656),
(281834, '2qaeA02', NULL, NULL, 124, NULL, NULL, 234656),
(281835, '6nsdB00', NULL, NULL, 520, NULL, NULL, 234656),
(281836, '1pn0A01', NULL, NULL, 254, NULL, NULL, 234656),
(281837, '4h4rA01', NULL, NULL, 189, NULL, NULL, 234656),
(281838, '4k22B01', NULL, NULL, 257, NULL, NULL, 234656),
(281839, '6b4oA01', NULL, NULL, 221, NULL, NULL, 234656),
(281840, '1d4dA02', NULL, NULL, 319, NULL, NULL, 234656),
(281841, '1x31B01', NULL, NULL, 233, NULL, NULL, 234656),
(281842, '4zn0A01', NULL, NULL, 184, NULL, NULL, 234656),
(281843, '4zn0A02', NULL, NULL, 127, NULL, NULL, 234656),
(281844, '3axbA01', NULL, NULL, 248, NULL, NULL, 234656),
(281845, '6b4oA02', NULL, NULL, 118, NULL, NULL, 234656),
(281846, '4k7zA01', NULL, NULL, 224, NULL, NULL, 234656),
(281847, '4k7zA02', NULL, NULL, 117, NULL, NULL, 234656),
(281848, '4x9mA01', NULL, NULL, 225, NULL, NULL, 234656),
(281849, '1gteA04', NULL, NULL, 153, NULL, NULL, 234656),
(281850, '1aogA02', NULL, NULL, 121, NULL, NULL, 234656),
(281851, '5y77B01', NULL, NULL, 379, NULL, NULL, 234656),
(281852, '1gteA03', NULL, NULL, 196, NULL, NULL, 234656),
(281853, '1y0pA02', NULL, NULL, 323, NULL, NULL, 234656),
(281854, '3c96A01', NULL, NULL, 171, NULL, NULL, 234656),
(281855, '5usxA01', NULL, NULL, 188, NULL, NULL, 234656),
(281856, '3f8dB01', NULL, NULL, 195, NULL, NULL, 234656),
(281857, '3i6dA01', NULL, NULL, 161, NULL, NULL, 234656),
(281858, '2wdqA01', NULL, NULL, 325, NULL, NULL, 234656),
(281859, '3ka7A01', NULL, NULL, 214, NULL, NULL, 234656),
(281860, '1b37A01', NULL, NULL, 254, NULL, NULL, 234656),
(281861, '2bryA01', NULL, NULL, 497, NULL, NULL, 234656),
(281862, '2z5yA01', NULL, NULL, 195, NULL, NULL, 234656),
(281863, '1zovA01', NULL, NULL, 184, NULL, NULL, 234656),
(281864, '5uaoC00', NULL, NULL, 516, NULL, NULL, 234656),
(281865, '2qaeA01', NULL, NULL, 223, NULL, NULL, 234656),
(281866, '2gf3A01', NULL, NULL, 187, NULL, NULL, 234656),
(281867, '1mo9A01', NULL, NULL, 205, NULL, NULL, 234656),
(281868, '1mo9A02', NULL, NULL, 135, NULL, NULL, 234656),
(281869, '1aogB01', NULL, NULL, 237, NULL, NULL, 234656),
(281870, '4ia6B01', NULL, NULL, 313, NULL, NULL, 234656),
(281871, '4ywoA02', NULL, NULL, 117, NULL, NULL, 234656),
(281872, '6c87A01', NULL, NULL, 191, NULL, NULL, 234656),
(281873, '4ywoA01', NULL, NULL, 222, NULL, NULL, 234656),
(281874, '4iv9A01', NULL, NULL, 262, NULL, NULL, 234656),
(281875, '1qo8D03', NULL, NULL, 314, NULL, NULL, 234656),
(281876, '2q0lA01', NULL, NULL, 187, NULL, NULL, 234656),
(281877, '6er9B01', NULL, NULL, 319, NULL, NULL, 234656),
(281878, '2e4gA00', NULL, NULL, 530, NULL, NULL, 234656),
(281879, '2qcuB01', NULL, NULL, 229, NULL, NULL, 234656),
(281880, '2q0lA02', NULL, NULL, 124, NULL, NULL, 234656),
(281881, '1y56B01', NULL, NULL, 231, NULL, NULL, 234656),
(281882, '3f8dA02', NULL, NULL, 123, NULL, NULL, 234656),
(281883, '6du7A02', NULL, NULL, 117, NULL, NULL, 234656),
(281884, '6du7A01', NULL, NULL, 218, NULL, NULL, 234656),
(281885, '5twbA01', NULL, NULL, 221, NULL, NULL, 234656),
(281886, '4up3A02', NULL, NULL, 126, NULL, NULL, 234656),
(281887, '1coyA01', NULL, NULL, 331, NULL, NULL, 234656);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(281888, '4kprB01', NULL, NULL, 242, NULL, NULL, 234656),
(281889, '4up3A01', NULL, NULL, 187, NULL, NULL, 234656),
(281890, '3l8kA02', NULL, NULL, 124, NULL, NULL, 234656),
(281891, '3l8kA01', NULL, NULL, 218, NULL, NULL, 234656),
(281892, '4emiA01', NULL, NULL, 177, NULL, NULL, 234656),
(281893, '1xhcA01', NULL, NULL, 188, NULL, NULL, 234656),
(281894, '2cduA01', NULL, NULL, 167, NULL, NULL, 234656),
(281895, '1xhcA02', NULL, NULL, 118, NULL, NULL, 234656),
(281896, '2cduA02', NULL, NULL, 151, NULL, NULL, 234656),
(281897, '3ic9A03', NULL, NULL, 122, NULL, NULL, 234656),
(281898, '3ladA01', NULL, NULL, 228, NULL, NULL, 234656),
(281899, '3ladA02', NULL, NULL, 122, NULL, NULL, 234656),
(281900, '6cr0A01', NULL, NULL, 228, NULL, NULL, 234656),
(281901, '4ntcA01', NULL, NULL, 211, NULL, NULL, 234656),
(281902, '4ntcA02', NULL, NULL, 124, NULL, NULL, 234656),
(281903, '4fx9A02', NULL, NULL, 148, NULL, NULL, 234656),
(281904, '3lovA01', NULL, NULL, 162, NULL, NULL, 234656),
(281905, '3lzwA02', NULL, NULL, 119, NULL, NULL, 234656),
(281906, '3lzwA01', NULL, NULL, 213, NULL, NULL, 234656),
(281907, '4i59A01', NULL, NULL, 213, NULL, NULL, 234656),
(281908, '5n1tA02', NULL, NULL, 134, NULL, NULL, 234656),
(281909, '5n1tA01', NULL, NULL, 188, NULL, NULL, 234656),
(281910, '3oc4A02', NULL, NULL, 124, NULL, NULL, 234656),
(281911, '3dmeA01', NULL, NULL, 216, NULL, NULL, 234656),
(281912, '1y56A02', NULL, NULL, 223, NULL, NULL, 234656),
(281913, '2qa1A01', NULL, NULL, 302, NULL, NULL, 234656),
(281914, '3dghA01', NULL, NULL, 237, NULL, NULL, 234656),
(281915, '3ef6A02', NULL, NULL, 120, NULL, NULL, 234656),
(281916, '3dghA02', NULL, NULL, 123, NULL, NULL, 234656),
(281917, '4kprA02', NULL, NULL, 126, NULL, NULL, 234656),
(281918, '2h88A01', NULL, NULL, 335, NULL, NULL, 234656),
(281919, '5u25A01', NULL, NULL, 231, NULL, NULL, 234656),
(281920, '4opcA00', NULL, NULL, 453, NULL, NULL, 234656),
(281921, '5m10A01', NULL, NULL, 311, NULL, NULL, 234656),
(281922, '2gmhA01', NULL, NULL, 261, NULL, NULL, 234656),
(281923, '6aonA02', NULL, NULL, 123, NULL, NULL, 234656),
(281924, '4jq9A01', NULL, NULL, 220, NULL, NULL, 234656),
(281925, '4jq9A02', NULL, NULL, 122, NULL, NULL, 234656),
(281926, '6aonA01', NULL, NULL, 234, NULL, NULL, 234656),
(281927, '1xdiA01', NULL, NULL, 225, NULL, NULL, 234656),
(281928, '5x6rB00', NULL, NULL, 392, NULL, NULL, 234656),
(281929, '1xdiA02', NULL, NULL, 119, NULL, NULL, 234656),
(281930, '6n7fA01', NULL, NULL, 222, NULL, NULL, 234656),
(281931, '5xgvA01', NULL, NULL, 287, NULL, NULL, 234656),
(281932, '2gqwA02', NULL, NULL, 123, NULL, NULL, 234656),
(281933, '3kd9A01', NULL, NULL, 192, NULL, NULL, 234656),
(281934, '3kd9A02', NULL, NULL, 255, NULL, NULL, 234656),
(281935, '3redA01', NULL, NULL, 332, NULL, NULL, 234656),
(281936, '6n7fA02', NULL, NULL, 118, NULL, NULL, 234656),
(281937, '3nixB00', NULL, NULL, 421, NULL, NULL, 234656),
(281938, '5xaoA01', NULL, NULL, 226, NULL, NULL, 234656),
(281939, '3qfaA02', NULL, NULL, 126, NULL, NULL, 234656),
(281940, '3qfaA01', NULL, NULL, 232, NULL, NULL, 234656),
(281941, '3ntdA01', NULL, NULL, 196, NULL, NULL, 234656),
(281942, '5utxA02', NULL, NULL, 127, NULL, NULL, 234656),
(281943, '3i3lA01', NULL, NULL, 447, NULL, NULL, 234656),
(281944, '2bc0A01', NULL, NULL, 217, NULL, NULL, 234656),
(281945, '2bc0A02', NULL, NULL, 136, NULL, NULL, 234656),
(281946, '5figA00', NULL, NULL, 108, NULL, NULL, 234657),
(281947, '3kawB00', NULL, NULL, 110, NULL, NULL, 234657),
(281948, '3lmfA00', NULL, NULL, 121, NULL, NULL, 234657),
(281949, '2m3dA01', NULL, NULL, 78, NULL, NULL, 234658),
(281950, '2e29A01', NULL, NULL, 76, NULL, NULL, 234658),
(281951, '4e45B01', NULL, NULL, 41, NULL, NULL, 234659),
(281952, '3b0bC01', NULL, NULL, 38, NULL, NULL, 234659),
(281953, '4draE01', NULL, NULL, 42, NULL, NULL, 234659),
(281954, '4ne3B01', NULL, NULL, 32, NULL, NULL, 234659),
(281955, '2kq9A00', NULL, NULL, 112, NULL, NULL, 234660),
(281956, '1tjlA00', NULL, NULL, 151, NULL, NULL, 234660),
(281957, '4ijjB00', NULL, NULL, 136, NULL, NULL, 234660),
(281958, '2lgnA00', NULL, NULL, 66, NULL, NULL, 234661);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(281959, '2p64A00', NULL, NULL, 52, NULL, NULL, 234662),
(281960, '2oaaB01', NULL, NULL, 109, NULL, NULL, 234663),
(281961, '2odiA01', NULL, NULL, 123, NULL, NULL, 234663),
(281962, '3ehhB01', NULL, NULL, 70, NULL, NULL, 234664),
(281963, '3ehhA01', NULL, NULL, 88, NULL, NULL, 234664),
(281964, '3ehfD01', NULL, NULL, 67, NULL, NULL, 234664),
(281965, '2db7A01', NULL, NULL, 55, NULL, NULL, 234665),
(281966, '3ze3E00', NULL, NULL, 86, NULL, NULL, 234666),
(281967, '3ze3A00', NULL, NULL, 130, NULL, NULL, 234666),
(281968, '3ze4C00', NULL, NULL, 94, NULL, NULL, 234666),
(281969, '3ze3B00', NULL, NULL, 98, NULL, NULL, 234666),
(281970, '3ze4A00', NULL, NULL, 130, NULL, NULL, 234666),
(281971, '4lo6B03', NULL, NULL, 122, NULL, NULL, 234667),
(281972, '4en6B03', NULL, NULL, 110, NULL, NULL, 234667),
(281973, '2z5bA00', NULL, NULL, 151, NULL, NULL, 234668),
(281974, '4b2sA02', NULL, NULL, 59, NULL, NULL, 234669),
(281975, '2wiiC02', NULL, NULL, 61, NULL, NULL, 234669),
(281976, '2wiiC03', NULL, NULL, 64, NULL, NULL, 234669),
(281977, '1tpmA00', NULL, NULL, 50, NULL, NULL, 234669),
(281978, '2wiiC04', NULL, NULL, 57, NULL, NULL, 234669),
(281979, '3t5oA04', NULL, NULL, 63, NULL, NULL, 234669),
(281980, '3t5oA03', NULL, NULL, 62, NULL, NULL, 234669),
(281981, '2kmsA02', NULL, NULL, 58, NULL, NULL, 234669),
(281982, '6atgA00', NULL, NULL, 61, NULL, NULL, 234669),
(281983, '3zd2A02', NULL, NULL, 60, NULL, NULL, 234669),
(281984, '4c16A04', NULL, NULL, 61, NULL, NULL, 234669),
(281985, '4c16A03', NULL, NULL, 62, NULL, NULL, 234669),
(281986, '1ly2A02', NULL, NULL, 59, NULL, NULL, 234669),
(281987, '1ly2A01', NULL, NULL, 65, NULL, NULL, 234669),
(281988, '4kkdB02', NULL, NULL, 77, NULL, NULL, 234669),
(281989, '1zjkA02', NULL, NULL, 76, NULL, NULL, 234669),
(281990, '1zjkA01', NULL, NULL, 80, NULL, NULL, 234669),
(281991, '5i0qB02', NULL, NULL, 62, NULL, NULL, 234669),
(281992, '2xwbF01', NULL, NULL, 68, NULL, NULL, 234669),
(281993, '5i0qB01', NULL, NULL, 66, NULL, NULL, 234669),
(281994, '2qy0A01', NULL, NULL, 69, NULL, NULL, 234669),
(281995, '3erbA03', NULL, NULL, 60, NULL, NULL, 234669),
(281996, '3erbA02', NULL, NULL, 60, NULL, NULL, 234669),
(281997, '2ybyA01', NULL, NULL, 65, NULL, NULL, 234669),
(281998, '3erbA01', NULL, NULL, 66, NULL, NULL, 234669),
(281999, '2ybyA02', NULL, NULL, 59, NULL, NULL, 234669),
(282000, '2cg7A01', NULL, NULL, 46, NULL, NULL, 234669),
(282001, '2cg7A02', NULL, NULL, 44, NULL, NULL, 234669),
(282002, '1hfiA00', NULL, NULL, 62, NULL, NULL, 234669),
(282003, '1h03P01', NULL, NULL, 62, NULL, NULL, 234669),
(282004, '2mczA01', NULL, NULL, 65, NULL, NULL, 234669),
(282005, '2xrbA02', NULL, NULL, 62, NULL, NULL, 234669),
(282006, '2xrbA01', NULL, NULL, 60, NULL, NULL, 234669),
(282007, '2xrbA04', NULL, NULL, 61, NULL, NULL, 234669),
(282008, '3sw0X02', NULL, NULL, 61, NULL, NULL, 234669),
(282009, '1h03P02', NULL, NULL, 61, NULL, NULL, 234669),
(282010, '3sw0X01', NULL, NULL, 60, NULL, NULL, 234669),
(282011, '2xrbA03', NULL, NULL, 71, NULL, NULL, 234669),
(282012, '4ayiA02', NULL, NULL, 58, NULL, NULL, 234669),
(282013, '2iz4A01', NULL, NULL, 52, NULL, NULL, 234669),
(282014, '4ayiE01', NULL, NULL, 67, NULL, NULL, 234669),
(282015, '1ok3A02', NULL, NULL, 64, NULL, NULL, 234669),
(282016, '1ok3A01', NULL, NULL, 64, NULL, NULL, 234669),
(282017, '2rkyC02', NULL, NULL, 47, NULL, NULL, 234669),
(282018, '3o8eD02', NULL, NULL, 64, NULL, NULL, 234669),
(282019, '1srzA00', NULL, NULL, 68, NULL, NULL, 234669),
(282020, '4b2rA01', NULL, NULL, 63, NULL, NULL, 234669),
(282021, '4b2rA02', NULL, NULL, 63, NULL, NULL, 234669),
(282022, '1qubA03', NULL, NULL, 62, NULL, NULL, 234669),
(282023, '2uwnA03', NULL, NULL, 61, NULL, NULL, 234669),
(282024, '1qubA02', NULL, NULL, 59, NULL, NULL, 234669),
(282025, '1qubA01', NULL, NULL, 62, NULL, NULL, 234669),
(282026, '1gkgA02', NULL, NULL, 69, NULL, NULL, 234669),
(282027, '4a5wB03', NULL, NULL, 68, NULL, NULL, 234669),
(282028, '4a5wB04', NULL, NULL, 63, NULL, NULL, 234669),
(282029, '1qubA04', NULL, NULL, 60, NULL, NULL, 234669),
(282030, '1hccA00', NULL, NULL, 59, NULL, NULL, 234669);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(282031, '4losA02', NULL, NULL, 69, NULL, NULL, 234669),
(282032, '3ix0B01', NULL, NULL, 52, NULL, NULL, 234669),
(282033, '2ehfA00', NULL, NULL, 73, NULL, NULL, 234669),
(282034, '3ejhA02', NULL, NULL, 50, NULL, NULL, 234669),
(282035, '3ejhA01', NULL, NULL, 43, NULL, NULL, 234669),
(282036, '1h04P01', NULL, NULL, 62, NULL, NULL, 234669),
(282037, '3op8A00', NULL, NULL, 85, NULL, NULL, 234669),
(282038, '2mcyA01', NULL, NULL, 66, NULL, NULL, 234669),
(282039, '1u5mA01', NULL, NULL, 36, NULL, NULL, 234669),
(282040, '4f4oC01', NULL, NULL, 57, NULL, NULL, 234669),
(282041, '4ynxB00', NULL, NULL, 42, NULL, NULL, 234669),
(282042, '1e5gA02', NULL, NULL, 58, NULL, NULL, 234669),
(282043, '1e5gA01', NULL, NULL, 62, NULL, NULL, 234669),
(282044, '2lojA01', NULL, NULL, 39, NULL, NULL, 234669),
(282045, '1g44C01', NULL, NULL, 65, NULL, NULL, 234669),
(282046, '4wjg201', NULL, NULL, 57, NULL, NULL, 234669),
(282047, '2yraA00', NULL, NULL, 74, NULL, NULL, 234669),
(282048, '3tvjA01', NULL, NULL, 68, NULL, NULL, 234669),
(282049, '2jraA01', NULL, NULL, 42, NULL, NULL, 234669),
(282050, '1g44C04', NULL, NULL, 44, NULL, NULL, 234669),
(282051, '4igdA01', NULL, NULL, 71, NULL, NULL, 234669),
(282052, '4igdA02', NULL, NULL, 77, NULL, NULL, 234669),
(282053, '1gknA02', NULL, NULL, 48, NULL, NULL, 234669),
(282054, '1gknA01', NULL, NULL, 67, NULL, NULL, 234669),
(282055, '3zd2B01', NULL, NULL, 65, NULL, NULL, 234669),
(282056, '4k12A00', NULL, NULL, 64, NULL, NULL, 234669),
(282057, '2rkyA01', NULL, NULL, 46, NULL, NULL, 234669),
(282058, '2b5iD01', NULL, NULL, 67, NULL, NULL, 234669),
(282059, '3o8eB01', NULL, NULL, 62, NULL, NULL, 234669),
(282060, '1o9aA01', NULL, NULL, 44, NULL, NULL, 234669),
(282061, '5hzpB01', NULL, NULL, 66, NULL, NULL, 234669),
(282062, '2rlpA01', NULL, NULL, 73, NULL, NULL, 234669),
(282063, '2ec3A01', NULL, NULL, 60, NULL, NULL, 234669),
(282064, '5fo8C02', NULL, NULL, 61, NULL, NULL, 234669),
(282065, '5fo8C01', NULL, NULL, 68, NULL, NULL, 234669),
(282066, '3kxvA01', NULL, NULL, 50, NULL, NULL, 234669),
(282067, '3zd1A02', NULL, NULL, 65, NULL, NULL, 234669),
(282068, '1vvcA02', NULL, NULL, 60, NULL, NULL, 234669),
(282069, '3zd1A01', NULL, NULL, 50, NULL, NULL, 234669),
(282070, '1ppqA01', NULL, NULL, 63, NULL, NULL, 234669),
(282071, '1elvA03', NULL, NULL, 69, NULL, NULL, 234669),
(282072, '3m7pA01', NULL, NULL, 39, NULL, NULL, 234669),
(282073, '3mqlA04', NULL, NULL, 57, NULL, NULL, 234669),
(282074, '1md8A03', NULL, NULL, 76, NULL, NULL, 234669),
(282075, '3r62A02', NULL, NULL, 66, NULL, NULL, 234669),
(282076, '2wiiC01', NULL, NULL, 70, NULL, NULL, 234669),
(282077, '1knzA02', NULL, NULL, 53, NULL, NULL, 234670),
(282078, '3euhA02', NULL, NULL, 193, NULL, NULL, 234671),
(282079, '2khkA00', NULL, NULL, 53, NULL, NULL, 234672),
(282080, '1lnsA03', NULL, NULL, 87, NULL, NULL, 234673),
(282081, '4j6eA02', NULL, NULL, 151, NULL, NULL, 234674),
(282082, '3n50B02', NULL, NULL, 67, NULL, NULL, 234675),
(282083, '2hcuA00', NULL, NULL, 189, NULL, NULL, 234676),
(282084, '2pkpA01', NULL, NULL, 159, NULL, NULL, 234676),
(282085, '3vbaA00', NULL, NULL, 176, NULL, NULL, 234676),
(282086, '3h5jA00', NULL, NULL, 171, NULL, NULL, 234676),
(282087, '3q3wB00', NULL, NULL, 183, NULL, NULL, 234676),
(282088, '2b3yA05', NULL, NULL, 235, NULL, NULL, 234676),
(282089, '1l5jA02', NULL, NULL, 200, NULL, NULL, 234676),
(282090, '1c96A04', NULL, NULL, 221, NULL, NULL, 234676),
(282091, '1v7lA01', NULL, NULL, 157, NULL, NULL, 234676),
(282092, '3snpA03', NULL, NULL, 230, NULL, NULL, 234676),
(282093, '3vu1A04', NULL, NULL, 132, NULL, NULL, 234677),
(282094, '3wovA04', NULL, NULL, 132, NULL, NULL, 234677),
(282095, '2zaiA04', NULL, NULL, 132, NULL, NULL, 234677),
(282096, '1mt1D00', NULL, NULL, 113, NULL, NULL, 234678),
(282097, '1n13B00', NULL, NULL, 113, NULL, NULL, 234678),
(282098, '1mt1B00', NULL, NULL, 113, NULL, NULL, 234678),
(282099, '1n2mC00', NULL, NULL, 165, NULL, NULL, 234678),
(282100, '1mt1H00', NULL, NULL, 113, NULL, NULL, 234678),
(282101, '1mt1F00', NULL, NULL, 113, NULL, NULL, 234678);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(282102, '1mt1L00', NULL, NULL, 113, NULL, NULL, 234678),
(282103, '1mt1J00', NULL, NULL, 113, NULL, NULL, 234678),
(282104, '1ibvB00', NULL, NULL, 228, NULL, NULL, 234678),
(282105, '2i32A00', NULL, NULL, 157, NULL, NULL, 234679),
(282106, '5ueaX00', NULL, NULL, 154, NULL, NULL, 234679),
(282107, '6a6yA00', NULL, NULL, 161, NULL, NULL, 234679),
(282108, '5zbaB00', NULL, NULL, 154, NULL, NULL, 234679),
(282109, '2dzeA00', NULL, NULL, 161, NULL, NULL, 234679),
(282110, '5bnxD00', NULL, NULL, 158, NULL, NULL, 234679),
(282111, '1rocA00', NULL, NULL, 155, NULL, NULL, 234679),
(282112, '2dgjA01', NULL, NULL, 127, NULL, NULL, 234680),
(282113, '2dgjB02', NULL, NULL, 130, NULL, NULL, 234680),
(282114, '1xvhB00', NULL, NULL, 129, NULL, NULL, 234680),
(282115, '4dncD00', NULL, NULL, 48, NULL, NULL, 234681),
(282116, '1bctA00', NULL, NULL, 69, NULL, NULL, 234682),
(282117, '4nv5B01', NULL, NULL, 182, NULL, NULL, 234683),
(282118, '2gzoA02', NULL, NULL, 89, NULL, NULL, 234684),
(282119, '2hafA02', NULL, NULL, 90, NULL, NULL, 234684),
(282120, '1l5aA02', NULL, NULL, 32, NULL, NULL, 234685),
(282121, '4hhxA00', NULL, NULL, 120, NULL, NULL, 234686),
(282122, '2whnA00', NULL, NULL, 116, NULL, NULL, 234686),
(282123, '3c1qA00', NULL, NULL, 123, NULL, NULL, 234686),
(282124, '5nbgA00', NULL, NULL, 109, NULL, NULL, 234686),
(282125, '4fm3A00', NULL, NULL, 98, NULL, NULL, 234687),
(282126, '1vs9W00', NULL, NULL, 67, NULL, NULL, 234688),
(282127, '1vwxh01', NULL, NULL, 77, NULL, NULL, 234688),
(282128, '1vx7301', NULL, NULL, 76, NULL, NULL, 234688),
(282129, '1vs8X00', NULL, NULL, 63, NULL, NULL, 234688),
(282130, '4a17U01', NULL, NULL, 78, NULL, NULL, 234688),
(282131, '5dm6V00', NULL, NULL, 66, NULL, NULL, 234688),
(282132, '4wfaV00', NULL, NULL, 69, NULL, NULL, 234688),
(282133, '3o58c00', NULL, NULL, 68, NULL, NULL, 234688),
(282134, '1vq8V00', NULL, NULL, 71, NULL, NULL, 234688),
(282135, '1r73A00', NULL, NULL, 66, NULL, NULL, 234688),
(282136, '3pyoY00', NULL, NULL, 62, NULL, NULL, 234688),
(282137, '1r89A01', NULL, NULL, 131, NULL, NULL, 234689),
(282138, '4pkwA02', NULL, NULL, 83, NULL, NULL, 234690),
(282139, '1dq3A02', NULL, NULL, 76, NULL, NULL, 234691),
(282140, '2gu0A01', NULL, NULL, 143, NULL, NULL, 234692),
(282141, '4g0aA01', NULL, NULL, 145, NULL, NULL, 234692),
(282142, '6f2mA01', NULL, NULL, 130, NULL, NULL, 234693),
(282143, '4nzrM02', NULL, NULL, 184, NULL, NULL, 234694),
(282144, '3k6qA02', NULL, NULL, 89, NULL, NULL, 234695),
(282145, '1jqpA01', NULL, NULL, 112, NULL, NULL, 234696),
(282146, '4oelA01', NULL, NULL, 117, NULL, NULL, 234696),
(282147, '4jdeB01', NULL, NULL, 139, NULL, NULL, 234697),
(282148, '4jdeA01', NULL, NULL, 137, NULL, NULL, 234697),
(282149, '3gg4B02', NULL, NULL, 176, NULL, NULL, 234698),
(282150, '3gg4A02', NULL, NULL, 176, NULL, NULL, 234698),
(282151, '3l0qA02', NULL, NULL, 176, NULL, NULL, 234698),
(282152, '3l0qB02', NULL, NULL, 176, NULL, NULL, 234698),
(282153, '2hgsA05', NULL, NULL, 68, NULL, NULL, 234699),
(282154, '1m0wB05', NULL, NULL, 62, NULL, NULL, 234699),
(282155, '3kalB05', NULL, NULL, 66, NULL, NULL, 234699),
(282156, '1ngmJ00', NULL, NULL, 53, NULL, NULL, 234700),
(282157, '1ngmB00', NULL, NULL, 72, NULL, NULL, 234700),
(282158, '5lznA00', NULL, NULL, 119, NULL, NULL, 234701),
(282159, '1wq6B00', NULL, NULL, 72, NULL, NULL, 234702),
(282160, '1wq6A00', NULL, NULL, 72, NULL, NULL, 234702),
(282161, '4jolA00', NULL, NULL, 64, NULL, NULL, 234702),
(282162, '4j4mA00', NULL, NULL, 202, NULL, NULL, 234703),
(282163, '1iagA00', NULL, NULL, 202, NULL, NULL, 234703),
(282164, '2o3eA03', NULL, NULL, 151, NULL, NULL, 234703),
(282165, '1budA00', NULL, NULL, 197, NULL, NULL, 234703),
(282166, '1hv5E00', NULL, NULL, 165, NULL, NULL, 234703),
(282167, '2x7mA01', NULL, NULL, 175, NULL, NULL, 234703),
(282168, '4dv8A03', NULL, NULL, 225, NULL, NULL, 234703),
(282169, '4iuwA01', NULL, NULL, 294, NULL, NULL, 234703),
(282170, '3khiA02', NULL, NULL, 126, NULL, NULL, 234703),
(282171, '2x3cA02', NULL, NULL, 171, NULL, NULL, 234703),
(282172, '1atlA00', NULL, NULL, 202, NULL, NULL, 234703);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(282173, '3ma2D00', NULL, NULL, 181, NULL, NULL, 234703),
(282174, '1su3A01', NULL, NULL, 250, NULL, NULL, 234703),
(282175, '4on1A02', NULL, NULL, 211, NULL, NULL, 234703),
(282176, '1quaA00', NULL, NULL, 197, NULL, NULL, 234703),
(282177, '4in9A00', NULL, NULL, 166, NULL, NULL, 234703),
(282178, '3k7lA01', NULL, NULL, 210, NULL, NULL, 234703),
(282179, '1kapP02', NULL, NULL, 233, NULL, NULL, 234703),
(282180, '1hovA00', NULL, NULL, 163, NULL, NULL, 234703),
(282181, '4wk7A00', NULL, NULL, 235, NULL, NULL, 234703),
(282182, '1wniA00', NULL, NULL, 201, NULL, NULL, 234703),
(282183, '3edgA00', NULL, NULL, 202, NULL, NULL, 234703),
(282184, '3vtgA00', NULL, NULL, 200, NULL, NULL, 234703),
(282185, '2dw0A01', NULL, NULL, 204, NULL, NULL, 234703),
(282186, '6esmA00', NULL, NULL, 160, NULL, NULL, 234703),
(282187, '1iabA00', NULL, NULL, 200, NULL, NULL, 234703),
(282188, '2w15A00', NULL, NULL, 202, NULL, NULL, 234703),
(282189, '2o36A03', NULL, NULL, 151, NULL, NULL, 234703),
(282190, '3v96B00', NULL, NULL, 165, NULL, NULL, 234703),
(282191, '1g12A00', NULL, NULL, 167, NULL, NULL, 234703),
(282192, '1i76A00', NULL, NULL, 163, NULL, NULL, 234703),
(282193, '2y6dA00', NULL, NULL, 174, NULL, NULL, 234703),
(282194, '3b8zA00', NULL, NULL, 217, NULL, NULL, 234703),
(282195, '5b5oA00', NULL, NULL, 172, NULL, NULL, 234703),
(282196, '3gboA00', NULL, NULL, 200, NULL, NULL, 234703),
(282197, '1ck7A01', NULL, NULL, 235, NULL, NULL, 234703),
(282198, '1r55A00', NULL, NULL, 214, NULL, NULL, 234703),
(282199, '4df9A02', NULL, NULL, 229, NULL, NULL, 234703),
(282200, '1rm8A00', NULL, NULL, 169, NULL, NULL, 234703),
(282201, '2ddfA00', NULL, NULL, 257, NULL, NULL, 234703),
(282202, '1xfxA01', NULL, NULL, 228, NULL, NULL, 234703),
(282203, '2jsdA00', NULL, NULL, 160, NULL, NULL, 234703),
(282204, '1k7iA02', NULL, NULL, 227, NULL, NULL, 234703),
(282205, '3zukA01', NULL, NULL, 318, NULL, NULL, 234703),
(282206, '3hdbA01', NULL, NULL, 202, NULL, NULL, 234703),
(282207, '4l63A00', NULL, NULL, 266, NULL, NULL, 234703),
(282208, '3u1rA02', NULL, NULL, 228, NULL, NULL, 234703),
(282209, '1slmA00', NULL, NULL, 255, NULL, NULL, 234703),
(282210, '2v4bA01', NULL, NULL, 221, NULL, NULL, 234703),
(282211, '3dslB01', NULL, NULL, 204, NULL, NULL, 234703),
(282212, '3p24C02', NULL, NULL, 212, NULL, NULL, 234703),
(282213, '3ayuA00', NULL, NULL, 167, NULL, NULL, 234703),
(282214, '4q1lA00', NULL, NULL, 202, NULL, NULL, 234703),
(282215, '4fxqA01', NULL, NULL, 217, NULL, NULL, 234703),
(282216, '3lqbA00', NULL, NULL, 199, NULL, NULL, 234703),
(282217, '5lv0A03', NULL, NULL, 151, NULL, NULL, 234703),
(282218, '2l0rA00', NULL, NULL, 106, NULL, NULL, 234703),
(282219, '3g5cA01', NULL, NULL, 207, NULL, NULL, 234703),
(282220, '5th6B00', NULL, NULL, 231, NULL, NULL, 234703),
(282221, '2erqB01', NULL, NULL, 211, NULL, NULL, 234703),
(282222, '3dwbA01', NULL, NULL, 315, NULL, NULL, 234703),
(282223, '3k7nA01', NULL, NULL, 205, NULL, NULL, 234703),
(282224, '3zvsB00', NULL, NULL, 160, NULL, NULL, 234703),
(282225, '4gwmA01', NULL, NULL, 237, NULL, NULL, 234703),
(282226, '1hy7B00', NULL, NULL, 173, NULL, NULL, 234703),
(282227, '1c7kA00', NULL, NULL, 132, NULL, NULL, 234703),
(282228, '1cxvA00', NULL, NULL, 164, NULL, NULL, 234703),
(282229, '3ediA00', NULL, NULL, 201, NULL, NULL, 234703),
(282230, '3p1vA02', NULL, NULL, 228, NULL, NULL, 234703),
(282231, '3lmcA00', NULL, NULL, 192, NULL, NULL, 234703),
(282232, '2ckiA00', NULL, NULL, 262, NULL, NULL, 234703),
(282233, '5ue2A00', NULL, NULL, 247, NULL, NULL, 234703),
(282234, '1eb6A00', NULL, NULL, 177, NULL, NULL, 234703),
(282235, '1kufA00', NULL, NULL, 203, NULL, NULL, 234703),
(282236, '1g9kA02', NULL, NULL, 228, NULL, NULL, 234703),
(282237, '1fblA01', NULL, NULL, 174, NULL, NULL, 234703),
(282238, '1yp1A00', NULL, NULL, 202, NULL, NULL, 234703),
(282239, '1y93A00', NULL, NULL, 159, NULL, NULL, 234703),
(282240, '4dd8A00', NULL, NULL, 208, NULL, NULL, 234703),
(282241, '3hbvP01', NULL, NULL, 138, NULL, NULL, 234703),
(282242, '1hfcA00', NULL, NULL, 169, NULL, NULL, 234703),
(282243, '5d7wA02', NULL, NULL, 232, NULL, NULL, 234703);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(282244, '2e3xA01', NULL, NULL, 206, NULL, NULL, 234703),
(282245, '6gidA01', NULL, NULL, 322, NULL, NULL, 234703),
(282246, '1j7nA01', NULL, NULL, 222, NULL, NULL, 234703),
(282247, '4gehA00', NULL, NULL, 207, NULL, NULL, 234704),
(282248, '1vt0M02', NULL, NULL, 90, NULL, NULL, 234705),
(282249, '4ga6A02', NULL, NULL, 152, NULL, NULL, 234706),
(282250, '4n4nB00', NULL, NULL, 57, NULL, NULL, 234707),
(282251, '1ye9A01', NULL, NULL, 46, NULL, NULL, 234708),
(282252, '5ghxA00', NULL, NULL, 268, NULL, NULL, 234709),
(282253, '4r23A02', NULL, NULL, 312, NULL, NULL, 234709),
(282254, '5eooA00', NULL, NULL, 265, NULL, NULL, 234709),
(282255, '1xa7A00', NULL, NULL, 255, NULL, NULL, 234709),
(282256, '1k25B02', NULL, NULL, 315, NULL, NULL, 234709),
(282257, '4k91A01', NULL, NULL, 252, NULL, NULL, 234709),
(282258, '4netB00', NULL, NULL, 361, NULL, NULL, 234709),
(282259, '2efxF00', NULL, NULL, 363, NULL, NULL, 234709),
(282260, '5ul8A00', NULL, NULL, 271, NULL, NULL, 234709),
(282261, '3agdA01', NULL, NULL, 309, NULL, NULL, 234709),
(282262, '4u3tB00', NULL, NULL, 330, NULL, NULL, 234709),
(282263, '5evlA00', NULL, NULL, 373, NULL, NULL, 234709),
(282264, '5e2hA00', NULL, NULL, 357, NULL, NULL, 234709),
(282265, '2wadA04', NULL, NULL, 350, NULL, NULL, 234709),
(282266, '4ua6A00', NULL, NULL, 263, NULL, NULL, 234709),
(282267, '1es5A00', NULL, NULL, 262, NULL, NULL, 234709),
(282268, '4p6bB00', NULL, NULL, 390, NULL, NULL, 234709),
(282269, '1w5dA01', NULL, NULL, 248, NULL, NULL, 234709),
(282270, '3bydA00', NULL, NULL, 267, NULL, NULL, 234709),
(282271, '5ihvA00', NULL, NULL, 269, NULL, NULL, 234709),
(282272, '1qmeA02', NULL, NULL, 344, NULL, NULL, 234709),
(282273, '4bjpA03', NULL, NULL, 181, NULL, NULL, 234709),
(282274, '4ewfA00', NULL, NULL, 275, NULL, NULL, 234709),
(282275, '4dxbA03', NULL, NULL, 261, NULL, NULL, 234709),
(282276, '1q2qA00', NULL, NULL, 363, NULL, NULL, 234709),
(282277, '1ci9A00', NULL, NULL, 392, NULL, NULL, 234709),
(282278, '4s2lA00', NULL, NULL, 237, NULL, NULL, 234709),
(282279, '4bqmA00', NULL, NULL, 332, NULL, NULL, 234709),
(282280, '4e6xB00', NULL, NULL, 336, NULL, NULL, 234709),
(282281, '4d2oB00', NULL, NULL, 284, NULL, NULL, 234709),
(282282, '6nhsA00', NULL, NULL, 239, NULL, NULL, 234709),
(282283, '1bueA00', NULL, NULL, 265, NULL, NULL, 234709),
(282284, '4c6yA00', NULL, NULL, 262, NULL, NULL, 234709),
(282285, '1nrfA00', NULL, NULL, 262, NULL, NULL, 234709),
(282286, '1m40A00', NULL, NULL, 263, NULL, NULL, 234709),
(282287, '5eviA00', NULL, NULL, 366, NULL, NULL, 234709),
(282288, '5e2eA00', NULL, NULL, 269, NULL, NULL, 234709),
(282289, '1mkiA01', NULL, NULL, 188, NULL, NULL, 234709),
(282290, '4op5A00', NULL, NULL, 263, NULL, NULL, 234709),
(282291, '2cc1A00', NULL, NULL, 262, NULL, NULL, 234709),
(282292, '4drtA01', NULL, NULL, 263, NULL, NULL, 234709),
(282293, '5hw3A00', NULL, NULL, 269, NULL, NULL, 234709),
(282294, '4ivkA00', NULL, NULL, 410, NULL, NULL, 234709),
(282295, '3mzfA01', NULL, NULL, 262, NULL, NULL, 234709),
(282296, '4yfmA00', NULL, NULL, 275, NULL, NULL, 234709),
(282297, '2qmiA01', NULL, NULL, 347, NULL, NULL, 234709),
(282298, '5ne2A00', NULL, NULL, 278, NULL, NULL, 234709),
(282299, '3lo7A02', NULL, NULL, 299, NULL, NULL, 234709),
(282300, '2pbyA01', NULL, NULL, 164, NULL, NULL, 234709),
(282301, '4jf5A00', NULL, NULL, 243, NULL, NULL, 234709),
(282302, '4wz4A00', NULL, NULL, 360, NULL, NULL, 234709),
(282303, '4iedC00', NULL, NULL, 254, NULL, NULL, 234709),
(282304, '3mfdB01', NULL, NULL, 236, NULL, NULL, 234709),
(282305, '3vmaA02', NULL, NULL, 408, NULL, NULL, 234709),
(282306, '1e25A00', NULL, NULL, 282, NULL, NULL, 234709),
(282307, '5chuA00', NULL, NULL, 362, NULL, NULL, 234709),
(282308, '5fsrA01', NULL, NULL, 282, NULL, NULL, 234709),
(282309, '4ryeA00', NULL, NULL, 269, NULL, NULL, 234709),
(282310, '3zytA00', NULL, NULL, 372, NULL, NULL, 234709),
(282311, '3vskA03', NULL, NULL, 373, NULL, NULL, 234709),
(282312, '5kzhC00', NULL, NULL, 250, NULL, NULL, 234709),
(282313, '2olvA03', NULL, NULL, 325, NULL, NULL, 234709),
(282314, '3zg9B02', NULL, NULL, 356, NULL, NULL, 234709);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(282315, '3ue3A03', NULL, NULL, 183, NULL, NULL, 234709),
(282316, '5dtkA00', NULL, NULL, 243, NULL, NULL, 234709),
(282317, '1g6aA00', NULL, NULL, 271, NULL, NULL, 234709),
(282318, '3a3jA01', NULL, NULL, 252, NULL, NULL, 234709),
(282319, '1xkzC00', NULL, NULL, 255, NULL, NULL, 234709),
(282320, '3w4pA00', NULL, NULL, 266, NULL, NULL, 234709),
(282321, '1h8zA00', NULL, NULL, 247, NULL, NULL, 234709),
(282322, '4hesA00', NULL, NULL, 275, NULL, NULL, 234709),
(282323, '5jyoB00', NULL, NULL, 316, NULL, NULL, 234709),
(282324, '4ovdA03', NULL, NULL, 190, NULL, NULL, 234709),
(282325, '3p09A00', NULL, NULL, 268, NULL, NULL, 234709),
(282326, '3pbtA03', NULL, NULL, 182, NULL, NULL, 234709),
(282327, '3a3dA01', NULL, NULL, 245, NULL, NULL, 234709),
(282328, '6njkA00', NULL, NULL, 367, NULL, NULL, 234709),
(282329, '5df7A02', NULL, NULL, 358, NULL, NULL, 234709),
(282330, '6nhuC00', NULL, NULL, 252, NULL, NULL, 234709),
(282331, '1rgyA00', NULL, NULL, 360, NULL, NULL, 234709),
(282332, '5hx9A00', NULL, NULL, 266, NULL, NULL, 234709),
(282333, '2ex2A01', NULL, NULL, 247, NULL, NULL, 234709),
(282334, '2zc7A00', NULL, NULL, 359, NULL, NULL, 234709),
(282335, '5gl9A00', NULL, NULL, 268, NULL, NULL, 234709),
(282336, '5cerA01', NULL, NULL, 238, NULL, NULL, 234709),
(282337, '1w79A01', NULL, NULL, 251, NULL, NULL, 234709),
(282338, '3i7jA00', NULL, NULL, 280, NULL, NULL, 234709),
(282339, '3wrzC00', NULL, NULL, 367, NULL, NULL, 234709),
(282340, '5vpqA00', NULL, NULL, 289, NULL, NULL, 234709),
(282341, '2ffyA00', NULL, NULL, 358, NULL, NULL, 234709),
(282342, '3mfdA01', NULL, NULL, 236, NULL, NULL, 234709),
(282343, '4gn2A00', NULL, NULL, 240, NULL, NULL, 234709),
(282344, '5tw4A01', NULL, NULL, 290, NULL, NULL, 234709),
(282345, '1ei5A01', NULL, NULL, 321, NULL, NULL, 234709),
(282346, '5u47A04', NULL, NULL, 371, NULL, NULL, 234709),
(282347, '5nj2A00', NULL, NULL, 274, NULL, NULL, 234709),
(282348, '2v2fF00', NULL, NULL, 390, NULL, NULL, 234709),
(282349, '6nj1A00', NULL, NULL, 282, NULL, NULL, 234709),
(282350, '5aqbA02', NULL, NULL, 263, NULL, NULL, 234709),
(282351, '5aq7A02', NULL, NULL, 265, NULL, NULL, 234709),
(282352, '4oonA02', NULL, NULL, 341, NULL, NULL, 234709),
(282353, '4id4A00', NULL, NULL, 263, NULL, NULL, 234709),
(282354, '5uy7A00', NULL, NULL, 340, NULL, NULL, 234709),
(282355, '2j9oD01', NULL, NULL, 263, NULL, NULL, 234709),
(282356, '3tg9A00', NULL, NULL, 331, NULL, NULL, 234709),
(282357, '5fqiA00', NULL, NULL, 269, NULL, NULL, 234709),
(282358, '6nfdA00', NULL, NULL, 268, NULL, NULL, 234709),
(282359, '3cjmA00', NULL, NULL, 255, NULL, NULL, 234709),
(282360, '3if6B00', NULL, NULL, 242, NULL, NULL, 234709),
(282361, '4oh0A00', NULL, NULL, 243, NULL, NULL, 234709),
(282362, '6niqA00', NULL, NULL, 267, NULL, NULL, 234709),
(282363, '5mozA00', NULL, NULL, 247, NULL, NULL, 234709),
(282364, '4mnrA02', NULL, NULL, 316, NULL, NULL, 234709),
(282365, '5tr7A00', NULL, NULL, 252, NULL, NULL, 234709),
(282366, '1ghpA00', NULL, NULL, 258, NULL, NULL, 234709),
(282367, '5iy2A00', NULL, NULL, 241, NULL, NULL, 234709),
(282368, '4ztkA00', NULL, NULL, 285, NULL, NULL, 234709),
(282369, '3vwnX01', NULL, NULL, 236, NULL, NULL, 234709),
(282370, '6n1nA00', NULL, NULL, 250, NULL, NULL, 234709),
(282371, '5e2gB00', NULL, NULL, 361, NULL, NULL, 234709),
(282372, '5e43A00', NULL, NULL, 268, NULL, NULL, 234709),
(282373, '2zq7A00', NULL, NULL, 262, NULL, NULL, 234709),
(282374, '1bsgA00', NULL, NULL, 266, NULL, NULL, 234709),
(282375, '1xp4A01', NULL, NULL, 278, NULL, NULL, 234709),
(282376, '1alqA00', NULL, NULL, 266, NULL, NULL, 234709),
(282377, '5f82B00', NULL, NULL, 269, NULL, NULL, 234709),
(282378, '1vqqB04', NULL, NULL, 339, NULL, NULL, 234709),
(282379, '5tfqA00', NULL, NULL, 280, NULL, NULL, 234709),
(282380, '3hlcA00', NULL, NULL, 432, NULL, NULL, 234709),
(282381, '5cecA01', NULL, NULL, 238, NULL, NULL, 234709),
(282382, '4mllB00', NULL, NULL, 251, NULL, NULL, 234709),
(282383, '4pprA00', NULL, NULL, 310, NULL, NULL, 234709),
(282384, '3lezA00', NULL, NULL, 260, NULL, NULL, 234709),
(282385, '1hzoA00', NULL, NULL, 271, NULL, NULL, 234709);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(282386, '2c5wB00', NULL, NULL, 385, NULL, NULL, 234709),
(282387, '4c75A00', NULL, NULL, 262, NULL, NULL, 234709),
(282388, '1k25C02', NULL, NULL, 328, NULL, NULL, 234709),
(282389, '2v1zA00', NULL, NULL, 270, NULL, NULL, 234709),
(282390, '3zdjA00', NULL, NULL, 263, NULL, NULL, 234709),
(282391, '3eqvA03', NULL, NULL, 181, NULL, NULL, 234709),
(282392, '1n9bA00', NULL, NULL, 265, NULL, NULL, 234709),
(282393, '5u2gA01', NULL, NULL, 465, NULL, NULL, 234709),
(282394, '5e2fA00', NULL, NULL, 237, NULL, NULL, 234709),
(282395, '1yqsA00', NULL, NULL, 349, NULL, NULL, 234709),
(282396, '3qhyA00', NULL, NULL, 271, NULL, NULL, 234709),
(282397, '2wafA03', NULL, NULL, 350, NULL, NULL, 234709),
(282398, '5tg4A00', NULL, NULL, 245, NULL, NULL, 234709),
(282399, '4y7pA00', NULL, NULL, 342, NULL, NULL, 234709),
(282400, '3itbD01', NULL, NULL, 258, NULL, NULL, 234709),
(282401, '4gdnC00', NULL, NULL, 342, NULL, NULL, 234709),
(282402, '6fm7A00', NULL, NULL, 356, NULL, NULL, 234709),
(282403, '2iwbA00', NULL, NULL, 246, NULL, NULL, 234709),
(282404, '2y2mA02', NULL, NULL, 312, NULL, NULL, 234709),
(282405, '3rjuA00', NULL, NULL, 351, NULL, NULL, 234709),
(282406, '6ni0A00', NULL, NULL, 249, NULL, NULL, 234709),
(282407, '3brmB01', NULL, NULL, 186, NULL, NULL, 234709),
(282408, '4uhuA00', NULL, NULL, 268, NULL, NULL, 234709),
(282409, '1dy6A00', NULL, NULL, 267, NULL, NULL, 234709),
(282410, '3udfA01', NULL, NULL, 381, NULL, NULL, 234709),
(282411, '1u60A00', NULL, NULL, 310, NULL, NULL, 234709),
(282412, '2wuqB00', NULL, NULL, 318, NULL, NULL, 234709),
(282413, '4euzA00', NULL, NULL, 283, NULL, NULL, 234709),
(282414, '4hbtA00', NULL, NULL, 263, NULL, NULL, 234709),
(282415, '3wwxA00', NULL, NULL, 349, NULL, NULL, 234709),
(282416, '6nlwA00', NULL, NULL, 246, NULL, NULL, 234709),
(282417, '5tgfD00', NULL, NULL, 339, NULL, NULL, 234709),
(282418, '1k38A00', NULL, NULL, 254, NULL, NULL, 234709),
(282419, '2xepB02', NULL, NULL, 256, NULL, NULL, 234709),
(282420, '4lclA00', NULL, NULL, 433, NULL, NULL, 234709),
(282421, '5ctmA00', NULL, NULL, 233, NULL, NULL, 234709),
(282422, '5gs8A00', NULL, NULL, 280, NULL, NULL, 234709),
(282423, '3bffA00', NULL, NULL, 262, NULL, NULL, 234709),
(282424, '5cxwA00', NULL, NULL, 380, NULL, NULL, 234709),
(282425, '3toiA00', NULL, NULL, 254, NULL, NULL, 234709),
(282426, '1rp5B04', NULL, NULL, 371, NULL, NULL, 234709),
(282427, '2qz6A00', NULL, NULL, 358, NULL, NULL, 234709),
(282428, '4gb7A00', NULL, NULL, 388, NULL, NULL, 234709),
(282429, '3w8kA00', NULL, NULL, 353, NULL, NULL, 234709),
(282430, '3w4qA00', NULL, NULL, 258, NULL, NULL, 234709),
(282431, '4rv7D00', NULL, NULL, 155, NULL, NULL, 234710),
(282432, '6gywA00', NULL, NULL, 175, NULL, NULL, 234710),
(282433, '3c1yA01', NULL, NULL, 138, NULL, NULL, 234710),
(282434, '2fb5A02', NULL, NULL, 132, NULL, NULL, 234710),
(282435, '1opoA02', NULL, NULL, 103, NULL, NULL, 234711),
(282436, '1ugoA00', NULL, NULL, 99, NULL, NULL, 234712),
(282437, '4hwdD00', NULL, NULL, 90, NULL, NULL, 234712),
(282438, '3a8yD00', NULL, NULL, 114, NULL, NULL, 234712),
(282439, '1uk5A00', NULL, NULL, 111, NULL, NULL, 234712),
(282440, '4hwfA00', NULL, NULL, 88, NULL, NULL, 234712),
(282441, '4hwiB02', NULL, NULL, 106, NULL, NULL, 234712),
(282442, '5aqmD00', NULL, NULL, 118, NULL, NULL, 234712),
(282443, '4hwhE00', NULL, NULL, 88, NULL, NULL, 234712),
(282444, '2d9dA00', NULL, NULL, 89, NULL, NULL, 234712),
(282445, '1i6zA00', NULL, NULL, 135, NULL, NULL, 234712),
(282446, '1m62A00', NULL, NULL, 87, NULL, NULL, 234712),
(282447, '1t7sA00', NULL, NULL, 137, NULL, NULL, 234712),
(282448, '3rhaB02', NULL, NULL, 164, NULL, NULL, 234713),
(282449, '3we0A02', NULL, NULL, 142, NULL, NULL, 234713),
(282450, '4iv9A02', NULL, NULL, 146, NULL, NULL, 234713),
(282451, '5z2gA01', NULL, NULL, 177, NULL, NULL, 234713),
(282452, '3k7mX02', NULL, NULL, 206, NULL, NULL, 234713),
(282453, '1s3eA02', NULL, NULL, 174, NULL, NULL, 234713),
(282454, '3qj4A02', NULL, NULL, 181, NULL, NULL, 234713),
(282455, '3kkjA02', NULL, NULL, 175, NULL, NULL, 234713),
(282456, '4zcdB02', NULL, NULL, 175, NULL, NULL, 234713);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(282457, '2iidA01', NULL, NULL, 183, NULL, NULL, 234713),
(282458, '1reoA01', NULL, NULL, 180, NULL, NULL, 234713),
(282459, '5ts5A01', NULL, NULL, 183, NULL, NULL, 234713),
(282460, '2vvmA02', NULL, NULL, 222, NULL, NULL, 234713),
(282461, '1rsgA02', NULL, NULL, 259, NULL, NULL, 234713),
(282462, '2jaeA02', NULL, NULL, 192, NULL, NULL, 234713),
(282463, '2yg5A02', NULL, NULL, 164, NULL, NULL, 234713),
(282464, '3kveA01', NULL, NULL, 180, NULL, NULL, 234713),
(282465, '1o5wB02', NULL, NULL, 174, NULL, NULL, 234713),
(282466, '1b37A02', NULL, NULL, 218, NULL, NULL, 234713),
(282467, '2bxrA02', NULL, NULL, 169, NULL, NULL, 234713),
(282468, '4i59A02', NULL, NULL, 166, NULL, NULL, 234713),
(282469, '1o5wA02', NULL, NULL, 266, NULL, NULL, 234713),
(282470, '2z5yA02', NULL, NULL, 266, NULL, NULL, 234713),
(282471, '2ju0B00', NULL, NULL, 52, NULL, NULL, 234714),
(282472, '1rgxA01', NULL, NULL, 25, NULL, NULL, 234715),
(282473, '1g6q102', NULL, NULL, 184, NULL, NULL, 234716),
(282474, '3ua3A03', NULL, NULL, 212, NULL, NULL, 234716),
(282475, '5dstA02', NULL, NULL, 177, NULL, NULL, 234716),
(282476, '4m37A02', NULL, NULL, 174, NULL, NULL, 234716),
(282477, '4qqkA02', NULL, NULL, 188, NULL, NULL, 234716),
(282478, '4gqbA03', NULL, NULL, 171, NULL, NULL, 234716),
(282479, '3q7eA02', NULL, NULL, 177, NULL, NULL, 234716),
(282480, '2fytA02', NULL, NULL, 170, NULL, NULL, 234716),
(282481, '6cu3A02', NULL, NULL, 176, NULL, NULL, 234716),
(282482, '6dvrB02', NULL, NULL, 201, NULL, NULL, 234716),
(282483, '5fubA02', NULL, NULL, 187, NULL, NULL, 234716),
(282484, '4c4aA04', NULL, NULL, 179, NULL, NULL, 234716),
(282485, '1f3lA02', NULL, NULL, 170, NULL, NULL, 234716),
(282486, '4c4aA02', NULL, NULL, 193, NULL, NULL, 234716),
(282487, '5fwaA02', NULL, NULL, 190, NULL, NULL, 234716),
(282488, '4g56A03', NULL, NULL, 171, NULL, NULL, 234716),
(282489, '4lwoB02', NULL, NULL, 186, NULL, NULL, 234716),
(282490, '3r0qA02', NULL, NULL, 208, NULL, NULL, 234716),
(282491, '3x0dA02', NULL, NULL, 176, NULL, NULL, 234716),
(282492, '4c08A02', NULL, NULL, 188, NULL, NULL, 234716),
(282493, '3payB02', NULL, NULL, 137, NULL, NULL, 234717),
(282494, '3gf8A02', NULL, NULL, 126, NULL, NULL, 234717),
(282495, '4qdgA02', NULL, NULL, 139, NULL, NULL, 234717),
(282496, '3udcA01', NULL, NULL, 127, NULL, NULL, 234718),
(282497, '5ajiB01', NULL, NULL, 102, NULL, NULL, 234718),
(282498, '2xjpA01', NULL, NULL, 224, NULL, NULL, 234719),
(282499, '6hosA00', NULL, NULL, 213, NULL, NULL, 234719),
(282500, '4cp0A00', NULL, NULL, 231, NULL, NULL, 234719),
(282501, '4couA00', NULL, NULL, 228, NULL, NULL, 234719),
(282502, '4aslA00', NULL, NULL, 233, NULL, NULL, 234719),
(282503, '4lhkA00', NULL, NULL, 220, NULL, NULL, 234719),
(282504, '5a3lA00', NULL, NULL, 209, NULL, NULL, 234719),
(282505, '4lhlA01', NULL, NULL, 229, NULL, NULL, 234719),
(282506, '2i7uA00', NULL, NULL, 62, NULL, NULL, 234720),
(282507, '5ot1A03', NULL, NULL, 54, NULL, NULL, 234721),
(282508, '4lxfA02', NULL, NULL, 70, NULL, NULL, 234721),
(282509, '1uokA02', NULL, NULL, 70, NULL, NULL, 234721),
(282510, '4xb3A02', NULL, NULL, 65, NULL, NULL, 234721),
(282511, '3wy2A02', NULL, NULL, 71, NULL, NULL, 234721),
(282512, '1g5aA03', NULL, NULL, 72, NULL, NULL, 234721),
(282513, '5do8A02', NULL, NULL, 67, NULL, NULL, 234721),
(282514, '1lwjA02', NULL, NULL, 65, NULL, NULL, 234721),
(282515, '1wzaA02', NULL, NULL, 64, NULL, NULL, 234721),
(282516, '4aeeA04', NULL, NULL, 79, NULL, NULL, 234721),
(282517, '3czgA03', NULL, NULL, 73, NULL, NULL, 234721),
(282518, '1j0hA03', NULL, NULL, 54, NULL, NULL, 234721),
(282519, '3zo9A02', NULL, NULL, 70, NULL, NULL, 234721),
(282520, '5brqA02', NULL, NULL, 71, NULL, NULL, 234721),
(282521, '3ucqA03', NULL, NULL, 77, NULL, NULL, 234721),
(282522, '4aieA02', NULL, NULL, 70, NULL, NULL, 234721),
(282523, '3aj7A02', NULL, NULL, 76, NULL, NULL, 234721),
(282524, '1m53A02', NULL, NULL, 70, NULL, NULL, 234721),
(282525, '1zjaA02', NULL, NULL, 70, NULL, NULL, 234721),
(282526, '3k8kA03', NULL, NULL, 77, NULL, NULL, 234721),
(282527, '5m99A02', NULL, NULL, 65, NULL, NULL, 234721);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(282528, '4wf7A02', NULL, NULL, 76, NULL, NULL, 234721),
(282529, '1ea9C03', NULL, NULL, 55, NULL, NULL, 234721),
(282530, '1wzlA03', NULL, NULL, 55, NULL, NULL, 234721),
(282531, '4howA02', NULL, NULL, 70, NULL, NULL, 234721),
(282532, '2wpgA03', NULL, NULL, 73, NULL, NULL, 234721),
(282533, '1smaA03', NULL, NULL, 54, NULL, NULL, 234721),
(282534, '4aysA03', NULL, NULL, 73, NULL, NULL, 234721),
(282535, '6fmeA02', NULL, NULL, 81, NULL, NULL, 234721),
(282536, '3gbeA02', NULL, NULL, 70, NULL, NULL, 234721),
(282537, '4mb1A02', NULL, NULL, 71, NULL, NULL, 234721),
(282538, '2ze0A02', NULL, NULL, 72, NULL, NULL, 234721),
(282539, '2atzA00', NULL, NULL, 180, NULL, NULL, 234722),
(282540, '1u3eM01', NULL, NULL, 106, NULL, NULL, 234723),
(282541, '6b3vA03', NULL, NULL, 43, NULL, NULL, 234724),
(282542, '2i7nA03', NULL, NULL, 43, NULL, NULL, 234724),
(282543, '5e26A03', NULL, NULL, 43, NULL, NULL, 234724),
(282544, '2cm0A00', NULL, NULL, 99, NULL, NULL, 234725),
(282545, '5ljmA00', NULL, NULL, 215, NULL, NULL, 234725),
(282546, '2ccqA00', NULL, NULL, 99, NULL, NULL, 234725),
(282547, '4p09A00', NULL, NULL, 184, NULL, NULL, 234725),
(282548, '2uwmA01', NULL, NULL, 133, NULL, NULL, 234726),
(282549, '2a9dA02', NULL, NULL, 123, NULL, NULL, 234727),
(282550, '1ogpA02', NULL, NULL, 131, NULL, NULL, 234727),
(282551, '2biiA02', NULL, NULL, 185, NULL, NULL, 234727),
(282552, '2blfA02', NULL, NULL, 114, NULL, NULL, 234727),
(282553, '2xtsA02', NULL, NULL, 130, NULL, NULL, 234727),
(282554, '5k3xA02', NULL, NULL, 113, NULL, NULL, 234727),
(282555, '2wyhA07', NULL, NULL, 77, NULL, NULL, 234728),
(282556, '5kbpA05', NULL, NULL, 78, NULL, NULL, 234728),
(282557, '2a01A02', NULL, NULL, 51, NULL, NULL, 234729),
(282558, '3r9qB02', NULL, NULL, 56, NULL, NULL, 234730),
(282559, '3r9qA02', NULL, NULL, 36, NULL, NULL, 234730),
(282560, '3qkaE02', NULL, NULL, 58, NULL, NULL, 234730),
(282561, '3l3sC02', NULL, NULL, 40, NULL, NULL, 234730),
(282562, '4qfeK02', NULL, NULL, 34, NULL, NULL, 234730),
(282563, '3l3sB02', NULL, NULL, 56, NULL, NULL, 234730),
(282564, '4z0mC02', NULL, NULL, 34, NULL, NULL, 234730),
(282565, '4z0mB02', NULL, NULL, 43, NULL, NULL, 234730),
(282566, '3qkaA02', NULL, NULL, 37, NULL, NULL, 234730),
(282567, '3tewA04', NULL, NULL, 131, NULL, NULL, 234731),
(282568, '4chdA00', NULL, NULL, 142, NULL, NULL, 234732),
(282569, '2odiA02', NULL, NULL, 115, NULL, NULL, 234733),
(282570, '2oa9B02', NULL, NULL, 140, NULL, NULL, 234733),
(282571, '3u2gA02', NULL, NULL, 129, NULL, NULL, 234734),
(282572, '4fxtA02', NULL, NULL, 107, NULL, NULL, 234735),
(282573, '4iykA02', NULL, NULL, 118, NULL, NULL, 234735),
(282574, '3hn5A02', NULL, NULL, 115, NULL, NULL, 234735),
(282575, '4eiuA02', NULL, NULL, 137, NULL, NULL, 234735),
(282576, '4yokA02', NULL, NULL, 105, NULL, NULL, 234735),
(282577, '1so9A00', NULL, NULL, 144, NULL, NULL, 234736),
(282578, '1c17M00', NULL, NULL, 177, NULL, NULL, 234737),
(282579, '2kw3A00', NULL, NULL, 68, NULL, NULL, 234738),
(282580, '5yvdA02', NULL, NULL, 123, NULL, NULL, 234739),
(282581, '2gtiA02', NULL, NULL, 131, NULL, NULL, 234739),
(282582, '4s1tA02', NULL, NULL, 127, NULL, NULL, 234739),
(282583, '2h85A02', NULL, NULL, 126, NULL, NULL, 234739),
(282584, '1ivzA00', NULL, NULL, 132, NULL, NULL, 234740),
(282585, '2e7vA01', NULL, NULL, 110, NULL, NULL, 234740),
(282586, '5os9A00', NULL, NULL, 124, NULL, NULL, 234741),
(282587, '6j9cD00', NULL, NULL, 123, NULL, NULL, 234741),
(282588, '6j9bA00', NULL, NULL, 122, NULL, NULL, 234741),
(282589, '1na6A01', NULL, NULL, 177, NULL, NULL, 234741),
(282590, '4i1kA00', NULL, NULL, 121, NULL, NULL, 234741),
(282591, '6j9aA00', NULL, NULL, 113, NULL, NULL, 234741),
(282592, '3hqfA00', NULL, NULL, 181, NULL, NULL, 234741),
(282593, '5yzzC00', NULL, NULL, 128, NULL, NULL, 234741),
(282594, '6fasA00', NULL, NULL, 119, NULL, NULL, 234741),
(282595, '1widA00', NULL, NULL, 130, NULL, NULL, 234741),
(282596, '4lduA02', NULL, NULL, 106, NULL, NULL, 234741),
(282597, '4ldvA02', NULL, NULL, 106, NULL, NULL, 234741),
(282598, '1yelA00', NULL, NULL, 104, NULL, NULL, 234741);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(282599, '2lg1A01', NULL, NULL, 70, NULL, NULL, 234742),
(282600, '1hczA02', NULL, NULL, 59, NULL, NULL, 234743),
(282601, '2awnC02', NULL, NULL, 84, NULL, NULL, 234743),
(282602, '2je6I01', NULL, NULL, 66, NULL, NULL, 234743),
(282603, '1zkoA00', NULL, NULL, 136, NULL, NULL, 234743),
(282604, '4iqzB01', NULL, NULL, 75, NULL, NULL, 234743),
(282605, '2edgA00', NULL, NULL, 130, NULL, NULL, 234743),
(282606, '5a35A00', NULL, NULL, 120, NULL, NULL, 234743),
(282607, '3n6rA04', NULL, NULL, 69, NULL, NULL, 234743),
(282608, '1iyuA00', NULL, NULL, 79, NULL, NULL, 234743),
(282609, '2nn6H01', NULL, NULL, 55, NULL, NULL, 234743),
(282610, '2it1A02', NULL, NULL, 63, NULL, NULL, 234743),
(282611, '4tquS02', NULL, NULL, 64, NULL, NULL, 234743),
(282612, '2ejmA01', NULL, NULL, 68, NULL, NULL, 234743),
(282613, '1gutA00', NULL, NULL, 68, NULL, NULL, 234743),
(282614, '1g29103', NULL, NULL, 65, NULL, NULL, 234743),
(282615, '3fppA02', NULL, NULL, 74, NULL, NULL, 234743),
(282616, '3lnnA03', NULL, NULL, 73, NULL, NULL, 234743),
(282617, '6d6qH01', NULL, NULL, 58, NULL, NULL, 234743),
(282618, '2dncA01', NULL, NULL, 79, NULL, NULL, 234743),
(282619, '1labA00', NULL, NULL, 80, NULL, NULL, 234743),
(282620, '3va7A07', NULL, NULL, 76, NULL, NULL, 234743),
(282621, '3mxuA00', NULL, NULL, 143, NULL, NULL, 234743),
(282622, '3m7nA01', NULL, NULL, 52, NULL, NULL, 234743),
(282623, '1ynjC05', NULL, NULL, 75, NULL, NULL, 234743),
(282624, '5jeaH01', NULL, NULL, 63, NULL, NULL, 234743),
(282625, '1ci3M02', NULL, NULL, 58, NULL, NULL, 234743),
(282626, '4kksA03', NULL, NULL, 72, NULL, NULL, 234743),
(282627, '3gqbA03', NULL, NULL, 67, NULL, NULL, 234743),
(282628, '2d62A02', NULL, NULL, 64, NULL, NULL, 234743),
(282629, '2qf7A07', NULL, NULL, 80, NULL, NULL, 234743),
(282630, '5oomW00', NULL, NULL, 109, NULL, NULL, 234743),
(282631, '2awnD02', NULL, NULL, 107, NULL, NULL, 234743),
(282632, '2o5iN10', NULL, NULL, 63, NULL, NULL, 234743),
(282633, '2lmcB00', NULL, NULL, 61, NULL, NULL, 234743),
(282634, '2yyzA02', NULL, NULL, 58, NULL, NULL, 234743),
(282635, '2nn6I01', NULL, NULL, 51, NULL, NULL, 234743),
(282636, '1fr3A00', NULL, NULL, 67, NULL, NULL, 234743),
(282637, '1v8qA00', NULL, NULL, 66, NULL, NULL, 234743),
(282638, '3tzuA00', NULL, NULL, 137, NULL, NULL, 234743),
(282639, '1pmrA00', NULL, NULL, 80, NULL, NULL, 234743),
(282640, '1onlA00', NULL, NULL, 128, NULL, NULL, 234743),
(282641, '2dneA00', NULL, NULL, 108, NULL, NULL, 234743),
(282642, '3a7lA00', NULL, NULL, 128, NULL, NULL, 234743),
(282643, '5guaA00', NULL, NULL, 71, NULL, NULL, 234743),
(282644, '4v19000', NULL, NULL, 114, NULL, NULL, 234743),
(282645, '4dk0A03', NULL, NULL, 71, NULL, NULL, 234743),
(282646, '1z6hA00', NULL, NULL, 72, NULL, NULL, 234743),
(282647, '3bg3A05', NULL, NULL, 71, NULL, NULL, 234743),
(282648, '1k8mA00', NULL, NULL, 93, NULL, NULL, 234743),
(282649, '3lwuA02', NULL, NULL, 74, NULL, NULL, 234743),
(282650, '4rcnB02', NULL, NULL, 77, NULL, NULL, 234743),
(282651, '4iqzD02', NULL, NULL, 105, NULL, NULL, 234743),
(282652, '3rlfA02', NULL, NULL, 66, NULL, NULL, 234743),
(282653, '4l8jA03', NULL, NULL, 73, NULL, NULL, 234743),
(282654, '2jxmB02', NULL, NULL, 57, NULL, NULL, 234743),
(282655, '1h9sA02', NULL, NULL, 72, NULL, NULL, 234743),
(282656, '1y69U01', NULL, NULL, 71, NULL, NULL, 234743),
(282657, '1ghjA00', NULL, NULL, 79, NULL, NULL, 234743),
(282658, '2aujD04', NULL, NULL, 58, NULL, NULL, 234743),
(282659, '4ljzC06', NULL, NULL, 75, NULL, NULL, 234743),
(282660, '2aujD03', NULL, NULL, 62, NULL, NULL, 234743),
(282661, '1b9mB02', NULL, NULL, 79, NULL, NULL, 234743),
(282662, '3d31A03', NULL, NULL, 71, NULL, NULL, 234743),
(282663, '2aujD01', NULL, NULL, 66, NULL, NULL, 234743),
(282664, '3crkD00', NULL, NULL, 87, NULL, NULL, 234743),
(282665, '2a6hD03', NULL, NULL, 54, NULL, NULL, 234743),
(282666, '3ne5B03', NULL, NULL, 70, NULL, NULL, 234743),
(282667, '3hblD06', NULL, NULL, 82, NULL, NULL, 234743),
(282668, '1vf7A02', NULL, NULL, 71, NULL, NULL, 234743),
(282669, '3wdnA00', NULL, NULL, 125, NULL, NULL, 234743),
(282670, '5bn3A03', NULL, NULL, 65, NULL, NULL, 234743);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(282671, '1gjxA00', NULL, NULL, 81, NULL, NULL, 234743),
(282672, '1oxxK03', NULL, NULL, 46, NULL, NULL, 234743),
(282673, '1v43A02', NULL, NULL, 58, NULL, NULL, 234743),
(282674, '3d4rB02', NULL, NULL, 68, NULL, NULL, 234743),
(282675, '2dn8A01', NULL, NULL, 72, NULL, NULL, 234743),
(282676, '5ze9A03', NULL, NULL, 70, NULL, NULL, 234743),
(282677, '3qjyA03', NULL, NULL, 72, NULL, NULL, 234743),
(282678, '2nn6G01', NULL, NULL, 94, NULL, NULL, 234743),
(282679, '1qjoA00', NULL, NULL, 80, NULL, NULL, 234743),
(282680, '1dczA00', NULL, NULL, 77, NULL, NULL, 234743),
(282681, '1hpcA00', NULL, NULL, 131, NULL, NULL, 234743),
(282682, '3u9sA05', NULL, NULL, 72, NULL, NULL, 234743),
(282683, '2f1mA02', NULL, NULL, 71, NULL, NULL, 234743),
(282684, '2pnrC01', NULL, NULL, 76, NULL, NULL, 234743),
(282685, '1b9mA03', NULL, NULL, 71, NULL, NULL, 234743),
(282686, '4i7zC02', NULL, NULL, 62, NULL, NULL, 234743),
(282687, '3fmcA02', NULL, NULL, 74, NULL, NULL, 234743),
(282688, '4h44C02', NULL, NULL, 62, NULL, NULL, 234743),
(282689, '2a6hC05', NULL, NULL, 75, NULL, NULL, 234743),
(282690, '1ynjJ02', NULL, NULL, 62, NULL, NULL, 234743),
(282691, '2ba0A01', NULL, NULL, 49, NULL, NULL, 234743),
(282692, '1bdoA00', NULL, NULL, 80, NULL, NULL, 234743),
(282693, '1h9mA02', NULL, NULL, 75, NULL, NULL, 234743),
(282694, '1h9mA01', NULL, NULL, 70, NULL, NULL, 234743),
(282695, '1e2wA02', NULL, NULL, 60, NULL, NULL, 234743),
(282696, '2l5tA00', NULL, NULL, 77, NULL, NULL, 234743),
(282697, '4tkoB02', NULL, NULL, 66, NULL, NULL, 234743),
(282698, '3hgbA00', NULL, NULL, 135, NULL, NULL, 234743),
(282699, '5jeaG01', NULL, NULL, 65, NULL, NULL, 234743),
(282700, '3og6A00', NULL, NULL, 160, NULL, NULL, 234744),
(282701, '3hhcC00', NULL, NULL, 162, NULL, NULL, 234744),
(282702, '2rmfA00', NULL, NULL, 40, NULL, NULL, 234745),
(282703, '3s6pG00', NULL, NULL, 72, NULL, NULL, 234746),
(282704, '4a94C00', NULL, NULL, 53, NULL, NULL, 234747),
(282705, '3plwA00', NULL, NULL, 110, NULL, NULL, 234748),
(282706, '3nrlA00', NULL, NULL, 81, NULL, NULL, 234749),
(282707, '2joxA00', NULL, NULL, 106, NULL, NULL, 234750),
(282708, '1hi9A02', NULL, NULL, 76, NULL, NULL, 234751),
(282709, '4cfrQ00', NULL, NULL, 45, NULL, NULL, 234752),
(282710, '4eu0A02', NULL, NULL, 137, NULL, NULL, 234753),
(282711, '3c4rA00', NULL, NULL, 127, NULL, NULL, 234754),
(282712, '3er9B03', NULL, NULL, 133, NULL, NULL, 234755),
(282713, '5ek0C01', NULL, NULL, 125, NULL, NULL, 234756),
(282714, '1orsC00', NULL, NULL, 132, NULL, NULL, 234756),
(282715, '3lutB02', NULL, NULL, 162, NULL, NULL, 234756),
(282716, '3lnmD02', NULL, NULL, 175, NULL, NULL, 234756),
(282717, '4g80T00', NULL, NULL, 139, NULL, NULL, 234756),
(282718, '3rvyA01', NULL, NULL, 114, NULL, NULL, 234756),
(282719, '4dxwB01', NULL, NULL, 116, NULL, NULL, 234756),
(282720, '6bogA04', NULL, NULL, 302, NULL, NULL, 234757),
(282721, '1z6aA01', NULL, NULL, 206, NULL, NULL, 234757),
(282722, '1z3iX01', NULL, NULL, 277, NULL, NULL, 234757),
(282723, '3mwyW03', NULL, NULL, 282, NULL, NULL, 234757),
(282724, '5jciA03', NULL, NULL, 89, NULL, NULL, 234758),
(282725, '4j57A03', NULL, NULL, 129, NULL, NULL, 234758),
(282726, '2wpfA03', NULL, NULL, 112, NULL, NULL, 234758),
(282727, '3oc4B03', NULL, NULL, 130, NULL, NULL, 234758),
(282728, '6du7A03', NULL, NULL, 113, NULL, NULL, 234758),
(282729, '1nhpA03', NULL, NULL, 113, NULL, NULL, 234758),
(282730, '2qaeA03', NULL, NULL, 121, NULL, NULL, 234758),
(282731, '6cmzB03', NULL, NULL, 121, NULL, NULL, 234758),
(282732, '5kvhA03', NULL, NULL, 92, NULL, NULL, 234758),
(282733, '1onfA03', NULL, NULL, 115, NULL, NULL, 234758),
(282734, '3urhB03', NULL, NULL, 121, NULL, NULL, 234758),
(282735, '3l8kA03', NULL, NULL, 124, NULL, NULL, 234758),
(282736, '1gesA03', NULL, NULL, 113, NULL, NULL, 234758),
(282737, '4emiA03', NULL, NULL, 98, NULL, NULL, 234758),
(282738, '4eqsA03', NULL, NULL, 108, NULL, NULL, 234758),
(282739, '1xhcA03', NULL, NULL, 61, NULL, NULL, 234758),
(282740, '2cduA03', NULL, NULL, 113, NULL, NULL, 234758),
(282741, '1dxlA03', NULL, NULL, 121, NULL, NULL, 234758);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(282742, '1lvlA03', NULL, NULL, 121, NULL, NULL, 234758),
(282743, '3cgbA03', NULL, NULL, 110, NULL, NULL, 234758),
(282744, '4la1A04', NULL, NULL, 129, NULL, NULL, 234758),
(282745, '3ic9A04', NULL, NULL, 126, NULL, NULL, 234758),
(282746, '3dk9A03', NULL, NULL, 113, NULL, NULL, 234758),
(282747, '3dgzA03', NULL, NULL, 128, NULL, NULL, 234758),
(282748, '3ladA03', NULL, NULL, 126, NULL, NULL, 234758),
(282749, '6b4oA03', NULL, NULL, 113, NULL, NULL, 234758),
(282750, '5fs8A03', NULL, NULL, 137, NULL, NULL, 234758),
(282751, '5vn0A03', NULL, NULL, 113, NULL, NULL, 234758),
(282752, '5u25A03', NULL, NULL, 122, NULL, NULL, 234758),
(282753, '1zmdA03', NULL, NULL, 124, NULL, NULL, 234758),
(282754, '3o0hA03', NULL, NULL, 125, NULL, NULL, 234758),
(282755, '1fecA03', NULL, NULL, 131, NULL, NULL, 234758),
(282756, '4k7zA03', NULL, NULL, 126, NULL, NULL, 234758),
(282757, '5u1oA03', NULL, NULL, 113, NULL, NULL, 234758),
(282758, '3kljA03', NULL, NULL, 83, NULL, NULL, 234758),
(282759, '4fx9A03', NULL, NULL, 118, NULL, NULL, 234758),
(282760, '3fg2P03', NULL, NULL, 86, NULL, NULL, 234758),
(282761, '2w0hA03', NULL, NULL, 131, NULL, NULL, 234758),
(282762, '6bz0D03', NULL, NULL, 127, NULL, NULL, 234758),
(282763, '1aogA03', NULL, NULL, 112, NULL, NULL, 234758),
(282764, '5vdnA03', NULL, NULL, 113, NULL, NULL, 234758),
(282765, '5x1yA03', NULL, NULL, 115, NULL, NULL, 234758),
(282766, '3dghA03', NULL, NULL, 115, NULL, NULL, 234758),
(282767, '2eq6A03', NULL, NULL, 124, NULL, NULL, 234758),
(282768, '1ebdA03', NULL, NULL, 115, NULL, NULL, 234758),
(282769, '1xdiA03', NULL, NULL, 122, NULL, NULL, 234758),
(282770, '4kprA03', NULL, NULL, 115, NULL, NULL, 234758),
(282771, '2r9zA03', NULL, NULL, 112, NULL, NULL, 234758),
(282772, '2yquA03', NULL, NULL, 121, NULL, NULL, 234758),
(282773, '5u8uA03', NULL, NULL, 127, NULL, NULL, 234758),
(282774, '1gv4A03', NULL, NULL, 131, NULL, NULL, 234758),
(282775, '3gd4B03', NULL, NULL, 88, NULL, NULL, 234758),
(282776, '4jq9A03', NULL, NULL, 122, NULL, NULL, 234758),
(282777, '6aonA03', NULL, NULL, 121, NULL, NULL, 234758),
(282778, '4dnaA03', NULL, NULL, 124, NULL, NULL, 234758),
(282779, '2gqwA03', NULL, NULL, 91, NULL, NULL, 234758),
(282780, '6n7fA03', NULL, NULL, 113, NULL, NULL, 234758),
(282781, '2hqmA03', NULL, NULL, 121, NULL, NULL, 234758),
(282782, '6ftcA04', NULL, NULL, 131, NULL, NULL, 234758),
(282783, '1v59A03', NULL, NULL, 121, NULL, NULL, 234758),
(282784, '3lxdA03', NULL, NULL, 86, NULL, NULL, 234758),
(282785, '5v36A03', NULL, NULL, 113, NULL, NULL, 234758),
(282786, '1q1rA03', NULL, NULL, 104, NULL, NULL, 234758),
(282787, '3qfaA03', NULL, NULL, 115, NULL, NULL, 234758),
(282788, '5w1jA04', NULL, NULL, 124, NULL, NULL, 234758),
(282789, '5fs6A03', NULL, NULL, 102, NULL, NULL, 234758),
(282790, '1mo9A03', NULL, NULL, 153, NULL, NULL, 234758),
(282791, '4ywoA03', NULL, NULL, 123, NULL, NULL, 234758),
(282792, '2bc0A03', NULL, NULL, 120, NULL, NULL, 234758),
(282793, '4burA03', NULL, NULL, 101, NULL, NULL, 234758),
(282794, '2a8xA03', NULL, NULL, 122, NULL, NULL, 234758),
(282795, '3if8B01', NULL, NULL, 64, NULL, NULL, 234759),
(282796, '4ysxA03', NULL, NULL, 117, NULL, NULL, 234760),
(282797, '5kxjA03', NULL, NULL, 88, NULL, NULL, 234760),
(282798, '2h88A03', NULL, NULL, 117, NULL, NULL, 234760),
(282799, '2e5vA03', NULL, NULL, 97, NULL, NULL, 234760),
(282800, '1jnrA03', NULL, NULL, 121, NULL, NULL, 234760),
(282801, '1kf6A03', NULL, NULL, 120, NULL, NULL, 234760),
(282802, '1zoyA03', NULL, NULL, 117, NULL, NULL, 234760),
(282803, '2bs2A03', NULL, NULL, 118, NULL, NULL, 234760),
(282804, '1knrA03', NULL, NULL, 116, NULL, NULL, 234760),
(282805, '2wdqA03', NULL, NULL, 117, NULL, NULL, 234760),
(282806, '3vkhA18', NULL, NULL, 183, NULL, NULL, 234761),
(282807, '3vkhB19', NULL, NULL, 144, NULL, NULL, 234761),
(282808, '1zlhB01', NULL, NULL, 38, NULL, NULL, 234762),
(282809, '6nmiG00', NULL, NULL, 71, NULL, NULL, 234763),
(282810, '3dgpB00', NULL, NULL, 71, NULL, NULL, 234763),
(282811, '1ydlA00', NULL, NULL, 79, NULL, NULL, 234763),
(282812, '3lhnB00', NULL, NULL, 107, NULL, NULL, 234764);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(282813, '4u3qB00', NULL, NULL, 122, NULL, NULL, 234764),
(282814, '2kgfA00', NULL, NULL, 140, NULL, NULL, 234765),
(282815, '1p7nA00', NULL, NULL, 176, NULL, NULL, 234765),
(282816, '2wlvA00', NULL, NULL, 144, NULL, NULL, 234765),
(282817, '2gonA00', NULL, NULL, 146, NULL, NULL, 234765),
(282818, '2gonC00', NULL, NULL, 146, NULL, NULL, 234765),
(282819, '1em9B00', NULL, NULL, 154, NULL, NULL, 234765),
(282820, '2gonB00', NULL, NULL, 146, NULL, NULL, 234765),
(282821, '1eiaA01', NULL, NULL, 133, NULL, NULL, 234765),
(282822, '4ph2A00', NULL, NULL, 134, NULL, NULL, 234765),
(282823, '2xguA00', NULL, NULL, 149, NULL, NULL, 234765),
(282824, '2xgvA00', NULL, NULL, 142, NULL, NULL, 234765),
(282825, '2xdeA00', NULL, NULL, 145, NULL, NULL, 234765),
(282826, '4dgaC00', NULL, NULL, 146, NULL, NULL, 234765),
(282827, '1u7kA00', NULL, NULL, 131, NULL, NULL, 234765),
(282828, '1g03A00', NULL, NULL, 134, NULL, NULL, 234765),
(282829, '2gonD00', NULL, NULL, 146, NULL, NULL, 234765),
(282830, '2pwoB00', NULL, NULL, 146, NULL, NULL, 234765),
(282831, '2v4xA00', NULL, NULL, 140, NULL, NULL, 234765),
(282832, '4htwA00', NULL, NULL, 143, NULL, NULL, 234765),
(282833, '2g7zA01', NULL, NULL, 157, NULL, NULL, 234766),
(282834, '3lupA01', NULL, NULL, 157, NULL, NULL, 234766),
(282835, '6alwA01', NULL, NULL, 153, NULL, NULL, 234766),
(282836, '3nyiB01', NULL, NULL, 158, NULL, NULL, 234766),
(282837, '2dt8A01', NULL, NULL, 150, NULL, NULL, 234766),
(282838, '1vpvA01', NULL, NULL, 166, NULL, NULL, 234766),
(282839, '4x9xA01', NULL, NULL, 149, NULL, NULL, 234766),
(282840, '1mgpA01', NULL, NULL, 179, NULL, NULL, 234766),
(282841, '6dj6B01', NULL, NULL, 152, NULL, NULL, 234766),
(282842, '6dkeA01', NULL, NULL, 155, NULL, NULL, 234766),
(282843, '3fysA01', NULL, NULL, 153, NULL, NULL, 234766),
(282844, '2f8lA01', NULL, NULL, 98, NULL, NULL, 234767),
(282845, '1xsoA00', NULL, NULL, 150, NULL, NULL, 234768),
(282846, '1to4A00', NULL, NULL, 156, NULL, NULL, 234768),
(282847, '1do5B00', NULL, NULL, 154, NULL, NULL, 234768),
(282848, '1ej8A00', NULL, NULL, 140, NULL, NULL, 234768),
(282849, '3ltvC00', NULL, NULL, 153, NULL, NULL, 234768),
(282850, '2e47B00', NULL, NULL, 156, NULL, NULL, 234768),
(282851, '1xtmA00', NULL, NULL, 157, NULL, NULL, 234768),
(282852, '2wwoB00', NULL, NULL, 169, NULL, NULL, 234768),
(282853, '3kbeA00', NULL, NULL, 157, NULL, NULL, 234768),
(282854, '4a7uA00', NULL, NULL, 153, NULL, NULL, 234768),
(282855, '3gtvA00', NULL, NULL, 153, NULL, NULL, 234768),
(282856, '2apsA00', NULL, NULL, 162, NULL, NULL, 234768),
(282857, '1z9nA00', NULL, NULL, 155, NULL, NULL, 234768),
(282858, '2q2lA00', NULL, NULL, 152, NULL, NULL, 234768),
(282859, '4bczA00', NULL, NULL, 110, NULL, NULL, 234768),
(282860, '5kbmA00', NULL, NULL, 159, NULL, NULL, 234768),
(282861, '2aqpA00', NULL, NULL, 164, NULL, NULL, 234768),
(282862, '1oalA00', NULL, NULL, 151, NULL, NULL, 234768),
(282863, '1mfmA00', NULL, NULL, 153, NULL, NULL, 234768),
(282864, '6d52B00', NULL, NULL, 165, NULL, NULL, 234768),
(282865, '1esoA00', NULL, NULL, 154, NULL, NULL, 234768),
(282866, '2k4wA00', NULL, NULL, 154, NULL, NULL, 234768),
(282867, '3pu7A00', NULL, NULL, 154, NULL, NULL, 234768),
(282868, '4l05A00', NULL, NULL, 154, NULL, NULL, 234768),
(282869, '3mndA00', NULL, NULL, 152, NULL, NULL, 234768),
(282870, '3l9yA00', NULL, NULL, 154, NULL, NULL, 234768),
(282871, '1srdA00', NULL, NULL, 154, NULL, NULL, 234768),
(282872, '5j07A00', NULL, NULL, 115, NULL, NULL, 234768),
(282873, '3ce1A00', NULL, NULL, 168, NULL, NULL, 234768),
(282874, '4u4iA00', NULL, NULL, 161, NULL, NULL, 234768),
(282875, '1q0eA00', NULL, NULL, 152, NULL, NULL, 234768),
(282876, '1pzsA00', NULL, NULL, 171, NULL, NULL, 234768),
(282877, '1f1gA00', NULL, NULL, 154, NULL, NULL, 234768),
(282878, '1e9pA00', NULL, NULL, 151, NULL, NULL, 234768),
(282879, '2jlpB00', NULL, NULL, 166, NULL, NULL, 234768),
(282880, '3f7lA00', NULL, NULL, 152, NULL, NULL, 234768),
(282881, '4ojaA00', NULL, NULL, 149, NULL, NULL, 234768),
(282882, '3tw5A02', NULL, NULL, 82, NULL, NULL, 234769),
(282883, '2bzrB02', NULL, NULL, 268, NULL, NULL, 234770);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(282884, '1y7oD00', NULL, NULL, 198, NULL, NULL, 234770),
(282885, '2vx2A01', NULL, NULL, 199, NULL, NULL, 234770),
(282886, '4zu2A01', NULL, NULL, 207, NULL, NULL, 234770),
(282887, '5c9gA01', NULL, NULL, 225, NULL, NULL, 234770),
(282888, '2f9yB00', NULL, NULL, 263, NULL, NULL, 234770),
(282889, '1fc6A03', NULL, NULL, 192, NULL, NULL, 234770),
(282890, '4ghnA03', NULL, NULL, 171, NULL, NULL, 234770),
(282891, '3hinA01', NULL, NULL, 211, NULL, NULL, 234770),
(282892, '1x0uA02', NULL, NULL, 257, NULL, NULL, 234770),
(282893, '1x0uA01', NULL, NULL, 265, NULL, NULL, 234770),
(282894, '3qxiB01', NULL, NULL, 207, NULL, NULL, 234770),
(282895, '5fusA01', NULL, NULL, 226, NULL, NULL, 234770),
(282896, '4fzwB01', NULL, NULL, 200, NULL, NULL, 234770),
(282897, '1xx4A01', NULL, NULL, 205, NULL, NULL, 234770),
(282898, '3qreA00', NULL, NULL, 227, NULL, NULL, 234770),
(282899, '3m6nC01', NULL, NULL, 216, NULL, NULL, 234770),
(282900, '2cbyD00', NULL, NULL, 208, NULL, NULL, 234770),
(282901, '2gtrA01', NULL, NULL, 204, NULL, NULL, 234770),
(282902, '3iavA02', NULL, NULL, 261, NULL, NULL, 234770),
(282903, '3fduF00', NULL, NULL, 235, NULL, NULL, 234770),
(282904, '1y7oE00', NULL, NULL, 198, NULL, NULL, 234770),
(282905, '2zl2A00', NULL, NULL, 177, NULL, NULL, 234770),
(282906, '2bzrA01', NULL, NULL, 260, NULL, NULL, 234770),
(282907, '6ojmB01', NULL, NULL, 223, NULL, NULL, 234770),
(282908, '4wz8C01', NULL, NULL, 252, NULL, NULL, 234770),
(282909, '3rsiA01', NULL, NULL, 207, NULL, NULL, 234770),
(282910, '3t3wB00', NULL, NULL, 245, NULL, NULL, 234770),
(282911, '3iavA01', NULL, NULL, 269, NULL, NULL, 234770),
(282912, '1uysA03', NULL, NULL, 342, NULL, NULL, 234770),
(282913, '5e0nX00', NULL, NULL, 236, NULL, NULL, 234770),
(282914, '3isaB00', NULL, NULL, 254, NULL, NULL, 234770),
(282915, '4i42C01', NULL, NULL, 222, NULL, NULL, 234770),
(282916, '4mouA01', NULL, NULL, 205, NULL, NULL, 234770),
(282917, '4z0mA01', NULL, NULL, 198, NULL, NULL, 234770),
(282918, '5z7rA01', NULL, NULL, 202, NULL, NULL, 234770),
(282919, '4zdfB00', NULL, NULL, 265, NULL, NULL, 234770),
(282920, '2f9iD00', NULL, NULL, 257, NULL, NULL, 234770),
(282921, '1pixA03', NULL, NULL, 299, NULL, NULL, 234770),
(282922, '1pixA02', NULL, NULL, 229, NULL, NULL, 234770),
(282923, '3tdcA03', NULL, NULL, 409, NULL, NULL, 234770),
(282924, '3tdcA01', NULL, NULL, 262, NULL, NULL, 234770),
(282925, '4jfcA01', NULL, NULL, 201, NULL, NULL, 234770),
(282926, '2vreB01', NULL, NULL, 217, NULL, NULL, 234770),
(282927, '3qxzA01', NULL, NULL, 204, NULL, NULL, 234770),
(282928, '2f9iC00', NULL, NULL, 327, NULL, NULL, 234770),
(282929, '4di1B01', NULL, NULL, 199, NULL, NULL, 234770),
(282930, '1wz8A01', NULL, NULL, 207, NULL, NULL, 234770),
(282931, '4l8kA02', NULL, NULL, 217, NULL, NULL, 234770),
(282932, '3laoB01', NULL, NULL, 228, NULL, NULL, 234770),
(282933, '1szoB00', NULL, NULL, 257, NULL, NULL, 234770),
(282934, '4fzwC01', NULL, NULL, 216, NULL, NULL, 234770),
(282935, '4q1iA00', NULL, NULL, 243, NULL, NULL, 234770),
(282936, '3h81A01', NULL, NULL, 198, NULL, NULL, 234770),
(282937, '4kpkA00', NULL, NULL, 265, NULL, NULL, 234770),
(282938, '3tlfD01', NULL, NULL, 216, NULL, NULL, 234770),
(282939, '3swxB01', NULL, NULL, 207, NULL, NULL, 234770),
(282940, '1y7oF00', NULL, NULL, 198, NULL, NULL, 234770),
(282941, '1mj3A01', NULL, NULL, 202, NULL, NULL, 234770),
(282942, '3gkbA00', NULL, NULL, 287, NULL, NULL, 234770),
(282943, '3k50A03', NULL, NULL, 179, NULL, NULL, 234770),
(282944, '5dufA00', NULL, NULL, 245, NULL, NULL, 234770),
(282945, '4jcqA00', NULL, NULL, 201, NULL, NULL, 234770),
(282946, '1nzyA01', NULL, NULL, 204, NULL, NULL, 234770),
(282947, '3peaF00', NULL, NULL, 261, NULL, NULL, 234770),
(282948, '5ve2I00', NULL, NULL, 251, NULL, NULL, 234770),
(282949, '2a7kB01', NULL, NULL, 197, NULL, NULL, 234770),
(282950, '3pe8A00', NULL, NULL, 235, NULL, NULL, 234770),
(282951, '2pbpA01', NULL, NULL, 200, NULL, NULL, 234770),
(282952, '4jyjB00', NULL, NULL, 275, NULL, NULL, 234770),
(282953, '5o34A01', NULL, NULL, 197, NULL, NULL, 234770),
(282954, '3ot6A00', NULL, NULL, 232, NULL, NULL, 234770);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(282955, '1k32A05', NULL, NULL, 216, NULL, NULL, 234770),
(282956, '5wydB01', NULL, NULL, 212, NULL, NULL, 234770),
(282957, '4asiE01', NULL, NULL, 271, NULL, NULL, 234770),
(282958, '2np9B02', NULL, NULL, 294, NULL, NULL, 234770),
(282959, '3u9rB01', NULL, NULL, 273, NULL, NULL, 234770),
(282960, '3u9rB02', NULL, NULL, 263, NULL, NULL, 234770),
(282961, '1j7xA02', NULL, NULL, 214, NULL, NULL, 234770),
(282962, '5fifC02', NULL, NULL, 252, NULL, NULL, 234770),
(282963, '1tg6E00', NULL, NULL, 205, NULL, NULL, 234770),
(282964, '3fduA01', NULL, NULL, 184, NULL, NULL, 234770),
(282965, '4wyoB03', NULL, NULL, 364, NULL, NULL, 234770),
(282966, '1y7oG00', NULL, NULL, 197, NULL, NULL, 234770),
(282967, '3g64A01', NULL, NULL, 218, NULL, NULL, 234770),
(282968, '2f9yA00', NULL, NULL, 316, NULL, NULL, 234770),
(282969, '4og1A01', NULL, NULL, 210, NULL, NULL, 234770),
(282970, '4hdtA00', NULL, NULL, 353, NULL, NULL, 234770),
(282971, '1hzdA01', NULL, NULL, 212, NULL, NULL, 234770),
(282972, '3qkaE01', NULL, NULL, 203, NULL, NULL, 234770),
(282973, '5dkpk00', NULL, NULL, 206, NULL, NULL, 234770),
(282974, '3ktiA00', NULL, NULL, 182, NULL, NULL, 234770),
(282975, '4izbB01', NULL, NULL, 208, NULL, NULL, 234770),
(282976, '3q7hB00', NULL, NULL, 195, NULL, NULL, 234770),
(282977, '4nnqC01', NULL, NULL, 193, NULL, NULL, 234770),
(282978, '4fn7B00', NULL, NULL, 231, NULL, NULL, 234770),
(282979, '4i4zA01', NULL, NULL, 212, NULL, NULL, 234770),
(282980, '4f47A01', NULL, NULL, 202, NULL, NULL, 234770),
(282981, '3oc7A01', NULL, NULL, 194, NULL, NULL, 234770),
(282982, '4k3wA01', NULL, NULL, 207, NULL, NULL, 234770),
(282983, '3ju1B00', NULL, NULL, 371, NULL, NULL, 234770),
(282984, '5c90B00', NULL, NULL, 195, NULL, NULL, 234770),
(282985, '4asiF03', NULL, NULL, 403, NULL, NULL, 234770),
(282986, '3kqfA01', NULL, NULL, 205, NULL, NULL, 234770),
(282987, '4kd6A00', NULL, NULL, 227, NULL, NULL, 234770),
(282988, '4jotA01', NULL, NULL, 212, NULL, NULL, 234770),
(282989, '6cfdI00', NULL, NULL, 191, NULL, NULL, 234770),
(282990, '4jjtB00', NULL, NULL, 232, NULL, NULL, 234770),
(282991, '2j5gK00', NULL, NULL, 263, NULL, NULL, 234770),
(282992, '3r9tB01', NULL, NULL, 206, NULL, NULL, 234770),
(282993, '2hw5A01', NULL, NULL, 202, NULL, NULL, 234770),
(282994, '2fw2B01', NULL, NULL, 203, NULL, NULL, 234770),
(282995, '1sg4A01', NULL, NULL, 204, NULL, NULL, 234770),
(282996, '5g1sG00', NULL, NULL, 201, NULL, NULL, 234770),
(282997, '5ingF01', NULL, NULL, 256, NULL, NULL, 234770),
(282998, '5e0sB00', NULL, NULL, 214, NULL, NULL, 234770),
(282999, '3gf3A02', NULL, NULL, 231, NULL, NULL, 234770),
(283000, '3lkeB00', NULL, NULL, 263, NULL, NULL, 234770),
(283001, '4kwbA01', NULL, NULL, 206, NULL, NULL, 234770),
(283002, '3gf3A03', NULL, NULL, 297, NULL, NULL, 234770),
(283003, '4q1hB01', NULL, NULL, 180, NULL, NULL, 234770),
(283004, '4nekA01', NULL, NULL, 196, NULL, NULL, 234770),
(283005, '3r0oA01', NULL, NULL, 212, NULL, NULL, 234770),
(283006, '5iklD02', NULL, NULL, 267, NULL, NULL, 234770),
(283007, '3r6hA00', NULL, NULL, 233, NULL, NULL, 234770),
(283008, '1on3B01', NULL, NULL, 261, NULL, NULL, 234770),
(283009, '2x24A03', NULL, NULL, 372, NULL, NULL, 234770),
(283010, '2x24A01', NULL, NULL, 250, NULL, NULL, 234770),
(283011, '4u0gJ00', NULL, NULL, 194, NULL, NULL, 234770),
(283012, '1dciA01', NULL, NULL, 212, NULL, NULL, 234770),
(283013, '3bptA00', NULL, NULL, 363, NULL, NULL, 234770),
(283014, '2uzfA01', NULL, NULL, 210, NULL, NULL, 234770),
(283015, '6iumA01', NULL, NULL, 279, NULL, NULL, 234770),
(283016, '4gm2A00', NULL, NULL, 184, NULL, NULL, 234770),
(283017, '5fifE01', NULL, NULL, 255, NULL, NULL, 234770),
(283018, '3qk8B01', NULL, NULL, 210, NULL, NULL, 234770),
(283019, '1uyvB02', NULL, NULL, 292, NULL, NULL, 234770),
(283020, '3q1tB01', NULL, NULL, 216, NULL, NULL, 234770),
(283021, '3bf0C03', NULL, NULL, 167, NULL, NULL, 234770),
(283022, '3l3sA01', NULL, NULL, 207, NULL, NULL, 234770),
(283023, '3t8bB00', NULL, NULL, 238, NULL, NULL, 234770),
(283024, '3bf0C01', NULL, NULL, 221, NULL, NULL, 234770),
(283025, '1y7oA00', NULL, NULL, 197, NULL, NULL, 234770);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(283026, '4wczC01', NULL, NULL, 218, NULL, NULL, 234770),
(283027, '3mybA01', NULL, NULL, 200, NULL, NULL, 234770),
(283028, '3n6rB01', NULL, NULL, 252, NULL, NULL, 234770),
(283029, '3moyA01', NULL, NULL, 205, NULL, NULL, 234770),
(283030, '3p85A00', NULL, NULL, 230, NULL, NULL, 234770),
(283031, '3n6rB02', NULL, NULL, 254, NULL, NULL, 234770),
(283032, '4rcnA04', NULL, NULL, 241, NULL, NULL, 234770),
(283033, '3hrxA01', NULL, NULL, 196, NULL, NULL, 234770),
(283034, '1uiyA01', NULL, NULL, 198, NULL, NULL, 234770),
(283035, '3h02A01', NULL, NULL, 225, NULL, NULL, 234770),
(283036, '3hp0A00', NULL, NULL, 267, NULL, NULL, 234770),
(283037, '3njdA00', NULL, NULL, 305, NULL, NULL, 234770),
(283038, '3rrvC00', NULL, NULL, 253, NULL, NULL, 234770),
(283039, '4qfeB01', NULL, NULL, 203, NULL, NULL, 234770),
(283040, '4lk5C01', NULL, NULL, 185, NULL, NULL, 234770),
(283041, '3p5mB01', NULL, NULL, 180, NULL, NULL, 234770),
(283042, '3omeB00', NULL, NULL, 261, NULL, NULL, 234770),
(283043, '6mx2J00', NULL, NULL, 194, NULL, NULL, 234770),
(283044, '2ej5B01', NULL, NULL, 199, NULL, NULL, 234770),
(283045, '4u19A01', NULL, NULL, 224, NULL, NULL, 234770),
(283046, '4mi2B01', NULL, NULL, 209, NULL, NULL, 234770),
(283047, '3dorA03', NULL, NULL, 254, NULL, NULL, 234770),
(283048, '1y7oB00', NULL, NULL, 198, NULL, NULL, 234770),
(283049, '3qmjA00', NULL, NULL, 219, NULL, NULL, 234770),
(283050, '1vrgA02', NULL, NULL, 257, NULL, NULL, 234770),
(283051, '3trrA01', NULL, NULL, 198, NULL, NULL, 234770),
(283052, '1vrgA01', NULL, NULL, 270, NULL, NULL, 234770),
(283053, '5ingD02', NULL, NULL, 262, NULL, NULL, 234770),
(283054, '4rcnB03', NULL, NULL, 274, NULL, NULL, 234770),
(283055, '2f6iC00', NULL, NULL, 194, NULL, NULL, 234770),
(283056, '4l6wA02', NULL, NULL, 223, NULL, NULL, 234770),
(283057, '4l6wA01', NULL, NULL, 205, NULL, NULL, 234770),
(283058, '1on9D02', NULL, NULL, 252, NULL, NULL, 234770),
(283059, '4jylA01', NULL, NULL, 200, NULL, NULL, 234770),
(283060, '3sllB01', NULL, NULL, 208, NULL, NULL, 234770),
(283061, '5iklF01', NULL, NULL, 223, NULL, NULL, 234770),
(283062, '1wdkA01', NULL, NULL, 313, NULL, NULL, 234770),
(283063, '5ctbB03', NULL, NULL, 342, NULL, NULL, 234770),
(283064, '4jwvA01', NULL, NULL, 201, NULL, NULL, 234770),
(283065, '4q0gA01', NULL, NULL, 266, NULL, NULL, 234770),
(283066, '3zwcA01', NULL, NULL, 279, NULL, NULL, 234770),
(283067, '5kjpA01', NULL, NULL, 207, NULL, NULL, 234770),
(283068, '2iexA01', NULL, NULL, 209, NULL, NULL, 234770),
(283069, '4jctA00', NULL, NULL, 193, NULL, NULL, 234770),
(283070, '2j5iA01', NULL, NULL, 211, NULL, NULL, 234770),
(283071, '1y7oC00', NULL, NULL, 198, NULL, NULL, 234770),
(283072, '3vivA00', NULL, NULL, 230, NULL, NULL, 234770),
(283073, '3i47A01', NULL, NULL, 203, NULL, NULL, 234770),
(283074, '5jbxB01', NULL, NULL, 201, NULL, NULL, 234770),
(283075, '6n92A01', NULL, NULL, 185, NULL, NULL, 234770),
(283076, '4jcsA01', NULL, NULL, 205, NULL, NULL, 234770),
(283077, '4g2rA01', NULL, NULL, 217, NULL, NULL, 234770),
(283078, '4lk5A00', NULL, NULL, 262, NULL, NULL, 234770),
(283079, '4jvtA01', NULL, NULL, 225, NULL, NULL, 234770),
(283080, '3r9qA01', NULL, NULL, 206, NULL, NULL, 234770),
(283081, '3h0uB00', NULL, NULL, 289, NULL, NULL, 234770),
(283082, '1yg6A00', NULL, NULL, 193, NULL, NULL, 234770),
(283083, '4b3hB01', NULL, NULL, 340, NULL, NULL, 234770),
(283084, '4k2nA01', NULL, NULL, 225, NULL, NULL, 234770),
(283085, '2ppyA01', NULL, NULL, 205, NULL, NULL, 234770),
(283086, '2w3pA01', NULL, NULL, 326, NULL, NULL, 234770),
(283087, '2w3pA02', NULL, NULL, 230, NULL, NULL, 234770),
(283088, '4k29B00', NULL, NULL, 271, NULL, NULL, 234770),
(283089, '2q35A01', NULL, NULL, 179, NULL, NULL, 234770),
(283090, '4j2uB00', NULL, NULL, 342, NULL, NULL, 234770),
(283091, '2wtbA01', NULL, NULL, 311, NULL, NULL, 234770),
(283092, '3u9tB01', NULL, NULL, 256, NULL, NULL, 234770),
(283093, '4q0gB02', NULL, NULL, 263, NULL, NULL, 234770),
(283094, '1p90A00', NULL, NULL, 123, NULL, NULL, 234771),
(283095, '2wfbA00', NULL, NULL, 120, NULL, NULL, 234771),
(283096, '2re2A00', NULL, NULL, 136, NULL, NULL, 234771);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(283097, '1o13A00', NULL, NULL, 119, NULL, NULL, 234771),
(283098, '1eo1A00', NULL, NULL, 124, NULL, NULL, 234771),
(283099, '2yx6D01', NULL, NULL, 105, NULL, NULL, 234771),
(283100, '2qtdA00', NULL, NULL, 105, NULL, NULL, 234771),
(283101, '1rduA00', NULL, NULL, 116, NULL, NULL, 234771),
(283102, '3myuA01', NULL, NULL, 157, NULL, NULL, 234772),
(283103, '3ekiA01', NULL, NULL, 176, NULL, NULL, 234772),
(283104, '4rocB01', NULL, NULL, 97, NULL, NULL, 234773),
(283105, '1cdwA02', NULL, NULL, 86, NULL, NULL, 234773),
(283106, '1mp9A02', NULL, NULL, 87, NULL, NULL, 234773),
(283107, '1mp9A01', NULL, NULL, 96, NULL, NULL, 234773),
(283108, '2z8uB02', NULL, NULL, 87, NULL, NULL, 234773),
(283109, '4py5A01', NULL, NULL, 72, NULL, NULL, 234773),
(283110, '2z8uA01', NULL, NULL, 101, NULL, NULL, 234773),
(283111, '1qnaA01', NULL, NULL, 93, NULL, NULL, 234773),
(283112, '2d0bA01', NULL, NULL, 90, NULL, NULL, 234773),
(283113, '1qnaA02', NULL, NULL, 86, NULL, NULL, 234773),
(283114, '1r4xA02', NULL, NULL, 115, NULL, NULL, 234773),
(283115, '2g30A02', NULL, NULL, 116, NULL, NULL, 234773),
(283116, '1ytbA02', NULL, NULL, 86, NULL, NULL, 234773),
(283117, '1ytbA01', NULL, NULL, 94, NULL, NULL, 234773),
(283118, '3vn5A01', NULL, NULL, 70, NULL, NULL, 234773),
(283119, '1aisA01', NULL, NULL, 91, NULL, NULL, 234773),
(283120, '1kyfA02', NULL, NULL, 113, NULL, NULL, 234773),
(283121, '1aisA02', NULL, NULL, 87, NULL, NULL, 234773),
(283122, '3eikA01', NULL, NULL, 93, NULL, NULL, 234773),
(283123, '2mj7A00', NULL, NULL, 141, NULL, NULL, 234773),
(283124, '3eikA02', NULL, NULL, 86, NULL, NULL, 234773),
(283125, '3rx6A00', NULL, NULL, 190, NULL, NULL, 234774),
(283126, '3cm1C00', NULL, NULL, 139, NULL, NULL, 234775),
(283127, '1ci6A00', NULL, NULL, 63, NULL, NULL, 234776),
(283128, '2xv5A00', NULL, NULL, 58, NULL, NULL, 234776),
(283129, '2ynyC00', NULL, NULL, 106, NULL, NULL, 234776),
(283130, '4aycA01', NULL, NULL, 53, NULL, NULL, 234776),
(283131, '4hytD01', NULL, NULL, 45, NULL, NULL, 234776),
(283132, '4jnuA00', NULL, NULL, 40, NULL, NULL, 234776),
(283133, '3nxsA01', NULL, NULL, 54, NULL, NULL, 234776),
(283134, '2lw9A00', NULL, NULL, 51, NULL, NULL, 234776),
(283135, '3tyyB00', NULL, NULL, 76, NULL, NULL, 234776),
(283136, '4c7nB00', NULL, NULL, 51, NULL, NULL, 234776),
(283137, '3lidA01', NULL, NULL, 47, NULL, NULL, 234776),
(283138, '2yo3A01', NULL, NULL, 77, NULL, NULL, 234776),
(283139, '3tk1B01', NULL, NULL, 53, NULL, NULL, 234776),
(283140, '1jnmA00', NULL, NULL, 62, NULL, NULL, 234776),
(283141, '3b8eB00', NULL, NULL, 46, NULL, NULL, 234776),
(283142, '3he5B00', NULL, NULL, 52, NULL, NULL, 234776),
(283143, '3p32A01', NULL, NULL, 46, NULL, NULL, 234776),
(283144, '1nwqA00', NULL, NULL, 62, NULL, NULL, 234776),
(283145, '3t97A00', NULL, NULL, 64, NULL, NULL, 234776),
(283146, '1yycA01', NULL, NULL, 30, NULL, NULL, 234776),
(283147, '5vpeB00', NULL, NULL, 68, NULL, NULL, 234776),
(283148, '1slqE02', NULL, NULL, 40, NULL, NULL, 234776),
(283149, '3a2aA00', NULL, NULL, 58, NULL, NULL, 234776),
(283150, '2wg5F01', NULL, NULL, 37, NULL, NULL, 234776),
(283151, '4b86B00', NULL, NULL, 59, NULL, NULL, 234776),
(283152, '1x8yA00', NULL, NULL, 86, NULL, NULL, 234776),
(283153, '3he4A00', NULL, NULL, 56, NULL, NULL, 234776),
(283154, '4aqrD00', NULL, NULL, 57, NULL, NULL, 234776),
(283155, '1ci6B00', NULL, NULL, 47, NULL, NULL, 234776),
(283156, '3a7oB00', NULL, NULL, 75, NULL, NULL, 234776),
(283157, '3kqgA01', NULL, NULL, 52, NULL, NULL, 234776),
(283158, '2xv5B00', NULL, NULL, 58, NULL, NULL, 234776),
(283159, '1gd2F00', NULL, NULL, 70, NULL, NULL, 234776),
(283160, '2vrsC01', NULL, NULL, 39, NULL, NULL, 234776),
(283161, '4c46A00', NULL, NULL, 76, NULL, NULL, 234776),
(283162, '1t2kD00', NULL, NULL, 61, NULL, NULL, 234776),
(283163, '5apsA00', NULL, NULL, 63, NULL, NULL, 234776),
(283164, '4bwdB00', NULL, NULL, 82, NULL, NULL, 234776),
(283165, '3htkA00', NULL, NULL, 60, NULL, NULL, 234776),
(283166, '3vn0B00', NULL, NULL, 51, NULL, NULL, 234776),
(283167, '2d3eA00', NULL, NULL, 134, NULL, NULL, 234776);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(283168, '1dh3A00', NULL, NULL, 55, NULL, NULL, 234776),
(283169, '2zfcA00', NULL, NULL, 49, NULL, NULL, 234776),
(283170, '1owaA01', NULL, NULL, 32, NULL, NULL, 234776),
(283171, '3a5tA00', NULL, NULL, 107, NULL, NULL, 234776),
(283172, '2e42A00', NULL, NULL, 78, NULL, NULL, 234776),
(283173, '1j2jB00', NULL, NULL, 45, NULL, NULL, 234776),
(283174, '3m0aA00', NULL, NULL, 66, NULL, NULL, 234776),
(283175, '2pjuD03', NULL, NULL, 46, NULL, NULL, 234776),
(283176, '2qm8A01', NULL, NULL, 52, NULL, NULL, 234776),
(283177, '2xu6A00', NULL, NULL, 72, NULL, NULL, 234776),
(283178, '2iu8C03', NULL, NULL, 37, NULL, NULL, 234776),
(283179, '3he4B00', NULL, NULL, 46, NULL, NULL, 234776),
(283180, '2b9cA00', NULL, NULL, 147, NULL, NULL, 234776),
(283181, '4eotA00', NULL, NULL, 95, NULL, NULL, 234776),
(283182, '3kqgF01', NULL, NULL, 34, NULL, NULL, 234776),
(283183, '4i6mC00', NULL, NULL, 76, NULL, NULL, 234776),
(283184, '6mg2A00', NULL, NULL, 78, NULL, NULL, 234776),
(283185, '4hytB01', NULL, NULL, 61, NULL, NULL, 234776),
(283186, '3tnuB00', NULL, NULL, 96, NULL, NULL, 234776),
(283187, '3nmdA00', NULL, NULL, 54, NULL, NULL, 234776),
(283188, '3pmoA03', NULL, NULL, 41, NULL, NULL, 234776),
(283189, '3m91A00', NULL, NULL, 51, NULL, NULL, 234776),
(283190, '1junA00', NULL, NULL, 44, NULL, NULL, 234776),
(283191, '2wpqA00', NULL, NULL, 99, NULL, NULL, 234776),
(283192, '2basA02', NULL, NULL, 46, NULL, NULL, 234776),
(283193, '3a7pB00', NULL, NULL, 76, NULL, NULL, 234776),
(283194, '2r32A01', NULL, NULL, 36, NULL, NULL, 234776),
(283195, '3ntnA02', NULL, NULL, 52, NULL, NULL, 234776),
(283196, '5zkoA00', NULL, NULL, 59, NULL, NULL, 234776),
(283197, '3ir9A01', NULL, NULL, 37, NULL, NULL, 234776),
(283198, '2ynzC01', NULL, NULL, 57, NULL, NULL, 234776),
(283199, '2xzrA00', NULL, NULL, 114, NULL, NULL, 234776),
(283200, '3oakA01', NULL, NULL, 41, NULL, NULL, 234776),
(283201, '4e79B03', NULL, NULL, 43, NULL, NULL, 234776),
(283202, '3m9bB01', NULL, NULL, 48, NULL, NULL, 234776),
(283203, '1hbwA00', NULL, NULL, 57, NULL, NULL, 234776),
(283204, '1gk6A00', NULL, NULL, 59, NULL, NULL, 234776),
(283205, '2kp8A00', NULL, NULL, 72, NULL, NULL, 234776),
(283206, '5vpcA00', NULL, NULL, 68, NULL, NULL, 234776),
(283207, '2hapC02', NULL, NULL, 39, NULL, NULL, 234776),
(283208, '2w6aB00', NULL, NULL, 63, NULL, NULL, 234776),
(283209, '3i5cA01', NULL, NULL, 30, NULL, NULL, 234776),
(283210, '5avuB01', NULL, NULL, 38, NULL, NULL, 234776),
(283211, '5apxC00', NULL, NULL, 62, NULL, NULL, 234776),
(283212, '2wt7B00', NULL, NULL, 90, NULL, NULL, 234776),
(283213, '2efrB00', NULL, NULL, 155, NULL, NULL, 234776),
(283214, '3virC00', NULL, NULL, 66, NULL, NULL, 234776),
(283215, '1csbA01', NULL, NULL, 42, NULL, NULL, 234776),
(283216, '3p7kA00', NULL, NULL, 45, NULL, NULL, 234776),
(283217, '4gkgA00', NULL, NULL, 67, NULL, NULL, 234776),
(283218, '2p67A01', NULL, NULL, 53, NULL, NULL, 234776),
(283219, '1nafA01', NULL, NULL, 53, NULL, NULL, 234776),
(283220, '3tnuA00', NULL, NULL, 91, NULL, NULL, 234776),
(283221, '1mv8A02', NULL, NULL, 32, NULL, NULL, 234776),
(283222, '4c7nA00', NULL, NULL, 51, NULL, NULL, 234776),
(283223, '4i2lC00', NULL, NULL, 42, NULL, NULL, 234776),
(283224, '1g2cB00', NULL, NULL, 43, NULL, NULL, 234776),
(283225, '1favA00', NULL, NULL, 79, NULL, NULL, 234776),
(283226, '3mgnA00', NULL, NULL, 47, NULL, NULL, 234776),
(283227, '3vyiF00', NULL, NULL, 51, NULL, NULL, 234776),
(283228, '2n9bA00', NULL, NULL, 69, NULL, NULL, 234776),
(283229, '3he5A00', NULL, NULL, 49, NULL, NULL, 234776),
(283230, '3swfA00', NULL, NULL, 74, NULL, NULL, 234776),
(283231, '2z5iC00', NULL, NULL, 52, NULL, NULL, 234776),
(283232, '4e75C03', NULL, NULL, 27, NULL, NULL, 234776),
(283233, '2c9lZ00', NULL, NULL, 63, NULL, NULL, 234776),
(283234, '2p2uA01', NULL, NULL, 79, NULL, NULL, 234776),
(283235, '4dzoB01', NULL, NULL, 42, NULL, NULL, 234776),
(283236, '3eh0A03', NULL, NULL, 32, NULL, NULL, 234776),
(283237, '1gu4A00', NULL, NULL, 78, NULL, NULL, 234776),
(283238, '4j3hA00', NULL, NULL, 46, NULL, NULL, 234776),
(283239, '3op9A02', NULL, NULL, 41, NULL, NULL, 234776);
INSERT INTO "PUBLIC"."MODEL" VALUES
(283240, '2wwwC01', NULL, NULL, 66, NULL, NULL, 234776),
(283241, '1gk4C00', NULL, NULL, 84, NULL, NULL, 234776),
(283242, '4m3lC00', NULL, NULL, 61, NULL, NULL, 234776),
(283243, '3p8mC00', NULL, NULL, 46, NULL, NULL, 234776),
(283244, '3nfqA01', NULL, NULL, 42, NULL, NULL, 234776),
(283245, '2wt7A00', NULL, NULL, 63, NULL, NULL, 234776),
(283246, '2yo2A01', NULL, NULL, 53, NULL, NULL, 234776),
(283247, '3uiaA00', NULL, NULL, 53, NULL, NULL, 234776),
(283248, '2yo2A03', NULL, NULL, 57, NULL, NULL, 234776),
(283249, '5b1aD00', NULL, NULL, 147, NULL, NULL, 234777),
(283250, '5z62D00', NULL, NULL, 144, NULL, NULL, 234777),
(283251, '1gkuB04', NULL, NULL, 73, NULL, NULL, 234778),
(283252, '3eh2A03', NULL, NULL, 137, NULL, NULL, 234779),
(283253, '3eh1A03', NULL, NULL, 133, NULL, NULL, 234779),
(283254, '3efoB03', NULL, NULL, 137, NULL, NULL, 234779),
(283255, '2nutA01', NULL, NULL, 174, NULL, NULL, 234779),
(283256, '2nutB03', NULL, NULL, 133, NULL, NULL, 234779),
(283257, '1pcxA03', NULL, NULL, 136, NULL, NULL, 234779),
(283258, '1m2oA01', NULL, NULL, 175, NULL, NULL, 234779),
(283259, '2j5uA01', NULL, NULL, 39, NULL, NULL, 234780),
(283260, '4r4mA00', NULL, NULL, 49, NULL, NULL, 234780),
(283261, '2j5uB01', NULL, NULL, 40, NULL, NULL, 234780),
(283262, '1dipA01', NULL, NULL, 46, NULL, NULL, 234780),
(283263, '2oqqA00', NULL, NULL, 42, NULL, NULL, 234780),
(283264, '1r8eA03', NULL, NULL, 44, NULL, NULL, 234780),
(283265, '3g9rA00', NULL, NULL, 42, NULL, NULL, 234780),
(283266, '3t97B00', NULL, NULL, 65, NULL, NULL, 234780),
(283267, '1vqqA01', NULL, NULL, 113, NULL, NULL, 234781),
(283268, '4bk0A02', NULL, NULL, 47, NULL, NULL, 234782),
(283269, '2x7xA03', NULL, NULL, 33, NULL, NULL, 234783),
(283270, '4bx8A01', NULL, NULL, 143, NULL, NULL, 234784),
(283271, '3pukA01', NULL, NULL, 135, NULL, NULL, 234784),
(283272, '1epuA01', NULL, NULL, 129, NULL, NULL, 234784),
(283273, '1fvhA02', NULL, NULL, 129, NULL, NULL, 234784),
(283274, '4jc8A01', NULL, NULL, 142, NULL, NULL, 234784),
(283275, '4ccaA01', NULL, NULL, 137, NULL, NULL, 234784),
(283276, '1y9jA01', NULL, NULL, 133, NULL, NULL, 234784),
(283277, '2xheA01', NULL, NULL, 128, NULL, NULL, 234784),
(283278, '1mqsA01', NULL, NULL, 140, NULL, NULL, 234784),
(283279, '4jehA01', NULL, NULL, 129, NULL, NULL, 234784),
(283280, '3vk6A02', NULL, NULL, 42, NULL, NULL, 234785),
(283281, '1gs0A01', NULL, NULL, 135, NULL, NULL, 234786),
(283282, '4dqyC03', NULL, NULL, 108, NULL, NULL, 234786),
(283283, '3kjdA01', NULL, NULL, 154, NULL, NULL, 234786),
(283284, '4l7nA01', NULL, NULL, 147, NULL, NULL, 234786),
(283285, '1efyA01', NULL, NULL, 136, NULL, NULL, 234786),
(283286, '4r6eD01', NULL, NULL, 137, NULL, NULL, 234786),
(283287, '4zzzA01', NULL, NULL, 145, NULL, NULL, 234786),
(283288, '4zzxA01', NULL, NULL, 145, NULL, NULL, 234786),
(283289, '5glkA00', NULL, NULL, 344, NULL, NULL, 234787),
(283290, '1w2tA01', NULL, NULL, 283, NULL, NULL, 234787),
(283291, '2ac1A01', NULL, NULL, 333, NULL, NULL, 234787),
(283292, '5flwA00', NULL, NULL, 304, NULL, NULL, 234787),
(283293, '5b6tA00', NULL, NULL, 327, NULL, NULL, 234787),
(283294, '6b7kA00', NULL, NULL, 301, NULL, NULL, 234787),
(283295, '3c7fA02', NULL, NULL, 345, NULL, NULL, 234787),
(283296, '4novA00', NULL, NULL, 306, NULL, NULL, 234787),
(283297, '3lv4A01', NULL, NULL, 321, NULL, NULL, 234787),
(283298, '3ligA01', NULL, NULL, 422, NULL, NULL, 234787),
(283299, '4ak5B00', NULL, NULL, 369, NULL, NULL, 234787),
(283300, '1uv4A00', NULL, NULL, 293, NULL, NULL, 234787),
(283301, '4kc7A01', NULL, NULL, 327, NULL, NULL, 234787),
(283302, '4ffhA01', NULL, NULL, 327, NULL, NULL, 234787),
(283303, '3wasA00', NULL, NULL, 390, NULL, NULL, 234787),
(283304, '3kf3A01', NULL, NULL, 332, NULL, NULL, 234787),
(283305, '3kstA00', NULL, NULL, 306, NULL, NULL, 234787),
(283306, '3wmyA00', NULL, NULL, 302, NULL, NULL, 234787),
(283307, '3r67A00', NULL, NULL, 356, NULL, NULL, 234787),
(283308, '5a7vB00', NULL, NULL, 359, NULL, NULL, 234787),
(283309, '4n4bA00', NULL, NULL, 319, NULL, NULL, 234787),
(283310, '4u6dA00', NULL, NULL, 387, NULL, NULL, 234787);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(283311, '4eqvA01', NULL, NULL, 336, NULL, NULL, 234787),
(283312, '5ayeA00', NULL, NULL, 335, NULL, NULL, 234787),
(283313, '4udgB00', NULL, NULL, 321, NULL, NULL, 234787),
(283314, '2x8sA01', NULL, NULL, 325, NULL, NULL, 234787),
(283315, '2b4wA00', NULL, NULL, 315, NULL, NULL, 234787),
(283316, '3nqhA01', NULL, NULL, 305, NULL, NULL, 234787),
(283317, '3qeeB00', NULL, NULL, 307, NULL, NULL, 234787),
(283318, '3sc7X01', NULL, NULL, 336, NULL, NULL, 234787),
(283319, '4onzA00', NULL, NULL, 359, NULL, NULL, 234787),
(283320, '6frwA00', NULL, NULL, 411, NULL, NULL, 234787),
(283321, '3pijA01', NULL, NULL, 377, NULL, NULL, 234787),
(283322, '4d47A00', NULL, NULL, 415, NULL, NULL, 234787),
(283323, '3zxkA01', NULL, NULL, 315, NULL, NULL, 234787),
(283324, '5m8eA00', NULL, NULL, 323, NULL, NULL, 234787),
(283325, '3vsfC01', NULL, NULL, 342, NULL, NULL, 234787),
(283326, '4pvaA00', NULL, NULL, 342, NULL, NULL, 234787),
(283327, '5nslA01', NULL, NULL, 428, NULL, NULL, 234787),
(283328, '6ms3A01', NULL, NULL, 311, NULL, NULL, 234787),
(283329, '5jowA01', NULL, NULL, 312, NULL, NULL, 234787),
(283330, '1w18A00', NULL, NULL, 493, NULL, NULL, 234787),
(283331, '3p2nB02', NULL, NULL, 342, NULL, NULL, 234787),
(283332, '1vkdA00', NULL, NULL, 338, NULL, NULL, 234787),
(283333, '5ubjA00', NULL, NULL, 303, NULL, NULL, 234787),
(283334, '3ugfA01', NULL, NULL, 333, NULL, NULL, 234787),
(283335, '5ho9B01', NULL, NULL, 400, NULL, NULL, 234787),
(283336, '3akhA01', NULL, NULL, 319, NULL, NULL, 234787),
(283337, '5c0pA00', NULL, NULL, 298, NULL, NULL, 234787),
(283338, '5ta7A00', NULL, NULL, 369, NULL, NULL, 234787),
(283339, '1oygA01', NULL, NULL, 441, NULL, NULL, 234787),
(283340, '4qqsB00', NULL, NULL, 315, NULL, NULL, 234787),
(283341, '3r4zA00', NULL, NULL, 374, NULL, NULL, 234787),
(283342, '5zqjA01', NULL, NULL, 326, NULL, NULL, 234787),
(283343, '3c2uA01', NULL, NULL, 328, NULL, NULL, 234787),
(283344, '2yfrA01', NULL, NULL, 484, NULL, NULL, 234787),
(283345, '1gyhA00', NULL, NULL, 318, NULL, NULL, 234787),
(283346, '5m8bA00', NULL, NULL, 325, NULL, NULL, 234787),
(283347, '3cu9A00', NULL, NULL, 314, NULL, NULL, 234787),
(283348, '1st8A01', NULL, NULL, 338, NULL, NULL, 234787),
(283349, '3tawA00', NULL, NULL, 356, NULL, NULL, 234787),
(283350, '4kcbB00', NULL, NULL, 324, NULL, NULL, 234787),
(283351, '1yrzA01', NULL, NULL, 320, NULL, NULL, 234787),
(283352, '3k1uA00', NULL, NULL, 330, NULL, NULL, 234787),
(283353, '5a8cA00', NULL, NULL, 300, NULL, NULL, 234787),
(283354, '6ifeA01', NULL, NULL, 326, NULL, NULL, 234787),
(283355, '6f1jB00', NULL, NULL, 302, NULL, NULL, 234787),
(283356, '1yifA01', NULL, NULL, 326, NULL, NULL, 234787),
(283357, '5jozA01', NULL, NULL, 307, NULL, NULL, 234787),
(283358, '2exhA01', NULL, NULL, 327, NULL, NULL, 234787),
(283359, '4u6bA00', NULL, NULL, 358, NULL, NULL, 234787),
(283360, '3qz4A00', NULL, NULL, 311, NULL, NULL, 234787),
(283361, '1y4wA01', NULL, NULL, 355, NULL, NULL, 234787),
(283362, '3qc2B00', NULL, NULL, 364, NULL, NULL, 234787),
(283363, '5aycA00', NULL, NULL, 386, NULL, NULL, 234787),
(283364, '5xh8A01', NULL, NULL, 427, NULL, NULL, 234787),
(283365, '1y7bA01', NULL, NULL, 326, NULL, NULL, 234787),
(283366, '4n1iA00', NULL, NULL, 334, NULL, NULL, 234787),
(283367, '4kcaA02', NULL, NULL, 393, NULL, NULL, 234787),
(283368, '4mlgG00', NULL, NULL, 324, NULL, NULL, 234787),
(283369, '3wpuA01', NULL, NULL, 487, NULL, NULL, 234787),
(283370, '4o8oA00', NULL, NULL, 303, NULL, NULL, 234787),
(283371, '5z5dA01', NULL, NULL, 305, NULL, NULL, 234787),
(283372, '3om4A01', NULL, NULL, 449, NULL, NULL, 234787),
(283373, '2xdqB03', NULL, NULL, 84, NULL, NULL, 234788),
(283374, '3aekB03', NULL, NULL, 72, NULL, NULL, 234788),
(283375, '4jioB02', NULL, NULL, 154, NULL, NULL, 234789),
(283376, '2xs1A03', NULL, NULL, 189, NULL, NULL, 234789),
(283377, '3mtuB00', NULL, NULL, 75, NULL, NULL, 234790),
(283378, '5jv3C00', NULL, NULL, 76, NULL, NULL, 234790),
(283379, '1txqB00', NULL, NULL, 86, NULL, NULL, 234790),
(283380, '1wu9B00', NULL, NULL, 80, NULL, NULL, 234790),
(283381, '3tq7B00', NULL, NULL, 82, NULL, NULL, 234790);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(283382, '1wu9A00', NULL, NULL, 61, NULL, NULL, 234790),
(283383, '4e61B00', NULL, NULL, 106, NULL, NULL, 234790),
(283384, '5jvrA00', NULL, NULL, 75, NULL, NULL, 234790),
(283385, '3dktA02', NULL, NULL, 96, NULL, NULL, 234791),
(283386, '2pk8A00', NULL, NULL, 103, NULL, NULL, 234791),
(283387, '1ohgA02', NULL, NULL, 107, NULL, NULL, 234791),
(283388, '2e0zA03', NULL, NULL, 104, NULL, NULL, 234791),
(283389, '2lr4A00', NULL, NULL, 128, NULL, NULL, 234792),
(283390, '4ii1A01', NULL, NULL, 86, NULL, NULL, 234793),
(283391, '3ce2A01', NULL, NULL, 157, NULL, NULL, 234794),
(283392, '2qr4A01', NULL, NULL, 156, NULL, NULL, 234794),
(283393, '2luyA01', NULL, NULL, 58, NULL, NULL, 234795),
(283394, '2x8kA02', NULL, NULL, 22, NULL, NULL, 234796),
(283395, '4fibA02', NULL, NULL, 65, NULL, NULL, 234797),
(283396, '2q7dB01', NULL, NULL, 140, NULL, NULL, 234798),
(283397, '2yqzA02', NULL, NULL, 68, NULL, NULL, 234799),
(283398, '1h5wB03', NULL, NULL, 45, NULL, NULL, 234800),
(283399, '2ojqA01', NULL, NULL, 149, NULL, NULL, 234801),
(283400, '4jioB01', NULL, NULL, 180, NULL, NULL, 234801),
(283401, '2xs1A02', NULL, NULL, 146, NULL, NULL, 234801),
(283402, '3rrsA02', NULL, NULL, 50, NULL, NULL, 234802),
(283403, '3qdeA02', NULL, NULL, 48, NULL, NULL, 234802),
(283404, '3actA02', NULL, NULL, 50, NULL, NULL, 234802),
(283405, '2i15A01', NULL, NULL, 44, NULL, NULL, 234802),
(283406, '1krlB00', NULL, NULL, 50, NULL, NULL, 234803),
(283407, '2wzpR03', NULL, NULL, 80, NULL, NULL, 234804),
(283408, '3n6xA03', NULL, NULL, 61, NULL, NULL, 234805),
(283409, '1xdpA01', NULL, NULL, 105, NULL, NULL, 234806),
(283410, '2o8rB01', NULL, NULL, 126, NULL, NULL, 234806),
(283411, '2df7A02', NULL, NULL, 140, NULL, NULL, 234807),
(283412, '3ideA02', NULL, NULL, 143, NULL, NULL, 234807),
(283413, '2gsyA02', NULL, NULL, 140, NULL, NULL, 234807),
(283414, '3d64A01', NULL, NULL, 304, NULL, NULL, 234808),
(283415, '1li4A01', NULL, NULL, 244, NULL, NULL, 234808),
(283416, '3g1uA01', NULL, NULL, 260, NULL, NULL, 234808),
(283417, '3mtgA01', NULL, NULL, 257, NULL, NULL, 234808),
(283418, '5v96B01', NULL, NULL, 276, NULL, NULL, 234808),
(283419, '3gvpA01', NULL, NULL, 252, NULL, NULL, 234808),
(283420, '5t8kA01', NULL, NULL, 309, NULL, NULL, 234808),
(283421, '3ce6B01', NULL, NULL, 305, NULL, NULL, 234808),
(283422, '3ondA01', NULL, NULL, 299, NULL, NULL, 234808),
(283423, '5axaC01', NULL, NULL, 244, NULL, NULL, 234808),
(283424, '5m67B01', NULL, NULL, 321, NULL, NULL, 234808),
(283425, '3x2fB01', NULL, NULL, 228, NULL, NULL, 234808),
(283426, '1v8bA01', NULL, NULL, 318, NULL, NULL, 234808),
(283427, '3n58A01', NULL, NULL, 306, NULL, NULL, 234808),
(283428, '3h9uC01', NULL, NULL, 248, NULL, NULL, 234808),
(283429, '2ougA00', NULL, NULL, 162, NULL, NULL, 234809),
(283430, '2exuA02', NULL, NULL, 99, NULL, NULL, 234809),
(283431, '3h7hB00', NULL, NULL, 106, NULL, NULL, 234809),
(283432, '3lpeA00', NULL, NULL, 92, NULL, NULL, 234809),
(283433, '3p8bB01', NULL, NULL, 86, NULL, NULL, 234809),
(283434, '2xhcA01', NULL, NULL, 97, NULL, NULL, 234809),
(283435, '5xonW01', NULL, NULL, 108, NULL, NULL, 234809),
(283436, '1m1hA01', NULL, NULL, 104, NULL, NULL, 234809),
(283437, '3ewgA00', NULL, NULL, 91, NULL, NULL, 234809),
(283438, '6c6uN00', NULL, NULL, 117, NULL, NULL, 234809),
(283439, '1nz8A00', NULL, NULL, 119, NULL, NULL, 234809),
(283440, '3jtnB00', NULL, NULL, 91, NULL, NULL, 234810),
(283441, '3jtpA00', NULL, NULL, 98, NULL, NULL, 234810),
(283442, '2vf1A01', NULL, NULL, 24, NULL, NULL, 234811),
(283443, '4n9jA02', NULL, NULL, 108, NULL, NULL, 234812),
(283444, '4g7nA02', NULL, NULL, 103, NULL, NULL, 234812),
(283445, '4nkbB02', NULL, NULL, 100, NULL, NULL, 234812),
(283446, '2y9yA03', NULL, NULL, 33, NULL, NULL, 234813),
(283447, '1ofcX03', NULL, NULL, 33, NULL, NULL, 234813),
(283448, '4dckA02', NULL, NULL, 45, NULL, NULL, 234813),
(283449, '4ovnF02', NULL, NULL, 35, NULL, NULL, 234813),
(283450, '4jpzB02', NULL, NULL, 38, NULL, NULL, 234813),
(283451, '3psfA05', NULL, NULL, 106, NULL, NULL, 234814),
(283452, '3or1A01', NULL, NULL, 64, NULL, NULL, 234815);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(283453, '2xsjA01', NULL, NULL, 64, NULL, NULL, 234815),
(283454, '3mm5A01', NULL, NULL, 62, NULL, NULL, 234815),
(283455, '2v4jA01', NULL, NULL, 64, NULL, NULL, 234815),
(283456, '5mz2I00', NULL, NULL, 139, NULL, NULL, 234816),
(283457, '1ir1S00', NULL, NULL, 123, NULL, NULL, 234816),
(283458, '1svdM00', NULL, NULL, 110, NULL, NULL, 234816),
(283459, '3rubS00', NULL, NULL, 123, NULL, NULL, 234816),
(283460, '5iu0I00', NULL, NULL, 126, NULL, NULL, 234816),
(283461, '5nv3I00', NULL, NULL, 129, NULL, NULL, 234816),
(283462, '8rucI00', NULL, NULL, 123, NULL, NULL, 234816),
(283463, '5wskE00', NULL, NULL, 128, NULL, NULL, 234816),
(283464, '2ybvB00', NULL, NULL, 118, NULL, NULL, 234816),
(283465, '1uzdC00', NULL, NULL, 134, NULL, NULL, 234816),
(283466, '5oyaI00', NULL, NULL, 139, NULL, NULL, 234816),
(283467, '1rblI00', NULL, NULL, 109, NULL, NULL, 234816),
(283468, '1uzhC00', NULL, NULL, 122, NULL, NULL, 234816),
(283469, '4mkvS00', NULL, NULL, 123, NULL, NULL, 234816),
(283470, '6ftlI00', NULL, NULL, 139, NULL, NULL, 234816),
(283471, '1bwvS00', NULL, NULL, 138, NULL, NULL, 234816),
(283472, '5n9zI00', NULL, NULL, 139, NULL, NULL, 234816),
(283473, '1gk8I00', NULL, NULL, 140, NULL, NULL, 234816),
(283474, '1burS00', NULL, NULL, 123, NULL, NULL, 234816),
(283475, '1bxnI00', NULL, NULL, 139, NULL, NULL, 234816),
(283476, '4hhhS00', NULL, NULL, 123, NULL, NULL, 234816),
(283477, '1wddS00', NULL, NULL, 128, NULL, NULL, 234816),
(283478, '4f0hB00', NULL, NULL, 138, NULL, NULL, 234816),
(283479, '4jleA00', NULL, NULL, 150, NULL, NULL, 234817),
(283480, '1q7lB01', NULL, NULL, 81, NULL, NULL, 234818),
(283481, '1kmxA00', NULL, NULL, 55, NULL, NULL, 234819),
(283482, '4deqA02', NULL, NULL, 53, NULL, NULL, 234819),
(283483, '4dzoA02', NULL, NULL, 81, NULL, NULL, 234820),
(283484, '2dvmA01', NULL, NULL, 159, NULL, NULL, 234821),
(283485, '2a9fA01', NULL, NULL, 161, NULL, NULL, 234821),
(283486, '2aw5A01', NULL, NULL, 253, NULL, NULL, 234821),
(283487, '1o0sA03', NULL, NULL, 221, NULL, NULL, 234821),
(283488, '3nv9A01', NULL, NULL, 192, NULL, NULL, 234821),
(283489, '1qr6A01', NULL, NULL, 255, NULL, NULL, 234821),
(283490, '1vl6A01', NULL, NULL, 165, NULL, NULL, 234821),
(283491, '5ceeA01', NULL, NULL, 155, NULL, NULL, 234821),
(283492, '1gq2A01', NULL, NULL, 255, NULL, NULL, 234821),
(283493, '2cv8B01', NULL, NULL, 85, NULL, NULL, 234822),
(283494, '2zyzB01', NULL, NULL, 88, NULL, NULL, 234822),
(283495, '1r0vA02', NULL, NULL, 75, NULL, NULL, 234822),
(283496, '3ajvA01', NULL, NULL, 78, NULL, NULL, 234822),
(283497, '1a79A02', NULL, NULL, 71, NULL, NULL, 234822),
(283498, '3p1yA02', NULL, NULL, 85, NULL, NULL, 234822),
(283499, '4fz2A01', NULL, NULL, 76, NULL, NULL, 234822),
(283500, '3ajvD01', NULL, NULL, 93, NULL, NULL, 234822),
(283501, '4fdwA01', NULL, NULL, 79, NULL, NULL, 234823),
(283502, '4fd0A01', NULL, NULL, 79, NULL, NULL, 234823),
(283503, '4fz4A00', NULL, NULL, 154, NULL, NULL, 234824),
(283504, '3onrJ00', NULL, NULL, 72, NULL, NULL, 234825),
(283505, '4evuB00', NULL, NULL, 72, NULL, NULL, 234825),
(283506, '2jnaA01', NULL, NULL, 69, NULL, NULL, 234825),
(283507, '2nocA01', NULL, NULL, 71, NULL, NULL, 234825),
(283508, '2m2jA00', NULL, NULL, 71, NULL, NULL, 234825),
(283509, '6r1eA00', NULL, NULL, 71, NULL, NULL, 234825),
(283510, '2ux9C00', NULL, NULL, 69, NULL, NULL, 234825),
(283511, '2yizA00', NULL, NULL, 69, NULL, NULL, 234825),
(283512, '2cc6A00', NULL, NULL, 68, NULL, NULL, 234825),
(283513, '2vxaA00', NULL, NULL, 72, NULL, NULL, 234825),
(283514, '4eziA02', NULL, NULL, 93, NULL, NULL, 234826),
(283515, '2xubA05', NULL, NULL, 106, NULL, NULL, 234827),
(283516, '3eyrB00', NULL, NULL, 178, NULL, NULL, 234828),
(283517, '3l6iA00', NULL, NULL, 181, NULL, NULL, 234828),
(283518, '3c4aA02', NULL, NULL, 148, NULL, NULL, 234829),
(283519, '3jamI03', NULL, NULL, 58, NULL, NULL, 234830),
(283520, '6faiI03', NULL, NULL, 57, NULL, NULL, 234830),
(283521, '6g5iI03', NULL, NULL, 63, NULL, NULL, 234830),
(283522, '2xzm203', NULL, NULL, 56, NULL, NULL, 234830),
(283523, '5xxuI03', NULL, NULL, 60, NULL, NULL, 234830);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(283524, '3nr7A00', NULL, NULL, 86, NULL, NULL, 234831),
(283525, '1ov9B00', NULL, NULL, 50, NULL, NULL, 234831),
(283526, '4icgA00', NULL, NULL, 46, NULL, NULL, 234831),
(283527, '1ni8A00', NULL, NULL, 46, NULL, NULL, 234831),
(283528, '1lr1A00', NULL, NULL, 61, NULL, NULL, 234831),
(283529, '1w98B02', NULL, NULL, 114, NULL, NULL, 234832),
(283530, '4yozA01', NULL, NULL, 181, NULL, NULL, 234832),
(283531, '1w98B01', NULL, NULL, 153, NULL, NULL, 234832),
(283532, '2r7gA01', NULL, NULL, 184, NULL, NULL, 234832),
(283533, '3k7aM01', NULL, NULL, 116, NULL, NULL, 234832),
(283534, '2r7gA02', NULL, NULL, 163, NULL, NULL, 234832),
(283535, '3g33B01', NULL, NULL, 119, NULL, NULL, 234832),
(283536, '2f2cA01', NULL, NULL, 112, NULL, NULL, 234832),
(283537, '3o0gD00', NULL, NULL, 149, NULL, NULL, 234832),
(283538, '2f2cA02', NULL, NULL, 106, NULL, NULL, 234832),
(283539, '1f5qB01', NULL, NULL, 109, NULL, NULL, 234832),
(283540, '1f5qB02', NULL, NULL, 143, NULL, NULL, 234832),
(283541, '4eojB02', NULL, NULL, 113, NULL, NULL, 234832),
(283542, '3ddqB01', NULL, NULL, 146, NULL, NULL, 234832),
(283543, '4eojD01', NULL, NULL, 139, NULL, NULL, 234832),
(283544, '1jkwA02', NULL, NULL, 101, NULL, NULL, 234832),
(283545, '3qhwB01', NULL, NULL, 139, NULL, NULL, 234832),
(283546, '1guxB00', NULL, NULL, 152, NULL, NULL, 234832),
(283547, '1c9bA01', NULL, NULL, 97, NULL, NULL, 234832),
(283548, '3g33B02', NULL, NULL, 113, NULL, NULL, 234832),
(283549, '1c9bA02', NULL, NULL, 106, NULL, NULL, 234832),
(283550, '1aisB01', NULL, NULL, 106, NULL, NULL, 234832),
(283551, '5xs2B01', NULL, NULL, 131, NULL, NULL, 234832),
(283552, '1aisB02', NULL, NULL, 94, NULL, NULL, 234832),
(283553, '3h4cA01', NULL, NULL, 104, NULL, NULL, 234832),
(283554, '5xs2B02', NULL, NULL, 132, NULL, NULL, 234832),
(283555, '3m03B00', NULL, NULL, 95, NULL, NULL, 234832),
(283556, '3pomB02', NULL, NULL, 165, NULL, NULL, 234832),
(283557, '1g3nC02', NULL, NULL, 113, NULL, NULL, 234832),
(283558, '2w96A02', NULL, NULL, 113, NULL, NULL, 234832),
(283559, '2w96A01', NULL, NULL, 158, NULL, NULL, 234832),
(283560, '1g3nC01', NULL, NULL, 144, NULL, NULL, 234832),
(283561, '4rocA01', NULL, NULL, 108, NULL, NULL, 234832),
(283562, '2i53A02', NULL, NULL, 111, NULL, NULL, 234832),
(283563, '6gu2B01', NULL, NULL, 149, NULL, NULL, 234832),
(283564, '2i53A01', NULL, NULL, 147, NULL, NULL, 234832),
(283565, '6gu2B02', NULL, NULL, 112, NULL, NULL, 234832),
(283566, '2pmiB00', NULL, NULL, 231, NULL, NULL, 234832),
(283567, '2ivxB01', NULL, NULL, 142, NULL, NULL, 234832),
(283568, '2ivxB02', NULL, NULL, 115, NULL, NULL, 234832),
(283569, '1kxuA01', NULL, NULL, 175, NULL, NULL, 234832),
(283570, '4yosA02', NULL, NULL, 188, NULL, NULL, 234832),
(283571, '1zp2A01', NULL, NULL, 123, NULL, NULL, 234832),
(283572, '4krdB00', NULL, NULL, 191, NULL, NULL, 234832),
(283573, '3mi9B01', NULL, NULL, 149, NULL, NULL, 234832),
(283574, '1zp2A02', NULL, NULL, 112, NULL, NULL, 234832),
(283575, '3mi9B02', NULL, NULL, 117, NULL, NULL, 234832),
(283576, '5iybM01', NULL, NULL, 98, NULL, NULL, 234832),
(283577, '1xu6A00', NULL, NULL, 80, NULL, NULL, 234833),
(283578, '3c5xA01', NULL, NULL, 144, NULL, NULL, 234834),
(283579, '2alaA01', NULL, NULL, 124, NULL, NULL, 234834),
(283580, '3p54A01', NULL, NULL, 140, NULL, NULL, 234834),
(283581, '5o6aA01', NULL, NULL, 135, NULL, NULL, 234834),
(283582, '1uzgA01', NULL, NULL, 136, NULL, NULL, 234834),
(283583, '1svbA01', NULL, NULL, 136, NULL, NULL, 234834),
(283584, '5jhmA01', NULL, NULL, 145, NULL, NULL, 234834),
(283585, '2hg0A01', NULL, NULL, 141, NULL, NULL, 234834),
(283586, '4fg0A01', NULL, NULL, 134, NULL, NULL, 234834),
(283587, '3n40F01', NULL, NULL, 128, NULL, NULL, 234834),
(283588, '4gsxA01', NULL, NULL, 128, NULL, NULL, 234834),
(283589, '6a0pA01', NULL, NULL, 141, NULL, NULL, 234834),
(283590, '3j27A01', NULL, NULL, 135, NULL, NULL, 234834),
(283591, '3uc0B00', NULL, NULL, 125, NULL, NULL, 234834),
(283592, '6ivzA01', NULL, NULL, 127, NULL, NULL, 234834),
(283593, '2p35A02', NULL, NULL, 70, NULL, NULL, 234835),
(283594, '1g8kC01', NULL, NULL, 119, NULL, NULL, 234836); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(283595, '2nwtA00', NULL, NULL, 69, NULL, NULL, 234837),
(283596, '2m4hA00', NULL, NULL, 71, NULL, NULL, 234838),
(283597, '2mxdA00', NULL, NULL, 62, NULL, NULL, 234838),
(283598, '3lxqA01', NULL, NULL, 101, NULL, NULL, 234839),
(283599, '3lxqB01', NULL, NULL, 101, NULL, NULL, 234839),
(283600, '3r9mA00', NULL, NULL, 376, NULL, NULL, 234840),
(283601, '5mk2B00', NULL, NULL, 361, NULL, NULL, 234840),
(283602, '1zb1A00', NULL, NULL, 372, NULL, NULL, 234840),
(283603, '5wa1A00', NULL, NULL, 358, NULL, NULL, 234840),
(283604, '3jszA01', NULL, NULL, 112, NULL, NULL, 234841),
(283605, '2wzfA01', NULL, NULL, 112, NULL, NULL, 234841),
(283606, '2i8dA01', NULL, NULL, 83, NULL, NULL, 234842),
(283607, '2kl4A00', NULL, NULL, 118, NULL, NULL, 234842),
(283608, '2i8dB01', NULL, NULL, 83, NULL, NULL, 234842),
(283609, '2oc6A01', NULL, NULL, 116, NULL, NULL, 234842),
(283610, '1vbkA01', NULL, NULL, 83, NULL, NULL, 234843),
(283611, '4ch7A02', NULL, NULL, 191, NULL, NULL, 234844),
(283612, '3h20A01', NULL, NULL, 70, NULL, NULL, 234845),
(283613, '4f0aB02', NULL, NULL, 68, NULL, NULL, 234846),
(283614, '2oa5A01', NULL, NULL, 91, NULL, NULL, 234847),
(283615, '2qtiA00', NULL, NULL, 80, NULL, NULL, 234847),
(283616, '2jrxA00', NULL, NULL, 83, NULL, NULL, 234847),
(283617, '2otaA00', NULL, NULL, 76, NULL, NULL, 234847),
(283618, '2juzA00', NULL, NULL, 80, NULL, NULL, 234847),
(283619, '2jpqA00', NULL, NULL, 83, NULL, NULL, 234847),
(283620, '2lzlA00', NULL, NULL, 43, NULL, NULL, 234848),
(283621, '3s32A00', NULL, NULL, 175, NULL, NULL, 234849),
(283622, '3rsnA00', NULL, NULL, 177, NULL, NULL, 234849),
(283623, '2o70B00', NULL, NULL, 174, NULL, NULL, 234850),
(283624, '2o8iA00', NULL, NULL, 165, NULL, NULL, 234850),
(283625, '3o7iA00', NULL, NULL, 166, NULL, NULL, 234850),
(283626, '2q37A00', NULL, NULL, 156, NULL, NULL, 234850),
(283627, '2e0zA01', NULL, NULL, 107, NULL, NULL, 234851),
(283628, '4mloA02', NULL, NULL, 47, NULL, NULL, 234852),
(283629, '2kxsA00', NULL, NULL, 146, NULL, NULL, 234853),
(283630, '3ud1A02', NULL, NULL, 168, NULL, NULL, 234853),
(283631, '4d8oA01', NULL, NULL, 161, NULL, NULL, 234853),
(283632, '3f59D00', NULL, NULL, 161, NULL, NULL, 234853),
(283633, '4d8oA02', NULL, NULL, 154, NULL, NULL, 234853),
(283634, '1x3zA03', NULL, NULL, 88, NULL, NULL, 234854),
(283635, '3isrA02', NULL, NULL, 100, NULL, NULL, 234855),
(283636, '2debA01', NULL, NULL, 49, NULL, NULL, 234856),
(283637, '5xogE01', NULL, NULL, 141, NULL, NULL, 234857),
(283638, '3h0gE01', NULL, NULL, 137, NULL, NULL, 234857),
(283639, '6gmhE01', NULL, NULL, 137, NULL, NULL, 234857),
(283640, '1dzfA01', NULL, NULL, 142, NULL, NULL, 234857),
(283641, '4g08A01', NULL, NULL, 84, NULL, NULL, 234858),
(283642, '2m5jA00', NULL, NULL, 107, NULL, NULL, 234858),
(283643, '1zzvA01', NULL, NULL, 73, NULL, NULL, 234858),
(283644, '4m0nA02', NULL, NULL, 78, NULL, NULL, 234858),
(283645, '4jtmA00', NULL, NULL, 81, NULL, NULL, 234858),
(283646, '2a02A01', NULL, NULL, 75, NULL, NULL, 234858),
(283647, '3ezjG01', NULL, NULL, 103, NULL, NULL, 234858),
(283648, '3gr5A01', NULL, NULL, 88, NULL, NULL, 234858),
(283649, '2w16B01', NULL, NULL, 93, NULL, NULL, 234858),
(283650, '4l6hA01', NULL, NULL, 413, NULL, NULL, 234859),
(283651, '1j93A00', NULL, NULL, 353, NULL, NULL, 234859),
(283652, '4l6hA02', NULL, NULL, 354, NULL, NULL, 234859),
(283653, '4zr8B00', NULL, NULL, 365, NULL, NULL, 234859),
(283654, '2ejaA00', NULL, NULL, 338, NULL, NULL, 234859),
(283655, '3bq5A01', NULL, NULL, 374, NULL, NULL, 234859),
(283656, '3rpdA00', NULL, NULL, 357, NULL, NULL, 234859),
(283657, '4wshA00', NULL, NULL, 363, NULL, NULL, 234859),
(283658, '2infA00', NULL, NULL, 359, NULL, NULL, 234859),
(283659, '4ztyA02', NULL, NULL, 361, NULL, NULL, 234859),
(283660, '1t7lA02', NULL, NULL, 356, NULL, NULL, 234859),
(283661, '3cyvA00', NULL, NULL, 354, NULL, NULL, 234859),
(283662, '1u1jA01', NULL, NULL, 404, NULL, NULL, 234859),
(283663, '4ztyA01', NULL, NULL, 408, NULL, NULL, 234859),
(283664, '1u1jA02', NULL, NULL, 361, NULL, NULL, 234859),
(283665, '4ay7A00', NULL, NULL, 348, NULL, NULL, 234859);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(283666, '4exqA00', NULL, NULL, 368, NULL, NULL, 234859),
(283667, '1ypxA00', NULL, NULL, 375, NULL, NULL, 234859),
(283668, '2nq5A01', NULL, NULL, 394, NULL, NULL, 234859),
(283669, '1r3sA00', NULL, NULL, 367, NULL, NULL, 234859),
(283670, '2nq5A02', NULL, NULL, 361, NULL, NULL, 234859),
(283671, '2b3yA04', NULL, NULL, 62, NULL, NULL, 234860),
(283672, '1ehsA00', NULL, NULL, 48, NULL, NULL, 234861),
(283673, '2wmmA02', NULL, NULL, 113, NULL, NULL, 234862),
(283674, '3al5A02', NULL, NULL, 52, NULL, NULL, 234863),
(283675, '2dulA02', NULL, NULL, 60, NULL, NULL, 234864),
(283676, '3axsA02', NULL, NULL, 70, NULL, NULL, 234864),
(283677, '6g3xA01', NULL, NULL, 93, NULL, NULL, 234865),
(283678, '1m3qA01', NULL, NULL, 92, NULL, NULL, 234865),
(283679, '2xhiA01', NULL, NULL, 91, NULL, NULL, 234865),
(283680, '1fftB01', NULL, NULL, 87, NULL, NULL, 234866),
(283681, '5b1aB01', NULL, NULL, 91, NULL, NULL, 234866),
(283682, '2gsmB01', NULL, NULL, 96, NULL, NULL, 234866),
(283683, '5z62B01', NULL, NULL, 91, NULL, NULL, 234866),
(283684, '6giqb01', NULL, NULL, 111, NULL, NULL, 234866),
(283685, '2yevB01', NULL, NULL, 93, NULL, NULL, 234866),
(283686, '3hb3B02', NULL, NULL, 81, NULL, NULL, 234866),
(283687, '2byoA00', NULL, NULL, 188, NULL, NULL, 234867),
(283688, '4qa8A00', NULL, NULL, 210, NULL, NULL, 234867),
(283689, '4zraA00', NULL, NULL, 203, NULL, NULL, 234867),
(283690, '5ys2A02', NULL, NULL, 107, NULL, NULL, 234868),
(283691, '2gumB01', NULL, NULL, 106, NULL, NULL, 234868),
(283692, '3fvcA01', NULL, NULL, 99, NULL, NULL, 234868),
(283693, '6escA01', NULL, NULL, 107, NULL, NULL, 234868),
(283694, '5jf0A00', NULL, NULL, 204, NULL, NULL, 234869),
(283695, '4e9aA00', NULL, NULL, 163, NULL, NULL, 234869),
(283696, '1lmhA00', NULL, NULL, 184, NULL, NULL, 234869),
(283697, '4dr8D00', NULL, NULL, 192, NULL, NULL, 234869),
(283698, '5j46A00', NULL, NULL, 169, NULL, NULL, 234869),
(283699, '1xeoA00', NULL, NULL, 168, NULL, NULL, 234869),
(283700, '2os3A00', NULL, NULL, 205, NULL, NULL, 234869),
(283701, '3uwbA00', NULL, NULL, 154, NULL, NULL, 234869),
(283702, '1ws0A00', NULL, NULL, 156, NULL, NULL, 234869),
(283703, '1lqyA00', NULL, NULL, 184, NULL, NULL, 234869),
(283704, '1y6hA00', NULL, NULL, 177, NULL, NULL, 234869),
(283705, '2oklB00', NULL, NULL, 185, NULL, NULL, 234869),
(283706, '6cazA00', NULL, NULL, 178, NULL, NULL, 234869),
(283707, '3u04A00', NULL, NULL, 190, NULL, NULL, 234869),
(283708, '5hgwA00', NULL, NULL, 185, NULL, NULL, 234869),
(283709, '1rl4B00', NULL, NULL, 188, NULL, NULL, 234869),
(283710, '5mteA00', NULL, NULL, 137, NULL, NULL, 234869),
(283711, '1lmeA00', NULL, NULL, 157, NULL, NULL, 234869),
(283712, '1v3yA00', NULL, NULL, 192, NULL, NULL, 234869),
(283713, '5cp0A00', NULL, NULL, 171, NULL, NULL, 234869),
(283714, '3g5kA00', NULL, NULL, 183, NULL, NULL, 234869),
(283715, '2os0A00', NULL, NULL, 188, NULL, NULL, 234869),
(283716, '4wxkC00', NULL, NULL, 169, NULL, NULL, 234869),
(283717, '1n5nA00', NULL, NULL, 180, NULL, NULL, 234869),
(283718, '3l87A00', NULL, NULL, 204, NULL, NULL, 234869),
(283719, '3e3uA00', NULL, NULL, 197, NULL, NULL, 234869),
(283720, '5kobA00', NULL, NULL, 185, NULL, NULL, 234869),
(283721, '1lm4B00', NULL, NULL, 194, NULL, NULL, 234869),
(283722, '4je6B00', NULL, NULL, 197, NULL, NULL, 234869),
(283723, '3svjP00', NULL, NULL, 203, NULL, NULL, 234869),
(283724, '3g6nA00', NULL, NULL, 191, NULL, NULL, 234869),
(283725, '3fwxA00', NULL, NULL, 169, NULL, NULL, 234869),
(283726, '3pn3A00', NULL, NULL, 193, NULL, NULL, 234869),
(283727, '3cpmA00', NULL, NULL, 193, NULL, NULL, 234869),
(283728, '3qu1A00', NULL, NULL, 171, NULL, NULL, 234869),
(283729, '3lm6B00', NULL, NULL, 346, NULL, NULL, 234870),
(283730, '3lmaB00', NULL, NULL, 347, NULL, NULL, 234870),
(283731, '3rfrA02', NULL, NULL, 97, NULL, NULL, 234871),
(283732, '4phzA02', NULL, NULL, 97, NULL, NULL, 234871),
(283733, '1yewA02', NULL, NULL, 97, NULL, NULL, 234871),
(283734, '6cxhA02', NULL, NULL, 97, NULL, NULL, 234871),
(283735, '3chxA02', NULL, NULL, 97, NULL, NULL, 234871),
(283736, '1v9mA01', NULL, NULL, 119, NULL, NULL, 234872);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(283737, '3frrA00', NULL, NULL, 191, NULL, NULL, 234873),
(283738, '3ggyA00', NULL, NULL, 193, NULL, NULL, 234873),
(283739, '2p1aB01', NULL, NULL, 146, NULL, NULL, 234874),
(283740, '1rxqD00', NULL, NULL, 178, NULL, NULL, 234874),
(283741, '2qe9B01', NULL, NULL, 166, NULL, NULL, 234874),
(283742, '2oqmB01', NULL, NULL, 183, NULL, NULL, 234874),
(283743, '3di5A00', NULL, NULL, 151, NULL, NULL, 234874),
(283744, '2ou6A00', NULL, NULL, 190, NULL, NULL, 234874),
(283745, '3cexA00', NULL, NULL, 172, NULL, NULL, 234874),
(283746, '2hkvA01', NULL, NULL, 141, NULL, NULL, 234874),
(283747, '2yqyA00', NULL, NULL, 138, NULL, NULL, 234874),
(283748, '2rd9B01', NULL, NULL, 181, NULL, NULL, 234874),
(283749, '2f22A00', NULL, NULL, 144, NULL, NULL, 234874),
(283750, '5cofA00', NULL, NULL, 173, NULL, NULL, 234874),
(283751, '3gorA01', NULL, NULL, 147, NULL, NULL, 234874),
(283752, '4n6cB00', NULL, NULL, 183, NULL, NULL, 234874),
(283753, '3gorC01', NULL, NULL, 147, NULL, NULL, 234874),
(283754, '3gorB01', NULL, NULL, 147, NULL, NULL, 234874),
(283755, '3gorD01', NULL, NULL, 147, NULL, NULL, 234874),
(283756, '2nsfA01', NULL, NULL, 159, NULL, NULL, 234874),
(283757, '3e4xD01', NULL, NULL, 147, NULL, NULL, 234874),
(283758, '3e4xC01', NULL, NULL, 147, NULL, NULL, 234874),
(283759, '5cqvA01', NULL, NULL, 150, NULL, NULL, 234874),
(283760, '3e4xB01', NULL, NULL, 147, NULL, NULL, 234874),
(283761, '3e4xA01', NULL, NULL, 147, NULL, NULL, 234874),
(283762, '6anrA00', NULL, NULL, 178, NULL, NULL, 234874),
(283763, '2qnlA00', NULL, NULL, 162, NULL, NULL, 234874),
(283764, '3dkaB01', NULL, NULL, 145, NULL, NULL, 234874),
(283765, '3qthB00', NULL, NULL, 176, NULL, NULL, 234874),
(283766, '5comA00', NULL, NULL, 183, NULL, NULL, 234874),
(283767, '5cogA00', NULL, NULL, 191, NULL, NULL, 234874),
(283768, '5civA00', NULL, NULL, 184, NULL, NULL, 234874),
(283769, '1v4aA01', NULL, NULL, 110, NULL, NULL, 234875),
(283770, '4fe9A04', NULL, NULL, 102, NULL, NULL, 234876),
(283771, '4fchA02', NULL, NULL, 104, NULL, NULL, 234876),
(283772, '2x53S02', NULL, NULL, 163, NULL, NULL, 234877),
(283773, '2wzpP03', NULL, NULL, 127, NULL, NULL, 234877),
(283774, '1u07B00', NULL, NULL, 90, NULL, NULL, 234878),
(283775, '2gskB00', NULL, NULL, 81, NULL, NULL, 234878),
(283776, '1srqD01', NULL, NULL, 109, NULL, NULL, 234879),
(283777, '4iglD00', NULL, NULL, 690, NULL, NULL, 234880),
(283778, '5kisB00', NULL, NULL, 689, NULL, NULL, 234880),
(283779, '3cvzC01', NULL, NULL, 106, NULL, NULL, 234881),
(283780, '2l0fB01', NULL, NULL, 42, NULL, NULL, 234882),
(283781, '2btzA01', NULL, NULL, 173, NULL, NULL, 234883),
(283782, '2q8gA01', NULL, NULL, 185, NULL, NULL, 234883),
(283783, '1y8oA01', NULL, NULL, 160, NULL, NULL, 234883),
(283784, '5j71A01', NULL, NULL, 169, NULL, NULL, 234883),
(283785, '4e01A01', NULL, NULL, 154, NULL, NULL, 234883),
(283786, '2e0aA01', NULL, NULL, 172, NULL, NULL, 234883),
(283787, '3g2bA00', NULL, NULL, 95, NULL, NULL, 234884),
(283788, '2xmxA01', NULL, NULL, 141, NULL, NULL, 234885),
(283789, '4g75A01', NULL, NULL, 158, NULL, NULL, 234885),
(283790, '1i6uA01', NULL, NULL, 69, NULL, NULL, 234886),
(283791, '6faiW01', NULL, NULL, 69, NULL, NULL, 234886),
(283792, '5mmjh01', NULL, NULL, 76, NULL, NULL, 234886),
(283793, '5o5jH01', NULL, NULL, 74, NULL, NULL, 234886),
(283794, '2vqeH01', NULL, NULL, 78, NULL, NULL, 234886),
(283795, '6az1J01', NULL, NULL, 69, NULL, NULL, 234886),
(283796, '1i94H01', NULL, NULL, 78, NULL, NULL, 234886),
(283797, '5xyiW01', NULL, NULL, 69, NULL, NULL, 234886),
(283798, '1s03H01', NULL, NULL, 71, NULL, NULL, 234886),
(283799, '1seiA01', NULL, NULL, 72, NULL, NULL, 234886),
(283800, '2xzmH01', NULL, NULL, 69, NULL, NULL, 234886),
(283801, '3j7aK01', NULL, NULL, 69, NULL, NULL, 234886),
(283802, '4pdbA01', NULL, NULL, 71, NULL, NULL, 234886),
(283803, '5xxuW01', NULL, NULL, 69, NULL, NULL, 234886),
(283804, '6g5iW01', NULL, NULL, 69, NULL, NULL, 234886),
(283805, '1c89A02', NULL, NULL, 64, NULL, NULL, 234887),
(283806, '5xqvA00', NULL, NULL, 67, NULL, NULL, 234887),
(283807, '3ameA00', NULL, NULL, 66, NULL, NULL, 234887);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(283808, '2wqpA02', NULL, NULL, 73, NULL, NULL, 234887),
(283809, '1ucsA00', NULL, NULL, 64, NULL, NULL, 234887),
(283810, '1vliA02', NULL, NULL, 70, NULL, NULL, 234887),
(283811, '4ny6A00', NULL, NULL, 65, NULL, NULL, 234887),
(283812, '3frnA02', NULL, NULL, 68, NULL, NULL, 234887),
(283813, '4ur4A00', NULL, NULL, 67, NULL, NULL, 234887),
(283814, '1wvoA00', NULL, NULL, 79, NULL, NULL, 234887),
(283815, '2lx2A00', NULL, NULL, 67, NULL, NULL, 234887),
(283816, '1msiA00', NULL, NULL, 70, NULL, NULL, 234887),
(283817, '1opsA00', NULL, NULL, 64, NULL, NULL, 234887),
(283818, '3qf6A00', NULL, NULL, 66, NULL, NULL, 234887),
(283819, '3g8rB02', NULL, NULL, 90, NULL, NULL, 234887),
(283820, '1vx7700', NULL, NULL, 120, NULL, NULL, 234888),
(283821, '4a17W00', NULL, NULL, 111, NULL, NULL, 234888),
(283822, '1vq8X00', NULL, NULL, 92, NULL, NULL, 234888),
(283823, '1vwxd00', NULL, NULL, 108, NULL, NULL, 234888),
(283824, '3u5ed00', NULL, NULL, 113, NULL, NULL, 234888),
(283825, '3o58a00', NULL, NULL, 88, NULL, NULL, 234888),
(283826, '4p78A00', NULL, NULL, 86, NULL, NULL, 234889),
(283827, '2dsyD00', NULL, NULL, 87, NULL, NULL, 234889),
(283828, '3kwrB00', NULL, NULL, 97, NULL, NULL, 234889),
(283829, '2yztA00', NULL, NULL, 67, NULL, NULL, 234889),
(283830, '2mjfA00', NULL, NULL, 40, NULL, NULL, 234890),
(283831, '2iruA02', NULL, NULL, 138, NULL, NULL, 234891),
(283832, '1wvkA00', NULL, NULL, 86, NULL, NULL, 234892),
(283833, '2egtA01', NULL, NULL, 27, NULL, NULL, 234893),
(283834, '4kncA02', NULL, NULL, 118, NULL, NULL, 234894),
(283835, '2z4iB02', NULL, NULL, 90, NULL, NULL, 234895),
(283836, '2a2fX01', NULL, NULL, 180, NULL, NULL, 234896),
(283837, '3lsoA01', NULL, NULL, 168, NULL, NULL, 234897),
(283838, '2dnfA01', NULL, NULL, 89, NULL, NULL, 234898),
(283839, '5ip4E00', NULL, NULL, 91, NULL, NULL, 234898),
(283840, '5io9A00', NULL, NULL, 106, NULL, NULL, 234898),
(283841, '1mg4A00', NULL, NULL, 113, NULL, NULL, 234898),
(283842, '2bqqA00', NULL, NULL, 113, NULL, NULL, 234898),
(283843, '1uf0A00', NULL, NULL, 116, NULL, NULL, 234898),
(283844, '1f0lB02', NULL, NULL, 179, NULL, NULL, 234899),
(283845, '4r2kA00', NULL, NULL, 329, NULL, NULL, 234900),
(283846, '3cisH00', NULL, NULL, 292, NULL, NULL, 234900),
(283847, '3mt0A00', NULL, NULL, 290, NULL, NULL, 234900),
(283848, '3olqA00', NULL, NULL, 319, NULL, NULL, 234900),
(283849, '3ab8A00', NULL, NULL, 268, NULL, NULL, 234900),
(283850, '4jdmA01', NULL, NULL, 51, NULL, NULL, 234901),
(283851, '3fkjA02', NULL, NULL, 64, NULL, NULL, 234902),
(283852, '3euaA02', NULL, NULL, 64, NULL, NULL, 234902),
(283853, '3vvmA02', NULL, NULL, 108, NULL, NULL, 234903),
(283854, '2b61A02', NULL, NULL, 104, NULL, NULL, 234903),
(283855, '2pl5A02', NULL, NULL, 101, NULL, NULL, 234903),
(283856, '2ex3B02', NULL, NULL, 95, NULL, NULL, 234904),
(283857, '4l8nA03', NULL, NULL, 168, NULL, NULL, 234905),
(283858, '4f54A00', NULL, NULL, 197, NULL, NULL, 234905),
(283859, '2l5yA01', NULL, NULL, 75, NULL, NULL, 234906),
(283860, '2k60A01', NULL, NULL, 73, NULL, NULL, 234906),
(283861, '3evyA00', NULL, NULL, 92, NULL, NULL, 234907),
(283862, '2d46A00', NULL, NULL, 61, NULL, NULL, 234908),
(283863, '3bp8C00', NULL, NULL, 75, NULL, NULL, 234909),
(283864, '3ipjA01', NULL, NULL, 80, NULL, NULL, 234909),
(283865, '3bp3A00', NULL, NULL, 82, NULL, NULL, 234909),
(283866, '2r31A02', NULL, NULL, 171, NULL, NULL, 234910),
(283867, '2r6iA02', NULL, NULL, 174, NULL, NULL, 234910),
(283868, '2v3cC01', NULL, NULL, 113, NULL, NULL, 234911),
(283869, '4ak9B01', NULL, NULL, 107, NULL, NULL, 234911),
(283870, '2q9bB01', NULL, NULL, 92, NULL, NULL, 234911),
(283871, '2j7pD01', NULL, NULL, 75, NULL, NULL, 234911),
(283872, '2v3cD01', NULL, NULL, 88, NULL, NULL, 234911),
(283873, '1ls1A01', NULL, NULL, 89, NULL, NULL, 234911),
(283874, '1j8mF01', NULL, NULL, 89, NULL, NULL, 234911),
(283875, '2iylD01', NULL, NULL, 68, NULL, NULL, 234911),
(283876, '3b9qA01', NULL, NULL, 91, NULL, NULL, 234911),
(283877, '3e70C01', NULL, NULL, 108, NULL, NULL, 234911),
(283878, '2qy9A01', NULL, NULL, 90, NULL, NULL, 234911); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(283879, '1wgwA00', NULL, NULL, 99, NULL, NULL, 234911),
(283880, '4c7oD01', NULL, NULL, 64, NULL, NULL, 234911),
(283881, '3dm5A01', NULL, NULL, 115, NULL, NULL, 234911),
(283882, '1vmaA01', NULL, NULL, 95, NULL, NULL, 234911),
(283883, '5l3vB01', NULL, NULL, 93, NULL, NULL, 234911),
(283884, '1zu4A01', NULL, NULL, 96, NULL, NULL, 234911),
(283885, '4c7oA01', NULL, NULL, 90, NULL, NULL, 234911),
(283886, '5l3qA01', NULL, NULL, 67, NULL, NULL, 234911),
(283887, '1rj9A01', NULL, NULL, 82, NULL, NULL, 234911),
(283888, '2ffhA01', NULL, NULL, 114, NULL, NULL, 234911),
(283889, '4njcA00', NULL, NULL, 65, NULL, NULL, 234912),
(283890, '1g71A02', NULL, NULL, 108, NULL, NULL, 234913),
(283891, '1v33A02', NULL, NULL, 103, NULL, NULL, 234913),
(283892, '4jdmC02', NULL, NULL, 39, NULL, NULL, 234914),
(283893, '4cidA01', NULL, NULL, 184, NULL, NULL, 234915),
(283894, '2qptA01', NULL, NULL, 146, NULL, NULL, 234915),
(283895, '5mtvA01', NULL, NULL, 160, NULL, NULL, 234915),
(283896, '4nn5A00', NULL, NULL, 130, NULL, NULL, 234916),
(283897, '5j13A00', NULL, NULL, 127, NULL, NULL, 234916),
(283898, '1tm9A00', NULL, NULL, 137, NULL, NULL, 234917),
(283899, '3mfdA02', NULL, NULL, 92, NULL, NULL, 234918),
(283900, '4xfjA03', NULL, NULL, 39, NULL, NULL, 234919),
(283901, '2nz2A03', NULL, NULL, 41, NULL, NULL, 234919),
(283902, '1vl2B03', NULL, NULL, 30, NULL, NULL, 234919),
(283903, '1korA03', NULL, NULL, 31, NULL, NULL, 234919),
(283904, '1vl2A03', NULL, NULL, 40, NULL, NULL, 234919),
(283905, '1xezA02', NULL, NULL, 428, NULL, NULL, 234920),
(283906, '3w0lC01', NULL, NULL, 280, NULL, NULL, 234921),
(283907, '4qs8A01', NULL, NULL, 295, NULL, NULL, 234921),
(283908, '1bg3A04', NULL, NULL, 254, NULL, NULL, 234921),
(283909, '1bg3A02', NULL, NULL, 261, NULL, NULL, 234921),
(283910, '3vpzA02', NULL, NULL, 200, NULL, NULL, 234921),
(283911, '1hkgA03', NULL, NULL, 270, NULL, NULL, 234921),
(283912, '2yhxA03', NULL, NULL, 270, NULL, NULL, 234921),
(283913, '1czaN02', NULL, NULL, 276, NULL, NULL, 234921),
(283914, '1bdgA01', NULL, NULL, 281, NULL, NULL, 234921),
(283915, '1sz2A02', NULL, NULL, 200, NULL, NULL, 234921),
(283916, '6ediA02', NULL, NULL, 225, NULL, NULL, 234921),
(283917, '3hm8C01', NULL, NULL, 273, NULL, NULL, 234921),
(283918, '2nztA01', NULL, NULL, 262, NULL, NULL, 234921),
(283919, '2nztA03', NULL, NULL, 254, NULL, NULL, 234921),
(283920, '3b8aX03', NULL, NULL, 275, NULL, NULL, 234921),
(283921, '3f9mA01', NULL, NULL, 291, NULL, NULL, 234921),
(283922, '4ixcA01', NULL, NULL, 277, NULL, NULL, 234921),
(283923, '5brhA02', NULL, NULL, 206, NULL, NULL, 234921),
(283924, '3o8mA03', NULL, NULL, 276, NULL, NULL, 234921),
(283925, '1czaN04', NULL, NULL, 252, NULL, NULL, 234921),
(283926, '5zqtA01', NULL, NULL, 294, NULL, NULL, 234921),
(283927, '1ig8A03', NULL, NULL, 276, NULL, NULL, 234921),
(283928, '2vkjA00', NULL, NULL, 106, NULL, NULL, 234922),
(283929, '1vq8P02', NULL, NULL, 33, NULL, NULL, 234923),
(283930, '2aplA01', NULL, NULL, 69, NULL, NULL, 234924),
(283931, '1qhhD01', NULL, NULL, 76, NULL, NULL, 234925),
(283932, '6c6zA02', NULL, NULL, 67, NULL, NULL, 234926),
(283933, '4qzvB02', NULL, NULL, 68, NULL, NULL, 234926),
(283934, '3swhA02', NULL, NULL, 151, NULL, NULL, 234927),
(283935, '2imuA00', NULL, NULL, 46, NULL, NULL, 234928),
(283936, '4xb6F00', NULL, NULL, 194, NULL, NULL, 234929),
(283937, '2xanA01', NULL, NULL, 160, NULL, NULL, 234930),
(283938, '4axcA01', NULL, NULL, 156, NULL, NULL, 234930),
(283939, '1wmiB00', NULL, NULL, 67, NULL, NULL, 234931),
(283940, '1ss6A01', NULL, NULL, 65, NULL, NULL, 234932),
(283941, '2osoA00', NULL, NULL, 163, NULL, NULL, 234933),
(283942, '3kxcA00', NULL, NULL, 165, NULL, NULL, 234933),
(283943, '6aq3A00', NULL, NULL, 172, NULL, NULL, 234933),
(283944, '2j3tB00', NULL, NULL, 159, NULL, NULL, 234933),
(283945, '2bjnB00', NULL, NULL, 160, NULL, NULL, 234933),
(283946, '2j3wF00', NULL, NULL, 167, NULL, NULL, 234933),
(283947, '3njcB00', NULL, NULL, 158, NULL, NULL, 234933),
(283948, '3cueD00', NULL, NULL, 193, NULL, NULL, 234933),
(283949, '2c0jA00', NULL, NULL, 161, NULL, NULL, 234933);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(283950, '3njcA00', NULL, NULL, 158, NULL, NULL, 234933),
(283951, '1sz7A00', NULL, NULL, 159, NULL, NULL, 234933),
(283952, '3cueB00', NULL, NULL, 168, NULL, NULL, 234933),
(283953, '3ixlA00', NULL, NULL, 240, NULL, NULL, 234934),
(283954, '4ix1A00', NULL, NULL, 258, NULL, NULL, 234934),
(283955, '2xedC00', NULL, NULL, 250, NULL, NULL, 234934),
(283956, '4fq5A00', NULL, NULL, 255, NULL, NULL, 234934),
(283957, '5lg5F00', NULL, NULL, 242, NULL, NULL, 234934),
(283958, '3qvlA00', NULL, NULL, 245, NULL, NULL, 234934),
(283959, '4mv7A03', NULL, NULL, 73, NULL, NULL, 234935),
(283960, '4a0tA03', NULL, NULL, 90, NULL, NULL, 234936),
(283961, '4d8oA03', NULL, NULL, 164, NULL, NULL, 234937),
(283962, '3addB02', NULL, NULL, 63, NULL, NULL, 234938),
(283963, '3a4mA02', NULL, NULL, 72, NULL, NULL, 234938),
(283964, '4tx1A00', NULL, NULL, 225, NULL, NULL, 234939),
(283965, '4s1pA00', NULL, NULL, 191, NULL, NULL, 234939),
(283966, '1k7cA00', NULL, NULL, 233, NULL, NULL, 234939),
(283967, '1z8hA00', NULL, NULL, 202, NULL, NULL, 234939),
(283968, '2o14A02', NULL, NULL, 214, NULL, NULL, 234939),
(283969, '3kvnA01', NULL, NULL, 324, NULL, NULL, 234939),
(283970, '5hoeA00', NULL, NULL, 230, NULL, NULL, 234939),
(283971, '4q7qB00', NULL, NULL, 266, NULL, NULL, 234939),
(283972, '2q0sA00', NULL, NULL, 216, NULL, NULL, 234939),
(283973, '1es9A00', NULL, NULL, 216, NULL, NULL, 234939),
(283974, '4lhsA02', NULL, NULL, 189, NULL, NULL, 234939),
(283975, '5b5lA00', NULL, NULL, 207, NULL, NULL, 234939),
(283976, '1yzfA00', NULL, NULL, 195, NULL, NULL, 234939),
(283977, '2hsjD00', NULL, NULL, 214, NULL, NULL, 234939),
(283978, '2waoA02', NULL, NULL, 221, NULL, NULL, 234939),
(283979, '2apjD00', NULL, NULL, 241, NULL, NULL, 234939),
(283980, '4k7jA01', NULL, NULL, 226, NULL, NULL, 234939),
(283981, '4jggA00', NULL, NULL, 186, NULL, NULL, 234939),
(283982, '4hyqA00', NULL, NULL, 236, NULL, NULL, 234939),
(283983, '4devA02', NULL, NULL, 249, NULL, NULL, 234939),
(283984, '4i8iA00', NULL, NULL, 271, NULL, NULL, 234939),
(283985, '3skvA02', NULL, NULL, 201, NULL, NULL, 234939),
(283986, '5malA00', NULL, NULL, 234, NULL, NULL, 234939),
(283987, '1escA00', NULL, NULL, 306, NULL, NULL, 234939),
(283988, '3p94A00', NULL, NULL, 204, NULL, NULL, 234939),
(283989, '3milB00', NULL, NULL, 240, NULL, NULL, 234939),
(283990, '5jd3A00', NULL, NULL, 218, NULL, NULL, 234939),
(283991, '4rw0A00', NULL, NULL, 185, NULL, NULL, 234939),
(283992, '2w9xA02', NULL, NULL, 230, NULL, NULL, 234939),
(283993, '3bzwF00', NULL, NULL, 255, NULL, NULL, 234939),
(283994, '4h08A00', NULL, NULL, 200, NULL, NULL, 234939),
(283995, '1fxwF00', NULL, NULL, 229, NULL, NULL, 234939),
(283996, '3rjtA00', NULL, NULL, 216, NULL, NULL, 234939),
(283997, '2vptA00', NULL, NULL, 215, NULL, NULL, 234939),
(283998, '3dciA00', NULL, NULL, 209, NULL, NULL, 234939),
(283999, '3hp4A00', NULL, NULL, 185, NULL, NULL, 234939),
(284000, '5a4aA00', NULL, NULL, 208, NULL, NULL, 234939),
(284001, '3dc7A00', NULL, NULL, 215, NULL, NULL, 234939),
(284002, '5tifA00', NULL, NULL, 185, NULL, NULL, 234939),
(284003, '4ppyA00', NULL, NULL, 210, NULL, NULL, 234939),
(284004, '3slrA01', NULL, NULL, 219, NULL, NULL, 234939),
(284005, '4m8kA00', NULL, NULL, 236, NULL, NULL, 234939),
(284006, '4rshA00', NULL, NULL, 179, NULL, NULL, 234939),
(284007, '1zmbA01', NULL, NULL, 248, NULL, NULL, 234939),
(284008, '4hf7A00', NULL, NULL, 209, NULL, NULL, 234939),
(284009, '4iyjA00', NULL, NULL, 212, NULL, NULL, 234939),
(284010, '2waaA02', NULL, NULL, 218, NULL, NULL, 234939),
(284011, '4xvhA02', NULL, NULL, 222, NULL, NULL, 234939),
(284012, '4nrdA00', NULL, NULL, 208, NULL, NULL, 234939),
(284013, '4q9aA00', NULL, NULL, 229, NULL, NULL, 234939),
(284014, '5bn1A00', NULL, NULL, 219, NULL, NULL, 234939),
(284015, '3vtiA04', NULL, NULL, 78, NULL, NULL, 234940),
(284016, '3vthA02', NULL, NULL, 75, NULL, NULL, 234940),
(284017, '3ttcA02', NULL, NULL, 67, NULL, NULL, 234940),
(284018, '4hizA01', NULL, NULL, 42, NULL, NULL, 234941),
(284019, '3ju4A01', NULL, NULL, 72, NULL, NULL, 234941),
(284020, '3gvkA01', NULL, NULL, 44, NULL, NULL, 234941);
INSERT INTO "PUBLIC"."MODEL" VALUES
(284021, '1xg8A00', NULL, NULL, 111, NULL, NULL, 234942),
(284022, '1qz8A01', NULL, NULL, 105, NULL, NULL, 234943),
(284023, '5hizA01', NULL, NULL, 106, NULL, NULL, 234943),
(284024, '5c94A00', NULL, NULL, 116, NULL, NULL, 234943),
(284025, '2j98A01', NULL, NULL, 101, NULL, NULL, 234943),
(284026, '3ee7A01', NULL, NULL, 113, NULL, NULL, 234943),
(284027, '2y0mB00', NULL, NULL, 46, NULL, NULL, 234944),
(284028, '1v0dA01', NULL, NULL, 49, NULL, NULL, 234945),
(284029, '4aybB07', NULL, NULL, 136, NULL, NULL, 234946),
(284030, '3h0gB07', NULL, NULL, 137, NULL, NULL, 234946),
(284031, '4qiwB07', NULL, NULL, 138, NULL, NULL, 234946),
(284032, '1twfB07', NULL, NULL, 137, NULL, NULL, 234946),
(284033, '4c2mB07', NULL, NULL, 126, NULL, NULL, 234946),
(284034, '2ly7A01', NULL, NULL, 146, NULL, NULL, 234946),
(284035, '1ynjC06', NULL, NULL, 128, NULL, NULL, 234946),
(284036, '3woeA00', NULL, NULL, 130, NULL, NULL, 234946),
(284037, '3tbiB01', NULL, NULL, 128, NULL, NULL, 234946),
(284038, '4r84A01', NULL, NULL, 88, NULL, NULL, 234947),
(284039, '2z4tA01', NULL, NULL, 92, NULL, NULL, 234947),
(284040, '2k9pA00', NULL, NULL, 80, NULL, NULL, 234948),
(284041, '2d00A02', NULL, NULL, 33, NULL, NULL, 234949),
(284042, '2bonA02', NULL, NULL, 159, NULL, NULL, 234950),
(284043, '3s40B02', NULL, NULL, 160, NULL, NULL, 234950),
(284044, '3vzbB02', NULL, NULL, 214, NULL, NULL, 234950),
(284045, '2qv7A02', NULL, NULL, 162, NULL, NULL, 234950),
(284046, '2p1rA02', NULL, NULL, 159, NULL, NULL, 234950),
(284047, '4werA02', NULL, NULL, 166, NULL, NULL, 234950),
(284048, '2vz4A00', NULL, NULL, 108, NULL, NULL, 234951),
(284049, '2jmlA00', NULL, NULL, 81, NULL, NULL, 234951),
(284050, '3ucsA00', NULL, NULL, 102, NULL, NULL, 234951),
(284051, '3hh0A01', NULL, NULL, 74, NULL, NULL, 234951),
(284052, '3gpvA00', NULL, NULL, 128, NULL, NULL, 234951),
(284053, '4r24B00', NULL, NULL, 85, NULL, NULL, 234951),
(284054, '1r8dB00', NULL, NULL, 109, NULL, NULL, 234951),
(284055, '1r8eA02', NULL, NULL, 75, NULL, NULL, 234951),
(284056, '3gp4B00', NULL, NULL, 142, NULL, NULL, 234951),
(284057, '3gpvB00', NULL, NULL, 131, NULL, NULL, 234951),
(284058, '2zhgA00', NULL, NULL, 135, NULL, NULL, 234951),
(284059, '4r4eB00', NULL, NULL, 84, NULL, NULL, 234951),
(284060, '4wlsA00', NULL, NULL, 111, NULL, NULL, 234951),
(284061, '3qaoA00', NULL, NULL, 140, NULL, NULL, 234951),
(284062, '5c8eG01', NULL, NULL, 78, NULL, NULL, 234951),
(284063, '5d90B00', NULL, NULL, 136, NULL, NULL, 234951),
(284064, '1q08A00', NULL, NULL, 99, NULL, NULL, 234951),
(284065, '5i41B00', NULL, NULL, 69, NULL, NULL, 234951),
(284066, '5lqbA00', NULL, NULL, 132, NULL, NULL, 234952),
(284067, '2o27A00', NULL, NULL, 145, NULL, NULL, 234952),
(284068, '1d9cA00', NULL, NULL, 121, NULL, NULL, 234952),
(284069, '3ux9A00', NULL, NULL, 169, NULL, NULL, 234952),
(284070, '1lk3A00', NULL, NULL, 160, NULL, NULL, 234952),
(284071, '5knhI00', NULL, NULL, 112, NULL, NULL, 234952),
(284072, '1au1B00', NULL, NULL, 166, NULL, NULL, 234952),
(284073, '1a7mA00', NULL, NULL, 180, NULL, NULL, 234952),
(284074, '3l5xA00', NULL, NULL, 113, NULL, NULL, 234952),
(284075, '3ejjB00', NULL, NULL, 155, NULL, NULL, 234952),
(284076, '1pvhB00', NULL, NULL, 169, NULL, NULL, 234952),
(284077, '3se4B00', NULL, NULL, 177, NULL, NULL, 234952),
(284078, '4yueC00', NULL, NULL, 130, NULL, NULL, 234952),
(284079, '1exzB00', NULL, NULL, 141, NULL, NULL, 234952),
(284080, '1bgeA00', NULL, NULL, 175, NULL, NULL, 234952),
(284081, '5gw9A00', NULL, NULL, 163, NULL, NULL, 234952),
(284082, '1lkiA00', NULL, NULL, 180, NULL, NULL, 234952),
(284083, '3qb1A00', NULL, NULL, 136, NULL, NULL, 234952),
(284084, '1huwA00', NULL, NULL, 191, NULL, NULL, 234952),
(284085, '1f6fA00', NULL, NULL, 199, NULL, NULL, 234952),
(284086, '1v7mV00', NULL, NULL, 163, NULL, NULL, 234952),
(284087, '5lxfA00', NULL, NULL, 159, NULL, NULL, 234952),
(284088, '3qb7B00', NULL, NULL, 132, NULL, NULL, 234952),
(284089, '4zf7B00', NULL, NULL, 138, NULL, NULL, 234952),
(284090, '3d48P00', NULL, NULL, 188, NULL, NULL, 234952),
(284091, '1fyhA02', NULL, NULL, 133, NULL, NULL, 234952);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(284092, '2l3yA00', NULL, NULL, 190, NULL, NULL, 234952),
(284093, '5d22B00', NULL, NULL, 127, NULL, NULL, 234952),
(284094, '1hguA00', NULL, NULL, 191, NULL, NULL, 234952),
(284095, '1aluA00', NULL, NULL, 166, NULL, NULL, 234952),
(284096, '1lqsL01', NULL, NULL, 114, NULL, NULL, 234952),
(284097, '1ax8A00', NULL, NULL, 146, NULL, NULL, 234952),
(284098, '1jliA00', NULL, NULL, 112, NULL, NULL, 234952),
(284099, '1hulA00', NULL, NULL, 108, NULL, NULL, 234952),
(284100, '1axiA00', NULL, NULL, 191, NULL, NULL, 234952),
(284101, '3d85C00', NULL, NULL, 178, NULL, NULL, 234952),
(284102, '3b5kB00', NULL, NULL, 113, NULL, NULL, 234952),
(284103, '4o6kA00', NULL, NULL, 144, NULL, NULL, 234952),
(284104, '3uf5B00', NULL, NULL, 153, NULL, NULL, 234952),
(284105, '4mhlA00', NULL, NULL, 177, NULL, NULL, 234952),
(284106, '1i1rB00', NULL, NULL, 181, NULL, NULL, 234952),
(284107, '3pivA00', NULL, NULL, 164, NULL, NULL, 234952),
(284108, '1vlkA00', NULL, NULL, 145, NULL, NULL, 234952),
(284109, '1eerA00', NULL, NULL, 166, NULL, NULL, 234952),
(284110, '1evsA00', NULL, NULL, 187, NULL, NULL, 234952),
(284111, '3ew3A00', NULL, NULL, 203, NULL, NULL, 234952),
(284112, '5uwcI00', NULL, NULL, 122, NULL, NULL, 234952),
(284113, '1bgcA00', NULL, NULL, 174, NULL, NULL, 234952),
(284114, '2d48A00', NULL, NULL, 129, NULL, NULL, 234952),
(284115, '5m5eD00', NULL, NULL, 138, NULL, NULL, 234952),
(284116, '1z7cA00', NULL, NULL, 191, NULL, NULL, 234952),
(284117, '3s9dA00', NULL, NULL, 168, NULL, NULL, 234952),
(284118, '3dlqI00', NULL, NULL, 151, NULL, NULL, 234952),
(284119, '3oq3A00', NULL, NULL, 166, NULL, NULL, 234952),
(284120, '1cnt200', NULL, NULL, 187, NULL, NULL, 234952),
(284121, '1eteA00', NULL, NULL, 134, NULL, NULL, 234952),
(284122, '1n1fA00', NULL, NULL, 159, NULL, NULL, 234952),
(284123, '4x51B00', NULL, NULL, 162, NULL, NULL, 234952),
(284124, '3piwA00', NULL, NULL, 161, NULL, NULL, 234952),
(284125, '4dohA00', NULL, NULL, 153, NULL, NULL, 234952),
(284126, '2l3oA00', NULL, NULL, 127, NULL, NULL, 234952),
(284127, '1wu3I00', NULL, NULL, 161, NULL, NULL, 234952),
(284128, '5e4eA00', NULL, NULL, 113, NULL, NULL, 234952),
(284129, '1b5lA00', NULL, NULL, 172, NULL, NULL, 234952),
(284130, '3besL00', NULL, NULL, 139, NULL, NULL, 234952),
(284131, '5d70A00', NULL, NULL, 127, NULL, NULL, 234952),
(284132, '1f45B00', NULL, NULL, 178, NULL, NULL, 234952),
(284133, '1miuA04', NULL, NULL, 134, NULL, NULL, 234953),
(284134, '1dgfA02', NULL, NULL, 258, NULL, NULL, 234954),
(284135, '4qolA00', NULL, NULL, 491, NULL, NULL, 234954),
(284136, '1a4eA00', NULL, NULL, 488, NULL, NULL, 234954),
(284137, '3e4wA02', NULL, NULL, 207, NULL, NULL, 234954),
(284138, '1m7sB00', NULL, NULL, 484, NULL, NULL, 234954),
(284139, '4cabA00', NULL, NULL, 507, NULL, NULL, 234954),
(284140, '4e37A00', NULL, NULL, 484, NULL, NULL, 234954),
(284141, '1gweA00', NULL, NULL, 503, NULL, NULL, 234954),
(284142, '4b7hA02', NULL, NULL, 257, NULL, NULL, 234954),
(284143, '5bv2Q01', NULL, NULL, 493, NULL, NULL, 234954),
(284144, '1sy7A01', NULL, NULL, 361, NULL, NULL, 234954),
(284145, '3ttvA01', NULL, NULL, 386, NULL, NULL, 234954),
(284146, '1si8A00', NULL, NULL, 484, NULL, NULL, 234954),
(284147, '2j2mA00', NULL, NULL, 491, NULL, NULL, 234954),
(284148, '1u5uA00', NULL, NULL, 374, NULL, NULL, 234954),
(284149, '2xq1H00', NULL, NULL, 509, NULL, NULL, 234954),
(284150, '1qwmA00', NULL, NULL, 505, NULL, NULL, 234954),
(284151, '3dy5A01', NULL, NULL, 488, NULL, NULL, 234954),
(284152, '4aumB01', NULL, NULL, 426, NULL, NULL, 234954),
(284153, '1e93A00', NULL, NULL, 484, NULL, NULL, 234954),
(284154, '2isaA00', NULL, NULL, 483, NULL, NULL, 234954),
(284155, '1f4jA00', NULL, NULL, 479, NULL, NULL, 234954),
(284156, '4aj9A01', NULL, NULL, 430, NULL, NULL, 234954),
(284157, '3rgpA02', NULL, NULL, 258, NULL, NULL, 234954),
(284158, '2iufA01', NULL, NULL, 428, NULL, NULL, 234954),
(284159, '4rt1A00', NULL, NULL, 112, NULL, NULL, 234955),
(284160, '4xrnC00', NULL, NULL, 111, NULL, NULL, 234955),
(284161, '4i86A00', NULL, NULL, 111, NULL, NULL, 234955),
(284162, '2rdeA02', NULL, NULL, 116, NULL, NULL, 234955);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(284163, '3kyfA02', NULL, NULL, 117, NULL, NULL, 234955),
(284164, '4p02A03', NULL, NULL, 122, NULL, NULL, 234955),
(284165, '3dsgB00', NULL, NULL, 99, NULL, NULL, 234955),
(284166, '5xlyB00', NULL, NULL, 133, NULL, NULL, 234955),
(284167, '5kecD02', NULL, NULL, 128, NULL, NULL, 234955),
(284168, '3cnrB00', NULL, NULL, 117, NULL, NULL, 234955),
(284169, '4i14A02', NULL, NULL, 135, NULL, NULL, 234956),
(284170, '2bz1A00', NULL, NULL, 174, NULL, NULL, 234956),
(284171, '4rl4A00', NULL, NULL, 176, NULL, NULL, 234956),
(284172, '2ex3B01', NULL, NULL, 96, NULL, NULL, 234957),
(284173, '5ee0A03', NULL, NULL, 89, NULL, NULL, 234958),
(284174, '2dbyA03', NULL, NULL, 90, NULL, NULL, 234958),
(284175, '2ohfA03', NULL, NULL, 85, NULL, NULL, 234958),
(284176, '1ni3A03', NULL, NULL, 91, NULL, NULL, 234958),
(284177, '1jalA03', NULL, NULL, 81, NULL, NULL, 234958),
(284178, '2v26A04', NULL, NULL, 135, NULL, NULL, 234959),
(284179, '2mysA04', NULL, NULL, 133, NULL, NULL, 234959),
(284180, '1lkxC03', NULL, NULL, 117, NULL, NULL, 234959),
(284181, '1lvkA04', NULL, NULL, 137, NULL, NULL, 234959),
(284182, '1br2A03', NULL, NULL, 109, NULL, NULL, 234959),
(284183, '1mmaA04', NULL, NULL, 106, NULL, NULL, 234959),
(284184, '2f9hA00', NULL, NULL, 129, NULL, NULL, 234960),
(284185, '3fdqA01', NULL, NULL, 125, NULL, NULL, 234961),
(284186, '2fgtA02', NULL, NULL, 105, NULL, NULL, 234962),
(284187, '2j5uA02', NULL, NULL, 84, NULL, NULL, 234963),
(284188, '2qf4A01', NULL, NULL, 81, NULL, NULL, 234963),
(284189, '1o75A02', NULL, NULL, 112, NULL, NULL, 234964),
(284190, '2rqmA01', NULL, NULL, 28, NULL, NULL, 234965),
(284191, '1dcsA00', NULL, NULL, 311, NULL, NULL, 234966),
(284192, '5c3pD00', NULL, NULL, 343, NULL, NULL, 234966),
(284193, '1w9yA00', NULL, NULL, 319, NULL, NULL, 234966),
(284194, '3ooxA00', NULL, NULL, 312, NULL, NULL, 234966),
(284195, '3on7B00', NULL, NULL, 280, NULL, NULL, 234966),
(284196, '1odmA00', NULL, NULL, 331, NULL, NULL, 234966),
(284197, '4xaeB00', NULL, NULL, 330, NULL, NULL, 234966),
(284198, '4rgkA00', NULL, NULL, 418, NULL, NULL, 234966),
(284199, '2dbnA00', NULL, NULL, 421, NULL, NULL, 234966),
(284200, '2csgA00', NULL, NULL, 424, NULL, NULL, 234966),
(284201, '1e5rB01', NULL, NULL, 203, NULL, NULL, 234966),
(284202, '5jqyA02', NULL, NULL, 196, NULL, NULL, 234966),
(284203, '1gp6A00', NULL, NULL, 350, NULL, NULL, 234966),
(284204, '5gj9A00', NULL, NULL, 303, NULL, NULL, 234966),
(284205, '6aaaA02', NULL, NULL, 181, NULL, NULL, 234967),
(284206, '1lciA02', NULL, NULL, 142, NULL, NULL, 234967),
(284207, '6aaaA03', NULL, NULL, 158, NULL, NULL, 234967),
(284208, '3a9uA02', NULL, NULL, 148, NULL, NULL, 234967),
(284209, '3cw9A02', NULL, NULL, 147, NULL, NULL, 234967),
(284210, '3a9uA01', NULL, NULL, 172, NULL, NULL, 234967),
(284211, '5u95B02', NULL, NULL, 148, NULL, NULL, 234967),
(284212, '3cw9A01', NULL, NULL, 174, NULL, NULL, 234967),
(284213, '1amuA02', NULL, NULL, 140, NULL, NULL, 234967),
(284214, '1amuA01', NULL, NULL, 170, NULL, NULL, 234967),
(284215, '1mdbA01', NULL, NULL, 158, NULL, NULL, 234967),
(284216, '1mdbA02', NULL, NULL, 174, NULL, NULL, 234967),
(284217, '5u95B01', NULL, NULL, 172, NULL, NULL, 234967),
(284218, '2d1sA02', NULL, NULL, 179, NULL, NULL, 234967),
(284219, '5kytA03', NULL, NULL, 159, NULL, NULL, 234967),
(284220, '5kytA02', NULL, NULL, 181, NULL, NULL, 234967),
(284221, '4rlqA01', NULL, NULL, 241, NULL, NULL, 234967),
(284222, '2d1sA03', NULL, NULL, 159, NULL, NULL, 234967),
(284223, '2vsqA03', NULL, NULL, 190, NULL, NULL, 234967),
(284224, '2vsqA04', NULL, NULL, 136, NULL, NULL, 234967),
(284225, '2q3lB00', NULL, NULL, 126, NULL, NULL, 234968),
(284226, '2ookA00', NULL, NULL, 127, NULL, NULL, 234968),
(284227, '2j3tD01', NULL, NULL, 135, NULL, NULL, 234969),
(284228, '2j3tC00', NULL, NULL, 145, NULL, NULL, 234969),
(284229, '2j3wC00', NULL, NULL, 142, NULL, NULL, 234969),
(284230, '3pr6A00', NULL, NULL, 162, NULL, NULL, 234969),
(284231, '3cueC00', NULL, NULL, 159, NULL, NULL, 234969),
(284232, '3cueA01', NULL, NULL, 157, NULL, NULL, 234969),
(284233, '2zuoA10', NULL, NULL, 127, NULL, NULL, 234970);
INSERT INTO "PUBLIC"."MODEL" VALUES
(284234, '2rpbA00', NULL, NULL, 113, NULL, NULL, 234970),
(284235, '1winA01', NULL, NULL, 117, NULL, NULL, 234970),
(284236, '4fvgA00', NULL, NULL, 133, NULL, NULL, 234970),
(284237, '3bk6A01', NULL, NULL, 114, NULL, NULL, 234970),
(284238, '1iw7D09', NULL, NULL, 73, NULL, NULL, 234971),
(284239, '1g8lA02', NULL, NULL, 57, NULL, NULL, 234971),
(284240, '1hqmD05', NULL, NULL, 75, NULL, NULL, 234971),
(284241, '1xi8A02', NULL, NULL, 65, NULL, NULL, 234971),
(284242, '6gbcA02', NULL, NULL, 58, NULL, NULL, 234971),
(284243, '1wu2B02', NULL, NULL, 60, NULL, NULL, 234971),
(284244, '2x3lB03', NULL, NULL, 59, NULL, NULL, 234971),
(284245, '1uz5A02', NULL, NULL, 57, NULL, NULL, 234971),
(284246, '6fgcA02', NULL, NULL, 58, NULL, NULL, 234971),
(284247, '2ph5A02', NULL, NULL, 302, NULL, NULL, 234972),
(284248, '4xqcA02', NULL, NULL, 297, NULL, NULL, 234972),
(284249, '4xkbA02', NULL, NULL, 79, NULL, NULL, 234973),
(284250, '1z3xA02', NULL, NULL, 76, NULL, NULL, 234973),
(284251, '3gl1A02', NULL, NULL, 55, NULL, NULL, 234974),
(284252, '5aqmA02', NULL, NULL, 55, NULL, NULL, 234974),
(284253, '5bn8A02', NULL, NULL, 55, NULL, NULL, 234974),
(284254, '1qqmA02', NULL, NULL, 55, NULL, NULL, 234974),
(284255, '6gfaA02', NULL, NULL, 56, NULL, NULL, 234974),
(284256, '4kboA02', NULL, NULL, 52, NULL, NULL, 234974),
(284257, '3d2fA02', NULL, NULL, 76, NULL, NULL, 234974),
(284258, '4gniA02', NULL, NULL, 57, NULL, NULL, 234974),
(284259, '3qfuA02', NULL, NULL, 55, NULL, NULL, 234974),
(284260, '3gdqA02', NULL, NULL, 55, NULL, NULL, 234974),
(284261, '3fe1A02', NULL, NULL, 55, NULL, NULL, 234974),
(284262, '3kvgA02', NULL, NULL, 56, NULL, NULL, 234974),
(284263, '3i33A02', NULL, NULL, 55, NULL, NULL, 234974),
(284264, '1dkgD02', NULL, NULL, 52, NULL, NULL, 234974),
(284265, '5f0xA02', NULL, NULL, 56, NULL, NULL, 234974),
(284266, '3e35A02', NULL, NULL, 44, NULL, NULL, 234975),
(284267, '2hr3B03', NULL, NULL, 50, NULL, NULL, 234975),
(284268, '2wamB02', NULL, NULL, 43, NULL, NULL, 234975),
(284269, '1s3jB03', NULL, NULL, 57, NULL, NULL, 234975),
(284270, '1nvpB00', NULL, NULL, 57, NULL, NULL, 234975),
(284271, '1s3jA03', NULL, NULL, 57, NULL, NULL, 234975),
(284272, '4hamA02', NULL, NULL, 54, NULL, NULL, 234975),
(284273, '3w7tA02', NULL, NULL, 39, NULL, NULL, 234975),
(284274, '1nh2B00', NULL, NULL, 53, NULL, NULL, 234975),
(284275, '3by6A02', NULL, NULL, 49, NULL, NULL, 234975),
(284276, '3ic7A02', NULL, NULL, 49, NULL, NULL, 234975),
(284277, '2p90A02', NULL, NULL, 45, NULL, NULL, 234975),
(284278, '1bzkA00', NULL, NULL, 43, NULL, NULL, 234976),
(284279, '3vbcA00', NULL, NULL, 162, NULL, NULL, 234977),
(284280, '1avoA00', NULL, NULL, 60, NULL, NULL, 234978),
(284281, '3nqnA00', NULL, NULL, 158, NULL, NULL, 234979),
(284282, '2ovbA02', NULL, NULL, 80, NULL, NULL, 234980),
(284283, '3mgbA02', NULL, NULL, 97, NULL, NULL, 234980),
(284284, '2jytA00', NULL, NULL, 69, NULL, NULL, 234981),
(284285, '2jyeA01', NULL, NULL, 61, NULL, NULL, 234981),
(284286, '4rniA00', NULL, NULL, 256, NULL, NULL, 234982),
(284287, '2r6oA00', NULL, NULL, 271, NULL, NULL, 234982),
(284288, '3hv8A00', NULL, NULL, 251, NULL, NULL, 234982),
(284289, '3gfzB02', NULL, NULL, 265, NULL, NULL, 234982),
(284290, '4fojA00', NULL, NULL, 264, NULL, NULL, 234982),
(284291, '4hu4A00', NULL, NULL, 259, NULL, NULL, 234982),
(284292, '3kzpA00', NULL, NULL, 235, NULL, NULL, 234982),
(284293, '4y8eA00', NULL, NULL, 263, NULL, NULL, 234982),
(284294, '3tlqA00', NULL, NULL, 242, NULL, NULL, 234982),
(284295, '3s83A00', NULL, NULL, 259, NULL, NULL, 234982),
(284296, '4q6jB00', NULL, NULL, 252, NULL, NULL, 234982),
(284297, '3pfmA00', NULL, NULL, 243, NULL, NULL, 234982),
(284298, '3pjxA02', NULL, NULL, 242, NULL, NULL, 234982),
(284299, '5m1tA00', NULL, NULL, 251, NULL, NULL, 234982),
(284300, '3sy8C02', NULL, NULL, 260, NULL, NULL, 234982),
(284301, '5m3cA02', NULL, NULL, 267, NULL, NULL, 234982),
(284302, '4lj3A00', NULL, NULL, 259, NULL, NULL, 234982),
(284303, '2basB01', NULL, NULL, 230, NULL, NULL, 234982),
(284304, '1erdA00', NULL, NULL, 40, NULL, NULL, 234983);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(284305, '1ha8A00', NULL, NULL, 51, NULL, NULL, 234983),
(284306, '2vmhA00', NULL, NULL, 151, NULL, NULL, 234984),
(284307, '2vngA00', NULL, NULL, 180, NULL, NULL, 234984),
(284308, '2yglB02', NULL, NULL, 181, NULL, NULL, 234984),
(284309, '2yglA01', NULL, NULL, 173, NULL, NULL, 234984),
(284310, '1jeyA04', NULL, NULL, 94, NULL, NULL, 234985),
(284311, '1jeyB03', NULL, NULL, 102, NULL, NULL, 234985),
(284312, '4uoiC00', NULL, NULL, 71, NULL, NULL, 234986),
(284313, '5cg8A00', NULL, NULL, 267, NULL, NULL, 234987),
(284314, '1cixA00', NULL, NULL, 44, NULL, NULL, 234988),
(284315, '1xi7A00', NULL, NULL, 61, NULL, NULL, 234988),
(284316, '1h59B00', NULL, NULL, 54, NULL, NULL, 234988),
(284317, '2dcvA00', NULL, NULL, 42, NULL, NULL, 234988),
(284318, '3zxcA00', NULL, NULL, 77, NULL, NULL, 234988),
(284319, '1wqjB01', NULL, NULL, 73, NULL, NULL, 234988),
(284320, '1dmuA00', NULL, NULL, 299, NULL, NULL, 234989),
(284321, '2d4uB00', NULL, NULL, 176, NULL, NULL, 234990),
(284322, '4h54A01', NULL, NULL, 134, NULL, NULL, 234990),
(284323, '1vlsA00', NULL, NULL, 146, NULL, NULL, 234990),
(284324, '4z9hB00', NULL, NULL, 161, NULL, NULL, 234990),
(284325, '3t9oB00', NULL, NULL, 135, NULL, NULL, 234990),
(284326, '2fj6A01', NULL, NULL, 72, NULL, NULL, 234991),
(284327, '2kvsA00', NULL, NULL, 80, NULL, NULL, 234991),
(284328, '2o6kB00', NULL, NULL, 81, NULL, NULL, 234991),
(284329, '3lmlA02', NULL, NULL, 92, NULL, NULL, 234992),
(284330, '4ghbA00', NULL, NULL, 272, NULL, NULL, 234993),
(284331, '1yx4A01', NULL, NULL, 68, NULL, NULL, 234994),
(284332, '1yx6A01', NULL, NULL, 88, NULL, NULL, 234994),
(284333, '4aq1A04', NULL, NULL, 127, NULL, NULL, 234995),
(284334, '3hbmA01', NULL, NULL, 141, NULL, NULL, 234996),
(284335, '2j8gA02', NULL, NULL, 82, NULL, NULL, 234997),
(284336, '2qj6A03', NULL, NULL, 94, NULL, NULL, 234997),
(284337, '2v05A02', NULL, NULL, 182, NULL, NULL, 234997),
(284338, '2g7cB03', NULL, NULL, 98, NULL, NULL, 234997),
(284339, '2g7cA02', NULL, NULL, 91, NULL, NULL, 234997),
(284340, '2qj6A01', NULL, NULL, 147, NULL, NULL, 234997),
(284341, '4x36A02', NULL, NULL, 136, NULL, NULL, 234997),
(284342, '2g7cB01', NULL, NULL, 66, NULL, NULL, 234997),
(284343, '3kllA01', NULL, NULL, 168, NULL, NULL, 234997),
(284344, '2f6eA00', NULL, NULL, 127, NULL, NULL, 234997),
(284345, '1h8gA00', NULL, NULL, 95, NULL, NULL, 234997),
(284346, '2bmlA00', NULL, NULL, 126, NULL, NULL, 234997),
(284347, '4tvcA01', NULL, NULL, 197, NULL, NULL, 234997),
(284348, '4nc0A01', NULL, NULL, 68, NULL, NULL, 234997),
(284349, '4nc2A00', NULL, NULL, 126, NULL, NULL, 234997),
(284350, '4iwtA00', NULL, NULL, 146, NULL, NULL, 234997),
(284351, '3klkA01', NULL, NULL, 167, NULL, NULL, 234997),
(284352, '3hiaA00', NULL, NULL, 94, NULL, NULL, 234997),
(284353, '3bnjA01', NULL, NULL, 329, NULL, NULL, 234998),
(284354, '3sxqA02', NULL, NULL, 355, NULL, NULL, 234998),
(284355, '1qo8D02', NULL, NULL, 100, NULL, NULL, 234998),
(284356, '3fo3A02', NULL, NULL, 355, NULL, NULL, 234998),
(284357, '3ubrA01', NULL, NULL, 296, NULL, NULL, 234998),
(284358, '2j7aD01', NULL, NULL, 334, NULL, NULL, 234998),
(284359, '1ft5A00', NULL, NULL, 211, NULL, NULL, 234998),
(284360, '2rdzA01', NULL, NULL, 309, NULL, NULL, 234998),
(284361, '2k3vA00', NULL, NULL, 86, NULL, NULL, 234998),
(284362, '1qdbA01', NULL, NULL, 315, NULL, NULL, 234998),
(284363, '1jniA00', NULL, NULL, 68, NULL, NULL, 234998),
(284364, '1m1qA00', NULL, NULL, 91, NULL, NULL, 234998),
(284365, '1d4dA01', NULL, NULL, 103, NULL, NULL, 234998),
(284366, '1y0pA01', NULL, NULL, 99, NULL, NULL, 234998),
(284367, '1oahA01', NULL, NULL, 332, NULL, NULL, 234998),
(284368, '3tgnA03', NULL, NULL, 48, NULL, NULL, 234999),
(284369, '1t36A04', NULL, NULL, 119, NULL, NULL, 235000),
(284370, '1a9xA04', NULL, NULL, 150, NULL, NULL, 235000),
(284371, '3bcyA00', NULL, NULL, 155, NULL, NULL, 235001),
(284372, '1x4sA00', NULL, NULL, 59, NULL, NULL, 235002),
(284373, '3nm7B00', NULL, NULL, 84, NULL, NULL, 235003),
(284374, '3n8bB00', NULL, NULL, 77, NULL, NULL, 235003),
(284375, '5fgoD00', NULL, NULL, 81, NULL, NULL, 235003);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(284376, '4hg2A02', NULL, NULL, 68, NULL, NULL, 235004),
(284377, '2hjqA01', NULL, NULL, 46, NULL, NULL, 235005),
(284378, '3k6sD04', NULL, NULL, 133, NULL, NULL, 235006),
(284379, '4aqsA03', NULL, NULL, 104, NULL, NULL, 235006),
(284380, '4aqsA02', NULL, NULL, 116, NULL, NULL, 235006),
(284381, '2gy5A03', NULL, NULL, 135, NULL, NULL, 235006),
(284382, '1vi7A01', NULL, NULL, 137, NULL, NULL, 235007),
(284383, '2cveA01', NULL, NULL, 125, NULL, NULL, 235007),
(284384, '3qg2A02', NULL, NULL, 41, NULL, NULL, 235008),
(284385, '3aagA01', NULL, NULL, 160, NULL, NULL, 235009),
(284386, '3aagB01', NULL, NULL, 158, NULL, NULL, 235009),
(284387, '3nuhB03', NULL, NULL, 92, NULL, NULL, 235010),
(284388, '3guuA02', NULL, NULL, 96, NULL, NULL, 235011),
(284389, '3zpxA02', NULL, NULL, 96, NULL, NULL, 235011),
(284390, '4zldA00', NULL, NULL, 155, NULL, NULL, 235012),
(284391, '4ywqA00', NULL, NULL, 152, NULL, NULL, 235012),
(284392, '3hjhA03', NULL, NULL, 97, NULL, NULL, 235013),
(284393, '2o5vA02', NULL, NULL, 176, NULL, NULL, 235014),
(284394, '5zwuA02', NULL, NULL, 173, NULL, NULL, 235014),
(284395, '3e59B02', NULL, NULL, 48, NULL, NULL, 235015),
(284396, '3kk4A01', NULL, NULL, 109, NULL, NULL, 235016),
(284397, '2hw4A01', NULL, NULL, 121, NULL, NULL, 235017),
(284398, '3v3tA02', NULL, NULL, 95, NULL, NULL, 235018),
(284399, '2aw4Z00', NULL, NULL, 70, NULL, NULL, 235019),
(284400, '1eiwA00', NULL, NULL, 111, NULL, NULL, 235020),
(284401, '2xzlA04', NULL, NULL, 53, NULL, NULL, 235021),
(284402, '2gk6A03', NULL, NULL, 54, NULL, NULL, 235021),
(284403, '1y5iA02', NULL, NULL, 397, NULL, NULL, 235022),
(284404, '1nt2B01', NULL, NULL, 71, NULL, NULL, 235023),
(284405, '5o5jT00', NULL, NULL, 86, NULL, NULL, 235024),
(284406, '2vqeT00', NULL, NULL, 106, NULL, NULL, 235024),
(284407, '1vs5T00', NULL, NULL, 87, NULL, NULL, 235024),
(284408, '5x8rt00', NULL, NULL, 108, NULL, NULL, 235024),
(284409, '1fx2A00', NULL, NULL, 235, NULL, NULL, 235025),
(284410, '2qv6A01', NULL, NULL, 128, NULL, NULL, 235025),
(284411, '6ao9A00', NULL, NULL, 192, NULL, NULL, 235025),
(284412, '5o5lA00', NULL, NULL, 225, NULL, NULL, 235025),
(284413, '4p2fA00', NULL, NULL, 189, NULL, NULL, 235025),
(284414, '1fx4A00', NULL, NULL, 231, NULL, NULL, 235025),
(284415, '1wc1C00', NULL, NULL, 199, NULL, NULL, 235025),
(284416, '4cllA01', NULL, NULL, 219, NULL, NULL, 235025),
(284417, '4ni2A00', NULL, NULL, 197, NULL, NULL, 235025),
(284418, '1y10B02', NULL, NULL, 183, NULL, NULL, 235025),
(284419, '4wp3C00', NULL, NULL, 210, NULL, NULL, 235025),
(284420, '4wp9A00', NULL, NULL, 177, NULL, NULL, 235025),
(284421, '1ybtB00', NULL, NULL, 184, NULL, NULL, 235025),
(284422, '4clfA02', NULL, NULL, 191, NULL, NULL, 235025),
(284423, '3r5gA00', NULL, NULL, 198, NULL, NULL, 235025),
(284424, '2wz1B00', NULL, NULL, 201, NULL, NULL, 235025),
(284425, '1azsB00', NULL, NULL, 212, NULL, NULL, 235025),
(284426, '1azsA00', NULL, NULL, 200, NULL, NULL, 235025),
(284427, '3mr7A00', NULL, NULL, 189, NULL, NULL, 235025),
(284428, '3et6A00', NULL, NULL, 190, NULL, NULL, 235025),
(284429, '2w01B00', NULL, NULL, 208, NULL, NULL, 235025),
(284430, '3u1uA01', NULL, NULL, 132, NULL, NULL, 235026),
(284431, '3nohA00', NULL, NULL, 139, NULL, NULL, 235027),
(284432, '4aybA05', NULL, NULL, 44, NULL, NULL, 235028),
(284433, '2ll0A00', NULL, NULL, 104, NULL, NULL, 235029),
(284434, '2kzcA00', NULL, NULL, 85, NULL, NULL, 235029),
(284435, '1cvrA01', NULL, NULL, 117, NULL, NULL, 235030),
(284436, '3vkhB01', NULL, NULL, 64, NULL, NULL, 235031),
(284437, '2z0rC00', NULL, NULL, 103, NULL, NULL, 235032),
(284438, '4u8uN02', NULL, NULL, 170, NULL, NULL, 235033),
(284439, '4u8uO02', NULL, NULL, 162, NULL, NULL, 235033),
(284440, '4u8uM02', NULL, NULL, 166, NULL, NULL, 235033),
(284441, '2gtlO02', NULL, NULL, 163, NULL, NULL, 235033),
(284442, '2gtlN02', NULL, NULL, 170, NULL, NULL, 235033),
(284443, '2gtlM02', NULL, NULL, 166, NULL, NULL, 235033),
(284444, '2lvgA00', NULL, NULL, 40, NULL, NULL, 235034),
(284445, '2kmgA00', NULL, NULL, 142, NULL, NULL, 235035),
(284446, '2wj9B00', NULL, NULL, 150, NULL, NULL, 235035);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(284447, '3aa0B01', NULL, NULL, 89, NULL, NULL, 235036),
(284448, '4akrB01', NULL, NULL, 88, NULL, NULL, 235036),
(284449, '3m7gA01', NULL, NULL, 65, NULL, NULL, 235037),
(284450, '2nr9A00', NULL, NULL, 196, NULL, NULL, 235038),
(284451, '2xovA00', NULL, NULL, 181, NULL, NULL, 235038),
(284452, '1izmA00', NULL, NULL, 184, NULL, NULL, 235039),
(284453, '4gytA00', NULL, NULL, 194, NULL, NULL, 235039),
(284454, '3e9vA00', NULL, NULL, 120, NULL, NULL, 235040),
(284455, '3djnB00', NULL, NULL, 118, NULL, NULL, 235040),
(284456, '2z15A00', NULL, NULL, 130, NULL, NULL, 235040),
(284457, '3klyD00', NULL, NULL, 254, NULL, NULL, 235041),
(284458, '3ne2C00', NULL, NULL, 246, NULL, NULL, 235041),
(284459, '2o9gA00', NULL, NULL, 234, NULL, NULL, 235041),
(284460, '4cskA00', NULL, NULL, 233, NULL, NULL, 235041),
(284461, '3gd8A00', NULL, NULL, 223, NULL, NULL, 235041),
(284462, '3zojA00', NULL, NULL, 279, NULL, NULL, 235041),
(284463, '3c02A00', NULL, NULL, 258, NULL, NULL, 235041),
(284464, '2b6oA00', NULL, NULL, 239, NULL, NULL, 235041),
(284465, '1z98A00', NULL, NULL, 258, NULL, NULL, 235041),
(284466, '3kcuD00', NULL, NULL, 257, NULL, NULL, 235041),
(284467, '1ldfA00', NULL, NULL, 259, NULL, NULL, 235041),
(284468, '3llqB00', NULL, NULL, 234, NULL, NULL, 235041),
(284469, '3d9sA00', NULL, NULL, 246, NULL, NULL, 235041),
(284470, '1j4nA00', NULL, NULL, 249, NULL, NULL, 235041),
(284471, '2f2bA00', NULL, NULL, 246, NULL, NULL, 235041),
(284472, '4nefA00', NULL, NULL, 242, NULL, NULL, 235041),
(284473, '5i32A00', NULL, NULL, 250, NULL, NULL, 235041),
(284474, '3tdsE00', NULL, NULL, 268, NULL, NULL, 235041),
(284475, '3q7kK00', NULL, NULL, 268, NULL, NULL, 235041),
(284476, '6f7hA00', NULL, NULL, 251, NULL, NULL, 235041),
(284477, '4fc4G00', NULL, NULL, 261, NULL, NULL, 235041),
(284478, '4lebA02', NULL, NULL, 139, NULL, NULL, 235042),
(284479, '2y7lA02', NULL, NULL, 151, NULL, NULL, 235042),
(284480, '3htyA00', NULL, NULL, 94, NULL, NULL, 235043),
(284481, '4qrlA00', NULL, NULL, 116, NULL, NULL, 235043),
(284482, '5bypA00', NULL, NULL, 127, NULL, NULL, 235043),
(284483, '1ty4B00', NULL, NULL, 170, NULL, NULL, 235044),
(284484, '1r2dA00', NULL, NULL, 142, NULL, NULL, 235044),
(284485, '2xa0A00', NULL, NULL, 147, NULL, NULL, 235044),
(284486, '1ty4A00', NULL, NULL, 170, NULL, NULL, 235044),
(284487, '5ktgA02', NULL, NULL, 79, NULL, NULL, 235044),
(284488, '4k5bC00', NULL, NULL, 145, NULL, NULL, 235044),
(284489, '4bduA02', NULL, NULL, 79, NULL, NULL, 235044),
(284490, '4qnqI00', NULL, NULL, 150, NULL, NULL, 235044),
(284491, '2wh6A00', NULL, NULL, 173, NULL, NULL, 235044),
(284492, '2vofC00', NULL, NULL, 157, NULL, NULL, 235044),
(284493, '1q59A00', NULL, NULL, 172, NULL, NULL, 235044),
(284494, '6o6fB01', NULL, NULL, 150, NULL, NULL, 235044),
(284495, '5c3fA01', NULL, NULL, 148, NULL, NULL, 235044),
(284496, '1ohuA00', NULL, NULL, 175, NULL, NULL, 235044),
(284497, '1pq1A00', NULL, NULL, 147, NULL, NULL, 235044),
(284498, '2imsA00', NULL, NULL, 171, NULL, NULL, 235044),
(284499, '1ohuB00', NULL, NULL, 175, NULL, NULL, 235044),
(284500, '5fmiA00', NULL, NULL, 162, NULL, NULL, 235044),
(284501, '3qbrX00', NULL, NULL, 179, NULL, NULL, 235044),
(284502, '4g35A01', NULL, NULL, 148, NULL, NULL, 235044),
(284503, '2jbyA00', NULL, NULL, 145, NULL, NULL, 235044),
(284504, '4b4sA01', NULL, NULL, 156, NULL, NULL, 235044),
(284505, '1k3kA00', NULL, NULL, 158, NULL, NULL, 235044),
(284506, '4uf1A00', NULL, NULL, 150, NULL, NULL, 235044),
(284507, '4qvxA00', NULL, NULL, 146, NULL, NULL, 235044),
(284508, '2w3lB00', NULL, NULL, 144, NULL, NULL, 235044),
(284509, '2a5yA00', NULL, NULL, 185, NULL, NULL, 235044),
(284510, '2me8A00', NULL, NULL, 212, NULL, NULL, 235044),
(284511, '2o42A00', NULL, NULL, 144, NULL, NULL, 235044),
(284512, '1ddbA00', NULL, NULL, 195, NULL, NULL, 235044),
(284513, '1o0lA00', NULL, NULL, 188, NULL, NULL, 235044),
(284514, '2kuaA01', NULL, NULL, 151, NULL, NULL, 235044),
(284515, '2vtyA00', NULL, NULL, 153, NULL, NULL, 235044),
(284516, '4zieA00', NULL, NULL, 168, NULL, NULL, 235044),
(284517, '5uukA00', NULL, NULL, 152, NULL, NULL, 235044);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(284518, '4u2vA02', NULL, NULL, 83, NULL, NULL, 235044),
(284519, '4mi8B00', NULL, NULL, 143, NULL, NULL, 235044),
(284520, '4yj4A00', NULL, NULL, 147, NULL, NULL, 235044),
(284521, '2bidA00', NULL, NULL, 197, NULL, NULL, 235044),
(284522, '6fs1A01', NULL, NULL, 148, NULL, NULL, 235044),
(284523, '2g7hA01', NULL, NULL, 76, NULL, NULL, 235045),
(284524, '2ox7A02', NULL, NULL, 69, NULL, NULL, 235046),
(284525, '2p84A02', NULL, NULL, 83, NULL, NULL, 235046),
(284526, '2qyzA02', NULL, NULL, 83, NULL, NULL, 235046),
(284527, '1z9iA01', NULL, NULL, 45, NULL, NULL, 235047),
(284528, '3w68A02', NULL, NULL, 52, NULL, NULL, 235048),
(284529, '1r5lA02', NULL, NULL, 52, NULL, NULL, 235048),
(284530, '4cc0B02', NULL, NULL, 46, NULL, NULL, 235049),
(284531, '4xbmA02', NULL, NULL, 46, NULL, NULL, 235049),
(284532, '1debB00', NULL, NULL, 54, NULL, NULL, 235050),
(284533, '1mz9A00', NULL, NULL, 45, NULL, NULL, 235050),
(284534, '3i9v201', NULL, NULL, 74, NULL, NULL, 235051),
(284535, '3bg1B03', NULL, NULL, 92, NULL, NULL, 235052),
(284536, '1mbyA00', NULL, NULL, 88, NULL, NULL, 235053),
(284537, '5lhy100', NULL, NULL, 91, NULL, NULL, 235053),
(284538, '2etnA02', NULL, NULL, 74, NULL, NULL, 235054),
(284539, '2f23A02', NULL, NULL, 74, NULL, NULL, 235054),
(284540, '2pn0A02', NULL, NULL, 94, NULL, NULL, 235054),
(284541, '1grjA02', NULL, NULL, 83, NULL, NULL, 235054),
(284542, '3bmbA02', NULL, NULL, 92, NULL, NULL, 235054),
(284543, '3gtyX02', NULL, NULL, 84, NULL, NULL, 235054),
(284544, '2p4vA02', NULL, NULL, 82, NULL, NULL, 235054),
(284545, '3lzqA00', NULL, NULL, 159, NULL, NULL, 235055),
(284546, '5i0yB00', NULL, NULL, 160, NULL, NULL, 235055),
(284547, '2o6fA00', NULL, NULL, 157, NULL, NULL, 235055),
(284548, '2phnA01', NULL, NULL, 159, NULL, NULL, 235056),
(284549, '4kh9A01', NULL, NULL, 138, NULL, NULL, 235057),
(284550, '1ztdA00', NULL, NULL, 133, NULL, NULL, 235058),
(284551, '4hdrB02', NULL, NULL, 261, NULL, NULL, 235059),
(284552, '6b5fA02', NULL, NULL, 271, NULL, NULL, 235059),
(284553, '1j33A02', NULL, NULL, 273, NULL, NULL, 235059),
(284554, '4hdrA02', NULL, NULL, 275, NULL, NULL, 235059),
(284555, '3l0zC00', NULL, NULL, 350, NULL, NULL, 235059),
(284556, '4kqiA02', NULL, NULL, 272, NULL, NULL, 235059),
(284557, '3u4gA00', NULL, NULL, 337, NULL, NULL, 235059),
(284558, '2v1nA01', NULL, NULL, 101, NULL, NULL, 235060),
(284559, '5woyA02', NULL, NULL, 126, NULL, NULL, 235061),
(284560, '2hroA02', NULL, NULL, 128, NULL, NULL, 235061),
(284561, '1zymA02', NULL, NULL, 126, NULL, NULL, 235061),
(284562, '4k7bA00', NULL, NULL, 124, NULL, NULL, 235062),
(284563, '4jc0A01', NULL, NULL, 138, NULL, NULL, 235063),
(284564, '1sauA02', NULL, NULL, 70, NULL, NULL, 235064),
(284565, '2xsjC02', NULL, NULL, 64, NULL, NULL, 235064),
(284566, '2v4jC02', NULL, NULL, 64, NULL, NULL, 235064),
(284567, '1yx3A02', NULL, NULL, 71, NULL, NULL, 235064),
(284568, '1ji8A02', NULL, NULL, 64, NULL, NULL, 235064),
(284569, '3or1C02', NULL, NULL, 64, NULL, NULL, 235064),
(284570, '2wzpP04', NULL, NULL, 33, NULL, NULL, 235065),
(284571, '1y64B01', NULL, NULL, 62, NULL, NULL, 235066),
(284572, '1ux5A01', NULL, NULL, 60, NULL, NULL, 235066),
(284573, '3qc7A02', NULL, NULL, 58, NULL, NULL, 235067),
(284574, '3a44C02', NULL, NULL, 21, NULL, NULL, 235068),
(284575, '5ol4A00', NULL, NULL, 100, NULL, NULL, 235069),
(284576, '3qgaA01', NULL, NULL, 103, NULL, NULL, 235069),
(284577, '4furA00', NULL, NULL, 104, NULL, NULL, 235069),
(284578, '1e9yA02', NULL, NULL, 101, NULL, NULL, 235069),
(284579, '4z42A00', NULL, NULL, 100, NULL, NULL, 235069),
(284580, '4ep8A00', NULL, NULL, 100, NULL, NULL, 235069),
(284581, '4gy7A01', NULL, NULL, 121, NULL, NULL, 235069),
(284582, '4g7eA01', NULL, NULL, 121, NULL, NULL, 235069),
(284583, '2fvhA00', NULL, NULL, 99, NULL, NULL, 235069),
(284584, '3deeA01', NULL, NULL, 86, NULL, NULL, 235070),
(284585, '5ysnA02', NULL, NULL, 87, NULL, NULL, 235071),
(284586, '2qezA02', NULL, NULL, 87, NULL, NULL, 235071),
(284587, '4fhdA01', NULL, NULL, 113, NULL, NULL, 235072),
(284588, '5mj3C00', NULL, NULL, 118, NULL, NULL, 235073);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(284589, '3gf3A01', NULL, NULL, 60, NULL, NULL, 235074),
(284590, '1pixA01', NULL, NULL, 59, NULL, NULL, 235074),
(284591, '5fu6E00', NULL, NULL, 197, NULL, NULL, 235075),
(284592, '5fu6C00', NULL, NULL, 148, NULL, NULL, 235075),
(284593, '4c0gB00', NULL, NULL, 102, NULL, NULL, 235075),
(284594, '4by6B00', NULL, NULL, 191, NULL, NULL, 235075),
(284595, '4by6C00', NULL, NULL, 215, NULL, NULL, 235075),
(284596, '4c0fC00', NULL, NULL, 117, NULL, NULL, 235075),
(284597, '1f46B00', NULL, NULL, 140, NULL, NULL, 235076),
(284598, '2uvpA00', NULL, NULL, 186, NULL, NULL, 235077),
(284599, '2uv9A01', NULL, NULL, 93, NULL, NULL, 235078),
(284600, '2uv8A01', NULL, NULL, 93, NULL, NULL, 235078),
(284601, '3rlfF03', NULL, NULL, 88, NULL, NULL, 235079),
(284602, '1gpjA03', NULL, NULL, 90, NULL, NULL, 235080),
(284603, '1kmiZ02', NULL, NULL, 134, NULL, NULL, 235081),
(284604, '2opeA00', NULL, NULL, 128, NULL, NULL, 235082),
(284605, '1zrtE02', NULL, NULL, 150, NULL, NULL, 235083),
(284606, '4qdcA01', NULL, NULL, 135, NULL, NULL, 235083),
(284607, '1g8kB00', NULL, NULL, 133, NULL, NULL, 235083),
(284608, '2ckfC02', NULL, NULL, 128, NULL, NULL, 235083),
(284609, '1fqtA00', NULL, NULL, 112, NULL, NULL, 235083),
(284610, '2zylA01', NULL, NULL, 135, NULL, NULL, 235083),
(284611, '2e74D02', NULL, NULL, 132, NULL, NULL, 235083),
(284612, '3gceA00', NULL, NULL, 121, NULL, NULL, 235083),
(284613, '5bokA00', NULL, NULL, 104, NULL, NULL, 235083),
(284614, '2jo6A00', NULL, NULL, 113, NULL, NULL, 235083),
(284615, '3n0qA02', NULL, NULL, 119, NULL, NULL, 235083),
(284616, '4ogqD02', NULL, NULL, 132, NULL, NULL, 235083),
(284617, '2b1xA02', NULL, NULL, 126, NULL, NULL, 235083),
(284618, '5nqdB00', NULL, NULL, 132, NULL, NULL, 235083),
(284619, '4hm8A02', NULL, NULL, 129, NULL, NULL, 235083),
(284620, '3en1A02', NULL, NULL, 127, NULL, NULL, 235083),
(284621, '1nykA00', NULL, NULL, 165, NULL, NULL, 235083),
(284622, '2bmoA02', NULL, NULL, 129, NULL, NULL, 235083),
(284623, '1uliA02', NULL, NULL, 127, NULL, NULL, 235083),
(284624, '1vm9A00', NULL, NULL, 111, NULL, NULL, 235083),
(284625, '3l74E02', NULL, NULL, 129, NULL, NULL, 235083),
(284626, '3dqyA00', NULL, NULL, 106, NULL, NULL, 235083),
(284627, '3cx5E02', NULL, NULL, 130, NULL, NULL, 235083),
(284628, '3c0dA00', NULL, NULL, 119, NULL, NULL, 235083),
(284629, '3d89A00', NULL, NULL, 157, NULL, NULL, 235083),
(284630, '2yiuC02', NULL, NULL, 145, NULL, NULL, 235083),
(284631, '2i7fA00', NULL, NULL, 108, NULL, NULL, 235083),
(284632, '3azcA00', NULL, NULL, 133, NULL, NULL, 235083),
(284633, '3gkeA01', NULL, NULL, 131, NULL, NULL, 235083),
(284634, '4nbgE00', NULL, NULL, 115, NULL, NULL, 235083),
(284635, '4qdfB01', NULL, NULL, 135, NULL, NULL, 235083),
(284636, '1wqlA02', NULL, NULL, 131, NULL, NULL, 235083),
(284637, '1jm1A00', NULL, NULL, 204, NULL, NULL, 235083),
(284638, '2gbwA02', NULL, NULL, 121, NULL, NULL, 235083),
(284639, '4aivA00', NULL, NULL, 119, NULL, NULL, 235083),
(284640, '5xteC02', NULL, NULL, 132, NULL, NULL, 235083),
(284641, '2e4qA00', NULL, NULL, 109, NULL, NULL, 235083),
(284642, '5aewA02', NULL, NULL, 131, NULL, NULL, 235083),
(284643, '1q90C00', NULL, NULL, 127, NULL, NULL, 235083),
(284644, '1rieA00', NULL, NULL, 129, NULL, NULL, 235083),
(284645, '2qpzA00', NULL, NULL, 103, NULL, NULL, 235083),
(284646, '5cxmA00', NULL, NULL, 110, NULL, NULL, 235083),
(284647, '3vcaA02', NULL, NULL, 119, NULL, NULL, 235083),
(284648, '3gzxA02', NULL, NULL, 131, NULL, NULL, 235083),
(284649, '2jzaA01', NULL, NULL, 118, NULL, NULL, 235083),
(284650, '2nwfA00', NULL, NULL, 141, NULL, NULL, 235083),
(284651, '1rfsA00', NULL, NULL, 139, NULL, NULL, 235083),
(284652, '4g4sO01', NULL, NULL, 208, NULL, NULL, 235084),
(284653, '1hx6A01', NULL, NULL, 242, NULL, NULL, 235085),
(284654, '1yrtA01', NULL, NULL, 155, NULL, NULL, 235086),
(284655, '2a3dA00', NULL, NULL, 73, NULL, NULL, 235087),
(284656, '2fm8B00', NULL, NULL, 135, NULL, NULL, 235088),
(284657, '2bsjB00', NULL, NULL, 133, NULL, NULL, 235088),
(284658, '4g6tA00', NULL, NULL, 128, NULL, NULL, 235088),
(284659, '1n5bB00', NULL, NULL, 132, NULL, NULL, 235088);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(284660, '3cxjA00', NULL, NULL, 146, NULL, NULL, 235088),
(284661, '4jmfB00', NULL, NULL, 116, NULL, NULL, 235088),
(284662, '1jyaB00', NULL, NULL, 130, NULL, NULL, 235088),
(284663, '1k3sA00', NULL, NULL, 113, NULL, NULL, 235088),
(284664, '1s28A00', NULL, NULL, 132, NULL, NULL, 235088),
(284665, '2plgA01', NULL, NULL, 141, NULL, NULL, 235088),
(284666, '3kxyJ00', NULL, NULL, 133, NULL, NULL, 235088),
(284667, '1xkpB00', NULL, NULL, 124, NULL, NULL, 235088),
(284668, '1xkpC00', NULL, NULL, 127, NULL, NULL, 235088),
(284669, '3tu3A00', NULL, NULL, 119, NULL, NULL, 235088),
(284670, '3epuA00', NULL, NULL, 144, NULL, NULL, 235088),
(284671, '1jyoA00', NULL, NULL, 130, NULL, NULL, 235088),
(284672, '1k3eB02', NULL, NULL, 105, NULL, NULL, 235088),
(284673, '1ry9A00', NULL, NULL, 145, NULL, NULL, 235088),
(284674, '4gf3A00', NULL, NULL, 141, NULL, NULL, 235088),
(284675, '1zcjA01', NULL, NULL, 32, NULL, NULL, 235089),
(284676, '2b5dX02', NULL, NULL, 114, NULL, NULL, 235090),
(284677, '3n98A02', NULL, NULL, 146, NULL, NULL, 235090),
(284678, '5wu7A02', NULL, NULL, 133, NULL, NULL, 235090),
(284679, '3p0bA02', NULL, NULL, 107, NULL, NULL, 235090),
(284680, '2e62A01', NULL, NULL, 52, NULL, NULL, 235091),
(284681, '2lz1A00', NULL, NULL, 90, NULL, NULL, 235092),
(284682, '1k1vA00', NULL, NULL, 41, NULL, NULL, 235092),
(284683, '2kz5A00', NULL, NULL, 91, NULL, NULL, 235092),
(284684, '1sknP00', NULL, NULL, 92, NULL, NULL, 235092),
(284685, '3zghA00', NULL, NULL, 184, NULL, NULL, 235093),
(284686, '2wjnH02', NULL, NULL, 139, NULL, NULL, 235094),
(284687, '1rzhH02', NULL, NULL, 144, NULL, NULL, 235094),
(284688, '5y5sH02', NULL, NULL, 140, NULL, NULL, 235094),
(284689, '2ve7A02', NULL, NULL, 138, NULL, NULL, 235095),
(284690, '1k8kE00', NULL, NULL, 178, NULL, NULL, 235096),
(284691, '4j8lA02', NULL, NULL, 114, NULL, NULL, 235097),
(284692, '1zldA00', NULL, NULL, 118, NULL, NULL, 235098),
(284693, '1devB00', NULL, NULL, 41, NULL, NULL, 235099),
(284694, '3i5qA02', NULL, NULL, 81, NULL, NULL, 235100),
(284695, '1oxjA02', NULL, NULL, 110, NULL, NULL, 235101),
(284696, '4ww7B00', NULL, NULL, 187, NULL, NULL, 235102),
(284697, '3enpA00', NULL, NULL, 177, NULL, NULL, 235102),
(284698, '1zd0A01', NULL, NULL, 135, NULL, NULL, 235102),
(284699, '3enhC01', NULL, NULL, 142, NULL, NULL, 235102),
(284700, '3uuxB01', NULL, NULL, 124, NULL, NULL, 235103),
(284701, '1lmlA04', NULL, NULL, 105, NULL, NULL, 235104),
(284702, '1bdsA00', NULL, NULL, 43, NULL, NULL, 235105),
(284703, '2h9xA00', NULL, NULL, 47, NULL, NULL, 235105),
(284704, '1b8wA00', NULL, NULL, 42, NULL, NULL, 235105),
(284705, '1sh1A00', NULL, NULL, 48, NULL, NULL, 235105),
(284706, '1apfA00', NULL, NULL, 49, NULL, NULL, 235105),
(284707, '1wqkA00', NULL, NULL, 42, NULL, NULL, 235105),
(284708, '1ahlA00', NULL, NULL, 49, NULL, NULL, 235105),
(284709, '4gv5A00', NULL, NULL, 42, NULL, NULL, 235105),
(284710, '1wxnA00', NULL, NULL, 42, NULL, NULL, 235105),
(284711, '2rngA02', NULL, NULL, 40, NULL, NULL, 235105),
(284712, '1atxA00', NULL, NULL, 46, NULL, NULL, 235105),
(284713, '1zlhB02', NULL, NULL, 37, NULL, NULL, 235105),
(284714, '1d6bA00', NULL, NULL, 42, NULL, NULL, 235105),
(284715, '2mn3A00', NULL, NULL, 44, NULL, NULL, 235105),
(284716, '2wadA01', NULL, NULL, 30, NULL, NULL, 235106),
(284717, '3u2aA00', NULL, NULL, 129, NULL, NULL, 235107),
(284718, '3d37B01', NULL, NULL, 188, NULL, NULL, 235108),
(284719, '1wruA01', NULL, NULL, 177, NULL, NULL, 235108),
(284720, '3cddF01', NULL, NULL, 199, NULL, NULL, 235108),
(284721, '3tndB01', NULL, NULL, 41, NULL, NULL, 235109),
(284722, '3o27B00', NULL, NULL, 68, NULL, NULL, 235109),
(284723, '2fy9A00', NULL, NULL, 54, NULL, NULL, 235109),
(284724, '1mvfD00', NULL, NULL, 47, NULL, NULL, 235109),
(284725, '1ub4C00', NULL, NULL, 85, NULL, NULL, 235109),
(284726, '5itmA00', NULL, NULL, 48, NULL, NULL, 235109),
(284727, '2w1tA01', NULL, NULL, 49, NULL, NULL, 235109),
(284728, '1yfbA00', NULL, NULL, 59, NULL, NULL, 235109),
(284729, '1z0rA00', NULL, NULL, 53, NULL, NULL, 235109),
(284730, '3gocA00', NULL, NULL, 237, NULL, NULL, 235110);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(284731, '4xpuB00', NULL, NULL, 217, NULL, NULL, 235110),
(284732, '3ga2A00', NULL, NULL, 246, NULL, NULL, 235110),
(284733, '2w36A00', NULL, NULL, 225, NULL, NULL, 235110),
(284734, '4nspA00', NULL, NULL, 250, NULL, NULL, 235110),
(284735, '2qh9A00', NULL, NULL, 184, NULL, NULL, 235110),
(284736, '5aoyA00', NULL, NULL, 250, NULL, NULL, 235110),
(284737, '1wkcA00', NULL, NULL, 184, NULL, NULL, 235111),
(284738, '2jcbB00', NULL, NULL, 200, NULL, NULL, 235111),
(284739, '3hy3A00', NULL, NULL, 203, NULL, NULL, 235111),
(284740, '1sbqA00', NULL, NULL, 164, NULL, NULL, 235111),
(284741, '1souA00', NULL, NULL, 194, NULL, NULL, 235111),
(284742, '1ydmB00', NULL, NULL, 187, NULL, NULL, 235111),
(284743, '2g40A00', NULL, NULL, 175, NULL, NULL, 235111),
(284744, '3abqB01', NULL, NULL, 26, NULL, NULL, 235112),
(284745, '2cwoA02', NULL, NULL, 83, NULL, NULL, 235113),
(284746, '2wb6A00', NULL, NULL, 130, NULL, NULL, 235114),
(284747, '1pfkA02', NULL, NULL, 126, NULL, NULL, 235115),
(284748, '3o8oA02', NULL, NULL, 157, NULL, NULL, 235115),
(284749, '3o8oB02', NULL, NULL, 158, NULL, NULL, 235115),
(284750, '5xz7A02', NULL, NULL, 123, NULL, NULL, 235115),
(284751, '3o8oB04', NULL, NULL, 154, NULL, NULL, 235115),
(284752, '3k2qA02', NULL, NULL, 189, NULL, NULL, 235115),
(284753, '4i7eA02', NULL, NULL, 125, NULL, NULL, 235115),
(284754, '3hnoD02', NULL, NULL, 189, NULL, NULL, 235115),
(284755, '3o8oG04', NULL, NULL, 165, NULL, NULL, 235115),
(284756, '3opyB05', NULL, NULL, 150, NULL, NULL, 235115),
(284757, '3opyA05', NULL, NULL, 153, NULL, NULL, 235115),
(284758, '1zxxA02', NULL, NULL, 125, NULL, NULL, 235115),
(284759, '3opyB03', NULL, NULL, 153, NULL, NULL, 235115),
(284760, '4u1rA04', NULL, NULL, 144, NULL, NULL, 235115),
(284761, '4u1rA02', NULL, NULL, 155, NULL, NULL, 235115),
(284762, '2higB03', NULL, NULL, 163, NULL, NULL, 235115),
(284763, '3opyA03', NULL, NULL, 159, NULL, NULL, 235115),
(284764, '2f48A02', NULL, NULL, 188, NULL, NULL, 235115),
(284765, '4a3sA02', NULL, NULL, 125, NULL, NULL, 235115),
(284766, '3o8lA04', NULL, NULL, 153, NULL, NULL, 235115),
(284767, '3o8lA02', NULL, NULL, 155, NULL, NULL, 235115),
(284768, '6a95B00', NULL, NULL, 57, NULL, NULL, 235116),
(284769, '3ci0J01', NULL, NULL, 113, NULL, NULL, 235117),
(284770, '6hr7A03', NULL, NULL, 120, NULL, NULL, 235118),
(284771, '4i6yA02', NULL, NULL, 110, NULL, NULL, 235118),
(284772, '2r4fA03', NULL, NULL, 117, NULL, NULL, 235118),
(284773, '3qauA02', NULL, NULL, 109, NULL, NULL, 235118),
(284774, '2a9uA01', NULL, NULL, 129, NULL, NULL, 235119),
(284775, '4it4A02', NULL, NULL, 91, NULL, NULL, 235119),
(284776, '1wcrA00', NULL, NULL, 103, NULL, NULL, 235119),
(284777, '2w2uA00', NULL, NULL, 83, NULL, NULL, 235119),
(284778, '3eabD01', NULL, NULL, 88, NULL, NULL, 235119),
(284779, '3zssA02', NULL, NULL, 79, NULL, NULL, 235119),
(284780, '3k1sF00', NULL, NULL, 109, NULL, NULL, 235119),
(284781, '3k1sG00', NULL, NULL, 109, NULL, NULL, 235119),
(284782, '2xzeB00', NULL, NULL, 146, NULL, NULL, 235119),
(284783, '3k1sH00', NULL, NULL, 109, NULL, NULL, 235119),
(284784, '5fvkA00', NULL, NULL, 82, NULL, NULL, 235119),
(284785, '4u33A02', NULL, NULL, 81, NULL, NULL, 235119),
(284786, '3k1sI00', NULL, NULL, 109, NULL, NULL, 235119),
(284787, '4u7yA00', NULL, NULL, 90, NULL, NULL, 235119),
(284788, '3k1sB00', NULL, NULL, 109, NULL, NULL, 235119),
(284789, '3k1sC00', NULL, NULL, 109, NULL, NULL, 235119),
(284790, '3k1sD00', NULL, NULL, 109, NULL, NULL, 235119),
(284791, '3k1sE00', NULL, NULL, 109, NULL, NULL, 235119),
(284792, '2mpkA00', NULL, NULL, 74, NULL, NULL, 235119),
(284793, '2crbA00', NULL, NULL, 97, NULL, NULL, 235119),
(284794, '3k1sA00', NULL, NULL, 109, NULL, NULL, 235119),
(284795, '4a5xA00', NULL, NULL, 86, NULL, NULL, 235119),
(284796, '2v6yA00', NULL, NULL, 83, NULL, NULL, 235119),
(284797, '2e2aC00', NULL, NULL, 105, NULL, NULL, 235119),
(284798, '5lb7B00', NULL, NULL, 80, NULL, NULL, 235119),
(284799, '4wzxA01', NULL, NULL, 78, NULL, NULL, 235119),
(284800, '2rpaA00', NULL, NULL, 78, NULL, NULL, 235119),
(284801, '4u7iA00', NULL, NULL, 95, NULL, NULL, 235119);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(284802, '1wfdA00', NULL, NULL, 93, NULL, NULL, 235119),
(284803, '5cgmA02', NULL, NULL, 81, NULL, NULL, 235119),
(284804, '1yxrA01', NULL, NULL, 74, NULL, NULL, 235119),
(284805, '3l8rA00', NULL, NULL, 103, NULL, NULL, 235119),
(284806, '4zeyA00', NULL, NULL, 84, NULL, NULL, 235119),
(284807, '2mysA06', NULL, NULL, 133, NULL, NULL, 235120),
(284808, '4anjA06', NULL, NULL, 113, NULL, NULL, 235120),
(284809, '4i9qA05', NULL, NULL, 83, NULL, NULL, 235121),
(284810, '2oyqD05', NULL, NULL, 101, NULL, NULL, 235121),
(284811, '3qexA05', NULL, NULL, 68, NULL, NULL, 235121),
(284812, '3tdnA00', NULL, NULL, 126, NULL, NULL, 235122),
(284813, '2ze3A02', NULL, NULL, 43, NULL, NULL, 235123),
(284814, '4k05A01', NULL, NULL, 245, NULL, NULL, 235124),
(284815, '2w00A06', NULL, NULL, 42, NULL, NULL, 235125),
(284816, '2hivA01', NULL, NULL, 231, NULL, NULL, 235126),
(284817, '4htpA00', NULL, NULL, 240, NULL, NULL, 235126),
(284818, '4eq5A01', NULL, NULL, 191, NULL, NULL, 235126),
(284819, '3rr5A01', NULL, NULL, 231, NULL, NULL, 235126),
(284820, '3l2pA01', NULL, NULL, 205, NULL, NULL, 235126),
(284821, '1x9nA01', NULL, NULL, 283, NULL, NULL, 235126),
(284822, '3gdeA01', NULL, NULL, 224, NULL, NULL, 235126),
(284823, '2cfmA01', NULL, NULL, 220, NULL, NULL, 235126),
(284824, '6ei3A00', NULL, NULL, 514, NULL, NULL, 235127),
(284825, '4zw9A00', NULL, NULL, 470, NULL, NULL, 235127),
(284826, '4oh3A00', NULL, NULL, 534, NULL, NULL, 235127),
(284827, '4j05A00', NULL, NULL, 432, NULL, NULL, 235127),
(284828, '4ja3A03', NULL, NULL, 190, NULL, NULL, 235127),
(284829, '3o7qA02', NULL, NULL, 195, NULL, NULL, 235127),
(284830, '3o7qA01', NULL, NULL, 222, NULL, NULL, 235127),
(284831, '3wdoA01', NULL, NULL, 392, NULL, NULL, 235127),
(284832, '1pw4A02', NULL, NULL, 213, NULL, NULL, 235127),
(284833, '1pw4A01', NULL, NULL, 209, NULL, NULL, 235127),
(284834, '4uvmA00', NULL, NULL, 524, NULL, NULL, 235127),
(284835, '4yb9D00', NULL, NULL, 444, NULL, NULL, 235127),
(284836, '4tpjA00', NULL, NULL, 492, NULL, NULL, 235127),
(284837, '4w6vA00', NULL, NULL, 502, NULL, NULL, 235127),
(284838, '4u4vA02', NULL, NULL, 238, NULL, NULL, 235127),
(284839, '4ldsA00', NULL, NULL, 427, NULL, NULL, 235127),
(284840, '4u4vA01', NULL, NULL, 237, NULL, NULL, 235127),
(284841, '4jr9A00', NULL, NULL, 466, NULL, NULL, 235127),
(284842, '4ikvA00', NULL, NULL, 507, NULL, NULL, 235127),
(284843, '4q65A00', NULL, NULL, 493, NULL, NULL, 235127),
(284844, '2y5yB02', NULL, NULL, 205, NULL, NULL, 235127),
(284845, '4qiqA00', NULL, NULL, 479, NULL, NULL, 235127),
(284846, '6gs4A00', NULL, NULL, 472, NULL, NULL, 235127),
(284847, '5eqgA00', NULL, NULL, 455, NULL, NULL, 235127),
(284848, '5oxoA00', NULL, NULL, 490, NULL, NULL, 235127),
(284849, '4gc0A02', NULL, NULL, 238, NULL, NULL, 235127),
(284850, '4gc0A01', NULL, NULL, 253, NULL, NULL, 235127),
(284851, '4iu9A00', NULL, NULL, 468, NULL, NULL, 235127),
(284852, '4iu9B01', NULL, NULL, 235, NULL, NULL, 235127),
(284853, '4iu9B02', NULL, NULL, 227, NULL, NULL, 235127),
(284854, '4ybqA00', NULL, NULL, 480, NULL, NULL, 235127),
(284855, '2cfqA02', NULL, NULL, 212, NULL, NULL, 235127),
(284856, '2cfqA01', NULL, NULL, 205, NULL, NULL, 235127),
(284857, '3cesB02', NULL, NULL, 150, NULL, NULL, 235128),
(284858, '3cp8A02', NULL, NULL, 139, NULL, NULL, 235128),
(284859, '3cp2A02', NULL, NULL, 99, NULL, NULL, 235128),
(284860, '2zxiD02', NULL, NULL, 145, NULL, NULL, 235128),
(284861, '3jskA01', NULL, NULL, 31, NULL, NULL, 235129),
(284862, '3fpzA01', NULL, NULL, 31, NULL, NULL, 235129),
(284863, '1regX00', NULL, NULL, 122, NULL, NULL, 235130),
(284864, '3zrhA01', NULL, NULL, 97, NULL, NULL, 235131),
(284865, '4v02C00', NULL, NULL, 128, NULL, NULL, 235132),
(284866, '1k8fA00', NULL, NULL, 157, NULL, NULL, 235132),
(284867, '3bh7B01', NULL, NULL, 193, NULL, NULL, 235132),
(284868, '2yuhA01', NULL, NULL, 172, NULL, NULL, 235132),
(284869, '2b0rB00', NULL, NULL, 168, NULL, NULL, 235132),
(284870, '1hf2C02', NULL, NULL, 123, NULL, NULL, 235132),
(284871, '1k4zA00', NULL, NULL, 159, NULL, NULL, 235132),
(284872, '2fa8B00', NULL, NULL, 105, NULL, NULL, 235133);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(284873, '1q98A00', NULL, NULL, 165, NULL, NULL, 235133),
(284874, '2dlxA01', NULL, NULL, 113, NULL, NULL, 235133),
(284875, '3vwvA00', NULL, NULL, 190, NULL, NULL, 235133),
(284876, '3i9v202', NULL, NULL, 107, NULL, NULL, 235133),
(284877, '4wxtA00', NULL, NULL, 125, NULL, NULL, 235133),
(284878, '4gltA01', NULL, NULL, 95, NULL, NULL, 235133),
(284879, '3ga4A00', NULL, NULL, 178, NULL, NULL, 235133),
(284880, '2obiA00', NULL, NULL, 165, NULL, NULL, 235133),
(284881, '1egoA00', NULL, NULL, 85, NULL, NULL, 235133),
(284882, '2in3A01', NULL, NULL, 89, NULL, NULL, 235133),
(284883, '2h66E00', NULL, NULL, 161, NULL, NULL, 235133),
(284884, '4pngB01', NULL, NULL, 86, NULL, NULL, 235133),
(284885, '4isdA01', NULL, NULL, 111, NULL, NULL, 235133),
(284886, '1a0rP01', NULL, NULL, 129, NULL, NULL, 235133),
(284887, '5y7iA01', NULL, NULL, 95, NULL, NULL, 235133),
(284888, '3m3mA01', NULL, NULL, 81, NULL, NULL, 235133),
(284889, '3mdkB01', NULL, NULL, 111, NULL, NULL, 235133),
(284890, '4zxgA01', NULL, NULL, 83, NULL, NULL, 235133),
(284891, '3ed3B02', NULL, NULL, 155, NULL, NULL, 235133),
(284892, '4o7hA01', NULL, NULL, 102, NULL, NULL, 235133),
(284893, '1t1vA00', NULL, NULL, 93, NULL, NULL, 235133),
(284894, '5a4uA01', NULL, NULL, 87, NULL, NULL, 235133),
(284895, '2j23A00', NULL, NULL, 121, NULL, NULL, 235133),
(284896, '4wkwB00', NULL, NULL, 199, NULL, NULL, 235133),
(284897, '3h79A00', NULL, NULL, 127, NULL, NULL, 235133),
(284898, '1z9hA01', NULL, NULL, 92, NULL, NULL, 235133),
(284899, '2c0gA01', NULL, NULL, 136, NULL, NULL, 235133),
(284900, '4la1A01', NULL, NULL, 111, NULL, NULL, 235133),
(284901, '1jzoA02', NULL, NULL, 139, NULL, NULL, 235133),
(284902, '3ixrA00', NULL, NULL, 162, NULL, NULL, 235133),
(284903, '1z6nA00', NULL, NULL, 167, NULL, NULL, 235133),
(284904, '3h8qA00', NULL, NULL, 114, NULL, NULL, 235133),
(284905, '1m0uA01', NULL, NULL, 91, NULL, NULL, 235133),
(284906, '4fo5A00', NULL, NULL, 143, NULL, NULL, 235133),
(284907, '2h8lA01', NULL, NULL, 118, NULL, NULL, 235133),
(284908, '4gtuA01', NULL, NULL, 112, NULL, NULL, 235133),
(284909, '2h8lA02', NULL, NULL, 112, NULL, NULL, 235133),
(284910, '4ruvA00', NULL, NULL, 114, NULL, NULL, 235133),
(284911, '4d73B00', NULL, NULL, 180, NULL, NULL, 235133),
(284912, '4i8bA00', NULL, NULL, 105, NULL, NULL, 235133),
(284913, '1vglB00', NULL, NULL, 108, NULL, NULL, 235133),
(284914, '5ld0A01', NULL, NULL, 113, NULL, NULL, 235133),
(284915, '2r37B00', NULL, NULL, 207, NULL, NULL, 235133),
(284916, '5c04A00', NULL, NULL, 153, NULL, NULL, 235133),
(284917, '3kjyA01', NULL, NULL, 115, NULL, NULL, 235133),
(284918, '3lxzA01', NULL, NULL, 80, NULL, NULL, 235133),
(284919, '2qgvA00', NULL, NULL, 140, NULL, NULL, 235133),
(284920, '2lrcA00', NULL, NULL, 114, NULL, NULL, 235133),
(284921, '3fw2A00', NULL, NULL, 150, NULL, NULL, 235133),
(284922, '1r5aA01', NULL, NULL, 79, NULL, NULL, 235133),
(284923, '2pwjA00', NULL, NULL, 171, NULL, NULL, 235133),
(284924, '1b4pA01', NULL, NULL, 112, NULL, NULL, 235133),
(284925, '2ju5A01', NULL, NULL, 124, NULL, NULL, 235133),
(284926, '2ht9B00', NULL, NULL, 111, NULL, NULL, 235133),
(284927, '6j3gB01', NULL, NULL, 117, NULL, NULL, 235133),
(284928, '2m80A00', NULL, NULL, 117, NULL, NULL, 235133),
(284929, '4qq7A01', NULL, NULL, 99, NULL, NULL, 235133),
(284930, '3cbuA01', NULL, NULL, 78, NULL, NULL, 235133),
(284931, '5hqpD02', NULL, NULL, 101, NULL, NULL, 235133),
(284932, '2khpA00', NULL, NULL, 92, NULL, NULL, 235133),
(284933, '5xbsD01', NULL, NULL, 146, NULL, NULL, 235133),
(284934, '6mwsA00', NULL, NULL, 115, NULL, NULL, 235133),
(284935, '3vurA01', NULL, NULL, 91, NULL, NULL, 235133),
(284936, '5hqpD01', NULL, NULL, 117, NULL, NULL, 235133),
(284937, '2trcP01', NULL, NULL, 134, NULL, NULL, 235133),
(284938, '2vafA01', NULL, NULL, 112, NULL, NULL, 235133),
(284939, '3eytB00', NULL, NULL, 158, NULL, NULL, 235133),
(284940, '2lnsA00', NULL, NULL, 140, NULL, NULL, 235133),
(284941, '3gmfA01', NULL, NULL, 102, NULL, NULL, 235133),
(284942, '4fh8E00', NULL, NULL, 175, NULL, NULL, 235133),
(284943, '2ynxA00', NULL, NULL, 106, NULL, NULL, 235133);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(284944, '1e2yF00', NULL, NULL, 166, NULL, NULL, 235133),
(284945, '3vk9A01', NULL, NULL, 80, NULL, NULL, 235133),
(284946, '4exjB01', NULL, NULL, 117, NULL, NULL, 235133),
(284947, '2f9sB00', NULL, NULL, 151, NULL, NULL, 235133),
(284948, '1t3bA02', NULL, NULL, 162, NULL, NULL, 235133),
(284949, '4fiwA00', NULL, NULL, 77, NULL, NULL, 235133),
(284950, '2yv9A01', NULL, NULL, 110, NULL, NULL, 235133),
(284951, '1m2dA00', NULL, NULL, 110, NULL, NULL, 235133),
(284952, '2yanA01', NULL, NULL, 97, NULL, NULL, 235133),
(284953, '1f2eA01', NULL, NULL, 95, NULL, NULL, 235133),
(284954, '2ljaA00', NULL, NULL, 152, NULL, NULL, 235133),
(284955, '2dc5A01', NULL, NULL, 126, NULL, NULL, 235133),
(284956, '2obkF00', NULL, NULL, 103, NULL, NULL, 235133),
(284957, '2jacA00', NULL, NULL, 110, NULL, NULL, 235133),
(284958, '5zfgA01', NULL, NULL, 80, NULL, NULL, 235133),
(284959, '2r2jA03', NULL, NULL, 163, NULL, NULL, 235133),
(284960, '5kqaA00', NULL, NULL, 115, NULL, NULL, 235133),
(284961, '4ju5A01', NULL, NULL, 105, NULL, NULL, 235133),
(284962, '3ir4A01', NULL, NULL, 78, NULL, NULL, 235133),
(284963, '3ia1B00', NULL, NULL, 154, NULL, NULL, 235133),
(284964, '4grfA00', NULL, NULL, 152, NULL, NULL, 235133),
(284965, '4npbA02', NULL, NULL, 139, NULL, NULL, 235133),
(284966, '5crwA02', NULL, NULL, 123, NULL, NULL, 235133),
(284967, '3fz5B00', NULL, NULL, 202, NULL, NULL, 235133),
(284968, '3zrdB00', NULL, NULL, 166, NULL, NULL, 235133),
(284969, '3d22A00', NULL, NULL, 139, NULL, NULL, 235133),
(284970, '3kzqA00', NULL, NULL, 208, NULL, NULL, 235133),
(284971, '3dexH00', NULL, NULL, 107, NULL, NULL, 235133),
(284972, '1zgmA01', NULL, NULL, 103, NULL, NULL, 235133),
(284973, '4nmuD00', NULL, NULL, 147, NULL, NULL, 235133),
(284974, '4j2fA01', NULL, NULL, 86, NULL, NULL, 235133),
(284975, '6g2jS00', NULL, NULL, 99, NULL, NULL, 235133),
(284976, '2cz2A01', NULL, NULL, 78, NULL, NULL, 235133),
(284977, '5yx1A01', NULL, NULL, 90, NULL, NULL, 235133),
(284978, '2cvbA00', NULL, NULL, 188, NULL, NULL, 235133),
(284979, '3kgkB00', NULL, NULL, 110, NULL, NULL, 235133),
(284980, '5crwA01', NULL, NULL, 124, NULL, NULL, 235133),
(284981, '3uvtC00', NULL, NULL, 111, NULL, NULL, 235133),
(284982, '2b5xA00', NULL, NULL, 148, NULL, NULL, 235133),
(284983, '2h30A00', NULL, NULL, 164, NULL, NULL, 235133),
(284984, '4eo3A01', NULL, NULL, 139, NULL, NULL, 235133),
(284985, '4nhzB01', NULL, NULL, 140, NULL, NULL, 235133),
(284986, '3vfiA00', NULL, NULL, 104, NULL, NULL, 235133),
(284987, '3c7mA00', NULL, NULL, 195, NULL, NULL, 235133),
(284988, '3gkxB00', NULL, NULL, 120, NULL, NULL, 235133),
(284989, '5imaA00', NULL, NULL, 160, NULL, NULL, 235133),
(284990, '2qsiA01', NULL, NULL, 83, NULL, NULL, 235133),
(284991, '2hyxA01', NULL, NULL, 201, NULL, NULL, 235133),
(284992, '2av4A00', NULL, NULL, 160, NULL, NULL, 235133),
(284993, '2zctA01', NULL, NULL, 145, NULL, NULL, 235133),
(284994, '5xbrA01', NULL, NULL, 144, NULL, NULL, 235133),
(284995, '5h5lB01', NULL, NULL, 91, NULL, NULL, 235133),
(284996, '1xccD01', NULL, NULL, 152, NULL, NULL, 235133),
(284997, '6bo0A00', NULL, NULL, 200, NULL, NULL, 235133),
(284998, '3ubkA01', NULL, NULL, 82, NULL, NULL, 235133),
(284999, '4jrrB00', NULL, NULL, 189, NULL, NULL, 235133),
(285000, '2dj3A01', NULL, NULL, 109, NULL, NULL, 235133),
(285001, '1v57A03', NULL, NULL, 155, NULL, NULL, 235133),
(285002, '3fz4A00', NULL, NULL, 120, NULL, NULL, 235133),
(285003, '3f0iA00', NULL, NULL, 119, NULL, NULL, 235133),
(285004, '5hr1G00', NULL, NULL, 81, NULL, NULL, 235133),
(285005, '4mzcA00', NULL, NULL, 111, NULL, NULL, 235133),
(285006, '5f0gA01', NULL, NULL, 77, NULL, NULL, 235133),
(285007, '4tw5A01', NULL, NULL, 122, NULL, NULL, 235133),
(285008, '1u6tA00', NULL, NULL, 121, NULL, NULL, 235133),
(285009, '4f0bA01', NULL, NULL, 112, NULL, NULL, 235133),
(285010, '6q6tA00', NULL, NULL, 113, NULL, NULL, 235133),
(285011, '4wbjA00', NULL, NULL, 164, NULL, NULL, 235133),
(285012, '5jy5A00', NULL, NULL, 110, NULL, NULL, 235133),
(285013, '3r2qA01', NULL, NULL, 89, NULL, NULL, 235133),
(285014, '1pn9A01', NULL, NULL, 77, NULL, NULL, 235133);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(285015, '4hqsA00', NULL, NULL, 136, NULL, NULL, 235133),
(285016, '2imiB01', NULL, NULL, 80, NULL, NULL, 235133),
(285017, '4p3yB00', NULL, NULL, 182, NULL, NULL, 235133),
(285018, '4cw9B00', NULL, NULL, 109, NULL, NULL, 235133),
(285019, '5lolA01', NULL, NULL, 90, NULL, NULL, 235133),
(285020, '2ct6A00', NULL, NULL, 111, NULL, NULL, 235133),
(285021, '3zl5E00', NULL, NULL, 161, NULL, NULL, 235133),
(285022, '1i5gA00', NULL, NULL, 144, NULL, NULL, 235133),
(285023, '6ji6A01', NULL, NULL, 108, NULL, NULL, 235133),
(285024, '4ip6A00', NULL, NULL, 132, NULL, NULL, 235133),
(285025, '3m8nD01', NULL, NULL, 104, NULL, NULL, 235133),
(285026, '3t58C01', NULL, NULL, 131, NULL, NULL, 235133),
(285027, '2k8sA00', NULL, NULL, 80, NULL, NULL, 235133),
(285028, '1xvqA00', NULL, NULL, 175, NULL, NULL, 235133),
(285029, '4f0cA01', NULL, NULL, 91, NULL, NULL, 235133),
(285030, '3hjpA00', NULL, NULL, 164, NULL, NULL, 235133),
(285031, '2remB00', NULL, NULL, 193, NULL, NULL, 235133),
(285032, '1x5eA01', NULL, NULL, 109, NULL, NULL, 235133),
(285033, '2yzuA00', NULL, NULL, 109, NULL, NULL, 235133),
(285034, '3bj5A00', NULL, NULL, 147, NULL, NULL, 235133),
(285035, '4ecjA01', NULL, NULL, 96, NULL, NULL, 235133),
(285036, '3nivC01', NULL, NULL, 78, NULL, NULL, 235133),
(285037, '6bkvB00', NULL, NULL, 114, NULL, NULL, 235133),
(285038, '3drnB00', NULL, NULL, 161, NULL, NULL, 235133),
(285039, '3nznA00', NULL, NULL, 103, NULL, NULL, 235133),
(285040, '3l9sA00', NULL, NULL, 191, NULL, NULL, 235133),
(285041, '4owyA00', NULL, NULL, 174, NULL, NULL, 235133),
(285042, '3c8eB01', NULL, NULL, 131, NULL, NULL, 235133),
(285043, '3w8sA01', NULL, NULL, 91, NULL, NULL, 235133),
(285044, '2okaA00', NULL, NULL, 87, NULL, NULL, 235133),
(285045, '2pn8H00', NULL, NULL, 193, NULL, NULL, 235133),
(285046, '4i5qA02', NULL, NULL, 139, NULL, NULL, 235133),
(285047, '5an1A01', NULL, NULL, 116, NULL, NULL, 235133),
(285048, '4mjeA01', NULL, NULL, 89, NULL, NULL, 235133),
(285049, '4o92A01', NULL, NULL, 101, NULL, NULL, 235133),
(285050, '4yapA01', NULL, NULL, 129, NULL, NULL, 235133),
(285051, '4euyA00', NULL, NULL, 105, NULL, NULL, 235133),
(285052, '4bpyA00', NULL, NULL, 175, NULL, NULL, 235133),
(285053, '3dieA01', NULL, NULL, 76, NULL, NULL, 235133),
(285054, '5zvlB00', NULL, NULL, 108, NULL, NULL, 235133),
(285055, '5oomk00', NULL, NULL, 96, NULL, NULL, 235133),
(285056, '4kh7B01', NULL, NULL, 89, NULL, NULL, 235133),
(285057, '1sjiA01', NULL, NULL, 124, NULL, NULL, 235133),
(285058, '1qq2A00', NULL, NULL, 175, NULL, NULL, 235133),
(285059, '1sjiA03', NULL, NULL, 124, NULL, NULL, 235133),
(285060, '1sjiA02', NULL, NULL, 102, NULL, NULL, 235133),
(285061, '3kp8A00', NULL, NULL, 106, NULL, NULL, 235133),
(285062, '1hyuA02', NULL, NULL, 95, NULL, NULL, 235133),
(285063, '1hyuA04', NULL, NULL, 94, NULL, NULL, 235133),
(285064, '2dmlA01', NULL, NULL, 118, NULL, NULL, 235133),
(285065, '3f3qA00', NULL, NULL, 109, NULL, NULL, 235133),
(285066, '3tdgA02', NULL, NULL, 142, NULL, NULL, 235133),
(285067, '2fheA01', NULL, NULL, 107, NULL, NULL, 235133),
(285068, '1a8lA01', NULL, NULL, 117, NULL, NULL, 235133),
(285069, '3lefA00', NULL, NULL, 172, NULL, NULL, 235133),
(285070, '1a8lA02', NULL, NULL, 106, NULL, NULL, 235133),
(285071, '4agsA03', NULL, NULL, 85, NULL, NULL, 235133),
(285072, '4agsA01', NULL, NULL, 85, NULL, NULL, 235133),
(285073, '4gciA01', NULL, NULL, 104, NULL, NULL, 235133),
(285074, '4lmwA01', NULL, NULL, 106, NULL, NULL, 235133),
(285075, '5epfA00', NULL, NULL, 162, NULL, NULL, 235133),
(285076, '5kn3A03', NULL, NULL, 133, NULL, NULL, 235133),
(285077, '3feuA00', NULL, NULL, 185, NULL, NULL, 235133),
(285078, '5kn3A02', NULL, NULL, 102, NULL, NULL, 235133),
(285079, '1fo5A00', NULL, NULL, 85, NULL, NULL, 235133),
(285080, '3f9uA00', NULL, NULL, 145, NULL, NULL, 235133),
(285081, '1x5dA01', NULL, NULL, 120, NULL, NULL, 235133),
(285082, '4mzwA01', NULL, NULL, 151, NULL, NULL, 235133),
(285083, '3qdnA01', NULL, NULL, 115, NULL, NULL, 235133),
(285084, '3f8uC04', NULL, NULL, 119, NULL, NULL, 235133),
(285085, '4dssB00', NULL, NULL, 112, NULL, NULL, 235133);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(285086, '2dj2A01', NULL, NULL, 117, NULL, NULL, 235133),
(285087, '3zmlB01', NULL, NULL, 82, NULL, NULL, 235133),
(285088, '2lkuA01', NULL, NULL, 97, NULL, NULL, 235133),
(285089, '2rliA00', NULL, NULL, 171, NULL, NULL, 235133),
(285090, '4lmvA01', NULL, NULL, 105, NULL, NULL, 235133),
(285091, '5ijtC00', NULL, NULL, 164, NULL, NULL, 235133),
(285092, '4ml1A02', NULL, NULL, 131, NULL, NULL, 235133),
(285093, '1zmaA00', NULL, NULL, 118, NULL, NULL, 235133),
(285094, '3emxA00', NULL, NULL, 135, NULL, NULL, 235133),
(285095, '3f6fA01', NULL, NULL, 78, NULL, NULL, 235133),
(285096, '2ojlA00', NULL, NULL, 85, NULL, NULL, 235133),
(285097, '4fybA00', NULL, NULL, 167, NULL, NULL, 235133),
(285098, '4tveA01', NULL, NULL, 131, NULL, NULL, 235133),
(285099, '3fz9A00', NULL, NULL, 112, NULL, NULL, 235133),
(285100, '3q6oA02', NULL, NULL, 109, NULL, NULL, 235133),
(285101, '5dvbD00', NULL, NULL, 170, NULL, NULL, 235133),
(285102, '2nbsA00', NULL, NULL, 122, NULL, NULL, 235133),
(285103, '3ha9A00', NULL, NULL, 165, NULL, NULL, 235133),
(285104, '4n30A00', NULL, NULL, 182, NULL, NULL, 235133),
(285105, '3lypB01', NULL, NULL, 109, NULL, NULL, 235133),
(285106, '3mngA00', NULL, NULL, 173, NULL, NULL, 235133),
(285107, '2mcsA00', NULL, NULL, 128, NULL, NULL, 235133),
(285108, '3q6oA01', NULL, NULL, 135, NULL, NULL, 235133),
(285109, '4q5nA01', NULL, NULL, 121, NULL, NULL, 235133),
(285110, '5d73A01', NULL, NULL, 99, NULL, NULL, 235133),
(285111, '3tueB00', NULL, NULL, 164, NULL, NULL, 235133),
(285112, '2c3nA01', NULL, NULL, 87, NULL, NULL, 235133),
(285113, '3dxbD01', NULL, NULL, 117, NULL, NULL, 235133),
(285114, '4kx4A01', NULL, NULL, 78, NULL, NULL, 235133),
(285115, '3tcoA00', NULL, NULL, 109, NULL, NULL, 235133),
(285116, '6e0gA00', NULL, NULL, 165, NULL, NULL, 235133),
(285117, '2wfcA00', NULL, NULL, 167, NULL, NULL, 235133),
(285118, '3sbcD00', NULL, NULL, 195, NULL, NULL, 235133),
(285119, '4jedA01', NULL, NULL, 98, NULL, NULL, 235133),
(285120, '3us3A02', NULL, NULL, 102, NULL, NULL, 235133),
(285121, '3us3A01', NULL, NULL, 126, NULL, NULL, 235133),
(285122, '1vf1A01', NULL, NULL, 120, NULL, NULL, 235133),
(285123, '2ypmA00', NULL, NULL, 106, NULL, NULL, 235133),
(285124, '3us3A03', NULL, NULL, 139, NULL, NULL, 235133),
(285125, '4ussA01', NULL, NULL, 197, NULL, NULL, 235133),
(285126, '4gxzD00', NULL, NULL, 173, NULL, NULL, 235133),
(285127, '2es7A00', NULL, NULL, 125, NULL, NULL, 235133),
(285128, '3hz4A00', NULL, NULL, 123, NULL, NULL, 235133),
(285129, '2qc7A01', NULL, NULL, 122, NULL, NULL, 235133),
(285130, '3gx8A01', NULL, NULL, 100, NULL, NULL, 235133),
(285131, '3erwC00', NULL, NULL, 145, NULL, NULL, 235133),
(285132, '5jwoB00', NULL, NULL, 99, NULL, NULL, 235133),
(285133, '2vupA00', NULL, NULL, 167, NULL, NULL, 235133),
(285134, '5d9xA01', NULL, NULL, 89, NULL, NULL, 235133),
(285135, '3kh7A00', NULL, NULL, 176, NULL, NULL, 235133),
(285136, '1u3iA01', NULL, NULL, 83, NULL, NULL, 235133),
(285137, '4mf5A01', NULL, NULL, 122, NULL, NULL, 235133),
(285138, '1t4yA01', NULL, NULL, 89, NULL, NULL, 235133),
(285139, '2dj0A01', NULL, NULL, 126, NULL, NULL, 235133),
(285140, '1senA00', NULL, NULL, 143, NULL, NULL, 235133),
(285141, '1z6mA01', NULL, NULL, 114, NULL, NULL, 235133),
(285142, '1k0dB01', NULL, NULL, 102, NULL, NULL, 235133),
(285143, '3ipzA01', NULL, NULL, 97, NULL, NULL, 235133),
(285144, '2fgxA00', NULL, NULL, 85, NULL, NULL, 235133),
(285145, '3hxsA01', NULL, NULL, 89, NULL, NULL, 235133),
(285146, '3dwvA00', NULL, NULL, 168, NULL, NULL, 235133),
(285147, '5jlyC00', NULL, NULL, 172, NULL, NULL, 235133),
(285148, '1gsuA01', NULL, NULL, 114, NULL, NULL, 235133),
(285149, '4ielB01', NULL, NULL, 82, NULL, NULL, 235133),
(285150, '5xtbF00', NULL, NULL, 83, NULL, NULL, 235133),
(285151, '3idvA01', NULL, NULL, 122, NULL, NULL, 235133),
(285152, '3s9fA00', NULL, NULL, 144, NULL, NULL, 235133),
(285153, '3idvA02', NULL, NULL, 119, NULL, NULL, 235133),
(285154, '1thxA00', NULL, NULL, 115, NULL, NULL, 235133),
(285155, '5hfiA00', NULL, NULL, 216, NULL, NULL, 235133),
(285156, '4aj8A00', NULL, NULL, 105, NULL, NULL, 235133);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(285157, '4ptsA01', NULL, NULL, 130, NULL, NULL, 235133),
(285158, '4hz4A01', NULL, NULL, 86, NULL, NULL, 235133),
(285159, '4i97A01', NULL, NULL, 77, NULL, NULL, 235133),
(285160, '2l57A00', NULL, NULL, 126, NULL, NULL, 235133),
(285161, '4mp4A01', NULL, NULL, 108, NULL, NULL, 235133),
(285162, '2e0qA00', NULL, NULL, 104, NULL, NULL, 235133),
(285163, '4wf5A00', NULL, NULL, 189, NULL, NULL, 235133),
(285164, '3or5A00', NULL, NULL, 165, NULL, NULL, 235133),
(285165, '1m7tA00', NULL, NULL, 107, NULL, NULL, 235133),
(285166, '2ywiB00', NULL, NULL, 196, NULL, NULL, 235133),
(285167, '1ttzA00', NULL, NULL, 87, NULL, NULL, 235133),
(285168, '3wgdC00', NULL, NULL, 113, NULL, NULL, 235133),
(285169, '4je1B00', NULL, NULL, 175, NULL, NULL, 235133),
(285170, '2ljkA01', NULL, NULL, 81, NULL, NULL, 235133),
(285171, '3gl5A01', NULL, NULL, 212, NULL, NULL, 235133),
(285172, '4l8eA01', NULL, NULL, 97, NULL, NULL, 235133),
(285173, '1gwcA01', NULL, NULL, 83, NULL, NULL, 235133),
(285174, '4k2dA00', NULL, NULL, 200, NULL, NULL, 235133),
(285175, '6f05A01', NULL, NULL, 85, NULL, NULL, 235133),
(285176, '1yy7A01', NULL, NULL, 108, NULL, NULL, 235133),
(285177, '3hczA00', NULL, NULL, 148, NULL, NULL, 235133),
(285178, '1v2aA01', NULL, NULL, 76, NULL, NULL, 235133),
(285179, '3gtuB01', NULL, NULL, 112, NULL, NULL, 235133),
(285180, '3ibhA01', NULL, NULL, 97, NULL, NULL, 235133),
(285181, '3cxgA00', NULL, NULL, 133, NULL, NULL, 235133),
(285182, '2e7pC00', NULL, NULL, 116, NULL, NULL, 235133),
(285183, '3uemA03', NULL, NULL, 123, NULL, NULL, 235133),
(285184, '2m72A00', NULL, NULL, 156, NULL, NULL, 235133),
(285185, '3uemA01', NULL, NULL, 114, NULL, NULL, 235133),
(285186, '3uemA02', NULL, NULL, 124, NULL, NULL, 235133),
(285187, '5iqyA01', NULL, NULL, 93, NULL, NULL, 235133),
(285188, '6i1cA00', NULL, NULL, 109, NULL, NULL, 235133),
(285189, '3ph9A00', NULL, NULL, 151, NULL, NULL, 235133),
(285190, '1gh2A00', NULL, NULL, 107, NULL, NULL, 235133),
(285191, '3rhbA00', NULL, NULL, 113, NULL, NULL, 235133),
(285192, '3f8uA01', NULL, NULL, 109, NULL, NULL, 235133),
(285193, '6gwwA01', NULL, NULL, 148, NULL, NULL, 235133),
(285194, '4ma9A00', NULL, NULL, 163, NULL, NULL, 235133),
(285195, '4z7xB00', NULL, NULL, 238, NULL, NULL, 235133),
(285196, '3mszB00', NULL, NULL, 89, NULL, NULL, 235133),
(285197, '1wmjA01', NULL, NULL, 108, NULL, NULL, 235133),
(285198, '3ic4A00', NULL, NULL, 92, NULL, NULL, 235133),
(285199, '3l78A00', NULL, NULL, 120, NULL, NULL, 235133),
(285200, '6ghfA01', NULL, NULL, 89, NULL, NULL, 235133),
(285201, '2l5lA00', NULL, NULL, 136, NULL, NULL, 235133),
(285202, '3r3eB01', NULL, NULL, 217, NULL, NULL, 235133),
(285203, '4ptsB01', NULL, NULL, 170, NULL, NULL, 235133),
(285204, '2l6cA00', NULL, NULL, 110, NULL, NULL, 235133),
(285205, '4v1ag00', NULL, NULL, 159, NULL, NULL, 235133),
(285206, '2ls5A00', NULL, NULL, 159, NULL, NULL, 235133),
(285207, '5nr1A01', NULL, NULL, 108, NULL, NULL, 235133),
(285208, '2p31A00', NULL, NULL, 155, NULL, NULL, 235133),
(285209, '4nwyC00', NULL, NULL, 134, NULL, NULL, 235133),
(285210, '5f05A01', NULL, NULL, 86, NULL, NULL, 235133),
(285211, '2wciA01', NULL, NULL, 108, NULL, NULL, 235133),
(285212, '3wgxB00', NULL, NULL, 113, NULL, NULL, 235133),
(285213, '3uarA01', NULL, NULL, 97, NULL, NULL, 235133),
(285214, '2dj1A00', NULL, NULL, 140, NULL, NULL, 235133),
(285215, '1oyjA01', NULL, NULL, 93, NULL, NULL, 235133),
(285216, '2wz9A00', NULL, NULL, 131, NULL, NULL, 235133),
(285217, '2r5gA01', NULL, NULL, 103, NULL, NULL, 235133),
(285218, '3qavA01', NULL, NULL, 79, NULL, NULL, 235133),
(285219, '5y63E00', NULL, NULL, 183, NULL, NULL, 235133),
(285220, '3lorD00', NULL, NULL, 160, NULL, NULL, 235133),
(285221, '4jbbA01', NULL, NULL, 101, NULL, NULL, 235133),
(285222, '4ikhA01', NULL, NULL, 106, NULL, NULL, 235133),
(285223, '2f51A00', NULL, NULL, 118, NULL, NULL, 235133),
(285224, '4ef0A01', NULL, NULL, 110, NULL, NULL, 235133),
(285225, '2vm1C01', NULL, NULL, 111, NULL, NULL, 235133),
(285226, '1fovA00', NULL, NULL, 82, NULL, NULL, 235133),
(285227, '2lrtA00', NULL, NULL, 152, NULL, NULL, 235133);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(285228, '3hhvA00', NULL, NULL, 110, NULL, NULL, 235133),
(285229, '4hi7B01', NULL, NULL, 80, NULL, NULL, 235133),
(285230, '3umaB00', NULL, NULL, 160, NULL, NULL, 235133),
(285231, '4mzwB01', NULL, NULL, 143, NULL, NULL, 235133),
(285232, '4mk3A01', NULL, NULL, 89, NULL, NULL, 235133),
(285233, '4oo4A00', NULL, NULL, 105, NULL, NULL, 235133),
(285234, '2jsyA00', NULL, NULL, 167, NULL, NULL, 235133),
(285235, '3rppA01', NULL, NULL, 208, NULL, NULL, 235133),
(285236, '5y4uA01', NULL, NULL, 106, NULL, NULL, 235133),
(285237, '2he3A00', NULL, NULL, 186, NULL, NULL, 235133),
(285238, '2lstA00', NULL, NULL, 130, NULL, NULL, 235133),
(285239, '2i1uA00', NULL, NULL, 121, NULL, NULL, 235133),
(285240, '5dbqA00', NULL, NULL, 109, NULL, NULL, 235133),
(285241, '2wulA01', NULL, NULL, 98, NULL, NULL, 235133),
(285242, '1r26A00', NULL, NULL, 125, NULL, NULL, 235133),
(285243, '3wywB01', NULL, NULL, 80, NULL, NULL, 235133),
(285244, '1tp9D00', NULL, NULL, 162, NULL, NULL, 235133),
(285245, '6g62A00', NULL, NULL, 115, NULL, NULL, 235133),
(285246, '3i6aB01', NULL, NULL, 113, NULL, NULL, 235133),
(285247, '1wryA00', NULL, NULL, 121, NULL, NULL, 235133),
(285248, '2vimA00', NULL, NULL, 104, NULL, NULL, 235133),
(285249, '4mcuD00', NULL, NULL, 190, NULL, NULL, 235133),
(285250, '4pomA00', NULL, NULL, 109, NULL, NULL, 235133),
(285251, '6atrA01', NULL, NULL, 112, NULL, NULL, 235133),
(285252, '2kokA00', NULL, NULL, 120, NULL, NULL, 235133),
(285253, '4zb6A01', NULL, NULL, 92, NULL, NULL, 235133),
(285254, '3razA00', NULL, NULL, 151, NULL, NULL, 235133),
(285255, '5f07A01', NULL, NULL, 85, NULL, NULL, 235133),
(285256, '1gp1A00', NULL, NULL, 198, NULL, NULL, 235133),
(285257, '4ivfF01', NULL, NULL, 115, NULL, NULL, 235133),
(285258, '4k9zA00', NULL, NULL, 151, NULL, NULL, 235133),
(285259, '2g2qB01', NULL, NULL, 115, NULL, NULL, 235133),
(285260, '1vw4400', NULL, NULL, 140, NULL, NULL, 235133),
(285261, '4f03A01', NULL, NULL, 106, NULL, NULL, 235133),
(285262, '5eckB01', NULL, NULL, 93, NULL, NULL, 235133),
(285263, '5vo7A00', NULL, NULL, 110, NULL, NULL, 235133),
(285264, '2ltkA01', NULL, NULL, 97, NULL, NULL, 235133),
(285265, '5k2iA00', NULL, NULL, 164, NULL, NULL, 235133),
(285266, '2v2gA01', NULL, NULL, 151, NULL, NULL, 235133),
(285267, '3eurA00', NULL, NULL, 142, NULL, NULL, 235133),
(285268, '1oe8A01', NULL, NULL, 83, NULL, NULL, 235133),
(285269, '4llrA00', NULL, NULL, 197, NULL, NULL, 235133),
(285270, '5u56C01', NULL, NULL, 106, NULL, NULL, 235133),
(285271, '2on5A01', NULL, NULL, 91, NULL, NULL, 235133),
(285272, '4puaA01', NULL, NULL, 145, NULL, NULL, 235133),
(285273, '1abaA00', NULL, NULL, 87, NULL, NULL, 235133),
(285274, '4kgiC01', NULL, NULL, 101, NULL, NULL, 235133),
(285275, '3touB01', NULL, NULL, 88, NULL, NULL, 235133),
(285276, '4pobA00', NULL, NULL, 117, NULL, NULL, 235133),
(285277, '3ktbA00', NULL, NULL, 106, NULL, NULL, 235133),
(285278, '4xcsB00', NULL, NULL, 176, NULL, NULL, 235133),
(285279, '4hdeA00', NULL, NULL, 170, NULL, NULL, 235133),
(285280, '2b1lA00', NULL, NULL, 129, NULL, NULL, 235133),
(285281, '4fyuA00', NULL, NULL, 145, NULL, NULL, 235133),
(285282, '4hs1A00', NULL, NULL, 85, NULL, NULL, 235133),
(285283, '1wwjA00', NULL, NULL, 105, NULL, NULL, 235133),
(285284, '6ap5A00', NULL, NULL, 115, NULL, NULL, 235133),
(285285, '4mpgB01', NULL, NULL, 104, NULL, NULL, 235133),
(285286, '2f8aB00', NULL, NULL, 185, NULL, NULL, 235133),
(285287, '4jr6B00', NULL, NULL, 198, NULL, NULL, 235133),
(285288, '3iv4A00', NULL, NULL, 112, NULL, NULL, 235133),
(285289, '1e6bA01', NULL, NULL, 85, NULL, NULL, 235133),
(285290, '6hf1A01', NULL, NULL, 130, NULL, NULL, 235133),
(285291, '1z3eA00', NULL, NULL, 132, NULL, NULL, 235133),
(285292, '1v9wA00', NULL, NULL, 130, NULL, NULL, 235133),
(285293, '6hf1A02', NULL, NULL, 108, NULL, NULL, 235133),
(285294, '1rw1A00', NULL, NULL, 114, NULL, NULL, 235133),
(285295, '3kebB00', NULL, NULL, 176, NULL, NULL, 235133),
(285296, '1psqA00', NULL, NULL, 163, NULL, NULL, 235133),
(285297, '1r7hA00', NULL, NULL, 75, NULL, NULL, 235133),
(285298, '4gf0A01', NULL, NULL, 102, NULL, NULL, 235133);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(285299, '5zwpA01', NULL, NULL, 77, NULL, NULL, 235133),
(285300, '5j7dC00', NULL, NULL, 112, NULL, NULL, 235133),
(285301, '1yq1A01', NULL, NULL, 92, NULL, NULL, 235133),
(285302, '2hnlA01', NULL, NULL, 92, NULL, NULL, 235133),
(285303, '5aykA06', NULL, NULL, 113, NULL, NULL, 235133),
(285304, '5c00D00', NULL, NULL, 208, NULL, NULL, 235133),
(285305, '5aykA05', NULL, NULL, 102, NULL, NULL, 235133),
(285306, '1f3aA01', NULL, NULL, 99, NULL, NULL, 235133),
(285307, '1jlvA01', NULL, NULL, 77, NULL, NULL, 235133),
(285308, '4chsA01', NULL, NULL, 87, NULL, NULL, 235133),
(285309, '2ws2A01', NULL, NULL, 91, NULL, NULL, 235133),
(285310, '3hd5A01', NULL, NULL, 146, NULL, NULL, 235133),
(285311, '5aykA04', NULL, NULL, 105, NULL, NULL, 235133),
(285312, '2bmxA00', NULL, NULL, 170, NULL, NULL, 235133),
(285313, '5aykA03', NULL, NULL, 116, NULL, NULL, 235133),
(285314, '1lbkA01', NULL, NULL, 99, NULL, NULL, 235133),
(285315, '4ksoB00', NULL, NULL, 102, NULL, NULL, 235133),
(285316, '1sj6A00', NULL, NULL, 101, NULL, NULL, 235133),
(285317, '1cqgA00', NULL, NULL, 105, NULL, NULL, 235133),
(285318, '5j4uA01', NULL, NULL, 99, NULL, NULL, 235133),
(285319, '5caxA00', NULL, NULL, 101, NULL, NULL, 235133),
(285320, '3rbtD01', NULL, NULL, 129, NULL, NULL, 235133),
(285321, '6g61A00', NULL, NULL, 111, NULL, NULL, 235133),
(285322, '5ucxA00', NULL, NULL, 201, NULL, NULL, 235133),
(285323, '4mh2E00', NULL, NULL, 163, NULL, NULL, 235133),
(285324, '3touA01', NULL, NULL, 111, NULL, NULL, 235133),
(285325, '3zitB00', NULL, NULL, 78, NULL, NULL, 235133),
(285326, '3ppuB01', NULL, NULL, 186, NULL, NULL, 235133),
(285327, '5f06A01', NULL, NULL, 85, NULL, NULL, 235133),
(285328, '2yoiA00', NULL, NULL, 106, NULL, NULL, 235133),
(285329, '2oe3A00', NULL, NULL, 114, NULL, NULL, 235133),
(285330, '1zl9A01', NULL, NULL, 93, NULL, NULL, 235133),
(285331, '4q5fD01', NULL, NULL, 103, NULL, NULL, 235133),
(285332, '2p0gB00', NULL, NULL, 81, NULL, NULL, 235133),
(285333, '4mpgA01', NULL, NULL, 81, NULL, NULL, 235133),
(285334, '1zofA00', NULL, NULL, 170, NULL, NULL, 235133),
(285335, '5crgA01', NULL, NULL, 126, NULL, NULL, 235133),
(285336, '5ganD00', NULL, NULL, 143, NULL, NULL, 235133),
(285337, '5fhiA01', NULL, NULL, 76, NULL, NULL, 235133),
(285338, '3apsA00', NULL, NULL, 122, NULL, NULL, 235133),
(285339, '2k6vA00', NULL, NULL, 172, NULL, NULL, 235133),
(285340, '1qgvA00', NULL, NULL, 142, NULL, NULL, 235133),
(285341, '2b7kA00', NULL, NULL, 184, NULL, NULL, 235133),
(285342, '4xvwL00', NULL, NULL, 205, NULL, NULL, 235133),
(285343, '2xhfB00', NULL, NULL, 171, NULL, NULL, 235133),
(285344, '1pmtA01', NULL, NULL, 96, NULL, NULL, 235133),
(285345, '4hojA01', NULL, NULL, 104, NULL, NULL, 235133),
(285346, '6dxnC00', NULL, NULL, 192, NULL, NULL, 235133),
(285347, '4k0nA01', NULL, NULL, 99, NULL, NULL, 235133),
(285348, '2p5qB00', NULL, NULL, 170, NULL, NULL, 235133),
(285349, '3kcmF00', NULL, NULL, 154, NULL, NULL, 235133),
(285350, '5g5aA01', NULL, NULL, 87, NULL, NULL, 235133),
(285351, '4cdoC00', NULL, NULL, 185, NULL, NULL, 235133),
(285352, '4e8hA01', NULL, NULL, 83, NULL, NULL, 235133),
(285353, '1nhyA01', NULL, NULL, 78, NULL, NULL, 235133),
(285354, '3dmlA00', NULL, NULL, 98, NULL, NULL, 235133),
(285355, '4bvxA01', NULL, NULL, 110, NULL, NULL, 235133),
(285356, '3fkfD00', NULL, NULL, 148, NULL, NULL, 235133),
(285357, '2gsrA01', NULL, NULL, 97, NULL, NULL, 235133),
(285358, '3hdcA01', NULL, NULL, 135, NULL, NULL, 235133),
(285359, '4x1uA00', NULL, NULL, 159, NULL, NULL, 235133),
(285360, '3cmiA00', NULL, NULL, 171, NULL, NULL, 235133),
(285361, '3hd5B01', NULL, NULL, 170, NULL, NULL, 235133),
(285362, '4g2eA00', NULL, NULL, 157, NULL, NULL, 235133),
(285363, '2wb9A01', NULL, NULL, 83, NULL, NULL, 235133),
(285364, '2i3yA01', NULL, NULL, 184, NULL, NULL, 235133),
(285365, '5abrA00', NULL, NULL, 104, NULL, NULL, 235133),
(285366, '6gsvA01', NULL, NULL, 112, NULL, NULL, 235133),
(285367, '2aheA01', NULL, NULL, 108, NULL, NULL, 235133),
(285368, '3f6dA01', NULL, NULL, 80, NULL, NULL, 235133),
(285369, '1nswA00', NULL, NULL, 105, NULL, NULL, 235133);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(285370, '5u56A01', NULL, NULL, 92, NULL, NULL, 235133),
(285371, '4tr3A00', NULL, NULL, 191, NULL, NULL, 235133),
(285372, '1fheA01', NULL, NULL, 107, NULL, NULL, 235133),
(285373, '3fhkA02', NULL, NULL, 120, NULL, NULL, 235133),
(285374, '4bwqC00', NULL, NULL, 142, NULL, NULL, 235133),
(285375, '6fmuA01', NULL, NULL, 105, NULL, NULL, 235133),
(285376, '3p7xB00', NULL, NULL, 166, NULL, NULL, 235133),
(285377, '5ft3B01', NULL, NULL, 80, NULL, NULL, 235133),
(285378, '1wouA00', NULL, NULL, 123, NULL, NULL, 235133),
(285379, '3isoA01', NULL, NULL, 108, NULL, NULL, 235133),
(285380, '3wd6A01', NULL, NULL, 138, NULL, NULL, 235133),
(285381, '1h75A00', NULL, NULL, 81, NULL, NULL, 235133),
(285382, '2ycdA01', NULL, NULL, 86, NULL, NULL, 235133),
(285383, '2l5oA00', NULL, NULL, 153, NULL, NULL, 235133),
(285384, '2gsqA01', NULL, NULL, 94, NULL, NULL, 235133),
(285385, '2yj7A00', NULL, NULL, 106, NULL, NULL, 235133),
(285386, '3f4sA01', NULL, NULL, 143, NULL, NULL, 235133),
(285387, '3qcpA01', NULL, NULL, 184, NULL, NULL, 235133),
(285388, '4zl8A00', NULL, NULL, 192, NULL, NULL, 235133),
(285389, '3ay8A01', NULL, NULL, 80, NULL, NULL, 235133),
(285390, '5b7cA01', NULL, NULL, 95, NULL, NULL, 235133),
(285391, '4pq1A01', NULL, NULL, 146, NULL, NULL, 235133),
(285392, '4iw9B01', NULL, NULL, 102, NULL, NULL, 235133),
(285393, '4n0vA01', NULL, NULL, 106, NULL, NULL, 235133),
(285394, '2npbA00', NULL, NULL, 96, NULL, NULL, 235133),
(285395, '4zbaA01', NULL, NULL, 92, NULL, NULL, 235133),
(285396, '4ri6A01', NULL, NULL, 87, NULL, NULL, 235133),
(285397, '5zteG00', NULL, NULL, 203, NULL, NULL, 235133),
(285398, '5hfkA01', NULL, NULL, 105, NULL, NULL, 235133),
(285399, '4hz2A01', NULL, NULL, 81, NULL, NULL, 235133),
(285400, '4pxoA01', NULL, NULL, 77, NULL, NULL, 235133),
(285401, '1jfuA00', NULL, NULL, 186, NULL, NULL, 235133),
(285402, '2yn1A00', NULL, NULL, 106, NULL, NULL, 235133),
(285403, '4bl7A01', NULL, NULL, 103, NULL, NULL, 235133),
(285404, '3hz8A00', NULL, NULL, 193, NULL, NULL, 235133),
(285405, '4f82B00', NULL, NULL, 176, NULL, NULL, 235133),
(285406, '3h1nB01', NULL, NULL, 132, NULL, NULL, 235133),
(285407, '3fk8A00', NULL, NULL, 133, NULL, NULL, 235133),
(285408, '4fquB01', NULL, NULL, 202, NULL, NULL, 235133),
(285409, '5hr3A00', NULL, NULL, 109, NULL, NULL, 235133),
(285410, '1nhoA00', NULL, NULL, 85, NULL, NULL, 235133),
(285411, '1rk4A01', NULL, NULL, 76, NULL, NULL, 235133),
(285412, '1kteA00', NULL, NULL, 105, NULL, NULL, 235133),
(285413, '2hlsA02', NULL, NULL, 102, NULL, NULL, 235133),
(285414, '5h5qA00', NULL, NULL, 169, NULL, NULL, 235133),
(285415, '2hlsA01', NULL, NULL, 121, NULL, NULL, 235133),
(285416, '4dejD01', NULL, NULL, 109, NULL, NULL, 235133),
(285417, '5w1jA01', NULL, NULL, 101, NULL, NULL, 235133),
(285418, '2znmD00', NULL, NULL, 195, NULL, NULL, 235133),
(285419, '2ggtB00', NULL, NULL, 164, NULL, NULL, 235133),
(285420, '1r5pB00', NULL, NULL, 108, NULL, NULL, 235133),
(285421, '2fwgA00', NULL, NULL, 134, NULL, NULL, 235133),
(285422, '3u5rE00', NULL, NULL, 193, NULL, NULL, 235133),
(285423, '3m0fA01', NULL, NULL, 81, NULL, NULL, 235133),
(285424, '4pqhA01', NULL, NULL, 104, NULL, NULL, 235133),
(285425, '4i6xA00', NULL, NULL, 131, NULL, NULL, 235133),
(285426, '1b48A01', NULL, NULL, 96, NULL, NULL, 235133),
(285427, '1faaA00', NULL, NULL, 124, NULL, NULL, 235133),
(285428, '1prxB01', NULL, NULL, 155, NULL, NULL, 235133),
(285429, '2hzeA00', NULL, NULL, 114, NULL, NULL, 235133),
(285430, '3tjjA00', NULL, NULL, 167, NULL, NULL, 235133),
(285431, '4huaA00', NULL, NULL, 108, NULL, NULL, 235133),
(285432, '2v1mA00', NULL, NULL, 169, NULL, NULL, 235133),
(285433, '4ekzA01', NULL, NULL, 112, NULL, NULL, 235133),
(285434, '1bjxA00', NULL, NULL, 110, NULL, NULL, 235133),
(285435, '3lwaA01', NULL, NULL, 158, NULL, NULL, 235133),
(285436, '1j9bA00', NULL, NULL, 141, NULL, NULL, 235133),
(285437, '5y9zA01', NULL, NULL, 91, NULL, NULL, 235133),
(285438, '5j9cA00', NULL, NULL, 175, NULL, NULL, 235133),
(285439, '1lu4A00', NULL, NULL, 136, NULL, NULL, 235133),
(285440, '3gl3D00', NULL, NULL, 152, NULL, NULL, 235133);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(285441, '1iloA00', NULL, NULL, 77, NULL, NULL, 235133),
(285442, '1axdA01', NULL, NULL, 82, NULL, NULL, 235133),
(285443, '5g5eA01', NULL, NULL, 81, NULL, NULL, 235133),
(285444, '3gykB00', NULL, NULL, 175, NULL, NULL, 235133),
(285445, '4id0A01', NULL, NULL, 102, NULL, NULL, 235133),
(285446, '2fnoB01', NULL, NULL, 103, NULL, NULL, 235133),
(285447, '2gdrA01', NULL, NULL, 96, NULL, NULL, 235133),
(285448, '3zywA01', NULL, NULL, 97, NULL, NULL, 235133),
(285449, '5yvnA01', NULL, NULL, 126, NULL, NULL, 235133),
(285450, '1fw1A01', NULL, NULL, 78, NULL, NULL, 235133),
(285451, '4gqcA00', NULL, NULL, 164, NULL, NULL, 235133),
(285452, '3uiwA00', NULL, NULL, 110, NULL, NULL, 235133),
(285453, '4ba7A00', NULL, NULL, 106, NULL, NULL, 235133),
(285454, '2i4aA00', NULL, NULL, 107, NULL, NULL, 235133),
(285455, '5xftA01', NULL, NULL, 90, NULL, NULL, 235133),
(285456, '1r4wA01', NULL, NULL, 208, NULL, NULL, 235133),
(285457, '2vocA00', NULL, NULL, 112, NULL, NULL, 235133),
(285458, '4nhwD01', NULL, NULL, 114, NULL, NULL, 235133),
(285459, '4kceB00', NULL, NULL, 163, NULL, NULL, 235133),
(285460, '1tw9A01', NULL, NULL, 91, NULL, NULL, 235133),
(285461, '3l4nA00', NULL, NULL, 127, NULL, NULL, 235133),
(285462, '4od7A00', NULL, NULL, 190, NULL, NULL, 235133),
(285463, '4gwrA00', NULL, NULL, 123, NULL, NULL, 235133),
(285464, '4mdcD01', NULL, NULL, 110, NULL, NULL, 235133),
(285465, '3vwxA01', NULL, NULL, 80, NULL, NULL, 235133),
(285466, '1nm3A01', NULL, NULL, 159, NULL, NULL, 235133),
(285467, '2ec4A00', NULL, NULL, 178, NULL, NULL, 235133),
(285468, '3ec3A01', NULL, NULL, 116, NULL, NULL, 235133),
(285469, '3ec3A02', NULL, NULL, 134, NULL, NULL, 235133),
(285470, '3fygA01', NULL, NULL, 99, NULL, NULL, 235133),
(285471, '2lqoA00', NULL, NULL, 92, NULL, NULL, 235133),
(285472, '3kijC00', NULL, NULL, 180, NULL, NULL, 235133),
(285473, '4l0wA00', NULL, NULL, 173, NULL, NULL, 235133),
(285474, '2mygA00', NULL, NULL, 97, NULL, NULL, 235133),
(285475, '2m46A00', NULL, NULL, 118, NULL, NULL, 235133),
(285476, '2c4jA01', NULL, NULL, 113, NULL, NULL, 235133),
(285477, '3gnjA00', NULL, NULL, 111, NULL, NULL, 235133),
(285478, '3rdwA00', NULL, NULL, 121, NULL, NULL, 235133),
(285479, '3m1gA01', NULL, NULL, 118, NULL, NULL, 235133),
(285480, '1wjkA01', NULL, NULL, 78, NULL, NULL, 235133),
(285481, '1tu7A01', NULL, NULL, 99, NULL, NULL, 235133),
(285482, '2n5fA01', NULL, NULL, 89, NULL, NULL, 235133),
(285483, '5cnwA01', NULL, NULL, 219, NULL, NULL, 235133),
(285484, '1usbA01', NULL, NULL, 103, NULL, NULL, 235133),
(285485, '3apqA02', NULL, NULL, 118, NULL, NULL, 235133),
(285486, '2vcvA01', NULL, NULL, 113, NULL, NULL, 235133),
(285487, '3einA01', NULL, NULL, 78, NULL, NULL, 235133),
(285488, '4xvwI01', NULL, NULL, 163, NULL, NULL, 235133),
(285489, '3e0uA00', NULL, NULL, 166, NULL, NULL, 235133),
(285490, '3p2aA02', NULL, NULL, 111, NULL, NULL, 235133),
(285491, '2a4vA01', NULL, NULL, 149, NULL, NULL, 235133),
(285492, '1xwaA00', NULL, NULL, 111, NULL, NULL, 235133),
(285493, '2pvqA01', NULL, NULL, 95, NULL, NULL, 235133),
(285494, '5l71A00', NULL, NULL, 171, NULL, NULL, 235133),
(285495, '4j56E00', NULL, NULL, 114, NULL, NULL, 235133),
(285496, '3zivA00', NULL, NULL, 106, NULL, NULL, 235133),
(285497, '1kngA00', NULL, NULL, 156, NULL, NULL, 235133),
(285498, '1w4vA00', NULL, NULL, 119, NULL, NULL, 235133),
(285499, '2ywmA01', NULL, NULL, 116, NULL, NULL, 235133),
(285500, '3bd2A00', NULL, NULL, 186, NULL, NULL, 235133),
(285501, '2ywmA02', NULL, NULL, 109, NULL, NULL, 235133),
(285502, '3lykB01', NULL, NULL, 92, NULL, NULL, 235133),
(285503, '3qouA01', NULL, NULL, 115, NULL, NULL, 235133),
(285504, '1nm3A02', NULL, NULL, 72, NULL, NULL, 235133),
(285505, '3ctgA00', NULL, NULL, 108, NULL, NULL, 235133),
(285506, '6gxgA00', NULL, NULL, 145, NULL, NULL, 235133),
(285507, '2lusA00', NULL, NULL, 143, NULL, NULL, 235133),
(285508, '1xw6A01', NULL, NULL, 113, NULL, NULL, 235133),
(285509, '5enuB00', NULL, NULL, 161, NULL, NULL, 235133),
(285510, '4kdxA01', NULL, NULL, 83, NULL, NULL, 235133),
(285511, '1dbyA00', NULL, NULL, 107, NULL, NULL, 235133);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(285512, '3fygB01', NULL, NULL, 99, NULL, NULL, 235133),
(285513, '3ik7A01', NULL, NULL, 100, NULL, NULL, 235133),
(285514, '2b5eA03', NULL, NULL, 127, NULL, NULL, 235133),
(285515, '2b5eA04', NULL, NULL, 140, NULL, NULL, 235133),
(285516, '2o7kA00', NULL, NULL, 107, NULL, NULL, 235133),
(285517, '3ewlB00', NULL, NULL, 142, NULL, NULL, 235133),
(285518, '2b5eA01', NULL, NULL, 122, NULL, NULL, 235133),
(285519, '3l9vC00', NULL, NULL, 189, NULL, NULL, 235133),
(285520, '4kunA00', NULL, NULL, 91, NULL, NULL, 235133),
(285521, '3gn3A00', NULL, NULL, 182, NULL, NULL, 235133),
(285522, '2b5eA02', NULL, NULL, 97, NULL, NULL, 235133),
(285523, '4dvcA00', NULL, NULL, 184, NULL, NULL, 235133),
(285524, '3me8B00', NULL, NULL, 170, NULL, NULL, 235133),
(285525, '2auvA00', NULL, NULL, 85, NULL, NULL, 235133),
(285526, '3m8nA01', NULL, NULL, 81, NULL, NULL, 235133),
(285527, '2v6kA01', NULL, NULL, 76, NULL, NULL, 235133),
(285528, '5agyA01', NULL, NULL, 87, NULL, NULL, 235133),
(285529, '1v98A00', NULL, NULL, 92, NULL, NULL, 235133),
(285530, '4yh2D01', NULL, NULL, 80, NULL, NULL, 235133),
(285531, '3iosA00', NULL, NULL, 150, NULL, NULL, 235133),
(285532, '3n5oA01', NULL, NULL, 89, NULL, NULL, 235133),
(285533, '4v1ap00', NULL, NULL, 112, NULL, NULL, 235133),
(285534, '2wrtA01', NULL, NULL, 108, NULL, NULL, 235133),
(285535, '4f9zA01', NULL, NULL, 111, NULL, NULL, 235133),
(285536, '4kndA00', NULL, NULL, 112, NULL, NULL, 235133),
(285537, '6eryA01', NULL, NULL, 94, NULL, NULL, 235133),
(285538, '4kdyB01', NULL, NULL, 80, NULL, NULL, 235133),
(285539, '3gv1A00', NULL, NULL, 147, NULL, NULL, 235133),
(285540, '1fb6A00', NULL, NULL, 105, NULL, NULL, 235133),
(285541, '1xzoB00', NULL, NULL, 174, NULL, NULL, 235133),
(285542, '4hqzA00', NULL, NULL, 141, NULL, NULL, 235133),
(285543, '3bbyA01', NULL, NULL, 85, NULL, NULL, 235133),
(285544, '2klxA00', NULL, NULL, 89, NULL, NULL, 235133),
(285545, '2vluA01', NULL, NULL, 109, NULL, NULL, 235133),
(285546, '3l9uA00', NULL, NULL, 201, NULL, NULL, 235133),
(285547, '2yv7A01', NULL, NULL, 115, NULL, NULL, 235133),
(285548, '2x64B01', NULL, NULL, 94, NULL, NULL, 235133),
(285549, '4nxiA00', NULL, NULL, 208, NULL, NULL, 235133),
(285550, '2yzhA00', NULL, NULL, 171, NULL, NULL, 235133),
(285551, '2pptA02', NULL, NULL, 109, NULL, NULL, 235133),
(285552, '1ti3A00', NULL, NULL, 113, NULL, NULL, 235133),
(285553, '4f9zA02', NULL, NULL, 116, NULL, NULL, 235133),
(285554, '1wpiA00', NULL, NULL, 133, NULL, NULL, 235133),
(285555, '4q5qA01', NULL, NULL, 114, NULL, NULL, 235133),
(285556, '6ep6A01', NULL, NULL, 87, NULL, NULL, 235133),
(285557, '1t00A00', NULL, NULL, 112, NULL, NULL, 235133),
(285558, '2dbcA00', NULL, NULL, 135, NULL, NULL, 235133),
(285559, '2c0dA00', NULL, NULL, 168, NULL, NULL, 235133),
(285560, '3hvvA00', NULL, NULL, 167, NULL, NULL, 235133),
(285561, '1un2A00', NULL, NULL, 197, NULL, NULL, 235133),
(285562, '3qpmB00', NULL, NULL, 197, NULL, NULL, 235133),
(285563, '5oomb00', NULL, NULL, 149, NULL, NULL, 235133),
(285564, '6jwkB01', NULL, NULL, 78, NULL, NULL, 235133),
(285565, '5j41A01', NULL, NULL, 100, NULL, NULL, 235133),
(285566, '3o76A01', NULL, NULL, 99, NULL, NULL, 235133),
(285567, '3ed3A01', NULL, NULL, 143, NULL, NULL, 235133),
(285568, '1xflA00', NULL, NULL, 124, NULL, NULL, 235133),
(285569, '6j3eA01', NULL, NULL, 104, NULL, NULL, 235133),
(285570, '3ghaA00', NULL, NULL, 202, NULL, NULL, 235133),
(285571, '1we0A00', NULL, NULL, 166, NULL, NULL, 235133),
(285572, '5jpoD01', NULL, NULL, 82, NULL, NULL, 235133),
(285573, '4q5rA01', NULL, NULL, 92, NULL, NULL, 235133),
(285574, '1wikA01', NULL, NULL, 97, NULL, NULL, 235133),
(285575, '2b1kA00', NULL, NULL, 150, NULL, NULL, 235133),
(285576, '2imfA00', NULL, NULL, 203, NULL, NULL, 235133),
(285577, '3iraA00', NULL, NULL, 173, NULL, NULL, 235133),
(285578, '3q18A01', NULL, NULL, 123, NULL, NULL, 235133),
(285579, '1o8xA00', NULL, NULL, 146, NULL, NULL, 235133),
(285580, '4pqiA01', NULL, NULL, 109, NULL, NULL, 235133),
(285581, '2fnoA01', NULL, NULL, 103, NULL, NULL, 235133),
(285582, '5y4tA00', NULL, NULL, 122, NULL, NULL, 235133);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(285583, '2xc2A00', NULL, NULL, 117, NULL, NULL, 235133),
(285584, '4xhmA00', NULL, NULL, 110, NULL, NULL, 235133),
(285585, '4i2uA00', NULL, NULL, 114, NULL, NULL, 235133),
(285586, '4wr4A01', NULL, NULL, 107, NULL, NULL, 235133),
(285587, '1aw9A01', NULL, NULL, 85, NULL, NULL, 235133),
(285588, '1j08A01', NULL, NULL, 117, NULL, NULL, 235133),
(285589, '4tr1A00', NULL, NULL, 92, NULL, NULL, 235133),
(285590, '1ev4A01', NULL, NULL, 99, NULL, NULL, 235133),
(285591, '5elgA01', NULL, NULL, 89, NULL, NULL, 235133),
(285592, '1j08A02', NULL, NULL, 106, NULL, NULL, 235133),
(285593, '2lv3A00', NULL, NULL, 102, NULL, NULL, 235133),
(285594, '5ey6A01', NULL, NULL, 89, NULL, NULL, 235133),
(285595, '3lszA01', NULL, NULL, 93, NULL, NULL, 235133),
(285596, '2on7A01', NULL, NULL, 91, NULL, NULL, 235133),
(285597, '4naxA01', NULL, NULL, 134, NULL, NULL, 235133),
(285598, '1vrsD00', NULL, NULL, 134, NULL, NULL, 235133),
(285599, '2kucA00', NULL, NULL, 130, NULL, NULL, 235133),
(285600, '3eviA00', NULL, NULL, 118, NULL, NULL, 235133),
(285601, '4rqrA00', NULL, NULL, 109, NULL, NULL, 235133),
(285602, '4zbdA01', NULL, NULL, 91, NULL, NULL, 235133),
(285603, '5uuoB01', NULL, NULL, 135, NULL, NULL, 235133),
(285604, '4o32C00', NULL, NULL, 93, NULL, NULL, 235133),
(285605, '3gixA00', NULL, NULL, 149, NULL, NULL, 235133),
(285606, '1qmbB00', NULL, NULL, 42, NULL, NULL, 235134),
(285607, '2c9oB02', NULL, NULL, 126, NULL, NULL, 235135),
(285608, '2cqaA01', NULL, NULL, 74, NULL, NULL, 235135),
(285609, '4a64C03', NULL, NULL, 105, NULL, NULL, 235136),
(285610, '4wqoD00', NULL, NULL, 163, NULL, NULL, 235136),
(285611, '4a64A02', NULL, NULL, 117, NULL, NULL, 235136),
(285612, '6i2mB01', NULL, NULL, 128, NULL, NULL, 235136),
(285613, '4n9f302', NULL, NULL, 175, NULL, NULL, 235136),
(285614, '6i2mB02', NULL, NULL, 122, NULL, NULL, 235136),
(285615, '6i2mB03', NULL, NULL, 109, NULL, NULL, 235136),
(285616, '3dplC01', NULL, NULL, 119, NULL, NULL, 235136),
(285617, '1ldjA04', NULL, NULL, 115, NULL, NULL, 235136),
(285618, '1ldjA03', NULL, NULL, 115, NULL, NULL, 235136),
(285619, '4a64A01', NULL, NULL, 132, NULL, NULL, 235136),
(285620, '1ldjA02', NULL, NULL, 123, NULL, NULL, 235136),
(285621, '1ldjA01', NULL, NULL, 160, NULL, NULL, 235136),
(285622, '4jghD01', NULL, NULL, 137, NULL, NULL, 235136),
(285623, '4eozB01', NULL, NULL, 133, NULL, NULL, 235136),
(285624, '4eozD02', NULL, NULL, 124, NULL, NULL, 235136),
(285625, '4eozD01', NULL, NULL, 133, NULL, NULL, 235136),
(285626, '2wzkA02', NULL, NULL, 127, NULL, NULL, 235136),
(285627, '2wzkA01', NULL, NULL, 146, NULL, NULL, 235136),
(285628, '3dqvD01', NULL, NULL, 119, NULL, NULL, 235136),
(285629, '3dqvC01', NULL, NULL, 119, NULL, NULL, 235136),
(285630, '2wzkA03', NULL, NULL, 110, NULL, NULL, 235136),
(285631, '4ecoB00', NULL, NULL, 613, NULL, NULL, 235137),
(285632, '3jb9j00', NULL, NULL, 162, NULL, NULL, 235137),
(285633, '4r6gA00', NULL, NULL, 464, NULL, NULL, 235137),
(285634, '2o6sA00', NULL, NULL, 208, NULL, NULL, 235137),
(285635, '4u7lA01', NULL, NULL, 323, NULL, NULL, 235137),
(285636, '4u7lA02', NULL, NULL, 133, NULL, NULL, 235137),
(285637, '2z62A00', NULL, NULL, 276, NULL, NULL, 235137),
(285638, '4b8cD01', NULL, NULL, 203, NULL, NULL, 235137),
(285639, '5ijcA00', NULL, NULL, 594, NULL, NULL, 235137),
(285640, '2z80B00', NULL, NULL, 327, NULL, NULL, 235137),
(285641, '4r5cA00', NULL, NULL, 304, NULL, NULL, 235137),
(285642, '3bz5A01', NULL, NULL, 371, NULL, NULL, 235137),
(285643, '1h6uA02', NULL, NULL, 162, NULL, NULL, 235137),
(285644, '4pufA01', NULL, NULL, 304, NULL, NULL, 235137),
(285645, '1io0A00', NULL, NULL, 166, NULL, NULL, 235137),
(285646, '3tsrE00', NULL, NULL, 457, NULL, NULL, 235137),
(285647, '2z7xB00', NULL, NULL, 520, NULL, NULL, 235137),
(285648, '4cilA01', NULL, NULL, 211, NULL, NULL, 235137),
(285649, '4u09A00', NULL, NULL, 401, NULL, NULL, 235137),
(285650, '1xwdC00', NULL, NULL, 252, NULL, NULL, 235137),
(285651, '4v2eA00', NULL, NULL, 331, NULL, NULL, 235137),
(285652, '4ufrC01', NULL, NULL, 456, NULL, NULL, 235137),
(285653, '2v9tB00', NULL, NULL, 220, NULL, NULL, 235137); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(285654, '4bv4R00', NULL, NULL, 446, NULL, NULL, 235137),
(285655, '4u06A00', NULL, NULL, 344, NULL, NULL, 235137),
(285656, '4mn8B00', NULL, NULL, 175, NULL, NULL, 235137),
(285657, '3vq2A00', NULL, NULL, 586, NULL, NULL, 235137),
(285658, '6f4jA00', NULL, NULL, 176, NULL, NULL, 235137),
(285659, '4qxeA01', NULL, NULL, 436, NULL, NULL, 235137),
(285660, '3rezC00', NULL, NULL, 129, NULL, NULL, 235137),
(285661, '2id5A01', NULL, NULL, 368, NULL, NULL, 235137),
(285662, '4ojuC00', NULL, NULL, 148, NULL, NULL, 235137),
(285663, '2o6qA00', NULL, NULL, 270, NULL, NULL, 235137),
(285664, '4rcaB00', NULL, NULL, 251, NULL, NULL, 235137),
(285665, '3rfjA00', NULL, NULL, 279, NULL, NULL, 235137),
(285666, '4pq8A00', NULL, NULL, 248, NULL, NULL, 235137),
(285667, '3wpcA00', NULL, NULL, 754, NULL, NULL, 235137),
(285668, '2ca6A00', NULL, NULL, 345, NULL, NULL, 235137),
(285669, '3zyiA01', NULL, NULL, 306, NULL, NULL, 235137),
(285670, '3g39A00', NULL, NULL, 170, NULL, NULL, 235137),
(285671, '2wfhA00', NULL, NULL, 193, NULL, NULL, 235137),
(285672, '1a9nC00', NULL, NULL, 176, NULL, NULL, 235137),
(285673, '4z8gA00', NULL, NULL, 175, NULL, NULL, 235137),
(285674, '5hzlB01', NULL, NULL, 201, NULL, NULL, 235137),
(285675, '4fhoB00', NULL, NULL, 231, NULL, NULL, 235137),
(285676, '3cigA00', NULL, NULL, 671, NULL, NULL, 235137),
(285677, '4aw4A02', NULL, NULL, 162, NULL, NULL, 235137),
(285678, '3a79B00', NULL, NULL, 530, NULL, NULL, 235137),
(285679, '3e6jA00', NULL, NULL, 229, NULL, NULL, 235137),
(285680, '4perA00', NULL, NULL, 460, NULL, NULL, 235137),
(285681, '4wwuH01', NULL, NULL, 161, NULL, NULL, 235137),
(285682, '3e4gA00', NULL, NULL, 176, NULL, NULL, 235137),
(285683, '5il7A00', NULL, NULL, 447, NULL, NULL, 235137),
(285684, '1ogqA00', NULL, NULL, 313, NULL, NULL, 235137),
(285685, '4hq1A02', NULL, NULL, 126, NULL, NULL, 235137),
(285686, '4hq1A01', NULL, NULL, 298, NULL, NULL, 235137),
(285687, '4psjA00', NULL, NULL, 271, NULL, NULL, 235137),
(285688, '4r6fA00', NULL, NULL, 331, NULL, NULL, 235137),
(285689, '4cnmA00', NULL, NULL, 299, NULL, NULL, 235137),
(285690, '4im6A00', NULL, NULL, 206, NULL, NULL, 235137),
(285691, '4kxfP04', NULL, NULL, 416, NULL, NULL, 235137),
(285692, '4ecnA03', NULL, NULL, 613, NULL, NULL, 235137),
(285693, '3wpfA00', NULL, NULL, 770, NULL, NULL, 235137),
(285694, '5b4pC00', NULL, NULL, 261, NULL, NULL, 235137),
(285695, '1z7xW00', NULL, NULL, 461, NULL, NULL, 235137),
(285696, '4xsqB00', NULL, NULL, 183, NULL, NULL, 235137),
(285697, '5d3iA00', NULL, NULL, 568, NULL, NULL, 235137),
(285698, '1ziwA00', NULL, NULL, 638, NULL, NULL, 235137),
(285699, '3g06A01', NULL, NULL, 325, NULL, NULL, 235137),
(285700, '2ifgA01', NULL, NULL, 156, NULL, NULL, 235137),
(285701, '4arnA00', NULL, NULL, 279, NULL, NULL, 235137),
(285702, '2r9uA00', NULL, NULL, 174, NULL, NULL, 235137),
(285703, '2z66A00', NULL, NULL, 306, NULL, NULL, 235137),
(285704, '4q62A00', NULL, NULL, 422, NULL, NULL, 235137),
(285705, '4wp6A00', NULL, NULL, 165, NULL, NULL, 235137),
(285706, '3wn4A00', NULL, NULL, 811, NULL, NULL, 235137),
(285707, '4xosA00', NULL, NULL, 152, NULL, NULL, 235137),
(285708, '4nkhE00', NULL, NULL, 239, NULL, NULL, 235137),
(285709, '4glpA00', NULL, NULL, 310, NULL, NULL, 235137),
(285710, '4p8sA00', NULL, NULL, 282, NULL, NULL, 235137),
(285711, '3sb4A01', NULL, NULL, 176, NULL, NULL, 235137),
(285712, '4fmzB00', NULL, NULL, 347, NULL, NULL, 235137),
(285713, '3sb4A02', NULL, NULL, 153, NULL, NULL, 235137),
(285714, '4li1A01', NULL, NULL, 430, NULL, NULL, 235137),
(285715, '1ds9A00', NULL, NULL, 198, NULL, NULL, 235137),
(285716, '3wpeA00', NULL, NULL, 732, NULL, NULL, 235137),
(285717, '1o6vB01', NULL, NULL, 384, NULL, NULL, 235137),
(285718, '3rfeA00', NULL, NULL, 130, NULL, NULL, 235137),
(285719, '5wfnC00', NULL, NULL, 199, NULL, NULL, 235137),
(285720, '6ejxA00', NULL, NULL, 278, NULL, NULL, 235137),
(285721, '4fdwA02', NULL, NULL, 302, NULL, NULL, 235137),
(285722, '3un9A01', NULL, NULL, 225, NULL, NULL, 235137),
(285723, '4q3iA00', NULL, NULL, 220, NULL, NULL, 235137),
(285724, '4kt1A01', NULL, NULL, 449, NULL, NULL, 235137);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(285725, '2ellA00', NULL, NULL, 168, NULL, NULL, 235137),
(285726, '4h09D00', NULL, NULL, 379, NULL, NULL, 235137),
(285727, '3o6nA00', NULL, NULL, 390, NULL, NULL, 235137),
(285728, '4i6jB02', NULL, NULL, 352, NULL, NULL, 235137),
(285729, '1xkuA00', NULL, NULL, 309, NULL, NULL, 235137),
(285730, '1jl5A00', NULL, NULL, 353, NULL, NULL, 235137),
(285731, '5a5cB00', NULL, NULL, 332, NULL, NULL, 235137),
(285732, '1pgvA00', NULL, NULL, 171, NULL, NULL, 235137),
(285733, '6fg8A00', NULL, NULL, 188, NULL, NULL, 235137),
(285734, '6dbgA01', NULL, NULL, 213, NULL, NULL, 235137),
(285735, '4ezgA00', NULL, NULL, 197, NULL, NULL, 235137),
(285736, '2o6rA00', NULL, NULL, 177, NULL, NULL, 235137),
(285737, '2z63A00', NULL, NULL, 570, NULL, NULL, 235137),
(285738, '4fs7A00', NULL, NULL, 394, NULL, NULL, 235137),
(285739, '4g8aA00', NULL, NULL, 611, NULL, NULL, 235137),
(285740, '4fd0A02', NULL, NULL, 302, NULL, NULL, 235137),
(285741, '3zynB00', NULL, NULL, 321, NULL, NULL, 235137),
(285742, '4gt6A00', NULL, NULL, 394, NULL, NULL, 235137),
(285743, '4k17B03', NULL, NULL, 510, NULL, NULL, 235137),
(285744, '4r5dA02', NULL, NULL, 183, NULL, NULL, 235137),
(285745, '2ft3F00', NULL, NULL, 308, NULL, NULL, 235137),
(285746, '6if5B00', NULL, NULL, 823, NULL, NULL, 235137),
(285747, '2z81A00', NULL, NULL, 549, NULL, NULL, 235137),
(285748, '2astB00', NULL, NULL, 336, NULL, NULL, 235137),
(285749, '3cvrA01', NULL, NULL, 255, NULL, NULL, 235137),
(285750, '1dceA03', NULL, NULL, 136, NULL, NULL, 235137),
(285751, '3rgzA01', NULL, NULL, 691, NULL, NULL, 235137),
(285752, '4xgoA00', NULL, NULL, 356, NULL, NULL, 235137),
(285753, '2xwtC00', NULL, NULL, 239, NULL, NULL, 235137),
(285754, '1p9aG00', NULL, NULL, 266, NULL, NULL, 235137),
(285755, '4v2dA00', NULL, NULL, 326, NULL, NULL, 235137),
(285756, '5lfnD00', NULL, NULL, 337, NULL, NULL, 235137),
(285757, '1wwlB00', NULL, NULL, 312, NULL, NULL, 235137),
(285758, '6dbfA00', NULL, NULL, 213, NULL, NULL, 235137),
(285759, '3rw6A02', NULL, NULL, 160, NULL, NULL, 235137),
(285760, '1oznA00', NULL, NULL, 285, NULL, NULL, 235137),
(285761, '4y61B00', NULL, NULL, 244, NULL, NULL, 235137),
(285762, '4z79A00', NULL, NULL, 188, NULL, NULL, 235137),
(285763, '3o53A00', NULL, NULL, 317, NULL, NULL, 235137),
(285764, '4lxrA02', NULL, NULL, 199, NULL, NULL, 235137),
(285765, '4tzhA00', NULL, NULL, 190, NULL, NULL, 235137),
(285766, '4r58A00', NULL, NULL, 220, NULL, NULL, 235137),
(285767, '2p1mB02', NULL, NULL, 531, NULL, NULL, 235137),
(285768, '4j0mA01', NULL, NULL, 682, NULL, NULL, 235137),
(285769, '3m19A00', NULL, NULL, 251, NULL, NULL, 235137),
(285770, '6g3wA00', NULL, NULL, 187, NULL, NULL, 235137),
(285771, '3gozA01', NULL, NULL, 310, NULL, NULL, 235137),
(285772, '2jqdA00', NULL, NULL, 169, NULL, NULL, 235137),
(285773, '1xeuA01', NULL, NULL, 180, NULL, NULL, 235137),
(285774, '4pkiG02', NULL, NULL, 171, NULL, NULL, 235137),
(285775, '4l3fA01', NULL, NULL, 179, NULL, NULL, 235137),
(285776, '5z8xA00', NULL, NULL, 328, NULL, NULL, 235137),
(285777, '4cp6A00', NULL, NULL, 417, NULL, NULL, 235137),
(285778, '2ra8A02', NULL, NULL, 286, NULL, NULL, 235137),
(285779, '2z7xA00', NULL, NULL, 549, NULL, NULL, 235137),
(285780, '4fcgA00', NULL, NULL, 312, NULL, NULL, 235137),
(285781, '5o0mA00', NULL, NULL, 323, NULL, NULL, 235137),
(285782, '4ay9X00', NULL, NULL, 315, NULL, NULL, 235137),
(285783, '2bnhA00', NULL, NULL, 457, NULL, NULL, 235137),
(285784, '5b0nA00', NULL, NULL, 224, NULL, NULL, 235137),
(285785, '3rfsA00', NULL, NULL, 272, NULL, NULL, 235137),
(285786, '3zyjA01', NULL, NULL, 298, NULL, NULL, 235137),
(285787, '3ogkH02', NULL, NULL, 540, NULL, NULL, 235137),
(285788, '4u08A00', NULL, NULL, 398, NULL, NULL, 235137),
(285789, '2v70A00', NULL, NULL, 220, NULL, NULL, 235137),
(285790, '3rg1E00', NULL, NULL, 596, NULL, NULL, 235137),
(285791, '1w8aA00', NULL, NULL, 192, NULL, NULL, 235137),
(285792, '4l3aA02', NULL, NULL, 157, NULL, NULL, 235137),
(285793, '2xotB01', NULL, NULL, 255, NULL, NULL, 235137),
(285794, '4rcwA00', NULL, NULL, 240, NULL, NULL, 235137),
(285795, '4r6jA00', NULL, NULL, 254, NULL, NULL, 235137);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(285796, '4peqB00', NULL, NULL, 456, NULL, NULL, 235137),
(285797, '2mjmA00', NULL, NULL, 101, NULL, NULL, 235138),
(285798, '2fz0A00', NULL, NULL, 149, NULL, NULL, 235139),
(285799, '3oymA01', NULL, NULL, 93, NULL, NULL, 235140),
(285800, '4nzgA00', NULL, NULL, 100, NULL, NULL, 235140),
(285801, '5a5hH00', NULL, NULL, 209, NULL, NULL, 235141),
(285802, '4akgA01', NULL, NULL, 221, NULL, NULL, 235141),
(285803, '4zb7A00', NULL, NULL, 222, NULL, NULL, 235141),
(285804, '4w66B00', NULL, NULL, 243, NULL, NULL, 235141),
(285805, '5a1nA00', NULL, NULL, 175, NULL, NULL, 235141),
(285806, '4q5qB00', NULL, NULL, 201, NULL, NULL, 235141),
(285807, '3bf0A02', NULL, NULL, 98, NULL, NULL, 235142),
(285808, '1jjdA00', NULL, NULL, 55, NULL, NULL, 235143),
(285809, '2z4iA01', NULL, NULL, 98, NULL, NULL, 235144),
(285810, '2z4iB01', NULL, NULL, 77, NULL, NULL, 235144),
(285811, '3hl6A02', NULL, NULL, 150, NULL, NULL, 235145),
(285812, '1jb7B00', NULL, NULL, 224, NULL, NULL, 235146),
(285813, '2f6sA00', NULL, NULL, 181, NULL, NULL, 235147),
(285814, '4xi8A00', NULL, NULL, 222, NULL, NULL, 235147),
(285815, '3shgA00', NULL, NULL, 205, NULL, NULL, 235147),
(285816, '4n67A00', NULL, NULL, 227, NULL, NULL, 235147),
(285817, '4wgjA00', NULL, NULL, 227, NULL, NULL, 235147),
(285818, '5nh2A01', NULL, NULL, 236, NULL, NULL, 235147),
(285819, '3cucA00', NULL, NULL, 291, NULL, NULL, 235147),
(285820, '4m16A00', NULL, NULL, 241, NULL, NULL, 235147),
(285821, '3n3uA00', NULL, NULL, 299, NULL, NULL, 235147),
(285822, '5jffA00', NULL, NULL, 191, NULL, NULL, 235147),
(285823, '4py3F00', NULL, NULL, 219, NULL, NULL, 235147),
(285824, '4x2cA00', NULL, NULL, 235, NULL, NULL, 235147),
(285825, '4u04A02', NULL, NULL, 253, NULL, NULL, 235147),
(285826, '3letA00', NULL, NULL, 314, NULL, NULL, 235147),
(285827, '5jj6B02', NULL, NULL, 241, NULL, NULL, 235147),
(285828, '5eu0A00', NULL, NULL, 224, NULL, NULL, 235147),
(285829, '5cklA00', NULL, NULL, 188, NULL, NULL, 235147),
(285830, '4npsA01', NULL, NULL, 237, NULL, NULL, 235147),
(285831, '2g03A00', NULL, NULL, 194, NULL, NULL, 235147),
(285832, '6i1yA01', NULL, NULL, 67, NULL, NULL, 235148),
(285833, '3gr5A02', NULL, NULL, 68, NULL, NULL, 235148),
(285834, '4g08A02', NULL, NULL, 75, NULL, NULL, 235148),
(285835, '6i1yA02', NULL, NULL, 72, NULL, NULL, 235148),
(285836, '4e9jA02', NULL, NULL, 73, NULL, NULL, 235148),
(285837, '4e9jB01', NULL, NULL, 153, NULL, NULL, 235148),
(285838, '2y3mB01', NULL, NULL, 114, NULL, NULL, 235148),
(285839, '5wq8A01', NULL, NULL, 68, NULL, NULL, 235148),
(285840, '5wq7A02', NULL, NULL, 73, NULL, NULL, 235148),
(285841, '5wq8A02', NULL, NULL, 72, NULL, NULL, 235148),
(285842, '5wq7A01', NULL, NULL, 68, NULL, NULL, 235148),
(285843, '3ossD00', NULL, NULL, 181, NULL, NULL, 235148),
(285844, '3ezjA03', NULL, NULL, 70, NULL, NULL, 235148),
(285845, '3ezjA02', NULL, NULL, 68, NULL, NULL, 235148),
(285846, '3u28B01', NULL, NULL, 30, NULL, NULL, 235149),
(285847, '4idoA02', NULL, NULL, 116, NULL, NULL, 235150),
(285848, '1z8uC00', NULL, NULL, 102, NULL, NULL, 235150),
(285849, '3x1dA02', NULL, NULL, 93, NULL, NULL, 235150),
(285850, '3vygD00', NULL, NULL, 126, NULL, NULL, 235151),
(285851, '1pseA00', NULL, NULL, 69, NULL, NULL, 235151),
(285852, '3hhtB02', NULL, NULL, 97, NULL, NULL, 235151),
(285853, '1dj7B00', NULL, NULL, 75, NULL, NULL, 235151),
(285854, '5l8rE00', NULL, NULL, 66, NULL, NULL, 235151),
(285855, '3a8gB02', NULL, NULL, 102, NULL, NULL, 235151),
(285856, '1jb0E00', NULL, NULL, 75, NULL, NULL, 235151),
(285857, '1v29B02', NULL, NULL, 97, NULL, NULL, 235151),
(285858, '4ob0B02', NULL, NULL, 104, NULL, NULL, 235151),
(285859, '4xk8E00', NULL, NULL, 64, NULL, NULL, 235151),
(285860, '4zgjB02', NULL, NULL, 101, NULL, NULL, 235151),
(285861, '6ijjE00', NULL, NULL, 65, NULL, NULL, 235151),
(285862, '5zgbE00', NULL, NULL, 62, NULL, NULL, 235151),
(285863, '5oy0500', NULL, NULL, 69, NULL, NULL, 235151),
(285864, '1qp2A00', NULL, NULL, 70, NULL, NULL, 235151),
(285865, '2wscE00', NULL, NULL, 65, NULL, NULL, 235151),
(285866, '3qyhB02', NULL, NULL, 98, NULL, NULL, 235151);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(285867, '6igzE00', NULL, NULL, 61, NULL, NULL, 235151),
(285868, '5zjiE00', NULL, NULL, 68, NULL, NULL, 235151),
(285869, '3tw8A03', NULL, NULL, 41, NULL, NULL, 235152),
(285870, '2bpa100', NULL, NULL, 426, NULL, NULL, 235153),
(285871, '1gff100', NULL, NULL, 426, NULL, NULL, 235153),
(285872, '1m06F00', NULL, NULL, 431, NULL, NULL, 235153),
(285873, '1no1A00', NULL, NULL, 67, NULL, NULL, 235154),
(285874, '1musA03', NULL, NULL, 126, NULL, NULL, 235155),
(285875, '3mr0A02', NULL, NULL, 21, NULL, NULL, 235156),
(285876, '5dynA01', NULL, NULL, 118, NULL, NULL, 235157),
(285877, '4yecA01', NULL, NULL, 112, NULL, NULL, 235157),
(285878, '3l7iA02', NULL, NULL, 183, NULL, NULL, 235158),
(285879, '4bl7B01', NULL, NULL, 67, NULL, NULL, 235159),
(285880, '2uz8A01', NULL, NULL, 55, NULL, NULL, 235159),
(285881, '4bvxB01', NULL, NULL, 57, NULL, NULL, 235159),
(285882, '4lhfA00', NULL, NULL, 91, NULL, NULL, 235160),
(285883, '1rlhA01', NULL, NULL, 54, NULL, NULL, 235161),
(285884, '2zuoA09', NULL, NULL, 63, NULL, NULL, 235162),
(285885, '3gf5A01', NULL, NULL, 54, NULL, NULL, 235162),
(285886, '2zuoA01', NULL, NULL, 56, NULL, NULL, 235162),
(285887, '2ffjB03', NULL, NULL, 149, NULL, NULL, 235163),
(285888, '2g8lA03', NULL, NULL, 154, NULL, NULL, 235163),
(285889, '1xqbA02', NULL, NULL, 92, NULL, NULL, 235164),
(285890, '3aaiA00', NULL, NULL, 94, NULL, NULL, 235165),
(285891, '5lbmA00', NULL, NULL, 91, NULL, NULL, 235165),
(285892, '4m1pA00', NULL, NULL, 104, NULL, NULL, 235165),
(285893, '5lcyA00', NULL, NULL, 91, NULL, NULL, 235165),
(285894, '5fmnA00', NULL, NULL, 86, NULL, NULL, 235165),
(285895, '4adzA00', NULL, NULL, 90, NULL, NULL, 235165),
(285896, '2hh7A00', NULL, NULL, 88, NULL, NULL, 235165),
(285897, '1nfkA01', NULL, NULL, 203, NULL, NULL, 235166),
(285898, '2v2tA01', NULL, NULL, 184, NULL, NULL, 235166),
(285899, '1nfiA01', NULL, NULL, 170, NULL, NULL, 235166),
(285900, '6ggrA00', NULL, NULL, 170, NULL, NULL, 235166),
(285901, '1gjiA01', NULL, NULL, 172, NULL, NULL, 235166),
(285902, '1a66A00', NULL, NULL, 178, NULL, NULL, 235166),
(285903, '1bvoA00', NULL, NULL, 175, NULL, NULL, 235166),
(285904, '1p7hL01', NULL, NULL, 173, NULL, NULL, 235166),
(285905, '1a3qA01', NULL, NULL, 179, NULL, NULL, 235166),
(285906, '1imhC01', NULL, NULL, 170, NULL, NULL, 235166),
(285907, '1uurA02', NULL, NULL, 133, NULL, NULL, 235166),
(285908, '3n40P01', NULL, NULL, 56, NULL, NULL, 235167),
(285909, '6immR00', NULL, NULL, 69, NULL, NULL, 235167),
(285910, '1sgoA01', NULL, NULL, 108, NULL, NULL, 235168),
(285911, '1mw9X01', NULL, NULL, 163, NULL, NULL, 235169),
(285912, '5uj1A01', NULL, NULL, 145, NULL, NULL, 235169),
(285913, '4cgyA01', NULL, NULL, 176, NULL, NULL, 235169),
(285914, '2gaiA01', NULL, NULL, 135, NULL, NULL, 235169),
(285915, '1gkuB05', NULL, NULL, 121, NULL, NULL, 235169),
(285916, '4dduA05', NULL, NULL, 122, NULL, NULL, 235169),
(285917, '5gvcB01', NULL, NULL, 173, NULL, NULL, 235169),
(285918, '1i7dA01', NULL, NULL, 156, NULL, NULL, 235169),
(285919, '3u8vA00', NULL, NULL, 93, NULL, NULL, 235170),
(285920, '2lfdA00', NULL, NULL, 115, NULL, NULL, 235170),
(285921, '1y4cA03', NULL, NULL, 114, NULL, NULL, 235170),
(285922, '2hz8A00', NULL, NULL, 115, NULL, NULL, 235170),
(285923, '5u1xA01', NULL, NULL, 67, NULL, NULL, 235171),
(285924, '4dw0A01', NULL, NULL, 66, NULL, NULL, 235171),
(285925, '5svlA01', NULL, NULL, 80, NULL, NULL, 235171),
(285926, '5f1cA01', NULL, NULL, 74, NULL, NULL, 235171),
(285927, '5svlB01', NULL, NULL, 55, NULL, NULL, 235171),
(285928, '4aibA01', NULL, NULL, 166, NULL, NULL, 235172),
(285929, '7odcA01', NULL, NULL, 192, NULL, NULL, 235172),
(285930, '6a2fA01', NULL, NULL, 150, NULL, NULL, 235172),
(285931, '4dzaA01', NULL, NULL, 154, NULL, NULL, 235172),
(285932, '6n2aA01', NULL, NULL, 178, NULL, NULL, 235172),
(285933, '3uw6A01', NULL, NULL, 152, NULL, NULL, 235172),
(285934, '1qu4A01', NULL, NULL, 157, NULL, NULL, 235172),
(285935, '4y2wA01', NULL, NULL, 156, NULL, NULL, 235172),
(285936, '3n29B01', NULL, NULL, 151, NULL, NULL, 235172),
(285937, '4bf5A01', NULL, NULL, 178, NULL, NULL, 235172);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(285938, '1knwA01', NULL, NULL, 180, NULL, NULL, 235172),
(285939, '3kw3B01', NULL, NULL, 147, NULL, NULL, 235172),
(285940, '4lusB01', NULL, NULL, 152, NULL, NULL, 235172),
(285941, '4xg1A01', NULL, NULL, 185, NULL, NULL, 235172),
(285942, '3n2bD01', NULL, NULL, 174, NULL, NULL, 235172),
(285943, '3mt1A01', NULL, NULL, 138, NULL, NULL, 235172),
(285944, '4qhrA01', NULL, NULL, 148, NULL, NULL, 235172),
(285945, '2yxxA01', NULL, NULL, 144, NULL, NULL, 235172),
(285946, '4beuA01', NULL, NULL, 175, NULL, NULL, 235172),
(285947, '2j66A01', NULL, NULL, 173, NULL, NULL, 235172),
(285948, '1bd0B02', NULL, NULL, 158, NULL, NULL, 235172),
(285949, '2nvaA01', NULL, NULL, 128, NULL, NULL, 235172),
(285950, '2dy3D01', NULL, NULL, 136, NULL, NULL, 235172),
(285951, '1f3tA01', NULL, NULL, 147, NULL, NULL, 235172),
(285952, '4eclA01', NULL, NULL, 153, NULL, NULL, 235172),
(285953, '3n2oC01', NULL, NULL, 209, NULL, NULL, 235172),
(285954, '3hurA01', NULL, NULL, 172, NULL, NULL, 235172),
(285955, '2odoA01', NULL, NULL, 150, NULL, NULL, 235172),
(285956, '1twiA01', NULL, NULL, 178, NULL, NULL, 235172),
(285957, '3co8A01', NULL, NULL, 159, NULL, NULL, 235172),
(285958, '5yycA01', NULL, NULL, 136, NULL, NULL, 235172),
(285959, '2oo0B01', NULL, NULL, 181, NULL, NULL, 235172),
(285960, '3s46A01', NULL, NULL, 149, NULL, NULL, 235172),
(285961, '4wr3C01', NULL, NULL, 151, NULL, NULL, 235172),
(285962, '3btnA01', NULL, NULL, 142, NULL, NULL, 235172),
(285963, '5gjoB01', NULL, NULL, 159, NULL, NULL, 235172),
(285964, '1xfcA01', NULL, NULL, 152, NULL, NULL, 235172),
(285965, '2pljA01', NULL, NULL, 159, NULL, NULL, 235172),
(285966, '3vabA01', NULL, NULL, 182, NULL, NULL, 235172),
(285967, '2qghA01', NULL, NULL, 143, NULL, NULL, 235172),
(285968, '2vd8A01', NULL, NULL, 158, NULL, NULL, 235172),
(285969, '3nzqA01', NULL, NULL, 198, NULL, NULL, 235172),
(285970, '6q71A01', NULL, NULL, 158, NULL, NULL, 235172),
(285971, '1rcqA01', NULL, NULL, 150, NULL, NULL, 235172),
(285972, '1d7kB01', NULL, NULL, 141, NULL, NULL, 235172),
(285973, '5fagA01', NULL, NULL, 150, NULL, NULL, 235172),
(285974, '4bhyB01', NULL, NULL, 170, NULL, NULL, 235172),
(285975, '2o0tA01', NULL, NULL, 188, NULL, NULL, 235172),
(285976, '3ha1A01', NULL, NULL, 164, NULL, NULL, 235172),
(285977, '3e5pB01', NULL, NULL, 149, NULL, NULL, 235172),
(285978, '5x7nB01', NULL, NULL, 196, NULL, NULL, 235172),
(285979, '2p3eA01', NULL, NULL, 179, NULL, NULL, 235172),
(285980, '4dyjA01', NULL, NULL, 167, NULL, NULL, 235172),
(285981, '1vfsA01', NULL, NULL, 151, NULL, NULL, 235172),
(285982, '3nzpB01', NULL, NULL, 182, NULL, NULL, 235172),
(285983, '6g58A01', NULL, NULL, 153, NULL, NULL, 235172),
(285984, '2obeA04', NULL, NULL, 208, NULL, NULL, 235173),
(285985, '1p2zA04', NULL, NULL, 208, NULL, NULL, 235173),
(285986, '5tipA01', NULL, NULL, 188, NULL, NULL, 235173),
(285987, '1dp3A00', NULL, NULL, 55, NULL, NULL, 235174),
(285988, '3omyA00', NULL, NULL, 52, NULL, NULL, 235174),
(285989, '4qpoD00', NULL, NULL, 53, NULL, NULL, 235174),
(285990, '2h5eA03', NULL, NULL, 140, NULL, NULL, 235175),
(285991, '3vqtB03', NULL, NULL, 141, NULL, NULL, 235175),
(285992, '3tr5A03', NULL, NULL, 140, NULL, NULL, 235175),
(285993, '4ccjA02', NULL, NULL, 64, NULL, NULL, 235176),
(285994, '4bxfA02', NULL, NULL, 63, NULL, NULL, 235176),
(285995, '3qs2A00', NULL, NULL, 188, NULL, NULL, 235177),
(285996, '3qs3A00', NULL, NULL, 191, NULL, NULL, 235177),
(285997, '2gbbB00', NULL, NULL, 156, NULL, NULL, 235178),
(285998, '5vhtA00', NULL, NULL, 99, NULL, NULL, 235178),
(285999, '5hubA00', NULL, NULL, 90, NULL, NULL, 235178),
(286000, '1ybzA00', NULL, NULL, 91, NULL, NULL, 235178),
(286001, '5j6fA01', NULL, NULL, 94, NULL, NULL, 235178),
(286002, '2fp1B00', NULL, NULL, 166, NULL, NULL, 235178),
(286003, '5gmuB00', NULL, NULL, 90, NULL, NULL, 235178),
(286004, '6cnzF00', NULL, NULL, 180, NULL, NULL, 235178),
(286005, '5mpvD00', NULL, NULL, 90, NULL, NULL, 235178),
(286006, '3nvtB01', NULL, NULL, 86, NULL, NULL, 235178),
(286007, '3nvtA01', NULL, NULL, 87, NULL, NULL, 235178),
(286008, '3rmiA00', NULL, NULL, 114, NULL, NULL, 235178);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(286009, '1ecmB00', NULL, NULL, 109, NULL, NULL, 235178),
(286010, '2gtvX00', NULL, NULL, 104, NULL, NULL, 235178),
(286011, '2vklA00', NULL, NULL, 90, NULL, NULL, 235178),
(286012, '5ts9B00', NULL, NULL, 173, NULL, NULL, 235178),
(286013, '3retA00', NULL, NULL, 101, NULL, NULL, 235178),
(286014, '2d8dB00', NULL, NULL, 90, NULL, NULL, 235178),
(286015, '2qgpB00', NULL, NULL, 112, NULL, NULL, 235179),
(286016, '4h9dB00', NULL, NULL, 95, NULL, NULL, 235179),
(286017, '2rprA00', NULL, NULL, 87, NULL, NULL, 235180),
(286018, '4bx9C00', NULL, NULL, 99, NULL, NULL, 235181),
(286019, '1whsB02', NULL, NULL, 95, NULL, NULL, 235182),
(286020, '1gxsB02', NULL, NULL, 98, NULL, NULL, 235182),
(286021, '5dc8A00', NULL, NULL, 389, NULL, NULL, 235183),
(286022, '3c10B00', NULL, NULL, 388, NULL, NULL, 235183),
(286023, '4zurA00', NULL, NULL, 341, NULL, NULL, 235183),
(286024, '5td7A01', NULL, NULL, 362, NULL, NULL, 235183),
(286025, '5wgiA00', NULL, NULL, 364, NULL, NULL, 235183),
(286026, '5ji5A00', NULL, NULL, 315, NULL, NULL, 235183),
(286027, '4a69A00', NULL, NULL, 376, NULL, NULL, 235183),
(286028, '5g1aB00', NULL, NULL, 371, NULL, NULL, 235183),
(286029, '5g0xA00', NULL, NULL, 379, NULL, NULL, 235183),
(286030, '1c3pA00', NULL, NULL, 375, NULL, NULL, 235183),
(286031, '6fu1A00', NULL, NULL, 446, NULL, NULL, 235183),
(286032, '5g0gA00', NULL, NULL, 360, NULL, NULL, 235183),
(286033, '4bkxB00', NULL, NULL, 376, NULL, NULL, 235183),
(286034, '2vqqA00', NULL, NULL, 413, NULL, NULL, 235183),
(286035, '4ly1A00', NULL, NULL, 369, NULL, NULL, 235183),
(286036, '3menB00', NULL, NULL, 342, NULL, NULL, 235183),
(286037, '2vqmA00', NULL, NULL, 413, NULL, NULL, 235183),
(286038, '3topA01', NULL, NULL, 46, NULL, NULL, 235184),
(286039, '5kzwA01', NULL, NULL, 50, NULL, NULL, 235184),
(286040, '1e9tA00', NULL, NULL, 59, NULL, NULL, 235184),
(286041, '2pspA02', NULL, NULL, 40, NULL, NULL, 235184),
(286042, '1hi7A00', NULL, NULL, 60, NULL, NULL, 235184),
(286043, '2pspA01', NULL, NULL, 66, NULL, NULL, 235184),
(286044, '3l4yA01', NULL, NULL, 45, NULL, NULL, 235184),
(286045, '3lppA01', NULL, NULL, 47, NULL, NULL, 235184),
(286046, '3fmgA02', NULL, NULL, 87, NULL, NULL, 235185),
(286047, '1vsrA00', NULL, NULL, 136, NULL, NULL, 235186),
(286048, '3r3pB00', NULL, NULL, 105, NULL, NULL, 235186),
(286049, '1u53A00', NULL, NULL, 196, NULL, NULL, 235187),
(286050, '1xtaA01', NULL, NULL, 180, NULL, NULL, 235187),
(286051, '3q2uA00', NULL, NULL, 205, NULL, NULL, 235187),
(286052, '4ifaA01', NULL, NULL, 285, NULL, NULL, 235187),
(286053, '3nt8B02', NULL, NULL, 204, NULL, NULL, 235187),
(286054, '3s6sB00', NULL, NULL, 183, NULL, NULL, 235187),
(286055, '3nt8A01', NULL, NULL, 197, NULL, NULL, 235187),
(286056, '1rc9A01', NULL, NULL, 180, NULL, NULL, 235187),
(286057, '4tpvA00', NULL, NULL, 182, NULL, NULL, 235187),
(286058, '3u3lC00', NULL, NULL, 233, NULL, NULL, 235187),
(286059, '5vhgA00', NULL, NULL, 150, NULL, NULL, 235187),
(286060, '4aiwA00', NULL, NULL, 154, NULL, NULL, 235187),
(286061, '4h0aA00', NULL, NULL, 323, NULL, NULL, 235187),
(286062, '4g2uA00', NULL, NULL, 219, NULL, NULL, 235187),
(286063, '2vznB00', NULL, NULL, 218, NULL, NULL, 235187),
(286064, '5jysA00', NULL, NULL, 141, NULL, NULL, 235187),
(286065, '4d53A00', NULL, NULL, 138, NULL, NULL, 235187),
(286066, '2ddbB01', NULL, NULL, 169, NULL, NULL, 235187),
(286067, '6imfA01', NULL, NULL, 180, NULL, NULL, 235187),
(286068, '1cfeA00', NULL, NULL, 135, NULL, NULL, 235187),
(286069, '1qnxA00', NULL, NULL, 209, NULL, NULL, 235187),
(286070, '4p27A00', NULL, NULL, 162, NULL, NULL, 235187),
(286071, '2zcmA00', NULL, NULL, 192, NULL, NULL, 235188),
(286072, '3qqaA02', NULL, NULL, 146, NULL, NULL, 235188),
(286073, '3ppbA00', NULL, NULL, 195, NULL, NULL, 235188),
(286074, '5k7fA02', NULL, NULL, 143, NULL, NULL, 235188),
(286075, '2g3bA00', NULL, NULL, 188, NULL, NULL, 235188),
(286076, '3kz9D00', NULL, NULL, 206, NULL, NULL, 235188),
(286077, '2pz9A00', NULL, NULL, 197, NULL, NULL, 235188),
(286078, '5d18A00', NULL, NULL, 216, NULL, NULL, 235188),
(286079, '1sgmA00', NULL, NULL, 191, NULL, NULL, 235188);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(286080, '3frqB00', NULL, NULL, 195, NULL, NULL, 235188),
(286081, '2oi8A00', NULL, NULL, 216, NULL, NULL, 235188),
(286082, '2fq4A02', NULL, NULL, 137, NULL, NULL, 235188),
(286083, '4mk6A00', NULL, NULL, 189, NULL, NULL, 235188),
(286084, '2rasA01', NULL, NULL, 196, NULL, NULL, 235188),
(286085, '2qkoA00', NULL, NULL, 189, NULL, NULL, 235188),
(286086, '2hytA00', NULL, NULL, 197, NULL, NULL, 235188),
(286087, '3s5rB00', NULL, NULL, 216, NULL, NULL, 235188),
(286088, '2genA00', NULL, NULL, 197, NULL, NULL, 235188),
(286089, '3nxcA00', NULL, NULL, 190, NULL, NULL, 235188),
(286090, '5x5iA00', NULL, NULL, 189, NULL, NULL, 235188),
(286091, '2wuiA00', NULL, NULL, 210, NULL, NULL, 235188),
(286092, '2d6yA00', NULL, NULL, 202, NULL, NULL, 235188),
(286093, '5x5iE00', NULL, NULL, 189, NULL, NULL, 235188),
(286094, '3bqyA02', NULL, NULL, 152, NULL, NULL, 235188),
(286095, '3cjdA00', NULL, NULL, 198, NULL, NULL, 235188),
(286096, '3e7qA00', NULL, NULL, 215, NULL, NULL, 235188),
(286097, '2qibB00', NULL, NULL, 231, NULL, NULL, 235188),
(286098, '2nx4C00', NULL, NULL, 194, NULL, NULL, 235188),
(286099, '3cdlB02', NULL, NULL, 143, NULL, NULL, 235188),
(286100, '3ni7B00', NULL, NULL, 188, NULL, NULL, 235188),
(286101, '3g7rA00', NULL, NULL, 221, NULL, NULL, 235188),
(286102, '3colB00', NULL, NULL, 196, NULL, NULL, 235188),
(286103, '3vvyD00', NULL, NULL, 194, NULL, NULL, 235188),
(286104, '3eupB00', NULL, NULL, 204, NULL, NULL, 235188),
(286105, '5mruA02', NULL, NULL, 150, NULL, NULL, 235188),
(286106, '3bhqA00', NULL, NULL, 211, NULL, NULL, 235188),
(286107, '2zcxA00', NULL, NULL, 213, NULL, NULL, 235188),
(286108, '4yzeB00', NULL, NULL, 201, NULL, NULL, 235188),
(286109, '3lhqB00', NULL, NULL, 220, NULL, NULL, 235188),
(286110, '4jykA02', NULL, NULL, 143, NULL, NULL, 235188),
(286111, '4cgrB00', NULL, NULL, 216, NULL, NULL, 235188),
(286112, '1vi0A02', NULL, NULL, 155, NULL, NULL, 235188),
(286113, '3vuqB00', NULL, NULL, 187, NULL, NULL, 235188),
(286114, '4g12A02', NULL, NULL, 149, NULL, NULL, 235188),
(286115, '2y2zA02', NULL, NULL, 162, NULL, NULL, 235188),
(286116, '3mvpA02', NULL, NULL, 149, NULL, NULL, 235188),
(286117, '4gflB00', NULL, NULL, 190, NULL, NULL, 235188),
(286118, '3c07B00', NULL, NULL, 214, NULL, NULL, 235188),
(286119, '4mxmA00', NULL, NULL, 203, NULL, NULL, 235188),
(286120, '2v57A00', NULL, NULL, 190, NULL, NULL, 235188),
(286121, '2xdnB00', NULL, NULL, 210, NULL, NULL, 235188),
(286122, '4d5cA02', NULL, NULL, 141, NULL, NULL, 235188),
(286123, '3ccyA02', NULL, NULL, 147, NULL, NULL, 235188),
(286124, '3dpjF00', NULL, NULL, 194, NULL, NULL, 235188),
(286125, '2hxiB02', NULL, NULL, 150, NULL, NULL, 235188),
(286126, '3egqB00', NULL, NULL, 170, NULL, NULL, 235188),
(286127, '4w97A02', NULL, NULL, 149, NULL, NULL, 235188),
(286128, '3bcgA00', NULL, NULL, 215, NULL, NULL, 235188),
(286129, '3anpB00', NULL, NULL, 204, NULL, NULL, 235188),
(286130, '3geuA00', NULL, NULL, 189, NULL, NULL, 235188),
(286131, '2rekA00', NULL, NULL, 199, NULL, NULL, 235188),
(286132, '5fglA00', NULL, NULL, 208, NULL, NULL, 235188),
(286133, '3s5rA00', NULL, NULL, 216, NULL, NULL, 235188),
(286134, '4d5fA02', NULL, NULL, 141, NULL, NULL, 235188),
(286135, '2guhA00', NULL, NULL, 180, NULL, NULL, 235188),
(286136, '2qtqB00', NULL, NULL, 213, NULL, NULL, 235188),
(286137, '3htaC00', NULL, NULL, 217, NULL, NULL, 235188),
(286138, '5d1rB00', NULL, NULL, 239, NULL, NULL, 235188),
(286139, '3vokA00', NULL, NULL, 189, NULL, NULL, 235188),
(286140, '3vprA02', NULL, NULL, 146, NULL, NULL, 235188),
(286141, '5x5iD00', NULL, NULL, 189, NULL, NULL, 235188),
(286142, '2qwtA00', NULL, NULL, 196, NULL, NULL, 235188),
(286143, '2iaiA02', NULL, NULL, 149, NULL, NULL, 235188),
(286144, '3dewA02', NULL, NULL, 147, NULL, NULL, 235188),
(286145, '2of7A02', NULL, NULL, 140, NULL, NULL, 235188),
(286146, '2g7gA00', NULL, NULL, 213, NULL, NULL, 235188),
(286147, '2gfnA00', NULL, NULL, 209, NULL, NULL, 235188),
(286148, '1jusA02', NULL, NULL, 135, NULL, NULL, 235188),
(286149, '4kwaB00', NULL, NULL, 195, NULL, NULL, 235188),
(286150, '3knwB00', NULL, NULL, 212, NULL, NULL, 235188);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(286151, '5x5iH00', NULL, NULL, 189, NULL, NULL, 235188),
(286152, '3b81A00', NULL, NULL, 203, NULL, NULL, 235188),
(286153, '2dg7A00', NULL, NULL, 195, NULL, NULL, 235188),
(286154, '2id3A02', NULL, NULL, 142, NULL, NULL, 235188),
(286155, '3bqzA02', NULL, NULL, 144, NULL, NULL, 235188),
(286156, '3f0cA02', NULL, NULL, 158, NULL, NULL, 235188),
(286157, '3npiB00', NULL, NULL, 210, NULL, NULL, 235188),
(286158, '2g7lA00', NULL, NULL, 243, NULL, NULL, 235188),
(286159, '3fiwA02', NULL, NULL, 132, NULL, NULL, 235188),
(286160, '1ui6A00', NULL, NULL, 215, NULL, NULL, 235188),
(286161, '1rktA02', NULL, NULL, 151, NULL, NULL, 235188),
(286162, '3on2A00', NULL, NULL, 199, NULL, NULL, 235188),
(286163, '3on4D00', NULL, NULL, 191, NULL, NULL, 235188),
(286164, '2np3A00', NULL, NULL, 178, NULL, NULL, 235188),
(286165, '3rh2A00', NULL, NULL, 212, NULL, NULL, 235188),
(286166, '1zk8B02', NULL, NULL, 132, NULL, NULL, 235188),
(286167, '3f1bA00', NULL, NULL, 203, NULL, NULL, 235188),
(286168, '3egqA00', NULL, NULL, 170, NULL, NULL, 235188),
(286169, '2yveB00', NULL, NULL, 185, NULL, NULL, 235188),
(286170, '2np5D00', NULL, NULL, 203, NULL, NULL, 235188),
(286171, '5l0xA00', NULL, NULL, 199, NULL, NULL, 235188),
(286172, '3kkcA01', NULL, NULL, 170, NULL, NULL, 235188),
(286173, '3pasA00', NULL, NULL, 195, NULL, NULL, 235188),
(286174, '3qkxB00', NULL, NULL, 188, NULL, NULL, 235188),
(286175, '5c4yA00', NULL, NULL, 136, NULL, NULL, 235188),
(286176, '2guhB00', NULL, NULL, 179, NULL, NULL, 235188),
(286177, '2zb9A02', NULL, NULL, 148, NULL, NULL, 235188),
(286178, '2dg8D00', NULL, NULL, 193, NULL, NULL, 235188),
(286179, '2f07B00', NULL, NULL, 197, NULL, NULL, 235188),
(286180, '4aciA00', NULL, NULL, 191, NULL, NULL, 235188),
(286181, '5x5iC00', NULL, NULL, 189, NULL, NULL, 235188),
(286182, '3himA00', NULL, NULL, 211, NULL, NULL, 235188),
(286183, '3htaD00', NULL, NULL, 191, NULL, NULL, 235188),
(286184, '5hawA00', NULL, NULL, 196, NULL, NULL, 235188),
(286185, '3vibA00', NULL, NULL, 210, NULL, NULL, 235188),
(286186, '3bniB00', NULL, NULL, 187, NULL, NULL, 235188),
(286187, '1z0xB02', NULL, NULL, 151, NULL, NULL, 235188),
(286188, '3lwjA00', NULL, NULL, 202, NULL, NULL, 235188),
(286189, '5aqcB00', NULL, NULL, 205, NULL, NULL, 235188),
(286190, '4hkuB00', NULL, NULL, 178, NULL, NULL, 235188),
(286191, '3ljlA00', NULL, NULL, 156, NULL, NULL, 235188),
(286192, '3c2bA02', NULL, NULL, 155, NULL, NULL, 235188),
(286193, '4mo7A02', NULL, NULL, 142, NULL, NULL, 235188),
(286194, '4nn1A00', NULL, NULL, 218, NULL, NULL, 235188),
(286195, '5gp9A02', NULL, NULL, 145, NULL, NULL, 235188),
(286196, '5x5iG00', NULL, NULL, 189, NULL, NULL, 235188),
(286197, '3o60A00', NULL, NULL, 185, NULL, NULL, 235188),
(286198, '2fd5A02', NULL, NULL, 132, NULL, NULL, 235188),
(286199, '5nioA02', NULL, NULL, 149, NULL, NULL, 235188),
(286200, '2fbqA00', NULL, NULL, 216, NULL, NULL, 235188),
(286201, '3bjbD00', NULL, NULL, 185, NULL, NULL, 235188),
(286202, '2i10B02', NULL, NULL, 131, NULL, NULL, 235188),
(286203, '2q24A00', NULL, NULL, 194, NULL, NULL, 235188),
(286204, '2hxoA02', NULL, NULL, 159, NULL, NULL, 235188),
(286205, '2xpwA02', NULL, NULL, 141, NULL, NULL, 235188),
(286206, '1t33A02', NULL, NULL, 162, NULL, NULL, 235188),
(286207, '2np3B02', NULL, NULL, 130, NULL, NULL, 235188),
(286208, '3v6gA00', NULL, NULL, 185, NULL, NULL, 235188),
(286209, '4udsA00', NULL, NULL, 214, NULL, NULL, 235188),
(286210, '3jsjC00', NULL, NULL, 190, NULL, NULL, 235188),
(286211, '3zqiA02', NULL, NULL, 142, NULL, NULL, 235188),
(286212, '2hyjA02', NULL, NULL, 147, NULL, NULL, 235188),
(286213, '3gziA00', NULL, NULL, 218, NULL, NULL, 235188),
(286214, '3nnrA00', NULL, NULL, 228, NULL, NULL, 235188),
(286215, '2jj7B02', NULL, NULL, 136, NULL, NULL, 235188),
(286216, '2raeA02', NULL, NULL, 137, NULL, NULL, 235188),
(286217, '5dajD00', NULL, NULL, 212, NULL, NULL, 235188),
(286218, '4me9B00', NULL, NULL, 189, NULL, NULL, 235188),
(286219, '2rasB01', NULL, NULL, 196, NULL, NULL, 235188),
(286220, '2ibdA02', NULL, NULL, 149, NULL, NULL, 235188),
(286221, '2fx0A02', NULL, NULL, 151, NULL, NULL, 235188);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(286222, '5x5iB00', NULL, NULL, 189, NULL, NULL, 235188),
(286223, '3aqtA00', NULL, NULL, 206, NULL, NULL, 235188),
(286224, '2optA02', NULL, NULL, 168, NULL, NULL, 235188),
(286225, '5x5iF00', NULL, NULL, 189, NULL, NULL, 235188),
(286226, '3bruB00', NULL, NULL, 194, NULL, NULL, 235188),
(286227, '2iu5B00', NULL, NULL, 195, NULL, NULL, 235188),
(286228, '2id6A02', NULL, NULL, 154, NULL, NULL, 235188),
(286229, '2eh3A02', NULL, NULL, 129, NULL, NULL, 235188),
(286230, '2g7sA00', NULL, NULL, 194, NULL, NULL, 235188),
(286231, '2hkuB00', NULL, NULL, 195, NULL, NULL, 235188),
(286232, '3dcfA02', NULL, NULL, 146, NULL, NULL, 235188),
(286233, '3rd3A00', NULL, NULL, 197, NULL, NULL, 235188),
(286234, '3ni7A00', NULL, NULL, 188, NULL, NULL, 235188),
(286235, '1z0xA02', NULL, NULL, 151, NULL, NULL, 235188),
(286236, '3qbmB00', NULL, NULL, 199, NULL, NULL, 235188),
(286237, '2oerA00', NULL, NULL, 192, NULL, NULL, 235188),
(286238, '2w53B00', NULL, NULL, 219, NULL, NULL, 235188),
(286239, '3kkdA00', NULL, NULL, 203, NULL, NULL, 235188),
(286240, '3cwrB00', NULL, NULL, 208, NULL, NULL, 235188),
(286241, '3nrgA00', NULL, NULL, 217, NULL, NULL, 235188),
(286242, '3he0B00', NULL, NULL, 196, NULL, NULL, 235188),
(286243, '2o7tA00', NULL, NULL, 199, NULL, NULL, 235188),
(286244, '4ac0A02', NULL, NULL, 137, NULL, NULL, 235188),
(286245, '3lsjA02', NULL, NULL, 167, NULL, NULL, 235188),
(286246, '4jkzA00', NULL, NULL, 194, NULL, NULL, 235188),
(286247, '3crjC00', NULL, NULL, 199, NULL, NULL, 235188),
(286248, '2rmsB00', NULL, NULL, 61, NULL, NULL, 235189),
(286249, '2qkdA04', NULL, NULL, 127, NULL, NULL, 235190),
(286250, '2qkdA02', NULL, NULL, 140, NULL, NULL, 235190),
(286251, '1tolA01', NULL, NULL, 82, NULL, NULL, 235191),
(286252, '3dgsA01', NULL, NULL, 112, NULL, NULL, 235191),
(286253, '1g3pA01', NULL, NULL, 113, NULL, NULL, 235191),
(286254, '1fgpA00', NULL, NULL, 70, NULL, NULL, 235191),
(286255, '4eo1A00', NULL, NULL, 70, NULL, NULL, 235191),
(286256, '2x9aA00', NULL, NULL, 65, NULL, NULL, 235191),
(286257, '1ohgA01', NULL, NULL, 146, NULL, NULL, 235192),
(286258, '5dllA01', NULL, NULL, 184, NULL, NULL, 235193),
(286259, '4kx7A01', NULL, NULL, 219, NULL, NULL, 235193),
(286260, '5ab0A01', NULL, NULL, 218, NULL, NULL, 235193),
(286261, '4gaaA01', NULL, NULL, 193, NULL, NULL, 235193),
(286262, '5mj6B01', NULL, NULL, 212, NULL, NULL, 235193),
(286263, '4wz9A01', NULL, NULL, 214, NULL, NULL, 235193),
(286264, '2xq0A01', NULL, NULL, 186, NULL, NULL, 235193),
(286265, '3b34A01', NULL, NULL, 180, NULL, NULL, 235193),
(286266, '4fkeA01', NULL, NULL, 221, NULL, NULL, 235193),
(286267, '5zi7A01', NULL, NULL, 185, NULL, NULL, 235193),
(286268, '4fyqA01', NULL, NULL, 223, NULL, NULL, 235193),
(286269, '4qhpA01', NULL, NULL, 178, NULL, NULL, 235193),
(286270, '3ciaA01', NULL, NULL, 188, NULL, NULL, 235193),
(286271, '6ea2A01', NULL, NULL, 187, NULL, NULL, 235193),
(286272, '6q4rA01', NULL, NULL, 210, NULL, NULL, 235193),
(286273, '1z5hA01', NULL, NULL, 170, NULL, NULL, 235193),
(286274, '3u9wA01', NULL, NULL, 193, NULL, NULL, 235193),
(286275, '4r84A03', NULL, NULL, 162, NULL, NULL, 235194),
(286276, '3s44A02', NULL, NULL, 176, NULL, NULL, 235194),
(286277, '2z4tA03', NULL, NULL, 176, NULL, NULL, 235194),
(286278, '4v3cA02', NULL, NULL, 176, NULL, NULL, 235194),
(286279, '2zwiB02', NULL, NULL, 155, NULL, NULL, 235194),
(286280, '3b47A00', NULL, NULL, 134, NULL, NULL, 235195),
(286281, '3b42A00', NULL, NULL, 135, NULL, NULL, 235195),
(286282, '4mixA00', NULL, NULL, 291, NULL, NULL, 235196),
(286283, '2l9jA00', NULL, NULL, 121, NULL, NULL, 235197),
(286284, '4c3eE00', NULL, NULL, 179, NULL, NULL, 235197),
(286285, '4cs9B02', NULL, NULL, 107, NULL, NULL, 235197),
(286286, '4cs9A00', NULL, NULL, 172, NULL, NULL, 235197),
(286287, '3mk7A00', NULL, NULL, 474, NULL, NULL, 235198),
(286288, '5b1aA00', NULL, NULL, 514, NULL, NULL, 235198),
(286289, '4xydA00', NULL, NULL, 456, NULL, NULL, 235198),
(286290, '2gsmC00', NULL, NULL, 534, NULL, NULL, 235198),
(286291, '3hb3A00', NULL, NULL, 542, NULL, NULL, 235198),
(286292, '3wfdB00', NULL, NULL, 465, NULL, NULL, 235198);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(286293, '3ayfA01', NULL, NULL, 564, NULL, NULL, 235198),
(286294, '1fftA00', NULL, NULL, 501, NULL, NULL, 235198),
(286295, '3s8fA00', NULL, NULL, 569, NULL, NULL, 235198),
(286296, '2yevA01', NULL, NULL, 533, NULL, NULL, 235198),
(286297, '6hu9a00', NULL, NULL, 534, NULL, NULL, 235198),
(286298, '2m3kA00', NULL, NULL, 119, NULL, NULL, 235199),
(286299, '3brvC00', NULL, NULL, 48, NULL, NULL, 235200),
(286300, '3brtC00', NULL, NULL, 47, NULL, NULL, 235200),
(286301, '2qsfA04', NULL, NULL, 76, NULL, NULL, 235201),
(286302, '2incC00', NULL, NULL, 83, NULL, NULL, 235202),
(286303, '3ge3C00', NULL, NULL, 84, NULL, NULL, 235202),
(286304, '2r7rA05', NULL, NULL, 187, NULL, NULL, 235203),
(286305, '1n7zA02', NULL, NULL, 158, NULL, NULL, 235204),
(286306, '4nzrM03', NULL, NULL, 123, NULL, NULL, 235205),
(286307, '4bjtA02', NULL, NULL, 50, NULL, NULL, 235206),
(286308, '5nhiB00', NULL, NULL, 134, NULL, NULL, 235207),
(286309, '6dnvA00', NULL, NULL, 125, NULL, NULL, 235207),
(286310, '3pfuA00', NULL, NULL, 139, NULL, NULL, 235207),
(286311, '1l6pA00', NULL, NULL, 125, NULL, NULL, 235207),
(286312, '3td7A02', NULL, NULL, 136, NULL, NULL, 235208),
(286313, '1tuoA03', NULL, NULL, 117, NULL, NULL, 235209),
(286314, '1tuoA02', NULL, NULL, 85, NULL, NULL, 235209),
(286315, '1tuoA01', NULL, NULL, 155, NULL, NULL, 235209),
(286316, '3uw2A01', NULL, NULL, 155, NULL, NULL, 235209),
(286317, '5bmnA01', NULL, NULL, 147, NULL, NULL, 235209),
(286318, '5bmnA02', NULL, NULL, 78, NULL, NULL, 235209),
(286319, '5bmnA03', NULL, NULL, 119, NULL, NULL, 235209),
(286320, '3uw2A03', NULL, NULL, 118, NULL, NULL, 235209),
(286321, '3uw2A02', NULL, NULL, 78, NULL, NULL, 235209),
(286322, '3pdkA03', NULL, NULL, 84, NULL, NULL, 235209),
(286323, '4hjhA03', NULL, NULL, 119, NULL, NULL, 235209),
(286324, '4hjhA02', NULL, NULL, 81, NULL, NULL, 235209),
(286325, '5jn5B01', NULL, NULL, 197, NULL, NULL, 235209),
(286326, '3i3wA01', NULL, NULL, 153, NULL, NULL, 235209),
(286327, '3i3wA02', NULL, NULL, 130, NULL, NULL, 235209),
(286328, '3i3wA03', NULL, NULL, 82, NULL, NULL, 235209),
(286329, '4qg5A02', NULL, NULL, 113, NULL, NULL, 235209),
(286330, '4qg5A03', NULL, NULL, 132, NULL, NULL, 235209),
(286331, '3pdkA02', NULL, NULL, 130, NULL, NULL, 235209),
(286332, '1kfiA03', NULL, NULL, 126, NULL, NULL, 235209),
(286333, '1kfiA02', NULL, NULL, 109, NULL, NULL, 235209),
(286334, '2z0fB02', NULL, NULL, 98, NULL, NULL, 235209),
(286335, '1kfqA01', NULL, NULL, 207, NULL, NULL, 235209),
(286336, '6gyzA02', NULL, NULL, 130, NULL, NULL, 235209),
(286337, '6gyzA01', NULL, NULL, 157, NULL, NULL, 235209),
(286338, '6gyzA03', NULL, NULL, 84, NULL, NULL, 235209),
(286339, '5o9xA01', NULL, NULL, 181, NULL, NULL, 235209),
(286340, '1wqaA03', NULL, NULL, 96, NULL, NULL, 235209),
(286341, '1wqaA02', NULL, NULL, 122, NULL, NULL, 235209),
(286342, '1wqaA01', NULL, NULL, 152, NULL, NULL, 235209),
(286343, '3na5A01', NULL, NULL, 207, NULL, NULL, 235209),
(286344, '4hjhB01', NULL, NULL, 158, NULL, NULL, 235209),
(286345, '5jn5A02', NULL, NULL, 103, NULL, NULL, 235209),
(286346, '3na5A02', NULL, NULL, 95, NULL, NULL, 235209),
(286347, '2dkaB01', NULL, NULL, 169, NULL, NULL, 235209),
(286348, '3na5A03', NULL, NULL, 125, NULL, NULL, 235209),
(286349, '2ehpA00', NULL, NULL, 126, NULL, NULL, 235209),
(286350, '5jn5A03', NULL, NULL, 100, NULL, NULL, 235209),
(286351, '1p5dX01', NULL, NULL, 154, NULL, NULL, 235209),
(286352, '1p5dX03', NULL, NULL, 119, NULL, NULL, 235209),
(286353, '4qg5B01', NULL, NULL, 171, NULL, NULL, 235209),
(286354, '2f7lA03', NULL, NULL, 98, NULL, NULL, 235209),
(286355, '1p5dX02', NULL, NULL, 78, NULL, NULL, 235209),
(286356, '2f7lA02', NULL, NULL, 122, NULL, NULL, 235209),
(286357, '2f7lA01', NULL, NULL, 150, NULL, NULL, 235209),
(286358, '3pdkB01', NULL, NULL, 153, NULL, NULL, 235209),
(286359, '2z0fA03', NULL, NULL, 122, NULL, NULL, 235209),
(286360, '2z0fA01', NULL, NULL, 202, NULL, NULL, 235209),
(286361, '2z0fA02', NULL, NULL, 67, NULL, NULL, 235209),
(286362, '2kieA00', NULL, NULL, 124, NULL, NULL, 235210),
(286363, '2kigA00', NULL, NULL, 161, NULL, NULL, 235210);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(286364, '2jswA00', NULL, NULL, 189, NULL, NULL, 235211),
(286365, '1r0dB00', NULL, NULL, 206, NULL, NULL, 235211),
(286366, '3ay5A02', NULL, NULL, 197, NULL, NULL, 235211),
(286367, '3clqA03', NULL, NULL, 70, NULL, NULL, 235212),
(286368, '4f87B00', NULL, NULL, 72, NULL, NULL, 235213),
(286369, '4lgyA02', NULL, NULL, 62, NULL, NULL, 235214),
(286370, '1u5kA03', NULL, NULL, 35, NULL, NULL, 235215),
(286371, '1vx7L02', NULL, NULL, 42, NULL, NULL, 235216),
(286372, '1j0tA00', NULL, NULL, 78, NULL, NULL, 235217),
(286373, '3k59A02', NULL, NULL, 67, NULL, NULL, 235218),
(286374, '1yu0A02', NULL, NULL, 147, NULL, NULL, 235219),
(286375, '3dzwA00', NULL, NULL, 109, NULL, NULL, 235220),
(286376, '2d04G00', NULL, NULL, 113, NULL, NULL, 235220),
(286377, '1dlpF02', NULL, NULL, 125, NULL, NULL, 235220),
(286378, '4h3oA00', NULL, NULL, 105, NULL, NULL, 235220),
(286379, '4gc1A01', NULL, NULL, 105, NULL, NULL, 235220),
(286380, '1dlpA01', NULL, NULL, 111, NULL, NULL, 235220),
(286381, '4gc1A03', NULL, NULL, 70, NULL, NULL, 235220),
(286382, '1b2pA00', NULL, NULL, 119, NULL, NULL, 235220),
(286383, '4gc1A02', NULL, NULL, 101, NULL, NULL, 235220),
(286384, '1kj1A00', NULL, NULL, 109, NULL, NULL, 235220),
(286385, '3a0cA00', NULL, NULL, 110, NULL, NULL, 235220),
(286386, '3r0eB00', NULL, NULL, 110, NULL, NULL, 235220),
(286387, '1kj1D00', NULL, NULL, 109, NULL, NULL, 235220),
(286388, '1xd6A00', NULL, NULL, 112, NULL, NULL, 235220),
(286389, '4le7A02', NULL, NULL, 82, NULL, NULL, 235220),
(286390, '5j76A00', NULL, NULL, 109, NULL, NULL, 235220),
(286391, '5d5gA00', NULL, NULL, 109, NULL, NULL, 235220),
(286392, '2dpfA00', NULL, NULL, 115, NULL, NULL, 235220),
(286393, '4tkcA00', NULL, NULL, 120, NULL, NULL, 235220),
(286394, '3mezD00', NULL, NULL, 113, NULL, NULL, 235220),
(286395, '4okcA01', NULL, NULL, 69, NULL, NULL, 235220),
(286396, '3mezC00', NULL, NULL, 111, NULL, NULL, 235220),
(286397, '5t1xD00', NULL, NULL, 110, NULL, NULL, 235220),
(286398, '1bwuD00', NULL, NULL, 109, NULL, NULL, 235220),
(286399, '5t1xC00', NULL, NULL, 110, NULL, NULL, 235220),
(286400, '1xd5D00', NULL, NULL, 112, NULL, NULL, 235220),
(286401, '1bwuA00', NULL, NULL, 106, NULL, NULL, 235220),
(286402, '1jpcA00', NULL, NULL, 109, NULL, NULL, 235220),
(286403, '2xepA03', NULL, NULL, 53, NULL, NULL, 235221),
(286404, '2x0dA01', NULL, NULL, 212, NULL, NULL, 235222),
(286405, '3l2dA02', NULL, NULL, 275, NULL, NULL, 235223),
(286406, '1u6rA02', NULL, NULL, 277, NULL, NULL, 235223),
(286407, '4s17C02', NULL, NULL, 358, NULL, NULL, 235223),
(286408, '5zhqA02', NULL, NULL, 260, NULL, NULL, 235223),
(286409, '2d3aA02', NULL, NULL, 253, NULL, NULL, 235223),
(286410, '2ojwC02', NULL, NULL, 255, NULL, NULL, 235223),
(286411, '4hppA02', NULL, NULL, 342, NULL, NULL, 235223),
(286412, '5zliA02', NULL, NULL, 356, NULL, NULL, 235223),
(286413, '1qk1A02', NULL, NULL, 279, NULL, NULL, 235223),
(286414, '1m15A02', NULL, NULL, 260, NULL, NULL, 235223),
(286415, '4acfA02', NULL, NULL, 359, NULL, NULL, 235223),
(286416, '1qh4A02', NULL, NULL, 277, NULL, NULL, 235223),
(286417, '3jpzA02', NULL, NULL, 275, NULL, NULL, 235223),
(286418, '1crkA02', NULL, NULL, 279, NULL, NULL, 235223),
(286419, '4z9mC02', NULL, NULL, 277, NULL, NULL, 235223),
(286420, '3fkyC02', NULL, NULL, 263, NULL, NULL, 235223),
(286421, '4z9mB02', NULL, NULL, 207, NULL, NULL, 235223),
(286422, '5u92A02', NULL, NULL, 260, NULL, NULL, 235223),
(286423, '1vrpA02', NULL, NULL, 277, NULL, NULL, 235223),
(286424, '3ju5C02', NULL, NULL, 275, NULL, NULL, 235223),
(286425, '3ng0A02', NULL, NULL, 355, NULL, NULL, 235223),
(286426, '2j1qA02', NULL, NULL, 260, NULL, NULL, 235223),
(286427, '4q2rA02', NULL, NULL, 276, NULL, NULL, 235223),
(286428, '4is4D02', NULL, NULL, 216, NULL, NULL, 235223),
(286429, '1f52A01', NULL, NULL, 353, NULL, NULL, 235223),
(286430, '4am1A02', NULL, NULL, 259, NULL, NULL, 235223),
(286431, '4is4A02', NULL, NULL, 253, NULL, NULL, 235223),
(286432, '4baxA02', NULL, NULL, 254, NULL, NULL, 235223),
(286433, '4rf6A04', NULL, NULL, 261, NULL, NULL, 235223),
(286434, '4rf6B02', NULL, NULL, 266, NULL, NULL, 235223); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(286435, '4lniA02', NULL, NULL, 337, NULL, NULL, 235223),
(286436, '4jk8B01', NULL, NULL, 153, NULL, NULL, 235224),
(286437, '3sbtA01', NULL, NULL, 161, NULL, NULL, 235224),
(286438, '6nqiA01', NULL, NULL, 144, NULL, NULL, 235224),
(286439, '2vveA02', NULL, NULL, 159, NULL, NULL, 235225),
(286440, '2vk9A01', NULL, NULL, 94, NULL, NULL, 235226),
(286441, '2vkhA01', NULL, NULL, 86, NULL, NULL, 235226),
(286442, '4dmvA01', NULL, NULL, 85, NULL, NULL, 235226),
(286443, '4errB00', NULL, NULL, 90, NULL, NULL, 235226),
(286444, '5uqmA01', NULL, NULL, 86, NULL, NULL, 235226),
(286445, '4hquA00', NULL, NULL, 109, NULL, NULL, 235227),
(286446, '2v5eB00', NULL, NULL, 101, NULL, NULL, 235227),
(286447, '1wq9A00', NULL, NULL, 96, NULL, NULL, 235227),
(286448, '2arpA00', NULL, NULL, 116, NULL, NULL, 235227),
(286449, '5e4gA00', NULL, NULL, 109, NULL, NULL, 235227),
(286450, '4n1dA00', NULL, NULL, 116, NULL, NULL, 235227),
(286451, '5f3bD00', NULL, NULL, 109, NULL, NULL, 235227),
(286452, '5n92A00', NULL, NULL, 132, NULL, NULL, 235227),
(286453, '4ec7A00', NULL, NULL, 116, NULL, NULL, 235227),
(286454, '2askA00', NULL, NULL, 113, NULL, NULL, 235227),
(286455, '1fzvA00', NULL, NULL, 115, NULL, NULL, 235227),
(286456, '2r53A00', NULL, NULL, 116, NULL, NULL, 235227),
(286457, '1mkkB00', NULL, NULL, 96, NULL, NULL, 235227),
(286458, '3mjkA00', NULL, NULL, 169, NULL, NULL, 235227),
(286459, '4x1jA00', NULL, NULL, 116, NULL, NULL, 235227),
(286460, '1b8kA00', NULL, NULL, 119, NULL, NULL, 235227),
(286461, '1hcnB00', NULL, NULL, 111, NULL, NULL, 235227),
(286462, '3jvfB01', NULL, NULL, 87, NULL, NULL, 235227),
(286463, '2c7wA00', NULL, NULL, 99, NULL, NULL, 235227),
(286464, '5bq8A00', NULL, NULL, 122, NULL, NULL, 235227),
(286465, '1wwwV00', NULL, NULL, 120, NULL, NULL, 235227),
(286466, '1aocA00', NULL, NULL, 175, NULL, NULL, 235227),
(286467, '3e07A00', NULL, NULL, 114, NULL, NULL, 235227),
(286468, '1agqB00', NULL, NULL, 98, NULL, NULL, 235227),
(286469, '5aejB00', NULL, NULL, 113, NULL, NULL, 235227),
(286470, '1mjvA00', NULL, NULL, 96, NULL, NULL, 235227),
(286471, '2qcqA00', NULL, NULL, 110, NULL, NULL, 235227),
(286472, '5vb9A01', NULL, NULL, 92, NULL, NULL, 235227),
(286473, '4mplA00', NULL, NULL, 116, NULL, NULL, 235227),
(286474, '3rjrB02', NULL, NULL, 112, NULL, NULL, 235227),
(286475, '5n92F00', NULL, NULL, 120, NULL, NULL, 235227),
(286476, '1nyuD00', NULL, NULL, 82, NULL, NULL, 235227),
(286477, '2xv7A00', NULL, NULL, 112, NULL, NULL, 235227),
(286478, '1betA00', NULL, NULL, 107, NULL, NULL, 235227),
(286479, '2h62B00', NULL, NULL, 114, NULL, NULL, 235227),
(286480, '4efvA00', NULL, NULL, 117, NULL, NULL, 235227),
(286481, '1bndA00', NULL, NULL, 119, NULL, NULL, 235227),
(286482, '4jphB00', NULL, NULL, 119, NULL, NULL, 235227),
(286483, '2gnnB00', NULL, NULL, 103, NULL, NULL, 235227),
(286484, '5tx4B00', NULL, NULL, 92, NULL, NULL, 235227),
(286485, '4midA00', NULL, NULL, 115, NULL, NULL, 235227),
(286486, '2tgiA00', NULL, NULL, 112, NULL, NULL, 235227),
(286487, '1b98A00', NULL, NULL, 130, NULL, NULL, 235227),
(286488, '4ay9D00', NULL, NULL, 92, NULL, NULL, 235227),
(286489, '3ij2A00', NULL, NULL, 120, NULL, NULL, 235227),
(286490, '4ay9B00', NULL, NULL, 111, NULL, NULL, 235227),
(286491, '1tgjA00', NULL, NULL, 112, NULL, NULL, 235227),
(286492, '1lxiA00', NULL, NULL, 104, NULL, NULL, 235227),
(286493, '2kd3A00', NULL, NULL, 97, NULL, NULL, 235227),
(286494, '1wq8A00', NULL, NULL, 110, NULL, NULL, 235227),
(286495, '1m4uA01', NULL, NULL, 129, NULL, NULL, 235227),
(286496, '3mjgB00', NULL, NULL, 110, NULL, NULL, 235227),
(286497, '5nmzA00', NULL, NULL, 101, NULL, NULL, 235227),
(286498, '1mkgA00', NULL, NULL, 96, NULL, NULL, 235227),
(286499, '2gyzA00', NULL, NULL, 105, NULL, NULL, 235227),
(286500, '3evsB00', NULL, NULL, 117, NULL, NULL, 235227),
(286501, '3mjkX00', NULL, NULL, 131, NULL, NULL, 235227),
(286502, '2x1wD00', NULL, NULL, 110, NULL, NULL, 235227),
(286503, '3ohmB01', NULL, NULL, 220, NULL, NULL, 235228),
(286504, '2zkmX01', NULL, NULL, 216, NULL, NULL, 235228),
(286505, '1bplA01', NULL, NULL, 106, NULL, NULL, 235229);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(286506, '2v89A01', NULL, NULL, 33, NULL, NULL, 235230),
(286507, '1k87A02', NULL, NULL, 121, NULL, NULL, 235231),
(286508, '2bskB00', NULL, NULL, 90, NULL, NULL, 235232),
(286509, '3dxrA00', NULL, NULL, 89, NULL, NULL, 235232),
(286510, '2bskD00', NULL, NULL, 90, NULL, NULL, 235232),
(286511, '3dxrB00', NULL, NULL, 79, NULL, NULL, 235232),
(286512, '2bskE00', NULL, NULL, 89, NULL, NULL, 235232),
(286513, '2bskF00', NULL, NULL, 73, NULL, NULL, 235232),
(286514, '3cjhB00', NULL, NULL, 64, NULL, NULL, 235232),
(286515, '3cjhI00', NULL, NULL, 64, NULL, NULL, 235232),
(286516, '6hzwA02', NULL, NULL, 121, NULL, NULL, 235233),
(286517, '4cofA02', NULL, NULL, 135, NULL, NULL, 235233),
(286518, '2m6bA00', NULL, NULL, 150, NULL, NULL, 235233),
(286519, '4tnwC02', NULL, NULL, 135, NULL, NULL, 235233),
(286520, '5tinA02', NULL, NULL, 126, NULL, NULL, 235233),
(286521, '4x5tA02', NULL, NULL, 135, NULL, NULL, 235233),
(286522, '3rqwA02', NULL, NULL, 122, NULL, NULL, 235233),
(286523, '6hz1A02', NULL, NULL, 121, NULL, NULL, 235233),
(286524, '3jadA02', NULL, NULL, 131, NULL, NULL, 235233),
(286525, '5osaA02', NULL, NULL, 120, NULL, NULL, 235233),
(286526, '1oedE00', NULL, NULL, 128, NULL, NULL, 235233),
(286527, '2mawA00', NULL, NULL, 137, NULL, NULL, 235233),
(286528, '2llyA01', NULL, NULL, 123, NULL, NULL, 235233),
(286529, '2bg9A02', NULL, NULL, 160, NULL, NULL, 235233),
(286530, '2lm2A01', NULL, NULL, 123, NULL, NULL, 235233),
(286531, '2bg9B02', NULL, NULL, 163, NULL, NULL, 235233),
(286532, '2bg9C02', NULL, NULL, 160, NULL, NULL, 235233),
(286533, '1oedA00', NULL, NULL, 127, NULL, NULL, 235233),
(286534, '2lkgA00', NULL, NULL, 140, NULL, NULL, 235233),
(286535, '1oedB00', NULL, NULL, 127, NULL, NULL, 235233),
(286536, '2ksrA01', NULL, NULL, 129, NULL, NULL, 235233),
(286537, '2bg9E02', NULL, NULL, 160, NULL, NULL, 235233),
(286538, '1oedC00', NULL, NULL, 127, NULL, NULL, 235233),
(286539, '1wtjB01', NULL, NULL, 103, NULL, NULL, 235234),
(286540, '1z2iA01', NULL, NULL, 101, NULL, NULL, 235234),
(286541, '1vbiA01', NULL, NULL, 107, NULL, NULL, 235234),
(286542, '3uoeA01', NULL, NULL, 88, NULL, NULL, 235234),
(286543, '4h8aB01', NULL, NULL, 64, NULL, NULL, 235234),
(286544, '2g8yB01', NULL, NULL, 114, NULL, NULL, 235234),
(286545, '4h8aA01', NULL, NULL, 100, NULL, NULL, 235234),
(286546, '1v9nA01', NULL, NULL, 115, NULL, NULL, 235234),
(286547, '2x06A01', NULL, NULL, 133, NULL, NULL, 235234),
(286548, '3i0pA01', NULL, NULL, 112, NULL, NULL, 235234),
(286549, '1nxuA01', NULL, NULL, 81, NULL, NULL, 235234),
(286550, '3fndA02', NULL, NULL, 44, NULL, NULL, 235235),
(286551, '4j2gA00', NULL, NULL, 257, NULL, NULL, 235236),
(286552, '5c50B00', NULL, NULL, 194, NULL, NULL, 235236),
(286553, '2v64H00', NULL, NULL, 191, NULL, NULL, 235236),
(286554, '5xuyC00', NULL, NULL, 190, NULL, NULL, 235236),
(286555, '3gmhC00', NULL, NULL, 207, NULL, NULL, 235236),
(286556, '4trkA00', NULL, NULL, 273, NULL, NULL, 235236),
(286557, '4gk0A00', NULL, NULL, 214, NULL, NULL, 235236),
(286558, '4tzqA00', NULL, NULL, 237, NULL, NULL, 235236),
(286559, '4yk8B00', NULL, NULL, 242, NULL, NULL, 235236),
(286560, '4tzmB00', NULL, NULL, 253, NULL, NULL, 235236),
(286561, '4aezH00', NULL, NULL, 203, NULL, NULL, 235236),
(286562, '4extC00', NULL, NULL, 204, NULL, NULL, 235236),
(286563, '2vfxJ00', NULL, NULL, 206, NULL, NULL, 235236),
(286564, '2nmlA00', NULL, NULL, 104, NULL, NULL, 235237),
(286565, '3a9lA00', NULL, NULL, 216, NULL, NULL, 235238),
(286566, '4nzrM01', NULL, NULL, 84, NULL, NULL, 235239),
(286567, '1sg7A00', NULL, NULL, 75, NULL, NULL, 235240),
(286568, '1za7A00', NULL, NULL, 165, NULL, NULL, 235241),
(286569, '1stmA00', NULL, NULL, 141, NULL, NULL, 235241),
(286570, '1yc6100', NULL, NULL, 154, NULL, NULL, 235241),
(286571, '4oq8A00', NULL, NULL, 159, NULL, NULL, 235241),
(286572, '4a18O00', NULL, NULL, 134, NULL, NULL, 235242),
(286573, '1vwxr00', NULL, NULL, 125, NULL, NULL, 235242),
(286574, '1vx7200', NULL, NULL, 127, NULL, NULL, 235242),
(286575, '3k1zA02', NULL, NULL, 84, NULL, NULL, 235243),
(286576, '3gmiA01', NULL, NULL, 138, NULL, NULL, 235244);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(286577, '4gj4B00', NULL, NULL, 126, NULL, NULL, 235245),
(286578, '2p08B00', NULL, NULL, 115, NULL, NULL, 235245),
(286579, '2p04A00', NULL, NULL, 121, NULL, NULL, 235245),
(286580, '1pc6A00', NULL, NULL, 146, NULL, NULL, 235246),
(286581, '1rp3B02', NULL, NULL, 37, NULL, NULL, 235247),
(286582, '4divA02', NULL, NULL, 71, NULL, NULL, 235248),
(286583, '1gl9B01', NULL, NULL, 73, NULL, NULL, 235249),
(286584, '1gkuB01', NULL, NULL, 58, NULL, NULL, 235249),
(286585, '3db9A01', NULL, NULL, 151, NULL, NULL, 235250),
(286586, '2pifA01', NULL, NULL, 162, NULL, NULL, 235250),
(286587, '3cbnA00', NULL, NULL, 151, NULL, NULL, 235251),
(286588, '2aegA03', NULL, NULL, 31, NULL, NULL, 235252),
(286589, '5nqzB01', NULL, NULL, 133, NULL, NULL, 235253),
(286590, '2kdyA01', NULL, NULL, 145, NULL, NULL, 235253),
(286591, '4ayiD01', NULL, NULL, 127, NULL, NULL, 235253),
(286592, '4z3tB01', NULL, NULL, 128, NULL, NULL, 235253),
(286593, '5nqyA01', NULL, NULL, 133, NULL, NULL, 235253),
(286594, '2k9qA02', NULL, NULL, 37, NULL, NULL, 235254),
(286595, '2qyfB00', NULL, NULL, 240, NULL, NULL, 235255),
(286596, '2napA01', NULL, NULL, 61, NULL, NULL, 235256),
(286597, '2vpzA01', NULL, NULL, 67, NULL, NULL, 235256),
(286598, '2e7zA01', NULL, NULL, 57, NULL, NULL, 235256),
(286599, '2iv2X01', NULL, NULL, 55, NULL, NULL, 235256),
(286600, '1q16A03', NULL, NULL, 47, NULL, NULL, 235256),
(286601, '3x0fB00', NULL, NULL, 93, NULL, NULL, 235257),
(286602, '3x0gA00', NULL, NULL, 93, NULL, NULL, 235257),
(286603, '2m7zA00', NULL, NULL, 81, NULL, NULL, 235257),
(286604, '5m33B00', NULL, NULL, 101, NULL, NULL, 235257),
(286605, '1g8qA00', NULL, NULL, 90, NULL, NULL, 235257),
(286606, '4au7A02', NULL, NULL, 145, NULL, NULL, 235258),
(286607, '5lszA00', NULL, NULL, 278, NULL, NULL, 235258),
(286608, '4ynmB00', NULL, NULL, 226, NULL, NULL, 235258),
(286609, '4mi0A00', NULL, NULL, 210, NULL, NULL, 235258),
(286610, '4wuyA01', NULL, NULL, 95, NULL, NULL, 235258),
(286611, '4ijdA01', NULL, NULL, 183, NULL, NULL, 235258),
(286612, '4qenA03', NULL, NULL, 263, NULL, NULL, 235258),
(286613, '4c1qA00', NULL, NULL, 175, NULL, NULL, 235258),
(286614, '6p0rB00', NULL, NULL, 242, NULL, NULL, 235258),
(286615, '4yz8A00', NULL, NULL, 217, NULL, NULL, 235258),
(286616, '3dalA00', NULL, NULL, 196, NULL, NULL, 235258),
(286617, '3s8pA02', NULL, NULL, 145, NULL, NULL, 235258),
(286618, '6a5kA03', NULL, NULL, 293, NULL, NULL, 235258),
(286619, '2qpwA01', NULL, NULL, 126, NULL, NULL, 235258),
(286620, '2rfiB00', NULL, NULL, 258, NULL, NULL, 235258),
(286621, '5f5eA00', NULL, NULL, 158, NULL, NULL, 235258),
(286622, '3f9xD00', NULL, NULL, 166, NULL, NULL, 235258),
(286623, '5vacA00', NULL, NULL, 229, NULL, NULL, 235258),
(286624, '4rz0A00', NULL, NULL, 146, NULL, NULL, 235258),
(286625, '3ep0A00', NULL, NULL, 129, NULL, NULL, 235258),
(286626, '3n71A01', NULL, NULL, 93, NULL, NULL, 235258),
(286627, '3db5A00', NULL, NULL, 151, NULL, NULL, 235258),
(286628, '5f6kC00', NULL, NULL, 159, NULL, NULL, 235258),
(286629, '3ooiA00', NULL, NULL, 232, NULL, NULL, 235258),
(286630, '3bo5A00', NULL, NULL, 290, NULL, NULL, 235258),
(286631, '3ihxC01', NULL, NULL, 139, NULL, NULL, 235258),
(286632, '1ml9A00', NULL, NULL, 302, NULL, NULL, 235258),
(286633, '4ldgA00', NULL, NULL, 240, NULL, NULL, 235258),
(286634, '5lsuB00', NULL, NULL, 228, NULL, NULL, 235258),
(286635, '3qwwA01', NULL, NULL, 95, NULL, NULL, 235258),
(286636, '5v37A01', NULL, NULL, 138, NULL, NULL, 235258),
(286637, '1mvhA00', NULL, NULL, 270, NULL, NULL, 235258),
(286638, '3kmaA00', NULL, NULL, 119, NULL, NULL, 235258),
(286639, '2f69A02', NULL, NULL, 143, NULL, NULL, 235258),
(286640, '3rq4A02', NULL, NULL, 147, NULL, NULL, 235258),
(286641, '5vscA00', NULL, NULL, 275, NULL, NULL, 235258),
(286642, '4nj5A02', NULL, NULL, 292, NULL, NULL, 235258),
(286643, '5tegA00', NULL, NULL, 160, NULL, NULL, 235258),
(286644, '4z4pA00', NULL, NULL, 166, NULL, NULL, 235258),
(286645, '6chgC00', NULL, NULL, 153, NULL, NULL, 235258),
(286646, '3rayA00', NULL, NULL, 164, NULL, NULL, 235258),
(286647, '2zuoC11', NULL, NULL, 156, NULL, NULL, 235259);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(286648, '6bsyA00', NULL, NULL, 70, NULL, NULL, 235260),
(286649, '1xf1A03', NULL, NULL, 131, NULL, NULL, 235261),
(286650, '1nvpD01', NULL, NULL, 52, NULL, NULL, 235262),
(286651, '1nh2D01', NULL, NULL, 56, NULL, NULL, 235262),
(286652, '1ywwA00', NULL, NULL, 65, NULL, NULL, 235263),
(286653, '1rykA00', NULL, NULL, 69, NULL, NULL, 235263),
(286654, '1f15B00', NULL, NULL, 190, NULL, NULL, 235264),
(286655, '1lajB00', NULL, NULL, 182, NULL, NULL, 235264),
(286656, '2qyuA02', NULL, NULL, 195, NULL, NULL, 235265),
(286657, '3nb2A02', NULL, NULL, 155, NULL, NULL, 235265),
(286658, '3r90A00', NULL, NULL, 188, NULL, NULL, 235266),
(286659, '2bhvD01', NULL, NULL, 164, NULL, NULL, 235267),
(286660, '3jqoA01', NULL, NULL, 140, NULL, NULL, 235267),
(286661, '5vlcA03', NULL, NULL, 55, NULL, NULL, 235268),
(286662, '1kaeA03', NULL, NULL, 55, NULL, NULL, 235268),
(286663, '6an0A03', NULL, NULL, 55, NULL, NULL, 235268),
(286664, '4g09A03', NULL, NULL, 55, NULL, NULL, 235268),
(286665, '4hteA01', NULL, NULL, 155, NULL, NULL, 235269),
(286666, '3aonB00', NULL, NULL, 115, NULL, NULL, 235270),
(286667, '2d00A01', NULL, NULL, 67, NULL, NULL, 235270),
(286668, '2qaiA00', NULL, NULL, 111, NULL, NULL, 235270),
(286669, '4ix9D00', NULL, NULL, 94, NULL, NULL, 235270),
(286670, '4rndD00', NULL, NULL, 118, NULL, NULL, 235270),
(286671, '2i4rB00', NULL, NULL, 102, NULL, NULL, 235270),
(286672, '2ov6A01', NULL, NULL, 78, NULL, NULL, 235270),
(286673, '3w3aH00', NULL, NULL, 100, NULL, NULL, 235270),
(286674, '4r7rA00', NULL, NULL, 128, NULL, NULL, 235271),
(286675, '2nykA02', NULL, NULL, 94, NULL, NULL, 235272),
(286676, '4jo8A02', NULL, NULL, 94, NULL, NULL, 235272),
(286677, '3mogA03', NULL, NULL, 94, NULL, NULL, 235273),
(286678, '1vx7d00', NULL, NULL, 87, NULL, NULL, 235274),
(286679, '3u5ek00', NULL, NULL, 78, NULL, NULL, 235274),
(286680, '1vwxk00', NULL, NULL, 70, NULL, NULL, 235274),
(286681, '4a18P00', NULL, NULL, 89, NULL, NULL, 235274),
(286682, '3jsrA00', NULL, NULL, 119, NULL, NULL, 235275),
(286683, '5m2pA00', NULL, NULL, 109, NULL, NULL, 235275),
(286684, '3hzeA00', NULL, NULL, 114, NULL, NULL, 235275),
(286685, '2zugA00', NULL, NULL, 90, NULL, NULL, 235276),
(286686, '2gj2A00', NULL, NULL, 85, NULL, NULL, 235276),
(286687, '4gdoA00', NULL, NULL, 43, NULL, NULL, 235277),
(286688, '1kilE00', NULL, NULL, 49, NULL, NULL, 235277),
(286689, '3rl0h00', NULL, NULL, 63, NULL, NULL, 235277),
(286690, '4g6tB00', NULL, NULL, 82, NULL, NULL, 235278),
(286691, '3towA00', NULL, NULL, 152, NULL, NULL, 235279),
(286692, '2qp2A02', NULL, NULL, 154, NULL, NULL, 235279),
(286693, '1vw4T02', NULL, NULL, 67, NULL, NULL, 235280),
(286694, '2rq7A02', NULL, NULL, 46, NULL, NULL, 235281),
(286695, '2yo2A02', NULL, NULL, 60, NULL, NULL, 235282),
(286696, '6b0sC00', NULL, NULL, 82, NULL, NULL, 235283),
(286697, '4hqnA01', NULL, NULL, 77, NULL, NULL, 235283),
(286698, '3t5oA01', NULL, NULL, 58, NULL, NULL, 235283),
(286699, '1szlA01', NULL, NULL, 52, NULL, NULL, 235283),
(286700, '1vexA00', NULL, NULL, 56, NULL, NULL, 235283),
(286701, '1lslA02', NULL, NULL, 57, NULL, NULL, 235283),
(286702, '1lslA01', NULL, NULL, 56, NULL, NULL, 235283),
(286703, '2d28C01', NULL, NULL, 63, NULL, NULL, 235284),
(286704, '1vs9O01', NULL, NULL, 55, NULL, NULL, 235285),
(286705, '2eqbC00', NULL, NULL, 97, NULL, NULL, 235286),
(286706, '4li0C00', NULL, NULL, 84, NULL, NULL, 235286),
(286707, '4lhxE00', NULL, NULL, 78, NULL, NULL, 235286),
(286708, '1ulkA01', NULL, NULL, 40, NULL, NULL, 235287),
(286709, '4wp4A00', NULL, NULL, 43, NULL, NULL, 235287),
(286710, '4mpiA00', NULL, NULL, 45, NULL, NULL, 235287),
(286711, '1wgtA04', NULL, NULL, 58, NULL, NULL, 235287),
(286712, '2lb7A00', NULL, NULL, 44, NULL, NULL, 235287),
(286713, '2dkvA01', NULL, NULL, 42, NULL, NULL, 235287),
(286714, '2uvoA01', NULL, NULL, 42, NULL, NULL, 235287),
(286715, '2uvoA02', NULL, NULL, 43, NULL, NULL, 235287),
(286716, '1p9gA00', NULL, NULL, 41, NULL, NULL, 235287),
(286717, '1uhaA02', NULL, NULL, 42, NULL, NULL, 235287),
(286718, '5xdiA00', NULL, NULL, 40, NULL, NULL, 235287);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(286719, '2uvoA03', NULL, NULL, 43, NULL, NULL, 235287),
(286720, '2uvoA04', NULL, NULL, 43, NULL, NULL, 235287),
(286721, '1ulkA03', NULL, NULL, 45, NULL, NULL, 235287),
(286722, '1uhaA01', NULL, NULL, 40, NULL, NULL, 235287),
(286723, '1ulkA02', NULL, NULL, 41, NULL, NULL, 235287),
(286724, '5wuzA00', NULL, NULL, 43, NULL, NULL, 235287),
(286725, '2x52A03', NULL, NULL, 43, NULL, NULL, 235287),
(286726, '2x52A02', NULL, NULL, 43, NULL, NULL, 235287),
(286727, '3qyfA03', NULL, NULL, 61, NULL, NULL, 235288),
(286728, '1vq8W02', NULL, NULL, 56, NULL, NULL, 235289),
(286729, '3bxoA02', NULL, NULL, 59, NULL, NULL, 235290),
(286730, '3pfgA02', NULL, NULL, 59, NULL, NULL, 235290),
(286731, '1ylmA00', NULL, NULL, 144, NULL, NULL, 235291),
(286732, '3uh8A00', NULL, NULL, 128, NULL, NULL, 235292),
(286733, '2x8kC01', NULL, NULL, 137, NULL, NULL, 235293),
(286734, '4divV01', NULL, NULL, 149, NULL, NULL, 235293),
(286735, '2wshB00', NULL, NULL, 143, NULL, NULL, 235294),
(286736, '4lvnP00', NULL, NULL, 93, NULL, NULL, 235295),
(286737, '2lu2A00', NULL, NULL, 81, NULL, NULL, 235295),
(286738, '1yxaB02', NULL, NULL, 152, NULL, NULL, 235296),
(286739, '4ga7A02', NULL, NULL, 134, NULL, NULL, 235296),
(286740, '1mtpA02', NULL, NULL, 91, NULL, NULL, 235296),
(286741, '3b9fI02', NULL, NULL, 139, NULL, NULL, 235296),
(286742, '2wxzC01', NULL, NULL, 158, NULL, NULL, 235296),
(286743, '4au3C02', NULL, NULL, 147, NULL, NULL, 235296),
(286744, '1wz9A02', NULL, NULL, 154, NULL, NULL, 235296),
(286745, '3nddA02', NULL, NULL, 95, NULL, NULL, 235296),
(286746, '1sngA01', NULL, NULL, 148, NULL, NULL, 235296),
(286747, '4au3A02', NULL, NULL, 147, NULL, NULL, 235296),
(286748, '6f02A02', NULL, NULL, 162, NULL, NULL, 235296),
(286749, '2h4pA02', NULL, NULL, 102, NULL, NULL, 235296),
(286750, '1imvA01', NULL, NULL, 192, NULL, NULL, 235296),
(286751, '4r9iA02', NULL, NULL, 100, NULL, NULL, 235296),
(286752, '3kcgI02', NULL, NULL, 146, NULL, NULL, 235296),
(286753, '3dy0A02', NULL, NULL, 105, NULL, NULL, 235296),
(286754, '1attA01', NULL, NULL, 144, NULL, NULL, 235296),
(286755, '2oayA02', NULL, NULL, 184, NULL, NULL, 235296),
(286756, '4ro9C01', NULL, NULL, 200, NULL, NULL, 235296),
(286757, '6f4vA02', NULL, NULL, 110, NULL, NULL, 235296),
(286758, '2wxyC01', NULL, NULL, 171, NULL, NULL, 235296),
(286759, '1k9oI02', NULL, NULL, 161, NULL, NULL, 235296),
(286760, '4kdsA02', NULL, NULL, 164, NULL, NULL, 235296),
(286761, '4x30A02', NULL, NULL, 151, NULL, NULL, 235296),
(286762, '3le2A02', NULL, NULL, 131, NULL, NULL, 235296),
(286763, '4c41A02', NULL, NULL, 139, NULL, NULL, 235296),
(286764, '2peeB02', NULL, NULL, 131, NULL, NULL, 235296),
(286765, '4if8A02', NULL, NULL, 95, NULL, NULL, 235296),
(286766, '4dteA02', NULL, NULL, 135, NULL, NULL, 235296),
(286767, '4ajtA02', NULL, NULL, 150, NULL, NULL, 235296),
(286768, '3stoA02', NULL, NULL, 156, NULL, NULL, 235296),
(286769, '4zk3A02', NULL, NULL, 134, NULL, NULL, 235296),
(286770, '3lw2A02', NULL, NULL, 120, NULL, NULL, 235296),
(286771, '1m93B02', NULL, NULL, 118, NULL, NULL, 235296),
(286772, '4au3D02', NULL, NULL, 147, NULL, NULL, 235296),
(286773, '4au3B02', NULL, NULL, 147, NULL, NULL, 235296),
(286774, '5cdzA02', NULL, NULL, 144, NULL, NULL, 235296),
(286775, '2arrA02', NULL, NULL, 132, NULL, NULL, 235296),
(286776, '5om6A02', NULL, NULL, 108, NULL, NULL, 235296),
(286777, '6hgmA02', NULL, NULL, 108, NULL, NULL, 235296),
(286778, '2h4rA02', NULL, NULL, 147, NULL, NULL, 235296),
(286779, '1jmoA02', NULL, NULL, 150, NULL, NULL, 235296),
(286780, '5hgcA02', NULL, NULL, 95, NULL, NULL, 235296),
(286781, '5om2A02', NULL, NULL, 108, NULL, NULL, 235296),
(286782, '2pefA02', NULL, NULL, 123, NULL, NULL, 235296),
(286783, '2xn6A02', NULL, NULL, 96, NULL, NULL, 235296),
(286784, '6hgeA02', NULL, NULL, 145, NULL, NULL, 235296),
(286785, '1lj5A02', NULL, NULL, 154, NULL, NULL, 235296),
(286786, '1hleA01', NULL, NULL, 104, NULL, NULL, 235296),
(286787, '5inwA02', NULL, NULL, 111, NULL, NULL, 235296),
(286788, '5ncsA02', NULL, NULL, 139, NULL, NULL, 235296),
(286789, '1uhgC01', NULL, NULL, 145, NULL, NULL, 235296);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(286790, '5c98B02', NULL, NULL, 129, NULL, NULL, 235296),
(286791, '2wxwA01', NULL, NULL, 161, NULL, NULL, 235296),
(286792, '2znhA02', NULL, NULL, 171, NULL, NULL, 235296),
(286793, '3vvjA02', NULL, NULL, 144, NULL, NULL, 235296),
(286794, '2vdxA02', NULL, NULL, 139, NULL, NULL, 235296),
(286795, '3f02B02', NULL, NULL, 102, NULL, NULL, 235296),
(286796, '4p0fA02', NULL, NULL, 141, NULL, NULL, 235296),
(286797, '4au2B02', NULL, NULL, 147, NULL, NULL, 235296),
(286798, '3ndaA02', NULL, NULL, 135, NULL, NULL, 235296),
(286799, '1a7cA02', NULL, NULL, 134, NULL, NULL, 235296),
(286800, '2v95A02', NULL, NULL, 129, NULL, NULL, 235296),
(286801, '5nbuA02', NULL, NULL, 131, NULL, NULL, 235296),
(286802, '3fgqA01', NULL, NULL, 187, NULL, NULL, 235296),
(286803, '1sekA02', NULL, NULL, 117, NULL, NULL, 235296),
(286804, '4dy0B02', NULL, NULL, 134, NULL, NULL, 235296),
(286805, '1as4A01', NULL, NULL, 108, NULL, NULL, 235296),
(286806, '1qmnA01', NULL, NULL, 145, NULL, NULL, 235296),
(286807, '2r9yA02', NULL, NULL, 155, NULL, NULL, 235296),
(286808, '4afxA02', NULL, NULL, 96, NULL, NULL, 235296),
(286809, '3ozqA01', NULL, NULL, 168, NULL, NULL, 235296),
(286810, '3f1sA02', NULL, NULL, 150, NULL, NULL, 235296),
(286811, '4bb2A02', NULL, NULL, 106, NULL, NULL, 235296),
(286812, '2du5B01', NULL, NULL, 27, NULL, NULL, 235297),
(286813, '2odrC01', NULL, NULL, 23, NULL, NULL, 235297),
(286814, '1r4xA01', NULL, NULL, 160, NULL, NULL, 235298),
(286815, '1pzdA01', NULL, NULL, 156, NULL, NULL, 235298),
(286816, '3m4yA01', NULL, NULL, 50, NULL, NULL, 235299),
(286817, '6nbqE00', NULL, NULL, 101, NULL, NULL, 235300),
(286818, '5lnkK00', NULL, NULL, 98, NULL, NULL, 235300),
(286819, '6g2jK00', NULL, NULL, 98, NULL, NULL, 235300),
(286820, '5xtck00', NULL, NULL, 97, NULL, NULL, 235300),
(286821, '3rkoG00', NULL, NULL, 100, NULL, NULL, 235300),
(286822, '4he8E00', NULL, NULL, 95, NULL, NULL, 235300),
(286823, '4eaeA00', NULL, NULL, 190, NULL, NULL, 235301),
(286824, '2kr1A00', NULL, NULL, 64, NULL, NULL, 235302),
(286825, '5ysnB02', NULL, NULL, 185, NULL, NULL, 235303),
(286826, '3ddeB00', NULL, NULL, 239, NULL, NULL, 235304),
(286827, '3bjdA02', NULL, NULL, 228, NULL, NULL, 235304),
(286828, '1rcwB00', NULL, NULL, 231, NULL, NULL, 235304),
(286829, '2f2gA00', NULL, NULL, 221, NULL, NULL, 235304),
(286830, '3b5oA00', NULL, NULL, 244, NULL, NULL, 235304),
(286831, '5kzlA00', NULL, NULL, 212, NULL, NULL, 235304),
(286832, '3mvuA00', NULL, NULL, 226, NULL, NULL, 235304),
(286833, '3oqlC00', NULL, NULL, 262, NULL, NULL, 235304),
(286834, '1n45A00', NULL, NULL, 233, NULL, NULL, 235304),
(286835, '1wovA01', NULL, NULL, 227, NULL, NULL, 235304),
(286836, '4wx0B00', NULL, NULL, 263, NULL, NULL, 235304),
(286837, '3rm5B02', NULL, NULL, 236, NULL, NULL, 235304),
(286838, '1z72A00', NULL, NULL, 225, NULL, NULL, 235304),
(286839, '1wwmA00', NULL, NULL, 190, NULL, NULL, 235304),
(286840, '1irmC00', NULL, NULL, 196, NULL, NULL, 235304),
(286841, '2a2mA00', NULL, NULL, 237, NULL, NULL, 235304),
(286842, '2qzcA00', NULL, NULL, 214, NULL, NULL, 235304),
(286843, '1j02A00', NULL, NULL, 222, NULL, NULL, 235304),
(286844, '1rtwB00', NULL, NULL, 220, NULL, NULL, 235304),
(286845, '4rajA00', NULL, NULL, 230, NULL, NULL, 235304),
(286846, '4fn6A01', NULL, NULL, 218, NULL, NULL, 235304),
(286847, '5uc9B00', NULL, NULL, 226, NULL, NULL, 235304),
(286848, '2gm8A00', NULL, NULL, 221, NULL, NULL, 235304),
(286849, '1wzdA00', NULL, NULL, 215, NULL, NULL, 235304),
(286850, '3no6A00', NULL, NULL, 248, NULL, NULL, 235304),
(286851, '2qcxA00', NULL, NULL, 222, NULL, NULL, 235304),
(286852, '1we1D00', NULL, NULL, 223, NULL, NULL, 235304),
(286853, '1uddA00', NULL, NULL, 226, NULL, NULL, 235304),
(286854, '1j77A00', NULL, NULL, 209, NULL, NULL, 235304),
(286855, '4lqxA00', NULL, NULL, 322, NULL, NULL, 235304),
(286856, '3hlxA00', NULL, NULL, 258, NULL, NULL, 235304),
(286857, '3ibxD00', NULL, NULL, 221, NULL, NULL, 235304),
(286858, '1sk7A00', NULL, NULL, 198, NULL, NULL, 235304),
(286859, '2yruA01', NULL, NULL, 115, NULL, NULL, 235305),
(286860, '4nboA00', NULL, NULL, 111, NULL, NULL, 235305);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(286861, '1dvkA00', NULL, NULL, 173, NULL, NULL, 235305),
(286862, '2vlaA03', NULL, NULL, 120, NULL, NULL, 235306),
(286863, '4a18T00', NULL, NULL, 66, NULL, NULL, 235307),
(286864, '2l32A00', NULL, NULL, 74, NULL, NULL, 235308),
(286865, '4wkbA00', NULL, NULL, 244, NULL, NULL, 235309),
(286866, '1vmkB00', NULL, NULL, 277, NULL, NULL, 235309),
(286867, '1yqqA00', NULL, NULL, 277, NULL, NULL, 235309),
(286868, '3bsfA00', NULL, NULL, 254, NULL, NULL, 235309),
(286869, '4mchA00', NULL, NULL, 249, NULL, NULL, 235309),
(286870, '1g2oA00', NULL, NULL, 268, NULL, NULL, 235309),
(286871, '1tcvA00', NULL, NULL, 287, NULL, NULL, 235309),
(286872, '2h8gA00', NULL, NULL, 246, NULL, NULL, 235309),
(286873, '3fucA00', NULL, NULL, 284, NULL, NULL, 235309),
(286874, '3emvA01', NULL, NULL, 249, NULL, NULL, 235309),
(286875, '4l0mA00', NULL, NULL, 236, NULL, NULL, 235309),
(286876, '2p4sA00', NULL, NULL, 284, NULL, NULL, 235309),
(286877, '3mb8A00', NULL, NULL, 250, NULL, NULL, 235309),
(286878, '4txjA00', NULL, NULL, 296, NULL, NULL, 235309),
(286879, '4qezB00', NULL, NULL, 239, NULL, NULL, 235309),
(286880, '1z34A00', NULL, NULL, 235, NULL, NULL, 235309),
(286881, '1vhwA00', NULL, NULL, 253, NULL, NULL, 235309),
(286882, '6aymA00', NULL, NULL, 238, NULL, NULL, 235309),
(286883, '3ozbA00', NULL, NULL, 259, NULL, NULL, 235309),
(286884, '4f1wB00', NULL, NULL, 248, NULL, NULL, 235309),
(286885, '1odkB00', NULL, NULL, 235, NULL, NULL, 235309),
(286886, '3u40D00', NULL, NULL, 242, NULL, NULL, 235309),
(286887, '4josB00', NULL, NULL, 230, NULL, NULL, 235309),
(286888, '3occD00', NULL, NULL, 239, NULL, NULL, 235309),
(286889, '4wkcA00', NULL, NULL, 245, NULL, NULL, 235309),
(286890, '3khsD00', NULL, NULL, 285, NULL, NULL, 235309),
(286891, '3bjeA01', NULL, NULL, 312, NULL, NULL, 235309),
(286892, '6if8B00', NULL, NULL, 237, NULL, NULL, 235309),
(286893, '4m3nA00', NULL, NULL, 231, NULL, NULL, 235309),
(286894, '1t8sA02', NULL, NULL, 312, NULL, NULL, 235309),
(286895, '3eufA00', NULL, NULL, 295, NULL, NULL, 235309),
(286896, '4lkrA00', NULL, NULL, 233, NULL, NULL, 235309),
(286897, '3la8A00', NULL, NULL, 268, NULL, NULL, 235309),
(286898, '2guwC02', NULL, NULL, 294, NULL, NULL, 235309),
(286899, '4m1eA00', NULL, NULL, 273, NULL, NULL, 235309),
(286900, '4earA00', NULL, NULL, 286, NULL, NULL, 235309),
(286901, '4g89A00', NULL, NULL, 237, NULL, NULL, 235309),
(286902, '5cyfC00', NULL, NULL, 296, NULL, NULL, 235309),
(286903, '4of4A00', NULL, NULL, 253, NULL, NULL, 235309),
(286904, '3uawA00', NULL, NULL, 235, NULL, NULL, 235309),
(286905, '4tymA00', NULL, NULL, 235, NULL, NULL, 235309),
(286906, '1qe5A00', NULL, NULL, 266, NULL, NULL, 235309),
(286907, '4ldnA00', NULL, NULL, 245, NULL, NULL, 235309),
(286908, '1v4nA00', NULL, NULL, 281, NULL, NULL, 235309),
(286909, '3qpbF00', NULL, NULL, 253, NULL, NULL, 235309),
(286910, '4rj2A00', NULL, NULL, 237, NULL, NULL, 235309),
(286911, '4kn5A00', NULL, NULL, 235, NULL, NULL, 235309),
(286912, '5ue1A00', NULL, NULL, 234, NULL, NULL, 235309),
(286913, '4r2xD00', NULL, NULL, 252, NULL, NULL, 235309),
(286914, '4d8yA00', NULL, NULL, 253, NULL, NULL, 235309),
(286915, '1zosA00', NULL, NULL, 230, NULL, NULL, 235309),
(286916, '5tc6A00', NULL, NULL, 275, NULL, NULL, 235309),
(286917, '5m2tA00', NULL, NULL, 253, NULL, NULL, 235309),
(286918, '4m7wA00', NULL, NULL, 235, NULL, NULL, 235309),
(286919, '5dk6A00', NULL, NULL, 248, NULL, NULL, 235309),
(286920, '4ns1C00', NULL, NULL, 272, NULL, NULL, 235309),
(286921, '3ku4C00', NULL, NULL, 309, NULL, NULL, 235309),
(286922, '4bmyA00', NULL, NULL, 230, NULL, NULL, 235309),
(286923, '4qasA00', NULL, NULL, 201, NULL, NULL, 235309),
(286924, '5f7jF00', NULL, NULL, 297, NULL, NULL, 235309),
(286925, '4r31A00', NULL, NULL, 261, NULL, NULL, 235309),
(286926, '5b7gA00', NULL, NULL, 249, NULL, NULL, 235309),
(286927, '4gljA00', NULL, NULL, 297, NULL, NULL, 235309),
(286928, '2a8yA00', NULL, NULL, 270, NULL, NULL, 235309),
(286929, '3p0fA00', NULL, NULL, 297, NULL, NULL, 235309),
(286930, '3ddoD00', NULL, NULL, 253, NULL, NULL, 235309),
(286931, '4oy3A00', NULL, NULL, 231, NULL, NULL, 235309);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(286932, '4pr3A00', NULL, NULL, 213, NULL, NULL, 235309),
(286933, '1je0C00', NULL, NULL, 236, NULL, NULL, 235309),
(286934, '4jwtA00', NULL, NULL, 259, NULL, NULL, 235309),
(286935, '4uc0A00', NULL, NULL, 267, NULL, NULL, 235309),
(286936, '4g41A00', NULL, NULL, 236, NULL, NULL, 235309),
(286937, '5ifkC00', NULL, NULL, 312, NULL, NULL, 235309),
(286938, '3bl6A00', NULL, NULL, 230, NULL, NULL, 235309),
(286939, '5zncA00', NULL, NULL, 245, NULL, NULL, 235309),
(286940, '5ko5A00', NULL, NULL, 287, NULL, NULL, 235309),
(286941, '1ybfA00', NULL, NULL, 250, NULL, NULL, 235309),
(286942, '1lx7A00', NULL, NULL, 253, NULL, NULL, 235309),
(286943, '3odgA00', NULL, NULL, 287, NULL, NULL, 235309),
(286944, '1sq6A00', NULL, NULL, 253, NULL, NULL, 235309),
(286945, '4lnaA00', NULL, NULL, 293, NULL, NULL, 235309),
(286946, '3eeiA00', NULL, NULL, 233, NULL, NULL, 235309),
(286947, '6f4xA00', NULL, NULL, 233, NULL, NULL, 235309),
(286948, '1wtaA00', NULL, NULL, 275, NULL, NULL, 235309),
(286949, '5eo6B00', NULL, NULL, 324, NULL, NULL, 235310),
(286950, '3e8jB00', NULL, NULL, 306, NULL, NULL, 235310),
(286951, '1tklA00', NULL, NULL, 326, NULL, NULL, 235310),
(286952, '1txnA00', NULL, NULL, 270, NULL, NULL, 235310),
(286953, '3ejoA00', NULL, NULL, 310, NULL, NULL, 235310),
(286954, '1vjuB00', NULL, NULL, 309, NULL, NULL, 235310),
(286955, '2aexA00', NULL, NULL, 346, NULL, NULL, 235310),
(286956, '2aneA00', NULL, NULL, 125, NULL, NULL, 235311),
(286957, '1zboA01', NULL, NULL, 114, NULL, NULL, 235311),
(286958, '3m65A01', NULL, NULL, 115, NULL, NULL, 235311),
(286959, '5fqdE02', NULL, NULL, 125, NULL, NULL, 235311),
(286960, '4ci2B02', NULL, NULL, 125, NULL, NULL, 235311),
(286961, '3jrtA00', NULL, NULL, 172, NULL, NULL, 235312),
(286962, '3djmD00', NULL, NULL, 116, NULL, NULL, 235313),
(286963, '2outA02', NULL, NULL, 41, NULL, NULL, 235314),
(286964, '1v66A00', NULL, NULL, 65, NULL, NULL, 235314),
(286965, '4bitA02', NULL, NULL, 56, NULL, NULL, 235314),
(286966, '2wqgA00', NULL, NULL, 51, NULL, NULL, 235314),
(286967, '2jvwA01', NULL, NULL, 60, NULL, NULL, 235314),
(286968, '1zbhA01', NULL, NULL, 74, NULL, NULL, 235314),
(286969, '2kvdA02', NULL, NULL, 58, NULL, NULL, 235314),
(286970, '1jeqA05', NULL, NULL, 51, NULL, NULL, 235314),
(286971, '2w51A02', NULL, NULL, 41, NULL, NULL, 235314),
(286972, '2kvuA00', NULL, NULL, 75, NULL, NULL, 235314),
(286973, '2rqyA02', NULL, NULL, 37, NULL, NULL, 235314),
(286974, '2fv6A01', NULL, NULL, 20, NULL, NULL, 235315),
(286975, '1zrxA00', NULL, NULL, 42, NULL, NULL, 235316),
(286976, '2wyhB04', NULL, NULL, 101, NULL, NULL, 235317),
(286977, '1htyA02', NULL, NULL, 111, NULL, NULL, 235317),
(286978, '5kbpA02', NULL, NULL, 99, NULL, NULL, 235317),
(286979, '1o7dB00', NULL, NULL, 84, NULL, NULL, 235317),
(286980, '1o7dC01', NULL, NULL, 61, NULL, NULL, 235317),
(286981, '3bvxA02', NULL, NULL, 111, NULL, NULL, 235317),
(286982, '3l09A03', NULL, NULL, 47, NULL, NULL, 235318),
(286983, '4jx2A01', NULL, NULL, 41, NULL, NULL, 235319),
(286984, '3duzA04', NULL, NULL, 34, NULL, NULL, 235320),
(286985, '3natA01', NULL, NULL, 155, NULL, NULL, 235321),
(286986, '4llgM00', NULL, NULL, 64, NULL, NULL, 235322),
(286987, '1amlA00', NULL, NULL, 40, NULL, NULL, 235323),
(286988, '2o3iA01', NULL, NULL, 240, NULL, NULL, 235324),
(286989, '3lxuX06', NULL, NULL, 255, NULL, NULL, 235325),
(286990, '5a0dB01', NULL, NULL, 110, NULL, NULL, 235326),
(286991, '2xi9A02', NULL, NULL, 102, NULL, NULL, 235326),
(286992, '5a0lA01', NULL, NULL, 111, NULL, NULL, 235326),
(286993, '4c0zE01', NULL, NULL, 119, NULL, NULL, 235326),
(286994, '1vddB01', NULL, NULL, 53, NULL, NULL, 235327),
(286995, '3vdpB01', NULL, NULL, 50, NULL, NULL, 235327),
(286996, '3vdpA01', NULL, NULL, 67, NULL, NULL, 235327),
(286997, '4jm1A00', NULL, NULL, 84, NULL, NULL, 235328),
(286998, '4i5sB03', NULL, NULL, 75, NULL, NULL, 235329),
(286999, '4q20A01', NULL, NULL, 84, NULL, NULL, 235329),
(287000, '2p67A03', NULL, NULL, 77, NULL, NULL, 235329),
(287001, '3nxsA03', NULL, NULL, 64, NULL, NULL, 235329),
(287002, '3a0rA02', NULL, NULL, 83, NULL, NULL, 235329);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(287003, '4u7nA01', NULL, NULL, 66, NULL, NULL, 235329),
(287004, '4biuE01', NULL, NULL, 115, NULL, NULL, 235329),
(287005, '3tk1B03', NULL, NULL, 66, NULL, NULL, 235329),
(287006, '5b1nA00', NULL, NULL, 69, NULL, NULL, 235329),
(287007, '1ixmA01', NULL, NULL, 71, NULL, NULL, 235329),
(287008, '5idjA01', NULL, NULL, 74, NULL, NULL, 235329),
(287009, '4fppB01', NULL, NULL, 71, NULL, NULL, 235329),
(287010, '4mt8B00', NULL, NULL, 102, NULL, NULL, 235329),
(287011, '4gczA03', NULL, NULL, 65, NULL, NULL, 235329),
(287012, '4gczB02', NULL, NULL, 92, NULL, NULL, 235329),
(287013, '3p32A03', NULL, NULL, 68, NULL, NULL, 235329),
(287014, '4jauA01', NULL, NULL, 90, NULL, NULL, 235329),
(287015, '4u7oA01', NULL, NULL, 82, NULL, NULL, 235329),
(287016, '2lfrA00', NULL, NULL, 114, NULL, NULL, 235329),
(287017, '2wwwA03', NULL, NULL, 67, NULL, NULL, 235329),
(287018, '3zccA00', NULL, NULL, 114, NULL, NULL, 235329),
(287019, '2c2aA01', NULL, NULL, 90, NULL, NULL, 235329),
(287020, '4bizE01', NULL, NULL, 80, NULL, NULL, 235329),
(287021, '4mtxC00', NULL, NULL, 102, NULL, NULL, 235329),
(287022, '4qpkA01', NULL, NULL, 76, NULL, NULL, 235329),
(287023, '4mtxD00', NULL, NULL, 102, NULL, NULL, 235329),
(287024, '3d36B02', NULL, NULL, 61, NULL, NULL, 235329),
(287025, '4mtxA00', NULL, NULL, 102, NULL, NULL, 235329),
(287026, '4kp4A01', NULL, NULL, 79, NULL, NULL, 235329),
(287027, '4mtxB00', NULL, NULL, 102, NULL, NULL, 235329),
(287028, '2qm8A03', NULL, NULL, 73, NULL, NULL, 235329),
(287029, '3iwcC00', NULL, NULL, 68, NULL, NULL, 235330),
(287030, '1wy6A00', NULL, NULL, 172, NULL, NULL, 235331),
(287031, '5xteC01', NULL, NULL, 64, NULL, NULL, 235332),
(287032, '3tguE01', NULL, NULL, 64, NULL, NULL, 235332),
(287033, '1bccE01', NULL, NULL, 64, NULL, NULL, 235332),
(287034, '3cx5E01', NULL, NULL, 55, NULL, NULL, 235332),
(287035, '1pp9E01', NULL, NULL, 64, NULL, NULL, 235332),
(287036, '3zilA00', NULL, NULL, 362, NULL, NULL, 235333),
(287037, '4a1gB00', NULL, NULL, 152, NULL, NULL, 235334),
(287038, '4aezI01', NULL, NULL, 198, NULL, NULL, 235334),
(287039, '3si5B00', NULL, NULL, 159, NULL, NULL, 235334),
(287040, '2wviA00', NULL, NULL, 164, NULL, NULL, 235334),
(287041, '3kd3A02', NULL, NULL, 60, NULL, NULL, 235335),
(287042, '4ap9A02', NULL, NULL, 60, NULL, NULL, 235335),
(287043, '1l7mA02', NULL, NULL, 61, NULL, NULL, 235335),
(287044, '3m1yB02', NULL, NULL, 61, NULL, NULL, 235335),
(287045, '3n28A03', NULL, NULL, 63, NULL, NULL, 235335),
(287046, '1nnlB02', NULL, NULL, 63, NULL, NULL, 235335),
(287047, '2e8yA01', NULL, NULL, 101, NULL, NULL, 235336),
(287048, '3wdhA01', NULL, NULL, 105, NULL, NULL, 235336),
(287049, '4jzaA02', NULL, NULL, 116, NULL, NULL, 235337),
(287050, '2pbyB02', NULL, NULL, 139, NULL, NULL, 235338),
(287051, '1mkiA02', NULL, NULL, 138, NULL, NULL, 235338),
(287052, '3r84A00', NULL, NULL, 86, NULL, NULL, 235339),
(287053, '4h63K00', NULL, NULL, 112, NULL, NULL, 235339),
(287054, '4n0rA03', NULL, NULL, 110, NULL, NULL, 235340),
(287055, '2nrrA00', NULL, NULL, 159, NULL, NULL, 235341),
(287056, '3c65A00', NULL, NULL, 159, NULL, NULL, 235341),
(287057, '4fxxB01', NULL, NULL, 82, NULL, NULL, 235342),
(287058, '1i8dC02', NULL, NULL, 98, NULL, NULL, 235343),
(287059, '4hizA03', NULL, NULL, 81, NULL, NULL, 235343),
(287060, '1fx0A01', NULL, NULL, 70, NULL, NULL, 235343),
(287061, '3ju4A03', NULL, NULL, 87, NULL, NULL, 235343),
(287062, '3oaaA01', NULL, NULL, 70, NULL, NULL, 235343),
(287063, '3a35A02', NULL, NULL, 98, NULL, NULL, 235343),
(287064, '3a35A01', NULL, NULL, 92, NULL, NULL, 235343),
(287065, '1skyB01', NULL, NULL, 70, NULL, NULL, 235343),
(287066, '2r9vA01', NULL, NULL, 71, NULL, NULL, 235343),
(287067, '6b8hK01', NULL, NULL, 95, NULL, NULL, 235343),
(287068, '5fl7A01', NULL, NULL, 71, NULL, NULL, 235343),
(287069, '3vr6A01', NULL, NULL, 78, NULL, NULL, 235343),
(287070, '5ik2K01', NULL, NULL, 70, NULL, NULL, 235343),
(287071, '3ziaB01', NULL, NULL, 71, NULL, NULL, 235343),
(287072, '3ddyA02', NULL, NULL, 90, NULL, NULL, 235343),
(287073, '1kzlA02', NULL, NULL, 107, NULL, NULL, 235343);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(287074, '3ddyA01', NULL, NULL, 87, NULL, NULL, 235343),
(287075, '1kzlA01', NULL, NULL, 89, NULL, NULL, 235343),
(287076, '4xd7B01', NULL, NULL, 69, NULL, NULL, 235343),
(287077, '2ck3A01', NULL, NULL, 70, NULL, NULL, 235343),
(287078, '4g6iB01', NULL, NULL, 93, NULL, NULL, 235343),
(287079, '2wssA01', NULL, NULL, 93, NULL, NULL, 235343),
(287080, '4g6iC02', NULL, NULL, 105, NULL, NULL, 235343),
(287081, '4xd7A01', NULL, NULL, 70, NULL, NULL, 235343),
(287082, '5cdfA01', NULL, NULL, 70, NULL, NULL, 235343),
(287083, '5dn6B01', NULL, NULL, 93, NULL, NULL, 235343),
(287084, '3gqbA01', NULL, NULL, 71, NULL, NULL, 235343),
(287085, '1i8dA01', NULL, NULL, 89, NULL, NULL, 235343),
(287086, '2qgmA03', NULL, NULL, 127, NULL, NULL, 235344),
(287087, '3b55A03', NULL, NULL, 127, NULL, NULL, 235344),
(287088, '2qtsA03', NULL, NULL, 88, NULL, NULL, 235345),
(287089, '6em3O02', NULL, NULL, 50, NULL, NULL, 235346),
(287090, '4a17I02', NULL, NULL, 50, NULL, NULL, 235346),
(287091, '2ciuA00', NULL, NULL, 127, NULL, NULL, 235347),
(287092, '3py9A01', NULL, NULL, 73, NULL, NULL, 235348),
(287093, '3py9A02', NULL, NULL, 69, NULL, NULL, 235348),
(287094, '3py9A03', NULL, NULL, 66, NULL, NULL, 235348),
(287095, '5e0yA00', NULL, NULL, 72, NULL, NULL, 235348),
(287096, '5e10A02', NULL, NULL, 68, NULL, NULL, 235348),
(287097, '3ouvA00', NULL, NULL, 71, NULL, NULL, 235348),
(287098, '2mgvA00', NULL, NULL, 65, NULL, NULL, 235348),
(287099, '5e10A01', NULL, NULL, 65, NULL, NULL, 235348),
(287100, '1x9pA01', NULL, NULL, 165, NULL, NULL, 235349),
(287101, '4ar2A01', NULL, NULL, 164, NULL, NULL, 235349),
(287102, '3hh0B02', NULL, NULL, 72, NULL, NULL, 235350),
(287103, '3ig5A04', NULL, NULL, 66, NULL, NULL, 235351),
(287104, '4h63Q02', NULL, NULL, 57, NULL, NULL, 235352),
(287105, '2x12A01', NULL, NULL, 190, NULL, NULL, 235353),
(287106, '1nktA02', NULL, NULL, 122, NULL, NULL, 235354),
(287107, '2ipcA02', NULL, NULL, 134, NULL, NULL, 235354),
(287108, '1tf5A02', NULL, NULL, 122, NULL, NULL, 235354),
(287109, '5k9tA02', NULL, NULL, 138, NULL, NULL, 235354),
(287110, '2e1mB01', NULL, NULL, 44, NULL, NULL, 235355),
(287111, '3qc1A02', NULL, NULL, 39, NULL, NULL, 235356),
(287112, '6e3aA01', NULL, NULL, 78, NULL, NULL, 235357),
(287113, '1wfxA01', NULL, NULL, 73, NULL, NULL, 235357),
(287114, '3ostA00', NULL, NULL, 128, NULL, NULL, 235358),
(287115, '3w1oA00', NULL, NULL, 119, NULL, NULL, 235359),
(287116, '2zpaA04', NULL, NULL, 140, NULL, NULL, 235360),
(287117, '3k59A05', NULL, NULL, 33, NULL, NULL, 235361),
(287118, '4i0wA00', NULL, NULL, 96, NULL, NULL, 235362),
(287119, '5l6hA06', NULL, NULL, 95, NULL, NULL, 235363),
(287120, '6dc6A06', NULL, NULL, 102, NULL, NULL, 235363),
(287121, '4ii2A06', NULL, NULL, 94, NULL, NULL, 235363),
(287122, '1loxA03', NULL, NULL, 113, NULL, NULL, 235364),
(287123, '3fg1D03', NULL, NULL, 133, NULL, NULL, 235364),
(287124, '3rdeA02', NULL, NULL, 85, NULL, NULL, 235364),
(287125, '3v98A03', NULL, NULL, 116, NULL, NULL, 235364),
(287126, '3vf1A03', NULL, NULL, 116, NULL, NULL, 235364),
(287127, '4nreA03', NULL, NULL, 116, NULL, NULL, 235364),
(287128, '3d3lA02', NULL, NULL, 85, NULL, NULL, 235364),
(287129, '4wfoA04', NULL, NULL, 134, NULL, NULL, 235364),
(287130, '2iukA04', NULL, NULL, 136, NULL, NULL, 235364),
(287131, '2iujA04', NULL, NULL, 134, NULL, NULL, 235364),
(287132, '1ik3A04', NULL, NULL, 134, NULL, NULL, 235364),
(287133, '1peqA03', NULL, NULL, 53, NULL, NULL, 235365),
(287134, '4fczA00', NULL, NULL, 183, NULL, NULL, 235366),
(287135, '2yy0B00', NULL, NULL, 53, NULL, NULL, 235367),
(287136, '3u8zD02', NULL, NULL, 70, NULL, NULL, 235368),
(287137, '4gxbA02', NULL, NULL, 62, NULL, NULL, 235368),
(287138, '2fefA01', NULL, NULL, 130, NULL, NULL, 235369),
(287139, '3bqeA00', NULL, NULL, 169, NULL, NULL, 235370),
(287140, '2j89A00', NULL, NULL, 183, NULL, NULL, 235370),
(287141, '4gwbA00', NULL, NULL, 168, NULL, NULL, 235370),
(287142, '4w8cB00', NULL, NULL, 144, NULL, NULL, 235370),
(287143, '1fvaA00', NULL, NULL, 201, NULL, NULL, 235370),
(287144, '2l90A00', NULL, NULL, 212, NULL, NULL, 235370);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(287145, '1ff3C00', NULL, NULL, 192, NULL, NULL, 235370),
(287146, '1fvgA00', NULL, NULL, 199, NULL, NULL, 235370),
(287147, '3pimB00', NULL, NULL, 187, NULL, NULL, 235370),
(287148, '4lwlA00', NULL, NULL, 217, NULL, NULL, 235370),
(287149, '1nwaA00', NULL, NULL, 168, NULL, NULL, 235370),
(287150, '3e0mC01', NULL, NULL, 164, NULL, NULL, 235370),
(287151, '4d7lB00', NULL, NULL, 213, NULL, NULL, 235370),
(287152, '1j27A00', NULL, NULL, 102, NULL, NULL, 235371),
(287153, '3r45C00', NULL, NULL, 81, NULL, NULL, 235372),
(287154, '2c5zA00', NULL, NULL, 104, NULL, NULL, 235373),
(287155, '2a7oA00', NULL, NULL, 112, NULL, NULL, 235373),
(287156, '3jybA00', NULL, NULL, 145, NULL, NULL, 235374),
(287157, '2l1lB00', NULL, NULL, 127, NULL, NULL, 235375),
(287158, '1w1wE00', NULL, NULL, 82, NULL, NULL, 235376),
(287159, '5xnsC00', NULL, NULL, 74, NULL, NULL, 235376),
(287160, '2csuA02', NULL, NULL, 159, NULL, NULL, 235377),
(287161, '2csuA03', NULL, NULL, 170, NULL, NULL, 235377),
(287162, '2fp4A02', NULL, NULL, 170, NULL, NULL, 235377),
(287163, '2fp4B03', NULL, NULL, 146, NULL, NULL, 235377),
(287164, '6mggA02', NULL, NULL, 166, NULL, NULL, 235377),
(287165, '3ufxB03', NULL, NULL, 148, NULL, NULL, 235377),
(287166, '2yv2A02', NULL, NULL, 168, NULL, NULL, 235377),
(287167, '5tdeB02', NULL, NULL, 186, NULL, NULL, 235377),
(287168, '5tdeA03', NULL, NULL, 189, NULL, NULL, 235377),
(287169, '2yv1A02', NULL, NULL, 164, NULL, NULL, 235377),
(287170, '1oi7A02', NULL, NULL, 165, NULL, NULL, 235377),
(287171, '4xymC03', NULL, NULL, 171, NULL, NULL, 235377),
(287172, '4xymA02', NULL, NULL, 164, NULL, NULL, 235377),
(287173, '2nu8B03', NULL, NULL, 149, NULL, NULL, 235377),
(287174, '2nu8A02', NULL, NULL, 166, NULL, NULL, 235377),
(287175, '6melA02', NULL, NULL, 172, NULL, NULL, 235377),
(287176, '3dmyA02', NULL, NULL, 140, NULL, NULL, 235377),
(287177, '3dmyA03', NULL, NULL, 166, NULL, NULL, 235377),
(287178, '3l4gC02', NULL, NULL, 45, NULL, NULL, 235378),
(287179, '4jmfA00', NULL, NULL, 50, NULL, NULL, 235379),
(287180, '4ymuD00', NULL, NULL, 220, NULL, NULL, 235380),
(287181, '3rlfF04', NULL, NULL, 245, NULL, NULL, 235380),
(287182, '3rlfG01', NULL, NULL, 283, NULL, NULL, 235380),
(287183, '2onkC00', NULL, NULL, 261, NULL, NULL, 235380),
(287184, '3d31C00', NULL, NULL, 260, NULL, NULL, 235380),
(287185, '3tuiA00', NULL, NULL, 217, NULL, NULL, 235380),
(287186, '4tquN00', NULL, NULL, 284, NULL, NULL, 235380),
(287187, '4tquM01', NULL, NULL, 249, NULL, NULL, 235380),
(287188, '4dnnA00', NULL, NULL, 56, NULL, NULL, 235381),
(287189, '4dnnB00', NULL, NULL, 56, NULL, NULL, 235381),
(287190, '2ymjA00', NULL, NULL, 52, NULL, NULL, 235381),
(287191, '3k6tB00', NULL, NULL, 60, NULL, NULL, 235381),
(287192, '4hfsA00', NULL, NULL, 212, NULL, NULL, 235382),
(287193, '4aybA09', NULL, NULL, 53, NULL, NULL, 235383),
(287194, '1e8pA00', NULL, NULL, 46, NULL, NULL, 235384),
(287195, '2j4mA01', NULL, NULL, 36, NULL, NULL, 235384),
(287196, '2j4mA02', NULL, NULL, 42, NULL, NULL, 235384),
(287197, '2hbpA00', NULL, NULL, 68, NULL, NULL, 235385),
(287198, '2lmzA00', NULL, NULL, 42, NULL, NULL, 235386),
(287199, '6cgvM01', NULL, NULL, 134, NULL, NULL, 235387),
(287200, '1e1hB02', NULL, NULL, 64, NULL, NULL, 235388),
(287201, '3k3qC02', NULL, NULL, 65, NULL, NULL, 235388),
(287202, '2pmsC00', NULL, NULL, 125, NULL, NULL, 235389),
(287203, '2p63A01', NULL, NULL, 47, NULL, NULL, 235390),
(287204, '2jsnA00', NULL, NULL, 96, NULL, NULL, 235391),
(287205, '5o7oC04', NULL, NULL, 208, NULL, NULL, 235392),
(287206, '2x0qA04', NULL, NULL, 208, NULL, NULL, 235392),
(287207, '2m0mA00', NULL, NULL, 107, NULL, NULL, 235393),
(287208, '2mabA00', NULL, NULL, 109, NULL, NULL, 235393),
(287209, '2k3pA01', NULL, NULL, 116, NULL, NULL, 235393),
(287210, '2mfzA01', NULL, NULL, 109, NULL, NULL, 235393),
(287211, '2khmA01', NULL, NULL, 108, NULL, NULL, 235393),
(287212, '3mhsB00', NULL, NULL, 96, NULL, NULL, 235394),
(287213, '4dhxB00', NULL, NULL, 101, NULL, NULL, 235394),
(287214, '1eboC00', NULL, NULL, 113, NULL, NULL, 235395),
(287215, '4jf3A00', NULL, NULL, 104, NULL, NULL, 235395);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(287216, '1y66A00', NULL, NULL, 52, NULL, NULL, 235395),
(287217, '5ka5A00', NULL, NULL, 91, NULL, NULL, 235395),
(287218, '1envA00', NULL, NULL, 123, NULL, NULL, 235395),
(287219, '1jq0A00', NULL, NULL, 84, NULL, NULL, 235395),
(287220, '1qbzA00', NULL, NULL, 123, NULL, NULL, 235395),
(287221, '2p6jA00', NULL, NULL, 52, NULL, NULL, 235395),
(287222, '3wfvA00', NULL, NULL, 86, NULL, NULL, 235395),
(287223, '3b77C02', NULL, NULL, 89, NULL, NULL, 235395),
(287224, '5cn0A00', NULL, NULL, 73, NULL, NULL, 235395),
(287225, '1jpxA00', NULL, NULL, 84, NULL, NULL, 235395),
(287226, '5hfmA00', NULL, NULL, 82, NULL, NULL, 235395),
(287227, '1f23D00', NULL, NULL, 76, NULL, NULL, 235395),
(287228, '1y4mA00', NULL, NULL, 53, NULL, NULL, 235395),
(287229, '3cp1A00', NULL, NULL, 86, NULL, NULL, 235395),
(287230, '3p30A00', NULL, NULL, 96, NULL, NULL, 235395),
(287231, '4jgsE00', NULL, NULL, 105, NULL, NULL, 235395),
(287232, '3k9aA00', NULL, NULL, 108, NULL, NULL, 235395),
(287233, '2lp7A00', NULL, NULL, 59, NULL, NULL, 235395),
(287234, '5ha6B00', NULL, NULL, 94, NULL, NULL, 235395),
(287235, '2eboA00', NULL, NULL, 74, NULL, NULL, 235395),
(287236, '1mg1A03', NULL, NULL, 84, NULL, NULL, 235395),
(287237, '4e2lD02', NULL, NULL, 107, NULL, NULL, 235395),
(287238, '4g2kC00', NULL, NULL, 109, NULL, NULL, 235395),
(287239, '3mhsC01', NULL, NULL, 42, NULL, NULL, 235395),
(287240, '1mofA00', NULL, NULL, 55, NULL, NULL, 235395),
(287241, '3gwoA00', NULL, NULL, 54, NULL, NULL, 235395),
(287242, '5h9cA00', NULL, NULL, 78, NULL, NULL, 235395),
(287243, '2x7rB00', NULL, NULL, 45, NULL, NULL, 235395),
(287244, '1qr9A00', NULL, NULL, 68, NULL, NULL, 235395),
(287245, '4n21E00', NULL, NULL, 130, NULL, NULL, 235395),
(287246, '2wdtC02', NULL, NULL, 124, NULL, NULL, 235396),
(287247, '1z2zA03', NULL, NULL, 89, NULL, NULL, 235397),
(287248, '4r80A00', NULL, NULL, 85, NULL, NULL, 235398),
(287249, '1e8rA00', NULL, NULL, 50, NULL, NULL, 235399),
(287250, '3qyeA02', NULL, NULL, 95, NULL, NULL, 235400),
(287251, '2qq8A02', NULL, NULL, 118, NULL, NULL, 235400),
(287252, '3hzjA02', NULL, NULL, 94, NULL, NULL, 235400),
(287253, '4nc6A02', NULL, NULL, 94, NULL, NULL, 235400),
(287254, '3qybA02', NULL, NULL, 93, NULL, NULL, 235400),
(287255, '4p17A02', NULL, NULL, 110, NULL, NULL, 235400),
(287256, '2w02B04', NULL, NULL, 21, NULL, NULL, 235401),
(287257, '3witA00', NULL, NULL, 82, NULL, NULL, 235402),
(287258, '3pqhA01', NULL, NULL, 60, NULL, NULL, 235402),
(287259, '2g7jA00', NULL, NULL, 124, NULL, NULL, 235403),
(287260, '1szhA01', NULL, NULL, 68, NULL, NULL, 235404),
(287261, '3es1A01', NULL, NULL, 40, NULL, NULL, 235405),
(287262, '2luhB00', NULL, NULL, 59, NULL, NULL, 235406),
(287263, '2zixB01', NULL, NULL, 62, NULL, NULL, 235407),
(287264, '2eqgA01', NULL, NULL, 38, NULL, NULL, 235408),
(287265, '1iq0A02', NULL, NULL, 100, NULL, NULL, 235409),
(287266, '3gdzB00', NULL, NULL, 109, NULL, NULL, 235409),
(287267, '2zueA01', NULL, NULL, 116, NULL, NULL, 235409),
(287268, '1f7uA03', NULL, NULL, 135, NULL, NULL, 235409),
(287269, '4gu5A03', NULL, NULL, 214, NULL, NULL, 235410),
(287270, '3umvA03', NULL, NULL, 151, NULL, NULL, 235410),
(287271, '2wq7A03', NULL, NULL, 186, NULL, NULL, 235410),
(287272, '1owlA03', NULL, NULL, 176, NULL, NULL, 235410),
(287273, '1np7B03', NULL, NULL, 181, NULL, NULL, 235410),
(287274, '2xryA03', NULL, NULL, 143, NULL, NULL, 235410),
(287275, '5zm0A03', NULL, NULL, 186, NULL, NULL, 235410),
(287276, '4mlpA03', NULL, NULL, 186, NULL, NULL, 235410),
(287277, '2j07A03', NULL, NULL, 162, NULL, NULL, 235410),
(287278, '3fy4C03', NULL, NULL, 225, NULL, NULL, 235410),
(287279, '4djaA03', NULL, NULL, 121, NULL, NULL, 235410),
(287280, '1dnpA03', NULL, NULL, 183, NULL, NULL, 235410),
(287281, '2j4dB03', NULL, NULL, 156, NULL, NULL, 235410),
(287282, '1u3dA03', NULL, NULL, 202, NULL, NULL, 235410),
(287283, '4u63A03', NULL, NULL, 188, NULL, NULL, 235410),
(287284, '5t5xA03', NULL, NULL, 188, NULL, NULL, 235410),
(287285, '2e0iA03', NULL, NULL, 183, NULL, NULL, 235410),
(287286, '3zxsA03', NULL, NULL, 121, NULL, NULL, 235410);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(287287, '2hd0A01', NULL, NULL, 79, NULL, NULL, 235411),
(287288, '1zbsA03', NULL, NULL, 89, NULL, NULL, 235412),
(287289, '1zxoA03', NULL, NULL, 89, NULL, NULL, 235412),
(287290, '2mysA01', NULL, NULL, 48, NULL, NULL, 235413),
(287291, '4e7sA01', NULL, NULL, 59, NULL, NULL, 235413),
(287292, '1b7tA02', NULL, NULL, 52, NULL, NULL, 235413),
(287293, '4pfoA01', NULL, NULL, 49, NULL, NULL, 235413),
(287294, '1lvkA01', NULL, NULL, 48, NULL, NULL, 235413),
(287295, '4xwwA02', NULL, NULL, 150, NULL, NULL, 235414),
(287296, '3zq4A02', NULL, NULL, 151, NULL, NULL, 235414),
(287297, '2az4A02', NULL, NULL, 154, NULL, NULL, 235414),
(287298, '3bk2A02', NULL, NULL, 150, NULL, NULL, 235414),
(287299, '5a0tA02', NULL, NULL, 158, NULL, NULL, 235414),
(287300, '6hikL01', NULL, NULL, 38, NULL, NULL, 235415),
(287301, '4re1C01', NULL, NULL, 38, NULL, NULL, 235415),
(287302, '6geiL01', NULL, NULL, 38, NULL, NULL, 235415),
(287303, '4oj5A02', NULL, NULL, 71, NULL, NULL, 235416),
(287304, '4qnlA02', NULL, NULL, 59, NULL, NULL, 235416),
(287305, '6ig5A01', NULL, NULL, 138, NULL, NULL, 235417),
(287306, '6n1mA01', NULL, NULL, 135, NULL, NULL, 235417),
(287307, '6at7B01', NULL, NULL, 247, NULL, NULL, 235417),
(287308, '3gzhA01', NULL, NULL, 143, NULL, NULL, 235417),
(287309, '1w27A01', NULL, NULL, 236, NULL, NULL, 235417),
(287310, '3ocfD01', NULL, NULL, 139, NULL, NULL, 235417),
(287311, '4eeiA01', NULL, NULL, 92, NULL, NULL, 235417),
(287312, '3unvA01', NULL, NULL, 194, NULL, NULL, 235417),
(287313, '1re5A01', NULL, NULL, 104, NULL, NULL, 235417),
(287314, '1k62A01', NULL, NULL, 137, NULL, NULL, 235417),
(287315, '4mx2A01', NULL, NULL, 120, NULL, NULL, 235417),
(287316, '1jswA01', NULL, NULL, 137, NULL, NULL, 235417),
(287317, '1c3cA01', NULL, NULL, 91, NULL, NULL, 235417),
(287318, '5v4lA01', NULL, NULL, 96, NULL, NULL, 235417),
(287319, '1hy0A01', NULL, NULL, 137, NULL, NULL, 235417),
(287320, '1gkmA01', NULL, NULL, 194, NULL, NULL, 235417),
(287321, '1tj7A01', NULL, NULL, 107, NULL, NULL, 235417),
(287322, '3rrpA01', NULL, NULL, 129, NULL, NULL, 235417),
(287323, '1yfmA01', NULL, NULL, 135, NULL, NULL, 235417),
(287324, '2qgaB01', NULL, NULL, 116, NULL, NULL, 235417),
(287325, '1q5nA01', NULL, NULL, 99, NULL, NULL, 235417),
(287326, '2qveA01', NULL, NULL, 193, NULL, NULL, 235417),
(287327, '1k7wA01', NULL, NULL, 137, NULL, NULL, 235417),
(287328, '3c8tA01', NULL, NULL, 102, NULL, NULL, 235417),
(287329, '4admA01', NULL, NULL, 127, NULL, NULL, 235417),
(287330, '1yisA01', NULL, NULL, 104, NULL, NULL, 235417),
(287331, '2x75A01', NULL, NULL, 92, NULL, NULL, 235417),
(287332, '1vdkA01', NULL, NULL, 138, NULL, NULL, 235417),
(287333, '5uppB01', NULL, NULL, 136, NULL, NULL, 235417),
(287334, '3gtdA01', NULL, NULL, 134, NULL, NULL, 235417),
(287335, '1furA01', NULL, NULL, 134, NULL, NULL, 235417),
(287336, '5eyvB01', NULL, NULL, 99, NULL, NULL, 235417),
(287337, '2o6yC01', NULL, NULL, 202, NULL, NULL, 235417),
(287338, '1i0aA01', NULL, NULL, 137, NULL, NULL, 235417),
(287339, '1dofA02', NULL, NULL, 94, NULL, NULL, 235417),
(287340, '2nynA01', NULL, NULL, 199, NULL, NULL, 235417),
(287341, '2nyfA01', NULL, NULL, 200, NULL, NULL, 235417),
(287342, '3qbpA01', NULL, NULL, 117, NULL, NULL, 235417),
(287343, '5nx8B01', NULL, NULL, 94, NULL, NULL, 235417),
(287344, '2e9fB01', NULL, NULL, 108, NULL, NULL, 235417),
(287345, '5xnyA01', NULL, NULL, 107, NULL, NULL, 235417),
(287346, '4hgvA01', NULL, NULL, 134, NULL, NULL, 235417),
(287347, '3tv2A01', NULL, NULL, 134, NULL, NULL, 235417),
(287348, '3rd8A01', NULL, NULL, 127, NULL, NULL, 235417),
(287349, '4nslA01', NULL, NULL, 131, NULL, NULL, 235417),
(287350, '5vkwA01', NULL, NULL, 97, NULL, NULL, 235417),
(287351, '3bhgA01', NULL, NULL, 120, NULL, NULL, 235417),
(287352, '4v2qB01', NULL, NULL, 223, NULL, NULL, 235417),
(287353, '3r6qA01', NULL, NULL, 134, NULL, NULL, 235417),
(287354, '2pfmA01', NULL, NULL, 103, NULL, NULL, 235417),
(287355, '1y2mD01', NULL, NULL, 246, NULL, NULL, 235417),
(287356, '4efcA01', NULL, NULL, 133, NULL, NULL, 235417),
(287357, '4b9iA00', NULL, NULL, 149, NULL, NULL, 235418);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(287358, '4b9jA00', NULL, NULL, 150, NULL, NULL, 235418),
(287359, '4b9gA00', NULL, NULL, 161, NULL, NULL, 235418),
(287360, '2ckxA00', NULL, NULL, 83, NULL, NULL, 235419),
(287361, '2ajeA00', NULL, NULL, 105, NULL, NULL, 235419),
(287362, '2rohA01', NULL, NULL, 79, NULL, NULL, 235419),
(287363, '1vw4U00', NULL, NULL, 86, NULL, NULL, 235420),
(287364, '1bxyA00', NULL, NULL, 60, NULL, NULL, 235420),
(287365, '6hmaX00', NULL, NULL, 58, NULL, NULL, 235420),
(287366, '5dm6W00', NULL, NULL, 55, NULL, NULL, 235420),
(287367, '6qula00', NULL, NULL, 59, NULL, NULL, 235420),
(287368, '5xymZ00', NULL, NULL, 61, NULL, NULL, 235420),
(287369, '1vq8W01', NULL, NULL, 98, NULL, NULL, 235420),
(287370, '5v7qZ00', NULL, NULL, 65, NULL, NULL, 235420),
(287371, '3r4rA02', NULL, NULL, 128, NULL, NULL, 235421),
(287372, '2h36X00', NULL, NULL, 112, NULL, NULL, 235422),
(287373, '3df6B00', NULL, NULL, 99, NULL, NULL, 235422),
(287374, '4ksnD00', NULL, NULL, 78, NULL, NULL, 235423),
(287375, '2lqlA01', NULL, NULL, 52, NULL, NULL, 235424),
(287376, '2l0yA00', NULL, NULL, 60, NULL, NULL, 235424),
(287377, '2lqlA02', NULL, NULL, 44, NULL, NULL, 235424),
(287378, '3a3cA03', NULL, NULL, 81, NULL, NULL, 235424),
(287379, '4ob0B01', NULL, NULL, 126, NULL, NULL, 235425),
(287380, '4zgjB01', NULL, NULL, 105, NULL, NULL, 235425),
(287381, '3vygE00', NULL, NULL, 157, NULL, NULL, 235425),
(287382, '3hhtB01', NULL, NULL, 132, NULL, NULL, 235425),
(287383, '3qyhB01', NULL, NULL, 118, NULL, NULL, 235425),
(287384, '3a8gB01', NULL, NULL, 110, NULL, NULL, 235425),
(287385, '1v29B01', NULL, NULL, 132, NULL, NULL, 235425),
(287386, '4lqeA00', NULL, NULL, 160, NULL, NULL, 235426),
(287387, '3qirD00', NULL, NULL, 118, NULL, NULL, 235427),
(287388, '1r4kA01', NULL, NULL, 133, NULL, NULL, 235427),
(287389, '4z4dA02', NULL, NULL, 126, NULL, NULL, 235427),
(287390, '4kreA02', NULL, NULL, 126, NULL, NULL, 235427),
(287391, '5vm9A02', NULL, NULL, 126, NULL, NULL, 235427),
(287392, '2qvwD02', NULL, NULL, 115, NULL, NULL, 235427),
(287393, '3o7vX00', NULL, NULL, 124, NULL, NULL, 235427),
(287394, '2xfmA00', NULL, NULL, 120, NULL, NULL, 235427),
(287395, '3mj0A00', NULL, NULL, 124, NULL, NULL, 235427),
(287396, '4ngfD02', NULL, NULL, 116, NULL, NULL, 235427),
(287397, '4nhaA02', NULL, NULL, 94, NULL, NULL, 235427),
(287398, '4ngdA02', NULL, NULL, 121, NULL, NULL, 235427),
(287399, '1sy7A02', NULL, NULL, 64, NULL, NULL, 235428),
(287400, '4aumA02', NULL, NULL, 99, NULL, NULL, 235428),
(287401, '3ttvA02', NULL, NULL, 104, NULL, NULL, 235428),
(287402, '4aj9A02', NULL, NULL, 98, NULL, NULL, 235428),
(287403, '2iufA02', NULL, NULL, 98, NULL, NULL, 235428),
(287404, '1h6uA01', NULL, NULL, 43, NULL, NULL, 235429),
(287405, '4aw4A01', NULL, NULL, 46, NULL, NULL, 235429),
(287406, '4dx9q00', NULL, NULL, 141, NULL, NULL, 235430),
(287407, '4f55A02', NULL, NULL, 36, NULL, NULL, 235431),
(287408, '4iaoA01', NULL, NULL, 138, NULL, NULL, 235432),
(287409, '2imzA00', NULL, NULL, 168, NULL, NULL, 235433),
(287410, '2lwyA00', NULL, NULL, 138, NULL, NULL, 235433),
(287411, '1am2A00', NULL, NULL, 199, NULL, NULL, 235433),
(287412, '1mi8A00', NULL, NULL, 158, NULL, NULL, 235433),
(287413, '1at0A00', NULL, NULL, 145, NULL, NULL, 235433),
(287414, '1zdeA00', NULL, NULL, 177, NULL, NULL, 235433),
(287415, '2lcjA00', NULL, NULL, 185, NULL, NULL, 235433),
(287416, '4kl5B00', NULL, NULL, 144, NULL, NULL, 235433),
(287417, '6freA00', NULL, NULL, 169, NULL, NULL, 235433),
(287418, '1dq3A01', NULL, NULL, 177, NULL, NULL, 235433),
(287419, '4lx3A00', NULL, NULL, 108, NULL, NULL, 235433),
(287420, '2jmzA01', NULL, NULL, 168, NULL, NULL, 235433),
(287421, '3nzmA00', NULL, NULL, 168, NULL, NULL, 235433),
(287422, '4qfqA00', NULL, NULL, 111, NULL, NULL, 235433),
(287423, '4o1rA00', NULL, NULL, 142, NULL, NULL, 235433),
(287424, '4o1sA00', NULL, NULL, 170, NULL, NULL, 235433),
(287425, '1dfaA01', NULL, NULL, 219, NULL, NULL, 235433),
(287426, '4e2uA00', NULL, NULL, 168, NULL, NULL, 235433),
(287427, '1gppA00', NULL, NULL, 237, NULL, NULL, 235433),
(287428, '5k08A00', NULL, NULL, 142, NULL, NULL, 235433);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(287429, '2cw8A01', NULL, NULL, 169, NULL, NULL, 235433),
(287430, '5o9jA00', NULL, NULL, 184, NULL, NULL, 235433),
(287431, '5o9iA00', NULL, NULL, 195, NULL, NULL, 235433),
(287432, '5zw4A00', NULL, NULL, 225, NULL, NULL, 235434),
(287433, '4guaA02', NULL, NULL, 208, NULL, NULL, 235434),
(287434, '2jjqA02', NULL, NULL, 204, NULL, NULL, 235434),
(287435, '3mq2A00', NULL, NULL, 218, NULL, NULL, 235434),
(287436, '3sm3A00', NULL, NULL, 218, NULL, NULL, 235434),
(287437, '3ubtA01', NULL, NULL, 180, NULL, NULL, 235434),
(287438, '3pvcA01', NULL, NULL, 224, NULL, NULL, 235434),
(287439, '3vseA03', NULL, NULL, 224, NULL, NULL, 235434),
(287440, '3tmaA02', NULL, NULL, 181, NULL, NULL, 235434),
(287441, '1g55A02', NULL, NULL, 199, NULL, NULL, 235434),
(287442, '3e8sA00', NULL, NULL, 227, NULL, NULL, 235434),
(287443, '1xj5B02', NULL, NULL, 237, NULL, NULL, 235434),
(287444, '2oxtA00', NULL, NULL, 265, NULL, NULL, 235434),
(287445, '4xcxA00', NULL, NULL, 249, NULL, NULL, 235434),
(287446, '3bt7A01', NULL, NULL, 224, NULL, NULL, 235434),
(287447, '3jwhA00', NULL, NULL, 217, NULL, NULL, 235434),
(287448, '1u2zA02', NULL, NULL, 180, NULL, NULL, 235434),
(287449, '4lecA00', NULL, NULL, 212, NULL, NULL, 235434),
(287450, '5x7fA00', NULL, NULL, 205, NULL, NULL, 235434),
(287451, '3dp7A03', NULL, NULL, 172, NULL, NULL, 235434),
(287452, '3iylW04', NULL, NULL, 233, NULL, NULL, 235434),
(287453, '6dubB00', NULL, NULL, 222, NULL, NULL, 235434),
(287454, '3cggA00', NULL, NULL, 195, NULL, NULL, 235434),
(287455, '3dxyA00', NULL, NULL, 218, NULL, NULL, 235434),
(287456, '4mikA00', NULL, NULL, 264, NULL, NULL, 235434),
(287457, '5ftwA02', NULL, NULL, 191, NULL, NULL, 235434),
(287458, '2b78A03', NULL, NULL, 213, NULL, NULL, 235434),
(287459, '1y8cA01', NULL, NULL, 186, NULL, NULL, 235434),
(287460, '1im8B00', NULL, NULL, 223, NULL, NULL, 235434),
(287461, '1xcjA00', NULL, NULL, 235, NULL, NULL, 235434),
(287462, '4rwzA00', NULL, NULL, 223, NULL, NULL, 235434),
(287463, '2fpoC00', NULL, NULL, 202, NULL, NULL, 235434),
(287464, '4c4aA03', NULL, NULL, 144, NULL, NULL, 235434),
(287465, '3r0qG01', NULL, NULL, 144, NULL, NULL, 235434),
(287466, '4pggA02', NULL, NULL, 250, NULL, NULL, 235434),
(287467, '4c4aA01', NULL, NULL, 150, NULL, NULL, 235434),
(287468, '2bzgA00', NULL, NULL, 232, NULL, NULL, 235434),
(287469, '2qm3A02', NULL, NULL, 226, NULL, NULL, 235434),
(287470, '3giwA00', NULL, NULL, 277, NULL, NULL, 235434),
(287471, '2ipxA02', NULL, NULL, 178, NULL, NULL, 235434),
(287472, '3c3pA00', NULL, NULL, 210, NULL, NULL, 235434),
(287473, '2b3tA02', NULL, NULL, 192, NULL, NULL, 235434),
(287474, '3hm2A00', NULL, NULL, 178, NULL, NULL, 235434),
(287475, '3g5tA00', NULL, NULL, 299, NULL, NULL, 235434),
(287476, '4iscA00', NULL, NULL, 164, NULL, NULL, 235434),
(287477, '3ptaA05', NULL, NULL, 202, NULL, NULL, 235434),
(287478, '5fubA01', NULL, NULL, 149, NULL, NULL, 235434),
(287479, '5ezqA02', NULL, NULL, 189, NULL, NULL, 235434),
(287480, '5iceA02', NULL, NULL, 251, NULL, NULL, 235434),
(287481, '2i7cB02', NULL, NULL, 224, NULL, NULL, 235434),
(287482, '3grzB00', NULL, NULL, 205, NULL, NULL, 235434),
(287483, '3ldgA02', NULL, NULL, 189, NULL, NULL, 235434),
(287484, '2wa2A00', NULL, NULL, 255, NULL, NULL, 235434),
(287485, '4gekA00', NULL, NULL, 230, NULL, NULL, 235434),
(287486, '3dmgA01', NULL, NULL, 179, NULL, NULL, 235434),
(287487, '4krgA01', NULL, NULL, 249, NULL, NULL, 235434),
(287488, '4l7vA00', NULL, NULL, 206, NULL, NULL, 235434),
(287489, '1nt2A02', NULL, NULL, 174, NULL, NULL, 235434),
(287490, '3dmgA02', NULL, NULL, 202, NULL, NULL, 235434),
(287491, '6iwtA02', NULL, NULL, 248, NULL, NULL, 235434),
(287492, '5t67A02', NULL, NULL, 202, NULL, NULL, 235434),
(287493, '6qe0A00', NULL, NULL, 283, NULL, NULL, 235434),
(287494, '2py6A03', NULL, NULL, 200, NULL, NULL, 235434),
(287495, '1xtpA01', NULL, NULL, 216, NULL, NULL, 235434),
(287496, '3bkwB00', NULL, NULL, 219, NULL, NULL, 235434),
(287497, '1ne2B00', NULL, NULL, 200, NULL, NULL, 235434),
(287498, '3lbyA00', NULL, NULL, 181, NULL, NULL, 235434),
(287499, '3m4xA02', NULL, NULL, 303, NULL, NULL, 235434);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(287500, '1o9gA01', NULL, NULL, 207, NULL, NULL, 235434),
(287501, '1ve3A00', NULL, NULL, 227, NULL, NULL, 235434),
(287502, '1uwvA02', NULL, NULL, 207, NULL, NULL, 235434),
(287503, '4kigA02', NULL, NULL, 178, NULL, NULL, 235434),
(287504, '2yx1A03', NULL, NULL, 180, NULL, NULL, 235434),
(287505, '1kyzA02', NULL, NULL, 250, NULL, NULL, 235434),
(287506, '3ftdA01', NULL, NULL, 184, NULL, NULL, 235434),
(287507, '3tqsA01', NULL, NULL, 190, NULL, NULL, 235434),
(287508, '2qyoA02', NULL, NULL, 249, NULL, NULL, 235434),
(287509, '1yf3A01', NULL, NULL, 164, NULL, NULL, 235434),
(287510, '5yx2B00', NULL, NULL, 208, NULL, NULL, 235434),
(287511, '3ou2A00', NULL, NULL, 218, NULL, NULL, 235434),
(287512, '3douA00', NULL, NULL, 191, NULL, NULL, 235434),
(287513, '3me5A02', NULL, NULL, 280, NULL, NULL, 235434),
(287514, '1zq9A01', NULL, NULL, 187, NULL, NULL, 235434),
(287515, '3kkzB00', NULL, NULL, 267, NULL, NULL, 235434),
(287516, '3m70A02', NULL, NULL, 179, NULL, NULL, 235434),
(287517, '1af7A02', NULL, NULL, 194, NULL, NULL, 235434),
(287518, '3g7uA01', NULL, NULL, 198, NULL, NULL, 235434),
(287519, '2pjdA01', NULL, NULL, 158, NULL, NULL, 235434),
(287520, '5f2kB02', NULL, NULL, 215, NULL, NULL, 235434),
(287521, '2pjdA02', NULL, NULL, 185, NULL, NULL, 235434),
(287522, '1kpgD00', NULL, NULL, 287, NULL, NULL, 235434),
(287523, '1ixkA02', NULL, NULL, 207, NULL, NULL, 235434),
(287524, '3tm4A02', NULL, NULL, 184, NULL, NULL, 235434),
(287525, '3khkA02', NULL, NULL, 319, NULL, NULL, 235434),
(287526, '3vc1J00', NULL, NULL, 276, NULL, NULL, 235434),
(287527, '3c3yA00', NULL, NULL, 237, NULL, NULL, 235434),
(287528, '1r8xA02', NULL, NULL, 188, NULL, NULL, 235434),
(287529, '2ob1A00', NULL, NULL, 319, NULL, NULL, 235434),
(287530, '5c0oH00', NULL, NULL, 220, NULL, NULL, 235434),
(287531, '4pcaB00', NULL, NULL, 226, NULL, NULL, 235434),
(287532, '1jg1A00', NULL, NULL, 235, NULL, NULL, 235434),
(287533, '4dkjA01', NULL, NULL, 311, NULL, NULL, 235434),
(287534, '5eehC03', NULL, NULL, 172, NULL, NULL, 235434),
(287535, '2yqzA01', NULL, NULL, 195, NULL, NULL, 235434),
(287536, '4x1oA00', NULL, NULL, 219, NULL, NULL, 235434),
(287537, '3ckkA01', NULL, NULL, 215, NULL, NULL, 235434),
(287538, '3tfwB00', NULL, NULL, 226, NULL, NULL, 235434),
(287539, '5cm2Z00', NULL, NULL, 205, NULL, NULL, 235434),
(287540, '1vbfA00', NULL, NULL, 231, NULL, NULL, 235434),
(287541, '3gu3A01', NULL, NULL, 175, NULL, NULL, 235434),
(287542, '2iipC00', NULL, NULL, 260, NULL, NULL, 235434),
(287543, '3c0kA03', NULL, NULL, 215, NULL, NULL, 235434),
(287544, '3hp7A02', NULL, NULL, 224, NULL, NULL, 235434),
(287545, '3egeA00', NULL, NULL, 261, NULL, NULL, 235434),
(287546, '5cvdB00', NULL, NULL, 226, NULL, NULL, 235434),
(287547, '5bp7A00', NULL, NULL, 248, NULL, NULL, 235434),
(287548, '4hh4C01', NULL, NULL, 198, NULL, NULL, 235434),
(287549, '5bxyA00', NULL, NULL, 158, NULL, NULL, 235434),
(287550, '5ccbA02', NULL, NULL, 217, NULL, NULL, 235434),
(287551, '1i1nA00', NULL, NULL, 226, NULL, NULL, 235434),
(287552, '3iv6A01', NULL, NULL, 196, NULL, NULL, 235434),
(287553, '2ih2A01', NULL, NULL, 223, NULL, NULL, 235434),
(287554, '2oo3A00', NULL, NULL, 283, NULL, NULL, 235434),
(287555, '3evfA00', NULL, NULL, 277, NULL, NULL, 235434),
(287556, '6fdfA01', NULL, NULL, 204, NULL, NULL, 235434),
(287557, '2gb4B00', NULL, NULL, 230, NULL, NULL, 235434),
(287558, '3ufbA02', NULL, NULL, 325, NULL, NULL, 235434),
(287559, '3l8dA00', NULL, NULL, 211, NULL, NULL, 235434),
(287560, '1xdzA00', NULL, NULL, 240, NULL, NULL, 235434),
(287561, '4qtuB00', NULL, NULL, 208, NULL, NULL, 235434),
(287562, '3ua4A02', NULL, NULL, 151, NULL, NULL, 235434),
(287563, '2okcA02', NULL, NULL, 318, NULL, NULL, 235434),
(287564, '5epeA00', NULL, NULL, 248, NULL, NULL, 235434),
(287565, '2b9eA02', NULL, NULL, 223, NULL, NULL, 235434),
(287566, '3cc8A00', NULL, NULL, 211, NULL, NULL, 235434),
(287567, '2nxcA03', NULL, NULL, 153, NULL, NULL, 235434),
(287568, '2xvmA00', NULL, NULL, 199, NULL, NULL, 235434),
(287569, '4ymhD00', NULL, NULL, 240, NULL, NULL, 235434),
(287570, '4kdrA00', NULL, NULL, 223, NULL, NULL, 235434);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(287571, '5fa8A00', NULL, NULL, 161, NULL, NULL, 235434),
(287572, '2as0A03', NULL, NULL, 218, NULL, NULL, 235434),
(287573, '3tr6A00', NULL, NULL, 225, NULL, NULL, 235434),
(287574, '3trkA02', NULL, NULL, 186, NULL, NULL, 235434),
(287575, '5gutA02', NULL, NULL, 297, NULL, NULL, 235434),
(287576, '3lccA00', NULL, NULL, 235, NULL, NULL, 235434),
(287577, '4g56A02', NULL, NULL, 167, NULL, NULL, 235434),
(287578, '1dl5A01', NULL, NULL, 201, NULL, NULL, 235434),
(287579, '3cvoA00', NULL, NULL, 202, NULL, NULL, 235434),
(287580, '1dusA00', NULL, NULL, 194, NULL, NULL, 235434),
(287581, '5dm2A00', NULL, NULL, 265, NULL, NULL, 235434),
(287582, '1l3iA00', NULL, NULL, 192, NULL, NULL, 235434),
(287583, '3bwyA00', NULL, NULL, 214, NULL, NULL, 235434),
(287584, '3axsA01', NULL, NULL, 322, NULL, NULL, 235434),
(287585, '3o4fH02', NULL, NULL, 234, NULL, NULL, 235434),
(287586, '3b5iB01', NULL, NULL, 254, NULL, NULL, 235434),
(287587, '2e5wB02', NULL, NULL, 224, NULL, NULL, 235434),
(287588, '5ehiA00', NULL, NULL, 276, NULL, NULL, 235434),
(287589, '5xncA02', NULL, NULL, 232, NULL, NULL, 235434),
(287590, '3evzA01', NULL, NULL, 191, NULL, NULL, 235434),
(287591, '3t0iA00', NULL, NULL, 245, NULL, NULL, 235434),
(287592, '3e7pA00', NULL, NULL, 270, NULL, NULL, 235434),
(287593, '2zigA00', NULL, NULL, 277, NULL, NULL, 235434),
(287594, '3jwgA00', NULL, NULL, 219, NULL, NULL, 235434),
(287595, '1eg2A00', NULL, NULL, 284, NULL, NULL, 235434),
(287596, '5yacA03', NULL, NULL, 186, NULL, NULL, 235434),
(287597, '1qamA01', NULL, NULL, 166, NULL, NULL, 235434),
(287598, '4necC01', NULL, NULL, 226, NULL, NULL, 235434),
(287599, '3bxoA01', NULL, NULL, 180, NULL, NULL, 235434),
(287600, '3ua3A02', NULL, NULL, 201, NULL, NULL, 235434),
(287601, '3h2bB00', NULL, NULL, 203, NULL, NULL, 235434),
(287602, '1wznA01', NULL, NULL, 189, NULL, NULL, 235434),
(287603, '2ozvA01', NULL, NULL, 219, NULL, NULL, 235434),
(287604, '4m37A01', NULL, NULL, 145, NULL, NULL, 235434),
(287605, '1wxxA03', NULL, NULL, 211, NULL, NULL, 235434),
(287606, '2pxxA00', NULL, NULL, 215, NULL, NULL, 235434),
(287607, '5p9vA00', NULL, NULL, 221, NULL, NULL, 235434),
(287608, '2p41A00', NULL, NULL, 273, NULL, NULL, 235434),
(287609, '4gc5A01', NULL, NULL, 238, NULL, NULL, 235434),
(287610, '3p9cA02', NULL, NULL, 248, NULL, NULL, 235434),
(287611, '3q7eA01', NULL, NULL, 135, NULL, NULL, 235434),
(287612, '2wk1A00', NULL, NULL, 249, NULL, NULL, 235434),
(287613, '6c8rB02', NULL, NULL, 223, NULL, NULL, 235434),
(287614, '3id6C02', NULL, NULL, 178, NULL, NULL, 235434),
(287615, '2xyqA00', NULL, NULL, 290, NULL, NULL, 235434),
(287616, '3lstA02', NULL, NULL, 247, NULL, NULL, 235434),
(287617, '1sqgA04', NULL, NULL, 199, NULL, NULL, 235434),
(287618, '1jsxA00', NULL, NULL, 207, NULL, NULL, 235434),
(287619, '5hfjC00', NULL, NULL, 232, NULL, NULL, 235434),
(287620, '1r74B02', NULL, NULL, 190, NULL, NULL, 235434),
(287621, '3k0bA02', NULL, NULL, 191, NULL, NULL, 235434),
(287622, '1iy9A01', NULL, NULL, 184, NULL, NULL, 235434),
(287623, '4fsdA01', NULL, NULL, 236, NULL, NULL, 235434),
(287624, '3g5lB00', NULL, NULL, 226, NULL, NULL, 235434),
(287625, '6q56A01', NULL, NULL, 166, NULL, NULL, 235434),
(287626, '3hnrA00', NULL, NULL, 197, NULL, NULL, 235434),
(287627, '6c5bA02', NULL, NULL, 249, NULL, NULL, 235434),
(287628, '3ajdA02', NULL, NULL, 206, NULL, NULL, 235434),
(287629, '3dliA00', NULL, NULL, 240, NULL, NULL, 235434),
(287630, '3kr9A01', NULL, NULL, 161, NULL, NULL, 235434),
(287631, '1nkvB00', NULL, NULL, 256, NULL, NULL, 235434),
(287632, '4obxA00', NULL, NULL, 235, NULL, NULL, 235434),
(287633, '3g89B00', NULL, NULL, 249, NULL, NULL, 235434),
(287634, '3p2eA00', NULL, NULL, 225, NULL, NULL, 235434),
(287635, '3i53A03', NULL, NULL, 162, NULL, NULL, 235434),
(287636, '6qmmA02', NULL, NULL, 223, NULL, NULL, 235434),
(287637, '3e23A00', NULL, NULL, 211, NULL, NULL, 235434),
(287638, '1r18A00', NULL, NULL, 227, NULL, NULL, 235434),
(287639, '1uirA02', NULL, NULL, 256, NULL, NULL, 235434),
(287640, '5c1iA00', NULL, NULL, 251, NULL, NULL, 235434),
(287641, '3ll7A02', NULL, NULL, 196, NULL, NULL, 235434);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(287642, '1booA00', NULL, NULL, 285, NULL, NULL, 235434),
(287643, '1wg8A01', NULL, NULL, 184, NULL, NULL, 235434),
(287644, '4m7rA00', NULL, NULL, 196, NULL, NULL, 235434),
(287645, '6ifwA01', NULL, NULL, 197, NULL, NULL, 235434),
(287646, '3a27A00', NULL, NULL, 246, NULL, NULL, 235434),
(287647, '5gm2K01', NULL, NULL, 246, NULL, NULL, 235434),
(287648, '4lg1B00', NULL, NULL, 224, NULL, NULL, 235434),
(287649, '2uyoA00', NULL, NULL, 310, NULL, NULL, 235434),
(287650, '1ej6A04', NULL, NULL, 230, NULL, NULL, 235434),
(287651, '1m6yA01', NULL, NULL, 187, NULL, NULL, 235434),
(287652, '4e70B02', NULL, NULL, 261, NULL, NULL, 235434),
(287653, '4pwyA00', NULL, NULL, 264, NULL, NULL, 235434),
(287654, '1vlmA00', NULL, NULL, 219, NULL, NULL, 235434),
(287655, '1i9gA02', NULL, NULL, 197, NULL, NULL, 235434),
(287656, '2g1pB01', NULL, NULL, 178, NULL, NULL, 235434),
(287657, '5h02A02', NULL, NULL, 178, NULL, NULL, 235434),
(287658, '1inlD01', NULL, NULL, 229, NULL, NULL, 235434),
(287659, '2i6gA00', NULL, NULL, 199, NULL, NULL, 235434),
(287660, '4fzvA02', NULL, NULL, 226, NULL, NULL, 235434),
(287661, '2avnA00', NULL, NULL, 260, NULL, NULL, 235434),
(287662, '2f8lA02', NULL, NULL, 245, NULL, NULL, 235434),
(287663, '5hoqC00', NULL, NULL, 257, NULL, NULL, 235434),
(287664, '4iv8A00', NULL, NULL, 245, NULL, NULL, 235434),
(287665, '3i9fB00', NULL, NULL, 170, NULL, NULL, 235434),
(287666, '6clwB03', NULL, NULL, 168, NULL, NULL, 235434),
(287667, '2h00B00', NULL, NULL, 254, NULL, NULL, 235434),
(287668, '4mtlA00', NULL, NULL, 208, NULL, NULL, 235434),
(287669, '1mjfB02', NULL, NULL, 226, NULL, NULL, 235434),
(287670, '5xohA02', NULL, NULL, 249, NULL, NULL, 235434),
(287671, '3bgvD00', NULL, NULL, 280, NULL, NULL, 235434),
(287672, '2bm8B02', NULL, NULL, 172, NULL, NULL, 235434),
(287673, '2fcaA00', NULL, NULL, 213, NULL, NULL, 235434),
(287674, '3gwzA02', NULL, NULL, 250, NULL, NULL, 235434),
(287675, '2frxB01', NULL, NULL, 310, NULL, NULL, 235434),
(287676, '2dpmA01', NULL, NULL, 181, NULL, NULL, 235434),
(287677, '3k6rA02', NULL, NULL, 192, NULL, NULL, 235434),
(287678, '1l1eB00', NULL, NULL, 287, NULL, NULL, 235434),
(287679, '3lecA01', NULL, NULL, 167, NULL, NULL, 235434),
(287680, '2pgxA02', NULL, NULL, 202, NULL, NULL, 235434),
(287681, '4p7fA00', NULL, NULL, 222, NULL, NULL, 235434),
(287682, '3dtnA01', NULL, NULL, 197, NULL, NULL, 235434),
(287683, '2cmgA02', NULL, NULL, 211, NULL, NULL, 235434),
(287684, '2yxlA04', NULL, NULL, 207, NULL, NULL, 235434),
(287685, '5eqjB02', NULL, NULL, 243, NULL, NULL, 235434),
(287686, '2qrvA01', NULL, NULL, 208, NULL, NULL, 235434),
(287687, '4qdjA00', NULL, NULL, 238, NULL, NULL, 235434),
(287688, '2i6gB00', NULL, NULL, 199, NULL, NULL, 235434),
(287689, '2h1rB01', NULL, NULL, 178, NULL, NULL, 235434),
(287690, '3mczA02', NULL, NULL, 247, NULL, NULL, 235434),
(287691, '3dh0B00', NULL, NULL, 193, NULL, NULL, 235434),
(287692, '1nv8A02', NULL, NULL, 197, NULL, NULL, 235434),
(287693, '2p35A01', NULL, NULL, 181, NULL, NULL, 235434),
(287694, '5ciyA01', NULL, NULL, 229, NULL, NULL, 235434),
(287695, '3ccfA00', NULL, NULL, 239, NULL, NULL, 235434),
(287696, '2o57D00', NULL, NULL, 268, NULL, NULL, 235434),
(287697, '3njrA00', NULL, NULL, 184, NULL, NULL, 235434),
(287698, '3ihtA00', NULL, NULL, 174, NULL, NULL, 235434),
(287699, '2r3sA03', NULL, NULL, 214, NULL, NULL, 235434),
(287700, '2qy6A01', NULL, NULL, 247, NULL, NULL, 235434),
(287701, '5ih3B01', NULL, NULL, 162, NULL, NULL, 235434),
(287702, '3eldA01', NULL, NULL, 266, NULL, NULL, 235434),
(287703, '6i6mA02', NULL, NULL, 250, NULL, NULL, 235434),
(287704, '4f85A00', NULL, NULL, 246, NULL, NULL, 235434),
(287705, '3merA00', NULL, NULL, 202, NULL, NULL, 235434),
(287706, '5cvvA02', NULL, NULL, 250, NULL, NULL, 235434),
(287707, '4pioB01', NULL, NULL, 189, NULL, NULL, 235434),
(287708, '1yb2A00', NULL, NULL, 250, NULL, NULL, 235434),
(287709, '3eeyA00', NULL, NULL, 197, NULL, NULL, 235434),
(287710, '6aw4A00', NULL, NULL, 228, NULL, NULL, 235434),
(287711, '3ggdA00', NULL, NULL, 245, NULL, NULL, 235434),
(287712, '3busB00', NULL, NULL, 248, NULL, NULL, 235434);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(287713, '2ip2A02', NULL, NULL, 246, NULL, NULL, 235434),
(287714, '5kvaA00', NULL, NULL, 227, NULL, NULL, 235434),
(287715, '1pjzA00', NULL, NULL, 203, NULL, NULL, 235434),
(287716, '2p8jA00', NULL, NULL, 209, NULL, NULL, 235434),
(287717, '2zwaA01', NULL, NULL, 364, NULL, NULL, 235434),
(287718, '3gnlA01', NULL, NULL, 169, NULL, NULL, 235434),
(287719, '5fcdA00', NULL, NULL, 239, NULL, NULL, 235434),
(287720, '2i62A00', NULL, NULL, 265, NULL, NULL, 235434),
(287721, '3mtiB00', NULL, NULL, 185, NULL, NULL, 235434),
(287722, '2o57A02', NULL, NULL, 165, NULL, NULL, 235434),
(287723, '2b2cA02', NULL, NULL, 225, NULL, NULL, 235434),
(287724, '2a14A00', NULL, NULL, 263, NULL, NULL, 235434),
(287725, '3ntvA00', NULL, NULL, 211, NULL, NULL, 235434),
(287726, '3lcvB02', NULL, NULL, 210, NULL, NULL, 235434),
(287727, '4azsA01', NULL, NULL, 219, NULL, NULL, 235434),
(287728, '4jxjA01', NULL, NULL, 181, NULL, NULL, 235434),
(287729, '2avdA00', NULL, NULL, 229, NULL, NULL, 235434),
(287730, '1tpyA00', NULL, NULL, 287, NULL, NULL, 235434),
(287731, '1g8aA02', NULL, NULL, 176, NULL, NULL, 235434),
(287732, '1f3lA01', NULL, NULL, 143, NULL, NULL, 235434),
(287733, '5fwaA01', NULL, NULL, 148, NULL, NULL, 235434),
(287734, '4ponA00', NULL, NULL, 200, NULL, NULL, 235434),
(287735, '4df3A02', NULL, NULL, 178, NULL, NULL, 235434),
(287736, '4a6dA02', NULL, NULL, 259, NULL, NULL, 235434),
(287737, '4lwoE01', NULL, NULL, 160, NULL, NULL, 235434),
(287738, '3evgA00', NULL, NULL, 275, NULL, NULL, 235434),
(287739, '3x0dA03', NULL, NULL, 134, NULL, NULL, 235434),
(287740, '2p7iA00', NULL, NULL, 228, NULL, NULL, 235434),
(287741, '3e05B00', NULL, NULL, 204, NULL, NULL, 235434),
(287742, '3x0dA01', NULL, NULL, 151, NULL, NULL, 235434),
(287743, '1v39A00', NULL, NULL, 322, NULL, NULL, 235434),
(287744, '1p91B00', NULL, NULL, 269, NULL, NULL, 235434),
(287745, '2hnkA00', NULL, NULL, 239, NULL, NULL, 235434),
(287746, '3futA01', NULL, NULL, 203, NULL, NULL, 235434),
(287747, '2fk8A00', NULL, NULL, 281, NULL, NULL, 235434),
(287748, '5dstC01', NULL, NULL, 154, NULL, NULL, 235434),
(287749, '1fp1D02', NULL, NULL, 249, NULL, NULL, 235434),
(287750, '2yuiA00', NULL, NULL, 182, NULL, NULL, 235434),
(287751, '2pbfA00', NULL, NULL, 227, NULL, NULL, 235434),
(287752, '4htfA00', NULL, NULL, 254, NULL, NULL, 235434),
(287753, '1g60B00', NULL, NULL, 260, NULL, NULL, 235434),
(287754, '3gruA01', NULL, NULL, 177, NULL, NULL, 235434),
(287755, '2gpyB00', NULL, NULL, 233, NULL, NULL, 235434),
(287756, '4dmgA03', NULL, NULL, 219, NULL, NULL, 235434),
(287757, '1wy7D00', NULL, NULL, 207, NULL, NULL, 235434),
(287758, '2dulA01', NULL, NULL, 318, NULL, NULL, 235434),
(287759, '2plwA00', NULL, NULL, 201, NULL, NULL, 235434),
(287760, '5ybbA02', NULL, NULL, 365, NULL, NULL, 235434),
(287761, '3ssmC02', NULL, NULL, 223, NULL, NULL, 235434),
(287762, '2ar0A02', NULL, NULL, 326, NULL, NULL, 235434),
(287763, '1pryA02', NULL, NULL, 176, NULL, NULL, 235434),
(287764, '2fhpA00', NULL, NULL, 187, NULL, NULL, 235434),
(287765, '2pwyA02', NULL, NULL, 178, NULL, NULL, 235434),
(287766, '4hg2B01', NULL, NULL, 170, NULL, NULL, 235434),
(287767, '4z2yA02', NULL, NULL, 228, NULL, NULL, 235434),
(287768, '3g2mA02', NULL, NULL, 172, NULL, NULL, 235434),
(287769, '3duwA00', NULL, NULL, 223, NULL, NULL, 235434),
(287770, '3thrA02', NULL, NULL, 188, NULL, NULL, 235434),
(287771, '3m6uB02', NULL, NULL, 303, NULL, NULL, 235434),
(287772, '1zg3A02', NULL, NULL, 253, NULL, NULL, 235434),
(287773, '3tkaA01', NULL, NULL, 203, NULL, NULL, 235434),
(287774, '1zkdA02', NULL, NULL, 172, NULL, NULL, 235434),
(287775, '3v97A02', NULL, NULL, 179, NULL, NULL, 235434),
(287776, '3ofkA00', NULL, NULL, 216, NULL, NULL, 235434),
(287777, '1m6eX02', NULL, NULL, 214, NULL, NULL, 235434),
(287778, '2eg5A02', NULL, NULL, 230, NULL, NULL, 235434),
(287779, '1o54A02', NULL, NULL, 196, NULL, NULL, 235434),
(287780, '2vdwG00', NULL, NULL, 302, NULL, NULL, 235434),
(287781, '5ynmA00', NULL, NULL, 303, NULL, NULL, 235434),
(287782, '4yuyB02', NULL, NULL, 228, NULL, NULL, 235434),
(287783, '4ft4A02', NULL, NULL, 416, NULL, NULL, 235434);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(287784, '1yzhB00', NULL, NULL, 214, NULL, NULL, 235434),
(287785, '2o07A02', NULL, NULL, 228, NULL, NULL, 235434),
(287786, '5n5dB00', NULL, NULL, 226, NULL, NULL, 235434),
(287787, '1xxlA00', NULL, NULL, 239, NULL, NULL, 235434),
(287788, '3lkdA02', NULL, NULL, 282, NULL, NULL, 235434),
(287789, '1vl5C00', NULL, NULL, 238, NULL, NULL, 235434),
(287790, '1ej0A00', NULL, NULL, 180, NULL, NULL, 235434),
(287791, '3mggB01', NULL, NULL, 170, NULL, NULL, 235434),
(287792, '2efjA02', NULL, NULL, 229, NULL, NULL, 235434),
(287793, '3frhA02', NULL, NULL, 195, NULL, NULL, 235434),
(287794, '3lduA02', NULL, NULL, 157, NULL, NULL, 235434),
(287795, '1suiA00', NULL, NULL, 227, NULL, NULL, 235434),
(287796, '2vdvE01', NULL, NULL, 204, NULL, NULL, 235434),
(287797, '3htxD03', NULL, NULL, 250, NULL, NULL, 235434),
(287798, '3o7wA00', NULL, NULL, 294, NULL, NULL, 235434),
(287799, '2yvlA02', NULL, NULL, 189, NULL, NULL, 235434),
(287800, '4rv9A02', NULL, NULL, 201, NULL, NULL, 235434),
(287801, '2jhpA02', NULL, NULL, 296, NULL, NULL, 235434),
(287802, '1g8sA02', NULL, NULL, 178, NULL, NULL, 235434),
(287803, '4dzrA00', NULL, NULL, 215, NULL, NULL, 235434),
(287804, '5evjA01', NULL, NULL, 235, NULL, NULL, 235434),
(287805, '3ujcA00', NULL, NULL, 266, NULL, NULL, 235434),
(287806, '2k4mA00', NULL, NULL, 153, NULL, NULL, 235434),
(287807, '1fpqA01', NULL, NULL, 201, NULL, NULL, 235434),
(287808, '4qpnA00', NULL, NULL, 203, NULL, NULL, 235434),
(287809, '4qvgA02', NULL, NULL, 198, NULL, NULL, 235434),
(287810, '3v97B04', NULL, NULL, 220, NULL, NULL, 235434),
(287811, '1i4wA01', NULL, NULL, 262, NULL, NULL, 235434),
(287812, '2yxdA00', NULL, NULL, 183, NULL, NULL, 235434),
(287813, '6aieA00', NULL, NULL, 189, NULL, NULL, 235434),
(287814, '3gczA00', NULL, NULL, 259, NULL, NULL, 235434),
(287815, '3q87B00', NULL, NULL, 170, NULL, NULL, 235434),
(287816, '2pkwA02', NULL, NULL, 204, NULL, NULL, 235434),
(287817, '3r3hA00', NULL, NULL, 220, NULL, NULL, 235434),
(287818, '3lpmA01', NULL, NULL, 248, NULL, NULL, 235434),
(287819, '3uwpA02', NULL, NULL, 220, NULL, NULL, 235434),
(287820, '3cbgA00', NULL, NULL, 232, NULL, NULL, 235434),
(287821, '3qv2A01', NULL, NULL, 207, NULL, NULL, 235434),
(287822, '1x19A02', NULL, NULL, 160, NULL, NULL, 235434),
(287823, '3bkxA00', NULL, NULL, 275, NULL, NULL, 235434),
(287824, '2r6zB02', NULL, NULL, 203, NULL, NULL, 235434),
(287825, '2esrA00', NULL, NULL, 160, NULL, NULL, 235434),
(287826, '4o29A00', NULL, NULL, 208, NULL, NULL, 235434),
(287827, '3vywA02', NULL, NULL, 238, NULL, NULL, 235434),
(287828, '3egvA02', NULL, NULL, 192, NULL, NULL, 235434),
(287829, '3lkzA00', NULL, NULL, 262, NULL, NULL, 235434),
(287830, '2b25A02', NULL, NULL, 194, NULL, NULL, 235434),
(287831, '1g6q101', NULL, NULL, 143, NULL, NULL, 235434),
(287832, '3opnA00', NULL, NULL, 232, NULL, NULL, 235434),
(287833, '3m33A00', NULL, NULL, 226, NULL, NULL, 235434),
(287834, '5lhmA00', NULL, NULL, 233, NULL, NULL, 235434),
(287835, '3tpzA01', NULL, NULL, 200, NULL, NULL, 235434),
(287836, '2vz9A05', NULL, NULL, 297, NULL, NULL, 235434),
(287837, '5kqrA00', NULL, NULL, 268, NULL, NULL, 235434),
(287838, '3orhD00', NULL, NULL, 219, NULL, NULL, 235434),
(287839, '3gjyA00', NULL, NULL, 278, NULL, NULL, 235434),
(287840, '4gqbA02', NULL, NULL, 167, NULL, NULL, 235434),
(287841, '3bzbB00', NULL, NULL, 237, NULL, NULL, 235434),
(287842, '3dlcA00', NULL, NULL, 219, NULL, NULL, 235434),
(287843, '5dlyA00', NULL, NULL, 266, NULL, NULL, 235434),
(287844, '2nyuB00', NULL, NULL, 196, NULL, NULL, 235434),
(287845, '2qe6A00', NULL, NULL, 274, NULL, NULL, 235434),
(287846, '4dcmA01', NULL, NULL, 176, NULL, NULL, 235434),
(287847, '4dcmA02', NULL, NULL, 199, NULL, NULL, 235434),
(287848, '2iftA00', NULL, NULL, 201, NULL, NULL, 235434),
(287849, '3d2lC01', NULL, NULL, 180, NULL, NULL, 235434),
(287850, '1fp2A02', NULL, NULL, 249, NULL, NULL, 235434),
(287851, '1ri5A00', NULL, NULL, 258, NULL, NULL, 235434),
(287852, '1qzzA03', NULL, NULL, 169, NULL, NULL, 235434),
(287853, '4pneA00', NULL, NULL, 280, NULL, NULL, 235434),
(287854, '2yxeB00', NULL, NULL, 215, NULL, NULL, 235434);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(287855, '2zfuA02', NULL, NULL, 163, NULL, NULL, 235434),
(287856, '4e2xA02', NULL, NULL, 202, NULL, NULL, 235434),
(287857, '3gdhA00', NULL, NULL, 220, NULL, NULL, 235434),
(287858, '5eovA00', NULL, NULL, 220, NULL, NULL, 235434),
(287859, '6dcbA00', NULL, NULL, 226, NULL, NULL, 235434),
(287860, '4kdcA00', NULL, NULL, 225, NULL, NULL, 235434),
(287861, '2px2B00', NULL, NULL, 269, NULL, NULL, 235434),
(287862, '4h0nA01', NULL, NULL, 199, NULL, NULL, 235434),
(287863, '1yubA01', NULL, NULL, 165, NULL, NULL, 235434),
(287864, '1ws6A00', NULL, NULL, 171, NULL, NULL, 235434),
(287865, '3dr5A00', NULL, NULL, 221, NULL, NULL, 235434),
(287866, '4aukA03', NULL, NULL, 182, NULL, NULL, 235434),
(287867, '4k6mA01', NULL, NULL, 269, NULL, NULL, 235434),
(287868, '3fzgA00', NULL, NULL, 200, NULL, NULL, 235434),
(287869, '3c6kB03', NULL, NULL, 194, NULL, NULL, 235434),
(287870, '4c08A01', NULL, NULL, 141, NULL, NULL, 235434),
(287871, '2igtA01', NULL, NULL, 264, NULL, NULL, 235434),
(287872, '3fpfA00', NULL, NULL, 265, NULL, NULL, 235434),
(287873, '5ikmA00', NULL, NULL, 269, NULL, NULL, 235434),
(287874, '3mb5A02', NULL, NULL, 193, NULL, NULL, 235434),
(287875, '3pfgA01', NULL, NULL, 204, NULL, NULL, 235434),
(287876, '2gs9A01', NULL, NULL, 202, NULL, NULL, 235434),
(287877, '1jqeA00', NULL, NULL, 292, NULL, NULL, 235434),
(287878, '3hemA00', NULL, NULL, 302, NULL, NULL, 235434),
(287879, '4iv0B00', NULL, NULL, 260, NULL, NULL, 235434),
(287880, '3ocjA00', NULL, NULL, 305, NULL, NULL, 235434),
(287881, '3uzuA01', NULL, NULL, 193, NULL, NULL, 235434),
(287882, '3lbfA00', NULL, NULL, 210, NULL, NULL, 235434),
(287883, '3p5jB01', NULL, NULL, 80, NULL, NULL, 235435),
(287884, '4fqeA00', NULL, NULL, 222, NULL, NULL, 235436),
(287885, '2f1cX00', NULL, NULL, 286, NULL, NULL, 235436),
(287886, '2wjrA00', NULL, NULL, 214, NULL, NULL, 235436),
(287887, '3gtyS00', NULL, NULL, 149, NULL, NULL, 235437),
(287888, '1rssA00', NULL, NULL, 151, NULL, NULL, 235437),
(287889, '1husA00', NULL, NULL, 155, NULL, NULL, 235437),
(287890, '6az1H00', NULL, NULL, 190, NULL, NULL, 235437),
(287891, '5optO00', NULL, NULL, 190, NULL, NULL, 235437),
(287892, '5xxuF00', NULL, NULL, 192, NULL, NULL, 235437),
(287893, '6faiF00', NULL, NULL, 206, NULL, NULL, 235437),
(287894, '2xzmG00', NULL, NULL, 200, NULL, NULL, 235437),
(287895, '1iqvA00', NULL, NULL, 201, NULL, NULL, 235437),
(287896, '3jamF00', NULL, NULL, 206, NULL, NULL, 235437),
(287897, '6g5iF00', NULL, NULL, 204, NULL, NULL, 235437),
(287898, '5mmjg00', NULL, NULL, 155, NULL, NULL, 235437),
(287899, '5xyiF00', NULL, NULL, 193, NULL, NULL, 235437),
(287900, '3j7aI00', NULL, NULL, 195, NULL, NULL, 235437),
(287901, '2vhpG00', NULL, NULL, 154, NULL, NULL, 235437),
(287902, '2r44A03', NULL, NULL, 118, NULL, NULL, 235438),
(287903, '1e9rA02', NULL, NULL, 113, NULL, NULL, 235438),
(287904, '1g8pA02', NULL, NULL, 90, NULL, NULL, 235438),
(287905, '3onqA03', NULL, NULL, 131, NULL, NULL, 235439),
(287906, '3h0gA03', NULL, NULL, 63, NULL, NULL, 235440),
(287907, '1twfA04', NULL, NULL, 63, NULL, NULL, 235440),
(287908, '4c2mA04', NULL, NULL, 77, NULL, NULL, 235440),
(287909, '5fj8A04', NULL, NULL, 62, NULL, NULL, 235440),
(287910, '4aybA03', NULL, NULL, 66, NULL, NULL, 235440),
(287911, '4qiwA03', NULL, NULL, 62, NULL, NULL, 235440),
(287912, '2kouA00', NULL, NULL, 102, NULL, NULL, 235441),
(287913, '1khbA01', NULL, NULL, 235, NULL, NULL, 235442),
(287914, '1ytmA01', NULL, NULL, 203, NULL, NULL, 235442),
(287915, '1ylhA01', NULL, NULL, 199, NULL, NULL, 235442),
(287916, '1j3bB01', NULL, NULL, 190, NULL, NULL, 235442),
(287917, '2fafA01', NULL, NULL, 218, NULL, NULL, 235442),
(287918, '6at4A01', NULL, NULL, 202, NULL, NULL, 235442),
(287919, '4gmuA01', NULL, NULL, 226, NULL, NULL, 235442),
(287920, '2zciA01', NULL, NULL, 220, NULL, NULL, 235442),
(287921, '1ii2B01', NULL, NULL, 178, NULL, NULL, 235442),
(287922, '4wptA01', NULL, NULL, 215, NULL, NULL, 235442),
(287923, '3zqeB00', NULL, NULL, 265, NULL, NULL, 235443),
(287924, '4d3eD00', NULL, NULL, 208, NULL, NULL, 235443),
(287925, '3r9vA00', NULL, NULL, 201, NULL, NULL, 235443);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(287926, '3nzzB00', NULL, NULL, 308, NULL, NULL, 235443),
(287927, '5vxmA00', NULL, NULL, 289, NULL, NULL, 235443),
(287928, '2ym9C00', NULL, NULL, 216, NULL, NULL, 235443),
(287929, '2p7nA00', NULL, NULL, 361, NULL, NULL, 235443),
(287930, '3nftA00', NULL, NULL, 277, NULL, NULL, 235443),
(287931, '2ym9D00', NULL, NULL, 143, NULL, NULL, 235443),
(287932, '3nrxA00', NULL, NULL, 130, NULL, NULL, 235444),
(287933, '3da5A00', NULL, NULL, 128, NULL, NULL, 235445),
(287934, '1u04A02', NULL, NULL, 117, NULL, NULL, 235445),
(287935, '2rsxA00', NULL, NULL, 159, NULL, NULL, 235446),
(287936, '1vl4A01', NULL, NULL, 222, NULL, NULL, 235447),
(287937, '3qtdA01', NULL, NULL, 235, NULL, NULL, 235447),
(287938, '5nj9D01', NULL, NULL, 236, NULL, NULL, 235447),
(287939, '1vpbA01', NULL, NULL, 239, NULL, NULL, 235447),
(287940, '2i46A00', NULL, NULL, 161, NULL, NULL, 235448),
(287941, '2m9vA00', NULL, NULL, 170, NULL, NULL, 235448),
(287942, '2wb7A03', NULL, NULL, 137, NULL, NULL, 235449),
(287943, '3txvA02', NULL, NULL, 137, NULL, NULL, 235450),
(287944, '2fiqA02', NULL, NULL, 124, NULL, NULL, 235450),
(287945, '4n7wA00', NULL, NULL, 307, NULL, NULL, 235451),
(287946, '3zuxA00', NULL, NULL, 314, NULL, NULL, 235451),
(287947, '5bz3A00', NULL, NULL, 385, NULL, NULL, 235451),
(287948, '2cgeA03', NULL, NULL, 153, NULL, NULL, 235452),
(287949, '1sf8G00', NULL, NULL, 126, NULL, NULL, 235452),
(287950, '4ipeB04', NULL, NULL, 140, NULL, NULL, 235452),
(287951, '5ulsA04', NULL, NULL, 150, NULL, NULL, 235452),
(287952, '2ioqA04', NULL, NULL, 134, NULL, NULL, 235452),
(287953, '3q6nC03', NULL, NULL, 151, NULL, NULL, 235452),
(287954, '3hjcA03', NULL, NULL, 152, NULL, NULL, 235452),
(287955, '2cw9A00', NULL, NULL, 194, NULL, NULL, 235453),
(287956, '3j7yd00', NULL, NULL, 171, NULL, NULL, 235453),
(287957, '3qk9B00', NULL, NULL, 197, NULL, NULL, 235453),
(287958, '4a2nB00', NULL, NULL, 194, NULL, NULL, 235454),
(287959, '3tixB01', NULL, NULL, 160, NULL, NULL, 235455),
(287960, '4m8aA00', NULL, NULL, 72, NULL, NULL, 235456),
(287961, '4v0bA00', NULL, NULL, 82, NULL, NULL, 235456),
(287962, '4c5wA01', NULL, NULL, 97, NULL, NULL, 235457),
(287963, '3luuA00', NULL, NULL, 101, NULL, NULL, 235457),
(287964, '3zheB02', NULL, NULL, 186, NULL, NULL, 235458),
(287965, '2vxgA01', NULL, NULL, 46, NULL, NULL, 235459),
(287966, '3dteA02', NULL, NULL, 41, NULL, NULL, 235460),
(287967, '2fywC01', NULL, NULL, 130, NULL, NULL, 235461),
(287968, '2fywA02', NULL, NULL, 125, NULL, NULL, 235461),
(287969, '1nmpA01', NULL, NULL, 119, NULL, NULL, 235461),
(287970, '2yybA01', NULL, NULL, 119, NULL, NULL, 235461),
(287971, '2yybA02', NULL, NULL, 117, NULL, NULL, 235461),
(287972, '1nmoA02', NULL, NULL, 122, NULL, NULL, 235461),
(287973, '3wsfA02', NULL, NULL, 117, NULL, NULL, 235461),
(287974, '3wsfB01', NULL, NULL, 131, NULL, NULL, 235461),
(287975, '4e6fA00', NULL, NULL, 181, NULL, NULL, 235462),
(287976, '4jhyA00', NULL, NULL, 167, NULL, NULL, 235462),
(287977, '3cirA02', NULL, NULL, 85, NULL, NULL, 235463),
(287978, '1d4dA03', NULL, NULL, 145, NULL, NULL, 235463),
(287979, '1qo8A01', NULL, NULL, 138, NULL, NULL, 235463),
(287980, '2lfcA00', NULL, NULL, 160, NULL, NULL, 235463),
(287981, '1kf6A02', NULL, NULL, 116, NULL, NULL, 235463),
(287982, '2bs2A02', NULL, NULL, 107, NULL, NULL, 235463),
(287983, '4c3xB02', NULL, NULL, 146, NULL, NULL, 235463),
(287984, '2wdqA02', NULL, NULL, 105, NULL, NULL, 235463),
(287985, '3gyxA02', NULL, NULL, 131, NULL, NULL, 235463),
(287986, '2h88A02', NULL, NULL, 104, NULL, NULL, 235463),
(287987, '4ysxA02', NULL, NULL, 104, NULL, NULL, 235463),
(287988, '1jnrA02', NULL, NULL, 132, NULL, NULL, 235463),
(287989, '1chuA02', NULL, NULL, 104, NULL, NULL, 235463),
(287990, '5kxjA02', NULL, NULL, 104, NULL, NULL, 235463),
(287991, '1y0pA03', NULL, NULL, 138, NULL, NULL, 235463),
(287992, '4at0A02', NULL, NULL, 127, NULL, NULL, 235463),
(287993, '2e5vA02', NULL, NULL, 96, NULL, NULL, 235463),
(287994, '2mn5A00', NULL, NULL, 57, NULL, NULL, 235464),
(287995, '1gk9B03', NULL, NULL, 161, NULL, NULL, 235465),
(287996, '3k3wB03', NULL, NULL, 159, NULL, NULL, 235465);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(287997, '4pemB03', NULL, NULL, 161, NULL, NULL, 235465),
(287998, '4wksC03', NULL, NULL, 182, NULL, NULL, 235465),
(287999, '4hstB03', NULL, NULL, 129, NULL, NULL, 235465),
(288000, '4yfbC03', NULL, NULL, 194, NULL, NULL, 235465),
(288001, '1cp9B03', NULL, NULL, 161, NULL, NULL, 235465),
(288002, '1fm2B02', NULL, NULL, 181, NULL, NULL, 235465),
(288003, '3c0uA00', NULL, NULL, 183, NULL, NULL, 235466),
(288004, '2g3wA00', NULL, NULL, 182, NULL, NULL, 235466),
(288005, '2ot9A01', NULL, NULL, 177, NULL, NULL, 235466),
(288006, '4kf9A01', NULL, NULL, 195, NULL, NULL, 235467),
(288007, '3ic8A01', NULL, NULL, 178, NULL, NULL, 235467),
(288008, '3zcoA00', NULL, NULL, 141, NULL, NULL, 235468),
(288009, '3a98B01', NULL, NULL, 86, NULL, NULL, 235469),
(288010, '3fotA02', NULL, NULL, 264, NULL, NULL, 235470),
(288011, '4hvmD02', NULL, NULL, 219, NULL, NULL, 235470),
(288012, '2xhgA02', NULL, NULL, 283, NULL, NULL, 235470),
(288013, '5t3eB02', NULL, NULL, 261, NULL, NULL, 235470),
(288014, '1l5aA03', NULL, NULL, 213, NULL, NULL, 235470),
(288015, '1q9jB02', NULL, NULL, 190, NULL, NULL, 235470),
(288016, '5du9B02', NULL, NULL, 221, NULL, NULL, 235470),
(288017, '2jgpA03', NULL, NULL, 233, NULL, NULL, 235470),
(288018, '2vsqA02', NULL, NULL, 239, NULL, NULL, 235470),
(288019, '1f02T00', NULL, NULL, 66, NULL, NULL, 235471),
(288020, '2zqkC00', NULL, NULL, 77, NULL, NULL, 235471),
(288021, '3nswA00', NULL, NULL, 106, NULL, NULL, 235472),
(288022, '2d2sA01', NULL, NULL, 129, NULL, NULL, 235473),
(288023, '3uepA00', NULL, NULL, 96, NULL, NULL, 235474),
(288024, '4yx1A00', NULL, NULL, 70, NULL, NULL, 235474),
(288025, '1o9yC00', NULL, NULL, 84, NULL, NULL, 235474),
(288026, '5xrwA00', NULL, NULL, 79, NULL, NULL, 235474),
(288027, '5xrwC00', NULL, NULL, 79, NULL, NULL, 235474),
(288028, '1o6aB00', NULL, NULL, 96, NULL, NULL, 235474),
(288029, '4tt9B00', NULL, NULL, 86, NULL, NULL, 235474),
(288030, '4af8A00', NULL, NULL, 345, NULL, NULL, 235475),
(288031, '3zjxB01', NULL, NULL, 86, NULL, NULL, 235476),
(288032, '1yr2A02', NULL, NULL, 343, NULL, NULL, 235477),
(288033, '3iujA02', NULL, NULL, 337, NULL, NULL, 235477),
(288034, '2bklA02', NULL, NULL, 338, NULL, NULL, 235477),
(288035, '2xe4A02', NULL, NULL, 352, NULL, NULL, 235477),
(288036, '4bp8A02', NULL, NULL, 345, NULL, NULL, 235477),
(288037, '5o3uA02', NULL, NULL, 355, NULL, NULL, 235477),
(288038, '2xdwA02', NULL, NULL, 353, NULL, NULL, 235477),
(288039, '2q07A01', NULL, NULL, 165, NULL, NULL, 235478),
(288040, '1uj8A00', NULL, NULL, 77, NULL, NULL, 235479),
(288041, '2v6eA01', NULL, NULL, 75, NULL, NULL, 235480),
(288042, '3zxwA02', NULL, NULL, 319, NULL, NULL, 235481),
(288043, '1bxnA02', NULL, NULL, 313, NULL, NULL, 235481),
(288044, '1rblA02', NULL, NULL, 319, NULL, NULL, 235481),
(288045, '1svdA02', NULL, NULL, 331, NULL, NULL, 235481),
(288046, '5rubA02', NULL, NULL, 303, NULL, NULL, 235481),
(288047, '1ykwA02', NULL, NULL, 290, NULL, NULL, 235481),
(288048, '3kdnA02', NULL, NULL, 302, NULL, NULL, 235481),
(288049, '5oyaA02', NULL, NULL, 315, NULL, NULL, 235481),
(288050, '1wddA02', NULL, NULL, 314, NULL, NULL, 235481),
(288051, '4nasA02', NULL, NULL, 286, NULL, NULL, 235481),
(288052, '3nwrA02', NULL, NULL, 290, NULL, NULL, 235481),
(288053, '5nv3A02', NULL, NULL, 313, NULL, NULL, 235481),
(288054, '2oemB02', NULL, NULL, 293, NULL, NULL, 235481),
(288055, '2d69A02', NULL, NULL, 297, NULL, NULL, 235481),
(288056, '5macC02', NULL, NULL, 334, NULL, NULL, 235481),
(288057, '3rubL02', NULL, NULL, 318, NULL, NULL, 235481),
(288058, '5iu0A02', NULL, NULL, 314, NULL, NULL, 235481),
(288059, '5c2cA02', NULL, NULL, 303, NULL, NULL, 235481),
(288060, '5hjxA02', NULL, NULL, 303, NULL, NULL, 235481),
(288061, '3fk4A02', NULL, NULL, 293, NULL, NULL, 235481),
(288062, '3qfwB02', NULL, NULL, 266, NULL, NULL, 235481),
(288063, '2qygA02', NULL, NULL, 287, NULL, NULL, 235481),
(288064, '1gk8A02', NULL, NULL, 314, NULL, NULL, 235481),
(288065, '2zviD02', NULL, NULL, 291, NULL, NULL, 235481),
(288066, '4f0hA02', NULL, NULL, 313, NULL, NULL, 235481),
(288067, '8rucA02', NULL, NULL, 314, NULL, NULL, 235481);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(288068, '3u5iW02', NULL, NULL, 69, NULL, NULL, 235482),
(288069, '5a2qw00', NULL, NULL, 62, NULL, NULL, 235482),
(288070, '2kcpA01', NULL, NULL, 68, NULL, NULL, 235483),
(288071, '2kcoA01', NULL, NULL, 76, NULL, NULL, 235483),
(288072, '2xgjB04', NULL, NULL, 127, NULL, NULL, 235484),
(288073, '4a4kA01', NULL, NULL, 123, NULL, NULL, 235484),
(288074, '4hn7A00', NULL, NULL, 88, NULL, NULL, 235485),
(288075, '2rqxA00', NULL, NULL, 89, NULL, NULL, 235485),
(288076, '1efuB03', NULL, NULL, 74, NULL, NULL, 235486),
(288077, '1xb2B03', NULL, NULL, 110, NULL, NULL, 235486),
(288078, '1xb2B02', NULL, NULL, 121, NULL, NULL, 235486),
(288079, '1efuB02', NULL, NULL, 86, NULL, NULL, 235486),
(288080, '1tfeA01', NULL, NULL, 100, NULL, NULL, 235486),
(288081, '3lnnA01', NULL, NULL, 91, NULL, NULL, 235487),
(288082, '3ne5B01', NULL, NULL, 99, NULL, NULL, 235487),
(288083, '3oocA01', NULL, NULL, 76, NULL, NULL, 235487),
(288084, '4kkuC01', NULL, NULL, 96, NULL, NULL, 235487),
(288085, '2v4dE01', NULL, NULL, 96, NULL, NULL, 235487),
(288086, '4l8jA01', NULL, NULL, 100, NULL, NULL, 235487),
(288087, '4dk0A01', NULL, NULL, 80, NULL, NULL, 235487),
(288088, '3ajeA02', NULL, NULL, 138, NULL, NULL, 235488),
(288089, '2yv4A00', NULL, NULL, 105, NULL, NULL, 235488),
(288090, '3aj1A02', NULL, NULL, 112, NULL, NULL, 235489),
(288091, '3hbxA01', NULL, NULL, 65, NULL, NULL, 235490),
(288092, '1pmmC01', NULL, NULL, 65, NULL, NULL, 235490),
(288093, '1xeyA01', NULL, NULL, 65, NULL, NULL, 235490),
(288094, '3t69A02', NULL, NULL, 226, NULL, NULL, 235491),
(288095, '3r1xA02', NULL, NULL, 205, NULL, NULL, 235491),
(288096, '4dexB00', NULL, NULL, 52, NULL, NULL, 235492),
(288097, '3oeeP02', NULL, NULL, 211, NULL, NULL, 235493),
(288098, '5dn6G02', NULL, NULL, 222, NULL, NULL, 235493),
(288099, '1h8eG02', NULL, NULL, 206, NULL, NULL, 235493),
(288100, '3oeeY02', NULL, NULL, 148, NULL, NULL, 235493),
(288101, '5fl7G02', NULL, NULL, 205, NULL, NULL, 235493),
(288102, '4tt3G02', NULL, NULL, 144, NULL, NULL, 235493),
(288103, '2qe7G02', NULL, NULL, 130, NULL, NULL, 235493),
(288104, '1fs0G01', NULL, NULL, 130, NULL, NULL, 235493),
(288105, '1dmrA01', NULL, NULL, 219, NULL, NULL, 235494),
(288106, '1eu1A01', NULL, NULL, 219, NULL, NULL, 235494),
(288107, '1g8kA02', NULL, NULL, 253, NULL, NULL, 235494),
(288108, '3ml1A02', NULL, NULL, 267, NULL, NULL, 235494),
(288109, '2vpzA02', NULL, NULL, 171, NULL, NULL, 235494),
(288110, '1h0hA02', NULL, NULL, 239, NULL, NULL, 235494),
(288111, '1tmoA01', NULL, NULL, 222, NULL, NULL, 235494),
(288112, '1ogyA02', NULL, NULL, 267, NULL, NULL, 235494),
(288113, '2napA02', NULL, NULL, 295, NULL, NULL, 235494),
(288114, '1q16A05', NULL, NULL, 234, NULL, NULL, 235494),
(288115, '5nqdA02', NULL, NULL, 244, NULL, NULL, 235494),
(288116, '1ti2A02', NULL, NULL, 362, NULL, NULL, 235494),
(288117, '1kqfA02', NULL, NULL, 239, NULL, NULL, 235494),
(288118, '2iv2X02', NULL, NULL, 268, NULL, NULL, 235494),
(288119, '2e7zA02', NULL, NULL, 304, NULL, NULL, 235494),
(288120, '2nyaA02', NULL, NULL, 267, NULL, NULL, 235494),
(288121, '4cczA02', NULL, NULL, 303, NULL, NULL, 235495),
(288122, '5umgA00', NULL, NULL, 282, NULL, NULL, 235495),
(288123, '4nirB00', NULL, NULL, 277, NULL, NULL, 235495),
(288124, '3tyzA00', NULL, NULL, 280, NULL, NULL, 235495),
(288125, '5visB00', NULL, NULL, 275, NULL, NULL, 235495),
(288126, '4s39A01', NULL, NULL, 288, NULL, NULL, 235495),
(288127, '6dayC00', NULL, NULL, 282, NULL, NULL, 235495),
(288128, '4pzvA02', NULL, NULL, 257, NULL, NULL, 235495),
(288129, '4o1eB00', NULL, NULL, 271, NULL, NULL, 235495),
(288130, '4mwaF00', NULL, NULL, 276, NULL, NULL, 235495),
(288131, '2yciX00', NULL, NULL, 271, NULL, NULL, 235495),
(288132, '5uswA00', NULL, NULL, 281, NULL, NULL, 235495),
(288133, '2dqwA00', NULL, NULL, 294, NULL, NULL, 235495),
(288134, '4hb7A00', NULL, NULL, 270, NULL, NULL, 235495),
(288135, '1eyeA00', NULL, NULL, 280, NULL, NULL, 235495),
(288136, '3tr9D00', NULL, NULL, 293, NULL, NULL, 235495),
(288137, '2vp8B00', NULL, NULL, 290, NULL, NULL, 235495),
(288138, '2y5sA00', NULL, NULL, 294, NULL, NULL, 235495);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(288139, '2vefB00', NULL, NULL, 314, NULL, NULL, 235495),
(288140, '4djdC01', NULL, NULL, 316, NULL, NULL, 235495),
(288141, '5u0vA00', NULL, NULL, 284, NULL, NULL, 235495),
(288142, '4djdD01', NULL, NULL, 309, NULL, NULL, 235495),
(288143, '3k13A00', NULL, NULL, 300, NULL, NULL, 235495),
(288144, '2e7fA00', NULL, NULL, 262, NULL, NULL, 235495),
(288145, '3bofA02', NULL, NULL, 266, NULL, NULL, 235495),
(288146, '2h9aB01', NULL, NULL, 296, NULL, NULL, 235495),
(288147, '3noyA01', NULL, NULL, 265, NULL, NULL, 235495),
(288148, '2h9aA01', NULL, NULL, 257, NULL, NULL, 235495),
(288149, '2bmbA02', NULL, NULL, 322, NULL, NULL, 235495),
(288150, '3rstA02', NULL, NULL, 67, NULL, NULL, 235496),
(288151, '1t3uB01', NULL, NULL, 48, NULL, NULL, 235497),
(288152, '4p1mB01', NULL, NULL, 61, NULL, NULL, 235497),
(288153, '3h09A04', NULL, NULL, 72, NULL, NULL, 235498),
(288154, '4du6B02', NULL, NULL, 136, NULL, NULL, 235499),
(288155, '1wurA02', NULL, NULL, 135, NULL, NULL, 235499),
(288156, '3o1kB00', NULL, NULL, 132, NULL, NULL, 235499),
(288157, '3bp1A02', NULL, NULL, 139, NULL, NULL, 235499),
(288158, '1dhnA00', NULL, NULL, 121, NULL, NULL, 235499),
(288159, '1is8A02', NULL, NULL, 131, NULL, NULL, 235499),
(288160, '2cg8C01', NULL, NULL, 119, NULL, NULL, 235499),
(288161, '5f3mA00', NULL, NULL, 123, NULL, NULL, 235499),
(288162, '4f8bA00', NULL, NULL, 145, NULL, NULL, 235499),
(288163, '1nbuA00', NULL, NULL, 119, NULL, NULL, 235499),
(288164, '4aeyA00', NULL, NULL, 118, NULL, NULL, 235499),
(288165, '1sqlJ00', NULL, NULL, 126, NULL, NULL, 235499),
(288166, '2o90A00', NULL, NULL, 122, NULL, NULL, 235499),
(288167, '3v9oA00', NULL, NULL, 143, NULL, NULL, 235499),
(288168, '3r2eA00', NULL, NULL, 120, NULL, NULL, 235499),
(288169, '1b9lA00', NULL, NULL, 120, NULL, NULL, 235499),
(288170, '3uxjA01', NULL, NULL, 118, NULL, NULL, 235499),
(288171, '4uqfA02', NULL, NULL, 135, NULL, NULL, 235499),
(288172, '3cr8A01', NULL, NULL, 143, NULL, NULL, 235500),
(288173, '1m8pA02', NULL, NULL, 188, NULL, NULL, 235500),
(288174, '1jhdA02', NULL, NULL, 193, NULL, NULL, 235500),
(288175, '2gksB01', NULL, NULL, 143, NULL, NULL, 235500),
(288176, '1r6xA01', NULL, NULL, 161, NULL, NULL, 235500),
(288177, '4dnxA01', NULL, NULL, 193, NULL, NULL, 235500),
(288178, '1t62B00', NULL, NULL, 166, NULL, NULL, 235500),
(288179, '3s9xA00', NULL, NULL, 159, NULL, NULL, 235500),
(288180, '1v47A01', NULL, NULL, 136, NULL, NULL, 235500),
(288181, '1x6vA02', NULL, NULL, 158, NULL, NULL, 235500),
(288182, '4mafA01', NULL, NULL, 170, NULL, NULL, 235500),
(288183, '2wcrB00', NULL, NULL, 159, NULL, NULL, 235501),
(288184, '1jyhA00', NULL, NULL, 157, NULL, NULL, 235502),
(288185, '1d5yB03', NULL, NULL, 172, NULL, NULL, 235502),
(288186, '1r8eA01', NULL, NULL, 159, NULL, NULL, 235502),
(288187, '2govA01', NULL, NULL, 173, NULL, NULL, 235502),
(288188, '5kawA00', NULL, NULL, 165, NULL, NULL, 235502),
(288189, '5x5mA00', NULL, NULL, 216, NULL, NULL, 235502),
(288190, '3gk6A00', NULL, NULL, 170, NULL, NULL, 235502),
(288191, '3r8jA00', NULL, NULL, 191, NULL, NULL, 235502),
(288192, '3e0hA00', NULL, NULL, 158, NULL, NULL, 235502),
(288193, '3b49A00', NULL, NULL, 211, NULL, NULL, 235502),
(288194, '3h0gB04', NULL, NULL, 178, NULL, NULL, 235503),
(288195, '4ljzC02', NULL, NULL, 174, NULL, NULL, 235503),
(288196, '4aybB04', NULL, NULL, 165, NULL, NULL, 235503),
(288197, '4kbmA02', NULL, NULL, 193, NULL, NULL, 235503),
(288198, '2a6hC03', NULL, NULL, 180, NULL, NULL, 235503),
(288199, '3ltiA01', NULL, NULL, 178, NULL, NULL, 235503),
(288200, '1ynjC03', NULL, NULL, 181, NULL, NULL, 235503),
(288201, '4c2mB04', NULL, NULL, 182, NULL, NULL, 235503),
(288202, '1twfB04', NULL, NULL, 177, NULL, NULL, 235503),
(288203, '4qiwB04', NULL, NULL, 163, NULL, NULL, 235503),
(288204, '3korB00', NULL, NULL, 119, NULL, NULL, 235504),
(288205, '3frwB00', NULL, NULL, 107, NULL, NULL, 235504),
(288206, '1jhgA00', NULL, NULL, 101, NULL, NULL, 235504),
(288207, '3g1cA00', NULL, NULL, 104, NULL, NULL, 235504),
(288208, '6eniA00', NULL, NULL, 116, NULL, NULL, 235504),
(288209, '1vk1A02', NULL, NULL, 130, NULL, NULL, 235505);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(288210, '5x0jA02', NULL, NULL, 130, NULL, NULL, 235505),
(288211, '3u64A00', NULL, NULL, 272, NULL, NULL, 235506),
(288212, '1wktA00', NULL, NULL, 88, NULL, NULL, 235507),
(288213, '1s2oA01', NULL, NULL, 173, NULL, NULL, 235508),
(288214, '2o2xA01', NULL, NULL, 213, NULL, NULL, 235508),
(288215, '2odaA00', NULL, NULL, 196, NULL, NULL, 235508),
(288216, '1qq5A01', NULL, NULL, 166, NULL, NULL, 235508),
(288217, '3f9rA01', NULL, NULL, 144, NULL, NULL, 235508),
(288218, '1yv9A01', NULL, NULL, 171, NULL, NULL, 235508),
(288219, '1wr8A01', NULL, NULL, 162, NULL, NULL, 235508),
(288220, '1ltqA02', NULL, NULL, 143, NULL, NULL, 235508),
(288221, '1wviA01', NULL, NULL, 149, NULL, NULL, 235508),
(288222, '3nuqA02', NULL, NULL, 181, NULL, NULL, 235508),
(288223, '2hcfA01', NULL, NULL, 166, NULL, NULL, 235508),
(288224, '1yv9A02', NULL, NULL, 93, NULL, NULL, 235508),
(288225, '3kc2A02', NULL, NULL, 163, NULL, NULL, 235508),
(288226, '2gfhA01', NULL, NULL, 170, NULL, NULL, 235508),
(288227, '3e8mA00', NULL, NULL, 164, NULL, NULL, 235508),
(288228, '3kc2A01', NULL, NULL, 189, NULL, NULL, 235508),
(288229, '1rkuA01', NULL, NULL, 111, NULL, NULL, 235508),
(288230, '3a1cB01', NULL, NULL, 170, NULL, NULL, 235508),
(288231, '3um9A01', NULL, NULL, 155, NULL, NULL, 235508),
(288232, '3kbbA01', NULL, NULL, 145, NULL, NULL, 235508),
(288233, '3n28A01', NULL, NULL, 156, NULL, NULL, 235508),
(288234, '3fvvA01', NULL, NULL, 157, NULL, NULL, 235508),
(288235, '2gmwA00', NULL, NULL, 188, NULL, NULL, 235508),
(288236, '4nabA02', NULL, NULL, 164, NULL, NULL, 235508),
(288237, '4mumA01', NULL, NULL, 145, NULL, NULL, 235508),
(288238, '3k1zA01', NULL, NULL, 157, NULL, NULL, 235508),
(288239, '5ksdA03', NULL, NULL, 152, NULL, NULL, 235508),
(288240, '2i33B00', NULL, NULL, 258, NULL, NULL, 235508),
(288241, '4as2A01', NULL, NULL, 224, NULL, NULL, 235508),
(288242, '2x4dA01', NULL, NULL, 162, NULL, NULL, 235508),
(288243, '2x4dA02', NULL, NULL, 105, NULL, NULL, 235508),
(288244, '3m9lA01', NULL, NULL, 154, NULL, NULL, 235508),
(288245, '3bwvA01', NULL, NULL, 131, NULL, NULL, 235508),
(288246, '3mmzC00', NULL, NULL, 176, NULL, NULL, 235508),
(288247, '1ys9A02', NULL, NULL, 96, NULL, NULL, 235508),
(288248, '1ys9A01', NULL, NULL, 158, NULL, NULL, 235508),
(288249, '1te2A01', NULL, NULL, 154, NULL, NULL, 235508),
(288250, '2ymmB01', NULL, NULL, 163, NULL, NULL, 235508),
(288251, '4jdpA01', NULL, NULL, 167, NULL, NULL, 235508),
(288252, '4jdpA02', NULL, NULL, 98, NULL, NULL, 235508),
(288253, '3slrA02', NULL, NULL, 168, NULL, NULL, 235508),
(288254, '4kn8A02', NULL, NULL, 96, NULL, NULL, 235508),
(288255, '4kn8A01', NULL, NULL, 171, NULL, NULL, 235508),
(288256, '4bndB01', NULL, NULL, 157, NULL, NULL, 235508),
(288257, '2pr7A00', NULL, NULL, 137, NULL, NULL, 235508),
(288258, '2yj6B01', NULL, NULL, 168, NULL, NULL, 235508),
(288259, '5is2A03', NULL, NULL, 221, NULL, NULL, 235508),
(288260, '3cnhA01', NULL, NULL, 133, NULL, NULL, 235508),
(288261, '4uavA01', NULL, NULL, 161, NULL, NULL, 235508),
(288262, '4fypB00', NULL, NULL, 228, NULL, NULL, 235508),
(288263, '3l8fA00', NULL, NULL, 187, NULL, NULL, 235508),
(288264, '2p9jB00', NULL, NULL, 162, NULL, NULL, 235508),
(288265, '4jb3A01', NULL, NULL, 156, NULL, NULL, 235508),
(288266, '5am2A01', NULL, NULL, 139, NULL, NULL, 235508),
(288267, '1ynsA01', NULL, NULL, 157, NULL, NULL, 235508),
(288268, '2fdrA01', NULL, NULL, 162, NULL, NULL, 235508),
(288269, '4l57A01', NULL, NULL, 140, NULL, NULL, 235508),
(288270, '1z5gA00', NULL, NULL, 214, NULL, NULL, 235508),
(288271, '4ohfA01', NULL, NULL, 202, NULL, NULL, 235508),
(288272, '4i9fB01', NULL, NULL, 156, NULL, NULL, 235508),
(288273, '2pkeA01', NULL, NULL, 167, NULL, NULL, 235508),
(288274, '2ghtA00', NULL, NULL, 181, NULL, NULL, 235508),
(288275, '3ib6C00', NULL, NULL, 189, NULL, NULL, 235508),
(288276, '2obbA00', NULL, NULL, 125, NULL, NULL, 235508),
(288277, '4g9bA01', NULL, NULL, 164, NULL, NULL, 235508),
(288278, '4xpzA01', NULL, NULL, 218, NULL, NULL, 235508),
(288279, '1cqzB01', NULL, NULL, 138, NULL, NULL, 235508),
(288280, '1wviC02', NULL, NULL, 109, NULL, NULL, 235508);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(288281, '4ezeB00', NULL, NULL, 295, NULL, NULL, 235508),
(288282, '3pdwA01', NULL, NULL, 170, NULL, NULL, 235508),
(288283, '3pdwA02', NULL, NULL, 96, NULL, NULL, 235508),
(288284, '1u02A01', NULL, NULL, 163, NULL, NULL, 235508),
(288285, '3ewiB00', NULL, NULL, 168, NULL, NULL, 235508),
(288286, '3s6jA01', NULL, NULL, 164, NULL, NULL, 235508),
(288287, '3fzqB01', NULL, NULL, 159, NULL, NULL, 235508),
(288288, '2zosB01', NULL, NULL, 166, NULL, NULL, 235508),
(288289, '2vkqA01', NULL, NULL, 188, NULL, NULL, 235508),
(288290, '1swvA01', NULL, NULL, 182, NULL, NULL, 235508),
(288291, '3l8hA00', NULL, NULL, 179, NULL, NULL, 235508),
(288292, '3qu5B01', NULL, NULL, 173, NULL, NULL, 235508),
(288293, '1nf2A01', NULL, NULL, 162, NULL, NULL, 235508),
(288294, '2fi1A01', NULL, NULL, 126, NULL, NULL, 235508),
(288295, '2p11A01', NULL, NULL, 156, NULL, NULL, 235508),
(288296, '2hdoA01', NULL, NULL, 145, NULL, NULL, 235508),
(288297, '3r4cA01', NULL, NULL, 167, NULL, NULL, 235508),
(288298, '3vayA01', NULL, NULL, 143, NULL, NULL, 235508),
(288299, '2hx1A01', NULL, NULL, 162, NULL, NULL, 235508),
(288300, '2hx1A02', NULL, NULL, 122, NULL, NULL, 235508),
(288301, '4zevB01', NULL, NULL, 164, NULL, NULL, 235508),
(288302, '4ofzA02', NULL, NULL, 217, NULL, NULL, 235508),
(288303, '3qleA00', NULL, NULL, 186, NULL, NULL, 235508),
(288304, '2fueA01', NULL, NULL, 160, NULL, NULL, 235508),
(288305, '3wguA03', NULL, NULL, 174, NULL, NULL, 235508),
(288306, '3skxA01', NULL, NULL, 162, NULL, NULL, 235508),
(288307, '1l7mB01', NULL, NULL, 149, NULL, NULL, 235508),
(288308, '1ydfA01', NULL, NULL, 164, NULL, NULL, 235508),
(288309, '1ydfA02', NULL, NULL, 93, NULL, NULL, 235508),
(288310, '3daoB01', NULL, NULL, 157, NULL, NULL, 235508),
(288311, '2hoqA01', NULL, NULL, 162, NULL, NULL, 235508),
(288312, '4pnhA00', NULL, NULL, 181, NULL, NULL, 235508),
(288313, '4bx0A01', NULL, NULL, 171, NULL, NULL, 235508),
(288314, '4bx0A02', NULL, NULL, 121, NULL, NULL, 235508),
(288315, '4uw9A01', NULL, NULL, 146, NULL, NULL, 235508),
(288316, '3n07B00', NULL, NULL, 179, NULL, NULL, 235508),
(288317, '1xpjA00', NULL, NULL, 126, NULL, NULL, 235508),
(288318, '2go7A01', NULL, NULL, 140, NULL, NULL, 235508),
(288319, '3qnmA01', NULL, NULL, 150, NULL, NULL, 235508),
(288320, '3umcA01', NULL, NULL, 156, NULL, NULL, 235508),
(288321, '3hltC01', NULL, NULL, 177, NULL, NULL, 235508),
(288322, '2i6xA01', NULL, NULL, 137, NULL, NULL, 235508),
(288323, '4dw8A01', NULL, NULL, 173, NULL, NULL, 235508),
(288324, '1vjrA02', NULL, NULL, 108, NULL, NULL, 235508),
(288325, '3skyA01', NULL, NULL, 157, NULL, NULL, 235508),
(288326, '1vjrA01', NULL, NULL, 163, NULL, NULL, 235508),
(288327, '2b30A01', NULL, NULL, 176, NULL, NULL, 235508),
(288328, '5mpmA03', NULL, NULL, 156, NULL, NULL, 235508),
(288329, '2b82A00', NULL, NULL, 211, NULL, NULL, 235508),
(288330, '4gibA01', NULL, NULL, 148, NULL, NULL, 235508),
(288331, '3m1yC01', NULL, NULL, 156, NULL, NULL, 235508),
(288332, '3kzxA01', NULL, NULL, 144, NULL, NULL, 235508),
(288333, '2cftA01', NULL, NULL, 173, NULL, NULL, 235508),
(288334, '3n1uA00', NULL, NULL, 191, NULL, NULL, 235508),
(288335, '4fe3A01', NULL, NULL, 193, NULL, NULL, 235508),
(288336, '1y8aA01', NULL, NULL, 167, NULL, NULL, 235508),
(288337, '1nrwA01', NULL, NULL, 158, NULL, NULL, 235508),
(288338, '3pgvB01', NULL, NULL, 159, NULL, NULL, 235508),
(288339, '2ho4A02', NULL, NULL, 89, NULL, NULL, 235508),
(288340, '1qyiA01', NULL, NULL, 188, NULL, NULL, 235508),
(288341, '2feaA01', NULL, NULL, 138, NULL, NULL, 235508),
(288342, '3mpoB01', NULL, NULL, 172, NULL, NULL, 235508),
(288343, '3d6jA01', NULL, NULL, 158, NULL, NULL, 235508),
(288344, '4navA00', NULL, NULL, 182, NULL, NULL, 235508),
(288345, '3l5kA01', NULL, NULL, 157, NULL, NULL, 235508),
(288346, '3ar4A03', NULL, NULL, 156, NULL, NULL, 235508),
(288347, '3ij5C00', NULL, NULL, 184, NULL, NULL, 235508),
(288348, '5yluA03', NULL, NULL, 174, NULL, NULL, 235508),
(288349, '4umvA03', NULL, NULL, 133, NULL, NULL, 235508),
(288350, '3ddhA01', NULL, NULL, 153, NULL, NULL, 235508),
(288351, '1nnlA01', NULL, NULL, 162, NULL, NULL, 235508);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(288352, '4i9fA02', NULL, NULL, 112, NULL, NULL, 235508),
(288353, '2w43A01', NULL, NULL, 144, NULL, NULL, 235508),
(288354, '2nyvA01', NULL, NULL, 158, NULL, NULL, 235508),
(288355, '3smvA01', NULL, NULL, 163, NULL, NULL, 235508),
(288356, '2hi0A01', NULL, NULL, 151, NULL, NULL, 235508),
(288357, '2hhlD00', NULL, NULL, 195, NULL, NULL, 235508),
(288358, '2g80A01', NULL, NULL, 147, NULL, NULL, 235508),
(288359, '1u7pD00', NULL, NULL, 164, NULL, NULL, 235508),
(288360, '4eekA01', NULL, NULL, 169, NULL, NULL, 235508),
(288361, '1cqzA01', NULL, NULL, 219, NULL, NULL, 235508),
(288362, '2ah5A01', NULL, NULL, 145, NULL, NULL, 235508),
(288363, '3umbA01', NULL, NULL, 154, NULL, NULL, 235508),
(288364, '6f2xA01', NULL, NULL, 151, NULL, NULL, 235508),
(288365, '4bbjA03', NULL, NULL, 135, NULL, NULL, 235508),
(288366, '4hgnB00', NULL, NULL, 176, NULL, NULL, 235508),
(288367, '2oycA01', NULL, NULL, 181, NULL, NULL, 235508),
(288368, '2oycA02', NULL, NULL, 125, NULL, NULL, 235508),
(288369, '2hf2A01', NULL, NULL, 176, NULL, NULL, 235508),
(288370, '5uj0A00', NULL, NULL, 145, NULL, NULL, 235508),
(288371, '4bkmA02', NULL, NULL, 134, NULL, NULL, 235508),
(288372, '3ed5A01', NULL, NULL, 154, NULL, NULL, 235508),
(288373, '3u13A01', NULL, NULL, 153, NULL, NULL, 235508),
(288374, '4um7B00', NULL, NULL, 173, NULL, NULL, 235508),
(288375, '2amyA01', NULL, NULL, 144, NULL, NULL, 235508),
(288376, '2wm8A00', NULL, NULL, 187, NULL, NULL, 235508),
(288377, '1x42A01', NULL, NULL, 149, NULL, NULL, 235508),
(288378, '2hszA01', NULL, NULL, 168, NULL, NULL, 235508),
(288379, '2b0cA01', NULL, NULL, 140, NULL, NULL, 235508),
(288380, '3hltA02', NULL, NULL, 89, NULL, NULL, 235508),
(288381, '4knvA01', NULL, NULL, 151, NULL, NULL, 235508),
(288382, '2g09A01', NULL, NULL, 193, NULL, NULL, 235508),
(288383, '1l6rA01', NULL, NULL, 157, NULL, NULL, 235508),
(288384, '3u26A01', NULL, NULL, 151, NULL, NULL, 235508),
(288385, '4ap9A01', NULL, NULL, 139, NULL, NULL, 235508),
(288386, '3i76B01', NULL, NULL, 160, NULL, NULL, 235508),
(288387, '3nasB01', NULL, NULL, 154, NULL, NULL, 235508),
(288388, '5ue7A01', NULL, NULL, 150, NULL, NULL, 235508),
(288389, '3iruA01', NULL, NULL, 185, NULL, NULL, 235508),
(288390, '2rbkA01', NULL, NULL, 160, NULL, NULL, 235508),
(288391, '2qyhB01', NULL, NULL, 158, NULL, NULL, 235508),
(288392, '4uasA01', NULL, NULL, 153, NULL, NULL, 235508),
(288393, '3sd7A01', NULL, NULL, 149, NULL, NULL, 235508),
(288394, '1rlmA01', NULL, NULL, 164, NULL, NULL, 235508),
(288395, '2zxeA03', NULL, NULL, 174, NULL, NULL, 235508),
(288396, '4ex6A01', NULL, NULL, 154, NULL, NULL, 235508),
(288397, '2qltA01', NULL, NULL, 177, NULL, NULL, 235508),
(288398, '1rkqA01', NULL, NULL, 175, NULL, NULL, 235508),
(288399, '1xviB01', NULL, NULL, 142, NULL, NULL, 235508),
(288400, '2q5eD00', NULL, NULL, 187, NULL, NULL, 235508),
(288401, '2b8eC01', NULL, NULL, 156, NULL, NULL, 235508),
(288402, '3dv9A01', NULL, NULL, 174, NULL, NULL, 235508),
(288403, '3shqA02', NULL, NULL, 229, NULL, NULL, 235508),
(288404, '3kd3A01', NULL, NULL, 159, NULL, NULL, 235508),
(288405, '1zjjA02', NULL, NULL, 117, NULL, NULL, 235508),
(288406, '3zx4A01', NULL, NULL, 172, NULL, NULL, 235508),
(288407, '2c4nA01', NULL, NULL, 146, NULL, NULL, 235508),
(288408, '4nv0A01', NULL, NULL, 237, NULL, NULL, 235508),
(288409, '3ocuA00', NULL, NULL, 262, NULL, NULL, 235508),
(288410, '1zrnA01', NULL, NULL, 157, NULL, NULL, 235508),
(288411, '2zg6B01', NULL, NULL, 143, NULL, NULL, 235508),
(288412, '3mn1G00', NULL, NULL, 189, NULL, NULL, 235508),
(288413, '2i54A01', NULL, NULL, 145, NULL, NULL, 235508),
(288414, '3dnpA01', NULL, NULL, 177, NULL, NULL, 235508),
(288415, '3l7yA01', NULL, NULL, 159, NULL, NULL, 235508),
(288416, '2c4nA02', NULL, NULL, 104, NULL, NULL, 235508),
(288417, '3mc1A01', NULL, NULL, 159, NULL, NULL, 235508),
(288418, '3e58B01', NULL, NULL, 148, NULL, NULL, 235508),
(288419, '2wf7A01', NULL, NULL, 143, NULL, NULL, 235508),
(288420, '3pctA00', NULL, NULL, 260, NULL, NULL, 235508),
(288421, '3gygC01', NULL, NULL, 203, NULL, NULL, 235508),
(288422, '2jarA01', NULL, NULL, 145, NULL, NULL, 235508);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(288423, '1k1eD00', NULL, NULL, 180, NULL, NULL, 235508),
(288424, '2no4B01', NULL, NULL, 165, NULL, NULL, 235508),
(288425, '4gxtA01', NULL, NULL, 227, NULL, NULL, 235508),
(288426, '2om6A01', NULL, NULL, 156, NULL, NULL, 235508),
(288427, '2fprB00', NULL, NULL, 176, NULL, NULL, 235508),
(288428, '2ho4B01', NULL, NULL, 170, NULL, NULL, 235508),
(288429, '2r8eA00', NULL, NULL, 188, NULL, NULL, 235508),
(288430, '3zvlA01', NULL, NULL, 195, NULL, NULL, 235508),
(288431, '3eprA01', NULL, NULL, 168, NULL, NULL, 235508),
(288432, '3eprA02', NULL, NULL, 96, NULL, NULL, 235508),
(288433, '4dccA01', NULL, NULL, 130, NULL, NULL, 235508),
(288434, '3umgC01', NULL, NULL, 183, NULL, NULL, 235508),
(288435, '1zjjB01', NULL, NULL, 146, NULL, NULL, 235508),
(288436, '2dstA00', NULL, NULL, 131, NULL, NULL, 235509),
(288437, '3l0mA02', NULL, NULL, 85, NULL, NULL, 235510),
(288438, '3kxaA01', NULL, NULL, 47, NULL, NULL, 235511),
(288439, '2r18A01', NULL, NULL, 79, NULL, NULL, 235512),
(288440, '3isyA00', NULL, NULL, 120, NULL, NULL, 235513),
(288441, '3d3zA00', NULL, NULL, 247, NULL, NULL, 235514),
(288442, '1iqqA00', NULL, NULL, 200, NULL, NULL, 235514),
(288443, '1iooA00', NULL, NULL, 196, NULL, NULL, 235514),
(288444, '1ucdA00', NULL, NULL, 190, NULL, NULL, 235514),
(288445, '3t0oA00', NULL, NULL, 238, NULL, NULL, 235514),
(288446, '1bolA00', NULL, NULL, 222, NULL, NULL, 235514),
(288447, '1vd1A00', NULL, NULL, 217, NULL, NULL, 235514),
(288448, '1dixA00', NULL, NULL, 208, NULL, NULL, 235514),
(288449, '1iybA00', NULL, NULL, 208, NULL, NULL, 235514),
(288450, '1sglA00', NULL, NULL, 209, NULL, NULL, 235514),
(288451, '1jy5A00', NULL, NULL, 212, NULL, NULL, 235514),
(288452, '2pqxA00', NULL, NULL, 245, NULL, NULL, 235514),
(288453, '4dw4B00', NULL, NULL, 167, NULL, NULL, 235514),
(288454, '1y7pB02', NULL, NULL, 143, NULL, NULL, 235515),
(288455, '3df7A04', NULL, NULL, 29, NULL, NULL, 235516),
(288456, '3fbnA00', NULL, NULL, 84, NULL, NULL, 235517),
(288457, '3fbiC00', NULL, NULL, 84, NULL, NULL, 235517),
(288458, '1epuA02', NULL, NULL, 115, NULL, NULL, 235518),
(288459, '4bx8A03', NULL, NULL, 125, NULL, NULL, 235518),
(288460, '1fvhA03', NULL, NULL, 114, NULL, NULL, 235518),
(288461, '2xheA03', NULL, NULL, 121, NULL, NULL, 235518),
(288462, '4ccaA03', NULL, NULL, 113, NULL, NULL, 235518),
(288463, '1mqsA03', NULL, NULL, 158, NULL, NULL, 235518),
(288464, '4jc8A03', NULL, NULL, 132, NULL, NULL, 235518),
(288465, '4jehA03', NULL, NULL, 114, NULL, NULL, 235518),
(288466, '3pukA03', NULL, NULL, 109, NULL, NULL, 235518),
(288467, '1t8sA01', NULL, NULL, 172, NULL, NULL, 235519),
(288468, '2guwB01', NULL, NULL, 152, NULL, NULL, 235519),
(288469, '2hfnB02', NULL, NULL, 53, NULL, NULL, 235520),
(288470, '1x0pE02', NULL, NULL, 46, NULL, NULL, 235520),
(288471, '2lklA01', NULL, NULL, 72, NULL, NULL, 235521),
(288472, '3vrdB03', NULL, NULL, 74, NULL, NULL, 235522),
(288473, '5n1tA03', NULL, NULL, 71, NULL, NULL, 235522),
(288474, '1fcdA03', NULL, NULL, 74, NULL, NULL, 235522),
(288475, '2b8iA00', NULL, NULL, 77, NULL, NULL, 235523),
(288476, '4fibA01', NULL, NULL, 64, NULL, NULL, 235524),
(288477, '2ky9A01', NULL, NULL, 67, NULL, NULL, 235524),
(288478, '4fibC01', NULL, NULL, 64, NULL, NULL, 235524),
(288479, '4fibB01', NULL, NULL, 64, NULL, NULL, 235524),
(288480, '2f4mA01', NULL, NULL, 230, NULL, NULL, 235525),
(288481, '4fgqB00', NULL, NULL, 193, NULL, NULL, 235525),
(288482, '3kd4A02', NULL, NULL, 160, NULL, NULL, 235525),
(288483, '2zk9X00', NULL, NULL, 185, NULL, NULL, 235525),
(288484, '4u65E00', NULL, NULL, 197, NULL, NULL, 235525),
(288485, '3isrA01', NULL, NULL, 192, NULL, NULL, 235525),
(288486, '3eswA01', NULL, NULL, 262, NULL, NULL, 235525),
(288487, '3c0fB00', NULL, NULL, 91, NULL, NULL, 235526),
(288488, '2fftA01', NULL, NULL, 15, NULL, NULL, 235527),
(288489, '5mmjb02', NULL, NULL, 52, NULL, NULL, 235528),
(288490, '5fpoA01', NULL, NULL, 61, NULL, NULL, 235528),
(288491, '1dgsA01', NULL, NULL, 76, NULL, NULL, 235528),
(288492, '1b04A03', NULL, NULL, 63, NULL, NULL, 235528),
(288493, '2vqeB02', NULL, NULL, 56, NULL, NULL, 235528);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(288494, '1zauA01', NULL, NULL, 77, NULL, NULL, 235528),
(288495, '5o5jV02', NULL, NULL, 52, NULL, NULL, 235528),
(288496, '4toiA02', NULL, NULL, 48, NULL, NULL, 235528),
(288497, '5tt5A01', NULL, NULL, 61, NULL, NULL, 235528),
(288498, '1ta8A01', NULL, NULL, 68, NULL, NULL, 235528),
(288499, '3uq8A01', NULL, NULL, 59, NULL, NULL, 235528),
(288500, '1stzA03', NULL, NULL, 89, NULL, NULL, 235529),
(288501, '2z1dB01', NULL, NULL, 147, NULL, NULL, 235530),
(288502, '1nltA02', NULL, NULL, 66, NULL, NULL, 235531),
(288503, '1exkA00', NULL, NULL, 79, NULL, NULL, 235531),
(288504, '2cttA01', NULL, NULL, 69, NULL, NULL, 235531),
(288505, '5oy0400', NULL, NULL, 140, NULL, NULL, 235532),
(288506, '1jb0D00', NULL, NULL, 138, NULL, NULL, 235532),
(288507, '2o01D01', NULL, NULL, 95, NULL, NULL, 235532),
(288508, '4xk8d00', NULL, NULL, 141, NULL, NULL, 235532),
(288509, '5l8rD00', NULL, NULL, 143, NULL, NULL, 235532),
(288510, '2vk9A03', NULL, NULL, 98, NULL, NULL, 235533),
(288511, '3kevA02', NULL, NULL, 107, NULL, NULL, 235534),
(288512, '4gaoD02', NULL, NULL, 110, NULL, NULL, 235534),
(288513, '2is9A02', NULL, NULL, 91, NULL, NULL, 235534),
(288514, '5v89A02', NULL, NULL, 104, NULL, NULL, 235534),
(288515, '4gbaA02', NULL, NULL, 110, NULL, NULL, 235534),
(288516, '2f48A03', NULL, NULL, 75, NULL, NULL, 235535),
(288517, '2wvxB04', NULL, NULL, 181, NULL, NULL, 235536),
(288518, '2ww3A04', NULL, NULL, 183, NULL, NULL, 235536),
(288519, '2ww2A04', NULL, NULL, 172, NULL, NULL, 235536),
(288520, '1n81A00', NULL, NULL, 186, NULL, NULL, 235537),
(288521, '4gzvC00', NULL, NULL, 142, NULL, NULL, 235538),
(288522, '4iabB00', NULL, NULL, 142, NULL, NULL, 235538),
(288523, '4i95A00', NULL, NULL, 142, NULL, NULL, 235538),
(288524, '3glkA02', NULL, NULL, 48, NULL, NULL, 235539),
(288525, '2yl2B02', NULL, NULL, 47, NULL, NULL, 235539),
(288526, '1w96A02', NULL, NULL, 45, NULL, NULL, 235539),
(288527, '3ksyA04', NULL, NULL, 37, NULL, NULL, 235540),
(288528, '4c2mA09', NULL, NULL, 196, NULL, NULL, 235541),
(288529, '3i9v103', NULL, NULL, 95, NULL, NULL, 235542),
(288530, '6g2jF03', NULL, NULL, 97, NULL, NULL, 235542),
(288531, '3p8aA02', NULL, NULL, 91, NULL, NULL, 235543),
(288532, '1j3mA00', NULL, NULL, 129, NULL, NULL, 235544),
(288533, '1q9uA00', NULL, NULL, 130, NULL, NULL, 235544),
(288534, '3mw8A01', NULL, NULL, 118, NULL, NULL, 235545),
(288535, '4es6A02', NULL, NULL, 135, NULL, NULL, 235545),
(288536, '1wcwA01', NULL, NULL, 132, NULL, NULL, 235545),
(288537, '4es6A01', NULL, NULL, 119, NULL, NULL, 235545),
(288538, '1wcwA02', NULL, NULL, 119, NULL, NULL, 235545),
(288539, '3mw8A02', NULL, NULL, 122, NULL, NULL, 235545),
(288540, '3re1A02', NULL, NULL, 135, NULL, NULL, 235545),
(288541, '1jr2A01', NULL, NULL, 125, NULL, NULL, 235545),
(288542, '1jr2A02', NULL, NULL, 140, NULL, NULL, 235545),
(288543, '3re1A01', NULL, NULL, 134, NULL, NULL, 235545),
(288544, '3d8tB01', NULL, NULL, 125, NULL, NULL, 235545),
(288545, '3p9zA01', NULL, NULL, 106, NULL, NULL, 235545),
(288546, '3p9zA02', NULL, NULL, 113, NULL, NULL, 235545),
(288547, '4evxA00', NULL, NULL, 106, NULL, NULL, 235546),
(288548, '1ohfA03', NULL, NULL, 141, NULL, NULL, 235547),
(288549, '3s6pA03', NULL, NULL, 142, NULL, NULL, 235547),
(288550, '4fsdA02', NULL, NULL, 98, NULL, NULL, 235548),
(288551, '3bs6B00', NULL, NULL, 280, NULL, NULL, 235549),
(288552, '3bl4A02', NULL, NULL, 48, NULL, NULL, 235550),
(288553, '1vt2J00', NULL, NULL, 142, NULL, NULL, 235551),
(288554, '5oomK00', NULL, NULL, 178, NULL, NULL, 235551),
(288555, '4a17I01', NULL, NULL, 148, NULL, NULL, 235551),
(288556, '1vw4H00', NULL, NULL, 163, NULL, NULL, 235551),
(288557, '1j3aA00', NULL, NULL, 142, NULL, NULL, 235551),
(288558, '2zjrG00', NULL, NULL, 145, NULL, NULL, 235551),
(288559, '3uxqN00', NULL, NULL, 140, NULL, NULL, 235551),
(288560, '4v19N00', NULL, NULL, 178, NULL, NULL, 235551),
(288561, '6em3O01', NULL, NULL, 149, NULL, NULL, 235551),
(288562, '1vx7K01', NULL, NULL, 148, NULL, NULL, 235551),
(288563, '1vwxO01', NULL, NULL, 150, NULL, NULL, 235551),
(288564, '1vq8J00', NULL, NULL, 145, NULL, NULL, 235551);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(288565, '2c61A00', NULL, NULL, 448, NULL, NULL, 235552),
(288566, '3vr4D00', NULL, NULL, 465, NULL, NULL, 235552),
(288567, '2dpyA00', NULL, NULL, 438, NULL, NULL, 235552),
(288568, '5bn3B00', NULL, NULL, 416, NULL, NULL, 235552),
(288569, '3gqbB00', NULL, NULL, 464, NULL, NULL, 235552),
(288570, '4h40A02', NULL, NULL, 145, NULL, NULL, 235553),
(288571, '3n54B03', NULL, NULL, 154, NULL, NULL, 235554),
(288572, '2hjmA01', NULL, NULL, 98, NULL, NULL, 235555),
(288573, '1s1dA00', NULL, NULL, 331, NULL, NULL, 235556),
(288574, '3aqoA02', NULL, NULL, 141, NULL, NULL, 235557),
(288575, '5xanA03', NULL, NULL, 128, NULL, NULL, 235557),
(288576, '3aa0A01', NULL, NULL, 113, NULL, NULL, 235558),
(288577, '4akrA01', NULL, NULL, 107, NULL, NULL, 235558),
(288578, '5wutA00', NULL, NULL, 235, NULL, NULL, 235559),
(288579, '4yg6B00', NULL, NULL, 163, NULL, NULL, 235559),
(288580, '3i4iB00', NULL, NULL, 214, NULL, NULL, 235559),
(288581, '1ioaA00', NULL, NULL, 240, NULL, NULL, 235559),
(288582, '3fbyA02', NULL, NULL, 228, NULL, NULL, 235559),
(288583, '4c1wA00', NULL, NULL, 188, NULL, NULL, 235559),
(288584, '1qnwA00', NULL, NULL, 242, NULL, NULL, 235559),
(288585, '3mppG01', NULL, NULL, 228, NULL, NULL, 235559),
(288586, '4yg0A00', NULL, NULL, 164, NULL, NULL, 235559),
(288587, '2yv8A00', NULL, NULL, 164, NULL, NULL, 235559),
(288588, '3c2uB02', NULL, NULL, 210, NULL, NULL, 235559),
(288589, '1wd3A01', NULL, NULL, 320, NULL, NULL, 235559),
(288590, '2h0bC00', NULL, NULL, 184, NULL, NULL, 235559),
(288591, '6ifeB02', NULL, NULL, 209, NULL, NULL, 235559),
(288592, '2r0hA00', NULL, NULL, 164, NULL, NULL, 235559),
(288593, '2a6vB00', NULL, NULL, 226, NULL, NULL, 235559),
(288594, '6a66A00', NULL, NULL, 142, NULL, NULL, 235559),
(288595, '1wbfA00', NULL, NULL, 242, NULL, NULL, 235559),
(288596, '1sltA00', NULL, NULL, 134, NULL, NULL, 235559),
(288597, '3rsjB01', NULL, NULL, 227, NULL, NULL, 235559),
(288598, '2fmdA00', NULL, NULL, 240, NULL, NULL, 235559),
(288599, '5ocrA00', NULL, NULL, 286, NULL, NULL, 235559),
(288600, '4l8qA00', NULL, NULL, 237, NULL, NULL, 235559),
(288601, '1gslA00', NULL, NULL, 243, NULL, NULL, 235559),
(288602, '1n1tA02', NULL, NULL, 202, NULL, NULL, 235559),
(288603, '2wsuB02', NULL, NULL, 156, NULL, NULL, 235559),
(288604, '3rq0A00', NULL, NULL, 230, NULL, NULL, 235559),
(288605, '2jkbA01', NULL, NULL, 192, NULL, NULL, 235559),
(288606, '3i8tA00', NULL, NULL, 140, NULL, NULL, 235559),
(288607, '3wz1A00', NULL, NULL, 282, NULL, NULL, 235559),
(288608, '5l73A00', NULL, NULL, 192, NULL, NULL, 235559),
(288609, '3ffzA03', NULL, NULL, 225, NULL, NULL, 235559),
(288610, '4crqA00', NULL, NULL, 233, NULL, NULL, 235559),
(288611, '4agrB00', NULL, NULL, 146, NULL, NULL, 235559),
(288612, '2dwrA01', NULL, NULL, 159, NULL, NULL, 235559),
(288613, '2zgqA00', NULL, NULL, 167, NULL, NULL, 235559),
(288614, '4asmB00', NULL, NULL, 363, NULL, NULL, 235559),
(288615, '3juuA00', NULL, NULL, 280, NULL, NULL, 235559),
(288616, '4awdB00', NULL, NULL, 297, NULL, NULL, 235559),
(288617, '2a5zA00', NULL, NULL, 239, NULL, NULL, 235559),
(288618, '3ipvB00', NULL, NULL, 239, NULL, NULL, 235559),
(288619, '3sitA00', NULL, NULL, 163, NULL, NULL, 235559),
(288620, '1mvqA00', NULL, NULL, 236, NULL, NULL, 235559),
(288621, '5xrgA00', NULL, NULL, 145, NULL, NULL, 235559),
(288622, '1macA00', NULL, NULL, 212, NULL, NULL, 235559),
(288623, '1yrzA02', NULL, NULL, 208, NULL, NULL, 235559),
(288624, '1jhnA01', NULL, NULL, 243, NULL, NULL, 235559),
(288625, '5vx5A01', NULL, NULL, 159, NULL, NULL, 235559),
(288626, '2b7yA00', NULL, NULL, 182, NULL, NULL, 235559),
(288627, '3dgtA00', NULL, NULL, 280, NULL, NULL, 235559),
(288628, '3pvnA00', NULL, NULL, 206, NULL, NULL, 235559),
(288629, '1fx5B00', NULL, NULL, 242, NULL, NULL, 235559),
(288630, '5jozA02', NULL, NULL, 208, NULL, NULL, 235559),
(288631, '3b3qE00', NULL, NULL, 197, NULL, NULL, 235559),
(288632, '1gv9A00', NULL, NULL, 235, NULL, NULL, 235559),
(288633, '2wsuA01', NULL, NULL, 139, NULL, NULL, 235559),
(288634, '1gbgA00', NULL, NULL, 214, NULL, NULL, 235559),
(288635, '1ikpA01', NULL, NULL, 230, NULL, NULL, 235559);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(288636, '1y7bA02', NULL, NULL, 216, NULL, NULL, 235559),
(288637, '6er4A00', NULL, NULL, 194, NULL, NULL, 235559),
(288638, '1bjqC00', NULL, NULL, 235, NULL, NULL, 235559),
(288639, '1v6iA00', NULL, NULL, 232, NULL, NULL, 235559),
(288640, '1dypA00', NULL, NULL, 271, NULL, NULL, 235559),
(288641, '2w39A00', NULL, NULL, 298, NULL, NULL, 235559),
(288642, '3km5A00', NULL, NULL, 180, NULL, NULL, 235559),
(288643, '4q27A00', NULL, NULL, 136, NULL, NULL, 235559),
(288644, '4dqaA02', NULL, NULL, 211, NULL, NULL, 235559),
(288645, '5freA00', NULL, NULL, 194, NULL, NULL, 235559),
(288646, '3zsjA00', NULL, NULL, 138, NULL, NULL, 235559),
(288647, '2vy0B00', NULL, NULL, 264, NULL, NULL, 235559),
(288648, '2durB01', NULL, NULL, 230, NULL, NULL, 235559),
(288649, '1yo8A05', NULL, NULL, 226, NULL, NULL, 235559),
(288650, '2exhA02', NULL, NULL, 208, NULL, NULL, 235559),
(288651, '1vavA00', NULL, NULL, 222, NULL, NULL, 235559),
(288652, '2zhnA00', NULL, NULL, 148, NULL, NULL, 235559),
(288653, '2wjsA03', NULL, NULL, 176, NULL, NULL, 235559),
(288654, '5u38A00', NULL, NULL, 239, NULL, NULL, 235559),
(288655, '2wjsA02', NULL, NULL, 183, NULL, NULL, 235559),
(288656, '5vxzA01', NULL, NULL, 193, NULL, NULL, 235559),
(288657, '2wjsA01', NULL, NULL, 193, NULL, NULL, 235559),
(288658, '2ymzA00', NULL, NULL, 130, NULL, NULL, 235559),
(288659, '5ymuA01', NULL, NULL, 159, NULL, NULL, 235559),
(288660, '5t9xC00', NULL, NULL, 295, NULL, NULL, 235559),
(288661, '4xzpA00', NULL, NULL, 148, NULL, NULL, 235559),
(288662, '5dzeA00', NULL, NULL, 207, NULL, NULL, 235559),
(288663, '4ygbA00', NULL, NULL, 228, NULL, NULL, 235559),
(288664, '5mk6A01', NULL, NULL, 236, NULL, NULL, 235559),
(288665, '5vkiA01', NULL, NULL, 159, NULL, NULL, 235559),
(288666, '3mepA00', NULL, NULL, 181, NULL, NULL, 235559),
(288667, '3zpyB00', NULL, NULL, 248, NULL, NULL, 235559),
(288668, '2d6mA00', NULL, NULL, 159, NULL, NULL, 235559),
(288669, '2a6zA00', NULL, NULL, 222, NULL, NULL, 235559),
(288670, '5vmrA01', NULL, NULL, 233, NULL, NULL, 235559),
(288671, '1d2sA00', NULL, NULL, 170, NULL, NULL, 235559),
(288672, '3azyA00', NULL, NULL, 272, NULL, NULL, 235559),
(288673, '4wzfA00', NULL, NULL, 249, NULL, NULL, 235559),
(288674, '4pbpA00', NULL, NULL, 210, NULL, NULL, 235559),
(288675, '3wdwA00', NULL, NULL, 298, NULL, NULL, 235559),
(288676, '5jvvA00', NULL, NULL, 298, NULL, NULL, 235559),
(288677, '1ux6A02', NULL, NULL, 213, NULL, NULL, 235559),
(288678, '4cd9D00', NULL, NULL, 259, NULL, NULL, 235559),
(288679, '2v73A00', NULL, NULL, 191, NULL, NULL, 235559),
(288680, '2sliA01', NULL, NULL, 196, NULL, NULL, 235559),
(288681, '5v38A01', NULL, NULL, 238, NULL, NULL, 235559),
(288682, '2ayhA00', NULL, NULL, 214, NULL, NULL, 235559),
(288683, '4wvvA00', NULL, NULL, 145, NULL, NULL, 235559),
(288684, '2ltnA00', NULL, NULL, 181, NULL, NULL, 235559),
(288685, '1loeC00', NULL, NULL, 181, NULL, NULL, 235559),
(288686, '2eigA00', NULL, NULL, 234, NULL, NULL, 235559),
(288687, '1n47A00', NULL, NULL, 233, NULL, NULL, 235559),
(288688, '5vx9A01', NULL, NULL, 159, NULL, NULL, 235559),
(288689, '3r4sA01', NULL, NULL, 240, NULL, NULL, 235559),
(288690, '1yifA02', NULL, NULL, 207, NULL, NULL, 235559),
(288691, '2c9aA01', NULL, NULL, 162, NULL, NULL, 235559),
(288692, '1h30A01', NULL, NULL, 225, NULL, NULL, 235559),
(288693, '1umzB00', NULL, NULL, 278, NULL, NULL, 235559),
(288694, '6jh5A00', NULL, NULL, 243, NULL, NULL, 235559),
(288695, '1w0pA03', NULL, NULL, 187, NULL, NULL, 235559),
(288696, '1pz7A00', NULL, NULL, 204, NULL, NULL, 235559),
(288697, '2uurA00', NULL, NULL, 227, NULL, NULL, 235559),
(288698, '1w0pA01', NULL, NULL, 177, NULL, NULL, 235559),
(288699, '1upsB01', NULL, NULL, 265, NULL, NULL, 235559),
(288700, '4gxlA00', NULL, NULL, 153, NULL, NULL, 235559),
(288701, '4drrA00', NULL, NULL, 163, NULL, NULL, 235559),
(288702, '5t5lA00', NULL, NULL, 242, NULL, NULL, 235559),
(288703, '6e20B00', NULL, NULL, 134, NULL, NULL, 235559),
(288704, '5gzcA00', NULL, NULL, 152, NULL, NULL, 235559),
(288705, '5eyyA00', NULL, NULL, 245, NULL, NULL, 235559),
(288706, '3sh4A00', NULL, NULL, 195, NULL, NULL, 235559);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(288707, '2gmeA00', NULL, NULL, 252, NULL, NULL, 235559),
(288708, '5u3eA00', NULL, NULL, 237, NULL, NULL, 235559),
(288709, '3wg3A00', NULL, NULL, 178, NULL, NULL, 235559),
(288710, '6f0oA01', NULL, NULL, 236, NULL, NULL, 235559),
(288711, '5zqjB02', NULL, NULL, 215, NULL, NULL, 235559),
(288712, '3q9oA01', NULL, NULL, 249, NULL, NULL, 235559),
(288713, '5hcfA01', NULL, NULL, 240, NULL, NULL, 235559),
(288714, '3mw3A00', NULL, NULL, 208, NULL, NULL, 235559),
(288715, '5mc9A01', NULL, NULL, 184, NULL, NULL, 235559),
(288716, '2uwaA00', NULL, NULL, 274, NULL, NULL, 235559),
(288717, '5mc9A02', NULL, NULL, 182, NULL, NULL, 235559),
(288718, '1ajkB00', NULL, NULL, 214, NULL, NULL, 235559),
(288719, '3atgA00', NULL, NULL, 256, NULL, NULL, 235559),
(288720, '4w65A00', NULL, NULL, 231, NULL, NULL, 235559),
(288721, '3zxfB00', NULL, NULL, 138, NULL, NULL, 235559),
(288722, '1gzcA00', NULL, NULL, 239, NULL, NULL, 235559),
(288723, '5cblB00', NULL, NULL, 148, NULL, NULL, 235559),
(288724, '3o0wA01', NULL, NULL, 251, NULL, NULL, 235559),
(288725, '4itcA00', NULL, NULL, 173, NULL, NULL, 235559),
(288726, '4atfA00', NULL, NULL, 308, NULL, NULL, 235559),
(288727, '3o5sA00', NULL, NULL, 213, NULL, NULL, 235559),
(288728, '3b9cA00', NULL, NULL, 144, NULL, NULL, 235559),
(288729, '2wkkA00', NULL, NULL, 150, NULL, NULL, 235559),
(288730, '1is3A00', NULL, NULL, 135, NULL, NULL, 235559),
(288731, '1lenA00', NULL, NULL, 181, NULL, NULL, 235559),
(288732, '3d6eB00', NULL, NULL, 201, NULL, NULL, 235559),
(288733, '5kxcA00', NULL, NULL, 243, NULL, NULL, 235559),
(288734, '3azvA01', NULL, NULL, 246, NULL, NULL, 235559),
(288735, '1s0iA02', NULL, NULL, 237, NULL, NULL, 235559),
(288736, '3vv1A00', NULL, NULL, 141, NULL, NULL, 235559),
(288737, '4xdqA00', NULL, NULL, 237, NULL, NULL, 235559),
(288738, '3zxkA02', NULL, NULL, 216, NULL, NULL, 235559),
(288739, '6fofA00', NULL, NULL, 154, NULL, NULL, 235559),
(288740, '1nlsA00', NULL, NULL, 237, NULL, NULL, 235559),
(288741, '3ujoC00', NULL, NULL, 258, NULL, NULL, 235559),
(288742, '1kqrA00', NULL, NULL, 160, NULL, NULL, 235559),
(288743, '4ozxA00', NULL, NULL, 285, NULL, NULL, 235559),
(288744, '5ik4A02', NULL, NULL, 175, NULL, NULL, 235559),
(288745, '3o12A00', NULL, NULL, 194, NULL, NULL, 235559),
(288746, '5jdbA01', NULL, NULL, 159, NULL, NULL, 235559),
(288747, '5ik4A01', NULL, NULL, 218, NULL, NULL, 235559),
(288748, '5tg3A00', NULL, NULL, 237, NULL, NULL, 235559),
(288749, '3wvjA00', NULL, NULL, 220, NULL, NULL, 235559),
(288750, '3v0aB03', NULL, NULL, 205, NULL, NULL, 235559),
(288751, '5dxdA00', NULL, NULL, 233, NULL, NULL, 235559),
(288752, '4be3A00', NULL, NULL, 314, NULL, NULL, 235559),
(288753, '1fnyA00', NULL, NULL, 237, NULL, NULL, 235559),
(288754, '3ilnA00', NULL, NULL, 251, NULL, NULL, 235559),
(288755, '2zzjA00', NULL, NULL, 238, NULL, NULL, 235559),
(288756, '4hanA02', NULL, NULL, 138, NULL, NULL, 235559),
(288757, '2jd4A02', NULL, NULL, 176, NULL, NULL, 235559),
(288758, '2jd4A01', NULL, NULL, 207, NULL, NULL, 235559),
(288759, '3gneB00', NULL, NULL, 252, NULL, NULL, 235559),
(288760, '1f9kA00', NULL, NULL, 238, NULL, NULL, 235559),
(288761, '1h9wB00', NULL, NULL, 237, NULL, NULL, 235559),
(288762, '1fatD00', NULL, NULL, 233, NULL, NULL, 235559),
(288763, '1c1lA00', NULL, NULL, 137, NULL, NULL, 235559),
(288764, '2je7A00', NULL, NULL, 239, NULL, NULL, 235559),
(288765, '3flpA00', NULL, NULL, 217, NULL, NULL, 235559),
(288766, '4y1uA00', NULL, NULL, 133, NULL, NULL, 235559),
(288767, '3wudA00', NULL, NULL, 136, NULL, NULL, 235559),
(288768, '5jp5D00', NULL, NULL, 145, NULL, NULL, 235559),
(288769, '3ikwA01', NULL, NULL, 304, NULL, NULL, 235559),
(288770, '5zqiA00', NULL, NULL, 223, NULL, NULL, 235559),
(288771, '3mw4A00', NULL, NULL, 178, NULL, NULL, 235559),
(288772, '4avsA00', NULL, NULL, 204, NULL, NULL, 235559),
(288773, '3qcwA02', NULL, NULL, 195, NULL, NULL, 235559),
(288774, '5nldB00', NULL, NULL, 139, NULL, NULL, 235559),
(288775, '4no4A00', NULL, NULL, 134, NULL, NULL, 235559),
(288776, '1cpnA00', NULL, NULL, 208, NULL, NULL, 235559),
(288777, '5hcaB01', NULL, NULL, 243, NULL, NULL, 235559);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(288778, '2r16A00', NULL, NULL, 182, NULL, NULL, 235559),
(288779, '5it6A00', NULL, NULL, 134, NULL, NULL, 235559),
(288780, '2erfA00', NULL, NULL, 209, NULL, NULL, 235559),
(288781, '2cwsA00', NULL, NULL, 237, NULL, NULL, 235559),
(288782, '1a78A00', NULL, NULL, 134, NULL, NULL, 235559),
(288783, '3v64A00', NULL, NULL, 191, NULL, NULL, 235559),
(288784, '2bqpA00', NULL, NULL, 234, NULL, NULL, 235559),
(288785, '1oq1B00', NULL, NULL, 223, NULL, NULL, 235559),
(288786, '4q8kA00', NULL, NULL, 233, NULL, NULL, 235559),
(288787, '1dbnA00', NULL, NULL, 239, NULL, NULL, 235559),
(288788, '3ajzA00', NULL, NULL, 135, NULL, NULL, 235559),
(288789, '5ca6B00', NULL, NULL, 161, NULL, NULL, 235559),
(288790, '4m00A01', NULL, NULL, 238, NULL, NULL, 235559),
(288791, '4xxpA00', NULL, NULL, 229, NULL, NULL, 235559),
(288792, '6f0pA01', NULL, NULL, 236, NULL, NULL, 235559),
(288793, '5cb7A00', NULL, NULL, 161, NULL, NULL, 235559),
(288794, '4bpzA00', NULL, NULL, 256, NULL, NULL, 235559),
(288795, '3zypA00', NULL, NULL, 218, NULL, NULL, 235559),
(288796, '5gm0A01', NULL, NULL, 154, NULL, NULL, 235559),
(288797, '5gm0A02', NULL, NULL, 130, NULL, NULL, 235559),
(288798, '2hykA00', NULL, NULL, 245, NULL, NULL, 235559),
(288799, '4lbqC00', NULL, NULL, 135, NULL, NULL, 235559),
(288800, '4ateA00', NULL, NULL, 266, NULL, NULL, 235559),
(288801, '5jowA02', NULL, NULL, 204, NULL, NULL, 235559),
(288802, '4zktB03', NULL, NULL, 205, NULL, NULL, 235559),
(288803, '3vuoA03', NULL, NULL, 205, NULL, NULL, 235559),
(288804, '3bodA00', NULL, NULL, 178, NULL, NULL, 235559),
(288805, '2cnaA00', NULL, NULL, 237, NULL, NULL, 235559),
(288806, '3h0oA00', NULL, NULL, 240, NULL, NULL, 235559),
(288807, '4myeA00', NULL, NULL, 237, NULL, NULL, 235559),
(288808, '3nv1A00', NULL, NULL, 138, NULL, NULL, 235559),
(288809, '3pmeA01', NULL, NULL, 225, NULL, NULL, 235559),
(288810, '1avbA00', NULL, NULL, 226, NULL, NULL, 235559),
(288811, '1uaiA00', NULL, NULL, 224, NULL, NULL, 235559),
(288812, '4yz1B01', NULL, NULL, 191, NULL, NULL, 235559),
(288813, '1dhkB00', NULL, NULL, 204, NULL, NULL, 235559),
(288814, '4u36A00', NULL, NULL, 240, NULL, NULL, 235559),
(288815, '3powA01', NULL, NULL, 248, NULL, NULL, 235559),
(288816, '4m3cB00', NULL, NULL, 239, NULL, NULL, 235559),
(288817, '1g7yB00', NULL, NULL, 253, NULL, NULL, 235559),
(288818, '5dg2B00', NULL, NULL, 135, NULL, NULL, 235559),
(288819, '4cciA00', NULL, NULL, 256, NULL, NULL, 235559),
(288820, '1a8dA01', NULL, NULL, 246, NULL, NULL, 235559),
(288821, '4gwmA02', NULL, NULL, 170, NULL, NULL, 235559),
(288822, '3wucB00', NULL, NULL, 137, NULL, NULL, 235559),
(288823, '3n7lA01', NULL, NULL, 235, NULL, NULL, 235559),
(288824, '3duiA00', NULL, NULL, 135, NULL, NULL, 235559),
(288825, '3pveA00', NULL, NULL, 189, NULL, NULL, 235559),
(288826, '4pq9A00', NULL, NULL, 233, NULL, NULL, 235559),
(288827, '1ajoA00', NULL, NULL, 214, NULL, NULL, 235559),
(288828, '1o4yA00', NULL, NULL, 288, NULL, NULL, 235559),
(288829, '2r1bA00', NULL, NULL, 220, NULL, NULL, 235559),
(288830, '1qmjA00', NULL, NULL, 132, NULL, NULL, 235559),
(288831, '3m1hD00', NULL, NULL, 178, NULL, NULL, 235559),
(288832, '3ajyA00', NULL, NULL, 135, NULL, NULL, 235559),
(288833, '2dycA00', NULL, NULL, 158, NULL, NULL, 235559),
(288834, '3asiA01', NULL, NULL, 182, NULL, NULL, 235559),
(288835, '1sbfA00', NULL, NULL, 234, NULL, NULL, 235559),
(288836, '3wcsA00', NULL, NULL, 238, NULL, NULL, 235559),
(288837, '1hqlA00', NULL, NULL, 239, NULL, NULL, 235559),
(288838, '5z5dA02', NULL, NULL, 199, NULL, NULL, 235559),
(288839, '3htmA02', NULL, NULL, 48, NULL, NULL, 235560),
(288840, '1v57A02', NULL, NULL, 24, NULL, NULL, 235561),
(288841, '5eo8A00', NULL, NULL, 311, NULL, NULL, 235562),
(288842, '4agiA00', NULL, NULL, 315, NULL, NULL, 235562),
(288843, '4csdB00', NULL, NULL, 272, NULL, NULL, 235562),
(288844, '5mxcA00', NULL, NULL, 325, NULL, NULL, 235562),
(288845, '3aqoA01', NULL, NULL, 88, NULL, NULL, 235563),
(288846, '1f0lA03', NULL, NULL, 154, NULL, NULL, 235564),
(288847, '3o5aA01', NULL, NULL, 135, NULL, NULL, 235565),
(288848, '2nyaA01', NULL, NULL, 126, NULL, NULL, 235565);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(288849, '1ogyA01', NULL, NULL, 135, NULL, NULL, 235565),
(288850, '1ykhB00', NULL, NULL, 132, NULL, NULL, 235566),
(288851, '3zq4C03', NULL, NULL, 107, NULL, NULL, 235567),
(288852, '3bk2A03', NULL, NULL, 99, NULL, NULL, 235567),
(288853, '4xwwA03', NULL, NULL, 98, NULL, NULL, 235567),
(288854, '3nqkA02', NULL, NULL, 160, NULL, NULL, 235568),
(288855, '3p02A02', NULL, NULL, 161, NULL, NULL, 235568),
(288856, '4qniA02', NULL, NULL, 163, NULL, NULL, 235568),
(288857, '6fd8A01', NULL, NULL, 88, NULL, NULL, 235569),
(288858, '6fd8A02', NULL, NULL, 90, NULL, NULL, 235569),
(288859, '1h4aX02', NULL, NULL, 90, NULL, NULL, 235569),
(288860, '1h4aX01', NULL, NULL, 83, NULL, NULL, 235569),
(288861, '1bd7B02', NULL, NULL, 84, NULL, NULL, 235569),
(288862, '5vh1A01', NULL, NULL, 88, NULL, NULL, 235569),
(288863, '5vh1A02', NULL, NULL, 90, NULL, NULL, 235569),
(288864, '3qk3B01', NULL, NULL, 95, NULL, NULL, 235569),
(288865, '2kp5A00', NULL, NULL, 92, NULL, NULL, 235569),
(288866, '3qk3B02', NULL, NULL, 89, NULL, NULL, 235569),
(288867, '1m8uA01', NULL, NULL, 83, NULL, NULL, 235569),
(288868, '1m8uA02', NULL, NULL, 90, NULL, NULL, 235569),
(288869, '1a45A02', NULL, NULL, 90, NULL, NULL, 235569),
(288870, '2m3cA01', NULL, NULL, 85, NULL, NULL, 235569),
(288871, '1zwmA01', NULL, NULL, 87, NULL, NULL, 235569),
(288872, '1zwmA02', NULL, NULL, 90, NULL, NULL, 235569),
(288873, '3cw3A00', NULL, NULL, 96, NULL, NULL, 235569),
(288874, '2bb2A02', NULL, NULL, 92, NULL, NULL, 235569),
(288875, '2m3cA02', NULL, NULL, 89, NULL, NULL, 235569),
(288876, '2jdgA01', NULL, NULL, 84, NULL, NULL, 235569),
(288877, '3hz2A00', NULL, NULL, 84, NULL, NULL, 235569),
(288878, '1elpA01', NULL, NULL, 83, NULL, NULL, 235569),
(288879, '1elpA02', NULL, NULL, 90, NULL, NULL, 235569),
(288880, '2jdfA02', NULL, NULL, 99, NULL, NULL, 235569),
(288881, '2jdfA01', NULL, NULL, 83, NULL, NULL, 235569),
(288882, '1npsA00', NULL, NULL, 88, NULL, NULL, 235569),
(288883, '4iauA01', NULL, NULL, 79, NULL, NULL, 235569),
(288884, '4iauA02', NULL, NULL, 84, NULL, NULL, 235569),
(288885, '1okiA02', NULL, NULL, 107, NULL, NULL, 235569),
(288886, '1okiA01', NULL, NULL, 103, NULL, NULL, 235569),
(288887, '1zirA02', NULL, NULL, 90, NULL, NULL, 235569),
(288888, '3so1E00', NULL, NULL, 97, NULL, NULL, 235569),
(288889, '1zirA01', NULL, NULL, 83, NULL, NULL, 235569),
(288890, '4el6A00', NULL, NULL, 106, NULL, NULL, 235569),
(288891, '1a7hA00', NULL, NULL, 86, NULL, NULL, 235569),
(288892, '3lwkA02', NULL, NULL, 95, NULL, NULL, 235569),
(288893, '2v2uA01', NULL, NULL, 83, NULL, NULL, 235569),
(288894, '3lwkA01', NULL, NULL, 96, NULL, NULL, 235569),
(288895, '2v2uA02', NULL, NULL, 90, NULL, NULL, 235569),
(288896, '1ammA02', NULL, NULL, 91, NULL, NULL, 235569),
(288897, '1ammA01', NULL, NULL, 83, NULL, NULL, 235569),
(288898, '3hzbC00', NULL, NULL, 90, NULL, NULL, 235569),
(288899, '2bv2A00', NULL, NULL, 83, NULL, NULL, 235569),
(288900, '1ytqA02', NULL, NULL, 92, NULL, NULL, 235569),
(288901, '1ytqA01', NULL, NULL, 86, NULL, NULL, 235569),
(288902, '4psrA03', NULL, NULL, 89, NULL, NULL, 235569),
(288903, '1yhpA01', NULL, NULL, 92, NULL, NULL, 235569),
(288904, '2dadA00', NULL, NULL, 93, NULL, NULL, 235569),
(288905, '1prrA02', NULL, NULL, 85, NULL, NULL, 235569),
(288906, '2nbrA01', NULL, NULL, 83, NULL, NULL, 235569),
(288907, '2nbrA02', NULL, NULL, 90, NULL, NULL, 235569),
(288908, '1hdfA00', NULL, NULL, 102, NULL, NULL, 235569),
(288909, '3enuA00', NULL, NULL, 114, NULL, NULL, 235569),
(288910, '4fd9A00', NULL, NULL, 92, NULL, NULL, 235569),
(288911, '3vg8C00', NULL, NULL, 116, NULL, NULL, 235570),
(288912, '3w1eA01', NULL, NULL, 90, NULL, NULL, 235571),
(288913, '3x01B02', NULL, NULL, 170, NULL, NULL, 235572),
(288914, '3x01A02', NULL, NULL, 179, NULL, NULL, 235572),
(288915, '6cn2A02', NULL, NULL, 170, NULL, NULL, 235572),
(288916, '2gk9B02', NULL, NULL, 141, NULL, NULL, 235572),
(288917, '2ybxB02', NULL, NULL, 166, NULL, NULL, 235572),
(288918, '2gsoA02', NULL, NULL, 103, NULL, NULL, 235573),
(288919, '4lr2A02', NULL, NULL, 96, NULL, NULL, 235573);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(288920, '4b56B02', NULL, NULL, 104, NULL, NULL, 235573),
(288921, '5eghA02', NULL, NULL, 111, NULL, NULL, 235573),
(288922, '4ufcA01', NULL, NULL, 334, NULL, NULL, 235574),
(288923, '2rdyA01', NULL, NULL, 389, NULL, NULL, 235574),
(288924, '2eabB01', NULL, NULL, 260, NULL, NULL, 235574),
(288925, '3w7tA01', NULL, NULL, 232, NULL, NULL, 235574),
(288926, '2hiyB01', NULL, NULL, 91, NULL, NULL, 235575),
(288927, '2m7bA00', NULL, NULL, 77, NULL, NULL, 235576),
(288928, '2m7aA00', NULL, NULL, 101, NULL, NULL, 235576),
(288929, '3ie4A00', NULL, NULL, 107, NULL, NULL, 235577),
(288930, '3aqxA00', NULL, NULL, 104, NULL, NULL, 235577),
(288931, '3aqyA00', NULL, NULL, 106, NULL, NULL, 235577),
(288932, '1dgwY01', NULL, NULL, 38, NULL, NULL, 235578),
(288933, '3i6dB03', NULL, NULL, 67, NULL, NULL, 235579),
(288934, '1sezA03', NULL, NULL, 92, NULL, NULL, 235579),
(288935, '2ivdA03', NULL, NULL, 92, NULL, NULL, 235579),
(288936, '3lovA03', NULL, NULL, 97, NULL, NULL, 235579),
(288937, '3lkmA02', NULL, NULL, 90, NULL, NULL, 235580),
(288938, '4kujA02', NULL, NULL, 121, NULL, NULL, 235580),
(288939, '1ia9A02', NULL, NULL, 106, NULL, NULL, 235580),
(288940, '1jg5A00', NULL, NULL, 83, NULL, NULL, 235581),
(288941, '4qclA02', NULL, NULL, 111, NULL, NULL, 235582),
(288942, '4fvmA02', NULL, NULL, 103, NULL, NULL, 235582),
(288943, '2mpnA00', NULL, NULL, 68, NULL, NULL, 235583),
(288944, '2lg4A00', NULL, NULL, 40, NULL, NULL, 235584),
(288945, '2mcfA00', NULL, NULL, 148, NULL, NULL, 235585),
(288946, '3if4A02', NULL, NULL, 47, NULL, NULL, 235586),
(288947, '2lvlA01', NULL, NULL, 113, NULL, NULL, 235587),
(288948, '3pu6A00', NULL, NULL, 157, NULL, NULL, 235588),
(288949, '1c8bA00', NULL, NULL, 338, NULL, NULL, 235588),
(288950, '2e85B00', NULL, NULL, 159, NULL, NULL, 235588),
(288951, '1cfzA00', NULL, NULL, 162, NULL, NULL, 235588),
(288952, '5ijaA00', NULL, NULL, 148, NULL, NULL, 235588),
(288953, '5z62K00', NULL, NULL, 49, NULL, NULL, 235589),
(288954, '5b1aK00', NULL, NULL, 56, NULL, NULL, 235589),
(288955, '5wkwA02', NULL, NULL, 151, NULL, NULL, 235590),
(288956, '3pmsA02', NULL, NULL, 184, NULL, NULL, 235590),
(288957, '4qhbA02', NULL, NULL, 179, NULL, NULL, 235590),
(288958, '4r4xA03', NULL, NULL, 173, NULL, NULL, 235590),
(288959, '3ks7A02', NULL, NULL, 179, NULL, NULL, 235590),
(288960, '3pmsA01', NULL, NULL, 135, NULL, NULL, 235590),
(288961, '3dkxA02', NULL, NULL, 74, NULL, NULL, 235591),
(288962, '3zqoA00', NULL, NULL, 72, NULL, NULL, 235592),
(288963, '3zqoB00', NULL, NULL, 56, NULL, NULL, 235592),
(288964, '3ptyA01', NULL, NULL, 125, NULL, NULL, 235593),
(288965, '3oipA01', NULL, NULL, 149, NULL, NULL, 235594),
(288966, '3e2dA02', NULL, NULL, 28, NULL, NULL, 235595),
(288967, '1igrA01', NULL, NULL, 184, NULL, NULL, 235596),
(288968, '3p0yA00', NULL, NULL, 194, NULL, NULL, 235596),
(288969, '4uv7A01', NULL, NULL, 193, NULL, NULL, 235596),
(288970, '1m6bA03', NULL, NULL, 172, NULL, NULL, 235596),
(288971, '2a91A03', NULL, NULL, 200, NULL, NULL, 235596),
(288972, '1m6bB03', NULL, NULL, 204, NULL, NULL, 235596),
(288973, '5sx5N00', NULL, NULL, 201, NULL, NULL, 235596),
(288974, '3i2tA01', NULL, NULL, 186, NULL, NULL, 235596),
(288975, '2ahxA03', NULL, NULL, 171, NULL, NULL, 235596),
(288976, '3i2tA03', NULL, NULL, 169, NULL, NULL, 235596),
(288977, '2ahxA01', NULL, NULL, 195, NULL, NULL, 235596),
(288978, '4leoC01', NULL, NULL, 197, NULL, NULL, 235596),
(288979, '1n8zC01', NULL, NULL, 192, NULL, NULL, 235596),
(288980, '1n8yC01', NULL, NULL, 193, NULL, NULL, 235596),
(288981, '2hr7A01', NULL, NULL, 191, NULL, NULL, 235596),
(288982, '2hr7B01', NULL, NULL, 240, NULL, NULL, 235596),
(288983, '4krpA01', NULL, NULL, 190, NULL, NULL, 235596),
(288984, '2hr7B03', NULL, NULL, 161, NULL, NULL, 235596),
(288985, '1n8yC03', NULL, NULL, 168, NULL, NULL, 235596),
(288986, '1igrA03', NULL, NULL, 179, NULL, NULL, 235596),
(288987, '1fxkB00', NULL, NULL, 109, NULL, NULL, 235597),
(288988, '1fxkC00', NULL, NULL, 133, NULL, NULL, 235597),
(288989, '2zqmA00', NULL, NULL, 117, NULL, NULL, 235597),
(288990, '3aeiA00', NULL, NULL, 99, NULL, NULL, 235597);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(288991, '2zdiB00', NULL, NULL, 117, NULL, NULL, 235597),
(288992, '2zdiC00', NULL, NULL, 151, NULL, NULL, 235597),
(288993, '2p09A00', NULL, NULL, 81, NULL, NULL, 235598),
(288994, '3rmqA01', NULL, NULL, 58, NULL, NULL, 235599),
(288995, '1tzvA00', NULL, NULL, 142, NULL, NULL, 235600),
(288996, '3r2cA00', NULL, NULL, 148, NULL, NULL, 235600),
(288997, '2yxlA01', NULL, NULL, 157, NULL, NULL, 235600),
(288998, '1eyvB00', NULL, NULL, 139, NULL, NULL, 235600),
(288999, '1sqgA01', NULL, NULL, 145, NULL, NULL, 235600),
(289000, '1q8cA00', NULL, NULL, 151, NULL, NULL, 235600),
(289001, '3d3bA00', NULL, NULL, 141, NULL, NULL, 235600),
(289002, '3pqiA02', NULL, NULL, 100, NULL, NULL, 235601),
(289003, '1sbxA00', NULL, NULL, 106, NULL, NULL, 235602),
(289004, '3eq5B00', NULL, NULL, 98, NULL, NULL, 235602),
(289005, '1l8rB00', NULL, NULL, 101, NULL, NULL, 235602),
(289006, '5t0oA01', NULL, NULL, 220, NULL, NULL, 235603),
(289007, '3w9iF01', NULL, NULL, 219, NULL, NULL, 235603),
(289008, '4mt1A01', NULL, NULL, 222, NULL, NULL, 235603),
(289009, '6bajA05', NULL, NULL, 203, NULL, NULL, 235603),
(289010, '4dx5A05', NULL, NULL, 247, NULL, NULL, 235603),
(289011, '3w9iF05', NULL, NULL, 233, NULL, NULL, 235603),
(289012, '4dx5C05', NULL, NULL, 223, NULL, NULL, 235603),
(289013, '4dx5C01', NULL, NULL, 219, NULL, NULL, 235603),
(289014, '5t0oA05', NULL, NULL, 229, NULL, NULL, 235603),
(289015, '4mt1A05', NULL, NULL, 227, NULL, NULL, 235603),
(289016, '6g6iA00', NULL, NULL, 108, NULL, NULL, 235604),
(289017, '3h90A02', NULL, NULL, 84, NULL, NULL, 235604),
(289018, '3w5xA00', NULL, NULL, 81, NULL, NULL, 235604),
(289019, '2zztA00', NULL, NULL, 87, NULL, NULL, 235604),
(289020, '6g5eA00', NULL, NULL, 82, NULL, NULL, 235604),
(289021, '3bypA00', NULL, NULL, 94, NULL, NULL, 235604),
(289022, '1wy5A02', NULL, NULL, 100, NULL, NULL, 235605),
(289023, '1ni5A02', NULL, NULL, 86, NULL, NULL, 235605),
(289024, '19hcA01', NULL, NULL, 155, NULL, NULL, 235606),
(289025, '1j0pA00', NULL, NULL, 108, NULL, NULL, 235606),
(289026, '2cthA00', NULL, NULL, 107, NULL, NULL, 235606),
(289027, '1hh5A00', NULL, NULL, 68, NULL, NULL, 235606),
(289028, '2e84A04', NULL, NULL, 125, NULL, NULL, 235606),
(289029, '1os6A00', NULL, NULL, 71, NULL, NULL, 235606),
(289030, '1up9A00', NULL, NULL, 107, NULL, NULL, 235606),
(289031, '2e84A02', NULL, NULL, 112, NULL, NULL, 235606),
(289032, '2e84A03', NULL, NULL, 157, NULL, NULL, 235606),
(289033, '1h29B04', NULL, NULL, 125, NULL, NULL, 235606),
(289034, '2e84A01', NULL, NULL, 120, NULL, NULL, 235606),
(289035, '1h29D03', NULL, NULL, 151, NULL, NULL, 235606),
(289036, '2bq4A00', NULL, NULL, 116, NULL, NULL, 235606),
(289037, '3h33A00', NULL, NULL, 75, NULL, NULL, 235606),
(289038, '3caoA00', NULL, NULL, 103, NULL, NULL, 235606),
(289039, '1i77A00', NULL, NULL, 107, NULL, NULL, 235606),
(289040, '1czjA00', NULL, NULL, 111, NULL, NULL, 235606),
(289041, '1rwjA00', NULL, NULL, 82, NULL, NULL, 235606),
(289042, '3bxuA00', NULL, NULL, 71, NULL, NULL, 235606),
(289043, '1gyoA00', NULL, NULL, 109, NULL, NULL, 235606),
(289044, '2a3mA00', NULL, NULL, 107, NULL, NULL, 235606),
(289045, '3ouqA01', NULL, NULL, 83, NULL, NULL, 235606),
(289046, '3ouqA02', NULL, NULL, 78, NULL, NULL, 235606),
(289047, '2cvcA01', NULL, NULL, 102, NULL, NULL, 235606),
(289048, '1z1nX04', NULL, NULL, 166, NULL, NULL, 235606),
(289049, '1duwA01', NULL, NULL, 155, NULL, NULL, 235606),
(289050, '3oueA02', NULL, NULL, 76, NULL, NULL, 235606),
(289051, '2cvcA02', NULL, NULL, 109, NULL, NULL, 235606),
(289052, '1z1nX02', NULL, NULL, 119, NULL, NULL, 235606),
(289053, '2cvcA03', NULL, NULL, 114, NULL, NULL, 235606),
(289054, '1z1nX03', NULL, NULL, 117, NULL, NULL, 235606),
(289055, '2cvcA04', NULL, NULL, 161, NULL, NULL, 235606),
(289056, '1duwA02', NULL, NULL, 137, NULL, NULL, 235606),
(289057, '1z1nX01', NULL, NULL, 99, NULL, NULL, 235606),
(289058, '3h34A00', NULL, NULL, 70, NULL, NULL, 235606),
(289059, '3h4nB00', NULL, NULL, 72, NULL, NULL, 235606),
(289060, '1ofwA02', NULL, NULL, 137, NULL, NULL, 235606),
(289061, '1ofwA01', NULL, NULL, 155, NULL, NULL, 235606);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(289062, '19hcA02', NULL, NULL, 137, NULL, NULL, 235606),
(289063, '2cy3A00', NULL, NULL, 118, NULL, NULL, 235606),
(289064, '1wadA00', NULL, NULL, 112, NULL, NULL, 235606),
(289065, '3canA00', NULL, NULL, 182, NULL, NULL, 235607),
(289066, '5xteG00', NULL, NULL, 51, NULL, NULL, 235608),
(289067, '2oarE02', NULL, NULL, 22, NULL, NULL, 235608),
(289068, '4ifdK01', NULL, NULL, 20, NULL, NULL, 235608),
(289069, '1mslA02', NULL, NULL, 18, NULL, NULL, 235608),
(289070, '1l0nK00', NULL, NULL, 56, NULL, NULL, 235608),
(289071, '2j59M02', NULL, NULL, 25, NULL, NULL, 235608),
(289072, '3clqB01', NULL, NULL, 24, NULL, NULL, 235608),
(289073, '3s6n201', NULL, NULL, 17, NULL, NULL, 235608),
(289074, '1ntmK00', NULL, NULL, 56, NULL, NULL, 235608),
(289075, '2wscH01', NULL, NULL, 23, NULL, NULL, 235608),
(289076, '3g3zA01', NULL, NULL, 28, NULL, NULL, 235608),
(289077, '2lkmA01', NULL, NULL, 17, NULL, NULL, 235608),
(289078, '3sdbA03', NULL, NULL, 123, NULL, NULL, 235609),
(289079, '4ckbA02', NULL, NULL, 211, NULL, NULL, 235610),
(289080, '1vw4V00', NULL, NULL, 64, NULL, NULL, 235611),
(289081, '2yq2A01', NULL, NULL, 89, NULL, NULL, 235612),
(289082, '3haxC00', NULL, NULL, 60, NULL, NULL, 235613),
(289083, '2aqcA00', NULL, NULL, 63, NULL, NULL, 235613),
(289084, '2ausB00', NULL, NULL, 60, NULL, NULL, 235613),
(289085, '2apoB00', NULL, NULL, 60, NULL, NULL, 235613),
(289086, '2htvA00', NULL, NULL, 390, NULL, NULL, 235614),
(289087, '5hx0A00', NULL, NULL, 365, NULL, NULL, 235614),
(289088, '4qn3A00', NULL, NULL, 390, NULL, NULL, 235614),
(289089, '3ti4A00', NULL, NULL, 388, NULL, NULL, 235614),
(289090, '2xziA00', NULL, NULL, 386, NULL, NULL, 235614),
(289091, '4yz1A02', NULL, NULL, 369, NULL, NULL, 235614),
(289092, '5hunA00', NULL, NULL, 400, NULL, NULL, 235614),
(289093, '6jjmA00', NULL, NULL, 460, NULL, NULL, 235614),
(289094, '4q6kA02', NULL, NULL, 359, NULL, NULL, 235614),
(289095, '6br5A00', NULL, NULL, 387, NULL, NULL, 235614),
(289096, '4cpyA00', NULL, NULL, 390, NULL, NULL, 235614),
(289097, '6hfcA00', NULL, NULL, 388, NULL, NULL, 235614),
(289098, '1s0iA01', NULL, NULL, 411, NULL, NULL, 235614),
(289099, '4hzzA00', NULL, NULL, 387, NULL, NULL, 235614),
(289100, '4k3yC00', NULL, NULL, 369, NULL, NULL, 235614),
(289101, '2aepA00', NULL, NULL, 395, NULL, NULL, 235614),
(289102, '1n1tA01', NULL, NULL, 386, NULL, NULL, 235614),
(289103, '4j9tA00', NULL, NULL, 363, NULL, NULL, 235614),
(289104, '4wa3A00', NULL, NULL, 388, NULL, NULL, 235614),
(289105, '4gdiA00', NULL, NULL, 373, NULL, NULL, 235614),
(289106, '5humA00', NULL, NULL, 391, NULL, NULL, 235614),
(289107, '1so7A00', NULL, NULL, 382, NULL, NULL, 235614),
(289108, '4gjtA00', NULL, NULL, 473, NULL, NULL, 235614),
(289109, '4mwjA00', NULL, NULL, 388, NULL, NULL, 235614),
(289110, '2rkcA00', NULL, NULL, 429, NULL, NULL, 235614),
(289111, '2vsmA00', NULL, NULL, 416, NULL, NULL, 235614),
(289112, '4bbwA02', NULL, NULL, 359, NULL, NULL, 235614),
(289113, '1nscA00', NULL, NULL, 390, NULL, NULL, 235614),
(289114, '2w20B01', NULL, NULL, 391, NULL, NULL, 235614),
(289115, '4hizA02', NULL, NULL, 378, NULL, NULL, 235614),
(289116, '4xjwA02', NULL, NULL, 370, NULL, NULL, 235614),
(289117, '4fj6A02', NULL, NULL, 360, NULL, NULL, 235614),
(289118, '3ju4A02', NULL, NULL, 357, NULL, NULL, 235614),
(289119, '4mzaA00', NULL, NULL, 437, NULL, NULL, 235614),
(289120, '3silA00', NULL, NULL, 379, NULL, NULL, 235614),
(289121, '3b7eA00', NULL, NULL, 385, NULL, NULL, 235614),
(289122, '3ckzA00', NULL, NULL, 385, NULL, NULL, 235614),
(289123, '4h53A00', NULL, NULL, 388, NULL, NULL, 235614),
(289124, '4uf7B00', NULL, NULL, 422, NULL, NULL, 235614),
(289125, '2sliA02', NULL, NULL, 383, NULL, NULL, 235614),
(289126, '3t1eB00', NULL, NULL, 446, NULL, NULL, 235614),
(289127, '4x4aA01', NULL, NULL, 393, NULL, NULL, 235614),
(289128, '2ydtA00', NULL, NULL, 367, NULL, NULL, 235614),
(289129, '1z4vA00', NULL, NULL, 448, NULL, NULL, 235614),
(289130, '3h6jA01', NULL, NULL, 315, NULL, NULL, 235614),
(289131, '1e8uA00', NULL, NULL, 446, NULL, NULL, 235614),
(289132, '1w0pA02', NULL, NULL, 381, NULL, NULL, 235614);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(289133, '3o9jA00', NULL, NULL, 387, NULL, NULL, 235614),
(289134, '6cmgA00', NULL, NULL, 428, NULL, NULL, 235614),
(289135, '2bf6A01', NULL, NULL, 383, NULL, NULL, 235614),
(289136, '3salA00', NULL, NULL, 395, NULL, NULL, 235614),
(289137, '6hgbA00', NULL, NULL, 389, NULL, NULL, 235614),
(289138, '1b9vA00', NULL, NULL, 390, NULL, NULL, 235614),
(289139, '3a72A00', NULL, NULL, 355, NULL, NULL, 235614),
(289140, '5hukA00', NULL, NULL, 402, NULL, NULL, 235614),
(289141, '5hugA00', NULL, NULL, 397, NULL, NULL, 235614),
(289142, '4gpvA02', NULL, NULL, 186, NULL, NULL, 235615),
(289143, '4jrfA02', NULL, NULL, 198, NULL, NULL, 235615),
(289144, '4jg5A02', NULL, NULL, 156, NULL, NULL, 235615),
(289145, '3liuA02', NULL, NULL, 212, NULL, NULL, 235615),
(289146, '2m4iA01', NULL, NULL, 81, NULL, NULL, 235616),
(289147, '1irxA03', NULL, NULL, 48, NULL, NULL, 235617),
(289148, '1floA01', NULL, NULL, 105, NULL, NULL, 235618),
(289149, '2lmkA00', NULL, NULL, 57, NULL, NULL, 235619),
(289150, '1f32A01', NULL, NULL, 89, NULL, NULL, 235620),
(289151, '1f32A02', NULL, NULL, 60, NULL, NULL, 235620),
(289152, '2l60A00', NULL, NULL, 41, NULL, NULL, 235621),
(289153, '3c19A02', NULL, NULL, 86, NULL, NULL, 235622),
(289154, '4r3uB00', NULL, NULL, 584, NULL, NULL, 235623),
(289155, '1ccwB01', NULL, NULL, 417, NULL, NULL, 235623),
(289156, '1reqA01', NULL, NULL, 522, NULL, NULL, 235623),
(289157, '1reqB01', NULL, NULL, 437, NULL, NULL, 235623),
(289158, '2xijA01', NULL, NULL, 516, NULL, NULL, 235623),
(289159, '1y8aA03', NULL, NULL, 30, NULL, NULL, 235624),
(289160, '2yayA01', NULL, NULL, 136, NULL, NULL, 235625),
(289161, '1oglA01', NULL, NULL, 131, NULL, NULL, 235625),
(289162, '4dk2A01', NULL, NULL, 116, NULL, NULL, 235625),
(289163, '5cl8A00', NULL, NULL, 241, NULL, NULL, 235626),
(289164, '4mzgB00', NULL, NULL, 222, NULL, NULL, 235627),
(289165, '4uy4A00', NULL, NULL, 216, NULL, NULL, 235627),
(289166, '4afkA00', NULL, NULL, 458, NULL, NULL, 235628),
(289167, '3mc6A01', NULL, NULL, 55, NULL, NULL, 235629),
(289168, '4c48C00', NULL, NULL, 49, NULL, NULL, 235630),
(289169, '2psoB01', NULL, NULL, 20, NULL, NULL, 235631),
(289170, '5l6hA05', NULL, NULL, 273, NULL, NULL, 235632),
(289171, '4ii2A05', NULL, NULL, 269, NULL, NULL, 235632),
(289172, '1z7lA00', NULL, NULL, 276, NULL, NULL, 235632),
(289173, '2xqyA02', NULL, NULL, 160, NULL, NULL, 235633),
(289174, '1vw4L02', NULL, NULL, 85, NULL, NULL, 235634),
(289175, '4r8oB00', NULL, NULL, 104, NULL, NULL, 235635),
(289176, '4r03A00', NULL, NULL, 109, NULL, NULL, 235635),
(289177, '4r8oA00', NULL, NULL, 104, NULL, NULL, 235635),
(289178, '3mswA00', NULL, NULL, 145, NULL, NULL, 235635),
(289179, '5o7oC01', NULL, NULL, 125, NULL, NULL, 235636),
(289180, '2x0qA01', NULL, NULL, 140, NULL, NULL, 235636),
(289181, '2h7aA01', NULL, NULL, 76, NULL, NULL, 235637),
(289182, '1srqA01', NULL, NULL, 142, NULL, NULL, 235638),
(289183, '3ll7A01', NULL, NULL, 72, NULL, NULL, 235639),
(289184, '4ewcA03', NULL, NULL, 79, NULL, NULL, 235640),
(289185, '4l8lA00', NULL, NULL, 145, NULL, NULL, 235641),
(289186, '4v0sB00', NULL, NULL, 146, NULL, NULL, 235641),
(289187, '2xdaA00', NULL, NULL, 150, NULL, NULL, 235641),
(289188, '1uqrE00', NULL, NULL, 154, NULL, NULL, 235641),
(289189, '3u80A00', NULL, NULL, 151, NULL, NULL, 235641),
(289190, '2uygA00', NULL, NULL, 149, NULL, NULL, 235641),
(289191, '3lwzB00', NULL, NULL, 153, NULL, NULL, 235641),
(289192, '3kipD00', NULL, NULL, 167, NULL, NULL, 235641),
(289193, '1gtzA00', NULL, NULL, 156, NULL, NULL, 235641),
(289194, '5ydbA00', NULL, NULL, 148, NULL, NULL, 235641),
(289195, '1gqoB00', NULL, NULL, 143, NULL, NULL, 235641),
(289196, '6cv6D00', NULL, NULL, 147, NULL, NULL, 235641),
(289197, '1om2A00', NULL, NULL, 95, NULL, NULL, 235642),
(289198, '3ax2A00', NULL, NULL, 73, NULL, NULL, 235642),
(289199, '1yzyA01', NULL, NULL, 235, NULL, NULL, 235643),
(289200, '5dmhB01', NULL, NULL, 244, NULL, NULL, 235643),
(289201, '3dqqB01', NULL, NULL, 236, NULL, NULL, 235643),
(289202, '1s5lH00', NULL, NULL, 66, NULL, NULL, 235644),
(289203, '5xnlH01', NULL, NULL, 64, NULL, NULL, 235644);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(289204, '3jcuH01', NULL, NULL, 64, NULL, NULL, 235644),
(289205, '5b66H01', NULL, NULL, 51, NULL, NULL, 235644),
(289206, '2kseA00', NULL, NULL, 77, NULL, NULL, 235645),
(289207, '5ti1A01', NULL, NULL, 142, NULL, NULL, 235646),
(289208, '1hyoA01', NULL, NULL, 113, NULL, NULL, 235646),
(289209, '4qkuA01', NULL, NULL, 138, NULL, NULL, 235646),
(289210, '4b1zM02', NULL, NULL, 44, NULL, NULL, 235647),
(289211, '2l2tA01', NULL, NULL, 23, NULL, NULL, 235648),
(289212, '5zcrA04', NULL, NULL, 94, NULL, NULL, 235649),
(289213, '1iv8A04', NULL, NULL, 97, NULL, NULL, 235649),
(289214, '3hjeA04', NULL, NULL, 96, NULL, NULL, 235649),
(289215, '1rgxA02', NULL, NULL, 64, NULL, NULL, 235650),
(289216, '1rh7A02', NULL, NULL, 63, NULL, NULL, 235650),
(289217, '1vq8N00', NULL, NULL, 187, NULL, NULL, 235651),
(289218, '1ovyA00', NULL, NULL, 97, NULL, NULL, 235651),
(289219, '1ilyA00', NULL, NULL, 90, NULL, NULL, 235651),
(289220, '5v7qO01', NULL, NULL, 100, NULL, NULL, 235651),
(289221, '5mmiP01', NULL, NULL, 104, NULL, NULL, 235651),
(289222, '6qulP00', NULL, NULL, 117, NULL, NULL, 235651),
(289223, '5o60P01', NULL, NULL, 100, NULL, NULL, 235651),
(289224, '3o58E00', NULL, NULL, 297, NULL, NULL, 235651),
(289225, '6hmaM01', NULL, NULL, 99, NULL, NULL, 235651),
(289226, '5dm6L01', NULL, NULL, 94, NULL, NULL, 235651),
(289227, '4a15A03', NULL, NULL, 140, NULL, NULL, 235652),
(289228, '4g59C01', NULL, NULL, 105, NULL, NULL, 235653),
(289229, '2o5nB01', NULL, NULL, 111, NULL, NULL, 235653),
(289230, '5jxxA02', NULL, NULL, 66, NULL, NULL, 235654),
(289231, '3t57A02', NULL, NULL, 84, NULL, NULL, 235654),
(289232, '6hy2X02', NULL, NULL, 66, NULL, NULL, 235654),
(289233, '4r36A02', NULL, NULL, 66, NULL, NULL, 235654),
(289234, '4eqyA02', NULL, NULL, 70, NULL, NULL, 235654),
(289235, '5f42A02', NULL, NULL, 86, NULL, NULL, 235654),
(289236, '5demA02', NULL, NULL, 66, NULL, NULL, 235654),
(289237, '1j2zA02', NULL, NULL, 77, NULL, NULL, 235654),
(289238, '3hsqA02', NULL, NULL, 68, NULL, NULL, 235654),
(289239, '3r0sA02', NULL, NULL, 69, NULL, NULL, 235654),
(289240, '4e6uA02', NULL, NULL, 67, NULL, NULL, 235654),
(289241, '1vq8L01', NULL, NULL, 51, NULL, NULL, 235655),
(289242, '1twcA01', NULL, NULL, 134, NULL, NULL, 235656),
(289243, '2e12A00', NULL, NULL, 101, NULL, NULL, 235657),
(289244, '3hjlA02', NULL, NULL, 106, NULL, NULL, 235658),
(289245, '3hjlA04', NULL, NULL, 92, NULL, NULL, 235658),
(289246, '1lkvX02', NULL, NULL, 140, NULL, NULL, 235658),
(289247, '1lkvX01', NULL, NULL, 92, NULL, NULL, 235658),
(289248, '3hjlA01', NULL, NULL, 90, NULL, NULL, 235658),
(289249, '4fhrB01', NULL, NULL, 124, NULL, NULL, 235658),
(289250, '4fhrB02', NULL, NULL, 92, NULL, NULL, 235658),
(289251, '3usyA01', NULL, NULL, 96, NULL, NULL, 235658),
(289252, '3ajcA01', NULL, NULL, 113, NULL, NULL, 235658),
(289253, '3uswA03', NULL, NULL, 98, NULL, NULL, 235658),
(289254, '3fqmA02', NULL, NULL, 86, NULL, NULL, 235659),
(289255, '4cl1B02', NULL, NULL, 86, NULL, NULL, 235659),
(289256, '4b43A01', NULL, NULL, 68, NULL, NULL, 235660),
(289257, '4rlcA00', NULL, NULL, 175, NULL, NULL, 235661),
(289258, '1p4tA00', NULL, NULL, 155, NULL, NULL, 235661),
(289259, '2lhfA00', NULL, NULL, 179, NULL, NULL, 235661),
(289260, '2jmmA00', NULL, NULL, 156, NULL, NULL, 235661),
(289261, '3gp6A00', NULL, NULL, 163, NULL, NULL, 235661),
(289262, '2ervA00', NULL, NULL, 150, NULL, NULL, 235661),
(289263, '2f1vA00', NULL, NULL, 197, NULL, NULL, 235661),
(289264, '1qj8A00', NULL, NULL, 148, NULL, NULL, 235661),
(289265, '2k0lA00', NULL, NULL, 216, NULL, NULL, 235661),
(289266, '4puxA00', NULL, NULL, 160, NULL, NULL, 235661),
(289267, '3qraA00', NULL, NULL, 157, NULL, NULL, 235661),
(289268, '3c5oB00', NULL, NULL, 157, NULL, NULL, 235661),
(289269, '3g7gH00', NULL, NULL, 158, NULL, NULL, 235661),
(289270, '2x27X00', NULL, NULL, 212, NULL, NULL, 235661),
(289271, '1qjpA00', NULL, NULL, 171, NULL, NULL, 235661),
(289272, '2igsA00', NULL, NULL, 219, NULL, NULL, 235662),
(289273, '2c1iA02', NULL, NULL, 107, NULL, NULL, 235663),
(289274, '1zhxA02', NULL, NULL, 87, NULL, NULL, 235664);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(289275, '2yk7A01', NULL, NULL, 82, NULL, NULL, 235665),
(289276, '2yk4A01', NULL, NULL, 82, NULL, NULL, 235665),
(289277, '2k47A00', NULL, NULL, 79, NULL, NULL, 235666),
(289278, '3hhwA00', NULL, NULL, 87, NULL, NULL, 235666),
(289279, '2w82A01', NULL, NULL, 61, NULL, NULL, 235667),
(289280, '1zx3A01', NULL, NULL, 90, NULL, NULL, 235668),
(289281, '4binA01', NULL, NULL, 131, NULL, NULL, 235669),
(289282, '1khvA04', NULL, NULL, 54, NULL, NULL, 235670),
(289283, '5v01B00', NULL, NULL, 173, NULL, NULL, 235671),
(289284, '4uuwA03', NULL, NULL, 147, NULL, NULL, 235671),
(289285, '5vu3H00', NULL, NULL, 170, NULL, NULL, 235671),
(289286, '5kvkA00', NULL, NULL, 170, NULL, NULL, 235671),
(289287, '5kolD00', NULL, NULL, 173, NULL, NULL, 235671),
(289288, '2a9sB00', NULL, NULL, 171, NULL, NULL, 235671),
(289289, '3ci9A00', NULL, NULL, 48, NULL, NULL, 235672),
(289290, '3miwA00', NULL, NULL, 53, NULL, NULL, 235672),
(289291, '4c7rA02', NULL, NULL, 48, NULL, NULL, 235672),
(289292, '4hh2A02', NULL, NULL, 39, NULL, NULL, 235672),
(289293, '2o1jB00', NULL, NULL, 52, NULL, NULL, 235672),
(289294, '4wbaA00', NULL, NULL, 52, NULL, NULL, 235672),
(289295, '5y9rD00', NULL, NULL, 46, NULL, NULL, 235672),
(289296, '2l5gB00', NULL, NULL, 42, NULL, NULL, 235672),
(289297, '5y2hB00', NULL, NULL, 51, NULL, NULL, 235672),
(289298, '2o1kA00', NULL, NULL, 52, NULL, NULL, 235672),
(289299, '5y2eB00', NULL, NULL, 47, NULL, NULL, 235672),
(289300, '3nw0B02', NULL, NULL, 134, NULL, NULL, 235673),
(289301, '2wa0A02', NULL, NULL, 124, NULL, NULL, 235673),
(289302, '1z21A00', NULL, NULL, 112, NULL, NULL, 235674),
(289303, '1vr8A00', NULL, NULL, 142, NULL, NULL, 235675),
(289304, '1n9pA00', NULL, NULL, 207, NULL, NULL, 235676),
(289305, '3k6nA00', NULL, NULL, 207, NULL, NULL, 235676),
(289306, '6jb1A01', NULL, NULL, 198, NULL, NULL, 235676),
(289307, '3vsqA00', NULL, NULL, 208, NULL, NULL, 235676),
(289308, '2wllB02', NULL, NULL, 157, NULL, NULL, 235676),
(289309, '5kukA01', NULL, NULL, 211, NULL, NULL, 235676),
(289310, '2gixB01', NULL, NULL, 208, NULL, NULL, 235676),
(289311, '4lp8A02', NULL, NULL, 163, NULL, NULL, 235676),
(289312, '3syaA01', NULL, NULL, 210, NULL, NULL, 235676),
(289313, '1mn8D00', NULL, NULL, 100, NULL, NULL, 235677),
(289314, '1uhuA00', NULL, NULL, 105, NULL, NULL, 235677),
(289315, '3aieA03', NULL, NULL, 417, NULL, NULL, 235678),
(289316, '5lfcA04', NULL, NULL, 415, NULL, NULL, 235678),
(289317, '5jbdA03', NULL, NULL, 403, NULL, NULL, 235678),
(289318, '4amcA04', NULL, NULL, 425, NULL, NULL, 235678),
(289319, '3klkA03', NULL, NULL, 369, NULL, NULL, 235678),
(289320, '4tvcA04', NULL, NULL, 421, NULL, NULL, 235678),
(289321, '2f9zC00', NULL, NULL, 159, NULL, NULL, 235679),
(289322, '1zpsA02', NULL, NULL, 26, NULL, NULL, 235680),
(289323, '2gviA01', NULL, NULL, 65, NULL, NULL, 235681),
(289324, '2fd4A00', NULL, NULL, 122, NULL, NULL, 235682),
(289325, '1wthA02', NULL, NULL, 102, NULL, NULL, 235683),
(289326, '2sicI00', NULL, NULL, 107, NULL, NULL, 235684),
(289327, '4hwxA00', NULL, NULL, 114, NULL, NULL, 235684),
(289328, '5b1aE00', NULL, NULL, 109, NULL, NULL, 235685),
(289329, '6giqf00', NULL, NULL, 102, NULL, NULL, 235685),
(289330, '2ia1A01', NULL, NULL, 119, NULL, NULL, 235686),
(289331, '4ckbA03', NULL, NULL, 134, NULL, NULL, 235687),
(289332, '3mggA02', NULL, NULL, 89, NULL, NULL, 235688),
(289333, '2ix3A05', NULL, NULL, 109, NULL, NULL, 235689),
(289334, '2iw3A05', NULL, NULL, 109, NULL, NULL, 235689),
(289335, '2iw3B05', NULL, NULL, 109, NULL, NULL, 235689),
(289336, '3dgpA00', NULL, NULL, 80, NULL, NULL, 235690),
(289337, '3tdqB00', NULL, NULL, 81, NULL, NULL, 235691),
(289338, '2l55A00', NULL, NULL, 82, NULL, NULL, 235691),
(289339, '2qcpX01', NULL, NULL, 75, NULL, NULL, 235691),
(289340, '4h8eA00', NULL, NULL, 238, NULL, NULL, 235692),
(289341, '1f75A00', NULL, NULL, 249, NULL, NULL, 235692),
(289342, '3ugsB00', NULL, NULL, 225, NULL, NULL, 235692),
(289343, '2vg1A00', NULL, NULL, 228, NULL, NULL, 235692),
(289344, '5hc8A00', NULL, NULL, 244, NULL, NULL, 235692),
(289345, '5hxqC00', NULL, NULL, 233, NULL, NULL, 235692);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(289346, '6acsA00', NULL, NULL, 240, NULL, NULL, 235692),
(289347, '4oncA01', NULL, NULL, 266, NULL, NULL, 235692),
(289348, '3wqlA01', NULL, NULL, 255, NULL, NULL, 235692),
(289349, '4q9mB00', NULL, NULL, 246, NULL, NULL, 235692),
(289350, '2d2rA00', NULL, NULL, 245, NULL, NULL, 235692),
(289351, '3sgvA00', NULL, NULL, 237, NULL, NULL, 235692),
(289352, '2zj2A04', NULL, NULL, 174, NULL, NULL, 235693),
(289353, '1wdvA00', NULL, NULL, 152, NULL, NULL, 235694),
(289354, '1vjfA00', NULL, NULL, 180, NULL, NULL, 235694),
(289355, '2dxaA00', NULL, NULL, 166, NULL, NULL, 235694),
(289356, '2z0xA00', NULL, NULL, 158, NULL, NULL, 235694),
(289357, '3op6A00', NULL, NULL, 152, NULL, NULL, 235694),
(289358, '3ri0B00', NULL, NULL, 165, NULL, NULL, 235694),
(289359, '2j3lA03', NULL, NULL, 147, NULL, NULL, 235694),
(289360, '1dbuA00', NULL, NULL, 158, NULL, NULL, 235694),
(289361, '5znjA03', NULL, NULL, 146, NULL, NULL, 235694),
(289362, '1vkiA00', NULL, NULL, 165, NULL, NULL, 235694),
(289363, '3memA01', NULL, NULL, 144, NULL, NULL, 235694),
(289364, '4dthA02', NULL, NULL, 137, NULL, NULL, 235695),
(289365, '4c9qA00', NULL, NULL, 304, NULL, NULL, 235696),
(289366, '4c9gA00', NULL, NULL, 295, NULL, NULL, 235696),
(289367, '1okcA00', NULL, NULL, 297, NULL, NULL, 235696),
(289368, '2lckA00', NULL, NULL, 303, NULL, NULL, 235696),
(289369, '2c1iA01', NULL, NULL, 129, NULL, NULL, 235697),
(289370, '3zd7A03', NULL, NULL, 139, NULL, NULL, 235698),
(289371, '5jajA03', NULL, NULL, 120, NULL, NULL, 235698),
(289372, '4i1sA01', NULL, NULL, 127, NULL, NULL, 235698),
(289373, '3ts9A00', NULL, NULL, 138, NULL, NULL, 235698),
(289374, '4a2pA03', NULL, NULL, 140, NULL, NULL, 235698),
(289375, '4gl2A03', NULL, NULL, 128, NULL, NULL, 235698),
(289376, '3tbkA03', NULL, NULL, 141, NULL, NULL, 235698),
(289377, '4zquA00', NULL, NULL, 124, NULL, NULL, 235699),
(289378, '4g6uA02', NULL, NULL, 138, NULL, NULL, 235699),
(289379, '2j7qA00', NULL, NULL, 232, NULL, NULL, 235700),
(289380, '2x5cA01', NULL, NULL, 91, NULL, NULL, 235701),
(289381, '1gpcA00', NULL, NULL, 218, NULL, NULL, 235702),
(289382, '2a1kA00', NULL, NULL, 233, NULL, NULL, 235702),
(289383, '3mzlB03', NULL, NULL, 239, NULL, NULL, 235703),
(289384, '6b08A01', NULL, NULL, 173, NULL, NULL, 235704),
(289385, '1z1yB01', NULL, NULL, 174, NULL, NULL, 235704),
(289386, '1z1yA01', NULL, NULL, 174, NULL, NULL, 235704),
(289387, '6b0gE00', NULL, NULL, 161, NULL, NULL, 235704),
(289388, '1z27A01', NULL, NULL, 174, NULL, NULL, 235704),
(289389, '1t77A02', NULL, NULL, 289, NULL, NULL, 235705),
(289390, '1mi1A02', NULL, NULL, 289, NULL, NULL, 235705),
(289391, '3hq1B03', NULL, NULL, 57, NULL, NULL, 235706),
(289392, '2omdA00', NULL, NULL, 135, NULL, NULL, 235707),
(289393, '2wp4B00', NULL, NULL, 147, NULL, NULL, 235707),
(289394, '3rpfA00', NULL, NULL, 148, NULL, NULL, 235707),
(289395, '5mpoC00', NULL, NULL, 154, NULL, NULL, 235707),
(289396, '2q5wE00', NULL, NULL, 149, NULL, NULL, 235707),
(289397, '1fm0E00', NULL, NULL, 150, NULL, NULL, 235707),
(289398, '2nqyA00', NULL, NULL, 206, NULL, NULL, 235708),
(289399, '1ynaA00', NULL, NULL, 194, NULL, NULL, 235708),
(289400, '1t6gC00', NULL, NULL, 184, NULL, NULL, 235708),
(289401, '3mf6A00', NULL, NULL, 193, NULL, NULL, 235708),
(289402, '4ixlA00', NULL, NULL, 211, NULL, NULL, 235708),
(289403, '2bw8A00', NULL, NULL, 227, NULL, NULL, 235708),
(289404, '3vgiA00', NULL, NULL, 270, NULL, NULL, 235708),
(289405, '3wp3A00', NULL, NULL, 190, NULL, NULL, 235708),
(289406, '1xnkA00', NULL, NULL, 196, NULL, NULL, 235708),
(289407, '5tvyA00', NULL, NULL, 188, NULL, NULL, 235708),
(289408, '4h7mB00', NULL, NULL, 226, NULL, NULL, 235708),
(289409, '5gm3B00', NULL, NULL, 219, NULL, NULL, 235708),
(289410, '1ks5A00', NULL, NULL, 223, NULL, NULL, 235708),
(289411, '2vg9A00', NULL, NULL, 217, NULL, NULL, 235708),
(289412, '3vl9B00', NULL, NULL, 229, NULL, NULL, 235708),
(289413, '1xndA00', NULL, NULL, 190, NULL, NULL, 235708),
(289414, '1oa3A00', NULL, NULL, 218, NULL, NULL, 235708),
(289415, '2jenA00', NULL, NULL, 233, NULL, NULL, 235708),
(289416, '1igoA00', NULL, NULL, 205, NULL, NULL, 235708);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(289417, '4nprB00', NULL, NULL, 219, NULL, NULL, 235708),
(289418, '2z79A00', NULL, NULL, 185, NULL, NULL, 235708),
(289419, '3m4fA00', NULL, NULL, 181, NULL, NULL, 235708),
(289420, '3wx5A00', NULL, NULL, 244, NULL, NULL, 235708),
(289421, '5hxvA00', NULL, NULL, 190, NULL, NULL, 235708),
(289422, '3amnA00', NULL, NULL, 265, NULL, NULL, 235708),
(289423, '1pvxA00', NULL, NULL, 194, NULL, NULL, 235708),
(289424, '2dckA01', NULL, NULL, 201, NULL, NULL, 235708),
(289425, '3wp4A00', NULL, NULL, 228, NULL, NULL, 235708),
(289426, '5vqjA00', NULL, NULL, 217, NULL, NULL, 235708),
(289427, '3b5lB00', NULL, NULL, 198, NULL, NULL, 235708),
(289428, '2nlrA00', NULL, NULL, 234, NULL, NULL, 235708),
(289429, '1f5jA00', NULL, NULL, 199, NULL, NULL, 235708),
(289430, '1h4gB00', NULL, NULL, 207, NULL, NULL, 235708),
(289431, '5m2dA00', NULL, NULL, 235, NULL, NULL, 235708),
(289432, '3b7mA00', NULL, NULL, 216, NULL, NULL, 235708),
(289433, '3akqA00', NULL, NULL, 190, NULL, NULL, 235708),
(289434, '1hixB00', NULL, NULL, 190, NULL, NULL, 235708),
(289435, '5jrmA00', NULL, NULL, 194, NULL, NULL, 235708),
(289436, '1xynA00', NULL, NULL, 178, NULL, NULL, 235708),
(289437, '3zseA00', NULL, NULL, 201, NULL, NULL, 235708),
(289438, '3lb9A00', NULL, NULL, 182, NULL, NULL, 235708),
(289439, '5ej3A00', NULL, NULL, 193, NULL, NULL, 235708),
(289440, '1oa4A00', NULL, NULL, 222, NULL, NULL, 235708),
(289441, '1oa2A00', NULL, NULL, 218, NULL, NULL, 235708),
(289442, '1olrA00', NULL, NULL, 224, NULL, NULL, 235708),
(289443, '2vujA00', NULL, NULL, 196, NULL, NULL, 235708),
(289444, '3wi3B00', NULL, NULL, 228, NULL, NULL, 235709),
(289445, '2zixB02', NULL, NULL, 103, NULL, NULL, 235710),
(289446, '2kc3A00', NULL, NULL, 184, NULL, NULL, 235711),
(289447, '1gs9A00', NULL, NULL, 144, NULL, NULL, 235711),
(289448, '1eq1A00', NULL, NULL, 166, NULL, NULL, 235711),
(289449, '6cfeA00', NULL, NULL, 141, NULL, NULL, 235711),
(289450, '1ya9A00', NULL, NULL, 181, NULL, NULL, 235711),
(289451, '1aepA00', NULL, NULL, 161, NULL, NULL, 235711),
(289452, '2a01C01', NULL, NULL, 185, NULL, NULL, 235711),
(289453, '3r2pA01', NULL, NULL, 139, NULL, NULL, 235711),
(289454, '3s84A02', NULL, NULL, 157, NULL, NULL, 235711),
(289455, '1utgA00', NULL, NULL, 70, NULL, NULL, 235712),
(289456, '1ccdA00', NULL, NULL, 77, NULL, NULL, 235712),
(289457, '3wurA00', NULL, NULL, 171, NULL, NULL, 235713),
(289458, '2j7aC00', NULL, NULL, 159, NULL, NULL, 235714),
(289459, '2wzoA01', NULL, NULL, 133, NULL, NULL, 235715),
(289460, '4alzA01', NULL, NULL, 66, NULL, NULL, 235716),
(289461, '4alzA02', NULL, NULL, 68, NULL, NULL, 235716),
(289462, '3pdiD03', NULL, NULL, 26, NULL, NULL, 235717),
(289463, '3we0A03', NULL, NULL, 137, NULL, NULL, 235718),
(289464, '4iv9A03', NULL, NULL, 149, NULL, NULL, 235718),
(289465, '1u7gA00', NULL, NULL, 385, NULL, NULL, 235719),
(289466, '3k3fA00', NULL, NULL, 340, NULL, NULL, 235719),
(289467, '3b9wA00', NULL, NULL, 369, NULL, NULL, 235719),
(289468, '2b2hA00', NULL, NULL, 399, NULL, NULL, 235719),
(289469, '5aezA00', NULL, NULL, 455, NULL, NULL, 235719),
(289470, '4ezcB00', NULL, NULL, 354, NULL, NULL, 235719),
(289471, '3hd6A00', NULL, NULL, 448, NULL, NULL, 235719),
(289472, '6qd5A00', NULL, NULL, 367, NULL, NULL, 235719),
(289473, '5aexJ00', NULL, NULL, 454, NULL, NULL, 235719),
(289474, '2idbC03', NULL, NULL, 35, NULL, NULL, 235720),
(289475, '2idbA03', NULL, NULL, 48, NULL, NULL, 235720),
(289476, '1ikpA02', NULL, NULL, 158, NULL, NULL, 235721),
(289477, '3q9oA02', NULL, NULL, 167, NULL, NULL, 235721),
(289478, '3k1lA02', NULL, NULL, 90, NULL, NULL, 235722),
(289479, '2jr1A01', NULL, NULL, 64, NULL, NULL, 235723),
(289480, '2ekgB01', NULL, NULL, 84, NULL, NULL, 235724),
(289481, '2g37A01', NULL, NULL, 60, NULL, NULL, 235724),
(289482, '1r9wA00', NULL, NULL, 145, NULL, NULL, 235725),
(289483, '1f08B00', NULL, NULL, 148, NULL, NULL, 235725),
(289484, '2pn5A01', NULL, NULL, 99, NULL, NULL, 235726),
(289485, '3lt7C00', NULL, NULL, 64, NULL, NULL, 235727),
(289486, '2yo3A04', NULL, NULL, 79, NULL, NULL, 235727),
(289487, '3h7zA00', NULL, NULL, 61, NULL, NULL, 235727);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(289488, '3h7xA00', NULL, NULL, 64, NULL, NULL, 235727),
(289489, '4bj1A02', NULL, NULL, 158, NULL, NULL, 235728),
(289490, '4q1vA01', NULL, NULL, 451, NULL, NULL, 235729),
(289491, '4wjlA01', NULL, NULL, 465, NULL, NULL, 235729),
(289492, '4a5sA02', NULL, NULL, 443, NULL, NULL, 235729),
(289493, '1z68A01', NULL, NULL, 464, NULL, NULL, 235729),
(289494, '4ffvA02', NULL, NULL, 446, NULL, NULL, 235729),
(289495, '1orvA01', NULL, NULL, 470, NULL, NULL, 235729),
(289496, '2z3zA01', NULL, NULL, 417, NULL, NULL, 235729),
(289497, '2ecfA01', NULL, NULL, 460, NULL, NULL, 235729),
(289498, '1xfdA01', NULL, NULL, 464, NULL, NULL, 235729),
(289499, '4h5bA00', NULL, NULL, 153, NULL, NULL, 235730),
(289500, '2ykoA02', NULL, NULL, 99, NULL, NULL, 235731),
(289501, '2w7aB00', NULL, NULL, 100, NULL, NULL, 235731),
(289502, '2nzwA01', NULL, NULL, 216, NULL, NULL, 235732),
(289503, '3zrtD01', NULL, NULL, 56, NULL, NULL, 235733),
(289504, '5kp7B00', NULL, NULL, 79, NULL, NULL, 235734),
(289505, '4bpfA00', NULL, NULL, 86, NULL, NULL, 235734),
(289506, '1x3oA00', NULL, NULL, 80, NULL, NULL, 235734),
(289507, '2dnwA00', NULL, NULL, 99, NULL, NULL, 235734),
(289508, '4r0mA03', NULL, NULL, 75, NULL, NULL, 235734),
(289509, '2gdyA01', NULL, NULL, 72, NULL, NULL, 235734),
(289510, '6h0jA00', NULL, NULL, 100, NULL, NULL, 235734),
(289511, '1af8A00', NULL, NULL, 86, NULL, NULL, 235734),
(289512, '3gzmB00', NULL, NULL, 81, NULL, NULL, 235734),
(289513, '2l22A02', NULL, NULL, 100, NULL, NULL, 235734),
(289514, '2l22A01', NULL, NULL, 91, NULL, NULL, 235734),
(289515, '2l4bA00', NULL, NULL, 88, NULL, NULL, 235734),
(289516, '2kooA00', NULL, NULL, 81, NULL, NULL, 235734),
(289517, '1vkuA00', NULL, NULL, 100, NULL, NULL, 235734),
(289518, '2n5hA00', NULL, NULL, 90, NULL, NULL, 235734),
(289519, '1nq4A00', NULL, NULL, 95, NULL, NULL, 235734),
(289520, '2mr7A00', NULL, NULL, 91, NULL, NULL, 235734),
(289521, '4h2wC00', NULL, NULL, 84, NULL, NULL, 235734),
(289522, '4h2uD00', NULL, NULL, 85, NULL, NULL, 235734),
(289523, '1t8kA00', NULL, NULL, 77, NULL, NULL, 235734),
(289524, '4ca3A01', NULL, NULL, 83, NULL, NULL, 235734),
(289525, '2n50A00', NULL, NULL, 79, NULL, NULL, 235734),
(289526, '1vw4801', NULL, NULL, 73, NULL, NULL, 235734),
(289527, '4neoA00', NULL, NULL, 93, NULL, NULL, 235734),
(289528, '2cg5B00', NULL, NULL, 91, NULL, NULL, 235734),
(289529, '4mrtC00', NULL, NULL, 90, NULL, NULL, 235734),
(289530, '2kr5A01', NULL, NULL, 76, NULL, NULL, 235734),
(289531, '1klpA00', NULL, NULL, 115, NULL, NULL, 235734),
(289532, '2roqA01', NULL, NULL, 97, NULL, NULL, 235734),
(289533, '5ejdA00', NULL, NULL, 77, NULL, NULL, 235734),
(289534, '2my5A00', NULL, NULL, 89, NULL, NULL, 235734),
(289535, '2mf4A01', NULL, NULL, 82, NULL, NULL, 235734),
(289536, '5czdB00', NULL, NULL, 85, NULL, NULL, 235734),
(289537, '4pxhB00', NULL, NULL, 90, NULL, NULL, 235734),
(289538, '2jgpA01', NULL, NULL, 79, NULL, NULL, 235734),
(289539, '2vsqA07', NULL, NULL, 75, NULL, NULL, 235734),
(289540, '2ehsA00', NULL, NULL, 77, NULL, NULL, 235734),
(289541, '2afdA00', NULL, NULL, 88, NULL, NULL, 235734),
(289542, '2lmlA00', NULL, NULL, 87, NULL, NULL, 235734),
(289543, '4hkgA00', NULL, NULL, 88, NULL, NULL, 235734),
(289544, '2pngA01', NULL, NULL, 72, NULL, NULL, 235734),
(289545, '2cgqA00', NULL, NULL, 88, NULL, NULL, 235734),
(289546, '2xz0D00', NULL, NULL, 82, NULL, NULL, 235734),
(289547, '3ce7A00', NULL, NULL, 107, NULL, NULL, 235734),
(289548, '2ju1A00', NULL, NULL, 95, NULL, NULL, 235734),
(289549, '4dg9A03', NULL, NULL, 82, NULL, NULL, 235734),
(289550, '6buhA00', NULL, NULL, 82, NULL, NULL, 235734),
(289551, '2l9fA00', NULL, NULL, 102, NULL, NULL, 235734),
(289552, '2cq8A01', NULL, NULL, 81, NULL, NULL, 235734),
(289553, '1or5A00', NULL, NULL, 83, NULL, NULL, 235734),
(289554, '2lolA00', NULL, NULL, 81, NULL, NULL, 235734),
(289555, '1f80D00', NULL, NULL, 81, NULL, NULL, 235734),
(289556, '2liuA01', NULL, NULL, 85, NULL, NULL, 235734),
(289557, '1dv5A00', NULL, NULL, 80, NULL, NULL, 235734),
(289558, '2lteA00', NULL, NULL, 103, NULL, NULL, 235734);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(289559, '2qnwA00', NULL, NULL, 82, NULL, NULL, 235734),
(289560, '2n98A00', NULL, NULL, 90, NULL, NULL, 235734),
(289561, '4iz6B03', NULL, NULL, 76, NULL, NULL, 235734),
(289562, '5hv8A00', NULL, NULL, 95, NULL, NULL, 235734),
(289563, '5ttbA00', NULL, NULL, 82, NULL, NULL, 235734),
(289564, '3lmoA00', NULL, NULL, 101, NULL, NULL, 235734),
(289565, '2l0qA00', NULL, NULL, 80, NULL, NULL, 235734),
(289566, '2lkiA00', NULL, NULL, 83, NULL, NULL, 235734),
(289567, '2m5rA00', NULL, NULL, 80, NULL, NULL, 235734),
(289568, '2kwlA00', NULL, NULL, 84, NULL, NULL, 235734),
(289569, '1qydA02', NULL, NULL, 121, NULL, NULL, 235735),
(289570, '3vpsB02', NULL, NULL, 102, NULL, NULL, 235735),
(289571, '3ko8A02', NULL, NULL, 112, NULL, NULL, 235735),
(289572, '2vrbA02', NULL, NULL, 116, NULL, NULL, 235735),
(289573, '2c20A02', NULL, NULL, 126, NULL, NULL, 235735),
(289574, '3eheA02', NULL, NULL, 116, NULL, NULL, 235735),
(289575, '5uzhA02', NULL, NULL, 105, NULL, NULL, 235735),
(289576, '2pk3A02', NULL, NULL, 90, NULL, NULL, 235735),
(289577, '1vl0A02', NULL, NULL, 78, NULL, NULL, 235735),
(289578, '4e5yD02', NULL, NULL, 100, NULL, NULL, 235735),
(289579, '2z1mA02', NULL, NULL, 110, NULL, NULL, 235735),
(289580, '3rufA02', NULL, NULL, 108, NULL, NULL, 235735),
(289581, '2zcuA02', NULL, NULL, 118, NULL, NULL, 235735),
(289582, '1n2sA02', NULL, NULL, 86, NULL, NULL, 235735),
(289583, '1kewA02', NULL, NULL, 84, NULL, NULL, 235735),
(289584, '2c5aA02', NULL, NULL, 136, NULL, NULL, 235735),
(289585, '2r6jA02', NULL, NULL, 128, NULL, NULL, 235735),
(289586, '4ej0A02', NULL, NULL, 121, NULL, NULL, 235735),
(289587, '6bwlA02', NULL, NULL, 121, NULL, NULL, 235735),
(289588, '1n7hB01', NULL, NULL, 115, NULL, NULL, 235735),
(289589, '6aqzA02', NULL, NULL, 95, NULL, NULL, 235735),
(289590, '1xgkA02', NULL, NULL, 117, NULL, NULL, 235735),
(289591, '1z45A02', NULL, NULL, 72, NULL, NULL, 235735),
(289592, '3slgC02', NULL, NULL, 95, NULL, NULL, 235735),
(289593, '2b69A02', NULL, NULL, 85, NULL, NULL, 235735),
(289594, '6dntA02', NULL, NULL, 109, NULL, NULL, 235735),
(289595, '5u9cC02', NULL, NULL, 77, NULL, NULL, 235735),
(289596, '1z7bA02', NULL, NULL, 101, NULL, NULL, 235735),
(289597, '4lw8A02', NULL, NULL, 92, NULL, NULL, 235735),
(289598, '1i24A02', NULL, NULL, 142, NULL, NULL, 235735),
(289599, '3e48B02', NULL, NULL, 105, NULL, NULL, 235735),
(289600, '1rkxB02', NULL, NULL, 164, NULL, NULL, 235735),
(289601, '1sb8A02', NULL, NULL, 107, NULL, NULL, 235735),
(289602, '2hunB02', NULL, NULL, 115, NULL, NULL, 235735),
(289603, '3sxpB02', NULL, NULL, 99, NULL, NULL, 235735),
(289604, '1e6uA02', NULL, NULL, 99, NULL, NULL, 235735),
(289605, '1ek6A01', NULL, NULL, 128, NULL, NULL, 235735),
(289606, '1eq2D02', NULL, NULL, 101, NULL, NULL, 235735),
(289607, '4zrmB02', NULL, NULL, 108, NULL, NULL, 235735),
(289608, '1oc2A02', NULL, NULL, 77, NULL, NULL, 235735),
(289609, '1r6dA02', NULL, NULL, 111, NULL, NULL, 235735),
(289610, '2wm3A02', NULL, NULL, 102, NULL, NULL, 235735),
(289611, '2p5yA02', NULL, NULL, 111, NULL, NULL, 235735),
(289612, '2ggsA02', NULL, NULL, 68, NULL, NULL, 235735),
(289613, '1wvgA02', NULL, NULL, 166, NULL, NULL, 235735),
(289614, '5gy7A02', NULL, NULL, 132, NULL, NULL, 235735),
(289615, '3enkB02', NULL, NULL, 125, NULL, NULL, 235735),
(289616, '1qycA02', NULL, NULL, 120, NULL, NULL, 235735),
(289617, '3c1oA02', NULL, NULL, 133, NULL, NULL, 235735),
(289618, '4wokA02', NULL, NULL, 123, NULL, NULL, 235735),
(289619, '4wpgA02', NULL, NULL, 79, NULL, NULL, 235735),
(289620, '6bi4A02', NULL, NULL, 102, NULL, NULL, 235735),
(289621, '1bxkA02', NULL, NULL, 94, NULL, NULL, 235735),
(289622, '2hrzA02', NULL, NULL, 98, NULL, NULL, 235735),
(289623, '1db3A02', NULL, NULL, 131, NULL, NULL, 235735),
(289624, '4lisA02', NULL, NULL, 138, NULL, NULL, 235735),
(289625, '3i6iA02', NULL, NULL, 122, NULL, NULL, 235735),
(289626, '2q1sA02', NULL, NULL, 94, NULL, NULL, 235735),
(289627, '3slgF02', NULL, NULL, 115, NULL, NULL, 235735),
(289628, '1rpnA02', NULL, NULL, 92, NULL, NULL, 235735),
(289629, '1gy8B01', NULL, NULL, 138, NULL, NULL, 235735);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(289630, '3sc6A02', NULL, NULL, 79, NULL, NULL, 235735),
(289631, '6gpkA02', NULL, NULL, 109, NULL, NULL, 235735),
(289632, '2gasA02', NULL, NULL, 119, NULL, NULL, 235735),
(289633, '2avtB01', NULL, NULL, 178, NULL, NULL, 235736),
(289634, '3l0xB01', NULL, NULL, 74, NULL, NULL, 235736),
(289635, '6d47A03', NULL, NULL, 138, NULL, NULL, 235736),
(289636, '6d47A02', NULL, NULL, 131, NULL, NULL, 235736),
(289637, '6d47A01', NULL, NULL, 124, NULL, NULL, 235736),
(289638, '5aguA03', NULL, NULL, 138, NULL, NULL, 235736),
(289639, '5wceA03', NULL, NULL, 119, NULL, NULL, 235736),
(289640, '3f1vA02', NULL, NULL, 124, NULL, NULL, 235736),
(289641, '2awaA01', NULL, NULL, 190, NULL, NULL, 235736),
(289642, '6amqA03', NULL, NULL, 119, NULL, NULL, 235736),
(289643, '3d1gA01', NULL, NULL, 123, NULL, NULL, 235736),
(289644, '5wceA02', NULL, NULL, 129, NULL, NULL, 235736),
(289645, '5wceB01', NULL, NULL, 131, NULL, NULL, 235736),
(289646, '3l0wA00', NULL, NULL, 169, NULL, NULL, 235736),
(289647, '5fveA02', NULL, NULL, 130, NULL, NULL, 235736),
(289648, '4tr8B03', NULL, NULL, 119, NULL, NULL, 235736),
(289649, '4tr6A01', NULL, NULL, 180, NULL, NULL, 235736),
(289650, '3t0pA01', NULL, NULL, 172, NULL, NULL, 235736),
(289651, '4tr8B02', NULL, NULL, 125, NULL, NULL, 235736),
(289652, '3t0pA02', NULL, NULL, 199, NULL, NULL, 235736),
(289653, '4tr8B01', NULL, NULL, 139, NULL, NULL, 235736),
(289654, '1vpkA02', NULL, NULL, 128, NULL, NULL, 235736),
(289655, '1vpkA01', NULL, NULL, 131, NULL, NULL, 235736),
(289656, '5ah2A02', NULL, NULL, 131, NULL, NULL, 235736),
(289657, '1sxjH02', NULL, NULL, 132, NULL, NULL, 235736),
(289658, '5ah2A01', NULL, NULL, 135, NULL, NULL, 235736),
(289659, '1vpkA03', NULL, NULL, 119, NULL, NULL, 235736),
(289660, '4k3lB03', NULL, NULL, 119, NULL, NULL, 235736),
(289661, '5ah2B03', NULL, NULL, 135, NULL, NULL, 235736),
(289662, '4k3lB02', NULL, NULL, 124, NULL, NULL, 235736),
(289663, '1sxjH01', NULL, NULL, 124, NULL, NULL, 235736),
(289664, '4trtA03', NULL, NULL, 127, NULL, NULL, 235736),
(289665, '4trtA01', NULL, NULL, 122, NULL, NULL, 235736),
(289666, '4trtA02', NULL, NULL, 119, NULL, NULL, 235736),
(289667, '5agvA01', NULL, NULL, 137, NULL, NULL, 235736),
(289668, '5agvA02', NULL, NULL, 131, NULL, NULL, 235736),
(289669, '3pgeA02', NULL, NULL, 96, NULL, NULL, 235736),
(289670, '4bh6L00', NULL, NULL, 53, NULL, NULL, 235737),
(289671, '2npnA01', NULL, NULL, 142, NULL, NULL, 235738),
(289672, '3kwpA01', NULL, NULL, 124, NULL, NULL, 235738),
(289673, '1ve2A01', NULL, NULL, 116, NULL, NULL, 235738),
(289674, '2yboA01', NULL, NULL, 123, NULL, NULL, 235738),
(289675, '3hh1A00', NULL, NULL, 117, NULL, NULL, 235738),
(289676, '4e16A01', NULL, NULL, 114, NULL, NULL, 235738),
(289677, '1pjqA04', NULL, NULL, 118, NULL, NULL, 235738),
(289678, '1wdeA01', NULL, NULL, 120, NULL, NULL, 235738),
(289679, '3ndcA01', NULL, NULL, 113, NULL, NULL, 235738),
(289680, '1s4dD01', NULL, NULL, 130, NULL, NULL, 235738),
(289681, '2z6rB01', NULL, NULL, 114, NULL, NULL, 235738),
(289682, '2bb3A01', NULL, NULL, 105, NULL, NULL, 235738),
(289683, '3i4tA01', NULL, NULL, 113, NULL, NULL, 235738),
(289684, '3nd1A01', NULL, NULL, 143, NULL, NULL, 235738),
(289685, '1vhvA01', NULL, NULL, 124, NULL, NULL, 235738),
(289686, '3nutC01', NULL, NULL, 120, NULL, NULL, 235738),
(289687, '1va0A01', NULL, NULL, 113, NULL, NULL, 235738),
(289688, '5hw4A01', NULL, NULL, 110, NULL, NULL, 235738),
(289689, '2qbuA01', NULL, NULL, 132, NULL, NULL, 235738),
(289690, '1wyzA01', NULL, NULL, 121, NULL, NULL, 235738),
(289691, '1cbfA01', NULL, NULL, 130, NULL, NULL, 235738),
(289692, '2e0nA01', NULL, NULL, 133, NULL, NULL, 235738),
(289693, '2zvbA01', NULL, NULL, 132, NULL, NULL, 235738),
(289694, '2qneA01', NULL, NULL, 468, NULL, NULL, 235739),
(289695, '4yycA00', NULL, NULL, 490, NULL, NULL, 235739),
(289696, '2d42A01', NULL, NULL, 184, NULL, NULL, 235740),
(289697, '3zjxA02', NULL, NULL, 203, NULL, NULL, 235740),
(289698, '3g4nA03', NULL, NULL, 207, NULL, NULL, 235740),
(289699, '1w3fA02', NULL, NULL, 166, NULL, NULL, 235740),
(289700, '2proC01', NULL, NULL, 67, NULL, NULL, 235741);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(289701, '3proC01', NULL, NULL, 84, NULL, NULL, 235741),
(289702, '3proC02', NULL, NULL, 78, NULL, NULL, 235741),
(289703, '2czvC01', NULL, NULL, 106, NULL, NULL, 235742),
(289704, '3wz0C00', NULL, NULL, 120, NULL, NULL, 235742),
(289705, '2av5A00', NULL, NULL, 120, NULL, NULL, 235742),
(289706, '5v4dB00', NULL, NULL, 128, NULL, NULL, 235743),
(289707, '1dbfA00', NULL, NULL, 127, NULL, NULL, 235743),
(289708, '5hp7A00', NULL, NULL, 108, NULL, NULL, 235743),
(289709, '3vczA00', NULL, NULL, 128, NULL, NULL, 235743),
(289710, '2dyyK00', NULL, NULL, 126, NULL, NULL, 235743),
(289711, '4nwoB00', NULL, NULL, 114, NULL, NULL, 235743),
(289712, '3l7qA00', NULL, NULL, 125, NULL, NULL, 235743),
(289713, '3v4dB00', NULL, NULL, 134, NULL, NULL, 235743),
(289714, '5yu2B00', NULL, NULL, 130, NULL, NULL, 235743),
(289715, '1qu9A00', NULL, NULL, 128, NULL, NULL, 235743),
(289716, '3d01E00', NULL, NULL, 165, NULL, NULL, 235743),
(289717, '1xhoA00', NULL, NULL, 117, NULL, NULL, 235743),
(289718, '3kjjB00', NULL, NULL, 128, NULL, NULL, 235743),
(289719, '2uynA00', NULL, NULL, 129, NULL, NULL, 235743),
(289720, '1jd1E00', NULL, NULL, 129, NULL, NULL, 235743),
(289721, '3k12D00', NULL, NULL, 122, NULL, NULL, 235743),
(289722, '1xhoC00', NULL, NULL, 117, NULL, NULL, 235743),
(289723, '1xhoB00', NULL, NULL, 117, NULL, NULL, 235743),
(289724, '2cwjA00', NULL, NULL, 123, NULL, NULL, 235743),
(289725, '3quwA00', NULL, NULL, 126, NULL, NULL, 235743),
(289726, '3gtzA00', NULL, NULL, 124, NULL, NULL, 235743),
(289727, '3lybC00', NULL, NULL, 165, NULL, NULL, 235743),
(289728, '6izhE00', NULL, NULL, 121, NULL, NULL, 235743),
(289729, '2cvlA00', NULL, NULL, 124, NULL, NULL, 235743),
(289730, '1ufyA00', NULL, NULL, 122, NULL, NULL, 235743),
(289731, '1x25A00', NULL, NULL, 128, NULL, NULL, 235743),
(289732, '1xrgA00', NULL, NULL, 125, NULL, NULL, 235743),
(289733, '3m1xA00', NULL, NULL, 126, NULL, NULL, 235743),
(289734, '2ewcB00', NULL, NULL, 126, NULL, NULL, 235743),
(289735, '3k0tC00', NULL, NULL, 124, NULL, NULL, 235743),
(289736, '3i7tA00', NULL, NULL, 120, NULL, NULL, 235743),
(289737, '3lmeC00', NULL, NULL, 138, NULL, NULL, 235743),
(289738, '2b33B00', NULL, NULL, 140, NULL, NULL, 235743),
(289739, '5y6uA00', NULL, NULL, 125, NULL, NULL, 235743),
(289740, '3i3fB00', NULL, NULL, 141, NULL, NULL, 235743),
(289741, '1oniB00', NULL, NULL, 138, NULL, NULL, 235743),
(289742, '1nq3D00', NULL, NULL, 136, NULL, NULL, 235743),
(289743, '2ig8A00', NULL, NULL, 144, NULL, NULL, 235743),
(289744, '1pf5A00', NULL, NULL, 131, NULL, NULL, 235743),
(289745, '1qahA00', NULL, NULL, 136, NULL, NULL, 235743),
(289746, '3r0pA00', NULL, NULL, 127, NULL, NULL, 235743),
(289747, '2otmA00', NULL, NULL, 154, NULL, NULL, 235743),
(289748, '1j7hA00', NULL, NULL, 130, NULL, NULL, 235743),
(289749, '4zk7A00', NULL, NULL, 130, NULL, NULL, 235743),
(289750, '3mx7A00', NULL, NULL, 90, NULL, NULL, 235744),
(289751, '2kd2A01', NULL, NULL, 84, NULL, NULL, 235744),
(289752, '2kw1A01', NULL, NULL, 84, NULL, NULL, 235744),
(289753, '1ezjA02', NULL, NULL, 52, NULL, NULL, 235745),
(289754, '2p9bA03', NULL, NULL, 130, NULL, NULL, 235746),
(289755, '1zhcA00', NULL, NULL, 76, NULL, NULL, 235747),
(289756, '4fx5A03', NULL, NULL, 103, NULL, NULL, 235748),
(289757, '6elqA03', NULL, NULL, 225, NULL, NULL, 235749),
(289758, '4udxX02', NULL, NULL, 169, NULL, NULL, 235749),
(289759, '4udxX03', NULL, NULL, 228, NULL, NULL, 235749),
(289760, '1gnlA03', NULL, NULL, 151, NULL, NULL, 235749),
(289761, '1gnlA04', NULL, NULL, 167, NULL, NULL, 235749),
(289762, '3cf4A02', NULL, NULL, 196, NULL, NULL, 235749),
(289763, '1ru3A02', NULL, NULL, 190, NULL, NULL, 235749),
(289764, '3i01A03', NULL, NULL, 228, NULL, NULL, 235749),
(289765, '6b6wA03', NULL, NULL, 214, NULL, NULL, 235749),
(289766, '1jqkA02', NULL, NULL, 169, NULL, NULL, 235749),
(289767, '6b6wA02', NULL, NULL, 171, NULL, NULL, 235749),
(289768, '1gntA03', NULL, NULL, 151, NULL, NULL, 235749),
(289769, '1gntA04', NULL, NULL, 173, NULL, NULL, 235749),
(289770, '1jqkA01', NULL, NULL, 228, NULL, NULL, 235749),
(289771, '1oaoA02', NULL, NULL, 157, NULL, NULL, 235749);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(289772, '1oaoC02', NULL, NULL, 190, NULL, NULL, 235749),
(289773, '6elqA02', NULL, NULL, 169, NULL, NULL, 235749),
(289774, '2qsdB02', NULL, NULL, 107, NULL, NULL, 235750),
(289775, '2p3yA02', NULL, NULL, 107, NULL, NULL, 235751),
(289776, '4a7kA02', NULL, NULL, 301, NULL, NULL, 235752),
(289777, '2xxlA01', NULL, NULL, 78, NULL, NULL, 235753),
(289778, '2ikdA00', NULL, NULL, 66, NULL, NULL, 235753),
(289779, '2ikeA00', NULL, NULL, 54, NULL, NULL, 235753),
(289780, '2k8oA00', NULL, NULL, 60, NULL, NULL, 235754),
(289781, '3m66A00', NULL, NULL, 270, NULL, NULL, 235755),
(289782, '2y73B03', NULL, NULL, 420, NULL, NULL, 235756),
(289783, '3hi7A03', NULL, NULL, 412, NULL, NULL, 235756),
(289784, '1w7cA01', NULL, NULL, 515, NULL, NULL, 235756),
(289785, '1ksiA03', NULL, NULL, 416, NULL, NULL, 235756),
(289786, '3sxxA03', NULL, NULL, 439, NULL, NULL, 235756),
(289787, '6grrA04', NULL, NULL, 410, NULL, NULL, 235756),
(289788, '3wa2X03', NULL, NULL, 424, NULL, NULL, 235756),
(289789, '3loyA03', NULL, NULL, 413, NULL, NULL, 235756),
(289790, '1tu5A03', NULL, NULL, 426, NULL, NULL, 235756),
(289791, '3pgbA01', NULL, NULL, 515, NULL, NULL, 235756),
(289792, '1vw5A00', NULL, NULL, 158, NULL, NULL, 235757),
(289793, '3fuyA00', NULL, NULL, 156, NULL, NULL, 235757),
(289794, '4djaA04', NULL, NULL, 76, NULL, NULL, 235758),
(289795, '3zxsA04', NULL, NULL, 70, NULL, NULL, 235758),
(289796, '4tq1A03', NULL, NULL, 58, NULL, NULL, 235759),
(289797, '2dyoA02', NULL, NULL, 60, NULL, NULL, 235759),
(289798, '3vqiC02', NULL, NULL, 72, NULL, NULL, 235759),
(289799, '4kgbB01', NULL, NULL, 237, NULL, NULL, 235760),
(289800, '4kgbA02', NULL, NULL, 217, NULL, NULL, 235760),
(289801, '3k6mD01', NULL, NULL, 233, NULL, NULL, 235760),
(289802, '3k6mC02', NULL, NULL, 214, NULL, NULL, 235760),
(289803, '3cdkB00', NULL, NULL, 219, NULL, NULL, 235760),
(289804, '3eh7A01', NULL, NULL, 188, NULL, NULL, 235760),
(289805, '3cdkC01', NULL, NULL, 229, NULL, NULL, 235760),
(289806, '1xr4A02', NULL, NULL, 270, NULL, NULL, 235760),
(289807, '1xr4B01', NULL, NULL, 238, NULL, NULL, 235760),
(289808, '1poiB00', NULL, NULL, 260, NULL, NULL, 235760),
(289809, '1poiA01', NULL, NULL, 264, NULL, NULL, 235760),
(289810, '3rrlB00', NULL, NULL, 207, NULL, NULL, 235760),
(289811, '3rrlA01', NULL, NULL, 229, NULL, NULL, 235760),
(289812, '2hj0A01', NULL, NULL, 274, NULL, NULL, 235760),
(289813, '1m3eA02', NULL, NULL, 215, NULL, NULL, 235760),
(289814, '2hj0A02', NULL, NULL, 245, NULL, NULL, 235760),
(289815, '3gk7A01', NULL, NULL, 184, NULL, NULL, 235760),
(289816, '2oasA01', NULL, NULL, 179, NULL, NULL, 235760),
(289817, '3dlxD01', NULL, NULL, 234, NULL, NULL, 235760),
(289818, '3d3uA01', NULL, NULL, 185, NULL, NULL, 235760),
(289819, '2ahuA02', NULL, NULL, 249, NULL, NULL, 235760),
(289820, '2ahuA01', NULL, NULL, 276, NULL, NULL, 235760),
(289821, '3dlxA02', NULL, NULL, 215, NULL, NULL, 235760),
(289822, '5dbnF00', NULL, NULL, 223, NULL, NULL, 235760),
(289823, '1k6dB00', NULL, NULL, 220, NULL, NULL, 235760),
(289824, '3upuA03', NULL, NULL, 131, NULL, NULL, 235761),
(289825, '2kdoA03', NULL, NULL, 80, NULL, NULL, 235762),
(289826, '4zckA02', NULL, NULL, 94, NULL, NULL, 235762),
(289827, '1darA05', NULL, NULL, 89, NULL, NULL, 235762),
(289828, '1n0uA05', NULL, NULL, 115, NULL, NULL, 235762),
(289829, '1zpwX00', NULL, NULL, 90, NULL, NULL, 235762),
(289830, '4qr2A00', NULL, NULL, 97, NULL, NULL, 235762),
(289831, '3e3xA02', NULL, NULL, 94, NULL, NULL, 235762),
(289832, '3ui3A02', NULL, NULL, 105, NULL, NULL, 235762),
(289833, '2ivyA01', NULL, NULL, 75, NULL, NULL, 235762),
(289834, '4fn5A05', NULL, NULL, 90, NULL, NULL, 235762),
(289835, '4tnoA01', NULL, NULL, 66, NULL, NULL, 235762),
(289836, '1vx4407', NULL, NULL, 69, NULL, NULL, 235762),
(289837, '1t95A03', NULL, NULL, 73, NULL, NULL, 235762),
(289838, '6fswA03', NULL, NULL, 73, NULL, NULL, 235762),
(289839, '4es1A00', NULL, NULL, 100, NULL, NULL, 235762),
(289840, '3b82A06', NULL, NULL, 121, NULL, NULL, 235762),
(289841, '1vi7A02', NULL, NULL, 80, NULL, NULL, 235762),
(289842, '6notA05', NULL, NULL, 83, NULL, NULL, 235762);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(289843, '3lh2U00', NULL, NULL, 76, NULL, NULL, 235762),
(289844, '3cb4A04', NULL, NULL, 111, NULL, NULL, 235762),
(289845, '2mzwA03', NULL, NULL, 102, NULL, NULL, 235762),
(289846, '2wbmA03', NULL, NULL, 70, NULL, NULL, 235762),
(289847, '2xexA05', NULL, NULL, 71, NULL, NULL, 235762),
(289848, '6n0iA05', NULL, NULL, 71, NULL, NULL, 235762),
(289849, '3oq2A00', NULL, NULL, 103, NULL, NULL, 235762),
(289850, '4makB00', NULL, NULL, 77, NULL, NULL, 235762),
(289851, '4qjty04', NULL, NULL, 114, NULL, NULL, 235762),
(289852, '2cveA02', NULL, NULL, 66, NULL, NULL, 235762),
(289853, '5h1oA00', NULL, NULL, 86, NULL, NULL, 235762),
(289854, '5g4dA01', NULL, NULL, 69, NULL, NULL, 235762),
(289855, '3excX01', NULL, NULL, 70, NULL, NULL, 235762),
(289856, '2yweA04', NULL, NULL, 114, NULL, NULL, 235762),
(289857, '1wc2A00', NULL, NULL, 181, NULL, NULL, 235763),
(289858, '2pnwA01', NULL, NULL, 212, NULL, NULL, 235763),
(289859, '5xbuA00', NULL, NULL, 190, NULL, NULL, 235763),
(289860, '4avrA00', NULL, NULL, 95, NULL, NULL, 235763),
(289861, '1bw3A00', NULL, NULL, 125, NULL, NULL, 235763),
(289862, '1n10A01', NULL, NULL, 124, NULL, NULL, 235763),
(289863, '2g5dA01', NULL, NULL, 201, NULL, NULL, 235763),
(289864, '2kqaA00', NULL, NULL, 129, NULL, NULL, 235763),
(289865, '5gm9A00', NULL, NULL, 213, NULL, NULL, 235763),
(289866, '4jp6A00', NULL, NULL, 122, NULL, NULL, 235763),
(289867, '3m3gA00', NULL, NULL, 120, NULL, NULL, 235763),
(289868, '3sujA00', NULL, NULL, 127, NULL, NULL, 235763),
(289869, '3d30A01', NULL, NULL, 108, NULL, NULL, 235763),
(289870, '3sumB00', NULL, NULL, 136, NULL, NULL, 235763),
(289871, '3sukA00', NULL, NULL, 125, NULL, NULL, 235763),
(289872, '4jcwA01', NULL, NULL, 104, NULL, NULL, 235763),
(289873, '3x2mA00', NULL, NULL, 180, NULL, NULL, 235763),
(289874, '3sulA00', NULL, NULL, 122, NULL, NULL, 235763),
(289875, '2hczX01', NULL, NULL, 141, NULL, NULL, 235763),
(289876, '3czbA01', NULL, NULL, 190, NULL, NULL, 235763),
(289877, '5h4uA00', NULL, NULL, 215, NULL, NULL, 235763),
(289878, '1l8fA00', NULL, NULL, 207, NULL, NULL, 235763),
(289879, '2engA00', NULL, NULL, 210, NULL, NULL, 235763),
(289880, '2ae0X01', NULL, NULL, 188, NULL, NULL, 235763),
(289881, '1fbtA00', NULL, NULL, 190, NULL, NULL, 235764),
(289882, '5vveA00', NULL, NULL, 258, NULL, NULL, 235764),
(289883, '2gfiA02', NULL, NULL, 248, NULL, NULL, 235764),
(289884, '3pgmA00', NULL, NULL, 244, NULL, NULL, 235764),
(289885, '6hviA02', NULL, NULL, 203, NULL, NULL, 235764),
(289886, '3k4qA01', NULL, NULL, 391, NULL, NULL, 235764),
(289887, '2rflH00', NULL, NULL, 173, NULL, NULL, 235764),
(289888, '1v37A00', NULL, NULL, 177, NULL, NULL, 235764),
(289889, '2yn0A00', NULL, NULL, 271, NULL, NULL, 235764),
(289890, '2hhjB00', NULL, NULL, 267, NULL, NULL, 235764),
(289891, '2a6pA00', NULL, NULL, 208, NULL, NULL, 235764),
(289892, '4aruA01', NULL, NULL, 288, NULL, NULL, 235764),
(289893, '3zhcA01', NULL, NULL, 283, NULL, NULL, 235764),
(289894, '4aruA02', NULL, NULL, 125, NULL, NULL, 235764),
(289895, '5wdiB00', NULL, NULL, 265, NULL, NULL, 235764),
(289896, '4odiD00', NULL, NULL, 232, NULL, NULL, 235764),
(289897, '3r7aB00', NULL, NULL, 237, NULL, NULL, 235764),
(289898, '1dkqA02', NULL, NULL, 124, NULL, NULL, 235764),
(289899, '1qfxA02', NULL, NULL, 258, NULL, NULL, 235764),
(289900, '4hbzA00', NULL, NULL, 186, NULL, NULL, 235764),
(289901, '6nruI00', NULL, NULL, 206, NULL, NULL, 235764),
(289902, '5hr5A02', NULL, NULL, 203, NULL, NULL, 235764),
(289903, '3eozB01', NULL, NULL, 183, NULL, NULL, 235764),
(289904, '1qhfA00', NULL, NULL, 240, NULL, NULL, 235764),
(289905, '3gp3C00', NULL, NULL, 238, NULL, NULL, 235764),
(289906, '5um0A00', NULL, NULL, 235, NULL, NULL, 235764),
(289907, '3ntlB01', NULL, NULL, 251, NULL, NULL, 235764),
(289908, '4embB00', NULL, NULL, 249, NULL, NULL, 235764),
(289909, '4pzaB00', NULL, NULL, 223, NULL, NULL, 235764),
(289910, '4tsrA01', NULL, NULL, 286, NULL, NULL, 235764),
(289911, '3mxoB00', NULL, NULL, 202, NULL, NULL, 235764),
(289912, '5cdhG00', NULL, NULL, 336, NULL, NULL, 235764),
(289913, '3c7tA01', NULL, NULL, 242, NULL, NULL, 235764);
INSERT INTO "PUBLIC"."MODEL" VALUES
(289914, '1k6mA02', NULL, NULL, 221, NULL, NULL, 235764),
(289915, '2yn2A00', NULL, NULL, 279, NULL, NULL, 235764),
(289916, '2qniA01', NULL, NULL, 213, NULL, NULL, 235764),
(289917, '3kkkB00', NULL, NULL, 239, NULL, NULL, 235764),
(289918, '1nt4A01', NULL, NULL, 244, NULL, NULL, 235764),
(289919, '1nt4A02', NULL, NULL, 147, NULL, NULL, 235764),
(289920, '3it3B00', NULL, NULL, 342, NULL, NULL, 235764),
(289921, '3mbkA01', NULL, NULL, 243, NULL, NULL, 235764),
(289922, '4gpzB00', NULL, NULL, 236, NULL, NULL, 235764),
(289923, '3e9dB00', NULL, NULL, 265, NULL, NULL, 235764),
(289924, '1h2eA00', NULL, NULL, 207, NULL, NULL, 235764),
(289925, '4eo9A00', NULL, NULL, 243, NULL, NULL, 235764),
(289926, '1nd6A00', NULL, NULL, 354, NULL, NULL, 235764),
(289927, '3zhcB02', NULL, NULL, 123, NULL, NULL, 235764),
(289928, '1bifA02', NULL, NULL, 221, NULL, NULL, 235764),
(289929, '4jocA00', NULL, NULL, 396, NULL, NULL, 235764),
(289930, '3fjyA02', NULL, NULL, 182, NULL, NULL, 235764),
(289931, '3f3kA00', NULL, NULL, 265, NULL, NULL, 235764),
(289932, '4ij5A00', NULL, NULL, 211, NULL, NULL, 235764),
(289933, '1fztA00', NULL, NULL, 211, NULL, NULL, 235764),
(289934, '1rpaA00', NULL, NULL, 342, NULL, NULL, 235764),
(289935, '3f2iF00', NULL, NULL, 172, NULL, NULL, 235764),
(289936, '2wnhA00', NULL, NULL, 418, NULL, NULL, 235764),
(289937, '3d8hB00', NULL, NULL, 250, NULL, NULL, 235764),
(289938, '1qwoA01', NULL, NULL, 390, NULL, NULL, 235764),
(289939, '6e4bA00', NULL, NULL, 204, NULL, NULL, 235764),
(289940, '3d4iB01', NULL, NULL, 252, NULL, NULL, 235764),
(289941, '1riiB00', NULL, NULL, 239, NULL, NULL, 235764),
(289942, '3hjgA00', NULL, NULL, 213, NULL, NULL, 235764),
(289943, '4arvA02', NULL, NULL, 126, NULL, NULL, 235764),
(289944, '5cu7A00', NULL, NULL, 405, NULL, NULL, 235764),
(289945, '4arvA01', NULL, NULL, 283, NULL, NULL, 235764),
(289946, '3ntlA02', NULL, NULL, 147, NULL, NULL, 235764),
(289947, '3dcyA00', NULL, NULL, 275, NULL, NULL, 235764),
(289948, '1ujcA00', NULL, NULL, 161, NULL, NULL, 235764),
(289949, '1e59A00', NULL, NULL, 249, NULL, NULL, 235764),
(289950, '2it2B00', NULL, NULL, 200, NULL, NULL, 235765),
(289951, '2dvkA00', NULL, NULL, 171, NULL, NULL, 235765),
(289952, '1tljB00', NULL, NULL, 192, NULL, NULL, 235765),
(289953, '2qg3B00', NULL, NULL, 208, NULL, NULL, 235765),
(289954, '3rfrA03', NULL, NULL, 141, NULL, NULL, 235766),
(289955, '4phzA03', NULL, NULL, 142, NULL, NULL, 235766),
(289956, '1yewA03', NULL, NULL, 136, NULL, NULL, 235766),
(289957, '3chxA03', NULL, NULL, 137, NULL, NULL, 235766),
(289958, '6cxhA03', NULL, NULL, 136, NULL, NULL, 235766),
(289959, '2zouB00', NULL, NULL, 149, NULL, NULL, 235767),
(289960, '2mkvA00', NULL, NULL, 64, NULL, NULL, 235768),
(289961, '2jo1A00', NULL, NULL, 72, NULL, NULL, 235768),
(289962, '1y9bA00', NULL, NULL, 90, NULL, NULL, 235768),
(289963, '2jp3A00', NULL, NULL, 67, NULL, NULL, 235768),
(289964, '1pzrA00', NULL, NULL, 60, NULL, NULL, 235769),
(289965, '3tekA00', NULL, NULL, 148, NULL, NULL, 235770),
(289966, '3vkgA09', NULL, NULL, 148, NULL, NULL, 235771),
(289967, '3vkhA09', NULL, NULL, 188, NULL, NULL, 235771),
(289968, '4akgA10', NULL, NULL, 189, NULL, NULL, 235771),
(289969, '2mblA01', NULL, NULL, 108, NULL, NULL, 235772),
(289970, '1qysA00', NULL, NULL, 106, NULL, NULL, 235772),
(289971, '2n41A00', NULL, NULL, 106, NULL, NULL, 235772),
(289972, '2mraA00', NULL, NULL, 117, NULL, NULL, 235772),
(289973, '2jvfA00', NULL, NULL, 96, NULL, NULL, 235772),
(289974, '4i5lB01', NULL, NULL, 103, NULL, NULL, 235773),
(289975, '4mewA01', NULL, NULL, 94, NULL, NULL, 235773),
(289976, '6es5B00', NULL, NULL, 50, NULL, NULL, 235774),
(289977, '6es7B00', NULL, NULL, 50, NULL, NULL, 235774),
(289978, '6es6B00', NULL, NULL, 50, NULL, NULL, 235774),
(289979, '1zoqC00', NULL, NULL, 47, NULL, NULL, 235774),
(289980, '2xz2A00', NULL, NULL, 66, NULL, NULL, 235775),
(289981, '4ltyA02', NULL, NULL, 64, NULL, NULL, 235776),
(289982, '1wznA02', NULL, NULL, 63, NULL, NULL, 235777),
(289983, '3d2lA02', NULL, NULL, 63, NULL, NULL, 235777),
(289984, '1y8cA02', NULL, NULL, 60, NULL, NULL, 235777);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(289985, '1k87A01', NULL, NULL, 52, NULL, NULL, 235778),
(289986, '3ivtA02', NULL, NULL, 118, NULL, NULL, 235779),
(289987, '1vwxW00', NULL, NULL, 63, NULL, NULL, 235780),
(289988, '6qklG00', NULL, NULL, 69, NULL, NULL, 235780),
(289989, '4a17T00', NULL, NULL, 62, NULL, NULL, 235780),
(289990, '1vq8U00', NULL, NULL, 66, NULL, NULL, 235780),
(289991, '3o58V00', NULL, NULL, 59, NULL, NULL, 235780),
(289992, '3g6eU00', NULL, NULL, 53, NULL, NULL, 235780),
(289993, '1vx7000', NULL, NULL, 69, NULL, NULL, 235780),
(289994, '3r84J00', NULL, NULL, 92, NULL, NULL, 235781),
(289995, '1wazA00', NULL, NULL, 46, NULL, NULL, 235782),
(289996, '2lj2A00', NULL, NULL, 60, NULL, NULL, 235782),
(289997, '2m67A00', NULL, NULL, 81, NULL, NULL, 235782),
(289998, '1n93X01', NULL, NULL, 208, NULL, NULL, 235783),
(289999, '1s5jA05', NULL, NULL, 62, NULL, NULL, 235784),
(290000, '2hsnA01', NULL, NULL, 53, NULL, NULL, 235785),
(290001, '2aj2A01', NULL, NULL, 102, NULL, NULL, 235786),
(290002, '2ew0A00', NULL, NULL, 192, NULL, NULL, 235786),
(290003, '2hafA01', NULL, NULL, 102, NULL, NULL, 235786),
(290004, '2gs5A01', NULL, NULL, 189, NULL, NULL, 235786),
(290005, '2do8A01', NULL, NULL, 169, NULL, NULL, 235786),
(290006, '2muiA00', NULL, NULL, 189, NULL, NULL, 235786),
(290007, '2gzoA01', NULL, NULL, 106, NULL, NULL, 235786),
(290008, '3wknF00', NULL, NULL, 54, NULL, NULL, 235787),
(290009, '5gnpA01', NULL, NULL, 78, NULL, NULL, 235788),
(290010, '5dkoA01', NULL, NULL, 78, NULL, NULL, 235788),
(290011, '2oezA01', NULL, NULL, 80, NULL, NULL, 235788),
(290012, '2b1yA00', NULL, NULL, 104, NULL, NULL, 235789),
(290013, '1goiB03', NULL, NULL, 51, NULL, NULL, 235790),
(290014, '2rtsA00', NULL, NULL, 73, NULL, NULL, 235790),
(290015, '1aiwA00', NULL, NULL, 62, NULL, NULL, 235790),
(290016, '4tx8A01', NULL, NULL, 53, NULL, NULL, 235790),
(290017, '1wvvB01', NULL, NULL, 50, NULL, NULL, 235790),
(290018, '4mb4A04', NULL, NULL, 45, NULL, NULL, 235790),
(290019, '1ed7A00', NULL, NULL, 45, NULL, NULL, 235790),
(290020, '4ifdK02', NULL, NULL, 34, NULL, NULL, 235791),
(290021, '2dlaA01', NULL, NULL, 160, NULL, NULL, 235792),
(290022, '2bw2A01', NULL, NULL, 55, NULL, NULL, 235793),
(290023, '5aa6A00', NULL, NULL, 597, NULL, NULL, 235794),
(290024, '3bb0A02', NULL, NULL, 401, NULL, NULL, 235794),
(290025, '1qi9A00', NULL, NULL, 556, NULL, NULL, 235794),
(290026, '1up8A00', NULL, NULL, 598, NULL, NULL, 235794),
(290027, '5lpcA00', NULL, NULL, 639, NULL, NULL, 235794),
(290028, '1qhbA00', NULL, NULL, 596, NULL, NULL, 235794),
(290029, '1auaA02', NULL, NULL, 83, NULL, NULL, 235795),
(290030, '3q8gA01', NULL, NULL, 92, NULL, NULL, 235795),
(290031, '3hy5A01', NULL, NULL, 101, NULL, NULL, 235795),
(290032, '3hx3A01', NULL, NULL, 67, NULL, NULL, 235795),
(290033, '3w68B01', NULL, NULL, 68, NULL, NULL, 235795),
(290034, '1r5lA01', NULL, NULL, 64, NULL, NULL, 235795),
(290035, '1oizB01', NULL, NULL, 80, NULL, NULL, 235795),
(290036, '2bu3B00', NULL, NULL, 212, NULL, NULL, 235796),
(290037, '5x6nA02', NULL, NULL, 124, NULL, NULL, 235797),
(290038, '2y8dA02', NULL, NULL, 131, NULL, NULL, 235797),
(290039, '4nuuA02', NULL, NULL, 124, NULL, NULL, 235797),
(290040, '3c64A00', NULL, NULL, 179, NULL, NULL, 235797),
(290041, '2wauA02', NULL, NULL, 129, NULL, NULL, 235797),
(290042, '2zc2A00', NULL, NULL, 78, NULL, NULL, 235798),
(290043, '2i5uA00', NULL, NULL, 83, NULL, NULL, 235798),
(290044, '2i1sA00', NULL, NULL, 188, NULL, NULL, 235799),
(290045, '3ushB00', NULL, NULL, 129, NULL, NULL, 235800),
(290046, '4iohA00', NULL, NULL, 134, NULL, NULL, 235800),
(290047, '5c24A02', NULL, NULL, 90, NULL, NULL, 235801),
(290048, '3hvaA00', NULL, NULL, 177, NULL, NULL, 235801),
(290049, '3fqlA03', NULL, NULL, 122, NULL, NULL, 235801),
(290050, '3lp1B03', NULL, NULL, 105, NULL, NULL, 235801),
(290051, '4kseB03', NULL, NULL, 59, NULL, NULL, 235801),
(290052, '4kseB02', NULL, NULL, 99, NULL, NULL, 235801),
(290053, '3lp1B04', NULL, NULL, 85, NULL, NULL, 235801),
(290054, '4dg1B04', NULL, NULL, 110, NULL, NULL, 235801),
(290055, '3ungC03', NULL, NULL, 142, NULL, NULL, 235801);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(290056, '3breB02', NULL, NULL, 185, NULL, NULL, 235801),
(290057, '3ignA00', NULL, NULL, 177, NULL, NULL, 235801),
(290058, '1hysB03', NULL, NULL, 77, NULL, NULL, 235801),
(290059, '3gqcC01', NULL, NULL, 171, NULL, NULL, 235801),
(290060, '4wxwA00', NULL, NULL, 165, NULL, NULL, 235801),
(290061, '3hvwA00', NULL, NULL, 176, NULL, NULL, 235801),
(290062, '6eibD00', NULL, NULL, 163, NULL, NULL, 235801),
(290063, '1jlcB04', NULL, NULL, 64, NULL, NULL, 235801),
(290064, '4ol8B03', NULL, NULL, 90, NULL, NULL, 235801),
(290065, '1sv5B02', NULL, NULL, 99, NULL, NULL, 235801),
(290066, '4ol8B01', NULL, NULL, 131, NULL, NULL, 235801),
(290067, '4uw2B03', NULL, NULL, 142, NULL, NULL, 235801),
(290068, '1jlcB03', NULL, NULL, 133, NULL, NULL, 235801),
(290069, '1ra6A02', NULL, NULL, 106, NULL, NULL, 235801),
(290070, '1harA02', NULL, NULL, 69, NULL, NULL, 235801),
(290071, '1xr5A02', NULL, NULL, 106, NULL, NULL, 235801),
(290072, '1mu2A02', NULL, NULL, 94, NULL, NULL, 235801),
(290073, '1mu2A03', NULL, NULL, 94, NULL, NULL, 235801),
(290074, '3qipA02', NULL, NULL, 94, NULL, NULL, 235801),
(290075, '1c0tB02', NULL, NULL, 59, NULL, NULL, 235801),
(290076, '5kfnA01', NULL, NULL, 184, NULL, NULL, 235801),
(290077, '1rthB04', NULL, NULL, 111, NULL, NULL, 235801),
(290078, '5m3cA01', NULL, NULL, 173, NULL, NULL, 235801),
(290079, '6cstA02', NULL, NULL, 120, NULL, NULL, 235801),
(290080, '2opsB03', NULL, NULL, 131, NULL, NULL, 235801),
(290081, '2ckwA03', NULL, NULL, 125, NULL, NULL, 235801),
(290082, '5ziuA02', NULL, NULL, 106, NULL, NULL, 235801),
(290083, '2opsB02', NULL, NULL, 49, NULL, NULL, 235801),
(290084, '2qv6B02', NULL, NULL, 122, NULL, NULL, 235801),
(290085, '5c24B02', NULL, NULL, 99, NULL, NULL, 235801),
(290086, '4f4wB01', NULL, NULL, 100, NULL, NULL, 235801),
(290087, '4zveA00', NULL, NULL, 172, NULL, NULL, 235801),
(290088, '3iclB00', NULL, NULL, 171, NULL, NULL, 235801),
(290089, '4dezA01', NULL, NULL, 100, NULL, NULL, 235801),
(290090, '1xr6A02', NULL, NULL, 108, NULL, NULL, 235801),
(290091, '3dlkB03', NULL, NULL, 75, NULL, NULL, 235801),
(290092, '3dlkB02', NULL, NULL, 110, NULL, NULL, 235801),
(290093, '4zhrA02', NULL, NULL, 94, NULL, NULL, 235801),
(290094, '4zhrA03', NULL, NULL, 94, NULL, NULL, 235801),
(290095, '5f8hA02', NULL, NULL, 106, NULL, NULL, 235801),
(290096, '4zpcA02', NULL, NULL, 106, NULL, NULL, 235801),
(290097, '4ol8A01', NULL, NULL, 145, NULL, NULL, 235801),
(290098, '2xhwA03', NULL, NULL, 81, NULL, NULL, 235801),
(290099, '6mihA01', NULL, NULL, 146, NULL, NULL, 235801),
(290100, '4urgA00', NULL, NULL, 150, NULL, NULL, 235801),
(290101, '4zmuA02', NULL, NULL, 155, NULL, NULL, 235801),
(290102, '2cjqA03', NULL, NULL, 102, NULL, NULL, 235801),
(290103, '3pjxA01', NULL, NULL, 181, NULL, NULL, 235801),
(290104, '4rnhA01', NULL, NULL, 173, NULL, NULL, 235801),
(290105, '4iobA00', NULL, NULL, 161, NULL, NULL, 235801),
(290106, '1khvA03', NULL, NULL, 130, NULL, NULL, 235801),
(290107, '1ikxB02', NULL, NULL, 104, NULL, NULL, 235801),
(290108, '4nldA02', NULL, NULL, 119, NULL, NULL, 235801),
(290109, '3qyyA00', NULL, NULL, 167, NULL, NULL, 235801),
(290110, '4nyzA02', NULL, NULL, 139, NULL, NULL, 235801),
(290111, '4zhrB02', NULL, NULL, 94, NULL, NULL, 235801),
(290112, '3dlkA02', NULL, NULL, 94, NULL, NULL, 235801),
(290113, '1s48A04', NULL, NULL, 111, NULL, NULL, 235801),
(290114, '2xhvB02', NULL, NULL, 86, NULL, NULL, 235801),
(290115, '1c9rA03', NULL, NULL, 94, NULL, NULL, 235801),
(290116, '1c9rA02', NULL, NULL, 94, NULL, NULL, 235801),
(290117, '4tqrA01', NULL, NULL, 98, NULL, NULL, 235801),
(290118, '3mtkA00', NULL, NULL, 178, NULL, NULL, 235801),
(290119, '1s1tA02', NULL, NULL, 94, NULL, NULL, 235801),
(290120, '3mfiA01', NULL, NULL, 209, NULL, NULL, 235801),
(290121, '4ymeA00', NULL, NULL, 158, NULL, NULL, 235801),
(290122, '3tvkA00', NULL, NULL, 179, NULL, NULL, 235801),
(290123, '5wm1A02', NULL, NULL, 109, NULL, NULL, 235801),
(290124, '3ezuA02', NULL, NULL, 153, NULL, NULL, 235801),
(290125, '3uqsA03', NULL, NULL, 123, NULL, NULL, 235801),
(290126, '3h5xA03', NULL, NULL, 123, NULL, NULL, 235801);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(290127, '5yuyA01', NULL, NULL, 122, NULL, NULL, 235801),
(290128, '3i5cA02', NULL, NULL, 176, NULL, NULL, 235801),
(290129, '4g1qA04', NULL, NULL, 107, NULL, NULL, 235801),
(290130, '4g1qA02', NULL, NULL, 94, NULL, NULL, 235801),
(290131, '4g1qA03', NULL, NULL, 94, NULL, NULL, 235801),
(290132, '3i5aA02', NULL, NULL, 181, NULL, NULL, 235801),
(290133, '1jkhA02', NULL, NULL, 94, NULL, NULL, 235801),
(290134, '2haiA03', NULL, NULL, 121, NULL, NULL, 235801),
(290135, '3hkwA03', NULL, NULL, 122, NULL, NULL, 235801),
(290136, '1yvfA03', NULL, NULL, 122, NULL, NULL, 235801),
(290137, '1xr7A02', NULL, NULL, 108, NULL, NULL, 235801),
(290138, '1c9rB03', NULL, NULL, 79, NULL, NULL, 235801),
(290139, '5euhC00', NULL, NULL, 172, NULL, NULL, 235801),
(290140, '2v0nB02', NULL, NULL, 172, NULL, NULL, 235801),
(290141, '3gv5B01', NULL, NULL, 132, NULL, NULL, 235801),
(290142, '2yngB03', NULL, NULL, 75, NULL, NULL, 235801),
(290143, '2yngB02', NULL, NULL, 111, NULL, NULL, 235801),
(290144, '3hhkA03', NULL, NULL, 120, NULL, NULL, 235801),
(290145, '4wywA02', NULL, NULL, 142, NULL, NULL, 235801),
(290146, '1mu2B04', NULL, NULL, 106, NULL, NULL, 235801),
(290147, '4hkqA01', NULL, NULL, 144, NULL, NULL, 235801),
(290148, '4g1qB02', NULL, NULL, 94, NULL, NULL, 235801),
(290149, '1tbaA00', NULL, NULL, 67, NULL, NULL, 235802),
(290150, '3s0xA02', NULL, NULL, 79, NULL, NULL, 235803),
(290151, '3u13A02', NULL, NULL, 55, NULL, NULL, 235804),
(290152, '4mumA02', NULL, NULL, 55, NULL, NULL, 235804),
(290153, '3bwvA02', NULL, NULL, 49, NULL, NULL, 235804),
(290154, '3bwvB02', NULL, NULL, 49, NULL, NULL, 235804),
(290155, '4l57A02', NULL, NULL, 55, NULL, NULL, 235804),
(290156, '2jarA02', NULL, NULL, 55, NULL, NULL, 235804),
(290157, '3hlzA02', NULL, NULL, 129, NULL, NULL, 235805),
(290158, '1qx8A00', NULL, NULL, 58, NULL, NULL, 235806),
(290159, '3zbeA00', NULL, NULL, 71, NULL, NULL, 235807),
(290160, '3aqpA02', NULL, NULL, 166, NULL, NULL, 235808),
(290161, '5xapA02', NULL, NULL, 162, NULL, NULL, 235808),
(290162, '1jk4A00', NULL, NULL, 89, NULL, NULL, 235809),
(290163, '2hnuA00', NULL, NULL, 81, NULL, NULL, 235809),
(290164, '5iz2B01', NULL, NULL, 127, NULL, NULL, 235810),
(290165, '2mx8A01', NULL, NULL, 113, NULL, NULL, 235810),
(290166, '2k3qA00', NULL, NULL, 118, NULL, NULL, 235810),
(290167, '3lr2A01', NULL, NULL, 125, NULL, NULL, 235810),
(290168, '2n3eA01', NULL, NULL, 115, NULL, NULL, 235810),
(290169, '1j9jA00', NULL, NULL, 247, NULL, NULL, 235811),
(290170, '2wqkA00', NULL, NULL, 251, NULL, NULL, 235811),
(290171, '2e6cA00', NULL, NULL, 244, NULL, NULL, 235811),
(290172, '3ty2A00', NULL, NULL, 261, NULL, NULL, 235811),
(290173, '5ksrB00', NULL, NULL, 270, NULL, NULL, 235811),
(290174, '4zg5A00', NULL, NULL, 263, NULL, NULL, 235811),
(290175, '1l5xA00', NULL, NULL, 280, NULL, NULL, 235811),
(290176, '4xepA00', NULL, NULL, 267, NULL, NULL, 235811),
(290177, '2xqyA01', NULL, NULL, 191, NULL, NULL, 235812),
(290178, '2es9A00', NULL, NULL, 115, NULL, NULL, 235813),
(290179, '3oeiE02', NULL, NULL, 37, NULL, NULL, 235814),
(290180, '2a6qA02', NULL, NULL, 34, NULL, NULL, 235814),
(290181, '4ws9A01', NULL, NULL, 154, NULL, NULL, 235815),
(290182, '4l4qB01', NULL, NULL, 149, NULL, NULL, 235815),
(290183, '4l7iA01', NULL, NULL, 148, NULL, NULL, 235815),
(290184, '1zr6A04', NULL, NULL, 29, NULL, NULL, 235816),
(290185, '1yj7B01', NULL, NULL, 72, NULL, NULL, 235817),
(290186, '4w4mH00', NULL, NULL, 78, NULL, NULL, 235817),
(290187, '2mkyA00', NULL, NULL, 58, NULL, NULL, 235817),
(290188, '6ijfC02', NULL, NULL, 70, NULL, NULL, 235818),
(290189, '4bi3A02', NULL, NULL, 72, NULL, NULL, 235818),
(290190, '4m8rA01', NULL, NULL, 112, NULL, NULL, 235819),
(290191, '1sr8A02', NULL, NULL, 153, NULL, NULL, 235820),
(290192, '1wteA02', NULL, NULL, 124, NULL, NULL, 235821),
(290193, '3kxeC01', NULL, NULL, 78, NULL, NULL, 235822),
(290194, '3s1sA02', NULL, NULL, 407, NULL, NULL, 235823),
(290195, '1a9xA02', NULL, NULL, 217, NULL, NULL, 235824),
(290196, '1gsaA02', NULL, NULL, 121, NULL, NULL, 235824),
(290197, '5ks8A00', NULL, NULL, 405, NULL, NULL, 235824); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(290198, '1a9xA06', NULL, NULL, 203, NULL, NULL, 235824),
(290199, '3nuaA02', NULL, NULL, 136, NULL, NULL, 235824),
(290200, '3mjfA03', NULL, NULL, 139, NULL, NULL, 235824),
(290201, '4fu0A02', NULL, NULL, 160, NULL, NULL, 235824),
(290202, '3ufxB01', NULL, NULL, 154, NULL, NULL, 235824),
(290203, '4e4tA03', NULL, NULL, 202, NULL, NULL, 235824),
(290204, '2fb9A02', NULL, NULL, 152, NULL, NULL, 235824),
(290205, '2i87B02', NULL, NULL, 174, NULL, NULL, 235824),
(290206, '5jvjA03', NULL, NULL, 98, NULL, NULL, 235824),
(290207, '3va7A02', NULL, NULL, 244, NULL, NULL, 235824),
(290208, '5oesA02', NULL, NULL, 108, NULL, NULL, 235824),
(290209, '5hv6A02', NULL, NULL, 130, NULL, NULL, 235824),
(290210, '3q2oA03', NULL, NULL, 190, NULL, NULL, 235824),
(290211, '3lp8A03', NULL, NULL, 138, NULL, NULL, 235824),
(290212, '5tdeA01', NULL, NULL, 160, NULL, NULL, 235824),
(290213, '1ulzA03', NULL, NULL, 250, NULL, NULL, 235824),
(290214, '2olsA02', NULL, NULL, 165, NULL, NULL, 235824),
(290215, '2yrxA03', NULL, NULL, 136, NULL, NULL, 235824),
(290216, '3vpbB03', NULL, NULL, 112, NULL, NULL, 235824),
(290217, '4hnvB01', NULL, NULL, 346, NULL, NULL, 235824),
(290218, '4egjC02', NULL, NULL, 152, NULL, NULL, 235824),
(290219, '4rcnA01', NULL, NULL, 403, NULL, NULL, 235824),
(290220, '5dmxB02', NULL, NULL, 201, NULL, NULL, 235824),
(290221, '1auvA03', NULL, NULL, 119, NULL, NULL, 235824),
(290222, '4mamB03', NULL, NULL, 196, NULL, NULL, 235824),
(290223, '1i7nA03', NULL, NULL, 119, NULL, NULL, 235824),
(290224, '4yj3F02', NULL, NULL, 191, NULL, NULL, 235824),
(290225, '2xclA03', NULL, NULL, 136, NULL, NULL, 235824),
(290226, '2r7kA02', NULL, NULL, 186, NULL, NULL, 235824),
(290227, '2z04B03', NULL, NULL, 195, NULL, NULL, 235824),
(290228, '1vbgA03', NULL, NULL, 98, NULL, NULL, 235824),
(290229, '1kblA06', NULL, NULL, 98, NULL, NULL, 235824),
(290230, '2pbzA02', NULL, NULL, 181, NULL, NULL, 235824),
(290231, '3vpdA03', NULL, NULL, 109, NULL, NULL, 235824),
(290232, '5bphA02', NULL, NULL, 149, NULL, NULL, 235824),
(290233, '2gqsA02', NULL, NULL, 136, NULL, NULL, 235824),
(290234, '3tiiB02', NULL, NULL, 191, NULL, NULL, 235824),
(290235, '3hblC03', NULL, NULL, 254, NULL, NULL, 235824),
(290236, '1m0wA02', NULL, NULL, 108, NULL, NULL, 235824),
(290237, '2yw2A03', NULL, NULL, 136, NULL, NULL, 235824),
(290238, '4egqB02', NULL, NULL, 151, NULL, NULL, 235824),
(290239, '3r9rA02', NULL, NULL, 145, NULL, NULL, 235824),
(290240, '3ethA02', NULL, NULL, 223, NULL, NULL, 235824),
(290241, '3votB02', NULL, NULL, 323, NULL, NULL, 235824),
(290242, '1vkzA03', NULL, NULL, 134, NULL, NULL, 235824),
(290243, '4fe2A02', NULL, NULL, 136, NULL, NULL, 235824),
(290244, '5d8dE02', NULL, NULL, 155, NULL, NULL, 235824),
(290245, '2pvpA02', NULL, NULL, 146, NULL, NULL, 235824),
(290246, '1bxrC02', NULL, NULL, 285, NULL, NULL, 235824),
(290247, '4egjD02', NULL, NULL, 172, NULL, NULL, 235824),
(290248, '3u55A02', NULL, NULL, 136, NULL, NULL, 235824),
(290249, '3orqA02', NULL, NULL, 214, NULL, NULL, 235824),
(290250, '2x0sA03', NULL, NULL, 121, NULL, NULL, 235824),
(290251, '1uc8A03', NULL, NULL, 108, NULL, NULL, 235824),
(290252, '4xymB01', NULL, NULL, 152, NULL, NULL, 235824),
(290253, '5dmxA02', NULL, NULL, 150, NULL, NULL, 235824),
(290254, '3n6rG03', NULL, NULL, 256, NULL, NULL, 235824),
(290255, '2p0aA02', NULL, NULL, 119, NULL, NULL, 235824),
(290256, '5h80B03', NULL, NULL, 263, NULL, NULL, 235824),
(290257, '1pk8A03', NULL, NULL, 119, NULL, NULL, 235824),
(290258, '3k5iA03', NULL, NULL, 198, NULL, NULL, 235824),
(290259, '3kalA02', NULL, NULL, 108, NULL, NULL, 235824),
(290260, '6f7cF02', NULL, NULL, 229, NULL, NULL, 235824),
(290261, '5k2mA03', NULL, NULL, 108, NULL, NULL, 235824),
(290262, '3ax6A03', NULL, NULL, 196, NULL, NULL, 235824),
(290263, '1z2nX02', NULL, NULL, 109, NULL, NULL, 235824),
(290264, '3wnzA03', NULL, NULL, 144, NULL, NULL, 235824),
(290265, '6dgiA02', NULL, NULL, 144, NULL, NULL, 235824),
(290266, '1kutA02', NULL, NULL, 133, NULL, NULL, 235824),
(290267, '2cnqA02', NULL, NULL, 146, NULL, NULL, 235824),
(290268, '3g8dA02', NULL, NULL, 241, NULL, NULL, 235824);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(290269, '2ywvA02', NULL, NULL, 137, NULL, NULL, 235824),
(290270, '1t36A06', NULL, NULL, 271, NULL, NULL, 235824),
(290271, '4fflA02', NULL, NULL, 269, NULL, NULL, 235824),
(290272, '1e4eA01', NULL, NULL, 158, NULL, NULL, 235824),
(290273, '5zctA03', NULL, NULL, 126, NULL, NULL, 235824),
(290274, '3kreA02', NULL, NULL, 140, NULL, NULL, 235824),
(290275, '4qslD01', NULL, NULL, 430, NULL, NULL, 235824),
(290276, '2hgsA02', NULL, NULL, 111, NULL, NULL, 235824),
(290277, '2nu8B01', NULL, NULL, 155, NULL, NULL, 235824),
(290278, '4eg0B02', NULL, NULL, 152, NULL, NULL, 235824),
(290279, '1kjqB03', NULL, NULL, 194, NULL, NULL, 235824),
(290280, '2vqdA02', NULL, NULL, 286, NULL, NULL, 235824),
(290281, '2q7dA02', NULL, NULL, 206, NULL, NULL, 235824),
(290282, '3i12A02', NULL, NULL, 166, NULL, NULL, 235824),
(290283, '3u9tA02', NULL, NULL, 299, NULL, NULL, 235824),
(290284, '3lwbA02', NULL, NULL, 147, NULL, NULL, 235824),
(290285, '3t7aA02', NULL, NULL, 202, NULL, NULL, 235824),
(290286, '5vevA03', NULL, NULL, 139, NULL, NULL, 235824),
(290287, '4izoA03', NULL, NULL, 202, NULL, NULL, 235824),
(290288, '3tqtA02', NULL, NULL, 173, NULL, NULL, 235824),
(290289, '5i47B03', NULL, NULL, 104, NULL, NULL, 235824),
(290290, '2fp4B01', NULL, NULL, 155, NULL, NULL, 235824),
(290291, '5mlkB02', NULL, NULL, 254, NULL, NULL, 235824),
(290292, '2r85A02', NULL, NULL, 185, NULL, NULL, 235824),
(290293, '3r5xD02', NULL, NULL, 155, NULL, NULL, 235824),
(290294, '1gsoA03', NULL, NULL, 139, NULL, NULL, 235824),
(290295, '2ip4A03', NULL, NULL, 137, NULL, NULL, 235824),
(290296, '2dwcA03', NULL, NULL, 230, NULL, NULL, 235824),
(290297, '3u9sE03', NULL, NULL, 236, NULL, NULL, 235824),
(290298, '3ouzA02', NULL, NULL, 285, NULL, NULL, 235824),
(290299, '4dimA03', NULL, NULL, 214, NULL, NULL, 235824),
(290300, '3r5fA02', NULL, NULL, 169, NULL, NULL, 235824),
(290301, '3glkA04', NULL, NULL, 265, NULL, NULL, 235824),
(290302, '3k3pA02', NULL, NULL, 164, NULL, NULL, 235824),
(290303, '2pn1A03', NULL, NULL, 120, NULL, NULL, 235824),
(290304, '3df7A02', NULL, NULL, 137, NULL, NULL, 235824),
(290305, '2qk4A03', NULL, NULL, 139, NULL, NULL, 235824),
(290306, '2z02A02', NULL, NULL, 137, NULL, NULL, 235824),
(290307, '1ehiA02', NULL, NULL, 159, NULL, NULL, 235824),
(290308, '1wr2A01', NULL, NULL, 160, NULL, NULL, 235824),
(290309, '2yl2B04', NULL, NULL, 265, NULL, NULL, 235824),
(290310, '2dzdA03', NULL, NULL, 254, NULL, NULL, 235824),
(290311, '4c5cA02', NULL, NULL, 149, NULL, NULL, 235824),
(290312, '2vpqA02', NULL, NULL, 295, NULL, NULL, 235824),
(290313, '4qshA02', NULL, NULL, 256, NULL, NULL, 235824),
(290314, '2wyoD02', NULL, NULL, 129, NULL, NULL, 235824),
(290315, '3tw6C01', NULL, NULL, 477, NULL, NULL, 235824),
(290316, '4mv4A02', NULL, NULL, 290, NULL, NULL, 235824),
(290317, '3se7C02', NULL, NULL, 161, NULL, NULL, 235824),
(290318, '2qf7B03', NULL, NULL, 257, NULL, NULL, 235824),
(290319, '1w96C04', NULL, NULL, 256, NULL, NULL, 235824),
(290320, '3aw8A03', NULL, NULL, 195, NULL, NULL, 235824),
(290321, '3kfuG02', NULL, NULL, 18, NULL, NULL, 235825),
(290322, '1tr2A03', NULL, NULL, 229, NULL, NULL, 235826),
(290323, '1tr2A02', NULL, NULL, 236, NULL, NULL, 235826),
(290324, '1st6A01', NULL, NULL, 255, NULL, NULL, 235826),
(290325, '1st6A02', NULL, NULL, 236, NULL, NULL, 235826),
(290326, '1st6A03', NULL, NULL, 229, NULL, NULL, 235826),
(290327, '1tr2A01', NULL, NULL, 252, NULL, NULL, 235826),
(290328, '2au3A04', NULL, NULL, 57, NULL, NULL, 235827),
(290329, '2bhwA01', NULL, NULL, 203, NULL, NULL, 235828),
(290330, '3jcuS01', NULL, NULL, 212, NULL, NULL, 235828),
(290331, '5xnlS01', NULL, NULL, 212, NULL, NULL, 235828),
(290332, '2o01200', NULL, NULL, 186, NULL, NULL, 235828),
(290333, '2o01300', NULL, NULL, 129, NULL, NULL, 235828),
(290334, '2o01401', NULL, NULL, 137, NULL, NULL, 235828),
(290335, '5xnl301', NULL, NULL, 205, NULL, NULL, 235828),
(290336, '3pl9A00', NULL, NULL, 156, NULL, NULL, 235828),
(290337, '2o01100', NULL, NULL, 187, NULL, NULL, 235828),
(290338, '4v19600', NULL, NULL, 65, NULL, NULL, 235829),
(290339, '1vvm600', NULL, NULL, 54, NULL, NULL, 235829);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(290340, '1vw4X00', NULL, NULL, 70, NULL, NULL, 235829),
(290341, '5x8t200', NULL, NULL, 65, NULL, NULL, 235829),
(290342, '5o60c00', NULL, NULL, 55, NULL, NULL, 235829),
(290343, '5xym100', NULL, NULL, 54, NULL, NULL, 235829),
(290344, '5dm6100', NULL, NULL, 54, NULL, NULL, 235829),
(290345, '6qulc00', NULL, NULL, 55, NULL, NULL, 235829),
(290346, '5v7q100', NULL, NULL, 55, NULL, NULL, 235829),
(290347, '6ddgO00', NULL, NULL, 49, NULL, NULL, 235829),
(290348, '3pio100', NULL, NULL, 55, NULL, NULL, 235829),
(290349, '5oom100', NULL, NULL, 65, NULL, NULL, 235829),
(290350, '6hma100', NULL, NULL, 47, NULL, NULL, 235829),
(290351, '2hvrA03', NULL, NULL, 89, NULL, NULL, 235830),
(290352, '4luqC00', NULL, NULL, 123, NULL, NULL, 235831),
(290353, '2zxeA04', NULL, NULL, 211, NULL, NULL, 235832),
(290354, '3skxA02', NULL, NULL, 118, NULL, NULL, 235832),
(290355, '3wguA04', NULL, NULL, 211, NULL, NULL, 235832),
(290356, '2kmvA01', NULL, NULL, 139, NULL, NULL, 235832),
(290357, '3gwiA00', NULL, NULL, 170, NULL, NULL, 235832),
(290358, '3a1cA02', NULL, NULL, 117, NULL, NULL, 235832),
(290359, '2arfA00', NULL, NULL, 165, NULL, NULL, 235832),
(290360, '1q3iA00', NULL, NULL, 214, NULL, NULL, 235832),
(290361, '2yj6A02', NULL, NULL, 95, NULL, NULL, 235832),
(290362, '5yluA04', NULL, NULL, 211, NULL, NULL, 235832),
(290363, '1svjA00', NULL, NULL, 136, NULL, NULL, 235832),
(290364, '3ar4A04', NULL, NULL, 244, NULL, NULL, 235832),
(290365, '5mpmA04', NULL, NULL, 243, NULL, NULL, 235832),
(290366, '2kmxA00', NULL, NULL, 185, NULL, NULL, 235832),
(290367, '1mo7A00', NULL, NULL, 213, NULL, NULL, 235832),
(290368, '4umvA04', NULL, NULL, 116, NULL, NULL, 235832),
(290369, '4bbjA04', NULL, NULL, 120, NULL, NULL, 235832),
(290370, '5ksdA04', NULL, NULL, 148, NULL, NULL, 235832),
(290371, '4i43B04', NULL, NULL, 172, NULL, NULL, 235833),
(290372, '2lllA00', NULL, NULL, 121, NULL, NULL, 235834),
(290373, '6ghdF00', NULL, NULL, 119, NULL, NULL, 235834),
(290374, '3gefA00', NULL, NULL, 118, NULL, NULL, 235834),
(290375, '3jt0B00', NULL, NULL, 121, NULL, NULL, 235834),
(290376, '1ufgA00', NULL, NULL, 151, NULL, NULL, 235834),
(290377, '3umnA00', NULL, NULL, 123, NULL, NULL, 235834),
(290378, '2kpwA00', NULL, NULL, 122, NULL, NULL, 235834),
(290379, '2oebA00', NULL, NULL, 155, NULL, NULL, 235835),
(290380, '4gkfA00', NULL, NULL, 169, NULL, NULL, 235835),
(290381, '2zopA00', NULL, NULL, 114, NULL, NULL, 235835),
(290382, '3o58N02', NULL, NULL, 37, NULL, NULL, 235836),
(290383, '4a17Y00', NULL, NULL, 103, NULL, NULL, 235837),
(290384, '3cc2Z00', NULL, NULL, 83, NULL, NULL, 235837),
(290385, '3o58g00', NULL, NULL, 92, NULL, NULL, 235837),
(290386, '1vx7h00', NULL, NULL, 96, NULL, NULL, 235837),
(290387, '1vwxp00', NULL, NULL, 91, NULL, NULL, 235837),
(290388, '1jj2Y00', NULL, NULL, 73, NULL, NULL, 235837),
(290389, '3o58d00', NULL, NULL, 88, NULL, NULL, 235837),
(290390, '1vq8100', NULL, NULL, 57, NULL, NULL, 235837),
(290391, '1vq8Z00', NULL, NULL, 83, NULL, NULL, 235837),
(290392, '4bs9A03', NULL, NULL, 156, NULL, NULL, 235838),
(290393, '2rrnA01', NULL, NULL, 83, NULL, NULL, 235839),
(290394, '1ux6A01', NULL, NULL, 137, NULL, NULL, 235840),
(290395, '4bjsC00', NULL, NULL, 60, NULL, NULL, 235841),
(290396, '4fuoA01', NULL, NULL, 77, NULL, NULL, 235842),
(290397, '4fuoA02', NULL, NULL, 131, NULL, NULL, 235842),
(290398, '4fzqA00', NULL, NULL, 79, NULL, NULL, 235842),
(290399, '3eo5A01', NULL, NULL, 88, NULL, NULL, 235842),
(290400, '2ltjA00', NULL, NULL, 112, NULL, NULL, 235842),
(290401, '5dblA00', NULL, NULL, 132, NULL, NULL, 235842),
(290402, '2e0zA02', NULL, NULL, 25, NULL, NULL, 235843),
(290403, '3giaA00', NULL, NULL, 444, NULL, NULL, 235844),
(290404, '3kluA01', NULL, NULL, 121, NULL, NULL, 235845),
(290405, '1zpsA01', NULL, NULL, 102, NULL, NULL, 235846),
(290406, '2ph7A02', NULL, NULL, 96, NULL, NULL, 235847),
(290407, '5l16A01', NULL, NULL, 123, NULL, NULL, 235848),
(290408, '3qtyB01', NULL, NULL, 153, NULL, NULL, 235848),
(290409, '2z1uA01', NULL, NULL, 153, NULL, NULL, 235848),
(290410, '2yxzD01', NULL, NULL, 143, NULL, NULL, 235848);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(290411, '3fd5B01', NULL, NULL, 143, NULL, NULL, 235848),
(290412, '3u0oA01', NULL, NULL, 135, NULL, NULL, 235848),
(290413, '3wjpA01', NULL, NULL, 155, NULL, NULL, 235848),
(290414, '3vtiC01', NULL, NULL, 135, NULL, NULL, 235848),
(290415, '3viuA03', NULL, NULL, 183, NULL, NULL, 235848),
(290416, '3viuA02', NULL, NULL, 150, NULL, NULL, 235848),
(290417, '3kizA01', NULL, NULL, 141, NULL, NULL, 235848),
(290418, '2z1eA01', NULL, NULL, 114, NULL, NULL, 235848),
(290419, '3mdoA01', NULL, NULL, 143, NULL, NULL, 235848),
(290420, '2v9yA01', NULL, NULL, 114, NULL, NULL, 235848),
(290421, '3c9uA01', NULL, NULL, 142, NULL, NULL, 235848),
(290422, '2rb9A01', NULL, NULL, 156, NULL, NULL, 235848),
(290423, '2zauA01', NULL, NULL, 130, NULL, NULL, 235848),
(290424, '1cliB01', NULL, NULL, 150, NULL, NULL, 235848),
(290425, '2zodB01', NULL, NULL, 164, NULL, NULL, 235848),
(290426, '2btuB01', NULL, NULL, 167, NULL, NULL, 235848),
(290427, '5vk4A01', NULL, NULL, 154, NULL, NULL, 235848),
(290428, '2z01A01', NULL, NULL, 151, NULL, NULL, 235848),
(290429, '3p4eA01', NULL, NULL, 154, NULL, NULL, 235848),
(290430, '5avmA01', NULL, NULL, 114, NULL, NULL, 235848),
(290431, '1vk3A03', NULL, NULL, 147, NULL, NULL, 235848),
(290432, '5cm7B01', NULL, NULL, 149, NULL, NULL, 235848),
(290433, '1vk3A02', NULL, NULL, 135, NULL, NULL, 235848),
(290434, '3mcqA01', NULL, NULL, 141, NULL, NULL, 235848),
(290435, '3l4jA05', NULL, NULL, 153, NULL, NULL, 235849),
(290436, '4elzB00', NULL, NULL, 133, NULL, NULL, 235849),
(290437, '4fm9A05', NULL, NULL, 149, NULL, NULL, 235849),
(290438, '4z4qA04', NULL, NULL, 89, NULL, NULL, 235849),
(290439, '3lpxA03', NULL, NULL, 124, NULL, NULL, 235849),
(290440, '3qx3A04', NULL, NULL, 123, NULL, NULL, 235849),
(290441, '1zvuA03', NULL, NULL, 140, NULL, NULL, 235849),
(290442, '1bgwA03', NULL, NULL, 141, NULL, NULL, 235849),
(290443, '6bq9A03', NULL, NULL, 87, NULL, NULL, 235849),
(290444, '2xcqA04', NULL, NULL, 89, NULL, NULL, 235849),
(290445, '4ddqA03', NULL, NULL, 90, NULL, NULL, 235849),
(290446, '4ckkC03', NULL, NULL, 124, NULL, NULL, 235849),
(290447, '1bjtA03', NULL, NULL, 106, NULL, NULL, 235849),
(290448, '2jksA01', NULL, NULL, 164, NULL, NULL, 235850),
(290449, '2jksA02', NULL, NULL, 151, NULL, NULL, 235850),
(290450, '1kzqA02', NULL, NULL, 124, NULL, NULL, 235850),
(290451, '1kzqA01', NULL, NULL, 132, NULL, NULL, 235850),
(290452, '2wnkA02', NULL, NULL, 106, NULL, NULL, 235850),
(290453, '2wnkA01', NULL, NULL, 132, NULL, NULL, 235850),
(290454, '3v5uA02', NULL, NULL, 221, NULL, NULL, 235851),
(290455, '3fhnA02', NULL, NULL, 135, NULL, NULL, 235852),
(290456, '2af5A02', NULL, NULL, 138, NULL, NULL, 235853),
(290457, '1rjlC00', NULL, NULL, 95, NULL, NULL, 235853),
(290458, '2hkdA02', NULL, NULL, 138, NULL, NULL, 235853),
(290459, '1p4pA00', NULL, NULL, 145, NULL, NULL, 235853),
(290460, '2ol7A02', NULL, NULL, 146, NULL, NULL, 235853),
(290461, '3ckfA02', NULL, NULL, 147, NULL, NULL, 235853),
(290462, '2fkjA02', NULL, NULL, 181, NULL, NULL, 235853),
(290463, '2oy7A02', NULL, NULL, 139, NULL, NULL, 235853),
(290464, '3ec5A02', NULL, NULL, 139, NULL, NULL, 235853),
(290465, '2oy7A03', NULL, NULL, 99, NULL, NULL, 235853),
(290466, '2i5vO02', NULL, NULL, 146, NULL, NULL, 235853),
(290467, '2w2rA00', NULL, NULL, 189, NULL, NULL, 235854),
(290468, '1lg7A00', NULL, NULL, 182, NULL, NULL, 235854),
(290469, '2ckzA01', NULL, NULL, 59, NULL, NULL, 235855),
(290470, '3mb2B00', NULL, NULL, 72, NULL, NULL, 235856),
(290471, '6fpsN00', NULL, NULL, 62, NULL, NULL, 235856),
(290472, '3mb2F00', NULL, NULL, 54, NULL, NULL, 235856),
(290473, '4jj9C00', NULL, NULL, 149, NULL, NULL, 235856),
(290474, '2xczA00', NULL, NULL, 115, NULL, NULL, 235856),
(290475, '3c6vA00', NULL, NULL, 143, NULL, NULL, 235856),
(290476, '1vw5B00', NULL, NULL, 121, NULL, NULL, 235856),
(290477, '3n4hA00', NULL, NULL, 118, NULL, NULL, 235856),
(290478, '2os5A00', NULL, NULL, 119, NULL, NULL, 235856),
(290479, '3t5sA00', NULL, NULL, 115, NULL, NULL, 235856),
(290480, '3abfA00', NULL, NULL, 64, NULL, NULL, 235856),
(290481, '3m20A00', NULL, NULL, 62, NULL, NULL, 235856);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(290482, '1otgA00', NULL, NULL, 125, NULL, NULL, 235856),
(290483, '2gdgA00', NULL, NULL, 114, NULL, NULL, 235856),
(290484, '3ej7C00', NULL, NULL, 60, NULL, NULL, 235856),
(290485, '3kerA00', NULL, NULL, 117, NULL, NULL, 235856),
(290486, '6bgnB00', NULL, NULL, 60, NULL, NULL, 235856),
(290487, '3ej9B00', NULL, NULL, 70, NULL, NULL, 235856),
(290488, '2opaA00', NULL, NULL, 61, NULL, NULL, 235856),
(290489, '4u5pA00', NULL, NULL, 141, NULL, NULL, 235856),
(290490, '3ry0A00', NULL, NULL, 65, NULL, NULL, 235856),
(290491, '3e6qA00', NULL, NULL, 130, NULL, NULL, 235856),
(290492, '2flzB00', NULL, NULL, 149, NULL, NULL, 235856),
(290493, '4lkbE00', NULL, NULL, 128, NULL, NULL, 235856),
(290494, '4fdxB00', NULL, NULL, 70, NULL, NULL, 235856),
(290495, '4m1aA00', NULL, NULL, 108, NULL, NULL, 235856),
(290496, '1otfA00', NULL, NULL, 62, NULL, NULL, 235856),
(290497, '4dh4A00', NULL, NULL, 114, NULL, NULL, 235856),
(290498, '3n4dH00', NULL, NULL, 148, NULL, NULL, 235856),
(290499, '3mb2C00', NULL, NULL, 72, NULL, NULL, 235856),
(290500, '1mwwB00', NULL, NULL, 128, NULL, NULL, 235856),
(290501, '4jcuB00', NULL, NULL, 133, NULL, NULL, 235856),
(290502, '6b1kA00', NULL, NULL, 114, NULL, NULL, 235856),
(290503, '4fazA00', NULL, NULL, 62, NULL, NULL, 235856),
(290504, '1gyxA01', NULL, NULL, 64, NULL, NULL, 235856),
(290505, '2aalA00', NULL, NULL, 131, NULL, NULL, 235856),
(290506, '3kanA00', NULL, NULL, 117, NULL, NULL, 235856),
(290507, '3ej9E00', NULL, NULL, 76, NULL, NULL, 235856),
(290508, '3mf7A00', NULL, NULL, 118, NULL, NULL, 235856),
(290509, '3ej7H00', NULL, NULL, 54, NULL, NULL, 235856),
(290510, '4nwpH00', NULL, NULL, 131, NULL, NULL, 235856),
(290511, '2x4kA00', NULL, NULL, 63, NULL, NULL, 235856),
(290512, '1uizA00', NULL, NULL, 115, NULL, NULL, 235856),
(290513, '3m21F00', NULL, NULL, 67, NULL, NULL, 235856),
(290514, '1u9dA00', NULL, NULL, 122, NULL, NULL, 235856),
(290515, '4lhpF00', NULL, NULL, 136, NULL, NULL, 235856),
(290516, '2wkfA00', NULL, NULL, 101, NULL, NULL, 235856),
(290517, '1hfoA00', NULL, NULL, 113, NULL, NULL, 235856),
(290518, '2fm7A00', NULL, NULL, 62, NULL, NULL, 235856),
(290519, '3b64A00', NULL, NULL, 112, NULL, NULL, 235856),
(290520, '2wkbA01', NULL, NULL, 106, NULL, NULL, 235856),
(290521, '3fwtA00', NULL, NULL, 116, NULL, NULL, 235856),
(290522, '3k4iC02', NULL, NULL, 38, NULL, NULL, 235857),
(290523, '4fzbC02', NULL, NULL, 59, NULL, NULL, 235857),
(290524, '4fzbA02', NULL, NULL, 40, NULL, NULL, 235857),
(290525, '3r4dB00', NULL, NULL, 254, NULL, NULL, 235858),
(290526, '6qfyB00', NULL, NULL, 288, NULL, NULL, 235858),
(290527, '4h14A00', NULL, NULL, 290, NULL, NULL, 235858),
(290528, '5iroD00', NULL, NULL, 108, NULL, NULL, 235859),
(290529, '4e5xG00', NULL, NULL, 100, NULL, NULL, 235859),
(290530, '3hj6A01', NULL, NULL, 187, NULL, NULL, 235860),
(290531, '2efvA00', NULL, NULL, 92, NULL, NULL, 235861),
(290532, '3kewB02', NULL, NULL, 155, NULL, NULL, 235862),
(290533, '1tkeA02', NULL, NULL, 102, NULL, NULL, 235862),
(290534, '2ztgA04', NULL, NULL, 96, NULL, NULL, 235862),
(290535, '3rhuA01', NULL, NULL, 113, NULL, NULL, 235862),
(290536, '3wqyB04', NULL, NULL, 98, NULL, NULL, 235862),
(290537, '1nyrB02', NULL, NULL, 158, NULL, NULL, 235862),
(290538, '3rfnA01', NULL, NULL, 112, NULL, NULL, 235862),
(290539, '1v4pC01', NULL, NULL, 110, NULL, NULL, 235862),
(290540, '2zzeA04', NULL, NULL, 95, NULL, NULL, 235862),
(290541, '2e1bA02', NULL, NULL, 129, NULL, NULL, 235862),
(290542, '2kq5A00', NULL, NULL, 51, NULL, NULL, 235863),
(290543, '3qnfA04', NULL, NULL, 190, NULL, NULL, 235864),
(290544, '2ichA01', NULL, NULL, 187, NULL, NULL, 235865),
(290545, '2ichB02', NULL, NULL, 135, NULL, NULL, 235865),
(290546, '3u6xS00', NULL, NULL, 105, NULL, NULL, 235866),
(290547, '2e1mA01', NULL, NULL, 41, NULL, NULL, 235867),
(290548, '4fcaA03', NULL, NULL, 160, NULL, NULL, 235868),
(290549, '3rfwA01', NULL, NULL, 61, NULL, NULL, 235869),
(290550, '2zxiA04', NULL, NULL, 55, NULL, NULL, 235870),
(290551, '3cp8A04', NULL, NULL, 53, NULL, NULL, 235870),
(290552, '2b9dA01', NULL, NULL, 39, NULL, NULL, 235871);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(290553, '2ewlA00', NULL, NULL, 56, NULL, NULL, 235871),
(290554, '2l25A00', NULL, NULL, 141, NULL, NULL, 235872),
(290555, '3f3pL01', NULL, NULL, 57, NULL, NULL, 235873),
(290556, '3f3fD01', NULL, NULL, 51, NULL, NULL, 235873),
(290557, '3f3pG01', NULL, NULL, 56, NULL, NULL, 235873),
(290558, '3f3pH01', NULL, NULL, 56, NULL, NULL, 235873),
(290559, '3f3pC01', NULL, NULL, 56, NULL, NULL, 235873),
(290560, '3f3pD01', NULL, NULL, 51, NULL, NULL, 235873),
(290561, '5b5vD00', NULL, NULL, 195, NULL, NULL, 235874),
(290562, '4lqqB00', NULL, NULL, 155, NULL, NULL, 235874),
(290563, '5brkA00', NULL, NULL, 217, NULL, NULL, 235874),
(290564, '5ncnA00', NULL, NULL, 178, NULL, NULL, 235874),
(290565, '4j1vA00', NULL, NULL, 184, NULL, NULL, 235874),
(290566, '5ncmA00', NULL, NULL, 196, NULL, NULL, 235874),
(290567, '5twgA00', NULL, NULL, 216, NULL, NULL, 235874),
(290568, '2hjnA00', NULL, NULL, 236, NULL, NULL, 235874),
(290569, '4xpmB00', NULL, NULL, 76, NULL, NULL, 235875),
(290570, '2grgA01', NULL, NULL, 83, NULL, NULL, 235875),
(290571, '2pt7G02', NULL, NULL, 72, NULL, NULL, 235876),
(290572, '6g5id00', NULL, NULL, 56, NULL, NULL, 235877),
(290573, '3j7aT00', NULL, NULL, 54, NULL, NULL, 235877),
(290574, '4bpeN00', NULL, NULL, 55, NULL, NULL, 235877),
(290575, '6az1S00', NULL, NULL, 57, NULL, NULL, 235877),
(290576, '1vx2d00', NULL, NULL, 56, NULL, NULL, 235877),
(290577, '5xxud00', NULL, NULL, 54, NULL, NULL, 235877),
(290578, '3jamd00', NULL, NULL, 56, NULL, NULL, 235877),
(290579, '3u5cd00', NULL, NULL, 56, NULL, NULL, 235877),
(290580, '5xyid00', NULL, NULL, 57, NULL, NULL, 235877),
(290581, '2vqeN00', NULL, NULL, 61, NULL, NULL, 235877),
(290582, '5o5jN00', NULL, NULL, 61, NULL, NULL, 235877),
(290583, '4e9oX00', NULL, NULL, 234, NULL, NULL, 235878),
(290584, '5ogoA00', NULL, NULL, 260, NULL, NULL, 235878),
(290585, '1fljA00', NULL, NULL, 260, NULL, NULL, 235878),
(290586, '1keqA00', NULL, NULL, 248, NULL, NULL, 235878),
(290587, '4cnxA00', NULL, NULL, 262, NULL, NULL, 235878),
(290588, '1kopA00', NULL, NULL, 223, NULL, NULL, 235878),
(290589, '4cnvA00', NULL, NULL, 262, NULL, NULL, 235878),
(290590, '3q31A00', NULL, NULL, 244, NULL, NULL, 235878),
(290591, '4xfwA00', NULL, NULL, 226, NULL, NULL, 235878),
(290592, '6b00A00', NULL, NULL, 266, NULL, NULL, 235878),
(290593, '3fe4B00', NULL, NULL, 261, NULL, NULL, 235878),
(290594, '5dvxB00', NULL, NULL, 260, NULL, NULL, 235878),
(290595, '5ogjA00', NULL, NULL, 263, NULL, NULL, 235878),
(290596, '4coqB00', NULL, NULL, 226, NULL, NULL, 235878),
(290597, '3jxfA00', NULL, NULL, 272, NULL, NULL, 235878),
(290598, '4xiwC00', NULL, NULL, 239, NULL, NULL, 235878),
(290599, '3b1bA01', NULL, NULL, 306, NULL, NULL, 235878),
(290600, '4g7aB00', NULL, NULL, 225, NULL, NULL, 235878),
(290601, '2w2jA00', NULL, NULL, 268, NULL, NULL, 235878),
(290602, '1rj5B00', NULL, NULL, 261, NULL, NULL, 235878),
(290603, '5e2mA00', NULL, NULL, 260, NULL, NULL, 235878),
(290604, '3fw3B00', NULL, NULL, 266, NULL, NULL, 235878),
(290605, '3uyqA00', NULL, NULL, 260, NULL, NULL, 235878),
(290606, '5cjfA00', NULL, NULL, 279, NULL, NULL, 235878),
(290607, '3ks3A00', NULL, NULL, 260, NULL, NULL, 235878),
(290608, '5hpjA00', NULL, NULL, 217, NULL, NULL, 235878),
(290609, '6ekiA00', NULL, NULL, 226, NULL, NULL, 235878),
(290610, '3zncA00', NULL, NULL, 258, NULL, NULL, 235878),
(290611, '3jxgA00', NULL, NULL, 269, NULL, NULL, 235878),
(290612, '1y7wA01', NULL, NULL, 261, NULL, NULL, 235878),
(290613, '4x5sA00', NULL, NULL, 232, NULL, NULL, 235878),
(290614, '5msaA00', NULL, NULL, 263, NULL, NULL, 235878),
(290615, '4twlA00', NULL, NULL, 246, NULL, NULL, 235878),
(290616, '6h38A00', NULL, NULL, 274, NULL, NULL, 235878),
(290617, '4xz5A00', NULL, NULL, 233, NULL, NULL, 235878),
(290618, '5eztX00', NULL, NULL, 257, NULL, NULL, 235878),
(290619, '5a29A01', NULL, NULL, 426, NULL, NULL, 235879),
(290620, '1w6kA02', NULL, NULL, 376, NULL, NULL, 235879),
(290621, '1w6kA03', NULL, NULL, 285, NULL, NULL, 235879),
(290622, '4mu9B00', NULL, NULL, 364, NULL, NULL, 235879),
(290623, '4c1sA00', NULL, NULL, 375, NULL, NULL, 235879);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(290624, '2sqcA02', NULL, NULL, 272, NULL, NULL, 235879),
(290625, '2h6fB00', NULL, NULL, 437, NULL, NULL, 235879),
(290626, '2bb6A01', NULL, NULL, 301, NULL, NULL, 235879),
(290627, '3oxuB00', NULL, NULL, 301, NULL, NULL, 235879),
(290628, '4ydeB00', NULL, NULL, 478, NULL, NULL, 235879),
(290629, '4zrpA01', NULL, NULL, 298, NULL, NULL, 235879),
(290630, '2sqcA01', NULL, NULL, 347, NULL, NULL, 235879),
(290631, '2wy8A00', NULL, NULL, 294, NULL, NULL, 235879),
(290632, '2b39A11', NULL, NULL, 305, NULL, NULL, 235879),
(290633, '2pn5A09', NULL, NULL, 291, NULL, NULL, 235879),
(290634, '4v1sA00', NULL, NULL, 360, NULL, NULL, 235879),
(290635, '3k7xA00', NULL, NULL, 349, NULL, NULL, 235879),
(290636, '4lnvA09', NULL, NULL, 291, NULL, NULL, 235879),
(290637, '1qqfA00', NULL, NULL, 277, NULL, NULL, 235879),
(290638, '4kkiA01', NULL, NULL, 287, NULL, NULL, 235879),
(290639, '1hzfA00', NULL, NULL, 328, NULL, NULL, 235879),
(290640, '5agdA00', NULL, NULL, 337, NULL, NULL, 235879),
(290641, '2v8iA01', NULL, NULL, 411, NULL, NULL, 235879),
(290642, '2g0dA00', NULL, NULL, 409, NULL, NULL, 235879),
(290643, '1gxmB00', NULL, NULL, 332, NULL, NULL, 235879),
(290644, '4l9pB00', NULL, NULL, 452, NULL, NULL, 235879),
(290645, '3draB00', NULL, NULL, 390, NULL, NULL, 235879),
(290646, '3cu7A11', NULL, NULL, 325, NULL, NULL, 235879),
(290647, '2pmvB00', NULL, NULL, 273, NULL, NULL, 235879),
(290648, '1r76A00', NULL, NULL, 408, NULL, NULL, 235879),
(290649, '3dssB00', NULL, NULL, 331, NULL, NULL, 235879),
(290650, '1n4qB00', NULL, NULL, 360, NULL, NULL, 235879),
(290651, '3q7aB00', NULL, NULL, 520, NULL, NULL, 235879),
(290652, '2r31A01', NULL, NULL, 68, NULL, NULL, 235880),
(290653, '2r6iA01', NULL, NULL, 110, NULL, NULL, 235880),
(290654, '2g3vA00', NULL, NULL, 161, NULL, NULL, 235881),
(290655, '2g3vB00', NULL, NULL, 161, NULL, NULL, 235881),
(290656, '2g3vC00', NULL, NULL, 161, NULL, NULL, 235881),
(290657, '2g3vD00', NULL, NULL, 161, NULL, NULL, 235881),
(290658, '4bi3A01', NULL, NULL, 91, NULL, NULL, 235882),
(290659, '6ijfC01', NULL, NULL, 94, NULL, NULL, 235882),
(290660, '3nb0A03', NULL, NULL, 90, NULL, NULL, 235883),
(290661, '3lm4A02', NULL, NULL, 188, NULL, NULL, 235884),
(290662, '3lm4A01', NULL, NULL, 136, NULL, NULL, 235884),
(290663, '2ei0A02', NULL, NULL, 164, NULL, NULL, 235884),
(290664, '1sp8C02', NULL, NULL, 224, NULL, NULL, 235884),
(290665, '1jc4A00', NULL, NULL, 148, NULL, NULL, 235884),
(290666, '1sp8C01', NULL, NULL, 175, NULL, NULL, 235884),
(290667, '1mpyA02', NULL, NULL, 158, NULL, NULL, 235884),
(290668, '1mpyA01', NULL, NULL, 149, NULL, NULL, 235884),
(290669, '1f1xA01', NULL, NULL, 138, NULL, NULL, 235884),
(290670, '3zgjA02', NULL, NULL, 196, NULL, NULL, 235884),
(290671, '5zszA02', NULL, NULL, 147, NULL, NULL, 235884),
(290672, '3zgjA01', NULL, NULL, 175, NULL, NULL, 235884),
(290673, '5f6qA01', NULL, NULL, 138, NULL, NULL, 235884),
(290674, '5umpA00', NULL, NULL, 140, NULL, NULL, 235884),
(290675, '3ghjA00', NULL, NULL, 116, NULL, NULL, 235884),
(290676, '2wl9A01', NULL, NULL, 135, NULL, NULL, 235884),
(290677, '1twuA00', NULL, NULL, 139, NULL, NULL, 235884),
(290678, '2qqzA01', NULL, NULL, 115, NULL, NULL, 235884),
(290679, '2wl3D02', NULL, NULL, 150, NULL, NULL, 235884),
(290680, '2rk9B00', NULL, NULL, 145, NULL, NULL, 235884),
(290681, '3pkvA00', NULL, NULL, 228, NULL, NULL, 235884),
(290682, '2c21A00', NULL, NULL, 144, NULL, NULL, 235884),
(290683, '3r6aB00', NULL, NULL, 128, NULL, NULL, 235884),
(290684, '4n04A00', NULL, NULL, 116, NULL, NULL, 235884),
(290685, '3zi1A01', NULL, NULL, 138, NULL, NULL, 235884),
(290686, '4gymB00', NULL, NULL, 149, NULL, NULL, 235884),
(290687, '1qtoA00', NULL, NULL, 122, NULL, NULL, 235884),
(290688, '1sqiB02', NULL, NULL, 192, NULL, NULL, 235884),
(290689, '3gm5A00', NULL, NULL, 159, NULL, NULL, 235884),
(290690, '3zi1A02', NULL, NULL, 145, NULL, NULL, 235884),
(290691, '2a4xA00', NULL, NULL, 138, NULL, NULL, 235884),
(290692, '4pavB00', NULL, NULL, 145, NULL, NULL, 235884),
(290693, '1lgtA02', NULL, NULL, 165, NULL, NULL, 235884),
(290694, '2rk0A01', NULL, NULL, 121, NULL, NULL, 235884);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(290695, '1lgtA01', NULL, NULL, 132, NULL, NULL, 235884),
(290696, '6bu2A00', NULL, NULL, 151, NULL, NULL, 235884),
(290697, '1tsjA00', NULL, NULL, 139, NULL, NULL, 235884),
(290698, '2qntA01', NULL, NULL, 131, NULL, NULL, 235884),
(290699, '2rbbA00', NULL, NULL, 141, NULL, NULL, 235884),
(290700, '5znhA01', NULL, NULL, 146, NULL, NULL, 235884),
(290701, '3opyB01', NULL, NULL, 155, NULL, NULL, 235884),
(290702, '5kefA00', NULL, NULL, 153, NULL, NULL, 235884),
(290703, '4mtsA00', NULL, NULL, 131, NULL, NULL, 235884),
(290704, '4hc5D00', NULL, NULL, 133, NULL, NULL, 235884),
(290705, '6bnzA02', NULL, NULL, 140, NULL, NULL, 235884),
(290706, '1k4nA00', NULL, NULL, 192, NULL, NULL, 235884),
(290707, '4g6xA00', NULL, NULL, 133, NULL, NULL, 235884),
(290708, '3hpyA01', NULL, NULL, 150, NULL, NULL, 235884),
(290709, '5c68A00', NULL, NULL, 126, NULL, NULL, 235884),
(290710, '1r9cA00', NULL, NULL, 139, NULL, NULL, 235884),
(290711, '3hpyA02', NULL, NULL, 139, NULL, NULL, 235884),
(290712, '2ehzA01', NULL, NULL, 138, NULL, NULL, 235884),
(290713, '2r5vB02', NULL, NULL, 204, NULL, NULL, 235884),
(290714, '2zyqA01', NULL, NULL, 133, NULL, NULL, 235884),
(290715, '2zyqA02', NULL, NULL, 167, NULL, NULL, 235884),
(290716, '1u69D00', NULL, NULL, 163, NULL, NULL, 235884),
(290717, '4jh2A01', NULL, NULL, 135, NULL, NULL, 235884),
(290718, '2pjsA01', NULL, NULL, 103, NULL, NULL, 235884),
(290719, '2p7oA00', NULL, NULL, 133, NULL, NULL, 235884),
(290720, '1nkiA00', NULL, NULL, 135, NULL, NULL, 235884),
(290721, '2za0B00', NULL, NULL, 184, NULL, NULL, 235884),
(290722, '1sqiA01', NULL, NULL, 174, NULL, NULL, 235884),
(290723, '3p8aA01', NULL, NULL, 162, NULL, NULL, 235884),
(290724, '3fcdB00', NULL, NULL, 134, NULL, NULL, 235884),
(290725, '1xy7B00', NULL, NULL, 145, NULL, NULL, 235884),
(290726, '3g12B00', NULL, NULL, 128, NULL, NULL, 235884),
(290727, '3rmuA00', NULL, NULL, 134, NULL, NULL, 235884),
(290728, '4nvsA00', NULL, NULL, 163, NULL, NULL, 235884),
(290729, '3hdpA00', NULL, NULL, 133, NULL, NULL, 235884),
(290730, '1u6lA01', NULL, NULL, 141, NULL, NULL, 235884),
(290731, '3ey8A01', NULL, NULL, 122, NULL, NULL, 235884),
(290732, '2r6uA01', NULL, NULL, 124, NULL, NULL, 235884),
(290733, '1npbA00', NULL, NULL, 141, NULL, NULL, 235884),
(290734, '2i7rA00', NULL, NULL, 118, NULL, NULL, 235884),
(290735, '3r4qA01', NULL, NULL, 132, NULL, NULL, 235884),
(290736, '1zswA01', NULL, NULL, 188, NULL, NULL, 235884),
(290737, '1zswA02', NULL, NULL, 150, NULL, NULL, 235884),
(290738, '3isqA02', NULL, NULL, 210, NULL, NULL, 235884),
(290739, '3isqA01', NULL, NULL, 167, NULL, NULL, 235884),
(290740, '2r5vA01', NULL, NULL, 152, NULL, NULL, 235884),
(290741, '4qb5D00', NULL, NULL, 148, NULL, NULL, 235884),
(290742, '3oa4A01', NULL, NULL, 137, NULL, NULL, 235884),
(290743, '1ss4A00', NULL, NULL, 153, NULL, NULL, 235884),
(290744, '4nazA01', NULL, NULL, 141, NULL, NULL, 235884),
(290745, '3l7tA01', NULL, NULL, 127, NULL, NULL, 235884),
(290746, '1cjxB02', NULL, NULL, 202, NULL, NULL, 235884),
(290747, '1xrkB00', NULL, NULL, 124, NULL, NULL, 235884),
(290748, '1ecsA00', NULL, NULL, 126, NULL, NULL, 235884),
(290749, '3b59A02', NULL, NULL, 148, NULL, NULL, 235884),
(290750, '3kolA01', NULL, NULL, 136, NULL, NULL, 235884),
(290751, '1f9zA00', NULL, NULL, 135, NULL, NULL, 235884),
(290752, '3b59A01', NULL, NULL, 123, NULL, NULL, 235884),
(290753, '4z6mA02', NULL, NULL, 139, NULL, NULL, 235884),
(290754, '4z6mA01', NULL, NULL, 139, NULL, NULL, 235884),
(290755, '1kw3B01', NULL, NULL, 132, NULL, NULL, 235884),
(290756, '1kw3B02', NULL, NULL, 154, NULL, NULL, 235884),
(290757, '3bqxA00', NULL, NULL, 150, NULL, NULL, 235884),
(290758, '3vb0A01', NULL, NULL, 130, NULL, NULL, 235884),
(290759, '4z04A00', NULL, NULL, 131, NULL, NULL, 235884),
(290760, '3vb0A02', NULL, NULL, 164, NULL, NULL, 235884),
(290761, '4mymA00', NULL, NULL, 176, NULL, NULL, 235884),
(290762, '3sk2A00', NULL, NULL, 132, NULL, NULL, 235884),
(290763, '5cj3A00', NULL, NULL, 135, NULL, NULL, 235884),
(290764, '3e5dA00', NULL, NULL, 127, NULL, NULL, 235884),
(290765, '2p25A01', NULL, NULL, 119, NULL, NULL, 235884);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(290766, '2zw5A02', NULL, NULL, 119, NULL, NULL, 235884),
(290767, '3oajA02', NULL, NULL, 144, NULL, NULL, 235884),
(290768, '3w0tA00', NULL, NULL, 187, NULL, NULL, 235884),
(290769, '3oajA01', NULL, NULL, 168, NULL, NULL, 235884),
(290770, '1xqaA01', NULL, NULL, 111, NULL, NULL, 235884),
(290771, '6bnnA01', NULL, NULL, 156, NULL, NULL, 235884),
(290772, '1f1uA01', NULL, NULL, 148, NULL, NULL, 235884),
(290773, '1f1uA02', NULL, NULL, 159, NULL, NULL, 235884),
(290774, '5uhjA00', NULL, NULL, 129, NULL, NULL, 235884),
(290775, '3oxhA01', NULL, NULL, 158, NULL, NULL, 235884),
(290776, '3oxhA02', NULL, NULL, 124, NULL, NULL, 235884),
(290777, '1t47A01', NULL, NULL, 178, NULL, NULL, 235884),
(290778, '1t47A02', NULL, NULL, 203, NULL, NULL, 235884),
(290779, '3ct8A00', NULL, NULL, 146, NULL, NULL, 235884),
(290780, '5v91A00', NULL, NULL, 145, NULL, NULL, 235884),
(290781, '3ey7A01', NULL, NULL, 122, NULL, NULL, 235884),
(290782, '4rt5A00', NULL, NULL, 114, NULL, NULL, 235884),
(290783, '3rheA00', NULL, NULL, 124, NULL, NULL, 235884),
(290784, '1cjxA01', NULL, NULL, 153, NULL, NULL, 235884),
(290785, '4huzA01', NULL, NULL, 169, NULL, NULL, 235884),
(290786, '3huhA01', NULL, NULL, 128, NULL, NULL, 235884),
(290787, '4lqbA00', NULL, NULL, 130, NULL, NULL, 235884),
(290788, '3zw5A01', NULL, NULL, 119, NULL, NULL, 235884),
(290789, '4huzA02', NULL, NULL, 151, NULL, NULL, 235884),
(290790, '1tfzA01', NULL, NULL, 197, NULL, NULL, 235884),
(290791, '1tfzA02', NULL, NULL, 211, NULL, NULL, 235884),
(290792, '5vb0C00', NULL, NULL, 144, NULL, NULL, 235884),
(290793, '3rriA00', NULL, NULL, 135, NULL, NULL, 235884),
(290794, '4gymA00', NULL, NULL, 149, NULL, NULL, 235884),
(290795, '3e0rB01', NULL, NULL, 123, NULL, NULL, 235884),
(290796, '3bxjB03', NULL, NULL, 219, NULL, NULL, 235885),
(290797, '1nf1A02', NULL, NULL, 211, NULL, NULL, 235885),
(290798, '1nf1A01', NULL, NULL, 101, NULL, NULL, 235885),
(290799, '5e6pA01', NULL, NULL, 433, NULL, NULL, 235885),
(290800, '1werA01', NULL, NULL, 176, NULL, NULL, 235885),
(290801, '3fayA00', NULL, NULL, 387, NULL, NULL, 235885),
(290802, '3rytA01', NULL, NULL, 448, NULL, NULL, 235885),
(290803, '3ig3A01', NULL, NULL, 452, NULL, NULL, 235885),
(290804, '5cjpE01', NULL, NULL, 343, NULL, NULL, 235885),
(290805, '3hm6X01', NULL, NULL, 405, NULL, NULL, 235885),
(290806, '5v6rB01', NULL, NULL, 441, NULL, NULL, 235885),
(290807, '1werA02', NULL, NULL, 158, NULL, NULL, 235885),
(290808, '4m8nC01', NULL, NULL, 453, NULL, NULL, 235885),
(290809, '5xnlE00', NULL, NULL, 83, NULL, NULL, 235886),
(290810, '5b5ee00', NULL, NULL, 83, NULL, NULL, 235886),
(290811, '2pffB05', NULL, NULL, 61, NULL, NULL, 235887),
(290812, '2ebeA00', NULL, NULL, 106, NULL, NULL, 235888),
(290813, '2q5cA02', NULL, NULL, 90, NULL, NULL, 235889),
(290814, '2pjuA02', NULL, NULL, 88, NULL, NULL, 235889),
(290815, '1co4A00', NULL, NULL, 42, NULL, NULL, 235890),
(290816, '1o8rA00', NULL, NULL, 94, NULL, NULL, 235891),
(290817, '3kz5E00', NULL, NULL, 52, NULL, NULL, 235892),
(290818, '1ynjJ03', NULL, NULL, 64, NULL, NULL, 235893),
(290819, '4qiwC02', NULL, NULL, 46, NULL, NULL, 235893),
(290820, '4aybC02', NULL, NULL, 46, NULL, NULL, 235893),
(290821, '3kxkB01', NULL, NULL, 123, NULL, NULL, 235894),
(290822, '2qtfA01', NULL, NULL, 97, NULL, NULL, 235894),
(290823, '1sdiA00', NULL, NULL, 213, NULL, NULL, 235895),
(290824, '2wyhB02', NULL, NULL, 106, NULL, NULL, 235896),
(290825, '1j3eA00', NULL, NULL, 115, NULL, NULL, 235897),
(290826, '3fmtB00', NULL, NULL, 162, NULL, NULL, 235897),
(290827, '3sk7A00', NULL, NULL, 116, NULL, NULL, 235897),
(290828, '1q2hA00', NULL, NULL, 69, NULL, NULL, 235898),
(290829, '5ffnA00', NULL, NULL, 311, NULL, NULL, 235899),
(290830, '4dztA00', NULL, NULL, 276, NULL, NULL, 235899),
(290831, '2x8jB01', NULL, NULL, 312, NULL, NULL, 235899),
(290832, '6f9mB00', NULL, NULL, 310, NULL, NULL, 235899),
(290833, '1r6vA03', NULL, NULL, 347, NULL, NULL, 235899),
(290834, '3edyA02', NULL, NULL, 366, NULL, NULL, 235899),
(290835, '1t1gA00', NULL, NULL, 364, NULL, NULL, 235899),
(290836, '4m1zB00', NULL, NULL, 345, NULL, NULL, 235899);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(290837, '3f7oA00', NULL, NULL, 284, NULL, NULL, 235899),
(290838, '1sh7A00', NULL, NULL, 284, NULL, NULL, 235899),
(290839, '1ga6A00', NULL, NULL, 372, NULL, NULL, 235899),
(290840, '2xrmA00', NULL, NULL, 311, NULL, NULL, 235899),
(290841, '3vyvA00', NULL, NULL, 275, NULL, NULL, 235899),
(290842, '2gkoA00', NULL, NULL, 309, NULL, NULL, 235899),
(290843, '1xf1A01', NULL, NULL, 331, NULL, NULL, 235899),
(290844, '2ixtA00', NULL, NULL, 310, NULL, NULL, 235899),
(290845, '1sueA00', NULL, NULL, 266, NULL, NULL, 235899),
(290846, '3ti9A00', NULL, NULL, 352, NULL, NULL, 235899),
(290847, '1sbtA00', NULL, NULL, 275, NULL, NULL, 235899),
(290848, '2qtwB01', NULL, NULL, 298, NULL, NULL, 235899),
(290849, '2id4A01', NULL, NULL, 339, NULL, NULL, 235899),
(290850, '4zoqM00', NULL, NULL, 343, NULL, NULL, 235899),
(290851, '5wslA00', NULL, NULL, 282, NULL, NULL, 235899),
(290852, '5jxgA01', NULL, NULL, 325, NULL, NULL, 235899),
(290853, '1dbiA00', NULL, NULL, 280, NULL, NULL, 235899),
(290854, '5fbzA01', NULL, NULL, 316, NULL, NULL, 235899),
(290855, '1r0rE00', NULL, NULL, 274, NULL, NULL, 235899),
(290856, '1sioC00', NULL, NULL, 364, NULL, NULL, 235899),
(290857, '3lpcA00', NULL, NULL, 340, NULL, NULL, 235899),
(290858, '1wmdA01', NULL, NULL, 317, NULL, NULL, 235899),
(290859, '1thmA00', NULL, NULL, 279, NULL, NULL, 235899),
(290860, '3lxuX01', NULL, NULL, 358, NULL, NULL, 235899),
(290861, '4hvlA00', NULL, NULL, 377, NULL, NULL, 235899),
(290862, '1y9zB01', NULL, NULL, 296, NULL, NULL, 235899),
(290863, '1gciA00', NULL, NULL, 269, NULL, NULL, 235899),
(290864, '4h6wA00', NULL, NULL, 306, NULL, NULL, 235899),
(290865, '5yl7A00', NULL, NULL, 347, NULL, NULL, 235899),
(290866, '5vl7B01', NULL, NULL, 278, NULL, NULL, 235899),
(290867, '2b6nA00', NULL, NULL, 278, NULL, NULL, 235899),
(290868, '1to2E00', NULL, NULL, 281, NULL, NULL, 235899),
(290869, '4i0wB01', NULL, NULL, 335, NULL, NULL, 235899),
(290870, '4lvnA00', NULL, NULL, 344, NULL, NULL, 235899),
(290871, '4mzdA00', NULL, NULL, 356, NULL, NULL, 235899),
(290872, '4kg7A00', NULL, NULL, 381, NULL, NULL, 235899),
(290873, '4yn3A01', NULL, NULL, 355, NULL, NULL, 235899),
(290874, '1bh6A00', NULL, NULL, 274, NULL, NULL, 235899),
(290875, '3f7mA00', NULL, NULL, 279, NULL, NULL, 235899),
(290876, '3f49S00', NULL, NULL, 266, NULL, NULL, 235899),
(290877, '3t41B02', NULL, NULL, 364, NULL, NULL, 235899),
(290878, '2iy9A00', NULL, NULL, 325, NULL, NULL, 235899),
(290879, '3afgA02', NULL, NULL, 312, NULL, NULL, 235899),
(290880, '4h6xA00', NULL, NULL, 357, NULL, NULL, 235899),
(290881, '2pwaA00', NULL, NULL, 279, NULL, NULL, 235899),
(290882, '2z30A00', NULL, NULL, 320, NULL, NULL, 235899),
(290883, '3vv3A00', NULL, NULL, 334, NULL, NULL, 235899),
(290884, '3wqbA01', NULL, NULL, 412, NULL, NULL, 235899),
(290885, '3zxyA00', NULL, NULL, 282, NULL, NULL, 235899),
(290886, '2rhqB04', NULL, NULL, 75, NULL, NULL, 235900),
(290887, '2cxiA03', NULL, NULL, 70, NULL, NULL, 235900),
(290888, '3l4gB01', NULL, NULL, 89, NULL, NULL, 235900),
(290889, '2cxiA01', NULL, NULL, 80, NULL, NULL, 235900),
(290890, '2rhqB01', NULL, NULL, 69, NULL, NULL, 235900),
(290891, '1b7yB04', NULL, NULL, 74, NULL, NULL, 235900),
(290892, '3pcoB01', NULL, NULL, 69, NULL, NULL, 235900),
(290893, '4p72A01', NULL, NULL, 69, NULL, NULL, 235900),
(290894, '1b7yB01', NULL, NULL, 70, NULL, NULL, 235900),
(290895, '3l4gB03', NULL, NULL, 74, NULL, NULL, 235900),
(290896, '3pcoB04', NULL, NULL, 75, NULL, NULL, 235900),
(290897, '4p72A04', NULL, NULL, 76, NULL, NULL, 235900),
(290898, '3pjvD01', NULL, NULL, 79, NULL, NULL, 235901),
(290899, '5iztB00', NULL, NULL, 219, NULL, NULL, 235902),
(290900, '4b2fA00', NULL, NULL, 214, NULL, NULL, 235902),
(290901, '1w33A00', NULL, NULL, 181, NULL, NULL, 235902),
(290902, '4bg5B00', NULL, NULL, 213, NULL, NULL, 235902),
(290903, '4alyB00', NULL, NULL, 201, NULL, NULL, 235902),
(290904, '3m8jA00', NULL, NULL, 111, NULL, NULL, 235903),
(290905, '2w7nA00', NULL, NULL, 101, NULL, NULL, 235903),
(290906, '2m4lA00', NULL, NULL, 99, NULL, NULL, 235904),
(290907, '3zliA02', NULL, NULL, 95, NULL, NULL, 235905);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(290908, '6f6dA02', NULL, NULL, 93, NULL, NULL, 235905),
(290909, '6fulA01', NULL, NULL, 120, NULL, NULL, 235905),
(290910, '2lorA00', NULL, NULL, 108, NULL, NULL, 235906),
(290911, '2cxhA01', NULL, NULL, 174, NULL, NULL, 235907),
(290912, '1w94A00', NULL, NULL, 156, NULL, NULL, 235907),
(290913, '2kxeA00', NULL, NULL, 75, NULL, NULL, 235908),
(290914, '4atgA00', NULL, NULL, 196, NULL, NULL, 235909),
(290915, '5dczA00', NULL, NULL, 215, NULL, NULL, 235910),
(290916, '5ws1A02', NULL, NULL, 213, NULL, NULL, 235910),
(290917, '5nwgB00', NULL, NULL, 162, NULL, NULL, 235910),
(290918, '4pnlA00', NULL, NULL, 202, NULL, NULL, 235910),
(290919, '5lx6A00', NULL, NULL, 191, NULL, NULL, 235910),
(290920, '3smjA00', NULL, NULL, 193, NULL, NULL, 235910),
(290921, '2x5yA00', NULL, NULL, 173, NULL, NULL, 235910),
(290922, '4gv2A02', NULL, NULL, 210, NULL, NULL, 235910),
(290923, '6ek3B00', NULL, NULL, 197, NULL, NULL, 235910),
(290924, '1gs0A02', NULL, NULL, 215, NULL, NULL, 235910),
(290925, '2pqfA00', NULL, NULL, 198, NULL, NULL, 235910),
(290926, '4torA00', NULL, NULL, 211, NULL, NULL, 235910),
(290927, '6i8mA02', NULL, NULL, 217, NULL, NULL, 235910),
(290928, '4zzxA02', NULL, NULL, 218, NULL, NULL, 235910),
(290929, '3lvqE02', NULL, NULL, 74, NULL, NULL, 235911),
(290930, '1vx7302', NULL, NULL, 48, NULL, NULL, 235912),
(290931, '4a17U02', NULL, NULL, 46, NULL, NULL, 235912),
(290932, '1vwxh02', NULL, NULL, 46, NULL, NULL, 235912),
(290933, '6em3h02', NULL, NULL, 46, NULL, NULL, 235912),
(290934, '4ekjA01', NULL, NULL, 161, NULL, NULL, 235913),
(290935, '1uhvA01', NULL, NULL, 156, NULL, NULL, 235913),
(290936, '2bs9A01', NULL, NULL, 137, NULL, NULL, 235913),
(290937, '6i6rB01', NULL, NULL, 165, NULL, NULL, 235913),
(290938, '4indA01', NULL, NULL, 151, NULL, NULL, 235914),
(290939, '4nphA02', NULL, NULL, 81, NULL, NULL, 235915),
(290940, '2oblA02', NULL, NULL, 74, NULL, NULL, 235915),
(290941, '3q23A04', NULL, NULL, 91, NULL, NULL, 235916),
(290942, '2dm9A00', NULL, NULL, 118, NULL, NULL, 235917),
(290943, '4efaE02', NULL, NULL, 136, NULL, NULL, 235917),
(290944, '3v6iA02', NULL, NULL, 91, NULL, NULL, 235917),
(290945, '4a2vA00', NULL, NULL, 131, NULL, NULL, 235918),
(290946, '2rqbA00', NULL, NULL, 135, NULL, NULL, 235918),
(290947, '3eqtA00', NULL, NULL, 145, NULL, NULL, 235918),
(290948, '3ga3A00', NULL, NULL, 133, NULL, NULL, 235918),
(290949, '3lrrA00', NULL, NULL, 121, NULL, NULL, 235918),
(290950, '4ae2C01', NULL, NULL, 46, NULL, NULL, 235919),
(290951, '2fsdA00', NULL, NULL, 110, NULL, NULL, 235920),
(290952, '3ut4A00', NULL, NULL, 134, NULL, NULL, 235921),
(290953, '5uwvA02', NULL, NULL, 121, NULL, NULL, 235922),
(290954, '3turB01', NULL, NULL, 128, NULL, NULL, 235922),
(290955, '4z7aA02', NULL, NULL, 127, NULL, NULL, 235922),
(290956, '5e5lB01', NULL, NULL, 95, NULL, NULL, 235922),
(290957, '4qrbA02', NULL, NULL, 120, NULL, NULL, 235922),
(290958, '6d4kA01', NULL, NULL, 92, NULL, NULL, 235922),
(290959, '4xvoA01', NULL, NULL, 95, NULL, NULL, 235922),
(290960, '3vypB01', NULL, NULL, 112, NULL, NULL, 235922),
(290961, '3e1tA02', NULL, NULL, 166, NULL, NULL, 235923),
(290962, '4qmkB03', NULL, NULL, 189, NULL, NULL, 235924),
(290963, '3tu3B03', NULL, NULL, 187, NULL, NULL, 235924),
(290964, '2yfoA01', NULL, NULL, 309, NULL, NULL, 235925),
(290965, '3mi6A01', NULL, NULL, 310, NULL, NULL, 235925),
(290966, '4fnqA01', NULL, NULL, 309, NULL, NULL, 235925),
(290967, '2xn2A01', NULL, NULL, 313, NULL, NULL, 235925),
(290968, '1p9cA01', NULL, NULL, 19, NULL, NULL, 235926),
(290969, '4aybB06', NULL, NULL, 223, NULL, NULL, 235927),
(290970, '4qiwJ06', NULL, NULL, 245, NULL, NULL, 235927),
(290971, '2a6hC01', NULL, NULL, 211, NULL, NULL, 235927),
(290972, '3h0gB06', NULL, NULL, 223, NULL, NULL, 235927),
(290973, '4c2mB06', NULL, NULL, 227, NULL, NULL, 235927),
(290974, '1twfB06', NULL, NULL, 223, NULL, NULL, 235927),
(290975, '1ynjC01', NULL, NULL, 217, NULL, NULL, 235927),
(290976, '4ljzC05', NULL, NULL, 281, NULL, NULL, 235927),
(290977, '4ljzI01', NULL, NULL, 231, NULL, NULL, 235927),
(290978, '3lxuX02', NULL, NULL, 95, NULL, NULL, 235928);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(290979, '4glxA05', NULL, NULL, 41, NULL, NULL, 235929),
(290980, '1vh6B01', NULL, NULL, 100, NULL, NULL, 235930),
(290981, '1vh6A01', NULL, NULL, 97, NULL, NULL, 235930),
(290982, '3bk6A02', NULL, NULL, 54, NULL, NULL, 235931),
(290983, '3wsxA03', NULL, NULL, 87, NULL, NULL, 235932),
(290984, '3f6kA03', NULL, NULL, 78, NULL, NULL, 235932),
(290985, '5cknA02', NULL, NULL, 44, NULL, NULL, 235933),
(290986, '1ataA00', NULL, NULL, 62, NULL, NULL, 235933),
(290987, '2flbL01', NULL, NULL, 42, NULL, NULL, 235933),
(290988, '1fakL01', NULL, NULL, 51, NULL, NULL, 235933),
(290989, '5l0rB00', NULL, NULL, 42, NULL, NULL, 235933),
(290990, '3v64C01', NULL, NULL, 42, NULL, NULL, 235933),
(290991, '2mgpA02', NULL, NULL, 52, NULL, NULL, 235933),
(290992, '2mgpA01', NULL, NULL, 47, NULL, NULL, 235933),
(290993, '2y38A02', NULL, NULL, 113, NULL, NULL, 235933),
(290994, '4xl1D01', NULL, NULL, 43, NULL, NULL, 235933),
(290995, '2i9aB01', NULL, NULL, 51, NULL, NULL, 235933),
(290996, '3fbyA01', NULL, NULL, 61, NULL, NULL, 235933),
(290997, '4cc0B03', NULL, NULL, 65, NULL, NULL, 235933),
(290998, '3sobB02', NULL, NULL, 57, NULL, NULL, 235933),
(290999, '5wb7E00', NULL, NULL, 62, NULL, NULL, 235933),
(291000, '3f6uL01', NULL, NULL, 45, NULL, NULL, 235933),
(291001, '1p0sL02', NULL, NULL, 45, NULL, NULL, 235933),
(291002, '1yukB02', NULL, NULL, 31, NULL, NULL, 235933),
(291003, '3v65D01', NULL, NULL, 44, NULL, NULL, 235933),
(291004, '5lf2A03', NULL, NULL, 47, NULL, NULL, 235933),
(291005, '1hx2A00', NULL, NULL, 60, NULL, NULL, 235933),
(291006, '1u8cB04', NULL, NULL, 40, NULL, NULL, 235933),
(291007, '3zyjB01', NULL, NULL, 86, NULL, NULL, 235933),
(291008, '5f19A01', NULL, NULL, 41, NULL, NULL, 235933),
(291009, '5vygA00', NULL, NULL, 50, NULL, NULL, 235933),
(291010, '3demA02', NULL, NULL, 44, NULL, NULL, 235933),
(291011, '3laqB01', NULL, NULL, 50, NULL, NULL, 235933),
(291012, '3fcsB05', NULL, NULL, 42, NULL, NULL, 235933),
(291013, '5ky2B00', NULL, NULL, 40, NULL, NULL, 235933),
(291014, '3k6sH04', NULL, NULL, 38, NULL, NULL, 235933),
(291015, '3k6sD05', NULL, NULL, 57, NULL, NULL, 235933),
(291016, '1ccvA00', NULL, NULL, 56, NULL, NULL, 235933),
(291017, '3fcsB04', NULL, NULL, 87, NULL, NULL, 235933),
(291018, '1pfxL02', NULL, NULL, 40, NULL, NULL, 235933),
(291019, '2w2qE00', NULL, NULL, 47, NULL, NULL, 235933),
(291020, '1l3yA00', NULL, NULL, 41, NULL, NULL, 235933),
(291021, '1lmjA00', NULL, NULL, 86, NULL, NULL, 235933),
(291022, '5vc1A02', NULL, NULL, 38, NULL, NULL, 235933),
(291023, '4bdxA00', NULL, NULL, 85, NULL, NULL, 235933),
(291024, '1kloA01', NULL, NULL, 53, NULL, NULL, 235933),
(291025, '1kloA03', NULL, NULL, 53, NULL, NULL, 235933),
(291026, '2k2sB00', NULL, NULL, 61, NULL, NULL, 235933),
(291027, '1kloA02', NULL, NULL, 56, NULL, NULL, 235933),
(291028, '3zygB01', NULL, NULL, 90, NULL, NULL, 235933),
(291029, '1z6cA00', NULL, NULL, 87, NULL, NULL, 235933),
(291030, '1ijqA02', NULL, NULL, 54, NULL, NULL, 235933),
(291031, '1nziB02', NULL, NULL, 42, NULL, NULL, 235933),
(291032, '1n1iC02', NULL, NULL, 51, NULL, NULL, 235933),
(291033, '6mv4L00', NULL, NULL, 54, NULL, NULL, 235933),
(291034, '2bz6L00', NULL, NULL, 53, NULL, NULL, 235933),
(291035, '3k9xA02', NULL, NULL, 50, NULL, NULL, 235933),
(291036, '4bxwA01', NULL, NULL, 38, NULL, NULL, 235933),
(291037, '3k9xA01', NULL, NULL, 41, NULL, NULL, 235933),
(291038, '1n7dA08', NULL, NULL, 45, NULL, NULL, 235933),
(291039, '1n7dA07', NULL, NULL, 38, NULL, NULL, 235933),
(291040, '2bouA01', NULL, NULL, 47, NULL, NULL, 235933),
(291041, '1haeA00', NULL, NULL, 63, NULL, NULL, 235933),
(291042, '2bouA02', NULL, NULL, 49, NULL, NULL, 235933),
(291043, '3qcwA03', NULL, NULL, 43, NULL, NULL, 235933),
(291044, '2bouA03', NULL, NULL, 47, NULL, NULL, 235933),
(291045, '1a3pA00', NULL, NULL, 45, NULL, NULL, 235933),
(291046, '1emnA01', NULL, NULL, 27, NULL, NULL, 235933),
(291047, '3sovA02', NULL, NULL, 56, NULL, NULL, 235933),
(291048, '2p26A03', NULL, NULL, 41, NULL, NULL, 235933),
(291049, '2p26A04', NULL, NULL, 55, NULL, NULL, 235933),
(291050, '1tpgA02', NULL, NULL, 45, NULL, NULL, 235933);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(291051, '1eaiC00', NULL, NULL, 61, NULL, NULL, 235933),
(291052, '1g1sA02', NULL, NULL, 38, NULL, NULL, 235933),
(291053, '4d90A01', NULL, NULL, 48, NULL, NULL, 235933),
(291054, '2m74A02', NULL, NULL, 67, NULL, NULL, 235933),
(291055, '2m74A01', NULL, NULL, 69, NULL, NULL, 235933),
(291056, '4d90A02', NULL, NULL, 95, NULL, NULL, 235933),
(291057, '2wg3D02', NULL, NULL, 55, NULL, NULL, 235933),
(291058, '1ob1C01', NULL, NULL, 44, NULL, NULL, 235933),
(291059, '2p3fN00', NULL, NULL, 78, NULL, NULL, 235933),
(291060, '3u7uK00', NULL, NULL, 55, NULL, NULL, 235933),
(291061, '1eqgA01', NULL, NULL, 53, NULL, NULL, 235933),
(291062, '1szbA02', NULL, NULL, 45, NULL, NULL, 235933),
(291063, '1ob1C02', NULL, NULL, 55, NULL, NULL, 235933),
(291064, '2wfxB02', NULL, NULL, 87, NULL, NULL, 235933),
(291065, '1yo8A02', NULL, NULL, 56, NULL, NULL, 235933),
(291066, '1yo8A03', NULL, NULL, 40, NULL, NULL, 235933),
(291067, '1b9wA02', NULL, NULL, 38, NULL, NULL, 235933),
(291068, '1yo8A01', NULL, NULL, 50, NULL, NULL, 235933),
(291069, '1p9jA00', NULL, NULL, 54, NULL, NULL, 235933),
(291070, '1b9wA01', NULL, NULL, 51, NULL, NULL, 235933),
(291071, '5l0vB00', NULL, NULL, 42, NULL, NULL, 235933),
(291072, '1g1tA02', NULL, NULL, 38, NULL, NULL, 235933),
(291073, '1jv2B03', NULL, NULL, 73, NULL, NULL, 235933),
(291074, '3cfwA02', NULL, NULL, 45, NULL, NULL, 235933),
(291075, '2ygoA02', NULL, NULL, 38, NULL, NULL, 235933),
(291076, '1apoA00', NULL, NULL, 42, NULL, NULL, 235933),
(291077, '3h5cB01', NULL, NULL, 39, NULL, NULL, 235933),
(291078, '1ioxA00', NULL, NULL, 50, NULL, NULL, 235933),
(291079, '3fcsD04', NULL, NULL, 40, NULL, NULL, 235933),
(291080, '3fcsD05', NULL, NULL, 48, NULL, NULL, 235933),
(291081, '4xbmA03', NULL, NULL, 66, NULL, NULL, 235933),
(291082, '1xdtR00', NULL, NULL, 41, NULL, NULL, 235933),
(291083, '3c9aC00', NULL, NULL, 52, NULL, NULL, 235933),
(291084, '1moxD00', NULL, NULL, 50, NULL, NULL, 235933),
(291085, '2jkhL00', NULL, NULL, 55, NULL, NULL, 235933),
(291086, '1nqlB00', NULL, NULL, 53, NULL, NULL, 235933),
(291087, '2kb9A00', NULL, NULL, 44, NULL, NULL, 235933),
(291088, '3f1sB01', NULL, NULL, 53, NULL, NULL, 235933),
(291089, '4jzeL00', NULL, NULL, 55, NULL, NULL, 235933),
(291090, '1autL02', NULL, NULL, 52, NULL, NULL, 235933),
(291091, '5e8dA00', NULL, NULL, 44, NULL, NULL, 235933),
(291092, '2h9eC01', NULL, NULL, 75, NULL, NULL, 235933),
(291093, '2rnlA00', NULL, NULL, 50, NULL, NULL, 235933),
(291094, '1n1iA01', NULL, NULL, 54, NULL, NULL, 235933),
(291095, '4d0eA03', NULL, NULL, 52, NULL, NULL, 235933),
(291096, '4d0eA01', NULL, NULL, 45, NULL, NULL, 235933),
(291097, '4xl1A02', NULL, NULL, 38, NULL, NULL, 235933),
(291098, '4xl1A03', NULL, NULL, 37, NULL, NULL, 235933),
(291099, '4aqtA02', NULL, NULL, 99, NULL, NULL, 235933),
(291100, '1kigL00', NULL, NULL, 51, NULL, NULL, 235933),
(291101, '2nprA02', NULL, NULL, 38, NULL, NULL, 235933),
(291102, '2nprA01', NULL, NULL, 52, NULL, NULL, 235933),
(291103, '1dx5I01', NULL, NULL, 45, NULL, NULL, 235933),
(291104, '1gk5A00', NULL, NULL, 49, NULL, NULL, 235933),
(291105, '4cufA02', NULL, NULL, 38, NULL, NULL, 235933),
(291106, '1dx5I02', NULL, NULL, 33, NULL, NULL, 235933),
(291107, '5jb9E00', NULL, NULL, 58, NULL, NULL, 235933),
(291108, '1emoA00', NULL, NULL, 82, NULL, NULL, 235933),
(291109, '1dx5I03', NULL, NULL, 40, NULL, NULL, 235933),
(291110, '2w86A03', NULL, NULL, 42, NULL, NULL, 235933),
(291111, '2fd6A01', NULL, NULL, 39, NULL, NULL, 235933),
(291112, '3kl6B00', NULL, NULL, 57, NULL, NULL, 235933),
(291113, '3ho3A02', NULL, NULL, 90, NULL, NULL, 235933),
(291114, '3k9xC02', NULL, NULL, 44, NULL, NULL, 235933),
(291115, '3k9xC01', NULL, NULL, 26, NULL, NULL, 235933),
(291116, '2ygqA02', NULL, NULL, 93, NULL, NULL, 235933),
(291117, '1apqA00', NULL, NULL, 53, NULL, NULL, 235933),
(291118, '3nt1A01', NULL, NULL, 41, NULL, NULL, 235933),
(291119, '2w86A01', NULL, NULL, 45, NULL, NULL, 235933),
(291120, '1uzkA01', NULL, NULL, 45, NULL, NULL, 235933),
(291121, '1ygcL00', NULL, NULL, 63, NULL, NULL, 235933),
(291122, '1tozA02', NULL, NULL, 73, NULL, NULL, 235933);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(291123, '1cejA02', NULL, NULL, 52, NULL, NULL, 235933),
(291124, '1uzkA03', NULL, NULL, 42, NULL, NULL, 235933),
(291125, '2p28B03', NULL, NULL, 52, NULL, NULL, 235933),
(291126, '3p5bL03', NULL, NULL, 46, NULL, NULL, 235933),
(291127, '2p28B04', NULL, NULL, 38, NULL, NULL, 235933),
(291128, '2dduA02', NULL, NULL, 35, NULL, NULL, 235933),
(291129, '3p5bL01', NULL, NULL, 75, NULL, NULL, 235933),
(291130, '3asiA02', NULL, NULL, 42, NULL, NULL, 235933),
(291131, '1x7aL02', NULL, NULL, 42, NULL, NULL, 235933),
(291132, '1q4gA01', NULL, NULL, 41, NULL, NULL, 235933),
(291133, '2w57A02', NULL, NULL, 49, NULL, NULL, 235934),
(291134, '5fd5A02', NULL, NULL, 55, NULL, NULL, 235934),
(291135, '4rayA02', NULL, NULL, 59, NULL, NULL, 235934),
(291136, '4lmyA02', NULL, NULL, 68, NULL, NULL, 235934),
(291137, '3eyyA02', NULL, NULL, 61, NULL, NULL, 235934),
(291138, '1mzbA02', NULL, NULL, 51, NULL, NULL, 235934),
(291139, '6d57A02', NULL, NULL, 61, NULL, NULL, 235934),
(291140, '2xigA02', NULL, NULL, 57, NULL, NULL, 235934),
(291141, '2fe3A02', NULL, NULL, 58, NULL, NULL, 235934),
(291142, '2o03A02', NULL, NULL, 56, NULL, NULL, 235934),
(291143, '3mwmA02', NULL, NULL, 55, NULL, NULL, 235934),
(291144, '4mtdA02', NULL, NULL, 63, NULL, NULL, 235934),
(291145, '1y7xA02', NULL, NULL, 56, NULL, NULL, 235935),
(291146, '3gf5B07', NULL, NULL, 60, NULL, NULL, 235935),
(291147, '1y7xA01', NULL, NULL, 47, NULL, NULL, 235935),
(291148, '3gnfB04', NULL, NULL, 53, NULL, NULL, 235935),
(291149, '3gnfB05', NULL, NULL, 55, NULL, NULL, 235935),
(291150, '3gnfB03', NULL, NULL, 52, NULL, NULL, 235935),
(291151, '2zuoA04', NULL, NULL, 53, NULL, NULL, 235935),
(291152, '2zuoA07', NULL, NULL, 56, NULL, NULL, 235935),
(291153, '2zuoA05', NULL, NULL, 55, NULL, NULL, 235935),
(291154, '3hhdA05', NULL, NULL, 60, NULL, NULL, 235936),
(291155, '5my2A05', NULL, NULL, 60, NULL, NULL, 235936),
(291156, '2wmfA02', NULL, NULL, 90, NULL, NULL, 235937),
(291157, '4d6gA02', NULL, NULL, 94, NULL, NULL, 235937),
(291158, '1u94A02', NULL, NULL, 59, NULL, NULL, 235938),
(291159, '2g88A02', NULL, NULL, 79, NULL, NULL, 235938),
(291160, '5jrjA02', NULL, NULL, 59, NULL, NULL, 235938),
(291161, '2zr9A02', NULL, NULL, 60, NULL, NULL, 235938),
(291162, '4ppfA02', NULL, NULL, 61, NULL, NULL, 235938),
(291163, '3hr8A02', NULL, NULL, 86, NULL, NULL, 235938),
(291164, '1xp8A02', NULL, NULL, 60, NULL, NULL, 235938),
(291165, '1gm5A01', NULL, NULL, 101, NULL, NULL, 235939),
(291166, '2p5zX04', NULL, NULL, 85, NULL, NULL, 235940),
(291167, '3pqiA01', NULL, NULL, 102, NULL, NULL, 235940),
(291168, '3qr8A01', NULL, NULL, 90, NULL, NULL, 235940),
(291169, '4uhvA04', NULL, NULL, 103, NULL, NULL, 235940),
(291170, '2lqiB00', NULL, NULL, 52, NULL, NULL, 235941),
(291171, '3h9nA01', NULL, NULL, 89, NULL, NULL, 235942),
(291172, '2qggA01', NULL, NULL, 98, NULL, NULL, 235942),
(291173, '2dyiA01', NULL, NULL, 84, NULL, NULL, 235942),
(291174, '2f1lA01', NULL, NULL, 89, NULL, NULL, 235942),
(291175, '5an9A03', NULL, NULL, 124, NULL, NULL, 235943),
(291176, '4a17B03', NULL, NULL, 119, NULL, NULL, 235943),
(291177, '1vx7E03', NULL, NULL, 118, NULL, NULL, 235943),
(291178, '1vq8B03', NULL, NULL, 111, NULL, NULL, 235943),
(291179, '3o58C03', NULL, NULL, 121, NULL, NULL, 235943),
(291180, '1vwxB03', NULL, NULL, 123, NULL, NULL, 235943),
(291181, '3e4wA01', NULL, NULL, 113, NULL, NULL, 235944),
(291182, '3kd4A01', NULL, NULL, 209, NULL, NULL, 235945),
(291183, '1hksA00', NULL, NULL, 106, NULL, NULL, 235946),
(291184, '3b73B00', NULL, NULL, 90, NULL, NULL, 235946),
(291185, '1o57A01', NULL, NULL, 73, NULL, NULL, 235946),
(291186, '1bm9A00', NULL, NULL, 122, NULL, NULL, 235946),
(291187, '3d5lB01', NULL, NULL, 108, NULL, NULL, 235946),
(291188, '5x12A01', NULL, NULL, 98, NULL, NULL, 235946),
(291189, '1zgaA01', NULL, NULL, 104, NULL, NULL, 235946),
(291190, '4r8hB02', NULL, NULL, 72, NULL, NULL, 235946),
(291191, '1mzbA01', NULL, NULL, 85, NULL, NULL, 235946),
(291192, '3lapD01', NULL, NULL, 68, NULL, NULL, 235946),
(291193, '2fe3B01', NULL, NULL, 87, NULL, NULL, 235946),
(291194, '2nriB00', NULL, NULL, 100, NULL, NULL, 235946);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(291195, '1okrA01', NULL, NULL, 64, NULL, NULL, 235946),
(291196, '2g7hA02', NULL, NULL, 81, NULL, NULL, 235946),
(291197, '1jgsA00', NULL, NULL, 138, NULL, NULL, 235946),
(291198, '3e3vA01', NULL, NULL, 65, NULL, NULL, 235946),
(291199, '3bwgB01', NULL, NULL, 73, NULL, NULL, 235946),
(291200, '3hsrA00', NULL, NULL, 140, NULL, NULL, 235946),
(291201, '2mlgA00', NULL, NULL, 84, NULL, NULL, 235946),
(291202, '1l3lA02', NULL, NULL, 63, NULL, NULL, 235946),
(291203, '3e3vA02', NULL, NULL, 45, NULL, NULL, 235946),
(291204, '3e3vA03', NULL, NULL, 67, NULL, NULL, 235946),
(291205, '1fzpD00', NULL, NULL, 123, NULL, NULL, 235946),
(291206, '2ve8D01', NULL, NULL, 66, NULL, NULL, 235946),
(291207, '2wteA02', NULL, NULL, 72, NULL, NULL, 235946),
(291208, '1t6sB02', NULL, NULL, 77, NULL, NULL, 235946),
(291209, '4n9hA02', NULL, NULL, 78, NULL, NULL, 235946),
(291210, '4rayA01', NULL, NULL, 86, NULL, NULL, 235946),
(291211, '2nazA00', NULL, NULL, 118, NULL, NULL, 235946),
(291212, '2oz6A02', NULL, NULL, 69, NULL, NULL, 235946),
(291213, '1hsjB03', NULL, NULL, 86, NULL, NULL, 235946),
(291214, '3kfwX01', NULL, NULL, 76, NULL, NULL, 235946),
(291215, '1hstA00', NULL, NULL, 90, NULL, NULL, 235946),
(291216, '4ixaB00', NULL, NULL, 110, NULL, NULL, 235946),
(291217, '4rgxB00', NULL, NULL, 162, NULL, NULL, 235946),
(291218, '5dcmA00', NULL, NULL, 97, NULL, NULL, 235946),
(291219, '1x1aA01', NULL, NULL, 177, NULL, NULL, 235946),
(291220, '2v1uA03', NULL, NULL, 100, NULL, NULL, 235946),
(291221, '2lsoA00', NULL, NULL, 83, NULL, NULL, 235946),
(291222, '2m8eA00', NULL, NULL, 57, NULL, NULL, 235946),
(291223, '2ipqX01', NULL, NULL, 56, NULL, NULL, 235946),
(291224, '4bpe700', NULL, NULL, 102, NULL, NULL, 235946),
(291225, '3cuqA02', NULL, NULL, 81, NULL, NULL, 235946),
(291226, '4ijaA01', NULL, NULL, 70, NULL, NULL, 235946),
(291227, '3qphA01', NULL, NULL, 104, NULL, NULL, 235946),
(291228, '3cuqA03', NULL, NULL, 86, NULL, NULL, 235946),
(291229, '2nnnC00', NULL, NULL, 140, NULL, NULL, 235946),
(291230, '2v9vA01', NULL, NULL, 60, NULL, NULL, 235946),
(291231, '4g6dA00', NULL, NULL, 73, NULL, NULL, 235946),
(291232, '2v9vA02', NULL, NULL, 69, NULL, NULL, 235946),
(291233, '3sxyA01', NULL, NULL, 77, NULL, NULL, 235946),
(291234, '1w4mA00', NULL, NULL, 103, NULL, NULL, 235946),
(291235, '4i2oA02', NULL, NULL, 88, NULL, NULL, 235946),
(291236, '1u5tA02', NULL, NULL, 75, NULL, NULL, 235946),
(291237, '5ilsA00', NULL, NULL, 101, NULL, NULL, 235946),
(291238, '2z3yA01', NULL, NULL, 108, NULL, NULL, 235946),
(291239, '1u5tA03', NULL, NULL, 72, NULL, NULL, 235946),
(291240, '5deqB02', NULL, NULL, 83, NULL, NULL, 235946),
(291241, '2fnaA03', NULL, NULL, 73, NULL, NULL, 235946),
(291242, '1xb4B02', NULL, NULL, 77, NULL, NULL, 235946),
(291243, '1yg2A01', NULL, NULL, 89, NULL, NULL, 235946),
(291244, '3h92A00', NULL, NULL, 92, NULL, NULL, 235946),
(291245, '3d5lA03', NULL, NULL, 52, NULL, NULL, 235946),
(291246, '1opcA00', NULL, NULL, 110, NULL, NULL, 235946),
(291247, '3d5lA02', NULL, NULL, 45, NULL, NULL, 235946),
(291248, '3b02A02', NULL, NULL, 85, NULL, NULL, 235946),
(291249, '2qbyA03', NULL, NULL, 103, NULL, NULL, 235946),
(291250, '1o7fA02', NULL, NULL, 156, NULL, NULL, 235946),
(291251, '1ttyA00', NULL, NULL, 87, NULL, NULL, 235946),
(291252, '2od5A00', NULL, NULL, 97, NULL, NULL, 235946),
(291253, '1ldjA07', NULL, NULL, 105, NULL, NULL, 235946),
(291254, '1ldjA06', NULL, NULL, 68, NULL, NULL, 235946),
(291255, '1dp7P00', NULL, NULL, 76, NULL, NULL, 235946),
(291256, '3s2wG00', NULL, NULL, 140, NULL, NULL, 235946),
(291257, '2heoA00', NULL, NULL, 67, NULL, NULL, 235946),
(291258, '1t6sA01', NULL, NULL, 86, NULL, NULL, 235946),
(291259, '5d4sB00', NULL, NULL, 88, NULL, NULL, 235946),
(291260, '5dd8A00', NULL, NULL, 181, NULL, NULL, 235946),
(291261, '4pggA01', NULL, NULL, 110, NULL, NULL, 235946),
(291262, '1fseB00', NULL, NULL, 74, NULL, NULL, 235946),
(291263, '4lmyA01', NULL, NULL, 95, NULL, NULL, 235946),
(291264, '1kq8A00', NULL, NULL, 81, NULL, NULL, 235946),
(291265, '1z91A00', NULL, NULL, 147, NULL, NULL, 235946);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(291266, '5kvrA00', NULL, NULL, 77, NULL, NULL, 235946),
(291267, '1i27A00', NULL, NULL, 73, NULL, NULL, 235946),
(291268, '2m5wA00', NULL, NULL, 91, NULL, NULL, 235946),
(291269, '3eetA01', NULL, NULL, 67, NULL, NULL, 235946),
(291270, '2qm3A01', NULL, NULL, 83, NULL, NULL, 235946),
(291271, '5it3A00', NULL, NULL, 85, NULL, NULL, 235946),
(291272, '5vyvA02', NULL, NULL, 79, NULL, NULL, 235946),
(291273, '4o3mA03', NULL, NULL, 122, NULL, NULL, 235946),
(291274, '4r1hA01', NULL, NULL, 77, NULL, NULL, 235946),
(291275, '1mkmB01', NULL, NULL, 78, NULL, NULL, 235946),
(291276, '1iuyA00', NULL, NULL, 92, NULL, NULL, 235946),
(291277, '6n9gA01', NULL, NULL, 100, NULL, NULL, 235946),
(291278, '4bqaA00', NULL, NULL, 142, NULL, NULL, 235946),
(291279, '3cuqB02', NULL, NULL, 80, NULL, NULL, 235946),
(291280, '3cuqB03', NULL, NULL, 70, NULL, NULL, 235946),
(291281, '1f9nB01', NULL, NULL, 60, NULL, NULL, 235946),
(291282, '1aoyA00', NULL, NULL, 78, NULL, NULL, 235946),
(291283, '1ldkB03', NULL, NULL, 83, NULL, NULL, 235946),
(291284, '3dp7B01', NULL, NULL, 98, NULL, NULL, 235946),
(291285, '3eyiB00', NULL, NULL, 72, NULL, NULL, 235946),
(291286, '1ylfA00', NULL, NULL, 149, NULL, NULL, 235946),
(291287, '3gw6D02', NULL, NULL, 168, NULL, NULL, 235946),
(291288, '1yo5C00', NULL, NULL, 97, NULL, NULL, 235946),
(291289, '5iceA01', NULL, NULL, 101, NULL, NULL, 235946),
(291290, '3c18A03', NULL, NULL, 57, NULL, NULL, 235946),
(291291, '1yqaA00', NULL, NULL, 87, NULL, NULL, 235946),
(291292, '1u5tB01', NULL, NULL, 85, NULL, NULL, 235946),
(291293, '1u5tB02', NULL, NULL, 69, NULL, NULL, 235946),
(291294, '3f3xA00', NULL, NULL, 144, NULL, NULL, 235946),
(291295, '2ff4A01', NULL, NULL, 106, NULL, NULL, 235946),
(291296, '3iwfB00', NULL, NULL, 107, NULL, NULL, 235946),
(291297, '5dcaA11', NULL, NULL, 105, NULL, NULL, 235946),
(291298, '2o61A03', NULL, NULL, 113, NULL, NULL, 235946),
(291299, '3ke2B00', NULL, NULL, 117, NULL, NULL, 235946),
(291300, '4avpA00', NULL, NULL, 106, NULL, NULL, 235946),
(291301, '3f8mB01', NULL, NULL, 61, NULL, NULL, 235946),
(291302, '6blbA03', NULL, NULL, 92, NULL, NULL, 235946),
(291303, '3l09A02', NULL, NULL, 84, NULL, NULL, 235946),
(291304, '1ka8A00', NULL, NULL, 100, NULL, NULL, 235946),
(291305, '6az1N00', NULL, NULL, 91, NULL, NULL, 235946),
(291306, '6g5iK00', NULL, NULL, 97, NULL, NULL, 235946),
(291307, '4mnuB00', NULL, NULL, 135, NULL, NULL, 235946),
(291308, '4ev0A02', NULL, NULL, 77, NULL, NULL, 235946),
(291309, '5ffxD00', NULL, NULL, 137, NULL, NULL, 235946),
(291310, '2xkoA02', NULL, NULL, 94, NULL, NULL, 235946),
(291311, '6iwtA01', NULL, NULL, 100, NULL, NULL, 235946),
(291312, '3fzvB01', NULL, NULL, 87, NULL, NULL, 235946),
(291313, '3la7B02', NULL, NULL, 94, NULL, NULL, 235946),
(291314, '2gwrA02', NULL, NULL, 113, NULL, NULL, 235946),
(291315, '2dllA01', NULL, NULL, 106, NULL, NULL, 235946),
(291316, '2rkhA01', NULL, NULL, 102, NULL, NULL, 235946),
(291317, '3kloA02', NULL, NULL, 68, NULL, NULL, 235946),
(291318, '1ulyA01', NULL, NULL, 90, NULL, NULL, 235946),
(291319, '3tduD00', NULL, NULL, 77, NULL, NULL, 235946),
(291320, '4ipaA02', NULL, NULL, 61, NULL, NULL, 235946),
(291321, '2ga1A02', NULL, NULL, 74, NULL, NULL, 235946),
(291322, '2pq8A03', NULL, NULL, 72, NULL, NULL, 235946),
(291323, '4f92B03', NULL, NULL, 92, NULL, NULL, 235946),
(291324, '1zljA00', NULL, NULL, 78, NULL, NULL, 235946),
(291325, '2g9wA01', NULL, NULL, 72, NULL, NULL, 235946),
(291326, '1b9mB01', NULL, NULL, 110, NULL, NULL, 235946),
(291327, '4kt5C00', NULL, NULL, 96, NULL, NULL, 235946),
(291328, '3lfkD00', NULL, NULL, 129, NULL, NULL, 235946),
(291329, '4f7zA02', NULL, NULL, 105, NULL, NULL, 235946),
(291330, '2p5kA00', NULL, NULL, 64, NULL, NULL, 235946),
(291331, '5vyvB01', NULL, NULL, 94, NULL, NULL, 235946),
(291332, '5d5vB00', NULL, NULL, 107, NULL, NULL, 235946),
(291333, '5optn00', NULL, NULL, 99, NULL, NULL, 235946),
(291334, '2k27A01', NULL, NULL, 77, NULL, NULL, 235946),
(291335, '2o3fB00', NULL, NULL, 86, NULL, NULL, 235946),
(291336, '1sfxB00', NULL, NULL, 109, NULL, NULL, 235946);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(291337, '4f92B09', NULL, NULL, 87, NULL, NULL, 235946),
(291338, '1k78A01', NULL, NULL, 66, NULL, NULL, 235946),
(291339, '2zkzD00', NULL, NULL, 99, NULL, NULL, 235946),
(291340, '1kyzA01', NULL, NULL, 115, NULL, NULL, 235946),
(291341, '4cicB00', NULL, NULL, 153, NULL, NULL, 235946),
(291342, '5fd5A01', NULL, NULL, 86, NULL, NULL, 235946),
(291343, '5eehB01', NULL, NULL, 97, NULL, NULL, 235946),
(291344, '4kfcB02', NULL, NULL, 99, NULL, NULL, 235946),
(291345, '2jtvA00', NULL, NULL, 65, NULL, NULL, 235946),
(291346, '1xd7A00', NULL, NULL, 145, NULL, NULL, 235946),
(291347, '3n97A00', NULL, NULL, 72, NULL, NULL, 235946),
(291348, '3iwzA02', NULL, NULL, 69, NULL, NULL, 235946),
(291349, '5fgmA00', NULL, NULL, 69, NULL, NULL, 235946),
(291350, '2fu4A00', NULL, NULL, 83, NULL, NULL, 235946),
(291351, '5aipB00', NULL, NULL, 146, NULL, NULL, 235946),
(291352, '3dplC03', NULL, NULL, 83, NULL, NULL, 235946),
(291353, '3f8mA01', NULL, NULL, 78, NULL, NULL, 235946),
(291354, '4hw0C00', NULL, NULL, 104, NULL, NULL, 235946),
(291355, '3elkB00', NULL, NULL, 117, NULL, NULL, 235946),
(291356, '1lq1B00', NULL, NULL, 120, NULL, NULL, 235946),
(291357, '3t5xA02', NULL, NULL, 72, NULL, NULL, 235946),
(291358, '2x4hA00', NULL, NULL, 139, NULL, NULL, 235946),
(291359, '2d1vA00', NULL, NULL, 108, NULL, NULL, 235946),
(291360, '5cyvA00', NULL, NULL, 146, NULL, NULL, 235946),
(291361, '3tgnB02', NULL, NULL, 63, NULL, NULL, 235946),
(291362, '2dqlA00', NULL, NULL, 115, NULL, NULL, 235946),
(291363, '1duxC00', NULL, NULL, 94, NULL, NULL, 235946),
(291364, '4jqfA02', NULL, NULL, 73, NULL, NULL, 235946),
(291365, '2gxgA00', NULL, NULL, 146, NULL, NULL, 235946),
(291366, '3boqA00', NULL, NULL, 160, NULL, NULL, 235946),
(291367, '2nraC01', NULL, NULL, 166, NULL, NULL, 235946),
(291368, '2nraC02', NULL, NULL, 110, NULL, NULL, 235946),
(291369, '5uagF02', NULL, NULL, 78, NULL, NULL, 235946),
(291370, '1p6rA00', NULL, NULL, 82, NULL, NULL, 235946),
(291371, '1qgpA00', NULL, NULL, 77, NULL, NULL, 235946),
(291372, '2di3A01', NULL, NULL, 76, NULL, NULL, 235946),
(291373, '4esbA00', NULL, NULL, 115, NULL, NULL, 235946),
(291374, '2ysrA00', NULL, NULL, 105, NULL, NULL, 235946),
(291375, '6cc0A02', NULL, NULL, 70, NULL, NULL, 235946),
(291376, '5u8jB02', NULL, NULL, 81, NULL, NULL, 235946),
(291377, '2fmlB03', NULL, NULL, 74, NULL, NULL, 235946),
(291378, '2q0oA02', NULL, NULL, 67, NULL, NULL, 235946),
(291379, '3fx3B02', NULL, NULL, 97, NULL, NULL, 235946),
(291380, '5e8gA00', NULL, NULL, 100, NULL, NULL, 235946),
(291381, '3i4pA01', NULL, NULL, 53, NULL, NULL, 235946),
(291382, '2esnA01', NULL, NULL, 93, NULL, NULL, 235946),
(291383, '2o3fC00', NULL, NULL, 86, NULL, NULL, 235946),
(291384, '2rqpA00', NULL, NULL, 88, NULL, NULL, 235946),
(291385, '3co6C00', NULL, NULL, 100, NULL, NULL, 235946),
(291386, '2rn7A01', NULL, NULL, 66, NULL, NULL, 235946),
(291387, '2zfwA00', NULL, NULL, 126, NULL, NULL, 235946),
(291388, '2p5vA01', NULL, NULL, 52, NULL, NULL, 235946),
(291389, '1ft9A02', NULL, NULL, 90, NULL, NULL, 235946),
(291390, '5cvrA02', NULL, NULL, 86, NULL, NULL, 235946),
(291391, '4y13A02', NULL, NULL, 70, NULL, NULL, 235946),
(291392, '1bjaA00', NULL, NULL, 95, NULL, NULL, 235946),
(291393, '1pueF00', NULL, NULL, 89, NULL, NULL, 235946),
(291394, '5gjkA01', NULL, NULL, 75, NULL, NULL, 235946),
(291395, '2dk5A01', NULL, NULL, 66, NULL, NULL, 235946),
(291396, '4p55B00', NULL, NULL, 108, NULL, NULL, 235946),
(291397, '1s7oB00', NULL, NULL, 113, NULL, NULL, 235946),
(291398, '2vn2C00', NULL, NULL, 128, NULL, NULL, 235946),
(291399, '3aafA00', NULL, NULL, 134, NULL, NULL, 235946),
(291400, '1oyiA00', NULL, NULL, 82, NULL, NULL, 235946),
(291401, '3wtsC00', NULL, NULL, 123, NULL, NULL, 235946),
(291402, '2v7fA00', NULL, NULL, 150, NULL, NULL, 235946),
(291403, '2xvcA00', NULL, NULL, 59, NULL, NULL, 235946),
(291404, '5dukB00', NULL, NULL, 77, NULL, NULL, 235946),
(291405, '4llgL04', NULL, NULL, 86, NULL, NULL, 235946),
(291406, '1if1B00', NULL, NULL, 113, NULL, NULL, 235946),
(291407, '4m9sB04', NULL, NULL, 177, NULL, NULL, 235946); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(291408, '5l87A00', NULL, NULL, 69, NULL, NULL, 235946),
(291409, '2c6yB00', NULL, NULL, 111, NULL, NULL, 235946),
(291410, '3e6bA02', NULL, NULL, 84, NULL, NULL, 235946),
(291411, '5bpdD01', NULL, NULL, 75, NULL, NULL, 235946),
(291412, '3wg9B01', NULL, NULL, 77, NULL, NULL, 235946),
(291413, '1hw1A01', NULL, NULL, 79, NULL, NULL, 235946),
(291414, '5ilvA00', NULL, NULL, 92, NULL, NULL, 235946),
(291415, '1fokA02', NULL, NULL, 87, NULL, NULL, 235946),
(291416, '2pjpA02', NULL, NULL, 61, NULL, NULL, 235946),
(291417, '2pjpA01', NULL, NULL, 60, NULL, NULL, 235946),
(291418, '1xgsA02', NULL, NULL, 77, NULL, NULL, 235946),
(291419, '5xxuK00', NULL, NULL, 100, NULL, NULL, 235946),
(291420, '2zbkA01', NULL, NULL, 158, NULL, NULL, 235946),
(291421, '3gvaA00', NULL, NULL, 116, NULL, NULL, 235946),
(291422, '2mbfA01', NULL, NULL, 97, NULL, NULL, 235946),
(291423, '2pbiA01', NULL, NULL, 112, NULL, NULL, 235946),
(291424, '3dkwG02', NULL, NULL, 81, NULL, NULL, 235946),
(291425, '1yioA02', NULL, NULL, 67, NULL, NULL, 235946),
(291426, '2j5pA01', NULL, NULL, 70, NULL, NULL, 235946),
(291427, '3e6mA00', NULL, NULL, 161, NULL, NULL, 235946),
(291428, '1wwxA01', NULL, NULL, 84, NULL, NULL, 235946),
(291429, '4l5jB01', NULL, NULL, 64, NULL, NULL, 235946),
(291430, '2z99A01', NULL, NULL, 95, NULL, NULL, 235946),
(291431, '2z99A02', NULL, NULL, 73, NULL, NULL, 235946),
(291432, '3lwfA01', NULL, NULL, 125, NULL, NULL, 235946),
(291433, '1hkqA00', NULL, NULL, 132, NULL, NULL, 235946),
(291434, '4hlyA00', NULL, NULL, 108, NULL, NULL, 235946),
(291435, '2yu3A01', NULL, NULL, 87, NULL, NULL, 235946),
(291436, '1u78A02', NULL, NULL, 45, NULL, NULL, 235946),
(291437, '3u1dB00', NULL, NULL, 151, NULL, NULL, 235946),
(291438, '3edpA01', NULL, NULL, 84, NULL, NULL, 235946),
(291439, '2fxaA00', NULL, NULL, 169, NULL, NULL, 235946),
(291440, '3hugA00', NULL, NULL, 92, NULL, NULL, 235946),
(291441, '4wcgA00', NULL, NULL, 62, NULL, NULL, 235946),
(291442, '2f2eA01', NULL, NULL, 91, NULL, NULL, 235946),
(291443, '6el8A00', NULL, NULL, 99, NULL, NULL, 235946),
(291444, '2pmuC00', NULL, NULL, 110, NULL, NULL, 235946),
(291445, '5dv5A01', NULL, NULL, 69, NULL, NULL, 235946),
(291446, '1y0uA00', NULL, NULL, 96, NULL, NULL, 235946),
(291447, '1s6lA01', NULL, NULL, 52, NULL, NULL, 235946),
(291448, '1hqcA03', NULL, NULL, 81, NULL, NULL, 235946),
(291449, '3bp8A01', NULL, NULL, 82, NULL, NULL, 235946),
(291450, '2zcwA02', NULL, NULL, 85, NULL, NULL, 235946),
(291451, '1pdnC02', NULL, NULL, 59, NULL, NULL, 235946),
(291452, '3bddD00', NULL, NULL, 142, NULL, NULL, 235946),
(291453, '2jrtA01', NULL, NULL, 86, NULL, NULL, 235946),
(291454, '4i98C01', NULL, NULL, 76, NULL, NULL, 235946),
(291455, '4ou0A00', NULL, NULL, 73, NULL, NULL, 235946),
(291456, '4i98C02', NULL, NULL, 91, NULL, NULL, 235946),
(291457, '1pdnC01', NULL, NULL, 69, NULL, NULL, 235946),
(291458, '2zj2A03', NULL, NULL, 84, NULL, NULL, 235946),
(291459, '2qlzA03', NULL, NULL, 70, NULL, NULL, 235946),
(291460, '3deuB00', NULL, NULL, 144, NULL, NULL, 235946),
(291461, '1wi9A01', NULL, NULL, 58, NULL, NULL, 235946),
(291462, '4u7bA02', NULL, NULL, 39, NULL, NULL, 235946),
(291463, '3szpA01', NULL, NULL, 89, NULL, NULL, 235946),
(291464, '3j7aY00', NULL, NULL, 170, NULL, NULL, 235946),
(291465, '2obpA00', NULL, NULL, 96, NULL, NULL, 235946),
(291466, '4gcvC00', NULL, NULL, 168, NULL, NULL, 235946),
(291467, '2kifA00', NULL, NULL, 108, NULL, NULL, 235946),
(291468, '1gxqA00', NULL, NULL, 106, NULL, NULL, 235946),
(291469, '2hfhA00', NULL, NULL, 93, NULL, NULL, 235946),
(291470, '3lmmB05', NULL, NULL, 61, NULL, NULL, 235946),
(291471, '1yyvB00', NULL, NULL, 131, NULL, NULL, 235946),
(291472, '3w6jE02', NULL, NULL, 102, NULL, NULL, 235946),
(291473, '3e6cC02', NULL, NULL, 86, NULL, NULL, 235946),
(291474, '4cxfA02', NULL, NULL, 69, NULL, NULL, 235946),
(291475, '2l02A00', NULL, NULL, 82, NULL, NULL, 235946),
(291476, '1fx7A01', NULL, NULL, 73, NULL, NULL, 235946),
(291477, '4u88A00', NULL, NULL, 109, NULL, NULL, 235946),
(291478, '3cjnA00', NULL, NULL, 162, NULL, NULL, 235946);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(291479, '1a04A02', NULL, NULL, 87, NULL, NULL, 235946),
(291480, '6clxA01', NULL, NULL, 98, NULL, NULL, 235946),
(291481, '5xncA01', NULL, NULL, 83, NULL, NULL, 235946),
(291482, '2pn6A01', NULL, NULL, 52, NULL, NULL, 235946),
(291483, '3i53B01', NULL, NULL, 99, NULL, NULL, 235946),
(291484, '1w5sA03', NULL, NULL, 113, NULL, NULL, 235946),
(291485, '5za3B00', NULL, NULL, 101, NULL, NULL, 235946),
(291486, '1vtnC00', NULL, NULL, 102, NULL, NULL, 235946),
(291487, '2cqkA00', NULL, NULL, 101, NULL, NULL, 235946),
(291488, '5fo5A00', NULL, NULL, 92, NULL, NULL, 235946),
(291489, '2qbyB03', NULL, NULL, 101, NULL, NULL, 235946),
(291490, '4b09B02', NULL, NULL, 98, NULL, NULL, 235946),
(291491, '3jcmN09', NULL, NULL, 82, NULL, NULL, 235946),
(291492, '2a61B00', NULL, NULL, 145, NULL, NULL, 235946),
(291493, '4p96A01', NULL, NULL, 79, NULL, NULL, 235946),
(291494, '4esjA02', NULL, NULL, 90, NULL, NULL, 235946),
(291495, '6az6A01', NULL, NULL, 79, NULL, NULL, 235946),
(291496, '3t8rA00', NULL, NULL, 143, NULL, NULL, 235946),
(291497, '1r7jA00', NULL, NULL, 95, NULL, NULL, 235946),
(291498, '2jscB01', NULL, NULL, 89, NULL, NULL, 235946),
(291499, '4nb5B01', NULL, NULL, 97, NULL, NULL, 235946),
(291500, '2m1bA00', NULL, NULL, 122, NULL, NULL, 235946),
(291501, '2qlzB01', NULL, NULL, 76, NULL, NULL, 235946),
(291502, '1bc8C00', NULL, NULL, 93, NULL, NULL, 235946),
(291503, '1s3jA02', NULL, NULL, 64, NULL, NULL, 235946),
(291504, '2gqqA01', NULL, NULL, 52, NULL, NULL, 235946),
(291505, '4u0yA00', NULL, NULL, 78, NULL, NULL, 235946),
(291506, '3p9cA01', NULL, NULL, 116, NULL, NULL, 235946),
(291507, '2l4aA00', NULL, NULL, 66, NULL, NULL, 235946),
(291508, '5m59A03', NULL, NULL, 91, NULL, NULL, 235946),
(291509, '4zyeA02', NULL, NULL, 84, NULL, NULL, 235946),
(291510, '3lstA01', NULL, NULL, 101, NULL, NULL, 235946),
(291511, '5hs7B00', NULL, NULL, 110, NULL, NULL, 235946),
(291512, '1pp8O00', NULL, NULL, 115, NULL, NULL, 235946),
(291513, '2gauA02', NULL, NULL, 81, NULL, NULL, 235946),
(291514, '5m59A09', NULL, NULL, 88, NULL, NULL, 235946),
(291515, '1j9iA00', NULL, NULL, 68, NULL, NULL, 235946),
(291516, '4bgdA03', NULL, NULL, 90, NULL, NULL, 235946),
(291517, '1on2A01', NULL, NULL, 73, NULL, NULL, 235946),
(291518, '1x3uA01', NULL, NULL, 69, NULL, NULL, 235946),
(291519, '2ozuA03', NULL, NULL, 72, NULL, NULL, 235946),
(291520, '3r0aA00', NULL, NULL, 123, NULL, NULL, 235946),
(291521, '4bgdA09', NULL, NULL, 103, NULL, NULL, 235946),
(291522, '2xubA04', NULL, NULL, 91, NULL, NULL, 235946),
(291523, '2ia2A01', NULL, NULL, 83, NULL, NULL, 235946),
(291524, '2xubA02', NULL, NULL, 92, NULL, NULL, 235946),
(291525, '3k2zB01', NULL, NULL, 66, NULL, NULL, 235946),
(291526, '2cg4A01', NULL, NULL, 57, NULL, NULL, 235946),
(291527, '6c5bA01', NULL, NULL, 92, NULL, NULL, 235946),
(291528, '4yifF00', NULL, NULL, 138, NULL, NULL, 235946),
(291529, '2p7vB00', NULL, NULL, 68, NULL, NULL, 235946),
(291530, '3rjpA00', NULL, NULL, 96, NULL, NULL, 235946),
(291531, '5dymA00', NULL, NULL, 100, NULL, NULL, 235946),
(291532, '2xubA01', NULL, NULL, 78, NULL, NULL, 235946),
(291533, '1xsvA00', NULL, NULL, 113, NULL, NULL, 235946),
(291534, '2l01A00', NULL, NULL, 77, NULL, NULL, 235946),
(291535, '1sfeA02', NULL, NULL, 87, NULL, NULL, 235946),
(291536, '1ixcA01', NULL, NULL, 87, NULL, NULL, 235946),
(291537, '1or7B02', NULL, NULL, 71, NULL, NULL, 235946),
(291538, '2bv6A00', NULL, NULL, 142, NULL, NULL, 235946),
(291539, '2o03A01', NULL, NULL, 75, NULL, NULL, 235946),
(291540, '6akpC00', NULL, NULL, 103, NULL, NULL, 235946),
(291541, '1tnsA00', NULL, NULL, 76, NULL, NULL, 235946),
(291542, '4b8xB00', NULL, NULL, 147, NULL, NULL, 235946),
(291543, '2fokA02', NULL, NULL, 87, NULL, NULL, 235946),
(291544, '5eriA00', NULL, NULL, 169, NULL, NULL, 235946),
(291545, '3sfzA03', NULL, NULL, 74, NULL, NULL, 235946),
(291546, '3cloA02', NULL, NULL, 64, NULL, NULL, 235946),
(291547, '6faiZ00', NULL, NULL, 67, NULL, NULL, 235946),
(291548, '4hamA01', NULL, NULL, 80, NULL, NULL, 235946),
(291549, '3l9fA01', NULL, NULL, 89, NULL, NULL, 235946);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(291550, '4asnA00', NULL, NULL, 101, NULL, NULL, 235946),
(291551, '3l00A02', NULL, NULL, 90, NULL, NULL, 235946),
(291552, '1u3eM02', NULL, NULL, 68, NULL, NULL, 235946),
(291553, '1j5yA01', NULL, NULL, 79, NULL, NULL, 235946),
(291554, '2qvoA00', NULL, NULL, 95, NULL, NULL, 235946),
(291555, '6jqsA00', NULL, NULL, 75, NULL, NULL, 235946),
(291556, '1fc3B00', NULL, NULL, 120, NULL, NULL, 235946),
(291557, '1ku3A00', NULL, NULL, 73, NULL, NULL, 235946),
(291558, '2do7A01', NULL, NULL, 80, NULL, NULL, 235946),
(291559, '3kp7A00', NULL, NULL, 151, NULL, NULL, 235946),
(291560, '4lb6B00', NULL, NULL, 72, NULL, NULL, 235946),
(291561, '3ff5A00', NULL, NULL, 54, NULL, NULL, 235946),
(291562, '1ussA00', NULL, NULL, 88, NULL, NULL, 235946),
(291563, '1in4A02', NULL, NULL, 73, NULL, NULL, 235946),
(291564, '3df8A00', NULL, NULL, 111, NULL, NULL, 235946),
(291565, '4rs8A00', NULL, NULL, 84, NULL, NULL, 235946),
(291566, '3ihuA01', NULL, NULL, 81, NULL, NULL, 235946),
(291567, '3vepH00', NULL, NULL, 86, NULL, NULL, 235946),
(291568, '1cf7A00', NULL, NULL, 76, NULL, NULL, 235946),
(291569, '4yiiA00', NULL, NULL, 90, NULL, NULL, 235946),
(291570, '1lddA00', NULL, NULL, 74, NULL, NULL, 235946),
(291571, '1u2wD00', NULL, NULL, 122, NULL, NULL, 235946),
(291572, '2ia0A01', NULL, NULL, 67, NULL, NULL, 235946),
(291573, '2ia2D01', NULL, NULL, 76, NULL, NULL, 235946),
(291574, '5cj9A01', NULL, NULL, 64, NULL, NULL, 235946),
(291575, '2hztC00', NULL, NULL, 107, NULL, NULL, 235946),
(291576, '2dceA01', NULL, NULL, 76, NULL, NULL, 235946),
(291577, '2qenA03', NULL, NULL, 70, NULL, NULL, 235946),
(291578, '4irhA00', NULL, NULL, 106, NULL, NULL, 235946),
(291579, '1z6tA04', NULL, NULL, 85, NULL, NULL, 235946),
(291580, '4pcqA01', NULL, NULL, 50, NULL, NULL, 235946),
(291581, '3cdhA00', NULL, NULL, 155, NULL, NULL, 235946),
(291582, '4qwqA00', NULL, NULL, 110, NULL, NULL, 235946),
(291583, '1s29A00', NULL, NULL, 92, NULL, NULL, 235946),
(291584, '2htjA01', NULL, NULL, 60, NULL, NULL, 235946),
(291585, '4ivnA01', NULL, NULL, 81, NULL, NULL, 235946),
(291586, '4a5nC00', NULL, NULL, 114, NULL, NULL, 235946),
(291587, '4ka4A00', NULL, NULL, 70, NULL, NULL, 235946),
(291588, '2r3sB01', NULL, NULL, 83, NULL, NULL, 235946),
(291589, '2hr3D02', NULL, NULL, 66, NULL, NULL, 235946),
(291590, '2a6hF02', NULL, NULL, 54, NULL, NULL, 235946),
(291591, '3wttH00', NULL, NULL, 93, NULL, NULL, 235946),
(291592, '5hvqC02', NULL, NULL, 98, NULL, NULL, 235946),
(291593, '2jzyA00', NULL, NULL, 112, NULL, NULL, 235946),
(291594, '2pfbB00', NULL, NULL, 136, NULL, NULL, 235946),
(291595, '4g9yA00', NULL, NULL, 157, NULL, NULL, 235946),
(291596, '4gggA00', NULL, NULL, 105, NULL, NULL, 235946),
(291597, '5znxA00', NULL, NULL, 102, NULL, NULL, 235946),
(291598, '1q1hA00', NULL, NULL, 88, NULL, NULL, 235946),
(291599, '3fm3A02', NULL, NULL, 80, NULL, NULL, 235946),
(291600, '2k4jA00', NULL, NULL, 115, NULL, NULL, 235946),
(291601, '2a6hF03', NULL, NULL, 82, NULL, NULL, 235946),
(291602, '2ia1B02', NULL, NULL, 59, NULL, NULL, 235946),
(291603, '1p2fA02', NULL, NULL, 98, NULL, NULL, 235946),
(291604, '5xyiK00', NULL, NULL, 91, NULL, NULL, 235946),
(291605, '5d6eA02', NULL, NULL, 80, NULL, NULL, 235946),
(291606, '3m8eB00', NULL, NULL, 101, NULL, NULL, 235946),
(291607, '5xohA01', NULL, NULL, 110, NULL, NULL, 235946),
(291608, '3ispA01', NULL, NULL, 87, NULL, NULL, 235946),
(291609, '1xdsB01', NULL, NULL, 112, NULL, NULL, 235946),
(291610, '2rdpA00', NULL, NULL, 150, NULL, NULL, 235946),
(291611, '4e70A01', NULL, NULL, 107, NULL, NULL, 235946),
(291612, '3u9gA01', NULL, NULL, 74, NULL, NULL, 235946),
(291613, '2eljA01', NULL, NULL, 75, NULL, NULL, 235946),
(291614, '3hugE00', NULL, NULL, 73, NULL, NULL, 235946),
(291615, '2hztD00', NULL, NULL, 107, NULL, NULL, 235946),
(291616, '3bjoA00', NULL, NULL, 103, NULL, NULL, 235946),
(291617, '3pqkA00', NULL, NULL, 102, NULL, NULL, 235946),
(291618, '3gwzA01', NULL, NULL, 89, NULL, NULL, 235946),
(291619, '2ia2C01', NULL, NULL, 60, NULL, NULL, 235946),
(291620, '4k2eB00', NULL, NULL, 95, NULL, NULL, 235946);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(291621, '3w6kC00', NULL, NULL, 92, NULL, NULL, 235946),
(291622, '4hyeA02', NULL, NULL, 69, NULL, NULL, 235946),
(291623, '2hyfA01', NULL, NULL, 73, NULL, NULL, 235946),
(291624, '4eqqA02', NULL, NULL, 48, NULL, NULL, 235946),
(291625, '3mczA01', NULL, NULL, 82, NULL, NULL, 235946),
(291626, '4x6gB01', NULL, NULL, 91, NULL, NULL, 235946),
(291627, '1l0oC00', NULL, NULL, 57, NULL, NULL, 235946),
(291628, '2b0lC00', NULL, NULL, 102, NULL, NULL, 235946),
(291629, '1ustA00', NULL, NULL, 93, NULL, NULL, 235946),
(291630, '1rz4A02', NULL, NULL, 104, NULL, NULL, 235946),
(291631, '1tlhB01', NULL, NULL, 68, NULL, NULL, 235946),
(291632, '1g4dA00', NULL, NULL, 69, NULL, NULL, 235946),
(291633, '3u2rA00', NULL, NULL, 149, NULL, NULL, 235946),
(291634, '1je8E00', NULL, NULL, 82, NULL, NULL, 235946),
(291635, '1z7uB00', NULL, NULL, 112, NULL, NULL, 235946),
(291636, '2a07J00', NULL, NULL, 93, NULL, NULL, 235946),
(291637, '3qp6A02', NULL, NULL, 79, NULL, NULL, 235946),
(291638, '3m1eA00', NULL, NULL, 94, NULL, NULL, 235946),
(291639, '2sttA00', NULL, NULL, 96, NULL, NULL, 235946),
(291640, '4xlnF03', NULL, NULL, 81, NULL, NULL, 235946),
(291641, '3f6oB00', NULL, NULL, 96, NULL, NULL, 235946),
(291642, '1ucrB00', NULL, NULL, 78, NULL, NULL, 235946),
(291643, '1bbyA00', NULL, NULL, 69, NULL, NULL, 235946),
(291644, '4irgA00', NULL, NULL, 109, NULL, NULL, 235946),
(291645, '1stzA01', NULL, NULL, 98, NULL, NULL, 235946),
(291646, '3bpvA00', NULL, NULL, 138, NULL, NULL, 235946),
(291647, '4h0eA00', NULL, NULL, 70, NULL, NULL, 235946),
(291648, '3m8eA00', NULL, NULL, 124, NULL, NULL, 235946),
(291649, '5hdkC00', NULL, NULL, 112, NULL, NULL, 235946),
(291650, '1s8nA02', NULL, NULL, 63, NULL, NULL, 235946),
(291651, '3tqnC01', NULL, NULL, 75, NULL, NULL, 235946),
(291652, '1ufmA00', NULL, NULL, 84, NULL, NULL, 235946),
(291653, '3c57B00', NULL, NULL, 49, NULL, NULL, 235946),
(291654, '4if4A02', NULL, NULL, 68, NULL, NULL, 235946),
(291655, '5zqhA00', NULL, NULL, 102, NULL, NULL, 235946),
(291656, '2ek5B00', NULL, NULL, 129, NULL, NULL, 235946),
(291657, '3eyyA01', NULL, NULL, 84, NULL, NULL, 235946),
(291658, '1tbxB00', NULL, NULL, 99, NULL, NULL, 235946),
(291659, '6paxA01', NULL, NULL, 68, NULL, NULL, 235946),
(291660, '2hztA00', NULL, NULL, 107, NULL, NULL, 235946),
(291661, '6paxA02', NULL, NULL, 49, NULL, NULL, 235946),
(291662, '3l7wA00', NULL, NULL, 108, NULL, NULL, 235946),
(291663, '2ip2A01', NULL, NULL, 88, NULL, NULL, 235946),
(291664, '4hf1A00', NULL, NULL, 144, NULL, NULL, 235946),
(291665, '1xmkA00', NULL, NULL, 79, NULL, NULL, 235946),
(291666, '1d3yA01', NULL, NULL, 74, NULL, NULL, 235946),
(291667, '1lj9B00', NULL, NULL, 144, NULL, NULL, 235946),
(291668, '6exmB02', NULL, NULL, 101, NULL, NULL, 235946),
(291669, '3o2pE00', NULL, NULL, 88, NULL, NULL, 235946),
(291670, '2vxzA01', NULL, NULL, 70, NULL, NULL, 235946),
(291671, '2fbhA00', NULL, NULL, 146, NULL, NULL, 235946),
(291672, '5f64A02', NULL, NULL, 76, NULL, NULL, 235946),
(291673, '3qu6C01', NULL, NULL, 107, NULL, NULL, 235946),
(291674, '5dcfA02', NULL, NULL, 64, NULL, NULL, 235946),
(291675, '6ga0A02', NULL, NULL, 90, NULL, NULL, 235946),
(291676, '1zarA01', NULL, NULL, 90, NULL, NULL, 235946),
(291677, '3vfzB00', NULL, NULL, 67, NULL, NULL, 235946),
(291678, '3gz5B02', NULL, NULL, 78, NULL, NULL, 235946),
(291679, '2hgcA00', NULL, NULL, 82, NULL, NULL, 235946),
(291680, '2dt5B01', NULL, NULL, 73, NULL, NULL, 235946),
(291681, '1k78I00', NULL, NULL, 66, NULL, NULL, 235946),
(291682, '2d1hB00', NULL, NULL, 109, NULL, NULL, 235946),
(291683, '3cuoD00', NULL, NULL, 99, NULL, NULL, 235946),
(291684, '2y75A00', NULL, NULL, 129, NULL, NULL, 235946),
(291685, '2v79A00', NULL, NULL, 115, NULL, NULL, 235946),
(291686, '1fnnB03', NULL, NULL, 112, NULL, NULL, 235946),
(291687, '1qo0D02', NULL, NULL, 52, NULL, NULL, 235946),
(291688, '3v8jA01', NULL, NULL, 70, NULL, NULL, 235946),
(291689, '3hhhA00', NULL, NULL, 116, NULL, NULL, 235946),
(291690, '2a5yC03', NULL, NULL, 129, NULL, NULL, 235946),
(291691, '3qp5A02', NULL, NULL, 72, NULL, NULL, 235946);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(291692, '1i1gA01', NULL, NULL, 51, NULL, NULL, 235946),
(291693, '2mc3A00', NULL, NULL, 109, NULL, NULL, 235946),
(291694, '4a6dA01', NULL, NULL, 94, NULL, NULL, 235946),
(291695, '2fswA00', NULL, NULL, 107, NULL, NULL, 235946),
(291696, '2aqeA00', NULL, NULL, 90, NULL, NULL, 235946),
(291697, '4kibA01', NULL, NULL, 99, NULL, NULL, 235946),
(291698, '3gudA00', NULL, NULL, 129, NULL, NULL, 235946),
(291699, '3tqnB01', NULL, NULL, 75, NULL, NULL, 235946),
(291700, '2gxbB00', NULL, NULL, 66, NULL, NULL, 235946),
(291701, '2ou2A03', NULL, NULL, 69, NULL, NULL, 235946),
(291702, '2nyxB01', NULL, NULL, 151, NULL, NULL, 235946),
(291703, '1cf7B00', NULL, NULL, 95, NULL, NULL, 235946),
(291704, '4l0yB00', NULL, NULL, 108, NULL, NULL, 235946),
(291705, '1ev7B02', NULL, NULL, 133, NULL, NULL, 235946),
(291706, '1fp1D01', NULL, NULL, 105, NULL, NULL, 235946),
(291707, '2hztB00', NULL, NULL, 107, NULL, NULL, 235946),
(291708, '3neuA01', NULL, NULL, 79, NULL, NULL, 235946),
(291709, '2ns0A00', NULL, NULL, 85, NULL, NULL, 235946),
(291710, '1b4aA01', NULL, NULL, 59, NULL, NULL, 235946),
(291711, '1oywA03', NULL, NULL, 183, NULL, NULL, 235946),
(291712, '2h6cA02', NULL, NULL, 85, NULL, NULL, 235946),
(291713, '2co5A00', NULL, NULL, 99, NULL, NULL, 235946),
(291714, '3nqoB00', NULL, NULL, 189, NULL, NULL, 235946),
(291715, '2qufA01', NULL, NULL, 76, NULL, NULL, 235946),
(291716, '2xzmT00', NULL, NULL, 155, NULL, NULL, 235946),
(291717, '5tjjA01', NULL, NULL, 77, NULL, NULL, 235946),
(291718, '1d8jA00', NULL, NULL, 81, NULL, NULL, 235946),
(291719, '1xmaA00', NULL, NULL, 111, NULL, NULL, 235946),
(291720, '4ad9A02', NULL, NULL, 84, NULL, NULL, 235946),
(291721, '1mgtA02', NULL, NULL, 86, NULL, NULL, 235946),
(291722, '4mtdD01', NULL, NULL, 89, NULL, NULL, 235946),
(291723, '4o5vA01', NULL, NULL, 71, NULL, NULL, 235946),
(291724, '2p8tA01', NULL, NULL, 91, NULL, NULL, 235946),
(291725, '2xigA01', NULL, NULL, 93, NULL, NULL, 235946),
(291726, '2lnbA00', NULL, NULL, 80, NULL, NULL, 235946),
(291727, '4q48A03', NULL, NULL, 185, NULL, NULL, 235946),
(291728, '4bqaG00', NULL, NULL, 85, NULL, NULL, 235946),
(291729, '3ic7A01', NULL, NULL, 77, NULL, NULL, 235946),
(291730, '3oopA01', NULL, NULL, 138, NULL, NULL, 235946),
(291731, '1fshA00', NULL, NULL, 105, NULL, NULL, 235946),
(291732, '1lvaA03', NULL, NULL, 62, NULL, NULL, 235946),
(291733, '4xrfA00', NULL, NULL, 142, NULL, NULL, 235946),
(291734, '1lvaA04', NULL, NULL, 60, NULL, NULL, 235946),
(291735, '4kmfA00', NULL, NULL, 62, NULL, NULL, 235946),
(291736, '4aihF00', NULL, NULL, 151, NULL, NULL, 235946),
(291737, '3zmdA00', NULL, NULL, 152, NULL, NULL, 235946),
(291738, '3hruB01', NULL, NULL, 138, NULL, NULL, 235946),
(291739, '3k9tA03', NULL, NULL, 79, NULL, NULL, 235946),
(291740, '2fbiA00', NULL, NULL, 142, NULL, NULL, 235946),
(291741, '3j7aO00', NULL, NULL, 89, NULL, NULL, 235946),
(291742, '4z2yA01', NULL, NULL, 94, NULL, NULL, 235946),
(291743, '3tqnA01', NULL, NULL, 75, NULL, NULL, 235946),
(291744, '5trdA01', NULL, NULL, 90, NULL, NULL, 235946),
(291745, '2elhA01', NULL, NULL, 66, NULL, NULL, 235946),
(291746, '4cydB02', NULL, NULL, 80, NULL, NULL, 235946),
(291747, '2o0yC01', NULL, NULL, 79, NULL, NULL, 235946),
(291748, '2oa4A01', NULL, NULL, 84, NULL, NULL, 235946),
(291749, '2v1xA03', NULL, NULL, 110, NULL, NULL, 235946),
(291750, '2ijlB00', NULL, NULL, 135, NULL, NULL, 235946),
(291751, '1uhwA00', NULL, NULL, 109, NULL, NULL, 235946),
(291752, '5aonA00', NULL, NULL, 53, NULL, NULL, 235946),
(291753, '2qwwC00', NULL, NULL, 154, NULL, NULL, 235946),
(291754, '5mmcA00', NULL, NULL, 70, NULL, NULL, 235946),
(291755, '2hoeA01', NULL, NULL, 62, NULL, NULL, 235946),
(291756, '3hhgE01', NULL, NULL, 88, NULL, NULL, 235946),
(291757, '1ys7A02', NULL, NULL, 105, NULL, NULL, 235946),
(291758, '4uhtA00', NULL, NULL, 102, NULL, NULL, 235946),
(291759, '3bj6B00', NULL, NULL, 152, NULL, NULL, 235946),
(291760, '3ulqB00', NULL, NULL, 62, NULL, NULL, 235946),
(291761, '3qrfF00', NULL, NULL, 82, NULL, NULL, 235946),
(291762, '2lkpA00', NULL, NULL, 119, NULL, NULL, 235946); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(291763, '2dk8A01', NULL, NULL, 65, NULL, NULL, 235946),
(291764, '3r4kB01', NULL, NULL, 65, NULL, NULL, 235946),
(291765, '4zs8B01', NULL, NULL, 67, NULL, NULL, 235946),
(291766, '4esfA00', NULL, NULL, 117, NULL, NULL, 235946),
(291767, '1p4wA00', NULL, NULL, 99, NULL, NULL, 235946),
(291768, '3bjaA00', NULL, NULL, 139, NULL, NULL, 235946),
(291769, '2m87A00', NULL, NULL, 103, NULL, NULL, 235946),
(291770, '2k4bA00', NULL, NULL, 69, NULL, NULL, 235946),
(291771, '1v3fA00', NULL, NULL, 120, NULL, NULL, 235946),
(291772, '2irfG00', NULL, NULL, 113, NULL, NULL, 235946),
(291773, '4bxuA00', NULL, NULL, 69, NULL, NULL, 235946),
(291774, '4mhgA01', NULL, NULL, 91, NULL, NULL, 235946),
(291775, '2oqrA03', NULL, NULL, 108, NULL, NULL, 235946),
(291776, '5cviA01', NULL, NULL, 139, NULL, NULL, 235946),
(291777, '2zkzB00', NULL, NULL, 99, NULL, NULL, 235946),
(291778, '3jtgA01', NULL, NULL, 85, NULL, NULL, 235946),
(291779, '3broD00', NULL, NULL, 141, NULL, NULL, 235946),
(291780, '2hyfD01', NULL, NULL, 73, NULL, NULL, 235946),
(291781, '2q2eA01', NULL, NULL, 145, NULL, NULL, 235946),
(291782, '4tv7D01', NULL, NULL, 93, NULL, NULL, 235946),
(291783, '1ghcA00', NULL, NULL, 75, NULL, NULL, 235946),
(291784, '2eshA00', NULL, NULL, 118, NULL, NULL, 235946),
(291785, '3pfiA03', NULL, NULL, 79, NULL, NULL, 235946),
(291786, '1xn7A00', NULL, NULL, 78, NULL, NULL, 235946),
(291787, '6fuuA00', NULL, NULL, 108, NULL, NULL, 235946),
(291788, '4hf0B00', NULL, NULL, 141, NULL, NULL, 235946),
(291789, '1qntA02', NULL, NULL, 91, NULL, NULL, 235946),
(291790, '1awcA00', NULL, NULL, 110, NULL, NULL, 235946),
(291791, '2hs5A01', NULL, NULL, 67, NULL, NULL, 235946),
(291792, '3gw2A00', NULL, NULL, 108, NULL, NULL, 235946),
(291793, '2g7uA01', NULL, NULL, 79, NULL, NULL, 235946),
(291794, '3p7nA02', NULL, NULL, 72, NULL, NULL, 235946),
(291795, '4bhbA02', NULL, NULL, 86, NULL, NULL, 235946),
(291796, '2hwvA00', NULL, NULL, 103, NULL, NULL, 235946),
(291797, '2o0yB01', NULL, NULL, 65, NULL, NULL, 235946),
(291798, '3g3zA02', NULL, NULL, 64, NULL, NULL, 235946),
(291799, '5d5wB00', NULL, NULL, 104, NULL, NULL, 235946),
(291800, '1t98A01', NULL, NULL, 95, NULL, NULL, 235946),
(291801, '1v4rA01', NULL, NULL, 79, NULL, NULL, 235946),
(291802, '3mq0A01', NULL, NULL, 79, NULL, NULL, 235946),
(291803, '4cuyK00', NULL, NULL, 93, NULL, NULL, 235946),
(291804, '2ijlA00', NULL, NULL, 135, NULL, NULL, 235946),
(291805, '3dv8A02', NULL, NULL, 78, NULL, NULL, 235946),
(291806, '4nqwA02', NULL, NULL, 93, NULL, NULL, 235946),
(291807, '3nrvB00', NULL, NULL, 148, NULL, NULL, 235946),
(291808, '3k69A00', NULL, NULL, 162, NULL, NULL, 235946),
(291809, '3dpuB01', NULL, NULL, 104, NULL, NULL, 235946),
(291810, '2hqrA02', NULL, NULL, 106, NULL, NULL, 235946),
(291811, '3g73A00', NULL, NULL, 103, NULL, NULL, 235946),
(291812, '5hdnD00', NULL, NULL, 112, NULL, NULL, 235946),
(291813, '2ma3A00', NULL, NULL, 88, NULL, NULL, 235946),
(291814, '4fx0A00', NULL, NULL, 148, NULL, NULL, 235946),
(291815, '4d0pA02', NULL, NULL, 65, NULL, NULL, 235946),
(291816, '1fpqA02', NULL, NULL, 129, NULL, NULL, 235946),
(291817, '3f6vA00', NULL, NULL, 104, NULL, NULL, 235946),
(291818, '1jhfA02', NULL, NULL, 70, NULL, NULL, 235946),
(291819, '5z4zA00', NULL, NULL, 91, NULL, NULL, 235946),
(291820, '6g5iZ00', NULL, NULL, 84, NULL, NULL, 235946),
(291821, '6az1a00', NULL, NULL, 86, NULL, NULL, 235946),
(291822, '3go5A04', NULL, NULL, 63, NULL, NULL, 235946),
(291823, '3to7A03', NULL, NULL, 81, NULL, NULL, 235946),
(291824, '1t0fA02', NULL, NULL, 99, NULL, NULL, 235946),
(291825, '4em2A00', NULL, NULL, 178, NULL, NULL, 235946),
(291826, '4pzjA00', NULL, NULL, 70, NULL, NULL, 235946),
(291827, '1zh5A01', NULL, NULL, 91, NULL, NULL, 235946),
(291828, '3sqnB01', NULL, NULL, 63, NULL, NULL, 235946),
(291829, '5u8jD01', NULL, NULL, 94, NULL, NULL, 235946),
(291830, '1repC01', NULL, NULL, 155, NULL, NULL, 235946),
(291831, '1repC02', NULL, NULL, 96, NULL, NULL, 235946),
(291832, '4nhjB00', NULL, NULL, 119, NULL, NULL, 235946),
(291833, '3jw4A00', NULL, NULL, 148, NULL, NULL, 235946);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(291834, '2qyoB01', NULL, NULL, 108, NULL, NULL, 235946),
(291835, '3zplF00', NULL, NULL, 157, NULL, NULL, 235946),
(291836, '2htsA00', NULL, NULL, 92, NULL, NULL, 235946),
(291837, '4p9fA01', NULL, NULL, 70, NULL, NULL, 235946),
(291838, '2o3fA00', NULL, NULL, 86, NULL, NULL, 235946),
(291839, '2zkzC00', NULL, NULL, 99, NULL, NULL, 235946),
(291840, '5x07F00', NULL, NULL, 85, NULL, NULL, 235946),
(291841, '2isyA01', NULL, NULL, 139, NULL, NULL, 235946),
(291842, '5hliB00', NULL, NULL, 149, NULL, NULL, 235946),
(291843, '2xrnB01', NULL, NULL, 64, NULL, NULL, 235946),
(291844, '2h6bA02', NULL, NULL, 105, NULL, NULL, 235946),
(291845, '1sd4A01', NULL, NULL, 64, NULL, NULL, 235946),
(291846, '1biaA01', NULL, NULL, 64, NULL, NULL, 235946),
(291847, '4l9jB00', NULL, NULL, 140, NULL, NULL, 235946),
(291848, '3c7jA01', NULL, NULL, 91, NULL, NULL, 235946),
(291849, '2vooB01', NULL, NULL, 89, NULL, NULL, 235946),
(291850, '4gyiA01', NULL, NULL, 95, NULL, NULL, 235946),
(291851, '5ed4A02', NULL, NULL, 108, NULL, NULL, 235946),
(291852, '2wv0A01', NULL, NULL, 71, NULL, NULL, 235946),
(291853, '1r1tA00', NULL, NULL, 99, NULL, NULL, 235946),
(291854, '2dbbB01', NULL, NULL, 58, NULL, NULL, 235946),
(291855, '2jt1A00', NULL, NULL, 77, NULL, NULL, 235946),
(291856, '6nceA00', NULL, NULL, 100, NULL, NULL, 235946),
(291857, '3by6C01', NULL, NULL, 77, NULL, NULL, 235946),
(291858, '4co8A00', NULL, NULL, 99, NULL, NULL, 235946),
(291859, '1p4xA02', NULL, NULL, 123, NULL, NULL, 235946),
(291860, '3zp5A00', NULL, NULL, 102, NULL, NULL, 235946),
(291861, '3htuA00', NULL, NULL, 79, NULL, NULL, 235946),
(291862, '3majA02', NULL, NULL, 77, NULL, NULL, 235946),
(291863, '1nhaA00', NULL, NULL, 82, NULL, NULL, 235946),
(291864, '2jpcA00', NULL, NULL, 61, NULL, NULL, 235946),
(291865, '5zz5B01', NULL, NULL, 75, NULL, NULL, 235946),
(291866, '2p4wA01', NULL, NULL, 103, NULL, NULL, 235946),
(291867, '2h09A01', NULL, NULL, 71, NULL, NULL, 235946),
(291868, '3mwmA01', NULL, NULL, 84, NULL, NULL, 235946),
(291869, '1sfuA00', NULL, NULL, 75, NULL, NULL, 235946),
(291870, '2mh2A00', NULL, NULL, 84, NULL, NULL, 235946),
(291871, '2uzkC01', NULL, NULL, 89, NULL, NULL, 235946),
(291872, '4zzlB01', NULL, NULL, 131, NULL, NULL, 235946),
(291873, '2oqgC00', NULL, NULL, 114, NULL, NULL, 235946),
(291874, '2ethA00', NULL, NULL, 154, NULL, NULL, 235946),
(291875, '4hqeA00', NULL, NULL, 115, NULL, NULL, 235946),
(291876, '2w25A01', NULL, NULL, 52, NULL, NULL, 235946),
(291877, '4s04A02', NULL, NULL, 107, NULL, NULL, 235946),
(291878, '1ub9A00', NULL, NULL, 100, NULL, NULL, 235946),
(291879, '1qbjC00', NULL, NULL, 81, NULL, NULL, 235946),
(291880, '3dqvC03', NULL, NULL, 89, NULL, NULL, 235946),
(291881, '2cfxA01', NULL, NULL, 50, NULL, NULL, 235946),
(291882, '4l9vA00', NULL, NULL, 145, NULL, NULL, 235946),
(291883, '3e97A02', NULL, NULL, 85, NULL, NULL, 235946),
(291884, '2hyfB01', NULL, NULL, 73, NULL, NULL, 235946),
(291885, '2m45A00', NULL, NULL, 87, NULL, NULL, 235946),
(291886, '1fp2A01', NULL, NULL, 103, NULL, NULL, 235946),
(291887, '3dptB01', NULL, NULL, 83, NULL, NULL, 235946),
(291888, '2pg4A00', NULL, NULL, 95, NULL, NULL, 235946),
(291889, '3q9vA00', NULL, NULL, 98, NULL, NULL, 235946),
(291890, '4ejoA00', NULL, NULL, 123, NULL, NULL, 235946),
(291891, '3c1dB01', NULL, NULL, 62, NULL, NULL, 235946),
(291892, '3bz6A02', NULL, NULL, 78, NULL, NULL, 235946),
(291893, '3d0sA02', NULL, NULL, 80, NULL, NULL, 235946),
(291894, '3t0yA02', NULL, NULL, 63, NULL, NULL, 235946),
(291895, '2zxjA00', NULL, NULL, 120, NULL, NULL, 235946),
(291896, '2w57A01', NULL, NULL, 84, NULL, NULL, 235946),
(291897, '3keoA01', NULL, NULL, 77, NULL, NULL, 235946),
(291898, '1j75A00', NULL, NULL, 67, NULL, NULL, 235946),
(291899, '5cvvB01', NULL, NULL, 118, NULL, NULL, 235946),
(291900, '4awxB00', NULL, NULL, 84, NULL, NULL, 235946),
(291901, '1wrjA02', NULL, NULL, 89, NULL, NULL, 235946),
(291902, '2fq3A00', NULL, NULL, 88, NULL, NULL, 235946),
(291903, '3bz6A01', NULL, NULL, 105, NULL, NULL, 235946),
(291904, '3jamZ00', NULL, NULL, 73, NULL, NULL, 235946);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(291905, '2q8kA02', NULL, NULL, 62, NULL, NULL, 235946),
(291906, '3jthB00', NULL, NULL, 98, NULL, NULL, 235946),
(291907, '4omzH00', NULL, NULL, 102, NULL, NULL, 235946),
(291908, '2xv4S03', NULL, NULL, 100, NULL, NULL, 235946),
(291909, '2e1nA00', NULL, NULL, 122, NULL, NULL, 235946),
(291910, '3lapA01', NULL, NULL, 89, NULL, NULL, 235946),
(291911, '5ybdX00', NULL, NULL, 97, NULL, NULL, 235946),
(291912, '2o8xA00', NULL, NULL, 70, NULL, NULL, 235946),
(291913, '6d57A01', NULL, NULL, 92, NULL, NULL, 235946),
(291914, '3fxqB01', NULL, NULL, 90, NULL, NULL, 235946),
(291915, '4a0zA01', NULL, NULL, 65, NULL, NULL, 235946),
(291916, '2a3sA00', NULL, NULL, 101, NULL, NULL, 235946),
(291917, '2cyyA01', NULL, NULL, 56, NULL, NULL, 235946),
(291918, '2fmyA02', NULL, NULL, 84, NULL, NULL, 235946),
(291919, '3dqvD03', NULL, NULL, 89, NULL, NULL, 235946),
(291920, '4g6qA01', NULL, NULL, 92, NULL, NULL, 235946),
(291921, '2r7dA01', NULL, NULL, 71, NULL, NULL, 235946),
(291922, '3l2cA00', NULL, NULL, 91, NULL, NULL, 235946),
(291923, '3jamK00', NULL, NULL, 106, NULL, NULL, 235946),
(291924, '2qq9A01', NULL, NULL, 73, NULL, NULL, 235946),
(291925, '5e1wA00', NULL, NULL, 180, NULL, NULL, 235946),
(291926, '2hyfC01', NULL, NULL, 73, NULL, NULL, 235946),
(291927, '2zkzA00', NULL, NULL, 99, NULL, NULL, 235946),
(291928, '5h20A00', NULL, NULL, 111, NULL, NULL, 235946),
(291929, '1z05A01', NULL, NULL, 72, NULL, NULL, 235946),
(291930, '3v4gA01', NULL, NULL, 65, NULL, NULL, 235946),
(291931, '2fa5A00', NULL, NULL, 162, NULL, NULL, 235946),
(291932, '2zo4A02', NULL, NULL, 56, NULL, NULL, 235946),
(291933, '2vt3B01', NULL, NULL, 82, NULL, NULL, 235946),
(291934, '3c1dA02', NULL, NULL, 46, NULL, NULL, 235946),
(291935, '3c1dA03', NULL, NULL, 51, NULL, NULL, 235946),
(291936, '3echA01', NULL, NULL, 134, NULL, NULL, 235946),
(291937, '2cujA01', NULL, NULL, 68, NULL, NULL, 235946),
(291938, '1kgsA02', NULL, NULL, 103, NULL, NULL, 235946),
(291939, '1ku9B01', NULL, NULL, 88, NULL, NULL, 235946),
(291940, '3ml6A01', NULL, NULL, 96, NULL, NULL, 235946),
(291941, '2kiuA00', NULL, NULL, 87, NULL, NULL, 235946),
(291942, '5vfaA02', NULL, NULL, 107, NULL, NULL, 235946),
(291943, '6do0A00', NULL, NULL, 117, NULL, NULL, 235946),
(291944, '3i71B00', NULL, NULL, 68, NULL, NULL, 235946),
(291945, '1p4xA01', NULL, NULL, 127, NULL, NULL, 235946),
(291946, '3qu3B01', NULL, NULL, 124, NULL, NULL, 235946),
(291947, '3dfgA03', NULL, NULL, 52, NULL, NULL, 235946),
(291948, '4lfuA02', NULL, NULL, 72, NULL, NULL, 235946),
(291949, '3dfgA02', NULL, NULL, 46, NULL, NULL, 235946),
(291950, '3dfgA01', NULL, NULL, 48, NULL, NULL, 235946),
(291951, '2fkiA00', NULL, NULL, 126, NULL, NULL, 235947),
(291952, '2a1vA00', NULL, NULL, 144, NULL, NULL, 235947),
(291953, '3h9xA00', NULL, NULL, 125, NULL, NULL, 235947),
(291954, '3g0tB01', NULL, NULL, 160, NULL, NULL, 235948),
(291955, '3g0tA01', NULL, NULL, 160, NULL, NULL, 235948),
(291956, '3h4cA02', NULL, NULL, 123, NULL, NULL, 235949),
(291957, '1inpA01', NULL, NULL, 47, NULL, NULL, 235950),
(291958, '6o6dA00', NULL, NULL, 80, NULL, NULL, 235951),
(291959, '1tifA00', NULL, NULL, 78, NULL, NULL, 235951),
(291960, '1fjrA02', NULL, NULL, 132, NULL, NULL, 235952),
(291961, '2zxrA04', NULL, NULL, 131, NULL, NULL, 235953),
(291962, '4dq9B00', NULL, NULL, 170, NULL, NULL, 235954),
(291963, '2qv8B00', NULL, NULL, 128, NULL, NULL, 235954),
(291964, '2knqA01', NULL, NULL, 132, NULL, NULL, 235954),
(291965, '4ipuB00', NULL, NULL, 137, NULL, NULL, 235954),
(291966, '1yz7A01', NULL, NULL, 85, NULL, NULL, 235955),
(291967, '2a19A02', NULL, NULL, 86, NULL, NULL, 235955),
(291968, '3cw2C02', NULL, NULL, 93, NULL, NULL, 235955),
(291969, '1kl9A02', NULL, NULL, 92, NULL, NULL, 235955),
(291970, '3aevA02', NULL, NULL, 86, NULL, NULL, 235955),
(291971, '1y13A00', NULL, NULL, 163, NULL, NULL, 235956),
(291972, '3lx3A00', NULL, NULL, 163, NULL, NULL, 235956),
(291973, '2g64A00', NULL, NULL, 140, NULL, NULL, 235956),
(291974, '3jygA00', NULL, NULL, 188, NULL, NULL, 235956),
(291975, '2obaB00', NULL, NULL, 121, NULL, NULL, 235956);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(291976, '3d7jA00', NULL, NULL, 152, NULL, NULL, 235956),
(291977, '3i2bG00', NULL, NULL, 141, NULL, NULL, 235956),
(291978, '4ntkA00', NULL, NULL, 121, NULL, NULL, 235956),
(291979, '1b66A00', NULL, NULL, 140, NULL, NULL, 235956),
(291980, '2dj6B00', NULL, NULL, 115, NULL, NULL, 235956),
(291981, '4jmdA00', NULL, NULL, 269, NULL, NULL, 235957),
(291982, '3bh2A01', NULL, NULL, 232, NULL, NULL, 235957),
(291983, '3bh3D01', NULL, NULL, 233, NULL, NULL, 235957),
(291984, '3cmbA00', NULL, NULL, 283, NULL, NULL, 235957),
(291985, '3c8wA01', NULL, NULL, 232, NULL, NULL, 235957),
(291986, '4zboC00', NULL, NULL, 265, NULL, NULL, 235957),
(291987, '2ra8A01', NULL, NULL, 75, NULL, NULL, 235958),
(291988, '3m1cB01', NULL, NULL, 115, NULL, NULL, 235959),
(291989, '1ffyA03', NULL, NULL, 285, NULL, NULL, 235960),
(291990, '1vk6A01', NULL, NULL, 137, NULL, NULL, 235961),
(291991, '3hugJ00', NULL, NULL, 64, NULL, NULL, 235962),
(291992, '4nqwB00', NULL, NULL, 80, NULL, NULL, 235962),
(291993, '2q1zD01', NULL, NULL, 101, NULL, NULL, 235962),
(291994, '1ijdB00', NULL, NULL, 42, NULL, NULL, 235963),
(291995, '1nkzB00', NULL, NULL, 41, NULL, NULL, 235963),
(291996, '5y5s200', NULL, NULL, 47, NULL, NULL, 235963),
(291997, '1dx7A00', NULL, NULL, 48, NULL, NULL, 235963),
(291998, '1jmmA01', NULL, NULL, 32, NULL, NULL, 235963),
(291999, '1lghB00', NULL, NULL, 45, NULL, NULL, 235963),
(292000, '1wrgA01', NULL, NULL, 37, NULL, NULL, 235963),
(292001, '1bboA01', NULL, NULL, 26, NULL, NULL, 235964),
(292002, '1bboA02', NULL, NULL, 31, NULL, NULL, 235964),
(292003, '2eozA01', NULL, NULL, 36, NULL, NULL, 235964),
(292004, '2ysoA01', NULL, NULL, 36, NULL, NULL, 235964),
(292005, '2em6A01', NULL, NULL, 36, NULL, NULL, 235964),
(292006, '2yrhA01', NULL, NULL, 35, NULL, NULL, 235964),
(292007, '2emwA01', NULL, NULL, 36, NULL, NULL, 235964),
(292008, '5kl3A00', NULL, NULL, 93, NULL, NULL, 235964),
(292009, '4x9jA00', NULL, NULL, 89, NULL, NULL, 235964),
(292010, '2lv2A00', NULL, NULL, 85, NULL, NULL, 235964),
(292011, '2emgA01', NULL, NULL, 36, NULL, NULL, 235964),
(292012, '2encA01', NULL, NULL, 36, NULL, NULL, 235964),
(292013, '4wsgA04', NULL, NULL, 58, NULL, NULL, 235964),
(292014, '2en2A01', NULL, NULL, 33, NULL, NULL, 235964),
(292015, '1a1iA01', NULL, NULL, 32, NULL, NULL, 235964),
(292016, '1x5wA01', NULL, NULL, 28, NULL, NULL, 235964),
(292017, '1x5wA02', NULL, NULL, 29, NULL, NULL, 235964),
(292018, '2emaA01', NULL, NULL, 36, NULL, NULL, 235964),
(292019, '2lvhA00', NULL, NULL, 59, NULL, NULL, 235964),
(292020, '2ytfA01', NULL, NULL, 36, NULL, NULL, 235964),
(292021, '2eojA01', NULL, NULL, 34, NULL, NULL, 235964),
(292022, '2yrmA01', NULL, NULL, 37, NULL, NULL, 235964),
(292023, '1llmD02', NULL, NULL, 58, NULL, NULL, 235964),
(292024, '2eq1A01', NULL, NULL, 36, NULL, NULL, 235964),
(292025, '2eooA01', NULL, NULL, 36, NULL, NULL, 235964),
(292026, '2ytqA01', NULL, NULL, 36, NULL, NULL, 235964),
(292027, '1ncsA00', NULL, NULL, 47, NULL, NULL, 235964),
(292028, '3uk3D01', NULL, NULL, 29, NULL, NULL, 235964),
(292029, '3uk3D02', NULL, NULL, 28, NULL, NULL, 235964),
(292030, '2en7A01', NULL, NULL, 36, NULL, NULL, 235964),
(292031, '2vrdA00', NULL, NULL, 61, NULL, NULL, 235964),
(292032, '2eoeA01', NULL, NULL, 36, NULL, NULL, 235964),
(292033, '2em0A01', NULL, NULL, 36, NULL, NULL, 235964),
(292034, '2ghfA01', NULL, NULL, 89, NULL, NULL, 235964),
(292035, '2prtA01', NULL, NULL, 34, NULL, NULL, 235964),
(292036, '2prtA02', NULL, NULL, 29, NULL, NULL, 235964),
(292037, '2prtA03', NULL, NULL, 28, NULL, NULL, 235964),
(292038, '2prtA04', NULL, NULL, 28, NULL, NULL, 235964),
(292039, '2m9aA01', NULL, NULL, 39, NULL, NULL, 235964),
(292040, '2elzA01', NULL, NULL, 36, NULL, NULL, 235964),
(292041, '2i13A05', NULL, NULL, 31, NULL, NULL, 235964),
(292042, '2i13A04', NULL, NULL, 28, NULL, NULL, 235964),
(292043, '2i13A03', NULL, NULL, 28, NULL, NULL, 235964),
(292044, '2i13A02', NULL, NULL, 29, NULL, NULL, 235964),
(292045, '2i13A01', NULL, NULL, 44, NULL, NULL, 235964),
(292046, '1z1bA01', NULL, NULL, 64, NULL, NULL, 235964),
(292047, '2m9aA02', NULL, NULL, 27, NULL, NULL, 235964);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(292048, '1llmC01', NULL, NULL, 30, NULL, NULL, 235964),
(292049, '2m9aA03', NULL, NULL, 32, NULL, NULL, 235964),
(292050, '1tf3A01', NULL, NULL, 30, NULL, NULL, 235964),
(292051, '2em5A00', NULL, NULL, 46, NULL, NULL, 235964),
(292052, '2emxA01', NULL, NULL, 36, NULL, NULL, 235964),
(292053, '2emhA01', NULL, NULL, 36, NULL, NULL, 235964),
(292054, '2epaA01', NULL, NULL, 30, NULL, NULL, 235964),
(292055, '2epaA02', NULL, NULL, 28, NULL, NULL, 235964),
(292056, '2en1A01', NULL, NULL, 36, NULL, NULL, 235964),
(292057, '2entA00', NULL, NULL, 48, NULL, NULL, 235964),
(292058, '2el4A00', NULL, NULL, 46, NULL, NULL, 235964),
(292059, '2yu5A00', NULL, NULL, 44, NULL, NULL, 235964),
(292060, '2em2A01', NULL, NULL, 36, NULL, NULL, 235964),
(292061, '2a25A01', NULL, NULL, 30, NULL, NULL, 235964),
(292062, '2ytgA01', NULL, NULL, 36, NULL, NULL, 235964),
(292063, '2eq0A01', NULL, NULL, 36, NULL, NULL, 235964),
(292064, '2emkA01', NULL, NULL, 36, NULL, NULL, 235964),
(292065, '2d8uA01', NULL, NULL, 49, NULL, NULL, 235964),
(292066, '2epzA01', NULL, NULL, 36, NULL, NULL, 235964),
(292067, '2csvA00', NULL, NULL, 72, NULL, NULL, 235964),
(292068, '1yuiA00', NULL, NULL, 54, NULL, NULL, 235964),
(292069, '2eosA01', NULL, NULL, 33, NULL, NULL, 235964),
(292070, '1meyC01', NULL, NULL, 29, NULL, NULL, 235964),
(292071, '2em7A01', NULL, NULL, 36, NULL, NULL, 235964),
(292072, '1meyC03', NULL, NULL, 32, NULL, NULL, 235964),
(292073, '2r1fB01', NULL, NULL, 39, NULL, NULL, 235964),
(292074, '2ct1A01', NULL, NULL, 56, NULL, NULL, 235964),
(292075, '2emfA01', NULL, NULL, 36, NULL, NULL, 235964),
(292076, '2el6A00', NULL, NULL, 46, NULL, NULL, 235964),
(292077, '1x3cA00', NULL, NULL, 73, NULL, NULL, 235964),
(292078, '2en3A01', NULL, NULL, 36, NULL, NULL, 235964),
(292079, '2lceA01', NULL, NULL, 43, NULL, NULL, 235964),
(292080, '2lceA02', NULL, NULL, 27, NULL, NULL, 235964),
(292081, '2embA01', NULL, NULL, 34, NULL, NULL, 235964),
(292082, '2wbuA02', NULL, NULL, 29, NULL, NULL, 235964),
(292083, '2eoiA01', NULL, NULL, 36, NULL, NULL, 235964),
(292084, '2wbuA01', NULL, NULL, 27, NULL, NULL, 235964),
(292085, '2gliA05', NULL, NULL, 29, NULL, NULL, 235964),
(292086, '2gliA02', NULL, NULL, 32, NULL, NULL, 235964),
(292087, '2gliA01', NULL, NULL, 33, NULL, NULL, 235964),
(292088, '1b69A00', NULL, NULL, 69, NULL, NULL, 235964),
(292089, '2gliA04', NULL, NULL, 31, NULL, NULL, 235964),
(292090, '2wbuA03', NULL, NULL, 27, NULL, NULL, 235964),
(292091, '2gliA03', NULL, NULL, 30, NULL, NULL, 235964),
(292092, '2lo3A01', NULL, NULL, 29, NULL, NULL, 235964),
(292093, '2el5A01', NULL, NULL, 34, NULL, NULL, 235964),
(292094, '2en8A01', NULL, NULL, 36, NULL, NULL, 235964),
(292095, '2eoyA01', NULL, NULL, 36, NULL, NULL, 235964),
(292096, '2ee8A03', NULL, NULL, 27, NULL, NULL, 235964),
(292097, '2ee8A01', NULL, NULL, 27, NULL, NULL, 235964),
(292098, '2ee8A02', NULL, NULL, 27, NULL, NULL, 235964),
(292099, '2dlqA01', NULL, NULL, 31, NULL, NULL, 235964),
(292100, '2dlqA04', NULL, NULL, 33, NULL, NULL, 235964),
(292101, '2dlqA02', NULL, NULL, 32, NULL, NULL, 235964),
(292102, '2dlqA03', NULL, NULL, 28, NULL, NULL, 235964),
(292103, '2emlA01', NULL, NULL, 36, NULL, NULL, 235964),
(292104, '1x6fA00', NULL, NULL, 88, NULL, NULL, 235964),
(292105, '2enhA01', NULL, NULL, 36, NULL, NULL, 235964),
(292106, '2epuA01', NULL, NULL, 35, NULL, NULL, 235964),
(292107, '4ijdA02', NULL, NULL, 33, NULL, NULL, 235964),
(292108, '2dgcA00', NULL, NULL, 63, NULL, NULL, 235964),
(292109, '2wbsA00', NULL, NULL, 89, NULL, NULL, 235964),
(292110, '2eorA01', NULL, NULL, 36, NULL, NULL, 235964),
(292111, '2ej4A01', NULL, NULL, 85, NULL, NULL, 235964),
(292112, '2em3A00', NULL, NULL, 46, NULL, NULL, 235964),
(292113, '2emzA01', NULL, NULL, 36, NULL, NULL, 235964),
(292114, '3ephA03', NULL, NULL, 54, NULL, NULL, 235964),
(292115, '2junA00', NULL, NULL, 101, NULL, NULL, 235964),
(292116, '2mknA00', NULL, NULL, 60, NULL, NULL, 235964),
(292117, '2epcA01', NULL, NULL, 33, NULL, NULL, 235964),
(292118, '1g2fC03', NULL, NULL, 27, NULL, NULL, 235964),
(292119, '3ddtC00', NULL, NULL, 48, NULL, NULL, 235964);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(292120, '1g2fC01', NULL, NULL, 30, NULL, NULL, 235964),
(292121, '1g2fC02', NULL, NULL, 27, NULL, NULL, 235964),
(292122, '2eoxA01', NULL, NULL, 34, NULL, NULL, 235964),
(292123, '2ytiA01', NULL, NULL, 36, NULL, NULL, 235964),
(292124, '1tf6A02', NULL, NULL, 29, NULL, NULL, 235964),
(292125, '1tf6A03', NULL, NULL, 34, NULL, NULL, 235964),
(292126, '4is1C00', NULL, NULL, 57, NULL, NULL, 235964),
(292127, '2dlkA02', NULL, NULL, 26, NULL, NULL, 235964),
(292128, '2dlkA01', NULL, NULL, 31, NULL, NULL, 235964),
(292129, '2eomA01', NULL, NULL, 36, NULL, NULL, 235964),
(292130, '2em8A01', NULL, NULL, 36, NULL, NULL, 235964),
(292131, '1x6eA01', NULL, NULL, 28, NULL, NULL, 235964),
(292132, '1x6eA02', NULL, NULL, 33, NULL, NULL, 235964),
(292133, '1ubdC02', NULL, NULL, 27, NULL, NULL, 235964),
(292134, '1ubdC01', NULL, NULL, 32, NULL, NULL, 235964),
(292135, '2enaA00', NULL, NULL, 46, NULL, NULL, 235964),
(292136, '1aayA01', NULL, NULL, 32, NULL, NULL, 235964),
(292137, '3vhtB02', NULL, NULL, 34, NULL, NULL, 235964),
(292138, '2en4A01', NULL, NULL, 36, NULL, NULL, 235964),
(292139, '2ep3A01', NULL, NULL, 36, NULL, NULL, 235964),
(292140, '3q1dA00', NULL, NULL, 47, NULL, NULL, 235964),
(292141, '2yu8A01', NULL, NULL, 36, NULL, NULL, 235964),
(292142, '2emcA01', NULL, NULL, 36, NULL, NULL, 235964),
(292143, '2eohA00', NULL, NULL, 46, NULL, NULL, 235964),
(292144, '2rpcA02', NULL, NULL, 27, NULL, NULL, 235964),
(292145, '2ytdA01', NULL, NULL, 36, NULL, NULL, 235964),
(292146, '2rsiA02', NULL, NULL, 29, NULL, NULL, 235964),
(292147, '2rpcA03', NULL, NULL, 39, NULL, NULL, 235964),
(292148, '2rsiA01', NULL, NULL, 27, NULL, NULL, 235964),
(292149, '1ubdC04', NULL, NULL, 35, NULL, NULL, 235964),
(292150, '2rsiA03', NULL, NULL, 27, NULL, NULL, 235964),
(292151, '1ubdC03', NULL, NULL, 30, NULL, NULL, 235964),
(292152, '2r1fA01', NULL, NULL, 39, NULL, NULL, 235964),
(292153, '2r1fA03', NULL, NULL, 39, NULL, NULL, 235964),
(292154, '2wbtB02', NULL, NULL, 52, NULL, NULL, 235964),
(292155, '1zr9A00', NULL, NULL, 67, NULL, NULL, 235964),
(292156, '1wjpA03', NULL, NULL, 41, NULL, NULL, 235964),
(292157, '2nabA01', NULL, NULL, 32, NULL, NULL, 235964),
(292158, '2rpcA01', NULL, NULL, 89, NULL, NULL, 235964),
(292159, '1wjpA02', NULL, NULL, 24, NULL, NULL, 235964),
(292160, '1wjpA01', NULL, NULL, 31, NULL, NULL, 235964),
(292161, '1a1hA01', NULL, NULL, 32, NULL, NULL, 235964),
(292162, '1rmdA02', NULL, NULL, 30, NULL, NULL, 235964),
(292163, '2j7jA01', NULL, NULL, 28, NULL, NULL, 235964),
(292164, '1a1hA03', NULL, NULL, 27, NULL, NULL, 235964),
(292165, '2j7jA03', NULL, NULL, 27, NULL, NULL, 235964),
(292166, '1tf6D01', NULL, NULL, 39, NULL, NULL, 235964),
(292167, '2ytoA01', NULL, NULL, 37, NULL, NULL, 235964),
(292168, '2j7jA02', NULL, NULL, 30, NULL, NULL, 235964),
(292169, '3mhsC02', NULL, NULL, 31, NULL, NULL, 235964),
(292170, '4gznC01', NULL, NULL, 28, NULL, NULL, 235964),
(292171, '4gznC02', NULL, NULL, 31, NULL, NULL, 235964),
(292172, '5k3qD00', NULL, NULL, 44, NULL, NULL, 235964),
(292173, '2adrA02', NULL, NULL, 31, NULL, NULL, 235964),
(292174, '1zu1A01', NULL, NULL, 57, NULL, NULL, 235964),
(292175, '2adrA01', NULL, NULL, 29, NULL, NULL, 235964),
(292176, '1zu1A02', NULL, NULL, 56, NULL, NULL, 235964),
(292177, '2eprA01', NULL, NULL, 38, NULL, NULL, 235964),
(292178, '2en6A01', NULL, NULL, 36, NULL, NULL, 235964),
(292179, '2ytjA01', NULL, NULL, 36, NULL, NULL, 235964),
(292180, '2eofA01', NULL, NULL, 34, NULL, NULL, 235964),
(292181, '2yspA01', NULL, NULL, 36, NULL, NULL, 235964),
(292182, '2djaA00', NULL, NULL, 84, NULL, NULL, 235964),
(292183, '5jpxA00', NULL, NULL, 45, NULL, NULL, 235964),
(292184, '2mdgA00', NULL, NULL, 55, NULL, NULL, 235964),
(292185, '2ctdA00', NULL, NULL, 96, NULL, NULL, 235964),
(292186, '2elyA01', NULL, NULL, 36, NULL, NULL, 235964),
(292187, '2yvrA00', NULL, NULL, 50, NULL, NULL, 235964),
(292188, '2em4A01', NULL, NULL, 36, NULL, NULL, 235964),
(292189, '4f6mA01', NULL, NULL, 48, NULL, NULL, 235964),
(292190, '2drpA01', NULL, NULL, 36, NULL, NULL, 235964),
(292191, '2drpA02', NULL, NULL, 30, NULL, NULL, 235964);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(292192, '4f6mA03', NULL, NULL, 40, NULL, NULL, 235964),
(292193, '4f6mA02', NULL, NULL, 28, NULL, NULL, 235964),
(292194, '1x6hA00', NULL, NULL, 86, NULL, NULL, 235964),
(292195, '2yteA01', NULL, NULL, 34, NULL, NULL, 235964),
(292196, '2emyA00', NULL, NULL, 46, NULL, NULL, 235964),
(292197, '2d9hA00', NULL, NULL, 78, NULL, NULL, 235964),
(292198, '2cshA01', NULL, NULL, 90, NULL, NULL, 235964),
(292199, '2emiA01', NULL, NULL, 36, NULL, NULL, 235964),
(292200, '2epxA01', NULL, NULL, 37, NULL, NULL, 235964),
(292201, '2ytpA01', NULL, NULL, 36, NULL, NULL, 235964),
(292202, '1a1gA01', NULL, NULL, 32, NULL, NULL, 235964),
(292203, '2egmA00', NULL, NULL, 57, NULL, NULL, 235964),
(292204, '2em9A01', NULL, NULL, 36, NULL, NULL, 235964),
(292205, '2eoqA01', NULL, NULL, 36, NULL, NULL, 235964),
(292206, '2eq3A01', NULL, NULL, 36, NULL, NULL, 235964),
(292207, '4m9vC00', NULL, NULL, 64, NULL, NULL, 235964),
(292208, '1g2dC02', NULL, NULL, 27, NULL, NULL, 235964),
(292209, '4bjtA01', NULL, NULL, 102, NULL, NULL, 235965),
(292210, '2wzr400', NULL, NULL, 85, NULL, NULL, 235966),
(292211, '1qqp400', NULL, NULL, 85, NULL, NULL, 235966),
(292212, '2mev400', NULL, NULL, 70, NULL, NULL, 235966),
(292213, '4gh4D00', NULL, NULL, 45, NULL, NULL, 235966),
(292214, '1zba400', NULL, NULL, 85, NULL, NULL, 235966),
(292215, '1wysA00', NULL, NULL, 75, NULL, NULL, 235967),
(292216, '1wfeA00', NULL, NULL, 86, NULL, NULL, 235967),
(292217, '1wfpA00', NULL, NULL, 74, NULL, NULL, 235967),
(292218, '1wg2A00', NULL, NULL, 64, NULL, NULL, 235967),
(292219, '1wffA00', NULL, NULL, 85, NULL, NULL, 235967),
(292220, '1x4wA00', NULL, NULL, 67, NULL, NULL, 235967),
(292221, '3s2rA01', NULL, NULL, 47, NULL, NULL, 235968),
(292222, '4ooaA01', NULL, NULL, 49, NULL, NULL, 235968),
(292223, '3tboA00', NULL, NULL, 60, NULL, NULL, 235968),
(292224, '2qh7B01', NULL, NULL, 48, NULL, NULL, 235968),
(292225, '2q1fA02', NULL, NULL, 413, NULL, NULL, 235969),
(292226, '1hn0A02', NULL, NULL, 384, NULL, NULL, 235969),
(292227, '3vsmA01', NULL, NULL, 347, NULL, NULL, 235969),
(292228, '1rwhA01', NULL, NULL, 372, NULL, NULL, 235969),
(292229, '1f1sA02', NULL, NULL, 374, NULL, NULL, 235969),
(292230, '3a0oA02', NULL, NULL, 365, NULL, NULL, 235969),
(292231, '1n7oA02', NULL, NULL, 372, NULL, NULL, 235969),
(292232, '5jmfA01', NULL, NULL, 384, NULL, NULL, 235969),
(292233, '3e7jA01', NULL, NULL, 333, NULL, NULL, 235969),
(292234, '4ok4A01', NULL, NULL, 341, NULL, NULL, 235969),
(292235, '4ozwA00', NULL, NULL, 335, NULL, NULL, 235969),
(292236, '1x1iA01', NULL, NULL, 361, NULL, NULL, 235969),
(292237, '1cb8A01', NULL, NULL, 312, NULL, NULL, 235969),
(292238, '4mmhA01', NULL, NULL, 364, NULL, NULL, 235969),
(292239, '1qazA00', NULL, NULL, 351, NULL, NULL, 235969),
(292240, '2q1fB02', NULL, NULL, 413, NULL, NULL, 235969),
(292241, '3nnbA01', NULL, NULL, 379, NULL, NULL, 235969),
(292242, '4fnvA01', NULL, NULL, 377, NULL, NULL, 235969),
(292243, '2wcoA01', NULL, NULL, 371, NULL, NULL, 235969),
(292244, 'mobidb-lite', NULL, 'consensus disorder prediction', NULL, NULL, 'disorder_prediction', 235970),
(292245, 'MF_01800', NULL, 'Chromosome partition protein MukB [mukB].', NULL, NULL, 'MukB', 235971),
(292246, 'MF_00257', NULL, 'Putative snRNP Sm-like protein.', NULL, NULL, 'Lsm_RuxX', 235972),
(292247, 'MF_03047', NULL, 'Ataxin-7-like protein 3 [ATXN7L3].', NULL, NULL, 'Sgf11', 235973),
(292248, 'MF_00636', NULL, 'RNase adapter protein RapZ [rapZ].', NULL, NULL, 'RapZ_like', 235974),
(292249, 'MF_01214', NULL, 'PyrE-like protein.', NULL, NULL, 'PyrE_like', 235975),
(292250, 'MF_00913', NULL, 'Probable peptidoglycan glycosyltransferase FtsW [ftsW].', NULL, NULL, 'PGT_FtsW_proteobact', 235976),
(292251, 'MF_00969', NULL, 'Transcription-repair-coupling factor [mfd].', NULL, NULL, 'TRCF', 235977),
(292252, 'MF_03128', NULL, 'Lipoyl synthase, mitochondrial [LIP1].', NULL, NULL, 'Lipoyl_synth_plantM', 235978),
(292253, 'MF_01947', NULL, 'N(4)-bis(aminopropyl)spermidine synthase [bpsA].', NULL, NULL, 'Aminopropyltransf_BpsA', 235979),
(292254, 'MF_02119', NULL, 'Lipoyl-[GcvH]:protein N-lipoyltransferase [lipL].', NULL, NULL, 'LipL', 235980);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(292255, 'MF_00230', NULL, 'Nicotinate-nucleotide--dimethylbenzimidazole phosphoribosyltransferase [cobT].', NULL, NULL, 'CobT', 235981),
(292256, 'MF_01077', NULL, 'Ribosome maturation factor RimP [rimP].', NULL, NULL, 'RimP', 235982),
(292257, 'MF_02099', NULL, 'Hydrogenase maturation factor HybF [hybF].', NULL, NULL, 'HybF_subfam', 235983),
(292258, 'MF_00853', NULL, 'Protoporphyrinogen IX dehydrogenase [quinone] [hemG].', NULL, NULL, 'HemG', 235984),
(292259, 'MF_00361', NULL, 'NAD kinase [nadK].', NULL, NULL, 'NAD_kinase', 235985),
(292260, 'MF_01322', NULL, 'DNA-directed RNA polymerase subunit beta'' [rpoC].', NULL, NULL, 'RNApol_bact_RpoC', 235986),
(292261, 'MF_01673', NULL, '5-deoxy-glucuronate isomerase [iolB].', NULL, NULL, 'IolB', 235987),
(292262, 'MF_00037', NULL, 'UDP-N-acetylenolpyruvoylglucosamine reductase [murB].', NULL, NULL, 'MurB', 235988),
(292263, 'MF_00618', NULL, 'Phycocyanobilin:ferredoxin oxidoreductase [pcyA].', NULL, NULL, 'Ferredoxin_bilin_red', 235989),
(292264, 'MF_01559', NULL, 'L-lactate dehydrogenase [lldD].', NULL, NULL, 'L_lact_dehydr', 235990),
(292265, 'MF_00685', NULL, '1,4-alpha-glucan branching enzyme GlgB [glgB].', NULL, NULL, 'GlgB', 235991),
(292266, 'MF_01534', NULL, 'HTH-type transcriptional activator RhaS [rhaS].', NULL, NULL, 'HTH_type_RhaS', 235992),
(292267, 'MF_03116', NULL, 'Methylthioribulose-1-phosphate dehydratase [APIP].', NULL, NULL, 'Salvage_MtnB_euk', 235993),
(292268, 'MF_00121', NULL, 'Aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase subunit B [gatB].', NULL, NULL, 'GatB', 235994),
(292269, 'MF_02005', NULL, 'Valine--tRNA ligase [valS].', NULL, NULL, 'Val_tRNA_synth_type2', 235995),
(292270, 'MF_00937', NULL, 'DNA topoisomerase 4 subunit A [parC].', NULL, NULL, 'ParC_type2', 235996),
(292271, 'MF_00566', NULL, 'Plastocyanin [petE].', NULL, NULL, 'Cytb6_f_plastocyanin', 235997),
(292272, 'MF_01923', NULL, 'Glutamate mutase epsilon subunit [glmE].', NULL, NULL, 'Me_Asp_mutase_E', 235998),
(292273, 'MF_04008', NULL, 'Capsid scaffolding protein.', NULL, NULL, 'HSV_SCAF', 235999),
(292274, 'MF_03023', NULL, 'Meiotic spindle formation protein mei-1 [mei-1].', NULL, NULL, 'Katanin_p60_A1', 236000),
(292275, 'MF_04085', NULL, 'Nucleoprotein [N].', NULL, NULL, 'ARENA_NCAP', 236001),
(292276, 'MF_00294', NULL, '50S ribosomal protein L33 [rpmG].', NULL, NULL, 'Ribosomal_L33', 236002),
(292277, 'MF_00223', NULL, 'GTP cyclohydrolase 1 [folE].', NULL, NULL, 'FolE', 236003),
(292278, 'MF_00126', NULL, 'Glutamine--tRNA ligase [glnS].', NULL, NULL, 'Gln_tRNA_synth', 236004),
(292279, 'MF_01026', NULL, '3-isopropylmalate dehydratase large subunit [leuC].', NULL, NULL, 'LeuC_type1', 236005),
(292280, 'MF_00997', NULL, 'Beta-barrel assembly-enhancing protease [bepA].', NULL, NULL, 'Protease_BepA', 236006),
(292281, 'MF_01076', NULL, 'UPF0273 protein <locus_tag>.', NULL, NULL, 'UPF0273', 236007),
(292282, 'MF_04160', NULL, 'Head completion nuclease.', NULL, NULL, 'NUCL_HEAD_T4', 236008),
(292283, 'MF_01094', NULL, 'Tetrahydromethanopterin S-methyltransferase subunit B [mtrB].', NULL, NULL, 'MtrB', 236009),
(292284, 'MF_00429', NULL, 'Na(+)-translocating NADH-quinone reductase subunit E [nqrE].', NULL, NULL, 'NqrE', 236010),
(292285, 'MF_02227', NULL, 'Ribulose-phosphate 3-epimerase [rpe].', NULL, NULL, 'RPE', 236011),
(292286, 'MF_00669', NULL, 'Small, acid-soluble spore protein I [sspI].', NULL, NULL, 'SspI', 236012),
(292287, 'MF_01241', NULL, 'Glucosamine-6-phosphate deaminase [nagB].', NULL, NULL, 'GlcN6P_deamin', 236013),
(292288, 'MF_01448', NULL, 'UPF0473 protein <locus_tag>.', NULL, NULL, 'UPF0473', 236014),
(292289, 'MF_01078', NULL, 'RNA-free ribonuclease P.', NULL, NULL, 'RNA_free_RNase_P', 236015),
(292290, 'MF_01203', NULL, 'Voltage-gated ClC-type chloride channel ClcB [clcB].', NULL, NULL, 'CLC_ClcB', 236016),
(292291, 'MF_00062', NULL, 'Sulfate adenylyltransferase subunit 1 [cysN].', NULL, NULL, 'Sulf_adenylyltr_sub1', 236017),
(292292, 'MF_00583_B', NULL, 'Putative ribose-phosphate pyrophosphokinase [prs].', NULL, NULL, 'RibP_PPkinase_B', 236018);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(292293, 'MF_00116', NULL, 'Deoxyuridine 5''-triphosphate nucleotidohydrolase [dut].', NULL, NULL, 'dUTPase_bact', 236019),
(292294, 'MF_00224', NULL, 'Dihydroorotate dehydrogenase [pyrD].', NULL, NULL, 'DHO_dh_type1', 236020),
(292295, 'MF_01670', NULL, 'Malonate-semialdehyde dehydrogenase [iolA].', NULL, NULL, 'IolA', 236021),
(292296, 'MF_01599', NULL, 'Na(+)/H(+) antiporter NhaB [nhaB].', NULL, NULL, 'NhaB', 236022),
(292297, 'MF_00949', NULL, 'Transcription elongation factor Spt4 [spt4].', NULL, NULL, 'Spt4_arch', 236023),
(292298, 'MF_01661', NULL, 'D-ribose pyranase [rbsD].', NULL, NULL, 'D_rib_pyranase', 236024),
(292299, 'MF_01211', NULL, 'Dihydroorotate dehydrogenase B (NAD(+)), electron transfer subunit [pyrK].', NULL, NULL, 'DHODB_Fe_S_bind', 236025),
(292300, 'MF_00460', NULL, 'Protein RnfH [rnfH].', NULL, NULL, 'UPF0125_RnfH', 236026),
(292301, 'MF_00792', NULL, '15,16-dihydrobiliverdin:ferredoxin oxidoreductase [pebA].', NULL, NULL, 'PebA', 236027),
(292302, 'MF_01461', NULL, 'Energy-coupling factor transporter transmembrane protein EcfT [ecfT].', NULL, NULL, 'EcfT', 236028),
(292303, 'MF_01331_B', NULL, '50S ribosomal protein L22 [rplV].', NULL, NULL, 'Ribosomal_L22_B', 236029),
(292304, 'MF_01406', NULL, 'UPF0282 protein <locus_tag>.', NULL, NULL, 'UPF0282', 236030),
(292305, 'MF_01340', NULL, 'UPF0353 protein <locus_tag>.', NULL, NULL, 'UPF0353', 236031),
(292306, 'MF_02097', NULL, 'Carnitine monooxygenase oxygenase subunit.', NULL, NULL, 'Carnitine_monoox_A', 236032),
(292307, 'MF_00168', NULL, 'Queuine tRNA-ribosyltransferase [tgt].', NULL, NULL, 'Q_tRNA_Tgt', 236033),
(292308, 'MF_01337_B', NULL, '50S ribosomal protein L18 [rplR].', NULL, NULL, 'Ribosomal_L18_B', 236034),
(292309, 'MF_00903', NULL, 'Probable Sec-independent protein translocase protein TatE [tatE].', NULL, NULL, 'TatE', 236035),
(292310, 'MF_01894', NULL, 'Chromosome partition protein Smc [smc].', NULL, NULL, 'Smc_prok', 236036),
(292311, 'MF_00360', NULL, '30S ribosomal protein S6 [rpsF].', NULL, NULL, 'Ribosomal_S6', 236037),
(292312, 'MF_00318', NULL, 'Enolase [eno].', NULL, NULL, 'Enolase', 236038),
(292313, 'MF_02089', NULL, 'Epoxyqueuosine reductase QueH [queH].', NULL, NULL, 'QueH', 236039),
(292314, 'MF_01462', NULL, 'Cobalt transport protein CbiM [cbiM].', NULL, NULL, 'CbiM', 236040),
(292315, 'MF_01187', NULL, 'UPF0434 protein YcaR [ycaR].', NULL, NULL, 'UPF0434', 236041),
(292316, 'MF_00241', NULL, '8-oxoguanine DNA glycosylase/AP lyase [ogg].', NULL, NULL, 'Ogg', 236042),
(292317, 'MF_01892', NULL, 'tRNA(Ile2) 2-agmatinylcytidine synthetase TiaS [tiaS].', NULL, NULL, 'tRNA_Ile2_agm2C_synt', 236043),
(292318, 'MF_00864', NULL, 'DNA-directed RNA polymerase subunit Rpo4 [rpo4].', NULL, NULL, 'RNApol_arch_Rpo4', 236044),
(292319, 'MF_01115', NULL, 'Putative ion-transport protein YfeO [yfeO].', NULL, NULL, 'CLC_YfeO', 236045),
(292320, 'MF_04203', NULL, 'Membrane protein [M].', NULL, NULL, 'GAMMA_CORONA_M', 236046),
(292321, 'MF_00930', NULL, 'Transcription elongation factor GreB [greB].', NULL, NULL, 'GreB', 236047),
(292322, 'MF_01200_A', NULL, 'Orotidine 5''-phosphate decarboxylase [pyrF].', NULL, NULL, 'OMPdecase_type1_A', 236048),
(292323, 'MF_00847', NULL, 'Energy-dependent translational throttle protein EttA [ettA].', NULL, NULL, 'EttA', 236049),
(292324, 'MF_02103', NULL, 'Lactate utilization protein B [lutB].', NULL, NULL, 'LutB', 236050),
(292325, 'MF_00247', NULL, 'Soluble pyridine nucleotide transhydrogenase [sthA].', NULL, NULL, 'SthA', 236051),
(292326, 'MF_01818', NULL, 'Ribonuclease BN [rbn].', NULL, NULL, 'RNase_Z_BN', 236052),
(292327, 'MF_00357', NULL, 'Probable DNA-directed RNA polymerase subunit delta [rpoE].', NULL, NULL, 'RNApol_bact_RpoE', 236053),
(292328, 'MF_01905', NULL, 'GlcNAc-binding protein A [gbpA].', NULL, NULL, 'GbpA', 236054),
(292329, 'MF_01009', NULL, 'Thiosulfate sulfurtransferase GlpE [glpE].', NULL, NULL, 'Thiosulf_sulfurtr', 236055),
(292330, 'MF_01870', NULL, 'Probable 4-deoxy-4-formamido-L-arabinose-phosphoundecaprenol deformylase ArnD [arnD].', NULL, NULL, 'ArnD', 236056);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(292331, 'MF_02028', NULL, 'UDP-N-acetylglucosamine 2-epimerase [wecB].', NULL, NULL, 'WecB_RffE', 236057),
(292332, 'MF_00432', NULL, 'Cytochrome b6-f complex subunit 5 [petG].', NULL, NULL, 'Cytb6_f_PetG', 236058),
(292333, 'MF_01423', NULL, 'Multidrug resistance protein MdtB [mdtB].', NULL, NULL, 'MdtB', 236059),
(292334, 'MF_02223', NULL, 'Pantoate kinase.', NULL, NULL, 'Pantoate_kinase', 236060),
(292335, 'MF_03229', NULL, 'Fat storage-inducing transmembrane protein 1 [FITM1].', NULL, NULL, 'FITM1', 236061),
(292336, 'MF_00092', NULL, 'Endonuclease MutS2 [mutS2].', NULL, NULL, 'MutS2', 236062),
(292337, 'MF_04051', NULL, 'Hexon protein [L3].', NULL, NULL, 'ADV_CAPSH', 236063),
(292338, 'MF_00637', NULL, 'Anti-sigma F factor [spoIIAB].', NULL, NULL, 'Anti_sigma_F', 236064),
(292339, 'MF_00084', NULL, 'Nodulation protein A [nodA].', NULL, NULL, 'NodA', 236065),
(292340, 'MF_01511', NULL, 'GMP reductase [guaC].', NULL, NULL, 'GMP_reduct_type2', 236066),
(292341, 'MF_01198', NULL, 'Anti-adapter protein IraP [iraP].', NULL, NULL, 'Anti_adapt_IraP', 236067),
(292342, 'MF_00700', NULL, 'DNA primase small subunit PriS [priS].', NULL, NULL, 'DNA_primase_sml_arc', 236068),
(292343, 'MF_01429', NULL, 'Iron-binding protein IscA [iscA].', NULL, NULL, 'Fe_S_insert_IscA', 236069),
(292344, 'MF_02228', NULL, 'Sulfopropanediol 3-dehydrogenase [hpsN].', NULL, NULL, 'Sulfopropanediol_dehydrog', 236070),
(292345, 'MF_03055', NULL, 'tRNA (guanine-N(7)-)-methyltransferase [METTL1].', NULL, NULL, 'tRNA_methyltr_TrmB_euk', 236071),
(292346, 'MF_00144', NULL, 'tRNA-specific 2-thiouridylase MnmA [mnmA].', NULL, NULL, 'tRNA_thiouridyl_MnmA', 236072),
(292347, 'MF_00815', NULL, 'ATP synthase gamma chain [atpG].', NULL, NULL, 'ATP_synth_gamma_bact', 236073),
(292348, 'MF_01320_A', NULL, '50S ribosomal protein L2 [rplB].', NULL, NULL, 'Ribosomal_L2_A', 236074),
(292349, 'MF_01402_B', NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase [apgM].', NULL, NULL, 'ApgM_B', 236075),
(292350, 'MF_00711', NULL, 'Glycine dehydrogenase (decarboxylating) [gcvP].', NULL, NULL, 'GcvP', 236076),
(292351, 'MF_04091', NULL, 'Non-structural glycoprotein 4.', NULL, NULL, 'ROTA_NSP4', 236077),
(292352, 'MF_00532_A', NULL, '30S ribosomal protein S9 [rpsI].', NULL, NULL, 'Ribosomal_S9_A', 236078),
(292353, 'MF_01921', NULL, 'S-adenosyl-L-methionine-dependent tRNA 4-demethylwyosine synthase [taw1].', NULL, NULL, 'TYW1_archaea', 236079),
(292354, 'MF_00531', NULL, '30S ribosomal protein S19 [rpsS].', NULL, NULL, 'Ribosomal_S19', 236080),
(292355, 'MF_00970', NULL, 'Ribonuclease E [rne].', NULL, NULL, 'RNase_E', 236081),
(292356, 'MF_00561', NULL, 'ADP-specific phosphofructokinase [pfkC].', NULL, NULL, 'ADP_PFKinase', 236082),
(292357, 'MF_03013', NULL, 'Clustered mitochondria protein homolog [CLU1].', NULL, NULL, 'CLU', 236083),
(292358, 'MF_03122', NULL, '40S ribosomal protein S1 [RPS3A].', NULL, NULL, 'Ribosomal_S3Ae_euk', 236084),
(292359, 'MF_00087', NULL, 'Glutamyl-tRNA reductase [hemA].', NULL, NULL, 'Glu_tRNA_reductase', 236085),
(292360, 'MF_03120', NULL, 'Lon protease homolog, mitochondrial [LONP1].', NULL, NULL, 'lonm_euk', 236086),
(292361, 'MF_01554_B', NULL, 'Phosphoglucosamine mutase [glmM].', NULL, NULL, 'GlmM_B', 236087),
(292362, 'MF_01634', NULL, 'tRNA-guanine(15) transglycosylase [tgtA].', NULL, NULL, 'TgtA_arch', 236088),
(292363, 'MF_01002', NULL, 'TDP-N-acetylfucosamine:lipid II N-acetylfucosaminyltransferase [wecF].', NULL, NULL, 'WecF_RffT', 236089),
(292364, 'MF_01438', NULL, 'DNA integrity scanning protein DisA [disA].', NULL, NULL, 'DisA', 236090),
(292365, 'MF_01359', NULL, 'NADH-quinone oxidoreductase subunit C/D [nuoC].', NULL, NULL, 'NDH1_NuoCD_1', 236091),
(292366, 'MF_00694', NULL, 'Probable 5-dehydro-4-deoxyglucarate dehydratase.', NULL, NULL, 'KDGDH', 236092),
(292367, 'MF_01583', NULL, 'Threonine/serine transporter TdcC [tdcC].', NULL, NULL, 'Thr_Ser_transp_TdcC', 236093),
(292368, 'MF_00117', NULL, '33 kDa chaperonin [hslO].', NULL, NULL, 'HslO', 236094),
(292369, 'MF_00380', NULL, 'Integration host factor subunit alpha [ihfA].', NULL, NULL, 'IHF_alpha', 236095);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(292370, 'MF_00426', NULL, 'Na(+)-translocating NADH-quinone reductase subunit B [nqrB].', NULL, NULL, 'NqrB', 236096),
(292371, 'MF_00854', NULL, 'Carboxysome shell protein CcmK [ccmK].', NULL, NULL, 'CcmK', 236097),
(292372, 'MF_00336', NULL, 'ATP-dependent dethiobiotin synthetase BioD [bioD].', NULL, NULL, 'BioD', 236098),
(292373, 'MF_00118_B', NULL, 'Elongation factor Tu [tuf].', NULL, NULL, 'EF_Tu_B', 236099),
(292374, 'MF_04120', NULL, 'Portal protein.', NULL, NULL, 'PORTAL_PROTEIN_T7', 236100),
(292375, 'MF_01815', NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 3 [fabH].', NULL, NULL, 'FabH', 236101),
(292376, 'MF_03031', NULL, 'Protein argonaute-2 [AGO2].', NULL, NULL, 'AGO2', 236102),
(292377, 'MF_00399', NULL, 'Thiol:disulfide interchange protein DsbD [dsbD].', NULL, NULL, 'DbsD', 236103),
(292378, 'MF_04009', NULL, 'Shutoff alkaline exonuclease.', NULL, NULL, 'HSV_AN', 236104),
(292379, 'MF_00593', NULL, 'D-alanine--D-alanyl carrier protein ligase [dltA].', NULL, NULL, 'DltA', 236105),
(292380, 'MF_00709', NULL, 'Fumarate reductase subunit D [frdD].', NULL, NULL, 'Fumarate_red_D', 236106),
(292381, 'MF_00796', NULL, 'Nucleoside-triphosphatase <locus_tag>.', NULL, NULL, 'NTPase_1', 236107),
(292382, 'MF_03064', NULL, 'Mitochondrial glycine transporter [SLC25A38].', NULL, NULL, 'SLC25A38', 236108),
(292383, 'MF_00358', NULL, '30S ribosomal protein S21 [rpsU].', NULL, NULL, 'Ribosomal_S21', 236109),
(292384, 'MF_00525', NULL, 'Surface composition regulator [glgS].', NULL, NULL, 'GlgS', 236110),
(292385, 'MF_00330', NULL, 'Cobalt transport protein CbiN [cbiN].', NULL, NULL, 'CbiN', 236111),
(292386, 'MF_00919', NULL, 'Ribosome modulation factor [rmf].', NULL, NULL, 'RMF', 236112),
(292387, 'MF_02073', NULL, 'Putrescine transporter PotE [potE].', NULL, NULL, 'Putrescine_transp', 236113),
(292388, 'MF_03034', NULL, 'RISC-loading complex subunit @gn(TARBP2) [TARBP2].', NULL, NULL, 'TRBP2', 236114),
(292389, 'MF_03065', NULL, 'Regulator of telomere elongation helicase 1 [RTEL1].', NULL, NULL, 'RTEL1', 236115),
(292390, 'MF_01690', NULL, 'Succinyl-diaminopimelate desuccinylase [dapE].', NULL, NULL, 'DapE', 236116),
(292391, 'MF_00627', NULL, 'L-threonine 3-dehydrogenase [tdh].', NULL, NULL, 'Thr_dehydrog', 236117),
(292392, 'MF_03070', NULL, 'Scavenger receptor class A member 5 [SCARA5].', NULL, NULL, 'SCARA5', 236118),
(292393, 'MF_01932', NULL, 'AMP nucleosidase [amn].', NULL, NULL, 'AMP_nucleosidase', 236119),
(292394, 'MF_01401', NULL, 'Peptide methionine sulfoxide reductase MsrA [msrA].', NULL, NULL, 'MsrA', 236120),
(292395, 'MF_03199', NULL, 'Palmitoyltransferase <gene_name> [PFA4].', NULL, NULL, 'DHHC_PAT_PFA4', 236121),
(292396, 'MF_02009', NULL, 'Tyrosine--tRNA ligase [tyrS].', NULL, NULL, 'Tyr_tRNA_synth_type4', 236122),
(292397, 'MF_00411', NULL, 'DNA-directed RNA polymerase subunit Rpo1C [rpo1C].', NULL, NULL, 'RNApol_arch_Rpo1C', 236123),
(292398, 'MF_02248', NULL, 'Inner membrane lipoprotein DcrB [dcrB].', NULL, NULL, 'DcrB', 236124),
(292399, 'MF_03037', NULL, 'Probable cytosolic iron-sulfur protein assembly protein CIAO1 [CIAO1].', NULL, NULL, 'ciao1', 236125),
(292400, 'MF_01327', NULL, 'Thiamine-phosphate synthase [thiE].', NULL, NULL, 'TMP_synthase_cyanobact', 236126),
(292401, 'MF_01416', NULL, 'ATP synthase subunit delta [atpD].', NULL, NULL, 'ATP_synth_delta_bact', 236127),
(292402, 'MF_00695', NULL, 'High frequency lysogenization protein HflD [hflD].', NULL, NULL, 'HflD_protein', 236128),
(292403, 'MF_04100', NULL, 'DNA-directed DNA polymerase.', NULL, NULL, 'DPOL_T4', 236129),
(292404, 'MF_01064', NULL, 'UPF0253 protein YaeP [yaeP].', NULL, NULL, 'UPF0253', 236130),
(292405, 'MF_01836', NULL, 'Circadian clock protein kinase KaiC [kaiC].', NULL, NULL, 'KaiC', 236131),
(292406, 'MF_04052', NULL, 'Penton protein [L2].', NULL, NULL, 'ADV_CAPSP', 236132),
(292407, 'MF_00833', NULL, 'FMN reductase (NADH) RutF [rutF].', NULL, NULL, 'RutF', 236133),
(292408, 'MF_00133', NULL, 'Tryptophan synthase beta chain [trpB].', NULL, NULL, 'Trp_synth_beta', 236134),
(292409, 'MF_00397', NULL, '2-(5''''-triphosphoribosyl)-3''-dephosphocoenzyme-A synthase [citG].', NULL, NULL, 'CitG', 236135);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(292410, 'MF_00666', NULL, 'Small, acid-soluble spore protein P [sspP].', NULL, NULL, 'SspP', 236136),
(292411, 'MF_02000', NULL, 'Small heat shock protein IbpA [ibpA].', NULL, NULL, 'HSP20_IbpA', 236137),
(292412, 'MF_00491', NULL, 'NAD(P)H-quinone oxidoreductase chain 4 [ndhD].', NULL, NULL, 'NDH1_NuoM', 236138),
(292413, 'MF_01489', NULL, 'Putative DNA helicase Rad25 [rad25].', NULL, NULL, 'Helicase_Rad25_arch', 236139),
(292414, 'MF_00417', NULL, 'Pyrrolidone-carboxylate peptidase [pcp].', NULL, NULL, 'Pyrrolid_peptidase', 236140),
(292415, 'MF_02037', NULL, 'Histidine N-alpha-methyltransferase [egtD].', NULL, NULL, 'EgtD', 236141),
(292416, 'MF_01303', NULL, 'Photosystem I iron-sulfur center [psaC].', NULL, NULL, 'PSI_PsaC', 236142),
(292417, 'MF_00028', NULL, 'Cobyric acid synthase [cobQ].', NULL, NULL, 'CobQ', 236143),
(292418, 'MF_00455', NULL, 'Xylose isomerase [xylA].', NULL, NULL, 'Xylose_isom_A', 236144),
(292419, 'MF_01465', NULL, 'Protein translocase subunit SecY [secY].', NULL, NULL, 'SecY', 236145),
(292420, 'MF_01194', NULL, 'Heat shock protein HspQ [hspQ].', NULL, NULL, 'HspQ', 236146),
(292421, 'MF_00772', NULL, 'Methylated-DNA--protein-cysteine methyltransferase [ogt].', NULL, NULL, 'OGT', 236147),
(292422, 'MF_00754', NULL, 'Ribonuclease P protein component 1 [rnp1].', NULL, NULL, 'RNase_P_1', 236148),
(292423, 'MF_01504', NULL, 'Small, acid-soluble spore protein K [sspK].', NULL, NULL, 'SspK', 236149),
(292424, 'MF_01837', NULL, 'Adaptive-response sensory-kinase SasA [sasA].', NULL, NULL, 'Kinase_SasA', 236150),
(292425, 'MF_01962', NULL, 'Adenine deaminase.', NULL, NULL, 'Adenine_deaminase', 236151),
(292426, 'MF_00818', NULL, 'NADPH-dependent 7-cyano-7-deazaguanine reductase [queF].', NULL, NULL, 'QueF_type1', 236152),
(292427, 'MF_01688', NULL, '2-hydroxy-6-oxo-6-phenylhexa-2,4-dienoate hydrolase [bphD].', NULL, NULL, 'Biphenyl_BphD', 236153),
(292428, 'MF_00698', NULL, 'Xaa-Pro dipeptidyl-peptidase [pepX].', NULL, NULL, 'Aminopeptidase_S15', 236154),
(292429, 'MF_00790', NULL, 'Lipase chaperone [lifO].', NULL, NULL, 'Lipase_chap', 236155),
(292430, 'MF_00068', NULL, 'N-acetylmuramic acid 6-phosphate etherase [murQ].', NULL, NULL, 'MurQ', 236156),
(292431, 'MF_01468', NULL, 'Mini-ribonuclease 3 [mrnC].', NULL, NULL, 'RNase_Mini_III', 236157),
(292432, 'MF_01566', NULL, 'UPF0370 protein YpfN [ypfN].', NULL, NULL, 'UPF0370', 236158),
(292433, 'MF_00744', NULL, 'Met repressor [metJ].', NULL, NULL, 'MetJ', 236159),
(292434, 'MF_01403', NULL, 'Probable phosphoketolase.', NULL, NULL, 'Phosphoketolase', 236160),
(292435, 'MF_01510', NULL, 'GMP synthase [glutamine-hydrolyzing] subunit A [guaAA].', NULL, NULL, 'GMP_synthase_A', 236161),
(292436, 'MF_00527', NULL, 'Putative 3-methyladenine DNA glycosylase.', NULL, NULL, '3MGH', 236162),
(292437, 'MF_00961', NULL, 'RNA polymerase sigma factor RpoH [rpoH].', NULL, NULL, 'Sigma70_RpoH', 236163),
(292438, 'MF_01864', NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase [miaB].', NULL, NULL, 'tRNA_metthiotr_MiaB', 236164),
(292439, 'MF_00829', NULL, 'UPF0435 protein <locus_tag>.', NULL, NULL, 'UPF0435', 236165),
(292440, 'MF_01117', NULL, 'CDP-archaeol synthase [carS].', NULL, NULL, 'CDP_archaeol_synth', 236166),
(292441, 'MF_00546', NULL, 'Acid shock protein [asr].', NULL, NULL, 'Asr', 236167),
(292442, 'MF_00497_A', NULL, 'Glycerol-1-phosphate dehydrogenase [NAD(P)+] [egsA].', NULL, NULL, 'G1P_dehydrogenase_A', 236168),
(292443, 'MF_00324', NULL, 'DNA polymerase II large subunit [polC].', NULL, NULL, 'DNApol_II_L_arch', 236169),
(292444, 'MF_01500', NULL, 'Tetrahydromethanopterin S-methyltransferase subunit G [mtrG].', NULL, NULL, 'MtrG', 236170),
(292445, 'MF_00131', NULL, 'Tryptophan synthase alpha chain [trpA].', NULL, NULL, 'Trp_synth_alpha', 236171),
(292446, 'MF_00017', NULL, 'Recombination protein RecR [recR].', NULL, NULL, 'RecR', 236172),
(292447, 'MF_02242', NULL, 'Archaetidylinositol phosphate synthase.', NULL, NULL, 'AIP_synthase', 236173),
(292448, 'MF_00347', NULL, 'Polyphosphate kinase [ppk].', NULL, NULL, 'Polyphosphate_kinase', 236174);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(292449, 'MF_00472', NULL, 'Ubiquinone biosynthesis O-methyltransferase [ubiG].', NULL, NULL, 'UbiG', 236175),
(292450, 'MF_00188', NULL, 'Protease HtpX [htpX].', NULL, NULL, 'Pept_M48_protease_HtpX', 236176),
(292451, 'MF_02006', NULL, 'Tyrosine--tRNA ligase [tyrS].', NULL, NULL, 'Tyr_tRNA_synth_type1', 236177),
(292452, 'MF_04113', NULL, 'Capsid vertex protein.', NULL, NULL, 'CAPSID_P_T4', 236178),
(292453, 'MF_01313', NULL, 'Nitric oxide reductase FlRd-NAD(+) reductase [norW].', NULL, NULL, 'NorW', 236179),
(292454, 'MF_01366', NULL, '50S ribosomal protein L13 [rplM].', NULL, NULL, 'Ribosomal_L13', 236180),
(292455, 'MF_00053', NULL, 'Ribonuclease HIII [rnhC].', NULL, NULL, 'RNase_HIII', 236181),
(292456, 'MF_00161', NULL, 'Lipoprotein signal peptidase [lspA].', NULL, NULL, 'LspA', 236182),
(292457, 'MF_00480_B', NULL, '30S ribosomal protein S7 [rpsG].', NULL, NULL, 'Ribosomal_S7_B', 236183),
(292458, 'MF_00842', NULL, 'Outer membrane protein A [ompA].', NULL, NULL, 'OmpA', 236184),
(292459, 'MF_01812', NULL, 'N-acetyltransferase Eis [eis].', NULL, NULL, 'Eis', 236185),
(292460, 'MF_01865', NULL, 'Ribosomal protein S12 methylthiotransferase RimO [rimO].', NULL, NULL, 'MTTase_RimO', 236186),
(292461, 'MF_00337', NULL, 'Exodeoxyribonuclease 7 small subunit [xseB].', NULL, NULL, 'Exonuc_7_S', 236187),
(292462, 'MF_00044', NULL, 'Aspartate--tRNA(Asp/Asn) ligase [aspS].', NULL, NULL, 'Asp_tRNA_synth_type1', 236188),
(292463, 'MF_00338', NULL, 'UPF0145 protein YbjQ [ybjQ].', NULL, NULL, 'UPF0145', 236189),
(292464, 'MF_00834', NULL, 'Adenosylmethionine-8-amino-7-oxononanoate aminotransferase [bioA].', NULL, NULL, 'BioA', 236190),
(292465, 'MF_00130', NULL, 'Holliday junction resolvase RecU [recU].', NULL, NULL, 'RecU', 236191),
(292466, 'MF_00003', NULL, 'Ribosome-binding factor A [rbfA].', NULL, NULL, 'RbfA', 236192),
(292467, 'MF_01165', NULL, 'Undecaprenyl phosphate-alpha-4-amino-4-deoxy-L-arabinose arabinosyl transferase [arnT].', NULL, NULL, 'ArnT_transfer', 236193),
(292468, 'MF_00760', NULL, 'UPF0302 protein <locus_tag>.', NULL, NULL, 'UPF0302', 236194),
(292469, 'MF_01275', NULL, 'Gamma-aminobutyraldehyde dehydrogenase [patD].', NULL, NULL, 'Aldedh_Prr', 236195),
(292470, 'MF_01477', NULL, 'Ribosomal silencing factor RsfS [rsfS].', NULL, NULL, 'Iojap_RsfS', 236196),
(292471, 'MF_02232', NULL, 'Ubiquinone biosynthesis protein UbiU [ubiU].', NULL, NULL, 'UbiU', 236197),
(292472, 'MF_00496', NULL, 'Fructose-6-phosphate aldolase [fsa].', NULL, NULL, 'F6P_aldolase', 236198),
(292473, 'MF_02065', NULL, 'Endolytic murein transglycosylase [mltG].', NULL, NULL, 'MltG', 236199),
(292474, 'MF_01216', NULL, 'FMN dependent NADH:quinone oxidoreductase [azoR].', NULL, NULL, 'Azoreductase_type1', 236200),
(292475, 'MF_01015', NULL, 'Putative transport protein YbjL [ybjL].', NULL, NULL, 'YbjL', 236201),
(292476, 'MF_01141', NULL, 'Antiholin-like protein LrgA [lrgA].', NULL, NULL, 'LrgA', 236202),
(292477, 'MF_03038', NULL, 'Cytosolic Fe-S cluster assembly factor NUBP1 [NUBP1].', NULL, NULL, 'NUBP1', 236203),
(292478, 'MF_00536', NULL, '4-hydroxythreonine-4-phosphate dehydrogenase [pdxA].', NULL, NULL, 'PdxA', 236204),
(292479, 'MF_00418', NULL, '4-hydroxy-tetrahydrodipicolinate synthase [dapA].', NULL, NULL, 'DapA', 236205),
(292480, 'MF_01036', NULL, 'Exoribonuclease 2 [rnb].', NULL, NULL, 'RNase_II', 236206),
(292481, 'MF_02059', NULL, 'Choline trimethylamine-lyase activating enzyme [cutD].', NULL, NULL, 'Activ_enz_CutD', 236207),
(292482, 'MF_02088', NULL, 'Probable queuosine precursor transporter.', NULL, NULL, 'Q_prec_transport', 236208),
(292483, 'MF_00280', NULL, '50S ribosomal protein L10 [rpl10].', NULL, NULL, 'Ribosomal_L10_arch', 236209),
(292484, 'MF_01446', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase [kae1].', NULL, NULL, 'Kae1', 236210),
(292485, 'MF_01529', NULL, 'Multidrug resistance protein MdtH [mdtH].', NULL, NULL, 'MFS_MdtH', 236211),
(292486, 'MF_01319', NULL, 'Thiol-disulfide oxidoreductase ResA [resA].', NULL, NULL, 'ResA', 236212),
(292487, 'MF_02034', NULL, 'Glutamate--cysteine ligase EgtA [egtA].', NULL, NULL, 'EgtA', 236213);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(292488, 'MF_01256', NULL, 'Putative metal-dependent hydrolase <locus_tag>.', NULL, NULL, 'YfiT_hydrol', 236214),
(292489, 'MF_02039', NULL, 'Cell division protein FtsN [ftsN].', NULL, NULL, 'FtsN_entero', 236215),
(292490, 'MF_00210', NULL, '3-phosphoshikimate 1-carboxyvinyltransferase [aroA].', NULL, NULL, 'EPSP_synth', 236216),
(292491, 'MF_01144', NULL, 'UPF0299 membrane protein YohJ [yohJ].', NULL, NULL, 'UPF0299', 236217),
(292492, 'MF_03046', NULL, 'Transcription and mRNA export factor <gene_name> [SUS1].', NULL, NULL, 'ENY2_Sus1', 236218),
(292493, 'MF_00167', NULL, 'Translational regulator CsrA [csrA].', NULL, NULL, 'CsrA', 236219),
(292494, 'MF_01007', NULL, 'Ribosomal RNA small subunit methyltransferase H [rsmH].', NULL, NULL, '16SrRNA_methyltr_H', 236220),
(292495, 'MF_01020', NULL, 'Phosphoribosyl-ATP pyrophosphatase [hisE].', NULL, NULL, 'HisE', 236221),
(292496, 'MF_04126', NULL, 'Intermediate capsid protein VP6.', NULL, NULL, 'Rota_VP6', 236222),
(292497, 'MF_03163', NULL, 'AdoMet-dependent rRNA methyltransferase <gene_name> [SPB1].', NULL, NULL, 'RNA_methyltr_E_SPB1', 236223),
(292498, 'MF_01447', NULL, 'Probable bifunctional tRNA threonylcarbamoyladenosine biosynthesis protein.', NULL, NULL, 'Kae1_Bud32_arch', 236224),
(292499, 'MF_00910', NULL, 'Cell division protein FtsL [ftsL].', NULL, NULL, 'FtsL', 236225),
(292500, 'MF_01639', NULL, 'Pyridoxal kinase PdxY [pdxY].', NULL, NULL, 'PdxY', 236226),
(292501, 'MF_01046', NULL, 'Protein/nucleic acid deglycase HchA [hchA].', NULL, NULL, 'Deglycase_HchA', 236227),
(292502, 'MF_02020', NULL, 'UDP-N-acetylmuramate--L-alanyl-gamma-D-glutamyl-meso-2,6-diaminoheptandioate ligase [mpl].', NULL, NULL, 'Mpl', 236228),
(292503, 'MF_00047', NULL, 'D-alanine--D-alanine ligase [ddl].', NULL, NULL, 'Dala_Dala_lig', 236229),
(292504, 'MF_00915', NULL, 'Cell division protein FtsP [ftsP].', NULL, NULL, 'FtsP', 236230),
(292505, 'MF_02205', NULL, 'ATP-dependent DNA helicase DinG [dinG].', NULL, NULL, 'DinG_proteobact', 236231),
(292506, 'MF_03009', NULL, 'Eukaryotic translation initiation factor 3 subunit J [EIF3J].', NULL, NULL, 'eIF3j', 236232),
(292507, 'MF_00924', NULL, 'Outer membrane protein assembly factor BamC [bamC].', NULL, NULL, 'OM_assembly_BamC', 236233),
(292508, 'MF_00140_B', NULL, 'Tryptophan--tRNA ligase [trpS].', NULL, NULL, 'Trp_tRNA_synth_B', 236234),
(292509, 'MF_03144', NULL, 'RNA-splicing ligase RtcB homolog [RTCB].', NULL, NULL, 'RtcB_euk', 236235),
(292510, 'MF_00081', NULL, 'Heat-inducible transcription repressor HrcA [hrcA].', NULL, NULL, 'HrcA', 236236),
(292511, 'MF_00946', NULL, 'Acid stress chaperone HdeA [hdeA].', NULL, NULL, 'HdeA', 236237),
(292512, 'MF_01397', NULL, 'NADH-quinone oxidoreductase subunit C/D [nuoC].', NULL, NULL, 'NDH1_NuoCD_2', 236238),
(292513, 'MF_01671', NULL, 'Inositol 2-dehydrogenase/D-chiro-inositol 3-dehydrogenase [iolG].', NULL, NULL, 'IolG', 236239),
(292514, 'MF_00041', NULL, 'Cysteine--tRNA ligase [cysS].', NULL, NULL, 'Cys_tRNA_synth', 236240),
(292515, 'MF_02052', NULL, '3-hydroxy-5-phosphonooxypentane-2,4-dione thiolase [lsrF].', NULL, NULL, 'LsrF', 236241),
(292516, 'MF_02067', NULL, 'Fructose-1,6-bisphosphate aldolase/phosphatase [fbp].', NULL, NULL, 'FBP_aldolase_phosphatase', 236242),
(292517, 'MF_01955', NULL, 'Urease subunit alpha [ureA].', NULL, NULL, 'Urease_beta_gamma', 236243),
(292518, 'MF_00112', NULL, 'Geranylgeranylglyceryl phosphate synthase [pcrB].', NULL, NULL, 'GGGP_HepGP_synthase', 236244),
(292519, 'MF_01103', NULL, 'UPF0291 protein <locus_tag>.', NULL, NULL, 'UPF0291', 236245),
(292520, 'MF_01452', NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B [addB].', NULL, NULL, 'AddB_type1', 236246),
(292521, 'MF_00939', NULL, 'DNA topoisomerase 4 subunit B [parE].', NULL, NULL, 'ParE_type2', 236247),
(292522, 'MF_00434', NULL, 'Putative pterin-4-alpha-carbinolamine dehydratase.', NULL, NULL, 'Pterin_4_alpha', 236248),
(292523, 'MF_01229', NULL, 'Alkanesulfonate monooxygenase [ssuD].', NULL, NULL, 'Alkanesulf_monooxygen', 236249),
(292524, 'MF_01911', NULL, 'HTH-type transcriptional regulator Hpr [hpr].', NULL, NULL, 'HTH_type_Hpr', 236250);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(292525, 'MF_00153', NULL, 'Probable deoxyhypusine synthase [dys].', NULL, NULL, 'DHS', 236251),
(292526, 'MF_00628', NULL, 'Peptidyl-tRNA hydrolase [pth].', NULL, NULL, 'Pept_tRNA_hydro_arch', 236252),
(292527, 'MF_04025', NULL, 'Capsid vertex component 2 [CVC2].', NULL, NULL, 'HSV_CVC2', 236253),
(292528, 'MF_01697', NULL, 'L-cysteine:1D-myo-inositol 2-amino-2-deoxy-alpha-D-glucopyranoside ligase [mshC].', NULL, NULL, 'MshC', 236254),
(292529, 'MF_00288', NULL, 'Methionine synthase [metE].', NULL, NULL, 'MetE', 236255),
(292530, 'MF_01091', NULL, '5,10-methylenetetrahydromethanopterin reductase [mer].', NULL, NULL, 'F420_mer', 236256),
(292531, 'MF_00659', NULL, 'UPF0250 protein YbeD [ybeD].', NULL, NULL, 'UPF0250', 236257),
(292532, 'MF_01238', NULL, 'Sialic acid transporter NanT [nanT].', NULL, NULL, 'MFS_NanT', 236258),
(292533, 'MF_03217', NULL, 'Phosphatidylethanolamine N-methyltransferase.', NULL, NULL, 'PEMT', 236259),
(292534, 'MF_03227', NULL, 'Butyryl-CoA:acetate CoA-transferase.', NULL, NULL, 'But_acet_CoA_trans', 236260),
(292535, 'MF_00503', NULL, '50S ribosomal protein L9 [rplI].', NULL, NULL, 'Ribosomal_L9', 236261),
(292536, 'MF_00198', NULL, 'Polyamine aminopropyltransferase [speE].', NULL, NULL, 'Spermidine_synth', 236262),
(292537, 'MF_01571', NULL, 'Proline--tRNA ligase [proS].', NULL, NULL, 'Pro_tRNA_synth_type3', 236263),
(292538, 'MF_00203', NULL, 'UvrABC system protein C [uvrC].', NULL, NULL, 'UvrC', 236264),
(292539, 'MF_00986', NULL, 'L-fuculokinase [fucK].', NULL, NULL, 'Fuculokinase', 236265),
(292540, 'MF_04150', NULL, 'RNA ligase 2.', NULL, NULL, 'RNALIG2_T4', 236266),
(292541, 'MF_03050', NULL, 'Molybdenum cofactor sulfurase [MOCOS].', NULL, NULL, 'MOCOS', 236267),
(292542, 'MF_00222', NULL, 'Shikimate dehydrogenase (NADP(+)) [aroE].', NULL, NULL, 'Shikimate_DH_AroE', 236268),
(292543, 'MF_00436', NULL, 'RNA-binding protein Hfq [hfq].', NULL, NULL, 'Hfq', 236269),
(292544, 'MF_01293', NULL, 'D-tagatose-1,6-bisphosphate aldolase subunit KbaY [kbaY].', NULL, NULL, 'TagBP_aldolase_KbaY', 236270),
(292545, 'MF_01149', NULL, 'Uncharacterized MFS-type transporter YcaD [ycaD].', NULL, NULL, 'MFS_YcaD', 236271),
(292546, 'MF_01478', NULL, '50S ribosomal protein L12 [rpl12].', NULL, NULL, 'Ribosomal_L12_arch', 236272),
(292547, 'MF_00499', NULL, '50S ribosomal protein L13e [rpl13e].', NULL, NULL, 'Ribosomal_L13e', 236273),
(292548, 'MF_01309_B', NULL, '30S ribosomal protein S3 [rpsC].', NULL, NULL, 'Ribosomal_S3_B', 236274),
(292549, 'MF_00218', NULL, 'Uroporphyrinogen decarboxylase [hemE].', NULL, NULL, 'URO_D', 236275),
(292550, 'MF_01269', NULL, 'Shikimate kinase 2 [aroL].', NULL, NULL, 'Shikimate_kinase_2', 236276),
(292551, 'MF_01306_B', NULL, '30S ribosomal protein S4 [rpsD].', NULL, NULL, 'Ribosomal_S4_B', 236277),
(292552, 'MF_04166', NULL, 'N6-succino-2-amino-2''-deoxyadenylate synthase [purZ].', NULL, NULL, 'Phage_PURZ', 236278),
(292553, 'MF_00292', NULL, '30S ribosomal protein S28e [rps28e].', NULL, NULL, 'Ribosomal_S28e', 236279),
(292554, 'MF_02217', NULL, 'tRNA 5-hydroxyuridine methyltransferase [trmR].', NULL, NULL, 'TrmR_methyltr', 236280),
(292555, 'MF_00099', NULL, 'Protein-glutamate methylesterase/protein-glutamine glutaminase [cheB].', NULL, NULL, 'CheB_chemtxs', 236281),
(292556, 'MF_00113', NULL, 'S-adenosylmethionine:tRNA ribosyltransferase-isomerase [queA].', NULL, NULL, 'QueA', 236282),
(292557, 'MF_01030', NULL, 'D-serine dehydratase [dsdA].', NULL, NULL, 'D_Ser_dehydrat', 236283),
(292558, 'MF_01225_A', NULL, 'GTP 3'',8-cyclase [moaA].', NULL, NULL, 'MoaA_A', 236284),
(292559, 'MF_01105', NULL, 'Amino-acid acetyltransferase [argA].', NULL, NULL, 'N_acetyl_glu_synth', 236285),
(292560, 'MF_00379', NULL, 'tRNA modification GTPase MnmE [mnmE].', NULL, NULL, 'GTPase_MnmE', 236286),
(292561, 'MF_00684', NULL, 'N(4)-acetylcytidine amidohydrolase.', NULL, NULL, 'ac4C_amidohydr', 236287),
(292562, 'MF_00615', NULL, 'DNA-directed RNA polymerase subunit Rpo12 [rpo12].', NULL, NULL, 'RNApol_arch_Rpo12', 236288),
(292563, 'MF_00996', NULL, '1,4-dihydroxy-6-naphtoate synthase [mqnD].', NULL, NULL, 'MqnD', 236289);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(292564, 'MF_02244', NULL, 'Coproheme decarboxylase [chdC].', NULL, NULL, 'Coproheme_decarbox_2', 236290),
(292565, 'MF_00473', NULL, 'Glucose-6-phosphate isomerase [pgi].', NULL, NULL, 'G6P_isomerase', 236291),
(292566, 'MF_00768', NULL, 'HTH-type transcriptional regulator BetI [betI].', NULL, NULL, 'HTH_type_BetI', 236292),
(292567, 'MF_00464', NULL, 'S-adenosylmethionine decarboxylase proenzyme [speH].', NULL, NULL, 'AdoMetDC_1', 236293),
(292568, 'MF_01582', NULL, 'Serine/threonine transporter SstT [sstT].', NULL, NULL, 'Ser_Thr_transp_SstT', 236294),
(292569, 'MF_01656', NULL, '4-hydroxy-2-oxovalerate aldolase [mhpE].', NULL, NULL, 'HOA', 236295),
(292570, 'MF_03223', NULL, 'Protein N-terminal and lysine N-methyltransferase EFM7 [EFM7].', NULL, NULL, 'Methyltr_EFM7', 236296),
(292571, 'MF_04071', NULL, 'Neuraminidase [NA].', NULL, NULL, 'INFV_NRAM', 236297),
(292572, 'MF_01499', NULL, 'Diadenylate cyclase [dacA].', NULL, NULL, 'DacA', 236298),
(292573, 'MF_03207', NULL, 'Elongation of very long chain fatty acids protein 7 [ELOVL7].', NULL, NULL, 'VLCF_elongase_7', 236299),
(292574, 'MF_01487', NULL, 'RecBCD enzyme subunit RecD [recD].', NULL, NULL, 'RecD', 236300),
(292575, 'MF_00301', NULL, 'Homoserine kinase [thrB].', NULL, NULL, 'Homoser_kinase_2', 236301),
(292576, 'MF_00008', NULL, 'Thymidylate synthase [thyA].', NULL, NULL, 'Thymidy_synth_bact', 236302),
(292577, 'MF_00469', NULL, 'tRNA uridine(34) hydroxylase [trhO].', NULL, NULL, 'TrhO', 236303),
(292578, 'MF_01428', NULL, 'Glutamyl-Q tRNA(Asp) synthetase [gluQ].', NULL, NULL, 'Glu_Q_tRNA_synth', 236304),
(292579, 'MF_01114', NULL, 'Regulatory protein RecX [recX].', NULL, NULL, 'RecX', 236305),
(292580, 'MF_04136', NULL, 'SAR-endolysin.', NULL, NULL, 'SAR_ENDOLYSIN', 236306),
(292581, 'MF_02213', NULL, 'Lipid II isoglutaminyl synthase (glutamine-hydrolyzing) subunit GatD [gatD].', NULL, NULL, 'Lipid_II_synth_GatD', 236307),
(292582, 'MF_01257', NULL, 'Phosphoenolpyruvate transferase [fbiA].', NULL, NULL, 'CofD', 236308),
(292583, 'MF_01182', NULL, 'Cytochrome c-552 [nrfA].', NULL, NULL, 'Cytochrom_C552', 236309),
(292584, 'MF_02202', NULL, 'Tol-Pal system protein TolQ [tolQ].', NULL, NULL, 'TolQ', 236310),
(292585, 'MF_01316', NULL, 'Photosystem II reaction center protein I [psbI].', NULL, NULL, 'PSII_PsbI', 236311),
(292586, 'MF_03148', NULL, 'Inosine triphosphate pyrophosphatase [ITPA].', NULL, NULL, 'HAM1_NTPase', 236312),
(292587, 'MF_01693', NULL, '8-amino-7-oxononanoate synthase [bioF].', NULL, NULL, 'BioF_aminotrans_2', 236313),
(292588, 'MF_04125', NULL, 'Outer capsid protein VP4.', NULL, NULL, 'Rota_VP4', 236314),
(292589, 'MF_00509', NULL, 'Cell division protein ZipA [zipA].', NULL, NULL, 'ZipA', 236315),
(292590, 'MF_02225', NULL, 'Coenzyme A biosynthesis bifunctional protein CoaBC [coaBC].', NULL, NULL, 'CoaBC', 236316),
(292591, 'MF_01580', NULL, 'Cell division activator CedA [cedA].', NULL, NULL, 'CedA', 236317),
(292592, 'MF_01341', NULL, '50S ribosomal protein L15 [rplO].', NULL, NULL, 'Ribosomal_L15', 236318),
(292593, 'MF_01846', NULL, 'Nucleoside triphosphatase NudI [nudI].', NULL, NULL, 'Nudix_NudI', 236319),
(292594, 'MF_01492', NULL, 'Ribonuclease J [rnj].', NULL, NULL, 'RNase_J_arch', 236320),
(292595, 'MF_01859', NULL, 'Ribosomal RNA large subunit methyltransferase G [rlmG].', NULL, NULL, '23SrRNA_methyltr_G', 236321),
(292596, 'MF_04080', NULL, 'Protein Vpr [vpr].', NULL, NULL, 'HIV_VPR', 236322),
(292597, 'MF_00832', NULL, 'Putative aminoacrylate hydrolase RutD [rutD].', NULL, NULL, 'RutD', 236323),
(292598, 'MF_00020', NULL, 'Acetate kinase [ackA].', NULL, NULL, 'Acetate_kinase', 236324),
(292599, 'MF_00622', NULL, 'Exosome complex component Rrp42 [rrp42].', NULL, NULL, 'Exosome_Rrp42', 236325),
(292600, 'MF_01274', NULL, 'Type III pantothenate kinase [coaX].', NULL, NULL, 'Pantothen_kinase_3', 236326),
(292601, 'MF_00640', NULL, 'Deoxyhypusine synthase-like protein.', NULL, NULL, 'DHS_like', 236327),
(292602, 'MF_01210_A', NULL, 'Carbamoyl-phosphate synthase large chain [carB].', NULL, NULL, 'CPSase_L_chain_A', 236328);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(292603, 'MF_00448', NULL, '50S ribosomal protein L10e [rpl10e].', NULL, NULL, 'Ribosomal_L10e', 236329),
(292604, 'MF_01343_A', NULL, '30S ribosomal protein S15 [rpsO].', NULL, NULL, 'Ribosomal_S15_A', 236330),
(292605, 'MF_00049_B', NULL, 'Leucine--tRNA ligase [leuS].', NULL, NULL, 'Leu_tRNA_synth_B', 236331),
(292606, 'MF_00255', NULL, 'Glycine--tRNA ligase beta subunit [glyS].', NULL, NULL, 'Gly_tRNA_synth_beta', 236332),
(292607, 'MF_01544', NULL, 'p-hydroxybenzoic acid efflux pump subunit AaeA [aaeA].', NULL, NULL, 'AaeA', 236333),
(292608, 'MF_00839', NULL, 'Ribosome hibernation promoting factor [hpf].', NULL, NULL, 'HPF', 236334),
(292609, 'MF_02002', NULL, 'Isoleucine--tRNA ligase [ileS].', NULL, NULL, 'Ile_tRNA_synth_type1', 236335),
(292610, 'MF_03036', NULL, '2''-deoxynucleoside 5''-phosphate N-hydrolase 1 [DNPH1].', NULL, NULL, 'Nuc_phosphate_hydrolase', 236336),
(292611, 'MF_00517', NULL, 'Probable sugar efflux transporter [sotB].', NULL, NULL, 'MFS_SotB', 236337),
(292612, 'MF_01247', NULL, 'HTH-type transcriptional regulator MalT [malT].', NULL, NULL, 'HTH_type_MalT', 236338),
(292613, 'MF_01562', NULL, 'Flotillin-like protein FloA [floA].', NULL, NULL, 'FloA', 236339),
(292614, 'MF_00444', NULL, 'ATP-dependent Clp protease proteolytic subunit [clpP].', NULL, NULL, 'ClpP', 236340),
(292615, 'MF_00809', NULL, 'ADP-dependent glucose/glucosamine kinase [glkA].', NULL, NULL, 'ADP_glucokinase', 236341),
(292616, 'MF_00727', NULL, 'Protein-glutamine gamma-glutamyltransferase [tgl].', NULL, NULL, 'Tgl', 236342),
(292617, 'MF_01358', NULL, 'NAD(P)H-quinone oxidoreductase subunit H, chloroplastic [ndhH].', NULL, NULL, 'NDH1_NuoD', 236343),
(292618, 'MF_04146', NULL, 'Terminase, large subunit.', NULL, NULL, 'TERL_T4', 236344),
(292619, 'MF_00196', NULL, 'Mannitol-1-phosphate 5-dehydrogenase [mtlD].', NULL, NULL, 'Mannitol_dehydrog', 236345),
(292620, 'MF_00935', NULL, 'Alanine dehydrogenase [ala].', NULL, NULL, 'AlaDH_arch', 236346),
(292621, 'MF_01096', NULL, 'Tetrahydromethanopterin S-methyltransferase subunit C [mtrC].', NULL, NULL, 'MtrC', 236347),
(292622, 'MF_01694', NULL, 'Biotin synthase [bioB].', NULL, NULL, 'BioB', 236348),
(292623, 'MF_01035', NULL, '3-isopropylmalate dehydrogenase [leuB].', NULL, NULL, 'LeuB_type2', 236349),
(292624, 'MF_00844_A', NULL, 'Rqc2 homolog RqcH [rqcH].', NULL, NULL, 'RqcH_A', 236350),
(292625, 'MF_01543', NULL, 'Formate--tetrahydrofolate ligase [fhs].', NULL, NULL, 'FTHFS', 236351),
(292626, 'MF_01116', NULL, '16S rRNA aminocarboxypropyltransferase.', NULL, NULL, 'TSR3', 236352),
(292627, 'MF_00246', NULL, 'Galactokinase [galK].', NULL, NULL, 'Galactokinase', 236353),
(292628, 'MF_03188', NULL, 'EEF1A lysine methyltransferase 2 [EEF1AKMT2].', NULL, NULL, 'Methyltr_EFM4', 236354),
(292629, 'MF_00492', NULL, 'Transaldolase [tal].', NULL, NULL, 'Transaldolase_1', 236355),
(292630, 'MF_00274', NULL, 'Nucleoid-associated protein YbaB [ybaB].', NULL, NULL, 'DNA_YbaB_EbfC', 236356),
(292631, 'MF_00094', NULL, 'Peptide chain release factor 2 [prfB].', NULL, NULL, 'Rel_fac_2', 236357),
(292632, 'MF_00723', NULL, 'Glutathione-dependent formaldehyde-activating enzyme [gfa].', NULL, NULL, 'Formald_GSH', 236358),
(292633, 'MF_03205', NULL, 'Elongation of very long chain fatty acids protein 5 [ELOVL5].', NULL, NULL, 'VLCF_elongase_5', 236359),
(292634, 'MF_01125', NULL, 'Reverse gyrase [rgy].', NULL, NULL, 'Reverse_gyrase', 236360),
(292635, 'MF_01440', NULL, 'Chemoreceptor glutamine deamidase CheD [cheD].', NULL, NULL, 'CheD', 236361),
(292636, 'MF_00072', NULL, 'Peptide chain release factor 3 [prfC].', NULL, NULL, 'Rel_fac_3', 236362),
(292637, 'MF_04076', NULL, 'External core antigen [C].', NULL, NULL, 'HBV_HBEAG', 236363),
(292638, 'MF_00277', NULL, 'Bifunctional uridylyltransferase/uridylyl-removing enzyme [glnD].', NULL, NULL, 'PII_uridylyl_transf', 236364),
(292639, 'MF_00589', NULL, 'Photosystem II 12 kDa extrinsic protein [psbU].', NULL, NULL, 'PSII_PsbU', 236365),
(292640, 'MF_03193', NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial [COQ6].', NULL, NULL, 'COQ6_monooxygenase', 236366);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(292641, 'MF_00569', NULL, 'Quinolinate synthase A [nadA].', NULL, NULL, 'NadA_type3', 236367),
(292642, 'MF_00174', NULL, 'Elongation factor P--(R)-beta-lysine ligase [epmA].', NULL, NULL, 'EF_P_modif_A', 236368),
(292643, 'MF_01023', NULL, 'Histidinol-phosphate aminotransferase [hisC].', NULL, NULL, 'HisC_aminotrans_2', 236369),
(292644, 'MF_01430', NULL, 'Outer membrane protein assembly factor BamA [bamA].', NULL, NULL, 'OM_assembly_BamA', 236370),
(292645, 'MF_02014', NULL, 'Cell division suppressor protein YneA [yneA].', NULL, NULL, 'YneA', 236371),
(292646, 'MF_01018', NULL, 'ATP phosphoribosyltransferase [hisG].', NULL, NULL, 'HisG_Short', 236372),
(292647, 'MF_03003', NULL, 'Eukaryotic translation initiation factor 3 subunit D [EIF3D].', NULL, NULL, 'eIF3d', 236373),
(292648, 'MF_03153', NULL, 'U1 small nuclear ribonucleoprotein C [SNRPC].', NULL, NULL, 'U1_C', 236374),
(292649, 'MF_03162', NULL, 'Putative tRNA (cytidine(32)/guanosine(34)-2''-O)-methyltransferase [TRM7].', NULL, NULL, 'RNA_methyltr_E_TRM7', 236375),
(292650, 'MF_03103', NULL, 'Maintenance of mitochondrial morphology protein 1 [MMM1].', NULL, NULL, 'Mmm1', 236376),
(292651, 'MF_00674', NULL, 'UPF0251 protein <locus_tag>.', NULL, NULL, 'UPF0251', 236377),
(292652, 'MF_03113', NULL, 'Golgi to ER traffic protein 1 [GET1].', NULL, NULL, 'Get1', 236378),
(292653, 'MF_01282', NULL, 'Virginiamycin B lyase [vgb].', NULL, NULL, 'VirginiamycinB_lyase', 236379),
(292654, 'MF_00940', NULL, 'Tat proofreading chaperone DmsD [dmsD].', NULL, NULL, 'DmsD_chaperone', 236380),
(292655, 'MF_01354', NULL, 'NAD(P)H-quinone oxidoreductase subunit O [ndhO].', NULL, NULL, 'NDH1_NDH1O', 236381),
(292656, 'MF_01219', NULL, 'Bifunctional protein PyrR [pyrR].', NULL, NULL, 'PyrR', 236382),
(292657, 'MF_00018', NULL, 'UPF0758 protein YicR [yicR].', NULL, NULL, 'UPF0758_YicR', 236383),
(292658, 'MF_00162', NULL, 'Glutathione synthetase [gshB].', NULL, NULL, 'GSH_S', 236384),
(292659, 'MF_01380', NULL, 'Iron-sulfur cluster insertion protein ErpA [erpA].', NULL, NULL, 'Fe_S_insert_ErpA', 236385),
(292660, 'MF_00912', NULL, 'Cell division protein DivIB [divIB].', NULL, NULL, 'DivIB', 236386),
(292661, 'MF_02096', NULL, 'DNA repair protein.', NULL, NULL, 'Nre', 236387),
(292662, 'MF_00697', NULL, 'UPF0276 protein <locus_tag>.', NULL, NULL, 'UPF0276', 236388),
(292663, 'MF_04084', NULL, 'Pre-glycoprotein polyprotein GP complex [GPC].', NULL, NULL, 'ARENA_GPC', 236389),
(292664, 'MF_00183', NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase [dxr].', NULL, NULL, 'DXP_reductoisom', 236390),
(292665, 'MF_00064', NULL, 'Sulfate adenylyltransferase subunit 2 [cysD].', NULL, NULL, 'Sulf_adenylyltr_sub2', 236391),
(292666, 'MF_01669', NULL, '3D-(3,5/4)-trihydroxycyclohexane-1,2-dione hydrolase [iolD].', NULL, NULL, 'IolD', 236392),
(292667, 'MF_01201', NULL, 'Alanine racemase.', NULL, NULL, 'Ala_racemase', 236393),
(292668, 'MF_02246', NULL, 'Guanosine-inosine kinase [gsk].', NULL, NULL, 'Gua_Ino_kinase', 236394),
(292669, 'MF_03141', NULL, 'Platelet-activating factor acetylhydrolase IB subunit alpha [PAFAH1B1].', NULL, NULL, 'lis1', 236395),
(292670, 'MF_00135', NULL, 'N-(5''-phosphoribosyl)anthranilate isomerase [trpF].', NULL, NULL, 'PRAI', 236396),
(292671, 'MF_00498', NULL, 'UPF0179 protein <locus_tag>.', NULL, NULL, 'UPF0179', 236397),
(292672, 'MF_00654', NULL, 'Pyrroloquinoline-quinone synthase [pqqC].', NULL, NULL, 'PQQ_syn_PqqC', 236398),
(292673, 'MF_01541', NULL, 'Sulfite reductase [NADPH] flavoprotein alpha-component [cysJ].', NULL, NULL, 'CysJ', 236399),
(292674, 'MF_01814', NULL, 'Transcription factor FapR [fapR].', NULL, NULL, 'Transcrip_fact_FapR', 236400),
(292675, 'MF_01364_A', NULL, '30S ribosomal protein S14 type Z [rpsZ].', NULL, NULL, 'Ribosomal_S14_2_A', 236401),
(292676, 'MF_00749', NULL, 'RNA chaperone ProQ [proQ].', NULL, NULL, 'ProQ', 236402),
(292677, 'MF_00667', NULL, 'Small, acid-soluble spore protein H [sspH].', NULL, NULL, 'SspH', 236403),
(292678, 'MF_00565', NULL, 'D-alanyl carrier protein [dltC].', NULL, NULL, 'DltC', 236404);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(292679, 'MF_04018', NULL, 'Triplex capsid protein 1 [TRX1].', NULL, NULL, 'HSV_TRX1', 236405),
(292680, 'MF_01508', NULL, 'Replication factor C large subunit [rfcL].', NULL, NULL, 'RfcL', 236406),
(292681, 'MF_00069', NULL, 'Hydroxylamine reductase [hcp].', NULL, NULL, 'Hydroxylam_reduct', 236407),
(292682, 'MF_04059', NULL, 'Protease [L3].', NULL, NULL, 'ADV_PRO', 236408),
(292683, 'MF_00138', NULL, 'Phosphoribosylamine--glycine ligase [purD].', NULL, NULL, 'GARS', 236409),
(292684, 'MF_01804', NULL, 'Segregation and condensation protein B [scpB].', NULL, NULL, 'ScpB', 236410),
(292685, 'MF_02054', NULL, 'Tyrosine recombinase XerH [xerH].', NULL, NULL, 'Recomb_XerH', 236411),
(292686, 'MF_00675', NULL, 'Uronate isomerase [uxaC].', NULL, NULL, 'UxaC', 236412),
(292687, 'MF_01370', NULL, 'Photosystem II reaction center Psb28 protein [psb28].', NULL, NULL, 'PSII_Psb28', 236413),
(292688, 'MF_01967', NULL, 'NAD-dependent protein deacetylase [cobB].', NULL, NULL, 'Sirtuin_ClassII', 236414),
(292689, 'MF_01049', NULL, 'L-carnitine/gamma-butyrobetaine antiporter [caiT].', NULL, NULL, 'CaiT', 236415),
(292690, 'MF_01110', NULL, 'N-acetyl-gamma-glutamyl-phosphate reductase [argC].', NULL, NULL, 'ArgC_type2', 236416),
(292691, 'MF_00176', NULL, 'Serine--tRNA ligase [serS].', NULL, NULL, 'Ser_tRNA_synth_type1', 236417),
(292692, 'MF_00303', NULL, 'Trigger factor [tig].', NULL, NULL, 'Trigger_factor_Tig', 236418),
(292693, 'MF_00273', NULL, '50S ribosomal protein L18Ae [rpl18a].', NULL, NULL, 'Ribosomal_L18Ae', 236419),
(292694, 'MF_02124', NULL, 'Alpha-1,4-glucan:maltose-1-phosphate maltosyltransferase [glgE].', NULL, NULL, 'GlgE', 236420),
(292695, 'MF_03004', NULL, 'Eukaryotic translation initiation factor 3 subunit E [EIF3E].', NULL, NULL, 'eIF3e', 236421),
(292696, 'MF_01467', NULL, 'Hypoxanthine/guanine phosphoribosyltransferase [hpt].', NULL, NULL, 'Hypx_phosphoribosyltr', 236422),
(292697, 'MF_01975', NULL, 'Methionine aminopeptidase [map].', NULL, NULL, 'MetAP_2_arc', 236423),
(292698, 'MF_01612', NULL, '5-amino-6-(D-ribitylamino)uracil--L-tyrosine 4-hydroxyphenyl transferase [cofH].', NULL, NULL, 'FO_synth_sub2', 236424),
(292699, 'MF_00571', NULL, 'Galactose-1-phosphate uridylyltransferase [galT].', NULL, NULL, 'GalP_UDP_trans', 236425),
(292700, 'MF_00373', NULL, '50S ribosomal protein L28 [rpmB].', NULL, NULL, 'Ribosomal_L28', 236426),
(292701, 'MF_00258', NULL, 'Glutamate racemase [murI].', NULL, NULL, 'Glu_racemase', 236427),
(292702, 'MF_00542', NULL, 'Probable butyrate kinase [buk].', NULL, NULL, 'Butyrate_kinase', 236428),
(292703, 'MF_00478', NULL, 'Ion-translocating oxidoreductase complex subunit E [rsxE].', NULL, NULL, 'RsxE_RnfE', 236429),
(292704, 'MF_00633', NULL, 'Cytochrome b6 [petB].', NULL, NULL, 'Cytb6_f_cytb6', 236430),
(292705, 'MF_04152', NULL, 'Single-stranded DNA-binding protein [32].', NULL, NULL, 'SSB_T4', 236431),
(292706, 'MF_00706', NULL, 'Ecotin [eco].', NULL, NULL, 'Ecotin', 236432),
(292707, 'MF_01152', NULL, 'Chaperone protein DnaJ [dnaJ].', NULL, NULL, 'DnaJ', 236433),
(292708, 'MF_04145', NULL, 'Terminase, large subunit.', NULL, NULL, 'TERL_SPP1', 236434),
(292709, 'MF_01386', NULL, 'Photosystem II reaction center X protein [psbX].', NULL, NULL, 'PSII_PsbX_1', 236435),
(292710, 'MF_01377', NULL, 'Probable lipid kinase YegS [yegS].', NULL, NULL, 'YegS', 236436),
(292711, 'MF_00090', NULL, 'Protein-L-isoaspartate O-methyltransferase [pcm].', NULL, NULL, 'PIMT', 236437),
(292712, 'MF_00313', NULL, 'Glutaminase [glsA].', NULL, NULL, 'Glutaminase', 236438),
(292713, 'MF_04122', NULL, 'Internal virion protein gp15.', NULL, NULL, 'GP15_T7', 236439),
(292714, 'MF_00848', NULL, 'ATP-binding protein Uup [uup].', NULL, NULL, 'Uup', 236440),
(292715, 'MF_01681', NULL, 'Enolase-phosphatase E1 [mtnC].', NULL, NULL, 'Salvage_MtnC', 236441),
(292716, 'MF_00556', NULL, 'Bacteriohemerythrin.', NULL, NULL, 'Hemerythrin', 236442),
(292717, 'MF_01177', NULL, 'HTH-type transcriptional repressor NsrR [nsrR].', NULL, NULL, 'HTH_type_NsrR', 236443),
(292718, 'MF_04023', NULL, 'Nuclear egress protein 1 [NEC1].', NULL, NULL, 'HSV_NEC1', 236444);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(292719, 'MF_01573', NULL, 'Pyrrolysine--tRNA ligase [pylS].', NULL, NULL, 'Pyl_tRNA_synth', 236445),
(292720, 'MF_00420', NULL, 'Phosphoribosylformylglycinamidine synthase subunit PurL [purL].', NULL, NULL, 'PurL_2', 236446),
(292721, 'MF_01977', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase [pfp].', NULL, NULL, 'Phosphofructokinase_II_P', 236447),
(292722, 'MF_00287', NULL, 'Probable disulfide formation protein [bdbC].', NULL, NULL, 'BdbC', 236448),
(292723, 'MF_00193', NULL, 'NH(3)-dependent NAD(+) synthetase [nadE].', NULL, NULL, 'NadE_ammonia_dep', 236449),
(292724, 'MF_01291', NULL, '5-keto-4-deoxy-D-glucarate aldolase [garL].', NULL, NULL, 'KDGluc_aldolase', 236450),
(292725, 'MF_01985', NULL, 'Phenolic acid decarboxylase.', NULL, NULL, 'UbiD_YclC', 236451),
(292726, 'MF_00109', NULL, 'Shikimate kinase [aroK].', NULL, NULL, 'Shikimate_kinase', 236452),
(292727, 'MF_04142', NULL, 'NAD--protein ADP-ribosyltransferase modB [modB].', NULL, NULL, 'MODB_T4', 236453),
(292728, 'MF_00575', NULL, 'UDP-2,3-diacylglucosamine hydrolase [lpxH].', NULL, NULL, 'LpxH', 236454),
(292729, 'MF_01986', NULL, 'Probable UbiX-like flavin prenyltransferase.', NULL, NULL, 'ubiX_pad_yclB', 236455),
(292730, 'MF_00858', NULL, 'Carboxysome shell vertex protein CcmL [ccmL].', NULL, NULL, 'CcmL', 236456),
(292731, 'MF_01374', NULL, 'Hydroxyacylglutathione hydrolase [gloB].', NULL, NULL, 'Glyoxalase_2', 236457),
(292732, 'MF_00146', NULL, 'dCTP deaminase, dUMP-forming [dcd].', NULL, NULL, 'dCTP_deaminase', 236458),
(292733, 'MF_01472', NULL, 'UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase GtfA subunit [gtfA].', NULL, NULL, 'GtfA', 236459),
(292734, 'MF_01925', NULL, 'Pyrroline-5-carboxylate reductase [proC].', NULL, NULL, 'P5C_reductase', 236460),
(292735, 'MF_04027', NULL, 'Ribonucleoside-diphosphate reductase large subunit-like protein [RIR1].', NULL, NULL, 'HSV_RIR1_betahv', 236461),
(292736, 'MF_01594', NULL, 'Rhomboid protease GlpG [glpG].', NULL, NULL, 'Rhomboid_GlpG', 236462),
(292737, 'MF_00070', NULL, '2-keto-3-deoxygluconate permease [kdgT].', NULL, NULL, 'KdgT', 236463),
(292738, 'MF_01445', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase [tsaD].', NULL, NULL, 'TsaD', 236464),
(292739, 'MF_01333_A', NULL, '50S ribosomal protein L5 [rplE].', NULL, NULL, 'Ribosomal_L5_A', 236465),
(292740, 'MF_00291_B', NULL, '30S ribosomal protein S2 [rpsB].', NULL, NULL, 'Ribosomal_S2_B', 236466),
(292741, 'MF_01908', NULL, 'Cyclic 2,3-diphosphoglycerate synthetase [cpgS].', NULL, NULL, 'Cyc_PG_syn', 236467),
(292742, 'MF_01896', NULL, 'DNA gyrase inhibitor [sbmC].', NULL, NULL, 'DNA_gyrase_inhibitor', 236468),
(292743, 'MF_01546', NULL, 'Protein AaeX [aaeX].', NULL, NULL, 'AaeX', 236469),
(292744, 'MF_03043', NULL, 'Queuine tRNA-ribosyltransferase accessory subunit 2 [QTRT2].', NULL, NULL, 'QTRT2', 236470),
(292745, 'MF_01668', NULL, '5-dehydro-2-deoxygluconokinase [iolC].', NULL, NULL, 'IolC', 236471),
(292746, 'MF_01245', NULL, 'UPF0248 protein <locus_tag>.', NULL, NULL, 'UPF0248', 236472),
(292747, 'MF_01609', NULL, 'Glutamate--cysteine ligase [gshA].', NULL, NULL, 'Glu_cys_ligase_2', 236473),
(292748, 'MF_01217', NULL, 'Acyl carrier protein [acpP].', NULL, NULL, 'Acyl_carrier', 236474),
(292749, 'MF_01038', NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase [gpmI].', NULL, NULL, 'GpmI', 236475),
(292750, 'MF_01471', NULL, 'CRISPR-associated endoribonuclease Cas2 [cas2].', NULL, NULL, 'Cas2', 236476),
(292751, 'MF_04063', NULL, 'Polymerase acidic protein [PA].', NULL, NULL, 'INFV_PA', 236477),
(292752, 'MF_00186', NULL, 'Glycerol kinase [glpK].', NULL, NULL, 'Glycerol_kin', 236478),
(292753, 'MF_00119', NULL, 'Translation initiation factor 2 subunit gamma [eif2g].', NULL, NULL, 'eIF_2_gamma', 236479),
(292754, 'MF_00819', NULL, 'Putative septation protein SpoVG [spoVG].', NULL, NULL, 'SpoVG', 236480),
(292755, 'MF_00500', NULL, '30S ribosomal protein S20 [rpsT].', NULL, NULL, 'Ribosomal_S20', 236481),
(292756, 'MF_02046', NULL, 'NAD-dependent glucose-6-phosphate dehydrogenase.', NULL, NULL, 'Glc6PDH_archaea', 236482);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(292757, 'MF_01906', NULL, 'D-(-)-3-hydroxybutyrate oligomer hydrolase.', NULL, NULL, '3HBOH', 236483),
(292758, 'MF_01655', NULL, '2-keto-4-pentenoate hydratase [mhpD].', NULL, NULL, 'MhpD', 236484),
(292759, 'MF_04138', NULL, 'Tape measure protein [H].', NULL, NULL, 'TMP_LAMBDA', 236485),
(292760, 'MF_01051', NULL, 'Carnitinyl-CoA dehydratase [caiD].', NULL, NULL, 'CaiD', 236486),
(292761, 'MF_01021', NULL, 'Phosphoribosyl-AMP cyclohydrolase [hisI].', NULL, NULL, 'HisI', 236487),
(292762, 'MF_00328', NULL, 'Guanylate kinase [gmk].', NULL, NULL, 'Guanylate_kinase', 236488),
(292763, 'MF_00039', NULL, 'Putative adenylate kinase.', NULL, NULL, 'Adenylate_kinase_AK6', 236489),
(292764, 'MF_00392', NULL, 'Lipid-A-disaccharide synthase [lpxB].', NULL, NULL, 'LpxB', 236490),
(292765, 'MF_02128', NULL, 'Thiamine-monophosphate kinase [thiL].', NULL, NULL, 'TMP_kinase', 236491),
(292766, 'MF_01622', NULL, 'tRNA 2-selenouridine synthase [selU].', NULL, NULL, 'tRNA_sel_U_synth', 236492),
(292767, 'MF_01972', NULL, 'Tryptophan 2,3-dioxygenase [kynA].', NULL, NULL, 'T23O', 236493),
(292768, 'MF_02062', NULL, 'Sodium/glutamate symporter [gltS].', NULL, NULL, 'GltS', 236494),
(292769, 'MF_04135', NULL, 'Portal protein B [B].', NULL, NULL, 'PORTAL_LAMBDA', 236495),
(292770, 'MF_01135', NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit delta [cdhD].', NULL, NULL, 'CdhD', 236496),
(292771, 'MF_00914', NULL, 'L-alanine exporter AlaE [alaE].', NULL, NULL, 'L_Ala_exporter', 236497),
(292772, 'MF_00452', NULL, 'Phosphoenolpyruvate carboxykinase [GTP] [pckG].', NULL, NULL, 'PEPCK_GTP', 236498),
(292773, 'MF_00991', NULL, 'Futalosine hydrolase [mqnB].', NULL, NULL, 'MqnB', 236499),
(292774, 'MF_01112', NULL, 'UPF0201 protein <locus_tag>.', NULL, NULL, 'UPF0201', 236500),
(292775, 'MF_01218_B', NULL, 'Uracil phosphoribosyltransferase [upp].', NULL, NULL, 'Upp_B', 236501),
(292776, 'MF_00365', NULL, 'DNA replication and repair protein RecF [recF].', NULL, NULL, 'RecF', 236502),
(292777, 'MF_00449', NULL, 'DNA double-strand break repair Rad50 ATPase [rad50].', NULL, NULL, 'RAD50', 236503),
(292778, 'MF_02086', NULL, '4-hydroxythreonine-4-phosphate dehydrogenase [pdxA].', NULL, NULL, 'PdxA_Epsilonprot', 236504),
(292779, 'MF_01497', NULL, 'Stress response kinase A [srkA].', NULL, NULL, 'SrkA_kinase', 236505),
(292780, 'MF_03111', NULL, 'Ubiquinone biosynthesis protein <gene_name>, mitochondrial [COQ4].', NULL, NULL, 'Coq4', 236506),
(292781, 'MF_04033', NULL, 'Envelope glycoprotein H [gH].', NULL, NULL, 'HSV_GH', 236507),
(292782, 'MF_00401', NULL, 'Peroxiredoxin.', NULL, NULL, 'Peroxiredoxin', 236508),
(292783, 'MF_01251', NULL, 'UPF0313 protein YgiQ [ygiQ].', NULL, NULL, 'UPF0313', 236509),
(292784, 'MF_02115', NULL, 'FAD synthase [ribL].', NULL, NULL, 'FAD_synth_arch', 236510),
(292785, 'MF_00033', NULL, 'UDP-N-acetylglucosamine--N-acetylmuramyl-(pentapeptide) pyrophosphoryl-undecaprenol N-acetylglucosamine transferase [murG].', NULL, NULL, 'MurG', 236511),
(292786, 'MF_01343_B', NULL, '30S ribosomal protein S15 [rpsO].', NULL, NULL, 'Ribosomal_S15_B', 236512),
(292787, 'MF_01617', NULL, 'Fatty acid oxidation complex subunit alpha [fadJ].', NULL, NULL, 'FadJ', 236513),
(292788, 'MF_03026', NULL, 'Leucine zipper putative tumor suppressor 2 [LZTS2].', NULL, NULL, 'LZTS2', 236514),
(292789, 'MF_00785', NULL, 'Sirohydrochlorin cobaltochelatase [cbiX].', NULL, NULL, 'CbiX', 236515),
(292790, 'MF_02133', NULL, 'Prokaryotic ubiquitin-like protein UBact [ubact].', NULL, NULL, 'UBact', 236516),
(292791, 'MF_00074', NULL, 'Ribosomal RNA small subunit methyltransferase G [rsmG].', NULL, NULL, '16SrRNA_methyltr_G', 236517),
(292792, 'MF_00437', NULL, 'Photosystem I assembly protein Ycf4 [ycf4].', NULL, NULL, 'Ycf4', 236518),
(292793, 'MF_01488', NULL, 'ATP-dependent RecD-like DNA helicase [recD2].', NULL, NULL, 'RecD_like', 236519),
(292794, 'MF_01531', NULL, 'Vitamin B12 transporter BtuB [btuB].', NULL, NULL, 'BtuB', 236520),
(292795, 'MF_00055', NULL, 'MEMO1 family protein <locus_tag>.', NULL, NULL, 'MEMO1', 236521);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(292796, 'MF_01212', NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase-like protein.', NULL, NULL, 'dGTPase_type2', 236522),
(292797, 'MF_01378', NULL, 'Cytochrome c-550 [psbV].', NULL, NULL, 'PSII_Cyt550', 236523),
(292798, 'MF_00169', NULL, '3-dehydroquinate dehydratase [aroQ].', NULL, NULL, 'AroQ', 236524),
(292799, 'MF_00194', NULL, 'Recombination-associated protein RdgC [rdgC].', NULL, NULL, 'RdgC', 236525),
(292800, 'MF_03226', NULL, 'Splicing factor YJU2 [YJU2].', NULL, NULL, 'YJU2', 236526),
(292801, 'MF_00493', NULL, 'Transaldolase [tal].', NULL, NULL, 'Transaldolase_2', 236527),
(292802, 'MF_00206', NULL, 'Lipoyl synthase [lipA].', NULL, NULL, 'Lipoyl_synth', 236528),
(292803, 'MF_00765', NULL, 'UPF0307 protein YjgA [yjgA].', NULL, NULL, 'UPF0307', 236529),
(292804, 'MF_01917', NULL, 'Cardiolipin synthase B [clsB].', NULL, NULL, 'Cardiolipin_synth_ClsB', 236530),
(292805, 'MF_01834', NULL, 'tRNA-splicing endonuclease [endA].', NULL, NULL, 'EndA_long', 236531),
(292806, 'MF_00954', NULL, 'Regulator of nucleoside diphosphate kinase [rnk].', NULL, NULL, 'Rnk', 236532),
(292807, 'MF_00459', NULL, 'Ion-translocating oxidoreductase complex subunit A [rsxA].', NULL, NULL, 'RsxA_RnfA', 236533),
(292808, 'MF_00504', NULL, 'Peptidase B [pepB].', NULL, NULL, 'Aminopeptidase_M17', 236534),
(292809, 'MF_01300', NULL, 'C4-dicarboxylate transport protein [dctA].', NULL, NULL, 'C4_dicarb_transport', 236535),
(292810, 'MF_00180', NULL, '3,4-dihydroxy-2-butanone 4-phosphate synthase [ribB].', NULL, NULL, 'RibB', 236536),
(292811, 'MF_03010', NULL, 'Eukaryotic translation initiation factor 3 subunit K [EIF3K].', NULL, NULL, 'eIF3k', 236537),
(292812, 'MF_03224', NULL, 'Cyanide hydratase.', NULL, NULL, 'CN_hydrolase', 236538),
(292813, 'MF_00145', NULL, 'Phosphoglycerate kinase [pgk].', NULL, NULL, 'Phosphoglyc_kinase', 236539),
(292814, 'MF_00297', NULL, 'NAD-capped RNA hydrolase NudC [nudC].', NULL, NULL, 'Nudix_NudC', 236540),
(292815, 'MF_00922', NULL, 'Outer membrane protein assembly factor BamD [bamD].', NULL, NULL, 'OM_assembly_BamD', 236541),
(292816, 'MF_04036', NULL, 'Envelope glycoprotein L [gL].', NULL, NULL, 'HSV_GL_betahv', 236542),
(292817, 'MF_01434', NULL, 'Monofunctional glycosyltransferase [mgt].', NULL, NULL, 'MGT', 236543),
(292818, 'MF_00108', NULL, '2-C-methyl-D-erythritol 4-phosphate cytidylyltransferase [ispD].', NULL, NULL, 'IspD', 236544),
(292819, 'MF_01957', NULL, 'Serine/threonine-protein kinase PknD [pknD].', NULL, NULL, 'PknD_kinase', 236545),
(292820, 'MF_01984', NULL, 'Flavin prenyltransferase UbiX [ubiX].', NULL, NULL, 'ubiX_pad', 236546),
(292821, 'MF_00925', NULL, 'Outer membrane protein assembly factor BamE [bamE].', NULL, NULL, 'OM_assembly_BamE', 236547),
(292822, 'MF_02249', NULL, '3-oxopimeloyl-[acyl-carrier-protein] synthase [bioZ].', NULL, NULL, 'BioZ', 236548),
(292823, 'MF_01382', NULL, 'Protein translocase subunit SecA [secA].', NULL, NULL, 'SecA', 236549),
(292824, 'MF_00232', NULL, 'Translation initiation factor 2 subunit beta [eif2b].', NULL, NULL, 'eIF_2_beta', 236550),
(292825, 'MF_00136', NULL, 'S-adenosylmethionine synthase [mat].', NULL, NULL, 'S_AdoMet_synth2', 236551),
(292826, 'MF_00016', NULL, 'Holliday junction ATP-dependent DNA helicase RuvB [ruvB].', NULL, NULL, 'DNA_helic_RuvB', 236552),
(292827, 'MF_02230', NULL, 'Ribose 1,5-bisphosphate isomerase.', NULL, NULL, 'R15P_isomerase', 236553),
(292828, 'MF_00519', NULL, 'L-arabinose isomerase [araA].', NULL, NULL, 'Arabinose_Isome', 236554),
(292829, 'MF_01287', NULL, 'Digeranylgeranylglycerophospholipid reductase.', NULL, NULL, 'DGGGPL_reductase', 236555),
(292830, 'MF_00435', NULL, 'Ketol-acid reductoisomerase (NADP(+)) [ilvC].', NULL, NULL, 'IlvC', 236556),
(292831, 'MF_00468', NULL, 'Sulfate transporter CysZ [cysZ].', NULL, NULL, 'CysZ', 236557),
(292832, 'MF_01155', NULL, 'Chaperone modulatory protein CbpM [cbpM].', NULL, NULL, 'CbpM', 236558),
(292833, 'MF_01907', NULL, 'thr operon leader peptide [thrL].', NULL, NULL, 'Leader_Thr', 236559),
(292834, 'MF_04148', NULL, 'Terminase, large subunit.', NULL, NULL, 'TERL_BPP22', 236560);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(292835, 'MF_00022', NULL, 'Glutamate--tRNA ligase [gltX].', NULL, NULL, 'Glu_tRNA_synth_type1', 236561),
(292836, 'MF_00529', NULL, 'Nitrogenase-stabilizing/protective protein NifW [nifW].', NULL, NULL, 'NifW', 236562),
(292837, 'MF_02132', NULL, 'AMP phosphorylase.', NULL, NULL, 'AMP_phosphorylase', 236563),
(292838, 'MF_00831', NULL, 'Putative aminoacrylate peracid reductase RutC [rutC].', NULL, NULL, 'RutC', 236564),
(292839, 'MF_00781', NULL, 'DNA-binding transcriptional activator HetR [hetR].', NULL, NULL, 'HetR', 236565),
(292840, 'MF_00124', NULL, 'Thymidine kinase [tdk].', NULL, NULL, 'Thymidine_kinase', 236566),
(292841, 'MF_01221', NULL, 'UPF0210 protein <locus_tag>.', NULL, NULL, 'UPF0210', 236567),
(292842, 'MF_01852', NULL, 'Threonylcarbamoyl-AMP synthase [tsaC].', NULL, NULL, 'TsaC', 236568),
(292843, 'MF_01902', NULL, 'Error-prone DNA polymerase [dnaE2].', NULL, NULL, 'DNApol_error_prone', 236569),
(292844, 'MF_01626', NULL, 'Protein ViaA [viaA].', NULL, NULL, 'ViaA', 236570),
(292845, 'MF_01147', NULL, 'Phosphatidylglycerol--prolipoprotein diacylglyceryl transferase [lgt].', NULL, NULL, 'Lgt', 236571),
(292846, 'MF_01474', NULL, '30S ribosomal protein S19e [rps19e].', NULL, NULL, 'Ribosomal_S19e', 236572),
(292847, 'MF_01326_B', NULL, '50S ribosomal protein L24 [rplX].', NULL, NULL, 'Ribosomal_L24_B', 236573),
(292848, 'MF_00715', NULL, 'Protein SlyX [slyX].', NULL, NULL, 'SlyX', 236574),
(292849, 'MF_01189', NULL, 'Purine ribonucleoside efflux pump NepI [nepI].', NULL, NULL, 'MFS_NepI', 236575),
(292850, 'MF_00266', NULL, 'tRNA(Phe) 7-((3-amino-3-carboxypropyl)-4-demethylwyosine(37)-N(4))-methyltransferase [taw3].', NULL, NULL, 'TYW3_archaea', 236576),
(292851, 'MF_04205', NULL, 'Envelope small membrane protein [E].', NULL, NULL, 'ALPHA_CORONA_E', 236577),
(292852, 'MF_01574', NULL, '6-phospho-beta-galactosidase [lacG].', NULL, NULL, 'LacG', 236578),
(292853, 'MF_01592', NULL, 'Uncharacterized Nudix hydrolase NudL [nudL].', NULL, NULL, 'Nudix_NudL', 236579),
(292854, 'MF_01289', NULL, 'D-galactonate dehydratase [dgoD].', NULL, NULL, 'Galacton_dehydrat', 236580),
(292855, 'MF_04144', NULL, 'Terminase, large subunit.', NULL, NULL, 'TERL_LAMBDA', 236581),
(292856, 'MF_01853', NULL, 'Protein pelota homolog [pelA].', NULL, NULL, 'PelO', 236582),
(292857, 'MF_00595', NULL, 'Phosphoenolpyruvate carboxylase [ppc].', NULL, NULL, 'PEPcase_type1', 236583),
(292858, 'MF_00725', NULL, 'Flagellar transcriptional regulator FlhD [flhD].', NULL, NULL, 'FlhD', 236584),
(292859, 'MF_00782', NULL, 'Glutathione biosynthesis bifunctional protein GshAB [gshAB].', NULL, NULL, 'Glut_biosynth', 236585),
(292860, 'MF_01232', NULL, 'UPF0229 protein YeaH [yeaH].', NULL, NULL, 'UPF0229', 236586),
(292861, 'MF_00410', NULL, '50S ribosomal protein L31e [rpl31e].', NULL, NULL, 'Ribosomal_L31e', 236587),
(292862, 'MF_00820', NULL, '2,3-diketo-L-gulonate reductase [dlgD].', NULL, NULL, 'Diketo_gul_reduc', 236588),
(292863, 'MF_00040', NULL, 'Ribosome-recycling factor [frr].', NULL, NULL, 'RRF', 236589),
(292864, 'MF_03212', NULL, 'NADPH--cytochrome P450 reductase [POR].', NULL, NULL, 'NCPR', 236590),
(292865, 'MF_01553', NULL, 'DNA-directed RNA polymerase subunit epsilon [rpoY].', NULL, NULL, 'RNApol_bact_RpoY', 236591),
(292866, 'MF_01877', NULL, 'Ribosomal RNA small subunit methyltransferase I [rsmI].', NULL, NULL, '16SrRNA_methyltr_I', 236592),
(292867, 'MF_00712', NULL, 'Probable glycine dehydrogenase (decarboxylating) subunit 1 [gcvPA].', NULL, NULL, 'GcvPA', 236593),
(292868, 'MF_01820', NULL, 'Small ribosomal subunit biogenesis GTPase RsgA [rsgA].', NULL, NULL, 'GTPase_RsgA', 236594),
(292869, 'MF_01345_B', NULL, '30S ribosomal protein S17 [rpsQ].', NULL, NULL, 'Ribosomal_S17_B', 236595),
(292870, 'MF_00384', NULL, 'Homoserine kinase [thrB].', NULL, NULL, 'Homoser_kinase', 236596),
(292871, 'MF_02117', NULL, 'N(2)-fixation sustaining protein CowN [cowN].', NULL, NULL, 'CowN', 236597),
(292872, 'MF_04050', NULL, 'Hexon-interlacing protein [IX].', NULL, NULL, 'ADV_CAP9', 236598),
(292873, 'MF_02024', NULL, 'Lipid III flippase [wzxE].', NULL, NULL, 'WzxE', 236599);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(292874, 'MF_02077', NULL, 'Lipid II flippase Amj [amj].', NULL, NULL, 'Amj_flippase', 236600),
(292875, 'MF_02007', NULL, 'Tyrosine--tRNA ligase [tyrS].', NULL, NULL, 'Tyr_tRNA_synth_type2', 236601),
(292876, 'MF_01171', NULL, 'Arginine N-succinyltransferase [astA].', NULL, NULL, 'AstA', 236602),
(292877, 'MF_01935', NULL, 'Isochorismate synthase MenF [menF].', NULL, NULL, 'MenF', 236603),
(292878, 'MF_04043', NULL, 'Inner tegument protein.', NULL, NULL, 'HSV_ITP', 236604),
(292879, 'MF_02112', NULL, 'Proteasome-associated ATPase [mpa].', NULL, NULL, 'ARC_ATPase', 236605),
(292880, 'MF_00200', NULL, 'RNA 3''-terminal phosphate cyclase [rtcA].', NULL, NULL, 'RTC', 236606),
(292881, 'MF_01506', NULL, 'Small, acid-soluble spore protein Tlp [tlp].', NULL, NULL, 'Tlp', 236607),
(292882, 'MF_00958', NULL, 'Regulator of RpoS [rssB].', NULL, NULL, 'RssB', 236608),
(292883, 'MF_00019', NULL, 'Phosphate acyltransferase [plsX].', NULL, NULL, 'PlsX', 236609),
(292884, 'MF_00213', NULL, 'Hydrogenase maturation factor HypA [hypA].', NULL, NULL, 'HypA_HybF', 236610),
(292885, 'MF_01385', NULL, 'Urease accessory protein UreF [ureF].', NULL, NULL, 'UreF', 236611),
(292886, 'MF_04030', NULL, 'DNA replication helicase [HELI].', NULL, NULL, 'HSV_HELI', 236612),
(292887, 'MF_01854', NULL, 'Fructose-1,6-bisphosphatase class 3 [fbp].', NULL, NULL, 'FBPase_class3', 236613),
(292888, 'MF_00614', NULL, 'Flap endonuclease 1 [fen].', NULL, NULL, 'Fen', 236614),
(292889, 'MF_00400', NULL, 'Multidrug resistance protein MdtK [mdtK].', NULL, NULL, 'MdtK', 236615),
(292890, 'MF_01953', NULL, 'Urease subunit alpha [ureC].', NULL, NULL, 'Urease_alpha', 236616),
(292891, 'MF_00570', NULL, 'Nicotinate phosphoribosyltransferase [pncB].', NULL, NULL, 'NAPRTase', 236617),
(292892, 'MF_04089', NULL, 'Non-structural protein 2.', NULL, NULL, 'ROTA_NSP2', 236618),
(292893, 'MF_00300', NULL, 'Chorismate synthase [aroC].', NULL, NULL, 'Chorismate_synth', 236619),
(292894, 'MF_01915', NULL, 'Lipopolysaccharide export system protein LptC [lptC].', NULL, NULL, 'LPS_assembly_LptC', 236620),
(292895, 'MF_00325', NULL, 'DNA polymerase II small subunit [polB].', NULL, NULL, 'DNApol_II_A_arch', 236621),
(292896, 'MF_01250', NULL, 'Pyrophosphatase PpaX [ppaX].', NULL, NULL, 'Pyrophosphat_PpaX', 236622),
(292897, 'MF_02082', NULL, '[LysW]-aminoadipate/[LysW]-glutamate kinase [lysZ].', NULL, NULL, 'LysZ', 236623),
(292898, 'MF_01350', NULL, 'NAD(P)H-quinone oxidoreductase subunit 1, chloroplastic [ndhA].', NULL, NULL, 'NDH1_NuoH', 236624),
(292899, 'MF_01369_B', NULL, '50S ribosomal protein L23 [rplW].', NULL, NULL, 'Ribosomal_L23_B', 236625),
(292900, 'MF_00052_A', NULL, 'Ribonuclease HII [rnhB].', NULL, NULL, 'RNase_HII_A', 236626),
(292901, 'MF_02106', NULL, 'Prokaryotic ubiquitin-like protein Pup [pup].', NULL, NULL, 'Pup', 236627),
(292902, 'MF_02047', NULL, '6-phosphogluconate dehydrogenase, NAD(+)-dependent, decarboxylating.', NULL, NULL, '6PGDH_archaea', 236628),
(292903, 'MF_00857', NULL, 'Cell division protein DrpB [drpB].', NULL, NULL, 'DrpB', 236629),
(292904, 'MF_00784', NULL, 'Accessory gene regulator protein B [agrB].', NULL, NULL, 'AgrB', 236630),
(292905, 'MF_01964', NULL, 'Inosine-5''-monophosphate dehydrogenase [guaB].', NULL, NULL, 'IMPDH', 236631),
(292906, 'MF_00422', NULL, 'Protein translocase subunit SecE [secE].', NULL, NULL, 'SecE', 236632),
(292907, 'MF_00992', NULL, 'Cyclic dehypoxanthine futalosine synthase [mqnC].', NULL, NULL, 'MqnC', 236633),
(292908, 'MF_01225_B', NULL, 'GTP 3'',8-cyclase [moaA].', NULL, NULL, 'MoaA_B', 236634),
(292909, 'MF_01297', NULL, 'Peroxynitrite isomerase.', NULL, NULL, 'nitrobindin', 236635),
(292910, 'MF_02085', NULL, 'UTP--glucose-1-phosphate uridylyltransferase [cugP].', NULL, NULL, 'CugP_cyano', 236636),
(292911, 'MF_04155', NULL, 'DnaB-like replicative helicase [41].', NULL, NULL, 'Helic_T4', 236637),
(292912, 'MF_01218_A', NULL, 'Uracil phosphoribosyltransferase [upp].', NULL, NULL, 'Upp_A', 236638),
(292913, 'MF_00665', NULL, 'Small, acid-soluble spore protein O [sspO].', NULL, NULL, 'SspO', 236639);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(292914, 'MF_01249', NULL, 'HPr kinase/phosphorylase [hprK].', NULL, NULL, 'HPr_kinase', 236640),
(292915, 'MF_01850', NULL, 'tRNA-cytidine(32) 2-sulfurtransferase [ttcA].', NULL, NULL, 'TtcA', 236641),
(292916, 'MF_02015', NULL, 'Nucleoid occlusion protein [noc].', NULL, NULL, 'ParB_Noc', 236642),
(292917, 'MF_02092', NULL, 'Quinone-dependent D-lactate dehydrogenase [dld].', NULL, NULL, 'DLDH_Dld', 236643),
(292918, 'MF_01883', NULL, '2-(5''''-triphosphoribosyl)-3''-dephosphocoenzyme-A synthase [mdcB].', NULL, NULL, 'MdcB', 236644),
(292919, 'MF_01842', NULL, 'Archaemetzincin [amzA].', NULL, NULL, 'Archaemetzincin', 236645),
(292920, 'MF_04079', NULL, 'Protein Tat [tat].', NULL, NULL, 'HIV_TAT', 236646),
(292921, 'MF_00086', NULL, 'S-adenosylmethionine synthase [metK].', NULL, NULL, 'S_AdoMet_synth1', 236647),
(292922, 'MF_00621', NULL, 'GTP-sensing transcriptional pleiotropic repressor CodY [codY].', NULL, NULL, 'HTH_type_CodY', 236648),
(292923, 'MF_01356', NULL, 'NAD(P)H-quinone oxidoreductase subunit K, chloroplastic [ndhK].', NULL, NULL, 'NDH1_NuoB', 236649),
(292924, 'MF_01979', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase [pfp].', NULL, NULL, 'Phosphofructokinase_II_Short', 236650),
(292925, 'MF_01976', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase [pfp].', NULL, NULL, 'Phosphofructokinase_III', 236651),
(292926, 'MF_01129', NULL, 'Putative K(+)-stimulated pyrophosphate-energized sodium pump [hppA].', NULL, NULL, 'PPase_energized_pump', 236652),
(292927, 'MF_04022', NULL, 'Small capsomere-interacting protein [SCP].', NULL, NULL, 'HSV_SCP_gammahv', 236653),
(292928, 'MF_03117', NULL, 'Enolase-phosphatase E1 [ENOPH1].', NULL, NULL, 'Salvage_MtnC_euk', 236654),
(292929, 'MF_01433', NULL, 'Pyrimidine-specific ribonucleoside hydrolase RihB [rihB].', NULL, NULL, 'Pyrim_hydro_RihB', 236655),
(292930, 'MF_01904', NULL, 'Phosphoenolpyruvate carboxylase [ppcA].', NULL, NULL, 'PEPcase_type2', 236656),
(292931, 'MF_00251', NULL, '50S ribosomal protein L36 [rpmJ].', NULL, NULL, 'Ribosomal_L36', 236657),
(292932, 'MF_02208', NULL, 'UDP-N-acetylmuramoyl-L-alanine--L-glutamate ligase [murD2].', NULL, NULL, 'MurD2_subfam', 236658),
(292933, 'MF_04082', NULL, 'Protein Vpu [vpu].', NULL, NULL, 'HIV_VPU', 236659),
(292934, 'MF_01641', NULL, 'UPF0509 protein YciZ [yciZ].', NULL, NULL, 'UPF0509', 236660),
(292935, 'MF_01209', NULL, 'Carbamoyl-phosphate synthase small chain [carA].', NULL, NULL, 'CPSase_S_chain', 236661),
(292936, 'MF_01312', NULL, 'Anaerobic nitric oxide reductase flavorubredoxin [norV].', NULL, NULL, 'NorV', 236662),
(292937, 'MF_00245', NULL, 'UPF0122 protein <locus_tag>.', NULL, NULL, 'UPF0122', 236663),
(292938, 'MF_03039', NULL, 'Cytosolic Fe-S cluster assembly factor NUBP2 [NUBP2].', NULL, NULL, 'NUBP2', 236664),
(292939, 'MF_00356', NULL, 'DNA polymerase III PolC-type [polC].', NULL, NULL, 'DNApol_PolC', 236665),
(292940, 'MF_00584', NULL, 'Putative HTH-type transcriptional regulatory protein <locus_tag>.', NULL, NULL, 'HTH_type_cro_C1', 236666),
(292941, 'MF_01213', NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase-like protein.', NULL, NULL, 'dGTPase_type3', 236667),
(292942, 'MF_00010', NULL, 'UPF0060 membrane protein YnfA [ynfA].', NULL, NULL, 'UPF0060', 236668),
(292943, 'MF_00471', NULL, 'Regulator of ribonuclease activity A [rraA].', NULL, NULL, 'RraA', 236669),
(292944, 'MF_01466', NULL, 'Accessory Sec system protein translocase subunit SecY2 [secY2].', NULL, NULL, 'SecY2', 236670),
(292945, 'MF_01845', NULL, 'UPF0597 protein YhaM [yhaM].', NULL, NULL, 'UPF0597', 236671),
(292946, 'MF_00918', NULL, 'Probable transcriptional regulatory protein YeeN [yeeN].', NULL, NULL, 'Transcrip_reg_TACO1_YeeN', 236672),
(292947, 'MF_00660', NULL, 'PqqA peptide cyclase [pqqE].', NULL, NULL, 'PqqE', 236673),
(292948, 'MF_00403_A', NULL, '30S ribosomal protein S12 [rpsL].', NULL, NULL, 'Ribosomal_S12_A', 236674),
(292949, 'MF_01674', NULL, 'O-phosphoserine--tRNA(Cys) ligase [sepS].', NULL, NULL, 'Sep_tRNA_synth', 236675),
(292950, 'MF_01153', NULL, 'Co-chaperone protein DjlA [djlA].', NULL, NULL, 'DjlA', 236676);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(292951, 'MF_00926', NULL, 'RNA polymerase-binding transcription factor DksA [dksA].', NULL, NULL, 'DksA', 236677),
(292952, 'MF_01363', NULL, '50S ribosomal protein L21 [rplU].', NULL, NULL, 'Ribosomal_L21', 236678),
(292953, 'MF_00424', NULL, 'Peptide chain release factor subunit 1 [prf1].', NULL, NULL, 'Rel_fact_arch_1', 236679),
(292954, 'MF_01528', NULL, 'Multidrug resistance protein MdtG [mdtG].', NULL, NULL, 'MFS_MdtG', 236680),
(292955, 'MF_00352', NULL, 'Light-independent protochlorophyllide reductase subunit N [bchN].', NULL, NULL, 'ChlN_BchN', 236681),
(292956, 'MF_01084', NULL, 'Diphthine synthase [dphB].', NULL, NULL, 'Diphthine_synth', 236682),
(292957, 'MF_00375', NULL, 'Glutamate-1-semialdehyde 2,1-aminomutase [hemL].', NULL, NULL, 'HemL_aminotrans_3', 236683),
(292958, 'MF_01451', NULL, 'ATP-dependent helicase/nuclease subunit A [addA].', NULL, NULL, 'AddA', 236684),
(292959, 'MF_00999', NULL, 'Sulfofructose kinase.', NULL, NULL, 'SF_kinase', 236685),
(292960, 'MF_00442', NULL, 'ATP-dependent DNA helicase Hel308 [hel308].', NULL, NULL, 'Helicase_Hel308', 236686),
(292961, 'MF_00724', NULL, 'Flagellar hook-basal body complex protein FliE [fliE].', NULL, NULL, 'FliE', 236687),
(292962, 'MF_01695', NULL, 'D-inositol-3-phosphate glycosyltransferase [mshA].', NULL, NULL, 'MshA', 236688),
(292963, 'MF_01589', NULL, 'Carboxy-S-adenosyl-L-methionine synthase [cmoA].', NULL, NULL, 'Cx_SAM_synthase', 236689),
(292964, 'MF_00687', NULL, '4-deoxy-L-threo-5-hexosulose-uronate ketol-isomerase [kduI].', NULL, NULL, 'KduI', 236690),
(292965, 'MF_02021', NULL, 'Cell division protein DamX [damX].', NULL, NULL, 'DamX', 236691),
(292966, 'MF_01635', NULL, '4-hydroxybenzoate octaprenyltransferase [ubiA].', NULL, NULL, 'UbiA', 236692),
(292967, 'MF_00851', NULL, 'Leader peptide SpeFL [speFL].', NULL, NULL, 'Leader_SpeFL', 236693),
(292968, 'MF_00548', NULL, 'Zinc transporter ZupT [zupT].', NULL, NULL, 'ZupT', 236694),
(292969, 'MF_02105', NULL, 'Lactate utilization protein A [lutA].', NULL, NULL, 'LutA', 236695),
(292970, 'MF_01513', NULL, 'Putative phenylalanine aminotransferase [pat].', NULL, NULL, 'Phe_aminotrans_2', 236696),
(292971, 'MF_01937', NULL, '1,4-dihydroxy-2-naphthoate octaprenyltransferase [menA].', NULL, NULL, 'MenA_1', 236697),
(292972, 'MF_00933', NULL, 'Arylsulfate sulfotransferase AssT [assT].', NULL, NULL, 'Arylsulfotrans_AssT', 236698),
(292973, 'MF_00846', NULL, 'Ribosome protection protein VmlR [vmlR].', NULL, NULL, 'VmlR', 236699),
(292974, 'MF_02201', NULL, 'Ferredoxin-type protein NapF [napF].', NULL, NULL, 'NapF', 236700),
(292975, 'MF_00901', NULL, '3''-5'' ssDNA/RNA exonuclease TatD [tatD].', NULL, NULL, 'TatD_exonuclease', 236701),
(292976, 'MF_01390', NULL, 'Maturase K [matK].', NULL, NULL, 'MatK', 236702),
(292977, 'MF_00598', NULL, 'Protein Smg [smg].', NULL, NULL, 'Smg', 236703),
(292978, 'MF_01831', NULL, 'Cysteine desulfurase [sufS].', NULL, NULL, 'SufS_aminotrans_5', 236704),
(292979, 'MF_01415', NULL, 'Glutathione-regulated potassium-efflux system ancillary protein KefG [kefG].', NULL, NULL, 'K_H_efflux_KefG', 236705),
(292980, 'MF_01207', NULL, 'Protein-methionine-sulfoxide reductase heme-binding subunit MsrQ [msrQ].', NULL, NULL, 'MsrQ', 236706),
(292981, 'MF_01949', NULL, 'O-acetyltransferase WecH [wecH].', NULL, NULL, 'Acetyltr_WecH', 236707),
(292982, 'MF_00682', NULL, 'Co-chaperone protein HscB [hscB].', NULL, NULL, 'HscB', 236708),
(292983, 'MF_01678', NULL, 'Putative methylthioribose-1-phosphate isomerase [mtnA].', NULL, NULL, 'Salvage_MtnA', 236709),
(292984, 'MF_00568', NULL, 'Quinolinate synthase A [nadA].', NULL, NULL, 'NadA_type2', 236710),
(292985, 'MF_00032', NULL, 'Translation initiation factor 6 [eif6].', NULL, NULL, 'eIF_6', 236711),
(292986, 'MF_01886', NULL, 'tRNA(Met) cytidine acetyltransferase TmcA [tmcA].', NULL, NULL, 'tRNA_acetyltr_TmcA', 236712),
(292987, 'MF_00080', NULL, 'Translation initiation factor IF-3 [infC].', NULL, NULL, 'IF_3', 236713),
(292988, 'MF_01278', NULL, 'Type-2 serine--tRNA ligase [serS].', NULL, NULL, 'Ser_tRNA_synth_type2', 236714);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(292989, 'MF_01484', NULL, 'Multidrug efflux pump accessory protein AcrZ [acrZ].', NULL, NULL, 'AcrZ', 236715),
(292990, 'MF_01945', NULL, 'Lipid A 1-diphosphate synthase [lpxT].', NULL, NULL, 'Lipid_A_LpxT', 236716),
(292991, 'MF_01266', NULL, 'Probable L-ascorbate-6-phosphate lactonase UlaG [ulaG].', NULL, NULL, 'UlaG', 236717),
(292992, 'MF_01498', NULL, 'DNA repair protein RadA [radA].', NULL, NULL, 'RadA_bact', 236718),
(292993, 'MF_01373', NULL, 'Lipoprotein LpqB [lpqB].', NULL, NULL, 'LpqB_lipoprot', 236719),
(292994, 'MF_01220_A', NULL, 'Uridylate kinase [pyrH].', NULL, NULL, 'PyrH_A', 236720),
(292995, 'MF_00630', NULL, 'UPF0232 protein <locus_tag>.', NULL, NULL, 'UPF0232', 236721),
(292996, 'MF_00260', NULL, 'Porphobilinogen deaminase [hemC].', NULL, NULL, 'Porphobil_deam', 236722),
(292997, 'MF_00275', NULL, 'Potassium-transporting ATPase potassium-binding subunit [kdpA].', NULL, NULL, 'KdpA', 236723),
(292998, 'MF_02222', NULL, 'Homocitrate synthase.', NULL, NULL, 'Homocitr_synth_fung_arch', 236724),
(292999, 'MF_00125', NULL, 'ATP phosphoribosyltransferase regulatory subunit [hisZ].', NULL, NULL, 'HisZ', 236725),
(293000, 'MF_01944', NULL, 'Lipid A biosynthesis myristoyltransferase [lpxM].', NULL, NULL, 'Lipid_A_LpxM', 236726),
(293001, 'MF_03114', NULL, 'Golgi to ER traffic protein 2 [GET2].', NULL, NULL, 'Get2', 236727),
(293002, 'MF_00604', NULL, 'Protein translation factor SUI1 homolog.', NULL, NULL, 'SUI1', 236728),
(293003, 'MF_01264', NULL, 'CCA-adding enzyme [cca].', NULL, NULL, 'CCA_arch', 236729),
(293004, 'MF_01637', NULL, 'Fe/S biogenesis protein NfuA [nfuA].', NULL, NULL, 'Fe_S_biogen_NfuA', 236730),
(293005, 'MF_02214', NULL, 'Lipid II isoglutaminyl synthase (glutamine-hydrolyzing) subunit MurT [murT].', NULL, NULL, 'Lipid_II_synth_MurT', 236731),
(293006, 'MF_00011', NULL, 'Adenylosuccinate synthetase [purA].', NULL, NULL, 'Adenylosucc_synth', 236732),
(293007, 'MF_04055', NULL, 'DNA polymerase [POL].', NULL, NULL, 'ADV_DPOL', 236733),
(293008, 'MF_00651', NULL, 'Putative pre-16S rRNA nuclease [yqgF].', NULL, NULL, 'Nuclease_YqgF', 236734),
(293009, 'MF_00679', NULL, 'Chaperone protein HscA [hscA].', NULL, NULL, 'HscA', 236735),
(293010, 'MF_01616', NULL, 'Membrane-bound lytic murein transglycosylase C [mltC].', NULL, NULL, 'MltC', 236736),
(293011, 'MF_01989', NULL, 'Cyanuric acid amidohydrolase.', NULL, NULL, 'Cyc_amidohydrol', 236737),
(293012, 'MF_01302_B', NULL, '30S ribosomal protein S8 [rpsH].', NULL, NULL, 'Ribosomal_S8_B', 236738),
(293013, 'MF_00202', NULL, 'Isopentenyl-diphosphate Delta-isomerase [idi].', NULL, NULL, 'Idi', 236739),
(293014, 'MF_03201', NULL, 'Elongation of very long chain fatty acids protein 1 [ELOVL1].', NULL, NULL, 'VLCF_elongase_1', 236740),
(293015, 'MF_00942', NULL, 'Endonuclease III [nth].', NULL, NULL, 'Nth', 236741),
(293016, 'MF_01320_B', NULL, '50S ribosomal protein L2 [rplB].', NULL, NULL, 'Ribosomal_L2_B', 236742),
(293017, 'MF_01578', NULL, 'Quinate/shikimate dehydrogenase [ydiB].', NULL, NULL, 'Shikimate_DH_YdiB', 236743),
(293018, 'MF_01610', NULL, 'Probable L-tyrosine/L-aspartate decarboxylase [mfnA].', NULL, NULL, 'MfnA_decarbox', 236744),
(293019, 'MF_00908', NULL, 'Negative modulator of initiation of replication [seqA].', NULL, NULL, 'SeqA', 236745),
(293020, 'MF_00152', NULL, 'Probable endonuclease 4 [nfo].', NULL, NULL, 'Nfo', 236746),
(293021, 'MF_02226', NULL, 'D-allulose-6-phosphate 3-epimerase [alsE].', NULL, NULL, 'AlluloseP_3_epimer', 236747),
(293022, 'MF_01280', NULL, 'Processive diacylglycerol beta-glucosyltransferase [ugtP].', NULL, NULL, 'Diacylglyc_glucosyltr', 236748),
(293023, 'MF_00514', NULL, '50S ribosomal protein L35 [rpmI].', NULL, NULL, 'Ribosomal_L35', 236749),
(293024, 'MF_04002', NULL, 'Major capsid protein L1 [L1].', NULL, NULL, 'PPV_L1', 236750),
(293025, 'MF_04000', NULL, 'Replication protein E1 [E1].', NULL, NULL, 'PPV_E1', 236751),
(293026, 'MF_01045', NULL, 'D-cysteine desulfhydrase [dcyD].', NULL, NULL, 'D_Cys_desulfhydr', 236752),
(293027, 'MF_00909', NULL, 'Cell division protein FtsZ [ftsZ].', NULL, NULL, 'FtsZ', 236753);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(293028, 'MF_01545', NULL, 'p-hydroxybenzoic acid efflux pump subunit AaeB [aaeB].', NULL, NULL, 'AaeB', 236754),
(293029, 'MF_00545', NULL, '30S ribosomal protein S24e [rps24e].', NULL, NULL, 'Ribosomal_S24e', 236755),
(293030, 'MF_00956', NULL, 'GDP-L-fucose synthase [fcl].', NULL, NULL, 'GDP_fucose_synth', 236756),
(293031, 'MF_01158', NULL, 'DnaA regulatory inactivator Hda [hda].', NULL, NULL, 'Hda', 236757),
(293032, 'MF_01878', NULL, 'Dipeptide and tripeptide permease A [dtpA].', NULL, NULL, 'PTR2_DtpA_subfam', 236758),
(293033, 'MF_04159', NULL, 'Protein spackle [sp].', NULL, NULL, 'SPACKLE_T4', 236759),
(293034, 'MF_01689', NULL, 'Ornithine aminotransferase [rocD].', NULL, NULL, 'Ornith_aminotrans_3', 236760),
(293035, 'MF_00049_A', NULL, 'Leucine--tRNA ligase [leuS].', NULL, NULL, 'Leu_tRNA_synth_A', 236761),
(293036, 'MF_00508', NULL, '30S ribosomal protein S10 [rpsJ].', NULL, NULL, 'Ribosomal_S10', 236762),
(293037, 'MF_01231', NULL, 'Haloalkane dehalogenase [dhaA].', NULL, NULL, 'Haloalk_dehal_type2', 236763),
(293038, 'MF_01302_A', NULL, '30S ribosomal protein S8 [rpsH].', NULL, NULL, 'Ribosomal_S8_A', 236764),
(293039, 'MF_00308', NULL, 'Prefoldin subunit alpha [pfdA].', NULL, NULL, 'PfdA', 236765),
(293040, 'MF_01920', NULL, 'ATP-dependent DNA helicase Rep [rep].', NULL, NULL, 'Helicase_Rep', 236766),
(293041, 'MF_04014', NULL, 'Tripartite terminase subunit 1 [TRM1].', NULL, NULL, 'HSV_TRM1', 236767),
(293042, 'MF_01458', NULL, 'ATP-dependent zinc metalloprotease FtsH [ftsH].', NULL, NULL, 'FtsH', 236768),
(293043, 'MF_00680', NULL, 'UPF0263 protein YciU [yciU].', NULL, NULL, 'UPF0263', 236769),
(293044, 'MF_01916', NULL, 'Cardiolipin synthase.', NULL, NULL, 'Cardiolipin_synth_Cls', 236770),
(293045, 'MF_01236', NULL, 'HTH-type transcriptional repressor NanR [nanR].', NULL, NULL, 'HTH_NanR', 236771),
(293046, 'MF_01885', NULL, 'tRNA (cytidine(34)-2''-O)-methyltransferase [trmL].', NULL, NULL, 'tRNA_methyltr_TrmL', 236772),
(293047, 'MF_00110', NULL, '3-dehydroquinate synthase [aroB].', NULL, NULL, 'DHQ_synthase', 236773),
(293048, 'MF_01205', NULL, 'O-acetyl-ADP-ribose deacetylase [ymdB].', NULL, NULL, 'YmdB', 236774),
(293049, 'MF_00157', NULL, 'Ribonuclease T [rnt].', NULL, NULL, 'RNase_T', 236775),
(293050, 'MF_00739', NULL, 'Urease subunit gamma [ureA].', NULL, NULL, 'Urease_gamma', 236776),
(293051, 'MF_01930', NULL, 'Phosphoribosylglycinamide formyltransferase [purN].', NULL, NULL, 'PurN', 236777),
(293052, 'MF_01490', NULL, 'Holliday junction resolvase Hjc [hjc].', NULL, NULL, 'HJ_Resolv_Hjc', 236778),
(293053, 'MF_00523', NULL, 'UDP-3-O-(3-hydroxymyristoyl)glucosamine N-acyltransferase [lpxD].', NULL, NULL, 'LpxD', 236779),
(293054, 'MF_00335', NULL, 'Ribonuclease Y [rny].', NULL, NULL, 'RNase_Y', 236780),
(293055, 'MF_01924', NULL, 'D-alanyl-D-alanine dipeptidase [ddpX].', NULL, NULL, 'A_A_dipeptidase', 236781),
(293056, 'MF_00101', NULL, 'Holo-[acyl-carrier-protein] synthase [acpS].', NULL, NULL, 'AcpS', 236782),
(293057, 'MF_00137', NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase [purC].', NULL, NULL, 'SAICAR_synth', 236783),
(293058, 'MF_04108', NULL, 'Holin.', NULL, NULL, 'HOLIN_T7', 236784),
(293059, 'MF_00588', NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit E [gatE].', NULL, NULL, 'GatE', 236785),
(293060, 'MF_00285', NULL, 'Potassium-transporting ATPase ATP-binding subunit [kdpB].', NULL, NULL, 'KdpB', 236786),
(293061, 'MF_00714', NULL, 'Alkylmercury lyase [merB].', NULL, NULL, 'MerB', 236787),
(293062, 'MF_04118', NULL, 'Internal virion protein gp14.', NULL, NULL, 'GP14_T7', 236788),
(293063, 'MF_01819', NULL, 'Transcriptional regulator SlyA [slyA].', NULL, NULL, 'HTH_type_SlyA', 236789),
(293064, 'MF_01332', NULL, 'Secretion monitor [secM].', NULL, NULL, 'SecM', 236790),
(293065, 'MF_00635', NULL, 'Probable deoxyuridine 5''-triphosphate nucleotidohydrolase [dut].', NULL, NULL, 'dUTPase_arch', 236791),
(293066, 'MF_01505', NULL, 'Small, acid-soluble spore protein N [sspN].', NULL, NULL, 'SspN', 236792),
(293067, 'MF_01145', NULL, 'Foldase protein PrsA [prsA].', NULL, NULL, 'Foldase_PrsA', 236793);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(293068, 'MF_03112', NULL, 'ATPase <gene_name> [GET3].', NULL, NULL, 'Asna1_Get3', 236794),
(293069, 'MF_01151', NULL, 'Protein GrpE [grpE].', NULL, NULL, 'GrpE', 236795),
(293070, 'MF_00312', NULL, 'V-type ATP synthase subunit F [atpF].', NULL, NULL, 'ATP_synth_F_arch', 236796),
(293071, 'MF_00699', NULL, 'Probable Brix domain-containing ribosomal biogenesis protein.', NULL, NULL, 'BriX', 236797),
(293072, 'MF_01283', NULL, 'Riboflavin biosynthesis protein RibBA [ribBA].', NULL, NULL, 'RibBA', 236798),
(293073, 'MF_00173', NULL, 'Arginine repressor [argR].', NULL, NULL, 'Arg_repressor', 236799),
(293074, 'MF_00793', NULL, 'Phycoerythrobilin:ferredoxin oxidoreductase [pebB].', NULL, NULL, 'PebB', 236800),
(293075, 'MF_01414', NULL, 'Glutathione-regulated potassium-efflux system ancillary protein KefF [kefF].', NULL, NULL, 'K_H_efflux_KefF', 236801),
(293076, 'MF_01512', NULL, 'Metallothiol transferase FosB [fosB].', NULL, NULL, 'FosB', 236802),
(293077, 'MF_02122', NULL, '2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-succinyltransferase [dapD].', NULL, NULL, 'DapD_type2', 236803),
(293078, 'MF_01686', NULL, 'Putative thymidylate synthase [thyA].', NULL, NULL, 'Thymidy_synth_arch', 236804),
(293079, 'MF_03052', NULL, 'Molybdopterin synthase catalytic subunit [cnxH].', NULL, NULL, 'MOC2B', 236805),
(293080, 'MF_01482', NULL, 'Mycothiol S-conjugate amidase [mca].', NULL, NULL, 'Mca', 236806),
(293081, 'MF_01851', NULL, 'UPF0637 protein <locus_tag>.', NULL, NULL, 'UPF0637', 236807),
(293082, 'MF_00463', NULL, 'Ion-translocating oxidoreductase complex subunit B [rsxB].', NULL, NULL, 'RsxB_RnfB', 236808),
(293083, 'MF_00613', NULL, 'Photosystem I reaction center subunit IV [psaE].', NULL, NULL, 'PSI_PsaE', 236809),
(293084, 'MF_00237', NULL, 'Sec-independent protein translocase protein TatB [tatB].', NULL, NULL, 'TatB', 236810),
(293085, 'MF_01181', NULL, 'Regulator of sigma D [rsd].', NULL, NULL, 'Rsd', 236811),
(293086, 'MF_00209', NULL, 'Inorganic pyrophosphatase [ppa].', NULL, NULL, 'Inorganic_PPase', 236812),
(293087, 'MF_00175', NULL, 'ATP-dependent Clp protease ATP-binding subunit ClpX [clpX].', NULL, NULL, 'ClpX', 236813),
(293088, 'MF_01353', NULL, 'NAD(P)H-quinone oxidoreductase subunit N [ndhN].', NULL, NULL, 'NDH1_NDH1N', 236814),
(293089, 'MF_00311', NULL, 'V-type proton ATPase subunit E [atpE].', NULL, NULL, 'ATP_synth_E_arch', 236815),
(293090, 'MF_01607', NULL, 'HTH-type transcriptional regulator YidZ [yidZ].', NULL, NULL, 'HTH_type_YidZ', 236816),
(293091, 'MF_03204', NULL, 'Elongation of very long chain fatty acids protein 4 [ELOVL4].', NULL, NULL, 'VLCF_elongase_4', 236817),
(293092, 'MF_00340', NULL, '50S ribosomal protein L32 [rpmF].', NULL, NULL, 'Ribosomal_L32', 236818),
(293093, 'MF_00852', NULL, '(S)-8-amino-7-oxononanoate synthase BioU [bioU].', NULL, NULL, 'BioU', 236819),
(293094, 'MF_00989', NULL, 'L-ribulose-5-phosphate 4-epimerase [araD].', NULL, NULL, 'AraD_entero', 236820),
(293095, 'MF_01537', NULL, 'Pyrimidine/purine nucleoside phosphorylase [ppnP].', NULL, NULL, 'Nucleos_phosphorylase_PpnP', 236821),
(293096, 'MF_03021', NULL, 'Spastin [SPAST].', NULL, NULL, 'Spastin', 236822),
(293097, 'MF_01184', NULL, 'Xanthine phosphoribosyltransferase [xpt].', NULL, NULL, 'XPRTase', 236823),
(293098, 'MF_01074', NULL, 'Pyridinium-3,5-bisthiocarboxylic acid mononucleotide nickel insertion protein [larC].', NULL, NULL, 'LarC', 236824),
(293099, 'MF_01127', NULL, 'Acetyltransferase YpeA [ypeA].', NULL, NULL, 'Acetyltransf_YpeA', 236825),
(293100, 'MF_01449', NULL, 'HTH-type transcriptional regulator SgrR [sgrR].', NULL, NULL, 'HTH_type_SgrR', 236826),
(293101, 'MF_01863', NULL, 'UPF0741 protein <locus_tag>.', NULL, NULL, 'UPF0741', 236827),
(293102, 'MF_01085', NULL, 'UPF0283 membrane protein YcjF [ycjF].', NULL, NULL, 'UPF0283', 236828),
(293103, 'MF_01933', NULL, 'o-succinylbenzoate synthase [menC].', NULL, NULL, 'MenC_2', 236829),
(293104, 'MF_00118_A', NULL, 'Elongation factor Tu [tuf].', NULL, NULL, 'EF_Tu_A', 236830),
(293105, 'MF_01402_A', NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase [apgM].', NULL, NULL, 'ApgM_A', 236831);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(293106, 'MF_01556', NULL, 'Galactose-6-phosphate isomerase subunit LacB [lacB].', NULL, NULL, 'LacB', 236832),
(293107, 'MF_02087', NULL, 'Pyridoxal phosphate homeostasis protein.', NULL, NULL, 'PLP_homeostasis', 236833),
(293108, 'MF_00038', NULL, 'Phospho-N-acetylmuramoyl-pentapeptide-transferase [mraY].', NULL, NULL, 'MraY', 236834),
(293109, 'MF_03024', NULL, 'Katanin p60 ATPase-containing subunit A-like 1 [KATNAL1].', NULL, NULL, 'Katanin_p60_AL1', 236835),
(293110, 'MF_00641', NULL, 'Malate synthase G [glcB].', NULL, NULL, 'Malate_synth_G', 236836),
(293111, 'MF_04096', NULL, 'Nucleoprotein [N].', NULL, NULL, 'BETA_CORONA_NCAP', 236837),
(293112, 'MF_01948', NULL, 'Lipopolysaccharide assembly protein A [lapA].', NULL, NULL, 'LPS_assembly_LapA', 236838),
(293113, 'MF_01072', NULL, 'Glucans biosynthesis glucosyltransferase H [mdoH].', NULL, NULL, 'MdoH_OpgH', 236839),
(293114, 'MF_01160', NULL, 'Divalent-cation tolerance protein CutA [cutA].', NULL, NULL, 'CutA', 236840),
(293115, 'MF_02066', NULL, 'Cell division coordinator CpoB [cpoB].', NULL, NULL, 'CpoB', 236841),
(293116, 'MF_00208', NULL, 'UDP-N-acetylmuramoyl-L-alanyl-D-glutamate--2,6-diaminopimelate ligase [murE].', NULL, NULL, 'MurE', 236842),
(293117, 'MF_01254', NULL, 'L-fucose isomerase [fucI].', NULL, NULL, 'Fucose_iso', 236843),
(293118, 'MF_01024', NULL, 'Histidinol dehydrogenase [hisD].', NULL, NULL, 'HisD', 236844),
(293119, 'MF_01042', NULL, 'UPF0115 protein YfcN [yfcN].', NULL, NULL, 'UPF0115', 236845),
(293120, 'MF_04060', NULL, 'Shutoff protein [L4].', NULL, NULL, 'ADV_SHUT', 236846),
(293121, 'MF_00407', NULL, 'DNA ligase [lig].', NULL, NULL, 'DNA_ligase', 236847),
(293122, 'MF_00717', NULL, 'Photosystem II protein Y [psbY].', NULL, NULL, 'PSII_PsbY', 236848),
(293123, 'MF_01913', NULL, '3-sulfolactaldehyde reductase.', NULL, NULL, 'SLA_reductase', 236849),
(293124, 'MF_00381', NULL, 'Integration host factor subunit beta [ihfB].', NULL, NULL, 'IHF_beta', 236850),
(293125, 'MF_00385', NULL, '30S ribosomal protein S16 [rpsP].', NULL, NULL, 'Ribosomal_S16', 236851),
(293126, 'MF_00797', NULL, 'UPF0335 protein <locus_tag>.', NULL, NULL, 'UPF0335', 236852),
(293127, 'MF_00441', NULL, 'Photosystem II reaction center protein K [psbK].', NULL, NULL, 'PSII_PsbK', 236853),
(293128, 'MF_02104', NULL, 'Lactate utilization protein C [lutC].', NULL, NULL, 'LutC', 236854),
(293129, 'MF_00528', NULL, 'dTTP/UTP pyrophosphatase.', NULL, NULL, 'Maf', 236855),
(293130, 'MF_00932', NULL, 'Thiol:disulfide interchange protein DsbL [dsbL].', NULL, NULL, 'DsbL', 236856),
(293131, 'MF_01310', NULL, '30S ribosomal protein S11 [rpsK].', NULL, NULL, 'Ribosomal_S11', 236857),
(293132, 'MF_00502', NULL, '50S ribosomal protein L31 type B [rpmE2].', NULL, NULL, 'Ribosomal_L31_2', 236858),
(293133, 'MF_00006', NULL, 'Argininosuccinate lyase [argH].', NULL, NULL, 'Arg_succ_lyase', 236859),
(293134, 'MF_03071', NULL, 'Chromodomain-helicase-DNA-binding protein 8 [CHD8].', NULL, NULL, 'CHD8', 236860),
(293135, 'MF_00344', NULL, 'GMP synthase [glutamine-hydrolyzing] [guaA].', NULL, NULL, 'GMP_synthase', 236861),
(293136, 'MF_01162', NULL, 'Bifunctional protein Aas [aas].', NULL, NULL, 'Aas', 236862),
(293137, 'MF_03027', NULL, 'Ribosome biogenesis protein @gn(BOP1) [BOP1].', NULL, NULL, 'BOP1', 236863),
(293138, 'MF_03154', NULL, '1,2-dihydroxy-3-keto-5-methylthiopentene dioxygenase [ADI1].', NULL, NULL, 'Salvage_MtnD_euk', 236864),
(293139, 'MF_01677', NULL, 'Methylthioribulose-1-phosphate dehydratase [mtnB].', NULL, NULL, 'Salvage_MtnB', 236865),
(293140, 'MF_00661', NULL, 'ATP-dependent RNA helicase RhlB [rhlB].', NULL, NULL, 'DEAD_helicase_RhlB', 236866),
(293141, 'MF_03025', NULL, 'Katanin p60 ATPase-containing subunit A-like 2 [KATNAL2].', NULL, NULL, 'Katanin_p60_AL2', 236867),
(293142, 'MF_01173', NULL, 'Succinylornithine transaminase [astC].', NULL, NULL, 'AstC_aminotrans_3', 236868),
(293143, 'MF_03115', NULL, 'Fe-S cluster assembly protein <gene_name> [DRE2].', NULL, NULL, 'Anamorsin', 236869),
(293144, 'MF_04073', NULL, 'Protein P [P].', NULL, NULL, 'HBV_DPOL', 236870);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(293145, 'MF_04072', NULL, 'Hemagglutinin [HA].', NULL, NULL, 'INFV_HEMA', 236871),
(293146, 'MF_00535', NULL, 'Cyanate hydratase [cynS].', NULL, NULL, 'Cyanate_hydrat', 236872),
(293147, 'MF_01351', NULL, 'NAD(P)H-quinone oxidoreductase subunit I, chloroplastic [ndhI].', NULL, NULL, 'NDH1_NuoI', 236873),
(293148, 'MF_02094', NULL, 'Phosphogluconate dehydratase [edd].', NULL, NULL, 'Edd', 236874),
(293149, 'MF_00944', NULL, 'Ribosome-binding ATPase YchF [ychF].', NULL, NULL, 'YchF_OLA1_ATPase', 236875),
(293150, 'MF_00406', NULL, '3-hydroxyacyl-[acyl-carrier-protein] dehydratase FabZ [fabZ].', NULL, NULL, 'FabZ', 236876),
(293151, 'MF_01555', NULL, 'Galactose-6-phosphate isomerase subunit LacA [lacA].', NULL, NULL, 'LacA', 236877),
(293152, 'MF_01090', NULL, '5,10-methenyltetrahydromethanopterin hydrogenase [hmd].', NULL, NULL, 'HMD', 236878),
(293153, 'MF_00741', NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase [purM].', NULL, NULL, 'AIRS', 236879),
(293154, 'MF_01657', NULL, 'Acetaldehyde dehydrogenase [mhpF].', NULL, NULL, 'Ac_ald_DH_ac', 236880),
(293155, 'MF_04158', NULL, 'Antitermination protein Q [Q].', NULL, NULL, 'Antitermination_lambda', 236881),
(293156, 'MF_01324', NULL, 'DNA-directed RNA polymerase subunit beta'' [rpoC2].', NULL, NULL, 'RNApol_bact_RpoC2', 236882),
(293157, 'MF_00089', NULL, 'Phosphomethylpyrimidine synthase [thiC].', NULL, NULL, 'ThiC', 236883),
(293158, 'MF_00143', NULL, 'UPF0114 protein YqhA [yqhA].', NULL, NULL, 'UPF0114', 236884),
(293159, 'MF_01290', NULL, '2-keto-3-deoxy-L-rhamnonate aldolase [rhmA].', NULL, NULL, 'KDR_aldolase', 236885),
(293160, 'MF_00216', NULL, 'Translation initiation factor 1A [eif1a].', NULL, NULL, 'aIF_1A', 236886),
(293161, 'MF_00620', NULL, 'Putative transcriptional regulatory protein <locus_tag>.', NULL, NULL, 'HTH_type_Tfx', 236887),
(293162, 'MF_01398', NULL, 'ATP synthase subunit b [atpF].', NULL, NULL, 'ATP_synth_b_bprime', 236888),
(293163, 'MF_03143', NULL, 'Pentafunctional AROM polypeptide [aroM].', NULL, NULL, 'Pentafunct_AroM', 236889),
(293164, 'MF_00102', NULL, '4-hydroxy-tetrahydrodipicolinate reductase [dapB].', NULL, NULL, 'DapB', 236890),
(293165, 'MF_01308', NULL, 'envelope membrane protein, chloroplastic [cemA].', NULL, NULL, 'CemA', 236891),
(293166, 'MF_01100', NULL, '5''-deoxynucleotidase YfbR [yfbR].', NULL, NULL, '5DNU', 236892),
(293167, 'MF_01832', NULL, 'Cysteine desulfuration protein SufE [sufE].', NULL, NULL, 'SufE', 236893),
(293168, 'MF_00905', NULL, '3'',5''-cyclic adenosine monophosphate phosphodiesterase CpdA [cpdA].', NULL, NULL, 'cAMP_phosphodiest_CpdA', 236894),
(293169, 'MF_00632', NULL, 'UPF0234 protein YajQ [yajQ].', NULL, NULL, 'UPF0234', 236895),
(293170, 'MF_00104', NULL, 'Ribonuclease 3 [rnc].', NULL, NULL, 'RNase_III', 236896),
(293171, 'MF_01080', NULL, 'tRNA pseudouridine synthase B [truB].', NULL, NULL, 'TruB_bact', 236897),
(293172, 'MF_01202', NULL, 'D-amino acid dehydrogenase [dadA].', NULL, NULL, 'DadA', 236898),
(293173, 'MF_01059', NULL, 'Cytoplasmic trehalase [treF].', NULL, NULL, 'Cyt_trehalase', 236899),
(293174, 'MF_00095', NULL, 'Sugar fermentation stimulation protein A [sfsA].', NULL, NULL, 'SfsA', 236900),
(293175, 'MF_00085', NULL, 'Translation initiation factor 5A [eif5a].', NULL, NULL, 'eIF_5A', 236901),
(293176, 'MF_00814', NULL, 'Nascent polypeptide-associated complex protein [nac].', NULL, NULL, 'NAC_arch', 236902),
(293177, 'MF_01328_A', NULL, '50S ribosomal protein L4 [rplD].', NULL, NULL, 'Ribosomal_L4_A', 236903),
(293178, 'MF_01849', NULL, 'Dual-specificity RNA methyltransferase RlmN [rlmN].', NULL, NULL, 'RNA_methyltr_RlmN', 236904),
(293179, 'MF_02090', NULL, 'Glutamine-dependent NAD(+) synthetase [nadE].', NULL, NULL, 'NadE_glutamine_dep', 236905),
(293180, 'MF_01527_B', NULL, 'GTP cyclohydrolase FolE2 [folE2].', NULL, NULL, 'GTP_cyclohydrol_B', 236906),
(293181, 'MF_00737', NULL, 'Formimidoylglutamase [hutG].', NULL, NULL, 'Formimidoylglutam', 236907),
(293182, 'MF_02245', NULL, 'ClpXP adapter protein SpxH [spxH].', NULL, NULL, 'Adapter_SpxH', 236908);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(293183, 'MF_00254', NULL, 'Glycine--tRNA ligase alpha subunit [glyQ].', NULL, NULL, 'Gly_tRNA_synth_alpha', 236909),
(293184, 'MF_00755', NULL, 'Ribonuclease P protein component 2 [rnp2].', NULL, NULL, 'RNase_P_2', 236910),
(293185, 'MF_00197', NULL, 'Diaminopimelate epimerase [dapF].', NULL, NULL, 'DAP_epimerase', 236911),
(293186, 'MF_00433', NULL, 'Cytochrome b6-f complex subunit 6 [petL].', NULL, NULL, 'Cytb6_f_PetL', 236912),
(293187, 'MF_03006', NULL, 'Eukaryotic translation initiation factor 3 subunit G [EIF3G].', NULL, NULL, 'eIF3g', 236913),
(293188, 'MF_01014', NULL, '1-(5-phosphoribosyl)-5-[(5-phosphoribosylamino)methylideneamino] imidazole-4-carboxamide isomerase [hisA].', NULL, NULL, 'HisA', 236914),
(293189, 'MF_01259', NULL, 'Bifunctional F420 biosynthesis protein FbiB [fbiB].', NULL, NULL, 'F420_ligase_FbiB', 236915),
(293190, 'MF_00976', NULL, 'Outer membrane lipoprotein RcsF [rcsF].', NULL, NULL, 'RcsF', 236916),
(293191, 'MF_03041', NULL, 'Protein Spindly [SPDL1].', NULL, NULL, 'SPDLY', 236917),
(293192, 'MF_00623', NULL, 'Exosome complex component Rrp4 [rrp4].', NULL, NULL, 'Exosome_Rrp4', 236918),
(293193, 'MF_00710', NULL, 'Malonate decarboxylase acyl carrier protein [mdcC].', NULL, NULL, 'Malonate_deCO2ase_dsu', 236919),
(293194, 'MF_00298', NULL, 'RNA pyrophosphohydrolase [rppH].', NULL, NULL, 'Nudix_RppH', 236920),
(293195, 'MF_02041', NULL, 'tRNA-dihydrouridine(20/20a) synthase [dusA].', NULL, NULL, 'DusA_subfam', 236921),
(293196, 'MF_00936', NULL, 'DNA topoisomerase 4 subunit A [parC].', NULL, NULL, 'ParC_type1', 236922),
(293197, 'MF_00339', NULL, 'ATP-dependent 6-phosphofructokinase [pfkA].', NULL, NULL, 'Phosphofructokinase_I_B1', 236923),
(293198, 'MF_03232', NULL, 'Acyl-coenzyme A diphosphatase YFT2 [YFT2].', NULL, NULL, 'YFT2', 236924),
(293199, 'MF_01391', NULL, 'Cytochrome c biogenesis protein CcsA [ccsA].', NULL, NULL, 'CytC_CcsA', 236925),
(293200, 'MF_02074', NULL, 'Renalase.', NULL, NULL, 'Bact_renalase', 236926),
(293201, 'MF_00554', NULL, 'Ribosomal RNA small subunit methyltransferase Nep1 [nep1].', NULL, NULL, 'NEP1', 236927),
(293202, 'MF_01133', NULL, 'Ribulose bisphosphate carboxylase [rbcL].', NULL, NULL, 'RuBisCO_L_type3', 236928),
(293203, 'MF_00315', NULL, '1-deoxy-D-xylulose-5-phosphate synthase [dxs].', NULL, NULL, 'DXP_synth', 236929),
(293204, 'MF_00963', NULL, 'RNA polymerase sigma factor RpoD [rpoD].', NULL, NULL, 'Sigma70_RpoD_SigA', 236930),
(293205, 'MF_04003', NULL, 'Minor capsid protein L2 [L2].', NULL, NULL, 'PPV_L2', 236931),
(293206, 'MF_01638', NULL, 'Pyridoxine/pyridoxal/pyridoxamine kinase [pdxK].', NULL, NULL, 'PdxK', 236932),
(293207, 'MF_00191', NULL, '4-hydroxy-3-methylbut-2-enyl diphosphate reductase [ispH].', NULL, NULL, 'IspH', 236933),
(293208, 'MF_00830', NULL, 'Ureidoacrylate amidohydrolase RutB [rutB].', NULL, NULL, 'RutB', 236934),
(293209, 'MF_00027', NULL, 'Hydrogenobyrinate a,c-diamide synthase [cobB].', NULL, NULL, 'CobB_CbiA', 236935),
(293210, 'MF_00036_A', NULL, 'Alanine--tRNA ligase [alaS].', NULL, NULL, 'Ala_tRNA_synth_A', 236936),
(293211, 'MF_00096', NULL, 'DNA mismatch repair protein MutS [mutS].', NULL, NULL, 'MutS', 236937),
(293212, 'MF_01648', NULL, '3-phenylpropionate/cinnamic acid dioxygenase subunit alpha [hcaE].', NULL, NULL, 'HcaE', 236938),
(293213, 'MF_00591', NULL, 'Exosome complex component Rrp41 [rrp41].', NULL, NULL, 'Exosome_Rrp41', 236939),
(293214, 'MF_00142', NULL, 'Iron-sulfur cluster assembly protein CyaY [cyaY].', NULL, NULL, 'CyaY', 236940),
(293215, 'MF_00189', NULL, 'Membrane-spanning protein YciB [yciB].', NULL, NULL, 'YciB', 236941),
(293216, 'MF_00494', NULL, 'Probable transaldolase [tal].', NULL, NULL, 'Transaldolase_3b', 236942),
(293217, 'MF_01368', NULL, '50S ribosomal protein L17 [rplQ].', NULL, NULL, 'Ribosomal_L17', 236943),
(293218, 'MF_03216', NULL, 'Phosphatidyl-N-methylethanolamine N-methyltransferase [PEMT].', NULL, NULL, 'PLMT', 236944),
(293219, 'MF_03168', NULL, 'Adenylate kinase 2, mitochondrial [AK2].', NULL, NULL, 'Adenylate_kinase_AK2', 236945),
(293220, 'MF_00466', NULL, 'Probable M18 family aminopeptidase 1 [apeA].', NULL, NULL, 'Aminopeptidase_M18_1', 236946);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(293221, 'MF_02032', NULL, '2-hydroxy-3-oxopropionate reductase [garR].', NULL, NULL, 'Tartronate_sem_reduc', 236947),
(293222, 'MF_00577', NULL, 'Urocanate hydratase [hutU].', NULL, NULL, 'HutU', 236948),
(293223, 'MF_04112', NULL, 'Lysis inhibition accessory protein.', NULL, NULL, 'Linr3_BPT4', 236949),
(293224, 'MF_01017', NULL, 'NAD(P)H dehydrogenase (quinone).', NULL, NULL, 'NQOR', 236950),
(293225, 'MF_00398', NULL, 'Probable apo-citrate lyase phosphoribosyl-dephospho-CoA transferase [citX].', NULL, NULL, 'CitX', 236951),
(293226, 'MF_00957', NULL, 'Poly(A) polymerase I [pcnB].', NULL, NULL, 'PolyA_pol', 236952),
(293227, 'MF_01233', NULL, 'HTH-type transcriptional regulator HdfR [hdfR].', NULL, NULL, 'HTH_type_HdfR', 236953),
(293228, 'MF_00752', NULL, 'Photosystem II reaction center protein H [psbH].', NULL, NULL, 'PSII_PsbH', 236954),
(293229, 'MF_00751', NULL, 'Preprotein translocase subunit SecG [secG].', NULL, NULL, 'SecG', 236955),
(293230, 'MF_00078', NULL, 'UPF0107 protein <locus_tag>.', NULL, NULL, 'UPF0107', 236956),
(293231, 'MF_00776', NULL, 'Glyoxylate reductase [gyaR].', NULL, NULL, 'GyaR', 236957),
(293232, 'MF_00307', NULL, 'Prefoldin subunit beta [pfdB].', NULL, NULL, 'PfdB', 236958),
(293233, 'MF_01841', NULL, 'Agmatine deiminase [aguA].', NULL, NULL, 'Agmatine_deimin', 236959),
(293234, 'MF_03172', NULL, 'UMP-CMP kinase [CMPK1].', NULL, NULL, 'Adenylate_kinase_UMP_CMP_kin', 236960),
(293235, 'MF_01292', NULL, '4-hydroxy-2-oxo-heptane-1,7-dioate aldolase [hpcH].', NULL, NULL, 'HKHD_aldolase', 236961),
(293236, 'MF_01420', NULL, 'Probable cell division protein WhiA [whiA].', NULL, NULL, 'HTH_type_WhiA', 236962),
(293237, 'MF_01847', NULL, 'HMP-PP phosphatase [cof].', NULL, NULL, 'HMP_PP_phosphat', 236963),
(293238, 'MF_01143', NULL, 'Holin-like protein CidA [cidA].', NULL, NULL, 'CidA', 236964),
(293239, 'MF_02209', NULL, 'UDP-N-acetyl-alpha-D-muramoyl-L-alanyl-L-glutamate epimerase [murL].', NULL, NULL, 'MurL', 236965),
(293240, 'MF_01539', NULL, 'tRNA(Met) cytidine acetate ligase [tmcAL].', NULL, NULL, 'TmcAL', 236966),
(293241, 'MF_01888', NULL, 'Regulator of ribonuclease activity B [rraB].', NULL, NULL, 'RraB', 236967),
(293242, 'MF_04065', NULL, 'RNA-directed RNA polymerase catalytic subunit [PB1].', NULL, NULL, 'INFV_RDRP', 236968),
(293243, 'MF_00968', NULL, 'ATP-dependent RNA helicase RhlE [rhlE].', NULL, NULL, 'DEAD_helicase_RhlE', 236969),
(293244, 'MF_03198', NULL, 'Protein-lysine N-methyltransferase <gene_name> [EFM6].', NULL, NULL, 'Methyltr_EFM6', 236970),
(293245, 'MF_00650', NULL, 'Phosphoribosyl-dephospho-CoA transferase [mdcG].', NULL, NULL, 'Malonate_MdcG', 236971),
(293246, 'MF_01536', NULL, 'UPF0344 protein <locus_tag>.', NULL, NULL, 'UPF0344', 236972),
(293247, 'MF_04077', NULL, 'Protein Rev [rev].', NULL, NULL, 'REV_HIV1', 236973),
(293248, 'MF_00226_B', NULL, 'Putative competence-damage inducible protein [cinA].', NULL, NULL, 'CinA_B', 236974),
(293249, 'MF_01538', NULL, 'UPF0346 protein <locus_tag>.', NULL, NULL, 'UPF0346', 236975),
(293250, 'MF_02114', NULL, '2-phospho-L-lactate  guanylyltransferase [cofC].', NULL, NULL, 'CofC', 236976),
(293251, 'MF_04016', NULL, 'Major capsid protein [MCP].', NULL, NULL, 'HSV_MCP', 236977),
(293252, 'MF_01204', NULL, 'Probable malonic semialdehyde reductase RutE [rutE].', NULL, NULL, 'Oxidoreductase_RutE_HadB', 236978),
(293253, 'MF_03106', NULL, 'Sulfate adenylyltransferase [MET3].', NULL, NULL, 'Sulf_adenylyltr_euk', 236979),
(293254, 'MF_04202', NULL, 'Membrane protein [M].', NULL, NULL, 'BETA_CORONA_M', 236980),
(293255, 'MF_00590', NULL, 'GTP-dependent dephospho-CoA kinase.', NULL, NULL, 'Dephospho_CoA_kinase_GTP_dep', 236981),
(293256, 'MF_01244', NULL, '3-dehydroquinate synthase [aroB''].', NULL, NULL, 'Arch_DHQ_synthase', 236982),
(293257, 'MF_00393', NULL, 'Glycerol-3-phosphate acyltransferase [plsB].', NULL, NULL, 'Glyc3P_acyltrans', 236983),
(293258, 'MF_01830', NULL, 'Putative hydro-lyase <locus_tag>.', NULL, NULL, 'Hydro_lyase', 236984),
(293259, 'MF_00377', NULL, 'Chromosomal replication initiator protein DnaA [dnaA].', NULL, NULL, 'DnaA_bact', 236985);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(293260, 'MF_00249', NULL, 'ATP-dependent protease ATPase subunit HslU [hslU].', NULL, NULL, 'HslU', 236986),
(293261, 'MF_00520', NULL, 'Ribulokinase [araB].', NULL, NULL, 'Ribulokinase', 236987),
(293262, 'MF_00863', NULL, 'DNA-directed RNA polymerase subunit Rpo1N [rpo1N].', NULL, NULL, 'RNApol_arch_Rpo1N', 236988),
(293263, 'MF_01435', NULL, 'Protein YebF [yebF].', NULL, NULL, 'YebF', 236989),
(293264, 'MF_01296', NULL, 'D-tagatose-1,6-bisphosphate aldolase subunit GatZ [gatZ].', NULL, NULL, 'Tagatose_aldol_GatZ', 236990),
(293265, 'MF_00524', NULL, 'Glucokinase [glk].', NULL, NULL, 'Glucokinase', 236991),
(293266, 'MF_01086', NULL, 'UPF0284 protein <locus_tag>.', NULL, NULL, 'UPF0284', 236992),
(293267, 'MF_04163', NULL, 'Sliding-clamp-loader small subunit.', NULL, NULL, 'T4_Clamp_Loader_S', 236993),
(293268, 'MF_00692', NULL, 'Protein adenylyltransferase SelO [selO].', NULL, NULL, 'SelO', 236994),
(293269, 'MF_02240', NULL, 'Phosphoserine phosphatase.', NULL, NULL, 'PSP', 236995),
(293270, 'MF_01188', NULL, 'UPF0441 protein YgiB [ygiB].', NULL, NULL, 'UPF0441', 236996),
(293271, 'MF_00923', NULL, 'Outer membrane protein assembly factor BamB [bamB].', NULL, NULL, 'OM_assembly_BamB', 236997),
(293272, 'MF_01172', NULL, 'N-succinylarginine dihydrolase [astB].', NULL, NULL, 'AstB', 236998),
(293273, 'MF_01260', NULL, 'Pimeloyl-[acyl-carrier protein] methyl ester esterase [bioH].', NULL, NULL, 'Carboxylester', 236999),
(293274, 'MF_01662', NULL, 'L-fucose mutarotase [fucU].', NULL, NULL, 'L_fucose_rotase', 237000),
(293275, 'MF_00408', NULL, 'TATA-box-binding protein [tbp].', NULL, NULL, 'TATA_bind_prot_arch', 237001),
(293276, 'MF_01958', NULL, 'Acetyl esterase [aes].', NULL, NULL, 'Acetyl_esterase', 237002),
(293277, 'MF_00309', NULL, 'V-type ATP synthase alpha chain [atpA].', NULL, NULL, 'ATP_synth_A_arch', 237003),
(293278, 'MF_01552', NULL, 'Ribosomal protein S6--L-glutamate ligase [rimK].', NULL, NULL, 'RimK', 237004),
(293279, 'MF_01450', NULL, 'Acylphosphatase [yccX].', NULL, NULL, 'Acylphosphatase_entero', 237005),
(293280, 'MF_02022', NULL, 'Cell division protein DedD [dedD].', NULL, NULL, 'DedD', 237006),
(293281, 'MF_04134', NULL, 'Tail assembly protein GT.', NULL, NULL, 'GT_LAMBD', 237007),
(293282, 'MF_04069', NULL, 'Matrix protein 2 [M].', NULL, NULL, 'INFV_M2', 237008),
(293283, 'MF_00396', NULL, 'Cytochrome b6-f complex subunit 7 [petM].', NULL, NULL, 'Cytb6_f_PetM', 237009),
(293284, 'MF_00631', NULL, 'Cell division protein CrgA [crgA].', NULL, NULL, 'CrgA', 237010),
(293285, 'MF_00293', NULL, 'Protein PsbN [psbN].', NULL, NULL, 'PSII_PsbN', 237011),
(293286, 'MF_01109', NULL, 'Ornithine carbamoyltransferase, catabolic [argI].', NULL, NULL, 'OTCase', 237012),
(293287, 'MF_00278', NULL, 'Imidazole glycerol phosphate synthase subunit HisH [hisH].', NULL, NULL, 'HisH', 237013),
(293288, 'MF_00840', NULL, 'Diadenylate cyclase [dacZ].', NULL, NULL, 'DacZ', 237014),
(293289, 'MF_03008', NULL, 'Eukaryotic translation initiation factor 3 subunit I [EIF3I].', NULL, NULL, 'eIF3i', 237015),
(293290, 'MF_00757', NULL, 'Ribonuclease P protein component 4 [rnp4].', NULL, NULL, 'RNase_P_4', 237016),
(293291, 'MF_00221', NULL, 'Divalent metal cation transporter MntH [mntH].', NULL, NULL, 'NRAMP', 237017),
(293292, 'MF_01087', NULL, 'UPF0285 protein <locus_tag>.', NULL, NULL, 'UPF0285', 237018),
(293293, 'MF_00240', NULL, 'Outer-membrane lipoprotein carrier protein [lolA].', NULL, NULL, 'LolA', 237019),
(293294, 'MF_00612', NULL, 'UPF0225 protein YchJ [ychJ].', NULL, NULL, 'UPF0225', 237020),
(293295, 'MF_01056', NULL, 'Protein FixB [fixB].', NULL, NULL, 'FixB', 237021),
(293296, 'MF_01146', NULL, 'Aquaporin Z [aqpZ].', NULL, NULL, 'Aquaporin_Z', 237022),
(293297, 'MF_04106', NULL, 'Baseplate wedge protein gp10.', NULL, NULL, 'BP10_T4', 237023),
(293298, 'MF_01683', NULL, 'Methylthioribose kinase [mtnK].', NULL, NULL, 'Salvage_MtnK', 237024),
(293299, 'MF_02010', NULL, 'Anti-adapter protein IraD [iraD].', NULL, NULL, 'IraD', 237025),
(293300, 'MF_00688', NULL, 'Leucyl/phenylalanyl-tRNA--protein transferase [aat].', NULL, NULL, 'Leu_Phe_trans', 237026);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(293301, 'MF_01025', NULL, '2-isopropylmalate synthase [leuA].', NULL, NULL, 'LeuA_type1', 237027),
(293302, 'MF_00657', NULL, 'PKHD-type hydroxylase YbiX [ybiX].', NULL, NULL, 'Hydroxyl_YbiX', 237028),
(293303, 'MF_00625', NULL, 'Selenide, water dikinase [selD].', NULL, NULL, 'SelD', 237029),
(293304, 'MF_02091', NULL, 'Uncharacterized MFS-type transporter YfcJ [yfcJ].', NULL, NULL, 'MFS_YfcJ', 237030),
(293305, 'MF_00012', NULL, 'Dihydroxy-acid dehydratase [ilvD].', NULL, NULL, 'IlvD', 237031),
(293306, 'MF_04127', NULL, 'Inner capsid protein VP2.', NULL, NULL, 'Rota_VP2_A', 237032),
(293307, 'MF_00929', NULL, 'Cellobiose 2-epimerase.', NULL, NULL, 'Cellobiose_2_epim', 237033),
(293308, 'MF_00164', NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing] [glmS].', NULL, NULL, 'GlmS', 237034),
(293309, 'MF_01422', NULL, 'Multidrug resistance protein MdtA [mdtA].', NULL, NULL, 'MdtA', 237035),
(293310, 'MF_01649', NULL, '3-phenylpropionate/cinnamic acid dioxygenase subunit beta [hcaF].', NULL, NULL, 'HcaF', 237036),
(293311, 'MF_01960', NULL, 'D-aminopeptidase [dap].', NULL, NULL, 'D_aminopeptidase', 237037),
(293312, 'MF_00036_B', NULL, 'Alanine--tRNA ligase [alaS].', NULL, NULL, 'Ala_tRNA_synth_B', 237038),
(293313, 'MF_00259', NULL, 'Aminomethyltransferase [gcvT].', NULL, NULL, 'GcvT', 237039),
(293314, 'MF_01185', NULL, 'Flagellar assembly factor FliW [fliW].', NULL, NULL, 'FliW', 237040),
(293315, 'MF_01352', NULL, 'NAD(P)H-quinone oxidoreductase subunit M [ndhM].', NULL, NULL, 'NDH1_NDH1M', 237041),
(293316, 'MF_01518', NULL, 'Adenine deaminase [ade].', NULL, NULL, 'Adenine_deamin', 237042),
(293317, 'MF_01940', NULL, 'RNA 2'',3''-cyclic phosphodiesterase [thpR].', NULL, NULL, 'RNA_CPDase', 237043),
(293318, 'MF_00646', NULL, 'Elongation factor P-like protein [yeiP].', NULL, NULL, 'EFP', 237044),
(293319, 'MF_00836', NULL, 'Ribose 1,5-bisphosphate phosphokinase PhnN [phnN].', NULL, NULL, 'PhnN', 237045),
(293320, 'MF_02019', NULL, 'UDP-N-acetylmuramoyl-tripeptide--D-alanyl-D-alanine ligase [murF].', NULL, NULL, 'MurF', 237046),
(293321, 'MF_00182', NULL, 'Methionyl-tRNA formyltransferase [fmt].', NULL, NULL, 'Formyl_trans', 237047),
(293322, 'MF_00239', NULL, 'Cytidylate kinase [cmk].', NULL, NULL, 'Cytidyl_kinase_type2', 237048),
(293323, 'MF_02051', NULL, '(4S)-4-hydroxy-5-phosphonooxypentane-2,3-dione isomerase [lsrG].', NULL, NULL, 'LsrG', 237049),
(293324, 'MF_01317', NULL, 'Photosystem II reaction center protein L [psbL].', NULL, NULL, 'PSII_PsbL', 237050),
(293325, 'MF_01563', NULL, 'HTH-type transcriptional regulator UlaR [ulaR].', NULL, NULL, 'HTH_type_UlaR', 237051),
(293326, 'MF_00904', NULL, 'Modulator protein MzrA [mzrA].', NULL, NULL, 'Modulator_MzrA', 237052),
(293327, 'MF_00310', NULL, 'V-type ATP synthase beta chain [atpB].', NULL, NULL, 'ATP_synth_B_arch', 237053),
(293328, 'MF_03104', NULL, 'Mitochondrial distribution and morphology protein 12 [MDM12].', NULL, NULL, 'Mdm12', 237054),
(293329, 'MF_00686', NULL, 'Probable Fe(2+)-trafficking protein [yggX].', NULL, NULL, 'Fe_traffic_YggX', 237055),
(293330, 'MF_01950', NULL, 'Acyl carrier protein phosphodiesterase [acpH].', NULL, NULL, 'AcpH', 237056),
(293331, 'MF_03210', NULL, 'Formate dehydrogenase, mitochondrial.', NULL, NULL, 'Formate_dehydrogenase', 237057),
(293332, 'MF_01065', NULL, 'UPF0257 lipoprotein YnfC [ynfC].', NULL, NULL, 'UPF0257', 237058),
(293333, 'MF_00204', NULL, 'UvrABC system protein B [uvrB].', NULL, NULL, 'UvrB', 237059),
(293334, 'MF_01043', NULL, 'Glycerol-3-phosphate acyltransferase [plsY].', NULL, NULL, 'PlsY', 237060),
(293335, 'MF_01138', NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit beta [cdhC].', NULL, NULL, 'CdhC', 237061),
(293336, 'MF_00479', NULL, 'Ion-translocating oxidoreductase complex subunit G [rsxG].', NULL, NULL, 'RsxG_RnfG', 237062),
(293337, 'MF_02045', NULL, 'Phosphoribosylaminoimidazole carboxylase [purE].', NULL, NULL, 'PurE_classII', 237063),
(293338, 'MF_00150', NULL, 'N-acetyl-gamma-glutamyl-phosphate reductase [argC].', NULL, NULL, 'ArgC_type1', 237064);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(293339, 'MF_01666', NULL, 'Glyoxylate/hydroxypyruvate reductase A [ghrA].', NULL, NULL, '2_Hacid_dh_C_GhrA', 237065),
(293340, 'MF_00728', NULL, 'Septation ring formation regulator EzrA [ezrA].', NULL, NULL, 'EzrA', 237066),
(293341, 'MF_01522', NULL, 'Low affinity potassium transport system protein kup [kup].', NULL, NULL, 'Kup', 237067),
(293342, 'MF_00192', NULL, 'DNA-directed RNA polymerase subunit Rpo6 [rpo6].', NULL, NULL, 'RNApol_arch_Rpo6', 237068),
(293343, 'MF_00689', NULL, 'Aspartate/glutamate leucyltransferase [bpt].', NULL, NULL, 'Bpt', 237069),
(293344, 'MF_01242', NULL, 'Aliphatic amidase [amiE].', NULL, NULL, 'Aliphatic_amidase', 237070),
(293345, 'MF_00648', NULL, 'Inosine/xanthosine triphosphatase.', NULL, NULL, 'Non_canon_purine_NTPase_YjjX', 237071),
(293346, 'MF_03067', NULL, 'E3 ubiquitin-protein ligase RNF8 [RNF8].', NULL, NULL, 'RNF8', 237072),
(293347, 'MF_04054', NULL, 'DNA-binding protein [DBP].', NULL, NULL, 'ADV_DNB2', 237073),
(293348, 'MF_01328_B', NULL, '50S ribosomal protein L4 [rplD].', NULL, NULL, 'Ribosomal_L4_B', 237074),
(293349, 'MF_01527_A', NULL, 'GTP cyclohydrolase FolE2 [folE2].', NULL, NULL, 'GTP_cyclohydrol_A', 237075),
(293350, 'MF_04153', NULL, 'Single-stranded DNA-binding protein.', NULL, NULL, 'SSB_T7', 237076),
(293351, 'MF_01220_B', NULL, 'Uridylate kinase [pyrH].', NULL, NULL, 'PyrH_B', 237077),
(293352, 'MF_00921', NULL, 'Putative pyruvate, phosphate dikinase regulatory protein.', NULL, NULL, 'PDRP', 237078),
(293353, 'MF_00083', NULL, 'Peptidyl-tRNA hydrolase [pth].', NULL, NULL, 'Pept_tRNA_hydro_bact', 237079),
(293354, 'MF_00043', NULL, 'Elongation factor 1-beta [ef1b].', NULL, NULL, 'EF1_beta', 237080),
(293355, 'MF_01807', NULL, 'Tyrosine recombinase XerD [xerD].', NULL, NULL, 'Recomb_XerD', 237081),
(293356, 'MF_03011', NULL, 'Eukaryotic translation initiation factor 3 subunit L [EIF3L].', NULL, NULL, 'eIF3l', 237082),
(293357, 'MF_00185', NULL, 'tRNA dimethylallyltransferase [miaA].', NULL, NULL, 'IPP_trans', 237083),
(293358, 'MF_01396', NULL, 'ATP synthase subunit c [atpH].', NULL, NULL, 'ATP_synth_c_bact', 237084),
(293359, 'MF_01895', NULL, 'Ribonuclease R [rnr].', NULL, NULL, 'RNase_R', 237085),
(293360, 'MF_01687', NULL, 'Beta-galactosidase [lacZ].', NULL, NULL, 'Beta_gal', 237086),
(293361, 'MF_01939', NULL, '2-methylisocitrate lyase [prpB].', NULL, NULL, 'PrpB', 237087),
(293362, 'MF_02076', NULL, 'Glutamate--tRNA ligase [gltX].', NULL, NULL, 'Glu_tRNA_synth_type2', 237088),
(293363, 'MF_00440', NULL, 'Transcriptional repressor NrdR [nrdR].', NULL, NULL, 'NrdR', 237089),
(293364, 'MF_02011', NULL, 'Cell cycle protein GpsB [gpsB].', NULL, NULL, 'GpsB', 237090),
(293365, 'MF_01234', NULL, 'N-acetylmannosamine kinase [nanK].', NULL, NULL, 'ManNAc_kinase', 237091),
(293366, 'MF_00438', NULL, 'Photosystem II reaction center protein M [psbM].', NULL, NULL, 'PSII_PsbM', 237092),
(293367, 'MF_00780', NULL, 'Protein YceI [yceI].', NULL, NULL, 'UPF0312', 237093),
(293368, 'MF_00629', NULL, '50S ribosomal protein L39e [rpl39e].', NULL, NULL, 'Ribosomal_L39e', 237094),
(293369, 'MF_01959', NULL, 'Cytochrome c-type biogenesis protein CcmE [ccmE].', NULL, NULL, 'CcmE', 237095),
(293370, 'MF_02130', NULL, 'Dihydroneopterin aldolase [mptD].', NULL, NULL, 'DHNA_arch', 237096),
(293371, 'MF_01411', NULL, 'LPS-assembly protein LptD [lptD].', NULL, NULL, 'LPS_assembly_LptD', 237097),
(293372, 'MF_01055', NULL, 'Protein FixA [fixA].', NULL, NULL, 'FixA', 237098),
(293373, 'MF_03007', NULL, 'Eukaryotic translation initiation factor 3 subunit H [EIF3H].', NULL, NULL, 'eIF3h', 237099),
(293374, 'MF_00756', NULL, 'Ribonuclease P protein component 3 [rnp3].', NULL, NULL, 'RNase_P_3', 237100),
(293375, 'MF_01339', NULL, 'Ribulose bisphosphate carboxylase [cbbM].', NULL, NULL, 'RuBisCO_L_type2', 237101),
(293376, 'MF_00226_A', NULL, 'Putative competence-damage inducible protein [cinA].', NULL, NULL, 'CinA_A', 237102),
(293377, 'MF_00670', NULL, 'Altronate oxidoreductase [uxaB].', NULL, NULL, 'Altron_oxidoreduct', 237103),
(293378, 'MF_00975', NULL, 'Exosome complex component Csl4 [csl4].', NULL, NULL, 'Exosome_Csl4', 237104);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(293379, 'MF_01164', NULL, 'Undecaprenyl-phosphate 4-deoxy-4-formamido-L-arabinose transferase [arnC].', NULL, NULL, 'ArnC_transfer', 237105),
(293380, 'MF_04128', NULL, 'Protein VP3.', NULL, NULL, 'Rota_VP3_A', 237106),
(293381, 'MF_02110', NULL, 'UPF0763 protein <locus_tag>.', NULL, NULL, 'UPF0763', 237107),
(293382, 'MF_01001', NULL, 'UDP-N-acetyl-D-mannosaminuronic acid transferase [wecG].', NULL, NULL, 'WecG_RffM', 237108),
(293383, 'MF_02234', NULL, 'N-acetylornithine carbamoyltransferase [argF''].', NULL, NULL, 'AOTCase', 237109),
(293384, 'MF_04011', NULL, 'DNA primase.', NULL, NULL, 'HSV_PRIM', 237110),
(293385, 'MF_03202', NULL, 'Elongation of very long chain fatty acids protein 2 [ELOVL2].', NULL, NULL, 'VLCF_elongase_2', 237111),
(293386, 'MF_00014', NULL, 'Ribosome maturation factor RimM [rimM].', NULL, NULL, 'Ribosome_mat_RimM', 237112),
(293387, 'MF_00079', NULL, 'ATP phosphoribosyltransferase [hisG].', NULL, NULL, 'HisG_Long', 237113),
(293388, 'MF_01323', NULL, 'DNA-directed RNA polymerase subunit gamma [rpoC1].', NULL, NULL, 'RNApol_bact_RpoC1', 237114),
(293389, 'MF_01912', NULL, 'Sulfofructosephosphate aldolase.', NULL, NULL, 'SFP_aldolase', 237115),
(293390, 'MF_01222', NULL, 'Protein archease.', NULL, NULL, 'Archease_arch', 237116),
(293391, 'MF_02016', NULL, 'Membrane-bound lytic murein transglycosylase F [mltF].', NULL, NULL, 'MltF', 237117),
(293392, 'MF_02093', NULL, 'Probable beta-carotene 15,15''-dioxygenase.', NULL, NULL, 'Beta_carotene_diox', 237118),
(293393, 'MF_01551', NULL, 'Ribosomal RNA large subunit methyltransferase M [rlmM].', NULL, NULL, '23SrRNA_methyltr_M', 237119),
(293394, 'MF_00626', NULL, 'Germination protease [gpr].', NULL, NULL, 'Germination_prot', 237120),
(293395, 'MF_00773', NULL, '50S ribosomal protein L24e [rpl24e].', NULL, NULL, 'Ribosomal_L24e', 237121),
(293396, 'MF_01844', NULL, 'Na(+)/H(+) antiporter NhaA [nhaA].', NULL, NULL, 'NhaA', 237122),
(293397, 'MF_00971', NULL, 'DNA-binding protein MutS2 [mutS2].', NULL, NULL, 'MutS2_archaea', 237123),
(293398, 'MF_00600', NULL, 'Chaperonin GroEL [groEL].', NULL, NULL, 'CH60', 237124),
(293399, 'MF_01978', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase [pfp].', NULL, NULL, 'Phosphofructokinase_II_B2', 237125),
(293400, 'MF_04131', NULL, 'Outer capsid glycoprotein VP7.', NULL, NULL, 'Rota_VP7_A', 237126),
(293401, 'MF_01393', NULL, 'ATP synthase subunit a [atpB].', NULL, NULL, 'ATP_synth_a_bact', 237127),
(293402, 'MF_01311', NULL, 'Protein-disulfide oxidoreductase DsbI [dsbI].', NULL, NULL, 'DsbI', 237128),
(293403, 'MF_01456', NULL, 'NAD(P)H-quinone oxidoreductase subunit 4L, chloroplastic [ndhE].', NULL, NULL, 'NDH1_NuoK', 237129),
(293404, 'MF_01876', NULL, 'Pseudouridine-5''-phosphate glycosidase [psuG].', NULL, NULL, 'PsiMP_glycosidase', 237130),
(293405, 'MF_00270', NULL, '30S ribosomal protein S18 [rpsR].', NULL, NULL, 'Ribosomal_S18', 237131),
(293406, 'MF_03035', NULL, 'Polyribonucleotide 5''-hydroxyl-kinase Clp1 [CLP1].', NULL, NULL, 'Clp1', 237132),
(293407, 'MF_00777', NULL, '30S ribosomal protein S27ae [rps27ae].', NULL, NULL, 'Ribosomal_S27ae', 237133),
(293408, 'MF_01082', NULL, 'tRNA pseudouridine synthase D [truD].', NULL, NULL, 'TruD', 237134),
(293409, 'MF_01335', NULL, 'Cytochrome b6-f complex iron-sulfur subunit [petC].', NULL, NULL, 'Cytb6_f_Rieske', 237135),
(293410, 'MF_00826', NULL, 'Glycine/sarcosine/betaine reductase complex component A [grdA].', NULL, NULL, 'GRDA', 237136),
(293411, 'MF_04057', NULL, 'Packaging protein 1 [IVa2].', NULL, NULL, 'ADV_PKG1', 237137),
(293412, 'MF_02048', NULL, 'D-aminoacyl-tRNA deacylase [dtd3].', NULL, NULL, 'Deacylase_DTD3', 237138),
(293413, 'MF_00995', NULL, 'Chorismate dehydratase [mqnA].', NULL, NULL, 'MqnA', 237139),
(293414, 'MF_03030', NULL, 'Mitochondrial genome maintenance exonuclease 1 [MGME1].', NULL, NULL, 'MGME1', 237140),
(293415, 'MF_03230', NULL, 'Acyl-coenzyme A diphosphatase FITM2 [FITM2].', NULL, NULL, 'FITM2', 237141),
(293416, 'MF_01271', NULL, 'N-acetyl-D-glucosamine kinase [nagK].', NULL, NULL, 'GlcNAc_kinase', 237142);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(293417, 'MF_03015', NULL, '40S ribosomal protein SA [rps-0].', NULL, NULL, 'Ribosomal_S2_euk', 237143),
(293418, 'MF_04204', NULL, 'Envelope small membrane protein [E].', NULL, NULL, 'BETA_CORONA_E', 237144),
(293419, 'MF_01062', NULL, 'Phosphoenolpyruvate synthase regulatory protein [ppsR].', NULL, NULL, 'PSRP', 237145),
(293420, 'MF_04026', NULL, 'Ribonucleoside-diphosphate reductase large subunit [RIR1].', NULL, NULL, 'HSV_RIR1', 237146),
(293421, 'MF_00445', NULL, 'NAD(P)H-quinone oxidoreductase subunit 2, chloroplastic [ndhB].', NULL, NULL, 'NDH1_NuoN_1', 237147),
(293422, 'MF_01369_A', NULL, '50S ribosomal protein L23 [rplW].', NULL, NULL, 'Ribosomal_L23_A', 237148),
(293423, 'MF_03169', NULL, 'GTP:AMP phosphotransferase AK3, mitochondrial [AK3].', NULL, NULL, 'Adenylate_kinase_AK3', 237149),
(293424, 'MF_00046', NULL, 'UDP-N-acetylmuramate--L-alanine ligase [murC].', NULL, NULL, 'MurC', 237150),
(293425, 'MF_00228', NULL, 'Hydroxyethylthiazole kinase [thiM].', NULL, NULL, 'Thz_kinase', 237151),
(293426, 'MF_00813', NULL, 'Probable allantoicase [alc].', NULL, NULL, 'Allantoicase', 237152),
(293427, 'MF_00951', NULL, 'Transcription antitermination protein RfaH [rfaH].', NULL, NULL, 'RfaH', 237153),
(293428, 'MF_04015', NULL, 'Tripartite terminase subunit 2 [TRM2].', NULL, NULL, 'HSV_TRM2', 237154),
(293429, 'MF_03221', NULL, 'Succinate--CoA ligase [GDP-forming] subunit beta, mitochondrial [SUCLG2].', NULL, NULL, 'Succ_CoA_betaG_euk', 237155),
(293430, 'MF_04114', NULL, 'Portal protein.', NULL, NULL, 'PORTAL_T4', 237156),
(293431, 'MF_00931', NULL, 'Aldehyde decarbonylase.', NULL, NULL, 'Aldeh_decarbonylase', 237157),
(293432, 'MF_01897', NULL, 'DNA gyrase subunit A [gyrA].', NULL, NULL, 'GyrA', 237158),
(293433, 'MF_04086', NULL, 'RNA-directed RNA polymerase L [L].', NULL, NULL, 'ARENA_L', 237159),
(293434, 'MF_04056', NULL, 'Pre-histone-like nucleoprotein [L2].', NULL, NULL, 'ADV_PVII', 237160),
(293435, 'MF_01342', NULL, '50S ribosomal protein L16 [rplP].', NULL, NULL, 'Ribosomal_L16', 237161),
(293436, 'MF_00816', NULL, 'UPF0352 protein YejL [yejL].', NULL, NULL, 'UPF0352', 237162),
(293437, 'MF_01375', NULL, 'Phosphonoacetaldehyde hydrolase [phnX].', NULL, NULL, 'PhnX', 237163),
(293438, 'MF_00127', NULL, 'Histidine--tRNA ligase [hisS].', NULL, NULL, 'His_tRNA_synth', 237164),
(293439, 'MF_00060', NULL, '5''/3''-nucleotidase SurE [surE].', NULL, NULL, 'SurE', 237165),
(293440, 'MF_03175', NULL, 'Methionine aminopeptidase 2 [METAP2].', NULL, NULL, 'MetAP_2_euk', 237166),
(293441, 'MF_00058', NULL, 'F420-dependent methylenetetrahydromethanopterin dehydrogenase [mtd].', NULL, NULL, 'MTD', 237167),
(293442, 'MF_00409', NULL, 'Tetraacyldisaccharide 4''-kinase [lpxK].', NULL, NULL, 'LpxK', 237168),
(293443, 'MF_01491', NULL, 'Ribonuclease J [rnj].', NULL, NULL, 'RNase_J_bact', 237169),
(293444, 'MF_04121', NULL, 'Peptidoglycan transglycosylase gp16.', NULL, NULL, 'TRANSGLYCOSYLASE_T7', 237170),
(293445, 'MF_00616', NULL, 'Ureidoglycolate lyase [allA].', NULL, NULL, 'Ureidogly_lyase', 237171),
(293446, 'MF_01810', NULL, 'Membrane protein insertase YidC [yidC].', NULL, NULL, 'YidC_type1', 237172),
(293447, 'MF_04040', NULL, 'Cytoplasmic envelopment protein 3.', NULL, NULL, 'HSV_CEP3_alphahv', 237173),
(293448, 'MF_01404', NULL, 'Pyruvoyl-dependent arginine decarboxylase [pdaD].', NULL, NULL, 'PvlArgDC', 237174),
(293449, 'MF_01495', NULL, 'Photosystem II CP47 reaction center protein [psbB].', NULL, NULL, 'PSII_PsbB_CP47', 237175),
(293450, 'MF_00220_B', NULL, 'Dihydroorotase [pyrC].', NULL, NULL, 'PyrC_classI_B', 237176),
(293451, 'MF_00788', NULL, '50S ribosomal protein L40e [rpl40e].', NULL, NULL, 'Ribosomal_L40e', 237177),
(293452, 'MF_04061', NULL, 'Preterminal protein [PTP].', NULL, NULL, 'ADV_TERM', 237178),
(293453, 'MF_00265', NULL, 'tRNA(fMet)-specific endonuclease VapC [vapC].', NULL, NULL, 'VapC_Nob1', 237179),
(293454, 'MF_01970', NULL, 'Kynureninase [kynU].', NULL, NULL, 'Kynureninase', 237180),
(293455, 'MF_00950', NULL, 'Transcription elongation factor Spt5 [spt5].', NULL, NULL, 'Spt5_arch', 237181);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(293456, 'MF_00467', NULL, 'Probable M18 family aminopeptidase 2 [apeB].', NULL, NULL, 'Aminopeptidase_M18_2', 237182),
(293457, 'MF_01157', NULL, 'DnaA initiator-associating protein DiaA [diaA].', NULL, NULL, 'SIS_DiaA', 237183),
(293458, 'MF_04044', NULL, 'Large tegument protein deneddylase.', NULL, NULL, 'HSV_LTP', 237184),
(293459, 'MF_03048', NULL, 'Ubiquitin-related modifier 1 [URM1].', NULL, NULL, 'Urm1', 237185),
(293460, 'MF_00845', NULL, 'Flavin-dependent monooxygenase.', NULL, NULL, 'TetX_monooxygenase', 237186),
(293461, 'MF_01215', NULL, 'Orotidine 5''-phosphate decarboxylase [pyrF].', NULL, NULL, 'OMPdecase_type2', 237187),
(293462, 'MF_00371', NULL, '30S ribosomal protein S27e [rps27e].', NULL, NULL, 'Ribosomal_S27e', 237188),
(293463, 'MF_01577', NULL, 'Putative multidrug resistance protein MdtD [mdtD].', NULL, NULL, 'MFS_MdtD', 237189),
(293464, 'MF_00376', NULL, 'Dephospho-CoA kinase [coaE].', NULL, NULL, 'Dephospho_CoA_kinase', 237190),
(293465, 'MF_01163', NULL, '5-formaminoimidazole-4-carboxamide-1-(beta)-D-ribofuranosyl 5''-monophosphate synthetase [purP].', NULL, NULL, 'IMP_biosynth_PurP', 237191),
(293466, 'MF_01576', NULL, 'Bifunctional protein FolD [folD].', NULL, NULL, 'THF_DHG_CYH', 237192),
(293467, 'MF_01417', NULL, 'Biosynthetic arginine decarboxylase [speA].', NULL, NULL, 'SpeA', 237193),
(293468, 'MF_04119', NULL, 'Minor capsid protein.', NULL, NULL, 'CAPSID_PROTEIN_T7', 237194),
(293469, 'MF_00172', NULL, '5-methyltetrahydropteroyltriglutamate--homocysteine methyltransferase [metE].', NULL, NULL, 'Meth_synth', 237195),
(293470, 'MF_00253_A', NULL, 'Glycine--tRNA ligase [glyQS].', NULL, NULL, 'Gly_tRNA_synth_A', 237196),
(293471, 'MF_00678', NULL, 'UPF0262 protein <locus_tag>.', NULL, NULL, 'UPF0262', 237197),
(293472, 'MF_03206', NULL, 'Elongation of very long chain fatty acids protein 6 [ELOVL6].', NULL, NULL, 'VLCF_elongase_6', 237198),
(293473, 'MF_01315', NULL, '30S ribosomal protein S13 [rpsM].', NULL, NULL, 'Ribosomal_S13_S18', 237199),
(293474, 'MF_01421', NULL, 'UPF0323 lipoprotein <locus_tag>.', NULL, NULL, 'UPF0323', 237200),
(293475, 'MF_01309_A', NULL, '30S ribosomal protein S3 [rpsC].', NULL, NULL, 'Ribosomal_S3_A', 237201),
(293476, 'MF_00296', NULL, 'Homoserine O-acetyltransferase [metXA].', NULL, NULL, 'MetX_acyltransf', 237202),
(293477, 'MF_00272', NULL, 'Glycine cleavage system H protein [gcvH].', NULL, NULL, 'GcvH', 237203),
(293478, 'MF_01475', NULL, '50S ribosomal protein L19e [rpl19e].', NULL, NULL, 'Ribosomal_L19e', 237204),
(293479, 'MF_04083', NULL, 'Envelope glycoprotein gp160 [env].', NULL, NULL, 'HIV_ENV', 237205),
(293480, 'MF_04201', NULL, 'Membrane protein [M].', NULL, NULL, 'ALPHA_CORONA_M', 237206),
(293481, 'MF_02057', NULL, 'tRNA 5-carboxymethoxyuridine methyltransferase [cmoM].', NULL, NULL, 'tRNA_methyltr_CmoM', 237207),
(293482, 'MF_00065', NULL, 'Adenylyl-sulfate kinase [cysC].', NULL, NULL, 'Adenylyl_sulf_kinase', 237208),
(293483, 'MF_01286', NULL, 'Digeranylgeranylglyceryl phosphate synthase.', NULL, NULL, 'DGGGP_synth', 237209),
(293484, 'MF_00367', NULL, 'GTPase Era [era].', NULL, NULL, 'GTPase_Era', 237210),
(293485, 'MF_00495', NULL, 'Phosphoglycolate phosphatase [gph].', NULL, NULL, 'GPH_hydrolase_bact', 237211),
(293486, 'MF_00720', NULL, 'Primosomal replication protein N [priB].', NULL, NULL, 'PriB', 237212),
(293487, 'MF_00844_B', NULL, 'Rqc2 homolog RqcH [rqcH].', NULL, NULL, 'RqcH_B', 237213),
(293488, 'MF_04141', NULL, 'NAD--protein ADP-ribosyltransferase modA [modA].', NULL, NULL, 'MODA_T4', 237214),
(293489, 'MF_00787', NULL, 'Cobalt-precorrin-5B C(1)-methyltransferase [cbiD].', NULL, NULL, 'CbiD', 237215),
(293490, 'MF_04070', NULL, 'Nucleoprotein [NP].', NULL, NULL, 'INFV_NCAP', 237216),
(293491, 'MF_00734', NULL, 'Tagatose 1,6-diphosphate aldolase [lacD].', NULL, NULL, 'LacD', 237217),
(293492, 'MF_04117', NULL, 'Major capsid protein.', NULL, NULL, 'CAPSID_H_T4', 237218),
(293493, 'MF_02120', NULL, 'Diaminopimelate decarboxylase [lysA].', NULL, NULL, 'LysA', 237219),
(293494, 'MF_01560', NULL, 'UPF0358 protein <locus_tag>.', NULL, NULL, 'UPF0358', 237220);
INSERT INTO "PUBLIC"."MODEL" VALUES
(293495, 'MF_01006', NULL, 'Undecaprenyl-diphosphatase [uppP].', NULL, NULL, 'Undec_diphosphatase', 237221),
(293496, 'MF_00783', NULL, 'Probable flagellum biosynthesis repressor protein FlbT [flbT].', NULL, NULL, 'FlbT', 237222),
(293497, 'MF_01667', NULL, 'Glyoxylate/hydroxypyruvate reductase B [ghrB].', NULL, NULL, '2_Hacid_dh_C_GhrB', 237223),
(293498, 'MF_03107', NULL, 'Very-long-chain 3-oxoacyl-CoA reductase.', NULL, NULL, '3_ketoreductase', 237224),
(293499, 'MF_01982', NULL, '2-phytyl-1,4-naphtoquinone methyltransferase [menG].', NULL, NULL, 'MenG_phylloquinone_subfam', 237225),
(293500, 'MF_02095', NULL, '3''(2''),5''-bisphosphate nucleotidase CysQ [cysQ].', NULL, NULL, 'CysQ', 237226),
(293501, 'MF_01427', NULL, '3''-5'' exoribonuclease YhaM [yhaM].', NULL, NULL, '3_5_Exoribonuc_YhaM', 237227),
(293502, 'MF_02235', NULL, 'N-succinylornithine carbamoyltransferase [argF''].', NULL, NULL, 'SOTCase', 237228),
(293503, 'MF_00779', NULL, 'Hut operon positive regulatory protein [hutP].', NULL, NULL, 'HutP', 237229),
(293504, 'MF_01550', NULL, 'Guanosine-5''-triphosphate,3''-diphosphate pyrophosphatase [gppA].', NULL, NULL, 'GppA', 237230),
(293505, 'MF_01943', NULL, 'Lipid A biosynthesis palmitoleoyltransferase [lpxP].', NULL, NULL, 'Lipid_A_LpxP', 237231),
(293506, 'MF_00054_A', NULL, 'Elongation factor G [fusA].', NULL, NULL, 'EF_G_EF_2_A', 237232),
(293507, 'MF_00959', NULL, 'RNA polymerase sigma factor RpoS [rpoS].', NULL, NULL, 'Sigma70_RpoS', 237233),
(293508, 'MF_03105', NULL, 'Mitochondrial distribution and morphology protein 34 [MDM34].', NULL, NULL, 'Mdm34', 237234),
(293509, 'MF_01816', NULL, 'Tyrosine recombinase XerS [xerS].', NULL, NULL, 'Recomb_XerS', 237235),
(293510, 'MF_01364_B', NULL, '30S ribosomal protein S14 type Z [rpsZ].', NULL, NULL, 'Ribosomal_S14_2_B', 237236),
(293511, 'MF_01480', NULL, 'CRISPR-associated endonuclease Cas9 [cas9].', NULL, NULL, 'Cas9', 237237),
(293512, 'MF_02056', NULL, 'O-succinylhomoserine sulfhydrylase [metZ].', NULL, NULL, 'MetZ', 237238),
(293513, 'MF_00219', NULL, 'Dihydroorotase [pyrC].', NULL, NULL, 'PyrC_classII', 237239),
(293514, 'MF_01240', NULL, 'UPF0309 protein <locus_tag>.', NULL, NULL, 'UPF0309', 237240),
(293515, 'MF_01148', NULL, 'Apolipoprotein N-acyltransferase [lnt].', NULL, NULL, 'Lnt', 237241),
(293516, 'MF_01070', NULL, 'Phosphoglycerol transferase I [mdoB].', NULL, NULL, 'MdoB_OpgB', 237242),
(293517, 'MF_01437', NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase [pgsA].', NULL, NULL, 'PgsA', 237243),
(293518, 'MF_04109', NULL, 'Endolysin.', NULL, NULL, 'ENDOLYSIN_LAMBDA', 237244),
(293519, 'MF_00501', NULL, '50S ribosomal protein L31 [rpmE].', NULL, NULL, 'Ribosomal_L31_1', 237245),
(293520, 'MF_00316', NULL, 'Molybdenum cofactor guanylyltransferase [mobA].', NULL, NULL, 'MobA', 237246),
(293521, 'MF_01061', NULL, 'Primosomal protein 1 [dnaT].', NULL, NULL, 'DnaT', 237247),
(293522, 'MF_00154', NULL, 'Protoheme IX farnesyltransferase [cyoE].', NULL, NULL, 'CyoE_CtaB', 237248),
(293523, 'MF_00916', NULL, 'Epoxyqueuosine reductase [queG].', NULL, NULL, 'QueG', 237249),
(293524, 'MF_01230', NULL, 'Haloalkane dehalogenase [dhmA].', NULL, NULL, 'Haloalk_dehal_type1', 237250),
(293525, 'MF_01496', NULL, 'Photosystem II CP43 reaction center protein [psbC].', NULL, NULL, 'PSII_PsbC_CP43', 237251),
(293526, 'MF_04110', NULL, 'Endolysin.', NULL, NULL, 'ENDOLYSIN_T4', 237252),
(293527, 'MF_00567', NULL, 'Quinolinate synthase A [nadA].', NULL, NULL, 'NadA_type1', 237253),
(293528, 'MF_00764', NULL, 'UPF0306 protein YhbP [yhbP].', NULL, NULL, 'UPF0306', 237254),
(293529, 'MF_00828', NULL, 'Photosystem I reaction center subunit XII [psaM].', NULL, NULL, 'PSI_PsaM', 237255),
(293530, 'MF_01243', NULL, 'Formamidase [amiF].', NULL, NULL, 'Formamidase', 237256),
(293531, 'MF_00742', NULL, 'Formyl-CoA:oxalate CoA-transferase [frc].', NULL, NULL, 'Formyl_CoA_transfer', 237257),
(293532, 'MF_00965', NULL, 'ATP-dependent RNA helicase DbpA [dbpA].', NULL, NULL, 'DEAD_helicase_DbpA', 237258),
(293533, 'MF_00413', NULL, 'Sulfur carrier protein TusA [tusA].', NULL, NULL, 'Thiourid_synth_A', 237259);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(293534, 'MF_01360', NULL, 'UPF0367 protein <locus_tag>.', NULL, NULL, 'UPF0367', 237260),
(293535, 'MF_01963', NULL, 'S-methyl-5''-thioadenosine phosphorylase [mtnP].', NULL, NULL, 'MTAP', 237261),
(293536, 'MF_00973', NULL, 'Gluconeogenesis factor.', NULL, NULL, 'Gluconeogen_factor', 237262),
(293537, 'MF_01486', NULL, 'RecBCD enzyme subunit RecC [recC].', NULL, NULL, 'RecC', 237263),
(293538, 'MF_00348', NULL, 'DNA repair and recombination protein RadA [radA].', NULL, NULL, 'RadA_arch', 237264),
(293539, 'MF_01047', NULL, 'UPF0227 protein YcfP [ycfP].', NULL, NULL, 'UPF0227', 237265),
(293540, 'MF_00821', NULL, 'Protein-export protein SecB [secB].', NULL, NULL, 'SecB', 237266),
(293541, 'MF_01246', NULL, 'Chitooligosaccharide deacetylase [chbG].', NULL, NULL, 'COD', 237267),
(293542, 'MF_00073', NULL, 'Transcription antitermination protein NusB [nusB].', NULL, NULL, 'NusB', 237268),
(293543, 'MF_01453', NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B [rexB].', NULL, NULL, 'AddB_type2', 237269),
(293544, 'MF_04087', NULL, 'RING finger protein Z [Z].', NULL, NULL, 'ARENA_Z', 237270),
(293545, 'MF_01946', NULL, 'Tubulin-like protein CetZ [cetZ].', NULL, NULL, 'CetZ', 237271),
(293546, 'MF_01392', NULL, 'Cytochrome c biogenesis protein Ccs1 [ccs1].', NULL, NULL, 'CytC_Ccs1', 237272),
(293547, 'MF_01365_A', NULL, '50S ribosomal protein L6 [rplF].', NULL, NULL, 'Ribosomal_L6_A', 237273),
(293548, 'MF_04151', NULL, 'Pre-baseplate central spike protein Gp5 [5].', NULL, NULL, 'NEEDLE_T4', 237274),
(293549, 'MF_00029', NULL, '30S ribosomal protein S8e [rps8e].', NULL, NULL, 'Ribosomal_S8e', 237275),
(293550, 'MF_00644', NULL, 'Photosystem II reaction center protein Z [psbZ].', NULL, NULL, 'PSII_PsbZ', 237276),
(293551, 'MF_01696', NULL, '1D-myo-inositol 2-acetamido-2-deoxy-alpha-D-glucopyranoside deacetylase [mshB].', NULL, NULL, 'MshB', 237277),
(293552, 'MF_01988', NULL, 'Succinate--CoA ligase [ADP-forming] subunit alpha [sucD].', NULL, NULL, 'Succ_CoA_alpha', 237278),
(293553, 'MF_00248', NULL, 'ATP-dependent protease subunit HslV [hslV].', NULL, NULL, 'HslV', 237279),
(293554, 'MF_01636', NULL, '3-octaprenyl-4-hydroxybenzoate carboxy-lyase [ubiD].', NULL, NULL, 'UbiD', 237280),
(293555, 'MF_00390', NULL, 'Sulfurtransferase TusD [tusD].', NULL, NULL, 'Thiourid_synth_D', 237281),
(293556, 'MF_00643', NULL, 'Cytochrome b559 subunit beta [psbF].', NULL, NULL, 'PSII_PsbF', 237282),
(293557, 'MF_01279', NULL, 'Xaa-Pro dipeptidase [pepQ].', NULL, NULL, 'X_Pro_dipeptid', 237283),
(293558, 'MF_00317', NULL, 'DNA polymerase sliding clamp [pcn].', NULL, NULL, 'DNApol_clamp_arch', 237284),
(293559, 'MF_01108', NULL, 'Acetylornithine deacetylase [argE].', NULL, NULL, 'ArgE', 237285),
(293560, 'MF_01413', NULL, 'Glutathione-regulated potassium-efflux system protein KefC [kefC].', NULL, NULL, 'K_H_efflux_KefC', 237286),
(293561, 'MF_01111', NULL, 'UPF0200 protein <locus_tag>.', NULL, NULL, 'UPF0200', 237287),
(293562, 'MF_00284', NULL, 'Phenylalanine--tRNA ligase beta subunit [pheT].', NULL, NULL, 'Phe_tRNA_synth_beta2', 237288),
(293563, 'MF_01067', NULL, 'UPF0259 membrane protein YciC [yciC].', NULL, NULL, 'UPF0259', 237289),
(293564, 'MF_04078', NULL, 'Protein Nef [nef].', NULL, NULL, 'NEF_HIV', 237290),
(293565, 'MF_00856', NULL, 'RuBisCO accumulation factor 1 [raf1].', NULL, NULL, 'Raf1', 237291),
(293566, 'MF_00421', NULL, 'Phosphoribosylformylglycinamidine synthase subunit PurQ [purQ].', NULL, NULL, 'PurQ', 237292),
(293567, 'MF_01608', NULL, 'Coenzyme A disulfide reductase [cdr].', NULL, NULL, 'CoA_diS_reduct', 237293),
(293568, 'MF_00994', NULL, 'Lipopolysaccharide assembly protein B [lapB].', NULL, NULL, 'LPS_assembly_LapB', 237294),
(293569, 'MF_00900', NULL, 'GTPase HflX [hflX].', NULL, NULL, 'GTPase_HflX', 237295),
(293570, 'MF_03203', NULL, 'Elongation of very long chain fatty acids protein 3 [ELOVL3].', NULL, NULL, 'VLCF_elongase_3', 237296),
(293571, 'MF_01692', NULL, 'N-acetyldiaminopimelate deacetylase.', NULL, NULL, 'DapEL', 237297),
(293572, 'MF_03130', NULL, 'Alpha-tubulin N-acetyltransferase 1 [mec-17].', NULL, NULL, 'mec17', 237298);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(293573, 'MF_03028', NULL, 'Pescadillo homolog [PES1].', NULL, NULL, 'Pescadillo', 237299),
(293574, 'MF_00512', NULL, '30S ribosomal protein S6e [rps6e].', NULL, NULL, 'Ribosomal_S6e', 237300),
(293575, 'MF_00647', NULL, 'Phosphopantetheine adenylyltransferase [coaD].', NULL, NULL, 'PPAT_arch', 237301),
(293576, 'MF_01081', NULL, 'Probable tRNA pseudouridine synthase B [truB].', NULL, NULL, 'TruB_arch', 237302),
(293577, 'MF_00234', NULL, 'Adenylate kinase [adkA].', NULL, NULL, 'Adenylate_kinase_AdkA', 237303),
(293578, 'MF_02239', NULL, 'Protoporphyrinogen IX oxidase.', NULL, NULL, 'HemJ', 237304),
(293579, 'MF_00521', NULL, '3-deoxy-D-manno-octulosonic acid kinase [kdkA].', NULL, NULL, 'KDO_kinase', 237305),
(293580, 'MF_00314', NULL, 'V-type ATP synthase subunit C [atpC].', NULL, NULL, 'ATP_synth_C_arch', 237306),
(293581, 'MF_00696', NULL, 'Fatty acid metabolism regulator protein [fadR].', NULL, NULL, 'HTH_FadR', 237307),
(293582, 'MF_00753', NULL, 'Anaerobic glycerol-3-phosphate dehydrogenase subunit B [glpB].', NULL, NULL, 'Glycerol3P_GlpB', 237308),
(293583, 'MF_00804', NULL, 'Betaine aldehyde dehydrogenase [betB].', NULL, NULL, 'BADH', 237309),
(293584, 'MF_00611', NULL, 'Protein FdhE [fdhE].', NULL, NULL, 'FdeH', 237310),
(293585, 'MF_00114', NULL, 'Deoxyribose-phosphate aldolase [deoC].', NULL, NULL, 'DeoC_type1', 237311),
(293586, 'MF_04012', NULL, 'Portal protein.', NULL, NULL, 'HSV_PORTL', 237312),
(293587, 'MF_01579', NULL, 'Ribosomal RNA small subunit methyltransferase F [rsmF].', NULL, NULL, '16SrRNA_methyltr_F', 237313),
(293588, 'MF_02247', NULL, 'Carboxylic acid reductase [car].', NULL, NULL, 'Carbox_acid_reduct', 237314),
(293589, 'MF_04029', NULL, 'Thymidine kinase [TK].', NULL, NULL, 'HSV_KITH', 237315),
(293590, 'MF_00938', NULL, 'DNA topoisomerase 4 subunit B [parE].', NULL, NULL, 'ParE_type1', 237316),
(293591, 'MF_04105', NULL, 'Antiholin.', NULL, NULL, 'ANTIH_T4', 237317),
(293592, 'MF_02084', NULL, '[LysW]-aminoadipate semialdehyde/glutamate semialdehyde transaminase [lysJ].', NULL, NULL, 'LysJ_aminotrans_3', 237318),
(293593, 'MF_00934', NULL, 'Ribosomal RNA large subunit methyltransferase J [rlmJ].', NULL, NULL, '23SrRNA_methyltr_J', 237319),
(293594, 'MF_00812', NULL, 'Thiopurine S-methyltransferase [tpm].', NULL, NULL, 'Thiopur_methtran', 237320),
(293595, 'MF_00163', NULL, 'Peptide deformylase [def].', NULL, NULL, 'Pep_deformylase', 237321),
(293596, 'MF_01871', NULL, 'Probable inorganic carbon transporter subunit DabA [dabA].', NULL, NULL, 'DabA', 237322),
(293597, 'MF_01276', NULL, 'Putrescine aminotransferase [patA].', NULL, NULL, 'Putres_aminotrans_3', 237323),
(293598, 'MF_02203', NULL, 'Tol-Pal system protein TolR [tolR].', NULL, NULL, 'TolR', 237324),
(293599, 'MF_01179', NULL, 'Cell division inhibitor SulA [sulA].', NULL, NULL, 'SulA', 237325),
(293600, 'MF_01318_B', NULL, '50S ribosomal protein L1 [rplA].', NULL, NULL, 'Ribosomal_L1_B', 237326),
(293601, 'MF_01140', NULL, 'Polyisoprenyl-teichoic acid--peptidoglycan teichoic acid transferase TagU [tagU].', NULL, NULL, 'TagU_transferase', 237327),
(293602, 'MF_00305', NULL, 'Signal recognition particle 19 kDa protein [srp19].', NULL, NULL, 'SRP19', 237328),
(293603, 'MF_00372', NULL, 'Imidazolonepropionase [hutI].', NULL, NULL, 'HutI', 237329),
(293604, 'MF_00673', NULL, 'UPF0254 protein <locus_tag>.', NULL, NULL, 'UPF0254', 237330),
(293605, 'MF_03066', NULL, 'E3 ubiquitin-protein ligase RNF168 [RNF168].', NULL, NULL, 'RNF168', 237331),
(293606, 'MF_00128', NULL, 'Protein NrdI [nrdI].', NULL, NULL, 'NrdI', 237332),
(293607, 'MF_00451', NULL, 'Nucleoside diphosphate kinase [ndk].', NULL, NULL, 'NDP_kinase', 237333),
(293608, 'MF_01879', NULL, 'Dipeptide and tripeptide permease B [dtpB].', NULL, NULL, 'PTR2_DtpB_subfam', 237334),
(293609, 'MF_01926', NULL, 'Phosphoribosylformylglycinamidine synthase subunit PurS [purS].', NULL, NULL, 'PurS', 237335),
(293610, 'MF_01224_A', NULL, 'Cyclic pyranopterin monophosphate synthase [moaC].', NULL, NULL, 'MoaC_A', 237336),
(293611, 'MF_00091', NULL, 'S-ribosylhomocysteine lyase [luxS].', NULL, NULL, 'LuxS', 237337);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(293612, 'MF_00107', NULL, '2-C-methyl-D-erythritol 2,4-cyclodiphosphate synthase [ispF].', NULL, NULL, 'IspF', 237338),
(293613, 'MF_00596', NULL, 'GMP reductase [guaC].', NULL, NULL, 'GMP_reduct_type1', 237339),
(293614, 'MF_00758', NULL, 'UPF0301 protein YqgE [yqgE].', NULL, NULL, 'UPF0301', 237340),
(293615, 'MF_00333', NULL, 'Oxygen-dependent coproporphyrinogen-III oxidase [hemF].', NULL, NULL, 'Coprogen_oxidas', 237341),
(293616, 'MF_00480_A', NULL, '30S ribosomal protein S7 [rpsG].', NULL, NULL, 'Ribosomal_S7_A', 237342),
(293617, 'MF_01633', NULL, '7-cyano-7-deazaguanine synthase [queC].', NULL, NULL, 'QueC', 237343),
(293618, 'MF_02003', NULL, 'Isoleucine--tRNA ligase [ileS].', NULL, NULL, 'Ile_tRNA_synth_type2', 237344),
(293619, 'MF_00134_B', NULL, 'Indole-3-glycerol phosphate synthase [trpC].', NULL, NULL, 'IGPS_B', 237345),
(293620, 'MF_00581', NULL, 'Argininosuccinate synthase [argG].', NULL, NULL, 'Arg_succ_synth_type2', 237346),
(293621, 'MF_01268', NULL, 'Bifunctional enzyme Fae/Hps [fae-hps].', NULL, NULL, 'Fae_Hps', 237347),
(293622, 'MF_00236', NULL, 'Sec-independent protein translocase protein TatA [tatA].', NULL, NULL, 'TatA_E', 237348),
(293623, 'MF_00543', NULL, 'Tyrosine phenol-lyase [tpl].', NULL, NULL, 'Tyr_phenol_lyase', 237349),
(293624, 'MF_01558', NULL, 'Cytidine deaminase [cdd].', NULL, NULL, 'Cyt_deam', 237350),
(293625, 'MF_04147', NULL, 'Terminase, large subunit.', NULL, NULL, 'TERL_T7', 237351),
(293626, 'MF_00534', NULL, 'Asparagine--tRNA ligase [asnS].', NULL, NULL, 'Asn_tRNA_synth', 237352),
(293627, 'MF_04095', NULL, 'Nucleoprotein [N].', NULL, NULL, 'ALPHA_CORONA_NCAP', 237353),
(293628, 'MF_01345_A', NULL, '30S ribosomal protein S17 [rpsQ].', NULL, NULL, 'Ribosomal_S17_A', 237354),
(293629, 'MF_01227', NULL, 'CTP synthase [pyrG].', NULL, NULL, 'PyrG', 237355),
(293630, 'MF_04139', NULL, 'NAD(+)--arginine ADP-ribosyltransferase [alt].', NULL, NULL, 'ALT_T4', 237356),
(293631, 'MF_00291_A', NULL, '30S ribosomal protein S2 [rpsB].', NULL, NULL, 'Ribosomal_S2_A', 237357),
(293632, 'MF_04021', NULL, 'Small capsomere-interacting protein [SCP].', NULL, NULL, 'HSV_SCP_betahv', 237358),
(293633, 'MF_03151', NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit F, mitochondrial [GTF1].', NULL, NULL, 'GatF', 237359),
(293634, 'MF_00841', NULL, 'Glucosyltransferase 3 [gtf3].', NULL, NULL, 'Gtf3', 237360),
(293635, 'MF_00967', NULL, 'ATP-dependent RNA helicase SrmB [srmB].', NULL, NULL, 'DEAD_helicase_SrmB', 237361),
(293636, 'MF_01252', NULL, 'Flavohemoprotein [hmp].', NULL, NULL, 'Hmp', 237362),
(293637, 'MF_02078', NULL, 'Probable lipid II flippase MurJ [murJ].', NULL, NULL, 'MurJ_MviN', 237363),
(293638, 'MF_00001', NULL, 'Aspartate carbamoyltransferase [pyrB].', NULL, NULL, 'Asp_carb_tr', 237364),
(293639, 'MF_01548', NULL, 'UPF0354 protein <locus_tag>.', NULL, NULL, 'UPF0354', 237365),
(293640, 'MF_00658', NULL, 'Ribosomal RNA large subunit methyltransferase H [rlmH].', NULL, NULL, '23SrRNA_methyltr_H', 237366),
(293641, 'MF_00671', NULL, 'Tol-Pal system protein TolB [tolB].', NULL, NULL, 'TolB', 237367),
(293642, 'MF_02044', NULL, 'DNA double-strand break repair protein Mre11 [mre11].', NULL, NULL, 'Mre11', 237368),
(293643, 'MF_00238', NULL, 'Cytidylate kinase [cmk].', NULL, NULL, 'Cytidyl_kinase_type1', 237369),
(293644, 'MF_01588', NULL, 'DNA ligase [ligA].', NULL, NULL, 'DNA_ligase_A', 237370),
(293645, 'MF_02207', NULL, 'Cell shape-determining protein MreB [mreB].', NULL, NULL, 'MreB', 237371),
(293646, 'MF_01479', NULL, 'Transcriptional regulator WhiB [whiB].', NULL, NULL, 'WhiB', 237372),
(293647, 'MF_02027', NULL, 'dTDP-fucosamine acetyltransferase [wecD].', NULL, NULL, 'WecD_RffC', 237373),
(293648, 'MF_01914', NULL, 'Lipopolysaccharide export system protein LptA [lptA].', NULL, NULL, 'LPS_assembly_LptA', 237374),
(293649, 'MF_01248', NULL, 'Glycogen debranching enzyme [glgX].', NULL, NULL, 'GlgX', 237375),
(293650, 'MF_00045', NULL, 'Oligoribonuclease [orn].', NULL, NULL, 'Oligoribonuclease', 237376),
(293651, 'MF_02001', NULL, 'Small heat shock protein IbpB [ibpB].', NULL, NULL, 'HSP20_IbpB', 237377);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(293652, 'MF_03109', NULL, 'Protein SEY1 [SEY1].', NULL, NULL, 'Sey1', 237378),
(293653, 'MF_01167', NULL, 'UDP-4-amino-4-deoxy-L-arabinose--oxoglutarate aminotransferase [arnB].', NULL, NULL, 'ArnB_transfer', 237379),
(293654, 'MF_00731', NULL, '2-succinylbenzoate--CoA ligase [menE].', NULL, NULL, 'MenE', 237380),
(293655, 'MF_00825', NULL, '3-hydroxyanthranilate 3,4-dioxygenase [nbaC].', NULL, NULL, '3_HAO', 237381),
(293656, 'MF_00990', NULL, 'L-2-hydroxyglutarate dehydrogenase [lhgD].', NULL, NULL, 'L_hydroxyglutarate_dehydrogenase', 237382),
(293657, 'MF_01338', NULL, 'Ribulose bisphosphate carboxylase large chain [rbcL].', NULL, NULL, 'RuBisCO_L_type1', 237383),
(293658, 'MF_02049', NULL, 'Nucleoside permease NupG [nupG].', NULL, NULL, 'NupG', 237384),
(293659, 'MF_04129', NULL, 'Intermediate capsid protein VP6.', NULL, NULL, 'Rota_VP6_A', 237385),
(293660, 'MF_01299', NULL, 'Oxaloacetate decarboxylase.', NULL, NULL, 'OadC', 237386),
(293661, 'MF_00560', NULL, 'Trans-aconitate 2-methyltransferase [tam].', NULL, NULL, 'Tran_acon_Me_trans', 237387),
(293662, 'MF_03101', NULL, 'Deoxyhypusine hydroxylase [DOHH].', NULL, NULL, 'Deoxyhypusine_hydroxylase', 237388),
(293663, 'MF_00707', NULL, 'UPF0735 ACT domain-containing protein <locus_tag>.', NULL, NULL, 'UPF0735', 237389),
(293664, 'MF_03005', NULL, 'Eukaryotic translation initiation factor 3 subunit F [EIF3F].', NULL, NULL, 'eIF3f', 237390),
(293665, 'MF_01442', NULL, 'Coproheme decarboxylase [chdC].', NULL, NULL, 'Coproheme_decarbox_1', 237391),
(293666, 'MF_01384', NULL, 'Urease accessory protein UreD [ureD].', NULL, NULL, 'UreD', 237392),
(293667, 'MF_00005', NULL, 'Argininosuccinate synthase [argG].', NULL, NULL, 'Arg_succ_synth_type1', 237393),
(293668, 'MF_00252', NULL, 'Lysine--tRNA ligase [lysS].', NULL, NULL, 'Lys_tRNA_synth_class2', 237394),
(293669, 'MF_00077', NULL, 'tRNA (cytidine(56)-2''-O)-methyltransferase.', NULL, NULL, 'tRNA_methyltr_aTrm56', 237395),
(293670, 'MF_02127', NULL, 'Glucose 1-dehydrogenase [gdh].', NULL, NULL, 'Glucose_DH', 237396),
(293671, 'MF_02029', NULL, 'UDP-N-acetyl-D-mannosamine dehydrogenase [wecC].', NULL, NULL, 'WecC_RffD', 237397),
(293672, 'MF_02058', NULL, 'Choline trimethylamine-lyase [cutC].', NULL, NULL, 'Choline_CutC', 237398),
(293673, 'MF_03126', NULL, 'Adenylosuccinate synthetase isozyme 1 [ADSSL1].', NULL, NULL, 'Adenylosucc_synth_vert_basic', 237399),
(293674, 'MF_00799', NULL, 'UPF0336 protein <locus_tag>.', NULL, NULL, 'UPF0336', 237400),
(293675, 'MF_04004', NULL, 'Protein E7 [E7].', NULL, NULL, 'PPV_E7', 237401),
(293676, 'MF_00827', NULL, 'UPF0386 protein YjhX [yjhX].', NULL, NULL, 'UPF0386', 237402),
(293677, 'MF_02083', NULL, '[LysW]-L-2-aminoadipate/[LysW]-L-glutamate phosphate reductase [lysY].', NULL, NULL, 'LysY', 237403),
(293678, 'MF_01126', NULL, 'UPF0298 protein <locus_tag>.', NULL, NULL, 'UPF0298', 237404),
(293679, 'MF_01175', NULL, 'tRNA-modifying protein YgfZ [ygfZ].', NULL, NULL, 'tRNA_modifying_YgfZ', 237405),
(293680, 'MF_03134', NULL, 'Probable alanine--tRNA ligase, chloroplastic.', NULL, NULL, 'Ala_tRNA_synth_plantC', 237406),
(293681, 'MF_01575', NULL, 'UPF0398 protein <locus_tag>.', NULL, NULL, 'UPF0398', 237407),
(293682, 'MF_02200', NULL, 'Chaperone NapD [napD].', NULL, NULL, 'NapD', 237408),
(293683, 'MF_01572', NULL, 'UPF0397 protein <locus_tag>.', NULL, NULL, 'UPF0397', 237409),
(293684, 'MF_03012', NULL, 'COP9/Signalosome and eIF3 complex-shared subunit 1 [EIF3M].', NULL, NULL, 'eIF3m', 237410),
(293685, 'MF_01223', NULL, 'UPF0212 protein <locus_tag>.', NULL, NULL, 'UPF0212', 237411),
(293686, 'MF_00341', NULL, 'UPF0146 protein <locus_tag>.', NULL, NULL, 'UPF0146', 237412),
(293687, 'MF_00663', NULL, 'Phosphatidylserine decarboxylase proenzyme [psd].', NULL, NULL, 'PS_decarb_PSD_B_type2', 237413),
(293688, 'MF_00795', NULL, 'Copper homeostasis protein CutC [cutC].', NULL, NULL, 'CutC', 237414),
(293689, 'MF_01481', NULL, 'Photosystem II lipoprotein Psb27 [psb27].', NULL, NULL, 'PSII_Psb27', 237415),
(293690, 'MF_00205', NULL, 'UvrABC system protein A [uvrA].', NULL, NULL, 'UvrA', 237416);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(293691, 'MF_00217', NULL, 'Mevalonate kinase [mvk].', NULL, NULL, 'Mevalonate_kinase', 237417),
(293692, 'MF_01139', NULL, 'Ditrans,polycis-undecaprenyl-diphosphate synthase ((2E,6E)-farnesyl-diphosphate specific) [uppS].', NULL, NULL, 'ISPT', 237418),
(293693, 'MF_01432', NULL, 'Non-specific ribonucleoside hydrolase RihC [rihC].', NULL, NULL, 'Nucleosid_hydro_RihC', 237419),
(293694, 'MF_03063', NULL, 'Elongation factor G, chloroplastic.', NULL, NULL, 'EF_G_plantC', 237420),
(293695, 'MF_01426', NULL, 'Cation/acetate symporter ActP [actP].', NULL, NULL, 'Acet_symport_ActP', 237421),
(293696, 'MF_01288', NULL, 'L-rhamnonate dehydratase [rhmD].', NULL, NULL, 'Rhamnon_dehydrat', 237422),
(293697, 'MF_01570', NULL, 'Proline--tRNA ligase [proS].', NULL, NULL, 'Pro_tRNA_synth_type2', 237423),
(293698, 'MF_01969', NULL, 'Kynurenine formamidase [kynB].', NULL, NULL, 'KynB', 237424),
(293699, 'MF_04068', NULL, 'Matrix protein 1 [M].', NULL, NULL, 'INFV_M1', 237425),
(293700, 'MF_00805', NULL, 'Citrate lyase acyl carrier protein [citD].', NULL, NULL, 'CitD', 237426),
(293701, 'MF_02060', NULL, 'tRNA (guanosine(18)-2''-O)-methyltransferase [trmH].', NULL, NULL, 'tRNA_methyltr_TrmH', 237427),
(293702, 'MF_01361', NULL, 'UPF0391 membrane protein YtjA [ytjA].', NULL, NULL, 'UPF0391', 237428),
(293703, 'MF_00713', NULL, 'Probable glycine dehydrogenase (decarboxylating) subunit 2 [gcvPB].', NULL, NULL, 'GcvPB', 237429),
(293704, 'MF_01630', NULL, 'Periplasmic nitrate reductase [napA].', NULL, NULL, 'Nitrate_reduct_NapA', 237430),
(293705, 'MF_02102', NULL, 'Putrescine carbamoyltransferase [ptcA].', NULL, NULL, 'PTCase', 237431),
(293706, 'MF_01611', NULL, '7,8-didemethyl-8-hydroxy-5-deazariboflavin synthase [cofG].', NULL, NULL, 'FO_synth_sub1', 237432),
(293707, 'MF_03040', NULL, 'U6 snRNA phosphodiesterase [USB1].', NULL, NULL, 'USB1', 237433),
(293708, 'MF_04049', NULL, 'Pre-hexon-linking protein VIII [L4].', NULL, NULL, 'ADV_CAP8', 237434),
(293709, 'MF_04149', NULL, 'RNA ligase 1.', NULL, NULL, 'RNALIG_T4', 237435),
(293710, 'MF_01561', NULL, 'Probable phosphatase YcdX [ycdX].', NULL, NULL, 'YcdX_phosphat', 237436),
(293711, 'MF_01881', NULL, 'Propionate kinase [tdcD].', NULL, NULL, 'Propion_kin_subfam1', 237437),
(293712, 'MF_01595', NULL, 'Polyribonucleotide nucleotidyltransferase [pnp].', NULL, NULL, 'PNPase', 237438),
(293713, 'MF_01348', NULL, 'Ycf48-like protein [hcf136].', NULL, NULL, 'Ycf48', 237439),
(293714, 'MF_00547', NULL, '50S ribosomal protein L37e [rpl37e].', NULL, NULL, 'Ribosomal_L37e', 237440),
(293715, 'MF_00551', NULL, 'Uridine kinase [udk].', NULL, NULL, 'Uridine_kinase', 237441),
(293716, 'MF_00705', NULL, 'IMP cyclohydrolase [purO].', NULL, NULL, 'IMP_cyclohydrol', 237442),
(293717, 'MF_00771', NULL, 'UPF0310 protein <locus_tag>.', NULL, NULL, 'UPF0310', 237443),
(293718, 'MF_01206', NULL, 'Protein-methionine-sulfoxide reductase catalytic subunit MsrP [msrP].', NULL, NULL, 'MsrP', 237444),
(293719, 'MF_00953', NULL, 'DNA topoisomerase 3 [topB].', NULL, NULL, 'Topoisom_3_prok', 237445),
(293720, 'MF_02211', NULL, 'Murein peptide amidase A [mpaA].', NULL, NULL, 'MpaA_carboxypeptidase', 237446),
(293721, 'MF_00271', NULL, 'V-type ATP synthase subunit D [atpD].', NULL, NULL, 'ATP_synth_D_arch', 237447),
(293722, 'MF_03059', NULL, 'Ribosome-releasing factor 2, mitochondrial [GFM2].', NULL, NULL, 'mEF_G_2', 237448),
(293723, 'MF_01581', NULL, 'UPF0482 protein YnfB [ynfB].', NULL, NULL, 'UPF0482', 237449),
(293724, 'MF_00178', NULL, '6,7-dimethyl-8-ribityllumazine synthase [ribH].', NULL, NULL, 'Lumazine_synth', 237450),
(293725, 'MF_00332', NULL, 'Chaperone protein DnaK [dnaK].', NULL, NULL, 'DnaK', 237451),
(293726, 'MF_01973', NULL, 'Lon protease [lon].', NULL, NULL, 'lon_bact', 237452),
(293727, 'MF_03002', NULL, 'Eukaryotic translation initiation factor 3 subunit C [EIF3C].', NULL, NULL, 'eIF3c', 237453),
(293728, 'MF_04062', NULL, 'Polymerase basic protein 2 [PB2].', NULL, NULL, 'INV_PB2', 237454),
(293729, 'MF_01060', NULL, 'Periplasmic trehalase [treA].', NULL, NULL, 'Peripl_trehalase', 237455);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(293730, 'MF_03102', NULL, 'Mitochondrial distribution and morphology protein 10 [MDM10].', NULL, NULL, 'Mdm10', 237456),
(293731, 'MF_00139', NULL, 'Bifunctional purine biosynthesis protein PurH [purH].', NULL, NULL, 'PurH', 237457),
(293732, 'MF_00681', NULL, '(5-formylfuran-3-yl)methyl phosphate synthase [mfnB].', NULL, NULL, 'MfnB', 237458),
(293733, 'MF_00056', NULL, '2-dehydro-3-deoxyphosphooctonate aldolase [kdsA].', NULL, NULL, 'KDO8P_synth', 237459),
(293734, 'MF_01593', NULL, 'Protein MtfA [mtfA].', NULL, NULL, 'MtfA', 237460),
(293735, 'MF_00052_B', NULL, 'Ribonuclease HII [rnhB].', NULL, NULL, 'RNase_HII_B', 237461),
(293736, 'MF_02219', NULL, 'Type 3 secretion system secretin [sctC].', NULL, NULL, 'Type_III_secretin', 237462),
(293737, 'MF_04090', NULL, 'Non-structural protein 3.', NULL, NULL, 'ROTA_NSP3', 237463),
(293738, 'MF_00349', NULL, '50S ribosomal protein L34e [rpl34e].', NULL, NULL, 'Ribosomal_L34e', 237464),
(293739, 'MF_00526', NULL, 'Glutamate mutase sigma subunit [glmS].', NULL, NULL, 'Me_Asp_mutase_S', 237465),
(293740, 'MF_00105', NULL, 'Transcription elongation factor GreA [greA].', NULL, NULL, 'GreA_GreB', 237466),
(293741, 'MF_00555', NULL, 'Aspartate--ammonia ligase [asnA].', NULL, NULL, 'AsnA', 237467),
(293742, 'MF_00540', NULL, 'Adenosine deaminase [add].', NULL, NULL, 'A_deaminase', 237468),
(293743, 'MF_00719', NULL, 'Adenosylcobinamide-GDP ribazoletransferase [cobS].', NULL, NULL, 'CobS', 237469),
(293744, 'MF_01409', NULL, 'UPF0219 protein <locus_tag>.', NULL, NULL, 'UPF0219', 237470),
(293745, 'MF_00532_B', NULL, '30S ribosomal protein S9 [rpsI].', NULL, NULL, 'Ribosomal_S9_B', 237471),
(293746, 'MF_01825', NULL, 'Erythronate-4-phosphate dehydrogenase [pdxB].', NULL, NULL, 'PdxB', 237472),
(293747, 'MF_01502', NULL, 'UPF0295 protein <locus_tag>.', NULL, NULL, 'UPF0295', 237473),
(293748, 'MF_00057', NULL, '8-amino-3,8-dideoxy-manno-octulosonate cytidylyltransferase [kdsB].', NULL, NULL, 'KdsB', 237474),
(293749, 'MF_00639', NULL, 'UDP-N-acetylmuramoylalanine--D-glutamate ligase [murD].', NULL, NULL, 'MurD', 237475),
(293750, 'MF_00981', NULL, 'Transcriptional regulatory protein RcsB [rcsB].', NULL, NULL, 'RcsB', 237476),
(293751, 'MF_00030', NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase [dgt].', NULL, NULL, 'dGTPase_type1', 237477),
(293752, 'MF_00446', NULL, 'Aspartate 1-decarboxylase [panD].', NULL, NULL, 'PanD', 237478),
(293753, 'MF_00486', NULL, 'Methenyltetrahydromethanopterin cyclohydrolase [mch].', NULL, NULL, 'McH', 237479),
(293754, 'MF_00244', NULL, 'Probable nicotinate-nucleotide adenylyltransferase [nadD].', NULL, NULL, 'NaMN_adenylyltr', 237480),
(293755, 'MF_01463_A', NULL, 'Protein translocase subunit SecD [secD].', NULL, NULL, 'SecD_A', 237481),
(293756, 'MF_02216', NULL, 'Ubiquinone biosynthesis accessory factor UbiK [ubiK].', NULL, NULL, 'UbiK', 237482),
(293757, 'MF_01097', NULL, 'Tetrahydromethanopterin S-methyltransferase subunit D [mtrD].', NULL, NULL, 'MtrD', 237483),
(293758, 'MF_01443', NULL, 'Bis(5''-nucleosyl)-tetraphosphatase PrpE [asymmetrical] [prpE].', NULL, NULL, 'PrpE', 237484),
(293759, 'MF_01346', NULL, 'ATP synthase subunit alpha [atpA].', NULL, NULL, 'ATP_synth_alpha_bact', 237485),
(293760, 'MF_00607', NULL, 'Ribosomal RNA small subunit methyltransferase A [rsmA].', NULL, NULL, '16SrRNA_methyltr_A', 237486),
(293761, 'MF_01012', NULL, '23S rRNA (uracil(747)-C(5))-methyltransferase RlmC [rlmC].', NULL, NULL, '23SrRNA_methyltr_RlmC', 237487),
(293762, 'MF_01052', NULL, 'Crotonobetainyl-CoA reductase [caiA].', NULL, NULL, 'CaiA', 237488),
(293763, 'MF_00394', NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(P)+] [gpsA].', NULL, NULL, 'NAD_Glyc3P_dehydrog', 237489),
(293764, 'MF_00063', NULL, 'Adenosine 5''-phosphosulfate reductase [cysH].', NULL, NULL, 'CysH', 237490),
(293765, 'MF_01591', NULL, 'Protein Ves [ves].', NULL, NULL, 'Ves', 237491),
(293766, 'MF_00601', NULL, 'Ethanolamine ammonia-lyase small subunit [eutC].', NULL, NULL, 'EutC', 237492),
(293767, 'MF_01525', NULL, 'Carnitine operon protein CaiE [caiE].', NULL, NULL, 'CaiE', 237493);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(293768, 'MF_00233', NULL, 'Outer-membrane lipoprotein LolB [lolB].', NULL, NULL, 'LolB', 237494),
(293769, 'MF_00256', NULL, '50S ribosomal protein L15e [rpl15e].', NULL, NULL, 'Ribosomal_L15e', 237495),
(293770, 'MF_01473', NULL, 'UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase stabilizing protein GtfB [gtfB].', NULL, NULL, 'GtfB', 237496),
(293771, 'MF_00664', NULL, 'Phosphatidylserine decarboxylase proenzyme [psd].', NULL, NULL, 'PS_decarb_PSD_A', 237497),
(293772, 'MF_02204', NULL, 'Peptidoglycan-associated lipoprotein [pal].', NULL, NULL, 'Pal', 237498),
(293773, 'MF_01839', NULL, 'Nucleoid occlusion factor SlmA [slmA].', NULL, NULL, 'NO_factor_SlmA', 237499),
(293774, 'MF_01654', NULL, '2-hydroxy-6-oxononadienedioate/2-hydroxy-6-oxononatrienedioate hydrolase [mhpC].', NULL, NULL, 'MhpC', 237500),
(293775, 'MF_00817', NULL, 'NADPH-dependent 7-cyano-7-deazaguanine reductase [queF].', NULL, NULL, 'QueF_type2', 237501),
(293776, 'MF_00599', NULL, 'Cell division protein FtsB [ftsB].', NULL, NULL, 'FtsB', 237502),
(293777, 'MF_01333_B', NULL, '50S ribosomal protein L5 [rplE].', NULL, NULL, 'Ribosomal_L5_B', 237503),
(293778, 'MF_01520', NULL, 'Bifunctional enzyme IspD/IspF [ispDF].', NULL, NULL, 'IspDF', 237504),
(293779, 'MF_00977', NULL, '3''-5'' exoribonuclease.', NULL, NULL, '3_5_Exoribonuc_actinobact', 237505),
(293780, 'MF_01011', NULL, 'tRNA/tmRNA (uracil-C(5))-methyltransferase [trmA].', NULL, NULL, 'RNA_methyltr_TrmA', 237506),
(293781, 'MF_01464_A', NULL, 'Protein-export membrane protein SecF [secF].', NULL, NULL, 'SecF_A', 237507),
(293782, 'MF_00395', NULL, 'Cytochrome b6-f complex subunit 8 [petN].', NULL, NULL, 'Cytb6_f_PetN', 237508),
(293783, 'MF_04137', NULL, 'Spanin, inner membrane subunit.', NULL, NULL, 'I_SPANIN_LAMBDA', 237509),
(293784, 'MF_00158', NULL, 'Pantothenate synthetase [panC].', NULL, NULL, 'PanC', 237510),
(293785, 'MF_00289_A', NULL, 'Proteasome subunit alpha [prcA].', NULL, NULL, 'Proteasome_A_A', 237511),
(293786, 'MF_00775', NULL, 'UPF0311 protein <locus_tag>.', NULL, NULL, 'UPF0311', 237512),
(293787, 'MF_00718', NULL, 'Tautomerase PptA [pptA].', NULL, NULL, 'Tautomerase_PptA', 237513),
(293788, 'MF_02025', NULL, 'ECA polysaccharide chain length modulation protein [wzzE].', NULL, NULL, 'WzzE', 237514),
(293789, 'MF_02241', NULL, 'Phosphatidylinositol phosphate synthase.', NULL, NULL, 'PIP_synthase', 237515),
(293790, 'MF_00865', NULL, 'DNA-directed RNA polymerase subunit Rpo7 [rpo7].', NULL, NULL, 'RNApol_arch_Rpo7', 237516),
(293791, 'MF_01629', NULL, 'Pyridoxine/pyridoxamine 5''-phosphate oxidase [pdxH].', NULL, NULL, 'PdxH', 237517),
(293792, 'MF_02111', NULL, 'Pup--protein ligase [pafA].', NULL, NULL, 'Pup_ligase', 237518),
(293793, 'MF_04093', NULL, 'Non-structural protein 6.', NULL, NULL, 'ROTA_NSP6', 237519),
(293794, 'MF_00701', NULL, 'DNA primase large subunit PriL [priL].', NULL, NULL, 'DNA_primase_lrg_arc', 237520),
(293795, 'MF_01400', NULL, 'Peptide methionine sulfoxide reductase MsrB [msrB].', NULL, NULL, 'MsrB', 237521),
(293796, 'MF_01032', NULL, 'Methanogen homoaconitase small subunit [hacB].', NULL, NULL, 'LeuD_type2', 237522),
(293797, 'MF_04132', NULL, 'Outer capsid protein VP4.', NULL, NULL, 'Rota_A_VP4', 237523),
(293798, 'MF_00559', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase [gap].', NULL, NULL, 'G3P_dehdrog_arch', 237524),
(293799, 'MF_00225', NULL, 'Dihydroorotate dehydrogenase (quinone) [pyrD].', NULL, NULL, 'DHO_dh_type2', 237525),
(293800, 'MF_02040', NULL, 'Iron-sulfur cluster carrier protein.', NULL, NULL, 'Mrp_NBP35', 237526),
(293801, 'MF_00733', NULL, '1-pyrroline-5-carboxylate dehydrogenase [rocA].', NULL, NULL, 'RocA', 237527),
(293802, 'MF_01180', NULL, 'Flagellar protein FliT [fliT].', NULL, NULL, 'FliT', 237528),
(293803, 'MF_00803', NULL, 'Ribosome biogenesis protein Nop10 [nop10].', NULL, NULL, 'Nop10', 237529),
(293804, 'MF_00098', NULL, 'Methionine--tRNA ligase [metG].', NULL, NULL, 'Met_tRNA_synth_type1', 237530),
(293805, 'MF_00484', NULL, 'Glycogen synthase [glgA].', NULL, NULL, 'Glycogen_synth', 237531);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(293806, 'MF_01331_A', NULL, '50S ribosomal protein L22 [rplV].', NULL, NULL, 'Ribosomal_L22_A', 237532),
(293807, 'MF_02243', NULL, 'Tagaturonate/fructuronate epimerase [uxaE].', NULL, NULL, 'UxaE', 237533),
(293808, 'MF_00048', NULL, 'UPF0102 protein YraN [yraN].', NULL, NULL, 'UPF0102', 237534),
(293809, 'MF_00120', NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit A [gatA].', NULL, NULL, 'GatA', 237535),
(293810, 'MF_03045', NULL, 'DIS3-like exonuclease 2 [DIS3L2].', NULL, NULL, 'DIS3L2', 237536),
(293811, 'MF_01193', NULL, 'Endoribonuclease SymE [symE].', NULL, NULL, 'Endoribonucl_SymE', 237537),
(293812, 'MF_01614', NULL, 'NADPH dehydrogenase [namA].', NULL, NULL, 'NamA', 237538),
(293813, 'MF_00490', NULL, '2-phosphosulfolactate phosphatase [comB].', NULL, NULL, 'ComB', 237539),
(293814, 'MF_01237', NULL, 'N-acetylneuraminate lyase [nanA].', NULL, NULL, 'N_acetylneuram_lyase', 237540),
(293815, 'MF_01597', NULL, 'Spermidine export protein MdtI [mdtI].', NULL, NULL, 'MdtI', 237541),
(293816, 'MF_04019', NULL, 'Triplex capsid protein 2 [TRX2].', NULL, NULL, 'HSV_TRX2', 237542),
(293817, 'MF_03056', NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit <gene_name> [WDR4].', NULL, NULL, 'TRM82', 237543),
(293818, 'MF_00583_A', NULL, 'Putative ribose-phosphate pyrophosphokinase [prs].', NULL, NULL, 'RibP_PPkinase_A', 237544),
(293819, 'MF_01424', NULL, 'Multidrug resistance protein MdtC [mdtC].', NULL, NULL, 'MdtC', 237545),
(293820, 'MF_00580', NULL, 'Co-chaperonin GroES [groES].', NULL, NULL, 'CH10', 237546),
(293821, 'MF_00151', NULL, 'Phosphopantetheine adenylyltransferase [coaD].', NULL, NULL, 'PPAT_bact', 237547),
(293822, 'MF_00597', NULL, 'Probable acetoacetate decarboxylase [adc].', NULL, NULL, 'ADC', 237548),
(293823, 'MF_00917', NULL, '7-carboxy-7-deazaguanine synthase [queE].', NULL, NULL, 'QueE', 237549),
(293824, 'MF_01540', NULL, 'Sulfite reductase [NADPH] hemoprotein beta-component [cysI].', NULL, NULL, 'CysI', 237550),
(293825, 'MF_00404', NULL, 'Probable oxaloacetate decarboxylase gamma chain [oadG].', NULL, NULL, 'OadG', 237551),
(293826, 'MF_01903', NULL, 'Xanthine-guanine phosphoribosyltransferase [gpt].', NULL, NULL, 'XGPRT', 237552),
(293827, 'MF_00945_B', NULL, 'Transcription termination/antitermination protein NusA [nusA].', NULL, NULL, 'NusA_B', 237553),
(293828, 'MF_02042', NULL, 'tRNA-dihydrouridine synthase B [dusB].', NULL, NULL, 'DusB_subfam', 237554),
(293829, 'MF_02069', NULL, 'Ribulose-5-phosphate reductase [tarJ].', NULL, NULL, 'TarJ', 237555),
(293830, 'MF_02063', NULL, 'Proton/glutamate-aspartate symporter [gltP].', NULL, NULL, 'GltP_subfam', 237556),
(293831, 'MF_00920', NULL, 'Signal recognition particle receptor FtsY [ftsY].', NULL, NULL, 'FtsY', 237557),
(293832, 'MF_04165', NULL, 'Late transcription coactivator.', NULL, NULL, 'T4_TRANSCR_COACT', 237558),
(293833, 'MF_00276', NULL, 'Potassium-transporting ATPase KdpC subunit [kdpC].', NULL, NULL, 'KdpC', 237559),
(293834, 'MF_01027', NULL, '3-isopropylmalate dehydratase large subunit [leuC].', NULL, NULL, 'LeuC_type2', 237560),
(293835, 'MF_01934', NULL, '1,4-dihydroxy-2-naphthoyl-CoA synthase [menB].', NULL, NULL, 'MenB', 237561),
(293836, 'MF_02008', NULL, 'Tyrosine--tRNA ligase [tyrS].', NULL, NULL, 'Tyr_tRNA_synth_type3', 237562),
(293837, 'MF_01093', NULL, 'Tetrahydromethanopterin S-methyltransferase subunit A [mtrA].', NULL, NULL, 'MtrA', 237563),
(293838, 'MF_01069', NULL, 'Glucans biosynthesis protein G [mdoG].', NULL, NULL, 'MdoG_OpgG', 237564),
(293839, 'MF_01855', NULL, 'Fructose-1,6-bisphosphatase class 1 [fbp].', NULL, NULL, 'FBPase_class1', 237565),
(293840, 'MF_01199', NULL, 'Anti-adapter protein IraM [iraM].', NULL, NULL, 'Anti_adapt_IraM', 237566),
(293841, 'MF_01835', NULL, 'Circadian clock protein KaiB [kaiB].', NULL, NULL, 'KaiB', 237567),
(293842, 'MF_02098', NULL, 'Carnitine monooxygenase reductase subunit.', NULL, NULL, 'Carnitine_monoox_B', 237568),
(293843, 'MF_04104', NULL, 'Holin.', NULL, NULL, 'HOLIN_T4', 237569),
(293844, 'MF_00801', NULL, 'Endonuclease V [nfi].', NULL, NULL, 'Endonuclease_5', 237570);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(293845, 'MF_01663', NULL, 'L-rhamnose mutarotase [rhaM].', NULL, NULL, 'L_rham_rotase', 237571),
(293846, 'MF_02031', NULL, 'Galactarate dehydratase (L-threo-forming) [garD].', NULL, NULL, 'Galactar_dehydrat', 237572),
(293847, 'MF_04024', NULL, 'Nuclear egress protein 2 [NEC2].', NULL, NULL, 'HSV_NEC2', 237573),
(293848, 'MF_00179', NULL, 'GTP cyclohydrolase-2 [ribA].', NULL, NULL, 'RibA', 237574),
(293849, 'MF_00606', NULL, 'UV DNA damage endonuclease [uvsE].', NULL, NULL, 'UV_endonuclease', 237575),
(293850, 'MF_00740', NULL, 'Phosphopentomutase [deoB].', NULL, NULL, 'Phosphopentomut', 237576),
(293851, 'MF_01355', NULL, 'NAD(P)H-quinone oxidoreductase subunit L [ndhL].', NULL, NULL, 'NDH1_NDH1L', 237577),
(293852, 'MF_01016', NULL, 'Putative transport protein YidE [yidE].', NULL, NULL, 'YidE', 237578),
(293853, 'MF_00181', NULL, 'Probable cytosol aminopeptidase [pepA].', NULL, NULL, 'Cytosol_peptidase_M17', 237579),
(293854, 'MF_04039', NULL, 'Cytoplasmic envelopment protein 2.', NULL, NULL, 'HSV_CEP2', 237580),
(293855, 'MF_01128', NULL, 'H(+)/Cl(-) exchange transporter ClcA [clcA].', NULL, NULL, 'CLC_ClcA', 237581),
(293856, 'MF_04066', NULL, 'Non-structural protein 1 [NS].', NULL, NULL, 'INFV_NS1', 237582),
(293857, 'MF_04099', NULL, 'Spike glycoprotein [S].', NULL, NULL, 'BETA_CORONA_SPIKE', 237583),
(293858, 'MF_01843', NULL, 'Protein Thf1 [thf1].', NULL, NULL, 'Thf1', 237584),
(293859, 'MF_02125', NULL, '50S ribosomal protein L3 glutamine methyltransferase [prmB].', NULL, NULL, 'L3_methyltr_PrmB', 237585),
(293860, 'MF_02126', NULL, 'Release factor glutamine methyltransferase [prmC].', NULL, NULL, 'RF_methyltr_PrmC', 237586),
(293861, 'MF_01010', NULL, '23S rRNA (uracil(1939)-C(5))-methyltransferase RlmD [rlmD].', NULL, NULL, '23SrRNA_methyltr_RlmD', 237587),
(293862, 'MF_03170', NULL, 'Adenylate kinase 4, mitochondrial [AK4].', NULL, NULL, 'Adenylate_kinase_AK4', 237588),
(293863, 'MF_04094', NULL, 'Non-structural protein 3.', NULL, NULL, 'ROTA_A_NSP3', 237589),
(293864, 'MF_01136', NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit gamma [cdhE].', NULL, NULL, 'CdhE', 237590),
(293865, 'MF_04116', NULL, 'Highly immunogenic outer capsid protein.', NULL, NULL, 'HOC_T4', 237591),
(293866, 'MF_00978', NULL, 'Bifunctional ligase/repressor BirA [birA].', NULL, NULL, 'Bifunct_BirA', 237592),
(293867, 'MF_04007', NULL, 'Major DNA-binding protein [DBP].', NULL, NULL, 'HSV_DNBI', 237593),
(293868, 'MF_02231', NULL, 'Ubiquinone biosynthesis accessory factor UbiT [ubiT].', NULL, NULL, 'UbiT', 237594),
(293869, 'MF_01349', NULL, 'Bifunctional pantoate ligase/cytidylate kinase [panC/cmk].', NULL, NULL, 'PanCY', 237595),
(293870, 'MF_01190', NULL, 'HTH-type transcriptional repressor FabR [fabR].', NULL, NULL, 'HTH_type_FabR', 237596),
(293871, 'MF_00329', NULL, '50S ribosomal protein L18e [rpl18e].', NULL, NULL, 'Ribosomal_L18e', 237597),
(293872, 'MF_01675', NULL, 'O-phospho-L-seryl-tRNA:Cys-tRNA synthase.', NULL, NULL, 'Sep_Cys_tRNA_synth', 237598),
(293873, 'MF_01176', NULL, 'HTH-type transcriptional regulator IscR [iscR].', NULL, NULL, 'HTH_type_IscR', 237599),
(293874, 'MF_01848', NULL, 'Ribosomal RNA large subunit methyltransferase F [rlmF].', NULL, NULL, '23SrRNA_methyltr_F', 237600),
(293875, 'MF_00122', NULL, 'Aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase subunit C [gatC].', NULL, NULL, 'GatC', 237601),
(293876, 'MF_00140_A', NULL, 'Tryptophan--tRNA ligase [trpS].', NULL, NULL, 'Trp_tRNA_synth_A', 237602),
(293877, 'MF_02123', NULL, 'F420-dependent glucose-6-phosphate dehydrogenase [fgd].', NULL, NULL, 'F420_G6P_DH', 237603),
(293878, 'MF_01557', NULL, 'Tagatose-6-phosphate kinase [lacC].', NULL, NULL, 'LacC', 237604),
(293879, 'MF_01470', NULL, 'CRISPR-associated endonuclease Cas1 [cas1].', NULL, NULL, 'Cas1', 237605),
(293880, 'MF_03051', NULL, 'Molybdopterin synthase sulfur carrier subunit [cnxG].', NULL, NULL, 'MOCS2A', 237606),
(293881, 'MF_01660', NULL, '2-succinyl-6-hydroxy-2,4-cyclohexadiene-1-carboxylate synthase [menH].', NULL, NULL, 'MenH', 237607),
(293882, 'MF_01106', NULL, 'Arginine biosynthesis bifunctional protein ArgJ [argJ].', NULL, NULL, 'ArgJ', 237608);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(293883, 'MF_00770', NULL, 'Rhamnulose-1-phosphate aldolase [rhaD].', NULL, NULL, 'RhaD', 237609),
(293884, 'MF_00211', NULL, 'Anthranilate phosphoribosyltransferase [trpD].', NULL, NULL, 'TrpD', 237610),
(293885, 'MF_01329', NULL, 'Photosystem II reaction center protein Ycf12 [ycf12].', NULL, NULL, 'PSII_Ycf12', 237611),
(293886, 'MF_00906', NULL, 'Cell division protein ZapC [zapC].', NULL, NULL, 'ZapC', 237612),
(293887, 'MF_02070', NULL, 'N-acetylglucosaminyldiphosphoundecaprenol N-acetyl-beta-D-mannosaminyltransferase.', NULL, NULL, 'TagA_TarA', 237613),
(293888, 'MF_02210', NULL, '[Ribosomal protein S18]-alanine N-acetyltransferase [rimI].', NULL, NULL, 'RimI', 237614),
(293889, 'MF_00402', NULL, '50S ribosomal protein L19 [rplS].', NULL, NULL, 'Ribosomal_L19', 237615),
(293890, 'MF_03181', NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3 [PAN3].', NULL, NULL, 'PAN3', 237616),
(293891, 'MF_00703', NULL, 'Putative thymidine phosphorylase.', NULL, NULL, 'Thymid_phosp_2', 237617),
(293892, 'MF_01118', NULL, 'Uncharacterized MFS-type transporter YhhS [yhhS].', NULL, NULL, 'MFS_YhhS', 237618),
(293893, 'MF_01526', NULL, 'UPF0342 protein <locus_tag>.', NULL, NULL, 'UPF0342', 237619),
(293894, 'MF_01615', NULL, 'Pyridoxal 5''-phosphate synthase subunit PdxT [pdxT].', NULL, NULL, 'PdxT', 237620),
(293895, 'MF_00023', NULL, 'SsrA-binding protein [smpB].', NULL, NULL, 'SmpB', 237621),
(293896, 'MF_00353', NULL, 'Light-independent protochlorophyllide reductase subunit B [bchB].', NULL, NULL, 'ChlB_BchB', 237622),
(293897, 'MF_01866', NULL, 'Protein YcgL [ycgL].', NULL, NULL, 'UPF0745', 237623),
(293898, 'MF_01191', NULL, 'UPF0442 protein YjjB [yjjB].', NULL, NULL, 'UPF0442', 237624),
(293899, 'MF_02035', NULL, 'Hercynine oxygenase [egtB].', NULL, NULL, 'EgtB', 237625),
(293900, 'MF_01860', NULL, 'UPF0736 protein <locus_tag>.', NULL, NULL, 'UPF0736', 237626),
(293901, 'MF_00462', NULL, 'Ion-translocating oxidoreductase complex subunit D [rsxD].', NULL, NULL, 'RsxD_RnfD', 237627),
(293902, 'MF_02061', NULL, 'Thioredoxin/glutathione peroxidase BtuE [btuE].', NULL, NULL, 'Thiored_glutath_peroxid', 237628),
(293903, 'MF_00652', NULL, 'UPF0246 protein YaaA [yaaA].', NULL, NULL, 'UPF0246', 237629),
(293904, 'MF_00279', NULL, 'Pyridoxine 5''-phosphate synthase [pdxJ].', NULL, NULL, 'PdxJ', 237630),
(293905, 'MF_03049', NULL, 'Adenylyltransferase and sulfurtransferase MOCS3 [MOCS3].', NULL, NULL, 'MOCS3_Uba4', 237631),
(293906, 'MF_00838', NULL, 'Diadenylate cyclase [dacB].', NULL, NULL, 'DacB', 237632),
(293907, 'MF_00945_A', NULL, 'Transcription termination/antitermination protein NusA [nusA].', NULL, NULL, 'NusA_A', 237633),
(293908, 'MF_01200_B', NULL, 'Orotidine 5''-phosphate decarboxylase [pyrF].', NULL, NULL, 'OMPdecase_type1_B', 237634),
(293909, 'MF_01068', NULL, 'Glucans biosynthesis protein D [mdoD].', NULL, NULL, 'MdoD_OpgD', 237635),
(293910, 'MF_03068', NULL, 'ATP-dependent RNA helicase DHX29 [DHX29].', NULL, NULL, 'DHX29', 237636),
(293911, 'MF_03158', NULL, 'Thiamine thiazole synthase, chloroplastic [THI4].', NULL, NULL, 'THI4', 237637),
(293912, 'MF_01459', NULL, 'Chromophore lyase CpcS/CpeS [cpcS].', NULL, NULL, 'Chrphore_lyase_CpxS', 237638),
(293913, 'MF_00326', NULL, '50S ribosomal protein L7Ae [rpl7ae].', NULL, NULL, 'Ribosomal_L7Ae_Arch', 237639),
(293914, 'MF_00386', NULL, 'Putative membrane protein insertion efficiency factor [yidD].', NULL, NULL, 'UPF0161_YidD', 237640),
(293915, 'MF_00475', NULL, 'Trp operon repressor [trpR].', NULL, NULL, 'Trp_repressor', 237641),
(293916, 'MF_01178', NULL, 'Sigma factor-binding protein Crl [crl].', NULL, NULL, 'Crl', 237642),
(293917, 'MF_01585', NULL, 'Lysophospholipid transporter LplT [lplT].', NULL, NULL, 'MFS_LplT', 237643),
(293918, 'MF_04156', NULL, 'DNA helicase assembly protein [59].', NULL, NULL, 'HELIC_LOADER_T4', 237644),
(293919, 'MF_00066', NULL, 'Sulfate adenylyltransferase [sat].', NULL, NULL, 'Sulf_adenylyltr', 237645),
(293920, 'MF_00165', NULL, 'Thymidylate kinase [tmk].', NULL, NULL, 'Thymidylate_kinase', 237646),
(293921, 'MF_00195', NULL, 'GTPase Der [der].', NULL, NULL, 'GTPase_Der', 237647);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(293922, 'MF_00769', NULL, '2-phosphoglycerate kinase [pgk2].', NULL, NULL, '2PGK', 237648),
(293923, 'MF_04140', NULL, 'Flap endonuclease.', NULL, NULL, 'FEN_T5', 237649),
(293924, 'MF_01071', NULL, 'UPF0266 membrane protein YobD [yobD].', NULL, NULL, 'UPF0266', 237650),
(293925, 'MF_00489', NULL, 'UPF0178 protein YaiI [yaiI].', NULL, NULL, 'UPF0178', 237651),
(293926, 'MF_02118', NULL, 'Octanoyltransferase LipM [lipM].', NULL, NULL, 'LipM', 237652),
(293927, 'MF_01838', NULL, 'Trans-2-enoyl-CoA reductase [NADH] [fabV].', NULL, NULL, 'FabV_reductase', 237653),
(293928, 'MF_00533', NULL, 'Nitrogenase iron protein [nifH].', NULL, NULL, 'NifH', 237654),
(293929, 'MF_00516', NULL, 'Monomeric sarcosine oxidase [soxA].', NULL, NULL, 'MSOX', 237655),
(293930, 'MF_01981', NULL, 'ATP-dependent 6-phosphofructokinase [pfkA].', NULL, NULL, 'Phosphofructokinase_II_X', 237656),
(293931, 'MF_03069', NULL, 'Protein kintoun [DNAAF2].', NULL, NULL, 'Kintoun', 237657),
(293932, 'MF_01372', NULL, 'UPF0412 protein YaaI [yaaI].', NULL, NULL, 'UPF0412', 237658),
(293933, 'MF_03208', NULL, 'Phosphatidylserine decarboxylase proenzyme [PISD].', NULL, NULL, 'PS_decarb_PSD_B_type1_euk', 237659),
(293934, 'MF_00184', NULL, 'Threonine--tRNA ligase [thrS].', NULL, NULL, 'Thr_tRNA_synth', 237660),
(293935, 'MF_01270', NULL, 'Anhydro-N-acetylmuramic acid kinase [anmK].', NULL, NULL, 'AnhMurNAc_kinase', 237661),
(293936, 'MF_00264', NULL, 'UPF0128 protein <locus_tag>.', NULL, NULL, 'UPF0128', 237662),
(293937, 'MF_04154', NULL, 'DNA helicase/primase [4].', NULL, NULL, 'Helic_Prim_T7', 237663),
(293938, 'MF_00557', NULL, 'Alginate lyase [algL].', NULL, NULL, 'Alginate_lyase', 237664),
(293939, 'MF_01410', NULL, 'Glucose-6-phosphate isomerase [pgiA].', NULL, NULL, 'G6P_isomerase_arch', 237665),
(293940, 'MF_00268', NULL, 'Protein RecA [recA].', NULL, NULL, 'RecA', 237666),
(293941, 'MF_04088', NULL, 'Non-structural protein 1.', NULL, NULL, 'ROTA_NSP1', 237667),
(293942, 'MF_01682', NULL, 'Acireductone dioxygenase [mtnD].', NULL, NULL, 'Salvage_MtnD', 237668),
(293943, 'MF_01567', NULL, 'UPF0371 protein <locus_tag>.', NULL, NULL, 'UPF0371', 237669),
(293944, 'MF_01868', NULL, 'Lipopolysaccharide core heptose(II)-phosphate phosphatase [ais].', NULL, NULL, 'Ais', 237670),
(293945, 'MF_01073', NULL, 'Macrodomain Ter protein [matP].', NULL, NULL, 'MatP', 237671),
(293946, 'MF_01008', NULL, 'Transcriptional regulator MraZ [mraZ].', NULL, NULL, 'MraZ', 237672),
(293947, 'MF_01684', NULL, '5''-methylthioadenosine/S-adenosylhomocysteine nucleosidase [mtnN].', NULL, NULL, 'Salvage_MtnN', 237673),
(293948, 'MF_00750', NULL, 'Oxygen-dependent choline dehydrogenase [betA].', NULL, NULL, 'Choline_dehydrogen', 237674),
(293949, 'MF_01890', NULL, 'Penicillin-binding protein activator LpoA [lpoA].', NULL, NULL, 'LpoA', 237675),
(293950, 'MF_00378', NULL, 'Exodeoxyribonuclease 7 large subunit [xseA].', NULL, NULL, 'Exonuc_7_L', 237676),
(293951, 'MF_01301', NULL, 'Maltoporin [lamB].', NULL, NULL, 'LamB', 237677),
(293952, 'MF_00572', NULL, '2-isopropylmalate synthase [leuA].', NULL, NULL, 'LeuA_type2', 237678),
(293953, 'MF_01408', NULL, 'Flavin-dependent thymidylate synthase [thyX].', NULL, NULL, 'ThyX', 237679),
(293954, 'MF_01326_A', NULL, '50S ribosomal protein L24 [rplX].', NULL, NULL, 'Ribosomal_L24_A', 237680),
(293955, 'MF_01603', NULL, 'Bifunctional protein HldE [hldE].', NULL, NULL, 'HldE', 237681),
(293956, 'MF_04048', NULL, 'Pre-protein VI [L3].', NULL, NULL, 'ADV_CAP6', 237682),
(293957, 'MF_01569', NULL, 'Proline--tRNA ligase [proS].', NULL, NULL, 'Pro_tRNA_synth_type1', 237683),
(293958, 'MF_00747', NULL, 'Isocitrate dehydrogenase kinase/phosphatase [aceK].', NULL, NULL, 'AceK', 237684),
(293959, 'MF_01691', NULL, '2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-acetyltransferase [dapH].', NULL, NULL, 'DapH', 237685),
(293960, 'MF_01983', NULL, 'UbiD-like decarboxylase.', NULL, NULL, 'UbiD_FDC', 237686),
(293961, 'MF_00156', NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase [panB].', NULL, NULL, 'PanB', 237687),
(293962, 'MF_04092', NULL, 'Non-structural protein 5.', NULL, NULL, 'ROTA_NSP5', 237688);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(293963, 'MF_00363', NULL, 'UPF0154 protein <locus_tag>.', NULL, NULL, 'UPF0154', 237689),
(293964, 'MF_00320', NULL, 'DNA-directed RNA polymerase subunit Rpo3 [rpo3].', NULL, NULL, 'RNApol_arch_Rpo3', 237690),
(293965, 'MF_01833', NULL, 'tRNA-splicing endonuclease [endA].', NULL, NULL, 'EndA_short', 237691),
(293966, 'MF_00766', NULL, 'Biosynthetic peptidoglycan transglycosylase [mtgA].', NULL, NULL, 'PGT_MtgA', 237692),
(293967, 'MF_04035', NULL, 'Envelope glycoprotein M [gM].', NULL, NULL, 'HSV_GM', 237693),
(293968, 'MF_04207', NULL, 'Hemagglutinin-esterase [HE].', NULL, NULL, 'BETA_CORONA_HE', 237694),
(293969, 'MF_00123', NULL, 'Arginine--tRNA ligase [argS].', NULL, NULL, 'Arg_tRNA_synth', 237695),
(293970, 'MF_01956', NULL, 'G/U mismatch-specific DNA glycosylase [mug].', NULL, NULL, 'MUG', 237696),
(293971, 'MF_01000', NULL, 'Vitamin B12-binding protein [btuF].', NULL, NULL, 'BtuF', 237697),
(293972, 'MF_01627', NULL, 'Purine nucleoside phosphorylase DeoD-type [deoD].', NULL, NULL, 'Pur_nucleosid_phosp', 237698),
(293973, 'MF_01033', NULL, '3-isopropylmalate dehydrogenase [leuB].', NULL, NULL, 'LeuB_type1', 237699),
(293974, 'MF_00823', NULL, 'Acetyl-coenzyme A carboxylase carboxyl transferase subunit alpha [accA].', NULL, NULL, 'AcetylCoA_CT_alpha', 237700),
(293975, 'MF_00511', NULL, '30S ribosomal protein S17e [rps17e].', NULL, NULL, 'Ribosomal_S17e', 237701),
(293976, 'MF_01273', NULL, 'Type II pantothenate kinase [coaW].', NULL, NULL, 'Pantothen_kinase_2', 237702),
(293977, 'MF_04143', NULL, 'Poxin-Schlafen.', NULL, NULL, 'Poxins', 237703),
(293978, 'MF_01824', NULL, 'Pyridoxal 5''-phosphate synthase subunit PdxS [pdxS].', NULL, NULL, 'PdxS', 237704),
(293979, 'MF_00767', NULL, 'Succinylglutamate desuccinylase [astE].', NULL, NULL, 'Arg_catab_AstE', 237705),
(293980, 'MF_01048', NULL, 'Protein PsiE [psiE].', NULL, NULL, 'PsiE', 237706),
(293981, 'MF_00007', NULL, 'DNA primase DnaG [dnaG].', NULL, NULL, 'DNA_primase_DnaG_arc', 237707),
(293982, 'MF_00082', NULL, 'Acetylglutamate kinase [argB].', NULL, NULL, 'ArgB', 237708),
(293983, 'MF_00850', NULL, 'Pyruvate dehydrogenase [ubiquinone] [poxB].', NULL, NULL, 'POX', 237709),
(293984, 'MF_00655', NULL, 'PqqA binding protein [pqqD].', NULL, NULL, 'PQQ_syn_PqqD', 237710),
(293985, 'MF_01004', NULL, 'Vitamin B12 import system permease protein BtuC [btuC].', NULL, NULL, 'BtuC', 237711),
(293986, 'MF_00111', NULL, 'UDP-N-acetylglucosamine 1-carboxyvinyltransferase [murA].', NULL, NULL, 'MurA', 237712),
(293987, 'MF_04037', NULL, 'Envelope glycoprotein N [gN].', NULL, NULL, 'HSV_GN', 237713),
(293988, 'MF_01803', NULL, 'Chromosome partition protein MukF [mukF].', NULL, NULL, 'MukF', 237714),
(293989, 'MF_00859', NULL, 'Ribulose bisphosphate carboxylase small subunit [cbbS].', NULL, NULL, 'RuBisCO_S_bact', 237715),
(293990, 'MF_01606', NULL, 'Iron-sulfur cluster repair protein YtfE [ytfE].', NULL, NULL, 'RIC_YtfE', 237716),
(293991, 'MF_01501', NULL, 'Tetrahydromethanopterin S-methyltransferase subunit H [mtrH].', NULL, NULL, 'MtrH', 237717),
(293992, 'MF_01159', NULL, 'Initiation-control protein YabA.', NULL, NULL, 'YabA', 237718),
(293993, 'MF_01344', NULL, 'Cytochrome b6-f complex subunit 4 [petD].', NULL, NULL, 'Cytb6_f_subIV', 237719),
(293994, 'MF_00366', NULL, 'DNA-directed RNA polymerase subunit omega [rpoZ].', NULL, NULL, 'RNApol_bact_RpoZ', 237720),
(293995, 'MF_00261', NULL, 'DNA-directed RNA polymerase subunit Rpo11 [rpo11].', NULL, NULL, 'RNApol_arch_Rpo11', 237721),
(293996, 'MF_01867', NULL, 'Putative cysteine ligase BshC [bshC].', NULL, NULL, 'BshC', 237722),
(293997, 'MF_00025', NULL, 'DNA-directed RNA polymerase subunit Rpo5 [rpo5].', NULL, NULL, 'RNApol_Rpo5_RPB5', 237723),
(293998, 'MF_00454', NULL, 'Putative fluoride ion transporter CrcB [crcB].', NULL, NULL, 'CrcB', 237724),
(293999, 'MF_04001', NULL, 'Regulatory protein E2 [E2].', NULL, NULL, 'PPV_E2', 237725),
(294000, 'MF_00485', NULL, '30S ribosomal protein S4e [rps4e].', NULL, NULL, 'Ribosomal_S4e', 237726),
(294001, 'MF_00250', NULL, 'DNA-directed RNA polymerase subunit Rpo10 [rpo10].', NULL, NULL, 'RNApol_arch_Rpo10', 237727);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(294002, 'MF_01514', NULL, 'UPF0314 protein <locus_tag>.', NULL, NULL, 'UPF0314', 237728),
(294003, 'MF_03060', NULL, 'Draxin [DRAXIN].', NULL, NULL, 'Draxin', 237729),
(294004, 'MF_01974', NULL, 'Methionine aminopeptidase [map].', NULL, NULL, 'MetAP_1', 237730),
(294005, 'MF_00170', NULL, 'Ribose-5-phosphate isomerase A [rpiA].', NULL, NULL, 'Rib_5P_isom_A', 237731),
(294006, 'MF_00323', NULL, 'Coproporphyrin III ferrochelatase [cpfC].', NULL, NULL, 'Ferrochelatase', 237732),
(294007, 'MF_01875', NULL, 'Non-homologous end joining protein Ku [ku].', NULL, NULL, 'Prokaryotic_Ku', 237733),
(294008, 'MF_04161', NULL, 'Sliding clamp.', NULL, NULL, 'Sliding_clamp_T4', 237734),
(294009, 'MF_01632', NULL, 'Chorismate pyruvate-lyase [ubiC].', NULL, NULL, 'UbiC', 237735),
(294010, 'MF_00051', NULL, 'Serine hydroxymethyltransferase [glyA].', NULL, NULL, 'SHMT', 237736),
(294011, 'MF_00368', NULL, '50S ribosomal protein L7/L12 [rplL].', NULL, NULL, 'Ribosomal_L7_L12', 237737),
(294012, 'MF_02131', NULL, '6-hydroxymethyl-7,8-dihydropterin pyrophosphokinase [mptE].', NULL, NULL, 'HMPDK_arch', 237738),
(294013, 'MF_01357', NULL, 'NAD(P)H-quinone oxidoreductase subunit J, chloroplastic [ndhJ].', NULL, NULL, 'NDH1_NuoC', 237739),
(294014, 'MF_01265', NULL, 'L-aspartate dehydrogenase [nadX].', NULL, NULL, 'NadX', 237740),
(294015, 'MF_01294', NULL, 'D-tagatose-1,6-bisphosphate aldolase subunit GatY [gatY].', NULL, NULL, 'TagBP_aldolase_GatY', 237741),
(294016, 'MF_03032', NULL, 'Protein argonaute-3 [EIF2C3].', NULL, NULL, 'AGO3', 237742),
(294017, 'MF_04098', NULL, 'Spike glycoprotein [S].', NULL, NULL, 'GAMMA_CORONA_SPIKE', 237743),
(294018, 'MF_00093', NULL, 'Peptide chain release factor 1 [prfA].', NULL, NULL, 'Rel_fac_1', 237744),
(294019, 'MF_01040', NULL, 'Probable phosphoglycerate mutase GpmB [gpmB].', NULL, NULL, 'PGAM_GpmB', 237745),
(294020, 'MF_00608', NULL, 'GTP cyclohydrolase III [gch3].', NULL, NULL, 'GTP_cyclohydro_3', 237746),
(294021, 'MF_02036', NULL, 'Gamma-glutamyl-hercynylcysteine sulfoxide hydrolase [egtC].', NULL, NULL, 'EgtC', 237747),
(294022, 'MF_01089', NULL, 'UPF0288 protein <locus_tag>.', NULL, NULL, 'UPF0288', 237748),
(294023, 'MF_02221', NULL, 'Carbamoyl-phosphate synthase.', NULL, NULL, 'CPSase', 237749),
(294024, 'MF_00207', NULL, 'Probable manganese-dependent inorganic pyrophosphatase [ppaC].', NULL, NULL, 'PPase_C', 237750),
(294025, 'MF_01304', NULL, 'UPF0194 membrane protein YbhG [ybhG].', NULL, NULL, 'UPF0194', 237751),
(294026, 'MF_01394', NULL, 'NAD(P)H-quinone oxidoreductase subunit 3, chloroplastic [ndhC].', NULL, NULL, 'NDH1_NuoA', 237752),
(294027, 'MF_02079', NULL, 'Peptidoglycan glycosyltransferase MrdB [mrdB].', NULL, NULL, 'PGT_RodA', 237753),
(294028, 'MF_00403_B', NULL, '30S ribosomal protein S12 [rpsL].', NULL, NULL, 'Ribosomal_S12_B', 237754),
(294029, 'MF_00362', NULL, '50S ribosomal protein L10 [rplJ].', NULL, NULL, 'Ribosomal_L10', 237755),
(294030, 'MF_00425', NULL, 'Na(+)-translocating NADH-quinone reductase subunit A [nqrA].', NULL, NULL, 'NqrA', 237756),
(294031, 'MF_00483', NULL, 'DNA replication terminus site-binding protein [tus].', NULL, NULL, 'Rep_term_Tus', 237757),
(294032, 'MF_03228', NULL, 'Probable butyrate:acetyl-CoA coenzyme A-transferase.', NULL, NULL, 'But_CoA_trans', 237758),
(294033, 'MF_01931', NULL, 'Amidophosphoribosyltransferase [purF].', NULL, NULL, 'PurF', 237759),
(294034, 'MF_01457', NULL, 'Flagellar brake protein YcgR [ycgR].', NULL, NULL, 'YcgR', 237760),
(294035, 'MF_00388', NULL, 'UDP-3-O-acyl-N-acetylglucosamine deacetylase [lpxC].', NULL, NULL, 'LpxC', 237761),
(294036, 'MF_01927', NULL, 'Formyltetrahydrofolate deformylase [purU].', NULL, NULL, 'PurU', 237762),
(294037, 'MF_01464_B', NULL, 'Protein-export membrane protein SecF [secF].', NULL, NULL, 'SecF_B', 237763),
(294038, 'MF_04053', NULL, 'Core-capsid bridging protein [L2].', NULL, NULL, 'ADV_CORE5', 237764),
(294039, 'MF_03220', NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta, mitochondrial [SUCLA2].', NULL, NULL, 'Succ_CoA_betaA_euk', 237765),
(294040, 'MF_01929', NULL, 'N5-carboxyaminoimidazole ribonucleotide mutase [purE].', NULL, NULL, 'PurE_classI', 237766);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(294041, 'MF_01938', NULL, '2-carboxy-1,4-naphthoquinone phytyltransferase [menA].', NULL, NULL, 'MenA_2', 237767),
(294042, 'MF_01565', NULL, 'Zinc transport protein ZntB [zntB].', NULL, NULL, 'ZntB', 237768),
(294043, 'MF_01910', NULL, 'Probable ribonuclease FAU-1 [fau-1].', NULL, NULL, 'RNA_binding_AU_1', 237769),
(294044, 'MF_01554_A', NULL, 'Phosphoglucosamine mutase [glmM].', NULL, NULL, 'GlmM_A', 237770),
(294045, 'MF_01533', NULL, 'HTH-type transcriptional activator RhaR [rhaR].', NULL, NULL, 'HTH_type_RhaR', 237771),
(294046, 'MF_00592', NULL, 'Deoxyribose-phosphate aldolase [deoC].', NULL, NULL, 'DeoC_type2', 237772),
(294047, 'MF_01521', NULL, 'Probable manganese efflux pump MntP [mntP].', NULL, NULL, 'MntP_pump', 237773),
(294048, 'MF_00553', NULL, 'Proteasome-activating nucleotidase [pan].', NULL, NULL, 'PAN', 237774),
(294049, 'MF_01121', NULL, 'NAD-dependent protein deacylase [cobB].', NULL, NULL, 'Sirtuin_ClassIII', 237775),
(294050, 'MF_01174', NULL, 'N-succinylglutamate 5-semialdehyde dehydrogenase [astD].', NULL, NULL, 'Aldedh_AstD', 237776),
(294051, 'MF_00159', NULL, '4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase (ferredoxin) [ispG].', NULL, NULL, 'IspG', 237777),
(294052, 'MF_01168', NULL, 'N-glycosylase/DNA lyase.', NULL, NULL, 'AGOG', 237778),
(294053, 'MF_01210_B', NULL, 'Carbamoyl-phosphate synthase large chain [carB].', NULL, NULL, 'CPSase_L_chain_B', 237779),
(294054, 'MF_02053', NULL, 'Autoinducer-2 kinase [lsrK].', NULL, NULL, 'LsrK', 237780),
(294055, 'MF_02121', NULL, 'Aspartate-semialdehyde dehydrogenase [asd].', NULL, NULL, 'ASADH', 237781),
(294056, 'MF_04157', NULL, 'DNA primase.', NULL, NULL, 'PRIMASE_T4', 237782),
(294057, 'MF_00927', NULL, 'Cell wall synthesis protein CwsA [cwsA].', NULL, NULL, 'CwsA', 237783),
(294058, 'MF_01889', NULL, 'Penicillin-binding protein activator LpoB [lpoB].', NULL, NULL, 'LpoB', 237784),
(294059, 'MF_01285', NULL, 'Riboflavin kinase [ribK].', NULL, NULL, 'Riboflavin_kinase', 237785),
(294060, 'MF_00414', NULL, 'Probable protein kinase UbiB [ubiB].', NULL, NULL, 'UbiB', 237786),
(294061, 'MF_01642', NULL, 'LL-diaminopimelate aminotransferase [dapL].', NULL, NULL, 'DapL_aminotrans_1', 237787),
(294062, 'MF_01083', NULL, 'Glutarate 2-hydroxylase [glaH].', NULL, NULL, 'glutarate_hydroxylase', 237788),
(294063, 'MF_01587', NULL, 'DNA ligase B [ligB].', NULL, NULL, 'DNA_ligase_B', 237789),
(294064, 'MF_02068', NULL, 'Ribitol-5-phosphate cytidylyltransferase [tarI].', NULL, NULL, 'TarI', 237790),
(294065, 'MF_00231', NULL, 'Translation initiation factor 2 subunit alpha [eif2a].', NULL, NULL, 'eIF_2_alpha', 237791),
(294066, 'MF_01028', NULL, 'Putative (R)-citramalate synthase CimA [cimA].', NULL, NULL, 'CimA', 237792),
(294067, 'MF_03187', NULL, 'EEF1A lysine methyltransferase 1 [EEF1AKMT1].', NULL, NULL, 'Methyltr_EFM5', 237793),
(294068, 'MF_01882', NULL, 'Probable propionate kinase [pduW].', NULL, NULL, 'Propion_kin_subfam2', 237794),
(294069, 'MF_02212', NULL, 'Broad specificity amino-acid racemase.', NULL, NULL, 'Bsr_racemase', 237795),
(294070, 'MF_00594', NULL, 'Cytochrome c6 [petJ].', NULL, NULL, 'Cytc_PetJ', 237796),
(294071, 'MF_01101', NULL, 'UPF0208 membrane protein YfbV [yfbV].', NULL, NULL, 'UPF0208', 237797),
(294072, 'MF_00513', NULL, 'HTH-type transcriptional regulator ArgP [argP].', NULL, NULL, 'HTH_type_ArgP', 237798),
(294073, 'MF_03231', NULL, 'Acyl-coenzyme A diphosphatase SCS3 [SCS3].', NULL, NULL, 'SCS3', 237799),
(294074, 'MF_00515', NULL, 'N-methyl-L-tryptophan oxidase [solA].', NULL, NULL, 'MTOX', 237800),
(294075, 'MF_01532', NULL, 'L-rhamnose-proton symporter [rhaT].', NULL, NULL, 'RhaT', 237801),
(294076, 'MF_01951', NULL, 'L-ribulose-5-phosphate 3-epimerase UlaE [ulaE].', NULL, NULL, 'UlaE', 237802),
(294077, 'MF_01605', NULL, '6-phosphogluconolactonase [pgl].', NULL, NULL, '6P_gluconolactonase', 237803),
(294078, 'MF_00447', NULL, 'Photosystem I reaction center subunit XI [psaL].', NULL, NULL, 'PSI_PsaL', 237804),
(294079, 'MF_01645', NULL, 'Allantoinase [allB].', NULL, NULL, 'Hydantoinase', 237805);
INSERT INTO "PUBLIC"."MODEL" VALUES
(294080, 'MF_00716', NULL, 'Nitrous-oxide reductase [nosZ].', NULL, NULL, 'NosZ', 237806),
(294081, 'MF_01650', NULL, '3-phenylpropionate/cinnamic acid dioxygenase ferredoxin subunit [hcaC].', NULL, NULL, 'HcaC', 237807),
(294082, 'MF_00562', NULL, 'D-aminoacyl-tRNA deacylase [dtdA].', NULL, NULL, 'Deacylase_DtdA', 237808),
(294083, 'MF_01383', NULL, 'Photosystem II D2 protein [psbD].', NULL, NULL, 'PSII_PsbD_D2', 237809),
(294084, 'MF_01306_A', NULL, '30S ribosomal protein S4 [rpsD].', NULL, NULL, 'Ribosomal_S4_A', 237810),
(294085, 'MF_00690', NULL, 'UPF0270 protein YheU [yheU].', NULL, NULL, 'UPF0270', 237811),
(294086, 'MF_01379', NULL, 'Photosystem II protein D1 [psbA].', NULL, NULL, 'PSII_PsbA_D1', 237812),
(294087, 'MF_01031', NULL, '3-isopropylmalate dehydratase small subunit [leuD].', NULL, NULL, 'LeuD_type1', 237813),
(294088, 'MF_03183', NULL, 'Endonuclease III-like protein 1 [NTHL1].', NULL, NULL, 'Endonuclease_III_Nth', 237814),
(294089, 'MF_01869', NULL, 'Probable 4-amino-4-deoxy-L-arabinose-phosphoundecaprenol flippase subunit ArnE [arnE].', NULL, NULL, 'Flippase_ArnE', 237815),
(294090, 'MF_00134_A', NULL, 'Indole-3-glycerol phosphate synthase [trpC].', NULL, NULL, 'IGPS_A', 237816),
(294091, 'MF_00988', NULL, 'D-allose kinase [alsK].', NULL, NULL, 'Allose_kinase', 237817),
(294092, 'MF_00955', NULL, 'GDP-mannose 4,6-dehydratase [gmd].', NULL, NULL, 'GDP_Man_dehydratase', 237818),
(294093, 'MF_02229', NULL, '5-deoxyribose 1-phosphate isomerase [drdI].', NULL, NULL, 'Deoxyribose1P_isomerase', 237819),
(294094, 'MF_02013', NULL, 'Cell division protein ZapA [zapA].', NULL, NULL, 'ZapA_type2', 237820),
(294095, 'MF_00061', NULL, 'Putative 4-diphosphocytidyl-2-C-methyl-D-erythritol kinase [ispE].', NULL, NULL, 'IspE', 237821),
(294096, 'MF_00299', NULL, 'Probable RNA 2''-phosphotransferase [kptA].', NULL, NULL, 'KptA', 237822),
(294097, 'MF_01821', NULL, 'RNA polymerase-associated protein RapA [rapA].', NULL, NULL, 'Helicase_RapA', 237823),
(294098, 'MF_01255', NULL, 'L-ectoine synthase [ectC].', NULL, NULL, 'Ectoine_synth', 237824),
(294099, 'MF_00849', NULL, '50S ribosomal subunit assembly factor BipA [bipA].', NULL, NULL, 'BipA', 237825),
(294100, 'MF_01119', NULL, 'UPF0294 protein YafD [yafD].', NULL, NULL, 'UPF0294', 237826),
(294101, 'MF_01535', NULL, 'Rhamnulokinase [rhaB].', NULL, NULL, 'Rhamnulokinase', 237827),
(294102, 'MF_00609', NULL, 'Histidine decarboxylase [hdc].', NULL, NULL, 'Pyridoxal_decarbox', 237828),
(294103, 'MF_03129', NULL, 'Lipoyl synthase, chloroplastic [LIP1P].', NULL, NULL, 'Lipoyl_synth_plantC', 237829),
(294104, 'MF_00235', NULL, 'Adenylate kinase [adk].', NULL, NULL, 'Adenylate_kinase_Adk', 237830),
(294105, 'MF_00263', NULL, 'UPF0127 protein <locus_tag>.', NULL, NULL, 'UPF0127', 237831),
(294106, 'MF_02116', NULL, '2-amino-5-formylamino-6-ribosylaminopyrimidin-4(3H)-one 5''-monophosphate deformylase [arfB].', NULL, NULL, 'FAPy_deform', 237832),
(294107, 'MF_00243', NULL, 'Nicotinamide-nucleotide adenylyltransferase.', NULL, NULL, 'NMN_adenylyltr', 237833),
(294108, 'MF_00824', NULL, 'Uncharacterized N-acetyltransferase <locus_tag>.', NULL, NULL, 'Acetyltransf_YlbP', 237834),
(294109, 'MF_01647', NULL, '3-phenylpropionate-dihydrodiol/cinnamic acid-dihydrodiol dehydrogenase [hcaB].', NULL, NULL, 'HcaB', 237835),
(294110, 'MF_04031', NULL, 'Deoxyuridine 5''-triphosphate nucleotidohydrolase [DUT].', NULL, NULL, 'HSV_DUT', 237836),
(294111, 'MF_04075', NULL, 'Large envelope protein [S].', NULL, NULL, 'HBV_HBSAG', 237837),
(294112, 'MF_01653', NULL, '2,3-dihydroxyphenylpropionate/2,3-dihydroxicinnamic acid 1,2-dioxygenase [mhpB].', NULL, NULL, 'MhpB', 237838),
(294113, 'MF_00745', NULL, 'Protein SprT-like.', NULL, NULL, 'SprT_like', 237839),
(294114, 'MF_00579', NULL, 'Formylmethanofuran--tetrahydromethanopterin formyltransferase [ftr].', NULL, NULL, 'FTR', 237840),
(294115, 'MF_01318_A', NULL, '50S ribosomal protein L1 [rplA].', NULL, NULL, 'Ribosomal_L1_A', 237841),
(294116, 'MF_01659', NULL, '2-succinyl-5-enolpyruvyl-6-hydroxy-3-cyclohexene-1-carboxylate synthase [menD].', NULL, NULL, 'MenD', 237842);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(294117, 'MF_03118', NULL, 'Probable bifunctional methylthioribulose-1-phosphate dehydratase/enolase-phosphatase E1.', NULL, NULL, 'Salvage_MtnBC', 237843),
(294118, 'MF_01387', NULL, 'Chromatin protein Cren7 [creN7].', NULL, NULL, 'Chromatin_Cren7', 237844),
(294119, 'MF_00387', NULL, 'Acyl-[acyl-carrier-protein]--UDP-N-acetylglucosamine O-acyltransferase [lpxA].', NULL, NULL, 'LpxA', 237845),
(294120, 'MF_03100', NULL, 'Structure-specific endonuclease subunit <gene_name> [SLX1].', NULL, NULL, 'Endonuc_su_Slx1', 237846),
(294121, 'MF_00212', NULL, 'Probable malate:quinone oxidoreductase [mqo].', NULL, NULL, 'MQO', 237847),
(294122, 'MF_01646', NULL, 'Siroheme synthase [cysG].', NULL, NULL, 'Siroheme_synth', 237848),
(294123, 'MF_01102', NULL, 'tRNA 5-methylaminomethyl-2-thiouridine biosynthesis bifunctional protein MnmC [mnmC].', NULL, NULL, 'MnmC', 237849),
(294124, 'MF_01463_B', NULL, 'Protein translocase subunit SecD [secD].', NULL, NULL, 'SecD_B', 237850),
(294125, 'MF_00024', NULL, 'Cobalamin biosynthesis protein CbiB [cbiB].', NULL, NULL, 'CobD_CbiB', 237851),
(294126, 'MF_01196', NULL, 'Cell division protein ZapB [zapB].', NULL, NULL, 'ZapB', 237852),
(294127, 'MF_01336', NULL, '50S ribosomal protein L25 [rplY].', NULL, NULL, 'Ribosomal_L25', 237853),
(294128, 'MF_01107', NULL, 'Acetylornithine/succinyldiaminopimelate aminotransferase [argD].', NULL, NULL, 'ArgD_aminotrans_3', 237854),
(294129, 'MF_00343', NULL, 'UPF0148 protein <locus_tag>.', NULL, NULL, 'UPF0148', 237855),
(294130, 'MF_02017', NULL, 'Cytoskeleton protein RodZ [rodZ].', NULL, NULL, 'RodZ', 237856),
(294131, 'MF_01388', NULL, 'Photosystem II reaction center X protein [psbX].', NULL, NULL, 'PSII_PsbX_2', 237857),
(294132, 'MF_00346', NULL, 'UPF0149 protein YgfB [ygfB].', NULL, NULL, 'UPF0149', 237858),
(294133, 'MF_00465', NULL, 'S-adenosylmethionine decarboxylase proenzyme [speD].', NULL, NULL, 'AdoMetDC_2', 237859),
(294134, 'MF_00806', NULL, 'Autonomous glycyl radical cofactor [grcA].', NULL, NULL, 'GrcA', 237860),
(294135, 'MF_00952', NULL, 'DNA topoisomerase 1 [topA].', NULL, NULL, 'Topoisom_1_prok', 237861),
(294136, 'MF_04017', NULL, 'Capsid vertex component 1 [CVC1].', NULL, NULL, 'HSV_CVC1', 237862),
(294137, 'MF_00786', NULL, 'Probable cobalt-precorrin-6B C(15)-methyltransferase (decarboxylating) [cbiT].', NULL, NULL, 'CbiT', 237863),
(294138, 'MF_01381', NULL, 'Endo-type membrane-bound lytic murein transglycosylase A [emtA].', NULL, NULL, 'EmtA', 237864),
(294139, 'MF_03062', NULL, 'Ubiquitin carboxyl-terminal hydrolase 16 [USP16].', NULL, NULL, 'UBP16', 237865),
(294140, 'MF_03121', NULL, 'Lon protease homolog 2, peroxisomal [LONP2].', NULL, NULL, 'lonp2_euk', 237866),
(294141, 'MF_04064', NULL, 'Protein PB1-F2 [PB1].', NULL, NULL, 'INFV_PB1F2', 237867),
(294142, 'MF_02113_B', NULL, 'Proteasome subunit beta [prcB].', NULL, NULL, 'Proteasome_B_B', 237868),
(294143, 'MF_01281', NULL, '5''-deoxyadenosine deaminase [dadD].', NULL, NULL, 'MTA_SAH_deamin', 237869),
(294144, 'MF_01965', NULL, 'ADP-dependent (S)-NAD(P)H-hydrate dehydratase [nnrD].', NULL, NULL, 'NADHX_dehydratase', 237870),
(294145, 'MF_01817', NULL, 'Tyrosine recombinase XerD-like.', NULL, NULL, 'Recomb_XerD_like', 237871),
(294146, 'MF_00497_B', NULL, 'Glycerol-1-phosphate dehydrogenase [NAD(P)+] [egsA].', NULL, NULL, 'G1P_dehydrogenase_B', 237872),
(294147, 'MF_00668', NULL, '6-carboxyhexanoate--CoA ligase [bioW].', NULL, NULL, 'BioW', 237873),
(294148, 'MF_00129', NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG [mnmG].', NULL, NULL, 'MnmG_GidA', 237874),
(294149, 'MF_00031', NULL, 'Holliday junction ATP-dependent DNA helicase RuvA [ruvA].', NULL, NULL, 'DNA_helic_RuvA', 237875),
(294150, 'MF_01862', NULL, 'Ribosomal RNA small subunit methyltransferase C [rsmC].', NULL, NULL, '16SrRNA_methyltr_C', 237876),
(294151, 'MF_00021', NULL, 'tRNA sulfurtransferase [thiI].', NULL, NULL, 'ThiI', 237877),
(294152, 'MF_00034', NULL, 'Crossover junction endodeoxyribonuclease RuvC [ruvC].', NULL, NULL, 'RuvC', 237878),
(294153, 'MF_00576', NULL, 'Gas vesicle structural protein [gvpA].', NULL, NULL, 'Gas_vesicle_A', 237879);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(294154, 'MF_01455', NULL, 'UPF0757 protein YmgG [ymgG].', NULL, NULL, 'UPF0757', 237880),
(294155, 'MF_03182', NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2 [PAN2].', NULL, NULL, 'PAN2', 237881),
(294156, 'MF_01092', NULL, 'Cell division protein ZapD [zapD].', NULL, NULL, 'ZapD', 237882),
(294157, 'MF_00947', NULL, 'Acid stress chaperone HdeB [hdeB].', NULL, NULL, 'HdeB', 237883),
(294158, 'MF_01142', NULL, 'Antiholin-like protein LrgB [lrgB].', NULL, NULL, 'LrgB', 237884),
(294159, 'MF_01123', NULL, 'Acetyl-coenzyme A synthetase [acs].', NULL, NULL, 'Ac_CoA_synth', 237885),
(294160, 'MF_00354', NULL, 'Isopentenyl-diphosphate delta-isomerase [fni].', NULL, NULL, 'Idi_2', 237886),
(294161, 'MF_04058', NULL, 'Packaging protein 3 [L1].', NULL, NULL, 'ADV_PKG3', 237887),
(294162, 'MF_00822', NULL, 'Urease accessory protein UreE [ureE].', NULL, NULL, 'UreE', 237888),
(294163, 'MF_01858', NULL, 'Ribosomal RNA large subunit methyltransferase K/L [rlmL].', NULL, NULL, '23SrRNA_methyltr_KL', 237889),
(294164, 'MF_00088', NULL, 'UPF0109 protein <locus_tag>.', NULL, NULL, 'UPF0109', 237890),
(294165, 'MF_00331', NULL, 'Cysteine desulfurase IscS [iscS].', NULL, NULL, 'Cys_desulf_IscS', 237891),
(294166, 'MF_02215', NULL, 'Ubiquinone biosynthesis accessory factor UbiJ [ubiJ].', NULL, NULL, 'UbiJ', 237892),
(294167, 'MF_00026', NULL, 'DNA-binding protein <locus_tag>.', NULL, NULL, 'dsDNA_bind', 237893),
(294168, 'MF_00552', NULL, 'Zinc transporter ZitB [zitB].', NULL, NULL, 'ZitB', 237894),
(294169, 'MF_00960', NULL, '2-amino-3,7-dideoxy-D-threo-hept-6-ulosonate synthase [aroA''].', NULL, NULL, 'ADH_synthase', 237895),
(294170, 'MF_00132', NULL, 'Type 2 DNA topoisomerase 6 subunit A [top6A].', NULL, NULL, 'Top6A', 237896),
(294171, 'MF_01050', NULL, 'L-carnitine CoA-transferase [caiB].', NULL, NULL, 'CaiB', 237897),
(294172, 'MF_01258', NULL, 'Coenzyme F420:L-glutamate ligase [cofE].', NULL, NULL, 'F420_ligase_CofE', 237898),
(294173, 'MF_01971', NULL, 'Kynurenine 3-monooxygenase [kmo].', NULL, NULL, 'Kynurenine_monooxygenase', 237899),
(294174, 'MF_04074', NULL, 'Protein X [X].', NULL, NULL, 'HBV_X', 237900),
(294175, 'MF_01980', NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase [pfp].', NULL, NULL, 'Phosphofructokinase_II_Long', 237901),
(294176, 'MF_04006', NULL, 'Protein E6 [E6].', NULL, NULL, 'HPV_E6', 237902),
(294177, 'MF_00866', NULL, 'DNA-directed RNA polymerase subunit Rpo8 [rpo8].', NULL, NULL, 'RNApol_arch_Rpo8', 237903),
(294178, 'MF_00794', NULL, 'Putative antitoxin <locus_tag>.', NULL, NULL, 'UPF0330', 237904),
(294179, 'MF_01037', NULL, 'Methylenetetrahydrofolate--tRNA-(uracil-5-)-methyltransferase TrmFO [trmFO].', NULL, NULL, 'TrmFO', 237905),
(294180, 'MF_01679', NULL, '2,3-diketo-5-methylthiopentyl-1-phosphate enolase [mtnW].', NULL, NULL, 'Salvage_MtnW', 237906),
(294181, 'MF_01134', NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit epsilon [cdhB].', NULL, NULL, 'CdhB', 237907),
(294182, 'MF_00672', NULL, 'UPF0761 membrane protein YihY [yihY].', NULL, NULL, 'UPF0761', 237908),
(294183, 'MF_00798', NULL, 'Transcription attenuation protein MtrB [mtrB].', NULL, NULL, 'Trp_attenuator', 237909),
(294184, 'MF_01022', NULL, 'Histidine biosynthesis bifunctional protein HisB [hisB].', NULL, NULL, 'Bifunc_HisB', 237910),
(294185, 'MF_01672', NULL, 'Inosose dehydratase [iolE].', NULL, NULL, 'IolE', 237911),
(294186, 'MF_04200', NULL, 'Spike glycoprotein [S].', NULL, NULL, 'ALPHA_CORONA_SPIKE', 237912),
(294187, 'MF_01161', NULL, 'tRNA(Ile)-lysidine synthase [tilS].', NULL, NULL, 'tRNA_Ile_lys_synt', 237913),
(294188, 'MF_01698', NULL, 'Mycothiol acetyltransferase [mshD].', NULL, NULL, 'MshD', 237914),
(294189, 'MF_01987', NULL, 'Ribokinase [rbsK].', NULL, NULL, 'Ribokinase', 237915),
(294190, 'MF_01347', NULL, 'ATP synthase subunit beta [atpB].', NULL, NULL, 'ATP_synth_beta_bact', 237916),
(294191, 'MF_03057', NULL, 'Succinate dehydrogenase assembly factor 2, mitochondrial [SDHAF2].', NULL, NULL, 'SDHAF2', 237917),
(294192, 'MF_00160', NULL, 'Phosphoserine aminotransferase [serC].', NULL, NULL, 'SerC_aminotrans_5', 237918);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(294193, 'MF_00453', NULL, 'Phosphoenolpyruvate carboxykinase (ATP) [pckA].', NULL, NULL, 'PEPCK_ATP', 237919),
(294194, 'MF_04047', NULL, 'Pre-hexon-linking protein IIIa.', NULL, NULL, 'ADV_CAP3', 237920),
(294195, 'MF_00267', NULL, 'Probable septum site-determining protein MinC [minC].', NULL, NULL, 'MinC', 237921),
(294196, 'MF_01954', NULL, 'Urease subunit beta [ureB].', NULL, NULL, 'Urease_beta', 237922),
(294197, 'MF_00972', NULL, 'tRNA-specific adenosine deaminase [tadA].', NULL, NULL, 'tRNA_aden_deaminase', 237923),
(294198, 'MF_00015', NULL, 'LexA repressor [lexA].', NULL, NULL, 'LexA', 237924),
(294199, 'MF_01584', NULL, 'UPF0502 protein YceH [yceH].', NULL, NULL, 'UPF0502', 237925),
(294200, 'MF_02018', NULL, 'PanD regulatory factor [panZ].', NULL, NULL, 'PanZ_PanM', 237926),
(294201, 'MF_00458', NULL, 'Photosystem I P700 chlorophyll a apoprotein A1 [psaA].', NULL, NULL, 'PSI_PsaA', 237927),
(294202, 'MF_01918', NULL, 'Cardiolipin synthase C [clsC].', NULL, NULL, 'Cardiolipin_synth_ClsC', 237928),
(294203, 'MF_00076', NULL, 'Imidazoleglycerol-phosphate dehydratase [hisB].', NULL, NULL, 'HisB', 237929),
(294204, 'MF_00214', NULL, '3-dehydroquinate dehydratase [aroD].', NULL, NULL, 'AroD', 237930),
(294205, 'MF_04032', NULL, 'Envelope glycoprotein B [gB].', NULL, NULL, 'HSV_GB', 237931),
(294206, 'MF_00585', NULL, 'UPF0216 protein <locus_tag>.', NULL, NULL, 'UPF0216', 237932),
(294207, 'MF_01305', NULL, 'Photosystem II reaction center protein J [psbJ].', NULL, NULL, 'PSII_PsbJ', 237933),
(294208, 'MF_00582', NULL, 'UPF0215 protein <locus_tag>.', NULL, NULL, 'UPF0215', 237934),
(294209, 'MF_03177', NULL, 'ATP-dependent DNA helicase RRM3 [RRM3].', NULL, NULL, 'RRM3', 237935),
(294210, 'MF_00638', NULL, 'Serine-protein kinase RsbW [rsbW].', NULL, NULL, 'Anti_sigma_B', 237936),
(294211, 'MF_00488', NULL, 'L-lactate dehydrogenase [ldh].', NULL, NULL, 'Lactate_dehydrog', 237937),
(294212, 'MF_01367', NULL, '50S ribosomal protein L14 [rplN].', NULL, NULL, 'Ribosomal_L14', 237938),
(294213, 'MF_00985', NULL, '2-amino-3-ketobutyrate coenzyme A ligase [kbl].', NULL, NULL, '2am3keto_CoA_ligase', 237939),
(294214, 'MF_01802', NULL, 'Chromosome partition protein MukE [mukE].', NULL, NULL, 'MukE', 237940),
(294215, 'MF_01485', NULL, 'RecBCD enzyme subunit RecB [recB].', NULL, NULL, 'RecB', 237941),
(294216, 'MF_01053', NULL, 'UPF0231 protein YacL [yacL].', NULL, NULL, 'UPF0231', 237942),
(294217, 'MF_00617', NULL, 'Mannosyl-3-phosphoglycerate phosphatase [mngB].', NULL, NULL, 'MPGP_rel', 237943),
(294218, 'MF_01295', NULL, 'D-tagatose-1,6-bisphosphate aldolase subunit KbaZ [kbaZ].', NULL, NULL, 'Tagatose_aldol_KbaZ', 237944),
(294219, 'MF_01598', NULL, 'Spermidine export protein MdtJ [mdtJ].', NULL, NULL, 'MdtJ', 237945),
(294220, 'MF_04111', NULL, 'Endolysin.', NULL, NULL, 'ENDOLYSIN_T7', 237946),
(294221, 'MF_01029', NULL, 'UPF0213 protein YhbQ [yhbQ].', NULL, NULL, 'UPF0213', 237947),
(294222, 'MF_01005', NULL, 'Vitamin B12 import ATP-binding protein BtuD [btuD].', NULL, NULL, 'BtuD', 237948),
(294223, 'MF_00286', NULL, 'Disulfide bond formation protein B [dsbB].', NULL, NULL, 'DsbB', 237949),
(294224, 'MF_00732', NULL, 'HTH-type transcriptional regulator MntR [mntR].', NULL, NULL, 'HTH_MntR', 237950),
(294225, 'MF_01922', NULL, 'tRNA(Phe) (4-demethylwyosine(37)-C(7)) aminocarboxypropyltransferase [taw2].', NULL, NULL, 'TYW2_archaea', 237951),
(294226, 'MF_00319', NULL, 'CDP-diacylglycerol pyrophosphatase [cdh].', NULL, NULL, 'Cdh', 237952),
(294227, 'MF_00983', NULL, 'Probable primosomal protein N'' [priA].', NULL, NULL, 'PriA', 237953),
(294228, 'MF_03176', NULL, 'ATP-dependent DNA helicase PIF1 [PIF1].', NULL, NULL, 'PIF1', 237954),
(294229, 'MF_01590', NULL, 'tRNA U34 carboxymethyltransferase [cmoB].', NULL, NULL, 'tRNA_carboxymethyltr_CmoB', 237955),
(294230, 'MF_02224', NULL, '4-phosphopantoate--beta-alanine ligase.', NULL, NULL, 'PPS', 237956),
(294231, 'MF_01371_A', NULL, '50S ribosomal protein L30 [rpmD].', NULL, NULL, 'Ribosomal_L30_A', 237957),
(294232, 'MF_01122', NULL, 'DNA/RNA-binding protein Alba [albA].', NULL, NULL, 'AlbA', 237958);
INSERT INTO "PUBLIC"."MODEL" VALUES
(294233, 'MF_01150', NULL, 'Chaperone protein TorD [torD].', NULL, NULL, 'TorD', 237959),
(294234, 'MF_02236', NULL, 'N-acetyl-L-citrulline deacetylase [argE''].', NULL, NULL, 'ACDase', 237960),
(294235, 'MF_00482', NULL, 'Photosystem I P700 chlorophyll a apoprotein A2 [psaB].', NULL, NULL, 'PSI_PsaB', 237961),
(294236, 'MF_01658', NULL, '3-demethoxyubiquinol 3-hydroxylase [coq7].', NULL, NULL, 'COQ7', 237962),
(294237, 'MF_01399', NULL, 'ATP synthase subunit b'' [atpF2].', NULL, NULL, 'ATP_synth_bprime', 237963),
(294238, 'MF_01419', NULL, 'Phosphoglycolate phosphatase.', NULL, NULL, 'GPH_hydrolase_arch', 237964),
(294239, 'MF_03033', NULL, 'Protein argonaute-4 [EIF2C4].', NULL, NULL, 'AGO4', 237965),
(294240, 'MF_02129', NULL, 'L-carnitine dehydrogenase [lcdH].', NULL, NULL, 'L_carnitine_dehydrog', 237966),
(294241, 'MF_00586', NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit D [gatD].', NULL, NULL, 'GatD', 237967),
(294242, 'MF_01263', NULL, 'CCA-adding enzyme [cca].', NULL, NULL, 'CCA_bact_type3', 237968),
(294243, 'MF_00364', NULL, 'Beta-hexosaminidase [nagZ].', NULL, NULL, 'NagZ', 237969),
(294244, 'MF_00389', NULL, 'Protein TusC [tusC].', NULL, NULL, 'Thiourid_synth_C', 237970),
(294245, 'MF_00855', NULL, 'RuBisCO chaperone RbcX [rbcX].', NULL, NULL, 'RbcX', 237971),
(294246, 'MF_00370', NULL, 'Shikimate kinase [aroK].', NULL, NULL, 'Shik_kinase_arch', 237972),
(294247, 'MF_00461', NULL, 'Ion-translocating oxidoreductase complex subunit C [rsxC].', NULL, NULL, 'RsxC_RnfC', 237973),
(294248, 'MF_01899', NULL, 'Ribonuclease D [rnd].', NULL, NULL, 'RNase_D', 237974),
(294249, 'MF_01330', NULL, 'Protein Ycf2 [ycf2].', NULL, NULL, 'Ycf2', 237975),
(294250, 'MF_01873', NULL, 'Ribosomal RNA large subunit methyltransferase Cfr [cfr].', NULL, NULL, '23SrRNA_methyltr_Cfr', 237976),
(294251, 'MF_00227', NULL, 'Ribonuclease P protein component [rnpA].', NULL, NULL, 'RNase_P', 237977),
(294252, 'MF_01325_A', NULL, '50S ribosomal protein L3 [rplC].', NULL, NULL, 'Ribosomal_L3_A', 237978),
(294253, 'MF_00610', NULL, 'Cytochrome f [petA].', NULL, NULL, 'Cytb6_f_cytF', 237979),
(294254, 'MF_01057', NULL, 'tRNA (guanine-N(7)-)-methyltransferase [trmB].', NULL, NULL, 'tRNA_methyltr_TrmB', 237980),
(294255, 'MF_01277', NULL, 'HTH-type transcriptional repressor PurR [purR].', NULL, NULL, 'HTH_type_PurR', 237981),
(294256, 'MF_02081', NULL, 'Peptidoglycan D,D-transpeptidase MrdA [mrdA].', NULL, NULL, 'MrdA_transpept', 237982),
(294257, 'MF_01362', NULL, 'UPF0387 membrane protein YohO [yohO].', NULL, NULL, 'UPF0387', 237983),
(294258, 'MF_04164', NULL, 'RNA polymerase sigma-like factor.', NULL, NULL, 'T4_Sigma_like_factor', 237984),
(294259, 'MF_01628', NULL, 'Thymidine phosphorylase [deoA].', NULL, NULL, 'Thymid_phosp', 237985),
(294260, 'MF_01186', NULL, 'LPS-assembly lipoprotein LptE [lptE].', NULL, NULL, 'LPS_assembly_LptE', 237986),
(294261, 'MF_01811', NULL, 'Membrane protein insertase YidC [yidC].', NULL, NULL, 'YidC_type2', 237987),
(294262, 'MF_00730', NULL, 'Nucleoid-associated protein YejK [yejK].', NULL, NULL, 'NdpA', 237988),
(294263, 'MF_00907', NULL, 'Proofreading thioesterase EntH [entH].', NULL, NULL, 'Thioesterase_EntH', 237989),
(294264, 'MF_01507', NULL, 'UPF0297 protein <locus_tag>.', NULL, NULL, 'UPF0297', 237990),
(294265, 'MF_01137', NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit alpha [cdhA].', NULL, NULL, 'CdhA', 237991),
(294266, 'MF_00928', NULL, '4-O-beta-D-mannosyl-D-glucose phosphorylase.', NULL, NULL, 'Man_Glc_phosphorylase', 237992),
(294267, 'MF_01601', NULL, 'ADP-L-glycero-D-manno-heptose-6-epimerase [hldD].', NULL, NULL, 'Heptose_epimerase', 237993),
(294268, 'MF_00474', NULL, 'Photosystem I reaction center subunit PsaK [psaK].', NULL, NULL, 'PSI_PsaK', 237994),
(294269, 'MF_01808', NULL, 'Tyrosine recombinase XerC [xerC].', NULL, NULL, 'Recomb_XerC_XerD', 237995),
(294270, 'MF_00653', NULL, 'Coenzyme PQQ synthesis protein B [pqqB].', NULL, NULL, 'PQQ_syn_PqqB', 237996),
(294271, 'MF_04130', NULL, 'Outer capsid glycoprotein VP7.', NULL, NULL, 'Rota_VP7', 237997);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(294272, 'MF_02218', NULL, 'Glucosamine kinase.', NULL, NULL, 'GlcN_kinase', 237998),
(294273, 'MF_00229', NULL, 'Histidine ammonia-lyase [hutH].', NULL, NULL, 'His_ammonia_lyase', 237999),
(294274, 'MF_00289_B', NULL, 'Proteasome subunit alpha [prcA].', NULL, NULL, 'Proteasome_A_B', 238000),
(294275, 'MF_04162', NULL, 'Sliding-clamp-loader large subunit.', NULL, NULL, 'T4_Clamp_Loader_L', 238001),
(294276, 'MF_00811', NULL, '2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-succinyltransferase [dapD].', NULL, NULL, 'DapD', 238002),
(294277, 'MF_00419', NULL, 'Phosphoribosylformylglycinamidine synthase [purL].', NULL, NULL, 'PurL_1', 238003),
(294278, 'MF_01170', NULL, 'Chromosome-anchoring protein RacA [racA].', NULL, NULL, 'RacA', 238004),
(294279, 'MF_01272', NULL, 'Heme oxygenase (staphylobilin-producing) [isdG].', NULL, NULL, 'Heme_degrading_monooxygenase', 238005),
(294280, 'MF_01941', NULL, 'Mid-cell-anchored protein Z [mapZ].', NULL, NULL, 'MapZ', 238006),
(294281, 'MF_00306', NULL, 'Signal recognition particle 54 kDa protein [srp54].', NULL, NULL, 'SRP54', 238007),
(294282, 'MF_01856', NULL, 'Ribosomal RNA small subunit methyltransferase B [rsmB].', NULL, NULL, '16SrRNA_methyltr_B', 238008),
(294283, 'MF_00415', NULL, 'Flagellar L-ring protein [flgH].', NULL, NULL, 'FlgH', 238009),
(294284, 'MF_02050', NULL, 'Fused isobutyryl-CoA mutase [icmF].', NULL, NULL, 'IcmF', 238010),
(294285, 'MF_00911', NULL, 'Cell division protein FtsQ [ftsQ].', NULL, NULL, 'FtsQ_subfam', 238011),
(294286, 'MF_00456', NULL, 'Glutamate 5-kinase [proB].', NULL, NULL, 'ProB', 238012),
(294287, 'MF_00269', NULL, 'Thiol peroxidase [tpx].', NULL, NULL, 'Tpx', 238013),
(294288, 'MF_00602', NULL, 'Protein-arginine kinase [mcsB].', NULL, NULL, 'Prot_Arg_kinase', 238014),
(294289, 'MF_01195', NULL, 'N-acetylneuraminate epimerase [nanM].', NULL, NULL, 'NanM', 238015),
(294290, 'MF_00430', NULL, 'Na(+)-translocating NADH-quinone reductase subunit F [nqrF].', NULL, NULL, 'NqrF', 238016),
(294291, 'MF_01586', NULL, 'Probable [Fe-S]-dependent transcriptional repressor [feoC].', NULL, NULL, 'FeoC', 238017),
(294292, 'MF_00427', NULL, 'Na(+)-translocating NADH-quinone reductase subunit C [nqrC].', NULL, NULL, 'NqrC', 238018),
(294293, 'MF_00774', NULL, 'Acyl transferase [luxD].', NULL, NULL, 'LuxD', 238019),
(294294, 'MF_00861', NULL, 'Ethanolamine ammonia-lyase large subunit [eutB].', NULL, NULL, 'EutB', 238020),
(294295, 'MF_01928', NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase [purK].', NULL, NULL, 'PurK', 238021),
(294296, 'MF_00322', NULL, 'Type 2 DNA topoisomerase 6 subunit B [top6B].', NULL, NULL, 'Top6B', 238022),
(294297, 'MF_00550', NULL, 'Peptidase T [pepT].', NULL, NULL, 'Aminopeptidase_M20', 238023),
(294298, 'MF_00166', NULL, 'DNA-binding protein Fis [fis].', NULL, NULL, 'DNA_binding_Fis', 238024),
(294299, 'MF_00374', NULL, '50S ribosomal protein L29 [rpmC].', NULL, NULL, 'Ribosomal_L29', 238025),
(294300, 'MF_03029', NULL, 'Ribosome biogenesis protein @gn(WDR12) [WDR12].', NULL, NULL, 'WDR12', 238026),
(294301, 'MF_00283', NULL, 'Phenylalanine--tRNA ligase beta subunit [pheT].', NULL, NULL, 'Phe_tRNA_synth_beta1', 238027),
(294302, 'MF_01494', NULL, 'DEAD-box ATP-dependent RNA helicase CshB [cshB].', NULL, NULL, 'DEAD_helicase_CshB', 238028),
(294303, 'MF_01618', NULL, '3-ketoacyl-CoA thiolase [fadI].', NULL, NULL, 'FadI', 238029),
(294304, 'MF_01019', NULL, 'Histidine biosynthesis bifunctional protein HisIE [hisI].', NULL, NULL, 'HisIE', 238030),
(294305, 'MF_01066', NULL, 'Glucans biosynthesis protein C [mdoC].', NULL, NULL, 'MdoC_OpgC', 238031),
(294306, 'MF_00383', NULL, 'Transcription initiation factor IIB [tfb].', NULL, NULL, 'TF2B_arch', 238032),
(294307, 'MF_04101', NULL, 'DNA-directed DNA polymerase.', NULL, NULL, 'DPOL_T7', 238033),
(294308, 'MF_00691', NULL, '5-oxoprolinase subunit A [pxpA].', NULL, NULL, 'PxpA', 238034),
(294309, 'MF_00302', NULL, 'ATP-dependent Clp protease adapter protein ClpS [clpS].', NULL, NULL, 'ClpS', 238035),
(294310, 'MF_00187', NULL, 'Sulfur carrier protein FdhD [fdhD].', NULL, NULL, 'FdhD', 238036);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(294311, 'MF_00538', NULL, 'Probable 4-amino-4-deoxy-L-arabinose-phosphoundecaprenol flippase subunit ArnF [arnF].', NULL, NULL, 'Flippase_ArnF', 238037),
(294312, 'MF_01124', NULL, 'Adapter protein MecA [mecA].', NULL, NULL, 'MecA', 238038),
(294313, 'MF_01376', NULL, '2-aminoethylphosphonate--pyruvate transaminase [phnW].', NULL, NULL, 'PhnW_aminotrans_5', 238039),
(294314, 'MF_04038', NULL, 'Cytoplasmic envelopment protein 1.', NULL, NULL, 'HSV_CEP1', 238040),
(294315, 'MF_01154', NULL, 'Curved DNA-binding protein [cbpA].', NULL, NULL, 'CbpA', 238041),
(294316, 'MF_02100', NULL, 'Uncharacterized methyltransferase <locus_tag>.', NULL, NULL, 'Methyltr_YrrT', 238042),
(294317, 'MF_00304', NULL, 'Thiamine thiazole synthase [thi4].', NULL, NULL, 'Thi4', 238043),
(294318, 'MF_01861', NULL, 'UPF0738 protein <locus_tag>.', NULL, NULL, 'UPF0738', 238044),
(294319, 'MF_01623', NULL, 'Penicillin-insensitive murein endopeptidase [mepA].', NULL, NULL, 'MepA', 238045),
(294320, 'MF_03184', NULL, 'ATP-dependent 6-phosphofructokinase.', NULL, NULL, 'Phosphofructokinase_I_E', 238046),
(294321, 'MF_00693', NULL, 'Probable transcriptional regulatory protein YebC [yebC].', NULL, NULL, 'Transcrip_reg_TACO1', 238047),
(294322, 'MF_00791', NULL, 'Protein ApaG [apaG].', NULL, NULL, 'ApaG', 238048),
(294323, 'MF_00097', NULL, 'Thiamine-phosphate synthase [thiE].', NULL, NULL, 'TMP_synthase', 238049),
(294324, 'MF_01524', NULL, 'Crotonobetaine/carnitine--CoA ligase [caiC].', NULL, NULL, 'CaiC', 238050),
(294325, 'MF_03022', NULL, 'Katanin p80 WD40 repeat-containing subunit B1 [KATNB1].', NULL, NULL, 'Katanin_p80_B1', 238051),
(294326, 'MF_00220_A', NULL, 'Dihydroorotase [pyrC].', NULL, NULL, 'PyrC_classI_A', 238052),
(294327, 'MF_00980', NULL, 'Phosphotransferase RcsD [rcsD].', NULL, NULL, 'RcsD', 238053),
(294328, 'MF_02206', NULL, '3''-5'' exonuclease DinG [dinG].', NULL, NULL, 'DinG_exonucl', 238054),
(294329, 'MF_00746', NULL, 'Protein SprT [sprT].', NULL, NULL, 'SprT', 238055),
(294330, 'MF_00974', NULL, 'DNA primase [dnaG].', NULL, NULL, 'DNA_primase_DnaG', 238056),
(294331, 'MF_00574', NULL, 'Putative ribosomal protein L7Ae-like.', NULL, NULL, 'Ribosomal_L7Ae_Bact', 238057),
(294332, 'MF_00729', NULL, 'Fructose-bisphosphate aldolase class 1 [fda].', NULL, NULL, 'FBP_aldolase_1', 238058),
(294333, 'MF_03211', NULL, 'RNA cytidine acetyltransferase [NAT10].', NULL, NULL, 'RNA_acetyltr_Nat10', 238059),
(294334, 'MF_00943', NULL, 'Maleate isomerase [maiA].', NULL, NULL, 'Maleate_isomerase', 238060),
(294335, 'MF_01893', NULL, 'tRNA pseudouridine synthase Pus10 [pus10].', NULL, NULL, 'Pus10_arch', 238061),
(294336, 'MF_02238', NULL, '3-dehydroshikimate dehydratase.', NULL, NULL, 'DSD', 238062),
(294337, 'MF_02023', NULL, 'Dissimilatory sulfite reductase.', NULL, NULL, 'Sulfite_red', 238063),
(294338, 'MF_02109', NULL, 'Cysteate synthase.', NULL, NULL, 'Cya_synthase', 238064),
(294339, 'MF_01483', NULL, 'RNA polymerase-binding protein RbpA [rbpA].', NULL, NULL, 'RbpA', 238065),
(294340, 'MF_04124', NULL, 'Protein VP3.', NULL, NULL, 'Rota_VP3', 238066),
(294341, 'MF_04013', NULL, 'Tripartite terminase subunit 3 [TRM3].', NULL, NULL, 'HSV_TRM3', 238067),
(294342, 'MF_04081', NULL, 'Virion infectivity factor [vif].', NULL, NULL, 'HIV_VIF', 238068),
(294343, 'MF_04133', NULL, 'Major capsid protein [E].', NULL, NULL, 'CAPSID_LAMBDA', 238069),
(294344, 'MF_00382', NULL, '50S ribosomal protein L20 [rplT].', NULL, NULL, 'Ribosomal_L20', 238070),
(294345, 'MF_00735', NULL, 'Ribosomal protein L11 methyltransferase [prmA].', NULL, NULL, 'Methyltr_PrmA', 238071),
(294346, 'MF_01436', NULL, 'Enterobactin exporter EntS [entS].', NULL, NULL, 'MFS_EntS', 238072),
(294347, 'MF_00050', NULL, 'Elongation factor Ts [tsf].', NULL, NULL, 'EF_Ts', 238073),
(294348, 'MF_00541', NULL, 'L-rhamnose isomerase [rhaA].', NULL, NULL, 'RhaA', 238074),
(294349, 'MF_04067', NULL, 'Nuclear export protein [NS].', NULL, NULL, 'INFV_NEP', 238075),
(294350, 'MF_00605', NULL, 'tRNA (guanine-N(1)-)-methyltransferase [trmD].', NULL, NULL, 'TrmD', 238076);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(294351, 'MF_00507', NULL, 'UPF0181 protein YoaH [yoaH].', NULL, NULL, 'UPF0181', 238077),
(294352, 'MF_00759', NULL, 'DNA mismatch repair protein MutH [mutH].', NULL, NULL, 'MutH', 238078),
(294353, 'MF_00539', NULL, '50S ribosomal protein L27 [rpmA].', NULL, NULL, 'Ribosomal_L27', 238079),
(294354, 'MF_00662', NULL, 'Phosphatidylserine decarboxylase proenzyme [psd].', NULL, NULL, 'PS_decarb_PSD_B_type1', 238080),
(294355, 'MF_00721', NULL, '50S ribosomal protein L14e [rpl14e].', NULL, NULL, 'Ribosomal_L14e', 238081),
(294356, 'MF_00350', NULL, 'DNA repair and recombination protein RadB [radB].', NULL, NULL, 'RadB', 238082),
(294357, 'MF_00962', NULL, 'RNA polymerase sigma factor FliA [fliA].', NULL, NULL, 'Sigma70_FliA', 238083),
(294358, 'MF_01253', NULL, 'Endonuclease 8 [nei].', NULL, NULL, 'Endonuclease_8', 238084),
(294359, 'MF_00106', NULL, 'Mannonate dehydratase [uxuA].', NULL, NULL, 'UxuA', 238085),
(294360, 'MF_00800', NULL, 'UPF0340 protein <locus_tag>.', NULL, NULL, 'UPF0340', 238086),
(294361, 'MF_00369', NULL, '50S ribosomal protein L21e [rpl21e].', NULL, NULL, 'Ribosomal_L21e', 238087),
(294362, 'MF_01604', NULL, 'Thiamine kinase [thiK].', NULL, NULL, 'Thiamine_kinase', 238088),
(294363, 'MF_01515', NULL, 'UPF0316 protein <locus_tag>.', NULL, NULL, 'UPF0316', 238089),
(294364, 'MF_01469', NULL, 'Ribonuclease M5 [rnmV].', NULL, NULL, 'RNase_M5', 238090),
(294365, 'MF_01454', NULL, 'GTPase Obg [obg].', NULL, NULL, 'GTPase_Obg', 238091),
(294366, 'MF_01874', NULL, 'UPF0756 membrane protein YeaL [yeaL].', NULL, NULL, 'UPF0756', 238092),
(294367, 'MF_00295', NULL, 'Homoserine O-succinyltransferase [metAS].', NULL, NULL, 'MetA_acyltransf', 238093),
(294368, 'MF_00009', NULL, 'Endoribonuclease YbeY [ybeY].', NULL, NULL, 'Endoribonucl_YbeY', 238094),
(294369, 'MF_02026', NULL, 'dTDP-4-amino-4,6-dideoxygalactose transaminase [wecE].', NULL, NULL, 'WecE_RffA', 238095),
(294370, 'MF_00481', NULL, '50S ribosomal protein L30e [rpl30e].', NULL, NULL, 'Ribosomal_L30e', 238096),
(294371, 'MF_03058', NULL, 'Vacuolar ATPase assembly integral membrane protein <gene_name> [VMA21].', NULL, NULL, 'VMA21', 238097),
(294372, 'MF_01887', NULL, '23S rRNA (guanosine-2''-O-)-methyltransferase RlmB [rlmB].', NULL, NULL, '23SrRNA_methyltr_B', 238098),
(294373, 'MF_00457', NULL, 'UPF0173 metal-dependent hydrolase <locus_tag>.', NULL, NULL, 'UPF0173', 238099),
(294374, 'MF_04103', NULL, 'Baseplate wedge protein gp7.', NULL, NULL, 'BP07_T4', 238100),
(294375, 'MF_00067', NULL, 'Phosphoheptose isomerase [gmhA].', NULL, NULL, 'GmhA', 238101),
(294376, 'MF_01058', NULL, 'Der GTPase-activating protein YihI [yihI].', NULL, NULL, 'GAP_YihI', 238102),
(294377, 'MF_01104', NULL, 'Protein Syd [syd].', NULL, NULL, 'Syd', 238103),
(294378, 'MF_00518', NULL, 'D-aminoacyl-tRNA deacylase [dtd].', NULL, NULL, 'Deacylase_Dtd', 238104),
(294379, 'MF_00763', NULL, 'UPF0305 protein <locus_tag>.', NULL, NULL, 'UPF0305', 238105),
(294380, 'MF_01337_A', NULL, '50S ribosomal protein L18 [rplR].', NULL, NULL, 'Ribosomal_L18_A', 238106),
(294381, 'MF_00004', NULL, 'Adenine phosphoribosyltransferase [apt].', NULL, NULL, 'Aden_phosphoribosyltr', 238107),
(294382, 'MF_00351', NULL, 'Fibrillarin-like rRNA/tRNA 2''-O-methyltransferase [flpA].', NULL, NULL, 'RNA_methyltransf_FlpA', 238108),
(294383, 'MF_00242', NULL, 'Arginine deiminase [arcA].', NULL, NULL, 'Arg_deiminase', 238109),
(294384, 'MF_00416', NULL, 'Flagellar P-ring protein [flgI].', NULL, NULL, 'FlgI', 238110),
(294385, 'MF_00345', NULL, 'GMP synthase [glutamine-hydrolyzing] subunit B [guaAB].', NULL, NULL, 'GMP_synthase_B', 238111),
(294386, 'MF_00862', NULL, 'Probable inorganic carbon transporter subunit DabB [dabB].', NULL, NULL, 'DabB', 238112),
(294387, 'MF_01389', NULL, 'Urease accessory protein UreG [ureG].', NULL, NULL, 'UreG', 238113),
(294388, 'MF_01267', NULL, '3-keto-L-gulonate-6-phosphate decarboxylase UlaD [ulaD].', NULL, NULL, 'UlaD', 238114),
(294389, 'MF_01156', NULL, 'Iron-sulfur cluster repair protein ScdA [scdA].', NULL, NULL, 'RIC_ScdA', 238115),
(294390, 'MF_01596', NULL, 'PhoP/PhoQ regulator MgrB [mgrB].', NULL, NULL, 'MgrB', 238116);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(294391, 'MF_02033', NULL, 'Cell division protein FtsA [ftsA].', NULL, NULL, 'FtsA', 238117),
(294392, 'MF_00253_B', NULL, 'Glycine--tRNA ligase [glyQS].', NULL, NULL, 'Gly_tRNA_synth_B', 238118),
(294393, 'MF_01261', NULL, 'Multifunctional CCA protein [cca].', NULL, NULL, 'CCA_bact_type1', 238119),
(294394, 'MF_02072', NULL, 'Inhibitor of hydrogen peroxide resistance [iprA].', NULL, NULL, 'IprA', 238120),
(294395, 'MF_04097', NULL, 'Nucleoprotein [N].', NULL, NULL, 'GAMMA_CORONA_NCAP', 238121),
(294396, 'MF_02038', NULL, 'Probable hercynylcysteine sulfoxide lyase [egtE].', NULL, NULL, 'EgtE', 238122),
(294397, 'MF_01901', NULL, 'Arginine exporter protein ArgO [argO].', NULL, NULL, 'ArgO', 238123),
(294398, 'MF_00054_B', NULL, 'Elongation factor G [fusA].', NULL, NULL, 'EF_G_EF_2_B', 238124),
(294399, 'MF_01095', NULL, 'UPF0292 protein <locus_tag>.', NULL, NULL, 'UPF0292', 238125),
(294400, 'MF_03110', NULL, 'Structure-specific endonuclease subunit @gn(SLX4) [SLX4].', NULL, NULL, 'Endonuc_su_Slx4', 238126),
(294401, 'MF_02220', NULL, 'Xylulose kinase [xylB].', NULL, NULL, 'XylB', 238127),
(294402, 'MF_00802', NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme [glnE].', NULL, NULL, 'GlnE', 238128),
(294403, 'MF_00902', NULL, 'Sec-independent protein translocase protein TatC [tatC].', NULL, NULL, 'TatC', 238129),
(294404, 'MF_00722', NULL, 'Endonuclease NucS [nucS].', NULL, NULL, 'NucS', 238130),
(294405, 'MF_02233', NULL, 'Ubiquinone biosynthesis protein UbiV [ubiV].', NULL, NULL, 'UbiV', 238131),
(294406, 'MF_01460', NULL, 'Chromophore lyase CpcT/CpeT [cpcT].', NULL, NULL, 'Chrphore_lyase_CpxT', 238132),
(294407, 'MF_00100_B', NULL, 'Translation initiation factor IF-2 [infB].', NULL, NULL, 'IF_2_B', 238133),
(294408, 'MF_02071', NULL, 'Endolytic peptidoglycan transglycosylase RlpA [rlpA].', NULL, NULL, 'RlpA', 238134),
(294409, 'MF_00443', NULL, 'Thiazole synthase [thiG].', NULL, NULL, 'ThiG', 238135),
(294410, 'MF_00190', NULL, 'Cardiolipin synthase A [clsA].', NULL, NULL, 'Cardiolipin_synth_ClsA', 238136),
(294411, 'MF_00013', NULL, 'Octanoyltransferase [lipB].', NULL, NULL, 'LipB', 238137),
(294412, 'MF_00677', NULL, 'UPF0261 protein <locus_tag>.', NULL, NULL, 'UPF0261', 238138),
(294413, 'MF_04042', NULL, 'Cytoplasmic envelopment protein 3.', NULL, NULL, 'HSV_CEP3_gammahv', 238139),
(294414, 'MF_01321', NULL, 'DNA-directed RNA polymerase subunit beta [rpoB].', NULL, NULL, 'RNApol_bact_RpoB', 238140),
(294415, 'MF_01547', NULL, 'Ribosomal RNA large subunit methyltransferase E [rlmE].', NULL, NULL, 'RNA_methyltr_E', 238141),
(294416, 'MF_00201', NULL, 'DNA repair protein RecO [recO].', NULL, NULL, 'RecO', 238142),
(294417, 'MF_03171', NULL, 'Adenylate kinase isoenzyme 1 [AK1].', NULL, NULL, 'Adenylate_kinase_AK1', 238143),
(294418, 'MF_01418', NULL, 'Agmatinase [speB].', NULL, NULL, 'SpeB', 238144),
(294419, 'MF_01431', NULL, 'Pyrimidine-specific ribonucleoside hydrolase RihA [rihA].', NULL, NULL, 'Pyrim_hydro_RihA', 238145),
(294420, 'MF_01898', NULL, 'DNA gyrase subunit B [gyrB].', NULL, NULL, 'GyrB', 238146),
(294421, 'MF_00002', NULL, 'Aspartate carbamoyltransferase regulatory chain [pyrI].', NULL, NULL, 'Asp_carb_tr_reg', 238147),
(294422, 'MF_00810', NULL, '50S ribosomal protein L32e [rpl32e].', NULL, NULL, 'Ribosomal_L32e', 238148),
(294423, 'MF_01235', NULL, 'Putative N-acetylmannosamine-6-phosphate 2-epimerase [nanE].', NULL, NULL, 'ManNAc6P_epimer', 238149),
(294424, 'MF_00587', NULL, 'tRNA (pseudouridine(54)-N(1))-methyltransferase [trmY].', NULL, NULL, 'tRNA_methyltr_TrmY', 238150),
(294425, 'MF_00391', NULL, '50S ribosomal protein L34 [rpmH].', NULL, NULL, 'Ribosomal_L34', 238151),
(294426, 'MF_00979', NULL, 'Sensor histidine kinase RcsC [rcsC].', NULL, NULL, 'RcsC', 238152),
(294427, 'MF_01872', NULL, 'tRNA1(Val) (adenine(37)-N6)-methyltransferase [yfiC].', NULL, NULL, 'tRNA_methyltr_YfiC', 238153),
(294428, 'MF_01909', NULL, 'Transcription factor E [tfe].', NULL, NULL, 'TFE_arch', 238154),
(294429, 'MF_03044', NULL, '25S rRNA (adenine(2142)-N(1))-methyltransferase [BMT2].', NULL, NULL, 'BMT2', 238155);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(294430, 'MF_04028', NULL, 'Ribonucleoside-diphosphate reductase small subunit [RIR2].', NULL, NULL, 'HSV_RIR2', 238156),
(294431, 'MF_00199', NULL, 'Bis(5''-nucleosyl)-tetraphosphatase, symmetrical [apaH].', NULL, NULL, 'ApaH', 238157),
(294432, 'MF_00649', NULL, 'DNA gyrase inhibitor YacG [yacG].', NULL, NULL, 'DNA_gyrase_inhibitor_YacG', 238158),
(294433, 'MF_01644', NULL, 'D-phenylhydantoinase [hyuA].', NULL, NULL, 'D_hydantoinase', 238159),
(294434, 'MF_04123', NULL, 'Inner capsid protein VP2.', NULL, NULL, 'Rota_VP2', 238160),
(294435, 'MF_01197', NULL, 'Cell division protein SepF [sepF].', NULL, NULL, 'SepF', 238161),
(294436, 'MF_01476', NULL, '50S ribosomal protein L44e [rpl44e].', NULL, NULL, 'Ribosomal_L44e', 238162),
(294437, 'MF_01325_B', NULL, '50S ribosomal protein L3 [rplC].', NULL, NULL, 'Ribosomal_L3_B', 238163),
(294438, 'MF_03053', NULL, 'Cytoplasmic tRNA 2-thiolation protein 1 [CTU1].', NULL, NULL, 'CTU1', 238164),
(294439, 'MF_01966', NULL, 'NAD(P)H-hydrate epimerase [nnrE].', NULL, NULL, 'NADHX_epimerase', 238165),
(294440, 'MF_01523', NULL, 'Ribosomal RNA small subunit methyltransferase J [rsmJ].', NULL, NULL, '16SrRNA_methyltr_J', 238166),
(294441, 'MF_00321', NULL, 'Probable GTP-binding protein EngB [engB].', NULL, NULL, 'GTPase_EngB', 238167),
(294442, 'MF_01509', NULL, 'Replication factor C small subunit [rfcS].', NULL, NULL, 'RfcS', 238168),
(294443, 'MF_00103', NULL, 'Formamidopyrimidine-DNA glycosylase [mutM].', NULL, NULL, 'Fapy_DNA_glycosyl', 238169),
(294444, 'MF_01664', NULL, 'Heme A synthase [ctaA].', NULL, NULL, 'HemeA_synth_type1', 238170),
(294445, 'MF_00564', NULL, 'Ribonuclease PH [rph].', NULL, NULL, 'RNase_PH', 238171),
(294446, 'MF_00941', NULL, 'GDP-mannose mannosyl hydrolase [gmm].', NULL, NULL, 'GDPMH_gmm', 238172),
(294447, 'MF_00948', NULL, 'Transcription termination/antitermination protein NusG [nusG].', NULL, NULL, 'NusG', 238173),
(294448, 'MF_02004', NULL, 'Valine--tRNA ligase [valS].', NULL, NULL, 'Val_tRNA_synth_type1', 238174),
(294449, 'MF_00656', NULL, 'Coenzyme PQQ synthesis protein A [pqqA].', NULL, NULL, 'PQQ_syn_PqqA', 238175),
(294450, 'MF_00412', NULL, 'Gamma-glutamyl phosphate reductase [proA].', NULL, NULL, 'ProA', 238176),
(294451, 'MF_00355', NULL, 'Light-independent protochlorophyllide reductase iron-sulfur ATP-binding protein [bchL].', NULL, NULL, 'ChlL_BchL', 238177),
(294452, 'MF_01003', NULL, 'Probable ECA polymerase [wzyE].', NULL, NULL, 'WzyE', 238178),
(294453, 'MF_00544', NULL, 'Tryptophanase [tnaA].', NULL, NULL, 'Tryptophanase', 238179),
(294454, 'MF_00619', NULL, 'Probable 30S ribosomal protein 3, chloroplastic [ycf65].', NULL, NULL, 'Ribosomal_plastid_S3', 238180),
(294455, 'MF_01805', NULL, 'Segregation and condensation protein A [scpA].', NULL, NULL, 'ScpA', 238181),
(294456, 'MF_04010', NULL, 'DNA helicase/primase complex-associated protein.', NULL, NULL, 'HSV_HEPA', 238182),
(294457, 'MF_00071', NULL, 'Elongation factor 4 [lepA].', NULL, NULL, 'LepA', 238183),
(294458, 'MF_03001', NULL, 'Eukaryotic translation initiation factor 3 subunit B [EIF3B].', NULL, NULL, 'eIF3b', 238184),
(294459, 'MF_01208', NULL, 'Orotate phosphoribosyltransferase [pyrE].', NULL, NULL, 'PyrE', 238185),
(294460, 'MF_00487', NULL, 'Malate dehydrogenase [mdh].', NULL, NULL, 'Malate_dehydrog_3', 238186),
(294461, 'MF_01098', NULL, 'Tetrahydromethanopterin S-methyltransferase subunit E [mtrE].', NULL, NULL, 'MtrE', 238187),
(294462, 'MF_00281', NULL, 'Phenylalanine--tRNA ligase alpha subunit [pheS].', NULL, NULL, 'Phe_tRNA_synth_alpha1', 238188),
(294463, 'MF_01952', NULL, 'L-ribulose-5-phosphate 4-epimerase UlaF [ulaF].', NULL, NULL, 'UlaF', 238189),
(294464, 'MF_00431', NULL, 'Photosystem I reaction center subunit VIII [psaI].', NULL, NULL, 'PSI_PsaI', 238190),
(294465, 'MF_00327', NULL, '50S ribosomal protein L37Ae [rpl37ae].', NULL, NULL, 'Ribosomal_L37Ae', 238191),
(294466, 'MF_00843', NULL, 'Major outer membrane lipoprotein Lpp [lpp].', NULL, NULL, 'Lpp', 238192),
(294467, 'MF_00148', NULL, 'Uracil-DNA glycosylase [ung].', NULL, NULL, 'UDG', 238193);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(294468, 'MF_02237', NULL, 'tRNA (cytosine(72)-C(5))-methyltransferase.', NULL, NULL, 'NSUN6', 238194),
(294469, 'MF_01039', NULL, '2,3-bisphosphoglycerate-dependent phosphoglycerate mutase [gpmA].', NULL, NULL, 'PGAM_GpmA', 238195),
(294470, 'MF_00075', NULL, 'Translation initiation factor IF-1 [infA].', NULL, NULL, 'IF_1', 238196),
(294471, 'MF_00530', NULL, 'ATP synthase epsilon chain [atpC].', NULL, NULL, 'ATP_synth_epsil_bac', 238197),
(294472, 'MF_01314', NULL, 'Anaerobic nitric oxide reductase transcription regulator NorR [norR].', NULL, NULL, 'NorR', 238198),
(294473, 'MF_01517', NULL, 'Malate dehydrogenase [mdh].', NULL, NULL, 'Malate_dehydrog_2', 238199),
(294474, 'MF_00563', NULL, 'S-inosyl-L-homocysteine hydrolase [ahcY].', NULL, NULL, 'AdoHcyase', 238200),
(294475, 'MF_03178', NULL, 'NADPH-dependent diflavin oxidoreductase 1 [TAH18].', NULL, NULL, 'NDOR1', 238201),
(294476, 'MF_00290', NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase [trm1].', NULL, NULL, 'tRNA_dimethyltr_TRM1', 238202),
(294477, 'MF_00789', NULL, 'UPF0319 protein YccT [yccT].', NULL, NULL, 'UPF0319', 238203),
(294478, 'MF_02064', NULL, 'RNA polymerase sigma factor SigI [sigI].', NULL, NULL, 'Sigma70_SigI', 238204),
(294479, 'MF_00505', NULL, 'Chaperone protein HtpG [htpG].', NULL, NULL, 'HSP90', 238205),
(294480, 'MF_00439', NULL, 'Photosystem I assembly protein Ycf3 [ycf3].', NULL, NULL, 'Ycf3', 238206),
(294481, 'MF_02108', NULL, 'HTH-type transcriptional regulator MurR [murR].', NULL, NULL, 'HTH_type_MurR', 238207),
(294482, 'MF_00262', NULL, 'Cell division topological specificity factor [minE].', NULL, NULL, 'MinE', 238208),
(294483, 'MF_00147_B', NULL, 'Triosephosphate isomerase [tpiA].', NULL, NULL, 'TIM_B', 238209),
(294484, 'MF_01307_B', NULL, '30S ribosomal protein S5 [rpsE].', NULL, NULL, 'Ribosomal_S5_B', 238210),
(294485, 'MF_01063', NULL, 'Esterase FrsA [frsA].', NULL, NULL, 'FrsA', 238211),
(294486, 'MF_01942', NULL, 'Lipid A biosynthesis lauroyltransferase [lpxL].', NULL, NULL, 'Lipid_A_LpxL_LpxP', 238212),
(294487, 'MF_00405', NULL, '3-hydroxydecanoyl-[acyl-carrier-protein] dehydratase [fabA].', NULL, NULL, 'FabA', 238213),
(294488, 'MF_00987', NULL, 'L-fuculose phosphate aldolase [fucA].', NULL, NULL, 'FucA', 238214),
(294489, 'MF_01884', NULL, 'Transcription termination factor Rho [rho].', NULL, NULL, 'Rho', 238215),
(294490, 'MF_01120', NULL, '[LysW]-lysine/[LysW]-ornithine hydrolase [lysK].', NULL, NULL, 'LysK', 238216),
(294491, 'MF_01441', NULL, 'DNA protection during starvation protein [dps].', NULL, NULL, 'Dps', 238217),
(294492, 'MF_01493', NULL, 'DEAD-box ATP-dependent RNA helicase CshA [cshA].', NULL, NULL, 'DEAD_helicase_CshA', 238218),
(294493, 'MF_01334', NULL, '50S ribosomal protein L25 [rplY].', NULL, NULL, 'Ribosomal_L25_CTC', 238219),
(294494, 'MF_01625', NULL, 'ATPase RavA [ravA].', NULL, NULL, 'ATPase_RavA', 238220),
(294495, 'MF_01620', NULL, '3-ketoacyl-CoA thiolase [fadA].', NULL, NULL, 'FadA', 238221),
(294496, 'MF_01034', NULL, 'Putative D-alanyl-D-alanine carboxypeptidase [yfeW].', NULL, NULL, 'S12_YfeW', 238222),
(294497, 'MF_01600', NULL, 'UPF0182 protein <locus_tag>.', NULL, NULL, 'UPF0182', 238223),
(294498, 'MF_00177', NULL, 'Lysine--tRNA ligase [lysS].', NULL, NULL, 'Lys_tRNA_synth_class1', 238224),
(294499, 'MF_04020', NULL, 'Small capsomere-interacting protein [SCP].', NULL, NULL, 'HSV_SCP_alphahv', 238225),
(294500, 'MF_01652', NULL, '3-(3-hydroxy-phenyl)propionate/3-hydroxycinnamic acid hydroxylase [mhpA].', NULL, NULL, 'MhpA', 238226),
(294501, 'MF_01503', NULL, 'Putative regulatory protein <locus_tag>.', NULL, NULL, 'RemA', 238227),
(294502, 'MF_01619', NULL, 'NAD-dependent malic enzyme [maeA].', NULL, NULL, 'NAD_malic_enz', 238228),
(294503, 'MF_01680', NULL, '2-hydroxy-3-keto-5-methylthiopentenyl-1-phosphate phosphatase [mtnX].', NULL, NULL, 'Salvage_MtnX', 238229),
(294504, 'MF_00736', NULL, '50S ribosomal protein L11 [rplK].', NULL, NULL, 'Ribosomal_L11', 238230),
(294505, 'MF_01088', NULL, 'Universal stress protein B [uspB].', NULL, NULL, 'UspB', 238231);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(294506, 'MF_01640', NULL, 'D-erythrose-4-phosphate dehydrogenase [epd].', NULL, NULL, 'E4P_dehydrog', 238232),
(294507, 'MF_00342', NULL, 'UPF0147 protein <locus_tag>.', NULL, NULL, 'UPF0147', 238233),
(294508, 'MF_01131', NULL, 'Redox-sensing transcriptional repressor Rex [rex].', NULL, NULL, 'Rex', 238234),
(294509, 'MF_01549', NULL, 'Protein DsrB [dsrB].', NULL, NULL, 'DsrB', 238235),
(294510, 'MF_03016', NULL, '40S ribosomal protein SA [RPSA].', NULL, NULL, 'Ribosomal_S2_laminin_receptor', 238236),
(294511, 'MF_03127', NULL, 'Adenylosuccinate synthetase isozyme 2 [ADSS].', NULL, NULL, 'Adenylosucc_synth_vert_acid', 238237),
(294512, 'MF_00982', NULL, 'Transcriptional regulatory protein RcsA [rcsA].', NULL, NULL, 'RcsA', 238238),
(294513, 'MF_00558', NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta [sucC].', NULL, NULL, 'Succ_CoA_beta', 238239),
(294514, 'MF_00100_A', NULL, 'Translation initiation factor IF-2 [infB].', NULL, NULL, 'IF_2_A', 238240),
(294515, 'MF_00155', NULL, 'Cytochrome c oxidase assembly protein CtaG [ctaG].', NULL, NULL, 'CtaG', 238241),
(294516, 'MF_00215', NULL, 'Pantothenate kinase [coaA].', NULL, NULL, 'Pantothen_kinase_1', 238242),
(294517, 'MF_01307_A', NULL, '30S ribosomal protein S5 [rpsE].', NULL, NULL, 'Ribosomal_S5_A', 238243),
(294518, 'MF_00510', NULL, 'Peptidase E [pepE].', NULL, NULL, 'Peptidase_E', 238244),
(294519, 'MF_02080', NULL, 'Peptidoglycan D,D-transpeptidase FtsI [ftsI].', NULL, NULL, 'FtsI_transpept', 238245),
(294520, 'MF_04041', NULL, 'Cytoplasmic envelopment protein 3.', NULL, NULL, 'HSV_CEP3_betahv', 238246),
(294521, 'MF_00964', NULL, 'ATP-dependent RNA helicase DeaD [deaD].', NULL, NULL, 'DEAD_helicase_DeaD', 238247),
(294522, 'MF_01631', NULL, 'Bifunctional protein GlmU [glmU].', NULL, NULL, 'GlmU', 238248),
(294523, 'MF_01516', NULL, 'Malate dehydrogenase [mdh].', NULL, NULL, 'Malate_dehydrog_1', 238249),
(294524, 'MF_01857', NULL, 'Ribosomal RNA large subunit methyltransferase I [rlmI].', NULL, NULL, '23SrRNA_methyltr_I', 238250),
(294525, 'MF_02030', NULL, 'Undecaprenyl-phosphate alpha-N-acetylglucosaminyl 1-phosphate transferase [wecA].', NULL, NULL, 'WecA_Gammaproteo', 238251),
(294526, 'MF_01602', NULL, 'Lipoate-protein ligase A [lplA].', NULL, NULL, 'LplA', 238252),
(294527, 'MF_01880', NULL, 'Dipeptide permease D [dtpD].', NULL, NULL, 'PTR2_DtpD_subfam', 238253),
(294528, 'MF_01099', NULL, 'Tetrahydromethanopterin S-methyltransferase subunit F [mtrF].', NULL, NULL, 'MtrF', 238254),
(294529, 'MF_01041', NULL, 'UPF0223 protein <locus_tag>.', NULL, NULL, 'UPF0223', 238255),
(294530, 'MF_01968', NULL, 'NAD-dependent protein deacetylase [cobB].', NULL, NULL, 'Sirtuin_ClassU', 238256),
(294531, 'MF_01651', NULL, '3-phenylpropionate/cinnamic acid dioxygenase ferredoxin--NAD(+) reductase component [hcaD].', NULL, NULL, 'HcaD', 238257),
(294532, 'MF_01936', NULL, '1,4-dihydroxy-2-naphthoyl-CoA hydrolase [menI].', NULL, NULL, 'MenI', 238258),
(294533, 'MF_01676', NULL, 'Alkyl hydroperoxide reductase AhpD [ahpD].', NULL, NULL, 'AhpD', 238259),
(294534, 'MF_02055', NULL, 'Tyrosine recombinase XerA [xerA].', NULL, NULL, 'Recomb_XerA', 238260),
(294535, 'MF_00998', NULL, 'Sulfoquinovose isomerase.', NULL, NULL, 'SQ_isomerase', 238261),
(294536, 'MF_03000', NULL, 'Eukaryotic translation initiation factor 3 subunit A [EIF3A].', NULL, NULL, 'eIF3a', 238262),
(294537, 'MF_01262', NULL, 'CCA-adding enzyme [cca].', NULL, NULL, 'CCA_bact_type2', 238263),
(294538, 'MF_00761', NULL, 'UPF0303 protein <locus_tag>.', NULL, NULL, 'UPF0303', 238264),
(294539, 'MF_03138', NULL, 'Translation factor GUF1 homolog, organellar chromatophore [lepA].', NULL, NULL, 'GUFP', 238265),
(294540, 'MF_01685', NULL, 'Ferredoxin--NADP reductase.', NULL, NULL, 'FENR2', 238266),
(294541, 'MF_00428', NULL, 'Na(+)-translocating NADH-quinone reductase subunit D [nqrD].', NULL, NULL, 'NqrD', 238267),
(294542, 'MF_02043', NULL, 'tRNA-dihydrouridine(16) synthase [dusC].', NULL, NULL, 'DusC_subfam', 238268),
(294543, 'MF_01013', NULL, 'Imidazole glycerol phosphate synthase subunit HisF [hisF].', NULL, NULL, 'HisF', 238269);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(294544, 'MF_00537', NULL, '30S ribosomal protein S14 [rpsN].', NULL, NULL, 'Ribosomal_S14_1', 238270),
(294545, 'MF_00676', NULL, 'UPF0260 protein YcgN [ycgN].', NULL, NULL, 'UPF0260', 238271),
(294546, 'MF_00578', NULL, 'Glutamate--cysteine ligase [gshA].', NULL, NULL, 'Glu_cys_ligase', 238272),
(294547, 'MF_01624', NULL, 'Arsenate reductase [arsC].', NULL, NULL, 'Arsenate_reduct', 238273),
(294548, 'MF_00522', NULL, 'Photosystem I reaction center subunit IX [psaJ].', NULL, NULL, 'PSI_PsaJ', 238274),
(294549, 'MF_00835', NULL, 'Malonyl-[acyl-carrier protein] O-methyltransferase [bioC].', NULL, NULL, 'BioC', 238275),
(294550, 'MF_04206', NULL, 'Envelope small membrane protein [E].', NULL, NULL, 'GAMMA_CORONA_E', 238276),
(294551, 'MF_00645', NULL, 'Protein <locus_tag>.', NULL, NULL, 'AMMECR1', 238277),
(294552, 'MF_01054', NULL, 'UPF0237 protein <locus_tag>.', NULL, NULL, 'UPF0237', 238278),
(294553, 'MF_01530', NULL, 'Multidrug resistance protein MdtL [mdtL].', NULL, NULL, 'MFS_MdtL', 238279),
(294554, 'MF_00059', NULL, 'DNA-directed RNA polymerase subunit alpha [rpoA].', NULL, NULL, 'RNApol_bact_RpoA', 238280),
(294555, 'MF_03014', NULL, 'Kynurenine formamidase [AFMID].', NULL, NULL, 'KFase', 238281),
(294556, 'MF_00359', NULL, '30S ribosomal protein S3Ae [rps3ae].', NULL, NULL, 'Ribosomal_S3Ae', 238282),
(294557, 'MF_01840', NULL, 'Aerobic magnesium-protoporphyrin IX monomethyl ester [oxidative] cyclase [acsF].', NULL, NULL, 'AcsF', 238283),
(294558, 'MF_02012', NULL, 'Cell division protein ZapA [zapA].', NULL, NULL, 'ZapA_type1', 238284),
(294559, 'MF_00762', NULL, 'UPF0304 protein YfbU [yfbU].', NULL, NULL, 'UPF0304', 238285),
(294560, 'MF_00807', NULL, '1-aminocyclopropane-1-carboxylate deaminase [acdS].', NULL, NULL, 'ACC_deaminase', 238286),
(294561, 'MF_00573', NULL, '50S ribosomal protein L35Ae [rpl35ae].', NULL, NULL, 'Ribosomal_L35Ae', 238287),
(294562, 'MF_02113_A', NULL, 'Proteasome subunit beta [prcB].', NULL, NULL, 'Proteasome_B_A', 238288),
(294563, 'MF_01228', NULL, 'Methionine--tRNA ligase [metG].', NULL, NULL, 'Met_tRNA_synth_type2', 238289),
(294564, 'MF_01542', NULL, 'UPF0349 protein <locus_tag>.', NULL, NULL, 'UPF0349', 238290),
(294565, 'MF_00476', NULL, 'Nickel-responsive regulator [nikR].', NULL, NULL, 'NikR', 238291),
(294566, 'MF_01699', NULL, 'Pyrimidine monooxygenase RutA [rutA].', NULL, NULL, 'RutA', 238292),
(294567, 'MF_01961', NULL, 'Catalase-peroxidase [katG].', NULL, NULL, 'Catal_peroxid', 238293),
(294568, 'MF_00634', NULL, 'UPF0235 protein YggU [yggU].', NULL, NULL, 'UPF0235', 238294),
(294569, 'MF_01919', NULL, 'Cell division protein ZapE [zapE].', NULL, NULL, 'ZapE', 238295),
(294570, 'MF_01044', NULL, 'Protein TsgA [tsgA].', NULL, NULL, 'MFS_TsgA', 238296),
(294571, 'MF_00147_A', NULL, 'Triosephosphate isomerase [tpiA].', NULL, NULL, 'TIM_A', 238297),
(294572, 'MF_00966', NULL, 'Glucose-6-phosphate 1-dehydrogenase [zwf].', NULL, NULL, 'G6PD', 238298),
(294573, 'MF_00708', NULL, 'Fumarate reductase subunit C [frdC].', NULL, NULL, 'Fumarate_red_C', 238299),
(294574, 'MF_00334', NULL, 'Homogentisate 1,2-dioxygenase [hmgA].', NULL, NULL, 'Homogentis_dioxygen', 238300),
(294575, 'MF_00423', NULL, 'L-seryl-tRNA(Sec) selenium transferase [selA].', NULL, NULL, 'SelA', 238301),
(294576, 'MF_00704', NULL, 'Probable aspartoacylase.', NULL, NULL, 'Aspartoacylase', 238302),
(294577, 'MF_01169', NULL, '2-oxoglutarate dehydrogenase E1 component [odhA].', NULL, NULL, 'SucA_OdhA', 238303),
(294578, 'MF_00984', NULL, 'Single-stranded DNA-binding protein.', NULL, NULL, 'SSB', 238304),
(294579, 'MF_02075', NULL, 'Aspartate--tRNA(Asp) ligase [aspS].', NULL, NULL, 'Asp_tRNA_synth_type2', 238305),
(294580, 'MF_01568', NULL, 'UPF0374 protein <locus_tag>.', NULL, NULL, 'UPF0374', 238306),
(294581, 'MF_00778', NULL, 'Probable subtilase-type protease inhibitor [sti].', NULL, NULL, 'SSI', 238307),
(294582, 'MF_00115', NULL, 'Large-conductance mechanosensitive channel [mscL].', NULL, NULL, 'MscL', 238308),
(294583, 'MF_01519', NULL, 'UPF0325 protein YaeH [yaeH].', NULL, NULL, 'UPF0325', 238309);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(294584, 'MF_01564', NULL, 'Protein TusB [tusB].', NULL, NULL, 'Thiourid_synth_B', 238310),
(294585, 'MF_01891', NULL, 'Flagellar transcriptional regulator FlhC [flhC].', NULL, NULL, 'FhlC', 238311),
(294586, 'MF_00141', NULL, 'Elongation factor P [efp].', NULL, NULL, 'EF_P', 238312),
(294587, 'MF_00149', NULL, 'DNA mismatch repair protein MutL [mutL].', NULL, NULL, 'DNA_mis_repair', 238313),
(294588, 'MF_01192', NULL, 'Flap endonuclease Xni [xni].', NULL, NULL, 'Xni', 238314),
(294589, 'MF_01395', NULL, 'Acetyl-coenzyme A carboxylase carboxyl transferase subunit beta, chloroplastic [accD].', NULL, NULL, 'AcetylCoA_CT_beta', 238315),
(294590, 'MF_01407', NULL, 'ORC1-type DNA replication protein.', NULL, NULL, 'ORC1_type_DNA_replic_protein', 238316),
(294591, 'MF_00282', NULL, 'Phenylalanine--tRNA ligase alpha subunit [pheS].', NULL, NULL, 'Phe_tRNA_synth_alpha2', 238317),
(294592, 'MF_00042', NULL, 'Ribonuclease H [rnhA].', NULL, NULL, 'RNase_H', 238318),
(294593, 'MF_00808', NULL, 'Photosystem II reaction center protein T [psbT].', NULL, NULL, 'PSII_PsbT', 238319),
(294594, 'MF_01166', NULL, 'Bifunctional polymyxin resistance protein ArnA [arnA].', NULL, NULL, 'ArnA', 238320),
(294595, 'MF_01183', NULL, 'Chaperone SurA [surA].', NULL, NULL, 'Chaperone_SurA', 238321),
(294596, 'MF_01425', NULL, 'Ferrous-iron efflux pump FieF [fieF].', NULL, NULL, 'Cation_efflux_FieF', 238322),
(294597, 'MF_00506', NULL, 'UPF0180 protein <locus_tag>.', NULL, NULL, 'UPF0180', 238323),
(294598, 'MF_00624', NULL, 'Glucose-1-phosphate adenylyltransferase [glgC].', NULL, NULL, 'GlgC', 238324),
(294599, 'MF_00470', NULL, 'o-succinylbenzoate synthase [menC].', NULL, NULL, 'MenC_1', 238325),
(294600, 'MF_01298', NULL, 'Arginine decarboxylase proenzyme.', NULL, NULL, 'ArgDC', 238326),
(294601, 'MF_04034', NULL, 'Envelope glycoprotein L [gL].', NULL, NULL, 'HSV_GL_alphagamma', 238327),
(294602, 'MF_00171', NULL, 'tRNA pseudouridine synthase A [truA].', NULL, NULL, 'TruA', 238328),
(294603, 'MF_00683', NULL, 'UPF0265 protein YeeX [yeeX].', NULL, NULL, 'UPF0265', 238329),
(294604, 'MF_00993', NULL, 'Aminodeoxyfutalosine synthase [mqnE].', NULL, NULL, 'MqnE', 238330),
(294605, 'MF_01079', NULL, 'UPF0280 protein <locus_tag>.', NULL, NULL, 'UPF0280', 238331),
(294606, 'MF_01621', NULL, 'Fatty acid oxidation complex subunit alpha [fadB].', NULL, NULL, 'FadB', 238332),
(294607, 'MF_01813', NULL, 'Ubiquinone/menaquinone biosynthesis C-methyltransferase UbiE [ubiE].', NULL, NULL, 'MenG_UbiE_methyltr', 238333),
(294608, 'MF_01405', NULL, 'dITP/XTP pyrophosphatase.', NULL, NULL, 'Non_canon_purine_NTPase', 238334),
(294609, 'MF_00642', NULL, 'Cytochrome b559 subunit alpha [psbE].', NULL, NULL, 'PSII_PsbE', 238335),
(294610, 'MF_01371_B', NULL, '50S ribosomal protein L30 [rpmD].', NULL, NULL, 'Ribosomal_L30_B', 238336),
(294611, 'MF_04115', NULL, 'Small outer capsid protein.', NULL, NULL, 'SOC_T4', 238337),
(294612, 'MF_01365_B', NULL, '50S ribosomal protein L6 [rplF].', NULL, NULL, 'Ribosomal_L6_B', 238338),
(294613, 'MF_03152', NULL, 'tRNA (guanine(37)-N1)-methyltransferase [TRMT5].', NULL, NULL, 'TRM5', 238339),
(294614, 'MF_01665', NULL, 'Heme A synthase [ctaA].', NULL, NULL, 'HemeA_synth_type2', 238340),
(294615, 'MF_02101', NULL, '1,4-dihydroxy-2-naphthoyl-CoA hydrolase.', NULL, NULL, 'DHNA_CoA_hydrolase', 238341),
(294616, 'MF_01132', NULL, 'Global transcriptional regulator Spx [spx].', NULL, NULL, 'Spx', 238342),
(294617, 'MF_01224_B', NULL, 'Cyclic pyranopterin monophosphate synthase [moaC].', NULL, NULL, 'MoaC_B', 238343),
(294618, 'MF_00837', NULL, 'Lipid A palmitoyltransferase PagP [pagP].', NULL, NULL, 'PagP_transferase', 238344),
(294619, 'MF_01412', NULL, 'Glutathione-regulated potassium-efflux system protein KefB [kefB].', NULL, NULL, 'K_H_efflux_KefB', 238345),
(294620, 'MF_00743', NULL, 'Fumarate hydratase class II [fumC].', NULL, NULL, 'FumaraseC', 238346),
(294621, 'MF_01643', NULL, 'Formate-dependent phosphoribosylglycinamide formyltransferase [purT].', NULL, NULL, 'PurT', 238347),
(294622, 'MF_01075', NULL, 'K(+)/H(+) antiporter NhaP2 [nhaP2].', NULL, NULL, 'NhaP2', 238348);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(294623, 'MF_01113', NULL, 'DNA polymerase IV [dinB].', NULL, NULL, 'DNApol_IV', 238349),
(294624, 'MF_00549', NULL, 'Methylglyoxal synthase [mgsA].', NULL, NULL, 'Methylglyoxal_synth', 238350),
(294625, 'MF_04102', NULL, 'Baseplate wedge protein gp6.', NULL, NULL, 'BP06_T4', 238351),
(294626, 'MF_03054', NULL, 'Cytoplasmic tRNA 2-thiolation protein 2 [CTU2].', NULL, NULL, 'CTU2', 238352),
(294627, 'MF_01444', NULL, 'Putative phosphoesterase <locus_tag>.', NULL, NULL, '2H_phosphoesterase_YjcG', 238353),
(294628, 'PTHR34271:SF15', NULL, NULL, NULL, NULL, 'WIYLD DOMAIN-CONTAINING PROTEIN', 238354),
(294629, 'PTHR34271:SF5', NULL, NULL, NULL, NULL, 'WIYLD DOMAIN-CONTAINING PROTEIN', 238354),
(294630, 'PTHR34271:SF6', NULL, NULL, NULL, NULL, 'WIYLD DOMAIN-CONTAINING PROTEIN', 238354),
(294631, 'PTHR34271:SF11', NULL, NULL, NULL, NULL, 'WIYLD DOMAIN-CONTAINING PROTEIN', 238354),
(294632, 'PTHR34271:SF1', NULL, NULL, NULL, NULL, 'NUCLEOLAR HISTONE METHYLTRANSFERASE-RELATED PROTEIN', 238354),
(294633, 'PTHR34271', NULL, NULL, NULL, NULL, 'NUCLEOLAR HISTONE METHYLTRANSFERASE-RELATED PROTEIN', 238354),
(294634, 'PTHR34271:SF9', NULL, NULL, NULL, NULL, 'WIYLD DOMAIN-CONTAINING PROTEIN-RELATED', 238354),
(294635, 'PTHR15288:SF2', NULL, NULL, NULL, NULL, 'DENN DOMAIN-CONTAINING PROTEIN 2D', 238355),
(294636, 'PTHR15288:SF3', NULL, NULL, NULL, NULL, 'DENN DOMAIN-CONTAINING PROTEIN 2A', 238355),
(294637, 'PTHR15288:SF4', NULL, NULL, NULL, NULL, 'OS02G0777100 PROTEIN', 238355),
(294638, 'PTHR15288:SF0', NULL, NULL, NULL, NULL, 'UDENN DOMAIN-CONTAINING PROTEIN', 238355),
(294639, 'PTHR15288:SF29', NULL, NULL, NULL, NULL, 'DENN (AEX-3) DOMAIN-CONTAINING PROTEIN', 238355),
(294640, 'PTHR15288:SF26', NULL, NULL, NULL, NULL, 'UDENN DOMAIN-CONTAINING PROTEIN', 238355),
(294641, 'PTHR15288:SF5', NULL, NULL, NULL, NULL, 'DENN DOMAIN-CONTAINING PROTEIN 2B', 238355),
(294642, 'PTHR15288:SF6', NULL, NULL, NULL, NULL, 'DENN DOMAIN-CONTAINING PROTEIN 2C', 238355),
(294643, 'PTHR15288:SF7', NULL, NULL, NULL, NULL, 'UDENN DOMAIN-CONTAINING PROTEIN', 238355),
(294644, 'PTHR15288:SF22', NULL, NULL, NULL, NULL, 'DENN (AEX-3) DOMAIN PROTEIN', 238355),
(294645, 'PTHR15288:SF21', NULL, NULL, NULL, NULL, 'UDENN DOMAIN-CONTAINING PROTEIN', 238355),
(294646, 'PTHR15288:SF23', NULL, NULL, NULL, NULL, 'UDENN DOMAIN-CONTAINING PROTEIN', 238355),
(294647, 'PTHR15288:SF20', NULL, NULL, NULL, NULL, 'UDENN DOMAIN-CONTAINING PROTEIN', 238355),
(294648, 'PTHR15288:SF30', NULL, NULL, NULL, NULL, 'DENN DOMAIN, DDENN DOMAIN, UDENN DOMAIN PROTEIN-RELATED', 238355),
(294649, 'PTHR15288', NULL, NULL, NULL, NULL, 'DENN DOMAIN-CONTAINING PROTEIN 2', 238355),
(294650, 'PTHR38739:SF3', NULL, NULL, NULL, NULL, '', 238356),
(294651, 'PTHR38739', NULL, NULL, NULL, NULL, '', 238356),
(294652, 'PTHR38739:SF2', NULL, NULL, NULL, NULL, '', 238356),
(294653, 'PTHR31395:SF16', NULL, NULL, NULL, NULL, 'MANSC DOMAIN CONTAINING 4', 238357),
(294654, 'PTHR31395:SF14', NULL, NULL, NULL, NULL, 'PROTEIN SHISA-5', 238357),
(294655, 'PTHR31395:SF24', NULL, NULL, NULL, NULL, '', 238357),
(294656, 'PTHR31395:SF23', NULL, NULL, NULL, NULL, 'S-LAYER HOMOLOGY DOMAIN-RELATED PROTEIN', 238357),
(294657, 'PTHR31395:SF11', NULL, NULL, NULL, NULL, 'PROTEIN SHISA-LIKE-1', 238357),
(294658, 'PTHR31395:SF22', NULL, NULL, NULL, NULL, '', 238357),
(294659, 'PTHR31395:SF21', NULL, NULL, NULL, NULL, 'GEO05642P1', 238357),
(294660, 'PTHR31395:SF20', NULL, NULL, NULL, NULL, 'STANLEY-CUP', 238357),
(294661, 'PTHR31395:SF3', NULL, NULL, NULL, NULL, 'PROTEIN SHISA-LIKE-2A', 238357),
(294662, 'PTHR31395:SF2', NULL, NULL, NULL, NULL, 'PROTEIN SHISA-LIKE-2B', 238357),
(294663, 'PTHR31395:SF5', NULL, NULL, NULL, NULL, 'PROTEIN SHISA-4', 238357),
(294664, 'PTHR31395:SF4', NULL, NULL, NULL, NULL, 'PROTEIN SHISA-3 HOMOLOG', 238357),
(294665, 'PTHR31395:SF19', NULL, NULL, NULL, NULL, 'PROTEIN CBR-MIG-13', 238357),
(294666, 'PTHR31395:SF18', NULL, NULL, NULL, NULL, 'SHISA FAMILY MEMBER 2A', 238357),
(294667, 'PTHR31395', NULL, NULL, NULL, NULL, 'SHISA', 238357),
(294668, 'PTHR31395:SF0', NULL, NULL, NULL, NULL, 'PROTEIN SHISA-2 HOMOLOG', 238357);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(294669, 'PTHR34207', NULL, NULL, NULL, NULL, 'PROTEIN BIC1', 238358),
(294670, 'PTHR34207:SF14', NULL, NULL, NULL, NULL, '', 238358),
(294671, 'PTHR34207:SF21', NULL, NULL, NULL, NULL, 'OS02G0532800 PROTEIN', 238358),
(294672, 'PTHR34207:SF2', NULL, NULL, NULL, NULL, 'PROTEIN BIC1', 238358),
(294673, 'PTHR34207:SF17', NULL, NULL, NULL, NULL, 'PROTEIN BIC2', 238358),
(294674, 'PTHR34207:SF16', NULL, NULL, NULL, NULL, '', 238358),
(294675, 'PTHR34207:SF18', NULL, NULL, NULL, NULL, '', 238358),
(294676, 'PTHR42841:SF8', NULL, NULL, NULL, NULL, 'AMP-DEPENDENT SYNTHETASE AND LIGASE FAMILY PROTEIN', 238359),
(294677, 'PTHR42841:SF5', NULL, NULL, NULL, NULL, 'FAD/NAD(P)-BINDING OXIDOREDUCTASE FAMILY PROTEIN', 238359),
(294678, 'PTHR42841', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 238359),
(294679, 'PTHR40787', NULL, NULL, NULL, NULL, 'SECRETED PROTEIN', 238360),
(294680, 'PTHR40787:SF2', NULL, NULL, NULL, NULL, 'SECRETED PROTEIN', 238360),
(294681, 'PTHR40787:SF3', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN SEC39, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G05810)-RELATED', 238360),
(294682, 'PTHR34294:SF11', NULL, NULL, NULL, NULL, 'DEOXYRIBONUCLEOSIDE REGULATOR', 238361),
(294683, 'PTHR34294:SF10', NULL, NULL, NULL, NULL, 'BLR3219 PROTEIN', 238361),
(294684, 'PTHR34294', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', 238361),
(294685, 'PTHR34294:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', 238361),
(294686, 'PTHR34294:SF5', NULL, NULL, NULL, NULL, 'CENTRAL GLYCOLYTIC GENES REGULATOR', 238361),
(294687, 'PTHR34294:SF12', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR LSRR', 238361),
(294688, 'PTHR32219:SF15', NULL, NULL, NULL, NULL, '', 238362),
(294689, 'PTHR32219:SF16', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING BETA-1,6-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 238362),
(294690, 'PTHR32219:SF18', NULL, NULL, NULL, NULL, 'BNAA08G14070D PROTEIN', 238362),
(294691, 'PTHR32219:SF23', NULL, NULL, NULL, NULL, 'BNAC07G50300D PROTEIN', 238362),
(294692, 'PTHR32219:SF12', NULL, NULL, NULL, NULL, 'PROTON PUMP-INTERACTOR 4', 238362),
(294693, 'PTHR32219:SF24', NULL, NULL, NULL, NULL, '', 238362),
(294694, 'PTHR32219:SF25', NULL, NULL, NULL, NULL, 'OS01G0747700 PROTEIN', 238362),
(294695, 'PTHR32219:SF20', NULL, NULL, NULL, NULL, 'PROTON PUMP-INTERACTOR 1-LIKE', 238362),
(294696, 'PTHR32219:SF21', NULL, NULL, NULL, NULL, 'PROTON PUMP-INTERACTOR 1-LIKE', 238362),
(294697, 'PTHR32219', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN YLMH-RELATED', 238362),
(294698, 'PTHR32219:SF3', NULL, NULL, NULL, NULL, 'CALPONIN-LIKE DOMAIN PROTEIN', 238362),
(294699, 'PTHR32219:SF2', NULL, NULL, NULL, NULL, 'PROTON PUMP-INTERACTOR 1', 238362),
(294700, 'PTHR32219:SF8', NULL, NULL, NULL, NULL, 'PROTON PUMP-INTERACTOR 2-RELATED', 238362),
(294701, 'PTHR37767:SF1', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 238363),
(294702, 'PTHR37767:SF2', NULL, NULL, NULL, NULL, 'BNAANNG08100D PROTEIN', 238363),
(294703, 'PTHR37767', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 238363),
(294704, 'PTHR48172', NULL, NULL, NULL, NULL, '', 238364),
(294705, 'PTHR48172:SF2', NULL, NULL, NULL, NULL, 'BNAC05G02270D PROTEIN', 238364),
(294706, 'PTHR48172:SF1', NULL, NULL, NULL, NULL, 'PROCESSING PROTEIN PRP39, PUTATIVE-RELATED', 238364),
(294707, 'PTHR16095:SF11', NULL, NULL, NULL, NULL, '', 238365),
(294708, 'PTHR16095:SF10', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 143', 238365),
(294709, 'PTHR16095', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 143 FAMILY MEMBER', 238365),
(294710, 'PTHR16095:SF9', NULL, NULL, NULL, NULL, 'PROLINE AND SERINE-RICH PROTEIN 2', 238365),
(294711, 'PTHR33479:SF6', NULL, NULL, NULL, NULL, 'BOWMAN-BIRK TYPE TRYPSIN INHIBITOR', 238366),
(294712, 'PTHR33479:SF7', NULL, NULL, NULL, NULL, 'BOWMAN-BIRK TYPE BRAN TRYPSIN INHIBITOR', 238366),
(294713, 'PTHR33479:SF8', NULL, NULL, NULL, NULL, 'BOWMAN-BIRK TYPE TRYPSIN INHIBITOR', 238366),
(294714, 'PTHR33479:SF9', NULL, NULL, NULL, NULL, 'BOWMAN_BIRK DOMAIN-CONTAINING PROTEIN', 238366);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(294715, 'PTHR33479:SF14', NULL, NULL, NULL, NULL, 'BOWMAN_BIRK DOMAIN-CONTAINING PROTEIN', 238366),
(294716, 'PTHR33479', NULL, NULL, NULL, NULL, 'BOWMAN-BIRK TYPE BRAN TRYPSIN INHIBITOR', 238366),
(294717, 'PTHR33479:SF18', NULL, NULL, NULL, NULL, 'SEED TRYPSIN/CHYMOTRYPSIN INHIBITOR IVB-LIKE ISOFORM X1', 238366),
(294718, 'PTHR33479:SF19', NULL, NULL, NULL, NULL, 'BOWMAN-BIRK TYPE PROTEINASE INHIBITOR C-II', 238366),
(294719, 'PTHR33479:SF20', NULL, NULL, NULL, NULL, 'BOWMAN_BIRK DOMAIN-CONTAINING PROTEIN', 238366),
(294720, 'PTHR33479:SF21', NULL, NULL, NULL, NULL, 'BOWMAN_BIRK DOMAIN-CONTAINING PROTEIN', 238366),
(294721, 'PTHR33479:SF11', NULL, NULL, NULL, NULL, 'BOWMAN_BIRK DOMAIN-CONTAINING PROTEIN', 238366),
(294722, 'PTHR33479:SF22', NULL, NULL, NULL, NULL, 'BOWMAN-BIRK TYPE BRAN TRYPSIN INHIBITOR', 238366),
(294723, 'PTHR33479:SF13', NULL, NULL, NULL, NULL, 'BOWMAN-BIRK TYPE TRYPSIN INHIBITOR', 238366),
(294724, 'PTHR33479:SF4', NULL, NULL, NULL, NULL, 'BOWMAN-BIRK INHIBITOR1', 238366),
(294725, 'PTHR46486:SF1', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 238367),
(294726, 'PTHR46486', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 238367),
(294727, 'PTHR24396:SF25', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 644', 238368),
(294728, 'PTHR24396:SF28', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN STP3-RELATED', 238368),
(294729, 'PTHR24396:SF29', NULL, NULL, NULL, NULL, 'SI:DKEY-217D24.6', 238368),
(294730, 'PTHR24396:SF19', NULL, NULL, NULL, NULL, 'FI01119P-RELATED', 238368),
(294731, 'PTHR24396', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 238368),
(294732, 'PTHR24396:SF21', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 236', 238368),
(294733, 'PTHR24396:SF22', NULL, NULL, NULL, NULL, 'PROTEIN WIZ', 238368),
(294734, 'PTHR10772:SF57', NULL, NULL, NULL, NULL, 'GROES CHAPERONIN FAMILY-RELATED', 238369),
(294735, 'PTHR10772:SF13', NULL, NULL, NULL, NULL, '10 KDA CHAPERONIN 1, CHLOROPLASTIC-RELATED', 238369),
(294736, 'PTHR10772:SF47', NULL, NULL, NULL, NULL, 'BNAA09G45320D PROTEIN', 238369),
(294737, 'PTHR10772:SF58', NULL, NULL, NULL, NULL, '10 KDA CHAPERONIN', 238369),
(294738, 'PTHR10772:SF39', NULL, NULL, NULL, NULL, 'OS06G0197500 PROTEIN', 238369),
(294739, 'PTHR10772:SF59', NULL, NULL, NULL, NULL, '20 KDA CHAPERONIN, CHLOROPLASTIC-LIKE', 238369),
(294740, 'PTHR10772:SF37', NULL, NULL, NULL, NULL, 'GROES-LIKE FAMILY PROTEIN', 238369),
(294741, 'PTHR10772:SF49', NULL, NULL, NULL, NULL, 'BNAA08G31360D PROTEIN', 238369),
(294742, 'PTHR10772:SF60', NULL, NULL, NULL, NULL, '20 KDA CHAPERONIN, CHLOROPLASTIC', 238369),
(294743, 'PTHR10772:SF61', NULL, NULL, NULL, NULL, 'OS02G0781400 PROTEIN', 238369),
(294744, 'PTHR10772:SF64', NULL, NULL, NULL, NULL, '', 238369),
(294745, 'PTHR10772:SF42', NULL, NULL, NULL, NULL, 'BNAA03G56040D PROTEIN', 238369),
(294746, 'PTHR10772:SF54', NULL, NULL, NULL, NULL, '10 KDA CHAPERONIN-LIKE', 238369),
(294747, 'PTHR10772:SF40', NULL, NULL, NULL, NULL, 'BNAC09G18910D PROTEIN', 238369),
(294748, 'PTHR10772:SF62', NULL, NULL, NULL, NULL, 'BNAA02G05060D PROTEIN', 238369),
(294749, 'PTHR10772:SF52', NULL, NULL, NULL, NULL, 'CHAPERONIN', 238369),
(294750, 'PTHR10772:SF30', NULL, NULL, NULL, NULL, '20 KDA CHAPERONIN, CHLOROPLASTIC-LIKE', 238369),
(294751, 'PTHR10772:SF63', NULL, NULL, NULL, NULL, 'CHAPERONIN', 238369),
(294752, 'PTHR10772', NULL, NULL, NULL, NULL, '10 KDA HEAT SHOCK PROTEIN', 238369),
(294753, 'PTHR10772:SF0', NULL, NULL, NULL, NULL, '10 KDA HEAT SHOCK PROTEIN, MITOCHONDRIAL', 238369),
(294754, 'PTHR11963:SF39', NULL, NULL, NULL, NULL, 'CYTOSOL AMINOPEPTIDASE', 238370),
(294755, 'PTHR11963:SF49', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 238370),
(294756, 'PTHR11963:SF38', NULL, NULL, NULL, NULL, 'CYSTEINYLGLYCINE-S-CONJUGATE DIPEPTIDASE', 238370),
(294757, 'PTHR11963', NULL, NULL, NULL, NULL, 'LEUCINE AMINOPEPTIDASE-RELATED', 238370),
(294758, 'PTHR11963:SF4', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE NPEPL1-RELATED', 238370),
(294759, 'PTHR11963:SF16', NULL, NULL, NULL, NULL, 'CYSTEINYLGLYCINE-S-CONJUGATE DIPEPTIDASE', 238370);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(294760, 'PTHR11963:SF48', NULL, NULL, NULL, NULL, 'ZGC:152830', 238370),
(294761, 'PTHR11963:SF37', NULL, NULL, NULL, NULL, 'LEUCINE AMINOPEPTIDASE 2 CHLOROPLASTIC', 238370),
(294762, 'PTHR11963:SF36', NULL, NULL, NULL, NULL, 'LEUCINE AMINOPEPTIDASE 1', 238370),
(294763, 'PTHR11963:SF25', NULL, NULL, NULL, NULL, 'CYSTEINYLGLYCINE-S-CONJUGATE DIPEPTIDASE', 238370),
(294764, 'PTHR11963:SF47', NULL, NULL, NULL, NULL, 'CYTOSOLIC AMINOPEPTIDASE FAMILY PROTEIN', 238370),
(294765, 'PTHR11963:SF35', NULL, NULL, NULL, NULL, 'CYTOSOL_AP DOMAIN-CONTAINING PROTEIN', 238370),
(294766, 'PTHR11963:SF23', NULL, NULL, NULL, NULL, 'CYTOSOL AMINOPEPTIDASE', 238370),
(294767, 'PTHR11963:SF45', NULL, NULL, NULL, NULL, 'LEUCINE AMINOPEPTIDASE 2, CHLOROPLASTIC-RELATED', 238370),
(294768, 'PTHR11963:SF43', NULL, NULL, NULL, NULL, 'LEUCINE AMINOPEPTIDASE 1, CHLOROPLASTIC', 238370),
(294769, 'PTHR11963:SF42', NULL, NULL, NULL, NULL, 'CYTOSOL_AP DOMAIN-CONTAINING PROTEIN', 238370),
(294770, 'PTHR11963:SF20', NULL, NULL, NULL, NULL, 'PEPTIDASE B', 238370),
(294771, 'PTHR14594:SF1', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 70 KDA', 238371),
(294772, 'PTHR14594', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 70 KDA', 238371),
(294773, 'PTHR14146:SF3', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT SEC8', 238372),
(294774, 'PTHR14146:SF0', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT 4', 238372),
(294775, 'PTHR14146', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT 4', 238372),
(294776, 'PTHR36735', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 238373),
(294777, 'PTHR36735:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 238373),
(294778, 'PTHR16119:SF15', NULL, NULL, NULL, NULL, 'PROTEIN CBG12710', 238374),
(294779, 'PTHR16119:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG11622', 238374),
(294780, 'PTHR16119:SF13', NULL, NULL, NULL, NULL, 'PROTEIN CBG21054', 238374),
(294781, 'PTHR16119:SF18', NULL, NULL, NULL, NULL, 'PROTEIN CBG03472', 238374),
(294782, 'PTHR16119:SF16', NULL, NULL, NULL, NULL, 'PROTEIN CBG12716', 238374),
(294783, 'PTHR16119:SF17', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 144', 238374),
(294784, 'PTHR16119', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 144', 238374),
(294785, 'PTHR16119:SF21', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 144 HOMOLOG B', 238374),
(294786, 'PTHR16119:SF22', NULL, NULL, NULL, NULL, '', 238374),
(294787, 'PTHR22106', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 78', 238375),
(294788, 'PTHR22106:SF5', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 78', 238375),
(294789, 'PTHR30252:SF0', NULL, NULL, NULL, NULL, 'PEPTIDE TRANSPORTER CSTA', 238376),
(294790, 'PTHR30252:SF4', NULL, NULL, NULL, NULL, 'CARBON STARVATION-RELATED', 238376),
(294791, 'PTHR30252:SF3', NULL, NULL, NULL, NULL, 'PYRUVATE/PROTON SYMPORTER BTST', 238376),
(294792, 'PTHR30252:SF2', NULL, NULL, NULL, NULL, 'PEPTIDE TRANSPORTER CSTA', 238376),
(294793, 'PTHR30252', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PEPTIDE TRANSPORTER', 238376),
(294794, 'PTHR46717:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF180', 238377),
(294795, 'PTHR46717', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF180', 238377),
(294796, 'PTHR31610', NULL, NULL, NULL, NULL, 'SLR0360 PROTEIN', 238378),
(294797, 'PTHR31610:SF0', NULL, NULL, NULL, NULL, 'SLR0360 PROTEIN', 238378),
(294798, 'PTHR47997', NULL, NULL, NULL, NULL, 'MYB DOMAIN PROTEIN 55', 238379),
(294799, 'PTHR47997:SF49', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 238379),
(294800, 'PTHR47997:SF45', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB83', 238379),
(294801, 'PTHR47997:SF85', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB39', 238379),
(294802, 'PTHR47997:SF86', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN MYB4-LIKE', 238379),
(294803, 'PTHR47997:SF87', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB26', 238379),
(294804, 'PTHR47997:SF44', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB46', 238379),
(294805, 'PTHR47997:SF88', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB61', 238379);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(294806, 'PTHR47997:SF81', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 238379),
(294807, 'PTHR47997:SF82', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB86', 238379),
(294808, 'PTHR47997:SF83', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 238379),
(294809, 'PTHR47997:SF84', NULL, NULL, NULL, NULL, 'OS01G0285300 PROTEIN', 238379),
(294810, 'PTHR47997:SF40', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB26-LIKE', 238379),
(294811, 'PTHR47997:SF80', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 238379),
(294812, 'PTHR47997:SF6', NULL, NULL, NULL, NULL, '', 238379),
(294813, 'PTHR47997:SF1', NULL, NULL, NULL, NULL, 'OS01G0702700 PROTEIN', 238379),
(294814, 'PTHR47997:SF2', NULL, NULL, NULL, NULL, 'MYB-LIKE DNA-BINDING DOMAIN CONTAINING PROTEIN', 238379),
(294815, 'PTHR47997:SF38', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB86', 238379),
(294816, 'PTHR47997:SF34', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN HV33-LIKE', 238379),
(294817, 'PTHR47997:SF78', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 238379),
(294818, 'PTHR47997:SF79', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN', 238379),
(294819, 'PTHR47997:SF7', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN 330-LIKE ISOFORM X1', 238379),
(294820, 'PTHR47997:SF36', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR MYB117', 238379),
(294821, 'PTHR47997:SF37', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 238379),
(294822, 'PTHR47997:SF8', NULL, NULL, NULL, NULL, '', 238379),
(294823, 'PTHR47997:SF74', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 238379),
(294824, 'PTHR47997:SF30', NULL, NULL, NULL, NULL, 'BNAA01G30350D PROTEIN', 238379),
(294825, 'PTHR47997:SF31', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 238379),
(294826, 'PTHR47997:SF75', NULL, NULL, NULL, NULL, 'MYB DOMAIN PROTEIN 55', 238379),
(294827, 'PTHR47997:SF32', NULL, NULL, NULL, NULL, 'BNACNNG68780D PROTEIN', 238379),
(294828, 'PTHR47997:SF76', NULL, NULL, NULL, NULL, 'OS07G0497500 PROTEIN', 238379),
(294829, 'PTHR47997:SF77', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 238379),
(294830, 'PTHR47997:SF70', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 238379),
(294831, 'PTHR47997:SF71', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB23-LIKE', 238379),
(294832, 'PTHR47997:SF72', NULL, NULL, NULL, NULL, 'MYB-LIKE TRANSCRIPTION FACTOR', 238379),
(294833, 'PTHR47997:SF73', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN HV33-LIKE', 238379),
(294834, 'PTHR47997:SF28', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB8-LIKE', 238379),
(294835, 'PTHR47997:SF23', NULL, NULL, NULL, NULL, 'OS04G0532800 PROTEIN', 238379),
(294836, 'PTHR47997:SF67', NULL, NULL, NULL, NULL, 'R2R3MYB-DOMAIN PROTEIN', 238379),
(294837, 'PTHR47997:SF68', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 238379),
(294838, 'PTHR47997:SF69', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, PUTATIVE-RELATED', 238379),
(294839, 'PTHR47997:SF63', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB46-LIKE', 238379),
(294840, 'PTHR47997:SF60', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 238379),
(294841, 'PTHR47997:SF61', NULL, NULL, NULL, NULL, 'BNACNNG28540D PROTEIN', 238379),
(294842, 'PTHR47997:SF17', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 238379),
(294843, 'PTHR47997:SF19', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB46', 238379),
(294844, 'PTHR47997:SF12', NULL, NULL, NULL, NULL, 'BNAC08G42690D PROTEIN', 238379),
(294845, 'PTHR47997:SF56', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, PUTATIVE-RELATED', 238379),
(294846, 'PTHR47997:SF59', NULL, NULL, NULL, NULL, 'BNACNNG19930D PROTEIN', 238379),
(294847, 'PTHR47997:SF11', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR LAF1', 238379),
(294848, 'PTHR47997:SF50', NULL, NULL, NULL, NULL, 'GMMYB29A1 PROTEIN', 238379),
(294849, 'PTHR11371:SF29', NULL, NULL, NULL, NULL, 'DEOXYRIBONUCLEASE-1-LIKE 2', 238380),
(294850, 'PTHR11371:SF28', NULL, NULL, NULL, NULL, 'DEOXYRIBONUCLEASE-1-LIKE 1', 238380),
(294851, 'PTHR11371', NULL, NULL, NULL, NULL, 'DEOXYRIBONUCLEASE', 238380);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(294852, 'PTHR11371:SF27', NULL, NULL, NULL, NULL, 'DEOXYRIBONUCLEASE-1', 238380),
(294853, 'PTHR11371:SF26', NULL, NULL, NULL, NULL, 'DEOXYRIBONUCLEASE', 238380),
(294854, 'PTHR11371:SF32', NULL, NULL, NULL, NULL, 'DEOXYRIBONUCLEASE GAMMA', 238380),
(294855, 'PTHR11371:SF31', NULL, NULL, NULL, NULL, 'EXTRACELULLAR DNA DEGRADATION PROTEIN, EDDB', 238380),
(294856, 'PTHR11371:SF34', NULL, NULL, NULL, NULL, 'DEOXYRIBONUCLEASE', 238380),
(294857, 'PTHR11371:SF11', NULL, NULL, NULL, NULL, 'DEOXYRIBONUCLEASE', 238380),
(294858, 'PTHR11371:SF33', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 238380),
(294859, 'PTHR47787:SF1', NULL, NULL, NULL, NULL, 'CENTROMERE-BINDING PROTEIN 1', 238381),
(294860, 'PTHR47787', NULL, NULL, NULL, NULL, 'CENTROMERE-BINDING PROTEIN 1', 238381),
(294861, 'PTHR34457:SF3', NULL, NULL, NULL, NULL, 'PROTEIN TIC236, CHLOROPLASTIC', 238382),
(294862, 'PTHR34457', NULL, NULL, NULL, NULL, 'EMBRYO DEFECTIVE 2410', 238382),
(294863, 'PTHR10624:SF6', NULL, NULL, NULL, NULL, 'UROKINASE PLASMINOGEN ACTIVATOR SURFACE RECEPTOR', 238383),
(294864, 'PTHR10624:SF9', NULL, NULL, NULL, NULL, 'LY6/PLAUR DOMAIN-CONTAINING PROTEIN 5', 238383),
(294865, 'PTHR10624:SF8', NULL, NULL, NULL, NULL, 'LY6/PLAUR DOMAIN-CONTAINING PROTEIN 3', 238383),
(294866, 'PTHR10624', NULL, NULL, NULL, NULL, 'UROKINASE PLASMINOGEN ACTIVATOR SURFACE RECEPTOR-RELATED', 238383),
(294867, 'PTHR23220:SF26', NULL, NULL, NULL, NULL, 'INTEGRIN ALPHA-10', 238384),
(294868, 'PTHR23220', NULL, NULL, NULL, NULL, 'INTEGRIN ALPHA', 238384),
(294869, 'PTHR23220:SF4', NULL, NULL, NULL, NULL, 'INTEGRIN ALPHA-V', 238384),
(294870, 'PTHR23220:SF5', NULL, NULL, NULL, NULL, 'INTEGRIN ALPHA-8', 238384),
(294871, 'PTHR23220:SF90', NULL, NULL, NULL, NULL, 'INTEGRIN ALPHA-7', 238384),
(294872, 'PTHR23220:SF130', NULL, NULL, NULL, NULL, 'INTEGRIN ALPHA-M', 238384),
(294873, 'PTHR23220:SF9', NULL, NULL, NULL, NULL, 'INTEGRIN ALPHA-6', 238384),
(294874, 'PTHR23220:SF83', NULL, NULL, NULL, NULL, 'INTEGRIN ALPHA-PS3-RELATED', 238384),
(294875, 'PTHR23220:SF133', NULL, NULL, NULL, NULL, 'INTEGRIN ALPHA-PS2', 238384),
(294876, 'PTHR23220:SF122', NULL, NULL, NULL, NULL, 'INTEGRIN ALPHA-PS1', 238384),
(294877, 'PTHR23220:SF132', NULL, NULL, NULL, NULL, 'INTEGRIN ALPHA-D', 238384),
(294878, 'PTHR23220:SF21', NULL, NULL, NULL, NULL, 'INTEGRIN ALPHA-11', 238384),
(294879, 'PTHR23220:SF73', NULL, NULL, NULL, NULL, 'INTEGRIN ALPHA-IIB', 238384),
(294880, 'PTHR23220:SF84', NULL, NULL, NULL, NULL, 'INTEGRIN ALPHA-L', 238384),
(294881, 'PTHR23220:SF79', NULL, NULL, NULL, NULL, 'INTEGRIN ALPHA-E', 238384),
(294882, 'PTHR23220:SF69', NULL, NULL, NULL, NULL, 'INTEGRIN ALPHA-9', 238384),
(294883, 'PTHR23220:SF22', NULL, NULL, NULL, NULL, 'INTEGRIN ALPHA-1', 238384),
(294884, 'PTHR23220:SF23', NULL, NULL, NULL, NULL, 'INTEGRIN ALPHA-2', 238384),
(294885, 'PTHR23220:SF118', NULL, NULL, NULL, NULL, 'INTEGRIN ALPHA-X', 238384),
(294886, 'PTHR23220:SF89', NULL, NULL, NULL, NULL, 'INTEGRIN ALPHA-3', 238384),
(294887, 'PTHR23220:SF78', NULL, NULL, NULL, NULL, 'INTEGRIN ALPHA-4', 238384),
(294888, 'PTHR23220:SF3', NULL, NULL, NULL, NULL, 'INTEGRIN ALPHA-5', 238384),
(294889, 'PTHR34963:SF4', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REACTION CENTER PSB28 PROTEIN', 238385),
(294890, 'PTHR34963:SF2', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REACTION CENTER PSB28 PROTEIN, CHLOROPLASTIC', 238385),
(294891, 'PTHR34963', NULL, NULL, NULL, NULL, '', 238385),
(294892, 'PTHR19303', NULL, NULL, NULL, NULL, 'TRANSPOSON', 238386),
(294893, 'PTHR19303:SF18', NULL, NULL, NULL, NULL, 'TIGGER TRANSPOSABLE ELEMENT-DERIVED PROTEIN 4', 238386),
(294894, 'PTHR19303:SF16', NULL, NULL, NULL, NULL, 'JERKY PROTEIN HOMOLOG-LIKE', 238386),
(294895, 'PTHR19303:SF17', NULL, NULL, NULL, NULL, 'TIGGER TRANSPOSABLE ELEMENT-DERIVED PROTEIN 7', 238386),
(294896, 'PTHR19303:SF36', NULL, NULL, NULL, NULL, 'TIGGER TRANSPOSABLE ELEMENT-DERIVED PROTEIN 3', 238386),
(294897, 'PTHR19303:SF59', NULL, NULL, NULL, NULL, 'CENPB DNA-BINDING DOMAIN CONTAINING 1', 238386),
(294898, 'PTHR19303:SF56', NULL, NULL, NULL, NULL, 'TIGGER TRANSPOSABLE ELEMENT-DERIVED PROTEIN 5', 238386);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(294899, 'PTHR19303:SF57', NULL, NULL, NULL, NULL, 'HTH CENPB-TYPE DOMAIN-CONTAINING PROTEIN', 238386),
(294900, 'PTHR19303:SF11', NULL, NULL, NULL, NULL, 'JERKY PROTEIN HOMOLOG', 238386),
(294901, 'PTHR19303:SF52', NULL, NULL, NULL, NULL, 'TIGGER TRANSPOSABLE ELEMENT-DERIVED PROTEIN 6', 238386),
(294902, 'PTHR19303:SF30', NULL, NULL, NULL, NULL, 'DDE-1 DOMAIN-CONTAINING PROTEIN', 238386),
(294903, 'PTHR19303:SF27', NULL, NULL, NULL, NULL, 'HTH CENPB-TYPE DOMAIN-CONTAINING PROTEIN', 238386),
(294904, 'PTHR19303:SF26', NULL, NULL, NULL, NULL, 'TIGGER TRANSPOSABLE ELEMENT-DERIVED PROTEIN 1', 238386),
(294905, 'PTHR19303:SF60', NULL, NULL, NULL, NULL, 'HTH CENPB-TYPE DOMAIN-CONTAINING PROTEIN', 238386),
(294906, 'PTHR19303:SF45', NULL, NULL, NULL, NULL, 'MAJOR CENTROMERE AUTOANTIGEN B', 238386),
(294907, 'PTHR19303:SF67', NULL, NULL, NULL, NULL, 'HTH CENPB-TYPE DOMAIN-CONTAINING PROTEIN', 238386),
(294908, 'PTHR19303:SF68', NULL, NULL, NULL, NULL, 'HTH CENPB-TYPE DOMAIN-CONTAINING PROTEIN', 238386),
(294909, 'PTHR19303:SF21', NULL, NULL, NULL, NULL, 'POGO TRANSPOSABLE ELEMENT WITH KRAB DOMAIN', 238386),
(294910, 'PTHR19303:SF65', NULL, NULL, NULL, NULL, 'HTH PSQ-TYPE DOMAIN-CONTAINING PROTEIN', 238386),
(294911, 'PTHR19303:SF22', NULL, NULL, NULL, NULL, 'TIGGER TRANSPOSABLE ELEMENT-DERIVED PROTEIN 2', 238386),
(294912, 'PTHR19303:SF66', NULL, NULL, NULL, NULL, 'HTH CENPB-TYPE DOMAIN-CONTAINING PROTEIN', 238386),
(294913, 'PTHR19303:SF63', NULL, NULL, NULL, NULL, 'CAG, ISOFORM A', 238386),
(294914, 'PTHR19303:SF42', NULL, NULL, NULL, NULL, 'DDE-1 DOMAIN-CONTAINING PROTEIN', 238386),
(294915, 'PTHR19303:SF20', NULL, NULL, NULL, NULL, 'HTH CENPB-TYPE DOMAIN-CONTAINING PROTEIN', 238386),
(294916, 'PTHR19303:SF64', NULL, NULL, NULL, NULL, 'PROTEIN PDC2', 238386),
(294917, 'PTHR19303:SF61', NULL, NULL, NULL, NULL, 'HTH CENPB-TYPE DOMAIN-CONTAINING PROTEIN', 238386),
(294918, 'PTHR19303:SF62', NULL, NULL, NULL, NULL, 'ARS-BINDING PROTEIN 1-RELATED', 238386),
(294919, 'PTHR48105:SF29', NULL, NULL, NULL, NULL, 'PYR_REDOX_2 DOMAIN-CONTAINING PROTEIN-RELATED', 238387),
(294920, 'PTHR48105', NULL, NULL, NULL, NULL, 'THIOREDOXIN REDUCTASE 1-RELATED-RELATED', 238387),
(294921, 'PTHR48105:SF6', NULL, NULL, NULL, NULL, 'ALKYL HYDROPEROXIDE REDUCTASE SUBUNIT F', 238387),
(294922, 'PTHR48105:SF5', NULL, NULL, NULL, NULL, 'BLR1248 PROTEIN', 238387),
(294923, 'PTHR48105:SF8', NULL, NULL, NULL, NULL, 'GLUTATHIONE REDUCTASE, CYTOSOLIC', 238387),
(294924, 'PTHR48105:SF20', NULL, NULL, NULL, NULL, 'THIOREDOXIN REDUCTASE', 238387),
(294925, 'PTHR48105:SF7', NULL, NULL, NULL, NULL, 'THIOREDOXIN REDUCTASE 1, CYTOPLASMIC', 238387),
(294926, 'PTHR48105:SF1', NULL, NULL, NULL, NULL, 'GLUTATHIONE REDUCTASE', 238387),
(294927, 'PTHR48105:SF4', NULL, NULL, NULL, NULL, 'PYR_REDOX_2 DOMAIN-CONTAINING PROTEIN', 238387),
(294928, 'PTHR48105:SF26', NULL, NULL, NULL, NULL, 'NADPH-DEPENDENT THIOREDOXIN REDUCTASE 3', 238387),
(294929, 'PTHR48105:SF28', NULL, NULL, NULL, NULL, 'THIOREDOXIN REDUCTASE GLIT (AFU_ORTHOLOGUE AFUA_6G09740)', 238387),
(294930, 'PTHR48105:SF27', NULL, NULL, NULL, NULL, 'THIOREDOXIN REDUCTASE NTRA', 238387),
(294931, 'PTHR48105:SF22', NULL, NULL, NULL, NULL, 'THIOREDOXIN REDUCTASE', 238387),
(294932, 'PTHR48105:SF21', NULL, NULL, NULL, NULL, 'THIOREDOXIN REDUCTASE 2, MITOCHONDRIAL', 238387),
(294933, 'PTHR48105:SF24', NULL, NULL, NULL, NULL, 'GLUTATHIONE REDUCTASE, CHLOROPLASTIC', 238387),
(294934, 'PTHR48105:SF19', NULL, NULL, NULL, NULL, 'THIOREDOXIN-DISULFIDE REDUCTASE', 238387),
(294935, 'PTHR48105:SF18', NULL, NULL, NULL, NULL, 'FERREDOXIN--NADP REDUCTASE 1', 238387),
(294936, 'PTHR48105:SF30', NULL, NULL, NULL, NULL, 'THIOREDOXIN REDUCTASE 3', 238387),
(294937, 'PTHR48105:SF15', NULL, NULL, NULL, NULL, 'FERREDOXIN--NADP REDUCTASE 2', 238387),
(294938, 'PTHR48105:SF14', NULL, NULL, NULL, NULL, 'THIOREDOXIN REDUCTASE (TRXB-2)', 238387),
(294939, 'PTHR48105:SF17', NULL, NULL, NULL, NULL, 'THIOREDOXIN REDUCTASE', 238387),
(294940, 'PTHR48105:SF16', NULL, NULL, NULL, NULL, 'THIOREDOXIN REDUCTASE 1-RELATED', 238387);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(294941, 'PTHR48105:SF33', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE', 238387),
(294942, 'PTHR48105:SF10', NULL, NULL, NULL, NULL, '', 238387),
(294943, 'PTHR48105:SF32', NULL, NULL, NULL, NULL, 'THIOREDOXIN REDUCTASE', 238387),
(294944, 'PTHR48105:SF35', NULL, NULL, NULL, NULL, 'SLR0600 PROTEIN', 238387),
(294945, 'PTHR48105:SF34', NULL, NULL, NULL, NULL, 'THIOREDOXIN REDUCTASE 2', 238387),
(294946, 'PTHR48105:SF12', NULL, NULL, NULL, NULL, 'THIOREDOXIN REDUCTASE', 238387),
(294947, 'PTHR46078:SF1', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN J2', 238388),
(294948, 'PTHR46078:SF3', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN J3', 238388),
(294949, 'PTHR46078:SF2', NULL, NULL, NULL, NULL, 'FORK-HEAD DOMAIN-CONTAINING PROTEIN', 238388),
(294950, 'PTHR46078:SF5', NULL, NULL, NULL, NULL, 'FORKHEAD BOX J3', 238388),
(294951, 'PTHR46078', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN J2 FAMILY MEMBER', 238388),
(294952, 'PTHR46078:SF4', NULL, NULL, NULL, NULL, 'FORKHEAD BOX J2', 238388),
(294953, 'PTHR33284:SF3', NULL, NULL, NULL, NULL, 'BNAA09G52520D PROTEIN', 238389),
(294954, 'PTHR33284:SF4', NULL, NULL, NULL, NULL, 'BNAA01G13300D PROTEIN', 238389),
(294955, 'PTHR33284:SF1', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L25/GLN-TRNA SYNTHETASE, ANTI-CODON-BINDING DOMAIN-CONTAINING PROTEIN', 238389),
(294956, 'PTHR33284:SF2', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L25/GLN-TRNA SYNTHETASE, ANTI-CODON-BINDING DOMAIN-CONTAINING PROTEIN', 238389),
(294957, 'PTHR33284', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L25/GLN-TRNA SYNTHETASE, ANTI-CODON-BINDING DOMAIN-CONTAINING PROTEIN', 238389),
(294958, 'PTHR15746:SF20', NULL, NULL, NULL, NULL, 'RAB11 FAMILY-INTERACTING PROTEIN 2', 238390),
(294959, 'PTHR15746:SF23', NULL, NULL, NULL, NULL, 'RAB11 INTERACTING PROTEIN, ISOFORM A', 238390),
(294960, 'PTHR15746:SF22', NULL, NULL, NULL, NULL, 'RAB11 FAMILY-INTERACTING PROTEIN 1', 238390),
(294961, 'PTHR15746:SF14', NULL, NULL, NULL, NULL, 'RAB11 FAMILY-INTERACTING PROTEIN 5', 238390),
(294962, 'PTHR15746:SF24', NULL, NULL, NULL, NULL, '', 238390),
(294963, 'PTHR15746', NULL, NULL, NULL, NULL, 'RAB11-RELATED', 238390),
(294964, 'PTHR37561:SF3', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 238391),
(294965, 'PTHR37561', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 238391),
(294966, 'PTHR46359:SF1', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 11', 238392),
(294967, 'PTHR46359:SF2', NULL, NULL, NULL, NULL, 'GEO07743P1', 238392),
(294968, 'PTHR46359:SF3', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 11A', 238392),
(294969, 'PTHR46359', NULL, NULL, NULL, NULL, 'GEO07743P1', 238392),
(294970, 'PTHR38454:SF1', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN-RELATED', 238393),
(294971, 'PTHR38454', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN-RELATED', 238393),
(294972, 'PTHR43738:SF3', NULL, NULL, NULL, NULL, 'MACB_PCD DOMAIN-CONTAINING PROTEIN', 238394),
(294973, 'PTHR43738:SF2', NULL, NULL, NULL, NULL, 'FTSX DOMAIN-CONTAINING PROTEIN', 238394),
(294974, 'PTHR43738:SF1', NULL, NULL, NULL, NULL, 'HEMIN TRANSPORT SYSTEM PERMEASE PROTEIN HRTB-RELATED', 238394),
(294975, 'PTHR43738', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, MEMBRANE PROTEIN', 238394),
(294976, 'PTHR40661', NULL, NULL, NULL, NULL, '', 238395),
(294977, 'PTHR40661:SF1', NULL, NULL, NULL, NULL, 'HTH CRO/C1-TYPE DOMAIN-CONTAINING PROTEIN', 238395),
(294978, 'PTHR40661:SF2', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR PRTR', 238395),
(294979, 'PTHR40661:SF3', NULL, NULL, NULL, NULL, 'FELS-1 PROPHAGE TRANSCRIPTIONAL REGULATOR-RELATED', 238395),
(294980, 'PTHR11873:SF0', NULL, NULL, NULL, NULL, 'LIPOCALIN-RELATED PROTEIN', 238396),
(294981, 'PTHR11873:SF2', NULL, NULL, NULL, NULL, 'RETINOL-BINDING PROTEIN 4', 238396),
(294982, 'PTHR11873:SF1', NULL, NULL, NULL, NULL, 'PURPURIN', 238396),
(294983, 'PTHR11873', NULL, NULL, NULL, NULL, 'RETINOL-BINDING PROTEIN 4', 238396),
(294984, 'PTHR19862:SF21', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 238397),
(294985, 'PTHR19862:SF18', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN, BETA SUBUNIT-RELATED', 238397);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(294986, 'PTHR19862', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 48', 238397),
(294987, 'PTHR19862:SF14', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 48', 238397),
(294988, 'PTHR38042:SF1', NULL, NULL, NULL, NULL, 'UROPORPHYRINOGEN-III SYNTHASE, CHLOROPLASTIC', 238398),
(294989, 'PTHR38042', NULL, NULL, NULL, NULL, 'UROPORPHYRINOGEN-III SYNTHASE, CHLOROPLASTIC', 238398),
(294990, 'PTHR38042:SF5', NULL, NULL, NULL, NULL, 'UROPORPHYRINOGEN-III SYNTHASE', 238398),
(294991, 'PTHR47508', NULL, NULL, NULL, NULL, 'SAM DOMAIN-CONTAINING PROTEIN-RELATED', 238399),
(294992, 'PTHR47508:SF3', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 238399),
(294993, 'PTHR47508:SF2', NULL, NULL, NULL, NULL, 'SAM DOMAIN-CONTAINING PROTEIN', 238399),
(294994, 'PTHR47508:SF1', NULL, NULL, NULL, NULL, 'DEATH DOMAIN-CONTAINING PROTEIN', 238399),
(294995, 'PTHR12039:SF0', NULL, NULL, NULL, NULL, 'NICOTINAMIDE-NUCLEOTIDE ADENYLYLTRANSFERASE', 238400),
(294996, 'PTHR12039:SF21', NULL, NULL, NULL, NULL, 'NICOTINAMIDE/NICOTINIC ACID MONONUCLEOTIDE ADENYLYLTRANSFERASE 1', 238400),
(294997, 'PTHR12039:SF4', NULL, NULL, NULL, NULL, 'NICOTINAMIDE-NUCLEOTIDE ADENYLYLTRANSFERASE', 238400),
(294998, 'PTHR12039:SF20', NULL, NULL, NULL, NULL, 'CTP_TRANSF_LIKE DOMAIN-CONTAINING PROTEIN', 238400),
(294999, 'PTHR12039:SF7', NULL, NULL, NULL, NULL, 'NICOTINAMIDE/NICOTINIC ACID MONONUCLEOTIDE ADENYLYLTRANSFERASE 3', 238400),
(295000, 'PTHR12039', NULL, NULL, NULL, NULL, 'NICOTINAMIDE MONONUCLEOTIDE ADENYLYLTRANSFERASE', 238400),
(295001, 'PTHR12039:SF13', NULL, NULL, NULL, NULL, 'NICOTINAMIDE-NUCLEOTIDE ADENYLYLTRANSFERASE', 238400),
(295002, 'PTHR12039:SF18', NULL, NULL, NULL, NULL, 'NICOTINAMIDE/NICOTINIC ACID MONONUCLEOTIDE ADENYLYLTRANSFERASE 2', 238400),
(295003, 'PTHR12039:SF17', NULL, NULL, NULL, NULL, 'NICOTINAMIDE-NUCLEOTIDE ADENYLYLTRANSFERASE', 238400),
(295004, 'PTHR46775:SF2', NULL, NULL, NULL, NULL, 'GBF-INTERACTING PROTEIN 1-LIKE', 238401),
(295005, 'PTHR46775:SF3', NULL, NULL, NULL, NULL, 'GBF-INTERACTING PROTEIN 1-LIKE ISOFORM X1', 238401),
(295006, 'PTHR46775:SF1', NULL, NULL, NULL, NULL, 'FLOCCULATION PROTEIN (DUF1296)', 238401),
(295007, 'PTHR46775:SF6', NULL, NULL, NULL, NULL, 'DUF1296 DOMAIN-CONTAINING PROTEIN', 238401),
(295008, 'PTHR46775', NULL, NULL, NULL, NULL, 'FLOCCULATION PROTEIN (DUF1296)', 238401),
(295009, 'PTHR46775:SF7', NULL, NULL, NULL, NULL, 'UBA-LIKE, GBF-INTERACTING PROTEIN 1-RELATED', 238401),
(295010, 'PTHR46775:SF4', NULL, NULL, NULL, NULL, 'DUF1296 DOMAIN-CONTAINING PROTEIN', 238401),
(295011, 'PTHR46775:SF5', NULL, NULL, NULL, NULL, 'GBF-INTERACTING PROTEIN 1', 238401),
(295012, 'PTHR22938:SF17', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238402),
(295013, 'PTHR22938:SF15', NULL, NULL, NULL, NULL, 'OS01G0568000 PROTEIN', 238402),
(295014, 'PTHR22938:SF9', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238402),
(295015, 'PTHR22938:SF18', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238402),
(295016, 'PTHR22938', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 598', 238402),
(295017, 'PTHR22938:SF0', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ZNF598', 238402),
(295018, 'PTHR22938:SF11', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238402),
(295019, 'PTHR40741:SF1', NULL, NULL, NULL, NULL, '', 238403),
(295020, 'PTHR40741:SF2', NULL, NULL, NULL, NULL, '', 238403),
(295021, 'PTHR40741', NULL, NULL, NULL, NULL, '', 238403),
(295022, 'PTHR28291:SF1', NULL, NULL, NULL, NULL, 'CTD KINASE SUBUNIT GAMMA', 238404),
(295023, 'PTHR28291', NULL, NULL, NULL, NULL, 'CTD KINASE SUBUNIT GAMMA', 238404),
(295024, 'PTHR46089:SF1', NULL, NULL, NULL, NULL, 'ALS2 C-TERMINAL-LIKE PROTEIN', 238405),
(295025, 'PTHR46089:SF2', NULL, NULL, NULL, NULL, 'ALSIN HOMOLOG', 238405),
(295026, 'PTHR46089:SF3', NULL, NULL, NULL, NULL, 'ALSIN', 238405),
(295027, 'PTHR46089', NULL, NULL, NULL, NULL, 'ALSIN HOMOLOG', 238405),
(295028, 'PTHR46089:SF4', NULL, NULL, NULL, NULL, '', 238405),
(295029, 'PTHR34095', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L55, MITOCHONDRIAL', 238406);
INSERT INTO "PUBLIC"."MODEL" VALUES
(295030, 'PTHR34095:SF1', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L55, MITOCHONDRIAL', 238406),
(295031, 'PTHR24104', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE NHLRC1-RELATED', 238407),
(295032, 'PTHR24104:SF8', NULL, NULL, NULL, NULL, 'B BOX-TYPE DOMAIN-CONTAINING PROTEIN', 238407),
(295033, 'PTHR24104:SF44', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 2', 238407),
(295034, 'PTHR24104:SF34', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE NHLRC1', 238407),
(295035, 'PTHR24104:SF23', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING 2B', 238407),
(295036, 'PTHR24104:SF45', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING 2A', 238407),
(295037, 'PTHR24104:SF25', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM71', 238407),
(295038, 'PTHR24104:SF40', NULL, NULL, NULL, NULL, 'NHL DOMAIN-CONTAINING PROTEIN', 238407),
(295039, 'PTHR24104:SF41', NULL, NULL, NULL, NULL, 'BRAIN TUMOR PROTEIN', 238407),
(295040, 'PTHR24104:SF31', NULL, NULL, NULL, NULL, 'NHL REPEAT-CONTAINING PROTEIN 3', 238407),
(295041, 'PTHR24104:SF20', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 238407),
(295042, 'PTHR24104:SF42', NULL, NULL, NULL, NULL, 'NHL REPEATCONTAINING PROTEIN', 238407),
(295043, 'PTHR24104:SF21', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 3', 238407),
(295044, 'PTHR24104:SF43', NULL, NULL, NULL, NULL, 'PROTEIN LIN-41', 238407),
(295045, 'PTHR47606', NULL, NULL, NULL, NULL, 'KILLER CELL LECTIN-LIKE RECEPTOR SUBFAMILY G MEMBER 2', 238408),
(295046, 'PTHR47606:SF1', NULL, NULL, NULL, NULL, 'KILLER CELL LECTIN-LIKE RECEPTOR SUBFAMILY G MEMBER 2', 238408),
(295047, 'PTHR46573', NULL, NULL, NULL, NULL, 'WD REPEAT, SAM AND U-BOX DOMAIN-CONTAINING PROTEIN 1', 238409),
(295048, 'PTHR46573:SF1', NULL, NULL, NULL, NULL, 'WD REPEAT, SAM AND U-BOX DOMAIN-CONTAINING PROTEIN 1', 238409),
(295049, 'PTHR36961', NULL, NULL, NULL, NULL, 'LEUKEMIA-ASSOCIATED PROTEIN 7', 238410),
(295050, 'PTHR36961:SF1', NULL, NULL, NULL, NULL, 'LEUKEMIA-ASSOCIATED PROTEIN 7', 238410),
(295051, 'PTHR33782:SF17', NULL, NULL, NULL, NULL, '', 238411),
(295052, 'PTHR33782:SF28', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 238411),
(295053, 'PTHR33782:SF19', NULL, NULL, NULL, NULL, 'BNAA09G18540D PROTEIN', 238411),
(295054, 'PTHR33782:SF20', NULL, NULL, NULL, NULL, '', 238411),
(295055, 'PTHR33782', NULL, NULL, NULL, NULL, 'OS01G0121600 PROTEIN', 238411),
(295056, 'PTHR33782:SF21', NULL, NULL, NULL, NULL, '', 238411),
(295057, 'PTHR33782:SF23', NULL, NULL, NULL, NULL, 'BNAA06G35010D PROTEIN', 238411),
(295058, 'PTHR33782:SF24', NULL, NULL, NULL, NULL, '', 238411),
(295059, 'PTHR33782:SF3', NULL, NULL, NULL, NULL, 'OS05G0516700 PROTEIN', 238411),
(295060, 'PTHR33782:SF13', NULL, NULL, NULL, NULL, 'BY GENSCAN AND GENEFINDER', 238411),
(295061, 'PTHR33782:SF25', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT', 238411),
(295062, 'PTHR33782:SF15', NULL, NULL, NULL, NULL, '', 238411),
(295063, 'PTHR33782:SF5', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT', 238411),
(295064, 'PTHR33782:SF26', NULL, NULL, NULL, NULL, 'BNAC05G11320D PROTEIN', 238411),
(295065, 'PTHR33782:SF27', NULL, NULL, NULL, NULL, '', 238411),
(295066, 'PTHR11269:SF9', NULL, NULL, NULL, NULL, 'PERIOD CIRCADIAN PROTEIN HOMOLOG 2', 238412),
(295067, 'PTHR11269:SF8', NULL, NULL, NULL, NULL, 'PERIOD CIRCADIAN PROTEIN HOMOLOG 1', 238412),
(295068, 'PTHR11269', NULL, NULL, NULL, NULL, 'PERIOD CIRCADIAN PROTEIN', 238412),
(295069, 'PTHR11269:SF13', NULL, NULL, NULL, NULL, 'PERIOD CIRCADIAN PROTEIN HOMOLOG 3', 238412),
(295070, 'PTHR11269:SF16', NULL, NULL, NULL, NULL, 'PERIOD CIRCADIAN PROTEIN', 238412),
(295071, 'PTHR43285:SF1', NULL, NULL, NULL, NULL, 'ANTHRANILATE PHOSPHORIBOSYLTRANSFERASE, CHLOROPLASTIC-LIKE ISOFORM X1', 238413),
(295072, 'PTHR43285:SF2', NULL, NULL, NULL, NULL, 'ANTHRANILATE PHOSPHORIBOSYLTRANSFERASE', 238413),
(295073, 'PTHR43285', NULL, NULL, NULL, NULL, 'ANTHRANILATE PHOSPHORIBOSYLTRANSFERASE', 238413);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(295074, 'PTHR43285:SF3', NULL, NULL, NULL, NULL, 'SLL1634 PROTEIN', 238413),
(295075, 'PTHR43285:SF4', NULL, NULL, NULL, NULL, 'TRANSFERASE-RELATED', 238413),
(295076, 'PTHR12689', NULL, NULL, NULL, NULL, 'A1 CISTRON SPLICING FACTOR AAR2-RELATED', 238414),
(295077, 'PTHR12689:SF4', NULL, NULL, NULL, NULL, 'PROTEIN AAR2 HOMOLOG', 238414),
(295078, 'PTHR31302', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN WITH METALLOPHOSPHOESTERASE DOMAIN-RELATED', 238415),
(295079, 'PTHR31302:SF21', NULL, NULL, NULL, NULL, 'METALLOPHOS DOMAIN-CONTAINING PROTEIN', 238415),
(295080, 'PTHR31302:SF20', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', 238415),
(295081, 'PTHR31302:SF22', NULL, NULL, NULL, NULL, 'PHOSPHOESTERASE-RELATED', 238415),
(295082, 'PTHR31302:SF25', NULL, NULL, NULL, NULL, 'PHOSPHOESTERASE', 238415),
(295083, 'PTHR31302:SF24', NULL, NULL, NULL, NULL, 'METALLOPHOSPHOESTERASE F40B5.2-RELATED', 238415),
(295084, 'PTHR31302:SF29', NULL, NULL, NULL, NULL, 'PHOSPHOESTERASE', 238415),
(295085, 'PTHR31302:SF28', NULL, NULL, NULL, NULL, 'METALLOPHOSPHOESTERASE, CALCINEURIN SUPERFAMILY', 238415),
(295086, 'PTHR31302:SF0', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN WITH METALLOPHOSPHOESTERASE DOMAIN', 238415),
(295087, 'PTHR21083:SF0', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL ASSEMBLY FACTOR 6', 238416),
(295088, 'PTHR21083', NULL, NULL, NULL, NULL, 'TWISTER', 238416),
(295089, 'PTHR43378:SF2', NULL, NULL, NULL, NULL, 'UDP-3-O-ACYLGLUCOSAMINE N-ACYLTRANSFERASE 1, MITOCHONDRIAL-RELATED', 238417),
(295090, 'PTHR43378', NULL, NULL, NULL, NULL, 'UDP-3-O-ACYLGLUCOSAMINE N-ACYLTRANSFERASE', 238417),
(295091, 'PTHR44177:SF1', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 8', 238418),
(295092, 'PTHR44177', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 8', 238418),
(295093, 'PTHR43814', NULL, NULL, NULL, NULL, 'ARGININOSUCCINATE LYASE', 238419),
(295094, 'PTHR43814:SF1', NULL, NULL, NULL, NULL, 'ARGININOSUCCINATE LYASE', 238419),
(295095, 'PTHR43814:SF5', NULL, NULL, NULL, NULL, '', 238419),
(295096, 'PTHR43814:SF6', NULL, NULL, NULL, NULL, '', 238419),
(295097, 'PTHR43814:SF4', NULL, NULL, NULL, NULL, 'ARGININOSUCCINATE LYASE', 238419),
(295098, 'PTHR35468:SF2', NULL, NULL, NULL, NULL, 'BNAC06G04540D PROTEIN', 238420),
(295099, 'PTHR35468:SF1', NULL, NULL, NULL, NULL, 'MYOSIN-LIKE PROTEIN', 238420),
(295100, 'PTHR35468', NULL, NULL, NULL, NULL, 'MYOSIN-LIKE PROTEIN', 238420),
(295101, 'PTHR35124:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 238421),
(295102, 'PTHR35124:SF3', NULL, NULL, NULL, NULL, 'BNAA03G57420D PROTEIN', 238421),
(295103, 'PTHR35124', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 238421),
(295104, 'PTHR35124:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 238421),
(295105, 'PTHR35124:SF4', NULL, NULL, NULL, NULL, '', 238421),
(295106, 'PTHR14495', NULL, NULL, NULL, NULL, 'SHIELDIN COMPLEX SUBUNIT 2', 238422),
(295107, 'PTHR14495:SF2', NULL, NULL, NULL, NULL, 'SHIELDIN COMPLEX SUBUNIT 2', 238422),
(295108, 'PTHR47657:SF7', NULL, NULL, NULL, NULL, 'STEROL REGULATORY ELEMENT-BINDING PROTEIN ECM22', 238423),
(295109, 'PTHR47657:SF9', NULL, NULL, NULL, NULL, 'ZN(2)-C6 FUNGAL-TYPE DOMAIN-CONTAINING PROTEIN', 238423),
(295110, 'PTHR47657:SF10', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 238423),
(295111, 'PTHR47657:SF11', NULL, NULL, NULL, NULL, 'FINGER DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G01650)-RELATED', 238423),
(295112, 'PTHR47657:SF12', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 238423),
(295113, 'PTHR47657:SF13', NULL, NULL, NULL, NULL, 'ZN(2)-C6 FUNGAL-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', 238423),
(295114, 'PTHR47657:SF14', NULL, NULL, NULL, NULL, 'ORSELLINIC ACID/F9775 BIOSYNTHESIS CLUSTER PROTEIN D-RELATED', 238423),
(295115, 'PTHR47657', NULL, NULL, NULL, NULL, 'STEROL REGULATORY ELEMENT-BINDING PROTEIN ECM22', 238423),
(295116, 'PTHR47657:SF3', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 238423);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(295117, 'PTHR11136:SF10', NULL, NULL, NULL, NULL, 'FOLYLPOLYGLUTAMATE SYNTHASE', 238424),
(295118, 'PTHR11136:SF13', NULL, NULL, NULL, NULL, 'FOLYLPOLYGLUTAMATE SYNTHASE', 238424),
(295119, 'PTHR11136', NULL, NULL, NULL, NULL, 'FOLYLPOLYGLUTAMATE SYNTHASE-RELATED', 238424),
(295120, 'PTHR11136:SF15', NULL, NULL, NULL, NULL, 'FOLYLPOLYGLUTAMATE SYNTHASE', 238424),
(295121, 'PTHR11136:SF5', NULL, NULL, NULL, NULL, 'FOLYLPOLYGLUTAMATE SYNTHASE, MITOCHONDRIAL', 238424),
(295122, 'PTHR11136:SF6', NULL, NULL, NULL, NULL, 'FOLYLPOLYGLUTAMATE SYNTHASE', 238424),
(295123, 'PTHR11136:SF14', NULL, NULL, NULL, NULL, 'FOLYLPOLYGLUTAMATE SYNTHASE', 238424),
(295124, 'PTHR11136:SF17', NULL, NULL, NULL, NULL, 'DIHYDROFOLATE SYNTHETASE', 238424),
(295125, 'PTHR11136:SF0', NULL, NULL, NULL, NULL, 'DIHYDROFOLATE SYNTHETASE-RELATED', 238424),
(295126, 'PTHR11136:SF16', NULL, NULL, NULL, NULL, 'FOLYLPOLYGLUTAMATE SYNTHASE', 238424),
(295127, 'PTHR35715', NULL, NULL, NULL, NULL, 'OS08G0511800 PROTEIN', 238425),
(295128, 'PTHR35715:SF8', NULL, NULL, NULL, NULL, 'OS09G0491692 PROTEIN', 238425),
(295129, 'PTHR35715:SF6', NULL, NULL, NULL, NULL, '', 238425),
(295130, 'PTHR35715:SF2', NULL, NULL, NULL, NULL, 'OS08G0511800 PROTEIN', 238425),
(295131, 'PTHR21719:SF1', NULL, NULL, NULL, NULL, 'FI06402P-RELATED', 238426),
(295132, 'PTHR21719', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 238426),
(295133, 'PTHR35936:SF6', NULL, NULL, NULL, NULL, 'PBPB DOMAIN-CONTAINING PROTEIN', 238427),
(295134, 'PTHR35936:SF7', NULL, NULL, NULL, NULL, 'BLL6724 PROTEIN', 238427),
(295135, 'PTHR35936:SF20', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ARGININE-BINDING PROTEIN 2-RELATED', 238427),
(295136, 'PTHR35936:SF32', NULL, NULL, NULL, NULL, 'MEMBRANE-BOUND LYTIC MUREIN TRANSGLYCOSYLASE F', 238427),
(295137, 'PTHR35936:SF23', NULL, NULL, NULL, NULL, 'LYSINE/ARGININE/ORNITHINE-BINDING PERIPLASMIC PROTEIN', 238427),
(295138, 'PTHR35936:SF34', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER EXTRACELLULAR-BINDING PROTEIN YCKB-RELATED', 238427),
(295139, 'PTHR35936:SF35', NULL, NULL, NULL, NULL, 'L-CYSTINE-BINDING PROTEIN TCYJ', 238427),
(295140, 'PTHR35936:SF13', NULL, NULL, NULL, NULL, 'HISTIDINE-BINDING PERIPLASMIC PROTEIN', 238427),
(295141, 'PTHR35936:SF36', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ARGININE-BINDING PROTEIN 1', 238427),
(295142, 'PTHR35936:SF25', NULL, NULL, NULL, NULL, 'PBPB DOMAIN-CONTAINING PROTEIN', 238427),
(295143, 'PTHR35936:SF27', NULL, NULL, NULL, NULL, 'PBPB DOMAIN-CONTAINING PROTEIN', 238427),
(295144, 'PTHR35936', NULL, NULL, NULL, NULL, 'MEMBRANE-BOUND LYTIC MUREIN TRANSGLYCOSYLASE F', 238427),
(295145, 'PTHR35936:SF17', NULL, NULL, NULL, NULL, 'GLUTAMINE-BINDING PERIPLASMIC PROTEIN', 238427),
(295146, 'PTHR35936:SF18', NULL, NULL, NULL, NULL, 'L-CYSTINE-BINDING PROTEIN TCYJ', 238427),
(295147, 'PTHR35936:SF19', NULL, NULL, NULL, NULL, 'AMINO-ACID-BINDING PROTEIN YXEM-RELATED', 238427),
(295148, 'PTHR36405', NULL, NULL, NULL, NULL, 'BNAA10G09140D PROTEIN', 238428),
(295149, 'PTHR36405:SF2', NULL, NULL, NULL, NULL, '', 238428),
(295150, 'PTHR36405:SF1', NULL, NULL, NULL, NULL, 'BNAA10G09140D PROTEIN', 238428),
(295151, 'PTHR36405:SF4', NULL, NULL, NULL, NULL, '', 238428),
(295152, 'PTHR36405:SF3', NULL, NULL, NULL, NULL, '', 238428),
(295153, 'PTHR34488:SF1', NULL, NULL, NULL, NULL, 'SI:CH211-245H14.1-RELATED', 238429),
(295154, 'PTHR34488', NULL, NULL, NULL, NULL, 'SI:CH211-245H14.1-RELATED', 238429),
(295155, 'PTHR42650', NULL, NULL, NULL, NULL, 'TAIL-ANCHORED PROTEIN INSERTION RECEPTOR WRB', 238430),
(295156, 'PTHR42650:SF1', NULL, NULL, NULL, NULL, 'GUIDED ENTRY OF TAIL-ANCHORED PROTEINS FACTOR 1', 238430),
(295157, 'PTHR24023:SF1059', NULL, NULL, NULL, NULL, 'COLLAGEN, TYPE XI, ALPHA 1A', 238431),
(295158, 'PTHR24023:SF1058', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(XXVII) CHAIN B', 238431),
(295159, 'PTHR24023:SF891', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(XVII) CHAIN', 238431),
(295160, 'PTHR24023:SF1057', NULL, NULL, NULL, NULL, 'MULTIPLEXIN, ISOFORM R', 238431),
(295161, 'PTHR24023:SF1056', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(VIII) CHAIN', 238431);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(295162, 'PTHR24023:SF1055', NULL, NULL, NULL, NULL, 'COLLAGEN TYPE XVIII ALPHA 1 CHAIN B', 238431),
(295163, 'PTHR24023:SF372', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(XVI) CHAIN', 238431),
(295164, 'PTHR24023:SF1054', NULL, NULL, NULL, NULL, '', 238431),
(295165, 'PTHR24023:SF1053', NULL, NULL, NULL, NULL, 'ENDOSTATIN DOMAIN-CONTAINING PROTEIN', 238431),
(295166, 'PTHR24023:SF1051', NULL, NULL, NULL, NULL, 'COLLAGEN, TYPE XXVIII, ALPHA 2A-RELATED', 238431),
(295167, 'PTHR24023:SF539', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-2(V) CHAIN', 238431),
(295168, 'PTHR24023:SF855', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-2(VIII) CHAIN', 238431),
(295169, 'PTHR24023:SF854', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(IV) CHAIN', 238431),
(295170, 'PTHR24023:SF533', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-6(IV) CHAIN', 238431),
(295171, 'PTHR24023:SF938', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(XIX) CHAIN', 238431),
(295172, 'PTHR24023:SF936', NULL, NULL, NULL, NULL, 'COLLAGEN TYPE VI ALPHA 2 CHAIN', 238431),
(295173, 'PTHR24023:SF42', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(XI) CHAIN', 238431),
(295174, 'PTHR24023:SF1019', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(IV) CHAIN', 238431),
(295175, 'PTHR24023:SF387', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(V) CHAIN', 238431),
(295176, 'PTHR24023:SF1069', NULL, NULL, NULL, NULL, 'WU:FC38H03', 238431),
(295177, 'PTHR24023:SF861', NULL, NULL, NULL, NULL, 'ACETYLCHOLINESTERASE COLLAGENIC TAIL PEPTIDE', 238431),
(295178, 'PTHR24023:SF1068', NULL, NULL, NULL, NULL, '', 238431),
(295179, 'PTHR24023:SF1023', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-3(V) CHAIN', 238431),
(295180, 'PTHR24023:SF1067', NULL, NULL, NULL, NULL, 'COLLAGEN, TYPE IV, ALPHA 3', 238431),
(295181, 'PTHR24023:SF1066', NULL, NULL, NULL, NULL, 'FIBRILLAR COLLAGEN NC1 DOMAIN-CONTAINING PROTEIN', 238431),
(295182, 'PTHR24023:SF1065', NULL, NULL, NULL, NULL, 'COLLAGEN, TYPE IX, ALPHA 1A', 238431),
(295183, 'PTHR24023:SF1064', NULL, NULL, NULL, NULL, 'COLLAGEN, TYPE XXVIII, ALPHA 1B', 238431),
(295184, 'PTHR24023:SF1063', NULL, NULL, NULL, NULL, 'COLLAGEN, TYPE V, ALPHA 2B', 238431),
(295185, 'PTHR24023:SF1062', NULL, NULL, NULL, NULL, 'COLLAGEN, TYPE IV, ALPHA 1', 238431),
(295186, 'PTHR24023:SF1061', NULL, NULL, NULL, NULL, 'MARCO-LIKE PROTEIN', 238431),
(295187, 'PTHR24023:SF866', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-3(IX) CHAIN', 238431),
(295188, 'PTHR24023:SF1060', NULL, NULL, NULL, NULL, 'FIBRILLAR COLLAGEN NC1 DOMAIN-CONTAINING PROTEIN', 238431),
(295189, 'PTHR24023:SF987', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(XXIV) CHAIN', 238431),
(295190, 'PTHR24023:SF588', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-2(IV) CHAIN', 238431),
(295191, 'PTHR24023:SF509', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-2(XI) CHAIN', 238431),
(295192, 'PTHR24023:SF906', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-2(IX) CHAIN', 238431),
(295193, 'PTHR24023:SF903', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(VIII) CHAIN', 238431),
(295194, 'PTHR24023:SF58', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(II) CHAIN', 238431),
(295195, 'PTHR24023:SF1029', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-5(IV) CHAIN', 238431),
(295196, 'PTHR24023:SF871', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(XIII) CHAIN', 238431),
(295197, 'PTHR24023:SF1079', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(IV) CHAIN', 238431),
(295198, 'PTHR24023:SF1078', NULL, NULL, NULL, NULL, 'FIBRILLAR COLLAGEN NC1 DOMAIN-CONTAINING PROTEIN', 238431),
(295199, 'PTHR24023:SF1034', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(XVIII) CHAIN', 238431),
(295200, 'PTHR24023:SF1077', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-3(IV) CHAIN', 238431),
(295201, 'PTHR24023:SF1076', NULL, NULL, NULL, NULL, 'FIBRILLAR COLLAGEN NC1 DOMAIN-CONTAINING PROTEIN', 238431),
(295202, 'PTHR24023:SF1075', NULL, NULL, NULL, NULL, 'OTOLIN 1', 238431),
(295203, 'PTHR24023:SF1074', NULL, NULL, NULL, NULL, 'LAM_G_DOMAIN DOMAIN-CONTAINING PROTEIN', 238431),
(295204, 'PTHR24023:SF714', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-4(IV) CHAIN', 238431),
(295205, 'PTHR24023:SF1073', NULL, NULL, NULL, NULL, 'COLLAGEN, TYPE IX, ALPHA 3', 238431);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(295206, 'PTHR24023:SF912', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(XV) CHAIN', 238431),
(295207, 'PTHR24023:SF1072', NULL, NULL, NULL, NULL, '3 ALPHA PROCOLLAGEN', 238431),
(295208, 'PTHR24023:SF1071', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(VII) CHAIN', 238431),
(295209, 'PTHR24023:SF910', NULL, NULL, NULL, NULL, 'COLLECTIN-12', 238431),
(295210, 'PTHR24023:SF1070', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-3(IV) CHAIN', 238431),
(295211, 'PTHR24023:SF878', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(XXVIII) CHAIN', 238431),
(295212, 'PTHR24023:SF995', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(XXIII) CHAIN', 238431),
(295213, 'PTHR24023:SF918', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(IX) CHAIN', 238431),
(295214, 'PTHR24023:SF917', NULL, NULL, NULL, NULL, 'COLLAGEN TYPE VI ALPHA 1 CHAIN', 238431),
(295215, 'PTHR24023:SF914', NULL, NULL, NULL, NULL, 'OTOLIN-1', 238431),
(295216, 'PTHR24023:SF958', NULL, NULL, NULL, NULL, 'ZGC:113232', 238431),
(295217, 'PTHR24023:SF1038', NULL, NULL, NULL, NULL, 'LAM_G_DOMAIN DOMAIN-CONTAINING PROTEIN', 238431),
(295218, 'PTHR24023:SF1047', NULL, NULL, NULL, NULL, 'SCAVENGER RECEPTOR CLASS A MEMBER 3', 238431),
(295219, 'PTHR24023:SF1002', NULL, NULL, NULL, NULL, 'C1Q DOMAIN-CONTAINING PROTEIN', 238431),
(295220, 'PTHR24023:SF880', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(X) CHAIN', 238431),
(295221, 'PTHR24023:SF1044', NULL, NULL, NULL, NULL, 'FIBRILLAR COLLAGEN NC1 DOMAIN-CONTAINING PROTEIN', 238431),
(295222, 'PTHR24023:SF1086', NULL, NULL, NULL, NULL, 'CUTICLE COLLAGEN 99-RELATED', 238431),
(295223, 'PTHR24023:SF1085', NULL, NULL, NULL, NULL, 'LAM_G_DOMAIN DOMAIN-CONTAINING PROTEIN', 238431),
(295224, 'PTHR24023:SF604', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(III) CHAIN', 238431),
(295225, 'PTHR24023:SF1084', NULL, NULL, NULL, NULL, 'FIBRILLAR COLLAGEN NC1 DOMAIN-CONTAINING PROTEIN-RELATED', 238431),
(295226, 'PTHR24023:SF1083', NULL, NULL, NULL, NULL, 'MACROPHAGE RECEPTOR MARCO', 238431),
(295227, 'PTHR24023:SF844', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(XXVII) CHAIN', 238431),
(295228, 'PTHR24023:SF1082', NULL, NULL, NULL, NULL, 'MACROPHAGE RECEPTOR MARCO', 238431),
(295229, 'PTHR24023:SF569', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(I) CHAIN', 238431),
(295230, 'PTHR24023:SF845', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(XXII) CHAIN', 238431),
(295231, 'PTHR24023:SF1081', NULL, NULL, NULL, NULL, 'COLLAGEN TYPE XVIII ALPHA 1 CHAIN A', 238431),
(295232, 'PTHR24023:SF966', NULL, NULL, NULL, NULL, 'ZMP:0000000760', 238431),
(295233, 'PTHR24023:SF1080', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA CHAIN CG42342-RELATED', 238431),
(295234, 'PTHR24023', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA', 238431),
(295235, 'PTHR24023:SF568', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-2(I) CHAIN', 238431),
(295236, 'PTHR28174', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN L36, MITOCHONDRIAL', 238432),
(295237, 'PTHR28174:SF1', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN L36, MITOCHONDRIAL', 238432),
(295238, 'PTHR44215', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 75', 238433),
(295239, 'PTHR44215:SF1', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 75', 238433),
(295240, 'PTHR30083:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', 238434),
(295241, 'PTHR30083:SF0', NULL, NULL, NULL, NULL, '3''-PHOSPHOADENOSINE 5''-PHOSPHOSULFATE SULFOTRANSFERASE (PAPS REDUCTASE)/FAD SYNTHETASE-RELATED', 238434),
(295242, 'PTHR30083', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 238434),
(295243, 'PTHR11067:SF9', NULL, NULL, NULL, NULL, 'INOSINE TRIPHOSPHATE PYROPHOSPHATASE', 238435),
(295244, 'PTHR11067', NULL, NULL, NULL, NULL, 'INOSINE TRIPHOSPHATE PYROPHOSPHATASE/HAM1 PROTEIN', 238435),
(295245, 'PTHR39160:SF6', NULL, NULL, NULL, NULL, 'CELL WALL-BINDING PROTEIN YOCH', 238436),
(295246, 'PTHR39160', NULL, NULL, NULL, NULL, 'CELL WALL-BINDING PROTEIN YOCH', 238436),
(295247, 'PTHR39160:SF4', NULL, NULL, NULL, NULL, 'CELL WALL SHAPING PROTEIN YABE-RELATED', 238436),
(295248, 'PTHR13826', NULL, NULL, NULL, NULL, 'INTESTINAL TREFOIL FACTOR-RELATED', 238437);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(295249, 'PTHR13826:SF18', NULL, NULL, NULL, NULL, 'TREFOIL FACTOR 1', 238437),
(295250, 'PTHR13826:SF14', NULL, NULL, NULL, NULL, 'P-TYPE DOMAIN-CONTAINING PROTEIN', 238437),
(295251, 'PTHR13826:SF16', NULL, NULL, NULL, NULL, 'TREFOIL FACTOR 3', 238437),
(295252, 'PTHR13826:SF17', NULL, NULL, NULL, NULL, 'TREFOIL FACTOR 2', 238437),
(295253, 'PTHR46519:SF3', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 238438),
(295254, 'PTHR46519:SF2', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 238438),
(295255, 'PTHR46519:SF5', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 238438),
(295256, 'PTHR46519', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 238438),
(295257, 'PTHR46519:SF10', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 238438),
(295258, 'PTHR46519:SF9', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 238438),
(295259, 'PTHR46519:SF14', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 238438),
(295260, 'PTHR46519:SF13', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 238438),
(295261, 'PTHR46519:SF11', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 238438),
(295262, 'PTHR46519:SF17', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 238438),
(295263, 'PTHR46519:SF16', NULL, NULL, NULL, NULL, 'GLU-RICH PROTEIN', 238438),
(295264, 'PTHR38107:SF4', NULL, NULL, NULL, NULL, 'LYSOZYME', 238439),
(295265, 'PTHR38107', NULL, NULL, NULL, NULL, '', 238439),
(295266, 'PTHR38107:SF3', NULL, NULL, NULL, NULL, 'LYSOZYME RRRD-RELATED', 238439),
(295267, 'PTHR45973:SF2', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 97 KDA', 238440),
(295268, 'PTHR45973:SF1', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 46', 238440),
(295269, 'PTHR45973:SF6', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 43', 238440),
(295270, 'PTHR45973:SF5', NULL, NULL, NULL, NULL, 'CENTRIOLIN', 238440),
(295271, 'PTHR45973', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT SDS22-RELATED', 238440),
(295272, 'PTHR45973:SF8', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 49', 238440),
(295273, 'PTHR45973:SF9', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL ASSEMBLY FACTOR 1 HOMOLOG', 238440),
(295274, 'PTHR45973:SF31', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 42', 238440),
(295275, 'PTHR45973:SF30', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 42', 238440),
(295276, 'PTHR45973:SF26', NULL, NULL, NULL, NULL, '', 238440),
(295277, 'PTHR45973:SF25', NULL, NULL, NULL, NULL, 'AGAP002013-PA', 238440),
(295278, 'PTHR45973:SF13', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT AND COILED-COIL CENTROSOMAL PROTEIN 1', 238440),
(295279, 'PTHR45973:SF24', NULL, NULL, NULL, NULL, '', 238440),
(295280, 'PTHR45973:SF23', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 7', 238440),
(295281, 'PTHR45973:SF12', NULL, NULL, NULL, NULL, 'DYNEIN REGULATORY COMPLEX SUBUNIT 3', 238440),
(295282, 'PTHR45973:SF19', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL ASSEMBLY FACTOR 1', 238440),
(295283, 'PTHR45973:SF29', NULL, NULL, NULL, NULL, '', 238440),
(295284, 'PTHR45973:SF28', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEATS AND IQ MOTIF CONTAINING 1', 238440),
(295285, 'PTHR45973:SF27', NULL, NULL, NULL, NULL, '', 238440),
(295286, 'PTHR43751:SF3', NULL, NULL, NULL, NULL, 'N-ACETYLGALACTOSAMINE 6-SULFATASE (GALNS)', 238441),
(295287, 'PTHR43751:SF5', NULL, NULL, NULL, NULL, 'N-ACETYLGALACTOSAMINE-6-O-SULFATASE', 238441),
(295288, 'PTHR43751:SF1', NULL, NULL, NULL, NULL, 'SULFATASE ATSG-RELATED', 238441),
(295289, 'PTHR43751:SF2', NULL, NULL, NULL, NULL, 'SULFATASE DOMAIN-CONTAINING PROTEIN', 238441),
(295290, 'PTHR43751', NULL, NULL, NULL, NULL, 'SULFATASE', 238441),
(295291, 'PTHR16263', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 38', 238442),
(295292, 'PTHR16263:SF4', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 38', 238442),
(295293, 'PTHR16263:SF11', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 38', 238442);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(295294, 'PTHR16263:SF10', NULL, NULL, NULL, NULL, 'BNACNNG39400D PROTEIN', 238442),
(295295, 'PTHR16263:SF9', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 38', 238442),
(295296, 'PTHR16263:SF12', NULL, NULL, NULL, NULL, 'BNAA07G09610D PROTEIN', 238442),
(295297, 'PTHR45662:SF7', NULL, NULL, NULL, NULL, 'SACI DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_1G15890)', 238443),
(295298, 'PTHR45662:SF8', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITIDE PHOSPHATASE SAC2', 238443),
(295299, 'PTHR45662:SF9', NULL, NULL, NULL, NULL, 'SAC DOMAIN-CONTAINING PROTEIN', 238443),
(295300, 'PTHR45662:SF18', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHATASE SAC7', 238443),
(295301, 'PTHR45662:SF2', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-3-PHOSPHATASE SAC1', 238443),
(295302, 'PTHR45662:SF17', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-3-PHOSPHATASE SAC1-A', 238443),
(295303, 'PTHR45662:SF4', NULL, NULL, NULL, NULL, '', 238443),
(295304, 'PTHR45662:SF19', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-3-PHOSPHATASE SAC1-B', 238443),
(295305, 'PTHR45662', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITIDE PHOSPHATASE SAC1', 238443),
(295306, 'PTHR45662:SF14', NULL, NULL, NULL, NULL, 'SAC DOMAIN-CONTAINING PROTEIN', 238443),
(295307, 'PTHR45662:SF13', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHATASE SAC6-LIKE', 238443),
(295308, 'PTHR45662:SF16', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHATASE SAC6', 238443),
(295309, 'PTHR45662:SF15', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITIDE PHOSPHATASE SAC1-A-RELATED', 238443),
(295310, 'PTHR45662:SF10', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHATASE SAC8', 238443),
(295311, 'PTHR45662:SF11', NULL, NULL, NULL, NULL, 'OS11G0309000 PROTEIN', 238443),
(295312, 'PTHR47230', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING ADAPTER MOLECULE 1', 238444),
(295313, 'PTHR47230:SF1', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING ADAPTER MOLECULE 1', 238444),
(295314, 'PTHR47230:SF2', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING ADAPTER MOLECULE 2', 238444),
(295315, 'PTHR11036:SF80', NULL, NULL, NULL, NULL, 'SEMAPHORIN-7A', 238445),
(295316, 'PTHR11036:SF85', NULL, NULL, NULL, NULL, 'SI:CH211-113G11.6', 238445),
(295317, 'PTHR11036:SF20', NULL, NULL, NULL, NULL, 'SEMAPHORIN-3G', 238445),
(295318, 'PTHR11036:SF65', NULL, NULL, NULL, NULL, 'SEMAPHORIN-6D', 238445),
(295319, 'PTHR11036:SF21', NULL, NULL, NULL, NULL, 'SEMA DOMAIN, IMMUNOGLOBULIN DOMAIN (IG), SHORT BASIC DOMAIN, SECRETED, (SEMAPHORIN) 3H', 238445),
(295320, 'PTHR11036:SF22', NULL, NULL, NULL, NULL, 'SEMAPHORIN-3E', 238445),
(295321, 'PTHR11036:SF23', NULL, NULL, NULL, NULL, 'SEMAPHORIN-3A', 238445),
(295322, 'PTHR11036:SF25', NULL, NULL, NULL, NULL, 'SEMAPHORIN-3C', 238445),
(295323, 'PTHR11036:SF69', NULL, NULL, NULL, NULL, 'SI:DKEY-49N23.1', 238445),
(295324, 'PTHR11036:SF27', NULL, NULL, NULL, NULL, 'SEMAPHORIN-3F', 238445),
(295325, 'PTHR11036:SF28', NULL, NULL, NULL, NULL, 'SEMA DOMAIN, IMMUNOGLOBULIN DOMAIN (IG), SHORT BASIC DOMAIN, SECRETED, (SEMAPHORIN) 3GA-RELATED', 238445),
(295326, 'PTHR11036:SF135', NULL, NULL, NULL, NULL, 'SEMA DOMAIN-CONTAINING PROTEIN', 238445),
(295327, 'PTHR11036:SF136', NULL, NULL, NULL, NULL, 'SEMA DOMAIN, TRANSMEMBRANE DOMAIN (TM), AND CYTOPLASMIC DOMAIN, (SEMAPHORIN) 6D', 238445),
(295328, 'PTHR11036:SF139', NULL, NULL, NULL, NULL, 'SEMAPHORIN-2A', 238445),
(295329, 'PTHR11036', NULL, NULL, NULL, NULL, 'SEMAPHORIN', 238445),
(295330, 'PTHR11036:SF131', NULL, NULL, NULL, NULL, 'MIP07328P', 238445),
(295331, 'PTHR11036:SF130', NULL, NULL, NULL, NULL, 'SEMA DOMAIN, TRANSMEMBRANE DOMAIN (TM), AND CYTOPLASMIC DOMAIN, (SEMAPHORIN) 6BA', 238445),
(295332, 'PTHR11036:SF90', NULL, NULL, NULL, NULL, 'SEMAPHORIN 2B, ISOFORM D-RELATED', 238445),
(295333, 'PTHR11036:SF92', NULL, NULL, NULL, NULL, 'SEMA DOMAIN-CONTAINING PROTEIN', 238445),
(295334, 'PTHR11036:SF71', NULL, NULL, NULL, NULL, 'SEMAPHORIN-3AA', 238445),
(295335, 'PTHR11036:SF72', NULL, NULL, NULL, NULL, 'SEMAPHORIN-4F', 238445),
(295336, 'PTHR11036:SF10', NULL, NULL, NULL, NULL, 'SEMAPHORIN-6B', 238445);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(295337, 'PTHR11036:SF11', NULL, NULL, NULL, NULL, 'SEMAPHORIN-6C', 238445),
(295338, 'PTHR11036:SF78', NULL, NULL, NULL, NULL, 'SEMAPHORIN-5A', 238445),
(295339, 'PTHR11036:SF12', NULL, NULL, NULL, NULL, 'SEMAPHORIN-6A', 238445),
(295340, 'PTHR11036:SF79', NULL, NULL, NULL, NULL, 'SEMAPHORIN 5C, ISOFORM A', 238445),
(295341, 'PTHR11036:SF14', NULL, NULL, NULL, NULL, 'SEMAPHORIN-4B', 238445),
(295342, 'PTHR11036:SF36', NULL, NULL, NULL, NULL, 'SEMAPHORIN-3D', 238445),
(295343, 'PTHR11036:SF15', NULL, NULL, NULL, NULL, 'SEMAPHORIN-4A', 238445),
(295344, 'PTHR11036:SF37', NULL, NULL, NULL, NULL, 'SEMAPHORIN-3B', 238445),
(295345, 'PTHR11036:SF16', NULL, NULL, NULL, NULL, 'SEMAPHORIN-4C', 238445),
(295346, 'PTHR11036:SF39', NULL, NULL, NULL, NULL, 'SEMAPHORIN-5B', 238445),
(295347, 'PTHR11036:SF17', NULL, NULL, NULL, NULL, 'SEMAPHORIN-4G', 238445),
(295348, 'PTHR11036:SF18', NULL, NULL, NULL, NULL, 'SEMAPHORIN-4D', 238445),
(295349, 'PTHR11036:SF144', NULL, NULL, NULL, NULL, '', 238445),
(295350, 'PTHR11036:SF145', NULL, NULL, NULL, NULL, 'SEMA DOMAIN, IMMUNOGLOBULIN DOMAIN (IG), TRANSMEMBRANE DOMAIN (TM) AND SHORT CYTOPLASMIC DOMAIN, (SEMAPHORIN) 4AA-RELATED', 238445),
(295351, 'PTHR11036:SF127', NULL, NULL, NULL, NULL, 'SEMAPHORIN-1A', 238445),
(295352, 'PTHR11036:SF142', NULL, NULL, NULL, NULL, 'SEMA DOMAIN, IMMUNOGLOBULIN DOMAIN (IG), TRANSMEMBRANE DOMAIN (TM) AND SHORT CYTOPLASMIC DOMAIN, (SEMAPHORIN) 4GA', 238445),
(295353, 'PTHR15333:SF2', NULL, NULL, NULL, NULL, 'SNRNA-ACTIVATING PROTEIN COMPLEX SUBUNIT 5', 238446),
(295354, 'PTHR15333', NULL, NULL, NULL, NULL, 'SNRNA-ACTIVATING PROTEIN COMPLEX SUBUNIT 5', 238446),
(295355, 'PTHR36368:SF1', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CASEINOLYTIC PROTEASE/CROTONASE FAMILY PROTEIN', 238447),
(295356, 'PTHR36368', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CASEINOLYTIC PROTEASE/CROTONASE FAMILY PROTEIN', 238447),
(295357, 'PTHR43297:SF7', NULL, NULL, NULL, NULL, 'D,D-DIPEPTIDE TRANSPORT ATP-BINDING PROTEIN DDPD-RELATED', 238448),
(295358, 'PTHR43297:SF11', NULL, NULL, NULL, NULL, 'ATPASE COMPONENT OF ABC-TYPE TRANSPORT SYSTEM-RELATED', 238448),
(295359, 'PTHR43297:SF12', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN', 238448),
(295360, 'PTHR43297:SF6', NULL, NULL, NULL, NULL, 'DIPEPTIDE TRANSPORT ATP-BINDING PROTEIN DPPD', 238448),
(295361, 'PTHR43297:SF9', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN', 238448),
(295362, 'PTHR43297:SF8', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE ABC TRANSPORTER, ATP-BINDING PROTEIN', 238448),
(295363, 'PTHR43297', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORT ATP-BINDING PROTEIN APPD', 238448),
(295364, 'PTHR43297:SF3', NULL, NULL, NULL, NULL, 'ABC-TYPE DIPEPTIDE/OLIGOPEPTIDE TRANSPORT SYSTEM, ATPASE COMPONENT', 238448),
(295365, 'PTHR43297:SF2', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORT ATP-BINDING PROTEIN APPD', 238448),
(295366, 'PTHR43297:SF4', NULL, NULL, NULL, NULL, 'PUTRESCINE EXPORT SYSTEM ATP-BINDING PROTEIN SAPD', 238448),
(295367, 'PTHR34411:SF8', NULL, NULL, NULL, NULL, '', 238449),
(295368, 'PTHR34411:SF3', NULL, NULL, NULL, NULL, '', 238449),
(295369, 'PTHR34411:SF2', NULL, NULL, NULL, NULL, '', 238449),
(295370, 'PTHR34411:SF1', NULL, NULL, NULL, NULL, '', 238449),
(295371, 'PTHR34411:SF7', NULL, NULL, NULL, NULL, '', 238449),
(295372, 'PTHR34411:SF5', NULL, NULL, NULL, NULL, '', 238449),
(295373, 'PTHR34411', NULL, NULL, NULL, NULL, '', 238449),
(295374, 'PTHR34411:SF4', NULL, NULL, NULL, NULL, '', 238449),
(295375, 'PTHR11952:SF10', NULL, NULL, NULL, NULL, '16S RRNA PROCESSING PROTEIN RIMM FAMILY', 238450),
(295376, 'PTHR11952:SF9', NULL, NULL, NULL, NULL, 'UDP-SUGAR PYROPHOSPHORYLASE', 238450),
(295377, 'PTHR11952', NULL, NULL, NULL, NULL, 'UDP- GLUCOSE PYROPHOSPHORYLASE', 238450),
(295378, 'PTHR11952:SF6', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLHEXOSAMINE PYROPHOSPHORYLASE-LIKE PROTEIN 1', 238450),
(295379, 'PTHR11952:SF4', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLHEXOSAMINE PYROPHOSPHORYLASE', 238450),
(295380, 'PTHR11952:SF2', NULL, NULL, NULL, NULL, 'LD24639P', 238450);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(295381, 'PTHR11952:SF14', NULL, NULL, NULL, NULL, 'UTP--GLUCOSE-1-PHOSPHATE URIDYLYLTRANSFERASE 3, CHLOROPLASTIC', 238450),
(295382, 'PTHR11952:SF15', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE DIPHOSPHORYLASE 1', 238450),
(295383, 'PTHR11952:SF16', NULL, NULL, NULL, NULL, 'BNACNNG10940D PROTEIN', 238450),
(295384, 'PTHR11952:SF17', NULL, NULL, NULL, NULL, 'OS08G0206900 PROTEIN', 238450),
(295385, 'PTHR17597', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN MLC1', 238451),
(295386, 'PTHR17597:SF0', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN MLC1', 238451),
(295387, 'PTHR45877:SF7', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SIAH1', 238452),
(295388, 'PTHR45877', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SIAH2', 238452),
(295389, 'PTHR45877:SF5', NULL, NULL, NULL, NULL, 'SEVEN IN ABSENTIA HOMOLOG 3', 238452),
(295390, 'PTHR45877:SF4', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SIAH2', 238452),
(295391, 'PTHR45877:SF3', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE', 238452),
(295392, 'PTHR45877:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SINA-RELATED', 238452),
(295393, 'PTHR35804:SF1', NULL, NULL, NULL, NULL, 'LYSINE EXPORTER LYSO', 238453),
(295394, 'PTHR35804', NULL, NULL, NULL, NULL, 'LYSINE EXPORTER LYSO', 238453),
(295395, 'PTHR23426', NULL, NULL, NULL, NULL, 'FERREDOXIN/ADRENODOXIN', 238454),
(295396, 'PTHR23426:SF63', NULL, NULL, NULL, NULL, 'TRANSFER PROTEIN, PUTATIVE-RELATED', 238454),
(295397, 'PTHR23426:SF65', NULL, NULL, NULL, NULL, 'FERREDOXIN 1-RELATED', 238454),
(295398, 'PTHR23426:SF64', NULL, NULL, NULL, NULL, 'FERREDOXIN-2, MITOCHONDRIAL', 238454),
(295399, 'PTHR23426:SF34', NULL, NULL, NULL, NULL, 'ADRENODOXIN-LIKE PROTEIN 1, MITOCHONDRIAL-RELATED', 238454),
(295400, 'PTHR23426:SF67', NULL, NULL, NULL, NULL, '2FE-2S FERREDOXIN-TYPE DOMAIN-CONTAINING PROTEIN', 238454),
(295401, 'PTHR23426:SF55', NULL, NULL, NULL, NULL, '2FE-2S FERREDOXIN-TYPE DOMAIN-CONTAINING PROTEIN', 238454),
(295402, 'PTHR23426:SF66', NULL, NULL, NULL, NULL, 'ADRENODOXIN-LIKE PROTEIN 1, MITOCHONDRIAL ISOFORM X1', 238454),
(295403, 'PTHR23426:SF69', NULL, NULL, NULL, NULL, 'OS09G0437900 PROTEIN', 238454),
(295404, 'PTHR23426:SF58', NULL, NULL, NULL, NULL, '2FE-2S FERREDOXIN-TYPE DOMAIN-CONTAINING PROTEIN', 238454),
(295405, 'PTHR23426:SF35', NULL, NULL, NULL, NULL, '2FE-2S FERREDOXIN-LIKE SUPERFAMILY PROTEIN', 238454),
(295406, 'PTHR23426:SF68', NULL, NULL, NULL, NULL, '2FE-2S FERREDOXIN-LIKE', 238454),
(295407, 'PTHR23426:SF27', NULL, NULL, NULL, NULL, 'PHOTOSYNTHETIC NDH SUBUNIT OF SUBCOMPLEX B 3, CHLOROPLASTIC', 238454),
(295408, 'PTHR23426:SF26', NULL, NULL, NULL, NULL, 'ADRENODOXIN, MITOCHONDRIAL', 238454),
(295409, 'PTHR47998', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB51-LIKE ISOFORM X1', 238455),
(295410, 'PTHR47998:SF81', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 238455),
(295411, 'PTHR47998:SF80', NULL, NULL, NULL, NULL, 'OS09G0532900 PROTEIN', 238455),
(295412, 'PTHR47998:SF50', NULL, NULL, NULL, NULL, 'R2R3 MYB TRANSCRIPTION FACTOR', 238455),
(295413, 'PTHR47998:SF72', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TT2', 238455),
(295414, 'PTHR47998:SF71', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 238455),
(295415, 'PTHR47998:SF74', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, PUTATIVE-RELATED', 238455),
(295416, 'PTHR47998:SF51', NULL, NULL, NULL, NULL, 'MYB-LIKE TRANSCRIPTION FACTOR ETC2-RELATED', 238455),
(295417, 'PTHR47998:SF73', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TT2', 238455),
(295418, 'PTHR47998:SF76', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 238455),
(295419, 'PTHR47998:SF75', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR MYB5-LIKE', 238455),
(295420, 'PTHR47998:SF31', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR MYB5', 238455),
(295421, 'PTHR47998:SF53', NULL, NULL, NULL, NULL, 'OS02G0732600 PROTEIN', 238455),
(295422, 'PTHR47998:SF12', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR CPC', 238455),
(295423, 'PTHR47998:SF78', NULL, NULL, NULL, NULL, 'MYB-LIKE TRANSCRIPTION FACTOR ETC1', 238455);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(295424, 'PTHR47998:SF33', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR-RELATED', 238455),
(295425, 'PTHR47998:SF77', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TRY', 238455),
(295426, 'PTHR47998:SF14', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB114-LIKE', 238455),
(295427, 'PTHR47998:SF58', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR CPC-LIKE', 238455),
(295428, 'PTHR47998:SF36', NULL, NULL, NULL, NULL, 'OS09G0401000 PROTEIN', 238455),
(295429, 'PTHR47998:SF79', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 238455),
(295430, 'PTHR47998:SF38', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 238455),
(295431, 'PTHR47998:SF16', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR WER', 238455),
(295432, 'PTHR47998:SF15', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB114-LIKE', 238455),
(295433, 'PTHR47998:SF18', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB23-LIKE', 238455),
(295434, 'PTHR47998:SF39', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR MYB5', 238455),
(295435, 'PTHR47998:SF70', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN 4, PUTATIVE-RELATED', 238455),
(295436, 'PTHR47998:SF83', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TT2', 238455),
(295437, 'PTHR47998:SF82', NULL, NULL, NULL, NULL, 'MYB-LIKE DOMAIN-CONTAINING PROTEIN', 238455),
(295438, 'PTHR47998:SF41', NULL, NULL, NULL, NULL, 'MYB-LIKE TRANSCRIPTION FACTOR ETC3 ISOFORM X1', 238455),
(295439, 'PTHR47998:SF85', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 238455),
(295440, 'PTHR47998:SF84', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN 308-LIKE', 238455),
(295441, 'PTHR47998:SF43', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB82', 238455),
(295442, 'PTHR47998:SF20', NULL, NULL, NULL, NULL, 'TRICHOME DIFFERENTIATION PROTEIN GL1', 238455),
(295443, 'PTHR47998:SF67', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 238455),
(295444, 'PTHR47998:SF23', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB12-LIKE', 238455),
(295445, 'PTHR47998:SF47', NULL, NULL, NULL, NULL, 'MYB-LIKE DOMAIN-CONTAINING PROTEIN', 238455),
(295446, 'PTHR47998:SF25', NULL, NULL, NULL, NULL, 'MYB DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 238455),
(295447, 'PTHR47998:SF69', NULL, NULL, NULL, NULL, 'PROTEIN ODORANT1-LIKE', 238455),
(295448, 'PTHR47998:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TRY-LIKE', 238455),
(295449, 'PTHR47998:SF68', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 238455),
(295450, 'PTHR47998:SF27', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB23', 238455),
(295451, 'PTHR47998:SF48', NULL, NULL, NULL, NULL, 'MYB-LIKE TRANSCRIPTION FACTOR ETC3', 238455),
(295452, 'PTHR47998:SF5', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR-RELATED', 238455),
(295453, 'PTHR47998:SF26', NULL, NULL, NULL, NULL, 'MYB RELATED TRANSCRIPTION FACTOR', 238455),
(295454, 'PTHR47998:SF28', NULL, NULL, NULL, NULL, 'MYB-LIKE TRANSCRIPTION FACTOR ETC1', 238455),
(295455, 'PTHR13374:SF3', NULL, NULL, NULL, NULL, 'DET1 HOMOLOG', 238456),
(295456, 'PTHR13374', NULL, NULL, NULL, NULL, 'DET1 HOMOLOG  DE-ETIOLATED-1 HOMOLOG', 238456),
(295457, 'PTHR12046:SF0', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE TYPE B CATALYTIC SUBUNIT', 238457),
(295458, 'PTHR12046:SF1', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE TYPE B CATALYTIC SUBUNIT', 238457),
(295459, 'PTHR12046', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE TYPE B CATALYTIC SUBUNIT', 238457),
(295460, 'PTHR47973:SF5', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 3', 238458),
(295461, 'PTHR47973:SF7', NULL, NULL, NULL, NULL, 'BNAANNG32980D PROTEIN', 238458),
(295462, 'PTHR47973:SF8', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 42', 238458),
(295463, 'PTHR47973:SF1', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 43-RELATED', 238458),
(295464, 'PTHR47973:SF2', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 2', 238458),
(295465, 'PTHR47973:SF36', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE-RELATED', 238458),
(295466, 'PTHR47973:SF37', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 2', 238458);
INSERT INTO "PUBLIC"."MODEL" VALUES
(295467, 'PTHR47973:SF38', NULL, NULL, NULL, NULL, 'OS11G0669200 PROTEIN', 238458),
(295468, 'PTHR47973:SF39', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 238458),
(295469, 'PTHR47973:SF9', NULL, NULL, NULL, NULL, 'BNAA08G30660D PROTEIN', 238458),
(295470, 'PTHR47973:SF32', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE-RELATED', 238458),
(295471, 'PTHR47973:SF33', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RLK (RECEPTOR-LIKE PROTEIN KINASE) 19-RELATED', 238458),
(295472, 'PTHR47973:SF34', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE ISOFORM X1-RELATED', 238458),
(295473, 'PTHR47973:SF35', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE', 238458),
(295474, 'PTHR47973:SF30', NULL, NULL, NULL, NULL, 'OS02G0165100 PROTEIN', 238458),
(295475, 'PTHR47973:SF31', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 238458),
(295476, 'PTHR47973:SF47', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE, NEUROTROPHIC RECEPTOR, TYPE 2-RELATED', 238458),
(295477, 'PTHR47973:SF48', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 238458),
(295478, 'PTHR47973:SF49', NULL, NULL, NULL, NULL, 'OS06G0676600 PROTEIN', 238458),
(295479, 'PTHR47973:SF43', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE-RELATED', 238458),
(295480, 'PTHR47973:SF44', NULL, NULL, NULL, NULL, 'OS12G0249300 PROTEIN', 238458),
(295481, 'PTHR47973:SF45', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 238458),
(295482, 'PTHR47973:SF46', NULL, NULL, NULL, NULL, 'GNK2-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 238458),
(295483, 'PTHR47973:SF40', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 2', 238458),
(295484, 'PTHR47973:SF41', NULL, NULL, NULL, NULL, 'BNAC02G19910D PROTEIN', 238458),
(295485, 'PTHR47973:SF42', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE', 238458),
(295486, 'PTHR47973:SF18', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 238458),
(295487, 'PTHR47973:SF19', NULL, NULL, NULL, NULL, 'OS11G0470500 PROTEIN', 238458),
(295488, 'PTHR47973', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 3', 238458),
(295489, 'PTHR47973:SF58', NULL, NULL, NULL, NULL, 'OS08G0203600 PROTEIN', 238458),
(295490, 'PTHR47973:SF14', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 238458),
(295491, 'PTHR47973:SF59', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 238458),
(295492, 'PTHR47973:SF15', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 238458),
(295493, 'PTHR47973:SF16', NULL, NULL, NULL, NULL, 'OS07G0539700 PROTEIN', 238458),
(295494, 'PTHR47973:SF17', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE RECEPTOR', 238458),
(295495, 'PTHR47973:SF10', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 238458),
(295496, 'PTHR47973:SF54', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 238458),
(295497, 'PTHR47973:SF11', NULL, NULL, NULL, NULL, 'CGMP-DEPENDENT KINASE-RELATED', 238458),
(295498, 'PTHR47973:SF55', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE', 238458),
(295499, 'PTHR47973:SF12', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 1', 238458),
(295500, 'PTHR47973:SF56', NULL, NULL, NULL, NULL, 'DUF26-DOMAIN RECEPTOR-LIKE PROTEIN KINASE FAMILY PROTEIN-RELATED', 238458),
(295501, 'PTHR47973:SF13', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 238458),
(295502, 'PTHR47973:SF57', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN RECEPTOR-LIKE TYROSINE-PROTEIN KINASE', 238458),
(295503, 'PTHR47973:SF50', NULL, NULL, NULL, NULL, 'OS04G0658700 PROTEIN', 238458),
(295504, 'PTHR47973:SF51', NULL, NULL, NULL, NULL, 'COLD-RESPONSIVE PROTEIN KINASE 1', 238458),
(295505, 'PTHR47973:SF52', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 238458),
(295506, 'PTHR47973:SF53', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 238458),
(295507, 'PTHR47973:SF29', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE, ACTIVE SITE PROTEIN-RELATED', 238458);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(295508, 'PTHR47973:SF25', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE RFK1-RELATED', 238458),
(295509, 'PTHR47973:SF26', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE-RELATED', 238458),
(295510, 'PTHR47973:SF27', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 238458),
(295511, 'PTHR47973:SF28', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 238458),
(295512, 'PTHR47973:SF21', NULL, NULL, NULL, NULL, 'PROTEIN KINASE, PLANT-TYPE, PUTATIVE-RELATED', 238458),
(295513, 'PTHR47973:SF22', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT FAMILY PROTEIN / PROTEIN KINASE FAMILY PROTEIN', 238458),
(295514, 'PTHR47973:SF23', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RLK (RECEPTOR-LIKE KINASE) PROTEIN', 238458),
(295515, 'PTHR47973:SF24', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE-RELATED', 238458),
(295516, 'PTHR47973:SF61', NULL, NULL, NULL, NULL, 'OS02G0639100 PROTEIN', 238458),
(295517, 'PTHR47973:SF62', NULL, NULL, NULL, NULL, 'TYROSINE KINASE FAMILY PROTEIN', 238458),
(295518, 'PTHR47973:SF20', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 238458),
(295519, 'PTHR47973:SF60', NULL, NULL, NULL, NULL, 'SERINE-THREONINE/TYROSINE-PROTEIN KINASE CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 238458),
(295520, 'PTHR38448:SF1', NULL, NULL, NULL, NULL, 'IG HYPOTHETICAL 16757', 238459),
(295521, 'PTHR38448:SF2', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN YLBF', 238459),
(295522, 'PTHR38448', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN YLBF-RELATED', 238459),
(295523, 'PTHR46336:SF8', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 238460),
(295524, 'PTHR46336', NULL, NULL, NULL, NULL, 'OS02G0260700 PROTEIN', 238460),
(295525, 'PTHR46336:SF32', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 238460),
(295526, 'PTHR46336:SF21', NULL, NULL, NULL, NULL, 'OS02G0260700 PROTEIN', 238460),
(295527, 'PTHR46336:SF30', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 238460),
(295528, 'PTHR46336:SF20', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 238460),
(295529, 'PTHR46336:SF31', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 238460),
(295530, 'PTHR46336:SF3', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN POB1', 238460),
(295531, 'PTHR46336:SF18', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN POB1-LIKE', 238460),
(295532, 'PTHR46336:SF29', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 238460),
(295533, 'PTHR46336:SF4', NULL, NULL, NULL, NULL, 'BACK DOMAIN-CONTAINING PROTEIN', 238460),
(295534, 'PTHR46336:SF19', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 238460),
(295535, 'PTHR46336:SF27', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 238460),
(295536, 'PTHR46336:SF6', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 238460),
(295537, 'PTHR46336:SF28', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN POB1-LIKE ISOFORM X1', 238460),
(295538, 'PTHR46336:SF12', NULL, NULL, NULL, NULL, 'BACK DOMAIN-CONTAINING PROTEIN', 238460),
(295539, 'PTHR16516:SF5', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 488', 238461),
(295540, 'PTHR16516:SF4', NULL, NULL, NULL, NULL, 'AGAP007109-PA', 238461),
(295541, 'PTHR16516', NULL, NULL, NULL, NULL, 'AGAP007109-PA', 238461),
(295542, 'PTHR16516:SF7', NULL, NULL, NULL, NULL, 'PR DOMAIN ZINC FINGER PROTEIN 8', 238461),
(295543, 'PTHR13847:SF129', NULL, NULL, NULL, NULL, 'FAD DEPENDENT OXIDOREDUCTASE', 238462),
(295544, 'PTHR13847:SF249', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE-RELATED', 238462),
(295545, 'PTHR13847:SF201', NULL, NULL, NULL, NULL, 'PUTATIBE OXIDOREDUCTASE', 238462),
(295546, 'PTHR13847:SF200', NULL, NULL, NULL, NULL, 'SARCOSINE DEHYDROGENASE, MITOCHONDRIAL', 238462),
(295547, 'PTHR13847:SF288', NULL, NULL, NULL, NULL, 'MALATE:QUINONE OXIDOREDUCTASE 2-RELATED', 238462),
(295548, 'PTHR13847:SF188', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 238462),
(295549, 'PTHR13847:SF287', NULL, NULL, NULL, NULL, 'FAD-DEPENDENT OXIDOREDUCTASE DOMAIN-CONTAINING PROTEIN 1', 238462);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(295550, 'PTHR13847:SF286', NULL, NULL, NULL, NULL, 'DAO DOMAIN-CONTAINING PROTEIN', 238462),
(295551, 'PTHR13847:SF187', NULL, NULL, NULL, NULL, 'DIMETHYLGLYCINE DEHYDROGENASE, MITOCHONDRIAL', 238462),
(295552, 'PTHR13847:SF285', NULL, NULL, NULL, NULL, 'DAO DOMAIN-CONTAINING PROTEIN', 238462),
(295553, 'PTHR13847:SF185', NULL, NULL, NULL, NULL, 'FAD DEPENDENT OXIDOREDUCTASE SUPERFAMILY (AFU_ORTHOLOGUE AFUA_3G02360)', 238462),
(295554, 'PTHR13847:SF284', NULL, NULL, NULL, NULL, 'DAO DOMAIN-CONTAINING PROTEIN', 238462),
(295555, 'PTHR13847:SF261', NULL, NULL, NULL, NULL, 'FAD-DEPENDENT OXIDOREDUCTASE FAMILY PROTEIN', 238462),
(295556, 'PTHR13847:SF283', NULL, NULL, NULL, NULL, 'TRNA 5-METHYLAMINOMETHYL-2-THIOURIDINE BIOSYNTHESIS BIFUNCTIONAL PROTEIN MNMC', 238462),
(295557, 'PTHR13847:SF260', NULL, NULL, NULL, NULL, 'DAO DOMAIN-CONTAINING PROTEIN', 238462),
(295558, 'PTHR13847:SF282', NULL, NULL, NULL, NULL, 'LETHAL (2) 37BB', 238462),
(295559, 'PTHR13847:SF281', NULL, NULL, NULL, NULL, 'DAO DOMAIN-CONTAINING PROTEIN', 238462),
(295560, 'PTHR13847:SF181', NULL, NULL, NULL, NULL, 'TRANSFERASE CAF17, MITOCHONDRIAL-RELATED', 238462),
(295561, 'PTHR13847:SF280', NULL, NULL, NULL, NULL, 'D-AMINO ACID DEHYDROGENASE', 238462),
(295562, 'PTHR13847:SF257', NULL, NULL, NULL, NULL, 'FI22513P1', 238462),
(295563, 'PTHR13847:SF213', NULL, NULL, NULL, NULL, 'DEPENDENT OXIDOREDUCTASE, PUTATIVE-RELATED', 238462),
(295564, 'PTHR13847:SF279', NULL, NULL, NULL, NULL, 'DAO DOMAIN-CONTAINING PROTEIN-RELATED', 238462),
(295565, 'PTHR13847:SF278', NULL, NULL, NULL, NULL, 'DAO DOMAIN-CONTAINING PROTEIN', 238462),
(295566, 'PTHR13847:SF277', NULL, NULL, NULL, NULL, 'MALATE:QUINONE OXIDOREDUCTASE', 238462),
(295567, 'PTHR13847', NULL, NULL, NULL, NULL, 'SARCOSINE DEHYDROGENASE-RELATED', 238462),
(295568, 'PTHR13847:SF275', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYLPUTRESCINE OXIDOREDUCTASE', 238462),
(295569, 'PTHR13847:SF274', NULL, NULL, NULL, NULL, 'RIESKE 2FE-2S IRON-SULFUR PROTEIN YHFW-RELATED', 238462),
(295570, 'PTHR13847:SF194', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE-RELATED', 238462),
(295571, 'PTHR13847:SF150', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE TDA3-RELATED', 238462),
(295572, 'PTHR13847:SF193', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE PHOSPHATASE REGULATORY SUBUNIT, MITOCHONDRIAL', 238462),
(295573, 'PTHR34965', NULL, NULL, NULL, NULL, 'OS07G0118300 PROTEIN', 238463),
(295574, 'PTHR34965:SF2', NULL, NULL, NULL, NULL, '', 238463),
(295575, 'PTHR34965:SF1', NULL, NULL, NULL, NULL, 'OS07G0118300 PROTEIN', 238463),
(295576, 'PTHR21225', NULL, NULL, NULL, NULL, 'PHOSPHO-2-DEHYDRO-3-DEOXYHEPTONATE ALDOLASE  DAHP SYNTHETASE', 238464),
(295577, 'PTHR21225:SF10', NULL, NULL, NULL, NULL, 'PHOSPHO-2-DEHYDRO-3-DEOXYHEPTONATE ALDOLASE, TYR-SENSITIVE', 238464),
(295578, 'PTHR21225:SF0', NULL, NULL, NULL, NULL, 'PHOSPHO-2-DEHYDRO-3-DEOXYHEPTONATE ALDOLASE, TYROSINE-INHIBITED', 238464),
(295579, 'PTHR21225:SF12', NULL, NULL, NULL, NULL, 'PHOSPHO-2-DEHYDRO-3-DEOXYHEPTONATE ALDOLASE, PHE-SENSITIVE', 238464),
(295580, 'PTHR21225:SF18', NULL, NULL, NULL, NULL, 'PHOSPHO-2-DEHYDRO-3-DEOXYHEPTONATE ALDOLASE, PHENYLALANINE-INHIBITED', 238464),
(295581, 'PTHR21225:SF6', NULL, NULL, NULL, NULL, 'PHOSPHO-2-DEHYDRO-3-DEOXYHEPTONATE ALDOLASE, TRP-SENSITIVE', 238464),
(295582, 'PTHR30591', NULL, NULL, NULL, NULL, 'RECBCD ENZYME SUBUNIT RECC', 238465),
(295583, 'PTHR30591:SF1', NULL, NULL, NULL, NULL, 'RECBCD ENZYME SUBUNIT RECC', 238465),
(295584, 'PTHR36325:SF1', NULL, NULL, NULL, NULL, 'MYOSIN-2 HEAVY CHAIN-LIKE PROTEIN', 238466),
(295585, 'PTHR36325', NULL, NULL, NULL, NULL, 'MYOSIN-2 HEAVY CHAIN-LIKE PROTEIN', 238466),
(295586, 'PTHR33477:SF7', NULL, NULL, NULL, NULL, '', 238467),
(295587, 'PTHR33477:SF8', NULL, NULL, NULL, NULL, 'P-LOOP NTPASE DOMAIN-CONTAINING PROTEIN LPA1 HOMOLOG 2', 238467),
(295588, 'PTHR33477:SF9', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 238467),
(295589, 'PTHR33477:SF3', NULL, NULL, NULL, NULL, 'P-LOOP NTPASE DOMAIN-CONTAINING PROTEIN LPA1 HOMOLOG 1', 238467);
INSERT INTO "PUBLIC"."MODEL" VALUES
(295590, 'PTHR33477:SF11', NULL, NULL, NULL, NULL, 'BNAA10G13560D PROTEIN', 238467),
(295591, 'PTHR33477:SF10', NULL, NULL, NULL, NULL, 'ATP/GTP NUCLEOTIDE-BINDING PROTEIN', 238467),
(295592, 'PTHR33477:SF4', NULL, NULL, NULL, NULL, 'P-LOOP NTPASE DOMAIN-CONTAINING PROTEIN LPA1 HOMOLOG', 238467),
(295593, 'PTHR33477:SF5', NULL, NULL, NULL, NULL, '', 238467),
(295594, 'PTHR33477', NULL, NULL, NULL, NULL, 'P-LOOP NTPASE DOMAIN-CONTAINING PROTEIN LPA1 HOMOLOG 1', 238467),
(295595, 'PTHR33477:SF2', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN', 238467),
(295596, 'PTHR11113', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINE-6-PHOSPHATE DEACETYLASE', 238468),
(295597, 'PTHR11113:SF15', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINE-6-PHOSPHATE DEACETYLASE-LIKE PROTEIN', 238468),
(295598, 'PTHR11113:SF2', NULL, NULL, NULL, NULL, 'ADENINE DEAMINASE', 238468),
(295599, 'PTHR11113:SF4', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINE-6-PHOSPHATE DEACETYLASE', 238468),
(295600, 'PTHR11113:SF14', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINE-6-PHOSPHATE DEACETYLASE', 238468),
(295601, 'PTHR11113:SF6', NULL, NULL, NULL, NULL, 'ADENINE DEAMINASE YERA-RELATED', 238468),
(295602, 'PTHR16284', NULL, NULL, NULL, NULL, 'PROTEIN CDV3 HOMOLOG', 238469),
(295603, 'PTHR16284:SF13', NULL, NULL, NULL, NULL, 'PROTEIN CDV3 HOMOLOG', 238469),
(295604, 'PTHR31933:SF10', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 15', 238470),
(295605, 'PTHR31933:SF21', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 238470),
(295606, 'PTHR31933:SF20', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 238470),
(295607, 'PTHR31933:SF5', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 31', 238470),
(295608, 'PTHR31933:SF4', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 8', 238470),
(295609, 'PTHR31933:SF7', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 238470),
(295610, 'PTHR31933:SF6', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 238470),
(295611, 'PTHR31933', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 2-RELATED', 238470),
(295612, 'PTHR31933:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PECTIC ARABINOGALACTAN SYNTHESIS-RELATED', 238470),
(295613, 'PTHR31933:SF19', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 39', 238470),
(295614, 'PTHR31933:SF18', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 238470),
(295615, 'PTHR31933:SF16', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 238470),
(295616, 'PTHR31933:SF15', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 238470),
(295617, 'PTHR31933:SF9', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 2', 238470),
(295618, 'PTHR31933:SF14', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 238470),
(295619, 'PTHR31933:SF8', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 238470),
(295620, 'PTHR31933:SF12', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 238470),
(295621, 'PTHR31933:SF11', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 238470),
(295622, 'PTHR31933:SF22', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 238470),
(295623, 'PTHR32410:SF209', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN FAMILY PROTEIN', 238471),
(295624, 'PTHR32410:SF207', NULL, NULL, NULL, NULL, 'C1_2 DOMAIN-CONTAINING PROTEIN', 238471),
(295625, 'PTHR32410:SF208', NULL, NULL, NULL, NULL, 'CHP-RICH ZINC FINGER PROTEIN-RELATED', 238471),
(295626, 'PTHR32410:SF206', NULL, NULL, NULL, NULL, 'C1 DOMAIN FAMILY PROTEIN, PUTATIVE-RELATED', 238471),
(295627, 'PTHR32410:SF162', NULL, NULL, NULL, NULL, 'CHP-RICH ZINC FINGER PROTEIN-LIKE-RELATED', 238471),
(295628, 'PTHR32410:SF184', NULL, NULL, NULL, NULL, 'CHP-RICH ZINC FINGER PROTEIN-LIKE-RELATED', 238471),
(295629, 'PTHR32410:SF163', NULL, NULL, NULL, NULL, 'C1 DOMAIN FAMILY PROTEIN, PUTATIVE-RELATED', 238471),
(295630, 'PTHR32410:SF185', NULL, NULL, NULL, NULL, 'PHORBOL-ESTER/DAG-TYPE DOMAIN-CONTAINING PROTEIN', 238471),
(295631, 'PTHR32410:SF160', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN FAMILY PROTEIN', 238471);
INSERT INTO "PUBLIC"."MODEL" VALUES
(295632, 'PTHR32410:SF161', NULL, NULL, NULL, NULL, 'ZINC FINGER, PHD-TYPE, C1-LIKE, ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 238471),
(295633, 'PTHR32410:SF181', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN FAMILY PROTEIN', 238471),
(295634, 'PTHR32410:SF203', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN FAMILY PROTEIN', 238471),
(295635, 'PTHR32410:SF204', NULL, NULL, NULL, NULL, 'CHP-RICH ZINC FINGER PROTEIN-LIKE', 238471),
(295636, 'PTHR32410:SF168', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN FAMILY PROTEIN', 238471),
(295637, 'PTHR32410:SF201', NULL, NULL, NULL, NULL, 'BNAC02G01500D PROTEIN', 238471),
(295638, 'PTHR32410:SF169', NULL, NULL, NULL, NULL, 'C1 DOMAIN FAMILY PROTEIN, PUTATIVE-RELATED', 238471),
(295639, 'PTHR32410:SF188', NULL, NULL, NULL, NULL, 'BNAA01G36140D PROTEIN', 238471),
(295640, 'PTHR32410:SF167', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN FAMILY PROTEIN', 238471),
(295641, 'PTHR32410:SF186', NULL, NULL, NULL, NULL, 'BNAA05G36950D PROTEIN', 238471),
(295642, 'PTHR32410', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN FAMILY PROTEIN', 238471),
(295643, 'PTHR32410:SF165', NULL, NULL, NULL, NULL, 'C1 DOMAIN FAMILY PROTEIN, PUTATIVE-RELATED', 238471),
(295644, 'PTHR32410:SF173', NULL, NULL, NULL, NULL, 'C1 DOMAIN FAMILY PROTEIN, PUTATIVE-RELATED', 238471),
(295645, 'PTHR32410:SF174', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN FAMILY PROTEIN', 238471),
(295646, 'PTHR32410:SF193', NULL, NULL, NULL, NULL, 'BNAA05G36940D PROTEIN', 238471),
(295647, 'PTHR32410:SF172', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN FAMILY PROTEIN', 238471),
(295648, 'PTHR32410:SF191', NULL, NULL, NULL, NULL, 'C1 DOMAIN FAMILY PROTEIN, PUTATIVE-RELATED', 238471),
(295649, 'PTHR32410:SF192', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN FAMILY PROTEIN', 238471),
(295650, 'PTHR32410:SF159', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN FAMILY PROTEIN', 238471),
(295651, 'PTHR32410:SF179', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN FAMILY PROTEIN', 238471),
(295652, 'PTHR32410:SF212', NULL, NULL, NULL, NULL, 'C1_2 DOMAIN-CONTAINING PROTEIN', 238471),
(295653, 'PTHR32410:SF157', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN FAMILY PROTEIN', 238471),
(295654, 'PTHR32410:SF213', NULL, NULL, NULL, NULL, 'PHORBOL-ESTER/DAG-TYPE DOMAIN-CONTAINING PROTEIN', 238471),
(295655, 'PTHR32410:SF210', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN FAMILY PROTEIN', 238471),
(295656, 'PTHR32410:SF199', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN FAMILY PROTEIN', 238471),
(295657, 'PTHR32410:SF155', NULL, NULL, NULL, NULL, 'CHP-RICH ZINC FINGER PROTEIN-LIKE', 238471),
(295658, 'PTHR32410:SF211', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN FAMILY PROTEIN', 238471),
(295659, 'PTHR32410:SF197', NULL, NULL, NULL, NULL, 'BNAA05G28670D PROTEIN', 238471),
(295660, 'PTHR32410:SF153', NULL, NULL, NULL, NULL, 'CHP-RICH ZINC FINGER PROTEIN-LIKE-RELATED', 238471),
(295661, 'PTHR32410:SF154', NULL, NULL, NULL, NULL, 'CHP-RICH ZINC FINGER PROTEIN-LIKE-RELATED', 238471),
(295662, 'PTHR32410:SF176', NULL, NULL, NULL, NULL, 'CHP-RICH ZINC FINGER PROTEIN-LIKE-RELATED', 238471),
(295663, 'PTHR33794:SF3', NULL, NULL, NULL, NULL, 'NEUTRAL PROTEASE B', 238472),
(295664, 'PTHR33794', NULL, NULL, NULL, NULL, 'BACILLOLYSIN', 238472),
(295665, 'PTHR33794:SF1', NULL, NULL, NULL, NULL, 'BACILLOLYSIN', 238472),
(295666, 'PTHR38812:SF2', NULL, NULL, NULL, NULL, 'MU-LIKE PROPHAGE FLUMU PROTEIN GP42', 238473),
(295667, 'PTHR38812', NULL, NULL, NULL, NULL, 'MU-LIKE PROPHAGE FLUMU PROTEIN GP42', 238473),
(295668, 'PTHR13483:SF11', NULL, NULL, NULL, NULL, 'ZINC FINGER HIT DOMAIN-CONTAINING PROTEIN 3', 238474),
(295669, 'PTHR13483', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 238474),
(295670, 'PTHR13483:SF3', NULL, NULL, NULL, NULL, 'BOX C/D SNORNA PROTEIN 1', 238474),
(295671, 'PTHR13483:SF17', NULL, NULL, NULL, NULL, 'PROTEIN HIT1', 238474),
(295672, 'PTHR13483:SF16', NULL, NULL, NULL, NULL, 'BNAC06G02250D PROTEIN', 238474);
INSERT INTO "PUBLIC"."MODEL" VALUES
(295673, 'PTHR12731', NULL, NULL, NULL, NULL, 'TRANSLOCON-ASSOCIATED PROTEIN, DELTA SUBUNIT', 238475),
(295674, 'PTHR12731:SF1', NULL, NULL, NULL, NULL, 'TRANSLOCON-ASSOCIATED PROTEIN SUBUNIT DELTA', 238475),
(295675, 'PTHR23340:SF0', NULL, NULL, NULL, NULL, 'SURP AND G-PATCH DOMAIN-CONTAINING PROTEIN 1-LIKE PROTEIN', 238476),
(295676, 'PTHR23340', NULL, NULL, NULL, NULL, 'ARGININE/SERINE RICH SPLICING FACTOR SF4/14', 238476),
(295677, 'PTHR23340:SF2', NULL, NULL, NULL, NULL, 'SURP AND G-PATCH DOMAIN-CONTAINING PROTEIN 2', 238476),
(295678, 'PTHR23340:SF3', NULL, NULL, NULL, NULL, 'SURP AND G-PATCH DOMAIN-CONTAINING PROTEIN 1', 238476),
(295679, 'PTHR37308', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN', 238477),
(295680, 'PTHR37308:SF1', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN', 238477),
(295681, 'PTHR12622:SF41', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE DTX3L', 238478),
(295682, 'PTHR12622:SF42', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE', 238478),
(295683, 'PTHR12622:SF7', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE DTX1', 238478),
(295684, 'PTHR12622:SF43', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE', 238478),
(295685, 'PTHR12622:SF21', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE DTX2-RELATED', 238478),
(295686, 'PTHR12622:SF37', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238478),
(295687, 'PTHR12622:SF5', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE DTX4', 238478),
(295688, 'PTHR12622:SF4', NULL, NULL, NULL, NULL, 'PROTEIN DELTEX', 238478),
(295689, 'PTHR12622', NULL, NULL, NULL, NULL, 'DELTEX-RELATED', 238478),
(295690, 'PTHR12622:SF35', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE DTX3-RELATED', 238478),
(295691, 'PTHR12622:SF36', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE', 238478),
(295692, 'PTHR12622:SF39', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE', 238478),
(295693, 'PTHR12700', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT D, MITOCHONDRIAL', 238479),
(295694, 'PTHR12700:SF17', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT D, MITOCHONDRIAL', 238479),
(295695, 'PTHR12700:SF16', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT D, MITOCHONDRIAL', 238479),
(295696, 'PTHR12700:SF22', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT D, MITOCHONDRIAL', 238479),
(295697, 'PTHR12700:SF23', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT D, MITOCHONDRIAL', 238479),
(295698, 'PTHR12700:SF12', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT D, MITOCHONDRIAL', 238479),
(295699, 'PTHR12700:SF20', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT D, MITOCHONDRIAL', 238479),
(295700, 'PTHR15511:SF2', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 13B', 238480),
(295701, 'PTHR15511', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 13B', 238480),
(295702, 'PTHR38039:SF1', NULL, NULL, NULL, NULL, 'TOXIN YOEB', 238481),
(295703, 'PTHR38039', NULL, NULL, NULL, NULL, 'TOXIN YOEB', 238481),
(295704, 'PTHR33820', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 17', 238482),
(295705, 'PTHR33820:SF3', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 17-LIKE', 238482),
(295706, 'PTHR33820:SF4', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 17', 238482),
(295707, 'PTHR33820:SF2', NULL, NULL, NULL, NULL, '', 238482),
(295708, 'PTHR36475', NULL, NULL, NULL, NULL, 'LEUCINE-RICH SINGLE-PASS MEMBRANE PROTEIN 1', 238483),
(295709, 'PTHR36475:SF1', NULL, NULL, NULL, NULL, 'LEUCINE-RICH SINGLE-PASS MEMBRANE PROTEIN 1', 238483),
(295710, 'PTHR45964', NULL, NULL, NULL, NULL, 'WSCD FAMILY MEMBER CG9164', 238484),
(295711, 'PTHR45964:SF7', NULL, NULL, NULL, NULL, 'WSC DOMAIN-CONTAINING PROTEIN 2', 238484),
(295712, 'PTHR45964:SF5', NULL, NULL, NULL, NULL, 'WSC DOMAIN-CONTAINING PROTEIN 1', 238484),
(295713, 'PTHR24045:SF0', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINE-1-PHOSPHOTRANSFERASE SUBUNITS ALPHA/BETA', 238485),
(295714, 'PTHR24045', NULL, NULL, NULL, NULL, '', 238485),
(295715, 'PTHR23167:SF3', NULL, NULL, NULL, NULL, 'CYTOSPIN-B', 238486);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(295716, 'PTHR23167', NULL, NULL, NULL, NULL, 'CALPONIN HOMOLOGY DOMAIN-CONTAINING PROTEIN DDB_G0272472-RELATED', 238486),
(295717, 'PTHR23167:SF18', NULL, NULL, NULL, NULL, 'CYTOSPIN-A', 238486),
(295718, 'PTHR23167:SF39', NULL, NULL, NULL, NULL, '[F-ACTIN]-MONOOXYGENASE MICAL2', 238486),
(295719, 'PTHR23167:SF45', NULL, NULL, NULL, NULL, 'SMOOTHELIN-LIKE PROTEIN 1', 238486),
(295720, 'PTHR23167:SF43', NULL, NULL, NULL, NULL, 'EH DOMAIN-BINDING PROTEIN 1', 238486),
(295721, 'PTHR23167:SF54', NULL, NULL, NULL, NULL, '[F-ACTIN]-MONOOXYGENASE MICAL', 238486),
(295722, 'PTHR23167:SF42', NULL, NULL, NULL, NULL, 'EH DOMAIN-BINDING PROTEIN 1-LIKE PROTEIN 1', 238486),
(295723, 'PTHR23167:SF37', NULL, NULL, NULL, NULL, 'SMOOTHELIN-LIKE PROTEIN 2', 238486),
(295724, 'PTHR23167:SF69', NULL, NULL, NULL, NULL, 'FI18193P1', 238486),
(295725, 'PTHR23167:SF35', NULL, NULL, NULL, NULL, '[F-ACTIN]-MONOOXYGENASE MICAL1', 238486),
(295726, 'PTHR23167:SF46', NULL, NULL, NULL, NULL, 'CALPONIN-HOMOLOGY (CH) DOMAIN-CONTAINING PROTEIN-RELATED', 238486),
(295727, 'PTHR23167:SF79', NULL, NULL, NULL, NULL, 'SI:CH211-195O20.7', 238486),
(295728, 'PTHR23167:SF81', NULL, NULL, NULL, NULL, 'MICAL-LIKE 1B, DUPLICATE 2', 238486),
(295729, 'PTHR23167:SF80', NULL, NULL, NULL, NULL, '[F-ACTIN]-MONOOXYGENASE MICAL1', 238486),
(295730, 'PTHR23167:SF74', NULL, NULL, NULL, NULL, '', 238486),
(295731, 'PTHR23167:SF52', NULL, NULL, NULL, NULL, 'SMOOTHELIN', 238486),
(295732, 'PTHR23167:SF62', NULL, NULL, NULL, NULL, 'EPS15 HOMOLOGY DOMAIN CONTAINING PROTEIN-BINDING PROTEIN 1, ISOFORM F', 238486),
(295733, 'PTHR23167:SF51', NULL, NULL, NULL, NULL, '[F-ACTIN]-MONOOXYGENASE MICAL3', 238486),
(295734, 'PTHR23167:SF83', NULL, NULL, NULL, NULL, 'ALPHA ACTININ 3', 238486),
(295735, 'PTHR23167:SF82', NULL, NULL, NULL, NULL, '', 238486),
(295736, 'PTHR35713', NULL, NULL, NULL, NULL, 'ARGININE/SERINE-RICH-LIKE SPLICING FACTOR', 238487),
(295737, 'PTHR35713:SF3', NULL, NULL, NULL, NULL, 'BNAA07G02500D PROTEIN', 238487),
(295738, 'PTHR35713:SF1', NULL, NULL, NULL, NULL, 'ARGININE/SERINE-RICH-LIKE SPLICING FACTOR', 238487),
(295739, 'PTHR46368:SF7', NULL, NULL, NULL, NULL, 'GFO_IDH_MOCA DOMAIN-CONTAINING PROTEIN', 238488),
(295740, 'PTHR46368:SF5', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 238488),
(295741, 'PTHR46368:SF4', NULL, NULL, NULL, NULL, 'OS10G0403700 PROTEIN', 238488),
(295742, 'PTHR46368:SF10', NULL, NULL, NULL, NULL, 'GFO_IDH_MOCA DOMAIN-CONTAINING PROTEIN', 238488),
(295743, 'PTHR46368:SF14', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE FAMILY, NAD-BINDING ROSSMANN FOLD PROTEIN', 238488),
(295744, 'PTHR46368:SF12', NULL, NULL, NULL, NULL, 'GFO_IDH_MOCA DOMAIN-CONTAINING PROTEIN', 238488),
(295745, 'PTHR46368:SF11', NULL, NULL, NULL, NULL, 'GFO_IDH_MOCA DOMAIN-CONTAINING PROTEIN', 238488),
(295746, 'PTHR46368', NULL, NULL, NULL, NULL, '', 238488),
(295747, 'PTHR46368:SF17', NULL, NULL, NULL, NULL, 'GFO_IDH_MOCA DOMAIN-CONTAINING PROTEIN', 238488),
(295748, 'PTHR46368:SF9', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE', 238488),
(295749, 'PTHR46368:SF16', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 238488),
(295750, 'PTHR46368:SF8', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE FAMILY, NAD-BINDING ROSSMANN FOLD PROTEIN', 238488),
(295751, 'PTHR41156:SF1', NULL, NULL, NULL, NULL, 'AGAP006184-PA', 238489),
(295752, 'PTHR41156', NULL, NULL, NULL, NULL, 'AGAP006184-PA', 238489),
(295753, 'PTHR47857:SF1', NULL, NULL, NULL, NULL, 'OS04G0559200 PROTEIN', 238490),
(295754, 'PTHR47857:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 238490),
(295755, 'PTHR47857', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', 238490),
(295756, 'PTHR47857:SF3', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 238490),
(295757, 'PTHR45825', NULL, NULL, NULL, NULL, 'GRANULE-BOUND STARCH SYNTHASE 1, CHLOROPLASTIC/AMYLOPLASTIC', 238491),
(295758, 'PTHR45825:SF15', NULL, NULL, NULL, NULL, 'STARCH SYNTHASE, CHLOROPLASTIC/AMYLOPLASTIC', 238491),
(295759, 'PTHR45825:SF8', NULL, NULL, NULL, NULL, 'GLYCOGEN SYNTHASE', 238491);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(295760, 'PTHR45825:SF17', NULL, NULL, NULL, NULL, 'STARCH SYNTHASE, CHLOROPLASTIC/AMYLOPLASTIC', 238491),
(295761, 'PTHR45825:SF11', NULL, NULL, NULL, NULL, 'STARCH SYNTHASE 1, CHLOROPLASTIC/AMYLOPLASTIC', 238491),
(295762, 'PTHR45825:SF4', NULL, NULL, NULL, NULL, 'SOLUBLE STARCH SYNTHASE 2-3, CHLOROPLASTIC/AMYLOPLASTIC', 238491),
(295763, 'PTHR45825:SF3', NULL, NULL, NULL, NULL, 'GRANULE-BOUND STARCH SYNTHASE 1, CHLOROPLASTIC/AMYLOPLASTIC', 238491),
(295764, 'PTHR45825:SF13', NULL, NULL, NULL, NULL, 'SOLUBLE STARCH SYNTHASE 2-2, CHLOROPLASTIC/AMYLOPLASTIC', 238491),
(295765, 'PTHR45825:SF2', NULL, NULL, NULL, NULL, 'STARCH SYNTHASE 2, CHLOROPLASTIC/AMYLOPLASTIC', 238491),
(295766, 'PTHR33731:SF2', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 238492),
(295767, 'PTHR33731:SF15', NULL, NULL, NULL, NULL, 'ORGAN SPECIFIC PROTEIN-RELATED', 238492),
(295768, 'PTHR33731:SF12', NULL, NULL, NULL, NULL, 'SPECIFIC TISSUE PROTEIN 1', 238492),
(295769, 'PTHR33731', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 238492),
(295770, 'PTHR33731:SF9', NULL, NULL, NULL, NULL, 'ORGAN SPECIFIC PROTEIN-RELATED', 238492),
(295771, 'PTHR13261', NULL, NULL, NULL, NULL, 'BRCA2 AND CDKN1A INTERACTING PROTEIN', 238493),
(295772, 'PTHR13261:SF0', NULL, NULL, NULL, NULL, 'BRCA2 AND CDKN1A-INTERACTING PROTEIN', 238493),
(295773, 'PTHR34671:SF9', NULL, NULL, NULL, NULL, 'EM-LIKE PROTEIN GEA6', 238494),
(295774, 'PTHR34671:SF5', NULL, NULL, NULL, NULL, 'EM PROTEIN CS41', 238494),
(295775, 'PTHR34671:SF26', NULL, NULL, NULL, NULL, 'EMBRYOGENSIS ABUNDANT PROTEIN', 238494),
(295776, 'PTHR34671:SF15', NULL, NULL, NULL, NULL, 'BNAA03G18930D PROTEIN', 238494),
(295777, 'PTHR34671:SF16', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN EMB564', 238494),
(295778, 'PTHR34671:SF19', NULL, NULL, NULL, NULL, 'EMBRYONIC ABUNDANT PROTEIN 1', 238494),
(295779, 'PTHR34671:SF21', NULL, NULL, NULL, NULL, 'SMALL HYDROPHILIC PLANT SEED PROTEIN', 238494),
(295780, 'PTHR34671:SF22', NULL, NULL, NULL, NULL, 'OS01G0159600 PROTEIN', 238494),
(295781, 'PTHR34671:SF11', NULL, NULL, NULL, NULL, 'EM-LIKE PROTEIN GEA1', 238494),
(295782, 'PTHR34671:SF24', NULL, NULL, NULL, NULL, 'SEED MATURATION PROTEIN P8B6, PUTATIVE-RELATED', 238494),
(295783, 'PTHR34671:SF14', NULL, NULL, NULL, NULL, 'EM PROTEIN', 238494),
(295784, 'PTHR34671:SF25', NULL, NULL, NULL, NULL, 'CARROT ABA-INDUCED IN SOMATIC EMBRYOS 3-LIKE', 238494),
(295785, 'PTHR34671', NULL, NULL, NULL, NULL, 'EM-LIKE PROTEIN GEA1', 238494),
(295786, 'PTHR47948:SF10', NULL, NULL, NULL, NULL, 'BNAA04G17570D PROTEIN', 238495),
(295787, 'PTHR47948:SF9', NULL, NULL, NULL, NULL, 'BNAA05G11950D PROTEIN', 238495),
(295788, 'PTHR47948', NULL, NULL, NULL, NULL, 'TRANS-CINNAMATE 4-MONOOXYGENASE', 238495),
(295789, 'PTHR47948:SF4', NULL, NULL, NULL, NULL, 'TRANS-CINNAMATE 4-MONOOXYGENASE', 238495),
(295790, 'PTHR47948:SF3', NULL, NULL, NULL, NULL, 'OS02G0467000 PROTEIN', 238495),
(295791, 'PTHR47948:SF1', NULL, NULL, NULL, NULL, 'TRANS-CINNAMATE 4-MONOOXYGENASE', 238495),
(295792, 'PTHR47948:SF8', NULL, NULL, NULL, NULL, 'BNAC03G16950D PROTEIN', 238495),
(295793, 'PTHR47948:SF7', NULL, NULL, NULL, NULL, 'BNAA04G17560D PROTEIN', 238495),
(295794, 'PTHR47948:SF6', NULL, NULL, NULL, NULL, '', 238495),
(295795, 'PTHR47948:SF5', NULL, NULL, NULL, NULL, 'TRANS-CINNAMATE 4-MONOOXYGENASE-LIKE', 238495),
(295796, 'PTHR11527:SF358', NULL, NULL, NULL, NULL, '16.9 KDA CLASS I HEAT SHOCK PROTEIN 2', 238496),
(295797, 'PTHR11527:SF314', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 238496),
(295798, 'PTHR11527:SF359', NULL, NULL, NULL, NULL, '18.1 KDA CLASS I HEAT SHOCK PROTEIN', 238496),
(295799, 'PTHR11527:SF353', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 238496),
(295800, 'PTHR11527:SF277', NULL, NULL, NULL, NULL, '17.7 KDA CLASS II HEAT SHOCK PROTEIN', 238496),
(295801, 'PTHR11527:SF310', NULL, NULL, NULL, NULL, 'SMALL HEAT SHOCK PROTEIN HSPI, MITOCHONDRIAL-RELATED', 238496),
(295802, 'PTHR11527:SF311', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 238496);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(295803, 'PTHR11527:SF355', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 238496),
(295804, 'PTHR11527:SF279', NULL, NULL, NULL, NULL, '17.4 KDA CLASS I HEAT SHOCK PROTEIN-RELATED', 238496),
(295805, 'PTHR11527:SF273', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 238496),
(295806, 'PTHR11527:SF351', NULL, NULL, NULL, NULL, '16.9 KDA CLASS I HEAT SHOCK PROTEIN 1', 238496),
(295807, 'PTHR11527:SF271', NULL, NULL, NULL, NULL, '22.0 KDA CLASS IV HEAT SHOCK PROTEIN-LIKE', 238496),
(295808, 'PTHR11527:SF347', NULL, NULL, NULL, NULL, '17.8 KDA HEAT SHOCK PROTEIN', 238496),
(295809, 'PTHR11527:SF348', NULL, NULL, NULL, NULL, '16.9 KDA CLASS I HEAT SHOCK PROTEIN 1', 238496),
(295810, 'PTHR11527:SF189', NULL, NULL, NULL, NULL, '18.9 KDA HEAT SHOCK PROTEIN', 238496),
(295811, 'PTHR11527:SF344', NULL, NULL, NULL, NULL, '18.1 KDA CLASS I HEAT SHOCK PROTEIN-LIKE', 238496),
(295812, 'PTHR11527:SF267', NULL, NULL, NULL, NULL, '22.0 KDA HEAT SHOCK PROTEIN', 238496),
(295813, 'PTHR11527:SF301', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 238496),
(295814, 'PTHR11527:SF308', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 238496),
(295815, 'PTHR11527:SF309', NULL, NULL, NULL, NULL, '17.3 KDA CLASS I HEAT SHOCK PROTEIN-LIKE', 238496),
(295816, 'PTHR11527:SF382', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 238496),
(295817, 'PTHR11527:SF383', NULL, NULL, NULL, NULL, '18.1 KDA CLASS I HEAT SHOCK PROTEIN-LIKE', 238496),
(295818, 'PTHR11527:SF142', NULL, NULL, NULL, NULL, '15.7 KDA HEAT SHOCK PROTEIN, PEROXISOMAL', 238496),
(295819, 'PTHR11527:SF384', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 238496),
(295820, 'PTHR11527:SF385', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 238496),
(295821, 'PTHR11527:SF380', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 238496),
(295822, 'PTHR11527:SF381', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 238496),
(295823, 'PTHR11527:SF260', NULL, NULL, NULL, NULL, '18.0 KDA CLASS II HEAT SHOCK PROTEIN', 238496),
(295824, 'PTHR11527:SF183', NULL, NULL, NULL, NULL, '17.8 KDA CLASS I HEAT SHOCK PROTEIN-LIKE', 238496),
(295825, 'PTHR11527:SF379', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 238496),
(295826, 'PTHR11527:SF335', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 238496),
(295827, 'PTHR11527:SF375', NULL, NULL, NULL, NULL, '16.6 KDA HEAT SHOCK PROTEIN', 238496),
(295828, 'PTHR11527:SF376', NULL, NULL, NULL, NULL, 'CLASS I HEAT SHOCK PROTEIN-RELATED', 238496),
(295829, 'PTHR11527:SF299', NULL, NULL, NULL, NULL, '18.5 KDA CLASS IV HEAT SHOCK PROTEIN', 238496),
(295830, 'PTHR11527:SF135', NULL, NULL, NULL, NULL, '21.9 KDA HEAT SHOCK PROTEIN', 238496),
(295831, 'PTHR11527:SF377', NULL, NULL, NULL, NULL, '17.4 KDA CLASS I HEAT SHOCK PROTEIN 3', 238496),
(295832, 'PTHR11527:SF334', NULL, NULL, NULL, NULL, 'HSP20/ALPHA CRYSTALLIN FAMILY PROTEIN', 238496),
(295833, 'PTHR11527:SF378', NULL, NULL, NULL, NULL, '17.1 KDA CLASS II HEAT SHOCK PROTEIN-LIKE', 238496),
(295834, 'PTHR11527:SF371', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 238496),
(295835, 'PTHR11527:SF372', NULL, NULL, NULL, NULL, 'HSP20.1 PROTEIN', 238496),
(295836, 'PTHR11527:SF295', NULL, NULL, NULL, NULL, '19.0 KDA CLASS II HEAT SHOCK PROTEIN', 238496),
(295837, 'PTHR11527:SF175', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 42', 238496),
(295838, 'PTHR11527:SF296', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 238496),
(295839, 'PTHR11527:SF373', NULL, NULL, NULL, NULL, '17.8 KDA CLASS I HEAT SHOCK PROTEIN-LIKE', 238496),
(295840, 'PTHR11527:SF374', NULL, NULL, NULL, NULL, '17.6 KDA CLASS II HEAT SHOCK PROTEIN', 238496),
(295841, 'PTHR11527:SF297', NULL, NULL, NULL, NULL, '17.4 KDA CLASS III HEAT SHOCK PROTEIN', 238496),
(295842, 'PTHR11527:SF290', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 238496),
(295843, 'PTHR11527:SF370', NULL, NULL, NULL, NULL, '17.9 KDA HEAT SHOCK PROTEIN 2', 238496),
(295844, 'PTHR11527:SF293', NULL, NULL, NULL, NULL, 'CYTOSOLIC CLASS I SMALL HEAT SHOCK PROTEIN', 238496);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(295845, 'PTHR11527:SF324', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 238496),
(295846, 'PTHR11527:SF368', NULL, NULL, NULL, NULL, '17.9 KDA CLASS II HEAT SHOCK PROTEIN', 238496),
(295847, 'PTHR11527:SF369', NULL, NULL, NULL, NULL, '18.1 KDA CLASS I HEAT SHOCK PROTEIN-LIKE', 238496),
(295848, 'PTHR11527:SF327', NULL, NULL, NULL, NULL, '17.9 KDA CLASS I HEAT SHOCK PROTEIN', 238496),
(295849, 'PTHR11527:SF364', NULL, NULL, NULL, NULL, '18.1 KDA CLASS I HEAT SHOCK PROTEIN', 238496),
(295850, 'PTHR11527:SF320', NULL, NULL, NULL, NULL, 'LOW MOLECULAR WEIGHT HEAT-SHOCK PROTEIN', 238496),
(295851, 'PTHR11527:SF365', NULL, NULL, NULL, NULL, '17.6 KDA CLASS I HEAT SHOCK PROTEIN 1-RELATED', 238496),
(295852, 'PTHR11527:SF366', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 238496),
(295853, 'PTHR11527:SF367', NULL, NULL, NULL, NULL, '17.3 KDA CLASS II HEAT SHOCK PROTEIN-LIKE', 238496),
(295854, 'PTHR11527:SF97', NULL, NULL, NULL, NULL, '15.4 KDA CLASS V HEAT SHOCK PROTEIN', 238496),
(295855, 'PTHR11527', NULL, NULL, NULL, NULL, 'HEAT-SHOCK PROTEIN 20 FAMILY MEMBER', 238496),
(295856, 'PTHR11527:SF360', NULL, NULL, NULL, NULL, '18.1 KDA CLASS I HEAT SHOCK PROTEIN-LIKE', 238496),
(295857, 'PTHR11527:SF361', NULL, NULL, NULL, NULL, '18.1 KDA CLASS I HEAT SHOCK PROTEIN', 238496),
(295858, 'PTHR11527:SF362', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 238496),
(295859, 'PTHR11527:SF286', NULL, NULL, NULL, NULL, '17.6 KDA CLASS I HEAT SHOCK PROTEIN 2-LIKE', 238496),
(295860, 'PTHR11527:SF363', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 238496),
(295861, 'PTHR13080:SF17', NULL, NULL, NULL, NULL, 'ATP SYNTHASE MEMBRANE SUBUNIT F', 238497),
(295862, 'PTHR13080:SF16', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT F, MITOCHONDRIAL', 238497),
(295863, 'PTHR13080', NULL, NULL, NULL, NULL, 'ATP SYNTHASE F CHAIN, MITOCHONDRIAL-RELATED', 238497),
(295864, 'PTHR13080:SF18', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT F, MITOCHONDRIAL', 238497),
(295865, 'PTHR13080:SF13', NULL, NULL, NULL, NULL, 'ATP SYNTHASE MEMBRANE SUBUNIT F', 238497),
(295866, 'PTHR13080:SF12', NULL, NULL, NULL, NULL, 'ATP SYNTHASE MEMBRANE SUBUNIT F', 238497),
(295867, 'PTHR13080:SF11', NULL, NULL, NULL, NULL, 'ATP SYNTHASE MEMBRANE SUBUNIT F', 238497),
(295868, 'PTHR13080:SF10', NULL, NULL, NULL, NULL, 'ATP SYNTHASE MEMBRANE SUBUNIT F', 238497),
(295869, 'PTHR31913:SF7', NULL, NULL, NULL, NULL, 'DEM PROTEIN', 238498),
(295870, 'PTHR31913', NULL, NULL, NULL, NULL, 'VACUOLAR IMPORT AND DEGRADATION PROTEIN 27', 238498),
(295871, 'PTHR31913:SF0', NULL, NULL, NULL, NULL, 'VACUOLAR IMPORT AND DEGRADATION PROTEIN 27', 238498),
(295872, 'PTHR31913:SF5', NULL, NULL, NULL, NULL, 'VID27 DOMAIN-CONTAINING PROTEIN', 238498),
(295873, 'PTHR31913:SF2', NULL, NULL, NULL, NULL, 'OS02G0789600 PROTEIN', 238498),
(295874, 'PTHR12103:SF19', NULL, NULL, NULL, NULL, '5''-NUCLEOTIDASE DOMAIN-CONTAINING 2', 238499),
(295875, 'PTHR12103:SF16', NULL, NULL, NULL, NULL, '5''-NUCLEOTIDASE-RELATED', 238499),
(295876, 'PTHR12103', NULL, NULL, NULL, NULL, '5''-NUCLEOTIDASE DOMAIN-CONTAINING', 238499),
(295877, 'PTHR12103:SF38', NULL, NULL, NULL, NULL, '5''-NUCLEOTIDASE DOMAIN-CONTAINING PROTEIN 1', 238499),
(295878, 'PTHR12103:SF15', NULL, NULL, NULL, NULL, 'CYTOSOLIC PURINE 5''-NUCLEOTIDASE', 238499),
(295879, 'PTHR12103:SF18', NULL, NULL, NULL, NULL, '5''-NUCLEOTIDASE DOMAIN-CONTAINING PROTEIN 4', 238499),
(295880, 'PTHR12103:SF17', NULL, NULL, NULL, NULL, 'CYTOSOLIC PURINE 5''-NUCLEOTIDASE', 238499),
(295881, 'PTHR12103:SF34', NULL, NULL, NULL, NULL, 'HAD-SUPERFAMILY HYDROLASE, SUBFAMILY IG, 5''-NUCLEOTIDASE-RELATED', 238499),
(295882, 'PTHR12103:SF12', NULL, NULL, NULL, NULL, 'FI20020P1', 238499),
(295883, 'PTHR12103:SF11', NULL, NULL, NULL, NULL, '5''-NUCLEOTIDASE DOMAIN-CONTAINING PROTEIN 3', 238499),
(295884, 'PTHR12103:SF22', NULL, NULL, NULL, NULL, 'HAD-SUPERFAMILY HYDROLASE, SUBFAMILY IG, 5''-NUCLEOTIDASE', 238499),
(295885, 'PTHR12103:SF33', NULL, NULL, NULL, NULL, 'CYTOSOLIC PURINE 5-NUCLEOTIDASE', 238499);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(295886, 'PTHR12103:SF14', NULL, NULL, NULL, NULL, '5''-NUCLEOTIDASE DOMAIN-CONTAINING PROTEIN 2', 238499),
(295887, 'PTHR12103:SF36', NULL, NULL, NULL, NULL, '5''-NUCLEOTIDASE, CYTOSOLIC IIB', 238499),
(295888, 'PTHR12103:SF35', NULL, NULL, NULL, NULL, 'BNAA07G31970D PROTEIN', 238499),
(295889, 'PTHR23542', NULL, NULL, NULL, NULL, '', 238500),
(295890, 'PTHR23542:SF1', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 238500),
(295891, 'PTHR14365:SF1', NULL, NULL, NULL, NULL, 'APOPTOSIS REGULATORY PROTEIN SIVA', 238501),
(295892, 'PTHR14365', NULL, NULL, NULL, NULL, 'APOPTOSIS REGULATORY PROTEIN SIVA', 238501),
(295893, 'PTHR35744', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 238502),
(295894, 'PTHR35744:SF2', NULL, NULL, NULL, NULL, 'OS06G0166200 PROTEIN', 238502),
(295895, 'PTHR35744:SF4', NULL, NULL, NULL, NULL, 'ZINC FINGER (C2H2 TYPE) FAMILY PROTEIN', 238502),
(295896, 'PTHR47937', NULL, NULL, NULL, NULL, 'PLASTID TRANSCRIPTIONALLY ACTIVE CHROMOSOME 2-LIKE PROTEIN', 238503),
(295897, 'PTHR47937:SF2', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE (PPR) REPEAT-CONTAINING PROTEIN, PF01535''-RELATED', 238503),
(295898, 'PTHR47937:SF1', NULL, NULL, NULL, NULL, 'SMR DOMAIN-CONTAINING PROTEIN', 238503),
(295899, 'PTHR47937:SF4', NULL, NULL, NULL, NULL, 'BNAA08G25870D PROTEIN', 238503),
(295900, 'PTHR47937:SF3', NULL, NULL, NULL, NULL, 'BNAC04G00520D PROTEIN', 238503),
(295901, 'PTHR47937:SF6', NULL, NULL, NULL, NULL, 'BNAA01G22910D PROTEIN', 238503),
(295902, 'PTHR47937:SF5', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 238503),
(295903, 'PTHR47937:SF7', NULL, NULL, NULL, NULL, 'BNAC09G22000D PROTEIN', 238503),
(295904, 'PTHR47645:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG08267', 238504),
(295905, 'PTHR47645', NULL, NULL, NULL, NULL, 'PROTEIN CBG08267', 238504),
(295906, 'PTHR31963:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER CONSTANS-LIKE PROTEIN (DUF3537)', 238505),
(295907, 'PTHR31963:SF10', NULL, NULL, NULL, NULL, 'F11F12.5 PROTEIN', 238505),
(295908, 'PTHR31963:SF21', NULL, NULL, NULL, NULL, '', 238505),
(295909, 'PTHR31963:SF11', NULL, NULL, NULL, NULL, 'EXTRACELLULAR LIGAND-GATED ION CHANNEL', 238505),
(295910, 'PTHR31963:SF4', NULL, NULL, NULL, NULL, 'RAS GUANINE NUCLEOTIDE EXCHANGE FACTOR K', 238505),
(295911, 'PTHR31963', NULL, NULL, NULL, NULL, 'RAS GUANINE NUCLEOTIDE EXCHANGE FACTOR K', 238505),
(295912, 'PTHR31963:SF20', NULL, NULL, NULL, NULL, 'BNAC03G41510D PROTEIN', 238505),
(295913, 'PTHR31963:SF14', NULL, NULL, NULL, NULL, 'EXTRACELLULAR LIGAND-GATED ION CHANNEL PROTEIN (DUF3537)', 238505),
(295914, 'PTHR31963:SF15', NULL, NULL, NULL, NULL, 'EXTRACELLULAR LIGAND-GATED ION CHANNEL', 238505),
(295915, 'PTHR31963:SF26', NULL, NULL, NULL, NULL, '', 238505),
(295916, 'PTHR31963:SF23', NULL, NULL, NULL, NULL, '', 238505),
(295917, 'PTHR31963:SF13', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF3537)-RELATED', 238505),
(295918, 'PTHR31963:SF24', NULL, NULL, NULL, NULL, 'BNAC01G32640D PROTEIN', 238505),
(295919, 'PTHR31963:SF18', NULL, NULL, NULL, NULL, '', 238505),
(295920, 'PTHR31963:SF19', NULL, NULL, NULL, NULL, 'BNAC06G26640D PROTEIN', 238505),
(295921, 'PTHR31963:SF16', NULL, NULL, NULL, NULL, 'OS02G0566400 PROTEIN', 238505),
(295922, 'PTHR31963:SF27', NULL, NULL, NULL, NULL, 'OS06G0635200 PROTEIN', 238505),
(295923, 'PTHR31963:SF17', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF3537)-RELATED', 238505),
(295924, 'PTHR31963:SF28', NULL, NULL, NULL, NULL, '', 238505),
(295925, 'PTHR14903:SF5', NULL, NULL, NULL, NULL, 'SCLEROSTIN DOMAIN-CONTAINING PROTEIN 1', 238506),
(295926, 'PTHR14903:SF4', NULL, NULL, NULL, NULL, 'SCLEROSTIN', 238506),
(295927, 'PTHR14903:SF7', NULL, NULL, NULL, NULL, 'NOVEL PROTEIN SIMILAR TO VERTEBRATE SCLEROSTIN DOMAIN CONTAINING 1 (SOSTDC1)', 238506),
(295928, 'PTHR14903:SF6', NULL, NULL, NULL, NULL, '', 238506),
(295929, 'PTHR14903', NULL, NULL, NULL, NULL, 'SCLEROSTIN-RELATED', 238506),
(295930, 'PTHR43690:SF29', NULL, NULL, NULL, NULL, 'INSULIN-DEGRADING ENZYME-LIKE 1, PEROXISOMAL', 238507),
(295931, 'PTHR43690:SF18', NULL, NULL, NULL, NULL, 'INSULIN-DEGRADING ENZYME-RELATED', 238507);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(295932, 'PTHR43690:SF28', NULL, NULL, NULL, NULL, 'BNAA02G30780D PROTEIN', 238507),
(295933, 'PTHR43690:SF7', NULL, NULL, NULL, NULL, 'OS01G0779100 PROTEIN', 238507),
(295934, 'PTHR43690:SF17', NULL, NULL, NULL, NULL, 'PROTEIN YHJJ', 238507),
(295935, 'PTHR43690:SF27', NULL, NULL, NULL, NULL, 'ENZYME, PUTATIVE-RELATED', 238507),
(295936, 'PTHR43690', NULL, NULL, NULL, NULL, 'NARDILYSIN', 238507),
(295937, 'PTHR43690:SF33', NULL, NULL, NULL, NULL, 'STROMAL PROCESSING PEPTIDASE, CHLOROPLASTIC', 238507),
(295938, 'PTHR43690:SF21', NULL, NULL, NULL, NULL, 'PROCESSING PROTEASE', 238507),
(295939, 'PTHR43690:SF35', NULL, NULL, NULL, NULL, 'NON-CATALYTIC MEMBER OF PEPTIDASE SUBFAMILY M16B-RELATED', 238507),
(295940, 'PTHR43690:SF34', NULL, NULL, NULL, NULL, 'ZINC PROTEASE PQQL-LIKE', 238507),
(295941, 'PTHR43690:SF23', NULL, NULL, NULL, NULL, 'INSULIN-DEGRADING ENZYME-LIKE 2', 238507),
(295942, 'PTHR43690:SF20', NULL, NULL, NULL, NULL, 'ZINC PROTEASE PQQL-LIKE', 238507),
(295943, 'PTHR31316:SF1', NULL, NULL, NULL, NULL, 'SECRETED BETA-GLUCOSIDASE C2G2.17C-RELATED', 238508),
(295944, 'PTHR31316:SF2', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE-LIKE PROTEIN NCA3, MITOCHONDRIAL-RELATED', 238508),
(295945, 'PTHR31316', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE-LIKE PROTEIN NCA3, MITOCHONDRIAL-RELATED', 238508),
(295946, 'PTHR31316:SF0', NULL, NULL, NULL, NULL, 'SECRETED BETA-GLUCOSIDASE SIM1-RELATED', 238508),
(295947, 'PTHR36304:SF4', NULL, NULL, NULL, NULL, 'DUF4388 DOMAIN-CONTAINING PROTEIN', 238509),
(295948, 'PTHR36304', NULL, NULL, NULL, NULL, 'DOMAIN GTPASE-ACTIVATING PROTEIN, PUTATIVE-RELATED-RELATED', 238509),
(295949, 'PTHR36304:SF2', NULL, NULL, NULL, NULL, 'DUF4388 DOMAIN-CONTAINING PROTEIN', 238509),
(295950, 'PTHR37263', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 238510),
(295951, 'PTHR37263:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 238510),
(295952, 'PTHR47843:SF6', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 238511),
(295953, 'PTHR47843:SF5', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 238511),
(295954, 'PTHR47843:SF3', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 238511),
(295955, 'PTHR47843:SF2', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 238511),
(295956, 'PTHR47843:SF1', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 238511),
(295957, 'PTHR47843', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN-RELATED', 238511),
(295958, 'PTHR47843:SF7', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 238511),
(295959, 'PTHR23095:SF4', NULL, NULL, NULL, NULL, 'PARANEOPLASTIC ANTIGEN-LIKE PROTEIN 5', 238512),
(295960, 'PTHR23095:SF43', NULL, NULL, NULL, NULL, 'PARANEOPLASTIC ANTIGEN-LIKE PROTEIN 8C', 238512),
(295961, 'PTHR23095:SF21', NULL, NULL, NULL, NULL, 'PARANEOPLASTIC ANTIGEN-LIKE PROTEIN 8A', 238512),
(295962, 'PTHR23095:SF20', NULL, NULL, NULL, NULL, 'PARANEOPLASTIC ANTIGEN MA6E', 238512),
(295963, 'PTHR23095:SF40', NULL, NULL, NULL, NULL, 'PARANEOPLASTIC ANTIGEN-LIKE PROTEIN 6A', 238512),
(295964, 'PTHR23095:SF14', NULL, NULL, NULL, NULL, 'MODULATOR OF APOPTOSIS 1', 238512),
(295965, 'PTHR23095:SF46', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 238512),
(295966, 'PTHR23095:SF45', NULL, NULL, NULL, NULL, 'PARANEOPLASTIC ANTIGEN-LIKE PROTEIN 8B', 238512),
(295967, 'PTHR23095:SF22', NULL, NULL, NULL, NULL, 'PARANEOPLASTIC ANTIGEN MA3', 238512),
(295968, 'PTHR23095:SF18', NULL, NULL, NULL, NULL, 'ZINC FINGER CCHC DOMAIN-CONTAINING PROTEIN 12', 238512),
(295969, 'PTHR23095:SF17', NULL, NULL, NULL, NULL, 'PARANEOPLASTIC ANTIGEN MA1', 238512),
(295970, 'PTHR23095:SF16', NULL, NULL, NULL, NULL, 'PARANEOPLASTIC ANTIGEN MA2', 238512),
(295971, 'PTHR23095:SF49', NULL, NULL, NULL, NULL, 'PARANEOPLASTIC ANTIGEN MA6F', 238512),
(295972, 'PTHR23095', NULL, NULL, NULL, NULL, 'PARANEOPLASTIC ANTIGEN', 238512),
(295973, 'PTHR23095:SF48', NULL, NULL, NULL, NULL, 'ZINC FINGER CCHC DOMAIN-CONTAINING PROTEIN 18', 238512),
(295974, 'PTHR35254:SF1', NULL, NULL, NULL, NULL, 'STIMULATED BY RETINOIC ACID GENE 8 PROTEIN HOMOLOG', 238513);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(295975, 'PTHR35254', NULL, NULL, NULL, NULL, 'STIMULATED BY RETINOIC ACID GENE 8 PROTEIN HOMOLOG', 238513),
(295976, 'PTHR15832:SF1', NULL, NULL, NULL, NULL, 'HETEROCHROMATIN PROTEIN 1-BINDING PROTEIN 3', 238514),
(295977, 'PTHR15832:SF2', NULL, NULL, NULL, NULL, 'SH2 DOMAIN-CONTAINING PROTEIN', 238514),
(295978, 'PTHR15832:SF3', NULL, NULL, NULL, NULL, 'SH2 DOMAIN-CONTAINING PROTEIN 5', 238514),
(295979, 'PTHR15832', NULL, NULL, NULL, NULL, 'SHC (SRC HOMOLOGY DOMAIN C-TERMINAL) ADAPTOR HOMOLOG', 238514),
(295980, 'PTHR40068:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR NIAR-RELATED', 238515),
(295981, 'PTHR40068', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR NIAR-RELATED', 238515),
(295982, 'PTHR14726', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 238516),
(295983, 'PTHR14726:SF1', NULL, NULL, NULL, NULL, 'JHY PROTEIN HOMOLOG', 238516),
(295984, 'PTHR35190', NULL, NULL, NULL, NULL, 'PROTEIN DCD1B', 238517),
(295985, 'PTHR35190:SF3', NULL, NULL, NULL, NULL, 'PROTEIN DCD1A', 238517),
(295986, 'PTHR35190:SF1', NULL, NULL, NULL, NULL, '', 238517),
(295987, 'PTHR35190:SF2', NULL, NULL, NULL, NULL, 'PROTEIN DCD1B', 238517),
(295988, 'PTHR12534:SF0', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S2, MITOCHONDRIAL', 238518),
(295989, 'PTHR12534:SF1', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S2, MITOCHONDRIAL', 238518),
(295990, 'PTHR12534', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S2  PROKARYOTIC AND ORGANELLAR', 238518),
(295991, 'PTHR14523', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN C17ORF53 HOMOLOG', 238519),
(295992, 'PTHR14523:SF1', NULL, NULL, NULL, NULL, 'HOMOLOGOUS RECOMBINATION OB-FOLD PROTEIN', 238519),
(295993, 'PTHR31861:SF23', NULL, NULL, NULL, NULL, 'BNAA02G05480D PROTEIN', 238520),
(295994, 'PTHR31861:SF22', NULL, NULL, NULL, NULL, 'BNAC03G70940D PROTEIN', 238520),
(295995, 'PTHR31861:SF21', NULL, NULL, NULL, NULL, 'SIMILARITY TO UNKNOWN PROTEIN', 238520),
(295996, 'PTHR31861:SF17', NULL, NULL, NULL, NULL, 'DUF577 DOMAIN-CONTAINING PROTEIN', 238520),
(295997, 'PTHR31861:SF16', NULL, NULL, NULL, NULL, 'F12P19.17 PROTEIN-RELATED', 238520),
(295998, 'PTHR31861:SF15', NULL, NULL, NULL, NULL, 'DUF577 DOMAIN-CONTAINING PROTEIN', 238520),
(295999, 'PTHR31861', NULL, NULL, NULL, NULL, 'OS10G0507500 PROTEIN', 238520),
(296000, 'PTHR14776:SF1', NULL, NULL, NULL, NULL, 'CADHERIN-LIKE AND PC-ESTERASE DOMAIN-CONTAINING PROTEIN 1', 238521),
(296001, 'PTHR14776', NULL, NULL, NULL, NULL, 'CADHERIN-LIKE AND PC-ESTERASE DOMAIN-CONTAINING PROTEIN 1', 238521),
(296002, 'PTHR47265:SF3', NULL, NULL, NULL, NULL, 'FE-S_BIOSYN DOMAIN-CONTAINING PROTEIN', 238522),
(296003, 'PTHR47265', NULL, NULL, NULL, NULL, 'IRON-SULFUR ASSEMBLY PROTEIN ISCA, CHLOROPLASTIC', 238522),
(296004, 'PTHR47265:SF2', NULL, NULL, NULL, NULL, 'OS06G0146400 PROTEIN', 238522),
(296005, 'PTHR47265:SF1', NULL, NULL, NULL, NULL, 'IRON-SULFUR ASSEMBLY PROTEIN ISCA, CHLOROPLASTIC', 238522),
(296006, 'PTHR35832:SF16', NULL, NULL, NULL, NULL, '', 238523),
(296007, 'PTHR35832:SF14', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 238523),
(296008, 'PTHR35832:SF7', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 238523),
(296009, 'PTHR35832:SF6', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 238523),
(296010, 'PTHR35832:SF19', NULL, NULL, NULL, NULL, '', 238523),
(296011, 'PTHR35832:SF18', NULL, NULL, NULL, NULL, '', 238523),
(296012, 'PTHR35832:SF9', NULL, NULL, NULL, NULL, '', 238523),
(296013, 'PTHR35832:SF17', NULL, NULL, NULL, NULL, '', 238523),
(296014, 'PTHR35832:SF12', NULL, NULL, NULL, NULL, '', 238523),
(296015, 'PTHR35832', NULL, NULL, NULL, NULL, 'OS12G0248400 PROTEIN-RELATED', 238523),
(296016, 'PTHR35832:SF10', NULL, NULL, NULL, NULL, 'OS06G0314501 PROTEIN', 238523),
(296017, 'PTHR10476:SF69', NULL, NULL, NULL, NULL, 'BNAA09G45880D PROTEIN', 238524),
(296018, 'PTHR10476:SF48', NULL, NULL, NULL, NULL, 'BNAA08G30490D PROTEIN', 238524),
(296019, 'PTHR10476:SF45', NULL, NULL, NULL, NULL, 'BNAANNG10150D PROTEIN', 238524),
(296020, 'PTHR10476:SF67', NULL, NULL, NULL, NULL, 'CHARGED MULTIVESICULAR BODY PROTEIN 2A HOMOLOG 1', 238524);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(296021, 'PTHR10476:SF2', NULL, NULL, NULL, NULL, 'CHARGED MULTIVESICULAR BODY PROTEIN 1B', 238524),
(296022, 'PTHR10476:SF1', NULL, NULL, NULL, NULL, 'CHARGED MULTIVESICULAR BODY PROTEIN 3', 238524),
(296023, 'PTHR10476:SF68', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 24 HOMOLOG 1', 238524),
(296024, 'PTHR10476:SF4', NULL, NULL, NULL, NULL, 'CHARGED MULTIVESICULAR BODY PROTEIN 2A', 238524),
(296025, 'PTHR10476:SF61', NULL, NULL, NULL, NULL, 'BNAC05G29160D PROTEIN', 238524),
(296026, 'PTHR10476:SF40', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 2 HOMOLOG 3', 238524),
(296027, 'PTHR10476:SF62', NULL, NULL, NULL, NULL, 'CHARGED MULTIVESICULAR BODY PROTEIN 2A-RELATED', 238524),
(296028, 'PTHR10476:SF65', NULL, NULL, NULL, NULL, 'CHARGED MULTIVESICULAR BODY PROTEIN', 238524),
(296029, 'PTHR10476:SF44', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 2 HOMOLOG 1-LIKE', 238524),
(296030, 'PTHR10476:SF66', NULL, NULL, NULL, NULL, 'SNF7 FAMILY-RELATED', 238524),
(296031, 'PTHR10476:SF63', NULL, NULL, NULL, NULL, 'ESCRT-RELATED PROTEIN CHMP1A-RELATED', 238524),
(296032, 'PTHR10476:SF64', NULL, NULL, NULL, NULL, 'ESCRT-RELATED PROTEIN CHMP1B-LIKE', 238524),
(296033, 'PTHR10476:SF36', NULL, NULL, NULL, NULL, 'ESCRT-RELATED PROTEIN CHMP1B-LIKE', 238524),
(296034, 'PTHR10476:SF37', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 24 HOMOLOG 1-LIKE ISOFORM X1', 238524),
(296035, 'PTHR10476:SF56', NULL, NULL, NULL, NULL, 'CHARGED MULTIVESICULAR BODY PROTEIN 2B', 238524),
(296036, 'PTHR10476:SF12', NULL, NULL, NULL, NULL, 'OS07G0236800 PROTEIN', 238524),
(296037, 'PTHR10476:SF18', NULL, NULL, NULL, NULL, 'CHARGED MULTIVESICULAR BODY PROTEIN 1B', 238524),
(296038, 'PTHR10476:SF19', NULL, NULL, NULL, NULL, 'CHARGED MULTIVESICULAR BODY PROTEIN 1B-2', 238524),
(296039, 'PTHR10476:SF17', NULL, NULL, NULL, NULL, 'CHARGED MULTIVESICULAR BODY PROTEIN 1A', 238524),
(296040, 'PTHR10476:SF39', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 24 HOMOLOG 1-LIKE ISOFORM X1', 238524),
(296041, 'PTHR10476:SF70', NULL, NULL, NULL, NULL, 'BNAC06G23830D PROTEIN', 238524),
(296042, 'PTHR10476', NULL, NULL, NULL, NULL, 'CHARGED MULTIVESICULAR BODY PROTEIN', 238524),
(296043, 'PTHR43224:SF1', NULL, NULL, NULL, NULL, '', 238525),
(296044, 'PTHR43224:SF3', NULL, NULL, NULL, NULL, '', 238525),
(296045, 'PTHR43224', NULL, NULL, NULL, NULL, 'AMIDINOTRANSFERASE', 238525),
(296046, 'PTHR46947', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 73', 238526),
(296047, 'PTHR46947:SF1', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 73', 238526),
(296048, 'PTHR36489:SF1', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 238527),
(296049, 'PTHR36489', NULL, NULL, NULL, NULL, 'PROTEIN-COUPLED RECEPTOR GPR1, PUTATIVE-RELATED', 238527),
(296050, 'PTHR37443:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG23797', 238528),
(296051, 'PTHR37443:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG09852', 238528),
(296052, 'PTHR37443:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG15264', 238528),
(296053, 'PTHR37443', NULL, NULL, NULL, NULL, 'PROTEIN CBG09852-RELATED', 238528),
(296054, 'PTHR14596:SF75', NULL, NULL, NULL, NULL, 'DEFECTIVE CHORION-1 PROTEIN, FC177 ISOFORM', 238529),
(296055, 'PTHR14596:SF72', NULL, NULL, NULL, NULL, 'HYDROGEN PEROXIDE STRESS REGULATOR 1', 238529),
(296056, 'PTHR14596', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 238529),
(296057, 'PTHR38433:SF1', NULL, NULL, NULL, NULL, 'LMO2585 PROTEIN', 238530),
(296058, 'PTHR38433', NULL, NULL, NULL, NULL, '', 238530),
(296059, 'PTHR31159', NULL, NULL, NULL, NULL, 'COMM DOMAIN-CONTAINING PROTEIN 3', 238531),
(296060, 'PTHR31159:SF1', NULL, NULL, NULL, NULL, 'COMM DOMAIN-CONTAINING PROTEIN 3', 238531),
(296061, 'PTHR37769', NULL, NULL, NULL, NULL, 'OS08G0243900 PROTEIN', 238532),
(296062, 'PTHR37769:SF1', NULL, NULL, NULL, NULL, 'OS08G0243900 PROTEIN', 238532),
(296063, 'PTHR37769:SF2', NULL, NULL, NULL, NULL, 'MHD DOMAIN-CONTAINING PROTEIN', 238532);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(296064, 'PTHR47746:SF67', NULL, NULL, NULL, NULL, 'BNAC08G40540D PROTEIN', 238533),
(296065, 'PTHR47746:SF68', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', 238533),
(296066, 'PTHR47746:SF65', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', 238533),
(296067, 'PTHR47746:SF87', NULL, NULL, NULL, NULL, '', 238533),
(296068, 'PTHR47746:SF21', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', 238533),
(296069, 'PTHR47746:SF66', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', 238533),
(296070, 'PTHR47746:SF63', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE RELATED PROTEIN', 238533),
(296071, 'PTHR47746:SF85', NULL, NULL, NULL, NULL, 'OS03G0794050 PROTEIN', 238533),
(296072, 'PTHR47746:SF86', NULL, NULL, NULL, NULL, '', 238533),
(296073, 'PTHR47746:SF64', NULL, NULL, NULL, NULL, 'RNA-DIRECTED DNA POLYMERASE (REVERSE TRANSCRIPTASE)-RELATED FAMILY PROTEIN-RELATED', 238533),
(296074, 'PTHR47746:SF42', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', 238533),
(296075, 'PTHR47746:SF61', NULL, NULL, NULL, NULL, '', 238533),
(296076, 'PTHR47746:SF83', NULL, NULL, NULL, NULL, 'NON-LTR RETROLELEMENT REVERSE TRANSCRIPTASE-RELATED', 238533),
(296077, 'PTHR47746:SF62', NULL, NULL, NULL, NULL, 'BNACNNG70710D PROTEIN', 238533),
(296078, 'PTHR47746:SF84', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', 238533),
(296079, 'PTHR47746:SF40', NULL, NULL, NULL, NULL, 'OS04G0563550 PROTEIN', 238533),
(296080, 'PTHR47746:SF47', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', 238533),
(296081, 'PTHR47746:SF69', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE ZINC-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 238533),
(296082, 'PTHR47746:SF48', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', 238533),
(296083, 'PTHR47746:SF70', NULL, NULL, NULL, NULL, '', 238533),
(296084, 'PTHR47746:SF71', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE ZINC-BINDING PROTEIN', 238533),
(296085, 'PTHR47746:SF78', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', 238533),
(296086, 'PTHR47746:SF79', NULL, NULL, NULL, NULL, 'ORF147A PROTEIN', 238533),
(296087, 'PTHR47746:SF57', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', 238533),
(296088, 'PTHR47746:SF76', NULL, NULL, NULL, NULL, '', 238533),
(296089, 'PTHR47746', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', 238533),
(296090, 'PTHR47746:SF77', NULL, NULL, NULL, NULL, '', 238533),
(296091, 'PTHR47746:SF74', NULL, NULL, NULL, NULL, 'RNA-DIRECTED DNA POLYMERASE (REVERSE TRANSCRIPTASE)-RELATED FAMILY PROTEIN-RELATED', 238533),
(296092, 'PTHR47746:SF75', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', 238533),
(296093, 'PTHR47746:SF72', NULL, NULL, NULL, NULL, 'RNA-DIRECTED DNA POLYMERASE (REVERSE TRANSCRIPTASE)-RELATED FAMILY PROTEIN', 238533),
(296094, 'PTHR47746:SF73', NULL, NULL, NULL, NULL, 'OS05G0430600 PROTEIN', 238533),
(296095, 'PTHR47746:SF19', NULL, NULL, NULL, NULL, '', 238533),
(296096, 'PTHR47746:SF81', NULL, NULL, NULL, NULL, 'OS02G0464450 PROTEIN', 238533),
(296097, 'PTHR47746:SF82', NULL, NULL, NULL, NULL, '', 238533),
(296098, 'PTHR47746:SF80', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', 238533),
(296099, 'PTHR37536:SF3', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_3G02970)-RELATED', 238534),
(296100, 'PTHR37536:SF1', NULL, NULL, NULL, NULL, 'ASPERGILLOPEPSIN, PUTAITVE (AFU_ORTHOLOGUE AFUA_7G01200)', 238534),
(296101, 'PTHR37536', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_3G02970)-RELATED', 238534),
(296102, 'PTHR34224:SF8', NULL, NULL, NULL, NULL, 'INTERACTOR OF CONSTITUTIVE ACTIVE ROPS 1', 238535),
(296103, 'PTHR34224:SF9', NULL, NULL, NULL, NULL, 'INTERACTOR OF CONSTITUTIVE ACTIVE ROPS 2, CHLOROPLASTIC-LIKE', 238535),
(296104, 'PTHR34224:SF10', NULL, NULL, NULL, NULL, 'INTERACTOR OF CONSTITUTIVE ACTIVE ROPS 3', 238535),
(296105, 'PTHR34224:SF14', NULL, NULL, NULL, NULL, 'TRNA-INTRON LYASE', 238535),
(296106, 'PTHR34224:SF13', NULL, NULL, NULL, NULL, 'INTERACTOR OF CONSTITUTIVE ACTIVE ROPS 5', 238535);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(296107, 'PTHR34224:SF4', NULL, NULL, NULL, NULL, 'INTERACTOR OF CONSTITUTIVE ACTIVE ROPS 2, CHLOROPLASTIC', 238535),
(296108, 'PTHR34224:SF12', NULL, NULL, NULL, NULL, 'INTERACTOR OF CONSTITUTIVE ACTIVE ROPS 1-LIKE', 238535),
(296109, 'PTHR34224:SF11', NULL, NULL, NULL, NULL, 'INTERACTOR OF CONSTITUTIVE ACTIVE ROPS 2, CHLOROPLASTIC-LIKE ISOFORM X1', 238535),
(296110, 'PTHR34224:SF2', NULL, NULL, NULL, NULL, 'INTERACTOR OF CONSTITUTIVE ACTIVE ROPS 4', 238535),
(296111, 'PTHR34224:SF18', NULL, NULL, NULL, NULL, 'INTERACTOR OF CONSTITUTIVE ACTIVE ROPS 3', 238535),
(296112, 'PTHR34224:SF17', NULL, NULL, NULL, NULL, 'INTERACTOR OF CONSTITUTIVE ACTIVE ROPS-RELATED', 238535),
(296113, 'PTHR34224:SF16', NULL, NULL, NULL, NULL, 'BNAA06G38430D PROTEIN', 238535),
(296114, 'PTHR34224:SF1', NULL, NULL, NULL, NULL, 'INTERACTOR OF CONSTITUTIVE ACTIVE ROPS 1', 238535),
(296115, 'PTHR34224', NULL, NULL, NULL, NULL, 'INTERACTOR OF CONSTITUTIVE ACTIVE ROPS 2, CHLOROPLASTIC-RELATED', 238535),
(296116, 'PTHR34224:SF15', NULL, NULL, NULL, NULL, 'BNAA03G16970D PROTEIN', 238535),
(296117, 'PTHR37429:SF1', NULL, NULL, NULL, NULL, 'DUF19 DOMAIN-CONTAINING PROTEIN', 238536),
(296118, 'PTHR37429:SF2', NULL, NULL, NULL, NULL, 'DUF19 DOMAIN-CONTAINING PROTEIN', 238536),
(296119, 'PTHR37429', NULL, NULL, NULL, NULL, 'PROTEIN CBG19148-RELATED', 238536),
(296120, 'PTHR37429:SF3', NULL, NULL, NULL, NULL, 'DUF19 DOMAIN-CONTAINING PROTEIN', 238536),
(296121, 'PTHR37429:SF4', NULL, NULL, NULL, NULL, 'DUF19 DOMAIN-CONTAINING PROTEIN', 238536),
(296122, 'PTHR38384', NULL, NULL, NULL, NULL, 'MEMBRANE LIPOPROTEIN-RELATED', 238537),
(296123, 'PTHR38384:SF3', NULL, NULL, NULL, NULL, 'BNAC07G34170D PROTEIN', 238537),
(296124, 'PTHR38384:SF2', NULL, NULL, NULL, NULL, 'MEMBRANE LIPOPROTEIN-RELATED', 238537),
(296125, 'PTHR34802', NULL, NULL, NULL, NULL, 'CHORISMATE SYNTHASE', 238538),
(296126, 'PTHR34802:SF3', NULL, NULL, NULL, NULL, '', 238538),
(296127, 'PTHR34802:SF2', NULL, NULL, NULL, NULL, '', 238538),
(296128, 'PTHR34802:SF4', NULL, NULL, NULL, NULL, '', 238538),
(296129, 'PTHR34802:SF1', NULL, NULL, NULL, NULL, 'CHORISMATE SYNTHASE', 238538),
(296130, 'PTHR35081:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 105', 238539),
(296131, 'PTHR35081', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 105', 238539),
(296132, 'PTHR47393', NULL, NULL, NULL, NULL, 'CYSTATIN-12-RELATED', 238540),
(296133, 'PTHR47393:SF1', NULL, NULL, NULL, NULL, 'CYSTATIN-12', 238540),
(296134, 'PTHR47393:SF3', NULL, NULL, NULL, NULL, 'CYSTATIN-15-RELATED', 238540),
(296135, 'PTHR47393:SF4', NULL, NULL, NULL, NULL, 'CYSTATIN-14', 238540),
(296136, 'PTHR45979:SF5', NULL, NULL, NULL, NULL, 'NTP_TRANSF_2 DOMAIN-CONTAINING PROTEIN', 238541),
(296137, 'PTHR45979:SF6', NULL, NULL, NULL, NULL, 'NTP_TRANSF_2 DOMAIN-CONTAINING PROTEIN', 238541),
(296138, 'PTHR45979:SF3', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 238541),
(296139, 'PTHR45979', NULL, NULL, NULL, NULL, 'PAP/OAS1 SUBSTRATE-BINDING DOMAIN SUPERFAMILY', 238541),
(296140, 'PTHR45979:SF2', NULL, NULL, NULL, NULL, 'PAP/OAS1 SUBSTRATE-BINDING DOMAIN SUPERFAMILY', 238541),
(296141, 'PTHR45979:SF30', NULL, NULL, NULL, NULL, 'NUCLEOTIDYLTRANSFERASE', 238541),
(296142, 'PTHR45979:SF9', NULL, NULL, NULL, NULL, 'PAP-ASSOCIATED DOMAIN-CONTAINING PROTEIN', 238541),
(296143, 'PTHR45979:SF31', NULL, NULL, NULL, NULL, 'NUCLEOTIDYLTRANSFERASE', 238541),
(296144, 'PTHR45979:SF20', NULL, NULL, NULL, NULL, 'NUCLEOTIDYLTRANSFERASE FAMILY PROTEIN', 238541),
(296145, 'PTHR45979:SF22', NULL, NULL, NULL, NULL, 'BNAC07G32340D PROTEIN', 238541),
(296146, 'PTHR45979:SF11', NULL, NULL, NULL, NULL, '', 238541),
(296147, 'PTHR45979:SF14', NULL, NULL, NULL, NULL, 'BNAC04G24980D PROTEIN', 238541),
(296148, 'PTHR45979:SF15', NULL, NULL, NULL, NULL, 'NTP_TRANSF_2 DOMAIN-CONTAINING PROTEIN', 238541),
(296149, 'PTHR45979:SF26', NULL, NULL, NULL, NULL, 'NUCLEOTIDYLTRANSFERASE DOMAIN CONTAINING PROTEIN, EXPRESSED', 238541),
(296150, 'PTHR45979:SF27', NULL, NULL, NULL, NULL, 'NTP_TRANSF_2 DOMAIN-CONTAINING PROTEIN', 238541);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(296151, 'PTHR45979:SF28', NULL, NULL, NULL, NULL, 'POLY(A) RNA POLYMERASE CID14-LIKE', 238541),
(296152, 'PTHR45979:SF17', NULL, NULL, NULL, NULL, 'POLYMERASE, NUCLEOTIDYL TRANSFERASE DOMAIN-CONTAINING PROTEIN-RELATED', 238541),
(296153, 'PTHR45979:SF29', NULL, NULL, NULL, NULL, 'PAP/OAS1 SUBSTRATE-BINDING DOMAIN SUPERFAMILY', 238541),
(296154, 'PTHR40696:SF1', NULL, NULL, NULL, NULL, 'DUF371 FAMILY PROTEIN', 238542),
(296155, 'PTHR40696', NULL, NULL, NULL, NULL, 'DUF371 FAMILY PROTEIN', 238542),
(296156, 'PTHR43522', NULL, NULL, NULL, NULL, 'TRANSKETOLASE', 238543),
(296157, 'PTHR43522:SF5', NULL, NULL, NULL, NULL, 'TRANSKETOLASE', 238543),
(296158, 'PTHR43522:SF6', NULL, NULL, NULL, NULL, 'TRANSKET_PYR DOMAIN-CONTAINING PROTEIN-RELATED', 238543),
(296159, 'PTHR43522:SF13', NULL, NULL, NULL, NULL, 'TRANSKETOLASE 2', 238543),
(296160, 'PTHR43522:SF10', NULL, NULL, NULL, NULL, 'TRANSKETOLASE', 238543),
(296161, 'PTHR43522:SF16', NULL, NULL, NULL, NULL, 'TRANSKETOLASE', 238543),
(296162, 'PTHR43522:SF17', NULL, NULL, NULL, NULL, 'TRANSKETOLASE', 238543),
(296163, 'PTHR43522:SF14', NULL, NULL, NULL, NULL, 'TRANSKETOLASE-1, CHLOROPLASTIC', 238543),
(296164, 'PTHR43522:SF15', NULL, NULL, NULL, NULL, 'TRANSKET_PYR DOMAIN-CONTAINING PROTEIN', 238543),
(296165, 'PTHR43522:SF2', NULL, NULL, NULL, NULL, 'TRANSKETOLASE 1-RELATED', 238543),
(296166, 'PTHR43522:SF3', NULL, NULL, NULL, NULL, 'TRANSKETOLASE', 238543),
(296167, 'PTHR12839:SF9', NULL, NULL, NULL, NULL, 'REGULATOR OF NONSENSE TRANSCRIPTS UPF2', 238544),
(296168, 'PTHR12839', NULL, NULL, NULL, NULL, 'NONSENSE-MEDIATED MRNA DECAY PROTEIN 2  UP-FRAMESHIFT SUPPRESSOR 2', 238544),
(296169, 'PTHR12839:SF7', NULL, NULL, NULL, NULL, 'REGULATOR OF NONSENSE TRANSCRIPTS 2', 238544),
(296170, 'PTHR39601:SF1', NULL, NULL, NULL, NULL, '', 238545),
(296171, 'PTHR39601:SF2', NULL, NULL, NULL, NULL, '', 238545),
(296172, 'PTHR39601', NULL, NULL, NULL, NULL, '', 238545),
(296173, 'PTHR12620:SF3', NULL, NULL, NULL, NULL, 'SPLICING FACTOR U2AF 26 KDA SUBUNIT', 238546),
(296174, 'PTHR12620:SF45', NULL, NULL, NULL, NULL, 'SPLICING FACTOR U2AF SMALL SUBUNIT B-LIKE', 238546),
(296175, 'PTHR12620:SF11', NULL, NULL, NULL, NULL, 'SPLICING FACTOR U2AF 35 KDA SUBUNIT-RELATED', 238546),
(296176, 'PTHR12620:SF2', NULL, NULL, NULL, NULL, 'U2 SMALL NUCLEAR RIBONUCLEOPROTEIN AUXILIARY FACTOR 35 KDA SUBUNIT-RELATED PROTEIN 1', 238546),
(296177, 'PTHR12620:SF33', NULL, NULL, NULL, NULL, 'U2 SMALL NUCLEAR RIBONUCLEOPROTEIN AUXILIARY FACTOR 35 KDA SUBUNIT-RELATED PROTEIN 1-RELATED', 238546),
(296178, 'PTHR12620:SF36', NULL, NULL, NULL, NULL, 'SPLICING FACTOR U2AF SMALL SUBUNIT B', 238546),
(296179, 'PTHR12620:SF47', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C3H FAMILY-RELATED', 238546),
(296180, 'PTHR12620:SF46', NULL, NULL, NULL, NULL, '', 238546),
(296181, 'PTHR12620:SF35', NULL, NULL, NULL, NULL, 'SPLICING FACTOR U2AF SMALL SUBUNIT A', 238546),
(296182, 'PTHR12620:SF49', NULL, NULL, NULL, NULL, 'SNRNP AUXILIARY FACTOR, SMALL SUBUNIT, PUTATIVE-RELATED', 238546),
(296183, 'PTHR12620:SF38', NULL, NULL, NULL, NULL, 'U2 SMALL NUCLEAR RIBONUCLEOPROTEIN AUXILIARY FACTOR 35 KDA SUBUNIT-RELATED PROTEIN 2', 238546),
(296184, 'PTHR12620:SF7', NULL, NULL, NULL, NULL, 'U2 SMALL NUCLEAR RIBONUCLEOPROTEIN AUXILIARY FACTOR 35 KDA SUBUNIT-RELATED PROTEIN 2', 238546),
(296185, 'PTHR12620:SF4', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH-TYPE, RNA BINDING MOTIF AND SERINE/ARGININE RICH 2', 238546),
(296186, 'PTHR12620:SF41', NULL, NULL, NULL, NULL, 'BNAC05G21650D PROTEIN', 238546),
(296187, 'PTHR12620:SF52', NULL, NULL, NULL, NULL, 'BNAA06G23240D PROTEIN', 238546),
(296188, 'PTHR12620:SF51', NULL, NULL, NULL, NULL, 'SPLICING FACTOR U2AF SMALL SUBUNIT B-LIKE', 238546),
(296189, 'PTHR12620:SF40', NULL, NULL, NULL, NULL, 'SPLICING FACTOR U2AF SMALL SUBUNIT B', 238546),
(296190, 'PTHR12620:SF43', NULL, NULL, NULL, NULL, 'RNA RECOGNITION MOTIF DOMAIN, EUKARYOTE-RELATED', 238546),
(296191, 'PTHR12620', NULL, NULL, NULL, NULL, 'U2 SNRNP AUXILIARY FACTOR, SMALL SUBUNIT', 238546),
(296192, 'PTHR12620:SF8', NULL, NULL, NULL, NULL, 'U2 SMALL NUCLEAR RNA AUXILIARY FACTOR 1', 238546);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(296193, 'PTHR46755:SF5', NULL, NULL, NULL, NULL, 'METHIONINE-R-SULFOXIDE REDUCTASE B1', 238547),
(296194, 'PTHR46755', NULL, NULL, NULL, NULL, 'METHIONINE-R-SULFOXIDE REDUCTASE B1', 238547),
(296195, 'PTHR44051:SF10', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE GSTA', 238548),
(296196, 'PTHR44051:SF21', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE FAMILY PROTEIN', 238548),
(296197, 'PTHR44051:SF2', NULL, NULL, NULL, NULL, 'HYPOTHETICAL GLUTATHIONE S-TRANSFERASE LIKE PROTEIN', 238548),
(296198, 'PTHR44051:SF20', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE 1 (EUROFUNG)', 238548),
(296199, 'PTHR44051:SF6', NULL, NULL, NULL, NULL, 'GST C-TERMINAL DOMAIN-CONTAINING PROTEIN', 238548),
(296200, 'PTHR44051:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR URE2', 238548),
(296201, 'PTHR44051:SF4', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE-RELATED', 238548),
(296202, 'PTHR44051:SF9', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE 1', 238548),
(296203, 'PTHR44051:SF7', NULL, NULL, NULL, NULL, '', 238548),
(296204, 'PTHR44051:SF8', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE-RELATED', 238548),
(296205, 'PTHR44051', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE-RELATED', 238548),
(296206, 'PTHR44051:SF18', NULL, NULL, NULL, NULL, 'S-TRANSFERASE, PUTATIVE-RELATED', 238548),
(296207, 'PTHR44051:SF19', NULL, NULL, NULL, NULL, 'DISULFIDE-BOND OXIDOREDUCTASE YFCG', 238548),
(296208, 'PTHR44051:SF16', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE DOMAIN-CONTAINING PROTEIN DDB_G0274223-RELATED', 238548),
(296209, 'PTHR44051:SF14', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE FAMILY PROTEIN', 238548),
(296210, 'PTHR31524', NULL, NULL, NULL, NULL, '', 238549),
(296211, 'PTHR31524:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG10426', 238549),
(296212, 'PTHR13016', NULL, NULL, NULL, NULL, 'AMMECR1 HOMOLOG', 238550),
(296213, 'PTHR13016:SF4', NULL, NULL, NULL, NULL, 'AMMECR1 DOMAIN-CONTAINING PROTEIN-RELATED', 238550),
(296214, 'PTHR13016:SF3', NULL, NULL, NULL, NULL, 'AMMECR1 DOMAIN-CONTAINING PROTEIN', 238550),
(296215, 'PTHR13016:SF2', NULL, NULL, NULL, NULL, 'AMME SYNDROME CANDIDATE GENE 1 PROTEIN', 238550),
(296216, 'PTHR13016:SF1', NULL, NULL, NULL, NULL, 'AMMECR1-LIKE PROTEIN', 238550),
(296217, 'PTHR13016:SF0', NULL, NULL, NULL, NULL, 'AMMECR NUCLEAR PROTEIN 1', 238550),
(296218, 'PTHR47169:SF1', NULL, NULL, NULL, NULL, 'OS01G0541250 PROTEIN', 238551),
(296219, 'PTHR47169', NULL, NULL, NULL, NULL, 'OS01G0541250 PROTEIN', 238551),
(296220, 'PTHR46279:SF15', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL22', 238552),
(296221, 'PTHR46279:SF14', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL20-RELATED', 238552),
(296222, 'PTHR46279:SF25', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE, GALACTURONAN-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 238552),
(296223, 'PTHR46279:SF2', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL21A-RELATED', 238552),
(296224, 'PTHR46279:SF17', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 238552),
(296225, 'PTHR46279:SF27', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL21A-RELATED', 238552),
(296226, 'PTHR46279:SF7', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 238552),
(296227, 'PTHR46279:SF21', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 238552),
(296228, 'PTHR46279:SF32', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL21A-RELATED', 238552),
(296229, 'PTHR46279:SF10', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 238552),
(296230, 'PTHR46279:SF6', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL20-LIKE', 238552),
(296231, 'PTHR46279:SF12', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 238552),
(296232, 'PTHR46279:SF23', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL21A-RELATED', 238552),
(296233, 'PTHR46279:SF31', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 238552),
(296234, 'PTHR46279:SF20', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 238552),
(296235, 'PTHR46279:SF30', NULL, NULL, NULL, NULL, 'GUB_WAK_BIND DOMAIN-CONTAINING PROTEIN', 238552);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(296236, 'PTHR46279', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 238552),
(296237, 'PTHR46279:SF9', NULL, NULL, NULL, NULL, 'OS01G0116300 PROTEIN', 238552),
(296238, 'PTHR12783:SF5', NULL, NULL, NULL, NULL, 'RALA-BINDING PROTEIN 1', 238553),
(296239, 'PTHR12783', NULL, NULL, NULL, NULL, 'RALA BINDING PROTEIN 1  RALBP1', 238553),
(296240, 'PTHR31082:SF11', NULL, NULL, NULL, NULL, 'DUF1212 DOMAIN MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_5G07620)', 238554),
(296241, 'PTHR31082:SF10', NULL, NULL, NULL, NULL, 'DUF1212 DOMAIN MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_3G01440)', 238554),
(296242, 'PTHR31082:SF4', NULL, NULL, NULL, NULL, 'DOMAIN MEMBRANE PROTEIN PRM10, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G13940)-RELATED', 238554),
(296243, 'PTHR31082', NULL, NULL, NULL, NULL, 'PHEROMONE-REGULATED MEMBRANE PROTEIN 10', 238554),
(296244, 'PTHR31082:SF13', NULL, NULL, NULL, NULL, 'DUF1212 FAMILY PROTEIN', 238554),
(296245, 'PTHR31082:SF12', NULL, NULL, NULL, NULL, 'THRE DOMAIN-CONTAINING PROTEIN', 238554),
(296246, 'PTHR45527:SF12', NULL, NULL, NULL, NULL, 'NONRIBOSOMAL PEPTIDE SYNTHETASE IVOA', 238555),
(296247, 'PTHR45527:SF11', NULL, NULL, NULL, NULL, 'NONRIBOSOMAL PEPTIDE SYNTHETASE 5', 238555),
(296248, 'PTHR45527:SF10', NULL, NULL, NULL, NULL, 'PHENYLOXAZOLINE SYNTHASE MBTB', 238555),
(296249, 'PTHR45527', NULL, NULL, NULL, NULL, 'NONRIBOSOMAL PEPTIDE SYNTHETASE', 238555),
(296250, 'PTHR45527:SF14', NULL, NULL, NULL, NULL, 'PLIPASTATIN SYNTHASE SUBUNIT B', 238555),
(296251, 'PTHR45527:SF13', NULL, NULL, NULL, NULL, 'ENTEROBACTIN SYNTHASE COMPONENT F', 238555),
(296252, 'PTHR45527:SF1', NULL, NULL, NULL, NULL, 'FATTY ACID SYNTHASE', 238555),
(296253, 'PTHR45527:SF2', NULL, NULL, NULL, NULL, 'FERRICROCIN SYNTHETASE (NONRIBOSOMAL PEPTIDE SIDEROPHORE SYNTHASE ) (EUROFUNG)', 238555),
(296254, 'PTHR45527:SF3', NULL, NULL, NULL, NULL, 'SIDEROPHORE SYNTHETASE (EUROFUNG)-RELATED', 238555),
(296255, 'PTHR45527:SF7', NULL, NULL, NULL, NULL, 'HYDROXAMATE-TYPE FERRICHROME SIDEROPHORE PEPTIDE SYNTHETASE', 238555),
(296256, 'PTHR12714:SF26', NULL, NULL, NULL, NULL, 'S-ISOPRENYLCYSTEINE O-METHYLTRANSFERASE', 238556),
(296257, 'PTHR12714:SF25', NULL, NULL, NULL, NULL, 'CONSERVED HYPOTHETICAL MEMBRANE PROTEIN', 238556),
(296258, 'PTHR12714:SF9', NULL, NULL, NULL, NULL, 'PROTEIN-S-ISOPRENYLCYSTEINE O-METHYLTRANSFERASE', 238556),
(296259, 'PTHR12714:SF24', NULL, NULL, NULL, NULL, 'SLR1182 PROTEIN', 238556),
(296260, 'PTHR12714:SF23', NULL, NULL, NULL, NULL, 'PROTEIN-S-ISOPRENYLCYSTEINE O-METHYLTRANSFERASE', 238556),
(296261, 'PTHR12714:SF11', NULL, NULL, NULL, NULL, 'PROTEIN C-TERMINAL S-ISOPRENYLCYSTEINE CARBOXYL O-METHYLTRANSFERASE', 238556),
(296262, 'PTHR12714', NULL, NULL, NULL, NULL, 'PROTEIN-S ISOPRENYLCYSTEINE O-METHYLTRANSFERASE', 238556),
(296263, 'PTHR12714:SF20', NULL, NULL, NULL, NULL, 'FAD SYNTHETASE 1, CHLOROPLASTIC-RELATED', 238556),
(296264, 'PTHR12714:SF19', NULL, NULL, NULL, NULL, 'PROTEIN-S-ISOPRENYLCYSTEINE O-METHYLTRANSFERASE', 238556),
(296265, 'PTHR31811', NULL, NULL, NULL, NULL, 'TRNA A64-2''-O-RIBOSYLPHOSPHATE TRANSFERASE', 238557),
(296266, 'PTHR31811:SF0', NULL, NULL, NULL, NULL, 'TRNA A64-2''-O-RIBOSYLPHOSPHATE TRANSFERASE', 238557),
(296267, 'PTHR34041', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REPAIR PROTEIN PSB27-H1, CHLOROPLASTIC', 238558),
(296268, 'PTHR34041:SF1', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REPAIR PROTEIN PSB27-H1, CHLOROPLASTIC', 238558),
(296269, 'PTHR34041:SF3', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II D1 PRECURSOR PROCESSING PROTEIN PSB27-H2, CHLOROPLASTIC', 238558),
(296270, 'PTHR34041:SF5', NULL, NULL, NULL, NULL, 'BNAC08G46250D PROTEIN', 238558),
(296271, 'PTHR48168:SF1', NULL, NULL, NULL, NULL, 'RNA GUANINE-7 METHYLTRANSFERASE-ACTIVATING SUBUNIT-LIKE (PSEUDOGENE)-RELATED', 238559),
(296272, 'PTHR48168', NULL, NULL, NULL, NULL, 'RNA GUANINE-7 METHYLTRANSFERASE-ACTIVATING SUBUNIT-LIKE (PSEUDOGENE)-RELATED', 238559),
(296273, 'PTHR13861:SF2', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT F', 238560),
(296274, 'PTHR13861:SF10', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT F', 238560);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(296275, 'PTHR13861:SF12', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT F-LIKE ISOFORM X1', 238560),
(296276, 'PTHR13861', NULL, NULL, NULL, NULL, 'VACUOLAR ATP SYNTHASE SUBUNIT F', 238560),
(296277, 'PTHR37978', NULL, NULL, NULL, NULL, 'PROTEIN CBG22381-RELATED', 238561),
(296278, 'PTHR37978:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG22381', 238561),
(296279, 'PTHR37978:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG18749', 238561),
(296280, 'PTHR43078:SF43', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE DECARBOXYLASE', 238562),
(296281, 'PTHR43078:SF22', NULL, NULL, NULL, NULL, 'UDP-GLUCURONIC ACID DECARBOXYLASE 1', 238562),
(296282, 'PTHR43078:SF44', NULL, NULL, NULL, NULL, 'CDP TYVULOSE EPIMERASE-RELATED', 238562),
(296283, 'PTHR43078:SF45', NULL, NULL, NULL, NULL, 'UDP-GLUCURONIC ACID DECARBOXYLASE 6', 238562),
(296284, 'PTHR43078:SF46', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE DECARBOXYLASE', 238562),
(296285, 'PTHR43078:SF24', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE DECARBOXYLASE', 238562),
(296286, 'PTHR43078:SF47', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE DECARBOXYLASE', 238562),
(296287, 'PTHR43078:SF48', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE DECARBOXYLASE', 238562),
(296288, 'PTHR43078:SF49', NULL, NULL, NULL, NULL, 'UDP-GLUCURONIC ACID DECARBOXYLASE 3-RELATED', 238562),
(296289, 'PTHR43078', NULL, NULL, NULL, NULL, 'UDP-GLUCURONIC ACID DECARBOXYLASE-RELATED', 238562),
(296290, 'PTHR43078:SF41', NULL, NULL, NULL, NULL, 'UDP-GLUCURONIC ACID DECARBOXYLASE 2', 238562),
(296291, 'PTHR43078:SF42', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE DECARBOXYLASE', 238562),
(296292, 'PTHR43078:SF29', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE DECARBOXYLASE', 238562),
(296293, 'PTHR43078:SF32', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE DECARBOXYLASE', 238562),
(296294, 'PTHR43078:SF6', NULL, NULL, NULL, NULL, 'UDP-GLUCURONIC ACID DECARBOXYLASE 1', 238562),
(296295, 'PTHR43078:SF33', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE DECARBOXYLASE', 238562),
(296296, 'PTHR43078:SF12', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE DECARBOXYLASE', 238562),
(296297, 'PTHR43078:SF7', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE DECARBOXYLASE', 238562),
(296298, 'PTHR43078:SF13', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE DECARBOXYLASE', 238562),
(296299, 'PTHR43078:SF14', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE DECARBOXYLASE', 238562),
(296300, 'PTHR43078:SF38', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE DECARBOXYLASE', 238562),
(296301, 'PTHR43078:SF16', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE DECARBOXYLASE', 238562),
(296302, 'PTHR43078:SF50', NULL, NULL, NULL, NULL, 'UDP-GLUCURONIC ACID DECARBOXYLASE 5', 238562),
(296303, 'PTHR43078:SF51', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE DECARBOXYLASE', 238562),
(296304, 'PTHR43078:SF31', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE DECARBOXYLASE', 238562),
(296305, 'PTHR43078:SF18', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE DECARBOXYLASE', 238562),
(296306, 'PTHR32010:SF23', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 238563),
(296307, 'PTHR32010:SF22', NULL, NULL, NULL, NULL, '', 238563),
(296308, 'PTHR32010:SF20', NULL, NULL, NULL, NULL, '', 238563),
(296309, 'PTHR32010', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II STABILITY/ASSEMBLY FACTOR HCF136, CHLOROPLASTIC', 238563),
(296310, 'PTHR32010:SF18', NULL, NULL, NULL, NULL, 'DUF789 FAMILY PROTEIN', 238563),
(296311, 'PTHR32010:SF19', NULL, NULL, NULL, NULL, 'OS04G0675000 PROTEIN', 238563),
(296312, 'PTHR33359', NULL, NULL, NULL, NULL, 'MOLYBDOPTERIN SYNTHASE SULFUR CARRIER SUBUNIT', 238564),
(296313, 'PTHR33359:SF1', NULL, NULL, NULL, NULL, 'MOLYBDOPTERIN SYNTHASE SULFUR CARRIER SUBUNIT', 238564),
(296314, 'PTHR35690', NULL, NULL, NULL, NULL, 'OS01G0363500 PROTEIN', 238565),
(296315, 'PTHR35690:SF1', NULL, NULL, NULL, NULL, 'OS01G0363500 PROTEIN', 238565),
(296316, 'PTHR12220:SF22', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L16-RELATED', 238566),
(296317, 'PTHR12220:SF24', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L16, MITOCHONDRIAL', 238566),
(296318, 'PTHR12220:SF13', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L16, MITOCHONDRIAL', 238566);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(296319, 'PTHR12220', NULL, NULL, NULL, NULL, '50S/60S RIBOSOMAL PROTEIN L16', 238566),
(296320, 'PTHR23077:SF190', NULL, NULL, NULL, NULL, 'PROTEIN HOMOLOG, PUTATIVE-RELATED', 238567),
(296321, 'PTHR23077:SF191', NULL, NULL, NULL, NULL, 'BNAC01G38940D PROTEIN', 238567),
(296322, 'PTHR23077:SF192', NULL, NULL, NULL, NULL, 'PEROXIN-1', 238567),
(296323, 'PTHR23077:SF193', NULL, NULL, NULL, NULL, 'OS08G0413000 PROTEIN', 238567),
(296324, 'PTHR23077:SF171', NULL, NULL, NULL, NULL, 'NUCLEAR VALOSIN-CONTAINING PROTEIN-LIKE', 238567),
(296325, 'PTHR23077:SF51', NULL, NULL, NULL, NULL, '', 238567),
(296326, 'PTHR23077:SF52', NULL, NULL, NULL, NULL, 'TRANSITIONAL ENDOPLASMIC RETICULUM ATPASE HOMOLOG 1', 238567),
(296327, 'PTHR23077:SF12', NULL, NULL, NULL, NULL, 'PEROXISOME BIOGENESIS FACTOR 1', 238567),
(296328, 'PTHR23077:SF148', NULL, NULL, NULL, NULL, 'OS09G0563800 PROTEIN', 238567),
(296329, 'PTHR23077:SF187', NULL, NULL, NULL, NULL, '', 238567),
(296330, 'PTHR23077:SF165', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE PROTEIN 48 HOMOLOG', 238567),
(296331, 'PTHR23077:SF188', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE PROTEIN 48 HOMOLOG', 238567),
(296332, 'PTHR23077:SF144', NULL, NULL, NULL, NULL, 'PROTEASOME-ASSOCIATED ATPASE', 238567),
(296333, 'PTHR23077:SF189', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE PROTEIN 48 HOMOLOG ISOFORM X1', 238567),
(296334, 'PTHR23077:SF146', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 238567),
(296335, 'PTHR23077:SF9', NULL, NULL, NULL, NULL, 'PEROXISOME ASSEMBLY FACTOR 2', 238567),
(296336, 'PTHR23077:SF183', NULL, NULL, NULL, NULL, 'ATPASE-RELATED', 238567),
(296337, 'PTHR23077:SF184', NULL, NULL, NULL, NULL, 'CELL DIVISION CONTROL PROTEIN 48 HOMOLOG D', 238567),
(296338, 'PTHR23077:SF185', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT ZINC METALLOPROTEASE FTSH', 238567),
(296339, 'PTHR23077:SF142', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238567),
(296340, 'PTHR23077:SF186', NULL, NULL, NULL, NULL, '', 238567),
(296341, 'PTHR23077:SF180', NULL, NULL, NULL, NULL, 'CELL DIVISION CONTROL PROTEIN 48 HOMOLOG D', 238567),
(296342, 'PTHR23077:SF182', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE PROTEIN 48 HOMOLOG', 238567),
(296343, 'PTHR23077:SF63', NULL, NULL, NULL, NULL, 'TRANSITIONAL ENDOPLASMIC RETICULUM ATPASE', 238567),
(296344, 'PTHR23077', NULL, NULL, NULL, NULL, 'AAA-FAMILY ATPASE', 238567),
(296345, 'PTHR23077:SF69', NULL, NULL, NULL, NULL, 'TRANSITIONAL ENDOPLASMIC RETICULUM ATPASE', 238567),
(296346, 'PTHR23077:SF27', NULL, NULL, NULL, NULL, 'ATPASE FAMILY PROTEIN 2 HOMOLOG', 238567),
(296347, 'PTHR23077:SF136', NULL, NULL, NULL, NULL, '', 238567),
(296348, 'PTHR23077:SF158', NULL, NULL, NULL, NULL, 'ATPASE, AAA-TYPE, CDC48 PROTEIN', 238567),
(296349, 'PTHR23077:SF159', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 238567),
(296350, 'PTHR23077:SF138', NULL, NULL, NULL, NULL, 'CELL DIVISION CONTROL PROTEIN 48 HOMOLOG A', 238567),
(296351, 'PTHR23077:SF117', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 5-LIKE PROTEIN 1', 238567),
(296352, 'PTHR23077:SF132', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT ZN PROTEASE', 238567),
(296353, 'PTHR23077:SF176', NULL, NULL, NULL, NULL, 'ATPASE, AAA-TYPE, CDC48 PROTEIN-RELATED', 238567),
(296354, 'PTHR23077:SF179', NULL, NULL, NULL, NULL, '', 238567),
(296355, 'PTHR23077:SF135', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238567),
(296356, 'PTHR23077:SF172', NULL, NULL, NULL, NULL, 'ACYLPHOSPHATASE', 238567),
(296357, 'PTHR23077:SF151', NULL, NULL, NULL, NULL, '', 238567),
(296358, 'PTHR23077:SF153', NULL, NULL, NULL, NULL, 'TRANSITIONAL ENDOPLASMIC RETICULUM ATPASE', 238567),
(296359, 'PTHR11329', NULL, NULL, NULL, NULL, 'LEUKOCYTE CELL-DERIVED CHEMOTAXIN 2', 238568),
(296360, 'PTHR11329:SF1', NULL, NULL, NULL, NULL, 'SI:CH1073-204B8.1', 238568),
(296361, 'PTHR11329:SF2', NULL, NULL, NULL, NULL, 'LEUKOCYTE CELL-DERIVED CHEMOTAXIN 2-RELATED', 238568),
(296362, 'PTHR11329:SF0', NULL, NULL, NULL, NULL, 'LEUKOCYTE CELL-DERIVED CHEMOTAXIN-2', 238568),
(296363, 'PTHR24102:SF28', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', 238569);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(296364, 'PTHR24102:SF18', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN 21B', 238569),
(296365, 'PTHR24102:SF6', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN 21A', 238569),
(296366, 'PTHR24102', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN', 238569),
(296367, 'PTHR40050', NULL, NULL, NULL, NULL, 'INNER SPORE COAT PROTEIN H', 238570),
(296368, 'PTHR40050:SF1', NULL, NULL, NULL, NULL, 'INNER SPORE COAT PROTEIN H', 238570),
(296369, 'PTHR44464:SF1', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 17', 238571),
(296370, 'PTHR44464', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 17', 238571),
(296371, 'PTHR16566:SF0', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN C-II', 238572),
(296372, 'PTHR16566', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN C-II', 238572),
(296373, 'PTHR11787:SF8', NULL, NULL, NULL, NULL, 'RAB GDP DISSOCIATION INHIBITOR', 238573),
(296374, 'PTHR11787:SF9', NULL, NULL, NULL, NULL, 'RAB PROTEINS GERANYLGERANYLTRANSFERASE COMPONENT A 2', 238573),
(296375, 'PTHR11787:SF19', NULL, NULL, NULL, NULL, 'GUANOSINE NUCLEOTIDE DIPHOSPHATE DISSOCIATION INHIBITOR 2', 238573),
(296376, 'PTHR11787:SF29', NULL, NULL, NULL, NULL, 'GUANOSINE NUCLEOTIDE DIPHOSPHATE DISSOCIATION INHIBITOR', 238573),
(296377, 'PTHR11787:SF18', NULL, NULL, NULL, NULL, 'GUANOSINE NUCLEOTIDE DIPHOSPHATE DISSOCIATION INHIBITOR', 238573),
(296378, 'PTHR11787:SF15', NULL, NULL, NULL, NULL, 'GUANOSINE NUCLEOTIDE DIPHOSPHATE DISSOCIATION INHIBITOR 2', 238573),
(296379, 'PTHR11787:SF26', NULL, NULL, NULL, NULL, 'GUANOSINE NUCLEOTIDE DIPHOSPHATE DISSOCIATION INHIBITOR', 238573),
(296380, 'PTHR11787', NULL, NULL, NULL, NULL, 'RAB GDP-DISSOCIATION INHIBITOR', 238573),
(296381, 'PTHR11787:SF28', NULL, NULL, NULL, NULL, 'GUANOSINE NUCLEOTIDE DIPHOSPHATE DISSOCIATION INHIBITOR', 238573),
(296382, 'PTHR11787:SF16', NULL, NULL, NULL, NULL, '', 238573),
(296383, 'PTHR11787:SF27', NULL, NULL, NULL, NULL, 'GUANOSINE NUCLEOTIDE DIPHOSPHATE DISSOCIATION INHIBITOR', 238573),
(296384, 'PTHR11787:SF11', NULL, NULL, NULL, NULL, 'GUANOSINE NUCLEOTIDE DIPHOSPHATE DISSOCIATION INHIBITOR', 238573),
(296385, 'PTHR11787:SF10', NULL, NULL, NULL, NULL, 'GUANOSINE NUCLEOTIDE DIPHOSPHATE DISSOCIATION INHIBITOR', 238573),
(296386, 'PTHR11787:SF24', NULL, NULL, NULL, NULL, 'GUANOSINE NUCLEOTIDE DIPHOSPHATE DISSOCIATION INHIBITOR', 238573),
(296387, 'PTHR11787:SF12', NULL, NULL, NULL, NULL, 'RAB PROTEINS GERANYLGERANYLTRANSFERASE COMPONENT A 1', 238573),
(296388, 'PTHR11787:SF1', NULL, NULL, NULL, NULL, 'RAB GDP DISSOCIATION INHIBITOR BETA', 238573),
(296389, 'PTHR11787:SF20', NULL, NULL, NULL, NULL, 'GUANOSINE NUCLEOTIDE DIPHOSPHATE DISSOCIATION INHIBITOR', 238573),
(296390, 'PTHR11787:SF3', NULL, NULL, NULL, NULL, 'RAB GDP DISSOCIATION INHIBITOR ALPHA', 238573),
(296391, 'PTHR11787:SF4', NULL, NULL, NULL, NULL, 'RAB PROTEINS GERANYLGERANYLTRANSFERASE COMPONENT A', 238573),
(296392, 'PTHR35511:SF2', NULL, NULL, NULL, NULL, 'A-KINASE ANCHOR-LIKE PROTEIN', 238574),
(296393, 'PTHR35511', NULL, NULL, NULL, NULL, 'A-KINASE ANCHOR-LIKE PROTEIN', 238574),
(296394, 'PTHR15938', NULL, NULL, NULL, NULL, 'TBP-1 INTERACTING PROTEIN', 238575),
(296395, 'PTHR15938:SF1', NULL, NULL, NULL, NULL, 'MEIOTIC NUCLEAR DIVISION PROTEIN 1', 238575),
(296396, 'PTHR15938:SF0', NULL, NULL, NULL, NULL, 'HOMOLOGOUS-PAIRING PROTEIN 2 HOMOLOG', 238575),
(296397, 'PTHR43867', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE CATALYTIC SUBUNIT A [UDP-FORMING]', 238576),
(296398, 'PTHR43867:SF5', NULL, NULL, NULL, NULL, 'GLUCANS BIOSYNTHESIS GLUCOSYLTRANSFERASE H', 238576),
(296399, 'PTHR43867:SF7', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE (EUROFUNG)-RELATED', 238576),
(296400, 'PTHR43867:SF2', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE CATALYTIC SUBUNIT A [UDP-FORMING]', 238576),
(296401, 'PTHR43867:SF4', NULL, NULL, NULL, NULL, 'BETA-(1-3)-GLUCOSYL TRANSFERASE', 238576),
(296402, 'PTHR21479:SF24', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 238577),
(296403, 'PTHR21479:SF25', NULL, NULL, NULL, NULL, 'PROTEIN CBG03503', 238577),
(296404, 'PTHR21479:SF22', NULL, NULL, NULL, NULL, 'PROTEIN CBG00204', 238577);
INSERT INTO "PUBLIC"."MODEL" VALUES
(296405, 'PTHR21479', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 238577),
(296406, 'PTHR21479:SF23', NULL, NULL, NULL, NULL, 'PROTEIN CBG24148', 238577),
(296407, 'PTHR21479:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG15728', 238577),
(296408, 'PTHR21479:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG17573', 238577),
(296409, 'PTHR21479:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG04466', 238577),
(296410, 'PTHR21479:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG21787', 238577),
(296411, 'PTHR21479:SF26', NULL, NULL, NULL, NULL, 'PROTEIN CBG26091', 238577),
(296412, 'PTHR21106', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 238578),
(296413, 'PTHR21106:SF2', NULL, NULL, NULL, NULL, 'COMPLEX I-B17', 238578),
(296414, 'PTHR47438', NULL, NULL, NULL, NULL, 'PHOSPHATE METABOLISM PROTEIN 8-RELATED', 238579),
(296415, 'PTHR47438:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATE METABOLISM PROTEIN 8-RELATED', 238579),
(296416, 'PTHR19849:SF0', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A-2-ACTIVATING PROTEIN', 238580),
(296417, 'PTHR19849:SF1', NULL, NULL, NULL, NULL, 'F-BOX/WD REPEAT-CONTAINING PROTEIN 7', 238580),
(296418, 'PTHR19849', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A-2-ACTIVATING PROTEIN', 238580),
(296419, 'PTHR40033', NULL, NULL, NULL, NULL, 'NA(+)-MALATE SYMPORTER', 238581),
(296420, 'PTHR40033:SF1', NULL, NULL, NULL, NULL, 'NA(+)-MALATE SYMPORTER', 238581),
(296421, 'PTHR40027:SF1', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN DIVIC', 238582),
(296422, 'PTHR40027', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN DIVIC', 238582),
(296423, 'PTHR34855', NULL, NULL, NULL, NULL, 'TRICHOHYALIN', 238583),
(296424, 'PTHR34855:SF1', NULL, NULL, NULL, NULL, 'TRICHOHYALIN', 238583),
(296425, 'PTHR37482:SF1', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN ASSEMBLY FACTOR BAME', 238584),
(296426, 'PTHR37482', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN ASSEMBLY FACTOR BAME', 238584),
(296427, 'PTHR31096:SF16', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN ACR11', 238585),
(296428, 'PTHR31096:SF59', NULL, NULL, NULL, NULL, '[PROTEIN-PII] URIDYLYLTRANSFERASE-RELATED', 238585),
(296429, 'PTHR31096:SF15', NULL, NULL, NULL, NULL, 'OS08G0533300 PROTEIN', 238585),
(296430, 'PTHR31096:SF74', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN ACR10-LIKE', 238585),
(296431, 'PTHR31096:SF73', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN-RELATED', 238585),
(296432, 'PTHR31096:SF51', NULL, NULL, NULL, NULL, 'ACT DOMAIN CONTAINING PROTEIN, EXPRESSED', 238585),
(296433, 'PTHR31096:SF10', NULL, NULL, NULL, NULL, 'DOMAIN CONTAINING PROTEIN, PUTATIVE, EXPRESSED-RELATED', 238585),
(296434, 'PTHR31096:SF53', NULL, NULL, NULL, NULL, 'ACT-DOMAIN REPEAT PROTEIN 8', 238585),
(296435, 'PTHR31096:SF75', NULL, NULL, NULL, NULL, 'BNAA03G01400D PROTEIN', 238585),
(296436, 'PTHR31096:SF78', NULL, NULL, NULL, NULL, 'BNAA02G27260D PROTEIN', 238585),
(296437, 'PTHR31096:SF77', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN ACR4-LIKE ISOFORM X1', 238585),
(296438, 'PTHR31096:SF55', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN ACR6', 238585),
(296439, 'PTHR31096:SF14', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN', 238585),
(296440, 'PTHR31096:SF70', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN-RELATED', 238585),
(296441, 'PTHR31096:SF50', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN ACR2', 238585),
(296442, 'PTHR31096:SF71', NULL, NULL, NULL, NULL, 'ACT DOMAIN REPEAT 8-RELATED', 238585),
(296443, 'PTHR31096:SF48', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN ACR7', 238585),
(296444, 'PTHR31096:SF63', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN-RELATED', 238585),
(296445, 'PTHR31096:SF85', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 238585),
(296446, 'PTHR31096:SF40', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN ACR4-LIKE', 238585),
(296447, 'PTHR31096:SF87', NULL, NULL, NULL, NULL, 'FOUR ACT DOMAIN ACT DOMAIN PROTEIN WHICH PROTEIN', 238585),
(296448, 'PTHR31096:SF65', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN ACR9', 238585);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(296449, 'PTHR31096:SF86', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN', 238585),
(296450, 'PTHR31096:SF23', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN ACR10', 238585),
(296451, 'PTHR31096:SF89', NULL, NULL, NULL, NULL, 'FROM 2D-PAGE OF LEAF PROTEIN, PUTATIVE-RELATED', 238585),
(296452, 'PTHR31096:SF67', NULL, NULL, NULL, NULL, 'BNAA08G24740D PROTEIN', 238585),
(296453, 'PTHR31096:SF44', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN DS12, CHLOROPLASTIC-LIKE', 238585),
(296454, 'PTHR31096:SF22', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN ACR4', 238585),
(296455, 'PTHR31096:SF88', NULL, NULL, NULL, NULL, 'FOUR ACT DOMAIN ACT DOMAIN PROTEIN WHICH PROTEIN', 238585),
(296456, 'PTHR31096:SF66', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN-RELATED', 238585),
(296457, 'PTHR31096:SF47', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN ACR8-LIKE ISOFORM X1', 238585),
(296458, 'PTHR31096:SF69', NULL, NULL, NULL, NULL, 'BNAC06G29950D PROTEIN', 238585),
(296459, 'PTHR31096:SF46', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN ACR5', 238585),
(296460, 'PTHR31096:SF68', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN-RELATED', 238585),
(296461, 'PTHR31096', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN ACR4-RELATED', 238585),
(296462, 'PTHR31096:SF5', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN ACR3', 238585),
(296463, 'PTHR31096:SF6', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN ACR8', 238585),
(296464, 'PTHR31096:SF83', NULL, NULL, NULL, NULL, 'FOUR ACT DOMAIN ACT DOMAIN PROTEIN WHICH PROTEIN', 238585),
(296465, 'PTHR31096:SF7', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN ACR1', 238585),
(296466, 'PTHR31096:SF82', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN-RELATED', 238585),
(296467, 'PTHR31096:SF60', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN ACR12', 238585),
(296468, 'PTHR39209:SF2', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 238586),
(296469, 'PTHR39209', NULL, NULL, NULL, NULL, '', 238586),
(296470, 'PTHR10077:SF0', NULL, NULL, NULL, NULL, 'CALPASTATIN', 238587),
(296471, 'PTHR10077', NULL, NULL, NULL, NULL, 'CALPASTATIN', 238587),
(296472, 'PTHR10635:SF6', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT BETA', 238588),
(296473, 'PTHR10635:SF7', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT BETA', 238588),
(296474, 'PTHR10635:SF2', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT BETA', 238588),
(296475, 'PTHR10635:SF3', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT BETA-1', 238588),
(296476, 'PTHR10635:SF4', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT BETA', 238588),
(296477, 'PTHR10635', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT BETA', 238588),
(296478, 'PTHR10635:SF0', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT BETA', 238588),
(296479, 'PTHR10635:SF1', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT BETA-1', 238588),
(296480, 'PTHR36790:SF1', NULL, NULL, NULL, NULL, 'MYELIN TRANSCRIPTION FACTOR', 238589),
(296481, 'PTHR36790:SF2', NULL, NULL, NULL, NULL, '', 238589),
(296482, 'PTHR36790', NULL, NULL, NULL, NULL, 'MYELIN TRANSCRIPTION FACTOR', 238589),
(296483, 'PTHR35725', NULL, NULL, NULL, NULL, 'CLASSICAL ARABINOGALACTAN PROTEIN 26', 238590),
(296484, 'PTHR35725:SF3', NULL, NULL, NULL, NULL, 'CLASSICAL ARABINOGALACTAN PROTEIN 25', 238590),
(296485, 'PTHR35725:SF4', NULL, NULL, NULL, NULL, 'CLASSICAL ARABINOGALACTAN PROTEIN 26', 238590),
(296486, 'PTHR21071', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLENOLPYRUVOYLGLUCOSAMINE REDUCTASE', 238591),
(296487, 'PTHR21071:SF5', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLENOLPYRUVOYLGLUCOSAMINE REDUCTASE', 238591),
(296488, 'PTHR21071:SF4', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLENOLPYRUVOYLGLUCOSAMINE REDUCTASE', 238591),
(296489, 'PTHR15208:SF2', NULL, NULL, NULL, NULL, 'RECEPTOR-BINDING CANCER ANTIGEN EXPRESSED ON SISO CELLS', 238592),
(296490, 'PTHR15208', NULL, NULL, NULL, NULL, 'RECEPTOR-BINDING CANCER ANTIGEN EXPRESSED ON SISO CELLS  CANCER ASSOCIATED SURFACE ANTIGEN RCAS1   ESTROGEN RECEPTOR-BINDING FRAGMENT- ASSOCIATED GENE 9 PROTEIN', 238592);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(296491, 'PTHR22708:SF0', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 56', 238593),
(296492, 'PTHR22708', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 238593),
(296493, 'PTHR22708:SF2', NULL, NULL, NULL, NULL, '', 238593),
(296494, 'PTHR36329', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 238594),
(296495, 'PTHR36329:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 238594),
(296496, 'PTHR28022', NULL, NULL, NULL, NULL, 'GPI MANNOSYLTRANSFERASE 2 SUBUNIT PGA1', 238595),
(296497, 'PTHR28022:SF1', NULL, NULL, NULL, NULL, 'GPI MANNOSYLTRANSFERASE 2 SUBUNIT PGA1', 238595),
(296498, 'PTHR27004:SF387', NULL, NULL, NULL, NULL, 'RECEPTOR LIKE PROTEIN 24', 238596),
(296499, 'PTHR27004:SF420', NULL, NULL, NULL, NULL, 'RECEPTOR LIKE PROTEIN 7', 238596),
(296500, 'PTHR27004:SF388', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE FAMILY PROTEIN', 238596),
(296501, 'PTHR27004:SF383', NULL, NULL, NULL, NULL, 'BNAA04G18970D PROTEIN', 238596),
(296502, 'PTHR27004:SF142', NULL, NULL, NULL, NULL, 'RECEPTOR LIKE PROTEIN 27', 238596),
(296503, 'PTHR27004:SF428', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 238596),
(296504, 'PTHR27004:SF307', NULL, NULL, NULL, NULL, 'OS01G0160200 PROTEIN', 238596),
(296505, 'PTHR27004:SF429', NULL, NULL, NULL, NULL, 'BNAC04G37570D PROTEIN', 238596),
(296506, 'PTHR27004:SF426', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE FLS2', 238596),
(296507, 'PTHR27004:SF427', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN, PLANT-TYPE-RELATED', 238596),
(296508, 'PTHR27004:SF424', NULL, NULL, NULL, NULL, 'HCR2-5D', 238596),
(296509, 'PTHR27004:SF425', NULL, NULL, NULL, NULL, 'OS01G0162800 PROTEIN', 238596),
(296510, 'PTHR27004:SF422', NULL, NULL, NULL, NULL, 'BNAA01G31270D PROTEIN', 238596),
(296511, 'PTHR27004:SF423', NULL, NULL, NULL, NULL, 'BNAC04G43850D PROTEIN', 238596),
(296512, 'PTHR27004:SF398', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 238596),
(296513, 'PTHR27004:SF431', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 238596),
(296514, 'PTHR27004:SF432', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 238596),
(296515, 'PTHR27004:SF430', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 12', 238596),
(296516, 'PTHR27004:SF395', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 238596),
(296517, 'PTHR27004:SF392', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 238596),
(296518, 'PTHR27004:SF439', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 12', 238596),
(296519, 'PTHR27004:SF319', NULL, NULL, NULL, NULL, '', 238596),
(296520, 'PTHR27004:SF437', NULL, NULL, NULL, NULL, 'PROTEIN KINASE, PLANT-TYPE, PUTATIVE-RELATED', 238596),
(296521, 'PTHR27004:SF317', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 54', 238596),
(296522, 'PTHR27004:SF438', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 36-RELATED', 238596),
(296523, 'PTHR27004:SF435', NULL, NULL, NULL, NULL, 'PROTEIN KINASE, PLANT-TYPE, PUTATIVE-RELATED', 238596),
(296524, 'PTHR27004:SF436', NULL, NULL, NULL, NULL, 'OS01G0132100 PROTEIN', 238596),
(296525, 'PTHR27004:SF433', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE FAMILY PROTEIN', 238596),
(296526, 'PTHR27004:SF434', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 238596),
(296527, 'PTHR27004:SF313', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 31', 238596),
(296528, 'PTHR27004:SF280', NULL, NULL, NULL, NULL, 'OS08G0266400 PROTEIN', 238596),
(296529, 'PTHR27004:SF442', NULL, NULL, NULL, NULL, '', 238596),
(296530, 'PTHR27004:SF321', NULL, NULL, NULL, NULL, 'BNAC04G43190D PROTEIN', 238596),
(296531, 'PTHR27004:SF443', NULL, NULL, NULL, NULL, 'OS08G0541300 PROTEIN', 238596),
(296532, 'PTHR27004:SF440', NULL, NULL, NULL, NULL, '', 238596),
(296533, 'PTHR27004:SF441', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 238596),
(296534, 'PTHR27004:SF208', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE GSO2', 238596),
(296535, 'PTHR27004:SF329', NULL, NULL, NULL, NULL, 'BNACNNG24010D PROTEIN', 238596);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(296536, 'PTHR27004:SF209', NULL, NULL, NULL, NULL, 'RECEPTOR LIKE PROTEIN 22', 238596),
(296537, 'PTHR27004:SF448', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 238596),
(296538, 'PTHR27004:SF327', NULL, NULL, NULL, NULL, 'BNAA05G10510D PROTEIN', 238596),
(296539, 'PTHR27004:SF328', NULL, NULL, NULL, NULL, 'BNAA04G20170D PROTEIN', 238596),
(296540, 'PTHR27004:SF446', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 12', 238596),
(296541, 'PTHR27004', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 12 ISOFORM X1', 238596),
(296542, 'PTHR27004:SF447', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 6', 238596),
(296543, 'PTHR27004:SF326', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 238596),
(296544, 'PTHR27004:SF444', NULL, NULL, NULL, NULL, 'TM RESISTANCE PROTEIN, PUTATIVE-RELATED', 238596),
(296545, 'PTHR27004:SF323', NULL, NULL, NULL, NULL, 'OS02G0161500 PROTEIN', 238596),
(296546, 'PTHR27004:SF445', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 238596),
(296547, 'PTHR27004:SF203', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE FLS2', 238596),
(296548, 'PTHR27004:SF332', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 238596),
(296549, 'PTHR27004:SF333', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 12', 238596),
(296550, 'PTHR27004:SF296', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 238596),
(296551, 'PTHR27004:SF173', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 7', 238596),
(296552, 'PTHR27004:SF338', NULL, NULL, NULL, NULL, 'BNAANNG12430D PROTEIN', 238596),
(296553, 'PTHR27004:SF339', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 238596),
(296554, 'PTHR27004:SF336', NULL, NULL, NULL, NULL, 'BNAA04G18520D PROTEIN', 238596),
(296555, 'PTHR27004:SF337', NULL, NULL, NULL, NULL, 'RECEPTOR LIKE PROTEIN 23', 238596),
(296556, 'PTHR27004:SF335', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT (LRR) FAMILY PROTEIN', 238596),
(296557, 'PTHR27004:SF181', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE IRK-RELATED', 238596),
(296558, 'PTHR27004:SF343', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 238596),
(296559, 'PTHR27004:SF222', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 49-RELATED', 238596),
(296560, 'PTHR27004:SF344', NULL, NULL, NULL, NULL, 'OS04G0480500 PROTEIN', 238596),
(296561, 'PTHR27004:SF220', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT FAMILY PROTEIN', 238596),
(296562, 'PTHR27004:SF221', NULL, NULL, NULL, NULL, 'OS01G0160600 PROTEIN', 238596),
(296563, 'PTHR27004:SF185', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 238596),
(296564, 'PTHR27004:SF346', NULL, NULL, NULL, NULL, 'BNAA04G18930D PROTEIN', 238596),
(296565, 'PTHR27004:SF59', NULL, NULL, NULL, NULL, 'OS01G0161300 PROTEIN', 238596),
(296566, 'PTHR27004:SF198', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE FLS2', 238596),
(296567, 'PTHR27004:SF195', NULL, NULL, NULL, NULL, 'RECEPTOR LIKE PROTEIN 28-RELATED', 238596),
(296568, 'PTHR27004:SF358', NULL, NULL, NULL, NULL, 'BNACNNG65590D PROTEIN', 238596),
(296569, 'PTHR27004:SF356', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 238596),
(296570, 'PTHR27004:SF357', NULL, NULL, NULL, NULL, 'BNAA05G10310D PROTEIN', 238596),
(296571, 'PTHR27004:SF242', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 19-RELATED', 238596),
(296572, 'PTHR27004:SF364', NULL, NULL, NULL, NULL, 'RECEPTOR LIKE PROTEIN 26', 238596),
(296573, 'PTHR27004:SF361', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 47-RELATED', 238596),
(296574, 'PTHR27004:SF360', NULL, NULL, NULL, NULL, 'BNAC05G03070D PROTEIN', 238596),
(296575, 'PTHR27004:SF406', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 20', 238596),
(296576, 'PTHR27004:SF404', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE FLS2', 238596),
(296577, 'PTHR27004:SF405', NULL, NULL, NULL, NULL, 'OS12G0217500 PROTEIN', 238596),
(296578, 'PTHR27004:SF401', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 238596); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(296579, 'PTHR27004:SF408', NULL, NULL, NULL, NULL, 'SMR DOMAIN-CONTAINING PROTEIN', 238596),
(296580, 'PTHR27004:SF376', NULL, NULL, NULL, NULL, 'BNAA05G10630D PROTEIN', 238596),
(296581, 'PTHR27004:SF410', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 238596),
(296582, 'PTHR27004:SF374', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 238596),
(296583, 'PTHR27004:SF375', NULL, NULL, NULL, NULL, 'HCR2-0B', 238596),
(296584, 'PTHR27004:SF372', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 11-RELATED', 238596),
(296585, 'PTHR27004:SF371', NULL, NULL, NULL, NULL, 'BNAC04G11580D PROTEIN', 238596),
(296586, 'PTHR27004:SF417', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE GSO1', 238596),
(296587, 'PTHR27004:SF416', NULL, NULL, NULL, NULL, 'BNAC04G37550D PROTEIN', 238596),
(296588, 'PTHR27004:SF411', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 238596),
(296589, 'PTHR27004:SF378', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 238596),
(296590, 'PTHR27004:SF136', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 44', 238596),
(296591, 'PTHR27004:SF379', NULL, NULL, NULL, NULL, 'BNAC04G42620D PROTEIN', 238596),
(296592, 'PTHR27004:SF412', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 238596),
(296593, 'PTHR27004:SF419', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 18-RELATED', 238596),
(296594, 'PTHR27004:SF380', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 33', 238596),
(296595, 'PTHR33150', NULL, NULL, NULL, NULL, 'EXTRACELLULAR MATRIX-BINDING PROTEIN EBH', 238597),
(296596, 'PTHR33150:SF1', NULL, NULL, NULL, NULL, 'EXTRACELLULAR MATRIX-BINDING PROTEIN EBH', 238597),
(296597, 'PTHR18962', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 39', 238598),
(296598, 'PTHR18962:SF0', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 39', 238598),
(296599, 'PTHR37344', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 5', 238599),
(296600, 'PTHR37344:SF1', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 5', 238599),
(296601, 'PTHR16091:SF3', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 238600),
(296602, 'PTHR16091:SF1', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 17', 238600),
(296603, 'PTHR16091', NULL, NULL, NULL, NULL, 'TTC17 PROTEIN', 238600),
(296604, 'PTHR13511:SF0', NULL, NULL, NULL, NULL, 'KXDL MOTIF-CONTAINING PROTEIN 1', 238601),
(296605, 'PTHR13511', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 238601),
(296606, 'PTHR46413:SF28', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED DOMAIN, HMA-RELATED', 238602),
(296607, 'PTHR46413:SF27', NULL, NULL, NULL, NULL, 'BNAC04G08310D PROTEIN', 238602),
(296608, 'PTHR46413:SF29', NULL, NULL, NULL, NULL, 'BNAA03G16900D PROTEIN', 238602),
(296609, 'PTHR46413:SF24', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 5', 238602),
(296610, 'PTHR46413:SF23', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED DOMAIN, HMA-RELATED', 238602),
(296611, 'PTHR46413:SF20', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 3-LIKE', 238602),
(296612, 'PTHR46413:SF6', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 238602),
(296613, 'PTHR46413:SF22', NULL, NULL, NULL, NULL, 'OS03G0829466 PROTEIN', 238602),
(296614, 'PTHR46413:SF4', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED DOMAIN CONTAINING PROTEIN, EXPRESSED', 238602),
(296615, 'PTHR46413:SF1', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 6', 238602),
(296616, 'PTHR46413:SF2', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 3', 238602),
(296617, 'PTHR46413:SF8', NULL, NULL, NULL, NULL, 'OS02G0818900 PROTEIN', 238602),
(296618, 'PTHR46413:SF17', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 3-LIKE', 238602),
(296619, 'PTHR46413:SF19', NULL, NULL, NULL, NULL, '', 238602),
(296620, 'PTHR46413:SF18', NULL, NULL, NULL, NULL, 'OS09G0549600 PROTEIN', 238602),
(296621, 'PTHR46413:SF35', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED DOMAIN, HMA-RELATED', 238602);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(296622, 'PTHR46413:SF13', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 1', 238602),
(296623, 'PTHR46413:SF12', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 3-LIKE', 238602),
(296624, 'PTHR46413:SF34', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 3-LIKE', 238602),
(296625, 'PTHR46413:SF37', NULL, NULL, NULL, NULL, 'FARNESYLATED PROTEIN', 238602),
(296626, 'PTHR46413:SF14', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED DOMAIN PROTEIN', 238602),
(296627, 'PTHR46413:SF36', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORT/DETOXIFICATION SUPERFAMILY PROTEIN', 238602),
(296628, 'PTHR46413:SF30', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 238602),
(296629, 'PTHR46413:SF33', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 3', 238602),
(296630, 'PTHR46413:SF11', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 238602),
(296631, 'PTHR46413:SF10', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 238602),
(296632, 'PTHR46413', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 6', 238602),
(296633, 'PTHR13480', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HAKAI-RELATED', 238603),
(296634, 'PTHR13480:SF0', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HAKAI', 238603),
(296635, 'PTHR13480:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HAKAI', 238603),
(296636, 'PTHR13480:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE CBLL2', 238603),
(296637, 'PTHR37968', NULL, NULL, NULL, NULL, 'PROTEIN CBG06678', 238604),
(296638, 'PTHR37968:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG06678', 238604),
(296639, 'PTHR33908:SF9', NULL, NULL, NULL, NULL, 'BLL5595 PROTEIN', 238605),
(296640, 'PTHR33908:SF11', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 238605),
(296641, 'PTHR33908:SF3', NULL, NULL, NULL, NULL, 'UNDECAPRENYL PHOSPHATE-ALPHA-4-AMINO-4-DEOXY-L-ARABINOSE ARABINOSYL TRANSFERASE', 238605),
(296642, 'PTHR33908', NULL, NULL, NULL, NULL, 'MANNOSYLTRANSFERASE YKCB-RELATED', 238605),
(296643, 'PTHR42708:SF1', NULL, NULL, NULL, NULL, 'GLIDING MOTILITY PROTEIN MGLA', 238606),
(296644, 'PTHR42708', NULL, NULL, NULL, NULL, 'ATP/GTP-BINDING PROTEIN-RELATED', 238606),
(296645, 'PTHR28112', NULL, NULL, NULL, NULL, 'SRP-INDEPENDENT TARGETING PROTEIN 3', 238607),
(296646, 'PTHR28112:SF2', NULL, NULL, NULL, NULL, 'PHO88 FAMILY PROTEIN', 238607),
(296647, 'PTHR28112:SF1', NULL, NULL, NULL, NULL, 'SRP-INDEPENDENT TARGETING PROTEIN 3', 238607),
(296648, 'PTHR33657', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G00600)-RELATED', 238608),
(296649, 'PTHR33657:SF8', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G00600)-RELATED', 238608),
(296650, 'PTHR33657:SF6', NULL, NULL, NULL, NULL, 'SECRETED PROTEIN', 238608),
(296651, 'PTHR31412:SF2', NULL, NULL, NULL, NULL, 'ZINC METALLOPEPTIDASE EGY3, CHLOROPLASTIC-RELATED', 238609),
(296652, 'PTHR31412', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEASE EGY1', 238609),
(296653, 'PTHR31412:SF0', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEASE EGY1, CHLOROPLASTIC-RELATED', 238609),
(296654, 'PTHR31412:SF6', NULL, NULL, NULL, NULL, '', 238609),
(296655, 'PTHR31412:SF5', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEASE EGY2, CHLOROPLASTIC-RELATED', 238609),
(296656, 'PTHR24172', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 238610),
(296657, 'PTHR24172:SF4', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 238610),
(296658, 'PTHR48094:SF8', NULL, NULL, NULL, NULL, 'OS01G0217800 PROTEIN', 238611),
(296659, 'PTHR48094:SF24', NULL, NULL, NULL, NULL, 'GLUTATHIONE-INDEPENDENT GLYOXALASE HSP3101-RELATED', 238611),
(296660, 'PTHR48094:SF23', NULL, NULL, NULL, NULL, 'PROTEIN/NUCLEIC ACID DEGLYCASE 3', 238611),
(296661, 'PTHR48094:SF12', NULL, NULL, NULL, NULL, 'PARKINSON DISEASE PROTEIN 7 HOMOLOG', 238611),
(296662, 'PTHR48094:SF22', NULL, NULL, NULL, NULL, 'DJ-1_PFPI DOMAIN-CONTAINING PROTEIN', 238611);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(296663, 'PTHR48094:SF11', NULL, NULL, NULL, NULL, 'GLUTATHIONE-INDEPENDENT GLYOXALASE HSP31-RELATED', 238611),
(296664, 'PTHR48094:SF4', NULL, NULL, NULL, NULL, 'PROTEIN DJ-1 HOMOLOG A', 238611),
(296665, 'PTHR48094:SF21', NULL, NULL, NULL, NULL, 'BNAC03G78170D PROTEIN', 238611),
(296666, 'PTHR48094:SF10', NULL, NULL, NULL, NULL, 'MAILLARD DEGLYCASE', 238611),
(296667, 'PTHR48094:SF5', NULL, NULL, NULL, NULL, 'PROTEIN DJ-1 HOMOLOG', 238611),
(296668, 'PTHR48094:SF20', NULL, NULL, NULL, NULL, 'PROTEIN/NUCLEIC ACID DEGLYCASE 1', 238611),
(296669, 'PTHR48094:SF6', NULL, NULL, NULL, NULL, '', 238611),
(296670, 'PTHR48094:SF7', NULL, NULL, NULL, NULL, 'PROTEIN DJ-1 HOMOLOG C', 238611),
(296671, 'PTHR48094:SF19', NULL, NULL, NULL, NULL, 'DJ-1_PFPI DOMAIN-CONTAINING PROTEIN', 238611),
(296672, 'PTHR48094:SF18', NULL, NULL, NULL, NULL, 'GLUTAMINE AMIDOTRANSFERASE-LIKE CLASS 1 DOMAIN-CONTAINING PROTEIN 1', 238611),
(296673, 'PTHR48094:SF16', NULL, NULL, NULL, NULL, 'PARKINSON DISEASE PROTEIN 7', 238611),
(296674, 'PTHR48094:SF15', NULL, NULL, NULL, NULL, 'OS01G0217500 PROTEIN', 238611),
(296675, 'PTHR48094', NULL, NULL, NULL, NULL, 'PROTEIN/NUCLEIC ACID DEGLYCASE DJ-1-RELATED', 238611),
(296676, 'PTHR48094:SF3', NULL, NULL, NULL, NULL, 'GLUTATHIONE-INDEPENDENT GLYOXALASE DJR-1.2', 238611),
(296677, 'PTHR23039:SF5', NULL, NULL, NULL, NULL, 'NANCE-HORAN SYNDROME PROTEIN', 238612),
(296678, 'PTHR23039:SF3', NULL, NULL, NULL, NULL, 'NHS-LIKE PROTEIN 1', 238612),
(296679, 'PTHR23039:SF2', NULL, NULL, NULL, NULL, 'NHS-LIKE PROTEIN 2', 238612),
(296680, 'PTHR23039:SF10', NULL, NULL, NULL, NULL, 'NANCE-HORAN SYNDROME B (CONGENITAL CATARACTS AND DENTAL ANOMALIES)', 238612),
(296681, 'PTHR23039', NULL, NULL, NULL, NULL, 'NANCE-HORAN SYNDROME PROTEIN', 238612),
(296682, 'PTHR23039:SF9', NULL, NULL, NULL, NULL, '', 238612),
(296683, 'PTHR23039:SF6', NULL, NULL, NULL, NULL, 'SIMILAR TO MKIAA1522 PROTEIN', 238612),
(296684, 'PTHR46391:SF13', NULL, NULL, NULL, NULL, 'ACTIVATOR OF SPOMIN LUC3', 238613),
(296685, 'PTHR46391:SF24', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 238613),
(296686, 'PTHR46391:SF14', NULL, NULL, NULL, NULL, 'BZIP PROTEIN', 238613),
(296687, 'PTHR46391:SF26', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER 34', 238613),
(296688, 'PTHR46391:SF20', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER 61', 238613),
(296689, 'PTHR46391:SF31', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER 61-LIKE', 238613),
(296690, 'PTHR46391:SF32', NULL, NULL, NULL, NULL, 'BASIC-LEUCINE ZIPPER (BZIP) TRANSCRIPTION FACTOR FAMILY PROTEIN-RELATED', 238613),
(296691, 'PTHR46391:SF21', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 238613),
(296692, 'PTHR46391:SF11', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER 19-LIKE ISOFORM X1', 238613),
(296693, 'PTHR46391:SF33', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER 2', 238613),
(296694, 'PTHR46391:SF34', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER 61-LIKE', 238613),
(296695, 'PTHR46391:SF2', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER 6', 238613),
(296696, 'PTHR46391:SF3', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER 19', 238613),
(296697, 'PTHR46391:SF17', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER 19-LIKE', 238613),
(296698, 'PTHR46391:SF29', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER 61-LIKE', 238613),
(296699, 'PTHR46391:SF19', NULL, NULL, NULL, NULL, 'BASIC-LEUCINE ZIPPER DOMAIN-CONTAINING PROTEIN-RELATED', 238613),
(296700, 'PTHR46391', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER 34', 238613),
(296701, 'PTHR46391:SF30', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 238613),
(296702, 'PTHR47792:SF1', NULL, NULL, NULL, NULL, 'PROTEIN SOK2-RELATED', 238614),
(296703, 'PTHR47792', NULL, NULL, NULL, NULL, 'PROTEIN SOK2-RELATED', 238614),
(296704, 'PTHR12650:SF33', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S30', 238615),
(296705, 'PTHR12650:SF20', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 238615),
(296706, 'PTHR12650:SF30', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S30', 238615),
(296707, 'PTHR12650:SF15', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S30', 238615);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(296708, 'PTHR12650:SF35', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S30', 238615),
(296709, 'PTHR12650:SF34', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S30', 238615),
(296710, 'PTHR12650:SF28', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S30', 238615),
(296711, 'PTHR12650', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S30/UBIQUITIN-LIKE PROTEIN FUBI', 238615),
(296712, 'PTHR12184:SF1', NULL, NULL, NULL, NULL, 'UBIQUINOL-CYTOCHROME-C REDUCTASE COMPLEX ASSEMBLY FACTOR 1', 238616),
(296713, 'PTHR12184', NULL, NULL, NULL, NULL, 'UBIQUINOL-CYTOCHROME C REDUCTASE COMPLEX ASSEMBLY FACTOR 1 FAMILY MEMBER', 238616),
(296714, 'PTHR46169:SF9', NULL, NULL, NULL, NULL, 'SI:DKEYP-117B8.4', 238617),
(296715, 'PTHR46169:SF26', NULL, NULL, NULL, NULL, 'BED-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', 238617),
(296716, 'PTHR46169:SF15', NULL, NULL, NULL, NULL, 'DNA REPLICATION-RELATED ELEMENT FACTOR, ISOFORM A', 238617),
(296717, 'PTHR46169:SF25', NULL, NULL, NULL, NULL, 'SI:CH211-152F22.4-RELATED', 238617),
(296718, 'PTHR46169:SF2', NULL, NULL, NULL, NULL, 'E3 SUMO-PROTEIN LIGASE ZBED1', 238617),
(296719, 'PTHR46169:SF17', NULL, NULL, NULL, NULL, 'DBD_TNP_HERMES DOMAIN-CONTAINING PROTEIN', 238617),
(296720, 'PTHR46169', NULL, NULL, NULL, NULL, 'DNA REPLICATION-RELATED ELEMENT FACTOR, ISOFORM A', 238617),
(296721, 'PTHR46169:SF24', NULL, NULL, NULL, NULL, 'PROTEIN CBG26704', 238617),
(296722, 'PTHR46169:SF23', NULL, NULL, NULL, NULL, 'SIN3-HDAC COMPLEX-ASSOCIATED FACTOR,-LIKE-RELATED', 238617),
(296723, 'PTHR46169:SF12', NULL, NULL, NULL, NULL, 'ZINC FINGER BED DOMAIN-CONTAINING PROTEIN 3', 238617),
(296724, 'PTHR46248:SF6', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE-RELATED', 238618),
(296725, 'PTHR46248:SF4', NULL, NULL, NULL, NULL, 'LZIPPER-MIP1 DOMAIN-CONTAINING PROTEIN', 238618),
(296726, 'PTHR46248:SF17', NULL, NULL, NULL, NULL, 'TERNARY COMPLEX FACTOR MIP1, LEUCINE-ZIPPER-RELATED', 238618),
(296727, 'PTHR46248:SF16', NULL, NULL, NULL, NULL, 'BNAA08G15520D PROTEIN', 238618),
(296728, 'PTHR46248:SF18', NULL, NULL, NULL, NULL, '', 238618),
(296729, 'PTHR46248:SF12', NULL, NULL, NULL, NULL, 'TERNARY COMPLEX FACTOR MIP1, LEUCINE-ZIPPER-RELATED', 238618),
(296730, 'PTHR46248:SF9', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 238618),
(296731, 'PTHR46248:SF8', NULL, NULL, NULL, NULL, '', 238618),
(296732, 'PTHR46248:SF15', NULL, NULL, NULL, NULL, 'TERNARY COMPLEX FACTOR MIP1, LEUCINE-ZIPPER-RELATED', 238618),
(296733, 'PTHR46248', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 238618),
(296734, 'PTHR46248:SF14', NULL, NULL, NULL, NULL, 'DUF547 DOMAIN-CONTAINING PROTEIN', 238618),
(296735, 'PTHR38664:SF1', NULL, NULL, NULL, NULL, 'SLR0058 PROTEIN', 238619),
(296736, 'PTHR38664', NULL, NULL, NULL, NULL, 'SLR0058 PROTEIN', 238619),
(296737, 'PTHR40630:SF1', NULL, NULL, NULL, NULL, 'POSSIBLE DNA-BINDING PROTEIN', 238620),
(296738, 'PTHR40630', NULL, NULL, NULL, NULL, 'POSSIBLE DNA-BINDING PROTEIN', 238620),
(296739, 'PTHR11931:SF32', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE (2,3-DIPHOSPHOGLYCERATE-DEPENDENT)', 238621),
(296740, 'PTHR11931:SF31', NULL, NULL, NULL, NULL, '', 238621),
(296741, 'PTHR11931:SF30', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE', 238621),
(296742, 'PTHR11931:SF14', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE 4-RELATED', 238621),
(296743, 'PTHR11931:SF24', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE (2,3-DIPHOSPHOGLYCERATE-DEPENDENT)', 238621),
(296744, 'PTHR11931:SF35', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE (2,3-DIPHOSPHOGLYCERATE-DEPENDENT)', 238621),
(296745, 'PTHR11931:SF23', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE (2,3-DIPHOSPHOGLYCERATE-DEPENDENT)', 238621),
(296746, 'PTHR11931:SF34', NULL, NULL, NULL, NULL, '', 238621),
(296747, 'PTHR11931:SF11', NULL, NULL, NULL, NULL, 'BISPHOSPHOGLYCERATE MUTASE', 238621),
(296748, 'PTHR11931:SF33', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE', 238621),
(296749, 'PTHR11931:SF29', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE (2,3-DIPHOSPHOGLYCERATE-DEPENDENT)', 238621),
(296750, 'PTHR11931:SF27', NULL, NULL, NULL, NULL, '2,3-BISPHOSPHOGLYCERATE-DEPENDENT PHOSPHOGLYCERATE MUTASE 2', 238621);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(296751, 'PTHR11931:SF16', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE (2,3-DIPHOSPHOGLYCERATE-DEPENDENT)', 238621),
(296752, 'PTHR11931:SF15', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE 1', 238621),
(296753, 'PTHR11931:SF0', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE', 238621),
(296754, 'PTHR11931', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE', 238621),
(296755, 'PTHR11931:SF8', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE 2', 238621),
(296756, 'PTHR11931:SF9', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE 2-RELATED', 238621),
(296757, 'PTHR31003:SF40', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR HRS1', 238622),
(296758, 'PTHR31003:SF41', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 238622),
(296759, 'PTHR31003:SF30', NULL, NULL, NULL, NULL, 'MYB DOMAIN, PLANT, HOMEODOMAIN-LIKE PROTEIN-RELATED', 238622),
(296760, 'PTHR31003:SF3', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN-RELATED', 238622),
(296761, 'PTHR31003:SF22', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR HHO5', 238622),
(296762, 'PTHR31003:SF44', NULL, NULL, NULL, NULL, 'MYB-LIKE TRANSCRIPTION FACTOR FAMILY PROTEIN', 238622),
(296763, 'PTHR31003:SF45', NULL, NULL, NULL, NULL, 'MYB-LIKE DNA-BINDING DOMAIN, SHAQKYF CLASS FAMILY PROTEIN, EXPRESSED', 238622),
(296764, 'PTHR31003:SF23', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 238622),
(296765, 'PTHR31003:SF31', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 238622),
(296766, 'PTHR31003:SF20', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR HHO1', 238622),
(296767, 'PTHR31003:SF42', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 238622),
(296768, 'PTHR31003:SF21', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE-RELATED', 238622),
(296769, 'PTHR31003:SF16', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR HHO2', 238622),
(296770, 'PTHR31003:SF38', NULL, NULL, NULL, NULL, 'MYB DOMAIN, PLANT, HOMEODOMAIN-LIKE PROTEIN-RELATED', 238622),
(296771, 'PTHR31003:SF24', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR HHO3', 238622),
(296772, 'PTHR31003:SF46', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 238622),
(296773, 'PTHR31003:SF36', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 238622),
(296774, 'PTHR31003:SF25', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 238622),
(296775, 'PTHR31003:SF19', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR EFM', 238622),
(296776, 'PTHR31003:SF28', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 238622),
(296777, 'PTHR31003:SF39', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 238622),
(296778, 'PTHR31003:SF17', NULL, NULL, NULL, NULL, 'OS07G0119300 PROTEIN', 238622),
(296779, 'PTHR31003', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR', 238622),
(296780, 'PTHR34941:SF1', NULL, NULL, NULL, NULL, 'DEHYDRIN HIRD11', 238623),
(296781, 'PTHR34941', NULL, NULL, NULL, NULL, 'DEHYDRIN HIRD11', 238623),
(296782, 'PTHR34941:SF4', NULL, NULL, NULL, NULL, 'PROTEIN SRC1', 238623),
(296783, 'PTHR28384', NULL, NULL, NULL, NULL, 'PROGRESSIVE ANKYLOSIS PROTEIN HOMOLOG', 238624),
(296784, 'PTHR28384:SF1', NULL, NULL, NULL, NULL, 'PROGRESSIVE ANKYLOSIS PROTEIN HOMOLOG', 238624),
(296785, 'PTHR10388:SF57', NULL, NULL, NULL, NULL, 'PROTEIN TRANSLATION FACTOR SUI1 HOMOLOG 2', 238625),
(296786, 'PTHR10388:SF58', NULL, NULL, NULL, NULL, 'OS05G0498400 PROTEIN', 238625),
(296787, 'PTHR10388:SF15', NULL, NULL, NULL, NULL, 'APO PROTEIN 2, CHLOROPLASTIC', 238625),
(296788, 'PTHR10388:SF50', NULL, NULL, NULL, NULL, 'APO PROTEIN 3, MITOCHONDRIAL-LIKE', 238625),
(296789, 'PTHR10388:SF73', NULL, NULL, NULL, NULL, 'SUI1 DOMAIN-CONTAINING PROTEIN', 238625),
(296790, 'PTHR10388:SF51', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 1B', 238625),
(296791, 'PTHR10388:SF53', NULL, NULL, NULL, NULL, 'APO PROTEIN 1, CHLOROPLASTIC', 238625),
(296792, 'PTHR10388:SF75', NULL, NULL, NULL, NULL, 'SUI1 DOMAIN-CONTAINING PROTEIN', 238625),
(296793, 'PTHR10388:SF54', NULL, NULL, NULL, NULL, 'SUI1 DOMAIN-CONTAINING PROTEIN', 238625); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(296794, 'PTHR10388:SF10', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 1', 238625),
(296795, 'PTHR10388:SF77', NULL, NULL, NULL, NULL, 'PROTEIN TRANSLATION FACTOR SUI1 HOMOLOG 2-LIKE', 238625),
(296796, 'PTHR10388:SF55', NULL, NULL, NULL, NULL, 'PROTEIN TRANSLATION FACTOR SUI1 HOMOLOG 1', 238625),
(296797, 'PTHR10388:SF80', NULL, NULL, NULL, NULL, 'SUI1 DOMAIN-CONTAINING PROTEIN', 238625),
(296798, 'PTHR10388', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR SUI1', 238625),
(296799, 'PTHR10388:SF67', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR SUI1', 238625),
(296800, 'PTHR10388:SF69', NULL, NULL, NULL, NULL, 'SUI1 DOMAIN-CONTAINING PROTEIN', 238625),
(296801, 'PTHR10388:SF48', NULL, NULL, NULL, NULL, 'APO PROTEIN 3, MITOCHONDRIAL', 238625),
(296802, 'PTHR10388:SF81', NULL, NULL, NULL, NULL, 'OS01G0794500 PROTEIN', 238625),
(296803, 'PTHR10388:SF82', NULL, NULL, NULL, NULL, 'PROTEIN TRANSLATION FACTOR SUI1 HOMOLOG ISOFORM X1', 238625),
(296804, 'PTHR10388:SF4', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR EIF1', 238625),
(296805, 'PTHR10388:SF83', NULL, NULL, NULL, NULL, 'GOS2-LIKE PROTEIN', 238625),
(296806, 'PTHR10388:SF84', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR SUI1', 238625),
(296807, 'PTHR10388:SF20', NULL, NULL, NULL, NULL, 'APO PROTEIN 4, MITOCHONDRIAL', 238625),
(296808, 'PTHR10388:SF64', NULL, NULL, NULL, NULL, 'SUI1 DOMAIN-CONTAINING PROTEIN', 238625),
(296809, 'PTHR10388:SF43', NULL, NULL, NULL, NULL, 'SUI1 DOMAIN-CONTAINING PROTEIN', 238625),
(296810, 'PTHR10388:SF65', NULL, NULL, NULL, NULL, 'SUI1 DOMAIN-CONTAINING PROTEIN', 238625),
(296811, 'PTHR43373', NULL, NULL, NULL, NULL, 'NA(+)/H(+) ANTIPORTER SUBUNIT', 238626),
(296812, 'PTHR43373:SF1', NULL, NULL, NULL, NULL, 'NA(+)/H(+) ANTIPORTER SUBUNIT A', 238626),
(296813, 'PTHR32092', NULL, NULL, NULL, NULL, '6-PHOSPHO-BETA-GLUCOSIDASE-RELATED', 238627),
(296814, 'PTHR32092:SF6', NULL, NULL, NULL, NULL, 'ALPHA-GALACTOSIDASE', 238627),
(296815, 'PTHR32092:SF5', NULL, NULL, NULL, NULL, '6-PHOSPHO-BETA-GLUCOSIDASE', 238627),
(296816, 'PTHR32092:SF2', NULL, NULL, NULL, NULL, 'ALPHA-GALACTURONIDASE', 238627),
(296817, 'PTHR32092:SF4', NULL, NULL, NULL, NULL, 'ALPHA-GLUCOSIDASE', 238627),
(296818, 'PTHR32092:SF14', NULL, NULL, NULL, NULL, 'MALTOSE-6''-PHOSPHATE GLUCOSIDASE', 238627),
(296819, 'PTHR32092:SF3', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 238627),
(296820, 'PTHR47187', NULL, NULL, NULL, NULL, 'NFATC2-INTERACTING PROTEIN', 238628),
(296821, 'PTHR47187:SF1', NULL, NULL, NULL, NULL, 'NFATC2-INTERACTING PROTEIN', 238628),
(296822, 'PTHR14753:SF3', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 38', 238629),
(296823, 'PTHR14753', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 38', 238629),
(296824, 'PTHR37897:SF1', NULL, NULL, NULL, NULL, 'VARLMGL DOMAIN-CONTAINING PROTEIN', 238630),
(296825, 'PTHR37897', NULL, NULL, NULL, NULL, 'DNAK FAMILY PROTEIN', 238630),
(296826, 'PTHR42705', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL NON-HOMOLOGOUS END JOINING PROTEIN LIGD', 238631),
(296827, 'PTHR42705:SF3', NULL, NULL, NULL, NULL, '', 238631),
(296828, 'PTHR42705:SF2', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL NON-HOMOLOGOUS END JOINING PROTEIN LIGD', 238631),
(296829, 'PTHR37941', NULL, NULL, NULL, NULL, 'FUMARASE E-RELATED', 238632),
(296830, 'PTHR37941:SF1', NULL, NULL, NULL, NULL, 'FUMARASE E-RELATED', 238632),
(296831, 'PTHR13231:SF3', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S31, MITOCHONDRIAL', 238633),
(296832, 'PTHR13231', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOMAL PROTEIN S31', 238633),
(296833, 'PTHR43443:SF1', NULL, NULL, NULL, NULL, '3-HEXULOSE-6-PHOSPHATE ISOMERASE', 238634),
(296834, 'PTHR43443', NULL, NULL, NULL, NULL, '3-HEXULOSE-6-PHOSPHATE ISOMERASE', 238634),
(296835, 'PTHR17039:SF1', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RIBONUCLEOPROTEIN PROTEIN MPP10', 238635),
(296836, 'PTHR17039:SF0', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RIBONUCLEOPROTEIN PROTEIN MPP10', 238635),
(296837, 'PTHR17039', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RIBONUCLEOPROTEIN PROTEIN MPP10', 238635);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(296838, 'PTHR39517', NULL, NULL, NULL, NULL, 'SLL0192 PROTEIN', 238636),
(296839, 'PTHR39517:SF1', NULL, NULL, NULL, NULL, 'SLL0192 PROTEIN', 238636),
(296840, 'PTHR16246:SF2', NULL, NULL, NULL, NULL, 'HOST CELL FACTOR C1 REGULATOR 1', 238637),
(296841, 'PTHR16246', NULL, NULL, NULL, NULL, 'HOST CELL FACTOR C1 REGULATOR 1', 238637),
(296842, 'PTHR33493:SF2', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN 46', 238638),
(296843, 'PTHR33493:SF30', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN', 238638),
(296844, 'PTHR33493:SF3', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN, LEA-25/LEA-D113-RELATED', 238638),
(296845, 'PTHR33493:SF31', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN D-113', 238638),
(296846, 'PTHR33493:SF21', NULL, NULL, NULL, NULL, '', 238638),
(296847, 'PTHR33493:SF32', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN 18', 238638),
(296848, 'PTHR33493:SF33', NULL, NULL, NULL, NULL, 'OS09G0278000 PROTEIN', 238638),
(296849, 'PTHR33493:SF22', NULL, NULL, NULL, NULL, 'BNAA08G30040D PROTEIN', 238638),
(296850, 'PTHR33493:SF12', NULL, NULL, NULL, NULL, '', 238638),
(296851, 'PTHR33493:SF24', NULL, NULL, NULL, NULL, '18 KDA SEED MATURATION PROTEIN-LIKE', 238638),
(296852, 'PTHR33493:SF6', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN 6', 238638),
(296853, 'PTHR33493:SF7', NULL, NULL, NULL, NULL, 'OS04G0589800 PROTEIN', 238638),
(296854, 'PTHR33493:SF25', NULL, NULL, NULL, NULL, '', 238638),
(296855, 'PTHR33493:SF15', NULL, NULL, NULL, NULL, '', 238638),
(296856, 'PTHR33493:SF26', NULL, NULL, NULL, NULL, '', 238638),
(296857, 'PTHR33493', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN 6-RELATED', 238638),
(296858, 'PTHR33493:SF16', NULL, NULL, NULL, NULL, '', 238638),
(296859, 'PTHR33493:SF28', NULL, NULL, NULL, NULL, '18 KDA SEED MATURATION PROTEIN-LIKE', 238638),
(296860, 'PTHR33493:SF29', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN', 238638),
(296861, 'PTHR33493:SF18', NULL, NULL, NULL, NULL, 'OS06G0324400 PROTEIN', 238638),
(296862, 'PTHR35658', NULL, NULL, NULL, NULL, 'RCG58666, ISOFORM CRA_A', 238639),
(296863, 'PTHR35658:SF1', NULL, NULL, NULL, NULL, 'RCG58666, ISOFORM CRA_A', 238639),
(296864, 'PTHR42509:SF1', NULL, NULL, NULL, NULL, 'DIX DOMAIN-CONTAINING PROTEIN', 238640),
(296865, 'PTHR42509', NULL, NULL, NULL, NULL, 'DIX DOMAIN-CONTAINING PROTEIN', 238640),
(296866, 'PTHR35729', NULL, NULL, NULL, NULL, 'T1B9.12 PROTEIN', 238641),
(296867, 'PTHR35729:SF4', NULL, NULL, NULL, NULL, 'PEPTIDASE S1, PA CLAN-RELATED', 238641),
(296868, 'PTHR35729:SF5', NULL, NULL, NULL, NULL, '', 238641),
(296869, 'PTHR35729:SF2', NULL, NULL, NULL, NULL, 'OS08G0528800 PROTEIN', 238641),
(296870, 'PTHR35729:SF1', NULL, NULL, NULL, NULL, 'T1B9.12 PROTEIN', 238641),
(296871, 'PTHR46142:SF3', NULL, NULL, NULL, NULL, 'F18B13.24 PROTEIN', 238642),
(296872, 'PTHR46142:SF4', NULL, NULL, NULL, NULL, 'OS04G0538900 PROTEIN', 238642),
(296873, 'PTHR46142:SF23', NULL, NULL, NULL, NULL, 'GLYOXALASE/BLEOMYCIN RESISTANCE PROTEIN/DIHYDROXYBIPHENYL DIOXYGENASE-RELATED', 238642),
(296874, 'PTHR46142:SF12', NULL, NULL, NULL, NULL, 'VOC DOMAIN-CONTAINING PROTEIN', 238642),
(296875, 'PTHR46142:SF22', NULL, NULL, NULL, NULL, 'VIRULENCE PROTEIN STM3117-LIKE', 238642),
(296876, 'PTHR46142:SF11', NULL, NULL, NULL, NULL, 'VOC DOMAIN-CONTAINING PROTEIN', 238642),
(296877, 'PTHR46142:SF10', NULL, NULL, NULL, NULL, 'OS01G0173600 PROTEIN', 238642),
(296878, 'PTHR46142:SF20', NULL, NULL, NULL, NULL, 'LACTOYLGLUTATHIONE LYASE', 238642),
(296879, 'PTHR46142:SF8', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 238642),
(296880, 'PTHR46142:SF9', NULL, NULL, NULL, NULL, 'VOC DOMAIN-CONTAINING PROTEIN', 238642),
(296881, 'PTHR46142:SF18', NULL, NULL, NULL, NULL, 'VOC DOMAIN-CONTAINING PROTEIN', 238642),
(296882, 'PTHR46142:SF16', NULL, NULL, NULL, NULL, 'VOC DOMAIN-CONTAINING PROTEIN', 238642),
(296883, 'PTHR46142', NULL, NULL, NULL, NULL, '', 238642),
(296884, 'PTHR46142:SF14', NULL, NULL, NULL, NULL, 'VOC DOMAIN-CONTAINING PROTEIN', 238642); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(296885, 'PTHR46142:SF13', NULL, NULL, NULL, NULL, 'LACTOYLGLUTATHIONE LYASE/GLYOXALASE I FAMILY PROTEIN', 238642),
(296886, 'PTHR39579:SF1', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YHCB', 238643),
(296887, 'PTHR39579', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YHCB', 238643),
(296888, 'PTHR10383:SF60', NULL, NULL, NULL, NULL, 'OS03G0454100 PROTEIN', 238644),
(296889, 'PTHR10383:SF61', NULL, NULL, NULL, NULL, 'SERINE INCORPORATOR 2', 238644),
(296890, 'PTHR10383:SF62', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 238644),
(296891, 'PTHR10383:SF51', NULL, NULL, NULL, NULL, 'SERINE INCORPORATOR 3', 238644),
(296892, 'PTHR10383:SF53', NULL, NULL, NULL, NULL, 'SERINC-DOMAIN CONTAINING SERINE AND SPHINGOLIPID BIOSYNTHESIS PROTEIN', 238644),
(296893, 'PTHR10383:SF54', NULL, NULL, NULL, NULL, 'SERINC-DOMAIN CONTAINING SERINE AND SPHINGOLIPID BIOSYNTHESIS PROTEIN', 238644),
(296894, 'PTHR10383:SF44', NULL, NULL, NULL, NULL, 'SERINC-DOMAIN CONTAINING SERINE AND SPHINGOLIPID BIOSYNTHESIS PROTEIN', 238644),
(296895, 'PTHR10383:SF22', NULL, NULL, NULL, NULL, 'SERINE INCORPORATOR 2', 238644),
(296896, 'PTHR10383:SF23', NULL, NULL, NULL, NULL, 'SERINC-DOMAIN CONTAINING SERINE AND SPHINGOLIPID BIOSYNTHESIS PROTEIN', 238644),
(296897, 'PTHR10383:SF46', NULL, NULL, NULL, NULL, 'SERINE INCORPORATOR/TMS MEMBRANE PROTEIN-RELATED', 238644),
(296898, 'PTHR10383:SF58', NULL, NULL, NULL, NULL, '', 238644),
(296899, 'PTHR10383:SF48', NULL, NULL, NULL, NULL, '', 238644),
(296900, 'PTHR10383:SF9', NULL, NULL, NULL, NULL, 'TMS1, ISOFORM F', 238644),
(296901, 'PTHR10383:SF15', NULL, NULL, NULL, NULL, 'SERINE INCORPORATOR 1', 238644),
(296902, 'PTHR10383:SF49', NULL, NULL, NULL, NULL, 'SERINC-DOMAIN CONTAINING SERINE AND SPHINGOLIPID BIOSYNTHESIS PROTEIN-RELATED', 238644),
(296903, 'PTHR10383:SF16', NULL, NULL, NULL, NULL, 'SERINE INCORPORATOR 5', 238644),
(296904, 'PTHR10383:SF19', NULL, NULL, NULL, NULL, 'PROTEIN CBG04578', 238644),
(296905, 'PTHR10383:SF5', NULL, NULL, NULL, NULL, 'SERINE INCORPORATOR 4', 238644),
(296906, 'PTHR10383', NULL, NULL, NULL, NULL, 'SERINE INCORPORATOR', 238644),
(296907, 'PTHR24317', NULL, NULL, NULL, NULL, 'PEROXISOMAL TRANS-2-ENOYL-COA REDUCTASE', 238645),
(296908, 'PTHR24317:SF7', NULL, NULL, NULL, NULL, 'PEROXISOMAL TRANS-2-ENOYL-COA REDUCTASE', 238645),
(296909, 'PTHR39136:SF1', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN 11', 238646),
(296910, 'PTHR39136', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN 11', 238646),
(296911, 'PTHR37211', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 238647),
(296912, 'PTHR37211:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 238647),
(296913, 'PTHR12728:SF1', NULL, NULL, NULL, NULL, 'RIBOSOME PRODUCTION FACTOR 2 HOMOLOG', 238648),
(296914, 'PTHR12728', NULL, NULL, NULL, NULL, 'BRIX DOMAIN CONTAINING PROTEIN', 238648),
(296915, 'PTHR12728:SF0', NULL, NULL, NULL, NULL, 'RIBOSOME PRODUCTION FACTOR 2 HOMOLOG', 238648),
(296916, 'PTHR47600:SF1', NULL, NULL, NULL, NULL, 'NUCLEIC ACID-BINDING, OB-FOLD-LIKE PROTEIN', 238649),
(296917, 'PTHR47600', NULL, NULL, NULL, NULL, 'NUCLEIC ACID-BINDING, OB-FOLD-LIKE PROTEIN', 238649),
(296918, 'PTHR47600:SF2', NULL, NULL, NULL, NULL, 'POLYRIBONUCLEOTIDE NUCLEOTIDYLTRANSFERASE-RELATED', 238649),
(296919, 'PTHR37710:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 238650),
(296920, 'PTHR37710', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 238650),
(296921, 'PTHR16477:SF4', NULL, NULL, NULL, NULL, 'SI:CH211-127N13.2-RELATED', 238651),
(296922, 'PTHR16477:SF2', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 106', 238651),
(296923, 'PTHR16477:SF3', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING 106A-RELATED', 238651),
(296924, 'PTHR16477', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 106', 238651),
(296925, 'PTHR23405:SF4', NULL, NULL, NULL, NULL, 'PROTEIN MAK16 HOMOLOG', 238652),
(296926, 'PTHR23405:SF5', NULL, NULL, NULL, NULL, 'THO COMPLEX SUBUNIT 7 HOMOLOG', 238652),
(296927, 'PTHR23405:SF11', NULL, NULL, NULL, NULL, 'PROTEIN MAK16 HOMOLOG', 238652);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(296928, 'PTHR23405:SF8', NULL, NULL, NULL, NULL, 'BNAC01G31980D PROTEIN', 238652),
(296929, 'PTHR23405', NULL, NULL, NULL, NULL, 'MAINTENANCE OF KILLER 16  MAK16  PROTEIN-RELATED', 238652),
(296930, 'PTHR23405:SF14', NULL, NULL, NULL, NULL, 'PROTEIN MAK16 HOMOLOG', 238652),
(296931, 'PTHR23405:SF9', NULL, NULL, NULL, NULL, 'PROTEIN MAK16 HOMOLOG', 238652),
(296932, 'PTHR23405:SF15', NULL, NULL, NULL, NULL, 'THO COMPLEX SUBUNIT 7A-LIKE', 238652),
(296933, 'PTHR23405:SF16', NULL, NULL, NULL, NULL, 'PROTEIN MAK16 HOMOLOG', 238652),
(296934, 'PTHR45910', NULL, NULL, NULL, NULL, 'N-ALPHA-ACETYLTRANSFERASE 20', 238653),
(296935, 'PTHR45910:SF2', NULL, NULL, NULL, NULL, 'RRN9 DOMAIN-CONTAINING PROTEIN', 238653),
(296936, 'PTHR45910:SF1', NULL, NULL, NULL, NULL, 'N-ALPHA-ACETYLTRANSFERASE 20', 238653),
(296937, 'PTHR39405:SF1', NULL, NULL, NULL, NULL, 'DSC E3 UBIQUITIN LIGASE COMPLEX SUBUNIT 4', 238654),
(296938, 'PTHR39405', NULL, NULL, NULL, NULL, 'DSC E3 UBIQUITIN LIGASE COMPLEX SUBUNIT 4', 238654),
(296939, 'PTHR31935:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 13', 238655),
(296940, 'PTHR31935', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 13', 238655),
(296941, 'PTHR33873:SF7', NULL, NULL, NULL, NULL, '', 238656),
(296942, 'PTHR33873:SF9', NULL, NULL, NULL, NULL, 'BNAC03G58740D PROTEIN', 238656),
(296943, 'PTHR33873:SF3', NULL, NULL, NULL, NULL, 'OS05G0515700 PROTEIN', 238656),
(296944, 'PTHR33873:SF12', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR VOZ1', 238656),
(296945, 'PTHR33873:SF13', NULL, NULL, NULL, NULL, 'BNAC04G48260D PROTEIN', 238656),
(296946, 'PTHR33873:SF4', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR VOZ2', 238656),
(296947, 'PTHR33873', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR VOZ1', 238656),
(296948, 'PTHR33873:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR VOZ1', 238656),
(296949, 'PTHR39324:SF1', NULL, NULL, NULL, NULL, 'CALCIUM DODECIN', 238657),
(296950, 'PTHR39324', NULL, NULL, NULL, NULL, 'CALCIUM DODECIN', 238657),
(296951, 'PTHR32027', NULL, NULL, NULL, NULL, 'CYTOSINE DEAMINASE', 238658),
(296952, 'PTHR32027:SF9', NULL, NULL, NULL, NULL, 'BLL3847 PROTEIN', 238658),
(296953, 'PTHR32027:SF0', NULL, NULL, NULL, NULL, 'CYTOSINE DEAMINASE', 238658),
(296954, 'PTHR46559', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE NON-RECEPTOR TYPE 11', 238659),
(296955, 'PTHR46559:SF4', NULL, NULL, NULL, NULL, '', 238659),
(296956, 'PTHR46559:SF5', NULL, NULL, NULL, NULL, '', 238659),
(296957, 'PTHR46559:SF6', NULL, NULL, NULL, NULL, '', 238659),
(296958, 'PTHR46559:SF1', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE NON-RECEPTOR TYPE 11', 238659),
(296959, 'PTHR46559:SF2', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE-PHOSPHATASE', 238659),
(296960, 'PTHR46559:SF3', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE NON-RECEPTOR TYPE', 238659),
(296961, 'PTHR33054:SF11', NULL, NULL, NULL, NULL, '', 238660),
(296962, 'PTHR33054:SF10', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 238660),
(296963, 'PTHR33054:SF9', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 238660),
(296964, 'PTHR33054', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 238660),
(296965, 'PTHR30268:SF0', NULL, NULL, NULL, NULL, 'L-RHAMNOSE ISOMERASE', 238661),
(296966, 'PTHR30268', NULL, NULL, NULL, NULL, 'L-RHAMNOSE ISOMERASE', 238661),
(296967, 'PTHR16105:SF6', NULL, NULL, NULL, NULL, 'RNA-BINDING REGION-CONTAINING PROTEIN 3', 238662),
(296968, 'PTHR16105:SF2', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 41', 238662),
(296969, 'PTHR16105:SF5', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 238662),
(296970, 'PTHR16105:SF0', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 238662),
(296971, 'PTHR16105', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 238662),
(296972, 'PTHR11843:SF0', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S12', 238663),
(296973, 'PTHR11843:SF30', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S12', 238663),
(296974, 'PTHR11843:SF21', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S12', 238663);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(296975, 'PTHR11843:SF20', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S12', 238663),
(296976, 'PTHR11843', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S12', 238663),
(296977, 'PTHR11843:SF12', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S12', 238663),
(296978, 'PTHR11843:SF34', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S12', 238663),
(296979, 'PTHR11843:SF11', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S12', 238663),
(296980, 'PTHR11843:SF22', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S12', 238663),
(296981, 'PTHR11843:SF33', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S12', 238663),
(296982, 'PTHR11843:SF36', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S12', 238663),
(296983, 'PTHR11843:SF24', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L7AE DOMAIN-CONTAINING PROTEIN', 238663),
(296984, 'PTHR11843:SF35', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S12', 238663),
(296985, 'PTHR11843:SF16', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S12', 238663),
(296986, 'PTHR11843:SF15', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S12', 238663),
(296987, 'PTHR11843:SF19', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S12', 238663),
(296988, 'PTHR14819', NULL, NULL, NULL, NULL, 'GTP-BINDING', 238664),
(296989, 'PTHR14819:SF5', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED VERY LARGE GTPASE 1', 238664),
(296990, 'PTHR14819:SF7', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 238664),
(296991, 'PTHR36128:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 117', 238665),
(296992, 'PTHR36128', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 117', 238665),
(296993, 'PTHR33603', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 238666),
(296994, 'PTHR33603:SF1', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA LARGE SUBUNIT METHYLTRANSFERASE H', 238666),
(296995, 'PTHR14552:SF25', NULL, NULL, NULL, NULL, 'DCTP PYROPHOSPHATASE 1', 238667),
(296996, 'PTHR14552:SF24', NULL, NULL, NULL, NULL, 'DCTP PYROPHOSPHATASE 1', 238667),
(296997, 'PTHR14552:SF2', NULL, NULL, NULL, NULL, 'DCTP PYROPHOSPHATASE 1', 238667),
(296998, 'PTHR14552:SF21', NULL, NULL, NULL, NULL, 'DCTP PYROPHOSPHATASE 1', 238667),
(296999, 'PTHR14552:SF27', NULL, NULL, NULL, NULL, 'DCTP PYROPHOSPHATASE 1-LIKE ISOFORM X1', 238667),
(297000, 'PTHR14552:SF26', NULL, NULL, NULL, NULL, 'DCTP PYROPHOSPHATASE 1', 238667),
(297001, 'PTHR14552', NULL, NULL, NULL, NULL, '', 238667),
(297002, 'PTHR43396:SF6', NULL, NULL, NULL, NULL, 'GLOBIN DOMAIN-CONTAINING PROTEIN', 238668),
(297003, 'PTHR43396:SF8', NULL, NULL, NULL, NULL, 'NITRIC OXIDE DIOXYGENASE', 238668),
(297004, 'PTHR43396:SF3', NULL, NULL, NULL, NULL, 'FLAVOHEMOPROTEIN', 238668),
(297005, 'PTHR43396:SF1', NULL, NULL, NULL, NULL, 'FLAVOHEMOPROTEIN B', 238668),
(297006, 'PTHR43396', NULL, NULL, NULL, NULL, 'FLAVOHEMOPROTEIN', 238668),
(297007, 'PTHR25952:SF250', NULL, NULL, NULL, NULL, 'DUF1725 DOMAIN-CONTAINING PROTEIN', 238669),
(297008, 'PTHR25952:SF252', NULL, NULL, NULL, NULL, 'GENE, 17555-RELATED', 238669),
(297009, 'PTHR25952:SF251', NULL, NULL, NULL, NULL, 'SI:DKEY-266F7.10', 238669),
(297010, 'PTHR25952', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 238669),
(297011, 'PTHR25952:SF247', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 238669),
(297012, 'PTHR25952:SF246', NULL, NULL, NULL, NULL, 'LINE-1 RETROTRANSPOSABLE ELEMENT ORF2 PROTEIN', 238669),
(297013, 'PTHR25952:SF249', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 238669),
(297014, 'PTHR25952:SF199', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 238669),
(297015, 'PTHR25952:SF234', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 238669),
(297016, 'PTHR33963', NULL, NULL, NULL, NULL, 'MKRN2 OPPOSITE STRAND PROTEIN', 238670),
(297017, 'PTHR33963:SF2', NULL, NULL, NULL, NULL, 'MKRN2 OPPOSITE STRAND PROTEIN', 238670),
(297018, 'PTHR15725:SF0', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 34', 238671);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(297019, 'PTHR15725:SF18', NULL, NULL, NULL, NULL, 'ZINC FINGER, CCCH-TYPE-RELATED', 238671),
(297020, 'PTHR15725:SF17', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 17-LIKE', 238671),
(297021, 'PTHR15725', NULL, NULL, NULL, NULL, 'ZN-FINGER, C-X8-C-X5-C-X3-H TYPE-CONTAINING', 238671),
(297022, 'PTHR15725:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 11A', 238671),
(297023, 'PTHR15725:SF1', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1700017N19 GENE', 238671),
(297024, 'PTHR15725:SF14', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH-TYPE-CONTAINING 11A', 238671),
(297025, 'PTHR15725:SF13', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 11B', 238671),
(297026, 'PTHR15725:SF20', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 32', 238671),
(297027, 'PTHR21583', NULL, NULL, NULL, NULL, 'ELYS PROTEIN', 238672),
(297028, 'PTHR21583:SF8', NULL, NULL, NULL, NULL, 'PROTEIN ELYS', 238672),
(297029, 'PTHR38429:SF1', NULL, NULL, NULL, NULL, 'SEPTATION PROTEIN SPOVG-RELATED', 238673),
(297030, 'PTHR38429', NULL, NULL, NULL, NULL, 'SEPTATION PROTEIN SPOVG-RELATED', 238673),
(297031, 'PTHR12191:SF22', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER ZIP6', 238674),
(297032, 'PTHR12191:SF32', NULL, NULL, NULL, NULL, 'ZRT (ZRT), IRT-(IRT-) LIKE PROTEIN TRANSPORTER', 238674),
(297033, 'PTHR12191:SF21', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER ZIP4', 238674),
(297034, 'PTHR12191:SF31', NULL, NULL, NULL, NULL, 'IP18018P', 238674),
(297035, 'PTHR12191:SF2', NULL, NULL, NULL, NULL, 'METAL CATION SYMPORTER ZIP8', 238674),
(297036, 'PTHR12191:SF30', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER FOI', 238674),
(297037, 'PTHR12191:SF36', NULL, NULL, NULL, NULL, 'ZRT (ZRT), IRT-(IRT-) LIKE PROTEIN TRANSPORTER', 238674),
(297038, 'PTHR12191:SF14', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER ZIP10', 238674),
(297039, 'PTHR12191', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 39', 238674),
(297040, 'PTHR12191:SF17', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER ZIP5', 238674),
(297041, 'PTHR12191:SF4', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER ZIP12', 238674),
(297042, 'PTHR12191:SF5', NULL, NULL, NULL, NULL, 'METAL CATION SYMPORTER ZIP14', 238674),
(297043, 'PTHR15052:SF2', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR 3C POLYPEPTIDE 2', 238675),
(297044, 'PTHR15052:SF3', NULL, NULL, NULL, NULL, '', 238675),
(297045, 'PTHR15052', NULL, NULL, NULL, NULL, 'RNA POLYMERASE III TRANSCRIPTION INITIATION FACTOR COMPLEX SUBUNIT', 238675),
(297046, 'PTHR15052:SF4', NULL, NULL, NULL, NULL, 'BNAA06G13690D PROTEIN', 238675),
(297047, 'PTHR37376:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 238676),
(297048, 'PTHR37376:SF4', NULL, NULL, NULL, NULL, '', 238676),
(297049, 'PTHR37376:SF10', NULL, NULL, NULL, NULL, 'ACTIN ASSOCIATED PROTEIN', 238676),
(297050, 'PTHR37376', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 238676),
(297051, 'PTHR37376:SF6', NULL, NULL, NULL, NULL, 'BNACNNG30510D PROTEIN', 238676),
(297052, 'PTHR37376:SF7', NULL, NULL, NULL, NULL, '', 238676),
(297053, 'PTHR37376:SF8', NULL, NULL, NULL, NULL, '', 238676),
(297054, 'PTHR15905', NULL, NULL, NULL, NULL, 'GOLGI-ASSOCIATED KINASE 1B-RELATED', 238677),
(297055, 'PTHR15905:SF5', NULL, NULL, NULL, NULL, 'GOLGI-ASSOCIATED KINASE 1A', 238677),
(297056, 'PTHR15905:SF1', NULL, NULL, NULL, NULL, 'GOLGI-ASSOCIATED KINASE 1B', 238677),
(297057, 'PTHR46779', NULL, NULL, NULL, NULL, 'BETA-1,6-GALACTOSYLTRANSFERASE GALT29A', 238678),
(297058, 'PTHR46779:SF2', NULL, NULL, NULL, NULL, 'SIALYLTRANSFERASE-LIKE PROTEIN 2', 238678),
(297059, 'PTHR46779:SF3', NULL, NULL, NULL, NULL, 'SIALYLTRANSFERASE-LIKE PROTEIN 3', 238678),
(297060, 'PTHR46779:SF1', NULL, NULL, NULL, NULL, 'BETA-1,6-GALACTOSYLTRANSFERASE GALT29A', 238678),
(297061, 'PTHR46779:SF6', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE FAMILY 29-RELATED', 238678),
(297062, 'PTHR46779:SF5', NULL, NULL, NULL, NULL, 'BETA-16-GALACTOSYLTRANSFERASE GALT29A', 238678),
(297063, 'PTHR22633:SF2', NULL, NULL, NULL, NULL, 'NEURONAL TYROSINE-PHOSPHORYLATED PHOSPHOINOSITIDE-3-KINASE ADAPTER 1', 238679);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(297064, 'PTHR22633:SF1', NULL, NULL, NULL, NULL, 'NEURONAL TYROSINE-PHOSPHORYLATED PHOSPHOINOSITIDE-3-KINASE ADAPTER 2', 238679),
(297065, 'PTHR22633', NULL, NULL, NULL, NULL, 'NEURONAL TYROSINE-PHOSPHORYLATED PHOSPHOINOSITIDE-3-KINASE ADAPTER 2-RELATED', 238679),
(297066, 'PTHR48128:SF1', NULL, NULL, NULL, NULL, 'REPELLENT PROTEIN 1', 238680),
(297067, 'PTHR48128', NULL, NULL, NULL, NULL, 'REPELLENT PROTEIN 1', 238680),
(297068, 'PTHR42933:SF3', NULL, NULL, NULL, NULL, 'SITE-SPECIFIC DNA-METHYLTRANSFERASE (ADENINE-SPECIFIC)', 238681),
(297069, 'PTHR42933', NULL, NULL, NULL, NULL, 'SLR6095 PROTEIN', 238681),
(297070, 'PTHR42933:SF1', NULL, NULL, NULL, NULL, 'SITE-SPECIFIC DNA-METHYLTRANSFERASE (ADENINE-SPECIFIC)', 238681),
(297071, 'PTHR42933:SF4', NULL, NULL, NULL, NULL, 'TYPE I RESTRICTION ENZYME ECOKI M PROTEIN', 238681),
(297072, 'PTHR13610:SF9', NULL, NULL, NULL, NULL, 'FI06469P', 238682),
(297073, 'PTHR13610:SF8', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT C LYSINE N-METHYLTRANSFERASE', 238682),
(297074, 'PTHR13610:SF19', NULL, NULL, NULL, NULL, 'PROTEIN L11 METHYLTRANSFERASE, PUTATIVE-RELATED', 238682),
(297075, 'PTHR13610', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 238682),
(297076, 'PTHR13610:SF18', NULL, NULL, NULL, NULL, 'SI:DKEY-190G11.3', 238682),
(297077, 'PTHR13610:SF5', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE TRANSLOCASE LYSINE N-METHYLTRANSFERASE', 238682),
(297078, 'PTHR13610:SF11', NULL, NULL, NULL, NULL, 'METHYLTRANFER_DOM DOMAIN-CONTAINING PROTEIN', 238682),
(297079, 'PTHR38839', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR WHID-RELATED', 238683),
(297080, 'PTHR38839:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR WHID', 238683),
(297081, 'PTHR38839:SF4', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR WHIB', 238683),
(297082, 'PTHR38839:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR WHIB7-RELATED', 238683),
(297083, 'PTHR38839:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR WHIB4', 238683),
(297084, 'PTHR38839:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR WHIB1', 238683),
(297085, 'PTHR11383:SF3', NULL, NULL, NULL, NULL, 'NAD(P)H PYROPHOSPHATASE NUDT13, MITOCHONDRIAL', 238684),
(297086, 'PTHR11383', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE-LINKED MOIETY X MOTIF 13', 238684),
(297087, 'PTHR38398', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 238685),
(297088, 'PTHR38398:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 238685),
(297089, 'PTHR38398:SF2', NULL, NULL, NULL, NULL, '', 238685),
(297090, 'PTHR37411:SF1', NULL, NULL, NULL, NULL, '', 238686),
(297091, 'PTHR37411', NULL, NULL, NULL, NULL, '', 238686),
(297092, 'PTHR12694:SF21', NULL, NULL, NULL, NULL, 'BNAC08G45360D PROTEIN', 238687),
(297093, 'PTHR12694:SF14', NULL, NULL, NULL, NULL, '', 238687),
(297094, 'PTHR12694:SF15', NULL, NULL, NULL, NULL, 'TFIIA-L3', 238687),
(297095, 'PTHR12694:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIA SUBUNIT 1', 238687),
(297096, 'PTHR12694:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIA SUBUNIT 1', 238687),
(297097, 'PTHR12694:SF17', NULL, NULL, NULL, NULL, 'BNAA08G28950D PROTEIN', 238687),
(297098, 'PTHR12694:SF9', NULL, NULL, NULL, NULL, 'TFIIA-ALPHA AND BETA-LIKE FACTOR', 238687),
(297099, 'PTHR12694', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIA SUBUNIT 1', 238687),
(297100, 'PTHR43499:SF1', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER I FAMILY MEMBER 1', 238688),
(297101, 'PTHR43499', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER I FAMILY MEMBER 1', 238688),
(297102, 'PTHR37318', NULL, NULL, NULL, NULL, 'BSL7504 PROTEIN', 238689),
(297103, 'PTHR37318:SF1', NULL, NULL, NULL, NULL, 'BSL7504 PROTEIN', 238689),
(297104, 'PTHR40032', NULL, NULL, NULL, NULL, 'EXPORTED PROTEIN-RELATED', 238690),
(297105, 'PTHR40032:SF1', NULL, NULL, NULL, NULL, 'EXPORTED PROTEIN-RELATED', 238690),
(297106, 'PTHR34584:SF1', NULL, NULL, NULL, NULL, 'NA(+)/H(+) ANTIPORTER SUBUNIT E1', 238691),
(297107, 'PTHR34584', NULL, NULL, NULL, NULL, 'NA(+)/H(+) ANTIPORTER SUBUNIT E1', 238691),
(297108, 'PTHR11844:SF25', NULL, NULL, NULL, NULL, 'NTR DOMAIN-CONTAINING PROTEIN', 238692);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(297109, 'PTHR11844:SF26', NULL, NULL, NULL, NULL, 'METALLOPROTEINASE INHIBITOR 4', 238692),
(297110, 'PTHR11844:SF24', NULL, NULL, NULL, NULL, 'METALLOPROTEINASE INHIBITOR 2', 238692),
(297111, 'PTHR11844:SF10', NULL, NULL, NULL, NULL, 'FRIZZLED-RELATED PROTEIN 1', 238692),
(297112, 'PTHR11844:SF32', NULL, NULL, NULL, NULL, 'TISSUE INHIBITOR OF METALLOPROTEINASE', 238692),
(297113, 'PTHR11844:SF22', NULL, NULL, NULL, NULL, 'METALLOPROTEINASE INHIBITOR 3', 238692),
(297114, 'PTHR11844:SF20', NULL, NULL, NULL, NULL, 'METALLOPROTEINASE INHIBITOR 1', 238692),
(297115, 'PTHR11844', NULL, NULL, NULL, NULL, 'METALLOPROTEASE INHIBITOR', 238692),
(297116, 'PTHR11844:SF31', NULL, NULL, NULL, NULL, 'NTR DOMAIN-CONTAINING PROTEIN', 238692),
(297117, 'PTHR11844:SF29', NULL, NULL, NULL, NULL, 'METALLOPROTEINASE INHIBITOR TAG-225-RELATED', 238692),
(297118, 'PTHR40788:SF2', NULL, NULL, NULL, NULL, '', 238693),
(297119, 'PTHR40788:SF1', NULL, NULL, NULL, NULL, '', 238693),
(297120, 'PTHR40788', NULL, NULL, NULL, NULL, '', 238693),
(297121, 'PTHR45670:SF15', NULL, NULL, NULL, NULL, 'LIGASE, PUTATIVE-RELATED', 238694),
(297122, 'PTHR45670:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HECTD1', 238694),
(297123, 'PTHR45670:SF14', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIP12', 238694),
(297124, 'PTHR45670:SF3', NULL, NULL, NULL, NULL, 'OS05G0122400 PROTEIN', 238694),
(297125, 'PTHR45670:SF17', NULL, NULL, NULL, NULL, 'HECT DOMAIN-CONTAINING PROTEIN', 238694),
(297126, 'PTHR45670:SF16', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE UPL3-LIKE', 238694),
(297127, 'PTHR45670:SF4', NULL, NULL, NULL, NULL, 'HECT E3 UBIQUITIN LIGASE-RELATED', 238694),
(297128, 'PTHR45670', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIP12', 238694),
(297129, 'PTHR45670:SF10', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE UPL4', 238694),
(297130, 'PTHR45670:SF13', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIP12', 238694),
(297131, 'PTHR36733:SF5', NULL, NULL, NULL, NULL, '', 238695),
(297132, 'PTHR36733:SF6', NULL, NULL, NULL, NULL, 'BNAC07G50610D PROTEIN', 238695),
(297133, 'PTHR36733:SF3', NULL, NULL, NULL, NULL, 'BNAC01G20690D PROTEIN', 238695),
(297134, 'PTHR36733:SF1', NULL, NULL, NULL, NULL, 'CELL WALL PROTEIN-RELATED', 238695),
(297135, 'PTHR36733:SF2', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 238695),
(297136, 'PTHR36733', NULL, NULL, NULL, NULL, 'CELL WALL PROTEIN-RELATED', 238695),
(297137, 'PTHR31525:SF4', NULL, NULL, NULL, NULL, 'HEME TRANSPORTER HRG-5', 238696),
(297138, 'PTHR31525:SF3', NULL, NULL, NULL, NULL, 'HEME TRANSPORTER HRG-4', 238696),
(297139, 'PTHR31525:SF2', NULL, NULL, NULL, NULL, 'HEME TRANSPORTER HRG-6', 238696),
(297140, 'PTHR31525:SF1', NULL, NULL, NULL, NULL, 'HEME TRANSPORTER HRG1', 238696),
(297141, 'PTHR31525', NULL, NULL, NULL, NULL, 'HEME TRANSPORTER HRG1', 238696),
(297142, 'PTHR33345:SF8', NULL, NULL, NULL, NULL, 'BNAC05G29900D PROTEIN', 238697),
(297143, 'PTHR33345:SF7', NULL, NULL, NULL, NULL, 'BNAA01G24650D PROTEIN', 238697),
(297144, 'PTHR33345:SF2', NULL, NULL, NULL, NULL, 'PHD_OBERON DOMAIN-CONTAINING PROTEIN', 238697),
(297145, 'PTHR33345:SF6', NULL, NULL, NULL, NULL, 'PHD_OBERON DOMAIN-CONTAINING PROTEIN', 238697),
(297146, 'PTHR33345', NULL, NULL, NULL, NULL, 'ADAPTER PROTEIN, PUTATIVE-RELATED', 238697),
(297147, 'PTHR33345:SF5', NULL, NULL, NULL, NULL, 'SPINDLE ASSEMBLY ABNORMAL PROTEIN', 238697),
(297148, 'PTHR33345:SF4', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 238697),
(297149, 'PTHR15876:SF10', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN ADIPOCYTE-ASSOCIATED 1-RELATED', 238698),
(297150, 'PTHR15876:SF8', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN ADIPOCYTE-ASSOCIATED 1', 238698),
(297151, 'PTHR15876', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN ADIPOCYTE-ASSOCIATED 1', 238698),
(297152, 'PTHR15876:SF11', NULL, NULL, NULL, NULL, 'PROTEIN CANDIDATE G-PROTEIN COUPLED RECEPTOR 8', 238698),
(297153, 'PTHR15876:SF12', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN ADIPOCYTE-ASSOCIATED 1-RELATED', 238698);
INSERT INTO "PUBLIC"."MODEL" VALUES
(297154, 'PTHR15876:SF13', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN ADIPOCYTE-ASSOCIATED 1-LIKE', 238698),
(297155, 'PTHR34921', NULL, NULL, NULL, NULL, 'MEIOTIC RECOMBINATION PROTEIN REC114', 238699),
(297156, 'PTHR34921:SF1', NULL, NULL, NULL, NULL, 'MEIOTIC RECOMBINATION PROTEIN REC114', 238699),
(297157, 'PTHR15901', NULL, NULL, NULL, NULL, 'TESTICULAR HAPLOID EXPRESSED GENE PROTEIN', 238700),
(297158, 'PTHR15901:SF16', NULL, NULL, NULL, NULL, 'TESTICULAR HAPLOID EXPRESSED GENE PROTEIN', 238700),
(297159, 'PTHR15901:SF15', NULL, NULL, NULL, NULL, 'TESTICULAR HAPLOID EXPRESSED GENE PROTEIN-LIKE', 238700),
(297160, 'PTHR23318:SF23', NULL, NULL, NULL, NULL, 'SMK-1 DOMAIN-CONTAINING PROTEIN', 238701),
(297161, 'PTHR23318:SF22', NULL, NULL, NULL, NULL, 'SMK-1 DOMAIN-CONTAINING PROTEIN', 238701),
(297162, 'PTHR23318:SF21', NULL, NULL, NULL, NULL, 'BNAA02G30850D PROTEIN', 238701),
(297163, 'PTHR23318:SF20', NULL, NULL, NULL, NULL, 'SMK-1 DOMAIN-CONTAINING PROTEIN', 238701),
(297164, 'PTHR23318:SF0', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 4 REGULATORY SUBUNIT 3', 238701),
(297165, 'PTHR23318', NULL, NULL, NULL, NULL, 'ATP SYNTHASE GAMMA-RELATED', 238701),
(297166, 'PTHR23318:SF24', NULL, NULL, NULL, NULL, 'BINDING PROTEIN-RELATED', 238701),
(297167, 'PTHR23318:SF19', NULL, NULL, NULL, NULL, 'PROTEIN PPP4R3C', 238701),
(297168, 'PTHR23318:SF18', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 4 REGULATORY SUBUNIT 3B', 238701),
(297169, 'PTHR23318:SF3', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 4 REGULATORY SUBUNIT 3A', 238701),
(297170, 'PTHR33788', NULL, NULL, NULL, NULL, 'OS07G0114300 PROTEIN', 238702),
(297171, 'PTHR33788:SF1', NULL, NULL, NULL, NULL, 'ZINC-BINDING PROTEIN', 238702),
(297172, 'PTHR33788:SF16', NULL, NULL, NULL, NULL, '4F5 DOMAIN-CONTAINING PROTEIN', 238702),
(297173, 'PTHR33788:SF15', NULL, NULL, NULL, NULL, 'BNAC03G27200D PROTEIN', 238702),
(297174, 'PTHR33788:SF17', NULL, NULL, NULL, NULL, '', 238702),
(297175, 'PTHR33788:SF23', NULL, NULL, NULL, NULL, '', 238702),
(297176, 'PTHR33788:SF25', NULL, NULL, NULL, NULL, '', 238702),
(297177, 'PTHR33788:SF24', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 238702),
(297178, 'PTHR33788:SF9', NULL, NULL, NULL, NULL, '', 238702),
(297179, 'PTHR33788:SF21', NULL, NULL, NULL, NULL, 'OS07G0114300 PROTEIN', 238702),
(297180, 'PTHR33788:SF20', NULL, NULL, NULL, NULL, 'BNAA09G42210D PROTEIN', 238702),
(297181, 'PTHR40761:SF1', NULL, NULL, NULL, NULL, 'CONSERVED INTEGRAL MEMBRANE ALANINE VALINE AND LEUCINE RICH PROTEIN-RELATED', 238703),
(297182, 'PTHR40761', NULL, NULL, NULL, NULL, 'CONSERVED INTEGRAL MEMBRANE ALANINE VALINE AND LEUCINE RICH PROTEIN-RELATED', 238703),
(297183, 'PTHR34441:SF1', NULL, NULL, NULL, NULL, 'MOTILE SPERM DOMAIN-CONTAINING PROTEIN 1', 238704),
(297184, 'PTHR34441:SF2', NULL, NULL, NULL, NULL, 'MOTILE SPERM DOMAIN-CONTAINING PROTEIN 1', 238704),
(297185, 'PTHR34441', NULL, NULL, NULL, NULL, 'MOTILE SPERM DOMAIN-CONTAINING PROTEIN 1', 238704),
(297186, 'PTHR34441:SF4', NULL, NULL, NULL, NULL, 'MOTILE SPERM DOMAIN-CONTAINING PROTEIN 3', 238704),
(297187, 'PTHR46484:SF3', NULL, NULL, NULL, NULL, 'MYELIN-ASSOCIATED GLYCOPROTEIN-LIKE', 238705),
(297188, 'PTHR46484:SF1', NULL, NULL, NULL, NULL, 'SI:CH211-171H4.5-RELATED', 238705),
(297189, 'PTHR46484:SF2', NULL, NULL, NULL, NULL, 'SI:CH73-380L3.3-RELATED', 238705),
(297190, 'PTHR46484', NULL, NULL, NULL, NULL, 'SI:CH211-171H4.5-RELATED', 238705),
(297191, 'PTHR31215:SF2', NULL, NULL, NULL, NULL, 'OS05G0510400 PROTEIN', 238706),
(297192, 'PTHR31215:SF40', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 238706),
(297193, 'PTHR31215:SF23', NULL, NULL, NULL, NULL, 'OS01G0193500 PROTEIN', 238706),
(297194, 'PTHR31215:SF25', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', 238706),
(297195, 'PTHR31215:SF36', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN-RELATED', 238706),
(297196, 'PTHR31215:SF26', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN, LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 238706);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(297197, 'PTHR31215', NULL, NULL, NULL, NULL, 'OS05G0510400 PROTEIN-RELATED', 238706),
(297198, 'PTHR31215:SF41', NULL, NULL, NULL, NULL, 'F-BOX/RNI-LIKE SUPERFAMILY PROTEIN-RELATED', 238706),
(297199, 'PTHR31215:SF30', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN', 238706),
(297200, 'PTHR31215:SF20', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN AUF1', 238706),
(297201, 'PTHR31215:SF21', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 238706),
(297202, 'PTHR31215:SF32', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN AUF2', 238706),
(297203, 'PTHR31215:SF22', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN', 238706),
(297204, 'PTHR31215:SF7', NULL, NULL, NULL, NULL, 'OS01G0770400 PROTEIN', 238706),
(297205, 'PTHR31215:SF38', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 238706),
(297206, 'PTHR31215:SF27', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN, LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 238706),
(297207, 'PTHR31215:SF17', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN', 238706),
(297208, 'PTHR31215:SF39', NULL, NULL, NULL, NULL, 'OS01G0812200 PROTEIN', 238706),
(297209, 'PTHR31215:SF28', NULL, NULL, NULL, NULL, 'F-BOX FAMILY PROTEIN', 238706),
(297210, 'PTHR31215:SF18', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 238706),
(297211, 'PTHR31215:SF19', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 238706),
(297212, 'PTHR36814', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I REACTION CENTER SUBUNIT N, CHLOROPLASTIC', 238707),
(297213, 'PTHR36814:SF2', NULL, NULL, NULL, NULL, 'BNAA06G23190D PROTEIN', 238707),
(297214, 'PTHR36814:SF1', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I REACTION CENTER SUBUNIT N, CHLOROPLASTIC', 238707),
(297215, 'PTHR36814:SF3', NULL, NULL, NULL, NULL, 'BNAA02G34030D PROTEIN', 238707),
(297216, 'PTHR35271:SF1', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, SUBSTRATE-BINDING LIPOPROTEIN-RELATED', 238708),
(297217, 'PTHR35271', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, SUBSTRATE-BINDING LIPOPROTEIN-RELATED', 238708),
(297218, 'PTHR13025:SF7', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN FAMILY, MEMBER D2', 238709),
(297219, 'PTHR13025:SF6', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN-RELATED', 238709),
(297220, 'PTHR13025:SF8', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN FAMILY, MEMBER D1', 238709),
(297221, 'PTHR13025:SF2', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN D2', 238709),
(297222, 'PTHR13025:SF5', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN D1', 238709),
(297223, 'PTHR13025', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN D', 238709),
(297224, 'PTHR45676:SF132', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL60', 238710),
(297225, 'PTHR45676:SF134', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RING1', 238710),
(297226, 'PTHR45676:SF54', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297227, 'PTHR45676:SF171', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297228, 'PTHR45676:SF98', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 238710),
(297229, 'PTHR45676:SF10', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297230, 'PTHR45676:SF96', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297231, 'PTHR45676:SF130', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297232, 'PTHR45676:SF50', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297233, 'PTHR45676:SF94', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297234, 'PTHR45676:SF92', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297235, 'PTHR45676:SF170', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297236, 'PTHR45676:SF93', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297237, 'PTHR45676:SF146', NULL, NULL, NULL, NULL, 'FINGER PROTEIN ATL3L, PUTATIVE-RELATED', 238710),
(297238, 'PTHR45676:SF29', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297239, 'PTHR45676:SF147', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE OS04G0590900', 238710);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(297240, 'PTHR45676:SF27', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297241, 'PTHR45676:SF149', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL52', 238710),
(297242, 'PTHR45676:SF69', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297243, 'PTHR45676:SF143', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297244, 'PTHR45676:SF26', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297245, 'PTHR45676:SF100', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297246, 'PTHR45676:SF23', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 238710),
(297247, 'PTHR45676:SF65', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297248, 'PTHR45676:SF66', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297249, 'PTHR45676:SF141', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297250, 'PTHR45676:SF61', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297251, 'PTHR45676:SF62', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297252, 'PTHR45676:SF106', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297253, 'PTHR45676:SF157', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297254, 'PTHR45676:SF158', NULL, NULL, NULL, NULL, '', 238710),
(297255, 'PTHR45676:SF114', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297256, 'PTHR45676:SF159', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL51', 238710),
(297257, 'PTHR45676:SF116', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297258, 'PTHR45676:SF153', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297259, 'PTHR45676:SF36', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297260, 'PTHR45676:SF154', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297261, 'PTHR45676:SF37', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297262, 'PTHR45676:SF110', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297263, 'PTHR45676:SF78', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297264, 'PTHR45676:SF155', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297265, 'PTHR45676:SF79', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297266, 'PTHR45676:SF112', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297267, 'PTHR45676:SF156', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297268, 'PTHR45676:SF150', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297269, 'PTHR45676:SF77', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297270, 'PTHR45676:SF74', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297271, 'PTHR45676:SF151', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297272, 'PTHR45676:SF75', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297273, 'PTHR45676:SF152', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297274, 'PTHR45676:SF31', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL53-RELATED', 238710),
(297275, 'PTHR45676', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL51-RELATED', 238710),
(297276, 'PTHR45676:SF71', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297277, 'PTHR45676:SF80', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297278, 'PTHR45676:SF119', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297279, 'PTHR45676:SF168', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297280, 'PTHR45676:SF125', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297281, 'PTHR45676:SF169', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 238710);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(297282, 'PTHR45676:SF49', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297283, 'PTHR45676:SF126', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL54', 238710),
(297284, 'PTHR45676:SF127', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297285, 'PTHR45676:SF120', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297286, 'PTHR45676:SF164', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297287, 'PTHR45676:SF48', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297288, 'PTHR45676:SF165', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 238710),
(297289, 'PTHR45676:SF166', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL3-RELATED', 238710),
(297290, 'PTHR45676:SF122', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297291, 'PTHR45676:SF89', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297292, 'PTHR45676:SF167', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297293, 'PTHR45676:SF160', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297294, 'PTHR45676:SF161', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297295, 'PTHR45676:SF88', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL33', 238710),
(297296, 'PTHR45676:SF162', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297297, 'PTHR45676:SF41', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL66', 238710),
(297298, 'PTHR45676:SF163', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297299, 'PTHR45676:SF84', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 238710),
(297300, 'PTHR15060', NULL, NULL, NULL, NULL, 'INTERLEUKIN-15 RECEPTOR SUBUNIT ALPHA', 238711),
(297301, 'PTHR15060:SF0', NULL, NULL, NULL, NULL, 'INTERLEUKIN-15 RECEPTOR SUBUNIT ALPHA', 238711),
(297302, 'PTHR16520:SF3', NULL, NULL, NULL, NULL, 'KINETOCHORE SCAFFOLD 1', 238712),
(297303, 'PTHR16520', NULL, NULL, NULL, NULL, 'KINETOCHORE SCAFFOLD 1', 238712),
(297304, 'PTHR28057:SF1', NULL, NULL, NULL, NULL, 'PROTEIN IFH1-RELATED', 238713),
(297305, 'PTHR28057', NULL, NULL, NULL, NULL, 'PROTEIN IFH1-RELATED', 238713),
(297306, 'PTHR36748', NULL, NULL, NULL, NULL, 'MENTAL RETARDATION GTPASE ACTIVATING PROTEIN', 238714),
(297307, 'PTHR36748:SF2', NULL, NULL, NULL, NULL, '', 238714),
(297308, 'PTHR36748:SF4', NULL, NULL, NULL, NULL, 'MENTAL RETARDATION GTPASE ACTIVATING PROTEIN', 238714),
(297309, 'PTHR36748:SF3', NULL, NULL, NULL, NULL, 'MENTAL RETARDATION GTPASE ACTIVATING PROTEIN', 238714),
(297310, 'PTHR36748:SF6', NULL, NULL, NULL, NULL, 'FAMILY TRANSCRIPTIONAL REGULATOR, PUTATIVE-RELATED', 238714),
(297311, 'PTHR36748:SF5', NULL, NULL, NULL, NULL, 'BNAC02G06370D PROTEIN', 238714),
(297312, 'PTHR20851', NULL, NULL, NULL, NULL, 'DORSAL INTERACTING PROTEIN 3', 238715),
(297313, 'PTHR20851:SF0', NULL, NULL, NULL, NULL, 'FI20150P1', 238715),
(297314, 'PTHR10641:SF1302', NULL, NULL, NULL, NULL, 'BNAC01G20650D PROTEIN', 238716),
(297315, 'PTHR10641:SF1300', NULL, NULL, NULL, NULL, 'MYB33', 238716),
(297316, 'PTHR10641:SF1305', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 238716),
(297317, 'PTHR10641:SF1149', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN MYB4-LIKE', 238716),
(297318, 'PTHR10641:SF1303', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 238716),
(297319, 'PTHR10641:SF1381', NULL, NULL, NULL, NULL, 'OS08G0486300 PROTEIN', 238716),
(297320, 'PTHR10641:SF1140', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 238716),
(297321, 'PTHR10641:SF1380', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB16', 238716),
(297322, 'PTHR10641:SF1264', NULL, NULL, NULL, NULL, 'BNAC01G41180D PROTEIN', 238716),
(297323, 'PTHR10641:SF1265', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 238716),
(297324, 'PTHR10641:SF1262', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB13', 238716),
(297325, 'PTHR10641:SF1263', NULL, NULL, NULL, NULL, 'MYB DOMAIN CLASS TRANSCRIPTION FACTOR', 238716);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(297326, 'PTHR10641:SF1021', NULL, NULL, NULL, NULL, 'PROTEIN ODORANT1-LIKE', 238716),
(297327, 'PTHR10641:SF1309', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB51', 238716),
(297328, 'PTHR10641:SF1308', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB41', 238716),
(297329, 'PTHR10641:SF976', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB8-LIKE', 238716),
(297330, 'PTHR10641:SF586', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB106', 238716),
(297331, 'PTHR10641:SF1279', NULL, NULL, NULL, NULL, 'BNAC03G17390D PROTEIN', 238716),
(297332, 'PTHR10641:SF1037', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB10', 238716),
(297333, 'PTHR10641:SF1313', NULL, NULL, NULL, NULL, 'MYB-RELATED TRANSCRIPTION FACTOR LBM3', 238716),
(297334, 'PTHR10641:SF1310', NULL, NULL, NULL, NULL, 'MYB-RELATED TRANSCRIPTION FACTOR LBM1', 238716),
(297335, 'PTHR10641:SF1277', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 238716),
(297336, 'PTHR10641:SF985', NULL, NULL, NULL, NULL, 'OS04G0593200 PROTEIN', 238716),
(297337, 'PTHR10641:SF622', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB17', 238716),
(297338, 'PTHR10641:SF1314', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB96', 238716),
(297339, 'PTHR10641:SF1270', NULL, NULL, NULL, NULL, 'BNACNNG43220D PROTEIN', 238716),
(297340, 'PTHR10641:SF1034', NULL, NULL, NULL, NULL, 'MYB DOMAIN PROTEIN 9', 238716),
(297341, 'PTHR10641:SF1152', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB60', 238716),
(297342, 'PTHR10641:SF1274', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN 306-LIKE', 238716),
(297343, 'PTHR10641:SF1169', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB58', 238716),
(297344, 'PTHR10641:SF1321', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB15', 238716),
(297345, 'PTHR10641:SF1289', NULL, NULL, NULL, NULL, 'BNAANNG06640D PROTEIN', 238716),
(297346, 'PTHR10641:SF1322', NULL, NULL, NULL, NULL, 'MYB DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 238716),
(297347, 'PTHR10641:SF1328', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB29-RELATED', 238716),
(297348, 'PTHR10641:SF596', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN ZM1', 238716),
(297349, 'PTHR10641:SF1282', NULL, NULL, NULL, NULL, 'BNAA09G05480D PROTEIN', 238716),
(297350, 'PTHR10641:SF1283', NULL, NULL, NULL, NULL, 'BNACNNG29120D PROTEIN', 238716),
(297351, 'PTHR10641:SF592', NULL, NULL, NULL, NULL, 'P-TYPE R2R3 MYB PROTEIN', 238716),
(297352, 'PTHR10641:SF1044', NULL, NULL, NULL, NULL, 'MYB DOMAIN PROTEIN 49', 238716),
(297353, 'PTHR10641:SF1320', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB-HB-LIKE FAMILY-RELATED', 238716),
(297354, 'PTHR10641:SF1287', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB104-RELATED', 238716),
(297355, 'PTHR10641:SF1290', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN 306-LIKE', 238716),
(297356, 'PTHR10641:SF1059', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB28', 238716),
(297357, 'PTHR10641:SF1334', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE-RELATED', 238716),
(297358, 'PTHR10641:SF1335', NULL, NULL, NULL, NULL, '', 238716),
(297359, 'PTHR10641:SF1338', NULL, NULL, NULL, NULL, 'BNAC01G31020D PROTEIN', 238716),
(297360, 'PTHR10641:SF1339', NULL, NULL, NULL, NULL, 'PROTEIN ODORANT1-LIKE', 238716),
(297361, 'PTHR10641:SF1336', NULL, NULL, NULL, NULL, 'THM18 PROTEIN', 238716),
(297362, 'PTHR10641:SF1291', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 238716),
(297363, 'PTHR10641:SF1170', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB122', 238716),
(297364, 'PTHR10641:SF1050', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB34', 238716),
(297365, 'PTHR10641:SF1055', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB76-LIKE', 238716),
(297366, 'PTHR10641:SF1297', NULL, NULL, NULL, NULL, 'OS06G0112700 PROTEIN', 238716),
(297367, 'PTHR10641:SF1298', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 238716),
(297368, 'PTHR10641:SF1295', NULL, NULL, NULL, NULL, 'MYB DOMAIN CLASS TRANSCRIPTION FACTOR', 238716),
(297369, 'PTHR10641:SF1296', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB53', 238716);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(297370, 'PTHR10641:SF1103', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB72', 238716),
(297371, 'PTHR10641:SF1346', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB14', 238716),
(297372, 'PTHR10641:SF1343', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 238716),
(297373, 'PTHR10641:SF1349', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 238716),
(297374, 'PTHR10641:SF1347', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR MIXTA-LIKE PROTEIN', 238716),
(297375, 'PTHR10641:SF1348', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB39-LIKE', 238716),
(297376, 'PTHR10641:SF1063', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-RELATED', 238716),
(297377, 'PTHR10641:SF1341', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB30', 238716),
(297378, 'PTHR10641:SF1064', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB4-LIKE', 238716),
(297379, 'PTHR10641:SF1356', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN 306-LIKE', 238716),
(297380, 'PTHR10641:SF1357', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN MYB4-LIKE ISOFORM X1', 238716),
(297381, 'PTHR10641:SF1354', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB17-LIKE', 238716),
(297382, 'PTHR10641:SF1355', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN MYB4-LIKE', 238716),
(297383, 'PTHR10641:SF1239', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB102', 238716),
(297384, 'PTHR10641:SF1358', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 238716),
(297385, 'PTHR10641:SF541', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB4', 238716),
(297386, 'PTHR10641:SF1359', NULL, NULL, NULL, NULL, 'OS06G0221000 PROTEIN', 238716),
(297387, 'PTHR10641:SF1352', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB34-LIKE', 238716),
(297388, 'PTHR10641:SF1353', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB23-LIKE', 238716),
(297389, 'PTHR10641:SF1232', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB74', 238716),
(297390, 'PTHR10641:SF1111', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB92', 238716),
(297391, 'PTHR10641:SF1350', NULL, NULL, NULL, NULL, 'GLOSSY3', 238716),
(297392, 'PTHR10641:SF1075', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB63', 238716),
(297393, 'PTHR10641:SF1230', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 238716),
(297394, 'PTHR10641:SF1351', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 238716),
(297395, 'PTHR10641:SF1367', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN 306-LIKE', 238716),
(297396, 'PTHR10641:SF1247', NULL, NULL, NULL, NULL, 'MYB-LIKE DNA-BINDING DOMAIN CONTAINING PROTEIN, EXPRESSED', 238716),
(297397, 'PTHR10641:SF1368', NULL, NULL, NULL, NULL, 'OS02G0579300 PROTEIN', 238716),
(297398, 'PTHR10641:SF1244', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB114-LIKE', 238716),
(297399, 'PTHR10641:SF1365', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 238716),
(297400, 'PTHR10641:SF1366', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB94', 238716),
(297401, 'PTHR10641:SF1245', NULL, NULL, NULL, NULL, 'BNAC04G41990D PROTEIN', 238716),
(297402, 'PTHR10641:SF1127', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB30', 238716),
(297403, 'PTHR10641:SF1369', NULL, NULL, NULL, NULL, 'OS04G0461000 PROTEIN', 238716),
(297404, 'PTHR10641:SF1248', NULL, NULL, NULL, NULL, 'OS07G0558100 PROTEIN', 238716),
(297405, 'PTHR10641:SF1007', NULL, NULL, NULL, NULL, 'PROTEIN ODORANT1-LIKE', 238716),
(297406, 'PTHR10641:SF1360', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN MYB4-LIKE', 238716),
(297407, 'PTHR10641:SF1363', NULL, NULL, NULL, NULL, '', 238716),
(297408, 'PTHR10641:SF1121', NULL, NULL, NULL, NULL, 'OS07G0629000 PROTEIN', 238716),
(297409, 'PTHR10641:SF1364', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB-HB-LIKE FAMILY-RELATED', 238716),
(297410, 'PTHR10641:SF1122', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 238716),
(297411, 'PTHR10641:SF1361', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB39-LIKE', 238716),
(297412, 'PTHR10641:SF1240', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN MYB4-LIKE', 238716),
(297413, 'PTHR10641:SF1362', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB3-LIKE', 238716);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(297414, 'PTHR10641', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR', 238716),
(297415, 'PTHR10641:SF1378', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB34-LIKE', 238716),
(297416, 'PTHR10641:SF1379', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB30', 238716),
(297417, 'PTHR10641:SF961', NULL, NULL, NULL, NULL, 'DNA BINDING PROTEIN', 238716),
(297418, 'PTHR10641:SF1376', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN 306-LIKE', 238716),
(297419, 'PTHR10641:SF1256', NULL, NULL, NULL, NULL, 'BNACNNG13680D PROTEIN', 238716),
(297420, 'PTHR10641:SF1377', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN 308-LIKE', 238716),
(297421, 'PTHR10641:SF1259', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 238716),
(297422, 'PTHR10641:SF1370', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB39-LIKE', 238716),
(297423, 'PTHR10641:SF1371', NULL, NULL, NULL, NULL, 'BNAA05G32240D PROTEIN', 238716),
(297424, 'PTHR10641:SF1250', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR', 238716),
(297425, 'PTHR10641:SF1094', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR MYB30', 238716),
(297426, 'PTHR10641:SF1374', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB39-LIKE', 238716),
(297427, 'PTHR10641:SF1375', NULL, NULL, NULL, NULL, 'MYB/HD-LIKE TRANSCRIPTION FACTOR', 238716),
(297428, 'PTHR10641:SF1254', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 238716),
(297429, 'PTHR10641:SF1133', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 238716),
(297430, 'PTHR10641:SF1372', NULL, NULL, NULL, NULL, '', 238716),
(297431, 'PTHR10641:SF1251', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 238716),
(297432, 'PTHR10641:SF1373', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB39', 238716),
(297433, 'PTHR47816', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA SMALL SUBUNIT METHYLTRANSFERASE C', 238717),
(297434, 'PTHR47816:SF4', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA SMALL SUBUNIT METHYLTRANSFERASE C', 238717),
(297435, 'PTHR47816:SF5', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA LARGE SUBUNIT METHYLTRANSFERASE G', 238717),
(297436, 'PTHR39441', NULL, NULL, NULL, NULL, '', 238718),
(297437, 'PTHR39441:SF1', NULL, NULL, NULL, NULL, '', 238718),
(297438, 'PTHR33285:SF40', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINES 4', 238719),
(297439, 'PTHR33285:SF42', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINES 4-RELATED', 238719),
(297440, 'PTHR33285:SF23', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINES 2', 238719),
(297441, 'PTHR33285:SF45', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINES 3', 238719),
(297442, 'PTHR33285:SF22', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINES 6-RELATED', 238719),
(297443, 'PTHR33285:SF44', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINE-BETA', 238719),
(297444, 'PTHR33285:SF47', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINE-BETA', 238719),
(297445, 'PTHR33285:SF46', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINE-BETA', 238719),
(297446, 'PTHR33285:SF49', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINE-BETA', 238719),
(297447, 'PTHR33285:SF48', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINE-BETA', 238719),
(297448, 'PTHR33285:SF28', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINE-BETA', 238719),
(297449, 'PTHR33285', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINES 3', 238719),
(297450, 'PTHR33285:SF52', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINE-BETA', 238719),
(297451, 'PTHR33285:SF30', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINES 5', 238719),
(297452, 'PTHR33285:SF51', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINE-BETA', 238719),
(297453, 'PTHR33285:SF54', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINE-BETA', 238719),
(297454, 'PTHR33285:SF32', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINES 5', 238719),
(297455, 'PTHR33285:SF53', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINE-BETA', 238719),
(297456, 'PTHR33285:SF56', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINE-BETA', 238719),
(297457, 'PTHR33285:SF33', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINE-BETA', 238719),
(297458, 'PTHR33285:SF55', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINES 3', 238719),
(297459, 'PTHR33285:SF1', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINES 1', 238719),
(297460, 'PTHR33285:SF36', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINE-BETA', 238719);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(297461, 'PTHR33285:SF38', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINE-BETA', 238719),
(297462, 'PTHR33285:SF37', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINE-BETA', 238719),
(297463, 'PTHR33285:SF39', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINE-BETA', 238719),
(297464, 'PTHR13343:SF27', NULL, NULL, NULL, NULL, 'PYRIDOXAMINE 5''-PHOSPHATE OXIDASE FAMILY PROTEIN', 238720),
(297465, 'PTHR13343:SF17', NULL, NULL, NULL, NULL, 'CELLULAR REPRESSOR OF E1A-STIMULATED GENES, ISOFORM A', 238720),
(297466, 'PTHR13343:SF28', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT (PPR) SUPERFAMILY PROTEIN', 238720),
(297467, 'PTHR13343:SF18', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT (PPR) SUPERFAMILY PROTEIN', 238720),
(297468, 'PTHR13343:SF29', NULL, NULL, NULL, NULL, 'PYRIDOXAMINE 5''-PHOSPHATE OXIDASE FAMILY PROTEIN', 238720),
(297469, 'PTHR13343:SF24', NULL, NULL, NULL, NULL, 'OS07G0573800 PROTEIN', 238720),
(297470, 'PTHR13343:SF35', NULL, NULL, NULL, NULL, 'FMN-BINDING SPLIT BARREL-RELATED', 238720),
(297471, 'PTHR13343:SF36', NULL, NULL, NULL, NULL, 'OS02G0148400 PROTEIN', 238720),
(297472, 'PTHR13343:SF26', NULL, NULL, NULL, NULL, '', 238720),
(297473, 'PTHR13343:SF15', NULL, NULL, NULL, NULL, 'PROTEIN CREG2', 238720),
(297474, 'PTHR13343:SF30', NULL, NULL, NULL, NULL, 'BNAC03G41910D PROTEIN', 238720),
(297475, 'PTHR13343:SF31', NULL, NULL, NULL, NULL, 'FMN-BINDING SPLIT BARREL-RELATED', 238720),
(297476, 'PTHR13343:SF21', NULL, NULL, NULL, NULL, 'PROTEIN CREG1', 238720),
(297477, 'PTHR13343:SF32', NULL, NULL, NULL, NULL, 'DUF2470 DOMAIN-CONTAINING PROTEIN', 238720),
(297478, 'PTHR13343', NULL, NULL, NULL, NULL, 'CREG1 PROTEIN', 238720),
(297479, 'PTHR13343:SF33', NULL, NULL, NULL, NULL, 'BNAC01G32220D PROTEIN', 238720),
(297480, 'PTHR13343:SF22', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA REDUCTASE-BINDING PROTEIN, CHLOROPLASTIC', 238720),
(297481, 'PTHR35499:SF1', NULL, NULL, NULL, NULL, 'OS05G0128300 PROTEIN', 238721),
(297482, 'PTHR35499:SF3', NULL, NULL, NULL, NULL, '', 238721),
(297483, 'PTHR35499:SF4', NULL, NULL, NULL, NULL, 'ALC-INTERACTING PROTEIN 1', 238721),
(297484, 'PTHR35499', NULL, NULL, NULL, NULL, 'OS05G0128300 PROTEIN', 238721),
(297485, 'PTHR38043', NULL, NULL, NULL, NULL, 'PROTEIN HEMX', 238722),
(297486, 'PTHR38043:SF1', NULL, NULL, NULL, NULL, 'PROTEIN HEMX', 238722),
(297487, 'PTHR33975:SF9', NULL, NULL, NULL, NULL, '', 238723),
(297488, 'PTHR33975:SF8', NULL, NULL, NULL, NULL, '', 238723),
(297489, 'PTHR33975', NULL, NULL, NULL, NULL, 'MYELIN-ASSOCIATED OLIGODENDROCYTE BASIC PROTEIN', 238723),
(297490, 'PTHR33975:SF7', NULL, NULL, NULL, NULL, 'OS08G0119100 PROTEIN', 238723),
(297491, 'PTHR33975:SF5', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 238723),
(297492, 'PTHR33975:SF10', NULL, NULL, NULL, NULL, '', 238723),
(297493, 'PTHR33975:SF2', NULL, NULL, NULL, NULL, 'MYELIN-ASSOCIATED OLIGODENDROCYTE BASIC PROTEIN', 238723),
(297494, 'PTHR33975:SF12', NULL, NULL, NULL, NULL, '', 238723),
(297495, 'PTHR22948', NULL, NULL, NULL, NULL, 'TUDOR DOMAIN CONTAINING PROTEIN', 238724),
(297496, 'PTHR22948:SF7', NULL, NULL, NULL, NULL, 'TUDOR DOMAIN-CONTAINING PROTEIN 15', 238724),
(297497, 'PTHR22948:SF14', NULL, NULL, NULL, NULL, 'TUDOR DOMAIN-CONTAINING PROTEIN 7', 238724),
(297498, 'PTHR22948:SF69', NULL, NULL, NULL, NULL, 'FI02030P-RELATED', 238724),
(297499, 'PTHR22948:SF15', NULL, NULL, NULL, NULL, 'TUDOR DOMAIN-CONTAINING PROTEIN 6', 238724),
(297500, 'PTHR22948:SF4', NULL, NULL, NULL, NULL, 'TUDOR DOMAIN-CONTAINING PROTEIN 1', 238724),
(297501, 'PTHR22948:SF29', NULL, NULL, NULL, NULL, 'TUDOR DOMAIN-CONTAINING PROTEIN-RELATED', 238724),
(297502, 'PTHR22948:SF18', NULL, NULL, NULL, NULL, 'TUDOR AND KH DOMAIN-CONTAINING PROTEIN', 238724),
(297503, 'PTHR22948:SF19', NULL, NULL, NULL, NULL, 'TUDOR DOMAIN-CONTAINING PROTEIN 5', 238724),
(297504, 'PTHR22948:SF50', NULL, NULL, NULL, NULL, 'PROTEIN CBR-EKL-1', 238724),
(297505, 'PTHR22948:SF72', NULL, NULL, NULL, NULL, 'FI20010P1-RELATED', 238724),
(297506, 'PTHR22948:SF71', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 238724);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(297507, 'PTHR22948:SF74', NULL, NULL, NULL, NULL, 'SI:DKEYP-93D12.1', 238724),
(297508, 'PTHR22948:SF73', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 31', 238724),
(297509, 'PTHR22948:SF65', NULL, NULL, NULL, NULL, 'A-KINASE ANCHOR PROTEIN 1, MITOCHONDRIAL', 238724),
(297510, 'PTHR22948:SF12', NULL, NULL, NULL, NULL, 'TUDOR DOMAIN-CONTAINING PROTEIN 10', 238724),
(297511, 'PTHR22948:SF70', NULL, NULL, NULL, NULL, 'TUDOR DOMAIN CONTAINING 12', 238724),
(297512, 'PTHR33181:SF36', NULL, NULL, NULL, NULL, 'BNAA01G27970D PROTEIN', 238725),
(297513, 'PTHR33181:SF2', NULL, NULL, NULL, NULL, 'OS03G0806800 PROTEIN', 238725),
(297514, 'PTHR33181:SF58', NULL, NULL, NULL, NULL, '', 238725),
(297515, 'PTHR33181:SF15', NULL, NULL, NULL, NULL, '', 238725),
(297516, 'PTHR33181:SF59', NULL, NULL, NULL, NULL, '', 238725),
(297517, 'PTHR33181:SF38', NULL, NULL, NULL, NULL, '', 238725),
(297518, 'PTHR33181:SF4', NULL, NULL, NULL, NULL, 'BNAA06G36850D PROTEIN', 238725),
(297519, 'PTHR33181:SF17', NULL, NULL, NULL, NULL, 'OS01G0778500 PROTEIN', 238725),
(297520, 'PTHR33181:SF10', NULL, NULL, NULL, NULL, 'SSRA-BINDING PROTEIN', 238725),
(297521, 'PTHR33181:SF54', NULL, NULL, NULL, NULL, 'OS04G0603400 PROTEIN', 238725),
(297522, 'PTHR33181:SF55', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 238725),
(297523, 'PTHR33181:SF33', NULL, NULL, NULL, NULL, 'OS08G0241300 PROTEIN', 238725),
(297524, 'PTHR33181:SF34', NULL, NULL, NULL, NULL, '', 238725),
(297525, 'PTHR33181:SF56', NULL, NULL, NULL, NULL, 'BNAC06G40830D PROTEIN', 238725),
(297526, 'PTHR33181:SF35', NULL, NULL, NULL, NULL, 'BNAA01G24710D PROTEIN', 238725),
(297527, 'PTHR33181:SF57', NULL, NULL, NULL, NULL, '', 238725),
(297528, 'PTHR33181:SF7', NULL, NULL, NULL, NULL, 'OS07G0572400 PROTEIN', 238725),
(297529, 'PTHR33181:SF18', NULL, NULL, NULL, NULL, 'OSJNBA0041A02.21-LIKE PROTEIN', 238725),
(297530, 'PTHR33181:SF19', NULL, NULL, NULL, NULL, 'OS04G0658200 PROTEIN', 238725),
(297531, 'PTHR33181:SF52', NULL, NULL, NULL, NULL, 'OS07G0204400 PROTEIN', 238725),
(297532, 'PTHR33181:SF30', NULL, NULL, NULL, NULL, '', 238725),
(297533, 'PTHR33181:SF53', NULL, NULL, NULL, NULL, '', 238725),
(297534, 'PTHR33181:SF31', NULL, NULL, NULL, NULL, '', 238725),
(297535, 'PTHR33181:SF25', NULL, NULL, NULL, NULL, '', 238725),
(297536, 'PTHR33181:SF47', NULL, NULL, NULL, NULL, 'BNAA02G36690D PROTEIN', 238725),
(297537, 'PTHR33181:SF49', NULL, NULL, NULL, NULL, 'OSJNBA0041A02.21-LIKE PROTEIN', 238725),
(297538, 'PTHR33181:SF43', NULL, NULL, NULL, NULL, '', 238725),
(297539, 'PTHR33181', NULL, NULL, NULL, NULL, 'OS01G0778500 PROTEIN', 238725),
(297540, 'PTHR33181:SF46', NULL, NULL, NULL, NULL, 'BNAC01G41370D PROTEIN', 238725),
(297541, 'PTHR33181:SF40', NULL, NULL, NULL, NULL, '', 238725),
(297542, 'PTHR33181:SF42', NULL, NULL, NULL, NULL, '', 238725),
(297543, 'PTHR31064:SF34', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORT PROTEIN 2', 238726),
(297544, 'PTHR31064:SF35', NULL, NULL, NULL, NULL, 'CATION TRANSPORTER HKT7-RELATED', 238726),
(297545, 'PTHR31064:SF36', NULL, NULL, NULL, NULL, 'SODIUM TRANSPORTER HKT1', 238726),
(297546, 'PTHR31064:SF25', NULL, NULL, NULL, NULL, 'CATION TRANSPORTER HKT1', 238726),
(297547, 'PTHR31064:SF5', NULL, NULL, NULL, NULL, 'POTASSIUM ION TRANSPORTER (EUROFUNG)', 238726),
(297548, 'PTHR31064:SF8', NULL, NULL, NULL, NULL, 'CATION TRANSPORTER HKT4', 238726),
(297549, 'PTHR31064:SF30', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORT PROTEIN DDB_G0292412-RELATED', 238726),
(297550, 'PTHR31064:SF31', NULL, NULL, NULL, NULL, 'CATION TRANSPORTER HKT6-RELATED', 238726),
(297551, 'PTHR31064:SF33', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY POTASSIUM TRANSPORT PROTEIN-RELATED', 238726),
(297552, 'PTHR31064:SF11', NULL, NULL, NULL, NULL, 'CATION TRANSPORTER HKT9-RELATED', 238726),
(297553, 'PTHR31064', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORT PROTEIN DDB_G0292412-RELATED', 238726),
(297554, 'PTHR31064:SF28', NULL, NULL, NULL, NULL, 'CATION TRANSPORTER HKT6-RELATED', 238726),
(297555, 'PTHR45290', NULL, NULL, NULL, NULL, 'OS03G0300300 PROTEIN', 238727);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(297556, 'PTHR45290:SF3', NULL, NULL, NULL, NULL, 'OS01G0649000 PROTEIN', 238727),
(297557, 'PTHR45290:SF1', NULL, NULL, NULL, NULL, 'OS03G0300300 PROTEIN', 238727),
(297558, 'PTHR33227:SF49', NULL, NULL, NULL, NULL, 'STIGMA-SPECIFIC STIG1-LIKE PROTEIN 1', 238728),
(297559, 'PTHR33227:SF15', NULL, NULL, NULL, NULL, 'STIGMA-SPECIFIC STIG1-LIKE PROTEIN 1', 238728),
(297560, 'PTHR33227:SF48', NULL, NULL, NULL, NULL, 'STIGMA-SPECIFIC STIG1-LIKE PROTEIN 4', 238728),
(297561, 'PTHR33227:SF18', NULL, NULL, NULL, NULL, 'STIGMA-SPECIFIC STIG1-LIKE PROTEIN 3', 238728),
(297562, 'PTHR33227:SF28', NULL, NULL, NULL, NULL, 'STIG1 FAMILY PROTEIN, PUTATIVE-RELATED', 238728),
(297563, 'PTHR33227:SF56', NULL, NULL, NULL, NULL, 'STIGMA-SPECIFIC PROTEIN STIG1-RELATED', 238728),
(297564, 'PTHR33227:SF34', NULL, NULL, NULL, NULL, 'STIGMA-SPECIFIC STIG1 FAMILY PROTEIN-RELATED', 238728),
(297565, 'PTHR33227:SF55', NULL, NULL, NULL, NULL, 'STIGMA-SPECIFIC PROTEIN STIG1-RELATED', 238728),
(297566, 'PTHR33227:SF33', NULL, NULL, NULL, NULL, 'BNAA03G11550D PROTEIN', 238728),
(297567, 'PTHR33227:SF52', NULL, NULL, NULL, NULL, 'STIGMA-SPECIFIC STIG1-LIKE PROTEIN 4', 238728),
(297568, 'PTHR33227:SF30', NULL, NULL, NULL, NULL, 'STIGMA-SPECIFIC PROTEIN STIG1-RELATED', 238728),
(297569, 'PTHR33227:SF51', NULL, NULL, NULL, NULL, 'STIGMA-SPECIFIC STIG1-LIKE PROTEIN 2', 238728),
(297570, 'PTHR33227:SF6', NULL, NULL, NULL, NULL, 'PROTEIN GRIM REAPER', 238728),
(297571, 'PTHR33227:SF54', NULL, NULL, NULL, NULL, 'PROTEIN STIG1', 238728),
(297572, 'PTHR33227:SF21', NULL, NULL, NULL, NULL, 'F12F1.21 PROTEIN', 238728),
(297573, 'PTHR33227:SF32', NULL, NULL, NULL, NULL, 'STIGMA-SPECIFIC STIG1-LIKE PROTEIN 3', 238728),
(297574, 'PTHR33227:SF53', NULL, NULL, NULL, NULL, 'STIGMA-SPECIFIC STIG1-LIKE PROTEIN 3', 238728),
(297575, 'PTHR33227:SF42', NULL, NULL, NULL, NULL, 'STIGMA-SPECIFIC STIG1-LIKE PROTEIN 1', 238728),
(297576, 'PTHR33227:SF31', NULL, NULL, NULL, NULL, '', 238728),
(297577, 'PTHR33227:SF50', NULL, NULL, NULL, NULL, '', 238728),
(297578, 'PTHR33227', NULL, NULL, NULL, NULL, 'STIGMA-SPECIFIC STIG1-LIKE PROTEIN 3', 238728),
(297579, 'PTHR12780:SF1', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE III SUBUNIT RPC6', 238729),
(297580, 'PTHR12780', NULL, NULL, NULL, NULL, 'RNA POLYMERASE III  DNA DIRECTED , 39KD SUBUNIT-RELATED', 238729),
(297581, 'PTHR13627', NULL, NULL, NULL, NULL, 'FUKUTIN RELATED PROTEIN', 238730),
(297582, 'PTHR13627:SF33', NULL, NULL, NULL, NULL, '', 238730),
(297583, 'PTHR13627:SF32', NULL, NULL, NULL, NULL, 'AGAP006029-PA', 238730),
(297584, 'PTHR13627:SF31', NULL, NULL, NULL, NULL, 'FUKUTIN-RELATED PROTEIN', 238730),
(297585, 'PTHR31272:SF9', NULL, NULL, NULL, NULL, 'BLL1027 PROTEIN', 238731),
(297586, 'PTHR31272:SF6', NULL, NULL, NULL, NULL, 'CYTOCHROME C-TYPE BIOGENESIS CCDA-LIKE CHLOROPLASTIC PROTEIN', 238731),
(297587, 'PTHR31272:SF4', NULL, NULL, NULL, NULL, 'CYTOCHROME C-TYPE BIOGENESIS PROTEIN HI_1454-RELATED', 238731),
(297588, 'PTHR31272', NULL, NULL, NULL, NULL, 'CYTOCHROME C-TYPE BIOGENESIS PROTEIN HI_1454-RELATED', 238731),
(297589, 'PTHR46975:SF2', NULL, NULL, NULL, NULL, 'PROTEIN SWEETIE', 238732),
(297590, 'PTHR46975', NULL, NULL, NULL, NULL, 'PROTEIN SWEETIE', 238732),
(297591, 'PTHR42655:SF1', NULL, NULL, NULL, NULL, 'GLYCOGEN PHOSPHORYLASE', 238733),
(297592, 'PTHR42655', NULL, NULL, NULL, NULL, 'GLYCOGEN PHOSPHORYLASE', 238733),
(297593, 'PTHR30429:SF1', NULL, NULL, NULL, NULL, 'D-METHIONINE-BINDING LIPOPROTEIN METQ-RELATED', 238734),
(297594, 'PTHR30429:SF3', NULL, NULL, NULL, NULL, 'LIPOPROTEIN', 238734),
(297595, 'PTHR30429:SF0', NULL, NULL, NULL, NULL, 'METHIONINE-BINDING LIPOPROTEIN METQ', 238734),
(297596, 'PTHR30429', NULL, NULL, NULL, NULL, 'D-METHIONINE-BINDING LIPOPROTEIN METQ', 238734),
(297597, 'PTHR48190:SF2', NULL, NULL, NULL, NULL, 'PROGRAMMED CELL DEATH PROTEIN 7', 238735),
(297598, 'PTHR48190', NULL, NULL, NULL, NULL, 'PROGRAMMED CELL DEATH PROTEIN 7', 238735),
(297599, 'PTHR21098:SF12', NULL, NULL, NULL, NULL, 'RIBOFLAVIN SYNTHASE', 238736),
(297600, 'PTHR21098:SF0', NULL, NULL, NULL, NULL, 'RIBOFLAVIN SYNTHASE', 238736);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(297601, 'PTHR21098', NULL, NULL, NULL, NULL, 'RIBOFLAVIN SYNTHASE ALPHA CHAIN', 238736),
(297602, 'PTHR47740', NULL, NULL, NULL, NULL, 'LCK-INTERACTING TRANSMEMBRANE ADAPTER 1, LIME1', 238737),
(297603, 'PTHR47740:SF1', NULL, NULL, NULL, NULL, 'LCK-INTERACTING TRANSMEMBRANE ADAPTER 1', 238737),
(297604, 'PTHR33915:SF6', NULL, NULL, NULL, NULL, 'JP18', 238738),
(297605, 'PTHR33915:SF9', NULL, NULL, NULL, NULL, 'STERILE ALPHA MOTIF (SAM) DOMAIN-CONTAINING PROTEIN', 238738),
(297606, 'PTHR33915:SF14', NULL, NULL, NULL, NULL, 'JP18', 238738),
(297607, 'PTHR33915', NULL, NULL, NULL, NULL, 'OSJNBA0033G05.11 PROTEIN', 238738),
(297608, 'PTHR33915:SF13', NULL, NULL, NULL, NULL, 'STERILE ALPHA MOTIF/POINTED DOMAIN-CONTAINING PROTEIN-RELATED', 238738),
(297609, 'PTHR33915:SF15', NULL, NULL, NULL, NULL, 'OS04G0644100 PROTEIN', 238738),
(297610, 'PTHR33915:SF1', NULL, NULL, NULL, NULL, 'SAM DOMAIN-CONTAINING PROTEIN', 238738),
(297611, 'PTHR33915:SF12', NULL, NULL, NULL, NULL, 'OS06G0645500 PROTEIN', 238738),
(297612, 'PTHR33915:SF11', NULL, NULL, NULL, NULL, 'JP18', 238738),
(297613, 'PTHR33915:SF3', NULL, NULL, NULL, NULL, 'STERILE ALPHA MOTIF (SAM) DOMAIN PROTEIN', 238738),
(297614, 'PTHR14741:SF40', NULL, NULL, NULL, NULL, 'TRIMETHYLGUANOSINE SYNTHASE', 238739),
(297615, 'PTHR14741:SF41', NULL, NULL, NULL, NULL, 'TRIMETHYLGUANOSINE SYNTHASE', 238739),
(297616, 'PTHR14741:SF36', NULL, NULL, NULL, NULL, 'WW DOMAIN-CONTAINING PROTEIN', 238739),
(297617, 'PTHR14741:SF32', NULL, NULL, NULL, NULL, 'TRIMETHYLGUANOSINE SYNTHASE', 238739),
(297618, 'PTHR14741', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE-DEPENDENT METHYLTRANSFERASE RELATED', 238739),
(297619, 'PTHR36072', NULL, NULL, NULL, NULL, 'OS01G0541600 PROTEIN', 238740),
(297620, 'PTHR36072:SF2', NULL, NULL, NULL, NULL, 'OS01G0541600 PROTEIN', 238740),
(297621, 'PTHR36072:SF4', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 238740),
(297622, 'PTHR13381', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II HOLOENZYME COMPONENT SRB7', 238741),
(297623, 'PTHR13381:SF2', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 21', 238741),
(297624, 'PTHR13381:SF1', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 21', 238741),
(297625, 'PTHR13381:SF3', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 21', 238741),
(297626, 'PTHR13381:SF0', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 21', 238741),
(297627, 'PTHR11571:SF245', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE A5', 238742),
(297628, 'PTHR11571:SF92', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE', 238742),
(297629, 'PTHR11571:SF123', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE A4', 238742),
(297630, 'PTHR11571:SF244', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 238742),
(297631, 'PTHR11571:SF161', NULL, NULL, NULL, NULL, '', 238742),
(297632, 'PTHR11571:SF120', NULL, NULL, NULL, NULL, 'GST N-TERMINAL DOMAIN-CONTAINING PROTEIN-RELATED', 238742),
(297633, 'PTHR11571:SF164', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE ALPHA-1-RELATED', 238742),
(297634, 'PTHR11571:SF209', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE', 238742),
(297635, 'PTHR11571:SF99', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 238742),
(297636, 'PTHR11571:SF247', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE MU 1', 238742),
(297637, 'PTHR11571:SF126', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE MU 1', 238742),
(297638, 'PTHR11571:SF98', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE 7-RELATED', 238742),
(297639, 'PTHR11571:SF125', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE', 238742),
(297640, 'PTHR11571:SF249', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE MU 5', 238742),
(297641, 'PTHR11571:SF127', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE', 238742),
(297642, 'PTHR11571:SF248', NULL, NULL, NULL, NULL, 'GST CLASS-PI', 238742),
(297643, 'PTHR11571:SF160', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE 6-RELATED', 238742),
(297644, 'PTHR11571:SF155', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE 4', 238742);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(297645, 'PTHR11571:SF157', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE A1', 238742),
(297646, 'PTHR11571:SF233', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE-RELATED', 238742),
(297647, 'PTHR11571:SF150', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE ALPHA-2-RELATED', 238742),
(297648, 'PTHR11571:SF8', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE', 238742),
(297649, 'PTHR11571:SF153', NULL, NULL, NULL, NULL, 'GST C-TERMINAL DOMAIN-CONTAINING PROTEIN', 238742),
(297650, 'PTHR11571:SF230', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 238742),
(297651, 'PTHR11571:SF45', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE', 238742),
(297652, 'PTHR11571:SF44', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE 2-RELATED', 238742),
(297653, 'PTHR11571:SF42', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE', 238742),
(297654, 'PTHR11571:SF158', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE', 238742),
(297655, 'PTHR11571:SF116', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE DOMAIN-CONTAINING PROTEIN DDB_G0273153/DDB_G0273923', 238742),
(297656, 'PTHR11571:SF101', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE A4', 238742),
(297657, 'PTHR11571:SF222', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 238742),
(297658, 'PTHR11571:SF261', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE GST-36-RELATED', 238742),
(297659, 'PTHR11571:SF260', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE', 238742),
(297660, 'PTHR11571:SF141', NULL, NULL, NULL, NULL, 'GST CLASS-PI', 238742),
(297661, 'PTHR11571:SF107', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE A2', 238742),
(297662, 'PTHR11571', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE', 238742),
(297663, 'PTHR11571:SF224', NULL, NULL, NULL, NULL, 'HEMATOPOIETIC PROSTAGLANDIN D SYNTHASE', 238742),
(297664, 'PTHR11571:SF105', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE', 238742),
(297665, 'PTHR11571:SF254', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE MU 2', 238742),
(297666, 'PTHR11571:SF133', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE MU 3', 238742),
(297667, 'PTHR11571:SF132', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE-RELATED', 238742),
(297668, 'PTHR11571:SF253', NULL, NULL, NULL, NULL, 'S-TRANSFERASE, PUTATIVE-RELATED', 238742),
(297669, 'PTHR11571:SF256', NULL, NULL, NULL, NULL, 'GST C-TERMINAL DOMAIN-CONTAINING PROTEIN-RELATED', 238742),
(297670, 'PTHR11571:SF211', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE MU 6', 238742),
(297671, 'PTHR11571:SF255', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE P', 238742),
(297672, 'PTHR11571:SF252', NULL, NULL, NULL, NULL, '', 238742),
(297673, 'PTHR11571:SF219', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE MU 3', 238742),
(297674, 'PTHR11571:SF258', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE ALPHA-3-RELATED', 238742),
(297675, 'PTHR11571:SF137', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE MU 4', 238742),
(297676, 'PTHR11571:SF257', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE A3', 238742),
(297677, 'PTHR11571:SF259', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE', 238742),
(297678, 'PTHR46456', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RAD51 HOMOLOG 2', 238743),
(297679, 'PTHR46456:SF1', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RAD51 HOMOLOG 2', 238743),
(297680, 'PTHR15314:SF1', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P PROTEIN SUBUNIT P20', 238744),
(297681, 'PTHR15314', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P PROTEIN SUBUNIT P20', 238744),
(297682, 'PTHR11884:SF1', NULL, NULL, NULL, NULL, 'GOLGI APPARATUS PROTEIN 1', 238745),
(297683, 'PTHR11884', NULL, NULL, NULL, NULL, 'SELECTIN LIGAND RELATED', 238745),
(297684, 'PTHR31019', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 238746),
(297685, 'PTHR31019:SF1', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 14', 238746),
(297686, 'PTHR46075:SF5', NULL, NULL, NULL, NULL, '', 238747),
(297687, 'PTHR46075:SF6', NULL, NULL, NULL, NULL, 'N-CHIMAERIN', 238747),
(297688, 'PTHR46075:SF4', NULL, NULL, NULL, NULL, 'BETA-CHIMAERIN', 238747);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(297689, 'PTHR46075:SF1', NULL, NULL, NULL, NULL, 'N-CHIMAERIN', 238747),
(297690, 'PTHR46075:SF2', NULL, NULL, NULL, NULL, 'RHO GTPASE ACTIVATING PROTEIN AT 5A, ISOFORM A', 238747),
(297691, 'PTHR46075', NULL, NULL, NULL, NULL, 'CHIMERIN FAMILY MEMBER', 238747),
(297692, 'PTHR11257:SF9', NULL, NULL, NULL, NULL, 'CHEMOSENSORY PROTEIN 13', 238748),
(297693, 'PTHR11257:SF11', NULL, NULL, NULL, NULL, 'CHEMOSENSORY PROTEIN 17', 238748),
(297694, 'PTHR11257:SF8', NULL, NULL, NULL, NULL, 'GEO08457P1', 238748),
(297695, 'PTHR11257', NULL, NULL, NULL, NULL, 'CHEMOSENSORY PROTEIN-RELATED', 238748),
(297696, 'PTHR11257:SF12', NULL, NULL, NULL, NULL, 'EJACULATORY BULB-SPECIFIC PROTEIN 3', 238748),
(297697, 'PTHR11257:SF13', NULL, NULL, NULL, NULL, 'GEO07322P1-RELATED', 238748),
(297698, 'PTHR14014:SF0', NULL, NULL, NULL, NULL, 'TELOMERE REPEATS-BINDING BOUQUET FORMATION PROTEIN 1', 238749),
(297699, 'PTHR14014', NULL, NULL, NULL, NULL, 'TELOMERE REPEATS-BINDING BOUQUET FORMATION PROTEIN 1', 238749),
(297700, 'PTHR46541:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN AEBP2', 238750),
(297701, 'PTHR46541', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN AEBP2', 238750),
(297702, 'PTHR47789:SF1', NULL, NULL, NULL, NULL, 'LAS SEVENTEEN-BINDING PROTEIN 5', 238751),
(297703, 'PTHR47789:SF2', NULL, NULL, NULL, NULL, 'VHS DOMAIN-CONTAINING PROTEIN', 238751),
(297704, 'PTHR47789', NULL, NULL, NULL, NULL, 'LAS SEVENTEEN-BINDING PROTEIN 5', 238751),
(297705, 'PTHR36706', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', 238752),
(297706, 'PTHR36706:SF1', NULL, NULL, NULL, NULL, 'BNAA10G03240D PROTEIN', 238752),
(297707, 'PTHR36706:SF2', NULL, NULL, NULL, NULL, 'BNAC08G44080D PROTEIN', 238752),
(297708, 'PTHR11601:SF61', NULL, NULL, NULL, NULL, 'CYSTEINE DESULFURASE', 238753),
(297709, 'PTHR11601:SF50', NULL, NULL, NULL, NULL, 'CYSTEINE DESULFURASE ISCS 2-RELATED', 238753),
(297710, 'PTHR11601', NULL, NULL, NULL, NULL, 'CYSTEINE DESULFURYLASE FAMILY MEMBER', 238753),
(297711, 'PTHR11601:SF34', NULL, NULL, NULL, NULL, 'CYSTEINE DESULFURASE, MITOCHONDRIAL', 238753),
(297712, 'PTHR11601:SF36', NULL, NULL, NULL, NULL, 'CYSTEINE DESULFURASE NIFS-RELATED', 238753),
(297713, 'PTHR11601:SF62', NULL, NULL, NULL, NULL, 'SELENOCYSTEINE LYASE', 238753),
(297714, 'PTHR10068:SF14', NULL, NULL, NULL, NULL, 'CELL WALL ADHESIN EAP1', 238754),
(297715, 'PTHR10068:SF16', NULL, NULL, NULL, NULL, 'BONE MARROW PROTEOGLYCAN', 238754),
(297716, 'PTHR10068:SF19', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE-RELATED', 238754),
(297717, 'PTHR10068:SF8', NULL, NULL, NULL, NULL, 'PROTEOGLYCAN 3', 238754),
(297718, 'PTHR10068', NULL, NULL, NULL, NULL, 'BONE MARROW PROTEOGLYCAN', 238754),
(297719, 'PTHR10068:SF20', NULL, NULL, NULL, NULL, '', 238754),
(297720, 'PTHR10068:SF21', NULL, NULL, NULL, NULL, '', 238754),
(297721, 'PTHR10168:SF270', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297722, 'PTHR10168:SF271', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE FOLD PROTEIN-RELATED', 238755),
(297723, 'PTHR10168:SF272', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297724, 'PTHR10168:SF273', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297725, 'PTHR10168:SF311', NULL, NULL, NULL, NULL, 'MONOTHIOL GLUTAREDOXIN-S9', 238755),
(297726, 'PTHR10168:SF114', NULL, NULL, NULL, NULL, 'MONOTHIOL GLUTAREDOXIN-S2', 238755),
(297727, 'PTHR10168:SF312', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297728, 'PTHR10168:SF279', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297729, 'PTHR10168:SF235', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297730, 'PTHR10168:SF313', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-C5', 238755),
(297731, 'PTHR10168:SF115', NULL, NULL, NULL, NULL, 'MONOTHIOL GLUTAREDOXIN-S10', 238755),
(297732, 'PTHR10168:SF314', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-LIKE, PLANT II, THIOREDOXIN-LIKE FOLD PROTEIN-RELATED', 238755),
(297733, 'PTHR10168:SF237', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(297734, 'PTHR10168:SF274', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297735, 'PTHR10168:SF230', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-C1', 238755),
(297736, 'PTHR10168:SF231', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297737, 'PTHR10168:SF275', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297738, 'PTHR10168:SF232', NULL, NULL, NULL, NULL, 'MONOTHIOL GLUTAREDOXIN-S4', 238755),
(297739, 'PTHR10168:SF111', NULL, NULL, NULL, NULL, 'MONOTHIOL GLUTAREDOXIN-S13', 238755),
(297740, 'PTHR10168:SF276', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297741, 'PTHR10168:SF310', NULL, NULL, NULL, NULL, 'THIOREDOXIN SUPERFAMILY PROTEIN-RELATED', 238755),
(297742, 'PTHR10168:SF233', NULL, NULL, NULL, NULL, 'MONOTHIOL GLUTAREDOXIN-S9', 238755),
(297743, 'PTHR10168:SF277', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297744, 'PTHR10168:SF319', NULL, NULL, NULL, NULL, 'MONOTHIOL GLUTAREDOXIN-S2 PROTEIN', 238755),
(297745, 'PTHR10168:SF238', NULL, NULL, NULL, NULL, 'MONOTHIOL GLUTAREDOXIN-S1', 238755),
(297746, 'PTHR10168:SF315', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN', 238755),
(297747, 'PTHR10168:SF118', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-C12-RELATED', 238755),
(297748, 'PTHR10168:SF239', NULL, NULL, NULL, NULL, 'MONOTHIOL GLUTAREDOXIN-S2', 238755),
(297749, 'PTHR10168:SF316', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297750, 'PTHR10168:SF317', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297751, 'PTHR10168:SF318', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-LIKE, PLANT II, THIOREDOXIN-LIKE FOLD PROTEIN-RELATED', 238755),
(297752, 'PTHR10168:SF62', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-C1-LIKE', 238755),
(297753, 'PTHR10168:SF282', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297754, 'PTHR10168:SF284', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297755, 'PTHR10168:SF240', NULL, NULL, NULL, NULL, 'MONOTHIOL GLUTAREDOXIN-S1-LIKE', 238755),
(297756, 'PTHR10168:SF289', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297757, 'PTHR10168:SF246', NULL, NULL, NULL, NULL, 'THIOREDOXIN SUPERFAMILY PROTEIN-RELATED', 238755),
(297758, 'PTHR10168:SF203', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-C14', 238755),
(297759, 'PTHR10168:SF248', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297760, 'PTHR10168:SF204', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-C6-LIKE', 238755),
(297761, 'PTHR10168:SF285', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297762, 'PTHR10168:SF242', NULL, NULL, NULL, NULL, 'MONOTHIOL GLUTAREDOXIN-S1-LIKE', 238755),
(297763, 'PTHR10168:SF286', NULL, NULL, NULL, NULL, 'MONOTHIOL GLUTAREDOXIN-S3-RELATED', 238755),
(297764, 'PTHR10168:SF243', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297765, 'PTHR10168:SF287', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297766, 'PTHR10168:SF200', NULL, NULL, NULL, NULL, 'MONOTHIOL GLUTAREDOXIN-S6', 238755),
(297767, 'PTHR10168:SF56', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-C6', 238755),
(297768, 'PTHR10168:SF249', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-C9-LIKE', 238755),
(297769, 'PTHR10168:SF128', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-C7', 238755),
(297770, 'PTHR10168:SF206', NULL, NULL, NULL, NULL, 'MONOTHIOL GLUTAREDOXIN-S2 PROTEIN', 238755),
(297771, 'PTHR10168:SF208', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-C2-RELATED', 238755),
(297772, 'PTHR10168:SF293', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-LIKE, PLANT II, THIOREDOXIN-LIKE FOLD PROTEIN-RELATED', 238755),
(297773, 'PTHR10168:SF295', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-C13-LIKE', 238755),
(297774, 'PTHR10168:SF291', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-C1 PROTEIN', 238755),
(297775, 'PTHR10168:SF212', NULL, NULL, NULL, NULL, 'MONOTHIOL GLUTAREDOXIN-S1-LIKE', 238755),
(297776, 'PTHR10168:SF256', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(297777, 'PTHR10168:SF257', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297778, 'PTHR10168:SF213', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-C13', 238755),
(297779, 'PTHR10168:SF258', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297780, 'PTHR10168:SF214', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297781, 'PTHR10168:SF215', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-C3', 238755),
(297782, 'PTHR10168:SF259', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297783, 'PTHR10168:SF298', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297784, 'PTHR10168:SF210', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297785, 'PTHR10168:SF254', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297786, 'PTHR10168:SF211', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-C11', 238755),
(297787, 'PTHR10168:SF299', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297788, 'PTHR10168:SF255', NULL, NULL, NULL, NULL, 'THIOREDOXIN SUPERFAMILY PROTEIN-RELATED', 238755),
(297789, 'PTHR10168:SF216', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-C8', 238755),
(297790, 'PTHR10168:SF219', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-C9', 238755),
(297791, 'PTHR10168', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN', 238755),
(297792, 'PTHR10168:SF83', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-C15', 238755),
(297793, 'PTHR10168:SF260', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297794, 'PTHR10168:SF261', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297795, 'PTHR10168:SF262', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-LIKE, PLANT II, THIOREDOXIN-LIKE FOLD PROTEIN-RELATED', 238755),
(297796, 'PTHR10168:SF300', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-C13', 238755),
(297797, 'PTHR10168:SF223', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-C10', 238755),
(297798, 'PTHR10168:SF267', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297799, 'PTHR10168:SF301', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN', 238755),
(297800, 'PTHR10168:SF224', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-C13', 238755),
(297801, 'PTHR10168:SF225', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297802, 'PTHR10168:SF226', NULL, NULL, NULL, NULL, 'MONOTHIOL GLUTAREDOXIN-S1-LIKE', 238755),
(297803, 'PTHR10168:SF303', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-C14-RELATED', 238755),
(297804, 'PTHR10168:SF263', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297805, 'PTHR10168:SF186', NULL, NULL, NULL, NULL, 'MONOTHIOL GLUTAREDOXIN-S1-LIKE', 238755),
(297806, 'PTHR10168:SF220', NULL, NULL, NULL, NULL, 'MONOTHIOL GLUTAREDOXIN-S2-LIKE', 238755),
(297807, 'PTHR10168:SF265', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297808, 'PTHR10168:SF221', NULL, NULL, NULL, NULL, 'MONOTHIOL GLUTAREDOXIN-S5', 238755),
(297809, 'PTHR10168:SF222', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-C9', 238755),
(297810, 'PTHR10168:SF266', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297811, 'PTHR10168:SF308', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297812, 'PTHR10168:SF309', NULL, NULL, NULL, NULL, 'MONOTHIOL GLUTAREDOXIN-S11', 238755),
(297813, 'PTHR10168:SF304', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 238755),
(297814, 'PTHR10168:SF228', NULL, NULL, NULL, NULL, 'MONOTHIOL GLUTAREDOXIN-S3-LIKE', 238755),
(297815, 'PTHR10168:SF72', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-C13', 238755),
(297816, 'PTHR31088:SF11', NULL, NULL, NULL, NULL, '', 238756),
(297817, 'PTHR31088:SF6', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED PROTEIN VIPP1, CHLOROPLASTIC', 238756),
(297818, 'PTHR31088:SF9', NULL, NULL, NULL, NULL, 'PHAGE SHOCK PROTEIN A-RELATED', 238756),
(297819, 'PTHR31088', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED PROTEIN VIPP1, CHLOROPLASTIC', 238756),
(297820, 'PTHR34124:SF18', NULL, NULL, NULL, NULL, 'OS04G0496300 PROTEIN', 238757);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(297821, 'PTHR34124:SF12', NULL, NULL, NULL, NULL, 'GB|AAF32471.1', 238757),
(297822, 'PTHR34124:SF2', NULL, NULL, NULL, NULL, 'F16B3.27 PROTEIN-RELATED', 238757),
(297823, 'PTHR34124:SF13', NULL, NULL, NULL, NULL, '', 238757),
(297824, 'PTHR34124:SF10', NULL, NULL, NULL, NULL, 'OS01G0896400 PROTEIN', 238757),
(297825, 'PTHR34124:SF11', NULL, NULL, NULL, NULL, '', 238757),
(297826, 'PTHR34124', NULL, NULL, NULL, NULL, 'F16B3.27 PROTEIN-RELATED', 238757),
(297827, 'PTHR34124:SF14', NULL, NULL, NULL, NULL, '', 238757),
(297828, 'PTHR10160', NULL, NULL, NULL, NULL, 'NAD(P) TRANSHYDROGENASE', 238758),
(297829, 'PTHR10160:SF19', NULL, NULL, NULL, NULL, 'PROTON-TRANSLOCATING NAD(P)(+) TRANSHYDROGENASE', 238758),
(297830, 'PTHR10160:SF22', NULL, NULL, NULL, NULL, 'NAD(P) TRANSHYDROGENASE, MITOCHONDRIAL', 238758),
(297831, 'PTHR10160:SF30', NULL, NULL, NULL, NULL, 'PROTON-TRANSLOCATING NAD(P)(+) TRANSHYDROGENASE', 238758),
(297832, 'PTHR12499:SF23', NULL, NULL, NULL, NULL, 'OPA3-LIKE PROTEIN-RELATED', 238759),
(297833, 'PTHR12499:SF12', NULL, NULL, NULL, NULL, 'OS01G0753150 PROTEIN', 238759),
(297834, 'PTHR12499:SF11', NULL, NULL, NULL, NULL, 'OPA3-LIKE PROTEIN', 238759),
(297835, 'PTHR12499:SF22', NULL, NULL, NULL, NULL, 'OPTIC ATROPHY 3 PROTEIN (OPA3)', 238759),
(297836, 'PTHR12499:SF0', NULL, NULL, NULL, NULL, 'OPTIC ATROPHY 3 PROTEIN', 238759),
(297837, 'PTHR12499', NULL, NULL, NULL, NULL, 'OPTIC ATROPHY 3 PROTEIN  OPA3', 238759),
(297838, 'PTHR12499:SF21', NULL, NULL, NULL, NULL, 'BNAA07G08310D PROTEIN', 238759),
(297839, 'PTHR34205', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 238760),
(297840, 'PTHR34205:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 238760),
(297841, 'PTHR23070:SF130', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297842, 'PTHR23070:SF131', NULL, NULL, NULL, NULL, 'PROTEIN HYPER-SENSITIVITY-RELATED 4-LIKE', 238761),
(297843, 'PTHR23070:SF132', NULL, NULL, NULL, NULL, 'ATP BINDING PROTEIN', 238761),
(297844, 'PTHR23070:SF133', NULL, NULL, NULL, NULL, 'OS07G0192800 PROTEIN', 238761),
(297845, 'PTHR23070:SF124', NULL, NULL, NULL, NULL, 'ATPASE, AAA FAMILY PROTEIN, EXPRESSED', 238761),
(297846, 'PTHR23070', NULL, NULL, NULL, NULL, 'BCS1 AAA-TYPE ATPASE', 238761),
(297847, 'PTHR23070:SF126', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297848, 'PTHR23070:SF127', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297849, 'PTHR23070:SF128', NULL, NULL, NULL, NULL, 'AAA-ATPASE ASD, MITOCHONDRIAL', 238761),
(297850, 'PTHR23070:SF21', NULL, NULL, NULL, NULL, 'ATPASE, AAA-TYPE, CORE, AAA-TYPE ATPASE DOMAIN-CONTAINING PROTEIN-RELATED', 238761),
(297851, 'PTHR23070:SF20', NULL, NULL, NULL, NULL, 'OS07G0192000 PROTEIN', 238761),
(297852, 'PTHR23070:SF94', NULL, NULL, NULL, NULL, 'PROTEIN HYPER-SENSITIVITY-RELATED 4-LIKE', 238761),
(297853, 'PTHR23070:SF92', NULL, NULL, NULL, NULL, '', 238761),
(297854, 'PTHR23070:SF90', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN', 238761),
(297855, 'PTHR23070:SF120', NULL, NULL, NULL, NULL, 'AAA-ATPASE ASD MITOCHONDRIAL', 238761),
(297856, 'PTHR23070:SF122', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CHAPERONE BCS1', 238761),
(297857, 'PTHR23070:SF123', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN ISOFORM 1', 238761),
(297858, 'PTHR23070:SF114', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297859, 'PTHR23070:SF115', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297860, 'PTHR23070:SF116', NULL, NULL, NULL, NULL, 'OS03G0802600 PROTEIN', 238761),
(297861, 'PTHR23070:SF118', NULL, NULL, NULL, NULL, 'OS05G0588850 PROTEIN', 238761),
(297862, 'PTHR23070:SF14', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297863, 'PTHR23070:SF10', NULL, NULL, NULL, NULL, 'AAA ATPASE DOMAIN-CONTAINING PROTEIN', 238761),
(297864, 'PTHR23070:SF11', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CHAPERONE BCS1', 238761),
(297865, 'PTHR23070:SF99', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(297866, 'PTHR23070:SF84', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297867, 'PTHR23070:SF80', NULL, NULL, NULL, NULL, 'OS12G0470700 PROTEIN', 238761),
(297868, 'PTHR23070:SF190', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN-RELATED', 238761),
(297869, 'PTHR23070:SF192', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297870, 'PTHR23070:SF193', NULL, NULL, NULL, NULL, 'OS07G0192700 PROTEIN', 238761),
(297871, 'PTHR23070:SF194', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297872, 'PTHR23070:SF195', NULL, NULL, NULL, NULL, 'OS12G0639500 PROTEIN', 238761),
(297873, 'PTHR23070:SF198', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297874, 'PTHR23070:SF110', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297875, 'PTHR23070:SF199', NULL, NULL, NULL, NULL, 'OS01G0605100 PROTEIN', 238761),
(297876, 'PTHR23070:SF111', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297877, 'PTHR23070:SF223', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297878, 'PTHR23070:SF102', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PROTEIN-LIKE CONTAINS SIMILARITY TO AAA-TYPE ATPASE', 238761),
(297879, 'PTHR23070:SF224', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297880, 'PTHR23070:SF225', NULL, NULL, NULL, NULL, 'P-LOOP NUCLEOSIDE TRIPHOSPHATE HYDROLASE SUPERFAMILY PROTEIN', 238761),
(297881, 'PTHR23070:SF226', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297882, 'PTHR23070:SF105', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297883, 'PTHR23070:SF108', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297884, 'PTHR23070:SF89', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297885, 'PTHR23070:SF87', NULL, NULL, NULL, NULL, 'ATPASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G14760)-RELATED', 238761),
(297886, 'PTHR23070:SF88', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297887, 'PTHR23070:SF180', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297888, 'PTHR23070:SF183', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297889, 'PTHR23070:SF185', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 238761),
(297890, 'PTHR23070:SF220', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297891, 'PTHR23070:SF187', NULL, NULL, NULL, NULL, 'OS06G0697600 PROTEIN', 238761),
(297892, 'PTHR23070:SF100', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN', 238761),
(297893, 'PTHR23070:SF221', NULL, NULL, NULL, NULL, 'AAA_ASSOC DOMAIN-CONTAINING PROTEIN', 238761),
(297894, 'PTHR23070:SF189', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297895, 'PTHR23070:SF222', NULL, NULL, NULL, NULL, 'AAA-ATPASE ASD, MITOCHONDRIAL-LIKE', 238761),
(297896, 'PTHR23070:SF179', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297897, 'PTHR23070:SF212', NULL, NULL, NULL, NULL, 'P-LOOP NUCLEOSIDE TRIPHOSPHATE HYDROLASE SUPERFAMILY PROTEIN', 238761),
(297898, 'PTHR23070:SF213', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297899, 'PTHR23070:SF214', NULL, NULL, NULL, NULL, 'ATPASE_AAA_CORE DOMAIN-CONTAINING PROTEIN', 238761),
(297900, 'PTHR23070:SF215', NULL, NULL, NULL, NULL, 'AAA_ASSOC DOMAIN-CONTAINING PROTEIN', 238761),
(297901, 'PTHR23070:SF216', NULL, NULL, NULL, NULL, 'ATPASE_AAA_CORE DOMAIN-CONTAINING PROTEIN', 238761),
(297902, 'PTHR23070:SF217', NULL, NULL, NULL, NULL, 'ATPASE, AAA-TYPE, CORE-RELATED', 238761),
(297903, 'PTHR23070:SF218', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297904, 'PTHR23070:SF219', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297905, 'PTHR23070:SF173', NULL, NULL, NULL, NULL, 'OS06G0697500 PROTEIN', 238761),
(297906, 'PTHR23070:SF176', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(297907, 'PTHR23070:SF210', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 238761),
(297908, 'PTHR23070:SF177', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297909, 'PTHR23070:SF211', NULL, NULL, NULL, NULL, 'BC1 SYNTHESIS, PUTATIVE-RELATED', 238761),
(297910, 'PTHR23070:SF178', NULL, NULL, NULL, NULL, 'AAA_ASSOC DOMAIN-CONTAINING PROTEIN', 238761),
(297911, 'PTHR23070:SF201', NULL, NULL, NULL, NULL, 'AAA-ATPASE ASD MITOCHONDRIAL', 238761),
(297912, 'PTHR23070:SF168', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297913, 'PTHR23070:SF169', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297914, 'PTHR23070:SF203', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297915, 'PTHR23070:SF205', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297916, 'PTHR23070:SF206', NULL, NULL, NULL, NULL, 'ATPASE_AAA_CORE DOMAIN-CONTAINING PROTEIN', 238761),
(297917, 'PTHR23070:SF207', NULL, NULL, NULL, NULL, 'BNAANNG09720D PROTEIN', 238761),
(297918, 'PTHR23070:SF208', NULL, NULL, NULL, NULL, 'PROTEIN HYPER-SENSITIVITY-RELATED 4', 238761),
(297919, 'PTHR23070:SF209', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297920, 'PTHR23070:SF163', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297921, 'PTHR23070:SF165', NULL, NULL, NULL, NULL, 'ATPASE, AAA-TYPE, CORE-RELATED', 238761),
(297922, 'PTHR23070:SF166', NULL, NULL, NULL, NULL, 'ATP BINDING PROTEIN', 238761),
(297923, 'PTHR23070:SF200', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297924, 'PTHR23070:SF157', NULL, NULL, NULL, NULL, 'NUCLEOSIDE TRIPHOSPHATE HYDROLASE SUPERFAMILY PROTEIN, PUTATIVE-RELATED', 238761),
(297925, 'PTHR23070:SF159', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297926, 'PTHR23070:SF9', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CHAPERONE BCS1-A-RELATED', 238761),
(297927, 'PTHR23070:SF52', NULL, NULL, NULL, NULL, 'CHAPERONE, PUTATIVE-RELATED', 238761),
(297928, 'PTHR23070:SF150', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297929, 'PTHR23070:SF152', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297930, 'PTHR23070:SF153', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297931, 'PTHR23070:SF155', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297932, 'PTHR23070:SF146', NULL, NULL, NULL, NULL, 'ATP BINDING PROTEIN', 238761),
(297933, 'PTHR23070:SF147', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297934, 'PTHR23070:SF43', NULL, NULL, NULL, NULL, 'OS09G0445700 PROTEIN', 238761),
(297935, 'PTHR23070:SF141', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE-RELATED', 238761),
(297936, 'PTHR23070:SF143', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 238761),
(297937, 'PTHR23070:SF144', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CHAPERONE BCS1', 238761),
(297938, 'PTHR23070:SF138', NULL, NULL, NULL, NULL, 'AAA-ATPASE ASD MITOCHONDRIAL', 238761),
(297939, 'PTHR23070:SF37', NULL, NULL, NULL, NULL, 'OS07G0517600 PROTEIN', 238761),
(297940, 'PTHR23070:SF34', NULL, NULL, NULL, NULL, 'OS01G0641800 PROTEIN', 238761),
(297941, 'PTHR11773', NULL, NULL, NULL, NULL, 'GLYCINE DEHYDROGENASE, DECARBOXYLATING', 238762),
(297942, 'PTHR11773:SF12', NULL, NULL, NULL, NULL, 'GLYCINE CLEAVAGE SYSTEM P PROTEIN', 238762),
(297943, 'PTHR11773:SF1', NULL, NULL, NULL, NULL, 'GLYCINE DEHYDROGENASE (DECARBOXYLATING), MITOCHONDRIAL', 238762),
(297944, 'PTHR26454:SF50', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297945, 'PTHR26454:SF14', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297946, 'PTHR26454:SF12', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 6F1', 238763),
(297947, 'PTHR26454:SF56', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297948, 'PTHR26454:SF55', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297949, 'PTHR26454', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297950, 'PTHR26454:SF10', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 6V1', 238763);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(297951, 'PTHR26454:SF53', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 6J1', 238763),
(297952, 'PTHR26454:SF51', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 6M1', 238763),
(297953, 'PTHR26454:SF9', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 6C4', 238763),
(297954, 'PTHR26454:SF8', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 6C2', 238763),
(297955, 'PTHR26454:SF19', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 6C68', 238763),
(297956, 'PTHR26454:SF7', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 6S1', 238763),
(297957, 'PTHR26454:SF18', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 6C76', 238763),
(297958, 'PTHR26454:SF17', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 6C70', 238763),
(297959, 'PTHR26454:SF6', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297960, 'PTHR26454:SF16', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2AP1', 238763),
(297961, 'PTHR26454:SF5', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297962, 'PTHR26454:SF4', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297963, 'PTHR26454:SF59', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297964, 'PTHR26454:SF15', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 6C65', 238763),
(297965, 'PTHR26454:SF3', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297966, 'PTHR26454:SF2', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 49', 238763),
(297967, 'PTHR26454:SF1', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297968, 'PTHR26454:SF0', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297969, 'PTHR26454:SF61', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297970, 'PTHR26454:SF60', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297971, 'PTHR26454:SF25', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297972, 'PTHR26454:SF23', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 807', 238763),
(297973, 'PTHR26454:SF22', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297974, 'PTHR26454:SF21', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297975, 'PTHR26454:SF62', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297976, 'PTHR26454:SF166', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR FAMILY 6 SUBFAMILY D MEMBER 6', 238763),
(297977, 'PTHR26454:SF165', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 6T1', 238763),
(297978, 'PTHR26454:SF162', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297979, 'PTHR26454:SF29', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297980, 'PTHR26454:SF164', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297981, 'PTHR26454:SF27', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 6C1', 238763),
(297982, 'PTHR26454:SF163', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297983, 'PTHR26454:SF26', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297984, 'PTHR26454:SF72', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 6C74', 238763),
(297985, 'PTHR26454:SF70', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297986, 'PTHR26454:SF36', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297987, 'PTHR26454:SF35', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297988, 'PTHR26454:SF79', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 6C75', 238763),
(297989, 'PTHR26454:SF78', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297990, 'PTHR26454:SF160', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297991, 'PTHR26454:SF33', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297992, 'PTHR26454:SF77', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297993, 'PTHR26454:SF32', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297994, 'PTHR26454:SF76', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297995, 'PTHR26454:SF31', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 214', 238763),
(297996, 'PTHR26454:SF74', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297997, 'PTHR26454:SF30', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 6X1', 238763),
(297998, 'PTHR26454:SF73', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(297999, 'PTHR26454:SF155', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 238763);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(298000, 'PTHR26454:SF154', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(298001, 'PTHR26454:SF156', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(298002, 'PTHR26454:SF39', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 6C3', 238763),
(298003, 'PTHR26454:SF152', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 212-RELATED', 238763),
(298004, 'PTHR26454:SF159', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(298005, 'PTHR26454:SF158', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(298006, 'PTHR26454:SF47', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(298007, 'PTHR26454:SF45', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(298008, 'PTHR26454:SF44', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(298009, 'PTHR26454:SF43', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(298010, 'PTHR26454:SF42', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 238763),
(298011, 'PTHR26454:SF40', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 6C6', 238763),
(298012, 'PTHR35275:SF9', NULL, NULL, NULL, NULL, '', 238764),
(298013, 'PTHR35275:SF12', NULL, NULL, NULL, NULL, 'ZCF37', 238764),
(298014, 'PTHR35275:SF11', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 238764),
(298015, 'PTHR35275:SF8', NULL, NULL, NULL, NULL, 'BNAC04G18610D PROTEIN', 238764),
(298016, 'PTHR35275:SF7', NULL, NULL, NULL, NULL, 'BNAA08G25890D PROTEIN', 238764),
(298017, 'PTHR35275:SF10', NULL, NULL, NULL, NULL, '', 238764),
(298018, 'PTHR35275:SF2', NULL, NULL, NULL, NULL, 'OS07G0585900 PROTEIN', 238764),
(298019, 'PTHR35275:SF1', NULL, NULL, NULL, NULL, 'OS03G0432000 PROTEIN', 238764),
(298020, 'PTHR35275', NULL, NULL, NULL, NULL, 'ZCF37', 238764),
(298021, 'PTHR35275:SF4', NULL, NULL, NULL, NULL, '', 238764),
(298022, 'PTHR35275:SF3', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 238764),
(298023, 'PTHR36112:SF1', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA SMALL SUBUNIT METHYLTRANSFERASE J', 238765),
(298024, 'PTHR36112', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA SMALL SUBUNIT METHYLTRANSFERASE J', 238765),
(298025, 'PTHR43575:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ABCI7, CHLOROPLASTIC', 238766),
(298026, 'PTHR43575', NULL, NULL, NULL, NULL, 'PROTEIN ABCI7, CHLOROPLASTIC', 238766),
(298027, 'PTHR43755', NULL, NULL, NULL, NULL, '', 238767),
(298028, 'PTHR43755:SF2', NULL, NULL, NULL, NULL, 'FAD-DEPENDENT PYRIDINE NUCLEOTIDE-DISULPHIDE OXIDOREDUCTASE', 238767),
(298029, 'PTHR43755:SF1', NULL, NULL, NULL, NULL, 'POSSIBLE DEHYDROGENASE/REDUCTASE', 238767),
(298030, 'PTHR31278', NULL, NULL, NULL, NULL, 'CHCHD1', 238768),
(298031, 'PTHR31278:SF2', NULL, NULL, NULL, NULL, 'COILED-COIL-HELIX-COILED-COIL-HELIX DOMAIN-CONTAINING PROTEIN 1', 238768),
(298032, 'PTHR14919:SF0', NULL, NULL, NULL, NULL, 'SPERM FLAGELLAR PROTEIN 2', 238769),
(298033, 'PTHR14919', NULL, NULL, NULL, NULL, 'KPL2-RELATED', 238769),
(298034, 'PTHR43510:SF1', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE FUNCTION, HYPOTHETICAL (EUROFUNG)', 238770),
(298035, 'PTHR43510', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE FUNCTION, HYPOTHETICAL (EUROFUNG)', 238770),
(298036, 'PTHR34778', NULL, NULL, NULL, NULL, 'OS02G0580700 PROTEIN', 238771),
(298037, 'PTHR34778:SF4', NULL, NULL, NULL, NULL, 'BNAA07G31790D PROTEIN', 238771),
(298038, 'PTHR34778:SF5', NULL, NULL, NULL, NULL, '', 238771),
(298039, 'PTHR34778:SF2', NULL, NULL, NULL, NULL, 'OS02G0580700 PROTEIN', 238771),
(298040, 'PTHR34778:SF1', NULL, NULL, NULL, NULL, '', 238771),
(298041, 'PTHR13674:SF3', NULL, NULL, NULL, NULL, 'PROTEIN FAM162B', 238772),
(298042, 'PTHR13674:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM162A', 238772),
(298043, 'PTHR13674:SF5', NULL, NULL, NULL, NULL, 'UPF0389 PROTEIN CG9231', 238772),
(298044, 'PTHR13674', NULL, NULL, NULL, NULL, 'GROWTH AND TRANSFORMATION-DEPENDENT PROTEIN', 238772),
(298045, 'PTHR46178:SF2', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 238773),
(298046, 'PTHR46178:SF9', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 238773),
(298047, 'PTHR46178:SF8', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 238773),
(298048, 'PTHR46178:SF13', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 238773);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(298049, 'PTHR46178:SF12', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 238773),
(298050, 'PTHR46178', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 238773),
(298051, 'PTHR46178:SF11', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 238773),
(298052, 'PTHR46178:SF10', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 238773),
(298053, 'PTHR46178:SF4', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 238773),
(298054, 'PTHR46178:SF3', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 238773),
(298055, 'PTHR14879:SF5', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 238774),
(298056, 'PTHR14879:SF17', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 34B', 238774),
(298057, 'PTHR14879:SF15', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RIFIFYLIN-LIKE PROTEIN', 238774),
(298058, 'PTHR14879:SF16', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE CBLA-RELATED', 238774),
(298059, 'PTHR14879', NULL, NULL, NULL, NULL, 'CASPASE REGULATOR, RING FINGER DOMAIN-CONTAINING', 238774),
(298060, 'PTHR14879:SF3', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF34', 238774),
(298061, 'PTHR14879:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RIFIFYLIN', 238774),
(298062, 'PTHR37576:SF2', NULL, NULL, NULL, NULL, '', 238775),
(298063, 'PTHR37576', NULL, NULL, NULL, NULL, '', 238775),
(298064, 'PTHR33930:SF2', NULL, NULL, NULL, NULL, 'BLR3452 PROTEIN', 238776),
(298065, 'PTHR33930', NULL, NULL, NULL, NULL, 'ALKYL HYDROPEROXIDE REDUCTASE AHPD', 238776),
(298066, 'PTHR33930:SF7', NULL, NULL, NULL, NULL, 'ALKYL HYDROPEROXIDE REDUCTASE AHPD', 238776),
(298067, 'PTHR46892', NULL, NULL, NULL, NULL, 'VISUAL SYSTEM HOMEOBOX 2', 238777),
(298068, 'PTHR46892:SF1', NULL, NULL, NULL, NULL, 'VISUAL SYSTEM HOMEOBOX 2', 238777),
(298069, 'PTHR31633:SF5', NULL, NULL, NULL, NULL, 'H/ACA RIBONUCLEOPROTEIN COMPLEX NON-CORE SUBUNIT NAF1', 238778),
(298070, 'PTHR31633', NULL, NULL, NULL, NULL, 'H/ACA RIBONUCLEOPROTEIN COMPLEX NON-CORE SUBUNIT NAF1', 238778),
(298071, 'PTHR31633:SF1', NULL, NULL, NULL, NULL, 'H/ACA RIBONUCLEOPROTEIN COMPLEX NON-CORE SUBUNIT NAF1', 238778),
(298072, 'PTHR37325:SF1', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE 21 KDA SUBUNIT, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G05910)-RELATED', 238779),
(298073, 'PTHR37325', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE 21 KDA SUBUNIT, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G05910)-RELATED', 238779),
(298074, 'PTHR34378:SF4', NULL, NULL, NULL, NULL, 'GLUTAMATE--CYSTEINE LIGASE', 238780),
(298075, 'PTHR34378:SF6', NULL, NULL, NULL, NULL, 'GLUTAMATE--CYSTEINE LIGASE', 238780),
(298076, 'PTHR34378:SF1', NULL, NULL, NULL, NULL, 'GLUTAMATE--CYSTEINE LIGASE, CHLOROPLASTIC', 238780),
(298077, 'PTHR34378:SF3', NULL, NULL, NULL, NULL, 'GAMMA GLUTAMYL CYSTEINE SYNTHETASE', 238780),
(298078, 'PTHR34378', NULL, NULL, NULL, NULL, 'GLUTAMATE--CYSTEINE LIGASE, CHLOROPLASTIC', 238780),
(298079, 'PTHR12561:SF3', NULL, NULL, NULL, NULL, 'LIPOYLTRANSFERASE 1, MITOCHONDRIAL', 238781),
(298080, 'PTHR12561', NULL, NULL, NULL, NULL, 'LIPOATE-PROTEIN LIGASE', 238781),
(298081, 'PTHR17384:SF7', NULL, NULL, NULL, NULL, 'P-SELECTIN GLYCOPROTEIN LIGAND 1', 238782),
(298082, 'PTHR17384', NULL, NULL, NULL, NULL, 'P-SELECTIN GLYCOPROTEIN LIGAND-1', 238782),
(298083, 'PTHR46136:SF18', NULL, NULL, NULL, NULL, 'NET DOMAIN-CONTAINING PROTEIN', 238783),
(298084, 'PTHR46136:SF29', NULL, NULL, NULL, NULL, 'BNAC03G48040D PROTEIN', 238783),
(298085, 'PTHR46136:SF19', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GTE12', 238783),
(298086, 'PTHR46136:SF8', NULL, NULL, NULL, NULL, 'OS05G0324000 PROTEIN', 238783),
(298087, 'PTHR46136:SF7', NULL, NULL, NULL, NULL, 'BROMO DOMAIN-CONTAINING PROTEIN', 238783),
(298088, 'PTHR46136:SF5', NULL, NULL, NULL, NULL, '', 238783),
(298089, 'PTHR46136', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GTE8', 238783),
(298090, 'PTHR46136:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GTE10', 238783),
(298091, 'PTHR46136:SF30', NULL, NULL, NULL, NULL, 'BROMO DOMAIN-CONTAINING PROTEIN', 238783),
(298092, 'PTHR46136:SF31', NULL, NULL, NULL, NULL, 'BNAA06G25570D PROTEIN', 238783);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(298093, 'PTHR46136:SF14', NULL, NULL, NULL, NULL, 'NET DOMAIN-CONTAINING PROTEIN', 238783),
(298094, 'PTHR46136:SF25', NULL, NULL, NULL, NULL, 'BROMO DOMAIN-CONTAINING PROTEIN', 238783),
(298095, 'PTHR46136:SF26', NULL, NULL, NULL, NULL, 'BNAA09G01940D PROTEIN', 238783),
(298096, 'PTHR46136:SF27', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GTE8', 238783),
(298097, 'PTHR46136:SF28', NULL, NULL, NULL, NULL, '', 238783),
(298098, 'PTHR46136:SF32', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GTE8', 238783),
(298099, 'PTHR46136:SF22', NULL, NULL, NULL, NULL, 'BROMODOMAIN AND EXTRATERMINAL DOMAIN PROTEIN 9-RELATED', 238783),
(298100, 'PTHR46136:SF23', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GTE11-RELATED', 238783),
(298101, 'PTHR32080', NULL, NULL, NULL, NULL, 'ANTIFUNGAL PROTEIN GINKBILOBIN-2-LIKE', 238784),
(298102, 'PTHR32080:SF29', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH REPEAT SECRETORY PROTEIN 38-LIKE', 238784),
(298103, 'PTHR32080:SF44', NULL, NULL, NULL, NULL, 'BNAC02G20110D PROTEIN', 238784),
(298104, 'PTHR32080:SF6', NULL, NULL, NULL, NULL, 'PLASMODESMATA-LOCATED PROTEIN 4', 238784),
(298105, 'PTHR32080:SF7', NULL, NULL, NULL, NULL, 'OS02G0643900 PROTEIN', 238784),
(298106, 'PTHR32080:SF64', NULL, NULL, NULL, NULL, 'GNK2-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 238784),
(298107, 'PTHR32080:SF42', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH REPEAT SECRETORY PROTEIN 60-LIKE', 238784),
(298108, 'PTHR32080:SF65', NULL, NULL, NULL, NULL, '', 238784),
(298109, 'PTHR32080:SF43', NULL, NULL, NULL, NULL, 'GNK2-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 238784),
(298110, 'PTHR32080:SF48', NULL, NULL, NULL, NULL, 'BNAA02G37170D PROTEIN', 238784),
(298111, 'PTHR32080:SF2', NULL, NULL, NULL, NULL, 'PLASMODESMATA-LOCATED PROTEIN 8', 238784),
(298112, 'PTHR32080:SF26', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH REPEAT SECRETORY PROTEIN 3-LIKE ISOFORM X1', 238784),
(298113, 'PTHR32080:SF3', NULL, NULL, NULL, NULL, 'PLASMODESMATA-LOCATED PROTEIN 7', 238784),
(298114, 'PTHR32080:SF27', NULL, NULL, NULL, NULL, 'OS01G0548750 PROTEIN', 238784),
(298115, 'PTHR32080:SF46', NULL, NULL, NULL, NULL, 'GNK2-HOMOLOGOUS DOMAIN-CONTAINING PROTEIN', 238784),
(298116, 'PTHR32080:SF24', NULL, NULL, NULL, NULL, 'PLASMODESMATA-LOCATED PROTEIN 2', 238784),
(298117, 'PTHR32080:SF47', NULL, NULL, NULL, NULL, 'PROTEIN KINASE FAMILY PROTEIN', 238784),
(298118, 'PTHR32080:SF40', NULL, NULL, NULL, NULL, 'PLASMODESMATA-LOCATED PROTEIN 1-RELATED', 238784),
(298119, 'PTHR32080:SF62', NULL, NULL, NULL, NULL, 'PLASMODESMATA-LOCATED PROTEIN 3', 238784),
(298120, 'PTHR32080:SF41', NULL, NULL, NULL, NULL, 'BNAA02G37140D PROTEIN', 238784),
(298121, 'PTHR32080:SF63', NULL, NULL, NULL, NULL, 'OS06G0253600 PROTEIN', 238784),
(298122, 'PTHR32080:SF55', NULL, NULL, NULL, NULL, 'BNAC02G41280D PROTEIN', 238784),
(298123, 'PTHR32080:SF31', NULL, NULL, NULL, NULL, 'PLASMODESMATA-LOCATED PROTEIN 6', 238784),
(298124, 'PTHR32080:SF53', NULL, NULL, NULL, NULL, 'GNK2-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 238784),
(298125, 'PTHR32080:SF54', NULL, NULL, NULL, NULL, 'GNK2-HOMOLOGOUS DOMAIN-CONTAINING PROTEIN', 238784),
(298126, 'PTHR32080:SF59', NULL, NULL, NULL, NULL, 'PLASMODESMATA-LOCATED PROTEIN 5', 238784),
(298127, 'PTHR32080:SF57', NULL, NULL, NULL, NULL, 'BNAC03G71000D PROTEIN', 238784),
(298128, 'PTHR32080:SF58', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH REPEAT SECRETORY PROTEIN 39-LIKE', 238784),
(298129, 'PTHR32080:SF36', NULL, NULL, NULL, NULL, 'PLASMODESMATA-LOCATED PROTEIN 1', 238784),
(298130, 'PTHR32080:SF51', NULL, NULL, NULL, NULL, 'GNK2-HOMOLOGOUS DOMAIN-CONTAINING PROTEIN', 238784),
(298131, 'PTHR32080:SF52', NULL, NULL, NULL, NULL, 'GNK2-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 238784),
(298132, 'PTHR32080:SF50', NULL, NULL, NULL, NULL, 'ANTIFUNGAL PROTEIN GINKBILOBIN-2-LIKE', 238784),
(298133, 'PTHR21102:SF0', NULL, NULL, NULL, NULL, 'OPALIN', 238785),
(298134, 'PTHR21102', NULL, NULL, NULL, NULL, 'OPALIN', 238785),
(298135, 'PTHR43446', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 238786),
(298136, 'PTHR43446:SF1', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 238786);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(298137, 'PTHR10613:SF0', NULL, NULL, NULL, NULL, 'LEUKOCYTE SURFACE ANTIGEN CD47', 238787),
(298138, 'PTHR10613', NULL, NULL, NULL, NULL, 'LEUKOCYTE SURFACE ANTIGEN CD47', 238787),
(298139, 'PTHR31619:SF6', NULL, NULL, NULL, NULL, 'OS03G0732000 PROTEIN', 238788),
(298140, 'PTHR31619:SF5', NULL, NULL, NULL, NULL, '4-HYDROXY-3-METHYLBUT-2-ENYL DIPHOSPHATE REDUCTASE, CHLOROPLASTIC', 238788),
(298141, 'PTHR31619', NULL, NULL, NULL, NULL, '4-HYDROXY-3-METHYLBUT-2-ENYL DIPHOSPHATE REDUCTASE, CHLOROPLASTIC', 238788),
(298142, 'PTHR37346:SF1', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 19', 238789),
(298143, 'PTHR37346', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 19', 238789),
(298144, 'PTHR47252:SF4', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 238790),
(298145, 'PTHR47252:SF5', NULL, NULL, NULL, NULL, 'GLYCOS_TRANSF_1 DOMAIN-CONTAINING PROTEIN', 238790),
(298146, 'PTHR47252', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 238790),
(298147, 'PTHR38530', NULL, NULL, NULL, NULL, 'OS06G0468300 PROTEIN', 238791),
(298148, 'PTHR38530:SF1', NULL, NULL, NULL, NULL, 'OS06G0468400 PROTEIN', 238791),
(298149, 'PTHR47719', NULL, NULL, NULL, NULL, 'SKP1-INTERACTING PARTNER 15', 238792),
(298150, 'PTHR47719:SF2', NULL, NULL, NULL, NULL, 'SKP1-INTERACTING PARTNER 15', 238792),
(298151, 'PTHR11407:SF28', NULL, NULL, NULL, NULL, 'LYSOZYME C', 238793),
(298152, 'PTHR11407:SF27', NULL, NULL, NULL, NULL, '9530003J23RIK PROTEIN', 238793),
(298153, 'PTHR11407:SF69', NULL, NULL, NULL, NULL, 'LYSOZYME C, MILK ISOZYME', 238793),
(298154, 'PTHR11407:SF25', NULL, NULL, NULL, NULL, 'SPERM ACROSOME MEMBRANE-ASSOCIATED PROTEIN 3', 238793),
(298155, 'PTHR11407:SF36', NULL, NULL, NULL, NULL, 'GEO02684P1-RELATED', 238793),
(298156, 'PTHR11407:SF9', NULL, NULL, NULL, NULL, 'LYSOZYME-LIKE PROTEIN 6', 238793),
(298157, 'PTHR11407', NULL, NULL, NULL, NULL, 'LYSOZYME C', 238793),
(298158, 'PTHR11407:SF21', NULL, NULL, NULL, NULL, 'LYSOZYME-LIKE PROTEIN 4', 238793),
(298159, 'PTHR11407:SF32', NULL, NULL, NULL, NULL, 'ALPHA-LACTALBUMIN', 238793),
(298160, 'PTHR11407:SF31', NULL, NULL, NULL, NULL, 'SPERM ACROSOME-ASSOCIATED PROTEIN 5', 238793),
(298161, 'PTHR11407:SF63', NULL, NULL, NULL, NULL, 'LYSOZYME', 238793),
(298162, 'PTHR11407:SF62', NULL, NULL, NULL, NULL, 'LYSOZYME-LIKE PROTEIN 1-RELATED', 238793),
(298163, 'PTHR11407:SF71', NULL, NULL, NULL, NULL, 'SLT DOMAIN-CONTAINING PROTEIN', 238793),
(298164, 'PTHR11407:SF70', NULL, NULL, NULL, NULL, 'SENSORY NEURON MEMBRANE PROTEIN 2-LIKE PROTEIN', 238793),
(298165, 'PTHR43188:SF1', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A OXIDASE 4, PEROXISOMAL', 238794),
(298166, 'PTHR43188:SF5', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A OXIDASE 4, PEROXISOMAL-LIKE', 238794),
(298167, 'PTHR43188:SF6', NULL, NULL, NULL, NULL, '', 238794),
(298168, 'PTHR43188:SF9', NULL, NULL, NULL, NULL, '', 238794),
(298169, 'PTHR43188:SF11', NULL, NULL, NULL, NULL, 'OS01G0159400 PROTEIN', 238794),
(298170, 'PTHR43188', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A OXIDASE', 238794),
(298171, 'PTHR43629', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 238795),
(298172, 'PTHR43629:SF2', NULL, NULL, NULL, NULL, 'RHODANESE-LIKE/PPIC DOMAIN-CONTAINING PROTEIN 12, CHLOROPLASTIC', 238795),
(298173, 'PTHR43629:SF3', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE C', 238795),
(298174, 'PTHR47151', NULL, NULL, NULL, NULL, 'LEU/ILE/VAL-BINDING ABC TRANSPORTER SUBUNIT', 238796),
(298175, 'PTHR47151:SF1', NULL, NULL, NULL, NULL, 'LEU/ILE/VAL-BINDING PROTEIN', 238796),
(298176, 'PTHR47151:SF2', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER SUBSTRATE-BINDING PROTEIN', 238796),
(298177, 'PTHR47151:SF3', NULL, NULL, NULL, NULL, 'LEUCINE-SPECIFIC-BINDING PROTEIN', 238796),
(298178, 'PTHR39961:SF1', NULL, NULL, NULL, NULL, 'HYPOTHETICAL CYTOSOLIC PROTEIN', 238797),
(298179, 'PTHR39961', NULL, NULL, NULL, NULL, 'HYPOTHETICAL CYTOSOLIC PROTEIN', 238797),
(298180, 'PTHR46756:SF14', NULL, NULL, NULL, NULL, 'GAS2-LIKE PROTEIN 2', 238798),
(298181, 'PTHR46756:SF15', NULL, NULL, NULL, NULL, 'RAC GUANINE NUCLEOTIDE EXCHANGE FACTOR B', 238798);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(298182, 'PTHR46756', NULL, NULL, NULL, NULL, 'TRANSGELIN', 238798),
(298183, 'PTHR46756:SF16', NULL, NULL, NULL, NULL, 'GAS2-LIKE PROTEIN 1', 238798),
(298184, 'PTHR46756:SF9', NULL, NULL, NULL, NULL, 'GROWTH ARREST-SPECIFIC PROTEIN 2', 238798),
(298185, 'PTHR46756:SF18', NULL, NULL, NULL, NULL, 'TRANSGELIN', 238798),
(298186, 'PTHR46756:SF7', NULL, NULL, NULL, NULL, 'GAS2-LIKE PROTEIN 3', 238798),
(298187, 'PTHR46756:SF8', NULL, NULL, NULL, NULL, 'GAS2-LIKE PROTEIN PICKLED EGGS', 238798),
(298188, 'PTHR46756:SF19', NULL, NULL, NULL, NULL, 'CALPONIN', 238798),
(298189, 'PTHR46756:SF20', NULL, NULL, NULL, NULL, 'CALPONIN-HOMOLOGY (CH) DOMAIN-CONTAINING PROTEIN', 238798),
(298190, 'PTHR46756:SF10', NULL, NULL, NULL, NULL, 'GROWTH ARREST-SPECIFIC 2B', 238798),
(298191, 'PTHR46756:SF21', NULL, NULL, NULL, NULL, 'GROWTH ARREST SPECIFIC 2 LIKE 2', 238798),
(298192, 'PTHR46756:SF22', NULL, NULL, NULL, NULL, 'CALPONIN-HOMOLOGY (CH) DOMAIN-CONTAINING PROTEIN', 238798),
(298193, 'PTHR46756:SF11', NULL, NULL, NULL, NULL, 'CALPONIN', 238798),
(298194, 'PTHR46756:SF12', NULL, NULL, NULL, NULL, 'CALPONIN-HOMOLOGY (CH) DOMAIN-CONTAINING PROTEIN', 238798),
(298195, 'PTHR46756:SF13', NULL, NULL, NULL, NULL, 'GAR DOMAIN-CONTAINING PROTEIN', 238798),
(298196, 'PTHR46756:SF4', NULL, NULL, NULL, NULL, 'CALPONIN', 238798),
(298197, 'PTHR46756:SF1', NULL, NULL, NULL, NULL, 'CALPONIN-1', 238798),
(298198, 'PTHR46756:SF2', NULL, NULL, NULL, NULL, 'CALPONIN-HOMOLOGY (CH) DOMAIN-CONTAINING PROTEIN', 238798),
(298199, 'PTHR31232:SF82', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298200, 'PTHR31232:SF83', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298201, 'PTHR31232:SF42', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298202, 'PTHR31232:SF87', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298203, 'PTHR31232:SF43', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG 29-RELATED', 238799),
(298204, 'PTHR31232:SF88', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298205, 'PTHR31232:SF45', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298206, 'PTHR31232:SF89', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298207, 'PTHR31232:SF48', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG 12', 238799),
(298208, 'PTHR31232:SF131', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298209, 'PTHR31232:SF135', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG 9', 238799),
(298210, 'PTHR31232:SF132', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298211, 'PTHR31232:SF133', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG 5', 238799),
(298212, 'PTHR31232:SF90', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298213, 'PTHR31232:SF139', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298214, 'PTHR31232:SF137', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298215, 'PTHR31232:SF109', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298216, 'PTHR31232:SF94', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298217, 'PTHR31232:SF107', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298218, 'PTHR31232:SF92', NULL, NULL, NULL, NULL, 'PLANT SELF-INCOMPATIBILITY PROTEIN S1 FAMILY', 238799),
(298219, 'PTHR31232:SF108', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298220, 'PTHR31232:SF54', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG-RELATED', 238799),
(298221, 'PTHR31232:SF51', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298222, 'PTHR31232:SF18', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298223, 'PTHR31232:SF141', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298224, 'PTHR31232:SF142', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298225, 'PTHR31232:SF101', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298226, 'PTHR31232:SF145', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298227, 'PTHR31232:SF146', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298228, 'PTHR31232:SF102', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298229, 'PTHR31232:SF100', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(298230, 'PTHR31232:SF144', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG 2', 238799),
(298231, 'PTHR31232:SF105', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298232, 'PTHR31232:SF149', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298233, 'PTHR31232:SF103', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298234, 'PTHR31232:SF147', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298235, 'PTHR31232:SF148', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298236, 'PTHR31232:SF60', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298237, 'PTHR31232:SF61', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298238, 'PTHR31232:SF119', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298239, 'PTHR31232:SF62', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298240, 'PTHR31232:SF63', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298241, 'PTHR31232:SF68', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298242, 'PTHR31232:SF69', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298243, 'PTHR31232:SF66', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298244, 'PTHR31232:SF67', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298245, 'PTHR31232:SF29', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG 13', 238799),
(298246, 'PTHR31232:SF26', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG-RELATED', 238799),
(298247, 'PTHR31232:SF27', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG 8', 238799),
(298248, 'PTHR31232:SF152', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298249, 'PTHR31232:SF153', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298250, 'PTHR31232:SF150', NULL, NULL, NULL, NULL, '', 238799),
(298251, 'PTHR31232:SF151', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298252, 'PTHR31232:SF112', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298253, 'PTHR31232:SF156', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG-RELATED', 238799),
(298254, 'PTHR31232:SF157', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298255, 'PTHR31232:SF113', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG-RELATED', 238799),
(298256, 'PTHR31232:SF154', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298257, 'PTHR31232:SF110', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298258, 'PTHR31232:SF111', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298259, 'PTHR31232:SF155', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298260, 'PTHR31232:SF8', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298261, 'PTHR31232:SF116', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298262, 'PTHR31232:SF117', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298263, 'PTHR31232:SF158', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298264, 'PTHR31232:SF114', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298265, 'PTHR31232:SF115', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298266, 'PTHR31232:SF159', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298267, 'PTHR31232:SF71', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298268, 'PTHR31232:SF70', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298269, 'PTHR31232:SF75', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298270, 'PTHR31232:SF31', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298271, 'PTHR31232:SF32', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298272, 'PTHR31232:SF73', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298273, 'PTHR31232:SF79', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298274, 'PTHR31232:SF35', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG 26', 238799),
(298275, 'PTHR31232:SF78', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298276, 'PTHR31232:SF39', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG-RELATED', 238799),
(298277, 'PTHR31232:SF160', NULL, NULL, NULL, NULL, 'LEGUMINOSIN GROUP486 SECRETED PEPTIDE', 238799),
(298278, 'PTHR31232:SF163', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG 18-RELATED', 238799),
(298279, 'PTHR31232:SF164', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(298280, 'PTHR31232:SF161', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG-RELATED', 238799),
(298281, 'PTHR31232:SF162', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298282, 'PTHR31232:SF167', NULL, NULL, NULL, NULL, '', 238799),
(298283, 'PTHR31232:SF123', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298284, 'PTHR31232:SF168', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG-RELATED', 238799),
(298285, 'PTHR31232:SF121', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298286, 'PTHR31232:SF165', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298287, 'PTHR31232:SF166', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298288, 'PTHR31232', NULL, NULL, NULL, NULL, '', 238799),
(298289, 'PTHR31232:SF125', NULL, NULL, NULL, NULL, 'S-PROTEIN HOMOLOG', 238799),
(298290, 'PTHR35990:SF1', NULL, NULL, NULL, NULL, 'GAG1AT PROTEIN', 238800),
(298291, 'PTHR35990', NULL, NULL, NULL, NULL, 'GAG1AT PROTEIN', 238800),
(298292, 'PTHR11903:SF8', NULL, NULL, NULL, NULL, 'PROSTAGLANDIN G/H SYNTHASE 2', 238801),
(298293, 'PTHR11903:SF11', NULL, NULL, NULL, NULL, 'ALPHA-DIOXYGENASE 1', 238801),
(298294, 'PTHR11903:SF30', NULL, NULL, NULL, NULL, 'BNAA07G38980D PROTEIN', 238801),
(298295, 'PTHR11903:SF31', NULL, NULL, NULL, NULL, 'PEROXIDASE SUPERFAMILY PROTEIN-RELATED', 238801),
(298296, 'PTHR11903:SF6', NULL, NULL, NULL, NULL, 'PROSTAGLANDIN G/H SYNTHASE 1', 238801),
(298297, 'PTHR11903', NULL, NULL, NULL, NULL, 'PROSTAGLANDIN G/H SYNTHASE', 238801),
(298298, 'PTHR11903:SF36', NULL, NULL, NULL, NULL, 'ALPHA-DOX2', 238801),
(298299, 'PTHR11903:SF25', NULL, NULL, NULL, NULL, 'ALPHA-DIOXYGENASE 2', 238801),
(298300, 'PTHR11903:SF37', NULL, NULL, NULL, NULL, 'PSI-PRODUCING OXYGENASE A', 238801),
(298301, 'PTHR11903:SF13', NULL, NULL, NULL, NULL, 'LINOLEATE 10R-LIPOXYGENASE', 238801),
(298302, 'PTHR11903:SF35', NULL, NULL, NULL, NULL, 'ALPHA-DIOXYGENASE 1-LIKE', 238801),
(298303, 'PTHR11903:SF29', NULL, NULL, NULL, NULL, 'BNAA02G16520D PROTEIN', 238801),
(298304, 'PTHR11903:SF18', NULL, NULL, NULL, NULL, 'COLLAGEN TRIPLE HELIX REPEAT-CONTAINING PROTEIN 1', 238801),
(298305, 'PTHR32248', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA-54 FACTOR', 238802),
(298306, 'PTHR32248:SF4', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA-54 FACTOR', 238802),
(298307, 'PTHR33481', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE', 238803),
(298308, 'PTHR33481:SF1', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 238803),
(298309, 'PTHR43447:SF48', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE ISOZYME 3C', 238804),
(298310, 'PTHR43447:SF20', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE', 238804),
(298311, 'PTHR43447:SF41', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE', 238804),
(298312, 'PTHR43447:SF22', NULL, NULL, NULL, NULL, 'OS05G0446900 PROTEIN', 238804),
(298313, 'PTHR43447:SF44', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE', 238804),
(298314, 'PTHR43447:SF21', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE', 238804),
(298315, 'PTHR43447:SF49', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE', 238804),
(298316, 'PTHR43447:SF27', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE 2B', 238804),
(298317, 'PTHR43447:SF29', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE', 238804),
(298318, 'PTHR43447:SF51', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE', 238804),
(298319, 'PTHR43447:SF50', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE 1A-RELATED', 238804),
(298320, 'PTHR43447:SF34', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE', 238804),
(298321, 'PTHR43447', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE', 238804),
(298322, 'PTHR43447:SF37', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE 1', 238804),
(298323, 'PTHR43447:SF53', NULL, NULL, NULL, NULL, '1,4-ALPHA-D-GLUCAN GLUCANOHYDROLASE', 238804),
(298324, 'PTHR43447:SF52', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE', 238804),
(298325, 'PTHR43447:SF30', NULL, NULL, NULL, NULL, '1,4-ALPHA-D-GLUCAN GLUCANOHYDROLASE', 238804),
(298326, 'PTHR43447:SF11', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE', 238804),
(298327, 'PTHR43447:SF33', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE 3, CHLOROPLASTIC', 238804),
(298328, 'PTHR43447:SF32', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE', 238804);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(298329, 'PTHR43447:SF3', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE 1', 238804),
(298330, 'PTHR43447:SF6', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE ISOZYME 3A', 238804),
(298331, 'PTHR43447:SF5', NULL, NULL, NULL, NULL, 'PANCREATIC ALPHA-AMYLASE', 238804),
(298332, 'PTHR43447:SF39', NULL, NULL, NULL, NULL, 'CBM20 DOMAIN-CONTAINING PROTEIN', 238804),
(298333, 'PTHR43447:SF38', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE ISOZYME 2A', 238804),
(298334, 'PTHR43447:SF7', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE 2-RELATED', 238804),
(298335, 'PTHR43447:SF19', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE', 238804),
(298336, 'PTHR43447:SF40', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE ISOZYME 3D', 238804),
(298337, 'PTHR12224:SF0', NULL, NULL, NULL, NULL, 'BETA-1,4-MANNOSYL-GLYCOPROTEIN 4-BETA-N-ACETYLGLUCOSAMINYLTRANSFERASE', 238805),
(298338, 'PTHR12224:SF7', NULL, NULL, NULL, NULL, '', 238805),
(298339, 'PTHR12224:SF6', NULL, NULL, NULL, NULL, 'OS02G0594900 PROTEIN', 238805),
(298340, 'PTHR12224:SF19', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE, FAMILY 17-RELATED', 238805),
(298341, 'PTHR12224:SF21', NULL, NULL, NULL, NULL, 'BNAANNG27230D PROTEIN', 238805),
(298342, 'PTHR12224:SF10', NULL, NULL, NULL, NULL, 'BETA-1,4-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 238805),
(298343, 'PTHR12224', NULL, NULL, NULL, NULL, 'BETA-1,4-MANNOSYL-GLYCOPROTEIN BETA-1,4-N-ACETYLGLUCOSAMINYL-TRANSFERASE', 238805),
(298344, 'PTHR12224:SF18', NULL, NULL, NULL, NULL, 'BNAC05G09150D PROTEIN', 238805),
(298345, 'PTHR12224:SF28', NULL, NULL, NULL, NULL, 'BETA-1,4-MANNOSYL-GLYCOPROTEIN BETA-1,4-N-ACETYLGLUCOSAMINYLTRANSFERASE, FAMILY GT17', 238805),
(298346, 'PTHR12224:SF17', NULL, NULL, NULL, NULL, 'BETA 1,4 N-ACETYLGLUCOSAMINYLTRANSFERASE', 238805),
(298347, 'PTHR12224:SF27', NULL, NULL, NULL, NULL, 'BETA-1,4-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN-RELATED', 238805),
(298348, 'PTHR12224:SF9', NULL, NULL, NULL, NULL, 'BETA-1,4-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 238805),
(298349, 'PTHR12224:SF15', NULL, NULL, NULL, NULL, 'BETA-1,4-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN-RELATED', 238805),
(298350, 'PTHR12224:SF26', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE, FAMILY 17-RELATED', 238805),
(298351, 'PTHR12224:SF25', NULL, NULL, NULL, NULL, 'BETA-1,4-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 238805),
(298352, 'PTHR12224:SF14', NULL, NULL, NULL, NULL, 'BETA-1,4-N-ACETYLGLUCOSAMINYLTRANSFERASE-LIKE PROTEIN', 238805),
(298353, 'PTHR12224:SF13', NULL, NULL, NULL, NULL, 'ACETYLGLUCOSAMINYLTRANSFERASE', 238805),
(298354, 'PTHR12224:SF12', NULL, NULL, NULL, NULL, 'BETA-1,4-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 238805),
(298355, 'PTHR12224:SF23', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE, FAMILY 17-RELATED', 238805),
(298356, 'PTHR12224:SF22', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE, FAMILY 17-RELATED', 238805),
(298357, 'PTHR21433:SF7', NULL, NULL, NULL, NULL, 'ZGC:103681', 238806),
(298358, 'PTHR21433:SF6', NULL, NULL, NULL, NULL, 'TMPIT-LIKE PROTEIN-RELATED', 238806),
(298359, 'PTHR21433:SF8', NULL, NULL, NULL, NULL, 'BNACNNG39370D PROTEIN', 238806),
(298360, 'PTHR21433:SF1', NULL, NULL, NULL, NULL, 'ION CHANNEL TACAN', 238806),
(298361, 'PTHR21433:SF0', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 120 HOMOLOG', 238806),
(298362, 'PTHR21433', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN INDUCED BY TUMOR NECROSIS FACTOR ALPHA', 238806),
(298363, 'PTHR21433:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 120B', 238806),
(298364, 'PTHR21433:SF5', NULL, NULL, NULL, NULL, 'TMPIT-LIKE PROTEIN', 238806),
(298365, 'PTHR21433:SF4', NULL, NULL, NULL, NULL, 'OS02G0106800 PROTEIN', 238806),
(298366, 'PTHR46836:SF5', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL N-ACETYGLUCOSAMINLYTRANSFERASE SUBUNIT P-RELATED', 238807),
(298367, 'PTHR46836:SF4', NULL, NULL, NULL, NULL, '', 238807),
(298368, 'PTHR46836', NULL, NULL, NULL, NULL, 'AFADIN', 238807),
(298369, 'PTHR46836:SF9', NULL, NULL, NULL, NULL, '', 238807),
(298370, 'PTHR46836:SF8', NULL, NULL, NULL, NULL, 'AFADIN', 238807),
(298371, 'PTHR46836:SF7', NULL, NULL, NULL, NULL, 'DUF4378 DOMAIN-CONTAINING PROTEIN', 238807);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(298372, 'PTHR46836:SF6', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 238807),
(298373, 'PTHR46836:SF1', NULL, NULL, NULL, NULL, 'OS05G0116700 PROTEIN', 238807),
(298374, 'PTHR46836:SF10', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL N-ACETYGLUCOSAMINLYTRANSFERASE SUBUNIT P-LIKE PROTEIN', 238807),
(298375, 'PTHR46836:SF11', NULL, NULL, NULL, NULL, 'BNAA07G37650D PROTEIN', 238807),
(298376, 'PTHR28457:SF4', NULL, NULL, NULL, NULL, 'CENTRAL APPARATUS ASSOCIATED PROTEIN C1A-32', 238808),
(298377, 'PTHR28457:SF3', NULL, NULL, NULL, NULL, 'CILIARY-ASSOCIATED CALCIUM-BINDING COILED-COIL PROTEIN 1', 238808),
(298378, 'PTHR28457:SF2', NULL, NULL, NULL, NULL, 'SIMILAR TO 4930578I06RIK PROTEIN', 238808),
(298379, 'PTHR28457', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 189', 238808),
(298380, 'PTHR28457:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 189', 238808),
(298381, 'PTHR40278:SF2', NULL, NULL, NULL, NULL, 'DNA UTILIZATION PROTEIN HOFN', 238809),
(298382, 'PTHR40278:SF1', NULL, NULL, NULL, NULL, 'TYPE II SECRETION SYSTEM PROTEIN L', 238809),
(298383, 'PTHR40278', NULL, NULL, NULL, NULL, 'DNA UTILIZATION PROTEIN HOFN', 238809),
(298384, 'PTHR35760:SF1', NULL, NULL, NULL, NULL, 'SI:CH211-22I13.2', 238810),
(298385, 'PTHR35760', NULL, NULL, NULL, NULL, 'SI:CH211-22I13.2', 238810),
(298386, 'PTHR43125:SF1', NULL, NULL, NULL, NULL, 'INOSITOL-3-PHOSPHATE SYNTHASE', 238811),
(298387, 'PTHR43125', NULL, NULL, NULL, NULL, 'INOSITOL-3-PHOSPHATE SYNTHASE', 238811),
(298388, 'PTHR15417:SF5', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 1C', 238812),
(298389, 'PTHR15417', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE INHIBITOR AND DOPAMINE- AND CAMP-REGULATED NEURONAL PHOSPHOPROTEIN', 238812),
(298390, 'PTHR15417:SF2', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 1B', 238812),
(298391, 'PTHR15417:SF4', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 1A', 238812),
(298392, 'PTHR32182:SF19', NULL, NULL, NULL, NULL, 'HOMOLOGY WITH RECF PROTEIN', 238813),
(298393, 'PTHR32182:SF23', NULL, NULL, NULL, NULL, 'ATP BINDING PROTEIN', 238813),
(298394, 'PTHR32182', NULL, NULL, NULL, NULL, 'DNA REPLICATION AND REPAIR PROTEIN RECF', 238813),
(298395, 'PTHR32182:SF25', NULL, NULL, NULL, NULL, 'SLR5023 PROTEIN', 238813),
(298396, 'PTHR32182:SF22', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT ENDONUCLEASE, OLD FAMILY-RELATED', 238813),
(298397, 'PTHR32182:SF0', NULL, NULL, NULL, NULL, 'DNA REPLICATION AND REPAIR PROTEIN RECF', 238813),
(298398, 'PTHR42878:SF7', NULL, NULL, NULL, NULL, 'OSMOLARITY TWO-COMPONENT SYSTEM PROTEIN SSK1', 238814),
(298399, 'PTHR42878', NULL, NULL, NULL, NULL, 'TWO-COMPONENT HISTIDINE KINASE', 238814),
(298400, 'PTHR42878:SF12', NULL, NULL, NULL, NULL, 'SENSOR HISTIDINE KINASE YCBM', 238814),
(298401, 'PTHR42878:SF3', NULL, NULL, NULL, NULL, 'SENSOR HISTIDINE KINASE RESE', 238814),
(298402, 'PTHR47214:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ROUGH SHEATH 2 HOMOLOG', 238815),
(298403, 'PTHR47214:SF4', NULL, NULL, NULL, NULL, 'BNAA03G17330D PROTEIN', 238815),
(298404, 'PTHR47214:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR AS1', 238815),
(298405, 'PTHR47214', NULL, NULL, NULL, NULL, 'PROTEIN ROUGH SHEATH 2 HOMOLOG', 238815),
(298406, 'PTHR12616', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING VPS41', 238816),
(298407, 'PTHR12616:SF1', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 41 HOMOLOG', 238816),
(298408, 'PTHR12616:SF14', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 238816),
(298409, 'PTHR12616:SF8', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 8 HOMOLOG', 238816),
(298410, 'PTHR12616:SF13', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 41 HOMOLOG', 238816),
(298411, 'PTHR12616:SF10', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 238816),
(298412, 'PTHR40641:SF2', NULL, NULL, NULL, NULL, 'INVOLUCRIN REPEAT PROTEIN', 238817),
(298413, 'PTHR40641', NULL, NULL, NULL, NULL, 'INVOLUCRIN REPEAT PROTEIN (AFU_ORTHOLOGUE AFUA_2G08060)', 238817);
INSERT INTO "PUBLIC"."MODEL" VALUES
(298414, 'PTHR14351', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC SERINE KINASE SUBSTRATE', 238818),
(298415, 'PTHR14351:SF1', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC SERINE KINASE SUBSTRATE', 238818),
(298416, 'PTHR22846:SF63', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 238819),
(298417, 'PTHR22846:SF52', NULL, NULL, NULL, NULL, 'F-BOX-LIKE/WD REPEAT-CONTAINING PROTEIN TBL1Y', 238819),
(298418, 'PTHR22846:SF42', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 238819),
(298419, 'PTHR22846:SF40', NULL, NULL, NULL, NULL, 'F-BOX-LIKE/WD REPEAT-CONTAINING PROTEIN TBL1XR1', 238819),
(298420, 'PTHR22846:SF70', NULL, NULL, NULL, NULL, 'F-BOX-LIKE/WD REPEAT-CONTAINING PROTEIN TBL1X', 238819),
(298421, 'PTHR22846', NULL, NULL, NULL, NULL, 'WD40 REPEAT PROTEIN', 238819),
(298422, 'PTHR22846:SF69', NULL, NULL, NULL, NULL, 'WD40 REPEAT-CONTAINING PROTEIN HOS15', 238819),
(298423, 'PTHR22846:SF2', NULL, NULL, NULL, NULL, 'F-BOX-LIKE/WD REPEAT-CONTAINING PROTEIN EBI', 238819),
(298424, 'PTHR22846:SF67', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 238819),
(298425, 'PTHR22846:SF68', NULL, NULL, NULL, NULL, 'TRANSDUCIN FAMILY PROTEIN/WD-40 REPEAT PROTEIN', 238819),
(298426, 'PTHR22846:SF66', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 238819),
(298427, 'PTHR22846:SF55', NULL, NULL, NULL, NULL, 'LISH DOMAIN-CONTAINING PROTEIN', 238819),
(298428, 'PTHR31050:SF6', NULL, NULL, NULL, NULL, 'TOXIN_10 DOMAIN-CONTAINING PROTEIN', 238820),
(298429, 'PTHR31050:SF7', NULL, NULL, NULL, NULL, 'DUF1262 FAMILY PROTEIN', 238820),
(298430, 'PTHR31050', NULL, NULL, NULL, NULL, 'OS08G0413200 PROTEIN', 238820),
(298431, 'PTHR31050:SF8', NULL, NULL, NULL, NULL, 'BNAC08G15950D PROTEIN', 238820),
(298432, 'PTHR31050:SF9', NULL, NULL, NULL, NULL, '', 238820),
(298433, 'PTHR31050:SF3', NULL, NULL, NULL, NULL, 'OS08G0412800 PROTEIN', 238820),
(298434, 'PTHR31050:SF4', NULL, NULL, NULL, NULL, 'DUF1262 FAMILY PROTEIN (DUF1262)', 238820),
(298435, 'PTHR31050:SF5', NULL, NULL, NULL, NULL, 'BNAC08G40280D PROTEIN', 238820),
(298436, 'PTHR31050:SF12', NULL, NULL, NULL, NULL, 'BNAA09G46230D PROTEIN', 238820),
(298437, 'PTHR31050:SF11', NULL, NULL, NULL, NULL, 'F13B4.1 PROTEIN', 238820),
(298438, 'PTHR31050:SF15', NULL, NULL, NULL, NULL, 'OS08G0413200 PROTEIN', 238820),
(298439, 'PTHR31050:SF14', NULL, NULL, NULL, NULL, 'TOXIN_10 DOMAIN-CONTAINING PROTEIN', 238820),
(298440, 'PTHR31050:SF13', NULL, NULL, NULL, NULL, '', 238820),
(298441, 'PTHR13094:SF3', NULL, NULL, NULL, NULL, 'BNAA01G26750D PROTEIN', 238821),
(298442, 'PTHR13094:SF2', NULL, NULL, NULL, NULL, 'BNAANNG27390D PROTEIN', 238821),
(298443, 'PTHR13094:SF4', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 BETA SUBCOMPLEX SUBUNIT 10-A-LIKE', 238821),
(298444, 'PTHR13094', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE PDSW SUBUNIT', 238821),
(298445, 'PTHR13094:SF1', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 BETA SUBCOMPLEX SUBUNIT 10', 238821),
(298446, 'PTHR30524', NULL, NULL, NULL, NULL, 'MANNITOL-1-PHOSPHATE 5-DEHYDROGENASE', 238822),
(298447, 'PTHR30524:SF0', NULL, NULL, NULL, NULL, 'ALTRONATE OXIDOREDUCTASE-RELATED', 238822),
(298448, 'PTHR46650:SF4', NULL, NULL, NULL, NULL, 'PEROXISOMAL ADENINE NUCLEOTIDE CARRIER 1', 238823),
(298449, 'PTHR46650:SF5', NULL, NULL, NULL, NULL, 'BNAA09G03780D PROTEIN', 238823),
(298450, 'PTHR46650', NULL, NULL, NULL, NULL, 'PEROXISOMAL ADENINE NUCLEOTIDE TRANSPORTER 1', 238823),
(298451, 'PTHR46650:SF1', NULL, NULL, NULL, NULL, 'PEROXISOMAL ADENINE NUCLEOTIDE TRANSPORTER 1', 238823),
(298452, 'PTHR46650:SF3', NULL, NULL, NULL, NULL, 'PEROXISOMAL ADENINE NUCLEOTIDE CARRIER 2', 238823),
(298453, 'PTHR44068:SF3', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 238824),
(298454, 'PTHR44068:SF4', NULL, NULL, NULL, NULL, 'S-ADENOSYL-METHIONINE-STEROL-C-METHYLTRANSFERAS (AFU_ORTHOLOGUE AFUA_4G09190)', 238824),
(298455, 'PTHR44068:SF1', NULL, NULL, NULL, NULL, 'ZGC:194242', 238824),
(298456, 'PTHR44068:SF2', NULL, NULL, NULL, NULL, 'OS11G0296900 PROTEIN', 238824);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(298457, 'PTHR44068:SF6', NULL, NULL, NULL, NULL, 'SAM_MT_ERG6_SMT DOMAIN-CONTAINING PROTEIN', 238824),
(298458, 'PTHR44068:SF9', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 238824),
(298459, 'PTHR44068', NULL, NULL, NULL, NULL, 'ZGC:194242', 238824),
(298460, 'PTHR44068:SF11', NULL, NULL, NULL, NULL, 'GERANYL DIPHOSPHATE 2-C-METHYLTRANSFERASE', 238824),
(298461, 'PTHR19961:SF35', NULL, NULL, NULL, NULL, 'PLASTIN-2', 238825),
(298462, 'PTHR19961:SF79', NULL, NULL, NULL, NULL, 'FIMBRIN-5', 238825),
(298463, 'PTHR19961:SF68', NULL, NULL, NULL, NULL, '', 238825),
(298464, 'PTHR19961:SF24', NULL, NULL, NULL, NULL, 'FIMBRIN', 238825),
(298465, 'PTHR19961:SF78', NULL, NULL, NULL, NULL, 'DYSTROPHIN-RELATED', 238825),
(298466, 'PTHR19961:SF67', NULL, NULL, NULL, NULL, 'DYSTROPHIN-RELATED', 238825),
(298467, 'PTHR19961:SF56', NULL, NULL, NULL, NULL, '', 238825),
(298468, 'PTHR19961:SF27', NULL, NULL, NULL, NULL, 'PLASTIN-1', 238825),
(298469, 'PTHR19961:SF18', NULL, NULL, NULL, NULL, 'FI19014P1', 238825),
(298470, 'PTHR19961:SF60', NULL, NULL, NULL, NULL, 'ACTIN-BINDING CALPONIN-LIKE (CH) DOMAIN PROTEIN', 238825),
(298471, 'PTHR19961:SF71', NULL, NULL, NULL, NULL, 'OS02G0588300 PROTEIN', 238825),
(298472, 'PTHR19961:SF70', NULL, NULL, NULL, NULL, 'FIMBRIN', 238825),
(298473, 'PTHR19961:SF62', NULL, NULL, NULL, NULL, 'FIMBRIN-1', 238825),
(298474, 'PTHR19961:SF64', NULL, NULL, NULL, NULL, 'FIMBRIN-3', 238825),
(298475, 'PTHR19961:SF31', NULL, NULL, NULL, NULL, '', 238825),
(298476, 'PTHR19961:SF63', NULL, NULL, NULL, NULL, 'FIMBRIN-2-LIKE', 238825),
(298477, 'PTHR19961:SF74', NULL, NULL, NULL, NULL, 'BNACNNG38580D PROTEIN', 238825),
(298478, 'PTHR19961:SF66', NULL, NULL, NULL, NULL, 'FIMBRIN-4', 238825),
(298479, 'PTHR19961:SF32', NULL, NULL, NULL, NULL, 'PLASTIN-3', 238825),
(298480, 'PTHR19961:SF76', NULL, NULL, NULL, NULL, '', 238825),
(298481, 'PTHR19961:SF65', NULL, NULL, NULL, NULL, '', 238825),
(298482, 'PTHR19961', NULL, NULL, NULL, NULL, 'FIMBRIN/PLASTIN', 238825),
(298483, 'PTHR46153:SF2', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN', 238826),
(298484, 'PTHR46153:SF9', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN 1, CHLOROPLASTIC', 238826),
(298485, 'PTHR46153:SF11', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN', 238826),
(298486, 'PTHR46153:SF23', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN', 238826),
(298487, 'PTHR46153:SF12', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN 5, CHLOROPLASTIC', 238826),
(298488, 'PTHR46153:SF20', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN 4, CHLOROPLASTIC', 238826),
(298489, 'PTHR46153:SF6', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN', 238826),
(298490, 'PTHR46153:SF26', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN', 238826),
(298491, 'PTHR46153:SF16', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN', 238826),
(298492, 'PTHR46153:SF27', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN', 238826),
(298493, 'PTHR46153:SF24', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN 2, CHLOROPLASTIC-RELATED', 238826),
(298494, 'PTHR46153:SF14', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN', 238826),
(298495, 'PTHR46153:SF28', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN', 238826),
(298496, 'PTHR46153', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN', 238826),
(298497, 'PTHR46153:SF18', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN', 238826),
(298498, 'PTHR20957:SF1', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 48', 238827),
(298499, 'PTHR20957:SF0', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 48', 238827),
(298500, 'PTHR20957:SF3', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 48', 238827),
(298501, 'PTHR20957', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 238827),
(298502, 'PTHR20957:SF2', NULL, NULL, NULL, NULL, '', 238827),
(298503, 'PTHR46047:SF1', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE NON-RECEPTOR TYPE 2', 238828),
(298504, 'PTHR46047', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE NON-RECEPTOR TYPE 61F', 238828),
(298505, 'PTHR46047:SF2', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE NON-RECEPTOR TYPE 1', 238828),
(298506, 'PTHR46047:SF3', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE NON-RECEPTOR TYPE 61F', 238828);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(298507, 'PTHR15032:SF32', NULL, NULL, NULL, NULL, 'LACTAMASE_B DOMAIN-CONTAINING PROTEIN', 238829),
(298508, 'PTHR15032', NULL, NULL, NULL, NULL, 'N-ACYL-PHOSPHATIDYLETHANOLAMINE-HYDROLYZING PHOSPHOLIPASE D', 238829),
(298509, 'PTHR15032:SF27', NULL, NULL, NULL, NULL, 'N-ACYL-PHOSPHATIDYLETHANOLAMINE-HYDROLYZING PHOSPHOLIPASE D', 238829),
(298510, 'PTHR15032:SF36', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN ROMA', 238829),
(298511, 'PTHR15032:SF35', NULL, NULL, NULL, NULL, 'CHROMOSOME 19, WHOLE GENOME SHOTGUN SEQUENCE', 238829),
(298512, 'PTHR15032:SF4', NULL, NULL, NULL, NULL, 'N-ACYL-PHOSPHATIDYLETHANOLAMINE-HYDROLYZING PHOSPHOLIPASE D', 238829),
(298513, 'PTHR15032:SF33', NULL, NULL, NULL, NULL, 'HYDROLASES OF THE BETA-LACTAMASE FOLD, PUTATIVE-RELATED', 238829),
(298514, 'PTHR46315:SF2', NULL, NULL, NULL, NULL, 'SPERMINE SYNTHASE', 238830),
(298515, 'PTHR46315:SF3', NULL, NULL, NULL, NULL, 'PABS DOMAIN-CONTAINING PROTEIN', 238830),
(298516, 'PTHR46315:SF4', NULL, NULL, NULL, NULL, 'PABS DOMAIN-CONTAINING PROTEIN', 238830),
(298517, 'PTHR46315:SF1', NULL, NULL, NULL, NULL, 'SPERMINE SYNTHASE', 238830),
(298518, 'PTHR46315', NULL, NULL, NULL, NULL, 'SPERMINE SYNTHASE', 238830),
(298519, 'PTHR45270', NULL, NULL, NULL, NULL, 'OS03G0832900 PROTEIN', 238831),
(298520, 'PTHR45270:SF4', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', 238831),
(298521, 'PTHR45270:SF3', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', 238831),
(298522, 'PTHR45270:SF1', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', 238831),
(298523, 'PTHR13205:SF18', NULL, NULL, NULL, NULL, '', 238832),
(298524, 'PTHR13205', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 15-RELATED', 238832),
(298525, 'PTHR13205:SF19', NULL, NULL, NULL, NULL, 'DOLICHOL KINASE', 238832),
(298526, 'PTHR13205:SF15', NULL, NULL, NULL, NULL, 'DOLICHOL KINASE', 238832),
(298527, 'PTHR14416', NULL, NULL, NULL, NULL, 'PROTEIN NJMU-R1', 238833),
(298528, 'PTHR14416:SF2', NULL, NULL, NULL, NULL, 'PROTEIN NJMU-R1', 238833),
(298529, 'PTHR12706', NULL, NULL, NULL, NULL, 'STRAWBERRY NOTCH-RELATED', 238834),
(298530, 'PTHR12706:SF32', NULL, NULL, NULL, NULL, '', 238834),
(298531, 'PTHR12706:SF33', NULL, NULL, NULL, NULL, 'PROTEIN WITH HELICASE_C DOMAIN', 238834),
(298532, 'PTHR12706:SF8', NULL, NULL, NULL, NULL, 'PROTEIN STRAWBERRY NOTCH HOMOLOG 1', 238834),
(298533, 'PTHR12706:SF30', NULL, NULL, NULL, NULL, 'PROTEIN STRAWBERRY NOTCH', 238834),
(298534, 'PTHR12706:SF31', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER SUPERFAMILY PROTEIN', 238834),
(298535, 'PTHR12706:SF5', NULL, NULL, NULL, NULL, 'PROTEIN STRAWBERRY NOTCH HOMOLOG 2', 238834),
(298536, 'PTHR12706:SF13', NULL, NULL, NULL, NULL, 'PROTEIN FORGETTER 1', 238834),
(298537, 'PTHR33562:SF20', NULL, NULL, NULL, NULL, 'PROTEIN QUIVER', 238835),
(298538, 'PTHR33562:SF23', NULL, NULL, NULL, NULL, 'PROTEIN QUIVER', 238835),
(298539, 'PTHR33562:SF22', NULL, NULL, NULL, NULL, 'PROTEIN QUIVER', 238835),
(298540, 'PTHR33562:SF25', NULL, NULL, NULL, NULL, 'PROTEIN QUIVER', 238835),
(298541, 'PTHR33562:SF14', NULL, NULL, NULL, NULL, 'PROTEIN QUIVER', 238835),
(298542, 'PTHR33562:SF24', NULL, NULL, NULL, NULL, 'PROTEIN CBG28048', 238835),
(298543, 'PTHR33562:SF26', NULL, NULL, NULL, NULL, 'PROTEIN QUIVER', 238835),
(298544, 'PTHR33562:SF15', NULL, NULL, NULL, NULL, 'IP04187P', 238835),
(298545, 'PTHR33562:SF18', NULL, NULL, NULL, NULL, 'BOUDIN-RELATED', 238835),
(298546, 'PTHR33562:SF17', NULL, NULL, NULL, NULL, 'LD40063P-RELATED', 238835),
(298547, 'PTHR33562:SF19', NULL, NULL, NULL, NULL, 'PROTEIN QUIVER', 238835),
(298548, 'PTHR33562:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG01603', 238835),
(298549, 'PTHR33562:SF2', NULL, NULL, NULL, NULL, 'PROTEIN QUIVER', 238835),
(298550, 'PTHR33562', NULL, NULL, NULL, NULL, 'ATILLA, ISOFORM B-RELATED-RELATED', 238835),
(298551, 'PTHR11264:SF8', NULL, NULL, NULL, NULL, 'URACIL-DNA GLYCOSYLASE', 238836),
(298552, 'PTHR11264:SF7', NULL, NULL, NULL, NULL, 'URACIL-DNA GLYCOSYLASE', 238836),
(298553, 'PTHR11264:SF6', NULL, NULL, NULL, NULL, 'URACIL-DNA GLYCOSYLASE', 238836);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(298554, 'PTHR11264:SF0', NULL, NULL, NULL, NULL, 'URACIL-DNA GLYCOSYLASE', 238836),
(298555, 'PTHR11264', NULL, NULL, NULL, NULL, 'URACIL-DNA GLYCOSYLASE', 238836),
(298556, 'PTHR12859', NULL, NULL, NULL, NULL, 'PRA1 PROTEIN', 238837),
(298557, 'PTHR12859:SF5', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN A3', 238837),
(298558, 'PTHR12859:SF4', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN A2', 238837),
(298559, 'PTHR12859:SF6', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 238837),
(298560, 'PTHR12859:SF1', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN 2', 238837),
(298561, 'PTHR12859:SF0', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 238837),
(298562, 'PTHR12859:SF3', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 238837),
(298563, 'PTHR12859:SF2', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN 3', 238837),
(298564, 'PTHR12859:SF9', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 238837),
(298565, 'PTHR12859:SF8', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 238837),
(298566, 'PTHR24054:SF0', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT ALPHA', 238838),
(298567, 'PTHR24054:SF27', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT ALPHA''', 238838),
(298568, 'PTHR24054:SF16', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT ALPHA-RELATED', 238838),
(298569, 'PTHR24054:SF49', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 238838),
(298570, 'PTHR24054:SF35', NULL, NULL, NULL, NULL, 'KINASE II, ALPHA CHAIN, PUTATIVE, EXPRESSED-RELATED', 238838),
(298571, 'PTHR24054:SF57', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT ALPHA-3', 238838),
(298572, 'PTHR24054:SF58', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 238838),
(298573, 'PTHR24054:SF28', NULL, NULL, NULL, NULL, 'CASEIN KINASE 2 ALPHA 1-RELATED', 238838),
(298574, 'PTHR24054:SF51', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0286481-RELATED', 238838),
(298575, 'PTHR24054:SF40', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT ALPHA-2', 238838),
(298576, 'PTHR24054:SF52', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT ALPHA', 238838),
(298577, 'PTHR24054', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT ALPHA', 238838),
(298578, 'PTHR24054:SF55', NULL, NULL, NULL, NULL, 'CASEIN KINASE II, ALPHA CHAIN', 238838),
(298579, 'PTHR24054:SF44', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 238838),
(298580, 'PTHR24054:SF56', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT ALPHA-1', 238838),
(298581, 'PTHR24054:SF34', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT ALPHA''', 238838),
(298582, 'PTHR24054:SF42', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT ALPHA-LIKE', 238838),
(298583, 'PTHR24054:SF53', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 238838),
(298584, 'PTHR35094', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT EXTENSIN-LIKE PROTEIN 2', 238839),
(298585, 'PTHR35094:SF1', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT EXTENSIN-LIKE PROTEIN 2', 238839),
(298586, 'PTHR35094:SF7', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 238839),
(298587, 'PTHR35094:SF8', NULL, NULL, NULL, NULL, 'BNAC02G20450D PROTEIN', 238839),
(298588, 'PTHR35094:SF9', NULL, NULL, NULL, NULL, 'BNAC07G13360D PROTEIN', 238839),
(298589, 'PTHR35094:SF3', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 238839),
(298590, 'PTHR35094:SF4', NULL, NULL, NULL, NULL, 'CHITIN-BINDING LECTIN 1-LIKE', 238839),
(298591, 'PTHR35094:SF5', NULL, NULL, NULL, NULL, 'BNAA09G51330D PROTEIN', 238839),
(298592, 'PTHR10918:SF5', NULL, NULL, NULL, NULL, 'HOMER, ISOFORM E', 238840),
(298593, 'PTHR10918:SF4', NULL, NULL, NULL, NULL, 'HOMER PROTEIN HOMOLOG 3', 238840),
(298594, 'PTHR10918:SF3', NULL, NULL, NULL, NULL, 'HOMER PROTEIN HOMOLOG 1', 238840),
(298595, 'PTHR10918', NULL, NULL, NULL, NULL, 'HOMER', 238840),
(298596, 'PTHR10918:SF2', NULL, NULL, NULL, NULL, 'HOMER PROTEIN HOMOLOG 2', 238840),
(298597, 'PTHR10372:SF6', NULL, NULL, NULL, NULL, 'CATENIN DELTA-1', 238841),
(298598, 'PTHR10372:SF5', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT PROTEIN DELETED IN VELO-CARDIO-FACIAL SYNDROME', 238841);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(298599, 'PTHR10372:SF27', NULL, NULL, NULL, NULL, 'ADHERENS JUNCTION PROTEIN P120', 238841),
(298600, 'PTHR10372:SF9', NULL, NULL, NULL, NULL, 'CATENIN DELTA-2', 238841),
(298601, 'PTHR10372:SF8', NULL, NULL, NULL, NULL, 'PLAKOPHILIN-4', 238841),
(298602, 'PTHR10372:SF25', NULL, NULL, NULL, NULL, 'PLAKOPHILIN-2', 238841),
(298603, 'PTHR10372:SF3', NULL, NULL, NULL, NULL, 'PLAKOPHILIN-1', 238841),
(298604, 'PTHR10372', NULL, NULL, NULL, NULL, 'PLAKOPHILLIN-RELATED', 238841),
(298605, 'PTHR10372:SF32', NULL, NULL, NULL, NULL, '', 238841),
(298606, 'PTHR10372:SF1', NULL, NULL, NULL, NULL, 'PLAKOPHILIN-3', 238841),
(298607, 'PTHR10372:SF31', NULL, NULL, NULL, NULL, 'CATENIN (CADHERIN-ASSOCIATED PROTEIN), DELTA 2B', 238841),
(298608, 'PTHR39640', NULL, NULL, NULL, NULL, 'VNG6129C', 238842),
(298609, 'PTHR39640:SF1', NULL, NULL, NULL, NULL, 'DUF790 FAMILY PROTEIN', 238842),
(298610, 'PTHR47874:SF4', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 238843),
(298611, 'PTHR47874:SF1', NULL, NULL, NULL, NULL, 'OS05G0407900 PROTEIN', 238843),
(298612, 'PTHR47874:SF7', NULL, NULL, NULL, NULL, 'BNAA05G30910D PROTEIN', 238843),
(298613, 'PTHR47874:SF6', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 238843),
(298614, 'PTHR47874:SF5', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN PPR5 HOMOLOG, CHLOROPLASTIC', 238843),
(298615, 'PTHR47874', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 238843),
(298616, 'PTHR35319', NULL, NULL, NULL, NULL, '', 238844),
(298617, 'PTHR35319:SF2', NULL, NULL, NULL, NULL, 'YCF54', 238844),
(298618, 'PTHR37245:SF3', NULL, NULL, NULL, NULL, 'OS04G0495150 PROTEIN', 238845),
(298619, 'PTHR37245:SF5', NULL, NULL, NULL, NULL, 'BNAA08G13710D PROTEIN', 238845),
(298620, 'PTHR37245:SF4', NULL, NULL, NULL, NULL, 'PAMP-INDUCED SECRETED PEPTIDE 1', 238845),
(298621, 'PTHR37245', NULL, NULL, NULL, NULL, 'PAMP-INDUCED SECRETED PEPTIDE 1', 238845),
(298622, 'PTHR37245:SF6', NULL, NULL, NULL, NULL, 'BNAC01G09990D PROTEIN', 238845),
(298623, 'PTHR37245:SF8', NULL, NULL, NULL, NULL, 'OS08G0540900 PROTEIN', 238845),
(298624, 'PTHR33198:SF8', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 238846),
(298625, 'PTHR33198', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN-RELATED', 238846),
(298626, 'PTHR33198:SF19', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 238846),
(298627, 'PTHR34048:SF3', NULL, NULL, NULL, NULL, 'LOW-DENSITY RECEPTOR-LIKE PROTEIN', 238847),
(298628, 'PTHR34048:SF7', NULL, NULL, NULL, NULL, 'THYLAKOID MEMBRANE PROTEIN SSL2009-LIKE', 238847),
(298629, 'PTHR34048:SF6', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 238847),
(298630, 'PTHR34048:SF5', NULL, NULL, NULL, NULL, 'INNER MEMBRANE LOCALIZED PROTEIN', 238847),
(298631, 'PTHR34048:SF10', NULL, NULL, NULL, NULL, '', 238847),
(298632, 'PTHR34048:SF9', NULL, NULL, NULL, NULL, '', 238847),
(298633, 'PTHR34048:SF8', NULL, NULL, NULL, NULL, '', 238847),
(298634, 'PTHR34048', NULL, NULL, NULL, NULL, 'LOW-DENSITY RECEPTOR-LIKE PROTEIN', 238847),
(298635, 'PTHR24161:SF114', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 238848),
(298636, 'PTHR24161:SF113', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX CONTAINING 10', 238848),
(298637, 'PTHR24161:SF112', NULL, NULL, NULL, NULL, '', 238848),
(298638, 'PTHR24161:SF111', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN 55', 238848),
(298639, 'PTHR24161:SF115', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN 44', 238848),
(298640, 'PTHR24161:SF20', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SAM DOMAIN-CONTAINING PROTEIN 4B', 238848),
(298641, 'PTHR24161:SF85', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL CHANNEL PYREXIA', 238848),
(298642, 'PTHR24161:SF41', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE', 238848),
(298643, 'PTHR24161:SF83', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 238848),
(298644, 'PTHR24161:SF24', NULL, NULL, NULL, NULL, 'USHER SYNDROME TYPE-1G PROTEIN', 238848),
(298645, 'PTHR24161', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN-RELATED', 238848);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(298646, 'PTHR24161:SF89', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 238848),
(298647, 'PTHR24161:SF21', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 35', 238848),
(298648, 'PTHR24161:SF87', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT PROTEIN (AFU_ORTHOLOGUE AFUA_1G14510)', 238848),
(298649, 'PTHR24161:SF103', NULL, NULL, NULL, NULL, 'LD20463P', 238848),
(298650, 'PTHR24161:SF102', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 238848),
(298651, 'PTHR24161:SF101', NULL, NULL, NULL, NULL, 'PROTEIN S-ACYLTRANSFERASE 23-RELATED', 238848),
(298652, 'PTHR24161:SF106', NULL, NULL, NULL, NULL, 'USHER SYNDROME 1GB (AUTOSOMAL RECESSIVE)', 238848),
(298653, 'PTHR24161:SF109', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND STERILE ALPHA MOTIF DOMAIN-CONTAINING 4B', 238848),
(298654, 'PTHR24161:SF108', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE HIP14', 238848),
(298655, 'PTHR24161:SF97', NULL, NULL, NULL, NULL, 'ANKYRIN 1', 238848),
(298656, 'PTHR24161:SF52', NULL, NULL, NULL, NULL, 'M-PHASE PHOSPHOPROTEIN 8', 238848),
(298657, 'PTHR24161:SF95', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 238848),
(298658, 'PTHR24161:SF72', NULL, NULL, NULL, NULL, 'TARGET OF RAPAMYCIN COMPLEX 2 SUBUNIT AVO2', 238848),
(298659, 'PTHR24161:SF17', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE', 238848),
(298660, 'PTHR24161:SF16', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE ZDHHC13', 238848),
(298661, 'PTHR24161:SF18', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE ZDHHC17', 238848),
(298662, 'PTHR24161:SF110', NULL, NULL, NULL, NULL, 'USHER SYNDROME 1GA (AUTOSOMAL RECESSIVE)', 238848),
(298663, 'PTHR33705', NULL, NULL, NULL, NULL, 'PHOSPHOCARRIER PROTEIN HPR', 238849),
(298664, 'PTHR33705:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOCARRIER PROTEIN HPR', 238849),
(298665, 'PTHR33705:SF2', NULL, NULL, NULL, NULL, 'PHOSPHOCARRIER PROTEIN NPR', 238849),
(298666, 'PTHR33705:SF5', NULL, NULL, NULL, NULL, 'HPR-LIKE PROTEIN CRH', 238849),
(298667, 'PTHR34726:SF2', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN DDB_G0283913-RELATED', 238850),
(298668, 'PTHR34726:SF1', NULL, NULL, NULL, NULL, '', 238850),
(298669, 'PTHR34726:SF3', NULL, NULL, NULL, NULL, 'GBP DOMAIN-CONTAINING PROTEIN', 238850),
(298670, 'PTHR34726', NULL, NULL, NULL, NULL, 'GBP DOMAIN-CONTAINING PROTEIN', 238850),
(298671, 'PTHR31005', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 238851),
(298672, 'PTHR31005:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG18975', 238851),
(298673, 'PTHR31005:SF4', NULL, NULL, NULL, NULL, 'PROTEIN F37C4.5', 238851),
(298674, 'PTHR31005:SF8', NULL, NULL, NULL, NULL, 'BLL7080 PROTEIN', 238851),
(298675, 'PTHR31005:SF9', NULL, NULL, NULL, NULL, 'DUF4139 DOMAIN-CONTAINING PROTEIN', 238851),
(298676, 'PTHR31005:SF10', NULL, NULL, NULL, NULL, 'DUF4140 DOMAIN-CONTAINING PROTEIN', 238851),
(298677, 'PTHR31983', NULL, NULL, NULL, NULL, 'ENDO-1,3(4)-BETA-GLUCANASE 1', 238852),
(298678, 'PTHR31983:SF18', NULL, NULL, NULL, NULL, 'ENDO-1,3(4)-BETA-GLUCANASE', 238852),
(298679, 'PTHR31983:SF19', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE FAMILY 81 PROTEIN', 238852),
(298680, 'PTHR31983:SF16', NULL, NULL, NULL, NULL, 'ENDO-1,3(4)-BETA-GLUCANASE', 238852),
(298681, 'PTHR31983:SF17', NULL, NULL, NULL, NULL, 'ENDO-1,3(4)-BETA-GLUCANASE', 238852),
(298682, 'PTHR31983:SF0', NULL, NULL, NULL, NULL, 'ENDO-1,3(4)-BETA-GLUCANASE 2', 238852),
(298683, 'PTHR31983:SF12', NULL, NULL, NULL, NULL, 'ENDO-1,3(4)-BETA-GLUCANASE', 238852),
(298684, 'PTHR31983:SF13', NULL, NULL, NULL, NULL, 'ENDO-1,3(4)-BETA-GLUCANASE', 238852),
(298685, 'PTHR31983:SF21', NULL, NULL, NULL, NULL, 'PRIMARY SEPTUM ENDO-1,3(4)-BETA-GLUCANASE', 238852),
(298686, 'PTHR31983:SF20', NULL, NULL, NULL, NULL, 'ENDO-1,3(4)-BETA-GLUCANASE 1', 238852),
(298687, 'PTHR45663:SF23', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 238853),
(298688, 'PTHR45663:SF24', NULL, NULL, NULL, NULL, 'THIOREDOXIN-1-LIKE', 238853),
(298689, 'PTHR45663:SF32', NULL, NULL, NULL, NULL, 'THIOREDOXIN FAMILY PROTEIN-RELATED', 238853),
(298690, 'PTHR45663:SF21', NULL, NULL, NULL, NULL, 'THIOREDOXIN M3, CHLOROPLASTIC', 238853);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(298691, 'PTHR45663:SF43', NULL, NULL, NULL, NULL, 'THIOREDOXIN-RELATED', 238853),
(298692, 'PTHR45663:SF11', NULL, NULL, NULL, NULL, 'GEO12009P1', 238853),
(298693, 'PTHR45663:SF44', NULL, NULL, NULL, NULL, 'OS01G0200400 PROTEIN', 238853),
(298694, 'PTHR45663:SF33', NULL, NULL, NULL, NULL, 'THIOREDOXIN-1-LIKE', 238853),
(298695, 'PTHR45663:SF22', NULL, NULL, NULL, NULL, 'THIOREDOXIN X, CHLOROPLASTIC', 238853),
(298696, 'PTHR45663:SF16', NULL, NULL, NULL, NULL, 'THIOREDOXIN M4, CHLOROPLASTIC', 238853),
(298697, 'PTHR45663:SF39', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 238853),
(298698, 'PTHR45663:SF28', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 238853),
(298699, 'PTHR45663:SF36', NULL, NULL, NULL, NULL, 'THIOREDOXIN', 238853),
(298700, 'PTHR45663:SF25', NULL, NULL, NULL, NULL, 'THIOREDOXIN Y2, CHLOROPLASTIC', 238853),
(298701, 'PTHR45663:SF15', NULL, NULL, NULL, NULL, 'THIOREDOXIN Y1, CHLOROPLASTIC', 238853),
(298702, 'PTHR45663:SF37', NULL, NULL, NULL, NULL, 'THIOREDOXIN M2, CHLOROPLASTIC', 238853),
(298703, 'PTHR45663:SF30', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 238853),
(298704, 'PTHR45663:SF41', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE PROTEIN YUSE', 238853),
(298705, 'PTHR45663:SF42', NULL, NULL, NULL, NULL, 'THIOREDOXIN M5, CHLOROPLASTIC', 238853),
(298706, 'PTHR45663', NULL, NULL, NULL, NULL, 'GEO12009P1', 238853),
(298707, 'PTHR45663:SF40', NULL, NULL, NULL, NULL, 'THIOREDOXIN 2', 238853),
(298708, 'PTHR45663:SF3', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 238853),
(298709, 'PTHR45663:SF6', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE PROTEIN YDBP', 238853),
(298710, 'PTHR45663:SF29', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 238853),
(298711, 'PTHR37951:SF1', NULL, NULL, NULL, NULL, 'TYPE VI SECRETION SYSTEM COMPONENT TSSA1', 238854),
(298712, 'PTHR37951', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 238854),
(298713, 'PTHR47660', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR WITH C2H2 AND ZN(2)-CYS(6) DNA BINDING DOMAIN (EUROFUNG)-RELATED-RELATED', 238855),
(298714, 'PTHR47660:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR WITH C2H2 AND ZN(2)-CYS(6) DNA BINDING DOMAIN (EUROFUNG)-RELATED', 238855),
(298715, 'PTHR47660:SF3', NULL, NULL, NULL, NULL, 'FINGER DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G03310)-RELATED', 238855),
(298716, 'PTHR47660:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR WITH C2H2 AND ZN(2)-CYS(6) DNA BINDING DOMAIN (EUROFUNG)-RELATED', 238855),
(298717, 'PTHR47660:SF9', NULL, NULL, NULL, NULL, '', 238855),
(298718, 'PTHR47660:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR WITH C2H2 AND ZN(2)-CYS(6) DNA BINDING DOMAIN (EUROFUNG)-RELATED', 238855),
(298719, 'PTHR34979:SF1', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YGAZ', 238856),
(298720, 'PTHR34979', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YGAZ', 238856),
(298721, 'PTHR48178', NULL, NULL, NULL, NULL, 'PEROXISOME BIOGENESIS FACTOR 2', 238857),
(298722, 'PTHR48178:SF1', NULL, NULL, NULL, NULL, 'PEROXISOME BIOGENESIS FACTOR 2', 238857),
(298723, 'PTHR13558', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 238858),
(298724, 'PTHR13558:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 134', 238858),
(298725, 'PTHR37391', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE', 238859),
(298726, 'PTHR37391:SF9', NULL, NULL, NULL, NULL, '', 238859),
(298727, 'PTHR37391:SF7', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN-CONTAINING PROTEIN-RELATED', 238859),
(298728, 'PTHR37391:SF6', NULL, NULL, NULL, NULL, 'BNAC01G32860D PROTEIN', 238859),
(298729, 'PTHR37391:SF5', NULL, NULL, NULL, NULL, '', 238859),
(298730, 'PTHR37391:SF4', NULL, NULL, NULL, NULL, '', 238859),
(298731, 'PTHR37391:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE', 238859),
(298732, 'PTHR37391:SF10', NULL, NULL, NULL, NULL, 'OS02G0828200 PROTEIN', 238859),
(298733, 'PTHR34481', NULL, NULL, NULL, NULL, 'TRYPSIN/FACTOR XIIA INHIBITOR-RELATED', 238860),
(298734, 'PTHR34481:SF16', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 238860); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(298735, 'PTHR34481:SF12', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE/TRYPSIN INHIBITOR CM2', 238860),
(298736, 'PTHR34481:SF13', NULL, NULL, NULL, NULL, 'TRYPSIN/FACTOR XIIA INHIBITOR', 238860),
(298737, 'PTHR34481:SF14', NULL, NULL, NULL, NULL, 'GLUTENIN, HIGH MOLECULAR WEIGHT SUBUNIT DX5', 238860),
(298738, 'PTHR34481:SF15', NULL, NULL, NULL, NULL, 'TRYPSIN/ALPHA-AMYLASE INHIBITOR CMX2', 238860),
(298739, 'PTHR34481:SF4', NULL, NULL, NULL, NULL, '17KDA ALPHA-AMYLASE/TRYPSIN INHIBITOR 2', 238860),
(298740, 'PTHR34481:SF10', NULL, NULL, NULL, NULL, 'CHYMOTRYPSIN INHIBITOR WCI', 238860),
(298741, 'PTHR34481:SF5', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE/TRYPSIN INHIBITOR CM3', 238860),
(298742, 'PTHR34481:SF11', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 238860),
(298743, 'PTHR34481:SF2', NULL, NULL, NULL, NULL, 'TRYPSIN/FACTOR XIIA INHIBITOR', 238860),
(298744, 'PTHR34481:SF1', NULL, NULL, NULL, NULL, 'SEED ALLERGENIC PROTEIN RAG1', 238860),
(298745, 'PTHR34481:SF8', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE INHIBITOR 0.19', 238860),
(298746, 'PTHR34481:SF7', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE/TRYPSIN INHIBITOR CM16', 238860),
(298747, 'PTHR34481:SF9', NULL, NULL, NULL, NULL, '19 KDA GLOBULIN', 238860),
(298748, 'PTHR22990:SF20', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 11', 238861),
(298749, 'PTHR22990', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN', 238861),
(298750, 'PTHR22990:SF22', NULL, NULL, NULL, NULL, 'UBR-TYPE DOMAIN-CONTAINING PROTEIN', 238861),
(298751, 'PTHR22990:SF32', NULL, NULL, NULL, NULL, '', 238861),
(298752, 'PTHR22990:SF15', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 10', 238861),
(298753, 'PTHR10800', NULL, NULL, NULL, NULL, 'PULMONARY SURFACTANT-ASSOCIATED PROTEIN C', 238862),
(298754, 'PTHR10800:SF4', NULL, NULL, NULL, NULL, 'PULMONARY SURFACTANT-ASSOCIATED PROTEIN C', 238862),
(298755, 'PTHR40467', NULL, NULL, NULL, NULL, '', 238863),
(298756, 'PTHR40467:SF1', NULL, NULL, NULL, NULL, '', 238863),
(298757, 'PTHR30522', NULL, NULL, NULL, NULL, 'NUCLEOSIDE TRIPHOSPHATE PYROPHOSPHOHYDROLASE', 238864),
(298758, 'PTHR30522:SF0', NULL, NULL, NULL, NULL, 'NUCLEOSIDE TRIPHOSPHATE PYROPHOSPHOHYDROLASE', 238864),
(298759, 'PTHR10921:SF0', NULL, NULL, NULL, NULL, 'NUCLEAR DISTRIBUTION PROTEIN NUDE-LIKE 1', 238865),
(298760, 'PTHR10921:SF1', NULL, NULL, NULL, NULL, 'NUCLEAR DISTRIBUTION PROTEIN NUDE HOMOLOG', 238865),
(298761, 'PTHR10921', NULL, NULL, NULL, NULL, 'NUCLEAR DISTRIBUTION PROTEIN NUDE HOMOLOG 1', 238865),
(298762, 'PTHR10921:SF2', NULL, NULL, NULL, NULL, 'NUCLEAR DISTRIBUTION PROTEIN NUDE HOMOLOG 1', 238865),
(298763, 'PTHR47232:SF3', NULL, NULL, NULL, NULL, 'BNAC09G37710D PROTEIN', 238866),
(298764, 'PTHR47232:SF4', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 238866),
(298765, 'PTHR47232:SF1', NULL, NULL, NULL, NULL, 'TRANSDUCIN FAMILY PROTEIN / WD-40 REPEAT FAMILY PROTEIN', 238866),
(298766, 'PTHR47232:SF2', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 238866),
(298767, 'PTHR47232', NULL, NULL, NULL, NULL, 'TRANSDUCIN FAMILY PROTEIN / WD-40 REPEAT FAMILY PROTEIN', 238866),
(298768, 'PTHR35993:SF1', NULL, NULL, NULL, NULL, 'OUTER ENVELOPE PORE PROTEIN 21B, CHLOROPLASTIC', 238867),
(298769, 'PTHR35993', NULL, NULL, NULL, NULL, 'OUTER ENVELOPE PORE PROTEIN 21B, CHLOROPLASTIC', 238867),
(298770, 'PTHR35993:SF2', NULL, NULL, NULL, NULL, 'OUTER ENVELOPE PORE PROTEIN 21A, CHLOROPLASTIC', 238867),
(298771, 'PTHR35993:SF3', NULL, NULL, NULL, NULL, '', 238867),
(298772, 'PTHR42685', NULL, NULL, NULL, NULL, 'GERANYLGERANYL DIPHOSPHATE REDUCTASE', 238868),
(298773, 'PTHR42685:SF4', NULL, NULL, NULL, NULL, 'GERANYLGERANYL DIPHOSPHATE REDUCTASE, CHLOROPLASTIC', 238868),
(298774, 'PTHR42685:SF22', NULL, NULL, NULL, NULL, 'CONDITIONED MEDIUM FACTOR RECEPTOR 1', 238868),
(298775, 'PTHR42685:SF20', NULL, NULL, NULL, NULL, 'HYDROGENASE, PUTATIVE-RELATED', 238868),
(298776, 'PTHR42685:SF21', NULL, NULL, NULL, NULL, 'DEHYDROGENASE (FLAVOPROTEIN)-LIKE PROTEIN', 238868),
(298777, 'PTHR42685:SF13', NULL, NULL, NULL, NULL, 'GERANYLGERANYL REDUCTASE', 238868);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(298778, 'PTHR42685:SF19', NULL, NULL, NULL, NULL, 'POSSIBLE OXIDOREDUCTASE', 238868),
(298779, 'PTHR42685:SF18', NULL, NULL, NULL, NULL, 'DIGERANYLGERANYLGLYCEROPHOSPHOLIPID REDUCTASE', 238868),
(298780, 'PTHR17097', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE KFYI SUBUNIT', 238869),
(298781, 'PTHR17097:SF0', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 SUBUNIT C1, MITOCHONDRIAL', 238869),
(298782, 'PTHR47272', NULL, NULL, NULL, NULL, 'DDE_TNP_1_7 DOMAIN-CONTAINING PROTEIN', 238870),
(298783, 'PTHR47272:SF1', NULL, NULL, NULL, NULL, 'DDE_TNP_1_7 DOMAIN-CONTAINING PROTEIN', 238870),
(298784, 'PTHR47272:SF2', NULL, NULL, NULL, NULL, 'DDE_TNP_1_7 DOMAIN-CONTAINING PROTEIN', 238870),
(298785, 'PTHR10098:SF111', NULL, NULL, NULL, NULL, 'CHAT DOMAIN-CONTAINING PROTEIN', 238871),
(298786, 'PTHR10098:SF110', NULL, NULL, NULL, NULL, '', 238871),
(298787, 'PTHR10098:SF109', NULL, NULL, NULL, NULL, '', 238871),
(298788, 'PTHR10098:SF108', NULL, NULL, NULL, NULL, 'RESPONSE REGULATOR ASPARTATE PHOSPHATASE A', 238871),
(298789, 'PTHR10098', NULL, NULL, NULL, NULL, 'RAPSYN-RELATED', 238871),
(298790, 'PTHR10098:SF106', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 28', 238871),
(298791, 'PTHR32411:SF57', NULL, NULL, NULL, NULL, 'GNK2-HOMOLOGOUS DOMAIN-CONTAINING PROTEIN', 238872),
(298792, 'PTHR32411:SF69', NULL, NULL, NULL, NULL, 'BNAC03G15220D PROTEIN', 238872),
(298793, 'PTHR32411:SF58', NULL, NULL, NULL, NULL, 'BNACNNG07220D PROTEIN', 238872),
(298794, 'PTHR32411:SF59', NULL, NULL, NULL, NULL, 'BNAC01G31750D PROTEIN', 238872),
(298795, 'PTHR32411:SF71', NULL, NULL, NULL, NULL, 'GNK2-HOMOLOGOUS DOMAIN-CONTAINING PROTEIN', 238872),
(298796, 'PTHR32411:SF62', NULL, NULL, NULL, NULL, 'BNACNNG21720D PROTEIN', 238872),
(298797, 'PTHR32411:SF51', NULL, NULL, NULL, NULL, 'DOMAIN-CONTAINING PROTEIN 2, PUTATIVE-RELATED', 238872),
(298798, 'PTHR32411:SF52', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH REPEAT SECRETORY PROTEIN 61-RELATED', 238872),
(298799, 'PTHR32411:SF63', NULL, NULL, NULL, NULL, 'BNAA05G10410D PROTEIN', 238872),
(298800, 'PTHR32411:SF64', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH REPEAT SECRETORY PROTEIN 26-RELATED', 238872),
(298801, 'PTHR32411:SF53', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH REPEAT SECRETORY PROTEIN 18-RELATED', 238872),
(298802, 'PTHR32411:SF65', NULL, NULL, NULL, NULL, 'BNAA01G36610D PROTEIN', 238872),
(298803, 'PTHR32411:SF54', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH REPEAT SECRETORY PROTEIN 29-RELATED', 238872),
(298804, 'PTHR32411:SF43', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH REPEAT SECRETORY PROTEIN 38', 238872),
(298805, 'PTHR32411:SF55', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH REPEAT SECRETORY PROTEIN 55', 238872),
(298806, 'PTHR32411:SF44', NULL, NULL, NULL, NULL, 'OS05G0112800 PROTEIN', 238872),
(298807, 'PTHR32411:SF66', NULL, NULL, NULL, NULL, 'BNAC03G42430D PROTEIN', 238872),
(298808, 'PTHR32411:SF56', NULL, NULL, NULL, NULL, 'BNAA01G12770D PROTEIN', 238872),
(298809, 'PTHR32411:SF67', NULL, NULL, NULL, NULL, 'GNK2-HOMOLOGOUS DOMAIN-CONTAINING PROTEIN', 238872),
(298810, 'PTHR32411:SF70', NULL, NULL, NULL, NULL, 'BNAC03G42460D PROTEIN', 238872),
(298811, 'PTHR32411', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH REPEAT SECRETORY PROTEIN 38-RELATED', 238872),
(298812, 'PTHR37383', NULL, NULL, NULL, NULL, 'OS01G0694200 PROTEIN', 238873),
(298813, 'PTHR37383:SF1', NULL, NULL, NULL, NULL, 'OS01G0694200 PROTEIN', 238873),
(298814, 'PTHR34060', NULL, NULL, NULL, NULL, 'POLYKETIDE CYCLASE / DEHYDRASE AND LIPID TRANSPORT PROTEIN', 238874),
(298815, 'PTHR34060:SF2', NULL, NULL, NULL, NULL, 'OS03G0837900 PROTEIN', 238874),
(298816, 'PTHR34060:SF3', NULL, NULL, NULL, NULL, 'POLYKETIDE_CYC DOMAIN-CONTAINING PROTEIN', 238874),
(298817, 'PTHR34060:SF1', NULL, NULL, NULL, NULL, 'POLYKETIDE CYCLASE / DEHYDRASE AND LIPID TRANSPORT PROTEIN', 238874),
(298818, 'PTHR42814', NULL, NULL, NULL, NULL, 'AMP-BINDING DOMAIN-CONTAINING PROTEIN', 238875),
(298819, 'PTHR42814:SF3', NULL, NULL, NULL, NULL, 'BETA-N-ACETYLHEXOSAMINIDASE', 238875),
(298820, 'PTHR28173', NULL, NULL, NULL, NULL, 'RIBONUCLEASES P/MRP PROTEIN SUBUNIT POP8', 238876);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(298821, 'PTHR28173:SF1', NULL, NULL, NULL, NULL, 'RIBONUCLEASES P/MRP PROTEIN SUBUNIT POP8', 238876),
(298822, 'PTHR41260', NULL, NULL, NULL, NULL, 'PROTEIN ECSC', 238877),
(298823, 'PTHR41260:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ECSC', 238877),
(298824, 'PTHR47246:SF1', NULL, NULL, NULL, NULL, 'MUCIN-19', 238878),
(298825, 'PTHR47246', NULL, NULL, NULL, NULL, 'MUCIN-19', 238878),
(298826, 'PTHR11649', NULL, NULL, NULL, NULL, 'MSS1/TRME-RELATED GTP-BINDING PROTEIN', 238879),
(298827, 'PTHR11649:SF75', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE, EXPRESSED-RELATED', 238879),
(298828, 'PTHR11649:SF76', NULL, NULL, NULL, NULL, 'ENGB-TYPE G DOMAIN-CONTAINING PROTEIN', 238879),
(298829, 'PTHR11649:SF72', NULL, NULL, NULL, NULL, 'G DOMAIN-CONTAINING PROTEIN', 238879),
(298830, 'PTHR11649:SF77', NULL, NULL, NULL, NULL, 'G DOMAIN-CONTAINING PROTEIN', 238879),
(298831, 'PTHR11649:SF13', NULL, NULL, NULL, NULL, 'ENGB-TYPE G DOMAIN-CONTAINING PROTEIN', 238879),
(298832, 'PTHR33710:SF71', NULL, NULL, NULL, NULL, 'ENDONUCLEASE/EXONUCLEASE/PHOSPHATASE FAMILY PROTEIN', 238880),
(298833, 'PTHR33710:SF70', NULL, NULL, NULL, NULL, '', 238880),
(298834, 'PTHR33710:SF49', NULL, NULL, NULL, NULL, 'OS01G0714200 PROTEIN', 238880),
(298835, 'PTHR33710:SF48', NULL, NULL, NULL, NULL, 'OS02G0307075 PROTEIN', 238880),
(298836, 'PTHR33710:SF26', NULL, NULL, NULL, NULL, 'ENDONUCLEASE/EXONUCLEASE/PHOSPHATASE', 238880),
(298837, 'PTHR33710:SF69', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 238880),
(298838, 'PTHR33710:SF25', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE', 238880),
(298839, 'PTHR33710:SF64', NULL, NULL, NULL, NULL, 'ENDONUCLEASE/EXONUCLEASE/PHOSPHATASE FAMILY PROTEIN', 238880),
(298840, 'PTHR33710:SF63', NULL, NULL, NULL, NULL, 'RETROTRANSPOSON, UNCLASSIFIED-LIKE PROTEIN', 238880),
(298841, 'PTHR33710:SF62', NULL, NULL, NULL, NULL, 'DNASE I-LIKE SUPERFAMILY PROTEIN', 238880),
(298842, 'PTHR33710:SF61', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 238880),
(298843, 'PTHR33710:SF68', NULL, NULL, NULL, NULL, '', 238880),
(298844, 'PTHR33710:SF46', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 238880),
(298845, 'PTHR33710:SF23', NULL, NULL, NULL, NULL, 'AP ENDONUCLEASE/REVERSE TRANSCRIPTASE', 238880),
(298846, 'PTHR33710:SF67', NULL, NULL, NULL, NULL, 'RETROTRANSPOSON PROTEIN, UNCLASSIFIED', 238880),
(298847, 'PTHR33710:SF66', NULL, NULL, NULL, NULL, 'ENDONUCLEASE/EXONUCLEASE/PHOSPHATASE FAMILY PROTEIN', 238880),
(298848, 'PTHR33710:SF65', NULL, NULL, NULL, NULL, 'ENDONUCLEASE/EXONUCLEASE/PHOSPHATASE', 238880),
(298849, 'PTHR33710', NULL, NULL, NULL, NULL, 'BNAC02G09200D PROTEIN', 238880),
(298850, 'PTHR33710:SF75', NULL, NULL, NULL, NULL, '', 238880),
(298851, 'PTHR33710:SF52', NULL, NULL, NULL, NULL, 'BNAC03G48920D PROTEIN', 238880),
(298852, 'PTHR33710:SF74', NULL, NULL, NULL, NULL, 'VIRAL MOVEMENT PROTEIN', 238880),
(298853, 'PTHR33710:SF73', NULL, NULL, NULL, NULL, 'ZF-CCHC_4 DOMAIN-CONTAINING PROTEIN', 238880),
(298854, 'PTHR33710:SF72', NULL, NULL, NULL, NULL, 'OS08G0365050 PROTEIN', 238880),
(298855, 'PTHR33710:SF13', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', 238880),
(298856, 'PTHR33710:SF35', NULL, NULL, NULL, NULL, 'RNA-DIRECTED DNA POLYMERASE (REVERSE TRANSCRIPTASE)_ RIBONUCLEASE H', 238880),
(298857, 'PTHR33710:SF77', NULL, NULL, NULL, NULL, 'OS06G0205337 PROTEIN', 238880),
(298858, 'PTHR33710:SF55', NULL, NULL, NULL, NULL, 'ENDONUCLEASE/EXONUCLEASE/PHOSPHATASE FAMILY PROTEIN', 238880),
(298859, 'PTHR33710:SF54', NULL, NULL, NULL, NULL, 'NON-LTR RETROELEMENT REVERSE TRANSCRIPTASE', 238880),
(298860, 'PTHR33710:SF76', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 238880),
(298861, 'PTHR31250:SF34', NULL, NULL, NULL, NULL, '', 238881),
(298862, 'PTHR31250:SF56', NULL, NULL, NULL, NULL, '', 238881),
(298863, 'PTHR31250:SF11', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 238881),
(298864, 'PTHR31250:SF55', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN IQM4', 238881),
(298865, 'PTHR31250:SF14', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN IQM2', 238881);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(298866, 'PTHR31250:SF58', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING FAMILY PROTEIN', 238881),
(298867, 'PTHR31250:SF57', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN IQM1', 238881),
(298868, 'PTHR31250:SF30', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN IQM5-LIKE', 238881),
(298869, 'PTHR31250:SF51', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN IQM2-LIKE', 238881),
(298870, 'PTHR31250:SF32', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN IQM6-LIKE', 238881),
(298871, 'PTHR31250:SF54', NULL, NULL, NULL, NULL, '', 238881),
(298872, 'PTHR31250:SF10', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN IQM3', 238881),
(298873, 'PTHR31250:SF31', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN IQM1-LIKE', 238881),
(298874, 'PTHR31250:SF5', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 238881),
(298875, 'PTHR31250:SF38', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN IQM6', 238881),
(298876, 'PTHR31250:SF16', NULL, NULL, NULL, NULL, 'OS07G0633400 PROTEIN', 238881),
(298877, 'PTHR31250:SF59', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN IQM4-LIKE', 238881),
(298878, 'PTHR31250:SF39', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN IQM1-LIKE', 238881),
(298879, 'PTHR31250:SF45', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN IQM3', 238881),
(298880, 'PTHR31250:SF67', NULL, NULL, NULL, NULL, 'OS01G0570800 PROTEIN', 238881),
(298881, 'PTHR31250:SF44', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING FAMILY PROTEIN-RELATED', 238881),
(298882, 'PTHR31250:SF66', NULL, NULL, NULL, NULL, 'BNAC01G37540D PROTEIN', 238881),
(298883, 'PTHR31250:SF68', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN IQM1-LIKE', 238881),
(298884, 'PTHR31250:SF41', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING FAMILY PROTEIN', 238881),
(298885, 'PTHR31250:SF40', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN IQM3-LIKE', 238881),
(298886, 'PTHR31250:SF65', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING FAMILY PROTEIN-RELATED', 238881),
(298887, 'PTHR31250:SF43', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN IQM3-LIKE', 238881),
(298888, 'PTHR31250:SF64', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING FAMILY PROTEIN', 238881),
(298889, 'PTHR31250:SF27', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN IQM5', 238881),
(298890, 'PTHR31250:SF49', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE-RELATED', 238881),
(298891, 'PTHR31250:SF48', NULL, NULL, NULL, NULL, '', 238881),
(298892, 'PTHR31250', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN IQM3', 238881),
(298893, 'PTHR16524:SF2', NULL, NULL, NULL, NULL, 'CELL DEATH REGULATOR AVEN', 238882),
(298894, 'PTHR16524', NULL, NULL, NULL, NULL, 'CELL DEATH REGULATOR AVEN', 238882),
(298895, 'PTHR28523', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY FACTOR 1', 238883),
(298896, 'PTHR28523:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY FACTOR 1', 238883),
(298897, 'PTHR13410:SF9', NULL, NULL, NULL, NULL, 'PROTEIN PBDC1', 238884),
(298898, 'PTHR13410', NULL, NULL, NULL, NULL, 'PROTEIN PBDC1', 238884),
(298899, 'PTHR32142:SF58', NULL, NULL, NULL, NULL, 'B BOX-TYPE DOMAIN-CONTAINING PROTEIN', 238885),
(298900, 'PTHR32142:SF59', NULL, NULL, NULL, NULL, '', 238885),
(298901, 'PTHR32142:SF52', NULL, NULL, NULL, NULL, '', 238885),
(298902, 'PTHR32142:SF55', NULL, NULL, NULL, NULL, '', 238885),
(298903, 'PTHR32142', NULL, NULL, NULL, NULL, 'B BOX-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', 238885),
(298904, 'PTHR32142:SF51', NULL, NULL, NULL, NULL, '', 238885),
(298905, 'PTHR46414:SF2', NULL, NULL, NULL, NULL, 'PROTEIN BHLHB9', 238886),
(298906, 'PTHR46414:SF3', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR-ASSOCIATED SORTING PROTEIN 1', 238886),
(298907, 'PTHR46414', NULL, NULL, NULL, NULL, 'PROTEIN BHLHB9-RELATED', 238886),
(298908, 'PTHR46414:SF1', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR-ASSOCIATED SORTING PROTEIN 2', 238886),
(298909, 'PTHR45431:SF4', NULL, NULL, NULL, NULL, 'SENESCENCE-ASSOCIATED PROTEIN', 238887),
(298910, 'PTHR45431', NULL, NULL, NULL, NULL, 'RHODANESE-LIKE DOMAIN-CONTAINING PROTEIN 15, CHLOROPLASTIC', 238887);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(298911, 'PTHR45431:SF3', NULL, NULL, NULL, NULL, 'RHODANESE-LIKE DOMAIN-CONTAINING PROTEIN 15, CHLOROPLASTIC', 238887),
(298912, 'PTHR45431:SF6', NULL, NULL, NULL, NULL, 'RHODANESE DOMAIN-CONTAINING PROTEIN', 238887),
(298913, 'PTHR45431:SF7', NULL, NULL, NULL, NULL, 'RHODANESE DOMAIN-CONTAINING PROTEIN', 238887),
(298914, 'PTHR23266:SF99', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY CONSTANT DELTA', 238888),
(298915, 'PTHR23266', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY CHAIN', 238888),
(298916, 'PTHR23266:SF95', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 238888),
(298917, 'PTHR23266:SF359', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 238888),
(298918, 'PTHR23266:SF238', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 4-34', 238888),
(298919, 'PTHR23266:SF237', NULL, NULL, NULL, NULL, 'IG LAMBDA-2 CHAIN C REGION-RELATED', 238888),
(298920, 'PTHR23266:SF317', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 1-69-2', 238888),
(298921, 'PTHR23266:SF113', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 238888),
(298922, 'PTHR23266:SF355', NULL, NULL, NULL, NULL, 'IG HEAVY CHAIN V REGION-RELATED', 238888),
(298923, 'PTHR23266:SF310', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA CONSTANT 1-RELATED', 238888),
(298924, 'PTHR23266:SF277', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 3-13', 238888),
(298925, 'PTHR23266:SF313', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 3-15', 238888),
(298926, 'PTHR23266:SF236', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 3-43-RELATED', 238888),
(298927, 'PTHR23266:SF357', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 3-11-RELATED', 238888),
(298928, 'PTHR23266:SF114', NULL, NULL, NULL, NULL, 'IG HEAVY CHAIN V REGION AMPC1-RELATED', 238888),
(298929, 'PTHR23266:SF230', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 1-2', 238888),
(298930, 'PTHR23266:SF196', NULL, NULL, NULL, NULL, 'IG HEAVY CHAIN V REGION 108A-RELATED', 238888),
(298931, 'PTHR23266:SF273', NULL, NULL, NULL, NULL, 'IGV DOMAIN-CONTAINING PROTEIN', 238888),
(298932, 'PTHR23266:SF152', NULL, NULL, NULL, NULL, 'IG HEAVY CHAIN V REGION MOPC 47A-RELATED', 238888),
(298933, 'PTHR23266:SF231', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 4-9', 238888),
(298934, 'PTHR23266:SF275', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 1-24', 238888),
(298935, 'PTHR23266:SF154', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA-LIKE POLYPEPTIDE 1', 238888),
(298936, 'PTHR23266:SF270', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 1-58', 238888),
(298937, 'PTHR23266:SF272', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 1-2', 238888),
(298938, 'PTHR23266:SF150', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 238888),
(298939, 'PTHR23266:SF304', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 1-18', 238888),
(298940, 'PTHR23266:SF348', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 5-10-1-RELATED', 238888),
(298941, 'PTHR23266:SF347', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 9-4', 238888),
(298942, 'PTHR23266:SF305', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 238888),
(298943, 'PTHR23266:SF228', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 1-4-RELATED', 238888),
(298944, 'PTHR23266:SF223', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 3-7', 238888),
(298945, 'PTHR23266:SF387', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 4-4', 238888),
(298946, 'PTHR23266:SF346', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 238888),
(298947, 'PTHR23266:SF302', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 238888),
(298948, 'PTHR23266:SF269', NULL, NULL, NULL, NULL, 'IG HEAVY CHAIN V REGION 345-RELATED', 238888),
(298949, 'PTHR23266:SF345', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA-LIKE POLYPEPTIDE 1', 238888),
(298950, 'PTHR23266:SF384', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 3-53-RELATED', 238888),
(298951, 'PTHR23266:SF383', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 5-16', 238888);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(298952, 'PTHR23266:SF262', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 1-69-RELATED', 238888),
(298953, 'PTHR23266:SF100', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 238888),
(298954, 'PTHR23266:SF386', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 3-48', 238888),
(298955, 'PTHR23266:SF341', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 238888),
(298956, 'PTHR23266:SF385', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 3-49', 238888),
(298957, 'PTHR23266:SF380', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 238888),
(298958, 'PTHR23266:SF382', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA CONSTANT 6', 238888),
(298959, 'PTHR23266:SF381', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 1-82', 238888),
(298960, 'PTHR23266:SF219', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 3-74', 238888),
(298961, 'PTHR23266:SF259', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 2-5', 238888),
(298962, 'PTHR23266:SF338', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 3-20', 238888),
(298963, 'PTHR23266:SF377', NULL, NULL, NULL, NULL, 'NON-FUNCTIONAL IMMUNOGLOBULIN HEAVY VARIABLE 7-81-RELATED', 238888),
(298964, 'PTHR23266:SF333', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 3-73', 238888),
(298965, 'PTHR23266:SF332', NULL, NULL, NULL, NULL, 'IG HEAVY CHAIN V REGION VH558 A1/A4-RELATED', 238888),
(298966, 'PTHR23266:SF376', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 238888),
(298967, 'PTHR23266:SF335', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 10-1-RELATED', 238888),
(298968, 'PTHR23266:SF379', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 1-3', 238888),
(298969, 'PTHR23266:SF378', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 238888),
(298970, 'PTHR23266:SF373', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 3-9', 238888),
(298971, 'PTHR23266:SF296', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA CONSTANT 7', 238888),
(298972, 'PTHR23266:SF372', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 3-23-RELATED', 238888),
(298973, 'PTHR23266:SF298', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 3/OR16-9 (NON-FUNCTIONAL)', 238888),
(298974, 'PTHR23266:SF254', NULL, NULL, NULL, NULL, 'IG HEAVY CHAIN V REGION MC101-RELATED', 238888),
(298975, 'PTHR23266:SF375', NULL, NULL, NULL, NULL, 'IG HEAVY CHAIN V REGION 36-65-RELATED', 238888),
(298976, 'PTHR23266:SF330', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 2-70-RELATED', 238888),
(298977, 'PTHR23266:SF253', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 238888),
(298978, 'PTHR23266:SF297', NULL, NULL, NULL, NULL, 'NON-FUNCTIONAL IMMUNOGLOBULIN HEAVY VARIABLE 1-38-4-RELATED', 238888),
(298979, 'PTHR23266:SF374', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 238888),
(298980, 'PTHR23266:SF371', NULL, NULL, NULL, NULL, 'IG HEAVY CHAIN V REGION 733', 238888),
(298981, 'PTHR23266:SF370', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 6-2', 238888),
(298982, 'PTHR23266:SF290', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 3/OR16-13 (NON-FUNCTIONAL)', 238888),
(298983, 'PTHR23266:SF326', NULL, NULL, NULL, NULL, 'RCG64228', 238888),
(298984, 'PTHR23266:SF369', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 3-72', 238888),
(298985, 'PTHR23266:SF322', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 1-46', 238888),
(298986, 'PTHR23266:SF366', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 238888),
(298987, 'PTHR23266:SF365', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 4-38-2', 238888),
(298988, 'PTHR23266:SF368', NULL, NULL, NULL, NULL, 'IGV DOMAIN-CONTAINING PROTEIN', 238888),
(298989, 'PTHR23266:SF323', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 4-30-2-RELATED', 238888),
(298990, 'PTHR23266:SF367', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN KAPPA CONSTANT', 238888),
(298991, 'PTHR23266:SF246', NULL, NULL, NULL, NULL, 'IG HEAVY CHAIN V REGION H8-RELATED', 238888),
(298992, 'PTHR23266:SF285', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 1-45', 238888);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(298993, 'PTHR23266:SF241', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 3-30-RELATED', 238888),
(298994, 'PTHR23266:SF240', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 238888),
(298995, 'PTHR23266:SF361', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 4-28', 238888),
(298996, 'PTHR23266:SF286', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 7-4-1', 238888),
(298997, 'PTHR23266:SF281', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 2-26', 238888),
(298998, 'PTHR23266:SF283', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA CONSTANT 2-RELATED', 238888),
(298999, 'PTHR23266:SF282', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY VARIABLE 1-8', 238888),
(299000, 'PTHR34562', NULL, NULL, NULL, NULL, 'WPP DOMAIN-INTERACTING PROTEIN 2', 238889),
(299001, 'PTHR34562:SF15', NULL, NULL, NULL, NULL, 'WPP DOMAIN-INTERACTING PROTEIN 2', 238889),
(299002, 'PTHR34562:SF13', NULL, NULL, NULL, NULL, 'OS08G0497900 PROTEIN', 238889),
(299003, 'PTHR34562:SF7', NULL, NULL, NULL, NULL, 'OS04G0471300 PROTEIN', 238889),
(299004, 'PTHR34562:SF8', NULL, NULL, NULL, NULL, 'WPP DOMAIN-INTERACTING PROTEIN 1', 238889),
(299005, 'PTHR34562:SF11', NULL, NULL, NULL, NULL, 'WPP DOMAIN-INTERACTING PROTEIN 1-LIKE', 238889),
(299006, 'PTHR34562:SF9', NULL, NULL, NULL, NULL, 'WPP DOMAIN-INTERACTING PROTEIN 3', 238889),
(299007, 'PTHR10622', NULL, NULL, NULL, NULL, 'HET DOMAIN-CONTAINING PROTEIN', 238890),
(299008, 'PTHR10622:SF10', NULL, NULL, NULL, NULL, 'HET DOMAIN-CONTAINING PROTEIN', 238890),
(299009, 'PTHR12612:SF29', NULL, NULL, NULL, NULL, 'NTF2-LIKE PROTEIN', 238891),
(299010, 'PTHR12612:SF25', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSPORT FACTOR 2', 238891),
(299011, 'PTHR12612:SF36', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSPORT FACTOR 2B-RELATED', 238891),
(299012, 'PTHR12612:SF37', NULL, NULL, NULL, NULL, 'NTF2 DOMAIN-CONTAINING PROTEIN', 238891),
(299013, 'PTHR12612:SF38', NULL, NULL, NULL, NULL, 'NTF2 DOMAIN-CONTAINING PROTEIN', 238891),
(299014, 'PTHR12612:SF9', NULL, NULL, NULL, NULL, 'NTF2-RELATED EXPORT PROTEIN 2', 238891),
(299015, 'PTHR12612:SF39', NULL, NULL, NULL, NULL, 'NTF2 DOMAIN-CONTAINING PROTEIN', 238891),
(299016, 'PTHR12612:SF28', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSPORT FACTOR 2', 238891),
(299017, 'PTHR12612:SF43', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSPORT FACTOR 2-LIKE', 238891),
(299018, 'PTHR12612:SF21', NULL, NULL, NULL, NULL, 'NTF2 DOMAIN-CONTAINING PROTEIN', 238891),
(299019, 'PTHR12612:SF44', NULL, NULL, NULL, NULL, 'NOVEL PROTEIN SIMILAR TO VERTEBRATE NUCLEAR TRANSPORT FACTOR 2 (NUTF2)', 238891),
(299020, 'PTHR12612:SF45', NULL, NULL, NULL, NULL, 'TRANSPORT FACTOR 2, PUTATIVE-RELATED', 238891),
(299021, 'PTHR12612:SF46', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSPORT FACTOR 2', 238891),
(299022, 'PTHR12612:SF30', NULL, NULL, NULL, NULL, 'NTF2 DOMAIN-CONTAINING PROTEIN', 238891),
(299023, 'PTHR12612:SF42', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSPORT FACTOR 2A', 238891),
(299024, 'PTHR12612:SF31', NULL, NULL, NULL, NULL, 'NTF2 DOMAIN-CONTAINING PROTEIN', 238891),
(299025, 'PTHR12612', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSPORT FACTOR 2', 238891),
(299026, 'PTHR12612:SF0', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSPORT FACTOR 2', 238891),
(299027, 'PTHR12612:SF4', NULL, NULL, NULL, NULL, 'NTF2-RELATED EXPORT PROTEIN 1', 238891),
(299028, 'PTHR12612:SF1', NULL, NULL, NULL, NULL, 'NTF2-RELATED EXPORT PROTEIN 2', 238891),
(299029, 'PTHR36804', NULL, NULL, NULL, NULL, 'OSJNBA0013K16.11 PROTEIN', 238892),
(299030, 'PTHR36804:SF1', NULL, NULL, NULL, NULL, 'OS04G0585600 PROTEIN', 238892),
(299031, 'PTHR10464:SF4', NULL, NULL, NULL, NULL, 'UREA TRANSPORTER', 238893),
(299032, 'PTHR10464:SF5', NULL, NULL, NULL, NULL, 'UREA TRANSPORTER 1', 238893),
(299033, 'PTHR10464:SF6', NULL, NULL, NULL, NULL, 'UREA TRANSPORTER 2', 238893),
(299034, 'PTHR10464:SF15', NULL, NULL, NULL, NULL, 'FACILITATED UREA TRANSPORTER', 238893),
(299035, 'PTHR10464:SF9', NULL, NULL, NULL, NULL, 'UREA TRANSPORTER', 238893),
(299036, 'PTHR10464', NULL, NULL, NULL, NULL, 'UREA TRANSPORTER', 238893);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(299037, 'PTHR34055:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 238894),
(299038, 'PTHR34055:SF12', NULL, NULL, NULL, NULL, 'BNAA04G27560D PROTEIN', 238894),
(299039, 'PTHR34055:SF13', NULL, NULL, NULL, NULL, 'OS06G0320300 PROTEIN', 238894),
(299040, 'PTHR34055:SF14', NULL, NULL, NULL, NULL, 'BNAC04G48140D PROTEIN', 238894),
(299041, 'PTHR34055:SF15', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING GACO-LIKE PROTEIN', 238894),
(299042, 'PTHR34055:SF8', NULL, NULL, NULL, NULL, '', 238894),
(299043, 'PTHR34055', NULL, NULL, NULL, NULL, 'OS09G0491596 PROTEIN', 238894),
(299044, 'PTHR34055:SF9', NULL, NULL, NULL, NULL, '', 238894),
(299045, 'PTHR34055:SF7', NULL, NULL, NULL, NULL, 'NEUROFILAMENT MEDIUM POLYPEPTIDE-LIKE', 238894),
(299046, 'PTHR34055:SF5', NULL, NULL, NULL, NULL, '', 238894),
(299047, 'PTHR19846:SF5', NULL, NULL, NULL, NULL, 'U4/U6 SMALL NUCLEAR RIBONUCLEOPROTEIN PRP4', 238895),
(299048, 'PTHR19846:SF3', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 238895),
(299049, 'PTHR19846', NULL, NULL, NULL, NULL, 'WD40 REPEAT PROTEIN', 238895),
(299050, 'PTHR19846:SF4', NULL, NULL, NULL, NULL, 'PROTEASOMAL ATPASE-ASSOCIATED FACTOR 1', 238895),
(299051, 'PTHR19846:SF0', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 238895),
(299052, 'PTHR44337:SF20', NULL, NULL, NULL, NULL, 'CARCINOEMBRYONIC ANTIGEN-RELATED CELL ADHESION MOLECULE 5-RELATED', 238896),
(299053, 'PTHR44337', NULL, NULL, NULL, NULL, 'CARCINOEMBRYONIC ANTIGEN-RELATED CELL ADHESION MOLECULE 8', 238896),
(299054, 'PTHR44337:SF10', NULL, NULL, NULL, NULL, 'CARCINOEMBRYONIC ANTIGEN-RELATED CELL ADHESION MOLECULE 18', 238896),
(299055, 'PTHR44337:SF24', NULL, NULL, NULL, NULL, 'CARCINOEMBRYONIC ANTIGEN-RELATED CELL ADHESION MOLECULE 6', 238896),
(299056, 'PTHR44337:SF13', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN SUPERFAMILY MEMBER 23', 238896),
(299057, 'PTHR44337:SF22', NULL, NULL, NULL, NULL, 'SI:DKEYP-97A10.3', 238896),
(299058, 'PTHR44337:SF23', NULL, NULL, NULL, NULL, 'V-SET AND IMMUNOGLOBULIN DOMAIN CONTAINING 10 LIKE 2', 238896),
(299059, 'PTHR44337:SF17', NULL, NULL, NULL, NULL, 'SI:CH211-264F5.6', 238896),
(299060, 'PTHR44337:SF15', NULL, NULL, NULL, NULL, 'PREGNANCY-SPECIFIC BETA-1-GLYCOPROTEIN 11-RELATED', 238896),
(299061, 'PTHR44337:SF16', NULL, NULL, NULL, NULL, 'SC:D0175-RELATED', 238896),
(299062, 'PTHR44337:SF1', NULL, NULL, NULL, NULL, 'CARCINOEMBRYONIC ANTIGEN-RELATED CELL ADHESION MOLECULE 8', 238896),
(299063, 'PTHR44337:SF6', NULL, NULL, NULL, NULL, 'CARCINOEMBRYONIC ANTIGEN-RELATED CELL ADHESION MOLECULE 19', 238896),
(299064, 'PTHR44337:SF8', NULL, NULL, NULL, NULL, '', 238896),
(299065, 'PTHR45436', NULL, NULL, NULL, NULL, 'SENSOR HISTIDINE KINASE YKOH', 238897),
(299066, 'PTHR45436:SF1', NULL, NULL, NULL, NULL, 'SENSOR PROTEIN QSEC', 238897),
(299067, 'PTHR45436:SF4', NULL, NULL, NULL, NULL, 'SENSOR PROTEIN PHOQ', 238897),
(299068, 'PTHR45436:SF10', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE', 238897),
(299069, 'PTHR45436:SF3', NULL, NULL, NULL, NULL, 'SENSOR HISTIDINE KINASE HPRS', 238897),
(299070, 'PTHR45436:SF5', NULL, NULL, NULL, NULL, 'SENSOR HISTIDINE KINASE TRCS', 238897),
(299071, 'PTHR45436:SF8', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE', 238897),
(299072, 'PTHR45436:SF15', NULL, NULL, NULL, NULL, 'SENSOR HISTIDINE KINASE CUSS', 238897),
(299073, 'PTHR45436:SF14', NULL, NULL, NULL, NULL, 'SENSOR PROTEIN QSEC', 238897),
(299074, 'PTHR45436:SF7', NULL, NULL, NULL, NULL, 'SENSOR PROTEIN BASS', 238897),
(299075, 'PTHR45436:SF9', NULL, NULL, NULL, NULL, 'SENSOR PROTEIN', 238897),
(299076, 'PTHR31694:SF19', NULL, NULL, NULL, NULL, '', 238898),
(299077, 'PTHR31694:SF8', NULL, NULL, NULL, NULL, '', 238898),
(299078, 'PTHR31694:SF5', NULL, NULL, NULL, NULL, 'DESICCATION PROTEIN PCC13-62', 238898),
(299079, 'PTHR31694:SF20', NULL, NULL, NULL, NULL, '', 238898),
(299080, 'PTHR31694:SF21', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 238898),
(299081, 'PTHR31694:SF17', NULL, NULL, NULL, NULL, 'DESICCATION-RELATED PROTEIN PCC13-62-LIKE', 238898);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(299082, 'PTHR31694:SF15', NULL, NULL, NULL, NULL, 'DESICCATION-RELATED PROTEIN PCC13-62-LIKE', 238898),
(299083, 'PTHR31694', NULL, NULL, NULL, NULL, 'DESICCATION-LIKE PROTEIN', 238898),
(299084, 'PTHR31694:SF24', NULL, NULL, NULL, NULL, 'DESICCATION-RELATED PROTEIN PCC13-62-RELATED', 238898),
(299085, 'PTHR31694:SF14', NULL, NULL, NULL, NULL, '', 238898),
(299086, 'PTHR31694:SF22', NULL, NULL, NULL, NULL, 'DESICCATION-RELATED PROTEIN PCC13-62-LIKE', 238898),
(299087, 'PTHR31694:SF23', NULL, NULL, NULL, NULL, '', 238898),
(299088, 'PTHR31694:SF12', NULL, NULL, NULL, NULL, 'DESICCATION-LIKE PROTEIN', 238898),
(299089, 'PTHR47119', NULL, NULL, NULL, NULL, 'PLANT VIRAL-RESPONSE FAMILY PROTEIN', 238899),
(299090, 'PTHR47119:SF2', NULL, NULL, NULL, NULL, 'C GLOBULAR STAGE ISOFORM 1', 238899),
(299091, 'PTHR47119:SF1', NULL, NULL, NULL, NULL, 'PLANT VIRAL-RESPONSE FAMILY PROTEIN', 238899),
(299092, 'PTHR47119:SF4', NULL, NULL, NULL, NULL, 'C GLOBULAR STAGE ISOFORM 1', 238899),
(299093, 'PTHR47119:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 45B-LIKE PROTEIN', 238899),
(299094, 'PTHR47119:SF5', NULL, NULL, NULL, NULL, 'BNAC05G24250D PROTEIN', 238899),
(299095, 'PTHR14865', NULL, NULL, NULL, NULL, 'CST COMPLEX SUBUNIT CTC1', 238900),
(299096, 'PTHR14865:SF2', NULL, NULL, NULL, NULL, 'CST COMPLEX SUBUNIT CTC1', 238900),
(299097, 'PTHR36719', NULL, NULL, NULL, NULL, 'OS01G0676200 PROTEIN', 238901),
(299098, 'PTHR36719:SF1', NULL, NULL, NULL, NULL, 'OS01G0676200 PROTEIN', 238901),
(299099, 'PTHR46769', NULL, NULL, NULL, NULL, 'POLYCYSTIC KIDNEY AND HEPATIC DISEASE 1 (AUTOSOMAL RECESSIVE)-LIKE 1', 238902),
(299100, 'PTHR46769:SF1', NULL, NULL, NULL, NULL, 'FIBROCYSTIN', 238902),
(299101, 'PTHR46769:SF2', NULL, NULL, NULL, NULL, 'FIBROCYSTIN-L', 238902),
(299102, 'PTHR13464:SF0', NULL, NULL, NULL, NULL, 'SAP30-BINDING PROTEIN', 238903),
(299103, 'PTHR13464', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR PROTEIN HCNGP', 238903),
(299104, 'PTHR38355:SF2', NULL, NULL, NULL, NULL, 'BNAA06G36690D PROTEIN', 238904),
(299105, 'PTHR38355:SF1', NULL, NULL, NULL, NULL, 'OS06G0149500 PROTEIN', 238904),
(299106, 'PTHR38355', NULL, NULL, NULL, NULL, 'OS06G0149500 PROTEIN', 238904),
(299107, 'PTHR34305', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 238905),
(299108, 'PTHR34305:SF1', NULL, NULL, NULL, NULL, 'CXC4 DOMAIN-CONTAINING PROTEIN', 238905),
(299109, 'PTHR15446:SF15', NULL, NULL, NULL, NULL, 'UROPLAKIN-3B', 238906),
(299110, 'PTHR15446:SF17', NULL, NULL, NULL, NULL, 'UROPLAKIN-3A', 238906),
(299111, 'PTHR15446:SF2', NULL, NULL, NULL, NULL, 'UROPLAKIN-3B-LIKE PROTEIN 1-RELATED', 238906),
(299112, 'PTHR15446', NULL, NULL, NULL, NULL, 'UROPLAKIN III', 238906),
(299113, 'PTHR32463:SF0', NULL, NULL, NULL, NULL, 'L-FUCOSE KINASE', 238907),
(299114, 'PTHR32463', NULL, NULL, NULL, NULL, 'L-FUCOSE KINASE', 238907),
(299115, 'PTHR47033', NULL, NULL, NULL, NULL, 'CYSTATIN-M', 238908),
(299116, 'PTHR47033:SF1', NULL, NULL, NULL, NULL, 'CYSTATIN-M', 238908),
(299117, 'PTHR33220:SF5', NULL, NULL, NULL, NULL, 'RRNA INTRON-ENCODED HOMING ENDONUCLEASE', 238909),
(299118, 'PTHR33220', NULL, NULL, NULL, NULL, 'BNAA09G04420D PROTEIN', 238909),
(299119, 'PTHR11573:SF29', NULL, NULL, NULL, NULL, 'RIBONUCLEOSIDE-DIPHOSPHATE REDUCTASE', 238910),
(299120, 'PTHR11573:SF28', NULL, NULL, NULL, NULL, 'RIBONUCLEOSIDE-DIPHOSPHATE REDUCTASE', 238910),
(299121, 'PTHR11573:SF30', NULL, NULL, NULL, NULL, 'RIBONUCLEOSIDE-DIPHOSPHATE REDUCTASE 2 SUBUNIT ALPHA', 238910),
(299122, 'PTHR11573:SF6', NULL, NULL, NULL, NULL, 'RIBONUCLEOSIDE-DIPHOSPHATE REDUCTASE LARGE SUBUNIT', 238910),
(299123, 'PTHR11573:SF25', NULL, NULL, NULL, NULL, 'RIBONUCLEOSIDE-DIPHOSPHATE REDUCTASE', 238910),
(299124, 'PTHR11573:SF24', NULL, NULL, NULL, NULL, 'RIBONUCLEOSIDE-DIPHOSPHATE REDUCTASE', 238910),
(299125, 'PTHR11573:SF27', NULL, NULL, NULL, NULL, 'RIBONUCLEOSIDE-DIPHOSPHATE REDUCTASE', 238910),
(299126, 'PTHR11573', NULL, NULL, NULL, NULL, 'RIBONUCLEOSIDE-DIPHOSPHATE REDUCTASE LARGE CHAIN', 238910),
(299127, 'PTHR43819:SF1', NULL, NULL, NULL, NULL, 'ARCHAEAL-TYPE GLUTAMATE SYNTHASE [NADPH]', 238911); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(299128, 'PTHR43819', NULL, NULL, NULL, NULL, 'ARCHAEAL-TYPE GLUTAMATE SYNTHASE [NADPH]', 238911),
(299129, 'PTHR47594:SF4', NULL, NULL, NULL, NULL, 'THYLAKOID ASSEMBLY8', 238912),
(299130, 'PTHR47594:SF5', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 238912),
(299131, 'PTHR47594', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 238912),
(299132, 'PTHR47594:SF3', NULL, NULL, NULL, NULL, 'PROTEIN THYLAKOID ASSEMBLY 8, CHLOROPLASTIC', 238912),
(299133, 'PTHR47594:SF6', NULL, NULL, NULL, NULL, '', 238912),
(299134, 'PTHR47594:SF7', NULL, NULL, NULL, NULL, '', 238912),
(299135, 'PTHR30520', NULL, NULL, NULL, NULL, 'FORMATE TRANSPORTER-RELATED', 238913),
(299136, 'PTHR30520:SF10', NULL, NULL, NULL, NULL, 'FORMATE TRANSPORTER 1-RELATED', 238913),
(299137, 'PTHR30520:SF2', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YFDC', 238913),
(299138, 'PTHR30520:SF8', NULL, NULL, NULL, NULL, 'NITRITE TRANSPORTER NIRC', 238913),
(299139, 'PTHR30520:SF6', NULL, NULL, NULL, NULL, 'FORMATE/NITRATE FAMILY TRANSPORTER (EUROFUNG)', 238913),
(299140, 'PTHR35533:SF13', NULL, NULL, NULL, NULL, 'CONSERVED REPEAT DOMAIN PROTEIN', 238914),
(299141, 'PTHR35533', NULL, NULL, NULL, NULL, 'CONSERVED REPEAT DOMAIN PROTEIN', 238914),
(299142, 'PTHR35508', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT L-TYPE CALCIUM CHANNEL SUBUNIT', 238915),
(299143, 'PTHR35508:SF1', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT L-TYPE CALCIUM CHANNEL SUBUNIT', 238915),
(299144, 'PTHR35508:SF2', NULL, NULL, NULL, NULL, 'OS09G0395000 PROTEIN', 238915),
(299145, 'PTHR35508:SF3', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 238915),
(299146, 'PTHR35508:SF6', NULL, NULL, NULL, NULL, 'BNAC02G06670D PROTEIN', 238915),
(299147, 'PTHR10356:SF0', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN B', 238916),
(299148, 'PTHR10356:SF5', NULL, NULL, NULL, NULL, 'ALLOGRAFT INFLAMMATORY FACTOR 1-LIKE', 238916),
(299149, 'PTHR10356:SF4', NULL, NULL, NULL, NULL, 'ALLOGRAFT INFLAMMATORY FACTOR 1', 238916),
(299150, 'PTHR10356', NULL, NULL, NULL, NULL, 'ALLOGRAFT INFLAMMATORY FACTOR-1', 238916),
(299151, 'PTHR23343:SF117', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 238917),
(299152, 'PTHR23343:SF118', NULL, NULL, NULL, NULL, '', 238917),
(299153, 'PTHR23343:SF31', NULL, NULL, NULL, NULL, 'ZONA PELLUCIDA SPERM-BINDING PROTEIN 4', 238917),
(299154, 'PTHR23343:SF4', NULL, NULL, NULL, NULL, 'ZONA PELLUCIDA SPERM-BINDING PROTEIN 2', 238917),
(299155, 'PTHR23343:SF41', NULL, NULL, NULL, NULL, 'ZONA PELLUCIDA SPERM-BINDING PROTEIN 1', 238917),
(299156, 'PTHR23343', NULL, NULL, NULL, NULL, 'ZONA PELLUCIDA SPERM-BINDING PROTEIN', 238917),
(299157, 'PTHR16116:SF5', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 839', 238918),
(299158, 'PTHR16116', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 839', 238918),
(299159, 'PTHR21252:SF2', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 25 MEMBER 46', 238919),
(299160, 'PTHR21252', NULL, NULL, NULL, NULL, 'TB1 PROTEIN-RELATED', 238919),
(299161, 'PTHR47820:SF3', NULL, NULL, NULL, NULL, 'OS07G0499800 PROTEIN', 238920),
(299162, 'PTHR47820:SF7', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 238920),
(299163, 'PTHR47820:SF6', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 238920),
(299164, 'PTHR47820:SF5', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 238920),
(299165, 'PTHR47820:SF4', NULL, NULL, NULL, NULL, 'RING FINGER PFF0165C-LIKE PROTEIN', 238920),
(299166, 'PTHR47820:SF9', NULL, NULL, NULL, NULL, 'GOLGIN FAMILY A PROTEIN', 238920),
(299167, 'PTHR47820', NULL, NULL, NULL, NULL, 'BNAC05G24000D PROTEIN', 238920),
(299168, 'PTHR43532:SF4', NULL, NULL, NULL, NULL, 'GLUCOSE-1-PHOSPHATE THYMIDYLYLTRANSFERASE 2', 238921),
(299169, 'PTHR43532:SF1', NULL, NULL, NULL, NULL, 'GLUCOSE-1-PHOSPHATE THYMIDYLYLTRANSFERASE 1', 238921),
(299170, 'PTHR43532', NULL, NULL, NULL, NULL, 'GLUCOSE-1-PHOSPHATE THYMIDYLYLTRANSFERASE', 238921),
(299171, 'PTHR30012:SF7', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN HOFC HOMOLOG', 238922),
(299172, 'PTHR30012:SF4', NULL, NULL, NULL, NULL, 'MSHA BIOGENESIS PROTEIN MSHG', 238922);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(299173, 'PTHR30012:SF0', NULL, NULL, NULL, NULL, 'TYPE II SECRETION SYSTEM PROTEIN F-RELATED', 238922),
(299174, 'PTHR30012', NULL, NULL, NULL, NULL, 'GENERAL SECRETION PATHWAY PROTEIN', 238922),
(299175, 'PTHR10507', NULL, NULL, NULL, NULL, 'CDC45-RELATED PROTEIN', 238923),
(299176, 'PTHR10507:SF2', NULL, NULL, NULL, NULL, '', 238923),
(299177, 'PTHR10507:SF0', NULL, NULL, NULL, NULL, 'CELL DIVISION CONTROL PROTEIN 45 HOMOLOG', 238923),
(299178, 'PTHR10507:SF1', NULL, NULL, NULL, NULL, '', 238923),
(299179, 'PTHR18898', NULL, NULL, NULL, NULL, 'NUCLEOPROTEIN TPR-RELATED', 238924),
(299180, 'PTHR18898:SF2', NULL, NULL, NULL, NULL, 'NUCLEOPROTEIN TPR', 238924),
(299181, 'PTHR18898:SF4', NULL, NULL, NULL, NULL, 'NUCLEOPROTEIN TPR', 238924),
(299182, 'PTHR18898:SF3', NULL, NULL, NULL, NULL, 'NUCLEOPROTEIN TPR', 238924),
(299183, 'PTHR18898:SF7', NULL, NULL, NULL, NULL, 'NUCLEOPORIN NUP211', 238924),
(299184, 'PTHR34916', NULL, NULL, NULL, NULL, 'GI:13385330', 238925),
(299185, 'PTHR34916:SF1', NULL, NULL, NULL, NULL, 'GI:13385330', 238925),
(299186, 'PTHR11240:SF76', NULL, NULL, NULL, NULL, 'RIBONUCLEASE T2,-LIKE', 238926),
(299187, 'PTHR11240:SF55', NULL, NULL, NULL, NULL, 'RIBONUCLEASE T(2)', 238926),
(299188, 'PTHR11240:SF77', NULL, NULL, NULL, NULL, 'INTRACELLULAR RIBONUCLEASE LX', 238926),
(299189, 'PTHR11240:SF78', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 238926),
(299190, 'PTHR11240:SF57', NULL, NULL, NULL, NULL, 'OS09G0538000 PROTEIN', 238926),
(299191, 'PTHR11240:SF79', NULL, NULL, NULL, NULL, 'RIBONUCLEASE T(2)', 238926),
(299192, 'PTHR11240:SF72', NULL, NULL, NULL, NULL, 'RIBONUCLEASE 1', 238926),
(299193, 'PTHR11240:SF75', NULL, NULL, NULL, NULL, 'RIBONUCLEASE 3', 238926),
(299194, 'PTHR11240:SF53', NULL, NULL, NULL, NULL, 'RIBONUCLEASE 2-LIKE ISOFORM X1', 238926),
(299195, 'PTHR11240:SF70', NULL, NULL, NULL, NULL, '', 238926),
(299196, 'PTHR11240:SF18', NULL, NULL, NULL, NULL, 'OS07G0630400 PROTEIN', 238926),
(299197, 'PTHR11240:SF58', NULL, NULL, NULL, NULL, 'RIBONUCLEASE T(2)', 238926),
(299198, 'PTHR11240:SF59', NULL, NULL, NULL, NULL, 'RIBONUCLEASE T2 FAMILY PROTEIN', 238926),
(299199, 'PTHR11240:SF17', NULL, NULL, NULL, NULL, 'RIBONUCLEASE T(2)', 238926),
(299200, 'PTHR11240:SF65', NULL, NULL, NULL, NULL, 'RIBONUCLEASE S-5-LIKE', 238926),
(299201, 'PTHR11240:SF22', NULL, NULL, NULL, NULL, 'RIBONUCLEASE T2', 238926),
(299202, 'PTHR11240:SF66', NULL, NULL, NULL, NULL, 'OS01G0897300 PROTEIN', 238926),
(299203, 'PTHR11240:SF67', NULL, NULL, NULL, NULL, 'RIBONUCLEASE T(2)', 238926),
(299204, 'PTHR11240:SF46', NULL, NULL, NULL, NULL, 'INTRACELLULAR RIBONUCLEASE LX-LIKE', 238926),
(299205, 'PTHR11240:SF61', NULL, NULL, NULL, NULL, 'RIBONUCLEASE 1-LIKE', 238926),
(299206, 'PTHR11240:SF80', NULL, NULL, NULL, NULL, 'RIBONUCLEASE T2 FAMILY PROTEIN', 238926),
(299207, 'PTHR11240:SF81', NULL, NULL, NULL, NULL, 'RIBONUCLEASE S-2', 238926),
(299208, 'PTHR11240:SF60', NULL, NULL, NULL, NULL, 'RIBONUCLEASE T2', 238926),
(299209, 'PTHR11240:SF82', NULL, NULL, NULL, NULL, 'RIBONUCLEASE 3-RELATED', 238926),
(299210, 'PTHR11240:SF69', NULL, NULL, NULL, NULL, 'RIBONUCLEASE T(2)', 238926),
(299211, 'PTHR11240', NULL, NULL, NULL, NULL, 'RIBONUCLEASE T2', 238926),
(299212, 'PTHR11240:SF47', NULL, NULL, NULL, NULL, 'OS09G0537700 PROTEIN', 238926),
(299213, 'PTHR33589', NULL, NULL, NULL, NULL, 'OS11G0524900 PROTEIN', 238927),
(299214, 'PTHR33589:SF4', NULL, NULL, NULL, NULL, 'ZYMOGEN GRANULE MEMBRANE PROTEIN 16', 238927),
(299215, 'PTHR33589:SF3', NULL, NULL, NULL, NULL, 'JACALIN-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 238927),
(299216, 'PTHR33589:SF1', NULL, NULL, NULL, NULL, 'ZYMOGEN GRANULE PROTEIN 16 HOMOLOG B', 238927),
(299217, 'PTHR10417', NULL, NULL, NULL, NULL, 'GLUCOCORTICOID MODULATORY ELEMENT-BINDING PROTEIN', 238928),
(299218, 'PTHR10417:SF8', NULL, NULL, NULL, NULL, 'SAND DOMAIN-CONTAINING PROTEIN', 238928),
(299219, 'PTHR10417:SF9', NULL, NULL, NULL, NULL, 'SP140 NUCLEAR BODY PROTEIN', 238928),
(299220, 'PTHR10417:SF12', NULL, NULL, NULL, NULL, 'STERILE ALPHA MOTIF DOMAIN-CONTAINING 11', 238928);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(299221, 'PTHR10417:SF2', NULL, NULL, NULL, NULL, 'GLUCOCORTICOID MODULATORY ELEMENT-BINDING PROTEIN 2', 238928),
(299222, 'PTHR10417:SF3', NULL, NULL, NULL, NULL, 'GLUCOCORTICOID MODULATORY ELEMENT-BINDING PROTEIN 1', 238928),
(299223, 'PTHR10417:SF14', NULL, NULL, NULL, NULL, 'SP110 NUCLEAR ANTIGEN, TANDEM DUPLICATE 2', 238928),
(299224, 'PTHR10417:SF13', NULL, NULL, NULL, NULL, 'SAND DOMAIN-CONTAINING PROTEIN', 238928),
(299225, 'PTHR10417:SF6', NULL, NULL, NULL, NULL, 'SAND DOMAIN-CONTAINING PROTEIN', 238928),
(299226, 'PTHR10417:SF4', NULL, NULL, NULL, NULL, 'SAND DOMAIN-CONTAINING PROTEIN-RELATED', 238928),
(299227, 'PTHR12675:SF3', NULL, NULL, NULL, NULL, 'MUSCLEBLIND-LIKE PROTEIN 3', 238929),
(299228, 'PTHR12675:SF6', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 10', 238929),
(299229, 'PTHR12675:SF7', NULL, NULL, NULL, NULL, 'MUSCLEBLIND-LIKE PROTEIN 1', 238929),
(299230, 'PTHR12675:SF4', NULL, NULL, NULL, NULL, 'MUSCLEBLIND-LIKE PROTEIN 2', 238929),
(299231, 'PTHR12675:SF11', NULL, NULL, NULL, NULL, '', 238929),
(299232, 'PTHR12675', NULL, NULL, NULL, NULL, 'MUSCLEBLIND-LIKE PROTEIN', 238929),
(299233, 'PTHR12675:SF12', NULL, NULL, NULL, NULL, 'PROTEIN MUSCLEBLIND', 238929),
(299234, 'PTHR47050', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 24', 238930),
(299235, 'PTHR47050:SF2', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 24', 238930),
(299236, 'PTHR47050:SF1', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 24-LIKE', 238930),
(299237, 'PTHR43055', NULL, NULL, NULL, NULL, 'FORMATE-DEPENDENT PHOSPHORIBOSYLGLYCINAMIDE FORMYLTRANSFERASE', 238931),
(299238, 'PTHR43055:SF1', NULL, NULL, NULL, NULL, 'FORMATE-DEPENDENT PHOSPHORIBOSYLGLYCINAMIDE FORMYLTRANSFERASE', 238931),
(299239, 'PTHR11551:SF27', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR-BINDING PROTEIN 6A-RELATED', 238932),
(299240, 'PTHR11551:SF13', NULL, NULL, NULL, NULL, 'IGFBP N-TERMINAL DOMAIN-CONTAINING PROTEIN', 238932),
(299241, 'PTHR11551:SF14', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR-BINDING PROTEIN 6', 238932),
(299242, 'PTHR11551:SF3', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR-BINDING PROTEIN 3', 238932),
(299243, 'PTHR11551:SF4', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR-BINDING PROTEIN 5', 238932),
(299244, 'PTHR11551:SF28', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR-BINDING PROTEIN 1', 238932),
(299245, 'PTHR11551:SF5', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR-BINDING PROTEIN 2', 238932),
(299246, 'PTHR11551:SF6', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR-BINDING PROTEIN 1', 238932),
(299247, 'PTHR11551:SF7', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR-BINDING PROTEIN 4', 238932),
(299248, 'PTHR11551', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR BINDING PROTEIN', 238932),
(299249, 'PTHR23123:SF15', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE 7A', 238933),
(299250, 'PTHR23123:SF37', NULL, NULL, NULL, NULL, 'JMJC DOMAIN-CONTAINING PROTEIN-RELATED', 238933),
(299251, 'PTHR23123:SF14', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE PHF2', 238933),
(299252, 'PTHR23123:SF35', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 19', 238933),
(299253, 'PTHR23123:SF3', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE 2A', 238933),
(299254, 'PTHR23123:SF11', NULL, NULL, NULL, NULL, 'HISTONE LYSINE DEMETHYLASE PHF8', 238933),
(299255, 'PTHR23123:SF21', NULL, NULL, NULL, NULL, 'JMJC DOMAIN-CONTAINING HISTONE DEMETHYLATION PROTEIN 1', 238933),
(299256, 'PTHR23123:SF10', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE 2B', 238933),
(299257, 'PTHR23123:SF31', NULL, NULL, NULL, NULL, 'LYSINE (K)-SPECIFIC DEMETHYLASE 2AA', 238933),
(299258, 'PTHR23123', NULL, NULL, NULL, NULL, 'PHD/F-BOX CONTAINING PROTEIN', 238933),
(299259, 'PTHR33531:SF8', NULL, NULL, NULL, NULL, 'RUBRERYTHRIN DOMAIN-CONTAINING PROTEIN', 238934),
(299260, 'PTHR33531:SF9', NULL, NULL, NULL, NULL, 'BLR7895 PROTEIN', 238934),
(299261, 'PTHR33531:SF7', NULL, NULL, NULL, NULL, 'RUBRERYTHRIN DOMAIN-CONTAINING PROTEIN', 238934);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(299262, 'PTHR33531', NULL, NULL, NULL, NULL, 'RUBRERYTHRIN SUBFAMILY', 238934),
(299263, 'PTHR36796:SF1', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 238935),
(299264, 'PTHR36796', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 238935),
(299265, 'PTHR39227:SF1', NULL, NULL, NULL, NULL, 'ADIPOGENESIS REGULATORY FACTOR', 238936),
(299266, 'PTHR39227', NULL, NULL, NULL, NULL, 'ADIPOGENESIS REGULATORY FACTOR', 238936),
(299267, 'PTHR33642:SF5', NULL, NULL, NULL, NULL, 'MATURASE', 238937),
(299268, 'PTHR33642:SF4', NULL, NULL, NULL, NULL, 'COX1/OXI3 INTRON 1 PROTEIN-RELATED', 238937),
(299269, 'PTHR33642:SF3', NULL, NULL, NULL, NULL, 'NUCLEAR INTRON MATURASE 4, MITOCHONDRIAL', 238937),
(299270, 'PTHR33642', NULL, NULL, NULL, NULL, 'COX1/OXI3 INTRON 1 PROTEIN-RELATED', 238937),
(299271, 'PTHR35108:SF1', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN 3-1, CHLOROPLASTIC', 238938),
(299272, 'PTHR35108', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN 3, CHLOROPLASTIC', 238938),
(299273, 'PTHR35108:SF12', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN 3-2, CHLOROPLASTIC', 238938),
(299274, 'PTHR35108:SF9', NULL, NULL, NULL, NULL, 'BNACNNG27150D PROTEIN', 238938),
(299275, 'PTHR35108:SF7', NULL, NULL, NULL, NULL, 'BNAC06G30280D PROTEIN', 238938),
(299276, 'PTHR35108:SF6', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN 3, CHLOROPLAST, PUTATIVE-RELATED', 238938),
(299277, 'PTHR35108:SF10', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN 3, CHLOROPLASTIC-LIKE', 238938),
(299278, 'PTHR34658', NULL, NULL, NULL, NULL, 'OS01G0151800 PROTEIN', 238939),
(299279, 'PTHR34658:SF7', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN G1', 238939),
(299280, 'PTHR34658:SF5', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 238939),
(299281, 'PTHR34658:SF6', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN G1', 238939),
(299282, 'PTHR34658:SF4', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 238939),
(299283, 'PTHR34658:SF2', NULL, NULL, NULL, NULL, 'OS01G0151800 PROTEIN', 238939),
(299284, 'PTHR31606:SF9', NULL, NULL, NULL, NULL, 'UPF0664 STRESS-INDUCED PROTEIN C29B12.11C-LIKE', 238940),
(299285, 'PTHR31606:SF11', NULL, NULL, NULL, NULL, 'WW DOMAIN-BINDING PROTEIN 2-LIKE', 238940),
(299286, 'PTHR31606:SF12', NULL, NULL, NULL, NULL, 'PH DOMAIN-LIKE PROTEIN-RELATED', 238940),
(299287, 'PTHR31606:SF13', NULL, NULL, NULL, NULL, 'GRAM DOMAIN-CONTAINING PROTEIN', 238940),
(299288, 'PTHR31606', NULL, NULL, NULL, NULL, 'WW DOMAIN BINDING PROTEIN 2, ISOFORM E', 238940),
(299289, 'PTHR31606:SF4', NULL, NULL, NULL, NULL, 'WW DOMAIN-BINDING PROTEIN 2', 238940),
(299290, 'PTHR31606:SF1', NULL, NULL, NULL, NULL, 'WW DOMAIN BINDING PROTEIN 2, ISOFORM E', 238940),
(299291, 'PTHR31606:SF2', NULL, NULL, NULL, NULL, 'POSTACROSOMAL SHEATH WW DOMAIN-BINDING PROTEIN', 238940),
(299292, 'PTHR43344:SF21', NULL, NULL, NULL, NULL, 'POLYOL PHOSPHATE PHOSPHATASE PYP1', 238941),
(299293, 'PTHR43344:SF2', NULL, NULL, NULL, NULL, 'PHOSPHOSERINE PHOSPHATASE', 238941),
(299294, 'PTHR43344:SF20', NULL, NULL, NULL, NULL, '', 238941),
(299295, 'PTHR43344:SF19', NULL, NULL, NULL, NULL, 'O-PHOSPHOSERINE PHOSPHOHYDROLASE', 238941),
(299296, 'PTHR43344:SF16', NULL, NULL, NULL, NULL, 'X8 DOMAIN-CONTAINING PROTEIN', 238941),
(299297, 'PTHR43344:SF17', NULL, NULL, NULL, NULL, 'O-PHOSPHOSERINE PHOSPHOHYDROLASE', 238941),
(299298, 'PTHR43344:SF14', NULL, NULL, NULL, NULL, 'PHOSPHOTRANSFERASE', 238941),
(299299, 'PTHR43344:SF15', NULL, NULL, NULL, NULL, 'PHOSPHOSERINE PHOSPHATASE SERB1', 238941),
(299300, 'PTHR43344', NULL, NULL, NULL, NULL, 'PHOSPHOSERINE PHOSPHATASE', 238941),
(299301, 'PTHR43344:SF13', NULL, NULL, NULL, NULL, 'PHOSPHATASE RV3661-RELATED', 238941),
(299302, 'PTHR40042', NULL, NULL, NULL, NULL, 'HYPOTHETICAL MEMBRANE SPANNING PROTEIN', 238942),
(299303, 'PTHR40042:SF1', NULL, NULL, NULL, NULL, 'HYPOTHETICAL MEMBRANE SPANNING PROTEIN', 238942),
(299304, 'PTHR47445:SF1', NULL, NULL, NULL, NULL, 'OS08G0441400 PROTEIN', 238943),
(299305, 'PTHR47445:SF2', NULL, NULL, NULL, NULL, '', 238943),
(299306, 'PTHR47445', NULL, NULL, NULL, NULL, 'OS08G0441400 PROTEIN', 238943);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(299307, 'PTHR46462:SF1', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SETD5', 238944),
(299308, 'PTHR46462:SF2', NULL, NULL, NULL, NULL, 'INACTIVE HISTONE-LYSINE N-METHYLTRANSFERASE 2E', 238944),
(299309, 'PTHR46462:SF3', NULL, NULL, NULL, NULL, 'UPSET, ISOFORM A', 238944),
(299310, 'PTHR46462', NULL, NULL, NULL, NULL, 'UPSET, ISOFORM A', 238944),
(299311, 'PTHR12035:SF109', NULL, NULL, NULL, NULL, 'SIALIC ACID-BINDING IG-LIKE LECTIN 14', 238945),
(299312, 'PTHR12035:SF127', NULL, NULL, NULL, NULL, 'SIALIC ACID-BINDING IG-LIKE LECTIN 11', 238945),
(299313, 'PTHR12035:SF116', NULL, NULL, NULL, NULL, 'ZMP:0000000650', 238945),
(299314, 'PTHR12035:SF128', NULL, NULL, NULL, NULL, 'SI:DKEY-24P1.7', 238945),
(299315, 'PTHR12035:SF106', NULL, NULL, NULL, NULL, 'SIALIC ACID-BINDING IG-LIKE LECTIN 8', 238945),
(299316, 'PTHR12035:SF107', NULL, NULL, NULL, NULL, 'MYELIN-ASSOCIATED GLYCOPROTEIN', 238945),
(299317, 'PTHR12035:SF129', NULL, NULL, NULL, NULL, 'SIALIC ACID-BINDING IG-LIKE LECTIN 6', 238945),
(299318, 'PTHR12035:SF123', NULL, NULL, NULL, NULL, 'SIALIC ACID-BINDING IG-LIKE LECTIN 10', 238945),
(299319, 'PTHR12035:SF124', NULL, NULL, NULL, NULL, 'MYELOID CELL SURFACE ANTIGEN CD33', 238945),
(299320, 'PTHR12035:SF113', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4931406B18 GENE', 238945),
(299321, 'PTHR12035:SF125', NULL, NULL, NULL, NULL, 'SIALIC ACID-BINDING IG-LIKE LECTIN 9', 238945),
(299322, 'PTHR12035:SF103', NULL, NULL, NULL, NULL, 'SIALIC ACID-BINDING IG-LIKE LECTIN 5', 238945),
(299323, 'PTHR12035:SF96', NULL, NULL, NULL, NULL, 'SIALIC ACID-BINDING IG-LIKE LECTIN 16', 238945),
(299324, 'PTHR12035:SF115', NULL, NULL, NULL, NULL, 'SIALIC ACID-BINDING IG-LIKE LECTIN 10', 238945),
(299325, 'PTHR12035:SF130', NULL, NULL, NULL, NULL, 'SI:DKEY-238D18.7-RELATED', 238945),
(299326, 'PTHR12035:SF53', NULL, NULL, NULL, NULL, 'SIALIC ACID-BINDING IG-LIKE LECTIN 12', 238945),
(299327, 'PTHR12035:SF42', NULL, NULL, NULL, NULL, 'SIALIC ACID BINDING IG LIKE LECTIN 11', 238945),
(299328, 'PTHR12035:SF131', NULL, NULL, NULL, NULL, 'SIALIC ACID-BINDING IG-LIKE LECTIN 5', 238945),
(299329, 'PTHR12035:SF110', NULL, NULL, NULL, NULL, 'SIALIC ACID-BINDING IG-LIKE LECTIN 13', 238945),
(299330, 'PTHR12035:SF99', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 238945),
(299331, 'PTHR12035:SF111', NULL, NULL, NULL, NULL, 'SIALIC ACID-BINDING IG-LIKE LECTIN 7', 238945),
(299332, 'PTHR12035:SF45', NULL, NULL, NULL, NULL, 'MYELOID CELL SURFACE ANTIGEN CD33', 238945),
(299333, 'PTHR12035:SF122', NULL, NULL, NULL, NULL, 'SI:CH73-380L3.2', 238945),
(299334, 'PTHR12035', NULL, NULL, NULL, NULL, 'SIALIC ACID BINDING IMMUNOGLOBULIN-LIKE LECTIN', 238945),
(299335, 'PTHR11839:SF26', NULL, NULL, NULL, NULL, 'ADP-RIBOSE DIPHOSPHATASE', 238946),
(299336, 'PTHR11839:SF15', NULL, NULL, NULL, NULL, 'URIDINE DIPHOSPHATE GLUCOSE PYROPHOSPHATASE NUDT14', 238946),
(299337, 'PTHR11839:SF16', NULL, NULL, NULL, NULL, 'GDP-MANNOSE PYROPHOSPHATASE', 238946),
(299338, 'PTHR11839:SF27', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 238946),
(299339, 'PTHR11839:SF29', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 238946),
(299340, 'PTHR11839:SF18', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 238946),
(299341, 'PTHR11839', NULL, NULL, NULL, NULL, 'UDP/ADP-SUGAR PYROPHOSPHATASE', 238946),
(299342, 'PTHR11839:SF30', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 25', 238946),
(299343, 'PTHR11839:SF5', NULL, NULL, NULL, NULL, 'ADP-RIBOSE PYROPHOSPHATASE', 238946),
(299344, 'PTHR11839:SF21', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 27, CHLOROPLASTIC', 238946),
(299345, 'PTHR11839:SF22', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 26, CHLOROPLASTIC', 238946),
(299346, 'PTHR11839:SF12', NULL, NULL, NULL, NULL, 'ADP COMPOUNDS HYDROLASE NUDE', 238946),
(299347, 'PTHR11839:SF23', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 238946),
(299348, 'PTHR11839:SF24', NULL, NULL, NULL, NULL, 'ADP-SUGAR PYROPHOSPHATASE', 238946),
(299349, 'PTHR11839:SF1', NULL, NULL, NULL, NULL, 'ADP-SUGAR PYROPHOSPHATASE', 238946);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(299350, 'PTHR37342', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC689959', 238947),
(299351, 'PTHR37342:SF1', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC689959', 238947),
(299352, 'PTHR45939:SF3', NULL, NULL, NULL, NULL, '', 238948),
(299353, 'PTHR45939:SF4', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 25 MEMBER 17', 238948),
(299354, 'PTHR45939:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL THIAMINE PYROPHOSPHATE CARRIER 1', 238948),
(299355, 'PTHR45939:SF2', NULL, NULL, NULL, NULL, 'CARRIER PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G13870)-RELATED', 238948),
(299356, 'PTHR45939', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN PMP34-RELATED', 238948),
(299357, 'PTHR45939:SF5', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN PMP34', 238948),
(299358, 'PTHR40758', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', 238949),
(299359, 'PTHR40758:SF1', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', 238949),
(299360, 'PTHR35784:SF1', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 5', 238950),
(299361, 'PTHR35784', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 5', 238950),
(299362, 'PTHR45743:SF17', NULL, NULL, NULL, NULL, '', 238951),
(299363, 'PTHR45743:SF39', NULL, NULL, NULL, NULL, 'K+ TRANSPORTER 1-RELATED', 238951),
(299364, 'PTHR45743:SF37', NULL, NULL, NULL, NULL, 'INWARDLY RECTIFYING POTASSIUM CHANNEL SUBUNIT', 238951),
(299365, 'PTHR45743:SF15', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL GORK', 238951),
(299366, 'PTHR45743:SF16', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL AKT5-RELATED', 238951),
(299367, 'PTHR45743:SF38', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL KAT3', 238951),
(299368, 'PTHR45743:SF13', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL AKT6', 238951),
(299369, 'PTHR45743:SF35', NULL, NULL, NULL, NULL, 'BNAA09G17910D PROTEIN', 238951),
(299370, 'PTHR45743:SF14', NULL, NULL, NULL, NULL, '', 238951),
(299371, 'PTHR45743:SF11', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 238951),
(299372, 'PTHR45743:SF34', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL, VOLTAGE-DEPENDENT, EAG/ELK/ERG, ANKYRIN REPEAT-CONTAINING DOMAIN PROTEIN-RELATED', 238951),
(299373, 'PTHR45743:SF53', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL KAT3-LIKE ISOFORM X1', 238951),
(299374, 'PTHR45743:SF10', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL AKT3', 238951),
(299375, 'PTHR45743:SF32', NULL, NULL, NULL, NULL, 'BNAC03G62660D PROTEIN', 238951),
(299376, 'PTHR45743:SF51', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL KAT2', 238951),
(299377, 'PTHR45743:SF52', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL KAT1', 238951),
(299378, 'PTHR45743:SF50', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL, VOLTAGE-DEPENDENT, EAG/ELK/ERG-RELATED', 238951),
(299379, 'PTHR45743:SF6', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL KAT1', 238951),
(299380, 'PTHR45743', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL AKT1', 238951),
(299381, 'PTHR45743:SF29', NULL, NULL, NULL, NULL, 'INWARDLY RECTIFYING POTASSIUM CHANNEL SUBUNIT', 238951),
(299382, 'PTHR45743:SF27', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL KAT3', 238951),
(299383, 'PTHR45743:SF24', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL AKT2/3-LIKE', 238951),
(299384, 'PTHR45743:SF46', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL KAT3-LIKE', 238951),
(299385, 'PTHR45743:SF25', NULL, NULL, NULL, NULL, 'CHANNEL AKT6, PUTATIVE-RELATED', 238951),
(299386, 'PTHR45743:SF22', NULL, NULL, NULL, NULL, 'INWARDLY RECTIFYING POTASSIUM CHANNEL SUBUNIT', 238951),
(299387, 'PTHR45743:SF4', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL KOR2', 238951),
(299388, 'PTHR45743:SF44', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL SKOR-LIKE', 238951),
(299389, 'PTHR45743:SF20', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL KAT3', 238951),
(299390, 'PTHR45743:SF2', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL AKT1', 238951),
(299391, 'PTHR45743:SF42', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL AKT1-LIKE', 238951),
(299392, 'PTHR45743:SF3', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL SKOR', 238951),
(299393, 'PTHR45743:SF21', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL AKT2/3', 238951);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(299394, 'PTHR45743:SF43', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL AKT1-LIKE', 238951),
(299395, 'PTHR21047', NULL, NULL, NULL, NULL, 'DTDP-6-DEOXY-D-GLUCOSE-3,5 EPIMERASE', 238952),
(299396, 'PTHR21047:SF2', NULL, NULL, NULL, NULL, 'L-RHAMNOSE BIOSYNTHETIC PATHWAY', 238952),
(299397, 'PTHR38631:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG12791', 238953),
(299398, 'PTHR38631:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG12798', 238953),
(299399, 'PTHR38631', NULL, NULL, NULL, NULL, '', 238953),
(299400, 'PTHR47457:SF1', NULL, NULL, NULL, NULL, 'OS05G0345500 PROTEIN', 238954),
(299401, 'PTHR47457', NULL, NULL, NULL, NULL, 'OS05G0345500 PROTEIN', 238954),
(299402, 'PTHR10466:SF12', NULL, NULL, NULL, NULL, 'PHOSPHOMANNOMUTASE', 238955),
(299403, 'PTHR10466:SF10', NULL, NULL, NULL, NULL, 'PHOSPHOMANNOMUTASE', 238955),
(299404, 'PTHR10466:SF9', NULL, NULL, NULL, NULL, 'PHOSPHOMANNOMUTASE', 238955),
(299405, 'PTHR10466:SF2', NULL, NULL, NULL, NULL, 'PHOSPHOMANNOMUTASE 2', 238955),
(299406, 'PTHR10466:SF14', NULL, NULL, NULL, NULL, 'PHOSPHOMANNOMUTASE', 238955),
(299407, 'PTHR10466', NULL, NULL, NULL, NULL, 'PHOSPHOMANNOMUTASE', 238955),
(299408, 'PTHR10466:SF13', NULL, NULL, NULL, NULL, 'PHOSPHOMANNOMUTASE', 238955),
(299409, 'PTHR10466:SF0', NULL, NULL, NULL, NULL, 'PHOSPHOMANNOMUTASE', 238955),
(299410, 'PTHR10466:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOMANNOMUTASE 1', 238955),
(299411, 'PTHR11626', NULL, NULL, NULL, NULL, 'FARNESYL-DIPHOSPHATE FARNESYLTRANSFERASE', 238956),
(299412, 'PTHR11626:SF6', NULL, NULL, NULL, NULL, 'SQUALENE SYNTHASE', 238956),
(299413, 'PTHR11626:SF5', NULL, NULL, NULL, NULL, 'SQUALENE SYNTHASE', 238956),
(299414, 'PTHR11626:SF4', NULL, NULL, NULL, NULL, 'SQUALENE SYNTHASE-LIKE', 238956),
(299415, 'PTHR11626:SF3', NULL, NULL, NULL, NULL, 'INACTIVE SQUALENE SYNTHASE 2', 238956),
(299416, 'PTHR11626:SF2', NULL, NULL, NULL, NULL, 'SQUALENE SYNTHASE', 238956),
(299417, 'PTHR34689', NULL, NULL, NULL, NULL, 'NUCLEIC ACID-BINDING PROTEIN', 238957),
(299418, 'PTHR34689:SF1', NULL, NULL, NULL, NULL, 'NUCLEIC ACID-BINDING PROTEIN', 238957),
(299419, 'PTHR37875:SF1', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC685964', 238958),
(299420, 'PTHR37875', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC685964', 238958),
(299421, 'PTHR45856:SF12', NULL, NULL, NULL, NULL, 'LIPASE-LIKE', 238959),
(299422, 'PTHR45856:SF14', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 238959),
(299423, 'PTHR45856', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 238959),
(299424, 'PTHR45856:SF20', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 238959),
(299425, 'PTHR45856:SF21', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 238959),
(299426, 'PTHR45856:SF11', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 238959),
(299427, 'PTHR45856:SF8', NULL, NULL, NULL, NULL, 'LIPASE FAMILY PROTEIN, EXPRESSED', 238959),
(299428, 'PTHR45856:SF18', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 238959),
(299429, 'PTHR45856:SF6', NULL, NULL, NULL, NULL, 'OS07G0668700 PROTEIN', 238959),
(299430, 'PTHR45856:SF19', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 238959),
(299431, 'PTHR45134:SF4', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 238960),
(299432, 'PTHR45134:SF5', NULL, NULL, NULL, NULL, 'OS08G0543275 PROTEIN', 238960),
(299433, 'PTHR45134:SF19', NULL, NULL, NULL, NULL, '', 238960),
(299434, 'PTHR45134:SF17', NULL, NULL, NULL, NULL, 'YALI0C14234P', 238960),
(299435, 'PTHR45134:SF18', NULL, NULL, NULL, NULL, '', 238960),
(299436, 'PTHR45134:SF16', NULL, NULL, NULL, NULL, '', 238960),
(299437, 'PTHR45134', NULL, NULL, NULL, NULL, '', 238960),
(299438, 'PTHR45134:SF20', NULL, NULL, NULL, NULL, '', 238960),
(299439, 'PTHR45134:SF21', NULL, NULL, NULL, NULL, '', 238960),
(299440, 'PTHR37558:SF2', NULL, NULL, NULL, NULL, 'PROTEIN B, PUTATIVE-RELATED', 238961),
(299441, 'PTHR37558:SF1', NULL, NULL, NULL, NULL, 'HTH CENPB-TYPE DOMAIN-CONTAINING PROTEIN', 238961),
(299442, 'PTHR37558', NULL, NULL, NULL, NULL, 'HTH CENPB-TYPE DOMAIN-CONTAINING PROTEIN', 238961);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(299443, 'PTHR37189:SF4', NULL, NULL, NULL, NULL, 'BNAC05G23500D PROTEIN', 238962),
(299444, 'PTHR37189:SF2', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 238962),
(299445, 'PTHR37189', NULL, NULL, NULL, NULL, 'CONCANAVALIN A-LIKE LECTIN/GLUCANASE DOMAIN-CONTAINING PROTEIN-RELATED', 238962),
(299446, 'PTHR37189:SF6', NULL, NULL, NULL, NULL, '', 238962),
(299447, 'PTHR37189:SF5', NULL, NULL, NULL, NULL, '', 238962),
(299448, 'PTHR37490:SF3', NULL, NULL, NULL, NULL, '', 238963),
(299449, 'PTHR37490:SF2', NULL, NULL, NULL, NULL, '', 238963),
(299450, 'PTHR37490', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 238963),
(299451, 'PTHR37490:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 238963),
(299452, 'PTHR15422:SF24', NULL, NULL, NULL, NULL, 'LD43293P', 238964),
(299453, 'PTHR15422:SF9', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE REDUCTASE CYB561D1-RELATED', 238964),
(299454, 'PTHR15422:SF37', NULL, NULL, NULL, NULL, '', 238964),
(299455, 'PTHR15422:SF25', NULL, NULL, NULL, NULL, '', 238964),
(299456, 'PTHR15422:SF36', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 DOMAIN-CONTAINING PROTEIN', 238964),
(299457, 'PTHR15422:SF42', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 DOMAIN-CONTAINING PROTEIN', 238964),
(299458, 'PTHR15422:SF41', NULL, NULL, NULL, NULL, 'CYTOCHROME B561/FERRIC REDUCTASE TRANSMEMBRANE-RELATED', 238964),
(299459, 'PTHR15422:SF43', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 DOMAIN-CONTAINING PROTEIN-RELATED', 238964),
(299460, 'PTHR15422:SF21', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE REDUCTASE CYB561D2', 238964),
(299461, 'PTHR15422:SF39', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 DOMAIN-CONTAINING PROTEIN', 238964),
(299462, 'PTHR15422', NULL, NULL, NULL, NULL, 'OS05G0565100 PROTEIN', 238964),
(299463, 'PTHR15422:SF38', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 DOMAIN-CONTAINING PROTEIN', 238964),
(299464, 'PTHR43177:SF9', NULL, NULL, NULL, NULL, 'PROTEIN NRFC', 238965),
(299465, 'PTHR43177:SF5', NULL, NULL, NULL, NULL, 'ANAEROBIC DIMETHYL SULFOXIDE REDUCTASE CHAIN B-RELATED', 238965),
(299466, 'PTHR43177:SF7', NULL, NULL, NULL, NULL, 'ANAEROBIC DIMETHYL SULFOXIDE REDUCTASE, SUBUNIT B-RELATED', 238965),
(299467, 'PTHR43177', NULL, NULL, NULL, NULL, 'PROTEIN NRFC', 238965),
(299468, 'PTHR43177:SF3', NULL, NULL, NULL, NULL, 'PROTEIN NRFC HOMOLOG', 238965),
(299469, 'PTHR11363:SF10', NULL, NULL, NULL, NULL, '', 238966),
(299470, 'PTHR11363:SF12', NULL, NULL, NULL, NULL, 'BNAA05G32030D PROTEIN', 238966),
(299471, 'PTHR11363:SF14', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L3-2', 238966),
(299472, 'PTHR11363:SF15', NULL, NULL, NULL, NULL, 'PREFOLDIN CHAPERONE SUBUNIT FAMILY PROTEIN', 238966),
(299473, 'PTHR11363:SF8', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L3', 238966),
(299474, 'PTHR11363:SF7', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L3-LIKE', 238966),
(299475, 'PTHR11363:SF17', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L3B', 238966),
(299476, 'PTHR11363:SF18', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L3-RELATED', 238966),
(299477, 'PTHR11363:SF4', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L3', 238966),
(299478, 'PTHR11363', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L3-RELATED', 238966),
(299479, 'PTHR11363:SF5', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L3', 238966),
(299480, 'PTHR40078', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN-RELATED', 238967),
(299481, 'PTHR40078:SF1', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN-RELATED', 238967),
(299482, 'PTHR46757', NULL, NULL, NULL, NULL, 'SORTING NEXIN-RELATED', 238968),
(299483, 'PTHR46757:SF9', NULL, NULL, NULL, NULL, 'SORTING NEXIN 2B-LIKE ISOFORM X1', 238968),
(299484, 'PTHR46757:SF8', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 17, VPS17-RELATED', 238968),
(299485, 'PTHR46757:SF5', NULL, NULL, NULL, NULL, 'OS01G0827200 PROTEIN', 238968),
(299486, 'PTHR46757:SF7', NULL, NULL, NULL, NULL, 'SORTING NEXIN-5/6/32-RELATED', 238968),
(299487, 'PTHR46757:SF6', NULL, NULL, NULL, NULL, 'SORTING NEXIN 2B', 238968),
(299488, 'PTHR46757:SF1', NULL, NULL, NULL, NULL, 'OS05G0474500 PROTEIN', 238968);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(299489, 'PTHR46757:SF11', NULL, NULL, NULL, NULL, 'SORTING NEXIN 2A', 238968),
(299490, 'PTHR46757:SF2', NULL, NULL, NULL, NULL, 'OS05G0346100 PROTEIN', 238968),
(299491, 'PTHR46757:SF10', NULL, NULL, NULL, NULL, 'PX DOMAIN-CONTAINING PROTEIN', 238968),
(299492, 'PTHR28017:SF1', NULL, NULL, NULL, NULL, 'DASH COMPLEX SUBUNIT DAD3', 238969),
(299493, 'PTHR28017', NULL, NULL, NULL, NULL, 'DASH COMPLEX SUBUNIT DAD3', 238969),
(299494, 'PTHR37705', NULL, NULL, NULL, NULL, 'BNAA08G11710D PROTEIN', 238970),
(299495, 'PTHR37705:SF2', NULL, NULL, NULL, NULL, 'BNAANNG40180D PROTEIN', 238970),
(299496, 'PTHR37705:SF1', NULL, NULL, NULL, NULL, 'BNAA08G11710D PROTEIN', 238970),
(299497, 'PTHR37705:SF8', NULL, NULL, NULL, NULL, 'BNACNNG63660D PROTEIN', 238970),
(299498, 'PTHR37705:SF7', NULL, NULL, NULL, NULL, '', 238970),
(299499, 'PTHR37705:SF9', NULL, NULL, NULL, NULL, 'BNAA03G50760D PROTEIN', 238970),
(299500, 'PTHR37705:SF4', NULL, NULL, NULL, NULL, 'BNAA08G02630D PROTEIN', 238970),
(299501, 'PTHR37705:SF3', NULL, NULL, NULL, NULL, 'BNAA07G04000D PROTEIN', 238970),
(299502, 'PTHR37705:SF6', NULL, NULL, NULL, NULL, '', 238970),
(299503, 'PTHR37705:SF5', NULL, NULL, NULL, NULL, 'BNAC05G26170D PROTEIN', 238970),
(299504, 'PTHR21644', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 238971),
(299505, 'PTHR21644:SF0', NULL, NULL, NULL, NULL, 'AT02555P-RELATED', 238971),
(299506, 'PTHR46477:SF15', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN PROTEIN', 238972),
(299507, 'PTHR46477:SF14', NULL, NULL, NULL, NULL, 'C1 DOMAIN FAMILY PROTEIN, PUTATIVE-RELATED', 238972),
(299508, 'PTHR46477:SF17', NULL, NULL, NULL, NULL, 'C1_2 DOMAIN-CONTAINING PROTEIN', 238972),
(299509, 'PTHR46477:SF16', NULL, NULL, NULL, NULL, 'OS08G0404500 PROTEIN', 238972),
(299510, 'PTHR46477:SF9', NULL, NULL, NULL, NULL, 'PHORBOL-ESTER/DAG-TYPE DOMAIN-CONTAINING PROTEIN', 238972),
(299511, 'PTHR46477', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN FAMILY PROTEIN', 238972),
(299512, 'PTHR46477:SF21', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN FAMILY PROTEIN', 238972),
(299513, 'PTHR46477:SF10', NULL, NULL, NULL, NULL, 'C1_2 DOMAIN-CONTAINING PROTEIN', 238972),
(299514, 'PTHR46477:SF24', NULL, NULL, NULL, NULL, 'OS08G0404900 PROTEIN', 238972),
(299515, 'PTHR46477:SF12', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN PROTEIN', 238972),
(299516, 'PTHR46477:SF5', NULL, NULL, NULL, NULL, 'PHORBOL-ESTER/DAG-TYPE DOMAIN-CONTAINING PROTEIN', 238972),
(299517, 'PTHR46477:SF7', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN PROTEIN', 238972),
(299518, 'PTHR46477:SF8', NULL, NULL, NULL, NULL, 'OS08G0257100 PROTEIN', 238972),
(299519, 'PTHR46477:SF18', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE-RELATED', 238972),
(299520, 'PTHR46477:SF3', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN FAMILY PROTEIN', 238972),
(299521, 'PTHR28671', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 169', 238973),
(299522, 'PTHR28671:SF6', NULL, NULL, NULL, NULL, '', 238973),
(299523, 'PTHR28671:SF8', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN CONTAINING 169', 238973),
(299524, 'PTHR28671:SF3', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 169', 238973),
(299525, 'PTHR39411', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 113', 238974),
(299526, 'PTHR39411:SF1', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 113', 238974),
(299527, 'PTHR42678:SF2', NULL, NULL, NULL, NULL, 'AMIDASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_6G14410)', 238975),
(299528, 'PTHR42678:SF18', NULL, NULL, NULL, NULL, 'AMIDASE DOMAIN-CONTAINING PROTEIN', 238975),
(299529, 'PTHR42678:SF5', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA(GLN) AMIDOTRANSFERASE SUBUNIT A', 238975),
(299530, 'PTHR42678:SF28', NULL, NULL, NULL, NULL, 'AMIDASE C869.01-RELATED', 238975),
(299531, 'PTHR42678:SF34', NULL, NULL, NULL, NULL, 'AMIDASE DOMAIN-CONTAINING PROTEIN', 238975),
(299532, 'PTHR42678:SF33', NULL, NULL, NULL, NULL, 'OS04G0183300 PROTEIN', 238975),
(299533, 'PTHR42678:SF11', NULL, NULL, NULL, NULL, 'N-CARBAMOYL-PUTRESCINE AMIDASE AGUB', 238975);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(299534, 'PTHR42678', NULL, NULL, NULL, NULL, 'AMIDASE', 238975),
(299535, 'PTHR42678:SF26', NULL, NULL, NULL, NULL, 'OS04G0183500 PROTEIN', 238975),
(299536, 'PTHR42678:SF25', NULL, NULL, NULL, NULL, 'AMIDASE C869.01-RELATED', 238975),
(299537, 'PTHR42678:SF36', NULL, NULL, NULL, NULL, 'C869.01-LIKE PROTEIN, PUTATIVE-RELATED', 238975),
(299538, 'PTHR42678:SF35', NULL, NULL, NULL, NULL, 'AMIDASE DOMAIN-CONTAINING PROTEIN', 238975),
(299539, 'PTHR42678:SF24', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 238975),
(299540, 'PTHR42678:SF30', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 238975),
(299541, 'PTHR34138:SF1', NULL, NULL, NULL, NULL, 'CELL SHAPE-DETERMINING PROTEIN MREC', 238976),
(299542, 'PTHR34138', NULL, NULL, NULL, NULL, 'CELL SHAPE-DETERMINING PROTEIN MREC', 238976),
(299543, 'PTHR24062:SF49', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299544, 'PTHR24062:SF47', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299545, 'PTHR24062:SF45', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299546, 'PTHR24062:SF167', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR 42-RELATED', 238977),
(299547, 'PTHR24062:SF89', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR 44-RELATED', 238977),
(299548, 'PTHR24062:SF87', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299549, 'PTHR24062:SF88', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299550, 'PTHR24062:SF168', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299551, 'PTHR24062:SF41', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299552, 'PTHR24062:SF174', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR 5', 238977),
(299553, 'PTHR24062:SF42', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299554, 'PTHR24062:SF176', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299555, 'PTHR24062:SF170', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299556, 'PTHR24062:SF38', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299557, 'PTHR24062:SF32', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299558, 'PTHR24062:SF158', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299559, 'PTHR24062:SF33', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299560, 'PTHR24062:SF9', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299561, 'PTHR24062:SF5', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR 52-RELATED', 238977),
(299562, 'PTHR24062:SF30', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299563, 'PTHR24062:SF31', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299564, 'PTHR24062:SF7', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299565, 'PTHR24062:SF165', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299566, 'PTHR24062:SF164', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299567, 'PTHR24062:SF8', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299568, 'PTHR24062:SF1', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299569, 'PTHR24062:SF3', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299570, 'PTHR24062:SF161', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299571, 'PTHR24062:SF160', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299572, 'PTHR24062:SF148', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299573, 'PTHR24062:SF25', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299574, 'PTHR24062:SF69', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299575, 'PTHR24062:SF26', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299576, 'PTHR24062:SF23', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299577, 'PTHR24062:SF189', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299578, 'PTHR24062:SF188', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(299579, 'PTHR24062:SF144', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299580, 'PTHR24062:SF147', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299581, 'PTHR24062:SF22', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299582, 'PTHR24062:SF146', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR 3', 238977),
(299583, 'PTHR24062', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299584, 'PTHR24062:SF190', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR 1', 238977),
(299585, 'PTHR24062:SF152', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299586, 'PTHR24062:SF151', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299587, 'PTHR24062:SF61', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299588, 'PTHR24062:SF154', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299589, 'PTHR24062:SF62', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299590, 'PTHR24062:SF16', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299591, 'PTHR24062:SF178', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR 2', 238977),
(299592, 'PTHR24062:SF177', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299593, 'PTHR24062:SF179', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299594, 'PTHR24062:SF18', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299595, 'PTHR24062:SF19', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299596, 'PTHR24062:SF185', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR-RELATED', 238977),
(299597, 'PTHR24062:SF53', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299598, 'PTHR24062:SF187', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299599, 'PTHR24062:SF51', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2-RELATED', 238977),
(299600, 'PTHR24062:SF186', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299601, 'PTHR24062:SF181', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR 4', 238977),
(299602, 'PTHR24062:SF92', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299603, 'PTHR24062:SF183', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299604, 'PTHR24062:SF90', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299605, 'PTHR24062:SF182', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', 238977),
(299606, 'PTHR35378:SF3', NULL, NULL, NULL, NULL, '', 238978),
(299607, 'PTHR35378:SF1', NULL, NULL, NULL, NULL, '', 238978),
(299608, 'PTHR35378:SF2', NULL, NULL, NULL, NULL, '', 238978),
(299609, 'PTHR35378', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', 238978),
(299610, 'PTHR45661:SF3', NULL, NULL, NULL, NULL, 'ANTIGEN BSP, PUTATIVE-RELATED', 238979),
(299611, 'PTHR45661', NULL, NULL, NULL, NULL, 'SURFACE ANTIGEN', 238979),
(299612, 'PTHR22692:SF28', NULL, NULL, NULL, NULL, 'MYOSIN VIIBB', 238980),
(299613, 'PTHR22692:SF16', NULL, NULL, NULL, NULL, 'MYOSIN XVB', 238980),
(299614, 'PTHR22692:SF26', NULL, NULL, NULL, NULL, 'MYTH4 DOMAIN-CONTAINING PROTEIN', 238980),
(299615, 'PTHR22692:SF35', NULL, NULL, NULL, NULL, '', 238980),
(299616, 'PTHR22692:SF24', NULL, NULL, NULL, NULL, 'MYOSIN VIIB', 238980),
(299617, 'PTHR22692:SF34', NULL, NULL, NULL, NULL, 'MYOSIN VIIA', 238980),
(299618, 'PTHR22692', NULL, NULL, NULL, NULL, 'MYOSIN VII, XV', 238980),
(299619, 'PTHR22692:SF33', NULL, NULL, NULL, NULL, 'MYOSIN', 238980),
(299620, 'PTHR22692:SF21', NULL, NULL, NULL, NULL, 'MYOSIN XVA', 238980),
(299621, 'PTHR10381', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE PROTEOLYTIC SUBUNIT', 238981),
(299622, 'PTHR10381:SF48', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE PROTEOLYTIC SUBUNIT', 238981),
(299623, 'PTHR10381:SF59', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE PROTEOLYTIC SUBUNIT', 238981),
(299624, 'PTHR10381:SF26', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE PROTEOLYTIC SUBUNIT-LIKE-RELATED', 238981),
(299625, 'PTHR10381:SF15', NULL, NULL, NULL, NULL, 'CHLOROPLASTIC ATP-DEPENDENT CLP PROTEASE PROTEOLYTIC SUBUNIT 1', 238981);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(299626, 'PTHR10381:SF49', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE PROTEOLYTIC SUBUNIT', 238981),
(299627, 'PTHR10381:SF46', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE PROTEOLYTIC SUBUNIT-RELATED PROTEIN 2, CHLOROPLASTIC', 238981),
(299628, 'PTHR10381:SF24', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE PROTEOLYTIC SUBUNIT 4, CHLOROPLASTIC', 238981),
(299629, 'PTHR10381:SF58', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE PROTEOLYTIC SUBUNIT', 238981),
(299630, 'PTHR10381:SF69', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE PROTEOLYTIC SUBUNIT', 238981),
(299631, 'PTHR10381:SF47', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE PROTEOLYTIC SUBUNIT-RELATED PROTEIN 4, CHLOROPLASTIC', 238981),
(299632, 'PTHR10381:SF6', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE PROTEOLYTIC SUBUNIT-RELATED PROTEIN 3, CHLOROPLASTIC', 238981),
(299633, 'PTHR10381:SF8', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE PROTEOLYTIC SUBUNIT 6, CHLOROPLASTIC', 238981),
(299634, 'PTHR10381:SF70', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE PROTEOLYTIC SUBUNIT', 238981),
(299635, 'PTHR10381:SF55', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE PROTEOLYTIC SUBUNIT-RELATED PROTEIN 1, CHLOROPLASTIC', 238981),
(299636, 'PTHR10381:SF11', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE PROTEOLYTIC SUBUNIT, MITOCHONDRIAL', 238981),
(299637, 'PTHR10381:SF12', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE PROTEOLYTIC SUBUNIT 5, CHLOROPLASTIC', 238981),
(299638, 'PTHR10381:SF65', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE PROTEOLYTIC SUBUNIT', 238981),
(299639, 'PTHR10381:SF40', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE PROTEOLYTIC SUBUNIT', 238981),
(299640, 'PTHR10381:SF71', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE PROTEOLYTIC SUBUNIT', 238981),
(299641, 'PTHR10381:SF60', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE PROTEOLYTIC SUBUNIT', 238981),
(299642, 'PTHR10381:SF50', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE PROTEOLYTIC SUBUNIT 3, CHLOROPLASTIC', 238981),
(299643, 'PTHR10381:SF72', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE PROTEOLYTIC SUBUNIT-LIKE-RELATED', 238981),
(299644, 'PTHR34449', NULL, NULL, NULL, NULL, 'RHO TERMINATION FACTOR', 238982),
(299645, 'PTHR34449:SF5', NULL, NULL, NULL, NULL, 'ATP BINDING / ATPASE', 238982),
(299646, 'PTHR34449:SF7', NULL, NULL, NULL, NULL, 'RHO-N DOMAIN-CONTAINING PROTEIN 1, CHLOROPLASTIC', 238982),
(299647, 'PTHR34449:SF2', NULL, NULL, NULL, NULL, 'RHO TERMINATION FACTOR', 238982),
(299648, 'PTHR46959', NULL, NULL, NULL, NULL, 'SULFOQUINOVOSIDASE', 238983),
(299649, 'PTHR46959:SF2', NULL, NULL, NULL, NULL, 'SULFOQUINOVOSIDASE', 238983),
(299650, 'PTHR36577:SF3', NULL, NULL, NULL, NULL, 'DUF521 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_6G00490)', 238984),
(299651, 'PTHR36577', NULL, NULL, NULL, NULL, 'DUF521 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_6G00490)', 238984),
(299652, 'PTHR34818', NULL, NULL, NULL, NULL, 'PROTEIN BLI-3', 238985),
(299653, 'PTHR34818:SF1', NULL, NULL, NULL, NULL, 'GENERAL STRESS PROTEIN 26', 238985),
(299654, 'PTHR15071:SF20', NULL, NULL, NULL, NULL, '', 238986),
(299655, 'PTHR15071:SF13', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 27', 238986),
(299656, 'PTHR15071:SF35', NULL, NULL, NULL, NULL, '', 238986),
(299657, 'PTHR15071:SF34', NULL, NULL, NULL, NULL, '', 238986),
(299658, 'PTHR15071', NULL, NULL, NULL, NULL, 'MANNOSE-6-PHOSPHATE RECEPTOR FAMILY MEMBER', 238986),
(299659, 'PTHR15071:SF17', NULL, NULL, NULL, NULL, 'CATION-INDEPENDENT MANNOSE-6-PHOSPHATE RECEPTOR', 238986),
(299660, 'PTHR15071:SF28', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 238986),
(299661, 'PTHR15071:SF0', NULL, NULL, NULL, NULL, 'MANNOSE 6-PHOSPHATE RECEPTOR-LIKE PROTEIN 1', 238986),
(299662, 'PTHR15071:SF25', NULL, NULL, NULL, NULL, '', 238986),
(299663, 'PTHR15071:SF29', NULL, NULL, NULL, NULL, 'CATION-DEPENDENT MANNOSE-6-PHOSPHATE RECEPTOR', 238986),
(299664, 'PTHR13183', NULL, NULL, NULL, NULL, 'AXONEMAL INNER ARM DYNEIN LIGHT CHAIN 28', 238987);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(299665, 'PTHR13183:SF2', NULL, NULL, NULL, NULL, 'ARM LIGHT CHAIN, AXONEMAL, PUTATIVE-RELATED', 238987),
(299666, 'PTHR13183:SF1', NULL, NULL, NULL, NULL, 'ARM LIGHT CHAIN, AXONEMAL, PUTATIVE-RELATED', 238987),
(299667, 'PTHR13183:SF0', NULL, NULL, NULL, NULL, 'AXONEMAL DYNEIN LIGHT INTERMEDIATE POLYPEPTIDE 1', 238987),
(299668, 'PTHR42713:SF2', NULL, NULL, NULL, NULL, 'TWO-COMPONENT SENSOR KINASE YESM', 238988),
(299669, 'PTHR42713:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN HPTR', 238988),
(299670, 'PTHR42713', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE-RELATED', 238988),
(299671, 'PTHR37748', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 238989),
(299672, 'PTHR37748:SF2', NULL, NULL, NULL, NULL, '', 238989),
(299673, 'PTHR37748:SF1', NULL, NULL, NULL, NULL, '', 238989),
(299674, 'PTHR33286:SF29', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 238990),
(299675, 'PTHR33286:SF49', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 238990),
(299676, 'PTHR33286:SF28', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 238990),
(299677, 'PTHR33286:SF48', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 238990),
(299678, 'PTHR33286:SF26', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 238990),
(299679, 'PTHR33286:SF23', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 238990),
(299680, 'PTHR33286:SF24', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 238990),
(299681, 'PTHR33286:SF46', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 238990),
(299682, 'PTHR33286:SF43', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 238990),
(299683, 'PTHR33286:SF44', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 238990),
(299684, 'PTHR33286:SF41', NULL, NULL, NULL, NULL, 'PROTEASE INHIBITOR/SEED STORAGE/LIPID TRANSFER FAMILY PROTEIN', 238990),
(299685, 'PTHR33286:SF42', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 238990),
(299686, 'PTHR33286', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', 238990),
(299687, 'PTHR33286:SF7', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 238990),
(299688, 'PTHR33286:SF1', NULL, NULL, NULL, NULL, 'OS01G0800600 PROTEIN', 238990),
(299689, 'PTHR33286:SF18', NULL, NULL, NULL, NULL, '', 238990),
(299690, 'PTHR33286:SF19', NULL, NULL, NULL, NULL, '', 238990),
(299691, 'PTHR33286:SF16', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 238990),
(299692, 'PTHR33286:SF39', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 238990),
(299693, 'PTHR33286:SF36', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 238990),
(299694, 'PTHR33286:SF37', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 238990),
(299695, 'PTHR33286:SF34', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 238990),
(299696, 'PTHR33286:SF54', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', 238990),
(299697, 'PTHR33286:SF32', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 238990),
(299698, 'PTHR33286:SF33', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 238990),
(299699, 'PTHR33286:SF52', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 238990),
(299700, 'PTHR33286:SF30', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 238990),
(299701, 'PTHR33286:SF31', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 238990),
(299702, 'PTHR33286:SF53', NULL, NULL, NULL, NULL, '', 238990),
(299703, 'PTHR33286:SF50', NULL, NULL, NULL, NULL, 'LIPID BINDING PROTEIN', 238990),
(299704, 'PTHR33286:SF51', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', 238990),
(299705, 'PTHR31682:SF30', NULL, NULL, NULL, NULL, 'UDP-ARABINOPYRANOSE MUTASE', 238991),
(299706, 'PTHR31682:SF5', NULL, NULL, NULL, NULL, 'ALPHA-1,4-GLUCAN-PROTEIN SYNTHASE', 238991),
(299707, 'PTHR31682:SF41', NULL, NULL, NULL, NULL, 'UDP-ARABINOPYRANOSE MUTASE', 238991),
(299708, 'PTHR31682:SF42', NULL, NULL, NULL, NULL, 'UDP-ARABINOPYRANOSE MUTASE', 238991);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(299709, 'PTHR31682:SF40', NULL, NULL, NULL, NULL, 'UDP-ARABINOPYRANOSE MUTASE', 238991),
(299710, 'PTHR31682:SF4', NULL, NULL, NULL, NULL, 'UDP-ARABINOPYRANOSE MUTASE 5-RELATED', 238991),
(299711, 'PTHR31682:SF39', NULL, NULL, NULL, NULL, 'UDP-ARABINOPYRANOSE MUTASE 4-RELATED', 238991),
(299712, 'PTHR31682:SF36', NULL, NULL, NULL, NULL, 'UDP-ARABINOPYRANOSE MUTASE 1-RELATED', 238991),
(299713, 'PTHR31682:SF23', NULL, NULL, NULL, NULL, 'UDP-ARABINOPYRANOSE MUTASE', 238991),
(299714, 'PTHR31682:SF45', NULL, NULL, NULL, NULL, 'UDP-ARABINOPYRANOSE MUTASE', 238991),
(299715, 'PTHR31682:SF24', NULL, NULL, NULL, NULL, 'UDP-ARABINOPYRANOSE MUTASE 2', 238991),
(299716, 'PTHR31682:SF46', NULL, NULL, NULL, NULL, 'UDP-ARABINOPYRANOSE MUTASE 1', 238991),
(299717, 'PTHR31682:SF43', NULL, NULL, NULL, NULL, 'UDP-ARABINOPYRANOSE MUTASE', 238991),
(299718, 'PTHR31682:SF22', NULL, NULL, NULL, NULL, 'UDP-ARABINOPYRANOSE MUTASE', 238991),
(299719, 'PTHR31682:SF44', NULL, NULL, NULL, NULL, 'UDP-ARABINOPYRANOSE MUTASE 3', 238991),
(299720, 'PTHR31682', NULL, NULL, NULL, NULL, 'UDP-ARABINOSE MUTASE', 238991),
(299721, 'PTHR13814:SF17', NULL, NULL, NULL, NULL, 'SI:CH211-284E20.8', 238992),
(299722, 'PTHR13814', NULL, NULL, NULL, NULL, 'FETUIN', 238992),
(299723, 'PTHR13814:SF6', NULL, NULL, NULL, NULL, 'ALPHA-2-HS-GLYCOPROTEIN', 238992),
(299724, 'PTHR13814:SF15', NULL, NULL, NULL, NULL, 'SI:CH211-262H13.5', 238992),
(299725, 'PTHR13814:SF16', NULL, NULL, NULL, NULL, 'CYSTATIN', 238992),
(299726, 'PTHR13814:SF3', NULL, NULL, NULL, NULL, 'HISTIDINE-RICH GLYCOPROTEIN', 238992),
(299727, 'PTHR13814:SF10', NULL, NULL, NULL, NULL, 'FETUIN-B', 238992),
(299728, 'PTHR13814:SF12', NULL, NULL, NULL, NULL, 'KININOGEN-1', 238992),
(299729, 'PTHR39173', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE', 238993),
(299730, 'PTHR39173:SF1', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE', 238993),
(299731, 'PTHR21386:SF0', NULL, NULL, NULL, NULL, 'PROTEIN INSCUTEABLE HOMOLOG', 238994),
(299732, 'PTHR21386', NULL, NULL, NULL, NULL, 'INSCUTEABLE', 238994),
(299733, 'PTHR21738', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 238995),
(299734, 'PTHR21738:SF0', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA PROCESSING PROTEIN 36 HOMOLOG', 238995),
(299735, 'PTHR47289:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, PUTATIVE (DUF1664)-RELATED', 238996),
(299736, 'PTHR47289:SF4', NULL, NULL, NULL, NULL, 'DUF1664 DOMAIN-CONTAINING PROTEIN', 238996),
(299737, 'PTHR47289', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, PUTATIVE (DUF1664)-RELATED', 238996),
(299738, 'PTHR47289:SF3', NULL, NULL, NULL, NULL, 'OS01G0112300 PROTEIN', 238996),
(299739, 'PTHR47289:SF5', NULL, NULL, NULL, NULL, 'DUF1664 DOMAIN-CONTAINING PROTEIN', 238996),
(299740, 'PTHR14248:SF32', NULL, NULL, NULL, NULL, 'CYCLIN-Y-LIKE PROTEIN 1', 238997),
(299741, 'PTHR14248:SF33', NULL, NULL, NULL, NULL, 'CYCLIN-Y', 238997),
(299742, 'PTHR14248', NULL, NULL, NULL, NULL, 'CYCLIN Y, ISOFORM A', 238997),
(299743, 'PTHR14248:SF25', NULL, NULL, NULL, NULL, 'CYCLIN-Y-LIKE PROTEIN 2', 238997),
(299744, 'PTHR14248:SF37', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 238997),
(299745, 'PTHR14248:SF38', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 238997),
(299746, 'PTHR14248:SF39', NULL, NULL, NULL, NULL, 'CYCLIN-Y-LIKE PROTEIN 3-RELATED', 238997),
(299747, 'PTHR14248:SF18', NULL, NULL, NULL, NULL, 'CYCLIN Y, ISOFORM A', 238997),
(299748, 'PTHR18870:SF8', NULL, NULL, NULL, NULL, 'PROTEIN FAM184B', 238998),
(299749, 'PTHR18870:SF7', NULL, NULL, NULL, NULL, 'PROTEIN FAM184A', 238998),
(299750, 'PTHR18870:SF10', NULL, NULL, NULL, NULL, 'ZGC:85722', 238998),
(299751, 'PTHR18870', NULL, NULL, NULL, NULL, 'PROTEIN TAG-278-RELATED', 238998),
(299752, 'PTHR18870:SF9', NULL, NULL, NULL, NULL, 'PROTEIN TAG-278-RELATED', 238998),
(299753, 'PTHR23361', NULL, NULL, NULL, NULL, 'MUCIN', 238999),
(299754, 'PTHR23361:SF19', NULL, NULL, NULL, NULL, 'IPT/TIG DOMAIN-CONTAINING PROTEIN', 238999),
(299755, 'PTHR34452:SF14', NULL, NULL, NULL, NULL, 'C2 NT-TYPE DOMAIN-CONTAINING PROTEIN', 239000);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(299756, 'PTHR34452:SF15', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN-RELATED PROTEIN', 239000),
(299757, 'PTHR34452:SF12', NULL, NULL, NULL, NULL, 'EEIG1/EHBP1 N-TERMINAL DOMAIN-CONTAINING PROTEIN-RELATED', 239000),
(299758, 'PTHR34452:SF1', NULL, NULL, NULL, NULL, 'SPORULATION-SPECIFIC PROTEIN', 239000),
(299759, 'PTHR34452:SF13', NULL, NULL, NULL, NULL, 'EEIG1/EHBP1 N-TERMINAL DOMAIN-CONTAINING PROTEIN-RELATED', 239000),
(299760, 'PTHR34452', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN-RELATED PROTEIN', 239000),
(299761, 'PTHR34452:SF7', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN-RELATED PROTEIN', 239000),
(299762, 'PTHR34452:SF9', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN-LIKE PROTEIN', 239000),
(299763, 'PTHR34452:SF5', NULL, NULL, NULL, NULL, 'MYOSIN-13-LIKE ISOFORM X1', 239000),
(299764, 'PTHR13363:SF0', NULL, NULL, NULL, NULL, 'B30.2/SPRY DOMAIN-CONTAINING PROTEIN', 239001),
(299765, 'PTHR13363', NULL, NULL, NULL, NULL, 'RING FINGER AND SRY DOMAIN-CONTAINING', 239001),
(299766, 'PTHR13363:SF6', NULL, NULL, NULL, NULL, 'RING FINGER AND SPRY DOMAIN-CONTAINING PROTEIN 1', 239001),
(299767, 'PTHR13363:SF5', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF123', 239001),
(299768, 'PTHR33711:SF9', NULL, NULL, NULL, NULL, 'PROTOCATECHUATE 3,4-DIOXYGENASE ALPHA CHAIN', 239002),
(299769, 'PTHR33711', NULL, NULL, NULL, NULL, 'DIOXYGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G02910)-RELATED', 239002),
(299770, 'PTHR33711:SF10', NULL, NULL, NULL, NULL, 'INTRADIOL_DIOXYGENAS DOMAIN-CONTAINING PROTEIN', 239002),
(299771, 'PTHR33711:SF5', NULL, NULL, NULL, NULL, 'DIOXYGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G03030)-RELATED', 239002),
(299772, 'PTHR33711:SF7', NULL, NULL, NULL, NULL, 'DIOXYGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G14270)-RELATED', 239002),
(299773, 'PTHR12004:SF13', NULL, NULL, NULL, NULL, 'PRORELAXIN H2', 239003),
(299774, 'PTHR12004:SF14', NULL, NULL, NULL, NULL, 'PRORELAXIN H1', 239003),
(299775, 'PTHR12004', NULL, NULL, NULL, NULL, 'RELAXIN', 239003),
(299776, 'PTHR12004:SF1', NULL, NULL, NULL, NULL, 'INSULIN-LIKE PEPTIDE INSL6', 239003),
(299777, 'PTHR12004:SF3', NULL, NULL, NULL, NULL, 'EARLY PLACENTA INSULIN-LIKE PEPTIDE', 239003),
(299778, 'PTHR10164:SF4', NULL, NULL, NULL, NULL, 'GH23156P', 239004),
(299779, 'PTHR10164:SF3', NULL, NULL, NULL, NULL, 'ISLET CELL AUTOANTIGEN 1', 239004),
(299780, 'PTHR10164', NULL, NULL, NULL, NULL, 'ISLET CELL AUTOANTIGEN 1', 239004),
(299781, 'PTHR10164:SF5', NULL, NULL, NULL, NULL, 'ISLET CELL AUTOANTIGEN 1-LIKE PROTEIN', 239004),
(299782, 'PTHR13186', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 31', 239005),
(299783, 'PTHR13186:SF0', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 31', 239005),
(299784, 'PTHR12349:SF4', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND LEM DOMAIN-CONTAINING PROTEIN 2', 239006),
(299785, 'PTHR12349', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND LEM DOMAIN-CONTAINING PROTEIN 2', 239006),
(299786, 'PTHR12349:SF1', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE ZDHHC8', 239006),
(299787, 'PTHR12349:SF3', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE ZDHHC5', 239006),
(299788, 'PTHR12349:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER DHHC-TYPE CONTAINING 8, ISOFORM E', 239006),
(299789, 'PTHR33895:SF2', NULL, NULL, NULL, NULL, 'HUMANIN-LIKE 7', 239007),
(299790, 'PTHR33895:SF5', NULL, NULL, NULL, NULL, 'HUMANIN-LIKE 4', 239007),
(299791, 'PTHR33895:SF3', NULL, NULL, NULL, NULL, 'HUMANIN-LIKE 10', 239007),
(299792, 'PTHR33895:SF4', NULL, NULL, NULL, NULL, 'HUMANIN-LIKE 5', 239007),
(299793, 'PTHR33895:SF18', NULL, NULL, NULL, NULL, 'HUMANIN-LIKE 1-RELATED', 239007),
(299794, 'PTHR33895:SF7', NULL, NULL, NULL, NULL, 'HUMANIN-LIKE 3', 239007),
(299795, 'PTHR33895:SF16', NULL, NULL, NULL, NULL, 'HUMANIN-LIKE 11', 239007),
(299796, 'PTHR33895:SF17', NULL, NULL, NULL, NULL, 'HUMANIN-LIKE 13', 239007),
(299797, 'PTHR33895', NULL, NULL, NULL, NULL, 'HUMANIN-LIKE 4', 239007),
(299798, 'PTHR33895:SF15', NULL, NULL, NULL, NULL, 'HUMANIN-RELATED', 239007),
(299799, 'PTHR13763:SF9', NULL, NULL, NULL, NULL, 'BRCA1-ASSOCIATED RING DOMAIN PROTEIN 1', 239008);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(299800, 'PTHR13763:SF0', NULL, NULL, NULL, NULL, 'BREAST CANCER TYPE 1 SUSCEPTIBILITY PROTEIN', 239008),
(299801, 'PTHR13763', NULL, NULL, NULL, NULL, 'BREAST CANCER TYPE 1 SUSCEPTIBILITY PROTEIN BRCA1', 239008),
(299802, 'PTHR13763:SF6', NULL, NULL, NULL, NULL, 'BRCA1-ASSOCIATED RING DOMAIN PROTEIN 1', 239008),
(299803, 'PTHR13763:SF7', NULL, NULL, NULL, NULL, 'BRCA1-ASSOCIATED RING DOMAIN PROTEIN 1', 239008),
(299804, 'PTHR13763:SF10', NULL, NULL, NULL, NULL, 'FINGER PROTEIN, PUTATIVE-RELATED', 239008),
(299805, 'PTHR13763:SF8', NULL, NULL, NULL, NULL, '', 239008),
(299806, 'PTHR24302:SF41', NULL, NULL, NULL, NULL, '', 239009),
(299807, 'PTHR24302:SF40', NULL, NULL, NULL, NULL, '', 239009),
(299808, 'PTHR24302:SF32', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 3, SUBFAMILY A, POLYPEPTIDE 65', 239009),
(299809, 'PTHR24302:SF8', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 3A25-RELATED', 239009),
(299810, 'PTHR24302:SF20', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 3A5', 239009),
(299811, 'PTHR24302:SF31', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 3A7', 239009),
(299812, 'PTHR24302:SF38', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 3A4', 239009),
(299813, 'PTHR24302:SF15', NULL, NULL, NULL, NULL, 'FATTY-ACID PEROXYGENASE', 239009),
(299814, 'PTHR24302', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 3', 239009),
(299815, 'PTHR24302:SF17', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 3, SUBFAMILY C, POLYPEPTIDE 4-RELATED', 239009),
(299816, 'PTHR24302:SF39', NULL, NULL, NULL, NULL, 'THROMBOXANE A SYNTHASE 1', 239009),
(299817, 'PTHR24302:SF6', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 3A43', 239009),
(299818, 'PTHR14571', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239010),
(299819, 'PTHR14571:SF9', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SET-26-RELATED', 239010),
(299820, 'PTHR14571:SF13', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN 13', 239010),
(299821, 'PTHR14571:SF14', NULL, NULL, NULL, NULL, 'PHD DOMAIN-CONTAINING PROTEIN', 239010),
(299822, 'PTHR14571:SF8', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN 23', 239010),
(299823, 'PTHR24043', NULL, NULL, NULL, NULL, 'SCAVENGER RECEPTOR CLASS F', 239011),
(299824, 'PTHR24043:SF0', NULL, NULL, NULL, NULL, 'SCAVENGER RECEPTOR CLASS F MEMBER 1', 239011),
(299825, 'PTHR24043:SF5', NULL, NULL, NULL, NULL, 'SCAVENGER RECEPTOR CLASS F MEMBER 2', 239011),
(299826, 'PTHR24043:SF7', NULL, NULL, NULL, NULL, 'MULTIPLE EGF-LIKE-DOMAINS 11', 239011),
(299827, 'PTHR24043:SF6', NULL, NULL, NULL, NULL, '', 239011),
(299828, 'PTHR16127:SF17', NULL, NULL, NULL, NULL, 'BNAA02G11530D PROTEIN', 239012),
(299829, 'PTHR16127:SF15', NULL, NULL, NULL, NULL, 'TAXILIN BETA B', 239012),
(299830, 'PTHR16127:SF13', NULL, NULL, NULL, NULL, 'GH01188P', 239012),
(299831, 'PTHR16127:SF14', NULL, NULL, NULL, NULL, 'GAMMA-TAXILIN', 239012),
(299832, 'PTHR16127', NULL, NULL, NULL, NULL, 'TAXILIN', 239012),
(299833, 'PTHR16127:SF12', NULL, NULL, NULL, NULL, 'ALPHA-TAXILIN', 239012),
(299834, 'PTHR16127:SF10', NULL, NULL, NULL, NULL, 'BETA-TAXILIN', 239012),
(299835, 'PTHR31768', NULL, NULL, NULL, NULL, 'B BOX-TYPE DOMAIN-CONTAINING PROTEIN', 239013),
(299836, 'PTHR31768:SF3', NULL, NULL, NULL, NULL, 'B BOX-TYPE DOMAIN-CONTAINING PROTEIN', 239013),
(299837, 'PTHR32009:SF78', NULL, NULL, NULL, NULL, 'RESISTANCE GENE ANALOG NBS6', 239014),
(299838, 'PTHR32009:SF109', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS)', 239014),
(299839, 'PTHR32009:SF76', NULL, NULL, NULL, NULL, 'RESISTANCE PROTEIN (TIR CLASS), PUTATIVE-RELATED', 239014),
(299840, 'PTHR32009:SF39', NULL, NULL, NULL, NULL, 'MRGH14', 239014),
(299841, 'PTHR32009:SF147', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 239014),
(299842, 'PTHR32009:SF103', NULL, NULL, NULL, NULL, 'BNAA09G13280D PROTEIN', 239014),
(299843, 'PTHR32009:SF146', NULL, NULL, NULL, NULL, 'TOLL/INTERLEUKIN-1 RECEPTOR-LIKE PROTEIN', 239014),
(299844, 'PTHR32009:SF145', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN PROTEIN', 239014),
(299845, 'PTHR32009:SF101', NULL, NULL, NULL, NULL, 'CYSTEINE DIOXYGENASE', 239014); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(299846, 'PTHR32009:SF144', NULL, NULL, NULL, NULL, 'RESISTANCE PROTEIN (TIR-NBS-LRR CLASS), PUTATIVE-RELATED', 239014),
(299847, 'PTHR32009:SF100', NULL, NULL, NULL, NULL, 'TOLL-INTERLEUKIN-RESISTANCE (TIR) DOMAIN FAMILY PROTEIN', 239014),
(299848, 'PTHR32009:SF106', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS)', 239014),
(299849, 'PTHR32009:SF149', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS)', 239014),
(299850, 'PTHR32009:SF104', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 239014),
(299851, 'PTHR32009:SF148', NULL, NULL, NULL, NULL, 'TOLL-INTERLEUKIN-RESISTANCE (TIR) DOMAIN FAMILY PROTEIN', 239014),
(299852, 'PTHR32009:SF143', NULL, NULL, NULL, NULL, 'BNAC08G49870D PROTEIN', 239014),
(299853, 'PTHR32009:SF142', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 239014),
(299854, 'PTHR32009:SF141', NULL, NULL, NULL, NULL, 'RESISTANCE PROTEIN RPP1-WSB, PUTATIVE-RELATED', 239014),
(299855, 'PTHR32009:SF140', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 239014),
(299856, 'PTHR32009:SF81', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 239014),
(299857, 'PTHR32009:SF42', NULL, NULL, NULL, NULL, 'SIMILARITY TO DISEASE RESISTANCE PROTEIN', 239014),
(299858, 'PTHR32009:SF86', NULL, NULL, NULL, NULL, 'TOLL/INTERLEUKIN-1 RECEPTOR (TIR) DOMAIN-CONTAINING PROTEIN-RELATED', 239014),
(299859, 'PTHR32009:SF85', NULL, NULL, NULL, NULL, 'BNAC09G18120D PROTEIN', 239014),
(299860, 'PTHR32009:SF83', NULL, NULL, NULL, NULL, 'TOLL-INTERLEUKIN-RESISTANCE (TIR) DOMAIN FAMILY PROTEIN', 239014),
(299861, 'PTHR32009:SF45', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS) FAMILY', 239014),
(299862, 'PTHR32009:SF89', NULL, NULL, NULL, NULL, 'TMV RESISTANCE PROTEIN N', 239014),
(299863, 'PTHR32009:SF49', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS) FAMILY', 239014),
(299864, 'PTHR32009:SF136', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 239014),
(299865, 'PTHR32009:SF135', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 239014),
(299866, 'PTHR32009:SF134', NULL, NULL, NULL, NULL, 'TMV RESISTANCE PROTEIN N', 239014),
(299867, 'PTHR32009:SF133', NULL, NULL, NULL, NULL, 'TOLL/INTERLEUKIN-1 RECEPTOR (TIR) DOMAIN-CONTAINING PROTEIN-RELATED', 239014),
(299868, 'PTHR32009:SF139', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 239014),
(299869, 'PTHR32009:SF138', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS) FAMILY', 239014),
(299870, 'PTHR32009:SF137', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 239014),
(299871, 'PTHR32009:SF132', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 239014),
(299872, 'PTHR32009:SF131', NULL, NULL, NULL, NULL, 'OS07G0566800 PROTEIN', 239014),
(299873, 'PTHR32009:SF130', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 239014),
(299874, 'PTHR32009:SF93', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 239014),
(299875, 'PTHR32009:SF92', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 239014),
(299876, 'PTHR32009:SF53', NULL, NULL, NULL, NULL, 'TOLL-INTERLEUKIN-RESISTANCE (TIR) DOMAIN FAMILY PROTEIN', 239014),
(299877, 'PTHR32009:SF97', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 239014),
(299878, 'PTHR32009:SF96', NULL, NULL, NULL, NULL, 'TOLL-INTERLEUKIN-RESISTANCE (TIR) DOMAIN FAMILY PROTEIN', 239014),
(299879, 'PTHR32009:SF95', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 239014),
(299880, 'PTHR32009:SF57', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 239014),
(299881, 'PTHR32009:SF99', NULL, NULL, NULL, NULL, 'TMV RESISTANCE PROTEIN N', 239014),
(299882, 'PTHR32009:SF125', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 239014),
(299883, 'PTHR32009:SF124', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS)', 239014),
(299884, 'PTHR32009:SF123', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 239014),
(299885, 'PTHR32009:SF122', NULL, NULL, NULL, NULL, 'TYPE DISEASE RESISTANCE PROTEIN, PUTATIVE-RELATED', 239014); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(299886, 'PTHR32009:SF129', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 239014),
(299887, 'PTHR32009:SF128', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE COP1-LIKE', 239014),
(299888, 'PTHR32009:SF127', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 239014),
(299889, 'PTHR32009:SF126', NULL, NULL, NULL, NULL, 'TOLL/INTERLEUKIN-1 RECEPTOR (TIR) DOMAIN-CONTAINING PROTEIN-RELATED', 239014),
(299890, 'PTHR32009:SF121', NULL, NULL, NULL, NULL, 'SIMILAR TO PART OF DISEASE RESISTANCE PROTEIN-RELATED', 239014),
(299891, 'PTHR32009:SF120', NULL, NULL, NULL, NULL, 'TYPE DISEASE RESISTANCE PROTEIN, PUTATIVE-RELATED', 239014),
(299892, 'PTHR32009:SF63', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RBA1-RELATED', 239014),
(299893, 'PTHR32009:SF62', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 239014),
(299894, 'PTHR32009:SF65', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS) FAMILY', 239014),
(299895, 'PTHR32009:SF119', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 239014),
(299896, 'PTHR32009:SF69', NULL, NULL, NULL, NULL, 'TOLL/INTERLEUKIN-1 RECEPTOR (TIR) DOMAIN-CONTAINING PROTEIN-RELATED', 239014),
(299897, 'PTHR32009:SF113', NULL, NULL, NULL, NULL, 'TIR-LIKE DOMAIN PROTEIN TSDC PROTEIN', 239014),
(299898, 'PTHR32009:SF116', NULL, NULL, NULL, NULL, 'BNAC09G13550D PROTEIN', 239014),
(299899, 'PTHR32009:SF115', NULL, NULL, NULL, NULL, 'RPP1-LIKE DISEASE RESISTANCE PROTEIN-RELATED', 239014),
(299900, 'PTHR32009:SF150', NULL, NULL, NULL, NULL, 'TOLL-INTERLEUKIN-RESISTANCE (TIR) DOMAIN FAMILY PROTEIN', 239014),
(299901, 'PTHR32009:SF110', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS)', 239014),
(299902, 'PTHR32009', NULL, NULL, NULL, NULL, 'TMV RESISTANCE PROTEIN N-LIKE', 239014),
(299903, 'PTHR32009:SF70', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 239014),
(299904, 'PTHR32009:SF75', NULL, NULL, NULL, NULL, 'PROTEIN PHLOEM PROTEIN 2-LIKE A5-RELATED', 239014),
(299905, 'PTHR32009:SF73', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 239014),
(299906, 'PTHR12801:SF140', NULL, NULL, NULL, NULL, 'RNA EXONUCLEASE 4', 239015),
(299907, 'PTHR12801:SF145', NULL, NULL, NULL, NULL, 'SMALL RNA DEGRADING NUCLEASE 1-RELATED', 239015),
(299908, 'PTHR12801:SF62', NULL, NULL, NULL, NULL, 'RNA EXONUCLEASE 1 HOMOLOG', 239015),
(299909, 'PTHR12801:SF123', NULL, NULL, NULL, NULL, 'RNA EXONUCLEASE 4', 239015),
(299910, 'PTHR12801:SF122', NULL, NULL, NULL, NULL, 'RNA EXONUCLEASE 4', 239015),
(299911, 'PTHR12801:SF143', NULL, NULL, NULL, NULL, 'RNA EXONUCLEASE 4', 239015),
(299912, 'PTHR12801:SF121', NULL, NULL, NULL, NULL, 'RNA EXONUCLEASE 4', 239015),
(299913, 'PTHR12801:SF82', NULL, NULL, NULL, NULL, 'RNA EXONUCLEASE 5', 239015),
(299914, 'PTHR12801:SF142', NULL, NULL, NULL, NULL, 'EXONUCLEASE DOMAIN-CONTAINING PROTEIN', 239015),
(299915, 'PTHR12801:SF124', NULL, NULL, NULL, NULL, '', 239015),
(299916, 'PTHR12801:SF146', NULL, NULL, NULL, NULL, 'RNA EXONUCLEASE 4', 239015),
(299917, 'PTHR12801:SF59', NULL, NULL, NULL, NULL, 'INTERFERON-STIMULATED GENE 20 KDA PROTEIN', 239015),
(299918, 'PTHR12801:SF57', NULL, NULL, NULL, NULL, 'APOPTOSIS-ENHANCING NUCLEASE', 239015),
(299919, 'PTHR12801', NULL, NULL, NULL, NULL, 'RNA EXONUCLEASE REXO1 / RECO3 FAMILY MEMBER-RELATED', 239015),
(299920, 'PTHR12801:SF78', NULL, NULL, NULL, NULL, 'INTERFERON-STIMULATED 20 KDA EXONUCLEASE-LIKE 2', 239015),
(299921, 'PTHR12801:SF130', NULL, NULL, NULL, NULL, 'RNA EXONUCLEASE 4', 239015),
(299922, 'PTHR12801:SF152', NULL, NULL, NULL, NULL, 'ZGC:152968', 239015),
(299923, 'PTHR12801:SF150', NULL, NULL, NULL, NULL, 'INTERFERON-STIMULATED EXONUCLEASE GENE-RELATED', 239015),
(299924, 'PTHR12801:SF156', NULL, NULL, NULL, NULL, 'EXONUCLEASE DOMAIN-CONTAINING PROTEIN', 239015),
(299925, 'PTHR12801:SF112', NULL, NULL, NULL, NULL, 'RNA EXONUCLEASE 3', 239015),
(299926, 'PTHR12801:SF155', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H70', 239015),
(299927, 'PTHR12801:SF133', NULL, NULL, NULL, NULL, 'RNA EXONUCLEASE 4', 239015),
(299928, 'PTHR12801:SF154', NULL, NULL, NULL, NULL, 'RNA EXONUCLEASE 4', 239015);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(299929, 'PTHR12801:SF153', NULL, NULL, NULL, NULL, 'EXONUCLEASE DOMAIN-CONTAINING PROTEIN', 239015),
(299930, 'PTHR12801:SF22', NULL, NULL, NULL, NULL, 'EXONUCLEASE GOR-RELATED', 239015),
(299931, 'PTHR12801:SF115', NULL, NULL, NULL, NULL, 'FI18136P1-RELATED', 239015),
(299932, 'PTHR12801:SF136', NULL, NULL, NULL, NULL, 'RNA EXONUCLEASE 4', 239015),
(299933, 'PTHR12801:SF114', NULL, NULL, NULL, NULL, 'EXONUCLEASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G00870)-RELATED', 239015),
(299934, 'PTHR12801:SF157', NULL, NULL, NULL, NULL, 'SMALL RNA DEGRADING NUCLEASE 5', 239015),
(299935, 'PTHR12801:SF118', NULL, NULL, NULL, NULL, 'RNA EXONUCLEASE 3', 239015),
(299936, 'PTHR12801:SF45', NULL, NULL, NULL, NULL, 'RNA EXONUCLEASE 4', 239015),
(299937, 'PTHR37192', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 239016),
(299938, 'PTHR37192:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 239016),
(299939, 'PTHR37192:SF4', NULL, NULL, NULL, NULL, 'BNAA05G15690D PROTEIN', 239016),
(299940, 'PTHR39235:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL N-ACETYLGLUCOSAMINYLTRANSFERASE SUBUNIT Y', 239017),
(299941, 'PTHR39235', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL N-ACETYLGLUCOSAMINYLTRANSFERASE SUBUNIT Y', 239017),
(299942, 'PTHR46842:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 266', 239018),
(299943, 'PTHR46842', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 266', 239018),
(299944, 'PTHR47247:SF1', NULL, NULL, NULL, NULL, 'KUNITZ-TYPE PROTEASE INHIBITOR 2', 239019),
(299945, 'PTHR47247', NULL, NULL, NULL, NULL, 'KUNITZ-TYPE PROTEASE INHIBITOR 2', 239019),
(299946, 'PTHR13595:SF2', NULL, NULL, NULL, NULL, '', 239020),
(299947, 'PTHR13595:SF3', NULL, NULL, NULL, NULL, '', 239020),
(299948, 'PTHR13595:SF1', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 6-INTERACTING PROTEIN 4', 239020),
(299949, 'PTHR13595', NULL, NULL, NULL, NULL, 'ARL6IP4 PROTEIN', 239020),
(299950, 'PTHR23161:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CIP2A', 239021),
(299951, 'PTHR23161', NULL, NULL, NULL, NULL, 'PROTEIN CIP2A', 239021),
(299952, 'PTHR31944:SF131', NULL, NULL, NULL, NULL, 'HEME-RESPONSIVE ZINC FINGER TRANSCRIPTION FACTOR HAP1', 239022),
(299953, 'PTHR31944:SF130', NULL, NULL, NULL, NULL, 'ZN(2)-C6 FUNGAL-TYPE DOMAIN-CONTAINING PROTEIN', 239022),
(299954, 'PTHR31944', NULL, NULL, NULL, NULL, 'HEME-RESPONSIVE ZINC FINGER TRANSCRIPTION FACTOR HAP1', 239022),
(299955, 'PTHR31944:SF129', NULL, NULL, NULL, NULL, 'ASPYRIDONES CLUSTER REGULATOR APDR-RELATED', 239022),
(299956, 'PTHR31645:SF17', NULL, NULL, NULL, NULL, 'IRON-PHYTOSIDEROPHORE TRANSPORTER YSL15', 239023),
(299957, 'PTHR31645:SF19', NULL, NULL, NULL, NULL, 'METAL-NICOTIANAMINE TRANSPORTER YSL16-RELATED', 239023),
(299958, 'PTHR31645:SF79', NULL, NULL, NULL, NULL, '', 239023),
(299959, 'PTHR31645:SF58', NULL, NULL, NULL, NULL, '', 239023),
(299960, 'PTHR31645:SF14', NULL, NULL, NULL, NULL, 'METAL-NICOTIANAMINE TRANSPORTER YSL18-RELATED', 239023),
(299961, 'PTHR31645:SF16', NULL, NULL, NULL, NULL, 'METAL-NICOTIANAMINE TRANSPORTER YSL5-RELATED', 239023),
(299962, 'PTHR31645:SF53', NULL, NULL, NULL, NULL, 'METAL-NICOTIANAMINE TRANSPORTER YSL7-RELATED', 239023),
(299963, 'PTHR31645:SF76', NULL, NULL, NULL, NULL, 'METAL-NICOTIANAMINE TRANSPORTER YSL8-RELATED', 239023),
(299964, 'PTHR31645:SF10', NULL, NULL, NULL, NULL, 'METAL-NICOTIANAMINE TRANSPORTER YSL7-RELATED', 239023),
(299965, 'PTHR31645:SF54', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 239023),
(299966, 'PTHR31645:SF11', NULL, NULL, NULL, NULL, 'METAL-NICOTIANAMINE TRANSPORTER YSL1', 239023),
(299967, 'PTHR31645:SF56', NULL, NULL, NULL, NULL, 'METAL-NICOTIANAMINE TRANSPORTER YSL7-RELATED', 239023),
(299968, 'PTHR31645:SF12', NULL, NULL, NULL, NULL, 'METAL-NICOTIANAMINE TRANSPORTER YSL11-RELATED', 239023),
(299969, 'PTHR31645:SF82', NULL, NULL, NULL, NULL, '', 239023),
(299970, 'PTHR31645:SF60', NULL, NULL, NULL, NULL, 'METAL-NICOTIANAMINE TRANSPORTER YSL2-LIKE ISOFORM X1', 239023),
(299971, 'PTHR31645:SF83', NULL, NULL, NULL, NULL, 'METAL-NICOTIANAMINE TRANSPORTER YSL1-RELATED', 239023);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(299972, 'PTHR31645:SF62', NULL, NULL, NULL, NULL, 'METAL-NICOTIANAMINE TRANSPORTER YSL5-RELATED', 239023),
(299973, 'PTHR31645:SF84', NULL, NULL, NULL, NULL, '', 239023),
(299974, 'PTHR31645', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORTER YGL114W-RELATED', 239023),
(299975, 'PTHR31645:SF63', NULL, NULL, NULL, NULL, 'METAL-NICOTIANAMINE TRANSPORTER YSL4-RELATED', 239023),
(299976, 'PTHR31645:SF85', NULL, NULL, NULL, NULL, '', 239023),
(299977, 'PTHR31645:SF41', NULL, NULL, NULL, NULL, 'METAL-NICOTIANAMINE TRANSPORTER YSL14-RELATED', 239023),
(299978, 'PTHR31645:SF80', NULL, NULL, NULL, NULL, 'METAL-NICOTIANAMINE TRANSPORTER YSL12-RELATED', 239023),
(299979, 'PTHR31645:SF81', NULL, NULL, NULL, NULL, 'METAL-NICOTIANAMINE TRANSPORTER YSL7-RELATED', 239023),
(299980, 'PTHR31645:SF68', NULL, NULL, NULL, NULL, 'BNAA03G46460D PROTEIN', 239023),
(299981, 'PTHR31645:SF69', NULL, NULL, NULL, NULL, 'BNAC03G75010D PROTEIN', 239023),
(299982, 'PTHR31645:SF48', NULL, NULL, NULL, NULL, 'METAL-NICOTIANAMINE TRANSPORTER YSL17-RELATED', 239023),
(299983, 'PTHR31645:SF49', NULL, NULL, NULL, NULL, 'METAL-NICOTIANAMINE TRANSPORTER YSL2', 239023),
(299984, 'PTHR31645:SF86', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE-RELATED', 239023),
(299985, 'PTHR31645:SF20', NULL, NULL, NULL, NULL, 'METAL-NICOTIANAMINE TRANSPORTER YSL7-RELATED', 239023),
(299986, 'PTHR31645:SF64', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORTER, OPT SUPERFAMILY-RELATED', 239023),
(299987, 'PTHR31645:SF0', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORTER YGL114W-RELATED', 239023),
(299988, 'PTHR31645:SF44', NULL, NULL, NULL, NULL, 'METAL-NICOTIANAMINE TRANSPORTER YSL2', 239023),
(299989, 'PTHR31645:SF66', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORTER, OPT SUPERFAMILY-RELATED', 239023),
(299990, 'PTHR31645:SF22', NULL, NULL, NULL, NULL, 'METAL-NICOTIANAMINE TRANSPORTER YSL7-RELATED', 239023),
(299991, 'PTHR31645:SF67', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORTER OPT FAMILY', 239023),
(299992, 'PTHR31645:SF71', NULL, NULL, NULL, NULL, 'BNACNNG45400D PROTEIN', 239023),
(299993, 'PTHR31645:SF4', NULL, NULL, NULL, NULL, 'METAL-NICOTIANAMINE TRANSPORTER YSL3', 239023),
(299994, 'PTHR31645:SF3', NULL, NULL, NULL, NULL, '', 239023),
(299995, 'PTHR31645:SF51', NULL, NULL, NULL, NULL, 'YELLOW STRIPE-LIKE 9 TRANSPORTER', 239023),
(299996, 'PTHR31645:SF74', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE-RELATED', 239023),
(299997, 'PTHR31645:SF9', NULL, NULL, NULL, NULL, 'METAL-NICOTIANAMINE TRANSPORTER YSL4-RELATED', 239023),
(299998, 'PTHR31645:SF7', NULL, NULL, NULL, NULL, 'METAL-NICOTIANAMINE TRANSPORTER YSL2', 239023),
(299999, 'PTHR31645:SF6', NULL, NULL, NULL, NULL, 'METAL-NICOTIANAMINE TRANSPORTER YSL13-RELATED', 239023),
(300000, 'PTHR31645:SF70', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORTER, OPT SUPERFAMILY-RELATED', 239023),
(300001, 'PTHR47429', NULL, NULL, NULL, NULL, 'PROTEIN TWIN LOV 1', 239024),
(300002, 'PTHR47429:SF4', NULL, NULL, NULL, NULL, 'PROTEIN TWIN LOV 1-LIKE', 239024),
(300003, 'PTHR47429:SF8', NULL, NULL, NULL, NULL, 'PHOTOTROPIN-1-LIKE', 239024),
(300004, 'PTHR47429:SF7', NULL, NULL, NULL, NULL, 'GATA-FACTOR', 239024),
(300005, 'PTHR47429:SF2', NULL, NULL, NULL, NULL, 'PROTEIN TWIN LOV 1', 239024),
(300006, 'PTHR42070', NULL, NULL, NULL, NULL, 'FILAMENT ASSOCIATED PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G06630)-RELATED', 239025),
(300007, 'PTHR42070:SF1', NULL, NULL, NULL, NULL, 'FILAMENT ASSOCIATED PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G06630)-RELATED', 239025),
(300008, 'PTHR45728:SF2', NULL, NULL, NULL, NULL, 'ACETYL-COA CARBOXYLASE', 239026),
(300009, 'PTHR45728:SF1', NULL, NULL, NULL, NULL, 'ACETYL-COA CARBOXYLASE 2', 239026),
(300010, 'PTHR45728:SF5', NULL, NULL, NULL, NULL, 'ACETYL-COA CARBOXYLASE 1', 239026),
(300011, 'PTHR45728:SF4', NULL, NULL, NULL, NULL, 'ACETYL-COA CARBOXYLASE 2', 239026),
(300012, 'PTHR45728:SF3', NULL, NULL, NULL, NULL, 'ACETYL-COA CARBOXYLASE', 239026),
(300013, 'PTHR45728', NULL, NULL, NULL, NULL, 'ACETYL-COA CARBOXYLASE, ISOFORM A', 239026),
(300014, 'PTHR45728:SF7', NULL, NULL, NULL, NULL, 'ACETYL-COA CARBOXYLASE', 239026);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(300015, 'PTHR16631:SF16', NULL, NULL, NULL, NULL, 'GPI-ANCHORED CELL WALL BETA-1,3-ENDOGLUCANASE EGLC', 239027),
(300016, 'PTHR16631:SF26', NULL, NULL, NULL, NULL, 'GLUCAN 1,3-BETA-GLUCOSIDASE', 239027),
(300017, 'PTHR16631:SF17', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE BTGC', 239027),
(300018, 'PTHR16631:SF14', NULL, NULL, NULL, NULL, 'FAMILY 17 GLUCOSIDASE SCW10-RELATED', 239027),
(300019, 'PTHR16631:SF13', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE EGLC-RELATED', 239027),
(300020, 'PTHR16631:SF24', NULL, NULL, NULL, NULL, 'FAMILY 17 GLUCOSIDASE SCW11-RELATED', 239027),
(300021, 'PTHR16631', NULL, NULL, NULL, NULL, 'GLUCAN 1,3-BETA-GLUCOSIDASE', 239027),
(300022, 'PTHR34196:SF8', NULL, NULL, NULL, NULL, 'BNACNNG50020D PROTEIN', 239028),
(300023, 'PTHR34196', NULL, NULL, NULL, NULL, 'OS02G0697700 PROTEIN', 239028),
(300024, 'PTHR34196:SF6', NULL, NULL, NULL, NULL, 'BNAA05G16500D PROTEIN', 239028),
(300025, 'PTHR34196:SF7', NULL, NULL, NULL, NULL, 'BNAA06G34420D PROTEIN', 239028),
(300026, 'PTHR34196:SF4', NULL, NULL, NULL, NULL, 'BNAC09G20880D PROTEIN', 239028),
(300027, 'PTHR34196:SF5', NULL, NULL, NULL, NULL, 'BNAA05G08450D PROTEIN', 239028),
(300028, 'PTHR34196:SF10', NULL, NULL, NULL, NULL, '', 239028),
(300029, 'PTHR34196:SF2', NULL, NULL, NULL, NULL, 'OS02G0697700 PROTEIN', 239028),
(300030, 'PTHR34196:SF3', NULL, NULL, NULL, NULL, '', 239028),
(300031, 'PTHR46222:SF1', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP14', 239029),
(300032, 'PTHR46222:SF2', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP7', 239029),
(300033, 'PTHR46222:SF3', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 239029),
(300034, 'PTHR46222', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP7/14', 239029),
(300035, 'PTHR14928', NULL, NULL, NULL, NULL, 'MICRO-RNA BINDING ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 7', 239030),
(300036, 'PTHR14928:SF6', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 7B', 239030),
(300037, 'PTHR14928:SF13', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 7A', 239030),
(300038, 'PTHR14928:SF14', NULL, NULL, NULL, NULL, 'C3H1-TYPE DOMAIN-CONTAINING PROTEIN', 239030),
(300039, 'PTHR14928:SF15', NULL, NULL, NULL, NULL, 'ACETAZOLAMIDE CONFERRING RESISTANCE PROTEIN ZAM', 239030),
(300040, 'PTHR23015:SF4', NULL, NULL, NULL, NULL, 'F-BOX A PROTEIN-RELATED', 239031),
(300041, 'PTHR23015:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG17911', 239031),
(300042, 'PTHR23015:SF11', NULL, NULL, NULL, NULL, 'FTH DOMAIN-CONTAINING PROTEIN', 239031),
(300043, 'PTHR23015:SF25', NULL, NULL, NULL, NULL, 'F-BOX A PROTEIN-RELATED', 239031),
(300044, 'PTHR23015:SF24', NULL, NULL, NULL, NULL, 'FTH DOMAIN-CONTAINING PROTEIN', 239031),
(300045, 'PTHR23015:SF26', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239031),
(300046, 'PTHR23015', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED C.ELEGANS PROTEIN', 239031),
(300047, 'PTHR22779', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239032),
(300048, 'PTHR22779:SF6', NULL, NULL, NULL, NULL, 'SD17342P', 239032),
(300049, 'PTHR22779:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 170A', 239032),
(300050, 'PTHR22779:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 170B', 239032),
(300051, 'PTHR40700:SF1', NULL, NULL, NULL, NULL, 'HYPOTHETICAL MEMBRANE PROTEIN, CONSERVED, DUF63 FAMILY', 239033),
(300052, 'PTHR40700', NULL, NULL, NULL, NULL, 'HYPOTHETICAL MEMBRANE PROTEIN, CONSERVED, DUF63 FAMILY', 239033),
(300053, 'PTHR11486:SF83', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR 2', 239034),
(300054, 'PTHR11486:SF41', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR 22', 239034),
(300055, 'PTHR11486:SF20', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR 7', 239034),
(300056, 'PTHR11486:SF86', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR 1', 239034),
(300057, 'PTHR11486:SF81', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR 21', 239034),
(300058, 'PTHR11486:SF25', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR 6', 239034); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(300059, 'PTHR11486:SF69', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR 23', 239034),
(300060, 'PTHR11486:SF26', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR 3', 239034),
(300061, 'PTHR11486:SF27', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR 16', 239034),
(300062, 'PTHR11486:SF28', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR 9', 239034),
(300063, 'PTHR11486:SF21', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR 10', 239034),
(300064, 'PTHR11486:SF23', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR 5', 239034),
(300065, 'PTHR11486:SF67', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR 11', 239034),
(300066, 'PTHR11486:SF140', NULL, NULL, NULL, NULL, 'EGL-17', 239034),
(300067, 'PTHR11486:SF143', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR 8B', 239034),
(300068, 'PTHR11486:SF142', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR', 239034),
(300069, 'PTHR11486:SF149', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR', 239034),
(300070, 'PTHR11486:SF148', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR', 239034),
(300071, 'PTHR11486:SF72', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR 20', 239034),
(300072, 'PTHR11486:SF30', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR', 239034),
(300073, 'PTHR11486:SF74', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR 19', 239034),
(300074, 'PTHR11486:SF31', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR 4', 239034),
(300075, 'PTHR11486:SF4', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR 18', 239034),
(300076, 'PTHR11486:SF3', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR 8', 239034),
(300077, 'PTHR11486:SF71', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR 17', 239034),
(300078, 'PTHR11486:SF17', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR 12', 239034),
(300079, 'PTHR11486:SF77', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR 13', 239034),
(300080, 'PTHR11486:SF150', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR', 239034),
(300081, 'PTHR11486:SF152', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR', 239034),
(300082, 'PTHR11486:SF18', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR 14', 239034),
(300083, 'PTHR11486:SF151', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR', 239034),
(300084, 'PTHR11486:SF154', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR', 239034),
(300085, 'PTHR11486:SF153', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR 21', 239034),
(300086, 'PTHR11486', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR', 239034),
(300087, 'PTHR11486:SF155', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR', 239034),
(300088, 'PTHR37442:SF2', NULL, NULL, NULL, NULL, 'CHONDROITIN PROTEOGLYCAN 4', 239035),
(300089, 'PTHR37442:SF1', NULL, NULL, NULL, NULL, 'CPG4 DOMAIN-CONTAINING PROTEIN', 239035),
(300090, 'PTHR37442', NULL, NULL, NULL, NULL, 'F18A1.7 PROTEIN-RELATED', 239035),
(300091, 'PTHR14880', NULL, NULL, NULL, NULL, 'PROLINE AND SERINE-RICH PROTEIN 1', 239036),
(300092, 'PTHR14880:SF2', NULL, NULL, NULL, NULL, 'PROLINE AND SERINE-RICH PROTEIN 1', 239036),
(300093, 'PTHR45873:SF1', NULL, NULL, NULL, NULL, 'DNA POLYMERASE ETA', 239037),
(300094, 'PTHR45873:SF5', NULL, NULL, NULL, NULL, 'UMUC DOMAIN-CONTAINING PROTEIN', 239037),
(300095, 'PTHR45873:SF4', NULL, NULL, NULL, NULL, 'IMS_C DOMAIN-CONTAINING PROTEIN', 239037),
(300096, 'PTHR45873', NULL, NULL, NULL, NULL, 'DNA POLYMERASE ETA', 239037),
(300097, 'PTHR43039:SF11', NULL, NULL, NULL, NULL, 'OS05G0590300 PROTEIN', 239038),
(300098, 'PTHR43039', NULL, NULL, NULL, NULL, 'ESTERASE-RELATED', 239038),
(300099, 'PTHR43039:SF23', NULL, NULL, NULL, NULL, 'OS01G0595600 PROTEIN', 239038),
(300100, 'PTHR43039:SF12', NULL, NULL, NULL, NULL, 'ESTERASE D14L-RELATED', 239038),
(300101, 'PTHR43039:SF24', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 239038),
(300102, 'PTHR43039:SF25', NULL, NULL, NULL, NULL, 'ALPHA/BETA HYDROLASE-RELATED', 239038),
(300103, 'PTHR43039:SF14', NULL, NULL, NULL, NULL, 'ESTERASE KAI2-RELATED', 239038),
(300104, 'PTHR43039:SF1', NULL, NULL, NULL, NULL, 'SIGMA FACTOR SIGB REGULATION PROTEIN RSBQ', 239038);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(300105, 'PTHR43039:SF20', NULL, NULL, NULL, NULL, 'SIGMA FACTOR SIGB REGULATION RSBQ-LIKE PROTEIN', 239038),
(300106, 'PTHR43039:SF3', NULL, NULL, NULL, NULL, 'ESTERASE KAI2-RELATED', 239038),
(300107, 'PTHR43039:SF10', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 239038),
(300108, 'PTHR43039:SF15', NULL, NULL, NULL, NULL, 'ESTERASE KAI2-RELATED', 239038),
(300109, 'PTHR43039:SF16', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 239038),
(300110, 'PTHR43039:SF17', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 239038),
(300111, 'PTHR43039:SF18', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 239038),
(300112, 'PTHR43039:SF4', NULL, NULL, NULL, NULL, 'STRIGOLACTONE ESTERASE D14', 239038),
(300113, 'PTHR43039:SF7', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 239038),
(300114, 'PTHR47009:SF4', NULL, NULL, NULL, NULL, 'GENE 12169-RELATED', 239039),
(300115, 'PTHR47009', NULL, NULL, NULL, NULL, 'HEPATITIS A VIRUS CELLULAR RECEPTOR 1 HOMOLOG', 239039),
(300116, 'PTHR47009:SF1', NULL, NULL, NULL, NULL, 'HEPATITIS A VIRUS CELLULAR RECEPTOR 1', 239039),
(300117, 'PTHR47009:SF10', NULL, NULL, NULL, NULL, 'T-CELL IMMUNOGLOBULIN AND MUCIN DOMAIN-CONTAINING PROTEIN 2', 239039),
(300118, 'PTHR47009:SF9', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 239039),
(300119, 'PTHR47009:SF8', NULL, NULL, NULL, NULL, 'HEPATITIS A VIRUS CELLULAR RECEPTOR 1 HOMOLOG', 239039),
(300120, 'PTHR47009:SF5', NULL, NULL, NULL, NULL, 'DPPA1', 239039),
(300121, 'PTHR38019', NULL, NULL, NULL, NULL, 'KDA ANTIGEN P200, PUTATIVE-RELATED', 239040),
(300122, 'PTHR38019:SF1', NULL, NULL, NULL, NULL, 'KDA ANTIGEN P200, PUTATIVE-RELATED', 239040),
(300123, 'PTHR37327:SF1', NULL, NULL, NULL, NULL, 'MIT DOMAIN-CONTAINING PROTEIN', 239041),
(300124, 'PTHR37327', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 239041),
(300125, 'PTHR43675:SF1', NULL, NULL, NULL, NULL, 'RIKEN CDNA 2700097O09 GENE', 239042),
(300126, 'PTHR43675', NULL, NULL, NULL, NULL, 'ARSENITE METHYLTRANSFERASE', 239042),
(300127, 'PTHR43675:SF30', NULL, NULL, NULL, NULL, 'CYCLOPROPANE-FATTY-ACYL-PHOSPHOLIPID SYNTHASE', 239042),
(300128, 'PTHR43675:SF10', NULL, NULL, NULL, NULL, 'CYCLOPROPANE FATTY ACID SYNTHASE', 239042),
(300129, 'PTHR43675:SF32', NULL, NULL, NULL, NULL, '', 239042),
(300130, 'PTHR43675:SF31', NULL, NULL, NULL, NULL, '', 239042),
(300131, 'PTHR43675:SF12', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 239042),
(300132, 'PTHR43675:SF23', NULL, NULL, NULL, NULL, 'AMINO_OXIDASE DOMAIN-CONTAINING PROTEIN', 239042),
(300133, 'PTHR43675:SF11', NULL, NULL, NULL, NULL, 'CYCLOPROPANE-FATTY-ACYL-PHOSPHOLIPID SYNTHASE', 239042),
(300134, 'PTHR43675:SF14', NULL, NULL, NULL, NULL, '2-HEPTAPRENYL-1,4-NAPHTHOQUINONE METHYLTRANSFERASE', 239042),
(300135, 'PTHR43675:SF25', NULL, NULL, NULL, NULL, 'TUBERCULOSTEARIC ACID METHYLTRANSFERASE UFAA1-LIKE', 239042),
(300136, 'PTHR43675:SF13', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 239042),
(300137, 'PTHR43675:SF7', NULL, NULL, NULL, NULL, 'ZGC:153372', 239042),
(300138, 'PTHR43675:SF8', NULL, NULL, NULL, NULL, 'ARSENITE METHYLTRANSFERASE', 239042),
(300139, 'PTHR43675:SF27', NULL, NULL, NULL, NULL, 'FAD/NAD(P)-BINDING DOMAIN, S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASE-RELATED', 239042),
(300140, 'PTHR43675:SF16', NULL, NULL, NULL, NULL, 'AMINO_OXIDASE DOMAIN-CONTAINING PROTEIN', 239042),
(300141, 'PTHR43675:SF9', NULL, NULL, NULL, NULL, 'ARSENITE METHYLTRANSFERASE', 239042),
(300142, 'PTHR43675:SF15', NULL, NULL, NULL, NULL, 'CYCLOPROPANE-FATTY-ACYL-PHOSPHOLIPID SYNTHASE', 239042),
(300143, 'PTHR43675:SF29', NULL, NULL, NULL, NULL, 'TUBERCULOSTEARIC ACID METHYLTRANSFERASE UFAA1-LIKE ISOFORM X1', 239042),
(300144, 'PTHR43675:SF28', NULL, NULL, NULL, NULL, 'AMINO_OXIDASE DOMAIN-CONTAINING PROTEIN', 239042),
(300145, 'PTHR43675:SF17', NULL, NULL, NULL, NULL, 'CYCLOPROPANE-FATTY-ACYL-PHOSPHOLIPID SYNTHASE', 239042),
(300146, 'PTHR43675:SF19', NULL, NULL, NULL, NULL, 'AMINO_OXIDASE DOMAIN-CONTAINING PROTEIN', 239042);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(300147, 'PTHR16039:SF1', NULL, NULL, NULL, NULL, 'HAUS AUGMIN-LIKE COMPLEX SUBUNIT 2', 239043),
(300148, 'PTHR16039', NULL, NULL, NULL, NULL, 'HAUS AUGMIN-LIKE COMPLEX SUBUNIT 2', 239043),
(300149, 'PTHR12415:SF4', NULL, NULL, NULL, NULL, 'TYROSYL-DNA PHOSPHODIESTERASE DOMAIN-CONTAINING PROTEIN', 239044),
(300150, 'PTHR12415', NULL, NULL, NULL, NULL, 'TYROSYL-DNA PHOSPHODIESTERASE 1', 239044),
(300151, 'PTHR12415:SF0', NULL, NULL, NULL, NULL, 'TYROSYL-DNA PHOSPHODIESTERASE 1', 239044),
(300152, 'PTHR12415:SF3', NULL, NULL, NULL, NULL, 'OS04G0403400 PROTEIN', 239044),
(300153, 'PTHR46619:SF5', NULL, NULL, NULL, NULL, 'XS DOMAIN-CONTAINING PROTEIN', 239045),
(300154, 'PTHR46619:SF4', NULL, NULL, NULL, NULL, 'XS DOMAIN-CONTAINING PROTEIN', 239045),
(300155, 'PTHR46619:SF3', NULL, NULL, NULL, NULL, 'RNA RECOGNITION MOTIF XS DOMAIN PROTEIN', 239045),
(300156, 'PTHR46619:SF2', NULL, NULL, NULL, NULL, 'XS DOMAIN-CONTAINING PROTEIN', 239045),
(300157, 'PTHR46619:SF1', NULL, NULL, NULL, NULL, 'XS DOMAIN CONTAINING PROTEIN EXPRESSED', 239045),
(300158, 'PTHR46619', NULL, NULL, NULL, NULL, 'RNA RECOGNITION MOTIF XS DOMAIN PROTEIN-RELATED', 239045),
(300159, 'PTHR21234:SF43', NULL, NULL, NULL, NULL, 'OS06G0112100 PROTEIN', 239046),
(300160, 'PTHR21234:SF44', NULL, NULL, NULL, NULL, 'PNP_UDP_1 DOMAIN-CONTAINING PROTEIN', 239046),
(300161, 'PTHR21234:SF41', NULL, NULL, NULL, NULL, 'PNP_UDP_1 DOMAIN-CONTAINING PROTEIN', 239046),
(300162, 'PTHR21234:SF30', NULL, NULL, NULL, NULL, 'PHOSPHORYLASE SUPERFAMILY PROTEIN', 239046),
(300163, 'PTHR21234:SF42', NULL, NULL, NULL, NULL, 'PHOSPHORYLASE SUPERFAMILY PROTEIN', 239046),
(300164, 'PTHR21234:SF47', NULL, NULL, NULL, NULL, 'NUCLEOSIDE PHOSPHORYLASE-RELATED', 239046),
(300165, 'PTHR21234:SF45', NULL, NULL, NULL, NULL, 'PNP_UDP_1 DOMAIN-CONTAINING PROTEIN', 239046),
(300166, 'PTHR21234:SF46', NULL, NULL, NULL, NULL, 'PNP_UDP_1 DOMAIN-CONTAINING PROTEIN', 239046),
(300167, 'PTHR21234:SF19', NULL, NULL, NULL, NULL, 'BARK STORAGE-LIKE PROTEIN', 239046),
(300168, 'PTHR21234', NULL, NULL, NULL, NULL, 'PURINE NUCLEOSIDE PHOSPHORYLASE', 239046),
(300169, 'PTHR30514:SF20', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', 239047),
(300170, 'PTHR30514:SF10', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, RPIR FAMILY', 239047),
(300171, 'PTHR30514', NULL, NULL, NULL, NULL, 'GLUCOKINASE', 239047),
(300172, 'PTHR30514:SF9', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', 239047),
(300173, 'PTHR30514:SF19', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR GLVR', 239047),
(300174, 'PTHR30514:SF17', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR MURR', 239047),
(300175, 'PTHR30514:SF18', NULL, NULL, NULL, NULL, 'RPIR-FAMILY TRANSCRIPTIONAL REGULATOR', 239047),
(300176, 'PTHR30514:SF1', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR HEXR-RELATED', 239047),
(300177, 'PTHR10012:SF3', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A ACTIVATOR 1', 239048),
(300178, 'PTHR10012:SF1', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A ACTIVATOR 2-RELATED', 239048),
(300179, 'PTHR10012:SF7', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A ACTIVATOR 2', 239048),
(300180, 'PTHR10012:SF6', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A ACTIVATOR', 239048),
(300181, 'PTHR10012:SF5', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A ACTIVATOR 2', 239048),
(300182, 'PTHR10012', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT B', 239048),
(300183, 'PTHR10012:SF0', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A ACTIVATOR', 239048),
(300184, 'PTHR38936', NULL, NULL, NULL, NULL, 'TITIN-LIKE ISOFORM X2', 239049),
(300185, 'PTHR38936:SF2', NULL, NULL, NULL, NULL, '', 239049),
(300186, 'PTHR38936:SF1', NULL, NULL, NULL, NULL, '', 239049),
(300187, 'PTHR47961:SF13', NULL, NULL, NULL, NULL, 'SEC63 DOMAIN-CONTAINING PROTEIN', 239050),
(300188, 'PTHR47961:SF10', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE HEL308', 239050);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(300189, 'PTHR47961:SF1', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT HELICASE MJ1401-RELATED', 239050),
(300190, 'PTHR47961:SF11', NULL, NULL, NULL, NULL, '', 239050),
(300191, 'PTHR47961:SF12', NULL, NULL, NULL, NULL, 'HELICASE POLQ-LIKE', 239050),
(300192, 'PTHR47961:SF4', NULL, NULL, NULL, NULL, 'U5 SMALL NUCLEAR RIBONUCLEOPROTEIN HELICASE', 239050),
(300193, 'PTHR47961', NULL, NULL, NULL, NULL, 'DNA POLYMERASE THETA, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G05260)-RELATED', 239050),
(300194, 'PTHR47961:SF2', NULL, NULL, NULL, NULL, 'DEAD/DEAH BOX HELICASE FAMILY PROTEIN, EXPRESSED', 239050),
(300195, 'PTHR47961:SF3', NULL, NULL, NULL, NULL, 'ATP DEPENDENT DEAD-BOX HELICASE-RELATED', 239050),
(300196, 'PTHR47961:SF8', NULL, NULL, NULL, NULL, 'DEXH-BOX ATP-DEPENDENT RNA HELICASE DEXH15 CHLOROPLASTIC', 239050),
(300197, 'PTHR47961:SF6', NULL, NULL, NULL, NULL, 'DNA POLYMERASE THETA, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G05260)-RELATED', 239050),
(300198, 'PTHR47961:SF7', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE HFM1-RELATED', 239050),
(300199, 'PTHR10559', NULL, NULL, NULL, NULL, 'TRANSCOBALAMIN-1/GASTRIC INTRINSIC FACTOR', 239051),
(300200, 'PTHR10559:SF18', NULL, NULL, NULL, NULL, 'TRANSCOBALAMIN II', 239051),
(300201, 'PTHR10559:SF15', NULL, NULL, NULL, NULL, 'COBALAMIN BINDING INTRINSIC FACTOR', 239051),
(300202, 'PTHR10559:SF14', NULL, NULL, NULL, NULL, 'TRANSCOBALAMIN-2', 239051),
(300203, 'PTHR10559:SF13', NULL, NULL, NULL, NULL, 'TRANSCOBALAMIN-1', 239051),
(300204, 'PTHR13952:SF28', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 239052),
(300205, 'PTHR13952:SF27', NULL, NULL, NULL, NULL, 'RNA-BINDING MOTIF PROTEIN, X-LINKED-LIKE-3', 239052),
(300206, 'PTHR13952:SF19', NULL, NULL, NULL, NULL, 'GLYCINE-RICH RNA-BINDING PROTEIN 4, MITOCHONDRIAL ISOFORM X1', 239052),
(300207, 'PTHR13952:SF29', NULL, NULL, NULL, NULL, 'BNAC06G03980D PROTEIN', 239052),
(300208, 'PTHR13952:SF24', NULL, NULL, NULL, NULL, 'BNAC05G47680D PROTEIN', 239052),
(300209, 'PTHR13952:SF23', NULL, NULL, NULL, NULL, 'U11/U12 SMALL NUCLEAR RIBONUCLEOPROTEIN 35 KDA PROTEIN', 239052),
(300210, 'PTHR13952:SF15', NULL, NULL, NULL, NULL, 'BNAC02G41530D PROTEIN', 239052),
(300211, 'PTHR13952:SF9', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR CWC21-LIKE ISOFORM X1', 239052),
(300212, 'PTHR13952:SF11', NULL, NULL, NULL, NULL, 'RNA-BINDING MOTIF PROTEIN, X-LINKED-LIKE-2', 239052),
(300213, 'PTHR13952:SF22', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 239052),
(300214, 'PTHR13952:SF21', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDE ADENYLYLTRANSFERASE DOMAIN/RNA RECOGNITION MOTIF PROTEIN-RELATED', 239052),
(300215, 'PTHR13952:SF5', NULL, NULL, NULL, NULL, 'U1 SMALL NUCLEAR RIBONUCLEOPROTEIN 70 KDA', 239052),
(300216, 'PTHR13952:SF6', NULL, NULL, NULL, NULL, 'RNA-BINDING MOTIF PROTEIN 42', 239052),
(300217, 'PTHR13952', NULL, NULL, NULL, NULL, 'U1 SMALL NUCLEAR RIBONUCLEOPROTEIN 70 KD', 239052),
(300218, 'PTHR43774:SF1', NULL, NULL, NULL, NULL, 'PEPTIDE METHIONINE SULFOXIDE REDUCTASE MSRA 2', 239053),
(300219, 'PTHR43774', NULL, NULL, NULL, NULL, 'PEPTIDE METHIONINE SULFOXIDE REDUCTASE', 239053),
(300220, 'PTHR34769:SF1', NULL, NULL, NULL, NULL, 'RCG42593, ISOFORM CRA_A', 239054),
(300221, 'PTHR34769', NULL, NULL, NULL, NULL, 'RCG42593, ISOFORM CRA_A', 239054),
(300222, 'PTHR30111:SF1', NULL, NULL, NULL, NULL, '33 KDA CHAPERONIN', 239055),
(300223, 'PTHR30111', NULL, NULL, NULL, NULL, '33 KDA CHAPERONIN', 239055),
(300224, 'PTHR12611:SF6', NULL, NULL, NULL, NULL, 'BNAA03G53780D PROTEIN', 239056),
(300225, 'PTHR12611:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR PROTEIN PUR-ALPHA', 239056),
(300226, 'PTHR12611:SF3', NULL, NULL, NULL, NULL, 'PURINE-RICH ELEMENT-BINDING PROTEIN GAMMA', 239056),
(300227, 'PTHR12611', NULL, NULL, NULL, NULL, 'PUR-TRANSCRIPTIONAL ACTIVATOR', 239056),
(300228, 'PTHR12611:SF4', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR PROTEIN PUR-BETA', 239056),
(300229, 'PTHR12611:SF5', NULL, NULL, NULL, NULL, 'PURINE-RICH ELEMENT-BINDING PROTEIN AB', 239056),
(300230, 'PTHR12611:SF0', NULL, NULL, NULL, NULL, 'PURINE-RICH BINDING PROTEIN-ALPHA, ISOFORM B', 239056);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(300231, 'PTHR43017', NULL, NULL, NULL, NULL, 'GALACTOSIDE O-ACETYLTRANSFERASE', 239057),
(300232, 'PTHR43017:SF1', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE YJL218W-RELATED', 239057),
(300233, 'PTHR13605', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239058),
(300234, 'PTHR13605:SF4', NULL, NULL, NULL, NULL, 'ER MEMBRANE PROTEIN COMPLEX SUBUNIT 7', 239058),
(300235, 'PTHR13605:SF7', NULL, NULL, NULL, NULL, 'ER MEMBRANE PROTEIN COMPLEX SUBUNIT 7 HOMOLOG', 239058),
(300236, 'PTHR13605:SF8', NULL, NULL, NULL, NULL, 'DUF2012 DOMAIN-CONTAINING PROTEIN', 239058),
(300237, 'PTHR39653:SF2', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 22-1', 239059),
(300238, 'PTHR39653:SF4', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 20-1', 239059),
(300239, 'PTHR39653:SF6', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 20-2-RELATED', 239059),
(300240, 'PTHR39653', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 20-2', 239059),
(300241, 'PTHR39653:SF5', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1110057P08 GENE', 239059),
(300242, 'PTHR39653:SF8', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 20-2', 239059),
(300243, 'PTHR36033:SF1', NULL, NULL, NULL, NULL, 'NUCLEIC ACID-BINDING PROTEINS SUPERFAMILY', 239060),
(300244, 'PTHR36033', NULL, NULL, NULL, NULL, 'NUCLEIC ACID-BINDING PROTEINS SUPERFAMILY', 239060),
(300245, 'PTHR48047:SF49', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300246, 'PTHR48047:SF180', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 83A1', 239061),
(300247, 'PTHR48047:SF182', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300248, 'PTHR48047:SF181', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 73D1', 239061),
(300249, 'PTHR48047:SF173', NULL, NULL, NULL, NULL, 'TRANSFERASE, PUTATIVE, EXPRESSED-RELATED', 239061),
(300250, 'PTHR48047:SF172', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300251, 'PTHR48047:SF175', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 83A1-LIKE', 239061),
(300252, 'PTHR48047:SF174', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300253, 'PTHR48047:SF210', NULL, NULL, NULL, NULL, 'UDP-GLUCOSYLTRANSFERASE FAMILY PROTEIN', 239061),
(300254, 'PTHR48047:SF177', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300255, 'PTHR48047:SF176', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300256, 'PTHR48047:SF179', NULL, NULL, NULL, NULL, 'TRANSFERASE, PUTATIVE, EXPRESSED-RELATED', 239061),
(300257, 'PTHR48047:SF178', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300258, 'PTHR48047:SF211', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300259, 'PTHR48047:SF45', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300260, 'PTHR48047:SF43', NULL, NULL, NULL, NULL, 'OS09G0379400 PROTEIN', 239061),
(300261, 'PTHR48047:SF191', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300262, 'PTHR48047:SF190', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300263, 'PTHR48047:SF193', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300264, 'PTHR48047:SF192', NULL, NULL, NULL, NULL, 'TRANSFERASE, PUTATIVE, EXPRESSED-RELATED', 239061),
(300265, 'PTHR48047:SF184', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300266, 'PTHR48047:SF183', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300267, 'PTHR48047:SF186', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 73C2-LIKE', 239061),
(300268, 'PTHR48047:SF185', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300269, 'PTHR48047:SF188', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300270, 'PTHR48047:SF187', NULL, NULL, NULL, NULL, 'CROCETIN GLUCOSYLTRANSFERASE 3-LIKE', 239061),
(300271, 'PTHR48047:SF102', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300272, 'PTHR48047:SF101', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300273, 'PTHR48047:SF189', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 89B1', 239061),
(300274, 'PTHR48047:SF58', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300275, 'PTHR48047:SF56', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(300276, 'PTHR48047:SF105', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300277, 'PTHR48047:SF55', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300278, 'PTHR48047:SF53', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300279, 'PTHR48047:SF107', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300280, 'PTHR48047:SF52', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 89B1', 239061),
(300281, 'PTHR48047:SF51', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 90A1', 239061),
(300282, 'PTHR48047:SF160', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300283, 'PTHR48047:SF61', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300284, 'PTHR48047:SF150', NULL, NULL, NULL, NULL, 'SOLANIDINE UDP-GLUCOSE GLUCOSYLTRANSFERASE 1', 239061),
(300285, 'PTHR48047:SF60', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300286, 'PTHR48047:SF153', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300287, 'PTHR48047:SF152', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 87A1', 239061),
(300288, 'PTHR48047:SF157', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300289, 'PTHR48047:SF69', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300290, 'PTHR48047:SF159', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 73C4', 239061),
(300291, 'PTHR48047:SF68', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 73D1', 239061),
(300292, 'PTHR48047:SF158', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300293, 'PTHR48047:SF67', NULL, NULL, NULL, NULL, 'SUPERFAMILY PROTEIN, PUTATIVE-RELATED', 239061),
(300294, 'PTHR48047:SF66', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 73C5-RELATED', 239061),
(300295, 'PTHR48047:SF65', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300296, 'PTHR48047:SF64', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300297, 'PTHR48047:SF171', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300298, 'PTHR48047:SF170', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300299, 'PTHR48047:SF162', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300300, 'PTHR48047:SF161', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300301, 'PTHR48047:SF71', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 73D1', 239061),
(300302, 'PTHR48047:SF164', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300303, 'PTHR48047:SF163', NULL, NULL, NULL, NULL, 'LOW QUALITY PROTEIN: UDP-GLYCOSYLTRANSFERASE 83A1-LIKE', 239061),
(300304, 'PTHR48047:SF166', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300305, 'PTHR48047:SF165', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 83A1', 239061),
(300306, 'PTHR48047:SF201', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300307, 'PTHR48047:SF168', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300308, 'PTHR48047:SF200', NULL, NULL, NULL, NULL, 'OS06G0271000 PROTEIN', 239061),
(300309, 'PTHR48047:SF167', NULL, NULL, NULL, NULL, 'UDP-GLUCOSYLTRANSFERASE FAMILY PROTEIN', 239061),
(300310, 'PTHR48047:SF203', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 86A2', 239061),
(300311, 'PTHR48047:SF202', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 87A2', 239061),
(300312, 'PTHR48047:SF169', NULL, NULL, NULL, NULL, 'UDP-GLUCOSYLTRANSFERASE FAMILY PROTEIN', 239061),
(300313, 'PTHR48047:SF79', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300314, 'PTHR48047:SF205', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 73C2', 239061),
(300315, 'PTHR48047:SF78', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300316, 'PTHR48047:SF204', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300317, 'PTHR48047:SF77', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 73C7', 239061),
(300318, 'PTHR48047:SF207', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300319, 'PTHR48047:SF206', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300320, 'PTHR48047:SF209', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 89A2', 239061),
(300321, 'PTHR48047:SF208', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(300322, 'PTHR48047', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300323, 'PTHR48047:SF83', NULL, NULL, NULL, NULL, 'CYANOHYDRIN BETA-GLUCOSYLTRANSFERASE-RELATED', 239061),
(300324, 'PTHR48047:SF82', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300325, 'PTHR48047:SF81', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300326, 'PTHR48047:SF131', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300327, 'PTHR48047:SF135', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300328, 'PTHR48047:SF136', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYL/UDP-GLUCOSYLTRANSFERASE-RELATED', 239061),
(300329, 'PTHR48047:SF88', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 73C1', 239061),
(300330, 'PTHR48047:SF84', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300331, 'PTHR48047:SF19', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300332, 'PTHR48047:SF17', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 86A1-LIKE', 239061),
(300333, 'PTHR48047:SF142', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300334, 'PTHR48047:SF90', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300335, 'PTHR48047:SF143', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 73D1', 239061),
(300336, 'PTHR48047:SF147', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300337, 'PTHR48047:SF12', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 89A2-LIKE', 239061),
(300338, 'PTHR48047:SF11', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 73C3-RELATED', 239061),
(300339, 'PTHR48047:SF95', NULL, NULL, NULL, NULL, 'CYANOHYDRIN BETA-GLUCOSYLTRANSFERASE-RELATED', 239061),
(300340, 'PTHR48047:SF29', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300341, 'PTHR48047:SF28', NULL, NULL, NULL, NULL, 'F11M15.8 PROTEIN', 239061),
(300342, 'PTHR48047:SF195', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 82A1', 239061),
(300343, 'PTHR48047:SF194', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300344, 'PTHR48047:SF197', NULL, NULL, NULL, NULL, 'SCOPOLETIN GLUCOSYLTRANSFERASE-LIKE', 239061),
(300345, 'PTHR48047:SF196', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300346, 'PTHR48047:SF199', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300347, 'PTHR48047:SF198', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300348, 'PTHR48047:SF112', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300349, 'PTHR48047:SF25', NULL, NULL, NULL, NULL, 'OS02G0206400 PROTEIN', 239061),
(300350, 'PTHR48047:SF114', NULL, NULL, NULL, NULL, 'BNAANNG25400D PROTEIN', 239061),
(300351, 'PTHR48047:SF23', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 73C6-LIKE', 239061),
(300352, 'PTHR48047:SF117', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 90A2', 239061),
(300353, 'PTHR48047:SF116', NULL, NULL, NULL, NULL, 'UDP-GLUCOSYL TRANSFERASE 73C7-RELATED', 239061),
(300354, 'PTHR48047:SF22', NULL, NULL, NULL, NULL, '', 239061),
(300355, 'PTHR48047:SF21', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300356, 'PTHR48047:SF118', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE-RELATED', 239061),
(300357, 'PTHR48047:SF1', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300358, 'PTHR48047:SF39', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300359, 'PTHR48047:SF37', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300360, 'PTHR48047:SF8', NULL, NULL, NULL, NULL, 'FLAVONOL 3-O-GLUCOSYLTRANSFERASE UGT89B1', 239061),
(300361, 'PTHR48047:SF6', NULL, NULL, NULL, NULL, 'OS06G0282400 PROTEIN', 239061),
(300362, 'PTHR48047:SF7', NULL, NULL, NULL, NULL, 'UDP-GLUCOSYLTRANSFERASE FAMILY PROTEIN', 239061),
(300363, 'PTHR48047:SF4', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 86A1', 239061),
(300364, 'PTHR48047:SF5', NULL, NULL, NULL, NULL, 'FLAVONOL 7-O-RHAMNOSYLTRANSFERASE', 239061),
(300365, 'PTHR48047:SF123', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300366, 'PTHR48047:SF126', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300367, 'PTHR48047:SF127', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(300368, 'PTHR48047:SF129', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300369, 'PTHR48047:SF30', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239061),
(300370, 'PTHR12209', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 239062),
(300371, 'PTHR12209:SF3', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 239062),
(300372, 'PTHR12209:SF2', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 239062),
(300373, 'PTHR12209:SF0', NULL, NULL, NULL, NULL, 'EKC/KEOPS COMPLEX SUBUNIT TP53RK', 239062),
(300374, 'PTHR37533', NULL, NULL, NULL, NULL, 'FLAGELLAR HOOK-LENGTH CONTROL PROTEIN', 239063),
(300375, 'PTHR37533:SF2', NULL, NULL, NULL, NULL, 'FLAGELLAR HOOK-LENGTH CONTROL PROTEIN', 239063),
(300376, 'PTHR21074:SF0', NULL, NULL, NULL, NULL, 'IQ AND UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 239064),
(300377, 'PTHR21074', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239064),
(300378, 'PTHR47609:SF1', NULL, NULL, NULL, NULL, 'MICOS COMPLEX SUBUNIT MIC25', 239065),
(300379, 'PTHR47609', NULL, NULL, NULL, NULL, 'MICOS COMPLEX SUBUNIT MIC25', 239065),
(300380, 'PTHR12509:SF8', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 4', 239066),
(300381, 'PTHR12509:SF9', NULL, NULL, NULL, NULL, 'ZGC:66426', 239066),
(300382, 'PTHR12509', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED 4-RELATED', 239066),
(300383, 'PTHR12509:SF16', NULL, NULL, NULL, NULL, 'SPERM FLAGELLAR PROTEIN 1', 239066),
(300384, 'PTHR12509:SF14', NULL, NULL, NULL, NULL, 'SPERM FLAGELLAR 1-LIKE', 239066),
(300385, 'PTHR46426', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE TMX3', 239067),
(300386, 'PTHR46426:SF1', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE TMX3', 239067),
(300387, 'PTHR14152', NULL, NULL, NULL, NULL, 'SQUAMOUS CELL CARCINOMA ANTIGEN RECOGNISED BY CYTOTOXIC T LYMPHOCYTES', 239068),
(300388, 'PTHR14152:SF5', NULL, NULL, NULL, NULL, 'U4/U6.U5 TRI-SNRNP-ASSOCIATED PROTEIN 1', 239068),
(300389, 'PTHR14152:SF7', NULL, NULL, NULL, NULL, '', 239068),
(300390, 'PTHR14152:SF6', NULL, NULL, NULL, NULL, 'IGE AUTOANTIGEN', 239068),
(300391, 'PTHR16260:SF3', NULL, NULL, NULL, NULL, 'SIMILAR TO 1700123O20RIK PROTEIN', 239069),
(300392, 'PTHR16260', NULL, NULL, NULL, NULL, 'SIMILAR TO 1700123O20RIK PROTEIN', 239069),
(300393, 'PTHR16260:SF4', NULL, NULL, NULL, NULL, '', 239069),
(300394, 'PTHR16260:SF5', NULL, NULL, NULL, NULL, 'CHROMOSOME 14 C14ORF119 HOMOLOG', 239069),
(300395, 'PTHR13062', NULL, NULL, NULL, NULL, 'COLLAGENASE', 239070),
(300396, 'PTHR13062:SF12', NULL, NULL, NULL, NULL, 'PRE-PRO-METALLOPROTEASE PRTV', 239070),
(300397, 'PTHR13062:SF9', NULL, NULL, NULL, NULL, 'A2M DOMAIN-CONTAINING PROTEIN', 239070),
(300398, 'PTHR33184:SF59', NULL, NULL, NULL, NULL, 'BNAA01G34760D PROTEIN', 239071),
(300399, 'PTHR33184:SF36', NULL, NULL, NULL, NULL, '14_3_3 DOMAIN-CONTAINING PROTEIN', 239071),
(300400, 'PTHR33184:SF58', NULL, NULL, NULL, NULL, 'BNAA02G24090D PROTEIN', 239071),
(300401, 'PTHR33184:SF35', NULL, NULL, NULL, NULL, '', 239071),
(300402, 'PTHR33184:SF57', NULL, NULL, NULL, NULL, 'BNAA02G24050D PROTEIN', 239071),
(300403, 'PTHR33184:SF39', NULL, NULL, NULL, NULL, '', 239071),
(300404, 'PTHR33184:SF52', NULL, NULL, NULL, NULL, '', 239071),
(300405, 'PTHR33184:SF74', NULL, NULL, NULL, NULL, 'BNAA02G24080D PROTEIN', 239071),
(300406, 'PTHR33184:SF51', NULL, NULL, NULL, NULL, 'BETA-1,3-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 239071),
(300407, 'PTHR33184:SF73', NULL, NULL, NULL, NULL, '', 239071),
(300408, 'PTHR33184:SF50', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 239071),
(300409, 'PTHR33184:SF72', NULL, NULL, NULL, NULL, 'BETA-1,3-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 239071),
(300410, 'PTHR33184:SF71', NULL, NULL, NULL, NULL, '', 239071),
(300411, 'PTHR33184:SF56', NULL, NULL, NULL, NULL, '', 239071),
(300412, 'PTHR33184:SF34', NULL, NULL, NULL, NULL, 'TPD1 PROTEIN HOMOLOG 1-LIKE', 239071),
(300413, 'PTHR33184:SF33', NULL, NULL, NULL, NULL, '', 239071),
(300414, 'PTHR33184:SF11', NULL, NULL, NULL, NULL, 'BETA-1,3-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 239071);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(300415, 'PTHR33184:SF77', NULL, NULL, NULL, NULL, '', 239071),
(300416, 'PTHR33184:SF32', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239071),
(300417, 'PTHR33184:SF76', NULL, NULL, NULL, NULL, 'TAPETUM DETERMINANT PROTEIN', 239071),
(300418, 'PTHR33184:SF54', NULL, NULL, NULL, NULL, '', 239071),
(300419, 'PTHR33184:SF75', NULL, NULL, NULL, NULL, 'TPD1 PROTEIN HOMOLOG 1B', 239071),
(300420, 'PTHR33184:SF27', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 239071),
(300421, 'PTHR33184:SF69', NULL, NULL, NULL, NULL, '', 239071),
(300422, 'PTHR33184:SF46', NULL, NULL, NULL, NULL, '', 239071),
(300423, 'PTHR33184', NULL, NULL, NULL, NULL, 'PROTEIN TAPETUM DETERMINANT 1-LIKE-RELATED', 239071),
(300424, 'PTHR33184:SF28', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239071),
(300425, 'PTHR33184:SF5', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 239071),
(300426, 'PTHR33184:SF2', NULL, NULL, NULL, NULL, 'PROTEIN TAPETUM DETERMINANT 1-LIKE', 239071),
(300427, 'PTHR33184:SF41', NULL, NULL, NULL, NULL, '', 239071),
(300428, 'PTHR33184:SF63', NULL, NULL, NULL, NULL, 'BNAA01G34870D PROTEIN', 239071),
(300429, 'PTHR33184:SF62', NULL, NULL, NULL, NULL, '', 239071),
(300430, 'PTHR33184:SF61', NULL, NULL, NULL, NULL, 'TPD1 PROTEIN HOMOLOG 1', 239071),
(300431, 'PTHR33184:SF60', NULL, NULL, NULL, NULL, 'BNAA03G51920D PROTEIN', 239071),
(300432, 'PTHR33184:SF45', NULL, NULL, NULL, NULL, 'PROTEIN TAPETUM DETERMINANT 1', 239071),
(300433, 'PTHR33184:SF67', NULL, NULL, NULL, NULL, 'PROTEIN TAPETUM DETERMINANT 1', 239071),
(300434, 'PTHR33184:SF43', NULL, NULL, NULL, NULL, '', 239071),
(300435, 'PTHR33184:SF42', NULL, NULL, NULL, NULL, '', 239071),
(300436, 'PTHR33184:SF64', NULL, NULL, NULL, NULL, 'BETA-1,3-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 239071),
(300437, 'PTHR12902:SF1', NULL, NULL, NULL, NULL, 'WISKOTT-ALDRICH SYNDROME PROTEIN FAMILY MEMBER', 239072),
(300438, 'PTHR12902:SF29', NULL, NULL, NULL, NULL, 'SCAR-LIKE DOMAIN-CONTAINING PROTEIN WAVE 5', 239072),
(300439, 'PTHR12902:SF6', NULL, NULL, NULL, NULL, 'WISKOTT-ALDRICH SYNDROME PROTEIN FAMILY MEMBER 2', 239072),
(300440, 'PTHR12902:SF7', NULL, NULL, NULL, NULL, 'WISKOTT-ALDRICH SYNDROME PROTEIN FAMILY MEMBER 3', 239072),
(300441, 'PTHR12902:SF8', NULL, NULL, NULL, NULL, 'WISKOTT-ALDRICH SYNDROME PROTEIN FAMILY MEMBER 1', 239072),
(300442, 'PTHR12902:SF11', NULL, NULL, NULL, NULL, 'WISKOTT-ALDRICH SYNDROME PROTEIN FAMILY MEMBER', 239072),
(300443, 'PTHR12902:SF33', NULL, NULL, NULL, NULL, 'PROTEIN SCAR3', 239072),
(300444, 'PTHR12902:SF9', NULL, NULL, NULL, NULL, 'WISKOTT-ALDRICH SYNDROME PROTEIN FAMILY MEMBER', 239072),
(300445, 'PTHR12902:SF32', NULL, NULL, NULL, NULL, 'PROTEIN SCAR4', 239072),
(300446, 'PTHR12902:SF10', NULL, NULL, NULL, NULL, 'PROTEIN SCAR', 239072),
(300447, 'PTHR12902:SF35', NULL, NULL, NULL, NULL, 'PROTEIN SCAR', 239072),
(300448, 'PTHR12902:SF23', NULL, NULL, NULL, NULL, 'WISKOTT-ALDRICH SYNDROME PROTEIN FAMILY MEMBER', 239072),
(300449, 'PTHR12902:SF26', NULL, NULL, NULL, NULL, 'PROTEIN SCAR', 239072),
(300450, 'PTHR12902:SF37', NULL, NULL, NULL, NULL, 'WH2 MOTIF FAMILY PROTEIN', 239072),
(300451, 'PTHR12902:SF36', NULL, NULL, NULL, NULL, 'PROTEIN SCAR1', 239072),
(300452, 'PTHR12902', NULL, NULL, NULL, NULL, 'WASP-1', 239072),
(300453, 'PTHR12902:SF31', NULL, NULL, NULL, NULL, 'PROTEIN SCAR', 239072),
(300454, 'PTHR11972:SF146', NULL, NULL, NULL, NULL, 'FAD-BINDING FR-TYPE DOMAIN-CONTAINING PROTEIN', 239073),
(300455, 'PTHR11972:SF148', NULL, NULL, NULL, NULL, 'FERRIC REDUCTION OXIDASE 3, MITOCHONDRIAL-RELATED', 239073),
(300456, 'PTHR11972:SF143', NULL, NULL, NULL, NULL, 'NOX1', 239073),
(300457, 'PTHR11972:SF142', NULL, NULL, NULL, NULL, 'FAD-BINDING FR-TYPE DOMAIN-CONTAINING PROTEIN', 239073),
(300458, 'PTHR11972:SF145', NULL, NULL, NULL, NULL, 'RESPIRATORY BURST OXIDASE-LIKE PROTEIN D', 239073),
(300459, 'PTHR11972:SF189', NULL, NULL, NULL, NULL, 'RESPIRATORY BURST OXIDASE HOMOLOG PROTEIN C', 239073),
(300460, 'PTHR11972:SF185', NULL, NULL, NULL, NULL, 'NAD(P)H OXIDASE (H(2)O(2)-FORMING)', 239073),
(300461, 'PTHR11972:SF141', NULL, NULL, NULL, NULL, '', 239073);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(300462, 'PTHR11972:SF60', NULL, NULL, NULL, NULL, 'CYTOCHROME B-245 HEAVY CHAIN', 239073),
(300463, 'PTHR11972:SF61', NULL, NULL, NULL, NULL, 'OS12G0541300 PROTEIN', 239073),
(300464, 'PTHR11972:SF64', NULL, NULL, NULL, NULL, 'RESPIRATORY BURST OXIDASE HOMOLOG PROTEIN B', 239073),
(300465, 'PTHR11972:SF67', NULL, NULL, NULL, NULL, 'DUAL OXIDASE 2', 239073),
(300466, 'PTHR11972:SF69', NULL, NULL, NULL, NULL, 'FERRIC REDUCTION OXIDASE 6-RELATED', 239073),
(300467, 'PTHR11972:SF135', NULL, NULL, NULL, NULL, '', 239073),
(300468, 'PTHR11972:SF137', NULL, NULL, NULL, NULL, 'RESPIRATORY BURST OXIDASE HOMOLOG PROTEIN H-RELATED', 239073),
(300469, 'PTHR11972:SF175', NULL, NULL, NULL, NULL, 'DUAL OXIDASE', 239073),
(300470, 'PTHR11972:SF178', NULL, NULL, NULL, NULL, 'FERRIC REDUCTASE TRANSMEMBRANE COMPONENT 8-RELATED', 239073),
(300471, 'PTHR11972:SF133', NULL, NULL, NULL, NULL, 'OS05G0465800 PROTEIN', 239073),
(300472, 'PTHR11972:SF172', NULL, NULL, NULL, NULL, 'RESPIRATORY BURST OXIDASE-RELATED', 239073),
(300473, 'PTHR11972:SF171', NULL, NULL, NULL, NULL, 'FAD-BINDING FR-TYPE DOMAIN-CONTAINING PROTEIN', 239073),
(300474, 'PTHR11972:SF174', NULL, NULL, NULL, NULL, 'BNAA03G47130D PROTEIN', 239073),
(300475, 'PTHR11972:SF54', NULL, NULL, NULL, NULL, 'RESPIRATORY BURST OXIDASE HOMOLOG PROTEIN J-RELATED', 239073),
(300476, 'PTHR11972:SF55', NULL, NULL, NULL, NULL, 'FERRIC REDUCTASE', 239073),
(300477, 'PTHR11972:SF12', NULL, NULL, NULL, NULL, 'NADPH OXIDASE 3', 239073),
(300478, 'PTHR11972:SF58', NULL, NULL, NULL, NULL, 'NADPH OXIDASE 5', 239073),
(300479, 'PTHR11972:SF139', NULL, NULL, NULL, NULL, '', 239073),
(300480, 'PTHR11972:SF169', NULL, NULL, NULL, NULL, 'FAD-BINDING FR-TYPE DOMAIN-CONTAINING PROTEIN', 239073),
(300481, 'PTHR11972:SF202', NULL, NULL, NULL, NULL, 'OS05G0528000 PROTEIN', 239073),
(300482, 'PTHR11972:SF201', NULL, NULL, NULL, NULL, 'SUPEROXIDE-GENERATING NADPH OXIDASE HEAVY CHAIN SUBUNIT C', 239073),
(300483, 'PTHR11972:SF204', NULL, NULL, NULL, NULL, 'FERRIC REDUCTION OXIDASE 2-LIKE', 239073),
(300484, 'PTHR11972:SF127', NULL, NULL, NULL, NULL, 'RESPIRATORY BURST OXIDASE HOMOLOG PROTEIN A-LIKE', 239073),
(300485, 'PTHR11972:SF203', NULL, NULL, NULL, NULL, 'NADPH OXIDASE 1', 239073),
(300486, 'PTHR11972:SF165', NULL, NULL, NULL, NULL, 'SUPEROXIDE-GENERATING NADPH OXIDASE HEAVY CHAIN SUBUNIT B', 239073),
(300487, 'PTHR11972:SF164', NULL, NULL, NULL, NULL, 'RESPIRATORY BURST OXIDASE-RELATED', 239073),
(300488, 'PTHR11972:SF200', NULL, NULL, NULL, NULL, 'FAD-BINDING FR-TYPE DOMAIN-CONTAINING PROTEIN', 239073),
(300489, 'PTHR11972:SF167', NULL, NULL, NULL, NULL, 'FERRIC REDUCTION OXIDASE 7, CHLOROPLASTIC-LIKE', 239073),
(300490, 'PTHR11972:SF161', NULL, NULL, NULL, NULL, 'BNAC02G38300D PROTEIN', 239073),
(300491, 'PTHR11972:SF160', NULL, NULL, NULL, NULL, 'BNAA09G44270D PROTEIN', 239073),
(300492, 'PTHR11972:SF162', NULL, NULL, NULL, NULL, 'FAD-BINDING FR-TYPE DOMAIN-CONTAINING PROTEIN', 239073),
(300493, 'PTHR11972:SF41', NULL, NULL, NULL, NULL, 'FERRIC REDUCTION OXIDASE 2', 239073),
(300494, 'PTHR11972:SF44', NULL, NULL, NULL, NULL, 'RESPIRATORY BURST OXIDASE HOMOLOG PROTEIN E', 239073),
(300495, 'PTHR11972', NULL, NULL, NULL, NULL, 'NADPH OXIDASE', 239073),
(300496, 'PTHR11972:SF158', NULL, NULL, NULL, NULL, 'RESPIRATORY BURST OXIDASE HOMOLOG PROTEIN G-RELATED', 239073),
(300497, 'PTHR11972:SF159', NULL, NULL, NULL, NULL, 'BNAA05G13820D PROTEIN', 239073),
(300498, 'PTHR11972:SF198', NULL, NULL, NULL, NULL, 'METALLOREDUCTASE AIM14-RELATED', 239073),
(300499, 'PTHR11972:SF154', NULL, NULL, NULL, NULL, 'RESPIRATORY BURST OXIDASE HOMOLOG PROTEIN A', 239073),
(300500, 'PTHR11972:SF197', NULL, NULL, NULL, NULL, 'RESPIRATORY BURST OXIDASE HOMOLOG PROTEIN D', 239073),
(300501, 'PTHR11972:SF153', NULL, NULL, NULL, NULL, 'NADPH OXIDASE 4', 239073),
(300502, 'PTHR11972:SF155', NULL, NULL, NULL, NULL, 'FERRIC REDUCTION OXIDASE 8, MITOCHONDRIAL', 239073),
(300503, 'PTHR11972:SF199', NULL, NULL, NULL, NULL, 'FERRIC/CUPRIC REDUCTASE TRANSMEMBRANE COMPONENT 7', 239073),
(300504, 'PTHR11972:SF194', NULL, NULL, NULL, NULL, 'FERRIC CHELATE REDUCTASE 2', 239073);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(300505, 'PTHR11972:SF150', NULL, NULL, NULL, NULL, 'RESPIRATORY BURST OXIDASE HOMOLOG PROTEIN I-RELATED', 239073),
(300506, 'PTHR11972:SF193', NULL, NULL, NULL, NULL, 'FAD-BINDING FR-TYPE DOMAIN-CONTAINING PROTEIN', 239073),
(300507, 'PTHR11972:SF196', NULL, NULL, NULL, NULL, 'FAD-BINDING FR-TYPE DOMAIN-CONTAINING PROTEIN', 239073),
(300508, 'PTHR11972:SF152', NULL, NULL, NULL, NULL, 'RESPIRATORY BURST OXIDASE HOMOLOG PROTEIN C', 239073),
(300509, 'PTHR11972:SF195', NULL, NULL, NULL, NULL, 'FAD-BINDING FR-TYPE DOMAIN-CONTAINING PROTEIN', 239073),
(300510, 'PTHR11972:SF151', NULL, NULL, NULL, NULL, 'RESPIRATORY BURST OXIDASE HOMOLOG H', 239073),
(300511, 'PTHR11972:SF190', NULL, NULL, NULL, NULL, 'OS08G0453700 PROTEIN', 239073),
(300512, 'PTHR11972:SF192', NULL, NULL, NULL, NULL, 'FERRIC REDUCTASE TRANSMEMBRANE COMPONENT 1-RELATED', 239073),
(300513, 'PTHR11972:SF191', NULL, NULL, NULL, NULL, 'FAD-BINDING FR-TYPE DOMAIN-CONTAINING PROTEIN', 239073),
(300514, 'PTHR11972:SF71', NULL, NULL, NULL, NULL, 'NADPH OXIDASE 1', 239073),
(300515, 'PTHR11972:SF75', NULL, NULL, NULL, NULL, 'DUAL OXIDASE 1', 239073),
(300516, 'PTHR11972:SF79', NULL, NULL, NULL, NULL, 'FERRIC REDUCTION OXIDASE 4-RELATED', 239073),
(300517, 'PTHR11972:SF39', NULL, NULL, NULL, NULL, 'FAD-BINDING FR-TYPE DOMAIN-CONTAINING PROTEIN', 239073),
(300518, 'PTHR40631:SF2', NULL, NULL, NULL, NULL, 'NON-REDUCING END ALPHA-L-ARABINOFURANOSIDASE', 239074),
(300519, 'PTHR40631:SF1', NULL, NULL, NULL, NULL, 'ALPHA-L-ARABINOFURANOSIDASE AXHA-2-RELATED', 239074),
(300520, 'PTHR40631', NULL, NULL, NULL, NULL, 'ALPHA-L-ARABINOFURANOSIDASE AXHA-2-RELATED', 239074),
(300521, 'PTHR46197:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ABHD14A', 239075),
(300522, 'PTHR46197', NULL, NULL, NULL, NULL, 'PROTEIN ABHD14B-LIKE', 239075),
(300523, 'PTHR46197:SF3', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 239075),
(300524, 'PTHR46197:SF2', NULL, NULL, NULL, NULL, 'PROTEIN ABHD14B', 239075),
(300525, 'PTHR48165', NULL, NULL, NULL, NULL, 'BNAC03G44900D PROTEIN', 239076),
(300526, 'PTHR48165:SF1', NULL, NULL, NULL, NULL, 'BNAC03G44900D PROTEIN', 239076),
(300527, 'PTHR48165:SF2', NULL, NULL, NULL, NULL, '', 239076),
(300528, 'PTHR48165:SF3', NULL, NULL, NULL, NULL, '', 239076),
(300529, 'PTHR35577:SF6', NULL, NULL, NULL, NULL, '', 239077),
(300530, 'PTHR35577:SF7', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH, ACIDIC INTEGRAL MEMBRANE PROTEIN', 239077),
(300531, 'PTHR35577:SF1', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN FAMILY PROTEIN', 239077),
(300532, 'PTHR35577:SF2', NULL, NULL, NULL, NULL, '', 239077),
(300533, 'PTHR35577', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH, ACIDIC INTEGRAL MEMBRANE PROTEIN-RELATED', 239077),
(300534, 'PTHR27007:SF31', NULL, NULL, NULL, NULL, 'PROTEIN KINASE, PUTATIVE, EXPRESSED-RELATED', 239078),
(300535, 'PTHR27007:SF417', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300536, 'PTHR27007:SF416', NULL, NULL, NULL, NULL, 'OS02G0299000 PROTEIN', 239078),
(300537, 'PTHR27007:SF419', NULL, NULL, NULL, NULL, 'OS01G0779300 PROTEIN', 239078),
(300538, 'PTHR27007:SF418', NULL, NULL, NULL, NULL, 'LECTIN RECEPTOR KINASE', 239078),
(300539, 'PTHR27007:SF34', NULL, NULL, NULL, NULL, 'LECTIN-DOMAIN RECEPTOR-LIKE PROTEIN KINASE FAMILY PROTEIN-RELATED', 239078),
(300540, 'PTHR27007:SF376', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300541, 'PTHR27007:SF257', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE I.6-RELATED', 239078),
(300542, 'PTHR27007:SF411', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE IX.1-LIKE', 239078),
(300543, 'PTHR27007:SF377', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300544, 'PTHR27007:SF410', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300545, 'PTHR27007:SF413', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300546, 'PTHR27007:SF412', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE IX.1-LIKE', 239078);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(300547, 'PTHR27007:SF415', NULL, NULL, NULL, NULL, 'INACTIVE L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE III.1-RELATED', 239078),
(300548, 'PTHR27007:SF414', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 239078),
(300549, 'PTHR27007:SF372', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300550, 'PTHR27007:SF130', NULL, NULL, NULL, NULL, 'INACTIVE LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE CORYNE', 239078),
(300551, 'PTHR27007:SF250', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300552, 'PTHR27007:SF373', NULL, NULL, NULL, NULL, 'OS02G0156000 PROTEIN', 239078),
(300553, 'PTHR27007:SF252', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE S.5-RELATED', 239078),
(300554, 'PTHR27007:SF406', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE IX.1-LIKE', 239078),
(300555, 'PTHR27007:SF28', NULL, NULL, NULL, NULL, 'LECTIN-LIKE RECEPTOR PROTEIN KINASE FAMILY PROTEIN-RELATED', 239078),
(300556, 'PTHR27007:SF405', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300557, 'PTHR27007:SF408', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300558, 'PTHR27007:SF25', NULL, NULL, NULL, NULL, 'OS07G0283125 PROTEIN', 239078),
(300559, 'PTHR27007:SF407', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE IX.1-LIKE', 239078),
(300560, 'PTHR27007:SF409', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300561, 'PTHR27007:SF21', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE S.7-RELATED', 239078),
(300562, 'PTHR27007:SF244', NULL, NULL, NULL, NULL, 'OS10G0533800 PROTEIN', 239078),
(300563, 'PTHR27007:SF364', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300564, 'PTHR27007:SF367', NULL, NULL, NULL, NULL, 'BNAA03G00300D PROTEIN', 239078),
(300565, 'PTHR27007:SF400', NULL, NULL, NULL, NULL, 'LECTIN-LIKE RECEPTOR KINASE 7', 239078),
(300566, 'PTHR27007:SF246', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300567, 'PTHR27007:SF245', NULL, NULL, NULL, NULL, 'LECTIN RECEPTOR KINASE', 239078),
(300568, 'PTHR27007:SF366', NULL, NULL, NULL, NULL, 'CHITINASE', 239078),
(300569, 'PTHR27007:SF369', NULL, NULL, NULL, NULL, 'BNACNNG19190D PROTEIN', 239078),
(300570, 'PTHR27007:SF248', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300571, 'PTHR27007:SF402', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300572, 'PTHR27007:SF401', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300573, 'PTHR27007:SF29', NULL, NULL, NULL, NULL, 'OS07G0283050 PROTEIN', 239078),
(300574, 'PTHR27007:SF361', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300575, 'PTHR27007:SF240', NULL, NULL, NULL, NULL, 'OS09G0268000 PROTEIN', 239078),
(300576, 'PTHR27007:SF360', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300577, 'PTHR27007:SF242', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE V.9', 239078),
(300578, 'PTHR27007:SF241', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE V.2-RELATED', 239078),
(300579, 'PTHR27007:SF1', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE V.9', 239078),
(300580, 'PTHR27007:SF51', NULL, NULL, NULL, NULL, 'OS02G0712700 PROTEIN', 239078),
(300581, 'PTHR27007:SF4', NULL, NULL, NULL, NULL, 'OS07G0131500 PROTEIN', 239078),
(300582, 'PTHR27007:SF439', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300583, 'PTHR27007', NULL, NULL, NULL, NULL, '', 239078),
(300584, 'PTHR27007:SF438', NULL, NULL, NULL, NULL, 'AGGLUTININ-2-LIKE', 239078),
(300585, 'PTHR27007:SF57', NULL, NULL, NULL, NULL, 'OS04G0531500 PROTEIN', 239078),
(300586, 'PTHR27007:SF156', NULL, NULL, NULL, NULL, 'OS07G0130200 PROTEIN', 239078),
(300587, 'PTHR27007:SF431', NULL, NULL, NULL, NULL, 'BNAC02G28690D PROTEIN', 239078);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(300588, 'PTHR27007:SF155', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300589, 'PTHR27007:SF430', NULL, NULL, NULL, NULL, 'LECTIN-LIKE RECEPTOR PROTEIN KINASE FAMILY PROTEIN-RELATED', 239078),
(300590, 'PTHR27007:SF279', NULL, NULL, NULL, NULL, 'LECTIN RECEPTOR KINASE', 239078),
(300591, 'PTHR27007:SF433', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN RECEPTOR KINASE', 239078),
(300592, 'PTHR27007:SF312', NULL, NULL, NULL, NULL, 'OS06G0210400 PROTEIN', 239078),
(300593, 'PTHR27007:SF158', NULL, NULL, NULL, NULL, 'LECTIN RECEPTOR KINASE', 239078),
(300594, 'PTHR27007:SF432', NULL, NULL, NULL, NULL, 'LECTIN-LIKE RECEPTOR PROTEIN KINASE FAMILY PROTEIN-RELATED', 239078),
(300595, 'PTHR27007:SF435', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300596, 'PTHR27007:SF159', NULL, NULL, NULL, NULL, 'LECTIN-LIKE RECEPTOR PROTEIN KINASE FAMILY PROTEIN-RELATED', 239078),
(300597, 'PTHR27007:SF434', NULL, NULL, NULL, NULL, 'RECEPTOR LIKE PROTEIN KINASE S.3', 239078),
(300598, 'PTHR27007:SF437', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300599, 'PTHR27007:SF315', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE V.9', 239078),
(300600, 'PTHR27007:SF436', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300601, 'PTHR27007:SF390', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300602, 'PTHR27007:SF150', NULL, NULL, NULL, NULL, 'LECTIN-LIKE RECEPTOR PROTEIN KINASE FAMILY PROTEIN-RELATED', 239078),
(300603, 'PTHR27007:SF392', NULL, NULL, NULL, NULL, 'KINASE', 239078),
(300604, 'PTHR27007:SF270', NULL, NULL, NULL, NULL, 'OS03G0258000 PROTEIN', 239078),
(300605, 'PTHR27007:SF152', NULL, NULL, NULL, NULL, 'OS04G0109100 PROTEIN', 239078),
(300606, 'PTHR27007:SF273', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE I.3-RELATED', 239078),
(300607, 'PTHR27007:SF394', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE I.9', 239078),
(300608, 'PTHR27007:SF393', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE I.8', 239078),
(300609, 'PTHR27007:SF151', NULL, NULL, NULL, NULL, 'OS09G0334800 PROTEIN', 239078),
(300610, 'PTHR27007:SF275', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE V.1-RELATED', 239078),
(300611, 'PTHR27007:SF274', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300612, 'PTHR27007:SF153', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE SIT2', 239078),
(300613, 'PTHR27007:SF395', NULL, NULL, NULL, NULL, 'OS07G0129800 PROTEIN', 239078),
(300614, 'PTHR27007:SF41', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300615, 'PTHR27007:SF428', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300616, 'PTHR27007:SF427', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300617, 'PTHR27007:SF48', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300618, 'PTHR27007:SF308', NULL, NULL, NULL, NULL, 'BNAA07G02650D PROTEIN', 239078),
(300619, 'PTHR27007:SF429', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300620, 'PTHR27007:SF43', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE VI.1-RELATED', 239078),
(300621, 'PTHR27007:SF420', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE II.1-RELATED', 239078),
(300622, 'PTHR27007:SF387', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300623, 'PTHR27007:SF386', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE II.1-RELATED', 239078),
(300624, 'PTHR27007:SF265', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE VIII.1', 239078),
(300625, 'PTHR27007:SF422', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE I.11-RELATED', 239078),
(300626, 'PTHR27007:SF268', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE VIII.2-LIKE', 239078);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(300627, 'PTHR27007:SF147', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE IX.1', 239078),
(300628, 'PTHR27007:SF301', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE V.9-LIKE', 239078),
(300629, 'PTHR27007:SF300', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300630, 'PTHR27007:SF421', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE IX.1-LIKE', 239078),
(300631, 'PTHR27007:SF267', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300632, 'PTHR27007:SF149', NULL, NULL, NULL, NULL, 'OS07G0575700 PROTEIN', 239078),
(300633, 'PTHR27007:SF424', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300634, 'PTHR27007:SF423', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE IX.1', 239078),
(300635, 'PTHR27007:SF426', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300636, 'PTHR27007:SF304', NULL, NULL, NULL, NULL, 'OS08G0124000 PROTEIN', 239078),
(300637, 'PTHR27007:SF425', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300638, 'PTHR27007:SF380', NULL, NULL, NULL, NULL, 'LECTIN-DOMAIN RECEPTOR-LIKE PROTEIN KINASE FAMILY PROTEIN-RELATED', 239078),
(300639, 'PTHR27007:SF140', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE VII.2-RELATED', 239078),
(300640, 'PTHR27007:SF261', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300641, 'PTHR27007:SF143', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300642, 'PTHR27007:SF385', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE V.9', 239078),
(300643, 'PTHR27007:SF218', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE V.4', 239078),
(300644, 'PTHR27007:SF211', NULL, NULL, NULL, NULL, 'OS04G0288500 PROTEIN', 239078),
(300645, 'PTHR27007:SF332', NULL, NULL, NULL, NULL, 'BNAA07G07620D PROTEIN', 239078),
(300646, 'PTHR27007:SF299', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300647, 'PTHR27007:SF210', NULL, NULL, NULL, NULL, 'LECTIN-LIKE RECEPTOR PROTEIN KINASE FAMILY PROTEIN-RELATED', 239078),
(300648, 'PTHR27007:SF177', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300649, 'PTHR27007:SF334', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE IV.3-RELATED', 239078),
(300650, 'PTHR27007:SF213', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE SIT1', 239078),
(300651, 'PTHR27007:SF215', NULL, NULL, NULL, NULL, 'OS07G0575750 PROTEIN', 239078),
(300652, 'PTHR27007:SF335', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300653, 'PTHR27007:SF217', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300654, 'PTHR27007:SF337', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300655, 'PTHR27007:SF170', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE I.7', 239078),
(300656, 'PTHR27007:SF291', NULL, NULL, NULL, NULL, 'OS07G0569550 PROTEIN', 239078),
(300657, 'PTHR27007:SF174', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300658, 'PTHR27007:SF297', NULL, NULL, NULL, NULL, 'BNAA10G13100D PROTEIN', 239078),
(300659, 'PTHR27007:SF175', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE V.5-RELATED', 239078),
(300660, 'PTHR27007:SF296', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300661, 'PTHR27007:SF62', NULL, NULL, NULL, NULL, 'OS12G0608500 PROTEIN', 239078),
(300662, 'PTHR27007:SF61', NULL, NULL, NULL, NULL, 'RECEPTOR LIKE PROTEIN KINASE S.2', 239078),
(300663, 'PTHR27007:SF328', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300664, 'PTHR27007:SF200', NULL, NULL, NULL, NULL, 'OS09G0251100 PROTEIN', 239078),
(300665, 'PTHR27007:SF288', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(300666, 'PTHR27007:SF442', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE IX.1', 239078),
(300667, 'PTHR27007:SF321', NULL, NULL, NULL, NULL, 'KINASE CHARK-RELATED', 239078),
(300668, 'PTHR27007:SF166', NULL, NULL, NULL, NULL, 'BNAA02G36540D PROTEIN', 239078),
(300669, 'PTHR27007:SF441', NULL, NULL, NULL, NULL, 'OS04G0138800 PROTEIN', 239078),
(300670, 'PTHR27007:SF320', NULL, NULL, NULL, NULL, 'OS09G0341100 PROTEIN', 239078),
(300671, 'PTHR27007:SF202', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE VIII.2', 239078),
(300672, 'PTHR27007:SF444', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300673, 'PTHR27007:SF323', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300674, 'PTHR27007:SF169', NULL, NULL, NULL, NULL, 'OS07G0130100 PROTEIN', 239078),
(300675, 'PTHR27007:SF443', NULL, NULL, NULL, NULL, '', 239078),
(300676, 'PTHR27007:SF201', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300677, 'PTHR27007:SF325', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE IV.1', 239078),
(300678, 'PTHR27007:SF204', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300679, 'PTHR27007:SF327', NULL, NULL, NULL, NULL, 'BNAA10G13090D PROTEIN', 239078),
(300680, 'PTHR27007:SF205', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE V.9', 239078),
(300681, 'PTHR27007:SF326', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300682, 'PTHR27007:SF161', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE S.1', 239078),
(300683, 'PTHR27007:SF282', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE V.3-RELATED', 239078),
(300684, 'PTHR27007:SF281', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300685, 'PTHR27007:SF160', NULL, NULL, NULL, NULL, 'CLADE XI LECTIN RECEPTOR KINASE', 239078),
(300686, 'PTHR27007:SF162', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE IX.2', 239078),
(300687, 'PTHR27007:SF440', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE S.4', 239078),
(300688, 'PTHR27007:SF164', NULL, NULL, NULL, NULL, 'OS12G0500400 PROTEIN', 239078),
(300689, 'PTHR27007:SF11', NULL, NULL, NULL, NULL, 'PROTEIN KINASE, PUTATIVE, EXPRESSED-RELATED', 239078),
(300690, 'PTHR27007:SF233', NULL, NULL, NULL, NULL, 'BNAC03G13350D PROTEIN', 239078),
(300691, 'PTHR27007:SF354', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300692, 'PTHR27007:SF356', NULL, NULL, NULL, NULL, '', 239078),
(300693, 'PTHR27007:SF355', NULL, NULL, NULL, NULL, 'BNAC03G30950D PROTEIN', 239078),
(300694, 'PTHR27007:SF358', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300695, 'PTHR27007:SF357', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE IX.1', 239078),
(300696, 'PTHR27007:SF19', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300697, 'PTHR27007:SF239', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300698, 'PTHR27007:SF359', NULL, NULL, NULL, NULL, 'OS07G0129900 PROTEIN', 239078),
(300699, 'PTHR27007:SF238', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE V.9', 239078),
(300700, 'PTHR27007:SF192', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE VI.2', 239078),
(300701, 'PTHR27007:SF194', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300702, 'PTHR27007:SF193', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE VII.1', 239078),
(300703, 'PTHR27007:SF196', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300704, 'PTHR27007:SF350', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE I.10-RELATED', 239078),
(300705, 'PTHR27007:SF195', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE S.6', 239078);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(300706, 'PTHR27007:SF231', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE I.1-RELATED', 239078),
(300707, 'PTHR27007:SF230', NULL, NULL, NULL, NULL, 'LECTIN RECEPTOR KINASE', 239078),
(300708, 'PTHR27007:SF190', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300709, 'PTHR27007:SF229', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300710, 'PTHR27007:SF343', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300711, 'PTHR27007:SF188', NULL, NULL, NULL, NULL, 'BNAA10G13180D PROTEIN', 239078),
(300712, 'PTHR27007:SF344', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300713, 'PTHR27007:SF223', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE IV.2', 239078),
(300714, 'PTHR27007:SF226', NULL, NULL, NULL, NULL, 'LECTIN-DOMAIN CONTAINING RECEPTOR KINASE VI.3-RELATED', 239078),
(300715, 'PTHR27007:SF349', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300716, 'PTHR27007:SF227', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300717, 'PTHR27007:SF348', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300718, 'PTHR27007:SF182', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300719, 'PTHR27007:SF185', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE S.5-RELATED', 239078),
(300720, 'PTHR27007:SF341', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300721, 'PTHR27007:SF187', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE I.5-RELATED', 239078),
(300722, 'PTHR27007:SF340', NULL, NULL, NULL, NULL, 'BNAC04G53070D PROTEIN', 239078),
(300723, 'PTHR27007:SF186', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239078),
(300724, 'PTHR11878:SF73', NULL, NULL, NULL, NULL, 'NCX4A', 239079),
(300725, 'PTHR11878:SF74', NULL, NULL, NULL, NULL, 'NA/CA-EXCHANGE PROTEIN, ISOFORM G', 239079),
(300726, 'PTHR11878', NULL, NULL, NULL, NULL, 'SODIUM/CALCIUM EXCHANGER', 239079),
(300727, 'PTHR11878:SF70', NULL, NULL, NULL, NULL, '', 239079),
(300728, 'PTHR11878:SF8', NULL, NULL, NULL, NULL, 'SODIUM/CALCIUM EXCHANGER 2', 239079),
(300729, 'PTHR11878:SF69', NULL, NULL, NULL, NULL, 'SODIUM CALCIUM EXCHANGER 1H', 239079),
(300730, 'PTHR11878:SF26', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 8 MEMBER 4B', 239079),
(300731, 'PTHR11878:SF7', NULL, NULL, NULL, NULL, 'SODIUM/CALCIUM EXCHANGER 3', 239079),
(300732, 'PTHR11878:SF6', NULL, NULL, NULL, NULL, 'SODIUM/CALCIUM EXCHANGER 1', 239079),
(300733, 'PTHR11878:SF75', NULL, NULL, NULL, NULL, 'NA/CA EXCHANGERS', 239079),
(300734, 'PTHR11878:SF65', NULL, NULL, NULL, NULL, 'NA/CA EXCHANGERS', 239079),
(300735, 'PTHR12233:SF21', NULL, NULL, NULL, NULL, 'OS11G0629200 PROTEIN', 239080),
(300736, 'PTHR12233:SF20', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 26A', 239080),
(300737, 'PTHR12233:SF1', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 26', 239080),
(300738, 'PTHR12233:SF15', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 26B', 239080),
(300739, 'PTHR12233:SF17', NULL, NULL, NULL, NULL, 'BNACNNG76240D PROTEIN', 239080),
(300740, 'PTHR12233:SF2', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 26C', 239080),
(300741, 'PTHR12233:SF5', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 26B', 239080),
(300742, 'PTHR12233:SF4', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 26A', 239080),
(300743, 'PTHR12233:SF19', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING 26A-RELATED', 239080),
(300744, 'PTHR12233', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING 26 RELATED', 239080),
(300745, 'PTHR47186:SF1', NULL, NULL, NULL, NULL, 'SI:DKEY-1H4.4', 239081),
(300746, 'PTHR47186:SF4', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 57', 239081),
(300747, 'PTHR47186:SF3', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239081);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(300748, 'PTHR47186:SF6', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RPV1-LIKE', 239081),
(300749, 'PTHR47186:SF10', NULL, NULL, NULL, NULL, 'RX_N DOMAIN-CONTAINING PROTEIN', 239081),
(300750, 'PTHR47186', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 57', 239081),
(300751, 'PTHR47186:SF11', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RPP2B-LIKE', 239081),
(300752, 'PTHR47186:SF5', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RGA1 ISOFORM X1-RELATED', 239081),
(300753, 'PTHR47186:SF8', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 239081),
(300754, 'PTHR47186:SF12', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RPM1-LIKE', 239081),
(300755, 'PTHR47186:SF7', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 239081),
(300756, 'PTHR47186:SF9', NULL, NULL, NULL, NULL, 'OS02G0478300 PROTEIN', 239081),
(300757, 'PTHR30065:SF7', NULL, NULL, NULL, NULL, 'SECRETION SYSTEM APPARATUS PROTEIN SSAT', 239082),
(300758, 'PTHR30065:SF8', NULL, NULL, NULL, NULL, 'FLAGELLAR BIOSYNTHETIC PROTEIN FLIR', 239082),
(300759, 'PTHR30065', NULL, NULL, NULL, NULL, 'FLAGELLAR BIOSYNTHETIC PROTEIN FLIR', 239082),
(300760, 'PTHR30065:SF1', NULL, NULL, NULL, NULL, 'FLAGELLAR BIOSYNTHETIC PROTEIN FLIR', 239082),
(300761, 'PTHR38767', NULL, NULL, NULL, NULL, 'DNA POLYMERASE III SUBUNIT CHI', 239083),
(300762, 'PTHR38767:SF1', NULL, NULL, NULL, NULL, 'DNA POLYMERASE III SUBUNIT CHI', 239083),
(300763, 'PTHR36468:SF1', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 19, MITOCHONDRIAL', 239084),
(300764, 'PTHR36468', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 19, MITOCHONDRIAL', 239084),
(300765, 'PTHR13302', NULL, NULL, NULL, NULL, 'CONSERVED OLIGOMERIC GOLGI COMPLEX COMPONENT 3', 239085),
(300766, 'PTHR13302:SF8', NULL, NULL, NULL, NULL, 'CONSERVED OLIGOMERIC GOLGI COMPLEX SUBUNIT 3', 239085),
(300767, 'PTHR30098:SF7', NULL, NULL, NULL, NULL, '', 239086),
(300768, 'PTHR30098:SF2', NULL, NULL, NULL, NULL, 'LEUCYL/PHENYLALANYL-TRNA--PROTEIN TRANSFERASE', 239086),
(300769, 'PTHR30098', NULL, NULL, NULL, NULL, 'LEUCYL/PHENYLALANYL-TRNA--PROTEIN TRANSFERASE', 239086),
(300770, 'PTHR31708:SF0', NULL, NULL, NULL, NULL, 'ABPBG26-RELATED', 239087),
(300771, 'PTHR31708:SF1', NULL, NULL, NULL, NULL, 'ABPBG11-RELATED', 239087),
(300772, 'PTHR31708', NULL, NULL, NULL, NULL, 'ABPBG26-RELATED', 239087),
(300773, 'PTHR12178:SF10', NULL, NULL, NULL, NULL, '', 239088),
(300774, 'PTHR12178:SF11', NULL, NULL, NULL, NULL, 'N-TERMINAL EF-HAND CALCIUM-BINDING PROTEIN 1', 239088),
(300775, 'PTHR12178:SF3', NULL, NULL, NULL, NULL, 'N-TERMINAL EF-HAND CALCIUM-BINDING PROTEIN 3', 239088),
(300776, 'PTHR12178:SF2', NULL, NULL, NULL, NULL, 'N-TERMINAL EF-HAND CALCIUM-BINDING PROTEIN 2', 239088),
(300777, 'PTHR12178', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 239088),
(300778, 'PTHR11274:SF17', NULL, NULL, NULL, NULL, 'DNA HELICASE', 239089),
(300779, 'PTHR11274:SF16', NULL, NULL, NULL, NULL, 'TFIIH BASAL TRANSCRIPTION FACTOR COMPLEX HELICASE XPB SUBUNIT', 239089),
(300780, 'PTHR11274:SF0', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION AND DNA REPAIR FACTOR IIH HELICASE SUBUNIT XPB', 239089),
(300781, 'PTHR11274:SF13', NULL, NULL, NULL, NULL, 'HELICASE A859L-RELATED', 239089),
(300782, 'PTHR11274', NULL, NULL, NULL, NULL, 'RAD25/XP-B DNA REPAIR HELICASE', 239089),
(300783, 'PTHR11274:SF12', NULL, NULL, NULL, NULL, 'HELICASE, POSSIBLE DNA REPAIR RAD25', 239089),
(300784, 'PTHR45398', NULL, NULL, NULL, NULL, '', 239090),
(300785, 'PTHR45398:SF1', NULL, NULL, NULL, NULL, 'D-ALANINE--D-ALANYL CARRIER PROTEIN LIGASE', 239090),
(300786, 'PTHR35331', NULL, NULL, NULL, NULL, 'STAGE V SPORULATION PROTEIN S', 239091),
(300787, 'PTHR35331:SF1', NULL, NULL, NULL, NULL, 'STAGE V SPORULATION PROTEIN S', 239091),
(300788, 'PTHR37236:SF2', NULL, NULL, NULL, NULL, 'BNAC03G30470D PROTEIN', 239092),
(300789, 'PTHR37236', NULL, NULL, NULL, NULL, 'AUXIN-BINDING PROTEIN 1', 239092),
(300790, 'PTHR37236:SF1', NULL, NULL, NULL, NULL, 'AUXIN-BINDING PROTEIN 1', 239092);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(300791, 'PTHR47993:SF22', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE', 239093),
(300792, 'PTHR47993:SF21', NULL, NULL, NULL, NULL, 'FBA_3 DOMAIN-CONTAINING PROTEIN', 239093),
(300793, 'PTHR47993:SF24', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300794, 'PTHR47993:SF23', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', 239093),
(300795, 'PTHR47993:SF26', NULL, NULL, NULL, NULL, 'FBA_1 DOMAIN-CONTAINING PROTEIN', 239093),
(300796, 'PTHR47993:SF308', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300797, 'PTHR47993:SF309', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300798, 'PTHR47993:SF304', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300799, 'PTHR47993:SF305', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300800, 'PTHR47993:SF306', NULL, NULL, NULL, NULL, 'F-BOX-LIKE PROTEIN', 239093),
(300801, 'PTHR47993:SF307', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300802, 'PTHR47993:SF300', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300803, 'PTHR47993:SF301', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300804, 'PTHR47993:SF302', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300805, 'PTHR47993:SF303', NULL, NULL, NULL, NULL, 'RETROVIRUS-RELATED POL POLYPROTEIN LINE-1', 239093),
(300806, 'PTHR47993:SF28', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300807, 'PTHR47993:SF11', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300808, 'PTHR47993:SF10', NULL, NULL, NULL, NULL, 'FBA_1 DOMAIN-CONTAINING PROTEIN', 239093),
(300809, 'PTHR47993:SF12', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300810, 'PTHR47993:SF15', NULL, NULL, NULL, NULL, '', 239093),
(300811, 'PTHR47993:SF17', NULL, NULL, NULL, NULL, 'BNAUNNG04600D PROTEIN', 239093),
(300812, 'PTHR47993:SF16', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300813, 'PTHR47993:SF19', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300814, 'PTHR47993:SF18', NULL, NULL, NULL, NULL, 'FBA_1 DOMAIN-CONTAINING PROTEIN', 239093),
(300815, 'PTHR47993:SF326', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300816, 'PTHR47993:SF205', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300817, 'PTHR47993:SF327', NULL, NULL, NULL, NULL, 'FBA_1 DOMAIN-CONTAINING PROTEIN', 239093),
(300818, 'PTHR47993:SF207', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300819, 'PTHR47993:SF328', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN CPR30-LIKE ISOFORM X1', 239093),
(300820, 'PTHR47993:SF329', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300821, 'PTHR47993:SF322', NULL, NULL, NULL, NULL, 'F-BOX FAMILY PROTEIN-LIKE PROTEIN', 239093),
(300822, 'PTHR47993:SF201', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300823, 'PTHR47993:SF323', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN INTERACTION DOMAIN PROTEIN', 239093),
(300824, 'PTHR47993:SF324', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300825, 'PTHR47993:SF203', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN EXPRESSED', 239093),
(300826, 'PTHR47993:SF325', NULL, NULL, NULL, NULL, 'RETROVIRUS-RELATED POL POLYPROTEIN LINE-1', 239093),
(300827, 'PTHR47993:SF320', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300828, 'PTHR47993:SF321', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300829, 'PTHR47993:SF200', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', 239093),
(300830, 'PTHR47993:SF319', NULL, NULL, NULL, NULL, 'FBA_1 DOMAIN-CONTAINING PROTEIN', 239093),
(300831, 'PTHR47993:SF315', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300832, 'PTHR47993:SF316', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300833, 'PTHR47993:SF317', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(300834, 'PTHR47993:SF318', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300835, 'PTHR47993:SF311', NULL, NULL, NULL, NULL, 'FBA_1 DOMAIN-CONTAINING PROTEIN', 239093),
(300836, 'PTHR47993:SF312', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300837, 'PTHR47993:SF313', NULL, NULL, NULL, NULL, 'FBA_1 DOMAIN-CONTAINING PROTEIN', 239093),
(300838, 'PTHR47993:SF314', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN INTERACTION DOMAIN CONTAINING PROTEIN', 239093),
(300839, 'PTHR47993:SF310', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300840, 'PTHR47993', NULL, NULL, NULL, NULL, 'OS09G0372900 PROTEIN-RELATED', 239093),
(300841, 'PTHR47993:SF229', NULL, NULL, NULL, NULL, 'FBA_3 DOMAIN-CONTAINING PROTEIN', 239093),
(300842, 'PTHR47993:SF109', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300843, 'PTHR47993:SF226', NULL, NULL, NULL, NULL, 'OS09G0372900 PROTEIN', 239093),
(300844, 'PTHR47993:SF222', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300845, 'PTHR47993:SF218', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300846, 'PTHR47993:SF333', NULL, NULL, NULL, NULL, 'FBA_1 DOMAIN-CONTAINING PROTEIN', 239093),
(300847, 'PTHR47993:SF334', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300848, 'PTHR47993:SF335', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300849, 'PTHR47993:SF215', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300850, 'PTHR47993:SF330', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300851, 'PTHR47993:SF331', NULL, NULL, NULL, NULL, 'BNAA05G19030D PROTEIN', 239093),
(300852, 'PTHR47993:SF332', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300853, 'PTHR47993:SF211', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN CPR30-LIKE ISOFORM X1', 239093),
(300854, 'PTHR47993:SF249', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300855, 'PTHR47993:SF245', NULL, NULL, NULL, NULL, 'OS02G0630200 PROTEIN', 239093),
(300856, 'PTHR47993:SF246', NULL, NULL, NULL, NULL, '', 239093),
(300857, 'PTHR47993:SF247', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300858, 'PTHR47993:SF127', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN EXPRESSED', 239093),
(300859, 'PTHR47993:SF248', NULL, NULL, NULL, NULL, 'S-LOCUS F-BOX PROTEIN TYPE-12', 239093),
(300860, 'PTHR47993:SF241', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300861, 'PTHR47993:SF242', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 15-RELATED', 239093),
(300862, 'PTHR47993:SF122', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN CPR30-LIKE', 239093),
(300863, 'PTHR47993:SF243', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN CPR30-LIKE', 239093),
(300864, 'PTHR47993:SF244', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300865, 'PTHR47993:SF240', NULL, NULL, NULL, NULL, 'FBA_1 DOMAIN-CONTAINING PROTEIN', 239093),
(300866, 'PTHR47993:SF8', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300867, 'PTHR47993:SF7', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300868, 'PTHR47993:SF9', NULL, NULL, NULL, NULL, 'FBA_1 DOMAIN-CONTAINING PROTEIN', 239093),
(300869, 'PTHR47993:SF2', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN INTERACTION DOMAIN CONTAINING PROTEIN, EXPRESSED', 239093),
(300870, 'PTHR47993:SF238', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300871, 'PTHR47993:SF117', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300872, 'PTHR47993:SF118', NULL, NULL, NULL, NULL, 'OS08G0492900 PROTEIN', 239093),
(300873, 'PTHR47993:SF239', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300874, 'PTHR47993:SF234', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300875, 'PTHR47993:SF237', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300876, 'PTHR47993:SF111', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', 239093);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(300877, 'PTHR47993:SF267', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300878, 'PTHR47993:SF147', NULL, NULL, NULL, NULL, 'FBA_1 DOMAIN-CONTAINING PROTEIN', 239093),
(300879, 'PTHR47993:SF268', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300880, 'PTHR47993:SF269', NULL, NULL, NULL, NULL, 'F-BOX ASSOCIATED UBIQUITINATION EFFECTOR FAMILY PROTEIN', 239093),
(300881, 'PTHR47993:SF148', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300882, 'PTHR47993:SF149', NULL, NULL, NULL, NULL, 'BSD DOMAIN PROTEIN', 239093),
(300883, 'PTHR47993:SF263', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN', 239093),
(300884, 'PTHR47993:SF143', NULL, NULL, NULL, NULL, 'OS08G0474400 PROTEIN', 239093),
(300885, 'PTHR47993:SF264', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300886, 'PTHR47993:SF265', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300887, 'PTHR47993:SF266', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300888, 'PTHR47993:SF260', NULL, NULL, NULL, NULL, 'OS07G0196300 PROTEIN', 239093),
(300889, 'PTHR47993:SF261', NULL, NULL, NULL, NULL, 'FBA_1 DOMAIN-CONTAINING PROTEIN', 239093),
(300890, 'PTHR47993:SF262', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300891, 'PTHR47993:SF97', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300892, 'PTHR47993:SF96', NULL, NULL, NULL, NULL, 'OS04G0385100 PROTEIN', 239093),
(300893, 'PTHR47993:SF99', NULL, NULL, NULL, NULL, 'OS02G0563800 PROTEIN', 239093),
(300894, 'PTHR47993:SF98', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300895, 'PTHR47993:SF93', NULL, NULL, NULL, NULL, 'OS04G0195100 PROTEIN', 239093),
(300896, 'PTHR47993:SF95', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300897, 'PTHR47993:SF139', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE PROTEIN', 239093),
(300898, 'PTHR47993:SF256', NULL, NULL, NULL, NULL, 'AND ASSOCIATED INTERACTION DOMAIN PROTEIN, PUTATIVE-RELATED', 239093),
(300899, 'PTHR47993:SF135', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300900, 'PTHR47993:SF257', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300901, 'PTHR47993:SF137', NULL, NULL, NULL, NULL, 'FBA_1 DOMAIN-CONTAINING PROTEIN', 239093),
(300902, 'PTHR47993:SF258', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300903, 'PTHR47993:SF259', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300904, 'PTHR47993:SF252', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300905, 'PTHR47993:SF131', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300906, 'PTHR47993:SF253', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300907, 'PTHR47993:SF254', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300908, 'PTHR47993:SF255', NULL, NULL, NULL, NULL, 'F-BOX ASSOCIATED UBIQUITINATION EFFECTOR FAMILY PROTEIN', 239093),
(300909, 'PTHR47993:SF134', NULL, NULL, NULL, NULL, 'BNAC09G13870D PROTEIN', 239093),
(300910, 'PTHR47993:SF250', NULL, NULL, NULL, NULL, 'F-BOX ASSOCIATED UBIQUITINATION EFFECTOR FAMILY PROTEIN', 239093),
(300911, 'PTHR47993:SF251', NULL, NULL, NULL, NULL, 'OS12G0568600 PROTEIN', 239093),
(300912, 'PTHR47993:SF86', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300913, 'PTHR47993:SF88', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300914, 'PTHR47993:SF290', NULL, NULL, NULL, NULL, 'BNACNNG09650D PROTEIN', 239093),
(300915, 'PTHR47993:SF291', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300916, 'PTHR47993:SF170', NULL, NULL, NULL, NULL, 'FBA_1 DOMAIN-CONTAINING PROTEIN', 239093),
(300917, 'PTHR47993:SF80', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300918, 'PTHR47993:SF82', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300919, 'PTHR47993:SF83', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(300920, 'PTHR47993:SF289', NULL, NULL, NULL, NULL, 'F-BOX ASSOCIATED UBIQUITINATION EFFECTOR FAMILY PROTEIN', 239093),
(300921, 'PTHR47993:SF169', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300922, 'PTHR47993:SF164', NULL, NULL, NULL, NULL, 'FBA_3 DOMAIN-CONTAINING PROTEIN', 239093),
(300923, 'PTHR47993:SF285', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300924, 'PTHR47993:SF286', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN CPR30-LIKE', 239093),
(300925, 'PTHR47993:SF165', NULL, NULL, NULL, NULL, 'F-BOX ASSOCIATED UBIQUITINATION EFFECTOR FAMILY PROTEIN', 239093),
(300926, 'PTHR47993:SF287', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300927, 'PTHR47993:SF167', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 239093),
(300928, 'PTHR47993:SF288', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300929, 'PTHR47993:SF281', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300930, 'PTHR47993:SF282', NULL, NULL, NULL, NULL, 'OS03G0366350 PROTEIN', 239093),
(300931, 'PTHR47993:SF283', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN INTERACTION DOMAIN PROTEIN', 239093),
(300932, 'PTHR47993:SF284', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN CPR30-LIKE', 239093),
(300933, 'PTHR47993:SF163', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300934, 'PTHR47993:SF77', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300935, 'PTHR47993:SF280', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300936, 'PTHR47993:SF76', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300937, 'PTHR47993:SF70', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 9-RELATED', 239093),
(300938, 'PTHR47993:SF73', NULL, NULL, NULL, NULL, 'FBA_1 DOMAIN-CONTAINING PROTEIN', 239093),
(300939, 'PTHR47993:SF72', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300940, 'PTHR47993:SF278', NULL, NULL, NULL, NULL, 'OS06G0300900 PROTEIN', 239093),
(300941, 'PTHR47993:SF279', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN CPR30-LIKE', 239093),
(300942, 'PTHR47993:SF159', NULL, NULL, NULL, NULL, 'F-BOX FAMILY PROTEIN', 239093),
(300943, 'PTHR47993:SF274', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300944, 'PTHR47993:SF154', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300945, 'PTHR47993:SF275', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300946, 'PTHR47993:SF276', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300947, 'PTHR47993:SF277', NULL, NULL, NULL, NULL, 'FBA_3 DOMAIN-CONTAINING PROTEIN', 239093),
(300948, 'PTHR47993:SF270', NULL, NULL, NULL, NULL, 'FBA_1 DOMAIN-CONTAINING PROTEIN', 239093),
(300949, 'PTHR47993:SF271', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300950, 'PTHR47993:SF151', NULL, NULL, NULL, NULL, 'F-BOX FAMILY PROTEIN', 239093),
(300951, 'PTHR47993:SF272', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE-RELATED', 239093),
(300952, 'PTHR47993:SF152', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE-RELATED', 239093),
(300953, 'PTHR47993:SF273', NULL, NULL, NULL, NULL, 'FBA_1 DOMAIN-CONTAINING PROTEIN', 239093),
(300954, 'PTHR47993:SF64', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300955, 'PTHR47993:SF66', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300956, 'PTHR47993:SF65', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300957, 'PTHR47993:SF69', NULL, NULL, NULL, NULL, 'BNAA05G20300D PROTEIN', 239093),
(300958, 'PTHR47993:SF60', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300959, 'PTHR47993:SF182', NULL, NULL, NULL, NULL, 'F-BOX/WD-40 REPEAT-CONTAINING PROTEIN 1', 239093),
(300960, 'PTHR47993:SF52', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300961, 'PTHR47993:SF180', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300962, 'PTHR47993:SF55', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(300963, 'PTHR47993:SF181', NULL, NULL, NULL, NULL, 'F-BOX ASSOCIATED UBIQUITINATION EFFECTOR FAMILY PROTEIN-RELATED', 239093),
(300964, 'PTHR47993:SF56', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300965, 'PTHR47993:SF51', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300966, 'PTHR47993:SF175', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300967, 'PTHR47993:SF296', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300968, 'PTHR47993:SF297', NULL, NULL, NULL, NULL, 'BNAA02G27110D PROTEIN', 239093),
(300969, 'PTHR47993:SF176', NULL, NULL, NULL, NULL, 'PROTEIN SUPPRESSOR OF NIM1 1', 239093),
(300970, 'PTHR47993:SF298', NULL, NULL, NULL, NULL, 'F-BOX ASSOCIATED UBIQUITINATION EFFECTOR FAMILY PROTEIN', 239093),
(300971, 'PTHR47993:SF177', NULL, NULL, NULL, NULL, 'OS04G0384500 PROTEIN', 239093),
(300972, 'PTHR47993:SF178', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300973, 'PTHR47993:SF299', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300974, 'PTHR47993:SF292', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300975, 'PTHR47993:SF171', NULL, NULL, NULL, NULL, 'FBA_1 DOMAIN-CONTAINING PROTEIN', 239093),
(300976, 'PTHR47993:SF293', NULL, NULL, NULL, NULL, 'FBA_1 DOMAIN-CONTAINING PROTEIN', 239093),
(300977, 'PTHR47993:SF173', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300978, 'PTHR47993:SF294', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE', 239093),
(300979, 'PTHR47993:SF295', NULL, NULL, NULL, NULL, 'OS05G0303900 PROTEIN', 239093),
(300980, 'PTHR47993:SF174', NULL, NULL, NULL, NULL, 'OS05G0116300 PROTEIN', 239093),
(300981, 'PTHR47993:SF48', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300982, 'PTHR47993:SF49', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN-RELATED', 239093),
(300983, 'PTHR47993:SF30', NULL, NULL, NULL, NULL, 'OS02G0543200 PROTEIN', 239093),
(300984, 'PTHR47993:SF32', NULL, NULL, NULL, NULL, '', 239093),
(300985, 'PTHR47993:SF35', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239093),
(300986, 'PTHR47993:SF37', NULL, NULL, NULL, NULL, 'F-BOX ASSOCIATED UBIQUITINATION EFFECTOR FAMILY PROTEIN', 239093),
(300987, 'PTHR47993:SF197', NULL, NULL, NULL, NULL, '', 239093),
(300988, 'PTHR47993:SF196', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN INTERACTION DOMAIN CONTAINING PROTEIN, EXPRESSED', 239093),
(300989, 'PTHR39428', NULL, NULL, NULL, NULL, 'F420H(2)-DEPENDENT QUINONE REDUCTASE RV1261C', 239094),
(300990, 'PTHR39428:SF1', NULL, NULL, NULL, NULL, 'F420H(2)-DEPENDENT QUINONE REDUCTASE RV1261C', 239094),
(300991, 'PTHR39428:SF3', NULL, NULL, NULL, NULL, 'DEAZAFLAVIN-DEPENDENT NITROREDUCTASE', 239094),
(300992, 'PTHR35466:SF4', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 239095),
(300993, 'PTHR35466:SF3', NULL, NULL, NULL, NULL, 'BNAA06G15420D PROTEIN', 239095),
(300994, 'PTHR35466:SF8', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239095),
(300995, 'PTHR35466:SF6', NULL, NULL, NULL, NULL, 'BNACNNG09780D PROTEIN', 239095),
(300996, 'PTHR35466', NULL, NULL, NULL, NULL, 'SERINE/ARGININE REPETITIVE MATRIX PROTEIN 1', 239095),
(300997, 'PTHR47564:SF1', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH AND TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN 1', 239096),
(300998, 'PTHR47564', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH AND TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN 1', 239096),
(300999, 'PTHR46497:SF1', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN 11', 239097),
(301000, 'PTHR46497', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN 11', 239097),
(301001, 'PTHR12333', NULL, NULL, NULL, NULL, 'COMM DOMAIN CONTAINING PROTEIN 10', 239098),
(301002, 'PTHR12333:SF0', NULL, NULL, NULL, NULL, 'COMM DOMAIN-CONTAINING PROTEIN 10', 239098),
(301003, 'PTHR18884:SF57', NULL, NULL, NULL, NULL, 'CELL DIVISION CONTROL PROTEIN 10', 239099),
(301004, 'PTHR18884:SF55', NULL, NULL, NULL, NULL, 'SEPTIN-6', 239099),
(301005, 'PTHR18884:SF117', NULL, NULL, NULL, NULL, 'SEPTIN', 239099);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(301006, 'PTHR18884:SF54', NULL, NULL, NULL, NULL, 'SEPTIN-8', 239099),
(301007, 'PTHR18884:SF51', NULL, NULL, NULL, NULL, 'SEPTIN-14', 239099),
(301008, 'PTHR18884:SF71', NULL, NULL, NULL, NULL, 'SEPTIN-4', 239099),
(301009, 'PTHR18884:SF50', NULL, NULL, NULL, NULL, 'SEPTIN-10', 239099),
(301010, 'PTHR18884:SF130', NULL, NULL, NULL, NULL, 'SEPTIN', 239099),
(301011, 'PTHR18884:SF131', NULL, NULL, NULL, NULL, 'SEPTIN HOMOLOG SPN5', 239099),
(301012, 'PTHR18884:SF70', NULL, NULL, NULL, NULL, 'SEPTIN', 239099),
(301013, 'PTHR18884:SF132', NULL, NULL, NULL, NULL, 'SEPTIN HOMOLOG SPN3', 239099),
(301014, 'PTHR18884:SF110', NULL, NULL, NULL, NULL, 'SEPTIN-TYPE G DOMAIN-CONTAINING PROTEIN', 239099),
(301015, 'PTHR18884:SF133', NULL, NULL, NULL, NULL, 'SEPTIN HOMOLOG SPN6', 239099),
(301016, 'PTHR18884:SF115', NULL, NULL, NULL, NULL, 'SEPTIN', 239099),
(301017, 'PTHR18884', NULL, NULL, NULL, NULL, 'SEPTIN', 239099),
(301018, 'PTHR18884:SF48', NULL, NULL, NULL, NULL, 'SEPTIN-11', 239099),
(301019, 'PTHR18884:SF68', NULL, NULL, NULL, NULL, 'SEPTIN-5', 239099),
(301020, 'PTHR18884:SF24', NULL, NULL, NULL, NULL, 'SPORULATION-REGULATED PROTEIN 3', 239099),
(301021, 'PTHR18884:SF69', NULL, NULL, NULL, NULL, 'SEPTIN-RELATED', 239099),
(301022, 'PTHR18884:SF47', NULL, NULL, NULL, NULL, 'SEPTIN-9', 239099),
(301023, 'PTHR18884:SF66', NULL, NULL, NULL, NULL, 'SEPTIN-12', 239099),
(301024, 'PTHR18884:SF127', NULL, NULL, NULL, NULL, 'SEPTIN-7', 239099),
(301025, 'PTHR18884:SF128', NULL, NULL, NULL, NULL, 'AIG1-TYPE G DOMAIN-CONTAINING PROTEIN-RELATED', 239099),
(301026, 'PTHR18884:SF67', NULL, NULL, NULL, NULL, 'SEPTIN-2', 239099),
(301027, 'PTHR18884:SF129', NULL, NULL, NULL, NULL, 'SEPTIN-7', 239099),
(301028, 'PTHR18884:SF64', NULL, NULL, NULL, NULL, 'SEPTIN-2', 239099),
(301029, 'PTHR18884:SF108', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 250', 239099),
(301030, 'PTHR18884:SF21', NULL, NULL, NULL, NULL, 'SPORULATION-REGULATED PROTEIN 28', 239099),
(301031, 'PTHR18884:SF62', NULL, NULL, NULL, NULL, 'NEURONAL-SPECIFIC SEPTIN-3', 239099),
(301032, 'PTHR18884:SF84', NULL, NULL, NULL, NULL, 'SEVENTH HOMOLOG OF SEPTIN 1', 239099),
(301033, 'PTHR18884:SF109', NULL, NULL, NULL, NULL, 'SEPTIN-1', 239099),
(301034, 'PTHR18884:SF83', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN-RELATED', 239099),
(301035, 'PTHR18884:SF6', NULL, NULL, NULL, NULL, 'SEPTIN-1', 239099),
(301036, 'PTHR18884:SF123', NULL, NULL, NULL, NULL, 'CELL DIVISION CONTROL PROTEIN 11', 239099),
(301037, 'PTHR18884:SF126', NULL, NULL, NULL, NULL, 'SEPTIN', 239099),
(301038, 'PTHR10361:SF65', NULL, NULL, NULL, NULL, '', 239100),
(301039, 'PTHR10361:SF40', NULL, NULL, NULL, NULL, 'SODIUM/BILE ACID COTRANSPORTER', 239100),
(301040, 'PTHR10361:SF62', NULL, NULL, NULL, NULL, 'SODIUM/PYRUVATE COTRANSPORTER BASS2, CHLOROPLASTIC', 239100),
(301041, 'PTHR10361:SF41', NULL, NULL, NULL, NULL, 'SODIUM/BILE ACID COTRANSPORTER 4', 239100),
(301042, 'PTHR10361:SF63', NULL, NULL, NULL, NULL, 'BILE ACID:SODIUM SYMPORTER/ARSENICAL RESISTANCE PROTEIN ACR3-RELATED', 239100),
(301043, 'PTHR10361:SF30', NULL, NULL, NULL, NULL, 'SODIUM/METABOLITE COTRANSPORTER BASS6, CHLOROPLASTIC-RELATED', 239100),
(301044, 'PTHR10361:SF24', NULL, NULL, NULL, NULL, 'P3 PROTEIN', 239100),
(301045, 'PTHR10361:SF58', NULL, NULL, NULL, NULL, 'SODIUM/METABOLITE COTRANSPORTER BASS2, CHLOROPLASTIC-RELATED', 239100),
(301046, 'PTHR10361:SF55', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 10 MEMBER 6', 239100),
(301047, 'PTHR10361:SF66', NULL, NULL, NULL, NULL, 'BILE ACID-SODIUM SYMPORTER FAMILY PROTEIN', 239100),
(301048, 'PTHR10361:SF33', NULL, NULL, NULL, NULL, 'SODIUM/METABOLITE COTRANSPORTER BASS3, CHLOROPLASTIC-RELATED', 239100),
(301049, 'PTHR10361:SF61', NULL, NULL, NULL, NULL, 'SODIUM/METABOLITE COTRANSPORTER BASS5, CHLOROPLASTIC-RELATED', 239100),
(301050, 'PTHR10361:SF28', NULL, NULL, NULL, NULL, 'RH04535P', 239100),
(301051, 'PTHR10361:SF29', NULL, NULL, NULL, NULL, 'SODIUM/BILE ACID COTRANSPORTER 5', 239100),
(301052, 'PTHR10361', NULL, NULL, NULL, NULL, 'SODIUM-BILE ACID COTRANSPORTER', 239100);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(301053, 'PTHR10361:SF19', NULL, NULL, NULL, NULL, 'ILEAL SODIUM/BILE ACID COTRANSPORTER', 239100),
(301054, 'PTHR10361:SF3', NULL, NULL, NULL, NULL, 'P3 PROTEIN', 239100),
(301055, 'PTHR47079:SF1', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING PROTEIN-LIKE', 239101),
(301056, 'PTHR47079', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING PROTEIN-LIKE', 239101),
(301057, 'PTHR22624:SF35', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE ATG4A', 239102),
(301058, 'PTHR22624', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE ATG4', 239102),
(301059, 'PTHR22624:SF59', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE', 239102),
(301060, 'PTHR22624:SF36', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE ATG4D', 239102),
(301061, 'PTHR22624:SF58', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE ATG4', 239102),
(301062, 'PTHR22624:SF53', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE', 239102),
(301063, 'PTHR22624:SF52', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE', 239102),
(301064, 'PTHR22624:SF55', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE', 239102),
(301065, 'PTHR22624:SF54', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE ATG4B', 239102),
(301066, 'PTHR22624:SF39', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE ATG4B', 239102),
(301067, 'PTHR22624:SF49', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE', 239102),
(301068, 'PTHR22624:SF38', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE ATG4C', 239102),
(301069, 'PTHR41307', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 239103),
(301070, 'PTHR41307:SF1', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 239103),
(301071, 'PTHR47176', NULL, NULL, NULL, NULL, 'OSJNBA0020J04.13 PROTEIN', 239104),
(301072, 'PTHR47176:SF2', NULL, NULL, NULL, NULL, 'T21P5.8 PROTEIN', 239104),
(301073, 'PTHR47176:SF3', NULL, NULL, NULL, NULL, 'RELATED DNASE, PUTATIVE-RELATED', 239104),
(301074, 'PTHR47176:SF1', NULL, NULL, NULL, NULL, 'OS04G0577500 PROTEIN', 239104),
(301075, 'PTHR34051', NULL, NULL, NULL, NULL, 'PROTEIN LOW PSII ACCUMULATION 3, CHLOROPLASTIC', 239105),
(301076, 'PTHR34051:SF2', NULL, NULL, NULL, NULL, 'PROTEIN LPA3', 239105),
(301077, 'PTHR34051:SF1', NULL, NULL, NULL, NULL, 'DUF1995 DOMAIN-CONTAINING PROTEIN', 239105),
(301078, 'PTHR30413', NULL, NULL, NULL, NULL, 'INNER MEMBRANE TRANSPORT PERMEASE', 239106),
(301079, 'PTHR30413:SF10', NULL, NULL, NULL, NULL, 'CAPSULE POLYSACCHARIDE EXPORT INNER-MEMBRANE PROTEIN CTRC', 239106),
(301080, 'PTHR30413:SF8', NULL, NULL, NULL, NULL, 'TRANSPORT PERMEASE PROTEIN', 239106),
(301081, 'PTHR21347', NULL, NULL, NULL, NULL, 'CLEFT LIP AND PALATE ASSOCIATED TRANSMEMBRANE PROTEIN-RELATED', 239107),
(301082, 'PTHR21347:SF0', NULL, NULL, NULL, NULL, 'CLEFT LIP AND PALATE TRANSMEMBRANE PROTEIN 1-LIKE PROTEIN', 239107),
(301083, 'PTHR21347:SF11', NULL, NULL, NULL, NULL, 'BNAA09G05230D PROTEIN', 239107),
(301084, 'PTHR21347:SF13', NULL, NULL, NULL, NULL, 'PROTEIN CBG10971', 239107),
(301085, 'PTHR21347:SF14', NULL, NULL, NULL, NULL, 'CLEFT LIP AND PALATE TRANSMEMBRANE PROTEIN 1', 239107),
(301086, 'PTHR39556', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 239108),
(301087, 'PTHR39556:SF1', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 239108),
(301088, 'PTHR21184:SF4', NULL, NULL, NULL, NULL, 'PROTEIN FAM151A', 239109),
(301089, 'PTHR21184:SF3', NULL, NULL, NULL, NULL, 'PROTEIN FAM151B', 239109),
(301090, 'PTHR21184', NULL, NULL, NULL, NULL, 'MENORIN (DENDRITIC BRANCHING PROTEIN)', 239109),
(301091, 'PTHR21184:SF6', NULL, NULL, NULL, NULL, 'MENORIN (DENDRITIC BRANCHING PROTEIN)', 239109),
(301092, 'PTHR34719:SF2', NULL, NULL, NULL, NULL, 'NICKEL-RESPONSIVE REGULATOR', 239110),
(301093, 'PTHR34719', NULL, NULL, NULL, NULL, 'NICKEL-RESPONSIVE REGULATOR', 239110),
(301094, 'PTHR22956:SF26', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 239111),
(301095, 'PTHR22956:SF15', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 239111),
(301096, 'PTHR22956:SF14', NULL, NULL, NULL, NULL, 'PROTEIN CBG17766', 239111),
(301097, 'PTHR22956:SF17', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN-RELATED', 239111);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(301098, 'PTHR22956', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING PROTEIN F37A4.4-RELATED-RELATED', 239111),
(301099, 'PTHR22956:SF18', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 239111),
(301100, 'PTHR21193', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE-LIKE DOMAIN-CONTAINING PROTEIN 1', 239112),
(301101, 'PTHR21193:SF3', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE-LIKE DOMAIN-CONTAINING PROTEIN 1', 239112),
(301102, 'PTHR42924:SF3', NULL, NULL, NULL, NULL, 'POLIIIAC DOMAIN-CONTAINING PROTEIN', 239113),
(301103, 'PTHR42924:SF11', NULL, NULL, NULL, NULL, 'POLIIIAC DOMAIN-CONTAINING PROTEIN', 239113),
(301104, 'PTHR42924', NULL, NULL, NULL, NULL, 'EXONUCLEASE', 239113),
(301105, 'PTHR42924:SF13', NULL, NULL, NULL, NULL, 'OS02G0752600 PROTEIN', 239113),
(301106, 'PTHR42924:SF16', NULL, NULL, NULL, NULL, 'POLIIIAC DOMAIN-CONTAINING PROTEIN', 239113),
(301107, 'PTHR15527:SF0', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM6 HOMOLOG', 239114),
(301108, 'PTHR15527', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM6 HOMOLOG', 239114),
(301109, 'PTHR13563:SF19', NULL, NULL, NULL, NULL, 'TRNA METHYLTRANSFERASE 10 HOMOLOG B', 239115),
(301110, 'PTHR13563:SF17', NULL, NULL, NULL, NULL, 'TRNA (GUANINE(9)-N(1))-METHYLTRANSFERASE', 239115),
(301111, 'PTHR13563:SF13', NULL, NULL, NULL, NULL, 'TRNA METHYLTRANSFERASE 10 HOMOLOG A', 239115),
(301112, 'PTHR13563:SF5', NULL, NULL, NULL, NULL, 'TRNA METHYLTRANSFERASE 10 HOMOLOG C', 239115),
(301113, 'PTHR13563:SF12', NULL, NULL, NULL, NULL, 'PROTEIN CBG09110', 239115),
(301114, 'PTHR13563', NULL, NULL, NULL, NULL, 'TRNA (GUANINE-9-) METHYLTRANSFERASE', 239115),
(301115, 'PTHR45445:SF2', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 239116),
(301116, 'PTHR45445', NULL, NULL, NULL, NULL, '', 239116),
(301117, 'PTHR12472:SF0', NULL, NULL, NULL, NULL, 'RAB3 GTPASE-ACTIVATING PROTEIN NON-CATALYTIC SUBUNIT', 239117),
(301118, 'PTHR12472', NULL, NULL, NULL, NULL, 'RAB3-GAP REGULATORY DOMAIN', 239117),
(301119, 'PTHR35129', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT GAMMA 1', 239118),
(301120, 'PTHR35129:SF5', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT GAMMA 2', 239118),
(301121, 'PTHR35129:SF4', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT GAMMA 2-LIKE', 239118),
(301122, 'PTHR35129:SF1', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT GAMMA 1', 239118),
(301123, 'PTHR13428:SF10', NULL, NULL, NULL, NULL, 'INNER NUCLEAR MEMBRANE PROTEIN MAN1', 239119),
(301124, 'PTHR13428:SF8', NULL, NULL, NULL, NULL, 'LEM DOMAIN-CONTAINING PROTEIN 2', 239119),
(301125, 'PTHR13428:SF12', NULL, NULL, NULL, NULL, 'INNER NUCLEAR MEMBRANE PROTEIN MAN1', 239119),
(301126, 'PTHR13428:SF15', NULL, NULL, NULL, NULL, 'RNA BINDING MOTIF PROTEIN HOMOLOG', 239119),
(301127, 'PTHR13428', NULL, NULL, NULL, NULL, 'INNER NUCLEAR MEMBRANE PROTEIN MAN1  LEM DOMAIN CONTAINING PROTEIN', 239119),
(301128, 'PTHR46679', NULL, NULL, NULL, NULL, '', 239120),
(301129, 'PTHR46679:SF1', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-2, MITOCHONDRIAL', 239120),
(301130, 'PTHR46679:SF3', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 239120),
(301131, 'PTHR46679:SF4', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 239120),
(301132, 'PTHR20935', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE-RELATED', 239121),
(301133, 'PTHR20935:SF1', NULL, NULL, NULL, NULL, 'SLL1549 PROTEIN', 239121),
(301134, 'PTHR20935:SF0', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PGAM5, MITOCHONDRIAL', 239121),
(301135, 'PTHR21525', NULL, NULL, NULL, NULL, 'MOTILE SPERM PROTEIN', 239122),
(301136, 'PTHR21525:SF9', NULL, NULL, NULL, NULL, 'PHAGE-LIKE ELEMENT PBSX PROTEIN XKDO', 239122),
(301137, 'PTHR21525:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG12274', 239122),
(301138, 'PTHR24300:SF89', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 516B1-RELATED', 239123),
(301139, 'PTHR24300:SF88', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 518A1-RELATED', 239123);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(301140, 'PTHR24300:SF86', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY', 239123),
(301141, 'PTHR24300:SF48', NULL, NULL, NULL, NULL, 'VITAMIN D 25-HYDROXYLASE', 239123),
(301142, 'PTHR24300:SF81', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY', 239123),
(301143, 'PTHR24300:SF84', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 2, SUBFAMILY T, POLYPEPTIDE 4', 239123),
(301144, 'PTHR24300:SF319', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 2K6-RELATED', 239123),
(301145, 'PTHR24300:SF118', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 508C1-RELATED', 239123),
(301146, 'PTHR24300:SF119', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 2D10-RELATED', 239123),
(301147, 'PTHR24300:SF317', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 2C8', 239123),
(301148, 'PTHR24300:SF114', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY', 239123),
(301149, 'PTHR24300:SF356', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 2E1', 239123),
(301150, 'PTHR24300:SF277', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 2B19-RELATED', 239123),
(301151, 'PTHR24300:SF310', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 555A1-RELATED', 239123),
(301152, 'PTHR24300:SF157', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 MONOOXYGENASE 521A1-RELATED', 239123),
(301153, 'PTHR24300:SF278', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY', 239123),
(301154, 'PTHR24300:SF275', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 2F1', 239123),
(301155, 'PTHR24300:SF110', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 508D1-RELATED', 239123),
(301156, 'PTHR24300:SF353', NULL, NULL, NULL, NULL, '3-KETOSTEROID OXYGENASE', 239123),
(301157, 'PTHR24300:SF196', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY', 239123),
(301158, 'PTHR24300:SF153', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 2B6', 239123),
(301159, 'PTHR24300:SF99', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 516A1-RELATED', 239123),
(301160, 'PTHR24300:SF209', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY', 239123),
(301161, 'PTHR24300:SF327', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP2X10-RELATED', 239123),
(301162, 'PTHR24300:SF328', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 508B1-RELATED', 239123),
(301163, 'PTHR24300:SF369', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY', 239123),
(301164, 'PTHR24300:SF326', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 2AA2-RELATED', 239123),
(301165, 'PTHR24300:SF367', NULL, NULL, NULL, NULL, '4-NITROPHENOL 2-HYDROXYLASE', 239123),
(301166, 'PTHR24300:SF368', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 2, SUBFAMILY AB, POLYPEPTIDE 1', 239123),
(301167, 'PTHR24300:SF365', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 306A1', 239123),
(301168, 'PTHR24300:SF200', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 2C70', 239123),
(301169, 'PTHR24300:SF201', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 515B1-RELATED', 239123),
(301170, 'PTHR24300:SF289', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 2, SUBFAMILY J, POLYPEPTIDE 12', 239123),
(301171, 'PTHR24300:SF366', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 2B9-RELATED', 239123),
(301172, 'PTHR24300:SF363', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 508A4-RELATED', 239123),
(301173, 'PTHR24300:SF122', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY', 239123),
(301174, 'PTHR24300:SF364', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 2U1', 239123),
(301175, 'PTHR24300:SF285', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY', 239123),
(301176, 'PTHR24300:SF362', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY', 239123),
(301177, 'PTHR24300:SF360', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 2C19', 239123),
(301178, 'PTHR24300:SF281', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 18A1', 239123),
(301179, 'PTHR24300:SF23', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 2S1', 239123),
(301180, 'PTHR24300:SF180', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 2A6', 239123),
(301181, 'PTHR24300:SF338', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP36A1-RELATED', 239123),
(301182, 'PTHR24300:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 2D6-RELATED', 239123),
(301183, 'PTHR24300:SF339', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 2B4', 239123),
(301184, 'PTHR24300:SF336', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 2C9', 239123);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(301185, 'PTHR24300:SF134', NULL, NULL, NULL, NULL, '', 239123),
(301186, 'PTHR24300:SF376', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 15A1', 239123),
(301187, 'PTHR24300:SF374', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 2C18', 239123),
(301188, 'PTHR24300:SF297', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 2A7', 239123),
(301189, 'PTHR24300:SF177', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 2J2', 239123),
(301190, 'PTHR24300:SF375', NULL, NULL, NULL, NULL, 'UNSPECIFIC MONOOXYGENASE', 239123),
(301191, 'PTHR24300:SF372', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 2. SUBFAMILY C, POLYPEPTIDE 37', 239123),
(301192, 'PTHR24300:SF373', NULL, NULL, NULL, NULL, '', 239123),
(301193, 'PTHR24300:SF296', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 508A1-RELATED', 239123),
(301194, 'PTHR24300:SF370', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 239123),
(301195, 'PTHR24300:SF371', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY', 239123),
(301196, 'PTHR24300:SF291', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 2W1', 239123),
(301197, 'PTHR24300:SF79', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY', 239123),
(301198, 'PTHR24300:SF309', NULL, NULL, NULL, NULL, 'CYTOCHROME P450-RELATED', 239123),
(301199, 'PTHR24300:SF109', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 2D26', 239123),
(301200, 'PTHR24300', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 508A4-RELATED', 239123),
(301201, 'PTHR24300:SF349', NULL, NULL, NULL, NULL, 'STEROID 21-HYDROXYLASE', 239123),
(301202, 'PTHR24300:SF108', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP2J9-RELATED', 239123),
(301203, 'PTHR24300:SF303', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY', 239123),
(301204, 'PTHR24300:SF105', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY', 239123),
(301205, 'PTHR24300:SF348', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY', 239123),
(301206, 'PTHR24300:SF301', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 2, SUBFAMILY J, POLYPEPTIDE 23-RELATED', 239123),
(301207, 'PTHR24300:SF147', NULL, NULL, NULL, NULL, 'PROTEIN CBR-CYP-34A4', 239123),
(301208, 'PTHR24300:SF103', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 2A13', 239123),
(301209, 'PTHR24300:SF346', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 2C44', 239123),
(301210, 'PTHR24300:SF104', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 508A2-RELATED', 239123),
(301211, 'PTHR24300:SF302', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 2K1-LIKE', 239123),
(301212, 'PTHR24300:SF342', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 2C55', 239123),
(301213, 'PTHR24300:SF142', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 2, SUBFAMILY J, POLYPEPTIDE 11-RELATED', 239123),
(301214, 'PTHR24300:SF340', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 2, SUBFAMILY G, POLYPEPTIDE 1', 239123),
(301215, 'PTHR24300:SF140', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 2C40-RELATED', 239123),
(301216, 'PTHR24300:SF181', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY', 239123),
(301217, 'PTHR43048:SF5', NULL, NULL, NULL, NULL, 'BLR5325 PROTEIN', 239124),
(301218, 'PTHR43048:SF4', NULL, NULL, NULL, NULL, 'LYASE-RELATED', 239124),
(301219, 'PTHR43048:SF3', NULL, NULL, NULL, NULL, 'METHYLMALONYL-COA EPIMERASE, MITOCHONDRIAL', 239124),
(301220, 'PTHR43048', NULL, NULL, NULL, NULL, 'METHYLMALONYL-COA EPIMERASE', 239124),
(301221, 'PTHR19879', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID', 239125),
(301222, 'PTHR19879:SF9', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 239125),
(301223, 'PTHR19879:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 5', 239125),
(301224, 'PTHR19879:SF7', NULL, NULL, NULL, NULL, 'PROTEASOMAL ATPASE-ASSOCIATED FACTOR 1', 239125),
(301225, 'PTHR19879:SF6', NULL, NULL, NULL, NULL, 'TAF5-LIKE RNA POLYMERASE II P300/CBP-ASSOCIATED FACTOR-ASSOCIATED FACTOR 65 KDA SUBUNIT 5L', 239125),
(301226, 'PTHR19879:SF5', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 55 HOMOLOG', 239125),
(301227, 'PTHR19879:SF4', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 5', 239125),
(301228, 'PTHR19879:SF1', NULL, NULL, NULL, NULL, 'CANNONBALL-RELATED', 239125);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(301229, 'PTHR46483:SF6', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 239126),
(301230, 'PTHR46483:SF7', NULL, NULL, NULL, NULL, 'ALPHA/BETA HYDROLASE FOLD PROTEIN-RELATED', 239126),
(301231, 'PTHR46483', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1 PLIP2, CHLOROPLASTIC', 239126),
(301232, 'PTHR46483:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1 PLIP1, CHLOROPLASTIC', 239126),
(301233, 'PTHR46483:SF3', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 239126),
(301234, 'PTHR46483:SF4', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1 PLIP2, CHLOROPLASTIC', 239126),
(301235, 'PTHR46483:SF5', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1 PLIP3, CHLOROPLASTIC', 239126),
(301236, 'PTHR35492', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN', 239127),
(301237, 'PTHR35492:SF1', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN', 239127),
(301238, 'PTHR31570:SF1', NULL, NULL, NULL, NULL, 'HAUS AUGMIN-LIKE COMPLEX SUBUNIT 1', 239128),
(301239, 'PTHR31570', NULL, NULL, NULL, NULL, 'HAUS AUGMIN-LIKE COMPLEX SUBUNIT 1', 239128),
(301240, 'PTHR37156:SF1', NULL, NULL, NULL, NULL, '', 239129),
(301241, 'PTHR37156', NULL, NULL, NULL, NULL, '', 239129),
(301242, 'PTHR37156:SF2', NULL, NULL, NULL, NULL, '', 239129),
(301243, 'PTHR20881:SF1', NULL, NULL, NULL, NULL, '3-METHYL-2-OXOBUTANOATE HYDROXYMETHYLTRANSFERASE', 239130),
(301244, 'PTHR20881:SF0', NULL, NULL, NULL, NULL, '3-METHYL-2-OXOBUTANOATE HYDROXYMETHYLTRANSFERASE', 239130),
(301245, 'PTHR20881', NULL, NULL, NULL, NULL, '3-METHYL-2-OXOBUTANOATE HYDROXYMETHYLTRANSFERASE', 239130),
(301246, 'PTHR14107:SF21', NULL, NULL, NULL, NULL, 'WD40/YVTN REPEAT-LIKE-CONTAINING DOMAIN-CONTAINING PROTEIN-RELATED', 239131),
(301247, 'PTHR14107:SF23', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 20-LIKE', 239131),
(301248, 'PTHR14107:SF22', NULL, NULL, NULL, NULL, 'LOW QUALITY PROTEIN: WD REPEAT-CONTAINING PROTEIN 20-LIKE', 239131),
(301249, 'PTHR14107:SF5', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 20', 239131),
(301250, 'PTHR14107', NULL, NULL, NULL, NULL, 'WD REPEAT PROTEIN', 239131),
(301251, 'PTHR14107:SF16', NULL, NULL, NULL, NULL, 'AT02583P', 239131),
(301252, 'PTHR14107:SF15', NULL, NULL, NULL, NULL, 'DYSTROPHIA MYOTONICA WD REPEAT-CONTAINING PROTEIN', 239131),
(301253, 'PTHR14107:SF18', NULL, NULL, NULL, NULL, 'NUCLEOTIDE BINDING PROTEIN', 239131),
(301254, 'PTHR42892', NULL, NULL, NULL, NULL, 'GLUCOSAMINE-6-PHOSPHATE DEAMINASE-LIKE PROTEIN BT_0258-RELATED', 239132),
(301255, 'PTHR42892:SF1', NULL, NULL, NULL, NULL, 'GLUCOSAMINE-6-PHOSPHATE DEAMINASE', 239132),
(301256, 'PTHR10741:SF5', NULL, NULL, NULL, NULL, 'TRANSLIN-ASSOCIATED PROTEIN X', 239133),
(301257, 'PTHR10741:SF2', NULL, NULL, NULL, NULL, 'TRANSLIN', 239133),
(301258, 'PTHR10741', NULL, NULL, NULL, NULL, 'TRANSLIN AND TRANSLIN ASSOCIATED PROTEIN X', 239133),
(301259, 'PTHR11926:SF1319', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301260, 'PTHR11926:SF906', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 76C3-RELATED', 239134),
(301261, 'PTHR11926:SF1311', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301262, 'PTHR11926:SF1439', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301263, 'PTHR11926:SF1318', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301264, 'PTHR11926:SF1161', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301265, 'PTHR11926:SF1283', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301266, 'PTHR11926:SF870', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 75D1', 239134),
(301267, 'PTHR11926:SF1164', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 76C2', 239134),
(301268, 'PTHR11926:SF751', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301269, 'PTHR11926:SF1320', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301270, 'PTHR11926:SF1441', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301271, 'PTHR11926:SF1442', NULL, NULL, NULL, NULL, 'CROCETIN GLUCOSYLTRANSFERASE, CHLOROPLASTIC-LIKE', 239134);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(301272, 'PTHR11926:SF1321', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301273, 'PTHR11926:SF913', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE SUPERFAMILY PROTEIN-RELATED', 239134),
(301274, 'PTHR11926:SF1429', NULL, NULL, NULL, NULL, 'UDP-GLUCOSYL TRANSFERASE 76E1-RELATED', 239134),
(301275, 'PTHR11926:SF1421', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301276, 'PTHR11926:SF1389', NULL, NULL, NULL, NULL, '', 239134),
(301277, 'PTHR11926:SF1422', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301278, 'PTHR11926:SF1425', NULL, NULL, NULL, NULL, 'OS07G0241800 PROTEIN', 239134),
(301279, 'PTHR11926:SF1426', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE SUPERFAMILY PROTEIN-RELATED', 239134),
(301280, 'PTHR11926:SF1427', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301281, 'PTHR11926:SF1270', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 74D1', 239134),
(301282, 'PTHR11926:SF1391', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301283, 'PTHR11926:SF1392', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301284, 'PTHR11926:SF1395', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301285, 'PTHR11926:SF1396', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301286, 'PTHR11926:SF1034', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 76E1-RELATED', 239134),
(301287, 'PTHR11926:SF863', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301288, 'PTHR11926:SF1398', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301289, 'PTHR11926:SF744', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301290, 'PTHR11926:SF986', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 84A1', 239134),
(301291, 'PTHR11926:SF1454', NULL, NULL, NULL, NULL, 'UDPGT DOMAIN-CONTAINING PROTEIN', 239134),
(301292, 'PTHR11926:SF1333', NULL, NULL, NULL, NULL, 'BNAA10G12540D PROTEIN', 239134),
(301293, 'PTHR11926:SF1179', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301294, 'PTHR11926:SF1335', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301295, 'PTHR11926:SF1456', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 239134),
(301296, 'PTHR11926:SF1337', NULL, NULL, NULL, NULL, 'OS07G0240600 PROTEIN', 239134),
(301297, 'PTHR11926:SF1459', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301298, 'PTHR11926:SF1339', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301299, 'PTHR11926:SF1461', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301300, 'PTHR11926:SF970', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301301, 'PTHR11926:SF1341', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301302, 'PTHR11926:SF1462', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301303, 'PTHR11926:SF1342', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301304, 'PTHR11926:SF1188', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE-RELATED', 239134),
(301305, 'PTHR11926:SF1343', NULL, NULL, NULL, NULL, '7-DEOXYLOGANETIN GLUCOSYLTRANSFERASE-LIKE', 239134),
(301306, 'PTHR11926:SF1464', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 76B1', 239134),
(301307, 'PTHR11926:SF732', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 79', 239134),
(301308, 'PTHR11926:SF1322', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301309, 'PTHR11926:SF1047', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE IRIDOID GLUCOSYLTRANSFERASE-LIKE ISOFORM X1', 239134),
(301310, 'PTHR11926:SF1443', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301311, 'PTHR11926:SF1444', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301312, 'PTHR11926:SF1323', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301313, 'PTHR11926:SF1445', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301314, 'PTHR11926:SF1328', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE SUPERFAMILY PROTEIN-RELATED', 239134),
(301315, 'PTHR11926:SF1449', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 75B2', 239134),
(301316, 'PTHR11926:SF1050', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 75B1', 239134);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(301317, 'PTHR11926', NULL, NULL, NULL, NULL, 'GLUCOSYL/GLUCURONOSYL TRANSFERASES', 239134),
(301318, 'PTHR11926:SF1451', NULL, NULL, NULL, NULL, 'OS07G0241500 PROTEIN', 239134),
(301319, 'PTHR11926:SF1299', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 84A3-RELATED', 239134),
(301320, 'PTHR11926:SF324', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301321, 'PTHR11926:SF968', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 76C1', 239134),
(301322, 'PTHR11926:SF727', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 74B1', 239134),
(301323, 'PTHR11926:SF1517', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301324, 'PTHR11926:SF1518', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301325, 'PTHR11926:SF1519', NULL, NULL, NULL, NULL, 'BNAANNG39200D PROTEIN', 239134),
(301326, 'PTHR11926:SF709', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301327, 'PTHR11926:SF1355', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301328, 'PTHR11926:SF1477', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 74F2', 239134),
(301329, 'PTHR11926:SF1356', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 74C1', 239134),
(301330, 'PTHR11926:SF1510', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301331, 'PTHR11926:SF1511', NULL, NULL, NULL, NULL, '', 239134),
(301332, 'PTHR11926:SF1512', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301333, 'PTHR11926:SF1358', NULL, NULL, NULL, NULL, 'UDP-GLUCOSYLTRANSFERASE', 239134),
(301334, 'PTHR11926:SF1359', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301335, 'PTHR11926:SF1513', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301336, 'PTHR11926:SF1514', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 76E1', 239134),
(301337, 'PTHR11926:SF391', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301338, 'PTHR11926:SF1515', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301339, 'PTHR11926:SF1516', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301340, 'PTHR11926:SF1480', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301341, 'PTHR11926:SF1481', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301342, 'PTHR11926:SF1360', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301343, 'PTHR11926:SF1482', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 76E5', 239134),
(301344, 'PTHR11926:SF1361', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE SUPERFAMILY PROTEIN-RELATED', 239134),
(301345, 'PTHR11926:SF1483', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301346, 'PTHR11926:SF1484', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301347, 'PTHR11926:SF1363', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301348, 'PTHR11926:SF950', NULL, NULL, NULL, NULL, 'OS07G0241700 PROTEIN', 239134),
(301349, 'PTHR11926:SF1364', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 85A1', 239134),
(301350, 'PTHR11926:SF1485', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301351, 'PTHR11926:SF1365', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301352, 'PTHR11926:SF1486', NULL, NULL, NULL, NULL, 'DIMBOA UDP-GLUCOSYLTRANSFERASE BX9', 239134),
(301353, 'PTHR11926:SF1244', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 76D1', 239134),
(301354, 'PTHR11926:SF953', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 75C1', 239134),
(301355, 'PTHR11926:SF715', NULL, NULL, NULL, NULL, 'OS04G0204000 PROTEIN', 239134),
(301356, 'PTHR11926:SF959', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301357, 'PTHR11926:SF1506', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301358, 'PTHR11926:SF1507', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYL/UDP-GLUCOSYLTRANSFERASE-RELATED', 239134),
(301359, 'PTHR11926:SF1508', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301360, 'PTHR11926:SF1509', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 74G1-LIKE', 239134),
(301361, 'PTHR11926:SF1102', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 84A2', 239134),
(301362, 'PTHR11926:SF1344', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(301363, 'PTHR11926:SF1500', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETATE BETA-GLUCOSYLTRANSFERASE', 239134),
(301364, 'PTHR11926:SF1468', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301365, 'PTHR11926:SF1501', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301366, 'PTHR11926:SF1348', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301367, 'PTHR11926:SF1502', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301368, 'PTHR11926:SF1469', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301369, 'PTHR11926:SF1349', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301370, 'PTHR11926:SF1503', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301371, 'PTHR11926:SF1504', NULL, NULL, NULL, NULL, '', 239134),
(301372, 'PTHR11926:SF1505', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301373, 'PTHR11926:SF1193', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301374, 'PTHR11926:SF1470', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 85A2-RELATED', 239134),
(301375, 'PTHR11926:SF1195', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301376, 'PTHR11926:SF1471', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301377, 'PTHR11926:SF1196', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301378, 'PTHR11926:SF1472', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301379, 'PTHR11926:SF1352', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 76C1', 239134),
(301380, 'PTHR11926:SF1353', NULL, NULL, NULL, NULL, 'ANTHOCYANIDIN 3-O-GLUCOSYLTRANSFERASE', 239134),
(301381, 'PTHR11926:SF1354', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301382, 'PTHR11926:SF1070', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301383, 'PTHR11926:SF1071', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301384, 'PTHR11926:SF706', NULL, NULL, NULL, NULL, 'CYTOKININ-N-GLUCOSYLTRANSFERASE 1', 239134),
(301385, 'PTHR11926:SF928', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 85A4', 239134),
(301386, 'PTHR11926:SF1498', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301387, 'PTHR11926:SF1377', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301388, 'PTHR11926:SF1378', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301389, 'PTHR11926:SF1499', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 239134),
(301390, 'PTHR11926:SF1412', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 83A1-LIKE', 239134),
(301391, 'PTHR11926:SF1413', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301392, 'PTHR11926:SF1415', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301393, 'PTHR11926:SF1417', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301394, 'PTHR11926:SF1383', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301395, 'PTHR11926:SF893', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301396, 'PTHR11926:SF1264', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE-RELATED', 239134),
(301397, 'PTHR11926:SF1385', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301398, 'PTHR11926:SF1265', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301399, 'PTHR11926:SF1386', NULL, NULL, NULL, NULL, 'BNACNNG37570D PROTEIN', 239134),
(301400, 'PTHR11926:SF774', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 85A7', 239134),
(301401, 'PTHR11926:SF1144', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301402, 'PTHR11926:SF1387', NULL, NULL, NULL, NULL, 'BNAA07G10530D PROTEIN', 239134),
(301403, 'PTHR11926:SF896', NULL, NULL, NULL, NULL, 'FLAVONOL 7-O-BETA-GLUCOSYLTRANSFERASE UGT74F1', 239134),
(301404, 'PTHR11926:SF1420', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 76C1', 239134),
(301405, 'PTHR11926:SF1407', NULL, NULL, NULL, NULL, '7-DEOXYLOGANETIN GLUCOSYLTRANSFERASE-LIKE', 239134),
(301406, 'PTHR11926:SF1408', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301407, 'PTHR11926:SF1409', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301408, 'PTHR11926:SF1520', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE', 239134);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(301409, 'PTHR11926:SF1366', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301410, 'PTHR11926:SF1487', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE', 239134),
(301411, 'PTHR11926:SF1521', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301412, 'PTHR11926:SF1488', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301413, 'PTHR11926:SF1400', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 76C1', 239134),
(301414, 'PTHR11926:SF1489', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE-RELATED', 239134),
(301415, 'PTHR11926:SF1522', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301416, 'PTHR11926:SF1402', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301417, 'PTHR11926:SF1006', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301418, 'PTHR11926:SF1523', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 75B1', 239134),
(301419, 'PTHR11926:SF1524', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301420, 'PTHR11926:SF1403', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301421, 'PTHR11926:SF1525', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301422, 'PTHR11926:SF1405', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301423, 'PTHR11926:SF1406', NULL, NULL, NULL, NULL, '', 239134),
(301424, 'PTHR11926:SF1490', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301425, 'PTHR11926:SF1491', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301426, 'PTHR11926:SF1492', NULL, NULL, NULL, NULL, '7-DEOXYLOGANETIN GLUCOSYLTRANSFERASE', 239134),
(301427, 'PTHR11926:SF1493', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 76C1', 239134),
(301428, 'PTHR11926:SF1494', NULL, NULL, NULL, NULL, 'FLAVONOL 3-O-GLUCOSYLTRANSFERASE UGT76E12-RELATED', 239134),
(301429, 'PTHR11926:SF1099', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301430, 'PTHR11926:SF1374', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 76F1-RELATED', 239134),
(301431, 'PTHR11926:SF1495', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301432, 'PTHR11926:SF1375', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301433, 'PTHR11926:SF763', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301434, 'PTHR11926:SF1496', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 74E1-RELATED', 239134),
(301435, 'PTHR11926:SF1133', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE IRIDOID GLUCOSYLTRANSFERASE-LIKE', 239134),
(301436, 'PTHR11926:SF1497', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301437, 'PTHR11926:SF1376', NULL, NULL, NULL, NULL, '', 239134),
(301438, 'PTHR11926:SF889', NULL, NULL, NULL, NULL, '', 239134),
(301439, 'PTHR11926:SF1091', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 239134),
(301440, 'PTHR11926:SF925', NULL, NULL, NULL, NULL, 'CYTOKININ 7-BETA-GLUCOSYLTRANSFERASE-RELATED', 239134),
(301441, 'PTHR14168:SF2', NULL, NULL, NULL, NULL, 'EPITHELIAL CELL ADHESION MOLECULE', 239135),
(301442, 'PTHR14168:SF5', NULL, NULL, NULL, NULL, 'TUMOR-ASSOCIATED CALCIUM SIGNAL TRANSDUCER 2', 239135),
(301443, 'PTHR14168:SF6', NULL, NULL, NULL, NULL, 'THYROGLOBULIN TYPE-1 DOMAIN-CONTAINING PROTEIN', 239135),
(301444, 'PTHR14168:SF4', NULL, NULL, NULL, NULL, '', 239135),
(301445, 'PTHR14168', NULL, NULL, NULL, NULL, 'TUMOR-ASSOCIATED CALCIUM SIGNAL TRANSDUCER', 239135),
(301446, 'PTHR47494', NULL, NULL, NULL, NULL, 'NKG2-D TYPE II INTEGRAL MEMBRANE PROTEIN', 239136),
(301447, 'PTHR47494:SF1', NULL, NULL, NULL, NULL, 'NKG2-D TYPE II INTEGRAL MEMBRANE PROTEIN', 239136),
(301448, 'PTHR38079', NULL, NULL, NULL, NULL, '', 239137),
(301449, 'PTHR38079:SF1', NULL, NULL, NULL, NULL, '', 239137),
(301450, 'PTHR23177:SF80', NULL, NULL, NULL, NULL, 'RHOGAP1', 239138),
(301451, 'PTHR23177:SF62', NULL, NULL, NULL, NULL, 'RHO GTPASE ACTIVATION PROTEIN-RELATED', 239138),
(301452, 'PTHR23177:SF73', NULL, NULL, NULL, NULL, 'PAK-BOX/P21-RHO-BINDING DOMAIN RHO GTPASE ACTIVATING PROTEIN', 239138),
(301453, 'PTHR23177:SF81', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 3', 239138),
(301454, 'PTHR23177:SF70', NULL, NULL, NULL, NULL, 'RHO GTPASE ACTIVATING PROTEIN WITH PAK-BOX/P21-RHO-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 239138);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(301455, 'PTHR23177:SF60', NULL, NULL, NULL, NULL, '', 239138),
(301456, 'PTHR23177:SF71', NULL, NULL, NULL, NULL, 'BNAA09G01300D PROTEIN', 239138),
(301457, 'PTHR23177:SF65', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 4', 239138),
(301458, 'PTHR23177:SF76', NULL, NULL, NULL, NULL, 'RHO-GAP DOMAIN-CONTAINING PROTEIN', 239138),
(301459, 'PTHR23177:SF66', NULL, NULL, NULL, NULL, 'BNAA05G27550D PROTEIN', 239138),
(301460, 'PTHR23177', NULL, NULL, NULL, NULL, 'MKIAA1688 PROTEIN', 239138),
(301461, 'PTHR23177:SF33', NULL, NULL, NULL, NULL, 'OS01G0967200 PROTEIN', 239138),
(301462, 'PTHR23177:SF77', NULL, NULL, NULL, NULL, 'RHO GTPASE ACTIVATING PROTEIN WITH PAK-BOX/P21-RHO-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 239138),
(301463, 'PTHR23177:SF74', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 3', 239138),
(301464, 'PTHR23177:SF64', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 1', 239138),
(301465, 'PTHR23177:SF75', NULL, NULL, NULL, NULL, 'RHO-GAP DOMAIN-CONTAINING PROTEIN', 239138),
(301466, 'PTHR23177:SF58', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN GACK', 239138),
(301467, 'PTHR23177:SF78', NULL, NULL, NULL, NULL, 'CRIB DOMAIN, RHO GTPASE ACTIVATION PROTEIN-RELATED', 239138),
(301468, 'PTHR23177:SF56', NULL, NULL, NULL, NULL, 'OS07G0408500 PROTEIN', 239138),
(301469, 'PTHR23177:SF35', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN GACA', 239138),
(301470, 'PTHR23177:SF57', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 5', 239138),
(301471, 'PTHR23177:SF79', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 2-LIKE', 239138),
(301472, 'PTHR23177:SF68', NULL, NULL, NULL, NULL, 'RHO-GAP DOMAIN-CONTAINING PROTEIN', 239138),
(301473, 'PTHR47584:SF17', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DNA-BINDING DOMAIN PROTEIN', 239139),
(301474, 'PTHR47584:SF9', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 239139),
(301475, 'PTHR47584:SF14', NULL, NULL, NULL, NULL, 'L10-INTERACTING MYB DOMAIN-CONTAINING PROTEIN-LIKE', 239139),
(301476, 'PTHR47584:SF19', NULL, NULL, NULL, NULL, 'L10-INTERACTING MYB DOMAIN-CONTAINING PROTEIN-LIKE', 239139),
(301477, 'PTHR47584:SF18', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 239139),
(301478, 'PTHR47584:SF20', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 239139),
(301479, 'PTHR47584:SF4', NULL, NULL, NULL, NULL, 'BNAA03G55740D PROTEIN', 239139),
(301480, 'PTHR47584', NULL, NULL, NULL, NULL, '', 239139),
(301481, 'PTHR47584:SF2', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 239139),
(301482, 'PTHR47584:SF10', NULL, NULL, NULL, NULL, 'BNAA09G54260D PROTEIN', 239139),
(301483, 'PTHR33931', NULL, NULL, NULL, NULL, 'HOLIN-LIKE PROTEIN CIDA-RELATED', 239140),
(301484, 'PTHR33931:SF2', NULL, NULL, NULL, NULL, 'HOLIN-LIKE PROTEIN CIDA 1', 239140),
(301485, 'PTHR33931:SF6', NULL, NULL, NULL, NULL, 'HOLIN-LIKE PROTEIN CIDA 2', 239140),
(301486, 'PTHR33931:SF5', NULL, NULL, NULL, NULL, 'UPF0299 MEMBRANE PROTEIN YOHJ', 239140),
(301487, 'PTHR33931:SF4', NULL, NULL, NULL, NULL, 'ANTIHOLIN-LIKE PROTEIN LRGA', 239140),
(301488, 'PTHR37451', NULL, NULL, NULL, NULL, 'MARVEL DOMAIN', 239141),
(301489, 'PTHR37451:SF1', NULL, NULL, NULL, NULL, 'MARVEL DOMAIN-CONTAINING PROTEIN', 239141),
(301490, 'PTHR37451:SF5', NULL, NULL, NULL, NULL, 'MARVEL DOMAIN-CONTAINING PROTEIN', 239141),
(301491, 'PTHR37451:SF3', NULL, NULL, NULL, NULL, 'MARVEL DOMAIN-CONTAINING PROTEIN', 239141),
(301492, 'PTHR37451:SF4', NULL, NULL, NULL, NULL, 'DEVELOPMENTAL REGULATORY PROTEIN WETA', 239141),
(301493, 'PTHR14272', NULL, NULL, NULL, NULL, 'SERTA DOMAIN-CONTAINING PROTEIN 4', 239142),
(301494, 'PTHR14272:SF4', NULL, NULL, NULL, NULL, 'SERTA DOMAIN-CONTAINING PROTEIN 4', 239142),
(301495, 'PTHR43113:SF1', NULL, NULL, NULL, NULL, '1,4-DIHYDROXY-2-NAPHTHOYL-COA SYNTHASE, PEROXISOMAL', 239143),
(301496, 'PTHR43113', NULL, NULL, NULL, NULL, 'NUCLEOSIDE-DIPHOSPHATE-SUGAR EPIMERASE', 239143),
(301497, 'PTHR31338:SF21', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 239144);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(301498, 'PTHR31338:SF32', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 239144),
(301499, 'PTHR31338:SF33', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 239144),
(301500, 'PTHR31338:SF22', NULL, NULL, NULL, NULL, 'MAJOR LATEX HOMOLOGUE TYPE2', 239144),
(301501, 'PTHR31338:SF34', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 239144),
(301502, 'PTHR31338:SF26', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 239144),
(301503, 'PTHR31338:SF27', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 239144),
(301504, 'PTHR31338:SF16', NULL, NULL, NULL, NULL, 'POLYKETIDE CYCLASE/DEHYDRASE AND LIPID TRANSPORT SUPERFAMILY PROTEIN', 239144),
(301505, 'PTHR31338:SF28', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 239144),
(301506, 'PTHR31338:SF18', NULL, NULL, NULL, NULL, 'MLP-LIKE PROTEIN 328-RELATED', 239144),
(301507, 'PTHR31338:SF29', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 239144),
(301508, 'PTHR31338:SF19', NULL, NULL, NULL, NULL, 'F17F8.9-RELATED', 239144),
(301509, 'PTHR31338', NULL, NULL, NULL, NULL, 'POLYKETIDE CYCLASE/DEHYDRASE AND LIPID TRANSPORT SUPERFAMILY PROTEIN', 239144),
(301510, 'PTHR31338:SF30', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 239144),
(301511, 'PTHR31338:SF31', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 239144),
(301512, 'PTHR31338:SF20', NULL, NULL, NULL, NULL, 'POLYKETIDE CYCLASE/DEHYDRASE AND LIPID TRANSPORT SUPERFAMILY PROTEIN', 239144),
(301513, 'PTHR39341', NULL, NULL, NULL, NULL, 'BSL7085 PROTEIN', 239145),
(301514, 'PTHR39341:SF1', NULL, NULL, NULL, NULL, 'DUF1858 DOMAIN-CONTAINING PROTEIN', 239145),
(301515, 'PTHR24406:SF17', NULL, NULL, NULL, NULL, 'ZINC FINGER TRANSCRIPTION FACTOR PQM-1-RELATED', 239146),
(301516, 'PTHR24406:SF3', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 276', 239146),
(301517, 'PTHR24406:SF16', NULL, NULL, NULL, NULL, 'FI01110P', 239146),
(301518, 'PTHR24406:SF4', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 692', 239146),
(301519, 'PTHR24406:SF5', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 711', 239146),
(301520, 'PTHR24406:SF6', NULL, NULL, NULL, NULL, 'ZINC FINGER X-CHROMOSOMAL PROTEIN', 239146),
(301521, 'PTHR24406:SF18', NULL, NULL, NULL, NULL, 'PARALYSED ARREST AT TWO-FOLD', 239146),
(301522, 'PTHR24406:SF7', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN CONTAINING 11', 239146),
(301523, 'PTHR24406:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR CTCFL', 239146),
(301524, 'PTHR24406', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR CTCFL-RELATED', 239146),
(301525, 'PTHR24406:SF9', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 239146),
(301526, 'PTHR24406:SF11', NULL, NULL, NULL, NULL, 'REPLICATION INITIATOR 1', 239146),
(301527, 'PTHR24406:SF13', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 239146),
(301528, 'PTHR24406:SF12', NULL, NULL, NULL, NULL, 'LATERAL SIGNALING TARGET', 239146),
(301529, 'PTHR24406:SF15', NULL, NULL, NULL, NULL, '', 239146),
(301530, 'PTHR24406:SF14', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 239146),
(301531, 'PTHR34353:SF3', NULL, NULL, NULL, NULL, 'CRISPR-ASSOCIATED ENDONUCLEASE CAS1', 239147),
(301532, 'PTHR34353', NULL, NULL, NULL, NULL, 'CRISPR-ASSOCIATED ENDONUCLEASE CAS1 1', 239147),
(301533, 'PTHR34353:SF2', NULL, NULL, NULL, NULL, 'CRISPR-ASSOCIATED ENDONUCLEASE CAS1 1', 239147),
(301534, 'PTHR22115:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 50', 239148),
(301535, 'PTHR22115:SF4', NULL, NULL, NULL, NULL, 'CCDC50_N DOMAIN-CONTAINING PROTEIN', 239148),
(301536, 'PTHR22115', NULL, NULL, NULL, NULL, 'C3ORF6 PROTEIN-RELATED', 239148),
(301537, 'PTHR22115:SF2', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING 187-RELATED', 239148),
(301538, 'PTHR31228:SF31', NULL, NULL, NULL, NULL, 'BNAC02G02480D PROTEIN', 239149),
(301539, 'PTHR31228:SF29', NULL, NULL, NULL, NULL, 'BNAC09G51240D PROTEIN', 239149),
(301540, 'PTHR31228', NULL, NULL, NULL, NULL, 'CYSTATIN/MONELLIN SUPERFAMILY PROTEIN', 239149);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(301541, 'PTHR31228:SF22', NULL, NULL, NULL, NULL, 'CYSTATIN/MONELLIN SUPERFAMILY PROTEIN', 239149),
(301542, 'PTHR31228:SF33', NULL, NULL, NULL, NULL, 'BNAA05G31020D PROTEIN', 239149),
(301543, 'PTHR31228:SF10', NULL, NULL, NULL, NULL, 'CYSTATIN/MONELLIN SUPERFAMILY PROTEIN', 239149),
(301544, 'PTHR31228:SF3', NULL, NULL, NULL, NULL, 'CYSTATIN-LIKE PROTEIN', 239149),
(301545, 'PTHR31228:SF32', NULL, NULL, NULL, NULL, 'BNAA03G17050D PROTEIN', 239149),
(301546, 'PTHR31228:SF24', NULL, NULL, NULL, NULL, 'CYSTATIN/MONELLIN SUPERFAMILY PROTEIN', 239149),
(301547, 'PTHR31228:SF35', NULL, NULL, NULL, NULL, 'BNAANNG03160D PROTEIN', 239149),
(301548, 'PTHR31228:SF34', NULL, NULL, NULL, NULL, 'BNAC05G03000D PROTEIN', 239149),
(301549, 'PTHR31228:SF23', NULL, NULL, NULL, NULL, 'CYSTATIN/MONELLIN SUPERFAMILY PROTEIN', 239149),
(301550, 'PTHR31228:SF37', NULL, NULL, NULL, NULL, 'BNAA05G20510D PROTEIN', 239149),
(301551, 'PTHR31228:SF25', NULL, NULL, NULL, NULL, 'CYSTATIN/MONELLIN SUPERFAMILY PROTEIN-RELATED', 239149),
(301552, 'PTHR31228:SF36', NULL, NULL, NULL, NULL, 'CYSTATIN/MONELLIN SUPERFAMILY PROTEIN', 239149),
(301553, 'PTHR31228:SF28', NULL, NULL, NULL, NULL, 'BNACNNG63820D PROTEIN', 239149),
(301554, 'PTHR31228:SF39', NULL, NULL, NULL, NULL, 'BNAC09G40850D PROTEIN', 239149),
(301555, 'PTHR31228:SF27', NULL, NULL, NULL, NULL, 'BNAC02G02470D PROTEIN', 239149),
(301556, 'PTHR31228:SF38', NULL, NULL, NULL, NULL, 'CYSTATIN-LIKE PROTEIN-RELATED', 239149),
(301557, 'PTHR34228:SF3', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A2-LIKE PROTEIN Y52B11A.8', 239150),
(301558, 'PTHR34228:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG09517', 239150),
(301559, 'PTHR34228', NULL, NULL, NULL, NULL, 'PROTEIN CBG09474-RELATED', 239150),
(301560, 'PTHR34228:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG09474', 239150),
(301561, 'PTHR34228:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG00662', 239150),
(301562, 'PTHR34228:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG09452', 239150),
(301563, 'PTHR34228:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG08862', 239150),
(301564, 'PTHR34228:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG17448', 239150),
(301565, 'PTHR31508:SF2', NULL, NULL, NULL, NULL, 'PROTEIN PITCHFORK', 239151),
(301566, 'PTHR31508', NULL, NULL, NULL, NULL, 'PROTEIN PITCHFORK', 239151),
(301567, 'PTHR48233:SF3', NULL, NULL, NULL, NULL, 'EVA-1 HOMOLOG B', 239152),
(301568, 'PTHR48233:SF4', NULL, NULL, NULL, NULL, 'BRINKER-RELATED', 239152),
(301569, 'PTHR48233:SF2', NULL, NULL, NULL, NULL, 'PROTEIN LIN-36', 239152),
(301570, 'PTHR48233', NULL, NULL, NULL, NULL, 'MUCIN 4B, ISOFORM B-RELATED', 239152),
(301571, 'PTHR42926:SF1', NULL, NULL, NULL, NULL, 'KAIC-LIKE PROTEIN 2', 239153),
(301572, 'PTHR42926', NULL, NULL, NULL, NULL, '', 239153),
(301573, 'PTHR31468:SF13', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCANOSYLTRANSFERASE GAS5', 239154),
(301574, 'PTHR31468:SF14', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCANOSYLTRANSFERASE GAS4', 239154),
(301575, 'PTHR31468', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCANOSYLTRANSFERASE GAS1', 239154),
(301576, 'PTHR31468:SF2', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCANOSYLTRANSFERASE GAS1', 239154),
(301577, 'PTHR31468:SF10', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCANOSYLTRANSFERASE GAS2', 239154),
(301578, 'PTHR31468:SF11', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCANOSYLTRANSFERASE', 239154),
(301579, 'PTHR31468:SF5', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCANOSYLTRANSFERASE GAS5', 239154),
(301580, 'PTHR31468:SF4', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCANOSYLTRANSFERASE GAS3-RELATED', 239154),
(301581, 'PTHR31468:SF9', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCANOSYLTRANSFERASE', 239154),
(301582, 'PTHR31468:SF8', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCANOSYLTRANSFERASE GAS2', 239154),
(301583, 'PTHR46920:SF1', NULL, NULL, NULL, NULL, 'PROTEIN MSS51 HOMOLOG, MITOCHONDRIAL-RELATED', 239155),
(301584, 'PTHR46920', NULL, NULL, NULL, NULL, '', 239155),
(301585, 'PTHR40599', NULL, NULL, NULL, NULL, '[CITRATE [PRO-3S]-LYASE] LIGASE', 239156),
(301586, 'PTHR40599:SF1', NULL, NULL, NULL, NULL, '[CITRATE [PRO-3S]-LYASE] LIGASE', 239156);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(301587, 'PTHR14870:SF1', NULL, NULL, NULL, NULL, 'TUBULIN EPSILON AND DELTA COMPLEX PROTEIN 2', 239157),
(301588, 'PTHR14870', NULL, NULL, NULL, NULL, 'TUBULIN EPSILON AND DELTA COMPLEX PROTEIN 2', 239157),
(301589, 'PTHR48027:SF11', NULL, NULL, NULL, NULL, 'OS01G0367300 PROTEIN', 239158),
(301590, 'PTHR48027:SF22', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 239158),
(301591, 'PTHR48027:SF23', NULL, NULL, NULL, NULL, 'DAZ-ASSOCIATED PROTEIN 1', 239158),
(301592, 'PTHR48027:SF20', NULL, NULL, NULL, NULL, 'SRA STEM-LOOP-INTERACTING RNA-BINDING PROTEIN, MITOCHONDRIAL', 239158),
(301593, 'PTHR48027:SF21', NULL, NULL, NULL, NULL, 'DAZ-ASSOCIATED PROTEIN 1', 239158),
(301594, 'PTHR48027:SF15', NULL, NULL, NULL, NULL, 'OS01G0945800 PROTEIN', 239158),
(301595, 'PTHR48027:SF13', NULL, NULL, NULL, NULL, 'UBP1-ASSOCIATED PROTEIN 2C-LIKE', 239158),
(301596, 'PTHR48027:SF24', NULL, NULL, NULL, NULL, 'OS12G0502200 PROTEIN', 239158),
(301597, 'PTHR48027:SF14', NULL, NULL, NULL, NULL, 'GLYCINE-RICH RNA-BINDING PROTEIN 5, MITOCHONDRIAL', 239158),
(301598, 'PTHR48027', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN 87F-RELATED', 239158),
(301599, 'PTHR48027:SF7', NULL, NULL, NULL, NULL, 'GLYCINE-RICH RNA-BINDING-LIKE PROTEIN', 239158),
(301600, 'PTHR48027:SF6', NULL, NULL, NULL, NULL, 'OS05G0376000 PROTEIN', 239158),
(301601, 'PTHR48027:SF9', NULL, NULL, NULL, NULL, 'MULTICOPY SUPPRESSOR OF SPORULATION PROTEIN MSA1', 239158),
(301602, 'PTHR48027:SF3', NULL, NULL, NULL, NULL, 'TRANSFORMER-2 PROTEIN HOMOLOG', 239158),
(301603, 'PTHR48027:SF5', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 239158),
(301604, 'PTHR48027:SF4', NULL, NULL, NULL, NULL, 'SMALL RNA-BINDING PROTEIN 11, CHLOROPLASTIC', 239158),
(301605, 'PTHR48027:SF19', NULL, NULL, NULL, NULL, 'OS07G0602600 PROTEIN', 239158),
(301606, 'PTHR48027:SF1', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-BINDING ALPHA-BETA PLAIT DOMAIN-CONTAINING PROTEIN-RELATED', 239158),
(301607, 'PTHR48027:SF18', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN 87F-RELATED', 239158),
(301608, 'PTHR30454', NULL, NULL, NULL, NULL, '4-HYDROXY-3-METHYLBUT-2-EN-1-YL DIPHOSPHATE SYNTHASE', 239159),
(301609, 'PTHR30454:SF0', NULL, NULL, NULL, NULL, '4-HYDROXY-3-METHYLBUT-2-EN-1-YL DIPHOSPHATE SYNTHASE (FERREDOXIN), CHLOROPLASTIC', 239159),
(301610, 'PTHR17601:SF1', NULL, NULL, NULL, NULL, 'RAFTLIN-2', 239160),
(301611, 'PTHR17601:SF7', NULL, NULL, NULL, NULL, 'RAFTLIN, LIPID RAFT LINKER 1A', 239160),
(301612, 'PTHR17601', NULL, NULL, NULL, NULL, 'RAFTLIN-RELATED', 239160),
(301613, 'PTHR17601:SF3', NULL, NULL, NULL, NULL, 'RAFTLIN', 239160),
(301614, 'PTHR38457:SF1', NULL, NULL, NULL, NULL, 'REGULATOR ABRB-RELATED', 239161),
(301615, 'PTHR38457', NULL, NULL, NULL, NULL, 'REGULATOR ABRB-RELATED', 239161),
(301616, 'PTHR43293', NULL, NULL, NULL, NULL, 'ACETATE COA-TRANSFERASE YDIF', 239162),
(301617, 'PTHR43293:SF3', NULL, NULL, NULL, NULL, 'CHOLESTEROL RING-CLEAVING HYDROLASE IPDB SUBUNIT', 239162),
(301618, 'PTHR43293:SF2', NULL, NULL, NULL, NULL, 'MALONATE DECARBOXYLASE ALPHA SUBUNIT', 239162),
(301619, 'PTHR43293:SF1', NULL, NULL, NULL, NULL, 'ACETATE COA-TRANSFERASE YDIF', 239162),
(301620, 'PTHR44119:SF7', NULL, NULL, NULL, NULL, 'MAGNESIUM CHELATASE SUBUNIT', 239163),
(301621, 'PTHR44119', NULL, NULL, NULL, NULL, 'MAGNESIUM-CHELATASE SUBUNIT CHLH, CHLOROPLASTIC', 239163),
(301622, 'PTHR44119:SF4', NULL, NULL, NULL, NULL, 'AEROBIC COBALTOCHELATASE SUBUNIT COBN', 239163),
(301623, 'PTHR44119:SF1', NULL, NULL, NULL, NULL, 'MAGNESIUM-CHELATASE SUBUNIT CHLH, CHLOROPLASTIC', 239163),
(301624, 'PTHR22691:SF14', NULL, NULL, NULL, NULL, 'BNAA09G42400D PROTEIN', 239164),
(301625, 'PTHR22691:SF1', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN CCDC61', 239164),
(301626, 'PTHR22691:SF8', NULL, NULL, NULL, NULL, 'PROTEIN SPT2 HOMOLOG', 239164),
(301627, 'PTHR22691', NULL, NULL, NULL, NULL, 'YEAST SPT2-RELATED', 239164),
(301628, 'PTHR22691:SF12', NULL, NULL, NULL, NULL, 'SPT2 CHROMATIN PROTEIN', 239164),
(301629, 'PTHR22691:SF13', NULL, NULL, NULL, NULL, 'SPT2 CHROMATIN PROTEIN', 239164);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(301630, 'PTHR22691:SF11', NULL, NULL, NULL, NULL, 'PROTEIN SPT2 HOMOLOG', 239164),
(301631, 'PTHR31470:SF50', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 239165),
(301632, 'PTHR31470:SF39', NULL, NULL, NULL, NULL, 'DUF1985 DOMAIN-CONTAINING PROTEIN', 239165),
(301633, 'PTHR31470', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASES SUPERFAMILY PROTEIN-RELATED-RELATED', 239165),
(301634, 'PTHR31470:SF46', NULL, NULL, NULL, NULL, 'ULP1 PROTEASE FAMILY, C-TERMINAL CATALYTIC DOMAIN CONTAINING PROTEIN', 239165),
(301635, 'PTHR31470:SF47', NULL, NULL, NULL, NULL, 'DUF1985 DOMAIN-CONTAINING PROTEIN', 239165),
(301636, 'PTHR31470:SF40', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASES SUPERFAMILY PROTEIN-RELATED', 239165),
(301637, 'PTHR31470:SF51', NULL, NULL, NULL, NULL, 'ULP1 PROTEASE FAMILY, C-TERMINAL CATALYTIC DOMAIN CONTAINING PROTEIN', 239165),
(301638, 'PTHR31470:SF52', NULL, NULL, NULL, NULL, 'DUF1985 DOMAIN-CONTAINING PROTEIN', 239165),
(301639, 'PTHR31470:SF41', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 239165),
(301640, 'PTHR31470:SF53', NULL, NULL, NULL, NULL, 'ULP1 PROTEASE FAMILY, C-TERMINAL CATALYTIC DOMAIN CONTAINING PROTEIN', 239165),
(301641, 'PTHR31470:SF42', NULL, NULL, NULL, NULL, 'DUF1985 DOMAIN-CONTAINING PROTEIN', 239165),
(301642, 'PTHR31470:SF54', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 239165),
(301643, 'PTHR10666:SF354', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 239166),
(301644, 'PTHR10666:SF431', NULL, NULL, NULL, NULL, 'POLYUBIQUITIN', 239166),
(301645, 'PTHR10666:SF355', NULL, NULL, NULL, NULL, 'POLYUBIQUITIN-LIKE', 239166),
(301646, 'PTHR10666:SF432', NULL, NULL, NULL, NULL, 'UBIQUITIN-60S RIBOSOMAL PROTEIN L40-1', 239166),
(301647, 'PTHR10666:SF430', NULL, NULL, NULL, NULL, '', 239166),
(301648, 'PTHR10666:SF397', NULL, NULL, NULL, NULL, '', 239166),
(301649, 'PTHR10666:SF394', NULL, NULL, NULL, NULL, '', 239166),
(301650, 'PTHR10666:SF393', NULL, NULL, NULL, NULL, 'UBIQUITIN', 239166),
(301651, 'PTHR10666:SF390', NULL, NULL, NULL, NULL, 'UBIQUITIN', 239166),
(301652, 'PTHR10666', NULL, NULL, NULL, NULL, 'UBIQUITIN', 239166),
(301653, 'PTHR10666:SF439', NULL, NULL, NULL, NULL, 'POLYUBIQUITIN-LIKE', 239166),
(301654, 'PTHR10666:SF437', NULL, NULL, NULL, NULL, 'POLYUBIQUITIN-B', 239166),
(301655, 'PTHR10666:SF438', NULL, NULL, NULL, NULL, 'GEO12007P1-RELATED', 239166),
(301656, 'PTHR10666:SF435', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 239166),
(301657, 'PTHR10666:SF359', NULL, NULL, NULL, NULL, '', 239166),
(301658, 'PTHR10666:SF436', NULL, NULL, NULL, NULL, 'UBIQUITIN-40S RIBOSOMAL PROTEIN S27A-2', 239166),
(301659, 'PTHR10666:SF433', NULL, NULL, NULL, NULL, 'OS10G0491500 PROTEIN', 239166),
(301660, 'PTHR10666:SF357', NULL, NULL, NULL, NULL, 'UBIQUITIN', 239166),
(301661, 'PTHR10666:SF434', NULL, NULL, NULL, NULL, 'UBIQUITIN-40S RIBOSOMAL PROTEIN S27A-1', 239166),
(301662, 'PTHR10666:SF442', NULL, NULL, NULL, NULL, 'UBIQUITIN-40S RIBOSOMAL PROTEIN S27A', 239166),
(301663, 'PTHR10666:SF443', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 239166),
(301664, 'PTHR10666:SF286', NULL, NULL, NULL, NULL, 'OS03G0808400 PROTEIN', 239166),
(301665, 'PTHR10666:SF440', NULL, NULL, NULL, NULL, 'POLYUBIQUITIN-LIKE', 239166),
(301666, 'PTHR10666:SF441', NULL, NULL, NULL, NULL, 'UBIQUITIN', 239166),
(301667, 'PTHR10666:SF364', NULL, NULL, NULL, NULL, '', 239166),
(301668, 'PTHR10666:SF285', NULL, NULL, NULL, NULL, '', 239166),
(301669, 'PTHR10666:SF329', NULL, NULL, NULL, NULL, '', 239166),
(301670, 'PTHR10666:SF448', NULL, NULL, NULL, NULL, 'POLYUBIQUITIN 11', 239166),
(301671, 'PTHR10666:SF449', NULL, NULL, NULL, NULL, 'UBIQUITIN-NEDD8-LIKE PROTEIN RUB1', 239166),
(301672, 'PTHR10666:SF446', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE PROTEIN FUBI', 239166),
(301673, 'PTHR10666:SF447', NULL, NULL, NULL, NULL, 'POLYUBIQUITIN 9', 239166),
(301674, 'PTHR10666:SF323', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 239166),
(301675, 'PTHR10666:SF444', NULL, NULL, NULL, NULL, 'UBIQUITIN-RIBOSOMAL 40S SUBUNIT PROTEIN S31 FUSION PROTEIN-RELATED', 239166);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(301676, 'PTHR10666:SF445', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 239166),
(301677, 'PTHR10666:SF376', NULL, NULL, NULL, NULL, 'POLYUBIQUITIN 11-LIKE', 239166),
(301678, 'PTHR10666:SF453', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S27A', 239166),
(301679, 'PTHR10666:SF454', NULL, NULL, NULL, NULL, 'ISG15 UBIQUITIN-LIKE MODIFIER', 239166),
(301680, 'PTHR10666:SF451', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 239166),
(301681, 'PTHR10666:SF452', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 239166),
(301682, 'PTHR10666:SF331', NULL, NULL, NULL, NULL, 'POLYUBIQUITIN-A', 239166),
(301683, 'PTHR10666:SF296', NULL, NULL, NULL, NULL, 'F15I1.4 PROTEIN-RELATED', 239166),
(301684, 'PTHR10666:SF450', NULL, NULL, NULL, NULL, 'F15I1.1 PROTEIN-RELATED', 239166),
(301685, 'PTHR10666:SF250', NULL, NULL, NULL, NULL, 'OS10G0475900 PROTEIN', 239166),
(301686, 'PTHR10666:SF173', NULL, NULL, NULL, NULL, 'NEDD8', 239166),
(301687, 'PTHR10666:SF292', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 239166),
(301688, 'PTHR10666:SF419', NULL, NULL, NULL, NULL, 'POLYUBIQUITIN 3', 239166),
(301689, 'PTHR10666:SF417', NULL, NULL, NULL, NULL, 'UBIQUITIN-40S RIBOSOMAL PROTEIN S31', 239166),
(301690, 'PTHR10666:SF418', NULL, NULL, NULL, NULL, 'UBIQUITIN-NEDD8-LIKE PROTEIN RUB2', 239166),
(301691, 'PTHR10666:SF415', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 239166),
(301692, 'PTHR10666:SF459', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 239166),
(301693, 'PTHR10666:SF416', NULL, NULL, NULL, NULL, 'UBIQUITIN', 239166),
(301694, 'PTHR10666:SF413', NULL, NULL, NULL, NULL, 'UBIQUITIN', 239166),
(301695, 'PTHR10666:SF457', NULL, NULL, NULL, NULL, 'POLYUBIQUITIN', 239166),
(301696, 'PTHR10666:SF458', NULL, NULL, NULL, NULL, 'POLYUBIQUITIN-C', 239166),
(301697, 'PTHR10666:SF455', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 239166),
(301698, 'PTHR10666:SF335', NULL, NULL, NULL, NULL, 'UBIQUITIN-NEDD8-LIKE PROTEIN RUB1', 239166),
(301699, 'PTHR10666:SF456', NULL, NULL, NULL, NULL, 'UBIQUITIN-60S RIBOSOMAL PROTEIN L40', 239166),
(301700, 'PTHR10666:SF412', NULL, NULL, NULL, NULL, 'F15I1.3 PROTEIN-RELATED', 239166),
(301701, 'PTHR10666:SF420', NULL, NULL, NULL, NULL, 'UBIQUITIN-60S RIBOSOMAL PROTEIN L40-2', 239166),
(301702, 'PTHR10666:SF421', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 239166),
(301703, 'PTHR10666:SF267', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE PROTEIN ISG15', 239166),
(301704, 'PTHR10666:SF462', NULL, NULL, NULL, NULL, 'UBIQUITIN', 239166),
(301705, 'PTHR10666:SF460', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 239166),
(301706, 'PTHR10666:SF461', NULL, NULL, NULL, NULL, '', 239166),
(301707, 'PTHR10666:SF428', NULL, NULL, NULL, NULL, 'POLYUBIQUITIN 14', 239166),
(301708, 'PTHR10666:SF429', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L40', 239166),
(301709, 'PTHR10666:SF426', NULL, NULL, NULL, NULL, 'UBIQUITIN', 239166),
(301710, 'PTHR10666:SF427', NULL, NULL, NULL, NULL, 'POLYUBIQUITIN-LIKE', 239166),
(301711, 'PTHR10666:SF424', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S27A-RELATED', 239166),
(301712, 'PTHR10666:SF425', NULL, NULL, NULL, NULL, 'UBIQUITIN', 239166),
(301713, 'PTHR10666:SF389', NULL, NULL, NULL, NULL, 'UBIQUITIN', 239166),
(301714, 'PTHR10666:SF422', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 239166),
(301715, 'PTHR10666:SF423', NULL, NULL, NULL, NULL, 'POLYUBIQUITIN', 239166),
(301716, 'PTHR37331', NULL, NULL, NULL, NULL, 'YALI0F11671P', 239167),
(301717, 'PTHR37331:SF1', NULL, NULL, NULL, NULL, 'YALI0F11671P', 239167),
(301718, 'PTHR10926:SF58', NULL, NULL, NULL, NULL, 'CDC50/LEM3 FAMILY-RELATED', 239168),
(301719, 'PTHR10926:SF69', NULL, NULL, NULL, NULL, 'INVASION PROTEIN 1', 239168),
(301720, 'PTHR10926:SF59', NULL, NULL, NULL, NULL, 'CDC50/LEM3 FAMILY-RELATED', 239168),
(301721, 'PTHR10926:SF27', NULL, NULL, NULL, NULL, 'ALA-INTERACTING SUBUNIT', 239168);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(301722, 'PTHR10926:SF49', NULL, NULL, NULL, NULL, 'ALA-INTERACTING SUBUNIT 4-RELATED', 239168),
(301723, 'PTHR10926:SF0', NULL, NULL, NULL, NULL, 'CELL CYCLE CONTROL PROTEIN 50A', 239168),
(301724, 'PTHR10926:SF17', NULL, NULL, NULL, NULL, 'CELL CYCLE CONTROL PROTEIN 50A', 239168),
(301725, 'PTHR10926:SF29', NULL, NULL, NULL, NULL, 'ALA-INTERACTING SUBUNIT 2-RELATED', 239168),
(301726, 'PTHR10926:SF1', NULL, NULL, NULL, NULL, 'CELL CYCLE CONTROL PROTEIN 50C', 239168),
(301727, 'PTHR10926:SF19', NULL, NULL, NULL, NULL, 'CELL CYCLE CONTROL PROTEIN 50B', 239168),
(301728, 'PTHR10926', NULL, NULL, NULL, NULL, 'CELL CYCLE CONTROL PROTEIN 50', 239168),
(301729, 'PTHR10926:SF70', NULL, NULL, NULL, NULL, 'ALA-INTERACTING SUBUNIT', 239168),
(301730, 'PTHR10926:SF71', NULL, NULL, NULL, NULL, 'ALA-INTERACTING SUBUNIT', 239168),
(301731, 'PTHR10926:SF72', NULL, NULL, NULL, NULL, 'ALA-INTERACTING SUBUNIT', 239168),
(301732, 'PTHR10926:SF50', NULL, NULL, NULL, NULL, 'ALA-INTERACTING SUBUNIT 5', 239168),
(301733, 'PTHR10926:SF73', NULL, NULL, NULL, NULL, '', 239168),
(301734, 'PTHR10926:SF62', NULL, NULL, NULL, NULL, 'ALA-INTERACTING SUBUNIT', 239168),
(301735, 'PTHR10926:SF30', NULL, NULL, NULL, NULL, 'ALA-INTERACTING SUBUNIT', 239168),
(301736, 'PTHR10926:SF20', NULL, NULL, NULL, NULL, 'ALKYLPHOSPHOCHOLINE RESISTANCE PROTEIN LEM3', 239168),
(301737, 'PTHR10926:SF21', NULL, NULL, NULL, NULL, 'PROTEIN CBG16211', 239168),
(301738, 'PTHR10926:SF65', NULL, NULL, NULL, NULL, 'ALA-INTERACTING SUBUNIT 1', 239168),
(301739, 'PTHR10926:SF56', NULL, NULL, NULL, NULL, 'ALA-INTERACTING SUBUNIT', 239168),
(301740, 'PTHR10926:SF23', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE RELATED', 239168),
(301741, 'PTHR10926:SF68', NULL, NULL, NULL, NULL, 'CELL CYCLE CONTROL PROTEIN', 239168),
(301742, 'PTHR37870', NULL, NULL, NULL, NULL, 'CHROMOSOME 1 OPEN READING FRAME 54', 239169),
(301743, 'PTHR37870:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 1 OPEN READING FRAME 54', 239169),
(301744, 'PTHR43606:SF2', NULL, NULL, NULL, NULL, 'PHOSPHATASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G08710)-RELATED', 239170),
(301745, 'PTHR43606', NULL, NULL, NULL, NULL, 'PHOSPHATASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G08710)-RELATED', 239170),
(301746, 'PTHR43606:SF1', NULL, NULL, NULL, NULL, 'SECRETED ALKALINE PHOSPHATASE-RELATED', 239170),
(301747, 'PTHR43606:SF6', NULL, NULL, NULL, NULL, 'ALKALINE PHOSPHATASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_5G03860)', 239170),
(301748, 'PTHR10706:SF150', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239171),
(301749, 'PTHR10706:SF160', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 39', 239171),
(301750, 'PTHR10706', NULL, NULL, NULL, NULL, 'F-BOX FAMILY PROTEIN', 239171),
(301751, 'PTHR10706:SF139', NULL, NULL, NULL, NULL, 'OS07G0535100 PROTEIN', 239171),
(301752, 'PTHR10706:SF149', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239171),
(301753, 'PTHR10706:SF159', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239171),
(301754, 'PTHR10706:SF154', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239171),
(301755, 'PTHR10706:SF153', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN, GALACTOSE OXIDASE/KELCH, BETA-PROPELLER-RELATED', 239171),
(301756, 'PTHR10706:SF142', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239171),
(301757, 'PTHR10706:SF130', NULL, NULL, NULL, NULL, 'OS01G0659900 PROTEIN', 239171),
(301758, 'PTHR10706:SF152', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239171),
(301759, 'PTHR10706:SF158', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239171),
(301760, 'PTHR10706:SF147', NULL, NULL, NULL, NULL, 'OS05G0139300 PROTEIN', 239171),
(301761, 'PTHR10706:SF157', NULL, NULL, NULL, NULL, '', 239171),
(301762, 'PTHR10706:SF145', NULL, NULL, NULL, NULL, 'OS05G0177400 PROTEIN', 239171),
(301763, 'PTHR10706:SF155', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 31', 239171),
(301764, 'PTHR10706:SF144', NULL, NULL, NULL, NULL, 'OS02G0260200 PROTEIN', 239171),
(301765, 'PTHR46478:SF1', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR A DOMAIN-CONTAINING PROTEIN 3A', 239172);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(301766, 'PTHR46478', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR A DOMAIN-CONTAINING PROTEIN 3A', 239172),
(301767, 'PTHR21381:SF3', NULL, NULL, NULL, NULL, 'ZGC:162297', 239173),
(301768, 'PTHR21381', NULL, NULL, NULL, NULL, 'ZGC:162297', 239173),
(301769, 'PTHR47712:SF2', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN, GALACTOSE OXIDASE, BETA-PROPELLER-RELATED', 239174),
(301770, 'PTHR47712:SF1', NULL, NULL, NULL, NULL, 'OS09G0555300 PROTEIN', 239174),
(301771, 'PTHR47712', NULL, NULL, NULL, NULL, 'OS09G0555300 PROTEIN', 239174),
(301772, 'PTHR28002', NULL, NULL, NULL, NULL, 'MIOREX COMPLEX COMPONENT 11', 239175),
(301773, 'PTHR28002:SF1', NULL, NULL, NULL, NULL, 'MIOREX COMPLEX COMPONENT 11', 239175),
(301774, 'PTHR11778:SF18', NULL, NULL, NULL, NULL, 'SERYL-TRNA SYNTHETASE', 239176),
(301775, 'PTHR11778:SF17', NULL, NULL, NULL, NULL, 'SERYL-TRNA SYNTHETASE', 239176),
(301776, 'PTHR11778:SF2', NULL, NULL, NULL, NULL, 'SERINE--TRNA SYNTHETASE-LIKE PROTEIN SLIMP', 239176),
(301777, 'PTHR11778', NULL, NULL, NULL, NULL, 'SERYL-TRNA SYNTHETASE', 239176),
(301778, 'PTHR11778:SF21', NULL, NULL, NULL, NULL, 'SERYL-TRNA SYNTHETASE', 239176),
(301779, 'PTHR11778:SF20', NULL, NULL, NULL, NULL, 'PROTEIN CBG08796', 239176),
(301780, 'PTHR11778:SF7', NULL, NULL, NULL, NULL, 'SERINE--TRNA LIGASE, CYTOPLASMIC-RELATED', 239176),
(301781, 'PTHR23028', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE', 239177),
(301782, 'PTHR23028:SF127', NULL, NULL, NULL, NULL, 'ACYL_TRANSF_3 DOMAIN-CONTAINING PROTEIN', 239177),
(301783, 'PTHR23028:SF116', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE FAMILY PROTEIN', 239177),
(301784, 'PTHR23028:SF128', NULL, NULL, NULL, NULL, 'ACYL_TRANSF_3 DOMAIN-CONTAINING PROTEIN', 239177),
(301785, 'PTHR23028:SF107', NULL, NULL, NULL, NULL, 'ACYL_TRANSF_3 DOMAIN-CONTAINING PROTEIN', 239177),
(301786, 'PTHR23028:SF118', NULL, NULL, NULL, NULL, 'ACYL_TRANSF_3 DOMAIN-CONTAINING PROTEIN', 239177),
(301787, 'PTHR23028:SF3', NULL, NULL, NULL, NULL, 'ACYL_TRANSF_3 DOMAIN-CONTAINING PROTEIN', 239177),
(301788, 'PTHR23028:SF124', NULL, NULL, NULL, NULL, 'ACYL_TRANSF_3 DOMAIN-CONTAINING PROTEIN-RELATED', 239177),
(301789, 'PTHR23028:SF53', NULL, NULL, NULL, NULL, 'ACYL_TRANSF_3 DOMAIN-CONTAINING PROTEIN', 239177),
(301790, 'PTHR23028:SF125', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE', 239177),
(301791, 'PTHR23028:SF126', NULL, NULL, NULL, NULL, 'ACYL_TRANSF_3 DOMAIN-CONTAINING PROTEIN', 239177),
(301792, 'PTHR23028:SF65', NULL, NULL, NULL, NULL, 'ACYL_TRANSF_3 DOMAIN-CONTAINING PROTEIN', 239177),
(301793, 'PTHR23028:SF115', NULL, NULL, NULL, NULL, 'ACYL_TRANSF_3 DOMAIN-CONTAINING PROTEIN', 239177),
(301794, 'PTHR23028:SF131', NULL, NULL, NULL, NULL, 'BLR2367 PROTEIN', 239177),
(301795, 'PTHR23028:SF132', NULL, NULL, NULL, NULL, 'ACYL_TRANSF_3 DOMAIN-CONTAINING PROTEIN', 239177),
(301796, 'PTHR23028:SF133', NULL, NULL, NULL, NULL, 'ACYL_TRANSF_3 DOMAIN-CONTAINING PROTEIN', 239177),
(301797, 'PTHR43722', NULL, NULL, NULL, NULL, 'PROLINE IMINOPEPTIDASE', 239178),
(301798, 'PTHR43722:SF1', NULL, NULL, NULL, NULL, 'PROLINE IMINOPEPTIDASE', 239178),
(301799, 'PTHR43722:SF2', NULL, NULL, NULL, NULL, 'PROLINE IMINOPEPTIDASE', 239178),
(301800, 'PTHR39192:SF1', NULL, NULL, NULL, NULL, 'IRON UPTAKE SYSTEM COMPONENT EFEO', 239179),
(301801, 'PTHR39192', NULL, NULL, NULL, NULL, 'IRON UPTAKE SYSTEM COMPONENT EFEO', 239179),
(301802, 'PTHR13113:SF1', NULL, NULL, NULL, NULL, 'EVOLUTIONARILY CONSERVED SIGNALING INTERMEDIATE IN TOLL PATHWAY, MITOCHONDRIAL', 239180),
(301803, 'PTHR13113', NULL, NULL, NULL, NULL, 'ECSIT  EVOLUTIONARILY CONSERVED SIGNALING INTERMEDIATE IN TOLL PATHWAYS', 239180),
(301804, 'PTHR23523:SF2', NULL, NULL, NULL, NULL, '2-NITROIMIDAZOLE TRANSPORTER', 239181),
(301805, 'PTHR23523', NULL, NULL, NULL, NULL, '', 239181),
(301806, 'PTHR23523:SF1', NULL, NULL, NULL, NULL, 'CYANATE TRANSPORT PROTEIN CYNX', 239181),
(301807, 'PTHR21964', NULL, NULL, NULL, NULL, 'BREAST CANCER METASTASIS-SUPPRESSOR 1', 239182),
(301808, 'PTHR21964:SF16', NULL, NULL, NULL, NULL, 'BREAST CANCER METASTASIS-SUPPRESSOR 1-LIKE PROTEIN', 239182);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(301809, 'PTHR21964:SF13', NULL, NULL, NULL, NULL, 'BRMS1 TRANSCRIPTIONAL REPRESSOR', 239182),
(301810, 'PTHR21964:SF35', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN SDS3', 239182),
(301811, 'PTHR21964:SF34', NULL, NULL, NULL, NULL, 'SIN3 HISTONE DEACETYLASE COREPRESSOR COMPLEX COMPONENT SDS3', 239182),
(301812, 'PTHR21964:SF15', NULL, NULL, NULL, NULL, 'BREAST CANCER METASTASIS-SUPPRESSOR 1', 239182),
(301813, 'PTHR21964:SF32', NULL, NULL, NULL, NULL, '', 239182),
(301814, 'PTHR23147:SF76', NULL, NULL, NULL, NULL, 'SPLICING FACTOR, ARGININE/SERINE-RICH 1', 239183),
(301815, 'PTHR23147:SF75', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN LARK', 239183),
(301816, 'PTHR23147:SF107', NULL, NULL, NULL, NULL, '', 239183),
(301817, 'PTHR23147:SF70', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR RSZ21', 239183),
(301818, 'PTHR23147', NULL, NULL, NULL, NULL, 'SERINE/ARGININE RICH SPLICING FACTOR', 239183),
(301819, 'PTHR23147:SF224', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR 2', 239183),
(301820, 'PTHR23147:SF268', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 239183),
(301821, 'PTHR23147:SF225', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 239183),
(301822, 'PTHR23147:SF269', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR RSZ22-RELATED', 239183),
(301823, 'PTHR23147:SF149', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SC35-LIKE SPLICING FACTOR SCL30A', 239183),
(301824, 'PTHR23147:SF264', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR SR34A-LIKE', 239183),
(301825, 'PTHR23147:SF220', NULL, NULL, NULL, NULL, 'SERINE AND ARGININE-RICH-SPLICING FACTOR 7B', 239183),
(301826, 'PTHR23147:SF265', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR 2', 239183),
(301827, 'PTHR23147:SF145', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR 2', 239183),
(301828, 'PTHR23147:SF266', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-BINDING ALPHA-BETA PLAIT DOMAIN-CONTAINING PROTEIN-RELATED', 239183),
(301829, 'PTHR23147:SF189', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR 7', 239183),
(301830, 'PTHR23147:SF102', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR RSZ21A', 239183),
(301831, 'PTHR23147:SF146', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR RS31-RELATED', 239183),
(301832, 'PTHR23147:SF267', NULL, NULL, NULL, NULL, 'OS03G0344100 PROTEIN', 239183),
(301833, 'PTHR23147:SF260', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR RS2Z33-LIKE ISOFORM X1', 239183),
(301834, 'PTHR23147:SF183', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SC35-LIKE SPLICING FACTOR SCL30', 239183),
(301835, 'PTHR23147:SF261', NULL, NULL, NULL, NULL, 'DXL6 PROTEIN', 239183),
(301836, 'PTHR23147:SF185', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 239183),
(301837, 'PTHR23147:SF262', NULL, NULL, NULL, NULL, 'OS07G0673500 PROTEIN', 239183),
(301838, 'PTHR23147:SF263', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 239183),
(301839, 'PTHR23147:SF181', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN-RELATED', 239183),
(301840, 'PTHR23147:SF48', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 19-RELATED', 239183),
(301841, 'PTHR23147:SF44', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR 1', 239183),
(301842, 'PTHR23147:SF119', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR 2', 239183),
(301843, 'PTHR23147:SF8', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4930595M18 GENE', 239183),
(301844, 'PTHR23147:SF80', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 4B', 239183),
(301845, 'PTHR23147:SF158', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SC35-LIKE SPLICING FACTOR SCL33', 239183),
(301846, 'PTHR23147:SF235', NULL, NULL, NULL, NULL, 'OS03G0374575 PROTEIN', 239183),
(301847, 'PTHR23147:SF279', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR 4-LIKE', 239183),
(301848, 'PTHR23147:SF237', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR 5', 239183),
(301849, 'PTHR23147:SF5', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR 10', 239183);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(301850, 'PTHR23147:SF275', NULL, NULL, NULL, NULL, 'OS08G0486200 PROTEIN', 239183),
(301851, 'PTHR23147:SF231', NULL, NULL, NULL, NULL, 'RNA-BINDING MOTIF PROTEIN 4.3', 239183),
(301852, 'PTHR23147:SF110', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 239183),
(301853, 'PTHR23147:SF3', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR 12', 239183),
(301854, 'PTHR23147:SF155', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SC35-LIKE SPLICING FACTOR SCL30A', 239183),
(301855, 'PTHR23147:SF276', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 239183),
(301856, 'PTHR23147:SF277', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR RSZ23', 239183),
(301857, 'PTHR23147:SF112', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 239183),
(301858, 'PTHR23147:SF156', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR SC35', 239183),
(301859, 'PTHR23147:SF233', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 4', 239183),
(301860, 'PTHR23147:SF234', NULL, NULL, NULL, NULL, 'BNAC03G15710D PROTEIN', 239183),
(301861, 'PTHR23147:SF278', NULL, NULL, NULL, NULL, 'OS05G0162600 PROTEIN', 239183),
(301862, 'PTHR23147:SF271', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR SR30', 239183),
(301863, 'PTHR23147:SF272', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 239183),
(301864, 'PTHR23147:SF273', NULL, NULL, NULL, NULL, 'RNA BINDING MOTIF PROTEIN 4B', 239183),
(301865, 'PTHR23147:SF230', NULL, NULL, NULL, NULL, 'SPLICING FACTOR, ARGININE/SERINE-RICH 2', 239183),
(301866, 'PTHR23147:SF274', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SC35-LIKE SPLICING FACTOR SCL33', 239183),
(301867, 'PTHR23147:SF270', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 239183),
(301868, 'PTHR23147:SF59', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR 9', 239183),
(301869, 'PTHR23147:SF14', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR 8', 239183),
(301870, 'PTHR23147:SF53', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 14', 239183),
(301871, 'PTHR23147:SF52', NULL, NULL, NULL, NULL, 'SERINE AND ARGININE-RICH-SPLICING FACTOR 7A', 239183),
(301872, 'PTHR23147:SF129', NULL, NULL, NULL, NULL, 'RNA RECOGNITION MOTIF', 239183),
(301873, 'PTHR23147:SF247', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR SR34A-LIKE', 239183),
(301874, 'PTHR23147:SF204', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR RS2Z32', 239183),
(301875, 'PTHR23147:SF127', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 239183),
(301876, 'PTHR23147:SF248', NULL, NULL, NULL, NULL, 'RNA RECOGNITION MOTIF', 239183),
(301877, 'PTHR23147:SF205', NULL, NULL, NULL, NULL, 'ASF/SF2-LIKE PRE-MRNA SPLICING FACTOR SRP31', 239183),
(301878, 'PTHR23147:SF121', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR 3', 239183),
(301879, 'PTHR23147:SF166', NULL, NULL, NULL, NULL, 'PROTEIN TERMINAL EAR1 HOMOLOG', 239183),
(301880, 'PTHR23147:SF245', NULL, NULL, NULL, NULL, '', 239183),
(301881, 'PTHR23147:SF282', NULL, NULL, NULL, NULL, 'RBD (RNA BINDING DOMAIN) PROTEIN', 239183),
(301882, 'PTHR23147:SF283', NULL, NULL, NULL, NULL, 'OS07G0633200 PROTEIN', 239183),
(301883, 'PTHR23147:SF284', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR SR34B', 239183),
(301884, 'PTHR23147:SF163', NULL, NULL, NULL, NULL, 'BNAA03G55470D PROTEIN', 239183),
(301885, 'PTHR23147:SF285', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR 2', 239183),
(301886, 'PTHR23147:SF280', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR RSZ22', 239183),
(301887, 'PTHR23147:SF281', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 239183),
(301888, 'PTHR23147:SF69', NULL, NULL, NULL, NULL, 'RNA-BINDING MOTIF PROTEIN 4.2-RELATED', 239183),
(301889, 'PTHR23147:SF25', NULL, NULL, NULL, NULL, 'OS03G0285900 PROTEIN', 239183),
(301890, 'PTHR23147:SF68', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR 4-RELATED', 239183),
(301891, 'PTHR23147:SF22', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR 2', 239183);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(301892, 'PTHR23147:SF63', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR SR34A', 239183),
(301893, 'PTHR23147:SF217', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN RSF1', 239183),
(301894, 'PTHR23147:SF218', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR RS2Z32', 239183),
(301895, 'PTHR23147:SF257', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 239183),
(301896, 'PTHR23147:SF213', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SC35-LIKE SPLICING FACTOR SCL30', 239183),
(301897, 'PTHR23147:SF137', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 239183),
(301898, 'PTHR23147:SF258', NULL, NULL, NULL, NULL, 'RNA RECOGNITION MOTIF', 239183),
(301899, 'PTHR23147:SF259', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 239183),
(301900, 'PTHR23147:SF132', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 239183),
(301901, 'PTHR23147:SF176', NULL, NULL, NULL, NULL, 'BNAA03G51620D PROTEIN', 239183),
(301902, 'PTHR23147:SF210', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR RS2Z33-LIKE ISOFORM X1', 239183),
(301903, 'PTHR23147:SF133', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 239183),
(301904, 'PTHR23147:SF178', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR RS31A', 239183),
(301905, 'PTHR23147:SF179', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 239183),
(301906, 'PTHR23147:SF256', NULL, NULL, NULL, NULL, 'BNAC01G41640D PROTEIN', 239183),
(301907, 'PTHR23147:SF172', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 239183),
(301908, 'PTHR23147:SF250', NULL, NULL, NULL, NULL, 'BNAA03G17170D PROTEIN', 239183),
(301909, 'PTHR35546:SF8', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301910, 'PTHR35546:SF9', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301911, 'PTHR35546:SF100', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301912, 'PTHR35546:SF101', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301913, 'PTHR35546:SF90', NULL, NULL, NULL, NULL, 'OS08G0529300 PROTEIN', 239184),
(301914, 'PTHR35546:SF102', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN', 239184),
(301915, 'PTHR35546:SF103', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301916, 'PTHR35546:SF104', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301917, 'PTHR35546:SF105', NULL, NULL, NULL, NULL, 'OS05G0139200 PROTEIN', 239184),
(301918, 'PTHR35546:SF83', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239184),
(301919, 'PTHR35546:SF106', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301920, 'PTHR35546:SF82', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301921, 'PTHR35546:SF107', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239184),
(301922, 'PTHR35546:SF41', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301923, 'PTHR35546:SF40', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301924, 'PTHR35546:SF84', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301925, 'PTHR35546:SF108', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301926, 'PTHR35546:SF109', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239184),
(301927, 'PTHR35546:SF87', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN-RELATED', 239184),
(301928, 'PTHR35546:SF86', NULL, NULL, NULL, NULL, '', 239184),
(301929, 'PTHR35546:SF89', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301930, 'PTHR35546:SF46', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301931, 'PTHR35546:SF49', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301932, 'PTHR35546:SF48', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301933, 'PTHR35546:SF110', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301934, 'PTHR35546:SF111', NULL, NULL, NULL, NULL, 'OS12G0275600 PROTEIN', 239184),
(301935, 'PTHR35546:SF112', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN', 239184);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(301936, 'PTHR35546:SF113', NULL, NULL, NULL, NULL, 'FBA_3 DOMAIN-CONTAINING PROTEIN', 239184),
(301937, 'PTHR35546:SF114', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 239184),
(301938, 'PTHR35546:SF81', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301939, 'PTHR35546:SF80', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN EXPRESSED', 239184),
(301940, 'PTHR35546:SF115', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301941, 'PTHR35546:SF116', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301942, 'PTHR35546:SF71', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301943, 'PTHR35546:SF117', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN', 239184),
(301944, 'PTHR35546:SF118', NULL, NULL, NULL, NULL, 'F-BOX ASSOCIATED UBIQUITINATION EFFECTOR FAMILY PROTEIN', 239184),
(301945, 'PTHR35546:SF73', NULL, NULL, NULL, NULL, '', 239184),
(301946, 'PTHR35546:SF31', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301947, 'PTHR35546:SF35', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301948, 'PTHR35546:SF38', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301949, 'PTHR35546:SF39', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 239184),
(301950, 'PTHR35546:SF70', NULL, NULL, NULL, NULL, '', 239184),
(301951, 'PTHR35546:SF61', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN', 239184),
(301952, 'PTHR35546:SF21', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301953, 'PTHR35546:SF64', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN', 239184),
(301954, 'PTHR35546:SF23', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301955, 'PTHR35546:SF66', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301956, 'PTHR35546:SF25', NULL, NULL, NULL, NULL, 'OS01G0876300 PROTEIN', 239184),
(301957, 'PTHR35546:SF24', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE-LIKE', 239184),
(301958, 'PTHR35546:SF68', NULL, NULL, NULL, NULL, 'FBA_3 DOMAIN-CONTAINING PROTEIN', 239184),
(301959, 'PTHR35546', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN INTERACTION DOMAIN PROTEIN-RELATED', 239184),
(301960, 'PTHR35546:SF29', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301961, 'PTHR35546:SF28', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301962, 'PTHR35546:SF50', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301963, 'PTHR35546:SF52', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE-LIKE', 239184),
(301964, 'PTHR35546:SF96', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301965, 'PTHR35546:SF95', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301966, 'PTHR35546:SF98', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN INTERACTION DOMAIN CONTAINING PROTEIN', 239184),
(301967, 'PTHR35546:SF99', NULL, NULL, NULL, NULL, 'F-BOX/KELCH-REPEAT PROTEIN', 239184),
(301968, 'PTHR35546:SF14', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE-LIKE', 239184),
(301969, 'PTHR35546:SF16', NULL, NULL, NULL, NULL, 'F-BOX ASSOCIATED UBIQUITINATION EFFECTOR FAMILY PROTEIN-RELATED', 239184),
(301970, 'PTHR35546:SF59', NULL, NULL, NULL, NULL, 'OS01G0379400 PROTEIN', 239184),
(301971, 'PTHR35546:SF15', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN INTERACTION DOMAIN PROTEIN', 239184),
(301972, 'PTHR35546:SF18', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239184),
(301973, 'PTHR35546:SF17', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE-LIKE', 239184),
(301974, 'PTHR35689:SF1', NULL, NULL, NULL, NULL, 'EARLY ENDOSOME ANTIGEN', 239185),
(301975, 'PTHR35689', NULL, NULL, NULL, NULL, 'EARLY ENDOSOME ANTIGEN', 239185),
(301976, 'PTHR35689:SF4', NULL, NULL, NULL, NULL, 'BNAA09G22990D PROTEIN', 239185),
(301977, 'PTHR35689:SF3', NULL, NULL, NULL, NULL, 'BNAA09G56970D PROTEIN', 239185),
(301978, 'PTHR35689:SF2', NULL, NULL, NULL, NULL, 'PLANT PROTEIN MATCH IS: (TAIR:PLANT.1) PROTEIN, PUTATIVE-RELATED', 239185),
(301979, 'PTHR16004:SF4', NULL, NULL, NULL, NULL, 'RBR-TYPE E3 UBIQUITIN TRANSFERASE', 239186);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(301980, 'PTHR16004:SF3', NULL, NULL, NULL, NULL, 'SI:DKEY-181M9.8', 239186),
(301981, 'PTHR16004', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 31-RELATED', 239186),
(301982, 'PTHR16004:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF31', 239186),
(301983, 'PTHR37161', NULL, NULL, NULL, NULL, 'HDC10475', 239187),
(301984, 'PTHR37161:SF2', NULL, NULL, NULL, NULL, 'AT11648P-RELATED', 239187),
(301985, 'PTHR37161:SF3', NULL, NULL, NULL, NULL, 'HDC10475', 239187),
(301986, 'PTHR43010:SF1', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 239188),
(301987, 'PTHR43010', NULL, NULL, NULL, NULL, 'UNIVERSAL STRESS PROTEIN SLR1230', 239188),
(301988, 'PTHR37432', NULL, NULL, NULL, NULL, 'PROTEIN CBG21304', 239189),
(301989, 'PTHR37432:SF1', NULL, NULL, NULL, NULL, 'DIMER_TNP_HAT DOMAIN-CONTAINING PROTEIN', 239189),
(301990, 'PTHR12940:SF0', NULL, NULL, NULL, NULL, 'SPLICING FACTOR ESS-2 HOMOLOG', 239190),
(301991, 'PTHR12940:SF1', NULL, NULL, NULL, NULL, 'BNAA05G29860D PROTEIN', 239190),
(301992, 'PTHR12940', NULL, NULL, NULL, NULL, 'ES-2 PROTEIN - RELATED', 239190),
(301993, 'PTHR46841:SF9', NULL, NULL, NULL, NULL, 'ZGC:113337', 239191),
(301994, 'PTHR46841:SF8', NULL, NULL, NULL, NULL, 'SI:DKEY-31E10.1', 239191),
(301995, 'PTHR46841:SF3', NULL, NULL, NULL, NULL, 'OX-2 MEMBRANE GLYCOPROTEIN', 239191),
(301996, 'PTHR46841', NULL, NULL, NULL, NULL, 'OX-2 MEMBRANE GLYCOPROTEIN', 239191),
(301997, 'PTHR46841:SF4', NULL, NULL, NULL, NULL, 'SC:D189-RELATED', 239191),
(301998, 'PTHR46841:SF7', NULL, NULL, NULL, NULL, 'ISEC2 PROTEIN, INTESTINAL SECRETORY CELL PROTEIN 2-RELATED', 239191),
(301999, 'PTHR33102:SF90', NULL, NULL, NULL, NULL, 'SMALL POLYPEPTIDE DEVIL 21', 239192),
(302000, 'PTHR33102:SF87', NULL, NULL, NULL, NULL, 'DVL FAMILY PROTEIN', 239192),
(302001, 'PTHR33102:SF86', NULL, NULL, NULL, NULL, 'SMALL POLYPEPTIDE DEVIL 23', 239192),
(302002, 'PTHR33102:SF85', NULL, NULL, NULL, NULL, '', 239192),
(302003, 'PTHR33102:SF63', NULL, NULL, NULL, NULL, '', 239192),
(302004, 'PTHR33102:SF62', NULL, NULL, NULL, NULL, '', 239192),
(302005, 'PTHR33102:SF84', NULL, NULL, NULL, NULL, 'OS05G0549232 PROTEIN', 239192),
(302006, 'PTHR33102:SF83', NULL, NULL, NULL, NULL, '', 239192),
(302007, 'PTHR33102:SF82', NULL, NULL, NULL, NULL, 'SMALL POLYPEPTIDE DEVIL 19-RELATED', 239192),
(302008, 'PTHR33102:SF27', NULL, NULL, NULL, NULL, 'ROTUNDIFOLIA LIKE 8', 239192),
(302009, 'PTHR33102:SF49', NULL, NULL, NULL, NULL, 'OS12G0573600 PROTEIN', 239192),
(302010, 'PTHR33102:SF26', NULL, NULL, NULL, NULL, 'DVL FAMILY PROTEIN', 239192),
(302011, 'PTHR33102:SF48', NULL, NULL, NULL, NULL, 'OS09G0306500 PROTEIN', 239192),
(302012, 'PTHR33102:SF47', NULL, NULL, NULL, NULL, 'SMALL POLYPEPTIDE DEVIL 12', 239192),
(302013, 'PTHR33102:SF46', NULL, NULL, NULL, NULL, 'SMALL POLYPEPTIDE DEVIL 17', 239192),
(302014, 'PTHR33102:SF24', NULL, NULL, NULL, NULL, 'OS01G0525701 PROTEIN', 239192),
(302015, 'PTHR33102:SF89', NULL, NULL, NULL, NULL, 'ROTUNDIFOLIA-LIKE PROTEIN', 239192),
(302016, 'PTHR33102:SF45', NULL, NULL, NULL, NULL, '', 239192),
(302017, 'PTHR33102', NULL, NULL, NULL, NULL, 'DVL19-RELATED-RELATED', 239192),
(302018, 'PTHR33102:SF44', NULL, NULL, NULL, NULL, 'SMALL POLYPEPTIDE ROTUNDIFOLIA LIKE 2', 239192),
(302019, 'PTHR33102:SF88', NULL, NULL, NULL, NULL, '', 239192),
(302020, 'PTHR33102:SF76', NULL, NULL, NULL, NULL, 'DVL-RELATED', 239192),
(302021, 'PTHR33102:SF75', NULL, NULL, NULL, NULL, '', 239192),
(302022, 'PTHR33102:SF96', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239192),
(302023, 'PTHR33102:SF95', NULL, NULL, NULL, NULL, '', 239192),
(302024, 'PTHR33102:SF73', NULL, NULL, NULL, NULL, 'BNAA09G35170D PROTEIN', 239192),
(302025, 'PTHR33102:SF94', NULL, NULL, NULL, NULL, '', 239192),
(302026, 'PTHR33102:SF72', NULL, NULL, NULL, NULL, 'ROTUNDIFOLIA LIKE 8', 239192),
(302027, 'PTHR33102:SF93', NULL, NULL, NULL, NULL, 'DVL FAMILY PROTEIN', 239192),
(302028, 'PTHR33102:SF70', NULL, NULL, NULL, NULL, 'OS01G0525800 PROTEIN', 239192),
(302029, 'PTHR33102:SF92', NULL, NULL, NULL, NULL, 'DVL-RELATED', 239192);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(302030, 'PTHR33102:SF91', NULL, NULL, NULL, NULL, 'OS01G0178850 PROTEIN', 239192),
(302031, 'PTHR33102:SF39', NULL, NULL, NULL, NULL, '', 239192),
(302032, 'PTHR33102:SF8', NULL, NULL, NULL, NULL, 'SMALL POLYPEPTIDE DEVIL 16-RELATED', 239192),
(302033, 'PTHR33102:SF38', NULL, NULL, NULL, NULL, 'SMALL POLYPEPTIDE DEVIL 4-RELATED', 239192),
(302034, 'PTHR33102:SF59', NULL, NULL, NULL, NULL, 'SMALL POLYPEPTIDE DEVIL 8', 239192),
(302035, 'PTHR33102:SF37', NULL, NULL, NULL, NULL, 'SMALL POLYPEPTIDE DEVIL 11', 239192),
(302036, 'PTHR33102:SF36', NULL, NULL, NULL, NULL, 'OS01G0525700 PROTEIN', 239192),
(302037, 'PTHR33102:SF57', NULL, NULL, NULL, NULL, 'SMALL POLYPEPTIDE DEVIL 10', 239192),
(302038, 'PTHR33102:SF79', NULL, NULL, NULL, NULL, 'ROTUNDIFOLIA-LIKE PROTEIN', 239192),
(302039, 'PTHR33102:SF78', NULL, NULL, NULL, NULL, 'OS01G0525350 PROTEIN', 239192),
(302040, 'PTHR33102:SF33', NULL, NULL, NULL, NULL, 'OS08G0357700 PROTEIN', 239192),
(302041, 'PTHR33102:SF77', NULL, NULL, NULL, NULL, 'SMALL POLYPEPTIDE DEVIL 7', 239192),
(302042, 'PTHR35014:SF1', NULL, NULL, NULL, NULL, 'INFECTION RESPONSE PROTEIN', 239193),
(302043, 'PTHR35014', NULL, NULL, NULL, NULL, 'INFECTION RESPONSE PROTEIN-RELATED', 239193),
(302044, 'PTHR35014:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG25495', 239193),
(302045, 'PTHR11324:SF8', NULL, NULL, NULL, NULL, 'BIG BANG, ISOFORM C', 239194),
(302046, 'PTHR11324', NULL, NULL, NULL, NULL, 'IL16-RELATED', 239194),
(302047, 'PTHR11324:SF1', NULL, NULL, NULL, NULL, 'RECEPTOR INTERACTING PROTEIN, PUTATIVE-RELATED', 239194),
(302048, 'PTHR11324:SF2', NULL, NULL, NULL, NULL, 'PRO-INTERLEUKIN-16', 239194),
(302049, 'PTHR11324:SF16', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN 2', 239194),
(302050, 'PTHR47027:SF20', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 239195),
(302051, 'PTHR47027:SF8', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 239195),
(302052, 'PTHR47027:SF18', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 239195),
(302053, 'PTHR47027:SF19', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 239195),
(302054, 'PTHR47027', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 239195),
(302055, 'PTHR47027:SF21', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE-LIKE PROTEIN WITH RNA-DIRECTED DNA POLYMERASE DOMAIN', 239195),
(302056, 'PTHR47027:SF22', NULL, NULL, NULL, NULL, '', 239195),
(302057, 'PTHR14754:SF34', NULL, NULL, NULL, NULL, 'HEMERYTHRIN DOMAIN-CONTAINING PROTEIN', 239196),
(302058, 'PTHR14754', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR A', 239196),
(302059, 'PTHR47636', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN RCO1', 239197),
(302060, 'PTHR47636:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN RCO1', 239197),
(302061, 'PTHR47636:SF2', NULL, NULL, NULL, NULL, 'CLR6 HISTONE DEACETYLASE ASSOCIATED PHD PROTEIN-1 CPH1', 239197),
(302062, 'PTHR16525:SF0', NULL, NULL, NULL, NULL, 'PROTEIN C12ORF4', 239198),
(302063, 'PTHR16525', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239198),
(302064, 'PTHR15902:SF5', NULL, NULL, NULL, NULL, '', 239199),
(302065, 'PTHR15902:SF6', NULL, NULL, NULL, NULL, 'NEURITIN 1-LIKE B', 239199),
(302066, 'PTHR15902', NULL, NULL, NULL, NULL, 'NEURITIN-RELATED', 239199),
(302067, 'PTHR15902:SF1', NULL, NULL, NULL, NULL, 'NEURITIN', 239199),
(302068, 'PTHR15902:SF2', NULL, NULL, NULL, NULL, 'NEURITIN-LIKE PROTEIN', 239199),
(302069, 'PTHR33348:SF7', NULL, NULL, NULL, NULL, 'PRECURSOR OF CEP11-RELATED', 239200),
(302070, 'PTHR33348:SF40', NULL, NULL, NULL, NULL, 'PRECURSOR OF CEP3', 239200),
(302071, 'PTHR33348:SF30', NULL, NULL, NULL, NULL, 'BNAA08G07800D PROTEIN', 239200),
(302072, 'PTHR33348:SF41', NULL, NULL, NULL, NULL, '', 239200),
(302073, 'PTHR33348:SF20', NULL, NULL, NULL, NULL, 'PRECURSOR OF CEP4', 239200),
(302074, 'PTHR33348:SF3', NULL, NULL, NULL, NULL, 'ENCODED PEPTIDE-RELATED', 239200),
(302075, 'PTHR33348:SF42', NULL, NULL, NULL, NULL, 'PRECURSOR OF CEP8', 239200);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(302076, 'PTHR33348:SF43', NULL, NULL, NULL, NULL, '', 239200),
(302077, 'PTHR33348:SF21', NULL, NULL, NULL, NULL, 'PRECURSOR OF CEP10-RELATED', 239200),
(302078, 'PTHR33348', NULL, NULL, NULL, NULL, 'PRECURSOR OF CEP5', 239200),
(302079, 'PTHR33348:SF44', NULL, NULL, NULL, NULL, 'PRECURSOR OF CEP6', 239200),
(302080, 'PTHR33348:SF33', NULL, NULL, NULL, NULL, 'BNAA04G13640D PROTEIN', 239200),
(302081, 'PTHR33348:SF34', NULL, NULL, NULL, NULL, 'ENCODED PEPTIDE-RELATED', 239200),
(302082, 'PTHR33348:SF45', NULL, NULL, NULL, NULL, '', 239200),
(302083, 'PTHR33348:SF24', NULL, NULL, NULL, NULL, '', 239200),
(302084, 'PTHR33348:SF35', NULL, NULL, NULL, NULL, 'BNAA09G52570D PROTEIN', 239200),
(302085, 'PTHR33348:SF46', NULL, NULL, NULL, NULL, '', 239200),
(302086, 'PTHR33348:SF47', NULL, NULL, NULL, NULL, 'OS08G0475500 PROTEIN', 239200),
(302087, 'PTHR33348:SF36', NULL, NULL, NULL, NULL, 'PRECURSOR OF CEP1', 239200),
(302088, 'PTHR33348:SF37', NULL, NULL, NULL, NULL, 'BNAA05G08420D PROTEIN', 239200),
(302089, 'PTHR33348:SF27', NULL, NULL, NULL, NULL, 'BNAC02G44010D PROTEIN', 239200),
(302090, 'PTHR33348:SF39', NULL, NULL, NULL, NULL, 'PRECURSOR OF CEP5', 239200),
(302091, 'PTHR12623:SF9', NULL, NULL, NULL, NULL, 'NGFI-A-BINDING PROTEIN 1', 239201),
(302092, 'PTHR12623:SF11', NULL, NULL, NULL, NULL, 'PRE-B-CELL LEUKEMIA TRANSCRIPTION FACTOR 1-LIKE', 239201),
(302093, 'PTHR12623:SF10', NULL, NULL, NULL, NULL, 'NGFI-A-BINDING PROTEIN HOMOLOG', 239201),
(302094, 'PTHR12623:SF6', NULL, NULL, NULL, NULL, 'NGFI-A-BINDING PROTEIN 2', 239201),
(302095, 'PTHR12623', NULL, NULL, NULL, NULL, 'NGFI-A BINDING PROTEIN', 239201),
(302096, 'PTHR43194:SF3', NULL, NULL, NULL, NULL, 'SIGMA FACTOR SIGB REGULATION PROTEIN RSBQ', 239202),
(302097, 'PTHR43194:SF2', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN LPX1', 239202),
(302098, 'PTHR43194:SF5', NULL, NULL, NULL, NULL, 'PIMELOYL-[ACYL-CARRIER PROTEIN] METHYL ESTER ESTERASE', 239202),
(302099, 'PTHR43194:SF4', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 239202),
(302100, 'PTHR43194', NULL, NULL, NULL, NULL, 'HYDROLASE ALPHA/BETA FOLD FAMILY', 239202),
(302101, 'PTHR40703', NULL, NULL, NULL, NULL, 'TRNA (PSEUDOURIDINE(54)-N(1))-METHYLTRANSFERASE', 239203),
(302102, 'PTHR40703:SF1', NULL, NULL, NULL, NULL, 'TRNA (PSEUDOURIDINE(54)-N(1))-METHYLTRANSFERASE', 239203),
(302103, 'PTHR34057:SF19', NULL, NULL, NULL, NULL, 'BNAC07G31630D PROTEIN', 239204),
(302104, 'PTHR34057:SF17', NULL, NULL, NULL, NULL, '', 239204),
(302105, 'PTHR34057:SF1', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR', 239204),
(302106, 'PTHR34057:SF12', NULL, NULL, NULL, NULL, '', 239204),
(302107, 'PTHR34057', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR', 239204),
(302108, 'PTHR34057:SF10', NULL, NULL, NULL, NULL, 'BNAA08G15670D PROTEIN', 239204),
(302109, 'PTHR34057:SF15', NULL, NULL, NULL, NULL, '', 239204),
(302110, 'PTHR34057:SF13', NULL, NULL, NULL, NULL, 'OS05G0365200 PROTEIN', 239204),
(302111, 'PTHR34301:SF8', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN-RELATED', 239205),
(302112, 'PTHR34301:SF10', NULL, NULL, NULL, NULL, 'ATPASE_2 DOMAIN-CONTAINING PROTEIN', 239205),
(302113, 'PTHR34301', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN-RELATED', 239205),
(302114, 'PTHR31466', NULL, NULL, NULL, NULL, 'GENE 5591-RELATED', 239206),
(302115, 'PTHR31466:SF1', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4930433I11 GENE', 239206),
(302116, 'PTHR31466:SF9', NULL, NULL, NULL, NULL, 'GENE 5591-RELATED', 239206),
(302117, 'PTHR31466:SF10', NULL, NULL, NULL, NULL, 'GENE 4884-RELATED', 239206),
(302118, 'PTHR37173', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 239207),
(302119, 'PTHR37173:SF1', NULL, NULL, NULL, NULL, 'PROLINE-RICH FAMILY PROTEIN', 239207),
(302120, 'PTHR37173:SF3', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 239207),
(302121, 'PTHR45756', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE', 239208),
(302122, 'PTHR45756:SF1', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0278665-RELATED', 239208);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(302123, 'PTHR28654:SF1', NULL, NULL, NULL, NULL, 'AXIN INTERACTOR, DORSALIZATION-ASSOCIATED PROTEIN', 239209),
(302124, 'PTHR28654', NULL, NULL, NULL, NULL, 'AXIN INTERACTOR, DORSALIZATION-ASSOCIATED PROTEIN', 239209),
(302125, 'PTHR15665', NULL, NULL, NULL, NULL, 'ASTEROID PROTEIN', 239210),
(302126, 'PTHR15665:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ASTEROID HOMOLOG 1', 239210),
(302127, 'PTHR15138:SF25', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 4', 239211),
(302128, 'PTHR15138:SF14', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 4', 239211),
(302129, 'PTHR15138:SF17', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 4B', 239211),
(302130, 'PTHR15138:SF27', NULL, NULL, NULL, NULL, 'RST DOMAIN-CONTAINING PROTEIN', 239211),
(302131, 'PTHR15138:SF22', NULL, NULL, NULL, NULL, 'TAFH DOMAIN-CONTAINING PROTEIN', 239211),
(302132, 'PTHR15138:SF24', NULL, NULL, NULL, NULL, 'OS03G0441000 PROTEIN', 239211),
(302133, 'PTHR15138', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 4', 239211),
(302134, 'PTHR15138:SF29', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 4', 239211),
(302135, 'PTHR15138:SF18', NULL, NULL, NULL, NULL, 'TATA-BOX-BINDING PROTEIN-ASSOCIATED FACTOR 4', 239211),
(302136, 'PTHR31117:SF2', NULL, NULL, NULL, NULL, 'PROTEIN KREG-1', 239212),
(302137, 'PTHR31117', NULL, NULL, NULL, NULL, 'PROTEIN KREG-1', 239212),
(302138, 'PTHR31117:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG16337', 239212),
(302139, 'PTHR31117:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG15402', 239212),
(302140, 'PTHR31698:SF9', NULL, NULL, NULL, NULL, 'LYSOZYME G', 239213),
(302141, 'PTHR31698', NULL, NULL, NULL, NULL, 'LYSOZYME G FAMILY MEMBER', 239213),
(302142, 'PTHR31698:SF8', NULL, NULL, NULL, NULL, 'LYSOZYME G', 239213),
(302143, 'PTHR31698:SF5', NULL, NULL, NULL, NULL, 'LYSOZYME G-LIKE PROTEIN 1', 239213),
(302144, 'PTHR31698:SF4', NULL, NULL, NULL, NULL, 'LYSOZYME G-LIKE PROTEIN 2', 239213),
(302145, 'PTHR31698:SF7', NULL, NULL, NULL, NULL, 'PEPTIDASE_M15_4 DOMAIN-CONTAINING PROTEIN', 239213),
(302146, 'PTHR22874:SF10', NULL, NULL, NULL, NULL, 'TRANSDUCIN FAMILY PROTEIN / WD-40 REPEAT FAMILY PROTEIN', 239214),
(302147, 'PTHR22874:SF1', NULL, NULL, NULL, NULL, 'ACTIVATING MOLECULE IN BECN1-REGULATED AUTOPHAGY PROTEIN 1', 239214),
(302148, 'PTHR22874', NULL, NULL, NULL, NULL, 'ACTIVATING MOLECULE IN BECN1-REGULATED AUTOPHAGY PROTEIN 1', 239214),
(302149, 'PTHR22874:SF9', NULL, NULL, NULL, NULL, 'TRANSDUCIN FAMILY PROTEIN / WD-40 REPEAT FAMILY PROTEIN', 239214),
(302150, 'PTHR22874:SF14', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 239214),
(302151, 'PTHR22874:SF8', NULL, NULL, NULL, NULL, 'TRANSDUCIN FAMILY PROTEIN / WD-40 REPEAT FAMILY PROTEIN', 239214),
(302152, 'PTHR22874:SF13', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 239214),
(302153, 'PTHR47529', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE D', 239215),
(302154, 'PTHR47529:SF1', NULL, NULL, NULL, NULL, 'PERIPLASMIC CHAPERONE PPID', 239215),
(302155, 'PTHR36018:SF1', NULL, NULL, NULL, NULL, 'OS09G0481800 PROTEIN', 239216),
(302156, 'PTHR36018', NULL, NULL, NULL, NULL, 'OS09G0481800 PROTEIN', 239216),
(302157, 'PTHR35691', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239217),
(302158, 'PTHR35691:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239217),
(302159, 'PTHR35691:SF2', NULL, NULL, NULL, NULL, 'BNAANNG04120D PROTEIN', 239217),
(302160, 'PTHR28581:SF1', NULL, NULL, NULL, NULL, 'CONSORTIN', 239218),
(302161, 'PTHR28581', NULL, NULL, NULL, NULL, 'CONSORTIN', 239218),
(302162, 'PTHR15402', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR-LIKE 5 PROTEIN', 239219),
(302163, 'PTHR15402:SF2', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 239219),
(302164, 'PTHR15402:SF4', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS- AND OOGENESIS-SPECIFIC BASIC HELIX-LOOP-HELIX-CONTAINING PROTEIN 1', 239219),
(302165, 'PTHR15402:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR-LIKE 5 PROTEIN', 239219);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(302166, 'PTHR47434:SF3', NULL, NULL, NULL, NULL, 'AMPK1_CBM DOMAIN-CONTAINING PROTEIN', 239220),
(302167, 'PTHR47434:SF2', NULL, NULL, NULL, NULL, 'PROTEIN PTST HOMOLOG 3, CHLOROPLASTIC', 239220),
(302168, 'PTHR47434:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PTST HOMOLOG 2, CHLOROPLASTIC', 239220),
(302169, 'PTHR47434', NULL, NULL, NULL, NULL, 'PROTEIN PTST HOMOLOG 3, CHLOROPLASTIC', 239220),
(302170, 'PTHR31776:SF23', NULL, NULL, NULL, NULL, 'NON-REDUCING END ALPHA-L-ARABINOFURANOSIDASE', 239221),
(302171, 'PTHR31776:SF13', NULL, NULL, NULL, NULL, 'NON-REDUCING END ALPHA-L-ARABINOFURANOSIDASE', 239221),
(302172, 'PTHR31776:SF14', NULL, NULL, NULL, NULL, 'NON-REDUCING END ALPHA-L-ARABINOFURANOSIDASE', 239221),
(302173, 'PTHR31776:SF25', NULL, NULL, NULL, NULL, 'NON-REDUCING END ALPHA-L-ARABINOFURANOSIDASE', 239221),
(302174, 'PTHR31776:SF15', NULL, NULL, NULL, NULL, 'NON-REDUCING END ALPHA-L-ARABINOFURANOSIDASE', 239221),
(302175, 'PTHR31776', NULL, NULL, NULL, NULL, 'ALPHA-L-ARABINOFURANOSIDASE 1', 239221),
(302176, 'PTHR31776:SF26', NULL, NULL, NULL, NULL, 'SECRETED ARABINOSIDASE-RELATED', 239221),
(302177, 'PTHR31776:SF20', NULL, NULL, NULL, NULL, 'NON-REDUCING END ALPHA-L-ARABINOFURANOSIDASE', 239221),
(302178, 'PTHR31776:SF21', NULL, NULL, NULL, NULL, 'ALPHA-L-ARABINOFURANOSIDASE 2', 239221),
(302179, 'PTHR31776:SF22', NULL, NULL, NULL, NULL, 'NON-REDUCING END ALPHA-L-ARABINOFURANOSIDASE', 239221),
(302180, 'PTHR31776:SF0', NULL, NULL, NULL, NULL, 'ALPHA-L-ARABINOFURANOSIDASE 1', 239221),
(302181, 'PTHR31776:SF16', NULL, NULL, NULL, NULL, 'NON-REDUCING END ALPHA-L-ARABINOFURANOSIDASE', 239221),
(302182, 'PTHR31776:SF17', NULL, NULL, NULL, NULL, 'NON-REDUCING END ALPHA-L-ARABINOFURANOSIDASE', 239221),
(302183, 'PTHR31776:SF18', NULL, NULL, NULL, NULL, 'NON-REDUCING END ALPHA-L-ARABINOFURANOSIDASE', 239221),
(302184, 'PTHR21220:SF0', NULL, NULL, NULL, NULL, 'DNA-DEPENDENT METALLOPROTEASE SPRTN', 239222),
(302185, 'PTHR21220', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239222),
(302186, 'PTHR21220:SF2', NULL, NULL, NULL, NULL, 'OS09G0407300 PROTEIN', 239222),
(302187, 'PTHR21220:SF4', NULL, NULL, NULL, NULL, 'SPRT-LIKE DOMAIN-CONTAINING PROTEIN', 239222),
(302188, 'PTHR14699:SF2', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 21A', 239223),
(302189, 'PTHR14699:SF0', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 21 HOMOLOG', 239223),
(302190, 'PTHR14699:SF1', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 21B', 239223),
(302191, 'PTHR14699', NULL, NULL, NULL, NULL, 'STI2 PROTEIN-RELATED', 239223),
(302192, 'PTHR38382', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN', 239224),
(302193, 'PTHR38382:SF1', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN', 239224),
(302194, 'PTHR15654:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 96', 239225),
(302195, 'PTHR15654', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239225),
(302196, 'PTHR15654:SF2', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 113', 239225),
(302197, 'PTHR47497:SF1', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 8', 239226),
(302198, 'PTHR47497', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 8', 239226),
(302199, 'PTHR14440', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE I SUBUNIT RPA49', 239227),
(302200, 'PTHR14440:SF7', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE I SUBUNIT RPA49', 239227),
(302201, 'PTHR47658:SF4', NULL, NULL, NULL, NULL, 'HMG BOX DOMAIN-CONTAINING PROTEIN', 239228),
(302202, 'PTHR47658:SF1', NULL, NULL, NULL, NULL, 'MEIOSIS INITIATOR PROTEIN', 239228),
(302203, 'PTHR47658', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP B PROTEIN 12-RELATED', 239228),
(302204, 'PTHR47658:SF2', NULL, NULL, NULL, NULL, 'HMG-BOX (HIGH MOBILITY GROUP) DNA-BINDING FAMILY PROTEIN', 239228),
(302205, 'PTHR47658:SF5', NULL, NULL, NULL, NULL, 'HMG BOX DOMAIN-CONTAINING PROTEIN', 239228),
(302206, 'PTHR47658:SF6', NULL, NULL, NULL, NULL, 'HMG BOX DOMAIN-CONTAINING PROTEIN', 239228),
(302207, 'PTHR45957:SF1', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT 2', 239229);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(302208, 'PTHR45957:SF2', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT 2', 239229),
(302209, 'PTHR45957', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT 2', 239229),
(302210, 'PTHR31728:SF4', NULL, NULL, NULL, NULL, '', 239230),
(302211, 'PTHR31728:SF5', NULL, NULL, NULL, NULL, 'OS07G0540200 PROTEIN', 239230),
(302212, 'PTHR31728', NULL, NULL, NULL, NULL, 'ABRAXAS FAMILY MEMBER', 239230),
(302213, 'PTHR31728:SF2', NULL, NULL, NULL, NULL, 'BRCA1-A COMPLEX SUBUNIT ABRAXAS 1', 239230),
(302214, 'PTHR31728:SF3', NULL, NULL, NULL, NULL, '', 239230),
(302215, 'PTHR31728:SF1', NULL, NULL, NULL, NULL, 'BRISC COMPLEX SUBUNIT ABRAXAS 2', 239230),
(302216, 'PTHR37562', NULL, NULL, NULL, NULL, '', 239231),
(302217, 'PTHR37562:SF5', NULL, NULL, NULL, NULL, '', 239231),
(302218, 'PTHR37562:SF2', NULL, NULL, NULL, NULL, '', 239231),
(302219, 'PTHR34951:SF7', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN', 239232),
(302220, 'PTHR34951:SF5', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 239232),
(302221, 'PTHR34951:SF6', NULL, NULL, NULL, NULL, 'PLASTOQUINOL-PLASTOCYANIN REDUCTASE', 239232),
(302222, 'PTHR34951:SF1', NULL, NULL, NULL, NULL, 'B6F COMPLEX SUBUNIT, PUTATIVE, EXPRESSED-RELATED', 239232),
(302223, 'PTHR34951', NULL, NULL, NULL, NULL, 'B6F COMPLEX SUBUNIT, PUTATIVE, EXPRESSED-RELATED', 239232),
(302224, 'PTHR34951:SF2', NULL, NULL, NULL, NULL, 'REDUCTASE, PUTATIVE-RELATED', 239232),
(302225, 'PTHR31897:SF7', NULL, NULL, NULL, NULL, 'DUF19 DOMAIN-CONTAINING PROTEIN', 239233),
(302226, 'PTHR31897:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG19579', 239233),
(302227, 'PTHR31897:SF9', NULL, NULL, NULL, NULL, 'DUF19 DOMAIN-CONTAINING PROTEIN', 239233),
(302228, 'PTHR31897:SF3', NULL, NULL, NULL, NULL, 'DUF19 DOMAIN-CONTAINING PROTEIN', 239233),
(302229, 'PTHR31897:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG04712', 239233),
(302230, 'PTHR31897:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG17019', 239233),
(302231, 'PTHR31897:SF6', NULL, NULL, NULL, NULL, 'DUF19 DOMAIN-CONTAINING PROTEIN', 239233),
(302232, 'PTHR31897', NULL, NULL, NULL, NULL, 'PROTEIN CBG17011-RELATED', 239233),
(302233, 'PTHR31897:SF12', NULL, NULL, NULL, NULL, 'DUF19 DOMAIN-CONTAINING PROTEIN', 239233),
(302234, 'PTHR31897:SF11', NULL, NULL, NULL, NULL, 'DUF19 DOMAIN-CONTAINING PROTEIN', 239233),
(302235, 'PTHR31897:SF10', NULL, NULL, NULL, NULL, 'DUF19 DOMAIN-CONTAINING PROTEIN', 239233),
(302236, 'PTHR31897:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG04687', 239233),
(302237, 'PTHR31897:SF2', NULL, NULL, NULL, NULL, 'DUF19 DOMAIN-CONTAINING PROTEIN', 239233),
(302238, 'PTHR15722:SF8', NULL, NULL, NULL, NULL, 'REPEAT PROTEIN, PUTATIVE-RELATED', 239234),
(302239, 'PTHR15722', NULL, NULL, NULL, NULL, 'IFT140/172-RELATED', 239234),
(302240, 'PTHR15722:SF2', NULL, NULL, NULL, NULL, 'INTRAFLAGELLAR TRANSPORT PROTEIN 172 HOMOLOG', 239234),
(302241, 'PTHR15722:SF7', NULL, NULL, NULL, NULL, 'INTRAFLAGELLAR TRANSPORT PROTEIN 140 HOMOLOG', 239234),
(302242, 'PTHR36166:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 9, WHOLE GENOME SHOTGUN SEQUENCE', 239235),
(302243, 'PTHR36166', NULL, NULL, NULL, NULL, 'CHROMOSOME 9, WHOLE GENOME SHOTGUN SEQUENCE', 239235),
(302244, 'PTHR43165:SF1', NULL, NULL, NULL, NULL, 'PHOSPHODIESTERASE MJ0936', 239236),
(302245, 'PTHR43165', NULL, NULL, NULL, NULL, 'METALLOPHOSPHOESTERASE', 239236),
(302246, 'PTHR10768:SF22', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L37', 239237),
(302247, 'PTHR10768:SF33', NULL, NULL, NULL, NULL, 'BNAA02G30880D PROTEIN', 239237),
(302248, 'PTHR10768:SF32', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L37', 239237),
(302249, 'PTHR10768:SF21', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L37', 239237),
(302250, 'PTHR10768:SF23', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L37', 239237),
(302251, 'PTHR10768:SF37', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L37', 239237),
(302252, 'PTHR10768:SF36', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L37', 239237),
(302253, 'PTHR10768:SF25', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L37-1-RELATED', 239237);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(302254, 'PTHR10768:SF39', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L37', 239237),
(302255, 'PTHR10768:SF38', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L37', 239237),
(302256, 'PTHR10768:SF19', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L37', 239237),
(302257, 'PTHR10768:SF29', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L37', 239237),
(302258, 'PTHR10768', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L37', 239237),
(302259, 'PTHR10768:SF40', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L37', 239237),
(302260, 'PTHR10768:SF0', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L37', 239237),
(302261, 'PTHR10768:SF20', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L37', 239237),
(302262, 'PTHR10768:SF30', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L37', 239237),
(302263, 'PTHR33538:SF6', NULL, NULL, NULL, NULL, 'BNAC03G14190D PROTEIN', 239238),
(302264, 'PTHR33538:SF5', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 239238),
(302265, 'PTHR33538:SF2', NULL, NULL, NULL, NULL, 'PROTEIN GAMETE EXPRESSED 1', 239238),
(302266, 'PTHR33538:SF1', NULL, NULL, NULL, NULL, 'PROTEIN BRAMBLEBERRY', 239238),
(302267, 'PTHR33538', NULL, NULL, NULL, NULL, 'PROTEIN GAMETE EXPRESSED 1', 239238),
(302268, 'PTHR18949:SF1', NULL, NULL, NULL, NULL, 'LYMPHOCYTE-SPECIFIC PROTEIN 1', 239239),
(302269, 'PTHR18949:SF0', NULL, NULL, NULL, NULL, 'CALDESMON', 239239),
(302270, 'PTHR18949:SF3', NULL, NULL, NULL, NULL, '', 239239),
(302271, 'PTHR18949', NULL, NULL, NULL, NULL, 'CALDESMON', 239239),
(302272, 'PTHR35089:SF1', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN SKP', 239240),
(302273, 'PTHR35089', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN SKP', 239240),
(302274, 'PTHR35829', NULL, NULL, NULL, NULL, 'OS05G0470900 PROTEIN', 239241),
(302275, 'PTHR35829:SF3', NULL, NULL, NULL, NULL, '', 239241),
(302276, 'PTHR35829:SF2', NULL, NULL, NULL, NULL, 'OS01G0829600 PROTEIN', 239241),
(302277, 'PTHR36799:SF2', NULL, NULL, NULL, NULL, 'DUF3148 FAMILY PROTEIN', 239242),
(302278, 'PTHR36799', NULL, NULL, NULL, NULL, '', 239242),
(302279, 'PTHR37232', NULL, NULL, NULL, NULL, 'FASCICLIN DOMAIN PROTEIN', 239243),
(302280, 'PTHR37232:SF2', NULL, NULL, NULL, NULL, 'FAS1 DOMAIN-CONTAINING PROTEIN', 239243),
(302281, 'PTHR30578', NULL, NULL, NULL, NULL, 'ELECTRON TRANSPORT COMPLEX PROTEIN RNFD', 239244),
(302282, 'PTHR30578:SF0', NULL, NULL, NULL, NULL, 'ION-TRANSLOCATING OXIDOREDUCTASE COMPLEX SUBUNIT D', 239244),
(302283, 'PTHR30578:SF1', NULL, NULL, NULL, NULL, 'NA(+)-TRANSLOCATING NADH-QUINONE REDUCTASE SUBUNIT B', 239244),
(302284, 'PTHR12809:SF6', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 14', 239245),
(302285, 'PTHR12809:SF2', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 14', 239245),
(302286, 'PTHR12809', NULL, NULL, NULL, NULL, 'MEDIATOR COMPLEX SUBUNIT', 239245),
(302287, 'PTHR35726:SF4', NULL, NULL, NULL, NULL, 'MYELIN TRANSCRIPTION FACTOR-LIKE PROTEIN', 239246),
(302288, 'PTHR35726', NULL, NULL, NULL, NULL, 'GLUTAMIC ACID-RICH PROTEIN-LIKE', 239246),
(302289, 'PTHR35726:SF5', NULL, NULL, NULL, NULL, '', 239246),
(302290, 'PTHR35726:SF8', NULL, NULL, NULL, NULL, '', 239246),
(302291, 'PTHR35726:SF9', NULL, NULL, NULL, NULL, '', 239246),
(302292, 'PTHR35726:SF10', NULL, NULL, NULL, NULL, 'BNAA09G40350D PROTEIN', 239246),
(302293, 'PTHR40375', NULL, NULL, NULL, NULL, 'SPORULATION-SPECIFIC PROTEIN 22', 239247),
(302294, 'PTHR40375:SF2', NULL, NULL, NULL, NULL, 'SPORULATION-SPECIFIC PROTEIN 22', 239247),
(302295, 'PTHR15441', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P PROTEIN SUBUNIT P14', 239248),
(302296, 'PTHR15441:SF1', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P PROTEIN SUBUNIT P14', 239248),
(302297, 'PTHR15441:SF2', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P/MRP PROTEIN SUBUNIT POP5', 239248),
(302298, 'PTHR33914:SF20', NULL, NULL, NULL, NULL, '', 239249),
(302299, 'PTHR33914:SF21', NULL, NULL, NULL, NULL, 'SERINE-RICH ADHESIN FOR PLATELETS-LIKE', 239249),
(302300, 'PTHR33914:SF22', NULL, NULL, NULL, NULL, '18S PRE-RIBOSOMAL ASSEMBLY PROTEIN GAR2-LIKE PROTEIN', 239249);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(302301, 'PTHR33914:SF13', NULL, NULL, NULL, NULL, 'OS04G0467100 PROTEIN', 239249),
(302302, 'PTHR33914:SF9', NULL, NULL, NULL, NULL, 'BNACNNG21260D PROTEIN', 239249),
(302303, 'PTHR33914:SF8', NULL, NULL, NULL, NULL, 'BNAC09G52460D PROTEIN', 239249),
(302304, 'PTHR33914:SF15', NULL, NULL, NULL, NULL, '', 239249),
(302305, 'PTHR33914:SF16', NULL, NULL, NULL, NULL, '', 239249),
(302306, 'PTHR33914', NULL, NULL, NULL, NULL, '18S PRE-RIBOSOMAL ASSEMBLY PROTEIN GAR2-LIKE PROTEIN', 239249),
(302307, 'PTHR33914:SF17', NULL, NULL, NULL, NULL, '', 239249),
(302308, 'PTHR33914:SF18', NULL, NULL, NULL, NULL, '', 239249),
(302309, 'PTHR33914:SF19', NULL, NULL, NULL, NULL, '', 239249),
(302310, 'PTHR33914:SF2', NULL, NULL, NULL, NULL, 'OS02G0582100 PROTEIN', 239249),
(302311, 'PTHR33914:SF3', NULL, NULL, NULL, NULL, 'PROTEIN BREAKING OF ASYMMETRY IN THE STOMATAL LINEAGE', 239249),
(302312, 'PTHR46970', NULL, NULL, NULL, NULL, 'BASIC HELIX-LOOP-HELIX DOMAIN-CONTAINING PROTEIN USF3', 239250),
(302313, 'PTHR46970:SF1', NULL, NULL, NULL, NULL, 'BASIC HELIX-LOOP-HELIX DOMAIN-CONTAINING PROTEIN USF3', 239250),
(302314, 'PTHR34109', NULL, NULL, NULL, NULL, 'BNAUNNG04460D PROTEIN-RELATED', 239251),
(302315, 'PTHR34109:SF1', NULL, NULL, NULL, NULL, 'VOC DOMAIN-CONTAINING PROTEIN', 239251),
(302316, 'PTHR34109:SF4', NULL, NULL, NULL, NULL, 'LYASE-RELATED', 239251),
(302317, 'PTHR34109:SF5', NULL, NULL, NULL, NULL, 'BNAA02G30200D PROTEIN', 239251),
(302318, 'PTHR12729', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239252),
(302319, 'PTHR12729:SF1', NULL, NULL, NULL, NULL, 'THG1 DOMAIN-CONTAINING PROTEIN', 239252),
(302320, 'PTHR12729:SF5', NULL, NULL, NULL, NULL, 'THG1 DOMAIN-CONTAINING PROTEIN', 239252),
(302321, 'PTHR12729:SF6', NULL, NULL, NULL, NULL, 'TRNA(HIS) GUANYLYLTRANSFERASE-RELATED', 239252),
(302322, 'PTHR12729:SF8', NULL, NULL, NULL, NULL, 'TRNA(HIS) GUANYLYLTRANSFERASE', 239252),
(302323, 'PTHR12729:SF11', NULL, NULL, NULL, NULL, 'TRNA(HIS) GUANYLYLTRANSFERASE', 239252),
(302324, 'PTHR42182:SF1', NULL, NULL, NULL, NULL, 'SLL0359 PROTEIN', 239253),
(302325, 'PTHR42182', NULL, NULL, NULL, NULL, 'SLL0359 PROTEIN', 239253),
(302326, 'PTHR34444:SF1', NULL, NULL, NULL, NULL, 'LOC361192', 239254),
(302327, 'PTHR34444:SF3', NULL, NULL, NULL, NULL, '', 239254),
(302328, 'PTHR34444', NULL, NULL, NULL, NULL, 'LOC361192', 239254),
(302329, 'PTHR15363', NULL, NULL, NULL, NULL, 'POU DOMAIN CLASS 2-ASSOCIATING FACTOR 1', 239255),
(302330, 'PTHR15363:SF3', NULL, NULL, NULL, NULL, 'POU DOMAIN CLASS 2-ASSOCIATING FACTOR 1', 239255),
(302331, 'PTHR15363:SF4', NULL, NULL, NULL, NULL, 'MUCIN 91C, ISOFORM A', 239255),
(302332, 'PTHR33163:SF47', NULL, NULL, NULL, NULL, 'PROTEIN TIC 214', 239256),
(302333, 'PTHR33163:SF39', NULL, NULL, NULL, NULL, 'PROTEIN TIC 214', 239256),
(302334, 'PTHR33163:SF38', NULL, NULL, NULL, NULL, 'PROTEIN TIC 214', 239256),
(302335, 'PTHR33163:SF40', NULL, NULL, NULL, NULL, 'PROTEIN TIC 214', 239256),
(302336, 'PTHR33163', NULL, NULL, NULL, NULL, 'PROTEIN TIC 214-RELATED', 239256),
(302337, 'PTHR33163:SF42', NULL, NULL, NULL, NULL, 'PROTEIN TIC 214', 239256),
(302338, 'PTHR33163:SF41', NULL, NULL, NULL, NULL, 'PROTEIN TIC 214', 239256),
(302339, 'PTHR33163:SF44', NULL, NULL, NULL, NULL, 'YCF1 DOMAIN PROTEIN', 239256),
(302340, 'PTHR33163:SF43', NULL, NULL, NULL, NULL, 'PROTEIN TIC 214', 239256),
(302341, 'PTHR33163:SF46', NULL, NULL, NULL, NULL, 'PROTEIN TIC 214', 239256),
(302342, 'PTHR33163:SF45', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN YCF1', 239256),
(302343, 'PTHR46364:SF13', NULL, NULL, NULL, NULL, 'BNAC03G64850D PROTEIN', 239257),
(302344, 'PTHR46364:SF11', NULL, NULL, NULL, NULL, 'CHROMATIN REMODELING PROTEIN EBS', 239257),
(302345, 'PTHR46364:SF10', NULL, NULL, NULL, NULL, '', 239257),
(302346, 'PTHR46364', NULL, NULL, NULL, NULL, 'OS08G0421900 PROTEIN', 239257),
(302347, 'PTHR46364:SF8', NULL, NULL, NULL, NULL, 'OS08G0421900 PROTEIN', 239257),
(302348, 'PTHR46364:SF9', NULL, NULL, NULL, NULL, 'CHROMATIN REMODELING PROTEIN EBS-LIKE', 239257),
(302349, 'PTHR46364:SF7', NULL, NULL, NULL, NULL, 'CHROMATIN REMODELING PROTEIN SHL', 239257);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(302350, 'PTHR46364:SF17', NULL, NULL, NULL, NULL, 'OS09G0386500 PROTEIN', 239257),
(302351, 'PTHR46364:SF16', NULL, NULL, NULL, NULL, 'CHROMATIN REMODELING PROTEIN EBS', 239257),
(302352, 'PTHR46364:SF15', NULL, NULL, NULL, NULL, '', 239257),
(302353, 'PTHR36091:SF1', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN 9, MITOCHONDRIAL', 239258),
(302354, 'PTHR36091', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN 9, MITOCHONDRIAL', 239258),
(302355, 'PTHR36091:SF2', NULL, NULL, NULL, NULL, 'APH DOMAIN-CONTAINING PROTEIN', 239258),
(302356, 'PTHR10363:SF2', NULL, NULL, NULL, NULL, 'BLEOMYCIN HYDROLASE', 239259),
(302357, 'PTHR10363', NULL, NULL, NULL, NULL, 'BLEOMYCIN HYDROLASE', 239259),
(302358, 'PTHR36354', NULL, NULL, NULL, NULL, 'IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT', 239260),
(302359, 'PTHR36354:SF3', NULL, NULL, NULL, NULL, 'BNAA09G35880D PROTEIN', 239260),
(302360, 'PTHR36354:SF2', NULL, NULL, NULL, NULL, 'IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT', 239260),
(302361, 'PTHR14987', NULL, NULL, NULL, NULL, 'PROTEIN LBH-RELATED', 239261),
(302362, 'PTHR14987:SF1', NULL, NULL, NULL, NULL, 'LBH DOMAIN-CONTAINING PROTEIN 1', 239261),
(302363, 'PTHR14987:SF2', NULL, NULL, NULL, NULL, 'PROTEIN LBH', 239261),
(302364, 'PTHR14987:SF3', NULL, NULL, NULL, NULL, 'LBH DOMAIN-CONTAINING PROTEIN 2', 239261),
(302365, 'PTHR14987:SF4', NULL, NULL, NULL, NULL, 'LBH DOMAIN-CONTAINING PROTEIN', 239261),
(302366, 'PTHR40400', NULL, NULL, NULL, NULL, 'SLR1512 PROTEIN', 239262),
(302367, 'PTHR40400:SF1', NULL, NULL, NULL, NULL, 'SLR1512 PROTEIN', 239262),
(302368, 'PTHR36787:SF2', NULL, NULL, NULL, NULL, 'BNAC07G42250D PROTEIN', 239263),
(302369, 'PTHR36787:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 239263),
(302370, 'PTHR36787', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 239263),
(302371, 'PTHR37196:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 239264),
(302372, 'PTHR37196', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 239264),
(302373, 'PTHR30441:SF4', NULL, NULL, NULL, NULL, 'PROTEIN ASMA', 239265),
(302374, 'PTHR30441:SF8', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE ASSEMBLY PROTEIN', 239265),
(302375, 'PTHR30441', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239265),
(302376, 'PTHR30441:SF9', NULL, NULL, NULL, NULL, 'ASMA FAMILY PROTEIN YHJG', 239265),
(302377, 'PTHR36971:SF1', NULL, NULL, NULL, NULL, 'C3H1-TYPE DOMAIN-CONTAINING PROTEIN', 239266),
(302378, 'PTHR36971', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', 239266),
(302379, 'PTHR36971:SF3', NULL, NULL, NULL, NULL, 'C3H1-TYPE DOMAIN-CONTAINING PROTEIN', 239266),
(302380, 'PTHR45917:SF9', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN 1A-RELATED', 239267),
(302381, 'PTHR45917:SF6', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN 4', 239267),
(302382, 'PTHR45917:SF7', NULL, NULL, NULL, NULL, 'CALCIUM BINDING PROTEIN 2', 239267),
(302383, 'PTHR45917:SF8', NULL, NULL, NULL, NULL, 'SI:CABZ01076231.1', 239267),
(302384, 'PTHR45917:SF1', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN 1', 239267),
(302385, 'PTHR45917', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN 1-RELATED', 239267),
(302386, 'PTHR45917:SF2', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN 2', 239267),
(302387, 'PTHR45917:SF3', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN 5', 239267),
(302388, 'PTHR45917:SF4', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN 4', 239267),
(302389, 'PTHR37715', NULL, NULL, NULL, NULL, 'OS01G0120700 PROTEIN', 239268),
(302390, 'PTHR37715:SF3', NULL, NULL, NULL, NULL, 'BNAA06G35160D PROTEIN', 239268),
(302391, 'PTHR37715:SF1', NULL, NULL, NULL, NULL, 'OS01G0120700 PROTEIN', 239268),
(302392, 'PTHR13510', NULL, NULL, NULL, NULL, 'FYVE-FINGER-CONTAINING RAB5 EFFECTOR PROTEIN RABENOSYN-5-RELATED', 239269),
(302393, 'PTHR13510:SF47', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G17070)-RELATED', 239269),
(302394, 'PTHR13510:SF48', NULL, NULL, NULL, NULL, '', 239269),
(302395, 'PTHR13510:SF44', NULL, NULL, NULL, NULL, 'RABENOSYN-5', 239269),
(302396, 'PTHR14202:SF0', NULL, NULL, NULL, NULL, '60 KDA SS-A/RO RIBONUCLEOPROTEIN', 239270);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(302397, 'PTHR14202', NULL, NULL, NULL, NULL, '60 KDA RIBONUCLEOPROTEIN SSA/RO', 239270),
(302398, 'PTHR31377:SF0', NULL, NULL, NULL, NULL, 'AGMATINE DEIMINASE-RELATED', 239271),
(302399, 'PTHR31377:SF5', NULL, NULL, NULL, NULL, 'BNAC09G47750D PROTEIN', 239271),
(302400, 'PTHR31377:SF4', NULL, NULL, NULL, NULL, '', 239271),
(302401, 'PTHR31377:SF2', NULL, NULL, NULL, NULL, 'AGMATINE DEIMINASE', 239271),
(302402, 'PTHR31377', NULL, NULL, NULL, NULL, 'AGMATINE DEIMINASE-RELATED', 239271),
(302403, 'PTHR22035:SF4', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 7', 239272),
(302404, 'PTHR22035', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 7', 239272),
(302405, 'PTHR34821:SF8', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 239273),
(302406, 'PTHR34821', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YDCZ', 239273),
(302407, 'PTHR34821:SF2', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YDCZ', 239273),
(302408, 'PTHR34821:SF3', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 239273),
(302409, 'PTHR30505:SF32', NULL, NULL, NULL, NULL, 'PTS SYSTEM FRUCTOSE-SPECIFIC EIIB''BC COMPONENT', 239274),
(302410, 'PTHR30505:SF34', NULL, NULL, NULL, NULL, 'FRUCTOSE-LIKE PERMEASE IIC COMPONENT 2', 239274),
(302411, 'PTHR30505:SF33', NULL, NULL, NULL, NULL, 'PTS SYSTEM MANNOSE-SPECIFIC EIIBCA COMPONENT', 239274),
(302412, 'PTHR30505', NULL, NULL, NULL, NULL, 'FRUCTOSE-LIKE PERMEASE', 239274),
(302413, 'PTHR30505:SF28', NULL, NULL, NULL, NULL, 'PTS SYSTEM 2-O-ALPHA-MANNOSYL-D-GLYCERATE-SPECIFIC EIIABC COMPONENT', 239274),
(302414, 'PTHR30505:SF0', NULL, NULL, NULL, NULL, 'FRUCTOSE-LIKE PTS SYSTEM EIIBC COMPONENT-RELATED', 239274),
(302415, 'PTHR34814:SF1', NULL, NULL, NULL, NULL, 'NITROSOGUANIDINE RESISTANCE PROTEIN SNG1', 239275),
(302416, 'PTHR34814', NULL, NULL, NULL, NULL, 'NITROSOGUANIDINE RESISTANCE PROTEIN SNG1', 239275),
(302417, 'PTHR34814:SF2', NULL, NULL, NULL, NULL, 'DUF3533 DOMAIN-CONTAINING PROTEIN', 239275),
(302418, 'PTHR21467', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 4 REGULATORY SUBUNIT 4 PPP4R4', 239276),
(302419, 'PTHR21467:SF0', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 4 REGULATORY SUBUNIT 4', 239276),
(302420, 'PTHR19430:SF0', NULL, NULL, NULL, NULL, 'PROTEIN BEX5', 239277),
(302421, 'PTHR19430:SF1', NULL, NULL, NULL, NULL, 'PROTEIN BEX3', 239277),
(302422, 'PTHR19430', NULL, NULL, NULL, NULL, 'PROTEIN BEX1-RELATED', 239277),
(302423, 'PTHR19430:SF2', NULL, NULL, NULL, NULL, 'PROTEIN BEX2', 239277),
(302424, 'PTHR19430:SF3', NULL, NULL, NULL, NULL, 'PROTEIN BEX1', 239277),
(302425, 'PTHR19430:SF4', NULL, NULL, NULL, NULL, 'PROTEIN BEX1', 239277),
(302426, 'PTHR19430:SF5', NULL, NULL, NULL, NULL, 'PROTEIN BEX1-LIKE', 239277),
(302427, 'PTHR28578:SF4', NULL, NULL, NULL, NULL, 'MITOTIC-SPINDLE ORGANIZING PROTEIN 2B', 239278),
(302428, 'PTHR28578:SF3', NULL, NULL, NULL, NULL, 'MITOTIC-SPINDLE ORGANIZING PROTEIN 2A', 239278),
(302429, 'PTHR28578', NULL, NULL, NULL, NULL, 'MITOTIC-SPINDLE ORGANIZING PROTEIN 2A-RELATED', 239278),
(302430, 'PTHR28578:SF2', NULL, NULL, NULL, NULL, 'MITOTIC-SPINDLE ORGANIZING PROTEIN 2', 239278),
(302431, 'PTHR12154:SF4', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE TRANSFERASE SUBUNIT ALG14 HOMOLOG', 239279),
(302432, 'PTHR12154', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE-RELATED', 239279),
(302433, 'PTHR46199:SF5', NULL, NULL, NULL, NULL, 'RAC GTPASE-ACTIVATING PROTEIN 1', 239280),
(302434, 'PTHR46199:SF4', NULL, NULL, NULL, NULL, 'RHO-GAP DOMAIN-CONTAINING PROTEIN', 239280),
(302435, 'PTHR46199', NULL, NULL, NULL, NULL, 'RAC GTPASE-ACTIVATING PROTEIN 1', 239280),
(302436, 'PTHR46199:SF3', NULL, NULL, NULL, NULL, 'FI24033P1-RELATED', 239280),
(302437, 'PTHR46199:SF2', NULL, NULL, NULL, NULL, 'SI:CH1073-416J23.1', 239280),
(302438, 'PTHR46199:SF1', NULL, NULL, NULL, NULL, 'RAC GTPASE-ACTIVATING PROTEIN 1', 239280),
(302439, 'PTHR31290', NULL, NULL, NULL, NULL, 'UV-DAMAGE ENDONUCLEASE', 239281),
(302440, 'PTHR31290:SF5', NULL, NULL, NULL, NULL, 'UV-DAMAGE ENDONUCLEASE', 239281),
(302441, 'PTHR22666', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239282);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(302442, 'PTHR22666:SF3', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DNA-BINDING DOMAIN-CONTAINING PROTEIN 1', 239282),
(302443, 'PTHR37203', NULL, NULL, NULL, NULL, '', 239283),
(302444, 'PTHR37203:SF3', NULL, NULL, NULL, NULL, 'SLR0975 PROTEIN', 239283),
(302445, 'PTHR45672:SF11', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE C17H9.14C', 239284),
(302446, 'PTHR45672:SF15', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 239284),
(302447, 'PTHR45672:SF14', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE', 239284),
(302448, 'PTHR45672:SF2', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE A5', 239284),
(302449, 'PTHR45672:SF3', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN 5', 239284),
(302450, 'PTHR45672', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE C17H9.14C-RELATED', 239284),
(302451, 'PTHR45672:SF16', NULL, NULL, NULL, NULL, 'DISULFIDE ISOMERASE, PUTATIVE-RELATED', 239284),
(302452, 'PTHR45672:SF9', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE', 239284),
(302453, 'PTHR38787:SF1', NULL, NULL, NULL, NULL, '', 239285),
(302454, 'PTHR38787:SF3', NULL, NULL, NULL, NULL, '', 239285),
(302455, 'PTHR38787', NULL, NULL, NULL, NULL, '', 239285),
(302456, 'PTHR43598:SF6', NULL, NULL, NULL, NULL, 'FORMATE DEHYDROGENASE-O MAJOR SUBUNIT', 239286),
(302457, 'PTHR43598:SF5', NULL, NULL, NULL, NULL, 'DMSO REDUCTASE CHAIN A', 239286),
(302458, 'PTHR43598:SF1', NULL, NULL, NULL, NULL, 'FORMATE DEHYDROGENASE, NITRATE-INDUCIBLE, MAJOR SUBUNIT', 239286),
(302459, 'PTHR43598', NULL, NULL, NULL, NULL, 'TUNGSTEN-CONTAINING FORMYLMETHANOFURAN DEHYDROGENASE 2 SUBUNIT B', 239286),
(302460, 'PTHR34684:SF2', NULL, NULL, NULL, NULL, '', 239287),
(302461, 'PTHR34684:SF3', NULL, NULL, NULL, NULL, 'BNAANNG09590D PROTEIN', 239287),
(302462, 'PTHR34684:SF4', NULL, NULL, NULL, NULL, 'BNAC03G35040D PROTEIN', 239287),
(302463, 'PTHR34684', NULL, NULL, NULL, NULL, 'OS08G0192200 PROTEIN', 239287),
(302464, 'PTHR34684:SF1', NULL, NULL, NULL, NULL, 'OS08G0192200 PROTEIN', 239287),
(302465, 'PTHR40562', NULL, NULL, NULL, NULL, '', 239288),
(302466, 'PTHR40562:SF1', NULL, NULL, NULL, NULL, 'NITRITE REDUCTASE (NADH) SMALL SUBUNIT', 239288),
(302467, 'PTHR33800:SF3', NULL, NULL, NULL, NULL, 'OS06G0114333-LIKE PROTEIN', 239289),
(302468, 'PTHR33800:SF5', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 239289),
(302469, 'PTHR33800:SF7', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 239289),
(302470, 'PTHR33800:SF8', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239289),
(302471, 'PTHR33800', NULL, NULL, NULL, NULL, 'OS06G0113600 PROTEIN', 239289),
(302472, 'PTHR33800:SF25', NULL, NULL, NULL, NULL, '', 239289),
(302473, 'PTHR33800:SF15', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 239289),
(302474, 'PTHR33800:SF26', NULL, NULL, NULL, NULL, '', 239289),
(302475, 'PTHR33800:SF24', NULL, NULL, NULL, NULL, '', 239289),
(302476, 'PTHR33800:SF13', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239289),
(302477, 'PTHR33800:SF10', NULL, NULL, NULL, NULL, '', 239289),
(302478, 'PTHR33800:SF21', NULL, NULL, NULL, NULL, '', 239289),
(302479, 'PTHR33800:SF11', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239289),
(302480, 'PTHR33800:SF1', NULL, NULL, NULL, NULL, 'OS02G0698100 PROTEIN', 239289),
(302481, 'PTHR33800:SF20', NULL, NULL, NULL, NULL, 'OS06G0114300 PROTEIN', 239289),
(302482, 'PTHR33800:SF18', NULL, NULL, NULL, NULL, '', 239289),
(302483, 'PTHR33800:SF19', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239289),
(302484, 'PTHR33800:SF16', NULL, NULL, NULL, NULL, '', 239289),
(302485, 'PTHR33800:SF27', NULL, NULL, NULL, NULL, 'OS06G0113600 PROTEIN', 239289),
(302486, 'PTHR33800:SF17', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 239289),
(302487, 'PTHR23049:SF7', NULL, NULL, NULL, NULL, 'MYOSIN REGULATORY LIGHT CHAIN 1-RELATED', 239290),
(302488, 'PTHR23049:SF8', NULL, NULL, NULL, NULL, 'MYOSIN LIGHT CHAIN 5', 239290),
(302489, 'PTHR23049:SF9', NULL, NULL, NULL, NULL, 'MYOSIN REGULATORY LIGHT CHAIN 2, VENTRICULAR/CARDIAC MUSCLE ISOFORM', 239290);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(302490, 'PTHR23049', NULL, NULL, NULL, NULL, 'MYOSIN REGULATORY LIGHT CHAIN 2', 239290),
(302491, 'PTHR23049:SF66', NULL, NULL, NULL, NULL, 'MYOSIN REGULATORY LIGHT POLYPEPTIDE 9', 239290),
(302492, 'PTHR23049:SF65', NULL, NULL, NULL, NULL, 'MYOSIN REGULATORY LIGHT CHAIN 2', 239290),
(302493, 'PTHR23049:SF10', NULL, NULL, NULL, NULL, 'MYOSIN REGULATORY LIGHT CHAIN 2, SKELETAL MUSCLE ISOFORM', 239290),
(302494, 'PTHR23049:SF61', NULL, NULL, NULL, NULL, '', 239290),
(302495, 'PTHR23049:SF60', NULL, NULL, NULL, NULL, 'CALMODULIN-LIKE PROTEIN', 239290),
(302496, 'PTHR23049:SF39', NULL, NULL, NULL, NULL, 'MYOSIN REGULATORY LIGHT CHAIN 2, ATRIAL ISOFORM', 239290),
(302497, 'PTHR23049:SF58', NULL, NULL, NULL, NULL, 'MYOSIN REGULATORY LIGHT CHAIN 12B', 239290),
(302498, 'PTHR23049:SF69', NULL, NULL, NULL, NULL, '', 239290),
(302499, 'PTHR23049:SF36', NULL, NULL, NULL, NULL, 'MYOSIN REGULATORY LIGHT CHAIN 10', 239290),
(302500, 'PTHR23049:SF68', NULL, NULL, NULL, NULL, 'MIP03207P', 239290),
(302501, 'PTHR23049:SF57', NULL, NULL, NULL, NULL, 'MYOSIN REGULATORY LIGHT CHAIN 12A', 239290),
(302502, 'PTHR23049:SF34', NULL, NULL, NULL, NULL, 'MYOSIN REGULATORY LIGHT CHAIN SQH', 239290),
(302503, 'PTHR23049:SF67', NULL, NULL, NULL, NULL, '', 239290),
(302504, 'PTHR34569:SF17', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE ARKADIA-A, PUTATIVE-RELATED', 239291),
(302505, 'PTHR34569', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239291),
(302506, 'PTHR34569:SF18', NULL, NULL, NULL, NULL, '', 239291),
(302507, 'PTHR34569:SF8', NULL, NULL, NULL, NULL, '', 239291),
(302508, 'PTHR34569:SF20', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239291),
(302509, 'PTHR34569:SF21', NULL, NULL, NULL, NULL, '', 239291),
(302510, 'PTHR34569:SF22', NULL, NULL, NULL, NULL, '', 239291),
(302511, 'PTHR34569:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239291),
(302512, 'PTHR34569:SF12', NULL, NULL, NULL, NULL, '', 239291),
(302513, 'PTHR28186', NULL, NULL, NULL, NULL, 'MEIOTICALLY UP-REGULATED GENE 9 PROTEIN', 239292),
(302514, 'PTHR28186:SF1', NULL, NULL, NULL, NULL, 'MEIOTICALLY UP-REGULATED GENE 9 PROTEIN', 239292),
(302515, 'PTHR32432:SF13', NULL, NULL, NULL, NULL, 'ETHANOLAMINE AMMONIA-LYASE REACTIVASE EUTA', 239293),
(302516, 'PTHR32432:SF4', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN FTSA', 239293),
(302517, 'PTHR32432:SF3', NULL, NULL, NULL, NULL, 'ETHANOLAMINE UTILIZATION PROTEIN EUTJ', 239293),
(302518, 'PTHR32432', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN FTSA-RELATED', 239293),
(302519, 'PTHR44490:SF1', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION ELONGATION FACTOR 1 EPSILON-1', 239294),
(302520, 'PTHR44490', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION ELONGATION FACTOR 1 EPSILON-1', 239294),
(302521, 'PTHR12000:SF19', NULL, NULL, NULL, NULL, 'VACUOLAR-PROCESSING ENZYME GAMMA-ISOZYME', 239295),
(302522, 'PTHR12000:SF27', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 239295),
(302523, 'PTHR12000:SF49', NULL, NULL, NULL, NULL, 'BNAC04G29170D PROTEIN', 239295),
(302524, 'PTHR12000:SF38', NULL, NULL, NULL, NULL, 'LEGUMAIN', 239295),
(302525, 'PTHR12000:SF48', NULL, NULL, NULL, NULL, 'VACUOLAR-PROCESSING ENZYME-RELATED', 239295),
(302526, 'PTHR12000:SF29', NULL, NULL, NULL, NULL, 'VACUOLAR-PROCESSING ENZYME DELTA-ISOZYME', 239295),
(302527, 'PTHR12000:SF28', NULL, NULL, NULL, NULL, 'VACUOLAR-PROCESSING ENZYME-LIKE', 239295),
(302528, 'PTHR12000:SF50', NULL, NULL, NULL, NULL, 'VACUOLAR-PROCESSING ENZYME GAMMA-ISOZYME', 239295),
(302529, 'PTHR12000:SF23', NULL, NULL, NULL, NULL, 'ASPARAGINYL ENDOPEPTIDASE', 239295),
(302530, 'PTHR12000:SF34', NULL, NULL, NULL, NULL, 'PREPROLEGUMAIN-RELATED', 239295),
(302531, 'PTHR12000:SF33', NULL, NULL, NULL, NULL, 'VACUOLAR-PROCESSING ENZYME ALPHA-ISOZYME', 239295),
(302532, 'PTHR12000:SF44', NULL, NULL, NULL, NULL, 'PEPTIDASE C13, LEGUMAIN-RELATED', 239295),
(302533, 'PTHR12000:SF36', NULL, NULL, NULL, NULL, '', 239295),
(302534, 'PTHR12000:SF25', NULL, NULL, NULL, NULL, 'VACUOLAR-PROCESSING ENZYME BETA-ISOZYME 1', 239295),
(302535, 'PTHR12000:SF47', NULL, NULL, NULL, NULL, 'VACUOLAR-PROCESSING ENZYME-RELATED', 239295);
INSERT INTO "PUBLIC"."MODEL" VALUES
(302536, 'PTHR12000:SF52', NULL, NULL, NULL, NULL, 'LEGUMAIN PROTEIN-RELATED', 239295),
(302537, 'PTHR12000', NULL, NULL, NULL, NULL, 'HEMOGLOBINASE FAMILY MEMBER', 239295),
(302538, 'PTHR12000:SF30', NULL, NULL, NULL, NULL, 'VACUOLAR-PROCESSING ENZYME-LIKE', 239295),
(302539, 'PTHR12000:SF40', NULL, NULL, NULL, NULL, 'LEGUMAIN', 239295),
(302540, 'PTHR12000:SF51', NULL, NULL, NULL, NULL, 'VACUOLAR-PROCESSING ENZYME-RELATED', 239295),
(302541, 'PTHR12000:SF21', NULL, NULL, NULL, NULL, '', 239295),
(302542, 'PTHR12000:SF42', NULL, NULL, NULL, NULL, 'LEGUMAIN', 239295),
(302543, 'PTHR12000:SF31', NULL, NULL, NULL, NULL, 'VACUOLAR-PROCESSING ENZYME-LIKE', 239295),
(302544, 'PTHR15297', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN SUPERFAMILY MEMBER 6', 239296),
(302545, 'PTHR15297:SF2', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN SUPERFAMILY MEMBER 6', 239296),
(302546, 'PTHR33219:SF10', NULL, NULL, NULL, NULL, 'YLMG HOMOLOG PROTEIN 1-2, CHLOROPLASTIC', 239297),
(302547, 'PTHR33219:SF12', NULL, NULL, NULL, NULL, 'YLMG HOMOLOG PROTEIN 1-1, CHLOROPLASTIC', 239297),
(302548, 'PTHR33219:SF14', NULL, NULL, NULL, NULL, 'PROTEIN COFACTOR ASSEMBLY OF COMPLEX C SUBUNIT B CCB3, CHLOROPLASTIC-RELATED', 239297),
(302549, 'PTHR33219', NULL, NULL, NULL, NULL, 'YLMG HOMOLOG PROTEIN 2, CHLOROPLASTIC', 239297),
(302550, 'PTHR47908', NULL, NULL, NULL, NULL, '', 239298),
(302551, 'PTHR47908:SF2', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 239298),
(302552, 'PTHR43858', NULL, NULL, NULL, NULL, 'ENERGY-DEPENDENT TRANSLATIONAL THROTTLE PROTEIN ETTA', 239299),
(302553, 'PTHR43858:SF1', NULL, NULL, NULL, NULL, 'NON-TRANSPORTER ABC PROTEIN', 239299),
(302554, 'PTHR14684:SF2', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN 15', 239300),
(302555, 'PTHR14684', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239300),
(302556, 'PTHR34174', NULL, NULL, NULL, NULL, 'HYDROLETHALUS SYNDROME PROTEIN 1', 239301),
(302557, 'PTHR34174:SF1', NULL, NULL, NULL, NULL, 'HYDROLETHALUS SYNDROME PROTEIN 1', 239301),
(302558, 'PTHR31748:SF1', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS V', 239302),
(302559, 'PTHR31748:SF0', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN-RELATED', 239302),
(302560, 'PTHR31748:SF5', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS V', 239302),
(302561, 'PTHR31748:SF4', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS V', 239302),
(302562, 'PTHR31748:SF11', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 239302),
(302563, 'PTHR31748', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS V', 239302),
(302564, 'PTHR31748:SF2', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 239302),
(302565, 'PTHR31748:SF9', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS V', 239302),
(302566, 'PTHR31748:SF6', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS V', 239302),
(302567, 'PTHR47099', NULL, NULL, NULL, NULL, 'METHYLCOBAMIDE:COM METHYLTRANSFERASE MTBA', 239303),
(302568, 'PTHR47099:SF1', NULL, NULL, NULL, NULL, 'METHYLCOBAMIDE:COM METHYLTRANSFERASE MTBA', 239303),
(302569, 'PTHR10962:SF4', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN 2B', 239304),
(302570, 'PTHR10962', NULL, NULL, NULL, NULL, 'INTEGRAL TRANSMEMBRANE PROTEIN 2', 239304),
(302571, 'PTHR10962:SF1', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN 2', 239304),
(302572, 'PTHR10962:SF7', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN 2A', 239304),
(302573, 'PTHR10962:SF5', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN 2C', 239304),
(302574, 'PTHR36142', NULL, NULL, NULL, NULL, 'METALLO-HYDROLASE/OXIDOREDUCTASE SUPERFAMILY PROTEIN', 239305),
(302575, 'PTHR36142:SF5', NULL, NULL, NULL, NULL, '', 239305),
(302576, 'PTHR36142:SF3', NULL, NULL, NULL, NULL, '', 239305),
(302577, 'PTHR36142:SF2', NULL, NULL, NULL, NULL, 'METALLO-HYDROLASE/OXIDOREDUCTASE SUPERFAMILY PROTEIN', 239305),
(302578, 'PTHR22747', NULL, NULL, NULL, NULL, 'NUCLEOPLASMIN', 239306),
(302579, 'PTHR22747:SF31', NULL, NULL, NULL, NULL, 'NUCLEOPHOSMIN', 239306);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(302580, 'PTHR22747:SF40', NULL, NULL, NULL, NULL, 'NUCLEOPHOSMIN', 239306),
(302581, 'PTHR22747:SF13', NULL, NULL, NULL, NULL, 'NUCLEOPLASMIN-3', 239306),
(302582, 'PTHR22747:SF32', NULL, NULL, NULL, NULL, 'NUCLEOPHOSMIN', 239306),
(302583, 'PTHR22747:SF33', NULL, NULL, NULL, NULL, 'NUCLEOPHOSMIN', 239306),
(302584, 'PTHR22747:SF38', NULL, NULL, NULL, NULL, 'NUCLEOPHOSMIN', 239306),
(302585, 'PTHR22747:SF28', NULL, NULL, NULL, NULL, 'NUCLEOPHOSMIN', 239306),
(302586, 'PTHR22747:SF39', NULL, NULL, NULL, NULL, 'NUCLEOPLASMIN DOMAIN-CONTAINING PROTEIN', 239306),
(302587, 'PTHR22747:SF36', NULL, NULL, NULL, NULL, 'NUCLEOPHOSMIN', 239306),
(302588, 'PTHR22747:SF14', NULL, NULL, NULL, NULL, 'NUCLEOPLASMIN-2', 239306),
(302589, 'PTHR22747:SF37', NULL, NULL, NULL, NULL, 'NUCLEOPHOSMIN', 239306),
(302590, 'PTHR22747:SF18', NULL, NULL, NULL, NULL, 'GEO09167P1-RELATED', 239306),
(302591, 'PTHR31393', NULL, NULL, NULL, NULL, 'C5ORF31', 239307),
(302592, 'PTHR31393:SF2', NULL, NULL, NULL, NULL, 'CHROMOSOME 7 OPEN READING FRAME 31', 239307),
(302593, 'PTHR31393:SF3', NULL, NULL, NULL, NULL, '', 239307),
(302594, 'PTHR44947', NULL, NULL, NULL, NULL, 'OS05G0501001 PROTEIN', 239308),
(302595, 'PTHR44947:SF1', NULL, NULL, NULL, NULL, 'OS05G0501001 PROTEIN', 239308),
(302596, 'PTHR31952:SF3', NULL, NULL, NULL, NULL, 'CB1 CANNABINOID RECEPTOR-INTERACTING PROTEIN 1', 239309),
(302597, 'PTHR31952', NULL, NULL, NULL, NULL, 'CB1 CANNABINOID RECEPTOR-INTERACTING PROTEIN 1', 239309),
(302598, 'PTHR31952:SF1', NULL, NULL, NULL, NULL, 'CB1 CANNABINOID RECEPTOR-INTERACTING PROTEIN 1', 239309),
(302599, 'PTHR31952:SF2', NULL, NULL, NULL, NULL, 'CB1 CANNABINOID RECEPTOR-INTERACTING PROTEIN 1', 239309),
(302600, 'PTHR43868', NULL, NULL, NULL, NULL, 'OS02G0711200 PROTEIN', 239310),
(302601, 'PTHR43868:SF1', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN', 239310),
(302602, 'PTHR47914', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 239311),
(302603, 'PTHR47914:SF1', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 239311),
(302604, 'PTHR36869', NULL, NULL, NULL, NULL, 'CHROMOSOME 16 OPEN READING FRAME 46', 239312),
(302605, 'PTHR36869:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 16 OPEN READING FRAME 46', 239312),
(302606, 'PTHR10676:SF257', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL HEAVY CHAIN 9', 239313),
(302607, 'PTHR10676:SF356', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL HEAVY CHAIN 14', 239313),
(302608, 'PTHR10676:SF399', NULL, NULL, NULL, NULL, '', 239313),
(302609, 'PTHR10676:SF398', NULL, NULL, NULL, NULL, '', 239313),
(302610, 'PTHR10676:SF255', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL HEAVY CHAIN 12', 239313),
(302611, 'PTHR10676:SF310', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL HEAVY CHAIN 7', 239313),
(302612, 'PTHR10676:SF397', NULL, NULL, NULL, NULL, '', 239313),
(302613, 'PTHR10676:SF352', NULL, NULL, NULL, NULL, 'CYTOPLASMIC DYNEIN 2 HEAVY CHAIN 1', 239313),
(302614, 'PTHR10676:SF396', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL HEAVY CHAIN 1', 239313),
(302615, 'PTHR10676:SF374', NULL, NULL, NULL, NULL, 'DYNEIN HEAVY CHAIN AT 93AB, ISOFORM C', 239313),
(302616, 'PTHR10676:SF395', NULL, NULL, NULL, NULL, '', 239313),
(302617, 'PTHR10676:SF394', NULL, NULL, NULL, NULL, '', 239313),
(302618, 'PTHR10676:SF392', NULL, NULL, NULL, NULL, 'HEAVY CHAIN, PUTATIVE-RELATED', 239313),
(302619, 'PTHR10676:SF339', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL HEAVY CHAIN 6', 239313),
(302620, 'PTHR10676:SF359', NULL, NULL, NULL, NULL, 'DYNEIN HEAVY CHAIN DOMAIN-CONTAINING PROTEIN 1', 239313),
(302621, 'PTHR10676:SF314', NULL, NULL, NULL, NULL, 'CYTOPLASMIC DYNEIN 1 HEAVY CHAIN 1', 239313),
(302622, 'PTHR10676:SF400', NULL, NULL, NULL, NULL, 'HEAVY CHAIN, PUTATIVE-RELATED', 239313),
(302623, 'PTHR10676:SF344', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL HEAVY CHAIN 5', 239313),
(302624, 'PTHR10676:SF343', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL HEAVY CHAIN 10', 239313),
(302625, 'PTHR10676:SF365', NULL, NULL, NULL, NULL, 'DYNEIN, AXONEMAL, HEAVY CHAIN 5-LIKE', 239313);
INSERT INTO "PUBLIC"."MODEL" VALUES
(302626, 'PTHR10676:SF287', NULL, NULL, NULL, NULL, 'HEAVY CHAIN, PUTATIVE-RELATED', 239313),
(302627, 'PTHR10676:SF242', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL HEAVY CHAIN 3', 239313),
(302628, 'PTHR10676:SF263', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL HEAVY CHAIN 11', 239313),
(302629, 'PTHR10676:SF284', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL HEAVY CHAIN 17', 239313),
(302630, 'PTHR10676:SF361', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL HEAVY CHAIN 8', 239313),
(302631, 'PTHR10676:SF360', NULL, NULL, NULL, NULL, 'HEAVY CHAIN, PUTATIVE-RELATED', 239313),
(302632, 'PTHR10676:SF183', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL HEAVY CHAIN 2', 239313),
(302633, 'PTHR10676', NULL, NULL, NULL, NULL, 'DYNEIN HEAVY CHAIN FAMILY PROTEIN', 239313),
(302634, 'PTHR10676:SF36', NULL, NULL, NULL, NULL, 'DYNEIN HEAVY CHAIN FAMILY PROTEIN', 239313),
(302635, 'PTHR10676:SF346', NULL, NULL, NULL, NULL, 'HEAVY CHAIN, PUTATIVE-RELATED', 239313),
(302636, 'PTHR42881:SF9', NULL, NULL, NULL, NULL, 'PROLYL ENDOPEPTIDASE', 239314),
(302637, 'PTHR42881', NULL, NULL, NULL, NULL, 'PROLYL ENDOPEPTIDASE', 239314),
(302638, 'PTHR42881:SF11', NULL, NULL, NULL, NULL, 'PROLYL ENDOPEPTIDASE', 239314),
(302639, 'PTHR42881:SF1', NULL, NULL, NULL, NULL, 'PROLYL ENDOPEPTIDASE', 239314),
(302640, 'PTHR42881:SF14', NULL, NULL, NULL, NULL, 'PROLYL ENDOPEPTIDASE', 239314),
(302641, 'PTHR42881:SF2', NULL, NULL, NULL, NULL, 'PROLYL ENDOPEPTIDASE', 239314),
(302642, 'PTHR42881:SF13', NULL, NULL, NULL, NULL, 'PROLYL ENDOPEPTIDASE', 239314),
(302643, 'PTHR42881:SF3', NULL, NULL, NULL, NULL, 'PROLYL ENDOPEPTIDASE', 239314),
(302644, 'PTHR42881:SF4', NULL, NULL, NULL, NULL, 'PROLYL ENDOPEPTIDASE', 239314),
(302645, 'PTHR42881:SF5', NULL, NULL, NULL, NULL, 'PROLYL ENDOPEPTIDASE', 239314),
(302646, 'PTHR42881:SF6', NULL, NULL, NULL, NULL, 'PROLYL ENDOPEPTIDASE', 239314),
(302647, 'PTHR42881:SF7', NULL, NULL, NULL, NULL, 'PROLYL ENDOPEPTIDASE', 239314),
(302648, 'PTHR43242:SF1', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 239315),
(302649, 'PTHR43242', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 239315),
(302650, 'PTHR43259', NULL, NULL, NULL, NULL, 'SPT10P', 239316),
(302651, 'PTHR43259:SF1', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 239316),
(302652, 'PTHR47288:SF3', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 8', 239317),
(302653, 'PTHR47288:SF2', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 12', 239317),
(302654, 'PTHR47288:SF1', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 9', 239317),
(302655, 'PTHR47288', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 9', 239317),
(302656, 'PTHR17149:SF5', NULL, NULL, NULL, NULL, 'NUCLEAR PROTEIN 1', 239318),
(302657, 'PTHR17149:SF6', NULL, NULL, NULL, NULL, 'NUCLEAR PROTEIN 1B', 239318),
(302658, 'PTHR17149:SF3', NULL, NULL, NULL, NULL, 'NUCLEAR PROTEIN 2', 239318),
(302659, 'PTHR17149:SF4', NULL, NULL, NULL, NULL, 'RH17958P', 239318),
(302660, 'PTHR17149', NULL, NULL, NULL, NULL, 'NUCLEAR PROTEIN 1 AND 2', 239318),
(302661, 'PTHR34206', NULL, NULL, NULL, NULL, 'OS06G0193300 PROTEIN', 239319),
(302662, 'PTHR34206:SF10', NULL, NULL, NULL, NULL, '', 239319),
(302663, 'PTHR34206:SF11', NULL, NULL, NULL, NULL, 'OS06G0193300 PROTEIN', 239319),
(302664, 'PTHR34206:SF1', NULL, NULL, NULL, NULL, 'OS10G0390701 PROTEIN', 239319),
(302665, 'PTHR34206:SF5', NULL, NULL, NULL, NULL, '', 239319),
(302666, 'PTHR34206:SF6', NULL, NULL, NULL, NULL, '', 239319),
(302667, 'PTHR34206:SF9', NULL, NULL, NULL, NULL, '', 239319),
(302668, 'PTHR23356:SF19', NULL, NULL, NULL, NULL, '', 239320),
(302669, 'PTHR23356', NULL, NULL, NULL, NULL, 'DPY30-RELATED', 239320),
(302670, 'PTHR23356:SF3', NULL, NULL, NULL, NULL, 'DPY30 DOMAIN-CONTAINING PROTEIN 2', 239320),
(302671, 'PTHR23356:SF4', NULL, NULL, NULL, NULL, 'DPY30 DOMAIN-CONTAINING PROTEIN 1', 239320),
(302672, 'PTHR23356:SF16', NULL, NULL, NULL, NULL, 'DPY30 DOMAIN-CONTAINING 2', 239320),
(302673, 'PTHR21639', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239321);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(302674, 'PTHR21639:SF5', NULL, NULL, NULL, NULL, 'DBF4-TYPE ZINC FINGER-CONTAINING PROTEIN 2', 239321),
(302675, 'PTHR35420:SF6', NULL, NULL, NULL, NULL, 'HYPOTHETICAL REPEAT PROTEIN', 239322),
(302676, 'PTHR35420:SF4', NULL, NULL, NULL, NULL, '', 239322),
(302677, 'PTHR35420:SF8', NULL, NULL, NULL, NULL, 'OS04G0654400 PROTEIN', 239322),
(302678, 'PTHR35420:SF7', NULL, NULL, NULL, NULL, 'BNAA05G14350D PROTEIN', 239322),
(302679, 'PTHR35420', NULL, NULL, NULL, NULL, 'OS02G0198500 PROTEIN', 239322),
(302680, 'PTHR35420:SF2', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 239322),
(302681, 'PTHR35420:SF1', NULL, NULL, NULL, NULL, 'OS09G0480532 PROTEIN', 239322),
(302682, 'PTHR43639:SF6', NULL, NULL, NULL, NULL, 'DIHYDROMONAPTERIN REDUCTASE', 239323),
(302683, 'PTHR43639:SF9', NULL, NULL, NULL, NULL, 'BLL5898 PROTEIN', 239323),
(302684, 'PTHR43639', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE, SHORT-CHAIN DEHYDROGENASE/REDUCTASE FAMILY (AFU_ORTHOLOGUE AFUA_5G02870)', 239323),
(302685, 'PTHR43639:SF5', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE, SHORT-CHAIN DEHYDROGENASE/REDUCTASE FAMILY (AFU_ORTHOLOGUE AFUA_6G09140)', 239323),
(302686, 'PTHR43639:SF1', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE, SHORT-CHAIN DEHYDROGENASE/REDUCTASE FAMILY (AFU_ORTHOLOGUE AFUA_5G02870)', 239323),
(302687, 'PTHR22989:SF9', NULL, NULL, NULL, NULL, 'METHYLTRANSF_21 DOMAIN-CONTAINING PROTEIN', 239324),
(302688, 'PTHR22989', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED DUF13  C.ELEGANS', 239324),
(302689, 'PTHR22989:SF7', NULL, NULL, NULL, NULL, 'METHYLTRANSF_21 DOMAIN-CONTAINING PROTEIN', 239324),
(302690, 'PTHR22989:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG09619', 239324),
(302691, 'PTHR22989:SF20', NULL, NULL, NULL, NULL, 'PROTEIN CBG01276', 239324),
(302692, 'PTHR22989:SF5', NULL, NULL, NULL, NULL, 'METHYLTRANSF_21 DOMAIN-CONTAINING PROTEIN', 239324),
(302693, 'PTHR22989:SF6', NULL, NULL, NULL, NULL, 'METHYLTRANSF_21 DOMAIN-CONTAINING PROTEIN', 239324),
(302694, 'PTHR22989:SF3', NULL, NULL, NULL, NULL, 'METHYLTRANSF_21 DOMAIN-CONTAINING PROTEIN', 239324),
(302695, 'PTHR22989:SF4', NULL, NULL, NULL, NULL, 'METHYLTRANSF_21 DOMAIN-CONTAINING PROTEIN', 239324),
(302696, 'PTHR22989:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG01918', 239324),
(302697, 'PTHR22989:SF16', NULL, NULL, NULL, NULL, 'PROTEIN CBG13050', 239324),
(302698, 'PTHR22989:SF17', NULL, NULL, NULL, NULL, 'METHYLTRANSF_21 DOMAIN-CONTAINING PROTEIN', 239324),
(302699, 'PTHR22989:SF15', NULL, NULL, NULL, NULL, 'METHYLTRANSF_21 DOMAIN-CONTAINING PROTEIN', 239324),
(302700, 'PTHR22989:SF12', NULL, NULL, NULL, NULL, 'METHYLTRANSF_21 DOMAIN-CONTAINING PROTEIN', 239324),
(302701, 'PTHR22989:SF13', NULL, NULL, NULL, NULL, 'METHYLTRANSF_21 DOMAIN-CONTAINING PROTEIN', 239324),
(302702, 'PTHR22989:SF10', NULL, NULL, NULL, NULL, 'METHYLTRANSF_21 DOMAIN-CONTAINING PROTEIN', 239324),
(302703, 'PTHR22989:SF21', NULL, NULL, NULL, NULL, 'METHYLTRANSF_21 DOMAIN-CONTAINING PROTEIN', 239324),
(302704, 'PTHR22989:SF11', NULL, NULL, NULL, NULL, 'PROTEIN CBG04469', 239324),
(302705, 'PTHR22989:SF19', NULL, NULL, NULL, NULL, 'METHYLTRANSF_21 DOMAIN-CONTAINING PROTEIN', 239324),
(302706, 'PTHR15066:SF0', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 187', 239325),
(302707, 'PTHR15066', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 187', 239325),
(302708, 'PTHR38082:SF2', NULL, NULL, NULL, NULL, 'ENDOTOXIN_N DOMAIN-CONTAINING PROTEIN', 239326),
(302709, 'PTHR38082', NULL, NULL, NULL, NULL, 'ENDOTOXIN_N DOMAIN-CONTAINING PROTEIN', 239326),
(302710, 'PTHR12040', NULL, NULL, NULL, NULL, 'ANTI-SILENCING PROTEIN 1', 239327),
(302711, 'PTHR12040:SF8', NULL, NULL, NULL, NULL, 'HISTONE CHAPERONE ASF1A', 239327),
(302712, 'PTHR12040:SF28', NULL, NULL, NULL, NULL, 'ANTI-SILENCING PROTEIN A-LIKE PROTEIN', 239327),
(302713, 'PTHR12040:SF18', NULL, NULL, NULL, NULL, 'HISTONE CHAPERONE ASF1B-RELATED', 239327),
(302714, 'PTHR12040:SF29', NULL, NULL, NULL, NULL, 'SILENCING GROUP A PROTEIN', 239327),
(302715, 'PTHR12040:SF26', NULL, NULL, NULL, NULL, 'BNAC06G27710D PROTEIN', 239327),
(302716, 'PTHR12040:SF27', NULL, NULL, NULL, NULL, 'HISTONE CHAPERONE ASF1A-RELATED', 239327);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(302717, 'PTHR12040:SF24', NULL, NULL, NULL, NULL, '', 239327),
(302718, 'PTHR12040:SF22', NULL, NULL, NULL, NULL, 'HISTONE CHAPERONE ASF1B', 239327),
(302719, 'PTHR12040:SF0', NULL, NULL, NULL, NULL, 'HISTONE CHAPERONE ASF1', 239327),
(302720, 'PTHR38462', NULL, NULL, NULL, NULL, 'EXONUCLEASE-LIKE PROTEIN', 239328),
(302721, 'PTHR38462:SF1', NULL, NULL, NULL, NULL, 'RNASE_H_2 DOMAIN-CONTAINING PROTEIN', 239328),
(302722, 'PTHR10909', NULL, NULL, NULL, NULL, 'ELECTRON TRANSPORT OXIDOREDUCTASE', 239329),
(302723, 'PTHR10909:SF384', NULL, NULL, NULL, NULL, 'PEROXISOMAL ACYL-COENZYME A OXIDASE 1-LIKE', 239329),
(302724, 'PTHR10909:SF351', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A OXIDASE', 239329),
(302725, 'PTHR10909:SF250', NULL, NULL, NULL, NULL, 'PEROXISOMAL ACYL-COENZYME A OXIDASE 1', 239329),
(302726, 'PTHR10909:SF382', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A OXIDASE', 239329),
(302727, 'PTHR10909:SF380', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A OXIDASE', 239329),
(302728, 'PTHR10909:SF390', NULL, NULL, NULL, NULL, 'PEROXISOMAL ACYL-COENZYME A OXIDASE 3', 239329),
(302729, 'PTHR10909:SF304', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A OXIDASE ACOX-1.5-RELATED', 239329),
(302730, 'PTHR10909:SF348', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A OXIDASE', 239329),
(302731, 'PTHR10909:SF226', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A OXIDASE', 239329),
(302732, 'PTHR10909:SF379', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A OXIDASE 3.2, PEROXISOMAL-RELATED', 239329),
(302733, 'PTHR10909:SF368', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A OXIDASE ACOX-1.1', 239329),
(302734, 'PTHR10909:SF389', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A OXIDASE', 239329),
(302735, 'PTHR10909:SF378', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A OXIDASE', 239329),
(302736, 'PTHR10909:SF223', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A OXIDASE', 239329),
(302737, 'PTHR10909:SF377', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A OXIDASE', 239329),
(302738, 'PTHR10909:SF267', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A OXIDASE', 239329),
(302739, 'PTHR10909:SF344', NULL, NULL, NULL, NULL, 'PEROXISOMAL ACYL-COENZYME A OXIDASE 2', 239329),
(302740, 'PTHR10909:SF376', NULL, NULL, NULL, NULL, 'PEROXISOMAL ACYL-COENZYME A OXIDASE 1.2-RELATED', 239329),
(302741, 'PTHR10909:SF386', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A OXIDASE', 239329),
(302742, 'PTHR10909:SF374', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A OXIDASE', 239329),
(302743, 'PTHR10909:SF352', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A OXIDASE-LIKE PROTEIN', 239329),
(302744, 'PTHR10407:SF15', NULL, NULL, NULL, NULL, 'HUNTINGTIN INTERACTING PROTEIN 1', 239330),
(302745, 'PTHR10407:SF14', NULL, NULL, NULL, NULL, 'HUNTINGTIN-INTERACTING PROTEIN 1', 239330),
(302746, 'PTHR10407', NULL, NULL, NULL, NULL, 'HUNTINGTIN INTERACTING PROTEIN 1', 239330),
(302747, 'PTHR10407:SF10', NULL, NULL, NULL, NULL, 'HUNTINGTIN-INTERACTING PROTEIN 1-RELATED PROTEIN', 239330),
(302748, 'PTHR14363', NULL, NULL, NULL, NULL, 'HEPARANASE-RELATED', 239331),
(302749, 'PTHR14363:SF21', NULL, NULL, NULL, NULL, 'HEPARANASE-LIKE PROTEIN 1', 239331),
(302750, 'PTHR14363:SF43', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE, FAMILY 79-RELATED', 239331),
(302751, 'PTHR14363:SF32', NULL, NULL, NULL, NULL, 'HEPARANASE-LIKE PROTEIN 2 ISOFORM X1', 239331),
(302752, 'PTHR14363:SF31', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE FAMILY 79 AMINO-TERMINAL DOMAIN PROTEIN', 239331),
(302753, 'PTHR14363:SF42', NULL, NULL, NULL, NULL, 'HEPARANASE-LIKE PROTEIN 3', 239331),
(302754, 'PTHR14363:SF30', NULL, NULL, NULL, NULL, 'PROTEIN 2, PUTATIVE, EXPRESSED-RELATED', 239331),
(302755, 'PTHR14363:SF41', NULL, NULL, NULL, NULL, 'HEPARANASE-LIKE PROTEIN 3', 239331),
(302756, 'PTHR14363:SF17', NULL, NULL, NULL, NULL, 'OS02G0802200 PROTEIN', 239331),
(302757, 'PTHR14363:SF39', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE, FAMILY 79-RELATED', 239331),
(302758, 'PTHR14363:SF36', NULL, NULL, NULL, NULL, 'OS06G0179000 PROTEIN', 239331),
(302759, 'PTHR14363:SF13', NULL, NULL, NULL, NULL, 'OS07G0598400 PROTEIN', 239331),
(302760, 'PTHR14363:SF35', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE FAMILY 79 AMINO-TERMINAL DOMAIN PROTEIN', 239331);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(302761, 'PTHR14363:SF38', NULL, NULL, NULL, NULL, 'GLUCURONIDASE 2-RELATED', 239331),
(302762, 'PTHR14363:SF37', NULL, NULL, NULL, NULL, 'HEPARANASE-LIKE PROTEIN 2', 239331),
(302763, 'PTHR31571:SF1', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN 6', 239332),
(302764, 'PTHR31571:SF5', NULL, NULL, NULL, NULL, '', 239332),
(302765, 'PTHR31571', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN 6', 239332),
(302766, 'PTHR31571:SF2', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE RTT109', 239332),
(302767, 'PTHR13148:SF0', NULL, NULL, NULL, NULL, 'POST-GPI ATTACHMENT TO PROTEINS FACTOR 3', 239333),
(302768, 'PTHR13148:SF13', NULL, NULL, NULL, NULL, 'POST-GPI ATTACHMENT TO PROTEINS FACTOR 3', 239333),
(302769, 'PTHR13148:SF1', NULL, NULL, NULL, NULL, 'POST-GPI ATTACHMENT TO PROTEINS FACTOR 3', 239333),
(302770, 'PTHR13148:SF17', NULL, NULL, NULL, NULL, 'POST-GPI ATTACHMENT TO PROTEINS FACTOR 3', 239333),
(302771, 'PTHR13148:SF18', NULL, NULL, NULL, NULL, 'POST-GPI ATTACHMENT TO PROTEINS FACTOR 3', 239333),
(302772, 'PTHR13148:SF7', NULL, NULL, NULL, NULL, 'POST-GPI ATTACHMENT TO PROTEINS FACTOR 3', 239333),
(302773, 'PTHR13148:SF16', NULL, NULL, NULL, NULL, 'POST-GPI ATTACHMENT TO PROTEINS FACTOR 3', 239333),
(302774, 'PTHR13148', NULL, NULL, NULL, NULL, 'PER1-RELATED', 239333),
(302775, 'PTHR13148:SF9', NULL, NULL, NULL, NULL, 'POST-GPI ATTACHMENT TO PROTEINS FACTOR 3', 239333),
(302776, 'PTHR13148:SF19', NULL, NULL, NULL, NULL, 'POST-GPI ATTACHMENT TO PROTEINS FACTOR 3', 239333),
(302777, 'PTHR21477', NULL, NULL, NULL, NULL, 'ZGC:172139', 239334),
(302778, 'PTHR21477:SF39', NULL, NULL, NULL, NULL, 'BNACNNG24930D PROTEIN', 239334),
(302779, 'PTHR21477:SF13', NULL, NULL, NULL, NULL, 'ZGC:172139', 239334),
(302780, 'PTHR21477:SF35', NULL, NULL, NULL, NULL, 'BNAC07G31540D PROTEIN', 239334),
(302781, 'PTHR21477:SF24', NULL, NULL, NULL, NULL, 'OS07G0124000 PROTEIN', 239334),
(302782, 'PTHR21477:SF25', NULL, NULL, NULL, NULL, 'PROTEIN PHLOEM PROTEIN 2-LIKE A10', 239334),
(302783, 'PTHR21477:SF27', NULL, NULL, NULL, NULL, 'CF9 PROTEIN', 239334),
(302784, 'PTHR21477:SF38', NULL, NULL, NULL, NULL, 'PROTEIN PHLOEM PROTEIN 2-LIKE A10-LIKE', 239334),
(302785, 'PTHR21477:SF31', NULL, NULL, NULL, NULL, 'PROTEIN PHLOEM PROTEIN 2-LIKE A10-LIKE', 239334),
(302786, 'PTHR21477:SF33', NULL, NULL, NULL, NULL, 'BNAANNG04040D PROTEIN', 239334),
(302787, 'PTHR21477:SF12', NULL, NULL, NULL, NULL, 'PROTEIN PHLOEM PROTEIN 2-LIKE A10', 239334),
(302788, 'PTHR21477:SF40', NULL, NULL, NULL, NULL, 'PHLOEM A10-LIKE PROTEIN', 239334),
(302789, 'PTHR21477:SF30', NULL, NULL, NULL, NULL, 'BNAC08G42360D PROTEIN', 239334),
(302790, 'PTHR45777:SF2', NULL, NULL, NULL, NULL, 'METHIONINE AMINOPEPTIDASE 2', 239335),
(302791, 'PTHR45777', NULL, NULL, NULL, NULL, 'METHIONINE AMINOPEPTIDASE 2', 239335),
(302792, 'PTHR45777:SF1', NULL, NULL, NULL, NULL, 'METHIONINE AMINOPEPTIDASE 2-2', 239335),
(302793, 'PTHR45777:SF3', NULL, NULL, NULL, NULL, 'METHIONINE AMINOPEPTIDASE 2A', 239335),
(302794, 'PTHR45777:SF6', NULL, NULL, NULL, NULL, 'METHIONINE AMINOPEPTIDASE 2', 239335),
(302795, 'PTHR45777:SF5', NULL, NULL, NULL, NULL, 'PEPTIDASE_M24 DOMAIN-CONTAINING PROTEIN', 239335),
(302796, 'PTHR13299:SF0', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN PEX16', 239336),
(302797, 'PTHR13299:SF1', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN PEX16', 239336),
(302798, 'PTHR13299:SF2', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN PEX16', 239336),
(302799, 'PTHR13299', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239336),
(302800, 'PTHR31444:SF0', NULL, NULL, NULL, NULL, 'POLYSACC_SYNT_4 DOMAIN-CONTAINING PROTEIN', 239337),
(302801, 'PTHR31444:SF2', NULL, NULL, NULL, NULL, 'OS11G0490100 PROTEIN', 239337),
(302802, 'PTHR31444:SF3', NULL, NULL, NULL, NULL, 'OS04G0649900 PROTEIN', 239337),
(302803, 'PTHR31444:SF43', NULL, NULL, NULL, NULL, 'POLYSACC_SYNT_4 DOMAIN-CONTAINING PROTEIN', 239337),
(302804, 'PTHR31444:SF21', NULL, NULL, NULL, NULL, 'POLYSACC_SYNT_4 DOMAIN-CONTAINING PROTEIN', 239337);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(302805, 'PTHR31444', NULL, NULL, NULL, NULL, 'OS11G0490100 PROTEIN', 239337),
(302806, 'PTHR31444:SF44', NULL, NULL, NULL, NULL, 'POLYSACC_SYNT_4 DOMAIN-CONTAINING PROTEIN', 239337),
(302807, 'PTHR31444:SF45', NULL, NULL, NULL, NULL, 'POLYSACC_SYNT_4 DOMAIN-CONTAINING PROTEIN', 239337),
(302808, 'PTHR31444:SF40', NULL, NULL, NULL, NULL, 'PROTEIN IRX15-LIKE-LIKE', 239337),
(302809, 'PTHR31444:SF41', NULL, NULL, NULL, NULL, 'OS02G0158500 PROTEIN', 239337),
(302810, 'PTHR31444:SF20', NULL, NULL, NULL, NULL, 'POLYSACC_SYNT_4 DOMAIN-CONTAINING PROTEIN', 239337),
(302811, 'PTHR31444:SF42', NULL, NULL, NULL, NULL, 'POLYSACC_SYNT_4 DOMAIN-CONTAINING PROTEIN', 239337),
(302812, 'PTHR31444:SF29', NULL, NULL, NULL, NULL, 'POLYSACC_SYNT_4 DOMAIN-CONTAINING PROTEIN', 239337),
(302813, 'PTHR31444:SF5', NULL, NULL, NULL, NULL, 'OS11G0242600 PROTEIN', 239337),
(302814, 'PTHR31444:SF8', NULL, NULL, NULL, NULL, 'PROTEIN IRREGULAR XYLEM 15', 239337),
(302815, 'PTHR31444:SF47', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 239337),
(302816, 'PTHR31444:SF26', NULL, NULL, NULL, NULL, 'GLUCURONOXYLAN 4-O-METHYLTRANSFERASE 2-RELATED', 239337),
(302817, 'PTHR31444:SF27', NULL, NULL, NULL, NULL, 'POLYSACC_SYNT_4 DOMAIN-CONTAINING PROTEIN', 239337),
(302818, 'PTHR31444:SF49', NULL, NULL, NULL, NULL, 'PROTEIN IRX15-LIKE', 239337),
(302819, 'PTHR31444:SF32', NULL, NULL, NULL, NULL, 'GLUCURONOXYLAN 4-O-METHYLTRANSFERASE 3-LIKE', 239337),
(302820, 'PTHR31444:SF34', NULL, NULL, NULL, NULL, 'GLUCURONOXYLAN 4-O-METHYLTRANSFERASE-LIKE PROTEIN (DUF579)', 239337),
(302821, 'PTHR31444:SF50', NULL, NULL, NULL, NULL, 'POLYSACC_SYNT_4 DOMAIN-CONTAINING PROTEIN', 239337),
(302822, 'PTHR31444:SF30', NULL, NULL, NULL, NULL, 'POLYSACCHARIDE BIOSYNTHESIS PROTEIN', 239337),
(302823, 'PTHR31444:SF31', NULL, NULL, NULL, NULL, 'GLUCURONOXYLAN 4-O-METHYLTRANSFERASE 1', 239337),
(302824, 'PTHR31444:SF36', NULL, NULL, NULL, NULL, 'IRX15/IRX15L/IGXM, POLYSACCHARIDE BIOSYNTHESIS DOMAIN PROTEIN-RELATED', 239337),
(302825, 'PTHR31444:SF37', NULL, NULL, NULL, NULL, 'POLYSACC_SYNT_4 DOMAIN-CONTAINING PROTEIN', 239337),
(302826, 'PTHR31444:SF38', NULL, NULL, NULL, NULL, 'POLYSACC_SYNT_4 DOMAIN-CONTAINING PROTEIN', 239337),
(302827, 'PTHR46965', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN 19', 239338),
(302828, 'PTHR46965:SF1', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN 19', 239338),
(302829, 'PTHR33490', NULL, NULL, NULL, NULL, 'BLR5614 PROTEIN-RELATED', 239339),
(302830, 'PTHR33490:SF12', NULL, NULL, NULL, NULL, 'BLL5557 PROTEIN', 239339),
(302831, 'PTHR33490:SF3', NULL, NULL, NULL, NULL, 'SLL1049 PROTEIN', 239339),
(302832, 'PTHR33490:SF1', NULL, NULL, NULL, NULL, 'SLL1233 PROTEIN', 239339),
(302833, 'PTHR33490:SF7', NULL, NULL, NULL, NULL, 'BLR2979 PROTEIN', 239339),
(302834, 'PTHR33490:SF6', NULL, NULL, NULL, NULL, 'BLR5614 PROTEIN', 239339),
(302835, 'PTHR10338:SF155', NULL, NULL, NULL, NULL, 'INTER-ALPHA-TRYPSIN INHIBITOR HEAVY CHAIN H6', 239340),
(302836, 'PTHR10338', NULL, NULL, NULL, NULL, 'INTER-ALPHA-TRYPSIN INHIBITOR HEAVY CHAIN FAMILY MEMBER', 239340),
(302837, 'PTHR10338:SF154', NULL, NULL, NULL, NULL, 'INTER-ALPHA-TRYPSIN INHIBITOR HEAVY CHAIN 1-RELATED', 239340),
(302838, 'PTHR10338:SF62', NULL, NULL, NULL, NULL, 'INTER-ALPHA-TRYPSIN INHIBITOR HEAVY CHAIN H5', 239340),
(302839, 'PTHR10338:SF115', NULL, NULL, NULL, NULL, 'INTER-ALPHA-TRYPSIN INHIBITOR HEAVY CHAIN H3', 239340),
(302840, 'PTHR10338:SF106', NULL, NULL, NULL, NULL, 'INTER-ALPHA-TRYPSIN INHIBITOR HEAVY CHAIN H1', 239340),
(302841, 'PTHR10338:SF14', NULL, NULL, NULL, NULL, 'INTER-ALPHA-TRYPSIN INHIBITOR HEAVY CHAIN H2', 239340),
(302842, 'PTHR10338:SF108', NULL, NULL, NULL, NULL, 'INTER-ALPHA-TRYPSIN INHIBITOR HEAVY CHAIN H4-LIKE PROTEIN', 239340),
(302843, 'PTHR10338:SF119', NULL, NULL, NULL, NULL, 'INTER-ALPHA-TRYPSIN INHIBITOR HEAVY CHAIN H4', 239340),
(302844, 'PTHR42789:SF1', NULL, NULL, NULL, NULL, 'D-ISOMER SPECIFIC 2-HYDROXYACID DEHYDROGENASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_6G10090)', 239341),
(302845, 'PTHR42789', NULL, NULL, NULL, NULL, 'D-ISOMER SPECIFIC 2-HYDROXYACID DEHYDROGENASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_6G10090)', 239341);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(302846, 'PTHR11769', NULL, NULL, NULL, NULL, 'HYALURONIDASE', 239342),
(302847, 'PTHR11769:SF19', NULL, NULL, NULL, NULL, 'HYALURONIDASE-3', 239342),
(302848, 'PTHR11769:SF7', NULL, NULL, NULL, NULL, 'HYALURONIDASE-4', 239342),
(302849, 'PTHR11769:SF20', NULL, NULL, NULL, NULL, 'HYALURONIDASE PH-20', 239342),
(302850, 'PTHR11769:SF6', NULL, NULL, NULL, NULL, 'HYALURONIDASE-2', 239342),
(302851, 'PTHR11769:SF23', NULL, NULL, NULL, NULL, 'HYALURONIDASE-1', 239342),
(302852, 'PTHR11769:SF35', NULL, NULL, NULL, NULL, 'HYALURONIDASE', 239342),
(302853, 'PTHR11769:SF9', NULL, NULL, NULL, NULL, 'HYALURONIDASE', 239342),
(302854, 'PTHR11769:SF17', NULL, NULL, NULL, NULL, 'HYALURONIDASE PH-20', 239342),
(302855, 'PTHR11769:SF36', NULL, NULL, NULL, NULL, 'HYALURONIDASE', 239342),
(302856, 'PTHR11769:SF37', NULL, NULL, NULL, NULL, 'HYALURONIDASE', 239342),
(302857, 'PTHR21696', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239343),
(302858, 'PTHR21696:SF2', NULL, NULL, NULL, NULL, 'PROTEIN UNC-79 HOMOLOG', 239343),
(302859, 'PTHR17453', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE 19 KD PROTEIN', 239344),
(302860, 'PTHR17453:SF3', NULL, NULL, NULL, NULL, 'BNAA08G03500D PROTEIN', 239344),
(302861, 'PTHR17453:SF0', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE 19 KDA PROTEIN', 239344),
(302862, 'PTHR17453:SF2', NULL, NULL, NULL, NULL, '', 239344),
(302863, 'PTHR17453:SF1', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE 19 KDA PROTEIN', 239344),
(302864, 'PTHR47339', NULL, NULL, NULL, NULL, 'CELL DIVISION CONTROL PROTEIN 24', 239345),
(302865, 'PTHR47339:SF1', NULL, NULL, NULL, NULL, 'CELL DIVISION CONTROL PROTEIN 24', 239345),
(302866, 'PTHR37191:SF1', NULL, NULL, NULL, NULL, 'OS08G0112600 PROTEIN', 239346),
(302867, 'PTHR37191', NULL, NULL, NULL, NULL, 'ZINC FINGER/BTB DOMAIN PROTEIN', 239346),
(302868, 'PTHR16029:SF11', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 192 KDA', 239347),
(302869, 'PTHR16029', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239347),
(302870, 'PTHR40633:SF5', NULL, NULL, NULL, NULL, 'ANCHORED PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G04370)-RELATED', 239348),
(302871, 'PTHR40633:SF2', NULL, NULL, NULL, NULL, 'GPI ANCHORED SERINE-THREONINE RICH PROTEIN (AFU_ORTHOLOGUE AFUA_1G03630)', 239348),
(302872, 'PTHR40633:SF1', NULL, NULL, NULL, NULL, 'MATRIX PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G05410)-RELATED', 239348),
(302873, 'PTHR40633', NULL, NULL, NULL, NULL, 'MATRIX PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G05410)-RELATED', 239348),
(302874, 'PTHR48207:SF2', NULL, NULL, NULL, NULL, 'FORMYL-COA:OXALATE COA-TRANSFERASE', 239349),
(302875, 'PTHR48207', NULL, NULL, NULL, NULL, 'SUCCINATE--HYDROXYMETHYLGLUTARATE COA-TRANSFERASE', 239349),
(302876, 'PTHR48207:SF3', NULL, NULL, NULL, NULL, 'SUCCINATE--HYDROXYMETHYLGLUTARATE COA-TRANSFERASE', 239349),
(302877, 'PTHR47332:SF5', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 239350),
(302878, 'PTHR47332:SF4', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN 5', 239350),
(302879, 'PTHR47332', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN 5', 239350),
(302880, 'PTHR47332:SF2', NULL, NULL, NULL, NULL, 'SET-6', 239350),
(302881, 'PTHR33621:SF10', NULL, NULL, NULL, NULL, 'ASPARTIC/GLUTAMIC ACID-RICH PROTEIN', 239351),
(302882, 'PTHR33621:SF9', NULL, NULL, NULL, NULL, '', 239351),
(302883, 'PTHR33621:SF8', NULL, NULL, NULL, NULL, '', 239351),
(302884, 'PTHR33621', NULL, NULL, NULL, NULL, 'ASPARTIC/GLUTAMIC ACID-RICH PROTEIN', 239351),
(302885, 'PTHR33621:SF4', NULL, NULL, NULL, NULL, '', 239351),
(302886, 'PTHR33621:SF2', NULL, NULL, NULL, NULL, 'LISH DOMAIN-LIKE PROTEIN', 239351),
(302887, 'PTHR14559', NULL, NULL, NULL, NULL, 'CASPASE RECRUITMENT DOMAIN FAMILY', 239352),
(302888, 'PTHR14559:SF12', NULL, NULL, NULL, NULL, 'CASPASE RECRUITMENT DOMAIN-CONTAINING PROTEIN 10', 239352),
(302889, 'PTHR14559:SF1', NULL, NULL, NULL, NULL, 'CASPASE RECRUITMENT DOMAIN-CONTAINING PROTEIN 14', 239352),
(302890, 'PTHR14559:SF4', NULL, NULL, NULL, NULL, 'CASPASE RECRUITMENT DOMAIN-CONTAINING PROTEIN 11', 239352);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(302891, 'PTHR14559:SF11', NULL, NULL, NULL, NULL, 'NR LBD DOMAIN-CONTAINING PROTEIN', 239352),
(302892, 'PTHR14559:SF3', NULL, NULL, NULL, NULL, 'CASPASE RECRUITMENT DOMAIN-CONTAINING PROTEIN 9', 239352),
(302893, 'PTHR34200:SF6', NULL, NULL, NULL, NULL, '', 239353),
(302894, 'PTHR34200:SF7', NULL, NULL, NULL, NULL, '', 239353),
(302895, 'PTHR34200', NULL, NULL, NULL, NULL, 'DENTIN SIALOPHOSPHOPROTEIN-LIKE ISOFORM X1', 239353),
(302896, 'PTHR34200:SF8', NULL, NULL, NULL, NULL, 'DENTIN SIALOPHOSPHOPROTEIN-LIKE ISOFORM X1', 239353),
(302897, 'PTHR34200:SF9', NULL, NULL, NULL, NULL, '', 239353),
(302898, 'PTHR34200:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 239353),
(302899, 'PTHR34200:SF5', NULL, NULL, NULL, NULL, '', 239353),
(302900, 'PTHR47495', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE', 239354),
(302901, 'PTHR47495:SF1', NULL, NULL, NULL, NULL, 'BLL3820 PROTEIN', 239354),
(302902, 'PTHR47495:SF2', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE', 239354),
(302903, 'PTHR47495:SF3', NULL, NULL, NULL, NULL, 'BLR6219 PROTEIN', 239354),
(302904, 'PTHR11058:SF20', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE SUBUNIT 3', 239355),
(302905, 'PTHR11058:SF21', NULL, NULL, NULL, NULL, 'NADH-QUINONE OXIDOREDUCTASE SUBUNIT A', 239355),
(302906, 'PTHR11058:SF9', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE CHAIN 3', 239355),
(302907, 'PTHR11058:SF19', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE SUBUNIT 3', 239355),
(302908, 'PTHR11058:SF17', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE SUBUNIT 3', 239355),
(302909, 'PTHR11058', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE CHAIN 3', 239355),
(302910, 'PTHR11058:SF22', NULL, NULL, NULL, NULL, 'NADH-QUINONE OXIDOREDUCTASE SUBUNIT A', 239355),
(302911, 'PTHR33801:SF17', NULL, NULL, NULL, NULL, 'ABA/WDS INDUCED PROTEIN', 239356),
(302912, 'PTHR33801:SF12', NULL, NULL, NULL, NULL, 'OS01G0959100 PROTEIN', 239356),
(302913, 'PTHR33801:SF22', NULL, NULL, NULL, NULL, 'ABSCISIC STRESS-RIPENING PROTEIN 3', 239356),
(302914, 'PTHR33801:SF10', NULL, NULL, NULL, NULL, 'ABSCISIC ACID STRESS RIPENING5', 239356),
(302915, 'PTHR33801:SF20', NULL, NULL, NULL, NULL, 'ABSCISIC STRESS-RIPENING PROTEIN 1', 239356),
(302916, 'PTHR33801:SF27', NULL, NULL, NULL, NULL, 'ABA/WDS INDUCED PROTEIN', 239356),
(302917, 'PTHR33801:SF26', NULL, NULL, NULL, NULL, 'OS04G0423400 PROTEIN', 239356),
(302918, 'PTHR33801:SF15', NULL, NULL, NULL, NULL, 'ABSCISIC ACID STRESS RIPENING1', 239356),
(302919, 'PTHR33801:SF14', NULL, NULL, NULL, NULL, 'ABA/WDS INDUCED PROTEIN', 239356),
(302920, 'PTHR33801:SF25', NULL, NULL, NULL, NULL, '', 239356),
(302921, 'PTHR33801:SF24', NULL, NULL, NULL, NULL, 'ABSCISIC STRESS-RIPENING PROTEIN 5', 239356),
(302922, 'PTHR33801:SF8', NULL, NULL, NULL, NULL, 'OS01G0963600 PROTEIN', 239356),
(302923, 'PTHR33801', NULL, NULL, NULL, NULL, 'ABSCISIC STRESS-RIPENING PROTEIN 5', 239356),
(302924, 'PTHR33801:SF7', NULL, NULL, NULL, NULL, 'ABSCISIC STRESS-RIPENING PROTEIN 2', 239356),
(302925, 'PTHR33801:SF2', NULL, NULL, NULL, NULL, 'ABSCISIC STRESS-RIPENING PROTEIN 1', 239356),
(302926, 'PTHR10374:SF30', NULL, NULL, NULL, NULL, 'LACTOYLGLUTATHIONE LYASE', 239357),
(302927, 'PTHR10374:SF19', NULL, NULL, NULL, NULL, 'LYASE (GLO1), PUTATIVE (AFU_ORTHOLOGUE AFUA_2G13550)-RELATED', 239357),
(302928, 'PTHR10374', NULL, NULL, NULL, NULL, 'LACTOYLGLUTATHIONE LYASE  GLYOXALASE I', 239357),
(302929, 'PTHR13678:SF2', NULL, NULL, NULL, NULL, 'LD45836P', 239358),
(302930, 'PTHR13678:SF23', NULL, NULL, NULL, NULL, 'MODIFIER OF RUDIMENTARY, MODR-RELATED', 239358),
(302931, 'PTHR13678:SF12', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 37D', 239358),
(302932, 'PTHR13678:SF22', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN-SORTING-ASSOCIATED PROTEIN 37 HOMOLOG 2', 239358),
(302933, 'PTHR13678:SF21', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN-SORTING-ASSOCIATED PROTEIN 37 HOMOLOG 1-LIKE', 239358),
(302934, 'PTHR13678:SF9', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 37B', 239358),
(302935, 'PTHR13678:SF8', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 37C', 239358);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(302936, 'PTHR13678:SF20', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 37A', 239358),
(302937, 'PTHR13678:SF26', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 37A', 239358),
(302938, 'PTHR13678:SF25', NULL, NULL, NULL, NULL, 'EG:115C2.5 PROTEIN', 239358),
(302939, 'PTHR13678', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 37', 239358),
(302940, 'PTHR13678:SF24', NULL, NULL, NULL, NULL, 'SI:CH211-284F22.3', 239358),
(302941, 'PTHR13678:SF19', NULL, NULL, NULL, NULL, 'VPS37 C-TERMINAL DOMAIN-CONTAINING PROTEIN', 239358),
(302942, 'PTHR44054:SF4', NULL, NULL, NULL, NULL, 'DCUN1 DOMAIN-CONTAINING PROTEIN', 239359),
(302943, 'PTHR44054', NULL, NULL, NULL, NULL, 'SYNAPTIC VESICLE MEMBRANE PROTEIN VAT-1 HOMOLOG-LIKE', 239359),
(302944, 'PTHR44054:SF1', NULL, NULL, NULL, NULL, 'SYNAPTIC VESICLE MEMBRANE PROTEIN VAT-1 HOMOLOG', 239359),
(302945, 'PTHR44054:SF2', NULL, NULL, NULL, NULL, 'SYNAPTIC VESICLE MEMBRANE PROTEIN VAT-1 HOMOLOG-LIKE', 239359),
(302946, 'PTHR44054:SF3', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN', 239359),
(302947, 'PTHR35666:SF1', NULL, NULL, NULL, NULL, 'SIMILAR TO RIKEN CDNA 4921536K21', 239360),
(302948, 'PTHR35666', NULL, NULL, NULL, NULL, 'SIMILAR TO RIKEN CDNA 4921536K21', 239360),
(302949, 'PTHR37755:SF1', NULL, NULL, NULL, NULL, 'PROTEIN TIC 56, CHLOROPLASTIC', 239361),
(302950, 'PTHR37755', NULL, NULL, NULL, NULL, 'PROTEIN TIC 56, CHLOROPLASTIC', 239361),
(302951, 'PTHR43682:SF1', NULL, NULL, NULL, NULL, 'LACTATE UTILIZATION PROTEIN C', 239362),
(302952, 'PTHR43682', NULL, NULL, NULL, NULL, 'LACTATE UTILIZATION PROTEIN C', 239362),
(302953, 'PTHR19229:SF219', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER A FAMILY MEMBER 9', 239363),
(302954, 'PTHR19229:SF218', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER A FAMILY MEMBER 2-LIKE ISOFORM X1', 239363),
(302955, 'PTHR19229:SF217', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER A FAMILY MEMBER 10-RELATED', 239363),
(302956, 'PTHR19229:SF139', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE, SUB-FAMILY A (ABC1), MEMBER 14', 239363),
(302957, 'PTHR19229:SF13', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY A MEMBER 6', 239363),
(302958, 'PTHR19229:SF215', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER A FAMILY MEMBER 8', 239363),
(302959, 'PTHR19229:SF259', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 239363),
(302960, 'PTHR19229:SF258', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER A FAMILY PROTEIN', 239363),
(302961, 'PTHR19229:SF257', NULL, NULL, NULL, NULL, 'OS06G0589300 PROTEIN', 239363),
(302962, 'PTHR19229:SF213', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER A FAMILY MEMBER 7', 239363),
(302963, 'PTHR19229:SF212', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER A FAMILY MEMBER 7', 239363),
(302964, 'PTHR19229:SF256', NULL, NULL, NULL, NULL, '', 239363),
(302965, 'PTHR19229:SF211', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER A FAMILY MEMBER 7-LIKE ISOFORM X1', 239363),
(302966, 'PTHR19229:SF98', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE ABCA3', 239363),
(302967, 'PTHR19229:SF255', NULL, NULL, NULL, NULL, 'ENGULFMENT ABC TRANSPORTER IN THE OVARY, ISOFORM B', 239363),
(302968, 'PTHR19229:SF254', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER A FAMILY MEMBER 3-RELATED', 239363),
(302969, 'PTHR19229:SF253', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER FAMILY', 239363),
(302970, 'PTHR19229:SF252', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER A FAMILY', 239363),
(302971, 'PTHR19229:SF251', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER A FAMILY', 239363),
(302972, 'PTHR19229:SF250', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE, SUB-FAMILY A (ABC1), MEMBER 3B', 239363),
(302973, 'PTHR19229:SF209', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE, SUB-FAMILY A (ABC1), MEMBER 5', 239363),
(302974, 'PTHR19229:SF29', NULL, NULL, NULL, NULL, 'GLUCOSYLCERAMIDE TRANSPORTER ABCA12', 239363),
(302975, 'PTHR19229:SF207', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER A FAMILY MEMBER 11', 239363),
(302976, 'PTHR19229:SF205', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER A FAMILY MEMBER 2', 239363);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(302977, 'PTHR19229:SF204', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER A FAMILY MEMBER 7-LIKE', 239363),
(302978, 'PTHR19229:SF248', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE, SUB-FAMILY A (ABC1), MEMBER 1B', 239363),
(302979, 'PTHR19229:SF127', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER A FAMILY MEMBER 7', 239363),
(302980, 'PTHR19229:SF245', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 239363),
(302981, 'PTHR19229:SF243', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE, SUB-FAMILY A (ABC1), MEMBER 15', 239363),
(302982, 'PTHR19229:SF120', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY A MEMBER 9', 239363),
(302983, 'PTHR19229:SF241', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE TRANSPORTER (ABC TRANSPORTER) FAMILY E MEMBER 2', 239363),
(302984, 'PTHR19229:SF163', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY A MEMBER 10', 239363),
(302985, 'PTHR19229', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE TRANSPORTER SUBFAMILY A  ABCA', 239363),
(302986, 'PTHR19229:SF239', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER A FAMILY MEMBER 1-RELATED', 239363),
(302987, 'PTHR19229:SF117', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY A MEMBER 17', 239363),
(302988, 'PTHR19229:SF238', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER A FAMILY MEMBER 3-RELATED', 239363),
(302989, 'PTHR19229:SF237', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER A FAMILY MEMBER 10', 239363),
(302990, 'PTHR19229:SF36', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER A FAMILY MEMBER 7-RELATED', 239363),
(302991, 'PTHR19229:SF236', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER A FAMILY MEMBER 12', 239363),
(302992, 'PTHR19229:SF235', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER A FAMILY MEMBER 8-LIKE ISOFORM X1', 239363),
(302993, 'PTHR19229:SF34', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE ABCA1', 239363),
(302994, 'PTHR19229:SF113', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY A MEMBER 13', 239363),
(302995, 'PTHR19229:SF234', NULL, NULL, NULL, NULL, '', 239363),
(302996, 'PTHR19229:SF231', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 239363),
(302997, 'PTHR19229:SF154', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER A FAMILY MEMBER 7', 239363),
(302998, 'PTHR19229:SF151', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER FAMILY', 239363),
(302999, 'PTHR19229:SF194', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER A FAMILY MEMBER 7', 239363),
(303000, 'PTHR19229:SF190', NULL, NULL, NULL, NULL, 'RETINAL-SPECIFIC PHOSPHOLIPID-TRANSPORTING ATPASE ABCA4', 239363),
(303001, 'PTHR19229:SF49', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE ABCA7', 239363),
(303002, 'PTHR19229:SF148', NULL, NULL, NULL, NULL, 'ABC-TYPE ORGANIC ANION TRANSPORTER ABCA8', 239363),
(303003, 'PTHR19229:SF225', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY A MEMBER 2', 239363),
(303004, 'PTHR19229:SF223', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER A FAMILY MEMBER 11-LIKE', 239363),
(303005, 'PTHR19229:SF101', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE, SUB-FAMILY A (ABC1), MEMBER 16', 239363),
(303006, 'PTHR19229:SF100', NULL, NULL, NULL, NULL, 'CHOLESTEROL TRANSPORTER ABCA5', 239363),
(303007, 'PTHR19229:SF186', NULL, NULL, NULL, NULL, 'ABC-TYPE ORGANIC ANION TRANSPORTER ABCA8A', 239363),
(303008, 'PTHR19229:SF141', NULL, NULL, NULL, NULL, 'OS08G0398350 PROTEIN', 239363),
(303009, 'PTHR19229:SF185', NULL, NULL, NULL, NULL, 'ABC PROTEIN, SUBFAMILY ABCA', 239363),
(303010, 'PTHR47933:SF31', NULL, NULL, NULL, NULL, 'OS06G0199100 PROTEIN', 239364),
(303011, 'PTHR47933:SF30', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT (PPR) SUPERFAMILY PROTEIN', 239364),
(303012, 'PTHR47933:SF35', NULL, NULL, NULL, NULL, 'OS03G0115300 PROTEIN', 239364),
(303013, 'PTHR47933:SF34', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 239364),
(303014, 'PTHR47933:SF32', NULL, NULL, NULL, NULL, 'OS06G0152500 PROTEIN', 239364),
(303015, 'PTHR47933:SF39', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 239364),
(303016, 'PTHR47933:SF38', NULL, NULL, NULL, NULL, 'SMR DOMAIN-CONTAINING PROTEIN', 239364);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(303017, 'PTHR47933:SF37', NULL, NULL, NULL, NULL, 'OS07G0590600 PROTEIN', 239364),
(303018, 'PTHR47933:SF36', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN 10, CHLOROPLASTIC', 239364),
(303019, 'PTHR47933:SF42', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT PROTEIN-RELATED', 239364),
(303020, 'PTHR47933:SF41', NULL, NULL, NULL, NULL, 'OS08G0499800 PROTEIN', 239364),
(303021, 'PTHR47933:SF40', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN 1, MITOCHONDRIAL-RELATED', 239364),
(303022, 'PTHR47933:SF46', NULL, NULL, NULL, NULL, 'REPEAT-LIKE SUPERFAMILY PROTEIN, PUTATIVE ISOFORM 1-RELATED', 239364),
(303023, 'PTHR47933:SF45', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN-RELATED', 239364),
(303024, 'PTHR47933:SF44', NULL, NULL, NULL, NULL, 'OS02G0633200 PROTEIN', 239364),
(303025, 'PTHR47933:SF43', NULL, NULL, NULL, NULL, 'BNAA09G52830D PROTEIN', 239364),
(303026, 'PTHR47933:SF49', NULL, NULL, NULL, NULL, 'BNAA07G38290D PROTEIN', 239364),
(303027, 'PTHR47933:SF48', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL', 239364),
(303028, 'PTHR47933:SF47', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT DOMAIN CONTAINING PROTEIN-RELATED', 239364),
(303029, 'PTHR47933:SF53', NULL, NULL, NULL, NULL, '', 239364),
(303030, 'PTHR47933:SF52', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN PNM1, MITOCHONDRIAL', 239364),
(303031, 'PTHR47933:SF51', NULL, NULL, NULL, NULL, 'OS01G0785700 PROTEIN', 239364),
(303032, 'PTHR47933', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN 1, MITOCHONDRIAL', 239364),
(303033, 'PTHR47933:SF50', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN MITOCHONDRIAL', 239364),
(303034, 'PTHR47933:SF13', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 239364),
(303035, 'PTHR47933:SF57', NULL, NULL, NULL, NULL, '', 239364),
(303036, 'PTHR47933:SF12', NULL, NULL, NULL, NULL, 'OS06G0111300 PROTEIN', 239364),
(303037, 'PTHR47933:SF56', NULL, NULL, NULL, NULL, 'OS01G0793200 PROTEIN', 239364),
(303038, 'PTHR47933:SF11', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT (PPR) SUPERFAMILY PROTEIN', 239364),
(303039, 'PTHR47933:SF55', NULL, NULL, NULL, NULL, '', 239364),
(303040, 'PTHR47933:SF54', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 239364),
(303041, 'PTHR47933:SF10', NULL, NULL, NULL, NULL, 'OS03G0162900 PROTEIN', 239364),
(303042, 'PTHR47933:SF16', NULL, NULL, NULL, NULL, '', 239364),
(303043, 'PTHR47933:SF59', NULL, NULL, NULL, NULL, 'SAP DOMAIN-CONTAINING PROTEIN', 239364),
(303044, 'PTHR47933:SF15', NULL, NULL, NULL, NULL, 'OS03G0795400 PROTEIN', 239364),
(303045, 'PTHR47933:SF14', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT (PPR) SUPERFAMILY PROTEIN', 239364),
(303046, 'PTHR47933:SF58', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE ISOFORM 1-RELATED', 239364),
(303047, 'PTHR47933:SF19', NULL, NULL, NULL, NULL, 'ENZYME, PUTATIVE-RELATED', 239364),
(303048, 'PTHR47933:SF18', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 239364),
(303049, 'PTHR47933:SF60', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 239364),
(303050, 'PTHR47933:SF64', NULL, NULL, NULL, NULL, '', 239364),
(303051, 'PTHR47933:SF5', NULL, NULL, NULL, NULL, 'OS01G0747600 PROTEIN', 239364),
(303052, 'PTHR47933:SF63', NULL, NULL, NULL, NULL, '', 239364),
(303053, 'PTHR47933:SF7', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT PROTEIN-RELATED', 239364),
(303054, 'PTHR47933:SF62', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 239364),
(303055, 'PTHR47933:SF8', NULL, NULL, NULL, NULL, 'OS02G0601600 PROTEIN', 239364),
(303056, 'PTHR47933:SF61', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 239364),
(303057, 'PTHR47933:SF9', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 239364),
(303058, 'PTHR47933:SF24', NULL, NULL, NULL, NULL, 'OS05G0207200 PROTEIN', 239364),
(303059, 'PTHR47933:SF68', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 239364);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(303060, 'PTHR47933:SF23', NULL, NULL, NULL, NULL, 'OS02G0468500 PROTEIN', 239364),
(303061, 'PTHR47933:SF67', NULL, NULL, NULL, NULL, '', 239364),
(303062, 'PTHR47933:SF66', NULL, NULL, NULL, NULL, 'BNAA05G13520D PROTEIN', 239364),
(303063, 'PTHR47933:SF22', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 239364),
(303064, 'PTHR47933:SF65', NULL, NULL, NULL, NULL, 'OS01G0616600 PROTEIN', 239364),
(303065, 'PTHR47933:SF26', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 239364),
(303066, 'PTHR47933:SF25', NULL, NULL, NULL, NULL, 'EMP16', 239364),
(303067, 'PTHR47933:SF29', NULL, NULL, NULL, NULL, 'OS03G0208600 PROTEIN', 239364),
(303068, 'PTHR47933:SF2', NULL, NULL, NULL, NULL, 'PROTON GRADIENT REGULATION3-LIKE PROTEIN', 239364),
(303069, 'PTHR47933:SF3', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 239364),
(303070, 'PTHR47933:SF4', NULL, NULL, NULL, NULL, '', 239364),
(303071, 'PTHR28262:SF1', NULL, NULL, NULL, NULL, 'DASH COMPLEX SUBUNIT SPC19', 239365),
(303072, 'PTHR28262', NULL, NULL, NULL, NULL, 'DASH COMPLEX SUBUNIT SPC19', 239365),
(303073, 'PTHR16078', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 87', 239366),
(303074, 'PTHR16078:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 87', 239366),
(303075, 'PTHR39387', NULL, NULL, NULL, NULL, 'SHAVENOID, ISOFORM B', 239367),
(303076, 'PTHR39387:SF1', NULL, NULL, NULL, NULL, 'SHAVENOID, ISOFORM B', 239367),
(303077, 'PTHR40064', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 239368),
(303078, 'PTHR40064:SF1', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 239368),
(303079, 'PTHR46933', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DNA-BINDING DOMAIN-CONTAINING PROTEIN 2', 239369),
(303080, 'PTHR46933:SF1', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DNA-BINDING DOMAIN-CONTAINING PROTEIN 2', 239369),
(303081, 'PTHR40083', NULL, NULL, NULL, NULL, 'UPF0122 PROTEIN CBO2450/CLC_2298', 239370),
(303082, 'PTHR40083:SF1', NULL, NULL, NULL, NULL, 'UPF0122 PROTEIN YLXM', 239370),
(303083, 'PTHR44835:SF1', NULL, NULL, NULL, NULL, 'PROTEIN O-GLCNAC TRANSFERASE', 239371),
(303084, 'PTHR44835', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE--PEPTIDE N-ACETYLGLUCOSAMINYLTRANSFERASE SPINDLY-RELATED', 239371),
(303085, 'PTHR32241:SF16', NULL, NULL, NULL, NULL, 'OS06G0677000 PROTEIN', 239372),
(303086, 'PTHR32241:SF27', NULL, NULL, NULL, NULL, 'PATATIN', 239372),
(303087, 'PTHR32241:SF28', NULL, NULL, NULL, NULL, 'PATATIN', 239372),
(303088, 'PTHR32241:SF18', NULL, NULL, NULL, NULL, 'PATATIN', 239372),
(303089, 'PTHR32241:SF19', NULL, NULL, NULL, NULL, 'PATATIN', 239372),
(303090, 'PTHR32241:SF20', NULL, NULL, NULL, NULL, 'PATATIN', 239372),
(303091, 'PTHR32241:SF21', NULL, NULL, NULL, NULL, 'PNPLA DOMAIN-CONTAINING PROTEIN', 239372),
(303092, 'PTHR32241:SF22', NULL, NULL, NULL, NULL, 'PATATIN', 239372),
(303093, 'PTHR32241:SF23', NULL, NULL, NULL, NULL, 'PATATIN', 239372),
(303094, 'PTHR32241:SF12', NULL, NULL, NULL, NULL, 'OS03G0784100 PROTEIN', 239372),
(303095, 'PTHR32241:SF13', NULL, NULL, NULL, NULL, 'INACTIVE PATATIN-LIKE PROTEIN 9-RELATED', 239372),
(303096, 'PTHR32241:SF24', NULL, NULL, NULL, NULL, 'PATATIN', 239372),
(303097, 'PTHR32241:SF25', NULL, NULL, NULL, NULL, 'PATATIN-LIKE PROTEIN 8', 239372),
(303098, 'PTHR32241:SF14', NULL, NULL, NULL, NULL, 'PATATIN-LIKE PROTEIN 7', 239372),
(303099, 'PTHR32241:SF26', NULL, NULL, NULL, NULL, 'PATATIN', 239372),
(303100, 'PTHR32241:SF4', NULL, NULL, NULL, NULL, 'OS12G0611300 PROTEIN', 239372),
(303101, 'PTHR32241', NULL, NULL, NULL, NULL, 'PATATIN-LIKE PROTEIN 6', 239372),
(303102, 'PTHR32241:SF3', NULL, NULL, NULL, NULL, 'PATATIN-LIKE PROTEIN 6', 239372),
(303103, 'PTHR32241:SF9', NULL, NULL, NULL, NULL, 'PATATIN', 239372),
(303104, 'PTHR32241:SF8', NULL, NULL, NULL, NULL, 'PATATIN-LIKE PROTEIN 3', 239372),
(303105, 'PTHR10605:SF62', NULL, NULL, NULL, NULL, 'HEPARAN SULFATE GLUCOSAMINE 3-O-SULFOTRANSFERASE 6', 239373),
(303106, 'PTHR10605:SF71', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 239373),
(303107, 'PTHR10605:SF11', NULL, NULL, NULL, NULL, 'HEPARAN SULFATE GLUCOSAMINE 3-O-SULFOTRANSFERASE 4', 239373);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(303108, 'PTHR10605:SF55', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 239373),
(303109, 'PTHR10605:SF10', NULL, NULL, NULL, NULL, 'HEPARAN SULFATE GLUCOSAMINE 3-O-SULFOTRANSFERASE 2', 239373),
(303110, 'PTHR10605:SF65', NULL, NULL, NULL, NULL, 'HEPARAN SULFATE 3-O SULFOTRANSFERASE-B, ISOFORM A', 239373),
(303111, 'PTHR10605:SF31', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 239373),
(303112, 'PTHR10605:SF64', NULL, NULL, NULL, NULL, 'HEPARAN SULFATE GLUCOSAMINE 3-O-SULFOTRANSFERASE 3A1', 239373),
(303113, 'PTHR10605:SF53', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL HEPARAN SULFATE N-DEACETYLASE/N-SULFOTRANSFERASE 2', 239373),
(303114, 'PTHR10605:SF30', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL HEPARAN SULFATE N-DEACETYLASE/N-SULFOTRANSFERASE 1', 239373),
(303115, 'PTHR10605', NULL, NULL, NULL, NULL, 'HEPARAN SULFATE SULFOTRANSFERASE', 239373),
(303116, 'PTHR10605:SF69', NULL, NULL, NULL, NULL, 'GH20068P', 239373),
(303117, 'PTHR10605:SF46', NULL, NULL, NULL, NULL, 'HEPARAN SULFATE GLUCOSAMINE 3-O-SULFOTRANSFERASE 5', 239373),
(303118, 'PTHR10605:SF68', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 239373),
(303119, 'PTHR10605:SF56', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL HEPARAN SULFATE N-DEACETYLASE/N-SULFOTRANSFERASE', 239373),
(303120, 'PTHR10605:SF45', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL HEPARAN SULFATE N-DEACETYLASE/N-SULFOTRANSFERASE 4', 239373),
(303121, 'PTHR10605:SF18', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 239373),
(303122, 'PTHR10605:SF29', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL HEPARAN SULFATE N-DEACETYLASE/N-SULFOTRANSFERASE 3', 239373),
(303123, 'PTHR10605:SF7', NULL, NULL, NULL, NULL, 'HEPARAN SULFATE GLUCOSAMINE 3-O-SULFOTRANSFERASE 3B1', 239373),
(303124, 'PTHR10605:SF16', NULL, NULL, NULL, NULL, 'HEPARAN SULFATE GLUCOSAMINE 3-O-SULFOTRANSFERASE 1', 239373),
(303125, 'PTHR15090:SF0', NULL, NULL, NULL, NULL, 'SEQUESTOSOME-1', 239374),
(303126, 'PTHR15090:SF7', NULL, NULL, NULL, NULL, 'ZZ-TYPE DOMAIN-CONTAINING PROTEIN', 239374),
(303127, 'PTHR15090:SF6', NULL, NULL, NULL, NULL, 'SEQUESTOSOME RELATED-RELATED', 239374),
(303128, 'PTHR15090', NULL, NULL, NULL, NULL, 'SEQUESTOSOME 1-RELATED', 239374),
(303129, 'PTHR40455:SF1', NULL, NULL, NULL, NULL, 'ANTITOXIN HIGA', 239375),
(303130, 'PTHR40455', NULL, NULL, NULL, NULL, 'ANTITOXIN HIGA', 239375),
(303131, 'PTHR11521:SF23', NULL, NULL, NULL, NULL, 'SLOW TROPONIN T', 239376),
(303132, 'PTHR11521:SF24', NULL, NULL, NULL, NULL, 'TROPONIN T', 239376),
(303133, 'PTHR11521:SF7', NULL, NULL, NULL, NULL, 'TROPONIN T', 239376),
(303134, 'PTHR11521:SF27', NULL, NULL, NULL, NULL, 'TROPONIN T, FAST SKELETAL MUSCLE', 239376),
(303135, 'PTHR11521:SF28', NULL, NULL, NULL, NULL, 'TROPONIN T', 239376),
(303136, 'PTHR11521:SF1', NULL, NULL, NULL, NULL, 'TROPONIN T, SKELETAL MUSCLE', 239376),
(303137, 'PTHR11521', NULL, NULL, NULL, NULL, 'TROPONIN T', 239376),
(303138, 'PTHR11521:SF5', NULL, NULL, NULL, NULL, 'TROPONIN T, CARDIAC MUSCLE', 239376),
(303139, 'PTHR11521:SF6', NULL, NULL, NULL, NULL, 'TROPONIN T, SLOW SKELETAL MUSCLE', 239376),
(303140, 'PTHR11521:SF20', NULL, NULL, NULL, NULL, 'NOVEL SLOW SKELETAL TROPONIN T FAMILY PROTEIN-RELATED', 239376),
(303141, 'PTHR11521:SF4', NULL, NULL, NULL, NULL, 'TROPONIN T, FAST SKELETAL MUSCLE', 239376),
(303142, 'PTHR21304', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239377),
(303143, 'PTHR21304:SF11', NULL, NULL, NULL, NULL, 'BNAA07G10410D PROTEIN', 239377),
(303144, 'PTHR21304:SF13', NULL, NULL, NULL, NULL, 'MICOS COMPLEX SUBUNIT MIC10-LIKE PROTEIN (DUF543)', 239377),
(303145, 'PTHR21304:SF0', NULL, NULL, NULL, NULL, 'MICOS COMPLEX SUBUNIT MIC10', 239377),
(303146, 'PTHR21304:SF5', NULL, NULL, NULL, NULL, 'MICOS COMPLEX SUBUNIT MIC10', 239377),
(303147, 'PTHR21304:SF6', NULL, NULL, NULL, NULL, 'MICOS COMPLEX SUBUNIT MIC10', 239377),
(303148, 'PTHR21304:SF4', NULL, NULL, NULL, NULL, '', 239377),
(303149, 'PTHR21304:SF9', NULL, NULL, NULL, NULL, '', 239377),
(303150, 'PTHR21304:SF7', NULL, NULL, NULL, NULL, 'MICOS COMPLEX SUBUNIT MIC10', 239377),
(303151, 'PTHR31125', NULL, NULL, NULL, NULL, 'F20P5.22 PROTEIN-RELATED', 239378);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(303152, 'PTHR31125:SF7', NULL, NULL, NULL, NULL, 'F20P5.24 PROTEIN-RELATED', 239378),
(303153, 'PTHR31125:SF8', NULL, NULL, NULL, NULL, 'F20P5.22 PROTEIN', 239378),
(303154, 'PTHR31125:SF11', NULL, NULL, NULL, NULL, 'BNAA07G38800D PROTEIN', 239378),
(303155, 'PTHR31125:SF10', NULL, NULL, NULL, NULL, 'BNAC06G31130D PROTEIN', 239378),
(303156, 'PTHR31125:SF9', NULL, NULL, NULL, NULL, 'BNAC01G14450D PROTEIN', 239378),
(303157, 'PTHR31125:SF12', NULL, NULL, NULL, NULL, 'BNAA06G37180D PROTEIN', 239378),
(303158, 'PTHR31008:SF5', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239379),
(303159, 'PTHR31008:SF7', NULL, NULL, NULL, NULL, 'OS07G0445600 PROTEIN', 239379),
(303160, 'PTHR31008:SF2', NULL, NULL, NULL, NULL, 'COP1-INTERACTING PROTEIN-LIKE PROTEIN', 239379),
(303161, 'PTHR31008:SF4', NULL, NULL, NULL, NULL, 'COP1-INTERACTING PROTEIN 7', 239379),
(303162, 'PTHR31008:SF34', NULL, NULL, NULL, NULL, '', 239379),
(303163, 'PTHR31008:SF23', NULL, NULL, NULL, NULL, 'BNAA02G22140D PROTEIN', 239379),
(303164, 'PTHR31008:SF13', NULL, NULL, NULL, NULL, 'COP1-INTERACTING PROTEIN-LIKE PROTEIN-RELATED', 239379),
(303165, 'PTHR31008:SF43', NULL, NULL, NULL, NULL, 'ERECT PANICAL 2', 239379),
(303166, 'PTHR31008:SF33', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 239379),
(303167, 'PTHR31008:SF22', NULL, NULL, NULL, NULL, 'ERECT PANICAL 2', 239379),
(303168, 'PTHR31008:SF16', NULL, NULL, NULL, NULL, 'TOLL-INTERLEUKIN-RESISTANCE (TIR) DOMAIN FAMILY PROTEIN', 239379),
(303169, 'PTHR31008:SF38', NULL, NULL, NULL, NULL, 'SERINE/ARGININE REPETITIVE MATRIX PROTEIN 2-LIKE ISOFORM X1', 239379),
(303170, 'PTHR31008:SF39', NULL, NULL, NULL, NULL, '', 239379),
(303171, 'PTHR31008:SF17', NULL, NULL, NULL, NULL, '', 239379),
(303172, 'PTHR31008:SF25', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 239379),
(303173, 'PTHR31008:SF15', NULL, NULL, NULL, NULL, 'GPI-ANCHORED ADHESIN-LIKE PROTEIN', 239379),
(303174, 'PTHR31008:SF26', NULL, NULL, NULL, NULL, 'OS02G0781900 PROTEIN', 239379),
(303175, 'PTHR31008:SF30', NULL, NULL, NULL, NULL, 'OS06G0196500 PROTEIN', 239379),
(303176, 'PTHR31008:SF41', NULL, NULL, NULL, NULL, '', 239379),
(303177, 'PTHR31008:SF42', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE-LIKE PROTEIN CSA1', 239379),
(303178, 'PTHR31008', NULL, NULL, NULL, NULL, 'COP1-INTERACTING PROTEIN-RELATED', 239379),
(303179, 'PTHR31008:SF40', NULL, NULL, NULL, NULL, 'TOLL-INTERLEUKIN-RESISTANCE (TIR) DOMAIN FAMILY PROTEIN', 239379),
(303180, 'PTHR31008:SF0', NULL, NULL, NULL, NULL, 'CSL1', 239379),
(303181, 'PTHR31241:SF28', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 239380),
(303182, 'PTHR31241:SF61', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 2G', 239380),
(303183, 'PTHR31241:SF62', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 2D', 239380),
(303184, 'PTHR31241:SF41', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 2G-LIKE', 239380),
(303185, 'PTHR31241:SF63', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 239380),
(303186, 'PTHR31241:SF24', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ABI4', 239380),
(303187, 'PTHR31241:SF5', NULL, NULL, NULL, NULL, 'OS08G0521600 PROTEIN', 239380),
(303188, 'PTHR31241:SF2', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 2F', 239380),
(303189, 'PTHR31241', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 2C', 239380),
(303190, 'PTHR31241:SF49', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 239380),
(303191, 'PTHR31241:SF20', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 239380),
(303192, 'PTHR31241:SF65', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 239380),
(303193, 'PTHR31241:SF43', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 2E', 239380),
(303194, 'PTHR31241:SF23', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 239380),
(303195, 'PTHR31241:SF71', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 239380);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(303196, 'PTHR31241:SF72', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 239380),
(303197, 'PTHR31241:SF73', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 239380),
(303198, 'PTHR31241:SF52', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 239380),
(303199, 'PTHR31241:SF74', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 2B', 239380),
(303200, 'PTHR31241:SF79', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 2A', 239380),
(303201, 'PTHR31241:SF57', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 239380),
(303202, 'PTHR31241:SF58', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 239380),
(303203, 'PTHR31241:SF37', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 2A-RELATED', 239380),
(303204, 'PTHR31241:SF59', NULL, NULL, NULL, NULL, 'DREB2A', 239380),
(303205, 'PTHR31241:SF38', NULL, NULL, NULL, NULL, 'AP2-EREBP TRANSCRIPTION FACTOR', 239380),
(303206, 'PTHR31241:SF75', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 2D-LIKE', 239380),
(303207, 'PTHR31241:SF76', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 2D-LIKE', 239380),
(303208, 'PTHR31241:SF32', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 239380),
(303209, 'PTHR31241:SF54', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 239380),
(303210, 'PTHR31241:SF77', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 239380),
(303211, 'PTHR31241:SF55', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 239380),
(303212, 'PTHR31241:SF78', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 2A-LIKE', 239380),
(303213, 'PTHR31241:SF56', NULL, NULL, NULL, NULL, 'DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 239380),
(303214, 'PTHR13931:SF15', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN', 239381),
(303215, 'PTHR13931:SF16', NULL, NULL, NULL, NULL, 'UBIQUITIN CONJUGATION FACTOR E4 A', 239381),
(303216, 'PTHR13931', NULL, NULL, NULL, NULL, 'UBIQUITINATION FACTOR E4', 239381),
(303217, 'PTHR13931:SF2', NULL, NULL, NULL, NULL, 'UBIQUITIN CONJUGATION FACTOR E4 B', 239381),
(303218, 'PTHR43341:SF27', NULL, NULL, NULL, NULL, 'AMINO-ACID PERMEASE ROCC', 239382),
(303219, 'PTHR43341:SF26', NULL, NULL, NULL, NULL, 'GENERAL AMINO ACID PERMEASE AGP3', 239382),
(303220, 'PTHR43341:SF24', NULL, NULL, NULL, NULL, 'VALINE/TYROSINE/TRYPTOPHAN AMINO-ACID PERMEASE 1', 239382),
(303221, 'PTHR43341:SF44', NULL, NULL, NULL, NULL, 'AMINO-ACID PERMEASE MEU22-RELATED', 239382),
(303222, 'PTHR43341:SF21', NULL, NULL, NULL, NULL, 'CHROMOSOME 8, WHOLE GENOME SHOTGUN SEQUENCE', 239382),
(303223, 'PTHR43341:SF43', NULL, NULL, NULL, NULL, 'AMINO-ACID PERMEASE 1', 239382),
(303224, 'PTHR43341:SF20', NULL, NULL, NULL, NULL, 'AA_PERMEASE DOMAIN-CONTAINING PROTEIN', 239382),
(303225, 'PTHR43341:SF42', NULL, NULL, NULL, NULL, 'DIFFERENTIATION PROCESS PUTATIVE AMINO-ACID PERMEASE ISP5-RELATED', 239382),
(303226, 'PTHR43341:SF38', NULL, NULL, NULL, NULL, 'PROLINE TRANSPORTER (EUROFUNG)', 239382),
(303227, 'PTHR43341:SF16', NULL, NULL, NULL, NULL, 'TRYPTOPHAN PERMEASE', 239382),
(303228, 'PTHR43341:SF15', NULL, NULL, NULL, NULL, 'GENERAL AMINO ACID PERMEASE AGP2', 239382),
(303229, 'PTHR43341:SF37', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER (EUROFUNG)', 239382),
(303230, 'PTHR43341:SF36', NULL, NULL, NULL, NULL, 'PROLINE-SPECIFIC PERMEASE', 239382),
(303231, 'PTHR43341:SF13', NULL, NULL, NULL, NULL, 'HISTIDINE PERMEASE', 239382),
(303232, 'PTHR43341', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE', 239382),
(303233, 'PTHR43341:SF35', NULL, NULL, NULL, NULL, 'ACID TRANSPORTER, PUTATIVE-RELATED', 239382),
(303234, 'PTHR43341:SF12', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER (EUROFUNG)', 239382),
(303235, 'PTHR43341:SF34', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (EUROFUNG)-RELATED', 239382),
(303236, 'PTHR43341:SF10', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE PERMEASE SAM3-RELATED', 239382),
(303237, 'PTHR43341:SF9', NULL, NULL, NULL, NULL, 'DICARBOXYLIC AMINO ACID PERMEASE', 239382);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(303238, 'PTHR43341:SF8', NULL, NULL, NULL, NULL, 'PROLINE-SPECIFIC PERMEASE PROY', 239382),
(303239, 'PTHR43341:SF7', NULL, NULL, NULL, NULL, 'LEU/VAL/ILE AMINO-ACID PERMEASE-RELATED', 239382),
(303240, 'PTHR43341:SF6', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER (EUROFUNG)', 239382),
(303241, 'PTHR43341:SF5', NULL, NULL, NULL, NULL, 'S-METHYLMETHIONINE PERMEASE-RELATED', 239382),
(303242, 'PTHR43341:SF4', NULL, NULL, NULL, NULL, 'ARGININE PERMEASE CAN1-RELATED', 239382),
(303243, 'PTHR43341:SF19', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC PERMEASE', 239382),
(303244, 'PTHR43341:SF3', NULL, NULL, NULL, NULL, 'AMINO-ACID PERMEASE PB1C11.02-RELATED', 239382),
(303245, 'PTHR43341:SF18', NULL, NULL, NULL, NULL, 'AA_PERMEASE DOMAIN-CONTAINING PROTEIN', 239382),
(303246, 'PTHR43341:SF17', NULL, NULL, NULL, NULL, 'GENERAL AMINO ACID PERMEASE AGP1-RELATED', 239382),
(303247, 'PTHR43341:SF39', NULL, NULL, NULL, NULL, 'SPS-SENSOR COMPONENT SSY1', 239382),
(303248, 'PTHR43341:SF2', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE', 239382),
(303249, 'PTHR43341:SF1', NULL, NULL, NULL, NULL, 'GENERAL AMINO-ACID PERMEASE GAP1', 239382),
(303250, 'PTHR39336:SF1', NULL, NULL, NULL, NULL, 'PYRIDOXAMINE PHOSPHATE OXIDASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_6G11440)', 239383),
(303251, 'PTHR39336:SF3', NULL, NULL, NULL, NULL, 'PYRIDOXAMINE PHOSPHATE OXIDASE', 239383),
(303252, 'PTHR39336', NULL, NULL, NULL, NULL, 'PYRIDOXAMINE PHOSPHATE OXIDASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_6G11440)', 239383),
(303253, 'PTHR32305:SF15', NULL, NULL, NULL, NULL, 'PROTEIN RHSA-RELATED', 239384),
(303254, 'PTHR32305', NULL, NULL, NULL, NULL, '', 239384),
(303255, 'PTHR32305:SF16', NULL, NULL, NULL, NULL, 'TYPE VI SECRETION SYSTEM SPIKE PROTEIN VGRG1C', 239384),
(303256, 'PTHR32305:SF11', NULL, NULL, NULL, NULL, 'TYPE VI SECRETION SYSTEM SPIKE PROTEIN VGRG3', 239384),
(303257, 'PTHR37410', NULL, NULL, NULL, NULL, 'ADHESIN, PUTATIVE-RELATED', 239385),
(303258, 'PTHR37410:SF1', NULL, NULL, NULL, NULL, 'ADHESIN, PUTATIVE-RELATED', 239385),
(303259, 'PTHR20978:SF8', NULL, NULL, NULL, NULL, 'SPLICING FACTOR SUBUNIT', 239386),
(303260, 'PTHR20978:SF9', NULL, NULL, NULL, NULL, 'SPLICING FACTOR SUBUNIT', 239386),
(303261, 'PTHR20978', NULL, NULL, NULL, NULL, 'SPLICING FACTOR 3B SUBUNIT 5', 239386),
(303262, 'PTHR20978:SF0', NULL, NULL, NULL, NULL, 'SPLICING FACTOR 3B SUBUNIT 5', 239386),
(303263, 'PTHR46455:SF7', NULL, NULL, NULL, NULL, 'RE12806P', 239387),
(303264, 'PTHR46455:SF5', NULL, NULL, NULL, NULL, 'SET AND MYND DOMAIN CONTAINING, ARTHROPOD-SPECIFIC, MEMBER 4, ISOFORM A', 239387),
(303265, 'PTHR46455:SF6', NULL, NULL, NULL, NULL, 'RE22408P-RELATED', 239387),
(303266, 'PTHR46455:SF3', NULL, NULL, NULL, NULL, 'SET AND MYND DOMAIN CONTAINING, ARTHROPOD-SPECIFIC, MEMBER 9, ISOFORM A-RELATED', 239387),
(303267, 'PTHR46455', NULL, NULL, NULL, NULL, 'SET AND MYND DOMAIN CONTAINING, ARTHROPOD-SPECIFIC, MEMBER 4, ISOFORM A', 239387),
(303268, 'PTHR46455:SF4', NULL, NULL, NULL, NULL, 'GH11294P', 239387),
(303269, 'PTHR46455:SF1', NULL, NULL, NULL, NULL, 'SET AND MYND DOMAIN CONTAINING, ARTHROPOD-SPECIFIC, MEMBER 2', 239387),
(303270, 'PTHR46455:SF2', NULL, NULL, NULL, NULL, 'AT24727P', 239387),
(303271, 'PTHR45703:SF35', NULL, NULL, NULL, NULL, 'DYNEIN HEAVY CHAIN', 239388),
(303272, 'PTHR45703', NULL, NULL, NULL, NULL, 'DYNEIN HEAVY CHAIN', 239388),
(303273, 'PTHR45703:SF32', NULL, NULL, NULL, NULL, 'DYNEINS HEAVY CHAIN', 239388),
(303274, 'PTHR45703:SF31', NULL, NULL, NULL, NULL, 'DYNEINS HEAVY CHAIN', 239388),
(303275, 'PTHR45703:SF34', NULL, NULL, NULL, NULL, 'DYNEINS HEAVY CHAIN', 239388),
(303276, 'PTHR45703:SF23', NULL, NULL, NULL, NULL, 'DYNEIN HEAVY CHAIN, CYTOPLASMIC', 239388),
(303277, 'PTHR45703:SF12', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL HEAVY CHAIN 11', 239388),
(303278, 'PTHR45703:SF22', NULL, NULL, NULL, NULL, 'CYTOPLASMIC DYNEIN 2 HEAVY CHAIN 1', 239388),
(303279, 'PTHR45703:SF33', NULL, NULL, NULL, NULL, 'DYNEIN BETA CHAIN, FLAGELLAR OUTER ARM', 239388),
(303280, 'PTHR45703:SF29', NULL, NULL, NULL, NULL, 'DYNEIN, AXONEMAL, HEAVY POLYPEPTIDE 9 LIKE', 239388);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(303281, 'PTHR45703:SF1', NULL, NULL, NULL, NULL, 'DYNEINS HEAVY CHAIN', 239388),
(303282, 'PTHR45703:SF28', NULL, NULL, NULL, NULL, 'DYNEINS HEAVY CHAIN', 239388),
(303283, 'PTHR45703:SF4', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL HEAVY CHAIN 17', 239388),
(303284, 'PTHR45703:SF8', NULL, NULL, NULL, NULL, 'DYNEINS HEAVY CHAIN', 239388),
(303285, 'PTHR45703:SF30', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL HEAVY CHAIN 12', 239388),
(303286, 'PTHR13243:SF1', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 16', 239389),
(303287, 'PTHR13243', NULL, NULL, NULL, NULL, 'HSPC111 PROTEIN-RELATED', 239389),
(303288, 'PTHR13419', NULL, NULL, NULL, NULL, 'ZINC FINGER-CONTAINING', 239390),
(303289, 'PTHR13419:SF0', NULL, NULL, NULL, NULL, 'CXXC-TYPE DOMAIN-CONTAINING PROTEIN', 239390),
(303290, 'PTHR13419:SF1', NULL, NULL, NULL, NULL, 'CXXC FINGER PROTEIN 4', 239390),
(303291, 'PTHR13419:SF2', NULL, NULL, NULL, NULL, 'CXXC-TYPE ZINC FINGER PROTEIN 5', 239390),
(303292, 'PTHR20855:SF137', NULL, NULL, NULL, NULL, 'MONOCYTE TO MACROPHAGE DIFFERENTIATION-ASSOCIATED 2A', 239391),
(303293, 'PTHR20855:SF38', NULL, NULL, NULL, NULL, 'MEMBRANE PROGESTIN RECEPTOR GAMMA', 239391),
(303294, 'PTHR20855:SF115', NULL, NULL, NULL, NULL, 'HEPTAHELICAL TRANSMEMBRANE PROTEIN 1', 239391),
(303295, 'PTHR20855:SF138', NULL, NULL, NULL, NULL, 'PROGESTIN AND ADIPOQ RECEPTOR FAMILY MEMBER 4', 239391),
(303296, 'PTHR20855:SF39', NULL, NULL, NULL, NULL, 'MEMBRANE PROGESTIN RECEPTOR DELTA', 239391),
(303297, 'PTHR20855:SF116', NULL, NULL, NULL, NULL, 'HEPTAHELICAL TRANSMEMBRANE PROTEIN 1-LIKE', 239391),
(303298, 'PTHR20855:SF58', NULL, NULL, NULL, NULL, 'MEMBRANE PROGESTIN RECEPTOR EPSILON', 239391),
(303299, 'PTHR20855:SF139', NULL, NULL, NULL, NULL, 'HEPTAHELICAL TRANSMEMBRANE PROTEIN 2', 239391),
(303300, 'PTHR20855:SF118', NULL, NULL, NULL, NULL, 'BNAC09G37480D PROTEIN', 239391),
(303301, 'PTHR20855:SF15', NULL, NULL, NULL, NULL, 'PROGESTIN AND ADIPOQ RECEPTOR FAMILY MEMBER 3', 239391),
(303302, 'PTHR20855:SF133', NULL, NULL, NULL, NULL, 'PROGESTIN AND ADIPOQ RECEPTOR FAMILY MEMBER IIIB', 239391),
(303303, 'PTHR20855:SF134', NULL, NULL, NULL, NULL, '', 239391),
(303304, 'PTHR20855:SF35', NULL, NULL, NULL, NULL, '', 239391),
(303305, 'PTHR20855:SF113', NULL, NULL, NULL, NULL, 'HAEMOLYSIN-III RELATED FAMILY PROTEIN, EXPRESSED', 239391),
(303306, 'PTHR20855', NULL, NULL, NULL, NULL, 'ADIPOR/PROGESTIN RECEPTOR-RELATED', 239391),
(303307, 'PTHR20855:SF136', NULL, NULL, NULL, NULL, '', 239391),
(303308, 'PTHR20855:SF33', NULL, NULL, NULL, NULL, 'ADIPONECTIN RECEPTOR PROTEIN 2', 239391),
(303309, 'PTHR20855:SF41', NULL, NULL, NULL, NULL, 'MEMBRANE PROGESTIN RECEPTOR ALPHA', 239391),
(303310, 'PTHR20855:SF130', NULL, NULL, NULL, NULL, 'HAEMOLYSIN-III FAMILY PROTEIN', 239391),
(303311, 'PTHR20855:SF42', NULL, NULL, NULL, NULL, '', 239391),
(303312, 'PTHR20855:SF61', NULL, NULL, NULL, NULL, '', 239391),
(303313, 'PTHR20855:SF131', NULL, NULL, NULL, NULL, '', 239391),
(303314, 'PTHR20855:SF40', NULL, NULL, NULL, NULL, 'ADIPONECTIN RECEPTOR PROTEIN 1', 239391),
(303315, 'PTHR20855:SF132', NULL, NULL, NULL, NULL, 'HEMOLYSIN-III-LIKE PROTEIN', 239391),
(303316, 'PTHR20855:SF104', NULL, NULL, NULL, NULL, 'HEPTAHELICAL TRANSMEMBRANE PROTEIN 4-LIKE ISOFORM X1', 239391),
(303317, 'PTHR20855:SF27', NULL, NULL, NULL, NULL, '', 239391),
(303318, 'PTHR20855:SF127', NULL, NULL, NULL, NULL, 'PROGESTIN AND ADIPOQ RECEPTOR-LIKE PROTEIN 1', 239391),
(303319, 'PTHR20855:SF105', NULL, NULL, NULL, NULL, 'HAEMOLYSIN-III RELATED FAMILY PROTEIN, EXPRESSED', 239391),
(303320, 'PTHR20855:SF128', NULL, NULL, NULL, NULL, 'PAQR3A PROTEIN', 239391),
(303321, 'PTHR20855:SF107', NULL, NULL, NULL, NULL, 'MONOCYTE TO MACROPHAGE DIFFERENTIATION FACTOR 2', 239391),
(303322, 'PTHR20855:SF129', NULL, NULL, NULL, NULL, 'HEMOLYSIN-3 HOMOLOG', 239391),
(303323, 'PTHR20855:SF26', NULL, NULL, NULL, NULL, 'MONOCYTE TO MACROPHAGE DIFFERENTIATION FACTOR', 239391),
(303324, 'PTHR20855:SF122', NULL, NULL, NULL, NULL, 'BNAA03G54210D PROTEIN', 239391),
(303325, 'PTHR20855:SF100', NULL, NULL, NULL, NULL, 'HEPTAHELICAL TRANSMEMBRANE PROTEIN 2', 239391);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(303326, 'PTHR20855:SF123', NULL, NULL, NULL, NULL, 'BNAA03G51100D PROTEIN', 239391),
(303327, 'PTHR20855:SF124', NULL, NULL, NULL, NULL, 'BNAA09G41600D PROTEIN', 239391),
(303328, 'PTHR20855:SF22', NULL, NULL, NULL, NULL, 'MEMBRANE PROGESTIN RECEPTOR BETA', 239391),
(303329, 'PTHR20855:SF108', NULL, NULL, NULL, NULL, 'HEPTAHELICAL TRANSMEMBRANE PROTEIN 3', 239391),
(303330, 'PTHR20855:SF3', NULL, NULL, NULL, NULL, 'LD03007P', 239391),
(303331, 'PTHR20855:SF109', NULL, NULL, NULL, NULL, 'HEPTAHELICAL TRANSMEMBRANE PROTEIN 2-LIKE', 239391),
(303332, 'PTHR20855:SF52', NULL, NULL, NULL, NULL, 'ADIPONECTIN RECEPTOR PROTEIN', 239391),
(303333, 'PTHR20855:SF96', NULL, NULL, NULL, NULL, 'PROGESTIN AND ADIPOQ RECEPTOR FAMILY MEMBER VII, A', 239391),
(303334, 'PTHR20855:SF140', NULL, NULL, NULL, NULL, 'ADIPOR/HEMOLYSIN-III-RELATED PROTEIN-RELATED', 239391),
(303335, 'PTHR20855:SF97', NULL, NULL, NULL, NULL, 'ADIPOR-LIKE RECEPTOR IZH3-RELATED', 239391),
(303336, 'PTHR20855:SF120', NULL, NULL, NULL, NULL, 'BNAA02G04790D PROTEIN', 239391),
(303337, 'PTHR20855:SF121', NULL, NULL, NULL, NULL, 'ADIPOR/HEMOLYSIN-III-RELATED PROTEIN-RELATED', 239391),
(303338, 'PTHR20855:SF95', NULL, NULL, NULL, NULL, 'ADIPOR-LIKE RECEPTOR IZH1', 239391),
(303339, 'PTHR20855:SF92', NULL, NULL, NULL, NULL, 'PROTEIN CBG19039', 239391),
(303340, 'PTHR31980:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM220BP-RELATED', 239392),
(303341, 'PTHR31980:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAM220A', 239392),
(303342, 'PTHR31980', NULL, NULL, NULL, NULL, 'PROTEIN FAM220A', 239392),
(303343, 'PTHR12398:SF29', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE INHIBITOR 2 FAMILY MEMBER C', 239393),
(303344, 'PTHR12398:SF39', NULL, NULL, NULL, NULL, 'PROTEIN GLC8-LIKE ISOFORM X1', 239393),
(303345, 'PTHR12398:SF28', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE INHIBITOR 2-LIKE ISOFORM X1', 239393),
(303346, 'PTHR12398:SF40', NULL, NULL, NULL, NULL, 'PHOSPHOPROTEIN PHOSPHATASE INHIBITOR', 239393),
(303347, 'PTHR12398:SF8', NULL, NULL, NULL, NULL, 'RIKEN CDNA 2810408A11 GENE', 239393),
(303348, 'PTHR12398:SF38', NULL, NULL, NULL, NULL, 'PROTEIN GLC8-LIKE ISOFORM X1', 239393),
(303349, 'PTHR12398:SF27', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE INHIBITOR 2 FAMILY MEMBER B', 239393),
(303350, 'PTHR12398:SF26', NULL, NULL, NULL, NULL, '', 239393),
(303351, 'PTHR12398:SF25', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE INHIBITOR 2-LIKE', 239393),
(303352, 'PTHR12398:SF35', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE INHIBITOR 2-RELATED', 239393),
(303353, 'PTHR12398:SF24', NULL, NULL, NULL, NULL, 'OS02G0602300 PROTEIN', 239393),
(303354, 'PTHR12398:SF33', NULL, NULL, NULL, NULL, 'BNAA03G12720D PROTEIN', 239393),
(303355, 'PTHR12398', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE INHIBITOR', 239393),
(303356, 'PTHR12398:SF20', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1, REGULATORY (INHIBITOR) SUBUNIT 2', 239393),
(303357, 'PTHR39299', NULL, NULL, NULL, NULL, '', 239394),
(303358, 'PTHR39299:SF1', NULL, NULL, NULL, NULL, '', 239394),
(303359, 'PTHR30181', NULL, NULL, NULL, NULL, 'MANNITOL PERMEASE IIC COMPONENT', 239395),
(303360, 'PTHR30181:SF2', NULL, NULL, NULL, NULL, 'PTS SYSTEM MANNITOL-SPECIFIC EIICBA COMPONENT', 239395),
(303361, 'PTHR30181:SF3', NULL, NULL, NULL, NULL, 'MULTIPHOSPHORYL TRANSFER PROTEIN', 239395),
(303362, 'PTHR35495:SF4', NULL, NULL, NULL, NULL, 'OS04G0624701 PROTEIN', 239396),
(303363, 'PTHR35495:SF12', NULL, NULL, NULL, NULL, 'BNAA08G14240D PROTEIN', 239396),
(303364, 'PTHR35495:SF13', NULL, NULL, NULL, NULL, '', 239396),
(303365, 'PTHR35495:SF2', NULL, NULL, NULL, NULL, '', 239396),
(303366, 'PTHR35495:SF10', NULL, NULL, NULL, NULL, '', 239396),
(303367, 'PTHR35495:SF1', NULL, NULL, NULL, NULL, 'OS06G0679600 PROTEIN', 239396),
(303368, 'PTHR35495:SF7', NULL, NULL, NULL, NULL, 'OS02G0164400 PROTEIN', 239396),
(303369, 'PTHR35495', NULL, NULL, NULL, NULL, 'OS06G0679600 PROTEIN', 239396),
(303370, 'PTHR35495:SF9', NULL, NULL, NULL, NULL, '', 239396),
(303371, 'PTHR11452:SF37', NULL, NULL, NULL, NULL, 'ALPHA-GALACTOSIDASE', 239397); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(303372, 'PTHR11452:SF79', NULL, NULL, NULL, NULL, 'ALPHA-GALACTOSIDASE', 239397),
(303373, 'PTHR11452:SF25', NULL, NULL, NULL, NULL, 'ALPHA-N-ACETYLGALACTOSAMINIDASE', 239397),
(303374, 'PTHR11452:SF36', NULL, NULL, NULL, NULL, 'ALPHA-GALACTOSIDASE', 239397),
(303375, 'PTHR11452:SF14', NULL, NULL, NULL, NULL, 'ALPHA-GALACTOSIDASE A', 239397),
(303376, 'PTHR11452:SF66', NULL, NULL, NULL, NULL, 'ALPHA-GALACTOSIDASE', 239397),
(303377, 'PTHR11452:SF33', NULL, NULL, NULL, NULL, 'ALPHA-GALACTOSIDASE 2', 239397),
(303378, 'PTHR11452:SF88', NULL, NULL, NULL, NULL, 'ALPHA-GALACTOSIDASE', 239397),
(303379, 'PTHR11452:SF89', NULL, NULL, NULL, NULL, 'ALPHA-GALACTOSIDASE', 239397),
(303380, 'PTHR11452:SF42', NULL, NULL, NULL, NULL, 'ALPHA-GALACTOSIDASE', 239397),
(303381, 'PTHR11452:SF75', NULL, NULL, NULL, NULL, 'ALPHA-GALACTOSIDASE MEL1', 239397),
(303382, 'PTHR11452:SF86', NULL, NULL, NULL, NULL, 'ALPHA-GALACTOSIDASE', 239397),
(303383, 'PTHR11452:SF76', NULL, NULL, NULL, NULL, 'ALPHA-GALACTOSIDASE', 239397),
(303384, 'PTHR11452:SF87', NULL, NULL, NULL, NULL, 'ALPHA-GALACTOSIDASE', 239397),
(303385, 'PTHR11452:SF73', NULL, NULL, NULL, NULL, 'ALPHA-GALACTOSIDASE', 239397),
(303386, 'PTHR11452:SF84', NULL, NULL, NULL, NULL, 'ALPHA-GALACTOSIDASE', 239397),
(303387, 'PTHR11452:SF85', NULL, NULL, NULL, NULL, 'ALPHA-GALACTOSIDASE 8-RELATED', 239397),
(303388, 'PTHR11452:SF71', NULL, NULL, NULL, NULL, 'ALPHA-GALACTOSIDASE', 239397),
(303389, 'PTHR11452:SF72', NULL, NULL, NULL, NULL, 'ALPHA-GALACTOSIDASE', 239397),
(303390, 'PTHR11452:SF61', NULL, NULL, NULL, NULL, 'ALPHA-GALACTOSIDASE B-RELATED', 239397),
(303391, 'PTHR11452:SF83', NULL, NULL, NULL, NULL, 'ALPHA-GALACTOSIDASE', 239397),
(303392, 'PTHR11452:SF80', NULL, NULL, NULL, NULL, 'ALPHA-GALACTOSIDASE 1', 239397),
(303393, 'PTHR11452', NULL, NULL, NULL, NULL, 'ALPHA-GALACTOSIDASE/ALPHA-N-ACETYLGALACTOSAMINIDASE', 239397),
(303394, 'PTHR21299:SF2', NULL, NULL, NULL, NULL, 'CYTIDYLATE KINASE', 239398),
(303395, 'PTHR21299', NULL, NULL, NULL, NULL, 'CYTIDYLATE KINASE/PANTOATE-BETA-ALANINE LIGASE', 239398),
(303396, 'PTHR21299:SF1', NULL, NULL, NULL, NULL, 'PANTOATE--BETA-ALANINE LIGASE', 239398),
(303397, 'PTHR33750:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG00704', 239399),
(303398, 'PTHR33750:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG02727', 239399),
(303399, 'PTHR33750', NULL, NULL, NULL, NULL, 'PROTEIN CBG02727', 239399),
(303400, 'PTHR45659:SF20', NULL, NULL, NULL, NULL, 'HOMEOBOX C6-RELATED', 239400),
(303401, 'PTHR45659:SF10', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-A5', 239400),
(303402, 'PTHR45659', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX', 239400),
(303403, 'PTHR45659:SF11', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-B7', 239400),
(303404, 'PTHR45659:SF12', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-A7', 239400),
(303405, 'PTHR45659:SF14', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-A6', 239400),
(303406, 'PTHR45659:SF1', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-C6', 239400),
(303407, 'PTHR45659:SF2', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-B5', 239400),
(303408, 'PTHR45659:SF19', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN EGL-5', 239400),
(303409, 'PTHR45659:SF5', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-C5', 239400),
(303410, 'PTHR45659:SF4', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN ABDOMINAL-A-RELATED', 239400),
(303411, 'PTHR45659:SF9', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-B6', 239400),
(303412, 'PTHR46348:SF1', NULL, NULL, NULL, NULL, 'DELETED IN LUNG AND ESOPHAGEAL CANCER PROTEIN 1', 239401),
(303413, 'PTHR46348', NULL, NULL, NULL, NULL, 'DELETED IN LUNG AND ESOPHAGEAL CANCER PROTEIN 1', 239401),
(303414, 'PTHR24333:SF8', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN CEH-62', 239402),
(303415, 'PTHR24333:SF9', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 239402),
(303416, 'PTHR24333:SF7', NULL, NULL, NULL, NULL, 'PROBOSCIPEDIA', 239402),
(303417, 'PTHR24333:SF5', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 239402),
(303418, 'PTHR24333:SF10', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 239402);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(303419, 'PTHR24333', NULL, NULL, NULL, NULL, 'HOMEO BOX HB9 LIKE A-RELATED', 239402),
(303420, 'PTHR10379:SF13', NULL, NULL, NULL, NULL, 'PROTEIN CBFA2T2', 239403),
(303421, 'PTHR10379', NULL, NULL, NULL, NULL, 'MTG8 ETO  EIGHT TWENTY ONE PROTEIN', 239403),
(303422, 'PTHR10379:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBFA2T3', 239403),
(303423, 'PTHR10379:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBFA2T1', 239403),
(303424, 'PTHR10379:SF14', NULL, NULL, NULL, NULL, 'NERVY, ISOFORM D', 239403),
(303425, 'PTHR35106:SF1', NULL, NULL, NULL, NULL, 'BNAA07G25190D PROTEIN', 239404),
(303426, 'PTHR35106:SF5', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 239404),
(303427, 'PTHR35106:SF4', NULL, NULL, NULL, NULL, 'OS09G0485800 PROTEIN', 239404),
(303428, 'PTHR35106', NULL, NULL, NULL, NULL, 'BNAA07G25190D PROTEIN', 239404),
(303429, 'PTHR28076:SF1', NULL, NULL, NULL, NULL, 'SPORULATION-SPECIFIC PROTEIN 71', 239405),
(303430, 'PTHR28076', NULL, NULL, NULL, NULL, 'SPORULATION-SPECIFIC PROTEIN 71', 239405),
(303431, 'PTHR21530:SF5', NULL, NULL, NULL, NULL, '', 239406),
(303432, 'PTHR21530:SF7', NULL, NULL, NULL, NULL, 'TRAB DOMAIN-CONTAINING PROTEIN', 239406),
(303433, 'PTHR21530:SF10', NULL, NULL, NULL, NULL, 'BNAA10G03300D PROTEIN', 239406),
(303434, 'PTHR21530:SF0', NULL, NULL, NULL, NULL, 'TRAB FAMILY PROTEIN', 239406),
(303435, 'PTHR21530:SF14', NULL, NULL, NULL, NULL, 'TRAB DOMAIN-CONTAINING PROTEIN-LIKE', 239406),
(303436, 'PTHR21530:SF13', NULL, NULL, NULL, NULL, 'BNAC03G71970D PROTEIN', 239406),
(303437, 'PTHR21530:SF12', NULL, NULL, NULL, NULL, 'BNAA05G10800D PROTEIN', 239406),
(303438, 'PTHR21530:SF9', NULL, NULL, NULL, NULL, 'BNAC08G44160D PROTEIN', 239406),
(303439, 'PTHR21530:SF16', NULL, NULL, NULL, NULL, '', 239406),
(303440, 'PTHR21530', NULL, NULL, NULL, NULL, 'PHEROMONE SHUTDOWN PROTEIN', 239406),
(303441, 'PTHR21530:SF15', NULL, NULL, NULL, NULL, '', 239406),
(303442, 'PTHR21007', NULL, NULL, NULL, NULL, 'LIVER EXPRESSED ANTIMICROBIAL PEPTIDE 2', 239407),
(303443, 'PTHR21007:SF4', NULL, NULL, NULL, NULL, 'LIVER-EXPRESSED ANTIMICROBIAL PEPTIDE 2', 239407),
(303444, 'PTHR21007:SF1', NULL, NULL, NULL, NULL, 'LIVER-EXPRESSED ANTIMICROBIAL PEPTIDE 2', 239407),
(303445, 'PTHR11410:SF0', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT A', 239408),
(303446, 'PTHR11410', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT A', 239408),
(303447, 'PTHR11782:SF120', NULL, NULL, NULL, NULL, 'PHOSPHATASE, PUTATIVE-RELATED', 239409),
(303448, 'PTHR11782:SF122', NULL, NULL, NULL, NULL, '', 239409),
(303449, 'PTHR11782:SF100', NULL, NULL, NULL, NULL, 'APYRASE 3-RELATED', 239409),
(303450, 'PTHR11782:SF121', NULL, NULL, NULL, NULL, 'NUCLEOSIDE-DIPHOSPHATASE MIG-23', 239409),
(303451, 'PTHR11782:SF106', NULL, NULL, NULL, NULL, 'ATP-DIPHOSPHATASE', 239409),
(303452, 'PTHR11782:SF107', NULL, NULL, NULL, NULL, 'APYRASE-LIKE PROTEIN', 239409),
(303453, 'PTHR11782:SF124', NULL, NULL, NULL, NULL, 'APYRASE-LIKE', 239409),
(303454, 'PTHR11782:SF102', NULL, NULL, NULL, NULL, 'DIPHOSPHATASE, PUTATIVE-RELATED', 239409),
(303455, 'PTHR11782:SF123', NULL, NULL, NULL, NULL, 'GDA1/CD39 FAMILY PROTEIN, EXPRESSED', 239409),
(303456, 'PTHR11782:SF104', NULL, NULL, NULL, NULL, 'NUCLEOSIDE PHOSPHATASE GDA1/CD39-RELATED', 239409),
(303457, 'PTHR11782:SF125', NULL, NULL, NULL, NULL, 'APYRASE 7-RELATED', 239409),
(303458, 'PTHR11782:SF96', NULL, NULL, NULL, NULL, 'APYRASE 6-RELATED', 239409),
(303459, 'PTHR11782:SF92', NULL, NULL, NULL, NULL, 'GDA1/CD39 NUCLEOSIDE PHOSPHATASE FAMILY PROTEIN', 239409),
(303460, 'PTHR11782:SF35', NULL, NULL, NULL, NULL, 'ECTONUCLEOSIDE TRIPHOSPHATE DIPHOSPHOHYDROLASE 5', 239409),
(303461, 'PTHR11782:SF79', NULL, NULL, NULL, NULL, 'OS08G0436100 PROTEIN', 239409),
(303462, 'PTHR11782:SF37', NULL, NULL, NULL, NULL, 'ECTONUCLEOSIDE TRIPHOSPHATE DIPHOSPHOHYDROLASE 7', 239409),
(303463, 'PTHR11782:SF38', NULL, NULL, NULL, NULL, 'ECTONUCLEOSIDE TRIPHOSPHATE DIPHOSPHOHYDROLASE 3', 239409),
(303464, 'PTHR11782:SF31', NULL, NULL, NULL, NULL, 'ECTONUCLEOSIDE TRIPHOSPHATE DIPHOSPHOHYDROLASE 8', 239409),
(303465, 'PTHR11782:SF97', NULL, NULL, NULL, NULL, 'APYRASE 1-LIKE', 239409);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(303466, 'PTHR11782:SF32', NULL, NULL, NULL, NULL, 'ECTONUCLEOSIDE TRIPHOSPHATE DIPHOSPHOHYDROLASE 1', 239409),
(303467, 'PTHR11782:SF33', NULL, NULL, NULL, NULL, 'ECTONUCLEOSIDE TRIPHOSPHATE DIPHOSPHOHYDROLASE 2', 239409),
(303468, 'PTHR11782:SF99', NULL, NULL, NULL, NULL, 'ECTONUCLEOSIDE TRIPHOSPHATE DIPHOSPHOHYDROLASE 6', 239409),
(303469, 'PTHR11782:SF3', NULL, NULL, NULL, NULL, 'NTPASE, ISOFORM F', 239409),
(303470, 'PTHR11782:SF111', NULL, NULL, NULL, NULL, 'APYRASE 3', 239409),
(303471, 'PTHR11782:SF110', NULL, NULL, NULL, NULL, 'ATP-DIPHOSPHATASE', 239409),
(303472, 'PTHR11782:SF29', NULL, NULL, NULL, NULL, 'ECTONUCLEOSIDE TRIPHOSPHATE DIPHOSPHOHYDROLASE 4', 239409),
(303473, 'PTHR11782:SF117', NULL, NULL, NULL, NULL, 'ECTONUCLEOSIDE TRIPHOSPHATE DIPHOSPHOHYDROLASE 8', 239409),
(303474, 'PTHR11782:SF116', NULL, NULL, NULL, NULL, 'NUCLEOSIDE PHOSPHATASE GDA1/CD39-RELATED', 239409),
(303475, 'PTHR11782:SF119', NULL, NULL, NULL, NULL, '', 239409),
(303476, 'PTHR11782:SF113', NULL, NULL, NULL, NULL, 'ATP-DIPHOSPHATASE', 239409),
(303477, 'PTHR11782:SF112', NULL, NULL, NULL, NULL, 'NUCLEOSIDE-TRIPHOSPHATASE NTP-1', 239409),
(303478, 'PTHR11782:SF115', NULL, NULL, NULL, NULL, 'GDA1/CD39 NUCLEOSIDE PHOSPHATASE FAMILY PROTEIN', 239409),
(303479, 'PTHR11782:SF82', NULL, NULL, NULL, NULL, 'APYRASE 3-RELATED', 239409),
(303480, 'PTHR11782:SF83', NULL, NULL, NULL, NULL, 'APYRASE 1', 239409),
(303481, 'PTHR11782:SF84', NULL, NULL, NULL, NULL, '', 239409),
(303482, 'PTHR11782:SF80', NULL, NULL, NULL, NULL, 'GDA1/CD39 NUCLEOSIDE PHOSPHATASE FAMILY PROTEIN', 239409),
(303483, 'PTHR11782:SF81', NULL, NULL, NULL, NULL, '', 239409),
(303484, 'PTHR11782:SF48', NULL, NULL, NULL, NULL, 'APYRASE 2-RELATED', 239409),
(303485, 'PTHR11782:SF86', NULL, NULL, NULL, NULL, 'APYRASE 1', 239409),
(303486, 'PTHR11782:SF87', NULL, NULL, NULL, NULL, 'APYRASE', 239409),
(303487, 'PTHR11782:SF88', NULL, NULL, NULL, NULL, 'APYRASE FAMILY PROTEIN-RELATED', 239409),
(303488, 'PTHR11782', NULL, NULL, NULL, NULL, 'ADENOSINE/GUANOSINE DIPHOSPHATASE', 239409),
(303489, 'PTHR11782:SF89', NULL, NULL, NULL, NULL, 'APYRASE 2', 239409),
(303490, 'PTHR43073:SF3', NULL, NULL, NULL, NULL, 'DIHYDROTHYMINE DEHYDROGENASE', 239410),
(303491, 'PTHR43073:SF2', NULL, NULL, NULL, NULL, 'DIHYDROPYRIMIDINE DEHYDROGENASE [NADP(+)]', 239410),
(303492, 'PTHR43073', NULL, NULL, NULL, NULL, 'DIHYDROPYRIMIDINE DEHYDROGENASE [NADP(+)]', 239410),
(303493, 'PTHR41773:SF1', NULL, NULL, NULL, NULL, 'RELA_SPOT DOMAIN-CONTAINING PROTEIN', 239411),
(303494, 'PTHR41773', NULL, NULL, NULL, NULL, 'GTP PYROPHOSPHATASE-RELATED', 239411),
(303495, 'PTHR30487', NULL, NULL, NULL, NULL, 'TYPE 4 PREPILIN-LIKE PROTEINS LEADER PEPTIDE-PROCESSING ENZYME', 239412),
(303496, 'PTHR30487:SF0', NULL, NULL, NULL, NULL, 'PREPILIN LEADER PEPTIDASE/N-METHYLTRANSFERASE-RELATED', 239412),
(303497, 'PTHR12394', NULL, NULL, NULL, NULL, 'ZYGIN', 239413),
(303498, 'PTHR12394:SF4', NULL, NULL, NULL, NULL, 'FASCICULATION AND ELONGATION PROTEIN ZETA-1', 239413),
(303499, 'PTHR12394:SF11', NULL, NULL, NULL, NULL, 'FASCICULATION AND ELONGATION PROTEIN ZETA-2', 239413),
(303500, 'PTHR12394:SF12', NULL, NULL, NULL, NULL, 'LD08195P', 239413),
(303501, 'PTHR13084', NULL, NULL, NULL, NULL, 'T-CELL LYMPHOMA BREAKPOINT-ASSOCIATED TARGET 1-RELATED', 239414),
(303502, 'PTHR13084:SF5', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM-TRANSPORTING ATPASE SUBUNIT BETA-1-INTERACTING PROTEIN 4', 239414),
(303503, 'PTHR13084:SF6', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM-TRANSPORTING ATPASE SUBUNIT BETA-1-INTERACTING PROTEIN', 239414),
(303504, 'PTHR13084:SF7', NULL, NULL, NULL, NULL, 'ZGC:100920', 239414),
(303505, 'PTHR13084:SF2', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM-TRANSPORTING ATPASE SUBUNIT BETA-1-INTERACTING PROTEIN 3', 239414),
(303506, 'PTHR13084:SF3', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM-TRANSPORTING ATPASE SUBUNIT BETA-1-INTERACTING PROTEIN 2', 239414),
(303507, 'PTHR13084:SF4', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM-TRANSPORTING ATPASE SUBUNIT BETA-1-INTERACTING PROTEIN 1', 239414);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(303508, 'PTHR36460:SF1', NULL, NULL, NULL, NULL, 'UPF0132 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_3G10255)', 239415),
(303509, 'PTHR36460', NULL, NULL, NULL, NULL, 'UPF0132 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_3G10255)', 239415),
(303510, 'PTHR45686:SF10', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN 2', 239416),
(303511, 'PTHR45686:SF4', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE ACTIVATING PROTEIN 3, ISOFORM H', 239416),
(303512, 'PTHR45686:SF19', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN AGD10', 239416),
(303513, 'PTHR45686:SF1', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN 3', 239416),
(303514, 'PTHR45686:SF26', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN AGD8-RELATED', 239416),
(303515, 'PTHR45686:SF18', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN GCS1', 239416),
(303516, 'PTHR45686', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE ACTIVATING PROTEIN 3, ISOFORM H-RELATED', 239416),
(303517, 'PTHR45686:SF23', NULL, NULL, NULL, NULL, 'ARF-GAP DOMAIN-CONTAINING PROTEIN', 239416),
(303518, 'PTHR45686:SF11', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN AGD8-RELATED', 239416),
(303519, 'PTHR45686:SF25', NULL, NULL, NULL, NULL, 'ACTIVATING PROTEIN, PUTATIVE, EXPRESSED-RELATED', 239416),
(303520, 'PTHR45686:SF24', NULL, NULL, NULL, NULL, 'FACTOR GTPASE ACTIVATING PROTEIN, PUTATIVE-RELATED', 239416),
(303521, 'PTHR45631:SF198', NULL, NULL, NULL, NULL, '', 239417),
(303522, 'PTHR45631:SF155', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303523, 'PTHR45631:SF59', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303524, 'PTHR45631:SF112', NULL, NULL, NULL, NULL, 'OS09G0355400 PROTEIN', 239417),
(303525, 'PTHR45631:SF156', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303526, 'PTHR45631:SF157', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE-RELATED', 239417),
(303527, 'PTHR45631:SF158', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE-RELATED', 239417),
(303528, 'PTHR45631:SF114', NULL, NULL, NULL, NULL, 'OS05G0525800 PROTEIN', 239417),
(303529, 'PTHR45631:SF159', NULL, NULL, NULL, NULL, 'REPEAT FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 239417),
(303530, 'PTHR45631:SF58', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303531, 'PTHR45631:SF57', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 239417),
(303532, 'PTHR45631:SF190', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303533, 'PTHR45631:SF191', NULL, NULL, NULL, NULL, 'DI-GLUCOSE BINDING PROTEIN WITH LEUCINE-RICH REPEAT DOMAIN-CONTAINING PROTEIN', 239417),
(303534, 'PTHR45631:SF95', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303535, 'PTHR45631:SF192', NULL, NULL, NULL, NULL, 'MALECTIN-LIKE CARBOHYDRATE-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 239417),
(303536, 'PTHR45631:SF193', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303537, 'PTHR45631:SF97', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 239417),
(303538, 'PTHR45631:SF194', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303539, 'PTHR45631:SF151', NULL, NULL, NULL, NULL, 'MALECTIN_LIKE DOMAIN-CONTAINING PROTEIN', 239417),
(303540, 'PTHR45631:SF91', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303541, 'PTHR45631:SF195', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT TRANSMEMBRANE PROTEIN KINASE PROTEIN', 239417),
(303542, 'PTHR45631:SF196', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 239417),
(303543, 'PTHR45631:SF94', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303544, 'PTHR45631:SF197', NULL, NULL, NULL, NULL, 'TYROSINE KINASE FAMILY PROTEIN', 239417);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(303545, 'PTHR45631:SF8', NULL, NULL, NULL, NULL, 'OS12G0567500 PROTEIN', 239417),
(303546, 'PTHR45631:SF6', NULL, NULL, NULL, NULL, 'OS09G0356800 PROTEIN', 239417),
(303547, 'PTHR45631:SF3', NULL, NULL, NULL, NULL, 'OS05G0393100 PROTEIN', 239417),
(303548, 'PTHR45631:SF118', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303549, 'PTHR45631:SF19', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303550, 'PTHR45631:SF165', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303551, 'PTHR45631:SF48', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 239417),
(303552, 'PTHR45631:SF166', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN-RELATED', 239417),
(303553, 'PTHR45631:SF167', NULL, NULL, NULL, NULL, 'MALECTIN_LIKE DOMAIN-CONTAINING PROTEIN', 239417),
(303554, 'PTHR45631:SF168', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303555, 'PTHR45631:SF124', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 239417),
(303556, 'PTHR45631:SF169', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303557, 'PTHR45631:SF45', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT (LRR) FAMILY PROTEIN', 239417),
(303558, 'PTHR45631:SF44', NULL, NULL, NULL, NULL, 'MALECTIN_LIKE DOMAIN-CONTAINING PROTEIN', 239417),
(303559, 'PTHR45631:SF41', NULL, NULL, NULL, NULL, 'SENESCENCE-INDUCED RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239417),
(303560, 'PTHR45631:SF160', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303561, 'PTHR45631:SF86', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 239417),
(303562, 'PTHR45631:SF161', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303563, 'PTHR45631:SF162', NULL, NULL, NULL, NULL, 'MALECTIN_LIKE DOMAIN-CONTAINING PROTEIN', 239417),
(303564, 'PTHR45631:SF163', NULL, NULL, NULL, NULL, 'KINASE-TRANSFORMING PROTEIN RAF, PUTATIVE-RELATED', 239417),
(303565, 'PTHR45631:SF82', NULL, NULL, NULL, NULL, 'PROTEIN KINASE FAMILY PROTEIN', 239417),
(303566, 'PTHR45631:SF164', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303567, 'PTHR45631:SF120', NULL, NULL, NULL, NULL, 'KINASE-LIKE PROTEIN-RELATED', 239417),
(303568, 'PTHR45631:SF176', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303569, 'PTHR45631:SF177', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303570, 'PTHR45631:SF133', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303571, 'PTHR45631:SF178', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303572, 'PTHR45631:SF135', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 239417),
(303573, 'PTHR45631:SF179', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303574, 'PTHR45631:SF77', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303575, 'PTHR45631:SF33', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303576, 'PTHR45631:SF138', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303577, 'PTHR45631:SF170', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303578, 'PTHR45631:SF31', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303579, 'PTHR45631:SF171', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303580, 'PTHR45631:SF75', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303581, 'PTHR45631:SF172', NULL, NULL, NULL, NULL, 'MALECTIN_LIKE DOMAIN-CONTAINING PROTEIN', 239417),
(303582, 'PTHR45631', NULL, NULL, NULL, NULL, 'OS07G0107800 PROTEIN-RELATED', 239417),
(303583, 'PTHR45631:SF70', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303584, 'PTHR45631:SF173', NULL, NULL, NULL, NULL, 'OS07G0107800 PROTEIN', 239417);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(303585, 'PTHR45631:SF174', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303586, 'PTHR45631:SF175', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303587, 'PTHR45631:SF27', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE MEE39-RELATED', 239417),
(303588, 'PTHR45631:SF143', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE', 239417),
(303589, 'PTHR45631:SF187', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303590, 'PTHR45631:SF188', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303591, 'PTHR45631:SF144', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-KINASE-RELATED', 239417),
(303592, 'PTHR45631:SF189', NULL, NULL, NULL, NULL, 'OS05G0525600 PROTEIN', 239417),
(303593, 'PTHR45631:SF29', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303594, 'PTHR45631:SF66', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303595, 'PTHR45631:SF148', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303596, 'PTHR45631:SF22', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE PAM74-RELATED', 239417),
(303597, 'PTHR45631:SF69', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 239417),
(303598, 'PTHR45631:SF68', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 239417),
(303599, 'PTHR45631:SF180', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303600, 'PTHR45631:SF181', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 4', 239417),
(303601, 'PTHR45631:SF21', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303602, 'PTHR45631:SF182', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303603, 'PTHR45631:SF183', NULL, NULL, NULL, NULL, 'BNAC02G06920D PROTEIN', 239417),
(303604, 'PTHR45631:SF184', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239417),
(303605, 'PTHR45631:SF185', NULL, NULL, NULL, NULL, 'LRR DI-GLUCOSE-BINDING PROTEIN', 239417),
(303606, 'PTHR45631:SF141', NULL, NULL, NULL, NULL, 'ER PROTEIN CARBOHYDRATE-BINDING PROTEIN', 239417),
(303607, 'PTHR45631:SF186', NULL, NULL, NULL, NULL, 'MALECTIN_LIKE DOMAIN-CONTAINING PROTEIN', 239417),
(303608, 'PTHR45631:SF107', NULL, NULL, NULL, NULL, 'BNAANNG03040D PROTEIN', 239417),
(303609, 'PTHR45631:SF109', NULL, NULL, NULL, NULL, 'BNAA08G28390D PROTEIN', 239417),
(303610, 'PTHR40398:SF1', NULL, NULL, NULL, NULL, 'PTS SYSTEM GLUCITOL/SORBITOL-SPECIFIC EIIA COMPONENT', 239418),
(303611, 'PTHR40398', NULL, NULL, NULL, NULL, 'PTS SYSTEM GLUCITOL/SORBITOL-SPECIFIC EIIA COMPONENT', 239418),
(303612, 'PTHR36594', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 239419),
(303613, 'PTHR36594:SF1', NULL, NULL, NULL, NULL, 'METACASPASE-3', 239419),
(303614, 'PTHR47534:SF3', NULL, NULL, NULL, NULL, 'ADH_ZINC_N DOMAIN-CONTAINING PROTEIN', 239420),
(303615, 'PTHR47534:SF2', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE AN1596', 239420),
(303616, 'PTHR47534', NULL, NULL, NULL, NULL, 'YALI0E05731P', 239420),
(303617, 'PTHR10755:SF9', NULL, NULL, NULL, NULL, 'COPROPORPHYRINOGEN OXIDASE', 239421),
(303618, 'PTHR10755:SF3', NULL, NULL, NULL, NULL, 'COPROPORPHYRINOGEN OXIDASE', 239421),
(303619, 'PTHR10755', NULL, NULL, NULL, NULL, 'COPROPORPHYRINOGEN III OXIDASE, MITOCHONDRIAL', 239421),
(303620, 'PTHR10755:SF0', NULL, NULL, NULL, NULL, 'OXYGEN-DEPENDENT COPROPORPHYRINOGEN-III OXIDASE, MITOCHONDRIAL', 239421),
(303621, 'PTHR10755:SF10', NULL, NULL, NULL, NULL, 'COPROPORPHYRINOGEN OXIDASE', 239421),
(303622, 'PTHR31518', NULL, NULL, NULL, NULL, 'ARGININE/SERINE-RICH PROTEIN PNISR', 239422),
(303623, 'PTHR31518:SF3', NULL, NULL, NULL, NULL, 'ARGININE/SERINE-RICH PROTEIN PNISR', 239422),
(303624, 'PTHR28199', NULL, NULL, NULL, NULL, 'PROCESSING OF GAS1 AND ALP PROTEIN 2', 239423),
(303625, 'PTHR28199:SF1', NULL, NULL, NULL, NULL, 'PROCESSING OF GAS1 AND ALP PROTEIN 2', 239423);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(303626, 'PTHR43981:SF9', NULL, NULL, NULL, NULL, 'ENOYL-[ACYL-CARRIER-PROTEIN] REDUCTASE, MITOCHONDRIAL', 239424),
(303627, 'PTHR43981:SF8', NULL, NULL, NULL, NULL, 'TRANS-2-ENOYL-COA REDUCTASE, MITOCHONDRIAL-RELATED', 239424),
(303628, 'PTHR43981:SF7', NULL, NULL, NULL, NULL, 'TRANS-2-ENOYL-COA REDUCTASE, MITOCHONDRIAL-RELATED', 239424),
(303629, 'PTHR43981:SF6', NULL, NULL, NULL, NULL, 'TRANS-2-ENOYL-COA REDUCTASE, MITOCHONDRIAL-RELATED', 239424),
(303630, 'PTHR43981:SF5', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 239424),
(303631, 'PTHR43981:SF4', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 239424),
(303632, 'PTHR43981:SF2', NULL, NULL, NULL, NULL, 'ENOYL-[ACYL-CARRIER-PROTEIN] REDUCTASE, MITOCHONDRIAL', 239424),
(303633, 'PTHR43981', NULL, NULL, NULL, NULL, 'ENOYL-[ACYL-CARRIER-PROTEIN] REDUCTASE, MITOCHONDRIAL', 239424),
(303634, 'PTHR43981:SF1', NULL, NULL, NULL, NULL, 'ENOYL-[ACYL-CARRIER-PROTEIN] REDUCTASE, MITOCHONDRIAL', 239424),
(303635, 'PTHR12286:SF8', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 239425),
(303636, 'PTHR12286:SF9', NULL, NULL, NULL, NULL, 'SACCHRP_DH_NADP DOMAIN-CONTAINING PROTEIN', 239425),
(303637, 'PTHR12286', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239425),
(303638, 'PTHR12286:SF10', NULL, NULL, NULL, NULL, '', 239425),
(303639, 'PTHR12286:SF5', NULL, NULL, NULL, NULL, 'SACCHAROPINE DEHYDROGENASE-LIKE OXIDOREDUCTASE', 239425),
(303640, 'PTHR12286:SF7', NULL, NULL, NULL, NULL, 'SACCHRP_DH_NADP DOMAIN-CONTAINING PROTEIN', 239425),
(303641, 'PTHR13409', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 39S RIBOSOMAL PROTEIN L51', 239426),
(303642, 'PTHR13409:SF0', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L51, MITOCHONDRIAL', 239426),
(303643, 'PTHR35587:SF1', NULL, NULL, NULL, NULL, '', 239427),
(303644, 'PTHR35587:SF4', NULL, NULL, NULL, NULL, '', 239427),
(303645, 'PTHR35587:SF3', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239427),
(303646, 'PTHR35587:SF5', NULL, NULL, NULL, NULL, '', 239427),
(303647, 'PTHR35587', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239427),
(303648, 'PTHR36026:SF4', NULL, NULL, NULL, NULL, 'OS01G0705500 PROTEIN', 239428),
(303649, 'PTHR36026:SF5', NULL, NULL, NULL, NULL, '', 239428),
(303650, 'PTHR36026:SF6', NULL, NULL, NULL, NULL, 'BNAA04G27200D PROTEIN', 239428),
(303651, 'PTHR36026', NULL, NULL, NULL, NULL, 'OS05G0542100 PROTEIN', 239428),
(303652, 'PTHR36026:SF1', NULL, NULL, NULL, NULL, 'OS05G0542100 PROTEIN', 239428),
(303653, 'PTHR45857', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 239429),
(303654, 'PTHR45857:SF1', NULL, NULL, NULL, NULL, 'FORMIN-LIKE 2B', 239429),
(303655, 'PTHR45857:SF4', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 239429),
(303656, 'PTHR45857:SF5', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN 2', 239429),
(303657, 'PTHR45857:SF2', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN 1', 239429),
(303658, 'PTHR45857:SF3', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN 3', 239429),
(303659, 'PTHR45857:SF8', NULL, NULL, NULL, NULL, 'FORMIN-HOMOLOGY AND ZINC FINGER DOMAINS PROTEIN 1', 239429),
(303660, 'PTHR45857:SF9', NULL, NULL, NULL, NULL, 'MULTIPLE WING HAIRS, ISOFORM C', 239429),
(303661, 'PTHR37422:SF13', NULL, NULL, NULL, NULL, 'SLR1515 PROTEIN', 239430),
(303662, 'PTHR37422:SF15', NULL, NULL, NULL, NULL, 'SLR0728 PROTEIN', 239430),
(303663, 'PTHR37422:SF17', NULL, NULL, NULL, NULL, 'TEICHURONIC ACID BIOSYNTHESIS PROTEIN TUAE', 239430),
(303664, 'PTHR37422', NULL, NULL, NULL, NULL, 'TEICHURONIC ACID BIOSYNTHESIS PROTEIN TUAE', 239430),
(303665, 'PTHR37422:SF16', NULL, NULL, NULL, NULL, 'O-ANTIGEN LIGASE', 239430),
(303666, 'PTHR37422:SF19', NULL, NULL, NULL, NULL, 'SLL0737 PROTEIN', 239430),
(303667, 'PTHR37422:SF18', NULL, NULL, NULL, NULL, 'O-ANTIGEN LIGASE', 239430),
(303668, 'PTHR43643:SF3', NULL, NULL, NULL, NULL, 'HISTIDINOL-PHOSPHATE AMINOTRANSFERASE', 239431),
(303669, 'PTHR43643', NULL, NULL, NULL, NULL, 'HISTIDINOL-PHOSPHATE AMINOTRANSFERASE 2', 239431),
(303670, 'PTHR43643:SF2', NULL, NULL, NULL, NULL, 'INDUCIBLE LYSINE DECARBOXYLASE', 239431);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(303671, 'PTHR43643:SF5', NULL, NULL, NULL, NULL, 'CONSTITUTIVE LYSINE DECARBOXYLASE', 239431),
(303672, 'PTHR43643:SF6', NULL, NULL, NULL, NULL, 'HISTIDINOL-PHOSPHATE AMINOTRANSFERASE', 239431),
(303673, 'PTHR48185:SF1', NULL, NULL, NULL, NULL, 'BNACNNG12700D PROTEIN', 239432),
(303674, 'PTHR48185', NULL, NULL, NULL, NULL, 'BNACNNG12700D PROTEIN', 239432),
(303675, 'PTHR46703', NULL, NULL, NULL, NULL, '', 239433),
(303676, 'PTHR46703:SF1', NULL, NULL, NULL, NULL, '', 239433),
(303677, 'PTHR31344:SF0', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP205', 239434),
(303678, 'PTHR31344:SF23', NULL, NULL, NULL, NULL, 'C2 NT-TYPE DOMAIN-CONTAINING PROTEIN', 239434),
(303679, 'PTHR31344:SF11', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN GAR2-LIKE PROTEIN', 239434),
(303680, 'PTHR31344:SF21', NULL, NULL, NULL, NULL, 'OS09G0487200 PROTEIN', 239434),
(303681, 'PTHR31344:SF10', NULL, NULL, NULL, NULL, 'NUCLEOLAR-LIKE PROTEIN', 239434),
(303682, 'PTHR31344:SF20', NULL, NULL, NULL, NULL, 'DILUTE DOMAIN-CONTAINING PROTEIN', 239434),
(303683, 'PTHR31344:SF15', NULL, NULL, NULL, NULL, 'EEIG1/EHBP1 PROTEIN AMINO-TERMINAL DOMAIN PROTEIN', 239434),
(303684, 'PTHR31344:SF14', NULL, NULL, NULL, NULL, 'NUCLEOLAR-LIKE PROTEIN', 239434),
(303685, 'PTHR31344:SF24', NULL, NULL, NULL, NULL, 'C2 NT-TYPE DOMAIN-CONTAINING PROTEIN', 239434),
(303686, 'PTHR31344:SF13', NULL, NULL, NULL, NULL, 'EEIG1/EHBP1 PROTEIN AMINO-TERMINAL DOMAIN PROTEIN', 239434),
(303687, 'PTHR31344:SF19', NULL, NULL, NULL, NULL, 'DILUTE DOMAIN-CONTAINING PROTEIN', 239434),
(303688, 'PTHR31344', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP205', 239434),
(303689, 'PTHR31344:SF18', NULL, NULL, NULL, NULL, 'BNAA04G24420D PROTEIN', 239434),
(303690, 'PTHR43016', NULL, NULL, NULL, NULL, 'PRESEQUENCE PROTEASE', 239435),
(303691, 'PTHR43016:SF15', NULL, NULL, NULL, NULL, 'M16C_ASSOCIATED DOMAIN-CONTAINING PROTEIN', 239435),
(303692, 'PTHR43016:SF16', NULL, NULL, NULL, NULL, 'METALLOPROTEASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G07610)-RELATED', 239435),
(303693, 'PTHR43016:SF6', NULL, NULL, NULL, NULL, '', 239435),
(303694, 'PTHR43016:SF7', NULL, NULL, NULL, NULL, 'PRESEQUENCE PROTEASE 1, CHLOROPLASTIC/MITOCHONDRIAL', 239435),
(303695, 'PTHR43016:SF11', NULL, NULL, NULL, NULL, 'METALLOENZYME, LUXS/M16 PEPTIDASE-LIKE PROTEIN-RELATED', 239435),
(303696, 'PTHR43016:SF13', NULL, NULL, NULL, NULL, 'PRESEQUENCE PROTEASE, MITOCHONDRIAL', 239435),
(303697, 'PTHR14768:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 91', 239436),
(303698, 'PTHR14768:SF3', NULL, NULL, NULL, NULL, 'SYNAPSE DIFFERENTIATION-INDUCING GENE PROTEIN 1', 239436),
(303699, 'PTHR14768', NULL, NULL, NULL, NULL, 'UPF0338 PROTEIN', 239436),
(303700, 'PTHR14768:SF4', NULL, NULL, NULL, NULL, 'SYNAPSE DIFFERENTIATION-INDUCING GENE PROTEIN 1-LIKE', 239436),
(303701, 'PTHR14768:SF5', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN PMIS2', 239436),
(303702, 'PTHR14076', NULL, NULL, NULL, NULL, 'RECEPTOR ACTIVITY MODIFYING PROTEIN  RAMP', 239437),
(303703, 'PTHR14076:SF3', NULL, NULL, NULL, NULL, 'RECEPTOR ACTIVITY-MODIFYING PROTEIN 1', 239437),
(303704, 'PTHR14076:SF2', NULL, NULL, NULL, NULL, 'RECEPTOR ACTIVITY-MODIFYING PROTEIN 3', 239437),
(303705, 'PTHR14076:SF10', NULL, NULL, NULL, NULL, 'RECEPTOR (G PROTEIN-COUPLED) ACTIVITY-MODIFYING PROTEIN 2', 239437),
(303706, 'PTHR14076:SF7', NULL, NULL, NULL, NULL, '', 239437),
(303707, 'PTHR14076:SF9', NULL, NULL, NULL, NULL, 'RECEPTOR ACTIVITY-MODIFYING PROTEIN 2', 239437),
(303708, 'PTHR44755', NULL, NULL, NULL, NULL, 'NATRIURETIC PEPTIDE RECEPTOR 3-RELATED', 239438),
(303709, 'PTHR44755:SF8', NULL, NULL, NULL, NULL, 'ANF_RECEPTOR DOMAIN-CONTAINING PROTEIN', 239438),
(303710, 'PTHR44755:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG14864', 239438),
(303711, 'PTHR44755:SF5', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE', 239438),
(303712, 'PTHR44755:SF2', NULL, NULL, NULL, NULL, 'ANF_RECEPTOR DOMAIN-CONTAINING PROTEIN', 239438),
(303713, 'PTHR44755:SF10', NULL, NULL, NULL, NULL, 'ANF_RECEPTOR DOMAIN-CONTAINING PROTEIN', 239438),
(303714, 'PTHR44755:SF1', NULL, NULL, NULL, NULL, 'ATRIAL NATRIURETIC PEPTIDE RECEPTOR 3', 239438);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(303715, 'PTHR44755:SF11', NULL, NULL, NULL, NULL, 'NATRIURETIC PEPTIDE RECEPTOR 3', 239438),
(303716, 'PTHR46612', NULL, NULL, NULL, NULL, 'XYLOSIDE XYLOSYLTRANSFERASE 1', 239439),
(303717, 'PTHR46612:SF1', NULL, NULL, NULL, NULL, 'XYLOSIDE XYLOSYLTRANSFERASE 1', 239439),
(303718, 'PTHR37378:SF1', NULL, NULL, NULL, NULL, 'BOWMAN_BIRK DOMAIN-CONTAINING PROTEIN', 239440),
(303719, 'PTHR37378:SF2', NULL, NULL, NULL, NULL, 'BOWMAN-BIRK TYPE WOUND-INDUCED PROTEINASE INHIBITOR WIP1', 239440),
(303720, 'PTHR37378', NULL, NULL, NULL, NULL, 'BOWMAN_BIRK DOMAIN-CONTAINING PROTEIN-RELATED', 239440),
(303721, 'PTHR37378:SF5', NULL, NULL, NULL, NULL, 'WALI5 PROTEIN', 239440),
(303722, 'PTHR37378:SF6', NULL, NULL, NULL, NULL, 'BOWMAN-BIRK TYPE WOUND-INDUCED PROTEINASE INHIBITOR WIP1', 239440),
(303723, 'PTHR37378:SF7', NULL, NULL, NULL, NULL, 'BOWMAN_BIRK DOMAIN-CONTAINING PROTEIN', 239440),
(303724, 'PTHR37378:SF8', NULL, NULL, NULL, NULL, 'BOWMAN_BIRK DOMAIN-CONTAINING PROTEIN', 239440),
(303725, 'PTHR37378:SF9', NULL, NULL, NULL, NULL, 'BOWMAN_BIRK DOMAIN-CONTAINING PROTEIN', 239440),
(303726, 'PTHR33769', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 26 ISOFORM X3', 239441),
(303727, 'PTHR33769:SF3', NULL, NULL, NULL, NULL, 'MESENTERIC ESTROGEN-DEPENDENT ADIPOGENESIS PROTEIN', 239441),
(303728, 'PTHR33769:SF1', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 26', 239441),
(303729, 'PTHR33769:SF2', NULL, NULL, NULL, NULL, '', 239441),
(303730, 'PTHR31743', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL CHANNEL 4-ASSOCIATED PROTEIN TCPC4AP', 239442),
(303731, 'PTHR31743:SF1', NULL, NULL, NULL, NULL, 'SHORT TRANSIENT RECEPTOR POTENTIAL CHANNEL 4-ASSOCIATED PROTEIN', 239442),
(303732, 'PTHR34706:SF3', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT PROTEIN (AFU_ORTHOLOGUE AFUA_7G06200)', 239443),
(303733, 'PTHR34706', NULL, NULL, NULL, NULL, 'SLR1338 PROTEIN', 239443),
(303734, 'PTHR34706:SF2', NULL, NULL, NULL, NULL, 'RFEF', 239443),
(303735, 'PTHR34706:SF1', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 239443),
(303736, 'PTHR44499:SF1', NULL, NULL, NULL, NULL, 'JOUBERIN', 239444),
(303737, 'PTHR44499', NULL, NULL, NULL, NULL, 'JOUBERIN', 239444),
(303738, 'PTHR12709:SF3', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE V SUBUNIT 7', 239445),
(303739, 'PTHR12709:SF10', NULL, NULL, NULL, NULL, 'BNAA03G50300D PROTEIN', 239445),
(303740, 'PTHR12709:SF1', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE III SUBUNIT RPC8', 239445),
(303741, 'PTHR12709:SF12', NULL, NULL, NULL, NULL, 'BNAA08G28730D PROTEIN', 239445),
(303742, 'PTHR12709:SF11', NULL, NULL, NULL, NULL, 'PROTEIN CBG16639', 239445),
(303743, 'PTHR12709:SF8', NULL, NULL, NULL, NULL, 'BNAA10G12180D PROTEIN', 239445),
(303744, 'PTHR12709:SF7', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE IV SUBUNIT 7', 239445),
(303745, 'PTHR12709', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE II, III', 239445),
(303746, 'PTHR12709:SF6', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT 7-LIKE PROTEIN', 239445),
(303747, 'PTHR12709:SF5', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE I SUBUNIT RPA43', 239445),
(303748, 'PTHR12709:SF4', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE II SUBUNIT RPB7', 239445),
(303749, 'PTHR10961:SF7', NULL, NULL, NULL, NULL, 'DAO DOMAIN-CONTAINING PROTEIN', 239446),
(303750, 'PTHR10961:SF41', NULL, NULL, NULL, NULL, 'SARCOSINE OXIDASE-RELATED', 239446),
(303751, 'PTHR10961:SF40', NULL, NULL, NULL, NULL, 'SARCOSINE OXIDASE-RELATED', 239446),
(303752, 'PTHR10961:SF10', NULL, NULL, NULL, NULL, 'DAO DOMAIN-CONTAINING PROTEIN', 239446),
(303753, 'PTHR10961:SF45', NULL, NULL, NULL, NULL, 'DAO DOMAIN-CONTAINING PROTEIN-RELATED', 239446),
(303754, 'PTHR10961:SF44', NULL, NULL, NULL, NULL, 'DAO DOMAIN-CONTAINING PROTEIN', 239446),
(303755, 'PTHR10961:SF22', NULL, NULL, NULL, NULL, 'OS01G0316100 PROTEIN', 239446),
(303756, 'PTHR10961:SF46', NULL, NULL, NULL, NULL, 'PEROXISOMAL SARCOSINE OXIDASE', 239446),
(303757, 'PTHR10961:SF24', NULL, NULL, NULL, NULL, 'HYPOTHETICAL FRUCTOSYL AMINE:OXYGEN OXIDOREDUCTASE (EUROFUNG)', 239446);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(303758, 'PTHR10961:SF37', NULL, NULL, NULL, NULL, 'DAO DOMAIN-CONTAINING PROTEIN', 239446),
(303759, 'PTHR10961', NULL, NULL, NULL, NULL, 'PEROXISOMAL SARCOSINE OXIDASE', 239446),
(303760, 'PTHR10961:SF26', NULL, NULL, NULL, NULL, 'L-SACCHAROPINE OXIDASE', 239446),
(303761, 'PTHR10961:SF15', NULL, NULL, NULL, NULL, 'DAO DOMAIN-CONTAINING PROTEIN', 239446),
(303762, 'PTHR10961:SF17', NULL, NULL, NULL, NULL, 'DAO DOMAIN-CONTAINING PROTEIN', 239446),
(303763, 'PTHR15502:SF7', NULL, NULL, NULL, NULL, 'CALCINEURIN-BINDING PROTEIN CABIN-1', 239447),
(303764, 'PTHR15502', NULL, NULL, NULL, NULL, 'CALCINEURIN-BINDING PROTEIN CABIN 1-RELATED', 239447),
(303765, 'PTHR13044:SF45', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR OF SULFUR METABOLISM MET28', 239448),
(303766, 'PTHR13044:SF12', NULL, NULL, NULL, NULL, 'STRESS ACTIVATED TRANSCRIPTION FACTOR ATFS-1', 239448),
(303767, 'PTHR13044:SF43', NULL, NULL, NULL, NULL, 'ACTIVATING TRANSCRIPTION FACTOR 5B', 239448),
(303768, 'PTHR13044:SF32', NULL, NULL, NULL, NULL, 'ACTIVATING TRANSCRIPTION FACTOR 4', 239448),
(303769, 'PTHR13044:SF44', NULL, NULL, NULL, NULL, 'ACTIVATING TRANSCRIPTION FACTOR 4', 239448),
(303770, 'PTHR13044:SF2', NULL, NULL, NULL, NULL, 'CYCLIC AMP-DEPENDENT TRANSCRIPTION FACTOR ATF-4', 239448),
(303771, 'PTHR13044:SF42', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR FAMILY', 239448),
(303772, 'PTHR13044:SF40', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR ZIP-3', 239448),
(303773, 'PTHR13044:SF3', NULL, NULL, NULL, NULL, 'CYCLIC AMP-DEPENDENT TRANSCRIPTION FACTOR ATF-5', 239448),
(303774, 'PTHR13044:SF38', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 239448),
(303775, 'PTHR13044:SF36', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 239448),
(303776, 'PTHR13044:SF14', NULL, NULL, NULL, NULL, 'CRYPTOCEPHAL, ISOFORM A', 239448),
(303777, 'PTHR13044', NULL, NULL, NULL, NULL, 'ACTIVATING TRANSCRIPTION FACTOR  ATF  4/5', 239448),
(303778, 'PTHR46319', NULL, NULL, NULL, NULL, 'ZINC FINGER FYVE DOMAIN-CONTAINING PROTEIN', 239449),
(303779, 'PTHR46319:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER FYVE DOMAIN-CONTAINING PROTEIN 9', 239449),
(303780, 'PTHR46319:SF3', NULL, NULL, NULL, NULL, 'ZINC FINGER FYVE DOMAIN-CONTAINING PROTEIN', 239449),
(303781, 'PTHR46319:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER FYVE DOMAIN-CONTAINING PROTEIN 16', 239449),
(303782, 'PTHR46307:SF4', NULL, NULL, NULL, NULL, 'G9A, ISOFORM B', 239450),
(303783, 'PTHR46307', NULL, NULL, NULL, NULL, 'G9A, ISOFORM B', 239450),
(303784, 'PTHR46307:SF2', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE EHMT1', 239450),
(303785, 'PTHR46307:SF1', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE EHMT2', 239450),
(303786, 'PTHR10795:SF722', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT2.5', 239451),
(303787, 'PTHR10795:SF601', NULL, NULL, NULL, NULL, 'CUCUMISIN-RELATED', 239451),
(303788, 'PTHR10795:SF569', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT3.16', 239451),
(303789, 'PTHR10795:SF723', NULL, NULL, NULL, NULL, '', 239451),
(303790, 'PTHR10795:SF724', NULL, NULL, NULL, NULL, '', 239451),
(303791, 'PTHR10795:SF603', NULL, NULL, NULL, NULL, 'PEPTIDASE_S8 DOMAIN-CONTAINING PROTEIN', 239451),
(303792, 'PTHR10795:SF322', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.3', 239451),
(303793, 'PTHR10795:SF604', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE GLYMA18G48580', 239451),
(303794, 'PTHR10795:SF442', NULL, NULL, NULL, NULL, 'OS02G0779200 PROTEIN', 239451),
(303795, 'PTHR10795:SF606', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT2.1', 239451),
(303796, 'PTHR10795:SF728', NULL, NULL, NULL, NULL, 'BNAA01G06940D PROTEIN', 239451),
(303797, 'PTHR10795:SF607', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.7', 239451),
(303798, 'PTHR10795:SF608', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.9', 239451),
(303799, 'PTHR10795:SF729', NULL, NULL, NULL, NULL, 'BNAA03G58460D PROTEIN', 239451),
(303800, 'PTHR10795:SF609', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.7', 239451); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(303801, 'PTHR10795:SF680', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.4', 239451),
(303802, 'PTHR10795:SF681', NULL, NULL, NULL, NULL, 'BNAA09G07440D PROTEIN', 239451),
(303803, 'PTHR10795:SF560', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT5.6', 239451),
(303804, 'PTHR10795:SF561', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239451),
(303805, 'PTHR10795:SF562', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT5.5-RELATED', 239451),
(303806, 'PTHR10795:SF563', NULL, NULL, NULL, NULL, '', 239451),
(303807, 'PTHR10795:SF564', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.1', 239451),
(303808, 'PTHR10795:SF565', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT4.11', 239451),
(303809, 'PTHR10795:SF686', NULL, NULL, NULL, NULL, 'BNAA02G07410D PROTEIN', 239451),
(303810, 'PTHR10795:SF687', NULL, NULL, NULL, NULL, 'PA-DOMAIN CONTAINING SUBTILASE FAMILY PROTEIN-RELATED', 239451),
(303811, 'PTHR10795:SF720', NULL, NULL, NULL, NULL, '', 239451),
(303812, 'PTHR10795:SF600', NULL, NULL, NULL, NULL, '', 239451),
(303813, 'PTHR10795:SF721', NULL, NULL, NULL, NULL, '', 239451),
(303814, 'PTHR10795:SF567', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.2', 239451),
(303815, 'PTHR10795:SF688', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT5.3', 239451),
(303816, 'PTHR10795:SF733', NULL, NULL, NULL, NULL, '', 239451),
(303817, 'PTHR10795:SF335', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.8', 239451),
(303818, 'PTHR10795:SF455', NULL, NULL, NULL, NULL, 'OS02G0665300 PROTEIN', 239451),
(303819, 'PTHR10795:SF614', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.9', 239451),
(303820, 'PTHR10795:SF735', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 239451),
(303821, 'PTHR10795:SF615', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.8', 239451),
(303822, 'PTHR10795:SF737', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT3.5 ISOFORM X1', 239451),
(303823, 'PTHR10795:SF618', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.5', 239451),
(303824, 'PTHR10795:SF690', NULL, NULL, NULL, NULL, 'SUBTILASE', 239451),
(303825, 'PTHR10795:SF571', NULL, NULL, NULL, NULL, '', 239451),
(303826, 'PTHR10795:SF692', NULL, NULL, NULL, NULL, 'BNACNNG41810D PROTEIN', 239451),
(303827, 'PTHR10795:SF572', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE SERINE PROTEASE', 239451),
(303828, 'PTHR10795:SF693', NULL, NULL, NULL, NULL, 'SBT4B PROTEIN', 239451),
(303829, 'PTHR10795:SF573', NULL, NULL, NULL, NULL, 'TRIPEPTIDYL-PEPTIDASE II-RELATED', 239451),
(303830, 'PTHR10795:SF694', NULL, NULL, NULL, NULL, 'PEPTIDASE S8, SUBTILISIN-RELATED PROTEIN-RELATED', 239451),
(303831, 'PTHR10795:SF695', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT3.12', 239451),
(303832, 'PTHR10795:SF730', NULL, NULL, NULL, NULL, 'BNAA04G17300D PROTEIN', 239451),
(303833, 'PTHR10795:SF610', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT4.4', 239451),
(303834, 'PTHR10795:SF698', NULL, NULL, NULL, NULL, 'BNAC09G01070D PROTEIN', 239451),
(303835, 'PTHR10795:SF731', NULL, NULL, NULL, NULL, 'BNAA06G34900D PROTEIN', 239451),
(303836, 'PTHR10795:SF458', NULL, NULL, NULL, NULL, 'OS04G0558900 PROTEIN', 239451),
(303837, 'PTHR10795:SF699', NULL, NULL, NULL, NULL, 'PEPTIDASE S8, SUBTILISIN-RELATED PROTEIN-RELATED', 239451),
(303838, 'PTHR10795:SF788', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT5.4', 239451),
(303839, 'PTHR10795:SF700', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE', 239451),
(303840, 'PTHR10795:SF667', NULL, NULL, NULL, NULL, 'OS02G0198700 PROTEIN', 239451),
(303841, 'PTHR10795:SF789', NULL, NULL, NULL, NULL, 'SERINE PROTEINASE 1, PUTATIVE-RELATED', 239451),
(303842, 'PTHR10795:SF548', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT3.11', 239451),
(303843, 'PTHR10795:SF702', NULL, NULL, NULL, NULL, 'PEPTIDASE S8, SUBTILISIN-RELATED PROTEIN-RELATED', 239451),
(303844, 'PTHR10795:SF669', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 239451),
(303845, 'PTHR10795:SF388', NULL, NULL, NULL, NULL, 'XYLEM SERINE PROTEINASE 1', 239451);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(303846, 'PTHR10795:SF549', NULL, NULL, NULL, NULL, 'OS01G0278950 PROTEIN', 239451),
(303847, 'PTHR10795:SF706', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT4.3', 239451),
(303848, 'PTHR10795:SF384', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT2.6', 239451),
(303849, 'PTHR10795:SF708', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.9', 239451),
(303850, 'PTHR10795:SF709', NULL, NULL, NULL, NULL, '', 239451),
(303851, 'PTHR10795:SF382', NULL, NULL, NULL, NULL, 'OS06G0624100 PROTEIN', 239451),
(303852, 'PTHR10795:SF780', NULL, NULL, NULL, NULL, 'BNAC01G37240D PROTEIN', 239451),
(303853, 'PTHR10795:SF781', NULL, NULL, NULL, NULL, 'BNAC02G25300D PROTEIN', 239451),
(303854, 'PTHR10795:SF660', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.8', 239451),
(303855, 'PTHR10795:SF782', NULL, NULL, NULL, NULL, 'CUCUMISIN-LIKE', 239451),
(303856, 'PTHR10795:SF541', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT4.14', 239451),
(303857, 'PTHR10795:SF783', NULL, NULL, NULL, NULL, 'CUCUMISIN-LIKE ISOFORM X1', 239451),
(303858, 'PTHR10795:SF542', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.5', 239451),
(303859, 'PTHR10795:SF784', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.7', 239451),
(303860, 'PTHR10795:SF663', NULL, NULL, NULL, NULL, 'P69F PROTEIN', 239451),
(303861, 'PTHR10795:SF785', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.4', 239451),
(303862, 'PTHR10795:SF786', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.7', 239451),
(303863, 'PTHR10795:SF665', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT4.3', 239451),
(303864, 'PTHR10795:SF544', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT4.4', 239451),
(303865, 'PTHR10795:SF820', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT3.6 ISOFORM X3', 239451),
(303866, 'PTHR10795:SF666', NULL, NULL, NULL, NULL, 'BNAA06G34890D PROTEIN', 239451),
(303867, 'PTHR10795:SF425', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.7', 239451),
(303868, 'PTHR10795:SF545', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT3', 239451),
(303869, 'PTHR10795:SF787', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT4.9', 239451),
(303870, 'PTHR10795:SF557', NULL, NULL, NULL, NULL, 'SERINE PROTEINASE 1, PUTATIVE-RELATED', 239451),
(303871, 'PTHR10795:SF799', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.4', 239451),
(303872, 'PTHR10795:SF711', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE', 239451),
(303873, 'PTHR10795:SF558', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 239451),
(303874, 'PTHR10795:SF679', NULL, NULL, NULL, NULL, 'BNAA02G21970D PROTEIN', 239451),
(303875, 'PTHR10795:SF559', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT4.2', 239451),
(303876, 'PTHR10795:SF714', NULL, NULL, NULL, NULL, 'LOW QUALITY PROTEIN: CUCUMISIN', 239451),
(303877, 'PTHR10795:SF397', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT4.15', 239451),
(303878, 'PTHR10795:SF717', NULL, NULL, NULL, NULL, 'BNACNNG38020D PROTEIN', 239451),
(303879, 'PTHR10795:SF718', NULL, NULL, NULL, NULL, '', 239451),
(303880, 'PTHR10795:SF719', NULL, NULL, NULL, NULL, 'PEPTIDASE S8, SUBTILISIN-RELATED PROTEIN-RELATED', 239451),
(303881, 'PTHR10795:SF790', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.1', 239451),
(303882, 'PTHR10795:SF791', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT4.1', 239451),
(303883, 'PTHR10795:SF670', NULL, NULL, NULL, NULL, 'BNAA02G07220D PROTEIN', 239451),
(303884, 'PTHR10795:SF792', NULL, NULL, NULL, NULL, 'BNAA02G29970D PROTEIN', 239451),
(303885, 'PTHR10795:SF671', NULL, NULL, NULL, NULL, 'BNAC05G51310D PROTEIN', 239451),
(303886, 'PTHR10795:SF793', NULL, NULL, NULL, NULL, '', 239451),
(303887, 'PTHR10795', NULL, NULL, NULL, NULL, 'PROPROTEIN CONVERTASE SUBTILISIN/KEXIN', 239451),
(303888, 'PTHR10795:SF673', NULL, NULL, NULL, NULL, 'SERINE PROTEINASE 1, PUTATIVE-RELATED', 239451),
(303889, 'PTHR10795:SF552', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.4', 239451),
(303890, 'PTHR10795:SF794', NULL, NULL, NULL, NULL, 'SERINE PROTEASE, PUTATIVE, EXPRESSED-RELATED', 239451);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(303891, 'PTHR10795:SF439', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT2.2', 239451),
(303892, 'PTHR10795:SF674', NULL, NULL, NULL, NULL, 'BNAA02G07390D PROTEIN', 239451),
(303893, 'PTHR10795:SF795', NULL, NULL, NULL, NULL, '', 239451),
(303894, 'PTHR10795:SF796', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.7', 239451),
(303895, 'PTHR10795:SF797', NULL, NULL, NULL, NULL, '', 239451),
(303896, 'PTHR10795:SF676', NULL, NULL, NULL, NULL, 'OS07G0578300 PROTEIN', 239451),
(303897, 'PTHR10795:SF798', NULL, NULL, NULL, NULL, 'OS12G0427600 PROTEIN', 239451),
(303898, 'PTHR10795:SF402', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.9', 239451),
(303899, 'PTHR10795:SF766', NULL, NULL, NULL, NULL, 'SUBTILISIN1', 239451),
(303900, 'PTHR10795:SF800', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT3.18', 239451),
(303901, 'PTHR10795:SF647', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT5.1', 239451),
(303902, 'PTHR10795:SF768', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE SERINE PROTEASE', 239451),
(303903, 'PTHR10795:SF801', NULL, NULL, NULL, NULL, 'SERINE PROTEASE', 239451),
(303904, 'PTHR10795:SF648', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.9', 239451),
(303905, 'PTHR10795:SF769', NULL, NULL, NULL, NULL, 'CO(2)-RESPONSE SECRETED PROTEASE', 239451),
(303906, 'PTHR10795:SF802', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.9 ISOFORM X2', 239451),
(303907, 'PTHR10795:SF803', NULL, NULL, NULL, NULL, 'CUCUMISIN', 239451),
(303908, 'PTHR10795:SF528', NULL, NULL, NULL, NULL, 'OS10G0524600 PROTEIN', 239451),
(303909, 'PTHR10795:SF649', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 239451),
(303910, 'PTHR10795:SF804', NULL, NULL, NULL, NULL, 'CUCUMISIN-LIKE ISOFORM X1', 239451),
(303911, 'PTHR10795:SF805', NULL, NULL, NULL, NULL, 'OS04G0121300 PROTEIN', 239451),
(303912, 'PTHR10795:SF806', NULL, NULL, NULL, NULL, '', 239451),
(303913, 'PTHR10795:SF361', NULL, NULL, NULL, NULL, 'OS07G0685900 PROTEIN', 239451),
(303914, 'PTHR10795:SF807', NULL, NULL, NULL, NULL, 'BNAA09G07410D PROTEIN', 239451),
(303915, 'PTHR10795:SF808', NULL, NULL, NULL, NULL, 'OS09G0441000 PROTEIN', 239451),
(303916, 'PTHR10795:SF809', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.5', 239451),
(303917, 'PTHR10795:SF406', NULL, NULL, NULL, NULL, 'OS02G0779900 PROTEIN', 239451),
(303918, 'PTHR10795:SF762', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE', 239451),
(303919, 'PTHR10795:SF643', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT4.13', 239451),
(303920, 'PTHR10795:SF523', NULL, NULL, NULL, NULL, 'SERINE PROTEINASE 1, PUTATIVE-RELATED', 239451),
(303921, 'PTHR10795:SF810', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.6', 239451),
(303922, 'PTHR10795:SF657', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE', 239451),
(303923, 'PTHR10795:SF811', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT4.12', 239451),
(303924, 'PTHR10795:SF658', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.2', 239451),
(303925, 'PTHR10795:SF779', NULL, NULL, NULL, NULL, '', 239451),
(303926, 'PTHR10795:SF812', NULL, NULL, NULL, NULL, 'PEPTIDASE_S8 DOMAIN-CONTAINING PROTEIN', 239451),
(303927, 'PTHR10795:SF813', NULL, NULL, NULL, NULL, '', 239451),
(303928, 'PTHR10795:SF539', NULL, NULL, NULL, NULL, 'TRIPEPTIDYL-PEPTIDASE II-RELATED', 239451),
(303929, 'PTHR10795:SF814', NULL, NULL, NULL, NULL, 'CUCUMISIN-LIKE', 239451),
(303930, 'PTHR10795:SF815', NULL, NULL, NULL, NULL, '', 239451),
(303931, 'PTHR10795:SF816', NULL, NULL, NULL, NULL, '', 239451),
(303932, 'PTHR10795:SF817', NULL, NULL, NULL, NULL, 'SERINE PROTEINASE 1, PUTATIVE-RELATED', 239451),
(303933, 'PTHR10795:SF818', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT3.9 ISOFORM X1', 239451),
(303934, 'PTHR10795:SF819', NULL, NULL, NULL, NULL, 'CUCUMISIN', 239451),
(303935, 'PTHR10795:SF771', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.9', 239451),
(303936, 'PTHR10795:SF651', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT4.4-RELATED', 239451),
(303937, 'PTHR10795:SF772', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.9', 239451);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(303938, 'PTHR10795:SF530', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT2.2', 239451),
(303939, 'PTHR10795:SF773', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE PREPROENZYME', 239451),
(303940, 'PTHR10795:SF532', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.7', 239451),
(303941, 'PTHR10795:SF654', NULL, NULL, NULL, NULL, 'BNACNNG17920D PROTEIN', 239451),
(303942, 'PTHR10795:SF469', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.7', 239451),
(303943, 'PTHR10795:SF624', NULL, NULL, NULL, NULL, '', 239451),
(303944, 'PTHR10795:SF625', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE SERINE PROTEASE', 239451),
(303945, 'PTHR10795:SF627', NULL, NULL, NULL, NULL, 'OS04G0559000 PROTEIN', 239451),
(303946, 'PTHR10795:SF749', NULL, NULL, NULL, NULL, 'SERINE PROTEASE', 239451),
(303947, 'PTHR10795:SF580', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.7', 239451),
(303948, 'PTHR10795:SF581', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.7', 239451),
(303949, 'PTHR10795:SF583', NULL, NULL, NULL, NULL, '', 239451),
(303950, 'PTHR10795:SF463', NULL, NULL, NULL, NULL, 'OS03G0119300 PROTEIN', 239451),
(303951, 'PTHR10795:SF584', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT2.3', 239451),
(303952, 'PTHR10795:SF585', NULL, NULL, NULL, NULL, 'OS01G0868900 PROTEIN', 239451),
(303953, 'PTHR10795:SF586', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 239451),
(303954, 'PTHR10795:SF740', NULL, NULL, NULL, NULL, 'OS02G0269600 PROTEIN', 239451),
(303955, 'PTHR10795:SF741', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE SERINE PROTEASE', 239451),
(303956, 'PTHR10795:SF588', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.7', 239451),
(303957, 'PTHR10795:SF468', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT3.18', 239451),
(303958, 'PTHR10795:SF635', NULL, NULL, NULL, NULL, 'OS03G0430500 PROTEIN', 239451),
(303959, 'PTHR10795:SF514', NULL, NULL, NULL, NULL, 'OS01G0868800 PROTEIN', 239451),
(303960, 'PTHR10795:SF756', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.7', 239451),
(303961, 'PTHR10795:SF757', NULL, NULL, NULL, NULL, '', 239451),
(303962, 'PTHR10795:SF636', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT2.5', 239451),
(303963, 'PTHR10795:SF637', NULL, NULL, NULL, NULL, 'TRIPEPTIDYL-PEPTIDASE II-RELATED', 239451),
(303964, 'PTHR10795:SF638', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT2.4', 239451),
(303965, 'PTHR10795:SF350', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.2', 239451),
(303966, 'PTHR10795:SF592', NULL, NULL, NULL, NULL, 'LOW QUALITY PROTEIN: SUBTILISIN-LIKE PROTEASE SBT5.3', 239451),
(303967, 'PTHR10795:SF594', NULL, NULL, NULL, NULL, 'SUBTILASE FAMILY PROTEIN-RELATED', 239451),
(303968, 'PTHR10795:SF595', NULL, NULL, NULL, NULL, '', 239451),
(303969, 'PTHR10795:SF596', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.2', 239451),
(303970, 'PTHR10795:SF630', NULL, NULL, NULL, NULL, 'CUCUMISIN PROTEIN', 239451),
(303971, 'PTHR10795:SF597', NULL, NULL, NULL, NULL, 'OS04G0430700 PROTEIN', 239451),
(303972, 'PTHR10795:SF752', NULL, NULL, NULL, NULL, 'OS04G0182300 PROTEIN', 239451),
(303973, 'PTHR10795:SF631', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.9', 239451),
(303974, 'PTHR10795:SF598', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT5.1', 239451),
(303975, 'PTHR10795:SF632', NULL, NULL, NULL, NULL, '', 239451),
(303976, 'PTHR10795:SF753', NULL, NULL, NULL, NULL, 'SERINE PROTEASE 2, PUTATIVE-RELATED', 239451),
(303977, 'PTHR10795:SF633', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT4.10-RELATED', 239451),
(303978, 'PTHR16154', NULL, NULL, NULL, NULL, 'NEURABIN', 239452),
(303979, 'PTHR16154:SF24', NULL, NULL, NULL, NULL, 'NEURABIN-2', 239452),
(303980, 'PTHR16154:SF22', NULL, NULL, NULL, NULL, 'NEURABIN-1', 239452),
(303981, 'PTHR16154:SF28', NULL, NULL, NULL, NULL, 'STERILE ALPHA MOTIF DOMAIN-CONTAINING PROTEIN 14', 239452),
(303982, 'PTHR16154:SF26', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 9A-LIKE A-RELATED', 239452),
(303983, 'PTHR16154:SF6', NULL, NULL, NULL, NULL, 'SPINOPHILIN, ISOFORM J', 239452);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(303984, 'PTHR16306:SF0', NULL, NULL, NULL, NULL, 'TRANSLIN-ASSOCIATED FACTOR X-INTERACTING PROTEIN 1', 239453),
(303985, 'PTHR16306:SF1', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 239453),
(303986, 'PTHR16306', NULL, NULL, NULL, NULL, 'TRANSLIN-ASSOCIATED FACTOR X-INTERACTING PROTEIN 1', 239453),
(303987, 'PTHR16081', NULL, NULL, NULL, NULL, 'VERTNIN', 239454),
(303988, 'PTHR16081:SF0', NULL, NULL, NULL, NULL, 'VERTNIN', 239454),
(303989, 'PTHR39181:SF1', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE YWQE', 239455),
(303990, 'PTHR39181', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE YWQE', 239455),
(303991, 'PTHR34461', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239456),
(303992, 'PTHR34461:SF4', NULL, NULL, NULL, NULL, 'OS01G0101800 PROTEIN', 239456),
(303993, 'PTHR34461:SF3', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 239456),
(303994, 'PTHR34461:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239456),
(303995, 'PTHR43187:SF2', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYL-HERCYNYLCYSTEINE SULFOXIDE HYDROLASE', 239457),
(303996, 'PTHR43187', NULL, NULL, NULL, NULL, 'GLUTAMINE AMIDOTRANSFERASE DUG3-RELATED', 239457),
(303997, 'PTHR43187:SF1', NULL, NULL, NULL, NULL, 'GLUTAMINE AMIDOTRANSFERASE DUG3-RELATED', 239457),
(303998, 'PTHR43948:SF14', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 239458),
(303999, 'PTHR43948:SF15', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 239458),
(304000, 'PTHR43948:SF18', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 239458),
(304001, 'PTHR43948:SF19', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK PROTEIN FAMILY (HSP40) MEMBER B6A-RELATED', 239458),
(304002, 'PTHR43948:SF4', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY B MEMBER 7', 239458),
(304003, 'PTHR43948:SF1', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY B MEMBER 3', 239458),
(304004, 'PTHR43948', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY B', 239458),
(304005, 'PTHR43948:SF9', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY B MEMBER 8', 239458),
(304006, 'PTHR43948:SF20', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK PROTEIN FAMILY (HSP40) MEMBER B2', 239458),
(304007, 'PTHR43948:SF21', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 239458),
(304008, 'PTHR43948:SF10', NULL, NULL, NULL, NULL, 'MRJ, ISOFORM E', 239458),
(304009, 'PTHR43948:SF22', NULL, NULL, NULL, NULL, '4930503B20RIK PROTEIN', 239458),
(304010, 'PTHR43948:SF6', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY B MEMBER 6', 239458),
(304011, 'PTHR36048:SF2', NULL, NULL, NULL, NULL, 'BNAA01G13530D PROTEIN', 239459),
(304012, 'PTHR36048', NULL, NULL, NULL, NULL, 'RIBOSOME MATURATION FACTOR', 239459),
(304013, 'PTHR36048:SF1', NULL, NULL, NULL, NULL, 'RIBOSOME MATURATION FACTOR', 239459),
(304014, 'PTHR21596:SF63', NULL, NULL, NULL, NULL, 'FACTOR OF DNA METHYLATION 1', 239460),
(304015, 'PTHR21596:SF62', NULL, NULL, NULL, NULL, 'PROTEIN INVOLVED IN DE NOVO 2-LIKE ISOFORM X1', 239460),
(304016, 'PTHR21596:SF84', NULL, NULL, NULL, NULL, 'FACTOR OF DNA METHYLATION 1', 239460),
(304017, 'PTHR21596:SF65', NULL, NULL, NULL, NULL, 'PROTEIN INVOLVED IN DE NOVO 2-RELATED', 239460),
(304018, 'PTHR21596:SF21', NULL, NULL, NULL, NULL, 'FACTOR OF DNA METHYLATION 1', 239460),
(304019, 'PTHR21596:SF64', NULL, NULL, NULL, NULL, 'XH DOMAIN-CONTAINING PROTEIN', 239460),
(304020, 'PTHR21596:SF81', NULL, NULL, NULL, NULL, 'XH DOMAIN-CONTAINING PROTEIN', 239460),
(304021, 'PTHR21596:SF80', NULL, NULL, NULL, NULL, 'FACTOR OF DNA METHYLATION 4-LIKE ISOFORM X1', 239460),
(304022, 'PTHR21596:SF61', NULL, NULL, NULL, NULL, 'OS01G0633200 PROTEIN', 239460),
(304023, 'PTHR21596:SF83', NULL, NULL, NULL, NULL, 'FACTOR OF DNA METHYLATION 4-LIKE', 239460),
(304024, 'PTHR21596:SF82', NULL, NULL, NULL, NULL, 'XH DOMAIN-CONTAINING PROTEIN', 239460),
(304025, 'PTHR21596:SF49', NULL, NULL, NULL, NULL, 'XH DOMAIN-CONTAINING PROTEIN', 239460),
(304026, 'PTHR21596:SF48', NULL, NULL, NULL, NULL, 'XH DOMAIN-CONTAINING PROTEIN', 239460),
(304027, 'PTHR21596:SF67', NULL, NULL, NULL, NULL, 'XH DOMAIN-CONTAINING PROTEIN', 239460);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(304028, 'PTHR21596:SF23', NULL, NULL, NULL, NULL, 'FACTOR OF DNA METHYLATION 4', 239460),
(304029, 'PTHR21596:SF66', NULL, NULL, NULL, NULL, 'BNAA06G16380D PROTEIN', 239460),
(304030, 'PTHR21596:SF47', NULL, NULL, NULL, NULL, 'XH DOMAIN-CONTAINING PROTEIN', 239460),
(304031, 'PTHR21596:SF68', NULL, NULL, NULL, NULL, 'BNAA09G56520D PROTEIN', 239460),
(304032, 'PTHR21596:SF3', NULL, NULL, NULL, NULL, 'FACTOR OF DNA METHYLATION 1-RELATED', 239460),
(304033, 'PTHR21596', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P SUBUNIT P38', 239460),
(304034, 'PTHR21596:SF52', NULL, NULL, NULL, NULL, 'FACTOR OF DNA METHYLATION 3', 239460),
(304035, 'PTHR21596:SF51', NULL, NULL, NULL, NULL, 'OS01G0147700 PROTEIN', 239460),
(304036, 'PTHR21596:SF73', NULL, NULL, NULL, NULL, 'XH DOMAIN-CONTAINING PROTEIN', 239460),
(304037, 'PTHR21596:SF54', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REGULATOR-LIKE', 239460),
(304038, 'PTHR21596:SF53', NULL, NULL, NULL, NULL, 'FACTOR OF DNA METHYLATION 5-RELATED', 239460),
(304039, 'PTHR21596:SF70', NULL, NULL, NULL, NULL, 'XH DOMAIN-CONTAINING PROTEIN', 239460),
(304040, 'PTHR21596:SF71', NULL, NULL, NULL, NULL, 'BNAC09G28530D PROTEIN', 239460),
(304041, 'PTHR21596:SF55', NULL, NULL, NULL, NULL, 'OS12G0572500 PROTEIN', 239460),
(304042, 'PTHR21596:SF77', NULL, NULL, NULL, NULL, 'XH/XS DOMAIN PROTEIN', 239460),
(304043, 'PTHR18871:SF2', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 112 KDA', 239461),
(304044, 'PTHR18871', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 112 KDA', 239461),
(304045, 'PTHR11481', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN FC RECEPTOR', 239462),
(304046, 'PTHR11481:SF68', NULL, NULL, NULL, NULL, 'FC RECEPTOR-LIKE PROTEIN 5', 239462),
(304047, 'PTHR11481:SF58', NULL, NULL, NULL, NULL, 'ALLERGIN-1', 239462),
(304048, 'PTHR11481:SF69', NULL, NULL, NULL, NULL, 'FC RECEPTOR-LIKE S, SCAVENGER RECEPTOR', 239462),
(304049, 'PTHR11481:SF5', NULL, NULL, NULL, NULL, 'PLATELET ENDOTHELIAL CELL ADHESION MOLECULE', 239462),
(304050, 'PTHR11481:SF97', NULL, NULL, NULL, NULL, 'LOW AFFINITY IMMUNOGLOBULIN GAMMA FC REGION RECEPTOR II-B-RELATED', 239462),
(304051, 'PTHR11481:SF64', NULL, NULL, NULL, NULL, 'FC RECEPTOR-LIKE PROTEIN 4', 239462),
(304052, 'PTHR11481:SF11', NULL, NULL, NULL, NULL, 'HIGH AFFINITY IMMUNOGLOBULIN GAMMA FC RECEPTOR I-RELATED', 239462),
(304053, 'PTHR11481:SF89', NULL, NULL, NULL, NULL, 'LOW AFFINITY IMMUNOGLOBULIN GAMMA FC REGION RECEPTOR III', 239462),
(304054, 'PTHR11481:SF67', NULL, NULL, NULL, NULL, 'PROTEIN IL-40', 239462),
(304055, 'PTHR11481:SF12', NULL, NULL, NULL, NULL, 'HIGH AFFINITY IMMUNOGLOBULIN EPSILON RECEPTOR SUBUNIT ALPHA', 239462),
(304056, 'PTHR11481:SF71', NULL, NULL, NULL, NULL, 'FC RECEPTOR-LIKE A', 239462),
(304057, 'PTHR11481:SF60', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 239462),
(304058, 'PTHR11481:SF93', NULL, NULL, NULL, NULL, 'FC RECEPTOR-LIKE PROTEIN 3', 239462),
(304059, 'PTHR11481:SF101', NULL, NULL, NULL, NULL, 'FC RECEPTOR-LIKE PROTEIN 2', 239462),
(304060, 'PTHR11481:SF94', NULL, NULL, NULL, NULL, 'FC RECEPTOR-LIKE B', 239462),
(304061, 'PTHR11481:SF62', NULL, NULL, NULL, NULL, 'FC RECEPTOR-LIKE PROTEIN 6', 239462),
(304062, 'PTHR11481:SF103', NULL, NULL, NULL, NULL, 'LOW AFFINITY IMMUNOGLOBULIN GAMMA FC REGION RECEPTOR III-A-RELATED', 239462),
(304063, 'PTHR11481:SF106', NULL, NULL, NULL, NULL, 'LOW AFFINITY IMMUNOGLOBULIN GAMMA FC REGION RECEPTOR II-A', 239462),
(304064, 'PTHR11481:SF105', NULL, NULL, NULL, NULL, 'PLATELET ENDOTHELIAL CELL ADHESION MOLECULE-LIKE', 239462),
(304065, 'PTHR11481:SF107', NULL, NULL, NULL, NULL, 'ZGC:154125', 239462),
(304066, 'PTHR46130:SF2', NULL, NULL, NULL, NULL, 'PAPPALYSIN-1', 239463),
(304067, 'PTHR46130:SF1', NULL, NULL, NULL, NULL, 'PAPPALYSIN-2', 239463),
(304068, 'PTHR46130', NULL, NULL, NULL, NULL, 'LAMGL DOMAIN-CONTAINING PROTEIN', 239463),
(304069, 'PTHR46130:SF3', NULL, NULL, NULL, NULL, '', 239463),
(304070, 'PTHR12570:SF91', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER-RELATED', 239464),
(304071, 'PTHR12570:SF92', NULL, NULL, NULL, NULL, 'SPICHTHYIN, ISOFORM B', 239464); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(304072, 'PTHR12570:SF70', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER-RELATED', 239464),
(304073, 'PTHR12570', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239464),
(304074, 'PTHR12570:SF90', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER-RELATED', 239464),
(304075, 'PTHR12570:SF77', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER-RELATED', 239464),
(304076, 'PTHR12570:SF11', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER NIPA6-RELATED', 239464),
(304077, 'PTHR12570:SF78', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER-RELATED', 239464),
(304078, 'PTHR12570:SF75', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER-RELATED', 239464),
(304079, 'PTHR12570:SF76', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER-RELATED', 239464),
(304080, 'PTHR12570:SF10', NULL, NULL, NULL, NULL, 'ZGC:101583', 239464),
(304081, 'PTHR12570:SF73', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER-RELATED', 239464),
(304082, 'PTHR12570:SF74', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER-RELATED', 239464),
(304083, 'PTHR12570:SF71', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER-RELATED', 239464),
(304084, 'PTHR12570:SF19', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER-RELATED', 239464),
(304085, 'PTHR12570:SF17', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER NIPA1', 239464),
(304086, 'PTHR12570:SF16', NULL, NULL, NULL, NULL, 'NIPA-LIKE PROTEIN 2', 239464),
(304087, 'PTHR12570:SF13', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER NIPA3', 239464),
(304088, 'PTHR12570:SF57', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER-RELATED', 239464),
(304089, 'PTHR12570:SF14', NULL, NULL, NULL, NULL, 'NIPA-LIKE PROTEIN 3', 239464),
(304090, 'PTHR12570:SF58', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER-RELATED', 239464),
(304091, 'PTHR12570:SF7', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER NIPA4', 239464),
(304092, 'PTHR12570:SF9', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER NIPA8-RELATED', 239464),
(304093, 'PTHR12570:SF88', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER-RELATED', 239464),
(304094, 'PTHR12570:SF89', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER NIPA3-RELATED', 239464),
(304095, 'PTHR12570:SF67', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER NIPA2-RELATED', 239464),
(304096, 'PTHR12570:SF64', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER-RELATED', 239464),
(304097, 'PTHR12570:SF20', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER NIPA1-RELATED', 239464),
(304098, 'PTHR12570:SF86', NULL, NULL, NULL, NULL, 'DUF803 DOMAIN-CONTAINING PROTEIN', 239464),
(304099, 'PTHR12570:SF65', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER NIPA9-RELATED', 239464),
(304100, 'PTHR12570:SF87', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER-RELATED', 239464),
(304101, 'PTHR12570:SF84', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER NIPA4-RELATED', 239464),
(304102, 'PTHR12570:SF62', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER NIPA7-RELATED', 239464),
(304103, 'PTHR12570:SF63', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER-RELATED', 239464),
(304104, 'PTHR12570:SF85', NULL, NULL, NULL, NULL, 'DUF803 DOMAIN MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_1G15880)', 239464),
(304105, 'PTHR12570:SF1', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER NIPA2', 239464),
(304106, 'PTHR12570:SF82', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239464),
(304107, 'PTHR12570:SF83', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER-RELATED', 239464),
(304108, 'PTHR12570:SF68', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER-RELATED', 239464),
(304109, 'PTHR12570:SF25', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER-RELATED', 239464),
(304110, 'PTHR35042', NULL, NULL, NULL, NULL, 'ANTHRONE OXYGENASE ENCC', 239465),
(304111, 'PTHR35042:SF1', NULL, NULL, NULL, NULL, 'DECARBOXYLASE', 239465),
(304112, 'PTHR35042:SF3', NULL, NULL, NULL, NULL, 'ANTHRONE OXYGENASE', 239465),
(304113, 'PTHR16181:SF19', NULL, NULL, NULL, NULL, 'PROTEIN FAM83F', 239466),
(304114, 'PTHR16181:SF5', NULL, NULL, NULL, NULL, 'PROTEIN FAM83G', 239466),
(304115, 'PTHR16181:SF28', NULL, NULL, NULL, NULL, 'PROTEIN FAM83B-RELATED', 239466),
(304116, 'PTHR16181:SF17', NULL, NULL, NULL, NULL, 'FAMILY WITH SEQUENCE SIMILARITY 83 MEMBER FB', 239466); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(304117, 'PTHR16181:SF27', NULL, NULL, NULL, NULL, 'SI:DKEY-27O4.1-RELATED', 239466),
(304118, 'PTHR16181:SF16', NULL, NULL, NULL, NULL, 'FAMILY WITH SEQUENCE SIMILARITY 83 MEMBER HA', 239466),
(304119, 'PTHR16181:SF26', NULL, NULL, NULL, NULL, 'PROTEIN FAM83H', 239466),
(304120, 'PTHR16181:SF14', NULL, NULL, NULL, NULL, 'FAMILY WITH SEQUENCE SIMILARITY 83 MEMBER FA', 239466),
(304121, 'PTHR16181:SF24', NULL, NULL, NULL, NULL, 'PROTEIN FAM83C', 239466),
(304122, 'PTHR16181', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239466),
(304123, 'PTHR16181:SF12', NULL, NULL, NULL, NULL, 'PROTEIN FAM83E', 239466),
(304124, 'PTHR16181:SF20', NULL, NULL, NULL, NULL, 'PROTEIN FAM83A', 239466),
(304125, 'PTHR37604', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT', 239467),
(304126, 'PTHR37604:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT', 239467),
(304127, 'PTHR28559:SF1', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN XRCC4', 239468),
(304128, 'PTHR28559', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN XRCC4', 239468),
(304129, 'PTHR16124:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REGULATOR OTHERS FAMILY-RELATED', 239469),
(304130, 'PTHR16124:SF3', NULL, NULL, NULL, NULL, 'MIS18-BINDING PROTEIN 1', 239469),
(304131, 'PTHR16124', NULL, NULL, NULL, NULL, 'MIS18-BINDING PROTEIN 1', 239469),
(304132, 'PTHR46645:SF2', NULL, NULL, NULL, NULL, 'GRAM DOMAIN-CONTAINING PROTEIN 2B', 239470),
(304133, 'PTHR46645:SF1', NULL, NULL, NULL, NULL, 'GRAM DOMAIN-CONTAINING PROTEIN', 239470),
(304134, 'PTHR46645', NULL, NULL, NULL, NULL, 'GRAM DOMAIN-CONTAINING PROTEIN 2B-RELATED', 239470),
(304135, 'PTHR39673', NULL, NULL, NULL, NULL, 'TUNGSTEN FORMYLMETHANOFURAN DEHYDROGENASE, SUBUNIT C (FWDC)', 239471),
(304136, 'PTHR39673:SF7', NULL, NULL, NULL, NULL, 'TUNGSTEN-CONTAINING FORMYLMETHANOFURAN DEHYDROGENASE 2 SUBUNIT C', 239471),
(304137, 'PTHR39673:SF5', NULL, NULL, NULL, NULL, 'GXGXG DOMAIN-CONTAINING PROTEIN', 239471),
(304138, 'PTHR10643:SF2', NULL, NULL, NULL, NULL, 'KINETOCHORE PROTEIN NDC80 HOMOLOG', 239472),
(304139, 'PTHR10643', NULL, NULL, NULL, NULL, 'KINETOCHORE PROTEIN NDC80', 239472),
(304140, 'PTHR30612', NULL, NULL, NULL, NULL, 'SECA INNER MEMBRANE COMPONENT OF SEC PROTEIN SECRETION SYSTEM', 239473),
(304141, 'PTHR30612:SF0', NULL, NULL, NULL, NULL, 'SI:DKEY-187J14.7-RELATED', 239473),
(304142, 'PTHR30612:SF10', NULL, NULL, NULL, NULL, 'SECA_MOTOR_DEAD DOMAIN-CONTAINING PROTEIN', 239473),
(304143, 'PTHR30612:SF11', NULL, NULL, NULL, NULL, 'PROTEIN TRANSLOCASE SUBUNIT SECA2, CHLOROPLASTIC', 239473),
(304144, 'PTHR15949', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 264', 239474),
(304145, 'PTHR15949:SF3', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 264', 239474),
(304146, 'PTHR47909:SF2', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 239475),
(304147, 'PTHR47909', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 239475),
(304148, 'PTHR31500:SF73', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304149, 'PTHR31500:SF79', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304150, 'PTHR31500:SF81', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304151, 'PTHR31500:SF82', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN 6', 239476),
(304152, 'PTHR31500:SF48', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304153, 'PTHR31500:SF85', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304154, 'PTHR31500:SF84', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304155, 'PTHR31500:SF45', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304156, 'PTHR31500:SF88', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304157, 'PTHR31500:SF47', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304158, 'PTHR31500:SF46', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(304159, 'PTHR31500:SF90', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304160, 'PTHR31500:SF92', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304161, 'PTHR31500:SF91', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304162, 'PTHR31500:SF94', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304163, 'PTHR31500:SF59', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304164, 'PTHR31500:SF18', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN 3', 239476),
(304165, 'PTHR31500:SF52', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN 4', 239476),
(304166, 'PTHR31500:SF96', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN 7', 239476),
(304167, 'PTHR31500:SF95', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304168, 'PTHR31500:SF51', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN 8', 239476),
(304169, 'PTHR31500:SF98', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304170, 'PTHR31500:SF56', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304171, 'PTHR31500:SF99', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304172, 'PTHR31500:SF55', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN 2', 239476),
(304173, 'PTHR31500:SF58', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304174, 'PTHR31500:SF13', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304175, 'PTHR31500:SF57', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN 10', 239476),
(304176, 'PTHR31500', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN 9', 239476),
(304177, 'PTHR31500:SF61', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304178, 'PTHR31500:SF110', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304179, 'PTHR31500:SF111', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304180, 'PTHR31500:SF112', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304181, 'PTHR31500:SF113', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304182, 'PTHR31500:SF103', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304183, 'PTHR31500:SF104', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304184, 'PTHR31500:SF107', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304185, 'PTHR31500:SF108', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304186, 'PTHR31500:SF109', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304187, 'PTHR31500:SF63', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN 13', 239476),
(304188, 'PTHR31500:SF62', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304189, 'PTHR31500:SF64', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN 12-RELATED', 239476),
(304190, 'PTHR31500:SF20', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304191, 'PTHR31500:SF67', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN 11', 239476),
(304192, 'PTHR31500:SF66', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304193, 'PTHR31500:SF68', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN 14', 239476),
(304194, 'PTHR31500:SF7', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN 1', 239476),
(304195, 'PTHR31500:SF70', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304196, 'PTHR31500:SF9', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN 9', 239476),
(304197, 'PTHR31500:SF72', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304198, 'PTHR31500:SF71', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(304199, 'PTHR31500:SF101', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 239476),
(304200, 'PTHR14577:SF0', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 12', 239477),
(304201, 'PTHR14577', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 12', 239477),
(304202, 'PTHR23278:SF32', NULL, NULL, NULL, NULL, 'NEUROMUSCULIN, ISOFORM E', 239478),
(304203, 'PTHR23278:SF33', NULL, NULL, NULL, NULL, 'HEMICENTIN 2', 239478),
(304204, 'PTHR23278:SF25', NULL, NULL, NULL, NULL, 'GH14967P', 239478),
(304205, 'PTHR23278:SF26', NULL, NULL, NULL, NULL, 'SIDESTEP III, ISOFORM O', 239478),
(304206, 'PTHR23278:SF28', NULL, NULL, NULL, NULL, 'SIDESTEP IV, ISOFORM C', 239478),
(304207, 'PTHR23278:SF2', NULL, NULL, NULL, NULL, 'SIDESTEP V, ISOFORM B', 239478),
(304208, 'PTHR23278:SF19', NULL, NULL, NULL, NULL, 'SIDESTEP VI, ISOFORM B', 239478),
(304209, 'PTHR23278:SF4', NULL, NULL, NULL, NULL, 'SIDESTEP, ISOFORM C', 239478),
(304210, 'PTHR23278:SF30', NULL, NULL, NULL, NULL, 'SIDESTEP VIII, ISOFORM B', 239478),
(304211, 'PTHR23278', NULL, NULL, NULL, NULL, 'SIDESTEP PROTEIN', 239478),
(304212, 'PTHR23278:SF31', NULL, NULL, NULL, NULL, 'SIDESTEP II, ISOFORM A', 239478),
(304213, 'PTHR11504:SF4', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 6A1, MITOCHONDRIAL', 239479),
(304214, 'PTHR11504:SF8', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT', 239479),
(304215, 'PTHR11504:SF9', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 6A-LIKE', 239479),
(304216, 'PTHR11504', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE POLYPEPTIDE VIA', 239479),
(304217, 'PTHR11504:SF7', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT', 239479),
(304218, 'PTHR11504:SF11', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 6A1, MITOCHONDRIAL', 239479),
(304219, 'PTHR11504:SF10', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 6A, MITOCHONDRIAL-LIKE', 239479),
(304220, 'PTHR11504:SF0', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT', 239479),
(304221, 'PTHR11504:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 6A2, MITOCHONDRIAL', 239479),
(304222, 'PTHR21574:SF0', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 120 KDA', 239480),
(304223, 'PTHR21574', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239480),
(304224, 'PTHR24164', NULL, NULL, NULL, NULL, 'RELA-ASSOCIATED INHIBITOR', 239481),
(304225, 'PTHR24164:SF4', NULL, NULL, NULL, NULL, 'RELA-ASSOCIATED INHIBITOR', 239481),
(304226, 'PTHR33751:SF12', NULL, NULL, NULL, NULL, 'CYTOCHROME-RELATED', 239482),
(304227, 'PTHR33751:SF11', NULL, NULL, NULL, NULL, 'BLL4483 PROTEIN', 239482),
(304228, 'PTHR33751:SF1', NULL, NULL, NULL, NULL, 'CBB3-TYPE CYTOCHROME C OXIDASE SUBUNIT CCOP', 239482),
(304229, 'PTHR33751:SF9', NULL, NULL, NULL, NULL, 'CYTOCHROME C4', 239482),
(304230, 'PTHR33751', NULL, NULL, NULL, NULL, 'CBB3-TYPE CYTOCHROME C OXIDASE SUBUNIT FIXP', 239482),
(304231, 'PTHR23097:SF181', NULL, NULL, NULL, NULL, 'SI:DKEYP-61B2.1-RELATED', 239483),
(304232, 'PTHR23097', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER', 239483),
(304233, 'PTHR23097:SF116', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 6B', 239483),
(304234, 'PTHR23097:SF90', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 11B', 239483),
(304235, 'PTHR35975:SF1', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 11A', 239484),
(304236, 'PTHR35975:SF2', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 11B', 239484),
(304237, 'PTHR35975', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 11A', 239484),
(304238, 'PTHR21725', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE UBR4', 239485),
(304239, 'PTHR21725:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE UBR4', 239485),
(304240, 'PTHR13200:SF1', NULL, NULL, NULL, NULL, 'NUCLEIC ACID BINDING PROTEIN', 239486),
(304241, 'PTHR13200', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239486),
(304242, 'PTHR13200:SF0', NULL, NULL, NULL, NULL, 'EEF1A LYSINE METHYLTRANSFERASE 1', 239486),
(304243, 'PTHR47366:SF1', NULL, NULL, NULL, NULL, 'TWO-ON-TWO HEMOGLOBIN-3', 239487);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(304244, 'PTHR47366:SF2', NULL, NULL, NULL, NULL, '', 239487),
(304245, 'PTHR47366', NULL, NULL, NULL, NULL, 'TWO-ON-TWO HEMOGLOBIN-3', 239487),
(304246, 'PTHR47366:SF3', NULL, NULL, NULL, NULL, '', 239487),
(304247, 'PTHR10245:SF119', NULL, NULL, NULL, NULL, 'HTH CRO/C1-TYPE DOMAIN-CONTAINING PROTEIN', 239488),
(304248, 'PTHR10245:SF118', NULL, NULL, NULL, NULL, 'MULTIPROTEIN BRIDGING FACTOR 1B', 239488),
(304249, 'PTHR10245:SF117', NULL, NULL, NULL, NULL, 'MULTIPROTEIN-BRIDGING FACTOR 1B', 239488),
(304250, 'PTHR10245:SF123', NULL, NULL, NULL, NULL, 'OS08G0366100 PROTEIN', 239488),
(304251, 'PTHR10245:SF122', NULL, NULL, NULL, NULL, 'MULTIPROTEIN-BRIDGING FACTOR 1C-LIKE', 239488),
(304252, 'PTHR10245:SF121', NULL, NULL, NULL, NULL, 'HTH CRO/C1-TYPE DOMAIN-CONTAINING PROTEIN', 239488),
(304253, 'PTHR10245', NULL, NULL, NULL, NULL, 'ENDOTHELIAL DIFFERENTIATION-RELATED FACTOR 1  MULTIPROTEIN BRIDGING FACTOR 1', 239488),
(304254, 'PTHR10245:SF15', NULL, NULL, NULL, NULL, 'ENDOTHELIAL DIFFERENTIATION-RELATED FACTOR 1', 239488),
(304255, 'PTHR10245:SF116', NULL, NULL, NULL, NULL, 'MULTIPROTEIN-BRIDGING FACTOR 1B-LIKE', 239488),
(304256, 'PTHR10245:SF115', NULL, NULL, NULL, NULL, 'HTH CRO/C1-TYPE DOMAIN-CONTAINING PROTEIN', 239488),
(304257, 'PTHR10245:SF114', NULL, NULL, NULL, NULL, 'MULTIPROTEIN-BRIDGING FACTOR 1A', 239488),
(304258, 'PTHR10245:SF124', NULL, NULL, NULL, NULL, 'MULTIPROTEIN BRIDGING FACTOR 1-RELATED', 239488),
(304259, 'PTHR28658', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 180', 239489),
(304260, 'PTHR28658:SF2', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY DOMAIN CONTAINING HOMOLOG', 239489),
(304261, 'PTHR28658:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 180', 239489),
(304262, 'PTHR28658:SF1', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY DOMAIN-CONTAINING 13B', 239489),
(304263, 'PTHR45924:SF4', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY G MEMBER 3', 239490),
(304264, 'PTHR45924:SF3', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY G MEMBER 2', 239490),
(304265, 'PTHR45924', NULL, NULL, NULL, NULL, 'FI17866P1', 239490),
(304266, 'PTHR45924:SF2', NULL, NULL, NULL, NULL, 'FI17866P1', 239490),
(304267, 'PTHR45924:SF1', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY G MEMBER 1', 239490),
(304268, 'PTHR13964:SF25', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 5A', 239491),
(304269, 'PTHR13964:SF24', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 4B', 239491),
(304270, 'PTHR13964:SF27', NULL, NULL, NULL, NULL, 'HAT-TRICK, ISOFORM D', 239491),
(304271, 'PTHR13964:SF37', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 5B', 239491),
(304272, 'PTHR13964:SF26', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 4A', 239491),
(304273, 'PTHR13964', NULL, NULL, NULL, NULL, 'RBP-RELATED', 239491),
(304274, 'PTHR13964:SF44', NULL, NULL, NULL, NULL, 'ARID DOMAIN-CONTAINING PROTEIN', 239491),
(304275, 'PTHR13964:SF41', NULL, NULL, NULL, NULL, 'ZGC:77151', 239491),
(304276, 'PTHR39142', NULL, NULL, NULL, NULL, 'MID1P', 239492),
(304277, 'PTHR39142:SF1', NULL, NULL, NULL, NULL, 'MID1P', 239492),
(304278, 'PTHR39671', NULL, NULL, NULL, NULL, 'COMPLEX PROTEIN NUCLEASE, PUTATIVE KREPB1-RELATED-RELATED', 239493),
(304279, 'PTHR39671:SF3', NULL, NULL, NULL, NULL, 'RNA EDITING COMPLEX PROTEIN MP61', 239493),
(304280, 'PTHR39671:SF2', NULL, NULL, NULL, NULL, 'COMPLEX PROTEIN NUCLEASE, PUTATIVE KREPB1-RELATED', 239493),
(304281, 'PTHR39671:SF1', NULL, NULL, NULL, NULL, 'RNA EDITING COMPLEX PROTEIN MP67', 239493),
(304282, 'PTHR31242:SF2', NULL, NULL, NULL, NULL, 'ACETOLACTATE SYNTHASE SMALL SUBUNIT, MITOCHONDRIAL', 239494),
(304283, 'PTHR31242', NULL, NULL, NULL, NULL, 'ACETOLACTATE SYNTHASE SMALL SUBUNIT, MITOCHONDRIAL', 239494),
(304284, 'PTHR19317:SF39', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 239495),
(304285, 'PTHR19317:SF2', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN F2', 239495),
(304286, 'PTHR19317:SF0', NULL, NULL, NULL, NULL, 'PRENYLATED RAB ACCEPTOR PROTEIN 1', 239495);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(304287, 'PTHR19317:SF1', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN H', 239495),
(304288, 'PTHR19317:SF90', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN F1', 239495),
(304289, 'PTHR19317:SF91', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 239495),
(304290, 'PTHR19317:SF70', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 239495),
(304291, 'PTHR19317:SF92', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN B3', 239495),
(304292, 'PTHR19317:SF71', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 239495),
(304293, 'PTHR19317:SF93', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN 2', 239495),
(304294, 'PTHR19317:SF72', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 239495),
(304295, 'PTHR19317:SF73', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 239495),
(304296, 'PTHR19317:SF53', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN G1', 239495),
(304297, 'PTHR19317:SF75', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 239495),
(304298, 'PTHR19317:SF10', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 239495),
(304299, 'PTHR19317:SF76', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN C', 239495),
(304300, 'PTHR19317:SF78', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 239495),
(304301, 'PTHR19317:SF34', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN B4', 239495),
(304302, 'PTHR19317:SF12', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 239495),
(304303, 'PTHR19317:SF79', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 239495),
(304304, 'PTHR19317:SF58', NULL, NULL, NULL, NULL, 'OS03G0741600 PROTEIN', 239495),
(304305, 'PTHR19317:SF16', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN E', 239495),
(304306, 'PTHR19317', NULL, NULL, NULL, NULL, 'PRENYLATED RAB ACCEPTOR 1-RELATED', 239495),
(304307, 'PTHR19317:SF80', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 239495),
(304308, 'PTHR19317:SF81', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN D', 239495),
(304309, 'PTHR19317:SF61', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN F3-RELATED', 239495),
(304310, 'PTHR19317:SF83', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN G2', 239495),
(304311, 'PTHR19317:SF84', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 239495),
(304312, 'PTHR19317:SF41', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 239495),
(304313, 'PTHR19317:SF85', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 239495),
(304314, 'PTHR19317:SF63', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 239495),
(304315, 'PTHR19317:SF42', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 239495),
(304316, 'PTHR19317:SF86', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN-RELATED', 239495),
(304317, 'PTHR19317:SF64', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 239495),
(304318, 'PTHR19317:SF65', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 239495),
(304319, 'PTHR19317:SF66', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 239495),
(304320, 'PTHR19317:SF45', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN B6', 239495),
(304321, 'PTHR19317:SF89', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 239495),
(304322, 'PTHR19317:SF46', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN B2', 239495),
(304323, 'PTHR19317:SF68', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 239495),
(304324, 'PTHR19317:SF69', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 239495),
(304325, 'PTHR19317:SF47', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 239495),
(304326, 'PTHR19317:SF48', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 239495),
(304327, 'PTHR39211', NULL, NULL, NULL, NULL, 'CHROMOSOME 7, WHOLE GENOME SHOTGUN SEQUENCE', 239496),
(304328, 'PTHR39211:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 7, WHOLE GENOME SHOTGUN SEQUENCE', 239496),
(304329, 'PTHR28266', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN L20, MITOCHONDRIAL', 239497),
(304330, 'PTHR28266:SF1', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN L20, MITOCHONDRIAL', 239497),
(304331, 'PTHR34042:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR OFP17-LIKE PROTEIN', 239498),
(304332, 'PTHR34042:SF4', NULL, NULL, NULL, NULL, 'OVATE DOMAIN-CONTAINING PROTEIN', 239498),
(304333, 'PTHR34042:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR OFP17-LIKE', 239498);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(304334, 'PTHR34042:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR OFP17', 239498),
(304335, 'PTHR34042', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR OFP17', 239498),
(304336, 'PTHR34042:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR OFP17', 239498),
(304337, 'PTHR15427:SF43', NULL, NULL, NULL, NULL, 'C1Q DOMAIN-CONTAINING PROTEIN', 239499),
(304338, 'PTHR15427:SF21', NULL, NULL, NULL, NULL, 'COMPLEMENT C1Q AND TUMOR NECROSIS FACTOR-RELATED PROTEIN 9A', 239499),
(304339, 'PTHR15427:SF20', NULL, NULL, NULL, NULL, 'ADIPONECTIN', 239499),
(304340, 'PTHR15427:SF42', NULL, NULL, NULL, NULL, 'EMI DOMAIN-CONTAINING PROTEIN', 239499),
(304341, 'PTHR15427:SF45', NULL, NULL, NULL, NULL, 'C1Q DOMAIN-CONTAINING PROTEIN', 239499),
(304342, 'PTHR15427:SF23', NULL, NULL, NULL, NULL, 'EMI DOMAIN-CONTAINING PROTEIN 1', 239499),
(304343, 'PTHR15427:SF44', NULL, NULL, NULL, NULL, 'C1Q DOMAIN-CONTAINING PROTEIN', 239499),
(304344, 'PTHR15427:SF41', NULL, NULL, NULL, NULL, 'COMPLEMENT C1Q AND TUMOR NECROSIS FACTOR-RELATED PROTEIN 9B', 239499),
(304345, 'PTHR15427:SF40', NULL, NULL, NULL, NULL, 'MULTIMERIN 2B', 239499),
(304346, 'PTHR15427:SF29', NULL, NULL, NULL, NULL, 'COMPLEMENT C1Q SUBCOMPONENT SUBUNIT C', 239499),
(304347, 'PTHR15427:SF3', NULL, NULL, NULL, NULL, 'MULTIMERIN-1', 239499),
(304348, 'PTHR15427:SF2', NULL, NULL, NULL, NULL, 'EMILIN-3', 239499),
(304349, 'PTHR15427:SF28', NULL, NULL, NULL, NULL, 'COMPLEMENT C1Q TUMOR NECROSIS FACTOR-RELATED PROTEIN 2', 239499),
(304350, 'PTHR15427:SF5', NULL, NULL, NULL, NULL, 'EMILIN-2', 239499),
(304351, 'PTHR15427:SF47', NULL, NULL, NULL, NULL, 'C1Q DOMAIN-CONTAINING PROTEIN', 239499),
(304352, 'PTHR15427:SF24', NULL, NULL, NULL, NULL, 'COMPLEMENT C1Q TUMOR NECROSIS FACTOR-RELATED PROTEIN 7', 239499),
(304353, 'PTHR15427:SF46', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(X) CHAIN', 239499),
(304354, 'PTHR15427:SF1', NULL, NULL, NULL, NULL, 'EMILIN-1', 239499),
(304355, 'PTHR15427:SF27', NULL, NULL, NULL, NULL, 'COMPLEMENT C1Q TUMOR NECROSIS FACTOR-RELATED PROTEIN 5', 239499),
(304356, 'PTHR15427:SF26', NULL, NULL, NULL, NULL, 'COMPLEMENT C1Q SUBCOMPONENT SUBUNIT A', 239499),
(304357, 'PTHR15427:SF6', NULL, NULL, NULL, NULL, 'MULTIMERIN-2', 239499),
(304358, 'PTHR15427:SF32', NULL, NULL, NULL, NULL, 'PROTEIN HP-20 HOMOLOG', 239499),
(304359, 'PTHR15427:SF34', NULL, NULL, NULL, NULL, 'PROTEIN HP-25 HOMOLOG 2', 239499),
(304360, 'PTHR15427:SF33', NULL, NULL, NULL, NULL, 'C1Q DOMAIN-CONTAINING PROTEIN', 239499),
(304361, 'PTHR15427:SF18', NULL, NULL, NULL, NULL, 'COMPLEMENT C1Q SUBCOMPONENT SUBUNIT B', 239499),
(304362, 'PTHR15427:SF39', NULL, NULL, NULL, NULL, 'ELASTIN MICROFIBRIL INTERFACER 1A', 239499),
(304363, 'PTHR15427:SF19', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(XXVI) CHAIN', 239499),
(304364, 'PTHR15427:SF36', NULL, NULL, NULL, NULL, 'ELASTIN MICROFIBRIL INTERFACER 2A', 239499),
(304365, 'PTHR15427:SF35', NULL, NULL, NULL, NULL, 'PROTEIN HP-25 HOMOLOG 1', 239499),
(304366, 'PTHR15427', NULL, NULL, NULL, NULL, 'EMILIN  ELASTIN MICROFIBRIL INTERFACE-LOCATED PROTEIN   ELASTIN MICROFIBRIL INTERFACER', 239499),
(304367, 'PTHR43849', NULL, NULL, NULL, NULL, 'BLL3936 PROTEIN', 239500),
(304368, 'PTHR43849:SF2', NULL, NULL, NULL, NULL, 'BLL3936 PROTEIN', 239500),
(304369, 'PTHR22945:SF29', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 239501),
(304370, 'PTHR22945:SF8', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS DELTA-34', 239501),
(304371, 'PTHR22945:SF89', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS D (DELTA)-RELATED', 239501),
(304372, 'PTHR22945:SF23', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS DELTA-1', 239501),
(304373, 'PTHR22945:SF24', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS D (DELTA)', 239501),
(304374, 'PTHR22945:SF9', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS D (DELTA)-RELATED', 239501),
(304375, 'PTHR22945:SF21', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS D (DELTA)-RELATED', 239501),
(304376, 'PTHR22945:SF22', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS D (DELTA)', 239501);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(304377, 'PTHR22945:SF27', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS DELTA-2-RELATED', 239501),
(304378, 'PTHR22945:SF28', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS DELTA-55', 239501),
(304379, 'PTHR22945:SF47', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS DELTA-40', 239501),
(304380, 'PTHR22945:SF25', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS D (DELTA)', 239501),
(304381, 'PTHR22945:SF26', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS DELTA-45-RELATED', 239501),
(304382, 'PTHR22945:SF48', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS D (DELTA)', 239501),
(304383, 'PTHR22945:SF92', NULL, NULL, NULL, NULL, 'PROTEIN CBG19324', 239501),
(304384, 'PTHR22945:SF90', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS D (DELTA)', 239501),
(304385, 'PTHR22945:SF91', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS DELTA-50', 239501),
(304386, 'PTHR22945:SF30', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 239501),
(304387, 'PTHR22945:SF96', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR', 239501),
(304388, 'PTHR22945:SF97', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS D (DELTA)', 239501),
(304389, 'PTHR22945:SF94', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS D (DELTA)', 239501),
(304390, 'PTHR22945:SF95', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS D (DELTA)', 239501),
(304391, 'PTHR22945:SF51', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS D (DELTA)-RELATED', 239501),
(304392, 'PTHR22945:SF100', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS D (DELTA)', 239501),
(304393, 'PTHR22945:SF101', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS D (DELTA)', 239501),
(304394, 'PTHR22945:SF19', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS D (DELTA)', 239501),
(304395, 'PTHR22945', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS D  DELTA', 239501),
(304396, 'PTHR22945:SF34', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS D (DELTA)', 239501),
(304397, 'PTHR22945:SF13', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS D (DELTA)', 239501),
(304398, 'PTHR22945:SF98', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS D (DELTA)', 239501),
(304399, 'PTHR22945:SF10', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS DELTA-33', 239501),
(304400, 'PTHR22945:SF11', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS D (DELTA)', 239501),
(304401, 'PTHR22945:SF33', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS DELTA-51', 239501),
(304402, 'PTHR22945:SF99', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 239501),
(304403, 'PTHR22945:SF16', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS DELTA-32', 239501),
(304404, 'PTHR22945:SF17', NULL, NULL, NULL, NULL, 'PROTEIN CBG05163', 239501),
(304405, 'PTHR22945:SF41', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 239501),
(304406, 'PTHR22945:SF83', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS D (DELTA)-RELATED', 239501),
(304407, 'PTHR22945:SF84', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS D (DELTA)', 239501),
(304408, 'PTHR22945:SF40', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS D (DELTA)-RELATED', 239501),
(304409, 'PTHR31614:SF26', NULL, NULL, NULL, NULL, 'BNAC02G24740D PROTEIN', 239502),
(304410, 'PTHR31614:SF38', NULL, NULL, NULL, NULL, 'BNAA03G58200D PROTEIN', 239502),
(304411, 'PTHR31614:SF27', NULL, NULL, NULL, NULL, 'BNAC09G52000D PROTEIN', 239502),
(304412, 'PTHR31614:SF7', NULL, NULL, NULL, NULL, 'POLLEN-SPECIFIC PROTEIN-LIKE', 239502),
(304413, 'PTHR31614:SF39', NULL, NULL, NULL, NULL, 'MAJOR POLLEN ALLERGEN LOL P 11-LIKE', 239502),
(304414, 'PTHR31614:SF28', NULL, NULL, NULL, NULL, 'OS07G0590500 PROTEIN', 239502),
(304415, 'PTHR31614:SF5', NULL, NULL, NULL, NULL, 'ALLERGEN-LIKE PROTEIN BRSN20', 239502),
(304416, 'PTHR31614:SF29', NULL, NULL, NULL, NULL, 'BNAC03G58910D PROTEIN', 239502),
(304417, 'PTHR31614:SF22', NULL, NULL, NULL, NULL, 'OLEE1-LIKE PROTEIN', 239502),
(304418, 'PTHR31614:SF2', NULL, NULL, NULL, NULL, 'F28N24.16 PROTEIN', 239502);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(304419, 'PTHR31614:SF33', NULL, NULL, NULL, NULL, 'POLLEN OLE E 1 ALLERGEN AND EXTENSIN FAMILY PROTEIN-RELATED', 239502),
(304420, 'PTHR31614:SF34', NULL, NULL, NULL, NULL, 'POLLEN-SPECIFIC PROTEIN C13', 239502),
(304421, 'PTHR31614:SF12', NULL, NULL, NULL, NULL, 'OS06G0556600 PROTEIN', 239502),
(304422, 'PTHR31614:SF23', NULL, NULL, NULL, NULL, 'ANTHER-SPECIFIC PROTEIN LAT52-LIKE', 239502),
(304423, 'PTHR31614:SF24', NULL, NULL, NULL, NULL, 'OLEE1-LIKE PROTEIN', 239502),
(304424, 'PTHR31614:SF36', NULL, NULL, NULL, NULL, 'ANTHER-SPECIFIC PROTEIN LAT52', 239502),
(304425, 'PTHR31614:SF19', NULL, NULL, NULL, NULL, 'POLLEN-SPECIFIC PROTEIN C13-LIKE', 239502),
(304426, 'PTHR31614', NULL, NULL, NULL, NULL, 'PROTEIN DOWNSTREAM OF FLC-RELATED', 239502),
(304427, 'PTHR31614:SF40', NULL, NULL, NULL, NULL, 'PROTEIN DOWNSTREAM OF FLC', 239502),
(304428, 'PTHR31614:SF30', NULL, NULL, NULL, NULL, '80A08_10', 239502),
(304429, 'PTHR31614:SF41', NULL, NULL, NULL, NULL, 'POLLEN OLE E 1 ALLERGEN AND EXTENSIN FAMILY PROTEIN-RELATED', 239502),
(304430, 'PTHR31614:SF42', NULL, NULL, NULL, NULL, 'ANTHER-SPECIFIC PROTEIN LAT52', 239502),
(304431, 'PTHR31614:SF20', NULL, NULL, NULL, NULL, 'POLLEN PROTEIN OLE E I-LIKE PROTEIN', 239502),
(304432, 'PTHR31614:SF32', NULL, NULL, NULL, NULL, 'BNAC03G62750D PROTEIN', 239502),
(304433, 'PTHR36833:SF2', NULL, NULL, NULL, NULL, 'SLR0610 PROTEIN', 239503),
(304434, 'PTHR36833', NULL, NULL, NULL, NULL, 'SLR0610 PROTEIN-RELATED', 239503),
(304435, 'PTHR36833:SF1', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE TRANSPORT PROTEIN-RELATED', 239503),
(304436, 'PTHR22798:SF10', NULL, NULL, NULL, NULL, 'MALIGNANT T-CELL-AMPLIFIED SEQUENCE 1', 239504),
(304437, 'PTHR22798:SF11', NULL, NULL, NULL, NULL, 'MALIGNANT T-CELL-AMPLIFIED SEQUENCE', 239504),
(304438, 'PTHR22798:SF0', NULL, NULL, NULL, NULL, 'MALIGNANT T-CELL-AMPLIFIED SEQUENCE 1', 239504),
(304439, 'PTHR22798', NULL, NULL, NULL, NULL, 'MCT-1 PROTEIN', 239504),
(304440, 'PTHR22798:SF9', NULL, NULL, NULL, NULL, 'PUA DOMAIN-CONTAINING PROTEIN', 239504),
(304441, 'PTHR44027:SF1', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 5', 239505),
(304442, 'PTHR44027:SF2', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 5G', 239505),
(304443, 'PTHR44027:SF6', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 5B', 239505),
(304444, 'PTHR44027:SF7', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 5 HOMOLOG', 239505),
(304445, 'PTHR44027:SF8', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 239505),
(304446, 'PTHR44027', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 5 HOMOLOG', 239505),
(304447, 'PTHR10366:SF490', NULL, NULL, NULL, NULL, 'REDUCTASE, PUTATIVE-RELATED', 239506),
(304448, 'PTHR10366:SF491', NULL, NULL, NULL, NULL, 'NAD DEPENDENT EPIMERASE/DEHYDRATASE FAMILY PROTEIN, EXPRESSED', 239506),
(304449, 'PTHR10366:SF770', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 239506),
(304450, 'PTHR10366:SF771', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 239506),
(304451, 'PTHR10366:SF653', NULL, NULL, NULL, NULL, 'OS08G0277200 PROTEIN', 239506),
(304452, 'PTHR10366:SF378', NULL, NULL, NULL, NULL, '3 BETA-HYDROXYSTEROID DEHYDROGENASE/DELTA 5--4-ISOMERASE TYPE 1', 239506),
(304453, 'PTHR10366:SF776', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304454, 'PTHR10366:SF775', NULL, NULL, NULL, NULL, '3 BETA-HYDROXYSTEROID DEHYDROGENASE/DELTA 5--4-ISOMERASE TYPE 2-RELATED', 239506),
(304455, 'PTHR10366:SF811', NULL, NULL, NULL, NULL, '3 BETA-HYDROXYSTEROID DEHYDROGENASE/DELTA 5--4-ISOMERASE TYPE 1', 239506),
(304456, 'PTHR10366:SF778', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304457, 'PTHR10366:SF777', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 239506),
(304458, 'PTHR10366:SF810', NULL, NULL, NULL, NULL, '3BETA-HYDROXYSTEROID DEHYDROGENASE/DELTA(5)-DELTA(4) ISOMERASE 1', 239506),
(304459, 'PTHR10366:SF659', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 239506);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(304460, 'PTHR10366:SF813', NULL, NULL, NULL, NULL, 'OS08G0515900 PROTEIN', 239506),
(304461, 'PTHR10366:SF812', NULL, NULL, NULL, NULL, 'HYDROXYSTEROID DEHYDROGENASE/ISOMERASE, PUTATIVE-RELATED', 239506),
(304462, 'PTHR10366:SF658', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 239506),
(304463, 'PTHR10366:SF815', NULL, NULL, NULL, NULL, 'LEUCOANTHOCYANIDIN REDUCTASE', 239506),
(304464, 'PTHR10366:SF814', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304465, 'PTHR10366:SF817', NULL, NULL, NULL, NULL, 'CINNAMOYL-COA REDUCTASE 1-LIKE', 239506),
(304466, 'PTHR10366:SF816', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/REDUCTASE FAMILY 42E MEMBER 1', 239506),
(304467, 'PTHR10366:SF819', NULL, NULL, NULL, NULL, 'REDUCTASE, PUTATIVE-RELATED', 239506),
(304468, 'PTHR10366:SF818', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304469, 'PTHR10366:SF781', NULL, NULL, NULL, NULL, '3BETA-HYDROXYSTEROID-DEHYDROGENASE/DECARBOXYLASE ISOFORM 2', 239506),
(304470, 'PTHR10366:SF660', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 239506),
(304471, 'PTHR10366:SF662', NULL, NULL, NULL, NULL, 'CINNAMYL ALCOHOL DEHYDROGENASE', 239506),
(304472, 'PTHR10366:SF782', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 239506),
(304473, 'PTHR10366:SF661', NULL, NULL, NULL, NULL, 'OS09G0127300 PROTEIN', 239506),
(304474, 'PTHR10366:SF784', NULL, NULL, NULL, NULL, '3 BETA-HYDROXYSTEROID DEHYDROGENASE/DELTA 5--4-ISOMERASE TYPE 2', 239506),
(304475, 'PTHR10366:SF663', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304476, 'PTHR10366:SF820', NULL, NULL, NULL, NULL, 'DIHYDROFLAVONOL-4-REDUCTASE', 239506),
(304477, 'PTHR10366:SF787', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304478, 'PTHR10366:SF786', NULL, NULL, NULL, NULL, 'OS09G0491820 PROTEIN', 239506),
(304479, 'PTHR10366:SF665', NULL, NULL, NULL, NULL, 'ANTHOCYANIDIN REDUCTASE', 239506),
(304480, 'PTHR10366:SF668', NULL, NULL, NULL, NULL, 'VESTITONE REDUCTASE-LIKE', 239506),
(304481, 'PTHR10366:SF822', NULL, NULL, NULL, NULL, 'CINNAMOYL-COA REDUCTASE-LIKE SNL6', 239506),
(304482, 'PTHR10366:SF789', NULL, NULL, NULL, NULL, 'VESTITONE REDUCTASE-LIKE', 239506),
(304483, 'PTHR10366:SF701', NULL, NULL, NULL, NULL, 'CINNAMOYL-COA REDUCTASE', 239506),
(304484, 'PTHR10366:SF700', NULL, NULL, NULL, NULL, 'OS09G0262000 PROTEIN', 239506),
(304485, 'PTHR10366:SF821', NULL, NULL, NULL, NULL, 'TETRAKETIDE ALPHA-PYRONE REDUCTASE 1', 239506),
(304486, 'PTHR10366:SF667', NULL, NULL, NULL, NULL, 'CINNAMOYL-COA REDUCTASE 2', 239506),
(304487, 'PTHR10366:SF824', NULL, NULL, NULL, NULL, 'CINNAMOYL-COA REDUCTASE', 239506),
(304488, 'PTHR10366:SF702', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304489, 'PTHR10366:SF823', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304490, 'PTHR10366:SF826', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-RHAMNOSE SYNTHASE/EPIMERASE-REDUCTASE', 239506),
(304491, 'PTHR10366:SF825', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 239506),
(304492, 'PTHR10366:SF707', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304493, 'PTHR10366:SF828', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304494, 'PTHR10366:SF827', NULL, NULL, NULL, NULL, 'DIHYDROFLAVONOL-4-REDUCTASE', 239506),
(304495, 'PTHR10366:SF709', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL POLYMYXIN RESISTANCE PROTEIN, ARNA-RELATED', 239506),
(304496, 'PTHR10366:SF829', NULL, NULL, NULL, NULL, '3BETA_HSD DOMAIN-CONTAINING PROTEIN', 239506),
(304497, 'PTHR10366:SF390', NULL, NULL, NULL, NULL, 'CINNAMOYL-COA REDUCTASE-LIKE PROTEIN', 239506),
(304498, 'PTHR10366:SF790', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304499, 'PTHR10366:SF792', NULL, NULL, NULL, NULL, 'HPNA PROTEIN', 239506),
(304500, 'PTHR10366:SF671', NULL, NULL, NULL, NULL, '3BETA_HSD DOMAIN-CONTAINING PROTEIN', 239506);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(304501, 'PTHR10366:SF794', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 239506),
(304502, 'PTHR10366:SF793', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304503, 'PTHR10366:SF672', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304504, 'PTHR10366:SF796', NULL, NULL, NULL, NULL, 'DIHYDROFLAVONOL-4-REDUCTASE-LIKE', 239506),
(304505, 'PTHR10366:SF675', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304506, 'PTHR10366:SF432', NULL, NULL, NULL, NULL, 'OS02G0180700 PROTEIN', 239506),
(304507, 'PTHR10366:SF795', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304508, 'PTHR10366:SF710', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304509, 'PTHR10366:SF798', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 239506),
(304510, 'PTHR10366:SF797', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 239506),
(304511, 'PTHR10366:SF676', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304512, 'PTHR10366:SF679', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304513, 'PTHR10366:SF799', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304514, 'PTHR10366:SF714', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304515, 'PTHR10366:SF713', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304516, 'PTHR10366:SF681', NULL, NULL, NULL, NULL, 'NAD(P)-BD_DOM DOMAIN-CONTAINING PROTEIN', 239506),
(304517, 'PTHR10366:SF562', NULL, NULL, NULL, NULL, 'ALDEHYDE REDUCTASE II (AFU_ORTHOLOGUE AFUA_1G11360)', 239506),
(304518, 'PTHR10366:SF563', NULL, NULL, NULL, NULL, 'CINNAMOYL-COA REDUCTASE 16', 239506),
(304519, 'PTHR10366:SF288', NULL, NULL, NULL, NULL, 'ANTHOCYANIDIN REDUCTASE', 239506),
(304520, 'PTHR10366:SF564', NULL, NULL, NULL, NULL, '3 BETA-HYDROXYSTEROID DEHYDROGENASE TYPE 7', 239506),
(304521, 'PTHR10366:SF688', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304522, 'PTHR10366:SF720', NULL, NULL, NULL, NULL, 'DIHYDROFLAVONOL 4-REDUCTASE', 239506),
(304523, 'PTHR10366:SF447', NULL, NULL, NULL, NULL, 'HYDROXYSTEROID DEHYDROGENASE/ISOMERASE FAMILY PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G06450)-RELATED', 239506),
(304524, 'PTHR10366:SF689', NULL, NULL, NULL, NULL, 'PROTEIN BRI1-5 ENHANCED 1', 239506),
(304525, 'PTHR10366:SF722', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL POLYMYXIN RESISTANCE PROTEIN, ARNA-RELATED', 239506),
(304526, 'PTHR10366:SF724', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304527, 'PTHR10366:SF727', NULL, NULL, NULL, NULL, 'OS04G0630600 PROTEIN', 239506),
(304528, 'PTHR10366:SF605', NULL, NULL, NULL, NULL, 'NAD(P)-BD_DOM DOMAIN-CONTAINING PROTEIN', 239506),
(304529, 'PTHR10366:SF726', NULL, NULL, NULL, NULL, 'OS04G0630400 PROTEIN', 239506),
(304530, 'PTHR10366:SF607', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304531, 'PTHR10366:SF728', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304532, 'PTHR10366:SF608', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304533, 'PTHR10366:SF609', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304534, 'PTHR10366:SF295', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 239506),
(304535, 'PTHR10366:SF693', NULL, NULL, NULL, NULL, '3BETA_HSD DOMAIN-CONTAINING PROTEIN', 239506),
(304536, 'PTHR10366:SF451', NULL, NULL, NULL, NULL, '3BETA_HSD DOMAIN-CONTAINING PROTEIN', 239506),
(304537, 'PTHR10366:SF692', NULL, NULL, NULL, NULL, 'NAD(P)-BD_DOM DOMAIN-CONTAINING PROTEIN', 239506),
(304538, 'PTHR10366:SF297', NULL, NULL, NULL, NULL, 'NADPH-DEPENDENT 3-KETO-STEROID REDUCTASE HSD3B4-RELATED', 239506),
(304539, 'PTHR10366:SF695', NULL, NULL, NULL, NULL, 'DIHYDROFLAVONOL 4-REDUCTASE', 239506),
(304540, 'PTHR10366:SF694', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(304541, 'PTHR10366:SF575', NULL, NULL, NULL, NULL, '3BETA_HSD DOMAIN-CONTAINING PROTEIN', 239506),
(304542, 'PTHR10366:SF696', NULL, NULL, NULL, NULL, '3BETA_HSD DOMAIN-CONTAINING PROTEIN', 239506),
(304543, 'PTHR10366:SF732', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304544, 'PTHR10366:SF731', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304545, 'PTHR10366:SF698', NULL, NULL, NULL, NULL, 'CINNAMOYL-COA REDUCTASE 1-LIKE', 239506),
(304546, 'PTHR10366:SF611', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304547, 'PTHR10366:SF579', NULL, NULL, NULL, NULL, '3-BETA HYDROXYSTEROID DEHYDROGENASE/ISOMERASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_3G02250)', 239506),
(304548, 'PTHR10366:SF613', NULL, NULL, NULL, NULL, 'DIHYDROFLAVONOL 4-REDUCTASE', 239506),
(304549, 'PTHR10366:SF733', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304550, 'PTHR10366:SF614', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304551, 'PTHR10366:SF736', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 239506),
(304552, 'PTHR10366:SF738', NULL, NULL, NULL, NULL, 'OS06G0651100 PROTEIN', 239506),
(304553, 'PTHR10366:SF617', NULL, NULL, NULL, NULL, 'DIHYDROFLAVONOL 4-REDUCTASE-LIKE PROTEIN', 239506),
(304554, 'PTHR10366:SF618', NULL, NULL, NULL, NULL, '3BETA_HSD DOMAIN-CONTAINING PROTEIN', 239506),
(304555, 'PTHR10366:SF740', NULL, NULL, NULL, NULL, 'CINNAMOYL-COA REDUCTASE', 239506),
(304556, 'PTHR10366:SF500', NULL, NULL, NULL, NULL, 'OS09G0491852 PROTEIN', 239506),
(304557, 'PTHR10366:SF589', NULL, NULL, NULL, NULL, 'CINNAMOYL-COA REDUCTASE-LIKE SNL6', 239506),
(304558, 'PTHR10366:SF742', NULL, NULL, NULL, NULL, '3BETA_HSD DOMAIN-CONTAINING PROTEIN', 239506),
(304559, 'PTHR10366:SF623', NULL, NULL, NULL, NULL, 'NAD DEPENDENT EPIMERASE/DEHYDRATASE FAMILY PROTEIN, EXPRESSED', 239506),
(304560, 'PTHR10366:SF349', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304561, 'PTHR10366:SF503', NULL, NULL, NULL, NULL, 'TETRAKETIDE ALPHA-PYRONE REDUCTASE 2', 239506),
(304562, 'PTHR10366:SF624', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 239506),
(304563, 'PTHR10366:SF746', NULL, NULL, NULL, NULL, 'NAD(P)-BD_DOM DOMAIN-CONTAINING PROTEIN', 239506),
(304564, 'PTHR10366:SF749', NULL, NULL, NULL, NULL, '3BETA_HSD DOMAIN-CONTAINING PROTEIN', 239506),
(304565, 'PTHR10366:SF627', NULL, NULL, NULL, NULL, 'CINNAMOYL-COA REDUCTASE-LIKE PROTEIN', 239506),
(304566, 'PTHR10366:SF628', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 239506),
(304567, 'PTHR10366:SF470', NULL, NULL, NULL, NULL, 'OS01G0283600 PROTEIN', 239506),
(304568, 'PTHR10366:SF353', NULL, NULL, NULL, NULL, 'CINNAMOYL-COA REDUCTASE 1', 239506),
(304569, 'PTHR10366:SF595', NULL, NULL, NULL, NULL, 'CINNAMOYL-COA REDUCTASE 1-LIKE', 239506),
(304570, 'PTHR10366:SF596', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304571, 'PTHR10366:SF355', NULL, NULL, NULL, NULL, '3BETA_HSD DOMAIN-CONTAINING PROTEIN', 239506),
(304572, 'PTHR10366:SF598', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 239506),
(304573, 'PTHR10366:SF756', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304574, 'PTHR10366:SF639', NULL, NULL, NULL, NULL, '3BETA-HYDROXYSTEROID-DEHYDROGENASE/DECARBOXYLASE ISOFORM 3', 239506),
(304575, 'PTHR10366:SF759', NULL, NULL, NULL, NULL, '3BETA_HSD DOMAIN-CONTAINING PROTEIN', 239506),
(304576, 'PTHR10366', NULL, NULL, NULL, NULL, 'NAD DEPENDENT EPIMERASE/DEHYDRATASE', 239506),
(304577, 'PTHR10366:SF483', NULL, NULL, NULL, NULL, 'CINNAMOYL COA REDUCTASE-LIKE PROTEIN', 239506),
(304578, 'PTHR10366:SF241', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/REDUCTASE FAMILY 42E MEMBER 2-RELATED', 239506),
(304579, 'PTHR10366:SF242', NULL, NULL, NULL, NULL, 'STEROL-4-ALPHA-CARBOXYLATE 3-DEHYDROGENASE, DECARBOXYLATING', 239506),
(304580, 'PTHR10366:SF364', NULL, NULL, NULL, NULL, '3BETA_HSD DOMAIN-CONTAINING PROTEIN', 239506);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(304581, 'PTHR10366:SF760', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304582, 'PTHR10366:SF763', NULL, NULL, NULL, NULL, 'OS06G0623300 PROTEIN', 239506),
(304583, 'PTHR10366:SF765', NULL, NULL, NULL, NULL, 'OS07G0601900 PROTEIN', 239506),
(304584, 'PTHR10366:SF369', NULL, NULL, NULL, NULL, 'CINNAMOYL-COA REDUCTASE-LIKE PROTEIN', 239506),
(304585, 'PTHR10366:SF800', NULL, NULL, NULL, NULL, 'CINNAMOYL-COA REDUCTASE 1-LIKE', 239506),
(304586, 'PTHR10366:SF404', NULL, NULL, NULL, NULL, 'CINNAMOYL-COA REDUCTASE 1', 239506),
(304587, 'PTHR10366:SF802', NULL, NULL, NULL, NULL, 'CINNAMYL ALCOHOL DEHYDROGENASE', 239506),
(304588, 'PTHR10366:SF769', NULL, NULL, NULL, NULL, 'CINNAMOYL-COA REDUCTASE 8', 239506),
(304589, 'PTHR10366:SF406', NULL, NULL, NULL, NULL, 'CINNAMOYL-COA REDUCTASE 1', 239506),
(304590, 'PTHR10366:SF768', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304591, 'PTHR10366:SF801', NULL, NULL, NULL, NULL, 'BNAC06G04550D PROTEIN', 239506),
(304592, 'PTHR10366:SF804', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304593, 'PTHR10366:SF803', NULL, NULL, NULL, NULL, 'DIHYDROFLAVONOL-4-REDUCTASE-LIKE', 239506),
(304594, 'PTHR10366:SF806', NULL, NULL, NULL, NULL, 'CINNAMOYL-COA REDUCTASE 1-LIKE', 239506),
(304595, 'PTHR10366:SF805', NULL, NULL, NULL, NULL, 'DIHYDROFLAVANOL-4-REDUCTASE 1', 239506),
(304596, 'PTHR10366:SF808', NULL, NULL, NULL, NULL, 'DIHYDROFLAVONOL-4-REDUCTASE-LIKE PROTEIN', 239506),
(304597, 'PTHR10366:SF807', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 239506),
(304598, 'PTHR10366:SF809', NULL, NULL, NULL, NULL, 'ANTHOCYANIDIN REDUCTASE-RELATED', 239506),
(304599, 'PTHR15467:SF4', NULL, NULL, NULL, NULL, 'ZINC FINGERS AND HOMEOBOXES PROTEIN 1', 239507),
(304600, 'PTHR15467:SF5', NULL, NULL, NULL, NULL, 'ZINC FINGERS AND HOMEOBOXES PROTEIN 2', 239507),
(304601, 'PTHR15467:SF6', NULL, NULL, NULL, NULL, 'ZINC FINGERS AND HOMEOBOXES PROTEIN 3', 239507),
(304602, 'PTHR15467:SF7', NULL, NULL, NULL, NULL, 'HOMEOBOX AND LEUCINE ZIPPER PROTEIN HOMEZ', 239507),
(304603, 'PTHR15467:SF9', NULL, NULL, NULL, NULL, 'DUX (VERTEBRATE DUAL HOMEOBOX) LIKE', 239507),
(304604, 'PTHR15467:SF10', NULL, NULL, NULL, NULL, 'HOMEOBOX AND LEUCINE ZIPPER ENCODING A-RELATED', 239507),
(304605, 'PTHR15467', NULL, NULL, NULL, NULL, 'ZINC-FINGERS AND HOMEOBOXES RELATED', 239507),
(304606, 'PTHR43665', NULL, NULL, NULL, NULL, 'ISOPENTENYL-DIPHOSPHATE DELTA-ISOMERASE', 239508),
(304607, 'PTHR43665:SF1', NULL, NULL, NULL, NULL, 'ISOPENTENYL-DIPHOSPHATE DELTA-ISOMERASE', 239508),
(304608, 'PTHR39369:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBR-LIN-24', 239509),
(304609, 'PTHR39369:SF6', NULL, NULL, NULL, NULL, 'LIN-24 (TWENTY-FOUR) LIKE', 239509),
(304610, 'PTHR39369', NULL, NULL, NULL, NULL, 'LIN-24 (TWENTY-FOUR) LIKE', 239509),
(304611, 'PTHR23525', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE-RELATED', 239510),
(304612, 'PTHR23525:SF1', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 239510),
(304613, 'PTHR35140:SF1', NULL, NULL, NULL, NULL, 'MITOTIC CHECK POINT PROTEIN BFA1', 239511),
(304614, 'PTHR35140', NULL, NULL, NULL, NULL, 'MITOTIC CHECK POINT PROTEIN BFA1', 239511),
(304615, 'PTHR18849:SF18', NULL, NULL, NULL, NULL, 'LRRCAP DOMAIN-CONTAINING PROTEIN', 239512),
(304616, 'PTHR18849:SF19', NULL, NULL, NULL, NULL, '', 239512),
(304617, 'PTHR18849:SF8', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING 61', 239512),
(304618, 'PTHR18849:SF4', NULL, NULL, NULL, NULL, 'GENE 29133-RELATED', 239512),
(304619, 'PTHR18849', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT PROTEIN', 239512),
(304620, 'PTHR18849:SF12', NULL, NULL, NULL, NULL, 'BNAA02G04390D PROTEIN', 239512),
(304621, 'PTHR18849:SF3', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT CONTAINING 23, ISOFORM CRA_A', 239512),
(304622, 'PTHR18849:SF13', NULL, NULL, NULL, NULL, 'BNAUNNG04160D PROTEIN', 239512),
(304623, 'PTHR18849:SF0', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 410-RELATED', 239512),
(304624, 'PTHR21771:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIA-EATING PROTEIN', 239513);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(304625, 'PTHR21771:SF0', NULL, NULL, NULL, NULL, 'MITOCHONDRIA-EATING PROTEIN', 239513),
(304626, 'PTHR21771', NULL, NULL, NULL, NULL, 'MITOCHONDRIA-EATING PROTEIN-RELATED', 239513),
(304627, 'PTHR42110', NULL, NULL, NULL, NULL, 'L-ASPARAGINASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G11890)-RELATED', 239514),
(304628, 'PTHR42110:SF1', NULL, NULL, NULL, NULL, 'L-ASPARAGINASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G11890)-RELATED', 239514),
(304629, 'PTHR24002:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG22167', 239515),
(304630, 'PTHR24002:SF3', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER 18', 239515),
(304631, 'PTHR24002', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER 18', 239515),
(304632, 'PTHR47226:SF3', NULL, NULL, NULL, NULL, 'C2 CALCIUM-DEPENDENT DOMAIN-CONTAINING PROTEIN 4A', 239516),
(304633, 'PTHR47226:SF1', NULL, NULL, NULL, NULL, 'C2 CALCIUM-DEPENDENT DOMAIN-CONTAINING PROTEIN 4B', 239516),
(304634, 'PTHR47226:SF4', NULL, NULL, NULL, NULL, 'C2 CALCIUM-DEPENDENT DOMAIN-CONTAINING 4A', 239516),
(304635, 'PTHR47226:SF5', NULL, NULL, NULL, NULL, '', 239516),
(304636, 'PTHR47226', NULL, NULL, NULL, NULL, 'C2 CALCIUM-DEPENDENT DOMAIN-CONTAINING PROTEIN 4A', 239516),
(304637, 'PTHR42813:SF7', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE (ZN-DEPENDENT)-RELATED', 239517),
(304638, 'PTHR42813:SF1', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G03930)-RELATED', 239517),
(304639, 'PTHR42813', NULL, NULL, NULL, NULL, 'ZINC-TYPE ALCOHOL DEHYDROGENASE-LIKE', 239517),
(304640, 'PTHR42813:SF2', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, ZINC-CONTAINING, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G02810)-RELATED', 239517),
(304641, 'PTHR42813:SF6', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE (EUROFUNG)', 239517),
(304642, 'PTHR42813:SF3', NULL, NULL, NULL, NULL, 'GLUTATHIONE-INDEPENDENT FORMALDEHYDE DEHYDROGENASE', 239517),
(304643, 'PTHR42813:SF4', NULL, NULL, NULL, NULL, 'DEHYDROGENASE 1, PUTATIVE-RELATED', 239517),
(304644, 'PTHR36522:SF1', NULL, NULL, NULL, NULL, 'AT HOOK-CONTAINING PROTEIN ATTF-4', 239518),
(304645, 'PTHR36522', NULL, NULL, NULL, NULL, 'AT HOOK-CONTAINING PROTEIN ATTF-4', 239518),
(304646, 'PTHR39472', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239519),
(304647, 'PTHR39472:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239519),
(304648, 'PTHR47690:SF1', NULL, NULL, NULL, NULL, 'GLUCOKINASE', 239520),
(304649, 'PTHR47690', NULL, NULL, NULL, NULL, 'GLUCOKINASE', 239520),
(304650, 'PTHR32556:SF17', NULL, NULL, NULL, NULL, '', 239521),
(304651, 'PTHR32556', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239521),
(304652, 'PTHR32556:SF18', NULL, NULL, NULL, NULL, '', 239521),
(304653, 'PTHR32556:SF4', NULL, NULL, NULL, NULL, '', 239521),
(304654, 'PTHR32556:SF7', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239521),
(304655, 'PTHR32556:SF6', NULL, NULL, NULL, NULL, '', 239521),
(304656, 'PTHR32556:SF21', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239521),
(304657, 'PTHR32556:SF11', NULL, NULL, NULL, NULL, '', 239521),
(304658, 'PTHR32556:SF2', NULL, NULL, NULL, NULL, '', 239521),
(304659, 'PTHR36454:SF1', NULL, NULL, NULL, NULL, 'LMO2823 PROTEIN', 239522),
(304660, 'PTHR36454', NULL, NULL, NULL, NULL, 'LMO2823 PROTEIN', 239522),
(304661, 'PTHR31270:SF1', NULL, NULL, NULL, NULL, 'GLUTAMINYL-PEPTIDE CYCLOTRANSFERASE', 239523),
(304662, 'PTHR31270', NULL, NULL, NULL, NULL, 'GLUTAMINYL-PEPTIDE CYCLOTRANSFERASE', 239523),
(304663, 'PTHR31270:SF2', NULL, NULL, NULL, NULL, 'GLUTAMINYL-PEPTIDE CYCLOTRANSFERASE-LIKE', 239523),
(304664, 'PTHR31270:SF3', NULL, NULL, NULL, NULL, '', 239523),
(304665, 'PTHR15837:SF5', NULL, NULL, NULL, NULL, '', 239524),
(304666, 'PTHR15837:SF4', NULL, NULL, NULL, NULL, 'BNAA07G24140D PROTEIN', 239524),
(304667, 'PTHR15837', NULL, NULL, NULL, NULL, 'RAN GUANINE NUCLEOTIDE RELEASE FACTOR', 239524),
(304668, 'PTHR15837:SF0', NULL, NULL, NULL, NULL, 'RAN GUANINE NUCLEOTIDE RELEASE FACTOR', 239524),
(304669, 'PTHR37885', NULL, NULL, NULL, NULL, 'CMT1A DUPLICATED REGION TRANSCRIPT 4 PROTEIN', 239525),
(304670, 'PTHR37885:SF1', NULL, NULL, NULL, NULL, 'CMT1A DUPLICATED REGION TRANSCRIPT 4 PROTEIN', 239525);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(304671, 'PTHR45751:SF29', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RGLG2', 239526),
(304672, 'PTHR45751', NULL, NULL, NULL, NULL, 'COPINE FAMILY PROTEIN 1', 239526),
(304673, 'PTHR45751:SF24', NULL, NULL, NULL, NULL, 'COPINE-RELATED', 239526),
(304674, 'PTHR45751:SF46', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 239526),
(304675, 'PTHR45751:SF45', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RGLG2-LIKE PROTEIN', 239526),
(304676, 'PTHR45751:SF33', NULL, NULL, NULL, NULL, 'OS08G0494300 PROTEIN', 239526),
(304677, 'PTHR45751:SF11', NULL, NULL, NULL, NULL, 'COPINE FAMILY PROTEIN 1', 239526),
(304678, 'PTHR45751:SF22', NULL, NULL, NULL, NULL, 'COPINE DOMAIN-CONTAINING PROTEIN', 239526),
(304679, 'PTHR45751:SF44', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RGLG2-LIKE PROTEIN', 239526),
(304680, 'PTHR45751:SF43', NULL, NULL, NULL, NULL, 'COPINE FAMILY PROTEIN 2', 239526),
(304681, 'PTHR45751:SF38', NULL, NULL, NULL, NULL, 'OS06G0608800 PROTEIN', 239526),
(304682, 'PTHR45751:SF16', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RGLG4', 239526),
(304683, 'PTHR45751:SF26', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239526),
(304684, 'PTHR45751:SF15', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RGLG1', 239526),
(304685, 'PTHR45751:SF47', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239526),
(304686, 'PTHR45751:SF25', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 239526),
(304687, 'PTHR45751:SF41', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239526),
(304688, 'PTHR45751:SF30', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RGLG5', 239526),
(304689, 'PTHR45751:SF40', NULL, NULL, NULL, NULL, 'PUTATIVE, EXPRESSED-RELATED', 239526),
(304690, 'PTHR11108:SF4', NULL, NULL, NULL, NULL, 'FERROCHELATASE-1, CHLOROPLASTIC/MITOCHONDRIAL', 239527),
(304691, 'PTHR11108:SF9', NULL, NULL, NULL, NULL, 'FERROCHELATASE-2, CHLOROPLASTIC', 239527),
(304692, 'PTHR11108:SF6', NULL, NULL, NULL, NULL, 'FERROCHELATASE', 239527),
(304693, 'PTHR11108', NULL, NULL, NULL, NULL, 'FERROCHELATASE', 239527),
(304694, 'PTHR11108:SF10', NULL, NULL, NULL, NULL, 'MYOSIN MOTOR DOMAIN-CONTAINING PROTEIN', 239527),
(304695, 'PTHR11108:SF1', NULL, NULL, NULL, NULL, 'FERROCHELATASE, MITOCHONDRIAL', 239527),
(304696, 'PTHR30466:SF1', NULL, NULL, NULL, NULL, 'FMN REDUCTASE (NADH) RUTF', 239528),
(304697, 'PTHR30466', NULL, NULL, NULL, NULL, 'FLAVIN REDUCTASE', 239528),
(304698, 'PTHR30466:SF11', NULL, NULL, NULL, NULL, 'FLAVIN-DEPENDENT MONOOXYGENASE, REDUCTASE SUBUNIT HSAB', 239528),
(304699, 'PTHR30466:SF15', NULL, NULL, NULL, NULL, 'POSSIBLE OXIDOREDUCTASE', 239528),
(304700, 'PTHR34313:SF2', NULL, NULL, NULL, NULL, 'ENDOGENOUS RETROVIRUS GROUP K MEMBER 113 ENV POLYPROTEIN-RELATED', 239529),
(304701, 'PTHR34313', NULL, NULL, NULL, NULL, 'ENDOGENOUS RETROVIRUS GROUP K MEMBER 113 ENV POLYPROTEIN-RELATED', 239529),
(304702, 'PTHR38146:SF8', NULL, NULL, NULL, NULL, 'TIFY DOMAIN-CONTAINING PROTEIN', 239530),
(304703, 'PTHR38146:SF9', NULL, NULL, NULL, NULL, 'UNKNOW PROTEIN', 239530),
(304704, 'PTHR38146', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S12, CHLOROPLASTIC', 239530),
(304705, 'PTHR35735', NULL, NULL, NULL, NULL, 'PROTEIN NIM1-INTERACTING 2', 239531),
(304706, 'PTHR35735:SF5', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN DDB_G0274347-LIKE', 239531),
(304707, 'PTHR35735:SF4', NULL, NULL, NULL, NULL, 'PROTEIN NIM1-INTERACTING 2', 239531),
(304708, 'PTHR35735:SF10', NULL, NULL, NULL, NULL, 'BNAA02G27670D PROTEIN', 239531),
(304709, 'PTHR35735:SF6', NULL, NULL, NULL, NULL, 'NIMIN2C PROTEIN', 239531),
(304710, 'PTHR35735:SF11', NULL, NULL, NULL, NULL, 'NIMIN2C PROTEIN', 239531),
(304711, 'PTHR35735:SF12', NULL, NULL, NULL, NULL, '', 239531),
(304712, 'PTHR35735:SF8', NULL, NULL, NULL, NULL, 'PROTEIN NEGATIVE REGULATOR OF RESISTANCE-LIKE', 239531),
(304713, 'PTHR35735:SF13', NULL, NULL, NULL, NULL, '', 239531),
(304714, 'PTHR35735:SF14', NULL, NULL, NULL, NULL, 'BNAA06G33280D PROTEIN', 239531),
(304715, 'PTHR35453:SF1', NULL, NULL, NULL, NULL, 'PROSTATE ANDROGEN-REGULATED MUCIN-LIKE PROTEIN 1', 239532);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(304716, 'PTHR35453', NULL, NULL, NULL, NULL, 'PROSTATE ANDROGEN-REGULATED MUCIN-LIKE PROTEIN 1', 239532),
(304717, 'PTHR47227:SF3', NULL, NULL, NULL, NULL, 'RNA POLYMERASES I, II, AND III 14.4 KDA POLYPEPTIDE, PUTATIVE-RELATED', 239533),
(304718, 'PTHR47227:SF4', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASES II AND V SUBUNIT 6B', 239533),
(304719, 'PTHR47227:SF5', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASES I, II, AND III SUBUNIT RPABC2', 239533),
(304720, 'PTHR47227:SF6', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASES II IV AND V SUBUNIT 6A', 239533),
(304721, 'PTHR47227', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT K', 239533),
(304722, 'PTHR37915', NULL, NULL, NULL, NULL, '', 239534),
(304723, 'PTHR37915:SF3', NULL, NULL, NULL, NULL, '', 239534),
(304724, 'PTHR31735', NULL, NULL, NULL, NULL, 'VACUOLAR MEMBRANE PROTEIN YPL162C', 239535),
(304725, 'PTHR31735:SF1', NULL, NULL, NULL, NULL, 'VACUOLAR MEMBRANE PROTEIN YPL162C', 239535),
(304726, 'PTHR31735:SF2', NULL, NULL, NULL, NULL, 'STORE-OPERATED CALCIUM ENTRY REGULATOR STIMATE', 239535),
(304727, 'PTHR31735:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 110,-LIKE', 239535),
(304728, 'PTHR45927:SF2', NULL, NULL, NULL, NULL, 'SERINE/THREONINE RECEPTOR-LIKE KINASE NFP', 239536),
(304729, 'PTHR45927', NULL, NULL, NULL, NULL, 'LYSM-DOMAIN RECEPTOR-LIKE KINASE-RELATED', 239536),
(304730, 'PTHR45927:SF5', NULL, NULL, NULL, NULL, 'PROTEIN LYK5-LIKE', 239536),
(304731, 'PTHR45927:SF7', NULL, NULL, NULL, NULL, 'LYSM-DOMAIN RECEPTOR-LIKE KINASE', 239536),
(304732, 'PTHR45927:SF13', NULL, NULL, NULL, NULL, 'PROTEIN LYK2', 239536),
(304733, 'PTHR45927:SF14', NULL, NULL, NULL, NULL, 'OS06G0625300 PROTEIN', 239536),
(304734, 'PTHR45927:SF6', NULL, NULL, NULL, NULL, 'PROTEIN LYK5', 239536),
(304735, 'PTHR45927:SF15', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239536),
(304736, 'PTHR45927:SF9', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN / PEPTIDOGLYCAN-BINDING LYSM DOMAIN-CONTAINING PROTEIN, PUTATIVE-RELATED', 239536),
(304737, 'PTHR45927:SF17', NULL, NULL, NULL, NULL, 'SERINE-THREONINE PROTEIN KINASE, PLANT-TYPE', 239536),
(304738, 'PTHR45927:SF20', NULL, NULL, NULL, NULL, '', 239536),
(304739, 'PTHR45927:SF10', NULL, NULL, NULL, NULL, 'LYSM-DOMAIN RECEPTOR-LIKE KINASE', 239536),
(304740, 'PTHR45927:SF21', NULL, NULL, NULL, NULL, 'LYSM-DOMAIN RECEPTOR-LIKE KINASE', 239536),
(304741, 'PTHR45927:SF11', NULL, NULL, NULL, NULL, 'LYSM DOMAIN RECEPTOR-LIKE KINASE 4', 239536),
(304742, 'PTHR36424:SF1', NULL, NULL, NULL, NULL, 'LOW AFFINITY K(+) TRANSPORTER 1-RELATED', 239537),
(304743, 'PTHR36424', NULL, NULL, NULL, NULL, 'PHEROMONE-REGULATED MEMBRANE PROTEIN 6', 239537),
(304744, 'PTHR42180:SF4', NULL, NULL, NULL, NULL, 'HOMOLOGY DOMAIN-CONTAINING PROTEIN, PUTATIVE-RELATED', 239538),
(304745, 'PTHR42180:SF5', NULL, NULL, NULL, NULL, 'CALPONIN-HOMOLOGY (CH) DOMAIN-CONTAINING PROTEIN', 239538),
(304746, 'PTHR42180', NULL, NULL, NULL, NULL, 'HOMOLOGY DOMAIN-CONTAINING PROTEIN,PUTATIVE-RELATED', 239538),
(304747, 'PTHR43018:SF3', NULL, NULL, NULL, NULL, 'CARBOXYSOME FORMATION PROTEIN', 239539),
(304748, 'PTHR43018', NULL, NULL, NULL, NULL, 'PHOSPHO-2-DEHYDRO-3-DEOXYHEPTONATE ALDOLASE', 239539),
(304749, 'PTHR43018:SF1', NULL, NULL, NULL, NULL, 'PROTEIN AROA(G)', 239539),
(304750, 'PTHR43018:SF2', NULL, NULL, NULL, NULL, 'PHOSPHO-2-DEHYDRO-3-DEOXYHEPTONATE ALDOLASE', 239539),
(304751, 'PTHR46350', NULL, NULL, NULL, NULL, 'RAS LIKE FAMILY 10 MEMBER B-RELATED', 239540),
(304752, 'PTHR46350:SF2', NULL, NULL, NULL, NULL, 'SMALL MONOMERIC GTPASE', 239540),
(304753, 'PTHR46350:SF1', NULL, NULL, NULL, NULL, 'RAS-LIKE PROTEIN FAMILY MEMBER 10B', 239540),
(304754, 'PTHR46350:SF3', NULL, NULL, NULL, NULL, 'RAS-LIKE PROTEIN FAMILY MEMBER 10A', 239540),
(304755, 'PTHR16120', NULL, NULL, NULL, NULL, 'AP-5 COMPLEX SUBUNIT SIGMA-1', 239541),
(304756, 'PTHR16120:SF0', NULL, NULL, NULL, NULL, 'AP-5 COMPLEX SUBUNIT SIGMA-1', 239541),
(304757, 'PTHR11785:SF238', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 7 MEMBER 13', 239542);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(304758, 'PTHR11785:SF117', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER', 239542),
(304759, 'PTHR11785:SF315', NULL, NULL, NULL, NULL, 'LARGE NEUTRAL AMINO ACIDS TRANSPORTER SMALL SUBUNIT 1', 239542),
(304760, 'PTHR11785:SF514', NULL, NULL, NULL, NULL, 'B(0,+)-TYPE AMINO ACID TRANSPORTER 1-LIKE PROTEIN', 239542),
(304761, 'PTHR11785:SF437', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 7 MEMBER 13-LIKE', 239542),
(304762, 'PTHR11785:SF515', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 7 MEMBER 5', 239542),
(304763, 'PTHR11785:SF516', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 239542),
(304764, 'PTHR11785:SF517', NULL, NULL, NULL, NULL, 'SI:DKEYP-120H9.1', 239542),
(304765, 'PTHR11785:SF518', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 7 MEMBER 10A', 239542),
(304766, 'PTHR11785:SF519', NULL, NULL, NULL, NULL, 'LARGE NEUTRAL AMINO ACIDS TRANSPORTER SMALL SUBUNIT 1-LIKE', 239542),
(304767, 'PTHR11785:SF73', NULL, NULL, NULL, NULL, 'ASC-TYPE AMINO ACID TRANSPORTER 1', 239542),
(304768, 'PTHR11785:SF353', NULL, NULL, NULL, NULL, 'METHIONINE TRANSPORTER (EUROFUNG)', 239542),
(304769, 'PTHR11785:SF375', NULL, NULL, NULL, NULL, '', 239542),
(304770, 'PTHR11785:SF398', NULL, NULL, NULL, NULL, 'Y+L AMINO ACID TRANSPORTER 2', 239542),
(304771, 'PTHR11785:SF354', NULL, NULL, NULL, NULL, 'B(0,+)-TYPE AMINO ACID TRANSPORTER 1', 239542),
(304772, 'PTHR11785:SF530', NULL, NULL, NULL, NULL, 'LD25378P', 239542),
(304773, 'PTHR11785:SF531', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER', 239542),
(304774, 'PTHR11785:SF498', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY METHIONINE PERMEASE', 239542),
(304775, 'PTHR11785:SF113', NULL, NULL, NULL, NULL, 'LARGE NEUTRAL AMINO ACIDS TRANSPORTER SMALL SUBUNIT 2', 239542),
(304776, 'PTHR11785:SF213', NULL, NULL, NULL, NULL, 'Y+L AMINO ACID TRANSPORTER 2-LIKE', 239542),
(304777, 'PTHR11785:SF532', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (EUROFUNG)-RELATED', 239542),
(304778, 'PTHR11785:SF533', NULL, NULL, NULL, NULL, '', 239542),
(304779, 'PTHR11785:SF115', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER', 239542),
(304780, 'PTHR11785:SF512', NULL, NULL, NULL, NULL, 'SOBREMESA, ISOFORM B', 239542),
(304781, 'PTHR11785:SF348', NULL, NULL, NULL, NULL, 'ASC-TYPE AMINO ACID TRANSPORTER 2', 239542),
(304782, 'PTHR11785:SF502', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER', 239542),
(304783, 'PTHR11785:SF528', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER PROTEIN JHI-21', 239542),
(304784, 'PTHR11785:SF340', NULL, NULL, NULL, NULL, 'AROMATIC-PREFERRING AMINO ACID TRANSPORTER', 239542),
(304785, 'PTHR11785:SF421', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER', 239542),
(304786, 'PTHR11785:SF389', NULL, NULL, NULL, NULL, '', 239542),
(304787, 'PTHR11785:SF323', NULL, NULL, NULL, NULL, 'CYSTINE/GLUTAMATE TRANSPORTER', 239542),
(304788, 'PTHR11785:SF246', NULL, NULL, NULL, NULL, 'SI:CH73-352P4.8', 239542),
(304789, 'PTHR11785:SF302', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER', 239542),
(304790, 'PTHR11785:SF303', NULL, NULL, NULL, NULL, 'Y+L AMINO ACID TRANSPORTER 1', 239542),
(304791, 'PTHR11785:SF523', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER PROTEIN 6', 239542),
(304792, 'PTHR11785:SF402', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER (EUROFUNG)', 239542),
(304793, 'PTHR11785', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER', 239542),
(304794, 'PTHR11785:SF382', NULL, NULL, NULL, NULL, 'LOW-AFFINITY METHIONINE PERMEASE', 239542),
(304795, 'PTHR11785:SF240', NULL, NULL, NULL, NULL, 'GH08870P', 239542),
(304796, 'PTHR42815:SF2', NULL, NULL, NULL, NULL, 'FAD-BINDING, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G07600)-RELATED', 239543),
(304797, 'PTHR42815', NULL, NULL, NULL, NULL, 'FAD-BINDING, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G07600)-RELATED', 239543),
(304798, 'PTHR13619', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239544),
(304799, 'PTHR13619:SF1', NULL, NULL, NULL, NULL, 'CDP-DIACYLGLYCEROL SYNTHASE', 239544),
(304800, 'PTHR13619:SF0', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE CYTIDYLYLTRANSFERASE, MITOCHONDRIAL', 239544),
(304801, 'PTHR31994', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 42', 239545);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(304802, 'PTHR31994:SF3', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 42', 239545),
(304803, 'PTHR40237:SF1', NULL, NULL, NULL, NULL, 'LD44813P', 239546),
(304804, 'PTHR40237', NULL, NULL, NULL, NULL, 'LD44813P', 239546),
(304805, 'PTHR10938:SF0', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR IF-3, MITOCHONDRIAL', 239547),
(304806, 'PTHR10938:SF3', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR IF3-2, CHLOROPLASTIC', 239547),
(304807, 'PTHR10938:SF5', NULL, NULL, NULL, NULL, 'IF3_N DOMAIN-CONTAINING PROTEIN', 239547),
(304808, 'PTHR10938:SF4', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR IF3-1, MITOCHONDRIAL', 239547),
(304809, 'PTHR10938:SF7', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR IF-3', 239547),
(304810, 'PTHR10938', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR IF-3', 239547),
(304811, 'PTHR23104:SF1', NULL, NULL, NULL, NULL, 'CELL GROWTH REGULATOR WITH EF HAND DOMAIN PROTEIN 1', 239548),
(304812, 'PTHR23104', NULL, NULL, NULL, NULL, 'MULTIPLE COAGULATION FACTOR DEFICIENCY PROTEIN 2  NEURAL STEM CELL DERIVED NEURONAL SURVIVAL PROTEIN', 239548),
(304813, 'PTHR23104:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG12288', 239548),
(304814, 'PTHR23104:SF14', NULL, NULL, NULL, NULL, 'MULTIPLE COAGULATION FACTOR DEFICIENCY PROTEIN 2', 239548),
(304815, 'PTHR23104:SF13', NULL, NULL, NULL, NULL, '', 239548),
(304816, 'PTHR23104:SF12', NULL, NULL, NULL, NULL, 'HLH DOMAIN-CONTAINING PROTEIN', 239548),
(304817, 'PTHR12166:SF7', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT SECRETION ACTIVATOR 2', 239549),
(304818, 'PTHR12166:SF8', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT SECRETION ACTIVATOR', 239549),
(304819, 'PTHR12166:SF6', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT SECRETION ACTIVATOR 1', 239549),
(304820, 'PTHR12166', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT SECRETION ACTIVATOR', 239549),
(304821, 'PTHR47604:SF1', NULL, NULL, NULL, NULL, 'ADENYLYL CYCLASE', 239550),
(304822, 'PTHR47604', NULL, NULL, NULL, NULL, 'ADENYLYL CYCLASE', 239550),
(304823, 'PTHR47604:SF2', NULL, NULL, NULL, NULL, 'ADENYLYL CYCLASE', 239550),
(304824, 'PTHR43846:SF1', NULL, NULL, NULL, NULL, 'TRNA URIDINE(34) HYDROXYLASE', 239551),
(304825, 'PTHR43846', NULL, NULL, NULL, NULL, 'UPF0176 PROTEIN YCEA', 239551),
(304826, 'PTHR22406', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239552),
(304827, 'PTHR22406:SF7', NULL, NULL, NULL, NULL, '', 239552),
(304828, 'PTHR22406:SF5', NULL, NULL, NULL, NULL, 'SLAIN MOTIF-CONTAINING PROTEIN-LIKE', 239552),
(304829, 'PTHR22406:SF4', NULL, NULL, NULL, NULL, 'SLAIN MOTIF-CONTAINING PROTEIN 2', 239552),
(304830, 'PTHR22406:SF2', NULL, NULL, NULL, NULL, 'SLAIN MOTIF-CONTAINING PROTEIN 1', 239552),
(304831, 'PTHR42990', NULL, NULL, NULL, NULL, 'ATPASE', 239553),
(304832, 'PTHR42990:SF1', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 239553),
(304833, 'PTHR20929:SF11', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL INTERMEDIATE CHAIN 7', 239554),
(304834, 'PTHR20929', NULL, NULL, NULL, NULL, 'LUNG ADENOMA SUSCEPTIBILITY 1-RELATED', 239554),
(304835, 'PTHR47325:SF2', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SUVR5-LIKE PROTEIN', 239555),
(304836, 'PTHR47325:SF1', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SUVR5', 239555),
(304837, 'PTHR47325', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SUVR5', 239555),
(304838, 'PTHR36515', NULL, NULL, NULL, NULL, 'PROTEIN CBG00810', 239556),
(304839, 'PTHR36515:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG00810', 239556),
(304840, 'PTHR33869:SF4', NULL, NULL, NULL, NULL, '', 239557),
(304841, 'PTHR33869:SF5', NULL, NULL, NULL, NULL, 'OS05G0561300 PROTEIN', 239557),
(304842, 'PTHR33869:SF10', NULL, NULL, NULL, NULL, '', 239557),
(304843, 'PTHR33869:SF32', NULL, NULL, NULL, NULL, 'BNAA02G16350D PROTEIN', 239557),
(304844, 'PTHR33869:SF31', NULL, NULL, NULL, NULL, 'BNAC06G43910D PROTEIN', 239557),
(304845, 'PTHR33869:SF30', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 2', 239557),
(304846, 'PTHR33869:SF29', NULL, NULL, NULL, NULL, '', 239557);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(304847, 'PTHR33869:SF18', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 1', 239557),
(304848, 'PTHR33869:SF17', NULL, NULL, NULL, NULL, 'OS06G0534200 PROTEIN', 239557),
(304849, 'PTHR33869:SF28', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 4', 239557),
(304850, 'PTHR33869:SF27', NULL, NULL, NULL, NULL, 'OS02G0250100 PROTEIN', 239557),
(304851, 'PTHR33869:SF26', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 3', 239557),
(304852, 'PTHR33869:SF14', NULL, NULL, NULL, NULL, 'CLE FAMILY OSCLE509 PROTEIN', 239557),
(304853, 'PTHR33869:SF24', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 33', 239557),
(304854, 'PTHR33869:SF12', NULL, NULL, NULL, NULL, '', 239557),
(304855, 'PTHR33869:SF33', NULL, NULL, NULL, NULL, 'BNAA03G58130D PROTEIN', 239557),
(304856, 'PTHR33869', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 3', 239557),
(304857, 'PTHR33869:SF11', NULL, NULL, NULL, NULL, 'CLE FAMILY OSCLE601 PROTEIN', 239557),
(304858, 'PTHR15301:SF11', NULL, NULL, NULL, NULL, 'INSULIN-INDUCED GENE 1 PROTEIN', 239558),
(304859, 'PTHR15301:SF10', NULL, NULL, NULL, NULL, 'INSULIN-INDUCED GENE 2 PROTEIN', 239558),
(304860, 'PTHR15301:SF12', NULL, NULL, NULL, NULL, 'INSILUN INDUCED PROTEIN', 239558),
(304861, 'PTHR15301:SF3', NULL, NULL, NULL, NULL, 'PROTEIN NSG1-RELATED', 239558),
(304862, 'PTHR15301', NULL, NULL, NULL, NULL, 'INSULIN-INDUCED GENE 1', 239558),
(304863, 'PTHR46923', NULL, NULL, NULL, NULL, 'CATION CHANNEL SPERM-ASSOCIATED PROTEIN 2', 239559),
(304864, 'PTHR46923:SF1', NULL, NULL, NULL, NULL, 'CATION CHANNEL SPERM-ASSOCIATED PROTEIN 2', 239559),
(304865, 'PTHR11695:SF294', NULL, NULL, NULL, NULL, 'RETICULON-4-INTERACTING PROTEIN 1, MITOCHONDRIAL', 239560),
(304866, 'PTHR11695:SF648', NULL, NULL, NULL, NULL, 'ZINC-BINDING OXIDOREDUCTASE', 239560),
(304867, 'PTHR11695:SF647', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 239560),
(304868, 'PTHR11695', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE RELATED', 239560),
(304869, 'PTHR11695:SF645', NULL, NULL, NULL, NULL, 'RETICULON-4-INTERACTING PROTEIN 1, MITOCHONDRIAL-LIKE PROTEIN', 239560),
(304870, 'PTHR11607:SF57', NULL, NULL, NULL, NULL, 'ALPHA-MANNOSIDASE 2X', 239561),
(304871, 'PTHR11607:SF68', NULL, NULL, NULL, NULL, 'ALPHA-MANNOSIDASE F', 239561),
(304872, 'PTHR11607:SF25', NULL, NULL, NULL, NULL, 'ALPHA-MANNOSIDASE C', 239561),
(304873, 'PTHR11607:SF58', NULL, NULL, NULL, NULL, 'ALPHA-MANNOSIDASE', 239561),
(304874, 'PTHR11607:SF19', NULL, NULL, NULL, NULL, 'ALPHA-MANNOSIDASE B', 239561),
(304875, 'PTHR11607:SF39', NULL, NULL, NULL, NULL, 'ALPHA-MANNOSIDASE D-RELATED', 239561),
(304876, 'PTHR11607:SF28', NULL, NULL, NULL, NULL, 'EPIDIDYMIS-SPECIFIC ALPHA-MANNOSIDASE', 239561),
(304877, 'PTHR11607:SF62', NULL, NULL, NULL, NULL, 'ALPHA-MANNOSIDASE', 239561),
(304878, 'PTHR11607', NULL, NULL, NULL, NULL, 'ALPHA-MANNOSIDASE', 239561),
(304879, 'PTHR11607:SF60', NULL, NULL, NULL, NULL, 'ALPHA-MANNOSIDASE', 239561),
(304880, 'PTHR11607:SF61', NULL, NULL, NULL, NULL, 'ALPHA-MANNOSIDASE', 239561),
(304881, 'PTHR11607:SF66', NULL, NULL, NULL, NULL, 'ALPHA-MANNOSIDASE', 239561),
(304882, 'PTHR11607:SF67', NULL, NULL, NULL, NULL, 'ALPHA-MANNOSIDASE', 239561),
(304883, 'PTHR11607:SF3', NULL, NULL, NULL, NULL, 'ALPHA-MANNOSIDASE 2-RELATED', 239561),
(304884, 'PTHR34075', NULL, NULL, NULL, NULL, 'BLR3430 PROTEIN', 239562),
(304885, 'PTHR34075:SF4', NULL, NULL, NULL, NULL, 'DUF35_N DOMAIN-CONTAINING PROTEIN', 239562),
(304886, 'PTHR34075:SF5', NULL, NULL, NULL, NULL, 'BLR3430 PROTEIN', 239562),
(304887, 'PTHR46229', NULL, NULL, NULL, NULL, 'BOLA TRANSCRIPTION REGULATOR', 239563),
(304888, 'PTHR46229:SF4', NULL, NULL, NULL, NULL, 'ACID STRESS PROTEIN IBAG', 239563),
(304889, 'PTHR46229:SF3', NULL, NULL, NULL, NULL, 'BOLA-LIKE PROTEIN DDB_G0274169', 239563),
(304890, 'PTHR46229:SF2', NULL, NULL, NULL, NULL, 'BOLA-LIKE PROTEIN 1', 239563),
(304891, 'PTHR21847', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING DOMAIN-CONTAINING PROTEIN 10', 239564),
(304892, 'PTHR21847:SF1', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING DOMAIN-CONTAINING PROTEIN 10', 239564);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(304893, 'PTHR14789:SF6', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING 14A', 239565),
(304894, 'PTHR14789', NULL, NULL, NULL, NULL, 'CHONDROLECTIN VARIANT CHODLFDELTAE.', 239565),
(304895, 'PTHR14789:SF1', NULL, NULL, NULL, NULL, 'CHONDROLECTIN', 239565),
(304896, 'PTHR14789:SF2', NULL, NULL, NULL, NULL, 'LAYILIN', 239565),
(304897, 'PTHR14789:SF4', NULL, NULL, NULL, NULL, 'ENDOSIALIN', 239565),
(304898, 'PTHR14789:SF5', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 14 MEMBER A', 239565),
(304899, 'PTHR11918:SF45', NULL, NULL, NULL, NULL, 'THREONYLCARBAMOYLADENOSINE TRNA METHYLTHIOTRANSFERASE', 239566),
(304900, 'PTHR11918', NULL, NULL, NULL, NULL, 'RADICAL SAM PROTEINS', 239566),
(304901, 'PTHR35488:SF2', NULL, NULL, NULL, NULL, 'OS05G0358900 PROTEIN', 239567),
(304902, 'PTHR35488:SF4', NULL, NULL, NULL, NULL, '', 239567),
(304903, 'PTHR35488:SF3', NULL, NULL, NULL, NULL, 'BNAA01G32570D PROTEIN', 239567),
(304904, 'PTHR35488', NULL, NULL, NULL, NULL, 'OS05G0358900 PROTEIN-RELATED', 239567),
(304905, 'PTHR12652:SF51', NULL, NULL, NULL, NULL, 'BNAC04G50420D PROTEIN', 239568),
(304906, 'PTHR12652:SF50', NULL, NULL, NULL, NULL, 'PEROXIN 11', 239568),
(304907, 'PTHR12652:SF42', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN 11 HOMOLOG', 239568),
(304908, 'PTHR12652:SF52', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN, PUTATIVE-RELATED', 239568),
(304909, 'PTHR12652:SF7', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN 11B', 239568),
(304910, 'PTHR12652:SF48', NULL, NULL, NULL, NULL, 'BNAA03G56960D PROTEIN', 239568),
(304911, 'PTHR12652:SF47', NULL, NULL, NULL, NULL, 'BNAA08G03650D PROTEIN', 239568),
(304912, 'PTHR12652:SF25', NULL, NULL, NULL, NULL, 'MICROBODY (PEROXISOME) PROLIFERATION PROTEIN PEROXIN 11C (EUROFUNG)-RELATED', 239568),
(304913, 'PTHR12652:SF17', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN 11B', 239568),
(304914, 'PTHR12652:SF49', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN 11-5-LIKE', 239568),
(304915, 'PTHR12652:SF44', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN 11-1', 239568),
(304916, 'PTHR12652:SF22', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN 11A', 239568),
(304917, 'PTHR12652:SF10', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN 11C-RELATED', 239568),
(304918, 'PTHR12652:SF46', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN 11E', 239568),
(304919, 'PTHR12652:SF23', NULL, NULL, NULL, NULL, 'MICROBODY (PEROXISOME) PROLIFERATION PROTEIN PEROXIN 11B (EUROFUNG)-RELATED', 239568),
(304920, 'PTHR12652:SF19', NULL, NULL, NULL, NULL, 'YALI0D25498P', 239568),
(304921, 'PTHR12652', NULL, NULL, NULL, NULL, 'PEROXISOMAL BIOGENESIS FACTOR 11', 239568),
(304922, 'PTHR47100:SF4', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PHOSPHATASE FAMILY PROTEIN', 239569),
(304923, 'PTHR47100', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE PHS1', 239569),
(304924, 'PTHR47100:SF5', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE PHS1', 239569),
(304925, 'PTHR47100:SF7', NULL, NULL, NULL, NULL, 'OS01G0311500 PROTEIN', 239569),
(304926, 'PTHR47035:SF3', NULL, NULL, NULL, NULL, 'OS11G0150450 PROTEIN', 239570),
(304927, 'PTHR47035', NULL, NULL, NULL, NULL, 'OS11G0150450 PROTEIN', 239570),
(304928, 'PTHR47035:SF4', NULL, NULL, NULL, NULL, 'OS02G0676500 PROTEIN', 239570),
(304929, 'PTHR47035:SF5', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL2-LIKE', 239570),
(304930, 'PTHR47035:SF6', NULL, NULL, NULL, NULL, 'OS04G0571800 PROTEIN', 239570),
(304931, 'PTHR47035:SF7', NULL, NULL, NULL, NULL, 'OS02G0528000 PROTEIN', 239570),
(304932, 'PTHR13388:SF9', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 132A', 239571),
(304933, 'PTHR13388:SF26', NULL, NULL, NULL, NULL, 'SI:DKEY-1D7.3', 239571),
(304934, 'PTHR13388:SF27', NULL, NULL, NULL, NULL, 'SI:DKEYP-14D3.1', 239571),
(304935, 'PTHR13388:SF7', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 132E', 239571),
(304936, 'PTHR13388:SF25', NULL, NULL, NULL, NULL, 'SI:DKEY-112M2.1', 239571),
(304937, 'PTHR13388:SF11', NULL, NULL, NULL, NULL, 'DETONATOR, ISOFORM E', 239571);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(304938, 'PTHR13388:SF23', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 132C-LIKE', 239571),
(304939, 'PTHR13388:SF12', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 132B', 239571),
(304940, 'PTHR13388:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 132C', 239571),
(304941, 'PTHR13388', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239571),
(304942, 'PTHR13388:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 132D', 239571),
(304943, 'PTHR33098:SF115', NULL, NULL, NULL, NULL, 'COTTON FIBER PROTEIN', 239572),
(304944, 'PTHR33098:SF76', NULL, NULL, NULL, NULL, '', 239572),
(304945, 'PTHR33098:SF114', NULL, NULL, NULL, NULL, 'DUF4408 DOMAIN PROTEIN', 239572),
(304946, 'PTHR33098:SF75', NULL, NULL, NULL, NULL, 'DUF4408 DOMAIN PROTEIN', 239572),
(304947, 'PTHR33098:SF117', NULL, NULL, NULL, NULL, 'COTTON FIBER EXPRESSED PROTEIN 1-LIKE PROTEIN', 239572),
(304948, 'PTHR33098:SF116', NULL, NULL, NULL, NULL, '', 239572),
(304949, 'PTHR33098:SF36', NULL, NULL, NULL, NULL, 'POLLEN-SPECIFIC LEUCINE-RICH REPEAT EXTENSIN-LIKE PROTEIN 2', 239572),
(304950, 'PTHR33098:SF79', NULL, NULL, NULL, NULL, 'DUF4408 DOMAIN-CONTAINING PROTEIN', 239572),
(304951, 'PTHR33098:SF78', NULL, NULL, NULL, NULL, 'DUF4408 DOMAIN-CONTAINING PROTEIN', 239572),
(304952, 'PTHR33098:SF72', NULL, NULL, NULL, NULL, '', 239572),
(304953, 'PTHR33098:SF111', NULL, NULL, NULL, NULL, 'OS05G0540900 PROTEIN', 239572),
(304954, 'PTHR33098:SF71', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 239572),
(304955, 'PTHR33098:SF110', NULL, NULL, NULL, NULL, 'DUF4408 DOMAIN-CONTAINING PROTEIN', 239572),
(304956, 'PTHR33098:SF113', NULL, NULL, NULL, NULL, 'OS08G0127800 PROTEIN', 239572),
(304957, 'PTHR33098:SF112', NULL, NULL, NULL, NULL, 'COTTON FIBER PROTEIN', 239572),
(304958, 'PTHR33098:SF62', NULL, NULL, NULL, NULL, 'OS01G0710100 PROTEIN', 239572),
(304959, 'PTHR33098:SF69', NULL, NULL, NULL, NULL, 'DUF761 DOMAIN PROTEIN', 239572),
(304960, 'PTHR33098:SF66', NULL, NULL, NULL, NULL, 'DUF4408 DOMAIN-CONTAINING PROTEIN', 239572),
(304961, 'PTHR33098:SF61', NULL, NULL, NULL, NULL, 'BNAC09G22350D PROTEIN', 239572),
(304962, 'PTHR33098:SF53', NULL, NULL, NULL, NULL, 'OS06G0566500 PROTEIN', 239572),
(304963, 'PTHR33098:SF52', NULL, NULL, NULL, NULL, 'T28P6.11 PROTEIN-RELATED', 239572),
(304964, 'PTHR33098:SF96', NULL, NULL, NULL, NULL, '', 239572),
(304965, 'PTHR33098:SF95', NULL, NULL, NULL, NULL, 'OS04G0676400 PROTEIN', 239572),
(304966, 'PTHR33098:SF57', NULL, NULL, NULL, NULL, 'DUF4408 DOMAIN-CONTAINING PROTEIN', 239572),
(304967, 'PTHR33098:SF99', NULL, NULL, NULL, NULL, '', 239572),
(304968, 'PTHR33098:SF90', NULL, NULL, NULL, NULL, '', 239572),
(304969, 'PTHR33098:SF50', NULL, NULL, NULL, NULL, 'PATHOGEN-ASSOCIATED MOLECULAR PATTERNS-INDUCED PROTEIN A70', 239572),
(304970, 'PTHR33098:SF92', NULL, NULL, NULL, NULL, '', 239572),
(304971, 'PTHR33098:SF91', NULL, NULL, NULL, NULL, 'BNAA06G10070D PROTEIN', 239572),
(304972, 'PTHR33098:SF2', NULL, NULL, NULL, NULL, 'OS08G0402500 PROTEIN', 239572),
(304973, 'PTHR33098:SF3', NULL, NULL, NULL, NULL, 'COTTON FIBER PROTEIN', 239572),
(304974, 'PTHR33098:SF15', NULL, NULL, NULL, NULL, 'DUF761 DOMAIN PROTEIN', 239572),
(304975, 'PTHR33098:SF9', NULL, NULL, NULL, NULL, 'OS09G0364400 PROTEIN', 239572),
(304976, 'PTHR33098:SF87', NULL, NULL, NULL, NULL, 'BNAC02G11900D PROTEIN', 239572),
(304977, 'PTHR33098:SF86', NULL, NULL, NULL, NULL, 'DUF4408 DOMAIN-CONTAINING PROTEIN', 239572),
(304978, 'PTHR33098:SF103', NULL, NULL, NULL, NULL, 'DUF4408 DOMAIN-CONTAINING PROTEIN', 239572),
(304979, 'PTHR33098:SF85', NULL, NULL, NULL, NULL, 'DUF4408 DOMAIN-CONTAINING PROTEIN', 239572),
(304980, 'PTHR33098:SF84', NULL, NULL, NULL, NULL, 'DUF4408 DOMAIN-CONTAINING PROTEIN', 239572),
(304981, 'PTHR33098:SF108', NULL, NULL, NULL, NULL, '', 239572),
(304982, 'PTHR33098:SF46', NULL, NULL, NULL, NULL, 'COTTON FIBER PROTEIN', 239572),
(304983, 'PTHR33098:SF107', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 239572),
(304984, 'PTHR33098:SF44', NULL, NULL, NULL, NULL, '', 239572);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(304985, 'PTHR33098:SF109', NULL, NULL, NULL, NULL, 'COTTON FIBER (DUF761)', 239572),
(304986, 'PTHR33098:SF100', NULL, NULL, NULL, NULL, '', 239572),
(304987, 'PTHR33098:SF81', NULL, NULL, NULL, NULL, 'DUF4408 DOMAIN-CONTAINING PROTEIN', 239572),
(304988, 'PTHR33098:SF102', NULL, NULL, NULL, NULL, '', 239572),
(304989, 'PTHR33098:SF101', NULL, NULL, NULL, NULL, 'DUF4408 DOMAIN-CONTAINING PROTEIN', 239572),
(304990, 'PTHR33098:SF80', NULL, NULL, NULL, NULL, 'COTTON FIBER', 239572),
(304991, 'PTHR33098:SF48', NULL, NULL, NULL, NULL, 'DUF4408 DOMAIN-CONTAINING PROTEIN', 239572),
(304992, 'PTHR33098', NULL, NULL, NULL, NULL, 'COTTON FIBER (DUF761)', 239572),
(304993, 'PTHR11590:SF44', NULL, NULL, NULL, NULL, 'PROTEIN 4.2', 239573),
(304994, 'PTHR11590:SF75', NULL, NULL, NULL, NULL, 'TGC DOMAIN-CONTAINING PROTEIN', 239573),
(304995, 'PTHR11590:SF42', NULL, NULL, NULL, NULL, 'COAGULATION FACTOR XIII A CHAIN', 239573),
(304996, 'PTHR11590:SF41', NULL, NULL, NULL, NULL, 'PROTEIN-GLUTAMINE GAMMA-GLUTAMYLTRANSFERASE Z', 239573),
(304997, 'PTHR11590', NULL, NULL, NULL, NULL, 'PROTEIN-GLUTAMINE GAMMA-GLUTAMYLTRANSFERASE', 239573),
(304998, 'PTHR11590:SF52', NULL, NULL, NULL, NULL, 'HEMOCYTE PROTEIN-GLUTAMINE GAMMA-GLUTAMYLTRANSFERASE-LIKE PROTEIN', 239573),
(304999, 'PTHR11590:SF73', NULL, NULL, NULL, NULL, 'TGC DOMAIN-CONTAINING PROTEIN-RELATED', 239573),
(305000, 'PTHR11590:SF40', NULL, NULL, NULL, NULL, 'HEMOCYTE PROTEIN-GLUTAMINE GAMMA-GLUTAMYLTRANSFERASE-LIKE PROTEIN', 239573),
(305001, 'PTHR11590:SF50', NULL, NULL, NULL, NULL, 'PROTEIN-GLUTAMINE GAMMA-GLUTAMYLTRANSFERASE 6', 239573),
(305002, 'PTHR11590:SF70', NULL, NULL, NULL, NULL, 'PROTEIN-GLUTAMINE GAMMA-GLUTAMYLTRANSFERASE 4', 239573),
(305003, 'PTHR11590:SF6', NULL, NULL, NULL, NULL, 'PROTEIN-GLUTAMINE GAMMA-GLUTAMYLTRANSFERASE 2', 239573),
(305004, 'PTHR11590:SF38', NULL, NULL, NULL, NULL, 'PROTEIN-GLUTAMINE GAMMA-GLUTAMYLTRANSFERASE 5', 239573),
(305005, 'PTHR11590:SF49', NULL, NULL, NULL, NULL, 'PROTEIN-GLUTAMINE GAMMA-GLUTAMYLTRANSFERASE K', 239573),
(305006, 'PTHR11590:SF69', NULL, NULL, NULL, NULL, 'RE08173P', 239573),
(305007, 'PTHR11590:SF36', NULL, NULL, NULL, NULL, 'PROTEIN-GLUTAMINE GAMMA-GLUTAMYLTRANSFERASE E', 239573),
(305008, 'PTHR44427:SF3', NULL, NULL, NULL, NULL, 'PREGNANCY-SPECIFIC BETA-1-GLYCOPROTEIN 8', 239574),
(305009, 'PTHR44427:SF5', NULL, NULL, NULL, NULL, 'V-SET AND IMMUNOGLOBULIN DOMAIN-CONTAINING PROTEIN 10-LIKE', 239574),
(305010, 'PTHR44427', NULL, NULL, NULL, NULL, 'CARCINOEMBRYONIC ANTIGEN-RELATED CELL ADHESION MOLECULE 19', 239574),
(305011, 'PTHR44427:SF4', NULL, NULL, NULL, NULL, 'PREGNANCY-SPECIFIC GLYCOPROTEIN 18-RELATED', 239574),
(305012, 'PTHR44427:SF7', NULL, NULL, NULL, NULL, 'CARCINOEMBRYONIC ANTIGEN-RELATED CELL ADHESION MOLECULE 20', 239574),
(305013, 'PTHR44427:SF9', NULL, NULL, NULL, NULL, 'SI:DKEY-93H22.7', 239574),
(305014, 'PTHR44427:SF8', NULL, NULL, NULL, NULL, 'CARCINOEMBRYONIC ANTIGEN-RELATED CELL ADHESION MOLECULE 4', 239574),
(305015, 'PTHR44427:SF18', NULL, NULL, NULL, NULL, 'HEMICENTIN 1', 239574),
(305016, 'PTHR44427:SF17', NULL, NULL, NULL, NULL, 'PREGNANCY-SPECIFIC BETA-1-GLYCOPROTEIN 4', 239574),
(305017, 'PTHR44427:SF19', NULL, NULL, NULL, NULL, 'PREGNANCY-SPECIFIC BETA-1-GLYCOPROTEIN 6-RELATED', 239574),
(305018, 'PTHR44427:SF14', NULL, NULL, NULL, NULL, 'PREGNANCY-SPECIFIC BETA-1-GLYCOPROTEIN 9', 239574),
(305019, 'PTHR44427:SF25', NULL, NULL, NULL, NULL, 'CARCINOEMBRYONIC ANTIGEN-RELATED CELL ADHESION MOLECULE 7', 239574),
(305020, 'PTHR44427:SF24', NULL, NULL, NULL, NULL, '', 239574),
(305021, 'PTHR44427:SF13', NULL, NULL, NULL, NULL, '', 239574),
(305022, 'PTHR44427:SF16', NULL, NULL, NULL, NULL, 'PREGNANCY-SPECIFIC BETA-1-GLYCOPROTEIN 1', 239574),
(305023, 'PTHR44427:SF15', NULL, NULL, NULL, NULL, 'PREGNANCY-SPECIFIC GLYCOPROTEIN 29', 239574),
(305024, 'PTHR44427:SF10', NULL, NULL, NULL, NULL, 'CARCINOEMBRYONIC ANTIGEN-RELATED CELL ADHESION MOLECULE 16', 239574),
(305025, 'PTHR44427:SF21', NULL, NULL, NULL, NULL, 'CARCINOEMBRYONIC ANTIGEN-RELATED CELL ADHESION MOLECULE 19', 239574);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(305026, 'PTHR44427:SF20', NULL, NULL, NULL, NULL, 'CEA CELL ADHESION MOLECULE 8', 239574),
(305027, 'PTHR44427:SF12', NULL, NULL, NULL, NULL, 'PREGNANCY-SPECIFIC BETA-1-GLYCOPROTEIN 3', 239574),
(305028, 'PTHR44427:SF23', NULL, NULL, NULL, NULL, 'CARCINOEMBRYONIC ANTIGEN-RELATED CELL ADHESION MOLECULE 3', 239574),
(305029, 'PTHR44427:SF1', NULL, NULL, NULL, NULL, 'CARCINOEMBRYONIC ANTIGEN-RELATED CELL ADHESION MOLECULE 1', 239574),
(305030, 'PTHR44427:SF22', NULL, NULL, NULL, NULL, 'IG DOMAIN-CONTAINING PROTEIN', 239574),
(305031, 'PTHR34797:SF7', NULL, NULL, NULL, NULL, 'ATG8-INTERACTING PROTEIN 1-LIKE ISOFORM X1', 239575),
(305032, 'PTHR34797:SF10', NULL, NULL, NULL, NULL, '', 239575),
(305033, 'PTHR34797:SF1', NULL, NULL, NULL, NULL, 'ATG8-INTERACTING PROTEIN 2', 239575),
(305034, 'PTHR34797', NULL, NULL, NULL, NULL, 'ATG8-INTERACTING PROTEIN 2', 239575),
(305035, 'PTHR34797:SF4', NULL, NULL, NULL, NULL, 'OS02G0821900 PROTEIN', 239575),
(305036, 'PTHR34797:SF3', NULL, NULL, NULL, NULL, 'ATG8-INTERACTING PROTEIN 1', 239575),
(305037, 'PTHR34797:SF6', NULL, NULL, NULL, NULL, '', 239575),
(305038, 'PTHR34797:SF5', NULL, NULL, NULL, NULL, 'BNAC04G50600D PROTEIN', 239575),
(305039, 'PTHR44240:SF19', NULL, NULL, NULL, NULL, 'DNAJ DOMAIN-CONTAINING PROTEIN-RELATED', 239576),
(305040, 'PTHR44240:SF15', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ 11, CHLOROPLASTIC', 239576),
(305041, 'PTHR44240:SF25', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 239576),
(305042, 'PTHR44240:SF17', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 239576),
(305043, 'PTHR44240:SF27', NULL, NULL, NULL, NULL, 'DNAJ DOMAIN-CONTAINING PROTEIN-RELATED', 239576),
(305044, 'PTHR44240:SF33', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 239576),
(305045, 'PTHR44240:SF22', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ 11, CHLOROPLASTIC-LIKE', 239576),
(305046, 'PTHR44240', NULL, NULL, NULL, NULL, 'DNAJ DOMAIN (PROKARYOTIC HEAT SHOCK PROTEIN)-RELATED', 239576),
(305047, 'PTHR44240:SF21', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 239576),
(305048, 'PTHR44240:SF10', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 239576),
(305049, 'PTHR44240:SF34', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ 11', 239576),
(305050, 'PTHR44240:SF12', NULL, NULL, NULL, NULL, 'OS06G0716100 PROTEIN', 239576),
(305051, 'PTHR23107', NULL, NULL, NULL, NULL, 'SYNOVIAL SARCOMA ASSOCIATED SS18 PROTEIN', 239577),
(305052, 'PTHR23107:SF2', NULL, NULL, NULL, NULL, 'PROTEIN SSXT', 239577),
(305053, 'PTHR23107:SF0', NULL, NULL, NULL, NULL, 'GRF1-INTERACTING FACTOR 3', 239577),
(305054, 'PTHR23107:SF35', NULL, NULL, NULL, NULL, '', 239577),
(305055, 'PTHR23107:SF36', NULL, NULL, NULL, NULL, '', 239577),
(305056, 'PTHR23107:SF25', NULL, NULL, NULL, NULL, 'SSXT PROTEIN (AMINO-TERMINAL REGION) PROTEIN', 239577),
(305057, 'PTHR23107:SF22', NULL, NULL, NULL, NULL, 'SSXT FAMILY PROTEIN-RELATED', 239577),
(305058, 'PTHR23107:SF33', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 239577),
(305059, 'PTHR23107:SF34', NULL, NULL, NULL, NULL, 'IP09280P-RELATED', 239577),
(305060, 'PTHR23107:SF31', NULL, NULL, NULL, NULL, '', 239577),
(305061, 'PTHR23107:SF32', NULL, NULL, NULL, NULL, '', 239577),
(305062, 'PTHR23107:SF21', NULL, NULL, NULL, NULL, 'CALCIUM-RESPONSIVE TRANSACTIVATOR', 239577),
(305063, 'PTHR23107:SF30', NULL, NULL, NULL, NULL, 'GRF1-INTERACTING FACTOR 1-LIKE', 239577),
(305064, 'PTHR23107:SF18', NULL, NULL, NULL, NULL, 'GRF1-INTERACTING FACTOR 1', 239577),
(305065, 'PTHR23107:SF37', NULL, NULL, NULL, NULL, '', 239577),
(305066, 'PTHR46742:SF1', NULL, NULL, NULL, NULL, '', 239578),
(305067, 'PTHR46742:SF3', NULL, NULL, NULL, NULL, 'LYSINE-RICH COILED-COIL PROTEIN 1', 239578),
(305068, 'PTHR46742:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER MATRIN-TYPE PROTEIN 1', 239578),
(305069, 'PTHR46742', NULL, NULL, NULL, NULL, 'LYSINE-RICH COILED-COIL PROTEIN 1', 239578),
(305070, 'PTHR38848', NULL, NULL, NULL, NULL, '', 239579),
(305071, 'PTHR38848:SF3', NULL, NULL, NULL, NULL, '', 239579),
(305072, 'PTHR13298:SF11', NULL, NULL, NULL, NULL, 'RAPAMYCIN-INSENSITIVE COMPANION OF MTOR', 239580);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(305073, 'PTHR13298', NULL, NULL, NULL, NULL, 'CYTOSOLIC REGULATOR PIANISSIMO', 239580),
(305074, 'PTHR44279:SF2', NULL, NULL, NULL, NULL, 'HYDROXYSTEROID (11-BETA) DEHYDROGENASE 1-LIKE B-RELATED', 239581),
(305075, 'PTHR44279:SF1', NULL, NULL, NULL, NULL, 'CORTICOSTEROID 11-BETA-DEHYDROGENASE ISOZYME 1', 239581),
(305076, 'PTHR44279:SF4', NULL, NULL, NULL, NULL, 'HYDROXYSTEROID (11-BETA) DEHYDROGENASE 1-LIKE, GENE 2', 239581),
(305077, 'PTHR44279:SF3', NULL, NULL, NULL, NULL, 'HYDROXYSTEROID 11-BETA-DEHYDROGENASE 1-LIKE PROTEIN', 239581),
(305078, 'PTHR44279', NULL, NULL, NULL, NULL, 'HYDROXYSTEROID (11-BETA) DEHYDROGENASE 1-LIKE B-RELATED', 239581),
(305079, 'PTHR10094', NULL, NULL, NULL, NULL, 'STEROL CARRIER PROTEIN 2  SCP-2  FAMILY PROTEIN', 239582),
(305080, 'PTHR10094:SF31', NULL, NULL, NULL, NULL, 'STEROL CARRIER PROTEIN 2B', 239582),
(305081, 'PTHR10094:SF25', NULL, NULL, NULL, NULL, 'SCP2 STEROL-BINDING DOMAIN-CONTAINING PROTEIN 1', 239582),
(305082, 'PTHR10094:SF27', NULL, NULL, NULL, NULL, 'OS02G0765800 PROTEIN', 239582),
(305083, 'PTHR10094:SF28', NULL, NULL, NULL, NULL, 'SCP2 DOMAIN-CONTAINING PROTEIN', 239582),
(305084, 'PTHR10094:SF29', NULL, NULL, NULL, NULL, 'SCP2 STEROL-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 239582),
(305085, 'PTHR32379', NULL, NULL, NULL, NULL, 'GUANIDINOACETATE N-METHYLTRANSFERASE', 239583),
(305086, 'PTHR32379:SF1', NULL, NULL, NULL, NULL, 'GUANIDINOACETATE N-METHYLTRANSFERASE', 239583),
(305087, 'PTHR47639', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN 18', 239584),
(305088, 'PTHR47639:SF1', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN 18', 239584),
(305089, 'PTHR42089', NULL, NULL, NULL, NULL, 'YALI0F09427P', 239585),
(305090, 'PTHR42089:SF1', NULL, NULL, NULL, NULL, 'YALI0F09427P', 239585),
(305091, 'PTHR14275:SF0', NULL, NULL, NULL, NULL, 'LIPID DROPLET ASSEMBLY FACTOR 1', 239586),
(305092, 'PTHR14275', NULL, NULL, NULL, NULL, 'PROMETHIN', 239586),
(305093, 'PTHR36056:SF4', NULL, NULL, NULL, NULL, '', 239587),
(305094, 'PTHR36056:SF1', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 239587),
(305095, 'PTHR36056:SF2', NULL, NULL, NULL, NULL, 'OS02G0550000 PROTEIN', 239587),
(305096, 'PTHR36056', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 239587),
(305097, 'PTHR36056:SF5', NULL, NULL, NULL, NULL, '', 239587),
(305098, 'PTHR46719', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C2H2 FAMILY-RELATED', 239588),
(305099, 'PTHR46719:SF18', NULL, NULL, NULL, NULL, 'FINGER PROTEIN ATL2I, PUTATIVE-RELATED', 239588),
(305100, 'PTHR46719:SF17', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239588),
(305101, 'PTHR46719:SF14', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C2H2 FAMILY-RELATED', 239588),
(305102, 'PTHR46719:SF24', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 239588),
(305103, 'PTHR46719:SF13', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 239588),
(305104, 'PTHR46719:SF16', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 239588),
(305105, 'PTHR46719:SF15', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL70-LIKE', 239588),
(305106, 'PTHR46719:SF21', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL70-LIKE', 239588),
(305107, 'PTHR46719:SF10', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239588),
(305108, 'PTHR46719:SF20', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL70-LIKE', 239588),
(305109, 'PTHR46719:SF23', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL70', 239588),
(305110, 'PTHR46719:SF11', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL70-LIKE', 239588),
(305111, 'PTHR46719:SF22', NULL, NULL, NULL, NULL, 'ZINC FINGER, C3HC4 TYPE (RING FINGER) PROTEIN', 239588),
(305112, 'PTHR46719:SF7', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL71-RELATED', 239588),
(305113, 'PTHR46719:SF6', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL70', 239588),
(305114, 'PTHR46719:SF8', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN-RELATED', 239588),
(305115, 'PTHR46719:SF5', NULL, NULL, NULL, NULL, 'OS07G0159600 PROTEIN', 239588);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(305116, 'PTHR23349:SF72', NULL, NULL, NULL, NULL, 'HLH54F', 239589),
(305117, 'PTHR23349:SF50', NULL, NULL, NULL, NULL, 'PROTEIN TWIST', 239589),
(305118, 'PTHR23349', NULL, NULL, NULL, NULL, 'BASIC HELIX-LOOP-HELIX TRANSCRIPTION FACTOR, TWIST', 239589),
(305119, 'PTHR23349:SF70', NULL, NULL, NULL, NULL, 'TWIST-RELATED PROTEIN 2', 239589),
(305120, 'PTHR23349:SF48', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR 24', 239589),
(305121, 'PTHR23349:SF64', NULL, NULL, NULL, NULL, 'TWIST-RELATED PROTEIN 1', 239589),
(305122, 'PTHR23349:SF42', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 239589),
(305123, 'PTHR23349:SF41', NULL, NULL, NULL, NULL, 'HEART- AND NEURAL CREST DERIVATIVES-EXPRESSED PROTEIN 2', 239589),
(305124, 'PTHR23349:SF63', NULL, NULL, NULL, NULL, 'FER3-LIKE PROTEIN', 239589),
(305125, 'PTHR23349:SF62', NULL, NULL, NULL, NULL, 'MUSCULIN', 239589),
(305126, 'PTHR23349:SF40', NULL, NULL, NULL, NULL, 'SI:CH211-246M6.4', 239589),
(305127, 'PTHR23349:SF68', NULL, NULL, NULL, NULL, 'FI14601P', 239589),
(305128, 'PTHR23349:SF67', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR 21', 239589),
(305129, 'PTHR23349:SF110', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 239589),
(305130, 'PTHR23349:SF66', NULL, NULL, NULL, NULL, 'TWIST3', 239589),
(305131, 'PTHR23349:SF106', NULL, NULL, NULL, NULL, '', 239589),
(305132, 'PTHR23349:SF103', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TWIST1', 239589),
(305133, 'PTHR23349:SF109', NULL, NULL, NULL, NULL, 'HELIX-LOOP-HELIX PROTEIN 10', 239589),
(305134, 'PTHR23349:SF108', NULL, NULL, NULL, NULL, 'ACHAETE-SCUTE FAMILY BHLH TRANSCRIPTION FACTOR 5', 239589),
(305135, 'PTHR23349:SF3', NULL, NULL, NULL, NULL, 'HEART- AND NEURAL CREST DERIVATIVES-EXPRESSED PROTEIN 1', 239589),
(305136, 'PTHR23349:SF59', NULL, NULL, NULL, NULL, 'PANCREAS TRANSCRIPTION FACTOR 1 SUBUNIT ALPHA', 239589),
(305137, 'PTHR23349:SF5', NULL, NULL, NULL, NULL, 'BASIC HELIX-LOOP-HELIX TRANSCRIPTION FACTOR SCLERAXIS', 239589),
(305138, 'PTHR23349:SF4', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR 15', 239589),
(305139, 'PTHR23349:SF10', NULL, NULL, NULL, NULL, 'CLASS A BASIC HELIX-LOOP-HELIX PROTEIN 9', 239589),
(305140, 'PTHR23349:SF97', NULL, NULL, NULL, NULL, '48 RELATED 2, ISOFORM D', 239589),
(305141, 'PTHR23349:SF73', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 239589),
(305142, 'PTHR23349:SF58', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR 23', 239589),
(305143, 'PTHR23349:SF57', NULL, NULL, NULL, NULL, 'FACTOR IN THE GERMLINE ALPHA', 239589),
(305144, 'PTHR47370:SF6', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 239590),
(305145, 'PTHR47370:SF7', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE HLS1-LIKE-RELATED', 239590),
(305146, 'PTHR47370', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASES (NAT) SUPERFAMILY PROTEIN', 239590),
(305147, 'PTHR47370:SF8', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 239590),
(305148, 'PTHR47370:SF9', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 239590),
(305149, 'PTHR47370:SF12', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASE (NAT) SUPERFAMILY PROTEIN', 239590),
(305150, 'PTHR47370:SF3', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASES (NAT) SUPERFAMILY PROTEIN', 239590),
(305151, 'PTHR47370:SF11', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE HLS1-LIKE-RELATED', 239590),
(305152, 'PTHR47370:SF4', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 239590),
(305153, 'PTHR47370:SF10', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE HLS1-RELATED', 239590),
(305154, 'PTHR47370:SF5', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 239590),
(305155, 'PTHR47370:SF1', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASES (NAT) SUPERFAMILY PROTEIN', 239590),
(305156, 'PTHR36571', NULL, NULL, NULL, NULL, 'PROTEIN YGIW', 239591),
(305157, 'PTHR36571:SF2', NULL, NULL, NULL, NULL, 'PERIPLASMIC PROTEIN-RELATED', 239591),
(305158, 'PTHR36571:SF1', NULL, NULL, NULL, NULL, 'PROTEIN YGIW', 239591); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(305159, 'PTHR37761:SF2', NULL, NULL, NULL, NULL, 'OS09G0108400 PROTEIN', 239592),
(305160, 'PTHR37761', NULL, NULL, NULL, NULL, 'OS09G0108400 PROTEIN', 239592),
(305161, 'PTHR21640:SF1', NULL, NULL, NULL, NULL, 'NESPRIN-4', 239593),
(305162, 'PTHR21640', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239593),
(305163, 'PTHR34251', NULL, NULL, NULL, NULL, 'LEUCINE-, GLUTAMATE- AND LYSINE-RICH PROTEIN 1', 239594),
(305164, 'PTHR34251:SF1', NULL, NULL, NULL, NULL, 'LEUCINE, GLUTAMATE AND LYSINE-RICH 1', 239594),
(305165, 'PTHR14130:SF3', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 17', 239595),
(305166, 'PTHR14130:SF13', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 44', 239595),
(305167, 'PTHR14130:SF14', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 92B', 239595),
(305168, 'PTHR14130:SF12', NULL, NULL, NULL, NULL, 'BARGIN-RELATED', 239595),
(305169, 'PTHR14130', NULL, NULL, NULL, NULL, '3BP-1 RELATED RHOGAP', 239595),
(305170, 'PTHR14130:SF15', NULL, NULL, NULL, NULL, 'SI:CH211-114M9.1', 239595),
(305171, 'PTHR47683:SF3', NULL, NULL, NULL, NULL, 'RIBOSOMAL LARGE SUBUNIT PSEUDOURIDINE SYNTHASE B', 239596),
(305172, 'PTHR47683:SF4', NULL, NULL, NULL, NULL, 'PSEUDOURIDINE SYNTHASE', 239596),
(305173, 'PTHR47683:SF2', NULL, NULL, NULL, NULL, 'S4 RNA-BINDING DOMAIN-CONTAINING PROTEIN', 239596),
(305174, 'PTHR47683', NULL, NULL, NULL, NULL, 'PSEUDOURIDINE SYNTHASE FAMILY PROTEIN-RELATED', 239596),
(305175, 'PTHR31919:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGERS AND HOMEOBOXES PROTEIN 1, ISOFORM 2', 239597),
(305176, 'PTHR31919', NULL, NULL, NULL, NULL, 'ZINC FINGERS AND HOMEOBOXES PROTEIN 1, ISOFORM 2', 239597),
(305177, 'PTHR14383:SF2', NULL, NULL, NULL, NULL, 'DIFFERENTIALLY EXPRESSED IN FDCP 6 HOMOLOG', 239598),
(305178, 'PTHR14383', NULL, NULL, NULL, NULL, 'SWAP-70 RECOMBINASE', 239598),
(305179, 'PTHR14383:SF1', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY D MEMBER 1', 239598),
(305180, 'PTHR14383:SF6', NULL, NULL, NULL, NULL, 'SWITCH-ASSOCIATED PROTEIN 70', 239598),
(305181, 'PTHR14383:SF5', NULL, NULL, NULL, NULL, 'RUN DOMAIN-CONTAINING PROTEIN', 239598),
(305182, 'PTHR12974:SF48', NULL, NULL, NULL, NULL, 'SI:DKEY-181O6.1', 239599),
(305183, 'PTHR12974:SF47', NULL, NULL, NULL, NULL, 'TERMINAL NUCLEOTIDYLTRANSFERASE 5AB', 239599),
(305184, 'PTHR12974:SF25', NULL, NULL, NULL, NULL, 'TERMINAL NUCLEOTIDYLTRANSFERASE 5A', 239599),
(305185, 'PTHR12974:SF36', NULL, NULL, NULL, NULL, 'TERMINAL NUCLEOTIDYLTRANSFERASE', 239599),
(305186, 'PTHR12974:SF46', NULL, NULL, NULL, NULL, 'TERMINAL NUCLEOTIDYLTRANSFERASE 5B', 239599),
(305187, 'PTHR12974:SF34', NULL, NULL, NULL, NULL, 'TERMINAL NUCLEOTIDYLTRANSFERASE 5C', 239599),
(305188, 'PTHR12974', NULL, NULL, NULL, NULL, 'PRION-LIKE- Q/N-RICH -DOMAIN-BEARING PROTEIN PROTEIN 44', 239599),
(305189, 'PTHR12974:SF30', NULL, NULL, NULL, NULL, 'TERMINAL NUCLEOTIDYLTRANSFERASE 5D', 239599),
(305190, 'PTHR39177', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE YTRC-RELATED', 239600),
(305191, 'PTHR39177:SF1', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE YTRC-RELATED', 239600),
(305192, 'PTHR36401:SF2', NULL, NULL, NULL, NULL, 'BNAC02G33360D PROTEIN', 239601),
(305193, 'PTHR36401:SF1', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 BETA SUBCOMPLEX SUBUNIT 8, MITOCHONDRIAL', 239601),
(305194, 'PTHR36401:SF3', NULL, NULL, NULL, NULL, 'BNAA09G18370D PROTEIN', 239601),
(305195, 'PTHR36401', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 BETA SUBCOMPLEX SUBUNIT 8, MITOCHONDRIAL', 239601),
(305196, 'PTHR23157:SF26', NULL, NULL, NULL, NULL, 'GRIP AND COILED-COIL DOMAIN-CONTAINING PROTEIN 2', 239602),
(305197, 'PTHR23157:SF25', NULL, NULL, NULL, NULL, 'GRIP AND COILED-COIL DOMAIN-CONTAINING PROTEIN 1', 239602),
(305198, 'PTHR23157:SF24', NULL, NULL, NULL, NULL, 'GOLGIN SUBFAMILY A MEMBER 1', 239602),
(305199, 'PTHR23157', NULL, NULL, NULL, NULL, 'GRIP AND COILED-COIL DOMAIN-CONTAINING PROTEIN 1', 239602),
(305200, 'PTHR46568:SF1', NULL, NULL, NULL, NULL, 'ALKYLDIHYDROXYACETONEPHOSPHATE SYNTHASE, PEROXISOMAL', 239603);
INSERT INTO "PUBLIC"."MODEL" VALUES
(305201, 'PTHR46568', NULL, NULL, NULL, NULL, 'ALKYLDIHYDROXYACETONEPHOSPHATE SYNTHASE, PEROXISOMAL', 239603),
(305202, 'PTHR21535:SF91', NULL, NULL, NULL, NULL, '', 239604),
(305203, 'PTHR21535', NULL, NULL, NULL, NULL, 'MAGNESIUM AND COBALT TRANSPORT PROTEIN/MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM8', 239604),
(305204, 'PTHR21535:SF90', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 239604),
(305205, 'PTHR21535:SF95', NULL, NULL, NULL, NULL, 'MGT2 MAGNESIUM TRANSPORTER', 239604),
(305206, 'PTHR21535:SF51', NULL, NULL, NULL, NULL, 'MANGANESE RESISTANCE PROTEIN MNR2', 239604),
(305207, 'PTHR21535:SF94', NULL, NULL, NULL, NULL, 'CORA FAMILY METAL ION TRANSPORTER (EUROFUNG)', 239604),
(305208, 'PTHR21535:SF93', NULL, NULL, NULL, NULL, '', 239604),
(305209, 'PTHR21535:SF92', NULL, NULL, NULL, NULL, '', 239604),
(305210, 'PTHR21535:SF55', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER ALR1-RELATED', 239604),
(305211, 'PTHR21535:SF89', NULL, NULL, NULL, NULL, 'CORA FAMILY TRANSPORTER-RELATED', 239604),
(305212, 'PTHR14493', NULL, NULL, NULL, NULL, 'UNKEMPT FAMILY MEMBER', 239605),
(305213, 'PTHR14493:SF131', NULL, NULL, NULL, NULL, 'ARM REPEAT CCCH-TYPE ZINC FINGER PROTEIN', 239605),
(305214, 'PTHR14493:SF130', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 56-LIKE', 239605),
(305215, 'PTHR14493:SF36', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN UNKEMPT HOMOLOG', 239605),
(305216, 'PTHR14493:SF37', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE UNKL-RELATED', 239605),
(305217, 'PTHR14493:SF91', NULL, NULL, NULL, NULL, 'FACTOR, PUTATIVE-RELATED', 239605),
(305218, 'PTHR14493:SF109', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 54', 239605),
(305219, 'PTHR14493:SF50', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN UNKEMPT', 239605),
(305220, 'PTHR14493:SF108', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 35', 239605),
(305221, 'PTHR14493:SF129', NULL, NULL, NULL, NULL, 'NUCLEIC ACID BINDING PROTEIN', 239605),
(305222, 'PTHR14493:SF95', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 61', 239605),
(305223, 'PTHR14493:SF98', NULL, NULL, NULL, NULL, 'NUCLEIC ACID BINDING PROTEIN', 239605),
(305224, 'PTHR14493:SF124', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C3H FAMILY-RELATED', 239605),
(305225, 'PTHR14493:SF145', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 30-LIKE ISOFORM X1', 239605),
(305226, 'PTHR14493:SF123', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 67', 239605),
(305227, 'PTHR14493:SF144', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 66-LIKE', 239605),
(305228, 'PTHR14493:SF143', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 20', 239605),
(305229, 'PTHR14493:SF128', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 67-RELATED', 239605),
(305230, 'PTHR14493:SF105', NULL, NULL, NULL, NULL, 'BNAA06G36220D PROTEIN', 239605),
(305231, 'PTHR14493:SF90', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 2', 239605),
(305232, 'PTHR14493:SF126', NULL, NULL, NULL, NULL, 'ZINC FINGER, CCCH-TYPE, ANKYRIN REPEAT-CONTAINING DOMAIN PROTEIN-RELATED', 239605),
(305233, 'PTHR14493:SF125', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 50', 239605),
(305234, 'PTHR14493:SF142', NULL, NULL, NULL, NULL, 'BNAA08G27570D PROTEIN', 239605),
(305235, 'PTHR14493:SF120', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 20', 239605),
(305236, 'PTHR14493:SF141', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 23', 239605),
(305237, 'PTHR14493:SF140', NULL, NULL, NULL, NULL, 'ZINC FINGER, CCCH-TYPE-RELATED', 239605),
(305238, 'PTHR14493:SF44', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 10', 239605),
(305239, 'PTHR14493:SF81', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 56-LIKE ISOFORM X1', 239605),
(305240, 'PTHR14493:SF119', NULL, NULL, NULL, NULL, 'ZINC FINGER, CCCH-TYPE, ANKYRIN REPEAT-CONTAINING DOMAIN PROTEIN-RELATED', 239605);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(305241, 'PTHR14493:SF118', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 30', 239605),
(305242, 'PTHR14493:SF87', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 66', 239605),
(305243, 'PTHR14493:SF86', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 29', 239605),
(305244, 'PTHR14493:SF135', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 56', 239605),
(305245, 'PTHR14493:SF134', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 47', 239605),
(305246, 'PTHR14493:SF112', NULL, NULL, NULL, NULL, 'C3H1-TYPE DOMAIN-CONTAINING PROTEIN', 239605),
(305247, 'PTHR14493:SF133', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 30-LIKE', 239605),
(305248, 'PTHR14493:SF132', NULL, NULL, NULL, NULL, 'ARM REPEAT CCCH-TYPE ZINC FINGER PROTEIN', 239605),
(305249, 'PTHR14493:SF139', NULL, NULL, NULL, NULL, '', 239605),
(305250, 'PTHR14493:SF117', NULL, NULL, NULL, NULL, 'C3HL DOMAIN CLASS TRANSCRIPTION FACTOR', 239605),
(305251, 'PTHR14493:SF138', NULL, NULL, NULL, NULL, 'NUCLEIC ACID BINDING PROTEIN', 239605),
(305252, 'PTHR14493:SF137', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 239605),
(305253, 'PTHR14493:SF136', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C3H FAMILY-RELATED', 239605),
(305254, 'PTHR34707:SF2', NULL, NULL, NULL, NULL, 'A-TYPE INCLUSION PROTEIN, PUTATIVE-RELATED', 239606),
(305255, 'PTHR34707', NULL, NULL, NULL, NULL, 'VIMENTIN-TYPE INTERMEDIATE FILAMENT-ASSOCIATED COILED-COIL PROTEIN', 239606),
(305256, 'PTHR34707:SF1', NULL, NULL, NULL, NULL, 'VIMENTIN-TYPE INTERMEDIATE FILAMENT-ASSOCIATED COILED-COIL PROTEIN', 239606),
(305257, 'PTHR13037:SF16', NULL, NULL, NULL, NULL, 'FORMIN-2', 239607),
(305258, 'PTHR13037:SF23', NULL, NULL, NULL, NULL, 'NEURAL WISKOTT-ALDRICH SYNDROME PROTEIN', 239607),
(305259, 'PTHR13037:SF24', NULL, NULL, NULL, NULL, 'POLYCOMB PROTEIN PCL-RELATED', 239607),
(305260, 'PTHR13037:SF11', NULL, NULL, NULL, NULL, 'FORMIN-1', 239607),
(305261, 'PTHR13037:SF22', NULL, NULL, NULL, NULL, '', 239607),
(305262, 'PTHR13037', NULL, NULL, NULL, NULL, 'FORMIN', 239607),
(305263, 'PTHR13037:SF20', NULL, NULL, NULL, NULL, '', 239607),
(305264, 'PTHR40448:SF1', NULL, NULL, NULL, NULL, 'TWO-COMPONENT SENSOR HISTIDINE KINASE', 239608),
(305265, 'PTHR40448', NULL, NULL, NULL, NULL, 'TWO-COMPONENT SENSOR HISTIDINE KINASE', 239608),
(305266, 'PTHR39174:SF1', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', 239609),
(305267, 'PTHR39174', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', 239609),
(305268, 'PTHR33095:SF55', NULL, NULL, NULL, NULL, 'BNACNNG71370D PROTEIN', 239610),
(305269, 'PTHR33095', NULL, NULL, NULL, NULL, 'OS07G0619500 PROTEIN', 239610),
(305270, 'PTHR33095:SF95', NULL, NULL, NULL, NULL, 'BNAC09G42800D PROTEIN', 239610),
(305271, 'PTHR33095:SF51', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239610),
(305272, 'PTHR33095:SF91', NULL, NULL, NULL, NULL, 'OS02G0761300 PROTEIN', 239610),
(305273, 'PTHR33095:SF90', NULL, NULL, NULL, NULL, '', 239610),
(305274, 'PTHR33095:SF115', NULL, NULL, NULL, NULL, '', 239610),
(305275, 'PTHR33095:SF116', NULL, NULL, NULL, NULL, 'OS06G0215100 PROTEIN', 239610),
(305276, 'PTHR33095:SF113', NULL, NULL, NULL, NULL, 'DNA LIGASE 1-LIKE', 239610),
(305277, 'PTHR33095:SF114', NULL, NULL, NULL, NULL, 'DUF1645 FAMILY PROTEIN', 239610),
(305278, 'PTHR33095:SF111', NULL, NULL, NULL, NULL, 'OS02G0134200 PROTEIN', 239610),
(305279, 'PTHR33095:SF112', NULL, NULL, NULL, NULL, '', 239610),
(305280, 'PTHR33095:SF110', NULL, NULL, NULL, NULL, 'OS05G0568800 PROTEIN', 239610),
(305281, 'PTHR33095:SF16', NULL, NULL, NULL, NULL, 'OS01G0253500 PROTEIN', 239610),
(305282, 'PTHR33095:SF79', NULL, NULL, NULL, NULL, 'BNAA05G33800D PROTEIN', 239610),
(305283, 'PTHR33095:SF57', NULL, NULL, NULL, NULL, 'DUF1645 FAMILY PROTEIN', 239610),
(305284, 'PTHR33095:SF119', NULL, NULL, NULL, NULL, 'OS12G0556900 PROTEIN', 239610),
(305285, 'PTHR33095:SF56', NULL, NULL, NULL, NULL, 'OS05G0578100 PROTEIN', 239610);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(305286, 'PTHR33095:SF117', NULL, NULL, NULL, NULL, 'BNAA09G06220D PROTEIN', 239610),
(305287, 'PTHR33095:SF118', NULL, NULL, NULL, NULL, '', 239610),
(305288, 'PTHR33095:SF14', NULL, NULL, NULL, NULL, 'AR781', 239610),
(305289, 'PTHR33095:SF8', NULL, NULL, NULL, NULL, 'DUF1645 FAMILY PROTEIN', 239610),
(305290, 'PTHR33095:SF9', NULL, NULL, NULL, NULL, 'OS05G0568600 PROTEIN', 239610),
(305291, 'PTHR33095:SF43', NULL, NULL, NULL, NULL, '', 239610),
(305292, 'PTHR33095:SF87', NULL, NULL, NULL, NULL, 'BNAA09G39980D PROTEIN', 239610),
(305293, 'PTHR33095:SF81', NULL, NULL, NULL, NULL, 'OS07G0619500 PROTEIN', 239610),
(305294, 'PTHR33095:SF83', NULL, NULL, NULL, NULL, 'BNAA02G29090D PROTEIN', 239610),
(305295, 'PTHR33095:SF105', NULL, NULL, NULL, NULL, 'DUF1645 FAMILY PROTEIN', 239610),
(305296, 'PTHR33095:SF124', NULL, NULL, NULL, NULL, 'DUF1645 FAMILY PROTEIN', 239610),
(305297, 'PTHR33095:SF125', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN', 239610),
(305298, 'PTHR33095:SF122', NULL, NULL, NULL, NULL, 'BNAC06G31430D PROTEIN', 239610),
(305299, 'PTHR33095:SF100', NULL, NULL, NULL, NULL, '', 239610),
(305300, 'PTHR33095:SF123', NULL, NULL, NULL, NULL, '', 239610),
(305301, 'PTHR33095:SF101', NULL, NULL, NULL, NULL, 'DUF1645 FAMILY PROTEIN', 239610),
(305302, 'PTHR33095:SF120', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN', 239610),
(305303, 'PTHR33095:SF121', NULL, NULL, NULL, NULL, '', 239610),
(305304, 'PTHR33095:SF68', NULL, NULL, NULL, NULL, 'BNAA04G10200D PROTEIN', 239610),
(305305, 'PTHR33095:SF108', NULL, NULL, NULL, NULL, '', 239610),
(305306, 'PTHR33095:SF23', NULL, NULL, NULL, NULL, 'OS01G0639600 PROTEIN', 239610),
(305307, 'PTHR33095:SF109', NULL, NULL, NULL, NULL, '', 239610),
(305308, 'PTHR33095:SF45', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN', 239610),
(305309, 'PTHR33095:SF106', NULL, NULL, NULL, NULL, '', 239610),
(305310, 'PTHR33095:SF48', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN', 239610),
(305311, 'PTHR33095:SF47', NULL, NULL, NULL, NULL, 'AR781', 239610),
(305312, 'PTHR33095:SF107', NULL, NULL, NULL, NULL, 'STRESS RESPONSE NST1-LIKE PROTEIN (DUF1645)', 239610),
(305313, 'PTHR45008', NULL, NULL, NULL, NULL, 'PTS SYSTEM GLUCOSE-SPECIFIC EIIA COMPONENT', 239611),
(305314, 'PTHR45008:SF1', NULL, NULL, NULL, NULL, 'PTS SYSTEM GLUCOSE-SPECIFIC EIIA COMPONENT', 239611),
(305315, 'PTHR21635', NULL, NULL, NULL, NULL, 'LEUCINE ZIPPER TRANSCRIPTION FACTOR LIKE', 239612),
(305316, 'PTHR21635:SF0', NULL, NULL, NULL, NULL, 'LEUCINE ZIPPER TRANSCRIPTION FACTOR-LIKE PROTEIN 1', 239612),
(305317, 'PTHR37732:SF2', NULL, NULL, NULL, NULL, 'SEED MATURATION PROTEIN 1', 239613),
(305318, 'PTHR37732', NULL, NULL, NULL, NULL, 'OS08G0104400 PROTEIN', 239613),
(305319, 'PTHR45987', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L12', 239614),
(305320, 'PTHR45987:SF2', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN-LIKE', 239614),
(305321, 'PTHR45987:SF1', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L7/L12-RELATED', 239614),
(305322, 'PTHR45987:SF15', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L12 DOMAIN-CONTAINING PROTEIN', 239614),
(305323, 'PTHR45987:SF18', NULL, NULL, NULL, NULL, 'BNAA09G02160D PROTEIN', 239614),
(305324, 'PTHR45987:SF17', NULL, NULL, NULL, NULL, 'BNACNNG16350D PROTEIN', 239614),
(305325, 'PTHR45987:SF23', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L7/L12', 239614),
(305326, 'PTHR45987:SF22', NULL, NULL, NULL, NULL, 'OS03G0734400 PROTEIN', 239614),
(305327, 'PTHR45987:SF11', NULL, NULL, NULL, NULL, 'OS07G0626100 PROTEIN', 239614),
(305328, 'PTHR45987:SF24', NULL, NULL, NULL, NULL, 'BNAA02G29080D PROTEIN', 239614),
(305329, 'PTHR45987:SF21', NULL, NULL, NULL, NULL, '', 239614),
(305330, 'PTHR45987:SF20', NULL, NULL, NULL, NULL, 'BNAC07G24760D PROTEIN', 239614),
(305331, 'PTHR45987:SF6', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L12/ ATP-DEPENDENT CLP PROTEASE ADAPTOR PROTEIN CLPS FAMILY PROTEIN', 239614),
(305332, 'PTHR45987:SF7', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L12-2, CHLOROPLASTIC', 239614),
(305333, 'PTHR45987:SF4', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L12, MITOCHONDRIAL', 239614);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(305334, 'PTHR35284:SF5', NULL, NULL, NULL, NULL, 'OUTER ENVELOPE PORE PROTEIN 24, CHLOROPLASTIC-LIKE', 239615),
(305335, 'PTHR35284:SF6', NULL, NULL, NULL, NULL, 'OUTER ENVELOPE PORE PROTEIN 24B, CHLOROPLASTIC-LIKE ISOFORM X1', 239615),
(305336, 'PTHR35284', NULL, NULL, NULL, NULL, 'OUTER ENVELOPE PORE PROTEIN 24A, CHLOROPLASTIC-RELATED', 239615),
(305337, 'PTHR35284:SF1', NULL, NULL, NULL, NULL, 'OUTER ENVELOPE PORE PROTEIN 24A, CHLOROPLASTIC-RELATED', 239615),
(305338, 'PTHR35284:SF7', NULL, NULL, NULL, NULL, 'BNAA06G36970D PROTEIN', 239615),
(305339, 'PTHR33528:SF15', NULL, NULL, NULL, NULL, 'OS08G0156000 PROTEIN', 239616),
(305340, 'PTHR33528:SF17', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 239616),
(305341, 'PTHR33528:SF22', NULL, NULL, NULL, NULL, '', 239616),
(305342, 'PTHR33528:SF14', NULL, NULL, NULL, NULL, 'OS07G0239500 PROTEIN', 239616),
(305343, 'PTHR33528:SF25', NULL, NULL, NULL, NULL, '', 239616),
(305344, 'PTHR33528', NULL, NULL, NULL, NULL, 'OS07G0239500 PROTEIN', 239616),
(305345, 'PTHR33528:SF21', NULL, NULL, NULL, NULL, 'BNAC01G19730D PROTEIN', 239616),
(305346, 'PTHR33528:SF20', NULL, NULL, NULL, NULL, '', 239616),
(305347, 'PTHR33528:SF19', NULL, NULL, NULL, NULL, '', 239616),
(305348, 'PTHR37448:SF1', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 239617),
(305349, 'PTHR37448', NULL, NULL, NULL, NULL, '', 239617),
(305350, 'PTHR22166:SF28', NULL, NULL, NULL, NULL, 'OS02G0830300 PROTEIN', 239618),
(305351, 'PTHR22166:SF30', NULL, NULL, NULL, NULL, 'LUNAPARK DOMAIN-CONTAINING PROTEIN-RELATED', 239618),
(305352, 'PTHR22166', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM JUNCTION FORMATION PROTEIN LUNAPARK', 239618),
(305353, 'PTHR22166:SF34', NULL, NULL, NULL, NULL, 'OS04G0672900 PROTEIN', 239618),
(305354, 'PTHR22166:SF12', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM JUNCTION FORMATION PROTEIN LUNAPARK', 239618),
(305355, 'PTHR22166:SF32', NULL, NULL, NULL, NULL, 'LUNAPARK DOMAIN-CONTAINING PROTEIN-RELATED', 239618),
(305356, 'PTHR22166:SF26', NULL, NULL, NULL, NULL, 'OS02G0830500 PROTEIN', 239618),
(305357, 'PTHR22166:SF27', NULL, NULL, NULL, NULL, 'ZINC_RIBBON_10 DOMAIN-CONTAINING PROTEIN', 239618),
(305358, 'PTHR22166:SF35', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE METAL-BINDING FAMILY PROTEIN (DUF2296)', 239618),
(305359, 'PTHR22166:SF13', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM JUNCTION FORMATION PROTEIN LUNAPARK-A', 239618),
(305360, 'PTHR22166:SF14', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM JUNCTION FORMATION PROTEIN LUNAPARK-B', 239618),
(305361, 'PTHR22166:SF36', NULL, NULL, NULL, NULL, 'LUNAPARK DOMAIN-CONTAINING PROTEIN-RELATED', 239618),
(305362, 'PTHR21720', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239619),
(305363, 'PTHR21720:SF6', NULL, NULL, NULL, NULL, 'DOUBLE-STRAND BREAK FACTOR', 239619),
(305364, 'PTHR21720:SF5', NULL, NULL, NULL, NULL, 'DOUBLE-STRAND BREAK FACTOR', 239619),
(305365, 'PTHR21720:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG00978', 239619),
(305366, 'PTHR21720:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG15325', 239619),
(305367, 'PTHR21720:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG03889', 239619),
(305368, 'PTHR43460:SF1', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 239620),
(305369, 'PTHR43460', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 239620),
(305370, 'PTHR34379:SF15', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 239621),
(305371, 'PTHR34379:SF14', NULL, NULL, NULL, NULL, '', 239621),
(305372, 'PTHR34379:SF6', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 239621),
(305373, 'PTHR34379:SF18', NULL, NULL, NULL, NULL, '', 239621),
(305374, 'PTHR34379:SF17', NULL, NULL, NULL, NULL, 'OS07G0553800 PROTEIN', 239621),
(305375, 'PTHR34379:SF3', NULL, NULL, NULL, NULL, 'PROTEIN 3F', 239621),
(305376, 'PTHR34379:SF9', NULL, NULL, NULL, NULL, 'BNAC09G47680D PROTEIN', 239621),
(305377, 'PTHR34379', NULL, NULL, NULL, NULL, 'OS07G0553800 PROTEIN', 239621),
(305378, 'PTHR45908:SF1', NULL, NULL, NULL, NULL, 'LIPASE ZK262.3-RELATED', 239622),
(305379, 'PTHR45908:SF2', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 239622);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(305380, 'PTHR45908:SF9', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 239622),
(305381, 'PTHR45908:SF20', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 239622),
(305382, 'PTHR45908:SF21', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 239622),
(305383, 'PTHR45908:SF10', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 239622),
(305384, 'PTHR45908:SF22', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 239622),
(305385, 'PTHR45908:SF11', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 239622),
(305386, 'PTHR45908:SF8', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 239622),
(305387, 'PTHR45908:SF23', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 239622),
(305388, 'PTHR45908:SF5', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 239622),
(305389, 'PTHR45908:SF13', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 239622),
(305390, 'PTHR45908:SF6', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 239622),
(305391, 'PTHR45908:SF14', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 239622),
(305392, 'PTHR45908:SF15', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 239622),
(305393, 'PTHR45908:SF4', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 239622),
(305394, 'PTHR45908:SF17', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 239622),
(305395, 'PTHR45908:SF18', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 239622),
(305396, 'PTHR45908:SF19', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 239622),
(305397, 'PTHR45908', NULL, NULL, NULL, NULL, 'PROTEIN CBG11750-RELATED', 239622),
(305398, 'PTHR14949:SF51', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR D AND EGF DOMAIN-CONTAINING PROTEIN', 239623),
(305399, 'PTHR14949:SF32', NULL, NULL, NULL, NULL, 'WNT INHIBITORY FACTOR 1', 239623),
(305400, 'PTHR14949:SF43', NULL, NULL, NULL, NULL, 'TERATOCARCINOMA-DERIVED GROWTH FACTOR 3-RELATED', 239623),
(305401, 'PTHR14949:SF21', NULL, NULL, NULL, NULL, 'EPIDERMAL GROWTH FACTOR-LIKE PROTEIN 7', 239623),
(305402, 'PTHR14949:SF50', NULL, NULL, NULL, NULL, 'LD16414P-RELATED', 239623),
(305403, 'PTHR14949', NULL, NULL, NULL, NULL, 'EGF-LIKE-DOMAIN, MULTIPLE 7, 8', 239623),
(305404, 'PTHR14949:SF49', NULL, NULL, NULL, NULL, 'VWFD DOMAIN-CONTAINING PROTEIN', 239623),
(305405, 'PTHR14949:SF27', NULL, NULL, NULL, NULL, 'EPIDERMAL GROWTH FACTOR-LIKE PROTEIN 8', 239623),
(305406, 'PTHR14949:SF48', NULL, NULL, NULL, NULL, 'SI:DKEY-30E9.7', 239623),
(305407, 'PTHR14949:SF26', NULL, NULL, NULL, NULL, 'TERATOCARCINOMA-DERIVED GROWTH FACTOR 1', 239623),
(305408, 'PTHR14949:SF47', NULL, NULL, NULL, NULL, 'SI:CH211-246M6.5', 239623),
(305409, 'PTHR14949:SF25', NULL, NULL, NULL, NULL, 'CRYPTIC FAMILY PROTEIN 1B-RELATED', 239623),
(305410, 'PTHR14949:SF46', NULL, NULL, NULL, NULL, 'SCHWANN CELL-SPECIFIC EGF-LIKE REPEAT AUTOCRINE FACTOR', 239623),
(305411, 'PTHR14949:SF35', NULL, NULL, NULL, NULL, 'EGF-LIKE-DOMAIN, MULTIPLE 7', 239623),
(305412, 'PTHR11055:SF16', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL 3''-PHOSPHOADENOSINE 5''-PHOSPHOSULFATE SYNTHASE 2', 239624),
(305413, 'PTHR11055:SF17', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL 3''-PHOSPHOADENOSINE 5''-PHOSPHOSULFATE SYNTHASE 1', 239624),
(305414, 'PTHR11055:SF39', NULL, NULL, NULL, NULL, 'ATP SULFURYLASE 4, CHLOROPLASTIC', 239624),
(305415, 'PTHR11055:SF1', NULL, NULL, NULL, NULL, '3''-PHOSPHOADENOSINE-5''-PHOSPHOSULFATE SYNTHASE', 239624),
(305416, 'PTHR11055:SF63', NULL, NULL, NULL, NULL, 'ADENYLYL-SULFATE KINASE 1, CHLOROPLASTIC', 239624),
(305417, 'PTHR11055:SF41', NULL, NULL, NULL, NULL, 'ATP-SULFURYLASE 3, CHLOROPLASTIC', 239624),
(305418, 'PTHR11055:SF53', NULL, NULL, NULL, NULL, 'ADENYLYL-SULFATE KINASE 2, CHLOROPLASTIC', 239624),
(305419, 'PTHR11055:SF65', NULL, NULL, NULL, NULL, 'SULFATE ADENYLYLTRANSFERASE', 239624),
(305420, 'PTHR11055:SF66', NULL, NULL, NULL, NULL, 'ADENYLYL-SULFATE KINASE', 239624),
(305421, 'PTHR11055:SF44', NULL, NULL, NULL, NULL, 'ADENYLYL-SULFATE KINASE 4, CHLOROPLASTIC', 239624);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(305422, 'PTHR11055:SF67', NULL, NULL, NULL, NULL, 'ADENYLYL-SULFATE KINASE', 239624),
(305423, 'PTHR11055:SF68', NULL, NULL, NULL, NULL, 'SULFATE ADENYLYLTRANSFERASE', 239624),
(305424, 'PTHR11055:SF46', NULL, NULL, NULL, NULL, 'ATP SULFURYLASE 1, CHLOROPLASTIC', 239624),
(305425, 'PTHR11055:SF69', NULL, NULL, NULL, NULL, 'SULFATE ADENYLYLTRANSFERASE', 239624),
(305426, 'PTHR11055:SF37', NULL, NULL, NULL, NULL, 'ATP SULFURYLASE 2', 239624),
(305427, 'PTHR11055:SF70', NULL, NULL, NULL, NULL, 'ADENYLYL-SULFATE KINASE', 239624),
(305428, 'PTHR11055:SF60', NULL, NULL, NULL, NULL, 'ADENYLYL-SULFATE KINASE', 239624),
(305429, 'PTHR11055:SF71', NULL, NULL, NULL, NULL, 'ADENYLYL-SULFATE KINASE', 239624),
(305430, 'PTHR11055:SF72', NULL, NULL, NULL, NULL, 'ADENYLYL-SULFATE KINASE', 239624),
(305431, 'PTHR11055', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL 3''-PHOSPHOADENOSINE 5''-PHOSPHOSULFATE SYNTHASE', 239624),
(305432, 'PTHR11055:SF61', NULL, NULL, NULL, NULL, 'ADENYLYL-SULFATE KINASE', 239624),
(305433, 'PTHR14455:SF0', NULL, NULL, NULL, NULL, 'S100P-BINDING PROTEIN', 239625),
(305434, 'PTHR14455', NULL, NULL, NULL, NULL, 'ASKOPOS', 239625),
(305435, 'PTHR31513:SF2', NULL, NULL, NULL, NULL, 'MRAZ', 239626),
(305436, 'PTHR31513', NULL, NULL, NULL, NULL, 'EPHRIN TYPE-B RECEPTOR', 239626),
(305437, 'PTHR31513:SF9', NULL, NULL, NULL, NULL, '', 239626),
(305438, 'PTHR31513:SF17', NULL, NULL, NULL, NULL, '', 239626),
(305439, 'PTHR31513:SF13', NULL, NULL, NULL, NULL, 'AAA_12 DOMAIN-CONTAINING PROTEIN', 239626),
(305440, 'PTHR31513:SF11', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN', 239626),
(305441, 'PTHR31513:SF12', NULL, NULL, NULL, NULL, '', 239626),
(305442, 'PTHR31513:SF1', NULL, NULL, NULL, NULL, 'EPHRIN TYPE-B RECEPTOR', 239626),
(305443, 'PTHR31513:SF10', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 239626),
(305444, 'PTHR46004:SF3', NULL, NULL, NULL, NULL, 'CYCLIC AMP RESPONSE ELEMENT-BINDING PROTEIN A', 239627),
(305445, 'PTHR46004', NULL, NULL, NULL, NULL, 'CYCLIC AMP RESPONSE ELEMENT-BINDING PROTEIN A', 239627),
(305446, 'PTHR46004:SF1', NULL, NULL, NULL, NULL, 'CYCLIC AMP-RESPONSIVE ELEMENT-BINDING PROTEIN 3-LIKE PROTEIN 1', 239627),
(305447, 'PTHR46004:SF2', NULL, NULL, NULL, NULL, 'CYCLIC AMP-RESPONSIVE ELEMENT-BINDING PROTEIN 3-LIKE PROTEIN 2', 239627),
(305448, 'PTHR33543:SF36', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN-LIKE PROTEIN 2A', 239628),
(305449, 'PTHR33543:SF26', NULL, NULL, NULL, NULL, 'BNAC02G03550D PROTEIN', 239628),
(305450, 'PTHR33543:SF37', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN-LIKE PROTEIN 4B', 239628),
(305451, 'PTHR33543:SF15', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN-LIKE PROTEIN 1A', 239628),
(305452, 'PTHR33543:SF35', NULL, NULL, NULL, NULL, '', 239628),
(305453, 'PTHR33543:SF18', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN-LIKE PROTEIN 2C', 239628),
(305454, 'PTHR33543:SF19', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN-LIKE PROTEIN TYPE 2', 239628),
(305455, 'PTHR33543:SF38', NULL, NULL, NULL, NULL, '', 239628),
(305456, 'PTHR33543:SF28', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN-LIKE PROTEIN 4A-RELATED', 239628),
(305457, 'PTHR33543:SF39', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN-LIKE PROTEIN TYPE 2', 239628),
(305458, 'PTHR33543:SF10', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN', 239628),
(305459, 'PTHR33543:SF33', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN-LIKE PROTEIN 2B', 239628),
(305460, 'PTHR33543:SF22', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN, FAMILY 15, PLANT-RELATED', 239628),
(305461, 'PTHR33543:SF30', NULL, NULL, NULL, NULL, 'BNAA03G54880D PROTEIN', 239628),
(305462, 'PTHR33543:SF20', NULL, NULL, NULL, NULL, 'BNAC03G35960D PROTEIN', 239628),
(305463, 'PTHR33543:SF7', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN-LIKE PROTEIN 1', 239628),
(305464, 'PTHR33543', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN-LIKE PROTEIN 2A', 239628),
(305465, 'PTHR41878', NULL, NULL, NULL, NULL, 'LEXA REPRESSOR-RELATED', 239629),
(305466, 'PTHR41878:SF1', NULL, NULL, NULL, NULL, 'LEXA REPRESSOR-RELATED', 239629),
(305467, 'PTHR46080:SF11', NULL, NULL, NULL, NULL, 'BNAA09G04350D PROTEIN', 239630);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(305468, 'PTHR46080:SF13', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 25 MEMBER 44-RELATED', 239630),
(305469, 'PTHR46080:SF19', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN', 239630),
(305470, 'PTHR46080:SF2', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CARRIER PROTEIN, EXPRESSED', 239630),
(305471, 'PTHR46080:SF18', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN J', 239630),
(305472, 'PTHR46080:SF4', NULL, NULL, NULL, NULL, 'OS09G0444700 PROTEIN', 239630),
(305473, 'PTHR46080:SF3', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN', 239630),
(305474, 'PTHR46080:SF17', NULL, NULL, NULL, NULL, 'SUBSTRATE CARRIER FAMILY PROTEIN', 239630),
(305475, 'PTHR46080:SF16', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 25 MEMBER 44-RELATED', 239630),
(305476, 'PTHR46080', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN J', 239630),
(305477, 'PTHR46080:SF5', NULL, NULL, NULL, NULL, 'OS01G0329400 PROTEIN', 239630),
(305478, 'PTHR46080:SF8', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 25 MEMBER 44-LIKE', 239630),
(305479, 'PTHR46080:SF7', NULL, NULL, NULL, NULL, 'CARRIER PROTEIN, PUTATIVE-RELATED', 239630),
(305480, 'PTHR21689', NULL, NULL, NULL, NULL, 'LIN-9', 239631),
(305481, 'PTHR21689:SF2', NULL, NULL, NULL, NULL, 'PROTEIN LIN-9 HOMOLOG', 239631),
(305482, 'PTHR21689:SF5', NULL, NULL, NULL, NULL, 'PROTEIN ALWAYS EARLY 1-RELATED', 239631),
(305483, 'PTHR21689:SF6', NULL, NULL, NULL, NULL, 'DIRP DOMAIN-CONTAINING PROTEIN', 239631),
(305484, 'PTHR21689:SF9', NULL, NULL, NULL, NULL, 'MYB DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 239631),
(305485, 'PTHR21689:SF7', NULL, NULL, NULL, NULL, 'DIRP DOMAIN-CONTAINING PROTEIN', 239631),
(305486, 'PTHR21689:SF8', NULL, NULL, NULL, NULL, 'DIRP DOMAIN-CONTAINING PROTEIN', 239631),
(305487, 'PTHR36498:SF1', NULL, NULL, NULL, NULL, 'TATA-BINDING PROTEIN-ASSOCIATED FACTOR 172', 239632),
(305488, 'PTHR36498', NULL, NULL, NULL, NULL, 'TATA-BINDING PROTEIN-ASSOCIATED FACTOR 172', 239632),
(305489, 'PTHR13036:SF0', NULL, NULL, NULL, NULL, 'CHITOBIOSYLDIPHOSPHODOLICHOL BETA-MANNOSYLTRANSFERASE', 239633),
(305490, 'PTHR13036:SF1', NULL, NULL, NULL, NULL, 'CHITOBIOSYLDIPHOSPHODOLICHOL BETA-MANNOSYLTRANSFERASE', 239633),
(305491, 'PTHR13036:SF2', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE ALG1L2-RELATED', 239633),
(305492, 'PTHR13036:SF4', NULL, NULL, NULL, NULL, 'BNAA09G56260D PROTEIN', 239633),
(305493, 'PTHR13036:SF5', NULL, NULL, NULL, NULL, 'GLYCOS_TRANSF_1 DOMAIN-CONTAINING PROTEIN', 239633),
(305494, 'PTHR13036', NULL, NULL, NULL, NULL, 'BETA1,4 MANNOSYLTRANSFERASE', 239633),
(305495, 'PTHR11073:SF25', NULL, NULL, NULL, NULL, 'CALRETICULIN-2', 239634),
(305496, 'PTHR11073:SF46', NULL, NULL, NULL, NULL, 'CALRETICULIN', 239634),
(305497, 'PTHR11073:SF45', NULL, NULL, NULL, NULL, 'CALRETICULIN', 239634),
(305498, 'PTHR11073:SF28', NULL, NULL, NULL, NULL, 'CALRETICULIN', 239634),
(305499, 'PTHR11073:SF27', NULL, NULL, NULL, NULL, 'CALRETICULIN', 239634),
(305500, 'PTHR11073:SF49', NULL, NULL, NULL, NULL, 'CALNEXIN 2', 239634),
(305501, 'PTHR11073:SF40', NULL, NULL, NULL, NULL, 'CALRETICULIN/CALNEXIN, CONCANAVALIN A-LIKE LECTIN/GLUCANASE DOMAIN PROTEIN-RELATED', 239634),
(305502, 'PTHR11073:SF3', NULL, NULL, NULL, NULL, 'CALRETICULIN-3', 239634),
(305503, 'PTHR11073:SF2', NULL, NULL, NULL, NULL, 'CALRETICULIN-1', 239634),
(305504, 'PTHR11073:SF1', NULL, NULL, NULL, NULL, 'CALNEXIN 14D-RELATED', 239634),
(305505, 'PTHR11073:SF42', NULL, NULL, NULL, NULL, 'CALRETICULIN', 239634),
(305506, 'PTHR11073:SF7', NULL, NULL, NULL, NULL, 'CALMEGIN', 239634),
(305507, 'PTHR11073', NULL, NULL, NULL, NULL, 'CALRETICULIN AND CALNEXIN', 239634),
(305508, 'PTHR11073:SF37', NULL, NULL, NULL, NULL, 'SI:CH211-274F20.2', 239634),
(305509, 'PTHR11073:SF14', NULL, NULL, NULL, NULL, 'CALRETICULIN', 239634),
(305510, 'PTHR11073:SF57', NULL, NULL, NULL, NULL, '', 239634),
(305511, 'PTHR11073:SF35', NULL, NULL, NULL, NULL, 'BNAANNG07030D PROTEIN', 239634),
(305512, 'PTHR11073:SF56', NULL, NULL, NULL, NULL, 'CALRETICULIN', 239634); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(305513, 'PTHR11073:SF39', NULL, NULL, NULL, NULL, 'CALRETICULIN', 239634),
(305514, 'PTHR11073:SF16', NULL, NULL, NULL, NULL, 'CALRETICULIN', 239634),
(305515, 'PTHR11073:SF55', NULL, NULL, NULL, NULL, 'CALRETICULIN/CALNEXIN', 239634),
(305516, 'PTHR11073:SF11', NULL, NULL, NULL, NULL, 'CALNEXIN', 239634),
(305517, 'PTHR11073:SF54', NULL, NULL, NULL, NULL, 'CALRETICULIN', 239634),
(305518, 'PTHR11073:SF53', NULL, NULL, NULL, NULL, 'CALRETICULIN', 239634),
(305519, 'PTHR11073:SF52', NULL, NULL, NULL, NULL, '', 239634),
(305520, 'PTHR34839:SF2', NULL, NULL, NULL, NULL, '', 239635),
(305521, 'PTHR34839', NULL, NULL, NULL, NULL, 'CS DOMAIN-CONTAINING PROTEIN', 239635),
(305522, 'PTHR34839:SF1', NULL, NULL, NULL, NULL, 'CS DOMAIN-CONTAINING PROTEIN', 239635),
(305523, 'PTHR18640:SF12', NULL, NULL, NULL, NULL, 'SODIUM/METABOLITE COTRANSPORTER BASS4, CHLOROPLASTIC-RELATED', 239636),
(305524, 'PTHR18640:SF13', NULL, NULL, NULL, NULL, 'SODIUM BILE ACID COTRANSPORTER-RELATED', 239636),
(305525, 'PTHR18640:SF14', NULL, NULL, NULL, NULL, 'SODIUM BILE ACID SYMPORTER FAMILY', 239636),
(305526, 'PTHR18640:SF5', NULL, NULL, NULL, NULL, 'SODIUM/BILE ACID COTRANSPORTER 7', 239636),
(305527, 'PTHR18640', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 10 MEMBER 7', 239636),
(305528, 'PTHR18640:SF10', NULL, NULL, NULL, NULL, 'SODIUM/METABOLITE COTRANSPORTER BASS4, CHLOROPLASTIC-RELATED', 239636),
(305529, 'PTHR47403:SF1', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 239637),
(305530, 'PTHR47403:SF2', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE 16,-LIKE', 239637),
(305531, 'PTHR47403', NULL, NULL, NULL, NULL, 'LOC100145250 PROTEIN', 239637),
(305532, 'PTHR47403:SF3', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE 16-RELATED', 239637),
(305533, 'PTHR38481:SF1', NULL, NULL, NULL, NULL, 'HYALURONATE LYASE', 239638),
(305534, 'PTHR38481', NULL, NULL, NULL, NULL, 'HYALURONATE LYASE', 239638),
(305535, 'PTHR21734', NULL, NULL, NULL, NULL, 'INHIBITOR OF NUCLEAR FACTOR KAPPA-B KINASE-INTERACTING PROTEIN', 239639),
(305536, 'PTHR21734:SF10', NULL, NULL, NULL, NULL, 'INHIBITOR OF NUCLEAR FACTOR KAPPA-B KINASE-INTERACTING PROTEIN', 239639),
(305537, 'PTHR21734:SF11', NULL, NULL, NULL, NULL, 'INHIBITOR OF NUCLEAR FACTOR KAPPA-B KINASE-INTERACTING PROTEIN', 239639),
(305538, 'PTHR43839:SF4', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORT SYSTEM PERMEASE PROTEIN OPPC', 239640),
(305539, 'PTHR43839', NULL, NULL, NULL, NULL, 'OPPC IN A BINDING PROTEIN-DEPENDENT TRANSPORT SYSTEM', 239640),
(305540, 'PTHR43839:SF3', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE ABC TRANSPORTER, PERMEASE PROTEIN-RELATED', 239640),
(305541, 'PTHR43839:SF1', NULL, NULL, NULL, NULL, 'OPPC IN A BINDING PROTEIN-DEPENDENT TRANSPORT SYSTEM', 239640),
(305542, 'PTHR47020', NULL, NULL, NULL, NULL, 'HILLARIN', 239641),
(305543, 'PTHR47020:SF1', NULL, NULL, NULL, NULL, 'HILLARIN', 239641),
(305544, 'PTHR10937:SF0', NULL, NULL, NULL, NULL, 'GLUTAMINE--FRUCTOSE-6-PHOSPHATE TRANSAMINASE (ISOMERIZING)', 239642),
(305545, 'PTHR10937:SF13', NULL, NULL, NULL, NULL, 'GLUTAMINE--FRUCTOSE-6-PHOSPHATE TRANSAMINASE (ISOMERIZING)', 239642),
(305546, 'PTHR10937:SF4', NULL, NULL, NULL, NULL, 'GLUCOSAMINE-6-PHOSPHATE DEAMINASE', 239642),
(305547, 'PTHR10937:SF12', NULL, NULL, NULL, NULL, 'GLUTAMINE--FRUCTOSE-6-PHOSPHATE AMINOTRANSFERASE [ISOMERIZING] 1', 239642),
(305548, 'PTHR10937:SF10', NULL, NULL, NULL, NULL, 'GLUTAMINE--FRUCTOSE-6-PHOSPHATE AMINOTRANSFERASE [ISOMERIZING] 2', 239642),
(305549, 'PTHR10937:SF8', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE-RELATED', 239642),
(305550, 'PTHR10937:SF17', NULL, NULL, NULL, NULL, 'GLUCOSAMINE-FRUCTOSE-6-PHOSPHATE AMINOTRANSFERASE-RELATED', 239642),
(305551, 'PTHR10937:SF16', NULL, NULL, NULL, NULL, 'GLUTAMINE--FRUCTOSE-6-PHOSPHATE TRANSAMINASE (ISOMERIZING)', 239642),
(305552, 'PTHR10937:SF14', NULL, NULL, NULL, NULL, 'FRUCTOSELYSINE 6-PHOSPHATE DEGLYCASE', 239642),
(305553, 'PTHR10937', NULL, NULL, NULL, NULL, 'GLUCOSAMINE--FRUCTOSE-6-PHOSPHATE AMINOTRANSFERASE, ISOMERIZING', 239642),
(305554, 'PTHR23250:SF3', NULL, NULL, NULL, NULL, 'SI:CH211-251F6.6-RELATED', 239643);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(305555, 'PTHR23250:SF1', NULL, NULL, NULL, NULL, 'TECTONIN BETA-PROPELLER REPEAT-CONTAINING PROTEIN 1', 239643),
(305556, 'PTHR23250', NULL, NULL, NULL, NULL, 'DYSFERLIN-RELATED', 239643),
(305557, 'PTHR23250:SF10', NULL, NULL, NULL, NULL, 'TECTONIN BETA-PROPELLER REPEAT-CONTAINING PROTEIN 1', 239643),
(305558, 'PTHR22367:SF2', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 14', 239644),
(305559, 'PTHR22367', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 14', 239644),
(305560, 'PTHR34709:SF61', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239645),
(305561, 'PTHR34709:SF67', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239645),
(305562, 'PTHR34709:SF44', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 239645),
(305563, 'PTHR34709:SF66', NULL, NULL, NULL, NULL, '', 239645),
(305564, 'PTHR34709:SF25', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 239645),
(305565, 'PTHR34709:SF69', NULL, NULL, NULL, NULL, 'OS03G0222200 PROTEIN', 239645),
(305566, 'PTHR34709:SF47', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 239645),
(305567, 'PTHR34709:SF68', NULL, NULL, NULL, NULL, 'ABC_TRANS_N DOMAIN-CONTAINING PROTEIN', 239645),
(305568, 'PTHR34709:SF62', NULL, NULL, NULL, NULL, 'OS12G0545400 PROTEIN', 239645),
(305569, 'PTHR34709:SF21', NULL, NULL, NULL, NULL, '', 239645),
(305570, 'PTHR34709:SF43', NULL, NULL, NULL, NULL, 'OS12G0527100 PROTEIN', 239645),
(305571, 'PTHR34709:SF65', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239645),
(305572, 'PTHR34709:SF42', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239645),
(305573, 'PTHR34709:SF64', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239645),
(305574, 'PTHR34709:SF19', NULL, NULL, NULL, NULL, '', 239645),
(305575, 'PTHR34709:SF16', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 239645),
(305576, 'PTHR34709:SF37', NULL, NULL, NULL, NULL, '', 239645),
(305577, 'PTHR34709:SF18', NULL, NULL, NULL, NULL, 'OS07G0547100 PROTEIN', 239645),
(305578, 'PTHR34709:SF39', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239645),
(305579, 'PTHR34709:SF70', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239645),
(305580, 'PTHR34709:SF72', NULL, NULL, NULL, NULL, 'OS07G0130000 PROTEIN', 239645),
(305581, 'PTHR34709:SF71', NULL, NULL, NULL, NULL, 'BNAA08G11870D PROTEIN', 239645),
(305582, 'PTHR34709:SF56', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239645),
(305583, 'PTHR34709:SF33', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239645),
(305584, 'PTHR34709:SF11', NULL, NULL, NULL, NULL, 'OS07G0113600 PROTEIN', 239645),
(305585, 'PTHR34709:SF36', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 239645),
(305586, 'PTHR34709:SF58', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 239645),
(305587, 'PTHR34709:SF57', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 15', 239645),
(305588, 'PTHR34709', NULL, NULL, NULL, NULL, 'OS10G0396666 PROTEIN', 239645),
(305589, 'PTHR34709:SF52', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239645),
(305590, 'PTHR34709:SF73', NULL, NULL, NULL, NULL, 'OS08G0469500 PROTEIN', 239645),
(305591, 'PTHR34709:SF54', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239645),
(305592, 'PTHR34709:SF10', NULL, NULL, NULL, NULL, 'OS07G0118900 PROTEIN', 239645),
(305593, 'PTHR34709:SF26', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 239645),
(305594, 'PTHR34709:SF29', NULL, NULL, NULL, NULL, 'OS06G0688400 PROTEIN', 239645),
(305595, 'PTHR34709:SF28', NULL, NULL, NULL, NULL, 'OS08G0272601 PROTEIN', 239645),
(305596, 'PTHR34011:SF6', NULL, NULL, NULL, NULL, 'PHYCOBILIPROTEIN APCE', 239646),
(305597, 'PTHR34011:SF7', NULL, NULL, NULL, NULL, 'C-PHYCOCYANIN BETA SUBUNIT', 239646),
(305598, 'PTHR34011:SF4', NULL, NULL, NULL, NULL, 'C-PHYCOCYANIN ALPHA SUBUNIT', 239646),
(305599, 'PTHR34011:SF5', NULL, NULL, NULL, NULL, 'PHYCOBILISOME 32.1 KDA LINKER POLYPEPTIDE, PHYCOCYANIN-ASSOCIATED, ROD 2', 239646),
(305600, 'PTHR34011', NULL, NULL, NULL, NULL, 'PHYCOBILISOME 32.1 KDA LINKER POLYPEPTIDE, PHYCOCYANIN-ASSOCIATED, ROD 2-RELATED', 239646);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(305601, 'PTHR34011:SF2', NULL, NULL, NULL, NULL, 'ALLOPHYCOCYANIN ALPHA CHAIN', 239646),
(305602, 'PTHR34011:SF3', NULL, NULL, NULL, NULL, 'ALLOPHYCOCYANIN BETA CHAIN', 239646),
(305603, 'PTHR24368:SF62', NULL, NULL, NULL, NULL, 'AMPHOTERIN-INDUCED PROTEIN 3', 239647),
(305604, 'PTHR24368:SF209', NULL, NULL, NULL, NULL, 'AMPHOTERIN-INDUCED PROTEIN 2', 239647),
(305605, 'PTHR24368', NULL, NULL, NULL, NULL, 'AMPHOTERIN-INDUCED PROTEIN', 239647),
(305606, 'PTHR24368:SF1', NULL, NULL, NULL, NULL, 'AMPHOTERIN-INDUCED PROTEIN 1', 239647),
(305607, 'PTHR24368:SF210', NULL, NULL, NULL, NULL, 'SURFACE ANTIGEN BSPA-LIKE', 239647),
(305608, 'PTHR11266:SF18', NULL, NULL, NULL, NULL, 'OS12G0508100 PROTEIN', 239648),
(305609, 'PTHR11266:SF105', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE 22 KDA (MPV17/PMP22) FAMILY PROTEIN-RELATED', 239648),
(305610, 'PTHR11266:SF104', NULL, NULL, NULL, NULL, '', 239648),
(305611, 'PTHR11266:SF107', NULL, NULL, NULL, NULL, 'BNAC03G44040D PROTEIN', 239648),
(305612, 'PTHR11266:SF106', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE 22 KDA (MPV17/PMP22) FAMILY PROTEIN-RELATED', 239648),
(305613, 'PTHR11266:SF50', NULL, NULL, NULL, NULL, 'VACUOLAR MEMBRANE PROTEIN YOR292C', 239648),
(305614, 'PTHR11266:SF94', NULL, NULL, NULL, NULL, '22 KDA PEROXISOMAL MEMBRANE PROTEIN', 239648),
(305615, 'PTHR11266:SF75', NULL, NULL, NULL, NULL, 'IP10007P', 239648),
(305616, 'PTHR11266:SF109', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE 22 KDA (MPV17/PMP22) FAMILY PROTEIN', 239648),
(305617, 'PTHR11266:SF91', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239648),
(305618, 'PTHR11266:SF108', NULL, NULL, NULL, NULL, 'BNACNNG22360D PROTEIN', 239648),
(305619, 'PTHR11266:SF93', NULL, NULL, NULL, NULL, 'WORONIN SORTING COMPLEX PROTEIN', 239648),
(305620, 'PTHR11266:SF17', NULL, NULL, NULL, NULL, 'PROTEIN MPV17', 239648),
(305621, 'PTHR11266:SF39', NULL, NULL, NULL, NULL, 'MPV17-LIKE PROTEIN', 239648),
(305622, 'PTHR11266:SF16', NULL, NULL, NULL, NULL, 'OS03G0583800 PROTEIN', 239648),
(305623, 'PTHR11266:SF116', NULL, NULL, NULL, NULL, 'MPV17-LIKE PROTEIN', 239648),
(305624, 'PTHR11266:SF115', NULL, NULL, NULL, NULL, '22 KDA PEROXISOMAL MEMBRANE PROTEIN', 239648),
(305625, 'PTHR11266:SF118', NULL, NULL, NULL, NULL, '', 239648),
(305626, 'PTHR11266:SF117', NULL, NULL, NULL, NULL, 'PROTEIN SYM1', 239648),
(305627, 'PTHR11266:SF112', NULL, NULL, NULL, NULL, 'PXMP2/4 FAMILY PROTEIN 3', 239648),
(305628, 'PTHR11266:SF111', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE 22 KDA (MPV17/PMP22) FAMILY PROTEIN', 239648),
(305629, 'PTHR11266:SF113', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN, MPV17/PMP22 FAMILY, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G13840)-RELATED', 239648),
(305630, 'PTHR11266:SF86', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN PMP22', 239648),
(305631, 'PTHR11266:SF85', NULL, NULL, NULL, NULL, 'MPV17-LIKE PROTEIN', 239648),
(305632, 'PTHR11266:SF80', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN 2', 239648),
(305633, 'PTHR11266:SF119', NULL, NULL, NULL, NULL, 'PROTEIN SYM1', 239648),
(305634, 'PTHR11266:SF8', NULL, NULL, NULL, NULL, 'MPV17-LIKE PROTEIN 2', 239648),
(305635, 'PTHR11266:SF81', NULL, NULL, NULL, NULL, 'GH12661P', 239648),
(305636, 'PTHR11266:SF26', NULL, NULL, NULL, NULL, 'IP08061P', 239648),
(305637, 'PTHR11266', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN 2, PXMP2  MPV17', 239648),
(305638, 'PTHR11266:SF28', NULL, NULL, NULL, NULL, 'SI:CH211-120K19.1', 239648),
(305639, 'PTHR11266:SF88', NULL, NULL, NULL, NULL, '22 KDA PEROXISOMAL MEMBRANE PROTEIN', 239648),
(305640, 'PTHR11266:SF87', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN 2, PXMP2', 239648),
(305641, 'PTHR11266:SF21', NULL, NULL, NULL, NULL, '', 239648),
(305642, 'PTHR11266:SF46', NULL, NULL, NULL, NULL, 'OS08G0566900 PROTEIN', 239648),
(305643, 'PTHR47210:SF1', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 26C-RELATED', 239649),
(305644, 'PTHR47210:SF4', NULL, NULL, NULL, NULL, 'TFIIS N-TERMINAL DOMAIN-CONTAINING PROTEIN', 239649),
(305645, 'PTHR47210:SF3', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 26C ISOFORM X1-RELATED', 239649);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(305646, 'PTHR47210', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 26C-RELATED', 239649),
(305647, 'PTHR47210:SF5', NULL, NULL, NULL, NULL, 'OS12G0165700 PROTEIN', 239649),
(305648, 'PTHR46791:SF5', NULL, NULL, NULL, NULL, 'ZMP:0000000984', 239650),
(305649, 'PTHR46791:SF4', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 239650),
(305650, 'PTHR46791:SF10', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 239650),
(305651, 'PTHR46791:SF11', NULL, NULL, NULL, NULL, 'ZGC:174680', 239650),
(305652, 'PTHR46791', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239650),
(305653, 'PTHR46791:SF9', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 239650),
(305654, 'PTHR46791:SF8', NULL, NULL, NULL, NULL, '', 239650),
(305655, 'PTHR46791:SF7', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 239650),
(305656, 'PTHR46320:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG16011', 239651),
(305657, 'PTHR46320', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE 1', 239651),
(305658, 'PTHR46320:SF2', NULL, NULL, NULL, NULL, 'GP-PDE DOMAIN-CONTAINING PROTEIN', 239651),
(305659, 'PTHR46320:SF1', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE 1', 239651),
(305660, 'PTHR47387', NULL, NULL, NULL, NULL, 'NECTIN-2', 239652),
(305661, 'PTHR47387:SF1', NULL, NULL, NULL, NULL, 'NECTIN-2', 239652),
(305662, 'PTHR34119:SF12', NULL, NULL, NULL, NULL, 'BNAA06G32570D PROTEIN', 239653),
(305663, 'PTHR34119', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN-LIKE', 239653),
(305664, 'PTHR34119:SF14', NULL, NULL, NULL, NULL, 'ARFAPTIN HOMOLOGY (AH) DOMAIN/BAR DOMAIN PROTEIN-RELATED', 239653),
(305665, 'PTHR34119:SF8', NULL, NULL, NULL, NULL, 'OS09G0509300 PROTEIN', 239653),
(305666, 'PTHR34119:SF7', NULL, NULL, NULL, NULL, 'OS04G0394700 PROTEIN', 239653),
(305667, 'PTHR34119:SF9', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 239653),
(305668, 'PTHR34119:SF17', NULL, NULL, NULL, NULL, 'ARFAPTIN HOMOLOGY (AH) DOMAIN/BAR DOMAIN PROTEIN-RELATED', 239653),
(305669, 'PTHR34119:SF18', NULL, NULL, NULL, NULL, 'BNAA05G10100D PROTEIN', 239653),
(305670, 'PTHR34119:SF1', NULL, NULL, NULL, NULL, 'OS02G0515200 PROTEIN', 239653),
(305671, 'PTHR34119:SF19', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 239653),
(305672, 'PTHR22743:SF170', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 239654),
(305673, 'PTHR22743', NULL, NULL, NULL, NULL, 'MEPRIN/TRAF-LIKE MATH FAMILY-C.ELEGANS', 239654),
(305674, 'PTHR22743:SF169', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 239654),
(305675, 'PTHR22743:SF168', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 239654),
(305676, 'PTHR22743:SF165', NULL, NULL, NULL, NULL, 'BTB AND MATH DOMAIN CONTAINING-RELATED', 239654),
(305677, 'PTHR30283:SF4', NULL, NULL, NULL, NULL, 'PEROXIDE STRESS RESISTANCE PROTEIN YAAA', 239655),
(305678, 'PTHR30283', NULL, NULL, NULL, NULL, 'PEROXIDE STRESS RESPONSE PROTEIN YAAA', 239655),
(305679, 'PTHR15817', NULL, NULL, NULL, NULL, 'STG PROTEIN', 239656),
(305680, 'PTHR15817:SF2', NULL, NULL, NULL, NULL, 'MUCIN 18B, ISOFORM A', 239656),
(305681, 'PTHR19376:SF60', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT BETA''', 239657),
(305682, 'PTHR19376:SF51', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE V SUBUNIT 1', 239657),
(305683, 'PTHR19376:SF63', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT BETA''''', 239657),
(305684, 'PTHR19376:SF64', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT', 239657),
(305685, 'PTHR19376:SF54', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT BETA''''', 239657),
(305686, 'PTHR19376:SF32', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE III SUBUNIT RPC1', 239657),
(305687, 'PTHR19376:SF65', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE', 239657),
(305688, 'PTHR19376:SF11', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE I SUBUNIT RPA1', 239657);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(305689, 'PTHR19376:SF66', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT', 239657),
(305690, 'PTHR19376:SF55', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT', 239657),
(305691, 'PTHR19376:SF67', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE', 239657),
(305692, 'PTHR19376:SF46', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT', 239657),
(305693, 'PTHR19376:SF36', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE IV SUBUNIT 1', 239657),
(305694, 'PTHR19376:SF37', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE II SUBUNIT RPB1', 239657),
(305695, 'PTHR19376', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE', 239657),
(305696, 'PTHR36367:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 239658),
(305697, 'PTHR36367', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 239658),
(305698, 'PTHR10896:SF17', NULL, NULL, NULL, NULL, 'BETA-1,4-XYLOSYLTRANSFERASE IRX14H-RELATED', 239659),
(305699, 'PTHR10896:SF59', NULL, NULL, NULL, NULL, 'BETA-1,4-XYLOSYLTRANSFERASE IRX9', 239659),
(305700, 'PTHR10896:SF26', NULL, NULL, NULL, NULL, 'BETA-1,4-XYLOSYLTRANSFERASE IRX9-RELATED', 239659),
(305701, 'PTHR10896:SF69', NULL, NULL, NULL, NULL, 'GALACTOSYLGALACTOSYLXYLOSYLPROTEIN 3-BETA-GLUCURONOSYLTRANSFERASE', 239659),
(305702, 'PTHR10896:SF25', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE OS03G0287800-RELATED', 239659),
(305703, 'PTHR10896:SF19', NULL, NULL, NULL, NULL, 'GALACTOSYLGALACTOSYLXYLOSYLPROTEIN 3-BETA-GLUCURONOSYLTRANSFERASE', 239659),
(305704, 'PTHR10896:SF64', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASES', 239659),
(305705, 'PTHR10896:SF31', NULL, NULL, NULL, NULL, 'BETA-1,4-XYLOSYLTRANSFERASE GT43E-RELATED', 239659),
(305706, 'PTHR10896:SF20', NULL, NULL, NULL, NULL, 'BETA-1,4-XYLOSYLTRANSFERASE IRX9L-RELATED', 239659),
(305707, 'PTHR10896:SF63', NULL, NULL, NULL, NULL, 'BETA-1,4-XYLOSYLTRANSFERASE IRX14', 239659),
(305708, 'PTHR10896:SF30', NULL, NULL, NULL, NULL, 'GALACTOSYLGALACTOSYLXYLOSYLPROTEIN 3-BETA-GLUCURONOSYLTRANSFERASE', 239659),
(305709, 'PTHR10896:SF51', NULL, NULL, NULL, NULL, 'GALACTOSYLGALACTOSYLXYLOSYLPROTEIN 3-BETA-GLUCURONOSYLTRANSFERASE S', 239659),
(305710, 'PTHR10896:SF50', NULL, NULL, NULL, NULL, 'GALACTOSYLGALACTOSYLXYLOSYLPROTEIN 3-BETA-GLUCURONOSYLTRANSFERASE P', 239659),
(305711, 'PTHR10896:SF24', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE OS04G0650300-RELATED', 239659),
(305712, 'PTHR10896:SF66', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASES', 239659),
(305713, 'PTHR10896:SF33', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE OS04G0103100-RELATED', 239659),
(305714, 'PTHR10896:SF21', NULL, NULL, NULL, NULL, 'GALACTOSYLGALACTOSYLXYLOSYLPROTEIN 3-BETA-GLUCURONOSYLTRANSFERASE 1', 239659),
(305715, 'PTHR10896:SF65', NULL, NULL, NULL, NULL, 'GALACTOSYLGALACTOSYLXYLOSYLPROTEIN 3-BETA-GLUCURONOSYLTRANSFERASE 3', 239659),
(305716, 'PTHR10896:SF32', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE OS01G0157700-RELATED', 239659),
(305717, 'PTHR10896:SF8', NULL, NULL, NULL, NULL, 'GALACTOSYLGALACTOSYLXYLOSYLPROTEIN 3-BETA-GLUCURONOSYLTRANSFERASE 2', 239659),
(305718, 'PTHR10896', NULL, NULL, NULL, NULL, 'GALACTOSYLGALACTOSYLXYLOSYLPROTEIN 3-BETA-GLUCURONOSYLTRANSFERASE  BETA-1,3-GLUCURONYLTRANSFERASE', 239659),
(305719, 'PTHR33663:SF3', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 185', 239660),
(305720, 'PTHR33663:SF2', NULL, NULL, NULL, NULL, '', 239660),
(305721, 'PTHR33663:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 177', 239660),
(305722, 'PTHR33663', NULL, NULL, NULL, NULL, '', 239660),
(305723, 'PTHR46000:SF9', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 239661),
(305724, 'PTHR46000:SF7', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 239661),
(305725, 'PTHR46000:SF8', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 239661),
(305726, 'PTHR46000:SF5', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 239661),
(305727, 'PTHR46000:SF6', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 239661),
(305728, 'PTHR46000:SF4', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 239661);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(305729, 'PTHR46000', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR-RELATED', 239661),
(305730, 'PTHR46000:SF1', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 239661),
(305731, 'PTHR46000:SF2', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 239661),
(305732, 'PTHR46000:SF11', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 239661),
(305733, 'PTHR46000:SF10', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 239661),
(305734, 'PTHR47034:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER TRANSCRIPTION FACTOR TRPS1', 239662),
(305735, 'PTHR47034', NULL, NULL, NULL, NULL, 'ZINC FINGER TRANSCRIPTION FACTOR TRPS1', 239662),
(305736, 'PTHR33825', NULL, NULL, NULL, NULL, 'CHITINASE-LIKE PROTEIN', 239663),
(305737, 'PTHR33825:SF14', NULL, NULL, NULL, NULL, 'CHITINASE-LIKE PROTEIN', 239663),
(305738, 'PTHR33825:SF4', NULL, NULL, NULL, NULL, 'OS05G0137600 PROTEIN', 239663),
(305739, 'PTHR33825:SF5', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 239663),
(305740, 'PTHR28441:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM91A1', 239664),
(305741, 'PTHR28441:SF3', NULL, NULL, NULL, NULL, 'FAM91A1-LIKE PROTEIN', 239664),
(305742, 'PTHR28441:SF1', NULL, NULL, NULL, NULL, 'OS05G0355133 PROTEIN', 239664),
(305743, 'PTHR28441', NULL, NULL, NULL, NULL, 'PROTEIN FAM91A1', 239664),
(305744, 'PTHR28441:SF6', NULL, NULL, NULL, NULL, '', 239664),
(305745, 'PTHR28441:SF7', NULL, NULL, NULL, NULL, '', 239664),
(305746, 'PTHR28441:SF4', NULL, NULL, NULL, NULL, 'PROTEIN FAM91A1', 239664),
(305747, 'PTHR28441:SF5', NULL, NULL, NULL, NULL, '', 239664),
(305748, 'PTHR22967:SF65', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE AKL1', 239665),
(305749, 'PTHR22967:SF10', NULL, NULL, NULL, NULL, 'BMP-2-INDUCIBLE PROTEIN KINASE', 239665),
(305750, 'PTHR22967:SF99', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239665),
(305751, 'PTHR22967:SF57', NULL, NULL, NULL, NULL, 'AUXILIN, ISOFORM A-RELATED', 239665),
(305752, 'PTHR22967', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE', 239665),
(305753, 'PTHR22967:SF101', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239665),
(305754, 'PTHR22967:SF91', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0280111-RELATED', 239665),
(305755, 'PTHR22967:SF103', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 239665),
(305756, 'PTHR22967:SF92', NULL, NULL, NULL, NULL, 'LD17053P', 239665),
(305757, 'PTHR22967:SF102', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN PPK38', 239665),
(305758, 'PTHR22967:SF105', NULL, NULL, NULL, NULL, 'CYCLIN G ASSOCIATED KINASE', 239665),
(305759, 'PTHR22967:SF104', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PPK29', 239665),
(305760, 'PTHR11661:SF19', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L11, MITOCHONDRIAL', 239666),
(305761, 'PTHR11661:SF39', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L12-3', 239666),
(305762, 'PTHR11661:SF2', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L12', 239666),
(305763, 'PTHR11661:SF18', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L12-3-LIKE', 239666),
(305764, 'PTHR11661:SF1', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L11, MITOCHONDRIAL', 239666),
(305765, 'PTHR11661:SF40', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L12', 239666),
(305766, 'PTHR11661:SF30', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L12', 239666),
(305767, 'PTHR11661:SF41', NULL, NULL, NULL, NULL, 'OS10G0466200 PROTEIN', 239666),
(305768, 'PTHR11661:SF11', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L11_N DOMAIN-CONTAINING PROTEIN', 239666),
(305769, 'PTHR11661:SF42', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L11_N DOMAIN-CONTAINING PROTEIN', 239666),
(305770, 'PTHR11661:SF21', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L12', 239666),
(305771, 'PTHR11661:SF43', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L12-1-RELATED', 239666),
(305772, 'PTHR11661:SF38', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L12', 239666),
(305773, 'PTHR11661:SF35', NULL, NULL, NULL, NULL, '', 239666),
(305774, 'PTHR11661', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L12', 239666);
INSERT INTO "PUBLIC"."MODEL" VALUES
(305775, 'PTHR11661:SF24', NULL, NULL, NULL, NULL, 'BNAC04G27310D PROTEIN', 239666),
(305776, 'PTHR11661:SF25', NULL, NULL, NULL, NULL, 'BNAA02G10390D PROTEIN', 239666),
(305777, 'PTHR43636:SF4', NULL, NULL, NULL, NULL, 'EFG_IV DOMAIN-CONTAINING PROTEIN', 239667),
(305778, 'PTHR43636:SF2', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR G, MITOCHONDRIAL', 239667),
(305779, 'PTHR43636', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR G, MITOCHONDRIAL', 239667),
(305780, 'PTHR43636:SF5', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR G, MITOCHONDRIAL', 239667),
(305781, 'PTHR37031:SF2', NULL, NULL, NULL, NULL, 'PHOD DOMAIN-CONTAINING PROTEIN', 239668),
(305782, 'PTHR37031', NULL, NULL, NULL, NULL, 'METALLOPHOSPHATASE BINDING DOMAIN PROTEIN', 239668),
(305783, 'PTHR32100:SF77', NULL, NULL, NULL, NULL, 'MICROSOMAL OMEGA-3 FATTY ACID DESATURASE', 239669),
(305784, 'PTHR32100:SF55', NULL, NULL, NULL, NULL, 'MICROSOMAL OMEGA-6-DESATURASE', 239669),
(305785, 'PTHR32100:SF76', NULL, NULL, NULL, NULL, 'MICROSOMAL OMEGA-6 FATTY ACID DESATURASE', 239669),
(305786, 'PTHR32100:SF57', NULL, NULL, NULL, NULL, 'MICROSOMAL OLEIC ACID DESATURASE', 239669),
(305787, 'PTHR32100:SF13', NULL, NULL, NULL, NULL, 'DELTA(12)-FATTY-ACID DESATURASE', 239669),
(305788, 'PTHR32100:SF35', NULL, NULL, NULL, NULL, 'DELTA(12) FATTY ACID DESATURASE FAT-2', 239669),
(305789, 'PTHR32100:SF56', NULL, NULL, NULL, NULL, 'MICROSOMAL OLEIC ACID DESATURASE', 239669),
(305790, 'PTHR32100:SF78', NULL, NULL, NULL, NULL, '', 239669),
(305791, 'PTHR32100:SF59', NULL, NULL, NULL, NULL, 'OMEGA-3 FATTY ACID DESATURASE PROTEIN-RELATED', 239669),
(305792, 'PTHR32100:SF58', NULL, NULL, NULL, NULL, 'FATTY ACID DESATURASE-RELATED', 239669),
(305793, 'PTHR32100:SF36', NULL, NULL, NULL, NULL, 'DELTA(12)-FATTY-ACID DESATURASE', 239669),
(305794, 'PTHR32100:SF39', NULL, NULL, NULL, NULL, '', 239669),
(305795, 'PTHR32100:SF75', NULL, NULL, NULL, NULL, 'OMEGA-3 FATTY ACID DESATURASE FAT-1', 239669),
(305796, 'PTHR32100:SF53', NULL, NULL, NULL, NULL, 'FATTY ACID DESATURASE DOMAIN-CONTAINING PROTEIN-RELATED', 239669),
(305797, 'PTHR32100:SF52', NULL, NULL, NULL, NULL, 'TEMPERATURE-SENSITIVE SN-2 ACYL-LIPID OMEGA-3 DESATURASE (FERREDOXIN), CHLOROPLASTIC', 239669),
(305798, 'PTHR32100:SF74', NULL, NULL, NULL, NULL, 'FATTY ACID DESATURASE7', 239669),
(305799, 'PTHR32100:SF19', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL OELATE/LINOLEIC ACID DELTA DESATURASE (EUROFUNG)', 239669),
(305800, 'PTHR32100:SF66', NULL, NULL, NULL, NULL, 'DELTA(12)-FATTY-ACID DESATURASE FAD2-LIKE', 239669),
(305801, 'PTHR32100:SF44', NULL, NULL, NULL, NULL, 'DELTA(12) FATTY ACID DEHYDROGENASE-RELATED', 239669),
(305802, 'PTHR32100:SF65', NULL, NULL, NULL, NULL, 'FATTY ACID DESATURASE DES3', 239669),
(305803, 'PTHR32100:SF46', NULL, NULL, NULL, NULL, 'DELTA(12)-FATTY-ACID DESATURASE FAD2-LIKE', 239669),
(305804, 'PTHR32100:SF68', NULL, NULL, NULL, NULL, 'MICROSOMAL OLEIC ACID DESATURASE', 239669),
(305805, 'PTHR32100:SF67', NULL, NULL, NULL, NULL, 'FA_DESATURASE DOMAIN-CONTAINING PROTEIN', 239669),
(305806, 'PTHR32100:SF48', NULL, NULL, NULL, NULL, '', 239669),
(305807, 'PTHR32100:SF47', NULL, NULL, NULL, NULL, 'ACYL-LIPID OMEGA-3 DESATURASE (CYTOCHROME B5), ENDOPLASMIC RETICULUM', 239669),
(305808, 'PTHR32100:SF69', NULL, NULL, NULL, NULL, 'FATTY ACID DESATURASE-RELATED', 239669),
(305809, 'PTHR32100:SF49', NULL, NULL, NULL, NULL, 'DELTA(12)-FATTY-ACID DESATURASE', 239669),
(305810, 'PTHR32100:SF60', NULL, NULL, NULL, NULL, 'BNAA04G17150D PROTEIN', 239669),
(305811, 'PTHR32100:SF62', NULL, NULL, NULL, NULL, 'ACYL-LIPID OMEGA-3 DESATURASE (CYTOCHROME B5), ENDOPLASMIC RETICULUM', 239669),
(305812, 'PTHR32100:SF40', NULL, NULL, NULL, NULL, 'OLEATE HYDROXYLASE FAH12', 239669),
(305813, 'PTHR32100:SF61', NULL, NULL, NULL, NULL, 'FATTY ACID DESATURASE 2', 239669),
(305814, 'PTHR32100:SF64', NULL, NULL, NULL, NULL, 'OS07G0416900 PROTEIN', 239669),
(305815, 'PTHR32100:SF41', NULL, NULL, NULL, NULL, 'SN-2 ACYL-LIPID OMEGA-3 DESATURASE (FERREDOXIN), CHLOROPLASTIC', 239669),
(305816, 'PTHR32100:SF63', NULL, NULL, NULL, NULL, 'OMEGA-6 FATTY ACID DESATURASE', 239669);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(305817, 'PTHR32100', NULL, NULL, NULL, NULL, 'OMEGA-6 FATTY ACID DESATURASE, CHLOROPLASTIC', 239669),
(305818, 'PTHR44668:SF2', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE SDR FAMILY MEMBER 7C', 239670),
(305819, 'PTHR44668', NULL, NULL, NULL, NULL, '', 239670),
(305820, 'PTHR44668:SF4', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE SDR FAMILY MEMBER 7C-A', 239670),
(305821, 'PTHR44668:SF3', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE SDR FAMILY MEMBER 7C-B', 239670),
(305822, 'PTHR45960:SF3', NULL, NULL, NULL, NULL, 'GRB2-ASSOCIATED-BINDING PROTEIN 3', 239671),
(305823, 'PTHR45960:SF4', NULL, NULL, NULL, NULL, 'GRB2-ASSOCIATED-BINDING PROTEIN 4', 239671),
(305824, 'PTHR45960:SF1', NULL, NULL, NULL, NULL, 'GRB2-ASSOCIATED-BINDING PROTEIN 2', 239671),
(305825, 'PTHR45960:SF2', NULL, NULL, NULL, NULL, 'PROTEIN DAUGHTER OF SEVENLESS', 239671),
(305826, 'PTHR45960', NULL, NULL, NULL, NULL, 'GRB2-ASSOCIATED-BINDING PROTEIN', 239671),
(305827, 'PTHR45960:SF5', NULL, NULL, NULL, NULL, 'GRB2-ASSOCIATED-BINDING PROTEIN 1', 239671),
(305828, 'PTHR43744:SF6', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN YESQ-RELATED', 239672),
(305829, 'PTHR43744', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN MG189-RELATED-RELATED', 239672),
(305830, 'PTHR43744:SF3', NULL, NULL, NULL, NULL, 'LACTOSE TRANSPORT SYSTEM PERMEASE PROTEIN LACG', 239672),
(305831, 'PTHR43744:SF4', NULL, NULL, NULL, NULL, 'OSMOPROTECTIVE COMPOUNDS UPTAKE PERMEASE PROTEIN GGTD', 239672),
(305832, 'PTHR43744:SF9', NULL, NULL, NULL, NULL, 'POLYGALACTURONAN/RHAMNOGALACTURONAN TRANSPORT SYSTEM PERMEASE PROTEIN YTCP', 239672),
(305833, 'PTHR43744:SF8', NULL, NULL, NULL, NULL, 'SN-GLYCEROL-3-PHOSPHATE TRANSPORT SYSTEM PERMEASE PROTEIN UGPE', 239672),
(305834, 'PTHR43744:SF1', NULL, NULL, NULL, NULL, 'BINDING-PROTEIN-DEPENDENT TRANSPORT SYSTEMS INNER MEMBRANE COMPONENT', 239672),
(305835, 'PTHR43744:SF15', NULL, NULL, NULL, NULL, 'MEMBRANE TRANSPORT PROTEIN-RELATED', 239672),
(305836, 'PTHR43744:SF2', NULL, NULL, NULL, NULL, 'ARABINOOLIGOSACCHARIDES TRANSPORT SYSTEM PERMEASE PROTEIN ARAQ', 239672),
(305837, 'PTHR43744:SF12', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN MG189-RELATED', 239672),
(305838, 'PTHR43744:SF13', NULL, NULL, NULL, NULL, 'SN-GLYCEROL-3-PHOSPHATE TRANSPORT INTEGRAL MEMBRANE PROTEIN ABC TRANSPORTER UGPE-RELATED', 239672),
(305839, 'PTHR38522:SF2', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE-ASSOCIATED CATION-BINDING PROTEIN 1', 239673),
(305840, 'PTHR38522:SF1', NULL, NULL, NULL, NULL, 'SALT STRESS ROOT PROTEIN RS1', 239673),
(305841, 'PTHR38522:SF4', NULL, NULL, NULL, NULL, 'BNAC09G18360D PROTEIN', 239673),
(305842, 'PTHR38522:SF3', NULL, NULL, NULL, NULL, 'BNAANNG10170D PROTEIN', 239673),
(305843, 'PTHR38522:SF6', NULL, NULL, NULL, NULL, 'BNAC02G47470D PROTEIN', 239673),
(305844, 'PTHR38522:SF5', NULL, NULL, NULL, NULL, 'DREPP FAMILY-RELATED', 239673),
(305845, 'PTHR38522', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE-ASSOCIATED CATION-BINDING PROTEIN 1', 239673),
(305846, 'PTHR34480:SF14', NULL, NULL, NULL, NULL, 'OS01G0967800 PROTEIN', 239674),
(305847, 'PTHR34480:SF13', NULL, NULL, NULL, NULL, '', 239674),
(305848, 'PTHR34480:SF12', NULL, NULL, NULL, NULL, 'OS01G0961600 PROTEIN', 239674),
(305849, 'PTHR34480', NULL, NULL, NULL, NULL, 'OS01G0967800 PROTEIN-RELATED', 239674),
(305850, 'PTHR34480:SF11', NULL, NULL, NULL, NULL, 'OS05G0173500 PROTEIN', 239674),
(305851, 'PTHR34480:SF10', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 239674),
(305852, 'PTHR35519', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEINS', 239675),
(305853, 'PTHR35519:SF2', NULL, NULL, NULL, NULL, 'BLL7046 PROTEIN', 239675),
(305854, 'PTHR35519:SF1', NULL, NULL, NULL, NULL, 'YALI0C06193P', 239675),
(305855, 'PTHR31447:SF5', NULL, NULL, NULL, NULL, 'OS06G0138200 PROTEIN', 239676),
(305856, 'PTHR31447:SF2', NULL, NULL, NULL, NULL, 'RNA DEMETHYLASE ALKBH10B', 239676),
(305857, 'PTHR31447:SF8', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE, 2OG-FE(II) OXYGENASE FAMILY PROTEIN', 239676),
(305858, 'PTHR31447:SF7', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 239676);
INSERT INTO "PUBLIC"."MODEL" VALUES
(305859, 'PTHR31447:SF22', NULL, NULL, NULL, NULL, '2OG-FE(II) OXYGENASE FAMILY OXIDOREDUCTASE', 239676),
(305860, 'PTHR31447:SF11', NULL, NULL, NULL, NULL, 'BNAC05G10890D PROTEIN', 239676),
(305861, 'PTHR31447:SF21', NULL, NULL, NULL, NULL, 'BNAA08G31420D PROTEIN', 239676),
(305862, 'PTHR31447', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN-RELATED', 239676),
(305863, 'PTHR31447:SF20', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 239676),
(305864, 'PTHR31447:SF16', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE, 2OG-FE(II) OXYGENASE FAMILY PROTEIN-RELATED', 239676),
(305865, 'PTHR31447:SF19', NULL, NULL, NULL, NULL, 'RNA DEMETHYLASE ALKBH5-LIKE', 239676),
(305866, 'PTHR31447:SF18', NULL, NULL, NULL, NULL, 'RNA DEMETHYLASE ALKBH9B', 239676),
(305867, 'PTHR31447:SF1', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 239676),
(305868, 'PTHR31447:SF0', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 239676),
(305869, 'PTHR37816', NULL, NULL, NULL, NULL, 'YALI0E33011P', 239677),
(305870, 'PTHR37816:SF2', NULL, NULL, NULL, NULL, 'DNA TOPOLOGY MODULATION PROTEIN FLAR-RELATED PROTEIN', 239677),
(305871, 'PTHR37816:SF3', NULL, NULL, NULL, NULL, 'MODULATES DNA TOPOLOGY', 239677),
(305872, 'PTHR37816:SF1', NULL, NULL, NULL, NULL, 'DNA TOPOLOGY MODULATION PROTEIN FLAR-RELATED PROTEIN', 239677),
(305873, 'PTHR47643:SF2', NULL, NULL, NULL, NULL, 'TPR DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_5G12710)', 239678),
(305874, 'PTHR47643', NULL, NULL, NULL, NULL, 'TPR DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_5G12710)', 239678),
(305875, 'PTHR46095:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 593', 239679),
(305876, 'PTHR46095', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 593', 239679),
(305877, 'PTHR47847', NULL, NULL, NULL, NULL, 'FCS-LIKE ZINC FINGER 17', 239680),
(305878, 'PTHR47847:SF4', NULL, NULL, NULL, NULL, 'FLZ-TYPE DOMAIN-CONTAINING PROTEIN', 239680),
(305879, 'PTHR47847:SF3', NULL, NULL, NULL, NULL, 'FLZ-TYPE DOMAIN-CONTAINING PROTEIN', 239680),
(305880, 'PTHR47847:SF2', NULL, NULL, NULL, NULL, 'FCS-LIKE ZINC FINGER 17', 239680),
(305881, 'PTHR47058:SF3', NULL, NULL, NULL, NULL, 'REPLICATION PROTEIN A 14 KDA SUBUNIT A-RELATED', 239681),
(305882, 'PTHR47058:SF4', NULL, NULL, NULL, NULL, 'NUCLEIC ACID-BINDING, OB-FOLD', 239681),
(305883, 'PTHR47058:SF5', NULL, NULL, NULL, NULL, '', 239681),
(305884, 'PTHR47058', NULL, NULL, NULL, NULL, 'REPLICATION PROTEIN A 14 KDA SUBUNIT A-RELATED', 239681),
(305885, 'PTHR47058:SF1', NULL, NULL, NULL, NULL, 'NUCLEIC ACID-BINDING, OB-FOLD-LIKE PROTEIN', 239681),
(305886, 'PTHR35462', NULL, NULL, NULL, NULL, '', 239682),
(305887, 'PTHR35462:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 239682),
(305888, 'PTHR40624', NULL, NULL, NULL, NULL, 'BIOSYNTHESIS MONOOXYGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G12025)-RELATED', 239683),
(305889, 'PTHR40624:SF1', NULL, NULL, NULL, NULL, 'BIOSYNTHESIS MONOOXYGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G12025)-RELATED', 239683),
(305890, 'PTHR30341', NULL, NULL, NULL, NULL, 'SODIUM ION/PROTON ANTIPORTER NHAA-RELATED', 239684),
(305891, 'PTHR30341:SF0', NULL, NULL, NULL, NULL, 'NA(+)/H(+) ANTIPORTER NHAA', 239684),
(305892, 'PTHR28576:SF2', NULL, NULL, NULL, NULL, 'PIGGYBAC TRANSPOSABLE ELEMENT-DERIVED PROTEIN 5', 239685),
(305893, 'PTHR28576', NULL, NULL, NULL, NULL, 'PIGGYBAC TRANSPOSABLE ELEMENT-DERIVED PROTEIN 5', 239685),
(305894, 'PTHR30040:SF2', NULL, NULL, NULL, NULL, 'FAD:PROTEIN FMN TRANSFERASE', 239686),
(305895, 'PTHR30040', NULL, NULL, NULL, NULL, 'THIAMINE BIOSYNTHESIS LIPOPROTEIN APBE', 239686),
(305896, 'PTHR45626:SF3', NULL, NULL, NULL, NULL, 'OS04G0629300 PROTEIN', 239687),
(305897, 'PTHR45626:SF4', NULL, NULL, NULL, NULL, 'FAMILY HELICASE, PUTATIVE-RELATED', 239687),
(305898, 'PTHR45626:SF17', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR 2', 239687),
(305899, 'PTHR45626:SF16', NULL, NULL, NULL, NULL, 'SNF2 DOMAIN-CONTAINING PROTEIN / HELICASE DOMAIN-CONTAINING PROTEIN / ZINC FINGER PROTEIN-LIKE PROTEIN', 239687);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(305900, 'PTHR45626:SF38', NULL, NULL, NULL, NULL, 'DEAD-BOX PROTEIN', 239687),
(305901, 'PTHR45626:SF37', NULL, NULL, NULL, NULL, 'BNAC07G15760D PROTEIN', 239687),
(305902, 'PTHR45626:SF14', NULL, NULL, NULL, NULL, 'SNF2-RELATED DOMAIN-CONTAINING PROTEIN', 239687),
(305903, 'PTHR45626:SF36', NULL, NULL, NULL, NULL, 'PROTEIN CBG13225', 239687),
(305904, 'PTHR45626:SF12', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RAD16', 239687),
(305905, 'PTHR45626:SF34', NULL, NULL, NULL, NULL, 'HELICASE-LIKE TRANSCRIPTION FACTOR CHR27', 239687),
(305906, 'PTHR45626:SF33', NULL, NULL, NULL, NULL, '', 239687),
(305907, 'PTHR45626:SF11', NULL, NULL, NULL, NULL, 'FAMILY HELICASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G06590)-RELATED', 239687),
(305908, 'PTHR45626', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR 2-RELATED', 239687),
(305909, 'PTHR45626:SF29', NULL, NULL, NULL, NULL, 'BNAA10G03160D PROTEIN', 239687),
(305910, 'PTHR45626:SF28', NULL, NULL, NULL, NULL, 'BNAA08G28190D PROTEIN', 239687),
(305911, 'PTHR45626:SF49', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 239687),
(305912, 'PTHR45626:SF27', NULL, NULL, NULL, NULL, 'BNAA09G48020D PROTEIN', 239687),
(305913, 'PTHR45626:SF26', NULL, NULL, NULL, NULL, 'FAMILY HELICASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G09120)-RELATED', 239687),
(305914, 'PTHR45626:SF48', NULL, NULL, NULL, NULL, 'BNAC03G41330D PROTEIN', 239687),
(305915, 'PTHR45626:SF47', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT HELICASE ULS1', 239687),
(305916, 'PTHR45626:SF46', NULL, NULL, NULL, NULL, 'HELICASE ATP-BINDING DOMAIN-CONTAINING PROTEIN', 239687),
(305917, 'PTHR45626:SF24', NULL, NULL, NULL, NULL, 'HELICASE-LIKE TRANSCRIPTION FACTOR CHR28-RELATED', 239687),
(305918, 'PTHR45626:SF45', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RAD5A', 239687),
(305919, 'PTHR45626:SF22', NULL, NULL, NULL, NULL, 'HELICASE-LIKE TRANSCRIPTION FACTOR', 239687),
(305920, 'PTHR45626:SF20', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT HELICASE RHP16-LIKE', 239687),
(305921, 'PTHR45626:SF30', NULL, NULL, NULL, NULL, 'HELICASE ATP-BINDING DOMAIN-CONTAINING PROTEIN', 239687),
(305922, 'PTHR22742:SF2', NULL, NULL, NULL, NULL, 'EXPANSION, ISOFORM A-RELATED', 239688),
(305923, 'PTHR22742', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239688),
(305924, 'PTHR10067:SF19', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLSERINE DECARBOXYLASE PROENZYME 2, MITOCHONDRIAL', 239689),
(305925, 'PTHR10067:SF18', NULL, NULL, NULL, NULL, 'BNACNNG14450D PROTEIN', 239689),
(305926, 'PTHR10067:SF6', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLSERINE DECARBOXYLASE PROENZYME, MITOCHONDRIAL', 239689),
(305927, 'PTHR10067:SF7', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLSERINE DECARBOXYLASE', 239689),
(305928, 'PTHR10067:SF13', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLSERINE DECARBOXYLASE', 239689),
(305929, 'PTHR10067', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLSERINE DECARBOXYLASE', 239689),
(305930, 'PTHR10067:SF9', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLSERINE DECARBOXYLASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_7G01730)', 239689),
(305931, 'PTHR10067:SF11', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLSERINE DECARBOXYLASE', 239689),
(305932, 'PTHR10067:SF17', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLSERINE DECARBOXYLASE PROENZYME 2', 239689),
(305933, 'PTHR10067:SF16', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLSERINE DECARBOXYLASE PROENZYME 2', 239689),
(305934, 'PTHR43673:SF10', NULL, NULL, NULL, NULL, 'PROTEIN DRGA', 239690),
(305935, 'PTHR43673:SF2', NULL, NULL, NULL, NULL, 'NITROREDUCTASE FAMILY PROTEIN', 239690),
(305936, 'PTHR43673:SF3', NULL, NULL, NULL, NULL, 'NAD(P)H NITROREDUCTASE YODC-RELATED', 239690),
(305937, 'PTHR43673:SF8', NULL, NULL, NULL, NULL, 'NAD(P)H NITROREDUCTASE MHQN-RELATED', 239690),
(305938, 'PTHR43673', NULL, NULL, NULL, NULL, 'NAD(P)H NITROREDUCTASE YDGI-RELATED', 239690),
(305939, 'PTHR43673:SF11', NULL, NULL, NULL, NULL, 'NITROREDUCTASE', 239690),
(305940, 'PTHR14742:SF3', NULL, NULL, NULL, NULL, 'RIBONUCLEASE MRP PROTEIN SUBUNIT SNM1', 239691),
(305941, 'PTHR14742:SF4', NULL, NULL, NULL, NULL, 'DDE TNP4 DOMAIN-CONTAINING PROTEIN', 239691),
(305942, 'PTHR14742', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P SUBUNIT P21', 239691); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(305943, 'PTHR14742:SF0', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P PROTEIN SUBUNIT P21', 239691),
(305944, 'PTHR35551', NULL, NULL, NULL, NULL, '', 239692),
(305945, 'PTHR35551:SF1', NULL, NULL, NULL, NULL, 'ACCLIMATION OF PHOTOSYNTHESIS TO ENVIRONMENT', 239692),
(305946, 'PTHR36566:SF1', NULL, NULL, NULL, NULL, 'PYRIDINIUM-3,5-BISTHIOCARBOXYLIC ACID MONONUCLEOTIDE NICKEL INSERTION PROTEIN', 239693),
(305947, 'PTHR36566', NULL, NULL, NULL, NULL, 'NICKEL INSERTION PROTEIN-RELATED', 239693),
(305948, 'PTHR13023:SF3', NULL, NULL, NULL, NULL, 'SOLUBLE CALCIUM-ACTIVATED NUCLEOTIDASE 1', 239694),
(305949, 'PTHR13023:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG14198', 239694),
(305950, 'PTHR13023', NULL, NULL, NULL, NULL, 'APYRASE', 239694),
(305951, 'PTHR27003:SF296', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(305952, 'PTHR27003:SF450', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(305953, 'PTHR27003:SF330', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(305954, 'PTHR27003:SF451', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(305955, 'PTHR27003:SF452', NULL, NULL, NULL, NULL, 'MALECTIN/RECEPTOR-LIKE KINASE FAMILY PROTEIN', 239695),
(305956, 'PTHR27003:SF331', NULL, NULL, NULL, NULL, 'SERINE/THREONINE/DUAL SPECIFICITY PROTEIN KINASE, CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 239695),
(305957, 'PTHR27003:SF453', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(305958, 'PTHR27003:SF454', NULL, NULL, NULL, NULL, 'OS04G0619600 PROTEIN', 239695),
(305959, 'PTHR27003:SF455', NULL, NULL, NULL, NULL, 'SERINE-THREONINE/TYROSINE-PROTEIN KINASE CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 239695),
(305960, 'PTHR27003:SF335', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE, NON-RECEPTOR SYK/ZAP-70-RELATED', 239695),
(305961, 'PTHR27003:SF456', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE FERONIA', 239695),
(305962, 'PTHR27003:SF457', NULL, NULL, NULL, NULL, 'MALECTIN/RECEPTOR-LIKE KINASE FAMILY PROTEIN', 239695),
(305963, 'PTHR27003:SF458', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN (MAP) KINASE, ERK3/4-RELATED', 239695),
(305964, 'PTHR27003:SF338', NULL, NULL, NULL, NULL, 'VASCULAR ENDOTHELIAL GROWTH FACTOR RECEPTOR 2 (VEGFR2)-RELATED', 239695),
(305965, 'PTHR27003:SF459', NULL, NULL, NULL, NULL, 'IQ MOTIF, EF-HAND BINDING SITE, PROTEIN KINASE-LIKE DOMAIN PROTEIN-RELATED', 239695),
(305966, 'PTHR27003:SF339', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(305967, 'PTHR27003:SF83', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(305968, 'PTHR27003:SF89', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE FAMILY PROTEIN-RELATED', 239695),
(305969, 'PTHR27003:SF88', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE THESEUS 1', 239695),
(305970, 'PTHR27003:SF283', NULL, NULL, NULL, NULL, 'LESCPTH2', 239695),
(305971, 'PTHR27003:SF440', NULL, NULL, NULL, NULL, 'GPCR KINASE, MITOGEN-ACTIVATED PROTEIN (MAP) KINASE KINASE KINASE 7-RELATED', 239695),
(305972, 'PTHR27003:SF287', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(305973, 'PTHR27003:SF441', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE ANXUR1', 239695),
(305974, 'PTHR27003:SF442', NULL, NULL, NULL, NULL, 'PK_TYR_SER-THR DOMAIN-CONTAINING PROTEIN', 239695),
(305975, 'PTHR27003:SF443', NULL, NULL, NULL, NULL, 'SERINE-THREONINE/TYROSINE-PROTEIN KINASE CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 239695),
(305976, 'PTHR27003:SF289', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE ANXUR2', 239695),
(305977, 'PTHR27003:SF323', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(305978, 'PTHR27003:SF444', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(305979, 'PTHR27003:SF445', NULL, NULL, NULL, NULL, 'OS05G0317900 PROTEIN', 239695),
(305980, 'PTHR27003:SF446', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(305981, 'PTHR27003:SF325', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(305982, 'PTHR27003:SF326', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE, NON-RECEPTOR SYK/ZAP-70-RELATED', 239695),
(305983, 'PTHR27003:SF447', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(305984, 'PTHR27003:SF448', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE, ULK1/ULK2-RELATED', 239695),
(305985, 'PTHR27003:SF328', NULL, NULL, NULL, NULL, 'SERINE-THREONINE/TYROSINE-PROTEIN KINASE CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 239695),
(305986, 'PTHR27003:SF449', NULL, NULL, NULL, NULL, 'OS05G0280700 PROTEIN', 239695),
(305987, 'PTHR27003:SF97', NULL, NULL, NULL, NULL, 'OS01G0253000 PROTEIN', 239695),
(305988, 'PTHR27003:SF293', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(305989, 'PTHR27003:SF69', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(305990, 'PTHR27003:SF352', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE ANXUR1', 239695),
(305991, 'PTHR27003:SF354', NULL, NULL, NULL, NULL, '', 239695),
(305992, 'PTHR27003:SF355', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(305993, 'PTHR27003:SF357', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(305994, 'PTHR27003:SF358', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN (MAP) KINASE KINASE KINASE, MLK1/MLK2/MLK4-RELATED', 239695),
(305995, 'PTHR27003:SF359', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN (MAP) KINASE KINASE KINASE, MLK1/MLK2/MLK4-RELATED', 239695),
(305996, 'PTHR27003', NULL, NULL, NULL, NULL, 'OS07G0166700 PROTEIN', 239695),
(305997, 'PTHR27003:SF65', NULL, NULL, NULL, NULL, 'OS03G0281500 PROTEIN', 239695),
(305998, 'PTHR27003:SF460', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE FERONIA', 239695),
(305999, 'PTHR27003:SF461', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE FERONIA', 239695),
(306000, 'PTHR27003:SF462', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE FERONIA', 239695),
(306001, 'PTHR27003:SF342', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE, NON-RECEPTOR SYK/ZAP-70-RELATED', 239695),
(306002, 'PTHR27003:SF463', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE', 239695),
(306003, 'PTHR27003:SF464', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(306004, 'PTHR27003:SF465', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE ANXUR1-RELATED', 239695),
(306005, 'PTHR27003:SF344', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(306006, 'PTHR27003:SF466', NULL, NULL, NULL, NULL, 'CONCANAVALIN A-LIKE LECTIN/GLUCANASE DOMAIN-CONTAINING PROTEIN-RELATED', 239695),
(306007, 'PTHR27003:SF467', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(306008, 'PTHR27003:SF468', NULL, NULL, NULL, NULL, 'OS07G0166700 PROTEIN', 239695),
(306009, 'PTHR27003:SF106', NULL, NULL, NULL, NULL, 'OS06G0126250 PROTEIN', 239695),
(306010, 'PTHR27003:SF78', NULL, NULL, NULL, NULL, 'OS05G0318700 PROTEIN', 239695),
(306011, 'PTHR27003:SF371', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(306012, 'PTHR27003:SF374', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(306013, 'PTHR27003:SF375', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE HERK 1', 239695),
(306014, 'PTHR27003:SF377', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(306015, 'PTHR27003:SF378', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE FERONIA', 239695),
(306016, 'PTHR27003:SF413', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(306017, 'PTHR27003:SF417', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(306018, 'PTHR27003:SF380', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN (MAP) KINASE KINASE KINASE STE11, CRYPTOCOCCUS-RELATED', 239695),
(306019, 'PTHR27003:SF381', NULL, NULL, NULL, NULL, 'BNAA09G46530D PROTEIN', 239695); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(306020, 'PTHR27003:SF43', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING RECEPTOR-LIKE CYTOPLASMIC KINASE 3', 239695),
(306021, 'PTHR27003:SF361', NULL, NULL, NULL, NULL, 'SERINE-THREONINE/TYROSINE-PROTEIN KINASE CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 239695),
(306022, 'PTHR27003:SF59', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(306023, 'PTHR27003:SF363', NULL, NULL, NULL, NULL, 'EPHRIN TYPE-A RECEPTOR 8-RELATED', 239695),
(306024, 'PTHR27003:SF366', NULL, NULL, NULL, NULL, 'MALECTIN/RECEPTOR-LIKE KINASE FAMILY PROTEIN', 239695),
(306025, 'PTHR27003:SF400', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING RECEPTOR-LIKE CYTOPLASMIC KINASE 3', 239695),
(306026, 'PTHR27003:SF368', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(306027, 'PTHR27003:SF401', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(306028, 'PTHR27003:SF369', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(306029, 'PTHR27003:SF405', NULL, NULL, NULL, NULL, 'FERONIA RECEPTOR-LIKE KINASE', 239695),
(306030, 'PTHR27003:SF408', NULL, NULL, NULL, NULL, 'SERINE-THREONINE/TYROSINE-PROTEIN KINASE CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 239695),
(306031, 'PTHR27003:SF370', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(306032, 'PTHR27003:SF393', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE THESEUS 1', 239695),
(306033, 'PTHR27003:SF395', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE FERONIA', 239695),
(306034, 'PTHR27003:SF276', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(306035, 'PTHR27003:SF397', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE THESEUS 1', 239695),
(306036, 'PTHR27003:SF277', NULL, NULL, NULL, NULL, 'MALECTIN/RECEPTOR-LIKE KINASE FAMILY PROTEIN', 239695),
(306037, 'PTHR27003:SF398', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(306038, 'PTHR27003:SF310', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE FERONIA', 239695),
(306039, 'PTHR27003:SF311', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING RECEPTOR-LIKE CYTOPLASMIC KINASE 2', 239695),
(306040, 'PTHR27003:SF278', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE FERONIA ISOFORM X1', 239695),
(306041, 'PTHR27003:SF312', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE FERONIA', 239695),
(306042, 'PTHR27003:SF433', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(306043, 'PTHR27003:SF313', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE', 239695),
(306044, 'PTHR27003:SF434', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(306045, 'PTHR27003:SF435', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(306046, 'PTHR27003:SF436', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING RECEPTOR-LIKE CYTOPLASMIC KINASE 3-RELATED', 239695),
(306047, 'PTHR27003:SF437', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(306048, 'PTHR27003:SF316', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE ANXUR1', 239695),
(306049, 'PTHR27003:SF317', NULL, NULL, NULL, NULL, 'FERONIA RECEPTOR-LIKE KINASE', 239695),
(306050, 'PTHR27003:SF438', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(306051, 'PTHR27003:SF318', NULL, NULL, NULL, NULL, 'OS03G0124200 PROTEIN', 239695),
(306052, 'PTHR27003:SF439', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE FERONIA', 239695),
(306053, 'PTHR27003:SF319', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(306054, 'PTHR27003:SF261', NULL, NULL, NULL, NULL, 'OS07G0147600 PROTEIN', 239695),
(306055, 'PTHR27003:SF383', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE, NON-RECEPTOR SYK/ZAP-70-RELATED', 239695),
(306056, 'PTHR27003:SF384', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(306057, 'PTHR27003:SF266', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE', 239695),
(306058, 'PTHR27003:SF387', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(306059, 'PTHR27003:SF267', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(306060, 'PTHR27003:SF423', NULL, NULL, NULL, NULL, 'PTO-LIKE SERINE/THREONINE KINASE', 239695),
(306061, 'PTHR27003:SF269', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE ANXUR2', 239695),
(306062, 'PTHR27003:SF303', NULL, NULL, NULL, NULL, 'TYROSINE KINASE FAMILY PROTEIN', 239695),
(306063, 'PTHR27003:SF426', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE HERK 1', 239695),
(306064, 'PTHR27003:SF307', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE FERONIA', 239695),
(306065, 'PTHR27003:SF390', NULL, NULL, NULL, NULL, 'SERINE-THREONINE/TYROSINE-PROTEIN KINASE CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 239695),
(306066, 'PTHR27003:SF391', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239695),
(306067, 'PTHR27003:SF392', NULL, NULL, NULL, NULL, 'JACALIN-LIKE LECTIN DOMAIN-CONTAINING PROTEIN-RELATED', 239695),
(306068, 'PTHR13696:SF96', NULL, NULL, NULL, NULL, 'CBIA DOMAIN-CONTAINING PROTEIN', 239696),
(306069, 'PTHR13696:SF52', NULL, NULL, NULL, NULL, 'PARA FAMILY PROTEIN CT_582', 239696),
(306070, 'PTHR13696:SF90', NULL, NULL, NULL, NULL, 'POSSIBLE SOJ/PARA-RELATED PROTEIN', 239696),
(306071, 'PTHR13696:SF69', NULL, NULL, NULL, NULL, 'PLASMID PARTITIONING PROTEIN-RELATED', 239696),
(306072, 'PTHR13696:SF97', NULL, NULL, NULL, NULL, 'CHROMOSOME PARTITIONING PROTEIN, PARA FAMILY', 239696),
(306073, 'PTHR13696', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE', 239696),
(306074, 'PTHR47066:SF1', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 9', 239697),
(306075, 'PTHR47066:SF2', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 239697),
(306076, 'PTHR47066', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 9', 239697),
(306077, 'PTHR13628', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239698),
(306078, 'PTHR13628:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 267', 239698),
(306079, 'PTHR16434:SF2', NULL, NULL, NULL, NULL, 'EWING''S TUMOR-ASSOCIATED ANTIGEN 1', 239699),
(306080, 'PTHR16434:SF4', NULL, NULL, NULL, NULL, 'ETAA1 ACTIVATOR OF ATR KINASE', 239699),
(306081, 'PTHR16434:SF3', NULL, NULL, NULL, NULL, 'SI:DKEY-78P8.1', 239699),
(306082, 'PTHR16434', NULL, NULL, NULL, NULL, 'EWING''S TUMOR-ASSOCIATED ANTIGEN 1 ETAA1', 239699),
(306083, 'PTHR37014:SF10', NULL, NULL, NULL, NULL, 'RICH PROTEIN MS8, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G05650)-RELATED', 239700),
(306084, 'PTHR37014:SF8', NULL, NULL, NULL, NULL, 'RICH PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G04870)-RELATED', 239700),
(306085, 'PTHR37014:SF9', NULL, NULL, NULL, NULL, 'CONSERVED HISTIDINE-RICH PROTEIN (AFU_ORTHOLOGUE AFUA_1G11910)', 239700),
(306086, 'PTHR37014', NULL, NULL, NULL, NULL, 'EXPRESSION LETHALITY PROTEIN HEL10, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G06580)-RELATED', 239700),
(306087, 'PTHR37014:SF1', NULL, NULL, NULL, NULL, 'EXPRESSION LETHALITY PROTEIN HEL10, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G06580)-RELATED', 239700),
(306088, 'PTHR43884:SF31', NULL, NULL, NULL, NULL, 'ACYL-COA DEHYDROGENASE/OXIDASE-RELATED', 239701),
(306089, 'PTHR43884:SF20', NULL, NULL, NULL, NULL, 'ACYL-COA DEHYDROGENASE FADE28', 239701),
(306090, 'PTHR43884:SF22', NULL, NULL, NULL, NULL, 'BLR3437 PROTEIN', 239701),
(306091, 'PTHR43884:SF11', NULL, NULL, NULL, NULL, 'VERY LONG-CHAIN SPECIFIC ACYL-COA DEHYDROGENASE, MITOCHONDRIAL', 239701),
(306092, 'PTHR43884:SF12', NULL, NULL, NULL, NULL, 'ISOVALERYL-COA DEHYDROGENASE, MITOCHONDRIAL-RELATED', 239701),
(306093, 'PTHR43884:SF34', NULL, NULL, NULL, NULL, 'BLR2947 PROTEIN', 239701),
(306094, 'PTHR43884:SF39', NULL, NULL, NULL, NULL, 'BLL5737 PROTEIN', 239701),
(306095, 'PTHR43884:SF17', NULL, NULL, NULL, NULL, 'ACYL COA DEHYDROGENASE', 239701),
(306096, 'PTHR43884:SF18', NULL, NULL, NULL, NULL, 'ISOVALERYL-COENZYME A DEHYDROGENASE', 239701),
(306097, 'PTHR43884:SF19', NULL, NULL, NULL, NULL, 'ACYL-COA DEHYDROGENASE FADE4-RELATED', 239701),
(306098, 'PTHR43884:SF35', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, MITOCHONDRIAL, PUTATIVE-RELATED', 239701);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(306099, 'PTHR43884:SF6', NULL, NULL, NULL, NULL, 'ACYL COA DEHYDROGENASE', 239701),
(306100, 'PTHR43884:SF25', NULL, NULL, NULL, NULL, 'ACYL-COA DEHYDROGENASE YDBM-RELATED', 239701),
(306101, 'PTHR43884:SF26', NULL, NULL, NULL, NULL, 'MEDIUM-CHAIN SPECIFIC ACYL-COA DEHYDROGENASE, MITOCHONDRIAL-LIKE PROTEIN-RELATED', 239701),
(306102, 'PTHR43884:SF37', NULL, NULL, NULL, NULL, 'ACYL-COA DEHYDROGENASE', 239701),
(306103, 'PTHR43884:SF9', NULL, NULL, NULL, NULL, 'COMPLEX I ASSEMBLY FACTOR ACAD9, MITOCHONDRIAL', 239701),
(306104, 'PTHR43884:SF27', NULL, NULL, NULL, NULL, '2-METHYLACYL-COA DEHYDROGENASE, MITOCHONDRIAL', 239701),
(306105, 'PTHR43884:SF38', NULL, NULL, NULL, NULL, 'ACYL-COA DEHYDROGENASE-RELATED', 239701),
(306106, 'PTHR43884', NULL, NULL, NULL, NULL, 'ACYL-COA DEHYDROGENASE', 239701),
(306107, 'PTHR43884:SF5', NULL, NULL, NULL, NULL, 'ACYL COA DEHYDROGENASE', 239701),
(306108, 'PTHR43884:SF1', NULL, NULL, NULL, NULL, 'SHORT/BRANCHED CHAIN SPECIFIC ACYL-COA DEHYDROGENASE, MITOCHONDRIAL', 239701),
(306109, 'PTHR10286:SF18', NULL, NULL, NULL, NULL, 'INORGANIC DIPHOSPHATASE', 239702),
(306110, 'PTHR10286:SF58', NULL, NULL, NULL, NULL, 'SOLUBLE INORGANIC PYROPHOSPHATASE 5', 239702),
(306111, 'PTHR10286:SF57', NULL, NULL, NULL, NULL, 'INORGANIC DIPHOSPHATASE', 239702),
(306112, 'PTHR10286:SF79', NULL, NULL, NULL, NULL, 'INORGANIC PYROPHOSPHATASE C3A12.02-RELATED', 239702),
(306113, 'PTHR10286:SF38', NULL, NULL, NULL, NULL, 'INORGANIC DIPHOSPHATASE', 239702),
(306114, 'PTHR10286:SF59', NULL, NULL, NULL, NULL, 'SOLUBLE INORGANIC PYROPHOSPHATASE 4', 239702),
(306115, 'PTHR10286:SF53', NULL, NULL, NULL, NULL, 'INORGANIC DIPHOSPHATASE', 239702),
(306116, 'PTHR10286:SF78', NULL, NULL, NULL, NULL, 'INORGANIC DIPHOSPHATASE', 239702),
(306117, 'PTHR10286:SF77', NULL, NULL, NULL, NULL, 'INORGANIC DIPHOSPHATASE', 239702),
(306118, 'PTHR10286:SF50', NULL, NULL, NULL, NULL, 'INORGANIC DIPHOSPHATASE', 239702),
(306119, 'PTHR10286:SF72', NULL, NULL, NULL, NULL, 'SOLUBLE INORGANIC PYROPHOSPHATASE 1', 239702),
(306120, 'PTHR10286:SF71', NULL, NULL, NULL, NULL, 'INORGANIC DIPHOSPHATASE', 239702),
(306121, 'PTHR10286:SF73', NULL, NULL, NULL, NULL, 'INORGANIC DIPHOSPHATASE', 239702),
(306122, 'PTHR10286:SF51', NULL, NULL, NULL, NULL, 'INORGANIC DIPHOSPHATASE', 239702),
(306123, 'PTHR10286', NULL, NULL, NULL, NULL, 'INORGANIC PYROPHOSPHATASE', 239702),
(306124, 'PTHR10286:SF0', NULL, NULL, NULL, NULL, 'SOLUBLE INORGANIC PYROPHOSPHATASE 2', 239702),
(306125, 'PTHR10286:SF3', NULL, NULL, NULL, NULL, 'INORGANIC PYROPHOSPHATASE', 239702),
(306126, 'PTHR10286:SF2', NULL, NULL, NULL, NULL, 'INORGANIC PYROPHOSPHATASE, MITOCHONDRIAL', 239702),
(306127, 'PTHR10286:SF69', NULL, NULL, NULL, NULL, 'SOLUBLE INORGANIC PYROPHOSPHATASE PPA1', 239702),
(306128, 'PTHR10286:SF47', NULL, NULL, NULL, NULL, 'INORGANIC PYROPHOSPHATASE', 239702),
(306129, 'PTHR10286:SF68', NULL, NULL, NULL, NULL, 'INORGANIC DIPHOSPHATASE', 239702),
(306130, 'PTHR10286:SF49', NULL, NULL, NULL, NULL, 'INORGANIC PYROPHOSPHATASE 2, MITOCHONDRIAL', 239702),
(306131, 'PTHR10286:SF43', NULL, NULL, NULL, NULL, 'INORGANIC DIPHOSPHATASE', 239702),
(306132, 'PTHR10286:SF65', NULL, NULL, NULL, NULL, 'SOLUBLE INORGANIC PYROPHOSPHATASE 3', 239702),
(306133, 'PTHR10286:SF67', NULL, NULL, NULL, NULL, 'INORGANIC DIPHOSPHATASE', 239702),
(306134, 'PTHR10286:SF66', NULL, NULL, NULL, NULL, 'INORGANIC DIPHOSPHATASE', 239702),
(306135, 'PTHR10286:SF83', NULL, NULL, NULL, NULL, 'INORGANIC DIPHOSPHATASE', 239702),
(306136, 'PTHR10286:SF82', NULL, NULL, NULL, NULL, 'INORGANIC DIPHOSPHATASE', 239702),
(306137, 'PTHR10286:SF63', NULL, NULL, NULL, NULL, 'INORGANIC DIPHOSPHATASE', 239702),
(306138, 'PTHR10286:SF81', NULL, NULL, NULL, NULL, 'INORGANIC DIPHOSPHATASE', 239702),
(306139, 'PTHR10286:SF80', NULL, NULL, NULL, NULL, 'SOLUBLE INORGANIC PYROPHOSPHATASE', 239702),
(306140, 'PTHR35172', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 239703),
(306141, 'PTHR35172:SF1', NULL, NULL, NULL, NULL, 'INVOLUCRIN', 239703),
(306142, 'PTHR44917', NULL, NULL, NULL, NULL, 'PROTEIN HIGH CHLOROPHYLL FLUORESCENT 107', 239704);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(306143, 'PTHR44917:SF1', NULL, NULL, NULL, NULL, 'PROTEIN HIGH CHLOROPHYLL FLUORESCENT 107', 239704),
(306144, 'PTHR30086:SF15', NULL, NULL, NULL, NULL, 'LEUCINE EFFLUX PROTEIN', 239705),
(306145, 'PTHR30086:SF16', NULL, NULL, NULL, NULL, 'LYSE TYPE TRANSLOCATOR-RELATED', 239705),
(306146, 'PTHR30086:SF6', NULL, NULL, NULL, NULL, 'AMINO ACID EFFLUX PROTEIN YCGF-RELATED', 239705),
(306147, 'PTHR30086:SF14', NULL, NULL, NULL, NULL, 'HOMOSERINE/HOMOSERINE LACTONE EFFLUX PROTEIN', 239705),
(306148, 'PTHR30086:SF22', NULL, NULL, NULL, NULL, 'ARGININE EXPORTER PROTEIN ARGO', 239705),
(306149, 'PTHR30086:SF23', NULL, NULL, NULL, NULL, 'CYSTEINE/O-ACETYLSERINE EFFLUX PROTEIN', 239705),
(306150, 'PTHR30086:SF5', NULL, NULL, NULL, NULL, 'HOMOGENTISATE EXPORT PROTEIN', 239705),
(306151, 'PTHR30086:SF20', NULL, NULL, NULL, NULL, 'CHEMOTACTIC TRANSDUCTION PROTEIN CHPE', 239705),
(306152, 'PTHR30086:SF21', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN-RELATED', 239705),
(306153, 'PTHR30086', NULL, NULL, NULL, NULL, 'ARGININE EXPORTER PROTEIN ARGO', 239705),
(306154, 'PTHR30086:SF19', NULL, NULL, NULL, NULL, 'THREONINE EFFLUX PROTEIN', 239705),
(306155, 'PTHR30086:SF17', NULL, NULL, NULL, NULL, 'AMINO ACID EFFLUX PERMEASE RHTB FAMILY-RELATED', 239705),
(306156, 'PTHR17616:SF11', NULL, NULL, NULL, NULL, 'WW DOMAIN-CONTAINING OXIDOREDUCTASE', 239706),
(306157, 'PTHR17616:SF6', NULL, NULL, NULL, NULL, 'WW DOMAIN-CONTAINING TRANSCRIPTION REGULATOR PROTEIN 1', 239706),
(306158, 'PTHR17616:SF9', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL COACTIVATOR YAP1', 239706),
(306159, 'PTHR17616:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL COACTIVATOR YORKIE', 239706),
(306160, 'PTHR17616', NULL, NULL, NULL, NULL, 'YES-ASSOCIATED PROTEIN YAP1 FAMILY MEMBER', 239706),
(306161, 'PTHR38674:SF1', NULL, NULL, NULL, NULL, 'ALKANE 1-MONOOXYGENASE 1', 239707),
(306162, 'PTHR38674', NULL, NULL, NULL, NULL, 'ALKANE 1-MONOOXYGENASE 1', 239707),
(306163, 'PTHR12854:SF22', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN-INTERACTING PROTEIN 4-LIKE', 239708),
(306164, 'PTHR12854:SF11', NULL, NULL, NULL, NULL, 'ATAXIN-2', 239708),
(306165, 'PTHR12854:SF21', NULL, NULL, NULL, NULL, 'LSMAD DOMAIN, ATAXIN 2, SM DOMAIN PROTEIN-RELATED', 239708),
(306166, 'PTHR12854', NULL, NULL, NULL, NULL, 'ATAXIN 2-RELATED', 239708),
(306167, 'PTHR12854:SF12', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN INTERACTING PROTEIN', 239708),
(306168, 'PTHR12854:SF15', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN-INTERACTING PROTEIN 4', 239708),
(306169, 'PTHR12854:SF17', NULL, NULL, NULL, NULL, 'LSMAD DOMAIN-CONTAINING PROTEIN', 239708),
(306170, 'PTHR12854:SF16', NULL, NULL, NULL, NULL, 'SM-ATX DOMAIN-CONTAINING PROTEIN', 239708),
(306171, 'PTHR12854:SF8', NULL, NULL, NULL, NULL, 'ATAXIN-2-LIKE PROTEIN', 239708),
(306172, 'PTHR12854:SF7', NULL, NULL, NULL, NULL, 'ATAXIN-2 HOMOLOG', 239708),
(306173, 'PTHR12378:SF47', NULL, NULL, NULL, NULL, 'PPPDE DOMAIN-CONTAINING PROTEIN', 239709),
(306174, 'PTHR12378:SF9', NULL, NULL, NULL, NULL, 'PPPDE DOMAIN-CONTAINING PROTEIN', 239709),
(306175, 'PTHR12378:SF68', NULL, NULL, NULL, NULL, 'PPPDE PUTATIVE THIOL PEPTIDASE FAMILY PROTEIN-RELATED', 239709),
(306176, 'PTHR12378:SF44', NULL, NULL, NULL, NULL, 'DESUMOYLATING ISOPEPTIDASE 2-LIKE', 239709),
(306177, 'PTHR12378:SF49', NULL, NULL, NULL, NULL, 'PPPDE DOMAIN-CONTAINING PROTEIN', 239709),
(306178, 'PTHR12378:SF48', NULL, NULL, NULL, NULL, 'PUTATIVE THIOL PEPTIDASE FAMILY PROTEIN-RELATED', 239709),
(306179, 'PTHR12378:SF61', NULL, NULL, NULL, NULL, 'PPPDE PUTATIVE PEPTIDASE DOMAIN-CONTAINING PROTEIN-RELATED', 239709),
(306180, 'PTHR12378:SF60', NULL, NULL, NULL, NULL, 'PPPDE DOMAIN-CONTAINING PROTEIN', 239709),
(306181, 'PTHR12378:SF81', NULL, NULL, NULL, NULL, 'OS02G0814000 PROTEIN', 239709),
(306182, 'PTHR12378:SF80', NULL, NULL, NULL, NULL, 'IP06716P-RELATED', 239709),
(306183, 'PTHR12378:SF65', NULL, NULL, NULL, NULL, 'PPPDE DOMAIN-CONTAINING PROTEIN', 239709),
(306184, 'PTHR12378:SF41', NULL, NULL, NULL, NULL, 'PPPDE DOMAIN-CONTAINING PROTEIN', 239709);
INSERT INTO "PUBLIC"."MODEL" VALUES
(306185, 'PTHR12378:SF62', NULL, NULL, NULL, NULL, 'BNAA09G55810D PROTEIN', 239709),
(306186, 'PTHR12378:SF7', NULL, NULL, NULL, NULL, 'DESUMOYLATING ISOPEPTIDASE 1', 239709),
(306187, 'PTHR12378:SF6', NULL, NULL, NULL, NULL, 'DEUBIQUITINASE DESI2', 239709),
(306188, 'PTHR12378:SF58', NULL, NULL, NULL, NULL, 'PPPDE PUTATIVE PEPTIDASE DOMAIN-CONTAINING PROTEIN-RELATED', 239709),
(306189, 'PTHR12378:SF13', NULL, NULL, NULL, NULL, 'OS06G0560400 PROTEIN', 239709),
(306190, 'PTHR12378:SF79', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239709),
(306191, 'PTHR12378:SF57', NULL, NULL, NULL, NULL, 'PPPDE DOMAIN-CONTAINING PROTEIN', 239709),
(306192, 'PTHR12378:SF56', NULL, NULL, NULL, NULL, 'PPPDE DOMAIN-CONTAINING PROTEIN', 239709),
(306193, 'PTHR12378:SF78', NULL, NULL, NULL, NULL, 'PPPDE DOMAIN-CONTAINING PROTEIN', 239709),
(306194, 'PTHR12378:SF55', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239709),
(306195, 'PTHR12378:SF17', NULL, NULL, NULL, NULL, 'OS06G0182100 PROTEIN', 239709),
(306196, 'PTHR12378:SF16', NULL, NULL, NULL, NULL, 'PPPDE DOMAIN-CONTAINING PROTEIN', 239709),
(306197, 'PTHR12378:SF38', NULL, NULL, NULL, NULL, 'OS03G0100900 PROTEIN', 239709),
(306198, 'PTHR12378:SF59', NULL, NULL, NULL, NULL, 'PPPDE PUTATIVE PEPTIDASE DOMAIN-CONTAINING PROTEIN-RELATED', 239709),
(306199, 'PTHR12378:SF70', NULL, NULL, NULL, NULL, 'PPPDE PUTATIVE PEPTIDASE DOMAIN-CONTAINING PROTEIN-RELATED', 239709),
(306200, 'PTHR12378:SF54', NULL, NULL, NULL, NULL, 'BNACNNG05060D PROTEIN', 239709),
(306201, 'PTHR12378:SF10', NULL, NULL, NULL, NULL, 'OS04G0548000 PROTEIN', 239709),
(306202, 'PTHR12378:SF75', NULL, NULL, NULL, NULL, 'DESUMOYLATING ISOPEPTIDASE 2', 239709),
(306203, 'PTHR12378:SF74', NULL, NULL, NULL, NULL, 'OS02G0655500 PROTEIN', 239709),
(306204, 'PTHR12378:SF52', NULL, NULL, NULL, NULL, 'F23A5.4 PROTEIN', 239709),
(306205, 'PTHR12378:SF51', NULL, NULL, NULL, NULL, 'DESI-LIKE PROTEIN', 239709),
(306206, 'PTHR12378:SF73', NULL, NULL, NULL, NULL, 'THIOL PEPTIDASE FAMILY PROTEIN, PUTATIVE-RELATED', 239709),
(306207, 'PTHR12378', NULL, NULL, NULL, NULL, 'DESUMOYLATING ISOPEPTIDASE', 239709),
(306208, 'PTHR31818:SF11', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 6', 239710),
(306209, 'PTHR31818:SF23', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 239710),
(306210, 'PTHR31818:SF12', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 239710),
(306211, 'PTHR31818:SF3', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 29', 239710),
(306212, 'PTHR31818:SF20', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 239710),
(306213, 'PTHR31818:SF21', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 239710),
(306214, 'PTHR31818:SF2', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 239710),
(306215, 'PTHR31818:SF15', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 239710),
(306216, 'PTHR31818:SF27', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 239710),
(306217, 'PTHR31818:SF16', NULL, NULL, NULL, NULL, 'PROTEIN ROOT HAIR SPECIFIC 17', 239710),
(306218, 'PTHR31818:SF13', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 239710),
(306219, 'PTHR31818:SF24', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 239710),
(306220, 'PTHR31818:SF14', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 239710),
(306221, 'PTHR31818', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 16', 239710),
(306222, 'PTHR31818:SF1', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 16', 239710),
(306223, 'PTHR31818:SF19', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 239710),
(306224, 'PTHR31818:SF28', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 239710),
(306225, 'PTHR42903', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YCCF', 239711),
(306226, 'PTHR42903:SF1', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YCCF', 239711),
(306227, 'PTHR24198:SF65', NULL, NULL, NULL, NULL, 'RECEPTOR-INTERACTING SERINE/THREONINE-PROTEIN KINASE 4', 239712),
(306228, 'PTHR24198', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239712);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(306229, 'PTHR24198:SF183', NULL, NULL, NULL, NULL, 'SUPPRESSOR/ENHANCER OF LIN-12', 239712),
(306230, 'PTHR24198:SF180', NULL, NULL, NULL, NULL, 'ANKYRIN-2-LIKE PROTEIN', 239712),
(306231, 'PTHR24198:SF175', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND PROTEIN KINASE DOMAIN-CONTAINING PROTEIN 1', 239712),
(306232, 'PTHR24198:SF186', NULL, NULL, NULL, NULL, 'ANKYRIN 1', 239712),
(306233, 'PTHR24198:SF165', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 239712),
(306234, 'PTHR24198:SF187', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX CONTAINING 15', 239712),
(306235, 'PTHR24198:SF176', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX CONTAINING 14', 239712),
(306236, 'PTHR24198:SF173', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX-CONTAINING 10-RELATED', 239712),
(306237, 'PTHR24198:SF184', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX-CONTAINING 3', 239712),
(306238, 'PTHR24198:SF185', NULL, NULL, NULL, NULL, 'ANKYRIN-3', 239712),
(306239, 'PTHR24198:SF169', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 239712),
(306240, 'PTHR36925', NULL, NULL, NULL, NULL, 'COBALT-PRECORRIN-6A REDUCTASE', 239713),
(306241, 'PTHR36925:SF1', NULL, NULL, NULL, NULL, 'COBALT-PRECORRIN-6A REDUCTASE', 239713),
(306242, 'PTHR18919:SF157', NULL, NULL, NULL, NULL, 'ACETYL-COA ACETYLTRANSFERASE, CYTOSOLIC 2-RELATED', 239714),
(306243, 'PTHR18919:SF134', NULL, NULL, NULL, NULL, 'BETA-KETOACYL COA THIOLASE FADA3-RELATED', 239714),
(306244, 'PTHR18919:SF156', NULL, NULL, NULL, NULL, 'ACETYL-COA ACETYLTRANSFERASE, MITOCHONDRIAL', 239714),
(306245, 'PTHR18919:SF155', NULL, NULL, NULL, NULL, 'BNAA02G30030D PROTEIN', 239714),
(306246, 'PTHR18919:SF133', NULL, NULL, NULL, NULL, 'PROTEIN CBG24740', 239714),
(306247, 'PTHR18919:SF139', NULL, NULL, NULL, NULL, 'TLP1_ADD_C DOMAIN-CONTAINING PROTEIN', 239714),
(306248, 'PTHR18919:SF138', NULL, NULL, NULL, NULL, 'ACETYL-COA C-ACETYLTRANSFERASE', 239714),
(306249, 'PTHR18919', NULL, NULL, NULL, NULL, 'ACETYL-COA C-ACYLTRANSFERASE', 239714),
(306250, 'PTHR18919:SF150', NULL, NULL, NULL, NULL, '', 239714),
(306251, 'PTHR18919:SF170', NULL, NULL, NULL, NULL, 'OS01G0110400 PROTEIN', 239714),
(306252, 'PTHR18919:SF153', NULL, NULL, NULL, NULL, 'TRIFUNCTIONAL ENZYME SUBUNIT BETA, MITOCHONDRIAL', 239714),
(306253, 'PTHR18919:SF89', NULL, NULL, NULL, NULL, '', 239714),
(306254, 'PTHR18919:SF151', NULL, NULL, NULL, NULL, 'BLR2427 PROTEIN', 239714),
(306255, 'PTHR18919:SF83', NULL, NULL, NULL, NULL, 'CARRIER PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G06380)-RELATED', 239714),
(306256, 'PTHR18919:SF147', NULL, NULL, NULL, NULL, 'TRIFUNCTIONAL ENZYME SUBUNIT BETA, MITOCHONDRIAL', 239714),
(306257, 'PTHR18919:SF169', NULL, NULL, NULL, NULL, 'ACETYL-COA ACETYLTRANSFERASE, CYTOSOLIC 1', 239714),
(306258, 'PTHR18919:SF146', NULL, NULL, NULL, NULL, 'ACETYL-COA ACETYLTRANSFERASE CYTOSOLIC 2-RELATED', 239714),
(306259, 'PTHR18919:SF168', NULL, NULL, NULL, NULL, 'PEROXISOMAL ACETOACETYL-COENZYME A THIOLASE', 239714),
(306260, 'PTHR18919:SF167', NULL, NULL, NULL, NULL, 'ACETYL-COA ACYLTRANSFERASE', 239714),
(306261, 'PTHR18919:SF145', NULL, NULL, NULL, NULL, '3-KETOACYL-COA THIOLASE, MITOCHONDRIAL', 239714),
(306262, 'PTHR18919:SF144', NULL, NULL, NULL, NULL, 'ACYL-COA THIOLASE-RELATED', 239714),
(306263, 'PTHR18919:SF107', NULL, NULL, NULL, NULL, '3-KETOACYL-COA THIOLASE, MITOCHONDRIAL', 239714),
(306264, 'PTHR18919:SF81', NULL, NULL, NULL, NULL, 'ACETYL-COA ACETYLTRANSFERASE, CYTOSOLIC', 239714),
(306265, 'PTHR18919:SF161', NULL, NULL, NULL, NULL, 'OS09G0252100 PROTEIN', 239714),
(306266, 'PTHR18919:SF143', NULL, NULL, NULL, NULL, '', 239714),
(306267, 'PTHR18919:SF165', NULL, NULL, NULL, NULL, 'ACETYL-COA ACETYLTRANSFERASE', 239714),
(306268, 'PTHR18919:SF164', NULL, NULL, NULL, NULL, 'ACETYL-COA ACETYLTRANSFERASE', 239714),
(306269, 'PTHR18919:SF141', NULL, NULL, NULL, NULL, 'ACETYL-COA ACETYLTRANSFERASE, CYTOSOLIC 1-LIKE', 239714),
(306270, 'PTHR18919:SF12', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE RV0859-RELATED', 239714),
(306271, 'PTHR18919:SF163', NULL, NULL, NULL, NULL, 'PEROXISOMAL ACETOACETYL-COENZYME A THIOLASE', 239714);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(306272, 'PTHR18919:SF140', NULL, NULL, NULL, NULL, 'ACETYL-COA C-ACETYLTRANSFERASE (ACETOACETYL-COA THIOLASE) (ACAB-5)', 239714),
(306273, 'PTHR18919:SF162', NULL, NULL, NULL, NULL, '', 239714),
(306274, 'PTHR23059:SF4', NULL, NULL, NULL, NULL, 'CYSTEINE AND HISTIDINE-RICH PROTEIN 1', 239715),
(306275, 'PTHR23059', NULL, NULL, NULL, NULL, 'CYSTEINE AND HISTIDINE-RICH PROTEIN 1', 239715),
(306276, 'PTHR48139:SF1', NULL, NULL, NULL, NULL, 'SI:DKEY-56M19.5', 239716),
(306277, 'PTHR48139', NULL, NULL, NULL, NULL, 'SI:DKEY-56M19.5', 239716),
(306278, 'PTHR47112:SF1', NULL, NULL, NULL, NULL, 'PX DOMAIN-CONTAINING PROTEIN', 239717),
(306279, 'PTHR47112', NULL, NULL, NULL, NULL, 'PX DOMAIN-CONTAINING PROTEIN', 239717),
(306280, 'PTHR32015:SF1', NULL, NULL, NULL, NULL, 'FASTING INDUCED LIPASE', 239718),
(306281, 'PTHR32015:SF2', NULL, NULL, NULL, NULL, 'LIPASE RELATED', 239718),
(306282, 'PTHR32015:SF3', NULL, NULL, NULL, NULL, 'LIPASE RELATED', 239718),
(306283, 'PTHR32015:SF4', NULL, NULL, NULL, NULL, 'LIPASE RELATED', 239718),
(306284, 'PTHR32015:SF5', NULL, NULL, NULL, NULL, 'LIPASE RELATED', 239718),
(306285, 'PTHR32015:SF11', NULL, NULL, NULL, NULL, 'LIPASE RELATED', 239718),
(306286, 'PTHR32015:SF12', NULL, NULL, NULL, NULL, 'LIPASE RELATED', 239718),
(306287, 'PTHR32015:SF7', NULL, NULL, NULL, NULL, 'LIPASE RELATED', 239718),
(306288, 'PTHR32015:SF8', NULL, NULL, NULL, NULL, 'LIPASE RELATED', 239718),
(306289, 'PTHR32015:SF10', NULL, NULL, NULL, NULL, 'LIPASE RELATED', 239718),
(306290, 'PTHR32015:SF9', NULL, NULL, NULL, NULL, 'LIPASE RELATED', 239718),
(306291, 'PTHR32015:SF27', NULL, NULL, NULL, NULL, 'FASTING INDUCED LIPASE', 239718),
(306292, 'PTHR32015', NULL, NULL, NULL, NULL, 'FASTING INDUCED LIPASE', 239718),
(306293, 'PTHR47577:SF2', NULL, NULL, NULL, NULL, 'THAP-TYPE DOMAIN-CONTAINING PROTEIN', 239719),
(306294, 'PTHR47577:SF1', NULL, NULL, NULL, NULL, 'THAP DOMAIN-CONTAINING PROTEIN 6', 239719),
(306295, 'PTHR47577', NULL, NULL, NULL, NULL, 'THAP DOMAIN-CONTAINING PROTEIN 6', 239719),
(306296, 'PTHR47714', NULL, NULL, NULL, NULL, 'CRS1/YHBY DOMAIN CONTAINING PROTEIN, EXPRESSED', 239720),
(306297, 'PTHR47714:SF1', NULL, NULL, NULL, NULL, 'RNA-BINDING CRS1 / YHBY (CRM) DOMAIN PROTEIN', 239720),
(306298, 'PTHR47714:SF2', NULL, NULL, NULL, NULL, 'CRM DOMAIN-CONTAINING PROTEIN', 239720),
(306299, 'PTHR21715:SF3', NULL, NULL, NULL, NULL, 'WW DOMAIN-CONTAINING PROTEIN', 239721),
(306300, 'PTHR21715', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239721),
(306301, 'PTHR21715:SF0', NULL, NULL, NULL, NULL, 'RH04127P', 239721),
(306302, 'PTHR23052:SF1', NULL, NULL, NULL, NULL, 'AXONEMAL DYNEIN LIGHT CHAIN DOMAIN-CONTAINING PROTEIN 1', 239722),
(306303, 'PTHR23052', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239722),
(306304, 'PTHR42867:SF1', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 239723),
(306305, 'PTHR42867', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 239723),
(306306, 'PTHR11158:SF23', NULL, NULL, NULL, NULL, 'PRELI DOMAIN CONTAINING PROTEIN 3A', 239724),
(306307, 'PTHR11158:SF34', NULL, NULL, NULL, NULL, 'PRELI/MSF1 DOMAIN-CONTAINING PROTEIN', 239724),
(306308, 'PTHR11158:SF24', NULL, NULL, NULL, NULL, 'PRELI DOMAIN-CONTAINING 1B', 239724),
(306309, 'PTHR11158:SF17', NULL, NULL, NULL, NULL, 'PROTEIN SLOWMO', 239724),
(306310, 'PTHR11158:SF28', NULL, NULL, NULL, NULL, 'OS09G0486000 PROTEIN', 239724),
(306311, 'PTHR11158:SF29', NULL, NULL, NULL, NULL, 'PRELI DOMAIN-CONTAINING PROTEIN 1, MITOCHONDRIAL', 239724),
(306312, 'PTHR11158', NULL, NULL, NULL, NULL, 'MSF1/PX19 RELATED', 239724),
(306313, 'PTHR11158:SF30', NULL, NULL, NULL, NULL, 'PRELI/MSF1 DOMAIN-CONTAINING PROTEIN', 239724),
(306314, 'PTHR11158:SF20', NULL, NULL, NULL, NULL, 'PRELI DOMAIN-CONTAINING PROTEIN 2', 239724),
(306315, 'PTHR11158:SF31', NULL, NULL, NULL, NULL, 'PRELI DOMAIN-CONTAINING PROTEIN 1, MITOCHONDRIAL', 239724),
(306316, 'PTHR11158:SF32', NULL, NULL, NULL, NULL, 'PRELI/MSF1 DOMAIN-CONTAINING PROTEIN', 239724),
(306317, 'PTHR11158:SF22', NULL, NULL, NULL, NULL, 'PRELI DOMAIN CONTAINING PROTEIN 3B', 239724);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(306318, 'PTHR11158:SF33', NULL, NULL, NULL, NULL, 'PRELI DOMAIN CONTAINING 1', 239724),
(306319, 'PTHR19443:SF22', NULL, NULL, NULL, NULL, 'HEXOKINASE-5', 239725),
(306320, 'PTHR19443:SF67', NULL, NULL, NULL, NULL, 'HEXOKINASE-2', 239725),
(306321, 'PTHR19443:SF24', NULL, NULL, NULL, NULL, 'PHOSPHOTRANSFERASE', 239725),
(306322, 'PTHR19443:SF28', NULL, NULL, NULL, NULL, 'HEXOKINASE HKDC1', 239725),
(306323, 'PTHR19443:SF29', NULL, NULL, NULL, NULL, 'PHOSPHOTRANSFERASE', 239725),
(306324, 'PTHR19443:SF80', NULL, NULL, NULL, NULL, 'HEXOKINASE-1', 239725),
(306325, 'PTHR19443:SF81', NULL, NULL, NULL, NULL, 'PHOSPHOTRANSFERASE', 239725),
(306326, 'PTHR19443:SF60', NULL, NULL, NULL, NULL, 'HEXOKINASE', 239725),
(306327, 'PTHR19443:SF82', NULL, NULL, NULL, NULL, 'HEXOKINASE-1', 239725),
(306328, 'PTHR19443:SF83', NULL, NULL, NULL, NULL, 'HEXOKINASE YLR446W-RELATED', 239725),
(306329, 'PTHR19443:SF84', NULL, NULL, NULL, NULL, 'PHOSPHOTRANSFERASE', 239725),
(306330, 'PTHR19443:SF63', NULL, NULL, NULL, NULL, 'HEXOKINASE-LIKE 1 PROTEIN-RELATED', 239725),
(306331, 'PTHR19443:SF64', NULL, NULL, NULL, NULL, 'PHOSPHOTRANSFERASE', 239725),
(306332, 'PTHR19443:SF77', NULL, NULL, NULL, NULL, 'PHOSPHOTRANSFERASE', 239725),
(306333, 'PTHR19443:SF78', NULL, NULL, NULL, NULL, 'PHOSPHOTRANSFERASE', 239725),
(306334, 'PTHR19443:SF79', NULL, NULL, NULL, NULL, 'HEXOKINASE-2', 239725),
(306335, 'PTHR19443:SF14', NULL, NULL, NULL, NULL, 'HEXOKINASE-9', 239725),
(306336, 'PTHR19443:SF15', NULL, NULL, NULL, NULL, 'HEXOKINASE-6', 239725),
(306337, 'PTHR19443:SF16', NULL, NULL, NULL, NULL, 'HEXOKINASE TYPE 1-RELATED', 239725),
(306338, 'PTHR19443:SF17', NULL, NULL, NULL, NULL, 'HEXOKINASE-8', 239725),
(306339, 'PTHR19443:SF18', NULL, NULL, NULL, NULL, 'HEXOKINASE-LIKE 2 PROTEIN-RELATED', 239725),
(306340, 'PTHR19443:SF19', NULL, NULL, NULL, NULL, 'HEXOKINASE-10', 239725),
(306341, 'PTHR19443:SF3', NULL, NULL, NULL, NULL, 'HEXOKINASE-4', 239725),
(306342, 'PTHR19443:SF1', NULL, NULL, NULL, NULL, 'HEXOKINASE-3', 239725),
(306343, 'PTHR19443:SF71', NULL, NULL, NULL, NULL, 'PHOSPHOTRANSFERASE', 239725),
(306344, 'PTHR19443:SF73', NULL, NULL, NULL, NULL, 'HEXOKINASE-3', 239725),
(306345, 'PTHR19443:SF6', NULL, NULL, NULL, NULL, 'HEXOKINASE-4', 239725),
(306346, 'PTHR19443:SF30', NULL, NULL, NULL, NULL, 'GLUCOKINASE-1-RELATED', 239725),
(306347, 'PTHR19443', NULL, NULL, NULL, NULL, 'HEXOKINASE', 239725),
(306348, 'PTHR19443:SF4', NULL, NULL, NULL, NULL, 'HEXOKINASE-2', 239725),
(306349, 'PTHR19443:SF54', NULL, NULL, NULL, NULL, 'PHOSPHOTRANSFERASE', 239725),
(306350, 'PTHR19443:SF32', NULL, NULL, NULL, NULL, 'PHOSPHOTRANSFERASE', 239725),
(306351, 'PTHR19443:SF10', NULL, NULL, NULL, NULL, 'HEXOKINASE-1', 239725),
(306352, 'PTHR36448:SF2', NULL, NULL, NULL, NULL, 'CUPIN_2 DOMAIN-CONTAINING PROTEIN', 239726),
(306353, 'PTHR36448', NULL, NULL, NULL, NULL, 'BLR7373 PROTEIN', 239726),
(306354, 'PTHR46040:SF2', NULL, NULL, NULL, NULL, 'SWI/SNF-RELATED MATRIX-ASSOCIATED ACTIN-DEPENDENT REGULATOR OF CHROMATIN SUBFAMILY E MEMBER 1-RELATED', 239727),
(306355, 'PTHR46040:SF1', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP PROTEIN 20A-RELATED', 239727),
(306356, 'PTHR46040:SF4', NULL, NULL, NULL, NULL, 'HMG BOX DOMAIN-CONTAINING PROTEIN', 239727),
(306357, 'PTHR46040:SF3', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP PROTEIN 2', 239727),
(306358, 'PTHR46040', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP PROTEIN 2', 239727),
(306359, 'PTHR13132:SF29', NULL, NULL, NULL, NULL, 'ALPHA-(1,6)-FUCOSYLTRANSFERASE', 239728),
(306360, 'PTHR13132:SF34', NULL, NULL, NULL, NULL, 'ALPHA 1,6-FUCOSYLTRANSFERASE', 239728),
(306361, 'PTHR13132:SF33', NULL, NULL, NULL, NULL, 'COATOMER PROTEIN', 239728),
(306362, 'PTHR13132:SF31', NULL, NULL, NULL, NULL, 'N-ACETYL-BETA-D-GLUCOSAMINIDE ALPHA-1,6-FUCOSYLTRANSFERASE-RELATED', 239728),
(306363, 'PTHR13132', NULL, NULL, NULL, NULL, 'ALPHA- 1,6 -FUCOSYLTRANSFERASE', 239728),
(306364, 'PTHR47233:SF3', NULL, NULL, NULL, NULL, 'CHEMOTAXIS PROTEIN CHEV', 239729),
(306365, 'PTHR47233:SF2', NULL, NULL, NULL, NULL, 'CHEMOTAXIS SIGNAL TRANSDUCTION SYSTEM RESPONSE REGULATOR CHEV', 239729);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(306366, 'PTHR47233', NULL, NULL, NULL, NULL, 'CHEMOTAXIS PROTEIN CHEV', 239729),
(306367, 'PTHR47233:SF4', NULL, NULL, NULL, NULL, 'CHEMOTAXIS SIGNAL TRANSDUCTION PROTEIN-RELATED', 239729),
(306368, 'PTHR47797:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 DOMAIN-CONTAINING PROTEIN-RELATED', 239730),
(306369, 'PTHR47797:SF3', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 DOMAIN-CONTAINING PROTEIN', 239730),
(306370, 'PTHR47797', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G05805)-RELATED', 239730),
(306371, 'PTHR30255:SF2', NULL, NULL, NULL, NULL, 'SINGLE-STRANDED-DNA-SPECIFIC EXONUCLEASE RECJ', 239731),
(306372, 'PTHR30255', NULL, NULL, NULL, NULL, 'SINGLE-STRANDED-DNA-SPECIFIC EXONUCLEASE RECJ', 239731),
(306373, 'PTHR11544:SF61', NULL, NULL, NULL, NULL, 'Y-BOX-BINDING PROTEIN 2', 239732),
(306374, 'PTHR11544:SF60', NULL, NULL, NULL, NULL, 'LD37574P', 239732),
(306375, 'PTHR11544:SF140', NULL, NULL, NULL, NULL, 'COLD SHOCK PROTEIN A-RELATED', 239732),
(306376, 'PTHR11544:SF135', NULL, NULL, NULL, NULL, 'CSD DOMAIN-CONTAINING PROTEIN', 239732),
(306377, 'PTHR11544:SF136', NULL, NULL, NULL, NULL, 'CSD_1 DOMAIN-CONTAINING PROTEIN', 239732),
(306378, 'PTHR11544:SF114', NULL, NULL, NULL, NULL, 'CSD DOMAIN-CONTAINING PROTEIN', 239732),
(306379, 'PTHR11544:SF14', NULL, NULL, NULL, NULL, 'Y-BOX-BINDING PROTEIN 3', 239732),
(306380, 'PTHR11544:SF137', NULL, NULL, NULL, NULL, 'CSD DOMAIN-CONTAINING PROTEIN', 239732),
(306381, 'PTHR11544:SF68', NULL, NULL, NULL, NULL, 'Y-BOX-BINDING PROTEIN 1', 239732),
(306382, 'PTHR11544:SF104', NULL, NULL, NULL, NULL, 'COLD SHOCK PROTEIN CSPD', 239732),
(306383, 'PTHR11544:SF141', NULL, NULL, NULL, NULL, 'COLD SHOCK-LIKE PROTEIN CSPD', 239732),
(306384, 'PTHR11544:SF116', NULL, NULL, NULL, NULL, 'CSP DOMAIN-CONTAINING PROTEIN', 239732),
(306385, 'PTHR11544:SF138', NULL, NULL, NULL, NULL, 'COLD SHOCK PROTEIN SCOF', 239732),
(306386, 'PTHR11544:SF127', NULL, NULL, NULL, NULL, 'COLD SHOCK PROTEIN CSPB', 239732),
(306387, 'PTHR11544:SF139', NULL, NULL, NULL, NULL, 'COLD SHOCK PROTEIN CSPV', 239732),
(306388, 'PTHR11544:SF129', NULL, NULL, NULL, NULL, 'CSD DOMAIN-CONTAINING PROTEIN', 239732),
(306389, 'PTHR11544', NULL, NULL, NULL, NULL, 'COLD SHOCK DOMAIN CONTAINING PROTEINS', 239732),
(306390, 'PTHR11153:SF14', NULL, NULL, NULL, NULL, 'SIDEROFLEXIN-2', 239733),
(306391, 'PTHR11153:SF35', NULL, NULL, NULL, NULL, 'SIDOREFLEXIN', 239733),
(306392, 'PTHR11153:SF3', NULL, NULL, NULL, NULL, 'SIDEROFLEXIN-4', 239733),
(306393, 'PTHR11153:SF20', NULL, NULL, NULL, NULL, 'SIDEROFLEXIN-3', 239733),
(306394, 'PTHR11153:SF8', NULL, NULL, NULL, NULL, 'SIDEROFLEXIN-1', 239733),
(306395, 'PTHR11153', NULL, NULL, NULL, NULL, 'SIDEROFLEXIN', 239733),
(306396, 'PTHR11153:SF17', NULL, NULL, NULL, NULL, 'SIDEROFLEXIN-5', 239733),
(306397, 'PTHR11153:SF16', NULL, NULL, NULL, NULL, 'SIDOREFLEXIN', 239733),
(306398, 'PTHR11153:SF6', NULL, NULL, NULL, NULL, 'SIDEROFLEXIN-5', 239733),
(306399, 'PTHR11153:SF37', NULL, NULL, NULL, NULL, '', 239733),
(306400, 'PTHR37940:SF1', NULL, NULL, NULL, NULL, 'LYSINE--TRNA LIGASE', 239734),
(306401, 'PTHR37940', NULL, NULL, NULL, NULL, 'LYSINE--TRNA LIGASE', 239734),
(306402, 'PTHR45768:SF62', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239735),
(306403, 'PTHR45768:SF61', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL18', 239735),
(306404, 'PTHR45768:SF60', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 239735),
(306405, 'PTHR45768:SF54', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL47', 239735),
(306406, 'PTHR45768:SF10', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL13-RELATED', 239735),
(306407, 'PTHR45768:SF53', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 239735),
(306408, 'PTHR45768:SF59', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C2H2 FAMILY-RELATED', 239735),
(306409, 'PTHR45768:SF15', NULL, NULL, NULL, NULL, 'OS05G0352750 PROTEIN', 239735),
(306410, 'PTHR45768:SF14', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239735),
(306411, 'PTHR45768:SF57', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239735);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(306412, 'PTHR45768:SF13', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C2H2 FAMILY-RELATED', 239735),
(306413, 'PTHR45768:SF56', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239735),
(306414, 'PTHR45768:SF19', NULL, NULL, NULL, NULL, 'OS06G0167200 PROTEIN', 239735),
(306415, 'PTHR45768:SF18', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239735),
(306416, 'PTHR45768:SF17', NULL, NULL, NULL, NULL, 'RING ZINC FINGER DOMAIN SUPERFAMILY PROTEIN-RELATED', 239735),
(306417, 'PTHR45768:SF16', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ATL4', 239735),
(306418, 'PTHR45768', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF13-LIKE', 239735),
(306419, 'PTHR45768:SF51', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239735),
(306420, 'PTHR45768:SF50', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239735),
(306421, 'PTHR45768:SF44', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239735),
(306422, 'PTHR45768:SF43', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 239735),
(306423, 'PTHR45768:SF42', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239735),
(306424, 'PTHR45768:SF46', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 239735),
(306425, 'PTHR45768:SF45', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 239735),
(306426, 'PTHR45768:SF40', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239735),
(306427, 'PTHR45768:SF77', NULL, NULL, NULL, NULL, 'OS10G0566400 PROTEIN', 239735),
(306428, 'PTHR45768:SF76', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL5-LIKE', 239735),
(306429, 'PTHR45768:SF32', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239735),
(306430, 'PTHR45768:SF31', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL63', 239735),
(306431, 'PTHR45768:SF75', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ATL4', 239735),
(306432, 'PTHR45768:SF74', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C2H2 FAMILY-RELATED', 239735),
(306433, 'PTHR45768:SF37', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C2H2 FAMILY-RELATED', 239735),
(306434, 'PTHR45768:SF36', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL46-LIKE ISOFORM X1', 239735),
(306435, 'PTHR45768:SF35', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239735),
(306436, 'PTHR45768:SF34', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL64', 239735),
(306437, 'PTHR45768:SF38', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL56-LIKE', 239735),
(306438, 'PTHR45768:SF73', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL48', 239735),
(306439, 'PTHR45768:SF72', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL5', 239735),
(306440, 'PTHR45768:SF71', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239735),
(306441, 'PTHR45768:SF70', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL46-LIKE', 239735),
(306442, 'PTHR45768:SF66', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 239735),
(306443, 'PTHR45768:SF21', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239735),
(306444, 'PTHR45768:SF7', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL65', 239735),
(306445, 'PTHR45768:SF20', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL3-LIKE', 239735),
(306446, 'PTHR45768:SF63', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239735),
(306447, 'PTHR45768:SF26', NULL, NULL, NULL, NULL, 'OS03G0149800 PROTEIN', 239735),
(306448, 'PTHR45768:SF25', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239735),
(306449, 'PTHR45768:SF24', NULL, NULL, NULL, NULL, 'OS09G0376700 PROTEIN', 239735),
(306450, 'PTHR45768:SF68', NULL, NULL, NULL, NULL, 'OS06G0233200 PROTEIN', 239735),
(306451, 'PTHR45768:SF23', NULL, NULL, NULL, NULL, 'OS02G0790600 PROTEIN', 239735),
(306452, 'PTHR45768:SF28', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL49-RELATED', 239735),
(306453, 'PTHR45768:SF27', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239735);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(306454, 'PTHR16703', NULL, NULL, NULL, NULL, 'CLAUDIN-12', 239736),
(306455, 'PTHR16703:SF3', NULL, NULL, NULL, NULL, 'CLAUDIN-12', 239736),
(306456, 'PTHR42804:SF1', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE-RELATED', 239737),
(306457, 'PTHR42804', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE', 239737),
(306458, 'PTHR42262', NULL, NULL, NULL, NULL, '', 239738),
(306459, 'PTHR42262:SF2', NULL, NULL, NULL, NULL, '', 239738),
(306460, 'PTHR42262:SF1', NULL, NULL, NULL, NULL, '', 239738),
(306461, 'PTHR14569:SF0', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 6 FAMILY MEMBER G6E', 239739),
(306462, 'PTHR14569', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 6 FAMILY MEMBER G6E', 239739),
(306463, 'PTHR46286:SF3', NULL, NULL, NULL, NULL, 'OS05G0145400 PROTEIN', 239740),
(306464, 'PTHR46286:SF1', NULL, NULL, NULL, NULL, 'VIN3-LIKE PROTEIN 1', 239740),
(306465, 'PTHR46286:SF2', NULL, NULL, NULL, NULL, 'VIN3-LIKE PROTEIN 2', 239740),
(306466, 'PTHR46286:SF11', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE-III DOMAIN-CONTAINING PROTEIN', 239740),
(306467, 'PTHR46286', NULL, NULL, NULL, NULL, 'VIN3-LIKE PROTEIN 2-RELATED', 239740),
(306468, 'PTHR46286:SF12', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE-III DOMAIN-CONTAINING PROTEIN', 239740),
(306469, 'PTHR46286:SF9', NULL, NULL, NULL, NULL, 'VIN3-LIKE PROTEIN 3', 239740),
(306470, 'PTHR46286:SF7', NULL, NULL, NULL, NULL, 'PROTEIN VERNALIZATION INSENSITIVE 3', 239740),
(306471, 'PTHR46286:SF8', NULL, NULL, NULL, NULL, 'PHD_OBERON DOMAIN-CONTAINING PROTEIN', 239740),
(306472, 'PTHR46286:SF5', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE-III DOMAIN-CONTAINING PROTEIN', 239740),
(306473, 'PTHR46286:SF6', NULL, NULL, NULL, NULL, 'OS08G0220600 PROTEIN', 239740),
(306474, 'PTHR21245:SF5', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN R', 239741),
(306475, 'PTHR21245:SF6', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 47', 239741),
(306476, 'PTHR21245:SF3', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 46-RELATED', 239741),
(306477, 'PTHR21245:SF4', NULL, NULL, NULL, NULL, 'DEAD END PROTEIN HOMOLOG 1', 239741),
(306478, 'PTHR21245:SF2', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 18-RELATED', 239741),
(306479, 'PTHR21245', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN', 239741),
(306480, 'PTHR21245:SF19', NULL, NULL, NULL, NULL, 'RNA BINDING PROTEIN', 239741),
(306481, 'PTHR21245:SF16', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 239741),
(306482, 'PTHR21245:SF17', NULL, NULL, NULL, NULL, 'NUCLEOLIN-LIKE ISOFORM X1', 239741),
(306483, 'PTHR21245:SF14', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 239741),
(306484, 'PTHR21245:SF9', NULL, NULL, NULL, NULL, 'OS04G0543200 PROTEIN', 239741),
(306485, 'PTHR21245:SF15', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 46-LIKE PROTEIN-RELATED', 239741),
(306486, 'PTHR21245:SF23', NULL, NULL, NULL, NULL, 'RNA BINDING PROTEIN', 239741),
(306487, 'PTHR21245:SF12', NULL, NULL, NULL, NULL, 'RNA BINDING PROTEIN', 239741),
(306488, 'PTHR21245:SF8', NULL, NULL, NULL, NULL, 'APOBEC1 COMPLEMENTATION FACTOR', 239741),
(306489, 'PTHR21245:SF13', NULL, NULL, NULL, NULL, 'RNA RECOGNITION MOTIF', 239741),
(306490, 'PTHR21245:SF10', NULL, NULL, NULL, NULL, 'SYNCRIP, ISOFORM Q-RELATED', 239741),
(306491, 'PTHR21245:SF21', NULL, NULL, NULL, NULL, 'OS07G0180800 PROTEIN', 239741),
(306492, 'PTHR21245:SF22', NULL, NULL, NULL, NULL, 'FACTOR, ARGININE/SERINE-RICH, PUTATIVE-RELATED', 239741),
(306493, 'PTHR21245:SF11', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN Q', 239741),
(306494, 'PTHR21245:SF20', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN R-LIKE ISOFORM X1', 239741),
(306495, 'PTHR36724', NULL, NULL, NULL, NULL, 'COMPLEX 1 LYR-LIKE PROTEIN', 239742),
(306496, 'PTHR36724:SF1', NULL, NULL, NULL, NULL, 'COMPLEX 1 LYR-LIKE PROTEIN', 239742),
(306497, 'PTHR35759', NULL, NULL, NULL, NULL, 'BNAA09G03860D PROTEIN', 239743),
(306498, 'PTHR35759:SF1', NULL, NULL, NULL, NULL, 'T-BOX PROTEIN 41', 239743),
(306499, 'PTHR47538:SF1', NULL, NULL, NULL, NULL, 'PERILIPIN-4', 239744);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(306500, 'PTHR47538', NULL, NULL, NULL, NULL, 'PERILIPIN 4', 239744),
(306501, 'PTHR45560:SF5', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 239745),
(306502, 'PTHR45560', NULL, NULL, NULL, NULL, 'OS04G0163150 PROTEIN-RELATED', 239745),
(306503, 'PTHR45560:SF4', NULL, NULL, NULL, NULL, 'OS04G0164500 PROTEIN', 239745),
(306504, 'PTHR45560:SF3', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 239745),
(306505, 'PTHR46517', NULL, NULL, NULL, NULL, 'FRUCTOSE-2,6-BISPHOSPHATASE TIGAR', 239746),
(306506, 'PTHR46517:SF3', NULL, NULL, NULL, NULL, 'FRUCTOSE-2,6-BISPHOSPHATASE TIGAR A-RELATED', 239746),
(306507, 'PTHR46517:SF2', NULL, NULL, NULL, NULL, 'FRUCTOSE-2,6-BISPHOSPHATASE TIGAR B', 239746),
(306508, 'PTHR46517:SF1', NULL, NULL, NULL, NULL, 'FRUCTOSE-2,6-BISPHOSPHATASE TIGAR', 239746),
(306509, 'PTHR21064:SF1', NULL, NULL, NULL, NULL, 'HYDROXYLYSINE KINASE', 239747),
(306510, 'PTHR21064', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239747),
(306511, 'PTHR21064:SF5', NULL, NULL, NULL, NULL, 'APH DOMAIN-CONTAINING PROTEIN', 239747),
(306512, 'PTHR21064:SF6', NULL, NULL, NULL, NULL, 'APH DOMAIN-CONTAINING PROTEIN', 239747),
(306513, 'PTHR35496:SF13', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 239748),
(306514, 'PTHR35496:SF12', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 239748),
(306515, 'PTHR35496:SF11', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 239748),
(306516, 'PTHR35496:SF7', NULL, NULL, NULL, NULL, '2S SULFUR-RICH SEED STORAGE PROTEIN 2-LIKE', 239748),
(306517, 'PTHR35496:SF4', NULL, NULL, NULL, NULL, '2S SEED STORAGE PROTEIN 1-RELATED', 239748),
(306518, 'PTHR35496', NULL, NULL, NULL, NULL, '2S SEED STORAGE PROTEIN 1-RELATED', 239748),
(306519, 'PTHR35496:SF19', NULL, NULL, NULL, NULL, '2S SULFUR-RICH SEED STORAGE PROTEIN 2-LIKE', 239748),
(306520, 'PTHR35496:SF18', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 239748),
(306521, 'PTHR35496:SF17', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 239748),
(306522, 'PTHR35496:SF16', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 239748),
(306523, 'PTHR35496:SF9', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 239748),
(306524, 'PTHR47771:SF8', NULL, NULL, NULL, NULL, '', 239749),
(306525, 'PTHR47771:SF7', NULL, NULL, NULL, NULL, 'RH73259P', 239749),
(306526, 'PTHR47771:SF6', NULL, NULL, NULL, NULL, 'LP03545P', 239749),
(306527, 'PTHR47771:SF9', NULL, NULL, NULL, NULL, 'HDC01644', 239749),
(306528, 'PTHR47771', NULL, NULL, NULL, NULL, 'LD27203P-RELATED', 239749),
(306529, 'PTHR47771:SF10', NULL, NULL, NULL, NULL, 'LD27203P', 239749),
(306530, 'PTHR47771:SF11', NULL, NULL, NULL, NULL, 'HL02234P', 239749),
(306531, 'PTHR47771:SF3', NULL, NULL, NULL, NULL, 'RH04334P', 239749),
(306532, 'PTHR38461', NULL, NULL, NULL, NULL, '4-DEOXY-L-THREO-5-HEXOSULOSE-URONATE KETOL-ISOMERASE', 239750),
(306533, 'PTHR38461:SF1', NULL, NULL, NULL, NULL, '4-DEOXY-L-THREO-5-HEXOSULOSE-URONATE KETOL-ISOMERASE', 239750),
(306534, 'PTHR10790:SF51', NULL, NULL, NULL, NULL, 'TPR-DOMAIN CONTAINING PROTEIN', 239751),
(306535, 'PTHR10790', NULL, NULL, NULL, NULL, 'TPR-DOMAIN CONTAINING PROTEIN', 239751),
(306536, 'PTHR46102:SF1', NULL, NULL, NULL, NULL, 'AXIN-2', 239752),
(306537, 'PTHR46102:SF2', NULL, NULL, NULL, NULL, 'AXIN', 239752),
(306538, 'PTHR46102:SF3', NULL, NULL, NULL, NULL, 'AXIN-1', 239752),
(306539, 'PTHR46102', NULL, NULL, NULL, NULL, 'AXIN', 239752),
(306540, 'PTHR43752:SF5', NULL, NULL, NULL, NULL, 'BNR/ASP-BOX REPEAT FAMILY PROTEIN', 239753),
(306541, 'PTHR43752:SF4', NULL, NULL, NULL, NULL, 'ALPHA-RHAMNOSIDASE-LIKE PROTEIN', 239753),
(306542, 'PTHR43752:SF3', NULL, NULL, NULL, NULL, 'BNR/ASP-BOX REPEAT FAMILY PROTEIN', 239753),
(306543, 'PTHR43752:SF2', NULL, NULL, NULL, NULL, 'BNR/ASP-BOX REPEAT FAMILY PROTEIN', 239753),
(306544, 'PTHR43752:SF7', NULL, NULL, NULL, NULL, 'SIALIDASE DOMAIN-CONTAINING PROTEIN', 239753),
(306545, 'PTHR43752', NULL, NULL, NULL, NULL, 'BNR/ASP-BOX REPEAT FAMILY PROTEIN', 239753),
(306546, 'PTHR37774:SF4', NULL, NULL, NULL, NULL, 'ATP SYNTHASE PROTEIN MI25', 239754);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(306547, 'PTHR37774', NULL, NULL, NULL, NULL, 'ATP SYNTHASE PROTEIN MI25-RELATED', 239754),
(306548, 'PTHR46290', NULL, NULL, NULL, NULL, 'DI-N-ACETYLCHITOBIASE', 239755),
(306549, 'PTHR46290:SF4', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_18 DOMAIN-CONTAINING PROTEIN', 239755),
(306550, 'PTHR46290:SF5', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_18 DOMAIN-CONTAINING PROTEIN', 239755),
(306551, 'PTHR46290:SF1', NULL, NULL, NULL, NULL, 'DI-N-ACETYLCHITOBIASE', 239755),
(306552, 'PTHR47301:SF1', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC681006', 239756),
(306553, 'PTHR47301', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC681006', 239756),
(306554, 'PTHR47389:SF2', NULL, NULL, NULL, NULL, 'OS01G0278600 PROTEIN', 239757),
(306555, 'PTHR47389:SF4', NULL, NULL, NULL, NULL, 'OS09G0436400 PROTEIN', 239757),
(306556, 'PTHR47389:SF5', NULL, NULL, NULL, NULL, 'OS09G0436700 PROTEIN', 239757),
(306557, 'PTHR47389:SF6', NULL, NULL, NULL, NULL, 'OS09G0436300 PROTEIN', 239757),
(306558, 'PTHR47389:SF7', NULL, NULL, NULL, NULL, 'PDZ_6 DOMAIN-CONTAINING PROTEIN', 239757),
(306559, 'PTHR47389:SF8', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239757),
(306560, 'PTHR47389', NULL, NULL, NULL, NULL, 'OS09G0436400 PROTEIN', 239757),
(306561, 'PTHR30258', NULL, NULL, NULL, NULL, 'TYPE II SECRETION SYSTEM PROTEIN GSPE-RELATED', 239758),
(306562, 'PTHR30258:SF13', NULL, NULL, NULL, NULL, 'SECRETION PATHWAY ATPASE-RELATED', 239758),
(306563, 'PTHR30258:SF1', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN HOFB HOMOLOG', 239758),
(306564, 'PTHR30258:SF2', NULL, NULL, NULL, NULL, 'BACTERIOPHAGE ADSORPTION PROTEIN B', 239758),
(306565, 'PTHR30258:SF3', NULL, NULL, NULL, NULL, 'PILUS ASSEMBLY PROTEIN', 239758),
(306566, 'PTHR30258:SF28', NULL, NULL, NULL, NULL, 'TWITCHING MOTILITY PROTEIN', 239758),
(306567, 'PTHR30258:SF27', NULL, NULL, NULL, NULL, 'TYPE II SECRETION SYSTEM PROTEIN E-RELATED', 239758),
(306568, 'PTHR15191:SF6', NULL, NULL, NULL, NULL, 'PTTG1IP FAMILY MEMBER 2', 239759),
(306569, 'PTHR15191:SF7', NULL, NULL, NULL, NULL, 'PTTG1-INTERACTING PROTEIN A-RELATED', 239759),
(306570, 'PTHR15191:SF8', NULL, NULL, NULL, NULL, 'PITUITARY TUMOR-TRANSFORMING GENE 1 PROTEIN-INTERACTING PROTEIN-LIKE', 239759),
(306571, 'PTHR15191:SF10', NULL, NULL, NULL, NULL, 'PITUITARY TUMOR-TRANSFORMING GENE 1 PROTEIN-INTERACTING PROTEIN', 239759),
(306572, 'PTHR15191:SF11', NULL, NULL, NULL, NULL, 'PSI DOMAIN-CONTAINING PROTEIN', 239759),
(306573, 'PTHR15191', NULL, NULL, NULL, NULL, 'PROTEIN CBG20567', 239759),
(306574, 'PTHR15191:SF1', NULL, NULL, NULL, NULL, 'PSI DOMAIN-CONTAINING PROTEIN', 239759),
(306575, 'PTHR15191:SF3', NULL, NULL, NULL, NULL, 'PITUITARY TUMOR-TRANSFORMING GENE 1 PROTEIN-INTERACTING PROTEIN', 239759),
(306576, 'PTHR43371', NULL, NULL, NULL, NULL, 'VITAMIN B12-DEPENDENT RIBONUCLEOTIDE REDUCTASE', 239760),
(306577, 'PTHR43371:SF1', NULL, NULL, NULL, NULL, 'RIBONUCLEOSIDE-DIPHOSPHATE REDUCTASE', 239760),
(306578, 'PTHR21152:SF38', NULL, NULL, NULL, NULL, 'SERINE-PYRUVATE AMINOTRANSFERASE (AGXT)', 239761),
(306579, 'PTHR21152:SF16', NULL, NULL, NULL, NULL, 'SERINE--PYRUVATE AMINOTRANSFERASE', 239761),
(306580, 'PTHR21152:SF22', NULL, NULL, NULL, NULL, 'SERINE--PYRUVATE AMINOTRANSFERASE', 239761),
(306581, 'PTHR21152:SF34', NULL, NULL, NULL, NULL, 'PHOSPHOSERINE AMINOTRANSFERASE', 239761),
(306582, 'PTHR21152', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE CLASS V', 239761),
(306583, 'PTHR21152:SF24', NULL, NULL, NULL, NULL, 'SERINE--PYRUVATE AMINOTRANSFERASE', 239761),
(306584, 'PTHR36617', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 239762),
(306585, 'PTHR36617:SF9', NULL, NULL, NULL, NULL, 'OS04G0516500 PROTEIN', 239762),
(306586, 'PTHR36617:SF8', NULL, NULL, NULL, NULL, '', 239762),
(306587, 'PTHR36617:SF7', NULL, NULL, NULL, NULL, 'OS01G0823550 PROTEIN', 239762),
(306588, 'PTHR36617:SF6', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', 239762),
(306589, 'PTHR36617:SF5', NULL, NULL, NULL, NULL, 'OS04G0117000 PROTEIN', 239762),
(306590, 'PTHR36617:SF10', NULL, NULL, NULL, NULL, '', 239762);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(306591, 'PTHR36617:SF12', NULL, NULL, NULL, NULL, 'OS05G0421675 PROTEIN', 239762),
(306592, 'PTHR36617:SF11', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 239762),
(306593, 'PTHR36617:SF13', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 239762),
(306594, 'PTHR42341', NULL, NULL, NULL, NULL, 'HYDROPHOBIN', 239763),
(306595, 'PTHR42341:SF1', NULL, NULL, NULL, NULL, 'HYDROPHOBIN', 239763),
(306596, 'PTHR32552:SF85', NULL, NULL, NULL, NULL, 'BLL7968 PROTEIN', 239764),
(306597, 'PTHR32552:SF74', NULL, NULL, NULL, NULL, 'FHUE RECEPTOR', 239764),
(306598, 'PTHR32552:SF84', NULL, NULL, NULL, NULL, 'TONB-DEPENDENT RECEPTOR-RELATED', 239764),
(306599, 'PTHR32552:SF83', NULL, NULL, NULL, NULL, 'BLR3904 PROTEIN', 239764),
(306600, 'PTHR32552:SF82', NULL, NULL, NULL, NULL, 'FCUA PROTEIN', 239764),
(306601, 'PTHR32552:SF81', NULL, NULL, NULL, NULL, 'TONB-DEPENDENT OUTER MEMBRANE RECEPTOR-RELATED', 239764),
(306602, 'PTHR32552:SF90', NULL, NULL, NULL, NULL, 'METAL-PSEUDOPALINE RECEPTOR CNTO', 239764),
(306603, 'PTHR32552', NULL, NULL, NULL, NULL, 'FERRICHROME IRON RECEPTOR-RELATED', 239764),
(306604, 'PTHR32552:SF68', NULL, NULL, NULL, NULL, 'FERRICHROME OUTER MEMBRANE TRANSPORTER/PHAGE RECEPTOR', 239764),
(306605, 'PTHR32552:SF89', NULL, NULL, NULL, NULL, 'CATECHOLATE SIDEROPHORE RECEPTOR FIU', 239764),
(306606, 'PTHR36168:SF4', NULL, NULL, NULL, NULL, '', 239765),
(306607, 'PTHR36168:SF1', NULL, NULL, NULL, NULL, 'AAA_16 DOMAIN-CONTAINING PROTEIN', 239765),
(306608, 'PTHR36168', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 239765),
(306609, 'PTHR12497:SF0', NULL, NULL, NULL, NULL, 'TAFAZZIN', 239766),
(306610, 'PTHR12497:SF5', NULL, NULL, NULL, NULL, 'N-ACYLPHOSPHATIDYLETHANOLAMINE SYNTHASE', 239766),
(306611, 'PTHR12497', NULL, NULL, NULL, NULL, 'TAZ PROTEIN  TAFAZZIN', 239766),
(306612, 'PTHR12497:SF7', NULL, NULL, NULL, NULL, 'TAFAZZIN FAMILY PROTEIN', 239766),
(306613, 'PTHR48223:SF1', NULL, NULL, NULL, NULL, 'EMBRYO DEFECTIVE 2759 PROTEIN', 239767),
(306614, 'PTHR48223:SF3', NULL, NULL, NULL, NULL, 'BNAA09G06350D PROTEIN', 239767),
(306615, 'PTHR48223:SF2', NULL, NULL, NULL, NULL, '', 239767),
(306616, 'PTHR48223', NULL, NULL, NULL, NULL, 'DEFECTIVE 2759, PUTATIVE ISOFORM 1-RELATED', 239767),
(306617, 'PTHR11961:SF31', NULL, NULL, NULL, NULL, 'CYTOCHROME C', 239768),
(306618, 'PTHR11961:SF6', NULL, NULL, NULL, NULL, 'CYTOCHROME C, TESTIS-SPECIFIC', 239768),
(306619, 'PTHR11961:SF52', NULL, NULL, NULL, NULL, 'CYTOCHROME C, MONOHAEM', 239768),
(306620, 'PTHR11961:SF41', NULL, NULL, NULL, NULL, 'CYTOCHROME C DOMAIN-CONTAINING PROTEIN', 239768),
(306621, 'PTHR11961:SF32', NULL, NULL, NULL, NULL, 'CYTOCHROME C', 239768),
(306622, 'PTHR11961:SF43', NULL, NULL, NULL, NULL, 'CYTOCHROME C', 239768),
(306623, 'PTHR11961:SF51', NULL, NULL, NULL, NULL, 'OS04G0693050 PROTEIN', 239768),
(306624, 'PTHR11961:SF50', NULL, NULL, NULL, NULL, 'CYTOCHROME C 2.1', 239768),
(306625, 'PTHR11961:SF27', NULL, NULL, NULL, NULL, 'CYTOCHROME C', 239768),
(306626, 'PTHR11961:SF38', NULL, NULL, NULL, NULL, 'CYTOCHROME C DOMAIN-CONTAINING PROTEIN', 239768),
(306627, 'PTHR11961:SF49', NULL, NULL, NULL, NULL, 'C, PUTATIVE-RELATED', 239768),
(306628, 'PTHR11961:SF29', NULL, NULL, NULL, NULL, 'CYTOCHROME C', 239768),
(306629, 'PTHR11961', NULL, NULL, NULL, NULL, 'CYTOCHROME C', 239768),
(306630, 'PTHR11961:SF46', NULL, NULL, NULL, NULL, 'CYTOCHROME C', 239768),
(306631, 'PTHR11961:SF12', NULL, NULL, NULL, NULL, 'CYTOCHROME C-RELATED', 239768),
(306632, 'PTHR11961:SF48', NULL, NULL, NULL, NULL, 'CYTOCHROME C-1', 239768),
(306633, 'PTHR11961:SF15', NULL, NULL, NULL, NULL, 'CYTOCHROME C, SOMATIC', 239768),
(306634, 'PTHR11961:SF25', NULL, NULL, NULL, NULL, 'CYTOCHROME C', 239768),
(306635, 'PTHR11961:SF47', NULL, NULL, NULL, NULL, 'CYTOCHROME C-LIKE', 239768),
(306636, 'PTHR16523:SF6', NULL, NULL, NULL, NULL, 'PEST PROTEOLYTIC SIGNAL-CONTAINING NUCLEAR PROTEIN', 239769),
(306637, 'PTHR16523:SF7', NULL, NULL, NULL, NULL, 'PEST PROTEOLYTIC SIGNAL-CONTAINING NUCLEAR PROTEIN', 239769),
(306638, 'PTHR16523:SF8', NULL, NULL, NULL, NULL, 'PEST PROTEOLYTIC SIGNAL-CONTAINING NUCLEAR PROTEIN', 239769);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(306639, 'PTHR16523', NULL, NULL, NULL, NULL, 'PEST PROTEOLYTIC SIGNAL-CONTAINING NUCLEAR PROTEIN', 239769),
(306640, 'PTHR21055:SF3', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 36', 239770),
(306641, 'PTHR21055', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239770),
(306642, 'PTHR15352', NULL, NULL, NULL, NULL, 'LYMPHOID-RESTRICTED MEMBRANE PROTEIN, JAW1', 239771),
(306643, 'PTHR15352:SF3', NULL, NULL, NULL, NULL, 'INOSITOL 1,4,5-TRIPHOSPHATE RECEPTOR ASSOCIATED 2', 239771),
(306644, 'PTHR15352:SF2', NULL, NULL, NULL, NULL, 'INOSITOL 1,4,5-TRIPHOSPHATE RECEPTOR ASSOCIATED 1', 239771),
(306645, 'PTHR15352:SF1', NULL, NULL, NULL, NULL, 'EF-HAND_9 DOMAIN-CONTAINING PROTEIN', 239771),
(306646, 'PTHR16172:SF27', NULL, NULL, NULL, NULL, 'FI19426P1', 239772),
(306647, 'PTHR16172:SF38', NULL, NULL, NULL, NULL, 'GH27779P', 239772),
(306648, 'PTHR16172:SF37', NULL, NULL, NULL, NULL, 'RE36877P', 239772),
(306649, 'PTHR16172', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239772),
(306650, 'PTHR16172:SF22', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY DOMAIN-CONTAINING PROTEIN 6-LIKE', 239772),
(306651, 'PTHR16172:SF35', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 239772),
(306652, 'PTHR16172:SF2', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY DOMAIN-CONTAINING PROTEIN 6', 239772),
(306653, 'PTHR16172:SF24', NULL, NULL, NULL, NULL, 'MFS_1_LIKE DOMAIN-CONTAINING PROTEIN', 239772),
(306654, 'PTHR16172:SF41', NULL, NULL, NULL, NULL, 'MFS_1_LIKE DOMAIN-CONTAINING PROTEIN', 239772),
(306655, 'PTHR16172:SF30', NULL, NULL, NULL, NULL, 'SUGAR BABY, ISOFORM C', 239772),
(306656, 'PTHR16172:SF40', NULL, NULL, NULL, NULL, 'MFS_1_LIKE DOMAIN-CONTAINING PROTEIN', 239772),
(306657, 'PTHR38494', NULL, NULL, NULL, NULL, 'STEROID RECEPTOR-ASSOCIATED AND REGULATED PROTEIN', 239773),
(306658, 'PTHR38494:SF1', NULL, NULL, NULL, NULL, 'STEROID RECEPTOR-ASSOCIATED AND REGULATED PROTEIN', 239773),
(306659, 'PTHR46527', NULL, NULL, NULL, NULL, 'NUCLEOPORIN-LIKE PROTEIN 2', 239774),
(306660, 'PTHR46527:SF1', NULL, NULL, NULL, NULL, 'NUCLEOPORIN NUP42', 239774),
(306661, 'PTHR34282:SF6', NULL, NULL, NULL, NULL, 'VARLMGL DOMAIN-CONTAINING PROTEIN', 239775),
(306662, 'PTHR34282:SF2', NULL, NULL, NULL, NULL, 'VARLMGL DOMAIN-CONTAINING PROTEIN', 239775),
(306663, 'PTHR34282:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239775),
(306664, 'PTHR34282', NULL, NULL, NULL, NULL, 'OS01G0228800 PROTEIN-RELATED', 239775),
(306665, 'PTHR31940', NULL, NULL, NULL, NULL, 'SMALL KINETOCHORE-ASSOCIATED PROTEIN', 239776),
(306666, 'PTHR31940:SF2', NULL, NULL, NULL, NULL, 'SMALL KINETOCHORE-ASSOCIATED PROTEIN', 239776),
(306667, 'PTHR39222', NULL, NULL, NULL, NULL, 'MCG9903', 239777),
(306668, 'PTHR39222:SF1', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1700020A23 GENE', 239777),
(306669, 'PTHR38687:SF2', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN FTSN', 239778),
(306670, 'PTHR38687:SF1', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN DEDD', 239778),
(306671, 'PTHR38687', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN DEDD-RELATED', 239778),
(306672, 'PTHR20275:SF37', NULL, NULL, NULL, NULL, 'BNAC02G25050D PROTEIN', 239779),
(306673, 'PTHR20275:SF26', NULL, NULL, NULL, NULL, 'NADH KINASE POS5, MITOCHONDRIAL', 239779),
(306674, 'PTHR20275:SF38', NULL, NULL, NULL, NULL, 'BNAA01G25380D PROTEIN', 239779),
(306675, 'PTHR20275:SF39', NULL, NULL, NULL, NULL, 'BNAANNG17540D PROTEIN', 239779),
(306676, 'PTHR20275:SF28', NULL, NULL, NULL, NULL, 'NADH KINASE', 239779),
(306677, 'PTHR20275:SF0', NULL, NULL, NULL, NULL, 'NAD KINASE', 239779),
(306678, 'PTHR20275:SF32', NULL, NULL, NULL, NULL, 'NAD/NADH KINASE FAMILY PROTEIN', 239779),
(306679, 'PTHR20275:SF43', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL NADP PHOSPHATASE/NAD KINASE', 239779),
(306680, 'PTHR20275:SF33', NULL, NULL, NULL, NULL, 'NAD KINASE 2, CHLOROPLASTIC-LIKE', 239779),
(306681, 'PTHR20275:SF11', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G12870)-RELATED', 239779),
(306682, 'PTHR20275:SF35', NULL, NULL, NULL, NULL, 'NAD KINASE 1-RELATED', 239779);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(306683, 'PTHR20275:SF13', NULL, NULL, NULL, NULL, 'NAD KINASE 1', 239779),
(306684, 'PTHR20275:SF30', NULL, NULL, NULL, NULL, 'NAD(+) KINASE', 239779),
(306685, 'PTHR20275:SF41', NULL, NULL, NULL, NULL, 'POLY(P)/ATP NAD KINASE', 239779),
(306686, 'PTHR20275:SF42', NULL, NULL, NULL, NULL, 'NAD+ KINASE FAMILY PROTEIN', 239779),
(306687, 'PTHR20275:SF31', NULL, NULL, NULL, NULL, 'NAD KINASE 3-RELATED', 239779),
(306688, 'PTHR20275:SF6', NULL, NULL, NULL, NULL, 'NAD KINASE 2, CHLOROPLASTIC', 239779),
(306689, 'PTHR20275', NULL, NULL, NULL, NULL, 'NAD KINASE', 239779),
(306690, 'PTHR20275:SF9', NULL, NULL, NULL, NULL, 'NAD KINASE 2', 239779),
(306691, 'PTHR20275:SF29', NULL, NULL, NULL, NULL, 'NAD(+) KINASE', 239779),
(306692, 'PTHR10552:SF11', NULL, NULL, NULL, NULL, 'U2 SMALL NUCLEAR RIBONUCLEOPROTEIN A''', 239780),
(306693, 'PTHR10552:SF6', NULL, NULL, NULL, NULL, 'U2 SMALL NUCLEAR RIBONUCLEOPROTEIN A''-RELATED', 239780),
(306694, 'PTHR10552', NULL, NULL, NULL, NULL, 'U2 SMALL NUCLEAR RIBONUCLEOPROTEIN A', 239780),
(306695, 'PTHR10552:SF10', NULL, NULL, NULL, NULL, 'U2 SMALL NUCLEAR RIBONUCLEOPROTEIN 40K', 239780),
(306696, 'PTHR10552:SF9', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEATS AND IQ MOTIF CONTAINING 1', 239780),
(306697, 'PTHR10552:SF8', NULL, NULL, NULL, NULL, 'LRRCAP DOMAIN-CONTAINING PROTEIN', 239780),
(306698, 'PTHR47269:SF1', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP21-4', 239781),
(306699, 'PTHR47269:SF2', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 239781),
(306700, 'PTHR47269:SF3', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP21-3, MITOCHONDRIAL', 239781),
(306701, 'PTHR47269:SF4', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 239781),
(306702, 'PTHR47269:SF5', NULL, NULL, NULL, NULL, 'PPIASE CYCLOPHILIN-TYPE DOMAIN-CONTAINING PROTEIN', 239781),
(306703, 'PTHR47269', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP21-4', 239781),
(306704, 'PTHR46832:SF1', NULL, NULL, NULL, NULL, '5''-METHYLTHIOADENOSINE/S-ADENOSYLHOMOCYSTEINE NUCLEOSIDASE', 239782),
(306705, 'PTHR46832:SF2', NULL, NULL, NULL, NULL, 'FUTALOSINE HYDROLASE', 239782),
(306706, 'PTHR46832', NULL, NULL, NULL, NULL, '5''-METHYLTHIOADENOSINE/S-ADENOSYLHOMOCYSTEINE NUCLEOSIDASE', 239782),
(306707, 'PTHR16087', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 206', 239783),
(306708, 'PTHR16087:SF0', NULL, NULL, NULL, NULL, 'PROTON-ACTIVATED CHLORIDE CHANNEL', 239783),
(306709, 'PTHR10900:SF121', NULL, NULL, NULL, NULL, '', 239784),
(306710, 'PTHR10900:SF120', NULL, NULL, NULL, NULL, 'FI19380P1', 239784),
(306711, 'PTHR10900:SF82', NULL, NULL, NULL, NULL, 'TRANSFORMING GROWTH FACTOR-BETA-INDUCED PROTEIN IG-H3', 239784),
(306712, 'PTHR10900:SF80', NULL, NULL, NULL, NULL, 'FASCICLIN-1', 239784),
(306713, 'PTHR10900', NULL, NULL, NULL, NULL, 'PERIOSTIN-RELATED', 239784),
(306714, 'PTHR10900:SF12', NULL, NULL, NULL, NULL, 'PERIOSTIN', 239784),
(306715, 'PTHR10900:SF77', NULL, NULL, NULL, NULL, 'FI05614P', 239784),
(306716, 'PTHR10900:SF119', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 239784),
(306717, 'PTHR10900:SF118', NULL, NULL, NULL, NULL, '', 239784),
(306718, 'PTHR10900:SF117', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN ELCF', 239784),
(306719, 'PTHR10900:SF116', NULL, NULL, NULL, NULL, 'RE16941P', 239784),
(306720, 'PTHR10900:SF114', NULL, NULL, NULL, NULL, 'FAS1 DOMAIN-CONTAINING PROTEIN', 239784),
(306721, 'PTHR10900:SF122', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 239784),
(306722, 'PTHR38766:SF1', NULL, NULL, NULL, NULL, 'FLAGELLAR PROTEIN FLIO', 239785),
(306723, 'PTHR38766', NULL, NULL, NULL, NULL, 'FLAGELLAR PROTEIN FLIO', 239785),
(306724, 'PTHR37355:SF1', NULL, NULL, NULL, NULL, 'PLACENTA-SPECIFIC PROTEIN 9', 239786),
(306725, 'PTHR37355', NULL, NULL, NULL, NULL, 'PLACENTA-SPECIFIC PROTEIN 9', 239786),
(306726, 'PTHR47130:SF5', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 239787),
(306727, 'PTHR47130:SF6', NULL, NULL, NULL, NULL, 'ZONA PELLUCIDA PROTEIN AX 4', 239787);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(306728, 'PTHR47130', NULL, NULL, NULL, NULL, 'SI:DKEY-19B23.11-RELATED', 239787),
(306729, 'PTHR47130:SF1', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 239787),
(306730, 'PTHR47130:SF3', NULL, NULL, NULL, NULL, 'ZONA PELLUCIDA PROTEIN', 239787),
(306731, 'PTHR46291:SF8', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239788),
(306732, 'PTHR46291:SF9', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239788),
(306733, 'PTHR46291', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239788),
(306734, 'PTHR46291:SF4', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239788),
(306735, 'PTHR46291:SF5', NULL, NULL, NULL, NULL, 'C2 CALCIUM-DEPENDENT DOMAIN-CONTAINING PROTEIN 4C', 239788),
(306736, 'PTHR46291:SF1', NULL, NULL, NULL, NULL, 'C2 CALCIUM-DEPENDENT DOMAIN-CONTAINING PROTEIN 4D', 239788),
(306737, 'PTHR17600:SF2', NULL, NULL, NULL, NULL, 'LRP CHAPERONE MESD', 239789),
(306738, 'PTHR17600', NULL, NULL, NULL, NULL, 'MESODERM DEVELOPMENT CANDIDATE 2', 239789),
(306739, 'PTHR35300:SF5', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE', 239790),
(306740, 'PTHR35300:SF4', NULL, NULL, NULL, NULL, 'COACTIVATOR CBP, KIX DOMAIN-CONTAINING PROTEIN-RELATED', 239790),
(306741, 'PTHR35300:SF6', NULL, NULL, NULL, NULL, 'BNAC01G30480D PROTEIN', 239790),
(306742, 'PTHR35300', NULL, NULL, NULL, NULL, 'COACTIVATOR CBP, KIX DOMAIN-CONTAINING PROTEIN-RELATED', 239790),
(306743, 'PTHR30267', NULL, NULL, NULL, NULL, 'PROTEIN KINASE PRKA', 239791),
(306744, 'PTHR30267:SF2', NULL, NULL, NULL, NULL, 'PROTEIN PRKA', 239791),
(306745, 'PTHR22763', NULL, NULL, NULL, NULL, 'RING ZINC FINGER PROTEIN', 239792),
(306746, 'PTHR22763:SF185', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239792),
(306747, 'PTHR22763:SF163', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF139', 239792),
(306748, 'PTHR22763:SF162', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239792),
(306749, 'PTHR22763:SF184', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SYNOVIOLIN', 239792),
(306750, 'PTHR22763:SF183', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239792),
(306751, 'PTHR22763:SF172', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE E3 UBIQUITIN-PROTEIN LIGASE FLY2', 239792),
(306752, 'PTHR22763:SF182', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239792),
(306753, 'PTHR22763:SF181', NULL, NULL, NULL, NULL, 'DSC E3 UBIQUITIN LIGASE COMPLEX SUBUNIT 1-LIKE ISOFORM X1', 239792),
(306754, 'PTHR22763:SF167', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 145', 239792),
(306755, 'PTHR22763:SF189', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C2H2 FAMILY-RELATED', 239792),
(306756, 'PTHR22763:SF188', NULL, NULL, NULL, NULL, 'ERAD-ASSOCIATED E3 UBIQUITIN-PROTEIN LIGASE HRD1B-LIKE', 239792),
(306757, 'PTHR22763:SF176', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239792),
(306758, 'PTHR22763:SF187', NULL, NULL, NULL, NULL, 'ERAD-ASSOCIATED E3 UBIQUITIN-PROTEIN LIGASE HRD1B', 239792),
(306759, 'PTHR22763:SF165', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239792),
(306760, 'PTHR22763:SF186', NULL, NULL, NULL, NULL, 'ERAD-ASSOCIATED E3 UBIQUITIN-PROTEIN LIGASE HRD1A', 239792),
(306761, 'PTHR22763:SF164', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239792),
(306762, 'PTHR47313:SF1', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA LARGE SUBUNIT METHYLTRANSFERASE K/L', 239793),
(306763, 'PTHR47313', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA LARGE SUBUNIT METHYLTRANSFERASE K/L', 239793),
(306764, 'PTHR45735:SF10', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 239794),
(306765, 'PTHR45735:SF2', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 239794),
(306766, 'PTHR45735:SF11', NULL, NULL, NULL, NULL, 'PROTEIN PTI1', 239794),
(306767, 'PTHR45735', NULL, NULL, NULL, NULL, 'CLEAVAGE STIMULATION FACTOR SUBUNIT 2', 239794),
(306768, 'PTHR45735:SF14', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN', 239794),
(306769, 'PTHR45735:SF13', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 239794);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(306770, 'PTHR45735:SF8', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 239794),
(306771, 'PTHR45735:SF6', NULL, NULL, NULL, NULL, 'CLEAVAGE STIMULATION FACTOR SUBUNIT 2', 239794),
(306772, 'PTHR45735:SF3', NULL, NULL, NULL, NULL, 'CLEAVAGE STIMULATION FACTOR SUBUNIT 2 TAU VARIANT', 239794),
(306773, 'PTHR45735:SF4', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 239794),
(306774, 'PTHR37151', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 61', 239795),
(306775, 'PTHR37151:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 61', 239795),
(306776, 'PTHR36373', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239796),
(306777, 'PTHR36373:SF2', NULL, NULL, NULL, NULL, '', 239796),
(306778, 'PTHR36373:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239796),
(306779, 'PTHR36373:SF3', NULL, NULL, NULL, NULL, 'BNACNNG36630D PROTEIN', 239796),
(306780, 'PTHR23176:SF130', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN GACEE', 239797),
(306781, 'PTHR23176:SF131', NULL, NULL, NULL, NULL, 'GTPASE-ACTIVATING PROTEIN BEM3', 239797),
(306782, 'PTHR23176:SF134', NULL, NULL, NULL, NULL, 'RHO-GAP DOMAIN-CONTAINING PROTEIN', 239797),
(306783, 'PTHR23176:SF135', NULL, NULL, NULL, NULL, 'RHO GTPASE ACTIVATOR RGA', 239797),
(306784, 'PTHR23176:SF132', NULL, NULL, NULL, NULL, 'RHO-TYPE GTPASE-ACTIVATING PROTEIN 4-RELATED', 239797),
(306785, 'PTHR23176:SF133', NULL, NULL, NULL, NULL, 'GTPASE-ACTIVATING PROTEIN PAC-1', 239797),
(306786, 'PTHR23176:SF12', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN GACT', 239797),
(306787, 'PTHR23176:SF99', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN GACP', 239797),
(306788, 'PTHR23176:SF11', NULL, NULL, NULL, NULL, 'RHO-GAP DOMAIN-CONTAINING PROTEIN', 239797),
(306789, 'PTHR23176:SF8', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN GACH', 239797),
(306790, 'PTHR23176:SF96', NULL, NULL, NULL, NULL, 'GTPASE-ACTIVATING PROTEIN BEM2/IPL2', 239797),
(306791, 'PTHR23176:SF5', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN GACFF', 239797),
(306792, 'PTHR23176', NULL, NULL, NULL, NULL, 'RHO/RAC/CDC GTPASE-ACTIVATING PROTEIN', 239797),
(306793, 'PTHR23176:SF0', NULL, NULL, NULL, NULL, 'RHO GTPASE ACTIVATING PROTEIN AT 19D, ISOFORM D', 239797),
(306794, 'PTHR23176:SF127', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN GACJ', 239797),
(306795, 'PTHR23176:SF128', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN RGD1', 239797),
(306796, 'PTHR23176:SF125', NULL, NULL, NULL, NULL, 'GTPASE ACTIVATOR (BEM2), PUTATIVE (AFU_ORTHOLOGUE AFUA_7G04450)-RELATED', 239797),
(306797, 'PTHR23176:SF103', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 9', 239797),
(306798, 'PTHR23176:SF104', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 27', 239797),
(306799, 'PTHR23176:SF107', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 12', 239797),
(306800, 'PTHR23176:SF129', NULL, NULL, NULL, NULL, 'RHO GTPASE ACTIVATING PROTEIN AT 16F, ISOFORM E-RELATED', 239797),
(306801, 'PTHR23176:SF108', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 15', 239797),
(306802, 'PTHR23176:SF102', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN GACI', 239797),
(306803, 'PTHR23176:SF121', NULL, NULL, NULL, NULL, 'RHO-TYPE GTPASE-ACTIVATING PROTEIN 1-RELATED', 239797),
(306804, 'PTHR23176:SF122', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN GACC-RELATED', 239797),
(306805, 'PTHR13639', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY FACTOR 4 HOMOLOG, MITOCHONDRIAL', 239798),
(306806, 'PTHR13639:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY FACTOR 4 HOMOLOG, MITOCHONDRIAL', 239798),
(306807, 'PTHR42918:SF11', NULL, NULL, NULL, NULL, 'LYSINE--TRNA LIGASE', 239799),
(306808, 'PTHR42918:SF13', NULL, NULL, NULL, NULL, 'LYSINE--TRNA LIGASE', 239799),
(306809, 'PTHR42918:SF12', NULL, NULL, NULL, NULL, 'LYSINE--TRNA LIGASE', 239799),
(306810, 'PTHR42918', NULL, NULL, NULL, NULL, 'LYSYL-TRNA SYNTHETASE', 239799),
(306811, 'PTHR42918:SF15', NULL, NULL, NULL, NULL, 'LYSINE--TRNA LIGASE, CHLOROPLASTIC/MITOCHONDRIAL', 239799);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(306812, 'PTHR42918:SF14', NULL, NULL, NULL, NULL, 'LYSINE--TRNA LIGASE', 239799),
(306813, 'PTHR42918:SF9', NULL, NULL, NULL, NULL, 'LYSINE--TRNA LIGASE', 239799),
(306814, 'PTHR42918:SF7', NULL, NULL, NULL, NULL, 'LYSYL-TRNA SYNTHETASE', 239799),
(306815, 'PTHR42918:SF6', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR P--(R)-BETA-LYSINE LIGASE', 239799),
(306816, 'PTHR42918:SF5', NULL, NULL, NULL, NULL, 'LYSINE--TRNA LIGASE, MITOCHONDRIAL', 239799),
(306817, 'PTHR42918:SF1', NULL, NULL, NULL, NULL, 'LYSINE--TRNA LIGASE', 239799),
(306818, 'PTHR15271', NULL, NULL, NULL, NULL, 'CHROMATIN ASSEMBLY FACTOR 1 SUBUNIT B', 239800),
(306819, 'PTHR15271:SF4', NULL, NULL, NULL, NULL, 'CHROMATIN ASSEMBLY FACTOR 1 SUBUNIT B', 239800),
(306820, 'PTHR15271:SF5', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 239800),
(306821, 'PTHR15426:SF6', NULL, NULL, NULL, NULL, 'PROTEIN DEPP1', 239801),
(306822, 'PTHR15426', NULL, NULL, NULL, NULL, 'PROTEIN DEPP1', 239801),
(306823, 'PTHR47976:SF101', NULL, NULL, NULL, NULL, 'G-TYPE LECTIN S-RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE LECRK1', 239802),
(306824, 'PTHR47976:SF102', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 239802),
(306825, 'PTHR47976:SF103', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306826, 'PTHR47976:SF104', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306827, 'PTHR47976:SF100', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239802),
(306828, 'PTHR47976:SF15', NULL, NULL, NULL, NULL, 'G-TYPE LECTIN S-RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE RLK1', 239802),
(306829, 'PTHR47976:SF58', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306830, 'PTHR47976:SF57', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306831, 'PTHR47976:SF13', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306832, 'PTHR47976:SF19', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306833, 'PTHR47976:SF18', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306834, 'PTHR47976:SF17', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306835, 'PTHR47976:SF52', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239802),
(306836, 'PTHR47976:SF96', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306837, 'PTHR47976:SF95', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306838, 'PTHR47976:SF94', NULL, NULL, NULL, NULL, 'S-LOCUS-LIKE RECEPTOR PROTEIN KINASE FAMILY PROTEIN-RELATED', 239802),
(306839, 'PTHR47976:SF93', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306840, 'PTHR47976:SF12', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306841, 'PTHR47976:SF105', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306842, 'PTHR47976:SF56', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306843, 'PTHR47976:SF99', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306844, 'PTHR47976:SF11', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306845, 'PTHR47976:SF106', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239802),
(306846, 'PTHR47976:SF10', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306847, 'PTHR47976:SF107', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 239802),
(306848, 'PTHR47976:SF98', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306849, 'PTHR47976:SF97', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306850, 'PTHR47976:SF53', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(306851, 'PTHR47976:SF92', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306852, 'PTHR47976:SF91', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306853, 'PTHR47976:SF90', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306854, 'PTHR47976:SF49', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306855, 'PTHR47976:SF47', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306856, 'PTHR47976:SF46', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306857, 'PTHR47976:SF85', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306858, 'PTHR47976:SF41', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306859, 'PTHR47976:SF84', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306860, 'PTHR47976:SF82', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306861, 'PTHR47976:SF45', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306862, 'PTHR47976:SF89', NULL, NULL, NULL, NULL, 'G-TYPE LECTIN S-RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE LECRK3', 239802),
(306863, 'PTHR47976:SF44', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306864, 'PTHR47976:SF88', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306865, 'PTHR47976:SF87', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306866, 'PTHR47976:SF43', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306867, 'PTHR47976:SF86', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE, ULK1/ULK2-RELATED', 239802),
(306868, 'PTHR47976:SF42', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306869, 'PTHR47976', NULL, NULL, NULL, NULL, 'G-TYPE LECTIN S-RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE SD2-5', 239802),
(306870, 'PTHR47976:SF79', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306871, 'PTHR47976:SF35', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306872, 'PTHR47976:SF39', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306873, 'PTHR47976:SF30', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306874, 'PTHR47976:SF74', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306875, 'PTHR47976:SF78', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 239802),
(306876, 'PTHR47976:SF34', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN KINASE ZMPK1-RELATED', 239802),
(306877, 'PTHR47976:SF77', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306878, 'PTHR47976:SF4', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306879, 'PTHR47976:SF5', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306880, 'PTHR47976:SF2', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306881, 'PTHR47976:SF3', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239802),
(306882, 'PTHR47976:SF70', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306883, 'PTHR47976:SF1', NULL, NULL, NULL, NULL, 'G-TYPE LECTIN S-RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE SD2-5', 239802),
(306884, 'PTHR47976:SF27', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306885, 'PTHR47976:SF26', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306886, 'PTHR47976:SF25', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306887, 'PTHR47976:SF29', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(306888, 'PTHR47976:SF28', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306889, 'PTHR47976:SF63', NULL, NULL, NULL, NULL, 'TYROSINE KINASE FAMILY PROTEIN', 239802),
(306890, 'PTHR47976:SF62', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306891, 'PTHR47976:SF60', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 239802),
(306892, 'PTHR47976:SF8', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306893, 'PTHR47976:SF9', NULL, NULL, NULL, NULL, 'OS01G0113650 PROTEIN', 239802),
(306894, 'PTHR47976:SF66', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306895, 'PTHR47976:SF21', NULL, NULL, NULL, NULL, 'OS12G0130600 PROTEIN', 239802),
(306896, 'PTHR47976:SF6', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306897, 'PTHR47976:SF20', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306898, 'PTHR47976:SF64', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306899, 'PTHR47976:SF7', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239802),
(306900, 'PTHR46240', NULL, NULL, NULL, NULL, 'SER/THR PROTEIN KINASE ULK4', 239803),
(306901, 'PTHR46240:SF1', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE ULK4', 239803),
(306902, 'PTHR15375', NULL, NULL, NULL, NULL, 'ACTIVATOR OF S-PHASE KINASE-RELATED', 239804),
(306903, 'PTHR15375:SF22', NULL, NULL, NULL, NULL, 'PROTEIN DBF4 HOMOLOG A', 239804),
(306904, 'PTHR15375:SF26', NULL, NULL, NULL, NULL, 'PROTEIN CHIFFON', 239804),
(306905, 'PTHR15375:SF27', NULL, NULL, NULL, NULL, 'DBF4-TYPE DOMAIN-CONTAINING PROTEIN', 239804),
(306906, 'PTHR15375:SF24', NULL, NULL, NULL, NULL, 'PROTEIN DBF4 HOMOLOG B', 239804),
(306907, 'PTHR12515:SF9', NULL, NULL, NULL, NULL, 'PROTEIN SMAUG HOMOLOG 2', 239805),
(306908, 'PTHR12515:SF8', NULL, NULL, NULL, NULL, 'PROTEIN SMAUG HOMOLOG 1', 239805),
(306909, 'PTHR12515:SF5', NULL, NULL, NULL, NULL, 'PROTEIN SMAUG', 239805),
(306910, 'PTHR12515', NULL, NULL, NULL, NULL, 'STERILE ALPHA MOTIF DOMAIN CONTAINING PROTEIN 4-RELATED', 239805),
(306911, 'PTHR12190:SF1', NULL, NULL, NULL, NULL, 'DBIRD COMPLEX SUBUNIT ZNF326', 239806),
(306912, 'PTHR12190', NULL, NULL, NULL, NULL, 'A-KINASE ANCHOR PROTEIN  AKAP  8', 239806),
(306913, 'PTHR12190:SF6', NULL, NULL, NULL, NULL, 'A-KINASE ANCHOR PROTEIN 8', 239806),
(306914, 'PTHR12190:SF4', NULL, NULL, NULL, NULL, 'A-KINASE ANCHOR PROTEIN 8-LIKE', 239806),
(306915, 'PTHR24324:SF11', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 239807),
(306916, 'PTHR24324:SF5', NULL, NULL, NULL, NULL, 'HEMATOPOIETICALLY-EXPRESSED HOMEOBOX PROTEIN HHEX', 239807),
(306917, 'PTHR24324:SF9', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 239807),
(306918, 'PTHR24324', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HHEX', 239807),
(306919, 'PTHR24324:SF10', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN PHO2', 239807),
(306920, 'PTHR12686', NULL, NULL, NULL, NULL, '3''-5'' EXORIBONUCLEASE CSL4-RELATED', 239808),
(306921, 'PTHR12686:SF8', NULL, NULL, NULL, NULL, 'EXOSOME COMPLEX COMPONENT CSL4', 239808),
(306922, 'PTHR46137:SF12', NULL, NULL, NULL, NULL, 'LRAT DOMAIN-CONTAINING PROTEIN', 239809),
(306923, 'PTHR46137:SF11', NULL, NULL, NULL, NULL, 'NC DOMAIN-CONTAINING PROTEIN-RELATED', 239809),
(306924, 'PTHR46137:SF14', NULL, NULL, NULL, NULL, 'LRAT DOMAIN-CONTAINING PROTEIN', 239809),
(306925, 'PTHR46137:SF13', NULL, NULL, NULL, NULL, 'LRAT DOMAIN-CONTAINING PROTEIN', 239809),
(306926, 'PTHR46137:SF9', NULL, NULL, NULL, NULL, 'NC DOMAIN-CONTAINING PROTEIN-LIKE PROTEIN', 239809),
(306927, 'PTHR46137:SF16', NULL, NULL, NULL, NULL, 'LRAT DOMAIN-CONTAINING PROTEIN', 239809),
(306928, 'PTHR46137:SF15', NULL, NULL, NULL, NULL, 'LRAT DOMAIN-CONTAINING PROTEIN', 239809),
(306929, 'PTHR46137:SF17', NULL, NULL, NULL, NULL, 'LRAT DOMAIN-CONTAINING PROTEIN', 239809),
(306930, 'PTHR46137', NULL, NULL, NULL, NULL, 'OS05G0310600 PROTEIN', 239809);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(306931, 'PTHR46137:SF10', NULL, NULL, NULL, NULL, 'LRAT DOMAIN-CONTAINING PROTEIN', 239809),
(306932, 'PTHR46137:SF19', NULL, NULL, NULL, NULL, 'GB|AAF32477.1', 239809),
(306933, 'PTHR46137:SF4', NULL, NULL, NULL, NULL, 'PROTEIN LEAD-SENSITIVE 1', 239809),
(306934, 'PTHR46137:SF7', NULL, NULL, NULL, NULL, 'LRAT DOMAIN-CONTAINING PROTEIN', 239809),
(306935, 'PTHR46137:SF1', NULL, NULL, NULL, NULL, 'NC DOMAIN-CONTAINING PROTEIN-RELATED', 239809),
(306936, 'PTHR46137:SF3', NULL, NULL, NULL, NULL, 'OS05G0310600 PROTEIN', 239809),
(306937, 'PTHR46137:SF2', NULL, NULL, NULL, NULL, 'OS09G0526800 PROTEIN', 239809),
(306938, 'PTHR43069:SF5', NULL, NULL, NULL, NULL, 'FUMARYLACETOACETASE', 239810),
(306939, 'PTHR43069:SF6', NULL, NULL, NULL, NULL, 'FUMARYLACETOACETASE', 239810),
(306940, 'PTHR43069:SF2', NULL, NULL, NULL, NULL, 'FUMARYLACETOACETASE', 239810),
(306941, 'PTHR43069', NULL, NULL, NULL, NULL, 'FUMARYLACETOACETASE', 239810),
(306942, 'PTHR12487:SF7', NULL, NULL, NULL, NULL, 'PROTEIN TEASHIRT-RELATED', 239811),
(306943, 'PTHR12487:SF5', NULL, NULL, NULL, NULL, 'TEASHIRT HOMOLOG 3', 239811),
(306944, 'PTHR12487:SF6', NULL, NULL, NULL, NULL, 'TEASHIRT HOMOLOG 1', 239811),
(306945, 'PTHR12487:SF3', NULL, NULL, NULL, NULL, 'TEASHIRT HOMOLOG 2', 239811),
(306946, 'PTHR12487', NULL, NULL, NULL, NULL, 'TEASHIRT-RELATED', 239811),
(306947, 'PTHR10774:SF194', NULL, NULL, NULL, NULL, 'C2 DOMAIN, SYNAPTOTAGMIN-LIKE MITOCHONDRIAL-LIPID-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 239812),
(306948, 'PTHR10774:SF182', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN-4-LIKE', 239812),
(306949, 'PTHR10774:SF190', NULL, NULL, NULL, NULL, 'C2 CALCIUM/LIPID-BINDING ENDONUCLEASE/EXONUCLEASE/PHOSPHATASE-RELATED', 239812),
(306950, 'PTHR10774:SF203', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN-5', 239812),
(306951, 'PTHR10774:SF214', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT LIPID-BINDING (CALB DOMAIN) FAMILY PROTEIN-RELATED', 239812),
(306952, 'PTHR10774:SF201', NULL, NULL, NULL, NULL, 'BNAC04G21980D PROTEIN', 239812),
(306953, 'PTHR10774:SF178', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN-4', 239812),
(306954, 'PTHR10774:SF200', NULL, NULL, NULL, NULL, 'BNAA08G31160D PROTEIN', 239812),
(306955, 'PTHR10774:SF189', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN-4-LIKE', 239812),
(306956, 'PTHR10774:SF199', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN-RELATED', 239812),
(306957, 'PTHR10774:SF188', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN-2', 239812),
(306958, 'PTHR10774:SF174', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT LIPID-BINDING (CALB DOMAIN) FAMILY PROTEIN', 239812),
(306959, 'PTHR10774:SF62', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN-3', 239812),
(306960, 'PTHR10774:SF207', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT LIPID-BINDING PROTEIN', 239812),
(306961, 'PTHR10774:SF217', NULL, NULL, NULL, NULL, 'OS06G0685300 PROTEIN', 239812),
(306962, 'PTHR10774:SF206', NULL, NULL, NULL, NULL, 'C2 DOMAIN, SYNAPTOTAGMIN-LIKE MITOCHONDRIAL-LIPID-BINDING DOMAIN PROTEIN-RELATED', 239812),
(306963, 'PTHR10774:SF216', NULL, NULL, NULL, NULL, 'OS09G0538800 PROTEIN', 239812),
(306964, 'PTHR10774:SF149', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN-5', 239812),
(306965, 'PTHR10774:SF215', NULL, NULL, NULL, NULL, 'BNAA08G28270D PROTEIN', 239812),
(306966, 'PTHR10774:SF204', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN-5-LIKE', 239812),
(306967, 'PTHR10774', NULL, NULL, NULL, NULL, 'EXTENDED SYNAPTOTAGMIN-RELATED', 239812),
(306968, 'PTHR37371', NULL, NULL, NULL, NULL, 'OS08G0180400 PROTEIN', 239813),
(306969, 'PTHR37371:SF1', NULL, NULL, NULL, NULL, 'OS07G0452600 PROTEIN', 239813),
(306970, 'PTHR37371:SF6', NULL, NULL, NULL, NULL, '', 239813),
(306971, 'PTHR37371:SF7', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 239813),
(306972, 'PTHR46354:SF2', NULL, NULL, NULL, NULL, 'PROTEIN DOG1-LIKE 4', 239814),
(306973, 'PTHR46354:SF1', NULL, NULL, NULL, NULL, 'PROTEIN RESPONSE TO ABA AND SALT 1-RELATED', 239814),
(306974, 'PTHR46354:SF4', NULL, NULL, NULL, NULL, 'DOG1 DOMAIN-CONTAINING PROTEIN', 239814),
(306975, 'PTHR46354:SF16', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TGA1-LIKE', 239814);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(306976, 'PTHR46354:SF27', NULL, NULL, NULL, NULL, 'DOG1 DOMAIN-CONTAINING PROTEIN', 239814),
(306977, 'PTHR46354:SF19', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TGA6-LIKE', 239814),
(306978, 'PTHR46354', NULL, NULL, NULL, NULL, 'DOG1 DOMAIN-CONTAINING PROTEIN', 239814),
(306979, 'PTHR46354:SF8', NULL, NULL, NULL, NULL, 'DOG1 DOMAIN-CONTAINING PROTEIN', 239814),
(306980, 'PTHR46354:SF7', NULL, NULL, NULL, NULL, 'PROTEIN DOG1-LIKE 1', 239814),
(306981, 'PTHR46354:SF9', NULL, NULL, NULL, NULL, 'PROTEIN INAPERTURATE POLLEN1', 239814),
(306982, 'PTHR46354:SF20', NULL, NULL, NULL, NULL, 'DOG1 DOMAIN-CONTAINING PROTEIN', 239814),
(306983, 'PTHR46354:SF11', NULL, NULL, NULL, NULL, 'PROTEIN DOG1-LIKE 2-RELATED', 239814),
(306984, 'PTHR46354:SF22', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TGA LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 239814),
(306985, 'PTHR46354:SF21', NULL, NULL, NULL, NULL, 'DOG1 DOMAIN-CONTAINING PROTEIN', 239814),
(306986, 'PTHR46354:SF10', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TGA LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 239814),
(306987, 'PTHR46354:SF24', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TGA3-LIKE', 239814),
(306988, 'PTHR46354:SF13', NULL, NULL, NULL, NULL, 'DOG1 DOMAIN-CONTAINING PROTEIN', 239814),
(306989, 'PTHR46354:SF23', NULL, NULL, NULL, NULL, 'DOG1 DOMAIN-CONTAINING PROTEIN', 239814),
(306990, 'PTHR46354:SF12', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN-LIKE PROTEIN', 239814),
(306991, 'PTHR46354:SF26', NULL, NULL, NULL, NULL, 'DOG1 DOMAIN-CONTAINING PROTEIN', 239814),
(306992, 'PTHR46354:SF15', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TGA6-LIKE', 239814),
(306993, 'PTHR46354:SF14', NULL, NULL, NULL, NULL, 'PROTEIN DELAY OF GERMINATION 1', 239814),
(306994, 'PTHR46354:SF25', NULL, NULL, NULL, NULL, 'RESPONSE TO ABA AND SALT 1', 239814),
(306995, 'PTHR22980:SF5', NULL, NULL, NULL, NULL, 'CENP-T_C DOMAIN-CONTAINING PROTEIN', 239815),
(306996, 'PTHR22980', NULL, NULL, NULL, NULL, 'CORTISTATIN', 239815),
(306997, 'PTHR22980:SF0', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN S', 239815),
(306998, 'PTHR38471:SF2', NULL, NULL, NULL, NULL, '', 239816),
(306999, 'PTHR38471', NULL, NULL, NULL, NULL, '', 239816),
(307000, 'PTHR43375', NULL, NULL, NULL, NULL, 'OROTIDINE 5''-PHOSPHATE DECARBOXYLASE', 239817),
(307001, 'PTHR43375:SF1', NULL, NULL, NULL, NULL, 'OROTIDINE 5''-PHOSPHATE DECARBOXYLASE', 239817),
(307002, 'PTHR24015:SF2006', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 239818),
(307003, 'PTHR24015:SF1951', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN MITOCHONDRIAL', 239818),
(307004, 'PTHR24015:SF1832', NULL, NULL, NULL, NULL, 'OS03G0241800 PROTEIN', 239818),
(307005, 'PTHR24015:SF1799', NULL, NULL, NULL, NULL, 'OS05G0581300 PROTEIN', 239818),
(307006, 'PTHR24015:SF1710', NULL, NULL, NULL, NULL, 'OS01G0764950 PROTEIN', 239818),
(307007, 'PTHR24015:SF1672', NULL, NULL, NULL, NULL, 'OS06G0506100 PROTEIN', 239818),
(307008, 'PTHR24015:SF1793', NULL, NULL, NULL, NULL, 'OS11G0109800 PROTEIN', 239818),
(307009, 'PTHR24015:SF1795', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 239818),
(307010, 'PTHR24015:SF2000', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 239818),
(307011, 'PTHR24015:SF550', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 239818),
(307012, 'PTHR24015:SF156', NULL, NULL, NULL, NULL, 'OS05G0574800 PROTEIN', 239818),
(307013, 'PTHR24015:SF553', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 239818),
(307014, 'PTHR24015:SF1958', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 239818),
(307015, 'PTHR24015:SF398', NULL, NULL, NULL, NULL, 'OS07G0259400 PROTEIN', 239818),
(307016, 'PTHR24015:SF1713', NULL, NULL, NULL, NULL, 'REPEAT SUPERFAMILY PROTEIN, PUTATIVE-RELATED', 239818),
(307017, 'PTHR24015:SF1955', NULL, NULL, NULL, NULL, '', 239818),
(307018, 'PTHR24015:SF679', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT-LIKE SUPERFAMILY PROTEIN', 239818),
(307019, 'PTHR24015:SF1954', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 239818);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(307020, 'PTHR24015:SF1956', NULL, NULL, NULL, NULL, 'OS03G0816600 PROTEIN', 239818),
(307021, 'PTHR24015:SF2017', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 239818),
(307022, 'PTHR24015:SF1687', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE (PPR) REPEAT PROTEIN', 239818),
(307023, 'PTHR24015:SF2016', NULL, NULL, NULL, NULL, '', 239818),
(307024, 'PTHR24015:SF548', NULL, NULL, NULL, NULL, 'OS08G0340900 PROTEIN', 239818),
(307025, 'PTHR24015:SF2019', NULL, NULL, NULL, NULL, 'OS11G0482400 PROTEIN', 239818),
(307026, 'PTHR24015:SF2018', NULL, NULL, NULL, NULL, '', 239818),
(307027, 'PTHR24015:SF2013', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN103', 239818),
(307028, 'PTHR24015:SF2012', NULL, NULL, NULL, NULL, '', 239818),
(307029, 'PTHR24015:SF1685', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 239818),
(307030, 'PTHR24015:SF2015', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 239818),
(307031, 'PTHR24015:SF2014', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 239818),
(307032, 'PTHR24015:SF2010', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 239818),
(307033, 'PTHR24015:SF96', NULL, NULL, NULL, NULL, 'OS01G0848300 PROTEIN', 239818),
(307034, 'PTHR24015:SF97', NULL, NULL, NULL, NULL, 'OS03G0235200 PROTEIN', 239818),
(307035, 'PTHR24015:SF260', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 239818),
(307036, 'PTHR24015:SF1849', NULL, NULL, NULL, NULL, 'OS03G0158900 PROTEIN', 239818),
(307037, 'PTHR24015:SF388', NULL, NULL, NULL, NULL, 'OS02G0680500 PROTEIN', 239818),
(307038, 'PTHR24015:SF1728', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN DOT4, CHLOROPLASTIC-LIKE', 239818),
(307039, 'PTHR24015:SF1969', NULL, NULL, NULL, NULL, 'OS08G0112400 PROTEIN', 239818),
(307040, 'PTHR24015:SF1603', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 239818),
(307041, 'PTHR24015:SF1844', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 239818),
(307042, 'PTHR24015:SF1726', NULL, NULL, NULL, NULL, 'OS03G0861900 PROTEIN', 239818),
(307043, 'PTHR24015:SF423', NULL, NULL, NULL, NULL, 'OS02G0106300 PROTEIN', 239818),
(307044, 'PTHR24015:SF424', NULL, NULL, NULL, NULL, 'OS09G0327200 PROTEIN', 239818),
(307045, 'PTHR24015:SF1725', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 239818),
(307046, 'PTHR24015:SF1774', NULL, NULL, NULL, NULL, 'OS09G0251500 PROTEIN', 239818),
(307047, 'PTHR24015:SF1653', NULL, NULL, NULL, NULL, 'OS06G0694300 PROTEIN', 239818),
(307048, 'PTHR24015:SF1771', NULL, NULL, NULL, NULL, 'OS08G0162200 PROTEIN', 239818),
(307049, 'PTHR24015:SF1892', NULL, NULL, NULL, NULL, 'OS04G0118700 PROTEIN', 239818),
(307050, 'PTHR24015:SF1770', NULL, NULL, NULL, NULL, 'OS05G0153400 PROTEIN', 239818),
(307051, 'PTHR24015:SF1773', NULL, NULL, NULL, NULL, 'OS01G0101150 PROTEIN', 239818),
(307052, 'PTHR24015:SF1013', NULL, NULL, NULL, NULL, 'OS03G0775400 PROTEIN', 239818),
(307053, 'PTHR24015', NULL, NULL, NULL, NULL, 'OS07G0578800 PROTEIN-RELATED', 239818),
(307054, 'PTHR24015:SF1938', NULL, NULL, NULL, NULL, 'OS11G0158300 PROTEIN', 239818),
(307055, 'PTHR24015:SF1933', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 239818),
(307056, 'PTHR24015:SF1812', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE (PPR) REPEAT PROTEIN', 239818),
(307057, 'PTHR24015:SF898', NULL, NULL, NULL, NULL, 'OS07G0436600 PROTEIN', 239818),
(307058, 'PTHR24015:SF811', NULL, NULL, NULL, NULL, 'OS01G0959600 PROTEIN', 239818),
(307059, 'PTHR24015:SF379', NULL, NULL, NULL, NULL, 'OS11G0433101 PROTEIN', 239818),
(307060, 'PTHR24015:SF1935', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 239818),
(307061, 'PTHR24015:SF1814', NULL, NULL, NULL, NULL, 'OS11G0583200 PROTEIN', 239818),
(307062, 'PTHR24015:SF1934', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 239818),
(307063, 'PTHR24015:SF930', NULL, NULL, NULL, NULL, 'DUF1664 DOMAIN-CONTAINING PROTEIN', 239818);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(307064, 'PTHR24015:SF526', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 239818),
(307065, 'PTHR24015:SF1700', NULL, NULL, NULL, NULL, 'OS03G0844000 PROTEIN', 239818),
(307066, 'PTHR24015:SF1780', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 239818),
(307067, 'PTHR24015:SF72', NULL, NULL, NULL, NULL, 'OS04G0436800 PROTEIN', 239818),
(307068, 'PTHR24015:SF1709', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 239818),
(307069, 'PTHR24015:SF524', NULL, NULL, NULL, NULL, 'OS07G0670000 PROTEIN', 239818),
(307070, 'PTHR24015:SF1943', NULL, NULL, NULL, NULL, 'OS04G0414800 PROTEIN', 239818),
(307071, 'PTHR24015:SF1825', NULL, NULL, NULL, NULL, 'OS04G0514500 PROTEIN', 239818),
(307072, 'PTHR24015:SF1703', NULL, NULL, NULL, NULL, 'OS12G0289800 PROTEIN', 239818),
(307073, 'PTHR24015:SF1824', NULL, NULL, NULL, NULL, 'OS11G0275400 PROTEIN', 239818),
(307074, 'PTHR24015:SF1753', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 239818),
(307075, 'PTHR24015:SF517', NULL, NULL, NULL, NULL, 'OS11G0256100 PROTEIN', 239818),
(307076, 'PTHR24015:SF1752', NULL, NULL, NULL, NULL, 'OS08G0375800 PROTEIN', 239818),
(307077, 'PTHR24015:SF878', NULL, NULL, NULL, NULL, 'OS09G0413300 PROTEIN', 239818),
(307078, 'PTHR24015:SF1991', NULL, NULL, NULL, NULL, 'OS01G0938000 PROTEIN', 239818),
(307079, 'PTHR24015:SF1993', NULL, NULL, NULL, NULL, 'REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN, PUTATIVE ISOFORM 1-RELATED', 239818),
(307080, 'PTHR24015:SF1992', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 239818),
(307081, 'PTHR24015:SF1919', NULL, NULL, NULL, NULL, '', 239818),
(307082, 'PTHR24015:SF1915', NULL, NULL, NULL, NULL, 'OS03G0582100 PROTEIN', 239818),
(307083, 'PTHR24015:SF356', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 239818),
(307084, 'PTHR24015:SF1917', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 239818),
(307085, 'PTHR24015:SF47', NULL, NULL, NULL, NULL, 'OS01G0374200 PROTEIN', 239818),
(307086, 'PTHR24015:SF48', NULL, NULL, NULL, NULL, 'OS09G0520300 PROTEIN', 239818),
(307087, 'PTHR24015:SF755', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN CHLOROPLASTIC', 239818),
(307088, 'PTHR24015:SF116', NULL, NULL, NULL, NULL, 'OS04G0602600 PROTEIN', 239818),
(307089, 'PTHR24015:SF1878', NULL, NULL, NULL, NULL, '', 239818),
(307090, 'PTHR24015:SF1910', NULL, NULL, NULL, NULL, 'PPR REPEAT PROTEIN', 239818),
(307091, 'PTHR24015:SF46', NULL, NULL, NULL, NULL, 'OS12G0181900 PROTEIN', 239818),
(307092, 'PTHR24015:SF635', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 239818),
(307093, 'PTHR24015:SF511', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN DOT4, CHLOROPLASTIC-LIKE', 239818),
(307094, 'PTHR24015:SF1758', NULL, NULL, NULL, NULL, 'OS02G0290000 PROTEIN', 239818),
(307095, 'PTHR24015:SF1885', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 239818),
(307096, 'PTHR24015:SF1764', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 239818),
(307097, 'PTHR24015:SF1920', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 239818),
(307098, 'PTHR24015:SF505', NULL, NULL, NULL, NULL, 'OS01G0819800 PROTEIN', 239818),
(307099, 'PTHR24015:SF1886', NULL, NULL, NULL, NULL, 'OS03G0781100 PROTEIN', 239818),
(307100, 'PTHR24015:SF1880', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 239818),
(307101, 'PTHR24015:SF908', NULL, NULL, NULL, NULL, 'OS10G0540100 PROTEIN', 239818),
(307102, 'PTHR24015:SF583', NULL, NULL, NULL, NULL, 'OS03G0849700 PROTEIN', 239818),
(307103, 'PTHR24015:SF344', NULL, NULL, NULL, NULL, 'OS07G0203900 PROTEIN', 239818),
(307104, 'PTHR24015:SF1805', NULL, NULL, NULL, NULL, '', 239818),
(307105, 'PTHR24015:SF502', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 239818),
(307106, 'PTHR24015:SF1922', NULL, NULL, NULL, NULL, 'OS07G0239600 PROTEIN', 239818),
(307107, 'PTHR24015:SF1801', NULL, NULL, NULL, NULL, 'OS01G0737900 PROTEIN', 239818);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(307108, 'PTHR24015:SF1767', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 239818),
(307109, 'PTHR24015:SF1924', NULL, NULL, NULL, NULL, 'OS03G0317100 PROTEIN', 239818),
(307110, 'PTHR24015:SF742', NULL, NULL, NULL, NULL, 'OS05G0112900 PROTEIN', 239818),
(307111, 'PTHR24015:SF622', NULL, NULL, NULL, NULL, 'OS02G0833050 PROTEIN', 239818),
(307112, 'PTHR24015:SF1923', NULL, NULL, NULL, NULL, 'OS03G0624800 PROTEIN', 239818),
(307113, 'PTHR24015:SF2028', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 239818),
(307114, 'PTHR24015:SF1973', NULL, NULL, NULL, NULL, 'OS11G0213500 PROTEIN', 239818),
(307115, 'PTHR24015:SF858', NULL, NULL, NULL, NULL, 'OS03G0852000 PROTEIN', 239818),
(307116, 'PTHR24015:SF1972', NULL, NULL, NULL, NULL, 'OS06G0228900 PROTEIN', 239818),
(307117, 'PTHR24015:SF1730', NULL, NULL, NULL, NULL, 'OS01G0880900 PROTEIN', 239818),
(307118, 'PTHR24015:SF2027', NULL, NULL, NULL, NULL, '', 239818),
(307119, 'PTHR24015:SF339', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 239818),
(307120, 'PTHR24015:SF1854', NULL, NULL, NULL, NULL, 'OS07G0578800 PROTEIN', 239818),
(307121, 'PTHR24015:SF856', NULL, NULL, NULL, NULL, 'OS01G0299200 PROTEIN', 239818),
(307122, 'PTHR24015:SF2029', NULL, NULL, NULL, NULL, '', 239818),
(307123, 'PTHR24015:SF1853', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 239818),
(307124, 'PTHR24015:SF2024', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 239818),
(307125, 'PTHR24015:SF2023', NULL, NULL, NULL, NULL, 'OS03G0185200 PROTEIN', 239818),
(307126, 'PTHR24015:SF1693', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 239818),
(307127, 'PTHR24015:SF2026', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 239818),
(307128, 'PTHR24015:SF739', NULL, NULL, NULL, NULL, 'OS03G0644200 PROTEIN', 239818),
(307129, 'PTHR24015:SF2025', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 239818),
(307130, 'PTHR24015:SF1695', NULL, NULL, NULL, NULL, 'OS06G0185800 PROTEIN', 239818),
(307131, 'PTHR24015:SF2020', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE (PPR) REPEAT PROTEIN', 239818),
(307132, 'PTHR24015:SF2022', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN CHLOROPLASTIC', 239818),
(307133, 'PTHR24015:SF2021', NULL, NULL, NULL, NULL, '', 239818),
(307134, 'PTHR24015:SF297', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 239818),
(307135, 'PTHR24015:SF334', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 239818),
(307136, 'PTHR24015:SF1856', NULL, NULL, NULL, NULL, 'OS05G0455900 PROTEIN', 239818),
(307137, 'PTHR24015:SF1978', NULL, NULL, NULL, NULL, 'OS02G0769900 PROTEIN', 239818),
(307138, 'PTHR24015:SF1862', NULL, NULL, NULL, NULL, 'OS01G0357800 PROTEIN', 239818),
(307139, 'PTHR24015:SF328', NULL, NULL, NULL, NULL, 'OS06G0611200 PROTEIN', 239818),
(307140, 'PTHR24015:SF1865', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 239818),
(307141, 'PTHR24015:SF1985', NULL, NULL, NULL, NULL, 'OS09G0555400 PROTEIN', 239818),
(307142, 'PTHR24015:SF2034', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN-RELATED', 239818),
(307143, 'PTHR24015:SF1740', NULL, NULL, NULL, NULL, 'OS03G0435200 PROTEIN', 239818),
(307144, 'PTHR24015:SF1981', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN, DYW DOMAIN PROTEIN-RELATED', 239818),
(307145, 'PTHR24015:SF1063', NULL, NULL, NULL, NULL, 'OS12G0156900 PROTEIN', 239818),
(307146, 'PTHR24015:SF2031', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 239818),
(307147, 'PTHR24015:SF2030', NULL, NULL, NULL, NULL, 'OS07G0244400 PROTEIN', 239818),
(307148, 'PTHR24015:SF2033', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 239818),
(307149, 'PTHR24015:SF2032', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT PROTEIN', 239818),
(307150, 'PTHR24015:SF285', NULL, NULL, NULL, NULL, 'OS07G0588100 PROTEIN', 239818),
(307151, 'PTHR24015:SF1909', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 239818); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(307152, 'PTHR24015:SF960', NULL, NULL, NULL, NULL, 'OS08G0481000 PROTEIN', 239818),
(307153, 'PTHR24015:SF1903', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 239818),
(307154, 'PTHR24015:SF563', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 239818),
(307155, 'PTHR24015:SF1900', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 239818),
(307156, 'PTHR24015:SF1745', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 239818),
(307157, 'PTHR24015:SF1868', NULL, NULL, NULL, NULL, 'OS12G0490100 PROTEIN', 239818),
(307158, 'PTHR46099', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 239819),
(307159, 'PTHR46099:SF2', NULL, NULL, NULL, NULL, 'ENDOTHELIN-1 RECEPTOR', 239819),
(307160, 'PTHR46099:SF1', NULL, NULL, NULL, NULL, '', 239819),
(307161, 'PTHR46099:SF4', NULL, NULL, NULL, NULL, 'ENDOTHELIN RECEPTOR NON-SELECTIVE TYPE', 239819),
(307162, 'PTHR46099:SF3', NULL, NULL, NULL, NULL, 'ENDOTHELIN RECEPTOR TYPE B', 239819),
(307163, 'PTHR33426', NULL, NULL, NULL, NULL, '', 239820),
(307164, 'PTHR33426:SF29', NULL, NULL, NULL, NULL, '', 239820),
(307165, 'PTHR33426:SF27', NULL, NULL, NULL, NULL, '', 239820),
(307166, 'PTHR33426:SF33', NULL, NULL, NULL, NULL, '', 239820),
(307167, 'PTHR33426:SF32', NULL, NULL, NULL, NULL, '', 239820),
(307168, 'PTHR33426:SF30', NULL, NULL, NULL, NULL, '', 239820),
(307169, 'PTHR33426:SF26', NULL, NULL, NULL, NULL, '', 239820),
(307170, 'PTHR33426:SF36', NULL, NULL, NULL, NULL, '', 239820),
(307171, 'PTHR33426:SF35', NULL, NULL, NULL, NULL, '', 239820),
(307172, 'PTHR33426:SF24', NULL, NULL, NULL, NULL, '', 239820),
(307173, 'PTHR33426:SF23', NULL, NULL, NULL, NULL, '', 239820),
(307174, 'PTHR33426:SF34', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 697', 239820),
(307175, 'PTHR10454:SF31', NULL, NULL, NULL, NULL, 'CASPASE-7', 239821),
(307176, 'PTHR10454:SF206', NULL, NULL, NULL, NULL, 'CASPASE-6', 239821),
(307177, 'PTHR10454:SF239', NULL, NULL, NULL, NULL, 'CASP8 AND FADD-LIKE APOPTOSIS REGULATOR', 239821),
(307178, 'PTHR10454:SF26', NULL, NULL, NULL, NULL, 'CASPASE-10', 239821),
(307179, 'PTHR10454:SF13', NULL, NULL, NULL, NULL, 'CASPASE-4', 239821),
(307180, 'PTHR10454:SF240', NULL, NULL, NULL, NULL, 'CASPASE 20, APOPTOSIS-RELATED CYSTEINE PEPTIDASE-RELATED', 239821),
(307181, 'PTHR10454:SF196', NULL, NULL, NULL, NULL, 'CASPASE_P20 DOMAIN-CONTAINING PROTEIN', 239821),
(307182, 'PTHR10454:SF162', NULL, NULL, NULL, NULL, 'CASPASE-8', 239821),
(307183, 'PTHR10454:SF151', NULL, NULL, NULL, NULL, 'CASPASE-2', 239821),
(307184, 'PTHR10454:SF226', NULL, NULL, NULL, NULL, 'CASPASE NC-LIKE PROTEIN', 239821),
(307185, 'PTHR10454', NULL, NULL, NULL, NULL, 'CASPASE', 239821),
(307186, 'PTHR10454:SF157', NULL, NULL, NULL, NULL, 'CASPASE-9', 239821),
(307187, 'PTHR10454:SF234', NULL, NULL, NULL, NULL, 'CASPASE 10, APOPTOSIS-RELATED CYSTEINE PEPTIDASE', 239821),
(307188, 'PTHR10454:SF134', NULL, NULL, NULL, NULL, 'INACTIVE CASPASE-12', 239821),
(307189, 'PTHR10454:SF155', NULL, NULL, NULL, NULL, 'CASPASE-14-LIKE', 239821),
(307190, 'PTHR10454:SF210', NULL, NULL, NULL, NULL, 'CASPASE-8', 239821),
(307191, 'PTHR10454:SF199', NULL, NULL, NULL, NULL, 'CASPASE-17/A', 239821),
(307192, 'PTHR10454:SF243', NULL, NULL, NULL, NULL, 'CASPASE-5', 239821),
(307193, 'PTHR10454:SF232', NULL, NULL, NULL, NULL, 'CASPASE-RELATED', 239821),
(307194, 'PTHR10454:SF220', NULL, NULL, NULL, NULL, 'FIIND DOMAIN-CONTAINING PROTEIN', 239821),
(307195, 'PTHR10454:SF198', NULL, NULL, NULL, NULL, 'CASPASE-3', 239821),
(307196, 'PTHR10454:SF242', NULL, NULL, NULL, NULL, 'AT03047P-RELATED', 239821),
(307197, 'PTHR10454:SF131', NULL, NULL, NULL, NULL, 'CASPASE-14', 239821),
(307198, 'PTHR10454:SF241', NULL, NULL, NULL, NULL, 'CASPASE-18/A', 239821),
(307199, 'PTHR11454:SF24', NULL, NULL, NULL, NULL, 'INSULIN-1', 239822),
(307200, 'PTHR11454:SF9', NULL, NULL, NULL, NULL, 'INSULIN', 239822),
(307201, 'PTHR11454', NULL, NULL, NULL, NULL, 'INSULIN/INSULIN GROWTH FACTOR', 239822),
(307202, 'PTHR11454:SF32', NULL, NULL, NULL, NULL, 'INSULIN, ISOFORM 2', 239822); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(307203, 'PTHR45903', NULL, NULL, NULL, NULL, 'GLUTAMATE-RICH WD REPEAT-CONTAINING PROTEIN 1', 239823),
(307204, 'PTHR45903:SF2', NULL, NULL, NULL, NULL, 'BNAA07G09700D PROTEIN', 239823),
(307205, 'PTHR45903:SF1', NULL, NULL, NULL, NULL, 'GLUTAMATE-RICH WD REPEAT-CONTAINING PROTEIN 1', 239823),
(307206, 'PTHR36387:SF2', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLMURAMOYL-L-ALANYL-D-GLUTAMATE-2, 6-DIAMINOPIMELATE LIGASE', 239824),
(307207, 'PTHR36387', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLMURAMOYL-L-ALANYL-D-GLUTAMATE-2, 6-DIAMINOPIMELATE LIGASE', 239824),
(307208, 'PTHR10884:SF16', NULL, NULL, NULL, NULL, 'COMPLEX I-30KD', 239825),
(307209, 'PTHR10884:SF15', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] IRON-SULFUR PROTEIN 3, MITOCHONDRIAL', 239825),
(307210, 'PTHR10884:SF14', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] IRON-SULFUR PROTEIN 3, MITOCHONDRIAL', 239825),
(307211, 'PTHR10884', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE  UBIQUINONE  IRON-SULFUR PROTEIN 3', 239825),
(307212, 'PTHR31755', NULL, NULL, NULL, NULL, 'FOLATE RECEPTOR-LIKE', 239826),
(307213, 'PTHR31755:SF2', NULL, NULL, NULL, NULL, 'OS08G0320800 PROTEIN', 239826),
(307214, 'PTHR31755:SF3', NULL, NULL, NULL, NULL, 'PLANT/F7F23-4 PROTEIN', 239826),
(307215, 'PTHR28122', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SUBSTRATE RECEPTOR MMS22', 239827),
(307216, 'PTHR28122:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SUBSTRATE RECEPTOR MMS22', 239827),
(307217, 'PTHR34806:SF8', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY NITRATE TRANSPORTER', 239828),
(307218, 'PTHR34806', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY NITRATE TRANSPORTER 3.2', 239828),
(307219, 'PTHR34806:SF14', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY NITRATE TRANSPORTER', 239828),
(307220, 'PTHR34806:SF6', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY NITRATE TRANSPORTER', 239828),
(307221, 'PTHR34806:SF7', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY NITRATE TRANSPORTER', 239828),
(307222, 'PTHR34806:SF13', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY NITRATE TRANSPORTER 3.2', 239828),
(307223, 'PTHR34806:SF4', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY NITRATE TRANSPORTER-ACTIVATING PROTEIN 2.2-RELATED', 239828),
(307224, 'PTHR34806:SF11', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY NITRATE TRANSPORTER-RELATED', 239828),
(307225, 'PTHR34806:SF10', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY NITRATE TRANSPORTER', 239828),
(307226, 'PTHR34806:SF1', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY NITRATE TRANSPORTER 3.1', 239828),
(307227, 'PTHR43129', NULL, NULL, NULL, NULL, 'FOSMIDOMYCIN RESISTANCE PROTEIN', 239829),
(307228, 'PTHR43129:SF1', NULL, NULL, NULL, NULL, 'FOSMIDOMYCIN RESISTANCE PROTEIN', 239829),
(307229, 'PTHR34874:SF1', NULL, NULL, NULL, NULL, 'PROTEIN YCHN', 239830),
(307230, 'PTHR34874', NULL, NULL, NULL, NULL, 'PROTEIN YCHN', 239830),
(307231, 'PTHR34874:SF3', NULL, NULL, NULL, NULL, 'SULFURTRANSFERASE TUSD', 239830),
(307232, 'PTHR13806:SF45', NULL, NULL, NULL, NULL, 'FLOTILLIN-LIKE', 239831),
(307233, 'PTHR13806:SF34', NULL, NULL, NULL, NULL, 'FLOTILLIN-LIKE', 239831),
(307234, 'PTHR13806:SF23', NULL, NULL, NULL, NULL, 'FLOTILLIN-LIKE PROTEIN 2', 239831),
(307235, 'PTHR13806:SF46', NULL, NULL, NULL, NULL, 'FLOTILLIN-1-RELATED', 239831),
(307236, 'PTHR13806:SF36', NULL, NULL, NULL, NULL, 'FLOTILLIN-LIKE', 239831),
(307237, 'PTHR13806:SF37', NULL, NULL, NULL, NULL, 'FLOTILLIN-LIKE', 239831),
(307238, 'PTHR13806:SF38', NULL, NULL, NULL, NULL, 'FLOTILLIN-LIKE PROTEIN 3', 239831),
(307239, 'PTHR13806', NULL, NULL, NULL, NULL, 'FLOTILLIN-RELATED', 239831),
(307240, 'PTHR13806:SF40', NULL, NULL, NULL, NULL, 'FLOTILLIN-LIKE', 239831),
(307241, 'PTHR13806:SF42', NULL, NULL, NULL, NULL, 'FLOTILLIN-LIKE', 239831),
(307242, 'PTHR13806:SF31', NULL, NULL, NULL, NULL, 'FLOTILLIN-LIKE PROTEIN 1-RELATED', 239831),
(307243, 'PTHR13806:SF32', NULL, NULL, NULL, NULL, 'FLOTILLIN', 239831),
(307244, 'PTHR13806:SF33', NULL, NULL, NULL, NULL, 'FLOTILLIN', 239831),
(307245, 'PTHR21682:SF2', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 149', 239832),
(307246, 'PTHR21682', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239832);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(307247, 'PTHR32022:SF10', NULL, NULL, NULL, NULL, 'D-GLUTAMATE CYCLASE, MITOCHONDRIAL', 239833),
(307248, 'PTHR32022', NULL, NULL, NULL, NULL, 'D-GLUTAMATE CYCLASE, MITOCHONDRIAL', 239833),
(307249, 'PTHR18939:SF4', NULL, NULL, NULL, NULL, 'RIBOSOME-BINDING PROTEIN 1', 239834),
(307250, 'PTHR18939', NULL, NULL, NULL, NULL, 'RIBOSOME BINDING PROTEIN-1', 239834),
(307251, 'PTHR21368:SF25', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L9, CHLOROPLASTIC', 239835),
(307252, 'PTHR21368', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L9', 239835),
(307253, 'PTHR21368:SF26', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L9, CHLOROPLASTIC', 239835),
(307254, 'PTHR21368:SF18', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L9, MITOCHONDRIAL', 239835),
(307255, 'PTHR14581:SF2', NULL, NULL, NULL, NULL, '', 239836),
(307256, 'PTHR14581', NULL, NULL, NULL, NULL, '', 239836),
(307257, 'PTHR14581:SF4', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 15', 239836),
(307258, 'PTHR14581:SF5', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 15-LIKE PROTEIN', 239836),
(307259, 'PTHR48171', NULL, NULL, NULL, NULL, 'DUF946 FAMILY PROTEIN', 239837),
(307260, 'PTHR48171:SF2', NULL, NULL, NULL, NULL, 'PROCESSING PROTEIN PRP39, PUTATIVE-RELATED', 239837),
(307261, 'PTHR48171:SF1', NULL, NULL, NULL, NULL, 'DUF946 FAMILY PROTEIN', 239837),
(307262, 'PTHR10779', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN ROADBLOCK', 239838),
(307263, 'PTHR10779:SF30', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN ROADBLOCK', 239838),
(307264, 'PTHR10779:SF31', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN ROADBLOCK-TYPE 2', 239838),
(307265, 'PTHR10779:SF3', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN ROADBLOCK-RELATED', 239838),
(307266, 'PTHR10779:SF18', NULL, NULL, NULL, NULL, 'ROBL_LC7 DOMAIN-CONTAINING PROTEIN', 239838),
(307267, 'PTHR10779:SF29', NULL, NULL, NULL, NULL, 'LIGHT CHAIN 2B, CYTOPLASMIC, PUTATIVE-RELATED', 239838),
(307268, 'PTHR10779:SF14', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN ROADBLOCK', 239838),
(307269, 'PTHR10779:SF17', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN ROADBLOCK-TYPE 1', 239838),
(307270, 'PTHR10779:SF13', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN ROADBLOCK', 239838),
(307271, 'PTHR35146:SF1', NULL, NULL, NULL, NULL, 'UPF0178 PROTEIN YAII', 239839),
(307272, 'PTHR35146', NULL, NULL, NULL, NULL, 'UPF0178 PROTEIN YAII', 239839),
(307273, 'PTHR10199:SF118', NULL, NULL, NULL, NULL, '', 239840),
(307274, 'PTHR10199:SF92', NULL, NULL, NULL, NULL, 'THROMBOSPONDIN-4', 239840),
(307275, 'PTHR10199:SF116', NULL, NULL, NULL, NULL, 'THROMBOSPONDIN 4A', 239840),
(307276, 'PTHR10199:SF100', NULL, NULL, NULL, NULL, 'THROMBOSPONDIN, ISOFORM A', 239840),
(307277, 'PTHR10199:SF88', NULL, NULL, NULL, NULL, 'CARTILAGE OLIGOMERIC MATRIX PROTEIN', 239840),
(307278, 'PTHR10199', NULL, NULL, NULL, NULL, 'THROMBOSPONDIN', 239840),
(307279, 'PTHR10199:SF110', NULL, NULL, NULL, NULL, '', 239840),
(307280, 'PTHR10199:SF10', NULL, NULL, NULL, NULL, 'THROMBOSPONDIN-2', 239840),
(307281, 'PTHR10199:SF89', NULL, NULL, NULL, NULL, 'THROMBOSPONDIN-3', 239840),
(307282, 'PTHR10199:SF78', NULL, NULL, NULL, NULL, 'THROMBOSPONDIN-1', 239840),
(307283, 'PTHR10199:SF119', NULL, NULL, NULL, NULL, 'RE20510P', 239840),
(307284, 'PTHR42748:SF7', NULL, NULL, NULL, NULL, 'NMRA-LIKE FAMILY DOMAIN-CONTAINING PROTEIN DDB_G0286605', 239841),
(307285, 'PTHR42748:SF30', NULL, NULL, NULL, NULL, 'NMRA DOMAIN-CONTAINING PROTEIN', 239841),
(307286, 'PTHR42748:SF8', NULL, NULL, NULL, NULL, 'NMRA-LIKE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_8G01860)', 239841),
(307287, 'PTHR42748:SF32', NULL, NULL, NULL, NULL, 'NMRA DOMAIN-CONTAINING PROTEIN', 239841),
(307288, 'PTHR42748:SF10', NULL, NULL, NULL, NULL, 'NMRA DOMAIN-CONTAINING PROTEIN', 239841),
(307289, 'PTHR42748:SF31', NULL, NULL, NULL, NULL, 'NMRA DOMAIN-CONTAINING PROTEIN-RELATED', 239841),
(307290, 'PTHR42748:SF11', NULL, NULL, NULL, NULL, 'NMRA DOMAIN-CONTAINING PROTEIN', 239841),
(307291, 'PTHR42748:SF22', NULL, NULL, NULL, NULL, 'NMRA DOMAIN-CONTAINING PROTEIN', 239841),
(307292, 'PTHR42748', NULL, NULL, NULL, NULL, 'NITROGEN METABOLITE REPRESSION PROTEIN NMRA FAMILY MEMBER', 239841);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(307293, 'PTHR42748:SF1', NULL, NULL, NULL, NULL, 'SLR0317 PROTEIN', 239841),
(307294, 'PTHR42748:SF3', NULL, NULL, NULL, NULL, 'BLL4366 PROTEIN', 239841),
(307295, 'PTHR42748:SF5', NULL, NULL, NULL, NULL, 'NITROGEN METABOLITE REPRESSION PROTEIN NMRA', 239841),
(307296, 'PTHR42748:SF4', NULL, NULL, NULL, NULL, 'NMRA DOMAIN-CONTAINING PROTEIN-RELATED', 239841),
(307297, 'PTHR42748:SF25', NULL, NULL, NULL, NULL, 'NMRA FAMILY PROTEIN', 239841),
(307298, 'PTHR42748:SF14', NULL, NULL, NULL, NULL, 'SNOAL-LIKE DOMAIN-CONTAINING PROTEIN', 239841),
(307299, 'PTHR42748:SF16', NULL, NULL, NULL, NULL, 'NMRA-LIKE FAMILY DOMAIN-CONTAINING PROTEIN 1', 239841),
(307300, 'PTHR42748:SF26', NULL, NULL, NULL, NULL, 'NMRA DOMAIN-CONTAINING PROTEIN', 239841),
(307301, 'PTHR42748:SF29', NULL, NULL, NULL, NULL, 'NMRA DOMAIN-CONTAINING PROTEIN', 239841),
(307302, 'PTHR42748:SF18', NULL, NULL, NULL, NULL, 'NMRA DOMAIN-CONTAINING PROTEIN', 239841),
(307303, 'PTHR42748:SF28', NULL, NULL, NULL, NULL, 'NMRA DOMAIN-CONTAINING PROTEIN', 239841),
(307304, 'PTHR14614:SF5', NULL, NULL, NULL, NULL, 'EEF1A LYSINE METHYLTRANSFERASE 3', 239842),
(307305, 'PTHR14614:SF92', NULL, NULL, NULL, NULL, '', 239842),
(307306, 'PTHR14614:SF7', NULL, NULL, NULL, NULL, 'OS05G0564100 PROTEIN', 239842),
(307307, 'PTHR14614:SF160', NULL, NULL, NULL, NULL, '', 239842),
(307308, 'PTHR14614:SF143', NULL, NULL, NULL, NULL, 'PROTEIN-LYSINE METHYLTRANSFERASE C42C1.13', 239842),
(307309, 'PTHR14614:SF142', NULL, NULL, NULL, NULL, '', 239842),
(307310, 'PTHR14614:SF120', NULL, NULL, NULL, NULL, '', 239842),
(307311, 'PTHR14614:SF123', NULL, NULL, NULL, NULL, 'OS04G0645500 PROTEIN', 239842),
(307312, 'PTHR14614:SF147', NULL, NULL, NULL, NULL, '', 239842),
(307313, 'PTHR14614:SF149', NULL, NULL, NULL, NULL, 'FAM86 DOMAIN-CONTAINING PROTEIN', 239842),
(307314, 'PTHR14614:SF104', NULL, NULL, NULL, NULL, 'N-METHYLTRANSFERASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G17750)-RELATED', 239842),
(307315, 'PTHR14614:SF109', NULL, NULL, NULL, NULL, 'UPF0665 FAMILY PROTEIN C23C4.06C', 239842),
(307316, 'PTHR14614:SF44', NULL, NULL, NULL, NULL, 'PROTEIN-LYSINE METHYLTRANSFERASE METTL21D', 239842),
(307317, 'PTHR14614:SF43', NULL, NULL, NULL, NULL, 'OS04G0492400 PROTEIN', 239842),
(307318, 'PTHR14614:SF1', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE-LIKE PROTEIN 21E PSEUDOGENE-RELATED', 239842),
(307319, 'PTHR14614:SF150', NULL, NULL, NULL, NULL, '', 239842),
(307320, 'PTHR14614:SF152', NULL, NULL, NULL, NULL, 'PROTEIN-LYSINE N-METHYLTRANSFERASE EFM6', 239842),
(307321, 'PTHR14614:SF130', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE-LIKE PROTEIN 23', 239842),
(307322, 'PTHR14614:SF151', NULL, NULL, NULL, NULL, '', 239842),
(307323, 'PTHR14614:SF132', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE FAMILY PROTEIN-RELATED', 239842),
(307324, 'PTHR14614:SF154', NULL, NULL, NULL, NULL, '', 239842),
(307325, 'PTHR14614:SF153', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 239842),
(307326, 'PTHR14614:SF156', NULL, NULL, NULL, NULL, 'PROTEIN-LYSINE N-METHYLTRANSFERASE EFM2', 239842),
(307327, 'PTHR14614:SF134', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN-RELATED', 239842),
(307328, 'PTHR14614:SF155', NULL, NULL, NULL, NULL, '', 239842),
(307329, 'PTHR14614:SF158', NULL, NULL, NULL, NULL, 'PROTEIN-LYSINE METHYLTRANSFERASE METTL21D', 239842),
(307330, 'PTHR14614:SF157', NULL, NULL, NULL, NULL, '', 239842),
(307331, 'PTHR14614:SF135', NULL, NULL, NULL, NULL, 'BNAA03G56760D PROTEIN', 239842),
(307332, 'PTHR14614:SF159', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 239842),
(307333, 'PTHR14614:SF115', NULL, NULL, NULL, NULL, '', 239842),
(307334, 'PTHR14614:SF117', NULL, NULL, NULL, NULL, 'PROTEIN-LYSINE N-METHYLTRANSFERASE EEF2KMT-RELATED', 239842),
(307335, 'PTHR14614:SF139', NULL, NULL, NULL, NULL, 'FAM86 DOMAIN-CONTAINING PROTEIN', 239842),
(307336, 'PTHR14614:SF39', NULL, NULL, NULL, NULL, 'HISTIDINE PROTEIN METHYLTRANSFERASE 1 HOMOLOG', 239842),
(307337, 'PTHR14614', NULL, NULL, NULL, NULL, 'HEPATOCELLULAR CARCINOMA-ASSOCIATED ANTIGEN', 239842);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(307338, 'PTHR14614:SF14', NULL, NULL, NULL, NULL, 'PROTEIN N-LYSINE METHYLTRANSFERASE METTL21A', 239842),
(307339, 'PTHR14614:SF13', NULL, NULL, NULL, NULL, 'PROTEIN-LYSINE METHYLTRANSFERASE METTL21C', 239842),
(307340, 'PTHR14614:SF98', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 239842),
(307341, 'PTHR14614:SF10', NULL, NULL, NULL, NULL, 'PROTEIN N-TERMINAL AND LYSINE N-METHYLTRANSFERASE EFM7', 239842),
(307342, 'PTHR14614:SF97', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 239842),
(307343, 'PTHR14614:SF94', NULL, NULL, NULL, NULL, 'RIBOSOMAL LYSINE N-METHYLTRANSFERASE 5', 239842),
(307344, 'PTHR18947:SF31', NULL, NULL, NULL, NULL, 'PROTEIN DAPLE', 239843),
(307345, 'PTHR18947:SF30', NULL, NULL, NULL, NULL, 'GIRDIN', 239843),
(307346, 'PTHR18947', NULL, NULL, NULL, NULL, 'HOOK PROTEINS', 239843),
(307347, 'PTHR18947:SF39', NULL, NULL, NULL, NULL, 'PROTEIN HOOK', 239843),
(307348, 'PTHR18947:SF28', NULL, NULL, NULL, NULL, 'GIRDIN, ISOFORM A', 239843),
(307349, 'PTHR18947:SF36', NULL, NULL, NULL, NULL, 'PROTEIN HOOK HOMOLOG 1', 239843),
(307350, 'PTHR18947:SF35', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 88B', 239843),
(307351, 'PTHR18947:SF38', NULL, NULL, NULL, NULL, 'PROTEIN HOOK HOMOLOG 3', 239843),
(307352, 'PTHR18947:SF37', NULL, NULL, NULL, NULL, 'PROTEIN HOOK HOMOLOG 2', 239843),
(307353, 'PTHR13178:SF0', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 BETA SUBCOMPLEX SUBUNIT 5, MITOCHONDRIAL', 239844),
(307354, 'PTHR13178', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE SGDH SUBUNIT', 239844),
(307355, 'PTHR31915:SF13', NULL, NULL, NULL, NULL, 'EF-HAND AND COILED-COIL DOMAIN-CONTAINING PROTEIN 1', 239845),
(307356, 'PTHR31915:SF10', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING AND COILED-COIL DOMAIN 2', 239845),
(307357, 'PTHR31915', NULL, NULL, NULL, NULL, 'SKICH DOMAIN-CONTAINING PROTEIN', 239845),
(307358, 'PTHR31915:SF8', NULL, NULL, NULL, NULL, 'TAX1-BINDING PROTEIN 1', 239845),
(307359, 'PTHR31915:SF7', NULL, NULL, NULL, NULL, 'TAX1-BINDING PROTEIN 1 HOMOLOG A', 239845),
(307360, 'PTHR31915:SF6', NULL, NULL, NULL, NULL, 'SKICH DOMAIN-CONTAINING PROTEIN', 239845),
(307361, 'PTHR31915:SF5', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING AND COILED-COIL DOMAIN-CONTAINING PROTEIN 1', 239845),
(307362, 'PTHR31915:SF4', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING AND COILED-COIL DOMAIN-CONTAINING PROTEIN 2', 239845),
(307363, 'PTHR13530:SF3', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 7', 239846),
(307364, 'PTHR13530', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 7', 239846),
(307365, 'PTHR23196:SF30', NULL, NULL, NULL, NULL, '', 239847),
(307366, 'PTHR23196:SF8', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE', 239847),
(307367, 'PTHR23196', NULL, NULL, NULL, NULL, 'PAX TRANSCRIPTION ACTIVATION DOMAIN INTERACTING PROTEIN', 239847),
(307368, 'PTHR23196:SF32', NULL, NULL, NULL, NULL, 'BRCT DOMAIN-CONTAINING DNA REPAIR PROTEIN', 239847),
(307369, 'PTHR23196:SF23', NULL, NULL, NULL, NULL, 'OS01G0939300 PROTEIN', 239847),
(307370, 'PTHR23196:SF34', NULL, NULL, NULL, NULL, 'MEDIATOR OF DNA DAMAGE CHECKPOINT PROTEIN 1', 239847),
(307371, 'PTHR23196:SF36', NULL, NULL, NULL, NULL, 'BRCT DOMAIN-CONTAINING DNA REPAIR-LIKE PROTEIN ISOFORM 2', 239847),
(307372, 'PTHR23196:SF38', NULL, NULL, NULL, NULL, 'BRCT DOMAIN-CONTAINING PROTEIN-RELATED', 239847),
(307373, 'PTHR23196:SF37', NULL, NULL, NULL, NULL, 'PAX-INTERACTING PROTEIN 1', 239847),
(307374, 'PTHR23196:SF1', NULL, NULL, NULL, NULL, 'LD44171P-RELATED', 239847),
(307375, 'PTHR23196:SF39', NULL, NULL, NULL, NULL, 'BRCT DOMAIN-CONTAINING PROTEIN', 239847),
(307376, 'PTHR40057:SF1', NULL, NULL, NULL, NULL, 'SLR1162 PROTEIN', 239848),
(307377, 'PTHR40057', NULL, NULL, NULL, NULL, 'SLR1162 PROTEIN', 239848),
(307378, 'PTHR30005:SF14', NULL, NULL, NULL, NULL, 'EXOPOLYPHOSPHATASE', 239849),
(307379, 'PTHR30005', NULL, NULL, NULL, NULL, 'EXOPOLYPHOSPHATASE', 239849),
(307380, 'PTHR30005:SF13', NULL, NULL, NULL, NULL, 'EXOPOLYPHOSPHATASE 2', 239849);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(307381, 'PTHR30005:SF0', NULL, NULL, NULL, NULL, 'RETROGRADE REGULATION PROTEIN 2', 239849),
(307382, 'PTHR32154:SF14', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE SYNTHASE SUBUNIT KORA', 239850),
(307383, 'PTHR32154:SF16', NULL, NULL, NULL, NULL, 'PYRUVATE FLAVODOXIN/FERREDOXIN OXIDOREDUCTASE DOMAIN PROTEIN', 239850),
(307384, 'PTHR32154:SF20', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE OXIDOREDUCTASE SUBUNIT KORA', 239850),
(307385, 'PTHR32154', NULL, NULL, NULL, NULL, 'PYRUVATE-FLAVODOXIN OXIDOREDUCTASE-RELATED', 239850),
(307386, 'PTHR32154:SF0', NULL, NULL, NULL, NULL, 'PYRUVATE-FLAVODOXIN OXIDOREDUCTASE-RELATED', 239850),
(307387, 'PTHR32154:SF29', NULL, NULL, NULL, NULL, 'BLR6743 PROTEIN', 239850),
(307388, 'PTHR12132:SF5', NULL, NULL, NULL, NULL, '', 239851),
(307389, 'PTHR12132:SF6', NULL, NULL, NULL, NULL, 'DNA REPAIR AND RECOMBINATION PROTEIN RAD22', 239851),
(307390, 'PTHR12132:SF1', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RAD52 HOMOLOG', 239851),
(307391, 'PTHR12132:SF2', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RAD59', 239851),
(307392, 'PTHR12132', NULL, NULL, NULL, NULL, 'DNA REPAIR AND RECOMBINATION PROTEIN RAD52, RAD59', 239851),
(307393, 'PTHR34291', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 239852),
(307394, 'PTHR34291:SF1', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 239852),
(307395, 'PTHR34291:SF10', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN', 239852),
(307396, 'PTHR34291:SF11', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN FAMILY PROTEIN, PUTATIVE-RELATED', 239852),
(307397, 'PTHR34291:SF12', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 239852),
(307398, 'PTHR34291:SF13', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN', 239852),
(307399, 'PTHR34291:SF14', NULL, NULL, NULL, NULL, '', 239852),
(307400, 'PTHR34291:SF15', NULL, NULL, NULL, NULL, 'BNAANNG38150D PROTEIN', 239852),
(307401, 'PTHR34291:SF7', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 239852),
(307402, 'PTHR34291:SF9', NULL, NULL, NULL, NULL, '', 239852),
(307403, 'PTHR34291:SF8', NULL, NULL, NULL, NULL, 'BNAANNG04970D PROTEIN', 239852),
(307404, 'PTHR34291:SF2', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN', 239852),
(307405, 'PTHR34291:SF5', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN', 239852),
(307406, 'PTHR34291:SF4', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 239852),
(307407, 'PTHR37354:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME ALIGNMENT-MAINTAINING PHOSPHOPROTEIN 1', 239853),
(307408, 'PTHR37354', NULL, NULL, NULL, NULL, 'CHROMOSOME ALIGNMENT-MAINTAINING PHOSPHOPROTEIN 1', 239853),
(307409, 'PTHR40314:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG15751', 239854),
(307410, 'PTHR40314:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG08508', 239854),
(307411, 'PTHR40314', NULL, NULL, NULL, NULL, 'PROTEIN CBG09102-RELATED', 239854),
(307412, 'PTHR47340', NULL, NULL, NULL, NULL, 'DUPLICATED HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN', 239855),
(307413, 'PTHR47340:SF1', NULL, NULL, NULL, NULL, 'DUPLICATED HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN', 239855),
(307414, 'PTHR10686:SF33', NULL, NULL, NULL, NULL, 'THIAMINE TRANSPORTER 2-LIKE', 239856),
(307415, 'PTHR10686:SF12', NULL, NULL, NULL, NULL, 'REDUCED FOLATE TRANSPORTER', 239856),
(307416, 'PTHR10686:SF20', NULL, NULL, NULL, NULL, 'FOLATE TRANSPORTER 1', 239856),
(307417, 'PTHR10686:SF37', NULL, NULL, NULL, NULL, 'THIAMINE TRANSPORTER 2', 239856),
(307418, 'PTHR10686:SF38', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 19 MEMBER 3B', 239856),
(307419, 'PTHR10686:SF35', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 19 MEMBER 3A', 239856),
(307420, 'PTHR10686:SF14', NULL, NULL, NULL, NULL, 'FOLATE-LIKE TRANSPORTER 2', 239856),
(307421, 'PTHR10686', NULL, NULL, NULL, NULL, 'FOLATE TRANSPORTER', 239856),
(307422, 'PTHR10686:SF19', NULL, NULL, NULL, NULL, 'THIAMINE TRANSPORTER 1', 239856),
(307423, 'PTHR10686:SF18', NULL, NULL, NULL, NULL, 'IP11787P-RELATED', 239856),
(307424, 'PTHR31163', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER', 239857);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(307425, 'PTHR31163:SF1249', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER', 239857),
(307426, 'PTHR34104:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 254', 239858),
(307427, 'PTHR34104', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 254', 239858),
(307428, 'PTHR43633', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE YQHD', 239859),
(307429, 'PTHR43633:SF1', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE YQHD', 239859),
(307430, 'PTHR24373:SF283', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT TRANSMEMBRANE NEURONAL PROTEIN 4', 239860),
(307431, 'PTHR24373:SF162', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT NEURONAL PROTEIN 2', 239860),
(307432, 'PTHR24373:SF359', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 239860),
(307433, 'PTHR24373:SF358', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING G-PROTEIN COUPLED RECEPTOR 6', 239860),
(307434, 'PTHR24373:SF274', NULL, NULL, NULL, NULL, 'RETICULON-4 RECEPTOR-LIKE 1', 239860),
(307435, 'PTHR24373:SF273', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEATS AND IMMUNOGLOBULIN-LIKE DOMAINS PROTEIN 1', 239860),
(307436, 'PTHR24373:SF276', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 3B', 239860),
(307437, 'PTHR24373:SF7', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT NEURONAL PROTEIN 3', 239860),
(307438, 'PTHR24373:SF352', NULL, NULL, NULL, NULL, 'TSUKUSHI', 239860),
(307439, 'PTHR24373:SF275', NULL, NULL, NULL, NULL, 'FI03225P', 239860),
(307440, 'PTHR24373:SF311', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEATS AND IMMUNOGLOBULIN-LIKE DOMAINS PROTEIN 3', 239860),
(307441, 'PTHR24373:SF277', NULL, NULL, NULL, NULL, 'CHONDROADHERIN', 239860),
(307442, 'PTHR24373:SF156', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND IMMUNOGLOBULIN-LIKE DOMAIN-CONTAINING NOGO RECEPTOR-INTERACTING PROTEIN 4', 239860),
(307443, 'PTHR24373:SF354', NULL, NULL, NULL, NULL, 'TRANSFORMING GROWTH FACTOR BETA ACTIVATOR LRRC32', 239860),
(307444, 'PTHR24373:SF357', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 239860),
(307445, 'PTHR24373:SF279', NULL, NULL, NULL, NULL, 'TLC DOMAIN-CONTAINING PROTEIN', 239860),
(307446, 'PTHR24373:SF356', NULL, NULL, NULL, NULL, 'CD180 ANTIGEN', 239860),
(307447, 'PTHR24373:SF272', NULL, NULL, NULL, NULL, 'RETICULON-4 RECEPTOR-LIKE 2', 239860),
(307448, 'PTHR24373:SF271', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE N SUBUNIT 2', 239860),
(307449, 'PTHR24373:SF348', NULL, NULL, NULL, NULL, 'CHAOPTIN', 239860),
(307450, 'PTHR24373:SF303', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING 3CA-RELATED', 239860),
(307451, 'PTHR24373:SF306', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEATS AND IMMUNOGLOBULIN-LIKE DOMAINS PROTEIN 2', 239860),
(307452, 'PTHR24373', NULL, NULL, NULL, NULL, 'SLIT RELATED LEUCINE-RICH REPEAT NEURONAL PROTEIN', 239860),
(307453, 'PTHR24373:SF307', NULL, NULL, NULL, NULL, 'TLR4 INTERACTOR WITH LEUCINE RICH REPEATS', 239860),
(307454, 'PTHR24373:SF263', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 29', 239860),
(307455, 'PTHR24373:SF262', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 15', 239860),
(307456, 'PTHR24373:SF97', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT NEURONAL PROTEIN 1', 239860),
(307457, 'PTHR24373:SF265', NULL, NULL, NULL, NULL, 'SI:CH211-180F4.1', 239860),
(307458, 'PTHR24373:SF264', NULL, NULL, NULL, NULL, 'NYCTALOPIN', 239860),
(307459, 'PTHR24373:SF266', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 3C', 239860),
(307460, 'PTHR24373:SF269', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 24', 239860),
(307461, 'PTHR24373:SF268', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT TRANSMEMBRANE NEURONAL 2', 239860),
(307462, 'PTHR24373:SF301', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 17', 239860),
(307463, 'PTHR24373:SF380', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 239860),
(307464, 'PTHR24373:SF261', NULL, NULL, NULL, NULL, 'VASORIN', 239860),
(307465, 'PTHR24373:SF381', NULL, NULL, NULL, NULL, 'LRRNT DOMAIN-CONTAINING PROTEIN', 239860);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(307466, 'PTHR24373:SF296', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT TRANSMEMBRANE NEURONAL PROTEIN 3', 239860),
(307467, 'PTHR24373:SF373', NULL, NULL, NULL, NULL, 'CHONDROADHERIN-LIKE A-RELATED', 239860),
(307468, 'PTHR24373:SF372', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT NEURONAL PROTEIN 1-LIKE PROTEIN', 239860),
(307469, 'PTHR24373:SF130', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND IMMUNOGLOBULIN-LIKE DOMAIN-CONTAINING NOGO RECEPTOR-INTERACTING PROTEIN 3', 239860),
(307470, 'PTHR24373:SF331', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND IG DOMAIN-CONTAINING 4A-RELATED', 239860),
(307471, 'PTHR24373:SF375', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 15-LIKE PROTEIN', 239860),
(307472, 'PTHR24373:SF374', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN, PUTATIVE-RELATED', 239860),
(307473, 'PTHR24373:SF377', NULL, NULL, NULL, NULL, 'CHONDROADHERIN-LIKE PROTEIN', 239860),
(307474, 'PTHR24373:SF376', NULL, NULL, NULL, NULL, 'TRANSFORMING GROWTH FACTOR BETA ACTIVATOR LRRC33', 239860),
(307475, 'PTHR24373:SF335', NULL, NULL, NULL, NULL, 'NEPHROCAN', 239860),
(307476, 'PTHR24373:SF379', NULL, NULL, NULL, NULL, 'TARTAN, ISOFORM B', 239860),
(307477, 'PTHR24373:SF378', NULL, NULL, NULL, NULL, 'LAMBIK', 239860),
(307478, 'PTHR24373:SF290', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT TRANSMEMBRANE NEURONAL PROTEIN 1', 239860),
(307479, 'PTHR24373:SF371', NULL, NULL, NULL, NULL, 'PLATELET GLYCOPROTEIN IB ALPHA CHAIN', 239860),
(307480, 'PTHR24373:SF38', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND IMMUNOGLOBULIN-LIKE DOMAIN-CONTAINING NOGO RECEPTOR-INTERACTING PROTEIN 2', 239860),
(307481, 'PTHR24373:SF293', NULL, NULL, NULL, NULL, 'TOLL-LIKE RECEPTOR 3', 239860),
(307482, 'PTHR24373:SF370', NULL, NULL, NULL, NULL, 'GH01279P-RELATED', 239860),
(307483, 'PTHR24373:SF369', NULL, NULL, NULL, NULL, '', 239860),
(307484, 'PTHR24373:SF285', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR-BINDING PROTEIN COMPLEX ACID LABILE SUBUNIT', 239860),
(307485, 'PTHR24373:SF31', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND IMMUNOGLOBULIN-LIKE DOMAIN-CONTAINING NOGO RECEPTOR-INTERACTING PROTEIN 1', 239860),
(307486, 'PTHR24373:SF284', NULL, NULL, NULL, NULL, 'CHONDROADHERIN-LIKE PROTEIN', 239860),
(307487, 'PTHR24373:SF366', NULL, NULL, NULL, NULL, 'FISH-LIPS, ISOFORM E', 239860),
(307488, 'PTHR24373:SF365', NULL, NULL, NULL, NULL, 'TLR4 INTERACTOR WITH LEUCINE-RICH REPEATS', 239860),
(307489, 'PTHR24373:SF288', NULL, NULL, NULL, NULL, 'PROTEIN ELFN1', 239860),
(307490, 'PTHR24373:SF368', NULL, NULL, NULL, NULL, 'AGAP007463-PA', 239860),
(307491, 'PTHR24373:SF367', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 239860),
(307492, 'PTHR36877:SF1', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 13', 239861),
(307493, 'PTHR36877', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 13', 239861),
(307494, 'PTHR11615:SF350', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862),
(307495, 'PTHR11615:SF273', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 1E1-RELATED', 239862),
(307496, 'PTHR11615:SF319', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 1F2', 239862),
(307497, 'PTHR11615:SF356', NULL, NULL, NULL, NULL, 'CASPARIAN STRIP MEMBRANE PROTEIN 3', 239862),
(307498, 'PTHR11615:SF235', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 1A1', 239862),
(307499, 'PTHR11615:SF234', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862),
(307500, 'PTHR11615:SF311', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862),
(307501, 'PTHR11615:SF355', NULL, NULL, NULL, NULL, 'CASPARIAN STRIP MEMBRANE PROTEIN 2', 239862),
(307502, 'PTHR11615:SF233', NULL, NULL, NULL, NULL, 'CASPARIAN STRIP MEMBRANE PROTEIN 1', 239862),
(307503, 'PTHR11615:SF354', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862),
(307504, 'PTHR11615:SF276', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 1D2', 239862),
(307505, 'PTHR11615:SF353', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862),
(307506, 'PTHR11615:SF359', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 1C1', 239862),
(307507, 'PTHR11615:SF315', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862);
INSERT INTO "PUBLIC"."MODEL" VALUES
(307508, 'PTHR11615:SF116', NULL, NULL, NULL, NULL, 'CASPARIAN STRIP MEMBRANE PROTEIN 2-RELATED', 239862),
(307509, 'PTHR11615:SF358', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862),
(307510, 'PTHR11615:SF357', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862),
(307511, 'PTHR11615:SF159', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 1C1', 239862),
(307512, 'PTHR11615:SF313', NULL, NULL, NULL, NULL, 'PERIPLASMIC [FE-FE] HYDROGENASE LARGE SUBUNIT HYDA', 239862),
(307513, 'PTHR11615:SF286', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862),
(307514, 'PTHR11615:SF363', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862),
(307515, 'PTHR11615:SF241', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 2C2', 239862),
(307516, 'PTHR11615:SF285', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862),
(307517, 'PTHR11615:SF362', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862),
(307518, 'PTHR11615:SF361', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862),
(307519, 'PTHR11615:SF360', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862),
(307520, 'PTHR11615:SF329', NULL, NULL, NULL, NULL, 'CASPARIAN STRIP MEMBRANE PROTEIN 5', 239862),
(307521, 'PTHR11615:SF246', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 2A2', 239862),
(307522, 'PTHR11615:SF323', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862),
(307523, 'PTHR11615:SF322', NULL, NULL, NULL, NULL, 'CYTOSOLIC IRON-SULFUR ASSEMBLY COMPONENT 3', 239862),
(307524, 'PTHR11615:SF124', NULL, NULL, NULL, NULL, 'NUCLEAR PRELAMIN A RECOGNITION FACTOR', 239862),
(307525, 'PTHR11615:SF365', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862),
(307526, 'PTHR11615:SF288', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862),
(307527, 'PTHR11615:SF321', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862),
(307528, 'PTHR11615:SF244', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 1B1', 239862),
(307529, 'PTHR11615:SF320', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862),
(307530, 'PTHR11615:SF243', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 3A1', 239862),
(307531, 'PTHR11615:SF364', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862),
(307532, 'PTHR11615:SF247', NULL, NULL, NULL, NULL, 'CASPARIAN STRIP MEMBRANE PROTEIN 4', 239862),
(307533, 'PTHR11615:SF292', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862),
(307534, 'PTHR11615:SF291', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862),
(307535, 'PTHR11615:SF290', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862),
(307536, 'PTHR11615:SF253', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 1E1', 239862),
(307537, 'PTHR11615:SF252', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 6', 239862),
(307538, 'PTHR11615:SF250', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 2C2', 239862),
(307539, 'PTHR11615:SF6', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE 75 KDA SUBUNIT, MITOCHONDRIAL', 239862),
(307540, 'PTHR11615', NULL, NULL, NULL, NULL, 'NITRATE, FORMATE, IRON DEHYDROGENASE', 239862),
(307541, 'PTHR11615:SF212', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 2A1', 239862),
(307542, 'PTHR11615:SF254', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 1C2', 239862),
(307543, 'PTHR11615:SF331', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862),
(307544, 'PTHR11615:SF338', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862),
(307545, 'PTHR11615:SF337', NULL, NULL, NULL, NULL, 'CASPARIAN STRIP MEMBRANE PROTEIN 1', 239862),
(307546, 'PTHR11615:SF258', NULL, NULL, NULL, NULL, 'CYTOSOLIC FE-S CLUSTER ASSEMBLY FACTOR CG17683-RELATED', 239862),
(307547, 'PTHR11615:SF143', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 2D1', 239862),
(307548, 'PTHR11615:SF264', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 1F1', 239862),
(307549, 'PTHR11615:SF341', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 1B2', 239862),
(307550, 'PTHR11615:SF263', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 1C2', 239862),
(307551, 'PTHR11615:SF262', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862),
(307552, 'PTHR11615:SF309', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862),
(307553, 'PTHR11615:SF307', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(307554, 'PTHR11615:SF306', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862),
(307555, 'PTHR11615:SF345', NULL, NULL, NULL, NULL, 'CATALYTIC SUBUNIT OF IRON-ONLY HYDROGENASE-RELATED', 239862),
(307556, 'PTHR11615:SF224', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 1D1', 239862),
(307557, 'PTHR11615:SF344', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN OS03G0196400', 239862),
(307558, 'PTHR11615:SF267', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862),
(307559, 'PTHR11615:SF100', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 2B2', 239862),
(307560, 'PTHR11615:SF342', NULL, NULL, NULL, NULL, 'CASPARIAN STRIP MEMBRANE PROTEIN 5', 239862),
(307561, 'PTHR11615:SF305', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862),
(307562, 'PTHR11615:SF348', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862),
(307563, 'PTHR11615:SF304', NULL, NULL, NULL, NULL, 'IRON HYDROGENASE, PUTATIVE-RELATED', 239862),
(307564, 'PTHR11615:SF302', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 239862),
(307565, 'PTHR11615:SF346', NULL, NULL, NULL, NULL, 'CASPARIAN STRIP MEMBRANE PROTEIN 4', 239862),
(307566, 'PTHR33516:SF13', NULL, NULL, NULL, NULL, 'PROPHAGE REPRESSOR COHE-RELATED', 239863),
(307567, 'PTHR33516', NULL, NULL, NULL, NULL, 'LEXA REPRESSOR', 239863),
(307568, 'PTHR33516:SF2', NULL, NULL, NULL, NULL, 'LEXA REPRESSOR', 239863),
(307569, 'PTHR19876:SF61', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT BETA''-2', 239864),
(307570, 'PTHR19876:SF68', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT BETA''-1', 239864),
(307571, 'PTHR19876:SF46', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT ALPHA-3', 239864),
(307572, 'PTHR19876:SF69', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT BETA''-2', 239864),
(307573, 'PTHR19876:SF47', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT ALPHA', 239864),
(307574, 'PTHR19876:SF25', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT BETA''-3', 239864),
(307575, 'PTHR19876:SF23', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 239864),
(307576, 'PTHR19876:SF42', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT ALPHA', 239864),
(307577, 'PTHR19876:SF20', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR PRP46-LIKE', 239864),
(307578, 'PTHR19876:SF43', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 239864),
(307579, 'PTHR19876:SF28', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT BETA''', 239864),
(307580, 'PTHR19876:SF29', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT ALPHA-2', 239864),
(307581, 'PTHR19876:SF48', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT BETA''', 239864),
(307582, 'PTHR19876:SF71', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT BETA''', 239864),
(307583, 'PTHR19876', NULL, NULL, NULL, NULL, 'COATOMER', 239864),
(307584, 'PTHR19876:SF72', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 239864),
(307585, 'PTHR19876:SF70', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 239864),
(307586, 'PTHR19876:SF35', NULL, NULL, NULL, NULL, '', 239864),
(307587, 'PTHR19876:SF58', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT ALPHA', 239864),
(307588, 'PTHR19876:SF33', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT ALPHA', 239864),
(307589, 'PTHR19876:SF53', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT BETA''', 239864),
(307590, 'PTHR19876:SF75', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT BETA''-3', 239864),
(307591, 'PTHR19876:SF54', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT BETA''-1', 239864),
(307592, 'PTHR19876:SF73', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT BETA''', 239864),
(307593, 'PTHR19876:SF74', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 239864),
(307594, 'PTHR19876:SF4', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 239864),
(307595, 'PTHR19876:SF59', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT ALPHA', 239864),
(307596, 'PTHR19876:SF38', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT ALPHA', 239864),
(307597, 'PTHR19876:SF1', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT ALPHA', 239864),
(307598, 'PTHR19876:SF2', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT BETA''', 239864),
(307599, 'PTHR43607:SF4', NULL, NULL, NULL, NULL, 'V-ATPASE 69 KDA SUBUNIT', 239865);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(307600, 'PTHR43607:SF2', NULL, NULL, NULL, NULL, 'V-ATPASE 69 KDA SUBUNIT', 239865),
(307601, 'PTHR43607:SF1', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE CATALYTIC SUBUNIT A', 239865),
(307602, 'PTHR43607', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE CATALYTIC SUBUNIT A', 239865),
(307603, 'PTHR43607:SF6', NULL, NULL, NULL, NULL, 'V-ATPASE 69 KDA SUBUNIT', 239865),
(307604, 'PTHR43607:SF5', NULL, NULL, NULL, NULL, 'V-ATPASE 69 KDA SUBUNIT', 239865),
(307605, 'PTHR42904:SF6', NULL, NULL, NULL, NULL, 'NAD-CAPPED RNA HYDROLASE NUDT12', 239866),
(307606, 'PTHR42904:SF4', NULL, NULL, NULL, NULL, 'NAD(+) DIPHOSPHATASE', 239866),
(307607, 'PTHR42904:SF11', NULL, NULL, NULL, NULL, 'NAD(+) DIPHOSPHATASE', 239866),
(307608, 'PTHR42904:SF10', NULL, NULL, NULL, NULL, 'NAD-CAPPED RNA HYDROLASE NUDC', 239866),
(307609, 'PTHR42904:SF8', NULL, NULL, NULL, NULL, 'NAD(+) DIPHOSPHATASE', 239866),
(307610, 'PTHR42904', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE, NUDC SUBFAMILY', 239866),
(307611, 'PTHR42904:SF1', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE-LINKED MOIETY X MOTIF 17', 239866),
(307612, 'PTHR36764:SF1', NULL, NULL, NULL, NULL, 'TRNA (ILE)-LYSIDINE SYNTHASE', 239867),
(307613, 'PTHR36764', NULL, NULL, NULL, NULL, 'TRNA (ILE)-LYSIDINE SYNTHASE', 239867),
(307614, 'PTHR28263:SF1', NULL, NULL, NULL, NULL, 'GOLGI TO ER TRAFFIC PROTEIN 2', 239868),
(307615, 'PTHR28263', NULL, NULL, NULL, NULL, 'GOLGI TO ER TRAFFIC PROTEIN 2', 239868),
(307616, 'PTHR19354:SF2', NULL, NULL, NULL, NULL, 'ZIPPER PUTATIVE TUMOR SUPPRESSOR 2 HOMOLOG-LIKE PROTEIN-RELATED', 239869),
(307617, 'PTHR19354:SF4', NULL, NULL, NULL, NULL, 'ZIPPER PUTATIVE TUMOR SUPPRESSOR 2-RELATED', 239869),
(307618, 'PTHR19354', NULL, NULL, NULL, NULL, 'ZIPPER PUTATIVE TUMOR SUPPRESSOR 2 HOMOLOG-LIKE PROTEIN-RELATED', 239869),
(307619, 'PTHR19354:SF5', NULL, NULL, NULL, NULL, 'ZIPPER PUTATIVE TUMOR SUPPRESSOR 1-RELATED', 239869),
(307620, 'PTHR19354:SF6', NULL, NULL, NULL, NULL, 'ZIPPER PUTATIVE TUMOR SUPPRESSOR 3-RELATED', 239869),
(307621, 'PTHR35367:SF2', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 239870),
(307622, 'PTHR35367', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 239870),
(307623, 'PTHR39087', NULL, NULL, NULL, NULL, 'UPF0104 MEMBRANE PROTEIN MJ1595', 239871),
(307624, 'PTHR39087:SF2', NULL, NULL, NULL, NULL, 'UPF0104 MEMBRANE PROTEIN MJ1595', 239871),
(307625, 'PTHR47485:SF1', NULL, NULL, NULL, NULL, 'THYLAKOID LUMENAL 17.4 KDA PROTEIN, CHLOROPLASTIC', 239872),
(307626, 'PTHR47485', NULL, NULL, NULL, NULL, 'THYLAKOID LUMENAL 17.4 KDA PROTEIN, CHLOROPLASTIC', 239872),
(307627, 'PTHR48251:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 160', 239873),
(307628, 'PTHR48251', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 160', 239873),
(307629, 'PTHR43798', NULL, NULL, NULL, NULL, 'MONOACYLGLYCEROL LIPASE', 239874),
(307630, 'PTHR43798:SF6', NULL, NULL, NULL, NULL, 'HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G13070)-RELATED', 239874),
(307631, 'PTHR43798:SF5', NULL, NULL, NULL, NULL, 'MONOACYLGLYCEROL LIPASE ABHD6', 239874),
(307632, 'PTHR43798:SF27', NULL, NULL, NULL, NULL, 'HYDROLASE ALPHA/BETA HYDROLASE FOLD FAMILY', 239874),
(307633, 'PTHR43798:SF26', NULL, NULL, NULL, NULL, 'HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G16900)-RELATED', 239874),
(307634, 'PTHR43798:SF29', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 239874),
(307635, 'PTHR43798:SF28', NULL, NULL, NULL, NULL, 'LIPASE', 239874),
(307636, 'PTHR43798:SF14', NULL, NULL, NULL, NULL, 'SERINE HYDROLASE-LIKE PROTEIN DDB_G0286239', 239874),
(307637, 'PTHR43798:SF24', NULL, NULL, NULL, NULL, 'CIS-3-ALKYL-4-ALKYLOXETAN-2-ONE DECARBOXYLASE', 239874),
(307638, 'PTHR43798:SF30', NULL, NULL, NULL, NULL, 'HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G14860)-RELATED', 239874),
(307639, 'PTHR43798:SF31', NULL, NULL, NULL, NULL, 'AB HYDROLASE SUPERFAMILY PROTEIN YCLE', 239874),
(307640, 'PTHR43798:SF20', NULL, NULL, NULL, NULL, '2-SUCCINYL-6-HYDROXY-2,4-CYCLOHEXADIENE-1-CARBOXYLATE SYNTHASE-RELATED', 239874);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(307641, 'PTHR43776:SF1', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE ABC TRANSPORTER, ATP-BINDING PROTEIN', 239875),
(307642, 'PTHR43776:SF14', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORT ATP-BINDING PROTEIN YKFD-RELATED', 239875),
(307643, 'PTHR43776', NULL, NULL, NULL, NULL, 'TRANSPORT ATP-BINDING PROTEIN', 239875),
(307644, 'PTHR43776:SF12', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, ATP-BINDING PROTEIN', 239875),
(307645, 'PTHR43776:SF8', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 239875),
(307646, 'PTHR43776:SF5', NULL, NULL, NULL, NULL, 'ATPASE COMPONENT OF ABC-TYPE TRANSPORT SYSTEM-RELATED', 239875),
(307647, 'PTHR43776:SF4', NULL, NULL, NULL, NULL, 'PUTRESCINE EXPORT SYSTEM ATP-BINDING PROTEIN SAPF', 239875),
(307648, 'PTHR43776:SF7', NULL, NULL, NULL, NULL, 'D,D-DIPEPTIDE TRANSPORT ATP-BINDING PROTEIN DDPF-RELATED', 239875),
(307649, 'PTHR43776:SF6', NULL, NULL, NULL, NULL, 'DIPEPTIDE TRANSPORT ATP-BINDING PROTEIN DPPF', 239875),
(307650, 'PTHR43776:SF15', NULL, NULL, NULL, NULL, 'GLUTATHIONE IMPORT ATP-BINDING PROTEIN GSIA', 239875),
(307651, 'PTHR46726', NULL, NULL, NULL, NULL, 'TWO PORE CHANNEL 3', 239876),
(307652, 'PTHR46726:SF1', NULL, NULL, NULL, NULL, 'TWO PORE CHANNEL 3', 239876),
(307653, 'PTHR46726:SF2', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-CONTAINING PROTEIN', 239876),
(307654, 'PTHR36024:SF4', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT PROTEIN SKIP35-LIKE ISOFORM X1', 239877),
(307655, 'PTHR36024:SF1', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT PROTEIN SKIP35', 239877),
(307656, 'PTHR36024', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT PROTEIN SKIP35', 239877),
(307657, 'PTHR36024:SF2', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT PROTEIN SKIP35', 239877),
(307658, 'PTHR36024:SF3', NULL, NULL, NULL, NULL, 'BNAC04G03320D PROTEIN', 239877),
(307659, 'PTHR28008:SF1', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G10980)-RELATED', 239878),
(307660, 'PTHR28008', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G10980)-RELATED', 239878),
(307661, 'PTHR12538:SF0', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S26', 239879),
(307662, 'PTHR12538:SF1', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S26', 239879),
(307663, 'PTHR12538:SF13', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S26', 239879),
(307664, 'PTHR12538:SF15', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S26', 239879),
(307665, 'PTHR12538:SF16', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S26', 239879),
(307666, 'PTHR12538:SF20', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S26', 239879),
(307667, 'PTHR12538:SF10', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S26', 239879),
(307668, 'PTHR12538:SF22', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 239879),
(307669, 'PTHR12538', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S26', 239879),
(307670, 'PTHR12538:SF11', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S26', 239879),
(307671, 'PTHR12538:SF12', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S26', 239879),
(307672, 'PTHR12538:SF17', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S26', 239879),
(307673, 'PTHR12538:SF18', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S26', 239879),
(307674, 'PTHR12538:SF7', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S26-RELATED', 239879),
(307675, 'PTHR15628:SF1', NULL, NULL, NULL, NULL, 'RWD DOMAIN-CONTAINING PROTEIN 3', 239880),
(307676, 'PTHR15628', NULL, NULL, NULL, NULL, 'RWD DOMAIN-CONTAINING PROTEIN 3', 239880),
(307677, 'PTHR33308:SF9', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN HYDROLASE FLGJ', 239881),
(307678, 'PTHR33308', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN HYDROLASE FLGJ', 239881),
(307679, 'PTHR47276:SF1', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 22', 239882),
(307680, 'PTHR47276', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 22', 239882),
(307681, 'PTHR31274:SF2', NULL, NULL, NULL, NULL, 'AGL149CP', 239883),
(307682, 'PTHR31274', NULL, NULL, NULL, NULL, 'PROTEIN ECM3', 239883),
(307683, 'PTHR31274:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ECM3', 239883);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(307684, 'PTHR16458:SF2', NULL, NULL, NULL, NULL, 'GLYCINE N-METHYLTRANSFERASE', 239884),
(307685, 'PTHR16458', NULL, NULL, NULL, NULL, 'GLYCINE N-METHYLTRANSFERASE', 239884),
(307686, 'PTHR10792:SF28', NULL, NULL, NULL, NULL, 'OS07G0224000 PROTEIN', 239885),
(307687, 'PTHR10792:SF51', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L24-1-RELATED', 239885),
(307688, 'PTHR10792:SF40', NULL, NULL, NULL, NULL, 'TRASH DOMAIN-CONTAINING PROTEIN', 239885),
(307689, 'PTHR10792:SF30', NULL, NULL, NULL, NULL, 'TRASH DOMAIN-CONTAINING PROTEIN', 239885),
(307690, 'PTHR10792:SF52', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L24, PUTATIVE-RELATED', 239885),
(307691, 'PTHR10792:SF50', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L24E-RELATED PROTEIN-RELATED', 239885),
(307692, 'PTHR10792:SF8', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS PROTEIN RLP24-RELATED', 239885),
(307693, 'PTHR10792:SF37', NULL, NULL, NULL, NULL, 'TRASH DOMAIN-CONTAINING PROTEIN', 239885),
(307694, 'PTHR10792:SF48', NULL, NULL, NULL, NULL, 'OS05G0486700 PROTEIN', 239885),
(307695, 'PTHR10792:SF26', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS PROTEIN RLP24-RELATED', 239885),
(307696, 'PTHR10792:SF49', NULL, NULL, NULL, NULL, 'TRASH DOMAIN-CONTAINING PROTEIN', 239885),
(307697, 'PTHR10792:SF27', NULL, NULL, NULL, NULL, 'TRASH DOMAIN-CONTAINING PROTEIN', 239885),
(307698, 'PTHR10792:SF1', NULL, NULL, NULL, NULL, 'TRASH DOMAIN-CONTAINING PROTEIN', 239885),
(307699, 'PTHR10792:SF36', NULL, NULL, NULL, NULL, 'TRASH DOMAIN-CONTAINING PROTEIN', 239885),
(307700, 'PTHR10792:SF44', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L24', 239885),
(307701, 'PTHR10792:SF23', NULL, NULL, NULL, NULL, '', 239885),
(307702, 'PTHR10792:SF34', NULL, NULL, NULL, NULL, 'TRASH DOMAIN-CONTAINING PROTEIN', 239885),
(307703, 'PTHR10792', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L24', 239885),
(307704, 'PTHR10792:SF32', NULL, NULL, NULL, NULL, 'TRASH DOMAIN-CONTAINING PROTEIN', 239885),
(307705, 'PTHR38730:SF1', NULL, NULL, NULL, NULL, 'SLL7028 PROTEIN', 239886),
(307706, 'PTHR38730', NULL, NULL, NULL, NULL, 'SLL7028 PROTEIN', 239886),
(307707, 'PTHR11208:SF121', NULL, NULL, NULL, NULL, 'OS07G0227400 PROTEIN', 239887),
(307708, 'PTHR11208:SF143', NULL, NULL, NULL, NULL, 'KH DOMAIN-CONTAINING PROTEIN', 239887),
(307709, 'PTHR11208:SF42', NULL, NULL, NULL, NULL, 'KH DOMAIN-CONTAINING PROTEIN SPIN1', 239887),
(307710, 'PTHR11208:SF120', NULL, NULL, NULL, NULL, 'PROTEIN QUAKING', 239887),
(307711, 'PTHR11208:SF142', NULL, NULL, NULL, NULL, 'KH DOMAIN-CONTAINING PROTEIN', 239887),
(307712, 'PTHR11208:SF140', NULL, NULL, NULL, NULL, 'GH05812P-RELATED', 239887),
(307713, 'PTHR11208:SF7', NULL, NULL, NULL, NULL, 'KH DOMAIN-CONTAINING PROTEIN', 239887),
(307714, 'PTHR11208:SF109', NULL, NULL, NULL, NULL, 'QUAKING RELATED 54B, ISOFORM E', 239887),
(307715, 'PTHR11208:SF108', NULL, NULL, NULL, NULL, 'KH DOMAIN CONTAINING PROTEIN, SPIN1-RELATED', 239887),
(307716, 'PTHR11208:SF103', NULL, NULL, NULL, NULL, 'KH DOMAIN-CONTAINING PROTEIN', 239887),
(307717, 'PTHR11208:SF147', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN ASD-2', 239887),
(307718, 'PTHR11208:SF125', NULL, NULL, NULL, NULL, 'PROTEIN QUAKING', 239887),
(307719, 'PTHR11208:SF34', NULL, NULL, NULL, NULL, 'KH DOMAIN-CONTAINING, RNA-BINDING, SIGNAL TRANSDUCTION-ASSOCIATED PROTEIN 2', 239887),
(307720, 'PTHR11208:SF146', NULL, NULL, NULL, NULL, 'OS01G0886300 PROTEIN', 239887),
(307721, 'PTHR11208:SF35', NULL, NULL, NULL, NULL, 'KH DOMAIN-CONTAINING PROTEIN', 239887),
(307722, 'PTHR11208:SF145', NULL, NULL, NULL, NULL, 'KH DOMAIN-CONTAINING PROTEIN', 239887),
(307723, 'PTHR11208:SF98', NULL, NULL, NULL, NULL, 'RNA-BINDING KH DOMAIN-CONTAINING PROTEIN', 239887),
(307724, 'PTHR11208:SF144', NULL, NULL, NULL, NULL, 'BRANCHPOINT-BRIDGING PROTEIN-LIKE', 239887),
(307725, 'PTHR11208:SF100', NULL, NULL, NULL, NULL, 'KH DOMAIN-CONTAINING PROTEIN', 239887),
(307726, 'PTHR11208:SF122', NULL, NULL, NULL, NULL, 'KH DOMAIN-CONTAINING PROTEIN', 239887),
(307727, 'PTHR11208:SF55', NULL, NULL, NULL, NULL, 'OS05G0481500 PROTEIN', 239887);
INSERT INTO "PUBLIC"."MODEL" VALUES
(307728, 'PTHR11208:SF128', NULL, NULL, NULL, NULL, 'K-LIKE DOMAIN PROTEIN-RELATED', 239887),
(307729, 'PTHR11208:SF149', NULL, NULL, NULL, NULL, 'KH DOMAIN-CONTAINING PROTEIN', 239887),
(307730, 'PTHR11208:SF104', NULL, NULL, NULL, NULL, 'OS02G0722700 PROTEIN', 239887),
(307731, 'PTHR11208:SF148', NULL, NULL, NULL, NULL, 'BRANCHPOINT-BRIDGING PROTEIN', 239887),
(307732, 'PTHR11208:SF92', NULL, NULL, NULL, NULL, 'KH DOMAIN-CONTAINING PROTEIN', 239887),
(307733, 'PTHR11208:SF150', NULL, NULL, NULL, NULL, '', 239887),
(307734, 'PTHR11208:SF132', NULL, NULL, NULL, NULL, 'PROTEIN QUAKING', 239887),
(307735, 'PTHR11208:SF30', NULL, NULL, NULL, NULL, 'KH DOMAIN-CONTAINING, RNA-BINDING, SIGNAL TRANSDUCTION-ASSOCIATED PROTEIN 1', 239887),
(307736, 'PTHR11208:SF131', NULL, NULL, NULL, NULL, 'PROTEIN QUAKING-A', 239887),
(307737, 'PTHR11208:SF51', NULL, NULL, NULL, NULL, 'KH DOMAIN-CONTAINING, RNA-BINDING, SIGNAL TRANSDUCTION-ASSOCIATED 1A', 239887),
(307738, 'PTHR11208:SF151', NULL, NULL, NULL, NULL, 'ZINC FINGER, CCHC-TYPE-RELATED', 239887),
(307739, 'PTHR11208', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN RELATED', 239887),
(307740, 'PTHR11208:SF29', NULL, NULL, NULL, NULL, 'KH DOMAIN-CONTAINING, RNA-BINDING, SIGNAL TRANSDUCTION-ASSOCIATED PROTEIN 3', 239887),
(307741, 'PTHR11208:SF45', NULL, NULL, NULL, NULL, 'SPLICING FACTOR 1', 239887),
(307742, 'PTHR11208:SF46', NULL, NULL, NULL, NULL, 'KH DOMAIN-CONTAINING PROTEIN', 239887),
(307743, 'PTHR11208:SF111', NULL, NULL, NULL, NULL, 'KH DOMAIN-CONTAINING PROTEIN', 239887),
(307744, 'PTHR11208:SF49', NULL, NULL, NULL, NULL, 'OS01G0818300 PROTEIN', 239887),
(307745, 'PTHR11208:SF117', NULL, NULL, NULL, NULL, 'PROTEIN CBG06045', 239887),
(307746, 'PTHR11208:SF137', NULL, NULL, NULL, NULL, 'KH DOMAIN-CONTAINING PROTEIN', 239887),
(307747, 'PTHR23169:SF32', NULL, NULL, NULL, NULL, 'PLECTIN A', 239888),
(307748, 'PTHR23169:SF10', NULL, NULL, NULL, NULL, 'PERIPLAKIN', 239888),
(307749, 'PTHR23169:SF21', NULL, NULL, NULL, NULL, 'EPIPLAKIN', 239888),
(307750, 'PTHR23169:SF20', NULL, NULL, NULL, NULL, 'PLECTIN', 239888),
(307751, 'PTHR23169:SF26', NULL, NULL, NULL, NULL, 'DESMOPLAKIN', 239888),
(307752, 'PTHR23169:SF7', NULL, NULL, NULL, NULL, 'ENVOPLAKIN', 239888),
(307753, 'PTHR23169:SF23', NULL, NULL, NULL, NULL, 'SHORT STOP, ISOFORM H', 239888),
(307754, 'PTHR23169:SF25', NULL, NULL, NULL, NULL, 'MICROTUBULE-ACTIN CROSS-LINKING FACTOR 1, ISOFORMS 1/2/3/5', 239888),
(307755, 'PTHR23169', NULL, NULL, NULL, NULL, 'ENVOPLAKIN', 239888),
(307756, 'PTHR23169:SF24', NULL, NULL, NULL, NULL, 'DYSTONIN', 239888),
(307757, 'PTHR35531:SF1', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YBCI-RELATED', 239889),
(307758, 'PTHR35531', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YBCI-RELATED', 239889),
(307759, 'PTHR42951:SF20', NULL, NULL, NULL, NULL, 'BETA LACTAMASE', 239890),
(307760, 'PTHR42951:SF21', NULL, NULL, NULL, NULL, 'METALLO-HYDROLASE YQJP-RELATED', 239890),
(307761, 'PTHR42951:SF22', NULL, NULL, NULL, NULL, 'LACTAMASE_B DOMAIN-CONTAINING PROTEIN', 239890),
(307762, 'PTHR42951:SF23', NULL, NULL, NULL, NULL, 'BLL0271 PROTEIN', 239890),
(307763, 'PTHR42951:SF13', NULL, NULL, NULL, NULL, 'LACTAMASE_B DOMAIN-CONTAINING PROTEIN', 239890),
(307764, 'PTHR42951:SF14', NULL, NULL, NULL, NULL, 'METALLO-BETA-LACTAMASE SUPERFAMILY PROTEIN', 239890),
(307765, 'PTHR42951:SF4', NULL, NULL, NULL, NULL, 'METALLO-BETA-LACTAMASE DOMAIN-CONTAINING PROTEIN 2', 239890),
(307766, 'PTHR42951:SF15', NULL, NULL, NULL, NULL, 'METALLO-BETA-LACTAMASE SUPERFAMILY PROTEIN', 239890),
(307767, 'PTHR42951:SF17', NULL, NULL, NULL, NULL, 'LACTAMASE_B DOMAIN-CONTAINING PROTEIN', 239890),
(307768, 'PTHR42951:SF18', NULL, NULL, NULL, NULL, 'METALLO-HYDROLASE MJ0296-RELATED', 239890),
(307769, 'PTHR42951:SF9', NULL, NULL, NULL, NULL, 'METAL-DEPENDENT HYDROLASE', 239890),
(307770, 'PTHR42951', NULL, NULL, NULL, NULL, 'METALLO-BETA-LACTAMASE DOMAIN-CONTAINING', 239890),
(307771, 'PTHR35718', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239891),
(307772, 'PTHR35718:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239891);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(307773, 'PTHR35718:SF2', NULL, NULL, NULL, NULL, 'PROLINE-RICH RECEPTOR-LIKE KINASE', 239891),
(307774, 'PTHR35718:SF3', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 239891),
(307775, 'PTHR35718:SF4', NULL, NULL, NULL, NULL, 'BNAA04G28410D PROTEIN', 239891),
(307776, 'PTHR22091', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239892),
(307777, 'PTHR22091:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 77', 239892),
(307778, 'PTHR46181', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL GLYCINE TRANSPORTER', 239893),
(307779, 'PTHR46181:SF2', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL GLYCINE TRANSPORTER B', 239893),
(307780, 'PTHR46181:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL GLYCINE TRANSPORTER A', 239893),
(307781, 'PTHR46181:SF3', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL GLYCINE TRANSPORTER', 239893),
(307782, 'PTHR47975:SF54', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239894),
(307783, 'PTHR47975:SF10', NULL, NULL, NULL, NULL, 'S-LOCUS RECEPTOR-LIKE PROTEIN KINASE FAMILY PROTEIN-RELATED', 239894),
(307784, 'PTHR47975:SF55', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239894),
(307785, 'PTHR47975:SF11', NULL, NULL, NULL, NULL, 'OS10G0200000 PROTEIN', 239894),
(307786, 'PTHR47975:SF52', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RPM1', 239894),
(307787, 'PTHR47975:SF53', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239894),
(307788, 'PTHR47975:SF50', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE', 239894),
(307789, 'PTHR47975:SF51', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239894),
(307790, 'PTHR47975:SF18', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE SD1-6', 239894),
(307791, 'PTHR47975:SF19', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239894),
(307792, 'PTHR47975:SF14', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239894),
(307793, 'PTHR47975:SF58', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239894),
(307794, 'PTHR47975:SF59', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239894),
(307795, 'PTHR47975:SF15', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239894),
(307796, 'PTHR47975:SF12', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239894),
(307797, 'PTHR47975:SF13', NULL, NULL, NULL, NULL, 'OS06G0142650 PROTEIN', 239894),
(307798, 'PTHR47975:SF57', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239894),
(307799, 'PTHR47975:SF65', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 19', 239894),
(307800, 'PTHR47975:SF21', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239894),
(307801, 'PTHR47975:SF22', NULL, NULL, NULL, NULL, 'G-TYPE LECTIN S-RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE SD2-2', 239894),
(307802, 'PTHR47975:SF66', NULL, NULL, NULL, NULL, 'OS11G0212300 PROTEIN', 239894),
(307803, 'PTHR47975:SF63', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239894),
(307804, 'PTHR47975:SF64', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239894),
(307805, 'PTHR47975:SF61', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE', 239894),
(307806, 'PTHR47975:SF62', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239894),
(307807, 'PTHR47975:SF60', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239894),
(307808, 'PTHR47975:SF29', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239894),
(307809, 'PTHR47975:SF27', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 239894),
(307810, 'PTHR47975:SF26', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239894),
(307811, 'PTHR47975:SF23', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239894),
(307812, 'PTHR47975:SF32', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239894);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(307813, 'PTHR47975:SF33', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239894),
(307814, 'PTHR47975:SF31', NULL, NULL, NULL, NULL, 'OS11G0274700 PROTEIN', 239894),
(307815, 'PTHR47975:SF39', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239894),
(307816, 'PTHR47975', NULL, NULL, NULL, NULL, 'S-LOCUS LECTIN KINASE FAMILY PROTEIN', 239894),
(307817, 'PTHR47975:SF43', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 239894),
(307818, 'PTHR47975:SF41', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 6', 239894),
(307819, 'PTHR47975:SF42', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN CONTAINING PROTEIN EXPRESSED', 239894),
(307820, 'PTHR47975:SF40', NULL, NULL, NULL, NULL, 'OS01G0648600 PROTEIN', 239894),
(307821, 'PTHR47975:SF49', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239894),
(307822, 'PTHR47975:SF47', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239894),
(307823, 'PTHR47975:SF4', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239894),
(307824, 'PTHR47975:SF48', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239894),
(307825, 'PTHR47975:SF45', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239894),
(307826, 'PTHR47975:SF5', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239894),
(307827, 'PTHR47975:SF6', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239894),
(307828, 'PTHR47975:SF46', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 6', 239894),
(307829, 'PTHR47975:SF7', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239894),
(307830, 'PTHR47975:SF8', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239894),
(307831, 'PTHR47975:SF9', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 239894),
(307832, 'PTHR47266:SF22', NULL, NULL, NULL, NULL, '', 239895),
(307833, 'PTHR47266:SF9', NULL, NULL, NULL, NULL, 'RETROVIRUS-RELATED POL POLYPROTEIN FROM TRANSPOSON 412-LIKE PROTEIN', 239895),
(307834, 'PTHR47266:SF23', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 239895),
(307835, 'PTHR47266:SF8', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H', 239895),
(307836, 'PTHR47266:SF24', NULL, NULL, NULL, NULL, 'RETROVIRUS-RELATED POL POLYPROTEIN FROM TRANSPOSON 17.6-LIKE PROTEIN', 239895),
(307837, 'PTHR47266:SF25', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H-LIKE DOMAIN, CHROMO DOMAIN-LIKE, CHROMO DOMAIN PROTEIN-RELATED', 239895),
(307838, 'PTHR47266:SF5', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H', 239895),
(307839, 'PTHR47266:SF4', NULL, NULL, NULL, NULL, 'KRAB-A DOMAIN-CONTAINING PROTEIN 2-LIKE', 239895),
(307840, 'PTHR47266:SF7', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 239895),
(307841, 'PTHR47266:SF20', NULL, NULL, NULL, NULL, '', 239895),
(307842, 'PTHR47266:SF21', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 239895),
(307843, 'PTHR47266:SF6', NULL, NULL, NULL, NULL, 'GYPSY RETROTRANSPOSON INTEGRASE-LIKE PROTEIN 1', 239895),
(307844, 'PTHR47266:SF3', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 239895),
(307845, 'PTHR47266:SF2', NULL, NULL, NULL, NULL, 'POLYPROTEIN/RETROTRANSPOSON, PUTATIVE-RELATED', 239895),
(307846, 'PTHR47266:SF26', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 239895),
(307847, 'PTHR47266:SF27', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN-RELATED', 239895),
(307848, 'PTHR47266:SF28', NULL, NULL, NULL, NULL, 'TRANSPOSON TF2-1 POLYPROTEIN-RELATED', 239895),
(307849, 'PTHR47266:SF29', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 239895),
(307850, 'PTHR47266:SF11', NULL, NULL, NULL, NULL, '', 239895),
(307851, 'PTHR47266:SF12', NULL, NULL, NULL, NULL, 'PROTEIN NYNRIN-LIKE', 239895),
(307852, 'PTHR47266:SF13', NULL, NULL, NULL, NULL, 'RT_RNASEH_2 DOMAIN-CONTAINING PROTEIN', 239895);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(307853, 'PTHR47266:SF14', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 239895),
(307854, 'PTHR47266:SF30', NULL, NULL, NULL, NULL, 'TRANSPOSON TY3-G GAG-POL POLYPROTEIN-RELATED', 239895),
(307855, 'PTHR47266:SF10', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H', 239895),
(307856, 'PTHR47266', NULL, NULL, NULL, NULL, 'ENDONUCLEASE-RELATED', 239895),
(307857, 'PTHR47266:SF19', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 239895),
(307858, 'PTHR47266:SF15', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN-RELATED', 239895),
(307859, 'PTHR47266:SF16', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H', 239895),
(307860, 'PTHR47266:SF17', NULL, NULL, NULL, NULL, 'PROTEIN NYNRIN-LIKE', 239895),
(307861, 'PTHR47266:SF18', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 239895),
(307862, 'PTHR38440', NULL, NULL, NULL, NULL, 'UPF0398 PROTEIN YPSA', 239896),
(307863, 'PTHR38440:SF1', NULL, NULL, NULL, NULL, 'UPF0398 PROTEIN SPR0331', 239896),
(307864, 'PTHR35004:SF6', NULL, NULL, NULL, NULL, 'TRANSPOSASE RV3428C-RELATED', 239897),
(307865, 'PTHR35004', NULL, NULL, NULL, NULL, 'TRANSPOSASE RV3428C-RELATED', 239897),
(307866, 'PTHR35004:SF7', NULL, NULL, NULL, NULL, 'BLL1997 PROTEIN', 239897),
(307867, 'PTHR42701:SF2', NULL, NULL, NULL, NULL, 'IMIDAZOLE GLYCEROL PHOSPHATE SYNTHASE SUBUNIT HISH 1', 239898),
(307868, 'PTHR42701:SF1', NULL, NULL, NULL, NULL, 'IMIDAZOLE GLYCEROL PHOSPHATE SYNTHASE SUBUNIT HISH', 239898),
(307869, 'PTHR42701', NULL, NULL, NULL, NULL, 'IMIDAZOLE GLYCEROL PHOSPHATE SYNTHASE SUBUNIT HISH', 239898),
(307870, 'PTHR18804:SF17', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN', 239899),
(307871, 'PTHR18804:SF16', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN', 239899),
(307872, 'PTHR18804', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN', 239899),
(307873, 'PTHR31822', NULL, NULL, NULL, NULL, 'SERINE-RICH SINGLE-PASS MEMBRANE PROTEIN 1', 239900),
(307874, 'PTHR31822:SF1', NULL, NULL, NULL, NULL, 'SERINE-RICH SINGLE-PASS MEMBRANE PROTEIN 1', 239900),
(307875, 'PTHR32246:SF63', NULL, NULL, NULL, NULL, 'OS07G0670300 PROTEIN', 239901),
(307876, 'PTHR32246:SF64', NULL, NULL, NULL, NULL, 'C2 DOMAIN PROTEIN', 239901),
(307877, 'PTHR32246:SF20', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT LIPID-BINDING (CALB DOMAIN) FAMILY PROTEIN', 239901),
(307878, 'PTHR32246:SF21', NULL, NULL, NULL, NULL, 'OS02G0518000 PROTEIN', 239901),
(307879, 'PTHR32246:SF66', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307880, 'PTHR32246:SF22', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307881, 'PTHR32246:SF117', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307882, 'PTHR32246:SF67', NULL, NULL, NULL, NULL, 'PROTEIN SRC2-LIKE PROTEIN', 239901),
(307883, 'PTHR32246:SF68', NULL, NULL, NULL, NULL, 'OS01G0853800 PROTEIN', 239901),
(307884, 'PTHR32246:SF24', NULL, NULL, NULL, NULL, 'OS07G0670200 PROTEIN', 239901),
(307885, 'PTHR32246:SF69', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT LIPID-BINDING (CALB DOMAIN) FAMILY PROTEIN', 239901),
(307886, 'PTHR32246:SF27', NULL, NULL, NULL, NULL, 'OS05G0370300 PROTEIN', 239901),
(307887, 'PTHR32246:SF28', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307888, 'PTHR32246:SF151', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307889, 'PTHR32246:SF114', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307890, 'PTHR32246:SF158', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307891, 'PTHR32246:SF115', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307892, 'PTHR32246:SF159', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307893, 'PTHR32246:SF112', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307894, 'PTHR32246:SF156', NULL, NULL, NULL, NULL, 'LIPID-BINDING FAMILY PROTEIN, PUTATIVE-RELATED', 239901),
(307895, 'PTHR32246:SF157', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307896, 'PTHR32246:SF154', NULL, NULL, NULL, NULL, 'C2 DOMAIN PROTEIN', 239901); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(307897, 'PTHR32246:SF155', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307898, 'PTHR32246:SF111', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307899, 'PTHR32246:SF152', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307900, 'PTHR32246:SF153', NULL, NULL, NULL, NULL, 'LIPID-BINDING (CALB DOMAIN) FAMILY PROTEIN, PUTATIVE-RELATED', 239901),
(307901, 'PTHR32246:SF70', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT LIPID-BINDING (CALB DOMAIN) FAMILY PROTEIN', 239901),
(307902, 'PTHR32246:SF71', NULL, NULL, NULL, NULL, 'PROTEIN SRC2 HOMOLOG', 239901),
(307903, 'PTHR32246:SF72', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT LIPID-BINDING (CALB DOMAIN) FAMILY PROTEIN', 239901),
(307904, 'PTHR32246:SF74', NULL, NULL, NULL, NULL, 'BON1-ASSOCIATED-LIKE PROTEIN', 239901),
(307905, 'PTHR32246:SF129', NULL, NULL, NULL, NULL, 'PROTEIN SRC2-LIKE', 239901),
(307906, 'PTHR32246:SF76', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT LIPID-BINDING (CALB DOMAIN) FAMILY PROTEIN', 239901),
(307907, 'PTHR32246:SF161', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307908, 'PTHR32246:SF162', NULL, NULL, NULL, NULL, 'PROTEIN SRC2-LIKE', 239901),
(307909, 'PTHR32246:SF160', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307910, 'PTHR32246:SF123', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307911, 'PTHR32246:SF124', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN-RELATED', 239901),
(307912, 'PTHR32246:SF165', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307913, 'PTHR32246:SF121', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307914, 'PTHR32246:SF166', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307915, 'PTHR32246:SF80', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307916, 'PTHR32246:SF163', NULL, NULL, NULL, NULL, 'PROTEIN SRC2-LIKE', 239901),
(307917, 'PTHR32246:SF120', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307918, 'PTHR32246:SF164', NULL, NULL, NULL, NULL, 'PROTEIN SRC2-LIKE PROTEIN', 239901),
(307919, 'PTHR32246:SF83', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT LIPID-BINDING (CALB DOMAIN) FAMILY PROTEIN', 239901),
(307920, 'PTHR32246:SF87', NULL, NULL, NULL, NULL, 'PROTEIN SRC2-LIKE', 239901),
(307921, 'PTHR32246:SF138', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307922, 'PTHR32246:SF88', NULL, NULL, NULL, NULL, 'PROTEIN SRC2 HOMOLOG', 239901),
(307923, 'PTHR32246:SF139', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307924, 'PTHR32246:SF136', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307925, 'PTHR32246:SF137', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT LIPID-BINDING (CALB DOMAIN) FAMILY PROTEIN', 239901),
(307926, 'PTHR32246:SF134', NULL, NULL, NULL, NULL, 'BON1-ASSOCIATED PROTEIN 1', 239901),
(307927, 'PTHR32246:SF132', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307928, 'PTHR32246:SF133', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307929, 'PTHR32246:SF91', NULL, NULL, NULL, NULL, 'PROTEIN SRC2 HOMOLOG', 239901),
(307930, 'PTHR32246:SF130', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307931, 'PTHR32246:SF109', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307932, 'PTHR32246:SF96', NULL, NULL, NULL, NULL, 'PROTEIN SRC2 HOMOLOG', 239901),
(307933, 'PTHR32246:SF107', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307934, 'PTHR32246:SF97', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT LIPID-BINDING (CALB DOMAIN) FAMILY PROTEIN', 239901),
(307935, 'PTHR32246:SF99', NULL, NULL, NULL, NULL, 'OS05G0149100 PROTEIN', 239901),
(307936, 'PTHR32246:SF106', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307937, 'PTHR32246:SF15', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT LIPID-BINDING (CALB DOMAIN) FAMILY PROTEIN', 239901),
(307938, 'PTHR32246:SF17', NULL, NULL, NULL, NULL, 'BON1-ASSOCIATED PROTEIN 2', 239901),
(307939, 'PTHR32246:SF103', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT LIPID-BINDING (CALB DOMAIN) FAMILY PROTEIN', 239901); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(307940, 'PTHR32246:SF101', NULL, NULL, NULL, NULL, 'OS01G0934100 PROTEIN', 239901),
(307941, 'PTHR32246:SF145', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307942, 'PTHR32246:SF146', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307943, 'PTHR32246:SF143', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 239901),
(307944, 'PTHR32246:SF100', NULL, NULL, NULL, NULL, 'PROTEIN SRC2', 239901),
(307945, 'PTHR32246:SF144', NULL, NULL, NULL, NULL, 'MYB-LIKE PROTEIN W', 239901),
(307946, 'PTHR32246', NULL, NULL, NULL, NULL, 'INGRESSION PROTEIN FIC1', 239901),
(307947, 'PTHR32246:SF142', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT LIPID-BINDING (CALB DOMAIN) FAMILY PROTEIN', 239901),
(307948, 'PTHR13518', NULL, NULL, NULL, NULL, 'PUTATIVE TREBLE-CLEF ZINC-FINGER C2ORF42 FAMILY MEMBER', 239902),
(307949, 'PTHR13518:SF1', NULL, NULL, NULL, NULL, 'RGD1306746 PROTEIN', 239902),
(307950, 'PTHR46365:SF1', NULL, NULL, NULL, NULL, 'COPPER TRANSPORT PROTEIN ATOX1', 239903),
(307951, 'PTHR46365', NULL, NULL, NULL, NULL, 'COPPER TRANSPORT PROTEIN ATOX1', 239903),
(307952, 'PTHR10270', NULL, NULL, NULL, NULL, 'SOX TRANSCRIPTION FACTOR', 239904),
(307953, 'PTHR10270:SF161', NULL, NULL, NULL, NULL, 'SOX DOMAIN-CONTAINING PROTEIN DICHAETE-RELATED', 239904),
(307954, 'PTHR10270:SF283', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SOX-19B', 239904),
(307955, 'PTHR10270:SF45', NULL, NULL, NULL, NULL, 'PROTEIN SOX-15', 239904),
(307956, 'PTHR10270:SF27', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SOX-4', 239904),
(307957, 'PTHR10270:SF216', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SOX-17', 239904),
(307958, 'PTHR10270:SF315', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SOX-1A-RELATED', 239904),
(307959, 'PTHR10270:SF40', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SOX-1', 239904),
(307960, 'PTHR10270:SF316', NULL, NULL, NULL, NULL, 'HMG BOX DOMAIN-CONTAINING PROTEIN-RELATED', 239904),
(307961, 'PTHR10270:SF317', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SOX-15-RELATED', 239904),
(307962, 'PTHR10270:SF318', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SOX-3', 239904),
(307963, 'PTHR10270:SF319', NULL, NULL, NULL, NULL, 'SEX-DETERMINING REGION Y PROTEIN', 239904),
(307964, 'PTHR10270:SF231', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SOX-2', 239904),
(307965, 'PTHR10270:SF210', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SOX-7', 239904),
(307966, 'PTHR10270:SF111', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SOX-3', 239904),
(307967, 'PTHR10270:SF199', NULL, NULL, NULL, NULL, 'SEX-DETERMINING REGION Y PROTEIN', 239904),
(307968, 'PTHR10270:SF310', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SEM-2', 239904),
(307969, 'PTHR10270:SF113', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SOX-11', 239904),
(307970, 'PTHR10270:SF312', NULL, NULL, NULL, NULL, 'HMG BOX DOMAIN-CONTAINING PROTEIN', 239904),
(307971, 'PTHR10270:SF313', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SOX-21', 239904),
(307972, 'PTHR10270:SF314', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SOX-2', 239904),
(307973, 'PTHR10270:SF295', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SOX', 239904),
(307974, 'PTHR10270:SF107', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SOX-14', 239904),
(307975, 'PTHR10270:SF11', NULL, NULL, NULL, NULL, 'SRY-BOX TRANSCRIPTION FACTOR 32', 239904),
(307976, 'PTHR10270:SF320', NULL, NULL, NULL, NULL, 'HMG BOX DOMAIN-CONTAINING PROTEIN-RELATED', 239904),
(307977, 'PTHR10270:SF221', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SOX-12', 239904),
(307978, 'PTHR10270:SF321', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SOX-2', 239904),
(307979, 'PTHR10270:SF302', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SOX-21-B', 239904),
(307980, 'PTHR10270:SF204', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SOX-18', 239904),
(307981, 'PTHR46565:SF9', NULL, NULL, NULL, NULL, 'COLD SHOCK PROTEIN 1-LIKE', 239905),
(307982, 'PTHR46565:SF19', NULL, NULL, NULL, NULL, 'COLD SHOCK DOMAIN PROTEIN 1', 239905),
(307983, 'PTHR46565:SF18', NULL, NULL, NULL, NULL, 'COLD SHOCK PROTEIN 1', 239905);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(307984, 'PTHR46565', NULL, NULL, NULL, NULL, 'COLD SHOCK DOMAIN PROTEIN 2', 239905),
(307985, 'PTHR46565:SF20', NULL, NULL, NULL, NULL, 'COLD SHOCK DOMAIN-CONTAINING PROTEIN 4', 239905),
(307986, 'PTHR46565:SF17', NULL, NULL, NULL, NULL, 'COLD SHOCK PROTEIN 2', 239905),
(307987, 'PTHR46565:SF16', NULL, NULL, NULL, NULL, 'SHOCK PROTEIN, PUTATIVE-RELATED', 239905),
(307988, 'PTHR46565:SF26', NULL, NULL, NULL, NULL, 'COLD SHOCK PROTEIN 2', 239905),
(307989, 'PTHR46565:SF25', NULL, NULL, NULL, NULL, 'COLD SHOCK DOMAIN PROTEIN 2', 239905),
(307990, 'PTHR46565:SF24', NULL, NULL, NULL, NULL, 'BNAA09G43450D PROTEIN', 239905),
(307991, 'PTHR46565:SF23', NULL, NULL, NULL, NULL, 'COLD SHOCK DOMAIN-CONTAINING PROTEIN 3', 239905),
(307992, 'PTHR46565:SF5', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN 2-LIKE', 239905),
(307993, 'PTHR46565:SF22', NULL, NULL, NULL, NULL, 'COLD SHOCK DOMAIN-CONTAINING PROTEIN 3-LIKE', 239905),
(307994, 'PTHR46565:SF21', NULL, NULL, NULL, NULL, '', 239905),
(307995, 'PTHR46565:SF10', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN 2', 239905),
(307996, 'PTHR33389:SF7', NULL, NULL, NULL, NULL, 'OS01G0678000 PROTEIN', 239906),
(307997, 'PTHR33389:SF28', NULL, NULL, NULL, NULL, '', 239906),
(307998, 'PTHR33389:SF17', NULL, NULL, NULL, NULL, '', 239906),
(307999, 'PTHR33389:SF16', NULL, NULL, NULL, NULL, '', 239906),
(308000, 'PTHR33389:SF3', NULL, NULL, NULL, NULL, 'OS07G0580700 PROTEIN', 239906),
(308001, 'PTHR33389:SF29', NULL, NULL, NULL, NULL, '', 239906),
(308002, 'PTHR33389:SF18', NULL, NULL, NULL, NULL, 'DUF2921 FAMILY PROTEIN', 239906),
(308003, 'PTHR33389:SF4', NULL, NULL, NULL, NULL, 'PII, URIDYLYLTRANSFERASE (DUF2921)', 239906),
(308004, 'PTHR33389:SF35', NULL, NULL, NULL, NULL, '', 239906),
(308005, 'PTHR33389:SF34', NULL, NULL, NULL, NULL, '', 239906),
(308006, 'PTHR33389:SF23', NULL, NULL, NULL, NULL, 'DUF2921 FAMILY PROTEIN', 239906),
(308007, 'PTHR33389:SF26', NULL, NULL, NULL, NULL, '', 239906),
(308008, 'PTHR33389:SF20', NULL, NULL, NULL, NULL, '', 239906),
(308009, 'PTHR33389:SF22', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE (DUF2921)-RELATED', 239906),
(308010, 'PTHR33389:SF33', NULL, NULL, NULL, NULL, 'OS01G0677900 PROTEIN', 239906),
(308011, 'PTHR33389', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE (DUF2921)-RELATED', 239906),
(308012, 'PTHR21649:SF171', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN, CHLOROPLASTIC', 239907),
(308013, 'PTHR21649:SF6', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN CP29.1, CHLOROPLASTIC', 239907),
(308014, 'PTHR21649:SF5', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I CHLOROPHYLL A/B-BINDING PROTEIN 6, CHLOROPLASTIC', 239907),
(308015, 'PTHR21649:SF91', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN, CHLOROPLASTIC', 239907),
(308016, 'PTHR21649:SF172', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN 3, CHLOROPLASTIC', 239907),
(308017, 'PTHR21649:SF173', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN, CHLOROPLASTIC', 239907),
(308018, 'PTHR21649:SF4', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN 4, CHLOROPLASTIC', 239907),
(308019, 'PTHR21649:SF174', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN, CHLOROPLASTIC', 239907),
(308020, 'PTHR21649:SF2', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN, CHLOROPLASTIC', 239907),
(308021, 'PTHR21649', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A/B BINDING PROTEIN', 239907),
(308022, 'PTHR21649:SF170', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN, CHLOROPLASTIC', 239907),
(308023, 'PTHR21649:SF7', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN 3, CHLOROPLASTIC', 239907),
(308024, 'PTHR21649:SF89', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN 6, CHLOROPLASTIC', 239907),
(308025, 'PTHR21649:SF136', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN, CHLOROPLASTIC', 239907),
(308026, 'PTHR21649:SF137', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN CP24 10B, CHLOROPLASTIC', 239907),
(308027, 'PTHR21649:SF138', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN, CHLOROPLASTIC', 239907);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(308028, 'PTHR21649:SF175', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN 1, CHLOROPLASTIC-RELATED', 239907),
(308029, 'PTHR21649:SF176', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN, CHLOROPLASTIC', 239907),
(308030, 'PTHR21649:SF133', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN 7, CHLOROPLASTIC', 239907),
(308031, 'PTHR21649:SF177', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN, CHLOROPLASTIC', 239907),
(308032, 'PTHR21649:SF134', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN, CHLOROPLASTIC', 239907),
(308033, 'PTHR21649:SF160', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN, CHLOROPLASTIC', 239907),
(308034, 'PTHR21649:SF161', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN, CHLOROPLASTIC', 239907),
(308035, 'PTHR21649:SF162', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN 2, CHLOROPLASTIC', 239907),
(308036, 'PTHR21649:SF163', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN, CHLOROPLASTIC', 239907),
(308037, 'PTHR21649:SF16', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN CP26, CHLOROPLASTIC', 239907),
(308038, 'PTHR21649:SF14', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I CHLOROPHYLL A/B-BINDING PROTEIN 3-1, CHLOROPLASTIC', 239907),
(308039, 'PTHR21649:SF128', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN, CHLOROPLASTIC', 239907),
(308040, 'PTHR21649:SF168', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN, CHLOROPLASTIC', 239907),
(308041, 'PTHR21649:SF169', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN 21, CHLOROPLASTIC', 239907),
(308042, 'PTHR21649:SF125', NULL, NULL, NULL, NULL, 'LIGHT-HARVESTING COMPLEX STRESS-RELATED PROTEIN 3.2, CHLOROPLASTIC', 239907),
(308043, 'PTHR21649:SF164', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN, CHLOROPLASTIC', 239907),
(308044, 'PTHR21649:SF120', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN, CHLOROPLASTIC', 239907),
(308045, 'PTHR21649:SF165', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN, CHLOROPLASTIC', 239907),
(308046, 'PTHR21649:SF121', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN, CHLOROPLASTIC', 239907),
(308047, 'PTHR21649:SF166', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN 48, CHLOROPLASTIC', 239907),
(308048, 'PTHR21649:SF122', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN, CHLOROPLASTIC', 239907),
(308049, 'PTHR21649:SF123', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN 1C, CHLOROPLASTIC', 239907),
(308050, 'PTHR21649:SF167', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN 8, CHLOROPLASTIC', 239907),
(308051, 'PTHR21649:SF150', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN, CHLOROPLASTIC', 239907),
(308052, 'PTHR21649:SF151', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN 1B, CHLOROPLASTIC', 239907),
(308053, 'PTHR21649:SF33', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN 2.1, CHLOROPLASTIC-RELATED', 239907),
(308054, 'PTHR21649:SF74', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN 7, CHLOROPLASTIC', 239907),
(308055, 'PTHR21649:SF71', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN CP29.2, CHLOROPLASTIC', 239907),
(308056, 'PTHR21649:SF118', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN, CHLOROPLASTIC', 239907),
(308057, 'PTHR21649:SF67', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I CHLOROPHYLL A/B-BINDING PROTEIN 5, CHLOROPLASTIC', 239907),
(308058, 'PTHR21649:SF157', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN, CHLOROPLASTIC', 239907),
(308059, 'PTHR21649:SF158', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN 40, CHLOROPLASTIC', 239907),
(308060, 'PTHR21649:SF159', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN M9, CHLOROPLASTIC', 239907),
(308061, 'PTHR21649:SF111', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN 4, CHLOROPLASTIC', 239907),
(308062, 'PTHR21649:SF80', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I CHLOROPHYLL A/B-BINDING PROTEIN 2, CHLOROPLASTIC', 239907),
(308063, 'PTHR21649:SF83', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN CP29.3, CHLOROPLASTIC', 239907);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(308064, 'PTHR21649:SF81', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN, CHLOROPLASTIC', 239907),
(308065, 'PTHR21649:SF108', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN 1, CHLOROPLASTIC', 239907),
(308066, 'PTHR21649:SF147', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN, CHLOROPLASTIC', 239907),
(308067, 'PTHR21649:SF143', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN 2.4, CHLOROPLASTIC', 239907),
(308068, 'PTHR21649:SF100', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN, CHLOROPLASTIC', 239907),
(308069, 'PTHR21649:SF144', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A-B BINDING PROTEIN, CHLOROPLASTIC', 239907),
(308070, 'PTHR47846', NULL, NULL, NULL, NULL, 'OS06G0681300 PROTEIN-RELATED', 239908),
(308071, 'PTHR47846:SF1', NULL, NULL, NULL, NULL, 'OS06G0681300 PROTEIN', 239908),
(308072, 'PTHR47846:SF3', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN', 239908),
(308073, 'PTHR47846:SF5', NULL, NULL, NULL, NULL, 'WASP-RELATED PROTEIN', 239908),
(308074, 'PTHR47846:SF4', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN', 239908),
(308075, 'PTHR31789:SF6', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN', 239909),
(308076, 'PTHR31789:SF7', NULL, NULL, NULL, NULL, '', 239909),
(308077, 'PTHR31789:SF1', NULL, NULL, NULL, NULL, 'OS05G0482600 PROTEIN', 239909),
(308078, 'PTHR31789', NULL, NULL, NULL, NULL, 'OS05G0482600 PROTEIN', 239909),
(308079, 'PTHR31789:SF4', NULL, NULL, NULL, NULL, 'OS01G0817800 PROTEIN', 239909),
(308080, 'PTHR31789:SF11', NULL, NULL, NULL, NULL, 'WD40/YVTN REPEAT-LIKE-CONTAINING DOMAIN-CONTAINING PROTEIN-RELATED', 239909),
(308081, 'PTHR31789:SF10', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN', 239909),
(308082, 'PTHR31789:SF13', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN-RELATED', 239909),
(308083, 'PTHR31789:SF14', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR WD40-LIKE FAMILY-RELATED', 239909),
(308084, 'PTHR31789:SF9', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239909),
(308085, 'PTHR15228:SF24', NULL, NULL, NULL, NULL, 'RHO-GAP DOMAIN-CONTAINING PROTEIN', 239910),
(308086, 'PTHR15228:SF36', NULL, NULL, NULL, NULL, 'SI:CH211-247J9.1', 239910),
(308087, 'PTHR15228:SF25', NULL, NULL, NULL, NULL, 'SPERMATHECAL PHYSIOLOGY VARIANT', 239910),
(308088, 'PTHR15228:SF16', NULL, NULL, NULL, NULL, 'GEM-INTERACTING PROTEIN', 239910),
(308089, 'PTHR15228:SF7', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 29', 239910),
(308090, 'PTHR15228:SF18', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 45', 239910),
(308091, 'PTHR15228:SF19', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 24', 239910),
(308092, 'PTHR15228', NULL, NULL, NULL, NULL, 'SPERMATHECAL PHYSIOLOGY VARIANT', 239910),
(308093, 'PTHR15228:SF20', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 25', 239910),
(308094, 'PTHR15228:SF22', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 22', 239910),
(308095, 'PTHR24305:SF218', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 239911),
(308096, 'PTHR24305:SF216', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 239911),
(308097, 'PTHR24305:SF6', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 302A1, MITOCHONDRIAL', 239911),
(308098, 'PTHR24305:SF215', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 MONOOXYGENASE CICH-RELATED', 239911),
(308099, 'PTHR24305:SF30', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 301A1, MITOCHONDRIAL-RELATED', 239911),
(308100, 'PTHR24305:SF213', NULL, NULL, NULL, NULL, '', 239911),
(308101, 'PTHR24305:SF210', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 MONOOXYGENASE ASQL-RELATED', 239911),
(308102, 'PTHR24305:SF175', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 MONOOXYGENASE PKFB', 239911),
(308103, 'PTHR24305:SF176', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 239911),
(308104, 'PTHR24305:SF78', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 239911),
(308105, 'PTHR24305:SF77', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 MONOOXYGENASE', 239911);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(308106, 'PTHR24305:SF172', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 239911),
(308107, 'PTHR24305:SF108', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 239911),
(308108, 'PTHR24305:SF229', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 239911),
(308109, 'PTHR24305:SF227', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 239911),
(308110, 'PTHR24305:SF228', NULL, NULL, NULL, NULL, 'P450 MONOOXYGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G03930)-RELATED', 239911),
(308111, 'PTHR24305:SF107', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 239911),
(308112, 'PTHR24305:SF226', NULL, NULL, NULL, NULL, '', 239911),
(308113, 'PTHR24305:SF223', NULL, NULL, NULL, NULL, 'CYTOCHROME P450-DIT2', 239911),
(308114, 'PTHR24305:SF85', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 239911),
(308115, 'PTHR24305:SF147', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 239911),
(308116, 'PTHR24305:SF224', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 313A1-RELATED', 239911),
(308117, 'PTHR24305:SF103', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 239911),
(308118, 'PTHR24305:SF188', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 239911),
(308119, 'PTHR24305:SF222', NULL, NULL, NULL, NULL, 'P450 MONOOXYGENASE, PUTATIVE-RELATED', 239911),
(308120, 'PTHR24305:SF187', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 239911),
(308121, 'PTHR24305:SF87', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 MONOOXYGENASE ALND-RELATED', 239911),
(308122, 'PTHR24305:SF182', NULL, NULL, NULL, NULL, 'STERIGMATOCYSTIN BIOSYNTHESIS P450 MONOOXYGENASE STCS-RELATED', 239911),
(308123, 'PTHR24305:SF180', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 239911),
(308124, 'PTHR24305:SF157', NULL, NULL, NULL, NULL, 'N-ACETYLTRYPTOPHAN 6-HYDROXYLASE IVOC-RELATED', 239911),
(308125, 'PTHR24305:SF96', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 239911),
(308126, 'PTHR24305:SF111', NULL, NULL, NULL, NULL, 'ECDYSONE 20-MONOOXYGENASE', 239911),
(308127, 'PTHR24305:SF199', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 239911),
(308128, 'PTHR24305:SF232', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 MONOOXYGENASE APDB-RELATED', 239911),
(308129, 'PTHR24305:SF233', NULL, NULL, NULL, NULL, 'OS02G0601400 PROTEIN', 239911),
(308130, 'PTHR24305:SF112', NULL, NULL, NULL, NULL, 'L-ORNITHINE-N5-MONOOXYGENASE (EUROFUNG)', 239911),
(308131, 'PTHR24305:SF156', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 239911),
(308132, 'PTHR24305:SF230', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 239911),
(308133, 'PTHR24305:SF231', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 239911),
(308134, 'PTHR24305:SF152', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 239911),
(308135, 'PTHR24305:SF190', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 239911),
(308136, 'PTHR24305', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 239911),
(308137, 'PTHR24305:SF168', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 239911),
(308138, 'PTHR24305:SF202', NULL, NULL, NULL, NULL, '', 239911),
(308139, 'PTHR24305:SF166', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 12A4, MITOCHONDRIAL-RELATED', 239911),
(308140, 'PTHR24305:SF164', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 239911),
(308141, 'PTHR24305:SF162', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 239911),
(308142, 'PTHR24305:SF160', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 239911),
(308143, 'PTHR24305:SF28', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 49A1-RELATED', 239911),
(308144, 'PTHR24305:SF161', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 239911),
(308145, 'PTHR24305:SF29', NULL, NULL, NULL, NULL, 'BENZOATE-PARA-HYDROXYLASE', 239911),
(308146, 'PTHR13463:SF3', NULL, NULL, NULL, NULL, 'PROTEIN C10', 239912),
(308147, 'PTHR13463', NULL, NULL, NULL, NULL, 'PROTEIN C10', 239912),
(308148, 'PTHR14155:SF609', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL29-LIKE', 239913);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(308149, 'PTHR14155:SF607', NULL, NULL, NULL, NULL, 'BNACNNG73870D PROTEIN', 239913),
(308150, 'PTHR14155:SF608', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913),
(308151, 'PTHR14155:SF490', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913),
(308152, 'PTHR14155:SF491', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ATL41', 239913),
(308153, 'PTHR14155:SF86', NULL, NULL, NULL, NULL, 'OS06G0534500 PROTEIN', 239913),
(308154, 'PTHR14155:SF487', NULL, NULL, NULL, NULL, 'OS02G0249300 PROTEIN', 239913),
(308155, 'PTHR14155:SF521', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL30', 239913),
(308156, 'PTHR14155:SF485', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ATL41', 239913),
(308157, 'PTHR14155:SF563', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913),
(308158, 'PTHR14155:SF561', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913),
(308159, 'PTHR14155:SF481', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913),
(308160, 'PTHR14155:SF605', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ATL31-LIKE', 239913),
(308161, 'PTHR14155:SF606', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 239913),
(308162, 'PTHR14155:SF529', NULL, NULL, NULL, NULL, 'OS06G0534900 PROTEIN', 239913),
(308163, 'PTHR14155:SF526', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE OS03G0188200', 239913),
(308164, 'PTHR14155:SF527', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ATL41', 239913),
(308165, 'PTHR14155:SF604', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913),
(308166, 'PTHR14155:SF568', NULL, NULL, NULL, NULL, 'OS02G0759400 PROTEIN', 239913),
(308167, 'PTHR14155:SF525', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913),
(308168, 'PTHR14155:SF522', NULL, NULL, NULL, NULL, 'OS06G0537600 PROTEIN', 239913),
(308169, 'PTHR14155:SF566', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913),
(308170, 'PTHR14155:SF567', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913),
(308171, 'PTHR14155:SF600', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL40', 239913),
(308172, 'PTHR14155:SF618', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL29', 239913),
(308173, 'PTHR14155:SF619', NULL, NULL, NULL, NULL, 'OS01G0213100 PROTEIN', 239913),
(308174, 'PTHR14155:SF575', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913),
(308175, 'PTHR14155:SF499', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913),
(308176, 'PTHR14155:SF576', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ATL6-LIKE', 239913),
(308177, 'PTHR14155:SF573', NULL, NULL, NULL, NULL, 'BNAA08G01790D PROTEIN', 239913),
(308178, 'PTHR14155:SF530', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL39', 239913),
(308179, 'PTHR14155:SF497', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ATL41', 239913),
(308180, 'PTHR14155:SF574', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL28', 239913),
(308181, 'PTHR14155:SF572', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 239913),
(308182, 'PTHR14155:SF493', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C2H2 FAMILY-RELATED', 239913),
(308183, 'PTHR14155:SF570', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913),
(308184, 'PTHR14155:SF616', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL19-RELATED', 239913),
(308185, 'PTHR14155:SF617', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL40-LIKE', 239913),
(308186, 'PTHR14155:SF614', NULL, NULL, NULL, NULL, 'OS08G0484200 PROTEIN', 239913),
(308187, 'PTHR14155:SF615', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ATL9', 239913),
(308188, 'PTHR14155:SF538', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE OS06G0535400', 239913),
(308189, 'PTHR14155:SF612', NULL, NULL, NULL, NULL, 'RING ZINC FINGER DOMAIN SUPERFAMILY PROTEIN-RELATED', 239913),
(308190, 'PTHR14155:SF613', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL34', 239913),
(308191, 'PTHR14155:SF577', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913);
INSERT INTO "PUBLIC"."MODEL" VALUES
(308192, 'PTHR14155:SF610', NULL, NULL, NULL, NULL, 'OS01G0755700 PROTEIN', 239913),
(308193, 'PTHR14155:SF534', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL38', 239913),
(308194, 'PTHR14155:SF578', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ATL31', 239913),
(308195, 'PTHR14155:SF611', NULL, NULL, NULL, NULL, 'ZINC FINGER, C3HC4 TYPE (RING FINGER) PROTEIN', 239913),
(308196, 'PTHR14155:SF590', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL11', 239913),
(308197, 'PTHR14155:SF223', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL3L', 239913),
(308198, 'PTHR14155:SF586', NULL, NULL, NULL, NULL, 'OS06G0536100 PROTEIN', 239913),
(308199, 'PTHR14155:SF620', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913),
(308200, 'PTHR14155:SF585', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913),
(308201, 'PTHR14155:SF263', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ATL6', 239913),
(308202, 'PTHR14155:SF582', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913),
(308203, 'PTHR14155:SF583', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913),
(308204, 'PTHR14155:SF580', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913),
(308205, 'PTHR14155:SF581', NULL, NULL, NULL, NULL, 'OS06G0218300 PROTEIN', 239913),
(308206, 'PTHR14155:SF627', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL17-RELATED', 239913),
(308207, 'PTHR14155:SF506', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ATL15', 239913),
(308208, 'PTHR14155:SF507', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL32', 239913),
(308209, 'PTHR14155:SF625', NULL, NULL, NULL, NULL, 'OS02G0248240 PROTEIN', 239913),
(308210, 'PTHR14155:SF504', NULL, NULL, NULL, NULL, 'OS05G0426066 PROTEIN', 239913),
(308211, 'PTHR14155:SF548', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913),
(308212, 'PTHR14155:SF505', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913),
(308213, 'PTHR14155:SF549', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL2K', 239913),
(308214, 'PTHR14155:SF626', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913),
(308215, 'PTHR14155:SF502', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C2H2 FAMILY-RELATED', 239913),
(308216, 'PTHR14155:SF546', NULL, NULL, NULL, NULL, 'OS02G0572200 PROTEIN', 239913),
(308217, 'PTHR14155:SF623', NULL, NULL, NULL, NULL, 'RING ZINC FINGER DOMAIN SUPERFAMILY PROTEIN-RELATED', 239913),
(308218, 'PTHR14155:SF503', NULL, NULL, NULL, NULL, 'OS03G0340100 PROTEIN', 239913),
(308219, 'PTHR14155:SF624', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913),
(308220, 'PTHR14155:SF547', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL35-RELATED', 239913),
(308221, 'PTHR14155:SF588', NULL, NULL, NULL, NULL, '', 239913),
(308222, 'PTHR14155:SF621', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913),
(308223, 'PTHR14155:SF622', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 239913),
(308224, 'PTHR14155:SF519', NULL, NULL, NULL, NULL, 'OS05G0359500 PROTEIN', 239913),
(308225, 'PTHR14155:SF480', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913),
(308226, 'PTHR14155:SF553', NULL, NULL, NULL, NULL, 'OS06G0535200 PROTEIN', 239913),
(308227, 'PTHR14155:SF551', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913),
(308228, 'PTHR14155:SF550', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ATL41', 239913),
(308229, 'PTHR14155:SF594', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 239913),
(308230, 'PTHR14155:SF591', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913),
(308231, 'PTHR14155:SF592', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL57', 239913),
(308232, 'PTHR14155:SF518', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913),
(308233, 'PTHR14155:SF559', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913),
(308234, 'PTHR14155:SF513', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(308235, 'PTHR14155:SF557', NULL, NULL, NULL, NULL, 'OS02G0572300 PROTEIN', 239913),
(308236, 'PTHR14155:SF558', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913),
(308237, 'PTHR14155:SF514', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913),
(308238, 'PTHR14155:SF511', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913),
(308239, 'PTHR14155:SF599', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 239913),
(308240, 'PTHR14155', NULL, NULL, NULL, NULL, 'RING FINGER DOMAIN-CONTAINING', 239913),
(308241, 'PTHR14155:SF478', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL81', 239913),
(308242, 'PTHR14155:SF512', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL19-RELATED', 239913),
(308243, 'PTHR13401', NULL, NULL, NULL, NULL, 'RAGULATOR COMPLEX PROTEIN LAMTOR1', 239914),
(308244, 'PTHR13401:SF2', NULL, NULL, NULL, NULL, 'RAGULATOR COMPLEX PROTEIN LAMTOR1', 239914),
(308245, 'PTHR21444:SF16', NULL, NULL, NULL, NULL, 'RECEPTOR FOR RETINOL UPTAKE STRA6', 239915),
(308246, 'PTHR21444:SF15', NULL, NULL, NULL, NULL, 'RECEPTOR FOR RETINOL UPTAKE STRA6', 239915),
(308247, 'PTHR21444:SF14', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 180', 239915),
(308248, 'PTHR21444:SF17', NULL, NULL, NULL, NULL, 'STIMULATED BY RETINOIC ACID GENE 6 PROTEIN-LIKE', 239915),
(308249, 'PTHR21444', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 180', 239915),
(308250, 'PTHR11594:SF9', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S27', 239916),
(308251, 'PTHR11594:SF7', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S27-RELATED', 239916),
(308252, 'PTHR11594:SF8', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S27', 239916),
(308253, 'PTHR11594:SF4', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S27', 239916),
(308254, 'PTHR11594:SF1', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S27', 239916),
(308255, 'PTHR11594:SF10', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S27-2', 239916),
(308256, 'PTHR11594:SF21', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S27', 239916),
(308257, 'PTHR11594:SF2', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S27-LIKE', 239916),
(308258, 'PTHR11594:SF22', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S27', 239916),
(308259, 'PTHR11594:SF0', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S27', 239916),
(308260, 'PTHR11594:SF20', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S27', 239916),
(308261, 'PTHR11594:SF25', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S27', 239916),
(308262, 'PTHR11594:SF14', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S27', 239916),
(308263, 'PTHR11594:SF23', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S27', 239916),
(308264, 'PTHR11594:SF24', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S27', 239916),
(308265, 'PTHR11594:SF13', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S27', 239916),
(308266, 'PTHR11594:SF18', NULL, NULL, NULL, NULL, '', 239916),
(308267, 'PTHR11594:SF19', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S27', 239916),
(308268, 'PTHR11594:SF16', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S27', 239916),
(308269, 'PTHR11594:SF17', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S27', 239916),
(308270, 'PTHR11594', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S27', 239916),
(308271, 'PTHR13600:SF9', NULL, NULL, NULL, NULL, 'LEUCINE CARBOXYL METHYLTRANSFERASE 2', 239917),
(308272, 'PTHR13600:SF21', NULL, NULL, NULL, NULL, 'LEUCINE CARBOXYL METHYLTRANSFERASE 1', 239917),
(308273, 'PTHR13600:SF33', NULL, NULL, NULL, NULL, 'LEUCINE CARBOXYL METHYLTRANSFERASE 1', 239917),
(308274, 'PTHR13600', NULL, NULL, NULL, NULL, 'LEUCINE CARBOXYL METHYLTRANSFERASE', 239917),
(308275, 'PTHR12639', NULL, NULL, NULL, NULL, 'VITAMIN K-DEPENDENT GAMMA-CARBOXYLASE', 239918),
(308276, 'PTHR12639:SF7', NULL, NULL, NULL, NULL, 'HTTM DOMAIN-CONTAINING PROTEIN', 239918),
(308277, 'PTHR12639:SF6', NULL, NULL, NULL, NULL, 'VITAMIN K-DEPENDENT GAMMA-CARBOXYLASE', 239918),
(308278, 'PTHR33414:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PLASTID MOVEMENT IMPAIRED 1-RELATED 1', 239919);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(308279, 'PTHR33414:SF2', NULL, NULL, NULL, NULL, 'PROTEIN PLASTID MOVEMENT IMPAIRED 1', 239919),
(308280, 'PTHR33414:SF16', NULL, NULL, NULL, NULL, 'C2 NT-TYPE DOMAIN-CONTAINING PROTEIN', 239919),
(308281, 'PTHR33414:SF15', NULL, NULL, NULL, NULL, 'EEIG1/EHBP1 N-TERMINAL DOMAIN-CONTAINING PROTEIN-RELATED', 239919),
(308282, 'PTHR33414:SF3', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239919),
(308283, 'PTHR33414:SF10', NULL, NULL, NULL, NULL, 'PROTEIN PLASTID MOVEMENT IMPAIRED 1-RELATED 2', 239919),
(308284, 'PTHR33414:SF14', NULL, NULL, NULL, NULL, 'PLASTID MOVEMENT IMPAIRED PROTEIN', 239919),
(308285, 'PTHR33414:SF13', NULL, NULL, NULL, NULL, 'PROTEIN PLASTID MOVEMENT IMPAIRED 1-RELATED 1-LIKE', 239919),
(308286, 'PTHR33414:SF12', NULL, NULL, NULL, NULL, 'C2 NT-TYPE DOMAIN-CONTAINING PROTEIN', 239919),
(308287, 'PTHR33414', NULL, NULL, NULL, NULL, 'PROTEIN PLASTID MOVEMENT IMPAIRED 1-RELATED 1', 239919),
(308288, 'PTHR33414:SF8', NULL, NULL, NULL, NULL, 'OS09G0559200 PROTEIN', 239919),
(308289, 'PTHR33414:SF5', NULL, NULL, NULL, NULL, 'OS02G0817100 PROTEIN', 239919),
(308290, 'PTHR33414:SF7', NULL, NULL, NULL, NULL, 'PROTEIN PLASTID MOVEMENT IMPAIRED 1-RELATED 1-LIKE', 239919),
(308291, 'PTHR11438:SF5', NULL, NULL, NULL, NULL, 'PREPRONOCICEPTIN', 239920),
(308292, 'PTHR11438:SF4', NULL, NULL, NULL, NULL, 'PROENKEPHALIN-B', 239920),
(308293, 'PTHR11438:SF3', NULL, NULL, NULL, NULL, 'PROENKEPHALIN-A', 239920),
(308294, 'PTHR11438:SF2', NULL, NULL, NULL, NULL, 'PREPRONOCICEPTIN', 239920),
(308295, 'PTHR11438', NULL, NULL, NULL, NULL, 'PROENKEPHALIN', 239920),
(308296, 'PTHR47267:SF5', NULL, NULL, NULL, NULL, 'DEHALOGENASE-LIKE HYDROLASE, PUTATIVE-RELATED', 239921),
(308297, 'PTHR47267:SF4', NULL, NULL, NULL, NULL, 'PYRIDOXAL PHOSPHATE PHOSPHATASE YIGL', 239921),
(308298, 'PTHR47267', NULL, NULL, NULL, NULL, '', 239921),
(308299, 'PTHR47267:SF2', NULL, NULL, NULL, NULL, 'HMP-PP PHOSPHATASE', 239921),
(308300, 'PTHR15384:SF0', NULL, NULL, NULL, NULL, 'PROTEIN EVI2B', 239922),
(308301, 'PTHR15384', NULL, NULL, NULL, NULL, 'PROTEIN EVI2B', 239922),
(308302, 'PTHR11830:SF28', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S3A', 239923),
(308303, 'PTHR11830:SF0', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S3A', 239923),
(308304, 'PTHR11830:SF17', NULL, NULL, NULL, NULL, 'CYLINDROMATOSIS (TURBAN TUMOR SYNDROME), B', 239923),
(308305, 'PTHR11830:SF36', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S3A-1-RELATED', 239923),
(308306, 'PTHR11830:SF25', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S3A', 239923),
(308307, 'PTHR11830:SF24', NULL, NULL, NULL, NULL, '', 239923),
(308308, 'PTHR11830:SF35', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S3A', 239923),
(308309, 'PTHR11830:SF38', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S3A-LIKE', 239923),
(308310, 'PTHR11830:SF3', NULL, NULL, NULL, NULL, 'CYLINDROMATOSIS, ISOFORM D', 239923),
(308311, 'PTHR11830:SF16', NULL, NULL, NULL, NULL, 'DEUBIQUITINATING ENZYME CYLD', 239923),
(308312, 'PTHR11830:SF15', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE CYLD', 239923),
(308313, 'PTHR11830:SF43', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S3A', 239923),
(308314, 'PTHR11830:SF32', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S3A', 239923),
(308315, 'PTHR11830:SF42', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S3A', 239923),
(308316, 'PTHR11830:SF31', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S3A', 239923),
(308317, 'PTHR11830:SF23', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S3A', 239923),
(308318, 'PTHR11830:SF22', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S3A', 239923),
(308319, 'PTHR11830:SF41', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S3A', 239923),
(308320, 'PTHR11830:SF30', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S3A', 239923),
(308321, 'PTHR11830', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S3A', 239923),
(308322, 'PTHR12241:SF91', NULL, NULL, NULL, NULL, 'TUBULIN POLYGLUTAMYLASE TTLL13P', 239924),
(308323, 'PTHR12241:SF159', NULL, NULL, NULL, NULL, 'TUBULIN-TYROSINE LIGASE-LIKE PROTEIN, CONSERVED', 239924);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(308324, 'PTHR12241:SF118', NULL, NULL, NULL, NULL, 'TUBULIN POLYGLUTAMYLASE TTLL2-RELATED', 239924),
(308325, 'PTHR12241:SF145', NULL, NULL, NULL, NULL, 'TUBULIN POLYGLUTAMYLASE TTLL5', 239924),
(308326, 'PTHR12241:SF155', NULL, NULL, NULL, NULL, 'TUBULIN-TYROSINE LIGASE FAMILY PROTEIN', 239924),
(308327, 'PTHR12241:SF147', NULL, NULL, NULL, NULL, 'TUBULIN POLYGLUTAMYLASE TTLL7', 239924),
(308328, 'PTHR12241:SF157', NULL, NULL, NULL, NULL, 'LIGASE-LIKE PROTEIN, PUTATIVE-RELATED', 239924),
(308329, 'PTHR12241:SF162', NULL, NULL, NULL, NULL, 'TUBULIN POLYGLUTAMYLASE TTLL4', 239924),
(308330, 'PTHR12241:SF154', NULL, NULL, NULL, NULL, 'TUBULIN POLYGLUTAMYLASE TTLL11', 239924),
(308331, 'PTHR12241:SF31', NULL, NULL, NULL, NULL, 'TUBULIN POLYGLUTAMYLASE TTLL1-RELATED', 239924),
(308332, 'PTHR12241:SF96', NULL, NULL, NULL, NULL, 'TUBULIN POLYGLUTAMYLASE TTLL6', 239924),
(308333, 'PTHR12241:SF161', NULL, NULL, NULL, NULL, 'TUBULIN POLYGLUTAMYLASE TTLL6', 239924),
(308334, 'PTHR12241:SF160', NULL, NULL, NULL, NULL, 'TYROSINE LIGASE PROTEIN, PUTATIVE-RELATED', 239924),
(308335, 'PTHR12241:SF39', NULL, NULL, NULL, NULL, 'TUBULIN POLYGLUTAMYLASE TTLL9-RELATED', 239924),
(308336, 'PTHR12241', NULL, NULL, NULL, NULL, 'TUBULIN POLYGLUTAMYLASE', 239924),
(308337, 'PTHR47756:SF1', NULL, NULL, NULL, NULL, 'BLL0085 PROTEIN', 239925),
(308338, 'PTHR47756:SF2', NULL, NULL, NULL, NULL, 'BLL6612 PROTEIN', 239925),
(308339, 'PTHR47756', NULL, NULL, NULL, NULL, 'BLL6612 PROTEIN-RELATED', 239925),
(308340, 'PTHR15346:SF0', NULL, NULL, NULL, NULL, 'DYNACTIN SUBUNIT 2', 239926),
(308341, 'PTHR15346', NULL, NULL, NULL, NULL, 'DYNACTIN SUBUNIT', 239926),
(308342, 'PTHR13337:SF6', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE [UBIQUINONE] CYTOCHROME B SMALL SUBUNIT, MITOCHONDRIAL', 239927),
(308343, 'PTHR13337:SF9', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE [UBIQUINONE] CYTOCHROME B SMALL SUBUNIT', 239927),
(308344, 'PTHR13337:SF8', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE [UBIQUINONE] CYTOCHROME B SMALL SUBUNIT', 239927),
(308345, 'PTHR13337:SF10', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE [UBIQUINONE] CYTOCHROME B SMALL SUBUNIT', 239927),
(308346, 'PTHR13337', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE', 239927),
(308347, 'PTHR13337:SF2', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE [UBIQUINONE] CYTOCHROME B SMALL SUBUNIT, MITOCHONDRIAL', 239927),
(308348, 'PTHR13337:SF5', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL INNER MEMBRANE PROTEIN SHH4-RELATED', 239927),
(308349, 'PTHR32178:SF6', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 239928),
(308350, 'PTHR32178:SF7', NULL, NULL, NULL, NULL, 'IG-LIKE V-TYPE DOMAIN-CONTAINING PROTEIN FAM187A', 239928),
(308351, 'PTHR32178', NULL, NULL, NULL, NULL, 'FAM187', 239928),
(308352, 'PTHR32178:SF8', NULL, NULL, NULL, NULL, 'PROTEIN FAM187B', 239928),
(308353, 'PTHR35318', NULL, NULL, NULL, NULL, 'BNAA10G08410D PROTEIN', 239929),
(308354, 'PTHR35318:SF12', NULL, NULL, NULL, NULL, 'OS08G0138900 PROTEIN', 239929),
(308355, 'PTHR35318:SF13', NULL, NULL, NULL, NULL, 'BNAANNG41220D PROTEIN', 239929),
(308356, 'PTHR35318:SF10', NULL, NULL, NULL, NULL, '', 239929),
(308357, 'PTHR35318:SF8', NULL, NULL, NULL, NULL, '', 239929),
(308358, 'PTHR35318:SF7', NULL, NULL, NULL, NULL, '', 239929),
(308359, 'PTHR35318:SF9', NULL, NULL, NULL, NULL, '', 239929),
(308360, 'PTHR35318:SF2', NULL, NULL, NULL, NULL, 'BNAA10G08410D PROTEIN', 239929),
(308361, 'PTHR43520:SF8', NULL, NULL, NULL, NULL, 'COPPER-TRANSPORTING ATPASE 2', 239930),
(308362, 'PTHR43520:SF25', NULL, NULL, NULL, NULL, 'CATION-TRANSPORTING ATPASE HMA5', 239930),
(308363, 'PTHR43520:SF7', NULL, NULL, NULL, NULL, '', 239930),
(308364, 'PTHR43520:SF26', NULL, NULL, NULL, NULL, 'COPPER-TRANSPORTING ATPASE HMA5-RELATED', 239930),
(308365, 'PTHR43520:SF27', NULL, NULL, NULL, NULL, 'COPPER-TRANSPORTING ATPASE RAN1', 239930),
(308366, 'PTHR43520:SF28', NULL, NULL, NULL, NULL, 'HEAVY METAL P-TYPE ATPASE', 239930),
(308367, 'PTHR43520:SF29', NULL, NULL, NULL, NULL, 'COPPER-TRANSPORTING ATPASE 1', 239930);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(308368, 'PTHR43520:SF18', NULL, NULL, NULL, NULL, 'COPPER-TRANSPORTING ATPASE HMA5-RELATED', 239930),
(308369, 'PTHR43520:SF19', NULL, NULL, NULL, NULL, 'COPPER-TRANSPORTING ATPASE PAA2, CHLOROPLASTIC', 239930),
(308370, 'PTHR43520', NULL, NULL, NULL, NULL, 'ATP7, ISOFORM B', 239930),
(308371, 'PTHR43520:SF22', NULL, NULL, NULL, NULL, 'COPPER-TRANSPORTING ATPASE PAA1, CHLOROPLASTIC', 239930),
(308372, 'PTHR43520:SF6', NULL, NULL, NULL, NULL, 'COPPER-EXPORTING P-TYPE ATPASE', 239930),
(308373, 'PTHR43520:SF5', NULL, NULL, NULL, NULL, 'CATION-TRANSPORTING P-TYPE ATPASE-RELATED', 239930),
(308374, 'PTHR43520:SF4', NULL, NULL, NULL, NULL, 'P-TYPE ATPASE', 239930),
(308375, 'PTHR48261', NULL, NULL, NULL, NULL, 'ACETYLGLUCOSAMINYLTRANSFERASE', 239931),
(308376, 'PTHR48261:SF1', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY PROTEIN', 239931),
(308377, 'PTHR48261:SF2', NULL, NULL, NULL, NULL, 'ACETYLGLUCOSAMINYLTRANSFERASE', 239931),
(308378, 'PTHR11127:SF2', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L14', 239932),
(308379, 'PTHR11127:SF4', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L14', 239932),
(308380, 'PTHR11127:SF20', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L14E DOMAIN-CONTAINING PROTEIN', 239932),
(308381, 'PTHR11127', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L14', 239932),
(308382, 'PTHR11127:SF9', NULL, NULL, NULL, NULL, '', 239932),
(308383, 'PTHR11127:SF17', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L14-1', 239932),
(308384, 'PTHR11127:SF18', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L14, TRANSLATION PROTEIN SH3-LIKE DOMAIN PROTEIN-RELATED', 239932),
(308385, 'PTHR11127:SF19', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L14-2', 239932),
(308386, 'PTHR11127:SF8', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L14-1', 239932),
(308387, 'PTHR46323:SF2', NULL, NULL, NULL, NULL, 'LACTASE', 239933),
(308388, 'PTHR46323', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 239933),
(308389, 'PTHR46323:SF1', NULL, NULL, NULL, NULL, 'LACTASE', 239933),
(308390, 'PTHR12217:SF4', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 2D', 239934),
(308391, 'PTHR12217', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 2D', 239934),
(308392, 'PTHR37458:SF1', NULL, NULL, NULL, NULL, 'THISBE', 239935),
(308393, 'PTHR37458', NULL, NULL, NULL, NULL, 'THISBE', 239935),
(308394, 'PTHR46760:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR 1', 239936),
(308395, 'PTHR46760', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR 1', 239936),
(308396, 'PTHR38792', NULL, NULL, NULL, NULL, 'BNR/ASP-BOX REPEAT DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_7G06430)-RELATED', 239937),
(308397, 'PTHR38792:SF3', NULL, NULL, NULL, NULL, 'BNR/ASP-BOX REPEAT DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_7G06430)-RELATED', 239937),
(308398, 'PTHR38792:SF1', NULL, NULL, NULL, NULL, 'BNR/ASP-BOX REPEAT PROTEIN', 239937),
(308399, 'PTHR46927:SF1', NULL, NULL, NULL, NULL, 'THAP DOMAIN-CONTAINING PROTEIN 5', 239938),
(308400, 'PTHR46927:SF2', NULL, NULL, NULL, NULL, 'THAP DOMAIN-CONTAINING PROTEIN 8', 239938),
(308401, 'PTHR46927:SF3', NULL, NULL, NULL, NULL, 'THAP-TYPE DOMAIN-CONTAINING PROTEIN', 239938),
(308402, 'PTHR46927', NULL, NULL, NULL, NULL, 'AGAP005574-PA', 239938),
(308403, 'PTHR12865:SF6', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-KINASE TYPE 2-BETA', 239939),
(308404, 'PTHR12865:SF5', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-KINASE TYPE 2', 239939),
(308405, 'PTHR12865:SF7', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-KINASE TYPE 2-ALPHA', 239939),
(308406, 'PTHR12865', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-KINASE TYPE-II', 239939),
(308407, 'PTHR12865:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-KINASE TYPE 2', 239939),
(308408, 'PTHR43167:SF1', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_6G01830)-RELATED', 239940),
(308409, 'PTHR43167', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_6G01830)-RELATED', 239940),
(308410, 'PTHR36786:SF1', NULL, NULL, NULL, NULL, '2-ISOPROPYLMALATE SYNTHASE', 239941),
(308411, 'PTHR36786', NULL, NULL, NULL, NULL, '2-ISOPROPYLMALATE SYNTHASE', 239941);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(308412, 'PTHR35110:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239942),
(308413, 'PTHR35110:SF3', NULL, NULL, NULL, NULL, 'OS08G0360000 PROTEIN', 239942),
(308414, 'PTHR35110', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239942),
(308415, 'PTHR43052', NULL, NULL, NULL, NULL, '', 239943),
(308416, 'PTHR43052:SF3', NULL, NULL, NULL, NULL, 'TRNA-5-TAURINOMETHYLURIDINE 2-SULFURTRANSFERASE', 239943),
(308417, 'PTHR43052:SF1', NULL, NULL, NULL, NULL, 'TRNA-5-TAURINOMETHYLURIDINE 2-SULFURTRANSFERASE', 239943),
(308418, 'PTHR30509:SF39', NULL, NULL, NULL, NULL, 'BNAA04G16670D PROTEIN', 239944),
(308419, 'PTHR30509', NULL, NULL, NULL, NULL, 'P-HYDROXYBENZOIC ACID EFFLUX PUMP SUBUNIT-RELATED', 239944),
(308420, 'PTHR30509:SF40', NULL, NULL, NULL, NULL, 'BLR3852 PROTEIN', 239944),
(308421, 'PTHR30509:SF41', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L6', 239944),
(308422, 'PTHR30509:SF30', NULL, NULL, NULL, NULL, 'P-TYPE TREFOIL', 239944),
(308423, 'PTHR30509:SF42', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YEEA', 239944),
(308424, 'PTHR30509:SF32', NULL, NULL, NULL, NULL, '', 239944),
(308425, 'PTHR30509:SF10', NULL, NULL, NULL, NULL, 'P-HYDROXYBENZOIC ACID EFFLUX PUMP SUBUNIT AAEB', 239944),
(308426, 'PTHR30509:SF23', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', 239944),
(308427, 'PTHR30509:SF34', NULL, NULL, NULL, NULL, 'F3L24.34 PROTEIN', 239944),
(308428, 'PTHR30509:SF9', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN MDTO', 239944),
(308429, 'PTHR30509:SF8', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YCCS', 239944),
(308430, 'PTHR30509:SF27', NULL, NULL, NULL, NULL, 'UPF0421 PROTEIN YGAE', 239944),
(308431, 'PTHR30509:SF38', NULL, NULL, NULL, NULL, '', 239944),
(308432, 'PTHR34945', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 239945),
(308433, 'PTHR34945:SF2', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 239945),
(308434, 'PTHR34945:SF4', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 239945),
(308435, 'PTHR34945:SF7', NULL, NULL, NULL, NULL, 'BNAC03G21390D PROTEIN', 239945),
(308436, 'PTHR34945:SF6', NULL, NULL, NULL, NULL, 'ISOPENICILLIN N SYNTHASE-LIKE PROTEIN-RELATED', 239945),
(308437, 'PTHR34945:SF9', NULL, NULL, NULL, NULL, 'NON-HEME DIOXYGENASE N-TERMINAL DOMAIN, ISOPENICILLIN N SYNTHASE-LIKE PROTEIN-RELATED', 239945),
(308438, 'PTHR34945:SF8', NULL, NULL, NULL, NULL, 'DOWNSTREAM TARGET OF AGL15-4', 239945),
(308439, 'PTHR37512:SF1', NULL, NULL, NULL, NULL, 'AAA_28 DOMAIN-CONTAINING PROTEIN', 239946),
(308440, 'PTHR37512', NULL, NULL, NULL, NULL, 'TRIFUNCTIONAL NAD BIOSYNTHESIS/REGULATOR PROTEIN NADR', 239946),
(308441, 'PTHR36370', NULL, NULL, NULL, NULL, 'THYLAKOID SOLUBLE PHOSPHOPROTEIN', 239947),
(308442, 'PTHR36370:SF1', NULL, NULL, NULL, NULL, 'THYLAKOID SOLUBLE PHOSPHOPROTEIN', 239947),
(308443, 'PTHR36370:SF5', NULL, NULL, NULL, NULL, 'THYLAKOID SOLUBLE PHOSPHOPROTEIN', 239947),
(308444, 'PTHR36370:SF2', NULL, NULL, NULL, NULL, '', 239947),
(308445, 'PTHR36370:SF3', NULL, NULL, NULL, NULL, 'BNAA10G29120D PROTEIN', 239947),
(308446, 'PTHR24067:SF341', NULL, NULL, NULL, NULL, 'CONJUGATING ENZYME, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G14130)-RELATED', 239948),
(308447, 'PTHR24067:SF342', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 7 ISOFORM X2', 239948),
(308448, 'PTHR24067:SF343', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 239948),
(308449, 'PTHR24067:SF344', NULL, NULL, NULL, NULL, 'UBC3', 239948),
(308450, 'PTHR24067:SF300', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 239948),
(308451, 'PTHR24067:SF260', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 A,-LIKE', 239948),
(308452, 'PTHR24067:SF261', NULL, NULL, NULL, NULL, 'NEDD8-CONJUGATING ENZYME UBC-12', 239948),
(308453, 'PTHR24067:SF263', NULL, NULL, NULL, NULL, 'UBE2G1 PROTEIN', 239948),
(308454, 'PTHR24067:SF340', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 3', 239948);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(308455, 'PTHR24067:SF349', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME', 239948),
(308456, 'PTHR24067:SF305', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 239948),
(308457, 'PTHR24067:SF301', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 1', 239948),
(308458, 'PTHR24067:SF345', NULL, NULL, NULL, NULL, 'SUMO-CONJUGATING ENZYME SCE1-LIKE', 239948),
(308459, 'PTHR24067:SF148', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 R2', 239948),
(308460, 'PTHR24067:SF346', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE 34 HOMOLOG (S. CEREVISIAE) A', 239948),
(308461, 'PTHR24067:SF347', NULL, NULL, NULL, NULL, 'E2 UBIQUITIN-CONJUGATING ENZYME', 239948),
(308462, 'PTHR24067:SF348', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 239948),
(308463, 'PTHR24067:SF304', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 239948),
(308464, 'PTHR24067:SF331', NULL, NULL, NULL, NULL, 'OS05G0460200 PROTEIN', 239948),
(308465, 'PTHR24067:SF298', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 13-RELATED', 239948),
(308466, 'PTHR24067:SF254', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2-17 KDA', 239948),
(308467, 'PTHR24067:SF332', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME (E2)', 239948),
(308468, 'PTHR24067:SF135', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 R1', 239948),
(308469, 'PTHR24067:SF294', NULL, NULL, NULL, NULL, 'PROTEIN CROSSBRONX-RELATED', 239948),
(308470, 'PTHR24067:SF295', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 2', 239948),
(308471, 'PTHR24067:SF252', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 U', 239948),
(308472, 'PTHR24067:SF338', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2C', 239948),
(308473, 'PTHR24067:SF339', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 239948),
(308474, 'PTHR24067:SF257', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 239948),
(308475, 'PTHR24067:SF334', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 14', 239948),
(308476, 'PTHR24067:SF335', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME', 239948),
(308477, 'PTHR24067:SF258', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2G 1A (UBC7 HOMOLOG, YEAST)', 239948),
(308478, 'PTHR24067:SF336', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 7-LIKE', 239948),
(308479, 'PTHR24067:SF337', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME/RWD-LIKE PROTEIN-RELATED', 239948),
(308480, 'PTHR24067:SF243', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 A', 239948),
(308481, 'PTHR24067:SF287', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 I', 239948),
(308482, 'PTHR24067:SF167', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2', 239948),
(308483, 'PTHR24067:SF245', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 239948),
(308484, 'PTHR24067:SF3', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 G1', 239948),
(308485, 'PTHR24067:SF283', NULL, NULL, NULL, NULL, 'SUMO-CONJUGATING ENZYME SCE1-LIKE', 239948),
(308486, 'PTHR24067:SF329', NULL, NULL, NULL, NULL, 'SUMO-CONJUGATING ENZYME SCE1', 239948),
(308487, 'PTHR24067:SF246', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 B', 239948),
(308488, 'PTHR24067:SF323', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 239948),
(308489, 'PTHR24067:SF248', NULL, NULL, NULL, NULL, 'DORSAL INTERACTING PROTEIN 4', 239948),
(308490, 'PTHR24067:SF325', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 239948),
(308491, 'PTHR24067:SF326', NULL, NULL, NULL, NULL, 'SUMO-CONJUGATING ENZYME SCE1', 239948),
(308492, 'PTHR24067:SF292', NULL, NULL, NULL, NULL, 'CONJUGATING ENZYME, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G15040)-RELATED', 239948),
(308493, 'PTHR24067:SF154', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 G2', 239948),
(308494, 'PTHR24067:SF352', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME', 239948),
(308495, 'PTHR24067:SF353', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 239948);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(308496, 'PTHR24067:SF310', NULL, NULL, NULL, NULL, 'UBC2', 239948),
(308497, 'PTHR24067:SF354', NULL, NULL, NULL, NULL, 'SUMO-CONJUGATING ENZYME SCE1-LIKE', 239948),
(308498, 'PTHR24067:SF157', NULL, NULL, NULL, NULL, 'FI11905P', 239948),
(308499, 'PTHR24067:SF311', NULL, NULL, NULL, NULL, 'SUMO-CONJUGATING ENZYME UBC9-LIKE', 239948),
(308500, 'PTHR24067:SF350', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2-17 KDA', 239948),
(308501, 'PTHR24067:SF273', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 7-LIKE', 239948),
(308502, 'PTHR24067:SF351', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME', 239948),
(308503, 'PTHR24067:SF274', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 2', 239948),
(308504, 'PTHR24067:SF317', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 239948),
(308505, 'PTHR24067:SF319', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 2', 239948),
(308506, 'PTHR24067', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2', 239948),
(308507, 'PTHR24067:SF313', NULL, NULL, NULL, NULL, 'SUMO CONJUGATION ENZYME 1 ISOFORM 2', 239948),
(308508, 'PTHR24067:SF314', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 239948),
(308509, 'PTHR24067:SF280', NULL, NULL, NULL, NULL, 'SUMO-CONJUGATING ENZYME UBC9', 239948),
(308510, 'PTHR13156:SF0', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] IRON-SULFUR PROTEIN 6, MITOCHONDRIAL', 239949),
(308511, 'PTHR13156:SF1', NULL, NULL, NULL, NULL, 'ZF-CHCC DOMAIN-CONTAINING PROTEIN', 239949),
(308512, 'PTHR13156', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE 13 KD-A SUBUNIT', 239949),
(308513, 'PTHR23106', NULL, NULL, NULL, NULL, 'ANGIOGENIC FACTOR WITH G PATCH AND FHA DOMAINS 1', 239950),
(308514, 'PTHR23106:SF24', NULL, NULL, NULL, NULL, 'ANGIOGENIC FACTOR WITH G PATCH AND FHA DOMAINS 1', 239950),
(308515, 'PTHR38377:SF1', NULL, NULL, NULL, NULL, 'THREONINE-TRNA LIGASE 2', 239951),
(308516, 'PTHR38377', NULL, NULL, NULL, NULL, 'THREONINE-TRNA LIGASE 2', 239951),
(308517, 'PTHR34630:SF34', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239952),
(308518, 'PTHR34630:SF78', NULL, NULL, NULL, NULL, '', 239952),
(308519, 'PTHR34630:SF79', NULL, NULL, NULL, NULL, '', 239952),
(308520, 'PTHR34630:SF76', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE RPP13-LIKE PROTEIN 1-RELATED', 239952),
(308521, 'PTHR34630:SF77', NULL, NULL, NULL, NULL, 'AND NB-ARC DOMAIN DISEASE RESISTANCE PROTEIN, PUTATIVE-RELATED', 239952),
(308522, 'PTHR34630:SF17', NULL, NULL, NULL, NULL, 'OS11G0263000 PROTEIN', 239952),
(308523, 'PTHR34630:SF70', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RGA3-RELATED', 239952),
(308524, 'PTHR34630:SF92', NULL, NULL, NULL, NULL, 'OS02G0118950 PROTEIN', 239952),
(308525, 'PTHR34630:SF71', NULL, NULL, NULL, NULL, 'RX_N DOMAIN-CONTAINING PROTEIN', 239952),
(308526, 'PTHR34630:SF93', NULL, NULL, NULL, NULL, 'OS11G0676050 PROTEIN', 239952),
(308527, 'PTHR34630:SF90', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 239952),
(308528, 'PTHR34630:SF91', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 239952),
(308529, 'PTHR34630:SF52', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 239952),
(308530, 'PTHR34630:SF74', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RGA3-RELATED', 239952),
(308531, 'PTHR34630:SF96', NULL, NULL, NULL, NULL, 'OS12G0565200 PROTEIN', 239952),
(308532, 'PTHR34630:SF97', NULL, NULL, NULL, NULL, 'RESISTANCE PROTEIN, PUTATIVE-RELATED', 239952),
(308533, 'PTHR34630:SF75', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RF9-RELATED', 239952),
(308534, 'PTHR34630:SF72', NULL, NULL, NULL, NULL, 'OS03G0689866 PROTEIN', 239952),
(308535, 'PTHR34630:SF94', NULL, NULL, NULL, NULL, 'RX_N DOMAIN-CONTAINING PROTEIN', 239952),
(308536, 'PTHR34630:SF73', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RGA1-RELATED', 239952),
(308537, 'PTHR34630:SF95', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT CONTAINING PROTEIN', 239952),
(308538, 'PTHR34630:SF19', NULL, NULL, NULL, NULL, 'OF AVRB OPERATION PROTEIN, PUTATIVE-RELATED', 239952);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(308539, 'PTHR34630', NULL, NULL, NULL, NULL, 'OS11G0677101 PROTEIN', 239952),
(308540, 'PTHR34630:SF89', NULL, NULL, NULL, NULL, 'OS02G0261400 PROTEIN', 239952),
(308541, 'PTHR34630:SF68', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE RPP13-LIKE PROTEIN 1-RELATED', 239952),
(308542, 'PTHR34630:SF87', NULL, NULL, NULL, NULL, 'NBS-LRR RESISTANCE PROTEIN', 239952),
(308543, 'PTHR34630:SF88', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 239952),
(308544, 'PTHR34630:SF49', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RGA1 ISOFORM X1-RELATED', 239952),
(308545, 'PTHR34630:SF69', NULL, NULL, NULL, NULL, 'OS02G0118900 PROTEIN', 239952),
(308546, 'PTHR34630:SF25', NULL, NULL, NULL, NULL, 'RESISTANCE DOMAIN PROTEIN', 239952),
(308547, 'PTHR34630:SF81', NULL, NULL, NULL, NULL, '', 239952),
(308548, 'PTHR34630:SF82', NULL, NULL, NULL, NULL, '', 239952),
(308549, 'PTHR34630:SF80', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN R3A', 239952),
(308550, 'PTHR34630:SF85', NULL, NULL, NULL, NULL, 'BNAC05G19470D PROTEIN', 239952),
(308551, 'PTHR34630:SF86', NULL, NULL, NULL, NULL, '', 239952),
(308552, 'PTHR34630:SF83', NULL, NULL, NULL, NULL, 'AND NB-ARC DOMAIN DISEASE RESISTANCE PROTEIN, PUTATIVE-RELATED', 239952),
(308553, 'PTHR34630:SF84', NULL, NULL, NULL, NULL, '', 239952),
(308554, 'PTHR37213:SF1', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE', 239953),
(308555, 'PTHR37213:SF2', NULL, NULL, NULL, NULL, 'BNAC04G43990D PROTEIN', 239953),
(308556, 'PTHR37213', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE', 239953),
(308557, 'PTHR21442:SF0', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 206', 239954),
(308558, 'PTHR21442', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239954),
(308559, 'PTHR46806:SF3', NULL, NULL, NULL, NULL, 'DISCOIDIN, CUB AND LCCL DOMAIN-CONTAINING PROTEIN 2', 239955),
(308560, 'PTHR46806:SF4', NULL, NULL, NULL, NULL, 'NEUROPILIN-1', 239955),
(308561, 'PTHR46806:SF5', NULL, NULL, NULL, NULL, 'F5/8 TYPE C DOMAIN-CONTAINING PROTEIN', 239955),
(308562, 'PTHR46806:SF6', NULL, NULL, NULL, NULL, 'SI:DKEY-34D22.1', 239955),
(308563, 'PTHR46806:SF1', NULL, NULL, NULL, NULL, 'DISCOIDIN, CUB AND LCCL DOMAIN-CONTAINING PROTEIN 1', 239955),
(308564, 'PTHR46806', NULL, NULL, NULL, NULL, 'F5/8 TYPE C DOMAIN-CONTAINING PROTEIN', 239955),
(308565, 'PTHR46806:SF2', NULL, NULL, NULL, NULL, 'NEUROPILIN-2', 239955),
(308566, 'PTHR46806:SF7', NULL, NULL, NULL, NULL, 'COAGULATION FACTOR VIII', 239955),
(308567, 'PTHR46806:SF8', NULL, NULL, NULL, NULL, 'NEUROPILIN 1B', 239955),
(308568, 'PTHR12862', NULL, NULL, NULL, NULL, 'BADF TYPE ATPASE DOMAIN-CONTAINING PROTEIN', 239956),
(308569, 'PTHR12862:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG13484', 239956),
(308570, 'PTHR12862:SF2', NULL, NULL, NULL, NULL, 'KINASE-RELATED', 239956),
(308571, 'PTHR12862:SF0', NULL, NULL, NULL, NULL, 'N-ACETYL-D-GLUCOSAMINE KINASE', 239956),
(308572, 'PTHR36912:SF5', NULL, NULL, NULL, NULL, '', 239957),
(308573, 'PTHR36912', NULL, NULL, NULL, NULL, 'ANTIGEN 332, DBL-LIKE PROTEIN-RELATED', 239957),
(308574, 'PTHR36912:SF4', NULL, NULL, NULL, NULL, '', 239957),
(308575, 'PTHR36912:SF3', NULL, NULL, NULL, NULL, '', 239957),
(308576, 'PTHR36912:SF2', NULL, NULL, NULL, NULL, 'ANTIGEN 332, DBL-LIKE PROTEIN', 239957),
(308577, 'PTHR33991', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RECO', 239958),
(308578, 'PTHR33991:SF1', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RECO', 239958),
(308579, 'PTHR48000:SF30', NULL, NULL, NULL, NULL, 'BNAA09G07190D PROTEIN', 239959),
(308580, 'PTHR48000:SF54', NULL, NULL, NULL, NULL, '', 239959),
(308581, 'PTHR48000:SF33', NULL, NULL, NULL, NULL, '', 239959),
(308582, 'PTHR48000:SF55', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR RAX3-LIKE', 239959),
(308583, 'PTHR48000:SF11', NULL, NULL, NULL, NULL, 'BNAA03G16870D PROTEIN', 239959),
(308584, 'PTHR48000:SF18', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR RAX1', 239959),
(308585, 'PTHR48000:SF19', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB36', 239959),
(308586, 'PTHR48000:SF56', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 239959);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(308587, 'PTHR48000:SF12', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR MYB37', 239959),
(308588, 'PTHR48000:SF35', NULL, NULL, NULL, NULL, '', 239959),
(308589, 'PTHR48000:SF57', NULL, NULL, NULL, NULL, 'OS02G0786400 PROTEIN', 239959),
(308590, 'PTHR48000:SF13', NULL, NULL, NULL, NULL, '', 239959),
(308591, 'PTHR48000:SF58', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR RAX3-LIKE', 239959),
(308592, 'PTHR48000:SF36', NULL, NULL, NULL, NULL, 'OS08G0248700 PROTEIN', 239959),
(308593, 'PTHR48000:SF15', NULL, NULL, NULL, NULL, 'OS09G0431300 PROTEIN', 239959),
(308594, 'PTHR48000:SF37', NULL, NULL, NULL, NULL, 'BNAA02G06100D PROTEIN', 239959),
(308595, 'PTHR48000:SF59', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR RAX2-LIKE', 239959),
(308596, 'PTHR48000:SF63', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR RAX3', 239959),
(308597, 'PTHR48000:SF41', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR RAX3-LIKE', 239959),
(308598, 'PTHR48000:SF64', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 239959),
(308599, 'PTHR48000:SF42', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB36-LIKE', 239959),
(308600, 'PTHR48000:SF20', NULL, NULL, NULL, NULL, 'MYB-LIKE DNA-BINDING DOMAIN CONTAINING PROTEIN, EXPRESSED', 239959),
(308601, 'PTHR48000:SF65', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 239959),
(308602, 'PTHR48000:SF21', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB36', 239959),
(308603, 'PTHR48000:SF66', NULL, NULL, NULL, NULL, 'OS01G0722300 PROTEIN', 239959),
(308604, 'PTHR48000:SF60', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR RAX3', 239959),
(308605, 'PTHR48000:SF61', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 239959),
(308606, 'PTHR48000:SF40', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 239959),
(308607, 'PTHR48000:SF62', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 239959),
(308608, 'PTHR48000', NULL, NULL, NULL, NULL, 'OS09G0431300 PROTEIN', 239959),
(308609, 'PTHR48000:SF3', NULL, NULL, NULL, NULL, 'BNAC02G43910D PROTEIN', 239959),
(308610, 'PTHR48000:SF5', NULL, NULL, NULL, NULL, 'OS01G0191900 PROTEIN', 239959),
(308611, 'PTHR48000:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB36', 239959),
(308612, 'PTHR48000:SF49', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN 84, PUTATIVE-RELATED', 239959),
(308613, 'PTHR48000:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR RAX1', 239959),
(308614, 'PTHR48000:SF28', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR RAX2', 239959),
(308615, 'PTHR48000:SF9', NULL, NULL, NULL, NULL, 'BNACNNG13370D PROTEIN', 239959),
(308616, 'PTHR48000:SF23', NULL, NULL, NULL, NULL, 'OS05G0553400 PROTEIN', 239959),
(308617, 'PTHR48000:SF67', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB87', 239959),
(308618, 'PTHR48000:SF46', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 239959),
(308619, 'PTHR48000:SF47', NULL, NULL, NULL, NULL, 'MYB DOMAIN PROTEIN 84-RELATED', 239959),
(308620, 'PTHR48000:SF26', NULL, NULL, NULL, NULL, '', 239959),
(308621, 'PTHR22647', NULL, NULL, NULL, NULL, 'SH3 DOMAIN AND TETRATRICOPEPTIDE REPEATS CONTAINING PROTEIN', 239960),
(308622, 'PTHR22647:SF2', NULL, NULL, NULL, NULL, 'SH3 DOMAIN AND TETRATRICOPEPTIDE REPEAT-CONTAINING PROTEIN 2', 239960),
(308623, 'PTHR22647:SF3', NULL, NULL, NULL, NULL, 'SH3 DOMAIN AND TETRATRICOPEPTIDE REPEAT-CONTAINING PROTEIN 1', 239960),
(308624, 'PTHR22647:SF4', NULL, NULL, NULL, NULL, '', 239960),
(308625, 'PTHR35797:SF1', NULL, NULL, NULL, NULL, 'PROTEASE-RELATED', 239961),
(308626, 'PTHR35797', NULL, NULL, NULL, NULL, 'PROTEASE-RELATED', 239961),
(308627, 'PTHR46163:SF20', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE', 239962),
(308628, 'PTHR46163:SF10', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE-PHOSPHATASE', 239962),
(308629, 'PTHR46163:SF7', NULL, NULL, NULL, NULL, 'PROTEIN TYROSINE PHOSPHATASE-LIKE PROTEIN EGG-3', 239962),
(308630, 'PTHR46163:SF8', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE', 239962),
(308631, 'PTHR46163:SF9', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE', 239962),
(308632, 'PTHR46163', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE-RELATED', 239962);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(308633, 'PTHR46163:SF12', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE', 239962),
(308634, 'PTHR46163:SF23', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE-RELATED', 239962),
(308635, 'PTHR46163:SF13', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE', 239962),
(308636, 'PTHR46163:SF24', NULL, NULL, NULL, NULL, 'PTPC_MOTIF DOMAIN-CONTAINING PROTEIN-RELATED', 239962),
(308637, 'PTHR46163:SF25', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE', 239962),
(308638, 'PTHR46163:SF14', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 239962),
(308639, 'PTHR46163:SF5', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE', 239962),
(308640, 'PTHR46163:SF15', NULL, NULL, NULL, NULL, 'PROTEIN CBG17666', 239962),
(308641, 'PTHR46163:SF16', NULL, NULL, NULL, NULL, 'PROTEIN CBG17743', 239962),
(308642, 'PTHR46163:SF17', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 239962),
(308643, 'PTHR46163:SF1', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE', 239962),
(308644, 'PTHR46163:SF2', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE', 239962),
(308645, 'PTHR46163:SF19', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE', 239962),
(308646, 'PTHR34298:SF2', NULL, NULL, NULL, NULL, 'SEGREGATION AND CONDENSATION PROTEIN B', 239963),
(308647, 'PTHR34298', NULL, NULL, NULL, NULL, 'SEGREGATION AND CONDENSATION PROTEIN B', 239963),
(308648, 'PTHR47069:SF10', NULL, NULL, NULL, NULL, 'OS04G0275550 PROTEIN', 239964),
(308649, 'PTHR47069:SF11', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 239964),
(308650, 'PTHR47069:SF9', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 239964),
(308651, 'PTHR47069:SF8', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 239964),
(308652, 'PTHR47069:SF7', NULL, NULL, NULL, NULL, 'PLANT TUDOR-LIKE RNA-BINDING PROTEIN', 239964),
(308653, 'PTHR47069', NULL, NULL, NULL, NULL, '', 239964),
(308654, 'PTHR47069:SF1', NULL, NULL, NULL, NULL, 'OS03G0580500 PROTEIN', 239964),
(308655, 'PTHR12644:SF2', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 2/3 COMPLEX SUBUNIT 5-LIKE PROTEIN', 239965),
(308656, 'PTHR12644:SF1', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 2/3 COMPLEX SUBUNIT 5', 239965),
(308657, 'PTHR12644:SF0', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 2/3 COMPLEX SUBUNIT 5', 239965),
(308658, 'PTHR12644', NULL, NULL, NULL, NULL, 'ARP2/3 COMPLEX 16 KD SUBUNIT  P16-ARC', 239965),
(308659, 'PTHR47946', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 78A7-RELATED', 239966),
(308660, 'PTHR47946:SF27', NULL, NULL, NULL, NULL, 'OS03G0134500 PROTEIN', 239966),
(308661, 'PTHR47946:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 78A9', 239966),
(308662, 'PTHR47946:SF28', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 78A6-LIKE', 239966),
(308663, 'PTHR47946:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 78A3', 239966),
(308664, 'PTHR47946:SF18', NULL, NULL, NULL, NULL, 'OS03G0603100 PROTEIN', 239966),
(308665, 'PTHR47946:SF19', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 78A3-LIKE', 239966),
(308666, 'PTHR47946:SF20', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 239966),
(308667, 'PTHR47946:SF10', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 78A5', 239966),
(308668, 'PTHR47946:SF21', NULL, NULL, NULL, NULL, 'CYTOCHROME P450-RELATED', 239966),
(308669, 'PTHR47946:SF11', NULL, NULL, NULL, NULL, 'BNAA09G51250D PROTEIN', 239966),
(308670, 'PTHR47946:SF22', NULL, NULL, NULL, NULL, 'BNAA04G27100D PROTEIN', 239966),
(308671, 'PTHR47946:SF12', NULL, NULL, NULL, NULL, 'OS09G0528700 PROTEIN', 239966),
(308672, 'PTHR47946:SF23', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 78A6', 239966),
(308673, 'PTHR47946:SF24', NULL, NULL, NULL, NULL, 'BNAA09G51570D PROTEIN', 239966),
(308674, 'PTHR47946:SF13', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN, EXPRESSED', 239966),
(308675, 'PTHR47946:SF25', NULL, NULL, NULL, NULL, 'BNAC02G22650D PROTEIN', 239966),
(308676, 'PTHR47946:SF14', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 239966);
INSERT INTO "PUBLIC"."MODEL" VALUES
(308677, 'PTHR47946:SF26', NULL, NULL, NULL, NULL, '', 239966),
(308678, 'PTHR47946:SF8', NULL, NULL, NULL, NULL, 'CYP71AU1', 239966),
(308679, 'PTHR47946:SF6', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 78A7', 239966),
(308680, 'PTHR47946:SF5', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 78, SUBFAMILY A, POLYPEPTIDE 8', 239966),
(308681, 'PTHR47946:SF4', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 78 PROTEIN', 239966),
(308682, 'PTHR40040', NULL, NULL, NULL, NULL, 'SMALL HYDROPHOBIC PROTEIN-RELATED', 239967),
(308683, 'PTHR40040:SF1', NULL, NULL, NULL, NULL, 'SMALL HYDROPHOBIC PROTEIN-RELATED', 239967),
(308684, 'PTHR40132', NULL, NULL, NULL, NULL, '', 239968),
(308685, 'PTHR40132:SF1', NULL, NULL, NULL, NULL, '', 239968),
(308686, 'PTHR47571', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE 3-3', 239969),
(308687, 'PTHR47571:SF1', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE 3-3', 239969),
(308688, 'PTHR36071', NULL, NULL, NULL, NULL, 'DNA DOUBLE-STRAND BREAK REPAIR PROTEIN', 239970),
(308689, 'PTHR36071:SF2', NULL, NULL, NULL, NULL, '', 239970),
(308690, 'PTHR36071:SF1', NULL, NULL, NULL, NULL, 'DNA DOUBLE-STRAND BREAK REPAIR PROTEIN', 239970),
(308691, 'PTHR11629:SF58', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT A', 239971),
(308692, 'PTHR11629:SF59', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT A, GOLGI ISOFORM', 239971),
(308693, 'PTHR11629:SF102', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT A', 239971),
(308694, 'PTHR11629:SF104', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT A', 239971),
(308695, 'PTHR11629:SF100', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT A', 239971),
(308696, 'PTHR11629:SF61', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT A', 239971),
(308697, 'PTHR11629:SF63', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT A', 239971),
(308698, 'PTHR11629:SF21', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE 116 KDA SUBUNIT A3', 239971),
(308699, 'PTHR11629:SF105', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT A', 239971),
(308700, 'PTHR11629:SF22', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE 116 KDA SUBUNIT A2', 239971),
(308701, 'PTHR11629:SF107', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT A', 239971),
(308702, 'PTHR11629:SF68', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE 116 KDA SUBUNIT A1', 239971),
(308703, 'PTHR11629:SF26', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE 116 KDA SUBUNIT A ISOFORM 4', 239971),
(308704, 'PTHR11629', NULL, NULL, NULL, NULL, 'VACUOLAR PROTON ATPASES', 239971),
(308705, 'PTHR11629:SF90', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT A', 239971),
(308706, 'PTHR11629:SF111', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT A', 239971),
(308707, 'PTHR11629:SF91', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT A', 239971),
(308708, 'PTHR11629:SF110', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT A2', 239971),
(308709, 'PTHR11629:SF71', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT A', 239971),
(308710, 'PTHR11629:SF94', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT A', 239971),
(308711, 'PTHR11629:SF72', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT A1', 239971),
(308712, 'PTHR11629:SF73', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT A', 239971),
(308713, 'PTHR11629:SF96', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT A', 239971),
(308714, 'PTHR11629:SF98', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT A', 239971),
(308715, 'PTHR11629:SF99', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT A', 239971),
(308716, 'PTHR11629:SF56', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT A', 239971),
(308717, 'PTHR46437', NULL, NULL, NULL, NULL, 'MORN REPEAT-CONTAINING PROTEIN 5', 239972),
(308718, 'PTHR46437:SF1', NULL, NULL, NULL, NULL, 'MORN REPEAT-CONTAINING PROTEIN 5', 239972),
(308719, 'PTHR47487:SF16', NULL, NULL, NULL, NULL, 'LATE BLIGHT RESISTANCE PROTEIN', 239973),
(308720, 'PTHR47487:SF17', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 239973),
(308721, 'PTHR47487:SF18', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 239973);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(308722, 'PTHR47487:SF19', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 346', 239973),
(308723, 'PTHR47487', NULL, NULL, NULL, NULL, 'OS06G0651300 PROTEIN-RELATED', 239973),
(308724, 'PTHR47487:SF2', NULL, NULL, NULL, NULL, 'MATRIN-TYPE DOMAIN-CONTAINING PROTEIN', 239973),
(308725, 'PTHR47487:SF20', NULL, NULL, NULL, NULL, 'ZINC FINGER, U1-TYPE-RELATED', 239973),
(308726, 'PTHR47487:SF21', NULL, NULL, NULL, NULL, '', 239973),
(308727, 'PTHR47487:SF3', NULL, NULL, NULL, NULL, 'GLUTENIN, HIGH MOLECULAR WEIGHT SUBUNIT 12-LIKE', 239973),
(308728, 'PTHR47487:SF11', NULL, NULL, NULL, NULL, 'OS09G0421800 PROTEIN', 239973),
(308729, 'PTHR47487:SF4', NULL, NULL, NULL, NULL, 'OS08G0441900 PROTEIN', 239973),
(308730, 'PTHR47487:SF12', NULL, NULL, NULL, NULL, 'GLUTENIN, HIGH MOLECULAR WEIGHT SUBUNIT DX5-LIKE', 239973),
(308731, 'PTHR47487:SF9', NULL, NULL, NULL, NULL, 'OS09G0421700 PROTEIN', 239973),
(308732, 'PTHR47487:SF14', NULL, NULL, NULL, NULL, 'U1-TYPE DOMAIN-CONTAINING PROTEIN', 239973),
(308733, 'PTHR47487:SF8', NULL, NULL, NULL, NULL, 'OS06G0651300 PROTEIN', 239973),
(308734, 'PTHR31837:SF3', NULL, NULL, NULL, NULL, 'CYTOCHROME B-245 CHAPERONE 1', 239974),
(308735, 'PTHR31837', NULL, NULL, NULL, NULL, 'CYTOCHROME B-245 CHAPERONE 1', 239974),
(308736, 'PTHR19869', NULL, NULL, NULL, NULL, 'SPERMATID WD-REPEAT PROTEIN', 239975),
(308737, 'PTHR19869:SF1', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 31', 239975),
(308738, 'PTHR23116:SF29', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN 7', 239976),
(308739, 'PTHR23116', NULL, NULL, NULL, NULL, 'PDZ DOMAIN CONTAINING WHIRLIN AND HARMONIN-RELATED', 239976),
(308740, 'PTHR23116:SF37', NULL, NULL, NULL, NULL, 'WHIRLIN', 239976),
(308741, 'PTHR23116:SF36', NULL, NULL, NULL, NULL, 'HARMONIN', 239976),
(308742, 'PTHR44489:SF17', NULL, NULL, NULL, NULL, 'WD REPEAT DOMAIN 86', 239977),
(308743, 'PTHR44489:SF18', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 48', 239977),
(308744, 'PTHR44489:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 63', 239977),
(308745, 'PTHR44489:SF19', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 86', 239977),
(308746, 'PTHR44489:SF14', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 59-RELATED', 239977),
(308747, 'PTHR44489:SF16', NULL, NULL, NULL, NULL, 'ZINC FINGER, CCCH-TYPE, WD40/YVTN REPEAT-LIKE-CONTAINING DOMAIN PROTEIN-RELATED', 239977),
(308748, 'PTHR44489:SF8', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 59', 239977),
(308749, 'PTHR44489:SF9', NULL, NULL, NULL, NULL, 'BNAC03G15740D PROTEIN', 239977),
(308750, 'PTHR44489:SF11', NULL, NULL, NULL, NULL, 'WD REPEAT DOMAIN 86', 239977),
(308751, 'PTHR44489', NULL, NULL, NULL, NULL, '', 239977),
(308752, 'PTHR13303:SF1', NULL, NULL, NULL, NULL, 'BNAA05G17160D PROTEIN', 239978),
(308753, 'PTHR13303:SF0', NULL, NULL, NULL, NULL, 'PREFOLDIN SUBUNIT 2', 239978),
(308754, 'PTHR13303', NULL, NULL, NULL, NULL, 'PREFOLDIN SUBUNIT 2', 239978),
(308755, 'PTHR23063:SF7', NULL, NULL, NULL, NULL, 'LYSOPHOSPHOLIPID ACYLTRANSFERASE LPCAT4', 239979),
(308756, 'PTHR23063:SF55', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID/GLYCEROL ACYLTRANSFERASE-RELATED', 239979),
(308757, 'PTHR23063:SF54', NULL, NULL, NULL, NULL, 'LYSOPHOSPHOLIPID ACYLTRANSFERASE LPEAT1', 239979),
(308758, 'PTHR23063:SF10', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE 3', 239979),
(308759, 'PTHR23063:SF21', NULL, NULL, NULL, NULL, 'LYSOPHOSPHATIDYLCHOLINE ACYLTRANSFERASE 2', 239979),
(308760, 'PTHR23063:SF2', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE 4, ISOFORM D-RELATED', 239979),
(308761, 'PTHR23063:SF53', NULL, NULL, NULL, NULL, 'PLSC DOMAIN-CONTAINING PROTEIN', 239979),
(308762, 'PTHR23063:SF1', NULL, NULL, NULL, NULL, 'LYSOPHOSPHATIDYLCHOLINE ACYLTRANSFERASE', 239979),
(308763, 'PTHR23063:SF52', NULL, NULL, NULL, NULL, 'LYSOPHOSPHOLIPID ACYLTRANSFERASE LPEAT2', 239979),
(308764, 'PTHR23063:SF50', NULL, NULL, NULL, NULL, 'PLSC DOMAIN-CONTAINING PROTEIN', 239979),
(308765, 'PTHR23063:SF6', NULL, NULL, NULL, NULL, 'PLSC DOMAIN-CONTAINING PROTEIN', 239979);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(308766, 'PTHR23063:SF39', NULL, NULL, NULL, NULL, 'LYSOPHOSPHOLIPID ACYLTRANSFERASE LPEAT1', 239979),
(308767, 'PTHR23063:SF38', NULL, NULL, NULL, NULL, 'PROTEIN CBG04491', 239979),
(308768, 'PTHR23063:SF49', NULL, NULL, NULL, NULL, 'BNAA03G56890D PROTEIN', 239979),
(308769, 'PTHR23063:SF37', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE 4', 239979),
(308770, 'PTHR23063', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID ACYLTRANSFERASE', 239979),
(308771, 'PTHR23063:SF58', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 239979),
(308772, 'PTHR23063:SF13', NULL, NULL, NULL, NULL, 'LYSOPHOSPHATIDYLCHOLINE ACYLTRANSFERASE 2B', 239979),
(308773, 'PTHR23063:SF57', NULL, NULL, NULL, NULL, 'LYSOPHOSPHATIDYLCHOLINE ACYLTRANSFERASE 1', 239979),
(308774, 'PTHR23063:SF46', NULL, NULL, NULL, NULL, 'LYSOPHOSPHATIDYLCHOLINE ACYLTRANSFERASE 1-RELATED', 239979),
(308775, 'PTHR23063:SF56', NULL, NULL, NULL, NULL, '1-ACYL-SN-GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE', 239979),
(308776, 'PTHR21724:SF110', NULL, NULL, NULL, NULL, 'PROTEIN CBG10421', 239980),
(308777, 'PTHR21724:SF43', NULL, NULL, NULL, NULL, 'SHKT DOMAIN-CONTAINING PROTEIN', 239980),
(308778, 'PTHR21724:SF98', NULL, NULL, NULL, NULL, '', 239980),
(308779, 'PTHR21724:SF0', NULL, NULL, NULL, NULL, 'PROTEIN CBR-TAG-293', 239980),
(308780, 'PTHR21724:SF99', NULL, NULL, NULL, NULL, 'PROTEIN CBG20818', 239980),
(308781, 'PTHR21724:SF25', NULL, NULL, NULL, NULL, 'PHARYNGEAL GLAND TOXIN-RELATED', 239980),
(308782, 'PTHR21724', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 239980),
(308783, 'PTHR21724:SF109', NULL, NULL, NULL, NULL, 'PROTEIN CBG06864', 239980),
(308784, 'PTHR21724:SF108', NULL, NULL, NULL, NULL, 'PROTEIN CBG03105', 239980),
(308785, 'PTHR21724:SF92', NULL, NULL, NULL, NULL, 'SHKT DOMAIN-CONTAINING PROTEIN', 239980),
(308786, 'PTHR21724:SF93', NULL, NULL, NULL, NULL, 'PHARYNGEAL GLAND TOXIN-RELATED', 239980),
(308787, 'PTHR21724:SF106', NULL, NULL, NULL, NULL, 'PROTEIN CBG01687', 239980),
(308788, 'PTHR21724:SF105', NULL, NULL, NULL, NULL, 'SYSTEMIC STRESS SIGNALING MEDIATOR', 239980),
(308789, 'PTHR21724:SF104', NULL, NULL, NULL, NULL, 'PROTEIN CBG10417', 239980),
(308790, 'PTHR21724:SF96', NULL, NULL, NULL, NULL, 'PROTEIN CBG20825', 239980),
(308791, 'PTHR21724:SF103', NULL, NULL, NULL, NULL, 'SHKT DOMAIN-CONTAINING PROTEIN', 239980),
(308792, 'PTHR21724:SF101', NULL, NULL, NULL, NULL, 'PROTEIN CBG01620', 239980),
(308793, 'PTHR21724:SF94', NULL, NULL, NULL, NULL, 'PROTEIN CBG15963', 239980),
(308794, 'PTHR21724:SF111', NULL, NULL, NULL, NULL, 'PROTEIN CBG28007', 239980),
(308795, 'PTHR21724:SF3', NULL, NULL, NULL, NULL, 'SHKT DOMAIN-CONTAINING PROTEIN', 239980),
(308796, 'PTHR21724:SF100', NULL, NULL, NULL, NULL, 'DIETARY RESTRICTION DOWN REGULATED-RELATED', 239980),
(308797, 'PTHR34946:SF8', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN SHOOT GRAVITROPISM 5', 239981),
(308798, 'PTHR34946:SF11', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 239981),
(308799, 'PTHR34946:SF7', NULL, NULL, NULL, NULL, 'OS02G0507100 PROTEIN', 239981),
(308800, 'PTHR34946:SF13', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 239981),
(308801, 'PTHR34946:SF15', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 239981),
(308802, 'PTHR34946', NULL, NULL, NULL, NULL, 'OS03G0310200 PROTEIN', 239981),
(308803, 'PTHR34946:SF2', NULL, NULL, NULL, NULL, 'OS03G0310200 PROTEIN', 239981),
(308804, 'PTHR34946:SF17', NULL, NULL, NULL, NULL, 'BNAANNG16740D PROTEIN', 239981),
(308805, 'PTHR34946:SF16', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 239981),
(308806, 'PTHR34946:SF18', NULL, NULL, NULL, NULL, 'ZINC FINGER C2H2-TYPE/INTEGRASE DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 239981),
(308807, 'PTHR12768:SF7', NULL, NULL, NULL, NULL, 'BECLIN-1-LIKE PROTEIN A', 239982),
(308808, 'PTHR12768:SF4', NULL, NULL, NULL, NULL, 'BECLIN-1', 239982),
(308809, 'PTHR12768:SF6', NULL, NULL, NULL, NULL, 'BECLIN-1', 239982),
(308810, 'PTHR12768', NULL, NULL, NULL, NULL, 'BECLIN 1', 239982),
(308811, 'PTHR12768:SF5', NULL, NULL, NULL, NULL, 'BECLIN-2', 239982);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(308812, 'PTHR43140:SF1', NULL, NULL, NULL, NULL, 'TYPE-1 RESTRICTION ENZYME ECOKI SPECIFICITY PROTEIN', 239983),
(308813, 'PTHR43140', NULL, NULL, NULL, NULL, 'TYPE-1 RESTRICTION ENZYME ECOKI SPECIFICITY PROTEIN', 239983),
(308814, 'PTHR22903', NULL, NULL, NULL, NULL, 'PLEKHH PROTEIN', 239984),
(308815, 'PTHR22903:SF4', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY H MEMBER 1', 239984),
(308816, 'PTHR22903:SF3', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY H MEMBER 2', 239984),
(308817, 'PTHR22903:SF8', NULL, NULL, NULL, NULL, 'MAX-1A', 239984),
(308818, 'PTHR43943', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE (SDR FAMILY) MEMBER 4', 239985),
(308819, 'PTHR43943:SF1', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE SDR FAMILY MEMBER 4-LIKE 1-RELATED', 239985),
(308820, 'PTHR43943:SF17', NULL, NULL, NULL, NULL, '3-PHENYLPROPIONATE-DIHYDRODIOL/CINNAMIC ACID-DIHYDRODIOL DEHYDROGENASE', 239985),
(308821, 'PTHR43943:SF2', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE (SDR FAMILY) MEMBER 4', 239985),
(308822, 'PTHR43943:SF3', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE SDR FAMILY MEMBER 2, MITOCHONDRIAL', 239985),
(308823, 'PTHR43943:SF8', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE SDR FAMILY MEMBER 4-RELATED', 239985),
(308824, 'PTHR43943:SF9', NULL, NULL, NULL, NULL, 'TROPINONE REDUCTASE-LIKE 3', 239985),
(308825, 'PTHR43943:SF11', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/REDUCTASE SDRA', 239985),
(308826, 'PTHR43943:SF12', NULL, NULL, NULL, NULL, 'GLUCOSE/RIBITOL DEHYDROGENASE-RELATED', 239985),
(308827, 'PTHR43943:SF13', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', 239985),
(308828, 'PTHR43943:SF14', NULL, NULL, NULL, NULL, 'TROPINONE REDUCTASE-LIKE 3', 239985),
(308829, 'PTHR43943:SF15', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE MEMBER 2', 239985),
(308830, 'PTHR43943:SF16', NULL, NULL, NULL, NULL, 'DEHYDROGENASES, SHORT CHAIN', 239985),
(308831, 'PTHR40547', NULL, NULL, NULL, NULL, 'SLL0298 PROTEIN', 239986),
(308832, 'PTHR40547:SF1', NULL, NULL, NULL, NULL, 'SLL0298 PROTEIN', 239986),
(308833, 'PTHR37829:SF4', NULL, NULL, NULL, NULL, 'BACTERIOPHAGE PROTEIN GP46-RELATED', 239987),
(308834, 'PTHR37829:SF6', NULL, NULL, NULL, NULL, 'BACTERIOPHAGE TAIL PROTEIN-RELATED', 239987),
(308835, 'PTHR37829:SF3', NULL, NULL, NULL, NULL, 'PROTEIN JAYE-RELATED', 239987),
(308836, 'PTHR37829', NULL, NULL, NULL, NULL, 'PHAGE-LIKE ELEMENT PBSX PROTEIN XKDT', 239987),
(308837, 'PTHR11409:SF47', NULL, NULL, NULL, NULL, 'ADENOSINE DEAMINASE', 239988),
(308838, 'PTHR11409', NULL, NULL, NULL, NULL, 'ADENOSINE DEAMINASE', 239988),
(308839, 'PTHR11409:SF48', NULL, NULL, NULL, NULL, 'ADENOSINE/AMP DEAMINASE', 239988),
(308840, 'PTHR11409:SF37', NULL, NULL, NULL, NULL, 'A_DEAMINASE DOMAIN-CONTAINING PROTEIN', 239988),
(308841, 'PTHR11409:SF39', NULL, NULL, NULL, NULL, 'ADENOSINE DEAMINASE 2', 239988),
(308842, 'PTHR11409:SF43', NULL, NULL, NULL, NULL, 'ADENOSINE DEAMINASE', 239988),
(308843, 'PTHR11409:SF42', NULL, NULL, NULL, NULL, 'ADENOSINE DEAMINASE-LIKE PROTEIN', 239988),
(308844, 'PTHR11409:SF45', NULL, NULL, NULL, NULL, 'ADENOSINE DEAMINASE 2-A', 239988),
(308845, 'PTHR11409:SF44', NULL, NULL, NULL, NULL, 'ADENOSINE DEAMINASE', 239988),
(308846, 'PTHR22978:SF29', NULL, NULL, NULL, NULL, 'PROTEIN BTG2', 239989),
(308847, 'PTHR22978:SF30', NULL, NULL, NULL, NULL, 'PROTEIN BTG1', 239989),
(308848, 'PTHR22978:SF40', NULL, NULL, NULL, NULL, 'ANTI_PROLIFRTN DOMAIN-CONTAINING PROTEIN', 239989),
(308849, 'PTHR22978', NULL, NULL, NULL, NULL, 'B-CELL TRANSLOCATION GENE', 239989),
(308850, 'PTHR22978:SF12', NULL, NULL, NULL, NULL, 'SI:DKEY-79D12.5', 239989),
(308851, 'PTHR22978:SF44', NULL, NULL, NULL, NULL, 'PROTEIN BTG3-LIKE PROTEIN', 239989),
(308852, 'PTHR22978:SF22', NULL, NULL, NULL, NULL, 'BTG FAMILY PROTEIN', 239989),
(308853, 'PTHR22978:SF27', NULL, NULL, NULL, NULL, 'BTG ANTI-PROLIFERATION FACTOR 1C', 239989),
(308854, 'PTHR22978:SF6', NULL, NULL, NULL, NULL, 'PROTEIN BTG3', 239989),
(308855, 'PTHR22978:SF5', NULL, NULL, NULL, NULL, 'PROTEIN BTG4', 239989);
INSERT INTO "PUBLIC"."MODEL" VALUES
(308856, 'PTHR23092:SF24', NULL, NULL, NULL, NULL, 'TERMINAL NUCLEOTIDYLTRANSFERASE 4A', 239990),
(308857, 'PTHR23092', NULL, NULL, NULL, NULL, 'POLY(A) RNA POLYMERASE', 239990),
(308858, 'PTHR23092:SF48', NULL, NULL, NULL, NULL, 'NUCLEOTIDYLTRANSFERASE FAMILY PROTEIN', 239990),
(308859, 'PTHR23092:SF15', NULL, NULL, NULL, NULL, 'INACTIVE NON-CANONICAL POLY(A) RNA POLYMERASE PROTEIN TRF4-2-RELATED', 239990),
(308860, 'PTHR23092:SF47', NULL, NULL, NULL, NULL, 'POLYMERASE SIGMA, PUTATIVE-RELATED', 239990),
(308861, 'PTHR23092:SF53', NULL, NULL, NULL, NULL, 'DNA POLYMERASE SIGMA SUBUNIT', 239990),
(308862, 'PTHR23092:SF31', NULL, NULL, NULL, NULL, 'DSCP-N DOMAIN-CONTAINING PROTEIN', 239990),
(308863, 'PTHR23092:SF52', NULL, NULL, NULL, NULL, 'POLY(A) RNA POLYMERASE CID12', 239990),
(308864, 'PTHR23092:SF51', NULL, NULL, NULL, NULL, 'TERMINAL NUCLEOTIDYLTRANSFERASE 4B', 239990),
(308865, 'PTHR23092:SF50', NULL, NULL, NULL, NULL, '', 239990),
(308866, 'PTHR35750:SF4', NULL, NULL, NULL, NULL, '', 239991),
(308867, 'PTHR35750:SF5', NULL, NULL, NULL, NULL, 'BNAA06G40400D PROTEIN', 239991),
(308868, 'PTHR35750', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID HYDROPEROXIDE GLUTATHIONE PEROXIDASE', 239991),
(308869, 'PTHR35750:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID HYDROPEROXIDE GLUTATHIONE PEROXIDASE', 239991),
(308870, 'PTHR35750:SF2', NULL, NULL, NULL, NULL, 'BNAANNG36270D PROTEIN', 239991),
(308871, 'PTHR40393', NULL, NULL, NULL, NULL, 'LYSINE BIOSYNTHESIS PROTEIN-RELATED-RELATED', 239992),
(308872, 'PTHR40393:SF1', NULL, NULL, NULL, NULL, 'LYSINE BIOSYNTHESIS PROTEIN-RELATED', 239992),
(308873, 'PTHR40393:SF2', NULL, NULL, NULL, NULL, 'ALPHA-AMINOADIPATE/GLUTAMATE CARRIER PROTEIN LYSW', 239992),
(308874, 'PTHR36144:SF4', NULL, NULL, NULL, NULL, 'ERYTHROCYTE VESICLE PROTEIN 1', 239993),
(308875, 'PTHR36144', NULL, NULL, NULL, NULL, 'S-ANTIGEN PROTEIN', 239993),
(308876, 'PTHR37154:SF1', NULL, NULL, NULL, NULL, 'MITOREGULIN', 239994),
(308877, 'PTHR37154', NULL, NULL, NULL, NULL, 'MITOREGULIN', 239994),
(308878, 'PTHR16833:SF0', NULL, NULL, NULL, NULL, 'DNA DAMAGE-INDUCIBLE TRANSCRIPT 3 PROTEIN', 239995),
(308879, 'PTHR16833', NULL, NULL, NULL, NULL, 'DNA DAMAGE-INDUCIBLE TRANSCRIPT 3 DDIT3', 239995),
(308880, 'PTHR45598:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG11839', 239996),
(308881, 'PTHR45598:SF2', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 239996),
(308882, 'PTHR45598:SF3', NULL, NULL, NULL, NULL, '', 239996),
(308883, 'PTHR45598', NULL, NULL, NULL, NULL, 'PROTEIN CBG11839-RELATED', 239996),
(308884, 'PTHR39355', NULL, NULL, NULL, NULL, 'PROTEIN CBG20624', 239997),
(308885, 'PTHR39355:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG20624', 239997),
(308886, 'PTHR46402:SF2', NULL, NULL, NULL, NULL, 'SET AND MYND DOMAIN-CONTAINING PROTEIN 5', 239998),
(308887, 'PTHR46402:SF1', NULL, NULL, NULL, NULL, '', 239998),
(308888, 'PTHR46402', NULL, NULL, NULL, NULL, 'SET AND MYND DOMAIN-CONTAINING PROTEIN 5', 239998),
(308889, 'PTHR21723:SF1', NULL, NULL, NULL, NULL, 'PROTEIN RIC-3', 239999),
(308890, 'PTHR21723', NULL, NULL, NULL, NULL, 'RESISTANCE TO INHIBITORS OF CHOLINESTERASE PROTEIN 3  RIC3', 239999),
(308891, 'PTHR21723:SF3', NULL, NULL, NULL, NULL, 'RIC3 ACETYLCHOLINE RECEPTOR CHAPERONE, ISOFORM C', 239999),
(308892, 'PTHR21723:SF2', NULL, NULL, NULL, NULL, 'RIC3 DOMAIN-CONTAINING PROTEIN', 239999),
(308893, 'PTHR15104:SF0', NULL, NULL, NULL, NULL, 'DIHYDROPTERIDINE REDUCTASE', 240000),
(308894, 'PTHR15104:SF1', NULL, NULL, NULL, NULL, 'QDPRA PROTEIN', 240000),
(308895, 'PTHR15104', NULL, NULL, NULL, NULL, 'DIHYDROPTERIDINE REDUCTASE', 240000),
(308896, 'PTHR37538', NULL, NULL, NULL, NULL, '', 240001),
(308897, 'PTHR37538:SF1', NULL, NULL, NULL, NULL, '', 240001),
(308898, 'PTHR37538:SF4', NULL, NULL, NULL, NULL, '', 240001),
(308899, 'PTHR10217:SF637', NULL, NULL, NULL, NULL, 'EAG-LIKE K[+] CHANNEL, ISOFORM A', 240002),
(308900, 'PTHR10217:SF638', NULL, NULL, NULL, NULL, 'ION_TRANS DOMAIN-CONTAINING PROTEIN-RELATED', 240002),
(308901, 'PTHR10217:SF506', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY H MEMBER 2', 240002);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(308902, 'PTHR10217:SF639', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL, SUBFAMILY H (EAG-RELATED), MEMBER 4A', 240002),
(308903, 'PTHR10217:SF435', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL PROTEIN EAG', 240002),
(308904, 'PTHR10217:SF468', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY H MEMBER 6', 240002),
(308905, 'PTHR10217:SF548', NULL, NULL, NULL, NULL, 'GH12235P', 240002),
(308906, 'PTHR10217:SF530', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY H MEMBER 1', 240002),
(308907, 'PTHR10217:SF640', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY H MEMBER 6', 240002),
(308908, 'PTHR10217:SF630', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY H MEMBER 4', 240002),
(308909, 'PTHR10217:SF641', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL, SUBFAMILY H (EAG-RELATED), MEMBER 3', 240002),
(308910, 'PTHR10217:SF466', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY H MEMBER 7', 240002),
(308911, 'PTHR10217:SF533', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY H MEMBER 5', 240002),
(308912, 'PTHR10217:SF380', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY H MEMBER 8', 240002),
(308913, 'PTHR10217:SF481', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY H MEMBER 3', 240002),
(308914, 'PTHR10217', NULL, NULL, NULL, NULL, 'VOLTAGE AND LIGAND GATED POTASSIUM CHANNEL', 240002),
(308915, 'PTHR40048:SF1', NULL, NULL, NULL, NULL, 'RHAMNOSYL O-METHYLTRANSFERASE', 240003),
(308916, 'PTHR40048', NULL, NULL, NULL, NULL, 'RHAMNOSYL O-METHYLTRANSFERASE', 240003),
(308917, 'PTHR42695:SF8', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYL PEPTIDASE 3', 240004),
(308918, 'PTHR42695:SF7', NULL, NULL, NULL, NULL, 'BNAA01G06540D PROTEIN', 240004),
(308919, 'PTHR42695', NULL, NULL, NULL, NULL, 'GLUTAMINE AMIDOTRANSFERASE YLR126C-RELATED', 240004),
(308920, 'PTHR42695:SF9', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYL PEPTIDASE 2-RELATED', 240004),
(308921, 'PTHR42695:SF13', NULL, NULL, NULL, NULL, 'GLUTAMINE AMIDOTRANSFERASE CLASS-I FAMILY PROTEIN, EXPRESSED', 240004),
(308922, 'PTHR42695:SF12', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYL PEPTIDASE 4', 240004),
(308923, 'PTHR42695:SF15', NULL, NULL, NULL, NULL, 'OS02G0179200 PROTEIN', 240004),
(308924, 'PTHR42695:SF14', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYL PEPTIDASE 1', 240004),
(308925, 'PTHR42695:SF16', NULL, NULL, NULL, NULL, 'BNAA08G13020D PROTEIN', 240004),
(308926, 'PTHR42695:SF19', NULL, NULL, NULL, NULL, 'CLASS I GLUTAMINE AMIDOTRANSFERASE', 240004),
(308927, 'PTHR42695:SF4', NULL, NULL, NULL, NULL, 'GLUTAMINE AMIDOTRANSFERASE TYPE-1 DOMAIN-CONTAINING PROTEIN', 240004),
(308928, 'PTHR42695:SF20', NULL, NULL, NULL, NULL, 'GLUTAMINE AMIDOTRANSFERASE TYPE-1 DOMAIN-CONTAINING PROTEIN', 240004),
(308929, 'PTHR42695:SF3', NULL, NULL, NULL, NULL, 'GLUTAMINE AMIDOTRANSFERASE TYPE-1 DOMAIN-CONTAINING PROTEIN', 240004),
(308930, 'PTHR42695:SF6', NULL, NULL, NULL, NULL, 'GLUTAMINE AMIDOTRANSFERASE TYPE-1 DOMAIN-CONTAINING PROTEIN', 240004),
(308931, 'PTHR42695:SF21', NULL, NULL, NULL, NULL, 'GLUTAMINE AMIDOTRANSFERASE TYPE-1 DOMAIN-CONTAINING PROTEIN', 240004),
(308932, 'PTHR42695:SF5', NULL, NULL, NULL, NULL, 'GLUTAMINE AMIDOTRANSFERASE YLR126C-RELATED', 240004),
(308933, 'PTHR35530:SF1', NULL, NULL, NULL, NULL, '2-HYDROXYMUCONATE TAUTOMERASE', 240005),
(308934, 'PTHR35530:SF2', NULL, NULL, NULL, NULL, 'BSL4019 PROTEIN', 240005),
(308935, 'PTHR35530', NULL, NULL, NULL, NULL, 'TAUTOMERASE-RELATED', 240005),
(308936, 'PTHR33488', NULL, NULL, NULL, NULL, 'ZGC:162509', 240006),
(308937, 'PTHR33488:SF2', NULL, NULL, NULL, NULL, 'ZGC:162509', 240006),
(308938, 'PTHR24116:SF1', NULL, NULL, NULL, NULL, 'KINASE D-INTERACTING SUBSTRATE 220A', 240007),
(308939, 'PTHR24116:SF2', NULL, NULL, NULL, NULL, 'KINASE D-INTERACTING SUBSTRATE OF 220 KDA B', 240007),
(308940, 'PTHR24116', NULL, NULL, NULL, NULL, 'KINASE D-INTERACTING SUBSTRATE OF 220 KDA', 240007),
(308941, 'PTHR24116:SF0', NULL, NULL, NULL, NULL, 'KINASE D-INTERACTING SUBSTRATE OF 220 KDA', 240007);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(308942, 'PTHR40736:SF3', NULL, NULL, NULL, NULL, '', 240008),
(308943, 'PTHR40736:SF1', NULL, NULL, NULL, NULL, '', 240008),
(308944, 'PTHR40736:SF2', NULL, NULL, NULL, NULL, '', 240008),
(308945, 'PTHR40736', NULL, NULL, NULL, NULL, '', 240008),
(308946, 'PTHR36649', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 240009),
(308947, 'PTHR36649:SF28', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 240009),
(308948, 'PTHR36649:SF29', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 240009),
(308949, 'PTHR21448', NULL, NULL, NULL, NULL, 'SMOOTH MUSCLE MYOSIN HEAVY CHAIN-RELATED', 240010),
(308950, 'PTHR21448:SF0', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 21', 240010),
(308951, 'PTHR47450:SF1', NULL, NULL, NULL, NULL, 'GLUCOKINASE', 240011),
(308952, 'PTHR47450', NULL, NULL, NULL, NULL, 'GLUCOKINASE', 240011),
(308953, 'PTHR36052', NULL, NULL, NULL, NULL, 'EXCITATORY AMINO ACID TRANSPORTER', 240012),
(308954, 'PTHR36052:SF1', NULL, NULL, NULL, NULL, 'EXCITATORY AMINO ACID TRANSPORTER', 240012),
(308955, 'PTHR43236', NULL, NULL, NULL, NULL, 'ANTITOXIN HIGA1', 240013),
(308956, 'PTHR43236:SF1', NULL, NULL, NULL, NULL, 'ANTITOXIN HIGA1', 240013),
(308957, 'PTHR43236:SF2', NULL, NULL, NULL, NULL, 'BLL1668 PROTEIN', 240013),
(308958, 'PTHR42940:SF8', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 11', 240014),
(308959, 'PTHR42940:SF5', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE 2', 240014),
(308960, 'PTHR42940:SF7', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE', 240014),
(308961, 'PTHR42940:SF6', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G04590)-RELATED', 240014),
(308962, 'PTHR42940:SF1', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 240014),
(308963, 'PTHR42940:SF3', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE 1-RELATED', 240014),
(308964, 'PTHR42940:SF2', NULL, NULL, NULL, NULL, 'DEHYDROGENASE FAMILY OXIDOREDUCTASE, PUTATIVE (JCVI)-RELATED', 240014),
(308965, 'PTHR42940', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE 1-RELATED', 240014),
(308966, 'PTHR16155', NULL, NULL, NULL, NULL, 'DED DOMAIN-CONTAINING PROTEIN', 240015),
(308967, 'PTHR16155:SF3', NULL, NULL, NULL, NULL, 'ZMP:0000000735', 240015),
(308968, 'PTHR16155:SF19', NULL, NULL, NULL, NULL, '', 240015),
(308969, 'PTHR16155:SF18', NULL, NULL, NULL, NULL, 'STERILE ALPHA MOTIF DOMAIN-CONTAINING PROTEIN 9-LIKE', 240015),
(308970, 'PTHR16155:SF17', NULL, NULL, NULL, NULL, 'STERILE ALPHA MOTIF DOMAIN-CONTAINING PROTEIN 9', 240015),
(308971, 'PTHR28567:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAM53B', 240016),
(308972, 'PTHR28567:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM53A', 240016),
(308973, 'PTHR28567', NULL, NULL, NULL, NULL, '', 240016),
(308974, 'PTHR28567:SF3', NULL, NULL, NULL, NULL, '', 240016),
(308975, 'PTHR28567:SF4', NULL, NULL, NULL, NULL, 'PROTEIN FAM53C', 240016),
(308976, 'PTHR47286:SF5', NULL, NULL, NULL, NULL, 'NEUROFILAMENT HEAVY PROTEIN', 240017),
(308977, 'PTHR47286:SF4', NULL, NULL, NULL, NULL, 'PROTEIN WVD2-LIKE 7', 240017),
(308978, 'PTHR47286:SF2', NULL, NULL, NULL, NULL, 'F3I6.9 PROTEIN', 240017),
(308979, 'PTHR47286', NULL, NULL, NULL, NULL, 'F3I6.9 PROTEIN', 240017),
(308980, 'PTHR47803', NULL, NULL, NULL, NULL, 'TRNA-SPECIFIC ADENOSINE DEAMINASE 1', 240018),
(308981, 'PTHR47803:SF1', NULL, NULL, NULL, NULL, 'TRNA-SPECIFIC ADENOSINE DEAMINASE 1', 240018),
(308982, 'PTHR18881:SF2', NULL, NULL, NULL, NULL, 'POLYAMINE-MODULATED FACTOR 1-BINDING PROTEIN 1', 240019),
(308983, 'PTHR18881', NULL, NULL, NULL, NULL, 'POLYAMINE-MODULATED FACTOR 1-BINDING PROTEIN 1-RELATED', 240019),
(308984, 'PTHR37822:SF2', NULL, NULL, NULL, NULL, 'SPORE PHOTOPRODUCT LYASE', 240020),
(308985, 'PTHR37822:SF1', NULL, NULL, NULL, NULL, 'PNP_UDP_1 DOMAIN-CONTAINING PROTEIN', 240020),
(308986, 'PTHR37822', NULL, NULL, NULL, NULL, 'SPORE PHOTOPRODUCT LYASE-RELATED', 240020),
(308987, 'PTHR47003:SF5', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 240021),
(308988, 'PTHR47003:SF6', NULL, NULL, NULL, NULL, '', 240021);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(308989, 'PTHR47003:SF3', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT PROTEIN', 240021),
(308990, 'PTHR47003:SF7', NULL, NULL, NULL, NULL, 'PPR SUPERFAMILY PROTEIN', 240021),
(308991, 'PTHR47003:SF8', NULL, NULL, NULL, NULL, 'BNAA06G16700D PROTEIN', 240021),
(308992, 'PTHR47003', NULL, NULL, NULL, NULL, 'OS01G0970900 PROTEIN', 240021),
(308993, 'PTHR47003:SF2', NULL, NULL, NULL, NULL, 'OS01G0970900 PROTEIN', 240021),
(308994, 'PTHR34277:SF2', NULL, NULL, NULL, NULL, 'OS03G0803200 PROTEIN', 240022),
(308995, 'PTHR34277:SF18', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 25', 240022),
(308996, 'PTHR34277:SF17', NULL, NULL, NULL, NULL, 'BNAA02G29310D PROTEIN', 240022),
(308997, 'PTHR34277:SF19', NULL, NULL, NULL, NULL, '', 240022),
(308998, 'PTHR34277:SF1', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE) GENE FAMILY MEMBER MTCLE20', 240022),
(308999, 'PTHR34277:SF21', NULL, NULL, NULL, NULL, 'CLE FAMILY OSCLE305 PROTEIN', 240022),
(309000, 'PTHR34277:SF20', NULL, NULL, NULL, NULL, '', 240022),
(309001, 'PTHR34277', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 26', 240022),
(309002, 'PTHR34277:SF23', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 26', 240022),
(309003, 'PTHR34277:SF22', NULL, NULL, NULL, NULL, 'CLE FAMILY OSCLE701 PROTEIN', 240022),
(309004, 'PTHR34277:SF25', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR-RELATED 25-RELATED', 240022),
(309005, 'PTHR34277:SF14', NULL, NULL, NULL, NULL, 'OS05G0505900 PROTEIN', 240022),
(309006, 'PTHR34277:SF24', NULL, NULL, NULL, NULL, 'CLE25', 240022),
(309007, 'PTHR34403:SF12', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 240023),
(309008, 'PTHR34403', NULL, NULL, NULL, NULL, 'TOL-PAL SYSTEM PROTEIN TOLA', 240023),
(309009, 'PTHR34403:SF13', NULL, NULL, NULL, NULL, 'OS07G0418600 PROTEIN', 240023),
(309010, 'PTHR34403:SF8', NULL, NULL, NULL, NULL, 'TOL-PAL SYSTEM PROTEIN TOLA', 240023),
(309011, 'PTHR34403:SF14', NULL, NULL, NULL, NULL, 'OS05G0225800 PROTEIN', 240023),
(309012, 'PTHR15215:SF0', NULL, NULL, NULL, NULL, 'CABIT DOMAIN-CONTAINING PROTEIN', 240024),
(309013, 'PTHR15215', NULL, NULL, NULL, NULL, 'CABIT DOMAIN-CONTAINING PROTEIN', 240024),
(309014, 'PTHR15215:SF3', NULL, NULL, NULL, NULL, 'PROTEIN THEMIS3', 240024),
(309015, 'PTHR15215:SF2', NULL, NULL, NULL, NULL, 'PROTEIN THEMIS2', 240024),
(309016, 'PTHR15215:SF1', NULL, NULL, NULL, NULL, 'PROTEIN THEMIS', 240024),
(309017, 'PTHR46159:SF18', NULL, NULL, NULL, NULL, 'CRC DOMAIN-CONTAINING PROTEIN', 240025),
(309018, 'PTHR46159:SF2', NULL, NULL, NULL, NULL, 'OS05G0509400 PROTEIN', 240025),
(309019, 'PTHR46159:SF15', NULL, NULL, NULL, NULL, 'CRC DOMAIN-CONTAINING PROTEIN', 240025),
(309020, 'PTHR46159:SF14', NULL, NULL, NULL, NULL, 'CRC DOMAIN-CONTAINING PROTEIN', 240025),
(309021, 'PTHR46159:SF13', NULL, NULL, NULL, NULL, 'CRC DOMAIN-CONTAINING PROTEIN TSO1', 240025),
(309022, 'PTHR46159:SF6', NULL, NULL, NULL, NULL, 'CRC DOMAIN-CONTAINING PROTEIN', 240025),
(309023, 'PTHR46159:SF12', NULL, NULL, NULL, NULL, 'PROTEIN TESMIN/TSO1-LIKE CXC 2-RELATED', 240025),
(309024, 'PTHR46159:SF11', NULL, NULL, NULL, NULL, 'PROTEIN TESMIN/TSO1-LIKE CXC 2', 240025),
(309025, 'PTHR46159:SF4', NULL, NULL, NULL, NULL, 'OS12G0605300 PROTEIN', 240025),
(309026, 'PTHR46159:SF8', NULL, NULL, NULL, NULL, 'PROTEIN TESMIN/TSO1-LIKE CXC 3', 240025),
(309027, 'PTHR46159', NULL, NULL, NULL, NULL, 'PROTEIN TESMIN/TSO1-LIKE CXC 2', 240025),
(309028, 'PTHR46159:SF19', NULL, NULL, NULL, NULL, 'OS12G0605500 PROTEIN', 240025),
(309029, 'PTHR48280', NULL, NULL, NULL, NULL, 'OS05G0394900 PROTEIN', 240026),
(309030, 'PTHR48280:SF1', NULL, NULL, NULL, NULL, 'OS05G0394900 PROTEIN', 240026),
(309031, 'PTHR11362:SF90', NULL, NULL, NULL, NULL, 'RCN1-CORN CENTRORADIALIS/TFL1-LIKE PROTEIN', 240027),
(309032, 'PTHR11362:SF94', NULL, NULL, NULL, NULL, 'FLOWERING LOCUS T-10', 240027),
(309033, 'PTHR11362:SF91', NULL, NULL, NULL, NULL, 'ZCN13', 240027),
(309034, 'PTHR11362:SF98', NULL, NULL, NULL, NULL, 'ZCN18', 240027),
(309035, 'PTHR11362:SF10', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLETHANOLAMINE-BINDING PROTEIN 1', 240027);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(309036, 'PTHR11362:SF96', NULL, NULL, NULL, NULL, 'FTC', 240027),
(309037, 'PTHR11362:SF13', NULL, NULL, NULL, NULL, 'PROTEIN TERMINAL FLOWER 1', 240027),
(309038, 'PTHR11362:SF99', NULL, NULL, NULL, NULL, 'OS06G0552900 PROTEIN', 240027),
(309039, 'PTHR11362:SF130', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 240027),
(309040, 'PTHR11362:SF133', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L38, MITOCHONDRIAL', 240027),
(309041, 'PTHR11362:SF135', NULL, NULL, NULL, NULL, 'LOCUS T-LIKE PROTEIN, PUTATIVE-RELATED', 240027),
(309042, 'PTHR11362:SF138', NULL, NULL, NULL, NULL, '', 240027),
(309043, 'PTHR11362:SF20', NULL, NULL, NULL, NULL, 'OS12G0232300 PROTEIN', 240027),
(309044, 'PTHR11362:SF9', NULL, NULL, NULL, NULL, 'PROTEIN FLOWERING LOCUS T-RELATED', 240027),
(309045, 'PTHR11362:SF8', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLETHANOLAMINE-BINDING PROTEIN 2', 240027),
(309046, 'PTHR11362:SF23', NULL, NULL, NULL, NULL, 'OS04G0488400 PROTEIN', 240027),
(309047, 'PTHR11362:SF122', NULL, NULL, NULL, NULL, 'BNAA06G12320D PROTEIN', 240027),
(309048, 'PTHR11362:SF121', NULL, NULL, NULL, NULL, 'BNACNNG10680D PROTEIN', 240027),
(309049, 'PTHR11362:SF126', NULL, NULL, NULL, NULL, 'FLOWERING LOCUS T', 240027),
(309050, 'PTHR11362:SF128', NULL, NULL, NULL, NULL, 'BNAC02G23820D PROTEIN', 240027),
(309051, 'PTHR11362:SF127', NULL, NULL, NULL, NULL, 'BNAC02G02900D PROTEIN', 240027),
(309052, 'PTHR11362:SF129', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLETHANOLAMINE-BINDING PROTEIN PEBP-RELATED', 240027),
(309053, 'PTHR11362:SF31', NULL, NULL, NULL, NULL, 'OS02G0232300 PROTEIN', 240027),
(309054, 'PTHR11362:SF30', NULL, NULL, NULL, NULL, 'OS05G0518000 PROTEIN', 240027),
(309055, 'PTHR11362:SF79', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLETHANOLAMINE-BINDING PROTEIN8', 240027),
(309056, 'PTHR11362:SF78', NULL, NULL, NULL, NULL, 'PROTEASE INHIBITOR', 240027),
(309057, 'PTHR11362:SF77', NULL, NULL, NULL, NULL, 'PUTATIVE, EXPRESSED-RELATED', 240027),
(309058, 'PTHR11362:SF111', NULL, NULL, NULL, NULL, '', 240027),
(309059, 'PTHR11362:SF110', NULL, NULL, NULL, NULL, 'PROTEIN FLOWERING LOCUS T-LIKE', 240027),
(309060, 'PTHR11362:SF113', NULL, NULL, NULL, NULL, 'OS01G0218500 PROTEIN', 240027),
(309061, 'PTHR11362:SF115', NULL, NULL, NULL, NULL, 'OS02G0531600 PROTEIN', 240027),
(309062, 'PTHR11362:SF114', NULL, NULL, NULL, NULL, 'BNAC06G27090D PROTEIN', 240027),
(309063, 'PTHR11362:SF117', NULL, NULL, NULL, NULL, '', 240027),
(309064, 'PTHR11362:SF116', NULL, NULL, NULL, NULL, 'FLOWERING LOCUS T', 240027),
(309065, 'PTHR11362:SF119', NULL, NULL, NULL, NULL, '', 240027),
(309066, 'PTHR11362:SF118', NULL, NULL, NULL, NULL, 'BNAA04G15930D PROTEIN', 240027),
(309067, 'PTHR11362:SF82', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLETHANOLAMINE-BINDING PROTEIN 4', 240027),
(309068, 'PTHR11362:SF81', NULL, NULL, NULL, NULL, 'PROTEIN CBG19696', 240027),
(309069, 'PTHR11362:SF87', NULL, NULL, NULL, NULL, 'ZCN17', 240027),
(309070, 'PTHR11362:SF42', NULL, NULL, NULL, NULL, 'PROTEIN MOTHER OF FT AND TFL1 HOMOLOG 2', 240027),
(309071, 'PTHR11362:SF85', NULL, NULL, NULL, NULL, 'INHIBITOR (TFS1), PUTATIVE (AFU_ORTHOLOGUE AFUA_4G08120)-RELATED', 240027),
(309072, 'PTHR11362:SF89', NULL, NULL, NULL, NULL, '', 240027),
(309073, 'PTHR11362:SF88', NULL, NULL, NULL, NULL, 'ZCN16', 240027),
(309074, 'PTHR11362:SF44', NULL, NULL, NULL, NULL, 'PROTEIN CBG05964', 240027),
(309075, 'PTHR11362:SF140', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 240027),
(309076, 'PTHR11362:SF142', NULL, NULL, NULL, NULL, 'FTB2', 240027),
(309077, 'PTHR11362:SF141', NULL, NULL, NULL, NULL, '', 240027),
(309078, 'PTHR11362:SF48', NULL, NULL, NULL, NULL, 'PROTEIN CENTRORADIALIS-LIKE', 240027),
(309079, 'PTHR11362:SF144', NULL, NULL, NULL, NULL, 'GH14494P-RELATED', 240027),
(309080, 'PTHR11362:SF100', NULL, NULL, NULL, NULL, '', 240027),
(309081, 'PTHR11362:SF143', NULL, NULL, NULL, NULL, 'PROTEIN HEADING DATE 3A-LIKE', 240027),
(309082, 'PTHR11362:SF146', NULL, NULL, NULL, NULL, 'PROTEIN CBG17738', 240027),
(309083, 'PTHR11362:SF145', NULL, NULL, NULL, NULL, 'PROTEIN MOTHER OF FT AND TFL1-LIKE', 240027);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(309084, 'PTHR11362:SF148', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE Y INHIBITOR', 240027),
(309085, 'PTHR11362:SF147', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLETHANOLAMINE BINDING PROTEIN', 240027),
(309086, 'PTHR11362:SF103', NULL, NULL, NULL, NULL, '', 240027),
(309087, 'PTHR11362:SF106', NULL, NULL, NULL, NULL, 'OS01G0202700 PROTEIN', 240027),
(309088, 'PTHR11362:SF105', NULL, NULL, NULL, NULL, '', 240027),
(309089, 'PTHR11362:SF108', NULL, NULL, NULL, NULL, 'PROTEIN BROTHER OF FT AND TFL 1', 240027),
(309090, 'PTHR11362', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLETHANOLAMINE-BINDING PROTEIN', 240027),
(309091, 'PTHR11362:SF107', NULL, NULL, NULL, NULL, 'CEN-LIKE PROTEIN 1', 240027),
(309092, 'PTHR11362:SF109', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLETHANOLAMINE-BINDING PROTEIN 1', 240027),
(309093, 'PTHR35748', NULL, NULL, NULL, NULL, 'OS05G0358400 PROTEIN', 240028),
(309094, 'PTHR35748:SF1', NULL, NULL, NULL, NULL, 'OS05G0358400 PROTEIN', 240028),
(309095, 'PTHR35748:SF2', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYL CYCLOTRANSFERASE-RELATED', 240028),
(309096, 'PTHR22227', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 240029),
(309097, 'PTHR22227:SF1', NULL, NULL, NULL, NULL, 'PABIR FAMILY MEMBER 2', 240029),
(309098, 'PTHR22227:SF3', NULL, NULL, NULL, NULL, 'PPP2R1A-PPP2R2A-INTERACTING PHOSPHATASE REGULATOR 1', 240029),
(309099, 'PTHR22227:SF12', NULL, NULL, NULL, NULL, 'PABIR FAMILY MEMBER 3', 240029),
(309100, 'PTHR22227:SF11', NULL, NULL, NULL, NULL, 'FAM122C PROTEIN', 240029),
(309101, 'PTHR22227:SF6', NULL, NULL, NULL, NULL, 'FAMILY WITH SEQUENCE SIMILARITY 122B', 240029),
(309102, 'PTHR22227:SF9', NULL, NULL, NULL, NULL, 'PABIR FAMILY MEMBER 1', 240029),
(309103, 'PTHR35362', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 240030),
(309104, 'PTHR35362:SF1', NULL, NULL, NULL, NULL, 'SKICH DOMAIN-CONTAINING PROTEIN', 240030),
(309105, 'PTHR43406:SF8', NULL, NULL, NULL, NULL, 'TRYPTOPHAN SYNTHASE', 240031),
(309106, 'PTHR43406:SF9', NULL, NULL, NULL, NULL, 'TRYPTOPHAN SYNTHASE', 240031),
(309107, 'PTHR43406', NULL, NULL, NULL, NULL, 'TRYPTOPHAN SYNTHASE, ALPHA CHAIN', 240031),
(309108, 'PTHR43406:SF10', NULL, NULL, NULL, NULL, 'TRYPTOPHAN SYNTHASE', 240031),
(309109, 'PTHR43406:SF1', NULL, NULL, NULL, NULL, 'TRYPTOPHAN SYNTHASE ALPHA CHAIN, CHLOROPLASTIC', 240031),
(309110, 'PTHR43406:SF12', NULL, NULL, NULL, NULL, 'TRYPTOPHAN SYNTHASE', 240031),
(309111, 'PTHR43406:SF3', NULL, NULL, NULL, NULL, 'TRYPTOPHAN SYNTHASE', 240031),
(309112, 'PTHR43406:SF6', NULL, NULL, NULL, NULL, 'TRYPTOPHAN SYNTHASE ALPHA CHAIN', 240031),
(309113, 'PTHR43406:SF7', NULL, NULL, NULL, NULL, 'INDOLE-3-GLYCEROL PHOSPHATE LYASE, CHLOROPLASTIC', 240031),
(309114, 'PTHR31710', NULL, NULL, NULL, NULL, 'GB|AAF16529.1-RELATED', 240032),
(309115, 'PTHR31710:SF38', NULL, NULL, NULL, NULL, 'GB|AAF16529.1-RELATED', 240032),
(309116, 'PTHR12322:SF17', NULL, NULL, NULL, NULL, 'DM DOMAIN-CONTAINING PROTEIN', 240033),
(309117, 'PTHR12322:SF49', NULL, NULL, NULL, NULL, 'DM (DOUBLESEX/MAB-3) DOMAIN FAMILY', 240033),
(309118, 'PTHR12322:SF15', NULL, NULL, NULL, NULL, 'DOUBLESEX- AND MAB-3-RELATED TRANSCRIPTION FACTOR C2', 240033),
(309119, 'PTHR12322:SF56', NULL, NULL, NULL, NULL, 'DM DOMAIN-CONTAINING PROTEIN', 240033),
(309120, 'PTHR12322:SF66', NULL, NULL, NULL, NULL, 'DOUBLESEX- AND MAB-3-RELATED TRANSCRIPTION FACTOR B1', 240033),
(309121, 'PTHR12322:SF119', NULL, NULL, NULL, NULL, 'DM DOMAIN-CONTAINING PROTEIN', 240033),
(309122, 'PTHR12322:SF76', NULL, NULL, NULL, NULL, 'DOUBLESEX- AND MAB-3-RELATED TRANSCRIPTION FACTOR A2', 240033),
(309123, 'PTHR12322:SF53', NULL, NULL, NULL, NULL, 'DOUBLESEX- AND MAB-3-RELATED TRANSCRIPTION FACTOR 2', 240033),
(309124, 'PTHR12322:SF52', NULL, NULL, NULL, NULL, 'DM DOMAIN-CONTAINING PROTEIN', 240033),
(309125, 'PTHR12322:SF71', NULL, NULL, NULL, NULL, 'DOUBLESEX- AND MAB-3-RELATED TRANSCRIPTION FACTOR A1', 240033),
(309126, 'PTHR12322:SF60', NULL, NULL, NULL, NULL, 'DMRT-LIKE FAMILY C1C1', 240033),
(309127, 'PTHR12322:SF70', NULL, NULL, NULL, NULL, 'DOUBLESEX- AND MAB-3-RELATED TRANSCRIPTION FACTOR 1', 240033);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(309128, 'PTHR12322:SF120', NULL, NULL, NULL, NULL, 'DOUBLESEX- AND MAB-3-RELATED TRANSCRIPTION FACTOR 3', 240033),
(309129, 'PTHR12322:SF110', NULL, NULL, NULL, NULL, 'DM DOMAIN-CONTAINING PROTEIN-RELATED', 240033),
(309130, 'PTHR12322:SF121', NULL, NULL, NULL, NULL, 'DOUBLESEX-MAB RELATED 93B', 240033),
(309131, 'PTHR12322:SF117', NULL, NULL, NULL, NULL, 'DOUBLESEX- AND MAB-3-RELATED TRANSCRIPTION FACTOR C1', 240033),
(309132, 'PTHR12322', NULL, NULL, NULL, NULL, 'DOUBLESEX AND MAB-3 RELATED TRANSCRIPTION FACTOR  DMRT', 240033),
(309133, 'PTHR12322:SF118', NULL, NULL, NULL, NULL, 'PROTEIN MALE ABNORMAL 3', 240033),
(309134, 'PTHR12322:SF115', NULL, NULL, NULL, NULL, 'PROTEIN CBR-MAB-23', 240033),
(309135, 'PTHR12322:SF116', NULL, NULL, NULL, NULL, 'DOUBLESEX-MAB RELATED 11E-RELATED', 240033),
(309136, 'PTHR12322:SF100', NULL, NULL, NULL, NULL, 'PROTEIN DOUBLESEX', 240033),
(309137, 'PTHR12044:SF9', NULL, NULL, NULL, NULL, 'BCL-2-LIKE PROTEIN 11', 240034),
(309138, 'PTHR12044:SF10', NULL, NULL, NULL, NULL, 'MEIOSIS INHIBITOR PROTEIN 1', 240034),
(309139, 'PTHR12044', NULL, NULL, NULL, NULL, 'BCL2 INTERACTING MEDIATOR OF CELL DEATH', 240034),
(309140, 'PTHR12044:SF11', NULL, NULL, NULL, NULL, 'SLP ADAPTER AND CSK-INTERACTING MEMBRANE PROTEIN', 240034),
(309141, 'PTHR12044:SF14', NULL, NULL, NULL, NULL, 'PUTATIVE RECOMBINATION INITIATION DEFECT 1-RELATED', 240034),
(309142, 'PTHR42932', NULL, NULL, NULL, NULL, 'GENERAL STRESS PROTEIN 20U', 240035),
(309143, 'PTHR42932:SF1', NULL, NULL, NULL, NULL, 'GENERAL STRESS PROTEIN 20U', 240035),
(309144, 'PTHR42932:SF2', NULL, NULL, NULL, NULL, 'DNA PROTECTION DURING STARVATION PROTEIN 1', 240035),
(309145, 'PTHR42932:SF3', NULL, NULL, NULL, NULL, 'DNA PROTECTION DURING STARVATION PROTEIN', 240035),
(309146, 'PTHR28618', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN POC5', 240036),
(309147, 'PTHR28618:SF1', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN POC5', 240036),
(309148, 'PTHR31421:SF14', NULL, NULL, NULL, NULL, 'GAGA-BINDING TRANSCRIPTIONAL ACTIVATOR', 240037),
(309149, 'PTHR31421:SF13', NULL, NULL, NULL, NULL, 'GAGA-BINDING TRANSCRIPTIONAL ACTIVATOR', 240037),
(309150, 'PTHR31421:SF15', NULL, NULL, NULL, NULL, 'GAGA-BINDING TRANSCRIPTIONAL ACTIVATOR', 240037),
(309151, 'PTHR31421:SF6', NULL, NULL, NULL, NULL, 'PROTEIN BASIC PENTACYSTEINE7', 240037),
(309152, 'PTHR31421:SF7', NULL, NULL, NULL, NULL, 'PROTEIN BASIC PENTACYSTEINE5', 240037),
(309153, 'PTHR31421:SF8', NULL, NULL, NULL, NULL, 'GAGA-BINDING TRANSCRIPTIONAL ACTIVATOR', 240037),
(309154, 'PTHR31421:SF10', NULL, NULL, NULL, NULL, 'GAGA-BINDING TRANSCRIPTIONAL ACTIVATOR', 240037),
(309155, 'PTHR31421:SF23', NULL, NULL, NULL, NULL, 'GAGA-BINDING TRANSCRIPTIONAL ACTIVATOR', 240037),
(309156, 'PTHR31421:SF12', NULL, NULL, NULL, NULL, 'BNAA06G09500D PROTEIN', 240037),
(309157, 'PTHR31421:SF22', NULL, NULL, NULL, NULL, 'PROTEIN BASIC PENTACYSTEINE3', 240037),
(309158, 'PTHR31421:SF2', NULL, NULL, NULL, NULL, 'PROTEIN BASIC PENTACYSTEINE6', 240037),
(309159, 'PTHR31421:SF3', NULL, NULL, NULL, NULL, 'PROTEIN BASIC PENTACYSTEINE4', 240037),
(309160, 'PTHR31421:SF0', NULL, NULL, NULL, NULL, 'PROTEIN BASIC PENTACYSTEINE1-RELATED', 240037),
(309161, 'PTHR31421', NULL, NULL, NULL, NULL, '', 240037),
(309162, 'PTHR31238:SF208', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309163, 'PTHR31238:SF200', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309164, 'PTHR31238:SF288', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309165, 'PTHR31238:SF8', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN SUBFAMILY 3 MEMBER 2', 240038),
(309166, 'PTHR31238:SF289', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309167, 'PTHR31238:SF202', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309168, 'PTHR31238:SF5', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN SUBFAMILY 1 MEMBER 1', 240038),
(309169, 'PTHR31238:SF205', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309170, 'PTHR31238:SF3', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN SUBFAMILY 3 MEMBER 4', 240038),
(309171, 'PTHR31238:SF280', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN 9-2-RELATED', 240038);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(309172, 'PTHR31238:SF281', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309173, 'PTHR31238:SF282', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309174, 'PTHR31238:SF162', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN SUBFAMILY T MEMBER 3', 240038),
(309175, 'PTHR31238:SF283', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309176, 'PTHR31238:SF284', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN 8-7', 240038),
(309177, 'PTHR31238:SF163', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309178, 'PTHR31238:SF285', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309179, 'PTHR31238:SF164', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309180, 'PTHR31238:SF286', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309181, 'PTHR31238:SF287', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309182, 'PTHR31238:SF166', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_3G03880)-RELATED', 240038),
(309183, 'PTHR31238:SF277', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309184, 'PTHR31238:SF157', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN SUBFAMILY 2 MEMBER 5-RELATED', 240038),
(309185, 'PTHR31238:SF278', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309186, 'PTHR31238:SF279', NULL, NULL, NULL, NULL, 'CUPIN TYPE-1 DOMAIN-CONTAINING PROTEIN', 240038),
(309187, 'PTHR31238:SF270', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309188, 'PTHR31238:SF271', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309189, 'PTHR31238:SF151', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309190, 'PTHR31238:SF272', NULL, NULL, NULL, NULL, 'CUPIN TYPE-1 DOMAIN-CONTAINING PROTEIN', 240038),
(309191, 'PTHR31238:SF152', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309192, 'PTHR31238:SF273', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309193, 'PTHR31238:SF274', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309194, 'PTHR31238:SF275', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309195, 'PTHR31238:SF154', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN 9-2-RELATED', 240038),
(309196, 'PTHR31238:SF276', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309197, 'PTHR31238:SF266', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN SUBFAMILY 3 MEMBER 1', 240038),
(309198, 'PTHR31238:SF145', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309199, 'PTHR31238:SF267', NULL, NULL, NULL, NULL, 'CUPIN TYPE-1 DOMAIN-CONTAINING PROTEIN', 240038),
(309200, 'PTHR31238:SF268', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309201, 'PTHR31238:SF269', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309202, 'PTHR31238:SF148', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN 9-1', 240038),
(309203, 'PTHR31238:SF149', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309204, 'PTHR31238:SF260', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309205, 'PTHR31238:SF261', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN 4-1', 240038),
(309206, 'PTHR31238:SF141', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309207, 'PTHR31238:SF263', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309208, 'PTHR31238:SF264', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309209, 'PTHR31238:SF143', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309210, 'PTHR31238:SF265', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309211, 'PTHR31238:SF144', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN SUBFAMILY 2 MEMBER 1', 240038),
(309212, 'PTHR31238:SF255', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309213, 'PTHR31238:SF256', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN SUBFAMILY 1 MEMBER 13-RELATED', 240038),
(309214, 'PTHR31238:SF257', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309215, 'PTHR31238:SF137', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309216, 'PTHR31238:SF258', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309217, 'PTHR31238:SF259', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(309218, 'PTHR31238:SF139', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309219, 'PTHR31238', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN SUBFAMILY 3 MEMBER 3', 240038),
(309220, 'PTHR31238:SF254', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN SUBFAMILY 1 MEMBER 16-RELATED', 240038),
(309221, 'PTHR31238:SF133', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309222, 'PTHR31238:SF49', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN 8-13', 240038),
(309223, 'PTHR31238:SF245', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309224, 'PTHR31238:SF124', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309225, 'PTHR31238:SF125', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309226, 'PTHR31238:SF246', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309227, 'PTHR31238:SF247', NULL, NULL, NULL, NULL, 'AUXIN-BINDING PROTEIN ABP19B', 240038),
(309228, 'PTHR31238:SF248', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN 8-2', 240038),
(309229, 'PTHR31238:SF249', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN 5-1', 240038),
(309230, 'PTHR31238:SF121', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN SUBFAMILY 1 MEMBER 3-RELATED', 240038),
(309231, 'PTHR31238:SF242', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309232, 'PTHR31238:SF122', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN SUBFAMILY 1 MEMBER 8', 240038),
(309233, 'PTHR31238:SF38', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN 8-3', 240038),
(309234, 'PTHR31238:SF36', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN 1-1', 240038),
(309235, 'PTHR31238:SF34', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN 1-2', 240038),
(309236, 'PTHR31238:SF32', NULL, NULL, NULL, NULL, 'DECARBOXYLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G14610)-RELATED', 240038),
(309237, 'PTHR31238:SF233', NULL, NULL, NULL, NULL, 'OXALATE OXIDASE GF-3.8', 240038),
(309238, 'PTHR31238:SF234', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN SUBFAMILY 3 MEMBER 3', 240038),
(309239, 'PTHR31238:SF114', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309240, 'PTHR31238:SF118', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309241, 'PTHR31238:SF239', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309242, 'PTHR31238:SF119', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN SUBFAMILY 1 MEMBER 6-RELATED', 240038),
(309243, 'PTHR31238:SF192', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309244, 'PTHR31238:SF230', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309245, 'PTHR31238:SF198', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309246, 'PTHR31238:SF28', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN 3-2-RELATED', 240038),
(309247, 'PTHR31238:SF111', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309248, 'PTHR31238:SF232', NULL, NULL, NULL, NULL, 'CUPIN TYPE-1 DOMAIN-CONTAINING PROTEIN', 240038),
(309249, 'PTHR31238:SF26', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN 3-5', 240038),
(309250, 'PTHR31238:SF23', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN 1-4', 240038),
(309251, 'PTHR31238:SF191', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309252, 'PTHR31238:SF109', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309253, 'PTHR31238:SF222', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309254, 'PTHR31238:SF102', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309255, 'PTHR31238:SF223', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309256, 'PTHR31238:SF103', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN SUBFAMILY 2 MEMBER 3', 240038),
(309257, 'PTHR31238:SF104', NULL, NULL, NULL, NULL, 'CUPIN TYPE-1 DOMAIN-CONTAINING PROTEIN', 240038),
(309258, 'PTHR31238:SF105', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309259, 'PTHR31238:SF226', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309260, 'PTHR31238:SF228', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN SUBFAMILY 1 MEMBER 10-RELATED', 240038),
(309261, 'PTHR31238:SF107', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309262, 'PTHR31238:SF229', NULL, NULL, NULL, NULL, 'NECTARIN-1-LIKE', 240038);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(309263, 'PTHR31238:SF108', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309264, 'PTHR31238:SF183', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309265, 'PTHR31238:SF184', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309266, 'PTHR31238:SF186', NULL, NULL, NULL, NULL, 'CUPIN TYPE-1 DOMAIN-CONTAINING PROTEIN', 240038),
(309267, 'PTHR31238:SF187', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309268, 'PTHR31238:SF220', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309269, 'PTHR31238:SF18', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN SUBFAMILY 2 MEMBER 4', 240038),
(309270, 'PTHR31238:SF14', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN SUBFAMILY T MEMBER 1-RELATED', 240038),
(309271, 'PTHR31238:SF97', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN 2-1-RELATED', 240038),
(309272, 'PTHR31238:SF96', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN 12-2', 240038),
(309273, 'PTHR31238:SF178', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309274, 'PTHR31238:SF211', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309275, 'PTHR31238:SF179', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309276, 'PTHR31238:SF212', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309277, 'PTHR31238:SF213', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309278, 'PTHR31238:SF214', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309279, 'PTHR31238:SF215', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309280, 'PTHR31238:SF216', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309281, 'PTHR31238:SF291', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309282, 'PTHR31238:SF170', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309283, 'PTHR31238:SF171', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309284, 'PTHR31238:SF292', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309285, 'PTHR31238:SF293', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309286, 'PTHR31238:SF173', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN SUBFAMILY 2 MEMBER 2', 240038),
(309287, 'PTHR31238:SF294', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309288, 'PTHR31238:SF295', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309289, 'PTHR31238:SF296', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309290, 'PTHR31238:SF210', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309291, 'PTHR31238:SF290', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN', 240038),
(309292, 'PTHR46969:SF1', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL PROTEIN HLDE', 240039),
(309293, 'PTHR46969', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL PROTEIN HLDE', 240039),
(309294, 'PTHR36127:SF4', NULL, NULL, NULL, NULL, '', 240040),
(309295, 'PTHR36127:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240040),
(309296, 'PTHR36127:SF3', NULL, NULL, NULL, NULL, '', 240040),
(309297, 'PTHR36127', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240040),
(309298, 'PTHR34132:SF4', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240041),
(309299, 'PTHR34132:SF11', NULL, NULL, NULL, NULL, '', 240041),
(309300, 'PTHR34132:SF8', NULL, NULL, NULL, NULL, 'BNAUNNG04130D PROTEIN', 240041),
(309301, 'PTHR34132', NULL, NULL, NULL, NULL, 'EMB|CAB87627.1-RELATED', 240041),
(309302, 'PTHR34132:SF2', NULL, NULL, NULL, NULL, 'EMB|CAB87627.1-RELATED', 240041),
(309303, 'PTHR34132:SF3', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE-LIKE PROTEIN', 240041),
(309304, 'PTHR36203:SF1', NULL, NULL, NULL, NULL, 'ASCORBATE-SPECIFIC PTS SYSTEM EIIA COMPONENT', 240042),
(309305, 'PTHR36203:SF2', NULL, NULL, NULL, NULL, 'POSSIBLE SUGAR-TRANSPORT PROTEIN', 240042),
(309306, 'PTHR36203:SF3', NULL, NULL, NULL, NULL, 'PHOSPHOTRANSFERASE IIA COMPONENT SGCA-RELATED', 240042),
(309307, 'PTHR36203:SF4', NULL, NULL, NULL, NULL, 'MANNITOL-SPECIFIC CRYPTIC PHOSPHOTRANSFERASE ENZYME IIA COMPONENT', 240042),
(309308, 'PTHR36203', NULL, NULL, NULL, NULL, 'ASCORBATE-SPECIFIC PTS SYSTEM EIIA COMPONENT', 240042),
(309309, 'PTHR45938', NULL, NULL, NULL, NULL, 'ACP24A4-RELATED', 240043);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(309310, 'PTHR45938:SF6', NULL, NULL, NULL, NULL, 'WAP, KAZAL, IMMUNOGLOBULIN, KUNITZ AND NTR DOMAIN-CONTAINING PROTEIN 1', 240043),
(309311, 'PTHR45938:SF7', NULL, NULL, NULL, NULL, 'WAP, KAZAL, IMMUNOGLOBULIN, KUNITZ AND NTR DOMAIN-CONTAINING PROTEIN 2', 240043),
(309312, 'PTHR45938:SF11', NULL, NULL, NULL, NULL, '', 240043),
(309313, 'PTHR21163:SF1', NULL, NULL, NULL, NULL, 'AGAP006635-PA', 240044),
(309314, 'PTHR21163:SF0', NULL, NULL, NULL, NULL, 'GH08205P-RELATED', 240044),
(309315, 'PTHR21163', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 240044),
(309316, 'PTHR36772:SF1', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-KINASE', 240045),
(309317, 'PTHR36772', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-KINASE', 240045),
(309318, 'PTHR15180:SF3', NULL, NULL, NULL, NULL, 'B-BLOCK_TFIIIC DOMAIN-CONTAINING PROTEIN', 240046),
(309319, 'PTHR15180:SF1', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR 3C POLYPEPTIDE 1', 240046),
(309320, 'PTHR15180', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR 3C POLYPEPTIDE 1', 240046),
(309321, 'PTHR35923', NULL, NULL, NULL, NULL, 'MAJOR EXTRACELLULAR ENDOGLUCANASE', 240047),
(309322, 'PTHR35923:SF3', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 240047),
(309323, 'PTHR35923:SF2', NULL, NULL, NULL, NULL, 'CELLULASE DOMAIN-CONTAINING PROTEIN', 240047),
(309324, 'PTHR34448', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE', 240048),
(309325, 'PTHR34448:SF1', NULL, NULL, NULL, NULL, 'BLL6088 PROTEIN', 240048),
(309326, 'PTHR34448:SF3', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE AMPS', 240048),
(309327, 'PTHR43133:SF43', NULL, NULL, NULL, NULL, 'ECF RNA POLYMERASE SIGMA FACTOR SIGM', 240049),
(309328, 'PTHR43133:SF32', NULL, NULL, NULL, NULL, 'BLR3042 PROTEIN', 240049),
(309329, 'PTHR43133:SF54', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA FACTOR RFAY-RELATED', 240049),
(309330, 'PTHR43133:SF55', NULL, NULL, NULL, NULL, 'BLR4028 PROTEIN', 240049),
(309331, 'PTHR43133:SF56', NULL, NULL, NULL, NULL, 'ECF RNA POLYMERASE SIGMA FACTOR SIGD', 240049),
(309332, 'PTHR43133:SF45', NULL, NULL, NULL, NULL, 'RNA POLYMERASE ECF-TYPE SIGMA FACTOR', 240049),
(309333, 'PTHR43133:SF46', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA FACTOR SIGY', 240049),
(309334, 'PTHR43133:SF25', NULL, NULL, NULL, NULL, 'ECF RNA POLYMERASE SIGMA FACTOR SIGG', 240049),
(309335, 'PTHR43133:SF39', NULL, NULL, NULL, NULL, 'SIMILAR TO RNA POLYMERASE SIGMA-E FACTOR', 240049),
(309336, 'PTHR43133:SF28', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA FACTOR HI_1459-RELATED', 240049),
(309337, 'PTHR43133', NULL, NULL, NULL, NULL, 'RNA POLYMERASE ECF-TYPE SIGMA FACTO', 240049),
(309338, 'PTHR43133:SF50', NULL, NULL, NULL, NULL, 'ECF RNA POLYMERASE SIGMA FACTOR SIGE', 240049),
(309339, 'PTHR43133:SF51', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA FACTOR SIGV', 240049),
(309340, 'PTHR43133:SF52', NULL, NULL, NULL, NULL, 'ECF RNA POLYMERASE SIGMA FACTOR SIGL', 240049),
(309341, 'PTHR43133:SF53', NULL, NULL, NULL, NULL, 'ECF RNA POLYMERASE SIGMA-E FACTOR', 240049),
(309342, 'PTHR43133:SF8', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA FACTOR FECI-RELATED', 240049),
(309343, 'PTHR15603:SF4', NULL, NULL, NULL, NULL, 'DEATH DOMAIN-CONTAINING PROTEIN', 240050),
(309344, 'PTHR15603:SF3', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-BINDING PROTEIN 4', 240050),
(309345, 'PTHR15603:SF1', NULL, NULL, NULL, NULL, 'METASTASIS-ASSOCIATED IN COLON CANCER PROTEIN 1', 240050),
(309346, 'PTHR15603', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-CONTAINING PROTEIN', 240050),
(309347, 'PTHR34539:SF15', NULL, NULL, NULL, NULL, '', 240051),
(309348, 'PTHR34539:SF14', NULL, NULL, NULL, NULL, 'BNAA06G33290D PROTEIN', 240051),
(309349, 'PTHR34539:SF17', NULL, NULL, NULL, NULL, 'BNAA02G27660D PROTEIN', 240051),
(309350, 'PTHR34539:SF16', NULL, NULL, NULL, NULL, 'T2P11.11 PROTEIN', 240051),
(309351, 'PTHR34539:SF22', NULL, NULL, NULL, NULL, '', 240051),
(309352, 'PTHR34539:SF21', NULL, NULL, NULL, NULL, '', 240051),
(309353, 'PTHR34539:SF10', NULL, NULL, NULL, NULL, '', 240051),
(309354, 'PTHR34539:SF13', NULL, NULL, NULL, NULL, '', 240051),
(309355, 'PTHR34539:SF12', NULL, NULL, NULL, NULL, 'BNAC06G43580D PROTEIN', 240051);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(309356, 'PTHR34539:SF19', NULL, NULL, NULL, NULL, 'T6J4.11 PROTEIN', 240051),
(309357, 'PTHR34539:SF18', NULL, NULL, NULL, NULL, 'BNAC08G15840D PROTEIN', 240051),
(309358, 'PTHR34539:SF3', NULL, NULL, NULL, NULL, 'BNAC06G25190D PROTEIN', 240051),
(309359, 'PTHR34539', NULL, NULL, NULL, NULL, 'T6J4.11 PROTEIN', 240051),
(309360, 'PTHR34539:SF4', NULL, NULL, NULL, NULL, '', 240051),
(309361, 'PTHR34539:SF20', NULL, NULL, NULL, NULL, 'BNACNNG70820D PROTEIN', 240051),
(309362, 'PTHR34539:SF9', NULL, NULL, NULL, NULL, 'BNAA09G29380D PROTEIN', 240051),
(309363, 'PTHR43310:SF2', NULL, NULL, NULL, NULL, 'SULFATE_TRANSP DOMAIN-CONTAINING PROTEIN', 240052),
(309364, 'PTHR43310:SF1', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORTER YBAR-RELATED', 240052),
(309365, 'PTHR43310', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORTER YBAR-RELATED', 240052),
(309366, 'PTHR43310:SF4', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORTER', 240052),
(309367, 'PTHR30003', NULL, NULL, NULL, NULL, 'L-LACTATE PERMEASE', 240053),
(309368, 'PTHR30003:SF2', NULL, NULL, NULL, NULL, 'L-LACTATE PERMEASE', 240053),
(309369, 'PTHR30003:SF0', NULL, NULL, NULL, NULL, 'GLYCOLATE PERMEASE GLCA', 240053),
(309370, 'PTHR30003:SF10', NULL, NULL, NULL, NULL, 'L-LACTATE PERMEASE', 240053),
(309371, 'PTHR30003:SF5', NULL, NULL, NULL, NULL, 'L-LACTATE PERMEASE', 240053),
(309372, 'PTHR33406:SF6', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN YDGH-RELATED', 240054),
(309373, 'PTHR33406:SF2', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN YDFJ', 240054),
(309374, 'PTHR33406', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN MJ1562-RELATED', 240054),
(309375, 'PTHR33406:SF10', NULL, NULL, NULL, NULL, 'SSD DOMAIN-CONTAINING PROTEIN', 240054),
(309376, 'PTHR45569', NULL, NULL, NULL, NULL, 'SENSOR PROTEIN KDPD', 240055),
(309377, 'PTHR45569:SF1', NULL, NULL, NULL, NULL, 'SENSOR PROTEIN KDPD', 240055),
(309378, 'PTHR12710:SF0', NULL, NULL, NULL, NULL, 'NUCLEAR PROTEIN LOCALIZATION PROTEIN 4 HOMOLOG', 240056),
(309379, 'PTHR12710', NULL, NULL, NULL, NULL, 'NUCLEAR PROTEIN LOCALIZATION 4', 240056),
(309380, 'PTHR33990:SF5', NULL, NULL, NULL, NULL, '3-DMU-9_3-MT DOMAIN-CONTAINING PROTEIN', 240057),
(309381, 'PTHR33990:SF4', NULL, NULL, NULL, NULL, '3-DEMETHYLUBIQUINONE-9 3-METHYLTRANSFERASE', 240057),
(309382, 'PTHR33990', NULL, NULL, NULL, NULL, 'PROTEIN YJDN-RELATED', 240057),
(309383, 'PTHR33990:SF1', NULL, NULL, NULL, NULL, 'PROTEIN YJDN', 240057),
(309384, 'PTHR33990:SF2', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN-RELATED', 240057),
(309385, 'PTHR21004:SF0', NULL, NULL, NULL, NULL, 'PEROXISOMAL LEADER PEPTIDE-PROCESSING PROTEASE', 240058),
(309386, 'PTHR21004', NULL, NULL, NULL, NULL, 'SERINE PROTEASE-RELATED', 240058),
(309387, 'PTHR13031', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P SUBUNIT P30', 240059),
(309388, 'PTHR13031:SF1', NULL, NULL, NULL, NULL, 'BNAA10G29620D PROTEIN', 240059),
(309389, 'PTHR13031:SF0', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P PROTEIN SUBUNIT P30', 240059),
(309390, 'PTHR21629:SF10', NULL, NULL, NULL, NULL, 'C6 DOMAIN-CONTAINING PROTEIN', 240060),
(309391, 'PTHR21629:SF5', NULL, NULL, NULL, NULL, 'C6 DOMAIN-CONTAINING PROTEIN', 240060),
(309392, 'PTHR21629:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG13119', 240060),
(309393, 'PTHR21629', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 240060),
(309394, 'PTHR43057:SF1', NULL, NULL, NULL, NULL, 'ARSENICAL-RESISTANCE PROTEIN 3', 240061),
(309395, 'PTHR43057', NULL, NULL, NULL, NULL, 'ARSENITE EFFLUX TRANSPORTER', 240061),
(309396, 'PTHR33469:SF5', NULL, NULL, NULL, NULL, 'PROTEIN EARLY FLOWERING 4', 240062),
(309397, 'PTHR33469:SF31', NULL, NULL, NULL, NULL, 'ELF4 DOMAIN-CONTAINING PROTEIN', 240062),
(309398, 'PTHR33469:SF20', NULL, NULL, NULL, NULL, 'ELF4-LIKE 3-RELATED', 240062),
(309399, 'PTHR33469:SF32', NULL, NULL, NULL, NULL, 'OS08G0366300 PROTEIN', 240062),
(309400, 'PTHR33469', NULL, NULL, NULL, NULL, 'PROTEIN ELF4-LIKE 4', 240062),
(309401, 'PTHR33469:SF30', NULL, NULL, NULL, NULL, 'FLOWERING 4 PROTEIN, PUTATIVE, EXPRESSED-RELATED', 240062),
(309402, 'PTHR33469:SF13', NULL, NULL, NULL, NULL, 'PROTEIN ELF4-LIKE 3', 240062);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(309403, 'PTHR33469:SF35', NULL, NULL, NULL, NULL, 'ELF4 DOMAIN-CONTAINING PROTEIN', 240062),
(309404, 'PTHR33469:SF14', NULL, NULL, NULL, NULL, 'PROTEIN EARLY FLOWERING 4-LIKE', 240062),
(309405, 'PTHR33469:SF36', NULL, NULL, NULL, NULL, 'ELF4 DOMAIN-CONTAINING PROTEIN', 240062),
(309406, 'PTHR33469:SF33', NULL, NULL, NULL, NULL, 'PROTEIN ELF4-LIKE 4', 240062),
(309407, 'PTHR33469:SF22', NULL, NULL, NULL, NULL, 'ELF4 DOMAIN-CONTAINING PROTEIN', 240062),
(309408, 'PTHR33469:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ELF4-LIKE 1', 240062),
(309409, 'PTHR33469:SF34', NULL, NULL, NULL, NULL, 'PROTEIN ELF4-LIKE 4-LIKE', 240062),
(309410, 'PTHR33469:SF28', NULL, NULL, NULL, NULL, 'ELF4 DOMAIN-CONTAINING PROTEIN', 240062),
(309411, 'PTHR33469:SF18', NULL, NULL, NULL, NULL, 'ELF4 DOMAIN-CONTAINING PROTEIN', 240062),
(309412, 'PTHR33469:SF37', NULL, NULL, NULL, NULL, 'ELF4-LIKE PROTEIN', 240062),
(309413, 'PTHR33469:SF15', NULL, NULL, NULL, NULL, 'PROTEIN ELF4-LIKE 2', 240062),
(309414, 'PTHR33469:SF16', NULL, NULL, NULL, NULL, 'PROTEIN ELF4-LIKE 4', 240062),
(309415, 'PTHR33469:SF19', NULL, NULL, NULL, NULL, 'PROTEIN ELF4-LIKE 3-LIKE', 240062),
(309416, 'PTHR14313:SF2', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 6 COMPLEX LOCUS PROTEIN G5B', 240063),
(309417, 'PTHR14313', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 6 COMPLEX LOCUS PROTEIN G5B', 240063),
(309418, 'PTHR10836:SF112', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE 2, CYTOSOLIC', 240064),
(309419, 'PTHR10836:SF111', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE', 240064),
(309420, 'PTHR10836:SF110', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE', 240064),
(309421, 'PTHR10836:SF89', NULL, NULL, NULL, NULL, 'GP_DH_N DOMAIN-CONTAINING PROTEIN', 240064),
(309422, 'PTHR10836:SF114', NULL, NULL, NULL, NULL, 'GP_DH_N DOMAIN-CONTAINING PROTEIN', 240064),
(309423, 'PTHR10836:SF113', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE', 240064),
(309424, 'PTHR10836:SF119', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE', 240064),
(309425, 'PTHR10836:SF76', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE-RELATED', 240064),
(309426, 'PTHR10836:SF98', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE', 240064),
(309427, 'PTHR10836:SF93', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE', 240064),
(309428, 'PTHR10836:SF92', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE GAPCP1, CHLOROPLASTIC', 240064),
(309429, 'PTHR10836:SF123', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE GAPC2, CYTOSOLIC', 240064),
(309430, 'PTHR10836:SF122', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE', 240064),
(309431, 'PTHR10836:SF121', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE (PHOSPHORYLATING)', 240064),
(309432, 'PTHR10836:SF120', NULL, NULL, NULL, NULL, 'GP_DH_N DOMAIN-CONTAINING PROTEIN', 240064),
(309433, 'PTHR10836:SF79', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE, TESTIS-SPECIFIC', 240064),
(309434, 'PTHR10836:SF127', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE GAPCP2, CHLOROPLASTIC', 240064),
(309435, 'PTHR10836:SF126', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE GAPC1, CYTOSOLIC', 240064),
(309436, 'PTHR10836:SF104', NULL, NULL, NULL, NULL, 'GP_DH_N DOMAIN-CONTAINING PROTEIN', 240064),
(309437, 'PTHR10836:SF125', NULL, NULL, NULL, NULL, 'GP_DH_N DOMAIN-CONTAINING PROTEIN', 240064),
(309438, 'PTHR10836:SF124', NULL, NULL, NULL, NULL, 'GP_DH_C DOMAIN-CONTAINING PROTEIN', 240064),
(309439, 'PTHR10836:SF109', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE', 240064),
(309440, 'PTHR10836:SF129', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE', 240064),
(309441, 'PTHR10836:SF128', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE', 240064),
(309442, 'PTHR10836:SF106', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE', 240064);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(309443, 'PTHR10836', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE 3-PHOSPHATE DEHYDROGENASE', 240064),
(309444, 'PTHR10836:SF87', NULL, NULL, NULL, NULL, 'GP_DH_N DOMAIN-CONTAINING PROTEIN', 240064),
(309445, 'PTHR10836:SF65', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE 1-RELATED', 240064),
(309446, 'PTHR31984', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (DUF179)-RELATED', 240065),
(309447, 'PTHR31984:SF14', NULL, NULL, NULL, NULL, 'BNAA02G29770D PROTEIN', 240065),
(309448, 'PTHR31984:SF13', NULL, NULL, NULL, NULL, 'OS01G0886000 PROTEIN', 240065),
(309449, 'PTHR31984:SF12', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 240065),
(309450, 'PTHR31984:SF1', NULL, NULL, NULL, NULL, 'OS10G0330400 PROTEIN', 240065),
(309451, 'PTHR31984:SF11', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (DUF179)-RELATED', 240065),
(309452, 'PTHR31984:SF18', NULL, NULL, NULL, NULL, '', 240065),
(309453, 'PTHR31984:SF17', NULL, NULL, NULL, NULL, '', 240065),
(309454, 'PTHR31984:SF16', NULL, NULL, NULL, NULL, '', 240065),
(309455, 'PTHR31984:SF15', NULL, NULL, NULL, NULL, 'BNAA09G02580D PROTEIN', 240065),
(309456, 'PTHR42908:SF19', NULL, NULL, NULL, NULL, 'TR-TYPE G DOMAIN-CONTAINING PROTEIN', 240066),
(309457, 'PTHR42908:SF3', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR-LIKE GTPASE 1', 240066),
(309458, 'PTHR42908:SF6', NULL, NULL, NULL, NULL, '116 KDA U5 SMALL NUCLEAR RIBONUCLEOPROTEIN COMPONENT', 240066),
(309459, 'PTHR42908:SF8', NULL, NULL, NULL, NULL, 'TR-TYPE G DOMAIN-CONTAINING PROTEIN', 240066),
(309460, 'PTHR42908', NULL, NULL, NULL, NULL, 'TRANSLATION ELONGATION FACTOR-RELATED', 240066),
(309461, 'PTHR42908:SF10', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION ELONGATION FACTOR 2', 240066),
(309462, 'PTHR42908:SF21', NULL, NULL, NULL, NULL, 'EFG_IV DOMAIN-CONTAINING PROTEIN', 240066),
(309463, 'PTHR42908:SF31', NULL, NULL, NULL, NULL, 'TR-TYPE G DOMAIN-CONTAINING PROTEIN', 240066),
(309464, 'PTHR42908:SF25', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR FAMILY PROTEIN', 240066),
(309465, 'PTHR42908:SF36', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 2-LIKE ISOFORM X1', 240066),
(309466, 'PTHR42908:SF35', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 2', 240066),
(309467, 'PTHR42908:SF34', NULL, NULL, NULL, NULL, 'TR-TYPE G DOMAIN-CONTAINING PROTEIN', 240066),
(309468, 'PTHR42908:SF23', NULL, NULL, NULL, NULL, 'TRANSLATION ELONGATION FACTOR EF-2 SUBUNIT', 240066),
(309469, 'PTHR42908:SF22', NULL, NULL, NULL, NULL, 'EFG_C DOMAIN-CONTAINING PROTEIN', 240066),
(309470, 'PTHR42908:SF29', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION ELONGATION FACTOR 2A, TANDEM DUPLICATE 1-RELATED', 240066),
(309471, 'PTHR42908:SF28', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION ELONGATION FACTOR 2,-LIKE 2-RELATED', 240066),
(309472, 'PTHR42908:SF38', NULL, NULL, NULL, NULL, 'TR-TYPE G DOMAIN-CONTAINING PROTEIN', 240066),
(309473, 'PTHR42908:SF37', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 2-LIKE', 240066),
(309474, 'PTHR37929', NULL, NULL, NULL, NULL, 'GRIP AND COILED-COIL DOMAIN-CONTAINING PROTEIN PFC0235W', 240067),
(309475, 'PTHR37929:SF1', NULL, NULL, NULL, NULL, 'SWI/SNF GLOBAL TRANSCRIPTION ACTIVATOR COMPLEX SUBUNIT SNF59', 240067),
(309476, 'PTHR40388:SF1', NULL, NULL, NULL, NULL, 'BRYOPORIN', 240068),
(309477, 'PTHR40388:SF3', NULL, NULL, NULL, NULL, '', 240068),
(309478, 'PTHR40388:SF2', NULL, NULL, NULL, NULL, 'ACTINOPORIN-LIKE PROTEIN', 240068),
(309479, 'PTHR40388', NULL, NULL, NULL, NULL, 'BRYOPORIN', 240068),
(309480, 'PTHR24261:SF16', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE-3-KINASE-INTERACTING PROTEIN 1', 240069),
(309481, 'PTHR24261', NULL, NULL, NULL, NULL, 'PLASMINOGEN-RELATED', 240069),
(309482, 'PTHR24261:SF8', NULL, NULL, NULL, NULL, 'HEPATOCYTE GROWTH FACTOR', 240069),
(309483, 'PTHR24261:SF12', NULL, NULL, NULL, NULL, 'HEPATOCYTE GROWTH FACTOR-LIKE PROTEIN-RELATED', 240069),
(309484, 'PTHR24261:SF13', NULL, NULL, NULL, NULL, 'PLASMINOGEN', 240069),
(309485, 'PTHR24261:SF2', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN(A)', 240069),
(309486, 'PTHR24261:SF7', NULL, NULL, NULL, NULL, 'KRINGLE DOMAIN-CONTAINING PROTEIN', 240069);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(309487, 'PTHR37515:SF2', NULL, NULL, NULL, NULL, 'YALI0C09240P', 240070),
(309488, 'PTHR37515', NULL, NULL, NULL, NULL, 'YALI0C09240P', 240070),
(309489, 'PTHR37515:SF1', NULL, NULL, NULL, NULL, '', 240070),
(309490, 'PTHR31903:SF22', NULL, NULL, NULL, NULL, 'OS02G0507600 PROTEIN', 240071),
(309491, 'PTHR31903:SF21', NULL, NULL, NULL, NULL, 'BNAANNG30210D PROTEIN', 240071),
(309492, 'PTHR31903:SF4', NULL, NULL, NULL, NULL, 'OS11G0490300 PROTEIN', 240071),
(309493, 'PTHR31903:SF13', NULL, NULL, NULL, NULL, '', 240071),
(309494, 'PTHR31903:SF23', NULL, NULL, NULL, NULL, '', 240071),
(309495, 'PTHR31903:SF12', NULL, NULL, NULL, NULL, '', 240071),
(309496, 'PTHR31903:SF20', NULL, NULL, NULL, NULL, 'BNAC03G57500D PROTEIN', 240071),
(309497, 'PTHR31903:SF19', NULL, NULL, NULL, NULL, '', 240071),
(309498, 'PTHR31903', NULL, NULL, NULL, NULL, 'F12F1.11-RELATED', 240071),
(309499, 'PTHR31903:SF17', NULL, NULL, NULL, NULL, 'BNAC08G41610D PROTEIN', 240071),
(309500, 'PTHR31903:SF16', NULL, NULL, NULL, NULL, '', 240071),
(309501, 'PTHR31903:SF6', NULL, NULL, NULL, NULL, 'F12F1.11-RELATED', 240071),
(309502, 'PTHR10520:SF16', NULL, NULL, NULL, NULL, 'AIR SYNTHASE', 240072),
(309503, 'PTHR10520:SF15', NULL, NULL, NULL, NULL, 'AIR SYNTHASE', 240072),
(309504, 'PTHR10520:SF12', NULL, NULL, NULL, NULL, 'TRIFUNCTIONAL PURINE BIOSYNTHETIC PROTEIN ADENOSINE-3', 240072),
(309505, 'PTHR10520', NULL, NULL, NULL, NULL, 'TRIFUNCTIONAL PURINE BIOSYNTHETIC PROTEIN ADENOSINE-3-RELATED', 240072),
(309506, 'PTHR28081:SF1', NULL, NULL, NULL, NULL, 'DAMAGE-REGULATED IMPORT FACILITATOR 1-RELATED', 240073),
(309507, 'PTHR28081', NULL, NULL, NULL, NULL, 'DAMAGE-REGULATED IMPORT FACILITATOR 1-RELATED', 240073),
(309508, 'PTHR43601', NULL, NULL, NULL, NULL, 'THIOREDOXIN, MITOCHONDRIAL', 240074),
(309509, 'PTHR43601:SF9', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE 1-1, CHLOROPLASTIC', 240074),
(309510, 'PTHR43601:SF5', NULL, NULL, NULL, NULL, 'EG:132E8.3 PROTEIN', 240074),
(309511, 'PTHR43601:SF3', NULL, NULL, NULL, NULL, 'THIOREDOXIN, MITOCHONDRIAL', 240074),
(309512, 'PTHR43601:SF32', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE 2-2, CHLOROPLASTIC', 240074),
(309513, 'PTHR43601:SF33', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 240074),
(309514, 'PTHR43601:SF11', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240074),
(309515, 'PTHR43601:SF31', NULL, NULL, NULL, NULL, 'MONODEHYDROASCORBATE REDUCTASE (NADH)-RELATED', 240074),
(309516, 'PTHR43601:SF14', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE 2-1, CHLOROPLASTIC', 240074),
(309517, 'PTHR43601:SF15', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 240074),
(309518, 'PTHR43601:SF34', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE 1-1, CHLOROPLASTIC', 240074),
(309519, 'PTHR43601:SF35', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 240074),
(309520, 'PTHR43601:SF18', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE 1-2, CHLOROPLASTIC', 240074),
(309521, 'PTHR43601:SF19', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE 2, CHLOROPLASTIC', 240074),
(309522, 'PTHR43601:SF16', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE 2, CHLOROPLASTIC ISOFORM X1', 240074),
(309523, 'PTHR43601:SF17', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE 1-2, CHLOROPLASTIC', 240074),
(309524, 'PTHR43601:SF28', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE 1-3, CHLOROPLASTIC', 240074),
(309525, 'PTHR45887', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR EIF-2B SUBUNIT EPSILON', 240075),
(309526, 'PTHR45887:SF1', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR EIF-2B SUBUNIT EPSILON', 240075),
(309527, 'PTHR45887:SF2', NULL, NULL, NULL, NULL, 'EIF-2B GDP-GTP EXCHANGE FACTOR SUBUNIT EPSILON', 240075),
(309528, 'PTHR39540', NULL, NULL, NULL, NULL, '', 240076),
(309529, 'PTHR39540:SF1', NULL, NULL, NULL, NULL, 'DICTOMALLEIN-1-RELATED', 240076),
(309530, 'PTHR47394', NULL, NULL, NULL, NULL, 'SMALL CELL ADHESION GLYCOPROTEIN', 240077),
(309531, 'PTHR47394:SF1', NULL, NULL, NULL, NULL, 'SMALL CELL ADHESION GLYCOPROTEIN', 240077),
(309532, 'PTHR34052', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN-LIKE', 240078);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(309533, 'PTHR34052:SF7', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 240078),
(309534, 'PTHR34052:SF10', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 240078),
(309535, 'PTHR34052:SF11', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 240078),
(309536, 'PTHR34052:SF8', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 240078),
(309537, 'PTHR34052:SF4', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 30', 240078),
(309538, 'PTHR34052:SF5', NULL, NULL, NULL, NULL, 'CUPREDOXIN SUPERFAMILY PROTEIN', 240078),
(309539, 'PTHR34052:SF6', NULL, NULL, NULL, NULL, 'CUB AND SUSHI DOMAIN-CONTAINING PROTEIN 3', 240078),
(309540, 'PTHR34052:SF1', NULL, NULL, NULL, NULL, 'OS06G0216700 PROTEIN', 240078),
(309541, 'PTHR34052:SF2', NULL, NULL, NULL, NULL, 'PLASTOCYANIN-LIKE DOMAIN PROTEIN', 240078),
(309542, 'PTHR33955', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 52', 240079),
(309543, 'PTHR33955:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 52B', 240079),
(309544, 'PTHR33955:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 52', 240079),
(309545, 'PTHR48083:SF19', NULL, NULL, NULL, NULL, 'FLAVIN-DEPENDENT MONOOXYGENASE, OXYGENASE SUBUNIT HSAA', 240080),
(309546, 'PTHR48083:SF5', NULL, NULL, NULL, NULL, 'NRGC PROTEIN', 240080),
(309547, 'PTHR48083:SF7', NULL, NULL, NULL, NULL, 'ACYL COA DEHYDROGENASE', 240080),
(309548, 'PTHR48083:SF6', NULL, NULL, NULL, NULL, 'ZGC:85777', 240080),
(309549, 'PTHR48083:SF15', NULL, NULL, NULL, NULL, 'ACYL-COA DEHYDROGENASE APDG', 240080),
(309550, 'PTHR48083:SF37', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE-RELATED', 240080),
(309551, 'PTHR48083:SF28', NULL, NULL, NULL, NULL, 'ACYL-COA DEHYDROGENASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_6G10880)-RELATED', 240080),
(309552, 'PTHR48083:SF17', NULL, NULL, NULL, NULL, 'ACYL-COA DEHYDROGENASE (AFU_ORTHOLOGUE AFUA_2G16630)', 240080),
(309553, 'PTHR48083:SF18', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A DEHYDROGENASE', 240080),
(309554, 'PTHR48083:SF33', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A DEHYDROGENASE', 240080),
(309555, 'PTHR48083:SF11', NULL, NULL, NULL, NULL, '', 240080),
(309556, 'PTHR48083:SF34', NULL, NULL, NULL, NULL, 'ACYL-COA DEHYDROGENASE IBR3-RELATED', 240080),
(309557, 'PTHR48083:SF23', NULL, NULL, NULL, NULL, 'CROTONOBETAINYL-COA REDUCTASE', 240080),
(309558, 'PTHR48083:SF13', NULL, NULL, NULL, NULL, 'ACYL-COA DEHYDROGENASE FAMILY MEMBER 11', 240080),
(309559, 'PTHR48083:SF35', NULL, NULL, NULL, NULL, 'ACYL-COA DEHYDROGENASE FAMILY MEMBER 10', 240080),
(309560, 'PTHR48083:SF36', NULL, NULL, NULL, NULL, 'ACYL-COA DEHYDROGENASE FADE3-RELATED', 240080),
(309561, 'PTHR48083:SF20', NULL, NULL, NULL, NULL, 'LONG-CHAIN SPECIFIC ACYL-COA DEHYDROGENASE, MITOCHONDRIAL', 240080),
(309562, 'PTHR48083:SF31', NULL, NULL, NULL, NULL, 'ACYL-COA DEHYDROGENASE-RELATED', 240080),
(309563, 'PTHR48083:SF32', NULL, NULL, NULL, NULL, '', 240080),
(309564, 'PTHR48083:SF21', NULL, NULL, NULL, NULL, 'ACYL COA DEHYDROGENASE', 240080),
(309565, 'PTHR48083', NULL, NULL, NULL, NULL, 'MEDIUM-CHAIN SPECIFIC ACYL-COA DEHYDROGENASE, MITOCHONDRIAL-RELATED', 240080),
(309566, 'PTHR48083:SF1', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G06510)-RELATED', 240080),
(309567, 'PTHR48083:SF2', NULL, NULL, NULL, NULL, 'MEDIUM-CHAIN SPECIFIC ACYL-COA DEHYDROGENASE, MITOCHONDRIAL', 240080),
(309568, 'PTHR15106:SF2', NULL, NULL, NULL, NULL, 'RETINOIC ACID RECEPTOR RESPONDER PROTEIN 2', 240081),
(309569, 'PTHR15106', NULL, NULL, NULL, NULL, 'RETINOIC ACID RECEPTOR RESPONDER PROTEIN 2', 240081),
(309570, 'PTHR33568', NULL, NULL, NULL, NULL, 'DNA POLYMERASE', 240082),
(309571, 'PTHR33568:SF3', NULL, NULL, NULL, NULL, 'DNA-DIRECTED DNA POLYMERASE', 240082),
(309572, 'PTHR47263:SF2', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE ACTIVATION PROTEIN GIT1', 240083),
(309573, 'PTHR47263:SF1', NULL, NULL, NULL, NULL, 'C2 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_7G02350)', 240083),
(309574, 'PTHR47263', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE ACTIVATION PROTEIN GIT1', 240083);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(309575, 'PTHR38542', NULL, NULL, NULL, NULL, 'OS04G0450500 PROTEIN', 240084),
(309576, 'PTHR38542:SF2', NULL, NULL, NULL, NULL, 'NUCLEIC ACID-BINDING PROTEIN-RELATED', 240084),
(309577, 'PTHR44809', NULL, NULL, NULL, NULL, '', 240085),
(309578, 'PTHR44809:SF1', NULL, NULL, NULL, NULL, 'PROTEIN O-MANNOSYL-TRANSFERASE TMTC1', 240085),
(309579, 'PTHR43535:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE CYTIDYLYLTRANSFERASE', 240086),
(309580, 'PTHR43535', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE CYTIDYLYLTRANSFERASE', 240086),
(309581, 'PTHR33159:SF35', NULL, NULL, NULL, NULL, 'OS06G0286375 PROTEIN', 240087),
(309582, 'PTHR33159:SF57', NULL, NULL, NULL, NULL, 'AVRRPT-CLEAVAGE DOMAIN-CONTAINING PROTEIN', 240087),
(309583, 'PTHR33159:SF15', NULL, NULL, NULL, NULL, 'OS04G0379600 PROTEIN', 240087),
(309584, 'PTHR33159:SF37', NULL, NULL, NULL, NULL, 'NITRATE-INDUCED NOI PROTEIN, EXPRESSED', 240087),
(309585, 'PTHR33159:SF38', NULL, NULL, NULL, NULL, 'AVRRPT-CLEAVAGE DOMAIN-CONTAINING PROTEIN', 240087),
(309586, 'PTHR33159:SF93', NULL, NULL, NULL, NULL, 'PROTEIN NOI4', 240087),
(309587, 'PTHR33159:SF72', NULL, NULL, NULL, NULL, 'RPM1-INTERACTING PROTEIN 4 (RIN4) FAMILY PROTEIN', 240087),
(309588, 'PTHR33159:SF94', NULL, NULL, NULL, NULL, 'RIN4, PATHOGENIC TYPE III EFFECTOR AVIRULENCE FACTOR AVR CLEAVAGE SITE-RELATED', 240087),
(309589, 'PTHR33159:SF95', NULL, NULL, NULL, NULL, 'RPM1-INTERACTING PROTEIN 4 (RIN4) FAMILY PROTEIN', 240087),
(309590, 'PTHR33159:SF74', NULL, NULL, NULL, NULL, 'RPM1-INTERACTING PROTEIN 4-LIKE', 240087),
(309591, 'PTHR33159:SF96', NULL, NULL, NULL, NULL, 'RPM1-INTERACTING PROTEIN 4-LIKE', 240087),
(309592, 'PTHR33159:SF52', NULL, NULL, NULL, NULL, 'AVRRPT-CLEAVAGE DOMAIN-CONTAINING PROTEIN', 240087),
(309593, 'PTHR33159:SF75', NULL, NULL, NULL, NULL, 'RPM1-INTERACTING PROTEIN 4-LIKE', 240087),
(309594, 'PTHR33159:SF97', NULL, NULL, NULL, NULL, 'RPM1-INTERACTING PROTEIN 4 (RIN4) FAMILY PROTEIN', 240087),
(309595, 'PTHR33159:SF98', NULL, NULL, NULL, NULL, 'RPM1-INTERACTING PROTEIN 4 (RIN4) FAMILY PROTEIN', 240087),
(309596, 'PTHR33159:SF99', NULL, NULL, NULL, NULL, 'RPM1-INTERACTING PROTEIN 4-LIKE ISOFORM X2', 240087),
(309597, 'PTHR33159:SF47', NULL, NULL, NULL, NULL, 'AVRRPT-CLEAVAGE DOMAIN-CONTAINING PROTEIN', 240087),
(309598, 'PTHR33159:SF6', NULL, NULL, NULL, NULL, 'RPM1-INTERACTING PROTEIN 4', 240087),
(309599, 'PTHR33159:SF49', NULL, NULL, NULL, NULL, 'AVRRPT-CLEAVAGE DOMAIN-CONTAINING PROTEIN', 240087),
(309600, 'PTHR33159:SF29', NULL, NULL, NULL, NULL, 'AVRRPT-CLEAVAGE DOMAIN-CONTAINING PROTEIN', 240087),
(309601, 'PTHR33159:SF61', NULL, NULL, NULL, NULL, 'AVRRPT-CLEAVAGE DOMAIN-CONTAINING PROTEIN', 240087),
(309602, 'PTHR33159:SF83', NULL, NULL, NULL, NULL, 'AVRRPT-CLEAVAGE DOMAIN-CONTAINING PROTEIN', 240087),
(309603, 'PTHR33159:SF62', NULL, NULL, NULL, NULL, 'AVRRPT-CLEAVAGE DOMAIN-CONTAINING PROTEIN', 240087),
(309604, 'PTHR33159:SF40', NULL, NULL, NULL, NULL, 'DEFENSE PROTEIN-LIKE PROTEIN', 240087),
(309605, 'PTHR33159:SF84', NULL, NULL, NULL, NULL, 'RPM1-INTERACTING PROTEIN 4 (RIN4) FAMILY PROTEIN', 240087),
(309606, 'PTHR33159:SF85', NULL, NULL, NULL, NULL, 'RPM1-INTERACTING PROTEIN 4-LIKE', 240087),
(309607, 'PTHR33159:SF63', NULL, NULL, NULL, NULL, 'AVRRPT-CLEAVAGE DOMAIN-CONTAINING PROTEIN', 240087),
(309608, 'PTHR33159:SF86', NULL, NULL, NULL, NULL, 'RIN4, PATHOGENIC TYPE III EFFECTOR AVIRULENCE FACTOR AVR CLEAVAGE-RELATED', 240087),
(309609, 'PTHR33159:SF87', NULL, NULL, NULL, NULL, 'OS09G0253000 PROTEIN', 240087),
(309610, 'PTHR33159:SF66', NULL, NULL, NULL, NULL, 'RPM1-INTERACTING PROTEIN 4 (RIN4) FAMILY PROTEIN', 240087),
(309611, 'PTHR33159:SF88', NULL, NULL, NULL, NULL, 'RIN4, PATHOGENIC TYPE III EFFECTOR AVIRULENCE FACTOR AVR CLEAVAGE SITE-RELATED', 240087),
(309612, 'PTHR33159:SF89', NULL, NULL, NULL, NULL, 'OS06G0636100 PROTEIN', 240087),
(309613, 'PTHR33159:SF90', NULL, NULL, NULL, NULL, 'RPM1-INTERACTING PROTEIN 4-LIKE', 240087),
(309614, 'PTHR33159:SF91', NULL, NULL, NULL, NULL, 'RPM1-INTERACTING PROTEIN 4 (RIN4) FAMILY PROTEIN', 240087),
(309615, 'PTHR33159:SF92', NULL, NULL, NULL, NULL, 'AVRRPT-CLEAVAGE DOMAIN-CONTAINING PROTEIN', 240087);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(309616, 'PTHR33159', NULL, NULL, NULL, NULL, 'RPM1-INTERACTING PROTEIN 4 (RIN4) FAMILY PROTEIN', 240087),
(309617, 'PTHR36844', NULL, NULL, NULL, NULL, 'PROTEASE PRSW', 240088),
(309618, 'PTHR36844:SF1', NULL, NULL, NULL, NULL, 'PROTEASE PRSW', 240088),
(309619, 'PTHR19305', NULL, NULL, NULL, NULL, 'SYNAPTOSOMAL ASSOCIATED PROTEIN', 240089),
(309620, 'PTHR19305:SF30', NULL, NULL, NULL, NULL, 'TARGET SNARE COILED-COIL DOMAIN-CONTAINING PROTEIN-RELATED', 240089),
(309621, 'PTHR19305:SF32', NULL, NULL, NULL, NULL, 'TARGET SNARE COILED-COIL-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 240089),
(309622, 'PTHR19305:SF10', NULL, NULL, NULL, NULL, 'T-SNARE PROTEIN AEX-4', 240089),
(309623, 'PTHR19305:SF33', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 240089),
(309624, 'PTHR19305:SF22', NULL, NULL, NULL, NULL, 'SYNAPTOSOMAL-ASSOCIATED PROTEIN', 240089),
(309625, 'PTHR19305:SF34', NULL, NULL, NULL, NULL, 'OS02G0529500 PROTEIN', 240089),
(309626, 'PTHR19305:SF24', NULL, NULL, NULL, NULL, 'SNAP25 HOMOLOGOUS PROTEIN SNAP29', 240089),
(309627, 'PTHR19305:SF35', NULL, NULL, NULL, NULL, 'SYNTAXIN-72', 240089),
(309628, 'PTHR19305:SF36', NULL, NULL, NULL, NULL, 'SYNAPTOSOMAL-ASSOCIATED PROTEIN', 240089),
(309629, 'PTHR19305:SF14', NULL, NULL, NULL, NULL, 'SYNAPTOSOMAL-ASSOCIATED PROTEIN-RELATED', 240089),
(309630, 'PTHR19305:SF26', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 240089),
(309631, 'PTHR19305:SF37', NULL, NULL, NULL, NULL, 'SNAP25 HOMOLOGOUS PROTEIN SNAP33-LIKE', 240089),
(309632, 'PTHR19305:SF38', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 240089),
(309633, 'PTHR19305:SF39', NULL, NULL, NULL, NULL, 'SNAP25 HOMOLOGOUS PROTEIN SNAP33', 240089),
(309634, 'PTHR19305:SF28', NULL, NULL, NULL, NULL, 'CULMINATION SPECIFIC PROTEIN 37D', 240089),
(309635, 'PTHR19305:SF29', NULL, NULL, NULL, NULL, 'OS03G0212400 PROTEIN', 240089),
(309636, 'PTHR19305:SF9', NULL, NULL, NULL, NULL, 'SYNAPTOSOMAL-ASSOCIATED PROTEIN 29', 240089),
(309637, 'PTHR19305:SF4', NULL, NULL, NULL, NULL, 'SYNAPTOSOMAL-ASSOCIATED PROTEIN 23', 240089),
(309638, 'PTHR19305:SF5', NULL, NULL, NULL, NULL, 'SYNAPTOSOMAL-ASSOCIATED PROTEIN 25', 240089),
(309639, 'PTHR19305:SF1', NULL, NULL, NULL, NULL, 'SYNAPTOSOMAL-ASSOCIATED PROTEIN 47', 240089),
(309640, 'PTHR39415', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 27', 240090),
(309641, 'PTHR39415:SF1', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 27', 240090),
(309642, 'PTHR22770:SF43', NULL, NULL, NULL, NULL, 'SHARPIN', 240091),
(309643, 'PTHR22770', NULL, NULL, NULL, NULL, 'UBIQUITIN CONJUGATING ENZYME 7 INTERACTING PROTEIN-RELATED', 240091),
(309644, 'PTHR22770:SF42', NULL, NULL, NULL, NULL, 'FINGER PROTEIN (ZIN), PUTATIVE (AFU_ORTHOLOGUE AFUA_4G03910)-RELATED', 240091),
(309645, 'PTHR22770:SF47', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF216', 240091),
(309646, 'PTHR22770:SF45', NULL, NULL, NULL, NULL, 'RANBP-TYPE AND C3HC4-TYPE ZINC FINGER-CONTAINING PROTEIN 1-RELATED', 240091),
(309647, 'PTHR22770:SF35', NULL, NULL, NULL, NULL, 'RANBP-TYPE AND C3HC4-TYPE ZINC FINGER-CONTAINING PROTEIN 1', 240091),
(309648, 'PTHR22770:SF13', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 240091),
(309649, 'PTHR13943:SF37', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A AND ACYLTRANSFERASE 1', 240092),
(309650, 'PTHR13943:SF36', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A AND ACYLTRANSFERASE 4', 240092),
(309651, 'PTHR13943', NULL, NULL, NULL, NULL, 'HRAS-LIKE SUPPRESSOR - RELATED', 240092),
(309652, 'PTHR13943:SF31', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A AND ACYLTRANSFERASE 3', 240092),
(309653, 'PTHR13943:SF78', NULL, NULL, NULL, NULL, 'HYPOTHETICAL LOC794087', 240092),
(309654, 'PTHR13943:SF77', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 240092),
(309655, 'PTHR13943:SF33', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A AND ACYLTRANSFERASE 2', 240092),
(309656, 'PTHR13943:SF2', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A AND ACYLTRANSFERASE 5', 240092),
(309657, 'PTHR11404:SF38', NULL, NULL, NULL, NULL, 'SUPEROXIDE DISMUTASE', 240093);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(309658, 'PTHR11404:SF29', NULL, NULL, NULL, NULL, 'SUPEROXIDE DISMUTASE', 240093),
(309659, 'PTHR11404:SF40', NULL, NULL, NULL, NULL, 'SUPEROXIDE DISMUTASE', 240093),
(309660, 'PTHR11404', NULL, NULL, NULL, NULL, 'SUPEROXIDE DISMUTASE 2', 240093),
(309661, 'PTHR11404:SF42', NULL, NULL, NULL, NULL, 'SUPEROXIDE DISMUTASE', 240093),
(309662, 'PTHR11404:SF41', NULL, NULL, NULL, NULL, 'SUPEROXIDE DISMUTASE [MN], MITOCHONDRIAL', 240093),
(309663, 'PTHR11404:SF43', NULL, NULL, NULL, NULL, 'SUPEROXIDE DISMUTASE [MN] 2, MITOCHONDRIAL', 240093),
(309664, 'PTHR11404:SF6', NULL, NULL, NULL, NULL, 'SUPEROXIDE DISMUTASE [MN], MITOCHONDRIAL', 240093),
(309665, 'PTHR24422:SF18', NULL, NULL, NULL, NULL, 'CHEMOTAXIS PROTEIN METHYLTRANSFERASE 2', 240094),
(309666, 'PTHR24422:SF19', NULL, NULL, NULL, NULL, 'CHEMOTAXIS PROTEIN METHYLTRANSFERASE', 240094),
(309667, 'PTHR24422', NULL, NULL, NULL, NULL, 'CHEMOTAXIS PROTEIN METHYLTRANSFERASE', 240094),
(309668, 'PTHR24422:SF21', NULL, NULL, NULL, NULL, 'CHEMOTAXIS PROTEIN METHYLTRANSFERASE', 240094),
(309669, 'PTHR24422:SF10', NULL, NULL, NULL, NULL, 'BIOFILM DISPERSION PROTEIN BDLA', 240094),
(309670, 'PTHR24422:SF8', NULL, NULL, NULL, NULL, 'CHEMOTAXIS PROTEIN', 240094),
(309671, 'PTHR24422:SF25', NULL, NULL, NULL, NULL, 'CONSERVED HYPOTHETICAL CHEMOTAXIS PROTEIN', 240094),
(309672, 'PTHR38083:SF1', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT CELL ADHESION MOLECULE 1-RELATED', 240095),
(309673, 'PTHR38083', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT CELL ADHESION MOLECULE 1-RELATED', 240095),
(309674, 'PTHR21213:SF0', NULL, NULL, NULL, NULL, 'GEO09665P1-RELATED', 240096),
(309675, 'PTHR21213:SF30', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 706', 240096),
(309676, 'PTHR21213:SF31', NULL, NULL, NULL, NULL, 'FACTOR, PUTATIVE-RELATED', 240096),
(309677, 'PTHR21213:SF3', NULL, NULL, NULL, NULL, '4F5 DOMAIN-CONTAINING PROTEIN', 240096),
(309678, 'PTHR21213:SF23', NULL, NULL, NULL, NULL, 'BNAA05G33350D PROTEIN', 240096),
(309679, 'PTHR21213:SF22', NULL, NULL, NULL, NULL, 'PROTEIN METHYLENE BLUE SENSITIVITY 2', 240096),
(309680, 'PTHR21213:SF24', NULL, NULL, NULL, NULL, 'PROTEIN METHYLENE BLUE SENSITIVITY 1', 240096),
(309681, 'PTHR21213:SF15', NULL, NULL, NULL, NULL, '4F5 DOMAIN-CONTAINING PROTEIN', 240096),
(309682, 'PTHR21213:SF26', NULL, NULL, NULL, NULL, 'ZGC:91910', 240096),
(309683, 'PTHR21213:SF29', NULL, NULL, NULL, NULL, '', 240096),
(309684, 'PTHR21213', NULL, NULL, NULL, NULL, 'GEO09665P1-RELATED', 240096),
(309685, 'PTHR21213:SF28', NULL, NULL, NULL, NULL, '', 240096),
(309686, 'PTHR13929:SF7', NULL, NULL, NULL, NULL, 'UBIA PRENYLTRANSFERASE FAMILY PROTEIN', 240097),
(309687, 'PTHR13929:SF4', NULL, NULL, NULL, NULL, '', 240097),
(309688, 'PTHR13929:SF15', NULL, NULL, NULL, NULL, '', 240097),
(309689, 'PTHR13929:SF0', NULL, NULL, NULL, NULL, 'UBIA PRENYLTRANSFERASE DOMAIN-CONTAINING PROTEIN 1', 240097),
(309690, 'PTHR13929', NULL, NULL, NULL, NULL, '1,4-DIHYDROXY-2-NAPHTHOATE OCTAPRENYLTRANSFERASE', 240097),
(309691, 'PTHR37011', NULL, NULL, NULL, NULL, 'POT FAMILY PEPTIDE TRANSPORT PROTEIN-RELATED', 240098),
(309692, 'PTHR37011:SF1', NULL, NULL, NULL, NULL, 'POT FAMILY PEPTIDE TRANSPORT PROTEIN-RELATED', 240098),
(309693, 'PTHR37011:SF2', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE LIPOPROTEIN-RELATED', 240098),
(309694, 'PTHR35363:SF23', NULL, NULL, NULL, NULL, '', 240099),
(309695, 'PTHR35363', NULL, NULL, NULL, NULL, '', 240099),
(309696, 'PTHR31659:SF0', NULL, NULL, NULL, NULL, 'EMB|CAB61945.1', 240100),
(309697, 'PTHR31659:SF38', NULL, NULL, NULL, NULL, 'PROTEIN OCTOPUS', 240100),
(309698, 'PTHR31659:SF19', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE (DUF740)-RELATED', 240100),
(309699, 'PTHR31659:SF35', NULL, NULL, NULL, NULL, 'UPF0503 PROTEIN CHLOROPLASTIC', 240100),
(309700, 'PTHR31659:SF23', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240100),
(309701, 'PTHR31659:SF4', NULL, NULL, NULL, NULL, 'UPF0503 PROTEIN CHLOROPLASTIC', 240100),
(309702, 'PTHR31659:SF25', NULL, NULL, NULL, NULL, '', 240100),
(309703, 'PTHR31659:SF9', NULL, NULL, NULL, NULL, 'PROTEIN: UPF0503-LIKE PROTEIN, PUTATIVE (DUF740)-RELATED', 240100);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(309704, 'PTHR31659', NULL, NULL, NULL, NULL, 'PROTEIN: UPF0503-LIKE PROTEIN, PUTATIVE (DUF740)-RELATED', 240100),
(309705, 'PTHR31659:SF20', NULL, NULL, NULL, NULL, 'PROTEIN OCTOPUS-LIKE', 240100),
(309706, 'PTHR31659:SF22', NULL, NULL, NULL, NULL, '', 240100),
(309707, 'PTHR31659:SF32', NULL, NULL, NULL, NULL, 'BNAC01G39210D PROTEIN', 240100),
(309708, 'PTHR31659:SF21', NULL, NULL, NULL, NULL, 'UPF0503 PROTEIN, CHLOROPLASTIC', 240100),
(309709, 'PTHR30239:SF24', NULL, NULL, NULL, NULL, 'ACETOHYDROXY-ACID SYNTHASE SMALL SUBUNIT', 240101),
(309710, 'PTHR30239:SF25', NULL, NULL, NULL, NULL, 'ACETOHYDROXY-ACID SYNTHASE SMALL SUBUNIT', 240101),
(309711, 'PTHR30239:SF26', NULL, NULL, NULL, NULL, 'ACETOHYDROXY-ACID SYNTHASE SMALL SUBUNIT', 240101),
(309712, 'PTHR30239', NULL, NULL, NULL, NULL, 'ACETOLACTATE SYNTHASE SMALL SUBUNIT', 240101),
(309713, 'PTHR30239:SF17', NULL, NULL, NULL, NULL, 'ACETOHYDROXY-ACID SYNTHASE SMALL SUBUNIT', 240101),
(309714, 'PTHR30239:SF18', NULL, NULL, NULL, NULL, 'ACETOLACTATE SYNTHASE SMALL SUBUNIT 1, CHLOROPLASTIC', 240101),
(309715, 'PTHR30239:SF4', NULL, NULL, NULL, NULL, 'ACETOLACTATE SYNTHASE ISOZYME 1 SMALL SUBUNIT', 240101),
(309716, 'PTHR30239:SF19', NULL, NULL, NULL, NULL, 'ACETOHYDROXY-ACID SYNTHASE SMALL SUBUNIT', 240101),
(309717, 'PTHR30239:SF0', NULL, NULL, NULL, NULL, 'ACETOLACTATE SYNTHASE SMALL SUBUNIT 2, CHLOROPLASTIC', 240101),
(309718, 'PTHR10037:SF208', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL PROTEIN TYPE 10 SUBUNIT ALPHA', 240102),
(309719, 'PTHR10037:SF209', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT T-TYPE CALCIUM CHANNEL SUBUNIT ALPHA', 240102),
(309720, 'PTHR10037:SF206', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL PROTEIN TYPE 5 SUBUNIT ALPHA', 240102),
(309721, 'PTHR10037:SF237', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL PROTEIN TYPE 3 SUBUNIT ALPHA', 240102),
(309722, 'PTHR10037:SF293', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT L-TYPE CALCIUM CHANNEL SUBUNIT ALPHA', 240102),
(309723, 'PTHR10037:SF294', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT L-TYPE CALCIUM CHANNEL SUBUNIT ALPHA', 240102),
(309724, 'PTHR10037:SF192', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT T-TYPE CALCIUM CHANNEL SUBUNIT ALPHA-1H', 240102),
(309725, 'PTHR10037:SF280', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL PROTEIN TYPE 1 SUBUNIT ALPHA', 240102),
(309726, 'PTHR10037:SF62', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL PROTEIN 60E', 240102),
(309727, 'PTHR10037:SF292', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL PROTEIN', 240102),
(309728, 'PTHR10037:SF290', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT L-TYPE CALCIUM CHANNEL SUBUNIT ALPHA', 240102),
(309729, 'PTHR10037:SF23', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL PROTEIN TYPE 8 SUBUNIT ALPHA', 240102),
(309730, 'PTHR10037:SF14', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL PROTEIN', 240102),
(309731, 'PTHR10037:SF137', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT T-TYPE CALCIUM CHANNEL SUBUNIT ALPHA', 240102),
(309732, 'PTHR10037:SF288', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL PROTEIN PARA', 240102),
(309733, 'PTHR10037:SF289', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT N-TYPE CALCIUM CHANNEL SUBUNIT ALPHA', 240102),
(309734, 'PTHR10037', NULL, NULL, NULL, NULL, 'VOLTAGE-GATED CATION CHANNEL  CALCIUM AND SODIUM', 240102),
(309735, 'PTHR10037:SF223', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL PROTEIN TYPE 4 SUBUNIT ALPHA', 240102),
(309736, 'PTHR10037:SF278', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL PROTEIN TYPE 2 SUBUNIT ALPHA', 240102),
(309737, 'PTHR10037:SF221', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL PROTEIN TYPE 9 SUBUNIT ALPHA', 240102),
(309738, 'PTHR10037:SF210', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL PROTEIN TYPE 11 SUBUNIT ALPHA', 240102),
(309739, 'PTHR10037:SF230', NULL, NULL, NULL, NULL, 'CA[2+]-CHANNEL PROTEIN ALPHA[[1]] SUBUNIT T, ISOFORM F', 240102),
(309740, 'PTHR37979', NULL, NULL, NULL, NULL, 'PROTEIN HER-1', 240103),
(309741, 'PTHR37979:SF1', NULL, NULL, NULL, NULL, 'PROTEIN HER-1', 240103),
(309742, 'PTHR21371:SF23', NULL, NULL, NULL, NULL, 'KETOL-ACID REDUCTOISOMERASE', 240104),
(309743, 'PTHR21371:SF24', NULL, NULL, NULL, NULL, '', 240104);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(309744, 'PTHR21371:SF21', NULL, NULL, NULL, NULL, 'KETOL-ACID REDUCTOISOMERASE', 240104),
(309745, 'PTHR21371:SF22', NULL, NULL, NULL, NULL, 'KETOL-ACID REDUCTOISOMERASE', 240104),
(309746, 'PTHR21371:SF1', NULL, NULL, NULL, NULL, 'KETOL-ACID REDUCTOISOMERASE, MITOCHONDRIAL', 240104),
(309747, 'PTHR21371', NULL, NULL, NULL, NULL, 'KETOL-ACID REDUCTOISOMERASE, MITOCHONDRIAL', 240104),
(309748, 'PTHR28069:SF1', NULL, NULL, NULL, NULL, 'GH20023P', 240105),
(309749, 'PTHR28069', NULL, NULL, NULL, NULL, 'GH20023P', 240105),
(309750, 'PTHR12661:SF5', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF SWI4 1 HOMOLOG', 240106),
(309751, 'PTHR12661:SF11', NULL, NULL, NULL, NULL, 'BRIX DOMAIN-CONTAINING PROTEIN', 240106),
(309752, 'PTHR12661', NULL, NULL, NULL, NULL, 'PETER PAN-RELATED', 240106),
(309753, 'PTHR46016:SF4', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF166', 240107),
(309754, 'PTHR46016', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE', 240107),
(309755, 'PTHR46016:SF3', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF114', 240107),
(309756, 'PTHR46016:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF125', 240107),
(309757, 'PTHR46016:SF1', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 240107),
(309758, 'PTHR39933:SF1', NULL, NULL, NULL, NULL, 'CENTAURIN-GAMMA-1A-LIKE PROTEIN', 240108),
(309759, 'PTHR39933', NULL, NULL, NULL, NULL, 'CENTAURIN-GAMMA-1A-LIKE PROTEIN', 240108),
(309760, 'PTHR34230:SF2', NULL, NULL, NULL, NULL, 'SAS-6_N DOMAIN-CONTAINING PROTEIN', 240109),
(309761, 'PTHR34230', NULL, NULL, NULL, NULL, 'ASSEMBLY ABNORMAL PROTEIN 6, PUTATIVE-RELATED', 240109),
(309762, 'PTHR14215', NULL, NULL, NULL, NULL, 'PROTEIN OF UNKNOWN FUNCTION DUF729', 240110),
(309763, 'PTHR14215:SF2', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL FISSION REGULATOR 2', 240110),
(309764, 'PTHR14215:SF3', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL FISSION REGULATOR 1-LIKE', 240110),
(309765, 'PTHR14215:SF0', NULL, NULL, NULL, NULL, '', 240110),
(309766, 'PTHR14215:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL FISSION REGULATOR 1', 240110),
(309767, 'PTHR36926:SF1', NULL, NULL, NULL, NULL, 'COLICIN V PRODUCTION PROTEIN', 240111),
(309768, 'PTHR36926', NULL, NULL, NULL, NULL, 'COLICIN V PRODUCTION PROTEIN', 240111),
(309769, 'PTHR10639:SF36', NULL, NULL, NULL, NULL, 'CLATHRIN LIGHT CHAIN 2', 240112),
(309770, 'PTHR10639:SF35', NULL, NULL, NULL, NULL, 'CLATHRIN LIGHT CHAIN', 240112),
(309771, 'PTHR10639:SF24', NULL, NULL, NULL, NULL, 'CLATHRIN LIGHT CHAIN 3', 240112),
(309772, 'PTHR10639:SF27', NULL, NULL, NULL, NULL, 'CLATHRIN LIGHT CHAIN', 240112),
(309773, 'PTHR10639:SF38', NULL, NULL, NULL, NULL, 'CLATHRIN LIGHT CHAIN 2', 240112),
(309774, 'PTHR10639:SF37', NULL, NULL, NULL, NULL, 'CLATHRIN LIGHT CHAIN', 240112),
(309775, 'PTHR10639:SF28', NULL, NULL, NULL, NULL, 'CLATHRIN LIGHT CHAIN B', 240112),
(309776, 'PTHR10639:SF7', NULL, NULL, NULL, NULL, 'CLATHRIN LIGHT CHAIN', 240112),
(309777, 'PTHR10639:SF39', NULL, NULL, NULL, NULL, 'CLATHRIN LIGHT CHAIN', 240112),
(309778, 'PTHR10639:SF1', NULL, NULL, NULL, NULL, 'CLATHRIN LIGHT CHAIN A', 240112),
(309779, 'PTHR10639', NULL, NULL, NULL, NULL, 'CLATHRIN LIGHT CHAIN', 240112),
(309780, 'PTHR10639:SF41', NULL, NULL, NULL, NULL, 'CLATHRIN LIGHT CHAIN', 240112),
(309781, 'PTHR10639:SF40', NULL, NULL, NULL, NULL, 'CLATHRIN LIGHT CHAIN', 240112),
(309782, 'PTHR10639:SF21', NULL, NULL, NULL, NULL, 'CLATHRIN LIGHT CHAIN 3', 240112),
(309783, 'PTHR10639:SF34', NULL, NULL, NULL, NULL, 'CLATHRIN LIGHT CHAIN', 240112),
(309784, 'PTHR10639:SF33', NULL, NULL, NULL, NULL, 'CLATHRIN LIGHT CHAIN 1', 240112),
(309785, 'PTHR34112:SF8', NULL, NULL, NULL, NULL, '', 240113),
(309786, 'PTHR34112:SF17', NULL, NULL, NULL, NULL, '', 240113),
(309787, 'PTHR34112:SF18', NULL, NULL, NULL, NULL, 'C-JUN-AMINO-TERMINAL KINASE-INTERACTING PROTEIN', 240113),
(309788, 'PTHR34112:SF12', NULL, NULL, NULL, NULL, '', 240113),
(309789, 'PTHR34112', NULL, NULL, NULL, NULL, 'C-JUN-AMINO-TERMINAL KINASE-INTERACTING PROTEIN', 240113),
(309790, 'PTHR34112:SF10', NULL, NULL, NULL, NULL, 'BNAC03G72810D PROTEIN', 240113);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(309791, 'PTHR34112:SF15', NULL, NULL, NULL, NULL, '', 240113),
(309792, 'PTHR34112:SF16', NULL, NULL, NULL, NULL, 'OS02G0566700 PROTEIN', 240113),
(309793, 'PTHR34112:SF13', NULL, NULL, NULL, NULL, 'OS04G0448200 PROTEIN', 240113),
(309794, 'PTHR14309', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240114),
(309795, 'PTHR14309:SF7', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY B MEMBER 1', 240114),
(309796, 'PTHR14309:SF8', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY B MEMBER 2', 240114),
(309797, 'PTHR14309:SF13', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 240114),
(309798, 'PTHR14309:SF10', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 240114),
(309799, 'PTHR14309:SF12', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 240114),
(309800, 'PTHR14084:SF0', NULL, NULL, NULL, NULL, 'KYNURENINASE', 240115),
(309801, 'PTHR14084', NULL, NULL, NULL, NULL, 'KYNURENINASE', 240115),
(309802, 'PTHR14084:SF2', NULL, NULL, NULL, NULL, 'KYNURENINASE 2', 240115),
(309803, 'PTHR16214:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 260', 240116),
(309804, 'PTHR16214', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 260', 240116),
(309805, 'PTHR14205:SF15', NULL, NULL, NULL, NULL, 'EARP AND GARP COMPLEX-INTERACTING PROTEIN 1', 240117),
(309806, 'PTHR14205:SF16', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN DWA2', 240117),
(309807, 'PTHR14205', NULL, NULL, NULL, NULL, 'WD-REPEAT PROTEIN', 240117),
(309808, 'PTHR39147', NULL, NULL, NULL, NULL, 'PROTEIN SPT21', 240118),
(309809, 'PTHR39147:SF1', NULL, NULL, NULL, NULL, 'PROTEIN SPT21', 240118),
(309810, 'PTHR23056:SF130', NULL, NULL, NULL, NULL, '', 240119),
(309811, 'PTHR23056:SF134', NULL, NULL, NULL, NULL, 'CALCINEURIN B-LIKE PROTEIN 6', 240119),
(309812, 'PTHR23056:SF112', NULL, NULL, NULL, NULL, 'BNAA03G52310D PROTEIN', 240119),
(309813, 'PTHR23056:SF98', NULL, NULL, NULL, NULL, 'EF HAND CALCIUM-BINDING FAMILY PROTEIN', 240119),
(309814, 'PTHR23056:SF111', NULL, NULL, NULL, NULL, 'CALCINEURIN B 04', 240119),
(309815, 'PTHR23056:SF133', NULL, NULL, NULL, NULL, 'CALCINEURIN B-LIKE PROTEIN 7 ISOFORM X1', 240119),
(309816, 'PTHR23056:SF132', NULL, NULL, NULL, NULL, 'CALCINEURIN B', 240119),
(309817, 'PTHR23056:SF97', NULL, NULL, NULL, NULL, 'CALCINEURIN B-LIKE PROTEIN 10', 240119),
(309818, 'PTHR23056:SF110', NULL, NULL, NULL, NULL, 'CALCINEURIN B-LIKE PROTEIN 4', 240119),
(309819, 'PTHR23056:SF96', NULL, NULL, NULL, NULL, 'CALCINEURIN B-LIKE PROTEIN 9', 240119),
(309820, 'PTHR23056:SF131', NULL, NULL, NULL, NULL, 'CALCINEURIN B-LIKE PROTEIN 4', 240119),
(309821, 'PTHR23056:SF95', NULL, NULL, NULL, NULL, 'CALCINEURIN B-LIKE PROTEIN 1 ISOFORM X1', 240119),
(309822, 'PTHR23056:SF138', NULL, NULL, NULL, NULL, 'CALCINEURIN B-LIKE PROTEIN 3', 240119),
(309823, 'PTHR23056:SF116', NULL, NULL, NULL, NULL, 'CALCINEURIN B-LIKE PROTEIN 2', 240119),
(309824, 'PTHR23056:SF137', NULL, NULL, NULL, NULL, 'CALCINEURIN B-LIKE PROTEIN 8', 240119),
(309825, 'PTHR23056:SF93', NULL, NULL, NULL, NULL, 'CALCINEURIN B-LIKE PROTEIN', 240119),
(309826, 'PTHR23056:SF136', NULL, NULL, NULL, NULL, 'CALCINEURIN B-LIKE PROTEIN 3-RELATED', 240119),
(309827, 'PTHR23056:SF135', NULL, NULL, NULL, NULL, 'CALCINEURIN B-LIKE PROTEIN 3 ISOFORM X2', 240119),
(309828, 'PTHR23056:SF91', NULL, NULL, NULL, NULL, 'CALCINEURIN B-LIKE PROTEIN 3 ISOFORM X2', 240119),
(309829, 'PTHR23056:SF119', NULL, NULL, NULL, NULL, 'CALCINEURIN B-LIKE 1', 240119),
(309830, 'PTHR23056:SF118', NULL, NULL, NULL, NULL, 'BNAC07G34450D PROTEIN', 240119),
(309831, 'PTHR23056:SF139', NULL, NULL, NULL, NULL, 'CALCINEURIN B-LIKE PROTEIN', 240119),
(309832, 'PTHR23056', NULL, NULL, NULL, NULL, 'CALCINEURIN B', 240119),
(309833, 'PTHR23056:SF141', NULL, NULL, NULL, NULL, 'CALCINEURIN B-LIKE PROTEIN 6', 240119),
(309834, 'PTHR23056:SF26', NULL, NULL, NULL, NULL, 'CALCINEURIN B-LIKE PROTEIN 10', 240119),
(309835, 'PTHR23056:SF140', NULL, NULL, NULL, NULL, 'CALCINEURIN B-LIKE PROTEIN 8-RELATED', 240119),
(309836, 'PTHR23056:SF88', NULL, NULL, NULL, NULL, 'CALCINEURIN B-LIKE PROTEIN 5', 240119);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(309837, 'PTHR23056:SF44', NULL, NULL, NULL, NULL, 'CALCINEURIN B-LIKE PROTEIN 1', 240119),
(309838, 'PTHR23056:SF122', NULL, NULL, NULL, NULL, 'SALT OVERLY SENSITIVE 3', 240119),
(309839, 'PTHR23056:SF143', NULL, NULL, NULL, NULL, 'CALCINEURIN B-LIKE PROTEIN 8', 240119),
(309840, 'PTHR23056:SF142', NULL, NULL, NULL, NULL, 'CALCINEURIN B-LIKE PROTEIN 7 ISOFORM X1', 240119),
(309841, 'PTHR23056:SF120', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN PAIR-RELATED', 240119),
(309842, 'PTHR23056:SF105', NULL, NULL, NULL, NULL, '', 240119),
(309843, 'PTHR23056:SF126', NULL, NULL, NULL, NULL, 'CALCINEURIN B-LIKE PROTEIN 3', 240119),
(309844, 'PTHR23056:SF125', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 240119),
(309845, 'PTHR23056:SF103', NULL, NULL, NULL, NULL, '', 240119),
(309846, 'PTHR23056:SF124', NULL, NULL, NULL, NULL, 'BNAANNG31750D PROTEIN', 240119),
(309847, 'PTHR23056:SF108', NULL, NULL, NULL, NULL, 'CALCINEURIN B-LIKE PROTEIN 5', 240119),
(309848, 'PTHR23056:SF106', NULL, NULL, NULL, NULL, 'CALCINEURIN B-LIKE PROTEIN 2', 240119),
(309849, 'PTHR43781', NULL, NULL, NULL, NULL, 'SACCHAROPINE DEHYDROGENASE', 240120),
(309850, 'PTHR43781:SF1', NULL, NULL, NULL, NULL, 'SACCHAROPINE DEHYDROGENASE', 240120),
(309851, 'PTHR44376:SF20', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL COREPRESSOR LEUNIG', 240121),
(309852, 'PTHR44376:SF16', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL COREPRESSOR LEUNIG_HOMOLOG-LIKE', 240121),
(309853, 'PTHR44376:SF5', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 240121),
(309854, 'PTHR44376:SF17', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL COREPRESSOR LEUNIG-LIKE ISOFORM X1', 240121),
(309855, 'PTHR44376:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL COREPRESSOR LEUNIG_HOMOLOG-LIKE ISOFORM X1', 240121),
(309856, 'PTHR44376:SF25', NULL, NULL, NULL, NULL, 'LIS1 HOMOLOGY MOTIF, WD40/YVTN REPEAT-LIKE-CONTAINING DOMAIN PROTEIN-RELATED', 240121),
(309857, 'PTHR44376:SF26', NULL, NULL, NULL, NULL, 'LEUNIG-RELATED1', 240121),
(309858, 'PTHR44376', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR OF FILAMENTOUS GROWTH FLO8', 240121),
(309859, 'PTHR44376:SF23', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 240121),
(309860, 'PTHR44376:SF13', NULL, NULL, NULL, NULL, 'LISH-SSDP-WD40', 240121),
(309861, 'PTHR44376:SF21', NULL, NULL, NULL, NULL, 'LIS1 HOMOLOGY MOTIF, WD40/YVTN REPEAT-LIKE-CONTAINING DOMAIN PROTEIN-RELATED', 240121),
(309862, 'PTHR44376:SF22', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR WD40-LIKE FAMILY-RELATED', 240121),
(309863, 'PTHR44376:SF11', NULL, NULL, NULL, NULL, 'OS03G0860900 PROTEIN', 240121),
(309864, 'PTHR44376:SF9', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL COREPRESSOR LEUNIG_HOMOLOG', 240121),
(309865, 'PTHR44376:SF18', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL COREPRESSOR LEUNIG-LIKE PROTEIN', 240121),
(309866, 'PTHR44376:SF19', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 240121),
(309867, 'PTHR37180:SF2', NULL, NULL, NULL, NULL, 'PRECURSOR OF CEP14', 240122),
(309868, 'PTHR37180:SF12', NULL, NULL, NULL, NULL, 'BNAA07G08040D PROTEIN', 240122),
(309869, 'PTHR37180:SF4', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN 3', 240122),
(309870, 'PTHR37180:SF5', NULL, NULL, NULL, NULL, 'PRECURSOR OF CEP13', 240122),
(309871, 'PTHR37180:SF14', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 240122),
(309872, 'PTHR37180:SF13', NULL, NULL, NULL, NULL, 'GI20245', 240122),
(309873, 'PTHR37180:SF8', NULL, NULL, NULL, NULL, 'BNAA06G11430D PROTEIN', 240122),
(309874, 'PTHR37180:SF9', NULL, NULL, NULL, NULL, 'BNAC03G75990D PROTEIN', 240122),
(309875, 'PTHR37180', NULL, NULL, NULL, NULL, 'PRECURSOR OF CEP14', 240122),
(309876, 'PTHR10826:SF23', NULL, NULL, NULL, NULL, 'BNAC04G55580D PROTEIN', 240123),
(309877, 'PTHR10826:SF34', NULL, NULL, NULL, NULL, 'BNAA03G12340D PROTEIN', 240123),
(309878, 'PTHR10826:SF22', NULL, NULL, NULL, NULL, '', 240123),
(309879, 'PTHR10826:SF33', NULL, NULL, NULL, NULL, 'BNAC03G71600D PROTEIN', 240123),
(309880, 'PTHR10826:SF31', NULL, NULL, NULL, NULL, 'BNAA03G12110D PROTEIN', 240123);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(309881, 'PTHR10826:SF41', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL GLYCOPROTEIN FAMILY PROTEIN', 240123),
(309882, 'PTHR10826:SF40', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ACIDIC PROTEIN MAM33, MITOCHONDRIAL', 240123),
(309883, 'PTHR10826:SF8', NULL, NULL, NULL, NULL, '', 240123),
(309884, 'PTHR10826:SF9', NULL, NULL, NULL, NULL, '', 240123),
(309885, 'PTHR10826:SF6', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 240123),
(309886, 'PTHR10826', NULL, NULL, NULL, NULL, 'COMPLEMENT COMPONENT 1', 240123),
(309887, 'PTHR10826:SF1', NULL, NULL, NULL, NULL, 'COMPLEMENT COMPONENT 1 Q SUBCOMPONENT-BINDING PROTEIN, MITOCHONDRIAL', 240123),
(309888, 'PTHR10826:SF29', NULL, NULL, NULL, NULL, 'OS05G0456000 PROTEIN', 240123),
(309889, 'PTHR10826:SF39', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL GLYCOPROTEIN FAMILY PROTEIN', 240123),
(309890, 'PTHR10826:SF17', NULL, NULL, NULL, NULL, '', 240123),
(309891, 'PTHR10826:SF38', NULL, NULL, NULL, NULL, 'OS09G0557400 PROTEIN', 240123),
(309892, 'PTHR10826:SF27', NULL, NULL, NULL, NULL, 'OS06G0326500 PROTEIN', 240123),
(309893, 'PTHR10826:SF15', NULL, NULL, NULL, NULL, 'OS01G0143800 PROTEIN', 240123),
(309894, 'PTHR10826:SF37', NULL, NULL, NULL, NULL, 'BNAA03G01820D PROTEIN', 240123),
(309895, 'PTHR10826:SF14', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN FAMILY PROTEIN', 240123),
(309896, 'PTHR10826:SF36', NULL, NULL, NULL, NULL, 'OS08G0439900 PROTEIN', 240123),
(309897, 'PTHR10826:SF35', NULL, NULL, NULL, NULL, 'BNAC03G15060D PROTEIN', 240123),
(309898, 'PTHR10826:SF24', NULL, NULL, NULL, NULL, 'BNAA03G54960D PROTEIN', 240123),
(309899, 'PTHR11987:SF51', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240124),
(309900, 'PTHR11987:SF50', NULL, NULL, NULL, NULL, 'ST8 ALPHA-N-ACETYL-NEURAMINIDE ALPHA-2,8-SIALYLTRANSFERASE 6', 240124),
(309901, 'PTHR11987:SF29', NULL, NULL, NULL, NULL, 'ALPHA-2,8-SIALYLTRANSFERASE 8F', 240124),
(309902, 'PTHR11987', NULL, NULL, NULL, NULL, 'ALPHA-2,8-SIALYLTRANSFERASE', 240124),
(309903, 'PTHR11987:SF48', NULL, NULL, NULL, NULL, 'CMP-N-ACETYLNEURAMINATE-POLY-ALPHA-2,8-SIALYLTRANSFERASE', 240124),
(309904, 'PTHR11987:SF36', NULL, NULL, NULL, NULL, 'SIA-ALPHA-2,3-GAL-BETA-1,4-GLCNAC-R:ALPHA 2,8-SIALYLTRANSFERASE', 240124),
(309905, 'PTHR11987:SF34', NULL, NULL, NULL, NULL, 'ST8 ALPHA-N-ACETYL-NEURAMINIDE ALPHA-2,8-SIALYLTRANSFERASE 8', 240124),
(309906, 'PTHR11987:SF45', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDE ALPHA-2,3-SIALYLTRANSFERASE', 240124),
(309907, 'PTHR11987:SF3', NULL, NULL, NULL, NULL, 'ALPHA-N-ACETYLNEURAMINIDE ALPHA-2,8-SIALYLTRANSFERASE', 240124),
(309908, 'PTHR11987:SF4', NULL, NULL, NULL, NULL, 'ALPHA-2,8-SIALYLTRANSFERASE 8E', 240124),
(309909, 'PTHR11987:SF30', NULL, NULL, NULL, NULL, 'ALPHA-2,8-SIALYLTRANSFERASE 8B', 240124),
(309910, 'PTHR43704', NULL, NULL, NULL, NULL, 'BSR5907 PROTEIN', 240125),
(309911, 'PTHR43704:SF1', NULL, NULL, NULL, NULL, 'BSR5907 PROTEIN', 240125),
(309912, 'PTHR37017:SF3', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 240126),
(309913, 'PTHR37017:SF12', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 240126),
(309914, 'PTHR37017:SF8', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 240126),
(309915, 'PTHR37017:SF10', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 240126),
(309916, 'PTHR37017', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN-RELATED', 240126),
(309917, 'PTHR37017:SF11', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN-RELATED', 240126),
(309918, 'PTHR37067', NULL, NULL, NULL, NULL, 'PX DOMAIN-CONTAINING PROTEIN', 240127),
(309919, 'PTHR37067:SF3', NULL, NULL, NULL, NULL, 'PX DOMAIN-CONTAINING PROTEIN', 240127),
(309920, 'PTHR47218', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 7 MEMBER A', 240128),
(309921, 'PTHR47218:SF2', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 240128),
(309922, 'PTHR47218:SF1', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 7 MEMBER A', 240128),
(309923, 'PTHR37028:SF6', NULL, NULL, NULL, NULL, '', 240129);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(309924, 'PTHR37028:SF8', NULL, NULL, NULL, NULL, '', 240129),
(309925, 'PTHR37028:SF7', NULL, NULL, NULL, NULL, '', 240129),
(309926, 'PTHR37028:SF4', NULL, NULL, NULL, NULL, '', 240129),
(309927, 'PTHR37028', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT-RELATED', 240129),
(309928, 'PTHR46685:SF1', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S15, MITOCHONDRIAL', 240130),
(309929, 'PTHR46685', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S15, MITOCHONDRIAL', 240130),
(309930, 'PTHR12855:SF11', NULL, NULL, NULL, NULL, 'SANT DOMAIN-CONTAINING PROTEIN', 240131),
(309931, 'PTHR12855', NULL, NULL, NULL, NULL, 'DNA METHYLTRANSFERASE 1-ASSOCIATED PROTEIN 1 FAMILY MEMBER', 240131),
(309932, 'PTHR12855:SF10', NULL, NULL, NULL, NULL, 'DNA METHYLTRANSFERASE 1-ASSOCIATED PROTEIN 1', 240131),
(309933, 'PTHR15173:SF2', NULL, NULL, NULL, NULL, 'OREXIN', 240132),
(309934, 'PTHR15173', NULL, NULL, NULL, NULL, 'OREXIN', 240132),
(309935, 'PTHR16501:SF18', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL FISSION FACTOR', 240133),
(309936, 'PTHR16501:SF17', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL FISSION FACTOR', 240133),
(309937, 'PTHR16501:SF6', NULL, NULL, NULL, NULL, 'TRANSPORT AND GOLGI ORGANIZATION PROTEIN 11', 240133),
(309938, 'PTHR16501:SF19', NULL, NULL, NULL, NULL, 'PROTEIN CBG27852', 240133),
(309939, 'PTHR16501:SF12', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL FISSION FACTOR', 240133),
(309940, 'PTHR16501', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 240133),
(309941, 'PTHR16501:SF16', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL FISSION FACTOR', 240133),
(309942, 'PTHR15591:SF14', NULL, NULL, NULL, NULL, 'IPORIN', 240134),
(309943, 'PTHR15591:SF13', NULL, NULL, NULL, NULL, 'RUN DOMAIN-CONTAINING PROTEIN', 240134),
(309944, 'PTHR15591:SF16', NULL, NULL, NULL, NULL, 'FARNESYL PYROPHOSPHATE SYNTHASE', 240134),
(309945, 'PTHR15591:SF15', NULL, NULL, NULL, NULL, '', 240134),
(309946, 'PTHR15591', NULL, NULL, NULL, NULL, 'RUN AND SH3 DOMAIN CONTAINING', 240134),
(309947, 'PTHR15591:SF11', NULL, NULL, NULL, NULL, 'RUN AND SH3 DOMAIN-CONTAINING PROTEIN 1', 240134),
(309948, 'PTHR15591:SF18', NULL, NULL, NULL, NULL, '', 240134),
(309949, 'PTHR15591:SF17', NULL, NULL, NULL, NULL, '', 240134),
(309950, 'PTHR15591:SF19', NULL, NULL, NULL, NULL, 'SI:DKEY-151M15.5', 240134),
(309951, 'PTHR15836:SF4', NULL, NULL, NULL, NULL, 'PERIPHILIN-1', 240135),
(309952, 'PTHR15836', NULL, NULL, NULL, NULL, 'PERIPHILIN 1', 240135),
(309953, 'PTHR14299:SF0', NULL, NULL, NULL, NULL, 'PHORBOL-12-MYRISTATE-13-ACETATE-INDUCED PROTEIN 1', 240136),
(309954, 'PTHR14299', NULL, NULL, NULL, NULL, 'PHORBOL-12-MYRISTATE-13-ACETATE-INDUCED PROTEIN 1', 240136),
(309955, 'PTHR14091:SF0', NULL, NULL, NULL, NULL, 'PERIODIC TRYPTOPHAN PROTEIN 1 HOMOLOG', 240137),
(309956, 'PTHR14091:SF1', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 240137),
(309957, 'PTHR14091:SF2', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 240137),
(309958, 'PTHR14091:SF5', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN', 240137),
(309959, 'PTHR14091', NULL, NULL, NULL, NULL, 'PERIODIC TRYPTOPHAN PROTEIN 1', 240137),
(309960, 'PTHR46187:SF3', NULL, NULL, NULL, NULL, 'ALKALINE CERAMIDASE 3', 240138),
(309961, 'PTHR46187', NULL, NULL, NULL, NULL, 'ALKALINE CERAMIDASE 3', 240138),
(309962, 'PTHR46187:SF1', NULL, NULL, NULL, NULL, '', 240138),
(309963, 'PTHR46187:SF2', NULL, NULL, NULL, NULL, 'ALKALINE CERAMIDASE DCD3B-RELATED', 240138),
(309964, 'PTHR22829:SF7', NULL, NULL, NULL, NULL, 'SI:DKEYP-97E7.9', 240139),
(309965, 'PTHR22829:SF16', NULL, NULL, NULL, NULL, '', 240139),
(309966, 'PTHR22829:SF6', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 3,4,5-TRISPHOSPHATE-DEPENDENT RAC EXCHANGER 1 PROTEIN', 240139),
(309967, 'PTHR22829:SF5', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN GPR155', 240139),
(309968, 'PTHR22829:SF29', NULL, NULL, NULL, NULL, '', 240139),
(309969, 'PTHR22829:SF18', NULL, NULL, NULL, NULL, 'DEP DOMAIN-CONTAINING MTOR-INTERACTING PROTEIN', 240139),
(309970, 'PTHR22829', NULL, NULL, NULL, NULL, 'DEP DOMAIN PROTEIN', 240139);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(309971, 'PTHR22829:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 3,4,5-TRISPHOSPHATE-DEPENDENT RAC EXCHANGER 2 PROTEIN', 240139),
(309972, 'PTHR34660:SF7', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 240140),
(309973, 'PTHR34660:SF9', NULL, NULL, NULL, NULL, 'BNAANNG08330D PROTEIN', 240140),
(309974, 'PTHR34660:SF16', NULL, NULL, NULL, NULL, 'BNAA01G32390D PROTEIN', 240140),
(309975, 'PTHR34660:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240140),
(309976, 'PTHR34660:SF15', NULL, NULL, NULL, NULL, 'BNAC03G35160D PROTEIN', 240140),
(309977, 'PTHR34660:SF3', NULL, NULL, NULL, NULL, 'MYB-LIKE PROTEIN X', 240140),
(309978, 'PTHR34660:SF18', NULL, NULL, NULL, NULL, 'BNAC05G44690D PROTEIN', 240140),
(309979, 'PTHR34660:SF22', NULL, NULL, NULL, NULL, 'DNA LIGASE', 240140),
(309980, 'PTHR34660:SF14', NULL, NULL, NULL, NULL, '', 240140),
(309981, 'PTHR34660:SF25', NULL, NULL, NULL, NULL, 'DNA BINDING PROTEIN', 240140),
(309982, 'PTHR34660:SF24', NULL, NULL, NULL, NULL, 'GLUTAMIC ACID-RICH PROTEIN-LIKE', 240140),
(309983, 'PTHR34660:SF13', NULL, NULL, NULL, NULL, 'BNAA07G03010D PROTEIN', 240140),
(309984, 'PTHR34660:SF21', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE-RELATED', 240140),
(309985, 'PTHR34660:SF10', NULL, NULL, NULL, NULL, 'BNAA09G09320D PROTEIN', 240140),
(309986, 'PTHR34660:SF20', NULL, NULL, NULL, NULL, '', 240140),
(309987, 'PTHR34660', NULL, NULL, NULL, NULL, 'MYB-LIKE PROTEIN X', 240140),
(309988, 'PTHR34782:SF1', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLFORMYLGLYCINAMIDINE SYNTHASE', 240141),
(309989, 'PTHR34782:SF9', NULL, NULL, NULL, NULL, '', 240141),
(309990, 'PTHR34782', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLFORMYLGLYCINAMIDINE SYNTHASE', 240141),
(309991, 'PTHR34782:SF7', NULL, NULL, NULL, NULL, '', 240141),
(309992, 'PTHR34782:SF8', NULL, NULL, NULL, NULL, '', 240141),
(309993, 'PTHR34782:SF5', NULL, NULL, NULL, NULL, 'OS02G0507400 PROTEIN', 240141),
(309994, 'PTHR34782:SF6', NULL, NULL, NULL, NULL, 'BNAA09G27930D PROTEIN', 240141),
(309995, 'PTHR28489:SF2', NULL, NULL, NULL, NULL, 'RENTINAL DEGENERATION 3-LIKE', 240142),
(309996, 'PTHR28489:SF3', NULL, NULL, NULL, NULL, 'PROTEIN RD3-LIKE', 240142),
(309997, 'PTHR28489:SF1', NULL, NULL, NULL, NULL, 'PROTEIN RD3', 240142),
(309998, 'PTHR28489:SF4', NULL, NULL, NULL, NULL, 'ZGC:162144', 240142),
(309999, 'PTHR28489', NULL, NULL, NULL, NULL, 'RENTINAL DEGENERATION 3-LIKE', 240142),
(310000, 'PTHR44328:SF10', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE, EXPRESSED-RELATED', 240143),
(310001, 'PTHR44328', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE L1', 240143),
(310002, 'PTHR44328:SF11', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE L2, CHLOROPLASTIC', 240143),
(310003, 'PTHR44328:SF16', NULL, NULL, NULL, NULL, 'PROTEIN IN2-1 HOMOLOG B', 240143),
(310004, 'PTHR44328:SF18', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE L3-LIKE ISOFORM X1', 240143),
(310005, 'PTHR44328:SF17', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE', 240143),
(310006, 'PTHR44328:SF5', NULL, NULL, NULL, NULL, 'PROTEIN IN2-1 HOMOLOG A', 240143),
(310007, 'PTHR44328:SF19', NULL, NULL, NULL, NULL, '', 240143),
(310008, 'PTHR44328:SF6', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE L1-RELATED', 240143),
(310009, 'PTHR44328:SF9', NULL, NULL, NULL, NULL, 'GST N-TERMINAL DOMAIN-CONTAINING PROTEIN', 240143),
(310010, 'PTHR43536:SF1', NULL, NULL, NULL, NULL, 'MANNOSYLGLYCOPROTEIN ENDO-BETA-MANNOSIDASE', 240144),
(310011, 'PTHR43536', NULL, NULL, NULL, NULL, 'MANNOSYLGLYCOPROTEIN ENDO-BETA-MANNOSIDASE', 240144),
(310012, 'PTHR43536:SF5', NULL, NULL, NULL, NULL, 'BETA-MANNOSIDASE', 240144),
(310013, 'PTHR43536:SF4', NULL, NULL, NULL, NULL, 'BETA-MANNOSIDASE', 240144),
(310014, 'PTHR28677:SF4', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE SUBUNIT 4B-RELATED', 240145),
(310015, 'PTHR28677', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE SUBUNIT 4A-RELATED', 240145),
(310016, 'PTHR28677:SF7', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE SUBUNIT 4A', 240145);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(310017, 'PTHR28677:SF8', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE SUBUNIT 4A', 240145),
(310018, 'PTHR17271:SF1', NULL, NULL, NULL, NULL, 'PROTEIN OUTSPREAD', 240146),
(310019, 'PTHR17271:SF14', NULL, NULL, NULL, NULL, 'TRIO AND F-ACTIN-BINDING PROTEIN A', 240146),
(310020, 'PTHR17271', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY  PH  DOMAIN-CONTAINING PROTEIN', 240146),
(310021, 'PTHR17271:SF12', NULL, NULL, NULL, NULL, 'MYOSIN PHOSPHATASE RHO-INTERACTING PROTEIN', 240146),
(310022, 'PTHR17271:SF9', NULL, NULL, NULL, NULL, 'MYOSIN PHOSPHATASE RHO-INTERACTING PROTEIN', 240146),
(310023, 'PTHR17271:SF10', NULL, NULL, NULL, NULL, 'TRIO AND F-ACTIN-BINDING PROTEIN', 240146),
(310024, 'PTHR33798', NULL, NULL, NULL, NULL, 'FLAVOPROTEIN OXYGENASE', 240147),
(310025, 'PTHR33798:SF5', NULL, NULL, NULL, NULL, 'FLAVIN_REDUCT DOMAIN-CONTAINING PROTEIN', 240147),
(310026, 'PTHR21210:SF0', NULL, NULL, NULL, NULL, 'TRNA (URACIL-O(2)-)-METHYLTRANSFERASE-RELATED', 240148),
(310027, 'PTHR21210', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 240148),
(310028, 'PTHR42995:SF5', NULL, NULL, NULL, NULL, 'ACETYL-COENZYME A CARBOXYLASE CARBOXYL TRANSFERASE SUBUNIT BETA, CHLOROPLASTIC', 240149),
(310029, 'PTHR42995:SF1', NULL, NULL, NULL, NULL, 'COA CARBOXYLTRANSFERASE N-TERMINAL DOMAIN-CONTAINING PROTEIN', 240149),
(310030, 'PTHR42995', NULL, NULL, NULL, NULL, 'ACETYL-COENZYME A CARBOXYLASE CARBOXYL TRANSFERASE SUBUNIT BETA, CHLOROPLASTIC', 240149),
(310031, 'PTHR28422:SF1', NULL, NULL, NULL, NULL, 'SIMILAR TO HUMAN CHROMOSOME 15 OPEN READING FRAME 39', 240150),
(310032, 'PTHR28422', NULL, NULL, NULL, NULL, 'SIMILAR TO HUMAN CHROMOSOME 15 OPEN READING FRAME 39', 240150),
(310033, 'PTHR28072', NULL, NULL, NULL, NULL, 'CRUCIFORM CUTTING ENDONUCLEASE 1, MITOCHONDRIAL-RELATED', 240151),
(310034, 'PTHR28072:SF1', NULL, NULL, NULL, NULL, 'CRUCIFORM CUTTING ENDONUCLEASE 1, MITOCHONDRIAL-RELATED', 240151),
(310035, 'PTHR28529:SF2', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN SWI5 HOMOLOG', 240152),
(310036, 'PTHR28529', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN SWI5 HOMOLOG', 240152),
(310037, 'PTHR35742:SF1', NULL, NULL, NULL, NULL, 'THYLAKOID LUMENAL 16.5 KDA PROTEIN, CHLOROPLASTIC', 240153),
(310038, 'PTHR35742', NULL, NULL, NULL, NULL, 'THYLAKOID LUMENAL 16.5 KDA PROTEIN, CHLOROPLASTIC', 240153),
(310039, 'PTHR28535:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ZGRF1', 240154),
(310040, 'PTHR28535', NULL, NULL, NULL, NULL, 'ZINC FINGER GRF-TYPE CONTAINING 1', 240154),
(310041, 'PTHR11419', NULL, NULL, NULL, NULL, 'INTERFERON GAMMA', 240155),
(310042, 'PTHR11419:SF0', NULL, NULL, NULL, NULL, 'INTERFERON GAMMA', 240155),
(310043, 'PTHR32289:SF5', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 74B, OPPOSITE STRAND', 240156),
(310044, 'PTHR32289:SF4', NULL, NULL, NULL, NULL, 'PROTEIN FAM167B', 240156),
(310045, 'PTHR32289:SF3', NULL, NULL, NULL, NULL, 'PROTEIN FAM167A', 240156),
(310046, 'PTHR32289:SF2', NULL, NULL, NULL, NULL, 'ALANINE AND ARGININE-RICH DOMAIN-CONTAINING PROTEIN', 240156),
(310047, 'PTHR32289:SF1', NULL, NULL, NULL, NULL, '', 240156),
(310048, 'PTHR32289', NULL, NULL, NULL, NULL, 'PROTEIN FAM167A', 240156),
(310049, 'PTHR47974:SF19', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 240157),
(310050, 'PTHR47974:SF9', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 240157),
(310051, 'PTHR47974', NULL, NULL, NULL, NULL, 'OS07G0415500 PROTEIN', 240157),
(310052, 'PTHR47974:SF21', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 240157),
(310053, 'PTHR47974:SF10', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 240157),
(310054, 'PTHR47974:SF20', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 240157),
(310055, 'PTHR47974:SF23', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 240157),
(310056, 'PTHR47974:SF2', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 240157),
(310057, 'PTHR47974:SF22', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 240157);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(310058, 'PTHR47974:SF3', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 240157),
(310059, 'PTHR47974:SF25', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 240157),
(310060, 'PTHR47974:SF24', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 240157),
(310061, 'PTHR47974:SF13', NULL, NULL, NULL, NULL, 'G-TYPE LECTIN S-RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE SD3-1', 240157),
(310062, 'PTHR47974:SF1', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 240157),
(310063, 'PTHR47974:SF27', NULL, NULL, NULL, NULL, 'G-TYPE LECTIN S-RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 240157),
(310064, 'PTHR47974:SF16', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 240157),
(310065, 'PTHR47974:SF6', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240157),
(310066, 'PTHR47974:SF15', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 240157),
(310067, 'PTHR47974:SF26', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 240157),
(310068, 'PTHR47974:SF7', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 240157),
(310069, 'PTHR47974:SF18', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 240157),
(310070, 'PTHR47974:SF29', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240157),
(310071, 'PTHR47974:SF4', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 240157),
(310072, 'PTHR47974:SF28', NULL, NULL, NULL, NULL, 'OS11G0133100 PROTEIN', 240157),
(310073, 'PTHR35280', NULL, NULL, NULL, NULL, 'F17L21.9', 240158),
(310074, 'PTHR35280:SF1', NULL, NULL, NULL, NULL, 'F17L21.9', 240158),
(310075, 'PTHR35280:SF2', NULL, NULL, NULL, NULL, 'BNAA07G08930D PROTEIN', 240158),
(310076, 'PTHR46547:SF10', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 8', 240159),
(310077, 'PTHR46547:SF7', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN GIS', 240159),
(310078, 'PTHR46547', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN GIS', 240159),
(310079, 'PTHR46547:SF6', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN GIS2', 240159),
(310080, 'PTHR46547:SF13', NULL, NULL, NULL, NULL, 'OS03G0216000 PROTEIN', 240159),
(310081, 'PTHR46547:SF5', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN-RELATED', 240159),
(310082, 'PTHR46547:SF9', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 8-LIKE', 240159),
(310083, 'PTHR46547:SF19', NULL, NULL, NULL, NULL, 'OS09G0445500 PROTEIN', 240159),
(310084, 'PTHR46547:SF4', NULL, NULL, NULL, NULL, 'OS02G0775600 PROTEIN', 240159),
(310085, 'PTHR46547:SF14', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 240159),
(310086, 'PTHR46547:SF15', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 8-LIKE', 240159),
(310087, 'PTHR46547:SF17', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 240159),
(310088, 'PTHR36573:SF1', NULL, NULL, NULL, NULL, 'INTERMEMBRANE PHOSPHOLIPID TRANSPORT SYSTEM BINDING PROTEIN MLAC', 240160),
(310089, 'PTHR36573', NULL, NULL, NULL, NULL, 'INTERMEMBRANE PHOSPHOLIPID TRANSPORT SYSTEM BINDING PROTEIN MLAC', 240160),
(310090, 'PTHR16500:SF3', NULL, NULL, NULL, NULL, 'BRCA2-INTERACTING TRANSCRIPTIONAL REPRESSOR EMSY', 240161),
(310091, 'PTHR16500', NULL, NULL, NULL, NULL, 'BRCA2-INTERACTING TRANSCRIPTIONAL REPRESSOR EMSY', 240161),
(310092, 'PTHR46288', NULL, NULL, NULL, NULL, 'PHORBOL-ESTER/DAG-TYPE DOMAIN-CONTAINING PROTEIN', 240162),
(310093, 'PTHR46288:SF18', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN FAMILY PROTEIN', 240162),
(310094, 'PTHR46288:SF38', NULL, NULL, NULL, NULL, 'CHP-RICH ZINC FINGER PROTEIN', 240162),
(310095, 'PTHR46288:SF17', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN PROTEIN', 240162),
(310096, 'PTHR46288:SF36', NULL, NULL, NULL, NULL, 'BNAC04G49590D PROTEIN', 240162),
(310097, 'PTHR46288:SF37', NULL, NULL, NULL, NULL, 'ZINC FINGER, PHD-TYPE, DC1, ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 240162),
(310098, 'PTHR46288:SF56', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN FAMILY PROTEIN', 240162);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(310099, 'PTHR46288:SF13', NULL, NULL, NULL, NULL, 'DC1 DOMAIN CONTAINING PROTEIN', 240162),
(310100, 'PTHR46288:SF76', NULL, NULL, NULL, NULL, 'C1_2 DOMAIN-CONTAINING PROTEIN', 240162),
(310101, 'PTHR46288:SF54', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN FAMILY PROTEIN', 240162),
(310102, 'PTHR46288:SF77', NULL, NULL, NULL, NULL, 'C1_2 DOMAIN-CONTAINING PROTEIN', 240162),
(310103, 'PTHR46288:SF52', NULL, NULL, NULL, NULL, 'PHORBOL-ESTER/DAG-TYPE DOMAIN-CONTAINING PROTEIN', 240162),
(310104, 'PTHR46288:SF74', NULL, NULL, NULL, NULL, 'DC1 DOMAIN CONTAINING PROTEIN', 240162),
(310105, 'PTHR46288:SF31', NULL, NULL, NULL, NULL, 'PHORBOL-ESTER/DAG-TYPE DOMAIN-CONTAINING PROTEIN', 240162),
(310106, 'PTHR46288:SF75', NULL, NULL, NULL, NULL, '', 240162),
(310107, 'PTHR46288:SF50', NULL, NULL, NULL, NULL, 'C1_2 DOMAIN-CONTAINING PROTEIN', 240162),
(310108, 'PTHR46288:SF72', NULL, NULL, NULL, NULL, 'PHORBOL-ESTER/DAG-TYPE DOMAIN-CONTAINING PROTEIN', 240162),
(310109, 'PTHR46288:SF73', NULL, NULL, NULL, NULL, 'CHP-RICH ZINC FINGER PROTEIN', 240162),
(310110, 'PTHR46288:SF70', NULL, NULL, NULL, NULL, 'C1_2 DOMAIN-CONTAINING PROTEIN', 240162),
(310111, 'PTHR46288:SF71', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN FAMILY PROTEIN-RELATED', 240162),
(310112, 'PTHR46288:SF8', NULL, NULL, NULL, NULL, 'CHP-RICH ZINC FINGER PROTEIN', 240162),
(310113, 'PTHR46288:SF29', NULL, NULL, NULL, NULL, 'PHORBOL-ESTER/DAG-TYPE DOMAIN-CONTAINING PROTEIN', 240162),
(310114, 'PTHR46288:SF27', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN FAMILY PROTEIN', 240162),
(310115, 'PTHR46288:SF49', NULL, NULL, NULL, NULL, 'ZINC FINGER, PHD-TYPE, C1-LIKE PROTEIN-RELATED', 240162),
(310116, 'PTHR46288:SF69', NULL, NULL, NULL, NULL, 'C1-LIKE, ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 240162),
(310117, 'PTHR46288:SF23', NULL, NULL, NULL, NULL, 'BNAC04G03640D PROTEIN', 240162),
(310118, 'PTHR46288:SF67', NULL, NULL, NULL, NULL, 'PHORBOL-ESTER/DAG-TYPE DOMAIN-CONTAINING PROTEIN', 240162),
(310119, 'PTHR46288:SF68', NULL, NULL, NULL, NULL, 'OS07G0609700 PROTEIN', 240162),
(310120, 'PTHR46288:SF46', NULL, NULL, NULL, NULL, 'BNAA04G25680D PROTEIN', 240162),
(310121, 'PTHR46288:SF21', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN FAMILY PROTEIN', 240162),
(310122, 'PTHR46288:SF65', NULL, NULL, NULL, NULL, 'OS07G0610700 PROTEIN', 240162),
(310123, 'PTHR46288:SF66', NULL, NULL, NULL, NULL, '', 240162),
(310124, 'PTHR46288:SF22', NULL, NULL, NULL, NULL, 'DC1 DOMAIN CONTAINING PROTEIN', 240162),
(310125, 'PTHR46288:SF63', NULL, NULL, NULL, NULL, 'C1_2 DOMAIN-CONTAINING PROTEIN', 240162),
(310126, 'PTHR46288:SF64', NULL, NULL, NULL, NULL, 'DC1 DOMAIN CONTAINING PROTEIN', 240162),
(310127, 'PTHR46288:SF42', NULL, NULL, NULL, NULL, 'CHP-RICH ZINC FINGER PROTEIN', 240162),
(310128, 'PTHR46288:SF61', NULL, NULL, NULL, NULL, '', 240162),
(310129, 'PTHR46288:SF62', NULL, NULL, NULL, NULL, '', 240162),
(310130, 'PTHR46288:SF60', NULL, NULL, NULL, NULL, 'BNACNNG53840D PROTEIN', 240162),
(310131, 'PTHR44920:SF1', NULL, NULL, NULL, NULL, 'RHODANESE-LIKE DOMAIN-CONTAINING PROTEIN 14, CHLOROPLASTIC', 240163),
(310132, 'PTHR44920', NULL, NULL, NULL, NULL, 'RHODANESE-LIKE DOMAIN-CONTAINING PROTEIN 14, CHLOROPLASTIC-RELATED', 240163),
(310133, 'PTHR44920:SF3', NULL, NULL, NULL, NULL, 'RHODANESE DOMAIN-CONTAINING PROTEIN', 240163),
(310134, 'PTHR44920:SF2', NULL, NULL, NULL, NULL, 'RHODANESE DOMAIN-CONTAINING PROTEIN', 240163),
(310135, 'PTHR13429:SF11', NULL, NULL, NULL, NULL, 'FERM DOMAIN-CONTAINING PROTEIN 6', 240164),
(310136, 'PTHR13429:SF12', NULL, NULL, NULL, NULL, '', 240164),
(310137, 'PTHR13429', NULL, NULL, NULL, NULL, 'FERM DOMAIN (PROTEIN4.1-EZRIN-RADIXIN-MOESIN) FAMILY', 240164),
(310138, 'PTHR13429:SF7', NULL, NULL, NULL, NULL, 'FERM DOMAIN-CONTAINING PROTEIN 1', 240164),
(310139, 'PTHR13429:SF5', NULL, NULL, NULL, NULL, 'PROTEIN EXPANDED', 240164),
(310140, 'PTHR31057:SF0', NULL, NULL, NULL, NULL, 'E3 UFM1-PROTEIN LIGASE 1', 240165),
(310141, 'PTHR31057', NULL, NULL, NULL, NULL, 'E3 UFM1-PROTEIN LIGASE 1', 240165); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(310142, 'PTHR11893:SF19', NULL, NULL, NULL, NULL, 'INNEXIN', 240166),
(310143, 'PTHR11893:SF18', NULL, NULL, NULL, NULL, 'INNEXIN UNC-7', 240166),
(310144, 'PTHR11893:SF31', NULL, NULL, NULL, NULL, 'INNEXIN-11', 240166),
(310145, 'PTHR11893:SF30', NULL, NULL, NULL, NULL, 'INNEXIN UNC-9', 240166),
(310146, 'PTHR11893:SF32', NULL, NULL, NULL, NULL, 'INNEXIN', 240166),
(310147, 'PTHR11893:SF10', NULL, NULL, NULL, NULL, 'INNEXIN-6', 240166),
(310148, 'PTHR11893', NULL, NULL, NULL, NULL, 'INNEXIN', 240166),
(310149, 'PTHR11893:SF15', NULL, NULL, NULL, NULL, 'INNEXIN-RELATED', 240166),
(310150, 'PTHR11893:SF37', NULL, NULL, NULL, NULL, 'INNEXIN INX3', 240166),
(310151, 'PTHR11893:SF14', NULL, NULL, NULL, NULL, 'INNEXIN-10', 240166),
(310152, 'PTHR11893:SF36', NULL, NULL, NULL, NULL, 'INNEXIN-5', 240166),
(310153, 'PTHR11893:SF39', NULL, NULL, NULL, NULL, 'INNEXIN INX1', 240166),
(310154, 'PTHR11893:SF17', NULL, NULL, NULL, NULL, 'INNEXIN', 240166),
(310155, 'PTHR11893:SF38', NULL, NULL, NULL, NULL, 'INNEXIN INX7', 240166),
(310156, 'PTHR11893:SF9', NULL, NULL, NULL, NULL, 'INNEXIN-7', 240166),
(310157, 'PTHR11893:SF40', NULL, NULL, NULL, NULL, 'INNEXIN SHAKING-B', 240166),
(310158, 'PTHR11893:SF20', NULL, NULL, NULL, NULL, 'INNEXIN-3', 240166),
(310159, 'PTHR11893:SF41', NULL, NULL, NULL, NULL, 'INNEXIN INX2', 240166),
(310160, 'PTHR11893:SF44', NULL, NULL, NULL, NULL, 'INNEXIN', 240166),
(310161, 'PTHR11893:SF4', NULL, NULL, NULL, NULL, 'INNEXIN', 240166),
(310162, 'PTHR11893:SF43', NULL, NULL, NULL, NULL, 'INNEXIN INX4-RELATED', 240166),
(310163, 'PTHR11893:SF21', NULL, NULL, NULL, NULL, 'INNEXIN EAT-5', 240166),
(310164, 'PTHR11893:SF46', NULL, NULL, NULL, NULL, 'INNEXIN-12', 240166),
(310165, 'PTHR11893:SF24', NULL, NULL, NULL, NULL, 'INNEXIN-19', 240166),
(310166, 'PTHR11893:SF23', NULL, NULL, NULL, NULL, 'INNEXIN-14', 240166),
(310167, 'PTHR11893:SF45', NULL, NULL, NULL, NULL, 'INNEXIN', 240166),
(310168, 'PTHR11893:SF7', NULL, NULL, NULL, NULL, 'INNEXIN', 240166),
(310169, 'PTHR11893:SF25', NULL, NULL, NULL, NULL, 'INNEXIN', 240166),
(310170, 'PTHR11893:SF6', NULL, NULL, NULL, NULL, 'INNEXIN-16', 240166),
(310171, 'PTHR11893:SF28', NULL, NULL, NULL, NULL, 'INNEXIN-2', 240166),
(310172, 'PTHR11893:SF27', NULL, NULL, NULL, NULL, 'INNEXIN-17', 240166),
(310173, 'PTHR20852:SF39', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE', 240167),
(310174, 'PTHR20852', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE', 240167),
(310175, 'PTHR20852:SF96', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE-RELATED', 240167),
(310176, 'PTHR20852:SF97', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE', 240167),
(310177, 'PTHR20852:SF99', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE', 240167),
(310178, 'PTHR20852:SF100', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE', 240167),
(310179, 'PTHR20852:SF102', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE CYTOSOLIC ISOZYME 1-2', 240167),
(310180, 'PTHR20852:SF57', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE 2 CYTOPLASMIC', 240167),
(310181, 'PTHR20852:SF101', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE', 240167),
(310182, 'PTHR20852:SF103', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE', 240167),
(310183, 'PTHR20852:SF105', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE CYTOSOLIC ISOZYME 1-5', 240167),
(310184, 'PTHR20852:SF107', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE', 240167),
(310185, 'PTHR20852:SF109', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE CYTOSOLIC ISOZYME 1-2', 240167),
(310186, 'PTHR20852:SF42', NULL, NULL, NULL, NULL, 'GLN-SYNT_C DOMAIN-CONTAINING PROTEIN', 240167),
(310187, 'PTHR20852:SF86', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE CYTOSOLIC ISOZYME 1-3', 240167),
(310188, 'PTHR20852:SF87', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE', 240167),
(310189, 'PTHR20852:SF43', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE', 240167),
(310190, 'PTHR20852:SF44', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE 1, MITOCHONDRIAL', 240167),
(310191, 'PTHR20852:SF45', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE', 240167),
(310192, 'PTHR20852:SF110', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE', 240167);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(310193, 'PTHR20852:SF113', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE CYTOSOLIC ISOZYME 1-4', 240167),
(310194, 'PTHR20852:SF114', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE CYTOSOLIC ISOZYME 1', 240167),
(310195, 'PTHR20852:SF90', NULL, NULL, NULL, NULL, 'GLN-SYNT_C DOMAIN-CONTAINING PROTEIN', 240167),
(310196, 'PTHR20852:SF92', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE CYTOSOLIC ISOZYME 1-3', 240167),
(310197, 'PTHR20852:SF93', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE CYTOSOLIC ISOZYME 1-1', 240167),
(310198, 'PTHR24100:SF64', NULL, NULL, NULL, NULL, 'BUTYROPHILIN, SUBFAMILY 3, MEMBER A3-RELATED', 240168),
(310199, 'PTHR24100:SF67', NULL, NULL, NULL, NULL, 'BUTYROPHILIN FAMILY MEMBER', 240168),
(310200, 'PTHR24100:SF46', NULL, NULL, NULL, NULL, 'ERYTHROID MEMBRANE-ASSOCIATED PROTEIN', 240168),
(310201, 'PTHR24100:SF0', NULL, NULL, NULL, NULL, 'V-SET DOMAIN-CONTAINING T-CELL ACTIVATION INHIBITOR 1', 240168),
(310202, 'PTHR24100:SF2', NULL, NULL, NULL, NULL, 'CD276 ANTIGEN', 240168),
(310203, 'PTHR24100:SF134', NULL, NULL, NULL, NULL, 'BUTYROPHILIN-LIKE PROTEIN 1', 240168),
(310204, 'PTHR24100:SF135', NULL, NULL, NULL, NULL, 'BUTYROPHILIN-LIKE PROTEIN 3', 240168),
(310205, 'PTHR24100:SF110', NULL, NULL, NULL, NULL, 'BUTYROPHILIN SUBFAMILY 2 MEMBER A3-RELATED', 240168),
(310206, 'PTHR24100:SF133', NULL, NULL, NULL, NULL, 'BUTYROPHILIN-LIKE PROTEIN 10', 240168),
(310207, 'PTHR24100:SF130', NULL, NULL, NULL, NULL, 'SI:CH73-1F23.1', 240168),
(310208, 'PTHR24100:SF138', NULL, NULL, NULL, NULL, 'BUTYROPHILIN SUBFAMILY 1 MEMBER A1', 240168),
(310209, 'PTHR24100:SF116', NULL, NULL, NULL, NULL, 'BUTYROPHILIN-LIKE PROTEIN 9', 240168),
(310210, 'PTHR24100:SF139', NULL, NULL, NULL, NULL, 'BUTYROPHILIN SUBFAMILY 2 MEMBER A2', 240168),
(310211, 'PTHR24100:SF115', NULL, NULL, NULL, NULL, 'BUTYROPHILIN SUBFAMILY 3 MEMBER A2', 240168),
(310212, 'PTHR24100:SF51', NULL, NULL, NULL, NULL, 'SELECTION AND UPKEEP OF INTRAEPITHELIAL T-CELLS PROTEIN 7-RELATED', 240168),
(310213, 'PTHR24100:SF55', NULL, NULL, NULL, NULL, 'ICOS LIGAND', 240168),
(310214, 'PTHR24100:SF56', NULL, NULL, NULL, NULL, 'BUTYROPHILIN SUBFAMILY 3 MEMBER A3', 240168),
(310215, 'PTHR24100:SF79', NULL, NULL, NULL, NULL, 'BUTYROPHILIN SUBFAMILY 2 MEMBER A1', 240168),
(310216, 'PTHR24100', NULL, NULL, NULL, NULL, 'BUTYROPHILIN', 240168),
(310217, 'PTHR24100:SF71', NULL, NULL, NULL, NULL, 'MYELIN-OLIGODENDROCYTE GLYCOPROTEIN', 240168),
(310218, 'PTHR24100:SF102', NULL, NULL, NULL, NULL, 'SELECTION AND UPKEEP OF INTRAEPITHELIAL T-CELLS PROTEIN 2-RELATED', 240168),
(310219, 'PTHR24100:SF129', NULL, NULL, NULL, NULL, 'SELECTION AND UPKEEP OF INTRAEPITHELIAL T-CELLS PROTEIN 1', 240168),
(310220, 'PTHR24100:SF108', NULL, NULL, NULL, NULL, 'BUTYROPHILIN-LIKE PROTEIN 8', 240168),
(310221, 'PTHR24100:SF127', NULL, NULL, NULL, NULL, 'GENE, 36028-RELATED', 240168),
(310222, 'PTHR24100:SF105', NULL, NULL, NULL, NULL, 'BTNL2-RELATED', 240168),
(310223, 'PTHR24100:SF106', NULL, NULL, NULL, NULL, 'HERV-H LTR-ASSOCIATING PROTEIN 2', 240168),
(310224, 'PTHR24100:SF128', NULL, NULL, NULL, NULL, 'BUTYROPHILIN SUBFAMILY 3 MEMBER A1', 240168),
(310225, 'PTHR34286:SF2', NULL, NULL, NULL, NULL, 'BNAA03G54340D PROTEIN', 240169),
(310226, 'PTHR34286:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 240169),
(310227, 'PTHR34286', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 240169),
(310228, 'PTHR39947', NULL, NULL, NULL, NULL, 'IP19862P', 240170),
(310229, 'PTHR39947:SF1', NULL, NULL, NULL, NULL, 'IP19862P', 240170),
(310230, 'PTHR35465:SF1', NULL, NULL, NULL, NULL, 'CAVEOLIN-1 PROTEIN', 240171),
(310231, 'PTHR35465', NULL, NULL, NULL, NULL, 'CAVEOLIN-1 PROTEIN', 240171),
(310232, 'PTHR35465:SF2', NULL, NULL, NULL, NULL, 'BNAC05G16190D PROTEIN', 240171),
(310233, 'PTHR43692', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLMURAMOYLALANINE--D-GLUTAMATE LIGASE', 240172),
(310234, 'PTHR43692:SF1', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLMURAMOYLALANINE--D-GLUTAMATE LIGASE', 240172),
(310235, 'PTHR43333:SF1', NULL, NULL, NULL, NULL, '2-HACID_DH_C DOMAIN-CONTAINING PROTEIN', 240173);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(310236, 'PTHR43333', NULL, NULL, NULL, NULL, '2-HACID_DH_C DOMAIN-CONTAINING PROTEIN', 240173),
(310237, 'PTHR42894', NULL, NULL, NULL, NULL, 'N-(5''-PHOSPHORIBOSYL)ANTHRANILATE ISOMERASE', 240174),
(310238, 'PTHR42894:SF3', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLANTHRANILATE ISOMERASE', 240174),
(310239, 'PTHR42894:SF2', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLANTHRANILATE ISOMERASE', 240174),
(310240, 'PTHR42894:SF1', NULL, NULL, NULL, NULL, 'N-(5''-PHOSPHORIBOSYL)ANTHRANILATE ISOMERASE', 240174),
(310241, 'PTHR12478:SF16', NULL, NULL, NULL, NULL, 'PROTEIN CHARYBDE-RELATED', 240175),
(310242, 'PTHR12478:SF17', NULL, NULL, NULL, NULL, 'DNA DAMAGE-INDUCIBLE TRANSCRIPT 4-LIKE PROTEIN', 240175),
(310243, 'PTHR12478:SF18', NULL, NULL, NULL, NULL, 'DNA DAMAGE-INDUCIBLE TRANSCRIPT 4-LIKE PROTEIN', 240175),
(310244, 'PTHR12478:SF7', NULL, NULL, NULL, NULL, 'DNA DAMAGE-INDUCIBLE TRANSCRIPT 4 PROTEIN', 240175),
(310245, 'PTHR12478', NULL, NULL, NULL, NULL, 'DNA-DAMAGE-INDUCIBLE TRANSCRIPT 4 PROTEIN DDIT4', 240175),
(310246, 'PTHR47629:SF9', NULL, NULL, NULL, NULL, 'CW DOMAIN-CONTAINING PROTEIN', 240176),
(310247, 'PTHR47629', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN-RELATED', 240176),
(310248, 'PTHR47629:SF6', NULL, NULL, NULL, NULL, 'CW DOMAIN-CONTAINING PROTEIN', 240176),
(310249, 'PTHR47629:SF5', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN-RELATED', 240176),
(310250, 'PTHR47629:SF8', NULL, NULL, NULL, NULL, 'CW DOMAIN-CONTAINING PROTEIN', 240176),
(310251, 'PTHR47629:SF7', NULL, NULL, NULL, NULL, 'CW DOMAIN-CONTAINING PROTEIN', 240176),
(310252, 'PTHR47629:SF2', NULL, NULL, NULL, NULL, 'CW DOMAIN-CONTAINING PROTEIN', 240176),
(310253, 'PTHR47629:SF1', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN-RELATED', 240176),
(310254, 'PTHR47629:SF4', NULL, NULL, NULL, NULL, 'CW DOMAIN-CONTAINING PROTEIN', 240176),
(310255, 'PTHR47629:SF3', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN-RELATED', 240176),
(310256, 'PTHR47629:SF13', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN-RELATED', 240176),
(310257, 'PTHR47629:SF12', NULL, NULL, NULL, NULL, 'CW DOMAIN-CONTAINING PROTEIN', 240176),
(310258, 'PTHR47629:SF11', NULL, NULL, NULL, NULL, 'CW DOMAIN-CONTAINING PROTEIN', 240176),
(310259, 'PTHR47629:SF10', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN-RELATED', 240176),
(310260, 'PTHR46144:SF1', NULL, NULL, NULL, NULL, 'ZGC:114104', 240177),
(310261, 'PTHR46144:SF2', NULL, NULL, NULL, NULL, 'ZGC:171482', 240177),
(310262, 'PTHR46144:SF3', NULL, NULL, NULL, NULL, 'ZINC FINGER MATRIN-TYPE PROTEIN 4', 240177),
(310263, 'PTHR46144', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 385B-LIKE', 240177),
(310264, 'PTHR46144:SF5', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 346', 240177),
(310265, 'PTHR46144:SF6', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 385B-LIKE', 240177),
(310266, 'PTHR46144:SF7', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 12-LIKE', 240177),
(310267, 'PTHR28360', NULL, NULL, NULL, NULL, 'DYNACTIN SUBUNIT 3', 240178),
(310268, 'PTHR28360:SF1', NULL, NULL, NULL, NULL, 'DYNACTIN SUBUNIT 3', 240178),
(310269, 'PTHR21253', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 240179),
(310270, 'PTHR21253:SF0', NULL, NULL, NULL, NULL, 'FI17420P1', 240179),
(310271, 'PTHR43147:SF5', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE', 240180),
(310272, 'PTHR43147:SF4', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 240180),
(310273, 'PTHR43147:SF2', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 240180),
(310274, 'PTHR43147', NULL, NULL, NULL, NULL, 'PROTEIN TAS', 240180),
(310275, 'PTHR14132', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM-TRANSPORTING ATPASE SUBUNIT GAMMA', 240181),
(310276, 'PTHR14132:SF12', NULL, NULL, NULL, NULL, 'PHOSPHOLEMMAN', 240181),
(310277, 'PTHR14132:SF11', NULL, NULL, NULL, NULL, 'FXYD DOMAIN-CONTAINING ION TRANSPORT REGULATOR 3', 240181),
(310278, 'PTHR14132:SF22', NULL, NULL, NULL, NULL, 'FXYD DOMAIN-CONTAINING ION TRANSPORT REGULATOR', 240181),
(310279, 'PTHR14132:SF10', NULL, NULL, NULL, NULL, 'FXYD DOMAIN-CONTAINING ION TRANSPORT REGULATOR 4', 240181);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(310280, 'PTHR14132:SF21', NULL, NULL, NULL, NULL, 'FXYD DOMAIN-CONTAINING ION TRANSPORT REGULATOR', 240181),
(310281, 'PTHR14132:SF20', NULL, NULL, NULL, NULL, 'FXYD DOMAIN-CONTAINING ION TRANSPORT REGULATOR', 240181),
(310282, 'PTHR14132:SF16', NULL, NULL, NULL, NULL, 'FXYD DOMAIN-CONTAINING ION TRANSPORT REGULATOR-RELATED', 240181),
(310283, 'PTHR14132:SF15', NULL, NULL, NULL, NULL, 'FXYD DOMAIN-CONTAINING ION TRANSPORT REGULATOR 6-RELATED', 240181),
(310284, 'PTHR14132:SF14', NULL, NULL, NULL, NULL, 'FXYD DOMAIN-CONTAINING ION TRANSPORT REGULATOR 5', 240181),
(310285, 'PTHR14132:SF3', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM-TRANSPORTING ATPASE SUBUNIT GAMMA', 240181),
(310286, 'PTHR14132:SF1', NULL, NULL, NULL, NULL, 'FXYD DOMAIN-CONTAINING ION TRANSPORT REGULATOR 7', 240181),
(310287, 'PTHR34934', NULL, NULL, NULL, NULL, 'FLAVIN-DEPENDENT THYMIDYLATE SYNTHASE', 240182),
(310288, 'PTHR34934:SF1', NULL, NULL, NULL, NULL, 'FLAVIN-DEPENDENT THYMIDYLATE SYNTHASE', 240182),
(310289, 'PTHR22836:SF0', NULL, NULL, NULL, NULL, 'PRE-MRNA 3'' END PROCESSING PROTEIN WDR33', 240183),
(310290, 'PTHR22836', NULL, NULL, NULL, NULL, 'WD40 REPEAT PROTEIN', 240183),
(310291, 'PTHR31785:SF2', NULL, NULL, NULL, NULL, 'UPF0524 PROTEIN C3ORF70', 240184),
(310292, 'PTHR31785', NULL, NULL, NULL, NULL, 'UPF0524 PROTEIN C3ORF70', 240184),
(310293, 'PTHR42980:SF1', NULL, NULL, NULL, NULL, '2-OXOISOVALERATE DEHYDROGENASE SUBUNIT BETA, MITOCHONDRIAL', 240185),
(310294, 'PTHR42980', NULL, NULL, NULL, NULL, '2-OXOISOVALERATE DEHYDROGENASE SUBUNIT BETA-RELATED', 240185),
(310295, 'PTHR48143', NULL, NULL, NULL, NULL, '', 240186),
(310296, 'PTHR48143:SF1', NULL, NULL, NULL, NULL, '', 240186),
(310297, 'PTHR31311:SF33', NULL, NULL, NULL, NULL, 'BNACNNG19100D PROTEIN', 240187),
(310298, 'PTHR31311:SF12', NULL, NULL, NULL, NULL, 'XYLOGLUCAN 6-XYLOSYLTRANSFERASE 3-RELATED', 240187),
(310299, 'PTHR31311:SF34', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE 7-RELATED', 240187),
(310300, 'PTHR31311:SF15', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE 6-LIKE', 240187),
(310301, 'PTHR31311:SF16', NULL, NULL, NULL, NULL, '', 240187),
(310302, 'PTHR31311:SF38', NULL, NULL, NULL, NULL, 'BNAA04G27220D PROTEIN', 240187),
(310303, 'PTHR31311:SF35', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE CAZY FAMILY GT34-LIKE PROTEIN', 240187),
(310304, 'PTHR31311:SF13', NULL, NULL, NULL, NULL, 'XYLOGLUCAN 6-XYLOSYLTRANSFERASE 5-RELATED', 240187),
(310305, 'PTHR31311:SF14', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE 6', 240187),
(310306, 'PTHR31311:SF19', NULL, NULL, NULL, NULL, 'XYLOGLUCAN 6-XYLOSYLTRANSFERASE 1', 240187),
(310307, 'PTHR31311:SF39', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE 7-RELATED', 240187),
(310308, 'PTHR31311:SF17', NULL, NULL, NULL, NULL, 'GALACTOSYL TRANSFERASE GMA12/MNN10 FAMILY PROTEIN', 240187),
(310309, 'PTHR31311:SF18', NULL, NULL, NULL, NULL, 'XYLOGLUCAN 6-XYLOSYLTRANSFERASE-RELATED', 240187),
(310310, 'PTHR31311:SF41', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 240187),
(310311, 'PTHR31311:SF44', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE 2-RELATED', 240187),
(310312, 'PTHR31311:SF22', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE 4-RELATED', 240187),
(310313, 'PTHR31311:SF45', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE 6-RELATED', 240187),
(310314, 'PTHR31311:SF23', NULL, NULL, NULL, NULL, 'XYLOGLUCAN 6-XYLOSYLTRANSFERASE 5-RELATED', 240187),
(310315, 'PTHR31311:SF42', NULL, NULL, NULL, NULL, 'XYLOGLUCAN 6-XYLOSYLTRANSFERASE 2-LIKE', 240187),
(310316, 'PTHR31311:SF20', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE 6', 240187),
(310317, 'PTHR31311:SF43', NULL, NULL, NULL, NULL, 'BNAUNNG01300D PROTEIN', 240187),
(310318, 'PTHR31311:SF21', NULL, NULL, NULL, NULL, 'XYLOGLUCAN 6-XYLOSYLTRANSFERASE 5-RELATED', 240187),
(310319, 'PTHR31311:SF26', NULL, NULL, NULL, NULL, 'ALPHA-6-GALACTOSYLTRANSFERASE', 240187),
(310320, 'PTHR31311:SF7', NULL, NULL, NULL, NULL, 'XYLOGLUCAN 6-XYLOSYLTRANSFERASE 2', 240187),
(310321, 'PTHR31311:SF9', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE 5-RELATED', 240187),
(310322, 'PTHR31311:SF8', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE 3-RELATED', 240187);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(310323, 'PTHR31311:SF25', NULL, NULL, NULL, NULL, 'XYLOGLUCAN 6-XYLOSYLTRANSFERASE 4', 240187),
(310324, 'PTHR31311:SF28', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE 6', 240187),
(310325, 'PTHR31311:SF29', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE 34-RELATED', 240187),
(310326, 'PTHR31311:SF3', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE 7-RELATED', 240187),
(310327, 'PTHR31311:SF5', NULL, NULL, NULL, NULL, 'XYLOGLUCAN 6-XYLOSYLTRANSFERASE 2', 240187),
(310328, 'PTHR31311', NULL, NULL, NULL, NULL, 'XYLOGLUCAN 6-XYLOSYLTRANSFERASE 5-RELATED-RELATED', 240187),
(310329, 'PTHR44395:SF1', NULL, NULL, NULL, NULL, 'PROTEIN O-MANNOSYL-TRANSFERASE TMTC3', 240188),
(310330, 'PTHR44395', NULL, NULL, NULL, NULL, '', 240188),
(310331, 'PTHR15132', NULL, NULL, NULL, NULL, 'SNRNA-ACTIVATING PROTEIN COMPLEX SUBUNIT 2', 240189),
(310332, 'PTHR15132:SF1', NULL, NULL, NULL, NULL, 'SNRNA-ACTIVATING PROTEIN COMPLEX SUBUNIT 2', 240189),
(310333, 'PTHR14057:SF47', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN ONECUT', 240190),
(310334, 'PTHR14057:SF34', NULL, NULL, NULL, NULL, 'ONE CUT DOMAIN FAMILY MEMBER 3', 240190),
(310335, 'PTHR14057:SF44', NULL, NULL, NULL, NULL, 'ONE CUT DOMAIN FAMILY MEMBER', 240190),
(310336, 'PTHR14057:SF32', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN CEH-21-RELATED', 240190),
(310337, 'PTHR14057:SF9', NULL, NULL, NULL, NULL, 'HEPATOCYTE NUCLEAR FACTOR 6', 240190),
(310338, 'PTHR14057:SF10', NULL, NULL, NULL, NULL, 'ONE CUT DOMAIN FAMILY MEMBER 2', 240190),
(310339, 'PTHR14057', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR ONECUT', 240190),
(310340, 'PTHR14057:SF48', NULL, NULL, NULL, NULL, 'ONE CUT DOMAIN FAMILY MEMBER', 240190),
(310341, 'PTHR14362', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 81', 240191),
(310342, 'PTHR14362:SF2', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 81', 240191),
(310343, 'PTHR48210:SF1', NULL, NULL, NULL, NULL, 'OS05G0352800 PROTEIN', 240192),
(310344, 'PTHR48210', NULL, NULL, NULL, NULL, 'OS05G0352800 PROTEIN', 240192),
(310345, 'PTHR31205:SF28', NULL, NULL, NULL, NULL, 'DUF569 DOMAIN-CONTAINING PROTEIN', 240193),
(310346, 'PTHR31205:SF29', NULL, NULL, NULL, NULL, 'DUF569 DOMAIN-CONTAINING PROTEIN', 240193),
(310347, 'PTHR31205:SF26', NULL, NULL, NULL, NULL, 'DUF569 DOMAIN-CONTAINING PROTEIN', 240193),
(310348, 'PTHR31205:SF48', NULL, NULL, NULL, NULL, 'DUF569 DOMAIN-CONTAINING PROTEIN', 240193),
(310349, 'PTHR31205:SF24', NULL, NULL, NULL, NULL, 'DUF569 DOMAIN-CONTAINING PROTEIN', 240193),
(310350, 'PTHR31205:SF69', NULL, NULL, NULL, NULL, 'ACTIN CROSS-LINKING PROTEIN (DUF569)', 240193),
(310351, 'PTHR31205:SF25', NULL, NULL, NULL, NULL, 'DUF569 DOMAIN-CONTAINING PROTEIN', 240193),
(310352, 'PTHR31205:SF47', NULL, NULL, NULL, NULL, 'DUF569 DOMAIN-CONTAINING PROTEIN', 240193),
(310353, 'PTHR31205:SF66', NULL, NULL, NULL, NULL, 'DUF569 DOMAIN-CONTAINING PROTEIN', 240193),
(310354, 'PTHR31205:SF23', NULL, NULL, NULL, NULL, 'CROSS-LINKING PROTEIN, PUTATIVE (DUF569)-RELATED', 240193),
(310355, 'PTHR31205:SF64', NULL, NULL, NULL, NULL, 'DUF569 DOMAIN-CONTAINING PROTEIN', 240193),
(310356, 'PTHR31205:SF73', NULL, NULL, NULL, NULL, 'ACTIN CROSS-LINKING-RELATED', 240193),
(310357, 'PTHR31205:SF51', NULL, NULL, NULL, NULL, 'DUF569 DOMAIN-CONTAINING PROTEIN', 240193),
(310358, 'PTHR31205:SF30', NULL, NULL, NULL, NULL, 'DUF569 DOMAIN-CONTAINING PROTEIN', 240193),
(310359, 'PTHR31205:SF52', NULL, NULL, NULL, NULL, 'DUF569 DOMAIN-CONTAINING PROTEIN', 240193),
(310360, 'PTHR31205', NULL, NULL, NULL, NULL, 'ACTIN CROSS-LINKING PROTEIN (DUF569)', 240193),
(310361, 'PTHR31205:SF71', NULL, NULL, NULL, NULL, 'DUF569 DOMAIN-CONTAINING PROTEIN', 240193),
(310362, 'PTHR31205:SF50', NULL, NULL, NULL, NULL, 'BNAA07G28440D PROTEIN', 240193),
(310363, 'PTHR31205:SF72', NULL, NULL, NULL, NULL, 'DUF569 DOMAIN-CONTAINING PROTEIN', 240193),
(310364, 'PTHR31205:SF70', NULL, NULL, NULL, NULL, 'ACTIN CROSS-LINKING PROTEIN', 240193),
(310365, 'PTHR31205:SF7', NULL, NULL, NULL, NULL, 'ACTIN CROSS-LINKING PROTEIN', 240193),
(310366, 'PTHR31205:SF4', NULL, NULL, NULL, NULL, 'DUF569 DOMAIN-CONTAINING PROTEIN', 240193);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(310367, 'PTHR31205:SF39', NULL, NULL, NULL, NULL, 'OS08G0164400 PROTEIN', 240193),
(310368, 'PTHR31205:SF3', NULL, NULL, NULL, NULL, 'OS07G0171500 PROTEIN', 240193),
(310369, 'PTHR31205:SF2', NULL, NULL, NULL, NULL, 'CROSS-LINKING PROTEIN, PUTATIVE (DUF569)-RELATED', 240193),
(310370, 'PTHR31205:SF59', NULL, NULL, NULL, NULL, 'ACTIN CROSS-LINKING-RELATED', 240193),
(310371, 'PTHR31205:SF37', NULL, NULL, NULL, NULL, 'ACTIN CROSS-LINKING PROTEIN (DUF569)', 240193),
(310372, 'PTHR31205:SF38', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 240193),
(310373, 'PTHR31205:SF57', NULL, NULL, NULL, NULL, 'DUF569 DOMAIN-CONTAINING PROTEIN', 240193),
(310374, 'PTHR31205:SF35', NULL, NULL, NULL, NULL, 'DUF569 DOMAIN-CONTAINING PROTEIN', 240193),
(310375, 'PTHR31205:SF36', NULL, NULL, NULL, NULL, 'DUF569 DOMAIN-CONTAINING PROTEIN', 240193),
(310376, 'PTHR31205:SF58', NULL, NULL, NULL, NULL, 'ACTIN CROSS-LINKING-RELATED', 240193),
(310377, 'PTHR31205:SF11', NULL, NULL, NULL, NULL, 'OS05G0115500 PROTEIN', 240193),
(310378, 'PTHR31205:SF55', NULL, NULL, NULL, NULL, 'ACTIN CROSS-LINKING-RELATED', 240193),
(310379, 'PTHR31205:SF33', NULL, NULL, NULL, NULL, 'DUF569 DOMAIN-CONTAINING PROTEIN', 240193),
(310380, 'PTHR31205:SF56', NULL, NULL, NULL, NULL, 'DUF569 DOMAIN-CONTAINING PROTEIN', 240193),
(310381, 'PTHR31205:SF34', NULL, NULL, NULL, NULL, 'ACTIN CROSS-LINKING PROTEIN', 240193),
(310382, 'PTHR31205:SF31', NULL, NULL, NULL, NULL, 'ACTIN CROSS-LINKING PROTEIN', 240193),
(310383, 'PTHR31205:SF32', NULL, NULL, NULL, NULL, 'DUF569 DOMAIN-CONTAINING PROTEIN', 240193),
(310384, 'PTHR31205:SF54', NULL, NULL, NULL, NULL, 'ACTIN CROSS-LINKING PROTEIN', 240193),
(310385, 'PTHR31205:SF62', NULL, NULL, NULL, NULL, 'DUF569 DOMAIN-CONTAINING PROTEIN', 240193),
(310386, 'PTHR31205:SF40', NULL, NULL, NULL, NULL, 'ACTIN CROSS-LINKING PROTEIN', 240193),
(310387, 'PTHR31205:SF41', NULL, NULL, NULL, NULL, '', 240193),
(310388, 'PTHR31205:SF60', NULL, NULL, NULL, NULL, 'BNAA07G09180D PROTEIN', 240193),
(310389, 'PTHR46235:SF18', NULL, NULL, NULL, NULL, 'PROTEIN ENHANCED DOWNY MILDEW 2', 240194),
(310390, 'PTHR46235:SF2', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 240194),
(310391, 'PTHR46235:SF3', NULL, NULL, NULL, NULL, 'PHD FINGER-CONTAINING PROTEIN DDB_G0268158', 240194),
(310392, 'PTHR46235:SF4', NULL, NULL, NULL, NULL, 'PROTEIN ENHANCED DOWNY MILDEW 2', 240194),
(310393, 'PTHR46235:SF13', NULL, NULL, NULL, NULL, 'EDM2-LIKE PROTEIN1', 240194),
(310394, 'PTHR46235:SF5', NULL, NULL, NULL, NULL, 'OS03G0266600 PROTEIN', 240194),
(310395, 'PTHR46235:SF15', NULL, NULL, NULL, NULL, 'PROTEIN ENHANCED DOWNY MILDEW 2', 240194),
(310396, 'PTHR46235', NULL, NULL, NULL, NULL, 'PHD FINGER-CONTAINING PROTEIN DDB_G0268158', 240194),
(310397, 'PTHR46235:SF7', NULL, NULL, NULL, NULL, 'OS08G0336500 PROTEIN', 240194),
(310398, 'PTHR46235:SF16', NULL, NULL, NULL, NULL, '', 240194),
(310399, 'PTHR46235:SF17', NULL, NULL, NULL, NULL, '', 240194),
(310400, 'PTHR46235:SF8', NULL, NULL, NULL, NULL, '', 240194),
(310401, 'PTHR31358:SF40', NULL, NULL, NULL, NULL, 'TPX2 DOMAIN-CONTAINING PROTEIN', 240195),
(310402, 'PTHR31358', NULL, NULL, NULL, NULL, 'PROTEIN WVD2-LIKE 4', 240195),
(310403, 'PTHR31358:SF29', NULL, NULL, NULL, NULL, 'PROTEIN WVD2-LIKE 5-RELATED', 240195),
(310404, 'PTHR31358:SF46', NULL, NULL, NULL, NULL, 'TARGETING PROTEIN FOR XKLP2 PROTEIN', 240195),
(310405, 'PTHR31358:SF35', NULL, NULL, NULL, NULL, 'BNAA03G52010D PROTEIN', 240195),
(310406, 'PTHR31358:SF45', NULL, NULL, NULL, NULL, 'TPX2 DOMAIN-CONTAINING PROTEIN', 240195),
(310407, 'PTHR31358:SF15', NULL, NULL, NULL, NULL, 'OS06G0606800 PROTEIN', 240195),
(310408, 'PTHR31358:SF36', NULL, NULL, NULL, NULL, 'TPX2 DOMAIN-CONTAINING PROTEIN', 240195),
(310409, 'PTHR31358:SF30', NULL, NULL, NULL, NULL, 'PROTEIN WVD2-LIKE 4', 240195),
(310410, 'PTHR31358:SF44', NULL, NULL, NULL, NULL, 'ASPARTATE CARBAMOYLTRANSFERASE, CHLOROPLASTIC', 240195),
(310411, 'PTHR31358:SF43', NULL, NULL, NULL, NULL, 'TPX2 (TARGETING PROTEIN FOR XKLP2) FAMILY PROTEIN', 240195);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(310412, 'PTHR31677:SF49', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF086', 240196),
(310413, 'PTHR31677:SF161', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 240196),
(310414, 'PTHR31677:SF163', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 240196),
(310415, 'PTHR31677:SF122', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 240196),
(310416, 'PTHR31677:SF167', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 240196),
(310417, 'PTHR31677:SF200', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF084-LIKE', 240196),
(310418, 'PTHR31677:SF86', NULL, NULL, NULL, NULL, 'AP2-EREBP TRANSCRIPTION FACTOR', 240196),
(310419, 'PTHR31677:SF87', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF088', 240196),
(310420, 'PTHR31677:SF209', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 6', 240196),
(310421, 'PTHR31677:SF201', NULL, NULL, NULL, NULL, 'OS04G0669200 PROTEIN', 240196),
(310422, 'PTHR31677:SF168', NULL, NULL, NULL, NULL, 'OS01G0797600 PROTEIN', 240196),
(310423, 'PTHR31677:SF202', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 240196),
(310424, 'PTHR31677:SF203', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 240196),
(310425, 'PTHR31677:SF127', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 5', 240196),
(310426, 'PTHR31677:SF204', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 11', 240196),
(310427, 'PTHR31677:SF205', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 3-RELATED', 240196),
(310428, 'PTHR31677:SF206', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 240196),
(310429, 'PTHR31677:SF207', NULL, NULL, NULL, NULL, 'AP2 DOMAIN CLASS TRANSCRIPTION FACTOR', 240196),
(310430, 'PTHR31677:SF208', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 240196),
(310431, 'PTHR31677:SF193', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF117', 240196),
(310432, 'PTHR31677:SF194', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 240196),
(310433, 'PTHR31677:SF150', NULL, NULL, NULL, NULL, '', 240196),
(310434, 'PTHR31677:SF152', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 240196),
(310435, 'PTHR31677:SF196', NULL, NULL, NULL, NULL, 'OS04G0610400 PROTEIN', 240196),
(310436, 'PTHR31677:SF197', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 240196),
(310437, 'PTHR31677:SF153', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 5-LIKE', 240196),
(310438, 'PTHR31677:SF198', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING TRANSCRIPTION FACTOR', 240196),
(310439, 'PTHR31677:SF110', NULL, NULL, NULL, NULL, 'AP2 DOMAIN CLASS TRANSCRIPTION FACTOR', 240196),
(310440, 'PTHR31677:SF155', NULL, NULL, NULL, NULL, 'AP2/EREBP TRANSCRIPTION FACTOR SUPERFAMILY PROTEIN-RELATED', 240196),
(310441, 'PTHR31677:SF199', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, PUTATIVE-RELATED', 240196),
(310442, 'PTHR31677:SF75', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF084', 240196),
(310443, 'PTHR31677:SF77', NULL, NULL, NULL, NULL, 'OS05G0497200 PROTEIN', 240196),
(310444, 'PTHR31677:SF78', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ESR2', 240196),
(310445, 'PTHR31677:SF191', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 3-LIKE', 240196),
(310446, 'PTHR31677:SF82', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 4', 240196),
(310447, 'PTHR31677:SF157', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 240196),
(310448, 'PTHR31677:SF159', NULL, NULL, NULL, NULL, 'OS02G0520000 PROTEIN', 240196),
(310449, 'PTHR31677:SF115', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 240196),
(310450, 'PTHR31677:SF118', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR LEP', 240196),
(310451, 'PTHR31677:SF140', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF106', 240196),
(310452, 'PTHR31677:SF142', NULL, NULL, NULL, NULL, 'DNA BINDING PROTEIN', 240196);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(310453, 'PTHR31677:SF220', NULL, NULL, NULL, NULL, 'ERF DOMAIN PROTEIN 9-RELATED', 240196),
(310454, 'PTHR31677:SF100', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 3-LIKE', 240196),
(310455, 'PTHR31677:SF221', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF087', 240196),
(310456, 'PTHR31677:SF145', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF109-LIKE', 240196),
(310457, 'PTHR31677:SF222', NULL, NULL, NULL, NULL, '', 240196),
(310458, 'PTHR31677:SF66', NULL, NULL, NULL, NULL, 'OS06G0691100 PROTEIN', 240196),
(310459, 'PTHR31677:SF68', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 240196),
(310460, 'PTHR31677:SF180', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF105', 240196),
(310461, 'PTHR31677:SF223', NULL, NULL, NULL, NULL, 'ETHYLENE RESPONSE FACTOR', 240196),
(310462, 'PTHR31677:SF146', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ESR1', 240196),
(310463, 'PTHR31677:SF102', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 240196),
(310464, 'PTHR31677:SF224', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE ELEMENT BINDING FACTOR', 240196),
(310465, 'PTHR31677:SF147', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 240196),
(310466, 'PTHR31677:SF225', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 240196),
(310467, 'PTHR31677:SF105', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 12', 240196),
(310468, 'PTHR31677:SF226', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF107', 240196),
(310469, 'PTHR31677:SF149', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR', 240196),
(310470, 'PTHR31677:SF106', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF106-LIKE', 240196),
(310471, 'PTHR31677:SF227', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 240196),
(310472, 'PTHR31677:SF107', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF109', 240196),
(310473, 'PTHR31677:SF228', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 10-RELATED', 240196),
(310474, 'PTHR31677:SF108', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 240196),
(310475, 'PTHR31677:SF172', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 240196),
(310476, 'PTHR31677:SF131', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 240196),
(310477, 'PTHR31677:SF210', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 8', 240196),
(310478, 'PTHR31677:SF134', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 240196),
(310479, 'PTHR31677:SF211', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 240196),
(310480, 'PTHR31677:SF98', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF091', 240196),
(310481, 'PTHR31677:SF56', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 240196),
(310482, 'PTHR31677', NULL, NULL, NULL, NULL, 'AP2 DOMAIN CLASS TRANSCRIPTION FACTOR', 240196),
(310483, 'PTHR31677:SF61', NULL, NULL, NULL, NULL, '', 240196),
(310484, 'PTHR31677:SF135', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 240196),
(310485, 'PTHR31677:SF212', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 4', 240196),
(310486, 'PTHR31677:SF213', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 240196),
(310487, 'PTHR31677:SF214', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR CRF1-LIKE', 240196),
(310488, 'PTHR31677:SF215', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 240196),
(310489, 'PTHR31677:SF138', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 240196),
(310490, 'PTHR31677:SF216', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF104', 240196),
(310491, 'PTHR31677:SF217', NULL, NULL, NULL, NULL, 'ERF TRANSCRIPTION FACTOR 5', 240196),
(310492, 'PTHR31677:SF218', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 240196),
(310493, 'PTHR31677:SF219', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 14', 240196);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(310494, 'PTHR35371', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN', 240197),
(310495, 'PTHR35371:SF2', NULL, NULL, NULL, NULL, '', 240197),
(310496, 'PTHR35371:SF1', NULL, NULL, NULL, NULL, 'BLR7753 PROTEIN', 240197),
(310497, 'PTHR33797:SF2', NULL, NULL, NULL, NULL, 'ORGANIC HYDROPEROXIDE RESISTANCE PROTEIN-LIKE', 240198),
(310498, 'PTHR33797', NULL, NULL, NULL, NULL, 'ORGANIC HYDROPEROXIDE RESISTANCE PROTEIN-LIKE', 240198),
(310499, 'PTHR35402:SF1', NULL, NULL, NULL, NULL, 'T2SSF DOMAIN-CONTAINING PROTEIN', 240199),
(310500, 'PTHR35402:SF2', NULL, NULL, NULL, NULL, 'FLAGELLA ACCESSORY PROTEIN J', 240199),
(310501, 'PTHR35402', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN-RELATED', 240199),
(310502, 'PTHR23002:SF109', NULL, NULL, NULL, NULL, 'ZINC KNUCKLE (CCHC-TYPE) FAMILY PROTEIN', 240200),
(310503, 'PTHR23002:SF53', NULL, NULL, NULL, NULL, 'ZINC FINGER CCHC DOMAIN-CONTAINING PROTEIN 13', 240200),
(310504, 'PTHR23002:SF89', NULL, NULL, NULL, NULL, 'OS04G0608700 PROTEIN', 240200),
(310505, 'PTHR23002:SF67', NULL, NULL, NULL, NULL, 'CELLULAR NUCLEIC ACID-BINDING PROTEIN', 240200),
(310506, 'PTHR23002', NULL, NULL, NULL, NULL, 'ZINC FINGER CCHC DOMAIN CONTAINING PROTEIN', 240200),
(310507, 'PTHR23002:SF84', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN GIS2', 240200),
(310508, 'PTHR23002:SF116', NULL, NULL, NULL, NULL, 'ZINC KNUCKLE FAMILY PROTEIN-RELATED', 240200),
(310509, 'PTHR23002:SF117', NULL, NULL, NULL, NULL, 'CELLULAR NUCLEIC ACID-BINDING PROTEIN', 240200),
(310510, 'PTHR23002:SF106', NULL, NULL, NULL, NULL, 'CELLULAR NUCLEIC ACID-BINDING PROTEIN', 240200),
(310511, 'PTHR23002:SF112', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 240200),
(310512, 'PTHR23002:SF113', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 240200),
(310513, 'PTHR23002:SF114', NULL, NULL, NULL, NULL, 'COLD SHOCK DOMAIN-CONTAINING PROTEIN 4-LIKE', 240200),
(310514, 'PTHR23002:SF115', NULL, NULL, NULL, NULL, '', 240200),
(310515, 'PTHR48133', NULL, NULL, NULL, NULL, 'GRF-TYPE DOMAIN-CONTAINING PROTEIN', 240201),
(310516, 'PTHR48133:SF1', NULL, NULL, NULL, NULL, '', 240201),
(310517, 'PTHR35075:SF1', NULL, NULL, NULL, NULL, 'A-KINASE ANCHOR PROTEIN 14', 240202),
(310518, 'PTHR35075', NULL, NULL, NULL, NULL, 'A-KINASE ANCHOR PROTEIN 14', 240202),
(310519, 'PTHR28241', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT PROTEIN 1', 240203),
(310520, 'PTHR28241:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT PROTEIN 1', 240203),
(310521, 'PTHR36718', NULL, NULL, NULL, NULL, 'OS05G0435400 PROTEIN', 240204),
(310522, 'PTHR36718:SF1', NULL, NULL, NULL, NULL, 'DOUBLE ZINC RIBBON PROTEIN MJ0416', 240204),
(310523, 'PTHR11524:SF46', NULL, NULL, NULL, NULL, 'BNAA09G18530D PROTEIN', 240205),
(310524, 'PTHR11524:SF57', NULL, NULL, NULL, NULL, 'OS04G0605900 PROTEIN', 240205),
(310525, 'PTHR11524:SF13', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L7-LIKE 1', 240205),
(310526, 'PTHR11524:SF47', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L7-RELATED', 240205),
(310527, 'PTHR11524:SF36', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L7-1', 240205),
(310528, 'PTHR11524:SF58', NULL, NULL, NULL, NULL, 'IP16805P', 240205),
(310529, 'PTHR11524:SF55', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L7-2', 240205),
(310530, 'PTHR11524:SF33', NULL, NULL, NULL, NULL, '', 240205),
(310531, 'PTHR11524:SF56', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L7-2-LIKE', 240205),
(310532, 'PTHR11524:SF45', NULL, NULL, NULL, NULL, 'BNAC04G03350D PROTEIN', 240205),
(310533, 'PTHR11524:SF12', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L7', 240205),
(310534, 'PTHR11524:SF53', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L7-2', 240205),
(310535, 'PTHR11524', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L7', 240205),
(310536, 'PTHR11524:SF42', NULL, NULL, NULL, NULL, 'BNAA02G27070D PROTEIN', 240205),
(310537, 'PTHR11524:SF43', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L7-4', 240205),
(310538, 'PTHR11524:SF54', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L7-A', 240205),
(310539, 'PTHR11524:SF32', NULL, NULL, NULL, NULL, '', 240205);
INSERT INTO "PUBLIC"."MODEL" VALUES
(310540, 'PTHR11524:SF40', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L7, PUTATIVE-RELATED', 240205),
(310541, 'PTHR11524:SF52', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L7-4-LIKE', 240205),
(310542, 'PTHR11524:SF28', NULL, NULL, NULL, NULL, '', 240205),
(310543, 'PTHR11524:SF39', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L7-3-RELATED', 240205),
(310544, 'PTHR11524:SF48', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L7-4-LIKE', 240205),
(310545, 'PTHR11524:SF26', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS PROTEIN RLP7', 240205),
(310546, 'PTHR11524:SF16', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L7', 240205),
(310547, 'PTHR31279:SF19', NULL, NULL, NULL, NULL, 'OS06G0219900 PROTEIN', 240206),
(310548, 'PTHR31279:SF18', NULL, NULL, NULL, NULL, 'PROTEIN EXORDIUM-LIKE 7', 240206),
(310549, 'PTHR31279:SF37', NULL, NULL, NULL, NULL, 'OS06G0220300 PROTEIN', 240206),
(310550, 'PTHR31279:SF58', NULL, NULL, NULL, NULL, 'PROTEIN EXORDIUM-LIKE 2', 240206),
(310551, 'PTHR31279:SF11', NULL, NULL, NULL, NULL, 'OS02G0756600 PROTEIN', 240206),
(310552, 'PTHR31279:SF77', NULL, NULL, NULL, NULL, 'PHOSPHATE-INDUCED PROTEIN 1-RELATED', 240206),
(310553, 'PTHR31279:SF76', NULL, NULL, NULL, NULL, '', 240206),
(310554, 'PTHR31279:SF54', NULL, NULL, NULL, NULL, 'PROTEIN EXORDIUM-RELATED', 240206),
(310555, 'PTHR31279:SF10', NULL, NULL, NULL, NULL, 'OS10G0376400 PROTEIN', 240206),
(310556, 'PTHR31279:SF79', NULL, NULL, NULL, NULL, '', 240206),
(310557, 'PTHR31279:SF13', NULL, NULL, NULL, NULL, 'PROTEIN EXORDIUM-LIKE 6', 240206),
(310558, 'PTHR31279:SF57', NULL, NULL, NULL, NULL, 'BNAA02G34120D PROTEIN', 240206),
(310559, 'PTHR31279:SF78', NULL, NULL, NULL, NULL, 'PROTEIN EXORDIUM-LIKE 2', 240206),
(310560, 'PTHR31279:SF73', NULL, NULL, NULL, NULL, 'PROTEIN EXORDIUM-LIKE', 240206),
(310561, 'PTHR31279:SF72', NULL, NULL, NULL, NULL, 'OS02G0756800 PROTEIN', 240206),
(310562, 'PTHR31279:SF75', NULL, NULL, NULL, NULL, 'PHOSPHATE-RESPONSIVE 1 FAMILY PROTEIN', 240206),
(310563, 'PTHR31279:SF4', NULL, NULL, NULL, NULL, 'PROTEIN EXORDIUM-LIKE 5', 240206),
(310564, 'PTHR31279:SF74', NULL, NULL, NULL, NULL, 'PROTEIN EXORDIUM-LIKE 2', 240206),
(310565, 'PTHR31279:SF3', NULL, NULL, NULL, NULL, 'PROTEIN EXORDIUM-LIKE 2', 240206),
(310566, 'PTHR31279:SF52', NULL, NULL, NULL, NULL, 'PHOSPHATE-INDUCED PROTEIN 1-RELATED', 240206),
(310567, 'PTHR31279:SF80', NULL, NULL, NULL, NULL, 'EXORDIUM LIKE 6-RELATED', 240206),
(310568, 'PTHR31279:SF60', NULL, NULL, NULL, NULL, 'BNAANNG05850D PROTEIN', 240206),
(310569, 'PTHR31279:SF7', NULL, NULL, NULL, NULL, 'PROTEIN EXORDIUM-LIKE 3', 240206),
(310570, 'PTHR31279:SF66', NULL, NULL, NULL, NULL, 'PHOSPHATE-RESPONSIVE 1 FAMILY PROTEIN', 240206),
(310571, 'PTHR31279:SF43', NULL, NULL, NULL, NULL, 'PROTEIN EXORDIUM-LIKE 4', 240206),
(310572, 'PTHR31279:SF40', NULL, NULL, NULL, NULL, 'OS06G0220200 PROTEIN', 240206),
(310573, 'PTHR31279:SF61', NULL, NULL, NULL, NULL, '', 240206),
(310574, 'PTHR31279:SF64', NULL, NULL, NULL, NULL, 'BNAC02G00880D PROTEIN', 240206),
(310575, 'PTHR31279:SF42', NULL, NULL, NULL, NULL, 'PROTEIN EXORDIUM', 240206),
(310576, 'PTHR31279:SF41', NULL, NULL, NULL, NULL, 'OS02G0756200 PROTEIN', 240206),
(310577, 'PTHR31279', NULL, NULL, NULL, NULL, 'PROTEIN EXORDIUM-LIKE 5', 240206),
(310578, 'PTHR31279:SF70', NULL, NULL, NULL, NULL, 'PHI-1 PROTEIN', 240206),
(310579, 'PTHR39963:SF1', NULL, NULL, NULL, NULL, 'METHYLTRANSF_30 DOMAIN-CONTAINING PROTEIN', 240207),
(310580, 'PTHR39963', NULL, NULL, NULL, NULL, 'SLL0983 PROTEIN', 240207),
(310581, 'PTHR24423:SF624', NULL, NULL, NULL, NULL, 'ETHYLENE RECEPTOR 3', 240208),
(310582, 'PTHR24423:SF635', NULL, NULL, NULL, NULL, 'ETHYLENE RECEPTOR', 240208),
(310583, 'PTHR24423', NULL, NULL, NULL, NULL, 'TWO-COMPONENT SENSOR HISTIDINE KINASE', 240208),
(310584, 'PTHR24423:SF625', NULL, NULL, NULL, NULL, 'ETHYLENE RESPONSE SENSOR 1', 240208),
(310585, 'PTHR24423:SF636', NULL, NULL, NULL, NULL, 'ETHYLENE RECEPTOR', 240208),
(310586, 'PTHR24423:SF637', NULL, NULL, NULL, NULL, 'ETHYLENE RECEPTOR', 240208),
(310587, 'PTHR24423:SF615', NULL, NULL, NULL, NULL, 'ETHYLENE RECEPTOR 1', 240208);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(310588, 'PTHR24423:SF638', NULL, NULL, NULL, NULL, 'ETHYLENE RESPONSE SENSOR 2', 240208),
(310589, 'PTHR24423:SF627', NULL, NULL, NULL, NULL, 'ETHYLENE RECEPTOR 1', 240208),
(310590, 'PTHR24423:SF617', NULL, NULL, NULL, NULL, 'PROTEIN EIN4', 240208),
(310591, 'PTHR24423:SF628', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 240208),
(310592, 'PTHR24423:SF639', NULL, NULL, NULL, NULL, 'ETHYLENE RESPONSE SENSOR 2-RELATED', 240208),
(310593, 'PTHR24423:SF618', NULL, NULL, NULL, NULL, 'ETHYLENE RECEPTOR 4', 240208),
(310594, 'PTHR24423:SF629', NULL, NULL, NULL, NULL, 'PROTEIN EIN4', 240208),
(310595, 'PTHR24423:SF619', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE DOMAIN-CONTAINING PROTEIN', 240208),
(310596, 'PTHR24423:SF640', NULL, NULL, NULL, NULL, 'ETHYLENE RECEPTOR', 240208),
(310597, 'PTHR24423:SF630', NULL, NULL, NULL, NULL, 'GAF DOMAIN-CONTAINING PROTEIN', 240208),
(310598, 'PTHR24423:SF631', NULL, NULL, NULL, NULL, '', 240208),
(310599, 'PTHR24423:SF633', NULL, NULL, NULL, NULL, 'ETHYLENE RECEPTOR 2', 240208),
(310600, 'PTHR24423:SF622', NULL, NULL, NULL, NULL, 'ETHYLENE RECEPTOR', 240208),
(310601, 'PTHR24423:SF634', NULL, NULL, NULL, NULL, 'ETHYLENE RECEPTOR', 240208),
(310602, 'PTHR14429:SF5', NULL, NULL, NULL, NULL, 'AUTISM SUSCEPTIBILITY GENE 2 PROTEIN', 240209),
(310603, 'PTHR14429', NULL, NULL, NULL, NULL, 'FIBROSIN FAMILY MEMBER', 240209),
(310604, 'PTHR14429:SF22', NULL, NULL, NULL, NULL, 'AGAP013055-PA', 240209),
(310605, 'PTHR14429:SF20', NULL, NULL, NULL, NULL, 'FIBROSIN-1-LIKE PROTEIN', 240209),
(310606, 'PTHR14429:SF24', NULL, NULL, NULL, NULL, 'FIBROSIN', 240209),
(310607, 'PTHR28075:SF3', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240210),
(310608, 'PTHR28075', NULL, NULL, NULL, NULL, 'CHROMOSOME 16, WHOLE GENOME SHOTGUN SEQUENCE', 240210),
(310609, 'PTHR28075:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 16, WHOLE GENOME SHOTGUN SEQUENCE', 240210),
(310610, 'PTHR28075:SF2', NULL, NULL, NULL, NULL, '', 240210),
(310611, 'PTHR36811:SF2', NULL, NULL, NULL, NULL, 'OS08G0444440 PROTEIN', 240211),
(310612, 'PTHR36811:SF3', NULL, NULL, NULL, NULL, 'BNAC03G12770D PROTEIN', 240211),
(310613, 'PTHR36811', NULL, NULL, NULL, NULL, 'OS08G0444440 PROTEIN', 240211),
(310614, 'PTHR33972:SF3', NULL, NULL, NULL, NULL, 'OS06G0661500 PROTEIN', 240212),
(310615, 'PTHR33972:SF27', NULL, NULL, NULL, NULL, '', 240212),
(310616, 'PTHR33972:SF28', NULL, NULL, NULL, NULL, '', 240212),
(310617, 'PTHR33972:SF18', NULL, NULL, NULL, NULL, 'BNAC05G12850D PROTEIN', 240212),
(310618, 'PTHR33972:SF19', NULL, NULL, NULL, NULL, 'BNAA07G36090D PROTEIN', 240212),
(310619, 'PTHR33972:SF23', NULL, NULL, NULL, NULL, '', 240212),
(310620, 'PTHR33972:SF24', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240212),
(310621, 'PTHR33972:SF25', NULL, NULL, NULL, NULL, 'REPETITIVE MATRIX PROTEIN 2, PUTATIVE ISOFORM 1-RELATED', 240212),
(310622, 'PTHR33972:SF26', NULL, NULL, NULL, NULL, '', 240212),
(310623, 'PTHR33972:SF2', NULL, NULL, NULL, NULL, 'OS04G0606700 PROTEIN', 240212),
(310624, 'PTHR33972:SF20', NULL, NULL, NULL, NULL, 'BNAC07G15820D PROTEIN', 240212),
(310625, 'PTHR33972:SF22', NULL, NULL, NULL, NULL, 'OS08G0230000 PROTEIN', 240212),
(310626, 'PTHR33972', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240212),
(310627, 'PTHR12272:SF11', NULL, NULL, NULL, NULL, 'PAN2-PAN3 DEADENYLATION COMPLEX SUBUNIT PAN3', 240213),
(310628, 'PTHR12272', NULL, NULL, NULL, NULL, 'DEADENYLATION COMPLEX SUBUNIT PAN3', 240213),
(310629, 'PTHR12272:SF12', NULL, NULL, NULL, NULL, 'PAB-DEPENDENT POLY(A)-SPECIFIC RIBONUCLEASE SUBUNIT PAN3-LIKE', 240213),
(310630, 'PTHR37427:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG00435', 240214),
(310631, 'PTHR37427:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG09543', 240214),
(310632, 'PTHR37427', NULL, NULL, NULL, NULL, 'PROTEIN CBG20963-RELATED', 240214),
(310633, 'PTHR37427:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG20963', 240214),
(310634, 'PTHR47342:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PTST, CHLOROPLASTIC', 240215),
(310635, 'PTHR47342', NULL, NULL, NULL, NULL, 'PROTEIN PTST, CHLOROPLASTIC', 240215);
INSERT INTO "PUBLIC"."MODEL" VALUES
(310636, 'PTHR46270', NULL, NULL, NULL, NULL, 'ARMADILLO-TYPE FOLD-RELATED', 240216),
(310637, 'PTHR46270:SF2', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 240216),
(310638, 'PTHR46270:SF5', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 240216),
(310639, 'PTHR38564:SF2', NULL, NULL, NULL, NULL, 'SI:CH73-250A16.5', 240217),
(310640, 'PTHR38564:SF1', NULL, NULL, NULL, NULL, '', 240217),
(310641, 'PTHR38564', NULL, NULL, NULL, NULL, 'SI:CH73-250A16.5-RELATED', 240217),
(310642, 'PTHR47061', NULL, NULL, NULL, NULL, 'LYR MOTIF-CONTAINING PROTEIN 9', 240218),
(310643, 'PTHR47061:SF1', NULL, NULL, NULL, NULL, 'LYR MOTIF-CONTAINING PROTEIN 9', 240218),
(310644, 'PTHR33876:SF3', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY NICKEL-TRANSPORT FAMILY PROTEIN', 240219),
(310645, 'PTHR33876', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', 240219),
(310646, 'PTHR33876:SF9', NULL, NULL, NULL, NULL, 'NICKEL-TRANSPORT FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 240219),
(310647, 'PTHR33876:SF4', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240219),
(310648, 'PTHR33876:SF5', NULL, NULL, NULL, NULL, 'DSBD_2 DOMAIN-CONTAINING PROTEIN', 240219),
(310649, 'PTHR13720:SF39', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 240220),
(310650, 'PTHR13720:SF18', NULL, NULL, NULL, NULL, 'FI23230P1', 240220),
(310651, 'PTHR13720:SF15', NULL, NULL, NULL, NULL, 'ECHINODERM MICROTUBULE-ASSOCIATED PROTEIN-LIKE 3', 240220),
(310652, 'PTHR13720:SF16', NULL, NULL, NULL, NULL, 'ECHINODERM MICROTUBULE-ASSOCIATED PROTEIN-LIKE 5', 240220),
(310653, 'PTHR13720:SF57', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 240220),
(310654, 'PTHR13720:SF13', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 251', 240220),
(310655, 'PTHR13720:SF24', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 90', 240220),
(310656, 'PTHR13720:SF58', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 240220),
(310657, 'PTHR13720:SF14', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 52', 240220),
(310658, 'PTHR13720:SF22', NULL, NULL, NULL, NULL, 'ECHINODERM MICROTUBULE-ASSOCIATED PROTEIN-LIKE 1', 240220),
(310659, 'PTHR13720:SF33', NULL, NULL, NULL, NULL, 'CALMODULIN', 240220),
(310660, 'PTHR13720:SF11', NULL, NULL, NULL, NULL, 'ECHINODERM MICROTUBULE-ASSOCIATED PROTEIN-LIKE 4', 240220),
(310661, 'PTHR13720:SF55', NULL, NULL, NULL, NULL, 'ECHINODERM MICROTUBULE-ASSOCIATED PROTEIN-LIKE CG42247', 240220),
(310662, 'PTHR13720:SF56', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 240220),
(310663, 'PTHR13720:SF53', NULL, NULL, NULL, NULL, '', 240220),
(310664, 'PTHR13720:SF40', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 54', 240220),
(310665, 'PTHR13720:SF52', NULL, NULL, NULL, NULL, 'ECHINODERM MICROTUBULE-ASSOCIATED PROTEIN-LIKE 6', 240220),
(310666, 'PTHR13720:SF50', NULL, NULL, NULL, NULL, 'ECHINODERM MICROTUBULE-ASSOCIATED PROTEIN-LIKE 2', 240220),
(310667, 'PTHR13720', NULL, NULL, NULL, NULL, 'WD-40 REPEAT PROTEIN', 240220),
(310668, 'PTHR14102:SF11', NULL, NULL, NULL, NULL, 'LD29223P', 240221),
(310669, 'PTHR14102:SF12', NULL, NULL, NULL, NULL, 'CDNA SEQUENCE BC034090', 240221),
(310670, 'PTHR14102:SF15', NULL, NULL, NULL, NULL, 'SI:CH211-13F8.1', 240221),
(310671, 'PTHR14102:SF14', NULL, NULL, NULL, NULL, 'PROTEIN CBG16414', 240221),
(310672, 'PTHR14102:SF4', NULL, NULL, NULL, NULL, 'PARTITIONING DEFECTIVE 6 HOMOLOG BETA', 240221),
(310673, 'PTHR14102:SF3', NULL, NULL, NULL, NULL, 'PARTITIONING DEFECTIVE 6 HOMOLOG GAMMA', 240221),
(310674, 'PTHR14102', NULL, NULL, NULL, NULL, 'PAR-6-RELATED', 240221),
(310675, 'PTHR14102:SF9', NULL, NULL, NULL, NULL, 'PARTITIONING DEFECTIVE 6 HOMOLOG ALPHA', 240221),
(310676, 'PTHR15382:SF7', NULL, NULL, NULL, NULL, 'CANOPY B', 240222),
(310677, 'PTHR15382:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CANOPY HOMOLOG 4', 240222),
(310678, 'PTHR15382', NULL, NULL, NULL, NULL, 'CTG4A-RELATED', 240222),
(310679, 'PTHR15382:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CANOPY HOMOLOG 3', 240222);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(310680, 'PTHR39598', NULL, NULL, NULL, NULL, 'AUSTINOL SYNTHESIS PROTEIN F-RELATED', 240223),
(310681, 'PTHR39598:SF1', NULL, NULL, NULL, NULL, 'AUSTINOL SYNTHESIS PROTEIN F-RELATED', 240223),
(310682, 'PTHR13042:SF11', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 240224),
(310683, 'PTHR13042', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE PROTEIN 5', 240224),
(310684, 'PTHR13042:SF7', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE PROTEIN 5', 240224),
(310685, 'PTHR13042:SF3', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE PROTEIN 5', 240224),
(310686, 'PTHR13042:SF6', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE PROTEIN 5', 240224),
(310687, 'PTHR13042:SF0', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE PROTEIN 5', 240224),
(310688, 'PTHR13042:SF14', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE SUPERFAMILY PROTEIN', 240224),
(310689, 'PTHR33598:SF10', NULL, NULL, NULL, NULL, 'HOP-INTERACTING PROTEIN THI043', 240225),
(310690, 'PTHR33598:SF2', NULL, NULL, NULL, NULL, 'MAR-BINDING FILAMENT-LIKE PROTEIN', 240225),
(310691, 'PTHR33598:SF12', NULL, NULL, NULL, NULL, 'OS12G0581700 PROTEIN', 240225),
(310692, 'PTHR33598', NULL, NULL, NULL, NULL, 'OS02G0833400 PROTEIN', 240225),
(310693, 'PTHR33598:SF4', NULL, NULL, NULL, NULL, 'OS02G0833400 PROTEIN', 240225),
(310694, 'PTHR30426', NULL, NULL, NULL, NULL, '4-HYDROXY-3-METHYLBUT-2-ENYL DIPHOSPHATE REDUCTASE', 240226),
(310695, 'PTHR30426:SF0', NULL, NULL, NULL, NULL, '4-HYDROXY-3-METHYLBUT-2-ENYL DIPHOSPHATE REDUCTASE', 240226),
(310696, 'PTHR23419', NULL, NULL, NULL, NULL, 'DIVALENT CATION TOLERANCE CUTA-RELATED', 240227),
(310697, 'PTHR23419:SF8', NULL, NULL, NULL, NULL, 'FI09726P', 240227),
(310698, 'PTHR23419:SF11', NULL, NULL, NULL, NULL, 'PROTEIN CUTA 1, CHLOROPLASTIC', 240227),
(310699, 'PTHR23419:SF2', NULL, NULL, NULL, NULL, 'CUTA DIVALENT CATION TOLERANCE HOMOLOG-LIKE', 240227),
(310700, 'PTHR23419:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CUTA', 240227),
(310701, 'PTHR37335:SF1', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1700003F12 GENE', 240228),
(310702, 'PTHR37335', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1700003F12 GENE', 240228),
(310703, 'PTHR46944', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 33', 240229),
(310704, 'PTHR46944:SF1', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 33', 240229),
(310705, 'PTHR45427', NULL, NULL, NULL, NULL, 'MUCIN-15', 240230),
(310706, 'PTHR45427:SF1', NULL, NULL, NULL, NULL, 'MUCIN-15', 240230),
(310707, 'PTHR38685:SF1', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN ZIPA', 240231),
(310708, 'PTHR38685', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN ZIPA', 240231),
(310709, 'PTHR46934:SF1', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 240232),
(310710, 'PTHR46934', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN-RELATED', 240232),
(310711, 'PTHR46934:SF10', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 240232),
(310712, 'PTHR46934:SF8', NULL, NULL, NULL, NULL, 'OS02G0813200 PROTEIN', 240232),
(310713, 'PTHR46934:SF9', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 240232),
(310714, 'PTHR46934:SF6', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 240232),
(310715, 'PTHR46934:SF5', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 240232),
(310716, 'PTHR20938:SF0', NULL, NULL, NULL, NULL, 'INTEGRATOR COMPLEX SUBUNIT 4', 240233),
(310717, 'PTHR20938', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 240233),
(310718, 'PTHR10117:SF79', NULL, NULL, NULL, NULL, 'ION_TRANS DOMAIN-CONTAINING PROTEIN', 240234),
(310719, 'PTHR10117:SF56', NULL, NULL, NULL, NULL, 'SHORT TRANSIENT RECEPTOR POTENTIAL CHANNEL 1', 240234),
(310720, 'PTHR10117:SF9', NULL, NULL, NULL, NULL, 'SHORT TRANSIENT RECEPTOR POTENTIAL CHANNEL 7', 240234),
(310721, 'PTHR10117:SF8', NULL, NULL, NULL, NULL, 'SHORT TRANSIENT RECEPTOR POTENTIAL CHANNEL 3', 240234),
(310722, 'PTHR10117:SF7', NULL, NULL, NULL, NULL, 'SHORT TRANSIENT RECEPTOR POTENTIAL CHANNEL 6', 240234),
(310723, 'PTHR10117:SF25', NULL, NULL, NULL, NULL, 'SHORT TRANSIENT RECEPTOR POTENTIAL CHANNEL 4', 240234);
INSERT INTO "PUBLIC"."MODEL" VALUES
(310724, 'PTHR10117:SF47', NULL, NULL, NULL, NULL, 'TRANSIENT-RECEPTOR-POTENTIAL-LIKE PROTEIN', 240234),
(310725, 'PTHR10117:SF6', NULL, NULL, NULL, NULL, 'SHORT TRANSIENT RECEPTOR POTENTIAL CHANNEL 2', 240234),
(310726, 'PTHR10117:SF76', NULL, NULL, NULL, NULL, 'SHORT TRANSIENT RECEPTOR POTENTIAL CHANNEL 5', 240234),
(310727, 'PTHR10117:SF54', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL-GAMMA PROTEIN', 240234),
(310728, 'PTHR10117', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL CHANNEL', 240234),
(310729, 'PTHR10117:SF51', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL PROTEIN', 240234),
(310730, 'PTHR10117:SF50', NULL, NULL, NULL, NULL, 'TRP HOMOLOGOUS CATION CHANNEL PROTEIN', 240234),
(310731, 'PTHR10117:SF80', NULL, NULL, NULL, NULL, 'TRANSIENT-RECEPTOR-POTENTIAL-LIKE PROTEIN', 240234),
(310732, 'PTHR38702', NULL, NULL, NULL, NULL, '', 240235),
(310733, 'PTHR38702:SF1', NULL, NULL, NULL, NULL, '', 240235),
(310734, 'PTHR13021', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR ISY1', 240236),
(310735, 'PTHR13021:SF8', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR ISY1 HOMOLOG', 240236),
(310736, 'PTHR46963:SF3', NULL, NULL, NULL, NULL, 'DUF3504 DOMAIN-CONTAINING PROTEIN', 240237),
(310737, 'PTHR46963:SF1', NULL, NULL, NULL, NULL, 'SIMILAR TO RIKEN CDNA E130308A19', 240237),
(310738, 'PTHR46963:SF2', NULL, NULL, NULL, NULL, 'SI:CH211-126I22.5', 240237),
(310739, 'PTHR46963', NULL, NULL, NULL, NULL, 'SIMILAR TO RIKEN CDNA E130308A19', 240237),
(310740, 'PTHR12316:SF19', NULL, NULL, NULL, NULL, 'NINJURIN-1', 240238),
(310741, 'PTHR12316', NULL, NULL, NULL, NULL, 'NINJURIN-RELATED', 240238),
(310742, 'PTHR12316:SF26', NULL, NULL, NULL, NULL, 'HAUS AUGMIN-LIKE COMPLEX, SUBUNIT 7', 240238),
(310743, 'PTHR12316:SF1', NULL, NULL, NULL, NULL, 'NINJURIN-B', 240238),
(310744, 'PTHR12316:SF27', NULL, NULL, NULL, NULL, 'NINJURIN-2-LIKE', 240238),
(310745, 'PTHR12316:SF17', NULL, NULL, NULL, NULL, 'NINJURIN C, ISOFORM D', 240238),
(310746, 'PTHR12316:SF24', NULL, NULL, NULL, NULL, 'NINJURIN-2', 240238),
(310747, 'PTHR12316:SF20', NULL, NULL, NULL, NULL, 'NINJURIN-A', 240238),
(310748, 'PTHR10644:SF3', NULL, NULL, NULL, NULL, 'DNA DAMAGE-BINDING PROTEIN 1', 240239),
(310749, 'PTHR10644:SF2', NULL, NULL, NULL, NULL, 'CLEAVAGE AND POLYADENYLATION SPECIFICITY FACTOR SUBUNIT 1', 240239),
(310750, 'PTHR10644:SF17', NULL, NULL, NULL, NULL, '', 240239),
(310751, 'PTHR10644', NULL, NULL, NULL, NULL, 'DNA REPAIR/RNA PROCESSING CPSF FAMILY', 240239),
(310752, 'PTHR10644:SF1', NULL, NULL, NULL, NULL, 'SPLICING FACTOR 3B SUBUNIT 3', 240239),
(310753, 'PTHR10644:SF14', NULL, NULL, NULL, NULL, 'MMS1_N DOMAIN-CONTAINING PROTEIN', 240239),
(310754, 'PTHR10644:SF6', NULL, NULL, NULL, NULL, 'CLEAVAGE AND POLYADENYLATION SPECIFICITY FACTOR (CPSF) A SUBUNIT PROTEIN', 240239),
(310755, 'PTHR10644:SF23', NULL, NULL, NULL, NULL, 'MMS1_N DOMAIN-CONTAINING PROTEIN', 240239),
(310756, 'PTHR10644:SF22', NULL, NULL, NULL, NULL, 'CHROMATIN MODIFICATION-RELATED PROTEIN RIK1', 240239),
(310757, 'PTHR10644:SF21', NULL, NULL, NULL, NULL, 'MMS1_N DOMAIN-CONTAINING PROTEIN', 240239),
(310758, 'PTHR10644:SF20', NULL, NULL, NULL, NULL, 'DNA DAMAGE-BINDING PROTEIN 1B', 240239),
(310759, 'PTHR48058:SF18', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE BAM3', 240240),
(310760, 'PTHR48058:SF26', NULL, NULL, NULL, NULL, 'LRR AMINO-TERMINAL DOMAIN PROTEIN', 240240),
(310761, 'PTHR48058:SF6', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE FAMILY PROTEIN / LRR FAMILY PROTEIN', 240240),
(310762, 'PTHR48058:SF19', NULL, NULL, NULL, NULL, 'OS04G0122000 PROTEIN', 240240),
(310763, 'PTHR48058:SF20', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 2', 240240),
(310764, 'PTHR48058:SF21', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 240240),
(310765, 'PTHR48058', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE FLS2-RELATED', 240240),
(310766, 'PTHR48058:SF24', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 240240); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(310767, 'PTHR48058:SF25', NULL, NULL, NULL, NULL, 'RESISTANCE FAMILY PROTEIN / LRR FAMILY PROTEIN, PUTATIVE-RELATED', 240240),
(310768, 'PTHR48058:SF22', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 240240),
(310769, 'PTHR48058:SF23', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE FAMILY PROTEIN', 240240),
(310770, 'PTHR37361', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE III DOMAIN-CONTAINING PROTEIN 9', 240241),
(310771, 'PTHR37361:SF2', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE III DOMAIN-CONTAINING PROTEIN 9', 240241),
(310772, 'PTHR37361:SF4', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE-III DOMAIN-CONTAINING PROTEIN', 240241),
(310773, 'PTHR46481', NULL, NULL, NULL, NULL, 'ZINC FINGER BED DOMAIN-CONTAINING PROTEIN 4', 240242),
(310774, 'PTHR46481:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER BED DOMAIN-CONTAINING PROTEIN 4', 240242),
(310775, 'PTHR31512', NULL, NULL, NULL, NULL, 'GENE 12569-RELATED', 240243),
(310776, 'PTHR31512:SF0', NULL, NULL, NULL, NULL, 'NOVEL PROTEIN-RELATED', 240243),
(310777, 'PTHR31512:SF1', NULL, NULL, NULL, NULL, 'CDNA SEQUENCE BC049762', 240243),
(310778, 'PTHR31512:SF2', NULL, NULL, NULL, NULL, 'MYB/SANT DNA-BINDING DOMAIN-CONTAINING 5', 240243),
(310779, 'PTHR47386:SF1', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 1B', 240244),
(310780, 'PTHR47386', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 1B', 240244),
(310781, 'PTHR47360', NULL, NULL, NULL, NULL, 'MUREIN DD-ENDOPEPTIDASE MEPS/MUREIN LD-CARBOXYPEPTIDASE', 240245),
(310782, 'PTHR47360:SF3', NULL, NULL, NULL, NULL, 'MUREIN DD-ENDOPEPTIDASE MEPS/MUREIN LD-CARBOXYPEPTIDASE', 240245),
(310783, 'PTHR47360:SF1', NULL, NULL, NULL, NULL, 'ENDOPEPTIDASE NLPC-RELATED', 240245),
(310784, 'PTHR37781', NULL, NULL, NULL, NULL, 'TFIIH COMPLEX SUBUNIT', 240246),
(310785, 'PTHR37781:SF1', NULL, NULL, NULL, NULL, 'TFIIH COMPLEX SUBUNIT', 240246),
(310786, 'PTHR33868:SF13', NULL, NULL, NULL, NULL, 'BNAA04G27190D PROTEIN', 240247),
(310787, 'PTHR33868:SF10', NULL, NULL, NULL, NULL, 'OS08G0483100 PROTEIN', 240247),
(310788, 'PTHR33868:SF11', NULL, NULL, NULL, NULL, 'BNAC05G00690D PROTEIN', 240247),
(310789, 'PTHR33868:SF16', NULL, NULL, NULL, NULL, '', 240247),
(310790, 'PTHR33868:SF17', NULL, NULL, NULL, NULL, 'OS08G0400300 PROTEIN', 240247),
(310791, 'PTHR33868:SF14', NULL, NULL, NULL, NULL, 'BNACNNG08610D PROTEIN', 240247),
(310792, 'PTHR33868', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240247),
(310793, 'PTHR33868:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240247),
(310794, 'PTHR33868:SF18', NULL, NULL, NULL, NULL, '', 240247),
(310795, 'PTHR33868:SF19', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 240247),
(310796, 'PTHR16134', NULL, NULL, NULL, NULL, 'F-BOX/TPR REPEAT PROTEIN POF3', 240248),
(310797, 'PTHR16134:SF141', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 8', 240248),
(310798, 'PTHR16134:SF99', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT INHIBITOR RESPONSE 1-LIKE', 240248),
(310799, 'PTHR16134:SF55', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 19-RELATED', 240248),
(310800, 'PTHR16134:SF142', NULL, NULL, NULL, NULL, 'S-PHASE KINASE-ASSOCIATED PROTEIN 2, ISOFORM A', 240248),
(310801, 'PTHR16134:SF143', NULL, NULL, NULL, NULL, 'AGAP004167-PA', 240248),
(310802, 'PTHR16134:SF144', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240248),
(310803, 'PTHR16134:SF10', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SKIP19', 240248),
(310804, 'PTHR16134:SF98', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240248),
(310805, 'PTHR16134:SF145', NULL, NULL, NULL, NULL, 'TRANSPORT INHIBITOR RESPONSE 1-LIKE PROTEIN-RELATED', 240248),
(310806, 'PTHR16134:SF95', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240248),
(310807, 'PTHR16134:SF93', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN FBW2-LIKE', 240248),
(310808, 'PTHR16134:SF103', NULL, NULL, NULL, NULL, 'BNAA03G56600D PROTEIN', 240248),
(310809, 'PTHR16134:SF94', NULL, NULL, NULL, NULL, 'OS06G0219700 PROTEIN', 240248),
(310810, 'PTHR16134:SF50', NULL, NULL, NULL, NULL, 'GRR1-LIKE PROTEIN 1', 240248);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(310811, 'PTHR16134:SF91', NULL, NULL, NULL, NULL, 'BNAA03G50430D PROTEIN', 240248),
(310812, 'PTHR16134:SF92', NULL, NULL, NULL, NULL, 'TRANSPORT INHIBITOR RESPONSE 1-LIKE PROTEIN-RELATED', 240248),
(310813, 'PTHR16134:SF107', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240248),
(310814, 'PTHR16134:SF90', NULL, NULL, NULL, NULL, 'OS02G0317500 PROTEIN', 240248),
(310815, 'PTHR16134:SF109', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240248),
(310816, 'PTHR16134:SF19', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 18', 240248),
(310817, 'PTHR16134:SF18', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 17', 240248),
(310818, 'PTHR16134:SF59', NULL, NULL, NULL, NULL, 'TRANSPORT INHIBITOR RESPONSE 1-LIKE PROTEIN OS11G0515500', 240248),
(310819, 'PTHR16134:SF57', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN FBX14', 240248),
(310820, 'PTHR16134:SF66', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT INHIBITOR RESPONSE 1', 240248),
(310821, 'PTHR16134:SF110', NULL, NULL, NULL, NULL, 'BNAA03G50450D PROTEIN', 240248),
(310822, 'PTHR16134:SF111', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN FBW2', 240248),
(310823, 'PTHR16134:SF63', NULL, NULL, NULL, NULL, 'OS08G0195900 PROTEIN', 240248),
(310824, 'PTHR16134:SF115', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240248),
(310825, 'PTHR16134:SF118', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN, LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 240248),
(310826, 'PTHR16134:SF119', NULL, NULL, NULL, NULL, 'AT02038P', 240248),
(310827, 'PTHR16134:SF4', NULL, NULL, NULL, NULL, 'OS06G0166000 PROTEIN', 240248),
(310828, 'PTHR16134:SF5', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 3', 240248),
(310829, 'PTHR16134:SF2', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 21-RELATED', 240248),
(310830, 'PTHR16134:SF28', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 6', 240248),
(310831, 'PTHR16134:SF3', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 12', 240248),
(310832, 'PTHR16134:SF1', NULL, NULL, NULL, NULL, 'F-BOX AND LEUCINE-RICH PROTEIN 22', 240248),
(310833, 'PTHR16134:SF77', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240248),
(310834, 'PTHR16134:SF120', NULL, NULL, NULL, NULL, 'CORONATINE-INSENSITIVE PROTEIN HOMOLOG 1B', 240248),
(310835, 'PTHR16134:SF32', NULL, NULL, NULL, NULL, 'S-PHASE KINASE-ASSOCIATED PROTEIN 2', 240248),
(310836, 'PTHR16134:SF73', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240248),
(310837, 'PTHR16134:SF125', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN FBX14', 240248),
(310838, 'PTHR16134:SF70', NULL, NULL, NULL, NULL, 'F-BOX SKIP17-LIKE PROTEIN-RELATED', 240248),
(310839, 'PTHR16134:SF129', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240248),
(310840, 'PTHR16134:SF39', NULL, NULL, NULL, NULL, '', 240248),
(310841, 'PTHR16134:SF79', NULL, NULL, NULL, NULL, 'TIR1', 240248),
(310842, 'PTHR16134:SF36', NULL, NULL, NULL, NULL, 'TRANSPORT INHIBITOR RESPONSE 1-LIKE PROTEIN', 240248),
(310843, 'PTHR16134:SF45', NULL, NULL, NULL, NULL, 'PROTEIN AUXIN SIGNALING F-BOX 3', 240248),
(310844, 'PTHR16134:SF132', NULL, NULL, NULL, NULL, 'PROTEIN AUXIN SIGNALING F-BOX 2', 240248),
(310845, 'PTHR16134:SF43', NULL, NULL, NULL, NULL, 'CORONATINE-INSENSITIVE PROTEIN 1', 240248),
(310846, 'PTHR16134:SF134', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240248),
(310847, 'PTHR16134:SF41', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240248),
(310848, 'PTHR16134:SF135', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240248),
(310849, 'PTHR16134:SF136', NULL, NULL, NULL, NULL, 'OS04G0448700 PROTEIN', 240248),
(310850, 'PTHR16134:SF137', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240248),
(310851, 'PTHR16134:SF80', NULL, NULL, NULL, NULL, 'BNAC03G77500D PROTEIN', 240248),
(310852, 'PTHR16134:SF138', NULL, NULL, NULL, NULL, 'GH10766P', 240248),
(310853, 'PTHR16134:SF139', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_5G02120)', 240248),
(310854, 'PTHR16134:SF140', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240248);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(310855, 'PTHR10185:SF9', NULL, NULL, NULL, NULL, 'INACTIVE PHOSPHOLIPASE D5', 240249),
(310856, 'PTHR10185:SF8', NULL, NULL, NULL, NULL, '5''-3'' EXONUCLEASE PLD4', 240249),
(310857, 'PTHR10185:SF17', NULL, NULL, NULL, NULL, 'GM01519P-RELATED', 240249),
(310858, 'PTHR10185:SF16', NULL, NULL, NULL, NULL, '5''-3'' EXONUCLEASE PLD3', 240249),
(310859, 'PTHR10185:SF26', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D FAMILY, MEMBER 7', 240249),
(310860, 'PTHR10185:SF15', NULL, NULL, NULL, NULL, 'PROTEIN CBG13083', 240249),
(310861, 'PTHR10185:SF25', NULL, NULL, NULL, NULL, '', 240249),
(310862, 'PTHR10185:SF12', NULL, NULL, NULL, NULL, 'PROTEIN CBG09383', 240249),
(310863, 'PTHR10185', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D - RELATED', 240249),
(310864, 'PTHR14986', NULL, NULL, NULL, NULL, 'RURM1 PROTEIN', 240250),
(310865, 'PTHR14986:SF4', NULL, NULL, NULL, NULL, 'UBIQUITIN-RELATED MODIFIER 1', 240250),
(310866, 'PTHR36806:SF1', NULL, NULL, NULL, NULL, 'ADENINE PHOSPHORIBOSYLTRANSFERASE', 240251),
(310867, 'PTHR36806', NULL, NULL, NULL, NULL, 'ADENINE PHOSPHORIBOSYLTRANSFERASE', 240251),
(310868, 'PTHR10724', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S1', 240252),
(310869, 'PTHR10724:SF7', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S1, CHLOROPLASTIC', 240252),
(310870, 'PTHR10724:SF10', NULL, NULL, NULL, NULL, 'S1 RNA-BINDING DOMAIN-CONTAINING PROTEIN 1', 240252),
(310871, 'PTHR10724:SF11', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S1, CHLOROPLASTIC', 240252),
(310872, 'PTHR10724:SF12', NULL, NULL, NULL, NULL, 'BNAA09G51670D PROTEIN', 240252),
(310873, 'PTHR14339:SF10', NULL, NULL, NULL, NULL, 'VASCULIN-LIKE PROTEIN 1', 240253),
(310874, 'PTHR14339:SF11', NULL, NULL, NULL, NULL, 'VASCULIN', 240253),
(310875, 'PTHR14339:SF12', NULL, NULL, NULL, NULL, '', 240253),
(310876, 'PTHR14339', NULL, NULL, NULL, NULL, 'VASCULIN', 240253),
(310877, 'PTHR47522:SF2', NULL, NULL, NULL, NULL, 'PROTEIN SALVADOR HOMOLOG 1', 240254),
(310878, 'PTHR47522', NULL, NULL, NULL, NULL, 'SALVADOR FAMILY WW DOMAIN-CONTAINING PROTEIN 1', 240254),
(310879, 'PTHR43848:SF2', NULL, NULL, NULL, NULL, 'PUTRESCINE TRANSPORT SYSTEM PERMEASE PROTEIN POTI', 240255),
(310880, 'PTHR43848:SF5', NULL, NULL, NULL, NULL, 'SPERMIDINE/PUTRESCINE TRANSPORT SYSTEM PERMEASE PROTEIN POTC', 240255),
(310881, 'PTHR43848', NULL, NULL, NULL, NULL, 'PUTRESCINE TRANSPORT SYSTEM PERMEASE PROTEIN POTI', 240255),
(310882, 'PTHR34135:SF4', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G14420)-RELATED', 240256),
(310883, 'PTHR34135:SF3', NULL, NULL, NULL, NULL, 'PNEUMOCOCCAL VACCINE ANTIGEN A', 240256),
(310884, 'PTHR34135:SF2', NULL, NULL, NULL, NULL, 'LYSOZYME', 240256),
(310885, 'PTHR34135:SF1', NULL, NULL, NULL, NULL, 'N-ACETYLMURAMOYL-L-ALANINE AMIDASE', 240256),
(310886, 'PTHR34135', NULL, NULL, NULL, NULL, 'LYSOZYME', 240256),
(310887, 'PTHR33694:SF1', NULL, NULL, NULL, NULL, 'UDP-3-O-ACYL-N-ACETYLGLUCOSAMINE DEACETYLASE 1, MITOCHONDRIAL-RELATED', 240257),
(310888, 'PTHR33694', NULL, NULL, NULL, NULL, 'UDP-3-O-ACYL-N-ACETYLGLUCOSAMINE DEACETYLASE 1, MITOCHONDRIAL-RELATED', 240257),
(310889, 'PTHR43821', NULL, NULL, NULL, NULL, 'NAD(P)H NITROREDUCTASE YDJA-RELATED', 240258),
(310890, 'PTHR43821:SF1', NULL, NULL, NULL, NULL, 'NAD(P)H NITROREDUCTASE YDJA-RELATED', 240258),
(310891, 'PTHR47739', NULL, NULL, NULL, NULL, 'TRNA1(VAL) (ADENINE(37)-N6)-METHYLTRANSFERASE', 240259),
(310892, 'PTHR47739:SF1', NULL, NULL, NULL, NULL, 'TRNA1(VAL) (ADENINE(37)-N6)-METHYLTRANSFERASE', 240259),
(310893, 'PTHR34796:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240260),
(310894, 'PTHR34796', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240260),
(310895, 'PTHR10942:SF49', NULL, NULL, NULL, NULL, 'METALLOENDOPEPTIDASE/ZINC ION-BINDING PROTEIN', 240261),
(310896, 'PTHR10942:SF6', NULL, NULL, NULL, NULL, 'LEISHMANOLYSIN-LIKE PEPTIDASE 2', 240261),
(310897, 'PTHR10942', NULL, NULL, NULL, NULL, 'LEISHMANOLYSIN-LIKE PEPTIDASE', 240261),
(310898, 'PTHR10942:SF51', NULL, NULL, NULL, NULL, 'IPT/TIG DOMAIN-CONTAINING PROTEIN', 240261);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(310899, 'PTHR10942:SF44', NULL, NULL, NULL, NULL, 'LEISHMANOLYSIN-LIKE PEPTIDASE', 240261),
(310900, 'PTHR10942:SF11', NULL, NULL, NULL, NULL, 'GP63', 240261),
(310901, 'PTHR10942:SF0', NULL, NULL, NULL, NULL, 'LEISHMANOLYSIN-LIKE PEPTIDASE', 240261),
(310902, 'PTHR10942:SF46', NULL, NULL, NULL, NULL, '', 240261),
(310903, 'PTHR10942:SF47', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN, PEPTIDASE M8, LEISHMANOLYSIN, FRIZZLED DOMAIN PROTEIN-RELATED', 240261),
(310904, 'PTHR10942:SF25', NULL, NULL, NULL, NULL, '', 240261),
(310905, 'PTHR23511:SF41', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 240262),
(310906, 'PTHR23511:SF11', NULL, NULL, NULL, NULL, 'SYNAPTIC VESICLE GLYCOPROTEIN 2A', 240262),
(310907, 'PTHR23511:SF33', NULL, NULL, NULL, NULL, 'BNAA09G16510D PROTEIN', 240262),
(310908, 'PTHR23511:SF40', NULL, NULL, NULL, NULL, 'SYNAPTIC VESICLE GLYCOPROTEIN 2', 240262),
(310909, 'PTHR23511:SF38', NULL, NULL, NULL, NULL, 'SYNAPTIC VESICLE 2-RELATED PROTEIN-LIKE PROTEIN', 240262),
(310910, 'PTHR23511:SF3', NULL, NULL, NULL, NULL, 'CHROMOSOME 19, WHOLE GENOME SHOTGUN SEQUENCE', 240262),
(310911, 'PTHR23511:SF4', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 240262),
(310912, 'PTHR23511:SF39', NULL, NULL, NULL, NULL, 'SYNAPTIC VESICLE GLYCOPROTEIN 2BA', 240262),
(310913, 'PTHR23511', NULL, NULL, NULL, NULL, 'SYNAPTIC VESICLE GLYCOPROTEIN 2', 240262),
(310914, 'PTHR23511:SF5', NULL, NULL, NULL, NULL, '3-(3-HYDROXY-PHENYL)PROPIONATE TRANSPORTER-RELATED', 240262),
(310915, 'PTHR23511:SF6', NULL, NULL, NULL, NULL, 'SYNAPTIC VESICLE GLYCOPROTEIN 2C', 240262),
(310916, 'PTHR23511:SF34', NULL, NULL, NULL, NULL, 'LP17136P', 240262),
(310917, 'PTHR23511:SF12', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G01740)-RELATED', 240262),
(310918, 'PTHR23511:SF35', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 240262),
(310919, 'PTHR23511:SF36', NULL, NULL, NULL, NULL, 'EG:BACR7A4.13 PROTEIN-RELATED', 240262),
(310920, 'PTHR23511:SF14', NULL, NULL, NULL, NULL, 'METABOLITE TRANSPORT PROTEIN YAAU-RELATED', 240262),
(310921, 'PTHR23511:SF2', NULL, NULL, NULL, NULL, 'SYNAPTIC VESICLE GLYCOPROTEIN 2B', 240262),
(310922, 'PTHR23511:SF37', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 240262),
(310923, 'PTHR13119', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEI', 240263),
(310924, 'PTHR13119:SF22', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 6', 240263),
(310925, 'PTHR13119:SF12', NULL, NULL, NULL, NULL, 'PROTEIN SUPPRESSOR OF SABLE', 240263),
(310926, 'PTHR13119:SF23', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 4', 240263),
(310927, 'PTHR13119:SF32', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 8', 240263),
(310928, 'PTHR12696:SF0', NULL, NULL, NULL, NULL, 'CULLIN-ASSOCIATED NEDD8-DISSOCIATED PROTEIN 1', 240264),
(310929, 'PTHR12696:SF3', NULL, NULL, NULL, NULL, 'TIP120 DOMAIN-CONTAINING PROTEIN', 240264),
(310930, 'PTHR12696', NULL, NULL, NULL, NULL, 'TIP120', 240264),
(310931, 'PTHR12696:SF1', NULL, NULL, NULL, NULL, 'CULLIN-ASSOCIATED NEDD8-DISSOCIATED PROTEIN 1', 240264),
(310932, 'PTHR12696:SF2', NULL, NULL, NULL, NULL, 'CULLIN-ASSOCIATED NEDD8-DISSOCIATED PROTEIN 2', 240264),
(310933, 'PTHR35475:SF3', NULL, NULL, NULL, NULL, '', 240265),
(310934, 'PTHR35475', NULL, NULL, NULL, NULL, 'WD REPEAT PROTEIN', 240265),
(310935, 'PTHR35475:SF1', NULL, NULL, NULL, NULL, 'WD REPEAT PROTEIN', 240265),
(310936, 'PTHR35475:SF2', NULL, NULL, NULL, NULL, 'OS11G0167400 PROTEIN', 240265),
(310937, 'PTHR43196:SF1', NULL, NULL, NULL, NULL, 'SULFATE ADENYLYLTRANSFERASE SUBUNIT 2', 240266),
(310938, 'PTHR43196', NULL, NULL, NULL, NULL, 'SULFATE ADENYLYLTRANSFERASE SUBUNIT 2', 240266),
(310939, 'PTHR38120', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240267),
(310940, 'PTHR38120:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240267),
(310941, 'PTHR38519', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 240268),
(310942, 'PTHR38519:SF6', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 240268);
INSERT INTO "PUBLIC"."MODEL" VALUES
(310943, 'PTHR38519:SF5', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 240268),
(310944, 'PTHR38519:SF3', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', 240268),
(310945, 'PTHR37839', NULL, NULL, NULL, NULL, 'NA(+)-TRANSLOCATING NADH-QUINONE REDUCTASE SUBUNIT A', 240269),
(310946, 'PTHR37839:SF1', NULL, NULL, NULL, NULL, 'NA(+)-TRANSLOCATING NADH-QUINONE REDUCTASE SUBUNIT A', 240269),
(310947, 'PTHR36899:SF5', NULL, NULL, NULL, NULL, 'BNAC08G40880D PROTEIN', 240270),
(310948, 'PTHR36899:SF3', NULL, NULL, NULL, NULL, 'F13K23.8 PROTEIN', 240270),
(310949, 'PTHR36899', NULL, NULL, NULL, NULL, 'OS04G0395700 PROTEIN', 240270),
(310950, 'PTHR46346:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL N-ACETYLGLUCOSAMINYLTRANSFERASE SUBUNIT P', 240271),
(310951, 'PTHR46346', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL N-ACETYLGLUCOSAMINYLTRANSFERASE SUBUNIT P', 240271),
(310952, 'PTHR37744:SF1', NULL, NULL, NULL, NULL, 'STAR LIPID TRANSFER-LIKE PROTEIN', 240272),
(310953, 'PTHR37744', NULL, NULL, NULL, NULL, 'STAR LIPID TRANSFER-LIKE PROTEIN', 240272),
(310954, 'PTHR35170', NULL, NULL, NULL, NULL, 'PROTEIN DD3-3', 240273),
(310955, 'PTHR35170:SF2', NULL, NULL, NULL, NULL, 'HTH CENPB-TYPE DOMAIN-CONTAINING PROTEIN', 240273),
(310956, 'PTHR35170:SF1', NULL, NULL, NULL, NULL, 'PROTEIN DD3-3', 240273),
(310957, 'PTHR37049:SF2', NULL, NULL, NULL, NULL, 'TSPC DOMAIN-CONTAINING PROTEIN', 240274),
(310958, 'PTHR37049:SF4', NULL, NULL, NULL, NULL, 'TSPC DOMAIN-CONTAINING PROTEIN', 240274),
(310959, 'PTHR37049', NULL, NULL, NULL, NULL, 'PEPTIDASE S41 FAMILY PROTEIN', 240274),
(310960, 'PTHR44554:SF1', NULL, NULL, NULL, NULL, 'LRP2-BINDING PROTEIN', 240275),
(310961, 'PTHR44554', NULL, NULL, NULL, NULL, 'LRP2-BINDING PROTEIN', 240275),
(310962, 'PTHR31540', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 131 KDA', 240276),
(310963, 'PTHR31540:SF1', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 131 KDA', 240276),
(310964, 'PTHR21678', NULL, NULL, NULL, NULL, 'GROWTH INHIBITION AND DIFFERENTIATION RELATED PROTEIN 88', 240277),
(310965, 'PTHR21678:SF7', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN R3HCC1L', 240277),
(310966, 'PTHR21678:SF6', NULL, NULL, NULL, NULL, 'R3H AND COILED-COIL DOMAIN-CONTAINING PROTEIN 1', 240277),
(310967, 'PTHR21678:SF0', NULL, NULL, NULL, NULL, 'OS01G0965600 PROTEIN', 240277),
(310968, 'PTHR47864:SF9', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 240278),
(310969, 'PTHR47864:SF8', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 240278),
(310970, 'PTHR47864:SF7', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 240278),
(310971, 'PTHR47864:SF6', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 240278),
(310972, 'PTHR47864:SF5', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 240278),
(310973, 'PTHR47864:SF4', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DNA-BINDING DOMAIN PROTEIN', 240278),
(310974, 'PTHR47864:SF10', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 240278),
(310975, 'PTHR47864:SF2', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 240278),
(310976, 'PTHR47864', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 240278),
(310977, 'PTHR43695:SF2', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_2G17250)-RELATED', 240279),
(310978, 'PTHR43695:SF1', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN ACETYLESTERASE', 240279),
(310979, 'PTHR43695', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_2G17250)-RELATED', 240279),
(310980, 'PTHR36451', NULL, NULL, NULL, NULL, 'PAPS-DEPENDENT SULFOTRANSFERASE STF3', 240280),
(310981, 'PTHR36451:SF1', NULL, NULL, NULL, NULL, 'PAPS-DEPENDENT SULFOTRANSFERASE STF3', 240280),
(310982, 'PTHR31962', NULL, NULL, NULL, NULL, 'SPHINGOLIPID LONG CHAIN BASE-RESPONSIVE PROTEIN PIL1', 240281),
(310983, 'PTHR31962:SF8', NULL, NULL, NULL, NULL, 'MEIOTIC EXPRESSION UP-REGULATED PROTEIN 14', 240281),
(310984, 'PTHR31962:SF4', NULL, NULL, NULL, NULL, 'PRIMARY COMPONENT OF EISOSOMES (EUROFUNG)', 240281);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(310985, 'PTHR31962:SF7', NULL, NULL, NULL, NULL, 'SPHINGOLIPID LONG CHAIN BASE-RESPONSIVE PROTEIN PIL2-RELATED', 240281),
(310986, 'PTHR31962:SF6', NULL, NULL, NULL, NULL, 'CHROMOSOME 21, WHOLE GENOME SHOTGUN SEQUENCE', 240281),
(310987, 'PTHR31962:SF1', NULL, NULL, NULL, NULL, 'SPHINGOLIPID LONG CHAIN BASE-RESPONSIVE PROTEIN PIL1', 240281),
(310988, 'PTHR31962:SF3', NULL, NULL, NULL, NULL, 'SPHINGOLIPID LONG CHAIN BASE-RESPONSIVE PROTEIN LSP1', 240281),
(310989, 'PTHR36366:SF3', NULL, NULL, NULL, NULL, '', 240282),
(310990, 'PTHR36366:SF4', NULL, NULL, NULL, NULL, 'PROTEIN RDM1-LIKE ISOFORM X1', 240282),
(310991, 'PTHR36366:SF1', NULL, NULL, NULL, NULL, 'PROTEIN RDM1', 240282),
(310992, 'PTHR36366', NULL, NULL, NULL, NULL, 'PROTEIN RDM1', 240282),
(310993, 'PTHR12192:SF29', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYLCYCLOTRANSFERASE', 240283),
(310994, 'PTHR12192:SF19', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYLCYCLOTRANSFERASE 2-2', 240283),
(310995, 'PTHR12192', NULL, NULL, NULL, NULL, 'CATION TRANSPORT PROTEIN CHAC-RELATED', 240283),
(310996, 'PTHR12192:SF2', NULL, NULL, NULL, NULL, 'GLUTATHIONE-SPECIFIC GAMMA-GLUTAMYLCYCLOTRANSFERASE 2', 240283),
(310997, 'PTHR12192:SF24', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYLCYCLOTRANSFERASE', 240283),
(310998, 'PTHR12192:SF26', NULL, NULL, NULL, NULL, 'GLUTATHIONE-SPECIFIC GAMMA-GLUTAMYLCYCLOTRANSFERASE 1', 240283),
(310999, 'PTHR12192:SF27', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYLCYCLOTRANSFERASE 2-1', 240283),
(311000, 'PTHR35176:SF2', NULL, NULL, NULL, NULL, 'F420H(2)-DEPENDENT REDUCTASE RV1155', 240284),
(311001, 'PTHR35176:SF1', NULL, NULL, NULL, NULL, 'F420H(2)-DEPENDENT BILIVERDIN REDUCTASE', 240284),
(311002, 'PTHR35176:SF11', NULL, NULL, NULL, NULL, 'PYRIDOXAMINE 5''-PHOSPHATE OXIDASE FAMILY PROTEIN', 240284),
(311003, 'PTHR35176:SF4', NULL, NULL, NULL, NULL, 'PYRIDOXAMINE 5''-PHOSPHATE OXIDASE-RELATED FMN-BINDING', 240284),
(311004, 'PTHR35176', NULL, NULL, NULL, NULL, 'HEME OXYGENASE HI_0854-RELATED', 240284),
(311005, 'PTHR35176:SF6', NULL, NULL, NULL, NULL, 'HEME OXYGENASE HI_0854-RELATED', 240284),
(311006, 'PTHR47783:SF1', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 240285),
(311007, 'PTHR47783', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 240285),
(311008, 'PTHR16932:SF18', NULL, NULL, NULL, NULL, 'INTERFERON ALPHA INDUCIBLE PROTEIN 45-RELATED', 240286),
(311009, 'PTHR16932:SF35', NULL, NULL, NULL, NULL, 'INTERFERON ALPHA-INDUCIBLE PROTEIN 27-LIKE PROTEIN 2', 240286),
(311010, 'PTHR16932:SF36', NULL, NULL, NULL, NULL, 'INTERFERON ALPHA-INDUCIBLE PROTEIN 27-LIKE PROTEIN 1', 240286),
(311011, 'PTHR16932:SF25', NULL, NULL, NULL, NULL, 'INTERFERON ALPHA-INDUCIBLE PROTEIN 6', 240286),
(311012, 'PTHR16932', NULL, NULL, NULL, NULL, 'INTERFERON ALPHA-INDUCIBLE PROTEIN 27', 240286),
(311013, 'PTHR16932:SF30', NULL, NULL, NULL, NULL, 'INTERFERON, ALPHA-INDUCIBLE PROTEIN 27', 240286),
(311014, 'PTHR16932:SF2', NULL, NULL, NULL, NULL, 'INTERFERON ALPHA-INDUCIBLE PROTEIN 27, MITOCHONDRIAL', 240286),
(311015, 'PTHR47849:SF2', NULL, NULL, NULL, NULL, '', 240287),
(311016, 'PTHR47849:SF11', NULL, NULL, NULL, NULL, '', 240287),
(311017, 'PTHR47849:SF8', NULL, NULL, NULL, NULL, 'LECTIN', 240287),
(311018, 'PTHR47849:SF10', NULL, NULL, NULL, NULL, '', 240287),
(311019, 'PTHR47849:SF7', NULL, NULL, NULL, NULL, 'CHITIN-BINDING TYPE-1 DOMAIN-CONTAINING PROTEIN', 240287),
(311020, 'PTHR47849', NULL, NULL, NULL, NULL, 'CHITIN-BINDING LECTIN 1', 240287),
(311021, 'PTHR47849:SF6', NULL, NULL, NULL, NULL, 'CHITIN-BINDING LECTIN 1', 240287),
(311022, 'PTHR47849:SF12', NULL, NULL, NULL, NULL, '', 240287),
(311023, 'PTHR47849:SF9', NULL, NULL, NULL, NULL, 'HFR-3', 240287),
(311024, 'PTHR39156', NULL, NULL, NULL, NULL, 'RIBONUCLEASE M5', 240288),
(311025, 'PTHR39156:SF1', NULL, NULL, NULL, NULL, 'RIBONUCLEASE M5', 240288),
(311026, 'PTHR39156:SF2', NULL, NULL, NULL, NULL, 'DNA PRIMASE (BACTERIAL TYPE) AND SMALL PRIMASE-LIKE PROTEINS', 240288),
(311027, 'PTHR40836:SF4', NULL, NULL, NULL, NULL, 'RB1-INDUCIBLE COILED-COIL PROTEIN', 240289);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(311028, 'PTHR40836:SF5', NULL, NULL, NULL, NULL, 'VARLMGL DOMAIN-CONTAINING PROTEIN', 240289),
(311029, 'PTHR40836', NULL, NULL, NULL, NULL, 'RB1-INDUCIBLE COILED-COIL PROTEIN', 240289),
(311030, 'PTHR40836:SF2', NULL, NULL, NULL, NULL, 'OS06G0728200 PROTEIN', 240289),
(311031, 'PTHR35983:SF1', NULL, NULL, NULL, NULL, 'UPF0166 PROTEIN TM_0021', 240290),
(311032, 'PTHR35983', NULL, NULL, NULL, NULL, 'UPF0166 PROTEIN TM_0021', 240290),
(311033, 'PTHR13208:SF2', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 4', 240291),
(311034, 'PTHR13208', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 4', 240291),
(311035, 'PTHR35893:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ELAB', 240292),
(311036, 'PTHR35893:SF3', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', 240292),
(311037, 'PTHR35893', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', 240292),
(311038, 'PTHR35893:SF4', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', 240292),
(311039, 'PTHR10791:SF22', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET12', 240293),
(311040, 'PTHR10791:SF68', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET5', 240293),
(311041, 'PTHR10791:SF112', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER SWEET1', 240293),
(311042, 'PTHR10791:SF233', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER SWEET', 240293),
(311043, 'PTHR10791:SF156', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311044, 'PTHR10791:SF28', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET3', 240293),
(311045, 'PTHR10791:SF232', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311046, 'PTHR10791:SF111', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET2', 240293),
(311047, 'PTHR10791:SF155', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311048, 'PTHR10791:SF198', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311049, 'PTHR10791:SF231', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311050, 'PTHR10791:SF153', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311051, 'PTHR10791:SF230', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311052, 'PTHR10791:SF196', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET11', 240293),
(311053, 'PTHR10791:SF152', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311054, 'PTHR10791:SF195', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311055, 'PTHR10791:SF193', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311056, 'PTHR10791:SF119', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311057, 'PTHR10791:SF239', NULL, NULL, NULL, NULL, '', 240293),
(311058, 'PTHR10791:SF238', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311059, 'PTHR10791:SF116', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311060, 'PTHR10791:SF237', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311061, 'PTHR10791:SF159', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET5', 240293),
(311062, 'PTHR10791:SF115', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311063, 'PTHR10791:SF236', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET8', 240293),
(311064, 'PTHR10791:SF235', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER SWEET', 240293),
(311065, 'PTHR10791:SF234', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311066, 'PTHR10791:SF157', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311067, 'PTHR10791:SF31', NULL, NULL, NULL, NULL, 'B BOX-TYPE DOMAIN-CONTAINING PROTEIN', 240293),
(311068, 'PTHR10791:SF192', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311069, 'PTHR10791:SF30', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER SWEET1', 240293); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(311070, 'PTHR10791:SF191', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311071, 'PTHR10791:SF190', NULL, NULL, NULL, NULL, 'PLANT DISEASE RESISTANT PROTEIN', 240293),
(311072, 'PTHR10791:SF37', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311073, 'PTHR10791:SF36', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER SWEET', 240293),
(311074, 'PTHR10791:SF222', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET15', 240293),
(311075, 'PTHR10791:SF221', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET2A-LIKE', 240293),
(311076, 'PTHR10791:SF143', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311077, 'PTHR10791:SF142', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET16', 240293),
(311078, 'PTHR10791:SF185', NULL, NULL, NULL, NULL, 'BNAA07G09540D PROTEIN', 240293),
(311079, 'PTHR10791:SF184', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311080, 'PTHR10791:SF183', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET16', 240293),
(311081, 'PTHR10791:SF182', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311082, 'PTHR10791:SF229', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET4', 240293),
(311083, 'PTHR10791:SF228', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311084, 'PTHR10791:SF227', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311085, 'PTHR10791:SF226', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311086, 'PTHR10791:SF148', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET10-LIKE', 240293),
(311087, 'PTHR10791:SF225', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311088, 'PTHR10791:SF224', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311089, 'PTHR10791:SF223', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET14', 240293),
(311090, 'PTHR10791:SF44', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET1', 240293),
(311091, 'PTHR10791:SF43', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER SWEET-RELATED', 240293),
(311092, 'PTHR10791:SF134', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET9', 240293),
(311093, 'PTHR10791:SF178', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311094, 'PTHR10791:SF133', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET11', 240293),
(311095, 'PTHR10791:SF210', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET13', 240293),
(311096, 'PTHR10791:SF176', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311097, 'PTHR10791:SF175', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311098, 'PTHR10791:SF131', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311099, 'PTHR10791:SF130', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET6-RELATED', 240293),
(311100, 'PTHR10791:SF174', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311101, 'PTHR10791:SF171', NULL, NULL, NULL, NULL, 'BNAA10G06560D PROTEIN', 240293),
(311102, 'PTHR10791:SF217', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311103, 'PTHR10791:SF139', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311104, 'PTHR10791:SF214', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311105, 'PTHR10791:SF179', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311106, 'PTHR10791:SF212', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311107, 'PTHR10791:SF5', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER SWEET', 240293),
(311108, 'PTHR10791:SF50', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET15', 240293),
(311109, 'PTHR10791:SF209', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311110, 'PTHR10791:SF54', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET2B', 240293);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(311111, 'PTHR10791:SF57', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET2A', 240293),
(311112, 'PTHR10791:SF58', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET3A', 240293),
(311113, 'PTHR10791:SF167', NULL, NULL, NULL, NULL, 'SWEET SUGAR TRANSPORTER-RELATED', 240293),
(311114, 'PTHR10791:SF122', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET14', 240293),
(311115, 'PTHR10791:SF166', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311116, 'PTHR10791:SF165', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET10', 240293),
(311117, 'PTHR10791:SF120', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET17', 240293),
(311118, 'PTHR10791:SF164', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311119, 'PTHR10791:SF163', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311120, 'PTHR10791:SF207', NULL, NULL, NULL, NULL, '', 240293),
(311121, 'PTHR10791:SF129', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET1B', 240293),
(311122, 'PTHR10791:SF206', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311123, 'PTHR10791:SF205', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311124, 'PTHR10791:SF126', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311125, 'PTHR10791:SF202', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311126, 'PTHR10791:SF169', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311127, 'PTHR10791', NULL, NULL, NULL, NULL, 'RAG1-ACTIVATING PROTEIN 1', 240293),
(311128, 'PTHR10791:SF124', NULL, NULL, NULL, NULL, 'BIDIRECTIONAL SUGAR TRANSPORTER SWEET', 240293),
(311129, 'PTHR40038:SF1', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED PROTEIN TCAA', 240294),
(311130, 'PTHR40038', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED PROTEIN TCAA', 240294),
(311131, 'PTHR12181', NULL, NULL, NULL, NULL, 'LIPIN', 240295),
(311132, 'PTHR12181:SF58', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE PHOSPHATASE', 240295),
(311133, 'PTHR12181:SF69', NULL, NULL, NULL, NULL, 'LNS2 (LIPIN/NED1/SMP2) PROTEIN', 240295),
(311134, 'PTHR12181:SF68', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE PHOSPHATASE', 240295),
(311135, 'PTHR12181:SF59', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE PHOSPHATASE PAH1', 240295),
(311136, 'PTHR12181:SF65', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE PHOSPHATASE', 240295),
(311137, 'PTHR12181:SF10', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE PHOSPHATASE LPIN1', 240295),
(311138, 'PTHR12181:SF12', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE PHOSPHATASE', 240295),
(311139, 'PTHR12181:SF11', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE PHOSPHATASE LPIN2', 240295),
(311140, 'PTHR12181:SF61', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE PHOSPHATASE PAH2-LIKE ISOFORM X1', 240295),
(311141, 'PTHR12181:SF72', NULL, NULL, NULL, NULL, 'LIPIN, HAD-LIKE DOMAIN, LNS2/PITP-RELATED', 240295),
(311142, 'PTHR12181:SF71', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE PHOSPHATASE', 240295),
(311143, 'PTHR12181:SF63', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE PHOSPHATASE', 240295),
(311144, 'PTHR12181:SF62', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE PHOSPHATASE LPIN3', 240295),
(311145, 'PTHR12181:SF70', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE PHOSPHATASE', 240295),
(311146, 'PTHR21320:SF6', NULL, NULL, NULL, NULL, 'BNAC05G01210D PROTEIN', 240296),
(311147, 'PTHR21320:SF7', NULL, NULL, NULL, NULL, 'BNAA08G27140D PROTEIN', 240296),
(311148, 'PTHR21320:SF3', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY PROTEIN COX11, MITOCHONDRIAL-RELATED', 240296),
(311149, 'PTHR21320', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY PROTEIN COX11-RELATED', 240296),
(311150, 'PTHR31004:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 79', 240297),
(311151, 'PTHR31004', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 79', 240297),
(311152, 'PTHR31004:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 79A', 240297),
(311153, 'PTHR31004:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 79-LIKE', 240297);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(311154, 'PTHR31004:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 79B', 240297),
(311155, 'PTHR14254:SF6', NULL, NULL, NULL, NULL, 'NON-SPECIFIC PROTEIN-TYROSINE KINASE', 240298),
(311156, 'PTHR14254:SF5', NULL, NULL, NULL, NULL, 'ERBB RECEPTOR FEEDBACK INHIBITOR 1', 240298),
(311157, 'PTHR14254:SF2', NULL, NULL, NULL, NULL, 'NON-SPECIFIC PROTEIN-TYROSINE KINASE', 240298),
(311158, 'PTHR14254', NULL, NULL, NULL, NULL, 'GENE 33 POLYPEPTIDE', 240298),
(311159, 'PTHR37238:SF2', NULL, NULL, NULL, NULL, '', 240299),
(311160, 'PTHR37238', NULL, NULL, NULL, NULL, 'OS05G0532500 PROTEIN', 240299),
(311161, 'PTHR37238:SF1', NULL, NULL, NULL, NULL, 'OS05G0532500 PROTEIN', 240299),
(311162, 'PTHR33206', NULL, NULL, NULL, NULL, 'PROTEIN CBG10425', 240300),
(311163, 'PTHR33206:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG10425', 240300),
(311164, 'PTHR33209:SF1', NULL, NULL, NULL, NULL, 'SERINE PROTEASE SPPA, CHLOROPLASTIC', 240301),
(311165, 'PTHR33209', NULL, NULL, NULL, NULL, 'PROTEASE 4', 240301),
(311166, 'PTHR43941:SF8', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 240302),
(311167, 'PTHR43941:SF9', NULL, NULL, NULL, NULL, 'PPIASE CYCLOPHILIN-TYPE DOMAIN-CONTAINING PROTEIN', 240302),
(311168, 'PTHR43941', NULL, NULL, NULL, NULL, 'STRUCTURAL MAINTENANCE OF CHROMOSOMES PROTEIN 2', 240302),
(311169, 'PTHR43941:SF4', NULL, NULL, NULL, NULL, 'EMI DOMAIN-CONTAINING PROTEIN', 240302),
(311170, 'PTHR43941:SF5', NULL, NULL, NULL, NULL, 'A-TYPE INCLUSION PROTEIN, PUTATIVE-RELATED', 240302),
(311171, 'PTHR43941:SF6', NULL, NULL, NULL, NULL, 'CRESTIN', 240302),
(311172, 'PTHR43941:SF7', NULL, NULL, NULL, NULL, 'VIRAL A-TYPE INCLUSION PROTEIN', 240302),
(311173, 'PTHR43941:SF1', NULL, NULL, NULL, NULL, 'STRUCTURAL MAINTENANCE OF CHROMOSOMES PROTEIN 2', 240302),
(311174, 'PTHR43941:SF10', NULL, NULL, NULL, NULL, 'STRUCTURAL MAINTENANCE OF CHROMOSOMES PROTEIN 2-1', 240302),
(311175, 'PTHR10890:SF25', NULL, NULL, NULL, NULL, 'CYSTEINE--TRNA LIGASE, CHLOROPLASTIC/MITOCHONDRIAL', 240303),
(311176, 'PTHR10890:SF26', NULL, NULL, NULL, NULL, 'CYSTEINE--TRNA LIGASE 1, CYTOPLASMIC-RELATED', 240303),
(311177, 'PTHR10890:SF24', NULL, NULL, NULL, NULL, 'CYSTEINYL-TRNA SYNTHETASE', 240303),
(311178, 'PTHR10890:SF32', NULL, NULL, NULL, NULL, 'CYSTEINYL-TRNA SYNTHETASE', 240303),
(311179, 'PTHR10890:SF30', NULL, NULL, NULL, NULL, 'CYSTEINE--TRNA LIGASE', 240303),
(311180, 'PTHR10890:SF31', NULL, NULL, NULL, NULL, 'CYSTEINYL-TRNA SYNTHETASE', 240303),
(311181, 'PTHR10890:SF29', NULL, NULL, NULL, NULL, 'CYSTEINYL-TRNA SYNTHETASE', 240303),
(311182, 'PTHR10890', NULL, NULL, NULL, NULL, 'CYSTEINYL-TRNA SYNTHETASE', 240303),
(311183, 'PTHR10890:SF4', NULL, NULL, NULL, NULL, 'CYSTEINE--TRNA LIGASE, MITOCHONDRIAL-RELATED', 240303),
(311184, 'PTHR10890:SF27', NULL, NULL, NULL, NULL, 'CYSTEINE--TRNA LIGASE, MITOCHONDRIAL-RELATED', 240303),
(311185, 'PTHR10890:SF3', NULL, NULL, NULL, NULL, 'CYSTEINE--TRNA LIGASE, CYTOPLASMIC', 240303),
(311186, 'PTHR43106', NULL, NULL, NULL, NULL, 'DEHYDROGENASE-RELATED', 240304),
(311187, 'PTHR43106:SF1', NULL, NULL, NULL, NULL, 'DEHYDROGENASE-RELATED', 240304),
(311188, 'PTHR47602:SF3', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240305),
(311189, 'PTHR47602:SF2', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SKIP22', 240305),
(311190, 'PTHR47602', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SKIP22', 240305),
(311191, 'PTHR42055:SF1', NULL, NULL, NULL, NULL, 'YALI0E03476P', 240306),
(311192, 'PTHR42055', NULL, NULL, NULL, NULL, 'YALI0E03476P', 240306),
(311193, 'PTHR42759:SF6', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN-RELATED', 240307),
(311194, 'PTHR42759', NULL, NULL, NULL, NULL, 'MOXR FAMILY PROTEIN', 240307),
(311195, 'PTHR42759:SF5', NULL, NULL, NULL, NULL, 'METHANOL DEHYDROGENASE REGULATOR', 240307),
(311196, 'PTHR42759:SF1', NULL, NULL, NULL, NULL, 'MAGNESIUM-CHELATASE SUBUNIT CHLD', 240307),
(311197, 'PTHR47111', NULL, NULL, NULL, NULL, 'BCDNA.LD29892', 240308),
(311198, 'PTHR47111:SF1', NULL, NULL, NULL, NULL, 'BCDNA.LD29892', 240308),
(311199, 'PTHR15171', NULL, NULL, NULL, NULL, 'EMERIN', 240309);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(311200, 'PTHR15171:SF2', NULL, NULL, NULL, NULL, 'EMERIN', 240309),
(311201, 'PTHR47190:SF1', NULL, NULL, NULL, NULL, '', 240310),
(311202, 'PTHR47190:SF2', NULL, NULL, NULL, NULL, 'CELLOBIOSE DEHYDROGENASE (AFU_ORTHOLOGUE AFUA_2G17620)', 240310),
(311203, 'PTHR47190', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE-RELATED', 240310),
(311204, 'PTHR47190:SF4', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE-RELATED', 240310),
(311205, 'PTHR16024', NULL, NULL, NULL, NULL, 'XK-RELATED PROTEIN', 240311),
(311206, 'PTHR16024:SF4', NULL, NULL, NULL, NULL, 'XK-RELATED PROTEIN', 240311),
(311207, 'PTHR16024:SF9', NULL, NULL, NULL, NULL, 'XK-RELATED PROTEIN 6', 240311),
(311208, 'PTHR16024:SF12', NULL, NULL, NULL, NULL, 'XK-RELATED PROTEIN', 240311),
(311209, 'PTHR16024:SF8', NULL, NULL, NULL, NULL, 'XK-RELATED PROTEIN 8', 240311),
(311210, 'PTHR16024:SF7', NULL, NULL, NULL, NULL, 'XK-RELATED PROTEIN 7', 240311),
(311211, 'PTHR16024:SF10', NULL, NULL, NULL, NULL, 'XK-RELATED PROTEIN', 240311),
(311212, 'PTHR16024:SF6', NULL, NULL, NULL, NULL, 'XK-RELATED PROTEIN', 240311),
(311213, 'PTHR16024:SF19', NULL, NULL, NULL, NULL, 'XK-RELATED PROTEIN', 240311),
(311214, 'PTHR16024:SF16', NULL, NULL, NULL, NULL, 'XK-RELATED PROTEIN 4', 240311),
(311215, 'PTHR16024:SF26', NULL, NULL, NULL, NULL, 'XK-RELATED PROTEIN', 240311),
(311216, 'PTHR16024:SF15', NULL, NULL, NULL, NULL, 'XK-RELATED PROTEIN 5', 240311),
(311217, 'PTHR16024:SF25', NULL, NULL, NULL, NULL, 'XK-RELATED PROTEIN', 240311),
(311218, 'PTHR16024:SF13', NULL, NULL, NULL, NULL, 'XK-RELATED PROTEIN 9', 240311),
(311219, 'PTHR45923', NULL, NULL, NULL, NULL, 'PROTEIN SEY1', 240312),
(311220, 'PTHR45923:SF3', NULL, NULL, NULL, NULL, 'PROTEIN ROOT HAIR DEFECTIVE 3 HOMOLOG 1', 240312),
(311221, 'PTHR45923:SF2', NULL, NULL, NULL, NULL, 'PROTEIN SEY1', 240312),
(311222, 'PTHR45923:SF5', NULL, NULL, NULL, NULL, 'PROTEIN ROOT HAIR DEFECTIVE 3 HOMOLOG 1', 240312),
(311223, 'PTHR45923:SF7', NULL, NULL, NULL, NULL, 'PROTEIN ROOT HAIR DEFECTIVE 3 HOMOLOG 2', 240312),
(311224, 'PTHR45923:SF6', NULL, NULL, NULL, NULL, 'PROTEIN ROOT HAIR DEFECTIVE 3 HOMOLOG', 240312),
(311225, 'PTHR45923:SF9', NULL, NULL, NULL, NULL, 'PROTEIN ROOT HAIR DEFECTIVE 3 HOMOLOG', 240312),
(311226, 'PTHR45923:SF8', NULL, NULL, NULL, NULL, 'PROTEIN ROOT HAIR DEFECTIVE 3 HOMOLOG 2', 240312),
(311227, 'PTHR45923:SF13', NULL, NULL, NULL, NULL, 'PROTEIN ROOT HAIR DEFECTIVE 3 HOMOLOG', 240312),
(311228, 'PTHR45923:SF14', NULL, NULL, NULL, NULL, 'RHD3/SEY1, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 240312),
(311229, 'PTHR45923:SF15', NULL, NULL, NULL, NULL, 'PROTEIN ROOT HAIR DEFECTIVE 3 HOMOLOG', 240312),
(311230, 'PTHR45923:SF16', NULL, NULL, NULL, NULL, 'PROTEIN ROOT HAIR DEFECTIVE 3 HOMOLOG', 240312),
(311231, 'PTHR45923:SF11', NULL, NULL, NULL, NULL, 'PROTEIN ROOT HAIR DEFECTIVE 3 HOMOLOG', 240312),
(311232, 'PTHR45923:SF17', NULL, NULL, NULL, NULL, 'PROTEIN ROOT HAIR DEFECTIVE 3 HOMOLOG', 240312),
(311233, 'PTHR45923:SF19', NULL, NULL, NULL, NULL, 'PROTEIN ROOT HAIR DEFECTIVE 3 HOMOLOG', 240312),
(311234, 'PTHR33885:SF3', NULL, NULL, NULL, NULL, 'PHAGE SHOCK PROTEIN C', 240313),
(311235, 'PTHR33885:SF4', NULL, NULL, NULL, NULL, 'LMO2487 PROTEIN', 240313),
(311236, 'PTHR33885', NULL, NULL, NULL, NULL, 'PHAGE SHOCK PROTEIN C', 240313),
(311237, 'PTHR38111:SF10', NULL, NULL, NULL, NULL, '', 240314),
(311238, 'PTHR38111:SF6', NULL, NULL, NULL, NULL, 'FINGER DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G01940)-RELATED', 240314),
(311239, 'PTHR38111', NULL, NULL, NULL, NULL, 'ZN(2)-C6 FUNGAL-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', 240314),
(311240, 'PTHR38111:SF5', NULL, NULL, NULL, NULL, 'PROTEIN FLIY, PUTATIVE-RELATED', 240314),
(311241, 'PTHR38111:SF2', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 240314),
(311242, 'PTHR38111:SF8', NULL, NULL, NULL, NULL, 'FINGER DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G01560)-RELATED', 240314),
(311243, 'PTHR38111:SF9', NULL, NULL, NULL, NULL, 'ZN(2)-C6 FUNGAL-TYPE DOMAIN-CONTAINING PROTEIN', 240314);
INSERT INTO "PUBLIC"."MODEL" VALUES
(311244, 'PTHR43143:SF4', NULL, NULL, NULL, NULL, 'METALLOPHOS DOMAIN-CONTAINING PROTEIN', 240315),
(311245, 'PTHR43143:SF3', NULL, NULL, NULL, NULL, 'BLL3016 PROTEIN', 240315),
(311246, 'PTHR43143:SF1', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE CPPED1', 240315),
(311247, 'PTHR43143', NULL, NULL, NULL, NULL, 'METALLOPHOSPHOESTERASE, CALCINEURIN SUPERFAMILY', 240315),
(311248, 'PTHR11920:SF458', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE', 240316),
(311249, 'PTHR11920:SF436', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE GUANYLATE CYCLASE GCY-15-RELATED', 240316),
(311250, 'PTHR11920:SF477', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE D', 240316),
(311251, 'PTHR11920:SF499', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE DOMAIN-CONTAINING PROTEIN', 240316),
(311252, 'PTHR11920:SF76', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE GUANYLATE CYCLASE GCY-6', 240316),
(311253, 'PTHR11920:SF335', NULL, NULL, NULL, NULL, 'GUANYLYL CYCLASE, MEMBRANE', 240316),
(311254, 'PTHR11920:SF459', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE GUANYLATE CYCLASE GCY-11', 240316),
(311255, 'PTHR11920:SF493', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE GUANYLATE CYCLASE GCY-22', 240316),
(311256, 'PTHR11920:SF274', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE', 240316),
(311257, 'PTHR11920:SF494', NULL, NULL, NULL, NULL, 'ATRIAL NATRIURETIC PEPTIDE RECEPTOR 2', 240316),
(311258, 'PTHR11920:SF370', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE GUANYLATE CYCLASE GCY-18', 240316),
(311259, 'PTHR11920:SF491', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE', 240316),
(311260, 'PTHR11920:SF475', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE', 240316),
(311261, 'PTHR11920:SF497', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE DOMAIN-CONTAINING PROTEIN', 240316),
(311262, 'PTHR11920:SF255', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE GUANYLATE CYCLASE GCY-25', 240316),
(311263, 'PTHR11920:SF355', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE GUANYLATE CYCLASE GCY-10-RELATED', 240316),
(311264, 'PTHR11920:SF498', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE GUANYLATE CYCLASE GCY-8', 240316),
(311265, 'PTHR11920:SF495', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE GUANYLATE CYCLASE GCY-7', 240316),
(311266, 'PTHR11920:SF375', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE GUANYLATE CYCLASE GCY-13', 240316),
(311267, 'PTHR11920:SF496', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE', 240316),
(311268, 'PTHR11920:SF474', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE GUANYLATE CYCLASE GYC76C', 240316),
(311269, 'PTHR11920:SF501', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE 32E', 240316),
(311270, 'PTHR11920:SF347', NULL, NULL, NULL, NULL, 'HEAT-STABLE ENTEROTOXIN RECEPTOR', 240316),
(311271, 'PTHR11920:SF40', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE GUANYLATE CYCLASE GCY-14-RELATED', 240316),
(311272, 'PTHR11920:SF502', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE', 240316),
(311273, 'PTHR11920:SF489', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE GUANYLATE CYCLASE GCY-3', 240316),
(311274, 'PTHR11920:SF500', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE 2G', 240316),
(311275, 'PTHR11920:SF505', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE', 240316),
(311276, 'PTHR11920:SF68', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE GUANYLATE CYCLASE GCY-4', 240316),
(311277, 'PTHR11920:SF228', NULL, NULL, NULL, NULL, 'RETINAL GUANYLYL CYCLASE 1', 240316),
(311278, 'PTHR11920:SF503', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE GUANYLATE CYCLASE GCY-9', 240316),
(311279, 'PTHR11920:SF349', NULL, NULL, NULL, NULL, 'RETINAL GUANYLYL CYCLASE 2', 240316),
(311280, 'PTHR11920:SF504', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE', 240316),
(311281, 'PTHR11920:SF483', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE', 240316),
(311282, 'PTHR11920:SF381', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE GUANYLATE CYCLASE GCY-5', 240316),
(311283, 'PTHR11920:SF480', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE', 240316),
(311284, 'PTHR11920:SF260', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE GUANYLATE CYCLASE GCY-23', 240316),
(311285, 'PTHR11920:SF481', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE', 240316),
(311286, 'PTHR11920', NULL, NULL, NULL, NULL, 'GUANYLYL CYCLASE', 240316); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(311287, 'PTHR11920:SF464', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE', 240316),
(311288, 'PTHR11920:SF487', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE, GERMINATION SPECIFIC', 240316),
(311289, 'PTHR11920:SF300', NULL, NULL, NULL, NULL, 'ATRIAL NATRIURETIC PEPTIDE RECEPTOR 1', 240316),
(311290, 'PTHR11920:SF71', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE GUANYLATE CYCLASE GCY-19', 240316),
(311291, 'PTHR11920:SF462', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE', 240316),
(311292, 'PTHR11920:SF363', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE GUANYLATE CYCLASE GCY-17', 240316),
(311293, 'PTHR11920:SF265', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE GUANYLATE CYCLASE GCY-1-RELATED', 240316),
(311294, 'PTHR11920:SF485', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE GUANYLATE CYCLASE DAF-11', 240316),
(311295, 'PTHR11920:SF342', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE GUANYLATE CYCLASE GCY-29', 240316),
(311296, 'PTHR11260:SF770', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U10', 240317),
(311297, 'PTHR11260:SF771', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U16', 240317),
(311298, 'PTHR11260:SF650', NULL, NULL, NULL, NULL, 'BNAA05G12560D PROTEIN', 240317),
(311299, 'PTHR11260:SF772', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE-RELATED', 240317),
(311300, 'PTHR11260:SF530', NULL, NULL, NULL, NULL, 'GLUTATHIONE-S-TRANSFERASE 28E45', 240317),
(311301, 'PTHR11260:SF531', NULL, NULL, NULL, NULL, '', 240317),
(311302, 'PTHR11260:SF773', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U26', 240317),
(311303, 'PTHR11260:SF774', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE-RELATED', 240317),
(311304, 'PTHR11260:SF775', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U10', 240317),
(311305, 'PTHR11260:SF654', NULL, NULL, NULL, NULL, 'S-TRANSFERASE, PUTATIVE-RELATED', 240317),
(311306, 'PTHR11260:SF533', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U5-RELATED', 240317),
(311307, 'PTHR11260:SF776', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE GST 27', 240317),
(311308, 'PTHR11260:SF535', NULL, NULL, NULL, NULL, '', 240317),
(311309, 'PTHR11260:SF777', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U8-LIKE', 240317),
(311310, 'PTHR11260:SF778', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U18-LIKE', 240317),
(311311, 'PTHR11260:SF536', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U7', 240317),
(311312, 'PTHR11260:SF779', NULL, NULL, NULL, NULL, 'S-TRANSFERASE TAU, PUTATIVE-RELATED', 240317),
(311313, 'PTHR11260:SF538', NULL, NULL, NULL, NULL, '', 240317),
(311314, 'PTHR11260:SF760', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE GST 23', 240317),
(311315, 'PTHR11260:SF761', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE FAMILY PROTEIN-RELATED', 240317),
(311316, 'PTHR11260:SF520', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE-RELATED', 240317),
(311317, 'PTHR11260:SF762', NULL, NULL, NULL, NULL, 'S-TRANSFERASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G07930)-RELATED', 240317),
(311318, 'PTHR11260:SF641', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE GSTU6', 240317),
(311319, 'PTHR11260:SF763', NULL, NULL, NULL, NULL, 'OS01G0949800 PROTEIN', 240317),
(311320, 'PTHR11260:SF642', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE-RELATED', 240317),
(311321, 'PTHR11260:SF764', NULL, NULL, NULL, NULL, 'OS10G0530500 PROTEIN', 240317),
(311322, 'PTHR11260:SF523', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE GST 23-LIKE', 240317),
(311323, 'PTHR11260:SF765', NULL, NULL, NULL, NULL, '', 240317),
(311324, 'PTHR11260:SF524', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE', 240317),
(311325, 'PTHR11260:SF766', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U9-LIKE', 240317),
(311326, 'PTHR11260:SF525', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE, N-TERMINAL DOMAIN CONTAINING PROTEIN, EXPRESSED', 240317),
(311327, 'PTHR11260:SF767', NULL, NULL, NULL, NULL, '', 240317),
(311328, 'PTHR11260:SF646', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U17-LIKE', 240317),
(311329, 'PTHR11260:SF768', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE-RELATED', 240317);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(311330, 'PTHR11260:SF647', NULL, NULL, NULL, NULL, '', 240317),
(311331, 'PTHR11260:SF769', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE-RELATED', 240317),
(311332, 'PTHR11260:SF528', NULL, NULL, NULL, NULL, 'GST C-TERMINAL DOMAIN-CONTAINING PROTEIN', 240317),
(311333, 'PTHR11260:SF649', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE', 240317),
(311334, 'PTHR11260:SF529', NULL, NULL, NULL, NULL, '', 240317),
(311335, 'PTHR11260:SF670', NULL, NULL, NULL, NULL, 'GST N-TERMINAL DOMAIN-CONTAINING PROTEIN', 240317),
(311336, 'PTHR11260:SF275', NULL, NULL, NULL, NULL, 'OS01G0558100 PROTEIN', 240317),
(311337, 'PTHR11260:SF550', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE GST 38', 240317),
(311338, 'PTHR11260', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE, GST, SUPERFAMILY, GST DOMAIN CONTAINING', 240317),
(311339, 'PTHR11260:SF672', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE-RELATED', 240317),
(311340, 'PTHR11260:SF552', NULL, NULL, NULL, NULL, '', 240317),
(311341, 'PTHR11260:SF673', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U13-LIKE', 240317),
(311342, 'PTHR11260:SF553', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE-RELATED', 240317),
(311343, 'PTHR11260:SF555', NULL, NULL, NULL, NULL, '', 240317),
(311344, 'PTHR11260:SF676', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U8', 240317),
(311345, 'PTHR11260:SF710', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE TAU 11-RELATED', 240317),
(311346, 'PTHR11260:SF677', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE T5', 240317),
(311347, 'PTHR11260:SF711', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U9', 240317),
(311348, 'PTHR11260:SF558', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U10-LIKE', 240317),
(311349, 'PTHR11260:SF712', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE, AMINO-TERMINAL DOMAIN PROTEIN', 240317),
(311350, 'PTHR11260:SF679', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE', 240317),
(311351, 'PTHR11260:SF713', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 240317),
(311352, 'PTHR11260:SF559', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U2', 240317),
(311353, 'PTHR11260:SF716', NULL, NULL, NULL, NULL, 'TAU CLASS GLUTATHIONE S-TRANSFERASE', 240317),
(311354, 'PTHR11260:SF719', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE-RELATED', 240317),
(311355, 'PTHR11260:SF780', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE-RELATED', 240317),
(311356, 'PTHR11260:SF660', NULL, NULL, NULL, NULL, 'BNAA07G28470D PROTEIN', 240317),
(311357, 'PTHR11260:SF781', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U19', 240317),
(311358, 'PTHR11260:SF782', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE ISOFORM X2-RELATED', 240317),
(311359, 'PTHR11260:SF783', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE-RELATED', 240317),
(311360, 'PTHR11260:SF784', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U9-LIKE', 240317),
(311361, 'PTHR11260:SF663', NULL, NULL, NULL, NULL, '', 240317),
(311362, 'PTHR11260:SF543', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 240317),
(311363, 'PTHR11260:SF544', NULL, NULL, NULL, NULL, '', 240317),
(311364, 'PTHR11260:SF666', NULL, NULL, NULL, NULL, 'GLUTATHIONE-S-TRANSFERASE', 240317),
(311365, 'PTHR11260:SF700', NULL, NULL, NULL, NULL, 'BNAC05G13370D PROTEIN', 240317),
(311366, 'PTHR11260:SF668', NULL, NULL, NULL, NULL, '', 240317),
(311367, 'PTHR11260:SF547', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE, AMINO-TERMINAL DOMAIN PROTEIN', 240317),
(311368, 'PTHR11260:SF669', NULL, NULL, NULL, NULL, 'BNAA09G45080D PROTEIN', 240317),
(311369, 'PTHR11260:SF549', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U24', 240317),
(311370, 'PTHR11260:SF704', NULL, NULL, NULL, NULL, '', 240317),
(311371, 'PTHR11260:SF705', NULL, NULL, NULL, NULL, 'S-TRANSFERASE, PUTATIVE-RELATED', 240317),
(311372, 'PTHR11260:SF708', NULL, NULL, NULL, NULL, 'OS01G0950000 PROTEIN', 240317),
(311373, 'PTHR11260:SF709', NULL, NULL, NULL, NULL, '', 240317),
(311374, 'PTHR11260:SF692', NULL, NULL, NULL, NULL, 'BNACNNG49200D PROTEIN', 240317);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(311375, 'PTHR11260:SF571', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U17-LIKE', 240317),
(311376, 'PTHR11260:SF573', NULL, NULL, NULL, NULL, '', 240317),
(311377, 'PTHR11260:SF695', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE, AMINO-TERMINAL DOMAIN PROTEIN', 240317),
(311378, 'PTHR11260:SF574', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE PARC-RELATED', 240317),
(311379, 'PTHR11260:SF696', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U7-LIKE', 240317),
(311380, 'PTHR11260:SF730', NULL, NULL, NULL, NULL, 'S-CRYSTALLIN-RELATED', 240317),
(311381, 'PTHR11260:SF697', NULL, NULL, NULL, NULL, 'BNAA06G11510D PROTEIN', 240317),
(311382, 'PTHR11260:SF576', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U9-LIKE', 240317),
(311383, 'PTHR11260:SF610', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE-RELATED', 240317),
(311384, 'PTHR11260:SF698', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U17-LIKE', 240317),
(311385, 'PTHR11260:SF732', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE GSTU1-RELATED', 240317),
(311386, 'PTHR11260:SF612', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U28', 240317),
(311387, 'PTHR11260:SF734', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE BZ2-RELATED', 240317),
(311388, 'PTHR11260:SF614', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE-RELATED', 240317),
(311389, 'PTHR11260:SF615', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U17', 240317),
(311390, 'PTHR11260:SF736', NULL, NULL, NULL, NULL, '', 240317),
(311391, 'PTHR11260:SF617', NULL, NULL, NULL, NULL, '', 240317),
(311392, 'PTHR11260:SF739', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE-RELATED', 240317),
(311393, 'PTHR11260:SF618', NULL, NULL, NULL, NULL, '', 240317),
(311394, 'PTHR11260:SF619', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE', 240317),
(311395, 'PTHR11260:SF580', NULL, NULL, NULL, NULL, 'GST7 PROTEIN', 240317),
(311396, 'PTHR11260:SF683', NULL, NULL, NULL, NULL, 'OS05G0412800 PROTEIN', 240317),
(311397, 'PTHR11260:SF684', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE, AMINO-TERMINAL DOMAIN PROTEIN', 240317),
(311398, 'PTHR11260:SF564', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U12', 240317),
(311399, 'PTHR11260:SF685', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U17-LIKE', 240317),
(311400, 'PTHR11260:SF686', NULL, NULL, NULL, NULL, 'GLUTATHIONE-S-TRANSFERASE', 240317),
(311401, 'PTHR11260:SF687', NULL, NULL, NULL, NULL, 'BNAA09G45070D PROTEIN', 240317),
(311402, 'PTHR11260:SF566', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE GST 26', 240317),
(311403, 'PTHR11260:SF721', NULL, NULL, NULL, NULL, '', 240317),
(311404, 'PTHR11260:SF688', NULL, NULL, NULL, NULL, 'BNAC06G31020D PROTEIN', 240317),
(311405, 'PTHR11260:SF600', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U8-LIKE', 240317),
(311406, 'PTHR11260:SF326', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE GSTU6-RELATED', 240317),
(311407, 'PTHR11260:SF568', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE-RELATED', 240317),
(311408, 'PTHR11260:SF689', NULL, NULL, NULL, NULL, 'BNAA02G35760D PROTEIN', 240317),
(311409, 'PTHR11260:SF601', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U20', 240317),
(311410, 'PTHR11260:SF569', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE', 240317),
(311411, 'PTHR11260:SF724', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U16', 240317),
(311412, 'PTHR11260:SF725', NULL, NULL, NULL, NULL, 'GST C-TERMINAL DOMAIN-CONTAINING PROTEIN', 240317),
(311413, 'PTHR11260:SF726', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE PARC-RELATED', 240317),
(311414, 'PTHR11260:SF605', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U23', 240317),
(311415, 'PTHR11260:SF607', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE GST 24', 240317),
(311416, 'PTHR11260:SF728', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE GST 23-LIKE', 240317),
(311417, 'PTHR11260:SF608', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE GSTU6', 240317),
(311418, 'PTHR11260:SF729', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE-RELATED', 240317);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(311419, 'PTHR11260:SF609', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U9', 240317),
(311420, 'PTHR11260:SF690', NULL, NULL, NULL, NULL, 'OS07G0468100 PROTEIN', 240317),
(311421, 'PTHR11260:SF570', NULL, NULL, NULL, NULL, '', 240317),
(311422, 'PTHR11260:SF593', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U25', 240317),
(311423, 'PTHR11260:SF594', NULL, NULL, NULL, NULL, 'GST C-TERMINAL DOMAIN-CONTAINING PROTEIN', 240317),
(311424, 'PTHR11260:SF232', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE37', 240317),
(311425, 'PTHR11260:SF595', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240317),
(311426, 'PTHR11260:SF474', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE', 240317),
(311427, 'PTHR11260:SF750', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U27', 240317),
(311428, 'PTHR11260:SF751', NULL, NULL, NULL, NULL, 'OS01G0692100 PROTEIN', 240317),
(311429, 'PTHR11260:SF597', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U18', 240317),
(311430, 'PTHR11260:SF476', NULL, NULL, NULL, NULL, 'OS10G0527601 PROTEIN', 240317),
(311431, 'PTHR11260:SF752', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U7-LIKE', 240317),
(311432, 'PTHR11260:SF631', NULL, NULL, NULL, NULL, 'GST C-TERMINAL DOMAIN-CONTAINING PROTEIN', 240317),
(311433, 'PTHR11260:SF511', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE, N-TERMINAL DOMAIN CONTAINING PROTEIN, EXPRESSED', 240317),
(311434, 'PTHR11260:SF632', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U13-RELATED', 240317),
(311435, 'PTHR11260:SF753', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE', 240317),
(311436, 'PTHR11260:SF478', NULL, NULL, NULL, NULL, 'GST C-TERMINAL DOMAIN-CONTAINING PROTEIN', 240317),
(311437, 'PTHR11260:SF599', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U16', 240317),
(311438, 'PTHR11260:SF754', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U21', 240317),
(311439, 'PTHR11260:SF755', NULL, NULL, NULL, NULL, 'OS01G0949700 PROTEIN', 240317),
(311440, 'PTHR11260:SF634', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE-RELATED', 240317),
(311441, 'PTHR11260:SF635', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE-RELATED', 240317),
(311442, 'PTHR11260:SF756', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE PARA-RELATED', 240317),
(311443, 'PTHR11260:SF757', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE-RELATED', 240317),
(311444, 'PTHR11260:SF758', NULL, NULL, NULL, NULL, '', 240317),
(311445, 'PTHR11260:SF16', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE, N-TERMINAL DOMAIN CONTAINING PROTEIN, EXPRESSED', 240317),
(311446, 'PTHR11260:SF759', NULL, NULL, NULL, NULL, 'S-TRANSFERASE, PUTATIVE-RELATED', 240317),
(311447, 'PTHR11260:SF639', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U1', 240317),
(311448, 'PTHR11260:SF518', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE GSTU6', 240317),
(311449, 'PTHR11260:SF519', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U25-LIKE', 240317),
(311450, 'PTHR11260:SF582', NULL, NULL, NULL, NULL, '', 240317),
(311451, 'PTHR11260:SF583', NULL, NULL, NULL, NULL, 'BNACNNG35440D PROTEIN', 240317),
(311452, 'PTHR11260:SF584', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U22', 240317),
(311453, 'PTHR11260:SF742', NULL, NULL, NULL, NULL, 'BNAA07G09580D PROTEIN', 240317),
(311454, 'PTHR11260:SF621', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U11', 240317),
(311455, 'PTHR11260:SF501', NULL, NULL, NULL, NULL, 'S-TRANSFERASE GSTU6, PUTATIVE, EXPRESSED-RELATED', 240317),
(311456, 'PTHR11260:SF622', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U9', 240317),
(311457, 'PTHR11260:SF743', NULL, NULL, NULL, NULL, 'GST_C DOMAIN-CONTAINING PROTEIN', 240317),
(311458, 'PTHR11260:SF744', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE, AMINO-TERMINAL DOMAIN PROTEIN', 240317),
(311459, 'PTHR11260:SF745', NULL, NULL, NULL, NULL, 'GST C-TERMINAL DOMAIN-CONTAINING PROTEIN', 240317),
(311460, 'PTHR11260:SF503', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE29', 240317),
(311461, 'PTHR11260:SF746', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE-RELATED', 240317);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(311462, 'PTHR11260:SF747', NULL, NULL, NULL, NULL, '', 240317),
(311463, 'PTHR11260:SF626', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U4', 240317),
(311464, 'PTHR11260:SF748', NULL, NULL, NULL, NULL, 'S-TRANSFERASE TAU, PUTATIVE-RELATED', 240317),
(311465, 'PTHR11260:SF627', NULL, NULL, NULL, NULL, 'GST C-TERMINAL DOMAIN-CONTAINING PROTEIN', 240317),
(311466, 'PTHR11260:SF628', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U15', 240317),
(311467, 'PTHR11260:SF749', NULL, NULL, NULL, NULL, 'S-TRANSFERASE GSTU6, PUTATIVE, EXPRESSED-RELATED', 240317),
(311468, 'PTHR11260:SF629', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE-RELATED', 240317),
(311469, 'PTHR11260:SF590', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U7-LIKE', 240317),
(311470, 'PTHR11260:SF591', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE U3', 240317),
(311471, 'PTHR39179:SF2', NULL, NULL, NULL, NULL, 'ENDOSPORE COAT-ASSOCIATED PROTEIN YUTH', 240318),
(311472, 'PTHR39179:SF3', NULL, NULL, NULL, NULL, 'COTS-RELATED PROTEIN', 240318),
(311473, 'PTHR39179', NULL, NULL, NULL, NULL, 'SPORE COAT PROTEIN I', 240318),
(311474, 'PTHR39179:SF1', NULL, NULL, NULL, NULL, 'SPORE COAT PROTEIN I', 240318),
(311475, 'PTHR28631', NULL, NULL, NULL, NULL, 'UPF0692 PROTEIN C19ORF54', 240319),
(311476, 'PTHR28631:SF1', NULL, NULL, NULL, NULL, 'UPF0692 PROTEIN C19ORF54', 240319),
(311477, 'PTHR21035:SF2', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S26, MITOCHONDRIAL', 240320),
(311478, 'PTHR21035', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S26, MITOCHONDRIAL', 240320),
(311479, 'PTHR42702:SF1', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN FOR BETA-LACTAMASE', 240321),
(311480, 'PTHR42702', NULL, NULL, NULL, NULL, 'NUCLEOTIDE PYROPHOSPHOHYDROLASE', 240321),
(311481, 'PTHR15109', NULL, NULL, NULL, NULL, 'AGAP004327-PA', 240322),
(311482, 'PTHR15109:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM193A', 240322),
(311483, 'PTHR15109:SF4', NULL, NULL, NULL, NULL, 'FAM193_C DOMAIN-CONTAINING PROTEIN', 240322),
(311484, 'PTHR15109:SF3', NULL, NULL, NULL, NULL, 'PROTEIN FAM193B', 240322),
(311485, 'PTHR48149:SF1', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L37A-2', 240323),
(311486, 'PTHR48149', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L37A-2', 240323),
(311487, 'PTHR46479:SF1', NULL, NULL, NULL, NULL, 'BIOGENESIS OF LYSOSOME-RELATED ORGANELLES COMPLEX 1 SUBUNIT 2', 240324),
(311488, 'PTHR46479', NULL, NULL, NULL, NULL, 'BIOGENESIS OF LYSOSOME-RELATED ORGANELLES COMPLEX 1 SUBUNIT 2', 240324),
(311489, 'PTHR22800', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN PROTEINS', 240325),
(311490, 'PTHR22800:SF250', NULL, NULL, NULL, NULL, 'KILLER CELL LECTIN-LIKE RECEPTOR SUBFAMILY I MEMBER 1', 240325),
(311491, 'PTHR22800:SF185', NULL, NULL, NULL, NULL, 'NKG2-F TYPE II INTEGRAL MEMBRANE PROTEIN', 240325),
(311492, 'PTHR22800:SF243', NULL, NULL, NULL, NULL, 'LY49 DOMAIN-CONTAINING PROTEIN', 240325),
(311493, 'PTHR22800:SF164', NULL, NULL, NULL, NULL, 'KILLER CELL LECTIN-LIKE RECEPTOR SUBFAMILY H, MEMBER 1', 240325),
(311494, 'PTHR22800:SF252', NULL, NULL, NULL, NULL, 'KILLER CELL LECTIN-LIKE RECEPTOR SUBFAMILY E MEMBER 1', 240325),
(311495, 'PTHR22800:SF253', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 240325),
(311496, 'PTHR22800:SF242', NULL, NULL, NULL, NULL, 'NKG2-A/NKG2-B TYPE II INTEGRAL MEMBRANE PROTEIN', 240325),
(311497, 'PTHR22800:SF247', NULL, NULL, NULL, NULL, 'NKG2-C TYPE II INTEGRAL MEMBRANE PROTEIN', 240325),
(311498, 'PTHR22800:SF237', NULL, NULL, NULL, NULL, 'KILLER CELL LECTIN-LIKE RECEPTOR SUBFAMILY I MEMBER 2', 240325),
(311499, 'PTHR22800:SF245', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 240325),
(311500, 'PTHR22800:SF246', NULL, NULL, NULL, NULL, 'NATURAL KILLER CELLS ANTIGEN CD94', 240325),
(311501, 'PTHR22800:SF239', NULL, NULL, NULL, NULL, 'NKG2-E TYPE II INTEGRAL MEMBRANE PROTEIN', 240325),
(311502, 'PTHR37810:SF9', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 240326),
(311503, 'PTHR37810', NULL, NULL, NULL, NULL, 'IMMUNITY PROTEIN SDPI', 240326);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(311504, 'PTHR37810:SF5', NULL, NULL, NULL, NULL, 'IMMUNITY PROTEIN SDPI', 240326),
(311505, 'PTHR46325:SF8', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN RIC7-LIKE', 240327),
(311506, 'PTHR46325:SF9', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN RIC6-RELATED', 240327),
(311507, 'PTHR46325', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN RIC8', 240327),
(311508, 'PTHR46325:SF25', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN RIC9', 240327),
(311509, 'PTHR46325:SF23', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN-RELATED', 240327),
(311510, 'PTHR46325:SF27', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN', 240327),
(311511, 'PTHR46325:SF40', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN', 240327),
(311512, 'PTHR46325:SF44', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN RIC8', 240327),
(311513, 'PTHR46325:SF22', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN', 240327),
(311514, 'PTHR46325:SF4', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN RIC7-LIKE', 240327),
(311515, 'PTHR46325:SF21', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN', 240327),
(311516, 'PTHR46325:SF43', NULL, NULL, NULL, NULL, 'ROP-INTERACTIVE CRIB MOTIF PROTEIN', 240327),
(311517, 'PTHR46325:SF20', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN RIC10', 240327),
(311518, 'PTHR46325:SF42', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN RIC10', 240327),
(311519, 'PTHR46325:SF6', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN RIC3', 240327),
(311520, 'PTHR46325:SF41', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN-RELATED', 240327),
(311521, 'PTHR46325:SF36', NULL, NULL, NULL, NULL, 'OS07G0446000 PROTEIN', 240327),
(311522, 'PTHR46325:SF14', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN RIC5', 240327),
(311523, 'PTHR46325:SF12', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN RIC11-LIKE ISOFORM X1', 240327),
(311524, 'PTHR46325:SF34', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN-RELATED', 240327),
(311525, 'PTHR46325:SF19', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN', 240327),
(311526, 'PTHR46325:SF39', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN RIC1', 240327),
(311527, 'PTHR46325:SF17', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN RIC10-LIKE', 240327),
(311528, 'PTHR46325:SF38', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN-RELATED', 240327),
(311529, 'PTHR46325:SF33', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN RIC11', 240327),
(311530, 'PTHR33353:SF4', NULL, NULL, NULL, NULL, 'FUNGAL CELLULOSE BINDING DOMAIN-CONTAINING PROTEIN', 240328),
(311531, 'PTHR33353:SF35', NULL, NULL, NULL, NULL, 'CARBOXYMETHYLCELLULASE D', 240328),
(311532, 'PTHR33353:SF3', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE II', 240328),
(311533, 'PTHR33353:SF13', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE II', 240328),
(311534, 'PTHR33353:SF2', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_2G14540)-RELATED', 240328),
(311535, 'PTHR33353:SF11', NULL, NULL, NULL, NULL, 'GLYCOSYLHYDROLASE FAMILY 61-7 PROTEIN', 240328),
(311536, 'PTHR33353:SF9', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE II', 240328),
(311537, 'PTHR33353:SF34', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_1G12560)-RELATED', 240328),
(311538, 'PTHR33353:SF10', NULL, NULL, NULL, NULL, 'CARBOXYMETHYLCELLULASE D', 240328),
(311539, 'PTHR33353:SF32', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_2G14490)-RELATED', 240328),
(311540, 'PTHR33353:SF6', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE IV', 240328),
(311541, 'PTHR33353:SF1', NULL, NULL, NULL, NULL, '', 240328),
(311542, 'PTHR33353', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_1G12560)-RELATED', 240328),
(311543, 'PTHR33353:SF19', NULL, NULL, NULL, NULL, 'GLYCOSYLHYDROLASE FAMILY 61-8 PROTEIN', 240328),
(311544, 'PTHR33353:SF17', NULL, NULL, NULL, NULL, 'ENDO-BETA-1,4-GLUCANASE D', 240328),
(311545, 'PTHR33353:SF18', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE II', 240328),
(311546, 'PTHR46930', NULL, NULL, NULL, NULL, 'CDK5 REGULATORY SUBUNIT-ASSOCIATED PROTEIN 2', 240329);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(311547, 'PTHR46930:SF1', NULL, NULL, NULL, NULL, 'CDK5 REGULATORY SUBUNIT-ASSOCIATED PROTEIN 2', 240329),
(311548, 'PTHR44029', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 21', 240330),
(311549, 'PTHR44029:SF1', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 21', 240330),
(311550, 'PTHR35105:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CDI-LIKE', 240331),
(311551, 'PTHR35105:SF9', NULL, NULL, NULL, NULL, 'BNAA02G11850D PROTEIN', 240331),
(311552, 'PTHR35105:SF3', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240331),
(311553, 'PTHR35105:SF6', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-DIPHOSPHO-SUGAR TRANSFERASE-RELATED', 240331),
(311554, 'PTHR35105:SF5', NULL, NULL, NULL, NULL, '', 240331),
(311555, 'PTHR35105', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240331),
(311556, 'PTHR35105:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CDI', 240331),
(311557, 'PTHR39602:SF3', NULL, NULL, NULL, NULL, 'SURFACE PROTEIN 1', 240332),
(311558, 'PTHR39602:SF2', NULL, NULL, NULL, NULL, 'ACW-9', 240332),
(311559, 'PTHR39602', NULL, NULL, NULL, NULL, 'ACW-9', 240332),
(311560, 'PTHR10705', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE SUBUNIT DAD1', 240333),
(311561, 'PTHR10705:SF2', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE SUBUNIT DAD1', 240333),
(311562, 'PTHR10705:SF3', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE SUBUNIT DAD1', 240333),
(311563, 'PTHR10705:SF0', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE SUBUNIT DAD1', 240333),
(311564, 'PTHR47258:SF6', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 240334),
(311565, 'PTHR47258:SF5', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 240334),
(311566, 'PTHR47258:SF7', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN', 240334),
(311567, 'PTHR47258:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE XERICO-RELATED', 240334),
(311568, 'PTHR47258', NULL, NULL, NULL, NULL, '', 240334),
(311569, 'PTHR47258:SF4', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE XERICO-RELATED', 240334),
(311570, 'PTHR47258:SF3', NULL, NULL, NULL, NULL, 'F21J9.24-RELATED', 240334),
(311571, 'PTHR33400:SF6', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN LUMINIDEPENDENS', 240335),
(311572, 'PTHR33400:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 6', 240335),
(311573, 'PTHR33400:SF11', NULL, NULL, NULL, NULL, 'C3H1-TYPE DOMAIN-CONTAINING PROTEIN', 240335),
(311574, 'PTHR33400:SF10', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 45-LIKE', 240335),
(311575, 'PTHR33400:SF12', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 45', 240335),
(311576, 'PTHR33400', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 6-RELATED', 240335),
(311577, 'PTHR33400:SF9', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 68', 240335),
(311578, 'PTHR33400:SF8', NULL, NULL, NULL, NULL, 'C3H1-TYPE DOMAIN-CONTAINING PROTEIN', 240335),
(311579, 'PTHR28333:SF1', NULL, NULL, NULL, NULL, 'SI:CH211-214J24.10', 240336),
(311580, 'PTHR28333', NULL, NULL, NULL, NULL, 'NUCLEAR FRAGILE X MENTAL RETARDATION-INTERACTING PROTEIN 2', 240336),
(311581, 'PTHR28333:SF2', NULL, NULL, NULL, NULL, 'NUCLEAR FRAGILE X MENTAL RETARDATION-INTERACTING PROTEIN 2', 240336),
(311582, 'PTHR15703', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4931406P16 GENE', 240337),
(311583, 'PTHR15703:SF3', NULL, NULL, NULL, NULL, 'GRANULE ASSOCIATED RAC AND RHOG EFFECTOR PROTEIN 1', 240337),
(311584, 'PTHR47379:SF3', NULL, NULL, NULL, NULL, 'SIALYLTRANSFERASE-LIKE PROTEIN 2', 240338),
(311585, 'PTHR47379', NULL, NULL, NULL, NULL, 'SIALYLTRANSFERASE-LIKE PROTEIN 2', 240338),
(311586, 'PTHR35734', NULL, NULL, NULL, NULL, 'OS01G0805200 PROTEIN', 240339),
(311587, 'PTHR35734:SF1', NULL, NULL, NULL, NULL, 'OS01G0805200 PROTEIN', 240339),
(311588, 'PTHR47630:SF2', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-61', 240340);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(311589, 'PTHR47630:SF1', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-4', 240340),
(311590, 'PTHR47630:SF6', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 240340),
(311591, 'PTHR47630', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY-RELATED-RELATED', 240340),
(311592, 'PTHR47630:SF5', NULL, NULL, NULL, NULL, 'NR LBD DOMAIN-CONTAINING PROTEIN', 240340),
(311593, 'PTHR47630:SF4', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-62', 240340),
(311594, 'PTHR47630:SF3', NULL, NULL, NULL, NULL, 'NR LBD DOMAIN-CONTAINING PROTEIN', 240340),
(311595, 'PTHR47630:SF8', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-34', 240340),
(311596, 'PTHR47630:SF7', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 240340),
(311597, 'PTHR30383:SF19', NULL, NULL, NULL, NULL, 'SGNH_HYDRO DOMAIN-CONTAINING PROTEIN', 240341),
(311598, 'PTHR30383:SF29', NULL, NULL, NULL, NULL, 'SGNH_HYDRO DOMAIN-CONTAINING PROTEIN', 240341),
(311599, 'PTHR30383:SF28', NULL, NULL, NULL, NULL, 'LIPASE/ACYLHYDROLASE-RELATED', 240341),
(311600, 'PTHR30383:SF30', NULL, NULL, NULL, NULL, 'SGNH_HYDRO DOMAIN-CONTAINING PROTEIN', 240341),
(311601, 'PTHR30383:SF21', NULL, NULL, NULL, NULL, 'SGNH_HYDRO DOMAIN-CONTAINING PROTEIN', 240341),
(311602, 'PTHR30383', NULL, NULL, NULL, NULL, 'THIOESTERASE 1/PROTEASE 1/LYSOPHOSPHOLIPASE L1', 240341),
(311603, 'PTHR30383:SF27', NULL, NULL, NULL, NULL, 'SPORE GERMINATION LIPASE LIPC', 240341),
(311604, 'PTHR30383:SF5', NULL, NULL, NULL, NULL, 'SGNH_HYDRO DOMAIN-CONTAINING PROTEIN-RELATED', 240341),
(311605, 'PTHR30383:SF26', NULL, NULL, NULL, NULL, 'SGNH_HYDRO DOMAIN-CONTAINING PROTEIN', 240341),
(311606, 'PTHR30383:SF2', NULL, NULL, NULL, NULL, 'CELLULOSE-BINDING PROTEIN', 240341),
(311607, 'PTHR30383:SF24', NULL, NULL, NULL, NULL, 'THIOESTERASE 1/PROTEASE 1/LYSOPHOSPHOLIPASE L1', 240341),
(311608, 'PTHR39145', NULL, NULL, NULL, NULL, 'BIOGENESIS OF LYSOSOME-RELATED ORGANELLES COMPLEX 1 SUBUNIT CNL1', 240342),
(311609, 'PTHR39145:SF1', NULL, NULL, NULL, NULL, 'BIOGENESIS OF LYSOSOME-RELATED ORGANELLES COMPLEX 1 SUBUNIT CNL1', 240342),
(311610, 'PTHR34201:SF10', NULL, NULL, NULL, NULL, 'BNAA08G02590D PROTEIN', 240343),
(311611, 'PTHR34201:SF11', NULL, NULL, NULL, NULL, '', 240343),
(311612, 'PTHR34201:SF12', NULL, NULL, NULL, NULL, 'PROTEIN TRIGALACTOSYLDIACYLGLYCEROL 5, CHLOROPLASTIC', 240343),
(311613, 'PTHR34201:SF9', NULL, NULL, NULL, NULL, 'BNAA02G12570D PROTEIN', 240343),
(311614, 'PTHR34201:SF1', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN', 240343),
(311615, 'PTHR34201:SF8', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240343),
(311616, 'PTHR34201', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN', 240343),
(311617, 'PTHR34201:SF5', NULL, NULL, NULL, NULL, '', 240343),
(311618, 'PTHR34201:SF6', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN', 240343),
(311619, 'PTHR31631', NULL, NULL, NULL, NULL, 'PROTEIN NETWORKED 2D', 240344),
(311620, 'PTHR31631:SF9', NULL, NULL, NULL, NULL, 'KINASE-INTERACTING PROTEIN 1-LIKE', 240344),
(311621, 'PTHR31631:SF8', NULL, NULL, NULL, NULL, 'PROTEIN NETWORKED 2C', 240344),
(311622, 'PTHR31631:SF5', NULL, NULL, NULL, NULL, 'PROTEIN NETWORKED 2D', 240344),
(311623, 'PTHR31631:SF6', NULL, NULL, NULL, NULL, 'KINASE-INTERACTING PROTEIN 1-LIKE', 240344),
(311624, 'PTHR31631:SF3', NULL, NULL, NULL, NULL, 'PROTEIN NETWORKED 2B', 240344),
(311625, 'PTHR31631:SF4', NULL, NULL, NULL, NULL, 'OS07G0695400 PROTEIN', 240344),
(311626, 'PTHR31631:SF1', NULL, NULL, NULL, NULL, 'OS05G0466200 PROTEIN', 240344),
(311627, 'PTHR31631:SF15', NULL, NULL, NULL, NULL, 'KINASE INTERACTING (KIP1-LIKE) FAMILY PROTEIN', 240344),
(311628, 'PTHR31631:SF0', NULL, NULL, NULL, NULL, 'PROTEIN NETWORKED 2D', 240344),
(311629, 'PTHR31631:SF18', NULL, NULL, NULL, NULL, 'PROTEIN NETWORKED 2A', 240344),
(311630, 'PTHR31631:SF19', NULL, NULL, NULL, NULL, 'OS01G0835800 PROTEIN', 240344),
(311631, 'PTHR48057:SF11', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240345),
(311632, 'PTHR48057:SF7', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT SERINE/THREONINE-PROTEIN KINASE 1', 240345);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(311633, 'PTHR48057:SF13', NULL, NULL, NULL, NULL, 'PROTEIN KINASE, PLANT-TYPE, PUTATIVE-RELATED', 240345),
(311634, 'PTHR48057:SF12', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 240345),
(311635, 'PTHR48057:SF5', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT (LRR) FAMILY PROTEIN-RELATED', 240345),
(311636, 'PTHR48057:SF9', NULL, NULL, NULL, NULL, 'DNA-DAMAGE-REPAIR/TOLERATION DRT100-LIKE PROTEIN', 240345),
(311637, 'PTHR48057', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT SERINE/THREONINE-PROTEIN KINASE 1', 240345),
(311638, 'PTHR48057:SF15', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE', 240345),
(311639, 'PTHR48057:SF14', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT FAMILY PROTEIN', 240345),
(311640, 'PTHR48057:SF2', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN-LIKE', 240345),
(311641, 'PTHR48057:SF1', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE GSO2', 240345),
(311642, 'PTHR48057:SF16', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240345),
(311643, 'PTHR23192:SF85', NULL, NULL, NULL, NULL, 'FI21454P1', 240346),
(311644, 'PTHR23192:SF83', NULL, NULL, NULL, NULL, 'OLFACTOMEDIN-LIKE DOMAIN-CONTAINING PROTEIN', 240346),
(311645, 'PTHR23192:SF80', NULL, NULL, NULL, NULL, 'OLFACTOMEDIN 2B', 240346),
(311646, 'PTHR23192', NULL, NULL, NULL, NULL, 'OLFACTOMEDIN-RELATED', 240346),
(311647, 'PTHR23192:SF27', NULL, NULL, NULL, NULL, 'NOELIN-2', 240346),
(311648, 'PTHR23192:SF49', NULL, NULL, NULL, NULL, 'OLFACTOMEDIN-LIKE PROTEIN 3B', 240346),
(311649, 'PTHR23192:SF68', NULL, NULL, NULL, NULL, 'SI:CH211-194M7.3', 240346),
(311650, 'PTHR23192:SF86', NULL, NULL, NULL, NULL, 'OLFACTOMEDIN 3B', 240346),
(311651, 'PTHR23192:SF29', NULL, NULL, NULL, NULL, 'OLFACTOMEDIN-LIKE PROTEIN 2A', 240346),
(311652, 'PTHR23192:SF5', NULL, NULL, NULL, NULL, 'GLIOMEDIN', 240346),
(311653, 'PTHR23192:SF7', NULL, NULL, NULL, NULL, 'OLFACTOMEDIN-4', 240346),
(311654, 'PTHR23192:SF8', NULL, NULL, NULL, NULL, 'OLFACTOMEDIN-LIKE PROTEIN 3', 240346),
(311655, 'PTHR23192:SF73', NULL, NULL, NULL, NULL, 'ADHESION G PROTEIN-COUPLED RECEPTOR L3.1', 240346),
(311656, 'PTHR23192:SF71', NULL, NULL, NULL, NULL, 'ADHESION G PROTEIN-COUPLED RECEPTOR L1', 240346),
(311657, 'PTHR23192:SF70', NULL, NULL, NULL, NULL, 'ADHESION G PROTEIN-COUPLED RECEPTOR L2B, TANDEM DUPLICATE 1-RELATED', 240346),
(311658, 'PTHR23192:SF37', NULL, NULL, NULL, NULL, 'OLFACTOMEDIN-LIKE PROTEIN 2B', 240346),
(311659, 'PTHR23192:SF13', NULL, NULL, NULL, NULL, 'OLFACTOMEDIN-LIKE PROTEIN 1', 240346),
(311660, 'PTHR23192:SF79', NULL, NULL, NULL, NULL, 'OLFACTOMEDIN-LIKE 2BB', 240346),
(311661, 'PTHR23192:SF35', NULL, NULL, NULL, NULL, 'OLFACTOMEDIN-LIKE DOMAIN-CONTAINING PROTEIN', 240346),
(311662, 'PTHR23192:SF36', NULL, NULL, NULL, NULL, 'NOELIN-3', 240346),
(311663, 'PTHR23192:SF33', NULL, NULL, NULL, NULL, 'MYOCILIN', 240346),
(311664, 'PTHR23192:SF34', NULL, NULL, NULL, NULL, 'NOELIN', 240346),
(311665, 'PTHR23192:SF75', NULL, NULL, NULL, NULL, 'ADHESION G PROTEIN-COUPLED RECEPTOR L3', 240346),
(311666, 'PTHR23192:SF31', NULL, NULL, NULL, NULL, 'SI:CH211-147M6.1-RELATED', 240346),
(311667, 'PTHR23192:SF32', NULL, NULL, NULL, NULL, 'OLFACTOMEDIN 5', 240346),
(311668, 'PTHR12775:SF0', NULL, NULL, NULL, NULL, 'REPLICATION TERMINATION FACTOR 2', 240347),
(311669, 'PTHR12775:SF1', NULL, NULL, NULL, NULL, 'REPLICATION TERMINATION FACTOR 2', 240347),
(311670, 'PTHR12775', NULL, NULL, NULL, NULL, 'PROTEIN C20ORF43 HOMOLOG', 240347),
(311671, 'PTHR12775:SF2', NULL, NULL, NULL, NULL, 'REPLICATION TERMINATION FACTOR 2', 240347),
(311672, 'PTHR39413:SF1', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 136', 240348),
(311673, 'PTHR39413', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 136', 240348),
(311674, 'PTHR13413', NULL, NULL, NULL, NULL, 'YLP MOTIF CONTAINING PROTEIN NUCLEAR PROTEIN ZAP', 240349),
(311675, 'PTHR13413:SF0', NULL, NULL, NULL, NULL, 'YLP MOTIF-CONTAINING PROTEIN 1', 240349),
(311676, 'PTHR31291', NULL, NULL, NULL, NULL, 'ALPHA-KETOGLUTARATE-DEPENDENT DIOXYGENASE FTO', 240350),
(311677, 'PTHR31291:SF2', NULL, NULL, NULL, NULL, 'ALPHA-KETOGLUTARATE-DEPENDENT DIOXYGENASE FTO', 240350);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(311678, 'PTHR46454:SF2', NULL, NULL, NULL, NULL, 'DHC_N2 DOMAIN-CONTAINING PROTEIN', 240351),
(311679, 'PTHR46454', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL HEAVY CHAIN 7-RELATED', 240351),
(311680, 'PTHR46454:SF17', NULL, NULL, NULL, NULL, 'DHC_N2 DOMAIN-CONTAINING PROTEIN', 240351),
(311681, 'PTHR48066:SF1', NULL, NULL, NULL, NULL, 'CARNOSINE SYNTHASE 1', 240352),
(311682, 'PTHR48066', NULL, NULL, NULL, NULL, 'CARNOSINE SYNTHASE 1', 240352),
(311683, 'PTHR12553:SF66', NULL, NULL, NULL, NULL, 'RIBONUCLEASE Z', 240353),
(311684, 'PTHR12553:SF65', NULL, NULL, NULL, NULL, 'TRNASE Z TRZ4, MITOCHONDRIAL', 240353),
(311685, 'PTHR12553:SF54', NULL, NULL, NULL, NULL, 'LACTAMASE_B DOMAIN-CONTAINING PROTEIN', 240353),
(311686, 'PTHR12553:SF49', NULL, NULL, NULL, NULL, 'ZINC PHOSPHODIESTERASE ELAC PROTEIN 2', 240353),
(311687, 'PTHR12553', NULL, NULL, NULL, NULL, 'ZINC PHOSPHODIESTERASE ELAC PROTEIN 2', 240353),
(311688, 'PTHR12553:SF71', NULL, NULL, NULL, NULL, 'RIBONUCLEASE Z', 240353),
(311689, 'PTHR12553:SF70', NULL, NULL, NULL, NULL, 'LACTAMASE_B DOMAIN-CONTAINING PROTEIN', 240353),
(311690, 'PTHR12553:SF73', NULL, NULL, NULL, NULL, 'RIBONUCLEASE Z 1', 240353),
(311691, 'PTHR12553:SF72', NULL, NULL, NULL, NULL, 'RIBONUCLEASE Z', 240353),
(311692, 'PTHR12553:SF64', NULL, NULL, NULL, NULL, 'RIBONUCLEASE Z', 240353),
(311693, 'PTHR12553:SF63', NULL, NULL, NULL, NULL, 'RIBONUCLEASE Z', 240353),
(311694, 'PTHR35545:SF16', NULL, NULL, NULL, NULL, 'OS07G0554800 PROTEIN', 240354),
(311695, 'PTHR35545:SF27', NULL, NULL, NULL, NULL, 'OS07G0645701 PROTEIN', 240354),
(311696, 'PTHR35545:SF8', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 240354),
(311697, 'PTHR35545:SF17', NULL, NULL, NULL, NULL, 'OS03G0157000 PROTEIN', 240354),
(311698, 'PTHR35545:SF28', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240354),
(311699, 'PTHR35545:SF18', NULL, NULL, NULL, NULL, '', 240354),
(311700, 'PTHR35545:SF29', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240354),
(311701, 'PTHR35545:SF19', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240354),
(311702, 'PTHR35545:SF12', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240354),
(311703, 'PTHR35545:SF13', NULL, NULL, NULL, NULL, '', 240354),
(311704, 'PTHR35545:SF26', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240354),
(311705, 'PTHR35545:SF20', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240354),
(311706, 'PTHR35545:SF31', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240354),
(311707, 'PTHR35545:SF32', NULL, NULL, NULL, NULL, 'OS05G0541600 PROTEIN', 240354),
(311708, 'PTHR35545:SF33', NULL, NULL, NULL, NULL, '', 240354),
(311709, 'PTHR35545:SF11', NULL, NULL, NULL, NULL, 'OS04G0376200 PROTEIN', 240354),
(311710, 'PTHR35545:SF22', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240354),
(311711, 'PTHR35545', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240354),
(311712, 'PTHR33122:SF50', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 240355),
(311713, 'PTHR33122:SF72', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 240355),
(311714, 'PTHR33122:SF73', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', 240355),
(311715, 'PTHR33122:SF74', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', 240355),
(311716, 'PTHR33122:SF57', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 240355),
(311717, 'PTHR33122:SF13', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', 240355),
(311718, 'PTHR33122:SF36', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 240355),
(311719, 'PTHR33122:SF58', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 240355),
(311720, 'PTHR33122:SF59', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 240355),
(311721, 'PTHR33122:SF75', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 240355);
INSERT INTO "PUBLIC"."MODEL" VALUES
(311722, 'PTHR33122:SF76', NULL, NULL, NULL, NULL, 'LIPID BINDING PROTEIN', 240355),
(311723, 'PTHR33122:SF33', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', 240355),
(311724, 'PTHR33122:SF77', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', 240355),
(311725, 'PTHR33122:SF55', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 240355),
(311726, 'PTHR33122:SF56', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 240355),
(311727, 'PTHR33122:SF78', NULL, NULL, NULL, NULL, 'ECA1-LIKE GAMETOGENESIS RELATED FAMILY PROTEIN', 240355),
(311728, 'PTHR33122:SF39', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 240355),
(311729, 'PTHR33122:SF4', NULL, NULL, NULL, NULL, 'OS04G0415800 PROTEIN', 240355),
(311730, 'PTHR33122', NULL, NULL, NULL, NULL, 'LIPID BINDING PROTEIN-RELATED', 240355),
(311731, 'PTHR33122:SF7', NULL, NULL, NULL, NULL, 'OS05G0160300 PROTEIN', 240355),
(311732, 'PTHR33122:SF60', NULL, NULL, NULL, NULL, 'LIPID-TRANSFER PROTEIN DIR1-RELATED', 240355),
(311733, 'PTHR33122:SF40', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', 240355),
(311734, 'PTHR33122:SF62', NULL, NULL, NULL, NULL, 'OS01G0914300 PROTEIN', 240355),
(311735, 'PTHR33122:SF63', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 240355),
(311736, 'PTHR33122:SF41', NULL, NULL, NULL, NULL, 'PVR3-LIKE PROTEIN', 240355),
(311737, 'PTHR33122:SF46', NULL, NULL, NULL, NULL, 'OS07G0290200 PROTEIN', 240355),
(311738, 'PTHR33122:SF69', NULL, NULL, NULL, NULL, 'LIPID TRANSFER PROTEIN', 240355),
(311739, 'PTHR33122:SF43', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 240355),
(311740, 'PTHR33122:SF65', NULL, NULL, NULL, NULL, 'INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN, PUTATIVE-RELATED', 240355),
(311741, 'PTHR33122:SF45', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 240355),
(311742, 'PTHR33122:SF67', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 240355),
(311743, 'PTHR47215:SF6', NULL, NULL, NULL, NULL, 'FAD-BINDING FR-TYPE DOMAIN-CONTAINING PROTEIN', 240356),
(311744, 'PTHR47215', NULL, NULL, NULL, NULL, '', 240356),
(311745, 'PTHR47215:SF3', NULL, NULL, NULL, NULL, '', 240356),
(311746, 'PTHR47215:SF2', NULL, NULL, NULL, NULL, 'FAD/NAD(P)-BINDING OXIDOREDUCTASE', 240356),
(311747, 'PTHR47215:SF1', NULL, NULL, NULL, NULL, 'F9L1.8 PROTEIN', 240356),
(311748, 'PTHR47884:SF1', NULL, NULL, NULL, NULL, 'PROSTATE AND TESTIS EXPRESSED PROTEIN 2', 240357),
(311749, 'PTHR47884', NULL, NULL, NULL, NULL, 'PROSTATE AND TESTIS EXPRESSED PROTEIN 2', 240357),
(311750, 'PTHR21569', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S9', 240358),
(311751, 'PTHR21569:SF43', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S16-LIKE', 240358),
(311752, 'PTHR21569:SF42', NULL, NULL, NULL, NULL, '', 240358),
(311753, 'PTHR21569:SF31', NULL, NULL, NULL, NULL, 'BNAC05G47390D PROTEIN', 240358),
(311754, 'PTHR21569:SF34', NULL, NULL, NULL, NULL, 'BNAA05G33140D PROTEIN', 240358),
(311755, 'PTHR21569:SF44', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S16', 240358),
(311756, 'PTHR21569:SF22', NULL, NULL, NULL, NULL, '', 240358),
(311757, 'PTHR21569:SF33', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S16-LIKE', 240358),
(311758, 'PTHR21569:SF27', NULL, NULL, NULL, NULL, 'BNAA03G57330D PROTEIN', 240358),
(311759, 'PTHR21569:SF16', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S16', 240358),
(311760, 'PTHR21569:SF38', NULL, NULL, NULL, NULL, 'BNAA03G07060D PROTEIN', 240358),
(311761, 'PTHR21569:SF37', NULL, NULL, NULL, NULL, '', 240358),
(311762, 'PTHR21569:SF26', NULL, NULL, NULL, NULL, 'BNAC03G22570D PROTEIN', 240358),
(311763, 'PTHR21569:SF29', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S16-LIKE', 240358),
(311764, 'PTHR21569:SF1', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S9, MITOCHONDRIAL', 240358),
(311765, 'PTHR21569:SF41', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S16', 240358);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(311766, 'PTHR21569:SF40', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S16', 240358),
(311767, 'PTHR11022:SF40', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN RECOGNITION PROTEIN 4', 240359),
(311768, 'PTHR11022:SF73', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN-RECOGNITION PROTEIN LD', 240359),
(311769, 'PTHR11022:SF72', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN RECOGNITION PROTEIN 2', 240359),
(311770, 'PTHR11022:SF69', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN RECOGNITION PROTEIN 6', 240359),
(311771, 'PTHR11022:SF58', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN RECOGNITION PROTEIN 1', 240359),
(311772, 'PTHR11022:SF68', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN-RECOGNITION PROTEIN LC-RELATED', 240359),
(311773, 'PTHR11022:SF12', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN RECOGNITION PROTEIN 3', 240359),
(311774, 'PTHR11022:SF66', NULL, NULL, NULL, NULL, 'N-ACETYLMURAMOYL-L-ALANINE AMIDASE', 240359),
(311775, 'PTHR11022:SF76', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN-RECOGNITION PROTEIN LA', 240359),
(311776, 'PTHR11022:SF75', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN-RECOGNITION PROTEIN LB-RELATED', 240359),
(311777, 'PTHR11022:SF41', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN RECOGNITION PROTEIN 5', 240359),
(311778, 'PTHR11022:SF74', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN-RECOGNITION PROTEIN SA', 240359),
(311779, 'PTHR11022', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN RECOGNITION PROTEIN', 240359),
(311780, 'PTHR45761:SF1', NULL, NULL, NULL, NULL, 'EXTENDED SYNAPTOTAGMIN-LIKE PROTEIN 2, ISOFORM C', 240360),
(311781, 'PTHR45761:SF6', NULL, NULL, NULL, NULL, 'EXTENDED SYNAPTOTAGMIN-LIKE PROTEIN 2A', 240360),
(311782, 'PTHR45761', NULL, NULL, NULL, NULL, 'EXTENDED SYNAPTOTAGMIN-LIKE PROTEIN 2, ISOFORM C', 240360),
(311783, 'PTHR45761:SF2', NULL, NULL, NULL, NULL, 'EXTENDED SYNAPTOTAGMIN-2', 240360),
(311784, 'PTHR45761:SF3', NULL, NULL, NULL, NULL, 'EXTENDED SYNAPTOTAGMIN-1', 240360),
(311785, 'PTHR45761:SF4', NULL, NULL, NULL, NULL, 'EXTENDED SYNAPTOTAGMIN-3', 240360),
(311786, 'PTHR10709:SF17', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 2/3 COMPLEX SUBUNIT', 240361),
(311787, 'PTHR10709:SF18', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 240361),
(311788, 'PTHR10709:SF19', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 240361),
(311789, 'PTHR10709:SF10', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 2/3 COMPLEX SUBUNIT 1B', 240361),
(311790, 'PTHR10709:SF11', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 2/3 COMPLEX SUBUNIT 1A', 240361),
(311791, 'PTHR10709:SF2', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 2/3 COMPLEX SUBUNIT', 240361),
(311792, 'PTHR10709', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 2/3 COMPLEX SUBUNIT 1', 240361),
(311793, 'PTHR37247', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 240362),
(311794, 'PTHR37247:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 240362),
(311795, 'PTHR28511:SF2', NULL, NULL, NULL, NULL, '', 240363),
(311796, 'PTHR28511:SF3', NULL, NULL, NULL, NULL, 'V, PUTATIVE-RELATED', 240363),
(311797, 'PTHR28511:SF1', NULL, NULL, NULL, NULL, 'ENDONUCLEASE V', 240363),
(311798, 'PTHR28511', NULL, NULL, NULL, NULL, 'ENDONUCLEASE V', 240363),
(311799, 'PTHR43257:SF2', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT SUBUNIT BETA', 240364),
(311800, 'PTHR43257', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT BETA SUBUNIT', 240364),
(311801, 'PTHR43257:SF3', NULL, NULL, NULL, NULL, 'ACETOIN:2,6-DICHLOROPHENOLINDOPHENOL OXIDOREDUCTASE SUBUNIT BETA', 240364),
(311802, 'PTHR14385', NULL, NULL, NULL, NULL, 'CXC CHEMOKINE LIGAND', 240365),
(311803, 'PTHR14385:SF0', NULL, NULL, NULL, NULL, 'C-X-C MOTIF CHEMOKINE 16', 240365),
(311804, 'PTHR16926', NULL, NULL, NULL, NULL, 'INTERLEUKIN 9', 240366),
(311805, 'PTHR16926:SF1', NULL, NULL, NULL, NULL, 'INTERLEUKIN-9', 240366),
(311806, 'PTHR46314:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG17655', 240367),
(311807, 'PTHR46314:SF2', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 25 MEMBER 44', 240367),
(311808, 'PTHR46314', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 25 MEMBER 44', 240367);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(311809, 'PTHR22969:SF10', NULL, NULL, NULL, NULL, 'INHIBITOR OF NUCLEAR FACTOR KAPPA-B KINASE SUBUNIT EPSILON', 240368),
(311810, 'PTHR22969', NULL, NULL, NULL, NULL, 'IKB KINASE', 240368),
(311811, 'PTHR22969:SF14', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE TBK1', 240368),
(311812, 'PTHR22969:SF15', NULL, NULL, NULL, NULL, 'FI05319P', 240368),
(311813, 'PTHR22969:SF13', NULL, NULL, NULL, NULL, 'INHIBITOR OF NUCLEAR FACTOR KAPPA-B KINASE SUBUNIT ALPHA', 240368),
(311814, 'PTHR22969:SF7', NULL, NULL, NULL, NULL, 'INHIBITOR OF NUCLEAR FACTOR KAPPA-B KINASE SUBUNIT BETA', 240368),
(311815, 'PTHR22969:SF17', NULL, NULL, NULL, NULL, 'INHIBITOR OF NUCLEAR FACTOR KAPPA-B KINASE SUBUNIT BETA', 240368),
(311816, 'PTHR45796:SF1', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN P2', 240369),
(311817, 'PTHR45796:SF3', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN P1', 240369),
(311818, 'PTHR45796:SF2', NULL, NULL, NULL, NULL, 'FORKHEAD BOX P3-RELATED', 240369),
(311819, 'PTHR45796:SF5', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN P3', 240369),
(311820, 'PTHR45796:SF4', NULL, NULL, NULL, NULL, 'FORKHEAD BOX P, ISOFORM C', 240369),
(311821, 'PTHR45796:SF7', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN P4', 240369),
(311822, 'PTHR45796:SF9', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN P2', 240369),
(311823, 'PTHR45796', NULL, NULL, NULL, NULL, 'FORKHEAD BOX P, ISOFORM C', 240369),
(311824, 'PTHR40387:SF4', NULL, NULL, NULL, NULL, 'PROTEIN FAM240C', 240370),
(311825, 'PTHR40387:SF3', NULL, NULL, NULL, NULL, 'PROTEIN FAM240A', 240370),
(311826, 'PTHR40387', NULL, NULL, NULL, NULL, 'PROTEIN FAM240B', 240370),
(311827, 'PTHR40387:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAM240B', 240370),
(311828, 'PTHR10036:SF3', NULL, NULL, NULL, NULL, 'UPAR/LY6 DOMAIN-CONTAINING PROTEIN', 240371),
(311829, 'PTHR10036:SF17', NULL, NULL, NULL, NULL, 'SECRETED LY-6/UPAR-RELATED PROTEIN 1', 240371),
(311830, 'PTHR10036:SF18', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 6 FAMILY MEMBER PGE', 240371),
(311831, 'PTHR10036:SF23', NULL, NULL, NULL, NULL, 'MAC-INHIBITORY PROTEIN', 240371),
(311832, 'PTHR10036:SF13', NULL, NULL, NULL, NULL, 'CD59 MOLECULE (CD59 BLOOD GROUP)', 240371),
(311833, 'PTHR10036:SF24', NULL, NULL, NULL, NULL, 'CD59 GLYCOPROTEIN', 240371),
(311834, 'PTHR10036:SF14', NULL, NULL, NULL, NULL, 'SI:CH211-113D22.2', 240371),
(311835, 'PTHR10036:SF25', NULL, NULL, NULL, NULL, 'HEP21 PROTEIN', 240371),
(311836, 'PTHR10036:SF26', NULL, NULL, NULL, NULL, '', 240371),
(311837, 'PTHR10036', NULL, NULL, NULL, NULL, 'CD59 GLYCOPROTEIN', 240371),
(311838, 'PTHR10036:SF22', NULL, NULL, NULL, NULL, 'TOXIN_TOLIP DOMAIN-CONTAINING PROTEIN', 240371),
(311839, 'PTHR10036:SF11', NULL, NULL, NULL, NULL, 'LY6/PLAUR DOMAIN-CONTAINING PROTEIN 2', 240371),
(311840, 'PTHR10036:SF7', NULL, NULL, NULL, NULL, 'LY6/PLAUR DOMAIN-CONTAINING PROTEIN 1', 240371),
(311841, 'PTHR36289', NULL, NULL, NULL, NULL, 'CHROMOSOME 12 OPEN READING FRAME 60', 240372),
(311842, 'PTHR36289:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 12 OPEN READING FRAME 60', 240372),
(311843, 'PTHR11370', NULL, NULL, NULL, NULL, 'DNA-REPAIR PROTEIN XRCC1', 240373),
(311844, 'PTHR11370:SF4', NULL, NULL, NULL, NULL, 'XRCC1_N DOMAIN-CONTAINING PROTEIN', 240373),
(311845, 'PTHR11370:SF5', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN XRCC1', 240373),
(311846, 'PTHR12766:SF10', NULL, NULL, NULL, NULL, 'DAXX-LIKE PROTEIN', 240374),
(311847, 'PTHR12766', NULL, NULL, NULL, NULL, 'DEATH DOMAIN-ASSOCIATED PROTEIN 6 DAXX', 240374),
(311848, 'PTHR12766:SF11', NULL, NULL, NULL, NULL, '', 240374),
(311849, 'PTHR12766:SF12', NULL, NULL, NULL, NULL, '', 240374),
(311850, 'PTHR12766:SF7', NULL, NULL, NULL, NULL, 'ELICITIN PROTEIN RAM2APUTATIVE ELICITIN PROTEIN RAM2BPUTATIVE ELICITIN PROTEIN RAM2C-RELATED', 240374),
(311851, 'PTHR12766:SF9', NULL, NULL, NULL, NULL, 'DEATH DOMAIN-ASSOCIATED PROTEIN 6', 240374),
(311852, 'PTHR11908:SF158', NULL, NULL, NULL, NULL, 'OXIDASE, PUTATIVE-RELATED', 240375),
(311853, 'PTHR11908:SF92', NULL, NULL, NULL, NULL, 'ALDEHYDE OXIDASE 1-RELATED', 240375);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(311854, 'PTHR11908:SF159', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETALDEHYDE OXIDASE-LIKE', 240375),
(311855, 'PTHR11908:SF134', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETALDEHYDE OXIDASE', 240375),
(311856, 'PTHR11908:SF157', NULL, NULL, NULL, NULL, 'XANTHINE DEHYDROGENASE SUBUNIT D-RELATED', 240375),
(311857, 'PTHR11908:SF135', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETALDEHYDE OXIDASE', 240375),
(311858, 'PTHR11908:SF139', NULL, NULL, NULL, NULL, 'ALDEHYDE OXIDASE GAD-3-RELATED', 240375),
(311859, 'PTHR11908:SF150', NULL, NULL, NULL, NULL, 'BENZALDEHYDE DEHYDROGENASE (NAD(+))-LIKE', 240375),
(311860, 'PTHR11908:SF99', NULL, NULL, NULL, NULL, 'ALDEHYDE OXIDASE 3', 240375),
(311861, 'PTHR11908:SF151', NULL, NULL, NULL, NULL, 'BNAA06G19620D PROTEIN', 240375),
(311862, 'PTHR11908:SF98', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETALDEHYDE OXIDASE', 240375),
(311863, 'PTHR11908:SF132', NULL, NULL, NULL, NULL, 'ALDEHYDE OXIDASE 1-RELATED', 240375),
(311864, 'PTHR11908:SF133', NULL, NULL, NULL, NULL, 'ABSCISIC-ALDEHYDE OXIDASE-LIKE', 240375),
(311865, 'PTHR11908:SF152', NULL, NULL, NULL, NULL, 'ALDEHYDE OXIDASE', 240375),
(311866, 'PTHR11908:SF130', NULL, NULL, NULL, NULL, 'XANTHINE DEHYDROGENASE', 240375),
(311867, 'PTHR11908:SF153', NULL, NULL, NULL, NULL, 'DEHYDROGENASE', 240375),
(311868, 'PTHR11908', NULL, NULL, NULL, NULL, 'XANTHINE DEHYDROGENASE', 240375),
(311869, 'PTHR11908:SF80', NULL, NULL, NULL, NULL, 'XANTHINE DEHYDROGENASE/OXIDASE', 240375),
(311870, 'PTHR11908:SF148', NULL, NULL, NULL, NULL, 'BNAA02G05170D PROTEIN', 240375),
(311871, 'PTHR11908:SF123', NULL, NULL, NULL, NULL, 'ALDEHYDE OXIDOREDUCTASE MOLYBDENUM-BINDING SUBUNIT PAOC', 240375),
(311872, 'PTHR11908:SF129', NULL, NULL, NULL, NULL, 'XANTHINE DEHYDROGENASE', 240375),
(311873, 'PTHR11908:SF84', NULL, NULL, NULL, NULL, 'ALDEHYDE OXIDASE 2', 240375),
(311874, 'PTHR11908:SF88', NULL, NULL, NULL, NULL, 'ALDEHYDE OXIDASE 4', 240375),
(311875, 'PTHR11908:SF140', NULL, NULL, NULL, NULL, 'ABSCISIC-ALDEHYDE OXIDASE-RELATED', 240375),
(311876, 'PTHR11908:SF89', NULL, NULL, NULL, NULL, 'ALDEHYDE OXIDASE-LIKE PROTEIN-RELATED', 240375),
(311877, 'PTHR11908:SF86', NULL, NULL, NULL, NULL, 'ALDEHYDE OXIDASE', 240375),
(311878, 'PTHR11908:SF143', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETALDEHYDE OXIDASE', 240375),
(311879, 'PTHR11908:SF144', NULL, NULL, NULL, NULL, 'BNAA09G00610D PROTEIN', 240375),
(311880, 'PTHR11908:SF100', NULL, NULL, NULL, NULL, 'XANTHINE DEHYDROGENASE', 240375),
(311881, 'PTHR11908:SF141', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETALDEHYDE OXIDASE-LIKE', 240375),
(311882, 'PTHR11908:SF142', NULL, NULL, NULL, NULL, 'ALDEHYDE OXIDASE3', 240375),
(311883, 'PTHR36879:SF1', NULL, NULL, NULL, NULL, 'GLUTAMATE-RICH PROTEIN 4', 240376),
(311884, 'PTHR36879', NULL, NULL, NULL, NULL, 'GLUTAMATE-RICH PROTEIN 4', 240376),
(311885, 'PTHR35805:SF1', NULL, NULL, NULL, NULL, 'ASPARTATE CARBAMOYLTRANSFERASE REGULATORY CHAIN', 240377),
(311886, 'PTHR35805', NULL, NULL, NULL, NULL, 'ASPARTATE CARBAMOYLTRANSFERASE REGULATORY CHAIN', 240377),
(311887, 'PTHR24409:SF407', NULL, NULL, NULL, NULL, '', 240378),
(311888, 'PTHR24409:SF308', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN CONTAINING 11', 240378),
(311889, 'PTHR24409:SF429', NULL, NULL, NULL, NULL, '', 240378),
(311890, 'PTHR24409:SF428', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 91-LIKE PROTEIN', 240378),
(311891, 'PTHR24409:SF306', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 423', 240378),
(311892, 'PTHR24409:SF427', NULL, NULL, NULL, NULL, '', 240378),
(311893, 'PTHR24409:SF426', NULL, NULL, NULL, NULL, 'LD43035P', 240378),
(311894, 'PTHR24409:SF409', NULL, NULL, NULL, NULL, '', 240378),
(311895, 'PTHR24409:SF408', NULL, NULL, NULL, NULL, 'FI01031P-RELATED', 240378),
(311896, 'PTHR24409:SF421', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 240378),
(311897, 'PTHR24409:SF420', NULL, NULL, NULL, NULL, 'IP01303P', 240378),
(311898, 'PTHR24409:SF363', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN CONTAINING 16', 240378),
(311899, 'PTHR24409:SF326', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 507', 240378);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(311900, 'PTHR24409:SF425', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 268-LIKE PROTEIN', 240378),
(311901, 'PTHR24409:SF424', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 551-LIKE PROTEIN', 240378),
(311902, 'PTHR24409:SF324', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 131', 240378),
(311903, 'PTHR24409:SF423', NULL, NULL, NULL, NULL, 'ZINC FINGER Y-CHROMOSOMAL PROTEIN', 240378),
(311904, 'PTHR24409:SF345', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 276', 240378),
(311905, 'PTHR24409:SF422', NULL, NULL, NULL, NULL, '', 240378),
(311906, 'PTHR24409:SF361', NULL, NULL, NULL, NULL, 'VASCULAR ENDOTHELIAL ZINC FINGER 1', 240378),
(311907, 'PTHR24409:SF418', NULL, NULL, NULL, NULL, 'SI:CH73-221F6.1', 240378),
(311908, 'PTHR24409:SF319', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 438', 240378),
(311909, 'PTHR24409', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 142', 240378),
(311910, 'PTHR24409:SF417', NULL, NULL, NULL, NULL, 'SERENDIPITY LOCUS PROTEIN BETA-RELATED', 240378),
(311911, 'PTHR24409:SF416', NULL, NULL, NULL, NULL, '', 240378),
(311912, 'PTHR24409:SF415', NULL, NULL, NULL, NULL, '', 240378),
(311913, 'PTHR24409:SF419', NULL, NULL, NULL, NULL, 'PROTEIN CBG02280', 240378),
(311914, 'PTHR24409:SF410', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 407', 240378),
(311915, 'PTHR24409:SF376', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR CTCF', 240378),
(311916, 'PTHR24409:SF310', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN CONTAINING 39', 240378),
(311917, 'PTHR24409:SF331', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 17', 240378),
(311918, 'PTHR24409:SF353', NULL, NULL, NULL, NULL, 'PR/SET DOMAIN 15', 240378),
(311919, 'PTHR24409:SF298', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 142', 240378),
(311920, 'PTHR24409:SF330', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 521', 240378),
(311921, 'PTHR24409:SF414', NULL, NULL, NULL, NULL, 'WORNIU', 240378),
(311922, 'PTHR24409:SF315', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 711', 240378),
(311923, 'PTHR24409:SF413', NULL, NULL, NULL, NULL, 'DATILOGRAFO, ISOFORM A', 240378),
(311924, 'PTHR24409:SF412', NULL, NULL, NULL, NULL, 'AT31036P-RELATED', 240378),
(311925, 'PTHR24409:SF357', NULL, NULL, NULL, NULL, 'HUCKEBEIN', 240378),
(311926, 'PTHR24409:SF313', NULL, NULL, NULL, NULL, 'SI:DKEY-226L10.6', 240378),
(311927, 'PTHR24409:SF334', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 653', 240378),
(311928, 'PTHR24409:SF356', NULL, NULL, NULL, NULL, 'C2H2 FINGER DOMAIN TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 240378),
(311929, 'PTHR24409:SF411', NULL, NULL, NULL, NULL, 'AGAP005274-PA', 240378),
(311930, 'PTHR24409:SF295', NULL, NULL, NULL, NULL, 'AZ2-RELATED', 240378),
(311931, 'PTHR24409:SF392', NULL, NULL, NULL, NULL, 'BCL6 TRANSCRIPTION REPRESSOR', 240378),
(311932, 'PTHR30024:SF17', NULL, NULL, NULL, NULL, 'PBPB DOMAIN-CONTAINING PROTEIN', 240379),
(311933, 'PTHR30024:SF7', NULL, NULL, NULL, NULL, 'NITRATE/NITRITE BINDING PROTEIN NRTA', 240379),
(311934, 'PTHR30024:SF47', NULL, NULL, NULL, NULL, 'TAURINE-BINDING PERIPLASMIC PROTEIN', 240379),
(311935, 'PTHR30024:SF46', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, SUBSTRATE-BINDING LIPOPROTEIN-RELATED', 240379),
(311936, 'PTHR30024:SF45', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER SUBSTRATE-BINDING PROTEIN', 240379),
(311937, 'PTHR30024:SF2', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER SUBSTRATE-BINDING PROTEIN', 240379),
(311938, 'PTHR30024:SF44', NULL, NULL, NULL, NULL, 'CHOLINE-BINDING PROTEIN', 240379),
(311939, 'PTHR30024:SF43', NULL, NULL, NULL, NULL, 'BLL4572 PROTEIN', 240379),
(311940, 'PTHR30024:SF21', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER SUBSTRATE-BINDING PROTEIN', 240379),
(311941, 'PTHR30024:SF42', NULL, NULL, NULL, NULL, 'ALIPHATIC SULFONATES-BINDING PROTEIN-RELATED', 240379),
(311942, 'PTHR30024:SF1', NULL, NULL, NULL, NULL, 'ALIPHATIC SULFONATES-BINDING PROTEIN-RELATED', 240379),
(311943, 'PTHR30024', NULL, NULL, NULL, NULL, 'ALIPHATIC SULFONATES-BINDING PROTEIN-RELATED', 240379),
(311944, 'PTHR46684:SF15', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 240380);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(311945, 'PTHR46684:SF14', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 240380),
(311946, 'PTHR46684:SF13', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 240380),
(311947, 'PTHR46684:SF12', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN-CONTAINING PROTEIN-RELATED', 240380),
(311948, 'PTHR46684:SF11', NULL, NULL, NULL, NULL, 'BASIC HELIX-LOOP-HELIX (BHLH) DNA-BINDING SUPERFAMILY PROTEIN-RELATED', 240380),
(311949, 'PTHR46684:SF10', NULL, NULL, NULL, NULL, 'BNAC07G03900D PROTEIN', 240380),
(311950, 'PTHR46684', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR FAMA', 240380),
(311951, 'PTHR46684:SF2', NULL, NULL, NULL, NULL, 'OS06G0526100 PROTEIN', 240380),
(311952, 'PTHR46684:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MUTE', 240380),
(311953, 'PTHR46684:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR FAMA', 240380),
(311954, 'PTHR46684:SF4', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SPEECHLESS', 240380),
(311955, 'PTHR46684:SF9', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 240380),
(311956, 'PTHR46684:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR FAMA-LIKE ISOFORM X1', 240380),
(311957, 'PTHR35548:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240381),
(311958, 'PTHR35548', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240381),
(311959, 'PTHR35548:SF3', NULL, NULL, NULL, NULL, '', 240381),
(311960, 'PTHR15664:SF6', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 230', 240382),
(311961, 'PTHR15664:SF16', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 230', 240382),
(311962, 'PTHR15664:SF17', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 230', 240382),
(311963, 'PTHR15664:SF21', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 230', 240382),
(311964, 'PTHR15664:SF22', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 230', 240382),
(311965, 'PTHR15664:SF11', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 230', 240382),
(311966, 'PTHR15664', NULL, NULL, NULL, NULL, 'C20ORF30 PROTEIN', 240382),
(311967, 'PTHR15664:SF12', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 230', 240382),
(311968, 'PTHR15664:SF13', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 230', 240382),
(311969, 'PTHR33607', NULL, NULL, NULL, NULL, 'ENDONUCLEASE-1', 240383),
(311970, 'PTHR33607:SF2', NULL, NULL, NULL, NULL, 'ENDONUCLEASE-1', 240383),
(311971, 'PTHR43827:SF12', NULL, NULL, NULL, NULL, 'XYLOSE AND ARABINOSE REDUCTASE', 240384),
(311972, 'PTHR43827:SF13', NULL, NULL, NULL, NULL, 'ALDO/KETO REDUCTASE FAMILY PROTEIN', 240384),
(311973, 'PTHR43827:SF8', NULL, NULL, NULL, NULL, 'ALDO/KETO REDUCTASE FAMILY PROTEIN', 240384),
(311974, 'PTHR43827:SF10', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 240384),
(311975, 'PTHR43827:SF11', NULL, NULL, NULL, NULL, 'ZGC:101765-RELATED', 240384),
(311976, 'PTHR43827:SF9', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE', 240384),
(311977, 'PTHR43827', NULL, NULL, NULL, NULL, '2,5-DIKETO-D-GLUCONIC ACID REDUCTASE', 240384),
(311978, 'PTHR43827:SF1', NULL, NULL, NULL, NULL, '2,5-DIKETO-D-GLUCONIC ACID REDUCTASE', 240384),
(311979, 'PTHR43827:SF3', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 240384),
(311980, 'PTHR42828', NULL, NULL, NULL, NULL, 'DHBP SYNTHASE RIBB-LIKE ALPHA/BETA DOMAIN-CONTAINING PROTEIN', 240385),
(311981, 'PTHR42828:SF3', NULL, NULL, NULL, NULL, 'DHBP SYNTHASE RIBB-LIKE ALPHA/BETA DOMAIN-CONTAINING PROTEIN', 240385),
(311982, 'PTHR21623', NULL, NULL, NULL, NULL, 'SPERIOLIN-BINDING FACTOR', 240386),
(311983, 'PTHR21623:SF2', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 33', 240386),
(311984, 'PTHR47147', NULL, NULL, NULL, NULL, 'SYNCOILIN', 240387),
(311985, 'PTHR47147:SF1', NULL, NULL, NULL, NULL, 'SYNCOILIN', 240387),
(311986, 'PTHR46961:SF10', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL HEAVY CHAIN 3', 240388),
(311987, 'PTHR46961:SF9', NULL, NULL, NULL, NULL, 'DHC_N2 DOMAIN-CONTAINING PROTEIN', 240388),
(311988, 'PTHR46961:SF11', NULL, NULL, NULL, NULL, 'DHC_N2 DOMAIN-CONTAINING PROTEIN', 240388),
(311989, 'PTHR46961:SF2', NULL, NULL, NULL, NULL, '', 240388);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(311990, 'PTHR46961:SF4', NULL, NULL, NULL, NULL, 'DHC_N2 DOMAIN-CONTAINING PROTEIN', 240388),
(311991, 'PTHR46961:SF3', NULL, NULL, NULL, NULL, '', 240388),
(311992, 'PTHR46961:SF6', NULL, NULL, NULL, NULL, '', 240388),
(311993, 'PTHR46961:SF5', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL HEAVY CHAIN 1', 240388),
(311994, 'PTHR46961', NULL, NULL, NULL, NULL, 'DYNEIN HEAVY CHAIN 1, AXONEMAL-LIKE PROTEIN', 240388),
(311995, 'PTHR46961:SF8', NULL, NULL, NULL, NULL, 'DYNEINS HEAVY CHAIN', 240388),
(311996, 'PTHR46961:SF7', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL HEAVY CHAIN 9', 240388),
(311997, 'PTHR33864:SF1', NULL, NULL, NULL, NULL, '', 240389),
(311998, 'PTHR33864:SF4', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE-LIKE PROTEIN', 240389),
(311999, 'PTHR33864', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE-LIKE PROTEIN-RELATED', 240389),
(312000, 'PTHR33864:SF5', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE-LIKE PROTEIN', 240389),
(312001, 'PTHR39210', NULL, NULL, NULL, NULL, 'HEPARIN-SULFATE LYASE', 240390),
(312002, 'PTHR39210:SF1', NULL, NULL, NULL, NULL, 'HEPARIN-SULFATE LYASE', 240390),
(312003, 'PTHR46695:SF15', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 44-LIKE ISOFORM X1', 240391),
(312004, 'PTHR46695:SF12', NULL, NULL, NULL, NULL, '', 240391),
(312005, 'PTHR46695:SF16', NULL, NULL, NULL, NULL, 'ZINC FINGER, CCCH-TYPE-RELATED', 240391),
(312006, 'PTHR46695', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 44-RELATED', 240391),
(312007, 'PTHR46695:SF5', NULL, NULL, NULL, NULL, 'RNA POLYMERASE-ASSOCIATED PROTEIN RTF1 HOMOLOG', 240391),
(312008, 'PTHR46695:SF4', NULL, NULL, NULL, NULL, 'PHD FINGER FAMILY PROTEIN / SWIB COMPLEX BAF60B DOMAIN-CONTAINING PROTEIN / GYF DOMAIN-CONTAINING PROTEIN-RELATED', 240391),
(312009, 'PTHR44998:SF3', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 240392),
(312010, 'PTHR44998:SF4', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE--PEPTIDE N-ACETYLGLUCOSAMINYLTRANSFERASE SPINDLY-RELATED', 240392),
(312011, 'PTHR44998', NULL, NULL, NULL, NULL, '', 240392),
(312012, 'PTHR44998:SF1', NULL, NULL, NULL, NULL, 'O-GLCNAC TRANSFERASE SUBUNIT P110', 240392),
(312013, 'PTHR42064', NULL, NULL, NULL, NULL, 'YALI0F28677P', 240393),
(312014, 'PTHR42064:SF1', NULL, NULL, NULL, NULL, 'YALI0F28677P', 240393),
(312015, 'PTHR21666', NULL, NULL, NULL, NULL, 'PEPTIDASE-RELATED', 240394),
(312016, 'PTHR21666:SF268', NULL, NULL, NULL, NULL, 'L-ALA--D-GLU ENDOPEPTIDASE', 240394),
(312017, 'PTHR21666:SF269', NULL, NULL, NULL, NULL, 'METALLOENDOPEPTIDASE-RELATED', 240394),
(312018, 'PTHR21666:SF265', NULL, NULL, NULL, NULL, 'MUREIN HYDROLASE ACTIVATOR ENVC', 240394),
(312019, 'PTHR21666:SF282', NULL, NULL, NULL, NULL, 'SLR0878 PROTEIN', 240394),
(312020, 'PTHR21666:SF272', NULL, NULL, NULL, NULL, 'LYSM DOMAIN-CONTAINING PROTEIN', 240394),
(312021, 'PTHR21666:SF283', NULL, NULL, NULL, NULL, 'STAGE II SPORULATION PROTEIN Q', 240394),
(312022, 'PTHR21666:SF284', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN YTFB', 240394),
(312023, 'PTHR21666:SF274', NULL, NULL, NULL, NULL, 'STAGE IV SPORULATION PROTEIN FA', 240394),
(312024, 'PTHR21666:SF263', NULL, NULL, NULL, NULL, 'MUREIN HYDROLASE ACTIVATOR NLPD', 240394),
(312025, 'PTHR21666:SF280', NULL, NULL, NULL, NULL, 'M23B, PUTATIVE-RELATED', 240394),
(312026, 'PTHR21666:SF270', NULL, NULL, NULL, NULL, 'MUREIN DD-ENDOPEPTIDASE MEPM', 240394),
(312027, 'PTHR21666:SF281', NULL, NULL, NULL, NULL, 'PERIPLASMIC METALLOPROTEASE M23B FAMILY', 240394),
(312028, 'PTHR37679:SF1', NULL, NULL, NULL, NULL, 'ARMADILLO-LIKE HELICAL DOMAIN-CONTAINING PROTEIN 2', 240395),
(312029, 'PTHR37679', NULL, NULL, NULL, NULL, 'ARMADILLO-LIKE HELICAL DOMAIN-CONTAINING PROTEIN 2', 240395),
(312030, 'PTHR46807:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PIF3', 240396),
(312031, 'PTHR46807:SF5', NULL, NULL, NULL, NULL, 'HELIX LOOP HELIX DNA-BINDING DOMAIN PROTEIN', 240396),
(312032, 'PTHR46807:SF4', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 240396),
(312033, 'PTHR46807', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PIF3', 240396);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(312034, 'PTHR46807:SF3', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 240396),
(312035, 'PTHR46807:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR APG', 240396),
(312036, 'PTHR40714:SF1', NULL, NULL, NULL, NULL, 'TMF-REGULATED NUCLEAR PROTEIN 1', 240397),
(312037, 'PTHR40714', NULL, NULL, NULL, NULL, 'TMF-REGULATED NUCLEAR PROTEIN 1', 240397),
(312038, 'PTHR32102:SF11', NULL, NULL, NULL, NULL, 'DUF1084 DOMAIN-CONTAINING PROTEIN', 240398),
(312039, 'PTHR32102:SF15', NULL, NULL, NULL, NULL, 'DUF1084 DOMAIN-CONTAINING PROTEIN', 240398),
(312040, 'PTHR32102:SF14', NULL, NULL, NULL, NULL, '', 240398),
(312041, 'PTHR32102:SF13', NULL, NULL, NULL, NULL, 'DUF1084 DOMAIN-CONTAINING PROTEIN', 240398),
(312042, 'PTHR32102:SF12', NULL, NULL, NULL, NULL, 'DUF1084 DOMAIN-CONTAINING PROTEIN', 240398),
(312043, 'PTHR32102:SF17', NULL, NULL, NULL, NULL, 'DUF1084 DOMAIN-CONTAINING PROTEIN', 240398),
(312044, 'PTHR32102', NULL, NULL, NULL, NULL, 'DUF1084 DOMAIN-CONTAINING PROTEIN-RELATED', 240398),
(312045, 'PTHR32102:SF16', NULL, NULL, NULL, NULL, 'DUF1084 DOMAIN-CONTAINING PROTEIN', 240398),
(312046, 'PTHR39164:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CCDC', 240399),
(312047, 'PTHR39164', NULL, NULL, NULL, NULL, 'PROTEIN CCDC', 240399),
(312048, 'PTHR47413:SF5', NULL, NULL, NULL, NULL, 'BNAANNG26420D PROTEIN', 240400),
(312049, 'PTHR47413:SF4', NULL, NULL, NULL, NULL, 'BNAC07G32870D PROTEIN', 240400),
(312050, 'PTHR47413:SF2', NULL, NULL, NULL, NULL, 'LIPASE-LIKE PAD4', 240400),
(312051, 'PTHR47413', NULL, NULL, NULL, NULL, 'LIPASE-LIKE PAD4', 240400),
(312052, 'PTHR43900:SF54', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE F12', 240401),
(312053, 'PTHR43900:SF56', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312054, 'PTHR43900:SF13', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312055, 'PTHR43900:SF58', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312056, 'PTHR43900:SF59', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312057, 'PTHR43900:SF17', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE 4', 240401),
(312058, 'PTHR43900:SF60', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE F5', 240401),
(312059, 'PTHR43900:SF62', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE F4', 240401),
(312060, 'PTHR43900:SF64', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE F11', 240401),
(312061, 'PTHR43900:SF43', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE F14', 240401),
(312062, 'PTHR43900:SF88', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312063, 'PTHR43900:SF44', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE F8, CHLOROPLASTIC', 240401),
(312064, 'PTHR43900:SF45', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE F9', 240401),
(312065, 'PTHR43900:SF89', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312066, 'PTHR43900:SF47', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE F6-RELATED', 240401),
(312067, 'PTHR43900', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE RHO', 240401),
(312068, 'PTHR43900:SF48', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE F2', 240401),
(312069, 'PTHR43900:SF49', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE GSTF1-RELATED', 240401),
(312070, 'PTHR43900:SF92', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312071, 'PTHR43900:SF93', NULL, NULL, NULL, NULL, 'PHI CLASS GLUTATHIONE S-TRANSFERASE', 240401),
(312072, 'PTHR43900:SF50', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE F10', 240401),
(312073, 'PTHR43900:SF94', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312074, 'PTHR43900:SF51', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312075, 'PTHR43900:SF95', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312076, 'PTHR43900:SF52', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312077, 'PTHR43900:SF53', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312078, 'PTHR43900:SF76', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE 1', 240401),
(312079, 'PTHR43900:SF32', NULL, NULL, NULL, NULL, '', 240401);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(312080, 'PTHR43900:SF77', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312081, 'PTHR43900:SF33', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312082, 'PTHR43900:SF78', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312083, 'PTHR43900:SF35', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312084, 'PTHR43900:SF79', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE', 240401),
(312085, 'PTHR43900:SF37', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312086, 'PTHR43900:SF38', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE, N-TERMINAL DOMAIN CONTAINING PROTEIN, EXPRESSED', 240401),
(312087, 'PTHR43900:SF39', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE GSTF2-RELATED', 240401),
(312088, 'PTHR43900:SF3', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE RHO', 240401),
(312089, 'PTHR43900:SF2', NULL, NULL, NULL, NULL, 'OS01G0372400 PROTEIN', 240401),
(312090, 'PTHR43900:SF6', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312091, 'PTHR43900:SF5', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312092, 'PTHR43900:SF80', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312093, 'PTHR43900:SF81', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312094, 'PTHR43900:SF83', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312095, 'PTHR43900:SF85', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312096, 'PTHR43900:SF41', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312097, 'PTHR43900:SF86', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE GSTB', 240401),
(312098, 'PTHR43900:SF42', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312099, 'PTHR43900:SF65', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312100, 'PTHR43900:SF67', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE F3', 240401),
(312101, 'PTHR43900:SF68', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312102, 'PTHR43900:SF27', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE-LIKE', 240401),
(312103, 'PTHR43900:SF28', NULL, NULL, NULL, NULL, 'GST C-TERMINAL DOMAIN-CONTAINING PROTEIN', 240401),
(312104, 'PTHR43900:SF70', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312105, 'PTHR43900:SF71', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312106, 'PTHR43900:SF72', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE F13', 240401),
(312107, 'PTHR43900:SF30', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312108, 'PTHR43900:SF74', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312109, 'PTHR43900:SF75', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240401),
(312110, 'PTHR36486:SF4', NULL, NULL, NULL, NULL, 'EXTRA-LARGE GUANINE NUCLEOTIDE-BINDING PROTEIN 1-LIKE', 240402),
(312111, 'PTHR36486:SF2', NULL, NULL, NULL, NULL, 'OS01G0977800 PROTEIN', 240402),
(312112, 'PTHR36486:SF3', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 240402),
(312113, 'PTHR36486', NULL, NULL, NULL, NULL, 'OS01G0977800 PROTEIN', 240402),
(312114, 'PTHR46518:SF2', NULL, NULL, NULL, NULL, '', 240403),
(312115, 'PTHR46518:SF1', NULL, NULL, NULL, NULL, 'OUTER DYNEIN ARM-DOCKING COMPLEX SUBUNIT 3', 240403),
(312116, 'PTHR46518', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 151', 240403),
(312117, 'PTHR45863:SF49', NULL, NULL, NULL, NULL, 'BR-SIGNALING KINASE 3-RELATED', 240404),
(312118, 'PTHR45863:SF46', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240404),
(312119, 'PTHR45863:SF24', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240404),
(312120, 'PTHR45863:SF47', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE BSK3', 240404),
(312121, 'PTHR45863:SF48', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE BSK11', 240404),
(312122, 'PTHR45863:SF41', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE', 240404),
(312123, 'PTHR45863:SF20', NULL, NULL, NULL, NULL, 'KINASE WITH TETRATRICOPEPTIDE REPEAT DOMAIN-CONTAINING PROTEIN', 240404);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(312124, 'PTHR45863:SF6', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE BSK6', 240404),
(312125, 'PTHR45863:SF22', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE BSK1', 240404),
(312126, 'PTHR45863:SF2', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE BSK3-RELATED', 240404),
(312127, 'PTHR45863:SF40', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE BSK7-RELATED', 240404),
(312128, 'PTHR45863:SF9', NULL, NULL, NULL, NULL, 'OS03G0825300 PROTEIN', 240404),
(312129, 'PTHR45863:SF7', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE BSK5', 240404),
(312130, 'PTHR45863:SF8', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240404),
(312131, 'PTHR45863:SF16', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE BSK1-2', 240404),
(312132, 'PTHR45863:SF39', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240404),
(312133, 'PTHR45863:SF18', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240404),
(312134, 'PTHR45863:SF19', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240404),
(312135, 'PTHR45863:SF12', NULL, NULL, NULL, NULL, 'KINASE WITH TETRATRICOPEPTIDE REPEAT DOMAIN-CONTAINING PROTEIN', 240404),
(312136, 'PTHR45863:SF34', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN-CONTAINING PROTEIN-RELATED', 240404),
(312137, 'PTHR45863:SF13', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE BSK4', 240404),
(312138, 'PTHR45863:SF35', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240404),
(312139, 'PTHR45863:SF14', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240404),
(312140, 'PTHR45863:SF15', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE BSK2', 240404),
(312141, 'PTHR45863:SF37', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240404),
(312142, 'PTHR45863:SF52', NULL, NULL, NULL, NULL, 'PK_TYR_SER-THR DOMAIN-CONTAINING PROTEIN', 240404),
(312143, 'PTHR45863:SF30', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240404),
(312144, 'PTHR45863:SF53', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240404),
(312145, 'PTHR45863:SF10', NULL, NULL, NULL, NULL, 'PROTEIN KINASE FAMILY PROTEIN-RELATED', 240404),
(312146, 'PTHR45863:SF54', NULL, NULL, NULL, NULL, 'TPR DOMAIN KINASE', 240404),
(312147, 'PTHR45863:SF32', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240404),
(312148, 'PTHR45863:SF11', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240404),
(312149, 'PTHR45863:SF33', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240404),
(312150, 'PTHR45863:SF50', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240404),
(312151, 'PTHR45863', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE BSK5', 240404),
(312152, 'PTHR45863:SF51', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240404),
(312153, 'PTHR34450:SF5', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 229-RELATED', 240405),
(312154, 'PTHR34450:SF6', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 241-RELATED', 240405),
(312155, 'PTHR34450:SF7', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 228-RELATED', 240405),
(312156, 'PTHR34450:SF8', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 232-RELATED', 240405),
(312157, 'PTHR34450:SF9', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 242-RELATED', 240405),
(312158, 'PTHR34450:SF10', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 245-RELATED', 240405),
(312159, 'PTHR34450', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 245-RELATED', 240405),
(312160, 'PTHR34450:SF2', NULL, NULL, NULL, NULL, 'SCR-LIKE PROTEIN', 240405),
(312161, 'PTHR34450:SF4', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 226-RELATED', 240405),
(312162, 'PTHR37690', NULL, NULL, NULL, NULL, 'CHORISMATE DEHYDRATASE', 240406),
(312163, 'PTHR37690:SF1', NULL, NULL, NULL, NULL, 'CHORISMATE DEHYDRATASE', 240406),
(312164, 'PTHR11352:SF13', NULL, NULL, NULL, NULL, 'PROLIFERATING CELL NUCLEAR ANTIGEN', 240407);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(312165, 'PTHR11352:SF12', NULL, NULL, NULL, NULL, 'PROLIFERATING CELL NUCLEAR ANTIGEN', 240407),
(312166, 'PTHR11352:SF14', NULL, NULL, NULL, NULL, 'PCNA_N DOMAIN-CONTAINING PROTEIN', 240407),
(312167, 'PTHR11352:SF11', NULL, NULL, NULL, NULL, 'PROLIFERATING CELL NUCLEAR ANTIGEN', 240407),
(312168, 'PTHR11352:SF10', NULL, NULL, NULL, NULL, 'PROLIFERATING CELL NUCLEAR ANTIGEN FAMILY PROTEIN', 240407),
(312169, 'PTHR11352:SF0', NULL, NULL, NULL, NULL, 'PROLIFERATING CELL NUCLEAR ANTIGEN', 240407),
(312170, 'PTHR11352:SF5', NULL, NULL, NULL, NULL, 'PROLIFERATING CELL NUCLEAR ANTIGEN', 240407),
(312171, 'PTHR11352:SF6', NULL, NULL, NULL, NULL, 'PROLIFERATING CELL NUCLEAR ANTIGEN', 240407),
(312172, 'PTHR11352:SF3', NULL, NULL, NULL, NULL, 'VEZATIN DOMAIN-CONTAINING PROTEIN', 240407),
(312173, 'PTHR11352', NULL, NULL, NULL, NULL, 'PROLIFERATING CELL NUCLEAR ANTIGEN', 240407),
(312174, 'PTHR11352:SF8', NULL, NULL, NULL, NULL, 'PROLIFERATING CELL NUCLEAR ANTIGEN', 240407),
(312175, 'PTHR33870:SF4', NULL, NULL, NULL, NULL, 'CARDIOMYOPATHY-ASSOCIATED PROTEIN', 240408),
(312176, 'PTHR33870:SF8', NULL, NULL, NULL, NULL, 'OS07G0472300 PROTEIN', 240408),
(312177, 'PTHR33870:SF30', NULL, NULL, NULL, NULL, 'BNAA10G16890D PROTEIN', 240408),
(312178, 'PTHR33870:SF7', NULL, NULL, NULL, NULL, 'OS12G0127650 PROTEIN', 240408),
(312179, 'PTHR33870:SF20', NULL, NULL, NULL, NULL, '', 240408),
(312180, 'PTHR33870:SF23', NULL, NULL, NULL, NULL, 'BNAA08G28910D PROTEIN', 240408),
(312181, 'PTHR33870:SF22', NULL, NULL, NULL, NULL, '', 240408),
(312182, 'PTHR33870:SF25', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 240408),
(312183, 'PTHR33870:SF1', NULL, NULL, NULL, NULL, 'OS03G0862000 PROTEIN', 240408),
(312184, 'PTHR33870:SF16', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 240408),
(312185, 'PTHR33870:SF27', NULL, NULL, NULL, NULL, 'OS05G0490400 PROTEIN', 240408),
(312186, 'PTHR33870:SF26', NULL, NULL, NULL, NULL, '', 240408),
(312187, 'PTHR33870:SF15', NULL, NULL, NULL, NULL, 'SERINE-RICH ADHESIN FOR PLATELETS-LIKE', 240408),
(312188, 'PTHR33870:SF18', NULL, NULL, NULL, NULL, 'BNAA10G29160D PROTEIN', 240408),
(312189, 'PTHR33870:SF29', NULL, NULL, NULL, NULL, 'DENTIN SIALOPHOSPHOPROTEIN', 240408),
(312190, 'PTHR33870:SF28', NULL, NULL, NULL, NULL, '', 240408),
(312191, 'PTHR33870:SF19', NULL, NULL, NULL, NULL, 'LRR PROTEIN', 240408),
(312192, 'PTHR33870', NULL, NULL, NULL, NULL, 'CARDIOMYOPATHY-ASSOCIATED PROTEIN', 240408),
(312193, 'PTHR23146:SF0', NULL, NULL, NULL, NULL, 'RNA POLYMERASE-ASSOCIATED PROTEIN LEO1', 240409),
(312194, 'PTHR23146:SF2', NULL, NULL, NULL, NULL, '', 240409),
(312195, 'PTHR23146:SF5', NULL, NULL, NULL, NULL, 'BNAANNG06810D PROTEIN', 240409),
(312196, 'PTHR23146', NULL, NULL, NULL, NULL, 'LEO1 PROTEIN', 240409),
(312197, 'PTHR21026:SF2', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L32, MITOCHONDRIAL', 240410),
(312198, 'PTHR21026', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L32, MITOCHONDRIAL', 240410),
(312199, 'PTHR21026:SF8', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L32, CHLOROPLASTIC', 240410),
(312200, 'PTHR21026:SF9', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L32, CHLOROPLASTIC', 240410),
(312201, 'PTHR36923', NULL, NULL, NULL, NULL, 'FERREDOXIN', 240411),
(312202, 'PTHR36923:SF3', NULL, NULL, NULL, NULL, 'FERREDOXIN', 240411),
(312203, 'PTHR38136:SF3', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN', 240412),
(312204, 'PTHR38136:SF2', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN', 240412),
(312205, 'PTHR38136', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN', 240412),
(312206, 'PTHR22412:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG23478', 240413),
(312207, 'PTHR22412:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG23477', 240413),
(312208, 'PTHR22412:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG15873', 240413),
(312209, 'PTHR22412', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 240413),
(312210, 'PTHR46924', NULL, NULL, NULL, NULL, 'METABOTROPIC GLUTAMATE RECEPTOR-LIKE PROTEIN C-RELATED-RELATED', 240414),
(312211, 'PTHR46924:SF1', NULL, NULL, NULL, NULL, 'METABOTROPIC GLUTAMATE RECEPTOR-LIKE PROTEIN L', 240414);
INSERT INTO "PUBLIC"."MODEL" VALUES
(312212, 'PTHR46924:SF2', NULL, NULL, NULL, NULL, 'METABOTROPIC GLUTAMATE RECEPTOR-LIKE PROTEIN A-RELATED', 240414),
(312213, 'PTHR46924:SF3', NULL, NULL, NULL, NULL, 'METABOTROPIC GLUTAMATE RECEPTOR-LIKE PROTEIN C-RELATED', 240414),
(312214, 'PTHR46924:SF4', NULL, NULL, NULL, NULL, 'METABOTROPIC GLUTAMATE RECEPTOR-LIKE PROTEIN N', 240414),
(312215, 'PTHR13466:SF1', NULL, NULL, NULL, NULL, 'SMP-LTD DOMAIN-CONTAINING PROTEIN', 240415),
(312216, 'PTHR13466:SF2', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 2', 240415),
(312217, 'PTHR13466:SF4', NULL, NULL, NULL, NULL, 'SMP-LTD DOMAIN-CONTAINING PROTEIN', 240415),
(312218, 'PTHR13466:SF7', NULL, NULL, NULL, NULL, 'SMP-LTD DOMAIN-CONTAINING PROTEIN', 240415),
(312219, 'PTHR13466:SF20', NULL, NULL, NULL, NULL, 'SMP-LTD DOMAIN-CONTAINING PROTEIN', 240415),
(312220, 'PTHR13466:SF22', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN, PUTATIVE-RELATED', 240415),
(312221, 'PTHR13466:SF21', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED SEQUENCE 2 PROTEIN-LIKE ISOFORM X1', 240415),
(312222, 'PTHR13466:SF12', NULL, NULL, NULL, NULL, 'SMP-LTD DOMAIN-CONTAINING PROTEIN', 240415),
(312223, 'PTHR13466:SF23', NULL, NULL, NULL, NULL, 'SMP-LTD DOMAIN-CONTAINING PROTEIN', 240415),
(312224, 'PTHR13466:SF15', NULL, NULL, NULL, NULL, 'SMP-LTD DOMAIN-CONTAINING PROTEIN', 240415),
(312225, 'PTHR13466:SF0', NULL, NULL, NULL, NULL, 'SMP-LTD DOMAIN-CONTAINING PROTEIN', 240415),
(312226, 'PTHR13466:SF19', NULL, NULL, NULL, NULL, 'NUCLEUS-VACUOLE JUNCTION PROTEIN 2', 240415),
(312227, 'PTHR13466:SF18', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN CONSERVED REGION (DUF2404)-RELATED', 240415),
(312228, 'PTHR13466', NULL, NULL, NULL, NULL, 'TEX2 PROTEIN-RELATED', 240415),
(312229, 'PTHR30566:SF5', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN 1, MITOCHONDRIAL-RELATED', 240416),
(312230, 'PTHR30566:SF25', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', 240416),
(312231, 'PTHR30566:SF24', NULL, NULL, NULL, NULL, 'OS02G0681000 PROTEIN', 240416),
(312232, 'PTHR30566', NULL, NULL, NULL, NULL, 'YNAI-RELATED MECHANOSENSITIVE ION CHANNEL', 240416),
(312233, 'PTHR30566:SF21', NULL, NULL, NULL, NULL, '', 240416),
(312234, 'PTHR30566:SF27', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN', 240416),
(312235, 'PTHR15237:SF2', NULL, NULL, NULL, NULL, 'CELL CYCLE CHECKPOINT CONTROL PROTEIN RAD9B', 240417),
(312236, 'PTHR15237:SF1', NULL, NULL, NULL, NULL, 'CELL CYCLE CHECKPOINT CONTROL PROTEIN RAD9A', 240417),
(312237, 'PTHR15237:SF0', NULL, NULL, NULL, NULL, 'CELL CYCLE CHECKPOINT CONTROL PROTEIN', 240417),
(312238, 'PTHR15237', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RAD9', 240417),
(312239, 'PTHR22725:SF9', NULL, NULL, NULL, NULL, 'FATTY ACID-BINDING PROTEIN HOMOLOG 3', 240418),
(312240, 'PTHR22725', NULL, NULL, NULL, NULL, 'FATTY ACID-BINDING PROTEIN HOMOLOG 1-RELATED-RELATED', 240418),
(312241, 'PTHR22725:SF2', NULL, NULL, NULL, NULL, 'FATTY ACID-BINDING PROTEIN HOMOLOG 1-RELATED', 240418),
(312242, 'PTHR22725:SF4', NULL, NULL, NULL, NULL, 'FATTY ACID-BINDING PROTEIN HOMOLOG 4', 240418),
(312243, 'PTHR37002:SF3', NULL, NULL, NULL, NULL, 'TGC DOMAIN-CONTAINING PROTEIN', 240419),
(312244, 'PTHR37002:SF10', NULL, NULL, NULL, NULL, 'TGC DOMAIN-CONTAINING PROTEIN', 240419),
(312245, 'PTHR37002:SF11', NULL, NULL, NULL, NULL, '', 240419),
(312246, 'PTHR37002:SF12', NULL, NULL, NULL, NULL, '', 240419),
(312247, 'PTHR37002:SF9', NULL, NULL, NULL, NULL, '', 240419),
(312248, 'PTHR37002', NULL, NULL, NULL, NULL, 'AGAP007005-PA', 240419),
(312249, 'PTHR37002:SF8', NULL, NULL, NULL, NULL, 'SRCR DOMAIN-CONTAINING PROTEIN', 240419),
(312250, 'PTHR37002:SF7', NULL, NULL, NULL, NULL, '', 240419),
(312251, 'PTHR37002:SF6', NULL, NULL, NULL, NULL, 'TGC DOMAIN-CONTAINING PROTEIN', 240419),
(312252, 'PTHR28235:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FYV4, MITOCHONDRIAL', 240420),
(312253, 'PTHR28235', NULL, NULL, NULL, NULL, 'PROTEIN FYV4, MITOCHONDRIAL', 240420),
(312254, 'PTHR33559', NULL, NULL, NULL, NULL, 'PROTEASOME ASSEMBLY CHAPERONE 4', 240421),
(312255, 'PTHR33559:SF1', NULL, NULL, NULL, NULL, 'PROTEASOME ASSEMBLY CHAPERONE 4', 240421);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(312256, 'PTHR33559:SF3', NULL, NULL, NULL, NULL, '', 240421),
(312257, 'PTHR43144:SF6', NULL, NULL, NULL, NULL, 'AMINOTRAN_1_2 DOMAIN-CONTAINING PROTEIN', 240422),
(312258, 'PTHR43144:SF5', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE ALD1, CHLOROPLASTIC', 240422),
(312259, 'PTHR43144:SF1', NULL, NULL, NULL, NULL, 'LL-DIAMINOPIMELATE AMINOTRANSFERASE, CHLOROPLASTIC', 240422),
(312260, 'PTHR43144:SF4', NULL, NULL, NULL, NULL, 'AMINOTRAN_1_2 DOMAIN-CONTAINING PROTEIN', 240422),
(312261, 'PTHR43144', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE', 240422),
(312262, 'PTHR34762:SF1', NULL, NULL, NULL, NULL, 'SMALL VASOHIBIN-BINDING PROTEIN', 240423),
(312263, 'PTHR34762', NULL, NULL, NULL, NULL, 'SMALL VASOHIBIN-BINDING PROTEIN', 240423),
(312264, 'PTHR46252', NULL, NULL, NULL, NULL, 'BRORIN FAMILY MEMBER', 240424),
(312265, 'PTHR46252:SF5', NULL, NULL, NULL, NULL, 'SI:DKEY-283B1.7', 240424),
(312266, 'PTHR46252:SF4', NULL, NULL, NULL, NULL, 'BRORIN', 240424),
(312267, 'PTHR46252:SF3', NULL, NULL, NULL, NULL, 'VWFC DOMAIN-CONTAINING PROTEIN', 240424),
(312268, 'PTHR46252:SF2', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR C DOMAIN-CONTAINING PROTEIN 2-LIKE', 240424),
(312269, 'PTHR46252:SF1', NULL, NULL, NULL, NULL, 'ZGC:113531', 240424),
(312270, 'PTHR14240', NULL, NULL, NULL, NULL, 'RETINITIS PIGMENTOSA GTPASE REGULATOR-INTERACTING PROTEIN', 240425),
(312271, 'PTHR14240:SF4', NULL, NULL, NULL, NULL, 'PROTEIN FANTOM', 240425),
(312272, 'PTHR14240:SF3', NULL, NULL, NULL, NULL, 'X-LINKED RETINITIS PIGMENTOSA GTPASE REGULATOR-INTERACTING PROTEIN 1', 240425),
(312273, 'PTHR14240:SF1', NULL, NULL, NULL, NULL, 'RPGR-INTERACTING PROTEIN 1-RELATED', 240425),
(312274, 'PTHR43592:SF25', NULL, NULL, NULL, NULL, 'CAAX AMINO TERMINAL PROTEASE-RELATED', 240426),
(312275, 'PTHR43592:SF24', NULL, NULL, NULL, NULL, 'CAAX AMINO TERMINAL PROTEASE FAMILY PROTEIN', 240426),
(312276, 'PTHR43592:SF20', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 240426),
(312277, 'PTHR43592:SF4', NULL, NULL, NULL, NULL, 'CAAX AMINO TERMINAL PROTEASE FAMILY PROTEIN', 240426),
(312278, 'PTHR43592', NULL, NULL, NULL, NULL, 'CAAX AMINO TERMINAL PROTEASE', 240426),
(312279, 'PTHR43592:SF7', NULL, NULL, NULL, NULL, 'CAAX AMINO TERMINAL PROTEASE FAMILY PROTEIN', 240426),
(312280, 'PTHR43592:SF27', NULL, NULL, NULL, NULL, 'SLL0360 PROTEIN', 240426),
(312281, 'PTHR43592:SF26', NULL, NULL, NULL, NULL, '', 240426),
(312282, 'PTHR43592:SF15', NULL, NULL, NULL, NULL, 'CAAX AMINO TERMINAL PROTEASE FAMILY PROTEIN', 240426),
(312283, 'PTHR43592:SF29', NULL, NULL, NULL, NULL, 'MEMBRANE PEPTIDASE YDIL-RELATED', 240426),
(312284, 'PTHR43592:SF18', NULL, NULL, NULL, NULL, 'CAAX AMINO TERMINAL PROTEASE FAMILY PROTEIN', 240426),
(312285, 'PTHR43592:SF28', NULL, NULL, NULL, NULL, 'CAAX AMINO TERMINAL PROTEASE FAMILY PROTEIN', 240426),
(312286, 'PTHR46593:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 64', 240427),
(312287, 'PTHR46593', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 64', 240427),
(312288, 'PTHR33142:SF59', NULL, NULL, NULL, NULL, 'SELF-PRUNING INTERACTING PROTEIN 1', 240428),
(312289, 'PTHR33142:SF15', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT PROTEIN KINASE INHIBITOR SMR4', 240428),
(312290, 'PTHR33142:SF101', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT PROTEIN KINASE INHIBITOR SMR2', 240428),
(312291, 'PTHR33142:SF102', NULL, NULL, NULL, NULL, '', 240428),
(312292, 'PTHR33142:SF100', NULL, NULL, NULL, NULL, 'EXG1', 240428),
(312293, 'PTHR33142:SF105', NULL, NULL, NULL, NULL, '', 240428),
(312294, 'PTHR33142:SF106', NULL, NULL, NULL, NULL, 'BNAA07G38890D PROTEIN', 240428),
(312295, 'PTHR33142:SF103', NULL, NULL, NULL, NULL, 'BNAC09G14560D PROTEIN', 240428),
(312296, 'PTHR33142:SF104', NULL, NULL, NULL, NULL, 'BNAC02G20010D PROTEIN', 240428),
(312297, 'PTHR33142:SF109', NULL, NULL, NULL, NULL, '', 240428),
(312298, 'PTHR33142:SF107', NULL, NULL, NULL, NULL, '', 240428),
(312299, 'PTHR33142:SF108', NULL, NULL, NULL, NULL, 'BNAA08G27110D PROTEIN', 240428),
(312300, 'PTHR33142:SF90', NULL, NULL, NULL, NULL, 'BNAC05G05230D PROTEIN', 240428);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(312301, 'PTHR33142:SF91', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT PROTEIN KINASE INHIBITOR SMR14', 240428),
(312302, 'PTHR33142:SF93', NULL, NULL, NULL, NULL, 'BNAA05G20000D PROTEIN', 240428),
(312303, 'PTHR33142:SF50', NULL, NULL, NULL, NULL, 'BNAC04G15330D PROTEIN', 240428),
(312304, 'PTHR33142:SF52', NULL, NULL, NULL, NULL, 'BNAC09G50580D PROTEIN', 240428),
(312305, 'PTHR33142:SF96', NULL, NULL, NULL, NULL, '', 240428),
(312306, 'PTHR33142:SF97', NULL, NULL, NULL, NULL, '', 240428),
(312307, 'PTHR33142', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT PROTEIN KINASE INHIBITOR SMR13', 240428),
(312308, 'PTHR33142:SF99', NULL, NULL, NULL, NULL, '', 240428),
(312309, 'PTHR33142:SF13', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT PROTEIN KINASE INHIBITOR SMR1', 240428),
(312310, 'PTHR33142:SF28', NULL, NULL, NULL, NULL, '', 240428),
(312311, 'PTHR33142:SF112', NULL, NULL, NULL, NULL, 'BNAC02G20000D PROTEIN', 240428),
(312312, 'PTHR33142:SF113', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT PROTEIN KINASE INHIBITOR SMR13', 240428),
(312313, 'PTHR33142:SF110', NULL, NULL, NULL, NULL, '', 240428),
(312314, 'PTHR33142:SF111', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT PROTEIN KINASE INHIBITOR SMR12', 240428),
(312315, 'PTHR33142:SF8', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT PROTEIN KINASE INHIBITOR SMR9', 240428),
(312316, 'PTHR33142:SF60', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT PROTEIN KINASE INHIBITOR SIM', 240428),
(312317, 'PTHR33142:SF61', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT PROTEIN KINASE INHIBITOR SMR5', 240428),
(312318, 'PTHR33142:SF62', NULL, NULL, NULL, NULL, '', 240428),
(312319, 'PTHR33142:SF65', NULL, NULL, NULL, NULL, 'NUCLEOPHOSMIN-LIKE', 240428),
(312320, 'PTHR33142:SF66', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT PROTEIN KINASE INHIBITOR SMR3', 240428),
(312321, 'PTHR33142:SF68', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT PROTEIN KINASE INHIBITOR SMR10', 240428),
(312322, 'PTHR33142:SF39', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT PROTEIN KINASE INHIBITOR SMR15-RELATED', 240428),
(312323, 'PTHR33142:SF70', NULL, NULL, NULL, NULL, 'BNAC02G03600D PROTEIN', 240428),
(312324, 'PTHR33142:SF73', NULL, NULL, NULL, NULL, 'BNAA03G54850D PROTEIN', 240428),
(312325, 'PTHR33142:SF74', NULL, NULL, NULL, NULL, 'BNAA05G28330D PROTEIN', 240428),
(312326, 'PTHR33142:SF76', NULL, NULL, NULL, NULL, 'BNAANNG22820D PROTEIN', 240428),
(312327, 'PTHR33142:SF34', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT PROTEIN KINASE INHIBITOR SMR7', 240428),
(312328, 'PTHR33142:SF78', NULL, NULL, NULL, NULL, 'BNAA03G01290D PROTEIN', 240428),
(312329, 'PTHR33142:SF48', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT PROTEIN KINASE INHIBITOR SMR6-LIKE', 240428),
(312330, 'PTHR33142:SF81', NULL, NULL, NULL, NULL, 'BNAANNG22280D PROTEIN', 240428),
(312331, 'PTHR33142:SF83', NULL, NULL, NULL, NULL, 'SELF-PRUNING INTERACTING PROTEIN 1', 240428),
(312332, 'PTHR33142:SF40', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT PROTEIN KINASE INHIBITOR SMR6', 240428),
(312333, 'PTHR33142:SF84', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240428),
(312334, 'PTHR33142:SF41', NULL, NULL, NULL, NULL, 'OS02G0131000 PROTEIN', 240428),
(312335, 'PTHR33142:SF85', NULL, NULL, NULL, NULL, 'BNAA01G25510D PROTEIN', 240428),
(312336, 'PTHR33142:SF86', NULL, NULL, NULL, NULL, '', 240428),
(312337, 'PTHR33142:SF88', NULL, NULL, NULL, NULL, 'FTSJ CELL DIVISION PROTEIN', 240428),
(312338, 'PTHR33142:SF89', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT PROTEIN KINASE INHIBITOR SMR2-LIKE ISOFORM X1', 240428),
(312339, 'PTHR34961:SF1', NULL, NULL, NULL, NULL, 'ROOT MERISTEM GROWTH FACTOR 10', 240429),
(312340, 'PTHR34961:SF7', NULL, NULL, NULL, NULL, '', 240429),
(312341, 'PTHR34961:SF5', NULL, NULL, NULL, NULL, '', 240429),
(312342, 'PTHR34961:SF11', NULL, NULL, NULL, NULL, 'OS04G0554900 PROTEIN', 240429),
(312343, 'PTHR34961', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 240429),
(312344, 'PTHR46242', NULL, NULL, NULL, NULL, 'ZINC FINGER CCHC DOMAIN-CONTAINING PROTEIN 9 ZCCHC9', 240430),
(312345, 'PTHR46242:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER CCHC DOMAIN-CONTAINING PROTEIN 9', 240430);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(312346, 'PTHR13007:SF19', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR 18', 240431),
(312347, 'PTHR13007', NULL, NULL, NULL, NULL, 'PRE-MRNA SPLICING FACTOR-RELATED', 240431),
(312348, 'PTHR13007:SF23', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR 18', 240431),
(312349, 'PTHR13007:SF22', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR 18', 240431),
(312350, 'PTHR13007:SF20', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR 18', 240431),
(312351, 'PTHR34340:SF2', NULL, NULL, NULL, NULL, '', 240432),
(312352, 'PTHR34340:SF1', NULL, NULL, NULL, NULL, 'MELANOREGULIN', 240432),
(312353, 'PTHR34340', NULL, NULL, NULL, NULL, '', 240432),
(312354, 'PTHR34340:SF3', NULL, NULL, NULL, NULL, 'MELANOREGULIN', 240432),
(312355, 'PTHR35513:SF2', NULL, NULL, NULL, NULL, 'BNAC02G38260D PROTEIN', 240433),
(312356, 'PTHR35513', NULL, NULL, NULL, NULL, 'OS02G0158600 PROTEIN', 240433),
(312357, 'PTHR35513:SF1', NULL, NULL, NULL, NULL, 'OS02G0158600 PROTEIN', 240433),
(312358, 'PTHR35099:SF20', NULL, NULL, NULL, NULL, '', 240434),
(312359, 'PTHR35099:SF4', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 240434),
(312360, 'PTHR35099:SF10', NULL, NULL, NULL, NULL, 'BNAA06G10500D PROTEIN', 240434),
(312361, 'PTHR35099:SF13', NULL, NULL, NULL, NULL, 'BNAA03G51890D PROTEIN', 240434),
(312362, 'PTHR35099:SF2', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR SUPERFAMILY PROTEIN-RELATED', 240434),
(312363, 'PTHR35099:SF14', NULL, NULL, NULL, NULL, 'BNAC06G40400D PROTEIN', 240434),
(312364, 'PTHR35099:SF17', NULL, NULL, NULL, NULL, 'OS02G0182700 PROTEIN', 240434),
(312365, 'PTHR35099', NULL, NULL, NULL, NULL, 'OS02G0182700 PROTEIN', 240434),
(312366, 'PTHR35099:SF19', NULL, NULL, NULL, NULL, '', 240434),
(312367, 'PTHR35099:SF18', NULL, NULL, NULL, NULL, '', 240434),
(312368, 'PTHR35099:SF9', NULL, NULL, NULL, NULL, 'BNAA09G56590D PROTEIN', 240434),
(312369, 'PTHR16311:SF3', NULL, NULL, NULL, NULL, 'THROMBOSPONDIN TYPE-1 DOMAIN-CONTAINING PROTEIN 1', 240435),
(312370, 'PTHR16311', NULL, NULL, NULL, NULL, 'THROMBOSPONDIN TYPE I DOMAIN-CONTAINING 1', 240435),
(312371, 'PTHR37177:SF4', NULL, NULL, NULL, NULL, 'PROTEIN PSY1', 240436),
(312372, 'PTHR37177:SF5', NULL, NULL, NULL, NULL, 'ALTERNATIVE NAD(P)H DEHYDROGENASE', 240436),
(312373, 'PTHR37177:SF2', NULL, NULL, NULL, NULL, 'PROTEIN PSY2', 240436),
(312374, 'PTHR37177:SF3', NULL, NULL, NULL, NULL, 'PROTEIN PSY3', 240436),
(312375, 'PTHR37177', NULL, NULL, NULL, NULL, 'PROTEIN PSY1', 240436),
(312376, 'PTHR37177:SF6', NULL, NULL, NULL, NULL, 'BNAA04G17160D PROTEIN', 240436),
(312377, 'PTHR43037:SF3', NULL, NULL, NULL, NULL, 'FERULOYL ESTERASE B', 240437),
(312378, 'PTHR43037:SF4', NULL, NULL, NULL, NULL, 'PEPTIDASE_S9 DOMAIN-CONTAINING PROTEIN', 240437),
(312379, 'PTHR43037:SF5', NULL, NULL, NULL, NULL, 'BLL1350 PROTEIN', 240437),
(312380, 'PTHR43037:SF1', NULL, NULL, NULL, NULL, 'BLL1128 PROTEIN', 240437),
(312381, 'PTHR43037', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT-RELATED', 240437),
(312382, 'PTHR42943:SF13', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE KAPPA-RELATED', 240438),
(312383, 'PTHR42943', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE KAPPA', 240438),
(312384, 'PTHR42943:SF4', NULL, NULL, NULL, NULL, '', 240438),
(312385, 'PTHR42943:SF3', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE KAPPA 1', 240438),
(312386, 'PTHR42943:SF2', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE KAPPA 1', 240438),
(312387, 'PTHR42943:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG18221', 240438),
(312388, 'PTHR36339', NULL, NULL, NULL, NULL, 'F23A5.5', 240439),
(312389, 'PTHR36339:SF2', NULL, NULL, NULL, NULL, 'F23A5.5', 240439),
(312390, 'PTHR12829:SF4', NULL, NULL, NULL, NULL, 'N(6)-ADENINE-SPECIFIC METHYLTRANSFERASE METTL4', 240440),
(312391, 'PTHR12829:SF2', NULL, NULL, NULL, NULL, 'N6-ADENOSINE-METHYLTRANSFERASE MT-A70-LIKE', 240440),
(312392, 'PTHR12829:SF7', NULL, NULL, NULL, NULL, 'N6-ADENOSINE-METHYLTRANSFERASE CATALYTIC SUBUNIT', 240440),
(312393, 'PTHR12829:SF8', NULL, NULL, NULL, NULL, '', 240440),
(312394, 'PTHR12829', NULL, NULL, NULL, NULL, 'N6-ADENOSINE-METHYLTRANSFERASE', 240440);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(312395, 'PTHR10256:SF2', NULL, NULL, NULL, NULL, 'SELENIDE, WATER DIKINASE 1', 240441),
(312396, 'PTHR10256:SF1', NULL, NULL, NULL, NULL, 'SELENIDE, WATER DIKINASE 2', 240441),
(312397, 'PTHR10256', NULL, NULL, NULL, NULL, 'SELENIDE, WATER DIKINASE', 240441),
(312398, 'PTHR10256:SF0', NULL, NULL, NULL, NULL, 'INACTIVE SELENIDE, WATER DIKINASE-LIKE PROTEIN-RELATED', 240441),
(312399, 'PTHR10256:SF3', NULL, NULL, NULL, NULL, 'SELENIDE, WATER DIKINASE', 240441),
(312400, 'PTHR11907:SF24', NULL, NULL, NULL, NULL, 'AMIDOPHOSPHORIBOSYLTRANSFERASE 3, CHLOROPLASTIC', 240442),
(312401, 'PTHR11907:SF26', NULL, NULL, NULL, NULL, 'AMIDOPHOSPHORIBOSYLTRANSFERASE', 240442),
(312402, 'PTHR11907:SF25', NULL, NULL, NULL, NULL, 'AMIDOPHOSPHORIBOSYLTRANSFERASE', 240442),
(312403, 'PTHR11907:SF0', NULL, NULL, NULL, NULL, 'AMIDOPHOSPHORIBOSYLTRANSFERASE', 240442),
(312404, 'PTHR11907:SF20', NULL, NULL, NULL, NULL, 'AMIDOPHOSPHORIBOSYLTRANSFERASE', 240442),
(312405, 'PTHR11907:SF22', NULL, NULL, NULL, NULL, 'AMIDOPHOSPHORIBOSYLTRANSFERASE', 240442),
(312406, 'PTHR11907:SF21', NULL, NULL, NULL, NULL, 'AMIDOPHOSPHORIBOSYLTRANSFERASE 2, CHLOROPLASTIC', 240442),
(312407, 'PTHR11907', NULL, NULL, NULL, NULL, 'AMIDOPHOSPHORIBOSYLTRANSFERASE', 240442),
(312408, 'PTHR37868', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 190', 240443),
(312409, 'PTHR37868:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 190', 240443),
(312410, 'PTHR24124:SF5', NULL, NULL, NULL, NULL, 'NF-KAPPA-B INHIBITOR ZETA', 240444),
(312411, 'PTHR24124:SF4', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN RFXANK', 240444),
(312412, 'PTHR24124:SF3', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY A PROTEIN 2', 240444),
(312413, 'PTHR24124:SF8', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 240444),
(312414, 'PTHR24124:SF14', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 240444),
(312415, 'PTHR24124:SF7', NULL, NULL, NULL, NULL, 'NF-KAPPA-B INHIBITOR DELTA', 240444),
(312416, 'PTHR24124:SF15', NULL, NULL, NULL, NULL, 'LP07441P', 240444),
(312417, 'PTHR24124', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY A', 240444),
(312418, 'PTHR43103:SF5', NULL, NULL, NULL, NULL, '4-EPIMERASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G00360)-RELATED', 240445),
(312419, 'PTHR43103:SF4', NULL, NULL, NULL, NULL, 'EPIMERASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G12770)-RELATED', 240445),
(312420, 'PTHR43103:SF3', NULL, NULL, NULL, NULL, 'ADP-L-GLYCERO-D-MANNO-HEPTOSE-6-EPIMERASE', 240445),
(312421, 'PTHR43103:SF6', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 240445),
(312422, 'PTHR43103', NULL, NULL, NULL, NULL, 'NUCLEOSIDE-DIPHOSPHATE-SUGAR EPIMERASE', 240445),
(312423, 'PTHR35910', NULL, NULL, NULL, NULL, '', 240446),
(312424, 'PTHR35910:SF5', NULL, NULL, NULL, NULL, '', 240446),
(312425, 'PTHR35910:SF1', NULL, NULL, NULL, NULL, '', 240446),
(312426, 'PTHR16797:SF4', NULL, NULL, NULL, NULL, '40-KDA HUNTINGTIN-ASSOCIATED PROTEIN', 240447),
(312427, 'PTHR16797', NULL, NULL, NULL, NULL, 'FACTOR VIII-ASSOCIATED GENE 1', 240447),
(312428, 'PTHR38777:SF1', NULL, NULL, NULL, NULL, 'FELS-2 PROPHAGE PROTEIN', 240448),
(312429, 'PTHR38777', NULL, NULL, NULL, NULL, 'FELS-2 PROPHAGE PROTEIN', 240448),
(312430, 'PTHR43288:SF2', NULL, NULL, NULL, NULL, 'ELP3 DOMAIN-CONTAINING PROTEIN', 240449),
(312431, 'PTHR43288:SF1', NULL, NULL, NULL, NULL, 'GLYCYL-RADICAL ENZYME ACTIVATING ENZYME MJ0021-RELATED', 240449),
(312432, 'PTHR43288', NULL, NULL, NULL, NULL, 'BIOTIN SYNTHASE-RELATED PROTEIN, RADICAL SAM SUPERFAMILY', 240449),
(312433, 'PTHR33729:SF8', NULL, NULL, NULL, NULL, 'METHYL-CPG-BINDING DOMAIN-CONTAINING PROTEIN 11-LIKE', 240450),
(312434, 'PTHR33729:SF13', NULL, NULL, NULL, NULL, 'MBD DOMAIN-CONTAINING PROTEIN', 240450),
(312435, 'PTHR33729:SF12', NULL, NULL, NULL, NULL, 'MBD DOMAIN-CONTAINING PROTEIN', 240450),
(312436, 'PTHR33729:SF6', NULL, NULL, NULL, NULL, 'METHYL-CPG-BINDING DOMAIN-CONTAINING PROTEIN 11', 240450),
(312437, 'PTHR33729:SF19', NULL, NULL, NULL, NULL, 'METHYL-CPG-BINDING DOMAIN-CONTAINING PROTEIN 10', 240450),
(312438, 'PTHR33729:SF18', NULL, NULL, NULL, NULL, 'METHYL-CPG-BINDING DOMAIN-CONTAINING PROTEIN 11-LIKE', 240450);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(312439, 'PTHR33729', NULL, NULL, NULL, NULL, 'METHYL-CPG BINDING DOMAIN CONTAINING PROTEIN, EXPRESSED', 240450),
(312440, 'PTHR33729:SF15', NULL, NULL, NULL, NULL, 'DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 240450),
(312441, 'PTHR33729:SF16', NULL, NULL, NULL, NULL, 'MBD DOMAIN-CONTAINING PROTEIN', 240450),
(312442, 'PTHR33729:SF2', NULL, NULL, NULL, NULL, 'METHYL-CPG BINDING DOMAIN CONTAINING PROTEIN, EXPRESSED', 240450),
(312443, 'PTHR34977', NULL, NULL, NULL, NULL, 'UPF0337 PROTEIN YJBJ', 240451),
(312444, 'PTHR34977:SF3', NULL, NULL, NULL, NULL, 'UPF0337 PROTEIN XCC3924', 240451),
(312445, 'PTHR34977:SF1', NULL, NULL, NULL, NULL, 'UPF0337 PROTEIN YJBJ', 240451),
(312446, 'PTHR46700:SF1', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 240452),
(312447, 'PTHR46700:SF5', NULL, NULL, NULL, NULL, 'ARMADILLO-TYPE FOLD PROTEIN-RELATED', 240452),
(312448, 'PTHR46700:SF2', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 240452),
(312449, 'PTHR46700:SF3', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 240452),
(312450, 'PTHR46700:SF6', NULL, NULL, NULL, NULL, 'ARMADILLO/BETA-CATENIN-LIKE REPEAT PROTEIN', 240452),
(312451, 'PTHR46700', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 240452),
(312452, 'PTHR47834', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE PROTEIN CITRX, CHLOROPLASTIC', 240453),
(312453, 'PTHR47834:SF2', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE PROTEIN CITRX, CHLOROPLASTIC', 240453),
(312454, 'PTHR47834:SF4', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 240453),
(312455, 'PTHR35449', NULL, NULL, NULL, NULL, 'PROTEIN SIX6OS1', 240454),
(312456, 'PTHR35449:SF1', NULL, NULL, NULL, NULL, 'PROTEIN SIX6OS1', 240454),
(312457, 'PTHR15302:SF0', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF103', 240455),
(312458, 'PTHR15302', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF103', 240455),
(312459, 'PTHR43777', NULL, NULL, NULL, NULL, 'MOLYBDENUM COFACTOR CYTIDYLYLTRANSFERASE', 240456),
(312460, 'PTHR43777:SF1', NULL, NULL, NULL, NULL, 'MOLYBDENUM COFACTOR CYTIDYLYLTRANSFERASE', 240456),
(312461, 'PTHR46490:SF5', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN-RELATED', 240457),
(312462, 'PTHR46490:SF4', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 12 MEMBER A', 240457),
(312463, 'PTHR46490:SF3', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 240457),
(312464, 'PTHR46490', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 12 MEMBER A-RELATED', 240457),
(312465, 'PTHR46490:SF2', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 1 MEMBER B', 240457),
(312466, 'PTHR46490:SF1', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 1 MEMBER A', 240457),
(312467, 'PTHR35555:SF3', NULL, NULL, NULL, NULL, '', 240458),
(312468, 'PTHR35555', NULL, NULL, NULL, NULL, '', 240458),
(312469, 'PTHR35555:SF1', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 240458),
(312470, 'PTHR11584:SF332', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 5', 240459),
(312471, 'PTHR11584:SF369', NULL, NULL, NULL, NULL, 'APOPTOTIC SIGNAL-REGULATING KINASE 1, ISOFORM C', 240459),
(312472, 'PTHR11584:SF391', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 6', 240459),
(312473, 'PTHR11584', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE', 240459),
(312474, 'PTHR11584:SF363', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 15', 240459),
(312475, 'PTHR31639:SF95', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 240460),
(312476, 'PTHR31639:SF262', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN', 240460),
(312477, 'PTHR31639:SF263', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312478, 'PTHR31639:SF264', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312479, 'PTHR31639:SF143', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312480, 'PTHR31639:SF265', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312481, 'PTHR31639:SF144', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(312482, 'PTHR31639:SF266', NULL, NULL, NULL, NULL, 'OS02G0537200 PROTEIN', 240460),
(312483, 'PTHR31639:SF146', NULL, NULL, NULL, NULL, '', 240460),
(312484, 'PTHR31639:SF300', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312485, 'PTHR31639:SF301', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 240460),
(312486, 'PTHR31639:SF302', NULL, NULL, NULL, NULL, 'F-BOX PLANT-LIKE PROTEIN', 240460),
(312487, 'PTHR31639:SF269', NULL, NULL, NULL, NULL, 'F-BOX PLANT-LIKE PROTEIN', 240460),
(312488, 'PTHR31639:SF303', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312489, 'PTHR31639:SF304', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312490, 'PTHR31639:SF305', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312491, 'PTHR31639:SF91', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312492, 'PTHR31639:SF306', NULL, NULL, NULL, NULL, 'BAH DOMAIN-CONTAINING PROTEIN', 240460),
(312493, 'PTHR31639:SF307', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 25-LIKE', 240460),
(312494, 'PTHR31639:SF308', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN, LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 240460),
(312495, 'PTHR31639:SF93', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 240460),
(312496, 'PTHR31639:SF309', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312497, 'PTHR31639:SF84', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312498, 'PTHR31639:SF131', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312499, 'PTHR31639:SF253', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312500, 'PTHR31639:SF132', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE', 240460),
(312501, 'PTHR31639:SF254', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN', 240460),
(312502, 'PTHR31639:SF88', NULL, NULL, NULL, NULL, '', 240460),
(312503, 'PTHR31639:SF256', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312504, 'PTHR31639:SF135', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312505, 'PTHR31639:SF257', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN, FBD DOMAIN, LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 240460),
(312506, 'PTHR31639:SF139', NULL, NULL, NULL, NULL, 'OS07G0242900 PROTEIN', 240460),
(312507, 'PTHR31639:SF240', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312508, 'PTHR31639:SF31', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312509, 'PTHR31639:SF243', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312510, 'PTHR31639:SF245', NULL, NULL, NULL, NULL, 'OS02G0694100 PROTEIN', 240460),
(312511, 'PTHR31639:SF124', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 25-LIKE', 240460),
(312512, 'PTHR31639:SF247', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312513, 'PTHR31639:SF128', NULL, NULL, NULL, NULL, 'OS11G0130500 PROTEIN', 240460),
(312514, 'PTHR31639:SF195', NULL, NULL, NULL, NULL, 'F-BOX/RNI/FBD-LIKE DOMAIN PROTEIN', 240460),
(312515, 'PTHR31639:SF230', NULL, NULL, NULL, NULL, 'OS08G0462300 PROTEIN', 240460),
(312516, 'PTHR31639:SF231', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312517, 'PTHR31639:SF232', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312518, 'PTHR31639:SF22', NULL, NULL, NULL, NULL, 'OS07G0160500 PROTEIN', 240460),
(312519, 'PTHR31639:SF199', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 240460),
(312520, 'PTHR31639:SF234', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE-RELATED', 240460),
(312521, 'PTHR31639:SF237', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 240460),
(312522, 'PTHR31639', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN-LIKE', 240460),
(312523, 'PTHR31639:SF238', NULL, NULL, NULL, NULL, 'F-BOX FAMILY PROTEIN', 240460),
(312524, 'PTHR31639:SF117', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312525, 'PTHR31639:SF193', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 13-LIKE', 240460);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(312526, 'PTHR31639:SF187', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312527, 'PTHR31639:SF100', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312528, 'PTHR31639:SF189', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312529, 'PTHR31639:SF223', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312530, 'PTHR31639:SF103', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN, FBD DOMAIN, LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 240460),
(312531, 'PTHR31639:SF56', NULL, NULL, NULL, NULL, 'OS08G0461800 PROTEIN', 240460),
(312532, 'PTHR31639:SF225', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312533, 'PTHR31639:SF105', NULL, NULL, NULL, NULL, 'F-BOX FAMILY PROTEIN', 240460),
(312534, 'PTHR31639:SF106', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312535, 'PTHR31639:SF229', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312536, 'PTHR31639:SF183', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312537, 'PTHR31639:SF294', NULL, NULL, NULL, NULL, 'OS06G0713400 PROTEIN', 240460),
(312538, 'PTHR31639:SF295', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 240460),
(312539, 'PTHR31639:SF296', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 240460),
(312540, 'PTHR31639:SF42', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312541, 'PTHR31639:SF176', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312542, 'PTHR31639:SF297', NULL, NULL, NULL, NULL, 'OS08G0267800 PROTEIN', 240460),
(312543, 'PTHR31639:SF298', NULL, NULL, NULL, NULL, 'F-BOX/RNI/FBD-LIKE DOMAIN PROTEIN', 240460),
(312544, 'PTHR31639:SF177', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312545, 'PTHR31639:SF211', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312546, 'PTHR31639:SF43', NULL, NULL, NULL, NULL, '', 240460),
(312547, 'PTHR31639:SF299', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312548, 'PTHR31639:SF46', NULL, NULL, NULL, NULL, 'OS04G0267600 PROTEIN', 240460),
(312549, 'PTHR31639:SF213', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312550, 'PTHR31639:SF214', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312551, 'PTHR31639:SF215', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312552, 'PTHR31639:SF217', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312553, 'PTHR31639:SF219', NULL, NULL, NULL, NULL, '', 240460),
(312554, 'PTHR31639:SF290', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312555, 'PTHR31639:SF291', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 240460),
(312556, 'PTHR31639:SF292', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312557, 'PTHR31639:SF293', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312558, 'PTHR31639:SF172', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE', 240460),
(312559, 'PTHR31639:SF283', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312560, 'PTHR31639:SF162', NULL, NULL, NULL, NULL, 'OS09G0454300 PROTEIN', 240460),
(312561, 'PTHR31639:SF284', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 13-LIKE', 240460),
(312562, 'PTHR31639:SF285', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312563, 'PTHR31639:SF286', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312564, 'PTHR31639:SF287', NULL, NULL, NULL, NULL, 'F-BOX AND LEUCINE RICH REPEAT DOMAINS CONTAINING PROTEIN', 240460),
(312565, 'PTHR31639:SF166', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE', 240460),
(312566, 'PTHR31639:SF77', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312567, 'PTHR31639:SF320', NULL, NULL, NULL, NULL, '', 240460),
(312568, 'PTHR31639:SF167', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE', 240460),
(312569, 'PTHR31639:SF321', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN, FBD DOMAIN, LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 240460);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(312570, 'PTHR31639:SF288', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE', 240460),
(312571, 'PTHR31639:SF289', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN', 240460),
(312572, 'PTHR31639:SF322', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', 240460),
(312573, 'PTHR31639:SF202', NULL, NULL, NULL, NULL, 'OS06G0204600 PROTEIN', 240460),
(312574, 'PTHR31639:SF203', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312575, 'PTHR31639:SF204', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312576, 'PTHR31639:SF70', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 240460),
(312577, 'PTHR31639:SF69', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312578, 'PTHR31639:SF280', NULL, NULL, NULL, NULL, 'OS04G0268600 PROTEIN', 240460),
(312579, 'PTHR31639:SF281', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312580, 'PTHR31639:SF160', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN', 240460),
(312581, 'PTHR31639:SF282', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 25-LIKE', 240460),
(312582, 'PTHR31639:SF272', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312583, 'PTHR31639:SF151', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312584, 'PTHR31639:SF62', NULL, NULL, NULL, NULL, '', 240460),
(312585, 'PTHR31639:SF152', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE', 240460),
(312586, 'PTHR31639:SF153', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312587, 'PTHR31639:SF276', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE', 240460),
(312588, 'PTHR31639:SF277', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312589, 'PTHR31639:SF65', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312590, 'PTHR31639:SF310', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312591, 'PTHR31639:SF278', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 240460),
(312592, 'PTHR31639:SF311', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312593, 'PTHR31639:SF312', NULL, NULL, NULL, NULL, 'CYCLIN-LIKE F-BOX', 240460),
(312594, 'PTHR31639:SF279', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312595, 'PTHR31639:SF313', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312596, 'PTHR31639:SF314', NULL, NULL, NULL, NULL, 'OS01G0752100 PROTEIN', 240460),
(312597, 'PTHR31639:SF315', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN, FBD DOMAIN, LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 240460),
(312598, 'PTHR31639:SF316', NULL, NULL, NULL, NULL, 'OS08G0460800 PROTEIN', 240460),
(312599, 'PTHR31639:SF317', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312600, 'PTHR31639:SF318', NULL, NULL, NULL, NULL, 'OS02G0160200 PROTEIN', 240460),
(312601, 'PTHR31639:SF319', NULL, NULL, NULL, NULL, 'F-BOX FAMILY PROTEIN', 240460),
(312602, 'PTHR31639:SF270', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240460),
(312603, 'PTHR31639:SF271', NULL, NULL, NULL, NULL, 'F-BOX FAMILY PROTEIN', 240460),
(312604, 'PTHR21010', NULL, NULL, NULL, NULL, 'AGAP001581-PA', 240461),
(312605, 'PTHR21010:SF3', NULL, NULL, NULL, NULL, 'AGAP001581-PA', 240461),
(312606, 'PTHR48152', NULL, NULL, NULL, NULL, 'F1C9.34 PROTEIN', 240462),
(312607, 'PTHR48152:SF4', NULL, NULL, NULL, NULL, '', 240462),
(312608, 'PTHR48152:SF3', NULL, NULL, NULL, NULL, 'DUF946 FAMILY PROTEIN (DUF946)', 240462),
(312609, 'PTHR48152:SF2', NULL, NULL, NULL, NULL, 'F1C9.34 PROTEIN-RELATED', 240462),
(312610, 'PTHR48152:SF8', NULL, NULL, NULL, NULL, '', 240462),
(312611, 'PTHR48152:SF7', NULL, NULL, NULL, NULL, '', 240462),
(312612, 'PTHR48152:SF6', NULL, NULL, NULL, NULL, '', 240462),
(312613, 'PTHR33153:SF3', NULL, NULL, NULL, NULL, 'MYND-TYPE DOMAIN-CONTAINING PROTEIN', 240463),
(312614, 'PTHR33153', NULL, NULL, NULL, NULL, 'MYND-TYPE DOMAIN-CONTAINING PROTEIN', 240463),
(312615, 'PTHR46304:SF1', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR II-I REPEAT DOMAIN-CONTAINING PROTEIN 1', 240464);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(312616, 'PTHR46304:SF3', NULL, NULL, NULL, NULL, 'GTF2I REPEAT DOMAIN CONTAINING 1', 240464),
(312617, 'PTHR46304:SF2', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR II-I', 240464),
(312618, 'PTHR46304', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR II-I REPEAT DOMAIN-CONTAINING PROTEIN 1', 240464),
(312619, 'PTHR19854:SF15', NULL, NULL, NULL, NULL, 'TRANSDUCIN BETA-LIKE PROTEIN 3', 240465),
(312620, 'PTHR19854', NULL, NULL, NULL, NULL, 'TRANSDUCIN BETA-LIKE 3', 240465),
(312621, 'PTHR19854:SF1', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT BETA-LIKE PROTEIN 1', 240465),
(312622, 'PTHR19854:SF19', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 240465),
(312623, 'PTHR19854:SF22', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 240465),
(312624, 'PTHR24095:SF83', NULL, NULL, NULL, NULL, 'ACETYL-COENZYME A SYNTHETASE', 240466),
(312625, 'PTHR24095:SF110', NULL, NULL, NULL, NULL, 'ACETYL-COENZYME A SYNTHETASE 2-LIKE, MITOCHONDRIAL', 240466),
(312626, 'PTHR24095', NULL, NULL, NULL, NULL, 'ACETYL-COENZYME A SYNTHETASE', 240466),
(312627, 'PTHR24095:SF146', NULL, NULL, NULL, NULL, 'ACETYL-COENZYME A SYNTHETASE', 240466),
(312628, 'PTHR24095:SF245', NULL, NULL, NULL, NULL, 'ACETYL-COENZYME A SYNTHETASE 2', 240466),
(312629, 'PTHR24095:SF244', NULL, NULL, NULL, NULL, 'ACETYL-COENZYME A SYNTHETASE', 240466),
(312630, 'PTHR24095:SF232', NULL, NULL, NULL, NULL, 'ACETYL-COENZYME A SYNTHETASE', 240466),
(312631, 'PTHR24095:SF243', NULL, NULL, NULL, NULL, 'ACETYL-COENZYME A SYNTHETASE', 240466),
(312632, 'PTHR24095:SF217', NULL, NULL, NULL, NULL, 'ACETYL-COENZYME A SYNTHETASE', 240466),
(312633, 'PTHR24095:SF14', NULL, NULL, NULL, NULL, 'ACETYL-COENZYME A SYNTHETASE 1', 240466),
(312634, 'PTHR24095:SF249', NULL, NULL, NULL, NULL, 'ACETYL-COENZYME A SYNTHETASE', 240466),
(312635, 'PTHR24095:SF248', NULL, NULL, NULL, NULL, 'ACETYL-COENZYME A SYNTHETASE', 240466),
(312636, 'PTHR24095:SF247', NULL, NULL, NULL, NULL, 'ACETYL-COENZYME A SYNTHETASE', 240466),
(312637, 'PTHR24095:SF126', NULL, NULL, NULL, NULL, 'ACETYL-COENZYME A SYNTHETASE, CYTOPLASMIC', 240466),
(312638, 'PTHR33343:SF3', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L35', 240467),
(312639, 'PTHR33343', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN BL35M', 240467),
(312640, 'PTHR33343:SF1', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN BL35M', 240467),
(312641, 'PTHR10828:SF74', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE-PHOSPHATASE', 240468),
(312642, 'PTHR10828:SF73', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE-PHOSPHATASE', 240468),
(312643, 'PTHR10828:SF43', NULL, NULL, NULL, NULL, 'M-PHASE INDUCER PHOSPHATASE CDC-25.1', 240468),
(312644, 'PTHR10828:SF64', NULL, NULL, NULL, NULL, 'M-PHASE INDUCER PHOSPHATASE 3', 240468),
(312645, 'PTHR10828:SF67', NULL, NULL, NULL, NULL, 'ARSENATE REDUCTASE 2.1', 240468),
(312646, 'PTHR10828:SF69', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE-PHOSPHATASE', 240468),
(312647, 'PTHR10828:SF46', NULL, NULL, NULL, NULL, 'M-PHASE INDUCER PHOSPHATASE 1', 240468),
(312648, 'PTHR10828:SF38', NULL, NULL, NULL, NULL, 'ARSENICAL-RESISTANCE PROTEIN 2-RELATED', 240468),
(312649, 'PTHR10828:SF48', NULL, NULL, NULL, NULL, 'M-PHASE INDUCER PHOSPHATASE 2', 240468),
(312650, 'PTHR10828:SF17', NULL, NULL, NULL, NULL, 'CDC25-LIKE PROTEIN PHOSPHATASE TWINE-RELATED', 240468),
(312651, 'PTHR10828', NULL, NULL, NULL, NULL, 'M-PHASE INDUCER PHOSPHATASE  DUAL SPECIFICITY PHOSPHATASE CDC25', 240468),
(312652, 'PTHR10828:SF50', NULL, NULL, NULL, NULL, 'REDUCTASE (ARC2), PUTATIVE (AFU_ORTHOLOGUE AFUA_6G13400)-RELATED', 240468),
(312653, 'PTHR34414:SF2', NULL, NULL, NULL, NULL, '', 240469),
(312654, 'PTHR34414:SF1', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 240469),
(312655, 'PTHR34414', NULL, NULL, NULL, NULL, 'HET DOMAIN-CONTAINING PROTEIN-RELATED', 240469),
(312656, 'PTHR44111:SF1', NULL, NULL, NULL, NULL, 'ELONGATOR COMPLEX PROTEIN 2', 240470),
(312657, 'PTHR44111', NULL, NULL, NULL, NULL, 'ELONGATOR COMPLEX PROTEIN 2', 240470),
(312658, 'PTHR30586', NULL, NULL, NULL, NULL, 'ELECTRON TRANSPORT COMPLEX PROTEIN RNFE', 240471);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(312659, 'PTHR30586:SF1', NULL, NULL, NULL, NULL, 'NA(+)-TRANSLOCATING NADH-QUINONE REDUCTASE SUBUNIT D', 240471),
(312660, 'PTHR30586:SF0', NULL, NULL, NULL, NULL, 'ION-TRANSLOCATING OXIDOREDUCTASE COMPLEX SUBUNIT E', 240471),
(312661, 'PTHR23389:SF3', NULL, NULL, NULL, NULL, 'CUTLET', 240472),
(312662, 'PTHR23389:SF21', NULL, NULL, NULL, NULL, 'ATPASE FAMILY AAA DOMAIN-CONTAINING PROTEIN 5', 240472),
(312663, 'PTHR23389:SF6', NULL, NULL, NULL, NULL, 'REPLICATION FACTOR C SUBUNIT 1', 240472),
(312664, 'PTHR23389', NULL, NULL, NULL, NULL, 'CHROMOSOME TRANSMISSION FIDELITY FACTOR 18', 240472),
(312665, 'PTHR23389:SF9', NULL, NULL, NULL, NULL, 'DNA LIGASE', 240472),
(312666, 'PTHR23389:SF33', NULL, NULL, NULL, NULL, 'CHROMOSOME TRANSMISSION FIDELITY PROTEIN 18 HOMOLOG', 240472),
(312667, 'PTHR23389:SF11', NULL, NULL, NULL, NULL, 'TELOMERE LENGTH REGULATION PROTEIN ELG1', 240472),
(312668, 'PTHR23389:SF12', NULL, NULL, NULL, NULL, 'CYTOKINE RECEPTOR-LIKE FACTOR 3', 240472),
(312669, 'PTHR23389:SF34', NULL, NULL, NULL, NULL, 'PROTEIN CBG21002', 240472),
(312670, 'PTHR23389:SF13', NULL, NULL, NULL, NULL, '', 240472),
(312671, 'PTHR23389:SF35', NULL, NULL, NULL, NULL, 'FACTOR C, SUBUNIT 1, PUTATIVE-RELATED', 240472),
(312672, 'PTHR40845:SF1', NULL, NULL, NULL, NULL, '', 240473),
(312673, 'PTHR40845', NULL, NULL, NULL, NULL, '', 240473),
(312674, 'PTHR39244:SF4', NULL, NULL, NULL, NULL, 'AGGLUTININ DOMAIN-CONTAINING PROTEIN', 240474),
(312675, 'PTHR39244:SF3', NULL, NULL, NULL, NULL, 'AGGLUTININ DOMAIN-CONTAINING PROTEIN', 240474),
(312676, 'PTHR39244', NULL, NULL, NULL, NULL, 'NATTERIN-4', 240474),
(312677, 'PTHR39244:SF6', NULL, NULL, NULL, NULL, 'AGGLUTININ DOMAIN-CONTAINING PROTEIN', 240474),
(312678, 'PTHR39244:SF5', NULL, NULL, NULL, NULL, 'AGGLUTININ DOMAIN-CONTAINING PROTEIN', 240474),
(312679, 'PTHR39244:SF2', NULL, NULL, NULL, NULL, 'AGGLUTININ DOMAIN-CONTAINING PROTEIN', 240474),
(312680, 'PTHR43096:SF64', NULL, NULL, NULL, NULL, 'PROTEIN DNAJ, PUTATIVE-RELATED', 240475),
(312681, 'PTHR43096:SF42', NULL, NULL, NULL, NULL, 'BNAA01G34580D PROTEIN', 240475),
(312682, 'PTHR43096:SF52', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ GFA2, MITOCHONDRIAL', 240475),
(312683, 'PTHR43096:SF63', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 240475),
(312684, 'PTHR43096:SF62', NULL, NULL, NULL, NULL, 'PROTEIN DNAJ, PUTATIVE-RELATED', 240475),
(312685, 'PTHR43096:SF61', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', 240475),
(312686, 'PTHR43096:SF50', NULL, NULL, NULL, NULL, 'DNAJ-CLASS MOLECULAR CHAPERONE', 240475),
(312687, 'PTHR43096:SF68', NULL, NULL, NULL, NULL, 'DNAJ_C DOMAIN-CONTAINING PROTEIN', 240475),
(312688, 'PTHR43096:SF45', NULL, NULL, NULL, NULL, 'DNAJ C TERMINAL REGION FAMILY PROTEIN, EXPRESSED', 240475),
(312689, 'PTHR43096:SF67', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK FAMILY PROTEIN', 240475),
(312690, 'PTHR43096:SF56', NULL, NULL, NULL, NULL, 'BNAC07G49210D PROTEIN', 240475),
(312691, 'PTHR43096:SF22', NULL, NULL, NULL, NULL, 'MOLECULAR CHAPERONE HSP40/DNAJ FAMILY PROTEIN', 240475),
(312692, 'PTHR43096:SF66', NULL, NULL, NULL, NULL, 'DNAJ-RELATED PROTEIN RSP1', 240475),
(312693, 'PTHR43096:SF43', NULL, NULL, NULL, NULL, 'ASSOCIATED DNAJ CHAPERONE, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G02090)-RELATED', 240475),
(312694, 'PTHR43096:SF65', NULL, NULL, NULL, NULL, 'DNAJ_C DOMAIN-CONTAINING PROTEIN', 240475),
(312695, 'PTHR43096:SF54', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ 1', 240475),
(312696, 'PTHR43096:SF10', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG 1, MITOCHONDRIAL-RELATED', 240475),
(312697, 'PTHR43096', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG 1, MITOCHONDRIAL-RELATED', 240475),
(312698, 'PTHR43096:SF60', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 240475),
(312699, 'PTHR43096:SF38', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ A6, CHLOROPLASTIC-LIKE', 240475),
(312700, 'PTHR43096:SF26', NULL, NULL, NULL, NULL, 'MOLECULAR CHAPERONE HSP40/DNAJ FAMILY PROTEIN', 240475),
(312701, 'PTHR43096:SF48', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ', 240475);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(312702, 'PTHR43096:SF36', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ 1, MITOCHONDRIAL', 240475),
(312703, 'PTHR43096:SF58', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', 240475),
(312704, 'PTHR28533:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PBN1', 240476),
(312705, 'PTHR28533', NULL, NULL, NULL, NULL, 'PROTEIN PBN1', 240476),
(312706, 'PTHR14856', NULL, NULL, NULL, NULL, 'PQ-LOOP REPEAT-CONTAINING PROTEIN 1-LIKE PROTEIN', 240477),
(312707, 'PTHR14856:SF11', NULL, NULL, NULL, NULL, 'SI:DKEY-246G23.2', 240477),
(312708, 'PTHR14856:SF10', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 66 MEMBER 2', 240477),
(312709, 'PTHR14856:SF9', NULL, NULL, NULL, NULL, 'SCRAMBLASE ANY1', 240477),
(312710, 'PTHR19271:SF33', NULL, NULL, NULL, NULL, 'CYTOCHROME B6/F COMPLEX, SUBUNIT IV-RELATED', 240478),
(312711, 'PTHR19271:SF32', NULL, NULL, NULL, NULL, 'CYTOCHROME B6-F COMPLEX SUBUNIT 4', 240478),
(312712, 'PTHR19271:SF20', NULL, NULL, NULL, NULL, 'CYTB_NTER DOMAIN-CONTAINING PROTEIN', 240478),
(312713, 'PTHR19271:SF31', NULL, NULL, NULL, NULL, 'CYTOCHROME B6', 240478),
(312714, 'PTHR19271:SF30', NULL, NULL, NULL, NULL, 'CYTOCHROME B', 240478),
(312715, 'PTHR19271:SF29', NULL, NULL, NULL, NULL, 'CYTOCHROME B6', 240478),
(312716, 'PTHR19271:SF16', NULL, NULL, NULL, NULL, 'CYTOCHROME B6', 240478),
(312717, 'PTHR19271:SF27', NULL, NULL, NULL, NULL, 'CYTOCHROME B6-F COMPLEX SUBUNIT 4', 240478),
(312718, 'PTHR19271:SF37', NULL, NULL, NULL, NULL, 'CYTOCHROME B', 240478),
(312719, 'PTHR19271:SF36', NULL, NULL, NULL, NULL, 'CYTB_NTER DOMAIN-CONTAINING PROTEIN', 240478),
(312720, 'PTHR19271:SF35', NULL, NULL, NULL, NULL, 'CYTOCHROME B', 240478),
(312721, 'PTHR19271:SF34', NULL, NULL, NULL, NULL, 'CYTB_NTER DOMAIN-CONTAINING PROTEIN', 240478),
(312722, 'PTHR19271', NULL, NULL, NULL, NULL, 'CYTOCHROME B', 240478),
(312723, 'PTHR48028:SF4', NULL, NULL, NULL, NULL, 'SC35-LIKE SPLICING FACTOR', 240479),
(312724, 'PTHR48028:SF3', NULL, NULL, NULL, NULL, 'BNAC02G48060D PROTEIN', 240479),
(312725, 'PTHR48028:SF2', NULL, NULL, NULL, NULL, 'GLYCINE-RICH RNA-BINDING PROTEIN RZ1A', 240479),
(312726, 'PTHR48028:SF1', NULL, NULL, NULL, NULL, 'OS03G0836200 PROTEIN', 240479),
(312727, 'PTHR48028:SF5', NULL, NULL, NULL, NULL, 'GLYCINE-RICH RNA-BINDING PROTEIN RZ1A-LIKE', 240479),
(312728, 'PTHR48028', NULL, NULL, NULL, NULL, 'GLYCINE-RICH RNA-BINDING PROTEIN RZ1A', 240479),
(312729, 'PTHR33169:SF25', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN YIZB-RELATED', 240480),
(312730, 'PTHR33169:SF14', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR RV3488', 240480),
(312731, 'PTHR33169:SF26', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', 240480),
(312732, 'PTHR33169:SF13', NULL, NULL, NULL, NULL, 'PADR-FAMILY TRANSCRIPTIONAL REGULATOR', 240480),
(312733, 'PTHR33169:SF24', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, PADR FAMILY', 240480),
(312734, 'PTHR33169', NULL, NULL, NULL, NULL, 'PADR-FAMILY TRANSCRIPTIONAL REGULATOR', 240480),
(312735, 'PTHR13477', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 39S RIBOSOMAL PROTEIN L49', 240481),
(312736, 'PTHR13477:SF0', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L49, MITOCHONDRIAL', 240481),
(312737, 'PTHR22972:SF8', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240482),
(312738, 'PTHR22972:SF7', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PINK1, MITOCHONDRIAL', 240482),
(312739, 'PTHR22972:SF6', NULL, NULL, NULL, NULL, 'PROTEIN PEAK3', 240482),
(312740, 'PTHR22972:SF5', NULL, NULL, NULL, NULL, 'INACTIVE TYROSINE-PROTEIN KINASE PEAK1', 240482),
(312741, 'PTHR22972:SF3', NULL, NULL, NULL, NULL, 'INACTIVE TYROSINE-PROTEIN KINASE PRAG1', 240482),
(312742, 'PTHR22972', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE', 240482),
(312743, 'PTHR47698:SF2', NULL, NULL, NULL, NULL, 'FATTY-ACID-BINDING PROTEIN 3, CHLOROPLASTIC', 240483),
(312744, 'PTHR47698', NULL, NULL, NULL, NULL, 'FATTY-ACID-BINDING PROTEIN 3, CHLOROPLASTIC', 240483),
(312745, 'PTHR33673:SF2', NULL, NULL, NULL, NULL, 'OS06G0150000 PROTEIN', 240484),
(312746, 'PTHR33673:SF3', NULL, NULL, NULL, NULL, 'SUPPRESSOR SRP40-LIKE PROTEIN', 240484);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(312747, 'PTHR33673:SF4', NULL, NULL, NULL, NULL, 'OS01G0193400 PROTEIN', 240484),
(312748, 'PTHR33673:SF29', NULL, NULL, NULL, NULL, '', 240484),
(312749, 'PTHR33673:SF38', NULL, NULL, NULL, NULL, 'HOMEOBOX-LIKE PROTEIN', 240484),
(312750, 'PTHR33673:SF17', NULL, NULL, NULL, NULL, '', 240484),
(312751, 'PTHR33673:SF39', NULL, NULL, NULL, NULL, 'BNAA09G56770D PROTEIN', 240484),
(312752, 'PTHR33673:SF36', NULL, NULL, NULL, NULL, 'MYB-LIKE PROTEIN Q', 240484),
(312753, 'PTHR33673:SF25', NULL, NULL, NULL, NULL, '', 240484),
(312754, 'PTHR33673:SF14', NULL, NULL, NULL, NULL, 'BNAC02G22810D PROTEIN', 240484),
(312755, 'PTHR33673:SF26', NULL, NULL, NULL, NULL, 'PININ-LIKE PROTEIN', 240484),
(312756, 'PTHR33673:SF37', NULL, NULL, NULL, NULL, 'BNAA06G10030D PROTEIN', 240484),
(312757, 'PTHR33673:SF35', NULL, NULL, NULL, NULL, '', 240484),
(312758, 'PTHR33673:SF21', NULL, NULL, NULL, NULL, '', 240484),
(312759, 'PTHR33673', NULL, NULL, NULL, NULL, 'SUPPRESSOR SRP40-LIKE PROTEIN', 240484),
(312760, 'PTHR37307', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN WHIA-RELATED', 240485),
(312761, 'PTHR37307:SF1', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN WHIA-RELATED', 240485),
(312762, 'PTHR38688:SF1', NULL, NULL, NULL, NULL, 'PYR_REDOX_2 DOMAIN-CONTAINING PROTEIN', 240486),
(312763, 'PTHR38688', NULL, NULL, NULL, NULL, 'PYR_REDOX_2 DOMAIN-CONTAINING PROTEIN', 240486),
(312764, 'PTHR35535:SF1', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN HSLJ', 240487),
(312765, 'PTHR35535', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN HSLJ', 240487),
(312766, 'PTHR33883:SF10', NULL, NULL, NULL, NULL, 'WPP DOMAIN-ASSOCIATED PROTEIN', 240488),
(312767, 'PTHR33883:SF5', NULL, NULL, NULL, NULL, 'OS09G0133800 PROTEIN', 240488),
(312768, 'PTHR33883:SF4', NULL, NULL, NULL, NULL, 'OS07G0147800 PROTEIN', 240488),
(312769, 'PTHR33883:SF7', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 240488),
(312770, 'PTHR33883:SF6', NULL, NULL, NULL, NULL, 'WPP DOMAIN-ASSOCIATED PROTEIN', 240488),
(312771, 'PTHR33883:SF9', NULL, NULL, NULL, NULL, 'WPP DOMAIN-ASSOCIATED PROTEIN-LIKE', 240488),
(312772, 'PTHR33883:SF11', NULL, NULL, NULL, NULL, 'BNAC05G23540D PROTEIN', 240488),
(312773, 'PTHR33883', NULL, NULL, NULL, NULL, 'WPP DOMAIN-ASSOCIATED PROTEIN', 240488),
(312774, 'PTHR33883:SF12', NULL, NULL, NULL, NULL, 'OS04G0521600 PROTEIN', 240488),
(312775, 'PTHR34372:SF7', NULL, NULL, NULL, NULL, '', 240489),
(312776, 'PTHR34372:SF8', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 5C', 240489),
(312777, 'PTHR34372:SF9', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 5C-RELATED', 240489),
(312778, 'PTHR34372', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 5C-2-RELATED', 240489),
(312779, 'PTHR34372:SF10', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 5C', 240489),
(312780, 'PTHR34372:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 5C-2-RELATED', 240489),
(312781, 'PTHR34372:SF3', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 5C-4-RELATED', 240489),
(312782, 'PTHR34372:SF4', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 5C-1-LIKE', 240489),
(312783, 'PTHR34372:SF5', NULL, NULL, NULL, NULL, '', 240489),
(312784, 'PTHR31040:SF1', NULL, NULL, NULL, NULL, 'NURIM', 240490),
(312785, 'PTHR31040', NULL, NULL, NULL, NULL, 'NURIM', 240490),
(312786, 'PTHR31813:SF4', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 23A', 240491),
(312787, 'PTHR31813:SF3', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 23D1-RELATED', 240491),
(312788, 'PTHR31813:SF6', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 23C', 240491),
(312789, 'PTHR31813:SF18', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 23B', 240491),
(312790, 'PTHR31813:SF19', NULL, NULL, NULL, NULL, '', 240491),
(312791, 'PTHR31813', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 23B', 240491),
(312792, 'PTHR31813:SF17', NULL, NULL, NULL, NULL, 'CHROMOSOME 3 OPEN READING FRAME 56', 240491),
(312793, 'PTHR31813:SF9', NULL, NULL, NULL, NULL, 'RIKEN CDNA 7420426K07 GENE', 240491),
(312794, 'PTHR21615:SF2', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN 1', 240492);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(312795, 'PTHR21615', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 240492),
(312796, 'PTHR47915:SF1', NULL, NULL, NULL, NULL, 'SI:DKEY-19B23.7', 240493),
(312797, 'PTHR47915', NULL, NULL, NULL, NULL, 'SI:DKEY-19B23.7', 240493),
(312798, 'PTHR18864', NULL, NULL, NULL, NULL, 'KINECTIN', 240494),
(312799, 'PTHR18864:SF1', NULL, NULL, NULL, NULL, 'KINECTIN', 240494),
(312800, 'PTHR37760:SF2', NULL, NULL, NULL, NULL, '', 240495),
(312801, 'PTHR37760', NULL, NULL, NULL, NULL, 'CHAPERONE', 240495),
(312802, 'PTHR37760:SF1', NULL, NULL, NULL, NULL, 'CHAPERONE', 240495),
(312803, 'PTHR35685:SF3', NULL, NULL, NULL, NULL, 'GEO02515P1-RELATED', 240496),
(312804, 'PTHR35685:SF2', NULL, NULL, NULL, NULL, '825-OAK-RELATED', 240496),
(312805, 'PTHR35685', NULL, NULL, NULL, NULL, '825-OAK-RELATED-RELATED', 240496),
(312806, 'PTHR33726:SF20', NULL, NULL, NULL, NULL, 'AVR9/CF-9 RAPIDLY ELICITED PROTEIN 180', 240497),
(312807, 'PTHR33726:SF21', NULL, NULL, NULL, NULL, 'BNAA06G36050D PROTEIN', 240497),
(312808, 'PTHR33726:SF3', NULL, NULL, NULL, NULL, 'OS01G0750900 PROTEIN', 240497),
(312809, 'PTHR33726:SF8', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 240497),
(312810, 'PTHR33726:SF19', NULL, NULL, NULL, NULL, 'OS03G0313800 PROTEIN', 240497),
(312811, 'PTHR33726', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 240497),
(312812, 'PTHR33726:SF17', NULL, NULL, NULL, NULL, '', 240497),
(312813, 'PTHR33726:SF18', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 240497),
(312814, 'PTHR33726:SF26', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 240497),
(312815, 'PTHR33726:SF15', NULL, NULL, NULL, NULL, 'OS01G0665900 PROTEIN', 240497),
(312816, 'PTHR33726:SF24', NULL, NULL, NULL, NULL, 'OS01G0631800 PROTEIN', 240497),
(312817, 'PTHR33726:SF13', NULL, NULL, NULL, NULL, 'OS05G0565701 PROTEIN', 240497),
(312818, 'PTHR33726:SF25', NULL, NULL, NULL, NULL, 'BNAA09G17940D PROTEIN', 240497),
(312819, 'PTHR33726:SF22', NULL, NULL, NULL, NULL, '', 240497),
(312820, 'PTHR33726:SF23', NULL, NULL, NULL, NULL, 'OS06G0620700 PROTEIN', 240497),
(312821, 'PTHR19963', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 240498),
(312822, 'PTHR19963:SF30', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 240498),
(312823, 'PTHR41771', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 240499),
(312824, 'PTHR41771:SF1', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 240499),
(312825, 'PTHR11458:SF1', NULL, NULL, NULL, NULL, 'DELTA-AMINOLEVULINIC ACID DEHYDRATASE', 240500),
(312826, 'PTHR11458:SF0', NULL, NULL, NULL, NULL, 'DELTA-AMINOLEVULINIC ACID DEHYDRATASE', 240500),
(312827, 'PTHR11458:SF3', NULL, NULL, NULL, NULL, 'DELTA-AMINOLEVULINIC ACID DEHYDRATASE 2, CHLOROPLASTIC-RELATED', 240500),
(312828, 'PTHR11458:SF2', NULL, NULL, NULL, NULL, 'DELTA-AMINOLEVULINIC ACID DEHYDRATASE', 240500),
(312829, 'PTHR11458', NULL, NULL, NULL, NULL, 'DELTA-AMINOLEVULINIC ACID DEHYDRATASE', 240500),
(312830, 'PTHR11458:SF4', NULL, NULL, NULL, NULL, 'PORPHOBILINOGEN SYNTHASE', 240500),
(312831, 'PTHR15304:SF3', NULL, NULL, NULL, NULL, 'ZGC:113363', 240501),
(312832, 'PTHR15304:SF2', NULL, NULL, NULL, NULL, 'MYOD FAMILY INHIBITOR DOMAIN-CONTAINING PROTEIN 2', 240501),
(312833, 'PTHR15304:SF1', NULL, NULL, NULL, NULL, 'MYOD FAMILY INHIBITOR', 240501),
(312834, 'PTHR15304:SF0', NULL, NULL, NULL, NULL, 'MYOD FAMILY INHIBITOR DOMAIN-CONTAINING PROTEIN', 240501),
(312835, 'PTHR15304', NULL, NULL, NULL, NULL, 'MYOD FAMILY INHIBITOR', 240501),
(312836, 'PTHR31718:SF64', NULL, NULL, NULL, NULL, 'PLAT DOMAIN-CONTAINING PROTEIN', 240502),
(312837, 'PTHR31718:SF41', NULL, NULL, NULL, NULL, 'PLAT DOMAIN-CONTAINING PROTEIN', 240502),
(312838, 'PTHR31718:SF63', NULL, NULL, NULL, NULL, 'LIPOXYGENASE HOMOLOGY DOMAIN-CONTAINING PROTEIN 1-LIKE', 240502),
(312839, 'PTHR31718:SF22', NULL, NULL, NULL, NULL, 'OS02G0753300 PROTEIN', 240502),
(312840, 'PTHR31718:SF44', NULL, NULL, NULL, NULL, 'BNAC04G47710D PROTEIN', 240502),
(312841, 'PTHR31718:SF43', NULL, NULL, NULL, NULL, 'PLAT/LH2 DOMAIN-CONTAINING PROTEIN-RELATED', 240502),
(312842, 'PTHR31718:SF46', NULL, NULL, NULL, NULL, 'EMBRYO-SPECIFIC PROTEIN ATS3A', 240502);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(312843, 'PTHR31718:SF23', NULL, NULL, NULL, NULL, 'EMBRYO-SPECIFIC PROTEIN 3, (ATS3)', 240502),
(312844, 'PTHR31718:SF25', NULL, NULL, NULL, NULL, 'LIPOXYGENASE HOMOLOGY DOMAIN-CONTAINING PROTEIN 1-LIKE', 240502),
(312845, 'PTHR31718:SF47', NULL, NULL, NULL, NULL, 'OS10G0361900 PROTEIN', 240502),
(312846, 'PTHR31718:SF60', NULL, NULL, NULL, NULL, 'PLAT DOMAIN-CONTAINING PROTEIN', 240502),
(312847, 'PTHR31718:SF62', NULL, NULL, NULL, NULL, 'PLAT-PLANT-STRESS PROTEIN', 240502),
(312848, 'PTHR31718:SF61', NULL, NULL, NULL, NULL, 'PLAT DOMAIN-CONTAINING PROTEIN 1', 240502),
(312849, 'PTHR31718:SF39', NULL, NULL, NULL, NULL, 'PLAT DOMAIN-CONTAINING PROTEIN', 240502),
(312850, 'PTHR31718:SF38', NULL, NULL, NULL, NULL, 'PLAT DOMAIN-CONTAINING PROTEIN', 240502),
(312851, 'PTHR31718:SF0', NULL, NULL, NULL, NULL, 'PLAT DOMAIN-CONTAINING PROTEIN 2', 240502),
(312852, 'PTHR31718:SF31', NULL, NULL, NULL, NULL, 'OS01G0172800 PROTEIN', 240502),
(312853, 'PTHR31718:SF30', NULL, NULL, NULL, NULL, 'EMBRYO-SPECIFIC PROTEIN', 240502),
(312854, 'PTHR31718:SF32', NULL, NULL, NULL, NULL, 'EMBRYO-SPECIFIC PROTEIN ATS3B', 240502),
(312855, 'PTHR31718:SF57', NULL, NULL, NULL, NULL, 'PLAT DOMAIN-CONTAINING PROTEIN', 240502),
(312856, 'PTHR31718:SF35', NULL, NULL, NULL, NULL, 'EMBRYO-SPECIFIC PROTEIN', 240502),
(312857, 'PTHR31718:SF56', NULL, NULL, NULL, NULL, 'PLAT DOMAIN-CONTAINING PROTEIN', 240502),
(312858, 'PTHR31718:SF34', NULL, NULL, NULL, NULL, 'EMBRYO-SPECIFIC PROTEIN ATS3', 240502),
(312859, 'PTHR31718:SF59', NULL, NULL, NULL, NULL, 'PLAT DOMAIN-CONTAINING PROTEIN', 240502),
(312860, 'PTHR31718:SF37', NULL, NULL, NULL, NULL, 'BNAA03G55510D PROTEIN', 240502),
(312861, 'PTHR31718:SF36', NULL, NULL, NULL, NULL, 'LIPOXYGENASE HOMOLOGY DOMAIN-CONTAINING PROTEIN 1-LIKE', 240502),
(312862, 'PTHR31718:SF58', NULL, NULL, NULL, NULL, 'BNAA09G05940D PROTEIN', 240502),
(312863, 'PTHR31718', NULL, NULL, NULL, NULL, 'PLAT DOMAIN-CONTAINING PROTEIN', 240502),
(312864, 'PTHR31718:SF27', NULL, NULL, NULL, NULL, 'OS05G0171200 PROTEIN', 240502),
(312865, 'PTHR42791:SF9', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 240503),
(312866, 'PTHR42791:SF6', NULL, NULL, NULL, NULL, 'HYPOTHETICAL ACETYLTRANSFERASE (EUROFUNG)', 240503),
(312867, 'PTHR42791', NULL, NULL, NULL, NULL, 'GNAT FAMILY ACETYLTRANSFERASE', 240503),
(312868, 'PTHR42791:SF5', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 240503),
(312869, 'PTHR42791:SF4', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE, GNAT FAMILY FAMILY (AFU_ORTHOLOGUE AFUA_4G09540)-RELATED', 240503),
(312870, 'PTHR42791:SF2', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE, GNAT FAMILY FAMILY (AFU_ORTHOLOGUE AFUA_8G05690)', 240503),
(312871, 'PTHR42791:SF1', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 240503),
(312872, 'PTHR42791:SF15', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 240503),
(312873, 'PTHR42791:SF14', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 240503),
(312874, 'PTHR42791:SF12', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 240503),
(312875, 'PTHR48236:SF1', NULL, NULL, NULL, NULL, 'COX19-LIKE CHCH FAMILY PROTEIN', 240504),
(312876, 'PTHR48236', NULL, NULL, NULL, NULL, 'COX19-LIKE CHCH FAMILY PROTEIN', 240504),
(312877, 'PTHR12634:SF30', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 6 REGULATORY SUBUNIT 3-LIKE ISOFORM X1', 240505),
(312878, 'PTHR12634:SF31', NULL, NULL, NULL, NULL, 'BNAC08G02360D PROTEIN', 240505),
(312879, 'PTHR12634:SF20', NULL, NULL, NULL, NULL, 'SIT4 PHOSPHATASE-ASSOCIATED FAMILY PROTEIN', 240505),
(312880, 'PTHR12634:SF12', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 6 REGULATORY SUBUNIT 3', 240505),
(312881, 'PTHR12634:SF34', NULL, NULL, NULL, NULL, 'SIT4 PHOSPHATASE-ASSOCIATED FAMILY PROTEIN', 240505),
(312882, 'PTHR12634:SF13', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 6 REGULATORY SUBUNIT 1', 240505),
(312883, 'PTHR12634:SF35', NULL, NULL, NULL, NULL, 'SIT4 PHOSPHATASE-ASSOCIATED FAMILY PROTEIN', 240505);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(312884, 'PTHR12634:SF21', NULL, NULL, NULL, NULL, 'SIT4 PHOSPHATASE-ASSOCIATED FAMILY PROTEIN', 240505),
(312885, 'PTHR12634:SF27', NULL, NULL, NULL, NULL, 'BNACNNG15910D PROTEIN', 240505),
(312886, 'PTHR12634:SF14', NULL, NULL, NULL, NULL, 'SIT4-ASSOCIATING PROTEIN SAP155-RELATED', 240505),
(312887, 'PTHR12634:SF36', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 6 REGULATORY SUBUNIT 3-LIKE ISOFORM X1', 240505),
(312888, 'PTHR12634:SF8', NULL, NULL, NULL, NULL, 'FIERY MOUNTAIN, ISOFORM D', 240505),
(312889, 'PTHR12634:SF15', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 6 REGULATORY SUBUNIT 2', 240505),
(312890, 'PTHR12634:SF26', NULL, NULL, NULL, NULL, 'SIT4 PHOSPHATASE-ASSOCIATED PROTEIN FAMILY, ARMADILLO-TYPE FOLD PROTEIN-RELATED', 240505),
(312891, 'PTHR12634:SF37', NULL, NULL, NULL, NULL, 'SIT4 PHOSPHATASE-ASSOCIATED FAMILY PROTEIN', 240505),
(312892, 'PTHR12634', NULL, NULL, NULL, NULL, 'SIT4 YEAST -ASSOCIATING PROTEIN-RELATED', 240505),
(312893, 'PTHR46380', NULL, NULL, NULL, NULL, 'CYCLIN-D-BINDING MYB-LIKE TRANSCRIPTION FACTOR 1', 240506),
(312894, 'PTHR46380:SF1', NULL, NULL, NULL, NULL, 'CYCLIN-D-BINDING MYB-LIKE TRANSCRIPTION FACTOR 1', 240506),
(312895, 'PTHR46380:SF2', NULL, NULL, NULL, NULL, 'CYCLIN-D-BINDING MYB-LIKE TRANSCRIPTION FACTOR 1', 240506),
(312896, 'PTHR46380:SF3', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4932411N23 GENE', 240506),
(312897, 'PTHR46380:SF4', NULL, NULL, NULL, NULL, 'REPLICATION TERMINATION FACTOR 1', 240506),
(312898, 'PTHR46380:SF5', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN REB1', 240506),
(312899, 'PTHR23329:SF1', NULL, NULL, NULL, NULL, 'TUFTELIN-INTERACTING PROTEIN 11', 240507),
(312900, 'PTHR23329', NULL, NULL, NULL, NULL, 'TUFTELIN-INTERACTING PROTEIN 11-RELATED', 240507),
(312901, 'PTHR23329:SF16', NULL, NULL, NULL, NULL, 'SEPTIN AND TUFTELIN-INTERACTING PROTEIN 1 HOMOLOG 1', 240507),
(312902, 'PTHR46025:SF4', NULL, NULL, NULL, NULL, 'PROTEIN XYLOSYLTRANSFERASE', 240508),
(312903, 'PTHR46025:SF2', NULL, NULL, NULL, NULL, 'XYLOSYLTRANSFERASE 1', 240508),
(312904, 'PTHR46025:SF3', NULL, NULL, NULL, NULL, 'XYLOSYLTRANSFERASE OXT', 240508),
(312905, 'PTHR46025:SF1', NULL, NULL, NULL, NULL, 'XYLOSYLTRANSFERASE 2', 240508),
(312906, 'PTHR46025', NULL, NULL, NULL, NULL, 'XYLOSYLTRANSFERASE OXT', 240508),
(312907, 'PTHR36932:SF1', NULL, NULL, NULL, NULL, 'CAPSULAR POLYSACCHARIDE BIOSYNTHESIS PROTEIN', 240509),
(312908, 'PTHR36932', NULL, NULL, NULL, NULL, 'CAPSULAR POLYSACCHARIDE BIOSYNTHESIS PROTEIN', 240509),
(312909, 'PTHR48059:SF15', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE INHIBITOR 2', 240510),
(312910, 'PTHR48059:SF14', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE INHIBITOR', 240510),
(312911, 'PTHR48059:SF13', NULL, NULL, NULL, NULL, 'BNAA03G55650D PROTEIN', 240510),
(312912, 'PTHR48059:SF12', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 240510),
(312913, 'PTHR48059:SF11', NULL, NULL, NULL, NULL, 'BNAA03G55610D PROTEIN', 240510),
(312914, 'PTHR48059:SF30', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT PROTEIN', 240510),
(312915, 'PTHR48059:SF2', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 240510),
(312916, 'PTHR48059:SF19', NULL, NULL, NULL, NULL, 'SERINE-THREONINE PROTEIN KINASE, PLANT-TYPE', 240510),
(312917, 'PTHR48059:SF16', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 240510),
(312918, 'PTHR48059:SF9', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT (LRR) FAMILY PROTEIN', 240510),
(312919, 'PTHR48059:SF7', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 240510),
(312920, 'PTHR48059:SF6', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 240510),
(312921, 'PTHR48059:SF4', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE INHIBITOR 1', 240510),
(312922, 'PTHR48059:SF3', NULL, NULL, NULL, NULL, 'OS05G0104700 PROTEIN', 240510),
(312923, 'PTHR48059', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE INHIBITOR 1', 240510),
(312924, 'PTHR48059:SF26', NULL, NULL, NULL, NULL, '', 240510),
(312925, 'PTHR48059:SF25', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN FLOR 1', 240510); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(312926, 'PTHR48059:SF24', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE INHIBITOR', 240510),
(312927, 'PTHR48059:SF23', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT (LRR) FAMILY PROTEIN', 240510),
(312928, 'PTHR48059:SF22', NULL, NULL, NULL, NULL, 'BNAA05G26870D PROTEIN', 240510),
(312929, 'PTHR48059:SF21', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 240510),
(312930, 'PTHR48059:SF20', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 240510),
(312931, 'PTHR48059:SF29', NULL, NULL, NULL, NULL, 'BNAA05G26860D PROTEIN', 240510),
(312932, 'PTHR48059:SF28', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE INHIBITOR', 240510),
(312933, 'PTHR48059:SF27', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 240510),
(312934, 'PTHR30521', NULL, NULL, NULL, NULL, 'DEFERROCHELATASE/PEROXIDASE', 240511),
(312935, 'PTHR30521:SF0', NULL, NULL, NULL, NULL, 'DYE-DECOLORIZING PEROXIDASE YFEX', 240511),
(312936, 'PTHR30521:SF4', NULL, NULL, NULL, NULL, 'DEFERROCHELATASE/PEROXIDASE EFEB', 240511),
(312937, 'PTHR30521:SF5', NULL, NULL, NULL, NULL, 'BLR4509 PROTEIN', 240511),
(312938, 'PTHR14964:SF3', NULL, NULL, NULL, NULL, '', 240512),
(312939, 'PTHR14964:SF4', NULL, NULL, NULL, NULL, '', 240512),
(312940, 'PTHR14964:SF5', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR-BINDING FACTOR 2', 240512),
(312941, 'PTHR14964:SF2', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR-BINDING FACTOR 2', 240512),
(312942, 'PTHR14964', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR BINDING FACTOR 2', 240512),
(312943, 'PTHR13580', NULL, NULL, NULL, NULL, 'TGF-BETA INDUCED APOPTOSIS PROTEIN', 240513),
(312944, 'PTHR13580:SF13', NULL, NULL, NULL, NULL, 'CYSTEINE/SERINE-RICH NUCLEAR PROTEIN 3', 240513),
(312945, 'PTHR13580:SF6', NULL, NULL, NULL, NULL, 'CYSTEINE/SERINE-RICH NUCLEAR PROTEIN 2', 240513),
(312946, 'PTHR13580:SF9', NULL, NULL, NULL, NULL, 'AXIN1 UP-REGULATED 1, ISOFORM A', 240513),
(312947, 'PTHR13580:SF10', NULL, NULL, NULL, NULL, 'CYSTEINE/SERINE-RICH NUCLEAR PROTEIN 1', 240513),
(312948, 'PTHR32157:SF8', NULL, NULL, NULL, NULL, 'CANCER/TESTIS ANTIGEN 47A', 240514),
(312949, 'PTHR32157:SF5', NULL, NULL, NULL, NULL, 'CANCER/TESTIS ANTIGEN 47B', 240514),
(312950, 'PTHR32157:SF0', NULL, NULL, NULL, NULL, 'GENE 6268-RELATED', 240514),
(312951, 'PTHR32157', NULL, NULL, NULL, NULL, 'GENE 6268-RELATED', 240514),
(312952, 'PTHR31346:SF7', NULL, NULL, NULL, NULL, 'MULTIPLE ORGANELLAR RNA EDITING FACTOR 2, CHLOROPLASTIC-RELATED', 240515),
(312953, 'PTHR31346:SF4', NULL, NULL, NULL, NULL, 'MULTIPLE ORGANELLAR RNA EDITING FACTOR 8, CHLOROPLASTIC/MITOCHONDRIAL', 240515),
(312954, 'PTHR31346:SF5', NULL, NULL, NULL, NULL, 'MULTIPLE ORGANELLAR RNA EDITING FACTOR 1, MITOCHONDRIAL', 240515),
(312955, 'PTHR31346', NULL, NULL, NULL, NULL, 'MULTIPLE ORGANELLAR RNA EDITING FACTOR 2, CHLOROPLASTIC-RELATED-RELATED', 240515),
(312956, 'PTHR31346:SF3', NULL, NULL, NULL, NULL, 'MULTIPLE ORGANELLAR RNA EDITING FACTOR 9, CHLOROPLASTIC', 240515),
(312957, 'PTHR31346:SF1', NULL, NULL, NULL, NULL, 'MULTIPLE ORGANELLAR RNA EDITING FACTOR 3, MITOCHONDRIAL', 240515),
(312958, 'PTHR31346:SF27', NULL, NULL, NULL, NULL, 'BNAC04G11080D PROTEIN', 240515),
(312959, 'PTHR31346:SF16', NULL, NULL, NULL, NULL, 'MULTIPLE ORGANELLAR RNA EDITING FACTOR 4, MITOCHONDRIAL', 240515),
(312960, 'PTHR31346:SF29', NULL, NULL, NULL, NULL, '', 240515),
(312961, 'PTHR31346:SF34', NULL, NULL, NULL, NULL, 'MULTIPLE ORGANELLAR RNA EDITING FACTOR 8, CHLOROPLASTIC/MITOCHONDRIAL-LIKE', 240515),
(312962, 'PTHR31346:SF12', NULL, NULL, NULL, NULL, 'MULTIPLE ORGANELLAR RNA EDITING FACTOR 7, MITOCHONDRIAL', 240515),
(312963, 'PTHR31346:SF22', NULL, NULL, NULL, NULL, '', 240515),
(312964, 'PTHR31346:SF11', NULL, NULL, NULL, NULL, 'ORGANELLE RRM DOMAIN-CONTAINING PROTEIN 1, CHLOROPLASTIC', 240515),
(312965, 'PTHR31346:SF33', NULL, NULL, NULL, NULL, 'MULTIPLE ORGANELLAR RNA EDITING FACTOR 1, MITOCHONDRIAL-LIKE', 240515),
(312966, 'PTHR31346:SF36', NULL, NULL, NULL, NULL, 'BNACNNG17940D PROTEIN', 240515),
(312967, 'PTHR31346:SF35', NULL, NULL, NULL, NULL, 'BNAA04G19490D PROTEIN', 240515);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(312968, 'PTHR31346:SF30', NULL, NULL, NULL, NULL, 'MULTIPLE ORGANELLAR RNA EDITING FACTOR 8, CHLOROPLASTIC/MITOCHONDRIAL-LIKE', 240515),
(312969, 'PTHR31346:SF32', NULL, NULL, NULL, NULL, 'OS04G0602000 PROTEIN', 240515),
(312970, 'PTHR31346:SF21', NULL, NULL, NULL, NULL, 'BNAC01G36450D PROTEIN', 240515),
(312971, 'PTHR31346:SF31', NULL, NULL, NULL, NULL, 'DAG PROTEIN, CHLOROPLAST', 240515),
(312972, 'PTHR31346:SF20', NULL, NULL, NULL, NULL, 'BNAANNG21120D PROTEIN', 240515),
(312973, 'PTHR34704', NULL, NULL, NULL, NULL, 'ATPASE', 240516),
(312974, 'PTHR34704:SF1', NULL, NULL, NULL, NULL, 'ARCHAEAL ATPASE', 240516),
(312975, 'PTHR43019', NULL, NULL, NULL, NULL, 'SERINE ENDOPROTEASE DEGS', 240517),
(312976, 'PTHR43019:SF60', NULL, NULL, NULL, NULL, 'PERIPLASMIC SERINE ENDOPROTEASE DEGP-LIKE', 240517),
(312977, 'PTHR43019:SF61', NULL, NULL, NULL, NULL, '', 240517),
(312978, 'PTHR43019:SF40', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240517),
(312979, 'PTHR43019:SF62', NULL, NULL, NULL, NULL, 'SERINE ENDOPROTEASE DEGS', 240517),
(312980, 'PTHR43019:SF39', NULL, NULL, NULL, NULL, 'PDZ_6 DOMAIN-CONTAINING PROTEIN', 240517),
(312981, 'PTHR43019:SF17', NULL, NULL, NULL, NULL, 'PDZ_6 DOMAIN-CONTAINING PROTEIN', 240517),
(312982, 'PTHR43019:SF18', NULL, NULL, NULL, NULL, 'OS07G0231900 PROTEIN', 240517),
(312983, 'PTHR43019:SF19', NULL, NULL, NULL, NULL, 'PDZ_6 DOMAIN-CONTAINING PROTEIN', 240517),
(312984, 'PTHR43019:SF31', NULL, NULL, NULL, NULL, 'OS05G0164500 PROTEIN', 240517),
(312985, 'PTHR43019:SF53', NULL, NULL, NULL, NULL, '', 240517),
(312986, 'PTHR43019:SF10', NULL, NULL, NULL, NULL, 'SLR0031 PROTEIN', 240517),
(312987, 'PTHR43019:SF34', NULL, NULL, NULL, NULL, 'PDZ_6 DOMAIN-CONTAINING PROTEIN', 240517),
(312988, 'PTHR43019:SF56', NULL, NULL, NULL, NULL, '', 240517),
(312989, 'PTHR43019:SF57', NULL, NULL, NULL, NULL, 'CELL DIVISION TOPOLOGICAL DETERMINANT MINJ', 240517),
(312990, 'PTHR43019:SF58', NULL, NULL, NULL, NULL, '', 240517),
(312991, 'PTHR43019:SF36', NULL, NULL, NULL, NULL, 'SERINE PROTEASE RV3671C', 240517),
(312992, 'PTHR43019:SF59', NULL, NULL, NULL, NULL, '', 240517),
(312993, 'PTHR43019:SF37', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN', 240517),
(312994, 'PTHR43019:SF16', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN', 240517),
(312995, 'PTHR43019:SF38', NULL, NULL, NULL, NULL, 'PROTEASE DO-LIKE 1, CHLOROPLASTIC', 240517),
(312996, 'PTHR43019:SF51', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN', 240517),
(312997, 'PTHR43019:SF30', NULL, NULL, NULL, NULL, 'OS07G0666400 PROTEIN', 240517),
(312998, 'PTHR43019:SF28', NULL, NULL, NULL, NULL, 'PDZ_6 DOMAIN-CONTAINING PROTEIN', 240517),
(312999, 'PTHR43019:SF29', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240517),
(313000, 'PTHR43019:SF20', NULL, NULL, NULL, NULL, 'PDZ_6 DOMAIN-CONTAINING PROTEIN', 240517),
(313001, 'PTHR43019:SF43', NULL, NULL, NULL, NULL, 'PDZ_6 DOMAIN-CONTAINING PROTEIN', 240517),
(313002, 'PTHR43019:SF21', NULL, NULL, NULL, NULL, 'OS05G0146100 PROTEIN', 240517),
(313003, 'PTHR43019:SF22', NULL, NULL, NULL, NULL, 'OS05G0158400 PROTEIN', 240517),
(313004, 'PTHR43019:SF23', NULL, NULL, NULL, NULL, 'PROTEASE DO-LIKE 5, CHLOROPLASTIC', 240517),
(313005, 'PTHR43019:SF46', NULL, NULL, NULL, NULL, '', 240517),
(313006, 'PTHR43019:SF25', NULL, NULL, NULL, NULL, 'PDZ_6 DOMAIN-CONTAINING PROTEIN', 240517),
(313007, 'PTHR43019:SF48', NULL, NULL, NULL, NULL, 'PEPTIDASE S1, PA CLAN-RELATED', 240517),
(313008, 'PTHR46893:SF1', NULL, NULL, NULL, NULL, 'FTP DOMAIN-CONTAINING PROTEIN', 240518),
(313009, 'PTHR46893', NULL, NULL, NULL, NULL, 'LCCL DOMAIN-CONTAINING PROTEIN', 240518),
(313010, 'PTHR34356:SF3', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240519),
(313011, 'PTHR34356:SF1', NULL, NULL, NULL, NULL, 'ANTIGENIC HEAT-STABLE PROTEIN', 240519),
(313012, 'PTHR34356', NULL, NULL, NULL, NULL, 'ANTIGENIC HEAT-STABLE PROTEIN', 240519),
(313013, 'PTHR35682:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 252', 240520),
(313014, 'PTHR35682', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 252', 240520);
INSERT INTO "PUBLIC"."MODEL" VALUES
(313015, 'PTHR48136', NULL, NULL, NULL, NULL, 'RUBREDOXIN-LIKE SUPERFAMILY PROTEIN', 240521),
(313016, 'PTHR48136:SF1', NULL, NULL, NULL, NULL, 'RUBREDOXIN-LIKE SUPERFAMILY PROTEIN', 240521),
(313017, 'PTHR46062', NULL, NULL, NULL, NULL, 'STEROL REGULATORY ELEMENT-BINDING PROTEIN', 240522),
(313018, 'PTHR46062:SF3', NULL, NULL, NULL, NULL, 'STEROL REGULATORY ELEMENT-BINDING PROTEIN 2', 240522),
(313019, 'PTHR46062:SF2', NULL, NULL, NULL, NULL, 'STEROL REGULATORY ELEMENT-BINDING PROTEIN 1', 240522),
(313020, 'PTHR46062:SF1', NULL, NULL, NULL, NULL, 'LP12374P', 240522),
(313021, 'PTHR16213:SF78', NULL, NULL, NULL, NULL, 'SELENOPROTEIN N', 240523),
(313022, 'PTHR16213', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 240523),
(313023, 'PTHR31801', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN 24, MITOCHONDRIAL', 240524),
(313024, 'PTHR31801:SF0', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN 24, MITOCHONDRIAL', 240524),
(313025, 'PTHR31801:SF1', NULL, NULL, NULL, NULL, 'SPHINGOMYELIN PHOSPHODIESTERASE', 240524),
(313026, 'PTHR31801:SF2', NULL, NULL, NULL, NULL, '', 240524),
(313027, 'PTHR36520:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG14667', 240525),
(313028, 'PTHR36520:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG13000', 240525),
(313029, 'PTHR36520:SF5', NULL, NULL, NULL, NULL, '', 240525),
(313030, 'PTHR36520', NULL, NULL, NULL, NULL, 'PROTEIN CBG13000-RELATED', 240525),
(313031, 'PTHR36520:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG21345', 240525),
(313032, 'PTHR10721:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM44', 240526),
(313033, 'PTHR10721:SF2', NULL, NULL, NULL, NULL, 'TIM44 DOMAIN-CONTAINING PROTEIN', 240526),
(313034, 'PTHR10721', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM44', 240526),
(313035, 'PTHR47641:SF12', NULL, NULL, NULL, NULL, '', 240527),
(313036, 'PTHR47641:SF1', NULL, NULL, NULL, NULL, 'GOLGI-ASSOCIATED OLFACTORY SIGNALING REGULATOR', 240527),
(313037, 'PTHR47641:SF13', NULL, NULL, NULL, NULL, 'DUF287 DOMAIN-CONTAINING PROTEIN', 240527),
(313038, 'PTHR47641:SF10', NULL, NULL, NULL, NULL, 'GI21801', 240527),
(313039, 'PTHR47641:SF11', NULL, NULL, NULL, NULL, '', 240527),
(313040, 'PTHR47641', NULL, NULL, NULL, NULL, 'PERIAXIN-LIKE', 240527),
(313041, 'PTHR47641:SF9', NULL, NULL, NULL, NULL, 'VITELLINE MEMBRANE PROTEIN VM26AB-RELATED', 240527),
(313042, 'PTHR33680:SF1', NULL, NULL, NULL, NULL, 'OS05G0489500 PROTEIN', 240528),
(313043, 'PTHR33680:SF7', NULL, NULL, NULL, NULL, 'OS02G0474200 PROTEIN', 240528),
(313044, 'PTHR33680:SF11', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 240528),
(313045, 'PTHR33680:SF8', NULL, NULL, NULL, NULL, 'GRF ZINC FINGER / ZINC KNUCKLE PROTEIN', 240528),
(313046, 'PTHR33680:SF10', NULL, NULL, NULL, NULL, 'OS11G0531300 PROTEIN', 240528),
(313047, 'PTHR33680:SF5', NULL, NULL, NULL, NULL, 'GRF-TYPE DOMAIN-CONTAINING PROTEIN', 240528),
(313048, 'PTHR33680', NULL, NULL, NULL, NULL, 'OS07G0190500 PROTEIN', 240528),
(313049, 'PTHR33680:SF12', NULL, NULL, NULL, NULL, 'GRF ZINC FINGER / ZINC KNUCKLE PROTEIN', 240528),
(313050, 'PTHR12374:SF28', NULL, NULL, NULL, NULL, 'MYB-LIKE PROTEIN J', 240529),
(313051, 'PTHR12374:SF62', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB1R1-LIKE', 240529),
(313052, 'PTHR12374:SF41', NULL, NULL, NULL, NULL, 'MYB-RELATED TRANSCRIPTION FACTOR', 240529),
(313053, 'PTHR12374:SF63', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ADAPTER 2-BETA', 240529),
(313054, 'PTHR12374:SF20', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ADAPTER 2-ALPHA', 240529),
(313055, 'PTHR12374:SF21', NULL, NULL, NULL, NULL, 'SWIRM DOMAIN-CONTAINING PROTEIN FUN19-RELATED', 240529),
(313056, 'PTHR12374:SF76', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB1R1-LIKE', 240529),
(313057, 'PTHR12374:SF77', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB1R1-RELATED', 240529),
(313058, 'PTHR12374:SF66', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ADAPTER', 240529),
(313059, 'PTHR12374:SF67', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR', 240529); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(313060, 'PTHR12374:SF78', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ADAPTER ADA2A', 240529),
(313061, 'PTHR12374:SF57', NULL, NULL, NULL, NULL, 'OS01G0603300 PROTEIN', 240529),
(313062, 'PTHR12374:SF79', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 240529),
(313063, 'PTHR12374:SF69', NULL, NULL, NULL, NULL, 'MYB-LIKE TRANSCRIPTION FACTOR FAMILY PROTEIN', 240529),
(313064, 'PTHR12374:SF47', NULL, NULL, NULL, NULL, 'MYB-LIKE DNA-BINDING DOMAIN PROTEIN', 240529),
(313065, 'PTHR12374', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ADAPTOR 2  ADA2 -RELATED', 240529),
(313066, 'PTHR12374:SF71', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 240529),
(313067, 'PTHR12374:SF61', NULL, NULL, NULL, NULL, 'OS05G0195700 PROTEIN', 240529),
(313068, 'PTHR12374:SF72', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB1R1', 240529),
(313069, 'PTHR33156:SF2', NULL, NULL, NULL, NULL, 'OS01G0738000 PROTEIN', 240530),
(313070, 'PTHR33156:SF35', NULL, NULL, NULL, NULL, 'OS01G0551400 PROTEIN', 240530),
(313071, 'PTHR33156:SF32', NULL, NULL, NULL, NULL, '', 240530),
(313072, 'PTHR33156:SF39', NULL, NULL, NULL, NULL, 'PROTEIN NONRESPONDING TO OXYLIPINS 2, MITOCHONDRIAL', 240530),
(313073, 'PTHR33156:SF58', NULL, NULL, NULL, NULL, 'BNAA09G43690D PROTEIN', 240530),
(313074, 'PTHR33156:SF59', NULL, NULL, NULL, NULL, 'OS01G0754000 PROTEIN', 240530),
(313075, 'PTHR33156:SF37', NULL, NULL, NULL, NULL, 'PROTEIN NONRESPONDING TO OXYLIPINS 2, MITOCHONDRIAL-LIKE', 240530),
(313076, 'PTHR33156:SF70', NULL, NULL, NULL, NULL, 'BNAA10G30120D PROTEIN', 240530),
(313077, 'PTHR33156:SF71', NULL, NULL, NULL, NULL, 'BNAANNG28360D PROTEIN', 240530),
(313078, 'PTHR33156:SF74', NULL, NULL, NULL, NULL, 'BNACNNG05150D PROTEIN', 240530),
(313079, 'PTHR33156:SF30', NULL, NULL, NULL, NULL, 'PROTEIN NUCLEAR FUSION DEFECTIVE 6, CHLOROPLASTIC/MITOCHONDRIAL-LIKE ISOFORM X1', 240530),
(313080, 'PTHR33156:SF52', NULL, NULL, NULL, NULL, 'PROTEIN NUCLEAR FUSION DEFECTIVE 6, CHLOROPLASTIC/MITOCHONDRIAL-LIKE', 240530),
(313081, 'PTHR33156:SF75', NULL, NULL, NULL, NULL, '', 240530),
(313082, 'PTHR33156:SF31', NULL, NULL, NULL, NULL, 'OS06G0332500 PROTEIN', 240530),
(313083, 'PTHR33156:SF72', NULL, NULL, NULL, NULL, 'BNAA04G16030D PROTEIN', 240530),
(313084, 'PTHR33156:SF50', NULL, NULL, NULL, NULL, 'BNAA02G25450D PROTEIN', 240530),
(313085, 'PTHR33156:SF73', NULL, NULL, NULL, NULL, 'BNAC06G07160D PROTEIN', 240530),
(313086, 'PTHR33156:SF51', NULL, NULL, NULL, NULL, '', 240530),
(313087, 'PTHR33156:SF9', NULL, NULL, NULL, NULL, 'OS02G0658300 PROTEIN', 240530),
(313088, 'PTHR33156:SF45', NULL, NULL, NULL, NULL, 'OS01G0238800 PROTEIN', 240530),
(313089, 'PTHR33156:SF43', NULL, NULL, NULL, NULL, 'OS02G0273900 PROTEIN', 240530),
(313090, 'PTHR33156:SF66', NULL, NULL, NULL, NULL, 'OS12G0592200 PROTEIN', 240530),
(313091, 'PTHR33156:SF69', NULL, NULL, NULL, NULL, '', 240530),
(313092, 'PTHR33156:SF48', NULL, NULL, NULL, NULL, 'PROTEIN NUCLEAR FUSION DEFECTIVE 6, MITOCHONDRIAL', 240530),
(313093, 'PTHR33156:SF26', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240530),
(313094, 'PTHR33156:SF60', NULL, NULL, NULL, NULL, '', 240530),
(313095, 'PTHR33156:SF42', NULL, NULL, NULL, NULL, 'CASPASE-6 PROTEIN', 240530),
(313096, 'PTHR33156', NULL, NULL, NULL, NULL, 'OS02G0230000 PROTEIN', 240530),
(313097, 'PTHR14106:SF0', NULL, NULL, NULL, NULL, 'TRIADIN', 240531),
(313098, 'PTHR14106', NULL, NULL, NULL, NULL, 'TRIADIN', 240531),
(313099, 'PTHR31626:SF4', NULL, NULL, NULL, NULL, 'SUSHI DOMAIN-CONTAINING PROTEIN', 240532),
(313100, 'PTHR31626:SF3', NULL, NULL, NULL, NULL, 'PROTEIN FAM171A2', 240532),
(313101, 'PTHR31626:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM171B', 240532),
(313102, 'PTHR31626:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAM171A1', 240532),
(313103, 'PTHR31626', NULL, NULL, NULL, NULL, 'SUSHI DOMAIN-CONTAINING PROTEIN', 240532),
(313104, 'PTHR33391:SF19', NULL, NULL, NULL, NULL, 'CYTOCHROME B559 SUBUNIT ALPHA', 240533),
(313105, 'PTHR33391', NULL, NULL, NULL, NULL, 'CYTOCHROME B559 SUBUNIT BETA-RELATED', 240533),
(313106, 'PTHR33391:SF15', NULL, NULL, NULL, NULL, 'CYTOCHROME B559 SUBUNIT ALPHA', 240533);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(313107, 'PTHR33391:SF9', NULL, NULL, NULL, NULL, 'CYTOCHROME B559 SUBUNIT BETA-RELATED', 240533),
(313108, 'PTHR33391:SF18', NULL, NULL, NULL, NULL, 'CYTOCHROM_B559 DOMAIN-CONTAINING PROTEIN', 240533),
(313109, 'PTHR33391:SF17', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II CYTOCHROME B559, ALPHA SUBUNIT-RELATED', 240533),
(313110, 'PTHR33391:SF14', NULL, NULL, NULL, NULL, 'CYTOCHROME B559 SUBUNIT BETA', 240533),
(313111, 'PTHR33391:SF13', NULL, NULL, NULL, NULL, 'CYTOCHROME B559 SUBUNIT ALPHA', 240533),
(313112, 'PTHR12585:SF19', NULL, NULL, NULL, NULL, 'DOUBLE-STRAND-BREAK REPAIR PROTEIN RAD21-LIKE PROTEIN 1', 240534),
(313113, 'PTHR12585:SF72', NULL, NULL, NULL, NULL, 'MEIOTIC RECOMBINATION PROTEIN REC8', 240534),
(313114, 'PTHR12585:SF71', NULL, NULL, NULL, NULL, 'DOUBLE-STRAND-BREAK REPAIR PROTEIN RAD21 HOMOLOG A-RELATED', 240534),
(313115, 'PTHR12585:SF51', NULL, NULL, NULL, NULL, 'MEIOTIC RECOMBINATION PROTEIN REC8', 240534),
(313116, 'PTHR12585:SF73', NULL, NULL, NULL, NULL, 'SISTER CHROMATID COHESION 1 PROTEIN 2', 240534),
(313117, 'PTHR12585:SF70', NULL, NULL, NULL, NULL, 'RAD21/REC8 N TERMINAL DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_6G02900)', 240534),
(313118, 'PTHR12585:SF69', NULL, NULL, NULL, NULL, 'FI11703P', 240534),
(313119, 'PTHR12585:SF68', NULL, NULL, NULL, NULL, 'SISTER CHROMATID COHESION PROTEIN 1', 240534),
(313120, 'PTHR12585:SF27', NULL, NULL, NULL, NULL, 'MEIOTIC RECOMBINATION PROTEIN REC8 HOMOLOG', 240534),
(313121, 'PTHR12585:SF54', NULL, NULL, NULL, NULL, 'RAD21 COHESIN COMPLEX COMPONENT-LIKE 1', 240534),
(313122, 'PTHR12585:SF20', NULL, NULL, NULL, NULL, 'DOUBLE-STRAND-BREAK REPAIR PROTEIN RAD21 HOMOLOG', 240534),
(313123, 'PTHR12585:SF64', NULL, NULL, NULL, NULL, 'SISTER CHROMATID COHESION 1 PROTEIN 1', 240534),
(313124, 'PTHR12585', NULL, NULL, NULL, NULL, 'SCC1 / RAD21 FAMILY MEMBER', 240534),
(313125, 'PTHR12585:SF55', NULL, NULL, NULL, NULL, 'SISTER CHROMATID COHESION 1 PROTEIN 3', 240534),
(313126, 'PTHR12585:SF66', NULL, NULL, NULL, NULL, 'BNAC02G06490D PROTEIN', 240534),
(313127, 'PTHR33768', NULL, NULL, NULL, NULL, 'MIP11318P', 240535),
(313128, 'PTHR33768:SF3', NULL, NULL, NULL, NULL, 'MIP11318P', 240535),
(313129, 'PTHR33768:SF5', NULL, NULL, NULL, NULL, 'SPERM AXONEMAL MAINTENANCE PROTEIN CFAP97D1', 240535),
(313130, 'PTHR33768:SF6', NULL, NULL, NULL, NULL, 'SI:CH211-284K5.2', 240535),
(313131, 'PTHR33768:SF7', NULL, NULL, NULL, NULL, 'SI:DKEY-83M22.7', 240535),
(313132, 'PTHR20934:SF19', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR 1 HOMOLOG', 240536),
(313133, 'PTHR20934:SF16', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR 1 HOMOLOG', 240536),
(313134, 'PTHR20934:SF17', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR 1 HOMOLOG', 240536),
(313135, 'PTHR20934:SF14', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR 1 HOMOLOG', 240536),
(313136, 'PTHR20934', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 240536),
(313137, 'PTHR20934:SF13', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR 1 HOMOLOG', 240536),
(313138, 'PTHR20934:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR 1 HOMOLOG', 240536),
(313139, 'PTHR20934:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR 1 HOMOLOG', 240536),
(313140, 'PTHR20934:SF10', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR 1 HOMOLOG', 240536),
(313141, 'PTHR20934:SF21', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR 1 HOMOLOG', 240536),
(313142, 'PTHR20934:SF22', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR 1 HOMOLOG', 240536),
(313143, 'PTHR20934:SF20', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR 1 HOMOLOG', 240536),
(313144, 'PTHR20934:SF0', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR 1 HOMOLOG', 240536),
(313145, 'PTHR46066:SF2', NULL, NULL, NULL, NULL, 'CHITINASE DOMAIN-CONTAINING PROTEIN 1', 240537),
(313146, 'PTHR46066:SF4', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_18 DOMAIN-CONTAINING PROTEIN', 240537),
(313147, 'PTHR46066', NULL, NULL, NULL, NULL, 'CHITINASE DOMAIN-CONTAINING PROTEIN 1 FAMILY MEMBER', 240537);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(313148, 'PTHR15706:SF2', NULL, NULL, NULL, NULL, 'SH3 AND PX DOMAIN-CONTAINING PROTEIN 2B', 240538),
(313149, 'PTHR15706:SF6', NULL, NULL, NULL, NULL, 'NEUTROPHIL CYTOSOL FACTOR 1-RELATED', 240538),
(313150, 'PTHR15706', NULL, NULL, NULL, NULL, 'SH3 MULTIPLE DOMAIN', 240538),
(313151, 'PTHR15706:SF20', NULL, NULL, NULL, NULL, 'NEUTROPHIL CYTOSOL FACTOR 4', 240538),
(313152, 'PTHR15706:SF10', NULL, NULL, NULL, NULL, 'NADPH OXIDASE ORGANIZER 1', 240538),
(313153, 'PTHR15706:SF22', NULL, NULL, NULL, NULL, 'SH3 AND PX DOMAIN-CONTAINING PROTEIN 2A', 240538),
(313154, 'PTHR15706:SF23', NULL, NULL, NULL, NULL, '', 240538),
(313155, 'PTHR15706:SF24', NULL, NULL, NULL, NULL, 'NADPH OXIDASE ORGANIZER 1A', 240538),
(313156, 'PTHR45237:SF2', NULL, NULL, NULL, NULL, 'POSSIBLE PARA-NITROBENZYL ESTERASE', 240539),
(313157, 'PTHR45237', NULL, NULL, NULL, NULL, 'POSSIBLE PARA-NITROBENZYL ESTERASE', 240539),
(313158, 'PTHR13030', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE', 240540),
(313159, 'PTHR13030:SF8', NULL, NULL, NULL, NULL, 'ADP-RIBOSE PYROPHOSPHATASE, MITOCHONDRIAL', 240540),
(313160, 'PTHR13030:SF13', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 240540),
(313161, 'PTHR13030:SF14', NULL, NULL, NULL, NULL, 'BCDNA.LD24702', 240540),
(313162, 'PTHR47840:SF1', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 240541),
(313163, 'PTHR47840', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 240541),
(313164, 'PTHR47840:SF3', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 240541),
(313165, 'PTHR46024:SF1', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE EGGLESS', 240542),
(313166, 'PTHR46024:SF2', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SETDB1', 240542),
(313167, 'PTHR46024:SF3', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SETDB2', 240542),
(313168, 'PTHR46024', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE EGGLESS', 240542),
(313169, 'PTHR17550', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TTC3', 240543),
(313170, 'PTHR17550:SF4', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TTC3', 240543),
(313171, 'PTHR17550:SF6', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TTC3', 240543),
(313172, 'PTHR17550:SF5', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 240543),
(313173, 'PTHR17550:SF8', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 240543),
(313174, 'PTHR17550:SF7', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 44', 240543),
(313175, 'PTHR48077:SF4', NULL, NULL, NULL, NULL, 'TRYPTOPHAN SYNTHASE', 240544),
(313176, 'PTHR48077:SF3', NULL, NULL, NULL, NULL, 'TRYPTOPHAN SYNTHASE', 240544),
(313177, 'PTHR48077:SF6', NULL, NULL, NULL, NULL, 'TRYPTOPHAN SYNTHASE BETA CHAIN', 240544),
(313178, 'PTHR48077', NULL, NULL, NULL, NULL, 'TRYPTOPHAN SYNTHASE-RELATED', 240544),
(313179, 'PTHR48077:SF11', NULL, NULL, NULL, NULL, 'TRYPTOPHAN SYNTHASE', 240544),
(313180, 'PTHR48077:SF2', NULL, NULL, NULL, NULL, 'PALP DOMAIN-CONTAINING PROTEIN', 240544),
(313181, 'PTHR48077:SF10', NULL, NULL, NULL, NULL, 'TRYPTOPHAN SYNTHASE', 240544),
(313182, 'PTHR48077:SF1', NULL, NULL, NULL, NULL, 'TRYPTOPHAN SYNTHASE', 240544),
(313183, 'PTHR48077:SF7', NULL, NULL, NULL, NULL, 'PALP DOMAIN-CONTAINING PROTEIN', 240544),
(313184, 'PTHR48077:SF9', NULL, NULL, NULL, NULL, 'TRYPTOPHAN SYNTHASE', 240544),
(313185, 'PTHR34656', NULL, NULL, NULL, NULL, 'PYRROLINE-5-CARBOXYLATE REDUCTASE', 240545),
(313186, 'PTHR34656:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 240545),
(313187, 'PTHR34656:SF1', NULL, NULL, NULL, NULL, 'PYRROLINE-5-CARBOXYLATE REDUCTASE', 240545),
(313188, 'PTHR34656:SF4', NULL, NULL, NULL, NULL, 'PYRROLINE-5-CARBOXYLATE REDUCTASE', 240545),
(313189, 'PTHR34656:SF3', NULL, NULL, NULL, NULL, '', 240545),
(313190, 'PTHR34656:SF6', NULL, NULL, NULL, NULL, 'BNAA02G22080D PROTEIN', 240545),
(313191, 'PTHR34656:SF5', NULL, NULL, NULL, NULL, '', 240545),
(313192, 'PTHR38605:SF1', NULL, NULL, NULL, NULL, 'ATPASE-RELATED', 240546); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(313193, 'PTHR38605', NULL, NULL, NULL, NULL, 'ATPASE-RELATED', 240546),
(313194, 'PTHR35161:SF22', NULL, NULL, NULL, NULL, '', 240547),
(313195, 'PTHR35161:SF21', NULL, NULL, NULL, NULL, '', 240547),
(313196, 'PTHR35161:SF10', NULL, NULL, NULL, NULL, '', 240547),
(313197, 'PTHR35161:SF13', NULL, NULL, NULL, NULL, 'BRCT DOMAIN-CONTAINING PROTEIN', 240547),
(313198, 'PTHR35161:SF15', NULL, NULL, NULL, NULL, 'OS07G0690800 PROTEIN', 240547),
(313199, 'PTHR35161:SF17', NULL, NULL, NULL, NULL, '', 240547),
(313200, 'PTHR35161', NULL, NULL, NULL, NULL, 'OS02G0303100 PROTEIN', 240547),
(313201, 'PTHR35161:SF16', NULL, NULL, NULL, NULL, '', 240547),
(313202, 'PTHR35161:SF19', NULL, NULL, NULL, NULL, 'OS02G0113400 PROTEIN', 240547),
(313203, 'PTHR35161:SF18', NULL, NULL, NULL, NULL, 'GST_C_6 DOMAIN-CONTAINING PROTEIN', 240547),
(313204, 'PTHR35161:SF9', NULL, NULL, NULL, NULL, '', 240547),
(313205, 'PTHR35161:SF4', NULL, NULL, NULL, NULL, 'OS02G0303100 PROTEIN', 240547),
(313206, 'PTHR35161:SF1', NULL, NULL, NULL, NULL, 'OS02G0138300 PROTEIN', 240547),
(313207, 'PTHR35161:SF20', NULL, NULL, NULL, NULL, '', 240547),
(313208, 'PTHR35161:SF5', NULL, NULL, NULL, NULL, '', 240547),
(313209, 'PTHR35161:SF6', NULL, NULL, NULL, NULL, 'HSP70-HSP90 ORGANIZING PROTEIN 2', 240547),
(313210, 'PTHR46899', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 27', 240548),
(313211, 'PTHR46899:SF3', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 27', 240548),
(313212, 'PTHR46899:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1, REGULATORY SUBUNIT 27B', 240548),
(313213, 'PTHR46899:SF2', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 240548),
(313214, 'PTHR36129:SF1', NULL, NULL, NULL, NULL, 'ORGANIC SOLUTE TRANSPORTER SUBUNIT BETA', 240549),
(313215, 'PTHR36129:SF2', NULL, NULL, NULL, NULL, 'RICIN B-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 240549),
(313216, 'PTHR36129', NULL, NULL, NULL, NULL, 'ORGANIC SOLUTE TRANSPORTER SUBUNIT BETA-RELATED', 240549),
(313217, 'PTHR47622:SF1', NULL, NULL, NULL, NULL, 'ARGININE/SERINE-RICH PROTEIN 1', 240550),
(313218, 'PTHR47622', NULL, NULL, NULL, NULL, 'ARGININE/SERINE-RICH PROTEIN 1', 240550),
(313219, 'PTHR43590:SF1', NULL, NULL, NULL, NULL, 'ARSENIC RESISTANCE PROTEIN ARSH (AFU_ORTHOLOGUE AFUA_5G15030)', 240551),
(313220, 'PTHR43590', NULL, NULL, NULL, NULL, 'ARSENIC RESISTANCE PROTEIN ARSH (AFU_ORTHOLOGUE AFUA_5G15030)', 240551),
(313221, 'PTHR42767:SF1', NULL, NULL, NULL, NULL, 'GLYCO_HYDR_30_2 DOMAIN-CONTAINING PROTEIN', 240552),
(313222, 'PTHR42767', NULL, NULL, NULL, NULL, 'ENDO-BETA-1,6-GALACTANASE', 240552),
(313223, 'PTHR35123:SF2', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE-LIKE PROTEIN', 240553),
(313224, 'PTHR35123:SF6', NULL, NULL, NULL, NULL, 'BNACNNG61670D PROTEIN', 240553),
(313225, 'PTHR35123', NULL, NULL, NULL, NULL, 'OS07G0633900 PROTEIN-RELATED', 240553),
(313226, 'PTHR35123:SF5', NULL, NULL, NULL, NULL, 'BNAA06G39450D PROTEIN', 240553),
(313227, 'PTHR35123:SF3', NULL, NULL, NULL, NULL, 'BNAC03G34450D PROTEIN', 240553),
(313228, 'PTHR35123:SF8', NULL, NULL, NULL, NULL, 'OS05G0383200 PROTEIN', 240553),
(313229, 'PTHR35123:SF7', NULL, NULL, NULL, NULL, 'OS07G0633900 PROTEIN', 240553),
(313230, 'PTHR31105:SF6', NULL, NULL, NULL, NULL, 'OS01G0621300 PROTEIN', 240554),
(313231, 'PTHR31105:SF8', NULL, NULL, NULL, NULL, 'OS05G0586400 PROTEIN', 240554),
(313232, 'PTHR31105:SF27', NULL, NULL, NULL, NULL, 'ZINC_RIBBON_12 DOMAIN-CONTAINING PROTEIN', 240554),
(313233, 'PTHR31105:SF38', NULL, NULL, NULL, NULL, 'PROTEIN ENHANCED DISEASE RESISTANCE 4', 240554),
(313234, 'PTHR31105:SF56', NULL, NULL, NULL, NULL, 'G-LIKE PROTEIN, PUTATIVE (DUF3133)-RELATED', 240554),
(313235, 'PTHR31105:SF48', NULL, NULL, NULL, NULL, 'DUF3133 FAMILY PROTEIN', 240554),
(313236, 'PTHR31105:SF47', NULL, NULL, NULL, NULL, 'EXTRA-LARGE G-LIKE PROTEIN', 240554),
(313237, 'PTHR31105:SF42', NULL, NULL, NULL, NULL, 'G-LIKE PROTEIN, PUTATIVE (DUF3133)-RELATED', 240554),
(313238, 'PTHR31105:SF53', NULL, NULL, NULL, NULL, 'ZINC_RIBBON_12 DOMAIN-CONTAINING PROTEIN', 240554);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(313239, 'PTHR31105:SF52', NULL, NULL, NULL, NULL, 'ZINC_RIBBON_12 DOMAIN-CONTAINING PROTEIN', 240554),
(313240, 'PTHR31105:SF33', NULL, NULL, NULL, NULL, 'ZINC_RIBBON_12 DOMAIN-CONTAINING PROTEIN', 240554),
(313241, 'PTHR31105:SF22', NULL, NULL, NULL, NULL, 'OS06G0524300 PROTEIN', 240554),
(313242, 'PTHR31105:SF55', NULL, NULL, NULL, NULL, 'ZINC_RIBBON_12 DOMAIN-CONTAINING PROTEIN', 240554),
(313243, 'PTHR31105:SF32', NULL, NULL, NULL, NULL, 'ZINC_RIBBON_12 DOMAIN-CONTAINING PROTEIN', 240554),
(313244, 'PTHR31105:SF43', NULL, NULL, NULL, NULL, 'OS05G0479900 PROTEIN', 240554),
(313245, 'PTHR31105:SF54', NULL, NULL, NULL, NULL, 'ZINC_RIBBON_12 DOMAIN-CONTAINING PROTEIN', 240554),
(313246, 'PTHR31105:SF51', NULL, NULL, NULL, NULL, 'OS07G0680600 PROTEIN', 240554),
(313247, 'PTHR31105', NULL, NULL, NULL, NULL, 'EXTRA-LARGE G-PROTEIN-LIKE', 240554),
(313248, 'PTHR13336:SF2', NULL, NULL, NULL, NULL, 'OCIA DOMAIN-CONTAINING PROTEIN 2', 240555),
(313249, 'PTHR13336', NULL, NULL, NULL, NULL, 'OVARIAN CARCINOMA IMMUNOREACTIVE ANTIGEN', 240555),
(313250, 'PTHR13336:SF4', NULL, NULL, NULL, NULL, 'OCIA DOMAIN-CONTAINING PROTEIN 1', 240555),
(313251, 'PTHR13336:SF3', NULL, NULL, NULL, NULL, 'OCIA DOMAIN-CONTAINING PROTEIN 1', 240555),
(313252, 'PTHR43766', NULL, NULL, NULL, NULL, 'TRYPTOPHAN--TRNA LIGASE, MITOCHONDRIAL', 240556),
(313253, 'PTHR43766:SF1', NULL, NULL, NULL, NULL, 'TRYPTOPHAN--TRNA LIGASE, MITOCHONDRIAL', 240556),
(313254, 'PTHR43766:SF3', NULL, NULL, NULL, NULL, 'TRYPTOPHANYL-TRNA SYNTHETASE', 240556),
(313255, 'PTHR37304', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 240557),
(313256, 'PTHR37304:SF1', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 240557),
(313257, 'PTHR31378:SF5', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 240558),
(313258, 'PTHR31378:SF9', NULL, NULL, NULL, NULL, '', 240558),
(313259, 'PTHR31378', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN-RELATED-RELATED', 240558),
(313260, 'PTHR31378:SF14', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 240558),
(313261, 'PTHR31378:SF17', NULL, NULL, NULL, NULL, '', 240558),
(313262, 'PTHR31378:SF29', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 240558),
(313263, 'PTHR31378:SF40', NULL, NULL, NULL, NULL, '', 240558),
(313264, 'PTHR31378:SF20', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 240558),
(313265, 'PTHR31378:SF31', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 240558),
(313266, 'PTHR31378:SF30', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 240558),
(313267, 'PTHR31378:SF11', NULL, NULL, NULL, NULL, 'CBM49 DOMAIN-CONTAINING PROTEIN', 240558),
(313268, 'PTHR31378:SF44', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 240558),
(313269, 'PTHR31378:SF32', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 240558),
(313270, 'PTHR31378:SF46', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 240558),
(313271, 'PTHR31378:SF45', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 240558),
(313272, 'PTHR12596:SF18', NULL, NULL, NULL, NULL, 'IMPORTIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 240559),
(313273, 'PTHR12596:SF19', NULL, NULL, NULL, NULL, '', 240559),
(313274, 'PTHR12596:SF2', NULL, NULL, NULL, NULL, 'EXPORTIN 7', 240559),
(313275, 'PTHR12596:SF8', NULL, NULL, NULL, NULL, 'RAN-BINDING PROTEIN 17', 240559),
(313276, 'PTHR12596:SF11', NULL, NULL, NULL, NULL, 'EXPORTIN-7', 240559),
(313277, 'PTHR12596:SF1', NULL, NULL, NULL, NULL, 'EXPORTIN-4', 240559),
(313278, 'PTHR12596:SF15', NULL, NULL, NULL, NULL, 'ARMADILLO/BETA-CATENIN-LIKE REPEAT PROTEIN', 240559),
(313279, 'PTHR12596', NULL, NULL, NULL, NULL, 'EXPORTIN 4,7-RELATED', 240559),
(313280, 'PTHR43501', NULL, NULL, NULL, NULL, 'CYTOSOL NON-SPECIFIC DIPEPTIDASE', 240560),
(313281, 'PTHR43501:SF1', NULL, NULL, NULL, NULL, 'CYTOSOL NON-SPECIFIC DIPEPTIDASE', 240560),
(313282, 'PTHR21974', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 240561),
(313283, 'PTHR21974:SF2', NULL, NULL, NULL, NULL, 'RE15880P', 240561);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(313284, 'PTHR41687:SF1', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 9', 240562),
(313285, 'PTHR41687', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 9', 240562),
(313286, 'PTHR22600:SF44', NULL, NULL, NULL, NULL, 'BETA-HEXOSAMINIDASE', 240563),
(313287, 'PTHR22600:SF55', NULL, NULL, NULL, NULL, 'BETA-HEXOSAMINIDASE', 240563),
(313288, 'PTHR22600:SF21', NULL, NULL, NULL, NULL, 'BETA-HEXOSAMINIDASE A', 240563),
(313289, 'PTHR22600:SF54', NULL, NULL, NULL, NULL, 'BETA-HEXOSAMINIDASE SUBUNIT A1-RELATED', 240563),
(313290, 'PTHR22600', NULL, NULL, NULL, NULL, 'BETA-HEXOSAMINIDASE', 240563),
(313291, 'PTHR22600:SF23', NULL, NULL, NULL, NULL, 'BETA-N-ACETYLHEXOSAMINIDASE', 240563),
(313292, 'PTHR22600:SF40', NULL, NULL, NULL, NULL, 'BETA-HEXOSAMINIDASE 1', 240563),
(313293, 'PTHR22600:SF53', NULL, NULL, NULL, NULL, 'BETA-HEXOSAMINIDASE', 240563),
(313294, 'PTHR22600:SF42', NULL, NULL, NULL, NULL, 'BETA-N-ACETYLHEXOSAMINIDASE', 240563),
(313295, 'PTHR22600:SF52', NULL, NULL, NULL, NULL, 'N-ACETYL-BETA-GLUCOSAMINIDASE', 240563),
(313296, 'PTHR22600:SF3', NULL, NULL, NULL, NULL, 'BETA-HEXOSAMINIDASE FDL-RELATED', 240563),
(313297, 'PTHR22600:SF26', NULL, NULL, NULL, NULL, 'BETA-HEXOSAMINIDASE 2', 240563),
(313298, 'PTHR22600:SF48', NULL, NULL, NULL, NULL, 'BETA-N-ACETYLHEXOSAMINIDASE', 240563),
(313299, 'PTHR22600:SF39', NULL, NULL, NULL, NULL, 'BETA-HEXOSAMINIDASE SUBUNIT ALPHA', 240563),
(313300, 'PTHR22600:SF38', NULL, NULL, NULL, NULL, 'BETA-HEXOSAMINIDASE SUBUNIT BETA', 240563),
(313301, 'PTHR22600:SF49', NULL, NULL, NULL, NULL, 'BETA-HEXOSAMINIDASE', 240563),
(313302, 'PTHR36100:SF1', NULL, NULL, NULL, NULL, 'BUD SITE SELECTION PROTEIN 4', 240564),
(313303, 'PTHR36100', NULL, NULL, NULL, NULL, 'BUD SITE SELECTION PROTEIN 4', 240564),
(313304, 'PTHR47084:SF1', NULL, NULL, NULL, NULL, 'SERINE PALMITOYLTRANSFERASE SMALL SUBUNIT A', 240565),
(313305, 'PTHR47084', NULL, NULL, NULL, NULL, 'SERINE PALMITOYLTRANSFERASE SMALL SUBUNIT A', 240565),
(313306, 'PTHR12881:SF13', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 1', 240566),
(313307, 'PTHR12881:SF4', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 1', 240566),
(313308, 'PTHR12881:SF10', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 1', 240566),
(313309, 'PTHR12881', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 1', 240566),
(313310, 'PTHR42254', NULL, NULL, NULL, NULL, 'METALLOPHOS DOMAIN-CONTAINING PROTEIN', 240567),
(313311, 'PTHR42254:SF1', NULL, NULL, NULL, NULL, 'METALLOPHOS DOMAIN-CONTAINING PROTEIN', 240567),
(313312, 'PTHR48252:SF29', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE 11', 240568),
(313313, 'PTHR48252:SF28', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE 15', 240568),
(313314, 'PTHR48252:SF26', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE 2', 240568),
(313315, 'PTHR48252:SF69', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE 3', 240568),
(313316, 'PTHR48252:SF68', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE HOS1', 240568),
(313317, 'PTHR48252:SF67', NULL, NULL, NULL, NULL, 'HIST_DEACETYL DOMAIN-CONTAINING PROTEIN', 240568),
(313318, 'PTHR48252:SF66', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE 8', 240568),
(313319, 'PTHR48252', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE 2-RELATED', 240568),
(313320, 'PTHR48252:SF65', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE', 240568),
(313321, 'PTHR48252:SF64', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE 6, ISOFORM G', 240568),
(313322, 'PTHR48252:SF63', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE 6', 240568),
(313323, 'PTHR48252:SF62', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE', 240568),
(313324, 'PTHR48252:SF61', NULL, NULL, NULL, NULL, 'TYPE-2 HISTONE DEACETYLASE 1', 240568),
(313325, 'PTHR48252:SF60', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE', 240568),
(313326, 'PTHR48252:SF18', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE', 240568),
(313327, 'PTHR48252:SF17', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE 2', 240568),
(313328, 'PTHR48252:SF15', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE 7', 240568);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(313329, 'PTHR48252:SF59', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 240568),
(313330, 'PTHR48252:SF58', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE', 240568),
(313331, 'PTHR48252:SF14', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE', 240568),
(313332, 'PTHR48252:SF57', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE HDAC1', 240568),
(313333, 'PTHR48252:SF12', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE', 240568),
(313334, 'PTHR48252:SF11', NULL, NULL, NULL, NULL, 'NAD-DEPENDENT PROTEIN DEACYLASE SIRTUIN-5, MITOCHONDRIAL-RELATED', 240568),
(313335, 'PTHR48252:SF19', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE 19', 240568),
(313336, 'PTHR48252:SF10', NULL, NULL, NULL, NULL, 'DEACETYLASE, PUTATIVE-RELATED', 240568),
(313337, 'PTHR48252:SF53', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE', 240568),
(313338, 'PTHR48252:SF52', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE 8', 240568),
(313339, 'PTHR48252:SF51', NULL, NULL, NULL, NULL, 'NAD-DEPENDENT PROTEIN DEACETYLASE SIRTUIN-7', 240568),
(313340, 'PTHR48252:SF3', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE', 240568),
(313341, 'PTHR48252:SF49', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE 14', 240568),
(313342, 'PTHR48252:SF48', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE', 240568),
(313343, 'PTHR48252:SF2', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE 12', 240568),
(313344, 'PTHR48252:SF47', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE', 240568),
(313345, 'PTHR48252:SF7', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE', 240568),
(313346, 'PTHR48252:SF45', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE', 240568),
(313347, 'PTHR48252:SF44', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE 1', 240568),
(313348, 'PTHR48252:SF8', NULL, NULL, NULL, NULL, 'ACETYLPOLYAMINE AMIDOHYDROLASE 2', 240568),
(313349, 'PTHR48252:SF43', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE 9', 240568),
(313350, 'PTHR48252:SF38', NULL, NULL, NULL, NULL, 'HIST_DEACETYL DOMAIN-CONTAINING PROTEIN', 240568),
(313351, 'PTHR48252:SF36', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE 1', 240568),
(313352, 'PTHR48252:SF76', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE 1', 240568),
(313353, 'PTHR48252:SF32', NULL, NULL, NULL, NULL, 'POLYAMINE DEACETYLASE HDAC10', 240568),
(313354, 'PTHR48252:SF75', NULL, NULL, NULL, NULL, 'OS04G0271000 PROTEIN', 240568),
(313355, 'PTHR48252:SF31', NULL, NULL, NULL, NULL, 'HIST_DEACETYL DOMAIN-CONTAINING PROTEIN', 240568),
(313356, 'PTHR48252:SF74', NULL, NULL, NULL, NULL, 'HIST_DEACETYL DOMAIN-CONTAINING PROTEIN', 240568),
(313357, 'PTHR48252:SF73', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE', 240568),
(313358, 'PTHR48252:SF72', NULL, NULL, NULL, NULL, 'DEACETYLASE SIRTUIN-TYPE DOMAIN-CONTAINING PROTEIN', 240568),
(313359, 'PTHR48252:SF71', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE 6', 240568),
(313360, 'PTHR48252:SF70', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE', 240568),
(313361, 'PTHR11950:SF48', NULL, NULL, NULL, NULL, 'RUNT RELATED B', 240569),
(313362, 'PTHR11950:SF49', NULL, NULL, NULL, NULL, 'PROTEIN LOZENGE', 240569),
(313363, 'PTHR11950:SF39', NULL, NULL, NULL, NULL, 'RUNT-RELATED TRANSCRIPTION FACTOR', 240569),
(313364, 'PTHR11950:SF50', NULL, NULL, NULL, NULL, 'RUNT RELATED A, ISOFORM D', 240569),
(313365, 'PTHR11950:SF40', NULL, NULL, NULL, NULL, 'RUNT-RELATED TRANSCRIPTION FACTOR 1', 240569),
(313366, 'PTHR11950', NULL, NULL, NULL, NULL, 'RUNT RELATED', 240569),
(313367, 'PTHR11950:SF7', NULL, NULL, NULL, NULL, 'RUNT-RELATED TRANSCRIPTION FACTOR 2', 240569),
(313368, 'PTHR11950:SF43', NULL, NULL, NULL, NULL, 'RUNT-RELATED TRANSCRIPTION FACTOR 3', 240569),
(313369, 'PTHR11950:SF31', NULL, NULL, NULL, NULL, 'SEGMENTATION PROTEIN RUNT', 240569),
(313370, 'PTHR37000', NULL, NULL, NULL, NULL, 'MUCIN-22', 240570),
(313371, 'PTHR37000:SF4', NULL, NULL, NULL, NULL, 'MUCIN-22', 240570),
(313372, 'PTHR37000:SF3', NULL, NULL, NULL, NULL, 'DOMAIN-CONTAINING PROTEIN, PUTATIVE-RELATED', 240570),
(313373, 'PTHR35151:SF2', NULL, NULL, NULL, NULL, '', 240571),
(313374, 'PTHR35151', NULL, NULL, NULL, NULL, '', 240571),
(313375, 'PTHR47280', NULL, NULL, NULL, NULL, 'PHEOPHYTINASE, CHLOROPLASTIC', 240572);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(313376, 'PTHR47280:SF1', NULL, NULL, NULL, NULL, 'PHEOPHYTINASE, CHLOROPLASTIC', 240572),
(313377, 'PTHR10913:SF71', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR KAZAL-TYPE 5', 240573),
(313378, 'PTHR10913:SF81', NULL, NULL, NULL, NULL, '', 240573),
(313379, 'PTHR10913:SF44', NULL, NULL, NULL, NULL, 'FOLLISTATIN-RELATED PROTEIN 5', 240573),
(313380, 'PTHR10913:SF6', NULL, NULL, NULL, NULL, 'FOLLISTATIN', 240573),
(313381, 'PTHR10913:SF64', NULL, NULL, NULL, NULL, '', 240573),
(313382, 'PTHR10913:SF9', NULL, NULL, NULL, NULL, 'FOLLISTATIN-RELATED PROTEIN 4', 240573),
(313383, 'PTHR10913:SF80', NULL, NULL, NULL, NULL, 'TOMOREGULIN-2', 240573),
(313384, 'PTHR10913', NULL, NULL, NULL, NULL, 'FOLLISTATIN-RELATED', 240573),
(313385, 'PTHR10913:SF14', NULL, NULL, NULL, NULL, 'FOLLISTATIN-RELATED PROTEIN 5-LIKE PROTEIN', 240573),
(313386, 'PTHR10913:SF13', NULL, NULL, NULL, NULL, 'FOLLISTATIN-RELATED PROTEIN 1', 240573),
(313387, 'PTHR10913:SF79', NULL, NULL, NULL, NULL, 'GH09510P', 240573),
(313388, 'PTHR10913:SF68', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN WITH EGF-LIKE AND TWO FOLLISTATIN-LIKE DOMAINS 1B', 240573),
(313389, 'PTHR10913:SF78', NULL, NULL, NULL, NULL, 'AGRIN', 240573),
(313390, 'PTHR10913:SF45', NULL, NULL, NULL, NULL, 'FOLLISTATIN, ISOFORM A-RELATED', 240573),
(313391, 'PTHR10913:SF16', NULL, NULL, NULL, NULL, 'FOLLISTATIN-RELATED PROTEIN 3', 240573),
(313392, 'PTHR12066:SF0', NULL, NULL, NULL, NULL, 'TELOMERASE REVERSE TRANSCRIPTASE', 240574),
(313393, 'PTHR12066', NULL, NULL, NULL, NULL, 'TELOMERASE REVERSE TRANSCRIPTASE', 240574),
(313394, 'PTHR31747:SF3', NULL, NULL, NULL, NULL, 'PROTEIN LSD1', 240575),
(313395, 'PTHR31747:SF17', NULL, NULL, NULL, NULL, 'PROTEIN LOL2', 240575),
(313396, 'PTHR31747:SF5', NULL, NULL, NULL, NULL, 'PROTEIN LOL4', 240575),
(313397, 'PTHR31747:SF14', NULL, NULL, NULL, NULL, 'PROTEIN LOL2', 240575),
(313398, 'PTHR31747:SF1', NULL, NULL, NULL, NULL, 'PROTEIN LOL1', 240575),
(313399, 'PTHR31747', NULL, NULL, NULL, NULL, 'PROTEIN LSD1', 240575),
(313400, 'PTHR31747:SF22', NULL, NULL, NULL, NULL, 'PROTEIN LOL2-LIKE', 240575),
(313401, 'PTHR31747:SF21', NULL, NULL, NULL, NULL, '', 240575),
(313402, 'PTHR31747:SF20', NULL, NULL, NULL, NULL, 'PROTEIN LSD1-LIKE', 240575),
(313403, 'PTHR46457:SF1', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RAD51 HOMOLOG 4', 240576),
(313404, 'PTHR46457', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RAD51 HOMOLOG 4', 240576),
(313405, 'PTHR33703:SF13', NULL, NULL, NULL, NULL, 'SENESCENCE ASSOCIATED GENE 20', 240577),
(313406, 'PTHR33703:SF21', NULL, NULL, NULL, NULL, 'WOUND-INDUCED PROTEIN 1', 240577),
(313407, 'PTHR33703:SF9', NULL, NULL, NULL, NULL, '', 240577),
(313408, 'PTHR33703:SF16', NULL, NULL, NULL, NULL, 'WOUND-INDUCED PROTEIN 1', 240577),
(313409, 'PTHR33703', NULL, NULL, NULL, NULL, 'OS07G0691300 PROTEIN', 240577),
(313410, 'PTHR33703:SF15', NULL, NULL, NULL, NULL, 'WOUND-INDUCED-LIKE PROTEIN', 240577),
(313411, 'PTHR33703:SF14', NULL, NULL, NULL, NULL, 'WOUND-INDUCED PROTEIN, WUN1-RELATED', 240577),
(313412, 'PTHR33703:SF1', NULL, NULL, NULL, NULL, 'WOUND-INDUCED PROTEIN 1-LIKE', 240577),
(313413, 'PTHR33703:SF20', NULL, NULL, NULL, NULL, 'OS05G0342100 PROTEIN', 240577),
(313414, 'PTHR33630:SF10', NULL, NULL, NULL, NULL, 'ACETYLXYLAN ESTERASE', 240578),
(313415, 'PTHR33630:SF1', NULL, NULL, NULL, NULL, 'AXE2', 240578),
(313416, 'PTHR33630:SF9', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE CULP4', 240578),
(313417, 'PTHR33630', NULL, NULL, NULL, NULL, 'CUTINASE RV1984C-RELATED-RELATED', 240578),
(313418, 'PTHR33630:SF12', NULL, NULL, NULL, NULL, 'CUTINASE', 240578),
(313419, 'PTHR15696:SF28', NULL, NULL, NULL, NULL, 'EST/SMG-LIKE PROTEIN 1-RELATED', 240579),
(313420, 'PTHR15696:SF29', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN-CONTAINING PROTEIN-RELATED', 240579),
(313421, 'PTHR15696:SF18', NULL, NULL, NULL, NULL, 'SMG-7', 240579),
(313422, 'PTHR15696:SF26', NULL, NULL, NULL, NULL, 'BNAC02G44260D PROTEIN', 240579),
(313423, 'PTHR15696:SF35', NULL, NULL, NULL, NULL, 'PROTEIN SMG7', 240579);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(313424, 'PTHR15696:SF36', NULL, NULL, NULL, NULL, 'CHROMOSOME 12, WHOLE GENOME SHOTGUN SEQUENCE', 240579),
(313425, 'PTHR15696:SF0', NULL, NULL, NULL, NULL, 'TELOMERASE-BINDING PROTEIN EST1A', 240579),
(313426, 'PTHR15696:SF25', NULL, NULL, NULL, NULL, 'OS08G0305300 PROTEIN', 240579),
(313427, 'PTHR15696:SF33', NULL, NULL, NULL, NULL, 'TELOMERASE ACTIVATING PROTEIN EST1', 240579),
(313428, 'PTHR15696:SF34', NULL, NULL, NULL, NULL, 'EST1_DNA_BIND DOMAIN-CONTAINING PROTEIN', 240579),
(313429, 'PTHR15696:SF32', NULL, NULL, NULL, NULL, 'PROTEIN SMG7-LIKE', 240579),
(313430, 'PTHR15696:SF5', NULL, NULL, NULL, NULL, 'PROTEIN SMG7', 240579),
(313431, 'PTHR15696:SF7', NULL, NULL, NULL, NULL, 'PROTEIN SMG5', 240579),
(313432, 'PTHR15696', NULL, NULL, NULL, NULL, 'SMG-7  SUPPRESSOR WITH MORPHOLOGICAL EFFECT ON GENITALIA PROTEIN 7', 240579),
(313433, 'PTHR33829:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 240580),
(313434, 'PTHR33829:SF2', NULL, NULL, NULL, NULL, 'OS04G0386700 PROTEIN', 240580),
(313435, 'PTHR33829:SF3', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 240580),
(313436, 'PTHR33829:SF4', NULL, NULL, NULL, NULL, 'BNAA09G05090D PROTEIN', 240580),
(313437, 'PTHR33829:SF5', NULL, NULL, NULL, NULL, 'BNAC09G28400D PROTEIN', 240580),
(313438, 'PTHR33829:SF6', NULL, NULL, NULL, NULL, '', 240580),
(313439, 'PTHR33829', NULL, NULL, NULL, NULL, 'OSJNBA0044M19.10 PROTEIN', 240580),
(313440, 'PTHR45800:SF16', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-KINASE GAMMA 5', 240581),
(313441, 'PTHR45800:SF18', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4-KINASE', 240581),
(313442, 'PTHR45800:SF19', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4-KINASE', 240581),
(313443, 'PTHR45800:SF30', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4-KINASE', 240581),
(313444, 'PTHR45800:SF31', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4-KINASE', 240581),
(313445, 'PTHR45800:SF32', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-KINASE GAMMA 6', 240581),
(313446, 'PTHR45800:SF11', NULL, NULL, NULL, NULL, 'PI3K/PI4K DOMAIN-CONTAINING PROTEIN', 240581),
(313447, 'PTHR45800:SF12', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4-KINASE', 240581),
(313448, 'PTHR45800:SF34', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4-KINASE', 240581),
(313449, 'PTHR45800:SF35', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4-KINASE', 240581),
(313450, 'PTHR45800:SF5', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-KINASE GAMMA 2', 240581),
(313451, 'PTHR45800:SF14', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-KINASE GAMMA 1', 240581),
(313452, 'PTHR45800:SF36', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4-KINASE', 240581),
(313453, 'PTHR45800:SF4', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-KINASE GAMMA 3', 240581),
(313454, 'PTHR45800:SF3', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-KINASE GAMMA 4', 240581),
(313455, 'PTHR45800:SF1', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4-KINASE', 240581),
(313456, 'PTHR45800', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-KINASE GAMMA', 240581),
(313457, 'PTHR45800:SF28', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4-KINASE', 240581),
(313458, 'PTHR45800:SF41', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4-KINASE', 240581),
(313459, 'PTHR45800:SF42', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4-KINASE', 240581),
(313460, 'PTHR45800:SF21', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-KINASE GAMMA 8', 240581),
(313461, 'PTHR45800:SF43', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4-KINASE', 240581),
(313462, 'PTHR45800:SF44', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4-KINASE', 240581),
(313463, 'PTHR45800:SF45', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4-KINASE', 240581),
(313464, 'PTHR45800:SF23', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4-KINASE', 240581),
(313465, 'PTHR45800:SF24', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-KINASE GAMMA 4', 240581),
(313466, 'PTHR38138:SF1', NULL, NULL, NULL, NULL, 'PILIN_N DOMAIN-CONTAINING PROTEIN', 240582),
(313467, 'PTHR38138', NULL, NULL, NULL, NULL, 'VNG6441H', 240582);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(313468, 'PTHR36363', NULL, NULL, NULL, NULL, 'OS04G0687200 PROTEIN', 240583),
(313469, 'PTHR36363:SF1', NULL, NULL, NULL, NULL, 'OS04G0687200 PROTEIN', 240583),
(313470, 'PTHR18934:SF250', NULL, NULL, NULL, NULL, 'RNA HELICASE', 240584),
(313471, 'PTHR18934:SF259', NULL, NULL, NULL, NULL, '', 240584),
(313472, 'PTHR18934:SF215', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR ATP-DEPENDENT RNA HELICASE DEAH1-LIKE', 240584),
(313473, 'PTHR18934:SF258', NULL, NULL, NULL, NULL, '', 240584),
(313474, 'PTHR18934:SF213', NULL, NULL, NULL, NULL, '3''-5'' RNA HELICASE YTHDC2', 240584),
(313475, 'PTHR18934:SF257', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DHX30', 240584),
(313476, 'PTHR18934:SF136', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DHX35-RELATED', 240584),
(313477, 'PTHR18934:SF256', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DHX57-RELATED', 240584),
(313478, 'PTHR18934:SF255', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 240584),
(313479, 'PTHR18934:SF254', NULL, NULL, NULL, NULL, 'UVRD_C_2 DOMAIN-CONTAINING PROTEIN', 240584),
(313480, 'PTHR18934:SF253', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR ATP-DEPENDENT RNA HELICASE C20H4.09-RELATED', 240584),
(313481, 'PTHR18934:SF91', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR ATP-DEPENDENT RNA HELICASE PRP16', 240584),
(313482, 'PTHR18934:SF95', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR ATP-DEPENDENT RNA HELICASE DHX15', 240584),
(313483, 'PTHR18934:SF208', NULL, NULL, NULL, NULL, 'OS05G0389800 PROTEIN', 240584),
(313484, 'PTHR18934:SF99', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DHX37-RELATED', 240584),
(313485, 'PTHR18934:SF120', NULL, NULL, NULL, NULL, 'OS06G0343100 PROTEIN', 240584),
(313486, 'PTHR18934:SF203', NULL, NULL, NULL, NULL, 'CHROMOSOME 16, WHOLE GENOME SHOTGUN SEQUENCE', 240584),
(313487, 'PTHR18934:SF126', NULL, NULL, NULL, NULL, 'OS03G0282700 PROTEIN', 240584),
(313488, 'PTHR18934:SF246', NULL, NULL, NULL, NULL, 'DEXH-BOX ATP-DEPENDENT RNA HELICASE DEXH4, CHLOROPLASTIC-RELATED', 240584),
(313489, 'PTHR18934:SF243', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DHR2-RELATED', 240584),
(313490, 'PTHR18934:SF81', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DEAH11, CHLOROPLASTIC-RELATED', 240584),
(313491, 'PTHR18934:SF83', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR ATP-DEPENDENT RNA HELICASE DHX16', 240584),
(313492, 'PTHR18934', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE', 240584),
(313493, 'PTHR18934:SF85', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DHX8', 240584),
(313494, 'PTHR18934:SF119', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE A', 240584),
(313495, 'PTHR18934:SF118', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DHX33', 240584),
(313496, 'PTHR18934:SF88', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR ATP-DEPENDENT RNA HELICASE DHX32-RELATED', 240584),
(313497, 'PTHR18934:SF197', NULL, NULL, NULL, NULL, 'DEPENDENT RNA HELICASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G07950)-RELATED', 240584),
(313498, 'PTHR18934:SF230', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE', 240584),
(313499, 'PTHR18934:SF238', NULL, NULL, NULL, NULL, '', 240584),
(313500, 'PTHR18934:SF237', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA/RNA HELICASE DHX36', 240584),
(313501, 'PTHR18934:SF235', NULL, NULL, NULL, NULL, 'DEAH-BOX RNA HELICASE, PUTATIVE-RELATED', 240584),
(313502, 'PTHR18934:SF113', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE TDRD9', 240584),
(313503, 'PTHR18934:SF234', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DHX40-RELATED', 240584),
(313504, 'PTHR18934:SF233', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE', 240584),
(313505, 'PTHR18934:SF111', NULL, NULL, NULL, NULL, 'RNA HELICASE, PUTATIVE-RELATED', 240584),
(313506, 'PTHR18934:SF231', NULL, NULL, NULL, NULL, 'BNAA08G19730D PROTEIN', 240584),
(313507, 'PTHR18934:SF109', NULL, NULL, NULL, NULL, 'DEAH-BOX HELICASE 15, ISOFORM A', 240584),
(313508, 'PTHR18934:SF229', NULL, NULL, NULL, NULL, 'DEXH-BOX ATP-DEPENDENT RNA HELICASE DEXH3', 240584);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(313509, 'PTHR18934:SF108', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DQX1', 240584),
(313510, 'PTHR18934:SF228', NULL, NULL, NULL, NULL, 'HELICASE C-TERMINAL DOMAIN-CONTAINING PROTEIN', 240584),
(313511, 'PTHR18934:SF263', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR ATP-DEPENDENT RNA HELICASE DEAH3-RELATED', 240584),
(313512, 'PTHR18934:SF262', NULL, NULL, NULL, NULL, 'S1 MOTIF DOMAIN-CONTAINING PROTEIN', 240584),
(313513, 'PTHR18934:SF261', NULL, NULL, NULL, NULL, 'SPLICING FACTOR ATP-DEPENDENT RNA HELICASE, PUTATIVE-RELATED', 240584),
(313514, 'PTHR18934:SF260', NULL, NULL, NULL, NULL, '', 240584),
(313515, 'PTHR18934:SF227', NULL, NULL, NULL, NULL, 'DEXH-BOX ATP-DEPENDENT RNA HELICASE DEXH2', 240584),
(313516, 'PTHR18934:SF148', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DHX34-RELATED', 240584),
(313517, 'PTHR18934:SF224', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DEAH12, CHLOROPLASTIC-LIKE', 240584),
(313518, 'PTHR18934:SF103', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE A-LIKE PROTEIN', 240584),
(313519, 'PTHR18934:SF146', NULL, NULL, NULL, NULL, 'DEXH-BOX ATP-DEPENDENT RNA HELICASE DEXH5, MITOCHONDRIAL', 240584),
(313520, 'PTHR18934:SF222', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR ATP-DEPENDENT RNA HELICASE DEAH8-RELATED', 240584),
(313521, 'PTHR18934:SF145', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DHX29', 240584),
(313522, 'PTHR18934:SF221', NULL, NULL, NULL, NULL, 'DEXH-BOX ATP-DEPENDENT RNA HELICASE DEXH8', 240584),
(313523, 'PTHR21568', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 240585),
(313524, 'PTHR21568:SF0', NULL, NULL, NULL, NULL, 'TRNA PSEUDOURIDINE SYNTHASE PUS10', 240585),
(313525, 'PTHR21568:SF1', NULL, NULL, NULL, NULL, 'TRNA PSEUDOURIDINE(55) SYNTHASE', 240585),
(313526, 'PTHR13194', NULL, NULL, NULL, NULL, 'COMPLEX I INTERMEDIATE-ASSOCIATED PROTEIN 30', 240586),
(313527, 'PTHR13194:SF25', NULL, NULL, NULL, NULL, 'COMPLEX I INTERMEDIATE-ASSOCIATED PROTEIN 30, MITOCHONDRIAL', 240586),
(313528, 'PTHR13194:SF23', NULL, NULL, NULL, NULL, 'COMPLEX I INTERMEDIATE-ASSOCIATED PROTEIN 30, MITOCHONDRIAL', 240586),
(313529, 'PTHR13194:SF24', NULL, NULL, NULL, NULL, 'NADH:UBIQUINONE OXIDOREDUCTASE INTERMEDIATE-ASSOCIATED PROTEIN 30', 240586),
(313530, 'PTHR13194:SF18', NULL, NULL, NULL, NULL, 'COMPLEX I INTERMEDIATE-ASSOCIATED PROTEIN 30, MITOCHONDRIAL', 240586),
(313531, 'PTHR13194:SF19', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 240586),
(313532, 'PTHR23342:SF0', NULL, NULL, NULL, NULL, 'N-ACETYLGLUTAMATE SYNTHASE, MITOCHONDRIAL', 240587),
(313533, 'PTHR23342:SF17', NULL, NULL, NULL, NULL, 'OS04G0550500 PROTEIN', 240587),
(313534, 'PTHR23342:SF16', NULL, NULL, NULL, NULL, 'AA_KINASE DOMAIN-CONTAINING PROTEIN', 240587),
(313535, 'PTHR23342:SF18', NULL, NULL, NULL, NULL, '[LYSW]-AMINOADIPATE KINASE', 240587),
(313536, 'PTHR23342:SF4', NULL, NULL, NULL, NULL, 'AMINO-ACID ACETYLTRANSFERASE, MITOCHONDRIAL', 240587),
(313537, 'PTHR23342', NULL, NULL, NULL, NULL, 'N-ACETYLGLUTAMATE SYNTHASE', 240587),
(313538, 'PTHR23342:SF6', NULL, NULL, NULL, NULL, 'ACETYLGLUTAMATE KINASE', 240587),
(313539, 'PTHR48232', NULL, NULL, NULL, NULL, 'INSULIN RECEPTOR SUBSTRATE HOMOLOG', 240588),
(313540, 'PTHR48232:SF1', NULL, NULL, NULL, NULL, 'INSULIN RECEPTOR SUBSTRATE HOMOLOG', 240588),
(313541, 'PTHR34460:SF7', NULL, NULL, NULL, NULL, 'VITELLOGENIN-LIKE PROTEIN', 240589),
(313542, 'PTHR34460', NULL, NULL, NULL, NULL, 'VITELLOGENIN-LIKE PROTEIN', 240589),
(313543, 'PTHR34460:SF6', NULL, NULL, NULL, NULL, 'OS02G0526700 PROTEIN', 240589),
(313544, 'PTHR34460:SF11', NULL, NULL, NULL, NULL, 'BNAA05G30600D PROTEIN', 240589),
(313545, 'PTHR34460:SF9', NULL, NULL, NULL, NULL, 'BNAA02G30570D PROTEIN', 240589),
(313546, 'PTHR34460:SF10', NULL, NULL, NULL, NULL, 'BNAC03G34960D PROTEIN', 240589),
(313547, 'PTHR34460:SF8', NULL, NULL, NULL, NULL, '', 240589),
(313548, 'PTHR34460:SF2', NULL, NULL, NULL, NULL, '', 240589),
(313549, 'PTHR31800', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 32', 240590);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(313550, 'PTHR31800:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 32', 240590),
(313551, 'PTHR15487:SF6', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 2-BINDING PROTEIN', 240591),
(313552, 'PTHR15487:SF4', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 2-BINDING PROTEIN', 240591),
(313553, 'PTHR15487:SF5', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 2-BINDING PROTEIN', 240591),
(313554, 'PTHR15487', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 2-BINDING PROTEIN', 240591),
(313555, 'PTHR33978:SF19', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240592),
(313556, 'PTHR33978:SF18', NULL, NULL, NULL, NULL, 'OS01G0656300 PROTEIN', 240592),
(313557, 'PTHR33978:SF4', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-KINASE', 240592),
(313558, 'PTHR33978:SF20', NULL, NULL, NULL, NULL, '', 240592),
(313559, 'PTHR33978', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-KINASE', 240592),
(313560, 'PTHR33978:SF23', NULL, NULL, NULL, NULL, 'OS02G0258000 PROTEIN', 240592),
(313561, 'PTHR33978:SF15', NULL, NULL, NULL, NULL, 'BNAC06G42460D PROTEIN', 240592),
(313562, 'PTHR33978:SF26', NULL, NULL, NULL, NULL, '', 240592),
(313563, 'PTHR33978:SF25', NULL, NULL, NULL, NULL, 'AVR9/CF-9 RAPIDLY ELICITED PROTEIN 194', 240592),
(313564, 'PTHR33978:SF28', NULL, NULL, NULL, NULL, '', 240592),
(313565, 'PTHR33978:SF27', NULL, NULL, NULL, NULL, 'BNAA09G39380D PROTEIN', 240592),
(313566, 'PTHR37340:SF1', NULL, NULL, NULL, NULL, 'GENE 7073-RELATED', 240593),
(313567, 'PTHR37340', NULL, NULL, NULL, NULL, 'GENE 7073-RELATED', 240593),
(313568, 'PTHR22422:SF6', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 188', 240594),
(313569, 'PTHR22422:SF5', NULL, NULL, NULL, NULL, 'SINGLE-PASS MEMBRANE AND COILED-COIL DOMAIN-CONTAINING PROTEIN 2', 240594),
(313570, 'PTHR22422:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AND COILED-COIL DOMAIN-CONTAINING PROTEIN 5B', 240594),
(313571, 'PTHR22422', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AND COILED-COIL DOMAIN-CONTAINING PROTEIN 5B-RELATED', 240594),
(313572, 'PTHR22422:SF7', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AND COILED-COIL DOMAIN-CONTAINING PROTEIN 5A', 240594),
(313573, 'PTHR38789:SF1', NULL, NULL, NULL, NULL, 'REPRESSIBLE PROTEIN GRG1, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G14210)-RELATED', 240595),
(313574, 'PTHR38789', NULL, NULL, NULL, NULL, 'REPRESSIBLE PROTEIN GRG1, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G14210)-RELATED', 240595),
(313575, 'PTHR47527', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER SUPERFAMILY PROTEIN', 240596),
(313576, 'PTHR47527:SF3', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER SUPERFAMILY PROTEIN', 240596),
(313577, 'PTHR47527:SF2', NULL, NULL, NULL, NULL, 'PHD FINGER FAMILY PROTEIN', 240596),
(313578, 'PTHR47527:SF6', NULL, NULL, NULL, NULL, 'OS06G0309000 PROTEIN', 240596),
(313579, 'PTHR47527:SF5', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', 240596),
(313580, 'PTHR45855', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PIF1-RELATED', 240597),
(313581, 'PTHR45855:SF26', NULL, NULL, NULL, NULL, 'OS07G0143200 PROTEIN', 240597),
(313582, 'PTHR45855:SF48', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 240597),
(313583, 'PTHR45855:SF69', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 240597),
(313584, 'PTHR45855:SF24', NULL, NULL, NULL, NULL, 'HELIX-LOOP-HELIX DNA-BINDING DOMAIN CONTAINING PROTEIN, EXPRESSED', 240597),
(313585, 'PTHR45855:SF68', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 240597),
(313586, 'PTHR45855:SF23', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR UNE10', 240597),
(313587, 'PTHR45855:SF67', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR UNE10-LIKE ISOFORM X1', 240597),
(313588, 'PTHR45855:SF66', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PIF7', 240597),
(313589, 'PTHR45855:SF21', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH119-RELATED', 240597),
(313590, 'PTHR45855:SF65', NULL, NULL, NULL, NULL, 'OS04G0618600 PROTEIN', 240597),
(313591, 'PTHR45855:SF64', NULL, NULL, NULL, NULL, 'HELIX-LOOP-HELIX DNA-BINDING DOMAIN CONTAINING PROTEIN, EXPRESSED', 240597);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(313592, 'PTHR45855:SF63', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MEE8-RELATED', 240597),
(313593, 'PTHR45855:SF62', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SPATULA', 240597),
(313594, 'PTHR45855:SF70', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PIF1-LIKE', 240597),
(313595, 'PTHR45855:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR ALC', 240597),
(313596, 'PTHR45855:SF19', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PIL1', 240597),
(313597, 'PTHR45855:SF17', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PHYTOCHROME INTERACTING FACTOR-LIKE 13', 240597),
(313598, 'PTHR45855:SF16', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PIF1', 240597),
(313599, 'PTHR45855:SF14', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PIF6', 240597),
(313600, 'PTHR45855:SF36', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PIF4', 240597),
(313601, 'PTHR45855:SF12', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 240597),
(313602, 'PTHR45855:SF55', NULL, NULL, NULL, NULL, 'BNAA07G24700D PROTEIN', 240597),
(313603, 'PTHR45855:SF32', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 240597),
(313604, 'PTHR45855:SF31', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR HFR1', 240597),
(313605, 'PTHR45855:SF52', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PIF5', 240597),
(313606, 'PTHR45855:SF30', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH109', 240597),
(313607, 'PTHR45855:SF51', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 240597),
(313608, 'PTHR45855:SF61', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 240597),
(313609, 'PTHR45855:SF60', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SPATULA-LIKE', 240597),
(313610, 'PTHR14991:SF0', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 32', 240598),
(313611, 'PTHR14991', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 32', 240598),
(313612, 'PTHR16228:SF26', NULL, NULL, NULL, NULL, 'AGAP000663-PA', 240599),
(313613, 'PTHR16228:SF22', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 41 MEMBER 3', 240599),
(313614, 'PTHR16228:SF23', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 41 MEMBER 1', 240599),
(313615, 'PTHR16228:SF24', NULL, NULL, NULL, NULL, 'PROTEIN CBG20346', 240599),
(313616, 'PTHR16228:SF25', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 41 MEMBER 2', 240599),
(313617, 'PTHR16228:SF7', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 41 MEMBER 1-LIKE PROTEIN', 240599),
(313618, 'PTHR16228', NULL, NULL, NULL, NULL, 'DIVALENT CATION TRANSPORTER  SOLUTE CARRIER FAMILY 41', 240599),
(313619, 'PTHR16228:SF21', NULL, NULL, NULL, NULL, 'PROTEIN CBG01705', 240599),
(313620, 'PTHR11923:SF69', NULL, NULL, NULL, NULL, 'SENSORY NEURON MEMBRANE PROTEIN 1', 240600),
(313621, 'PTHR11923:SF48', NULL, NULL, NULL, NULL, 'LYSOSOME MEMBRANE PROTEIN 2-A', 240600),
(313622, 'PTHR11923:SF56', NULL, NULL, NULL, NULL, 'LYSOSOME MEMBRANE PROTEIN II', 240600),
(313623, 'PTHR11923:SF67', NULL, NULL, NULL, NULL, 'RE68569P', 240600),
(313624, 'PTHR11923:SF12', NULL, NULL, NULL, NULL, 'PLATELET GLYCOPROTEIN 4', 240600),
(313625, 'PTHR11923:SF89', NULL, NULL, NULL, NULL, 'GH15894P', 240600),
(313626, 'PTHR11923:SF88', NULL, NULL, NULL, NULL, 'DEBRIS BUSTER, ISOFORM D', 240600),
(313627, 'PTHR11923:SF55', NULL, NULL, NULL, NULL, 'PROTEIN CBR-SCAV-5', 240600),
(313628, 'PTHR11923', NULL, NULL, NULL, NULL, 'SCAVENGER RECEPTOR CLASS B TYPE-1  SR-B1', 240600),
(313629, 'PTHR11923:SF109', NULL, NULL, NULL, NULL, 'SENSORY NEURON MEMBRANE PROTEIN 2', 240600),
(313630, 'PTHR11923:SF108', NULL, NULL, NULL, NULL, 'SCAVENGER RECEPTOR (CD36 FAMILY) RELATED', 240600),
(313631, 'PTHR11923:SF105', NULL, NULL, NULL, NULL, 'PROTEIN CBR-SCAV-1', 240600),
(313632, 'PTHR11923:SF96', NULL, NULL, NULL, NULL, 'SCAVENGER RECEPTOR CLASS B MEMBER 1', 240600),
(313633, 'PTHR11923:SF104', NULL, NULL, NULL, NULL, 'FI07620P', 240600),
(313634, 'PTHR11923:SF50', NULL, NULL, NULL, NULL, 'GH19047P', 240600),
(313635, 'PTHR11923:SF107', NULL, NULL, NULL, NULL, 'EPITHELIAL MEMBRANE PROTEIN, ISOFORM B', 240600),
(313636, 'PTHR11923:SF94', NULL, NULL, NULL, NULL, 'SCAVENGER RECEPTOR CLASS B, MEMBER 2A', 240600);
INSERT INTO "PUBLIC"."MODEL" VALUES
(313637, 'PTHR11923:SF51', NULL, NULL, NULL, NULL, 'FI02050P-RELATED', 240600),
(313638, 'PTHR11923:SF106', NULL, NULL, NULL, NULL, 'SCAVENGER RECEPTOR (CD36 FAMILY) RELATED', 240600),
(313639, 'PTHR11923:SF92', NULL, NULL, NULL, NULL, 'LYSOSOME MEMBRANE PROTEIN 2', 240600),
(313640, 'PTHR11923:SF93', NULL, NULL, NULL, NULL, 'GH07959P-RELATED', 240600),
(313641, 'PTHR11923:SF103', NULL, NULL, NULL, NULL, 'SCAVENGER RECEPTOR (CD36 FAMILY) RELATED', 240600),
(313642, 'PTHR11923:SF102', NULL, NULL, NULL, NULL, 'LYSOSOME MEMBRANE PROTEIN 2-B', 240600),
(313643, 'PTHR33796:SF1', NULL, NULL, NULL, NULL, 'HOLLIDAY JUNCTION ATP-DEPENDENT DNA HELICASE RUVA', 240601),
(313644, 'PTHR33796', NULL, NULL, NULL, NULL, 'HOLLIDAY JUNCTION ATP-DEPENDENT DNA HELICASE RUVA', 240601),
(313645, 'PTHR46782:SF1', NULL, NULL, NULL, NULL, 'OS01G0757700 PROTEIN', 240602),
(313646, 'PTHR46782', NULL, NULL, NULL, NULL, 'OS01G0757700 PROTEIN', 240602),
(313647, 'PTHR46782:SF2', NULL, NULL, NULL, NULL, 'OS07G0545900 PROTEIN', 240602),
(313648, 'PTHR21162:SF3', NULL, NULL, NULL, NULL, 'P53 AND DNA DAMAGE-REGULATED PROTEIN 1', 240603),
(313649, 'PTHR21162', NULL, NULL, NULL, NULL, 'P53 AND DNA DAMAGE-REGULATED PROTEIN', 240603),
(313650, 'PTHR21162:SF0', NULL, NULL, NULL, NULL, 'P53 AND DNA DAMAGE-REGULATED PROTEIN 1', 240603),
(313651, 'PTHR24271:SF70', NULL, NULL, NULL, NULL, 'GRANZYME H', 240604),
(313652, 'PTHR24271:SF52', NULL, NULL, NULL, NULL, 'GRANZYME K', 240604),
(313653, 'PTHR24271:SF72', NULL, NULL, NULL, NULL, 'GRANZYME A', 240604),
(313654, 'PTHR24271:SF50', NULL, NULL, NULL, NULL, '', 240604),
(313655, 'PTHR24271:SF73', NULL, NULL, NULL, NULL, 'PROSTATE-SPECIFIC ANTIGEN', 240604),
(313656, 'PTHR24271:SF51', NULL, NULL, NULL, NULL, 'GRANZYME M', 240604),
(313657, 'PTHR24271:SF5', NULL, NULL, NULL, NULL, 'PROTEASE, SERINE 51', 240604),
(313658, 'PTHR24271:SF3', NULL, NULL, NULL, NULL, 'KALLIKREIN-13', 240604),
(313659, 'PTHR24271:SF19', NULL, NULL, NULL, NULL, 'KALLIKREIN-6', 240604),
(313660, 'PTHR24271:SF56', NULL, NULL, NULL, NULL, 'SERINE PROTEASE 58', 240604),
(313661, 'PTHR24271:SF13', NULL, NULL, NULL, NULL, 'CATHEPSIN G', 240604),
(313662, 'PTHR24271:SF57', NULL, NULL, NULL, NULL, 'KALLIKREIN-9', 240604),
(313663, 'PTHR24271:SF54', NULL, NULL, NULL, NULL, 'COMPLEMENT FACTOR D', 240604),
(313664, 'PTHR24271:SF10', NULL, NULL, NULL, NULL, 'AZUROCIDIN', 240604),
(313665, 'PTHR24271:SF55', NULL, NULL, NULL, NULL, 'SERINE PROTEASE 57', 240604),
(313666, 'PTHR24271:SF58', NULL, NULL, NULL, NULL, 'DUODENASE-1', 240604),
(313667, 'PTHR24271:SF59', NULL, NULL, NULL, NULL, 'KALLIKREIN-5', 240604),
(313668, 'PTHR24271:SF81', NULL, NULL, NULL, NULL, 'GRANZYME B', 240604),
(313669, 'PTHR24271:SF60', NULL, NULL, NULL, NULL, 'KALLIKREIN-15', 240604),
(313670, 'PTHR24271:SF80', NULL, NULL, NULL, NULL, 'GRANZYME 3, TANDEM DUPLICATE 1-RELATED', 240604),
(313671, 'PTHR24271:SF63', NULL, NULL, NULL, NULL, 'KALLIKREIN-12', 240604),
(313672, 'PTHR24271:SF64', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 240604),
(313673, 'PTHR24271:SF61', NULL, NULL, NULL, NULL, 'INACTIVE SERINE PROTEASE 37-RELATED', 240604),
(313674, 'PTHR24271:SF84', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 240604),
(313675, 'PTHR24271:SF62', NULL, NULL, NULL, NULL, 'KALLIKREIN-8', 240604),
(313676, 'PTHR24271', NULL, NULL, NULL, NULL, 'KALLIKREIN-RELATED', 240604),
(313677, 'PTHR24271:SF23', NULL, NULL, NULL, NULL, 'CHYMASE 2, MAST CELL-RELATED', 240604),
(313678, 'PTHR24271:SF45', NULL, NULL, NULL, NULL, 'KALLIKREIN-7', 240604),
(313679, 'PTHR24271:SF89', NULL, NULL, NULL, NULL, 'KALLIKREIN-2', 240604),
(313680, 'PTHR24271:SF68', NULL, NULL, NULL, NULL, 'KALLIKREIN-11', 240604),
(313681, 'PTHR24271:SF24', NULL, NULL, NULL, NULL, 'CHYMASE', 240604),
(313682, 'PTHR24271:SF43', NULL, NULL, NULL, NULL, 'GRANZYME C', 240604),
(313683, 'PTHR24271:SF65', NULL, NULL, NULL, NULL, 'KALLIKREIN-4', 240604),
(313684, 'PTHR24271:SF87', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN-RELATED', 240604),
(313685, 'PTHR24271:SF44', NULL, NULL, NULL, NULL, '1700074P13RIK PROTEIN', 240604);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(313686, 'PTHR24271:SF22', NULL, NULL, NULL, NULL, 'MAST CELL PROTEASE 8', 240604),
(313687, 'PTHR24271:SF66', NULL, NULL, NULL, NULL, 'KALLIKREIN-10', 240604),
(313688, 'PTHR24271:SF88', NULL, NULL, NULL, NULL, 'SI:CH211-212D10.1', 240604),
(313689, 'PTHR24271:SF47', NULL, NULL, NULL, NULL, 'KALLIKREIN-1', 240604),
(313690, 'PTHR24271:SF69', NULL, NULL, NULL, NULL, 'GRANZYME A', 240604),
(313691, 'PTHR24271:SF48', NULL, NULL, NULL, NULL, 'KALLIKREIN-14', 240604),
(313692, 'PTHR46495', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE 21', 240605),
(313693, 'PTHR46495:SF2', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE 18', 240605),
(313694, 'PTHR46495:SF1', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE 21', 240605),
(313695, 'PTHR46764:SF6', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 240606),
(313696, 'PTHR46764:SF5', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 240606),
(313697, 'PTHR46764:SF4', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 240606),
(313698, 'PTHR46764:SF3', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 240606),
(313699, 'PTHR46764:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE BAH1-LIKE-RELATED', 240606),
(313700, 'PTHR46764:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE BAH1', 240606),
(313701, 'PTHR46764', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE BAH1', 240606),
(313702, 'PTHR31488', NULL, NULL, NULL, NULL, 'DPY-19-LIKE 1, LIKE (H. SAPIENS)', 240607),
(313703, 'PTHR31488:SF5', NULL, NULL, NULL, NULL, 'C-MANNOSYLTRANSFERASE DPY19L1-RELATED', 240607),
(313704, 'PTHR31488:SF6', NULL, NULL, NULL, NULL, 'C-MANNOSYLTRANSFERASE DPY19L2-RELATED', 240607),
(313705, 'PTHR31488:SF1', NULL, NULL, NULL, NULL, 'DPY-19-LIKE 1, LIKE (H. SAPIENS)', 240607),
(313706, 'PTHR31488:SF2', NULL, NULL, NULL, NULL, 'C-MANNOSYLTRANSFERASE DPY19L4-RELATED', 240607),
(313707, 'PTHR31488:SF3', NULL, NULL, NULL, NULL, '', 240607),
(313708, 'PTHR31488:SF4', NULL, NULL, NULL, NULL, 'C-MANNOSYLTRANSFERASE DPY19L3-RELATED', 240607),
(313709, 'PTHR30308:SF2', NULL, NULL, NULL, NULL, 'SSRA-BINDING PROTEIN', 240608),
(313710, 'PTHR30308', NULL, NULL, NULL, NULL, 'TMRNA-BINDING COMPONENT OF TRANS-TRANSLATION TAGGING COMPLEX', 240608),
(313711, 'PTHR46833', NULL, NULL, NULL, NULL, 'TELOMERIC REPEAT-BINDING FACTOR 2 TERF2', 240609),
(313712, 'PTHR46833:SF1', NULL, NULL, NULL, NULL, 'TELOMERIC REPEAT-BINDING FACTOR 2', 240609),
(313713, 'PTHR22736', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 240610),
(313714, 'PTHR22736:SF2', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 66', 240610),
(313715, 'PTHR47784:SF5', NULL, NULL, NULL, NULL, 'STEROL UPTAKE CONTROL PROTEIN 2', 240611),
(313716, 'PTHR47784:SF4', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 240611),
(313717, 'PTHR47784:SF9', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 240611),
(313718, 'PTHR47784:SF7', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 240611),
(313719, 'PTHR47784:SF8', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 240611),
(313720, 'PTHR47784', NULL, NULL, NULL, NULL, 'STEROL UPTAKE CONTROL PROTEIN 2', 240611),
(313721, 'PTHR47784:SF13', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 240611),
(313722, 'PTHR47784:SF12', NULL, NULL, NULL, NULL, 'ZN(2)-C6 FUNGAL-TYPE DOMAIN-CONTAINING PROTEIN', 240611),
(313723, 'PTHR47784:SF1', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 240611),
(313724, 'PTHR47784:SF10', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G14150)-RELATED', 240611),
(313725, 'PTHR10342:SF273', NULL, NULL, NULL, NULL, 'RE14504P', 240612),
(313726, 'PTHR10342:SF272', NULL, NULL, NULL, NULL, 'ARYLSULFATASE B', 240612),
(313727, 'PTHR10342:SF264', NULL, NULL, NULL, NULL, 'MIP05773P-RELATED', 240612),
(313728, 'PTHR10342:SF274', NULL, NULL, NULL, NULL, 'SULFATASE DOMAIN-CONTAINING PROTEIN', 240612);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(313729, 'PTHR10342', NULL, NULL, NULL, NULL, 'ARYLSULFATASE', 240612),
(313730, 'PTHR10342:SF68', NULL, NULL, NULL, NULL, 'ARYLSULFATASE I', 240612),
(313731, 'PTHR10342:SF69', NULL, NULL, NULL, NULL, 'ARYLSULFATASE J', 240612),
(313732, 'PTHR10342:SF267', NULL, NULL, NULL, NULL, 'SI:DKEY-174I8.1', 240612),
(313733, 'PTHR47253:SF8', NULL, NULL, NULL, NULL, 'ISOCHORISMATE SYNTHASE 1, CHLOROPLASTIC', 240613),
(313734, 'PTHR47253', NULL, NULL, NULL, NULL, '', 240613),
(313735, 'PTHR47253:SF6', NULL, NULL, NULL, NULL, 'OS02G0581400 PROTEIN', 240613),
(313736, 'PTHR47253:SF4', NULL, NULL, NULL, NULL, 'ISOCHORISMATE SYNTHASE 2, CHLOROPLASTIC', 240613),
(313737, 'PTHR47253:SF5', NULL, NULL, NULL, NULL, 'ISOCHORISMATE SYNTHASE', 240613),
(313738, 'PTHR36432:SF4', NULL, NULL, NULL, NULL, 'TRANSITION STATE REGULATOR ABH-RELATED', 240614),
(313739, 'PTHR36432', NULL, NULL, NULL, NULL, '', 240614),
(313740, 'PTHR36432:SF1', NULL, NULL, NULL, NULL, 'STAGE V SPORULATION PROTEIN T', 240614),
(313741, 'PTHR35791', NULL, NULL, NULL, NULL, 'UPF0754 MEMBRANE PROTEIN YHEB', 240615),
(313742, 'PTHR35791:SF1', NULL, NULL, NULL, NULL, 'UPF0754 MEMBRANE PROTEIN YHEB', 240615),
(313743, 'PTHR46432:SF1', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 42', 240616),
(313744, 'PTHR46432', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 42', 240616),
(313745, 'PTHR46814:SF1', NULL, NULL, NULL, NULL, 'EGALITARIAN, ISOFORM B', 240617),
(313746, 'PTHR46814', NULL, NULL, NULL, NULL, 'EGALITARIAN, ISOFORM B', 240617),
(313747, 'PTHR46814:SF4', NULL, NULL, NULL, NULL, '3''-5'' EXONUCLEASE DOMAIN-CONTAINING PROTEIN', 240617),
(313748, 'PTHR34354', NULL, NULL, NULL, NULL, 'NADPH-DEPENDENT 7-CYANO-7-DEAZAGUANINE REDUCTASE', 240618),
(313749, 'PTHR34354:SF1', NULL, NULL, NULL, NULL, 'NADPH-DEPENDENT 7-CYANO-7-DEAZAGUANINE REDUCTASE', 240618),
(313750, 'PTHR33515', NULL, NULL, NULL, NULL, 'RIBOSOME-BINDING FACTOR A, CHLOROPLASTIC-RELATED', 240619),
(313751, 'PTHR33515:SF1', NULL, NULL, NULL, NULL, 'RIBOSOME-BINDING FACTOR A, CHLOROPLASTIC-RELATED', 240619),
(313752, 'PTHR36357:SF4', NULL, NULL, NULL, NULL, 'BNAC04G50660D PROTEIN', 240620),
(313753, 'PTHR36357:SF3', NULL, NULL, NULL, NULL, 'MESODERM DEVELOPMENT CANDIDATE 2-RELATED', 240620),
(313754, 'PTHR36357:SF2', NULL, NULL, NULL, NULL, '', 240620),
(313755, 'PTHR36357:SF1', NULL, NULL, NULL, NULL, 'OS03G0148300 PROTEIN', 240620),
(313756, 'PTHR36357', NULL, NULL, NULL, NULL, 'OS03G0148300 PROTEIN', 240620),
(313757, 'PTHR34213:SF3', NULL, NULL, NULL, NULL, 'BNAA03G01470D PROTEIN', 240621),
(313758, 'PTHR34213:SF2', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSPORT FACTOR 2 (NTF2) FAMILY PROTEIN', 240621),
(313759, 'PTHR34213', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSPORT FACTOR 2 (NTF2) FAMILY PROTEIN', 240621),
(313760, 'PTHR36705', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 20', 240622),
(313761, 'PTHR36705:SF11', NULL, NULL, NULL, NULL, 'OS05G0170600 PROTEIN', 240622),
(313762, 'PTHR36705:SF12', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 20', 240622),
(313763, 'PTHR36705:SF7', NULL, NULL, NULL, NULL, 'CLE FAMILY OSCLE206 PROTEIN', 240622),
(313764, 'PTHR36705:SF8', NULL, NULL, NULL, NULL, 'CLE FAMILY OSCLE204 PROTEIN', 240622),
(313765, 'PTHR36705:SF10', NULL, NULL, NULL, NULL, 'CLE FAMILY OSCLE201 PROTEIN', 240622),
(313766, 'PTHR36705:SF2', NULL, NULL, NULL, NULL, 'OS10G0502300 PROTEIN', 240622),
(313767, 'PTHR36705:SF3', NULL, NULL, NULL, NULL, 'CLE FAMILY OSCLE403 PROTEIN', 240622),
(313768, 'PTHR36705:SF13', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 19', 240622),
(313769, 'PTHR36705:SF5', NULL, NULL, NULL, NULL, 'CLE FAMILY OSCLE302 PROTEIN', 240622),
(313770, 'PTHR19861:SF0', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 82', 240623),
(313771, 'PTHR19861:SF5', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN', 240623),
(313772, 'PTHR19861:SF4', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 240623),
(313773, 'PTHR19861:SF7', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN', 240623);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(313774, 'PTHR19861:SF8', NULL, NULL, NULL, NULL, 'WD REPEAT PROTEIN', 240623),
(313775, 'PTHR19861', NULL, NULL, NULL, NULL, 'WD40 REPEAT PROTEIN SWD2', 240623),
(313776, 'PTHR47848', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN', 240624),
(313777, 'PTHR47848:SF5', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 240624),
(313778, 'PTHR47848:SF4', NULL, NULL, NULL, NULL, 'UNIVERSAL STRESS PROTEIN FAMILY PROTEIN', 240624),
(313779, 'PTHR47848:SF1', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN', 240624),
(313780, 'PTHR32493:SF0', NULL, NULL, NULL, NULL, 'SUSHI DOMAIN-CONTAINING PROTEIN 5', 240625),
(313781, 'PTHR32493', NULL, NULL, NULL, NULL, 'SUSHI DOMAIN-CONTAINING PROTEIN 5', 240625),
(313782, 'PTHR37023', NULL, NULL, NULL, NULL, 'TRANSPOSASE', 240626),
(313783, 'PTHR37023:SF1', NULL, NULL, NULL, NULL, 'ISSOD25 TRANSPOSASE TNPA_ISSOD25', 240626),
(313784, 'PTHR11206:SF119', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313785, 'PTHR11206:SF359', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 35', 240627),
(313786, 'PTHR11206:SF478', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313787, 'PTHR11206:SF357', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313788, 'PTHR11206:SF358', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313789, 'PTHR11206:SF479', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313790, 'PTHR11206:SF476', NULL, NULL, NULL, NULL, 'MATE FAMILY TRANSPORTER', 240627),
(313791, 'PTHR11206:SF113', NULL, NULL, NULL, NULL, 'MATE EFFLUX FAMILY PROTEIN (EUROFUNG)', 240627),
(313792, 'PTHR11206:SF355', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313793, 'PTHR11206:SF356', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313794, 'PTHR11206:SF477', NULL, NULL, NULL, NULL, 'TRANSPORTER PROTEIN, PUTATIVE-RELATED', 240627),
(313795, 'PTHR11206:SF353', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 9-LIKE', 240627),
(313796, 'PTHR11206:SF474', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313797, 'PTHR11206:SF354', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313798, 'PTHR11206:SF475', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313799, 'PTHR11206:SF197', NULL, NULL, NULL, NULL, 'AEL099WP', 240627),
(313800, 'PTHR11206:SF472', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 16', 240627),
(313801, 'PTHR11206:SF473', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313802, 'PTHR11206:SF470', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313803, 'PTHR11206:SF350', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 38-RELATED', 240627),
(313804, 'PTHR11206:SF196', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313805, 'PTHR11206:SF471', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313806, 'PTHR11206:SF194', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313807, 'PTHR11206:SF109', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 34', 240627),
(313808, 'PTHR11206:SF469', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313809, 'PTHR11206:SF346', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 33', 240627),
(313810, 'PTHR11206:SF468', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 54', 240627),
(313811, 'PTHR11206:SF347', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313812, 'PTHR11206:SF102', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 20-RELATED', 240627),
(313813, 'PTHR11206:SF344', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313814, 'PTHR11206:SF466', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313815, 'PTHR11206:SF103', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313816, 'PTHR11206:SF345', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313817, 'PTHR11206:SF342', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313818, 'PTHR11206:SF343', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313819, 'PTHR11206:SF461', NULL, NULL, NULL, NULL, '', 240627); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(313820, 'PTHR11206:SF341', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313821, 'PTHR11206:SF180', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313822, 'PTHR11206:SF181', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313823, 'PTHR11206:SF419', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313824, 'PTHR11206:SF417', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313825, 'PTHR11206:SF414', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313826, 'PTHR11206:SF415', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313827, 'PTHR11206:SF412', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313828, 'PTHR11206:SF379', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313829, 'PTHR11206:SF413', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313830, 'PTHR11206:SF410', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313831, 'PTHR11206:SF377', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313832, 'PTHR11206:SF378', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313833, 'PTHR11206:SF411', NULL, NULL, NULL, NULL, 'MULTI ANTIMICROBIAL EXTRUSION PROTEIN-RELATED', 240627),
(313834, 'PTHR11206:SF375', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313835, 'PTHR11206:SF255', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 7-RELATED', 240627),
(313836, 'PTHR11206:SF373', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313837, 'PTHR11206:SF131', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313838, 'PTHR11206:SF374', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 49', 240627),
(313839, 'PTHR11206:SF372', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313840, 'PTHR11206:SF130', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313841, 'PTHR11206:SF490', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313842, 'PTHR11206:SF370', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313843, 'PTHR11206:SF408', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313844, 'PTHR11206:SF405', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313845, 'PTHR11206:SF406', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 36', 240627),
(313846, 'PTHR11206:SF403', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PUMP', 240627),
(313847, 'PTHR11206:SF404', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313848, 'PTHR11206:SF489', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313849, 'PTHR11206:SF368', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313850, 'PTHR11206:SF401', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313851, 'PTHR11206:SF402', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 24', 240627),
(313852, 'PTHR11206:SF369', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313853, 'PTHR11206:SF487', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313854, 'PTHR11206:SF366', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313855, 'PTHR11206:SF124', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 53', 240627),
(313856, 'PTHR11206:SF367', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313857, 'PTHR11206:SF488', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313858, 'PTHR11206:SF364', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313859, 'PTHR11206:SF485', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313860, 'PTHR11206:SF486', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313861, 'PTHR11206:SF365', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313862, 'PTHR11206:SF362', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313863, 'PTHR11206:SF483', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313864, 'PTHR11206:SF484', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313865, 'PTHR11206:SF363', NULL, NULL, NULL, NULL, 'MULTIDRUG AND TOXIN EXTRUSION PROTEIN', 240627);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(313866, 'PTHR11206:SF481', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313867, 'PTHR11206:SF361', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 51', 240627),
(313868, 'PTHR11206:SF482', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313869, 'PTHR11206:SF480', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313870, 'PTHR11206:SF319', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313871, 'PTHR11206:SF317', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313872, 'PTHR11206:SF438', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313873, 'PTHR11206:SF318', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313874, 'PTHR11206:SF436', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313875, 'PTHR11206:SF437', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 30-LIKE', 240627),
(313876, 'PTHR11206:SF434', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313877, 'PTHR11206:SF313', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 25', 240627),
(313878, 'PTHR11206:SF92', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 48', 240627),
(313879, 'PTHR11206:SF159', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313880, 'PTHR11206:SF435', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313881, 'PTHR11206:SF93', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 56', 240627),
(313882, 'PTHR11206:SF399', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313883, 'PTHR11206:SF311', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 52', 240627),
(313884, 'PTHR11206:SF432', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313885, 'PTHR11206:SF157', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313886, 'PTHR11206:SF85', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 41', 240627),
(313887, 'PTHR11206:SF430', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313888, 'PTHR11206:SF431', NULL, NULL, NULL, NULL, 'MULTI ANTIMICROBIAL EXTRUSION PROTEIN-RELATED', 240627),
(313889, 'PTHR11206:SF310', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313890, 'PTHR11206:SF87', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 10-RELATED', 240627),
(313891, 'PTHR11206:SF153', NULL, NULL, NULL, NULL, 'ETHIONINE RESISTANCE-CONFERRING PROTEIN 1', 240627),
(313892, 'PTHR11206:SF395', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313893, 'PTHR11206:SF396', NULL, NULL, NULL, NULL, '', 240627),
(313894, 'PTHR11206:SF275', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 29-RELATED', 240627),
(313895, 'PTHR11206:SF272', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 40', 240627),
(313896, 'PTHR11206:SF393', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313897, 'PTHR11206:SF394', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313898, 'PTHR11206:SF273', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313899, 'PTHR11206:SF391', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313900, 'PTHR11206:SF270', NULL, NULL, NULL, NULL, 'MULTIDRUG AND TOXIN EXTRUSION PROTEIN 2', 240627),
(313901, 'PTHR11206:SF392', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313902, 'PTHR11206:SF390', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 14', 240627),
(313903, 'PTHR11206:SF429', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313904, 'PTHR11206:SF308', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313905, 'PTHR11206:SF309', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313906, 'PTHR11206:SF306', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313907, 'PTHR11206:SF427', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 5-RELATED', 240627),
(313908, 'PTHR11206:SF307', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313909, 'PTHR11206:SF304', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313910, 'PTHR11206:SF425', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313911, 'PTHR11206:SF302', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(313912, 'PTHR11206:SF303', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313913, 'PTHR11206:SF388', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313914, 'PTHR11206:SF301', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313915, 'PTHR11206:SF268', NULL, NULL, NULL, NULL, 'MULTIDRUG AND TOXIN EXTRUSION PROTEIN-RELATED', 240627),
(313916, 'PTHR11206:SF389', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313917, 'PTHR11206:SF422', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 26-RELATED', 240627),
(313918, 'PTHR11206:SF144', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313919, 'PTHR11206:SF265', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313920, 'PTHR11206:SF384', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313921, 'PTHR11206:SF264', NULL, NULL, NULL, NULL, 'MULTIDRUG AND TOXIN EXTRUSION PROTEIN', 240627),
(313922, 'PTHR11206:SF385', NULL, NULL, NULL, NULL, 'MULTI ANTIMICROBIAL EXTRUSION PROTEIN-RELATED', 240627),
(313923, 'PTHR11206:SF261', NULL, NULL, NULL, NULL, 'OS03G0571700 PROTEIN', 240627),
(313924, 'PTHR11206:SF140', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 37', 240627),
(313925, 'PTHR11206:SF383', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313926, 'PTHR11206:SF141', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313927, 'PTHR11206:SF380', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313928, 'PTHR11206:SF458', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 31', 240627),
(313929, 'PTHR11206:SF338', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313930, 'PTHR11206:SF333', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 1-RELATED', 240627),
(313931, 'PTHR11206:SF455', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313932, 'PTHR11206:SF73', NULL, NULL, NULL, NULL, 'MULTIDRUG AND TOXIN EXTRUSION PROTEIN 1', 240627),
(313933, 'PTHR11206:SF334', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313934, 'PTHR11206:SF177', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313935, 'PTHR11206:SF452', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313936, 'PTHR11206:SF331', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 33-LIKE', 240627),
(313937, 'PTHR11206:SF453', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 50', 240627),
(313938, 'PTHR11206:SF299', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313939, 'PTHR11206:SF296', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313940, 'PTHR11206:SF330', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313941, 'PTHR11206:SF176', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313942, 'PTHR11206:SF294', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 9', 240627),
(313943, 'PTHR11206:SF174', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313944, 'PTHR11206:SF171', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313945, 'PTHR11206:SF292', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 23', 240627),
(313946, 'PTHR11206:SF293', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 17', 240627),
(313947, 'PTHR11206:SF290', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313948, 'PTHR11206:SF449', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 16', 240627),
(313949, 'PTHR11206:SF329', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313950, 'PTHR11206:SF326', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 15', 240627),
(313951, 'PTHR11206:SF327', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313952, 'PTHR11206:SF80', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 27', 240627),
(313953, 'PTHR11206:SF81', NULL, NULL, NULL, NULL, 'MULTIDRUG AND TOXIN EXTRUSION PROTEIN 2', 240627),
(313954, 'PTHR11206:SF324', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313955, 'PTHR11206:SF325', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313956, 'PTHR11206:SF201', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313957, 'PTHR11206:SF444', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(313958, 'PTHR11206:SF323', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313959, 'PTHR11206:SF320', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313960, 'PTHR11206:SF441', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 19', 240627),
(313961, 'PTHR11206:SF287', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313962, 'PTHR11206:SF285', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313963, 'PTHR11206:SF286', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313964, 'PTHR11206:SF165', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 55', 240627),
(313965, 'PTHR11206:SF283', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN MDTK', 240627),
(313966, 'PTHR11206:SF78', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 18', 240627),
(313967, 'PTHR11206', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN', 240627),
(313968, 'PTHR11206:SF282', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313969, 'PTHR11206:SF280', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 240627),
(313970, 'PTHR33407:SF11', NULL, NULL, NULL, NULL, 'PECTATE LYASE H-RELATED', 240628),
(313971, 'PTHR33407', NULL, NULL, NULL, NULL, 'PECTATE LYASE F-RELATED', 240628),
(313972, 'PTHR33407:SF8', NULL, NULL, NULL, NULL, 'PECTATE LYASE E', 240628),
(313973, 'PTHR33407:SF9', NULL, NULL, NULL, NULL, 'PECTATE LYASE F-RELATED', 240628),
(313974, 'PTHR31406:SF1', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 240629),
(313975, 'PTHR31406:SF3', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 240629),
(313976, 'PTHR31406:SF6', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 240629),
(313977, 'PTHR31406', NULL, NULL, NULL, NULL, 'PROTEIN CBG06702-RELATED', 240629),
(313978, 'PTHR37550:SF1', NULL, NULL, NULL, NULL, 'SSL1300 PROTEIN', 240630),
(313979, 'PTHR37550', NULL, NULL, NULL, NULL, 'ANTITOXIN VAPB1', 240630),
(313980, 'PTHR37550:SF3', NULL, NULL, NULL, NULL, 'ANTITOXIN VAPB1', 240630),
(313981, 'PTHR24031:SF84', NULL, NULL, NULL, NULL, 'EUKARYOTIC INITIATION FACTOR 4A', 240631),
(313982, 'PTHR24031:SF196', NULL, NULL, NULL, NULL, '', 240631),
(313983, 'PTHR24031:SF708', NULL, NULL, NULL, NULL, 'EUKARYOTIC INITIATION FACTOR 4A-3', 240631),
(313984, 'PTHR24031:SF307', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX1', 240631),
(313985, 'PTHR24031:SF746', NULL, NULL, NULL, NULL, 'EUKARYOTIC INITIATION FACTOR 4A-8-LIKE', 240631),
(313986, 'PTHR24031:SF625', NULL, NULL, NULL, NULL, 'RNA HELICASE', 240631),
(313987, 'PTHR24031:SF624', NULL, NULL, NULL, NULL, 'DEAD/H RNA HELICASE, PUTATIVE-RELATED', 240631),
(313988, 'PTHR24031:SF667', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 26', 240631),
(313989, 'PTHR24031:SF700', NULL, NULL, NULL, NULL, 'RNA HELICASE', 240631),
(313990, 'PTHR24031:SF706', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX27-RELATED', 240631),
(313991, 'PTHR24031:SF629', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE MRH4, MITOCHONDRIAL', 240631),
(313992, 'PTHR24031:SF221', NULL, NULL, NULL, NULL, 'EUKARYOTIC INITIATION FACTOR 4A-I', 240631),
(313993, 'PTHR24031:SF384', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE MSS116, MITOCHONDRIAL', 240631),
(313994, 'PTHR24031:SF620', NULL, NULL, NULL, NULL, '', 240631),
(313995, 'PTHR24031:SF301', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX18', 240631),
(313996, 'PTHR24031:SF223', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE GLH-4', 240631),
(313997, 'PTHR24031:SF89', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX31-RELATED', 240631),
(313998, 'PTHR24031:SF740', NULL, NULL, NULL, NULL, 'RNA HELICASE', 240631),
(313999, 'PTHR24031:SF421', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX28-RELATED', 240631),
(314000, 'PTHR24031:SF663', NULL, NULL, NULL, NULL, 'RNA HELICASE', 240631),
(314001, 'PTHR24031:SF54', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX10-RELATED', 240631),
(314002, 'PTHR24031:SF96', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX56-RELATED', 240631);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(314003, 'PTHR24031:SF91', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX24', 240631),
(314004, 'PTHR24031:SF719', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 240631),
(314005, 'PTHR24031:SF2', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX55', 240631),
(314006, 'PTHR24031:SF757', NULL, NULL, NULL, NULL, 'DEAD/H RNA HELICASE, PUTATIVE-RELATED', 240631),
(314007, 'PTHR24031:SF756', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 3, CHLOROPLASTIC', 240631),
(314008, 'PTHR24031:SF634', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX18', 240631),
(314009, 'PTHR24031:SF715', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 31', 240631),
(314010, 'PTHR24031:SF594', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX52-RELATED', 240631),
(314011, 'PTHR24031:SF753', NULL, NULL, NULL, NULL, '', 240631),
(314012, 'PTHR24031:SF676', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX49-RELATED', 240631),
(314013, 'PTHR24031:SF597', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 51-RELATED', 240631),
(314014, 'PTHR24031:SF751', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN', 240631),
(314015, 'PTHR24031:SF292', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX54', 240631),
(314016, 'PTHR24031:SF725', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE-LIKE PROTEIN', 240631),
(314017, 'PTHR24031:SF769', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 51', 240631),
(314018, 'PTHR24031:SF768', NULL, NULL, NULL, NULL, '', 240631),
(314019, 'PTHR24031:SF724', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN-RELATED', 240631),
(314020, 'PTHR24031:SF767', NULL, NULL, NULL, NULL, 'EUKARYOTIC INITIATION FACTOR 4A-9', 240631),
(314021, 'PTHR24031:SF326', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 53, MITOCHONDRIAL', 240631),
(314022, 'PTHR24031:SF766', NULL, NULL, NULL, NULL, 'DEAD/H RNA HELICASE, PUTATIVE-RELATED', 240631),
(314023, 'PTHR24031:SF645', NULL, NULL, NULL, NULL, 'RNA HELICASE', 240631),
(314024, 'PTHR24031:SF729', NULL, NULL, NULL, NULL, 'BNAA01G17110D PROTEIN', 240631),
(314025, 'PTHR24031:SF727', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX47-RELATED', 240631),
(314026, 'PTHR24031:SF684', NULL, NULL, NULL, NULL, 'DEAD/H RNA HELICASE, PUTATIVE-RELATED', 240631),
(314027, 'PTHR24031:SF761', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX49-RELATED', 240631),
(314028, 'PTHR24031:SF760', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 45', 240631),
(314029, 'PTHR24031:SF682', NULL, NULL, NULL, NULL, 'RNA HELICASE', 240631),
(314030, 'PTHR24031:SF688', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 25', 240631),
(314031, 'PTHR24031:SF765', NULL, NULL, NULL, NULL, 'EUKARYOTIC INITIATION FACTOR 4A-8-LIKE', 240631),
(314032, 'PTHR24031:SF324', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 33-RELATED', 240631),
(314033, 'PTHR24031:SF25', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX46-RELATED', 240631),
(314034, 'PTHR24031:SF764', NULL, NULL, NULL, NULL, 'RNA HELICASE', 240631),
(314035, 'PTHR24031:SF68', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX51', 240631),
(314036, 'PTHR24031:SF763', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE', 240631),
(314037, 'PTHR24031:SF125', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX42', 240631),
(314038, 'PTHR24031:SF762', NULL, NULL, NULL, NULL, 'EUKARYOTIC INITIATION FACTOR 4A-II', 240631),
(314039, 'PTHR24031:SF735', NULL, NULL, NULL, NULL, 'EUKARYOTIC INITIATION FACTOR 4A-1', 240631),
(314040, 'PTHR24031', NULL, NULL, NULL, NULL, 'RNA HELICASE', 240631),
(314041, 'PTHR24031:SF777', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 9, MITOCHONDRIAL', 240631),
(314042, 'PTHR24031:SF737', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 240631),
(314043, 'PTHR24031:SF772', NULL, NULL, NULL, NULL, 'EUKARYOTIC INITIATION FACTOR 4A-2', 240631);
INSERT INTO "PUBLIC"."MODEL" VALUES
(314044, 'PTHR24031:SF771', NULL, NULL, NULL, NULL, '', 240631),
(314045, 'PTHR24031:SF694', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 39-LIKE ISOFORM X1', 240631),
(314046, 'PTHR24031:SF770', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 25', 240631),
(314047, 'PTHR24031:SF692', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 53', 240631),
(314048, 'PTHR24031:SF296', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 9', 240631),
(314049, 'PTHR24031:SF776', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE-LIKE PROTEIN', 240631),
(314050, 'PTHR24031:SF775', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX10-RELATED', 240631),
(314051, 'PTHR24031:SF731', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE', 240631),
(314052, 'PTHR24031:SF730', NULL, NULL, NULL, NULL, 'BNAC02G01070D PROTEIN', 240631),
(314053, 'PTHR24031:SF774', NULL, NULL, NULL, NULL, 'EUKARYOTIC INITIATION FACTOR 4A-1', 240631),
(314054, 'PTHR24031:SF773', NULL, NULL, NULL, NULL, 'DUF4217 DOMAIN-CONTAINING PROTEIN', 240631),
(314055, 'PTHR47625', NULL, NULL, NULL, NULL, '', 240632),
(314056, 'PTHR47625:SF1', NULL, NULL, NULL, NULL, '', 240632),
(314057, 'PTHR13064:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 9B', 240633),
(314058, 'PTHR13064:SF1', NULL, NULL, NULL, NULL, 'PROTON-TRANSPORTING V-TYPE ATPASE COMPLEX ASSEMBLY REGULATOR TMEM9', 240633),
(314059, 'PTHR13064', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 9 FAMILY MEMBER', 240633),
(314060, 'PTHR13064:SF6', NULL, NULL, NULL, NULL, 'AGAP007259-PA', 240633),
(314061, 'PTHR14149:SF10', NULL, NULL, NULL, NULL, 'RAS GTPASE-ACTIVATING-LIKE PROTEIN IQGAP3', 240634),
(314062, 'PTHR14149:SF19', NULL, NULL, NULL, NULL, '', 240634),
(314063, 'PTHR14149:SF15', NULL, NULL, NULL, NULL, 'RAS GTPASE-ACTIVATING-LIKE PROTEIN IQGAP1', 240634),
(314064, 'PTHR14149:SF16', NULL, NULL, NULL, NULL, 'RAS GTPASE-ACTIVATING-LIKE PROTEIN GAPA', 240634),
(314065, 'PTHR14149:SF17', NULL, NULL, NULL, NULL, 'GTPASE-ACTIVATING PROTEIN', 240634),
(314066, 'PTHR14149', NULL, NULL, NULL, NULL, 'RAS GTPASE-ACTIVATING PROTEIN WITH IQ MOTIF', 240634),
(314067, 'PTHR14149:SF12', NULL, NULL, NULL, NULL, 'RAS GTPASE-ACTIVATING-LIKE PROTEIN IQGAP2', 240634),
(314068, 'PTHR14149:SF14', NULL, NULL, NULL, NULL, 'PATTERNED EXPRESSION SITE', 240634),
(314069, 'PTHR41153', NULL, NULL, NULL, NULL, 'RE41427P', 240635),
(314070, 'PTHR41153:SF2', NULL, NULL, NULL, NULL, 'RE41427P', 240635),
(314071, 'PTHR22426', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 240636),
(314072, 'PTHR22426:SF1', NULL, NULL, NULL, NULL, 'LYSINE-RICH NUCLEOLAR PROTEIN 1', 240636),
(314073, 'PTHR22426:SF2', NULL, NULL, NULL, NULL, 'ARGININE/SERINE-RICH COILED-COIL PROTEIN 2', 240636),
(314074, 'PTHR22426:SF3', NULL, NULL, NULL, NULL, 'SMAP DOMAIN-CONTAINING PROTEIN', 240636),
(314075, 'PTHR22426:SF4', NULL, NULL, NULL, NULL, 'LYSINE-RICH NUCLEOLAR PROTEIN 1', 240636),
(314076, 'PTHR22426:SF5', NULL, NULL, NULL, NULL, 'SMAP DOMAIN-CONTAINING PROTEIN', 240636),
(314077, 'PTHR22426:SF6', NULL, NULL, NULL, NULL, '', 240636),
(314078, 'PTHR31116:SF38', NULL, NULL, NULL, NULL, 'DNA-3-METHYLADENINE GLYCOSYLASE 1-LIKE', 240637),
(314079, 'PTHR31116:SF17', NULL, NULL, NULL, NULL, 'DNA-3-METHYLADENINE GLYCOSYLASE I', 240637),
(314080, 'PTHR31116:SF5', NULL, NULL, NULL, NULL, 'OS06G0649800 PROTEIN', 240637),
(314081, 'PTHR31116:SF4', NULL, NULL, NULL, NULL, 'DNA GLYCOSYLASE SUPERFAMILY PROTEIN', 240637),
(314082, 'PTHR31116:SF29', NULL, NULL, NULL, NULL, 'DNA GLYCOSYLASE SUPERFAMILY PROTEIN', 240637),
(314083, 'PTHR31116:SF19', NULL, NULL, NULL, NULL, 'DNA-3-METHYLADENINE GLYCOSYLASE I', 240637),
(314084, 'PTHR31116:SF7', NULL, NULL, NULL, NULL, 'OS09G0420300 PROTEIN', 240637),
(314085, 'PTHR31116:SF41', NULL, NULL, NULL, NULL, '', 240637),
(314086, 'PTHR31116:SF30', NULL, NULL, NULL, NULL, '', 240637),
(314087, 'PTHR31116:SF42', NULL, NULL, NULL, NULL, 'BNAC02G46050D PROTEIN', 240637),
(314088, 'PTHR31116:SF31', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN KINASE SPLA-LIKE', 240637);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(314089, 'PTHR31116:SF32', NULL, NULL, NULL, NULL, 'BNAC01G38620D PROTEIN', 240637),
(314090, 'PTHR31116:SF43', NULL, NULL, NULL, NULL, 'DNA GLYCOSYLASE SUPERFAMILY PROTEIN', 240637),
(314091, 'PTHR31116:SF22', NULL, NULL, NULL, NULL, 'BNAC01G14540D PROTEIN', 240637),
(314092, 'PTHR31116:SF44', NULL, NULL, NULL, NULL, 'OS04G0501200 PROTEIN', 240637),
(314093, 'PTHR31116:SF45', NULL, NULL, NULL, NULL, 'DNA-3-METHYLADENINE GLYCOSYLASE 1-LIKE', 240637),
(314094, 'PTHR31116:SF46', NULL, NULL, NULL, NULL, 'DNA-3-METHYLADENINE GLYCOSYLASE I', 240637),
(314095, 'PTHR31116:SF25', NULL, NULL, NULL, NULL, 'DNA GLYCOSYLASE SUPERFAMILY PROTEIN', 240637),
(314096, 'PTHR31116:SF47', NULL, NULL, NULL, NULL, 'DNA-3-METHYLADENINE GLYCOSYLASE 1-LIKE', 240637),
(314097, 'PTHR31116:SF48', NULL, NULL, NULL, NULL, 'GMP SYNTHASE [GLUTAMINE-HYDROLYZING]-RELATED', 240637),
(314098, 'PTHR31116', NULL, NULL, NULL, NULL, 'OS04G0501200 PROTEIN', 240637),
(314099, 'PTHR33096', NULL, NULL, NULL, NULL, 'CXC2 DOMAIN-CONTAINING PROTEIN', 240638),
(314100, 'PTHR33096:SF1', NULL, NULL, NULL, NULL, 'CXC1 DOMAIN-CONTAINING PROTEIN', 240638),
(314101, 'PTHR46298:SF1', NULL, NULL, NULL, NULL, 'ANDROGLOBIN', 240639),
(314102, 'PTHR46298', NULL, NULL, NULL, NULL, 'ANDROGLOBIN', 240639),
(314103, 'PTHR30160:SF1', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE 1,2-N-ACETYLGLUCOSAMINETRANSFERASE-RELATED', 240640),
(314104, 'PTHR30160:SF19', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE HEPTOSYLTRANSFERASE 1', 240640),
(314105, 'PTHR30160:SF15', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE HI_0523-RELATED', 240640),
(314106, 'PTHR30160', NULL, NULL, NULL, NULL, 'TETRAACYLDISACCHARIDE 4''-KINASE-RELATED', 240640),
(314107, 'PTHR30160:SF21', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE CORE HEPTOSYLTRANSFERASE OPSX', 240640),
(314108, 'PTHR30160:SF22', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE CORE BIOSYNTHESIS PROTEIN', 240640),
(314109, 'PTHR30160:SF7', NULL, NULL, NULL, NULL, 'ADP-HEPTOSE--LPS HEPTOSYLTRANSFERASE 2', 240640),
(314110, 'PTHR22988:SF22', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE MRCK GAMMA', 240641),
(314111, 'PTHR22988:SF66', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE GENGHIS KHAN', 240641),
(314112, 'PTHR22988', NULL, NULL, NULL, NULL, 'MYOTONIC DYSTROPHY S/T KINASE-RELATED', 240641),
(314113, 'PTHR22988:SF33', NULL, NULL, NULL, NULL, 'RHO-ASSOCIATED PROTEIN KINASE 1', 240641),
(314114, 'PTHR22988:SF34', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE MRCK BETA', 240641),
(314115, 'PTHR22988:SF31', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE MRCK ALPHA', 240641),
(314116, 'PTHR22988:SF75', NULL, NULL, NULL, NULL, 'MYOSIN_TAIL_1 DOMAIN-CONTAINING PROTEIN', 240641),
(314117, 'PTHR22988:SF28', NULL, NULL, NULL, NULL, 'RHO-ASSOCIATED PROTEIN KINASE 2', 240641),
(314118, 'PTHR22988:SF39', NULL, NULL, NULL, NULL, 'PROTEIN CBG04771', 240641),
(314119, 'PTHR22988:SF73', NULL, NULL, NULL, NULL, 'RHO-ASSOCIATED PROTEIN KINASE', 240641),
(314120, 'PTHR22988:SF74', NULL, NULL, NULL, NULL, '', 240641),
(314121, 'PTHR22988:SF71', NULL, NULL, NULL, NULL, 'CITRON RHO-INTERACTING KINASE', 240641),
(314122, 'PTHR22988:SF72', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240641),
(314123, 'PTHR42765:SF2', NULL, NULL, NULL, NULL, 'TYROSINE--TRNA LIGASE', 240642),
(314124, 'PTHR42765:SF1', NULL, NULL, NULL, NULL, 'ISOLEUCINE--TRNA LIGASE, MITOCHONDRIAL', 240642),
(314125, 'PTHR42765', NULL, NULL, NULL, NULL, 'SOLEUCYL-TRNA SYNTHETASE', 240642),
(314126, 'PTHR10390', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN SIX', 240643),
(314127, 'PTHR10390:SF61', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN SIX2', 240643),
(314128, 'PTHR10390:SF73', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN SIX7', 240643),
(314129, 'PTHR10390:SF40', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN SIX5', 240643),
(314130, 'PTHR10390:SF74', NULL, NULL, NULL, NULL, 'SIX HOMEOBOX 6A', 240643),
(314131, 'PTHR10390:SF64', NULL, NULL, NULL, NULL, 'SIX HOMEOBOX 4A-RELATED', 240643),
(314132, 'PTHR10390:SF31', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN SIX3', 240643);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(314133, 'PTHR10390:SF65', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 240643),
(314134, 'PTHR10390:SF33', NULL, NULL, NULL, NULL, 'PROTEIN OPTIX', 240643),
(314135, 'PTHR10390:SF44', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 240643),
(314136, 'PTHR10390:SF12', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN SIX6', 240643),
(314137, 'PTHR10390:SF34', NULL, NULL, NULL, NULL, 'ANOMALOUS HOMEOBOX PROTEIN', 240643),
(314138, 'PTHR10390:SF68', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN CEH-33', 240643),
(314139, 'PTHR10390:SF13', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN SIX1', 240643),
(314140, 'PTHR10390:SF36', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN SIX4', 240643),
(314141, 'PTHR10390:SF69', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 240643),
(314142, 'PTHR39419', NULL, NULL, NULL, NULL, 'SLL0814 PROTEIN', 240644),
(314143, 'PTHR39419:SF1', NULL, NULL, NULL, NULL, 'SLL0814 PROTEIN', 240644),
(314144, 'PTHR11885:SF20', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S13', 240645),
(314145, 'PTHR11885:SF21', NULL, NULL, NULL, NULL, 'RIBOSOMAL_S13_N DOMAIN-CONTAINING PROTEIN', 240645),
(314146, 'PTHR11885:SF23', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S15-RELATED', 240645),
(314147, 'PTHR11885:SF17', NULL, NULL, NULL, NULL, 'RIBOSOMAL_S13_N DOMAIN-CONTAINING PROTEIN', 240645),
(314148, 'PTHR11885', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S15P/S13E', 240645),
(314149, 'PTHR11885:SF19', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S15, CHLOROPLASTIC', 240645),
(314150, 'PTHR11885:SF6', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S13', 240645),
(314151, 'PTHR11885:SF7', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S13', 240645),
(314152, 'PTHR11885:SF25', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S13-1-RELATED', 240645),
(314153, 'PTHR11885:SF26', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S13-LIKE', 240645),
(314154, 'PTHR11885:SF16', NULL, NULL, NULL, NULL, 'OS07G0572900 PROTEIN', 240645),
(314155, 'PTHR11885:SF27', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S13', 240645),
(314156, 'PTHR48102:SF17', NULL, NULL, NULL, NULL, 'OS01G0886600 PROTEIN', 240646),
(314157, 'PTHR48102:SF16', NULL, NULL, NULL, NULL, 'CLP PROTEASE REGULATORY SUBUNIT CLPX2, MITOCHONDRIAL-LIKE ISOFORM X1', 240646),
(314158, 'PTHR48102:SF15', NULL, NULL, NULL, NULL, 'CLP PROTEASE REGULATORY SUBUNIT CLPX2, MITOCHONDRIAL-LIKE', 240646),
(314159, 'PTHR48102', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE ATP-BINDING SUBUNIT CLPX-LIKE, MITOCHONDRIAL-RELATED', 240646),
(314160, 'PTHR48102:SF3', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT PROTEASE ATPASE SUBUNIT HSLU', 240646),
(314161, 'PTHR48102:SF2', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT PROTEASE ATPASE SUBUNIT HSLU2', 240646),
(314162, 'PTHR48102:SF1', NULL, NULL, NULL, NULL, 'BNAA03G12280D PROTEIN', 240646),
(314163, 'PTHR48102:SF7', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE ATP-BINDING SUBUNIT CLPX-LIKE, MITOCHONDRIAL', 240646),
(314164, 'PTHR48102:SF14', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE-RELATED', 240646),
(314165, 'PTHR48102:SF6', NULL, NULL, NULL, NULL, 'CLP PROTEASE REGULATORY SUBUNIT CLPX1, MITOCHONDRIAL', 240646),
(314166, 'PTHR48102:SF12', NULL, NULL, NULL, NULL, 'CLP PROTEASE REGULATORY SUBUNIT CLPX2, MITOCHONDRIAL-LIKE ISOFORM X1', 240646),
(314167, 'PTHR48102:SF4', NULL, NULL, NULL, NULL, 'CLP PROTEASE REGULATORY SUBUNIT CLPX2, MITOCHONDRIAL', 240646),
(314168, 'PTHR48102:SF10', NULL, NULL, NULL, NULL, 'PROTEIN CBG04167', 240646),
(314169, 'PTHR48102:SF8', NULL, NULL, NULL, NULL, 'CLP PROTEASE REGULATORY SUBUNIT CLPX1 MITOCHONDRIAL', 240646),
(314170, 'PTHR31581', NULL, NULL, NULL, NULL, 'KICSTOR COMPLEX PROTEIN C12ORF66', 240647),
(314171, 'PTHR31581:SF1', NULL, NULL, NULL, NULL, 'KICSTOR SUBUNIT 2', 240647),
(314172, 'PTHR15933:SF13', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 30', 240648),
(314173, 'PTHR15933', NULL, NULL, NULL, NULL, 'PROTEIN CBG16327', 240648),
(314174, 'PTHR15933:SF20', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN', 240648),
(314175, 'PTHR15933:SF1', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 40', 240648);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(314176, 'PTHR28052:SF1', NULL, NULL, NULL, NULL, 'UPF0545 PROTEIN C22ORF39', 240649),
(314177, 'PTHR28052:SF2', NULL, NULL, NULL, NULL, '', 240649),
(314178, 'PTHR28052', NULL, NULL, NULL, NULL, 'UPF0545 PROTEIN C22ORF39', 240649),
(314179, 'PTHR35309', NULL, NULL, NULL, NULL, '', 240650),
(314180, 'PTHR35309:SF4', NULL, NULL, NULL, NULL, 'TOCOPHEROL CYCLASE', 240650),
(314181, 'PTHR35309:SF2', NULL, NULL, NULL, NULL, 'TOCOPHEROL CYCLASE, CHLOROPLASTIC', 240650),
(314182, 'PTHR15076:SF4', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN XG', 240651),
(314183, 'PTHR15076', NULL, NULL, NULL, NULL, 'CD99/MIC2 PROTEIN RELATED', 240651),
(314184, 'PTHR15076:SF12', NULL, NULL, NULL, NULL, 'CD99 ANTIGEN-LIKE PROTEIN 2', 240651),
(314185, 'PTHR15076:SF15', NULL, NULL, NULL, NULL, 'CD99 ANTIGEN', 240651),
(314186, 'PTHR36016:SF9', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 240652),
(314187, 'PTHR36016:SF10', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 13', 240652),
(314188, 'PTHR36016:SF13', NULL, NULL, NULL, NULL, 'CLE7', 240652),
(314189, 'PTHR36016:SF12', NULL, NULL, NULL, NULL, 'BNAC04G13300D PROTEIN', 240652),
(314190, 'PTHR36016:SF4', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 53', 240652),
(314191, 'PTHR36016:SF1', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 5-RELATED', 240652),
(314192, 'PTHR36016:SF8', NULL, NULL, NULL, NULL, '', 240652),
(314193, 'PTHR36016:SF7', NULL, NULL, NULL, NULL, 'BNAA04G18030D PROTEIN', 240652),
(314194, 'PTHR36016', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 7', 240652),
(314195, 'PTHR47462:SF1', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE PROTEIN 5', 240653),
(314196, 'PTHR47462', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE PROTEIN 5', 240653),
(314197, 'PTHR34812', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REACTION CENTER PROTEIN J', 240654),
(314198, 'PTHR34812:SF3', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REACTION CENTER PROTEIN J', 240654),
(314199, 'PTHR34674:SF6', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 240655),
(314200, 'PTHR34674:SF5', NULL, NULL, NULL, NULL, 'BNAA01G28480D PROTEIN', 240655),
(314201, 'PTHR34674:SF4', NULL, NULL, NULL, NULL, 'BNAA02G09120D PROTEIN', 240655),
(314202, 'PTHR34674:SF3', NULL, NULL, NULL, NULL, 'BNAA03G57520D PROTEIN', 240655),
(314203, 'PTHR34674', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLCHOLINE:DIACYLGLYCEROL CHOLINEPHOSPHOTRANSFERASE 1-RELATED', 240655),
(314204, 'PTHR34674:SF2', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLCHOLINE:DIACYLGLYCEROL CHOLINEPHOSPHOTRANSFERASE 1-LIKE', 240655),
(314205, 'PTHR34674:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLCHOLINE:DIACYLGLYCEROL CHOLINEPHOSPHOTRANSFERASE 1-RELATED', 240655),
(314206, 'PTHR43233:SF1', NULL, NULL, NULL, NULL, 'FAMILY N-ACETYLTRANSFERASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G03350)-RELATED', 240656),
(314207, 'PTHR43233', NULL, NULL, NULL, NULL, 'FAMILY N-ACETYLTRANSFERASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G03350)-RELATED', 240656),
(314208, 'PTHR30603:SF17', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA-G FACTOR', 240657),
(314209, 'PTHR30603:SF19', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA-F FACTOR', 240657),
(314210, 'PTHR30603:SF57', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA FACTOR SIGB', 240657),
(314211, 'PTHR30603:SF13', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA FACTOR SIGC', 240657),
(314212, 'PTHR30603:SF45', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA FACTOR SIGF, CHLOROPLASTIC', 240657),
(314213, 'PTHR30603:SF67', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA FACTOR RPOS', 240657),
(314214, 'PTHR30603:SF59', NULL, NULL, NULL, NULL, 'RNA POLYMERASE PRINCIPAL SIGMA FACTOR HRDA', 240657),
(314215, 'PTHR30603:SF4', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA FACTOR SIGE, CHLOROPLASTIC/MITOCHONDRIAL', 240657),
(314216, 'PTHR30603:SF25', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA FACTOR', 240657),
(314217, 'PTHR30603:SF47', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA FACTOR SIGD, CHLOROPLASTIC', 240657),
(314218, 'PTHR30603:SF14', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA FACTOR SIGA', 240657);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(314219, 'PTHR30603', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA FACTOR RPO', 240657),
(314220, 'PTHR30603:SF64', NULL, NULL, NULL, NULL, 'PLASTID RNA POLYMERASE SIGMA FACTOR X', 240657),
(314221, 'PTHR30603:SF53', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA-F TYPE, RNA POLYMERASE SIGMA-70 LIKE DOMAIN PROTEIN-RELATED', 240657),
(314222, 'PTHR30603:SF63', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA FACTOR SIGA-LIKE', 240657),
(314223, 'PTHR30603:SF52', NULL, NULL, NULL, NULL, 'SIGMA FACTOR A-RELATED', 240657),
(314224, 'PTHR30603:SF66', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 33 HOMOLOG', 240657),
(314225, 'PTHR30603:SF65', NULL, NULL, NULL, NULL, '', 240657),
(314226, 'PTHR30603:SF60', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA FACTOR RPOD', 240657),
(314227, 'PTHR30603:SF62', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA FACTOR SIGA', 240657),
(314228, 'PTHR30603:SF51', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA-K FACTOR', 240657),
(314229, 'PTHR30603:SF50', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA-70 LIKE DOMAIN, RNA POLYMERASE SIGMA-B/F/G TYPE-RELATED', 240657),
(314230, 'PTHR45588:SF3', NULL, NULL, NULL, NULL, 'TPR DOMAIN PROTEIN', 240658),
(314231, 'PTHR45588:SF1', NULL, NULL, NULL, NULL, 'WW DOMAIN-CONTAINING PROTEIN', 240658),
(314232, 'PTHR45588:SF2', NULL, NULL, NULL, NULL, 'TPR DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_3G00240)', 240658),
(314233, 'PTHR45588', NULL, NULL, NULL, NULL, 'TPR DOMAIN-CONTAINING PROTEIN', 240658),
(314234, 'PTHR42776:SF21', NULL, NULL, NULL, NULL, 'PEPTIDASE_S9 DOMAIN-CONTAINING PROTEIN', 240659),
(314235, 'PTHR42776:SF11', NULL, NULL, NULL, NULL, 'DIPEPTIDYL-PEPTIDASE 5-RELATED', 240659),
(314236, 'PTHR42776:SF25', NULL, NULL, NULL, NULL, 'BNAA01G19230D PROTEIN', 240659),
(314237, 'PTHR42776:SF26', NULL, NULL, NULL, NULL, 'BNAA08G30180D PROTEIN', 240659),
(314238, 'PTHR42776:SF23', NULL, NULL, NULL, NULL, 'ENZYME-LIKE PROTEIN, PUTATIVE-RELATED', 240659),
(314239, 'PTHR42776:SF13', NULL, NULL, NULL, NULL, 'DIPEPTIDYL-PEPTIDASE 5', 240659),
(314240, 'PTHR42776:SF18', NULL, NULL, NULL, NULL, 'ACYLAMINO-ACID-RELEASING ENZYME 2', 240659),
(314241, 'PTHR42776:SF29', NULL, NULL, NULL, NULL, 'PEPTIDASE_S9 DOMAIN-CONTAINING PROTEIN', 240659),
(314242, 'PTHR42776:SF5', NULL, NULL, NULL, NULL, 'PEPTIDASE_S9 DOMAIN-CONTAINING PROTEIN', 240659),
(314243, 'PTHR42776:SF4', NULL, NULL, NULL, NULL, 'ACYLAMINO-ACID-RELEASING ENZYME', 240659),
(314244, 'PTHR42776:SF27', NULL, NULL, NULL, NULL, 'DIPEPTIDYL PEPTIDASE FAMILY MEMBER 6', 240659),
(314245, 'PTHR42776:SF16', NULL, NULL, NULL, NULL, 'ACYL-PEPTIDE HYDROLASE', 240659),
(314246, 'PTHR42776:SF28', NULL, NULL, NULL, NULL, 'GLUTAMYL ENDOPEPTIDASE, CHLOROPLASTIC-RELATED', 240659),
(314247, 'PTHR42776:SF3', NULL, NULL, NULL, NULL, 'DIPEPTIDYL PEPTIDASE FOUR (IV) FAMILY', 240659),
(314248, 'PTHR42776', NULL, NULL, NULL, NULL, 'SERINE PEPTIDASE S9 FAMILY MEMBER', 240659),
(314249, 'PTHR42776:SF1', NULL, NULL, NULL, NULL, 'ACYL-PEPTIDE HYDROLASE', 240659),
(314250, 'PTHR18834', NULL, NULL, NULL, NULL, 'STEROID RECEPTOR RNA ACTIVATOR 1', 240660),
(314251, 'PTHR18834:SF2', NULL, NULL, NULL, NULL, 'STEROID RECEPTOR RNA ACTIVATOR 1', 240660),
(314252, 'PTHR48062:SF18', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 240661),
(314253, 'PTHR48062:SF39', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 240661),
(314254, 'PTHR48062:SF55', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 240661),
(314255, 'PTHR48062:SF5', NULL, NULL, NULL, NULL, 'ATRLP45 (RECEPTOR 45)_ PROTEIN BINDING', 240661),
(314256, 'PTHR48062:SF6', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR PROTEIN KINASE MSL1-LIKE ISOFORM X1', 240661),
(314257, 'PTHR48062:SF54', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 240661),
(314258, 'PTHR48062:SF32', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 240661),
(314259, 'PTHR48062:SF53', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 8-RELATED', 240661),
(314260, 'PTHR48062:SF31', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN', 240661);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(314261, 'PTHR48062:SF3', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 1', 240661),
(314262, 'PTHR48062:SF52', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE FLS2', 240661),
(314263, 'PTHR48062:SF4', NULL, NULL, NULL, NULL, 'OS02G0155750 PROTEIN', 240661),
(314264, 'PTHR48062:SF59', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE FAMILY PROTEIN, PUTATIVE-RELATED', 240661),
(314265, 'PTHR48062:SF37', NULL, NULL, NULL, NULL, 'DNA-DAMAGE-REPAIR/TOLERATION PROTEIN DRT100-LIKE', 240661),
(314266, 'PTHR48062:SF58', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 240661),
(314267, 'PTHR48062:SF14', NULL, NULL, NULL, NULL, 'BNAA06G12780D PROTEIN', 240661),
(314268, 'PTHR48062:SF35', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 240661),
(314269, 'PTHR48062:SF7', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 15', 240661),
(314270, 'PTHR48062:SF57', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 240661),
(314271, 'PTHR48062:SF12', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 240661),
(314272, 'PTHR48062:SF56', NULL, NULL, NULL, NULL, 'OS04G0647900 PROTEIN', 240661),
(314273, 'PTHR48062:SF34', NULL, NULL, NULL, NULL, 'PIRIFORMOSPORA INDICA-INSENSITIVE PROTEIN 2-LIKE', 240661),
(314274, 'PTHR48062:SF51', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE BAM3', 240661),
(314275, 'PTHR48062:SF22', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 240661),
(314276, 'PTHR48062:SF44', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 13', 240661),
(314277, 'PTHR48062:SF43', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 240661),
(314278, 'PTHR48062:SF21', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 240661),
(314279, 'PTHR48062:SF42', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 14', 240661),
(314280, 'PTHR48062:SF25', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 9A', 240661),
(314281, 'PTHR48062:SF46', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 240661),
(314282, 'PTHR48062:SF45', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 12', 240661),
(314283, 'PTHR48062:SF23', NULL, NULL, NULL, NULL, 'PIRIFORMOSPORA INDICA-INSENSITIVE-LIKE PROTEIN', 240661),
(314284, 'PTHR48062', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 14', 240661),
(314285, 'PTHR48062:SF62', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240661),
(314286, 'PTHR48062:SF61', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE GSO1 ISOFORM X1', 240661),
(314287, 'PTHR48062:SF2', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 2-RELATED', 240661),
(314288, 'PTHR48062:SF60', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 240661),
(314289, 'PTHR43888:SF41', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 240662),
(314290, 'PTHR43888:SF39', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 240662),
(314291, 'PTHR43888:SF53', NULL, NULL, NULL, NULL, 'DNAJ-RELATED PROTEIN SCJ1', 240662),
(314292, 'PTHR43888:SF31', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY A MEMBER 2', 240662),
(314293, 'PTHR43888:SF10', NULL, NULL, NULL, NULL, 'DNAJ-LIKE-2, ISOFORM A', 240662),
(314294, 'PTHR43888:SF12', NULL, NULL, NULL, NULL, 'DNAJ PROTEIN HOMOLOG XDJ1', 240662),
(314295, 'PTHR43888:SF13', NULL, NULL, NULL, NULL, 'DNAJ (HSP40) HOMOLOG, SUBFAMILY A, MEMBER 4, GENE 2', 240662),
(314296, 'PTHR43888:SF35', NULL, NULL, NULL, NULL, 'DNAJ PROTEIN HOMOLOG 2-LIKE ISOFORM X1', 240662),
(314297, 'PTHR43888:SF14', NULL, NULL, NULL, NULL, 'DNAJ PROTEIN ERDJ3B', 240662),
(314298, 'PTHR43888:SF36', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ A6', 240662),
(314299, 'PTHR43888:SF37', NULL, NULL, NULL, NULL, 'SHOCK PROTEIN DNAJ, PUTATIVE-RELATED', 240662),
(314300, 'PTHR43888:SF16', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY A MEMBER 1 HOMOLOG', 240662),
(314301, 'PTHR43888:SF7', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN APJ1', 240662),
(314302, 'PTHR43888:SF8', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY A MEMBER 1', 240662);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(314303, 'PTHR43888', NULL, NULL, NULL, NULL, 'DNAJ-LIKE-2, ISOFORM A-RELATED', 240662),
(314304, 'PTHR43888:SF9', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY A MEMBER 4', 240662),
(314305, 'PTHR43888:SF2', NULL, NULL, NULL, NULL, 'PROTEIN DNAJ, PUTATIVE-RELATED', 240662),
(314306, 'PTHR43888:SF50', NULL, NULL, NULL, NULL, 'DNAJ PROTEIN HOMOLOG', 240662),
(314307, 'PTHR43888:SF51', NULL, NULL, NULL, NULL, 'DNAJ', 240662),
(314308, 'PTHR43888:SF5', NULL, NULL, NULL, NULL, 'PROTEIN DNAJ, PUTATIVE-RELATED', 240662),
(314309, 'PTHR43888:SF52', NULL, NULL, NULL, NULL, 'DNAJ-LIKE PROTEIN', 240662),
(314310, 'PTHR43888:SF28', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ 2-RELATED', 240662),
(314311, 'PTHR43888:SF44', NULL, NULL, NULL, NULL, 'BNAA02G05430D PROTEIN', 240662),
(314312, 'PTHR43888:SF45', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK PROTEIN FAMILY (HSP40) MEMBER A1', 240662),
(314313, 'PTHR43888:SF46', NULL, NULL, NULL, NULL, 'DNAJ PROTEIN ERDJ3B', 240662),
(314314, 'PTHR43888:SF24', NULL, NULL, NULL, NULL, 'DNAJ PROTEIN HOMOLOG 2-LIKE', 240662),
(314315, 'PTHR43888:SF47', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 240662),
(314316, 'PTHR43888:SF25', NULL, NULL, NULL, NULL, 'DNAJ PROTEIN HOMOLOG', 240662),
(314317, 'PTHR13589:SF15', NULL, NULL, NULL, NULL, 'CREB-REGULATED TRANSCRIPTION COACTIVATOR, ISOFORM B', 240663),
(314318, 'PTHR13589:SF14', NULL, NULL, NULL, NULL, 'CREB-REGULATED TRANSCRIPTION COACTIVATOR 1', 240663),
(314319, 'PTHR13589', NULL, NULL, NULL, NULL, 'CREB-REGULATED TRANSCRIPTION COACTIVATOR', 240663),
(314320, 'PTHR13589:SF6', NULL, NULL, NULL, NULL, 'CREB-REGULATED TRANSCRIPTION COACTIVATOR 2', 240663),
(314321, 'PTHR13589:SF4', NULL, NULL, NULL, NULL, 'CREB-REGULATED TRANSCRIPTION COACTIVATOR 3', 240663),
(314322, 'PTHR11429', NULL, NULL, NULL, NULL, 'MYELIN BASIC PROTEIN', 240664),
(314323, 'PTHR11429:SF0', NULL, NULL, NULL, NULL, 'MYELIN BASIC PROTEIN', 240664),
(314324, 'PTHR38353', NULL, NULL, NULL, NULL, 'TROPOMYOSIN', 240665),
(314325, 'PTHR38353:SF2', NULL, NULL, NULL, NULL, 'TROPOMYOSIN', 240665),
(314326, 'PTHR38780', NULL, NULL, NULL, NULL, 'PROTEIN TUSC', 240666),
(314327, 'PTHR38780:SF1', NULL, NULL, NULL, NULL, 'PROTEIN TUSC', 240666),
(314328, 'PTHR21449', NULL, NULL, NULL, NULL, 'PROTEIN CBG05271-RELATED', 240667),
(314329, 'PTHR21449:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG13742', 240667),
(314330, 'PTHR21449:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG05315', 240667),
(314331, 'PTHR21449:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG05271', 240667),
(314332, 'PTHR12243:SF48', NULL, NULL, NULL, NULL, '', 240668),
(314333, 'PTHR12243:SF59', NULL, NULL, NULL, NULL, 'SI:CH73-59F11.3', 240668),
(314334, 'PTHR12243:SF37', NULL, NULL, NULL, NULL, 'SI:CH211-207I20.3-RELATED', 240668),
(314335, 'PTHR12243:SF36', NULL, NULL, NULL, NULL, 'SI:CH211-15D5.12-RELATED', 240668),
(314336, 'PTHR12243:SF58', NULL, NULL, NULL, NULL, 'BRICKWALL, ISOFORM A-RELATED', 240668),
(314337, 'PTHR12243:SF57', NULL, NULL, NULL, NULL, 'MADF DOMAIN TRANSCRIPTION FACTOR', 240668),
(314338, 'PTHR12243:SF34', NULL, NULL, NULL, NULL, 'MADF DOMAIN TRANSCRIPTION FACTOR', 240668),
(314339, 'PTHR12243:SF63', NULL, NULL, NULL, NULL, 'LD26477P', 240668),
(314340, 'PTHR12243:SF51', NULL, NULL, NULL, NULL, 'MADF DOMAIN-CONTAINING PROTEIN', 240668),
(314341, 'PTHR12243:SF62', NULL, NULL, NULL, NULL, 'MADF DOMAIN-CONTAINING PROTEIN', 240668),
(314342, 'PTHR12243:SF61', NULL, NULL, NULL, NULL, 'COREPRESSOR OF PANGOLIN, ISOFORM A-RELATED', 240668),
(314343, 'PTHR12243:SF60', NULL, NULL, NULL, NULL, 'FI03846P-RELATED', 240668),
(314344, 'PTHR12243', NULL, NULL, NULL, NULL, 'MADF DOMAIN TRANSCRIPTION FACTOR', 240668),
(314345, 'PTHR39398', NULL, NULL, NULL, NULL, 'YALI0F14311P', 240669),
(314346, 'PTHR39398:SF1', NULL, NULL, NULL, NULL, 'CSN8_PSD8_EIF3K DOMAIN-CONTAINING PROTEIN', 240669),
(314347, 'PTHR36443:SF1', NULL, NULL, NULL, NULL, 'BSR5223 PROTEIN', 240670),
(314348, 'PTHR36443', NULL, NULL, NULL, NULL, 'BSR5223 PROTEIN', 240670),
(314349, 'PTHR27006:SF554', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE ISOFORM 1', 240671);
INSERT INTO "PUBLIC"."MODEL" VALUES
(314350, 'PTHR27006', NULL, NULL, NULL, NULL, 'PROMASTIGOTE SURFACE ANTIGEN PROTEIN PSA', 240671),
(314351, 'PTHR23117:SF18', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND GUANYLATE KINASE DOMAIN-CONTAINING PROTEIN', 240672),
(314352, 'PTHR23117', NULL, NULL, NULL, NULL, 'GUANYLATE KINASE-RELATED', 240672),
(314353, 'PTHR23117:SF17', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 240672),
(314354, 'PTHR23117:SF21', NULL, NULL, NULL, NULL, 'GUANYLATE KINASE', 240672),
(314355, 'PTHR23117:SF22', NULL, NULL, NULL, NULL, 'GUANYLATE KINASE 1B', 240672),
(314356, 'PTHR23117:SF23', NULL, NULL, NULL, NULL, 'GUANYLATE KINASE', 240672),
(314357, 'PTHR23117:SF13', NULL, NULL, NULL, NULL, 'GUANYLATE KINASE', 240672),
(314358, 'PTHR23117:SF8', NULL, NULL, NULL, NULL, 'RIBOSE 1,5-BISPHOSPHATE PHOSPHOKINASE PHNN', 240672),
(314359, 'PTHR23117:SF20', NULL, NULL, NULL, NULL, 'GUANYLATE KINASE', 240672),
(314360, 'PTHR47349', NULL, NULL, NULL, NULL, 'CHROMOSOME 8, WHOLE GENOME SHOTGUN SEQUENCE', 240673),
(314361, 'PTHR47349:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 8, WHOLE GENOME SHOTGUN SEQUENCE', 240673),
(314362, 'PTHR37322:SF3', NULL, NULL, NULL, NULL, 'CHONDROITIN SULFATE ABC EXOLYASE', 240674),
(314363, 'PTHR37322', NULL, NULL, NULL, NULL, '', 240674),
(314364, 'PTHR14421:SF3', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 1', 240675),
(314365, 'PTHR14421', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 1', 240675),
(314366, 'PTHR37728', NULL, NULL, NULL, NULL, 'BNAA04G26730D PROTEIN', 240676),
(314367, 'PTHR37728:SF1', NULL, NULL, NULL, NULL, 'BNAA04G26730D PROTEIN', 240676),
(314368, 'PTHR38627:SF1', NULL, NULL, NULL, NULL, 'G-PROTEIN ALPHA SUBUNIT ACTIVATING PROTEIN GBAS-1', 240677),
(314369, 'PTHR38627:SF2', NULL, NULL, NULL, NULL, 'DOUBLE-STRAND TELOMERIC DNA-BINDING PROTEINS 1-RELATED', 240677),
(314370, 'PTHR38627', NULL, NULL, NULL, NULL, 'GA BINDING AND ACTIVATING AND SPK (SPK) DOMAIN CONTAINING-RELATED', 240677),
(314371, 'PTHR35761', NULL, NULL, NULL, NULL, 'ATR INTERACTING PROTEIN', 240678),
(314372, 'PTHR35761:SF1', NULL, NULL, NULL, NULL, 'PROTEIN SENSITIVE TO UV 2', 240678),
(314373, 'PTHR12899:SF3', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L18, MITOCHONDRIAL', 240679),
(314374, 'PTHR12899:SF20', NULL, NULL, NULL, NULL, 'BNAC09G30310D PROTEIN', 240679),
(314375, 'PTHR12899:SF21', NULL, NULL, NULL, NULL, 'OS09G0549700 PROTEIN', 240679),
(314376, 'PTHR12899:SF13', NULL, NULL, NULL, NULL, '50S RIBOSOMAL L18-LIKE PROTEIN', 240679),
(314377, 'PTHR12899', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L18, MITOCHONDRIAL', 240679),
(314378, 'PTHR12899:SF14', NULL, NULL, NULL, NULL, 'F14B2.25/F14B2.25', 240679),
(314379, 'PTHR12899:SF17', NULL, NULL, NULL, NULL, 'BNAC02G39880D PROTEIN', 240679),
(314380, 'PTHR12899:SF18', NULL, NULL, NULL, NULL, 'BNAC01G24050D PROTEIN', 240679),
(314381, 'PTHR12899:SF5', NULL, NULL, NULL, NULL, 'RIBOSOMAL L18P/L5E FAMILY PROTEIN', 240679),
(314382, 'PTHR12899:SF6', NULL, NULL, NULL, NULL, 'OS01G0256600 PROTEIN', 240679),
(314383, 'PTHR12899:SF16', NULL, NULL, NULL, NULL, 'OS02G0689700 PROTEIN', 240679),
(314384, 'PTHR12899:SF7', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240679),
(314385, 'PTHR12899:SF8', NULL, NULL, NULL, NULL, 'RIBOSOMAL L18P/L5E FAMILY PROTEIN', 240679),
(314386, 'PTHR12899:SF19', NULL, NULL, NULL, NULL, 'OS03G0694800 PROTEIN', 240679),
(314387, 'PTHR30182:SF12', NULL, NULL, NULL, NULL, 'L-SERINE DEHYDRATASE, BETA CHAIN-RELATED', 240680),
(314388, 'PTHR30182:SF6', NULL, NULL, NULL, NULL, 'L-SERINE DEHYDRATASE TDCG', 240680),
(314389, 'PTHR30182:SF1', NULL, NULL, NULL, NULL, 'L-SERINE DEHYDRATASE 1', 240680),
(314390, 'PTHR30182', NULL, NULL, NULL, NULL, 'L-SERINE DEHYDRATASE', 240680),
(314391, 'PTHR30182:SF14', NULL, NULL, NULL, NULL, 'L-SERINE DEHYDRATASE 2', 240680),
(314392, 'PTHR47388', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 18', 240681),
(314393, 'PTHR47388:SF1', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 18', 240681),
(314394, 'PTHR33347:SF1', NULL, NULL, NULL, NULL, 'PROTEIN SOB FIVE-LIKE 5', 240682);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(314395, 'PTHR33347:SF27', NULL, NULL, NULL, NULL, 'PROTEIN SOB FIVE-LIKE 3-RELATED', 240682),
(314396, 'PTHR33347:SF49', NULL, NULL, NULL, NULL, 'BNAA08G19660D PROTEIN', 240682),
(314397, 'PTHR33347:SF48', NULL, NULL, NULL, NULL, '', 240682),
(314398, 'PTHR33347', NULL, NULL, NULL, NULL, 'OSJNBA0091C07.3 PROTEIN', 240682),
(314399, 'PTHR33347:SF42', NULL, NULL, NULL, NULL, 'BNAANNG07890D PROTEIN', 240682),
(314400, 'PTHR33347:SF20', NULL, NULL, NULL, NULL, 'PROTEIN SUPPRESSOR OF PHYTOCHROME B 5', 240682),
(314401, 'PTHR33347:SF62', NULL, NULL, NULL, NULL, '', 240682),
(314402, 'PTHR33347:SF61', NULL, NULL, NULL, NULL, '', 240682),
(314403, 'PTHR33347:SF44', NULL, NULL, NULL, NULL, 'BNAUNNG01670D PROTEIN', 240682),
(314404, 'PTHR33347:SF22', NULL, NULL, NULL, NULL, '', 240682),
(314405, 'PTHR33347:SF21', NULL, NULL, NULL, NULL, '', 240682),
(314406, 'PTHR33347:SF60', NULL, NULL, NULL, NULL, '', 240682),
(314407, 'PTHR33347:SF39', NULL, NULL, NULL, NULL, 'PROTEIN SOB FIVE-LIKE 2', 240682),
(314408, 'PTHR33347:SF17', NULL, NULL, NULL, NULL, 'BNACNNG48440D PROTEIN', 240682),
(314409, 'PTHR33347:SF38', NULL, NULL, NULL, NULL, '', 240682),
(314410, 'PTHR33347:SF59', NULL, NULL, NULL, NULL, '', 240682),
(314411, 'PTHR33347:SF58', NULL, NULL, NULL, NULL, 'OS09G0473600 PROTEIN', 240682),
(314412, 'PTHR33347:SF31', NULL, NULL, NULL, NULL, 'PROTEIN SOB FIVE-LIKE 1', 240682),
(314413, 'PTHR33347:SF53', NULL, NULL, NULL, NULL, 'RCG54054', 240682),
(314414, 'PTHR33347:SF51', NULL, NULL, NULL, NULL, '', 240682),
(314415, 'PTHR33347:SF35', NULL, NULL, NULL, NULL, 'BNAA02G14060D PROTEIN', 240682),
(314416, 'PTHR33347:SF57', NULL, NULL, NULL, NULL, '', 240682),
(314417, 'PTHR33347:SF34', NULL, NULL, NULL, NULL, 'PROTEIN SOB FIVE-LIKE 6', 240682),
(314418, 'PTHR33347:SF56', NULL, NULL, NULL, NULL, 'OS03G0199500 PROTEIN', 240682),
(314419, 'PTHR33347:SF55', NULL, NULL, NULL, NULL, '', 240682),
(314420, 'PTHR19855', NULL, NULL, NULL, NULL, 'WD40 REPEAT PROTEIN 12, 37', 240683),
(314421, 'PTHR19855:SF24', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN', 240683),
(314422, 'PTHR19855:SF35', NULL, NULL, NULL, NULL, 'F-BOX AND WD40 DOMAIN PROTEIN', 240683),
(314423, 'PTHR19855:SF34', NULL, NULL, NULL, NULL, 'F-BOX/WD REPEAT-CONTAINING PROTEIN 9', 240683),
(314424, 'PTHR19855:SF12', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 37', 240683),
(314425, 'PTHR19855:SF37', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 240683),
(314426, 'PTHR19855:SF36', NULL, NULL, NULL, NULL, 'F-BOX/WD REPEAT-CONTAINING PROTEIN A-LIKE PROTEIN', 240683),
(314427, 'PTHR19855:SF25', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 240683),
(314428, 'PTHR19855:SF31', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR STERILE APETALA', 240683),
(314429, 'PTHR19855:SF33', NULL, NULL, NULL, NULL, 'F-BOX/WD REPEAT-CONTAINING PROTEIN MEC-15', 240683),
(314430, 'PTHR19855:SF11', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS PROTEIN WDR12', 240683),
(314431, 'PTHR19855:SF21', NULL, NULL, NULL, NULL, '', 240683),
(314432, 'PTHR19855:SF28', NULL, NULL, NULL, NULL, 'CCR4-ASSOCIATED FACTOR 4', 240683),
(314433, 'PTHR19855:SF16', NULL, NULL, NULL, NULL, 'F-BOX AND WD REPEAT DOMAIN-CONTAINING 8', 240683),
(314434, 'PTHR19855:SF38', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR STERILE APETALA-LIKE', 240683),
(314435, 'PTHR19855:SF19', NULL, NULL, NULL, NULL, 'F-BOX AND WD-40 PROTEIN', 240683),
(314436, 'PTHR43877:SF2', NULL, NULL, NULL, NULL, 'AMINOALKYLPHOSPHONATE N-ACETYLTRANSFERASE-RELATED', 240684),
(314437, 'PTHR43877:SF5', NULL, NULL, NULL, NULL, 'BLR1117 PROTEIN', 240684),
(314438, 'PTHR43877', NULL, NULL, NULL, NULL, '', 240684),
(314439, 'PTHR43877:SF7', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE', 240684),
(314440, 'PTHR43877:SF6', NULL, NULL, NULL, NULL, 'GCN5-RELATED N-ACETYLTRANSFERASE', 240684),
(314441, 'PTHR43877:SF8', NULL, NULL, NULL, NULL, 'GCN5-RELATED N-ACETYLTRANSFERASE', 240684),
(314442, 'PTHR43877:SF1', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 240684);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(314443, 'PTHR42923:SF3', NULL, NULL, NULL, NULL, 'PROTOPORPHYRINOGEN OXIDASE', 240685),
(314444, 'PTHR42923:SF39', NULL, NULL, NULL, NULL, 'AMINO OXIDASE-RELATED', 240685),
(314445, 'PTHR42923:SF17', NULL, NULL, NULL, NULL, 'AMINO_OXIDASE DOMAIN-CONTAINING PROTEIN', 240685),
(314446, 'PTHR42923:SF38', NULL, NULL, NULL, NULL, 'PHYTOENE DEHYDROGENASE', 240685),
(314447, 'PTHR42923:SF26', NULL, NULL, NULL, NULL, 'FMN REDUCTASE LOT6, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G06600)-RELATED', 240685),
(314448, 'PTHR42923:SF24', NULL, NULL, NULL, NULL, 'OS04G0560500 PROTEIN', 240685),
(314449, 'PTHR42923:SF34', NULL, NULL, NULL, NULL, 'AMINO_OXIDASE DOMAIN-CONTAINING PROTEIN', 240685),
(314450, 'PTHR42923', NULL, NULL, NULL, NULL, 'PROTOPORPHYRINOGEN OXIDASE', 240685),
(314451, 'PTHR42923:SF33', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 240685),
(314452, 'PTHR42923:SF42', NULL, NULL, NULL, NULL, 'AMINO_OXIDASE DOMAIN-CONTAINING PROTEIN', 240685),
(314453, 'PTHR42923:SF20', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING AMINE OXIDASEDEHYDROGENASE', 240685),
(314454, 'PTHR42923:SF41', NULL, NULL, NULL, NULL, '15-CIS-PHYTOENE DESATURASE, CHLOROPLASTIC/CHROMOPLASTIC-RELATED', 240685),
(314455, 'PTHR42923:SF40', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC HISTONE DEMETHYLASE 2', 240685),
(314456, 'PTHR16026:SF4', NULL, NULL, NULL, NULL, 'CARTILAGE ACIDIC PROTEIN 1B', 240686),
(314457, 'PTHR16026:SF1', NULL, NULL, NULL, NULL, 'CARTILAGE ACIDIC PROTEIN 1A', 240686),
(314458, 'PTHR16026:SF0', NULL, NULL, NULL, NULL, 'CARTILAGE ACIDIC PROTEIN 1', 240686),
(314459, 'PTHR16026', NULL, NULL, NULL, NULL, 'CARTILAGE ACIDIC PROTEIN 1', 240686),
(314460, 'PTHR31203', NULL, NULL, NULL, NULL, 'BETA-KERATIN-RELATED PROTEIN-RELATED', 240687),
(314461, 'PTHR31203:SF1', NULL, NULL, NULL, NULL, 'BETA-KERATIN-RELATED PROTEIN-RELATED', 240687),
(314462, 'PTHR19343:SF20', NULL, NULL, NULL, NULL, 'T-CELL RECEPTOR ALPHA CHAIN V REGION 2B4', 240688),
(314463, 'PTHR19343:SF0', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 23/DELTA VARIABLE 6', 240688),
(314464, 'PTHR19343:SF5', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 7-6', 240688),
(314465, 'PTHR19343:SF7', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 240688),
(314466, 'PTHR19343:SF2', NULL, NULL, NULL, NULL, 'T-CELL RECEPTOR BETA CHAIN V REGION E1', 240688),
(314467, 'PTHR19343:SF18', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 12-1', 240688),
(314468, 'PTHR19343:SF3', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 12-2', 240688),
(314469, 'PTHR19343:SF17', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 240688),
(314470, 'PTHR19343:SF15', NULL, NULL, NULL, NULL, 'IGV DOMAIN-CONTAINING PROTEIN', 240688),
(314471, 'PTHR19343:SF14', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 240688),
(314472, 'PTHR19343:SF24', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 29/DELTA VARIABLE 5', 240688),
(314473, 'PTHR19343', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 1-2', 240688),
(314474, 'PTHR19343:SF13', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 21', 240688),
(314475, 'PTHR19343:SF9', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 240688),
(314476, 'PTHR19343:SF23', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 1-2', 240688),
(314477, 'PTHR19343:SF12', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 12-3', 240688),
(314478, 'PTHR19343:SF21', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 240688),
(314479, 'PTHR24185', NULL, NULL, NULL, NULL, 'CALCIUM-INDEPENDENT PHOSPHOLIPASE A2-GAMMA', 240689),
(314480, 'PTHR24185:SF3', NULL, NULL, NULL, NULL, 'PATATIN DOMAIN-CONTAINING PROTEIN', 240689),
(314481, 'PTHR24185:SF4', NULL, NULL, NULL, NULL, 'SERINE HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G07870)-RELATED', 240689),
(314482, 'PTHR24185:SF1', NULL, NULL, NULL, NULL, 'CALCIUM-INDEPENDENT PHOSPHOLIPASE A2-GAMMA', 240689),
(314483, 'PTHR24185:SF2', NULL, NULL, NULL, NULL, 'PNPLA DOMAIN-CONTAINING PROTEIN', 240689),
(314484, 'PTHR24185:SF7', NULL, NULL, NULL, NULL, 'PATATIN FAMILY PROTEIN', 240689);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(314485, 'PTHR24185:SF8', NULL, NULL, NULL, NULL, 'PNPLA DOMAIN-CONTAINING PROTEIN', 240689),
(314486, 'PTHR10877:SF136', NULL, NULL, NULL, NULL, 'POLYCYSTIC KIDNEY DISEASE PROTEIN 1-LIKE 3', 240690),
(314487, 'PTHR10877:SF114', NULL, NULL, NULL, NULL, 'POLYCYSTIN-2', 240690),
(314488, 'PTHR10877:SF145', NULL, NULL, NULL, NULL, 'POLYCYSTIC KIDNEY DISEASE PROTEIN 1-LIKE 1', 240690),
(314489, 'PTHR10877:SF134', NULL, NULL, NULL, NULL, 'POLYCYSTIC KIDNEY DISEASE PROTEIN 1-LIKE 2', 240690),
(314490, 'PTHR10877:SF185', NULL, NULL, NULL, NULL, 'POLYCYSTIC KIDNEY DISEASE AND RECEPTOR FOR EGG JELLY-RELATED PROTEIN', 240690),
(314491, 'PTHR10877:SF150', NULL, NULL, NULL, NULL, 'RECEPTOR FOR EGG JELLY 6', 240690),
(314492, 'PTHR10877:SF183', NULL, NULL, NULL, NULL, 'POLYCYSTIC KIDNEY DISEASE 2-LIKE 1 PROTEIN', 240690),
(314493, 'PTHR10877:SF47', NULL, NULL, NULL, NULL, 'POLYCYSTIC KIDNEY DISEASE 2-LIKE 2 PROTEIN', 240690),
(314494, 'PTHR10877:SF192', NULL, NULL, NULL, NULL, 'PKD_CHANNEL DOMAIN-CONTAINING PROTEIN', 240690),
(314495, 'PTHR10877', NULL, NULL, NULL, NULL, 'POLYCYSTIN FAMILY MEMBER', 240690),
(314496, 'PTHR10877:SF193', NULL, NULL, NULL, NULL, 'LOCATION OF VULVA DEFECTIVE 1', 240690),
(314497, 'PTHR10877:SF190', NULL, NULL, NULL, NULL, '', 240690),
(314498, 'PTHR10877:SF191', NULL, NULL, NULL, NULL, 'CA2+-MODULATED NONSELECTIVE CATION CHANNEL POLYCYSTIN', 240690),
(314499, 'PTHR28136:SF1', NULL, NULL, NULL, NULL, 'NUCLEUS EXPORT PROTEIN BRR6', 240691),
(314500, 'PTHR28136:SF4', NULL, NULL, NULL, NULL, 'NUCLEUS EXPORT PROTEIN BRL1', 240691),
(314501, 'PTHR28136', NULL, NULL, NULL, NULL, 'NUCLEUS EXPORT PROTEIN BRR6', 240691),
(314502, 'PTHR43253', NULL, NULL, NULL, NULL, 'TRICORN PROTEASE HOMOLOG 2-RELATED', 240692),
(314503, 'PTHR43253:SF1', NULL, NULL, NULL, NULL, 'TRICORN PROTEASE HOMOLOG 2-RELATED', 240692),
(314504, 'PTHR45836:SF3', NULL, NULL, NULL, NULL, 'SLIT HOMOLOG 1 PROTEIN', 240693),
(314505, 'PTHR45836:SF4', NULL, NULL, NULL, NULL, 'PROTEIN SLIT', 240693),
(314506, 'PTHR45836:SF1', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN 1', 240693),
(314507, 'PTHR45836:SF2', NULL, NULL, NULL, NULL, 'SLIT HOMOLOG 2 PROTEIN', 240693),
(314508, 'PTHR45836:SF8', NULL, NULL, NULL, NULL, 'TOLL-LIKE RECEPTOR 6', 240693),
(314509, 'PTHR45836', NULL, NULL, NULL, NULL, 'SLIT HOMOLOG', 240693),
(314510, 'PTHR45836:SF6', NULL, NULL, NULL, NULL, 'RETICULON-4 RECEPTOR', 240693),
(314511, 'PTHR45836:SF9', NULL, NULL, NULL, NULL, 'SLIT HOMOLOG 3 PROTEIN', 240693),
(314512, 'PTHR45836:SF19', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR-BINDING PROTEIN COMPLEX ACID LABILE SUBUNIT', 240693),
(314513, 'PTHR45836:SF21', NULL, NULL, NULL, NULL, 'PROTEIN DELTA HOMOLOG 2', 240693),
(314514, 'PTHR45836:SF10', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING G-PROTEIN COUPLED RECEPTOR 4', 240693),
(314515, 'PTHR45836:SF22', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING G-PROTEIN COUPLED RECEPTOR 6', 240693),
(314516, 'PTHR45836:SF11', NULL, NULL, NULL, NULL, 'RETICULON-4 RECEPTOR-LIKE 1', 240693),
(314517, 'PTHR45836:SF12', NULL, NULL, NULL, NULL, 'NEUROGENIC LOCUS NOTCH HOMOLOG PROTEIN 1', 240693),
(314518, 'PTHR45836:SF13', NULL, NULL, NULL, NULL, 'NOTCH GENE HOMOLOG 1', 240693),
(314519, 'PTHR45836:SF15', NULL, NULL, NULL, NULL, 'NEUROGENIC LOCUS NOTCH HOMOLOG PROTEIN 2', 240693),
(314520, 'PTHR45836:SF16', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN 2', 240693),
(314521, 'PTHR45836:SF17', NULL, NULL, NULL, NULL, 'NEUROGENIC LOCUS NOTCH HOMOLOG PROTEIN 3', 240693),
(314522, 'PTHR13103:SF3', NULL, NULL, NULL, NULL, 'SCHWANNOMIN-INTERACTING PROTEIN 1', 240694),
(314523, 'PTHR13103:SF4', NULL, NULL, NULL, NULL, 'SI:DKEY-6N21.12-RELATED', 240694),
(314524, 'PTHR13103:SF2', NULL, NULL, NULL, NULL, 'IQCJ-SCHIP1 READTHROUGH TRANSCRIPT PROTEIN-RELATED', 240694),
(314525, 'PTHR13103', NULL, NULL, NULL, NULL, 'SCHWANNOMIN INTERACTING PROTEIN 1', 240694),
(314526, 'PTHR46796:SF2', NULL, NULL, NULL, NULL, 'ARAC-FAMILY TRANSCRIPTIONAL REGULATOR-RELATED', 240695);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(314527, 'PTHR46796:SF7', NULL, NULL, NULL, NULL, 'ARAC-FAMILY TRANSCRIPTIONAL REGULATOR-RELATED', 240695),
(314528, 'PTHR46796:SF6', NULL, NULL, NULL, NULL, 'ARAC SUBFAMILY', 240695),
(314529, 'PTHR46796:SF10', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR FEAR', 240695),
(314530, 'PTHR46796:SF11', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL ACTIVATOR RHAS', 240695),
(314531, 'PTHR46796:SF12', NULL, NULL, NULL, NULL, 'HTH-TYPE DNA-BINDING TRANSCRIPTIONAL ACTIVATOR EUTR', 240695),
(314532, 'PTHR46796', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL ACTIVATOR RHAS-RELATED', 240695),
(314533, 'PTHR38820', NULL, NULL, NULL, NULL, 'ANNEXIN-2 RECEPTOR', 240696),
(314534, 'PTHR38820:SF1', NULL, NULL, NULL, NULL, 'ANNEXIN-2 RECEPTOR', 240696),
(314535, 'PTHR42855:SF1', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER', 240697),
(314536, 'PTHR42855:SF2', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN-RELATED', 240697),
(314537, 'PTHR42855', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING SUBUNIT', 240697),
(314538, 'PTHR46605', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR', 240698),
(314539, 'PTHR46605:SF1', NULL, NULL, NULL, NULL, 'DEATH DOMAIN-CONTAINING MEMBRANE PROTEIN NRADD', 240698),
(314540, 'PTHR46605:SF5', NULL, NULL, NULL, NULL, 'NERVE GROWTH FACTOR RECEPTOR B', 240698),
(314541, 'PTHR46605:SF2', NULL, NULL, NULL, NULL, '', 240698),
(314542, 'PTHR46605:SF3', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 16', 240698),
(314543, 'PTHR36864:SF1', NULL, NULL, NULL, NULL, 'CANCER-ASSOCIATED GENE 1 PROTEIN', 240699),
(314544, 'PTHR36864', NULL, NULL, NULL, NULL, 'CANCER-ASSOCIATED GENE 1 PROTEIN', 240699),
(314545, 'PTHR28599:SF1', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 12', 240700),
(314546, 'PTHR28599:SF3', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 12', 240700),
(314547, 'PTHR28599:SF2', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 12', 240700),
(314548, 'PTHR28599', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 12', 240700),
(314549, 'PTHR10093', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER ASSEMBLY ENZYME  NIFU HOMOLOG', 240701),
(314550, 'PTHR10093:SF24', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER ASSEMBLY PROTEIN', 240701),
(314551, 'PTHR10093:SF12', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER ASSEMBLY PROTEIN 3', 240701),
(314552, 'PTHR10093:SF29', NULL, NULL, NULL, NULL, 'NIFU_N DOMAIN-CONTAINING PROTEIN', 240701),
(314553, 'PTHR10093:SF28', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER ASSEMBLY PROTEIN 1', 240701),
(314554, 'PTHR10093:SF15', NULL, NULL, NULL, NULL, 'NIFU_N DOMAIN-CONTAINING PROTEIN', 240701),
(314555, 'PTHR10093:SF26', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER ASSEMBLY ENZYME ISCU, MITOCHONDRIAL', 240701),
(314556, 'PTHR10093:SF8', NULL, NULL, NULL, NULL, 'NIFU_N DOMAIN-CONTAINING PROTEIN', 240701),
(314557, 'PTHR10093:SF20', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER ASSEMBLY PROTEIN', 240701),
(314558, 'PTHR10093:SF30', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER ASSEMBLY PROTEIN', 240701),
(314559, 'PTHR38626', NULL, NULL, NULL, NULL, 'SKN-1 DEPENDENT ZYGOTIC TRANSCRIPT-RELATED', 240702),
(314560, 'PTHR38626:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG09928', 240702),
(314561, 'PTHR38626:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG18294', 240702),
(314562, 'PTHR38626:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG09935', 240702),
(314563, 'PTHR38626:SF4', NULL, NULL, NULL, NULL, 'SKN-1 DEPENDENT ZYGOTIC TRANSCRIPT', 240702),
(314564, 'PTHR36734:SF1', NULL, NULL, NULL, NULL, 'YCF37-LIKE PROTEIN', 240703),
(314565, 'PTHR36734', NULL, NULL, NULL, NULL, 'YCF37-LIKE PROTEIN', 240703),
(314566, 'PTHR20967', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 240704),
(314567, 'PTHR20967:SF0', NULL, NULL, NULL, NULL, 'BRAIN PEPTIDE IDL-LIKE PROTEIN', 240704),
(314568, 'PTHR33099', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 240705),
(314569, 'PTHR33099:SF11', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 240705);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(314570, 'PTHR33099:SF13', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 240705),
(314571, 'PTHR33099:SF7', NULL, NULL, NULL, NULL, 'MYND-TYPE DOMAIN-CONTAINING PROTEIN', 240705),
(314572, 'PTHR33099:SF14', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 240705),
(314573, 'PTHR45629:SF11', NULL, NULL, NULL, NULL, 'OS01G0636700 PROTEIN', 240706),
(314574, 'PTHR45629:SF9', NULL, NULL, NULL, NULL, 'THYMINE DIOXYGENASE JBP1', 240706),
(314575, 'PTHR45629:SF7', NULL, NULL, NULL, NULL, 'DNA EXCISION REPAIR PROTEIN ERCC-6-RELATED', 240706),
(314576, 'PTHR45629', NULL, NULL, NULL, NULL, 'SNF2/RAD54 FAMILY MEMBER', 240706),
(314577, 'PTHR44269:SF2', NULL, NULL, NULL, NULL, 'IP05441P', 240707),
(314578, 'PTHR44269:SF3', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE SDR FAMILY MEMBER 7', 240707),
(314579, 'PTHR44269:SF4', NULL, NULL, NULL, NULL, 'GENE 4756-RELATED', 240707),
(314580, 'PTHR44269', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE SDR FAMILY MEMBER 7-RELATED', 240707),
(314581, 'PTHR44269:SF1', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE SDR FAMILY MEMBER 7', 240707),
(314582, 'PTHR41287', NULL, NULL, NULL, NULL, '', 240708),
(314583, 'PTHR41287:SF1', NULL, NULL, NULL, NULL, 'PROTEIN YMFN', 240708),
(314584, 'PTHR22572:SF158', NULL, NULL, NULL, NULL, 'NTP_TRANSFERASE DOMAIN-CONTAINING PROTEIN', 240709),
(314585, 'PTHR22572:SF146', NULL, NULL, NULL, NULL, 'ADP-GLUCOSE PYROPHOSPHORYLASE FAMILY PROTEIN', 240709),
(314586, 'PTHR22572:SF137', NULL, NULL, NULL, NULL, 'UTP--GLUCOSE-1-PHOSPHATE URIDYLYLTRANSFERASE', 240709),
(314587, 'PTHR22572:SF159', NULL, NULL, NULL, NULL, 'D-ALPHA-D-MANNOSE-1-PHOSPHATE GUANYLYLTRANSFERASE MANB (D-ALPHA-D-HEPTOSE-1-PHOSPHATE GUANYLYLTRANSFERASE)', 240709),
(314588, 'PTHR22572:SF104', NULL, NULL, NULL, NULL, 'MANNOSE-1-PHOSPHATE GUANYLTRANSFERASE ALPHA', 240709),
(314589, 'PTHR22572:SF161', NULL, NULL, NULL, NULL, 'MANNOSE-1-PHOSPHATE GUANYLYLTRANSFERASE 2-RELATED', 240709),
(314590, 'PTHR22572', NULL, NULL, NULL, NULL, 'SUGAR-1-PHOSPHATE GUANYL TRANSFERASE', 240709),
(314591, 'PTHR22572:SF160', NULL, NULL, NULL, NULL, 'SUGAR PHOSPHATE NUCLEOTYDYL TRANSFERASE', 240709),
(314592, 'PTHR22572:SF152', NULL, NULL, NULL, NULL, 'NTP_TRANSFERASE DOMAIN-CONTAINING PROTEIN', 240709),
(314593, 'PTHR22572:SF141', NULL, NULL, NULL, NULL, 'MANNOSE-1-PHOSPHATE GUANYLYLTRANSFERASE 3-RELATED', 240709),
(314594, 'PTHR22572:SF154', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-DIPHOSPHO-SUGAR TRANSFERASE-RELATED', 240709),
(314595, 'PTHR22572:SF145', NULL, NULL, NULL, NULL, 'MANNOSE-1-PHOSPHATE GUANYLYLTRANSFERASE 1', 240709),
(314596, 'PTHR22572:SF156', NULL, NULL, NULL, NULL, 'SUGAR-PHOSPHATE NUCLEOTYDYLTRANSFERASE', 240709),
(314597, 'PTHR22572:SF15', NULL, NULL, NULL, NULL, 'MANNOSE-1-PHOSPHATE GUANYLTRANSFERASE BETA', 240709),
(314598, 'PTHR13041', NULL, NULL, NULL, NULL, 'JTB PROTEIN-RELATED', 240710),
(314599, 'PTHR13041:SF3', NULL, NULL, NULL, NULL, 'PROTEIN JTB', 240710),
(314600, 'PTHR12761:SF1', NULL, NULL, NULL, NULL, 'HERMANSKY-PUDLAK SYNDROME 1 PROTEIN', 240711),
(314601, 'PTHR12761', NULL, NULL, NULL, NULL, 'HERMANSKY-PUDLAK SYNDROME PROTEIN 1', 240711),
(314602, 'PTHR34258:SF1', NULL, NULL, NULL, NULL, 'ARMADILLO-LIKE HELICAL DOMAIN CONTAINING PROTEIN 1', 240712),
(314603, 'PTHR34258', NULL, NULL, NULL, NULL, 'ARMADILLO-LIKE HELICAL DOMAIN CONTAINING PROTEIN 1', 240712),
(314604, 'PTHR24012:SF719', NULL, NULL, NULL, NULL, 'RNA BINDING MOTIF PROTEIN 19', 240713),
(314605, 'PTHR24012:SF717', NULL, NULL, NULL, NULL, 'U4/U6 SNRNA-ASSOCIATED-SPLICING FACTOR PRP24', 240713),
(314606, 'PTHR24012:SF838', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN', 240713),
(314607, 'PTHR24012:SF716', NULL, NULL, NULL, NULL, 'CUGBP ELAV-LIKE FAMILY MEMBER 6', 240713),
(314608, 'PTHR24012:SF759', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN 6', 240713),
(314609, 'PTHR24012:SF879', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN', 240713),
(314610, 'PTHR24012:SF878', NULL, NULL, NULL, NULL, 'PROTEIN PES4-RELATED', 240713);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(314611, 'PTHR24012:SF834', NULL, NULL, NULL, NULL, 'CHROMOSOME 8, WHOLE GENOME SHOTGUN SEQUENCE', 240713),
(314612, 'PTHR24012:SF712', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN', 240713),
(314613, 'PTHR24012:SF877', NULL, NULL, NULL, NULL, 'BRUNO 1, ISOFORM B-RELATED', 240713),
(314614, 'PTHR24012:SF832', NULL, NULL, NULL, NULL, 'BNAC09G00470D PROTEIN', 240713),
(314615, 'PTHR24012:SF876', NULL, NULL, NULL, NULL, 'OS04G0682400 PROTEIN', 240713),
(314616, 'PTHR24012:SF677', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN', 240713),
(314617, 'PTHR24012:SF875', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN 1-A', 240713),
(314618, 'PTHR24012:SF753', NULL, NULL, NULL, NULL, 'RNA-BINDING POST-TRANSCRIPTIONAL REGULATOR CSX1', 240713),
(314619, 'PTHR24012:SF874', NULL, NULL, NULL, NULL, 'MEI2 C-TERMINAL RRM ONLY LIKE 2', 240713),
(314620, 'PTHR24012:SF796', NULL, NULL, NULL, NULL, 'PROTEIN ALAN SHEPARD', 240713),
(314621, 'PTHR24012:SF873', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN', 240713),
(314622, 'PTHR24012:SF675', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN', 240713),
(314623, 'PTHR24012:SF751', NULL, NULL, NULL, NULL, 'MULTIPLE RNA-BINDING DOMAIN-CONTAINING PROTEIN 1', 240713),
(314624, 'PTHR24012:SF790', NULL, NULL, NULL, NULL, 'TERMINAL EAR1-LIKE 1', 240713),
(314625, 'PTHR24012:SF909', NULL, NULL, NULL, NULL, 'F12A21.10', 240713),
(314626, 'PTHR24012:SF908', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 240713),
(314627, 'PTHR24012:SF907', NULL, NULL, NULL, NULL, 'U2 SNRNP COMPLEX SUBUNIT', 240713),
(314628, 'PTHR24012:SF906', NULL, NULL, NULL, NULL, 'RNA-BINDING MOTIF, SINGLE-STRANDED-INTERACTING PROTEIN 1', 240713),
(314629, 'PTHR24012:SF829', NULL, NULL, NULL, NULL, 'RRM_2 DOMAIN-CONTAINING PROTEIN', 240713),
(314630, 'PTHR24012:SF905', NULL, NULL, NULL, NULL, 'FLOWERING TIME CONTROL PROTEIN FCA-LIKE ISOFORM X1', 240713),
(314631, 'PTHR24012:SF904', NULL, NULL, NULL, NULL, '', 240713),
(314632, 'PTHR24012:SF903', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 240713),
(314633, 'PTHR24012:SF826', NULL, NULL, NULL, NULL, '', 240713),
(314634, 'PTHR24012:SF902', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN', 240713),
(314635, 'PTHR24012:SF868', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 240713),
(314636, 'PTHR24012:SF901', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 240713),
(314637, 'PTHR24012:SF702', NULL, NULL, NULL, NULL, 'RNA-BINDING MOTIF, SINGLE-STRANDED-INTERACTING PROTEIN 1', 240713),
(314638, 'PTHR24012:SF900', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE-RELATED', 240713),
(314639, 'PTHR24012:SF745', NULL, NULL, NULL, NULL, '', 240713),
(314640, 'PTHR24012:SF866', NULL, NULL, NULL, NULL, 'OS05G0373400 PROTEIN', 240713),
(314641, 'PTHR24012:SF744', NULL, NULL, NULL, NULL, 'OS12G0136200 PROTEIN', 240713),
(314642, 'PTHR24012:SF820', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN', 240713),
(314643, 'PTHR24012:SF786', NULL, NULL, NULL, NULL, 'RNA-BINDING MOTIF, SINGLE-STRANDED-INTERACTING PROTEIN 2', 240713),
(314644, 'PTHR24012:SF742', NULL, NULL, NULL, NULL, 'RNA-BINDING MOTIF, SINGLE-STRANDED-INTERACTING PROTEIN 3', 240713),
(314645, 'PTHR24012:SF466', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN 1-LIKE', 240713),
(314646, 'PTHR24012:SF860', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN 1-B', 240713),
(314647, 'PTHR24012:SF818', NULL, NULL, NULL, NULL, 'BNACNNG43140D PROTEIN', 240713),
(314648, 'PTHR24012', NULL, NULL, NULL, NULL, 'RNA BINDING PROTEIN', 240713),
(314649, 'PTHR24012:SF817', NULL, NULL, NULL, NULL, '', 240713),
(314650, 'PTHR24012:SF739', NULL, NULL, NULL, NULL, 'CUGBP ELAV-LIKE FAMILY MEMBER 3', 240713),
(314651, 'PTHR24012:SF812', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 45', 240713),
(314652, 'PTHR24012:SF899', NULL, NULL, NULL, NULL, 'LD36772P-RELATED', 240713),
(314653, 'PTHR24012:SF733', NULL, NULL, NULL, NULL, 'TIA1 CYTOTOXIC GRANULE ASSOCIATED RNA BINDING PROTEIN LIKE 1', 240713),
(314654, 'PTHR24012:SF898', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN', 240713);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(314655, 'PTHR24012:SF897', NULL, NULL, NULL, NULL, 'RNA-BINDING MOTIF PROTEIN 42', 240713),
(314656, 'PTHR24012:SF699', NULL, NULL, NULL, NULL, 'CUGBP ELAV-LIKE FAMILY MEMBER 2', 240713),
(314657, 'PTHR24012:SF776', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN 4-LIKE', 240713),
(314658, 'PTHR24012:SF698', NULL, NULL, NULL, NULL, 'FLOWERING TIME CONTROL FCA-LIKE PROTEIN', 240713),
(314659, 'PTHR24012:SF896', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN 8', 240713),
(314660, 'PTHR24012:SF852', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN', 240713),
(314661, 'PTHR24012:SF455', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN 7', 240713),
(314662, 'PTHR24012:SF895', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN', 240713),
(314663, 'PTHR24012:SF894', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN', 240713),
(314664, 'PTHR24012:SF893', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN 2', 240713),
(314665, 'PTHR24012:SF695', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 240713),
(314666, 'PTHR24012:SF892', NULL, NULL, NULL, NULL, 'RRM_2 DOMAIN-CONTAINING PROTEIN', 240713),
(314667, 'PTHR24012:SF891', NULL, NULL, NULL, NULL, 'RNA BINDING PROTEIN RNP-RELATED', 240713),
(314668, 'PTHR24012:SF692', NULL, NULL, NULL, NULL, 'TIA1 CYTOTOXIC GRANULE ASSOCIATED RNA BINDING PROTEIN', 240713),
(314669, 'PTHR24012:SF890', NULL, NULL, NULL, NULL, 'PROTEIN MEI2-LIKE 7', 240713),
(314670, 'PTHR24012:SF690', NULL, NULL, NULL, NULL, 'BRUNO 3, ISOFORM Q', 240713),
(314671, 'PTHR24012:SF491', NULL, NULL, NULL, NULL, 'RNP (RRM RNA BINDING DOMAIN) CONTAINING', 240713),
(314672, 'PTHR24012:SF809', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 240713),
(314673, 'PTHR24012:SF728', NULL, NULL, NULL, NULL, 'CUGBP ELAV-LIKE FAMILY MEMBER 5', 240713),
(314674, 'PTHR24012:SF409', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN 1', 240713),
(314675, 'PTHR24012:SF804', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN BRN1-LIKE', 240713),
(314676, 'PTHR24012:SF848', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN 1-LIKE 2', 240713),
(314677, 'PTHR24012:SF803', NULL, NULL, NULL, NULL, 'MEI2 C-TERMINAL RRM ONLY LIKE 1', 240713),
(314678, 'PTHR24012:SF889', NULL, NULL, NULL, NULL, 'RNA RECOGNITION MOTIF DOMAIN CONTAINING PROTEIN', 240713),
(314679, 'PTHR24012:SF888', NULL, NULL, NULL, NULL, 'PLASTID-SPECIFIC 30S RIBOSOMAL PROTEIN 2', 240713),
(314680, 'PTHR24012:SF767', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN', 240713),
(314681, 'PTHR24012:SF843', NULL, NULL, NULL, NULL, 'CUGBP ELAV-LIKE FAMILY MEMBER 3', 240713),
(314682, 'PTHR24012:SF887', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN 1', 240713),
(314683, 'PTHR24012:SF886', NULL, NULL, NULL, NULL, 'EMBRYONIC DEVELOPMENTAL PROTEIN TOFU-6', 240713),
(314684, 'PTHR24012:SF721', NULL, NULL, NULL, NULL, 'CUGBP ELAV-LIKE FAMILY MEMBER 4', 240713),
(314685, 'PTHR24012:SF842', NULL, NULL, NULL, NULL, 'FLOWERING TIME CONTROL PROTEIN FCA', 240713),
(314686, 'PTHR24012:SF885', NULL, NULL, NULL, NULL, 'EG:132E8.1 PROTEIN-RELATED', 240713),
(314687, 'PTHR24012:SF841', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN', 240713),
(314688, 'PTHR24012:SF686', NULL, NULL, NULL, NULL, 'CUGBP ELAV-LIKE FAMILY MEMBER 1', 240713),
(314689, 'PTHR24012:SF884', NULL, NULL, NULL, NULL, 'MEI2 C-TERMINAL RRM ONLY LIKE 1', 240713),
(314690, 'PTHR24012:SF883', NULL, NULL, NULL, NULL, 'RBM-28', 240713),
(314691, 'PTHR24012:SF882', NULL, NULL, NULL, NULL, 'RNA RECOGNITION MOTIF 2, NUCLEOTIDE-BINDING ALPHA-BETA PLAIT DOMAIN PROTEIN-RELATED', 240713),
(314692, 'PTHR24012:SF365', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN 4', 240713),
(314693, 'PTHR24012:SF881', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN 5', 240713),
(314694, 'PTHR24012:SF760', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN 4', 240713),
(314695, 'PTHR24012:SF682', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN 5', 240713),
(314696, 'PTHR24012:SF880', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN', 240713);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(314697, 'PTHR24012:SF680', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN 3', 240713),
(314698, 'PTHR31887:SF1', NULL, NULL, NULL, NULL, 'NEMATODE SPECIFIC PEPTIDE FAMILY, GROUP B', 240714),
(314699, 'PTHR31887', NULL, NULL, NULL, NULL, 'NEMATODE SPECIFIC PEPTIDE FAMILY, GROUP B', 240714),
(314700, 'PTHR10161:SF50', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE 7', 240715),
(314701, 'PTHR10161:SF40', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE 4', 240715),
(314702, 'PTHR10161:SF51', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 240715),
(314703, 'PTHR10161:SF52', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE', 240715),
(314704, 'PTHR10161', NULL, NULL, NULL, NULL, 'TARTRATE-RESISTANT ACID PHOSPHATASE TYPE 5', 240715),
(314705, 'PTHR10161:SF44', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 240715),
(314706, 'PTHR10161:SF55', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 240715),
(314707, 'PTHR10161:SF34', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE 3', 240715),
(314708, 'PTHR10161:SF56', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE 3', 240715),
(314709, 'PTHR10161:SF57', NULL, NULL, NULL, NULL, 'PROTEIN WITH METALLOPHOSPHATASE DOMAIN', 240715),
(314710, 'PTHR10161:SF46', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 240715),
(314711, 'PTHR10161:SF14', NULL, NULL, NULL, NULL, 'TARTRATE-RESISTANT ACID PHOSPHATASE TYPE 5', 240715),
(314712, 'PTHR10161:SF36', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 240715),
(314713, 'PTHR10161:SF58', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 240715),
(314714, 'PTHR10161:SF48', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 240715),
(314715, 'PTHR10161:SF49', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE 8', 240715),
(314716, 'PTHR10161:SF38', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 240715),
(314717, 'PTHR10161:SF28', NULL, NULL, NULL, NULL, 'TARTRATE-RESISTANT ACID PHOSPHATASE TYPE 5', 240715),
(314718, 'PTHR10161:SF29', NULL, NULL, NULL, NULL, 'TARTRATE-RESISTANT ACID PHOSPHATASE TYPE 5', 240715),
(314719, 'PTHR10161:SF19', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 240715),
(314720, 'PTHR31143:SF2', NULL, NULL, NULL, NULL, 'FR47 DOMAIN-CONTAINING PROTEIN', 240716),
(314721, 'PTHR31143', NULL, NULL, NULL, NULL, '', 240716),
(314722, 'PTHR12439:SF39', NULL, NULL, NULL, NULL, 'POLY(U)-SPECIFIC ENDORIBONUCLEASE', 240717),
(314723, 'PTHR12439', NULL, NULL, NULL, NULL, 'PLACENTAL PROTEIN 11-RELATED', 240717),
(314724, 'PTHR12439:SF40', NULL, NULL, NULL, NULL, 'POLY(U)-SPECIFIC ENDORIBONUCLEASE', 240717),
(314725, 'PTHR12439:SF41', NULL, NULL, NULL, NULL, 'POLY(U)-SPECIFIC ENDORIBONUCLEASE', 240717),
(314726, 'PTHR12439:SF32', NULL, NULL, NULL, NULL, 'POLY(U)-SPECIFIC ENDORIBONUCLEASE-B', 240717),
(314727, 'PTHR12439:SF33', NULL, NULL, NULL, NULL, 'POLY(U)-SPECIFIC ENDORIBONUCLEASE', 240717),
(314728, 'PTHR12439:SF11', NULL, NULL, NULL, NULL, 'POLY(U)-SPECIFIC ENDORIBONUCLEASE', 240717),
(314729, 'PTHR12439:SF34', NULL, NULL, NULL, NULL, 'XENDOU DOMAIN-CONTAINING PROTEIN', 240717),
(314730, 'PTHR12439:SF13', NULL, NULL, NULL, NULL, 'POLY(U)-SPECIFIC ENDORIBONUCLEASE-C', 240717),
(314731, 'PTHR36124:SF1', NULL, NULL, NULL, NULL, 'DUF2236 DOMAIN-CONTAINING PROTEIN', 240718),
(314732, 'PTHR36124:SF5', NULL, NULL, NULL, NULL, 'DUF2236 DOMAIN-CONTAINING PROTEIN', 240718),
(314733, 'PTHR36124', NULL, NULL, NULL, NULL, '', 240718),
(314734, 'PTHR36124:SF4', NULL, NULL, NULL, NULL, '', 240718),
(314735, 'PTHR21452:SF4', NULL, NULL, NULL, NULL, 'EXPORTIN-6', 240719),
(314736, 'PTHR21452', NULL, NULL, NULL, NULL, 'EXPORTIN-6', 240719),
(314737, 'PTHR13333:SF5', NULL, NULL, NULL, NULL, 'M-AAA PROTEASE-INTERACTING PROTEIN 1, MITOCHONDRIAL', 240720),
(314738, 'PTHR13333:SF7', NULL, NULL, NULL, NULL, 'SI:DKEY-82O10.4', 240720),
(314739, 'PTHR13333:SF6', NULL, NULL, NULL, NULL, 'MATRIX AAA PEPTIDASE-INTERACTING PROTEIN 1', 240720),
(314740, 'PTHR13333', NULL, NULL, NULL, NULL, 'M-AAA PROTEASE-INTERACTING PROTEIN 1, MITOCHONDRIAL', 240720),
(314741, 'PTHR36999:SF1', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NADP]', 240721);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(314742, 'PTHR36999', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NADP]', 240721),
(314743, 'PTHR12460', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR-RELATED PROTEIN', 240722),
(314744, 'PTHR12460:SF28', NULL, NULL, NULL, NULL, 'ENTH/VHS FAMILY PROTEIN', 240722),
(314745, 'PTHR12460:SF39', NULL, NULL, NULL, NULL, 'CID DOMAIN-CONTAINING PROTEIN', 240722),
(314746, 'PTHR12460:SF38', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 240722),
(314747, 'PTHR12460:SF27', NULL, NULL, NULL, NULL, 'ENTH/VHS FAMILY PROTEIN', 240722),
(314748, 'PTHR12460:SF37', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240722),
(314749, 'PTHR12460:SF26', NULL, NULL, NULL, NULL, 'CID DOMAIN-CONTAINING PROTEIN', 240722),
(314750, 'PTHR12460:SF36', NULL, NULL, NULL, NULL, 'OS01G0925000 PROTEIN', 240722),
(314751, 'PTHR12460:SF0', NULL, NULL, NULL, NULL, 'CID DOMAIN-CONTAINING PROTEIN 1-RELATED', 240722),
(314752, 'PTHR12460:SF23', NULL, NULL, NULL, NULL, 'CID DOMAIN-CONTAINING PROTEIN', 240722),
(314753, 'PTHR12460:SF20', NULL, NULL, NULL, NULL, 'CID DOMAIN-CONTAINING PROTEIN', 240722),
(314754, 'PTHR12460:SF31', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II-BINDING DOMAIN PROTEIN', 240722),
(314755, 'PTHR12460:SF41', NULL, NULL, NULL, NULL, 'CID DOMAIN-CONTAINING PROTEIN', 240722),
(314756, 'PTHR12460:SF40', NULL, NULL, NULL, NULL, 'REGULATION OF NUCLEAR PRE-MRNA DOMAIN-CONTAINING PROTEIN 2', 240722),
(314757, 'PTHR12460:SF2', NULL, NULL, NULL, NULL, 'REGULATION OF NUCLEAR PRE-MRNA DOMAIN-CONTAINING PROTEIN 1A', 240722),
(314758, 'PTHR12460:SF3', NULL, NULL, NULL, NULL, 'REGULATION OF NUCLEAR PRE-MRNA DOMAIN-CONTAINING PROTEIN 1B', 240722),
(314759, 'PTHR43465:SF2', NULL, NULL, NULL, NULL, 'DUF1680 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_1G08910)', 240723),
(314760, 'PTHR43465:SF1', NULL, NULL, NULL, NULL, 'SIX-HAIRPIN GLYCOSIDASE', 240723),
(314761, 'PTHR43465', NULL, NULL, NULL, NULL, 'DUF1680 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_1G08910)', 240723),
(314762, 'PTHR44573:SF1', NULL, NULL, NULL, NULL, 'NADPH-DEPENDENT ALKENAL/ONE OXIDOREDUCTASE, CHLOROPLASTIC', 240724),
(314763, 'PTHR44573', NULL, NULL, NULL, NULL, 'NADPH-DEPENDENT ALKENAL/ONE OXIDOREDUCTASE, CHLOROPLASTIC', 240724),
(314764, 'PTHR44573:SF6', NULL, NULL, NULL, NULL, '2-METHYLENE-FURAN-3-ONE REDUCTASE-RELATED', 240724),
(314765, 'PTHR44573:SF5', NULL, NULL, NULL, NULL, '2-METHYLENE-FURAN-3-ONE REDUCTASE-RELATED', 240724),
(314766, 'PTHR44573:SF4', NULL, NULL, NULL, NULL, '2-METHYLENE-FURAN-3-ONE REDUCTASE-LIKE', 240724),
(314767, 'PTHR44573:SF3', NULL, NULL, NULL, NULL, 'CYTOSOLIC ALKENAL/ONE OXIDOREDUCTASE', 240724),
(314768, 'PTHR44573:SF2', NULL, NULL, NULL, NULL, '2-METHYLENE-FURAN-3-ONE REDUCTASE-LIKE', 240724),
(314769, 'PTHR16083:SF68', NULL, NULL, NULL, NULL, 'BNAANNG26500D PROTEIN', 240725),
(314770, 'PTHR16083:SF67', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RF9-RELATED', 240725),
(314771, 'PTHR16083:SF66', NULL, NULL, NULL, NULL, 'RH62264P', 240725),
(314772, 'PTHR16083:SF21', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 57', 240725),
(314773, 'PTHR16083:SF65', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN TAO1-LIKE', 240725),
(314774, 'PTHR16083:SF64', NULL, NULL, NULL, NULL, 'NEMATODE RESISTANCE', 240725),
(314775, 'PTHR16083:SF20', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 20', 240725),
(314776, 'PTHR16083:SF63', NULL, NULL, NULL, NULL, '', 240725),
(314777, 'PTHR16083:SF62', NULL, NULL, NULL, NULL, 'BNAC09G11610D PROTEIN', 240725),
(314778, 'PTHR16083:SF61', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS)', 240725),
(314779, 'PTHR16083:SF3', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 27', 240725),
(314780, 'PTHR16083:SF25', NULL, NULL, NULL, NULL, 'RESISTANCE PROTEIN (TIR-NBS-LRR CLASS), PUTATIVE-RELATED', 240725),
(314781, 'PTHR16083:SF69', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 240725),
(314782, 'PTHR16083:SF60', NULL, NULL, NULL, NULL, 'RESISTANCE PROTEIN (TIR-NBS-LRR CLASS), PUTATIVE-RELATED', 240725);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(314783, 'PTHR16083:SF79', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 240725),
(314784, 'PTHR16083:SF57', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN SOC-2 HOMOLOG-LIKE PROTEIN', 240725),
(314785, 'PTHR16083:SF56', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (NBS-LRR CLASS) FAMILY PROTEIN', 240725),
(314786, 'PTHR16083:SF34', NULL, NULL, NULL, NULL, 'OS01G0536466 PROTEIN', 240725),
(314787, 'PTHR16083:SF78', NULL, NULL, NULL, NULL, '', 240725),
(314788, 'PTHR16083:SF55', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN SOG2', 240725),
(314789, 'PTHR16083:SF77', NULL, NULL, NULL, NULL, 'SAM DOMAIN-CONTAINING PROTEIN', 240725),
(314790, 'PTHR16083:SF11', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND CALPONIN HOMOLOGY DOMAIN-CONTAINING PROTEIN 2', 240725),
(314791, 'PTHR16083:SF76', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN TAO1-LIKE', 240725),
(314792, 'PTHR16083:SF54', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 59', 240725),
(314793, 'PTHR16083:SF10', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND CALPONIN HOMOLOGY DOMAIN-CONTAINING PROTEIN 1', 240725),
(314794, 'PTHR16083:SF53', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT CONTAINING 27', 240725),
(314795, 'PTHR16083:SF75', NULL, NULL, NULL, NULL, 'OS09G0328066 PROTEIN', 240725),
(314796, 'PTHR16083:SF52', NULL, NULL, NULL, NULL, 'TMV RESISTANCE PROTEIN N-LIKE', 240725),
(314797, 'PTHR16083:SF74', NULL, NULL, NULL, NULL, 'TIR-NBS-LRR TYPE DISEASE RESISTANCE PROTEIN', 240725),
(314798, 'PTHR16083:SF73', NULL, NULL, NULL, NULL, 'AND NB-ARC DOMAIN DISEASE RESISTANCE PROTEIN, PUTATIVE-RELATED', 240725),
(314799, 'PTHR16083:SF51', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 28', 240725),
(314800, 'PTHR16083', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT CONTAINING PROTEIN', 240725),
(314801, 'PTHR16083:SF72', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 240725),
(314802, 'PTHR16083:SF50', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS) FAMILY PROTEIN', 240725),
(314803, 'PTHR16083:SF39', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE LRSAM1', 240725),
(314804, 'PTHR16083:SF17', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 18', 240725),
(314805, 'PTHR16083:SF59', NULL, NULL, NULL, NULL, 'OS08G0170150 PROTEIN', 240725),
(314806, 'PTHR16083:SF58', NULL, NULL, NULL, NULL, 'BNAANNG03860D PROTEIN', 240725),
(314807, 'PTHR16083:SF7', NULL, NULL, NULL, NULL, 'DISP COMPLEX PROTEIN LRCH3', 240725),
(314808, 'PTHR16083:SF8', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 10', 240725),
(314809, 'PTHR16083:SF6', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 10B', 240725),
(314810, 'PTHR16083:SF9', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND CALPONIN HOMOLOGY DOMAIN-CONTAINING PROTEIN 4', 240725),
(314811, 'PTHR16083:SF71', NULL, NULL, NULL, NULL, '', 240725),
(314812, 'PTHR16083:SF70', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN PIK5-NP', 240725),
(314813, 'PTHR35299:SF6', NULL, NULL, NULL, NULL, 'RUBISCO ACCUMULATION FACTOR 1', 240726),
(314814, 'PTHR35299:SF4', NULL, NULL, NULL, NULL, 'RUBISCO ACCUMULATION FACTOR 1.1, CHLOROPLASTIC', 240726),
(314815, 'PTHR35299:SF3', NULL, NULL, NULL, NULL, 'RUBISCO ACCUMULATION FACTOR 1.2, CHLOROPLASTIC', 240726),
(314816, 'PTHR35299', NULL, NULL, NULL, NULL, 'RUBISCO ACCUMULATION FACTOR 1', 240726),
(314817, 'PTHR18956', NULL, NULL, NULL, NULL, 'HYALURONAN MEDIATED MOTILITY RECEPTOR', 240727),
(314818, 'PTHR18956:SF6', NULL, NULL, NULL, NULL, 'HYALURONAN MEDIATED MOTILITY RECEPTOR', 240727),
(314819, 'PTHR13767:SF2', NULL, NULL, NULL, NULL, 'TRNA PSEUDOURIDINE SYNTHASE 1-RELATED', 240728),
(314820, 'PTHR13767', NULL, NULL, NULL, NULL, 'TRNA-PSEUDOURIDINE SYNTHASE', 240728),
(314821, 'PTHR10498:SF6', NULL, NULL, NULL, NULL, 'PARALEMMIN-1', 240729),
(314822, 'PTHR10498:SF10', NULL, NULL, NULL, NULL, 'PALM2 AND AKAP2 FUSION-RELATED', 240729),
(314823, 'PTHR10498:SF24', NULL, NULL, NULL, NULL, 'PALM2 AND AKAP2 FUSION', 240729);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(314824, 'PTHR10498', NULL, NULL, NULL, NULL, 'PARALEMMIN-RELATED', 240729),
(314825, 'PTHR19315', NULL, NULL, NULL, NULL, 'ER MEMBRANE PROTEIN COMPLEX SUBUNIT 4', 240730),
(314826, 'PTHR19315:SF9', NULL, NULL, NULL, NULL, 'ER MEMBRANE PROTEIN COMPLEX SUBUNIT 4', 240730),
(314827, 'PTHR45974:SF135', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314828, 'PTHR45974:SF256', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314829, 'PTHR45974:SF255', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314830, 'PTHR45974:SF211', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE', 240731),
(314831, 'PTHR45974:SF4', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE FEI 1', 240731),
(314832, 'PTHR45974:SF134', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314833, 'PTHR45974:SF137', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314834, 'PTHR45974:SF258', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN, PLANT-TYPE-RELATED', 240731),
(314835, 'PTHR45974:SF214', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINE RECEPTOR 1-RELATED', 240731),
(314836, 'PTHR45974:SF213', NULL, NULL, NULL, NULL, 'BRASSINOSTEROID LRR RECEPTOR KINASE', 240731),
(314837, 'PTHR45974:SF257', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314838, 'PTHR45974:SF49', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314839, 'PTHR45974:SF252', NULL, NULL, NULL, NULL, 'PROTEIN KINASE, PLANT-TYPE, PUTATIVE-RELATED', 240731),
(314840, 'PTHR45974:SF251', NULL, NULL, NULL, NULL, '', 240731),
(314841, 'PTHR45974:SF177', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314842, 'PTHR45974:SF254', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314843, 'PTHR45974:SF253', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE FAMILY PROTEIN', 240731),
(314844, 'PTHR45974:SF171', NULL, NULL, NULL, NULL, 'OS02G0153500 PROTEIN', 240731),
(314845, 'PTHR45974:SF250', NULL, NULL, NULL, NULL, 'PROTEIN KINASE, PLANT-TYPE, PUTATIVE-RELATED', 240731),
(314846, 'PTHR45974:SF172', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314847, 'PTHR45974', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 55', 240731),
(314848, 'PTHR45974:SF44', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314849, 'PTHR45974:SF90', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314850, 'PTHR45974:SF219', NULL, NULL, NULL, NULL, 'OSJNBB0004A17.8 PROTEIN', 240731),
(314851, 'PTHR45974:SF216', NULL, NULL, NULL, NULL, 'OS01G0960400 PROTEIN', 240731),
(314852, 'PTHR45974:SF139', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314853, 'PTHR45974:SF259', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314854, 'PTHR45974:SF138', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314855, 'PTHR45974:SF8', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314856, 'PTHR45974:SF267', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314857, 'PTHR45974:SF146', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314858, 'PTHR45974:SF266', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR PROTEIN KINASE HPCA1', 240731),
(314859, 'PTHR45974:SF148', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 240731),
(314860, 'PTHR45974:SF268', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314861, 'PTHR45974:SF263', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314862, 'PTHR45974:SF186', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314863, 'PTHR45974:SF262', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314864, 'PTHR45974:SF141', NULL, NULL, NULL, NULL, 'OS07G0134600 PROTEIN', 240731);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(314865, 'PTHR45974:SF265', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314866, 'PTHR45974:SF100', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE FAMILY PROTEIN', 240731),
(314867, 'PTHR45974:SF143', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314868, 'PTHR45974:SF187', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314869, 'PTHR45974:SF264', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT (LRR) FAMILY PROTEIN', 240731),
(314870, 'PTHR45974:SF50', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 240731),
(314871, 'PTHR45974:SF181', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314872, 'PTHR45974:SF94', NULL, NULL, NULL, NULL, 'INACTIVE LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE BIR2', 240731),
(314873, 'PTHR45974:SF95', NULL, NULL, NULL, NULL, 'OS02G0153700 PROTEIN', 240731),
(314874, 'PTHR45974:SF261', NULL, NULL, NULL, NULL, 'KINASE BRI1, PUTATIVE-RELATED', 240731),
(314875, 'PTHR45974:SF260', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314876, 'PTHR45974:SF183', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINE RECEPTOR 1', 240731),
(314877, 'PTHR45974:SF97', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314878, 'PTHR45974:SF55', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314879, 'PTHR45974:SF12', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314880, 'PTHR45974:SF227', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314881, 'PTHR45974:SF108', NULL, NULL, NULL, NULL, 'OS05G0481100 PROTEIN', 240731),
(314882, 'PTHR45974:SF229', NULL, NULL, NULL, NULL, 'OS05G0486100 PROTEIN', 240731),
(314883, 'PTHR45974:SF107', NULL, NULL, NULL, NULL, 'ATP BINDING PROTEIN', 240731),
(314884, 'PTHR45974:SF234', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314885, 'PTHR45974:SF233', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314886, 'PTHR45974:SF156', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 240731),
(314887, 'PTHR45974:SF159', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE', 240731),
(314888, 'PTHR45974:SF26', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING RECEPTOR-LIKE CYTOPLASMIC KINASE 1', 240731),
(314889, 'PTHR45974:SF115', NULL, NULL, NULL, NULL, 'MDIS1-INTERACTING RECEPTOR LIKE KINASE 2-LIKE', 240731),
(314890, 'PTHR45974:SF28', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 240731),
(314891, 'PTHR45974:SF29', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE FAMILY PROTEIN', 240731),
(314892, 'PTHR45974:SF196', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314893, 'PTHR45974:SF155', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314894, 'PTHR45974:SF198', NULL, NULL, NULL, NULL, 'OS01G0892300 PROTEIN', 240731),
(314895, 'PTHR45974:SF231', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314896, 'PTHR45974:SF61', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314897, 'PTHR45974:SF63', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314898, 'PTHR45974:SF194', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314899, 'PTHR45974:SF65', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314900, 'PTHR45974:SF23', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314901, 'PTHR45974:SF237', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314902, 'PTHR45974:SF119', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314903, 'PTHR45974:SF245', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314904, 'PTHR45974:SF201', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(314905, 'PTHR45974:SF168', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314906, 'PTHR45974:SF244', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314907, 'PTHR45974:SF167', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314908, 'PTHR45974:SF247', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314909, 'PTHR45974:SF203', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 240731),
(314910, 'PTHR45974:SF246', NULL, NULL, NULL, NULL, 'OS02G0153100 PROTEIN', 240731),
(314911, 'PTHR45974:SF163', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314912, 'PTHR45974:SF240', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314913, 'PTHR45974:SF243', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314914, 'PTHR45974:SF166', NULL, NULL, NULL, NULL, 'INACTIVE LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE BIR2', 240731),
(314915, 'PTHR45974:SF242', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 240731),
(314916, 'PTHR45974:SF72', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314917, 'PTHR45974:SF34', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING RECEPTOR-LIKE CYTOPLASMIC KINASE 2', 240731),
(314918, 'PTHR45974:SF249', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240731),
(314919, 'PTHR45974:SF248', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 240731),
(314920, 'PTHR45974:SF127', NULL, NULL, NULL, NULL, 'OS05G0414700 PROTEIN', 240731),
(314921, 'PTHR45974:SF207', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 240731),
(314922, 'PTHR37171', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE YRZF-RELATED', 240732),
(314923, 'PTHR37171:SF1', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE YRZF-RELATED', 240732),
(314924, 'PTHR42029:SF2', NULL, NULL, NULL, NULL, '', 240733),
(314925, 'PTHR42029:SF3', NULL, NULL, NULL, NULL, '', 240733),
(314926, 'PTHR42029', NULL, NULL, NULL, NULL, '', 240733),
(314927, 'PTHR14447:SF0', NULL, NULL, NULL, NULL, 'UROTENSIN-2', 240734),
(314928, 'PTHR14447', NULL, NULL, NULL, NULL, 'UROTENSIN 2', 240734),
(314929, 'PTHR46904', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN T', 240735),
(314930, 'PTHR46904:SF1', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN T', 240735),
(314931, 'PTHR44442', NULL, NULL, NULL, NULL, '3-KETO-STEROID REDUCTASE', 240736),
(314932, 'PTHR44442:SF1', NULL, NULL, NULL, NULL, '3-KETO-STEROID REDUCTASE/17-BETA-HYDROXYSTEROID DEHYDROGENASE 7', 240736),
(314933, 'PTHR35177:SF2', NULL, NULL, NULL, NULL, 'HYDROGENASE MATURATION FACTOR HYBG', 240737),
(314934, 'PTHR35177:SF1', NULL, NULL, NULL, NULL, 'HYDROGENASE MATURATION FACTOR HYPC', 240737),
(314935, 'PTHR35177', NULL, NULL, NULL, NULL, 'HYDROGENASE MATURATION FACTOR HYBG', 240737),
(314936, 'PTHR35712', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN-LIKE PROTEIN', 240738),
(314937, 'PTHR35712:SF1', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN-LIKE PROTEIN', 240738),
(314938, 'PTHR23517', NULL, NULL, NULL, NULL, 'RESISTANCE PROTEIN MDTM, PUTATIVE-RELATED-RELATED', 240739),
(314939, 'PTHR23517:SF10', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 240739),
(314940, 'PTHR23517:SF13', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY MFS_1', 240739),
(314941, 'PTHR23517:SF15', NULL, NULL, NULL, NULL, 'PROTON-DEPENDENT OLIGOPEPTIDE FAMILY TRANSPORT PROTEIN-RELATED', 240739),
(314942, 'PTHR23517:SF14', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 240739),
(314943, 'PTHR23517:SF1', NULL, NULL, NULL, NULL, '', 240739),
(314944, 'PTHR23517:SF2', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN MDTH', 240739),
(314945, 'PTHR23517:SF3', NULL, NULL, NULL, NULL, 'CONSERVED INTEGRAL MEMBRANE PROTEIN-RELATED', 240739),
(314946, 'PTHR30401', NULL, NULL, NULL, NULL, 'TRNA 2-SELENOURIDINE SYNTHASE', 240740),
(314947, 'PTHR30401:SF0', NULL, NULL, NULL, NULL, 'TRNA 2-SELENOURIDINE SYNTHASE', 240740);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(314948, 'PTHR21385:SF5', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 240741),
(314949, 'PTHR21385', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN-RELATED', 240741),
(314950, 'PTHR21385:SF0', NULL, NULL, NULL, NULL, 'RE51073P', 240741),
(314951, 'PTHR38393', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA (GLN) AMIDOTRANSFERASE SUBUNIT C', 240742),
(314952, 'PTHR38393:SF1', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA (GLN) AMIDOTRANSFERASE SUBUNIT C', 240742),
(314953, 'PTHR46766:SF1', NULL, NULL, NULL, NULL, 'GLUTAMINE-RICH PROTEIN 2', 240743),
(314954, 'PTHR46766', NULL, NULL, NULL, NULL, 'GLUTAMINE-RICH PROTEIN 2', 240743),
(314955, 'PTHR35549', NULL, NULL, NULL, NULL, 'OS04G0584500 PROTEIN', 240744),
(314956, 'PTHR35549:SF1', NULL, NULL, NULL, NULL, 'OS04G0584500 PROTEIN', 240744),
(314957, 'PTHR35549:SF2', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN', 240744),
(314958, 'PTHR35549:SF5', NULL, NULL, NULL, NULL, '', 240744),
(314959, 'PTHR35549:SF3', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE LIN-RELATED', 240744),
(314960, 'PTHR47804', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L19', 240745),
(314961, 'PTHR47804:SF1', NULL, NULL, NULL, NULL, 'ARAE_2 DOMAIN-CONTAINING PROTEIN', 240745),
(314962, 'PTHR47804:SF3', NULL, NULL, NULL, NULL, 'PROTEIN BRE4', 240745),
(314963, 'PTHR47804:SF5', NULL, NULL, NULL, NULL, '', 240745),
(314964, 'PTHR47804:SF4', NULL, NULL, NULL, NULL, 'AFR661WP', 240745),
(314965, 'PTHR48227:SF1', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 58-LIKE', 240746),
(314966, 'PTHR48227', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE 1-LIKE', 240746),
(314967, 'PTHR30332:SF17', NULL, NULL, NULL, NULL, 'TYPE IV PILIATION SYSTEM PROTEIN DR_0774-RELATED', 240747),
(314968, 'PTHR30332:SF26', NULL, NULL, NULL, NULL, 'GENERAL SECRETION PATHWAY PROTEIN D', 240747),
(314969, 'PTHR30332:SF25', NULL, NULL, NULL, NULL, 'SECRETIN XPSD', 240747),
(314970, 'PTHR30332:SF24', NULL, NULL, NULL, NULL, 'SECRETIN GSPD-RELATED', 240747),
(314971, 'PTHR30332:SF23', NULL, NULL, NULL, NULL, 'SECRETION PATHWAY PROTEIN D, PUTATIVE-RELATED', 240747),
(314972, 'PTHR30332:SF22', NULL, NULL, NULL, NULL, 'MSHA SYSTEM OUTER MEMBRANE SECRETIN MSHL', 240747),
(314973, 'PTHR30332:SF4', NULL, NULL, NULL, NULL, 'TYPE 3 SECRETION SYSTEM SECRETIN', 240747),
(314974, 'PTHR30332', NULL, NULL, NULL, NULL, 'PROBABLE GENERAL SECRETION PATHWAY PROTEIN D', 240747),
(314975, 'PTHR30332:SF5', NULL, NULL, NULL, NULL, 'SPI-1 TYPE 3 SECRETION SYSTEM SECRETIN', 240747),
(314976, 'PTHR33420:SF4', NULL, NULL, NULL, NULL, 'FIMBRIAL-LIKE PROTEIN FIMF', 240748),
(314977, 'PTHR33420:SF3', NULL, NULL, NULL, NULL, 'FIMBRIAL SUBUNIT ELFA-RELATED', 240748),
(314978, 'PTHR33420:SF5', NULL, NULL, NULL, NULL, 'FIMBRIAL SUBUNIT', 240748),
(314979, 'PTHR33420:SF26', NULL, NULL, NULL, NULL, 'FIMBRIAL SUBUNIT-RELATED', 240748),
(314980, 'PTHR33420:SF25', NULL, NULL, NULL, NULL, 'FIMBRIN-LIKE PROTEIN FIMI-RELATED', 240748),
(314981, 'PTHR33420:SF14', NULL, NULL, NULL, NULL, 'FIMBRIAL PROTEIN', 240748),
(314982, 'PTHR33420:SF28', NULL, NULL, NULL, NULL, 'FIMBRIAE-RELATED', 240748),
(314983, 'PTHR33420:SF27', NULL, NULL, NULL, NULL, 'PROTEIN FIMG', 240748),
(314984, 'PTHR33420:SF11', NULL, NULL, NULL, NULL, 'TYPE 1 FIMBRIN D-MANNOSE SPECIFIC ADHESIN', 240748),
(314985, 'PTHR33420:SF33', NULL, NULL, NULL, NULL, 'MINOR FIMBRIAL SUBUNIT-RELATED', 240748),
(314986, 'PTHR33420:SF32', NULL, NULL, NULL, NULL, 'FIMBRIAL-LIKE PROTEIN-RELATED', 240748),
(314987, 'PTHR33420:SF10', NULL, NULL, NULL, NULL, 'FIMBRIAE MAJOR SUBUNIT-RELATED', 240748),
(314988, 'PTHR33420:SF34', NULL, NULL, NULL, NULL, 'MINOR FIMBRIAL SUBUNIT-RELATED', 240748),
(314989, 'PTHR33420:SF12', NULL, NULL, NULL, NULL, 'FIMBRIN-LIKE PROTEIN FIMI', 240748),
(314990, 'PTHR33420:SF9', NULL, NULL, NULL, NULL, 'MINOR FIMBRIAL SUBUNIT-RELATED', 240748),
(314991, 'PTHR33420:SF31', NULL, NULL, NULL, NULL, 'TYPE 1 FIMBRIN D-MANNOSE SPECIFIC ADHESIN', 240748),
(314992, 'PTHR33420', NULL, NULL, NULL, NULL, 'FIMBRIAL SUBUNIT ELFA-RELATED', 240748),
(314993, 'PTHR31204', NULL, NULL, NULL, NULL, 'SIGMA INTRACELLULAR RECEPTOR 2', 240749);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(314994, 'PTHR31204:SF1', NULL, NULL, NULL, NULL, 'SIGMA INTRACELLULAR RECEPTOR 2', 240749),
(314995, 'PTHR31204:SF4', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240749),
(314996, 'PTHR31204:SF6', NULL, NULL, NULL, NULL, 'EXPERA DOMAIN-CONTAINING PROTEIN', 240749),
(314997, 'PTHR31204:SF8', NULL, NULL, NULL, NULL, 'EXPERA DOMAIN-CONTAINING PROTEIN', 240749),
(314998, 'PTHR31204:SF7', NULL, NULL, NULL, NULL, 'EXPERA DOMAIN-CONTAINING PROTEIN', 240749),
(314999, 'PTHR31204:SF9', NULL, NULL, NULL, NULL, 'EXPERA DOMAIN-CONTAINING PROTEIN', 240749),
(315000, 'PTHR47827', NULL, NULL, NULL, NULL, 'AHD DOMAIN-CONTAINING PROTEIN', 240750),
(315001, 'PTHR47827:SF5', NULL, NULL, NULL, NULL, 'PROTEIN AF-9', 240750),
(315002, 'PTHR47827:SF4', NULL, NULL, NULL, NULL, 'PROTEIN ENL', 240750),
(315003, 'PTHR47827:SF3', NULL, NULL, NULL, NULL, 'AHD DOMAIN-CONTAINING PROTEIN', 240750),
(315004, 'PTHR42336:SF2', NULL, NULL, NULL, NULL, '', 240751),
(315005, 'PTHR42336:SF1', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 240751),
(315006, 'PTHR42336', NULL, NULL, NULL, NULL, '', 240751),
(315007, 'PTHR38580', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 192', 240752),
(315008, 'PTHR38580:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 192', 240752),
(315009, 'PTHR44663:SF1', NULL, NULL, NULL, NULL, 'JUNCTIONAL ADHESION MOLECULE 2B', 240753),
(315010, 'PTHR44663:SF2', NULL, NULL, NULL, NULL, 'JUNCTIONAL ADHESION MOLECULE B', 240753),
(315011, 'PTHR44663:SF3', NULL, NULL, NULL, NULL, 'JUNCTIONAL ADHESION MOLECULE 2A', 240753),
(315012, 'PTHR44663', NULL, NULL, NULL, NULL, 'JUNCTIONAL ADHESION MOLECULE B', 240753),
(315013, 'PTHR31929:SF86', NULL, NULL, NULL, NULL, 'BNAA10G16780D PROTEIN', 240754),
(315014, 'PTHR31929:SF128', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN 15A-LIKE', 240754),
(315015, 'PTHR31929:SF84', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED SAUR', 240754),
(315016, 'PTHR31929:SF40', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN 15A-LIKE', 240754),
(315017, 'PTHR31929:SF166', NULL, NULL, NULL, NULL, 'SMALL AUXIN-UP RNA-RELATED', 240754),
(315018, 'PTHR31929:SF167', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED SAUR', 240754),
(315019, 'PTHR31929:SF123', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN 15A-LIKE', 240754),
(315020, 'PTHR31929:SF82', NULL, NULL, NULL, NULL, 'BNAC02G34520D PROTEIN', 240754),
(315021, 'PTHR31929:SF168', NULL, NULL, NULL, NULL, '', 240754),
(315022, 'PTHR31929:SF80', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED SAUR', 240754),
(315023, 'PTHR31929:SF125', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED SAUR', 240754),
(315024, 'PTHR31929:SF169', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR22-LIKE', 240754),
(315025, 'PTHR31929:SF49', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR15', 240754),
(315026, 'PTHR31929:SF162', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY', 240754),
(315027, 'PTHR31929:SF163', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR22-LIKE', 240754),
(315028, 'PTHR31929:SF164', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN 15A', 240754),
(315029, 'PTHR31929:SF120', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN 6B-LIKE', 240754),
(315030, 'PTHR31929:SF165', NULL, NULL, NULL, NULL, '', 240754),
(315031, 'PTHR31929:SF48', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN X10A', 240754),
(315032, 'PTHR31929:SF45', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN 15A-LIKE', 240754),
(315033, 'PTHR31929:SF89', NULL, NULL, NULL, NULL, 'BNAA02G26410D PROTEIN', 240754),
(315034, 'PTHR31929', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY-RELATED', 240754),
(315035, 'PTHR31929:SF87', NULL, NULL, NULL, NULL, 'BNAA10G16770D PROTEIN', 240754),
(315036, 'PTHR31929:SF160', NULL, NULL, NULL, NULL, 'SMALL AUXIN-UP RNA-RELATED', 240754),
(315037, 'PTHR31929:SF161', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN 15A-LIKE', 240754),
(315038, 'PTHR31929:SF137', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR21-LIKE', 240754),
(315039, 'PTHR31929:SF75', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN 15A-LIKE', 240754);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(315040, 'PTHR31929:SF139', NULL, NULL, NULL, NULL, 'BNAA02G26400D PROTEIN', 240754),
(315041, 'PTHR31929:SF73', NULL, NULL, NULL, NULL, 'BNAA10G16810D PROTEIN', 240754),
(315042, 'PTHR31929:SF177', NULL, NULL, NULL, NULL, 'BNAA10G16790D PROTEIN', 240754),
(315043, 'PTHR31929:SF71', NULL, NULL, NULL, NULL, 'BNAC03G65770D PROTEIN', 240754),
(315044, 'PTHR31929:SF178', NULL, NULL, NULL, NULL, 'BNAA10G16750D PROTEIN', 240754),
(315045, 'PTHR31929:SF135', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN X15-LIKE', 240754),
(315046, 'PTHR31929:SF179', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN 15A-LIKE', 240754),
(315047, 'PTHR31929:SF136', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN 15A-LIKE', 240754),
(315048, 'PTHR31929:SF38', NULL, NULL, NULL, NULL, 'SMALL AUXIN-UP RNA-RELATED', 240754),
(315049, 'PTHR31929:SF173', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN 15A-LIKE', 240754),
(315050, 'PTHR31929:SF39', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY', 240754),
(315051, 'PTHR31929:SF130', NULL, NULL, NULL, NULL, 'BNAA02G03920D PROTEIN', 240754),
(315052, 'PTHR31929:SF174', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR21', 240754),
(315053, 'PTHR31929:SF175', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY-RELATED', 240754),
(315054, 'PTHR31929:SF176', NULL, NULL, NULL, NULL, 'BNAA02G03930D PROTEIN', 240754),
(315055, 'PTHR31929:SF34', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR19-RELATED', 240754),
(315056, 'PTHR31929:SF35', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE FAMILY PROTEIN', 240754),
(315057, 'PTHR31929:SF170', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE FAMILY PROTEIN', 240754),
(315058, 'PTHR31929:SF79', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN 15A-LIKE', 240754),
(315059, 'PTHR31929:SF171', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY', 240754),
(315060, 'PTHR31929:SF172', NULL, NULL, NULL, NULL, 'SMALL AUXIN-UP RNA-RELATED', 240754),
(315061, 'PTHR31929:SF77', NULL, NULL, NULL, NULL, 'BNAA02G03880D PROTEIN', 240754),
(315062, 'PTHR31929:SF104', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR21', 240754),
(315063, 'PTHR31929:SF63', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR22-LIKE', 240754),
(315064, 'PTHR31929:SF105', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY', 240754),
(315065, 'PTHR31929:SF144', NULL, NULL, NULL, NULL, '', 240754),
(315066, 'PTHR31929:SF60', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN 6B', 240754),
(315067, 'PTHR31929:SF184', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE FAMILY PROTEIN', 240754),
(315068, 'PTHR31929:SF143', NULL, NULL, NULL, NULL, 'BNAANNG36540D PROTEIN', 240754),
(315069, 'PTHR31929:SF67', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN 15A-LIKE', 240754),
(315070, 'PTHR31929:SF180', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED SAUR', 240754),
(315071, 'PTHR31929:SF181', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN X15-LIKE', 240754),
(315072, 'PTHR31929:SF68', NULL, NULL, NULL, NULL, 'AUXIN RESPONSIVE PROTEIN', 240754),
(315073, 'PTHR31929:SF182', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR22-LIKE', 240754),
(315074, 'PTHR31929:SF183', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR21-LIKE', 240754),
(315075, 'PTHR31929:SF159', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED SAUR', 240754),
(315076, 'PTHR31929:SF96', NULL, NULL, NULL, NULL, 'BNAA10G16800D PROTEIN', 240754),
(315077, 'PTHR31929:SF115', NULL, NULL, NULL, NULL, 'BNAA10G16740D PROTEIN', 240754),
(315078, 'PTHR31929:SF52', NULL, NULL, NULL, NULL, 'BNAC04G29280D PROTEIN', 240754),
(315079, 'PTHR31929:SF94', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED SAUR', 240754),
(315080, 'PTHR31929:SF50', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN 15A-LIKE', 240754),
(315081, 'PTHR31929:SF155', NULL, NULL, NULL, NULL, 'SAUR FAMILY PROTEIN', 240754),
(315082, 'PTHR31929:SF92', NULL, NULL, NULL, NULL, 'BNAC09G39840D PROTEIN', 240754),
(315083, 'PTHR31929:SF156', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY', 240754);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(315084, 'PTHR31929:SF157', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR21-LIKE', 240754),
(315085, 'PTHR31929:SF90', NULL, NULL, NULL, NULL, 'BNAC09G39760D PROTEIN', 240754),
(315086, 'PTHR31929:SF158', NULL, NULL, NULL, NULL, 'SMALL AUXIN-UP RNA-RELATED', 240754),
(315087, 'PTHR31929:SF91', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY', 240754),
(315088, 'PTHR31929:SF114', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY', 240754),
(315089, 'PTHR31929:SF151', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR21-LIKE', 240754),
(315090, 'PTHR31929:SF154', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR21-LIKE', 240754),
(315091, 'PTHR31929:SF110', NULL, NULL, NULL, NULL, 'BNAA02G03910D PROTEIN', 240754),
(315092, 'PTHR31929:SF57', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE FAMILY PROTEIN', 240754),
(315093, 'PTHR31929:SF54', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN 15A-LIKE', 240754),
(315094, 'PTHR31929:SF98', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED SAUR', 240754),
(315095, 'PTHR31929:SF150', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN X10A-LIKE', 240754),
(315096, 'PTHR31929:SF99', NULL, NULL, NULL, NULL, 'BNAA02G03900D PROTEIN', 240754),
(315097, 'PTHR31929:SF108', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR20', 240754),
(315098, 'PTHR31929:SF109', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY-RELATED', 240754),
(315099, 'PTHR38847', NULL, NULL, NULL, NULL, '', 240755),
(315100, 'PTHR38847:SF1', NULL, NULL, NULL, NULL, 'PSEUDOU_SYNTH_2 DOMAIN-CONTAINING PROTEIN', 240755),
(315101, 'PTHR38847:SF4', NULL, NULL, NULL, NULL, '', 240755),
(315102, 'PTHR38762:SF1', NULL, NULL, NULL, NULL, 'CRYPTIC OUTER MEMBRANE PORIN BGLH-RELATED', 240756),
(315103, 'PTHR38762', NULL, NULL, NULL, NULL, 'CRYPTIC OUTER MEMBRANE PORIN BGLH-RELATED', 240756),
(315104, 'PTHR34546:SF3', NULL, NULL, NULL, NULL, 'OS06G0153600 PROTEIN', 240757),
(315105, 'PTHR34546', NULL, NULL, NULL, NULL, 'OS06G0153600 PROTEIN', 240757),
(315106, 'PTHR34546:SF7', NULL, NULL, NULL, NULL, '', 240757),
(315107, 'PTHR34546:SF5', NULL, NULL, NULL, NULL, '', 240757),
(315108, 'PTHR34546:SF6', NULL, NULL, NULL, NULL, 'OS01G0759000 PROTEIN', 240757),
(315109, 'PTHR38041:SF2', NULL, NULL, NULL, NULL, 'MONOFUNCTIONAL CHORISMATE MUTASE', 240758),
(315110, 'PTHR38041:SF1', NULL, NULL, NULL, NULL, 'CHORISMATE MUTASE', 240758),
(315111, 'PTHR38041', NULL, NULL, NULL, NULL, 'CHORISMATE MUTASE', 240758),
(315112, 'PTHR10233:SF19', NULL, NULL, NULL, NULL, 'INITIATION FACTOR 2B-RELATED PROTEIN-RELATED', 240759),
(315113, 'PTHR10233:SF21', NULL, NULL, NULL, NULL, 'NAGB/RPIA/COA TRANSFERASE-LIKE SUPERFAMILY PROTEIN', 240759),
(315114, 'PTHR10233', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR EIF-2B', 240759),
(315115, 'PTHR10233:SF14', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR EIF-2B SUBUNIT DELTA', 240759),
(315116, 'PTHR10233:SF16', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR EIF-2B SUBUNIT DELTA-LIKE ISOFORM X1', 240759),
(315117, 'PTHR10233:SF17', NULL, NULL, NULL, NULL, 'NAGB/RPIA/COA TRANSFERASE-LIKE SUPERFAMILY PROTEIN', 240759),
(315118, 'PTHR10233:SF18', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR EIF-2B DELTA SUBUNIT', 240759),
(315119, 'PTHR37038:SF12', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR', 240760),
(315120, 'PTHR37038:SF13', NULL, NULL, NULL, NULL, 'HTH CRO/C1-TYPE DOMAIN-CONTAINING PROTEIN', 240760),
(315121, 'PTHR37038:SF14', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR', 240760),
(315122, 'PTHR37038', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', 240760),
(315123, 'PTHR42948:SF1', NULL, NULL, NULL, NULL, 'TRANSPORTER', 240761),
(315124, 'PTHR42948', NULL, NULL, NULL, NULL, 'TRANSPORTER', 240761),
(315125, 'PTHR45771:SF3', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-B4', 240762),
(315126, 'PTHR45771:SF6', NULL, NULL, NULL, NULL, 'HOMEOTIC PROTEIN SEX COMBS REDUCED-RELATED', 240762),
(315127, 'PTHR45771:SF5', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-D4', 240762);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(315128, 'PTHR45771:SF9', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-C4', 240762),
(315129, 'PTHR45771:SF13', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 240762),
(315130, 'PTHR45771', NULL, NULL, NULL, NULL, 'HOMEOTIC PROTEIN DEFORMED', 240762),
(315131, 'PTHR45771:SF12', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN MAB-5', 240762),
(315132, 'PTHR45771:SF2', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-A4', 240762),
(315133, 'PTHR13098', NULL, NULL, NULL, NULL, 'WOLFRAMIN', 240763),
(315134, 'PTHR13098:SF4', NULL, NULL, NULL, NULL, 'WOLFRAM SYNDROME 1A (WOLFRAMIN)', 240763),
(315135, 'PTHR13098:SF5', NULL, NULL, NULL, NULL, 'WOLFRAM SYNDROME 1B (WOLFRAMIN)', 240763),
(315136, 'PTHR13098:SF3', NULL, NULL, NULL, NULL, 'WOLFRAMIN', 240763),
(315137, 'PTHR18829:SF0', NULL, NULL, NULL, NULL, 'PROTEIN YAE1 HOMOLOG', 240764),
(315138, 'PTHR18829:SF1', NULL, NULL, NULL, NULL, 'YAE1_N DOMAIN-CONTAINING PROTEIN', 240764),
(315139, 'PTHR18829', NULL, NULL, NULL, NULL, 'PROTEIN YAE1 HOMOLOG', 240764),
(315140, 'PTHR34357:SF11', NULL, NULL, NULL, NULL, 'BNAA08G31550D PROTEIN', 240765),
(315141, 'PTHR34357:SF10', NULL, NULL, NULL, NULL, 'GCK DOMAIN-CONTAINING PROTEIN', 240765),
(315142, 'PTHR34357:SF8', NULL, NULL, NULL, NULL, 'GCK DOMAIN-CONTAINING PROTEIN', 240765),
(315143, 'PTHR34357:SF7', NULL, NULL, NULL, NULL, 'GCK DOMAIN-CONTAINING PROTEIN', 240765),
(315144, 'PTHR34357:SF9', NULL, NULL, NULL, NULL, 'GCK DOMAIN-CONTAINING PROTEIN', 240765),
(315145, 'PTHR34357:SF4', NULL, NULL, NULL, NULL, 'GCK DOMAIN-CONTAINING PROTEIN', 240765),
(315146, 'PTHR34357:SF5', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240765),
(315147, 'PTHR34357:SF13', NULL, NULL, NULL, NULL, 'GCK DOMAIN-CONTAINING PROTEIN', 240765),
(315148, 'PTHR34357', NULL, NULL, NULL, NULL, 'F7A19.14 PROTEIN-RELATED', 240765),
(315149, 'PTHR34357:SF12', NULL, NULL, NULL, NULL, 'GCK DOMAIN-CONTAINING PROTEIN', 240765),
(315150, 'PTHR34357:SF2', NULL, NULL, NULL, NULL, 'F26F24.3-RELATED', 240765),
(315151, 'PTHR45652:SF17', NULL, NULL, NULL, NULL, 'IF ROD DOMAIN-CONTAINING PROTEIN', 240766),
(315152, 'PTHR45652:SF16', NULL, NULL, NULL, NULL, 'NEUROFILAMENT, LIGHT POLYPEPTIDE A', 240766),
(315153, 'PTHR45652:SF14', NULL, NULL, NULL, NULL, 'PERIPHERIN', 240766),
(315154, 'PTHR45652:SF13', NULL, NULL, NULL, NULL, 'ZGC:65851', 240766),
(315155, 'PTHR45652:SF22', NULL, NULL, NULL, NULL, '', 240766),
(315156, 'PTHR45652:SF11', NULL, NULL, NULL, NULL, 'NOTOCHORD GRANULAR SURFACE-RELATED', 240766),
(315157, 'PTHR45652:SF9', NULL, NULL, NULL, NULL, 'GLIAL FIBRILLARY ACIDIC PROTEIN', 240766),
(315158, 'PTHR45652:SF10', NULL, NULL, NULL, NULL, 'SI:DKEY-27M7.4', 240766),
(315159, 'PTHR45652:SF21', NULL, NULL, NULL, NULL, 'IF ROD DOMAIN-CONTAINING PROTEIN', 240766),
(315160, 'PTHR45652:SF20', NULL, NULL, NULL, NULL, 'IF ROD DOMAIN-CONTAINING PROTEIN', 240766),
(315161, 'PTHR45652', NULL, NULL, NULL, NULL, 'GLIAL FIBRILLARY ACIDIC PROTEIN', 240766),
(315162, 'PTHR45652:SF8', NULL, NULL, NULL, NULL, 'NEUROFILAMENT LIGHT POLYPEPTIDE', 240766),
(315163, 'PTHR45652:SF7', NULL, NULL, NULL, NULL, 'VIMENTIN-RELATED 2', 240766),
(315164, 'PTHR45652:SF5', NULL, NULL, NULL, NULL, 'VIMENTIN', 240766),
(315165, 'PTHR45652:SF4', NULL, NULL, NULL, NULL, 'SI:DKEY-33C12.3', 240766),
(315166, 'PTHR45652:SF3', NULL, NULL, NULL, NULL, 'NEUROFILAMENT MEDIUM POLYPEPTIDE', 240766),
(315167, 'PTHR45652:SF19', NULL, NULL, NULL, NULL, 'DESMIN B', 240766),
(315168, 'PTHR45652:SF2', NULL, NULL, NULL, NULL, 'DESMIN', 240766),
(315169, 'PTHR45652:SF18', NULL, NULL, NULL, NULL, 'ALPHA-INTERNEXIN', 240766),
(315170, 'PTHR24330:SF12', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN BARH-LIKE 1', 240767),
(315171, 'PTHR24330:SF10', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN B-H1-RELATED', 240767),
(315172, 'PTHR24330:SF4', NULL, NULL, NULL, NULL, 'BARH-LIKE 2 HOMEOBOX PROTEIN', 240767),
(315173, 'PTHR24330:SF18', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN CEH-31', 240767),
(315174, 'PTHR24330:SF19', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 29', 240767);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(315175, 'PTHR24330:SF5', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN BARH-LIKE 1B', 240767),
(315176, 'PTHR24330', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN BARH-LIKE', 240767),
(315177, 'PTHR24330:SF6', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 240767),
(315178, 'PTHR24330:SF7', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN BARH-LIKE 2', 240767),
(315179, 'PTHR24330:SF8', NULL, NULL, NULL, NULL, 'BARH-LIKE 1 HOMEOBOX PROTEIN', 240767),
(315180, 'PTHR47292', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR (TFIIS) FAMILY PROTEIN-RELATED', 240768),
(315181, 'PTHR47292:SF3', NULL, NULL, NULL, NULL, '', 240768),
(315182, 'PTHR47292:SF5', NULL, NULL, NULL, NULL, 'BNAA03G46610D PROTEIN', 240768),
(315183, 'PTHR47292:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR (TFIIS) FAMILY PROTEIN', 240768),
(315184, 'PTHR24103:SF595', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 14', 240769),
(315185, 'PTHR24103:SF397', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM17', 240769),
(315186, 'PTHR24103:SF672', NULL, NULL, NULL, NULL, 'MITSUGUMIN-53', 240769),
(315187, 'PTHR24103:SF596', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 54', 240769),
(315188, 'PTHR24103:SF233', NULL, NULL, NULL, NULL, '', 240769),
(315189, 'PTHR24103:SF673', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING 63B-RELATED', 240769),
(315190, 'PTHR24103:SF597', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 44', 240769),
(315191, 'PTHR24103:SF674', NULL, NULL, NULL, NULL, 'RET FINGER PROTEIN-LIKE 1-RELATED', 240769),
(315192, 'PTHR24103:SF312', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 75-RELATED', 240769),
(315193, 'PTHR24103:SF675', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 240769),
(315194, 'PTHR24103:SF554', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING 35-28', 240769),
(315195, 'PTHR24103:SF676', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIML1-RELATED', 240769),
(315196, 'PTHR24103:SF632', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 48', 240769),
(315197, 'PTHR24103:SF677', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 61-RELATED', 240769),
(315198, 'PTHR24103:SF633', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING 108-RELATED', 240769),
(315199, 'PTHR24103:SF678', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 43', 240769),
(315200, 'PTHR24103:SF557', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 240769),
(315201, 'PTHR24103:SF635', NULL, NULL, NULL, NULL, 'BLOODTHIRSTY-RELATED GENE FAMILY, MEMBER 2', 240769),
(315202, 'PTHR24103:SF679', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE TRIM40', 240769),
(315203, 'PTHR24103:SF590', NULL, NULL, NULL, NULL, 'SI:CH211-120G10.1-RELATED', 240769),
(315204, 'PTHR24103:SF393', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM58', 240769),
(315205, 'PTHR24103:SF670', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM4', 240769),
(315206, 'PTHR24103:SF671', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING 107', 240769),
(315207, 'PTHR24103:SF637', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 49-RELATED', 240769),
(315208, 'PTHR24103:SF639', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM39', 240769),
(315209, 'PTHR24103:SF683', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING 52', 240769),
(315210, 'PTHR24103:SF562', NULL, NULL, NULL, NULL, '', 240769),
(315211, 'PTHR24103:SF640', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 55', 240769),
(315212, 'PTHR24103:SF684', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR 7', 240769),
(315213, 'PTHR24103:SF51', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 6', 240769),
(315214, 'PTHR24103:SF564', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE TRIM40', 240769),
(315215, 'PTHR24103:SF600', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 64-RELATED', 240769),
(315216, 'PTHR24103:SF644', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 135', 240769),
(315217, 'PTHR24103:SF369', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 26', 240769);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(315218, 'PTHR24103:SF567', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 77', 240769),
(315219, 'PTHR24103:SF326', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM50', 240769),
(315220, 'PTHR24103:SF568', NULL, NULL, NULL, NULL, 'B BOX AND SPRY DOMAIN-CONTAINING PROTEIN', 240769),
(315221, 'PTHR24103:SF646', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 39', 240769),
(315222, 'PTHR24103:SF602', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING 101', 240769),
(315223, 'PTHR24103:SF569', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF CONTAINING 65', 240769),
(315224, 'PTHR24103:SF680', NULL, NULL, NULL, NULL, 'SI:CH73-54F23.4', 240769),
(315225, 'PTHR24103:SF11', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 72', 240769),
(315226, 'PTHR24103:SF362', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN RFP', 240769),
(315227, 'PTHR24103:SF681', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MIDLINE-1', 240769),
(315228, 'PTHR24103:SF682', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN/ISG15 LIGASE TRIM25-LIKE', 240769),
(315229, 'PTHR24103:SF561', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIML2-RELATED', 240769),
(315230, 'PTHR24103:SF286', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM69', 240769),
(315231, 'PTHR24103:SF647', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 34', 240769),
(315232, 'PTHR24103:SF329', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 10', 240769),
(315233, 'PTHR24103:SF648', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM11-RELATED', 240769),
(315234, 'PTHR24103:SF649', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING 51G, PSEUDOGENE', 240769),
(315235, 'PTHR24103:SF606', NULL, NULL, NULL, NULL, 'PYRIN', 240769),
(315236, 'PTHR24103:SF609', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM13', 240769),
(315237, 'PTHR24103:SF650', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM22', 240769),
(315238, 'PTHR24103:SF573', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM62', 240769),
(315239, 'PTHR24103:SF574', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 51', 240769),
(315240, 'PTHR24103:SF652', NULL, NULL, NULL, NULL, 'CABZ01076234.2-RELATED', 240769),
(315241, 'PTHR24103:SF575', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 64C', 240769),
(315242, 'PTHR24103:SF653', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING 30C-RELATED', 240769),
(315243, 'PTHR24103:SF654', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN/ISG15 LIGASE TRIM25-LIKE', 240769),
(315244, 'PTHR24103:SF259', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 15', 240769),
(315245, 'PTHR24103:SF578', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 77-LIKE', 240769),
(315246, 'PTHR24103:SF611', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM7', 240769),
(315247, 'PTHR24103:SF337', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING 105', 240769),
(315248, 'PTHR24103:SF657', NULL, NULL, NULL, NULL, 'RET FINGER PROTEIN-LIKE 3', 240769),
(315249, 'PTHR24103:SF613', NULL, NULL, NULL, NULL, '', 240769),
(315250, 'PTHR24103:SF47', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM38', 240769),
(315251, 'PTHR24103:SF46', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM21', 240769),
(315252, 'PTHR24103:SF89', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM68', 240769),
(315253, 'PTHR24103:SF570', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM63', 240769),
(315254, 'PTHR24103:SF87', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM31', 240769),
(315255, 'PTHR24103:SF416', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 5', 240769),
(315256, 'PTHR24103:SF615', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 49B-RELATED', 240769),
(315257, 'PTHR24103:SF659', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM41', 240769),
(315258, 'PTHR24103:SF617', NULL, NULL, NULL, NULL, 'B30.2/SPRY DOMAIN-CONTAINING PROTEIN-RELATED', 240769),
(315259, 'PTHR24103:SF661', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 49D', 240769);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(315260, 'PTHR24103:SF662', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 73-RELATED', 240769),
(315261, 'PTHR24103:SF586', NULL, NULL, NULL, NULL, 'BLOODTHIRSTY-RELATED GENE FAMILY, MEMBER 31-RELATED', 240769),
(315262, 'PTHR24103:SF620', NULL, NULL, NULL, NULL, 'SI:DKEY-219E21.2', 240769),
(315263, 'PTHR24103:SF664', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 75-RELATED', 240769),
(315264, 'PTHR24103:SF621', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 43B', 240769),
(315265, 'PTHR24103:SF588', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 240769),
(315266, 'PTHR24103:SF665', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM35', 240769),
(315267, 'PTHR24103:SF666', NULL, NULL, NULL, NULL, 'RET FINGER PROTEIN-LIKE 4A-RELATED', 240769),
(315268, 'PTHR24103:SF304', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 60', 240769),
(315269, 'PTHR24103:SF667', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING 69', 240769),
(315270, 'PTHR24103:SF668', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF CONTAINING 25', 240769),
(315271, 'PTHR24103:SF624', NULL, NULL, NULL, NULL, '', 240769),
(315272, 'PTHR24103', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM', 240769),
(315273, 'PTHR24103:SF582', NULL, NULL, NULL, NULL, '', 240769),
(315274, 'PTHR24103:SF669', NULL, NULL, NULL, NULL, 'SI:CH211-28P3.4', 240769),
(315275, 'PTHR24103:SF629', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM39-LIKE', 240769),
(315276, 'PTHR22997:SF10', NULL, NULL, NULL, NULL, 'PIH1_CS DOMAIN-CONTAINING PROTEIN', 240770),
(315277, 'PTHR22997', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 240770),
(315278, 'PTHR22997:SF8', NULL, NULL, NULL, NULL, 'PIH1 DOMAIN-CONTAINING PROTEIN', 240770),
(315279, 'PTHR22997:SF7', NULL, NULL, NULL, NULL, '', 240770),
(315280, 'PTHR22997:SF6', NULL, NULL, NULL, NULL, 'PIH1 DOMAIN-CONTAINING PROTEIN 2', 240770),
(315281, 'PTHR22997:SF11', NULL, NULL, NULL, NULL, 'PIH1 DOMAIN-CONTAINING PROTEIN', 240770),
(315282, 'PTHR22997:SF3', NULL, NULL, NULL, NULL, 'PROTEIN KINTOUN', 240770),
(315283, 'PTHR22997:SF0', NULL, NULL, NULL, NULL, 'PIH1 DOMAIN-CONTAINING PROTEIN 1', 240770),
(315284, 'PTHR30473:SF1', NULL, NULL, NULL, NULL, 'PHOH-LIKE PROTEIN', 240771),
(315285, 'PTHR30473:SF2', NULL, NULL, NULL, NULL, 'PINC DOMAIN-CONTAINING PROTEIN', 240771),
(315286, 'PTHR30473:SF3', NULL, NULL, NULL, NULL, 'PROTEIN PHOH', 240771),
(315287, 'PTHR30473', NULL, NULL, NULL, NULL, 'PROTEIN PHOH', 240771),
(315288, 'PTHR11056:SF4', NULL, NULL, NULL, NULL, 'HOMOGENTISATE 1,2-DIOXYGENASE', 240772),
(315289, 'PTHR11056:SF5', NULL, NULL, NULL, NULL, 'HOMOGENTISATE 1,2-DIOXYGENASE', 240772),
(315290, 'PTHR11056:SF0', NULL, NULL, NULL, NULL, 'HOMOGENTISATE 1,2-DIOXYGENASE', 240772),
(315291, 'PTHR11056', NULL, NULL, NULL, NULL, 'HOMOGENTISATE 1,2-DIOXYGENASE', 240772),
(315292, 'PTHR37970:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG08588', 240773),
(315293, 'PTHR37970', NULL, NULL, NULL, NULL, 'PROTEIN CBG08587', 240773),
(315294, 'PTHR46765:SF1', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN', 240774),
(315295, 'PTHR46765', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN', 240774),
(315296, 'PTHR33415', NULL, NULL, NULL, NULL, 'PROTEIN EMBRYO DEFECTIVE 514', 240775),
(315297, 'PTHR33415:SF19', NULL, NULL, NULL, NULL, 'REQUIRED TO MAINTAIN REPRESSION6', 240775),
(315298, 'PTHR33415:SF15', NULL, NULL, NULL, NULL, 'PROTEIN DCL HOMOLOG, CHLOROPLASTIC', 240775),
(315299, 'PTHR33415:SF12', NULL, NULL, NULL, NULL, 'PROTEIN EMBRYO DEFECTIVE 514', 240775),
(315300, 'PTHR33415:SF4', NULL, NULL, NULL, NULL, 'DCL PROTEIN (DUF3223)', 240775),
(315301, 'PTHR33415:SF22', NULL, NULL, NULL, NULL, 'OS08G0308700 PROTEIN', 240775),
(315302, 'PTHR33415:SF21', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE IV SUBUNIT 1-LIKE', 240775),
(315303, 'PTHR33415:SF10', NULL, NULL, NULL, NULL, 'PROTEIN DCL, CHLOROPLASTIC-LIKE', 240775),
(315304, 'PTHR33415:SF20', NULL, NULL, NULL, NULL, 'BNACNNG45980D PROTEIN', 240775);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(315305, 'PTHR43200:SF8', NULL, NULL, NULL, NULL, 'PAP-SPECIFIC PHOSPHATASE, MITOCHONDRIAL ISOFORM X1-RELATED', 240776),
(315306, 'PTHR43200', NULL, NULL, NULL, NULL, 'PHOSPHATASE', 240776),
(315307, 'PTHR43200:SF11', NULL, NULL, NULL, NULL, 'SAL2 PHOSPHATASE-RELATED', 240776),
(315308, 'PTHR43200:SF22', NULL, NULL, NULL, NULL, '3''(2''),5''-BISPHOSPHATE NUCLEOTIDASE', 240776),
(315309, 'PTHR43200:SF12', NULL, NULL, NULL, NULL, 'SAL3 PHOSPHATASE-RELATED', 240776),
(315310, 'PTHR43200:SF24', NULL, NULL, NULL, NULL, 'PAP-SPECIFIC PHOSPHATASE HAL2-LIKE', 240776),
(315311, 'PTHR43200:SF13', NULL, NULL, NULL, NULL, '', 240776),
(315312, 'PTHR43200:SF25', NULL, NULL, NULL, NULL, '3''(2''),5''-BISPHOSPHATE NUCLEOTIDASE', 240776),
(315313, 'PTHR43200:SF17', NULL, NULL, NULL, NULL, '3''(2''),5''-BISPHOSPHATE NUCLEOTIDASE', 240776),
(315314, 'PTHR43200:SF18', NULL, NULL, NULL, NULL, '3''(2''),5''-BISPHOSPHATE NUCLEOTIDASE', 240776),
(315315, 'PTHR43200:SF7', NULL, NULL, NULL, NULL, 'OS12G0183200 PROTEIN', 240776),
(315316, 'PTHR43200:SF6', NULL, NULL, NULL, NULL, '3''(2''),5''-BISPHOSPHATE NUCLEOTIDASE', 240776),
(315317, 'PTHR43200:SF4', NULL, NULL, NULL, NULL, 'PAP-SPECIFIC PHOSPHATASE, MITOCHONDRIAL-RELATED', 240776),
(315318, 'PTHR43200:SF2', NULL, NULL, NULL, NULL, '3''(2''),5''-BISPHOSPHATE NUCLEOTIDASE', 240776),
(315319, 'PTHR43200:SF21', NULL, NULL, NULL, NULL, '3''(2''),5''-BISPHOSPHATE NUCLEOTIDASE', 240776),
(315320, 'PTHR39082', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE C-BETA-2-RELATED', 240777),
(315321, 'PTHR39082:SF1', NULL, NULL, NULL, NULL, 'ZF-RING_7 DOMAIN-CONTAINING PROTEIN', 240777),
(315322, 'PTHR35763:SF3', NULL, NULL, NULL, NULL, '', 240778),
(315323, 'PTHR35763:SF2', NULL, NULL, NULL, NULL, 'BNACNNG32740D PROTEIN', 240778),
(315324, 'PTHR35763:SF1', NULL, NULL, NULL, NULL, 'COMPLEX 1 LYR-LIKE PROTEIN', 240778),
(315325, 'PTHR35763', NULL, NULL, NULL, NULL, 'COMPLEX 1 LYR-LIKE PROTEIN', 240778),
(315326, 'PTHR43515', NULL, NULL, NULL, NULL, 'THREONINE SYNTHASE-LIKE 1', 240779),
(315327, 'PTHR43515:SF1', NULL, NULL, NULL, NULL, 'THREONINE SYNTHASE-LIKE 1', 240779),
(315328, 'PTHR24252', NULL, NULL, NULL, NULL, 'ACROSIN-RELATED', 240780),
(315329, 'PTHR24252:SF6', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE SERINE PROTEASE 15', 240780),
(315330, 'PTHR24252:SF7', NULL, NULL, NULL, NULL, 'CUB DOMAIN-CONTAINING PROTEIN', 240780),
(315331, 'PTHR24252:SF8', NULL, NULL, NULL, NULL, 'ACROSIN', 240780),
(315332, 'PTHR46999:SF5', NULL, NULL, NULL, NULL, 'PPDK_N DOMAIN-CONTAINING PROTEIN', 240781),
(315333, 'PTHR46999', NULL, NULL, NULL, NULL, 'ALPHA-GLUCAN WATER DIKINASE 1, CHLOROPLASTIC-RELATED', 240781),
(315334, 'PTHR46999:SF4', NULL, NULL, NULL, NULL, 'ALPHA-GLUCAN WATER DIKINASE 2', 240781),
(315335, 'PTHR46999:SF6', NULL, NULL, NULL, NULL, 'PYRUVATE, PHOSPHATE DIKINASE-RELATED', 240781),
(315336, 'PTHR46999:SF9', NULL, NULL, NULL, NULL, 'PPDK_N DOMAIN-CONTAINING PROTEIN', 240781),
(315337, 'PTHR46999:SF1', NULL, NULL, NULL, NULL, 'ALPHA-GLUCAN WATER DIKINASE 1, CHLOROPLASTIC', 240781),
(315338, 'PTHR46999:SF2', NULL, NULL, NULL, NULL, 'CARBOHYDRATE-BINDING MODULE FAMILY 45 PROTEIN', 240781),
(315339, 'PTHR32263:SF14', NULL, NULL, NULL, NULL, 'INACTIVE POLY [ADP-RIBOSE] POLYMERASE SRO2-RELATED', 240782),
(315340, 'PTHR32263:SF15', NULL, NULL, NULL, NULL, 'INACTIVE POLY [ADP-RIBOSE] POLYMERASE RCD1', 240782),
(315341, 'PTHR32263:SF37', NULL, NULL, NULL, NULL, 'WWE PROTEIN-PROTEIN INTERACTION DOMAIN PROTEIN FAMILY-RELATED', 240782),
(315342, 'PTHR32263:SF26', NULL, NULL, NULL, NULL, 'POLY [ADP-RIBOSE] POLYMERASE', 240782),
(315343, 'PTHR32263:SF12', NULL, NULL, NULL, NULL, 'INACTIVE POLY [ADP-RIBOSE] POLYMERASE SRO4-RELATED', 240782),
(315344, 'PTHR32263:SF23', NULL, NULL, NULL, NULL, 'INACTIVE POLY [ADP-RIBOSE] POLYMERASE SRO4', 240782),
(315345, 'PTHR32263:SF24', NULL, NULL, NULL, NULL, 'INACTIVE POLY [ADP-RIBOSE] POLYMERASE RCD1-LIKE', 240782),
(315346, 'PTHR32263:SF13', NULL, NULL, NULL, NULL, 'OS06G0248400 PROTEIN', 240782),
(315347, 'PTHR32263:SF35', NULL, NULL, NULL, NULL, 'POLY [ADP-RIBOSE] POLYMERASE', 240782);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(315348, 'PTHR32263:SF10', NULL, NULL, NULL, NULL, 'OS10G0577800 PROTEIN', 240782),
(315349, 'PTHR32263:SF22', NULL, NULL, NULL, NULL, 'PARP CATALYTIC DOMAIN-CONTAINING PROTEIN', 240782),
(315350, 'PTHR32263:SF11', NULL, NULL, NULL, NULL, 'INACTIVE POLY [ADP-RIBOSE] POLYMERASE RCD1-LIKE ISOFORM X1', 240782),
(315351, 'PTHR32263:SF30', NULL, NULL, NULL, NULL, 'BNAA09G30950D PROTEIN', 240782),
(315352, 'PTHR32263:SF31', NULL, NULL, NULL, NULL, 'POLY [ADP-RIBOSE] POLYMERASE', 240782),
(315353, 'PTHR32263:SF40', NULL, NULL, NULL, NULL, 'BNAA05G08530D PROTEIN', 240782),
(315354, 'PTHR32263:SF5', NULL, NULL, NULL, NULL, 'INACTIVE POLY [ADP-RIBOSE] POLYMERASE SRO1-RELATED', 240782),
(315355, 'PTHR32263', NULL, NULL, NULL, NULL, 'INACTIVE POLY [ADP-RIBOSE] POLYMERASE SRO4-RELATED', 240782),
(315356, 'PTHR32263:SF19', NULL, NULL, NULL, NULL, 'OS03G0230300 PROTEIN', 240782),
(315357, 'PTHR32263:SF16', NULL, NULL, NULL, NULL, 'INACTIVE POLY [ADP-RIBOSE] POLYMERASE SRO3-RELATED', 240782),
(315358, 'PTHR32263:SF38', NULL, NULL, NULL, NULL, 'POLY [ADP-RIBOSE] POLYMERASE', 240782),
(315359, 'PTHR32263:SF28', NULL, NULL, NULL, NULL, 'BNAC03G74760D PROTEIN', 240782),
(315360, 'PTHR32263:SF17', NULL, NULL, NULL, NULL, 'POLY [ADP-RIBOSE] POLYMERASE', 240782),
(315361, 'PTHR32263:SF39', NULL, NULL, NULL, NULL, 'RST DOMAIN-CONTAINING PROTEIN', 240782),
(315362, 'PTHR33074:SF63', NULL, NULL, NULL, NULL, 'OS02G0113300 PROTEIN', 240783),
(315363, 'PTHR33074:SF62', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240783),
(315364, 'PTHR33074:SF109', NULL, NULL, NULL, NULL, 'OS01G0601950 PROTEIN', 240783),
(315365, 'PTHR33074:SF60', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783),
(315366, 'PTHR33074:SF66', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783),
(315367, 'PTHR33074', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', 240783),
(315368, 'PTHR33074:SF108', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783),
(315369, 'PTHR33074:SF103', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783),
(315370, 'PTHR33074:SF102', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783),
(315371, 'PTHR33074:SF100', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783),
(315372, 'PTHR33074:SF68', NULL, NULL, NULL, NULL, 'OS09G0557100 PROTEIN', 240783),
(315373, 'PTHR33074:SF74', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783),
(315374, 'PTHR33074:SF72', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783),
(315375, 'PTHR33074:SF77', NULL, NULL, NULL, NULL, 'OS03G0178900 PROTEIN', 240783),
(315376, 'PTHR33074:SF76', NULL, NULL, NULL, NULL, 'OS11G0569701 PROTEIN', 240783),
(315377, 'PTHR33074:SF75', NULL, NULL, NULL, NULL, 'OS01G0189800 PROTEIN', 240783),
(315378, 'PTHR33074:SF79', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240783),
(315379, 'PTHR33074:SF41', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783),
(315380, 'PTHR33074:SF85', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783),
(315381, 'PTHR33074:SF83', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240783),
(315382, 'PTHR33074:SF89', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783),
(315383, 'PTHR33074:SF129', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783),
(315384, 'PTHR33074:SF87', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783),
(315385, 'PTHR33074:SF127', NULL, NULL, NULL, NULL, 'OS04G0388000 PROTEIN', 240783),
(315386, 'PTHR33074:SF128', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240783),
(315387, 'PTHR33074:SF42', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783),
(315388, 'PTHR33074:SF125', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783),
(315389, 'PTHR33074:SF126', NULL, NULL, NULL, NULL, 'OS07G0633300 PROTEIN', 240783),
(315390, 'PTHR33074:SF123', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783),
(315391, 'PTHR33074:SF124', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(315392, 'PTHR33074:SF122', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783),
(315393, 'PTHR33074:SF49', NULL, NULL, NULL, NULL, 'OS07G0258000 PROTEIN', 240783),
(315394, 'PTHR33074:SF96', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240783),
(315395, 'PTHR33074:SF95', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240783),
(315396, 'PTHR33074:SF50', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783),
(315397, 'PTHR33074:SF93', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783),
(315398, 'PTHR33074:SF99', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783),
(315399, 'PTHR33074:SF119', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783),
(315400, 'PTHR33074:SF98', NULL, NULL, NULL, NULL, 'OS09G0567000 PROTEIN', 240783),
(315401, 'PTHR33074:SF97', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783),
(315402, 'PTHR33074:SF53', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783),
(315403, 'PTHR33074:SF114', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783),
(315404, 'PTHR33074:SF113', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783),
(315405, 'PTHR33074:SF92', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783),
(315406, 'PTHR33074:SF110', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783),
(315407, 'PTHR33074:SF91', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783),
(315408, 'PTHR33074:SF90', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783),
(315409, 'PTHR33074:SF14', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783),
(315410, 'PTHR33074:SF57', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 240783),
(315411, 'PTHR33074:SF18', NULL, NULL, NULL, NULL, 'OS06G0718700 PROTEIN', 240783),
(315412, 'PTHR46117:SF2', NULL, NULL, NULL, NULL, 'UPSTREAM STIMULATORY FACTOR 2', 240784),
(315413, 'PTHR46117:SF3', NULL, NULL, NULL, NULL, 'FI24210P1', 240784),
(315414, 'PTHR46117:SF1', NULL, NULL, NULL, NULL, 'UPSTREAM STIMULATORY FACTOR 1', 240784),
(315415, 'PTHR46117', NULL, NULL, NULL, NULL, 'FI24210P1', 240784),
(315416, 'PTHR38332', NULL, NULL, NULL, NULL, 'PROTEIN CBG11604', 240785),
(315417, 'PTHR38332:SF1', NULL, NULL, NULL, NULL, 'RE49668P', 240785),
(315418, 'PTHR38332:SF2', NULL, NULL, NULL, NULL, 'PROTEIN QUIVER', 240785),
(315419, 'PTHR15177', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 143', 240786),
(315420, 'PTHR15177:SF2', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 143', 240786),
(315421, 'PTHR12959', NULL, NULL, NULL, NULL, 'GPI TRANSAMIDASE COMPONENT PIG-T-RELATED', 240787),
(315422, 'PTHR12959:SF11', NULL, NULL, NULL, NULL, 'GPI TRANSAMIDASE COMPONENT PIG-T', 240787),
(315423, 'PTHR12959:SF13', NULL, NULL, NULL, NULL, '', 240787),
(315424, 'PTHR47702', NULL, NULL, NULL, NULL, 'RETROTRANSPOSON GAG-LIKE PROTEIN 9', 240788),
(315425, 'PTHR47702:SF1', NULL, NULL, NULL, NULL, 'RETROTRANSPOSON GAG-LIKE PROTEIN 9', 240788),
(315426, 'PTHR12144:SF0', NULL, NULL, NULL, NULL, 'NEGATIVE ELONGATION FACTOR C/D', 240789),
(315427, 'PTHR12144', NULL, NULL, NULL, NULL, 'NEGATIVE ELONGATION FACTOR D', 240789),
(315428, 'PTHR33966', NULL, NULL, NULL, NULL, 'PROTEIN ODR-4 HOMOLOG', 240790),
(315429, 'PTHR33966:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ODR-4 HOMOLOG', 240790),
(315430, 'PTHR20903:SF0', NULL, NULL, NULL, NULL, 'PREFOLDIN SUBUNIT 1', 240791),
(315431, 'PTHR20903:SF2', NULL, NULL, NULL, NULL, '', 240791),
(315432, 'PTHR20903:SF1', NULL, NULL, NULL, NULL, 'PREFOLDIN SUBUNIT 1', 240791),
(315433, 'PTHR20903', NULL, NULL, NULL, NULL, 'PREFOLDIN SUBUNIT 1-RELATED', 240791),
(315434, 'PTHR35325:SF1', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REACTION CENTER PROTEIN K', 240792),
(315435, 'PTHR35325:SF6', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REACTION CENTER PROTEIN K', 240792),
(315436, 'PTHR35325:SF5', NULL, NULL, NULL, NULL, '', 240792),
(315437, 'PTHR35325:SF4', NULL, NULL, NULL, NULL, '', 240792),
(315438, 'PTHR35325:SF3', NULL, NULL, NULL, NULL, '', 240792);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(315439, 'PTHR35325:SF7', NULL, NULL, NULL, NULL, '', 240792),
(315440, 'PTHR35325', NULL, NULL, NULL, NULL, '', 240792),
(315441, 'PTHR15735:SF21', NULL, NULL, NULL, NULL, 'PROTEIN NERVOUS WRECK', 240793),
(315442, 'PTHR15735:SF20', NULL, NULL, NULL, NULL, 'HIGH OSMOLARITY SIGNALING PROTEIN SHO1', 240793),
(315443, 'PTHR15735:SF12', NULL, NULL, NULL, NULL, 'CDC42-INTERACTING PROTEIN 4, ISOFORM B', 240793),
(315444, 'PTHR15735:SF11', NULL, NULL, NULL, NULL, 'F-BAR AND DOUBLE SH3 DOMAINS PROTEIN 2', 240793),
(315445, 'PTHR15735:SF22', NULL, NULL, NULL, NULL, 'FORMIN-BINDING PROTEIN 1A', 240793),
(315446, 'PTHR15735:SF17', NULL, NULL, NULL, NULL, 'CDC42-INTERACTING PROTEIN 4', 240793),
(315447, 'PTHR15735', NULL, NULL, NULL, NULL, 'FCH AND DOUBLE SH3 DOMAINS PROTEIN', 240793),
(315448, 'PTHR15735:SF19', NULL, NULL, NULL, NULL, 'ACTIN CYTOSKELETON-REGULATORY COMPLEX PROTEIN SLA1', 240793),
(315449, 'PTHR15735:SF14', NULL, NULL, NULL, NULL, 'FORMIN-BINDING PROTEIN 1-LIKE', 240793),
(315450, 'PTHR15735:SF13', NULL, NULL, NULL, NULL, 'FORMIN-BINDING PROTEIN 1', 240793),
(315451, 'PTHR15735:SF4', NULL, NULL, NULL, NULL, 'F-BAR AND DOUBLE SH3 DOMAINS PROTEIN 1', 240793),
(315452, 'PTHR15735:SF16', NULL, NULL, NULL, NULL, 'TRANSDUCER OF CDC42-DEPENDENT ACTIN ASSEMBLY PROTEIN 2 HOMOLOG', 240793),
(315453, 'PTHR46221:SF2', NULL, NULL, NULL, NULL, 'FERM AND PDZ DOMAIN-CONTAINING PROTEIN 1', 240794),
(315454, 'PTHR46221:SF3', NULL, NULL, NULL, NULL, 'FERM DOMAIN (PROTEIN4.1-EZRIN-RADIXIN-MOESIN) FAMILY', 240794),
(315455, 'PTHR46221:SF1', NULL, NULL, NULL, NULL, 'FERM AND PDZ DOMAIN-CONTAINING PROTEIN 3', 240794),
(315456, 'PTHR46221', NULL, NULL, NULL, NULL, 'FERM AND PDZ DOMAIN-CONTAINING PROTEIN FAMILY MEMBER', 240794),
(315457, 'PTHR46221:SF7', NULL, NULL, NULL, NULL, 'NON-SPECIFIC PROTEIN-TYROSINE KINASE', 240794),
(315458, 'PTHR46221:SF4', NULL, NULL, NULL, NULL, 'FERM AND PDZ DOMAIN-CONTAINING PROTEIN 4', 240794),
(315459, 'PTHR46221:SF8', NULL, NULL, NULL, NULL, 'NON-SPECIFIC PROTEIN-TYROSINE KINASE', 240794),
(315460, 'PTHR46221:SF9', NULL, NULL, NULL, NULL, 'NON-SPECIFIC PROTEIN-TYROSINE KINASE', 240794),
(315461, 'PTHR15282:SF10', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY E MEMBER 1-RELATED', 240795),
(315462, 'PTHR15282:SF11', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY E MEMBER 1', 240795),
(315463, 'PTHR15282', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY E MEMBER 1, 3', 240795),
(315464, 'PTHR15282:SF9', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY E MEMBER 4', 240795),
(315465, 'PTHR15282:SF8', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY E MEMBER 2', 240795),
(315466, 'PTHR15282:SF7', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY E REGULATORY BETA SUBUNIT 5', 240795),
(315467, 'PTHR15282:SF6', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY E MEMBER 3', 240795),
(315468, 'PTHR47659:SF1', NULL, NULL, NULL, NULL, 'GLUCOSE STARVATION MODULATOR PROTEIN 1', 240796),
(315469, 'PTHR47659', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 240796),
(315470, 'PTHR47659:SF4', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 240796),
(315471, 'PTHR47659:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ACTIVATOR OF GLUCONEOGENESIS ERT1', 240796),
(315472, 'PTHR37261', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S27', 240797),
(315473, 'PTHR37261:SF1', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S27', 240797),
(315474, 'PTHR11051', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE-RELATED', 240798),
(315475, 'PTHR11051:SF13', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE-RELATED', 240798),
(315476, 'PTHR11051:SF15', NULL, NULL, NULL, NULL, '', 240798),
(315477, 'PTHR11051:SF14', NULL, NULL, NULL, NULL, 'MALTOSE PHOSPHORYLASE', 240798),
(315478, 'PTHR11051:SF8', NULL, NULL, NULL, NULL, 'PROTEIN-GLUCOSYLGALACTOSYLHYDROXYLYSINE GLUCOSIDASE', 240798),
(315479, 'PTHR12468', NULL, NULL, NULL, NULL, 'GPI MANNOSYLTRANSFERASE 2', 240799);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(315480, 'PTHR12468:SF4', NULL, NULL, NULL, NULL, 'GPI MANNOSYLTRANSFERASE 2', 240799),
(315481, 'PTHR12468:SF2', NULL, NULL, NULL, NULL, 'GPI MANNOSYLTRANSFERASE 2', 240799),
(315482, 'PTHR48193', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEASE ZMPB-RELATED', 240800),
(315483, 'PTHR48193:SF2', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEASE ZMPB', 240800),
(315484, 'PTHR36755', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 240801),
(315485, 'PTHR36755:SF1', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 240801),
(315486, 'PTHR36755:SF2', NULL, NULL, NULL, NULL, '', 240801),
(315487, 'PTHR12691', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 23', 240802),
(315488, 'PTHR12691:SF10', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 23', 240802),
(315489, 'PTHR12691:SF11', NULL, NULL, NULL, NULL, 'BNAA09G30010D PROTEIN', 240802),
(315490, 'PTHR42738:SF1', NULL, NULL, NULL, NULL, 'HYDROXYMETHYLGLUTARYL-COA LYASE, MITOCHONDRIAL', 240803),
(315491, 'PTHR42738:SF15', NULL, NULL, NULL, NULL, 'HYDROXYMETHYLGLUTARYL-COA LYASE', 240803),
(315492, 'PTHR42738:SF14', NULL, NULL, NULL, NULL, 'HYDROXYMETHYLGLUTARYL-COA LYASE', 240803),
(315493, 'PTHR42738', NULL, NULL, NULL, NULL, 'HYDROXYMETHYLGLUTARYL-COA LYASE', 240803),
(315494, 'PTHR42738:SF13', NULL, NULL, NULL, NULL, 'HYDROXYMETHYLGLUTARYL-COA LYASE', 240803),
(315495, 'PTHR42738:SF5', NULL, NULL, NULL, NULL, '3-HYDROXY-3-METHYLGLUTARYL-COA LYASE, CYTOPLASMIC', 240803),
(315496, 'PTHR42738:SF7', NULL, NULL, NULL, NULL, 'HYDROXYMETHYLGLUTARYL-COA LYASE', 240803),
(315497, 'PTHR42738:SF11', NULL, NULL, NULL, NULL, 'HYDROXYMETHYLGLUTARYL-COA LYASE', 240803),
(315498, 'PTHR36027:SF1', NULL, NULL, NULL, NULL, 'MEIOSIS-SPECIFIC PROTEIN ASY3', 240804),
(315499, 'PTHR36027', NULL, NULL, NULL, NULL, 'MEIOSIS-SPECIFIC PROTEIN ASY3', 240804),
(315500, 'PTHR33664:SF1', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL ASSEMBLY FACTOR 9', 240805),
(315501, 'PTHR33664', NULL, NULL, NULL, NULL, 'RCG26366', 240805),
(315502, 'PTHR40020', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY FACTOR 2', 240806),
(315503, 'PTHR40020:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY FACTOR 2', 240806),
(315504, 'PTHR13950:SF13', NULL, NULL, NULL, NULL, 'DMX-LIKE PROTEIN 2', 240807),
(315505, 'PTHR13950:SF12', NULL, NULL, NULL, NULL, 'DMX-LIKE PROTEIN 1', 240807),
(315506, 'PTHR13950', NULL, NULL, NULL, NULL, 'RABCONNECTIN-RELATED', 240807),
(315507, 'PTHR13950:SF9', NULL, NULL, NULL, NULL, 'RABCONNECTIN-3A', 240807),
(315508, 'PTHR48268', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN KNOTTED-1-LIKE 6 ISOFORM X1', 240808),
(315509, 'PTHR48268:SF2', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN KNOTTED-1-LIKE 6 ISOFORM X1', 240808),
(315510, 'PTHR48268:SF1', NULL, NULL, NULL, NULL, 'BNAA09G45470D PROTEIN', 240808),
(315511, 'PTHR43170:SF3', NULL, NULL, NULL, NULL, 'GMP REDUCTASE 1', 240809),
(315512, 'PTHR43170', NULL, NULL, NULL, NULL, 'GMP REDUCTASE', 240809),
(315513, 'PTHR43170:SF5', NULL, NULL, NULL, NULL, 'GMP REDUCTASE', 240809),
(315514, 'PTHR43170:SF4', NULL, NULL, NULL, NULL, 'GMP REDUCTASE 2', 240809),
(315515, 'PTHR31157:SF2', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 240810),
(315516, 'PTHR31157:SF5', NULL, NULL, NULL, NULL, '', 240810),
(315517, 'PTHR31157:SF28', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 240810),
(315518, 'PTHR31157:SF29', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 240810),
(315519, 'PTHR31157:SF4', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 240810),
(315520, 'PTHR31157:SF15', NULL, NULL, NULL, NULL, '', 240810),
(315521, 'PTHR31157:SF26', NULL, NULL, NULL, NULL, 'HYPOTHETICAL EXPORTED PROTEIN', 240810),
(315522, 'PTHR31157', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 240810),
(315523, 'PTHR31157:SF1', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 240810),
(315524, 'PTHR48229:SF2', NULL, NULL, NULL, NULL, 'CAIB/BAIF FAMILY PROTEIN', 240811),
(315525, 'PTHR48229', NULL, NULL, NULL, NULL, 'CAIB/BAIF FAMILY ENZYME (AFU_ORTHOLOGUE AFUA_1G05360)-RELATED', 240811);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(315526, 'PTHR48229:SF1', NULL, NULL, NULL, NULL, 'CAIB/BAIF FAMILY ENZYME (AFU_ORTHOLOGUE AFUA_1G05360)-RELATED', 240811),
(315527, 'PTHR46614', NULL, NULL, NULL, NULL, 'MORN REPEAT-CONTAINING PROTEIN 4', 240812),
(315528, 'PTHR46614:SF1', NULL, NULL, NULL, NULL, 'MORN REPEAT-CONTAINING PROTEIN 4', 240812),
(315529, 'PTHR47335', NULL, NULL, NULL, NULL, 'UNCONVENTIONAL MYOSIN-XVI', 240813),
(315530, 'PTHR47335:SF1', NULL, NULL, NULL, NULL, 'UNCONVENTIONAL MYOSIN-XVI', 240813),
(315531, 'PTHR39956:SF1', NULL, NULL, NULL, NULL, 'GH09530P-RELATED', 240814),
(315532, 'PTHR39956', NULL, NULL, NULL, NULL, 'GH09530P-RELATED', 240814),
(315533, 'PTHR28582', NULL, NULL, NULL, NULL, 'TRNA-SPLICING ENDONUCLEASE SUBUNIT SEN15', 240815),
(315534, 'PTHR28582:SF1', NULL, NULL, NULL, NULL, 'TRNA-SPLICING ENDONUCLEASE SUBUNIT SEN15', 240815),
(315535, 'PTHR15387', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 17', 240816),
(315536, 'PTHR15387:SF0', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 17', 240816),
(315537, 'PTHR24042:SF2', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C-BINDING PROTEIN NELL1', 240817),
(315538, 'PTHR24042', NULL, NULL, NULL, NULL, 'NEL HOMOLOG', 240817),
(315539, 'PTHR24042:SF0', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C-BINDING PROTEIN NELL2', 240817),
(315540, 'PTHR24042:SF5', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C-BINDING PROTEIN NELL1-LIKE PROTEIN', 240817),
(315541, 'PTHR24042:SF6', NULL, NULL, NULL, NULL, 'SI:CH211-252F13.5', 240817),
(315542, 'PTHR24042:SF3', NULL, NULL, NULL, NULL, 'EGF_CA DOMAIN-CONTAINING PROTEIN', 240817),
(315543, 'PTHR24042:SF7', NULL, NULL, NULL, NULL, 'SI:CH211-37E10.2', 240817),
(315544, 'PTHR35764:SF1', NULL, NULL, NULL, NULL, 'PROTEIN SHORTAGE IN CHIASMATA 1', 240818),
(315545, 'PTHR35764:SF4', NULL, NULL, NULL, NULL, '', 240818),
(315546, 'PTHR35764', NULL, NULL, NULL, NULL, 'PROTEIN SHORTAGE IN CHIASMATA 1', 240818),
(315547, 'PTHR28612:SF1', NULL, NULL, NULL, NULL, 'SERINE PALMITOYLTRANSFERASE SMALL SUBUNIT B', 240819),
(315548, 'PTHR28612', NULL, NULL, NULL, NULL, 'SERINE PALMITOYLTRANSFERASE SMALL SUBUNIT B', 240819),
(315549, 'PTHR31434', NULL, NULL, NULL, NULL, 'S PHASE CYCLIN A-ASSOCIATED PROTEIN IN THE ENDOPLASMIC RETICULUM', 240820),
(315550, 'PTHR31434:SF2', NULL, NULL, NULL, NULL, 'S PHASE CYCLIN A-ASSOCIATED PROTEIN IN THE ENDOPLASMIC RETICULUM', 240820),
(315551, 'PTHR36784:SF1', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE', 240821),
(315552, 'PTHR36784', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE', 240821),
(315553, 'PTHR47541:SF1', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 240822),
(315554, 'PTHR47541', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 240822),
(315555, 'PTHR31843:SF14', NULL, NULL, NULL, NULL, 'ALLENE-OXIDE CYCLASE', 240823),
(315556, 'PTHR31843:SF15', NULL, NULL, NULL, NULL, 'ALLENE-OXIDE CYCLASE', 240823),
(315557, 'PTHR31843', NULL, NULL, NULL, NULL, 'ALLENE OXIDE CYCLASE 4, CHLOROPLASTIC', 240823),
(315558, 'PTHR31843:SF16', NULL, NULL, NULL, NULL, 'ALLENE-OXIDE CYCLASE', 240823),
(315559, 'PTHR31843:SF9', NULL, NULL, NULL, NULL, 'ALLENE OXIDE CYCLASE 1, CHLOROPLASTIC-RELATED', 240823),
(315560, 'PTHR31843:SF10', NULL, NULL, NULL, NULL, 'ALLENE-OXIDE CYCLASE', 240823),
(315561, 'PTHR31843:SF11', NULL, NULL, NULL, NULL, 'ALLENE OXIDE CYCLASE 4, CHLOROPLASTIC', 240823),
(315562, 'PTHR31843:SF17', NULL, NULL, NULL, NULL, 'ALLENE-OXIDE CYCLASE', 240823),
(315563, 'PTHR31843:SF19', NULL, NULL, NULL, NULL, 'ALLENE OXIDE CYCLASE 3, CHLOROPLASTIC', 240823),
(315564, 'PTHR34784:SF1', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L34', 240824),
(315565, 'PTHR34784', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L34', 240824),
(315566, 'PTHR35477:SF5', NULL, NULL, NULL, NULL, 'BNAC01G44190D PROTEIN', 240825),
(315567, 'PTHR35477:SF6', NULL, NULL, NULL, NULL, '', 240825),
(315568, 'PTHR35477:SF3', NULL, NULL, NULL, NULL, 'PHD FINGER-LIKE PROTEIN', 240825),
(315569, 'PTHR35477:SF4', NULL, NULL, NULL, NULL, 'BNAA03G53370D PROTEIN', 240825);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(315570, 'PTHR35477:SF1', NULL, NULL, NULL, NULL, 'OS06G0728500 PROTEIN', 240825),
(315571, 'PTHR35477', NULL, NULL, NULL, NULL, 'OS06G0728500 PROTEIN', 240825),
(315572, 'PTHR35477:SF2', NULL, NULL, NULL, NULL, 'BNAC02G20790D PROTEIN', 240825),
(315573, 'PTHR19139', NULL, NULL, NULL, NULL, 'AQUAPORIN TRANSPORTER', 240826),
(315574, 'PTHR19139:SF281', NULL, NULL, NULL, NULL, 'MIP17260P', 240826),
(315575, 'PTHR19139:SF270', NULL, NULL, NULL, NULL, 'ENTOMOGLYCEROPORIN 1-RELATED', 240826),
(315576, 'PTHR19139:SF34', NULL, NULL, NULL, NULL, 'AQUAPORIN-4', 240826),
(315577, 'PTHR19139:SF45', NULL, NULL, NULL, NULL, 'AQUAPORIN-2', 240826),
(315578, 'PTHR19139:SF268', NULL, NULL, NULL, NULL, 'NEUROGENIC PROTEIN BIG BRAIN', 240826),
(315579, 'PTHR19139:SF38', NULL, NULL, NULL, NULL, 'AQUAPORIN-5', 240826),
(315580, 'PTHR19139:SF39', NULL, NULL, NULL, NULL, 'LENS FIBER MAJOR INTRINSIC PROTEIN', 240826),
(315581, 'PTHR19139:SF177', NULL, NULL, NULL, NULL, 'AQUAPORIN-14', 240826),
(315582, 'PTHR19139:SF199', NULL, NULL, NULL, NULL, 'AQUAPORIN', 240826),
(315583, 'PTHR19139:SF277', NULL, NULL, NULL, NULL, 'AQUAPORIN-0B', 240826),
(315584, 'PTHR19139:SF113', NULL, NULL, NULL, NULL, 'AQUAPORIN-6', 240826),
(315585, 'PTHR19139:SF161', NULL, NULL, NULL, NULL, 'AQUAPORIN-1', 240826),
(315586, 'PTHR19139:SF283', NULL, NULL, NULL, NULL, '', 240826),
(315587, 'PTHR19139:SF284', NULL, NULL, NULL, NULL, '', 240826),
(315588, 'PTHR19139:SF285', NULL, NULL, NULL, NULL, 'AQUAPORIN A-RELATED', 240826),
(315589, 'PTHR11387:SF32', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT', 240827),
(315590, 'PTHR11387:SF12', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 6B2', 240827),
(315591, 'PTHR11387:SF16', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 6B1', 240827),
(315592, 'PTHR11387', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 6B', 240827),
(315593, 'PTHR11387:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT', 240827),
(315594, 'PTHR11387:SF31', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT', 240827),
(315595, 'PTHR16866:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG24674', 240828),
(315596, 'PTHR16866', NULL, NULL, NULL, NULL, 'GASTRIN-RELEASING PEPTIDE', 240828),
(315597, 'PTHR16866:SF2', NULL, NULL, NULL, NULL, 'GASTRIN-RELEASING PEPTIDE', 240828),
(315598, 'PTHR16866:SF3', NULL, NULL, NULL, NULL, 'NEUROMEDIN-B', 240828),
(315599, 'PTHR31331:SF8', NULL, NULL, NULL, NULL, 'LCCL DOMAIN-CONTAINING PROTEIN', 240829),
(315600, 'PTHR31331:SF1', NULL, NULL, NULL, NULL, 'LCCL DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_5G08630)', 240829),
(315601, 'PTHR31331:SF7', NULL, NULL, NULL, NULL, 'LCCL DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_5G02970)', 240829),
(315602, 'PTHR31331', NULL, NULL, NULL, NULL, 'LCCL DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_5G08630)', 240829),
(315603, 'PTHR36300', NULL, NULL, NULL, NULL, 'RAW, ISOFORM A', 240830),
(315604, 'PTHR36300:SF1', NULL, NULL, NULL, NULL, 'RAW, ISOFORM A', 240830),
(315605, 'PTHR34559', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 8', 240831),
(315606, 'PTHR34559:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 8-2, MITOCHONDRIAL', 240831),
(315607, 'PTHR34559:SF1', NULL, NULL, NULL, NULL, 'OS06G0175900 PROTEIN', 240831),
(315608, 'PTHR34559:SF4', NULL, NULL, NULL, NULL, 'BNAA05G28070D PROTEIN', 240831),
(315609, 'PTHR34559:SF6', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 8-1, MITOCHONDRIAL', 240831),
(315610, 'PTHR34559:SF5', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 8-RELATED', 240831),
(315611, 'PTHR11608:SF0', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL PROTEIN PYRR', 240832),
(315612, 'PTHR11608', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL PROTEIN PYRR', 240832),
(315613, 'PTHR46013:SF8', NULL, NULL, NULL, NULL, 'SI:DKEY-24P1.1', 240833),
(315614, 'PTHR46013:SF7', NULL, NULL, NULL, NULL, 'UNC-89', 240833),
(315615, 'PTHR46013:SF4', NULL, NULL, NULL, NULL, 'CD22 MOLECULE-RELATED', 240833),
(315616, 'PTHR46013:SF1', NULL, NULL, NULL, NULL, 'VASCULAR CELL ADHESION MOLECULE 1B', 240833),
(315617, 'PTHR46013', NULL, NULL, NULL, NULL, 'VASCULAR CELL ADHESION MOLECULE 1', 240833);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(315618, 'PTHR10856:SF23', NULL, NULL, NULL, NULL, 'CORONIN-6', 240834),
(315619, 'PTHR10856', NULL, NULL, NULL, NULL, 'CORONIN', 240834),
(315620, 'PTHR10856:SF24', NULL, NULL, NULL, NULL, 'CORONIN-1B', 240834),
(315621, 'PTHR10856:SF43', NULL, NULL, NULL, NULL, 'CORONIN', 240834),
(315622, 'PTHR10856:SF10', NULL, NULL, NULL, NULL, 'CORONIN-1C', 240834),
(315623, 'PTHR10856:SF17', NULL, NULL, NULL, NULL, 'CORONIN-2B', 240834),
(315624, 'PTHR10856:SF0', NULL, NULL, NULL, NULL, 'CORONIN-LIKE PROTEIN', 240834),
(315625, 'PTHR10856:SF2', NULL, NULL, NULL, NULL, 'CORONIN-2A', 240834),
(315626, 'PTHR10856:SF18', NULL, NULL, NULL, NULL, 'CORONIN-1A', 240834),
(315627, 'PTHR10856:SF41', NULL, NULL, NULL, NULL, 'CORONIN', 240834),
(315628, 'PTHR10856:SF20', NULL, NULL, NULL, NULL, 'CORONIN-7', 240834),
(315629, 'PTHR10856:SF42', NULL, NULL, NULL, NULL, 'CORONIN-B', 240834),
(315630, 'PTHR35245:SF1', NULL, NULL, NULL, NULL, '', 240835),
(315631, 'PTHR35245', NULL, NULL, NULL, NULL, '', 240835),
(315632, 'PTHR12403:SF25', NULL, NULL, NULL, NULL, '', 240836),
(315633, 'PTHR12403:SF26', NULL, NULL, NULL, NULL, 'BNAA06G40850D PROTEIN', 240836),
(315634, 'PTHR12403:SF1', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT 2', 240836),
(315635, 'PTHR12403:SF28', NULL, NULL, NULL, NULL, 'BNAC09G18320D PROTEIN', 240836),
(315636, 'PTHR12403', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT 2', 240836),
(315637, 'PTHR12403:SF30', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT 2-RELATED', 240836),
(315638, 'PTHR12403:SF32', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 240836),
(315639, 'PTHR12403:SF33', NULL, NULL, NULL, NULL, 'TRAPP-ASSOCIATED PROTEIN TCA17', 240836),
(315640, 'PTHR12403:SF11', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT 2-LIKE PROTEIN', 240836),
(315641, 'PTHR12403:SF34', NULL, NULL, NULL, NULL, 'SNARE-LIKE SUPERFAMILY PROTEIN', 240836),
(315642, 'PTHR12403:SF23', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT 2-LIKE PROTEIN', 240836),
(315643, 'PTHR12403:SF12', NULL, NULL, NULL, NULL, 'RIKEN CDNA 0610009B22 GENE', 240836),
(315644, 'PTHR43393:SF2', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE', 240837),
(315645, 'PTHR43393:SF1', NULL, NULL, NULL, NULL, 'PYRIMIDINE/PURINE NUCLEOTIDE 5''-MONOPHOSPHATE NUCLEOSIDASE', 240837),
(315646, 'PTHR43393', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE', 240837),
(315647, 'PTHR24107:SF27', NULL, NULL, NULL, NULL, 'DYNEIN REGULATORY COMPLEX SUBUNIT 5', 240838),
(315648, 'PTHR24107:SF2', NULL, NULL, NULL, NULL, 'FI16513P1-RELATED', 240838),
(315649, 'PTHR24107:SF28', NULL, NULL, NULL, NULL, 'NLR FAMILY CARD DOMAIN CONTAINING 3', 240838),
(315650, 'PTHR24107:SF26', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN AAC1', 240838),
(315651, 'PTHR24107:SF4', NULL, NULL, NULL, NULL, 'NUCLEOTIDE BINDING OLIGOMERIZATION DOMAIN CONTAINING 1', 240838),
(315652, 'PTHR24107', NULL, NULL, NULL, NULL, 'YNEIN REGULATORY COMPLEX SUBUNIT 5', 240838),
(315653, 'PTHR24107:SF29', NULL, NULL, NULL, NULL, 'MAP-HOMOLOGOUS PROTEIN 1', 240838),
(315654, 'PTHR24107:SF18', NULL, NULL, NULL, NULL, '', 240838),
(315655, 'PTHR24107:SF19', NULL, NULL, NULL, NULL, 'NUCLEOTIDE BINDING OLIGOMERIZATION DOMAIN CONTAINING 2', 240838),
(315656, 'PTHR24107:SF20', NULL, NULL, NULL, NULL, 'WALL BIOGENESIS PROTEIN MHP1, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G12900)-RELATED', 240838),
(315657, 'PTHR24107:SF23', NULL, NULL, NULL, NULL, 'RIBONUCLEASE INHIBITOR-LIKE PROTEIN', 240838),
(315658, 'PTHR24107:SF22', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN', 240838),
(315659, 'PTHR22618', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 240839),
(315660, 'PTHR22618:SF2', NULL, NULL, NULL, NULL, 'PROTEIN O-MANNOSE KINASE', 240839),
(315661, 'PTHR47444:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240840),
(315662, 'PTHR47444', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240840);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(315663, 'PTHR47444:SF2', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 240840),
(315664, 'PTHR34043:SF3', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 240841),
(315665, 'PTHR34043:SF9', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 240841),
(315666, 'PTHR34043', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 240841),
(315667, 'PTHR34043:SF6', NULL, NULL, NULL, NULL, 'BNAC08G49970D PROTEIN', 240841),
(315668, 'PTHR34043:SF5', NULL, NULL, NULL, NULL, 'LIPASE', 240841),
(315669, 'PTHR34043:SF8', NULL, NULL, NULL, NULL, 'LIPASE-LIKE', 240841),
(315670, 'PTHR34043:SF7', NULL, NULL, NULL, NULL, 'BNAA08G20530D PROTEIN', 240841),
(315671, 'PTHR36406', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 30', 240842),
(315672, 'PTHR36406:SF3', NULL, NULL, NULL, NULL, 'BNAA09G06600D PROTEIN', 240842),
(315673, 'PTHR36406:SF2', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 30', 240842),
(315674, 'PTHR36138:SF10', NULL, NULL, NULL, NULL, '', 240843),
(315675, 'PTHR36138:SF12', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240843),
(315676, 'PTHR36138:SF9', NULL, NULL, NULL, NULL, 'OS04G0604500 PROTEIN', 240843),
(315677, 'PTHR36138', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', 240843),
(315678, 'PTHR23400:SF0', NULL, NULL, NULL, NULL, 'DENTIN MATRIX ACIDIC PHOSPHOPROTEIN 1', 240844),
(315679, 'PTHR23400', NULL, NULL, NULL, NULL, 'DENTIN MATRIX ACIDIC PHOSPHOPROTEIN 1', 240844),
(315680, 'PTHR10322:SF20', NULL, NULL, NULL, NULL, 'DNA POLYMERASE 1', 240845),
(315681, 'PTHR10322', NULL, NULL, NULL, NULL, 'DNA POLYMERASE CATALYTIC SUBUNIT', 240845),
(315682, 'PTHR10322:SF23', NULL, NULL, NULL, NULL, 'DNA POLYMERASE DELTA CATALYTIC SUBUNIT', 240845),
(315683, 'PTHR10322:SF35', NULL, NULL, NULL, NULL, 'DNA-DIRECTED DNA POLYMERASE', 240845),
(315684, 'PTHR47506', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 240846),
(315685, 'PTHR47506:SF6', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REPRESSOR NEMR', 240846),
(315686, 'PTHR47506:SF3', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR LMRA', 240846),
(315687, 'PTHR47506:SF9', NULL, NULL, NULL, NULL, 'HTH TETR-TYPE DOMAIN-CONTAINING PROTEIN', 240846),
(315688, 'PTHR47506:SF8', NULL, NULL, NULL, NULL, 'REPRESSOR OF PUTATIVE XENOBIOTIC REDUCTASE TETR FAMILY-RELATED', 240846),
(315689, 'PTHR47506:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 240846),
(315690, 'PTHR47506:SF1', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR YJDC', 240846),
(315691, 'PTHR31756:SF9', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL KINASE-PYROPHOSPHORYLASE-RELATED', 240847),
(315692, 'PTHR31756', NULL, NULL, NULL, NULL, 'PYRUVATE, PHOSPHATE DIKINASE REGULATORY PROTEIN 1, CHLOROPLASTIC', 240847),
(315693, 'PTHR31756:SF5', NULL, NULL, NULL, NULL, 'PYRUVATE, PHOSPHATE DIKINASE REGULATORY PROTEIN 2', 240847),
(315694, 'PTHR31756:SF10', NULL, NULL, NULL, NULL, 'PYRUVATE PHOSPHATE DIKINASE REGULATORY PROTEIN 2', 240847),
(315695, 'PTHR31756:SF7', NULL, NULL, NULL, NULL, 'BNAA05G34010D PROTEIN', 240847),
(315696, 'PTHR31756:SF3', NULL, NULL, NULL, NULL, 'PYRUVATE, PHOSPHATE DIKINASE REGULATORY PROTEIN 1, CHLOROPLASTIC', 240847),
(315697, 'PTHR43790:SF2', NULL, NULL, NULL, NULL, 'AUTOINDUCER 2 IMPORT ATP-BINDING PROTEIN LSRA', 240848),
(315698, 'PTHR43790:SF3', NULL, NULL, NULL, NULL, 'D-ALLOSE IMPORT ATP-BINDING PROTEIN ALSA-RELATED', 240848),
(315699, 'PTHR43790:SF1', NULL, NULL, NULL, NULL, 'XYLOSE IMPORT ATP-BINDING PROTEIN XYLG', 240848),
(315700, 'PTHR43790:SF6', NULL, NULL, NULL, NULL, 'ARABINOSE IMPORT ATP-BINDING PROTEIN ARAG', 240848),
(315701, 'PTHR43790:SF7', NULL, NULL, NULL, NULL, 'GALACTOSE/METHYL GALACTOSIDE IMPORT ATP-BINDING PROTEIN MGLA', 240848),
(315702, 'PTHR43790', NULL, NULL, NULL, NULL, 'CARBOHYDRATE TRANSPORT ATP-BINDING PROTEIN MG119-RELATED', 240848),
(315703, 'PTHR43790:SF4', NULL, NULL, NULL, NULL, 'GUANOSINE IMPORT ATP-BINDING PROTEIN NUPO', 240848),
(315704, 'PTHR43790:SF8', NULL, NULL, NULL, NULL, 'SUGAR ABC TRANSPORTER ATP-BINDING PROTEIN', 240848);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(315705, 'PTHR43790:SF9', NULL, NULL, NULL, NULL, 'GALACTOFURANOSE TRANSPORTER ATP-BINDING PROTEIN YTFR', 240848),
(315706, 'PTHR37010:SF1', NULL, NULL, NULL, NULL, 'SULFURTRANSFERASE TUSE', 240849),
(315707, 'PTHR37010', NULL, NULL, NULL, NULL, 'SULFURTRANSFERASE TUSE', 240849),
(315708, 'PTHR35308', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 7', 240850),
(315709, 'PTHR35308:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 7', 240850),
(315710, 'PTHR35308:SF7', NULL, NULL, NULL, NULL, 'OS07G0647500 PROTEIN', 240850),
(315711, 'PTHR35308:SF14', NULL, NULL, NULL, NULL, '', 240850),
(315712, 'PTHR35308:SF13', NULL, NULL, NULL, NULL, '', 240850),
(315713, 'PTHR35308:SF12', NULL, NULL, NULL, NULL, '', 240850),
(315714, 'PTHR35308:SF11', NULL, NULL, NULL, NULL, 'OS05G0457000 PROTEIN', 240850),
(315715, 'PTHR35308:SF10', NULL, NULL, NULL, NULL, 'ACYTOCHROME-C OXIDASE/ELECTRON CARRIER PROTEIN', 240850),
(315716, 'PTHR47106:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL-HELIX-COILED-COIL-HELIX DOMAIN-CONTAINING PROTEIN 5', 240851),
(315717, 'PTHR47106', NULL, NULL, NULL, NULL, 'COILED-COIL-HELIX-COILED-COIL-HELIX DOMAIN-CONTAINING PROTEIN 5', 240851),
(315718, 'PTHR46309:SF12', NULL, NULL, NULL, NULL, 'GB|AAC80581.1', 240852),
(315719, 'PTHR46309:SF13', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE, ACYL-COA N-ACYLTRANSFERASE, JAS TPL-BINDING DOMAIN PROTEIN-RELATED', 240852),
(315720, 'PTHR46309:SF10', NULL, NULL, NULL, NULL, 'PHD ZINC FINGER PROTEIN', 240852),
(315721, 'PTHR46309:SF21', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASE WITH RING/FYVE/PHD-TYPE ZINC FINGER PROTEIN', 240852),
(315722, 'PTHR46309:SF11', NULL, NULL, NULL, NULL, 'AGENET-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 240852),
(315723, 'PTHR46309:SF16', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASE WITH RING/FYVE/PHD-TYPE ZINC FINGER DOMAIN', 240852),
(315724, 'PTHR46309', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN 12', 240852),
(315725, 'PTHR46309:SF17', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASE WITH RING/FYVE/PHD-TYPE ZINC FINGER DOMAIN-CONTAINING PROTEIN', 240852),
(315726, 'PTHR46309:SF14', NULL, NULL, NULL, NULL, '', 240852),
(315727, 'PTHR46309:SF15', NULL, NULL, NULL, NULL, 'PHD-FINGER PROTEIN', 240852),
(315728, 'PTHR46309:SF18', NULL, NULL, NULL, NULL, '', 240852),
(315729, 'PTHR46309:SF19', NULL, NULL, NULL, NULL, 'BNAA01G18860D PROTEIN', 240852),
(315730, 'PTHR46309:SF1', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN 12', 240852),
(315731, 'PTHR46309:SF5', NULL, NULL, NULL, NULL, 'GNAT FAMILY ACETYLTRANSFERASE', 240852),
(315732, 'PTHR46309:SF7', NULL, NULL, NULL, NULL, 'OS04G0433900 PROTEIN', 240852),
(315733, 'PTHR46309:SF8', NULL, NULL, NULL, NULL, '', 240852),
(315734, 'PTHR46309:SF20', NULL, NULL, NULL, NULL, 'BNAA06G23040D PROTEIN', 240852),
(315735, 'PTHR30420:SF2', NULL, NULL, NULL, NULL, 'N-SUCCINYLARGININE DIHYDROLASE', 240853),
(315736, 'PTHR30420:SF1', NULL, NULL, NULL, NULL, 'ARGININE N-SUCCINYLTRANSFERASE', 240853),
(315737, 'PTHR30420', NULL, NULL, NULL, NULL, 'N-SUCCINYLARGININE DIHYDROLASE', 240853),
(315738, 'PTHR33939:SF1', NULL, NULL, NULL, NULL, 'DDE_3 DOMAIN-CONTAINING PROTEIN', 240854),
(315739, 'PTHR33939', NULL, NULL, NULL, NULL, 'PROTEIN CBG22215', 240854),
(315740, 'PTHR45961:SF8', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE-PHOSPHATASE', 240855),
(315741, 'PTHR45961:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG00285', 240855),
(315742, 'PTHR45961:SF1', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE-PHOSPHATASE', 240855),
(315743, 'PTHR45961:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG09952', 240855),
(315744, 'PTHR45961:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG14753', 240855),
(315745, 'PTHR45961', NULL, NULL, NULL, NULL, 'IP21249P', 240855),
(315746, 'PTHR45961:SF5', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE 14', 240855),
(315747, 'PTHR45961:SF6', NULL, NULL, NULL, NULL, 'IP21249P', 240855),
(315748, 'PTHR45961:SF7', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PHOSPHATASE 28', 240855),
(315749, 'PTHR44566:SF1', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 25', 240856);
INSERT INTO "PUBLIC"."MODEL" VALUES
(315750, 'PTHR44566', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN', 240856),
(315751, 'PTHR34830:SF1', NULL, NULL, NULL, NULL, 'SIMILAR TO HYPOTHETICAL PROTEIN MGC34837', 240857),
(315752, 'PTHR34830', NULL, NULL, NULL, NULL, 'SIMILAR TO HYPOTHETICAL PROTEIN MGC34837', 240857),
(315753, 'PTHR15394', NULL, NULL, NULL, NULL, 'SERINE HYDROLASE RBBP9', 240858),
(315754, 'PTHR15394:SF3', NULL, NULL, NULL, NULL, 'SERINE HYDROLASE RBBP9', 240858),
(315755, 'PTHR34314:SF7', NULL, NULL, NULL, NULL, '', 240859),
(315756, 'PTHR34314:SF6', NULL, NULL, NULL, NULL, 'CRENARCHAEAL PROTEIN, PUTATIVE-RELATED', 240859),
(315757, 'PTHR34314', NULL, NULL, NULL, NULL, 'CRENARCHAEAL PROTEIN, PUTATIVE-RELATED', 240859),
(315758, 'PTHR14677:SF31', NULL, NULL, NULL, NULL, '', 240860),
(315759, 'PTHR14677:SF20', NULL, NULL, NULL, NULL, 'ZINC FINGER, AN1-TYPE DOMAIN 2A', 240860),
(315760, 'PTHR14677:SF40', NULL, NULL, NULL, NULL, 'CDC48-ASSOCIATED UBIQUITIN-LIKE/ZINC FINGER PROTEIN 1', 240860),
(315761, 'PTHR14677:SF35', NULL, NULL, NULL, NULL, 'ZINC FINGER AN1 AND C2H2 DOMAIN-CONTAINING STRESS-ASSOCIATED PROTEIN 16-RELATED', 240860),
(315762, 'PTHR14677:SF13', NULL, NULL, NULL, NULL, 'AN1-TYPE ZINC FINGER PROTEIN 2B', 240860),
(315763, 'PTHR14677:SF36', NULL, NULL, NULL, NULL, 'ZINC FINGER AN1 AND C2H2 DOMAIN-CONTAINING STRESS-ASSOCIATED PROTEIN 13-RELATED', 240860),
(315764, 'PTHR14677:SF11', NULL, NULL, NULL, NULL, 'AN1-TYPE ZINC FINGER PROTEIN 2A', 240860),
(315765, 'PTHR14677:SF28', NULL, NULL, NULL, NULL, 'ZINC FINGER AN1 AND C2H2 DOMAIN-CONTAINING STRESS-ASSOCIATED PROTEIN 11-LIKE', 240860),
(315766, 'PTHR14677:SF39', NULL, NULL, NULL, NULL, 'RE31204P', 240860),
(315767, 'PTHR14677:SF37', NULL, NULL, NULL, NULL, 'AN1-TYPE ZINC FINGER PROTEIN 1', 240860),
(315768, 'PTHR14677:SF27', NULL, NULL, NULL, NULL, 'ZINC FINGER AN1 AND C2H2 DOMAIN-CONTAINING STRESS-ASSOCIATED PROTEIN 11', 240860),
(315769, 'PTHR14677:SF38', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 240860),
(315770, 'PTHR14677', NULL, NULL, NULL, NULL, 'ARSENITE INDUCUBLE RNA ASSOCIATED PROTEIN AIP-1-RELATED', 240860),
(315771, 'PTHR23260:SF9', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 11-1', 240861),
(315772, 'PTHR23260:SF8', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 27-1', 240861),
(315773, 'PTHR23260', NULL, NULL, NULL, NULL, 'KERATIN ASSOCIATED PROTEIN 3-3-RELATED', 240861),
(315774, 'PTHR23260:SF3', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 3-1', 240861),
(315775, 'PTHR23260:SF2', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 24-1', 240861),
(315776, 'PTHR23260:SF1', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 3-3', 240861),
(315777, 'PTHR23260:SF7', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 26-1', 240861),
(315778, 'PTHR23260:SF6', NULL, NULL, NULL, NULL, 'GENE 11939-RELATED', 240861),
(315779, 'PTHR23260:SF5', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 3-2', 240861),
(315780, 'PTHR31014:SF0', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL TRANSLATION SYSTEM COMPONENT PET127-RELATED', 240862),
(315781, 'PTHR31014', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 240862),
(315782, 'PTHR48014:SF13', NULL, NULL, NULL, NULL, 'STE20-RELATED KINASE ADAPTER PROTEIN BETA', 240863),
(315783, 'PTHR48014:SF14', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE BLUS1-LIKE ISOFORM X1', 240863),
(315784, 'PTHR48014:SF12', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE OSR1-LIKE', 240863),
(315785, 'PTHR48014:SF10', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 240863),
(315786, 'PTHR48014:SF30', NULL, NULL, NULL, NULL, 'OS02G0179000 PROTEIN', 240863),
(315787, 'PTHR48014:SF19', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240863),
(315788, 'PTHR48014:SF17', NULL, NULL, NULL, NULL, 'OS10G0518800 PROTEIN', 240863),
(315789, 'PTHR48014:SF18', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 240863),
(315790, 'PTHR48014:SF15', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 240863),
(315791, 'PTHR48014:SF16', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE', 240863);
INSERT INTO "PUBLIC"."MODEL" VALUES
(315792, 'PTHR48014:SF24', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE FRAY2', 240863),
(315793, 'PTHR48014:SF22', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240863),
(315794, 'PTHR48014', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE FRAY2', 240863),
(315795, 'PTHR48014:SF23', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240863),
(315796, 'PTHR48014:SF20', NULL, NULL, NULL, NULL, 'STE20-RELATED KINASE ADAPTER PROTEIN ALPHA', 240863),
(315797, 'PTHR48014:SF21', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 240863),
(315798, 'PTHR48014:SF9', NULL, NULL, NULL, NULL, 'DEATH-ASSOCIATED PROTEIN KINASE 1-RELATED', 240863),
(315799, 'PTHR48014:SF28', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE FRAY1', 240863),
(315800, 'PTHR48014:SF7', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE BLUS1', 240863),
(315801, 'PTHR48014:SF29', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE BLUS1 ISOFORM X1', 240863),
(315802, 'PTHR48014:SF26', NULL, NULL, NULL, NULL, 'KINASE FAMILY PROTEIN', 240863),
(315803, 'PTHR48014:SF4', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240863),
(315804, 'PTHR48014:SF5', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240863),
(315805, 'PTHR48014:SF3', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240863),
(315806, 'PTHR48014:SF1', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240863),
(315807, 'PTHR10689:SF9', NULL, NULL, NULL, NULL, 'PROSTAGLANDIN E SYNTHASE', 240864),
(315808, 'PTHR10689:SF3', NULL, NULL, NULL, NULL, 'MICROSOMAL GLUTATHIONE S-TRANSFERASE 1', 240864),
(315809, 'PTHR10689', NULL, NULL, NULL, NULL, 'MICROSOMAL GLUTATHIONE S-TRANSFERASE 1', 240864),
(315810, 'PTHR10689:SF6', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 240864),
(315811, 'PTHR23261:SF77', NULL, NULL, NULL, NULL, 'GROUND-LIKE DOMAIN-CONTAINING PROTEIN', 240865),
(315812, 'PTHR23261:SF76', NULL, NULL, NULL, NULL, 'GROUND-LIKE DOMAIN-CONTAINING PROTEIN', 240865),
(315813, 'PTHR23261:SF75', NULL, NULL, NULL, NULL, 'GROUND-LIKE DOMAIN-CONTAINING PROTEIN', 240865),
(315814, 'PTHR23261:SF74', NULL, NULL, NULL, NULL, 'GROUND-LIKE DOMAIN-CONTAINING PROTEIN', 240865),
(315815, 'PTHR23261:SF72', NULL, NULL, NULL, NULL, 'POLYGLUTAMINE-REPEAT PROTEIN PQN-41', 240865),
(315816, 'PTHR23261', NULL, NULL, NULL, NULL, 'GROUNDHOG-RELATED', 240865),
(315817, 'PTHR23261:SF79', NULL, NULL, NULL, NULL, 'GROUND-LIKE DOMAIN-CONTAINING PROTEIN', 240865),
(315818, 'PTHR23261:SF78', NULL, NULL, NULL, NULL, 'GROUND-LIKE DOMAIN-CONTAINING PROTEIN', 240865),
(315819, 'PTHR14555:SF6', NULL, NULL, NULL, NULL, 'RAB EFFECTOR MYRIP', 240866),
(315820, 'PTHR14555:SF1', NULL, NULL, NULL, NULL, 'MELANOPHILIN', 240866),
(315821, 'PTHR14555:SF3', NULL, NULL, NULL, NULL, 'RABBD DOMAIN-CONTAINING PROTEIN', 240866),
(315822, 'PTHR14555', NULL, NULL, NULL, NULL, 'MYELIN-ASSOCIATED OLIGODENDROCYTIC BASIC PROTEIN  MOBP -RELATED', 240866),
(315823, 'PTHR43706:SF13', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE-RELATED', 240867),
(315824, 'PTHR43706:SF12', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE-LIKE PROTEIN YUTJ', 240867),
(315825, 'PTHR43706:SF10', NULL, NULL, NULL, NULL, 'ROTENONE-INSENSITIVE NADH-UBIQUINONE OXIDOREDUCTASE, MITOCHONDRIAL', 240867),
(315826, 'PTHR43706:SF9', NULL, NULL, NULL, NULL, 'TYPE II NADH:QUINONE OXIDOREDUCTASE', 240867),
(315827, 'PTHR43706:SF49', NULL, NULL, NULL, NULL, 'FAD/NAD(P)-BINDING DOMAIN, WAX SYNTHASE DOMAIN PROTEIN-RELATED', 240867),
(315828, 'PTHR43706:SF48', NULL, NULL, NULL, NULL, 'NADH:UBIQUINONE REDUCTASE (NON-ELECTROGENIC)', 240867),
(315829, 'PTHR43706:SF26', NULL, NULL, NULL, NULL, 'PYR_REDOX_2 DOMAIN-CONTAINING PROTEIN', 240867),
(315830, 'PTHR43706:SF25', NULL, NULL, NULL, NULL, 'EXTERNAL ALTERNATIVE NAD(P)H-UBIQUINONE OXIDOREDUCTASE B4, MITOCHONDRIAL', 240867),
(315831, 'PTHR43706:SF47', NULL, NULL, NULL, NULL, 'EXTERNAL ALTERNATIVE NAD(P)H-UBIQUINONE OXIDOREDUCTASE B2, MITOCHONDRIAL-RELATED', 240867);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(315832, 'PTHR43706:SF4', NULL, NULL, NULL, NULL, 'OS07G0564500 PROTEIN', 240867),
(315833, 'PTHR43706:SF3', NULL, NULL, NULL, NULL, 'NADH:UBIQUINONE REDUCTASE (NON-ELECTROGENIC)', 240867),
(315834, 'PTHR43706:SF29', NULL, NULL, NULL, NULL, 'NADH:UBIQUINONE REDUCTASE (NON-ELECTROGENIC)', 240867),
(315835, 'PTHR43706:SF42', NULL, NULL, NULL, NULL, 'EXTERNAL NADH-UBIQUINONE OXIDOREDUCTASE 1, MITOCHONDRIAL-RELATED', 240867),
(315836, 'PTHR43706:SF41', NULL, NULL, NULL, NULL, 'NADH:UBIQUINONE REDUCTASE (NON-ELECTROGENIC)', 240867),
(315837, 'PTHR43706:SF40', NULL, NULL, NULL, NULL, 'NADH:UBIQUINONE REDUCTASE (NON-ELECTROGENIC)', 240867),
(315838, 'PTHR43706:SF46', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE C947.15C, MITOCHONDRIAL-RELATED', 240867),
(315839, 'PTHR43706:SF23', NULL, NULL, NULL, NULL, 'NADH:UBIQUINONE REDUCTASE (NON-ELECTROGENIC)', 240867),
(315840, 'PTHR43706:SF45', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE-LIKE PROTEIN RV1812C', 240867),
(315841, 'PTHR43706:SF44', NULL, NULL, NULL, NULL, 'NADH:UBIQUINONE REDUCTASE (NON-ELECTROGENIC)', 240867),
(315842, 'PTHR43706:SF22', NULL, NULL, NULL, NULL, 'NADH:UBIQUINONE REDUCTASE (NON-ELECTROGENIC)', 240867),
(315843, 'PTHR43706:SF43', NULL, NULL, NULL, NULL, 'NADH:UBIQUINONE REDUCTASE (NON-ELECTROGENIC)', 240867),
(315844, 'PTHR43706:SF21', NULL, NULL, NULL, NULL, 'INTERNAL ALTERNATIVE NAD(P)H-UBIQUINONE OXIDOREDUCTASE A1, MITOCHONDRIAL', 240867),
(315845, 'PTHR43706', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE', 240867),
(315846, 'PTHR43706:SF17', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE (EUROFUNG)', 240867),
(315847, 'PTHR43706:SF38', NULL, NULL, NULL, NULL, 'PYR_REDOX_2 DOMAIN-CONTAINING PROTEIN', 240867),
(315848, 'PTHR43706:SF36', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE B2', 240867),
(315849, 'PTHR28348:SF1', NULL, NULL, NULL, NULL, 'UPF0193 PROTEIN EVG1', 240868),
(315850, 'PTHR28348', NULL, NULL, NULL, NULL, 'UPF0193 PROTEIN EVG1', 240868),
(315851, 'PTHR24349:SF509', NULL, NULL, NULL, NULL, 'OS02G0807000 PROTEIN', 240869),
(315852, 'PTHR24349:SF508', NULL, NULL, NULL, NULL, '', 240869),
(315853, 'PTHR24349:SF349', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 18', 240869),
(315854, 'PTHR24349:SF503', NULL, NULL, NULL, NULL, '', 240869),
(315855, 'PTHR24349:SF502', NULL, NULL, NULL, NULL, 'CPK18 CALCIUM-DEPENDENT PROTEIN KINASE', 240869),
(315856, 'PTHR24349:SF347', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 26', 240869),
(315857, 'PTHR24349:SF468', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S6 KINASE A4', 240869),
(315858, 'PTHR24349:SF501', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE-LIKE', 240869),
(315859, 'PTHR24349:SF467', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 17-LIKE ISOFORM X1', 240869),
(315860, 'PTHR24349:SF500', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 1-LIKE', 240869),
(315861, 'PTHR24349:SF346', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 8', 240869),
(315862, 'PTHR24349:SF507', NULL, NULL, NULL, NULL, '', 240869),
(315863, 'PTHR24349:SF506', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN PAIR, SERINE/THREONINE PROTEIN KINASE, STRIATED MUSCLE-SPECIFIC-RELATED', 240869),
(315864, 'PTHR24349:SF505', NULL, NULL, NULL, NULL, 'CPK14 CALCIUM-DEPENDENT PROTEIN KINASE', 240869),
(315865, 'PTHR24349:SF109', NULL, NULL, NULL, NULL, 'MAP KINASE-ACTIVATED PROTEIN KINASE MAK-1', 240869),
(315866, 'PTHR24349:SF504', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240869),
(315867, 'PTHR24349:SF461', NULL, NULL, NULL, NULL, 'BNAC09G37160D PROTEIN', 240869),
(315868, 'PTHR24349:SF186', NULL, NULL, NULL, NULL, 'CDPK-RELATED KINASE 4', 240869),
(315869, 'PTHR24349:SF340', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 5', 240869),
(315870, 'PTHR24349:SF343', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240869),
(315871, 'PTHR24349:SF183', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 17', 240869),
(315872, 'PTHR24349:SF182', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 15', 240869);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(315873, 'PTHR24349:SF338', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-DEPENDENT PROTEIN KINASE TYPE IV', 240869),
(315874, 'PTHR24349:SF337', NULL, NULL, NULL, NULL, 'CDPK-RELATED KINASE', 240869),
(315875, 'PTHR24349:SF456', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 32', 240869),
(315876, 'PTHR24349:SF335', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 7', 240869),
(315877, 'PTHR24349:SF296', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 17-LIKE', 240869),
(315878, 'PTHR24349:SF450', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 2-LIKE', 240869),
(315879, 'PTHR24349:SF295', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 25', 240869),
(315880, 'PTHR24349:SF334', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 19', 240869),
(315881, 'PTHR24349:SF179', NULL, NULL, NULL, NULL, 'MAP KINASE-ACTIVATED PROTEIN KINASE 5', 240869),
(315882, 'PTHR24349:SF333', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 23', 240869),
(315883, 'PTHR24349:SF299', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 29', 240869),
(315884, 'PTHR24349:SF453', NULL, NULL, NULL, NULL, 'CALMODULIN-DOMAIN KINASE CDPK PROTEIN', 240869),
(315885, 'PTHR24349:SF452', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYLASE KINASE 1', 240869),
(315886, 'PTHR24349:SF292', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 8-LIKE', 240869),
(315887, 'PTHR24349:SF291', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 21', 240869),
(315888, 'PTHR24349:SF92', NULL, NULL, NULL, NULL, 'CDPK-RELATED KINASE 7', 240869),
(315889, 'PTHR24349:SF164', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 27', 240869),
(315890, 'PTHR24349:SF284', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240869),
(315891, 'PTHR24349:SF444', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 8', 240869),
(315892, 'PTHR24349:SF322', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 18', 240869),
(315893, 'PTHR24349:SF443', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240869),
(315894, 'PTHR24349:SF167', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 30', 240869),
(315895, 'PTHR24349:SF288', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 28', 240869),
(315896, 'PTHR24349:SF320', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 2', 240869),
(315897, 'PTHR24349:SF166', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 12', 240869),
(315898, 'PTHR24349:SF287', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 16', 240869),
(315899, 'PTHR24349:SF441', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE (CDPK) FAMILY PROTEIN-RELATED', 240869),
(315900, 'PTHR24349:SF160', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 24', 240869),
(315901, 'PTHR24349:SF280', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 240869),
(315902, 'PTHR24349:SF81', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 6', 240869),
(315903, 'PTHR24349:SF437', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN PAIR, DEATH-ASSOCIATED PROTEIN KINASE 1-RELATED', 240869),
(315904, 'PTHR24349:SF314', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 11-LIKE', 240869),
(315905, 'PTHR24349:SF434', NULL, NULL, NULL, NULL, 'BNAC02G41580D PROTEIN', 240869),
(315906, 'PTHR24349:SF439', NULL, NULL, NULL, NULL, 'BNAA09G08020D PROTEIN', 240869),
(315907, 'PTHR24349:SF396', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 13', 240869),
(315908, 'PTHR24349:SF279', NULL, NULL, NULL, NULL, 'OS10G0510700 PROTEIN', 240869),
(315909, 'PTHR24349:SF312', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 26-LIKE', 240869),
(315910, 'PTHR24349:SF157', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-DEPENDENT SERINE/THREONINE-PROTEIN KINASE 1', 240869),
(315911, 'PTHR24349:SF311', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYLASE KINASE 2-LIKE', 240869),
(315912, 'PTHR24349:SF432', NULL, NULL, NULL, NULL, 'BNAC07G32550D PROTEIN', 240869),
(315913, 'PTHR24349:SF398', NULL, NULL, NULL, NULL, 'BNAA02G32840D PROTEIN', 240869);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(315914, 'PTHR24349:SF431', NULL, NULL, NULL, NULL, '', 240869),
(315915, 'PTHR24349:SF397', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 13-RELATED', 240869),
(315916, 'PTHR24349:SF392', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 20-LIKE', 240869),
(315917, 'PTHR24349:SF391', NULL, NULL, NULL, NULL, 'BNAC09G38250D PROTEIN', 240869),
(315918, 'PTHR24349:SF270', NULL, NULL, NULL, NULL, 'SI:CH73-60H1.1', 240869),
(315919, 'PTHR24349:SF305', NULL, NULL, NULL, NULL, 'CDPK-RELATED KINASE 8', 240869),
(315920, 'PTHR24349:SF426', NULL, NULL, NULL, NULL, 'BNAA09G05220D PROTEIN', 240869),
(315921, 'PTHR24349:SF303', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 22-RELATED', 240869),
(315922, 'PTHR24349:SF424', NULL, NULL, NULL, NULL, 'BNAA03G46140D PROTEIN', 240869),
(315923, 'PTHR24349:SF302', NULL, NULL, NULL, NULL, 'CALMODULIN-DOMAIN KINASE CDPK PROTEIN', 240869),
(315924, 'PTHR24349:SF428', NULL, NULL, NULL, NULL, 'BNAA05G11330D PROTEIN', 240869),
(315925, 'PTHR24349:SF427', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 10', 240869),
(315926, 'PTHR24349:SF385', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 28-LIKE', 240869),
(315927, 'PTHR24349:SF384', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240869),
(315928, 'PTHR24349:SF263', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 1', 240869),
(315929, 'PTHR24349:SF383', NULL, NULL, NULL, NULL, 'BNAC09G38330D PROTEIN', 240869),
(315930, 'PTHR24349:SF261', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PEPKR2', 240869),
(315931, 'PTHR24349:SF388', NULL, NULL, NULL, NULL, 'BNACNNG42020D PROTEIN', 240869),
(315932, 'PTHR24349:SF420', NULL, NULL, NULL, NULL, 'BNAA09G44420D PROTEIN', 240869),
(315933, 'PTHR24349:SF540', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 26-LIKE', 240869),
(315934, 'PTHR24349:SF64', NULL, NULL, NULL, NULL, 'MAP KINASE-ACTIVATED PROTEIN KINASE 3', 240869),
(315935, 'PTHR24349:SF63', NULL, NULL, NULL, NULL, 'MAP KINASE-ACTIVATED PROTEIN KINASE 2', 240869),
(315936, 'PTHR24349:SF536', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 15', 240869),
(315937, 'PTHR24349:SF415', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240869),
(315938, 'PTHR24349:SF414', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYLASE KINASE 2', 240869),
(315939, 'PTHR24349:SF535', NULL, NULL, NULL, NULL, 'OS09G0466900 PROTEIN', 240869),
(315940, 'PTHR24349:SF413', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN PAIR-RELATED', 240869),
(315941, 'PTHR24349:SF534', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240869),
(315942, 'PTHR24349:SF533', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 26', 240869),
(315943, 'PTHR24349:SF539', NULL, NULL, NULL, NULL, 'CDPK-RELATED KINASE 6', 240869),
(315944, 'PTHR24349:SF538', NULL, NULL, NULL, NULL, 'BNAA09G09050D PROTEIN', 240869),
(315945, 'PTHR24349:SF537', NULL, NULL, NULL, NULL, 'CALMODULIN-DOMAIN PROTEIN KINASE 9-RELATED', 240869),
(315946, 'PTHR24349:SF374', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 20', 240869),
(315947, 'PTHR24349:SF495', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN PAIR-RELATED', 240869),
(315948, 'PTHR24349:SF373', NULL, NULL, NULL, NULL, '', 240869),
(315949, 'PTHR24349:SF532', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-DEPENDENT PROTEIN KINASE CAMK3', 240869),
(315950, 'PTHR24349:SF499', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240869),
(315951, 'PTHR24349:SF136', NULL, NULL, NULL, NULL, 'OS02G0625300 PROTEIN', 240869),
(315952, 'PTHR24349:SF411', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYLASE KINASE 1-LIKE', 240869),
(315953, 'PTHR24349:SF531', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 21-RELATED', 240869),
(315954, 'PTHR24349:SF377', NULL, NULL, NULL, NULL, 'BNAA02G32820D PROTEIN', 240869),
(315955, 'PTHR24349:SF498', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 24', 240869),
(315956, 'PTHR24349:SF497', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE FAMILY PROTEIN-RELATED', 240869);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(315957, 'PTHR24349:SF530', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240869),
(315958, 'PTHR24349:SF496', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT KINASE', 240869),
(315959, 'PTHR24349:SF254', NULL, NULL, NULL, NULL, 'MAP KINASE-INTERACTING SERINE/THREONINE-PROTEIN KINASE 2', 240869),
(315960, 'PTHR24349:SF490', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240869),
(315961, 'PTHR24349:SF404', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 1', 240869),
(315962, 'PTHR24349:SF525', NULL, NULL, NULL, NULL, 'CALMODULIN-DOMAIN PROTEIN KINASE 7-RELATED', 240869),
(315963, 'PTHR24349:SF524', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE', 240869),
(315964, 'PTHR24349:SF403', NULL, NULL, NULL, NULL, 'BNAC04G42320D PROTEIN', 240869),
(315965, 'PTHR24349:SF249', NULL, NULL, NULL, NULL, 'CDPK-RELATED KINASE 2', 240869),
(315966, 'PTHR24349:SF369', NULL, NULL, NULL, NULL, 'CDPK-RELATED KINASE 1', 240869),
(315967, 'PTHR24349:SF523', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240869),
(315968, 'PTHR24349:SF248', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 5', 240869),
(315969, 'PTHR24349:SF127', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 22', 240869),
(315970, 'PTHR24349:SF489', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 5', 240869),
(315971, 'PTHR24349:SF401', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240869),
(315972, 'PTHR24349:SF522', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE SK5-LIKE', 240869),
(315973, 'PTHR24349:SF408', NULL, NULL, NULL, NULL, 'SERINE/THREONINE/DUAL SPECIFICITY PROTEIN KINASE, CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 240869),
(315974, 'PTHR24349:SF529', NULL, NULL, NULL, NULL, 'SERINE/THREONINE/DUAL SPECIFICITY PROTEIN KINASE, CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 240869),
(315975, 'PTHR24349:SF528', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 29', 240869),
(315976, 'PTHR24349:SF406', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240869),
(315977, 'PTHR24349:SF527', NULL, NULL, NULL, NULL, 'LD17393P', 240869),
(315978, 'PTHR24349:SF405', NULL, NULL, NULL, NULL, 'BNAC03G17520D PROTEIN', 240869),
(315979, 'PTHR24349:SF526', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 26-LIKE', 240869),
(315980, 'PTHR24349:SF361', NULL, NULL, NULL, NULL, 'CDPK-RELATED KINASE 3', 240869),
(315981, 'PTHR24349:SF360', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 20', 240869),
(315982, 'PTHR24349:SF521', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240869),
(315983, 'PTHR24349:SF520', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN PAIR, SERINE/THREONINE-PROTEIN KINASE UNC-51-RELATED', 240869),
(315984, 'PTHR24349:SF487', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240869),
(315985, 'PTHR24349:SF486', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 28-RELATED', 240869),
(315986, 'PTHR24349:SF485', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 3', 240869),
(315987, 'PTHR24349:SF364', NULL, NULL, NULL, NULL, 'BNAC04G47900D PROTEIN', 240869),
(315988, 'PTHR24349:SF243', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE CG17528', 240869),
(315989, 'PTHR24349:SF519', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 6', 240869),
(315990, 'PTHR24349', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE', 240869),
(315991, 'PTHR24349:SF514', NULL, NULL, NULL, NULL, 'MAP KINASE-ACTIVATED PROTEIN KINASE 2', 240869),
(315992, 'PTHR24349:SF513', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 3', 240869),
(315993, 'PTHR24349:SF512', NULL, NULL, NULL, NULL, 'CALMODULIN-DOMAIN KINASE CDPK PROTEIN', 240869),
(315994, 'PTHR24349:SF478', NULL, NULL, NULL, NULL, '', 240869),
(315995, 'PTHR24349:SF511', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 2-LIKE', 240869),
(315996, 'PTHR24349:SF115', NULL, NULL, NULL, NULL, 'CDPK-RELATED KINASE 5', 240869),
(315997, 'PTHR24349:SF518', NULL, NULL, NULL, NULL, 'CALMODULIN-DOMAIN KINASE CDPK PROTEIN', 240869);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(315998, 'PTHR24349:SF517', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 3', 240869),
(315999, 'PTHR24349:SF516', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 4', 240869),
(316000, 'PTHR24349:SF515', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240869),
(316001, 'PTHR24349:SF119', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 7', 240869),
(316002, 'PTHR24349:SF473', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 14', 240869),
(316003, 'PTHR24349:SF350', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 33-RELATED', 240869),
(316004, 'PTHR24349:SF477', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 34', 240869),
(316005, 'PTHR24349:SF356', NULL, NULL, NULL, NULL, '', 240869),
(316006, 'PTHR24349:SF114', NULL, NULL, NULL, NULL, 'MAP KINASE-INTERACTING SERINE/THREONINE-PROTEIN KINASE 1', 240869),
(316007, 'PTHR24349:SF510', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 21-LIKE', 240869),
(316008, 'PTHR24349:SF355', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 14', 240869),
(316009, 'PTHR24349:SF353', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 17', 240869),
(316010, 'PTHR24349:SF194', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 13', 240869),
(316011, 'PTHR24349:SF192', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PROTEIN KINASE 11', 240869),
(316012, 'PTHR13165:SF4', NULL, NULL, NULL, NULL, 'OS02G0149600 PROTEIN', 240870),
(316013, 'PTHR13165:SF2', NULL, NULL, NULL, NULL, 'OS08G0517300 PROTEIN', 240870),
(316014, 'PTHR13165:SF0', NULL, NULL, NULL, NULL, 'SERRATE RNA EFFECTOR MOLECULE HOMOLOG', 240870),
(316015, 'PTHR13165', NULL, NULL, NULL, NULL, 'ARSENITE-RESISTANCE PROTEIN 2', 240870),
(316016, 'PTHR46054', NULL, NULL, NULL, NULL, 'MATERNAL EFFECT PROTEIN STAUFEN', 240871),
(316017, 'PTHR46054:SF3', NULL, NULL, NULL, NULL, 'MATERNAL EFFECT PROTEIN STAUFEN', 240871),
(316018, 'PTHR46054:SF2', NULL, NULL, NULL, NULL, 'DOUBLE-STRANDED RNA-BINDING PROTEIN STAUFEN HOMOLOG 1', 240871),
(316019, 'PTHR46054:SF1', NULL, NULL, NULL, NULL, 'DOUBLE-STRANDED RNA-BINDING PROTEIN STAUFEN HOMOLOG 2', 240871),
(316020, 'PTHR34319', NULL, NULL, NULL, NULL, 'MAJOR EXPORTED PROTEIN', 240872),
(316021, 'PTHR34319:SF7', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 240872),
(316022, 'PTHR34319:SF6', NULL, NULL, NULL, NULL, 'MAJOR EXPORTED PROTEIN', 240872),
(316023, 'PTHR35306:SF5', NULL, NULL, NULL, NULL, '', 240873),
(316024, 'PTHR35306', NULL, NULL, NULL, NULL, 'BNAA03G57290D PROTEIN', 240873),
(316025, 'PTHR35306:SF6', NULL, NULL, NULL, NULL, '', 240873),
(316026, 'PTHR35306:SF1', NULL, NULL, NULL, NULL, 'BNAA03G57290D PROTEIN', 240873),
(316027, 'PTHR35306:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240873),
(316028, 'PTHR10003:SF37', NULL, NULL, NULL, NULL, 'CELL SURFACE SUPEROXIDE DISMUTASE [CU-ZN] 4', 240874),
(316029, 'PTHR10003:SF95', NULL, NULL, NULL, NULL, 'SUPEROXIDE DISMUTASE [CU-ZN] 2, CHLOROPLASTIC', 240874),
(316030, 'PTHR10003:SF73', NULL, NULL, NULL, NULL, 'EXTRACELLULAR SUPEROXIDE DISMUTASE [CU-ZN] 2', 240874),
(316031, 'PTHR10003:SF94', NULL, NULL, NULL, NULL, 'EXTRACELLULAR SUPEROXIDE DISMUTASE [CU-ZN] 3', 240874),
(316032, 'PTHR10003:SF83', NULL, NULL, NULL, NULL, 'SUPEROXIDE DISMUTASE [CU-ZN] 2', 240874),
(316033, 'PTHR10003:SF71', NULL, NULL, NULL, NULL, 'SUPEROXIDE DISMUTASE [CU-ZN]', 240874),
(316034, 'PTHR10003:SF82', NULL, NULL, NULL, NULL, 'SOD_CU DOMAIN-CONTAINING PROTEIN', 240874),
(316035, 'PTHR10003:SF77', NULL, NULL, NULL, NULL, 'EXTRACELLULAR SUPEROXIDE DISMUTASE [CU-ZN]', 240874),
(316036, 'PTHR10003:SF99', NULL, NULL, NULL, NULL, 'SUPEROXIDE DISMUTASE [CU-ZN]', 240874),
(316037, 'PTHR10003:SF98', NULL, NULL, NULL, NULL, 'SUPEROXIDE DISMUTASE [CU-ZN]', 240874),
(316038, 'PTHR10003:SF86', NULL, NULL, NULL, NULL, 'COPPER CHAPERONE FOR SUPEROXIDE DISMUTASE', 240874),
(316039, 'PTHR10003:SF97', NULL, NULL, NULL, NULL, 'SUPEROXIDE DISMUTASE [CU-ZN]', 240874),
(316040, 'PTHR10003:SF31', NULL, NULL, NULL, NULL, 'SUPEROXIDE DISMUTASE [CU-ZN] 3', 240874);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(316041, 'PTHR10003:SF96', NULL, NULL, NULL, NULL, 'EXTRACELLULAR SUPEROXIDE DISMUTASE [CU-ZN]', 240874),
(316042, 'PTHR10003:SF101', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 240874),
(316043, 'PTHR10003:SF100', NULL, NULL, NULL, NULL, 'SUPEROXIDE DISMUTASE [CU-ZN] 4-RELATED', 240874),
(316044, 'PTHR10003:SF91', NULL, NULL, NULL, NULL, 'SUPEROXIDE DISMUTASE', 240874),
(316045, 'PTHR10003:SF102', NULL, NULL, NULL, NULL, 'SUPEROXIDE DISMUTASE [CU-ZN]', 240874),
(316046, 'PTHR10003', NULL, NULL, NULL, NULL, 'SUPEROXIDE DISMUTASE  CU-ZN -RELATED', 240874),
(316047, 'PTHR43254:SF2', NULL, NULL, NULL, NULL, 'PUTATIVE, EXPRESSED-RELATED', 240875),
(316048, 'PTHR43254:SF3', NULL, NULL, NULL, NULL, 'C-TERMINAL BINDING PROTEIN AN', 240875),
(316049, 'PTHR43254', NULL, NULL, NULL, NULL, 'C-TERMINAL BINDING PROTEIN AN-RELATED', 240875),
(316050, 'PTHR40111', NULL, NULL, NULL, NULL, 'CEPHALOSPORIN-C DEACETYLASE', 240876),
(316051, 'PTHR40111:SF1', NULL, NULL, NULL, NULL, 'CEPHALOSPORIN-C DEACETYLASE', 240876),
(316052, 'PTHR35733:SF1', NULL, NULL, NULL, NULL, 'OS02G0307800 PROTEIN', 240877),
(316053, 'PTHR35733', NULL, NULL, NULL, NULL, 'OS02G0307800 PROTEIN', 240877),
(316054, 'PTHR11547:SF20', NULL, NULL, NULL, NULL, 'ARGININE KINASE', 240878),
(316055, 'PTHR11547:SF64', NULL, NULL, NULL, NULL, 'PHOSPHAGEN KINASE N-TERMINAL DOMAIN-CONTAINING PROTEIN', 240878),
(316056, 'PTHR11547:SF52', NULL, NULL, NULL, NULL, 'CREATINE KINASE', 240878),
(316057, 'PTHR11547:SF63', NULL, NULL, NULL, NULL, 'CREATINE KINASE M-TYPE', 240878),
(316058, 'PTHR11547:SF57', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CREATINE KINASE', 240878),
(316059, 'PTHR11547:SF24', NULL, NULL, NULL, NULL, 'CREATINE KINASE U-TYPE, MITOCHONDRIAL', 240878),
(316060, 'PTHR11547:SF23', NULL, NULL, NULL, NULL, 'CREATINE KINASE B-TYPE', 240878),
(316061, 'PTHR11547:SF15', NULL, NULL, NULL, NULL, 'ARGININE KINASE', 240878),
(316062, 'PTHR11547:SF38', NULL, NULL, NULL, NULL, 'ARGININE KINASE', 240878),
(316063, 'PTHR11547:SF19', NULL, NULL, NULL, NULL, 'CREATINE KINASE S-TYPE, MITOCHONDRIAL', 240878),
(316064, 'PTHR11547', NULL, NULL, NULL, NULL, 'ARGININE OR CREATINE KINASE', 240878),
(316065, 'PTHR11547:SF60', NULL, NULL, NULL, NULL, 'CREATINE KINASE', 240878),
(316066, 'PTHR11547:SF62', NULL, NULL, NULL, NULL, 'CREATINE KINASE', 240878),
(316067, 'PTHR11547:SF61', NULL, NULL, NULL, NULL, 'ARGININE KINASE ZC434.8-RELATED', 240878),
(316068, 'PTHR21136:SF194', NULL, NULL, NULL, NULL, 'OS03G0165800 PROTEIN', 240879),
(316069, 'PTHR21136:SF172', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE PROTEIN 711-RELATED', 240879),
(316070, 'PTHR21136:SF195', NULL, NULL, NULL, NULL, 'BNAC04G43540D PROTEIN', 240879),
(316071, 'PTHR21136:SF192', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE PROTEIN 725-RELATED', 240879),
(316072, 'PTHR21136:SF193', NULL, NULL, NULL, NULL, 'SYNAPTOBREVIN, LONGIN-LIKE DOMAIN PROTEIN-RELATED', 240879),
(316073, 'PTHR21136:SF176', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE PROTEIN 721', 240879),
(316074, 'PTHR21136:SF199', NULL, NULL, NULL, NULL, 'BNAC06G15130D PROTEIN', 240879),
(316075, 'PTHR21136:SF177', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE PROTEIN 713', 240879),
(316076, 'PTHR21136:SF72', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE PROTEIN 724', 240879),
(316077, 'PTHR21136:SF196', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE PROTEIN 7', 240879),
(316078, 'PTHR21136:SF174', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN, PUTATIVE-RELATED', 240879),
(316079, 'PTHR21136:SF197', NULL, NULL, NULL, NULL, 'BNAA08G05870D PROTEIN', 240879),
(316080, 'PTHR21136:SF114', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE PROTEIN 7A', 240879),
(316081, 'PTHR21136:SF214', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE PROTEIN 714', 240879),
(316082, 'PTHR21136:SF178', NULL, NULL, NULL, NULL, 'SYNAPTOBREVIN-LIKE PROTEIN', 240879),
(316083, 'PTHR21136:SF179', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE PROTEIN 7', 240879),
(316084, 'PTHR21136:SF212', NULL, NULL, NULL, NULL, '', 240879);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(316085, 'PTHR21136:SF217', NULL, NULL, NULL, NULL, 'SYNAPTOBREVIN, LONGIN-LIKE DOMAIN PROTEIN-RELATED', 240879),
(316086, 'PTHR21136:SF218', NULL, NULL, NULL, NULL, 'OS03G0803000 PROTEIN', 240879),
(316087, 'PTHR21136:SF215', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE PROTEIN 722-LIKE', 240879),
(316088, 'PTHR21136:SF216', NULL, NULL, NULL, NULL, 'LONGIN-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 240879),
(316089, 'PTHR21136:SF183', NULL, NULL, NULL, NULL, 'OS12G0639800 PROTEIN', 240879),
(316090, 'PTHR21136:SF181', NULL, NULL, NULL, NULL, 'LONGIN-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 240879),
(316091, 'PTHR21136:SF187', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE PROTEIN 726 ISOFORM X1-RELATED', 240879),
(316092, 'PTHR21136:SF188', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE PROTEIN 722-RELATED', 240879),
(316093, 'PTHR21136:SF186', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN, PUTATIVE-RELATED', 240879),
(316094, 'PTHR21136:SF202', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE PROTEIN 7', 240879),
(316095, 'PTHR21136', NULL, NULL, NULL, NULL, 'SNARE PROTEINS', 240879),
(316096, 'PTHR21136:SF169', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE PROTEIN 727', 240879),
(316097, 'PTHR21136:SF104', NULL, NULL, NULL, NULL, 'OS02G0803600 PROTEIN', 240879),
(316098, 'PTHR21136:SF203', NULL, NULL, NULL, NULL, 'SYNAPTOBREVIN, LONGIN-LIKE DOMAIN PROTEIN-RELATED', 240879),
(316099, 'PTHR21136:SF200', NULL, NULL, NULL, NULL, 'SYNAPTOBREVIN, LONGIN-LIKE DOMAIN PROTEIN-RELATED', 240879),
(316100, 'PTHR21136:SF168', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE PROTEIN 9', 240879),
(316101, 'PTHR21136:SF201', NULL, NULL, NULL, NULL, 'BNAC08G43980D PROTEIN', 240879),
(316102, 'PTHR21136:SF207', NULL, NULL, NULL, NULL, 'BNAA08G28050D PROTEIN', 240879),
(316103, 'PTHR21136:SF92', NULL, NULL, NULL, NULL, 'LONGIN DOMAIN-CONTAINING PROTEIN', 240879),
(316104, 'PTHR21136:SF208', NULL, NULL, NULL, NULL, 'SYNAPTOBREVIN, LONGIN-LIKE DOMAIN PROTEIN-RELATED', 240879),
(316105, 'PTHR21136:SF209', NULL, NULL, NULL, NULL, 'BNAC04G43180D PROTEIN', 240879),
(316106, 'PTHR30461:SF25', NULL, NULL, NULL, NULL, 'RESOLVASE-RELATED', 240880),
(316107, 'PTHR30461:SF23', NULL, NULL, NULL, NULL, 'DNA RECOMBINASE-RELATED', 240880),
(316108, 'PTHR30461:SF24', NULL, NULL, NULL, NULL, 'RESOLVASE HOMOLOG YNEB', 240880),
(316109, 'PTHR30461:SF22', NULL, NULL, NULL, NULL, 'SERINE RECOMBINASE PINE-RELATED', 240880),
(316110, 'PTHR30461', NULL, NULL, NULL, NULL, 'DNA-INVERTASE FROM LAMBDOID PROPHAGE', 240880),
(316111, 'PTHR30461:SF2', NULL, NULL, NULL, NULL, 'RESOLVASE HOMOLOG YOKA', 240880),
(316112, 'PTHR30461:SF19', NULL, NULL, NULL, NULL, 'SITE-SPECIFIC RECOMBINASE RESOLVASE FAMILY', 240880),
(316113, 'PTHR46061', NULL, NULL, NULL, NULL, 'THYROTROPIN-RELEASING HORMONE RECEPTOR', 240881),
(316114, 'PTHR46061:SF1', NULL, NULL, NULL, NULL, 'THYROLIBERIN RECEPTOR', 240881),
(316115, 'PTHR46061:SF3', NULL, NULL, NULL, NULL, 'THYROLIBERIN RECEPTOR', 240881),
(316116, 'PTHR46061:SF2', NULL, NULL, NULL, NULL, 'THYROTROPIN-RELEASING HORMONE RECEPTOR', 240881),
(316117, 'PTHR46061:SF5', NULL, NULL, NULL, NULL, 'THYROLIBERIN RECEPTOR', 240881),
(316118, 'PTHR46061:SF7', NULL, NULL, NULL, NULL, 'THYROLIBERIN RECEPTOR', 240881),
(316119, 'PTHR46061:SF6', NULL, NULL, NULL, NULL, 'THYROLIBERIN RECEPTOR', 240881),
(316120, 'PTHR33784:SF9', NULL, NULL, NULL, NULL, '', 240882),
(316121, 'PTHR33784:SF19', NULL, NULL, NULL, NULL, 'BNACNNG56230D PROTEIN', 240882),
(316122, 'PTHR33784:SF13', NULL, NULL, NULL, NULL, 'BNAA05G34450D PROTEIN', 240882),
(316123, 'PTHR33784:SF35', NULL, NULL, NULL, NULL, 'BNACNNG21980D PROTEIN', 240882),
(316124, 'PTHR33784:SF36', NULL, NULL, NULL, NULL, 'BNAA02G22090D PROTEIN', 240882),
(316125, 'PTHR33784:SF33', NULL, NULL, NULL, NULL, 'BNAANNG11990D PROTEIN', 240882),
(316126, 'PTHR33784:SF12', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240882),
(316127, 'PTHR33784:SF34', NULL, NULL, NULL, NULL, 'BNAC02G24560D PROTEIN', 240882),
(316128, 'PTHR33784:SF17', NULL, NULL, NULL, NULL, 'BNAC02G46650D PROTEIN', 240882);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(316129, 'PTHR33784:SF15', NULL, NULL, NULL, NULL, 'BNAA05G15050D PROTEIN', 240882),
(316130, 'PTHR33784:SF37', NULL, NULL, NULL, NULL, 'BNAC06G31390D PROTEIN', 240882),
(316131, 'PTHR33784:SF38', NULL, NULL, NULL, NULL, 'BNAC04G15540D PROTEIN', 240882),
(316132, 'PTHR33784:SF10', NULL, NULL, NULL, NULL, 'OS05G0482100 PROTEIN', 240882),
(316133, 'PTHR33784', NULL, NULL, NULL, NULL, 'OS05G0482100 PROTEIN', 240882),
(316134, 'PTHR33784:SF30', NULL, NULL, NULL, NULL, 'BNAC07G14780D PROTEIN', 240882),
(316135, 'PTHR33784:SF46', NULL, NULL, NULL, NULL, 'BNACNNG67490D PROTEIN', 240882),
(316136, 'PTHR33784:SF24', NULL, NULL, NULL, NULL, 'BNACNNG11770D PROTEIN', 240882),
(316137, 'PTHR33784:SF47', NULL, NULL, NULL, NULL, 'F-BOX PLANT-LIKE PROTEIN', 240882),
(316138, 'PTHR33784:SF25', NULL, NULL, NULL, NULL, 'NUCLEIC ACID-BINDING, OB-FOLD-LIKE PROTEIN', 240882),
(316139, 'PTHR33784:SF44', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240882),
(316140, 'PTHR33784:SF23', NULL, NULL, NULL, NULL, 'BNAANNG23470D PROTEIN', 240882),
(316141, 'PTHR33784:SF45', NULL, NULL, NULL, NULL, 'BNAC02G33130D PROTEIN', 240882),
(316142, 'PTHR33784:SF28', NULL, NULL, NULL, NULL, 'BNAC01G30150D PROTEIN', 240882),
(316143, 'PTHR33784:SF29', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240882),
(316144, 'PTHR33784:SF26', NULL, NULL, NULL, NULL, 'BNAC02G26070D PROTEIN', 240882),
(316145, 'PTHR33784:SF27', NULL, NULL, NULL, NULL, 'BNAA08G03080D PROTEIN', 240882),
(316146, 'PTHR33784:SF42', NULL, NULL, NULL, NULL, 'BNAA09G16370D PROTEIN', 240882),
(316147, 'PTHR33784:SF20', NULL, NULL, NULL, NULL, 'BNAA04G05730D PROTEIN', 240882),
(316148, 'PTHR33784:SF21', NULL, NULL, NULL, NULL, 'BNAC03G16590D PROTEIN', 240882),
(316149, 'PTHR33784:SF43', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN', 240882),
(316150, 'PTHR33784:SF41', NULL, NULL, NULL, NULL, 'BNACNNG17550D PROTEIN', 240882),
(316151, 'PTHR47236:SF4', NULL, NULL, NULL, NULL, 'GENE, 32742-RELATED', 240883),
(316152, 'PTHR47236', NULL, NULL, NULL, NULL, 'GENE, 32742-RELATED-RELATED', 240883),
(316153, 'PTHR32294:SF4', NULL, NULL, NULL, NULL, 'ERROR-PRONE DNA POLYMERASE', 240884),
(316154, 'PTHR32294:SF0', NULL, NULL, NULL, NULL, 'DNA POLYMERASE III SUBUNIT ALPHA', 240884),
(316155, 'PTHR32294', NULL, NULL, NULL, NULL, 'DNA POLYMERASE III SUBUNIT ALPHA', 240884),
(316156, 'PTHR32294:SF5', NULL, NULL, NULL, NULL, 'DNA POLYMERASE III POLC-TYPE', 240884),
(316157, 'PTHR42200', NULL, NULL, NULL, NULL, 'ARCHAEAL FLAGELLA-RELATED PROTEIN F-RELATED', 240885),
(316158, 'PTHR42200:SF1', NULL, NULL, NULL, NULL, 'FLAGELLA-RELATED PROTEIN G-RELATED', 240885),
(316159, 'PTHR42200:SF2', NULL, NULL, NULL, NULL, 'ARCHAEAL FLAGELLA-RELATED PROTEIN F', 240885),
(316160, 'PTHR22751:SF166', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 240886),
(316161, 'PTHR22751:SF287', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 240886),
(316162, 'PTHR22751:SF286', NULL, NULL, NULL, NULL, 'PROTEIN CBG26668', 240886),
(316163, 'PTHR22751:SF102', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 240886),
(316164, 'PTHR22751:SF101', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 240886),
(316165, 'PTHR22751:SF266', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 240886),
(316166, 'PTHR22751:SF288', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 240886),
(316167, 'PTHR22751:SF127', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 240886),
(316168, 'PTHR22751:SF283', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 240886),
(316169, 'PTHR22751', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR-RELATED', 240886),
(316170, 'PTHR22751:SF284', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 240886),
(316171, 'PTHR22751:SF13', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 240886),
(316172, 'PTHR22751:SF33', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 240886); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(316173, 'PTHR22751:SF54', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 240886),
(316174, 'PTHR22751:SF42', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 240886),
(316175, 'PTHR22751:SF30', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 240886),
(316176, 'PTHR22751:SF63', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 240886),
(316177, 'PTHR22751:SF73', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 240886),
(316178, 'PTHR11937:SF59', NULL, NULL, NULL, NULL, 'ACTIN-LIKE PROTEIN 7B', 240887),
(316179, 'PTHR11937:SF162', NULL, NULL, NULL, NULL, 'ACTIN, INDIRECT FLIGHT MUSCLE-LIKE PROTEIN', 240887),
(316180, 'PTHR11937:SF445', NULL, NULL, NULL, NULL, 'ACTIN, AORTIC SMOOTH MUSCLE', 240887),
(316181, 'PTHR11937:SF168', NULL, NULL, NULL, NULL, 'BETA-ACTIN-LIKE PROTEIN 2', 240887),
(316182, 'PTHR11937:SF201', NULL, NULL, NULL, NULL, 'ACTIN, GAMMA-ENTERIC SMOOTH MUSCLE', 240887),
(316183, 'PTHR11937:SF167', NULL, NULL, NULL, NULL, 'ACTIN-LIKE PROTEIN 7A', 240887),
(316184, 'PTHR11937:SF208', NULL, NULL, NULL, NULL, 'ACTIN-LIKE PROTEIN 8', 240887),
(316185, 'PTHR11937:SF449', NULL, NULL, NULL, NULL, 'BNAA04G29020D PROTEIN', 240887),
(316186, 'PTHR11937:SF448', NULL, NULL, NULL, NULL, 'ACTIN-LIKE', 240887),
(316187, 'PTHR11937:SF46', NULL, NULL, NULL, NULL, 'SWI/SNF AND RSC COMPLEXES SUBUNIT ARP9', 240887),
(316188, 'PTHR11937:SF47', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 6', 240887),
(316189, 'PTHR11937:SF150', NULL, NULL, NULL, NULL, 'ACTIN, EPSILON 1', 240887),
(316190, 'PTHR11937:SF390', NULL, NULL, NULL, NULL, 'SI:CH211-241J12.3', 240887),
(316191, 'PTHR11937:SF434', NULL, NULL, NULL, NULL, 'ACTIN-12-RELATED', 240887),
(316192, 'PTHR11937:SF159', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN T3', 240887),
(316193, 'PTHR11937:SF555', NULL, NULL, NULL, NULL, 'ACTIN', 240887),
(316194, 'PTHR11937:SF554', NULL, NULL, NULL, NULL, 'BNAC04G48100D PROTEIN', 240887),
(316195, 'PTHR11937:SF553', NULL, NULL, NULL, NULL, 'ACTIN-75', 240887),
(316196, 'PTHR11937:SF278', NULL, NULL, NULL, NULL, 'BETA-ACTIN-LIKE PROTEIN 3-RELATED', 240887),
(316197, 'PTHR11937:SF156', NULL, NULL, NULL, NULL, 'ACTIN DOMAIN-CONTAINING PROTEIN', 240887),
(316198, 'PTHR11937:SF552', NULL, NULL, NULL, NULL, 'ACTIN-97', 240887),
(316199, 'PTHR11937:SF155', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 1', 240887),
(316200, 'PTHR11937:SF397', NULL, NULL, NULL, NULL, 'ACTIN-57B-RELATED', 240887),
(316201, 'PTHR11937:SF551', NULL, NULL, NULL, NULL, '', 240887),
(316202, 'PTHR11937:SF276', NULL, NULL, NULL, NULL, 'ACTIN-97', 240887),
(316203, 'PTHR11937:SF154', NULL, NULL, NULL, NULL, 'ACTIN-17-RELATED', 240887),
(316204, 'PTHR11937:SF550', NULL, NULL, NULL, NULL, 'ACTIN, ALPHA SARCOMERIC/SKELETAL', 240887),
(316205, 'PTHR11937:SF274', NULL, NULL, NULL, NULL, 'BRAHMA ASSOCIATED PROTEIN 55KD', 240887),
(316206, 'PTHR11937:SF153', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN T1', 240887),
(316207, 'PTHR11937:SF439', NULL, NULL, NULL, NULL, 'BNAC07G49030D PROTEIN', 240887),
(316208, 'PTHR11937:SF437', NULL, NULL, NULL, NULL, 'ACTIN', 240887),
(316209, 'PTHR11937:SF54', NULL, NULL, NULL, NULL, 'ACTIN-LIKE 11', 240887),
(316210, 'PTHR11937:SF436', NULL, NULL, NULL, NULL, 'ACTIN-7', 240887),
(316211, 'PTHR11937:SF556', NULL, NULL, NULL, NULL, '', 240887),
(316212, 'PTHR11937:SF37', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 2', 240887),
(316213, 'PTHR11937:SF38', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN T2', 240887),
(316214, 'PTHR11937:SF184', NULL, NULL, NULL, NULL, 'ACTIN ALPHA CARDIAC MUSCLE 1B', 240887),
(316215, 'PTHR11937:SF183', NULL, NULL, NULL, NULL, 'ACTIN-LIKE PROTEIN 10', 240887),
(316216, 'PTHR11937', NULL, NULL, NULL, NULL, 'ACTIN', 240887),
(316217, 'PTHR11937:SF465', NULL, NULL, NULL, NULL, '', 240887),
(316218, 'PTHR11937:SF463', NULL, NULL, NULL, NULL, 'BNAA02G07080D PROTEIN', 240887),
(316219, 'PTHR11937:SF461', NULL, NULL, NULL, NULL, 'ACTIN-71', 240887),
(316220, 'PTHR11937:SF508', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 240887);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(316221, 'PTHR11937:SF507', NULL, NULL, NULL, NULL, 'ACTIN', 240887),
(316222, 'PTHR11937:SF505', NULL, NULL, NULL, NULL, 'ACTIN-8', 240887),
(316223, 'PTHR11937:SF504', NULL, NULL, NULL, NULL, 'ACTIN-3', 240887),
(316224, 'PTHR11937:SF501', NULL, NULL, NULL, NULL, 'ACTIN, INDIRECT FLIGHT MUSCLE-RELATED', 240887),
(316225, 'PTHR11937:SF456', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 8', 240887),
(316226, 'PTHR11937:SF455', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 240887),
(316227, 'PTHR11937:SF451', NULL, NULL, NULL, NULL, 'ACTIN-LIKE PROTEIN ARP9', 240887),
(316228, 'PTHR11937:SF176', NULL, NULL, NULL, NULL, 'ACTIN, ALPHA CARDIAC MUSCLE 1', 240887),
(316229, 'PTHR11937:SF175', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 3', 240887),
(316230, 'PTHR11937:SF31', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 3', 240887),
(316231, 'PTHR11937:SF459', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 240887),
(316232, 'PTHR11937:SF458', NULL, NULL, NULL, NULL, '', 240887),
(316233, 'PTHR11937:SF457', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240887),
(316234, 'PTHR11937:SF13', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 8', 240887),
(316235, 'PTHR11937:SF14', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 10', 240887),
(316236, 'PTHR11937:SF16', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 5', 240887),
(316237, 'PTHR11937:SF520', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 240887),
(316238, 'PTHR11937:SF487', NULL, NULL, NULL, NULL, 'ACTIN-LIKE PROTEIN 6A', 240887),
(316239, 'PTHR11937:SF486', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 3', 240887),
(316240, 'PTHR11937:SF409', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 2', 240887),
(316241, 'PTHR11937:SF408', NULL, NULL, NULL, NULL, 'ACTIN-7', 240887),
(316242, 'PTHR11937:SF529', NULL, NULL, NULL, NULL, 'ACTIN-1-RELATED', 240887),
(316243, 'PTHR11937:SF528', NULL, NULL, NULL, NULL, '', 240887),
(316244, 'PTHR11937:SF527', NULL, NULL, NULL, NULL, 'MACRONUCLEAR ACTIN', 240887),
(316245, 'PTHR11937:SF526', NULL, NULL, NULL, NULL, 'ACTIN-42A-RELATED', 240887),
(316246, 'PTHR11937:SF524', NULL, NULL, NULL, NULL, 'BNAA09G38930D PROTEIN', 240887),
(316247, 'PTHR11937:SF248', NULL, NULL, NULL, NULL, 'ACTIN-1', 240887),
(316248, 'PTHR11937:SF195', NULL, NULL, NULL, NULL, 'BETA-CENTRACTIN', 240887),
(316249, 'PTHR11937:SF194', NULL, NULL, NULL, NULL, 'ACTIN-LIKE PROTEIN 9', 240887),
(316250, 'PTHR11937:SF193', NULL, NULL, NULL, NULL, 'ACTIN, ALPHA SKELETAL MUSCLE', 240887),
(316251, 'PTHR11937:SF192', NULL, NULL, NULL, NULL, 'ACTIN, CYTOPLASMIC 2', 240887),
(316252, 'PTHR11937:SF190', NULL, NULL, NULL, NULL, 'ZGC:101810', 240887),
(316253, 'PTHR11937:SF511', NULL, NULL, NULL, NULL, 'BNAA08G24380D PROTEIN', 240887),
(316254, 'PTHR11937:SF474', NULL, NULL, NULL, NULL, 'BNAC09G46850D PROTEIN', 240887),
(316255, 'PTHR11937:SF471', NULL, NULL, NULL, NULL, 'ACTIN-1-RELATED', 240887),
(316256, 'PTHR11937:SF196', NULL, NULL, NULL, NULL, 'ACTIN-LIKE PROTEIN 6B', 240887),
(316257, 'PTHR11937:SF519', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 3', 240887),
(316258, 'PTHR11937:SF515', NULL, NULL, NULL, NULL, 'ACTIN-58', 240887),
(316259, 'PTHR11937:SF514', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 3B-RELATED', 240887),
(316260, 'PTHR11937:SF513', NULL, NULL, NULL, NULL, 'ACTIN', 240887),
(316261, 'PTHR11937:SF512', NULL, NULL, NULL, NULL, '', 240887),
(316262, 'PTHR11937:SF544', NULL, NULL, NULL, NULL, 'ACTIN', 240887),
(316263, 'PTHR11937:SF543', NULL, NULL, NULL, NULL, 'ACTIN', 240887),
(316264, 'PTHR11937:SF389', NULL, NULL, NULL, NULL, 'ACTIN', 240887),
(316265, 'PTHR11937:SF421', NULL, NULL, NULL, NULL, 'ACTIN-10-RELATED', 240887),
(316266, 'PTHR11937:SF542', NULL, NULL, NULL, NULL, 'SWI/SNF AND RSC COMPLEXES SUBUNIT ARP42', 240887),
(316267, 'PTHR11937:SF541', NULL, NULL, NULL, NULL, 'ACTIN FAMILY PROTEIN', 240887),
(316268, 'PTHR11937:SF387', NULL, NULL, NULL, NULL, 'ACTIN', 240887),
(316269, 'PTHR11937:SF540', NULL, NULL, NULL, NULL, 'ACTIN', 240887),
(316270, 'PTHR11937:SF549', NULL, NULL, NULL, NULL, 'ACTIN-11', 240887);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(316271, 'PTHR11937:SF427', NULL, NULL, NULL, NULL, 'ACTIN-2', 240887),
(316272, 'PTHR11937:SF548', NULL, NULL, NULL, NULL, '', 240887),
(316273, 'PTHR11937:SF547', NULL, NULL, NULL, NULL, 'POTE ANKYRIN DOMAIN FAMILY MEMBER E-RELATED', 240887),
(316274, 'PTHR11937:SF546', NULL, NULL, NULL, NULL, 'ACTIN ALPHA CARDIAC MUSCLE 1', 240887),
(316275, 'PTHR11937:SF149', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 2-A-RELATED', 240887),
(316276, 'PTHR11937:SF545', NULL, NULL, NULL, NULL, 'ACTIN, CYTOSKELETAL 3B', 240887),
(316277, 'PTHR11937:SF370', NULL, NULL, NULL, NULL, 'ALPHA-CENTRACTIN', 240887),
(316278, 'PTHR11937:SF491', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 240887),
(316279, 'PTHR11937:SF533', NULL, NULL, NULL, NULL, 'ACTIN, CYTOPLASMIC 1', 240887),
(316280, 'PTHR11937:SF532', NULL, NULL, NULL, NULL, '', 240887),
(316281, 'PTHR11937:SF411', NULL, NULL, NULL, NULL, 'ACTIN-4', 240887),
(316282, 'PTHR11937:SF410', NULL, NULL, NULL, NULL, 'ACTIN-2', 240887),
(316283, 'PTHR11937:SF531', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 7', 240887),
(316284, 'PTHR11937:SF530', NULL, NULL, NULL, NULL, 'ACTIN', 240887),
(316285, 'PTHR11937:SF497', NULL, NULL, NULL, NULL, 'ACTIN-101', 240887),
(316286, 'PTHR11937:SF539', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 240887),
(316287, 'PTHR11937:SF417', NULL, NULL, NULL, NULL, '', 240887),
(316288, 'PTHR11937:SF538', NULL, NULL, NULL, NULL, 'ACTIN RELATED PROTEIN', 240887),
(316289, 'PTHR11937:SF537', NULL, NULL, NULL, NULL, 'ACTIN 17-D', 240887),
(316290, 'PTHR11937:SF536', NULL, NULL, NULL, NULL, 'ACTIN-7-LIKE', 240887),
(316291, 'PTHR11937:SF414', NULL, NULL, NULL, NULL, 'ACTIN, CYTOPLASMIC 1', 240887),
(316292, 'PTHR11937:SF535', NULL, NULL, NULL, NULL, 'ACTIN-7', 240887),
(316293, 'PTHR11937:SF534', NULL, NULL, NULL, NULL, 'ACTIN-97', 240887),
(316294, 'PTHR11937:SF413', NULL, NULL, NULL, NULL, '', 240887),
(316295, 'PTHR36800:SF1', NULL, NULL, NULL, NULL, 'POLYAMINE-MODULATED FACTOR 1-BINDING PROTEIN', 240888),
(316296, 'PTHR36800', NULL, NULL, NULL, NULL, 'POLYAMINE-MODULATED FACTOR 1-BINDING PROTEIN', 240888),
(316297, 'PTHR10969:SF60', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 8B', 240889),
(316298, 'PTHR10969:SF82', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN', 240889),
(316299, 'PTHR10969:SF83', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 8B', 240889),
(316300, 'PTHR10969:SF62', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 8D', 240889),
(316301, 'PTHR10969:SF84', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN', 240889),
(316302, 'PTHR10969:SF20', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID RECEPTOR-ASSOCIATED PROTEIN', 240889),
(316303, 'PTHR10969:SF86', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN', 240889),
(316304, 'PTHR10969:SF67', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 8A', 240889),
(316305, 'PTHR10969:SF89', NULL, NULL, NULL, NULL, 'GABA TYPE A RECEPTOR ASSOCIATED PROTEIN LIKE 1', 240889),
(316306, 'PTHR10969:SF80', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 8I', 240889),
(316307, 'PTHR10969:SF81', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 8D', 240889),
(316308, 'PTHR10969', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEINS 1A/1B LIGHT CHAIN 3-RELATED', 240889),
(316309, 'PTHR10969:SF79', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN', 240889),
(316310, 'PTHR10969:SF57', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN', 240889),
(316311, 'PTHR10969:SF14', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEINS 1A/1B LIGHT CHAIN 3A', 240889),
(316312, 'PTHR10969:SF37', NULL, NULL, NULL, NULL, 'PROTEIN LGG-2', 240889),
(316313, 'PTHR10969:SF15', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEINS 1A/1B LIGHT CHAIN 3 BETA 2-RELATED', 240889),
(316314, 'PTHR10969:SF16', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID RECEPTOR-ASSOCIATED PROTEIN-LIKE 3', 240889),
(316315, 'PTHR10969:SF93', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN', 240889),
(316316, 'PTHR10969:SF94', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN', 240889); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(316317, 'PTHR10969:SF50', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEINS 1A/1B LIGHT CHAIN 3C', 240889),
(316318, 'PTHR10969:SF95', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN', 240889),
(316319, 'PTHR10969:SF73', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN', 240889),
(316320, 'PTHR10969:SF96', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 8-LIKE PROTEIN DDB_G0290491', 240889),
(316321, 'PTHR10969:SF52', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN 1 LIGHT CHAIN 3 GAMMA,-LIKE', 240889),
(316322, 'PTHR10969:SF74', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN', 240889),
(316323, 'PTHR10969:SF30', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID RECEPTOR-ASSOCIATED PROTEIN-LIKE 1', 240889),
(316324, 'PTHR10969:SF97', NULL, NULL, NULL, NULL, 'GABA(A) RECEPTOR-ASSOCIATED PROTEIN B', 240889),
(316325, 'PTHR10969:SF54', NULL, NULL, NULL, NULL, 'ZGC:92606', 240889),
(316326, 'PTHR10969:SF98', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN', 240889),
(316327, 'PTHR10969:SF33', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED 8A, ISOFORM A-RELATED', 240889),
(316328, 'PTHR10969:SF55', NULL, NULL, NULL, NULL, 'GABA(A) RECEPTOR ASSOCIATED PROTEIN', 240889),
(316329, 'PTHR10969:SF99', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 8F', 240889),
(316330, 'PTHR10969:SF78', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN', 240889),
(316331, 'PTHR10969:SF90', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 8C', 240889),
(316332, 'PTHR10969:SF91', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN', 240889),
(316333, 'PTHR10969:SF70', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 8E', 240889),
(316334, 'PTHR10969:SF92', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN', 240889),
(316335, 'PTHR10969:SF4', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID RECEPTOR-ASSOCIATED PROTEIN-LIKE 2', 240889),
(316336, 'PTHR10969:SF25', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 8H', 240889),
(316337, 'PTHR10969:SF69', NULL, NULL, NULL, NULL, 'MAP1 LIGHT CHAIN 3-LIKE PROTEIN 2', 240889),
(316338, 'PTHR31374:SF144', NULL, NULL, NULL, NULL, '', 240890),
(316339, 'PTHR31374:SF386', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR50', 240890),
(316340, 'PTHR31374:SF387', NULL, NULL, NULL, NULL, 'SAUR FAMILY PROTEIN', 240890),
(316341, 'PTHR31374:SF266', NULL, NULL, NULL, NULL, 'SAUR FAMILY PROTEIN', 240890),
(316342, 'PTHR31374:SF388', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR36', 240890),
(316343, 'PTHR31374:SF146', NULL, NULL, NULL, NULL, 'OS08G0118800 PROTEIN', 240890),
(316344, 'PTHR31374:SF389', NULL, NULL, NULL, NULL, '', 240890),
(316345, 'PTHR31374:SF269', NULL, NULL, NULL, NULL, 'AUXIN RESPONSIVE SAUR PROTEIN', 240890),
(316346, 'PTHR31374:SF148', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR36-LIKE', 240890),
(316347, 'PTHR31374:SF380', NULL, NULL, NULL, NULL, 'SAUR25-AUXIN-RESPONSIVE SAUR FAMILY MEMBER', 240890),
(316348, 'PTHR31374:SF260', NULL, NULL, NULL, NULL, 'BNAANNG07560D PROTEIN', 240890),
(316349, 'PTHR31374:SF140', NULL, NULL, NULL, NULL, 'SMALL AUXIN-UP RNA-RELATED', 240890),
(316350, 'PTHR31374:SF261', NULL, NULL, NULL, NULL, 'OS01G0768333 PROTEIN', 240890),
(316351, 'PTHR31374:SF383', NULL, NULL, NULL, NULL, 'BNAA03G58660D PROTEIN', 240890),
(316352, 'PTHR31374:SF262', NULL, NULL, NULL, NULL, '', 240890),
(316353, 'PTHR31374:SF141', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY', 240890),
(316354, 'PTHR31374:SF384', NULL, NULL, NULL, NULL, 'SMALL AUXIN-UP RNA-RELATED', 240890),
(316355, 'PTHR31374:SF142', NULL, NULL, NULL, NULL, 'OS07G0475700 PROTEIN', 240890),
(316356, 'PTHR31374:SF264', NULL, NULL, NULL, NULL, 'SMALL AUXIN-UP RNA-RELATED', 240890),
(316357, 'PTHR31374:SF143', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR36-LIKE', 240890),
(316358, 'PTHR31374:SF385', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR32-LIKE', 240890),
(316359, 'PTHR31374:SF133', NULL, NULL, NULL, NULL, 'BNAC09G29950D PROTEIN', 240890),
(316360, 'PTHR31374:SF254', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR41', 240890);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(316361, 'PTHR31374:SF134', NULL, NULL, NULL, NULL, '', 240890),
(316362, 'PTHR31374:SF256', NULL, NULL, NULL, NULL, 'BNAC05G50280D PROTEIN', 240890),
(316363, 'PTHR31374:SF137', NULL, NULL, NULL, NULL, 'SAUR FAMILY PROTEIN', 240890),
(316364, 'PTHR31374:SF379', NULL, NULL, NULL, NULL, 'BNAC03G16420D PROTEIN', 240890),
(316365, 'PTHR31374:SF259', NULL, NULL, NULL, NULL, 'BNAANNG09090D PROTEIN', 240890),
(316366, 'PTHR31374:SF139', NULL, NULL, NULL, NULL, 'OS02G0143300 PROTEIN', 240890),
(316367, 'PTHR31374:SF370', NULL, NULL, NULL, NULL, '', 240890),
(316368, 'PTHR31374:SF6', NULL, NULL, NULL, NULL, 'OS04G0608300 PROTEIN', 240890),
(316369, 'PTHR31374:SF371', NULL, NULL, NULL, NULL, 'ARABIDOPSIS THALIANA GENOMIC DNA, CHROMOSOME 5, P1 CLONE:MOK16', 240890),
(316370, 'PTHR31374:SF251', NULL, NULL, NULL, NULL, 'BNAC02G44790D PROTEIN', 240890),
(316371, 'PTHR31374:SF5', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR77', 240890),
(316372, 'PTHR31374:SF7', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY', 240890),
(316373, 'PTHR31374:SF253', NULL, NULL, NULL, NULL, '', 240890),
(316374, 'PTHR31374:SF132', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN 15A-LIKE', 240890),
(316375, 'PTHR31374:SF374', NULL, NULL, NULL, NULL, 'SMALL AUXIN-UP RNA-RELATED', 240890),
(316376, 'PTHR31374:SF9', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE FAMILY PROTEIN', 240890),
(316377, 'PTHR31374:SF167', NULL, NULL, NULL, NULL, 'OS10G0510500 PROTEIN', 240890),
(316378, 'PTHR31374:SF289', NULL, NULL, NULL, NULL, 'BNAA02G17300D PROTEIN', 240890),
(316379, 'PTHR31374:SF168', NULL, NULL, NULL, NULL, 'SMALL AUXIN-UP RNA-RELATED', 240890),
(316380, 'PTHR31374:SF281', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETIC ACID-INDUCED PROTEIN ARG7-LIKE', 240890),
(316381, 'PTHR31374:SF162', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN-LIKE', 240890),
(316382, 'PTHR31374:SF284', NULL, NULL, NULL, NULL, 'BNAANNG07570D PROTEIN', 240890),
(316383, 'PTHR31374:SF163', NULL, NULL, NULL, NULL, 'AUXIN INDUCED LIKE-PROTEIN', 240890),
(316384, 'PTHR31374:SF285', NULL, NULL, NULL, NULL, 'BNAC03G46960D PROTEIN', 240890),
(316385, 'PTHR31374:SF155', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR40', 240890),
(316386, 'PTHR31374:SF397', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN 15A-LIKE', 240890),
(316387, 'PTHR31374:SF277', NULL, NULL, NULL, NULL, 'SAUR FAMILY PROTEIN', 240890),
(316388, 'PTHR31374:SF398', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR32-LIKE', 240890),
(316389, 'PTHR31374:SF399', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR71-LIKE', 240890),
(316390, 'PTHR31374:SF157', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR36-LIKE', 240890),
(316391, 'PTHR31374:SF279', NULL, NULL, NULL, NULL, 'SMALL AUXIN-UP RNA-RELATED', 240890),
(316392, 'PTHR31374:SF390', NULL, NULL, NULL, NULL, '', 240890),
(316393, 'PTHR31374:SF391', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN 6B', 240890),
(316394, 'PTHR31374:SF270', NULL, NULL, NULL, NULL, 'SMALL AUXIN-UP RNA-RELATED', 240890),
(316395, 'PTHR31374:SF271', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY', 240890),
(316396, 'PTHR31374:SF392', NULL, NULL, NULL, NULL, '', 240890),
(316397, 'PTHR31374:SF393', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY-RELATED', 240890),
(316398, 'PTHR31374:SF272', NULL, NULL, NULL, NULL, 'SMALL AUXIN-UP RNA-RELATED', 240890),
(316399, 'PTHR31374:SF151', NULL, NULL, NULL, NULL, '', 240890),
(316400, 'PTHR31374:SF152', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE FAMILY PROTEIN', 240890),
(316401, 'PTHR31374:SF394', NULL, NULL, NULL, NULL, 'OS02G0445100 PROTEIN', 240890),
(316402, 'PTHR31374:SF274', NULL, NULL, NULL, NULL, 'SMALL AUXIN-UP RNA-RELATED', 240890),
(316403, 'PTHR31374:SF153', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR32-LIKE', 240890),
(316404, 'PTHR31374:SF395', NULL, NULL, NULL, NULL, 'SMALL AUXIN-UP RNA-RELATED', 240890),
(316405, 'PTHR31374:SF154', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY', 240890),
(316406, 'PTHR31374:SF396', NULL, NULL, NULL, NULL, 'F6F9.11 PROTEIN', 240890);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(316407, 'PTHR31374:SF275', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR32-LIKE', 240890),
(316408, 'PTHR31374:SF188', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE FAMILY PROTEIN', 240890),
(316409, 'PTHR31374:SF181', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR32-LIKE', 240890),
(316410, 'PTHR31374:SF182', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN 15A-LIKE', 240890),
(316411, 'PTHR31374:SF183', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY', 240890),
(316412, 'PTHR31374:SF184', NULL, NULL, NULL, NULL, 'PROTEIN SMALL AUXIN UP-REGULATED RNA 10', 240890),
(316413, 'PTHR31374:SF187', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR32-LIKE', 240890),
(316414, 'PTHR31374:SF52', NULL, NULL, NULL, NULL, 'OS08G0452500 PROTEIN', 240890),
(316415, 'PTHR31374:SF298', NULL, NULL, NULL, NULL, 'BNACNNG23650D PROTEIN', 240890),
(316416, 'PTHR31374:SF178', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR15-LIKE', 240890),
(316417, 'PTHR31374:SF299', NULL, NULL, NULL, NULL, 'BNAANNG09080D PROTEIN', 240890),
(316418, 'PTHR31374:SF170', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY', 240890),
(316419, 'PTHR31374:SF291', NULL, NULL, NULL, NULL, 'BNAC02G03220D PROTEIN', 240890),
(316420, 'PTHR31374:SF293', NULL, NULL, NULL, NULL, 'BNAC05G15800D PROTEIN', 240890),
(316421, 'PTHR31374:SF294', NULL, NULL, NULL, NULL, 'SMALL AUXIN-UP RNA-RELATED', 240890),
(316422, 'PTHR31374:SF57', NULL, NULL, NULL, NULL, '', 240890),
(316423, 'PTHR31374:SF295', NULL, NULL, NULL, NULL, 'CALMODULIN BINDING PROTEIN', 240890),
(316424, 'PTHR31374:SF54', NULL, NULL, NULL, NULL, 'OS08G0118500 PROTEIN', 240890),
(316425, 'PTHR31374:SF176', NULL, NULL, NULL, NULL, 'OS06G0137400 PROTEIN', 240890),
(316426, 'PTHR31374:SF400', NULL, NULL, NULL, NULL, 'SAUR FAMILY PROTEIN', 240890),
(316427, 'PTHR31374:SF401', NULL, NULL, NULL, NULL, 'BNAANNG22670D PROTEIN', 240890),
(316428, 'PTHR31374:SF402', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED SAUR', 240890),
(316429, 'PTHR31374:SF403', NULL, NULL, NULL, NULL, 'BNAANNG08410D PROTEIN', 240890),
(316430, 'PTHR31374:SF404', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN 15A-LIKE', 240890),
(316431, 'PTHR31374:SF405', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN 15A-LIKE', 240890),
(316432, 'PTHR31374:SF406', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR32-LIKE', 240890),
(316433, 'PTHR31374:SF407', NULL, NULL, NULL, NULL, 'AUXIN RESPONSIVE SAUR PROTEIN', 240890),
(316434, 'PTHR31374:SF408', NULL, NULL, NULL, NULL, 'SAUR FAMILY PROTEIN', 240890),
(316435, 'PTHR31374:SF409', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN 15A-LIKE', 240890),
(316436, 'PTHR31374:SF199', NULL, NULL, NULL, NULL, 'SMALL AUXIN-UP RNA-RELATED', 240890),
(316437, 'PTHR31374:SF193', NULL, NULL, NULL, NULL, 'OS03G0780350 PROTEIN', 240890),
(316438, 'PTHR31374:SF195', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240890),
(316439, 'PTHR31374:SF196', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR71', 240890),
(316440, 'PTHR31374:SF197', NULL, NULL, NULL, NULL, '', 240890),
(316441, 'PTHR31374:SF198', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR72', 240890),
(316442, 'PTHR31374:SF420', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY', 240890),
(316443, 'PTHR31374:SF421', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR71', 240890),
(316444, 'PTHR31374:SF422', NULL, NULL, NULL, NULL, 'OS02G0143400 PROTEIN', 240890),
(316445, 'PTHR31374:SF302', NULL, NULL, NULL, NULL, 'BNAC09G37060D PROTEIN', 240890),
(316446, 'PTHR31374:SF423', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY', 240890),
(316447, 'PTHR31374:SF303', NULL, NULL, NULL, NULL, 'SAUR FAMILY PROTEIN', 240890),
(316448, 'PTHR31374:SF424', NULL, NULL, NULL, NULL, 'BNAC01G00010D PROTEIN', 240890),
(316449, 'PTHR31374:SF425', NULL, NULL, NULL, NULL, 'BNAA03G16940D PROTEIN', 240890),
(316450, 'PTHR31374:SF304', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR36-LIKE', 240890),
(316451, 'PTHR31374:SF426', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR41-LIKE', 240890);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(316452, 'PTHR31374:SF28', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY', 240890),
(316453, 'PTHR31374:SF26', NULL, NULL, NULL, NULL, 'OS02G0512000 PROTEIN', 240890),
(316454, 'PTHR31374:SF29', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY', 240890),
(316455, 'PTHR31374:SF427', NULL, NULL, NULL, NULL, 'SMALL AUXIN-UP RNA-RELATED', 240890),
(316456, 'PTHR31374:SF428', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR36-LIKE', 240890),
(316457, 'PTHR31374:SF429', NULL, NULL, NULL, NULL, 'SMALL AUXIN-UP RNA-RELATED', 240890),
(316458, 'PTHR31374:SF308', NULL, NULL, NULL, NULL, '', 240890),
(316459, 'PTHR31374:SF410', NULL, NULL, NULL, NULL, '', 240890),
(316460, 'PTHR31374:SF411', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY', 240890),
(316461, 'PTHR31374:SF412', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY-RELATED', 240890),
(316462, 'PTHR31374:SF413', NULL, NULL, NULL, NULL, 'AUXIN RESPONSIVE PROTEIN', 240890),
(316463, 'PTHR31374:SF414', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR32', 240890),
(316464, 'PTHR31374:SF415', NULL, NULL, NULL, NULL, '', 240890),
(316465, 'PTHR31374:SF16', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE FAMILY PROTEIN', 240890),
(316466, 'PTHR31374:SF15', NULL, NULL, NULL, NULL, 'SMALL AUXIN-UP RNA-RELATED', 240890),
(316467, 'PTHR31374:SF12', NULL, NULL, NULL, NULL, 'OS04G0662400 PROTEIN', 240890),
(316468, 'PTHR31374:SF13', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY', 240890),
(316469, 'PTHR31374:SF19', NULL, NULL, NULL, NULL, 'F8A24.8 PROTEIN', 240890),
(316470, 'PTHR31374:SF416', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY-RELATED', 240890),
(316471, 'PTHR31374:SF417', NULL, NULL, NULL, NULL, 'SMALL AUXIN-UP RNA-RELATED', 240890),
(316472, 'PTHR31374:SF418', NULL, NULL, NULL, NULL, '', 240890),
(316473, 'PTHR31374:SF419', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY', 240890),
(316474, 'PTHR31374', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN-LIKE-RELATED', 240890),
(316475, 'PTHR31374:SF321', NULL, NULL, NULL, NULL, '', 240890),
(316476, 'PTHR31374:SF201', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE FAMILY PROTEIN', 240890),
(316477, 'PTHR31374:SF323', NULL, NULL, NULL, NULL, 'BNAC08G11390D PROTEIN', 240890),
(316478, 'PTHR31374:SF202', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY', 240890),
(316479, 'PTHR31374:SF203', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR71-LIKE', 240890),
(316480, 'PTHR31374:SF206', NULL, NULL, NULL, NULL, 'F5M15.19', 240890),
(316481, 'PTHR31374:SF49', NULL, NULL, NULL, NULL, 'AUXIN RESPONSIVE PROTEIN, EXPRESSED', 240890),
(316482, 'PTHR31374:SF45', NULL, NULL, NULL, NULL, '', 240890),
(316483, 'PTHR31374:SF44', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE FAMILY PROTEIN', 240890),
(316484, 'PTHR31374:SF329', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY', 240890),
(316485, 'PTHR31374:SF208', NULL, NULL, NULL, NULL, 'SAUR33-AUXIN-RESPONSIVE SAUR FAMILY MEMBER', 240890),
(316486, 'PTHR31374:SF30', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE FAMILY PROTEIN', 240890),
(316487, 'PTHR31374:SF430', NULL, NULL, NULL, NULL, 'SAUR FAMILY PROTEIN', 240890),
(316488, 'PTHR31374:SF310', NULL, NULL, NULL, NULL, 'SMALL AUXIN-UP PROTEIN 58', 240890),
(316489, 'PTHR31374:SF311', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY', 240890),
(316490, 'PTHR31374:SF312', NULL, NULL, NULL, NULL, 'SAUR FAMILY PROTEIN', 240890),
(316491, 'PTHR31374:SF32', NULL, NULL, NULL, NULL, 'SMALL AUXIN-UP RNA-RELATED', 240890),
(316492, 'PTHR31374:SF342', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE FAMILY PROTEIN', 240890),
(316493, 'PTHR31374:SF222', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN-RELATED', 240890),
(316494, 'PTHR31374:SF343', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY-RELATED', 240890),
(316495, 'PTHR31374:SF344', NULL, NULL, NULL, NULL, '', 240890),
(316496, 'PTHR31374:SF346', NULL, NULL, NULL, NULL, 'AUXIN RESPONSIVE PROTEIN', 240890);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(316497, 'PTHR31374:SF348', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR71-LIKE', 240890),
(316498, 'PTHR31374:SF227', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETIC ACID-INDUCED PROTEIN ARG7-LIKE', 240890),
(316499, 'PTHR31374:SF228', NULL, NULL, NULL, NULL, 'OS02G0769100 PROTEIN', 240890),
(316500, 'PTHR31374:SF341', NULL, NULL, NULL, NULL, '', 240890),
(316501, 'PTHR31374:SF210', NULL, NULL, NULL, NULL, 'OS04G0537100 PROTEIN', 240890),
(316502, 'PTHR31374:SF331', NULL, NULL, NULL, NULL, 'SAUR FAMILY PROTEIN', 240890),
(316503, 'PTHR31374:SF211', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETIC ACID-INDUCED PROTEIN ARG7', 240890),
(316504, 'PTHR31374:SF212', NULL, NULL, NULL, NULL, 'AUXIN RESPONSIVE PROTEIN', 240890),
(316505, 'PTHR31374:SF213', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE FAMILY PROTEIN', 240890),
(316506, 'PTHR31374:SF335', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY-RELATED', 240890),
(316507, 'PTHR31374:SF214', NULL, NULL, NULL, NULL, 'AUXIN RESPONSIVE PROTEIN', 240890),
(316508, 'PTHR31374:SF336', NULL, NULL, NULL, NULL, 'OS02G0643800 PROTEIN', 240890),
(316509, 'PTHR31374:SF337', NULL, NULL, NULL, NULL, 'BNAA09G38680D PROTEIN', 240890),
(316510, 'PTHR31374:SF216', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY', 240890),
(316511, 'PTHR31374:SF330', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN X10A', 240890),
(316512, 'PTHR31374:SF218', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR71-LIKE', 240890),
(316513, 'PTHR31374:SF339', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR76', 240890),
(316514, 'PTHR31374:SF219', NULL, NULL, NULL, NULL, 'AUXIN RESPONSIVE PROTEIN', 240890),
(316515, 'PTHR31374:SF364', NULL, NULL, NULL, NULL, '', 240890),
(316516, 'PTHR31374:SF366', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR78', 240890),
(316517, 'PTHR31374:SF124', NULL, NULL, NULL, NULL, 'OS04G0617350 PROTEIN', 240890),
(316518, 'PTHR31374:SF246', NULL, NULL, NULL, NULL, 'BNACNNG59500D PROTEIN', 240890),
(316519, 'PTHR31374:SF368', NULL, NULL, NULL, NULL, 'SMALL AUXIN-UP RNA-RELATED', 240890),
(316520, 'PTHR31374:SF247', NULL, NULL, NULL, NULL, 'BNAA02G05090D PROTEIN', 240890),
(316521, 'PTHR31374:SF248', NULL, NULL, NULL, NULL, 'BNAA01G05940D PROTEIN', 240890),
(316522, 'PTHR31374:SF369', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY', 240890),
(316523, 'PTHR31374:SF249', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY-RELATED', 240890),
(316524, 'PTHR31374:SF361', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR32-LIKE', 240890),
(316525, 'PTHR31374:SF240', NULL, NULL, NULL, NULL, 'BNAC06G01240D PROTEIN', 240890),
(316526, 'PTHR31374:SF363', NULL, NULL, NULL, NULL, 'AUXIN-REGULATED PROTEIN-RELATED', 240890),
(316527, 'PTHR31374:SF242', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR15-LIKE', 240890),
(316528, 'PTHR31374:SF232', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN-LIKE PROTEIN', 240890),
(316529, 'PTHR31374:SF233', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR72-LIKE', 240890),
(316530, 'PTHR31374:SF113', NULL, NULL, NULL, NULL, 'SMALL AUXIN UP RNA1', 240890),
(316531, 'PTHR31374:SF234', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR71', 240890),
(316532, 'PTHR31374:SF356', NULL, NULL, NULL, NULL, 'SMALL AUXIN-UP RNA-RELATED', 240890),
(316533, 'PTHR31374:SF116', NULL, NULL, NULL, NULL, 'OS01G0155100 PROTEIN', 240890),
(316534, 'PTHR31374:SF359', NULL, NULL, NULL, NULL, '', 240890),
(316535, 'PTHR31374:SF238', NULL, NULL, NULL, NULL, 'BNACNNG20020D PROTEIN', 240890),
(316536, 'PTHR31374:SF118', NULL, NULL, NULL, NULL, 'OS02G0305950 PROTEIN', 240890),
(316537, 'PTHR31374:SF119', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY', 240890),
(316538, 'PTHR36172', NULL, NULL, NULL, NULL, '', 240891),
(316539, 'PTHR36172:SF1', NULL, NULL, NULL, NULL, 'RESOLVASE/INVERTASE-TYPE RECOMBINASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 240891),
(316540, 'PTHR28160:SF1', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN L15, MITOCHONDRIAL', 240892);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(316541, 'PTHR28160', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN L15, MITOCHONDRIAL', 240892),
(316542, 'PTHR34952:SF6', NULL, NULL, NULL, NULL, 'BNAA03G17240D PROTEIN', 240893),
(316543, 'PTHR34952:SF7', NULL, NULL, NULL, NULL, 'BNAA04G21460D PROTEIN', 240893),
(316544, 'PTHR34952:SF8', NULL, NULL, NULL, NULL, 'BRI1-KD INTERACTING PROTEIN 130', 240893),
(316545, 'PTHR34952:SF9', NULL, NULL, NULL, NULL, '', 240893),
(316546, 'PTHR34952:SF2', NULL, NULL, NULL, NULL, 'OS05G0113500 PROTEIN', 240893),
(316547, 'PTHR34952:SF4', NULL, NULL, NULL, NULL, '', 240893),
(316548, 'PTHR34952', NULL, NULL, NULL, NULL, 'OS05G0113500 PROTEIN', 240893),
(316549, 'PTHR34952:SF1', NULL, NULL, NULL, NULL, '', 240893),
(316550, 'PTHR21937:SF5', NULL, NULL, NULL, NULL, 'GENE 973-RELATED', 240894),
(316551, 'PTHR21937', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 240894),
(316552, 'PTHR46795:SF2', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, PERMEASE PROTEIN-RELATED', 240895),
(316553, 'PTHR46795:SF3', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE-RELATED', 240895),
(316554, 'PTHR46795', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE-RELATED-RELATED', 240895),
(316555, 'PTHR46795:SF1', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN', 240895),
(316556, 'PTHR42711:SF14', NULL, NULL, NULL, NULL, 'ABC-TYPE MULTIDRUG TRANSPORT SYSTEM, ATPASE COMPONENT', 240896),
(316557, 'PTHR42711:SF13', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, ATP-BINDING PROTEIN', 240896),
(316558, 'PTHR42711:SF16', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN', 240896),
(316559, 'PTHR42711:SF15', NULL, NULL, NULL, NULL, 'ABC-TYPE MULTIDRUG TRANSPORT SYSTEM, ATPASE COMPONENT-RELATED', 240896),
(316560, 'PTHR42711:SF10', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN', 240896),
(316561, 'PTHR42711:SF12', NULL, NULL, NULL, NULL, 'MULTIDRUG EFFLUX SYSTEM ATP-BINDING PROTEIN RV1218C', 240896),
(316562, 'PTHR42711:SF1', NULL, NULL, NULL, NULL, 'ABC-TRANSPORT PROTEIN, ATP-BINDING COMPONENT-RELATED', 240896),
(316563, 'PTHR42711:SF4', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER RELATED', 240896),
(316564, 'PTHR42711:SF5', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN NATA', 240896),
(316565, 'PTHR42711', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN', 240896),
(316566, 'PTHR42711:SF17', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN', 240896),
(316567, 'PTHR43728:SF1', NULL, NULL, NULL, NULL, 'RADICAL SAM SUPERFAMILY PROTEIN-RELATED', 240897),
(316568, 'PTHR43728', NULL, NULL, NULL, NULL, 'SLR0304 PROTEIN', 240897),
(316569, 'PTHR13055:SF11', NULL, NULL, NULL, NULL, 'PLEXIN DOMAIN-CONTAINING PROTEIN 2', 240898),
(316570, 'PTHR13055', NULL, NULL, NULL, NULL, 'TUMOR ENDOTHELIAL MARKER 7 RELATED', 240898),
(316571, 'PTHR13055:SF10', NULL, NULL, NULL, NULL, 'PLEXIN DOMAIN-CONTAINING PROTEIN 1', 240898),
(316572, 'PTHR13055:SF12', NULL, NULL, NULL, NULL, 'LD40707P', 240898),
(316573, 'PTHR37464', NULL, NULL, NULL, NULL, 'BLL2463 PROTEIN', 240899),
(316574, 'PTHR37464:SF1', NULL, NULL, NULL, NULL, 'BLL2463 PROTEIN', 240899),
(316575, 'PTHR46563:SF1', NULL, NULL, NULL, NULL, 'C2H2 TYPE ZN-FINGER-CONTAINING PROTEIN-RELATED', 240900),
(316576, 'PTHR46563', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 240900),
(316577, 'PTHR46563:SF3', NULL, NULL, NULL, NULL, 'CKK DOMAIN-CONTAINING PROTEIN', 240900),
(316578, 'PTHR46948', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P PROTEIN SUBUNIT P38', 240901),
(316579, 'PTHR46948:SF1', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P PROTEIN SUBUNIT P38', 240901),
(316580, 'PTHR11721:SF16', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L18E/L15P DOMAIN-CONTAINING PROTEIN', 240902),
(316581, 'PTHR11721:SF38', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L18E/L15P DOMAIN-CONTAINING PROTEIN', 240902),
(316582, 'PTHR11721:SF27', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L27A', 240902),
(316583, 'PTHR11721:SF3', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L27A', 240902),
(316584, 'PTHR11721:SF28', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L18E/L15P DOMAIN-CONTAINING PROTEIN', 240902);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(316585, 'PTHR11721:SF14', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L18E/L15P DOMAIN-CONTAINING PROTEIN', 240902),
(316586, 'PTHR11721:SF36', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L27A-3', 240902),
(316587, 'PTHR11721:SF25', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L27A-3-LIKE', 240902),
(316588, 'PTHR11721:SF37', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L18E/L15P DOMAIN-CONTAINING PROTEIN', 240902),
(316589, 'PTHR11721', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L27A', 240902),
(316590, 'PTHR11721:SF30', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L27A', 240902),
(316591, 'PTHR11721:SF31', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L18E/L15P DOMAIN-CONTAINING PROTEIN', 240902),
(316592, 'PTHR11721:SF34', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L18E/L15P DOMAIN-CONTAINING PROTEIN', 240902),
(316593, 'PTHR11721:SF23', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L18E/L15P DOMAIN-CONTAINING PROTEIN', 240902),
(316594, 'PTHR11721:SF35', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L27A-3', 240902),
(316595, 'PTHR12250:SF0', NULL, NULL, NULL, NULL, 'GPI ETHANOLAMINE PHOSPHATE TRANSFERASE 1', 240903),
(316596, 'PTHR12250', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL GLYCAN, CLASS N', 240903),
(316597, 'PTHR33128:SF74', NULL, NULL, NULL, NULL, '', 240904),
(316598, 'PTHR33128:SF52', NULL, NULL, NULL, NULL, 'OS02G0508801 PROTEIN', 240904),
(316599, 'PTHR33128:SF51', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 240904),
(316600, 'PTHR33128:SF73', NULL, NULL, NULL, NULL, 'BNAA06G16390D PROTEIN', 240904),
(316601, 'PTHR33128:SF76', NULL, NULL, NULL, NULL, '', 240904),
(316602, 'PTHR33128:SF54', NULL, NULL, NULL, NULL, 'OS01G0849500 PROTEIN', 240904),
(316603, 'PTHR33128:SF75', NULL, NULL, NULL, NULL, '', 240904),
(316604, 'PTHR33128:SF53', NULL, NULL, NULL, NULL, 'BNAA06G39150D PROTEIN', 240904),
(316605, 'PTHR33128:SF78', NULL, NULL, NULL, NULL, 'OS02G0509500 PROTEIN', 240904),
(316606, 'PTHR33128:SF56', NULL, NULL, NULL, NULL, '', 240904),
(316607, 'PTHR33128:SF34', NULL, NULL, NULL, NULL, 'OS04G0387600 PROTEIN', 240904),
(316608, 'PTHR33128:SF55', NULL, NULL, NULL, NULL, 'OS11G0496500 PROTEIN', 240904),
(316609, 'PTHR33128:SF77', NULL, NULL, NULL, NULL, 'BNAC06G13370D PROTEIN', 240904),
(316610, 'PTHR33128:SF58', NULL, NULL, NULL, NULL, '', 240904),
(316611, 'PTHR33128:SF79', NULL, NULL, NULL, NULL, 'OS05G0103400 PROTEIN', 240904),
(316612, 'PTHR33128:SF57', NULL, NULL, NULL, NULL, 'PEROXIDASE (DUF 3339)', 240904),
(316613, 'PTHR33128:SF35', NULL, NULL, NULL, NULL, '', 240904),
(316614, 'PTHR33128:SF38', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 240904),
(316615, 'PTHR33128:SF59', NULL, NULL, NULL, NULL, '', 240904),
(316616, 'PTHR33128:SF39', NULL, NULL, NULL, NULL, 'OS01G0923200 PROTEIN', 240904),
(316617, 'PTHR33128', NULL, NULL, NULL, NULL, 'OS05G0103400 PROTEIN', 240904),
(316618, 'PTHR33128:SF81', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF 3339)-RELATED', 240904),
(316619, 'PTHR33128:SF80', NULL, NULL, NULL, NULL, '', 240904),
(316620, 'PTHR33128:SF61', NULL, NULL, NULL, NULL, 'BNAA02G28560D PROTEIN', 240904),
(316621, 'PTHR33128:SF60', NULL, NULL, NULL, NULL, 'BNAA06G18990D PROTEIN', 240904),
(316622, 'PTHR33128:SF82', NULL, NULL, NULL, NULL, '', 240904),
(316623, 'PTHR33128:SF40', NULL, NULL, NULL, NULL, '', 240904),
(316624, 'PTHR33128:SF65', NULL, NULL, NULL, NULL, '', 240904),
(316625, 'PTHR33128:SF42', NULL, NULL, NULL, NULL, '', 240904),
(316626, 'PTHR33128:SF64', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF 3339)-RELATED', 240904),
(316627, 'PTHR33128:SF67', NULL, NULL, NULL, NULL, 'F1C9.28 PROTEIN', 240904),
(316628, 'PTHR33128:SF45', NULL, NULL, NULL, NULL, 'OS05G0103300 PROTEIN', 240904),
(316629, 'PTHR33128:SF66', NULL, NULL, NULL, NULL, '', 240904),
(316630, 'PTHR33128:SF44', NULL, NULL, NULL, NULL, '', 240904),
(316631, 'PTHR33128:SF47', NULL, NULL, NULL, NULL, 'GPI-ANCHORED-LIKE PROTEIN (DUF 3339)', 240904),
(316632, 'PTHR33128:SF69', NULL, NULL, NULL, NULL, 'OS01G0101900 PROTEIN', 240904),
(316633, 'PTHR33128:SF46', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF 3339)-RELATED', 240904);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(316634, 'PTHR33128:SF68', NULL, NULL, NULL, NULL, 'BNAA04G10730D PROTEIN', 240904),
(316635, 'PTHR33128:SF49', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 240904),
(316636, 'PTHR33128:SF2', NULL, NULL, NULL, NULL, 'OS04G0387900 PROTEIN', 240904),
(316637, 'PTHR33128:SF1', NULL, NULL, NULL, NULL, '', 240904),
(316638, 'PTHR33128:SF9', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 240904),
(316639, 'PTHR33128:SF6', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 240904),
(316640, 'PTHR33128:SF70', NULL, NULL, NULL, NULL, 'BNAA06G32460D PROTEIN', 240904),
(316641, 'PTHR33128:SF72', NULL, NULL, NULL, NULL, '', 240904),
(316642, 'PTHR33128:SF71', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 240904),
(316643, 'PTHR12599:SF16', NULL, NULL, NULL, NULL, '4A-HYDROXYTETRAHYDROBIOPTERIN DEHYDRATASE', 240905),
(316644, 'PTHR12599:SF15', NULL, NULL, NULL, NULL, 'PTERIN-4-ALPHA-CARBINOLAMINE DEHYDRATASE 2', 240905),
(316645, 'PTHR12599:SF14', NULL, NULL, NULL, NULL, '4A-HYDROXYTETRAHYDROBIOPTERIN DEHYDRATASE', 240905),
(316646, 'PTHR12599:SF13', NULL, NULL, NULL, NULL, 'PTERIN-4-ALPHA-CARBINOLAMINE DEHYDRATASE', 240905),
(316647, 'PTHR12599:SF8', NULL, NULL, NULL, NULL, 'PTERIN-4-ALPHA-CARBINOLAMINE DEHYDRATASE, CHLOROPLASTIC-RELATED', 240905),
(316648, 'PTHR12599', NULL, NULL, NULL, NULL, 'PTERIN-4-ALPHA-CARBINOLAMINE DEHYDRATASE', 240905),
(316649, 'PTHR12599:SF0', NULL, NULL, NULL, NULL, 'PTERIN-4-ALPHA-CARBINOLAMINE DEHYDRATASE', 240905),
(316650, 'PTHR37488:SF6', NULL, NULL, NULL, NULL, 'DUF1275 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_3G07550)', 240906),
(316651, 'PTHR37488:SF7', NULL, NULL, NULL, NULL, 'DUF1275 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_5G13060)', 240906),
(316652, 'PTHR37488', NULL, NULL, NULL, NULL, 'DUF1275 DOMAIN-CONTAINING PROTEIN', 240906),
(316653, 'PTHR37488:SF2', NULL, NULL, NULL, NULL, 'DUF1275 DOMAIN-CONTAINING PROTEIN', 240906),
(316654, 'PTHR37488:SF1', NULL, NULL, NULL, NULL, 'DUF1275 DOMAIN-CONTAINING PROTEIN', 240906),
(316655, 'PTHR37179:SF1', NULL, NULL, NULL, NULL, 'TRANSGLYCOSYLASE', 240907),
(316656, 'PTHR37179', NULL, NULL, NULL, NULL, 'TRANSGLYCOSYLASE', 240907),
(316657, 'PTHR16483', NULL, NULL, NULL, NULL, 'GASTROKINE 1', 240908),
(316658, 'PTHR16483:SF0', NULL, NULL, NULL, NULL, 'BRICHOS DOMAIN-CONTAINING PROTEIN 5', 240908),
(316659, 'PTHR16483:SF4', NULL, NULL, NULL, NULL, 'BRICHOS DOMAIN-CONTAINING PROTEIN', 240908),
(316660, 'PTHR16483:SF3', NULL, NULL, NULL, NULL, 'GASTROKINE-2', 240908),
(316661, 'PTHR16483:SF2', NULL, NULL, NULL, NULL, 'GASTROKINE-3', 240908),
(316662, 'PTHR16483:SF1', NULL, NULL, NULL, NULL, 'GASTROKINE-1', 240908),
(316663, 'PTHR16483:SF5', NULL, NULL, NULL, NULL, 'GASTROKINE-1-LIKE', 240908),
(316664, 'PTHR34791:SF6', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', 240909),
(316665, 'PTHR34791:SF1', NULL, NULL, NULL, NULL, 'OS02G0272100 PROTEIN', 240909),
(316666, 'PTHR34791:SF4', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN', 240909),
(316667, 'PTHR34791', NULL, NULL, NULL, NULL, 'OS02G0272100 PROTEIN', 240909),
(316668, 'PTHR34791:SF3', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 240909),
(316669, 'PTHR33871:SF18', NULL, NULL, NULL, NULL, 'F24J8.12 PROTEIN', 240910),
(316670, 'PTHR33871:SF19', NULL, NULL, NULL, NULL, 'BNACNNG04080D PROTEIN', 240910),
(316671, 'PTHR33871:SF1', NULL, NULL, NULL, NULL, 'OS01G0779800 PROTEIN', 240910),
(316672, 'PTHR33871:SF20', NULL, NULL, NULL, NULL, '', 240910),
(316673, 'PTHR33871:SF8', NULL, NULL, NULL, NULL, 'OS03G0582800 PROTEIN', 240910),
(316674, 'PTHR33871:SF16', NULL, NULL, NULL, NULL, 'CK25', 240910),
(316675, 'PTHR33871:SF17', NULL, NULL, NULL, NULL, 'BNAC05G08500D PROTEIN', 240910),
(316676, 'PTHR33871:SF14', NULL, NULL, NULL, NULL, '', 240910),
(316677, 'PTHR33871:SF15', NULL, NULL, NULL, NULL, '', 240910),
(316678, 'PTHR33871:SF24', NULL, NULL, NULL, NULL, 'OS05G0503100 PROTEIN', 240910),
(316679, 'PTHR33871:SF21', NULL, NULL, NULL, NULL, 'BNAC08G42190D PROTEIN', 240910),
(316680, 'PTHR33871', NULL, NULL, NULL, NULL, 'OS05G0503100 PROTEIN-RELATED', 240910);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(316681, 'PTHR33871:SF22', NULL, NULL, NULL, NULL, '', 240910),
(316682, 'PTHR36338:SF1', NULL, NULL, NULL, NULL, 'OS02G0495900 PROTEIN', 240911),
(316683, 'PTHR36338', NULL, NULL, NULL, NULL, 'OS02G0495900 PROTEIN', 240911),
(316684, 'PTHR42782', NULL, NULL, NULL, NULL, 'SI:CH73-314G15.3', 240912),
(316685, 'PTHR42782:SF2', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE-LIKE PROTEIN', 240912),
(316686, 'PTHR42782:SF4', NULL, NULL, NULL, NULL, 'SI:CH73-314G15.3', 240912),
(316687, 'PTHR46158:SF12', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 240913),
(316688, 'PTHR46158:SF13', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 240913),
(316689, 'PTHR46158:SF10', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 240913),
(316690, 'PTHR46158:SF11', NULL, NULL, NULL, NULL, 'ZINC FINGER RING-CH-TYPE DOMAIN CONTAINING PROTEIN', 240913),
(316691, 'PTHR46158:SF7', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 240913),
(316692, 'PTHR46158:SF2', NULL, NULL, NULL, NULL, 'OS02G0165000 PROTEIN', 240913),
(316693, 'PTHR46158:SF1', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 240913),
(316694, 'PTHR46158:SF14', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 240913),
(316695, 'PTHR46158:SF15', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING-CH-TYPE, ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 240913),
(316696, 'PTHR46158:SF20', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 240913),
(316697, 'PTHR46158', NULL, NULL, NULL, NULL, 'OS02G0165000 PROTEIN', 240913),
(316698, 'PTHR46158:SF18', NULL, NULL, NULL, NULL, 'OS04G0105100 PROTEIN', 240913),
(316699, 'PTHR46158:SF19', NULL, NULL, NULL, NULL, 'ZINC FINGER FAMILY PROTEIN', 240913),
(316700, 'PTHR46158:SF9', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 240913),
(316701, 'PTHR43757:SF2', NULL, NULL, NULL, NULL, 'AMINOMETHYLTRANSFERASE, MITOCHONDRIAL', 240914),
(316702, 'PTHR43757', NULL, NULL, NULL, NULL, 'AMINOMETHYLTRANSFERASE', 240914),
(316703, 'PTHR43757:SF6', NULL, NULL, NULL, NULL, 'AMINOMETHYLTRANSFERASE', 240914),
(316704, 'PTHR43757:SF9', NULL, NULL, NULL, NULL, 'FAD DEPENDENT OXIDOREDUCTASE', 240914),
(316705, 'PTHR43757:SF14', NULL, NULL, NULL, NULL, 'GLYCINE CLEAVAGE T-PROTEIN FAMILY', 240914),
(316706, 'PTHR43757:SF13', NULL, NULL, NULL, NULL, 'DAO DOMAIN-CONTAINING PROTEIN', 240914),
(316707, 'PTHR43757:SF12', NULL, NULL, NULL, NULL, 'DIMETHYLGLYCINE DEHYDROGENASE', 240914),
(316708, 'PTHR43757:SF11', NULL, NULL, NULL, NULL, 'SARCOSINE DEHYDROGENASE', 240914),
(316709, 'PTHR45682', NULL, NULL, NULL, NULL, 'AGAP008228-PA', 240915),
(316710, 'PTHR45682:SF10', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE 13 ISOFORM B', 240915),
(316711, 'PTHR45682:SF12', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE', 240915),
(316712, 'PTHR45682:SF14', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PHOSPHATASE 29-RELATED', 240915),
(316713, 'PTHR45682:SF13', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE', 240915),
(316714, 'PTHR45682:SF1', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE 3', 240915),
(316715, 'PTHR45682:SF16', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE', 240915),
(316716, 'PTHR45682:SF15', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE', 240915),
(316717, 'PTHR45682:SF3', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE', 240915),
(316718, 'PTHR45682:SF2', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE', 240915),
(316719, 'PTHR45682:SF8', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE 26', 240915),
(316720, 'PTHR45682:SF5', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE', 240915),
(316721, 'PTHR45682:SF4', NULL, NULL, NULL, NULL, 'SERINE/THREONINE/TYROSINE-INTERACTING-LIKE PROTEIN 2', 240915),
(316722, 'PTHR45682:SF6', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PHOSPHATASE 29', 240915),
(316723, 'PTHR41247:SF1', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REPRESSOR YCNK', 240916);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(316724, 'PTHR41247', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REPRESSOR YCNK', 240916),
(316725, 'PTHR35088:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 178', 240917),
(316726, 'PTHR35088', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 178', 240917),
(316727, 'PTHR43857', NULL, NULL, NULL, NULL, 'BLR7761 PROTEIN', 240918),
(316728, 'PTHR43857:SF1', NULL, NULL, NULL, NULL, 'ENDORIBONUCLEASE-RELATED', 240918),
(316729, 'PTHR38133', NULL, NULL, NULL, NULL, 'SLR1429 PROTEIN', 240919),
(316730, 'PTHR38133:SF1', NULL, NULL, NULL, NULL, 'SLR1429 PROTEIN', 240919),
(316731, 'PTHR13134:SF3', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT 13', 240920),
(316732, 'PTHR13134:SF4', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT 13-RELATED', 240920),
(316733, 'PTHR13134', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 240920),
(316734, 'PTHR43528:SF3', NULL, NULL, NULL, NULL, 'CITRATE-PROTON SYMPORTER', 240921),
(316735, 'PTHR43528:SF5', NULL, NULL, NULL, NULL, 'PROLINE/BETAINE TRANSPORTER', 240921),
(316736, 'PTHR43528:SF6', NULL, NULL, NULL, NULL, 'CITRATE-PROTON SYMPORTER', 240921),
(316737, 'PTHR43528', NULL, NULL, NULL, NULL, 'ALPHA-KETOGLUTARATE PERMEASE', 240921),
(316738, 'PTHR43528:SF1', NULL, NULL, NULL, NULL, 'ALPHA-KETOGLUTARATE PERMEASE', 240921),
(316739, 'PTHR43528:SF7', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN-RELATED', 240921),
(316740, 'PTHR43528:SF8', NULL, NULL, NULL, NULL, 'BLR0239 PROTEIN', 240921),
(316741, 'PTHR11109', NULL, NULL, NULL, NULL, 'GTP CYCLOHYDROLASE I', 240922),
(316742, 'PTHR11109:SF6', NULL, NULL, NULL, NULL, 'GTP CYCLOHYDROLASE 1', 240922),
(316743, 'PTHR11109:SF7', NULL, NULL, NULL, NULL, 'GTP CYCLOHYDROLASE 1', 240922),
(316744, 'PTHR11109:SF11', NULL, NULL, NULL, NULL, 'GTP CYCLOHYDROLASE 1', 240922),
(316745, 'PTHR11109:SF10', NULL, NULL, NULL, NULL, 'GTP CYCLOHYDROLASE 1', 240922),
(316746, 'PTHR11109:SF13', NULL, NULL, NULL, NULL, 'GTP CYCLOHYDROLASE 1', 240922),
(316747, 'PTHR11109:SF12', NULL, NULL, NULL, NULL, 'GTP CYCLOHYDROLASE 1', 240922),
(316748, 'PTHR28255', NULL, NULL, NULL, NULL, '', 240923),
(316749, 'PTHR28255:SF1', NULL, NULL, NULL, NULL, 'UPF0303 PROTEIN YBR137W', 240923),
(316750, 'PTHR37758:SF1', NULL, NULL, NULL, NULL, 'OS03G0334300 PROTEIN', 240924),
(316751, 'PTHR37758', NULL, NULL, NULL, NULL, 'OS03G0334300 PROTEIN', 240924),
(316752, 'PTHR47798:SF2', NULL, NULL, NULL, NULL, 'PROTEIN AIR1', 240925),
(316753, 'PTHR47798', NULL, NULL, NULL, NULL, 'OS04G0555800 PROTEIN', 240925),
(316754, 'PTHR11780:SF10', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] FLAVOPROTEIN 1, MITOCHONDRIAL', 240926),
(316755, 'PTHR11780:SF11', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] FLAVOPROTEIN 1, MITOCHONDRIAL', 240926),
(316756, 'PTHR11780', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE FLAVOPROTEIN 1  NDUFV1', 240926),
(316757, 'PTHR45955', NULL, NULL, NULL, NULL, 'PHOSPHOACETYLGLUCOSAMINE MUTASE', 240927),
(316758, 'PTHR45955:SF3', NULL, NULL, NULL, NULL, 'PHOSPHOACETYLGLUCOSAMINE MUTASE 2', 240927),
(316759, 'PTHR45955:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOACETYLGLUCOSAMINE MUTASE', 240927),
(316760, 'PTHR45955:SF2', NULL, NULL, NULL, NULL, 'PHOSPHOACETYLGLUCOSAMINE MUTASE', 240927),
(316761, 'PTHR13738:SF9', NULL, NULL, NULL, NULL, 'TROPONIN I, SLOW SKELETAL MUSCLE', 240928),
(316762, 'PTHR13738:SF31', NULL, NULL, NULL, NULL, 'TROPONIN I TYPE 2A (SKELETAL, FAST), TANDEM DUPLICATE 3-RELATED', 240928),
(316763, 'PTHR13738:SF40', NULL, NULL, NULL, NULL, 'INCENP_ARK-BIND DOMAIN-CONTAINING PROTEIN', 240928),
(316764, 'PTHR13738:SF1', NULL, NULL, NULL, NULL, 'TROPONIN I', 240928),
(316765, 'PTHR13738:SF2', NULL, NULL, NULL, NULL, 'TROPONIN I, CARDIAC MUSCLE', 240928),
(316766, 'PTHR13738:SF6', NULL, NULL, NULL, NULL, 'TROPONIN I 1', 240928),
(316767, 'PTHR13738', NULL, NULL, NULL, NULL, 'TROPONIN I', 240928),
(316768, 'PTHR13738:SF18', NULL, NULL, NULL, NULL, 'TROPONIN I 3', 240928),
(316769, 'PTHR13738:SF13', NULL, NULL, NULL, NULL, 'TROPONIN I TYPE 2A (SKELETAL, FAST), TANDEM DUPLICATE 2', 240928);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(316770, 'PTHR13738:SF12', NULL, NULL, NULL, NULL, 'TROPONIN I4A-RELATED', 240928),
(316771, 'PTHR13738:SF33', NULL, NULL, NULL, NULL, 'TROPONIN I4B, TANDEM DUPLICATE 1', 240928),
(316772, 'PTHR13738:SF39', NULL, NULL, NULL, NULL, 'TROPONIN I 2', 240928),
(316773, 'PTHR13738:SF38', NULL, NULL, NULL, NULL, 'TROPONIN I, SKELETAL, SLOW C-RELATED', 240928),
(316774, 'PTHR13738:SF37', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 240928),
(316775, 'PTHR13738:SF15', NULL, NULL, NULL, NULL, 'TROPONIN I, FAST SKELETAL MUSCLE', 240928),
(316776, 'PTHR44873:SF1', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 30, MITOCHONDRIAL', 240929),
(316777, 'PTHR44873', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 30, MITOCHONDRIAL', 240929),
(316778, 'PTHR11766:SF0', NULL, NULL, NULL, NULL, 'TYROSINE--TRNA LIGASE, MITOCHONDRIAL', 240930),
(316779, 'PTHR11766', NULL, NULL, NULL, NULL, 'TYROSYL-TRNA SYNTHETASE', 240930),
(316780, 'PTHR11766:SF1', NULL, NULL, NULL, NULL, 'TYROSINE--TRNA LIGASE', 240930),
(316781, 'PTHR39175:SF1', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G15060)-RELATED', 240931),
(316782, 'PTHR39175', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G15060)-RELATED', 240931),
(316783, 'PTHR36019:SF3', NULL, NULL, NULL, NULL, 'PLANT/PROTEIN', 240932),
(316784, 'PTHR36019:SF2', NULL, NULL, NULL, NULL, 'BNAA02G24660D PROTEIN', 240932),
(316785, 'PTHR36019:SF7', NULL, NULL, NULL, NULL, '', 240932),
(316786, 'PTHR36019', NULL, NULL, NULL, NULL, 'PLANT/PROTEIN', 240932),
(316787, 'PTHR36947', NULL, NULL, NULL, NULL, 'PROTEIN CBG04364', 240933),
(316788, 'PTHR36947:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG04364', 240933),
(316789, 'PTHR36947:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG03147', 240933),
(316790, 'PTHR36947:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG04400', 240933),
(316791, 'PTHR47479:SF2', NULL, NULL, NULL, NULL, 'OS05G0393200 PROTEIN', 240934),
(316792, 'PTHR47479:SF4', NULL, NULL, NULL, NULL, 'BNAANNG03100D PROTEIN', 240934),
(316793, 'PTHR47479', NULL, NULL, NULL, NULL, 'OS05G0393200 PROTEIN', 240934),
(316794, 'PTHR31356:SF64', NULL, NULL, NULL, NULL, 'L-ASCORBATE PEROXIDASE 7, CHLOROPLASTIC-RELATED', 240935),
(316795, 'PTHR31356:SF53', NULL, NULL, NULL, NULL, 'PEROXIDASE', 240935),
(316796, 'PTHR31356:SF8', NULL, NULL, NULL, NULL, 'L-ASCORBATE PEROXIDASE 6-RELATED', 240935),
(316797, 'PTHR31356:SF41', NULL, NULL, NULL, NULL, 'L-ASCORBATE PEROXIDASE 3, PEROXISOMAL-LIKE', 240935),
(316798, 'PTHR31356:SF63', NULL, NULL, NULL, NULL, 'L-ASCORBATE PEROXIDASE', 240935),
(316799, 'PTHR31356:SF62', NULL, NULL, NULL, NULL, 'L-ASCORBATE PEROXIDASE T, CHLOROPLASTIC', 240935),
(316800, 'PTHR31356:SF61', NULL, NULL, NULL, NULL, 'L-ASCORBATE PEROXIDASE 3, PEROXISOMAL-RELATED', 240935),
(316801, 'PTHR31356:SF35', NULL, NULL, NULL, NULL, 'L-ASCORBATE PEROXIDASE 2, CYTOSOLIC', 240935),
(316802, 'PTHR31356:SF57', NULL, NULL, NULL, NULL, 'L-ASCORBATE PEROXIDASE 1, CYTOSOLIC', 240935),
(316803, 'PTHR31356:SF34', NULL, NULL, NULL, NULL, 'THYLAKOID LUMENAL 29 KDA PROTEIN, CHLOROPLASTIC', 240935),
(316804, 'PTHR31356:SF56', NULL, NULL, NULL, NULL, 'L-ASCORBATE PEROXIDASE', 240935),
(316805, 'PTHR31356:SF11', NULL, NULL, NULL, NULL, 'L-ASCORBATE PEROXIDASE 8, CHLOROPLASTIC-RELATED', 240935),
(316806, 'PTHR31356:SF55', NULL, NULL, NULL, NULL, 'ASCORBATE PEROXIDASE', 240935),
(316807, 'PTHR31356:SF43', NULL, NULL, NULL, NULL, 'CYTOSOLIC ASCORBATE PEROXIDASE 1', 240935),
(316808, 'PTHR31356:SF38', NULL, NULL, NULL, NULL, 'L-ASCORBATE PEROXIDASE 5, PEROXISOMAL', 240935),
(316809, 'PTHR31356:SF15', NULL, NULL, NULL, NULL, 'PEROXIDASE_4 DOMAIN-CONTAINING PROTEIN', 240935),
(316810, 'PTHR31356:SF59', NULL, NULL, NULL, NULL, 'L-ASCORBATE PEROXIDASE 2, CYTOSOLIC', 240935),
(316811, 'PTHR31356:SF36', NULL, NULL, NULL, NULL, 'L-ASCORBATE PEROXIDASE 3', 240935),
(316812, 'PTHR31356:SF58', NULL, NULL, NULL, NULL, 'CYTOCHROME C PEROXIDASE, MITOCHONDRIAL', 240935),
(316813, 'PTHR31356:SF47', NULL, NULL, NULL, NULL, 'L-ASCORBATE PEROXIDASE', 240935);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(316814, 'PTHR31356', NULL, NULL, NULL, NULL, 'THYLAKOID LUMENAL 29 KDA PROTEIN, CHLOROPLASTIC-RELATED', 240935),
(316815, 'PTHR31356:SF60', NULL, NULL, NULL, NULL, 'L-ASCORBATE PEROXIDASE 1, CYTOSOLIC', 240935),
(316816, 'PTHR31356:SF1', NULL, NULL, NULL, NULL, 'L-ASCORBATE PEROXIDASE S, CHLOROPLASTIC/MITOCHONDRIAL', 240935),
(316817, 'PTHR28094:SF2', NULL, NULL, NULL, NULL, 'T5ORF172 DOMAIN-CONTAINING PROTEIN', 240936),
(316818, 'PTHR28094:SF3', NULL, NULL, NULL, NULL, 'T5ORF172 DOMAIN-CONTAINING PROTEIN', 240936),
(316819, 'PTHR28094:SF1', NULL, NULL, NULL, NULL, 'MEIOTICALLY UP-REGULATED GENE 113 PROTEIN', 240936),
(316820, 'PTHR28094', NULL, NULL, NULL, NULL, 'MEIOTICALLY UP-REGULATED GENE 113 PROTEIN', 240936),
(316821, 'PTHR39942:SF1', NULL, NULL, NULL, NULL, 'BCDNA.LD26519-RELATED', 240937),
(316822, 'PTHR39942', NULL, NULL, NULL, NULL, 'BCDNA.LD26519-RELATED', 240937),
(316823, 'PTHR24148:SF66', NULL, NULL, NULL, NULL, 'ANKYRIN AND HET DOMAIN PROTEIN', 240938),
(316824, 'PTHR24148', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 39 HOMOLOG-RELATED', 240938),
(316825, 'PTHR24148:SF71', NULL, NULL, NULL, NULL, 'HET DOMAIN-CONTAINING PROTEIN', 240938),
(316826, 'PTHR24148:SF73', NULL, NULL, NULL, NULL, 'HETEROKARYON INCOMPATIBILITY PROTEIN 6, OR ALLELE', 240938),
(316827, 'PTHR24148:SF64', NULL, NULL, NULL, NULL, 'HET DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_8G01020)-RELATED', 240938),
(316828, 'PTHR24148:SF76', NULL, NULL, NULL, NULL, 'HET DOMAIN-CONTAINING PROTEIN', 240938),
(316829, 'PTHR28063:SF1', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II NUCLEAR LOCALIZATION PROTEIN IWR1', 240939),
(316830, 'PTHR28063', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II NUCLEAR LOCALIZATION PROTEIN IWR1', 240939),
(316831, 'PTHR13126', NULL, NULL, NULL, NULL, 'CHAPERONE ATP11', 240940),
(316832, 'PTHR13126:SF3', NULL, NULL, NULL, NULL, 'BNAA04G19940D PROTEIN', 240940),
(316833, 'PTHR13126:SF0', NULL, NULL, NULL, NULL, 'ATP SYNTHASE MITOCHONDRIAL F1 COMPLEX ASSEMBLY FACTOR 1', 240940),
(316834, 'PTHR47896:SF1', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN BETA-9', 240941),
(316835, 'PTHR47896', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN BETA-9', 240941),
(316836, 'PTHR30328', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR', 240942),
(316837, 'PTHR30328:SF54', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REPRESSOR SCO4008', 240942),
(316838, 'PTHR37187', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240943),
(316839, 'PTHR37187:SF11', NULL, NULL, NULL, NULL, 'BNAA04G20080D PROTEIN', 240943),
(316840, 'PTHR37187:SF10', NULL, NULL, NULL, NULL, 'BNAA07G07940D PROTEIN', 240943),
(316841, 'PTHR37187:SF20', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', 240943),
(316842, 'PTHR37187:SF15', NULL, NULL, NULL, NULL, '', 240943),
(316843, 'PTHR37187:SF9', NULL, NULL, NULL, NULL, 'BNAA03G48470D PROTEIN', 240943),
(316844, 'PTHR37187:SF7', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240943),
(316845, 'PTHR37187:SF8', NULL, NULL, NULL, NULL, 'BNAA09G26770D PROTEIN', 240943),
(316846, 'PTHR37187:SF19', NULL, NULL, NULL, NULL, 'BNAC03G59220D PROTEIN', 240943),
(316847, 'PTHR37187:SF18', NULL, NULL, NULL, NULL, '', 240943),
(316848, 'PTHR37187:SF17', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240943),
(316849, 'PTHR37187:SF16', NULL, NULL, NULL, NULL, 'BNACNNG74510D PROTEIN', 240943),
(316850, 'PTHR37187:SF6', NULL, NULL, NULL, NULL, 'BNAC08G11140D PROTEIN', 240943),
(316851, 'PTHR31080:SF114', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 240944),
(316852, 'PTHR31080:SF113', NULL, NULL, NULL, NULL, 'CELL WALL / VACUOLAR INHIBITOR OF FRUCTOSIDASE 1-LIKE', 240944),
(316853, 'PTHR31080:SF234', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316854, 'PTHR31080:SF112', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR', 240944),
(316855, 'PTHR31080:SF199', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316856, 'PTHR31080:SF232', NULL, NULL, NULL, NULL, '21 KDA PROTEIN-LIKE', 240944),
(316857, 'PTHR31080:SF111', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(316858, 'PTHR31080:SF118', NULL, NULL, NULL, NULL, 'PECTINESTERASE INHIBITOR 10', 240944),
(316859, 'PTHR31080:SF239', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR SUPERFAMILY PROTEIN', 240944),
(316860, 'PTHR31080:SF117', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR SUPERFAMILY PROTEIN', 240944),
(316861, 'PTHR31080:SF237', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316862, 'PTHR31080:SF236', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316863, 'PTHR31080:SF119', NULL, NULL, NULL, NULL, 'PECTINESTERASE INHIBITOR 4', 240944),
(316864, 'PTHR31080:SF121', NULL, NULL, NULL, NULL, 'PECTINESTERASE INHIBITOR DOMAIN CONTAINING PROTEIN EXPRESSED', 240944),
(316865, 'PTHR31080:SF242', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316866, 'PTHR31080:SF240', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316867, 'PTHR31080:SF102', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316868, 'PTHR31080:SF222', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316869, 'PTHR31080:SF188', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316870, 'PTHR31080:SF221', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316871, 'PTHR31080:SF107', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316872, 'PTHR31080:SF227', NULL, NULL, NULL, NULL, '21 KDA PROTEIN-LIKE', 240944),
(316873, 'PTHR31080:SF104', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 240944),
(316874, 'PTHR31080:SF229', NULL, NULL, NULL, NULL, 'PECTIN METHYLESTERASE INHIBITOR-RELATED', 240944),
(316875, 'PTHR31080:SF190', NULL, NULL, NULL, NULL, 'PECTINESTERASE INHIBITOR DOMAIN-CONTAINING PROTEIN-RELATED', 240944),
(316876, 'PTHR31080:SF194', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR SUPERFAMILY PROTEIN', 240944),
(316877, 'PTHR31080:SF192', NULL, NULL, NULL, NULL, 'PECTINESTERASE INHIBITOR 11', 240944),
(316878, 'PTHR31080:SF198', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316879, 'PTHR31080:SF110', NULL, NULL, NULL, NULL, 'PECTINESTERASE INHIBITOR 3', 240944),
(316880, 'PTHR31080:SF231', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316881, 'PTHR31080:SF197', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316882, 'PTHR31080:SF195', NULL, NULL, NULL, NULL, 'INVERTASE INHIBITOR', 240944),
(316883, 'PTHR31080:SF136', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR SUPERFAMILY PROTEIN', 240944),
(316884, 'PTHR31080:SF135', NULL, NULL, NULL, NULL, 'CELL WALL / VACUOLAR INHIBITOR OF FRUCTOSIDASE 1-LIKE', 240944),
(316885, 'PTHR31080:SF69', NULL, NULL, NULL, NULL, 'OS03G0830600 PROTEIN', 240944),
(316886, 'PTHR31080:SF134', NULL, NULL, NULL, NULL, 'CELL WALL / VACUOLAR INHIBITOR OF FRUCTOSIDASE 2-LIKE', 240944),
(316887, 'PTHR31080:SF255', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316888, 'PTHR31080:SF254', NULL, NULL, NULL, NULL, 'OS10G0508700 PROTEIN', 240944),
(316889, 'PTHR31080:SF66', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240944),
(316890, 'PTHR31080:SF139', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316891, 'PTHR31080:SF138', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR SUPERFAMILY PROTEIN', 240944),
(316892, 'PTHR31080:SF68', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR SUPERFAMILY PROTEIN', 240944),
(316893, 'PTHR31080:SF64', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR SUPERFAMILY PROTEIN', 240944),
(316894, 'PTHR31080:SF264', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316895, 'PTHR31080:SF263', NULL, NULL, NULL, NULL, 'PGPS/D7', 240944),
(316896, 'PTHR31080:SF261', NULL, NULL, NULL, NULL, 'OS04G0445300 PROTEIN', 240944),
(316897, 'PTHR31080:SF140', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(316898, 'PTHR31080:SF125', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316899, 'PTHR31080:SF246', NULL, NULL, NULL, NULL, 'PECTINESTERASE INHIBITOR-LIKE', 240944),
(316900, 'PTHR31080:SF244', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR SUPERFAMILY PROTEIN', 240944),
(316901, 'PTHR31080:SF243', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316902, 'PTHR31080:SF122', NULL, NULL, NULL, NULL, '21 KDA PROTEIN-LIKE', 240944),
(316903, 'PTHR31080', NULL, NULL, NULL, NULL, 'PECTINESTERASE INHIBITOR-LIKE', 240944),
(316904, 'PTHR31080:SF128', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316905, 'PTHR31080:SF76', NULL, NULL, NULL, NULL, 'OS04G0587100 PROTEIN', 240944),
(316906, 'PTHR31080:SF79', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR SUPERFAMILY PROTEIN', 240944),
(316907, 'PTHR31080:SF248', NULL, NULL, NULL, NULL, 'PECTINESTERASE INHIBITOR-LIKE', 240944),
(316908, 'PTHR31080:SF127', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316909, 'PTHR31080:SF78', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316910, 'PTHR31080:SF73', NULL, NULL, NULL, NULL, 'OS02G0103200 PROTEIN', 240944),
(316911, 'PTHR31080:SF253', NULL, NULL, NULL, NULL, 'BNAA01G30250D PROTEIN', 240944),
(316912, 'PTHR31080:SF71', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316913, 'PTHR31080:SF250', NULL, NULL, NULL, NULL, 'OS05G0543000 PROTEIN', 240944),
(316914, 'PTHR31080:SF70', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240944),
(316915, 'PTHR31080:SF279', NULL, NULL, NULL, NULL, 'OS02G0688200 PROTEIN', 240944),
(316916, 'PTHR31080:SF158', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR SUPERFAMILY PROTEIN', 240944),
(316917, 'PTHR31080:SF157', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR SUPERFAMILY PROTEIN', 240944),
(316918, 'PTHR31080:SF278', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316919, 'PTHR31080:SF277', NULL, NULL, NULL, NULL, 'PECTINESTERASE INHIBITOR DOMAIN-CONTAINING PROTEIN-RELATED', 240944),
(316920, 'PTHR31080:SF156', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316921, 'PTHR31080:SF155', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316922, 'PTHR31080:SF276', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR SUPERFAMILY PROTEIN', 240944),
(316923, 'PTHR31080:SF88', NULL, NULL, NULL, NULL, 'OS08G0222800 PROTEIN', 240944),
(316924, 'PTHR31080:SF87', NULL, NULL, NULL, NULL, 'PECTINESTERASE INHIBITOR 7', 240944),
(316925, 'PTHR31080:SF161', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316926, 'PTHR31080:SF84', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316927, 'PTHR31080:SF282', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR', 240944),
(316928, 'PTHR31080:SF281', NULL, NULL, NULL, NULL, 'OS12G0561500 PROTEIN', 240944),
(316929, 'PTHR31080:SF83', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316930, 'PTHR31080:SF160', NULL, NULL, NULL, NULL, '21 KDA PROTEIN-LIKE', 240944),
(316931, 'PTHR31080:SF280', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR', 240944),
(316932, 'PTHR31080:SF86', NULL, NULL, NULL, NULL, 'PECTINESTERASE INHIBITOR 6', 240944),
(316933, 'PTHR31080:SF286', NULL, NULL, NULL, NULL, 'CELL WALL / VACUOLAR INHIBITOR OF FRUCTOSIDASE 1-LIKE', 240944),
(316934, 'PTHR31080:SF285', NULL, NULL, NULL, NULL, 'PECTIN METHYLESTERASE INHIBITOR 1', 240944),
(316935, 'PTHR31080:SF284', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316936, 'PTHR31080:SF162', NULL, NULL, NULL, NULL, '21 KDA PROTEIN-LIKE', 240944),
(316937, 'PTHR31080:SF283', NULL, NULL, NULL, NULL, 'C/VIF2', 240944),
(316938, 'PTHR31080:SF15', NULL, NULL, NULL, NULL, 'INVERTASE', 240944),
(316939, 'PTHR31080:SF268', NULL, NULL, NULL, NULL, 'PGPS/D7', 240944),
(316940, 'PTHR31080:SF147', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(316941, 'PTHR31080:SF146', NULL, NULL, NULL, NULL, 'PECTINESTERASE INHIBITOR DOMAIN CONTAINING PROTEIN', 240944),
(316942, 'PTHR31080:SF267', NULL, NULL, NULL, NULL, 'CELL WALL / VACUOLAR INHIBITOR OF FRUCTOSIDASE 2', 240944),
(316943, 'PTHR31080:SF145', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316944, 'PTHR31080:SF144', NULL, NULL, NULL, NULL, '21 KDA PROTEIN-LIKE', 240944),
(316945, 'PTHR31080:SF149', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316946, 'PTHR31080:SF12', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316947, 'PTHR31080:SF148', NULL, NULL, NULL, NULL, '21 KDA PROTEIN-LIKE', 240944),
(316948, 'PTHR31080:SF269', NULL, NULL, NULL, NULL, 'PECTIN METHYLESTERASE INHIBITOR 1', 240944),
(316949, 'PTHR31080:SF18', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316950, 'PTHR31080:SF95', NULL, NULL, NULL, NULL, 'INVERTASE INHIBITOR-LIKE PROTEIN-RELATED', 240944),
(316951, 'PTHR31080:SF150', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316952, 'PTHR31080:SF271', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316953, 'PTHR31080:SF270', NULL, NULL, NULL, NULL, '21 KDA PROTEIN-LIKE', 240944),
(316954, 'PTHR31080:SF96', NULL, NULL, NULL, NULL, '21 KDA PROTEIN-LIKE', 240944),
(316955, 'PTHR31080:SF91', NULL, NULL, NULL, NULL, 'PECTIN METHYLESTERASE INHIBITOR 1', 240944),
(316956, 'PTHR31080:SF154', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316957, 'PTHR31080:SF275', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR SUPERFAMILY PROTEIN', 240944),
(316958, 'PTHR31080:SF274', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 26-RELATED', 240944),
(316959, 'PTHR31080:SF90', NULL, NULL, NULL, NULL, 'OS02G0689000 PROTEIN', 240944),
(316960, 'PTHR31080:SF152', NULL, NULL, NULL, NULL, 'CELL WALL / VACUOLAR INHIBITOR OF FRUCTOSIDASE 2', 240944),
(316961, 'PTHR31080:SF273', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316962, 'PTHR31080:SF272', NULL, NULL, NULL, NULL, '21 KDA PROTEIN-LIKE', 240944),
(316963, 'PTHR31080:SF213', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316964, 'PTHR31080:SF212', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316965, 'PTHR31080:SF179', NULL, NULL, NULL, NULL, 'PECTINESTERASE INHIBITOR DOMAIN-CONTAINING PROTEIN-RELATED', 240944),
(316966, 'PTHR31080:SF178', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR SUPERFAMILY PROTEIN-RELATED', 240944),
(316967, 'PTHR31080:SF177', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316968, 'PTHR31080:SF27', NULL, NULL, NULL, NULL, 'OS07G0244800 PROTEIN', 240944),
(316969, 'PTHR31080:SF210', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316970, 'PTHR31080:SF217', NULL, NULL, NULL, NULL, 'OS08G0541800 PROTEIN', 240944),
(316971, 'PTHR31080:SF21', NULL, NULL, NULL, NULL, 'OS07G0247000 PROTEIN', 240944),
(316972, 'PTHR31080:SF216', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316973, 'PTHR31080:SF215', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316974, 'PTHR31080:SF214', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316975, 'PTHR31080:SF219', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316976, 'PTHR31080:SF1', NULL, NULL, NULL, NULL, 'OS05G0360900 PROTEIN', 240944),
(316977, 'PTHR31080:SF218', NULL, NULL, NULL, NULL, 'PECTINESTERASE INHIBITOR DOMAIN-CONTAINING PROTEIN-RELATED', 240944),
(316978, 'PTHR31080:SF6', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR SUPERFAMILY PROTEIN', 240944),
(316979, 'PTHR31080:SF181', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 240944),
(316980, 'PTHR31080:SF180', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316981, 'PTHR31080:SF220', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316982, 'PTHR31080:SF186', NULL, NULL, NULL, NULL, '21 KDA PROTEIN-LIKE', 240944);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(316983, 'PTHR31080:SF185', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316984, 'PTHR31080:SF184', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316985, 'PTHR31080:SF169', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316986, 'PTHR31080:SF289', NULL, NULL, NULL, NULL, 'CELL WALL / VACUOLAR INHIBITOR OF FRUCTOSIDASE 2', 240944),
(316987, 'PTHR31080:SF288', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR SUPERFAMILY PROTEIN', 240944),
(316988, 'PTHR31080:SF200', NULL, NULL, NULL, NULL, 'PECTINESTERASE INHIBITOR-LIKE', 240944),
(316989, 'PTHR31080:SF166', NULL, NULL, NULL, NULL, '21 KDA PROTEIN-LIKE', 240944),
(316990, 'PTHR31080:SF287', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316991, 'PTHR31080:SF206', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316992, 'PTHR31080:SF205', NULL, NULL, NULL, NULL, '', 240944),
(316993, 'PTHR31080:SF35', NULL, NULL, NULL, NULL, 'OS12G0128900 PROTEIN', 240944),
(316994, 'PTHR31080:SF204', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316995, 'PTHR31080:SF203', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316996, 'PTHR31080:SF209', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316997, 'PTHR31080:SF208', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(316998, 'PTHR31080:SF207', NULL, NULL, NULL, NULL, 'PECTINESTERASE INHIBITOR 9', 240944),
(316999, 'PTHR31080:SF172', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(317000, 'PTHR31080:SF291', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 240944),
(317001, 'PTHR31080:SF290', NULL, NULL, NULL, NULL, 'INVERTASE INHIBITOR', 240944),
(317002, 'PTHR31080:SF176', NULL, NULL, NULL, NULL, 'CELL WALL / VACUOLAR INHIBITOR OF FRUCTOSIDASE 1', 240944),
(317003, 'PTHR31080:SF174', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR SUPERFAMILY PROTEIN-RELATED', 240944),
(317004, 'PTHR31080:SF173', NULL, NULL, NULL, NULL, 'PECTINESTERASE INHIBITOR DOMAIN-CONTAINING PROTEIN-RELATED', 240944),
(317005, 'PTHR41152', NULL, NULL, NULL, NULL, 'AT26438P-RELATED', 240945),
(317006, 'PTHR41152:SF8', NULL, NULL, NULL, NULL, 'AT26438P-RELATED', 240945),
(317007, 'PTHR35683:SF8', NULL, NULL, NULL, NULL, 'YALI0C04136P', 240946),
(317008, 'PTHR35683:SF7', NULL, NULL, NULL, NULL, 'AGAP002273-PA', 240946),
(317009, 'PTHR35683:SF4', NULL, NULL, NULL, NULL, 'PAS DOMAIN-CONTAINING PROTEIN', 240946),
(317010, 'PTHR35683', NULL, NULL, NULL, NULL, 'YALI0C04136P', 240946),
(317011, 'PTHR12281', NULL, NULL, NULL, NULL, 'RP42 RELATED', 240947),
(317012, 'PTHR12281:SF29', NULL, NULL, NULL, NULL, 'DEFECTIVE IN CULLIN NEDDYLATION PROTEIN', 240947),
(317013, 'PTHR12281:SF16', NULL, NULL, NULL, NULL, 'DCN1-LIKE PROTEIN 2', 240947),
(317014, 'PTHR12281:SF27', NULL, NULL, NULL, NULL, 'DEFECTIVE IN CULLIN NEDDYLATION PROTEIN', 240947),
(317015, 'PTHR12281:SF28', NULL, NULL, NULL, NULL, 'DEFECTIVE IN CULLIN NEDDYLATION PROTEIN', 240947),
(317016, 'PTHR12281:SF25', NULL, NULL, NULL, NULL, 'DEFECTIVE IN CULLIN NEDDYLATION PROTEIN', 240947),
(317017, 'PTHR12281:SF26', NULL, NULL, NULL, NULL, 'DEFECTIVE IN CULLIN NEDDYLATION PROTEIN', 240947),
(317018, 'PTHR12281:SF34', NULL, NULL, NULL, NULL, 'DEFECTIVE IN CULLIN NEDDYLATION PROTEIN', 240947),
(317019, 'PTHR12281:SF12', NULL, NULL, NULL, NULL, 'DEFECTIVE IN CULLIN NEDDYLATION PROTEIN', 240947),
(317020, 'PTHR12281:SF10', NULL, NULL, NULL, NULL, 'DCN1-LIKE PROTEIN 1', 240947),
(317021, 'PTHR12281:SF21', NULL, NULL, NULL, NULL, 'DEFECTIVE IN CULLIN NEDDYLATION PROTEIN', 240947),
(317022, 'PTHR12281:SF32', NULL, NULL, NULL, NULL, 'DCN1-LIKE PROTEIN', 240947),
(317023, 'PTHR12281:SF22', NULL, NULL, NULL, NULL, 'DEFECTIVE IN CULLIN NEDDYLATION PROTEIN', 240947),
(317024, 'PTHR12281:SF33', NULL, NULL, NULL, NULL, 'DEFECTIVE IN CULLIN NEDDYLATION PROTEIN', 240947),
(317025, 'PTHR12281:SF30', NULL, NULL, NULL, NULL, 'DEFECTIVE IN CULLIN NEDDYLATION PROTEIN', 240947);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(317026, 'PTHR12281:SF20', NULL, NULL, NULL, NULL, 'DEFECTIVE IN CULLIN NEDDYLATION PROTEIN', 240947),
(317027, 'PTHR12281:SF31', NULL, NULL, NULL, NULL, 'DCN1-LIKE PROTEIN 3', 240947),
(317028, 'PTHR12281:SF6', NULL, NULL, NULL, NULL, 'DCN1-LIKE PROTEIN 5', 240947),
(317029, 'PTHR12281:SF8', NULL, NULL, NULL, NULL, 'DCN1-LIKE PROTEIN 4', 240947),
(317030, 'PTHR12281:SF2', NULL, NULL, NULL, NULL, 'DEFECTIVE IN CULLIN NEDDYLATION PROTEIN', 240947),
(317031, 'PTHR13421:SF16', NULL, NULL, NULL, NULL, 'SNRNA-ACTIVATING PROTEIN COMPLEX SUBUNIT 3', 240948),
(317032, 'PTHR13421:SF22', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RNA-ACTIVATING COMPLEX POLYPEPTIDE 3', 240948),
(317033, 'PTHR13421', NULL, NULL, NULL, NULL, 'SNRNA-ACTIVATING PROTEIN COMPLEX SUBUNIT 3', 240948),
(317034, 'PTHR35696', NULL, NULL, NULL, NULL, 'ELECTRON CARRIER/IRON ION-BINDING PROTEIN', 240949),
(317035, 'PTHR35696:SF1', NULL, NULL, NULL, NULL, 'ELECTRON CARRIER/IRON ION-BINDING PROTEIN', 240949),
(317036, 'PTHR38815:SF1', NULL, NULL, NULL, NULL, 'HYPOTHETICAL MEMBRANE PROTEIN, CONSERVED, DUF373 FAMILY', 240950),
(317037, 'PTHR38815', NULL, NULL, NULL, NULL, 'HYPOTHETICAL MEMBRANE PROTEIN, CONSERVED, DUF373 FAMILY', 240950),
(317038, 'PTHR43051:SF1', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDE ADENYLYLTRANSFERASE FAMILY PROTEIN', 240951),
(317039, 'PTHR43051:SF11', NULL, NULL, NULL, NULL, 'TRNA NUCLEOTIDYLTRANSFERASE/POLY(A) POLYMERASE', 240951),
(317040, 'PTHR43051:SF3', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDE ADENYLYLTRANSFERASE FAMILY PROTEIN', 240951),
(317041, 'PTHR43051:SF2', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDE ADENYLYLTRANSFERASE FAMILY PROTEIN-RELATED', 240951),
(317042, 'PTHR43051:SF10', NULL, NULL, NULL, NULL, '', 240951),
(317043, 'PTHR43051', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDE ADENYLYLTRANSFERASE FAMILY PROTEIN', 240951),
(317044, 'PTHR43051:SF4', NULL, NULL, NULL, NULL, 'POLY(A) POLYMERASE I-LIKE', 240951),
(317045, 'PTHR43051:SF7', NULL, NULL, NULL, NULL, 'POLY A POLYMERASE, HEAD DOMAIN-CONTAINING PROTEIN-RELATED', 240951),
(317046, 'PTHR34614', NULL, NULL, NULL, NULL, '', 240952),
(317047, 'PTHR34614:SF2', NULL, NULL, NULL, NULL, 'TRANSPOSASE', 240952),
(317048, 'PTHR31294:SF8', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 21-1-RELATED', 240953),
(317049, 'PTHR31294', NULL, NULL, NULL, NULL, '', 240953),
(317050, 'PTHR46991:SF29', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN HSP20/ALPHA CRYSTALLIN FAMILY PROTEIN', 240954),
(317051, 'PTHR46991:SF26', NULL, NULL, NULL, NULL, 'BNAA06G35710D PROTEIN', 240954),
(317052, 'PTHR46991:SF21', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 240954),
(317053, 'PTHR46991:SF20', NULL, NULL, NULL, NULL, 'BNAA02G24820D PROTEIN', 240954),
(317054, 'PTHR46991:SF24', NULL, NULL, NULL, NULL, '14.7 KDA HEAT SHOCK PROTEIN', 240954),
(317055, 'PTHR46991:SF23', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 240954),
(317056, 'PTHR46991:SF22', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN HSP20/ALPHA CRYSTALLIN FAMILY', 240954),
(317057, 'PTHR46991:SF4', NULL, NULL, NULL, NULL, '14.7 KDA HEAT SHOCK PROTEIN-LIKE', 240954),
(317058, 'PTHR46991:SF7', NULL, NULL, NULL, NULL, 'HEAT SHOCK 22 KDA PROTEIN, MITOCHONDRIAL-LIKE', 240954),
(317059, 'PTHR46991:SF8', NULL, NULL, NULL, NULL, 'HEAT SHOCK 22 KDA PROTEIN, MITOCHONDRIAL-LIKE', 240954),
(317060, 'PTHR46991:SF9', NULL, NULL, NULL, NULL, '23.6 KDA HEAT SHOCK PROTEIN MITOCHONDRIAL', 240954),
(317061, 'PTHR46991', NULL, NULL, NULL, NULL, '23.5 KDA HEAT SHOCK PROTEIN, MITOCHONDRIAL', 240954),
(317062, 'PTHR46991:SF17', NULL, NULL, NULL, NULL, 'BNAC07G33800D PROTEIN', 240954),
(317063, 'PTHR46991:SF38', NULL, NULL, NULL, NULL, 'BNAA10G12430D PROTEIN', 240954),
(317064, 'PTHR46991:SF37', NULL, NULL, NULL, NULL, '57 KDA HEAT SHOCK PROTEIN-RELATED', 240954),
(317065, 'PTHR46991:SF19', NULL, NULL, NULL, NULL, 'BNAA06G35430D PROTEIN', 240954),
(317066, 'PTHR46991:SF32', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 240954),
(317067, 'PTHR46991:SF10', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN HSP20/ALPHA CRYSTALLIN FAMILY', 240954);
INSERT INTO "PUBLIC"."MODEL" VALUES
(317068, 'PTHR46991:SF31', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 240954),
(317069, 'PTHR46991:SF30', NULL, NULL, NULL, NULL, 'BNAA01G31830D PROTEIN', 240954),
(317070, 'PTHR46991:SF36', NULL, NULL, NULL, NULL, '26.2 KDA HEAT SHOCK PROTEIN, MITOCHONDRIAL', 240954),
(317071, 'PTHR46991:SF14', NULL, NULL, NULL, NULL, 'BNAA02G24850D PROTEIN', 240954),
(317072, 'PTHR46991:SF13', NULL, NULL, NULL, NULL, 'BNAA06G35720D PROTEIN', 240954),
(317073, 'PTHR46991:SF34', NULL, NULL, NULL, NULL, 'BNAC07G33820D PROTEIN', 240954),
(317074, 'PTHR46991:SF11', NULL, NULL, NULL, NULL, 'SMALL HEAT SHOCK PROTEIN HSPF', 240954),
(317075, 'PTHR46991:SF33', NULL, NULL, NULL, NULL, '23.5 KDA HEAT SHOCK PROTEIN, MITOCHONDRIAL', 240954),
(317076, 'PTHR33833:SF4', NULL, NULL, NULL, NULL, 'YCF49-LIKE PROTEIN', 240955),
(317077, 'PTHR33833', NULL, NULL, NULL, NULL, 'NUCLEOLAR-LIKE PROTEIN-RELATED', 240955),
(317078, 'PTHR33833:SF3', NULL, NULL, NULL, NULL, 'YCF49-LIKE PROTEIN', 240955),
(317079, 'PTHR46014:SF3', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 240956),
(317080, 'PTHR46014', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 1', 240956),
(317081, 'PTHR46014:SF1', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 1', 240956),
(317082, 'PTHR47759', NULL, NULL, NULL, NULL, 'OS04G0509100 PROTEIN', 240957),
(317083, 'PTHR47759:SF2', NULL, NULL, NULL, NULL, 'TRIGLYCERIDE LIPASE-RELATED', 240957),
(317084, 'PTHR46337:SF1', NULL, NULL, NULL, NULL, 'RCC1-LIKE G EXCHANGING FACTOR-LIKE PROTEIN', 240958),
(317085, 'PTHR46337', NULL, NULL, NULL, NULL, 'RCC1-LIKE G EXCHANGING FACTOR-LIKE PROTEIN', 240958),
(317086, 'PTHR24209:SF25', NULL, NULL, NULL, NULL, 'PROTEIN DA1-RELATED 1', 240959),
(317087, 'PTHR24209:SF35', NULL, NULL, NULL, NULL, 'PROTEIN DA1-RELATED 6-LIKE', 240959),
(317088, 'PTHR24209:SF27', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR INTERACTOR AND REGULATOR LIM FAMILY-RELATED', 240959),
(317089, 'PTHR24209:SF37', NULL, NULL, NULL, NULL, 'LIM ZINC-BINDING DOMAIN-CONTAINING PROTEIN', 240959),
(317090, 'PTHR24209:SF32', NULL, NULL, NULL, NULL, 'PROTEIN DA1-RELATED 3', 240959),
(317091, 'PTHR24209:SF31', NULL, NULL, NULL, NULL, 'PROTEIN DA1-LIKE ISOFORM X1', 240959),
(317092, 'PTHR24209:SF12', NULL, NULL, NULL, NULL, 'DOMAIN-CONTAINING PROTEIN, PUTATIVE, EXPRESSED-RELATED', 240959),
(317093, 'PTHR24209:SF34', NULL, NULL, NULL, NULL, 'LIM ZINC-BINDING DOMAIN-CONTAINING PROTEIN', 240959),
(317094, 'PTHR24209:SF23', NULL, NULL, NULL, NULL, 'PROTEIN DA1-RELATED 2-LIKE ISOFORM X1', 240959),
(317095, 'PTHR24209:SF11', NULL, NULL, NULL, NULL, 'DOMAIN-CONTAINING PROTEIN, PUTATIVE, EXPRESSED-RELATED', 240959),
(317096, 'PTHR24209', NULL, NULL, NULL, NULL, 'PROTEIN DA1-RELATED 2', 240959),
(317097, 'PTHR24209:SF33', NULL, NULL, NULL, NULL, 'PROTEIN DA1-RELATED 2-LIKE ISOFORM X1', 240959),
(317098, 'PTHR24209:SF29', NULL, NULL, NULL, NULL, 'PROTEIN DA1', 240959),
(317099, 'PTHR24209:SF28', NULL, NULL, NULL, NULL, 'PROTEIN DA1-RELATED 4-RELATED', 240959),
(317100, 'PTHR24209:SF30', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR INTERACTOR AND REGULATOR LIM FAMILY-RELATED', 240959),
(317101, 'PTHR24209:SF7', NULL, NULL, NULL, NULL, 'PROTEIN DA1-RELATED 2', 240959),
(317102, 'PTHR12713:SF32', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT G', 240960),
(317103, 'PTHR12713:SF11', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT G', 240960),
(317104, 'PTHR12713:SF33', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT G', 240960),
(317105, 'PTHR12713:SF22', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT G 2', 240960),
(317106, 'PTHR12713:SF30', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT G', 240960),
(317107, 'PTHR12713:SF31', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT G', 240960),
(317108, 'PTHR12713:SF26', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT G2', 240960),
(317109, 'PTHR12713:SF12', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT G 1', 240960),
(317110, 'PTHR12713:SF34', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT G', 240960);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(317111, 'PTHR12713:SF13', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT G 2', 240960),
(317112, 'PTHR12713:SF29', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT G', 240960),
(317113, 'PTHR12713:SF27', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT G3', 240960),
(317114, 'PTHR12713:SF5', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT G 3', 240960),
(317115, 'PTHR12713', NULL, NULL, NULL, NULL, 'VACUOLAR ATP SYNTHASE SUBUNIT G', 240960),
(317116, 'PTHR31306:SF8', NULL, NULL, NULL, NULL, '', 240961),
(317117, 'PTHR31306', NULL, NULL, NULL, NULL, 'ALPHA-1,6-MANNOSYLTRANSFERASE MNN11-RELATED', 240961),
(317118, 'PTHR31306:SF11', NULL, NULL, NULL, NULL, '', 240961),
(317119, 'PTHR31306:SF3', NULL, NULL, NULL, NULL, 'NUCLEOTID_TRANS DOMAIN-CONTAINING PROTEIN', 240961),
(317120, 'PTHR31306:SF2', NULL, NULL, NULL, NULL, 'ALPHA-1,2-GALACTOSYLTRANSFERASE GMH3-RELATED', 240961),
(317121, 'PTHR31306:SF10', NULL, NULL, NULL, NULL, 'ALPHA-1,6-MANNOSYLTRANSFERASE MNN11-RELATED', 240961),
(317122, 'PTHR31306:SF5', NULL, NULL, NULL, NULL, 'ALPHA-1,6-MANNOSYLTRANSFERASE MNN10-RELATED', 240961),
(317123, 'PTHR31306:SF4', NULL, NULL, NULL, NULL, 'ALPHA-1,2-GALACTOSYLTRANSFERASE', 240961),
(317124, 'PTHR31410:SF1', NULL, NULL, NULL, NULL, 'POST-GPI ATTACHMENT TO PROTEINS FACTOR 4', 240962),
(317125, 'PTHR31410', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 246', 240962),
(317126, 'PTHR38015:SF1', NULL, NULL, NULL, NULL, 'OCTOPINE_DH DOMAIN-CONTAINING PROTEIN', 240963),
(317127, 'PTHR38015', NULL, NULL, NULL, NULL, 'BLR6086 PROTEIN', 240963),
(317128, 'PTHR31713:SF90', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN 60 B', 240964),
(317129, 'PTHR31713:SF91', NULL, NULL, NULL, NULL, 'OS11G0663100 PROTEIN', 240964),
(317130, 'PTHR31713:SF70', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN 60 D', 240964),
(317131, 'PTHR31713:SF92', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN', 240964),
(317132, 'PTHR31713:SF93', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN', 240964),
(317133, 'PTHR31713:SF72', NULL, NULL, NULL, NULL, 'OS08G0360300 PROTEIN', 240964),
(317134, 'PTHR31713:SF94', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN 60 A-LIKE ISOFORM X1', 240964),
(317135, 'PTHR31713:SF73', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN 60 F', 240964),
(317136, 'PTHR31713:SF51', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN 60 E', 240964),
(317137, 'PTHR31713:SF75', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING-LIKE PROTEIN', 240964),
(317138, 'PTHR31713:SF10', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 240964),
(317139, 'PTHR31713:SF54', NULL, NULL, NULL, NULL, 'BNAA06G25110D PROTEIN', 240964),
(317140, 'PTHR31713:SF88', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN', 240964),
(317141, 'PTHR31713:SF67', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN60-RELATED', 240964),
(317142, 'PTHR31713:SF45', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN 60 A-LIKE ISOFORM X1', 240964),
(317143, 'PTHR31713:SF89', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN 60 C', 240964),
(317144, 'PTHR31713:SF68', NULL, NULL, NULL, NULL, 'BNAA02G35270D PROTEIN', 240964),
(317145, 'PTHR31713:SF46', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN 60 A-LIKE ISOFORM X1', 240964),
(317146, 'PTHR31713:SF47', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE, EXPRESSED-RELATED', 240964),
(317147, 'PTHR31713:SF69', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN60-RELATED', 240964),
(317148, 'PTHR31713:SF48', NULL, NULL, NULL, NULL, 'PROTEIN SAR DEFICIENT 1-LIKE', 240964),
(317149, 'PTHR31713:SF80', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 240964),
(317150, 'PTHR31713:SF81', NULL, NULL, NULL, NULL, '', 240964),
(317151, 'PTHR31713:SF82', NULL, NULL, NULL, NULL, '', 240964),
(317152, 'PTHR31713:SF62', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN', 240964),
(317153, 'PTHR31713:SF40', NULL, NULL, NULL, NULL, 'OS02G0562300 PROTEIN', 240964),
(317154, 'PTHR31713:SF84', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE, EXPRESSED-RELATED', 240964);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(317155, 'PTHR31713:SF63', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN60-RELATED', 240964),
(317156, 'PTHR31713:SF41', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN 60 A-LIKE', 240964),
(317157, 'PTHR31713:SF86', NULL, NULL, NULL, NULL, '', 240964),
(317158, 'PTHR31713:SF64', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN60-RELATED', 240964),
(317159, 'PTHR31713:SF42', NULL, NULL, NULL, NULL, 'PROTEIN SAR DEFICIENT 1', 240964),
(317160, 'PTHR31713:SF43', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN 60 G', 240964),
(317161, 'PTHR31713:SF87', NULL, NULL, NULL, NULL, '', 240964),
(317162, 'PTHR31713:SF65', NULL, NULL, NULL, NULL, 'CAM-BINDING PROTEIN 60-LIKE G-RELATED', 240964),
(317163, 'PTHR31713:SF77', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN, REVERSE TRANSCRIPTASE, RNA-DEPENDENT DNA POLYMERASE-RELATED', 240964),
(317164, 'PTHR31713:SF55', NULL, NULL, NULL, NULL, 'OS11G0665000 PROTEIN', 240964),
(317165, 'PTHR31713:SF78', NULL, NULL, NULL, NULL, 'BNAANNG28220D PROTEIN', 240964),
(317166, 'PTHR31713:SF79', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN60-RELATED', 240964),
(317167, 'PTHR31713:SF57', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN 60 D-LIKE', 240964),
(317168, 'PTHR31713:SF14', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN 60 A', 240964),
(317169, 'PTHR31713', NULL, NULL, NULL, NULL, 'OS02G0177800 PROTEIN', 240964),
(317170, 'PTHR31713:SF59', NULL, NULL, NULL, NULL, 'BNAA09G04040D PROTEIN', 240964),
(317171, 'PTHR31713:SF8', NULL, NULL, NULL, NULL, '', 240964),
(317172, 'PTHR31713:SF18', NULL, NULL, NULL, NULL, 'OS02G0177800 PROTEIN', 240964),
(317173, 'PTHR31713:SF7', NULL, NULL, NULL, NULL, 'OS04G0444200 PROTEIN', 240964),
(317174, 'PTHR37553:SF8', NULL, NULL, NULL, NULL, '', 240965),
(317175, 'PTHR37553:SF6', NULL, NULL, NULL, NULL, 'DUF4705 DOMAIN-CONTAINING PROTEIN', 240965),
(317176, 'PTHR37553:SF7', NULL, NULL, NULL, NULL, '', 240965),
(317177, 'PTHR37553:SF10', NULL, NULL, NULL, NULL, '', 240965),
(317178, 'PTHR37553', NULL, NULL, NULL, NULL, '', 240965),
(317179, 'PTHR37553:SF11', NULL, NULL, NULL, NULL, '', 240965),
(317180, 'PTHR11620:SF96', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT C4', 240966),
(317181, 'PTHR11620:SF97', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L23A-RELATED', 240966),
(317182, 'PTHR11620:SF75', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L25/L23-RELATED', 240966),
(317183, 'PTHR11620:SF2', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L23EN DOMAIN-CONTAINING PROTEIN', 240966),
(317184, 'PTHR11620:SF87', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L23EN DOMAIN-CONTAINING PROTEIN', 240966),
(317185, 'PTHR11620:SF76', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L23EN DOMAIN-CONTAINING PROTEIN', 240966),
(317186, 'PTHR11620:SF98', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L23, CHLOROPLASTIC', 240966),
(317187, 'PTHR11620:SF99', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L23A', 240966),
(317188, 'PTHR11620:SF60', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L23A', 240966),
(317189, 'PTHR11620:SF72', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L23A', 240966),
(317190, 'PTHR11620:SF94', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L23A 1', 240966),
(317191, 'PTHR11620:SF95', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L23EN DOMAIN-CONTAINING PROTEIN', 240966),
(317192, 'PTHR11620:SF100', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L23A-1', 240966),
(317193, 'PTHR11620:SF73', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L23A-LIKE', 240966),
(317194, 'PTHR11620:SF62', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L23, CHLOROPLASTIC', 240966),
(317195, 'PTHR11620:SF69', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L23, CHLOROPLASTIC', 240966),
(317196, 'PTHR11620:SF59', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L23, CHLOROPLASTIC', 240966),
(317197, 'PTHR11620:SF80', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L23A', 240966),
(317198, 'PTHR11620', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L23A', 240966),
(317199, 'PTHR11620:SF91', NULL, NULL, NULL, NULL, 'SIMILAR TO 60S RIBOSOMAL PROTEIN L23A', 240966);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(317200, 'PTHR42930:SF3', NULL, NULL, NULL, NULL, 'PHOSPHATE-SPECIFIC TRANSPORT SYSTEM ACCESSORY PROTEIN PHOU', 240967),
(317201, 'PTHR42930:SF5', NULL, NULL, NULL, NULL, 'PHOSPHATE REGULATORY PROTEIN-LIKE PROTEIN', 240967),
(317202, 'PTHR42930', NULL, NULL, NULL, NULL, 'PHOSPHATE-SPECIFIC TRANSPORT SYSTEM ACCESSORY PROTEIN PHOU', 240967),
(317203, 'PTHR42930:SF2', NULL, NULL, NULL, NULL, 'PHOU DOMAIN-CONTAINING PROTEIN', 240967),
(317204, 'PTHR43618:SF3', NULL, NULL, NULL, NULL, '', 240968),
(317205, 'PTHR43618:SF4', NULL, NULL, NULL, NULL, 'SHORT CHAIN DEHYDROGENASE/REDUCTASE FAMILY (AFU_ORTHOLOGUE AFUA_5G12480)', 240968),
(317206, 'PTHR43618:SF1', NULL, NULL, NULL, NULL, 'SHORT CHAIN DEHYDROGENASE/REDUCTASE', 240968),
(317207, 'PTHR43618:SF2', NULL, NULL, NULL, NULL, 'CHAIN DEHYDROGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G06930)-RELATED', 240968),
(317208, 'PTHR43618:SF12', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE, SHORT-CHAIN DEHYDROGENASE/REDUCTASE FAMILY (AFU_ORTHOLOGUE AFUA_1G14540)-RELATED', 240968),
(317209, 'PTHR43618:SF13', NULL, NULL, NULL, NULL, 'CHAIN DEHYDROGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G17650)-RELATED', 240968),
(317210, 'PTHR43618', NULL, NULL, NULL, NULL, '7-ALPHA-HYDROXYSTEROID DEHYDROGENASE', 240968),
(317211, 'PTHR43618:SF16', NULL, NULL, NULL, NULL, 'SHORT CHAIN DEHYDROGENASE/REDUCTASE FAMILY (AFU_ORTHOLOGUE AFUA_7G04540)', 240968),
(317212, 'PTHR43618:SF17', NULL, NULL, NULL, NULL, 'SHORT CHAIN DEHYDROGENASE/REDUCTASE FAMILY (AFU_ORTHOLOGUE AFUA_4G13550)', 240968),
(317213, 'PTHR43618:SF8', NULL, NULL, NULL, NULL, '7ALPHA-HYDROXYSTEROID DEHYDROGENASE', 240968),
(317214, 'PTHR37752', NULL, NULL, NULL, NULL, 'OS02G0610700 PROTEIN', 240969),
(317215, 'PTHR37752:SF2', NULL, NULL, NULL, NULL, 'BNAA03G48950D PROTEIN', 240969),
(317216, 'PTHR37752:SF1', NULL, NULL, NULL, NULL, 'OS02G0610700 PROTEIN', 240969),
(317217, 'PTHR35603', NULL, NULL, NULL, NULL, '', 240970),
(317218, 'PTHR35603:SF1', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE LIPOPROTEIN SLYB', 240970),
(317219, 'PTHR35603:SF2', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE LIPOPROTEIN-RELATED', 240970),
(317220, 'PTHR34157:SF2', NULL, NULL, NULL, NULL, 'TUZIN', 240971),
(317221, 'PTHR34157', NULL, NULL, NULL, NULL, 'TUZIN', 240971),
(317222, 'PTHR21346:SF0', NULL, NULL, NULL, NULL, 'RE45833P', 240972),
(317223, 'PTHR21346', NULL, NULL, NULL, NULL, 'FUN14 DOMAIN CONTAINING', 240972),
(317224, 'PTHR21346:SF4', NULL, NULL, NULL, NULL, '', 240972),
(317225, 'PTHR21346:SF2', NULL, NULL, NULL, NULL, 'FUN14 DOMAIN-CONTAINING PROTEIN 1', 240972),
(317226, 'PTHR21346:SF8', NULL, NULL, NULL, NULL, '', 240972),
(317227, 'PTHR21346:SF5', NULL, NULL, NULL, NULL, 'FUN14 DOMAIN-CONTAINING PROTEIN 2', 240972),
(317228, 'PTHR21346:SF9', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1700034I23 GENE', 240972),
(317229, 'PTHR10844:SF21', NULL, NULL, NULL, NULL, 'CAVEOLIN-1', 240973),
(317230, 'PTHR10844:SF16', NULL, NULL, NULL, NULL, 'CAVEOLIN-3', 240973),
(317231, 'PTHR10844:SF13', NULL, NULL, NULL, NULL, 'CAVEOLIN', 240973),
(317232, 'PTHR10844:SF3', NULL, NULL, NULL, NULL, 'CAVEOLIN-2', 240973),
(317233, 'PTHR10844', NULL, NULL, NULL, NULL, 'CAVEOLIN', 240973),
(317234, 'PTHR10844:SF19', NULL, NULL, NULL, NULL, 'CAVEOLIN-2', 240973),
(317235, 'PTHR10844:SF28', NULL, NULL, NULL, NULL, 'CAVEOLIN', 240973),
(317236, 'PTHR10844:SF18', NULL, NULL, NULL, NULL, 'CAVEOLIN-1', 240973),
(317237, 'PTHR10844:SF29', NULL, NULL, NULL, NULL, 'CAVEOLIN', 240973),
(317238, 'PTHR10844:SF30', NULL, NULL, NULL, NULL, 'CAVEOLIN', 240973),
(317239, 'PTHR19331:SF481', NULL, NULL, NULL, NULL, '', 240974),
(317240, 'PTHR19331:SF470', NULL, NULL, NULL, NULL, 'DMBT1-LIKE PROTEIN-RELATED', 240974),
(317241, 'PTHR19331:SF480', NULL, NULL, NULL, NULL, 'SCAVENGER RECEPTOR CYSTEINE RICH FAMILY MEMBER WITH 4 DOMAINS', 240974),
(317242, 'PTHR19331:SF463', NULL, NULL, NULL, NULL, 'SCAVENGER RECEPTOR CYSTEINE-RICH TYPE 1 PROTEIN M160', 240974),
(317243, 'PTHR19331:SF441', NULL, NULL, NULL, NULL, 'SCAVENGER RECEPTOR CYSTEINE-RICH TYPE 1 PROTEIN M130', 240974),
(317244, 'PTHR19331:SF22', NULL, NULL, NULL, NULL, 'DELETED IN MALIGNANT BRAIN TUMORS 1 PROTEIN', 240974);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(317245, 'PTHR19331:SF440', NULL, NULL, NULL, NULL, 'MACROPHAGE SCAVENGER RECEPTOR TYPES I AND II', 240974),
(317246, 'PTHR19331:SF482', NULL, NULL, NULL, NULL, 'SCAVENGER RECEPTOR CLASS A MEMBER 5', 240974),
(317247, 'PTHR19331:SF471', NULL, NULL, NULL, NULL, 'DELETED IN MALIGNANT BRAIN TUMORS 1 PROTEIN', 240974),
(317248, 'PTHR19331:SF478', NULL, NULL, NULL, NULL, 'DELETED IN MALIGNANT BRAIN TUMORS 1 PROTEIN', 240974),
(317249, 'PTHR19331:SF477', NULL, NULL, NULL, NULL, 'T-CELL DIFFERENTIATION ANTIGEN CD6', 240974),
(317250, 'PTHR19331:SF476', NULL, NULL, NULL, NULL, '', 240974),
(317251, 'PTHR19331:SF465', NULL, NULL, NULL, NULL, 'EGG PEPTIDE SPERACT RECEPTOR', 240974),
(317252, 'PTHR19331:SF475', NULL, NULL, NULL, NULL, 'SRCR DOMAIN-CONTAINING PROTEIN', 240974),
(317253, 'PTHR19331:SF458', NULL, NULL, NULL, NULL, 'SCAVENGER RECEPTOR CYSTEINE-RICH DOMAIN-CONTAINING PROTEIN SCART1', 240974),
(317254, 'PTHR19331:SF468', NULL, NULL, NULL, NULL, 'ANTIGEN WC1.1', 240974),
(317255, 'PTHR19331:SF479', NULL, NULL, NULL, NULL, '', 240974),
(317256, 'PTHR19331', NULL, NULL, NULL, NULL, 'SCAVENGER RECEPTOR DOMAIN-CONTAINING', 240974),
(317257, 'PTHR19331:SF329', NULL, NULL, NULL, NULL, 'SOLUBLE SCAVENGER RECEPTOR CYSTEINE-RICH DOMAIN-CONTAINING PROTEIN SSC5D', 240974),
(317258, 'PTHR19331:SF439', NULL, NULL, NULL, NULL, 'SCAVENGER RECEPTOR CYSTEINE-RICH DOMAIN-CONTAINING GROUP B PROTEIN', 240974),
(317259, 'PTHR45990:SF1', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN REV1', 240975),
(317260, 'PTHR45990', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN REV1', 240975),
(317261, 'PTHR42907', NULL, NULL, NULL, NULL, 'FMN-LINKED OXIDOREDUCTASES SUPERFAMILY PROTEIN', 240976),
(317262, 'PTHR42907:SF5', NULL, NULL, NULL, NULL, 'DUS DOMAIN-CONTAINING PROTEIN', 240976),
(317263, 'PTHR42907:SF6', NULL, NULL, NULL, NULL, 'TRNA-DIHYDROURIDINE SYNTHASE, ALDOLASE-TYPE TIM BARREL-RELATED', 240976),
(317264, 'PTHR42907:SF1', NULL, NULL, NULL, NULL, 'FMN-LINKED OXIDOREDUCTASES SUPERFAMILY PROTEIN', 240976),
(317265, 'PTHR42907:SF3', NULL, NULL, NULL, NULL, 'TRNA-DIHYDROURIDINE SYNTHASE', 240976),
(317266, 'PTHR22754', NULL, NULL, NULL, NULL, 'DISCO-INTERACTING PROTEIN 2  DIP2 -RELATED', 240977),
(317267, 'PTHR22754:SF38', NULL, NULL, NULL, NULL, 'DISCO-INTERACTING PROTEIN 2 HOMOLOG B', 240977),
(317268, 'PTHR22754:SF40', NULL, NULL, NULL, NULL, 'OS01G0636300 PROTEIN', 240977),
(317269, 'PTHR22754:SF42', NULL, NULL, NULL, NULL, 'MEIOTICALLY UP-REGULATED GENE 62 PROTEIN', 240977),
(317270, 'PTHR22754:SF41', NULL, NULL, NULL, NULL, 'AMP-BINDING ENZYME', 240977),
(317271, 'PTHR22754:SF33', NULL, NULL, NULL, NULL, 'DISCO-INTERACTING PROTEIN 2 HOMOLOG C', 240977),
(317272, 'PTHR22754:SF32', NULL, NULL, NULL, NULL, 'DISCO-INTERACTING PROTEIN 2', 240977),
(317273, 'PTHR22754:SF35', NULL, NULL, NULL, NULL, '10A19I.5', 240977),
(317274, 'PTHR22754:SF34', NULL, NULL, NULL, NULL, 'DISCO-INTERACTING PROTEIN 2 HOMOLOG A', 240977),
(317275, 'PTHR46280:SF3', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY F MEMBER 1 HOMOLOG', 240978),
(317276, 'PTHR46280', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY F MEMBER 2-RELATED', 240978),
(317277, 'PTHR46280:SF2', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY F MEMBER 1', 240978),
(317278, 'PTHR46280:SF1', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY F MEMBER 2', 240978),
(317279, 'PTHR11946', NULL, NULL, NULL, NULL, 'VALYL-TRNA SYNTHETASES', 240979),
(317280, 'PTHR11946:SF112', NULL, NULL, NULL, NULL, 'VALYL-TRNA SYNTHETASE', 240979),
(317281, 'PTHR11946:SF113', NULL, NULL, NULL, NULL, 'VALYL-TRNA SYNTHETASE', 240979),
(317282, 'PTHR11946:SF57', NULL, NULL, NULL, NULL, 'VALINE--TRNA LIGASE, MITOCHONDRIAL-RELATED', 240979),
(317283, 'PTHR11946:SF111', NULL, NULL, NULL, NULL, 'VALYL-TRNA SYNTHETASE', 240979),
(317284, 'PTHR11946:SF114', NULL, NULL, NULL, NULL, 'VALINE--TRNA LIGASE, MITOCHONDRIAL', 240979),
(317285, 'PTHR11946:SF115', NULL, NULL, NULL, NULL, 'VALINE--TRNA LIGASE', 240979),
(317286, 'PTHR11946:SF109', NULL, NULL, NULL, NULL, 'VALYL-TRNA SYNTHETASE', 240979);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(317287, 'PTHR11946:SF94', NULL, NULL, NULL, NULL, 'VALYL-TRNA SYNTHETASE', 240979),
(317288, 'PTHR11946:SF93', NULL, NULL, NULL, NULL, 'VALINE--TRNA LIGASE, CHLOROPLASTIC/MITOCHONDRIAL 2', 240979),
(317289, 'PTHR11946:SF71', NULL, NULL, NULL, NULL, 'VALINE--TRNA LIGASE, MITOCHONDRIAL', 240979),
(317290, 'PTHR34681:SF3', NULL, NULL, NULL, NULL, 'BNAC08G10430D PROTEIN', 240980),
(317291, 'PTHR34681:SF1', NULL, NULL, NULL, NULL, 'OS07G0671100 PROTEIN', 240980),
(317292, 'PTHR34681:SF2', NULL, NULL, NULL, NULL, 'UVEAL AUTOANTIGEN WITH COILED-COIL/ANKYRIN', 240980),
(317293, 'PTHR34681', NULL, NULL, NULL, NULL, 'UVEAL AUTOANTIGEN WITH COILED-COIL/ANKYRIN', 240980),
(317294, 'PTHR45710:SF18', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 2 MEMBER E', 240981),
(317295, 'PTHR45710:SF19', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 2 MEMBER D-RELATED', 240981),
(317296, 'PTHR45710:SF25', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 240981),
(317297, 'PTHR45710:SF24', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 240981),
(317298, 'PTHR45710:SF27', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 240981),
(317299, 'PTHR45710:SF26', NULL, NULL, NULL, NULL, 'FI15750P1-RELATED', 240981),
(317300, 'PTHR45710:SF15', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 2 MEMBER B', 240981),
(317301, 'PTHR45710:SF21', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 240981),
(317302, 'PTHR45710:SF20', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 2, MEMBER M', 240981),
(317303, 'PTHR45710:SF23', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 2 MEMBER D', 240981),
(317304, 'PTHR45710:SF22', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 2 MEMBER A', 240981),
(317305, 'PTHR45710', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN 180', 240981),
(317306, 'PTHR45710:SF6', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 240981),
(317307, 'PTHR45710:SF8', NULL, NULL, NULL, NULL, 'EARLY ACTIVATION ANTIGEN CD69', 240981),
(317308, 'PTHR46339', NULL, NULL, NULL, NULL, 'PROTEIN CBG15282-RELATED', 240982),
(317309, 'PTHR46339:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG18270', 240982),
(317310, 'PTHR46339:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG19340', 240982),
(317311, 'PTHR46339:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG16264', 240982),
(317312, 'PTHR46339:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG15282', 240982),
(317313, 'PTHR46339:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG15281', 240982),
(317314, 'PTHR46339:SF5', NULL, NULL, NULL, NULL, '', 240982),
(317315, 'PTHR46339:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG17404', 240982),
(317316, 'PTHR46339:SF12', NULL, NULL, NULL, NULL, 'PROTEIN CBG06945', 240982),
(317317, 'PTHR46339:SF11', NULL, NULL, NULL, NULL, 'PROTEIN CBG21944', 240982),
(317318, 'PTHR46339:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG06944', 240982),
(317319, 'PTHR46339:SF14', NULL, NULL, NULL, NULL, 'BPTI/KUNITZ INHIBITOR DOMAIN-CONTAINING PROTEIN', 240982),
(317320, 'PTHR46339:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG05670', 240982),
(317321, 'PTHR46339:SF10', NULL, NULL, NULL, NULL, 'PROTEIN CBG13502', 240982),
(317322, 'PTHR46339:SF15', NULL, NULL, NULL, NULL, 'PROTEIN CBG00667', 240982),
(317323, 'PTHR43632', NULL, NULL, NULL, NULL, 'PERMEASE COMPONENT OF TUNGSTATE ABC TRANSPORTER', 240983),
(317324, 'PTHR43632:SF1', NULL, NULL, NULL, NULL, 'PERMEASE COMPONENT OF TUNGSTATE ABC TRANSPORTER', 240983),
(317325, 'PTHR33050', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 240984),
(317326, 'PTHR33050:SF7', NULL, NULL, NULL, NULL, 'DNA/RNA POLYMERASES-RELATED', 240984),
(317327, 'PTHR21713:SF28', NULL, NULL, NULL, NULL, 'NAC-A/B DOMAIN-CONTAINING PROTEIN', 240985),
(317328, 'PTHR21713:SF39', NULL, NULL, NULL, NULL, 'NAC-A/B DOMAIN-CONTAINING PROTEIN', 240985),
(317329, 'PTHR21713:SF38', NULL, NULL, NULL, NULL, 'NAC-A/B DOMAIN-CONTAINING PROTEIN', 240985),
(317330, 'PTHR21713:SF25', NULL, NULL, NULL, NULL, 'NASCENT POLYPEPTIDE-ASSOCIATED COMPLEX SUBUNIT ALPHA-LIKE PROTEIN 3', 240985); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(317331, 'PTHR21713:SF36', NULL, NULL, NULL, NULL, 'NASCENT POLYPEPTIDE-ASSOCIATED COMPLEX SUBUNIT ALPHA-LIKE PROTEIN 1', 240985),
(317332, 'PTHR21713:SF35', NULL, NULL, NULL, NULL, 'NASCENT POLYPEPTIDE-ASSOCIATED COMPLEX SUBUNIT ALPHA-LIKE PROTEIN 1 ISOFORM X1', 240985),
(317333, 'PTHR21713:SF24', NULL, NULL, NULL, NULL, 'NASCENT POLYPEPTIDE-ASSOCIATED COMPLEX SUBUNIT ALPHA-LIKE PROTEIN 4-RELATED', 240985),
(317334, 'PTHR21713:SF23', NULL, NULL, NULL, NULL, 'NASCENT POLYPEPTIDE-ASSOCIATED COMPLEX SUBUNIT ALPHA-LIKE PROTEIN-RELATED', 240985),
(317335, 'PTHR21713:SF33', NULL, NULL, NULL, NULL, 'NASCENT POLYPEPTIDE-ASSOCIATED COMPLEX SUBUNIT ALPHA-LIKE PROTEIN 3', 240985),
(317336, 'PTHR21713', NULL, NULL, NULL, NULL, 'NASCENT POLYPEPTIDE ASSOCIATED COMPLEX ALPHA SUBUNIT-RELATED', 240985),
(317337, 'PTHR21713:SF29', NULL, NULL, NULL, NULL, 'NAC-A/B DOMAIN-CONTAINING PROTEIN', 240985),
(317338, 'PTHR21713:SF18', NULL, NULL, NULL, NULL, 'NASCENT POLYPEPTIDE-ASSOCIATED COMPLEX ALPHA SUBUNIT-LIKE PROTEIN', 240985),
(317339, 'PTHR21713:SF3', NULL, NULL, NULL, NULL, 'NASCENT POLYPEPTIDE-ASSOCIATED COMPLEX SUBUNIT ALPHA, MUSCLE-SPECIFIC FORM', 240985),
(317340, 'PTHR21713:SF42', NULL, NULL, NULL, NULL, 'NAC-A/B DOMAIN-CONTAINING PROTEIN', 240985),
(317341, 'PTHR21713:SF41', NULL, NULL, NULL, NULL, 'NASCENT POLYPEPTIDE ASSOCIATED COMPLEX ALPHA CHAIN', 240985),
(317342, 'PTHR21713:SF30', NULL, NULL, NULL, NULL, '', 240985),
(317343, 'PTHR21713:SF4', NULL, NULL, NULL, NULL, 'GH09281P-RELATED', 240985),
(317344, 'PTHR21713:SF40', NULL, NULL, NULL, NULL, 'NAC-A/B DOMAIN-CONTAINING PROTEIN', 240985),
(317345, 'PTHR21713:SF1', NULL, NULL, NULL, NULL, 'NAC-ALPHA DOMAIN-CONTAINING PROTEIN 1', 240985),
(317346, 'PTHR21713:SF2', NULL, NULL, NULL, NULL, 'NASCENT POLYPEPTIDE-ASSOCIATED COMPLEX SUBUNIT ALPHA-2', 240985),
(317347, 'PTHR42982', NULL, NULL, NULL, NULL, 'SEC-INDEPENDENT PROTEIN TRANSLOCASE PROTEIN TATA', 240986),
(317348, 'PTHR42982:SF7', NULL, NULL, NULL, NULL, 'SEC-INDEPENDENT PROTEIN TRANSLOCASE PROTEIN TATA', 240986),
(317349, 'PTHR42982:SF5', NULL, NULL, NULL, NULL, 'SEC-INDEPENDENT PROTEIN TRANSLOCASE PROTEIN TATE', 240986),
(317350, 'PTHR42982:SF1', NULL, NULL, NULL, NULL, 'SEC-INDEPENDENT PROTEIN TRANSLOCASE PROTEIN TATA', 240986),
(317351, 'PTHR28232', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN RXT2', 240987),
(317352, 'PTHR28232:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN RXT2', 240987),
(317353, 'PTHR12952:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 244', 240988),
(317354, 'PTHR12952:SF0', NULL, NULL, NULL, NULL, 'PROTEIN SYS1 HOMOLOG', 240988),
(317355, 'PTHR12952:SF3', NULL, NULL, NULL, NULL, 'PROTEIN SYS1 HOMOLOG', 240988),
(317356, 'PTHR12952:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 244', 240988),
(317357, 'PTHR12952', NULL, NULL, NULL, NULL, 'SYS1', 240988),
(317358, 'PTHR28236:SF1', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN L44, MITOCHONDRIAL', 240989),
(317359, 'PTHR28236', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN L44, MITOCHONDRIAL', 240989),
(317360, 'PTHR48006:SF77', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317361, 'PTHR48006:SF33', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317362, 'PTHR48006:SF32', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317363, 'PTHR48006:SF76', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240990),
(317364, 'PTHR48006:SF35', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 240990),
(317365, 'PTHR48006:SF79', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317366, 'PTHR48006:SF34', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317367, 'PTHR48006:SF78', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317368, 'PTHR48006:SF37', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240990),
(317369, 'PTHR48006:SF36', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(317370, 'PTHR48006:SF39', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240990),
(317371, 'PTHR48006:SF38', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317372, 'PTHR48006:SF71', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317373, 'PTHR48006:SF70', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317374, 'PTHR48006:SF73', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240990),
(317375, 'PTHR48006:SF72', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE RFK1-RELATED', 240990),
(317376, 'PTHR48006', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN DDB_G0281931-RELATED', 240990),
(317377, 'PTHR48006:SF31', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240990),
(317378, 'PTHR48006:SF75', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240990),
(317379, 'PTHR48006:SF30', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317380, 'PTHR48006:SF74', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE FAMILY PROTEIN', 240990),
(317381, 'PTHR48006:SF44', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317382, 'PTHR48006:SF43', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBS1', 240990),
(317383, 'PTHR48006:SF46', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317384, 'PTHR48006:SF45', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317385, 'PTHR48006:SF48', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317386, 'PTHR48006:SF47', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINE RECEPTOR 2-LIKE', 240990),
(317387, 'PTHR48006:SF49', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317388, 'PTHR48006:SF80', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240990),
(317389, 'PTHR48006:SF82', NULL, NULL, NULL, NULL, 'CONCANAVALIN A-LIKE LECTIN/GLUCANASE DOMAIN-CONTAINING PROTEIN-RELATED', 240990),
(317390, 'PTHR48006:SF81', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317391, 'PTHR48006:SF84', NULL, NULL, NULL, NULL, 'REPEAT TRANSMEMBRANE PROTEIN KINASE, PUTATIVE, EXPRESSED-RELATED', 240990),
(317392, 'PTHR48006:SF40', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN CONTAINING BETA_HELIX', 240990),
(317393, 'PTHR48006:SF83', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317394, 'PTHR48006:SF42', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE FAMILY PROTEIN', 240990),
(317395, 'PTHR48006:SF85', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN DDB_G0281931-RELATED', 240990),
(317396, 'PTHR48006:SF41', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317397, 'PTHR48006:SF55', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317398, 'PTHR48006:SF11', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240990),
(317399, 'PTHR48006:SF10', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING RECEPTOR KINASE CAMRLK', 240990),
(317400, 'PTHR48006:SF54', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317401, 'PTHR48006:SF57', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 240990),
(317402, 'PTHR48006:SF56', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317403, 'PTHR48006:SF12', NULL, NULL, NULL, NULL, '', 240990),
(317404, 'PTHR48006:SF15', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240990),
(317405, 'PTHR48006:SF59', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240990),
(317406, 'PTHR48006:SF58', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240990),
(317407, 'PTHR48006:SF14', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240990); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(317408, 'PTHR48006:SF17', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 240990),
(317409, 'PTHR48006:SF5', NULL, NULL, NULL, NULL, 'CONCANAVALIN A-LIKE LECTIN/GLUCANASE DOMAIN-CONTAINING PROTEIN-RELATED', 240990),
(317410, 'PTHR48006:SF8', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE FAMILY PROTEIN-RELATED', 240990),
(317411, 'PTHR48006:SF7', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 240990),
(317412, 'PTHR48006:SF51', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240990),
(317413, 'PTHR48006:SF2', NULL, NULL, NULL, NULL, 'OS05G0305900 PROTEIN', 240990),
(317414, 'PTHR48006:SF50', NULL, NULL, NULL, NULL, 'OS03G0724300 PROTEIN', 240990),
(317415, 'PTHR48006:SF53', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317416, 'PTHR48006:SF52', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317417, 'PTHR48006:SF19', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240990),
(317418, 'PTHR48006:SF66', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317419, 'PTHR48006:SF22', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 240990),
(317420, 'PTHR48006:SF21', NULL, NULL, NULL, NULL, 'OS02G0241100 PROTEIN', 240990),
(317421, 'PTHR48006:SF65', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317422, 'PTHR48006:SF68', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317423, 'PTHR48006:SF67', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317424, 'PTHR48006:SF69', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317425, 'PTHR48006:SF28', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 240990),
(317426, 'PTHR48006:SF60', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317427, 'PTHR48006:SF62', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317428, 'PTHR48006:SF61', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317429, 'PTHR48006:SF64', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317430, 'PTHR48006:SF20', NULL, NULL, NULL, NULL, 'OS08G0276400 PROTEIN', 240990),
(317431, 'PTHR48006:SF63', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 240990),
(317432, 'PTHR48006:SF29', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 240990),
(317433, 'PTHR23069:SF7', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN', 240991),
(317434, 'PTHR23069:SF5', NULL, NULL, NULL, NULL, 'ATPASE FAMILY AAA DOMAIN-CONTAINING PROTEIN 2B', 240991),
(317435, 'PTHR23069:SF4', NULL, NULL, NULL, NULL, 'ATPASE FAMILY AAA DOMAIN-CONTAINING PROTEIN 2', 240991),
(317436, 'PTHR23069:SF0', NULL, NULL, NULL, NULL, 'TAT-BINDING HOMOLOG 7', 240991),
(317437, 'PTHR23069:SF10', NULL, NULL, NULL, NULL, 'ATPASE WITH BROMODOMAIN PROTEIN', 240991),
(317438, 'PTHR23069:SF11', NULL, NULL, NULL, NULL, 'BROMO DOMAIN-CONTAINING PROTEIN', 240991),
(317439, 'PTHR23069', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING', 240991),
(317440, 'PTHR19847:SF22', NULL, NULL, NULL, NULL, 'LEC14B HOMOLOG', 240992),
(317441, 'PTHR19847:SF23', NULL, NULL, NULL, NULL, 'LEC14B HOMOLOG', 240992),
(317442, 'PTHR19847:SF7', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 11', 240992),
(317443, 'PTHR19847:SF25', NULL, NULL, NULL, NULL, 'LEC14B HOMOLOG', 240992),
(317444, 'PTHR19847:SF26', NULL, NULL, NULL, NULL, 'TRANSDUCIN FAMILY PROTEIN / WD-40 REPEAT FAMILY PROTEIN', 240992),
(317445, 'PTHR19847:SF16', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 240992),
(317446, 'PTHR19847', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 11', 240992),
(317447, 'PTHR15590', NULL, NULL, NULL, NULL, 'CX9C MOTIF-CONTAINING PROTEIN 4', 240993);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(317448, 'PTHR15590:SF0', NULL, NULL, NULL, NULL, 'CX9C MOTIF-CONTAINING PROTEIN 4', 240993),
(317449, 'PTHR37228:SF1', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S21 FAMILY PROTEIN', 240994),
(317450, 'PTHR37228', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S21 FAMILY PROTEIN', 240994),
(317451, 'PTHR37228:SF3', NULL, NULL, NULL, NULL, 'BNAA06G32950D PROTEIN', 240994),
(317452, 'PTHR37228:SF4', NULL, NULL, NULL, NULL, '', 240994),
(317453, 'PTHR32075:SF6', NULL, NULL, NULL, NULL, 'ISWI CHROMATIN-REMODELING COMPLEX SUBUNIT YPL216W-RELATED', 240995),
(317454, 'PTHR32075', NULL, NULL, NULL, NULL, 'ISWI CHROMATIN-REMODELING COMPLEX SUBUNIT YPL216W-RELATED', 240995),
(317455, 'PTHR47968:SF61', NULL, NULL, NULL, NULL, 'ATP-BINDING MICROTUBULE MOTOR FAMILY PROTEIN', 240996),
(317456, 'PTHR47968:SF40', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-7H', 240996),
(317457, 'PTHR47968:SF60', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 240996),
(317458, 'PTHR47968:SF18', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-7F', 240996),
(317459, 'PTHR47968:SF19', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 240996),
(317460, 'PTHR47968:SF17', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 240996),
(317461, 'PTHR47968:SF39', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-7B', 240996),
(317462, 'PTHR47968:SF58', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN TEA2', 240996),
(317463, 'PTHR47968:SF36', NULL, NULL, NULL, NULL, 'CENTROMERE-ASSOCIATED PROTEIN E', 240996),
(317464, 'PTHR47968:SF15', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 240996),
(317465, 'PTHR47968:SF37', NULL, NULL, NULL, NULL, 'ATP-BINDING MICROTUBULE MOTOR FAMILY PROTEIN', 240996),
(317466, 'PTHR47968:SF59', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 240996),
(317467, 'PTHR47968:SF34', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 240996),
(317468, 'PTHR47968:SF56', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 240996),
(317469, 'PTHR47968:SF35', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-7D, MITOCHONDRIAL', 240996),
(317470, 'PTHR47968:SF13', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 240996),
(317471, 'PTHR47968:SF57', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 240996),
(317472, 'PTHR47968:SF54', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN NACK2', 240996),
(317473, 'PTHR47968:SF32', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-7J', 240996),
(317474, 'PTHR47968:SF33', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 240996),
(317475, 'PTHR47968:SF11', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN-RELATED', 240996),
(317476, 'PTHR47968:SF55', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-7F', 240996),
(317477, 'PTHR47968:SF30', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 240996),
(317478, 'PTHR47968:SF52', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 240996),
(317479, 'PTHR47968:SF53', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 240996),
(317480, 'PTHR47968', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN E', 240996),
(317481, 'PTHR47968:SF50', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 240996),
(317482, 'PTHR47968:SF8', NULL, NULL, NULL, NULL, 'DUF3490 DOMAIN-CONTAINING PROTEIN', 240996),
(317483, 'PTHR47968:SF51', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-7O', 240996),
(317484, 'PTHR47968:SF9', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 240996),
(317485, 'PTHR47968:SF3', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-7G', 240996),
(317486, 'PTHR47968:SF5', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 240996),
(317487, 'PTHR47968:SF29', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 240996),
(317488, 'PTHR47968:SF49', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 240996),
(317489, 'PTHR47968:SF28', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-7C', 240996),
(317490, 'PTHR47968:SF26', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN NACK2', 240996),
(317491, 'PTHR47968:SF23', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-7A', 240996);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(317492, 'PTHR47968:SF45', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-7H', 240996),
(317493, 'PTHR47968:SF2', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-7E', 240996),
(317494, 'PTHR47968:SF21', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-7I', 240996),
(317495, 'PTHR47968:SF43', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-7J', 240996),
(317496, 'PTHR47968:SF22', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 240996),
(317497, 'PTHR35024:SF5', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 240997),
(317498, 'PTHR35024:SF4', NULL, NULL, NULL, NULL, 'HYPOTHETICAL CYTOSOLIC PROTEIN', 240997),
(317499, 'PTHR35024', NULL, NULL, NULL, NULL, 'HYPOTHETICAL CYTOSOLIC PROTEIN', 240997),
(317500, 'PTHR34261', NULL, NULL, NULL, NULL, 'APC REGULATOR OF WNT-SIGNALING PATHWAY-RELATED', 240998),
(317501, 'PTHR34261:SF1', NULL, NULL, NULL, NULL, 'TUBULIN POLYMERIZATION-PROMOTING PROTEIN', 240998),
(317502, 'PTHR23512:SF7', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 240999),
(317503, 'PTHR23512', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY DOMAIN-CONTAINING PROTEIN 1', 240999),
(317504, 'PTHR23512:SF4', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 240999),
(317505, 'PTHR23512:SF5', NULL, NULL, NULL, NULL, 'IM:7160594', 240999),
(317506, 'PTHR23512:SF2', NULL, NULL, NULL, NULL, '', 240999),
(317507, 'PTHR23512:SF12', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G00260)-RELATED', 240999),
(317508, 'PTHR23512:SF3', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY DOMAIN-CONTAINING PROTEIN 1', 240999),
(317509, 'PTHR23512:SF11', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN', 240999),
(317510, 'PTHR23235:SF109', NULL, NULL, NULL, NULL, 'KRUEPPEL-LIKE FACTOR 2', 241000),
(317511, 'PTHR23235:SF93', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 241000),
(317512, 'PTHR23235:SF50', NULL, NULL, NULL, NULL, 'KRUEPPEL-LIKE FACTOR 6', 241000),
(317513, 'PTHR23235:SF107', NULL, NULL, NULL, NULL, 'KRUEPPEL-LIKE FACTOR 1', 241000),
(317514, 'PTHR23235:SF54', NULL, NULL, NULL, NULL, 'E3 SUMO-PROTEIN LIGASE EGR2', 241000),
(317515, 'PTHR23235:SF56', NULL, NULL, NULL, NULL, 'KRUEPPEL-LIKE FACTOR 12', 241000),
(317516, 'PTHR23235:SF57', NULL, NULL, NULL, NULL, 'KRUPPEL-LIKE FACTOR 3', 241000),
(317517, 'PTHR23235:SF58', NULL, NULL, NULL, NULL, 'EARLY GROWTH RESPONSE PROTEIN 4', 241000),
(317518, 'PTHR23235:SF15', NULL, NULL, NULL, NULL, 'LETHAL SP8', 241000),
(317519, 'PTHR23235:SF59', NULL, NULL, NULL, NULL, 'KRUEPPEL-LIKE FACTOR 14', 241000),
(317520, 'PTHR23235:SF16', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SP1', 241000),
(317521, 'PTHR23235:SF17', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SP4', 241000),
(317522, 'PTHR23235:SF19', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SP7', 241000),
(317523, 'PTHR23235:SF82', NULL, NULL, NULL, NULL, 'KRUEPPEL-LIKE FACTOR 5', 241000),
(317524, 'PTHR23235:SF41', NULL, NULL, NULL, NULL, 'KRUPPEL-LIKE FACTOR 1 (ERYTHROID)-RELATED', 241000),
(317525, 'PTHR23235:SF85', NULL, NULL, NULL, NULL, 'KRUPPEL-LIKE FACTOR 18', 241000),
(317526, 'PTHR23235:SF42', NULL, NULL, NULL, NULL, 'EARLY GROWTH RESPONSE PROTEIN 1', 241000),
(317527, 'PTHR23235:SF44', NULL, NULL, NULL, NULL, 'KRUEPPEL-LIKE FACTOR 15', 241000),
(317528, 'PTHR23235:SF89', NULL, NULL, NULL, NULL, 'CABUT, ISOFORM A-RELATED', 241000),
(317529, 'PTHR23235:SF46', NULL, NULL, NULL, NULL, 'KRUEPPEL-LIKE FACTOR 8', 241000),
(317530, 'PTHR23235:SF48', NULL, NULL, NULL, NULL, 'KRUEPPEL-LIKE FACTOR 3', 241000),
(317531, 'PTHR23235:SF49', NULL, NULL, NULL, NULL, 'WILMS TUMOR PROTEIN', 241000),
(317532, 'PTHR23235', NULL, NULL, NULL, NULL, 'KRUEPPEL-LIKE TRANSCRIPTION FACTOR', 241000),
(317533, 'PTHR23235:SF131', NULL, NULL, NULL, NULL, 'KRUPPEL LIKE FACTOR 9', 241000),
(317534, 'PTHR23235:SF130', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 367', 241000),
(317535, 'PTHR23235:SF135', NULL, NULL, NULL, NULL, 'KRUEPPEL-LIKE FACTOR 14', 241000),
(317536, 'PTHR23235:SF134', NULL, NULL, NULL, NULL, 'KRUPPEL LIKE FACTOR 9', 241000);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(317537, 'PTHR23235:SF133', NULL, NULL, NULL, NULL, 'KRUEPPEL-LIKE FACTOR 1', 241000),
(317538, 'PTHR23235:SF132', NULL, NULL, NULL, NULL, 'KRUEPPEL-LIKE FACTOR 9', 241000),
(317539, 'PTHR23235:SF137', NULL, NULL, NULL, NULL, 'SI:CH211-117K10.3', 241000),
(317540, 'PTHR23235:SF136', NULL, NULL, NULL, NULL, 'KRUPPEL-LIKE FACTOR 15, GENE 2', 241000),
(317541, 'PTHR23235:SF71', NULL, NULL, NULL, NULL, 'KRUEPPEL-LIKE FACTOR 16', 241000),
(317542, 'PTHR23235:SF129', NULL, NULL, NULL, NULL, 'KRUPPEL-LIKE FACTOR 18', 241000),
(317543, 'PTHR23235:SF75', NULL, NULL, NULL, NULL, 'LETHAL (3) NEO38, ISOFORM L', 241000),
(317544, 'PTHR23235:SF77', NULL, NULL, NULL, NULL, 'KRUEPPEL-LIKE FACTOR 7', 241000),
(317545, 'PTHR23235:SF78', NULL, NULL, NULL, NULL, 'EARLY GROWTH RESPONSE PROTEIN 3', 241000),
(317546, 'PTHR23235:SF120', NULL, NULL, NULL, NULL, 'KRUEPPEL-LIKE FACTOR 17', 241000),
(317547, 'PTHR23235:SF124', NULL, NULL, NULL, NULL, 'KRUPPEL-LIKE FACTOR 1-RELATED', 241000),
(317548, 'PTHR23235:SF123', NULL, NULL, NULL, NULL, 'SP5 PROTEIN', 241000),
(317549, 'PTHR23235:SF122', NULL, NULL, NULL, NULL, 'KRUPPEL LIKE FACTOR 4', 241000),
(317550, 'PTHR23235:SF128', NULL, NULL, NULL, NULL, 'KRUPPEL-LIKE FACTOR 8', 241000),
(317551, 'PTHR23235:SF127', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G09820)-RELATED', 241000),
(317552, 'PTHR23235:SF126', NULL, NULL, NULL, NULL, 'FI01014P-RELATED', 241000),
(317553, 'PTHR23235:SF125', NULL, NULL, NULL, NULL, 'WILMS TUMOR PROTEIN HOMOLOG', 241000),
(317554, 'PTHR23235:SF60', NULL, NULL, NULL, NULL, 'STRIPE, ISOFORM D', 241000),
(317555, 'PTHR23235:SF62', NULL, NULL, NULL, NULL, 'KRUPPEL-LIKE FACTOR 2', 241000),
(317556, 'PTHR23235:SF64', NULL, NULL, NULL, NULL, 'KRUEPPEL-LIKE FACTOR 10', 241000),
(317557, 'PTHR23235:SF65', NULL, NULL, NULL, NULL, 'KRUEPPEL-LIKE FACTOR 11', 241000),
(317558, 'PTHR23235:SF21', NULL, NULL, NULL, NULL, 'KRUEPPEL-LIKE FACTOR 13', 241000),
(317559, 'PTHR23235:SF23', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SP6', 241000),
(317560, 'PTHR23235:SF67', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 352', 241000),
(317561, 'PTHR23235:SF25', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SP8', 241000),
(317562, 'PTHR23235:SF26', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SP9', 241000),
(317563, 'PTHR23235:SF28', NULL, NULL, NULL, NULL, 'SP5 TRANSCRIPTION FACTOR-LIKE', 241000),
(317564, 'PTHR23235:SF29', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SP5', 241000),
(317565, 'PTHR23235:SF113', NULL, NULL, NULL, NULL, '', 241000),
(317566, 'PTHR23235:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SP3', 241000),
(317567, 'PTHR23235:SF112', NULL, NULL, NULL, NULL, 'SP3A TRANSCRIPTION FACTOR-RELATED', 241000),
(317568, 'PTHR23235:SF111', NULL, NULL, NULL, NULL, 'ZGC:153115', 241000),
(317569, 'PTHR23235:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SP2', 241000),
(317570, 'PTHR23235:SF110', NULL, NULL, NULL, NULL, '', 241000),
(317571, 'PTHR23235:SF117', NULL, NULL, NULL, NULL, 'KRUEPPEL-LIKE FACTOR 4', 241000),
(317572, 'PTHR23235:SF115', NULL, NULL, NULL, NULL, 'KRUPPEL LIKE FACTOR 7', 241000),
(317573, 'PTHR22662:SF0', NULL, NULL, NULL, NULL, 'TOLL/INTERLEUKIN-1 RECEPTOR DOMAIN-CONTAINING ADAPTER PROTEIN', 241001),
(317574, 'PTHR22662', NULL, NULL, NULL, NULL, 'TIRAP', 241001),
(317575, 'PTHR46387:SF43', NULL, NULL, NULL, NULL, '', 241002),
(317576, 'PTHR46387:SF5', NULL, NULL, NULL, NULL, 'OS08G0481175 PROTEIN', 241002),
(317577, 'PTHR46387:SF10', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 241002),
(317578, 'PTHR46387:SF44', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 241002),
(317579, 'PTHR46387:SF30', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H, BACTERIA-RELATED', 241002),
(317580, 'PTHR46387:SF41', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H', 241002),
(317581, 'PTHR46387:SF20', NULL, NULL, NULL, NULL, 'CAULI_VI DOMAIN-CONTAINING PROTEIN', 241002),
(317582, 'PTHR46387:SF42', NULL, NULL, NULL, NULL, 'RNASE H FAMILY PROTEIN', 241002),
(317583, 'PTHR46387:SF47', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H', 241002); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(317584, 'PTHR46387:SF48', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 241002),
(317585, 'PTHR46387:SF45', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H', 241002),
(317586, 'PTHR46387:SF46', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 241002),
(317587, 'PTHR46387:SF13', NULL, NULL, NULL, NULL, 'OS10G0458700 PROTEIN', 241002),
(317588, 'PTHR46387:SF8', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H-LIKE', 241002),
(317589, 'PTHR46387', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDYL TRANSFERASE, RIBONUCLEASE H-LIKE SUPERFAMILY PROTEIN', 241002),
(317590, 'PTHR46387:SF40', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDYL TRANSFERASE, RIBONUCLEASE H-LIKE SUPERFAMILY PROTEIN', 241002),
(317591, 'PTHR46387:SF2', NULL, NULL, NULL, NULL, 'RIBONUCLEASE HI', 241002),
(317592, 'PTHR46387:SF49', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H', 241002),
(317593, 'PTHR46387:SF39', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H', 241002),
(317594, 'PTHR47055', NULL, NULL, NULL, NULL, 'DDE_TNP_1_7 DOMAIN-CONTAINING PROTEIN', 241003),
(317595, 'PTHR47055:SF2', NULL, NULL, NULL, NULL, 'PIGGYBAC TRANSPOSABLE ELEMENT-DERIVED PROTEIN 2-RELATED', 241003),
(317596, 'PTHR47055:SF3', NULL, NULL, NULL, NULL, 'DDE_TNP_1_7 DOMAIN-CONTAINING PROTEIN', 241003),
(317597, 'PTHR47055:SF1', NULL, NULL, NULL, NULL, 'PIGGYBAC TRANSPOSABLE ELEMENT-DERIVED PROTEIN 1', 241003),
(317598, 'PTHR13389:SF0', NULL, NULL, NULL, NULL, 'PUMILIO HOMOLOG 3', 241004),
(317599, 'PTHR13389', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 241004),
(317600, 'PTHR13389:SF2', NULL, NULL, NULL, NULL, 'PUM-HD DOMAIN-CONTAINING PROTEIN', 241004),
(317601, 'PTHR24269:SF25', NULL, NULL, NULL, NULL, '', 241005),
(317602, 'PTHR24269:SF13', NULL, NULL, NULL, NULL, 'KREMEN PROTEIN 1', 241005),
(317603, 'PTHR24269:SF24', NULL, NULL, NULL, NULL, '', 241005),
(317604, 'PTHR24269:SF23', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE SENSOR TRANSDUCER (EUROFUNG)-RELATED', 241005),
(317605, 'PTHR24269:SF16', NULL, NULL, NULL, NULL, 'PROTEIN SLG1', 241005),
(317606, 'PTHR24269:SF15', NULL, NULL, NULL, NULL, 'KREMEN PROTEIN 2', 241005),
(317607, 'PTHR24269', NULL, NULL, NULL, NULL, 'KREMEN PROTEIN', 241005),
(317608, 'PTHR47355:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SPL2', 241006),
(317609, 'PTHR47355', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SPL2', 241006),
(317610, 'PTHR47355:SF3', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241006),
(317611, 'PTHR38819', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 20A-RELATED', 241007),
(317612, 'PTHR38819:SF1', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 20A-RELATED', 241007),
(317613, 'PTHR44793:SF1', NULL, NULL, NULL, NULL, 'MATRIX REMODELING-ASSOCIATED PROTEIN 8', 241008),
(317614, 'PTHR44793', NULL, NULL, NULL, NULL, 'MATRIX REMODELING-ASSOCIATED PROTEIN 8', 241008),
(317615, 'PTHR46604:SF1', NULL, NULL, NULL, NULL, 'OS11G0665800 PROTEIN', 241009),
(317616, 'PTHR46604', NULL, NULL, NULL, NULL, 'PROTEIN MID1-COMPLEMENTING ACTIVITY 1', 241009),
(317617, 'PTHR46604:SF2', NULL, NULL, NULL, NULL, 'PROTEIN MID1-COMPLEMENTING ACTIVITY 1-LIKE ISOFORM X1', 241009),
(317618, 'PTHR46604:SF16', NULL, NULL, NULL, NULL, 'BNAANNG08310D PROTEIN', 241009),
(317619, 'PTHR46604:SF13', NULL, NULL, NULL, NULL, '', 241009),
(317620, 'PTHR46604:SF12', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241009),
(317621, 'PTHR46604:SF15', NULL, NULL, NULL, NULL, 'PROTEIN MID1-COMPLEMENTING ACTIVITY 2', 241009),
(317622, 'PTHR46604:SF14', NULL, NULL, NULL, NULL, 'MID1-COMPLEMENTING ACTIVITY-LIKE PROTEIN', 241009),
(317623, 'PTHR46604:SF3', NULL, NULL, NULL, NULL, 'PROTEIN MID1-COMPLEMENTING ACTIVITY 1', 241009),
(317624, 'PTHR46604:SF4', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241009),
(317625, 'PTHR46604:SF11', NULL, NULL, NULL, NULL, 'OS11G0670100 PROTEIN', 241009),
(317626, 'PTHR46604:SF10', NULL, NULL, NULL, NULL, 'PROTEIN MID1-COMPLEMENTING ACTIVITY 1-LIKE', 241009),
(317627, 'PTHR47481:SF13', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 241010);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(317628, 'PTHR47481:SF12', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 241010),
(317629, 'PTHR47481:SF11', NULL, NULL, NULL, NULL, 'INTEGRASE CORE DOMAIN CONTAINING PROTEIN', 241010),
(317630, 'PTHR47481:SF10', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H-LIKE DOMAIN, GAG-PRE-INTEGRASE DOMAIN, GAG-POLYPEPTIDE OF LTR COPIA-TYPE-RELATED', 241010),
(317631, 'PTHR47481:SF17', NULL, NULL, NULL, NULL, '', 241010),
(317632, 'PTHR47481:SF16', NULL, NULL, NULL, NULL, 'GAG_PRE-INTEGRS DOMAIN-CONTAINING PROTEIN', 241010),
(317633, 'PTHR47481:SF15', NULL, NULL, NULL, NULL, '', 241010),
(317634, 'PTHR47481:SF14', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 241010),
(317635, 'PTHR47481:SF19', NULL, NULL, NULL, NULL, 'RETROTRAN_GAG_3 DOMAIN-CONTAINING PROTEIN', 241010),
(317636, 'PTHR47481:SF18', NULL, NULL, NULL, NULL, '', 241010),
(317637, 'PTHR47481', NULL, NULL, NULL, NULL, '', 241010),
(317638, 'PTHR47481:SF24', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 241010),
(317639, 'PTHR47481:SF23', NULL, NULL, NULL, NULL, '', 241010),
(317640, 'PTHR47481:SF22', NULL, NULL, NULL, NULL, 'OS01G0873500 PROTEIN', 241010),
(317641, 'PTHR47481:SF21', NULL, NULL, NULL, NULL, 'BASIC-LEUCINE ZIPPER TRANSCRIPTION FACTOR Q-RELATED', 241010),
(317642, 'PTHR47481:SF26', NULL, NULL, NULL, NULL, '', 241010),
(317643, 'PTHR47481:SF25', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 241010),
(317644, 'PTHR47481:SF9', NULL, NULL, NULL, NULL, 'COPIA-LIKE POLYPROTEIN/RETROTRANSPOSON', 241010),
(317645, 'PTHR47481:SF6', NULL, NULL, NULL, NULL, '', 241010),
(317646, 'PTHR47481:SF5', NULL, NULL, NULL, NULL, '', 241010),
(317647, 'PTHR47481:SF8', NULL, NULL, NULL, NULL, 'GAG-POLYPEPTIDE OF LTR COPIA-TYPE-RELATED', 241010),
(317648, 'PTHR47481:SF7', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 241010),
(317649, 'PTHR47481:SF20', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 241010),
(317650, 'PTHR47481:SF2', NULL, NULL, NULL, NULL, '', 241010),
(317651, 'PTHR47481:SF4', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE', 241010),
(317652, 'PTHR47481:SF3', NULL, NULL, NULL, NULL, 'GAG-POLYPEPTIDE OF LTR COPIA-TYPE-RELATED', 241010),
(317653, 'PTHR43036:SF1', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 241011),
(317654, 'PTHR43036:SF2', NULL, NULL, NULL, NULL, 'OS04G0481300 PROTEIN', 241011),
(317655, 'PTHR43036', NULL, NULL, NULL, NULL, 'OSJNBB0011N17.9 PROTEIN', 241011),
(317656, 'PTHR46625', NULL, NULL, NULL, NULL, '72 KDA INOSITOL POLYPHOSPHATE 5-PHOSPHATASE', 241012),
(317657, 'PTHR46625:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL POLYPHOSPHATE 5-PHOSPHATASE TYPE IV', 241012),
(317658, 'PTHR43610', NULL, NULL, NULL, NULL, 'BLL6696 PROTEIN', 241013),
(317659, 'PTHR43610:SF1', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 241013),
(317660, 'PTHR33428:SF14', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', 241014),
(317661, 'PTHR33428:SF15', NULL, NULL, NULL, NULL, 'CHLOROPHYLLASE', 241014),
(317662, 'PTHR33428:SF9', NULL, NULL, NULL, NULL, 'CHLOROPHYLLASE-1', 241014),
(317663, 'PTHR33428:SF10', NULL, NULL, NULL, NULL, 'CHLOROPHYLLASE-1', 241014),
(317664, 'PTHR33428:SF11', NULL, NULL, NULL, NULL, 'CHLOROPHYLLASE-2, CHLOROPLASTIC-LIKE', 241014),
(317665, 'PTHR33428:SF12', NULL, NULL, NULL, NULL, 'CHLOROPHYLLASE 2', 241014),
(317666, 'PTHR33428', NULL, NULL, NULL, NULL, 'CHLOROPHYLLASE-2, CHLOROPLASTIC', 241014),
(317667, 'PTHR33428:SF13', NULL, NULL, NULL, NULL, 'CHLOROPHYLLASE', 241014),
(317668, 'PTHR33428:SF2', NULL, NULL, NULL, NULL, 'CHLOROPHYLLASE-2', 241014),
(317669, 'PTHR31195', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 241015),
(317670, 'PTHR31195:SF2', NULL, NULL, NULL, NULL, 'ZGC:77056', 241015),
(317671, 'PTHR42994:SF2', NULL, NULL, NULL, NULL, 'T, PUTATIVE-RELATED', 241016),
(317672, 'PTHR42994:SF1', NULL, NULL, NULL, NULL, 'PEPTIDASE T', 241016),
(317673, 'PTHR42994', NULL, NULL, NULL, NULL, 'PEPTIDASE T', 241016),
(317674, 'PTHR46802:SF1', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE BAZ1B', 241017);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(317675, 'PTHR46802', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE BAZ1B', 241017),
(317676, 'PTHR33069:SF3', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 241018),
(317677, 'PTHR33069:SF4', NULL, NULL, NULL, NULL, 'CHROMOSOME 10, WHOLE GENOME SHOTGUN SEQUENCE', 241018),
(317678, 'PTHR33069', NULL, NULL, NULL, NULL, 'CHROMOSOME 7, WHOLE GENOME SHOTGUN SEQUENCE-RELATED', 241018),
(317679, 'PTHR18860:SF151', NULL, NULL, NULL, NULL, '14-3-3 PROTEIN EPSILON', 241019),
(317680, 'PTHR18860:SF150', NULL, NULL, NULL, NULL, '14_3_3 DOMAIN-CONTAINING PROTEIN', 241019),
(317681, 'PTHR18860:SF153', NULL, NULL, NULL, NULL, '14_3_3 DOMAIN-CONTAINING PROTEIN', 241019),
(317682, 'PTHR18860:SF152', NULL, NULL, NULL, NULL, '14-3-3-LIKE PROTEIN GF14 OMEGA', 241019),
(317683, 'PTHR18860:SF28', NULL, NULL, NULL, NULL, '14-3-3 PROTEIN BETA/ALPHA', 241019),
(317684, 'PTHR18860:SF69', NULL, NULL, NULL, NULL, '14-3-3-LIKE PROTEIN GF14 LAMBDA', 241019),
(317685, 'PTHR18860:SF22', NULL, NULL, NULL, NULL, '14-3-3 PROTEIN GAMMA', 241019),
(317686, 'PTHR18860:SF67', NULL, NULL, NULL, NULL, '14-3-3 PROTEIN EPSILON', 241019),
(317687, 'PTHR18860:SF21', NULL, NULL, NULL, NULL, '14-3-3-LIKE PROTEIN 1-RELATED', 241019),
(317688, 'PTHR18860:SF65', NULL, NULL, NULL, NULL, '14_3_3 DOMAIN-CONTAINING PROTEIN', 241019),
(317689, 'PTHR18860:SF107', NULL, NULL, NULL, NULL, '14_3_3 DOMAIN-CONTAINING PROTEIN', 241019),
(317690, 'PTHR18860:SF104', NULL, NULL, NULL, NULL, '14_3_3 DOMAIN-CONTAINING PROTEIN', 241019),
(317691, 'PTHR18860:SF148', NULL, NULL, NULL, NULL, '14_3_3 DOMAIN-CONTAINING PROTEIN', 241019),
(317692, 'PTHR18860:SF103', NULL, NULL, NULL, NULL, '14-3-3-LIKE PROTEIN GF14-F', 241019),
(317693, 'PTHR18860:SF147', NULL, NULL, NULL, NULL, '14_3_3 DOMAIN-CONTAINING PROTEIN', 241019),
(317694, 'PTHR18860:SF106', NULL, NULL, NULL, NULL, '14-3-3-LIKE PROTEIN GF14 MU', 241019),
(317695, 'PTHR18860:SF149', NULL, NULL, NULL, NULL, 'CHECKPOINT SIGNAL TRANSDUCER RAD25', 241019),
(317696, 'PTHR18860:SF105', NULL, NULL, NULL, NULL, '14_3_3 DOMAIN-CONTAINING PROTEIN', 241019),
(317697, 'PTHR18860:SF100', NULL, NULL, NULL, NULL, '14-3-3 PROTEIN 10', 241019),
(317698, 'PTHR18860:SF146', NULL, NULL, NULL, NULL, '14-3-3-LIKE PROTEIN D', 241019),
(317699, 'PTHR18860:SF102', NULL, NULL, NULL, NULL, '14_3_3 DOMAIN-CONTAINING PROTEIN', 241019),
(317700, 'PTHR18860:SF145', NULL, NULL, NULL, NULL, '14-3-3-LIKE PROTEIN GF14 KAPPA', 241019),
(317701, 'PTHR18860:SF140', NULL, NULL, NULL, NULL, 'PROTEIN BMH1-RELATED', 241019),
(317702, 'PTHR18860:SF142', NULL, NULL, NULL, NULL, '14-3-3-LIKE PROTEIN GF14-B', 241019),
(317703, 'PTHR18860:SF141', NULL, NULL, NULL, NULL, '14-3-3-LIKE PROTEIN GF14-A', 241019),
(317704, 'PTHR18860:SF39', NULL, NULL, NULL, NULL, '14-3-3 PROTEIN (EUROFUNG)', 241019),
(317705, 'PTHR18860:SF78', NULL, NULL, NULL, NULL, '14_3_3 DOMAIN-CONTAINING PROTEIN', 241019),
(317706, 'PTHR18860:SF31', NULL, NULL, NULL, NULL, '14-3-3-LIKE PROTEIN GF14 OMICRON', 241019),
(317707, 'PTHR18860:SF137', NULL, NULL, NULL, NULL, '14-3-3-LIKE PROTEIN C', 241019),
(317708, 'PTHR18860:SF139', NULL, NULL, NULL, NULL, '14-3-3-LIKE PROTEIN GF14 IOTA', 241019),
(317709, 'PTHR18860:SF133', NULL, NULL, NULL, NULL, '14-3-3 PROTEIN 9', 241019),
(317710, 'PTHR18860:SF134', NULL, NULL, NULL, NULL, '14-3-3-LIKE PROTEIN GF14-D', 241019),
(317711, 'PTHR18860:SF131', NULL, NULL, NULL, NULL, '14_3_3 DOMAIN-CONTAINING PROTEIN', 241019),
(317712, 'PTHR18860:SF88', NULL, NULL, NULL, NULL, '14_3_3 DOMAIN-CONTAINING PROTEIN', 241019),
(317713, 'PTHR18860:SF89', NULL, NULL, NULL, NULL, '14-3-3-LIKE PROTEIN', 241019),
(317714, 'PTHR18860:SF86', NULL, NULL, NULL, NULL, 'GENERAL REGULATORY FACTOR 2', 241019),
(317715, 'PTHR18860:SF3', NULL, NULL, NULL, NULL, '14-3-3 PROTEIN THETA', 241019),
(317716, 'PTHR18860:SF84', NULL, NULL, NULL, NULL, '14_3_3 DOMAIN-CONTAINING PROTEIN', 241019),
(317717, 'PTHR18860:SF85', NULL, NULL, NULL, NULL, 'GENERAL REGULATORY FACTOR 13', 241019),
(317718, 'PTHR18860:SF129', NULL, NULL, NULL, NULL, '14_3_3 DOMAIN-CONTAINING PROTEIN', 241019);
INSERT INTO "PUBLIC"."MODEL" VALUES
(317719, 'PTHR18860:SF7', NULL, NULL, NULL, NULL, '14-3-3 PROTEIN ZETA/DELTA', 241019),
(317720, 'PTHR18860:SF80', NULL, NULL, NULL, NULL, '14-3-3-LIKE PROTEIN', 241019),
(317721, 'PTHR18860:SF126', NULL, NULL, NULL, NULL, '14_3_3 DOMAIN-CONTAINING PROTEIN', 241019),
(317722, 'PTHR18860:SF127', NULL, NULL, NULL, NULL, '14-3-3 DOMAIN-CONTAINING PROTEIN-RELATED', 241019),
(317723, 'PTHR18860', NULL, NULL, NULL, NULL, '14-3-3 PROTEIN', 241019),
(317724, 'PTHR18860:SF124', NULL, NULL, NULL, NULL, '14-3-3 PROTEIN 6', 241019),
(317725, 'PTHR18860:SF120', NULL, NULL, NULL, NULL, '14_3_3 DOMAIN-CONTAINING PROTEIN', 241019),
(317726, 'PTHR18860:SF17', NULL, NULL, NULL, NULL, '14-3-3 PROTEIN ZETA', 241019),
(317727, 'PTHR18860:SF16', NULL, NULL, NULL, NULL, '14-3-3 PROTEIN ETA', 241019),
(317728, 'PTHR18860:SF14', NULL, NULL, NULL, NULL, '14-3-3 PROTEIN SIGMA', 241019),
(317729, 'PTHR18860:SF99', NULL, NULL, NULL, NULL, '14-3-3-LIKE PROTEIN GF14 CHI-RELATED', 241019),
(317730, 'PTHR18860:SF97', NULL, NULL, NULL, NULL, '14-3-3-LIKE PROTEIN B', 241019),
(317731, 'PTHR18860:SF95', NULL, NULL, NULL, NULL, '14-3-3-LIKE PROTEIN GF14 PSI', 241019),
(317732, 'PTHR18860:SF96', NULL, NULL, NULL, NULL, '14_3_3 DOMAIN-CONTAINING PROTEIN', 241019),
(317733, 'PTHR18860:SF119', NULL, NULL, NULL, NULL, '14_3_3 DOMAIN-CONTAINING PROTEIN', 241019),
(317734, 'PTHR18860:SF118', NULL, NULL, NULL, NULL, '14_3_3 DOMAIN-CONTAINING PROTEIN', 241019),
(317735, 'PTHR18860:SF114', NULL, NULL, NULL, NULL, '14-3-3 PROTEIN 5', 241019),
(317736, 'PTHR18860:SF155', NULL, NULL, NULL, NULL, '14-3-3 FAMILY PROTEIN-RELATED', 241019),
(317737, 'PTHR18860:SF154', NULL, NULL, NULL, NULL, 'TYROSINE 3-MONOOXYGENASE/TRYPTOPHAN 5-MONOOXYGENASE ACTIVATION PROTEIN, BETA POLYPEPTIDE-LIKE-RELATED', 241019),
(317738, 'PTHR18860:SF110', NULL, NULL, NULL, NULL, '14_3_3 DOMAIN-CONTAINING PROTEIN', 241019),
(317739, 'PTHR18860:SF157', NULL, NULL, NULL, NULL, '14-3-3-LIKE PROTEIN-RELATED', 241019),
(317740, 'PTHR18860:SF113', NULL, NULL, NULL, NULL, '14-3-3 DOMAIN-CONTAINING PROTEIN-RELATED', 241019),
(317741, 'PTHR18860:SF156', NULL, NULL, NULL, NULL, '14-3-3 PROTEIN 8', 241019),
(317742, 'PTHR37185', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN', 241020),
(317743, 'PTHR37185:SF3', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN', 241020),
(317744, 'PTHR37185:SF4', NULL, NULL, NULL, NULL, '', 241020),
(317745, 'PTHR33843', NULL, NULL, NULL, NULL, 'ASCORBATE-SPECIFIC PTS SYSTEM EIIC COMPONENT', 241021),
(317746, 'PTHR33843:SF4', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', 241021),
(317747, 'PTHR33843:SF5', NULL, NULL, NULL, NULL, 'ASCORBATE-SPECIFIC PTS SYSTEM EIIC COMPONENT', 241021),
(317748, 'PTHR11034:SF18', NULL, NULL, NULL, NULL, 'PROTEIN NDRG1', 241022),
(317749, 'PTHR11034:SF17', NULL, NULL, NULL, NULL, 'PROTEIN NDRG2', 241022),
(317750, 'PTHR11034:SF52', NULL, NULL, NULL, NULL, '', 241022),
(317751, 'PTHR11034:SF40', NULL, NULL, NULL, NULL, 'BCDNA.GH02439', 241022),
(317752, 'PTHR11034:SF50', NULL, NULL, NULL, NULL, 'NDRG, ALPHA/BETA HYDROLASE FOLD PROTEIN-RELATED', 241022),
(317753, 'PTHR11034:SF61', NULL, NULL, NULL, NULL, 'POLLEN-SPECIFIC PROTEIN SF21-LIKE ISOFORM X1', 241022),
(317754, 'PTHR11034:SF60', NULL, NULL, NULL, NULL, '', 241022),
(317755, 'PTHR11034:SF49', NULL, NULL, NULL, NULL, 'BNAA10G10880D PROTEIN', 241022),
(317756, 'PTHR11034:SF48', NULL, NULL, NULL, NULL, 'OS02G0224800 PROTEIN', 241022),
(317757, 'PTHR11034:SF59', NULL, NULL, NULL, NULL, 'PROTEIN NDRG2', 241022),
(317758, 'PTHR11034:SF57', NULL, NULL, NULL, NULL, 'POLLEN-SPECIFIC PROTEIN SF21-LIKE ISOFORM X1', 241022),
(317759, 'PTHR11034:SF56', NULL, NULL, NULL, NULL, 'GH09802P', 241022),
(317760, 'PTHR11034:SF55', NULL, NULL, NULL, NULL, 'PROTEIN NDL3', 241022),
(317761, 'PTHR11034:SF43', NULL, NULL, NULL, NULL, 'OS05G0196200 PROTEIN', 241022),
(317762, 'PTHR11034:SF21', NULL, NULL, NULL, NULL, 'PROTEIN NDRG4', 241022),
(317763, 'PTHR11034:SF54', NULL, NULL, NULL, NULL, 'PROTEIN NDL2', 241022),
(317764, 'PTHR11034:SF20', NULL, NULL, NULL, NULL, 'PROTEIN NDRG3', 241022);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(317765, 'PTHR11034', NULL, NULL, NULL, NULL, 'N-MYC DOWNSTREAM REGULATED', 241022),
(317766, 'PTHR11034:SF42', NULL, NULL, NULL, NULL, 'OS06G0563000 PROTEIN', 241022),
(317767, 'PTHR11034:SF53', NULL, NULL, NULL, NULL, 'NDRG, ALPHA/BETA HYDROLASE FOLD PROTEIN-RELATED', 241022),
(317768, 'PTHR37996', NULL, NULL, NULL, NULL, 'B- AND T-LYMPHOCYTE ATTENUATOR', 241023),
(317769, 'PTHR37996:SF1', NULL, NULL, NULL, NULL, 'B- AND T-LYMPHOCYTE ATTENUATOR', 241023),
(317770, 'PTHR32337', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 7', 241024),
(317771, 'PTHR32337:SF2', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 7', 241024),
(317772, 'PTHR13561:SF20', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE 2-BINDING PROTEIN 1', 241025),
(317773, 'PTHR13561:SF21', NULL, NULL, NULL, NULL, 'BRCT DOMAIN-CONTAINING PROTEIN', 241025),
(317774, 'PTHR13561', NULL, NULL, NULL, NULL, 'DNA REPLICATION REGULATOR DPB11-RELATED', 241025),
(317775, 'PTHR37197', NULL, NULL, NULL, NULL, 'F19K23.17 PROTEIN', 241026),
(317776, 'PTHR37197:SF2', NULL, NULL, NULL, NULL, 'F19K23.17 PROTEIN', 241026),
(317777, 'PTHR37259:SF3', NULL, NULL, NULL, NULL, 'BNAC09G38370D PROTEIN', 241027),
(317778, 'PTHR37259:SF4', NULL, NULL, NULL, NULL, 'BNAA02G04150D PROTEIN', 241027),
(317779, 'PTHR37259:SF2', NULL, NULL, NULL, NULL, 'OS07G0474300 PROTEIN', 241027),
(317780, 'PTHR37259', NULL, NULL, NULL, NULL, 'OS07G0474300 PROTEIN', 241027),
(317781, 'PTHR33946:SF4', NULL, NULL, NULL, NULL, 'COAGULATION FACTOR XI', 241028),
(317782, 'PTHR33946', NULL, NULL, NULL, NULL, '', 241028),
(317783, 'PTHR37246', NULL, NULL, NULL, NULL, 'OS07G0658000 PROTEIN', 241029),
(317784, 'PTHR37246:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A2 FAMILY PROTEIN', 241029),
(317785, 'PTHR35610:SF3', NULL, NULL, NULL, NULL, '', 241030),
(317786, 'PTHR35610:SF1', NULL, NULL, NULL, NULL, '3-ISOPROPYLMALATE DEHYDRATASE', 241030),
(317787, 'PTHR35610:SF7', NULL, NULL, NULL, NULL, '3-ISOPROPYLMALATE DEHYDRATASE', 241030),
(317788, 'PTHR35610', NULL, NULL, NULL, NULL, '3-ISOPROPYLMALATE DEHYDRATASE-RELATED', 241030),
(317789, 'PTHR31476:SF5', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE FAMILY PROTEIN', 241031),
(317790, 'PTHR31476:SF4', NULL, NULL, NULL, NULL, 'PROTEIN WHAT''S THIS FACTOR 1 HOMOLOG, CHLOROPLASTIC', 241031),
(317791, 'PTHR31476:SF3', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE FAMILY PROTEIN', 241031),
(317792, 'PTHR31476:SF2', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE FAMILY PROTEIN', 241031),
(317793, 'PTHR31476:SF9', NULL, NULL, NULL, NULL, 'PROTEIN ROOT PRIMORDIUM DEFECTIVE 1', 241031),
(317794, 'PTHR31476:SF8', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241031),
(317795, 'PTHR31476:SF6', NULL, NULL, NULL, NULL, 'EMB|CAB68190.1', 241031),
(317796, 'PTHR31476:SF10', NULL, NULL, NULL, NULL, 'OS04G0546100 PROTEIN', 241031),
(317797, 'PTHR31476:SF20', NULL, NULL, NULL, NULL, 'PORR DOMAIN-CONTAINING PROTEIN', 241031),
(317798, 'PTHR31476:SF12', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE FAMILY PROTEIN', 241031),
(317799, 'PTHR31476:SF11', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE FAMILY PROTEIN', 241031),
(317800, 'PTHR31476:SF14', NULL, NULL, NULL, NULL, 'OS09G0473400 PROTEIN', 241031),
(317801, 'PTHR31476:SF13', NULL, NULL, NULL, NULL, 'PROTEIN WHAT''S THIS FACTOR 9, MITOCHONDRIAL', 241031),
(317802, 'PTHR31476:SF16', NULL, NULL, NULL, NULL, 'F14O23.23 PROTEIN', 241031),
(317803, 'PTHR31476:SF15', NULL, NULL, NULL, NULL, 'ASSOCIATED SALT-INDUCIBLE PROTEIN, PUTATIVE-RELATED', 241031),
(317804, 'PTHR31476', NULL, NULL, NULL, NULL, 'PROTEIN WHAT''S THIS FACTOR 1 HOMOLOG, CHLOROPLASTIC', 241031),
(317805, 'PTHR31476:SF19', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE FAMILY PROTEIN', 241031),
(317806, 'PTHR48289:SF1', NULL, NULL, NULL, NULL, 'DDE TNP4 DOMAIN-CONTAINING PROTEIN', 241032),
(317807, 'PTHR48289', NULL, NULL, NULL, NULL, 'DDE TNP4 DOMAIN-CONTAINING PROTEIN', 241032),
(317808, 'PTHR24226:SF3', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 146-RELATED', 241033); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(317809, 'PTHR24226:SF4', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 241033),
(317810, 'PTHR24226:SF2', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED ESTROGEN RECEPTOR 1', 241033),
(317811, 'PTHR24226:SF0', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 182', 241033),
(317812, 'PTHR24226', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 182 AND ESTROGEN RECEPTOR 1', 241033),
(317813, 'PTHR28564', NULL, NULL, NULL, NULL, 'STANNIN', 241034),
(317814, 'PTHR28564:SF1', NULL, NULL, NULL, NULL, 'STANNIN', 241034),
(317815, 'PTHR30602:SF12', NULL, NULL, NULL, NULL, 'AMINO-ACID ACETYLTRANSFERASE NAGS1, CHLOROPLASTIC-RELATED', 241035),
(317816, 'PTHR30602:SF13', NULL, NULL, NULL, NULL, 'AMINO-ACID N-ACETYLTRANSFERASE', 241035),
(317817, 'PTHR30602:SF14', NULL, NULL, NULL, NULL, 'AMINO-ACID N-ACETYLTRANSFERASE', 241035),
(317818, 'PTHR30602', NULL, NULL, NULL, NULL, 'AMINO-ACID ACETYLTRANSFERASE', 241035),
(317819, 'PTHR30602:SF9', NULL, NULL, NULL, NULL, 'AMINO-ACID N-ACETYLTRANSFERASE', 241035),
(317820, 'PTHR37334:SF1', NULL, NULL, NULL, NULL, 'RGD1561796', 241036),
(317821, 'PTHR37334', NULL, NULL, NULL, NULL, 'RGD1561796', 241036),
(317822, 'PTHR24296:SF217', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 SUPERFAMILY PROTEIN', 241037),
(317823, 'PTHR24296:SF218', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN, EXPRESSED', 241037),
(317824, 'PTHR24296:SF216', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 94A2-LIKE', 241037),
(317825, 'PTHR24296:SF219', NULL, NULL, NULL, NULL, 'BNAA03G56840D PROTEIN', 241037),
(317826, 'PTHR24296:SF176', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 94A2-LIKE', 241037),
(317827, 'PTHR24296:SF210', NULL, NULL, NULL, NULL, 'CYTOCHROME P450-RELATED', 241037),
(317828, 'PTHR24296:SF28', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 96 SUBFAMILY A POLYPEPTIDE 1', 241037),
(317829, 'PTHR24296:SF213', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 PROTEIN-RELATED', 241037),
(317830, 'PTHR24296:SF26', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 86A1', 241037),
(317831, 'PTHR24296:SF214', NULL, NULL, NULL, NULL, 'BNAC08G09240D PROTEIN', 241037),
(317832, 'PTHR24296:SF178', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 241037),
(317833, 'PTHR24296:SF211', NULL, NULL, NULL, NULL, 'P450, PUTATIVE-RELATED', 241037),
(317834, 'PTHR24296:SF179', NULL, NULL, NULL, NULL, 'BNAA03G12650D PROTEIN', 241037),
(317835, 'PTHR24296:SF212', NULL, NULL, NULL, NULL, 'BNAC06G16010D PROTEIN', 241037),
(317836, 'PTHR24296:SF180', NULL, NULL, NULL, NULL, 'BNAA09G15130D PROTEIN', 241037),
(317837, 'PTHR24296:SF184', NULL, NULL, NULL, NULL, 'BNAA06G40600D PROTEIN', 241037),
(317838, 'PTHR24296:SF182', NULL, NULL, NULL, NULL, 'BNACNNG08760D PROTEIN', 241037),
(317839, 'PTHR24296:SF206', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 241037),
(317840, 'PTHR24296:SF207', NULL, NULL, NULL, NULL, 'BNAC02G24420D PROTEIN', 241037),
(317841, 'PTHR24296:SF204', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 94, SUBFAMILY B, POLYPEPTIDE 2', 241037),
(317842, 'PTHR24296:SF205', NULL, NULL, NULL, NULL, 'CYTOCHROME P450-RELATED', 241037),
(317843, 'PTHR24296:SF208', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 94C1', 241037),
(317844, 'PTHR24296:SF166', NULL, NULL, NULL, NULL, '', 241037),
(317845, 'PTHR24296:SF19', NULL, NULL, NULL, NULL, 'OS04G0573900 PROTEIN', 241037),
(317846, 'PTHR24296:SF163', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 704, SUBFAMILY A, POLYPEPTIDE 1', 241037),
(317847, 'PTHR24296:SF17', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 96 SUBFAMILY A POLYPEPTIDE 1', 241037),
(317848, 'PTHR24296:SF164', NULL, NULL, NULL, NULL, '', 241037),
(317849, 'PTHR24296:SF202', NULL, NULL, NULL, NULL, 'BNAA09G15100D PROTEIN', 241037),
(317850, 'PTHR24296:SF203', NULL, NULL, NULL, NULL, 'BNAC09G15720D PROTEIN', 241037),
(317851, 'PTHR24296:SF200', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 MONOOXYGENASE', 241037),
(317852, 'PTHR24296:SF168', NULL, NULL, NULL, NULL, 'BNAC03G76440D PROTEIN', 241037),
(317853, 'PTHR24296:SF97', NULL, NULL, NULL, NULL, 'OS01G0951500 PROTEIN', 241037);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(317854, 'PTHR24296', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 241037),
(317855, 'PTHR24296:SF96', NULL, NULL, NULL, NULL, 'BNAA06G40570D PROTEIN', 241037),
(317856, 'PTHR24296:SF8', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 704B1', 241037),
(317857, 'PTHR24296:SF95', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 241037),
(317858, 'PTHR24296:SF94', NULL, NULL, NULL, NULL, '', 241037),
(317859, 'PTHR24296:SF170', NULL, NULL, NULL, NULL, 'BNAA06G38770D PROTEIN', 241037),
(317860, 'PTHR24296:SF93', NULL, NULL, NULL, NULL, 'ALKANE HYDROXYLASE MAH1-LIKE', 241037),
(317861, 'PTHR24296:SF171', NULL, NULL, NULL, NULL, 'BNAANNG14430D PROTEIN', 241037),
(317862, 'PTHR24296:SF5', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 94B3', 241037),
(317863, 'PTHR24296:SF92', NULL, NULL, NULL, NULL, 'BNAC05G09030D PROTEIN', 241037),
(317864, 'PTHR24296:SF91', NULL, NULL, NULL, NULL, '', 241037),
(317865, 'PTHR24296:SF3', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 86B1', 241037),
(317866, 'PTHR24296:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 94 PROTEIN', 241037),
(317867, 'PTHR24296:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 96, SUBFAMILY A, POLYPEPTIDE 10', 241037),
(317868, 'PTHR24296:SF155', NULL, NULL, NULL, NULL, '', 241037),
(317869, 'PTHR24296:SF158', NULL, NULL, NULL, NULL, '', 241037),
(317870, 'PTHR24296:SF157', NULL, NULL, NULL, NULL, '', 241037),
(317871, 'PTHR24296:SF89', NULL, NULL, NULL, NULL, '', 241037),
(317872, 'PTHR24296:SF88', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 704 SUBFAMILY A POLYPEPTIDE 2', 241037),
(317873, 'PTHR24296:SF87', NULL, NULL, NULL, NULL, '', 241037),
(317874, 'PTHR24296:SF85', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 241037),
(317875, 'PTHR24296:SF161', NULL, NULL, NULL, NULL, '', 241037),
(317876, 'PTHR24296:SF162', NULL, NULL, NULL, NULL, '', 241037),
(317877, 'PTHR24296:SF84', NULL, NULL, NULL, NULL, '', 241037),
(317878, 'PTHR24296:SF83', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 86, SUBFAMILY C, POLYPEPTIDE 4', 241037),
(317879, 'PTHR24296:SF81', NULL, NULL, NULL, NULL, 'OS05G0382500 PROTEIN', 241037),
(317880, 'PTHR24296:SF149', NULL, NULL, NULL, NULL, '', 241037),
(317881, 'PTHR24296:SF143', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 96, SUBFAMILY A, POLYPEPTIDE 5', 241037),
(317882, 'PTHR24296:SF144', NULL, NULL, NULL, NULL, '', 241037),
(317883, 'PTHR24296:SF141', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 94C1-LIKE', 241037),
(317884, 'PTHR24296:SF262', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 704C1-LIKE', 241037),
(317885, 'PTHR24296:SF263', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 94C1-LIKE', 241037),
(317886, 'PTHR24296:SF142', NULL, NULL, NULL, NULL, '', 241037),
(317887, 'PTHR24296:SF147', NULL, NULL, NULL, NULL, 'ALKANE HYDROXYLASE MAH1', 241037),
(317888, 'PTHR24296:SF148', NULL, NULL, NULL, NULL, '', 241037),
(317889, 'PTHR24296:SF146', NULL, NULL, NULL, NULL, 'ALKANE HYDROXYLASE MAH1-LIKE', 241037),
(317890, 'PTHR24296:SF78', NULL, NULL, NULL, NULL, 'OS02G0666500 PROTEIN', 241037),
(317891, 'PTHR24296:SF76', NULL, NULL, NULL, NULL, 'OS01G0183600 PROTEIN', 241037),
(317892, 'PTHR24296:SF150', NULL, NULL, NULL, NULL, 'OS01G0858350 PROTEIN', 241037),
(317893, 'PTHR24296:SF259', NULL, NULL, NULL, NULL, '', 241037),
(317894, 'PTHR24296:SF139', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 86A4', 241037),
(317895, 'PTHR24296:SF253', NULL, NULL, NULL, NULL, 'ALKANE HYDROXYLASE MAH1-LIKE', 241037),
(317896, 'PTHR24296:SF254', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 241037),
(317897, 'PTHR24296:SF251', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY-DEPENDENT FATTY ACID HYDROXYLASE', 241037),
(317898, 'PTHR24296:SF252', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN, EXPRESSED', 241037),
(317899, 'PTHR24296:SF131', NULL, NULL, NULL, NULL, 'OS12G0134900 PROTEIN', 241037),
(317900, 'PTHR24296:SF136', NULL, NULL, NULL, NULL, 'ALKANE HYDROXYLASE MAH1-LIKE', 241037),
(317901, 'PTHR24296:SF257', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN, EXPRESSED', 241037),
(317902, 'PTHR24296:SF258', NULL, NULL, NULL, NULL, 'CYTOCHROME P450-RELATED', 241037);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(317903, 'PTHR24296:SF255', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE-RELATED', 241037),
(317904, 'PTHR24296:SF256', NULL, NULL, NULL, NULL, 'ALKANE HYDROXYLASE MAH1-LIKE', 241037),
(317905, 'PTHR24296:SF135', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 241037),
(317906, 'PTHR24296:SF260', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 94A2-LIKE', 241037),
(317907, 'PTHR24296:SF140', NULL, NULL, NULL, NULL, 'BNAC01G00400D PROTEIN', 241037),
(317908, 'PTHR24296:SF261', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY-DEPENDENT FATTY ACID HYDROXYLASE', 241037),
(317909, 'PTHR24296:SF248', NULL, NULL, NULL, NULL, '', 241037),
(317910, 'PTHR24296:SF249', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 86, SUBFAMILY A, POLYPEPTIDE 4-RELATED', 241037),
(317911, 'PTHR24296:SF121', NULL, NULL, NULL, NULL, 'CYTOCHROME P-450-LIKE PROTEIN', 241037),
(317912, 'PTHR24296:SF122', NULL, NULL, NULL, NULL, 'ALKANE HYDROXYLASE MAH1-LIKE', 241037),
(317913, 'PTHR24296:SF243', NULL, NULL, NULL, NULL, '', 241037),
(317914, 'PTHR24296:SF240', NULL, NULL, NULL, NULL, '', 241037),
(317915, 'PTHR24296:SF241', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 241037),
(317916, 'PTHR24296:SF246', NULL, NULL, NULL, NULL, '', 241037),
(317917, 'PTHR24296:SF125', NULL, NULL, NULL, NULL, '', 241037),
(317918, 'PTHR24296:SF247', NULL, NULL, NULL, NULL, '', 241037),
(317919, 'PTHR24296:SF123', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 94A2-LIKE', 241037),
(317920, 'PTHR24296:SF244', NULL, NULL, NULL, NULL, '', 241037),
(317921, 'PTHR24296:SF245', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 96, SUBFAMILY A, POLYPEPTIDE 2-RELATED', 241037),
(317922, 'PTHR24296:SF124', NULL, NULL, NULL, NULL, '', 241037),
(317923, 'PTHR24296:SF250', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 241037),
(317924, 'PTHR24296:SF237', NULL, NULL, NULL, NULL, 'P450, PUTATIVE, EXPRESSED-RELATED', 241037),
(317925, 'PTHR24296:SF117', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 86A2-RELATED', 241037),
(317926, 'PTHR24296:SF231', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN, EXPRESSED', 241037),
(317927, 'PTHR24296:SF110', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 96, SUBFAMILY A, POLYPEPTIDE 11-RELATED', 241037),
(317928, 'PTHR24296:SF198', NULL, NULL, NULL, NULL, 'ALKANE HYDROXYLASE MAH1-LIKE', 241037),
(317929, 'PTHR24296:SF111', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN-RELATED', 241037),
(317930, 'PTHR24296:SF232', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN, EXPRESSED', 241037),
(317931, 'PTHR24296:SF115', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 96, SUBFAMILY A, POLYPEPTIDE 13', 241037),
(317932, 'PTHR24296:SF236', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 241037),
(317933, 'PTHR24296:SF112', NULL, NULL, NULL, NULL, 'CYTOCHROME P450-DEPENDENT FATTY ACID HYDROXYLASE', 241037),
(317934, 'PTHR24296:SF234', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 94 PROTEIN', 241037),
(317935, 'PTHR24296:SF113', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 96 SUBFAMILY A POLYPEPTIDE 1', 241037),
(317936, 'PTHR24296:SF107', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 86, SUBFAMILY C, POLYPEPTIDE 1', 241037),
(317937, 'PTHR24296:SF108', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 96, SUBFAMILY A, POLYPEPTIDE 1', 241037),
(317938, 'PTHR24296:SF226', NULL, NULL, NULL, NULL, 'BNAC08G48490D PROTEIN', 241037),
(317939, 'PTHR24296:SF105', NULL, NULL, NULL, NULL, 'CYTOCHROME P450-RELATED', 241037),
(317940, 'PTHR24296:SF106', NULL, NULL, NULL, NULL, '', 241037),
(317941, 'PTHR24296:SF227', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 86A22', 241037),
(317942, 'PTHR24296:SF187', NULL, NULL, NULL, NULL, 'BNAA09G15080D PROTEIN', 241037),
(317943, 'PTHR24296:SF220', NULL, NULL, NULL, NULL, 'BNAANNG34510D PROTEIN', 241037),
(317944, 'PTHR24296:SF221', NULL, NULL, NULL, NULL, '', 241037),
(317945, 'PTHR24296:SF39', NULL, NULL, NULL, NULL, 'OS08G0263000 PROTEIN', 241037),
(317946, 'PTHR24296:SF103', NULL, NULL, NULL, NULL, '', 241037),
(317947, 'PTHR24296:SF37', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 96 SUBFAMILY A POLYPEPTIDE 1', 241037);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(317948, 'PTHR24296:SF104', NULL, NULL, NULL, NULL, 'ALKANE HYDROXYLASE MAH1-LIKE', 241037),
(317949, 'PTHR24296:SF101', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 94B1', 241037),
(317950, 'PTHR24296:SF189', NULL, NULL, NULL, NULL, 'BNAA08G06820D PROTEIN', 241037),
(317951, 'PTHR24296:SF222', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 86A8', 241037),
(317952, 'PTHR24296:SF191', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 94A2-LIKE', 241037),
(317953, 'PTHR24296:SF30', NULL, NULL, NULL, NULL, 'OS05G0445100 PROTEIN', 241037),
(317954, 'PTHR24296:SF194', NULL, NULL, NULL, NULL, 'BNAC03G60620D PROTEIN', 241037),
(317955, 'PTHR24296:SF195', NULL, NULL, NULL, NULL, 'BNAA06G31970D PROTEIN', 241037),
(317956, 'PTHR24296:SF192', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 94C1', 241037),
(317957, 'PTHR24296:SF193', NULL, NULL, NULL, NULL, 'ALKANE HYDROXYLASE MAH1-LIKE', 241037),
(317958, 'PTHR38934:SF22', NULL, NULL, NULL, NULL, 'KINASE', 241038),
(317959, 'PTHR38934', NULL, NULL, NULL, NULL, 'HYPHALLY REGULATED CELL WALL PROTEIN 1', 241038),
(317960, 'PTHR38934:SF6', NULL, NULL, NULL, NULL, 'BAP-LIKE', 241038),
(317961, 'PTHR46616:SF1', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 241039),
(317962, 'PTHR46616', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE', 241039),
(317963, 'PTHR46616:SF7', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 241039),
(317964, 'PTHR46616:SF6', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF182-LIKE', 241039),
(317965, 'PTHR46616:SF8', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE, RING-TYPE ZINC-FINGER, LISH DIMERIZATION MOTIF PROTEIN-RELATED', 241039),
(317966, 'PTHR46616:SF3', NULL, NULL, NULL, NULL, 'OS03G0427100 PROTEIN', 241039),
(317967, 'PTHR46616:SF2', NULL, NULL, NULL, NULL, 'OS03G0211100 PROTEIN', 241039),
(317968, 'PTHR37299:SF3', NULL, NULL, NULL, NULL, 'STAGE 0 SPORULATION PROTEIN A HOMOLOG', 241040),
(317969, 'PTHR37299:SF4', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', 241040),
(317970, 'PTHR37299:SF1', NULL, NULL, NULL, NULL, 'STAGE 0 SPORULATION PROTEIN A HOMOLOG', 241040),
(317971, 'PTHR37299:SF2', NULL, NULL, NULL, NULL, 'HTH LYTTR-TYPE DOMAIN-CONTAINING PROTEIN', 241040),
(317972, 'PTHR37299', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', 241040),
(317973, 'PTHR46183:SF15', NULL, NULL, NULL, NULL, 'BNAA09G41010D PROTEIN', 241041),
(317974, 'PTHR46183:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CLMP1', 241041),
(317975, 'PTHR46183:SF16', NULL, NULL, NULL, NULL, 'PROTEIN PHOX3', 241041),
(317976, 'PTHR46183:SF11', NULL, NULL, NULL, NULL, 'OCTICOSAPEPTIDE/PHOX/BEM1P DOMAIN-CONTAINING PROTEIN', 241041),
(317977, 'PTHR46183:SF10', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 70 (HSP70)-INTERACTING PROTEIN', 241041),
(317978, 'PTHR46183:SF1', NULL, NULL, NULL, NULL, 'HSP-INTERACTING PROTEIN', 241041),
(317979, 'PTHR46183:SF4', NULL, NULL, NULL, NULL, 'PROTEIN PHOX4', 241041),
(317980, 'PTHR46183:SF12', NULL, NULL, NULL, NULL, 'PB1 DOMAIN, TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN PROTEIN-RELATED', 241041),
(317981, 'PTHR46183:SF3', NULL, NULL, NULL, NULL, 'OCTICOSAPEPTIDE/PHOX/BEM1P (PB1) DOMAIN-CONTAINING PROTEIN / TETRATRICOPEPTIDE REPEAT (TPR)-CONTAINING PROTEIN', 241041),
(317982, 'PTHR46183:SF19', NULL, NULL, NULL, NULL, 'PB1 DOMAIN, 43KDA POSTSYNAPTIC PROTEIN-RELATED', 241041),
(317983, 'PTHR46183:SF9', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 241041),
(317984, 'PTHR46183:SF18', NULL, NULL, NULL, NULL, 'PROTEIN PHOX1', 241041),
(317985, 'PTHR46183', NULL, NULL, NULL, NULL, 'PROTEIN CLMP1', 241041),
(317986, 'PTHR38165', NULL, NULL, NULL, NULL, '', 241042),
(317987, 'PTHR38165:SF1', NULL, NULL, NULL, NULL, 'GLUCANASE B', 241042),
(317988, 'PTHR23289:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY PROTEIN COX15 HOMOLOG', 241043),
(317989, 'PTHR23289', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY PROTEIN COX15', 241043),
(317990, 'PTHR11831:SF51', NULL, NULL, NULL, NULL, 'ALKALINE/NEUTRAL INVERTASE', 241044),
(317991, 'PTHR11831:SF50', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S4, CHLOROPLASTIC', 241044);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(317992, 'PTHR11831:SF30', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S4, MITOCHONDRIAL', 241044),
(317993, 'PTHR11831:SF22', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S4, CHLOROPLASTIC', 241044),
(317994, 'PTHR11831:SF44', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S9', 241044),
(317995, 'PTHR11831:SF43', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S4, CHLOROPLASTIC', 241044),
(317996, 'PTHR11831:SF46', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S9', 241044),
(317997, 'PTHR11831:SF45', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN YLMH-RELATED', 241044),
(317998, 'PTHR11831:SF26', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S9-1', 241044),
(317999, 'PTHR11831:SF48', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S9', 241044),
(318000, 'PTHR11831:SF47', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S9-2', 241044),
(318001, 'PTHR11831:SF5', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S9', 241044),
(318002, 'PTHR11831:SF39', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S4/S9-RELATED', 241044),
(318003, 'PTHR11831:SF49', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S9-2-LIKE', 241044),
(318004, 'PTHR11831', NULL, NULL, NULL, NULL, '30S 40S RIBOSOMAL PROTEIN', 241044),
(318005, 'PTHR11831:SF1', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RIBONUCLEOPROTEIN PROTEIN IMP3', 241044),
(318006, 'PTHR11831:SF4', NULL, NULL, NULL, NULL, '37S RIBOSOMAL PROTEIN NAM9, MITOCHONDRIAL', 241044),
(318007, 'PTHR35458:SF2', NULL, NULL, NULL, NULL, 'NYN DOMAIN-CONTAINING PROTEIN', 241045),
(318008, 'PTHR35458:SF8', NULL, NULL, NULL, NULL, 'SLR0650 PROTEIN', 241045),
(318009, 'PTHR35458', NULL, NULL, NULL, NULL, 'SLR0755 PROTEIN', 241045),
(318010, 'PTHR43490:SF37', NULL, NULL, NULL, NULL, 'OS02G0607700 PROTEIN', 241046),
(318011, 'PTHR43490:SF79', NULL, NULL, NULL, NULL, '(+)-NEOMENTHOL DEHYDROGENASE-LIKE ISOFORM X1', 241046),
(318012, 'PTHR43490:SF78', NULL, NULL, NULL, NULL, 'OS04G0532100 PROTEIN', 241046),
(318013, 'PTHR43490:SF117', NULL, NULL, NULL, NULL, '(+)-NEOMENTHOL DEHYDROGENASE-LIKE ISOFORM X1', 241046),
(318014, 'PTHR43490:SF119', NULL, NULL, NULL, NULL, 'SALUTARIDINE REDUCTASE-LIKE', 241046),
(318015, 'PTHR43490:SF116', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN-RELATED', 241046),
(318016, 'PTHR43490:SF115', NULL, NULL, NULL, NULL, '', 241046),
(318017, 'PTHR43490:SF132', NULL, NULL, NULL, NULL, '(+)-NEOMENTHOL DEHYDROGENASE-LIKE ISOFORM X1', 241046),
(318018, 'PTHR43490:SF110', NULL, NULL, NULL, NULL, '', 241046),
(318019, 'PTHR43490:SF131', NULL, NULL, NULL, NULL, 'SALUTARIDINE REDUCTASE-LIKE', 241046),
(318020, 'PTHR43490:SF112', NULL, NULL, NULL, NULL, 'GLUCOSE/RIBITOL DEHYDROGENASE-RELATED', 241046),
(318021, 'PTHR43490:SF111', NULL, NULL, NULL, NULL, '(+)-NEOMENTHOL DEHYDROGENASE-LIKE ISOFORM X1', 241046),
(318022, 'PTHR43490:SF91', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/REDUCTASE', 241046),
(318023, 'PTHR43490:SF73', NULL, NULL, NULL, NULL, 'CHAIN DEHYDROGENASE/REDUCTASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G00840)-RELATED', 241046),
(318024, 'PTHR43490:SF94', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE-RELATED', 241046),
(318025, 'PTHR43490:SF71', NULL, NULL, NULL, NULL, '(+)-NEOMENTHOL DEHYDROGENASE-LIKE', 241046),
(318026, 'PTHR43490:SF92', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 241046),
(318027, 'PTHR43490:SF70', NULL, NULL, NULL, NULL, 'BNACNNG24570D PROTEIN', 241046),
(318028, 'PTHR43490:SF99', NULL, NULL, NULL, NULL, 'OS01G0929500 PROTEIN', 241046),
(318029, 'PTHR43490:SF98', NULL, NULL, NULL, NULL, 'OS02G0640600 PROTEIN', 241046),
(318030, 'PTHR43490:SF89', NULL, NULL, NULL, NULL, '(+)-NEOMENTHOL DEHYDROGENASE-RELATED', 241046),
(318031, 'PTHR43490:SF67', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD PROTEIN', 241046),
(318032, 'PTHR43490:SF129', NULL, NULL, NULL, NULL, 'OS07G0685800 PROTEIN', 241046),
(318033, 'PTHR43490:SF107', NULL, NULL, NULL, NULL, 'GLUCOSE/RIBITOL DEHYDROGENASE-RELATED', 241046),
(318034, 'PTHR43490:SF128', NULL, NULL, NULL, NULL, 'CARBONYL REDUCTASE [NADPH] 1-LIKE', 241046),
(318035, 'PTHR43490:SF103', NULL, NULL, NULL, NULL, '(+)-NEOMENTHOL DEHYDROGENASE-LIKE', 241046);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(318036, 'PTHR43490:SF125', NULL, NULL, NULL, NULL, '(+)-NEOMENTHOL DEHYDROGENASE-RELATED', 241046),
(318037, 'PTHR43490:SF127', NULL, NULL, NULL, NULL, 'OS02G0640800 PROTEIN', 241046),
(318038, 'PTHR43490:SF105', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD PROTEIN', 241046),
(318039, 'PTHR43490:SF104', NULL, NULL, NULL, NULL, 'CARBONYL REDUCTASE', 241046),
(318040, 'PTHR43490:SF126', NULL, NULL, NULL, NULL, '(+)-NEOMENTHOL DEHYDROGENASE-RELATED', 241046),
(318041, 'PTHR43490:SF120', NULL, NULL, NULL, NULL, 'OS04G0531750 PROTEIN', 241046),
(318042, 'PTHR43490:SF123', NULL, NULL, NULL, NULL, 'SHORT CHAIN DEHYDROGENASE', 241046),
(318043, 'PTHR43490:SF100', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', 241046),
(318044, 'PTHR43490:SF130', NULL, NULL, NULL, NULL, '(+)-NEOMENTHOL DEHYDROGENASE', 241046),
(318045, 'PTHR43490:SF80', NULL, NULL, NULL, NULL, '(+)-NEOMENTHOL DEHYDROGENASE', 241046),
(318046, 'PTHR43490', NULL, NULL, NULL, NULL, '(+)-NEOMENTHOL DEHYDROGENASE', 241046),
(318047, 'PTHR43490:SF62', NULL, NULL, NULL, NULL, '(+)-NEOMENTHOL DEHYDROGENASE', 241046),
(318048, 'PTHR43490:SF82', NULL, NULL, NULL, NULL, '(+)-NEOMENTHOL DEHYDROGENASE-LIKE', 241046),
(318049, 'PTHR43490:SF60', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 241046),
(318050, 'PTHR43490:SF88', NULL, NULL, NULL, NULL, '(+)-NEOMENTHOL DEHYDROGENASE', 241046),
(318051, 'PTHR43490:SF66', NULL, NULL, NULL, NULL, '(+)-NEOMENTHOL DEHYDROGENASE-LIKE', 241046),
(318052, 'PTHR43490:SF65', NULL, NULL, NULL, NULL, '(+)-NEOMENTHOL DEHYDROGENASE', 241046),
(318053, 'PTHR43490:SF64', NULL, NULL, NULL, NULL, '', 241046),
(318054, 'PTHR38501:SF1', NULL, NULL, NULL, NULL, 'PHOTORECEPTOR DISK COMPONENT PRCD', 241047),
(318055, 'PTHR38501', NULL, NULL, NULL, NULL, 'PHOTORECEPTOR DISK COMPONENT PRCD', 241047),
(318056, 'PTHR10965:SF14', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L38', 241048),
(318057, 'PTHR10965:SF9', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L38, PUTATIVE, EXPRESSED-RELATED', 241048),
(318058, 'PTHR10965:SF20', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L38', 241048),
(318059, 'PTHR10965:SF10', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L38', 241048),
(318060, 'PTHR10965', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L38', 241048),
(318061, 'PTHR10965:SF0', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L38', 241048),
(318062, 'PTHR10965:SF17', NULL, NULL, NULL, NULL, 'BNACNNG77070D PROTEIN', 241048),
(318063, 'PTHR10965:SF18', NULL, NULL, NULL, NULL, '', 241048),
(318064, 'PTHR10965:SF19', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L38', 241048),
(318065, 'PTHR11124:SF24', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 29', 241049),
(318066, 'PTHR11124:SF25', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 29', 241049),
(318067, 'PTHR11124', NULL, NULL, NULL, NULL, 'VACUOLAR SORTING PROTEIN VPS29', 241049),
(318068, 'PTHR11124:SF12', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 29', 241049),
(318069, 'PTHR11124:SF26', NULL, NULL, NULL, NULL, 'PHOSPHODIESTERASE YFCE', 241049),
(318070, 'PTHR37365:SF1', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 44', 241050),
(318071, 'PTHR37365', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 44', 241050),
(318072, 'PTHR10722:SF18', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L19', 241051),
(318073, 'PTHR10722:SF39', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L19', 241051),
(318074, 'PTHR10722:SF28', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L19E DOMAIN-CONTAINING PROTEIN', 241051),
(318075, 'PTHR10722:SF38', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L19', 241051),
(318076, 'PTHR10722:SF0', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L19', 241051),
(318077, 'PTHR10722:SF33', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L19', 241051),
(318078, 'PTHR10722:SF22', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L19', 241051),
(318079, 'PTHR10722:SF43', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L19', 241051),
(318080, 'PTHR10722:SF42', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L19-2', 241051);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(318081, 'PTHR10722:SF41', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L19', 241051),
(318082, 'PTHR10722:SF25', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L19', 241051),
(318083, 'PTHR10722:SF24', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L19', 241051),
(318084, 'PTHR10722:SF35', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L19', 241051),
(318085, 'PTHR10722:SF23', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L19', 241051),
(318086, 'PTHR10722:SF34', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L19', 241051),
(318087, 'PTHR10722:SF40', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L19-1-RELATED', 241051),
(318088, 'PTHR10722', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L19', 241051),
(318089, 'PTHR16968', NULL, NULL, NULL, NULL, 'LENS EPITHELIAL CELL PROTEIN LEP503', 241052),
(318090, 'PTHR16968:SF2', NULL, NULL, NULL, NULL, 'LENS EPITHELIAL CELL PROTEIN LEP503', 241052),
(318091, 'PTHR10458:SF2', NULL, NULL, NULL, NULL, 'PEPTIDE DEFORMYLASE, MITOCHONDRIAL', 241053),
(318092, 'PTHR10458:SF22', NULL, NULL, NULL, NULL, 'PEPTIDE DEFORMYLASE', 241053),
(318093, 'PTHR10458:SF21', NULL, NULL, NULL, NULL, 'PEPTIDE DEFORMYLASE', 241053),
(318094, 'PTHR10458', NULL, NULL, NULL, NULL, 'PEPTIDE DEFORMYLASE', 241053),
(318095, 'PTHR10458:SF20', NULL, NULL, NULL, NULL, 'PEPTIDE DEFORMYLASE 1', 241053),
(318096, 'PTHR10458:SF8', NULL, NULL, NULL, NULL, 'PEPTIDE DEFORMYLASE 2', 241053),
(318097, 'PTHR10458:SF18', NULL, NULL, NULL, NULL, 'PEPTIDE DEFORMYLASE', 241053),
(318098, 'PTHR10458:SF17', NULL, NULL, NULL, NULL, 'PEPTIDE DEFORMYLASE', 241053),
(318099, 'PTHR23236:SF110', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 241054),
(318100, 'PTHR23236:SF53', NULL, NULL, NULL, NULL, 'BNACNNG45920D PROTEIN', 241054),
(318101, 'PTHR23236:SF96', NULL, NULL, NULL, NULL, 'BNAA01G06440D PROTEIN', 241054),
(318102, 'PTHR23236:SF11', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4H', 241054),
(318103, 'PTHR23236:SF112', NULL, NULL, NULL, NULL, 'RNA BINDING PROTEIN', 241054),
(318104, 'PTHR23236:SF99', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 241054),
(318105, 'PTHR23236:SF111', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 241054),
(318106, 'PTHR23236:SF98', NULL, NULL, NULL, NULL, 'BNAA03G46620D PROTEIN', 241054),
(318107, 'PTHR23236:SF114', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4B', 241054),
(318108, 'PTHR23236:SF92', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN 1', 241054),
(318109, 'PTHR23236:SF113', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 241054),
(318110, 'PTHR23236:SF116', NULL, NULL, NULL, NULL, 'BNAC04G47460D PROTEIN', 241054),
(318111, 'PTHR23236:SF95', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 13', 241054),
(318112, 'PTHR23236:SF51', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 6', 241054),
(318113, 'PTHR23236:SF94', NULL, NULL, NULL, NULL, 'BNAC08G40790D PROTEIN', 241054),
(318114, 'PTHR23236:SF115', NULL, NULL, NULL, NULL, 'BNAC06G40890D PROTEIN', 241054),
(318115, 'PTHR23236:SF16', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN 2', 241054),
(318116, 'PTHR23236:SF56', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 241054),
(318117, 'PTHR23236:SF12', NULL, NULL, NULL, NULL, 'EUKARYOTIC INITIATION FACTOR 4B-RELATED', 241054),
(318118, 'PTHR23236:SF59', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN 1-LIKE', 241054),
(318119, 'PTHR23236', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4B/4H', 241054),
(318120, 'PTHR23236:SF64', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 241054),
(318121, 'PTHR23236:SF63', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 241054),
(318122, 'PTHR23236:SF22', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 241054),
(318123, 'PTHR23236:SF65', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-BINDING ALPHA-BETA PLAIT DOMAIN-CONTAINING PROTEIN-RELATED', 241054),
(318124, 'PTHR23236:SF27', NULL, NULL, NULL, NULL, 'EMBRYONIC POLYADENYLATE-BINDING PROTEIN 2', 241054),
(318125, 'PTHR23236:SF68', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 241054);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(318126, 'PTHR23236:SF24', NULL, NULL, NULL, NULL, 'PHRAGMOPLASTIN INTERACTING PROTEIN 1', 241054),
(318127, 'PTHR23236:SF23', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN EEED8.12-RELATED', 241054),
(318128, 'PTHR23236:SF25', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 34', 241054),
(318129, 'PTHR23236:SF69', NULL, NULL, NULL, NULL, 'BNAA04G17650D PROTEIN', 241054),
(318130, 'PTHR23236:SF2', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4B', 241054),
(318131, 'PTHR23236:SF74', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-BINDING ALPHA-BETA PLAIT DOMAIN-CONTAINING PROTEIN-RELATED', 241054),
(318132, 'PTHR23236:SF30', NULL, NULL, NULL, NULL, 'NUCLEOLIN 2', 241054),
(318133, 'PTHR23236:SF77', NULL, NULL, NULL, NULL, 'NUCLEOLIN 1', 241054),
(318134, 'PTHR23236:SF76', NULL, NULL, NULL, NULL, '', 241054),
(318135, 'PTHR23236:SF71', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 241054),
(318136, 'PTHR23236:SF73', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 241054),
(318137, 'PTHR23236:SF79', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 241054),
(318138, 'PTHR23236:SF36', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 241054),
(318139, 'PTHR23236:SF107', NULL, NULL, NULL, NULL, 'BNAA04G14290D PROTEIN', 241054),
(318140, 'PTHR23236:SF106', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 241054),
(318141, 'PTHR23236:SF109', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 241054),
(318142, 'PTHR23236:SF90', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 241054),
(318143, 'PTHR23236:SF108', NULL, NULL, NULL, NULL, 'OS03G0123200 PROTEIN', 241054),
(318144, 'PTHR23236:SF42', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4B', 241054),
(318145, 'PTHR23236:SF44', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 241054),
(318146, 'PTHR23236:SF101', NULL, NULL, NULL, NULL, 'NUCLEAR RNA-BINDING PROTEIN SART-3', 241054),
(318147, 'PTHR23236:SF100', NULL, NULL, NULL, NULL, 'NUCLEOLIN', 241054),
(318148, 'PTHR23236:SF103', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 241054),
(318149, 'PTHR23236:SF102', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN 2-RELATED', 241054),
(318150, 'PTHR23236:SF84', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 241054),
(318151, 'PTHR23236:SF105', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 241054),
(318152, 'PTHR23236:SF104', NULL, NULL, NULL, NULL, 'GALECTIN', 241054),
(318153, 'PTHR23236:SF89', NULL, NULL, NULL, NULL, 'OS06G0219600 PROTEIN', 241054),
(318154, 'PTHR23236:SF45', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 241054),
(318155, 'PTHR37449', NULL, NULL, NULL, NULL, '', 241055),
(318156, 'PTHR37449:SF1', NULL, NULL, NULL, NULL, 'OS02G0159950 PROTEIN', 241055),
(318157, 'PTHR30432', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR MODE', 241056),
(318158, 'PTHR30432:SF1', NULL, NULL, NULL, NULL, 'DNA-BINDING TRANSCRIPTIONAL DUAL REGULATOR MODE', 241056),
(318159, 'PTHR11243:SF22', NULL, NULL, NULL, NULL, 'GROWTH FACTOR RECEPTOR-BOUND PROTEIN 14', 241057),
(318160, 'PTHR11243:SF23', NULL, NULL, NULL, NULL, 'LD06925P', 241057),
(318161, 'PTHR11243:SF15', NULL, NULL, NULL, NULL, 'RAS-ASSOCIATED AND PLECKSTRIN HOMOLOGY DOMAINS-CONTAINING PROTEIN 1', 241057),
(318162, 'PTHR11243:SF37', NULL, NULL, NULL, NULL, 'SH2 DOMAIN-CONTAINING PROTEIN', 241057),
(318163, 'PTHR11243:SF14', NULL, NULL, NULL, NULL, 'AMYLOID BETA A4 PRECURSOR PROTEIN-BINDING FAMILY B MEMBER 1-INTERACTING PROTEIN', 241057),
(318164, 'PTHR11243:SF25', NULL, NULL, NULL, NULL, 'GROWTH FACTOR RECEPTOR-BOUND PROTEIN 7', 241057),
(318165, 'PTHR11243:SF4', NULL, NULL, NULL, NULL, 'GROWTH FACTOR RECEPTOR-BOUND PROTEIN 10', 241057),
(318166, 'PTHR11243', NULL, NULL, NULL, NULL, 'GROWTH FACTOR RECEPTOR-BOUND PROTEIN', 241057),
(318167, 'PTHR15825:SF7', NULL, NULL, NULL, NULL, 'UBIQUITIN-FOLD MODIFIER 1', 241058),
(318168, 'PTHR15825:SF4', NULL, NULL, NULL, NULL, 'UBIQUITIN-FOLD MODIFIER 1', 241058);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(318169, 'PTHR15825:SF5', NULL, NULL, NULL, NULL, 'UBIQUITIN-FOLD MODIFIER 1', 241058),
(318170, 'PTHR15825', NULL, NULL, NULL, NULL, 'UBIQUITIN-FOLD MODIFIER 1', 241058),
(318171, 'PTHR15825:SF3', NULL, NULL, NULL, NULL, 'UBIQUITIN-FOLD MODIFIER 1', 241058),
(318172, 'PTHR15825:SF0', NULL, NULL, NULL, NULL, 'UBIQUITIN-FOLD MODIFIER 1', 241058),
(318173, 'PTHR15825:SF1', NULL, NULL, NULL, NULL, 'UBIQUITIN-FOLD MODIFIER 1', 241058),
(318174, 'PTHR12792:SF2', NULL, NULL, NULL, NULL, 'SEPARASE', 241059),
(318175, 'PTHR12792:SF0', NULL, NULL, NULL, NULL, 'SEPARIN', 241059),
(318176, 'PTHR12792', NULL, NULL, NULL, NULL, 'EXTRA SPINDLE POLES 1-RELATED', 241059),
(318177, 'PTHR23004:SF10', NULL, NULL, NULL, NULL, 'DOUBLECORTIN DOMAIN-CONTAINING PROTEIN 2B', 241060),
(318178, 'PTHR23004:SF7', NULL, NULL, NULL, NULL, 'BLL1318 PROTEIN', 241060),
(318179, 'PTHR23004:SF5', NULL, NULL, NULL, NULL, 'DOUBLECORTIN DOMAIN-CONTAINING PROTEIN 2', 241060),
(318180, 'PTHR23004:SF9', NULL, NULL, NULL, NULL, 'DOUBLECORTIN DOMAIN-CONTAINING PROTEIN 2C', 241060),
(318181, 'PTHR23004', NULL, NULL, NULL, NULL, 'DOUBLECORTIN DOMAIN CONTAINING 2', 241060),
(318182, 'PTHR23004:SF22', NULL, NULL, NULL, NULL, 'DOUBLECORTIN DOMAIN-CONTAINING PROTEIN', 241060),
(318183, 'PTHR23004:SF11', NULL, NULL, NULL, NULL, 'PROTEIN RPI-1', 241060),
(318184, 'PTHR23004:SF23', NULL, NULL, NULL, NULL, 'DOUBLECORTIN DOMAIN-CONTAINING PROTEIN', 241060),
(318185, 'PTHR33926', NULL, NULL, NULL, NULL, 'PROTEIN TIC 22, CHLOROPLASTIC', 241061),
(318186, 'PTHR33926:SF4', NULL, NULL, NULL, NULL, 'PROTEIN TIC 22, CHLOROPLASTIC', 241061),
(318187, 'PTHR33926:SF1', NULL, NULL, NULL, NULL, 'PROTEIN TIC 22-LIKE, CHLOROPLASTIC', 241061),
(318188, 'PTHR43775', NULL, NULL, NULL, NULL, 'FATTY ACID SYNTHASE', 241062),
(318189, 'PTHR43775:SF52', NULL, NULL, NULL, NULL, 'STEREOSELECTIVE KETO-REDUCTASE AF490', 241062),
(318190, 'PTHR43775:SF20', NULL, NULL, NULL, NULL, 'HYBRID PKS-NRPS SYNTHETASE APDA', 241062),
(318191, 'PTHR43775:SF50', NULL, NULL, NULL, NULL, 'HIGHLY REDUCING POLYKETIDE SYNTHASE SRDA', 241062),
(318192, 'PTHR43775:SF40', NULL, NULL, NULL, NULL, 'STERIGMATOCYSTIN BIOSYNTHESIS POLYKETIDE SYNTHASE-RELATED', 241062),
(318193, 'PTHR43775:SF51', NULL, NULL, NULL, NULL, 'INACTIVE PHENOLPHTHIOCEROL SYNTHESIS POLYKETIDE SYNTHASE TYPE I PKS1-RELATED', 241062),
(318194, 'PTHR43775:SF34', NULL, NULL, NULL, NULL, 'POLYKETIDE SYNTHASE 16-RELATED', 241062),
(318195, 'PTHR43775:SF23', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', 241062),
(318196, 'PTHR43775:SF45', NULL, NULL, NULL, NULL, 'CONIDIAL PIGMENT POLYKETIDE SYNTHASE ALB1', 241062),
(318197, 'PTHR43775:SF46', NULL, NULL, NULL, NULL, 'FUMIGERMIN SYNTHASE', 241062),
(318198, 'PTHR43775:SF13', NULL, NULL, NULL, NULL, 'POLYKETIDE SYNTHASE 1', 241062),
(318199, 'PTHR43775:SF24', NULL, NULL, NULL, NULL, 'NON-REDUCING POLYKETIDE SYNTHASE APTA-RELATED', 241062),
(318200, 'PTHR43775:SF21', NULL, NULL, NULL, NULL, 'NON-REDUCING POLYKETIDE SYNTHASE AUSA-RELATED', 241062),
(318201, 'PTHR43775:SF22', NULL, NULL, NULL, NULL, 'SYNTHASE, PUTATIVE (JCVI)-RELATED', 241062),
(318202, 'PTHR43775:SF49', NULL, NULL, NULL, NULL, 'SYNTHASE, PUTATIVE (JCVI)-RELATED', 241062),
(318203, 'PTHR43775:SF28', NULL, NULL, NULL, NULL, 'SYNTHASE, PUTATIVE-RELATED', 241062),
(318204, 'PTHR43775:SF47', NULL, NULL, NULL, NULL, 'OLEOYL-[ACYL-CARRIER-PROTEIN] HYDROLASE', 241062),
(318205, 'PTHR43775:SF14', NULL, NULL, NULL, NULL, 'ITERATIVE POLYKETIDE SYNTHASE AFOE-RELATED', 241062),
(318206, 'PTHR43775:SF48', NULL, NULL, NULL, NULL, 'HIGHLY REDUCING POLYKETIDE SYNTHASE SDGA', 241062),
(318207, 'PTHR43775:SF15', NULL, NULL, NULL, NULL, 'SI:DKEY-61P9.11', 241062),
(318208, 'PTHR43775:SF37', NULL, NULL, NULL, NULL, 'FATTY ACID SYNTHASE', 241062),
(318209, 'PTHR43775:SF7', NULL, NULL, NULL, NULL, 'FATTY ACID SYNTHASE', 241062),
(318210, 'PTHR43775:SF29', NULL, NULL, NULL, NULL, 'ASPERFURANONE POLYKETIDE SYNTHASE AFOG-RELATED', 241062),
(318211, 'PTHR43775:SF18', NULL, NULL, NULL, NULL, 'ENZYME, PUTATIVE (JCVI)-RELATED', 241062);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(318212, 'PTHR11761:SF29', NULL, NULL, NULL, NULL, 'BNAA06G11840D PROTEIN', 241063),
(318213, 'PTHR11761:SF42', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L23', 241063),
(318214, 'PTHR11761:SF41', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L23-LIKE', 241063),
(318215, 'PTHR11761:SF40', NULL, NULL, NULL, NULL, '60S RIBOSOMAL L23-LIKE PROTEIN', 241063),
(318216, 'PTHR11761:SF24', NULL, NULL, NULL, NULL, '', 241063),
(318217, 'PTHR11761:SF46', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L14, CHLOROPLASTIC', 241063),
(318218, 'PTHR11761:SF3', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN L38, MITOCHONDRIAL', 241063),
(318219, 'PTHR11761', NULL, NULL, NULL, NULL, '50S/60S RIBOSOMAL PROTEIN L14/L23', 241063),
(318220, 'PTHR11761:SF45', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L14P/L23E', 241063),
(318221, 'PTHR11761:SF23', NULL, NULL, NULL, NULL, '', 241063),
(318222, 'PTHR11761:SF44', NULL, NULL, NULL, NULL, '60S RIBOSOMAL L23-LIKE PROTEIN', 241063),
(318223, 'PTHR11761:SF22', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L23', 241063),
(318224, 'PTHR11761:SF21', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN HLL, MITOCHONDRIAL', 241063),
(318225, 'PTHR11761:SF32', NULL, NULL, NULL, NULL, 'BNAA06G36160D PROTEIN', 241063),
(318226, 'PTHR11761:SF43', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L17', 241063),
(318227, 'PTHR11761:SF28', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L14B/L23E-RELATED', 241063),
(318228, 'PTHR11761:SF39', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L23, PUTATIVE, EXPRESSED-RELATED', 241063),
(318229, 'PTHR11761:SF8', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L23', 241063),
(318230, 'PTHR11761:SF27', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L14, CHLOROPLASTIC', 241063),
(318231, 'PTHR11761:SF26', NULL, NULL, NULL, NULL, '', 241063),
(318232, 'PTHR11761:SF37', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L14B/L23E-RELATED', 241063),
(318233, 'PTHR11761:SF25', NULL, NULL, NULL, NULL, '', 241063),
(318234, 'PTHR13034:SF2', NULL, NULL, NULL, NULL, 'DYNACTIN SUBUNIT 4', 241064),
(318235, 'PTHR13034', NULL, NULL, NULL, NULL, 'DYNACTIN P62 SUBUNIT', 241064),
(318236, 'PTHR36466:SF1', NULL, NULL, NULL, NULL, 'BCL-2-LIKE PROTEIN 15', 241065),
(318237, 'PTHR36466', NULL, NULL, NULL, NULL, 'BCL-2-LIKE PROTEIN 15', 241065),
(318238, 'PTHR47796', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE-LIKE PROTEIN', 241066),
(318239, 'PTHR47796:SF1', NULL, NULL, NULL, NULL, 'OS08G0500800 PROTEIN', 241066),
(318240, 'PTHR46318', NULL, NULL, NULL, NULL, 'UPSTREAM BINDING TRANSCRIPTION FACTOR', 241067),
(318241, 'PTHR46318:SF5', NULL, NULL, NULL, NULL, 'UPSTREAM-BINDING TRANSCRIPTION FACTOR,-LIKE', 241067),
(318242, 'PTHR46318:SF3', NULL, NULL, NULL, NULL, 'UPSTREAM BINDING TRANSCRIPTION FACTOR', 241067),
(318243, 'PTHR46318:SF4', NULL, NULL, NULL, NULL, 'NUCLEOLAR TRANSCRIPTION FACTOR 1', 241067),
(318244, 'PTHR46318:SF1', NULL, NULL, NULL, NULL, 'UPSTREAM-BINDING FACTOR 1-LIKE PROTEIN 1-RELATED', 241067),
(318245, 'PTHR46318:SF2', NULL, NULL, NULL, NULL, 'UPSTREAM-BINDING TRANSCRIPTION FACTOR', 241067),
(318246, 'PTHR23033:SF7', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN-N-ACETYLGALACTOSAMINE 3-BETA-GALACTOSYLTRANSFERASE 1', 241068),
(318247, 'PTHR23033:SF48', NULL, NULL, NULL, NULL, 'PROTEIN CBG16569', 241068),
(318248, 'PTHR23033:SF15', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN-N-ACETYLGALACTOSAMINE 3-BETA-GALACTOSYLTRANSFERASE 1', 241068),
(318249, 'PTHR23033:SF38', NULL, NULL, NULL, NULL, 'C1GALT1-SPECIFIC CHAPERONE 1-LIKE PROTEIN', 241068),
(318250, 'PTHR23033:SF49', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 241068),
(318251, 'PTHR23033:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG18324', 241068),
(318252, 'PTHR23033:SF9', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN-N-ACETYLGALACTOSAMINE 3-BETA-GALACTOSYLTRANSFERASE 1-A', 241068),
(318253, 'PTHR23033', NULL, NULL, NULL, NULL, 'BETA1,3-GALACTOSYLTRANSFERASE', 241068),
(318254, 'PTHR23033:SF2', NULL, NULL, NULL, NULL, 'C1GALT1-SPECIFIC CHAPERONE 1', 241068),
(318255, 'PTHR23033:SF50', NULL, NULL, NULL, NULL, '', 241068),
(318256, 'PTHR23033:SF45', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN-N-ACETYLGALACTOSAMINE 3-BETA-GALACTOSYLTRANSFERASE 1-B', 241068); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(318257, 'PTHR23033:SF12', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN-N-ACETYLGALACTOSAMINE 3-BETA-GALACTOSYLTRANSFERASE 1', 241068),
(318258, 'PTHR23033:SF13', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN-N-ACETYLGALACTOSAMINE 3-BETA-GALACTOSYLTRANSFERASE 1', 241068),
(318259, 'PTHR23033:SF14', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN-N-ACETYLGALACTOSAMINE 3-BETA-GALACTOSYLTRANSFERASE 1-RELATED', 241068),
(318260, 'PTHR23033:SF47', NULL, NULL, NULL, NULL, 'APPLE DOMAIN-CONTAINING PROTEIN', 241068),
(318261, 'PTHR23033:SF40', NULL, NULL, NULL, NULL, 'APPLE DOMAIN-CONTAINING PROTEIN', 241068),
(318262, 'PTHR23033:SF41', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN-N-ACETYLGALACTOSAMINE 3-BETA-GALACTOSYLTRANSFERASE 1', 241068),
(318263, 'PTHR23033:SF43', NULL, NULL, NULL, NULL, '', 241068),
(318264, 'PTHR39708', NULL, NULL, NULL, NULL, 'OS07G0483400 PROTEIN', 241069),
(318265, 'PTHR39708:SF2', NULL, NULL, NULL, NULL, 'OS07G0483400 PROTEIN', 241069),
(318266, 'PTHR46572', NULL, NULL, NULL, NULL, 'RHO1 GDP-GTP EXCHANGE PROTEIN 1-RELATED', 241070),
(318267, 'PTHR46572:SF3', NULL, NULL, NULL, NULL, 'RHO1 GUANINE NUCLEOTIDE EXCHANGE FACTOR 2', 241070),
(318268, 'PTHR46572:SF2', NULL, NULL, NULL, NULL, 'RHO1 GDP-GTP EXCHANGE PROTEIN 1-RELATED', 241070),
(318269, 'PTHR46572:SF1', NULL, NULL, NULL, NULL, 'RHO1 GUANINE NUCLEOTIDE EXCHANGE FACTOR TUS1', 241070),
(318270, 'PTHR17117:SF1', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] FLAVOPROTEIN 3, MITOCHONDRIAL', 241071),
(318271, 'PTHR17117:SF3', NULL, NULL, NULL, NULL, 'COMPLEX I-9KD', 241071),
(318272, 'PTHR17117', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE', 241071),
(318273, 'PTHR22902', NULL, NULL, NULL, NULL, 'SESQUIPEDALIAN', 241072),
(318274, 'PTHR22902:SF50', NULL, NULL, NULL, NULL, 'OS07G0138100 PROTEIN', 241072),
(318275, 'PTHR22902:SF43', NULL, NULL, NULL, NULL, '', 241072),
(318276, 'PTHR22902:SF9', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY J MEMBER 1', 241072),
(318277, 'PTHR22902:SF53', NULL, NULL, NULL, NULL, 'INOSITOL PHOSPHATASE INTERACTING PROTEIN, ISOFORM A', 241072),
(318278, 'PTHR22902:SF31', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 241072),
(318279, 'PTHR22902:SF52', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 241072),
(318280, 'PTHR22902:SF51', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY A MEMBER 3', 241072),
(318281, 'PTHR22902:SF47', NULL, NULL, NULL, NULL, '', 241072),
(318282, 'PTHR22902:SF11', NULL, NULL, NULL, NULL, 'ZGC:153733', 241072),
(318283, 'PTHR22902:SF39', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN-RELATED', 241072),
(318284, 'PTHR22902:SF17', NULL, NULL, NULL, NULL, 'SESQUIPEDALIAN-1', 241072),
(318285, 'PTHR22902:SF27', NULL, NULL, NULL, NULL, 'SI:CH73-111K22.3', 241072),
(318286, 'PTHR22902:SF49', NULL, NULL, NULL, NULL, 'OS03G0666200 PROTEIN', 241072),
(318287, 'PTHR22902:SF26', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING PROTEIN 1', 241072),
(318288, 'PTHR22902:SF48', NULL, NULL, NULL, NULL, 'CERAMIDE TRANSFER PROTEIN', 241072),
(318289, 'PTHR22902:SF15', NULL, NULL, NULL, NULL, 'SESQUIPEDALIAN-2', 241072),
(318290, 'PTHR30032:SF5', NULL, NULL, NULL, NULL, 'GERMINATION-SPECIFIC N-ACETYLMURAMOYL-L-ALANINE AMIDASE', 241073),
(318291, 'PTHR30032:SF8', NULL, NULL, NULL, NULL, 'AMIDASE ENHANCER', 241073),
(318292, 'PTHR30032:SF1', NULL, NULL, NULL, NULL, 'N-ACETYLMURAMOYL-L-ALANINE AMIDASE LYTC', 241073),
(318293, 'PTHR30032:SF4', NULL, NULL, NULL, NULL, 'STAGE II SPORULATION PROTEIN D', 241073),
(318294, 'PTHR30032', NULL, NULL, NULL, NULL, 'N-ACETYLMURAMOYL-L-ALANINE AMIDASE-RELATED', 241073),
(318295, 'PTHR15499:SF4', NULL, NULL, NULL, NULL, 'ROC DOMAIN-CONTAINING PROTEIN', 241074),
(318296, 'PTHR15499:SF3', NULL, NULL, NULL, NULL, 'HMG BOX-CONTAINING PROTEIN 1', 241074),
(318297, 'PTHR15499', NULL, NULL, NULL, NULL, 'HMG BOX-CONTAINING PROTEIN 1', 241074),
(318298, 'PTHR36070:SF1', NULL, NULL, NULL, NULL, 'OS04G0165500 PROTEIN', 241075),
(318299, 'PTHR36070', NULL, NULL, NULL, NULL, 'OSJNBA0019G23.7 PROTEIN', 241075);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(318300, 'PTHR44218:SF1', NULL, NULL, NULL, NULL, 'PROTEIN SPA1-RELATED 4', 241076),
(318301, 'PTHR44218', NULL, NULL, NULL, NULL, 'PROTEIN SPA1-RELATED 2', 241076),
(318302, 'PTHR44218:SF8', NULL, NULL, NULL, NULL, 'COATOMER BETA'' SUBUNIT (COPB2)-RELATED', 241076),
(318303, 'PTHR44218:SF9', NULL, NULL, NULL, NULL, 'SPA1-RELATED 2-RELATED', 241076),
(318304, 'PTHR44218:SF6', NULL, NULL, NULL, NULL, 'PROTEIN SUPPRESSOR OF PHYA-105 1', 241076),
(318305, 'PTHR44218:SF10', NULL, NULL, NULL, NULL, 'LIGASE COP1, PUTATIVE-RELATED', 241076),
(318306, 'PTHR44218:SF7', NULL, NULL, NULL, NULL, '', 241076),
(318307, 'PTHR44218:SF15', NULL, NULL, NULL, NULL, 'PROTEIN SPA1-RELATED 2', 241076),
(318308, 'PTHR44218:SF4', NULL, NULL, NULL, NULL, 'PROTEIN SUPPRESSOR OF PHYA-105 1-LIKE ISOFORM X1', 241076),
(318309, 'PTHR44218:SF16', NULL, NULL, NULL, NULL, '', 241076),
(318310, 'PTHR44218:SF5', NULL, NULL, NULL, NULL, 'PROTEIN SPA1-RELATED 3-LIKE ISOFORM X1', 241076),
(318311, 'PTHR44218:SF13', NULL, NULL, NULL, NULL, 'PROTEIN SPA1-RELATED 3', 241076),
(318312, 'PTHR47287:SF13', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 241077),
(318313, 'PTHR47287:SF1', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 241077),
(318314, 'PTHR47287:SF10', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 241077),
(318315, 'PTHR47287:SF11', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C2H2 FAMILY-RELATED', 241077),
(318316, 'PTHR47287:SF9', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 241077),
(318317, 'PTHR47287', NULL, NULL, NULL, NULL, 'C2H2 AND C2HC ZINC FINGERS SUPERFAMILY PROTEIN', 241077),
(318318, 'PTHR47287:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C2H2 FAMILY-RELATED', 241077),
(318319, 'PTHR47287:SF16', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 241077),
(318320, 'PTHR47287:SF14', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 241077),
(318321, 'PTHR47287:SF15', NULL, NULL, NULL, NULL, 'C2H2 AND C2HC ZINC FINGERS SUPERFAMILY PROTEIN', 241077),
(318322, 'PTHR43120:SF6', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA REDUCTASE 3, CHLOROPLASTIC-RELATED', 241078),
(318323, 'PTHR43120:SF18', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA REDUCTASE', 241078),
(318324, 'PTHR43120:SF17', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA REDUCTASE', 241078),
(318325, 'PTHR43120:SF16', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA REDUCTASE', 241078),
(318326, 'PTHR43120:SF4', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA REDUCTASE', 241078),
(318327, 'PTHR43120:SF7', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA REDUCTASE', 241078),
(318328, 'PTHR43120:SF11', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA REDUCTASE', 241078),
(318329, 'PTHR43120:SF10', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA REDUCTASE', 241078),
(318330, 'PTHR43120', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA REDUCTASE 1, CHLOROPLASTIC', 241078),
(318331, 'PTHR43120:SF1', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA REDUCTASE 1, CHLOROPLASTIC', 241078),
(318332, 'PTHR43120:SF14', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA REDUCTASE 2, CHLOROPLASTIC', 241078),
(318333, 'PTHR43120:SF12', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA REDUCTASE', 241078),
(318334, 'PTHR46357:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR ATRX', 241079),
(318335, 'PTHR46357', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR ATRX', 241079),
(318336, 'PTHR15680', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L19', 241080),
(318337, 'PTHR15680:SF18', NULL, NULL, NULL, NULL, 'BNAC09G20060D PROTEIN', 241080),
(318338, 'PTHR15680:SF9', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L19, MITOCHONDRIAL', 241080),
(318339, 'PTHR15680:SF10', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L19-1, CHLOROPLASTIC-RELATED', 241080),
(318340, 'PTHR15680:SF17', NULL, NULL, NULL, NULL, '', 241080),
(318341, 'PTHR15680:SF16', NULL, NULL, NULL, NULL, 'BNAA06G35530D PROTEIN', 241080),
(318342, 'PTHR15917', NULL, NULL, NULL, NULL, '', 241081),
(318343, 'PTHR15917:SF3', NULL, NULL, NULL, NULL, 'INHIBITORY SYNAPTIC FACTOR 1', 241081),
(318344, 'PTHR15917:SF2', NULL, NULL, NULL, NULL, '', 241081);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(318345, 'PTHR15917:SF0', NULL, NULL, NULL, NULL, 'PROTEIN LARGEN', 241081),
(318346, 'PTHR46661:SF4', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 241082),
(318347, 'PTHR46661', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ZNRF1-LIKE PROTEIN', 241082),
(318348, 'PTHR46661:SF3', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ZNRF2', 241082),
(318349, 'PTHR46661:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ZNRF1', 241082),
(318350, 'PTHR46661:SF1', NULL, NULL, NULL, NULL, 'ZGC:66427', 241082),
(318351, 'PTHR32343:SF61', NULL, NULL, NULL, NULL, 'RNA BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN-RELATED', 241083),
(318352, 'PTHR32343:SF82', NULL, NULL, NULL, NULL, 'OS02G0244600 PROTEIN', 241083),
(318353, 'PTHR32343:SF81', NULL, NULL, NULL, NULL, '', 241083),
(318354, 'PTHR32343:SF80', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-BINDING ALPHA-BETA PLAIT DOMAIN-CONTAINING PROTEIN-RELATED', 241083),
(318355, 'PTHR32343:SF9', NULL, NULL, NULL, NULL, 'RRM-CONTAINING PROTEIN-RELATED', 241083),
(318356, 'PTHR32343:SF8', NULL, NULL, NULL, NULL, 'LD29830P', 241083),
(318357, 'PTHR32343:SF63', NULL, NULL, NULL, NULL, 'ATAXIN-2, NUCLEOTIDE-BINDING ALPHA-BETA PLAIT DOMAIN PROTEIN-RELATED', 241083),
(318358, 'PTHR32343:SF62', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 241083),
(318359, 'PTHR32343:SF69', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN', 241083),
(318360, 'PTHR32343:SF24', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN-INTERACTING PROTEIN 10', 241083),
(318361, 'PTHR32343:SF46', NULL, NULL, NULL, NULL, 'BINDING PARTNER OF ACD11 1-LIKE ISOFORM X1', 241083),
(318362, 'PTHR32343:SF68', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 241083),
(318363, 'PTHR32343:SF67', NULL, NULL, NULL, NULL, 'OS01G0209400 PROTEIN', 241083),
(318364, 'PTHR32343:SF22', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN-INTERACTING PROTEIN 9', 241083),
(318365, 'PTHR32343:SF44', NULL, NULL, NULL, NULL, 'PROTEIN VIP1-LIKE', 241083),
(318366, 'PTHR32343:SF29', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 241083),
(318367, 'PTHR32343:SF28', NULL, NULL, NULL, NULL, 'OS04G0624800 PROTEIN', 241083),
(318368, 'PTHR32343:SF49', NULL, NULL, NULL, NULL, 'BNAA06G00790D PROTEIN', 241083),
(318369, 'PTHR32343:SF48', NULL, NULL, NULL, NULL, 'BNAA09G04880D PROTEIN', 241083),
(318370, 'PTHR32343:SF26', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 241083),
(318371, 'PTHR32343:SF6', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR 11', 241083),
(318372, 'PTHR32343:SF72', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN-INTERACTING PROTEIN 11', 241083),
(318373, 'PTHR32343:SF71', NULL, NULL, NULL, NULL, 'SPLICING REGULATORY GLUTAMINE/LYSINE-RICH PROTEIN 1', 241083),
(318374, 'PTHR32343:SF70', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 241083),
(318375, 'PTHR32343:SF32', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN-INTERACTING PROTEIN 13', 241083),
(318376, 'PTHR32343:SF10', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 241083),
(318377, 'PTHR32343:SF54', NULL, NULL, NULL, NULL, 'BNAANNG17810D PROTEIN', 241083),
(318378, 'PTHR32343:SF75', NULL, NULL, NULL, NULL, 'OS04G0594400 PROTEIN', 241083),
(318379, 'PTHR32343:SF74', NULL, NULL, NULL, NULL, 'RRM-CONTAINING PROTEIN-RELATED', 241083),
(318380, 'PTHR32343:SF30', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN-INTERACTING PROTEIN 12', 241083),
(318381, 'PTHR32343:SF52', NULL, NULL, NULL, NULL, 'CTC-INTERACTING DOMAIN 8-RELATED', 241083),
(318382, 'PTHR32343:SF73', NULL, NULL, NULL, NULL, 'BNACNNG52570D PROTEIN', 241083),
(318383, 'PTHR32343:SF36', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN-INTERACTING PROTEIN 10-LIKE', 241083),
(318384, 'PTHR32343:SF57', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 241083),
(318385, 'PTHR32343:SF79', NULL, NULL, NULL, NULL, 'CTC-INTERACTING DOMAIN PROTEIN', 241083),
(318386, 'PTHR32343:SF78', NULL, NULL, NULL, NULL, 'BNAA09G04860D PROTEIN', 241083); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(318387, 'PTHR32343:SF34', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN-INTERACTING PROTEIN 8', 241083),
(318388, 'PTHR32343:SF33', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN-INTERACTING PROTEIN 8-LIKE', 241083),
(318389, 'PTHR32343:SF77', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN-INTERACTING PROTEIN 11-LIKE ISOFORM X1', 241083),
(318390, 'PTHR32343:SF16', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 241083),
(318391, 'PTHR32343:SF38', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN-INTERACTING PROTEIN 8-LIKE ISOFORM X1', 241083),
(318392, 'PTHR32343:SF59', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN-INTERACTING PROTEIN 11-LIKE', 241083),
(318393, 'PTHR32343:SF37', NULL, NULL, NULL, NULL, 'BINDING PARTNER OF ACD11 1', 241083),
(318394, 'PTHR32343:SF19', NULL, NULL, NULL, NULL, 'OS11G0549537 PROTEIN', 241083),
(318395, 'PTHR32343', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR', 241083),
(318396, 'PTHR47832:SF1', NULL, NULL, NULL, NULL, 'DNA PHOTOLYASE', 241084),
(318397, 'PTHR47832', NULL, NULL, NULL, NULL, 'DNA PHOTOLYASE', 241084),
(318398, 'PTHR31714', NULL, NULL, NULL, NULL, 'F-BOX ASSOCIATED UBIQUITINATION EFFECTOR FAMILY PROTEIN-RELATED', 241085),
(318399, 'PTHR31714:SF10', NULL, NULL, NULL, NULL, 'F-BOX ASSOCIATED UBIQUITINATION EFFECTOR FAMILY PROTEIN-RELATED', 241085),
(318400, 'PTHR32217', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 6H', 241086),
(318401, 'PTHR32217:SF3', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 6 COMPLEX, LOCUS G2-RELATED', 241086),
(318402, 'PTHR32217:SF2', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 6L', 241086),
(318403, 'PTHR32217:SF5', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 6H', 241086),
(318404, 'PTHR47574:SF4', NULL, NULL, NULL, NULL, 'CHROMO DOMAIN-CONTAINING PROTEIN', 241087),
(318405, 'PTHR47574', NULL, NULL, NULL, NULL, 'CANCER-RELATED REGULATOR OF ACTIN DYNAMICS', 241087),
(318406, 'PTHR47574:SF3', NULL, NULL, NULL, NULL, 'CAPPING PROTEIN-INHIBITING REGULATOR OF ACTIN DYNAMICS', 241087),
(318407, 'PTHR28268:SF1', NULL, NULL, NULL, NULL, 'MICOS SUBUNIT MIC26', 241088),
(318408, 'PTHR28268', NULL, NULL, NULL, NULL, 'MICOS SUBUNIT MIC26', 241088),
(318409, 'PTHR40621:SF6', NULL, NULL, NULL, NULL, 'AP-1-LIKE TRANSCRIPTION FACTOR YAP1-RELATED', 241089),
(318410, 'PTHR40621:SF10', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 241089),
(318411, 'PTHR40621:SF7', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 241089),
(318412, 'PTHR40621:SF8', NULL, NULL, NULL, NULL, 'AP-1-LIKE TRANSCRIPTION FACTOR YAP3', 241089),
(318413, 'PTHR40621:SF9', NULL, NULL, NULL, NULL, 'MEAB PROTEIN', 241089),
(318414, 'PTHR40621:SF3', NULL, NULL, NULL, NULL, 'BZIP-TYPE TRANSCRIPTION FACTOR-RELATED', 241089),
(318415, 'PTHR40621', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR KAPC-RELATED', 241089),
(318416, 'PTHR30006', NULL, NULL, NULL, NULL, 'THIAMINE-BINDING PERIPLASMIC PROTEIN-RELATED', 241090),
(318417, 'PTHR30006:SF3', NULL, NULL, NULL, NULL, 'THIAMINE-BINDING PERIPLASMIC PROTEIN', 241090),
(318418, 'PTHR30006:SF2', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER SUBSTRATE-BINDING PROTEIN', 241090),
(318419, 'PTHR30006:SF24', NULL, NULL, NULL, NULL, 'ABC-TYPE IRON(III) TRANSPORT SYSTEM, PERIPLASMIC COMPONENT', 241090),
(318420, 'PTHR30006:SF25', NULL, NULL, NULL, NULL, 'EXPORTED PROTEIN-RELATED', 241090),
(318421, 'PTHR30006:SF15', NULL, NULL, NULL, NULL, 'IRON-UTILIZATION PERIPLASMIC PROTEIN', 241090),
(318422, 'PTHR30006:SF21', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE TRANSPORT REGULATORY PROTEIN PGTC', 241090),
(318423, 'PTHR34098:SF1', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 47', 241091),
(318424, 'PTHR34098:SF2', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 241091),
(318425, 'PTHR34098', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 47', 241091),
(318426, 'PTHR43616', NULL, NULL, NULL, NULL, 'GLYCEROL DEHYDROGENASE', 241092),
(318427, 'PTHR43616:SF3', NULL, NULL, NULL, NULL, 'HYDROXYCARBOXYLATE DEHYDROGENASE A', 241092),
(318428, 'PTHR43616:SF5', NULL, NULL, NULL, NULL, 'GLYCEROL DEHYDROGENASE 1', 241092);
INSERT INTO "PUBLIC"."MODEL" VALUES
(318429, 'PTHR19346:SF4', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 241093),
(318430, 'PTHR19346:SF3', NULL, NULL, NULL, NULL, 'THIAMINE TRANSPORTER SLC35F3-RELATED', 241093),
(318431, 'PTHR19346:SF2', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 35 MEMBER F4', 241093),
(318432, 'PTHR19346', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 241093),
(318433, 'PTHR34114:SF15', NULL, NULL, NULL, NULL, 'BNAC05G39800D PROTEIN', 241094),
(318434, 'PTHR34114:SF16', NULL, NULL, NULL, NULL, 'BNAA05G13800D PROTEIN', 241094),
(318435, 'PTHR34114:SF17', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN PROTEIN 13-RELATED', 241094),
(318436, 'PTHR34114:SF11', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN PEPTIDE 13', 241094),
(318437, 'PTHR34114:SF12', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN PEPTIDE 1', 241094),
(318438, 'PTHR34114:SF13', NULL, NULL, NULL, NULL, 'BNAA06G00380D PROTEIN', 241094),
(318439, 'PTHR34114:SF14', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN PEPTIDE 3', 241094),
(318440, 'PTHR34114:SF20', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN PEPTIDE 14-LIKE', 241094),
(318441, 'PTHR34114:SF10', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN PROTEIN 12', 241094),
(318442, 'PTHR34114:SF8', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 241094),
(318443, 'PTHR34114:SF3', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN PEPTIDE 3', 241094),
(318444, 'PTHR34114:SF7', NULL, NULL, NULL, NULL, '', 241094),
(318445, 'PTHR34114:SF4', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN PROTEIN 21', 241094),
(318446, 'PTHR34114:SF19', NULL, NULL, NULL, NULL, 'BNAA02G08570D PROTEIN', 241094),
(318447, 'PTHR34114', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN PEPTIDE 1', 241094),
(318448, 'PTHR19309', NULL, NULL, NULL, NULL, 'GASTRIN', 241095),
(318449, 'PTHR19309:SF0', NULL, NULL, NULL, NULL, 'GASTRIN', 241095),
(318450, 'PTHR28580:SF1', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR IIH SUBUNIT 5', 241096),
(318451, 'PTHR28580:SF3', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II TRANSCRIPTION FACTOR B SUBUNIT 5', 241096),
(318452, 'PTHR28580', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR IIH SUBUNIT 5', 241096),
(318453, 'PTHR11441:SF0', NULL, NULL, NULL, NULL, 'THYMIDINE KINASE, CYTOSOLIC', 241097),
(318454, 'PTHR11441:SF11', NULL, NULL, NULL, NULL, 'THYMIDINE KINASE B', 241097),
(318455, 'PTHR11441:SF10', NULL, NULL, NULL, NULL, 'THYMIDINE KINASE', 241097),
(318456, 'PTHR11441:SF3', NULL, NULL, NULL, NULL, 'THYMIDINE KINASE', 241097),
(318457, 'PTHR11441:SF5', NULL, NULL, NULL, NULL, 'THYMIDINE KINASE', 241097),
(318458, 'PTHR11441', NULL, NULL, NULL, NULL, 'THYMIDINE KINASE', 241097),
(318459, 'PTHR23009', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 241098),
(318460, 'PTHR23009:SF2', NULL, NULL, NULL, NULL, 'HISTIDINE-RICH CARBOXYL TERMINUS PROTEIN 1', 241098),
(318461, 'PTHR24208:SF175', NULL, NULL, NULL, NULL, 'FI06571P', 241099),
(318462, 'PTHR24208:SF121', NULL, NULL, NULL, NULL, 'LIM/HOMEOBOX PROTEIN LHX6', 241099),
(318463, 'PTHR24208:SF166', NULL, NULL, NULL, NULL, 'LIM HOMEOBOX TRANSCRIPTION FACTOR 1 ALPHA, ISOFORM B', 241099),
(318464, 'PTHR24208', NULL, NULL, NULL, NULL, 'LIM/HOMEOBOX PROTEIN LHX', 241099),
(318465, 'PTHR24208:SF80', NULL, NULL, NULL, NULL, 'LIM/HOMEOBOX PROTEIN LHX2', 241099),
(318466, 'PTHR24208:SF91', NULL, NULL, NULL, NULL, 'LIM/HOMEOBOX PROTEIN LHX3', 241099),
(318467, 'PTHR24208:SF170', NULL, NULL, NULL, NULL, 'MECHANOSENSORY PROTEIN 3', 241099),
(318468, 'PTHR24208:SF95', NULL, NULL, NULL, NULL, 'LIM/HOMEOBOX PROTEIN LHX9', 241099),
(318469, 'PTHR24208:SF96', NULL, NULL, NULL, NULL, 'LIM HOMEOBOX TRANSCRIPTION FACTOR 1-BETA', 241099),
(318470, 'PTHR24208:SF88', NULL, NULL, NULL, NULL, 'LIM HOMEOBOX TRANSCRIPTION FACTOR 1-ALPHA', 241099),
(318471, 'PTHR24208:SF106', NULL, NULL, NULL, NULL, 'LIM/HOMEOBOX PROTEIN LHX1', 241099),
(318472, 'PTHR24208:SF128', NULL, NULL, NULL, NULL, 'LIM3, ISOFORM G', 241099),
(318473, 'PTHR24208:SF117', NULL, NULL, NULL, NULL, 'LIM/HOMEOBOX PROTEIN LHX8', 241099),
(318474, 'PTHR24208:SF118', NULL, NULL, NULL, NULL, 'LIM HOMEOBOX TRANSCRIPTION FACTOR 1, ALPHA-LIKE', 241099);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(318475, 'PTHR24208:SF168', NULL, NULL, NULL, NULL, 'PROTEIN APTEROUS', 241099),
(318476, 'PTHR24208:SF115', NULL, NULL, NULL, NULL, 'LIM/HOMEOBOX PROTEIN LHX5', 241099),
(318477, 'PTHR24208:SF127', NULL, NULL, NULL, NULL, 'LIM/HOMEOBOX PROTEIN AWH', 241099),
(318478, 'PTHR24208:SF105', NULL, NULL, NULL, NULL, 'DLIM1', 241099),
(318479, 'PTHR24208:SF116', NULL, NULL, NULL, NULL, 'LIM/HOMEOBOX PROTEIN LHX4', 241099),
(318480, 'PTHR37784:SF2', NULL, NULL, NULL, NULL, 'PROTEIN MSN1', 241100),
(318481, 'PTHR37784:SF1', NULL, NULL, NULL, NULL, 'GLYCOLYTIC GENES TRANSCRIPTIONAL ACTIVATOR GCR1', 241100),
(318482, 'PTHR37784', NULL, NULL, NULL, NULL, 'PROTEIN MSN1', 241100),
(318483, 'PTHR37784:SF7', NULL, NULL, NULL, NULL, 'HIGH-OSMOLARITY-INDUCED TRANSCRIPTION PROTEIN 1', 241100),
(318484, 'PTHR37784:SF4', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR-LIKE PROTEIN EUC1', 241100),
(318485, 'PTHR36878:SF1', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 30', 241101),
(318486, 'PTHR36878', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 30', 241101),
(318487, 'PTHR28664:SF3', NULL, NULL, NULL, NULL, 'TIGHT JUNCTION-ASSOCIATED PROTEIN 1', 241102),
(318488, 'PTHR28664:SF4', NULL, NULL, NULL, NULL, '', 241102),
(318489, 'PTHR28664:SF2', NULL, NULL, NULL, NULL, 'BRAIN-ENRICHED GUANYLATE KINASE-ASSOCIATED PROTEIN', 241102),
(318490, 'PTHR28664:SF5', NULL, NULL, NULL, NULL, '', 241102),
(318491, 'PTHR28664', NULL, NULL, NULL, NULL, 'TIGHT JUNCTION-ASSOCIATED PROTEIN 1', 241102),
(318492, 'PTHR48211:SF1', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 241103),
(318493, 'PTHR48211', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 241103),
(318494, 'PTHR35339', NULL, NULL, NULL, NULL, '', 241104),
(318495, 'PTHR35339:SF3', NULL, NULL, NULL, NULL, '', 241104),
(318496, 'PTHR35339:SF2', NULL, NULL, NULL, NULL, '', 241104),
(318497, 'PTHR35339:SF4', NULL, NULL, NULL, NULL, '', 241104),
(318498, 'PTHR12510', NULL, NULL, NULL, NULL, 'TROPONIN C-AKIN-1 PROTEIN', 241105),
(318499, 'PTHR12510:SF16', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYLCYCLOTRANSFERASE FAMILY PROTEIN', 241105),
(318500, 'PTHR12510:SF4', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYLAMINECYCLOTRANSFERASE', 241105),
(318501, 'PTHR12510:SF15', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYLCYCLOTRANSFERASE FAMILY PROTEIN', 241105),
(318502, 'PTHR12510:SF5', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYLCYCLOTRANSFERASE FAMILY PROTEIN', 241105),
(318503, 'PTHR12510:SF17', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYLCYCLOTRANSFERASE FAMILY PROTEIN', 241105),
(318504, 'PTHR48104:SF8', NULL, NULL, NULL, NULL, 'METACASPASE-5', 241106),
(318505, 'PTHR48104:SF7', NULL, NULL, NULL, NULL, 'METACASPASE-9', 241106),
(318506, 'PTHR48104:SF6', NULL, NULL, NULL, NULL, 'ZF-LSD1 DOMAIN-CONTAINING PROTEIN', 241106),
(318507, 'PTHR48104:SF3', NULL, NULL, NULL, NULL, 'METACASPASE TYPE II', 241106),
(318508, 'PTHR48104:SF40', NULL, NULL, NULL, NULL, 'LATEX-ABUNDANT PROTEIN-LIKE PROTEIN', 241106),
(318509, 'PTHR48104:SF2', NULL, NULL, NULL, NULL, 'ICE-LIKE PROTEASE (CASPASE) P20 DOMAIN PROTEIN', 241106),
(318510, 'PTHR48104:SF41', NULL, NULL, NULL, NULL, 'METACASPASE FAMILY PROTEIN-RELATED', 241106),
(318511, 'PTHR48104:SF20', NULL, NULL, NULL, NULL, 'METACASPASE-6', 241106),
(318512, 'PTHR48104:SF42', NULL, NULL, NULL, NULL, 'OS03G0389000 PROTEIN', 241106),
(318513, 'PTHR48104:SF43', NULL, NULL, NULL, NULL, 'BNAA02G34110D PROTEIN', 241106),
(318514, 'PTHR48104', NULL, NULL, NULL, NULL, 'METACASPASE-4', 241106),
(318515, 'PTHR48104:SF44', NULL, NULL, NULL, NULL, 'CASPASE-LIKE DOMAIN PROTEIN-RELATED', 241106),
(318516, 'PTHR48104:SF22', NULL, NULL, NULL, NULL, 'METACASPASE-1-LIKE', 241106),
(318517, 'PTHR48104:SF23', NULL, NULL, NULL, NULL, 'METACASPASE (EUROFUNG)', 241106),
(318518, 'PTHR48104:SF45', NULL, NULL, NULL, NULL, 'METACASPASE-2', 241106),
(318519, 'PTHR48104:SF24', NULL, NULL, NULL, NULL, 'ICE-LIKE PROTEASE P20 DOMAIN CONTAINING PROTEIN, EXPRESSED', 241106),
(318520, 'PTHR48104:SF46', NULL, NULL, NULL, NULL, 'METACASPASE 8-RELATED', 241106),
(318521, 'PTHR48104:SF27', NULL, NULL, NULL, NULL, '', 241106);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(318522, 'PTHR48104:SF30', NULL, NULL, NULL, NULL, 'METACASPASE-1', 241106),
(318523, 'PTHR48104:SF10', NULL, NULL, NULL, NULL, 'ZF-LSD1 DOMAIN-CONTAINING PROTEIN', 241106),
(318524, 'PTHR48104:SF32', NULL, NULL, NULL, NULL, 'ZF-LSD1 DOMAIN-CONTAINING PROTEIN', 241106),
(318525, 'PTHR48104:SF33', NULL, NULL, NULL, NULL, 'ZINC FINGER, LSD1-TYPE, CASPASE-LIKE DOMAIN PROTEIN-RELATED', 241106),
(318526, 'PTHR48104:SF11', NULL, NULL, NULL, NULL, 'ICE-LIKE PROTEASE (CASPASE) P20 DOMAIN PROTEIN', 241106),
(318527, 'PTHR48104:SF12', NULL, NULL, NULL, NULL, 'BNAA09G10690D PROTEIN', 241106),
(318528, 'PTHR48104:SF13', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 241106),
(318529, 'PTHR48104:SF36', NULL, NULL, NULL, NULL, 'ICE-LIKE PROTEASE P20 DOMAIN CONTAINING PROTEIN, EXPRESSED', 241106),
(318530, 'PTHR48104:SF14', NULL, NULL, NULL, NULL, 'METACASPASE-7', 241106),
(318531, 'PTHR48104:SF15', NULL, NULL, NULL, NULL, '', 241106),
(318532, 'PTHR48104:SF37', NULL, NULL, NULL, NULL, 'ZF-LSD1 DOMAIN-CONTAINING PROTEIN', 241106),
(318533, 'PTHR48104:SF16', NULL, NULL, NULL, NULL, '', 241106),
(318534, 'PTHR48104:SF17', NULL, NULL, NULL, NULL, 'METACASPASE-3', 241106),
(318535, 'PTHR48104:SF18', NULL, NULL, NULL, NULL, 'METACASPASE-8', 241106),
(318536, 'PTHR48104:SF19', NULL, NULL, NULL, NULL, 'ZF-LSD1 DOMAIN-CONTAINING PROTEIN', 241106),
(318537, 'PTHR13822:SF15', NULL, NULL, NULL, NULL, 'ATP-SYNT_DE_N DOMAIN-CONTAINING PROTEIN', 241107),
(318538, 'PTHR13822:SF14', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT DELTA'', MITOCHONDRIAL-LIKE', 241107),
(318539, 'PTHR13822:SF17', NULL, NULL, NULL, NULL, 'ATP-SYNT_DE_N DOMAIN-CONTAINING PROTEIN', 241107),
(318540, 'PTHR13822:SF16', NULL, NULL, NULL, NULL, 'ATP-SYNT_DE_N DOMAIN-CONTAINING PROTEIN', 241107),
(318541, 'PTHR13822', NULL, NULL, NULL, NULL, 'ATP SYNTHASE DELTA/EPSILON CHAIN', 241107),
(318542, 'PTHR13822:SF7', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT DELTA, MITOCHONDRIAL', 241107),
(318543, 'PTHR13822:SF22', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT DELTA'', MITOCHONDRIAL', 241107),
(318544, 'PTHR13822:SF10', NULL, NULL, NULL, NULL, 'ATP SYNTHASE EPSILON CHAIN, CHLOROPLASTIC', 241107),
(318545, 'PTHR13822:SF24', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT DELTA'', MITOCHONDRIAL-LIKE', 241107),
(318546, 'PTHR13822:SF23', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT DELTA'', MITOCHONDRIAL-LIKE', 241107),
(318547, 'PTHR33432:SF27', NULL, NULL, NULL, NULL, 'PROTEIN EMSY-LIKE 3', 241108),
(318548, 'PTHR33432:SF26', NULL, NULL, NULL, NULL, 'BNAC06G15990D PROTEIN', 241108),
(318549, 'PTHR33432:SF15', NULL, NULL, NULL, NULL, 'EMSY N TERMINUS (ENT)/ PLANT TUDOR-LIKE DOMAINS-CONTAINING PROTEIN', 241108),
(318550, 'PTHR33432:SF29', NULL, NULL, NULL, NULL, 'PROTEIN EMSY-LIKE 3-LIKE', 241108),
(318551, 'PTHR33432:SF28', NULL, NULL, NULL, NULL, 'PROTEIN EMSY-LIKE 4', 241108),
(318552, 'PTHR33432:SF17', NULL, NULL, NULL, NULL, 'EMSY N TERMINUS (ENT) DOMAIN-CONTAINING PROTEIN', 241108),
(318553, 'PTHR33432:SF34', NULL, NULL, NULL, NULL, 'PROTEIN EMSY-LIKE 2', 241108),
(318554, 'PTHR33432:SF23', NULL, NULL, NULL, NULL, 'ENT DOMAIN-CONTAINING PROTEIN', 241108),
(318555, 'PTHR33432:SF22', NULL, NULL, NULL, NULL, 'OS10G0436850 PROTEIN', 241108),
(318556, 'PTHR33432:SF33', NULL, NULL, NULL, NULL, 'PLANT TUDOR-LIKE RNA-BINDING PROTEIN', 241108),
(318557, 'PTHR33432:SF36', NULL, NULL, NULL, NULL, 'BNAA04G14470D PROTEIN', 241108),
(318558, 'PTHR33432:SF35', NULL, NULL, NULL, NULL, 'OS01G0611200 PROTEIN', 241108),
(318559, 'PTHR33432:SF30', NULL, NULL, NULL, NULL, 'OS07G0179500 PROTEIN', 241108),
(318560, 'PTHR33432:SF32', NULL, NULL, NULL, NULL, 'ENT DOMAIN-CONTAINING PROTEIN', 241108),
(318561, 'PTHR33432:SF31', NULL, NULL, NULL, NULL, 'OS04G0659400 PROTEIN', 241108),
(318562, 'PTHR33432:SF20', NULL, NULL, NULL, NULL, 'PROTEIN EMSY-LIKE 1', 241108),
(318563, 'PTHR33432:SF2', NULL, NULL, NULL, NULL, 'R-INTERACTING FACTOR 1', 241108),
(318564, 'PTHR33432:SF4', NULL, NULL, NULL, NULL, 'OS08G0510500 PROTEIN', 241108),
(318565, 'PTHR33432', NULL, NULL, NULL, NULL, 'PROTEIN EMSY-LIKE 4', 241108);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(318566, 'PTHR40552:SF6', NULL, NULL, NULL, NULL, 'FI09606P-RELATED', 241109),
(318567, 'PTHR40552', NULL, NULL, NULL, NULL, 'AT05186P-RELATED', 241109),
(318568, 'PTHR46993:SF6', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 241110),
(318569, 'PTHR46993:SF7', NULL, NULL, NULL, NULL, 'MYB-LIKE HTH TRANSCRIPTIONAL REGULATOR FAMILY PROTEIN', 241110),
(318570, 'PTHR46993:SF2', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 241110),
(318571, 'PTHR46993:SF4', NULL, NULL, NULL, NULL, 'MYB-LIKE HTH TRANSCRIPTIONAL REGULATOR FAMILY PROTEIN', 241110),
(318572, 'PTHR46993', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 241110),
(318573, 'PTHR46993:SF11', NULL, NULL, NULL, NULL, 'OS06G0181300 PROTEIN', 241110),
(318574, 'PTHR46993:SF12', NULL, NULL, NULL, NULL, 'MYB-LIKE DNA-BINDING DOMAIN PROTEIN', 241110),
(318575, 'PTHR11904:SF9', NULL, NULL, NULL, NULL, 'INOSINE PHOSPHORYLASE-RELATED', 241111),
(318576, 'PTHR11904:SF12', NULL, NULL, NULL, NULL, 'PURINE NUCLEOSIDE PHOSPHORYLASE', 241111),
(318577, 'PTHR11904', NULL, NULL, NULL, NULL, 'METHYLTHIOADENOSINE/PURINE NUCLEOSIDE PHOSPHORYLASE', 241111),
(318578, 'PTHR11904:SF26', NULL, NULL, NULL, NULL, 'PURINE NUCLEOSIDE PHOSPHORYLASE', 241111),
(318579, 'PTHR11904:SF24', NULL, NULL, NULL, NULL, 'PURINE NUCLEOSIDE PHOSPHORYLASE', 241111),
(318580, 'PTHR11904:SF13', NULL, NULL, NULL, NULL, 'PURINE NUCLEOSIDE PHOSPHORYLASE', 241111),
(318581, 'PTHR31705:SF4', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 30', 241112),
(318582, 'PTHR31705', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 30', 241112),
(318583, 'PTHR31705:SF5', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 30', 241112),
(318584, 'PTHR31705:SF6', NULL, NULL, NULL, NULL, 'MEDIATOR COMPLEX SUBUNIT 30', 241112),
(318585, 'PTHR12872:SF1', NULL, NULL, NULL, NULL, 'ALPHA-N-ACETYLGLUCOSAMINIDASE', 241113),
(318586, 'PTHR12872:SF3', NULL, NULL, NULL, NULL, 'ALPHA-N-ACETYLGLUCOSAMINIDASE', 241113),
(318587, 'PTHR12872', NULL, NULL, NULL, NULL, 'ALPHA-N-ACETYLGLUCOSAMINIDASE', 241113),
(318588, 'PTHR34493:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG13422', 241114),
(318589, 'PTHR34493:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG24986', 241114),
(318590, 'PTHR34493:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG18576', 241114),
(318591, 'PTHR34493:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG02471', 241114),
(318592, 'PTHR34493', NULL, NULL, NULL, NULL, 'PROTEIN CBG13422-RELATED', 241114),
(318593, 'PTHR34493:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG09625', 241114),
(318594, 'PTHR34493:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG09274', 241114),
(318595, 'PTHR34493:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBR-SPE-27', 241114),
(318596, 'PTHR46444:SF9', NULL, NULL, NULL, NULL, 'DCD (DEVELOPMENT AND CELL DEATH) DOMAIN PROTEIN', 241115),
(318597, 'PTHR46444:SF18', NULL, NULL, NULL, NULL, 'DCD DOMAIN-CONTAINING PROTEIN', 241115),
(318598, 'PTHR46444:SF19', NULL, NULL, NULL, NULL, 'OS02G0745600 PROTEIN', 241115),
(318599, 'PTHR46444:SF14', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241115),
(318600, 'PTHR46444:SF4', NULL, NULL, NULL, NULL, 'OS06G0227200 PROTEIN', 241115),
(318601, 'PTHR46444:SF3', NULL, NULL, NULL, NULL, 'DCD (DEVELOPMENT AND CELL DEATH) DOMAIN PROTEIN', 241115),
(318602, 'PTHR46444:SF17', NULL, NULL, NULL, NULL, 'DCD (DEVELOPMENT AND CELL DEATH) DOMAIN PROTEIN', 241115),
(318603, 'PTHR46444:SF8', NULL, NULL, NULL, NULL, 'DCD DOMAIN-CONTAINING PROTEIN', 241115),
(318604, 'PTHR46444:SF11', NULL, NULL, NULL, NULL, 'DCD DOMAIN-CONTAINING PROTEIN', 241115),
(318605, 'PTHR46444', NULL, NULL, NULL, NULL, 'DCD (DEVELOPMENT AND CELL DEATH) DOMAIN PROTEIN-RELATED', 241115),
(318606, 'PTHR46444:SF7', NULL, NULL, NULL, NULL, 'DCD (DEVELOPMENT AND CELL DEATH) DOMAIN PROTEIN', 241115),
(318607, 'PTHR46979', NULL, NULL, NULL, NULL, 'SORTING NEXIN-41', 241116),
(318608, 'PTHR46979:SF3', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 20', 241116),
(318609, 'PTHR46979:SF2', NULL, NULL, NULL, NULL, 'SORTING NEXIN-41', 241116);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(318610, 'PTHR46979:SF1', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 20', 241116),
(318611, 'PTHR43449:SF3', NULL, NULL, NULL, NULL, 'NTP_TRANSF_2 DOMAIN-CONTAINING PROTEIN', 241117),
(318612, 'PTHR43449', NULL, NULL, NULL, NULL, 'NUCLEOTIDYLTRANSFERASE', 241117),
(318613, 'PTHR43449:SF1', NULL, NULL, NULL, NULL, 'NTP_TRANSF_2 DOMAIN-CONTAINING PROTEIN', 241117),
(318614, 'PTHR12983:SF9', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 10', 241118),
(318615, 'PTHR12983', NULL, NULL, NULL, NULL, 'RING FINGER 10 FAMILY MEMBER', 241118),
(318616, 'PTHR42658:SF1', NULL, NULL, NULL, NULL, '', 241119),
(318617, 'PTHR42658', NULL, NULL, NULL, NULL, '', 241119),
(318618, 'PTHR35977', NULL, NULL, NULL, NULL, 'CHROMOSOME 16 OPEN READING FRAME 71', 241120),
(318619, 'PTHR35977:SF1', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL ASSEMBLY FACTOR 8', 241120),
(318620, 'PTHR36015', NULL, NULL, NULL, NULL, 'HOLLIDAY JUNCTION RESOLVASE MOC1, CHLOROPLASTIC-RELATED', 241121),
(318621, 'PTHR36015:SF6', NULL, NULL, NULL, NULL, 'HOLLIDAY JUNCTION RESOLVASE MOC1, CHLOROPLASTIC-RELATED', 241121),
(318622, 'PTHR35895:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 16, WHOLE GENOME SHOTGUN SEQUENCE', 241122),
(318623, 'PTHR35895:SF2', NULL, NULL, NULL, NULL, '', 241122),
(318624, 'PTHR35895:SF3', NULL, NULL, NULL, NULL, '', 241122),
(318625, 'PTHR35895', NULL, NULL, NULL, NULL, 'CHROMOSOME 16, WHOLE GENOME SHOTGUN SEQUENCE', 241122),
(318626, 'PTHR13884:SF16', NULL, NULL, NULL, NULL, 'DUF853 DOMAIN-CONTAINING PROTEIN', 241123),
(318627, 'PTHR13884', NULL, NULL, NULL, NULL, 'DUF853 DOMAIN-CONTAINING PROTEIN', 241123),
(318628, 'PTHR13884:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG13449', 241123),
(318629, 'PTHR47573', NULL, NULL, NULL, NULL, 'PROTEIN AF-9 HOMOLOG', 241124),
(318630, 'PTHR47573:SF1', NULL, NULL, NULL, NULL, 'PROTEIN AF-9 HOMOLOG', 241124),
(318631, 'PTHR41913', NULL, NULL, NULL, NULL, '', 241125),
(318632, 'PTHR41913:SF1', NULL, NULL, NULL, NULL, '', 241125),
(318633, 'PTHR22298:SF174', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318634, 'PTHR22298:SF130', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318635, 'PTHR22298:SF176', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318636, 'PTHR22298:SF132', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318637, 'PTHR22298:SF177', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318638, 'PTHR22298:SF170', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318639, 'PTHR22298:SF171', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 10', 241126),
(318640, 'PTHR22298:SF41', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 5', 241126),
(318641, 'PTHR22298:SF138', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318642, 'PTHR22298', NULL, NULL, NULL, NULL, 'ENDO-1,4-BETA-GLUCANASE', 241126),
(318643, 'PTHR22298:SF43', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 22', 241126),
(318644, 'PTHR22298:SF139', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318645, 'PTHR22298:SF178', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318646, 'PTHR22298:SF46', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 15', 241126),
(318647, 'PTHR22298:SF134', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318648, 'PTHR22298:SF135', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 19', 241126),
(318649, 'PTHR22298:SF179', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318650, 'PTHR22298:SF136', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318651, 'PTHR22298:SF180', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318652, 'PTHR22298:SF165', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318653, 'PTHR22298:SF121', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 18', 241126),
(318654, 'PTHR22298:SF166', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318655, 'PTHR22298:SF122', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 4', 241126),
(318656, 'PTHR22298:SF160', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318657, 'PTHR22298:SF161', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318658, 'PTHR22298:SF128', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 10', 241126),
(318659, 'PTHR22298:SF129', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 24', 241126);
INSERT INTO "PUBLIC"."MODEL" VALUES
(318660, 'PTHR22298:SF36', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 9', 241126),
(318661, 'PTHR22298:SF124', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 1', 241126),
(318662, 'PTHR22298:SF168', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318663, 'PTHR22298:SF125', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 12-RELATED', 241126),
(318664, 'PTHR22298:SF152', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318665, 'PTHR22298:SF153', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318666, 'PTHR22298:SF154', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318667, 'PTHR22298:SF111', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 3', 241126),
(318668, 'PTHR22298:SF60', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318669, 'PTHR22298:SF151', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318670, 'PTHR22298:SF116', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 21', 241126),
(318671, 'PTHR22298:SF64', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 7', 241126),
(318672, 'PTHR22298:SF118', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 23', 241126),
(318673, 'PTHR22298:SF22', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 18-RELATED', 241126),
(318674, 'PTHR22298:SF23', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 11', 241126),
(318675, 'PTHR22298:SF26', NULL, NULL, NULL, NULL, 'CELLULASE', 241126),
(318676, 'PTHR22298:SF114', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 2', 241126),
(318677, 'PTHR22298:SF158', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318678, 'PTHR22298:SF159', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318679, 'PTHR22298:SF115', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318680, 'PTHR22298:SF28', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 8', 241126),
(318681, 'PTHR22298:SF29', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318682, 'PTHR22298:SF141', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318683, 'PTHR22298:SF185', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 25', 241126),
(318684, 'PTHR22298:SF186', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318685, 'PTHR22298:SF187', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318686, 'PTHR22298:SF144', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318687, 'PTHR22298:SF181', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318688, 'PTHR22298:SF182', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318689, 'PTHR22298:SF183', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318690, 'PTHR22298:SF184', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 17', 241126),
(318691, 'PTHR22298:SF52', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 16', 241126),
(318692, 'PTHR22298:SF140', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318693, 'PTHR22298:SF149', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318694, 'PTHR22298:SF53', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 5', 241126),
(318695, 'PTHR22298:SF54', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 9', 241126),
(318696, 'PTHR22298:SF98', NULL, NULL, NULL, NULL, 'CELLULASE', 241126),
(318697, 'PTHR22298:SF55', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 17', 241126),
(318698, 'PTHR22298:SF107', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 21', 241126),
(318699, 'PTHR22298:SF108', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318700, 'PTHR22298:SF146', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318701, 'PTHR22298:SF103', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 22', 241126),
(318702, 'PTHR22298:SF148', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318703, 'PTHR22298:SF104', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 16', 241126),
(318704, 'PTHR22298:SF18', NULL, NULL, NULL, NULL, 'CELLULASE-RELATED', 241126),
(318705, 'PTHR22298:SF19', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 19-RELATED', 241126),
(318706, 'PTHR22298:SF109', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 241126),
(318707, 'PTHR47987:SF7', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE CYTOSOLIC SERINE/THREONINE-PROTEIN KINASE RBK1', 241127),
(318708, 'PTHR47987:SF9', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE CYTOSOLIC SERINE/THREONINE-KINASE', 241127),
(318709, 'PTHR47987:SF8', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241127),
(318710, 'PTHR47987', NULL, NULL, NULL, NULL, 'OS08G0249100 PROTEIN', 241127);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(318711, 'PTHR47987:SF11', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241127),
(318712, 'PTHR47987:SF22', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241127),
(318713, 'PTHR47987:SF12', NULL, NULL, NULL, NULL, 'PROTEIN KINASE FAMILY PROTEIN', 241127),
(318714, 'PTHR47987:SF31', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE CYTOSOLIC SERINE/THREONINE-KINASE', 241127),
(318715, 'PTHR47987:SF20', NULL, NULL, NULL, NULL, 'OS04G0654600 PROTEIN', 241127),
(318716, 'PTHR47987:SF10', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE CYTOSOLIC SERINE/THREONINE-PROTEIN KINASE RBK2 ISOFORM X1', 241127),
(318717, 'PTHR47987:SF32', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 241127),
(318718, 'PTHR47987:SF30', NULL, NULL, NULL, NULL, 'OS06G0693200 PROTEIN', 241127),
(318719, 'PTHR47987:SF17', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE CYTOSOLIC SERINE/THREONINE-PROTEIN KINASE RBK2 ISOFORM X1', 241127),
(318720, 'PTHR47987:SF28', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE CYTOSOLIC SERINE/THREONINE-PROTEIN KINASE RBK1', 241127),
(318721, 'PTHR47987:SF29', NULL, NULL, NULL, NULL, 'ROP BINDING PROTEIN KINASES 1-RELATED', 241127),
(318722, 'PTHR47987:SF15', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 241127),
(318723, 'PTHR47987:SF3', NULL, NULL, NULL, NULL, 'OS08G0249100 PROTEIN', 241127),
(318724, 'PTHR47987:SF16', NULL, NULL, NULL, NULL, 'SERINE/THREONINE/DUAL SPECIFICITY PROTEIN KINASE, CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 241127),
(318725, 'PTHR47987:SF2', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241127),
(318726, 'PTHR47987:SF13', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241127),
(318727, 'PTHR47987:SF5', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241127),
(318728, 'PTHR47987:SF24', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241127),
(318729, 'PTHR47987:SF14', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE CYTOSOLIC SERINE/THREONINE-PROTEIN KINASE RBK2', 241127),
(318730, 'PTHR47987:SF4', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241127),
(318731, 'PTHR42104:SF1', NULL, NULL, NULL, NULL, 'EXTRACELLULAR GUANYL-SPECIFIC RIBONUCLEASE RNTA (AFU_ORTHOLOGUE AFUA_4G03230)', 241128),
(318732, 'PTHR42104:SF2', NULL, NULL, NULL, NULL, 'GUANYL-SPECIFIC RIBONUCLEASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G01200)-RELATED', 241128),
(318733, 'PTHR42104', NULL, NULL, NULL, NULL, 'EXTRACELLULAR GUANYL-SPECIFIC RIBONUCLEASE RNTA (AFU_ORTHOLOGUE AFUA_4G03230)', 241128),
(318734, 'PTHR36517', NULL, NULL, NULL, NULL, 'PROTEIN CBG25732', 241129),
(318735, 'PTHR36517:SF1', NULL, NULL, NULL, NULL, 'DUF281 DOMAIN-CONTAINING PROTEIN', 241129),
(318736, 'PTHR40382', NULL, NULL, NULL, NULL, '', 241130),
(318737, 'PTHR40382:SF1', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4930523C07 GENE', 241130),
(318738, 'PTHR46585:SF3', NULL, NULL, NULL, NULL, '', 241131),
(318739, 'PTHR46585:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG24832', 241131),
(318740, 'PTHR46585', NULL, NULL, NULL, NULL, 'INTEGRASE CORE DOMAIN CONTAINING PROTEIN', 241131),
(318741, 'PTHR46585:SF1', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 241131),
(318742, 'PTHR46585:SF2', NULL, NULL, NULL, NULL, '', 241131),
(318743, 'PTHR13364', NULL, NULL, NULL, NULL, 'DEFECTIVE SPERMATOGENESIS PROTEIN 39', 241132),
(318744, 'PTHR13364:SF6', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-DEFECTIVE PROTEIN 39 HOMOLOG', 241132),
(318745, 'PTHR46537:SF2', NULL, NULL, NULL, NULL, 'OS01G0796700 PROTEIN', 241133),
(318746, 'PTHR46537', NULL, NULL, NULL, NULL, 'OS11G0578200 PROTEIN', 241133),
(318747, 'PTHR46537:SF3', NULL, NULL, NULL, NULL, 'OS05G0497600 PROTEIN', 241133),
(318748, 'PTHR46537:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RING1A-RELATED', 241133),
(318749, 'PTHR46537:SF8', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 241133),
(318750, 'PTHR46537:SF6', NULL, NULL, NULL, NULL, 'RING 1A-RELATED', 241133),
(318751, 'PTHR46537:SF7', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 241133); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(318752, 'PTHR46537:SF4', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RING1A-RELATED', 241133),
(318753, 'PTHR46537:SF5', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RING1A-RELATED', 241133),
(318754, 'PTHR43804:SF3', NULL, NULL, NULL, NULL, 'PEPTIDE CHAIN RELEASE FACTOR 1-LIKE, MITOCHONDRIAL', 241134),
(318755, 'PTHR43804:SF1', NULL, NULL, NULL, NULL, 'PEPTIDE CHAIN RELEASE FACTOR 1, MITOCHONDRIAL', 241134),
(318756, 'PTHR43804', NULL, NULL, NULL, NULL, 'LD18447P', 241134),
(318757, 'PTHR43804:SF7', NULL, NULL, NULL, NULL, 'LD18447P', 241134),
(318758, 'PTHR43804:SF6', NULL, NULL, NULL, NULL, 'CLASS I PEPTIDE CHAIN RELEASE FACTOR', 241134),
(318759, 'PTHR31083:SF28', NULL, NULL, NULL, NULL, '', 241135),
(318760, 'PTHR31083:SF29', NULL, NULL, NULL, NULL, 'DUF966 DOMAIN PROTEIN', 241135),
(318761, 'PTHR31083:SF18', NULL, NULL, NULL, NULL, 'PROTEIN SOSEKI 2', 241135),
(318762, 'PTHR31083:SF46', NULL, NULL, NULL, NULL, 'BNAA02G06850D PROTEIN', 241135),
(318763, 'PTHR31083:SF25', NULL, NULL, NULL, NULL, 'PROTEIN UPSTREAM OF FLC-LIKE', 241135),
(318764, 'PTHR31083:SF36', NULL, NULL, NULL, NULL, '', 241135),
(318765, 'PTHR31083:SF47', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE, EXPRESSED-RELATED', 241135),
(318766, 'PTHR31083', NULL, NULL, NULL, NULL, 'UPSTREAM OF FLC PROTEIN (DUF966)', 241135),
(318767, 'PTHR31083:SF5', NULL, NULL, NULL, NULL, 'PROTEIN SOSEKI 1', 241135),
(318768, 'PTHR31083:SF4', NULL, NULL, NULL, NULL, 'PROTEIN SOSEKI 4-RELATED', 241135),
(318769, 'PTHR31083:SF20', NULL, NULL, NULL, NULL, 'PROTEIN UPSTREAM OF FLC-LIKE ISOFORM X1', 241135),
(318770, 'PTHR31083:SF42', NULL, NULL, NULL, NULL, 'AUXIN-REGULATED PROTEIN', 241135),
(318771, 'PTHR31083:SF32', NULL, NULL, NULL, NULL, 'OS09G0571000 PROTEIN', 241135),
(318772, 'PTHR31083:SF43', NULL, NULL, NULL, NULL, '', 241135),
(318773, 'PTHR31083:SF44', NULL, NULL, NULL, NULL, 'PROTEIN UPSTREAM OF FLC-LIKE', 241135),
(318774, 'PTHR31083:SF45', NULL, NULL, NULL, NULL, 'BNAC08G44320D PROTEIN', 241135),
(318775, 'PTHR31083:SF23', NULL, NULL, NULL, NULL, 'PROTEIN UPSTREAM OF FLC-LIKE', 241135),
(318776, 'PTHR31083:SF34', NULL, NULL, NULL, NULL, '', 241135),
(318777, 'PTHR31083:SF6', NULL, NULL, NULL, NULL, 'PROTEIN SOSEKI 3', 241135),
(318778, 'PTHR31083:SF41', NULL, NULL, NULL, NULL, 'OS01G0975000 PROTEIN', 241135),
(318779, 'PTHR13071', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 28S RIBOSOMAL PROTEIN S22', 241136),
(318780, 'PTHR13071:SF4', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S22, MITOCHONDRIAL', 241136),
(318781, 'PTHR10578:SF67', NULL, NULL, NULL, NULL, 'CYTOCHROME B2, MITOCHONDRIAL', 241137),
(318782, 'PTHR10578:SF139', NULL, NULL, NULL, NULL, 'HYDROXYACID OXIDASE 2', 241137),
(318783, 'PTHR10578:SF116', NULL, NULL, NULL, NULL, '(S)-2-HYDROXY-ACID OXIDASE', 241137),
(318784, 'PTHR10578:SF85', NULL, NULL, NULL, NULL, 'L-LACTATE DEHYDROGENASE', 241137),
(318785, 'PTHR10578:SF137', NULL, NULL, NULL, NULL, 'HYDROXYACID OXIDASE 1', 241137),
(318786, 'PTHR10578:SF86', NULL, NULL, NULL, NULL, 'DEPENDENT DEHYDROGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G02720)-RELATED', 241137),
(318787, 'PTHR10578:SF115', NULL, NULL, NULL, NULL, 'PEROXISOMAL (S)-2-HYDROXY-ACID OXIDASE GLO1', 241137),
(318788, 'PTHR10578:SF113', NULL, NULL, NULL, NULL, 'PEROXISOMAL (S)-2-HYDROXY-ACID OXIDASE GLO5', 241137),
(318789, 'PTHR10578:SF135', NULL, NULL, NULL, NULL, '(S)-2-HYDROXY-ACID OXIDASE', 241137),
(318790, 'PTHR10578:SF70', NULL, NULL, NULL, NULL, 'PEROXISOMAL (S)-2-HYDROXY-ACID OXIDASE GLO3', 241137),
(318791, 'PTHR10578:SF133', NULL, NULL, NULL, NULL, '(S)-2-HYDROXY-ACID OXIDASE', 241137),
(318792, 'PTHR10578:SF132', NULL, NULL, NULL, NULL, 'PEROXISOMAL (S)-2-HYDROXY-ACID OXIDASE GLO4', 241137),
(318793, 'PTHR10578:SF110', NULL, NULL, NULL, NULL, '(S)-2-HYDROXY-ACID OXIDASE GLO2', 241137),
(318794, 'PTHR10578:SF72', NULL, NULL, NULL, NULL, 'PEROXISOMAL (S)-2-HYDROXY-ACID OXIDASE GLO2', 241137),
(318795, 'PTHR10578:SF130', NULL, NULL, NULL, NULL, '(S)-2-HYDROXY-ACID OXIDASE', 241137),
(318796, 'PTHR10578:SF107', NULL, NULL, NULL, NULL, 'FMN HYDROXY ACID DEHYDROGENASE DOMAIN-CONTAINING PROTEIN', 241137);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(318797, 'PTHR10578:SF126', NULL, NULL, NULL, NULL, '(S)-2-HYDROXY-ACID OXIDASE', 241137),
(318798, 'PTHR10578:SF75', NULL, NULL, NULL, NULL, 'L-LACTATE DEHYDROGENASE (AFU_ORTHOLOGUE AFUA_4G07050)', 241137),
(318799, 'PTHR10578:SF104', NULL, NULL, NULL, NULL, 'CYTOCHROME B2-LIKE, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G07020)-RELATED', 241137),
(318800, 'PTHR10578:SF125', NULL, NULL, NULL, NULL, '(S)-2-HYDROXY-ACID OXIDASE', 241137),
(318801, 'PTHR10578', NULL, NULL, NULL, NULL, 'S -2-HYDROXY-ACID OXIDASE-RELATED', 241137),
(318802, 'PTHR10578:SF145', NULL, NULL, NULL, NULL, '(S)-2-HYDROXY-ACID OXIDASE', 241137),
(318803, 'PTHR10578:SF123', NULL, NULL, NULL, NULL, '(S)-2-HYDROXY-ACID OXIDASE', 241137),
(318804, 'PTHR10578:SF101', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 241137),
(318805, 'PTHR10578:SF144', NULL, NULL, NULL, NULL, '(S)-2-HYDROXY-ACID OXIDASE', 241137),
(318806, 'PTHR10578:SF82', NULL, NULL, NULL, NULL, 'CYTOCHROME B2, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G07200)-RELATED', 241137),
(318807, 'PTHR10578:SF143', NULL, NULL, NULL, NULL, 'DEPENDENT DEHYDROGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G00500)-RELATED', 241137),
(318808, 'PTHR10578:SF121', NULL, NULL, NULL, NULL, '(S)-2-HYDROXY-ACID OXIDASE', 241137),
(318809, 'PTHR10578:SF142', NULL, NULL, NULL, NULL, 'FMN HYDROXY ACID DEHYDROGENASE DOMAIN-CONTAINING PROTEIN', 241137),
(318810, 'PTHR10578:SF120', NULL, NULL, NULL, NULL, '(S)-2-HYDROXY-ACID OXIDASE', 241137),
(318811, 'PTHR10578:SF141', NULL, NULL, NULL, NULL, '(S)-2-HYDROXY-ACID OXIDASE', 241137),
(318812, 'PTHR10578:SF140', NULL, NULL, NULL, NULL, 'FMN HYDROXY ACID DEHYDROGENASE DOMAIN-CONTAINING PROTEIN', 241137),
(318813, 'PTHR36712:SF2', NULL, NULL, NULL, NULL, 'BNAA06G09740D PROTEIN', 241138),
(318814, 'PTHR36712:SF3', NULL, NULL, NULL, NULL, '', 241138),
(318815, 'PTHR36712', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 241138),
(318816, 'PTHR36712:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 241138),
(318817, 'PTHR38105:SF2', NULL, NULL, NULL, NULL, 'N-ACETYLNEURAMINIC ACID OUTER MEMBRANE CHANNEL PROTEIN NANC-RELATED', 241139),
(318818, 'PTHR38105:SF5', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN-RELATED', 241139),
(318819, 'PTHR38105', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN-RELATED-RELATED', 241139),
(318820, 'PTHR31901:SF48', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETIC ACID-AMIDO SYNTHETASE GH3.10', 241140),
(318821, 'PTHR31901:SF46', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETIC ACID-AMIDO SYNTHETASE', 241140),
(318822, 'PTHR31901:SF45', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETIC ACID-AMIDO SYNTHETASE GH3.5', 241140),
(318823, 'PTHR31901:SF89', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETIC ACID-AMIDO SYNTHETASE GH3.6-LIKE', 241140),
(318824, 'PTHR31901:SF49', NULL, NULL, NULL, NULL, 'BNAC06G02210D PROTEIN', 241140),
(318825, 'PTHR31901:SF9', NULL, NULL, NULL, NULL, 'GH3 DOMAIN-CONTAINING PROTEIN', 241140),
(318826, 'PTHR31901:SF7', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETIC ACID-AMIDO SYNTHETASE GH3.2-RELATED', 241140),
(318827, 'PTHR31901:SF91', NULL, NULL, NULL, NULL, 'BNAA03G52600D PROTEIN', 241140),
(318828, 'PTHR31901:SF90', NULL, NULL, NULL, NULL, 'BNAA03G52610D PROTEIN', 241140),
(318829, 'PTHR31901:SF51', NULL, NULL, NULL, NULL, 'BNAC09G43720D PROTEIN', 241140),
(318830, 'PTHR31901:SF50', NULL, NULL, NULL, NULL, 'JASMONIC ACID-AMIDO SYNTHETASE JAR1', 241140),
(318831, 'PTHR31901:SF94', NULL, NULL, NULL, NULL, 'JASMONIC ACID-AMIDO SYNTHETASE JAR1-LIKE ISOFORM X1', 241140),
(318832, 'PTHR31901:SF93', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETIC ACID-AMIDO SYNTHETASE GH3.17-LIKE ISOFORM X1', 241140),
(318833, 'PTHR31901:SF92', NULL, NULL, NULL, NULL, 'BNAA05G14780D PROTEIN', 241140),
(318834, 'PTHR31901:SF55', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETIC ACID-AMIDO SYNTHETASE GH3.3', 241140),
(318835, 'PTHR31901:SF5', NULL, NULL, NULL, NULL, 'JASMONOYL--L-AMINO ACID SYNTHETASE JAR1', 241140),
(318836, 'PTHR31901:SF54', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE GH3 FAMILY PROTEIN', 241140),
(318837, 'PTHR31901:SF53', NULL, NULL, NULL, NULL, 'JASMONIC ACID-AMIDO SYNTHETASE JAR1-LIKE', 241140);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(318838, 'PTHR31901:SF52', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE GH3 FAMILY PROTEIN', 241140),
(318839, 'PTHR31901:SF58', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETIC ACID-AMIDO SYNTHETASE GH3.1-RELATED', 241140),
(318840, 'PTHR31901:SF14', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETIC ACID-AMIDO SYNTHETASE GH3.7-RELATED', 241140),
(318841, 'PTHR31901:SF57', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETIC ACID-AMIDO SYNTHETASE GH3.17-LIKE ISOFORM X3', 241140),
(318842, 'PTHR31901:SF56', NULL, NULL, NULL, NULL, 'JASMONOYL--L-AMINO ACID SYNTHETASE GH3.3', 241140),
(318843, 'PTHR31901:SF18', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETIC ACID-AMIDO SYNTHETASE GH3.9-RELATED', 241140),
(318844, 'PTHR31901:SF62', NULL, NULL, NULL, NULL, '', 241140),
(318845, 'PTHR31901:SF61', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE GH3 FAMILY PROTEIN', 241140),
(318846, 'PTHR31901:SF60', NULL, NULL, NULL, NULL, '', 241140),
(318847, 'PTHR31901:SF66', NULL, NULL, NULL, NULL, 'BNACNNG59530D PROTEIN', 241140),
(318848, 'PTHR31901:SF65', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETIC ACID-AMIDO SYNTHETASE GH3.6', 241140),
(318849, 'PTHR31901:SF64', NULL, NULL, NULL, NULL, 'GH3 FAMILY-RELATED', 241140),
(318850, 'PTHR31901:SF63', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETIC ACID-AMIDO SYNTHETASE', 241140),
(318851, 'PTHR31901:SF69', NULL, NULL, NULL, NULL, 'BNAA03G13150D PROTEIN', 241140),
(318852, 'PTHR31901:SF68', NULL, NULL, NULL, NULL, 'BNAA09G48110D PROTEIN', 241140),
(318853, 'PTHR31901:SF67', NULL, NULL, NULL, NULL, 'GH3 FAMILY-RELATED', 241140),
(318854, 'PTHR31901', NULL, NULL, NULL, NULL, 'GH3 DOMAIN-CONTAINING PROTEIN', 241140),
(318855, 'PTHR31901:SF73', NULL, NULL, NULL, NULL, 'BNACNNG49810D PROTEIN', 241140),
(318856, 'PTHR31901:SF72', NULL, NULL, NULL, NULL, 'BNAA08G05580D PROTEIN', 241140),
(318857, 'PTHR31901:SF70', NULL, NULL, NULL, NULL, 'BNAC03G14570D PROTEIN', 241140),
(318858, 'PTHR31901:SF77', NULL, NULL, NULL, NULL, '', 241140),
(318859, 'PTHR31901:SF33', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETIC ACID-AMIDO SYNTHETASE GH3.17', 241140),
(318860, 'PTHR31901:SF76', NULL, NULL, NULL, NULL, 'BNACNNG49820D PROTEIN', 241140),
(318861, 'PTHR31901:SF75', NULL, NULL, NULL, NULL, 'BNAC09G31070D PROTEIN', 241140),
(318862, 'PTHR31901:SF74', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETIC ACID-AMIDO SYNTHETASE GH3.6-LIKE', 241140),
(318863, 'PTHR31901:SF37', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETIC ACID-AMIDO SYNTHETASE GH3.6', 241140),
(318864, 'PTHR31901:SF36', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETIC ACID-AMIDO SYNTHETASE GH3.6', 241140),
(318865, 'PTHR31901:SF79', NULL, NULL, NULL, NULL, 'GH3 FAMILY-RELATED', 241140),
(318866, 'PTHR31901:SF35', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETIC ACID-AMIDO SYNTHETASE GH3.4-RELATED', 241140),
(318867, 'PTHR31901:SF78', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE GH3 FAMILY PROTEIN-RELATED', 241140),
(318868, 'PTHR31901:SF39', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETIC ACID-AMIDO SYNTHETASE GH3.6-LIKE', 241140),
(318869, 'PTHR31901:SF38', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETIC ACID-AMIDO SYNTHETASE GH3.2-RELATED', 241140),
(318870, 'PTHR31901:SF80', NULL, NULL, NULL, NULL, 'BNAA04G16140D PROTEIN', 241140),
(318871, 'PTHR31901:SF84', NULL, NULL, NULL, NULL, 'BNAA03G52620D PROTEIN', 241140),
(318872, 'PTHR31901:SF83', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETIC ACID-AMIDO SYNTHETASE GH3.6-LIKE', 241140),
(318873, 'PTHR31901:SF82', NULL, NULL, NULL, NULL, 'BNAA09G15010D PROTEIN', 241140),
(318874, 'PTHR31901:SF81', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE GH3 FAMILY PROTEIN', 241140),
(318875, 'PTHR31901:SF44', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETIC ACID-AMIDO SYNTHETASE GH3.6-RELATED', 241140),
(318876, 'PTHR31901:SF88', NULL, NULL, NULL, NULL, 'BNACNNG28110D PROTEIN', 241140),
(318877, 'PTHR31901:SF87', NULL, NULL, NULL, NULL, 'BNAC01G19430D PROTEIN', 241140),
(318878, 'PTHR31901:SF43', NULL, NULL, NULL, NULL, '4-SUBSTITUTED BENZOATES-GLUTAMATE LIGASE GH3.12', 241140),
(318879, 'PTHR31901:SF86', NULL, NULL, NULL, NULL, 'BNAA07G08630D PROTEIN', 241140),
(318880, 'PTHR31901:SF42', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETIC ACID-AMIDO SYNTHETASE GH3.6', 241140);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(318881, 'PTHR31901:SF41', NULL, NULL, NULL, NULL, 'JASMONIC ACID-AMIDO SYNTHETASE JAR1-LIKE', 241140),
(318882, 'PTHR31901:SF85', NULL, NULL, NULL, NULL, 'GH3 FAMILY-RELATED', 241140),
(318883, 'PTHR10957', NULL, NULL, NULL, NULL, 'RAP1 GTPASE-GDP DISSOCIATION STIMULATOR 1', 241141),
(318884, 'PTHR10957:SF3', NULL, NULL, NULL, NULL, 'SI:DKEY-191G9.5-RELATED', 241141),
(318885, 'PTHR10957:SF2', NULL, NULL, NULL, NULL, 'RAP1 GTPASE-GDP DISSOCIATION STIMULATOR 1', 241141),
(318886, 'PTHR10957:SF1', NULL, NULL, NULL, NULL, 'FI02061P', 241141),
(318887, 'PTHR43615', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE SYNTHASE-RELATED', 241142),
(318888, 'PTHR43615:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE SYNTHASE-RELATED', 241142),
(318889, 'PTHR48148:SF2', NULL, NULL, NULL, NULL, 'KERATINOCYTE PROLINE-RICH PROTEIN', 241143),
(318890, 'PTHR48148', NULL, NULL, NULL, NULL, 'KERATINOCYTE PROLINE-RICH PROTEIN', 241143),
(318891, 'PTHR12932', NULL, NULL, NULL, NULL, 'P25 ALPHA-RELATED', 241144),
(318892, 'PTHR12932:SF16', NULL, NULL, NULL, NULL, 'TUBULIN POLYMERIZATION-PROMOTING PROTEIN FAMILY MEMBER 3', 241144),
(318893, 'PTHR12932:SF18', NULL, NULL, NULL, NULL, 'TUBULIN POLYMERIZATION-PROMOTING PROTEIN', 241144),
(318894, 'PTHR12932:SF23', NULL, NULL, NULL, NULL, 'TUBULIN POLYMERIZATION-PROMOTING PROTEIN FAMILY MEMBER 3', 241144),
(318895, 'PTHR12932:SF9', NULL, NULL, NULL, NULL, 'TUBULIN POLYMERIZATION-PROMOTING PROTEIN HOMOLOG', 241144),
(318896, 'PTHR12932:SF21', NULL, NULL, NULL, NULL, 'TUBULIN POLYMERIZATION-PROMOTING PROTEIN FAMILY MEMBER 2', 241144),
(318897, 'PTHR10982:SF21', NULL, NULL, NULL, NULL, 'FATTY ACID SYNTHASE SUBUNIT BETA', 241145),
(318898, 'PTHR10982', NULL, NULL, NULL, NULL, 'MALONYL COA-ACYL CARRIER PROTEIN TRANSACYLASE', 241145),
(318899, 'PTHR10982:SF23', NULL, NULL, NULL, NULL, 'FATTY ACID SYNTHASE SUBUNIT ALPHA', 241145),
(318900, 'PTHR10566:SF121', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241146),
(318901, 'PTHR10566:SF120', NULL, NULL, NULL, NULL, 'PROTEIN ACTIVITY OF BC1 COMPLEX KINASE 3, CHLOROPLASTIC', 241146),
(318902, 'PTHR10566:SF123', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 241146),
(318903, 'PTHR10566:SF124', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 241146),
(318904, 'PTHR10566:SF113', NULL, NULL, NULL, NULL, 'PROTEIN ACTIVITY OF BC1 COMPLEX KINASE 7, CHLOROPLASTIC', 241146),
(318905, 'PTHR10566', NULL, NULL, NULL, NULL, 'CHAPERONE-ACTIVITY OF BC1 COMPLEX  CABC1 -RELATED', 241146),
(318906, 'PTHR10566:SF53', NULL, NULL, NULL, NULL, 'PROTEIN ACTIVITY OF BC1 COMPLEX KINASE 1, CHLOROPLASTIC', 241146),
(318907, 'PTHR10566:SF127', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER-LIKE PROTEIN', 241146),
(318908, 'PTHR10566:SF126', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241146),
(318909, 'PTHR10566:SF115', NULL, NULL, NULL, NULL, 'PROTEIN ACTIVITY OF BC1 COMPLEX KINASE 8, CHLOROPLASTIC', 241146),
(318910, 'PTHR10566:SF118', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241146),
(318911, 'PTHR10566:SF128', NULL, NULL, NULL, NULL, 'UBIB DOMAIN CONTAINING KINASE', 241146),
(318912, 'PTHR10566:SF117', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241146),
(318913, 'PTHR10566:SF119', NULL, NULL, NULL, NULL, 'OS04G0640500 PROTEIN', 241146),
(318914, 'PTHR44598:SF3', NULL, NULL, NULL, NULL, 'JUNCTIONAL ADHESION MOLECULE 3B-RELATED', 241147),
(318915, 'PTHR44598:SF2', NULL, NULL, NULL, NULL, 'JUNCTIONAL ADHESION MOLECULE C', 241147),
(318916, 'PTHR44598:SF1', NULL, NULL, NULL, NULL, 'JUNCTIONAL ADHESION MOLECULE 3A', 241147),
(318917, 'PTHR44598', NULL, NULL, NULL, NULL, 'JUNCTIONAL ADHESION MOLECULE C', 241147),
(318918, 'PTHR40903:SF4', NULL, NULL, NULL, NULL, 'HYPHALLY REGULATED CELL WALL PROTEIN 3', 241148),
(318919, 'PTHR40903:SF3', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 241148),
(318920, 'PTHR40903', NULL, NULL, NULL, NULL, 'GLYCINE-RICH CELL WALL STRUCTURAL PROTEIN 1-LIKE', 241148),
(318921, 'PTHR40903:SF2', NULL, NULL, NULL, NULL, 'GLYCINE-RICH CELL WALL STRUCTURAL PROTEIN 1', 241148);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(318922, 'PTHR40903:SF1', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 241148),
(318923, 'PTHR14652', NULL, NULL, NULL, NULL, 'TYPE 2 DNA TOPOISOMERASE 6 SUBUNIT B-LIKE', 241149),
(318924, 'PTHR14652:SF2', NULL, NULL, NULL, NULL, 'TYPE 2 DNA TOPOISOMERASE 6 SUBUNIT B-LIKE', 241149),
(318925, 'PTHR47917', NULL, NULL, NULL, NULL, '', 241150),
(318926, 'PTHR47917:SF2', NULL, NULL, NULL, NULL, 'F420_LIGASE DOMAIN-CONTAINING PROTEIN', 241150),
(318927, 'PTHR47917:SF1', NULL, NULL, NULL, NULL, 'COENZYME F420:L-GLUTAMATE LIGASE', 241150),
(318928, 'PTHR46034:SF32', NULL, NULL, NULL, NULL, 'DCD DOMAIN-CONTAINING PROTEIN NRP-B', 241151),
(318929, 'PTHR46034:SF34', NULL, NULL, NULL, NULL, 'B2 PROTEIN-LIKE', 241151),
(318930, 'PTHR46034:SF12', NULL, NULL, NULL, NULL, 'B2 PROTEIN', 241151),
(318931, 'PTHR46034:SF14', NULL, NULL, NULL, NULL, 'B2 PROTEIN-LIKE', 241151),
(318932, 'PTHR46034:SF35', NULL, NULL, NULL, NULL, 'DCD DOMAIN-CONTAINING PROTEIN', 241151),
(318933, 'PTHR46034:SF13', NULL, NULL, NULL, NULL, 'DCD (DEVELOPMENT AND CELL DEATH) DOMAIN PROTEIN', 241151),
(318934, 'PTHR46034:SF38', NULL, NULL, NULL, NULL, 'OS09G0563700 PROTEIN', 241151),
(318935, 'PTHR46034:SF37', NULL, NULL, NULL, NULL, 'DCD DOMAIN-CONTAINING PROTEIN NRP', 241151),
(318936, 'PTHR46034:SF15', NULL, NULL, NULL, NULL, 'DCD (DEVELOPMENT AND CELL DEATH) DOMAIN PROTEIN', 241151),
(318937, 'PTHR46034:SF18', NULL, NULL, NULL, NULL, 'DCD DOMAIN-CONTAINING PROTEIN', 241151),
(318938, 'PTHR46034:SF39', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 1', 241151),
(318939, 'PTHR46034:SF41', NULL, NULL, NULL, NULL, 'DCD (DEVELOPMENT AND CELL DEATH) DOMAIN PROTEIN', 241151),
(318940, 'PTHR46034:SF40', NULL, NULL, NULL, NULL, 'DCD (DEVELOPMENT AND CELL DEATH) DOMAIN PROTEIN-RELATED', 241151),
(318941, 'PTHR46034:SF3', NULL, NULL, NULL, NULL, 'B2 PROTEIN-LIKE', 241151),
(318942, 'PTHR46034:SF43', NULL, NULL, NULL, NULL, 'B2 PROTEIN-LIKE', 241151),
(318943, 'PTHR46034:SF42', NULL, NULL, NULL, NULL, 'OS01G0165200 PROTEIN', 241151),
(318944, 'PTHR46034:SF20', NULL, NULL, NULL, NULL, 'DCD DOMAIN-CONTAINING PROTEIN NRP-A', 241151),
(318945, 'PTHR46034:SF23', NULL, NULL, NULL, NULL, 'DCD (DEVELOPMENT AND CELL DEATH) DOMAIN PROTEIN', 241151),
(318946, 'PTHR46034:SF44', NULL, NULL, NULL, NULL, 'DCD DOMAIN-CONTAINING PROTEIN', 241151),
(318947, 'PTHR46034:SF25', NULL, NULL, NULL, NULL, 'DCD DOMAIN-CONTAINING PROTEIN', 241151),
(318948, 'PTHR46034:SF9', NULL, NULL, NULL, NULL, 'DCD (DEVELOPMENT AND CELL DEATH) DOMAIN PROTEIN', 241151),
(318949, 'PTHR46034', NULL, NULL, NULL, NULL, '', 241151),
(318950, 'PTHR46034:SF7', NULL, NULL, NULL, NULL, 'INFLUENZA VIRUS NS1A-BINDING PROTEIN', 241151),
(318951, 'PTHR46034:SF26', NULL, NULL, NULL, NULL, 'DCD DOMAIN-CONTAINING PROTEIN', 241151),
(318952, 'PTHR46034:SF29', NULL, NULL, NULL, NULL, 'DCD DOMAIN-CONTAINING PROTEIN', 241151),
(318953, 'PTHR31968', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RELATED PROTEIN 53', 241152),
(318954, 'PTHR31968:SF4', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RELATED PROTEIN 53', 241152),
(318955, 'PTHR11842:SF15', NULL, NULL, NULL, NULL, 'MITOTIC SPINDLE ASSEMBLY CHECKPOINT PROTEIN MAD2B', 241153),
(318956, 'PTHR11842', NULL, NULL, NULL, NULL, 'MITOTIC SPINDLE ASSEMBLY CHECKPOINT PROTEIN MAD2', 241153),
(318957, 'PTHR11842:SF14', NULL, NULL, NULL, NULL, 'MITOTIC ARREST DEFICIENT 2 LIKE 2', 241153),
(318958, 'PTHR11842:SF11', NULL, NULL, NULL, NULL, 'MITOTIC SPINDLE ASSEMBLY CHECKPOINT PROTEIN MAD2A', 241153),
(318959, 'PTHR11842:SF10', NULL, NULL, NULL, NULL, 'MITOTIC SPINDLE ASSEMBLY CHECKPOINT PROTEIN MAD2B', 241153),
(318960, 'PTHR11842:SF13', NULL, NULL, NULL, NULL, 'MITOTIC SPINDLE ASSEMBLY CHECKPOINT PROTEIN MAD2A', 241153),
(318961, 'PTHR11842:SF12', NULL, NULL, NULL, NULL, 'HORMA DOMAIN-CONTAINING PROTEIN', 241153),
(318962, 'PTHR35497:SF1', NULL, NULL, NULL, NULL, 'ACYL-UDP-N-ACETYLGLUCOSAMINE O-ACYLTRANSFERASE', 241154),
(318963, 'PTHR35497:SF2', NULL, NULL, NULL, NULL, 'BNAA03G49140D PROTEIN', 241154),
(318964, 'PTHR35497', NULL, NULL, NULL, NULL, 'ACYL-UDP-N-ACETYLGLUCOSAMINE O-ACYLTRANSFERASE', 241154);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(318965, 'PTHR44329:SF39', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 10', 241155),
(318966, 'PTHR44329', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE TNNI3K-RELATED', 241155),
(318967, 'PTHR44329:SF35', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 9', 241155),
(318968, 'PTHR44329:SF32', NULL, NULL, NULL, NULL, 'OS01G0748600 PROTEIN', 241155),
(318969, 'PTHR44329:SF252', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241155),
(318970, 'PTHR44329:SF131', NULL, NULL, NULL, NULL, 'BNACNNG11260D PROTEIN', 241155),
(318971, 'PTHR44329:SF253', NULL, NULL, NULL, NULL, '', 241155),
(318972, 'PTHR44329:SF250', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE STY46-LIKE', 241155),
(318973, 'PTHR44329:SF251', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE EDR1-LIKE ISOFORM X1', 241155),
(318974, 'PTHR44329:SF256', NULL, NULL, NULL, NULL, 'PAS DOMAIN-CONTAINING PROTEIN TYROSINE KINASE FAMILY PROTEIN', 241155),
(318975, 'PTHR44329:SF136', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241155),
(318976, 'PTHR44329:SF257', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE HT1-LIKE', 241155),
(318977, 'PTHR44329:SF254', NULL, NULL, NULL, NULL, 'INTEGRIN-LINKED PROTEIN KINASE', 241155),
(318978, 'PTHR44329:SF255', NULL, NULL, NULL, NULL, 'OS09G0566550 PROTEIN', 241155),
(318979, 'PTHR44329:SF134', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE EDR1-LIKE ISOFORM X1', 241155),
(318980, 'PTHR44329:SF137', NULL, NULL, NULL, NULL, 'OS02G0527600 PROTEIN', 241155),
(318981, 'PTHR44329:SF258', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING PROTEIN KINASE A-RELATED', 241155),
(318982, 'PTHR44329:SF259', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241155),
(318983, 'PTHR44329:SF41', NULL, NULL, NULL, NULL, 'OS12G0163800 PROTEIN', 241155),
(318984, 'PTHR44329:SF47', NULL, NULL, NULL, NULL, 'PAS DOMAIN-CONTAINING PROTEIN TYROSINE KINASE FAMILY PROTEIN', 241155),
(318985, 'PTHR44329:SF46', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 11', 241155),
(318986, 'PTHR44329:SF260', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241155),
(318987, 'PTHR44329:SF263', NULL, NULL, NULL, NULL, 'DUAL-SPECIFICITY KINASE TKL-PL-4 FAMILY-RELATED', 241155),
(318988, 'PTHR44329:SF143', NULL, NULL, NULL, NULL, '', 241155),
(318989, 'PTHR44329:SF264', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241155),
(318990, 'PTHR44329:SF261', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241155),
(318991, 'PTHR44329:SF140', NULL, NULL, NULL, NULL, 'INTEGRIN-LINKED KINASE FAMILY PROTEIN', 241155),
(318992, 'PTHR44329:SF262', NULL, NULL, NULL, NULL, 'RAF HOMOLOG SERINE/THREONINE-PROTEIN KINASE RAF', 241155),
(318993, 'PTHR44329:SF141', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241155),
(318994, 'PTHR44329:SF146', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE', 241155),
(318995, 'PTHR44329:SF267', NULL, NULL, NULL, NULL, 'OS01G0674100 PROTEIN', 241155),
(318996, 'PTHR44329:SF268', NULL, NULL, NULL, NULL, 'MAP KINASE KINASE KINASE-LIKE PROTEIN', 241155),
(318997, 'PTHR44329:SF265', NULL, NULL, NULL, NULL, 'PROTEIN SERINE/THREONINE KINASE', 241155),
(318998, 'PTHR44329:SF266', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DRKD-RELATED', 241155),
(318999, 'PTHR44329:SF148', NULL, NULL, NULL, NULL, 'ATMRK SERINE/THREONINE PROTEIN KINASE-LIKE', 241155),
(319000, 'PTHR44329:SF269', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE STY17-LIKE ISOFORM X1', 241155),
(319001, 'PTHR44329:SF149', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241155),
(319002, 'PTHR44329:SF53', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN KINASE SHKD', 241155),
(319003, 'PTHR44329:SF17', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 12', 241155),
(319004, 'PTHR44329:SF14', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 13', 241155);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(319005, 'PTHR44329:SF15', NULL, NULL, NULL, NULL, 'MIXED LINEAGE KINASE DOMAIN-LIKE PROTEIN', 241155),
(319006, 'PTHR44329:SF11', NULL, NULL, NULL, NULL, 'OS09G0443600 PROTEIN', 241155),
(319007, 'PTHR44329:SF270', NULL, NULL, NULL, NULL, 'KINASE LIKE PROTEIN', 241155),
(319008, 'PTHR44329:SF150', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241155),
(319009, 'PTHR44329:SF271', NULL, NULL, NULL, NULL, 'ATMRK1', 241155),
(319010, 'PTHR44329:SF274', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241155),
(319011, 'PTHR44329:SF275', NULL, NULL, NULL, NULL, 'SERINE/THREONINE/DUAL SPECIFICITY PROTEIN KINASE, CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 241155),
(319012, 'PTHR44329:SF272', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 241155),
(319013, 'PTHR44329:SF151', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE STY17', 241155),
(319014, 'PTHR44329:SF273', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE STY8', 241155),
(319015, 'PTHR44329:SF278', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE STY46-LIKE', 241155),
(319016, 'PTHR44329:SF279', NULL, NULL, NULL, NULL, 'OS01G0641000 PROTEIN', 241155),
(319017, 'PTHR44329:SF276', NULL, NULL, NULL, NULL, 'MAP KINASE KINASE KINASE-LIKE PROTEIN', 241155),
(319018, 'PTHR44329:SF155', NULL, NULL, NULL, NULL, 'BNAA07G02330D PROTEIN', 241155),
(319019, 'PTHR44329:SF277', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241155),
(319020, 'PTHR44329:SF28', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN KINASE SHKE', 241155),
(319021, 'PTHR44329:SF25', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241155),
(319022, 'PTHR44329:SF24', NULL, NULL, NULL, NULL, 'MITOGEN ACTIVATED PROTEIN KINASE KINASE KINASE-LIKE PROTEIN', 241155),
(319023, 'PTHR44329:SF22', NULL, NULL, NULL, NULL, 'RAF PROTO-ONCOGENE SERINE/THREONINE-PROTEIN KINASE', 241155),
(319024, 'PTHR44329:SF281', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE CTR1', 241155),
(319025, 'PTHR44329:SF160', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241155),
(319026, 'PTHR44329:SF161', NULL, NULL, NULL, NULL, 'OS01G0747400 PROTEIN', 241155),
(319027, 'PTHR44329:SF280', NULL, NULL, NULL, NULL, 'PROTEIN KINASE', 241155),
(319028, 'PTHR44329:SF165', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241155),
(319029, 'PTHR44329:SF163', NULL, NULL, NULL, NULL, 'SERINE/THREONINE/DUAL SPECIFICITY PROTEIN KINASE, CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 241155),
(319030, 'PTHR44329:SF168', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 241155),
(319031, 'PTHR44329:SF166', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE HT1-LIKE', 241155),
(319032, 'PTHR44329:SF167', NULL, NULL, NULL, NULL, 'BNAA06G25660D PROTEIN', 241155),
(319033, 'PTHR44329:SF204', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241155),
(319034, 'PTHR44329:SF30', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 21', 241155),
(319035, 'PTHR44329:SF79', NULL, NULL, NULL, NULL, 'OS04G0686650 PROTEIN', 241155),
(319036, 'PTHR44329:SF171', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE', 241155),
(319037, 'PTHR44329:SF8', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN KINASE SHKA', 241155),
(319038, 'PTHR44329:SF213', NULL, NULL, NULL, NULL, 'OS01G0201200 PROTEIN', 241155),
(319039, 'PTHR44329:SF7', NULL, NULL, NULL, NULL, 'OS02G0608500 PROTEIN', 241155),
(319040, 'PTHR44329:SF6', NULL, NULL, NULL, NULL, 'RECEPTOR-INTERACTING SERINE/THREONINE-PROTEIN KINASE 1', 241155),
(319041, 'PTHR44329:SF177', NULL, NULL, NULL, NULL, 'CTR1 KINASE', 241155),
(319042, 'PTHR44329:SF210', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE HT1-LIKE ISOFORM X1', 241155),
(319043, 'PTHR44329:SF211', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241155),
(319044, 'PTHR44329:SF216', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE STY8-LIKE', 241155),
(319045, 'PTHR44329:SF214', NULL, NULL, NULL, NULL, 'ZINC FINGER CONTAINING PROTEIN KINASE-RELATED', 241155);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(319046, 'PTHR44329:SF215', NULL, NULL, NULL, NULL, 'OS01G0892800 PROTEIN', 241155),
(319047, 'PTHR44329:SF218', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241155),
(319048, 'PTHR44329:SF84', NULL, NULL, NULL, NULL, 'PROTEIN KINASE LIKE PROTEIN', 241155),
(319049, 'PTHR44329:SF80', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE EDR1-LIKE ISOFORM X1', 241155),
(319050, 'PTHR44329:SF9', NULL, NULL, NULL, NULL, 'RECEPTOR-INTERACTING SERINE/THREONINE-PROTEIN KINASE 2', 241155),
(319051, 'PTHR44329:SF88', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE HT1-LIKE', 241155),
(319052, 'PTHR44329:SF182', NULL, NULL, NULL, NULL, 'DEATH-ASSOCIATED PROTEIN KINASE 1-RELATED', 241155),
(319053, 'PTHR44329:SF181', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241155),
(319054, 'PTHR44329:SF186', NULL, NULL, NULL, NULL, 'BNAA05G30750D PROTEIN', 241155),
(319055, 'PTHR44329:SF220', NULL, NULL, NULL, NULL, 'OS06G0232100 PROTEIN', 241155),
(319056, 'PTHR44329:SF223', NULL, NULL, NULL, NULL, 'INTEGRIN-LINKED PROTEIN KINASE FAMILY-RELATED', 241155),
(319057, 'PTHR44329:SF224', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE EDR1-LIKE ISOFORM X1', 241155),
(319058, 'PTHR44329:SF101', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE STY8', 241155),
(319059, 'PTHR44329:SF228', NULL, NULL, NULL, NULL, 'KINASE-LIKE PROTEIN', 241155),
(319060, 'PTHR44329:SF107', NULL, NULL, NULL, NULL, 'BNAA05G30760D PROTEIN', 241155),
(319061, 'PTHR44329:SF226', NULL, NULL, NULL, NULL, 'OS12G0605900 PROTEIN', 241155),
(319062, 'PTHR44329:SF96', NULL, NULL, NULL, NULL, 'OS04G0610900 PROTEIN', 241155),
(319063, 'PTHR44329:SF229', NULL, NULL, NULL, NULL, '', 241155),
(319064, 'PTHR44329:SF91', NULL, NULL, NULL, NULL, 'INTEGRIN-LINKED PROTEIN KINASE 1-RELATED', 241155),
(319065, 'PTHR44329:SF57', NULL, NULL, NULL, NULL, 'INTEGRIN-LINKED PROTEIN KINASE', 241155),
(319066, 'PTHR44329:SF55', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE A-RAF', 241155),
(319067, 'PTHR44329:SF194', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241155),
(319068, 'PTHR44329:SF191', NULL, NULL, NULL, NULL, 'ACT-LIKE TYROSINE KINASE FAMILY PROTEIN', 241155),
(319069, 'PTHR44329:SF230', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241155),
(319070, 'PTHR44329:SF197', NULL, NULL, NULL, NULL, 'INTEGRIN-LINKED KINASE FAMILY PROTEIN', 241155),
(319071, 'PTHR44329:SF110', NULL, NULL, NULL, NULL, '', 241155),
(319072, 'PTHR44329:SF231', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 241155),
(319073, 'PTHR44329:SF198', NULL, NULL, NULL, NULL, '', 241155),
(319074, 'PTHR44329:SF196', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE STY46-LIKE ISOFORM X1', 241155),
(319075, 'PTHR44329:SF235', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 20', 241155),
(319076, 'PTHR44329:SF238', NULL, NULL, NULL, NULL, 'ACT DOMAIN, PROTEIN KINASE-LIKE DOMAIN PROTEIN-RELATED', 241155),
(319077, 'PTHR44329:SF115', NULL, NULL, NULL, NULL, 'MAP KINASE KINASE KINASE-LIKE PROTEIN', 241155),
(319078, 'PTHR44329:SF237', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241155),
(319079, 'PTHR44329:SF64', NULL, NULL, NULL, NULL, 'OS02G0120100 PROTEIN', 241155),
(319080, 'PTHR44329:SF119', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241155),
(319081, 'PTHR44329:SF62', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE STY8-LIKE ISOFORM X1', 241155),
(319082, 'PTHR44329:SF68', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 241155),
(319083, 'PTHR44329:SF65', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE STY8-LIKE', 241155),
(319084, 'PTHR44329:SF242', NULL, NULL, NULL, NULL, 'BNAC04G42540D PROTEIN', 241155),
(319085, 'PTHR44329:SF121', NULL, NULL, NULL, NULL, '', 241155),
(319086, 'PTHR44329:SF240', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE B-RAF', 241155),
(319087, 'PTHR44329:SF246', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE TNNI3K', 241155);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(319088, 'PTHR44329:SF243', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN KINASE SHKB', 241155),
(319089, 'PTHR44329:SF249', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE STY8-LIKE', 241155),
(319090, 'PTHR44329:SF128', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE STY46', 241155),
(319091, 'PTHR44329:SF126', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241155),
(319092, 'PTHR44329:SF73', NULL, NULL, NULL, NULL, 'OS05G0519200 PROTEIN', 241155),
(319093, 'PTHR44329:SF71', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241155),
(319094, 'PTHR11604:SF35', NULL, NULL, NULL, NULL, 'PROFILIN-3', 241156),
(319095, 'PTHR11604:SF54', NULL, NULL, NULL, NULL, 'PROFILIN', 241156),
(319096, 'PTHR11604:SF10', NULL, NULL, NULL, NULL, 'PROFILIN', 241156),
(319097, 'PTHR11604:SF39', NULL, NULL, NULL, NULL, 'PROFILIN', 241156),
(319098, 'PTHR11604:SF38', NULL, NULL, NULL, NULL, 'PROFILIN', 241156),
(319099, 'PTHR11604:SF59', NULL, NULL, NULL, NULL, 'PROFILIN', 241156),
(319100, 'PTHR11604:SF37', NULL, NULL, NULL, NULL, 'PROFILIN', 241156),
(319101, 'PTHR11604:SF58', NULL, NULL, NULL, NULL, 'PROFILIN', 241156),
(319102, 'PTHR11604:SF36', NULL, NULL, NULL, NULL, 'PROFILIN', 241156),
(319103, 'PTHR11604:SF60', NULL, NULL, NULL, NULL, 'PROFILIN', 241156),
(319104, 'PTHR11604:SF64', NULL, NULL, NULL, NULL, 'PROFILIN', 241156),
(319105, 'PTHR11604:SF41', NULL, NULL, NULL, NULL, 'PROFILIN', 241156),
(319106, 'PTHR11604:SF63', NULL, NULL, NULL, NULL, 'PROFILIN', 241156),
(319107, 'PTHR11604:SF62', NULL, NULL, NULL, NULL, 'PROFILIN-1', 241156),
(319108, 'PTHR11604:SF40', NULL, NULL, NULL, NULL, 'PROFILIN', 241156),
(319109, 'PTHR11604:SF61', NULL, NULL, NULL, NULL, 'PROFILIN-1', 241156),
(319110, 'PTHR11604:SF46', NULL, NULL, NULL, NULL, 'PROFILIN-1', 241156),
(319111, 'PTHR11604:SF2', NULL, NULL, NULL, NULL, 'PROFILIN-4', 241156),
(319112, 'PTHR11604:SF24', NULL, NULL, NULL, NULL, 'PROFILIN-1-RELATED', 241156),
(319113, 'PTHR11604:SF45', NULL, NULL, NULL, NULL, 'PROFILIN', 241156),
(319114, 'PTHR11604:SF1', NULL, NULL, NULL, NULL, 'PROFILIN-2', 241156),
(319115, 'PTHR11604:SF66', NULL, NULL, NULL, NULL, 'PROFILIN', 241156),
(319116, 'PTHR11604:SF65', NULL, NULL, NULL, NULL, 'PROFILIN-RELATED', 241156),
(319117, 'PTHR11604:SF3', NULL, NULL, NULL, NULL, 'PROFILIN-2', 241156),
(319118, 'PTHR11604:SF28', NULL, NULL, NULL, NULL, 'PROFILIN-3', 241156),
(319119, 'PTHR11604:SF6', NULL, NULL, NULL, NULL, 'PROFILIN-1', 241156),
(319120, 'PTHR11604:SF5', NULL, NULL, NULL, NULL, '', 241156),
(319121, 'PTHR11604:SF49', NULL, NULL, NULL, NULL, 'PROFILIN LP04', 241156),
(319122, 'PTHR11604:SF26', NULL, NULL, NULL, NULL, 'PROFILIN-4', 241156),
(319123, 'PTHR11604:SF25', NULL, NULL, NULL, NULL, 'PROFILIN-5', 241156),
(319124, 'PTHR11604', NULL, NULL, NULL, NULL, 'PROFILIN', 241156),
(319125, 'PTHR11604:SF31', NULL, NULL, NULL, NULL, 'PROFILIN', 241156),
(319126, 'PTHR11604:SF0', NULL, NULL, NULL, NULL, 'PROFILIN', 241156),
(319127, 'PTHR11604:SF51', NULL, NULL, NULL, NULL, 'PROFILIN-A', 241156),
(319128, 'PTHR46470', NULL, NULL, NULL, NULL, 'N-ACYLNEURAMINATE-9-PHOSPHATASE', 241157),
(319129, 'PTHR46470:SF3', NULL, NULL, NULL, NULL, 'N-ACYLNEURAMINATE-9-PHOSPHATASE', 241157),
(319130, 'PTHR46470:SF2', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE 3-PHOSPHATE PHOSPHATASE', 241157),
(319131, 'PTHR46470:SF4', NULL, NULL, NULL, NULL, '5-AMINO-6-(5-PHOSPHO-D-RIBITYLAMINO)URACIL PHOSPHATASE YIGB', 241157),
(319132, 'PTHR47608:SF1', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR KAZAL-TYPE 2', 241158),
(319133, 'PTHR47608', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR KAZAL-TYPE 2, SPINK2', 241158),
(319134, 'PTHR10259', NULL, NULL, NULL, NULL, 'THIOPURINE S-METHYLTRANSFERASE', 241159),
(319135, 'PTHR10259:SF21', NULL, NULL, NULL, NULL, 'PROKINETICIN DOMAIN-CONTAINING PROTEIN', 241159),
(319136, 'PTHR10259:SF11', NULL, NULL, NULL, NULL, 'THIOPURINE S-METHYLTRANSFERASE', 241159),
(319137, 'PTHR21517:SF3', NULL, NULL, NULL, NULL, 'APICAL JUNCTION COMPONENT 1 HOMOLOG', 241160);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(319138, 'PTHR21517', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 241160),
(319139, 'PTHR31966:SF13', NULL, NULL, NULL, NULL, 'OS07G0551400 PROTEIN', 241161),
(319140, 'PTHR31966:SF25', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 241161),
(319141, 'PTHR31966:SF15', NULL, NULL, NULL, NULL, 'UNIVERSAL STRESS PROTEIN MT2085-LIKE', 241161),
(319142, 'PTHR31966', NULL, NULL, NULL, NULL, 'OS01G0783500 PROTEIN', 241161),
(319143, 'PTHR31966:SF27', NULL, NULL, NULL, NULL, 'OS01G0783500 PROTEIN', 241161),
(319144, 'PTHR31966:SF28', NULL, NULL, NULL, NULL, 'UNIVERSAL STRESS PROTEIN MT2085-LIKE', 241161),
(319145, 'PTHR31966:SF18', NULL, NULL, NULL, NULL, 'UNIVERSAL STRESS PROTEIN PHOS32', 241161),
(319146, 'PTHR31966:SF29', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 241161),
(319147, 'PTHR31966:SF19', NULL, NULL, NULL, NULL, 'UNIVERSAL STRESS PROTEIN PHOS34', 241161),
(319148, 'PTHR31966:SF20', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 241161),
(319149, 'PTHR31966:SF3', NULL, NULL, NULL, NULL, 'OS05G0501700 PROTEIN', 241161),
(319150, 'PTHR31966:SF21', NULL, NULL, NULL, NULL, 'UNIVERSAL STRESS PROTEIN A-RELATED', 241161),
(319151, 'PTHR46692:SF9', NULL, NULL, NULL, NULL, 'INOSINE-URIDINE PREFERRING NUCLEOSIDE HYDROLASE', 241162),
(319152, 'PTHR46692:SF7', NULL, NULL, NULL, NULL, 'INOSINE-URIDINE PREFERRING NUCLEOSIDE HYDROLASE', 241162),
(319153, 'PTHR46692:SF12', NULL, NULL, NULL, NULL, '', 241162),
(319154, 'PTHR46692', NULL, NULL, NULL, NULL, 'INOSINE-URIDINE PREFERRING NUCLEOSIDE HYDROLASE FAMILY PROTEIN', 241162),
(319155, 'PTHR46692:SF1', NULL, NULL, NULL, NULL, 'INOSINE-URIDINE PREFERRING NUCLEOSIDE HYDROLASE FAMILY PROTEIN', 241162),
(319156, 'PTHR46692:SF13', NULL, NULL, NULL, NULL, 'INOSINE/URIDINE-PREFERRING NUCLEOSIDE HYDROLASE DOMAIN-CONTAINING PROTEIN-RELATED', 241162),
(319157, 'PTHR46692:SF5', NULL, NULL, NULL, NULL, 'OS05G0406100 PROTEIN', 241162),
(319158, 'PTHR46692:SF4', NULL, NULL, NULL, NULL, 'INOSINE-URIDINE PREFERRING NUCLEOSIDE HYDROLASE', 241162),
(319159, 'PTHR46692:SF2', NULL, NULL, NULL, NULL, 'INOSINE-URIDINE PREFERRING NUCLEOSIDE HYDROLASE FAMILY PROTEIN', 241162),
(319160, 'PTHR10841:SF20', NULL, NULL, NULL, NULL, 'SYNAPSIN-2', 241163),
(319161, 'PTHR10841:SF24', NULL, NULL, NULL, NULL, 'SYNAPSIN-1', 241163),
(319162, 'PTHR10841', NULL, NULL, NULL, NULL, 'SYNAPSIN', 241163),
(319163, 'PTHR10841:SF28', NULL, NULL, NULL, NULL, '', 241163),
(319164, 'PTHR10841:SF17', NULL, NULL, NULL, NULL, 'SYNAPSIN', 241163),
(319165, 'PTHR10841:SF27', NULL, NULL, NULL, NULL, 'SYNAPSIN-3', 241163),
(319166, 'PTHR10841:SF26', NULL, NULL, NULL, NULL, 'SYNAPSIN IIA', 241163),
(319167, 'PTHR10841:SF6', NULL, NULL, NULL, NULL, 'SYNAPSIN III', 241163),
(319168, 'PTHR23331:SF1', NULL, NULL, NULL, NULL, 'WASH COMPLEX SUBUNIT 1', 241164),
(319169, 'PTHR23331:SF4', NULL, NULL, NULL, NULL, 'WAS/WASL-INTERACTING PROTEIN FAMILY MEMBER 3', 241164),
(319170, 'PTHR23331:SF3', NULL, NULL, NULL, NULL, 'WAS PROTEIN FAMILY HOMOLOG 4-RELATED', 241164),
(319171, 'PTHR23331:SF5', NULL, NULL, NULL, NULL, 'WAS PROTEIN FAMILY HOMOLOG 2-RELATED', 241164),
(319172, 'PTHR23331', NULL, NULL, NULL, NULL, 'CXYORF1', 241164),
(319173, 'PTHR30128:SF79', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I PSAA/PSAB-RELATED', 241165),
(319174, 'PTHR30128:SF78', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I PSAA/PSAB-RELATED', 241165),
(319175, 'PTHR30128:SF77', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I P700 CHLOROPHYLL A APOPROTEIN A1', 241165),
(319176, 'PTHR30128:SF76', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I PSAA/PSAB-RELATED', 241165),
(319177, 'PTHR30128:SF32', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN-ASSOCIATED LIPOPROTEIN', 241165),
(319178, 'PTHR30128', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN, OMPA-RELATED', 241165),
(319179, 'PTHR30128:SF70', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I P700 CHLOROPHYLL A APOPROTEIN A1', 241165),
(319180, 'PTHR30128:SF80', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I', 241165),
(319181, 'PTHR30128:SF19', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN A', 241165),
(319182, 'PTHR30128:SF75', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I P700 CHLOROPHYLL A APOPROTEIN A2', 241165); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(319183, 'PTHR30128:SF74', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN OMPA FAMILY', 241165),
(319184, 'PTHR36030', NULL, NULL, NULL, NULL, '', 241166),
(319185, 'PTHR36030:SF1', NULL, NULL, NULL, NULL, '', 241166),
(319186, 'PTHR36030:SF2', NULL, NULL, NULL, NULL, '', 241166),
(319187, 'PTHR36030:SF3', NULL, NULL, NULL, NULL, '', 241166),
(319188, 'PTHR36030:SF4', NULL, NULL, NULL, NULL, '', 241166),
(319189, 'PTHR36030:SF5', NULL, NULL, NULL, NULL, '', 241166),
(319190, 'PTHR42691', NULL, NULL, NULL, NULL, 'ASPARTATE AMINOTRANSFERASE YHDR-RELATED', 241167),
(319191, 'PTHR42691:SF1', NULL, NULL, NULL, NULL, 'ASPARTATE AMINOTRANSFERASE YHDR-RELATED', 241167),
(319192, 'PTHR13504', NULL, NULL, NULL, NULL, 'FIDO DOMAIN-CONTAINING PROTEIN DDB_G0283145', 241168),
(319193, 'PTHR13504:SF35', NULL, NULL, NULL, NULL, 'PROTEIN ADENYLYLTRANSFERASE SOFIC', 241168),
(319194, 'PTHR13504:SF34', NULL, NULL, NULL, NULL, 'PROTEIN ADENYLYLTRANSFERASE FICD', 241168),
(319195, 'PTHR13504:SF33', NULL, NULL, NULL, NULL, 'FIDO DOMAIN-CONTAINING PROTEIN', 241168),
(319196, 'PTHR13504:SF38', NULL, NULL, NULL, NULL, 'PROTEIN ADENYLYLTRANSFERASE AQ_AA38-RELATED', 241168),
(319197, 'PTHR43308', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN ALPHA-RELATED', 241169),
(319198, 'PTHR43308:SF4', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN ALPHA', 241169),
(319199, 'PTHR43308:SF1', NULL, NULL, NULL, NULL, 'S-LAYER PROTEIN SLPA', 241169),
(319200, 'PTHR12498:SF0', NULL, NULL, NULL, NULL, 'PROTEIN N-TERMINAL ASPARAGINE AMIDOHYDROLASE', 241170),
(319201, 'PTHR12498', NULL, NULL, NULL, NULL, 'N-TERMINAL ASPARAGINE AMIDOHYDROLASE', 241170),
(319202, 'PTHR38117:SF1', NULL, NULL, NULL, NULL, '', 241171),
(319203, 'PTHR38117:SF2', NULL, NULL, NULL, NULL, '', 241171),
(319204, 'PTHR38117', NULL, NULL, NULL, NULL, '', 241171),
(319205, 'PTHR36805:SF4', NULL, NULL, NULL, NULL, 'AGENET DOMAIN-CONTAINING PROTEIN', 241172),
(319206, 'PTHR36805:SF7', NULL, NULL, NULL, NULL, 'AGENET DOMAIN-CONTAINING PROTEIN', 241172),
(319207, 'PTHR36805:SF8', NULL, NULL, NULL, NULL, 'BNAA02G11040D PROTEIN', 241172),
(319208, 'PTHR36805', NULL, NULL, NULL, NULL, 'AGENET DOMAIN-CONTAINING PROTEIN', 241172),
(319209, 'PTHR36805:SF6', NULL, NULL, NULL, NULL, 'BNAC03G15690D PROTEIN', 241172),
(319210, 'PTHR11655:SF29', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L9', 241173),
(319211, 'PTHR11655:SF39', NULL, NULL, NULL, NULL, 'BNAC02G12270D PROTEIN', 241173),
(319212, 'PTHR11655:SF17', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L6-RELATED', 241173),
(319213, 'PTHR11655:SF28', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L9', 241173),
(319214, 'PTHR11655', NULL, NULL, NULL, NULL, '60S/50S RIBOSOMAL PROTEIN L6/L9', 241173),
(319215, 'PTHR11655:SF16', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L9', 241173),
(319216, 'PTHR11655:SF37', NULL, NULL, NULL, NULL, 'BNAA02G22240D PROTEIN', 241173),
(319217, 'PTHR11655:SF14', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN L6, MITOCHONDRIAL', 241173),
(319218, 'PTHR11655:SF47', NULL, NULL, NULL, NULL, 'BNAANNG34360D PROTEIN', 241173),
(319219, 'PTHR11655:SF46', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L9', 241173),
(319220, 'PTHR11655:SF35', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L6 FAMILY-RELATED', 241173),
(319221, 'PTHR11655:SF34', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L9', 241173),
(319222, 'PTHR11655:SF45', NULL, NULL, NULL, NULL, '', 241173),
(319223, 'PTHR11655:SF33', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L6 DOMAIN-CONTAINING PROTEIN', 241173),
(319224, 'PTHR11655:SF44', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L9-1', 241173),
(319225, 'PTHR11655:SF43', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L9-2', 241173),
(319226, 'PTHR11655:SF42', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L6 DOMAIN-CONTAINING PROTEIN', 241173),
(319227, 'PTHR11655:SF31', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L9', 241173),
(319228, 'PTHR11655:SF30', NULL, NULL, NULL, NULL, '', 241173),
(319229, 'PTHR11655:SF41', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L9', 241173),
(319230, 'PTHR43334:SF1', NULL, NULL, NULL, NULL, 'ACETATE--COA LIGASE [ADP-FORMING]', 241174);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(319231, 'PTHR43334', NULL, NULL, NULL, NULL, 'ACETATE--COA LIGASE [ADP-FORMING]', 241174),
(319232, 'PTHR47743:SF1', NULL, NULL, NULL, NULL, 'CRACD-LIKE PROTEIN', 241175),
(319233, 'PTHR47743:SF2', NULL, NULL, NULL, NULL, 'ACROSOMAL PROTEIN KIAA1210', 241175),
(319234, 'PTHR47743', NULL, NULL, NULL, NULL, 'KIAA1210 / KIAA1211 FAMILY MEMBER', 241175),
(319235, 'PTHR13377:SF12', NULL, NULL, NULL, NULL, 'OS07G0655400 PROTEIN', 241176),
(319236, 'PTHR13377:SF10', NULL, NULL, NULL, NULL, 'BNAC01G39550D PROTEIN', 241176),
(319237, 'PTHR13377:SF13', NULL, NULL, NULL, NULL, 'RHOMBOID-LIKE PROTEIN 19', 241176),
(319238, 'PTHR13377:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 115', 241176),
(319239, 'PTHR13377', NULL, NULL, NULL, NULL, 'PLACENTAL PROTEIN 6', 241176),
(319240, 'PTHR13377:SF5', NULL, NULL, NULL, NULL, 'OS04G0103300 PROTEIN', 241176),
(319241, 'PTHR33573:SF17', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 4D1', 241177),
(319242, 'PTHR33573:SF39', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 3A2', 241177),
(319243, 'PTHR33573:SF19', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 241177),
(319244, 'PTHR33573:SF57', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 4B1', 241177),
(319245, 'PTHR33573:SF35', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 4U1', 241177),
(319246, 'PTHR33573:SF13', NULL, NULL, NULL, NULL, 'CASPARIAN STRIP MEMBRANE PROTEIN 2', 241177),
(319247, 'PTHR33573:SF36', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 4B1', 241177),
(319248, 'PTHR33573:SF58', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 241177),
(319249, 'PTHR33573:SF14', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 241177),
(319250, 'PTHR33573:SF59', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 241177),
(319251, 'PTHR33573:SF37', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 241177),
(319252, 'PTHR33573:SF15', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 4A4', 241177),
(319253, 'PTHR33573:SF16', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 241177),
(319254, 'PTHR33573:SF38', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 4A1', 241177),
(319255, 'PTHR33573:SF53', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 4A2', 241177),
(319256, 'PTHR33573:SF54', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 4B2', 241177),
(319257, 'PTHR33573:SF55', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 241177),
(319258, 'PTHR33573:SF33', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 241177),
(319259, 'PTHR33573:SF11', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 241177),
(319260, 'PTHR33573:SF56', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 4C1', 241177),
(319261, 'PTHR33573:SF50', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 4A3', 241177),
(319262, 'PTHR33573:SF51', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 241177),
(319263, 'PTHR33573:SF52', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 241177),
(319264, 'PTHR33573:SF30', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 2B1-RELATED', 241177),
(319265, 'PTHR33573:SF3', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 241177),
(319266, 'PTHR33573:SF46', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 2A1', 241177),
(319267, 'PTHR33573:SF47', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 1U1', 241177),
(319268, 'PTHR33573:SF48', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 3A1', 241177),
(319269, 'PTHR33573:SF49', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN UU-1', 241177),
(319270, 'PTHR33573:SF20', NULL, NULL, NULL, NULL, 'CASPARIAN STRIP MEMBRANE PROTEIN 4', 241177),
(319271, 'PTHR33573:SF42', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 241177),
(319272, 'PTHR33573:SF43', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 241177),
(319273, 'PTHR33573:SF44', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 4D1', 241177),
(319274, 'PTHR33573:SF45', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 241177),
(319275, 'PTHR33573:SF60', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 4B3', 241177),
(319276, 'PTHR33573:SF61', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 4A2', 241177),
(319277, 'PTHR33573', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 4A4', 241177),
(319278, 'PTHR33573:SF40', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 4D2', 241177),
(319279, 'PTHR33573:SF62', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 241177);
INSERT INTO "PUBLIC"."MODEL" VALUES
(319280, 'PTHR33573:SF63', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 241177),
(319281, 'PTHR33573:SF41', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 241177),
(319282, 'PTHR12506:SF70', NULL, NULL, NULL, NULL, 'BNAC04G00080D PROTEIN', 241178),
(319283, 'PTHR12506:SF71', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 32-LIKE', 241178),
(319284, 'PTHR12506:SF50', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 26', 241178),
(319285, 'PTHR12506:SF51', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 67-LIKE ISOFORM X1', 241178),
(319286, 'PTHR12506:SF52', NULL, NULL, NULL, NULL, 'BNAA02G35100D PROTEIN', 241178),
(319287, 'PTHR12506:SF75', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 67-LIKE ISOFORM X1', 241178),
(319288, 'PTHR12506', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE RELATED', 241178),
(319289, 'PTHR12506:SF65', NULL, NULL, NULL, NULL, 'BNAC03G34690D PROTEIN', 241178),
(319290, 'PTHR12506:SF43', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 32', 241178),
(319291, 'PTHR12506:SF66', NULL, NULL, NULL, NULL, 'BNAANNG03230D PROTEIN', 241178),
(319292, 'PTHR12506:SF67', NULL, NULL, NULL, NULL, 'BNAA07G07880D PROTEIN', 241178),
(319293, 'PTHR12506:SF46', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 12', 241178),
(319294, 'PTHR12506:SF47', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C3H FAMILY-RELATED', 241178),
(319295, 'PTHR12506:SF69', NULL, NULL, NULL, NULL, 'BNAA07G07850D PROTEIN', 241178),
(319296, 'PTHR12506:SF25', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 66', 241178),
(319297, 'PTHR12506:SF49', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 43', 241178),
(319298, 'PTHR12506:SF80', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 6', 241178),
(319299, 'PTHR12506:SF60', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 34', 241178),
(319300, 'PTHR12506:SF61', NULL, NULL, NULL, NULL, 'BNAA09G26730D PROTEIN', 241178),
(319301, 'PTHR12506:SF41', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 58', 241178),
(319302, 'PTHR12506:SF64', NULL, NULL, NULL, NULL, 'NUCLEIC ACID BINDING PROTEIN', 241178),
(319303, 'PTHR12506:SF20', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 67', 241178),
(319304, 'PTHR12506:SF18', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 33-RELATED', 241178),
(319305, 'PTHR12506:SF76', NULL, NULL, NULL, NULL, '', 241178),
(319306, 'PTHR12506:SF77', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 37', 241178),
(319307, 'PTHR12506:SF56', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C3H FAMILY-RELATED', 241178),
(319308, 'PTHR12506:SF78', NULL, NULL, NULL, NULL, 'BNAANNG12770D PROTEIN', 241178),
(319309, 'PTHR12506:SF79', NULL, NULL, NULL, NULL, 'ZINC FINGER C-X8-C-X5-C-X3-H TYPE FAMILY PROTEIN-RELATED', 241178),
(319310, 'PTHR12506:SF57', NULL, NULL, NULL, NULL, 'BNAA07G07840D PROTEIN', 241178),
(319311, 'PTHR12506:SF58', NULL, NULL, NULL, NULL, 'BNAA05G35010D PROTEIN', 241178),
(319312, 'PTHR12506:SF59', NULL, NULL, NULL, NULL, 'BNAA04G19090D PROTEIN', 241178),
(319313, 'PTHR36770:SF1', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I ASSEMBLY FACTOR PSA3, CHLOROPLASTIC', 241179),
(319314, 'PTHR36770', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I ASSEMBLY FACTOR PSA3, CHLOROPLASTIC', 241179),
(319315, 'PTHR37477', NULL, NULL, NULL, NULL, 'COBALT-PRECORRIN-5A HYDROLASE', 241180),
(319316, 'PTHR37477:SF1', NULL, NULL, NULL, NULL, 'COBALT-PRECORRIN-5A HYDROLASE', 241180),
(319317, 'PTHR33724', NULL, NULL, NULL, NULL, 'INTRAFLAGELLAR TRANSPORT PROTEIN 43 HOMOLOG', 241181),
(319318, 'PTHR33724:SF1', NULL, NULL, NULL, NULL, 'INTRAFLAGELLAR TRANSPORT PROTEIN 43 HOMOLOG', 241181),
(319319, 'PTHR31313', NULL, NULL, NULL, NULL, 'TY1 ENHANCER ACTIVATOR', 241182),
(319320, 'PTHR31313:SF81', NULL, NULL, NULL, NULL, 'TY1 ENHANCER ACTIVATOR-RELATED', 241182),
(319321, 'PTHR31313:SF82', NULL, NULL, NULL, NULL, 'ACTIVATORY PROTEIN CHA4', 241182);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(319322, 'PTHR31313:SF83', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 241182),
(319323, 'PTHR31313:SF4', NULL, NULL, NULL, NULL, 'CONIDIAL DEVELOPMENT PROTEIN FLUFFY', 241182),
(319324, 'PTHR31313:SF77', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 241182),
(319325, 'PTHR31313:SF78', NULL, NULL, NULL, NULL, 'FUNGAL_TRANS DOMAIN-CONTAINING PROTEIN', 241182),
(319326, 'PTHR31313:SF79', NULL, NULL, NULL, NULL, 'C6 FINGER DOMAIN-CONTAINING PROTEIN', 241182),
(319327, 'PTHR31313:SF84', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 241182),
(319328, 'PTHR31313:SF74', NULL, NULL, NULL, NULL, 'NITROGEN ASSIMILATION TRANSCRIPTION FACTOR NIRA', 241182),
(319329, 'PTHR33509', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENIS ABUNDANT PROTEIN 2-RELATED', 241183),
(319330, 'PTHR33509:SF18', NULL, NULL, NULL, NULL, 'OS08G0451300 PROTEIN', 241183),
(319331, 'PTHR33509:SF29', NULL, NULL, NULL, NULL, 'OS01G0314800 PROTEIN', 241183),
(319332, 'PTHR33509:SF27', NULL, NULL, NULL, NULL, 'BNAC08G10490D PROTEIN', 241183),
(319333, 'PTHR33509:SF28', NULL, NULL, NULL, NULL, 'PROTEIN SENESCENCE-ASSOCIATED GENE 21, MITOCHONDRIAL-LIKE', 241183),
(319334, 'PTHR33509:SF39', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENIS ABUNDANT PROTEIN 2', 241183),
(319335, 'PTHR33509:SF25', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN LEA5', 241183),
(319336, 'PTHR33509:SF37', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN LEA5-D-RELATED', 241183),
(319337, 'PTHR33509:SF15', NULL, NULL, NULL, NULL, 'OS03G0400700 PROTEIN', 241183),
(319338, 'PTHR33509:SF34', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENIS ABUNDANT PROTEIN 41', 241183),
(319339, 'PTHR33509:SF35', NULL, NULL, NULL, NULL, 'PROTEIN SENESCENCE-ASSOCIATED GENE 21, MITOCHONDRIAL-LIKE', 241183),
(319340, 'PTHR33509:SF3', NULL, NULL, NULL, NULL, 'OS05G0362600 PROTEIN', 241183),
(319341, 'PTHR33509:SF21', NULL, NULL, NULL, NULL, 'OS02G0564600 PROTEIN', 241183),
(319342, 'PTHR33509:SF22', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN 37', 241183),
(319343, 'PTHR33509:SF30', NULL, NULL, NULL, NULL, 'BNACNNG19220D PROTEIN', 241183),
(319344, 'PTHR33509:SF41', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETIC ACID-INDUCED PROTEIN ARG2-RELATED', 241183),
(319345, 'PTHR33509:SF31', NULL, NULL, NULL, NULL, 'BNAA02G36510D PROTEIN', 241183),
(319346, 'PTHR33509:SF40', NULL, NULL, NULL, NULL, 'PROTEIN SENESCENCE-ASSOCIATED GENE 21, MITOCHONDRIAL-LIKE', 241183),
(319347, 'PTHR33509:SF5', NULL, NULL, NULL, NULL, 'PROTEIN SENESCENCE-ASSOCIATED GENE 21, MITOCHONDRIAL', 241183),
(319348, 'PTHR44819:SF1', NULL, NULL, NULL, NULL, 'V-TYPE IMMUNOGLOBULIN DOMAIN-CONTAINING SUPPRESSOR OF T-CELL ACTIVATION', 241184),
(319349, 'PTHR44819', NULL, NULL, NULL, NULL, 'V-TYPE IMMUNOGLOBULIN DOMAIN-CONTAINING SUPPRESSOR OF T-CELL ACTIVATION', 241184),
(319350, 'PTHR46932:SF16', NULL, NULL, NULL, NULL, 'OS02G0585100 PROTEIN', 241185),
(319351, 'PTHR46932:SF17', NULL, NULL, NULL, NULL, 'COPPER TRANSPORT PROTEIN FAMILY', 241185),
(319352, 'PTHR46932', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 47', 241185),
(319353, 'PTHR46932:SF15', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 241185),
(319354, 'PTHR46932:SF12', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 47', 241185),
(319355, 'PTHR46932:SF13', NULL, NULL, NULL, NULL, 'OS04G0467950 PROTEIN', 241185),
(319356, 'PTHR46932:SF4', NULL, NULL, NULL, NULL, 'COPPER TRANSPORT PROTEIN FAMILY', 241185),
(319357, 'PTHR46932:SF10', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED DOMAIN PROTEIN', 241185),
(319358, 'PTHR46932:SF11', NULL, NULL, NULL, NULL, 'OS02G0582800 PROTEIN', 241185),
(319359, 'PTHR46932:SF6', NULL, NULL, NULL, NULL, '', 241185),
(319360, 'PTHR46932:SF5', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 241185),
(319361, 'PTHR46932:SF7', NULL, NULL, NULL, NULL, '', 241185),
(319362, 'PTHR46932:SF9', NULL, NULL, NULL, NULL, 'COPPER TRANSPORT PROTEIN FAMILY', 241185);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(319363, 'PTHR40289:SF1', NULL, NULL, NULL, NULL, 'SUSHI DOMAIN-CONTAINING PROTEIN', 241186),
(319364, 'PTHR40289', NULL, NULL, NULL, NULL, 'PROTEIN CBG04714', 241186),
(319365, 'PTHR45500:SF1', NULL, NULL, NULL, NULL, 'OS02G0202600 PROTEIN', 241187),
(319366, 'PTHR45500', NULL, NULL, NULL, NULL, 'OS02G0202600 PROTEIN', 241187),
(319367, 'PTHR47401', NULL, NULL, NULL, NULL, 'INTERLEUKIN-4', 241188),
(319368, 'PTHR47401:SF1', NULL, NULL, NULL, NULL, 'INTERLEUKIN-4', 241188),
(319369, 'PTHR14239:SF0', NULL, NULL, NULL, NULL, 'F420-DEPENDENT NADP REDUCTASE', 241189),
(319370, 'PTHR14239:SF3', NULL, NULL, NULL, NULL, 'METALLOREDUCTASE STEAP1-RELATED', 241189),
(319371, 'PTHR14239:SF5', NULL, NULL, NULL, NULL, 'METALLOREDUCTASE STEAP4', 241189),
(319372, 'PTHR14239:SF6', NULL, NULL, NULL, NULL, 'METALLOREDUCTASE STEAP2', 241189),
(319373, 'PTHR14239', NULL, NULL, NULL, NULL, 'DUDULIN-RELATED', 241189),
(319374, 'PTHR14239:SF8', NULL, NULL, NULL, NULL, 'METALLOREDUCTASE STEAP3', 241189),
(319375, 'PTHR14239:SF10', NULL, NULL, NULL, NULL, 'REDUCTASE-RELATED', 241189),
(319376, 'PTHR14239:SF9', NULL, NULL, NULL, NULL, 'STEAP FAMILY MEMBER 1B', 241189),
(319377, 'PTHR33132:SF121', NULL, NULL, NULL, NULL, 'BNAANNG27180D PROTEIN', 241190),
(319378, 'PTHR33132:SF120', NULL, NULL, NULL, NULL, '', 241190),
(319379, 'PTHR33132:SF123', NULL, NULL, NULL, NULL, 'SERINE-RICH PROTEIN-LIKE PROTEIN', 241190),
(319380, 'PTHR33132:SF122', NULL, NULL, NULL, NULL, '', 241190),
(319381, 'PTHR33132:SF125', NULL, NULL, NULL, NULL, '', 241190),
(319382, 'PTHR33132:SF103', NULL, NULL, NULL, NULL, 'BNAA07G38590D PROTEIN', 241190),
(319383, 'PTHR33132:SF124', NULL, NULL, NULL, NULL, '', 241190),
(319384, 'PTHR33132:SF127', NULL, NULL, NULL, NULL, 'OS06G0608000 PROTEIN', 241190),
(319385, 'PTHR33132:SF126', NULL, NULL, NULL, NULL, '', 241190),
(319386, 'PTHR33132:SF107', NULL, NULL, NULL, NULL, '', 241190),
(319387, 'PTHR33132:SF129', NULL, NULL, NULL, NULL, '', 241190),
(319388, 'PTHR33132:SF128', NULL, NULL, NULL, NULL, 'OS01G0778900 PROTEIN', 241190),
(319389, 'PTHR33132:SF109', NULL, NULL, NULL, NULL, '', 241190),
(319390, 'PTHR33132:SF108', NULL, NULL, NULL, NULL, 'OS02G0799600 PROTEIN', 241190),
(319391, 'PTHR33132:SF98', NULL, NULL, NULL, NULL, 'BNAC09G54130D PROTEIN', 241190),
(319392, 'PTHR33132:SF99', NULL, NULL, NULL, NULL, '', 241190),
(319393, 'PTHR33132:SF74', NULL, NULL, NULL, NULL, 'BNACNNG20100D PROTEIN', 241190),
(319394, 'PTHR33132:SF130', NULL, NULL, NULL, NULL, 'BNAC03G69280D PROTEIN', 241190),
(319395, 'PTHR33132:SF53', NULL, NULL, NULL, NULL, 'PLANT/F18G18-20 PROTEIN', 241190),
(319396, 'PTHR33132:SF36', NULL, NULL, NULL, NULL, '', 241190),
(319397, 'PTHR33132:SF110', NULL, NULL, NULL, NULL, 'SERINE-RICH PROTEIN-LIKE PROTEIN', 241190),
(319398, 'PTHR33132:SF132', NULL, NULL, NULL, NULL, '', 241190),
(319399, 'PTHR33132:SF131', NULL, NULL, NULL, NULL, '', 241190),
(319400, 'PTHR33132:SF112', NULL, NULL, NULL, NULL, '', 241190),
(319401, 'PTHR33132:SF134', NULL, NULL, NULL, NULL, 'OS02G0525600 PROTEIN', 241190),
(319402, 'PTHR33132:SF111', NULL, NULL, NULL, NULL, '', 241190),
(319403, 'PTHR33132:SF57', NULL, NULL, NULL, NULL, '', 241190),
(319404, 'PTHR33132:SF133', NULL, NULL, NULL, NULL, 'CHROMO DOMAIN-CONTAINING PROTEIN', 241190),
(319405, 'PTHR33132:SF79', NULL, NULL, NULL, NULL, 'BNAA05G14930D PROTEIN', 241190),
(319406, 'PTHR33132:SF114', NULL, NULL, NULL, NULL, '', 241190),
(319407, 'PTHR33132:SF113', NULL, NULL, NULL, NULL, 'SERINE-RICH PROTEIN-LIKE PROTEIN', 241190),
(319408, 'PTHR33132:SF91', NULL, NULL, NULL, NULL, 'OS04G0403900 PROTEIN', 241190),
(319409, 'PTHR33132:SF135', NULL, NULL, NULL, NULL, 'PLANT/F18G18-20 PROTEIN', 241190),
(319410, 'PTHR33132:SF116', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 241190),
(319411, 'PTHR33132:SF115', NULL, NULL, NULL, NULL, '', 241190),
(319412, 'PTHR33132:SF118', NULL, NULL, NULL, NULL, '', 241190),
(319413, 'PTHR33132:SF50', NULL, NULL, NULL, NULL, 'OS02G0799700 PROTEIN', 241190),
(319414, 'PTHR33132:SF117', NULL, NULL, NULL, NULL, '', 241190);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(319415, 'PTHR33132:SF95', NULL, NULL, NULL, NULL, '', 241190),
(319416, 'PTHR33132:SF92', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241190),
(319417, 'PTHR33132:SF93', NULL, NULL, NULL, NULL, 'BNACNNG68960D PROTEIN', 241190),
(319418, 'PTHR33132:SF119', NULL, NULL, NULL, NULL, '', 241190),
(319419, 'PTHR33132', NULL, NULL, NULL, NULL, 'OSJNBB0118P14.9 PROTEIN', 241190),
(319420, 'PTHR11683:SF10', NULL, NULL, NULL, NULL, 'NEURONAL MEMBRANE GLYCOPROTEIN M6-B', 241191),
(319421, 'PTHR11683:SF11', NULL, NULL, NULL, NULL, 'MYELIN PROTEOLIPID PROTEIN', 241191),
(319422, 'PTHR11683:SF12', NULL, NULL, NULL, NULL, 'M6, ISOFORM F', 241191),
(319423, 'PTHR11683:SF14', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN M6AA', 241191),
(319424, 'PTHR11683:SF15', NULL, NULL, NULL, NULL, 'DMALPHA2B', 241191),
(319425, 'PTHR11683:SF16', NULL, NULL, NULL, NULL, 'DMGAMMA1', 241191),
(319426, 'PTHR11683:SF17', NULL, NULL, NULL, NULL, 'DMALPHA1', 241191),
(319427, 'PTHR11683:SF4', NULL, NULL, NULL, NULL, 'NEURONAL MEMBRANE GLYCOPROTEIN M6-A', 241191),
(319428, 'PTHR11683', NULL, NULL, NULL, NULL, 'MYELIN PROTEOLIPID', 241191),
(319429, 'PTHR46048:SF3', NULL, NULL, NULL, NULL, 'HYDROXYCARBOXYLIC ACID RECEPTOR 1', 241192),
(319430, 'PTHR46048:SF1', NULL, NULL, NULL, NULL, 'OXOEICOSANOID RECEPTOR 1', 241192),
(319431, 'PTHR46048:SF10', NULL, NULL, NULL, NULL, 'HYDROXYCARBOXYLIC ACID RECEPTOR 1-4', 241192),
(319432, 'PTHR46048:SF7', NULL, NULL, NULL, NULL, '12-(S)-HYDROXY-5,8,10,14-EICOSATETRAENOIC ACID RECEPTOR', 241192),
(319433, 'PTHR46048', NULL, NULL, NULL, NULL, 'HYDROXYCARBOXYLIC ACID RECEPTOR 2', 241192),
(319434, 'PTHR46048:SF5', NULL, NULL, NULL, NULL, 'HYDROXYCARBOXYLIC ACID RECEPTOR 3', 241192),
(319435, 'PTHR46048:SF6', NULL, NULL, NULL, NULL, 'HYDROXYCARBOXYLIC ACID RECEPTOR 2', 241192),
(319436, 'PTHR45007', NULL, NULL, NULL, NULL, 'CARBOXYLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G07570)-RELATED', 241193),
(319437, 'PTHR45007:SF1', NULL, NULL, NULL, NULL, 'CARBOXYLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G07570)-RELATED', 241193),
(319438, 'PTHR22879:SF2', NULL, NULL, NULL, NULL, 'NUT FAMILY MEMBER 2F-RELATED', 241194),
(319439, 'PTHR22879', NULL, NULL, NULL, NULL, 'NUT FAMILY MEMBER 1', 241194),
(319440, 'PTHR22879:SF14', NULL, NULL, NULL, NULL, 'NUT FAMILY MEMBER 2A-RELATED', 241194),
(319441, 'PTHR22879:SF13', NULL, NULL, NULL, NULL, 'NUT FAMILY MEMBER 1', 241194),
(319442, 'PTHR30034:SF3', NULL, NULL, NULL, NULL, 'FLAGELLAR MOTOR SWITCH PROTEIN FLIM', 241195),
(319443, 'PTHR30034:SF6', NULL, NULL, NULL, NULL, 'FLAGELLAR MOTOR SWITCH PROTEIN FLIM', 241195),
(319444, 'PTHR30034:SF5', NULL, NULL, NULL, NULL, 'SECRETION SYSTEM APPARATUS PROTEIN SSAQ', 241195),
(319445, 'PTHR30034', NULL, NULL, NULL, NULL, 'FLAGELLAR MOTOR SWITCH PROTEIN FLIM', 241195),
(319446, 'PTHR47516', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS U-RELATED', 241196),
(319447, 'PTHR47516:SF1', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS U', 241196),
(319448, 'PTHR47516:SF2', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS U', 241196),
(319449, 'PTHR47516:SF3', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS U', 241196),
(319450, 'PTHR24230:SF17', NULL, NULL, NULL, NULL, 'GALANIN RECEPTOR TYPE 3', 241197),
(319451, 'PTHR24230:SF13', NULL, NULL, NULL, NULL, 'GALANIN RECEPTOR TYPE 2', 241197),
(319452, 'PTHR24230:SF59', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 84', 241197),
(319453, 'PTHR24230:SF53', NULL, NULL, NULL, NULL, 'UROTENSIN II RECEPTOR', 241197),
(319454, 'PTHR24230:SF75', NULL, NULL, NULL, NULL, 'CORAZONIN RECEPTOR, ISOFORM B', 241197),
(319455, 'PTHR24230:SF31', NULL, NULL, NULL, NULL, 'GALANIN RECEPTOR TYPE 1', 241197),
(319456, 'PTHR24230:SF76', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 241197),
(319457, 'PTHR24230:SF10', NULL, NULL, NULL, NULL, 'CYSTEINYL LEUKOTRIENE RECEPTOR 2', 241197),
(319458, 'PTHR24230:SF32', NULL, NULL, NULL, NULL, 'RELAXIN-3 RECEPTOR 2', 241197),
(319459, 'PTHR24230:SF55', NULL, NULL, NULL, NULL, 'GALANIN RECEPTOR 2-LIKE PROTEIN', 241197),
(319460, 'PTHR24230:SF12', NULL, NULL, NULL, NULL, 'CYSTEINYL LEUKOTRIENE RECEPTOR 1', 241197);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(319461, 'PTHR24230:SF78', NULL, NULL, NULL, NULL, 'KISS-1 RECEPTOR', 241197),
(319462, 'PTHR24230:SF51', NULL, NULL, NULL, NULL, 'LEUKOTRIENE B4 RECEPTOR 1', 241197),
(319463, 'PTHR24230:SF138', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 241197),
(319464, 'PTHR24230:SF158', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 241197),
(319465, 'PTHR24230:SF136', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 241197),
(319466, 'PTHR24230:SF159', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 241197),
(319467, 'PTHR24230:SF156', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR AH9.4-RELATED', 241197),
(319468, 'PTHR24230:SF157', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 241197),
(319469, 'PTHR24230:SF70', NULL, NULL, NULL, NULL, 'RELAXIN-3 RECEPTOR 1', 241197),
(319470, 'PTHR24230:SF154', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 241197),
(319471, 'PTHR24230:SF155', NULL, NULL, NULL, NULL, 'LEUKOTRIENE B4 RECEPTOR 2B', 241197),
(319472, 'PTHR24230:SF152', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 241197),
(319473, 'PTHR24230:SF131', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR 151', 241197),
(319474, 'PTHR24230:SF153', NULL, NULL, NULL, NULL, 'ALLATOSTATIN A RECEPTOR 2, ISOFORM A', 241197),
(319475, 'PTHR24230:SF8', NULL, NULL, NULL, NULL, 'LEUKOTRIENE B4 RECEPTOR 2', 241197),
(319476, 'PTHR24230:SF7', NULL, NULL, NULL, NULL, 'MELANIN-CONCENTRATING HORMONE RECEPTOR 2', 241197),
(319477, 'PTHR24230:SF0', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 24', 241197),
(319478, 'PTHR24230:SF1', NULL, NULL, NULL, NULL, 'KISS1 RECEPTOR B', 241197),
(319479, 'PTHR24230:SF49', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 241197),
(319480, 'PTHR24230:SF86', NULL, NULL, NULL, NULL, 'LEUKOTRIENE B4 RECEPTOR 2A', 241197),
(319481, 'PTHR24230:SF64', NULL, NULL, NULL, NULL, 'KISS1 RECEPTOR A', 241197),
(319482, 'PTHR24230', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR', 241197),
(319483, 'PTHR24230:SF82', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 241197),
(319484, 'PTHR24230:SF60', NULL, NULL, NULL, NULL, 'UROTENSIN-2 RECEPTOR', 241197),
(319485, 'PTHR24230:SF61', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 241197),
(319486, 'PTHR24230:SF84', NULL, NULL, NULL, NULL, 'UROTENSIN II RECEPTOR', 241197),
(319487, 'PTHR24230:SF128', NULL, NULL, NULL, NULL, 'SI:DKEY-148A17.5-RELATED', 241197),
(319488, 'PTHR24230:SF147', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 241197),
(319489, 'PTHR24230:SF123', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 241197),
(319490, 'PTHR24230:SF124', NULL, NULL, NULL, NULL, 'UROTENSIN-2 RECEPTOR 3', 241197),
(319491, 'PTHR24230:SF144', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 241197),
(319492, 'PTHR24230:SF141', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 241197),
(319493, 'PTHR24230:SF120', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR DAF-38', 241197),
(319494, 'PTHR46630:SF1', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 29', 241198),
(319495, 'PTHR46630', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 29', 241198),
(319496, 'PTHR12300:SF162', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN J', 241199),
(319497, 'PTHR12300:SF161', NULL, NULL, NULL, NULL, 'RECEPTOR EXPRESSION-ENHANCING PROTEIN', 241199),
(319498, 'PTHR12300:SF29', NULL, NULL, NULL, NULL, 'RECEPTOR EXPRESSION-ENHANCING PROTEIN 2', 241199),
(319499, 'PTHR12300:SF127', NULL, NULL, NULL, NULL, 'RECEPTOR EXPRESSION-ENHANCING PROTEIN', 241199),
(319500, 'PTHR12300:SF123', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN', 241199),
(319501, 'PTHR12300:SF22', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN A', 241199),
(319502, 'PTHR12300:SF154', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN', 241199);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(319503, 'PTHR12300:SF153', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN', 241199),
(319504, 'PTHR12300:SF152', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN', 241199),
(319505, 'PTHR12300:SF150', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN K', 241199),
(319506, 'PTHR12300:SF117', NULL, NULL, NULL, NULL, 'LP05237P-RELATED', 241199),
(319507, 'PTHR12300:SF116', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN D', 241199),
(319508, 'PTHR12300:SF114', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN', 241199),
(319509, 'PTHR12300:SF158', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN', 241199),
(319510, 'PTHR12300:SF113', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN H', 241199),
(319511, 'PTHR12300:SF157', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN C', 241199),
(319512, 'PTHR12300:SF156', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN', 241199),
(319513, 'PTHR12300:SF55', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN', 241199),
(319514, 'PTHR12300:SF99', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN F', 241199),
(319515, 'PTHR12300:SF98', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN', 241199),
(319516, 'PTHR12300:SF57', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 241199),
(319517, 'PTHR12300:SF119', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN B', 241199),
(319518, 'PTHR12300:SF93', NULL, NULL, NULL, NULL, 'RECEPTOR EXPRESSION-ENHANCING PROTEIN 5', 241199),
(319519, 'PTHR12300:SF95', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN', 241199),
(319520, 'PTHR12300:SF53', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN', 241199),
(319521, 'PTHR12300:SF143', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN', 241199),
(319522, 'PTHR12300:SF140', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN', 241199),
(319523, 'PTHR12300:SF182', NULL, NULL, NULL, NULL, 'ABSCISIC ACID-RESPONSIVE (TB2/DP1, HVA22) FAMILY PROTEIN', 241199),
(319524, 'PTHR12300:SF181', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN', 241199),
(319525, 'PTHR12300:SF180', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN', 241199),
(319526, 'PTHR12300:SF107', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN', 241199),
(319527, 'PTHR12300:SF105', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN G-RELATED', 241199),
(319528, 'PTHR12300:SF104', NULL, NULL, NULL, NULL, 'RECEPTOR EXPRESSION-ENHANCING PROTEIN', 241199),
(319529, 'PTHR12300:SF147', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN', 241199),
(319530, 'PTHR12300:SF146', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN', 241199),
(319531, 'PTHR12300:SF145', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN', 241199),
(319532, 'PTHR12300:SF100', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN', 241199),
(319533, 'PTHR12300:SF43', NULL, NULL, NULL, NULL, 'TB2/DP1, HVA22 FAMILY PROTEIN', 241199),
(319534, 'PTHR12300', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEINS', 241199),
(319535, 'PTHR12300:SF176', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN', 241199),
(319536, 'PTHR12300:SF132', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN', 241199),
(319537, 'PTHR12300:SF175', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN', 241199),
(319538, 'PTHR12300:SF174', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN E', 241199),
(319539, 'PTHR12300:SF173', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN', 241199),
(319540, 'PTHR12300:SF172', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN', 241199),
(319541, 'PTHR12300:SF139', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN', 241199),
(319542, 'PTHR12300:SF179', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN', 241199),
(319543, 'PTHR12300:SF178', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN', 241199),
(319544, 'PTHR12300:SF177', NULL, NULL, NULL, NULL, 'PROTEIN YOP1', 241199),
(319545, 'PTHR12300:SF133', NULL, NULL, NULL, NULL, 'RECEPTOR EXPRESSION-ENHANCING PROTEIN 6', 241199),
(319546, 'PTHR12300:SF33', NULL, NULL, NULL, NULL, 'RECEPTOR EXPRESSION-ENHANCING PROTEIN 1', 241199),
(319547, 'PTHR12300:SF34', NULL, NULL, NULL, NULL, 'RECEPTOR EXPRESSION-ENHANCING PROTEIN', 241199),
(319548, 'PTHR12300:SF36', NULL, NULL, NULL, NULL, 'RECEPTOR EXPRESSION-ENHANCING PROTEIN 4', 241199),
(319549, 'PTHR12300:SF39', NULL, NULL, NULL, NULL, 'RECEPTOR EXPRESSION-ENHANCING PROTEIN 3', 241199); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(319550, 'PTHR37216:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241200),
(319551, 'PTHR37216:SF3', NULL, NULL, NULL, NULL, '', 241200),
(319552, 'PTHR37216', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241200),
(319553, 'PTHR12375:SF45', NULL, NULL, NULL, NULL, 'LUC7 RELATED SPLICING FACTOR HOMOLOG', 241201),
(319554, 'PTHR12375:SF46', NULL, NULL, NULL, NULL, 'BNAC02G44170D PROTEIN', 241201),
(319555, 'PTHR12375:SF47', NULL, NULL, NULL, NULL, 'LUC7-LIKE PROTEIN 3', 241201),
(319556, 'PTHR12375:SF48', NULL, NULL, NULL, NULL, 'LUC7-LIKE (S. CEREVISIAE)', 241201),
(319557, 'PTHR12375:SF52', NULL, NULL, NULL, NULL, 'ZGC:158803', 241201),
(319558, 'PTHR12375:SF30', NULL, NULL, NULL, NULL, 'LD04387P', 241201),
(319559, 'PTHR12375:SF31', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN LUC7-LIKE 1-RELATED', 241201),
(319560, 'PTHR12375:SF53', NULL, NULL, NULL, NULL, 'ARGININE-ASPARTATE-RICH RNA BINDING PROTEIN-LIKE', 241201),
(319561, 'PTHR12375:SF43', NULL, NULL, NULL, NULL, '', 241201),
(319562, 'PTHR12375:SF50', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN LUC7-LIKE 2-RELATED', 241201),
(319563, 'PTHR12375:SF49', NULL, NULL, NULL, NULL, 'OS02G0605600 PROTEIN', 241201),
(319564, 'PTHR12375:SF28', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN LUC7-LIKE 2-RELATED', 241201),
(319565, 'PTHR12375', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN LUC7-RELATED', 241201),
(319566, 'PTHR14920', NULL, NULL, NULL, NULL, 'OSMOTIC AVOIDANCE ABNORMAL PROTEIN 1/WD REPEAT MEMBRANE PROTEIN', 241202),
(319567, 'PTHR14920:SF0', NULL, NULL, NULL, NULL, 'WD REPEAT DOMAIN 19-RELATED', 241202),
(319568, 'PTHR14920:SF1', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 241202),
(319569, 'PTHR14920:SF2', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 19', 241202),
(319570, 'PTHR14920:SF3', NULL, NULL, NULL, NULL, 'IFTA-1', 241202),
(319571, 'PTHR13989:SF40', NULL, NULL, NULL, NULL, 'RPA_C DOMAIN-CONTAINING PROTEIN', 241203),
(319572, 'PTHR13989:SF51', NULL, NULL, NULL, NULL, 'RPA_C DOMAIN-CONTAINING PROTEIN', 241203),
(319573, 'PTHR13989:SF50', NULL, NULL, NULL, NULL, '', 241203),
(319574, 'PTHR13989:SF30', NULL, NULL, NULL, NULL, 'REPLICATION PROTEIN A 32 KDA SUBUNIT C', 241203),
(319575, 'PTHR13989:SF33', NULL, NULL, NULL, NULL, 'CST COMPLEX SUBUNIT STN1', 241203),
(319576, 'PTHR13989:SF43', NULL, NULL, NULL, NULL, 'REPLICATION PROTEIN A 30 KDA SUBUNIT-RELATED', 241203),
(319577, 'PTHR13989:SF32', NULL, NULL, NULL, NULL, 'ROR1', 241203),
(319578, 'PTHR13989', NULL, NULL, NULL, NULL, 'REPLICATION PROTEIN A-RELATED', 241203),
(319579, 'PTHR13989:SF46', NULL, NULL, NULL, NULL, 'REPLICATION PROTEIN A 32 KDA SUBUNIT A-LIKE', 241203),
(319580, 'PTHR13989:SF35', NULL, NULL, NULL, NULL, 'RPA_C DOMAIN-CONTAINING PROTEIN', 241203),
(319581, 'PTHR13989:SF34', NULL, NULL, NULL, NULL, 'REPLICATION PROTEIN A 32 KDA SUBUNIT A', 241203),
(319582, 'PTHR13989:SF47', NULL, NULL, NULL, NULL, 'OB-FOLD NUCLEIC ACID BINDING DOMAIN (AFU_ORTHOLOGUE AFUA_2G13170)', 241203),
(319583, 'PTHR13989:SF49', NULL, NULL, NULL, NULL, 'REPLICATION PROTEIN A 32 KDA SUBUNIT B', 241203),
(319584, 'PTHR13989:SF16', NULL, NULL, NULL, NULL, 'REPLICATION PROTEIN A 32 KDA SUBUNIT', 241203),
(319585, 'PTHR30629:SF2', NULL, NULL, NULL, NULL, 'PROPHAGE INTEGRASE INTS-RELATED', 241204),
(319586, 'PTHR30629', NULL, NULL, NULL, NULL, 'PROPHAGE INTEGRASE', 241204),
(319587, 'PTHR30629:SF6', NULL, NULL, NULL, NULL, 'PROPHAGE INTEGRASE INTA-RELATED', 241204),
(319588, 'PTHR30629:SF9', NULL, NULL, NULL, NULL, 'PROTEIN INTB-RELATED', 241204),
(319589, 'PTHR32268:SF11', NULL, NULL, NULL, NULL, 'HOMOSERINE O-ACETYLTRANSFERASE', 241205),
(319590, 'PTHR32268:SF15', NULL, NULL, NULL, NULL, 'HOMOSERINE ACETYLTRANSFERASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_1G15350)', 241205),
(319591, 'PTHR32268:SF16', NULL, NULL, NULL, NULL, 'SERINE O-SUCCINYLTRANSFERASE', 241205),
(319592, 'PTHR32268', NULL, NULL, NULL, NULL, 'HOMOSERINE O-ACETYLTRANSFERASE', 241205),
(319593, 'PTHR42849', NULL, NULL, NULL, NULL, 'N-ACETYLNEURAMINATE LYASE', 241206),
(319594, 'PTHR42849:SF1', NULL, NULL, NULL, NULL, 'N-ACETYLNEURAMINATE LYASE', 241206);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(319595, 'PTHR37224', NULL, NULL, NULL, NULL, 'OS02G0804400 PROTEIN', 241207),
(319596, 'PTHR37224:SF1', NULL, NULL, NULL, NULL, 'OS02G0804400 PROTEIN', 241207),
(319597, 'PTHR43215:SF14', NULL, NULL, NULL, NULL, 'RADIAL SPOKE HEAD 1 HOMOLOG', 241208),
(319598, 'PTHR43215', NULL, NULL, NULL, NULL, 'RADIAL SPOKE HEAD 1 HOMOLOG', 241208),
(319599, 'PTHR43215:SF13', NULL, NULL, NULL, NULL, 'PROTEIN TIC 100', 241208),
(319600, 'PTHR43215:SF4', NULL, NULL, NULL, NULL, 'PROTEIN ACCUMULATION AND REPLICATION OF CHLOROPLASTS 3', 241208),
(319601, 'PTHR43215:SF12', NULL, NULL, NULL, NULL, 'HISTONE H3 K4-SPECIFIC METHYLTRANSFERASE SET7/9 FAMILY PROTEIN', 241208),
(319602, 'PTHR15668', NULL, NULL, NULL, NULL, 'JM1 PROTEIN', 241209),
(319603, 'PTHR15668:SF4', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 22', 241209),
(319604, 'PTHR43562:SF4', NULL, NULL, NULL, NULL, 'NA(+)/H(+) ANTIPORTER NHAS5', 241210),
(319605, 'PTHR43562:SF3', NULL, NULL, NULL, NULL, 'SODIUM ION/PROTON EXCHANGER (EUROFUNG)', 241210),
(319606, 'PTHR43562:SF2', NULL, NULL, NULL, NULL, 'SODIUM-HYDROGEN ANTIPORTER', 241210),
(319607, 'PTHR43562:SF1', NULL, NULL, NULL, NULL, 'NA(+)/H(+) ANTIPORTER YJBQ-RELATED', 241210),
(319608, 'PTHR43562', NULL, NULL, NULL, NULL, 'NAPA-TYPE SODIUM/HYDROGEN ANTIPORTER', 241210),
(319609, 'PTHR43032:SF2', NULL, NULL, NULL, NULL, 'BLL0505 PROTEIN', 241211),
(319610, 'PTHR43032', NULL, NULL, NULL, NULL, 'PROTEIN-METHIONINE-SULFOXIDE REDUCTASE', 241211),
(319611, 'PTHR43032:SF4', NULL, NULL, NULL, NULL, 'OXIDORED_MOLYB DOMAIN-CONTAINING PROTEIN', 241211),
(319612, 'PTHR43032:SF3', NULL, NULL, NULL, NULL, 'PROTEIN-METHIONINE-SULFOXIDE REDUCTASE CATALYTIC SUBUNIT MSRP', 241211),
(319613, 'PTHR43032:SF5', NULL, NULL, NULL, NULL, 'CONSERVED TRANSMEMBRANE PROTEIN-RELATED', 241211),
(319614, 'PTHR46440', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-D12-RELATED', 241212),
(319615, 'PTHR46440:SF1', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-D12', 241212),
(319616, 'PTHR46440:SF2', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-C12', 241212),
(319617, 'PTHR43451', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE (GNAT) FAMILY PROTEIN', 241213),
(319618, 'PTHR43451:SF1', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE-RELATED', 241213),
(319619, 'PTHR43855', NULL, NULL, NULL, NULL, 'THIOSULFATE SULFURTRANSFERASE', 241214),
(319620, 'PTHR43855:SF1', NULL, NULL, NULL, NULL, 'THIOSULFATE SULFURTRANSFERASE', 241214),
(319621, 'PTHR43855:SF2', NULL, NULL, NULL, NULL, 'THIOSULFATE SULFURTRANSFERASE-RELATED', 241214),
(319622, 'PTHR14526:SF2', NULL, NULL, NULL, NULL, 'AURORA KINASE A AND NINEIN-INTERACTING PROTEIN', 241215),
(319623, 'PTHR14526', NULL, NULL, NULL, NULL, 'AURORA KINASE A AND NINEIN-INTERACTING PROTEIN', 241215),
(319624, 'PTHR12998', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 241216),
(319625, 'PTHR12998:SF0', NULL, NULL, NULL, NULL, 'TRNA:M(4)X MODIFICATION ENZYME TRM13 HOMOLOG', 241216),
(319626, 'PTHR12998:SF1', NULL, NULL, NULL, NULL, 'TRNA:M(4)X MODIFICATION ENZYME TRM13', 241216),
(319627, 'PTHR37809', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S12 METHYLTHIOTRANSFERASE ACCESSORY FACTOR YCAO', 241217),
(319628, 'PTHR37809:SF1', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S12 METHYLTHIOTRANSFERASE ACCESSORY FACTOR YCAO', 241217),
(319629, 'PTHR33704', NULL, NULL, NULL, NULL, 'PROTEIN HEAT INTOLERANT 4-RELATED', 241218),
(319630, 'PTHR33704:SF1', NULL, NULL, NULL, NULL, 'PROTEIN HEAT INTOLERANT 4-RELATED', 241218),
(319631, 'PTHR33704:SF6', NULL, NULL, NULL, NULL, 'BNAC02G00570D PROTEIN', 241218),
(319632, 'PTHR33704:SF5', NULL, NULL, NULL, NULL, '', 241218),
(319633, 'PTHR41749:SF1', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 241219),
(319634, 'PTHR41749', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 241219),
(319635, 'PTHR16517:SF99', NULL, NULL, NULL, NULL, 'TUBBY-LIKE F-BOX PROTEIN 11', 241220),
(319636, 'PTHR16517:SF12', NULL, NULL, NULL, NULL, 'TUBBY-RELATED PROTEIN 1', 241220),
(319637, 'PTHR16517:SF95', NULL, NULL, NULL, NULL, 'TUBBY-LIKE F-BOX PROTEIN 14', 241220);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(319638, 'PTHR16517:SF50', NULL, NULL, NULL, NULL, 'TUBBY-LIKE F-BOX PROTEIN 7', 241220),
(319639, 'PTHR16517:SF7', NULL, NULL, NULL, NULL, 'PROTEIN KING TUBBY', 241220),
(319640, 'PTHR16517:SF97', NULL, NULL, NULL, NULL, 'TUBBY-LIKE F-BOX PROTEIN', 241220),
(319641, 'PTHR16517:SF142', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TUBBY FAMILY-RELATED', 241220),
(319642, 'PTHR16517:SF120', NULL, NULL, NULL, NULL, 'TUBBY-LIKE F-BOX PROTEIN', 241220),
(319643, 'PTHR16517:SF121', NULL, NULL, NULL, NULL, 'TUBBY-LIKE F-BOX PROTEIN', 241220),
(319644, 'PTHR16517:SF143', NULL, NULL, NULL, NULL, 'TUBBY-LIKE F-BOX PROTEIN 13', 241220),
(319645, 'PTHR16517:SF146', NULL, NULL, NULL, NULL, 'TUBBY-LIKE F-BOX PROTEIN', 241220),
(319646, 'PTHR16517:SF124', NULL, NULL, NULL, NULL, 'TUBBY-LIKE F-BOX PROTEIN', 241220),
(319647, 'PTHR16517:SF147', NULL, NULL, NULL, NULL, 'TUBBY-LIKE F-BOX PROTEIN 1', 241220),
(319648, 'PTHR16517:SF39', NULL, NULL, NULL, NULL, 'TUBBY-LIKE F-BOX PROTEIN 3', 241220),
(319649, 'PTHR16517:SF122', NULL, NULL, NULL, NULL, 'BNAA05G14540D PROTEIN', 241220),
(319650, 'PTHR16517:SF38', NULL, NULL, NULL, NULL, 'TUBBY-LIKE F-BOX PROTEIN 7', 241220),
(319651, 'PTHR16517:SF145', NULL, NULL, NULL, NULL, 'TUBBY-LIKE F-BOX PROTEIN', 241220),
(319652, 'PTHR16517:SF101', NULL, NULL, NULL, NULL, 'TUBBY-LIKE F-BOX PROTEIN 10-RELATED', 241220),
(319653, 'PTHR16517:SF128', NULL, NULL, NULL, NULL, 'BNAC08G46700D PROTEIN', 241220),
(319654, 'PTHR16517:SF107', NULL, NULL, NULL, NULL, 'TUBBY-LIKE F-BOX PROTEIN 11', 241220),
(319655, 'PTHR16517:SF104', NULL, NULL, NULL, NULL, 'TUBBY-LIKE F-BOX PROTEIN 6', 241220),
(319656, 'PTHR16517:SF148', NULL, NULL, NULL, NULL, 'TUB DOMAIN-CONTAINING PROTEIN', 241220),
(319657, 'PTHR16517:SF126', NULL, NULL, NULL, NULL, '', 241220),
(319658, 'PTHR16517:SF127', NULL, NULL, NULL, NULL, 'TUBBY-LIKE F-BOX PROTEIN', 241220),
(319659, 'PTHR16517:SF149', NULL, NULL, NULL, NULL, 'TUBBY-LIKE F-BOX PROTEIN 8', 241220),
(319660, 'PTHR16517:SF108', NULL, NULL, NULL, NULL, 'TUB-LIKE PROTEIN 4A', 241220),
(319661, 'PTHR16517:SF2', NULL, NULL, NULL, NULL, 'TUBBY-RELATED PROTEIN 4', 241220),
(319662, 'PTHR16517:SF1', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 35', 241220),
(319663, 'PTHR16517:SF24', NULL, NULL, NULL, NULL, 'TUBBY-RELATED PROTEIN 2', 241220),
(319664, 'PTHR16517:SF84', NULL, NULL, NULL, NULL, 'TUBBY-LIKE F-BOX PROTEIN 9', 241220),
(319665, 'PTHR16517:SF150', NULL, NULL, NULL, NULL, 'TUBBY-LIKE F-BOX PROTEIN 2', 241220),
(319666, 'PTHR16517:SF20', NULL, NULL, NULL, NULL, 'TUBBY PROTEIN HOMOLOG', 241220),
(319667, 'PTHR16517:SF86', NULL, NULL, NULL, NULL, 'TUBBY-LIKE F-BOX PROTEIN 1', 241220),
(319668, 'PTHR16517:SF131', NULL, NULL, NULL, NULL, 'TUBBY-LIKE PROTEIN 8', 241220),
(319669, 'PTHR16517:SF151', NULL, NULL, NULL, NULL, 'TUB DOMAIN-CONTAINING PROTEIN', 241220),
(319670, 'PTHR16517:SF152', NULL, NULL, NULL, NULL, '', 241220),
(319671, 'PTHR16517:SF114', NULL, NULL, NULL, NULL, 'TUBBY-LIKE F-BOX PROTEIN', 241220),
(319672, 'PTHR16517:SF136', NULL, NULL, NULL, NULL, 'TUBBY-LIKE F-BOX PROTEIN', 241220),
(319673, 'PTHR16517:SF111', NULL, NULL, NULL, NULL, 'SI:DKEY-220F10.4', 241220),
(319674, 'PTHR16517:SF134', NULL, NULL, NULL, NULL, 'TUBBY-LIKE F-BOX PROTEIN 2', 241220),
(319675, 'PTHR16517:SF115', NULL, NULL, NULL, NULL, 'TUB-LIKE PROTEIN 4B', 241220),
(319676, 'PTHR16517:SF116', NULL, NULL, NULL, NULL, 'TUBBY-LIKE F-BOX PROTEIN', 241220),
(319677, 'PTHR16517:SF138', NULL, NULL, NULL, NULL, 'TUBBY-RELATED PROTEIN 3', 241220),
(319678, 'PTHR16517:SF119', NULL, NULL, NULL, NULL, 'TUBBY-LIKE F-BOX PROTEIN 3-RELATED', 241220),
(319679, 'PTHR16517', NULL, NULL, NULL, NULL, 'TUBBY-RELATED', 241220),
(319680, 'PTHR22842', NULL, NULL, NULL, NULL, 'WD40 REPEAT PROTEIN', 241221),
(319681, 'PTHR22842:SF3', NULL, NULL, NULL, NULL, 'WD REPEAT DOMAIN-CONTAINING PROTEIN 83', 241221),
(319682, 'PTHR22842:SF1', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 241221),
(319683, 'PTHR14557:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AND UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN 1', 241222);
INSERT INTO "PUBLIC"."MODEL" VALUES
(319684, 'PTHR14557:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AND UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN 2', 241222),
(319685, 'PTHR14557:SF5', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 241222),
(319686, 'PTHR14557', NULL, NULL, NULL, NULL, 'PROTEIN C7ORF21', 241222),
(319687, 'PTHR20849:SF2', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4E-BINDING PROTEIN MEXTLI', 241223),
(319688, 'PTHR20849', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 241223),
(319689, 'PTHR33127:SF29', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', 241224),
(319690, 'PTHR33127:SF47', NULL, NULL, NULL, NULL, '', 241224),
(319691, 'PTHR33127:SF69', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 241224),
(319692, 'PTHR33127:SF28', NULL, NULL, NULL, NULL, 'CDC68-LIKE PROTEIN-RELATED', 241224),
(319693, 'PTHR33127:SF87', NULL, NULL, NULL, NULL, '', 241224),
(319694, 'PTHR33127:SF43', NULL, NULL, NULL, NULL, 'OS09G0380600 PROTEIN', 241224),
(319695, 'PTHR33127:SF88', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 241224),
(319696, 'PTHR33127:SF5', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 241224),
(319697, 'PTHR33127:SF67', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 241224),
(319698, 'PTHR33127:SF45', NULL, NULL, NULL, NULL, 'OS05G0143700 PROTEIN', 241224),
(319699, 'PTHR33127:SF68', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 241224),
(319700, 'PTHR33127:SF46', NULL, NULL, NULL, NULL, 'OS09G0340800 PROTEIN', 241224),
(319701, 'PTHR33127:SF24', NULL, NULL, NULL, NULL, 'OS08G0193000 PROTEIN', 241224),
(319702, 'PTHR33127:SF83', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REGULATION', 241224),
(319703, 'PTHR33127:SF84', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 241224),
(319704, 'PTHR33127:SF62', NULL, NULL, NULL, NULL, 'BNAA09G35900D PROTEIN', 241224),
(319705, 'PTHR33127:SF85', NULL, NULL, NULL, NULL, 'OS11G0436500 PROTEIN', 241224),
(319706, 'PTHR33127:SF63', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 241224),
(319707, 'PTHR33127:SF86', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN KIB4-RELATED', 241224),
(319708, 'PTHR33127:SF20', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 241224),
(319709, 'PTHR33127:SF42', NULL, NULL, NULL, NULL, 'F-BOX/KELCH-REPEAT PROTEIN', 241224),
(319710, 'PTHR33127', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 241224),
(319711, 'PTHR33127:SF70', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 241224),
(319712, 'PTHR33127:SF4', NULL, NULL, NULL, NULL, 'OS03G0779600 PROTEIN', 241224),
(319713, 'PTHR33127:SF36', NULL, NULL, NULL, NULL, 'OS06G0135800 PROTEIN', 241224),
(319714, 'PTHR33127:SF59', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 241224),
(319715, 'PTHR33127:SF37', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 241224),
(319716, 'PTHR33127:SF32', NULL, NULL, NULL, NULL, '', 241224),
(319717, 'PTHR33127:SF54', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 241224),
(319718, 'PTHR33127:SF33', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 241224),
(319719, 'PTHR33127:SF77', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 241224),
(319720, 'PTHR33127:SF34', NULL, NULL, NULL, NULL, '', 241224),
(319721, 'PTHR33127:SF35', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE-RELATED', 241224),
(319722, 'PTHR33127:SF57', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 241224),
(319723, 'PTHR33127:SF50', NULL, NULL, NULL, NULL, 'OS01G0885800 PROTEIN', 241224),
(319724, 'PTHR33127:SF52', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 241224),
(319725, 'PTHR33127:SF30', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 241224),
(319726, 'PTHR33127:SF74', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 241224),
(319727, 'PTHR33127:SF53', NULL, NULL, NULL, NULL, 'OS06G0702200 PROTEIN', 241224),
(319728, 'PTHR33127:SF75', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 241224),
(319729, 'PTHR33127:SF31', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 241224); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(319730, 'PTHR33127:SF81', NULL, NULL, NULL, NULL, 'OS09G0384900 PROTEIN', 241224),
(319731, 'PTHR33127:SF82', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 241224),
(319732, 'PTHR14464:SF5', NULL, NULL, NULL, NULL, 'DEFECTS IN MORPHOLOGY PROTEIN 1', 241225),
(319733, 'PTHR14464:SF4', NULL, NULL, NULL, NULL, 'EXONUCLEASE V', 241225),
(319734, 'PTHR14464', NULL, NULL, NULL, NULL, 'EXONUCLEASE V', 241225),
(319735, 'PTHR11241:SF7', NULL, NULL, NULL, NULL, 'DEOXYURIDINE 5''-TRIPHOSPHATE NUCLEOTIDOHYDROLASE', 241226),
(319736, 'PTHR11241:SF9', NULL, NULL, NULL, NULL, 'DEOXYURIDINE 5''-TRIPHOSPHATE NUCLEOTIDOHYDROLASE', 241226),
(319737, 'PTHR11241:SF8', NULL, NULL, NULL, NULL, 'DUTPASE DOMAIN-CONTAINING PROTEIN', 241226),
(319738, 'PTHR11241:SF10', NULL, NULL, NULL, NULL, 'DEOXYURIDINE 5''-TRIPHOSPHATE NUCLEOTIDOHYDROLASE', 241226),
(319739, 'PTHR11241:SF12', NULL, NULL, NULL, NULL, 'INACTIVE DEOXYURIDINE 5''-TRIPHOSPHATE NUCLEOTIDOHYDROLASE-LIKE PROTEIN FLJ16323-RELATED', 241226),
(319740, 'PTHR11241', NULL, NULL, NULL, NULL, 'DEOXYURIDINE 5''-TRIPHOSPHATE NUCLEOTIDOHYDROLASE', 241226),
(319741, 'PTHR11241:SF11', NULL, NULL, NULL, NULL, 'DEOXYURIDINE 5''-TRIPHOSPHATE NUCLEOTIDOHYDROLASE, MITOCHONDRIAL', 241226),
(319742, 'PTHR11241:SF0', NULL, NULL, NULL, NULL, 'DEOXYURIDINE 5''-TRIPHOSPHATE NUCLEOTIDOHYDROLASE', 241226),
(319743, 'PTHR35092', NULL, NULL, NULL, NULL, 'CHLORINASE MJ1651', 241227),
(319744, 'PTHR35092:SF1', NULL, NULL, NULL, NULL, 'CHLORINASE MJ1651', 241227),
(319745, 'PTHR44590:SF3', NULL, NULL, NULL, NULL, 'COESTERASE DOMAIN-CONTAINING PROTEIN', 241228),
(319746, 'PTHR44590:SF4', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 241228),
(319747, 'PTHR44590', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE-RELATED', 241228),
(319748, 'PTHR12725:SF115', NULL, NULL, NULL, NULL, 'BNAA10G12490D PROTEIN', 241229),
(319749, 'PTHR12725:SF81', NULL, NULL, NULL, NULL, 'OS03G0701200 PROTEIN', 241229),
(319750, 'PTHR12725:SF123', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF DISRUPTION OF TFIIS-LIKE', 241229),
(319751, 'PTHR12725:SF124', NULL, NULL, NULL, NULL, 'HALOACID DEHALOGENASE-LIKE HYDROLASE', 241229),
(319752, 'PTHR12725:SF113', NULL, NULL, NULL, NULL, 'HALOACID DEHALOGENASE-LIKE HYDROLASE', 241229),
(319753, 'PTHR12725:SF118', NULL, NULL, NULL, NULL, 'HAD HYDROLASE, SUBFAMILY IA-RELATED', 241229),
(319754, 'PTHR12725:SF119', NULL, NULL, NULL, NULL, 'OS07G0634400 PROTEIN', 241229),
(319755, 'PTHR12725:SF82', NULL, NULL, NULL, NULL, 'HALOACID DEHALOGENASE-LIKE HYDROLASE (HAD) SUPERFAMILY PROTEIN', 241229),
(319756, 'PTHR12725:SF116', NULL, NULL, NULL, NULL, 'BNAA10G27270D PROTEIN', 241229),
(319757, 'PTHR12725:SF71', NULL, NULL, NULL, NULL, 'OS01G0973000 PROTEIN', 241229),
(319758, 'PTHR12725:SF72', NULL, NULL, NULL, NULL, 'HALOACID DEHALOGENASE-LIKE HYDROLASE', 241229),
(319759, 'PTHR12725:SF117', NULL, NULL, NULL, NULL, 'HALOACID DEHALOGENASE-LIKE HYDROLASE', 241229),
(319760, 'PTHR12725:SF111', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 241229),
(319761, 'PTHR12725', NULL, NULL, NULL, NULL, 'HALOACID DEHALOGENASE-LIKE HYDROLASE', 241229),
(319762, 'PTHR12725:SF120', NULL, NULL, NULL, NULL, 'CATALYTIC/ HYDROLASE', 241229),
(319763, 'PTHR38781', NULL, NULL, NULL, NULL, 'ANTITOXIN DINJ-RELATED', 241230),
(319764, 'PTHR38781:SF1', NULL, NULL, NULL, NULL, 'ANTITOXIN DINJ-RELATED', 241230),
(319765, 'PTHR20861:SF1', NULL, NULL, NULL, NULL, 'HOMOSERINE KINASE', 241231),
(319766, 'PTHR20861:SF3', NULL, NULL, NULL, NULL, 'SHIKIMATE KINASE', 241231),
(319767, 'PTHR20861:SF8', NULL, NULL, NULL, NULL, 'HOMOSERINE KINASE', 241231),
(319768, 'PTHR20861:SF6', NULL, NULL, NULL, NULL, 'BETA-RIBOFURANOSYLAMINOBENZENE 5''-PHOSPHATE SYNTHASE', 241231),
(319769, 'PTHR20861', NULL, NULL, NULL, NULL, 'HOMOSERINE/4-DIPHOSPHOCYTIDYL-2-C-METHYL-D-ERYTHRITOL KINASE', 241231),
(319770, 'PTHR10122:SF0', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 5B, ISOFORM A-RELATED', 241232),
(319771, 'PTHR10122:SF19', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 5B-LIKE-RELATED', 241232);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(319772, 'PTHR10122:SF18', NULL, NULL, NULL, NULL, 'BNAC01G35940D PROTEIN', 241232),
(319773, 'PTHR10122:SF20', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 5B, MITOCHONDRIAL', 241232),
(319774, 'PTHR10122:SF13', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT VB', 241232),
(319775, 'PTHR10122', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 5B, MITOCHONDRIAL', 241232),
(319776, 'PTHR10122:SF11', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE POLYPEPTIDE VB', 241232),
(319777, 'PTHR10122:SF15', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 5B-2 MITOCHONDRIAL', 241232),
(319778, 'PTHR34933', NULL, NULL, NULL, NULL, 'FLAGELLAR L-RING PROTEIN', 241233),
(319779, 'PTHR34933:SF1', NULL, NULL, NULL, NULL, 'FLAGELLAR L-RING PROTEIN', 241233),
(319780, 'PTHR34933:SF3', NULL, NULL, NULL, NULL, 'FLAGELLAR L-RING PROTEIN', 241233),
(319781, 'PTHR37534:SF23', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 241234),
(319782, 'PTHR37534:SF24', NULL, NULL, NULL, NULL, 'MISCELLANEOUS ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)', 241234),
(319783, 'PTHR37534:SF43', NULL, NULL, NULL, NULL, 'FINGER DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G01850)-RELATED', 241234),
(319784, 'PTHR37534:SF21', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR PROTEIN UGA3', 241234),
(319785, 'PTHR37534:SF25', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN-RELATED', 241234),
(319786, 'PTHR37534:SF26', NULL, NULL, NULL, NULL, 'C6 ZINC FINGER DOMAIN-CONTAINING PROTEIN', 241234),
(319787, 'PTHR37534:SF41', NULL, NULL, NULL, NULL, 'SFGA', 241234),
(319788, 'PTHR37534:SF42', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN UME6', 241234),
(319789, 'PTHR37534:SF20', NULL, NULL, NULL, NULL, 'ZN(2)-C6 FUNGAL-TYPE DOMAIN-CONTAINING PROTEIN', 241234),
(319790, 'PTHR37534:SF40', NULL, NULL, NULL, NULL, 'ZN(2)-C6 FUNGAL-TYPE DOMAIN-CONTAINING PROTEIN', 241234),
(319791, 'PTHR37534:SF29', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 241234),
(319792, 'PTHR37534:SF12', NULL, NULL, NULL, NULL, 'NOSA PROTEIN-RELATED', 241234),
(319793, 'PTHR37534:SF10', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 241234),
(319794, 'PTHR37534:SF11', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 241234),
(319795, 'PTHR37534:SF38', NULL, NULL, NULL, NULL, 'ZN(2)-C6 FUNGAL-TYPE DOMAIN-CONTAINING PROTEIN', 241234),
(319796, 'PTHR37534:SF16', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 241234),
(319797, 'PTHR37534:SF17', NULL, NULL, NULL, NULL, 'ZN(2)-C6 FUNGAL-TYPE DOMAIN-CONTAINING PROTEIN', 241234),
(319798, 'PTHR37534:SF39', NULL, NULL, NULL, NULL, '', 241234),
(319799, 'PTHR37534:SF14', NULL, NULL, NULL, NULL, 'LYSINE BIOSYNTHESIS REGULATORY PROTEIN LYS14', 241234),
(319800, 'PTHR37534:SF36', NULL, NULL, NULL, NULL, 'ZN(2)-C6 FUNGAL-TYPE DOMAIN-CONTAINING PROTEIN', 241234),
(319801, 'PTHR37534:SF15', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 241234),
(319802, 'PTHR37534:SF37', NULL, NULL, NULL, NULL, 'ZN(2)-C6 FUNGAL-TYPE DOMAIN-CONTAINING PROTEIN', 241234),
(319803, 'PTHR37534:SF2', NULL, NULL, NULL, NULL, 'ADHESION AND HYPHAL REGULATOR 1', 241234),
(319804, 'PTHR37534:SF4', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 241234),
(319805, 'PTHR37534:SF3', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 241234),
(319806, 'PTHR37534:SF5', NULL, NULL, NULL, NULL, 'C6 ZINC FINGER DOMAIN-CONTAINING PROTEIN', 241234),
(319807, 'PTHR37534:SF8', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 241234),
(319808, 'PTHR37534:SF7', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 241234),
(319809, 'PTHR37534:SF9', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 241234),
(319810, 'PTHR37534:SF18', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 241234);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(319811, 'PTHR37534', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR PROTEIN UGA3', 241234),
(319812, 'PTHR15907:SF170', NULL, NULL, NULL, NULL, '', 241235),
(319813, 'PTHR15907:SF171', NULL, NULL, NULL, NULL, 'BNAC06G30300D PROTEIN', 241235),
(319814, 'PTHR15907:SF174', NULL, NULL, NULL, NULL, '', 241235),
(319815, 'PTHR15907:SF217', NULL, NULL, NULL, NULL, 'OS10G0560200 PROTEIN', 241235),
(319816, 'PTHR15907:SF216', NULL, NULL, NULL, NULL, 'PLAC8 FAMILY PROTEIN', 241235),
(319817, 'PTHR15907:SF219', NULL, NULL, NULL, NULL, 'CELL NUMBER REGULATOR 7', 241235),
(319818, 'PTHR15907:SF218', NULL, NULL, NULL, NULL, 'PLANT CADMIUM RESISTANCE 2', 241235),
(319819, 'PTHR15907:SF211', NULL, NULL, NULL, NULL, '', 241235),
(319820, 'PTHR15907:SF134', NULL, NULL, NULL, NULL, '', 241235),
(319821, 'PTHR15907:SF210', NULL, NULL, NULL, NULL, 'PROTEIN PLANT CADMIUM RESISTANCE 9', 241235),
(319822, 'PTHR15907:SF177', NULL, NULL, NULL, NULL, 'PROTEIN PLANT CADMIUM RESISTANCE 10', 241235),
(319823, 'PTHR15907:SF213', NULL, NULL, NULL, NULL, 'PROTEIN PLANT CADMIUM RESISTANCE 7-LIKE', 241235),
(319824, 'PTHR15907:SF136', NULL, NULL, NULL, NULL, 'CELL NUMBER REGULATOR 10', 241235),
(319825, 'PTHR15907:SF212', NULL, NULL, NULL, NULL, 'PROTEIN PLANT CADMIUM RESISTANCE 2-LIKE', 241235),
(319826, 'PTHR15907:SF135', NULL, NULL, NULL, NULL, 'PROTEIN PLANT CADMIUM RESISTANCE 12', 241235),
(319827, 'PTHR15907:SF215', NULL, NULL, NULL, NULL, 'PLAC8 FAMILY PROTEIN-RELATED', 241235),
(319828, 'PTHR15907:SF214', NULL, NULL, NULL, NULL, '', 241235),
(319829, 'PTHR15907:SF161', NULL, NULL, NULL, NULL, 'DUF614 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_1G14190)', 241235),
(319830, 'PTHR15907:SF160', NULL, NULL, NULL, NULL, 'CELL NUMBER REGULATOR 10-RELATED', 241235),
(319831, 'PTHR15907:SF91', NULL, NULL, NULL, NULL, 'CELL NUMBER REGULATOR 8', 241235),
(319832, 'PTHR15907', NULL, NULL, NULL, NULL, 'DUF614 FAMILY PROTEIN-RELATED', 241235),
(319833, 'PTHR15907:SF206', NULL, NULL, NULL, NULL, 'PROTEIN PLANT CADMIUM RESISTANCE 11', 241235),
(319834, 'PTHR15907:SF128', NULL, NULL, NULL, NULL, '', 241235),
(319835, 'PTHR15907:SF205', NULL, NULL, NULL, NULL, 'PROTEIN PLANT CADMIUM RESISTANCE 6', 241235),
(319836, 'PTHR15907:SF208', NULL, NULL, NULL, NULL, 'CELL NUMBER REGULATOR 6-LIKE', 241235),
(319837, 'PTHR15907:SF207', NULL, NULL, NULL, NULL, 'PLAC8 FAMILY PROTEIN', 241235),
(319838, 'PTHR15907:SF209', NULL, NULL, NULL, NULL, '', 241235),
(319839, 'PTHR15907:SF165', NULL, NULL, NULL, NULL, 'PROTEIN PLANT CADMIUM RESISTANCE 7-LIKE', 241235),
(319840, 'PTHR15907:SF120', NULL, NULL, NULL, NULL, '', 241235),
(319841, 'PTHR15907:SF164', NULL, NULL, NULL, NULL, 'BNAA09G45360D PROTEIN', 241235),
(319842, 'PTHR15907:SF200', NULL, NULL, NULL, NULL, 'DUF614 FAMILY PROTEIN', 241235),
(319843, 'PTHR15907:SF167', NULL, NULL, NULL, NULL, 'PLANT CADMIUM RESISTANCE PROTEIN', 241235),
(319844, 'PTHR15907:SF123', NULL, NULL, NULL, NULL, 'GENE1000 PROTEIN', 241235),
(319845, 'PTHR15907:SF166', NULL, NULL, NULL, NULL, 'BNAA02G11260D PROTEIN', 241235),
(319846, 'PTHR15907:SF122', NULL, NULL, NULL, NULL, 'PLAC8-LIKE PROTEIN 1', 241235),
(319847, 'PTHR15907:SF201', NULL, NULL, NULL, NULL, 'PLANT CADMIUM RESISTANCE PROTEIN', 241235),
(319848, 'PTHR15907:SF204', NULL, NULL, NULL, NULL, '', 241235),
(319849, 'PTHR15907:SF126', NULL, NULL, NULL, NULL, 'PROTEIN PLANT CADMIUM RESISTANCE 8-LIKE', 241235),
(319850, 'PTHR15907:SF192', NULL, NULL, NULL, NULL, 'CELL NUMBER REGULATOR 4', 241235),
(319851, 'PTHR15907:SF191', NULL, NULL, NULL, NULL, '', 241235),
(319852, 'PTHR15907:SF150', NULL, NULL, NULL, NULL, 'PROTEIN PLANT CADMIUM RESISTANCE 8', 241235),
(319853, 'PTHR15907:SF194', NULL, NULL, NULL, NULL, '', 241235),
(319854, 'PTHR15907:SF193', NULL, NULL, NULL, NULL, 'PROTEIN PLANT CADMIUM RESISTANCE 6-LIKE', 241235),
(319855, 'PTHR15907:SF152', NULL, NULL, NULL, NULL, 'CELL NUMBER REGULATOR 3', 241235),
(319856, 'PTHR15907:SF4', NULL, NULL, NULL, NULL, 'PLACENTA SPECIFIC 8 A', 241235),
(319857, 'PTHR15907:SF118', NULL, NULL, NULL, NULL, 'PLAC8 FAMILY PROTEIN', 241235); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(319858, 'PTHR15907:SF119', NULL, NULL, NULL, NULL, 'CELL NUMBER REGULATOR-LIKE PROTEIN', 241235),
(319859, 'PTHR15907:SF154', NULL, NULL, NULL, NULL, '', 241235),
(319860, 'PTHR15907:SF198', NULL, NULL, NULL, NULL, 'PROTEIN PLANT CADMIUM RESISTANCE 4-RELATED', 241235),
(319861, 'PTHR15907:SF197', NULL, NULL, NULL, NULL, 'PROTEIN PLANT CADMIUM RESISTANCE 2-LIKE', 241235),
(319862, 'PTHR15907:SF112', NULL, NULL, NULL, NULL, 'PLAC8 FAMILY PROTEIN', 241235),
(319863, 'PTHR15907:SF155', NULL, NULL, NULL, NULL, 'BNAA06G09660D PROTEIN', 241235),
(319864, 'PTHR15907:SF114', NULL, NULL, NULL, NULL, 'CELL NUMBER REGULATOR 2-LIKE ISOFORM X1', 241235),
(319865, 'PTHR15907:SF157', NULL, NULL, NULL, NULL, 'PLAC8 MOTIF-CONTAINING PROTEIN-RELATED', 241235),
(319866, 'PTHR15907:SF116', NULL, NULL, NULL, NULL, '', 241235),
(319867, 'PTHR15907:SF159', NULL, NULL, NULL, NULL, 'BNAA05G36430D PROTEIN', 241235),
(319868, 'PTHR15907:SF34', NULL, NULL, NULL, NULL, 'PLAC8 ONZIN-RELATED PROTEIN 1', 241235),
(319869, 'PTHR15907:SF32', NULL, NULL, NULL, NULL, 'PLACENTA-SPECIFIC GENE 8 PROTEIN', 241235),
(319870, 'PTHR15907:SF180', NULL, NULL, NULL, NULL, 'CELL NUMBER REGULATOR 3-RELATED', 241235),
(319871, 'PTHR15907:SF30', NULL, NULL, NULL, NULL, 'PLAC8 ONZIN-RELATED PROTEIN 2-RELATED', 241235),
(319872, 'PTHR15907:SF182', NULL, NULL, NULL, NULL, 'PROTEIN PLANT CADMIUM RESISTANCE 1-RELATED', 241235),
(319873, 'PTHR15907:SF185', NULL, NULL, NULL, NULL, 'PLAC8 MOTIF-CONTAINING PROTEIN-RELATED', 241235),
(319874, 'PTHR15907:SF140', NULL, NULL, NULL, NULL, 'CELL NUMBER REGULATOR 8-LIKE', 241235),
(319875, 'PTHR15907:SF184', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 241235),
(319876, 'PTHR15907:SF107', NULL, NULL, NULL, NULL, 'PLAC8 ONZIN-RELATED PROTEIN 6', 241235),
(319877, 'PTHR15907:SF187', NULL, NULL, NULL, NULL, 'PLAC8 MOTIF-CONTAINING PROTEIN-RELATED', 241235),
(319878, 'PTHR15907:SF220', NULL, NULL, NULL, NULL, 'PLAC8 MOTIF-CONTAINING PROTEIN-RELATED', 241235),
(319879, 'PTHR15907:SF186', NULL, NULL, NULL, NULL, 'CORNIFELIN HOMOLOG A-LIKE', 241235),
(319880, 'PTHR15907:SF142', NULL, NULL, NULL, NULL, 'PLAC8 FAMILY PROTEIN', 241235),
(319881, 'PTHR15907:SF222', NULL, NULL, NULL, NULL, 'PLAC8 MOTIF-CONTAINING PROTEIN-RELATED', 241235),
(319882, 'PTHR15907:SF189', NULL, NULL, NULL, NULL, 'DUF614 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_5G13250)', 241235),
(319883, 'PTHR15907:SF101', NULL, NULL, NULL, NULL, 'CELL NUMBER REGULATOR 1', 241235),
(319884, 'PTHR15907:SF188', NULL, NULL, NULL, NULL, 'CELL NUMBER REGULATOR 6-LIKE', 241235),
(319885, 'PTHR15907:SF221', NULL, NULL, NULL, NULL, 'PLAC8 FAMILY PROTEIN', 241235),
(319886, 'PTHR15907:SF103', NULL, NULL, NULL, NULL, 'PLAC8 ONZIN-RELATED PROTEIN 10', 241235),
(319887, 'PTHR15907:SF147', NULL, NULL, NULL, NULL, 'PROTEIN PLANT CADMIUM RESISTANCE 7', 241235),
(319888, 'PTHR15907:SF26', NULL, NULL, NULL, NULL, 'CORNIFELIN', 241235),
(319889, 'PTHR15907:SF223', NULL, NULL, NULL, NULL, '', 241235),
(319890, 'PTHR15907:SF105', NULL, NULL, NULL, NULL, 'PROTEIN PLANT CADMIUM RESISTANCE 4-LIKE', 241235),
(319891, 'PTHR15907:SF148', NULL, NULL, NULL, NULL, 'EARLY ZYGOTE PROTEIN', 241235),
(319892, 'PTHR15907:SF104', NULL, NULL, NULL, NULL, 'DUF614 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_5G00975)', 241235),
(319893, 'PTHR46815', NULL, NULL, NULL, NULL, 'PROTEIN KISH-B', 241236),
(319894, 'PTHR46815:SF1', NULL, NULL, NULL, NULL, 'PROTEIN KISH-B', 241236),
(319895, 'PTHR12642:SF1', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS PROTEIN NSA2 HOMOLOG', 241237),
(319896, 'PTHR12642', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS PROTEIN NSA2 HOMOLOG', 241237),
(319897, 'PTHR12642:SF0', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS PROTEIN NSA2 HOMOLOG', 241237),
(319898, 'PTHR12642:SF3', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS PROTEIN NSA2 HOMOLOG', 241237),
(319899, 'PTHR12642:SF2', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS PROTEIN NSA2 HOMOLOG', 241237),
(319900, 'PTHR12642:SF5', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS PROTEIN NSA2 HOMOLOG', 241237),
(319901, 'PTHR12642:SF4', NULL, NULL, NULL, NULL, '', 241237);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(319902, 'PTHR12642:SF6', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS PROTEIN NSA2 HOMOLOG', 241237),
(319903, 'PTHR33779', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241238),
(319904, 'PTHR33779:SF17', NULL, NULL, NULL, NULL, 'PHD DOMAIN-CONTAINING PROTEIN', 241238),
(319905, 'PTHR33779:SF19', NULL, NULL, NULL, NULL, 'ZINC ION BINDING PROTEIN', 241238),
(319906, 'PTHR33779:SF24', NULL, NULL, NULL, NULL, 'CHROMATIN REGULATOR PHD FAMILY-RELATED', 241238),
(319907, 'PTHR33779:SF14', NULL, NULL, NULL, NULL, 'OS02G0568600 PROTEIN', 241238),
(319908, 'PTHR33779:SF15', NULL, NULL, NULL, NULL, '', 241238),
(319909, 'PTHR33779:SF10', NULL, NULL, NULL, NULL, 'BNAA09G38550D PROTEIN', 241238),
(319910, 'PTHR33779:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241238),
(319911, 'PTHR33779:SF11', NULL, NULL, NULL, NULL, 'OS04G0551600 PROTEIN', 241238),
(319912, 'PTHR33779:SF22', NULL, NULL, NULL, NULL, '', 241238),
(319913, 'PTHR33779:SF23', NULL, NULL, NULL, NULL, 'ZINC ION BINDING PROTEIN', 241238),
(319914, 'PTHR31214', NULL, NULL, NULL, NULL, 'PROTEIN FAM221A-RELATED', 241239),
(319915, 'PTHR31214:SF3', NULL, NULL, NULL, NULL, 'PROTEIN FAM221B', 241239),
(319916, 'PTHR31214:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM221A', 241239),
(319917, 'PTHR31657:SF83', NULL, NULL, NULL, NULL, 'DRE-BINDING PROTEIN 1', 241240),
(319918, 'PTHR31657:SF40', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF062', 241240),
(319919, 'PTHR31657:SF84', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 241240),
(319920, 'PTHR31657:SF85', NULL, NULL, NULL, NULL, 'OS02G0638650 PROTEIN', 241240),
(319921, 'PTHR31657:SF20', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF061', 241240),
(319922, 'PTHR31657:SF42', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 241240),
(319923, 'PTHR31657:SF80', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING TRANSCRIPTION FACTOR', 241240),
(319924, 'PTHR31657:SF81', NULL, NULL, NULL, NULL, 'BNAA06G24070D PROTEIN', 241240),
(319925, 'PTHR31657:SF82', NULL, NULL, NULL, NULL, 'AP DOMAIN DRE BINDING FACTOR', 241240),
(319926, 'PTHR31657:SF18', NULL, NULL, NULL, NULL, 'AP2 DOMAIN CONTAINING PROTEIN, EXPRESSED', 241240),
(319927, 'PTHR31657:SF19', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF053', 241240),
(319928, 'PTHR31657:SF58', NULL, NULL, NULL, NULL, 'BNAC01G20660D PROTEIN', 241240),
(319929, 'PTHR31657:SF36', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF054', 241240),
(319930, 'PTHR31657:SF38', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF057', 241240),
(319931, 'PTHR31657:SF76', NULL, NULL, NULL, NULL, 'ETHYLENE RESPONSE FACTOR', 241240),
(319932, 'PTHR31657:SF33', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF055', 241240),
(319933, 'PTHR31657:SF55', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT BINDING PROTEIN 3', 241240),
(319934, 'PTHR31657:SF77', NULL, NULL, NULL, NULL, 'BNAA09G12290D PROTEIN', 241240),
(319935, 'PTHR31657:SF56', NULL, NULL, NULL, NULL, 'BNAC03G60650D PROTEIN', 241240),
(319936, 'PTHR31657:SF78', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR RAP2-4', 241240),
(319937, 'PTHR31657:SF79', NULL, NULL, NULL, NULL, 'AP2 DOMAIN CLASS TRANSCRIPTION FACTOR', 241240),
(319938, 'PTHR31657:SF57', NULL, NULL, NULL, NULL, 'BNAA02G34570D PROTEIN', 241240),
(319939, 'PTHR31657:SF35', NULL, NULL, NULL, NULL, 'AP2/EREBP TRANSCRIPTION FACTOR SUPERFAMILY PROTEIN-RELATED', 241240),
(319940, 'PTHR31657:SF72', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 241240),
(319941, 'PTHR31657:SF73', NULL, NULL, NULL, NULL, 'OS02G0752800 PROTEIN', 241240),
(319942, 'PTHR31657:SF74', NULL, NULL, NULL, NULL, 'OS10G0371100 PROTEIN', 241240),
(319943, 'PTHR31657:SF52', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 241240),
(319944, 'PTHR31657:SF75', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 241240),
(319945, 'PTHR31657:SF53', NULL, NULL, NULL, NULL, 'BNAC07G50590D PROTEIN', 241240);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(319946, 'PTHR31657:SF71', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 241240),
(319947, 'PTHR31657:SF29', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF056', 241240),
(319948, 'PTHR31657', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF061', 241240),
(319949, 'PTHR31657:SF47', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 241240),
(319950, 'PTHR31657:SF48', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 241240),
(319951, 'PTHR31657:SF27', NULL, NULL, NULL, NULL, 'BNAA01G05760D PROTEIN', 241240),
(319952, 'PTHR31657:SF49', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF060', 241240),
(319953, 'PTHR31657:SF28', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR RAP2-13', 241240),
(319954, 'PTHR31657:SF24', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 241240),
(319955, 'PTHR47372:SF50', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN, GROUP 3-LIKE', 241241),
(319956, 'PTHR47372:SF51', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT DOMAIN-CONTAINING PROTEIN / LEA DOMAIN-CONTAINING PROTEIN-RELATED', 241241),
(319957, 'PTHR47372:SF31', NULL, NULL, NULL, NULL, 'LATE EMBRYO ABUNDANCE PROTEIN', 241241),
(319958, 'PTHR47372:SF32', NULL, NULL, NULL, NULL, 'EMBRYOGENESIS ABUNDANT PROTEIN FAMILY PROTEIN, PUTATIVE-RELATED', 241241),
(319959, 'PTHR47372:SF33', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) PROTEIN-RELATED', 241241),
(319960, 'PTHR47372:SF11', NULL, NULL, NULL, NULL, 'RE19971P', 241241),
(319961, 'PTHR47372:SF2', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN 14', 241241),
(319962, 'PTHR47372:SF13', NULL, NULL, NULL, NULL, 'EMBRYONIC PROTEIN DC-8-LIKE', 241241),
(319963, 'PTHR47372:SF35', NULL, NULL, NULL, NULL, 'BNAC04G08680D PROTEIN', 241241),
(319964, 'PTHR47372:SF3', NULL, NULL, NULL, NULL, 'COLD-RESPONSIVE LEA/RAB-RELATED COR PROTEIN', 241241),
(319965, 'PTHR47372:SF36', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN (LEA) FAMILY PROTEIN', 241241),
(319966, 'PTHR47372:SF37', NULL, NULL, NULL, NULL, '', 241241),
(319967, 'PTHR47372:SF5', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN (LEA) FAMILY PROTEIN', 241241),
(319968, 'PTHR47372:SF16', NULL, NULL, NULL, NULL, 'BNAA01G28600D PROTEIN', 241241),
(319969, 'PTHR47372:SF38', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN', 241241),
(319970, 'PTHR47372:SF6', NULL, NULL, NULL, NULL, 'BNAA02G22630D PROTEIN', 241241),
(319971, 'PTHR47372:SF39', NULL, NULL, NULL, NULL, 'KDA SEED MATURATION PROTEIN, PUTATIVE-RELATED', 241241),
(319972, 'PTHR47372:SF18', NULL, NULL, NULL, NULL, 'GROUP 3 LEA PROTEIN', 241241),
(319973, 'PTHR47372:SF40', NULL, NULL, NULL, NULL, '', 241241),
(319974, 'PTHR47372:SF41', NULL, NULL, NULL, NULL, 'COLD ACCLIMATION PROTEIN WCOR615', 241241),
(319975, 'PTHR47372:SF42', NULL, NULL, NULL, NULL, 'PROTEIN CBG04827', 241241),
(319976, 'PTHR47372:SF43', NULL, NULL, NULL, NULL, '', 241241),
(319977, 'PTHR47372:SF44', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN 7', 241241),
(319978, 'PTHR47372:SF45', NULL, NULL, NULL, NULL, 'BNAC05G37670D PROTEIN', 241241),
(319979, 'PTHR47372:SF24', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN (LEA) FAMILY PROTEIN', 241241),
(319980, 'PTHR47372:SF46', NULL, NULL, NULL, NULL, 'BNACNNG78600D PROTEIN', 241241),
(319981, 'PTHR47372:SF47', NULL, NULL, NULL, NULL, 'DAUER UP-REGULATED', 241241),
(319982, 'PTHR47372:SF48', NULL, NULL, NULL, NULL, 'BNAC03G23750D PROTEIN', 241241),
(319983, 'PTHR47372:SF49', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN 29', 241241),
(319984, 'PTHR47372', NULL, NULL, NULL, NULL, 'DAUER UP-REGULATED-RELATED', 241241),
(319985, 'PTHR10974:SF72', NULL, NULL, NULL, NULL, 'PROTEIN CBG03373', 241242),
(319986, 'PTHR10974:SF9', NULL, NULL, NULL, NULL, 'FI02830P-RELATED', 241242),
(319987, 'PTHR10974:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG09258', 241242),
(319988, 'PTHR10974:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG22535', 241242);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(319989, 'PTHR10974:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG19234', 241242),
(319990, 'PTHR10974:SF35', NULL, NULL, NULL, NULL, 'PROTEIN CBG09618', 241242),
(319991, 'PTHR10974:SF1', NULL, NULL, NULL, NULL, 'FI08016P-RELATED', 241242),
(319992, 'PTHR10974:SF69', NULL, NULL, NULL, NULL, 'PROTEIN CBG09637', 241242),
(319993, 'PTHR10974:SF66', NULL, NULL, NULL, NULL, 'PROTEIN CBG09726', 241242),
(319994, 'PTHR10974:SF75', NULL, NULL, NULL, NULL, 'PROTEIN CBG11140', 241242),
(319995, 'PTHR10974', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 241242),
(319996, 'PTHR10974:SF40', NULL, NULL, NULL, NULL, 'PROTEIN CBG05224', 241242),
(319997, 'PTHR10974:SF73', NULL, NULL, NULL, NULL, 'FI21235P1', 241242),
(319998, 'PTHR10974:SF74', NULL, NULL, NULL, NULL, '', 241242),
(319999, 'PTHR10974:SF39', NULL, NULL, NULL, NULL, '', 241242),
(320000, 'PTHR10974:SF37', NULL, NULL, NULL, NULL, '', 241242),
(320001, 'PTHR10974:SF48', NULL, NULL, NULL, NULL, 'PROTEIN CBG23355', 241242),
(320002, 'PTHR31846:SF19', NULL, NULL, NULL, NULL, 'CRM-DOMAIN CONTAINING FACTOR CFM3A, CHLOROPLASTIC/MITOCHONDRIAL', 241243),
(320003, 'PTHR31846:SF18', NULL, NULL, NULL, NULL, 'CRM-DOMAIN CONTAINING FACTOR CFM3B, CHLOROPLASTIC', 241243),
(320004, 'PTHR31846:SF17', NULL, NULL, NULL, NULL, '(CRM) DOMAIN PROTEIN, PUTATIVE-RELATED', 241243),
(320005, 'PTHR31846:SF7', NULL, NULL, NULL, NULL, 'CRS1 / YHBY (CRM) DOMAIN-CONTAINING PROTEIN', 241243),
(320006, 'PTHR31846', NULL, NULL, NULL, NULL, 'CRS1 / YHBY (CRM) DOMAIN-CONTAINING PROTEIN', 241243),
(320007, 'PTHR31846:SF4', NULL, NULL, NULL, NULL, 'CRS1 / YHBY (CRM) DOMAIN-CONTAINING PROTEIN', 241243),
(320008, 'PTHR31846:SF22', NULL, NULL, NULL, NULL, 'BNAANNG11170D PROTEIN', 241243),
(320009, 'PTHR31846:SF10', NULL, NULL, NULL, NULL, 'CHLOROPLASTIC GROUP IIA INTRON SPLICING FACILITATOR CRS1, CHLOROPLASTIC', 241243),
(320010, 'PTHR31846:SF20', NULL, NULL, NULL, NULL, 'CRM-DOMAIN CONTAINING FACTOR CFM2, CHLOROPLASTIC', 241243),
(320011, 'PTHR36427:SF4', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L1P/L10E FAMILY', 241244),
(320012, 'PTHR36427:SF3', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L1, MITOCHONDRIAL', 241244),
(320013, 'PTHR36427', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN L1, MITOCHONDRIAL', 241244),
(320014, 'PTHR12921:SF0', NULL, NULL, NULL, NULL, 'UBIQUITIN-FOLD MODIFIER-CONJUGATING ENZYME 1', 241245),
(320015, 'PTHR12921', NULL, NULL, NULL, NULL, 'UBIQUITIN-FOLD MODIFIER-CONJUGATING ENZYME 1', 241245),
(320016, 'PTHR46540:SF1', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 12', 241246),
(320017, 'PTHR46540', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 12', 241246),
(320018, 'PTHR39400:SF1', NULL, NULL, NULL, NULL, 'YALI0E29227P', 241247),
(320019, 'PTHR39400', NULL, NULL, NULL, NULL, 'YALI0E29227P', 241247),
(320020, 'PTHR36034:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241248),
(320021, 'PTHR36034:SF4', NULL, NULL, NULL, NULL, '', 241248),
(320022, 'PTHR36034:SF3', NULL, NULL, NULL, NULL, 'BNAA01G27160D PROTEIN', 241248),
(320023, 'PTHR36034', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241248),
(320024, 'PTHR35561:SF1', NULL, NULL, NULL, NULL, 'RNA 2'',3''-CYCLIC PHOSPHODIESTERASE', 241249),
(320025, 'PTHR35561', NULL, NULL, NULL, NULL, 'RNA 2'',3''-CYCLIC PHOSPHODIESTERASE', 241249),
(320026, 'PTHR31061', NULL, NULL, NULL, NULL, 'LD22376P', 241250),
(320027, 'PTHR31061:SF6', NULL, NULL, NULL, NULL, 'OS02G0526000 PROTEIN', 241250),
(320028, 'PTHR31061:SF5', NULL, NULL, NULL, NULL, 'HEPARAN-ALPHA-GLUCOSAMINIDE N-ACETYLTRANSFERASE-LIKE PROTEIN', 241250),
(320029, 'PTHR31061:SF28', NULL, NULL, NULL, NULL, 'DUF1624 DOMAIN-CONTAINING PROTEIN', 241250),
(320030, 'PTHR31061:SF37', NULL, NULL, NULL, NULL, 'HEPARAN-ALPHA-GLUCOSAMINIDE N-ACETYLTRANSFERASE', 241250),
(320031, 'PTHR31061:SF27', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241250),
(320032, 'PTHR31061:SF24', NULL, NULL, NULL, NULL, 'LD22376P', 241250),
(320033, 'PTHR31061:SF35', NULL, NULL, NULL, NULL, 'HEPARAN-ALPHA-GLUCOSAMINIDE N-ACETYLTRANSFERASE-LIKE PROTEIN', 241250);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(320034, 'PTHR31061:SF36', NULL, NULL, NULL, NULL, 'DUF1624 DOMAIN-CONTAINING PROTEIN', 241250),
(320035, 'PTHR31061:SF25', NULL, NULL, NULL, NULL, 'HEPARAN-ALPHA-GLUCOSAMINIDE N-ACETYLTRANSFERASE-LIKE PROTEIN (DUF1624)', 241250),
(320036, 'PTHR31061:SF23', NULL, NULL, NULL, NULL, 'OS05G0155700 PROTEIN', 241250),
(320037, 'PTHR31061:SF34', NULL, NULL, NULL, NULL, 'SI:DKEY-192P21.6', 241250),
(320038, 'PTHR31061:SF31', NULL, NULL, NULL, NULL, 'HEPARAN-ALPHA-GLUCOSAMINIDE N-ACETYLTRANSFERASE-LIKE', 241250),
(320039, 'PTHR43391:SF87', NULL, NULL, NULL, NULL, 'SHORT CHAIN DEHYDROGENASE/REDUCTASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_6G04120)', 241251),
(320040, 'PTHR43391:SF88', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/REDUCTASE-RELATED', 241251),
(320041, 'PTHR43391:SF66', NULL, NULL, NULL, NULL, '11-BETA-HYDROXYSTEROID DEHYDROGENASE-LIKE 4A', 241251),
(320042, 'PTHR43391:SF63', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', 241251),
(320043, 'PTHR43391:SF85', NULL, NULL, NULL, NULL, 'GLUCOSE/RIBITOL DEHYDROGENASE-RELATED', 241251),
(320044, 'PTHR43391:SF42', NULL, NULL, NULL, NULL, '11-BETA-HYDROXYSTEROID DEHYDROGENASE-LIKE 2-RELATED', 241251),
(320045, 'PTHR43391:SF86', NULL, NULL, NULL, NULL, 'OS12G0633800 PROTEIN', 241251),
(320046, 'PTHR43391:SF83', NULL, NULL, NULL, NULL, '', 241251),
(320047, 'PTHR43391:SF84', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', 241251),
(320048, 'PTHR43391:SF81', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 241251),
(320049, 'PTHR43391:SF82', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE SADH-RELATED', 241251),
(320050, 'PTHR43391:SF69', NULL, NULL, NULL, NULL, '11-BETA-HYDROXYSTEROID DEHYDROGENASE-LIKE 4A ISOFORM X1', 241251),
(320051, 'PTHR43391:SF26', NULL, NULL, NULL, NULL, 'BLL7251 PROTEIN', 241251),
(320052, 'PTHR43391:SF89', NULL, NULL, NULL, NULL, '11-BETA-HYDROXYSTEROID DEHYDROGENASE 1A', 241251),
(320053, 'PTHR43391:SF67', NULL, NULL, NULL, NULL, 'STEROLEOSIN', 241251),
(320054, 'PTHR43391:SF46', NULL, NULL, NULL, NULL, '11-BETA-HYDROXYSTEROID DEHYDROGENASE-LIKE 5', 241251),
(320055, 'PTHR43391:SF5', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/REDUCTASE FAMILY PROTEIN', 241251),
(320056, 'PTHR43391:SF1', NULL, NULL, NULL, NULL, 'ZMP:0000001048', 241251),
(320057, 'PTHR43391:SF76', NULL, NULL, NULL, NULL, '11-BETA-HYDROXYSTEROID DEHYDROGENASE-LIKE 6', 241251),
(320058, 'PTHR43391:SF54', NULL, NULL, NULL, NULL, 'OS12G0464400 PROTEIN', 241251),
(320059, 'PTHR43391:SF11', NULL, NULL, NULL, NULL, 'SHORT CHAIN DEHYDROGENASE/REDUCTASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_6G04850)', 241251),
(320060, 'PTHR43391:SF74', NULL, NULL, NULL, NULL, '', 241251),
(320061, 'PTHR43391:SF72', NULL, NULL, NULL, NULL, 'RETINOL DEHYDROGENASE', 241251),
(320062, 'PTHR43391:SF73', NULL, NULL, NULL, NULL, 'STEROLEOSIN', 241251),
(320063, 'PTHR43391:SF9', NULL, NULL, NULL, NULL, 'RETINOL DEHYDROGENASE', 241251),
(320064, 'PTHR43391:SF8', NULL, NULL, NULL, NULL, 'RETINOL DEHYDROGENASE 8', 241251),
(320065, 'PTHR43391:SF70', NULL, NULL, NULL, NULL, 'CHAIN OXIDOREDUCTASE/DEHYDROGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G01770)-RELATED', 241251),
(320066, 'PTHR43391:SF14', NULL, NULL, NULL, NULL, '11-BETA-HYDROXYSTEROID DEHYDROGENASE-LIKE 5', 241251),
(320067, 'PTHR43391:SF58', NULL, NULL, NULL, NULL, 'HYDROXYSTEROID DEHYDROGENASE 3-RELATED', 241251),
(320068, 'PTHR43391:SF15', NULL, NULL, NULL, NULL, '17-BETA-HYDROXYSTEROID DEHYDROGENASE TYPE 1', 241251),
(320069, 'PTHR43391:SF37', NULL, NULL, NULL, NULL, 'OS02G0511100 PROTEIN', 241251),
(320070, 'PTHR43391:SF34', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE SDR FAMILY PROTEIN 7-LIKE', 241251),
(320071, 'PTHR43391:SF12', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE EPHD-RELATED', 241251),
(320072, 'PTHR43391:SF78', NULL, NULL, NULL, NULL, '11-BETA-HYDROXYSTEROID DEHYDROGENASE 1B-LIKE ISOFORM X1', 241251),
(320073, 'PTHR43391', NULL, NULL, NULL, NULL, 'RETINOL DEHYDROGENASE-RELATED', 241251),
(320074, 'PTHR43771', NULL, NULL, NULL, NULL, 'PHOSPHOMANNOMUTASE', 241252),
(320075, 'PTHR43771:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOMANNOMUTASE', 241252);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(320076, 'PTHR43771:SF2', NULL, NULL, NULL, NULL, 'PHOSPHOMANNOMUTASE/PHOSPHOGLUCOMUTASE', 241252),
(320077, 'PTHR10315:SF117', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320078, 'PTHR10315:SF118', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320079, 'PTHR10315:SF119', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320080, 'PTHR10315:SF71', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320081, 'PTHR10315:SF157', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SINAT2-RELATED', 241253),
(320082, 'PTHR10315:SF158', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SINAT5', 241253),
(320083, 'PTHR10315:SF114', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320084, 'PTHR10315:SF159', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320085, 'PTHR10315:SF116', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320086, 'PTHR10315:SF153', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320087, 'PTHR10315:SF154', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320088, 'PTHR10315:SF110', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320089, 'PTHR10315:SF111', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE DIS1', 241253),
(320090, 'PTHR10315:SF155', NULL, NULL, NULL, NULL, 'IP10571P', 241253),
(320091, 'PTHR10315:SF156', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320092, 'PTHR10315:SF150', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320093, 'PTHR10315:SF151', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320094, 'PTHR10315:SF152', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320095, 'PTHR10315:SF83', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SINA-LIKE 11-RELATED', 241253),
(320096, 'PTHR10315:SF107', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320097, 'PTHR10315:SF81', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320098, 'PTHR10315:SF109', NULL, NULL, NULL, NULL, 'SIAH-TYPE DOMAIN-CONTAINING PROTEIN', 241253),
(320099, 'PTHR10315:SF146', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE', 241253),
(320100, 'PTHR10315:SF102', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320101, 'PTHR10315:SF147', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320102, 'PTHR10315:SF80', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SINAT3', 241253),
(320103, 'PTHR10315:SF103', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320104, 'PTHR10315:SF104', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320105, 'PTHR10315:SF148', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320106, 'PTHR10315:SF149', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320107, 'PTHR10315:SF105', NULL, NULL, NULL, NULL, 'SIAH-TYPE DOMAIN-CONTAINING PROTEIN', 241253),
(320108, 'PTHR10315:SF142', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320109, 'PTHR10315:SF145', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SINAT4', 241253),
(320110, 'PTHR10315:SF101', NULL, NULL, NULL, NULL, 'OS01G0122000 PROTEIN', 241253),
(320111, 'PTHR10315:SF139', NULL, NULL, NULL, NULL, '', 241253),
(320112, 'PTHR10315:SF90', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320113, 'PTHR10315:SF91', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320114, 'PTHR10315:SF131', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320115, 'PTHR10315:SF133', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320116, 'PTHR10315:SF134', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320117, 'PTHR10315:SF87', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE', 241253);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(320118, 'PTHR10315:SF130', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320119, 'PTHR10315:SF128', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320120, 'PTHR10315:SF129', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320121, 'PTHR10315:SF124', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320122, 'PTHR10315:SF126', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320123, 'PTHR10315', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN PROTEIN LIGASE SIAH', 241253),
(320124, 'PTHR10315:SF120', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320125, 'PTHR10315:SF121', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320126, 'PTHR10315:SF122', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320127, 'PTHR10315:SF98', NULL, NULL, NULL, NULL, 'SIAH-TYPE DOMAIN-CONTAINING PROTEIN', 241253),
(320128, 'PTHR10315:SF160', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320129, 'PTHR10315:SF161', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320130, 'PTHR10315:SF162', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320131, 'PTHR10315:SF96', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320132, 'PTHR10315:SF163', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241253),
(320133, 'PTHR34126:SF3', NULL, NULL, NULL, NULL, 'PEROXISOME BIOGENESIS PROTEIN 22-LIKE', 241254),
(320134, 'PTHR34126:SF6', NULL, NULL, NULL, NULL, 'BNACNNG43580D PROTEIN', 241254),
(320135, 'PTHR34126:SF1', NULL, NULL, NULL, NULL, 'PEROXISOME BIOGENESIS PROTEIN 22', 241254),
(320136, 'PTHR34126:SF7', NULL, NULL, NULL, NULL, '', 241254),
(320137, 'PTHR34126', NULL, NULL, NULL, NULL, 'PEROXISOME BIOGENESIS PROTEIN 22', 241254),
(320138, 'PTHR34126:SF10', NULL, NULL, NULL, NULL, '', 241254),
(320139, 'PTHR34126:SF8', NULL, NULL, NULL, NULL, 'BNACNNG26350D PROTEIN', 241254),
(320140, 'PTHR34126:SF9', NULL, NULL, NULL, NULL, 'PEROXISOME BIOGENESIS PROTEIN 22', 241254),
(320141, 'PTHR47382:SF6', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 241255),
(320142, 'PTHR47382:SF5', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 50-RELATED', 241255),
(320143, 'PTHR47382:SF7', NULL, NULL, NULL, NULL, 'ATP BINDING PROTEIN', 241255),
(320144, 'PTHR47382:SF1', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 52-LIKE', 241255),
(320145, 'PTHR47382:SF4', NULL, NULL, NULL, NULL, 'AMINOACYLTRANSFERASE, E1 UBIQUITIN-ACTIVATING ENZYME-RELATED', 241255),
(320146, 'PTHR47382', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 52-LIKE', 241255),
(320147, 'PTHR47382:SF3', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN', 241255),
(320148, 'PTHR23402:SF12', NULL, NULL, NULL, NULL, 'PROTEIN CBG19464', 241256),
(320149, 'PTHR23402:SF23', NULL, NULL, NULL, NULL, 'BNAA09G31040D PROTEIN', 241256),
(320150, 'PTHR23402:SF22', NULL, NULL, NULL, NULL, 'PEPTIDASE C15 PYROGLUTAMYL PEPTIDASE I-LIKE', 241256),
(320151, 'PTHR23402:SF27', NULL, NULL, NULL, NULL, 'PYROGLUTAMYL-PEPTIDASE I', 241256),
(320152, 'PTHR23402:SF16', NULL, NULL, NULL, NULL, 'PYROGLUTAMYL-PEPTIDASE 1', 241256),
(320153, 'PTHR23402:SF26', NULL, NULL, NULL, NULL, 'PEPTIDASE C15, PYROGLUTAMYL PEPTIDASE I-LIKE PROTEIN', 241256),
(320154, 'PTHR23402:SF15', NULL, NULL, NULL, NULL, 'PYROGLUTAMYL-PEPTIDASE 1-LIKE PROTEIN', 241256),
(320155, 'PTHR23402', NULL, NULL, NULL, NULL, 'PROTEASE FAMILY C15 PYROGLUTAMYL-PEPTIDASE I-RELATED', 241256),
(320156, 'PTHR23402:SF1', NULL, NULL, NULL, NULL, 'RE07960P', 241256),
(320157, 'PTHR23402:SF28', NULL, NULL, NULL, NULL, 'PYROGLUTAMYL-PEPTIDASE I LIKE', 241256),
(320158, 'PTHR15570:SF2', NULL, NULL, NULL, NULL, 'G0/G1 SWITCH PROTEIN 2', 241257),
(320159, 'PTHR15570', NULL, NULL, NULL, NULL, 'G0/G1 SWITCH PROTEIN 2', 241257),
(320160, 'PTHR35289', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 241258);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(320161, 'PTHR35289:SF1', NULL, NULL, NULL, NULL, 'ATP SYNTHASE 9 MITOCHONDRIAL-RELATED', 241258),
(320162, 'PTHR47919', NULL, NULL, NULL, NULL, 'INFECTION RESPONSE PROTEIN-RELATED', 241259),
(320163, 'PTHR47919:SF2', NULL, NULL, NULL, NULL, 'CUB DOMAIN-CONTAINING PROTEIN-RELATED', 241259),
(320164, 'PTHR47919:SF1', NULL, NULL, NULL, NULL, 'CUB_2 DOMAIN-CONTAINING PROTEIN', 241259),
(320165, 'PTHR34474:SF4', NULL, NULL, NULL, NULL, 'HEME OXYGENASE (STAPHYLOBILIN-PRODUCING) 1', 241260),
(320166, 'PTHR34474', NULL, NULL, NULL, NULL, 'SIGNAL TRANSDUCTION PROTEIN TRAP', 241260),
(320167, 'PTHR34474:SF1', NULL, NULL, NULL, NULL, 'HEME-DEGRADING MONOOXYGENASE HMOA', 241260),
(320168, 'PTHR34474:SF2', NULL, NULL, NULL, NULL, 'SIGNAL TRANSDUCTION PROTEIN TRAP', 241260),
(320169, 'PTHR18964:SF149', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL UDP-N-ACETYLGLUCOSAMINE 2-EPIMERASE/N-ACETYLMANNOSAMINE KINASE', 241261),
(320170, 'PTHR18964:SF146', NULL, NULL, NULL, NULL, 'POLYPHOSPHATE GLUCOKINASE', 241261),
(320171, 'PTHR18964', NULL, NULL, NULL, NULL, 'ROK (REPRESSOR, ORF, KINASE) FAMILY', 241261),
(320172, 'PTHR18964:SF169', NULL, NULL, NULL, NULL, 'N-ACETYLMANNOSAMINE KINASE', 241261),
(320173, 'PTHR18964:SF170', NULL, NULL, NULL, NULL, 'SUGAR KINASE-RELATED', 241261),
(320174, 'PTHR18964:SF173', NULL, NULL, NULL, NULL, 'GLUCOKINASE', 241261),
(320175, 'PTHR18964:SF162', NULL, NULL, NULL, NULL, 'N-ACETYL-D-GLUCOSAMINE KINASE', 241261),
(320176, 'PTHR18964:SF174', NULL, NULL, NULL, NULL, 'D-ALLOSE KINASE-RELATED', 241261),
(320177, 'PTHR18964:SF175', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINE REPRESSOR', 241261),
(320178, 'PTHR18964:SF110', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, XYLR-RELATED', 241261),
(320179, 'PTHR18964:SF165', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDE KINASE', 241261),
(320180, 'PTHR43163:SF4', NULL, NULL, NULL, NULL, 'PUTRESCINE EXPORT SYSTEM PERMEASE PROTEIN SAPB', 241262),
(320181, 'PTHR43163:SF5', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSPORT SYSTEM PERMEASE PROTEIN GSIC', 241262),
(320182, 'PTHR43163:SF6', NULL, NULL, NULL, NULL, 'DIPEPTIDE TRANSPORT SYSTEM PERMEASE PROTEIN DPPB-RELATED', 241262),
(320183, 'PTHR43163:SF7', NULL, NULL, NULL, NULL, 'PEPTIDE TRANSPORT SYSTEM INTEGRAL MEMBRANE PROTEIN-RELATED', 241262),
(320184, 'PTHR43163:SF8', NULL, NULL, NULL, NULL, 'D,D-DIPEPTIDE TRANSPORT SYSTEM PERMEASE PROTEIN DDPB-RELATED', 241262),
(320185, 'PTHR43163', NULL, NULL, NULL, NULL, 'DIPEPTIDE TRANSPORT SYSTEM PERMEASE PROTEIN DPPB-RELATED', 241262),
(320186, 'PTHR43163:SF2', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN', 241262),
(320187, 'PTHR43163:SF3', NULL, NULL, NULL, NULL, 'METAL TRANSPORT INTEGRAL MEMBRANE PROTEIN-RELATED', 241262),
(320188, 'PTHR35396', NULL, NULL, NULL, NULL, '', 241263),
(320189, 'PTHR35396:SF1', NULL, NULL, NULL, NULL, '', 241263),
(320190, 'PTHR10696:SF45', NULL, NULL, NULL, NULL, 'TAUD/TFDA-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 241264),
(320191, 'PTHR10696:SF56', NULL, NULL, NULL, NULL, 'TAUD DOMAIN-CONTAINING PROTEIN', 241264),
(320192, 'PTHR10696:SF46', NULL, NULL, NULL, NULL, 'TAUD DOMAIN-CONTAINING PROTEIN', 241264),
(320193, 'PTHR10696:SF25', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE AIM17-RELATED', 241264),
(320194, 'PTHR10696:SF49', NULL, NULL, NULL, NULL, 'TAUD DOMAIN-CONTAINING PROTEIN', 241264),
(320195, 'PTHR10696:SF51', NULL, NULL, NULL, NULL, 'TRIMETHYLLYSINE DIOXYGENASE, MITOCHONDRIAL', 241264),
(320196, 'PTHR10696:SF52', NULL, NULL, NULL, NULL, 'TAUD DOMAIN-CONTAINING PROTEIN', 241264),
(320197, 'PTHR10696:SF53', NULL, NULL, NULL, NULL, 'PAERUCUMARIN BIOSYNTHESIS PROTEIN PVCB', 241264),
(320198, 'PTHR10696:SF42', NULL, NULL, NULL, NULL, 'OS08G0383800 PROTEIN', 241264),
(320199, 'PTHR10696:SF43', NULL, NULL, NULL, NULL, 'TAUD/TFDA-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 241264),
(320200, 'PTHR10696:SF54', NULL, NULL, NULL, NULL, 'FAMILY OXIDOREDUCTASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G13850)-RELATED', 241264),
(320201, 'PTHR10696:SF21', NULL, NULL, NULL, NULL, 'TAUD DOMAIN-CONTAINING PROTEIN', 241264),
(320202, 'PTHR10696:SF44', NULL, NULL, NULL, NULL, 'TAUD/TFDA-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 241264);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(320203, 'PTHR10696:SF55', NULL, NULL, NULL, NULL, 'DIOXYGENASE, PUTATIVE-RELATED', 241264),
(320204, 'PTHR10696:SF33', NULL, NULL, NULL, NULL, 'GAMMA-BUTYROBETAINE DIOXYGENASE', 241264),
(320205, 'PTHR10696', NULL, NULL, NULL, NULL, 'GAMMA-BUTYROBETAINE HYDROXYLASE-RELATED', 241264),
(320206, 'PTHR37764', NULL, NULL, NULL, NULL, 'KETOSE/ALDOSE ISOMERASE, PUTATIVE (MOG1/PSBP/DUF1795-LIKE PHOTOSYSTEM II REACTION CENTER PSBP FAMILY PROTEIN)-RELATED', 241265),
(320207, 'PTHR37764:SF1', NULL, NULL, NULL, NULL, 'KETOSE/ALDOSE ISOMERASE, PUTATIVE (MOG1/PSBP/DUF1795-LIKE PHOTOSYSTEM II REACTION CENTER PSBP FAMILY PROTEIN)-RELATED', 241265),
(320208, 'PTHR10060:SF14', NULL, NULL, NULL, NULL, 'RELATED DEOXYRIBONUCLEASE, PUTATIVE-RELATED', 241266),
(320209, 'PTHR10060', NULL, NULL, NULL, NULL, 'TATD FAMILY DEOXYRIBONUCLEASE', 241266),
(320210, 'PTHR10060:SF47', NULL, NULL, NULL, NULL, '', 241266),
(320211, 'PTHR10060:SF15', NULL, NULL, NULL, NULL, 'DEOXYRIBONUCLEASE TATDN1-RELATED', 241266),
(320212, 'PTHR10060:SF16', NULL, NULL, NULL, NULL, '', 241266),
(320213, 'PTHR10060:SF20', NULL, NULL, NULL, NULL, 'FI03671P', 241266),
(320214, 'PTHR31696:SF82', NULL, NULL, NULL, NULL, 'BNAC03G23430D PROTEIN', 241267),
(320215, 'PTHR31696:SF83', NULL, NULL, NULL, NULL, 'BNAC04G01990D PROTEIN', 241267),
(320216, 'PTHR31696:SF61', NULL, NULL, NULL, NULL, 'OS01G0268700 PROTEIN', 241267),
(320217, 'PTHR31696:SF62', NULL, NULL, NULL, NULL, 'OS08G0476600 PROTEIN', 241267),
(320218, 'PTHR31696:SF63', NULL, NULL, NULL, NULL, 'PROTEIN MIZU-KUSSEI 1-LIKE', 241267),
(320219, 'PTHR31696:SF64', NULL, NULL, NULL, NULL, 'OS03G0733266 PROTEIN', 241267),
(320220, 'PTHR31696:SF86', NULL, NULL, NULL, NULL, '', 241267),
(320221, 'PTHR31696:SF87', NULL, NULL, NULL, NULL, 'OS06G0495800 PROTEIN', 241267),
(320222, 'PTHR31696:SF66', NULL, NULL, NULL, NULL, 'PROTEIN MIZU-KUSSEI 1', 241267),
(320223, 'PTHR31696:SF88', NULL, NULL, NULL, NULL, 'BNAC04G02000D PROTEIN', 241267),
(320224, 'PTHR31696:SF23', NULL, NULL, NULL, NULL, 'OS01G0642600 PROTEIN', 241267),
(320225, 'PTHR31696:SF68', NULL, NULL, NULL, NULL, 'BNAC03G76390D PROTEIN', 241267),
(320226, 'PTHR31696:SF69', NULL, NULL, NULL, NULL, 'PROTEIN MIZU-KUSSEI 1-LIKE', 241267),
(320227, 'PTHR31696:SF27', NULL, NULL, NULL, NULL, 'OS03G0811550 PROTEIN', 241267),
(320228, 'PTHR31696:SF3', NULL, NULL, NULL, NULL, 'OS09G0463600 PROTEIN', 241267),
(320229, 'PTHR31696:SF4', NULL, NULL, NULL, NULL, 'OS08G0171800 PROTEIN', 241267),
(320230, 'PTHR31696:SF90', NULL, NULL, NULL, NULL, 'BNAA02G27570D PROTEIN', 241267),
(320231, 'PTHR31696:SF70', NULL, NULL, NULL, NULL, 'PROTEIN MIZU-KUSSEI 1-LIKE', 241267),
(320232, 'PTHR31696:SF71', NULL, NULL, NULL, NULL, 'PROTEIN MIZU-KUSSEI 1', 241267),
(320233, 'PTHR31696:SF72', NULL, NULL, NULL, NULL, 'OS05G0280000 PROTEIN', 241267),
(320234, 'PTHR31696:SF73', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241267),
(320235, 'PTHR31696:SF75', NULL, NULL, NULL, NULL, 'PROTEIN MIZU-KUSSEI 1-LIKE', 241267),
(320236, 'PTHR31696:SF76', NULL, NULL, NULL, NULL, 'BNAA09G05420D PROTEIN', 241267),
(320237, 'PTHR31696:SF78', NULL, NULL, NULL, NULL, '', 241267),
(320238, 'PTHR31696:SF57', NULL, NULL, NULL, NULL, 'OS05G0577100 PROTEIN', 241267),
(320239, 'PTHR31696:SF58', NULL, NULL, NULL, NULL, 'OS02G0709600 PROTEIN', 241267),
(320240, 'PTHR31696:SF14', NULL, NULL, NULL, NULL, 'PLANT-SPECIFIC DOMAIN TIGR01570 FAMILY PROTEIN', 241267),
(320241, 'PTHR31696:SF59', NULL, NULL, NULL, NULL, 'OS04G0638800 PROTEIN', 241267),
(320242, 'PTHR31696', NULL, NULL, NULL, NULL, 'PROTEIN MIZU-KUSSEI 1', 241267),
(320243, 'PTHR31696:SF81', NULL, NULL, NULL, NULL, '', 241267),
(320244, 'PTHR22704:SF1', NULL, NULL, NULL, NULL, 'BMERB DOMAIN-CONTAINING PROTEIN 1', 241268),
(320245, 'PTHR22704:SF2', NULL, NULL, NULL, NULL, 'BMERB DOMAIN-CONTAINING PROTEIN', 241268),
(320246, 'PTHR22704', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 241268),
(320247, 'PTHR45508', NULL, NULL, NULL, NULL, 'RHODANESE-LIKE DOMAIN-CONTAINING PROTEIN 9, CHLOROPLASTIC', 241269),
(320248, 'PTHR45508:SF1', NULL, NULL, NULL, NULL, 'RHODANESE-LIKE DOMAIN-CONTAINING PROTEIN 9, CHLOROPLASTIC', 241269);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(320249, 'PTHR43603', NULL, NULL, NULL, NULL, 'COBW DOMAIN-CONTAINING PROTEIN DDB_G0274527', 241270),
(320250, 'PTHR43603:SF3', NULL, NULL, NULL, NULL, 'METAL CHAPERONE YCIC-RELATED', 241270),
(320251, 'PTHR43603:SF1', NULL, NULL, NULL, NULL, 'COBW DOMAIN-CONTAINING PROTEIN DDB_G0274527', 241270),
(320252, 'PTHR43603:SF2', NULL, NULL, NULL, NULL, 'COBW C-TERMINAL DOMAIN-CONTAINING PROTEIN', 241270),
(320253, 'PTHR12610:SF22', NULL, NULL, NULL, NULL, 'SINGLE-STRANDED DNA-BINDING PROTEIN 3', 241271),
(320254, 'PTHR12610:SF30', NULL, NULL, NULL, NULL, 'SINGLE-STRANDED DNA-BINDING PROTEIN 4', 241271),
(320255, 'PTHR12610:SF31', NULL, NULL, NULL, NULL, 'SINGLE STRANDED DNA-BINDING PROTEIN 3B', 241271),
(320256, 'PTHR12610:SF12', NULL, NULL, NULL, NULL, 'SEQUENCE-SPECIFIC SINGLE-STRANDED DNA-BINDING PROTEIN, ISOFORM D', 241271),
(320257, 'PTHR12610:SF23', NULL, NULL, NULL, NULL, 'SINGLE-STRANDED DNA-BINDING PROTEIN 2', 241271),
(320258, 'PTHR12610', NULL, NULL, NULL, NULL, 'SINGLE STRANDED DNA BINDING PROTEIN', 241271),
(320259, 'PTHR37266', NULL, NULL, NULL, NULL, 'CYTOCHROME B6-F COMPLEX SUBUNIT 6', 241272),
(320260, 'PTHR37266:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME B6-F COMPLEX SUBUNIT 6', 241272),
(320261, 'PTHR37266:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME B6-F COMPLEX SUBUNIT 6', 241272),
(320262, 'PTHR45759:SF1', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN 4', 241273),
(320263, 'PTHR45759:SF3', NULL, NULL, NULL, NULL, 'NOG1_N DOMAIN-CONTAINING PROTEIN', 241273),
(320264, 'PTHR45759:SF4', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN', 241273),
(320265, 'PTHR45759:SF5', NULL, NULL, NULL, NULL, 'BNACNNG63300D PROTEIN', 241273),
(320266, 'PTHR45759', NULL, NULL, NULL, NULL, 'NUCLEOLAR GTP-BINDING PROTEIN 1', 241273),
(320267, 'PTHR45759:SF7', NULL, NULL, NULL, NULL, 'NUCLEOLAR GTP-BINDING PROTEIN 1', 241273),
(320268, 'PTHR42778:SF1', NULL, NULL, NULL, NULL, '2-AMINOETHYLPHOSPHONATE--PYRUVATE TRANSAMINASE', 241274),
(320269, 'PTHR42778', NULL, NULL, NULL, NULL, '2-AMINOETHYLPHOSPHONATE--PYRUVATE TRANSAMINASE', 241274),
(320270, 'PTHR21522', NULL, NULL, NULL, NULL, 'PROTON CHANNEL OTOP', 241275),
(320271, 'PTHR21522:SF60', NULL, NULL, NULL, NULL, '', 241275),
(320272, 'PTHR21522:SF34', NULL, NULL, NULL, NULL, 'OTOPETRIN-LIKE', 241275),
(320273, 'PTHR21522:SF35', NULL, NULL, NULL, NULL, 'PROTON CHANNEL OTOP2', 241275),
(320274, 'PTHR21522:SF32', NULL, NULL, NULL, NULL, 'OTOPETRIN-LIKE', 241275),
(320275, 'PTHR21522:SF43', NULL, NULL, NULL, NULL, 'OTOPETRIN-LIKE', 241275),
(320276, 'PTHR21522:SF33', NULL, NULL, NULL, NULL, 'OTOPETRIN-LIKE', 241275),
(320277, 'PTHR21522:SF30', NULL, NULL, NULL, NULL, 'GH01206P', 241275),
(320278, 'PTHR21522:SF31', NULL, NULL, NULL, NULL, 'OTOPETRIN-LIKE', 241275),
(320279, 'PTHR21522:SF61', NULL, NULL, NULL, NULL, 'PROTON CHANNEL OTOPLC', 241275),
(320280, 'PTHR21522:SF40', NULL, NULL, NULL, NULL, 'OTOPETRIN-LIKE', 241275),
(320281, 'PTHR21522:SF62', NULL, NULL, NULL, NULL, 'OTOPETRIN-LIKE A, ISOFORM C', 241275),
(320282, 'PTHR21522:SF29', NULL, NULL, NULL, NULL, 'OTOPETRIN-LIKE', 241275),
(320283, 'PTHR21522:SF19', NULL, NULL, NULL, NULL, 'PROTON CHANNEL OTOP1', 241275),
(320284, 'PTHR21522:SF36', NULL, NULL, NULL, NULL, 'PROTON CHANNEL OTOP3', 241275),
(320285, 'PTHR21522:SF58', NULL, NULL, NULL, NULL, 'AGAP000074-PA', 241275),
(320286, 'PTHR47124', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SKIP8', 241276),
(320287, 'PTHR47124:SF1', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SKIP8', 241276),
(320288, 'PTHR17534:SF4', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR LIGAND SUPERFAMILY MEMBER 4', 241277),
(320289, 'PTHR17534', NULL, NULL, NULL, NULL, 'OX40 LIGAND', 241277),
(320290, 'PTHR21669:SF2', NULL, NULL, NULL, NULL, 'CAPZ-INTERACTING PROTEIN', 241278),
(320291, 'PTHR21669:SF12', NULL, NULL, NULL, NULL, 'UBINUCLEIN-1', 241278),
(320292, 'PTHR21669:SF1', NULL, NULL, NULL, NULL, 'WASH COMPLEX SUBUNIT 2', 241278),
(320293, 'PTHR21669:SF10', NULL, NULL, NULL, NULL, 'UBINUCLEIN-2', 241278),
(320294, 'PTHR21669:SF27', NULL, NULL, NULL, NULL, 'WOUND-RESPONSIVE FAMILY PROTEIN', 241278);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(320295, 'PTHR21669:SF38', NULL, NULL, NULL, NULL, 'WASH COMPLEX SUBUNIT 2A-RELATED', 241278),
(320296, 'PTHR21669:SF39', NULL, NULL, NULL, NULL, '', 241278),
(320297, 'PTHR21669:SF28', NULL, NULL, NULL, NULL, 'YEMANUCLEIN', 241278),
(320298, 'PTHR21669', NULL, NULL, NULL, NULL, 'CAPZ-INTERACTING PROTEIN AND RELATED PROTEINS', 241278),
(320299, 'PTHR21669:SF26', NULL, NULL, NULL, NULL, 'HUN DOMAIN-CONTAINING PROTEIN', 241278),
(320300, 'PTHR21669:SF29', NULL, NULL, NULL, NULL, 'WOUND-RESPONSIVE FAMILY PROTEIN ISOFORM 1', 241278),
(320301, 'PTHR38500:SF1', NULL, NULL, NULL, NULL, 'SURFACTANT-ASSOCIATED PROTEIN 2', 241279),
(320302, 'PTHR38500', NULL, NULL, NULL, NULL, 'SURFACTANT-ASSOCIATED PROTEIN 2', 241279),
(320303, 'PTHR30157', NULL, NULL, NULL, NULL, 'FERRIC REDUCTASE, NADPH-DEPENDENT', 241280),
(320304, 'PTHR30157:SF1', NULL, NULL, NULL, NULL, 'VIBRIOBACTIN UTILIZATION PROTEIN VIUB', 241280),
(320305, 'PTHR30157:SF0', NULL, NULL, NULL, NULL, 'NADPH-DEPENDENT FERRIC-CHELATE REDUCTASE', 241280),
(320306, 'PTHR43641:SF2', NULL, NULL, NULL, NULL, 'DEHYDRATASE YBIW-RELATED', 241281),
(320307, 'PTHR43641:SF3', NULL, NULL, NULL, NULL, 'DEHYDRATASE PFLD-RELATED', 241281),
(320308, 'PTHR43641', NULL, NULL, NULL, NULL, 'FORMATE ACETYLTRANSFERASE 3-RELATED', 241281),
(320309, 'PTHR20884:SF21', NULL, NULL, NULL, NULL, 'GDP-L-GALACTOSE PHOSPHORYLASE 1', 241282),
(320310, 'PTHR20884:SF22', NULL, NULL, NULL, NULL, 'BNAA03G48310D PROTEIN', 241282),
(320311, 'PTHR20884', NULL, NULL, NULL, NULL, 'GDP-D-GLUCOSE PHOSPHORYLASE 1', 241282),
(320312, 'PTHR20884:SF23', NULL, NULL, NULL, NULL, 'MANNOSE-1-PHOSPHATE GUANYLYLTRANSFERASE-RELATED', 241282),
(320313, 'PTHR20884:SF13', NULL, NULL, NULL, NULL, 'GDP-L-GALACTOSE PHOSPHORYLASE', 241282),
(320314, 'PTHR20884:SF19', NULL, NULL, NULL, NULL, 'ASCORBATE BIOSYNTHESIS-RELATED PROTEIN', 241282),
(320315, 'PTHR20884:SF9', NULL, NULL, NULL, NULL, 'OS12G0612100 PROTEIN', 241282),
(320316, 'PTHR20884:SF8', NULL, NULL, NULL, NULL, 'GDP-D-GLUCOSE PHOSPHORYLASE 1', 241282),
(320317, 'PTHR20884:SF15', NULL, NULL, NULL, NULL, 'GDP-L-GALACTOSE PHOSPHORYLASE', 241282),
(320318, 'PTHR20884:SF17', NULL, NULL, NULL, NULL, 'GDP-L-GALACTOSE PHOSPHORYLASE 2', 241282),
(320319, 'PTHR22870:SF444', NULL, NULL, NULL, NULL, 'BNAC09G21720D PROTEIN', 241283),
(320320, 'PTHR22870:SF445', NULL, NULL, NULL, NULL, '', 241283),
(320321, 'PTHR22870:SF365', NULL, NULL, NULL, NULL, 'REGULATOR OF CHROMOSOME CONDENSATION (CELL CYCLE REGULATORY PROTEIN)-RELATED', 241283),
(320322, 'PTHR22870:SF442', NULL, NULL, NULL, NULL, 'BNAA02G27780D PROTEIN', 241283),
(320323, 'PTHR22870:SF443', NULL, NULL, NULL, NULL, 'BNAA09G52370D PROTEIN', 241283),
(320324, 'PTHR22870:SF404', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING PROTEIN', 241283),
(320325, 'PTHR22870:SF448', NULL, NULL, NULL, NULL, '', 241283),
(320326, 'PTHR22870:SF449', NULL, NULL, NULL, NULL, '', 241283),
(320327, 'PTHR22870:SF446', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HERC1-LIKE PROTEIN-RELATED', 241283),
(320328, 'PTHR22870:SF447', NULL, NULL, NULL, NULL, 'BNAC06G26510D PROTEIN', 241283),
(320329, 'PTHR22870:SF360', NULL, NULL, NULL, NULL, 'ULTRAVIOLET-B RECEPTOR UVR8', 241283),
(320330, 'PTHR22870:SF440', NULL, NULL, NULL, NULL, 'RETINITIS PIGMENTOSA GTPASE REGULATOR A-RELATED', 241283),
(320331, 'PTHR22870:SF363', NULL, NULL, NULL, NULL, 'REGULATOR OF CHROMOSOME CONDENSATION (RCC1) FAMILY WITH FYVE ZINC FINGER DOMAIN', 241283),
(320332, 'PTHR22870:SF441', NULL, NULL, NULL, NULL, '', 241283),
(320333, 'PTHR22870:SF361', NULL, NULL, NULL, NULL, 'RAN GTPASE BINDING PROTEIN', 241283),
(320334, 'PTHR22870:SF408', NULL, NULL, NULL, NULL, 'RCC1 REPEAT-CONTAINING PROTEIN DDB_G0284033', 241283),
(320335, 'PTHR22870:SF455', NULL, NULL, NULL, NULL, 'BNAC09G41800D PROTEIN', 241283),
(320336, 'PTHR22870:SF379', NULL, NULL, NULL, NULL, 'PH, RCC1 AND FYVE DOMAINS-CONTAINING PROTEIN 1', 241283),
(320337, 'PTHR22870:SF335', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 241283),
(320338, 'PTHR22870:SF412', NULL, NULL, NULL, NULL, 'BNAC02G42750D PROTEIN', 241283);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(320339, 'PTHR22870:SF456', NULL, NULL, NULL, NULL, 'OS01G0700200 PROTEIN', 241283),
(320340, 'PTHR22870:SF453', NULL, NULL, NULL, NULL, 'CLARET, ISOFORM A', 241283),
(320341, 'PTHR22870:SF454', NULL, NULL, NULL, NULL, 'REGULATOR OF CHROMOSOME CONDENSATION (RCC1) FAMILY PROTEIN', 241283),
(320342, 'PTHR22870:SF459', NULL, NULL, NULL, NULL, 'REGULATOR OF CHROMOSOME CONDENSATION (RCC1) FAMILY WITH FYVEZINC FINGER DOMAIN', 241283),
(320343, 'PTHR22870:SF415', NULL, NULL, NULL, NULL, 'PH, RCC1 AND FYVE DOMAINS-CONTAINING PROTEIN 1-LIKE ISOFORM X1', 241283),
(320344, 'PTHR22870:SF413', NULL, NULL, NULL, NULL, 'REGULATOR OF CHROMOSOME CONDENSATION (RCC1) FAMILY PROTEIN', 241283),
(320345, 'PTHR22870:SF457', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE-RELATED', 241283),
(320346, 'PTHR22870:SF458', NULL, NULL, NULL, NULL, '', 241283),
(320347, 'PTHR22870:SF371', NULL, NULL, NULL, NULL, 'OS02G0554100 PROTEIN', 241283),
(320348, 'PTHR22870:SF451', NULL, NULL, NULL, NULL, 'MJK13.9 PROTEIN', 241283),
(320349, 'PTHR22870:SF375', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NEK8', 241283),
(320350, 'PTHR22870:SF452', NULL, NULL, NULL, NULL, 'CHROMOSOME CONDENSATION REGULATOR RCC1 REPEAT PROTEIN', 241283),
(320351, 'PTHR22870:SF450', NULL, NULL, NULL, NULL, 'REGULATOR OF CHROMOSOME CONDENSATION 1/BETA-LACTAMASE-INHIBITOR PROTEIN II-RELATED', 241283),
(320352, 'PTHR22870:SF373', NULL, NULL, NULL, NULL, 'REGULATOR OF CHROMOSOME CONDENSATION (RCC1) FAMILY WITH FYVE ZINC FINGER DOMAIN-CONTAINING PROTEIN', 241283),
(320353, 'PTHR22870:SF419', NULL, NULL, NULL, NULL, 'FYVE-TYPE DOMAIN-CONTAINING PROTEIN', 241283),
(320354, 'PTHR22870:SF417', NULL, NULL, NULL, NULL, 'BNAA01G28890D PROTEIN', 241283),
(320355, 'PTHR22870:SF224', NULL, NULL, NULL, NULL, 'RCC1 AND BTB DOMAIN-CONTAINING PROTEIN 1', 241283),
(320356, 'PTHR22870:SF423', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL SERINE/THREONINE-PROTEIN KINASE/NEDD4-LIKE E3 UBIQUITIN-PROTEIN LIGASE', 241283),
(320357, 'PTHR22870:SF387', NULL, NULL, NULL, NULL, 'BNAA07G38600D PROTEIN', 241283),
(320358, 'PTHR22870:SF420', NULL, NULL, NULL, NULL, '', 241283),
(320359, 'PTHR22870:SF388', NULL, NULL, NULL, NULL, '', 241283),
(320360, 'PTHR22870:SF344', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN / REGULATOR OF CHROMOSOME CONDENSATION (RCC1) FAMILY PROTEIN', 241283),
(320361, 'PTHR22870:SF427', NULL, NULL, NULL, NULL, 'OS02G0597000 PROTEIN', 241283),
(320362, 'PTHR22870:SF424', NULL, NULL, NULL, NULL, 'REGULATOR OF CHROMOSOME CONDENSATION (RCC1) FAMILY PROTEIN-RELATED', 241283),
(320363, 'PTHR22870', NULL, NULL, NULL, NULL, 'REGULATOR OF CHROMOSOME CONDENSATION', 241283),
(320364, 'PTHR22870:SF382', NULL, NULL, NULL, NULL, 'REGULATOR OF CHROMOSOME CONDENSATION (RCC1) FAMILY PROTEIN', 241283),
(320365, 'PTHR22870:SF380', NULL, NULL, NULL, NULL, 'CHROMOSOME CONDENSATION REGULATOR RCC1 REPEAT PROTEIN', 241283),
(320366, 'PTHR22870:SF220', NULL, NULL, NULL, NULL, 'RCC1 AND BTB DOMAIN-CONTAINING PROTEIN 2', 241283),
(320367, 'PTHR22870:SF385', NULL, NULL, NULL, NULL, 'RAN GTPASE BINDING PROTEIN', 241283),
(320368, 'PTHR22870:SF386', NULL, NULL, NULL, NULL, '', 241283),
(320369, 'PTHR22870:SF428', NULL, NULL, NULL, NULL, 'REGULATOR OF CHROMOSOME CONDENSATION (RCC1) FAMILY PROTEIN', 241283),
(320370, 'PTHR22870:SF429', NULL, NULL, NULL, NULL, '', 241283),
(320371, 'PTHR22870:SF24', NULL, NULL, NULL, NULL, 'REGULATOR OF CHROMOSOME CONDENSATION (RCC1) FAMILY PROTEIN', 241283),
(320372, 'PTHR22870:SF398', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HERC2', 241283),
(320373, 'PTHR22870:SF310', NULL, NULL, NULL, NULL, '', 241283),
(320374, 'PTHR22870:SF311', NULL, NULL, NULL, NULL, 'REGULATOR OF CHROMOSOME CONDENSATION (RCC1) FAMILY PROTEIN-RELATED', 241283),
(320375, 'PTHR22870:SF355', NULL, NULL, NULL, NULL, 'CHROMOSOME CONDENSATION REGULATOR RCC1 REPEAT PROTEIN', 241283),
(320376, 'PTHR22870:SF437', NULL, NULL, NULL, NULL, 'REGULATOR OF CHROMOSOME CONDENSATION (RCC1) FAMILY WITH FYVE ZINC FINGER DOMAIN-CONTAINING PROTEIN', 241283),
(320377, 'PTHR22870:SF358', NULL, NULL, NULL, NULL, 'REGULATOR OF CHROMOSOME CONDENSATION (RCC1) FAMILY WITH FYVE ZINC FINGER DOMAIN-CONTAINING PROTEIN', 241283);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(320378, 'PTHR22870:SF435', NULL, NULL, NULL, NULL, 'OF CHROMOSOME CONDENSATION, PUTATIVE-RELATED', 241283),
(320379, 'PTHR22870:SF396', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HERC2-LIKE PROTEIN', 241283),
(320380, 'PTHR22870:SF352', NULL, NULL, NULL, NULL, 'REGULATOR OF CHROMOSOME CONDENSATION (RCC1) FAMILY WITH FYVE ZINC FINGER DOMAIN-CONTAINING PROTEIN', 241283),
(320381, 'PTHR22870:SF231', NULL, NULL, NULL, NULL, 'RAB-GAP TBC DOMAIN-CONTAINING PROTEIN', 241283),
(320382, 'PTHR22870:SF198', NULL, NULL, NULL, NULL, '', 241283),
(320383, 'PTHR22870:SF430', NULL, NULL, NULL, NULL, 'BRX DOMAIN-CONTAINING PROTEIN', 241283),
(320384, 'PTHR22870:SF155', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HERC1-RELATED', 241283),
(320385, 'PTHR22870:SF350', NULL, NULL, NULL, NULL, 'F12P19.9 PROTEIN', 241283),
(320386, 'PTHR22870:SF395', NULL, NULL, NULL, NULL, 'UVB-RESISTANCE PROTEIN UVR8-RELATED', 241283),
(320387, 'PTHR22870:SF91', NULL, NULL, NULL, NULL, 'REGULATOR OF CHROMOSOME CONDENSATION (RCC1) FAMILY WITH FYVE ZINC FINGER DOMAIN-CONTAINING PROTEIN', 241283),
(320388, 'PTHR22926:SF5', NULL, NULL, NULL, NULL, 'PHOSPHO-N-ACETYLMURAMOYL-PENTAPEPTIDE-TRANSFERASE HOMOLOG', 241284),
(320389, 'PTHR22926:SF3', NULL, NULL, NULL, NULL, 'UNDECAPRENYL-PHOSPHATE ALPHA-N-ACETYLGLUCOSAMINYL 1-PHOSPHATE TRANSFERASE', 241284),
(320390, 'PTHR22926', NULL, NULL, NULL, NULL, 'PHOSPHO-N-ACETYLMURAMOYL-PENTAPEPTIDE-TRANSFERASE', 241284),
(320391, 'PTHR43537:SF21', NULL, NULL, NULL, NULL, 'GALACTONATE OPERON TRANSCRIPTIONAL REPRESSOR', 241285),
(320392, 'PTHR43537:SF43', NULL, NULL, NULL, NULL, 'GNTR-FAMILY TRANSCRIPTIONAL REGULATOR', 241285),
(320393, 'PTHR43537:SF44', NULL, NULL, NULL, NULL, 'GNTR-FAMLY TRANSCRIPTIONAL REGULATOR-RELATED', 241285),
(320394, 'PTHR43537:SF45', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 241285),
(320395, 'PTHR43537:SF34', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE COMPLEX REPRESSOR', 241285),
(320396, 'PTHR43537:SF23', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REPRESSOR NANR', 241285),
(320397, 'PTHR43537:SF46', NULL, NULL, NULL, NULL, 'GNTR FAMILY REGULATORY PROTEIN-RELATED', 241285),
(320398, 'PTHR43537:SF24', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 241285),
(320399, 'PTHR43537:SF47', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN GNTR HTH', 241285),
(320400, 'PTHR43537', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, GNTR FAMILY', 241285),
(320401, 'PTHR43537:SF48', NULL, NULL, NULL, NULL, 'UXU OPERON TRANSCRIPTIONAL REGULATOR', 241285),
(320402, 'PTHR43537:SF39', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR MCBR', 241285),
(320403, 'PTHR43537:SF18', NULL, NULL, NULL, NULL, 'L-LACTATE DEHYDROGENASE OPERON REGULATORY PROTEIN-RELATED', 241285),
(320404, 'PTHR43537:SF2', NULL, NULL, NULL, NULL, 'GLUCONATE OPERON TRANSCRIPTIONAL REPRESSOR', 241285),
(320405, 'PTHR43537:SF1', NULL, NULL, NULL, NULL, 'GLC OPERON TRANSCRIPTIONAL ACTIVATOR', 241285),
(320406, 'PTHR43537:SF40', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR LUTR', 241285),
(320407, 'PTHR43537:SF7', NULL, NULL, NULL, NULL, 'EXU REGULON TRANSCRIPTIONAL REGULATOR', 241285),
(320408, 'PTHR43537:SF41', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 241285),
(320409, 'PTHR43537:SF6', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR LGOR-RELATED', 241285),
(320410, 'PTHR43537:SF5', NULL, NULL, NULL, NULL, 'FATTY ACID METABOLISM REGULATOR PROTEIN', 241285),
(320411, 'PTHR43537:SF20', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REPRESSOR GLAR', 241285),
(320412, 'PTHR43537:SF42', NULL, NULL, NULL, NULL, 'GNTR FAMILY REGULATORY PROTEIN-RELATED', 241285),
(320413, 'PTHR15627:SF15', NULL, NULL, NULL, NULL, 'TRNA-URIDINE AMINOCARBOXYPROPYLTRANSFERASE 1', 241286),
(320414, 'PTHR15627:SF16', NULL, NULL, NULL, NULL, 'TRNA-URIDINE AMINOCARBOXYPROPYLTRANSFERASE', 241286),
(320415, 'PTHR15627:SF8', NULL, NULL, NULL, NULL, 'TRNA-URIDINE AMINOCARBOXYPROPYLTRANSFERASE 1', 241286),
(320416, 'PTHR15627', NULL, NULL, NULL, NULL, 'NATURAL KILLER CELL-SPECIFIC ANTIGEN KLIP1', 241286);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(320417, 'PTHR15627:SF14', NULL, NULL, NULL, NULL, 'PROTEIN YIPF3', 241286),
(320418, 'PTHR38420', NULL, NULL, NULL, NULL, 'AP-4-A PHOSPHORYLASE II', 241287),
(320419, 'PTHR38420:SF3', NULL, NULL, NULL, NULL, '5'',5''''''-P-1,P-4-TETRAPHOSPHATE PHOSPHORYLASE 2', 241287),
(320420, 'PTHR38420:SF1', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_5G14690)-RELATED', 241287),
(320421, 'PTHR10815:SF5', NULL, NULL, NULL, NULL, 'METHYLATED-DNA--PROTEIN-CYSTEINE METHYLTRANSFERASE', 241288),
(320422, 'PTHR10815', NULL, NULL, NULL, NULL, 'METHYLATED-DNA--PROTEIN-CYSTEINE METHYLTRANSFERASE', 241288),
(320423, 'PTHR10815:SF13', NULL, NULL, NULL, NULL, '6-O-METHYLGUANINE-DNA METHYLTRANSFERASE', 241288),
(320424, 'PTHR10815:SF14', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL TRANSCRIPTIONAL ACTIVATOR/DNA REPAIR ENZYME ADA', 241288),
(320425, 'PTHR10815:SF12', NULL, NULL, NULL, NULL, 'METHYLATED-DNA--PROTEIN-CYSTEINE METHYLTRANSFERASE, INDUCIBLE', 241288),
(320426, 'PTHR21394:SF0', NULL, NULL, NULL, NULL, 'MAU2 CHROMATID COHESION FACTOR HOMOLOG', 241289),
(320427, 'PTHR21394', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 241289),
(320428, 'PTHR43583:SF2', NULL, NULL, NULL, NULL, 'BIOTIN AND THIAMIN SYNTHESIS ASSOCIATED DOMAIN CONTAINING PROTEIN', 241290),
(320429, 'PTHR43583', NULL, NULL, NULL, NULL, '2-IMINOACETATE SYNTHASE', 241290),
(320430, 'PTHR43583:SF1', NULL, NULL, NULL, NULL, '2-IMINOACETATE SYNTHASE', 241290),
(320431, 'PTHR13286:SF20', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE COMPLEX SUBUNIT SAP30L', 241291),
(320432, 'PTHR13286:SF11', NULL, NULL, NULL, NULL, 'SAP30_SIN3_BDG DOMAIN-CONTAINING PROTEIN', 241291),
(320433, 'PTHR13286:SF21', NULL, NULL, NULL, NULL, 'SAP30_SIN3_BDG DOMAIN-CONTAINING PROTEIN', 241291),
(320434, 'PTHR13286:SF17', NULL, NULL, NULL, NULL, 'SAP30_SIN3_BDG DOMAIN-CONTAINING PROTEIN', 241291),
(320435, 'PTHR13286:SF16', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE COMPLEX SUBUNIT SAP30/SAP30-LIKE PROTEIN-RELATED', 241291),
(320436, 'PTHR13286:SF15', NULL, NULL, NULL, NULL, 'SAP30_SIN3_BDG DOMAIN-CONTAINING PROTEIN', 241291),
(320437, 'PTHR13286:SF6', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE COMPLEX SUBUNIT', 241291),
(320438, 'PTHR13286:SF5', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE COMPLEX SUBUNIT SAP30L', 241291),
(320439, 'PTHR13286', NULL, NULL, NULL, NULL, 'SAP30', 241291),
(320440, 'PTHR13286:SF8', NULL, NULL, NULL, NULL, 'OS04G0166600 PROTEIN', 241291),
(320441, 'PTHR13286:SF7', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE COMPLEX SUBUNIT SAP30', 241291),
(320442, 'PTHR36220:SF1', NULL, NULL, NULL, NULL, '', 241292),
(320443, 'PTHR36220', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', 241292),
(320444, 'PTHR23232:SF90', NULL, NULL, NULL, NULL, 'KRAB DOMAIN-CONTAINING PROTEIN 1', 241293),
(320445, 'PTHR23232:SF110', NULL, NULL, NULL, NULL, 'KRAB DOMAIN-CONTAINING PROTEIN', 241293),
(320446, 'PTHR23232:SF92', NULL, NULL, NULL, NULL, 'KRAB DOMAIN-CONTAINING PROTEIN', 241293),
(320447, 'PTHR23232:SF112', NULL, NULL, NULL, NULL, 'KRAB DOMAIN-CONTAINING PROTEIN', 241293),
(320448, 'PTHR23232:SF111', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1700020N01 GENE', 241293),
(320449, 'PTHR23232:SF98', NULL, NULL, NULL, NULL, 'KRAB DOMAIN-CONTAINING PROTEIN 4', 241293),
(320450, 'PTHR23232:SF114', NULL, NULL, NULL, NULL, 'KRAB DOMAIN-CONTAINING PROTEIN', 241293),
(320451, 'PTHR23232:SF113', NULL, NULL, NULL, NULL, 'KRAB DOMAIN-CONTAINING PROTEIN', 241293),
(320452, 'PTHR23232:SF116', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 487', 241293),
(320453, 'PTHR23232:SF115', NULL, NULL, NULL, NULL, 'KRAB DOMAIN-CONTAINING PROTEIN', 241293),
(320454, 'PTHR23232:SF118', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 746', 241293),
(320455, 'PTHR23232:SF117', NULL, NULL, NULL, NULL, 'KRAB DOMAIN-CONTAINING PROTEIN', 241293),
(320456, 'PTHR23232:SF119', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 383', 241293),
(320457, 'PTHR23232:SF121', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 282', 241293),
(320458, 'PTHR23232:SF120', NULL, NULL, NULL, NULL, 'PROTEIN ZNF783', 241293),
(320459, 'PTHR23232:SF123', NULL, NULL, NULL, NULL, 'KRAB DOMAIN-CONTAINING PROTEIN', 241293);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(320460, 'PTHR23232:SF122', NULL, NULL, NULL, NULL, 'KRAB DOMAIN-CONTAINING PROTEIN', 241293),
(320461, 'PTHR23232:SF125', NULL, NULL, NULL, NULL, 'KRAB DOMAIN-CONTAINING PROTEIN', 241293),
(320462, 'PTHR23232', NULL, NULL, NULL, NULL, 'KRAB DOMAIN C2H2 ZINC FINGER', 241293),
(320463, 'PTHR23232:SF124', NULL, NULL, NULL, NULL, 'KRAB DOMAIN-CONTAINING PROTEIN', 241293),
(320464, 'PTHR23232:SF102', NULL, NULL, NULL, NULL, 'KRAB DOMAIN-CONTAINING PROTEIN', 241293),
(320465, 'PTHR23232:SF105', NULL, NULL, NULL, NULL, 'KRAB DOMAIN-CONTAINING PROTEIN', 241293),
(320466, 'PTHR23232:SF85', NULL, NULL, NULL, NULL, 'KRAB DOMAIN-CONTAINING PROTEIN', 241293),
(320467, 'PTHR23232:SF127', NULL, NULL, NULL, NULL, 'KRAB DOMAIN-CONTAINING PROTEIN', 241293),
(320468, 'PTHR23232:SF86', NULL, NULL, NULL, NULL, 'KRAB DOMAIN-CONTAINING PROTEIN', 241293),
(320469, 'PTHR23232:SF126', NULL, NULL, NULL, NULL, '', 241293),
(320470, 'PTHR23232:SF69', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 688', 241293),
(320471, 'PTHR23232:SF129', NULL, NULL, NULL, NULL, 'KRAB DOMAIN-CONTAINING PROTEIN ZNF747-RELATED', 241293),
(320472, 'PTHR23232:SF128', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 57', 241293),
(320473, 'PTHR23232:SF109', NULL, NULL, NULL, NULL, 'KRAB DOMAIN-CONTAINING PROTEIN', 241293),
(320474, 'PTHR23232:SF67', NULL, NULL, NULL, NULL, 'PROTEIN ZNF738', 241293),
(320475, 'PTHR31744:SF107', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 94-RELATED', 241294),
(320476, 'PTHR31744:SF149', NULL, NULL, NULL, NULL, 'PROTEIN CUP-SHAPED COTYLEDON 3-LIKE', 241294),
(320477, 'PTHR31744:SF70', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320478, 'PTHR31744:SF103', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320479, 'PTHR31744:SF72', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320480, 'PTHR31744:SF104', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 100', 241294),
(320481, 'PTHR31744:SF101', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 21/22', 241294),
(320482, 'PTHR31744:SF73', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 46', 241294),
(320483, 'PTHR31744:SF146', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN-RELATED', 241294),
(320484, 'PTHR31744:SF74', NULL, NULL, NULL, NULL, 'OS08G0433500 PROTEIN', 241294),
(320485, 'PTHR31744:SF109', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320486, 'PTHR31744:SF143', NULL, NULL, NULL, NULL, 'PROTEIN CUP-SHAPED COTYLEDON 3-LIKE', 241294),
(320487, 'PTHR31744:SF65', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR JUNGBRUNNEN 1', 241294),
(320488, 'PTHR31744:SF144', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320489, 'PTHR31744:SF21', NULL, NULL, NULL, NULL, 'OS08G0200600 PROTEIN', 241294),
(320490, 'PTHR31744:SF22', NULL, NULL, NULL, NULL, 'NAC DOMAIN CONTAINING PROTEIN 58', 241294),
(320491, 'PTHR31744:SF185', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320492, 'PTHR31744:SF66', NULL, NULL, NULL, NULL, 'NAC020_2B.2', 241294),
(320493, 'PTHR31744:SF67', NULL, NULL, NULL, NULL, 'ANAC079/ANAC080/ATNAC4 PROTEIN', 241294),
(320494, 'PTHR31744:SF186', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320495, 'PTHR31744:SF118', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320496, 'PTHR31744:SF119', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 92-LIKE', 241294),
(320497, 'PTHR31744:SF116', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320498, 'PTHR31744:SF114', NULL, NULL, NULL, NULL, 'PROTEIN CUP-SHAPED COTYLEDON 2', 241294),
(320499, 'PTHR31744:SF159', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320500, 'PTHR31744:SF115', NULL, NULL, NULL, NULL, 'NAC DOMAIN CONTAINING PROTEIN 38', 241294),
(320501, 'PTHR31744:SF62', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 77', 241294),
(320502, 'PTHR31744:SF112', NULL, NULL, NULL, NULL, 'NAC TRANSCRIPTION FACTOR-LIKE PROTEIN', 241294),
(320503, 'PTHR31744:SF113', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(320504, 'PTHR31744:SF4', NULL, NULL, NULL, NULL, 'NAC TRANSCRIPTION FACTOR', 241294),
(320505, 'PTHR31744:SF190', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 100-LIKE', 241294),
(320506, 'PTHR31744:SF191', NULL, NULL, NULL, NULL, 'NAC TRANSCRIPTION FACTOR-LIKE PROTEIN', 241294),
(320507, 'PTHR31744:SF53', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR JUNGBRUNNEN 1-LIKE', 241294),
(320508, 'PTHR31744:SF110', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR JUNGBRUNNEN 1-LIKE', 241294),
(320509, 'PTHR31744:SF198', NULL, NULL, NULL, NULL, 'GRAB2 PROTEIN', 241294),
(320510, 'PTHR31744:SF154', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320511, 'PTHR31744:SF199', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320512, 'PTHR31744:SF111', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320513, 'PTHR31744:SF54', NULL, NULL, NULL, NULL, 'NAC TRANSCRIPTION FACTOR 15', 241294),
(320514, 'PTHR31744:SF55', NULL, NULL, NULL, NULL, 'OS08G0436700 PROTEIN', 241294),
(320515, 'PTHR31744:SF152', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320516, 'PTHR31744:SF196', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320517, 'PTHR31744:SF197', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320518, 'PTHR31744:SF153', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320519, 'PTHR31744:SF12', NULL, NULL, NULL, NULL, 'OS02G0579000 PROTEIN', 241294),
(320520, 'PTHR31744:SF56', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 94-RELATED', 241294),
(320521, 'PTHR31744:SF194', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320522, 'PTHR31744:SF195', NULL, NULL, NULL, NULL, 'CONTAINING PROTEIN 21/22, PUTATIVE, EXPRESSED-RELATED', 241294),
(320523, 'PTHR31744:SF192', NULL, NULL, NULL, NULL, 'PROTEIN CUP-SHAPED COTYLEDON 2-LIKE', 241294),
(320524, 'PTHR31744:SF193', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320525, 'PTHR31744:SF129', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320526, 'PTHR31744:SF206', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320527, 'PTHR31744:SF207', NULL, NULL, NULL, NULL, 'OS02G0810900 PROTEIN', 241294),
(320528, 'PTHR31744:SF127', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320529, 'PTHR31744:SF204', NULL, NULL, NULL, NULL, 'PROTEIN CUP-SHAPED COTYLEDON 1-LIKE', 241294),
(320530, 'PTHR31744:SF92', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 87', 241294),
(320531, 'PTHR31744:SF205', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 94-RELATED', 241294),
(320532, 'PTHR31744:SF128', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320533, 'PTHR31744:SF169', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320534, 'PTHR31744:SF202', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320535, 'PTHR31744:SF93', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320536, 'PTHR31744:SF203', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320537, 'PTHR31744:SF200', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320538, 'PTHR31744:SF123', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320539, 'PTHR31744:SF124', NULL, NULL, NULL, NULL, 'NAC (NO APICAL MERISTEM) DOMAIN TRANSCRIPTIONAL REGULATOR SUPERFAMILY PROTEIN', 241294),
(320540, 'PTHR31744:SF201', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 92', 241294),
(320541, 'PTHR31744:SF96', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 21/22', 241294),
(320542, 'PTHR31744', NULL, NULL, NULL, NULL, 'PROTEIN CUP-SHAPED COTYLEDON 2-RELATED', 241294),
(320543, 'PTHR31744:SF86', NULL, NULL, NULL, NULL, 'PROTEIN CUP-SHAPED COTYLEDON 3', 241294),
(320544, 'PTHR31744:SF87', NULL, NULL, NULL, NULL, 'CONTAINING PROTEIN 21/22, PUTATIVE, EXPRESSED-RELATED', 241294),
(320545, 'PTHR31744:SF166', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 87-LIKE ISOFORM X1', 241294);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(320546, 'PTHR31744:SF88', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 26', 241294),
(320547, 'PTHR31744:SF89', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 79', 241294),
(320548, 'PTHR31744:SF120', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320549, 'PTHR31744:SF161', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320550, 'PTHR31744:SF162', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320551, 'PTHR31744:SF160', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 100-LIKE ISOFORM X1', 241294),
(320552, 'PTHR31744:SF80', NULL, NULL, NULL, NULL, 'NAC DOMAIN CONTAINING PROTEIN 74', 241294),
(320553, 'PTHR31744:SF139', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320554, 'PTHR31744:SF82', NULL, NULL, NULL, NULL, 'NAC (NO APICAL MERISTEM) DOMAIN TRANSCRIPTIONAL REGULATOR SUPERFAMILY PROTEIN', 241294),
(320555, 'PTHR31744:SF136', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320556, 'PTHR31744:SF83', NULL, NULL, NULL, NULL, 'PROTEIN CUP-SHAPED COTYLEDON 1', 241294),
(320557, 'PTHR31744:SF134', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320558, 'PTHR31744:SF135', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 59', 241294),
(320559, 'PTHR31744:SF85', NULL, NULL, NULL, NULL, 'NAC020_2B.1', 241294),
(320560, 'PTHR31744:SF179', NULL, NULL, NULL, NULL, 'NAC FAMILY TRANSCRIPTION FACTOR NAC-B1', 241294),
(320561, 'PTHR31744:SF176', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320562, 'PTHR31744:SF132', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN-RELATED', 241294),
(320563, 'PTHR31744:SF177', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320564, 'PTHR31744:SF76', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320565, 'PTHR31744:SF77', NULL, NULL, NULL, NULL, 'PROTEIN FEZ', 241294),
(320566, 'PTHR31744:SF130', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320567, 'PTHR31744:SF78', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241294),
(320568, 'PTHR31744:SF79', NULL, NULL, NULL, NULL, 'OS01G0888300 PROTEIN', 241294),
(320569, 'PTHR31744:SF171', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR NAM FAMILY-RELATED', 241294),
(320570, 'PTHR34698:SF2', NULL, NULL, NULL, NULL, '5-OXOPROLINASE SUBUNIT B', 241295),
(320571, 'PTHR34698', NULL, NULL, NULL, NULL, '5-OXOPROLINASE SUBUNIT B', 241295),
(320572, 'PTHR46215:SF9', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN 25', 241296),
(320573, 'PTHR46215:SF8', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 241296),
(320574, 'PTHR46215', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN 24-RELATED', 241296),
(320575, 'PTHR46215:SF20', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN 18', 241296),
(320576, 'PTHR46215:SF10', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 241296),
(320577, 'PTHR46215:SF21', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 241296),
(320578, 'PTHR46215:SF5', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 241296),
(320579, 'PTHR46215:SF17', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 241296),
(320580, 'PTHR46215:SF6', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN 9', 241296),
(320581, 'PTHR46215:SF18', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 241296),
(320582, 'PTHR46215:SF19', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 241296),
(320583, 'PTHR46215:SF12', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 241296),
(320584, 'PTHR46215:SF23', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 241296),
(320585, 'PTHR46215:SF1', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN 16', 241296),
(320586, 'PTHR46215:SF13', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 241296),
(320587, 'PTHR46215:SF24', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 241296),
(320588, 'PTHR46215:SF25', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN 10', 241296),
(320589, 'PTHR46215:SF26', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 241296),
(320590, 'PTHR46215:SF15', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN 24', 241296),
(320591, 'PTHR34693:SF3', NULL, NULL, NULL, NULL, '', 241297);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(320592, 'PTHR34693:SF2', NULL, NULL, NULL, NULL, '', 241297),
(320593, 'PTHR34693:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PAR32', 241297),
(320594, 'PTHR34693:SF4', NULL, NULL, NULL, NULL, 'YALI0F00528P', 241297),
(320595, 'PTHR34693', NULL, NULL, NULL, NULL, 'PROTEIN PAR32', 241297),
(320596, 'PTHR10050:SF51', NULL, NULL, NULL, NULL, 'PROTEIN O-MANNOSYL-TRANSFERASE 1', 241298),
(320597, 'PTHR10050:SF50', NULL, NULL, NULL, NULL, 'DOLICHYL-PHOSPHATE-MANNOSE--PROTEIN MANNOSYLTRANSFERASE 1-RELATED', 241298),
(320598, 'PTHR10050', NULL, NULL, NULL, NULL, 'DOLICHYL-PHOSPHATE-MANNOSE--PROTEIN MANNOSYLTRANSFERASE', 241298),
(320599, 'PTHR10050:SF53', NULL, NULL, NULL, NULL, '', 241298),
(320600, 'PTHR10050:SF52', NULL, NULL, NULL, NULL, 'DOLICHYL-PHOSPHATE-MANNOSE--PROTEIN MANNOSYLTRANSFERASE 6', 241298),
(320601, 'PTHR10050:SF46', NULL, NULL, NULL, NULL, 'PROTEIN O-MANNOSYL-TRANSFERASE 2', 241298),
(320602, 'PTHR40572', NULL, NULL, NULL, NULL, 'PROTEIN BAX', 241299),
(320603, 'PTHR40572:SF1', NULL, NULL, NULL, NULL, 'PROTEIN BAX', 241299),
(320604, 'PTHR13713:SF57', NULL, NULL, NULL, NULL, 'CMP-N-ACETYLNEURAMINATE-BETA-GALACTOSAMIDE-ALPHA-2,3-SIALYLTRANSFERASE 4', 241300),
(320605, 'PTHR13713', NULL, NULL, NULL, NULL, 'SIALYLTRANSFERASE', 241300),
(320606, 'PTHR13713:SF60', NULL, NULL, NULL, NULL, 'LACTOSYLCERAMIDE ALPHA-2,3-SIALYLTRANSFERASE', 241300),
(320607, 'PTHR13713:SF94', NULL, NULL, NULL, NULL, 'ST3 BETA-GALACTOSIDE ALPHA-2,3-SIALYLTRANSFERASE 7', 241300),
(320608, 'PTHR13713:SF92', NULL, NULL, NULL, NULL, 'LITAF DOMAIN-CONTAINING PROTEIN', 241300),
(320609, 'PTHR13713:SF8', NULL, NULL, NULL, NULL, 'TYPE 2 LACTOSAMINE ALPHA-2,3-SIALYLTRANSFERASE', 241300),
(320610, 'PTHR13713:SF59', NULL, NULL, NULL, NULL, '', 241300),
(320611, 'PTHR13713:SF37', NULL, NULL, NULL, NULL, 'CMP-N-ACETYLNEURAMINATE-BETA-1,4-GALACTOSIDE ALPHA-2,3-SIALYLTRANSFERASE', 241300),
(320612, 'PTHR34081', NULL, NULL, NULL, NULL, 'MALECTIN DOMAIN-CONTAINING PROTEIN', 241301),
(320613, 'PTHR34081:SF1', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE TOR', 241301),
(320614, 'PTHR45737', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR A DOMAIN-CONTAINING PROTEIN 5A', 241302),
(320615, 'PTHR45737:SF3', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR A DOMAIN-CONTAINING PROTEIN 5A', 241302),
(320616, 'PTHR45737:SF4', NULL, NULL, NULL, NULL, 'VON WILLEBRAND DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_4G01160)', 241302),
(320617, 'PTHR45737:SF1', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR A DOMAIN-CONTAINING PROTEIN DDB_G0267758-RELATED', 241302),
(320618, 'PTHR45737:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED SEQUENCE AW551984', 241302),
(320619, 'PTHR45737:SF8', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR A DOMAIN-CONTAINING PROTEIN 5A', 241302),
(320620, 'PTHR45737:SF5', NULL, NULL, NULL, NULL, 'POLY [ADP-RIBOSE] POLYMERASE', 241302),
(320621, 'PTHR45737:SF6', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR A DOMAIN-CONTAINING PROTEIN DDB_G0285975-RELATED', 241302),
(320622, 'PTHR43544:SF36', NULL, NULL, NULL, NULL, 'CHAIN OXIDOREDUCTASE (CSGA), PUTATIVE (AFU_ORTHOLOGUE AFUA_4G00910)-RELATED', 241303),
(320623, 'PTHR43544', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/REDUCTASE', 241303),
(320624, 'PTHR43544:SF26', NULL, NULL, NULL, NULL, 'SHORT CHAIN DEHYDROGENASE/REDUCTASE FAMILY OXIDOREDUCTASE (JCVI)', 241303),
(320625, 'PTHR43544:SF15', NULL, NULL, NULL, NULL, 'CHAIN DEHYDROGENASE (ATSC), PUTATIVE (AFU_ORTHOLOGUE AFUA_3G00180)-RELATED', 241303),
(320626, 'PTHR43544:SF16', NULL, NULL, NULL, NULL, 'PROTEIN CBG13128', 241303),
(320627, 'PTHR43544:SF28', NULL, NULL, NULL, NULL, 'NADB-LER1-RELATED', 241303),
(320628, 'PTHR43544:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG23231', 241303),
(320629, 'PTHR43544:SF5', NULL, NULL, NULL, NULL, 'DEHYDROGENASES, SHORT CHAIN', 241303),
(320630, 'PTHR43544:SF7', NULL, NULL, NULL, NULL, 'LD36273P', 241303),
(320631, 'PTHR43544:SF30', NULL, NULL, NULL, NULL, 'NADB-LER2', 241303),
(320632, 'PTHR43544:SF20', NULL, NULL, NULL, NULL, 'ZGC:110339', 241303),
(320633, 'PTHR43544:SF31', NULL, NULL, NULL, NULL, 'PROTEIN CBG23230', 241303);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(320634, 'PTHR43544:SF10', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/REDUCTASE FAMILY PROTEIN', 241303),
(320635, 'PTHR43544:SF32', NULL, NULL, NULL, NULL, 'CHAIN DEHYDROGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G01530)-RELATED', 241303),
(320636, 'PTHR43544:SF21', NULL, NULL, NULL, NULL, '', 241303),
(320637, 'PTHR43544:SF33', NULL, NULL, NULL, NULL, 'SI:CH73-186J5.2-RELATED', 241303),
(320638, 'PTHR43544:SF12', NULL, NULL, NULL, NULL, 'ZGC:65997', 241303),
(320639, 'PTHR43544:SF34', NULL, NULL, NULL, NULL, 'SI:DKEY-12E7.4', 241303),
(320640, 'PTHR43544:SF35', NULL, NULL, NULL, NULL, 'SKN-1 DEPENDENT ZYGOTIC TRANSCRIPT', 241303),
(320641, 'PTHR43544:SF2', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE-LIKE PROTEIN', 241303),
(320642, 'PTHR30555', NULL, NULL, NULL, NULL, 'HYDROPEROXIDASE I, BIFUNCTIONAL CATALASE-PEROXIDASE', 241304),
(320643, 'PTHR30555:SF6', NULL, NULL, NULL, NULL, 'CATALASE-PEROXIDASE', 241304),
(320644, 'PTHR30555:SF0', NULL, NULL, NULL, NULL, 'CATALASE-PEROXIDASE', 241304),
(320645, 'PTHR13137', NULL, NULL, NULL, NULL, 'DC11  ACN9 HOMOLOG', 241305),
(320646, 'PTHR13137:SF6', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE ASSEMBLY FACTOR 3, MITOCHONDRIAL', 241305),
(320647, 'PTHR42281:SF1', NULL, NULL, NULL, NULL, 'ACETYL-COA DECARBONYLASE/SYNTHASE COMPLEX SUBUNIT BETA 2', 241306),
(320648, 'PTHR42281', NULL, NULL, NULL, NULL, '', 241306),
(320649, 'PTHR32083:SF41', NULL, NULL, NULL, NULL, 'DIENELACTONE HYDROLASE (AFU_ORTHOLOGUE AFUA_4G03730)', 241307),
(320650, 'PTHR32083:SF31', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 58', 241307),
(320651, 'PTHR32083:SF32', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 110', 241307),
(320652, 'PTHR32083:SF0', NULL, NULL, NULL, NULL, 'CILIA AND FLAGELLA-ASSOCIATED PROTEIN 58', 241307),
(320653, 'PTHR32083', NULL, NULL, NULL, NULL, 'CILIA AND FLAGELLA-ASSOCIATED PROTEIN 58-RELATED', 241307),
(320654, 'PTHR32083:SF34', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 146', 241307),
(320655, 'PTHR32083:SF45', NULL, NULL, NULL, NULL, '', 241307),
(320656, 'PTHR32083:SF24', NULL, NULL, NULL, NULL, '', 241307),
(320657, 'PTHR32083:SF46', NULL, NULL, NULL, NULL, 'BNAA09G28150D PROTEIN', 241307),
(320658, 'PTHR32083:SF47', NULL, NULL, NULL, NULL, 'FLAGELLAR ATTACHMENT ZONE PROTEIN 1', 241307),
(320659, 'PTHR47661:SF2', NULL, NULL, NULL, NULL, 'PHOSPHOGLUCAN PHOSPHATASE LSF1, CHLOROPLASTIC', 241308),
(320660, 'PTHR47661:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CONTAINING PDZ DOMAIN, A K-BOX DOMAIN, AND A TPR REGION', 241308),
(320661, 'PTHR47661:SF4', NULL, NULL, NULL, NULL, 'OS08G0162600 PROTEIN', 241308),
(320662, 'PTHR47661', NULL, NULL, NULL, NULL, 'PHOSPHOGLUCAN PHOSPHATASE LSF1, CHLOROPLASTIC', 241308),
(320663, 'PTHR19368:SF3', NULL, NULL, NULL, NULL, 'X-LINKED LYMPHOCYTE-REGULATED PROTEIN 3A-RELATED', 241309),
(320664, 'PTHR19368:SF18', NULL, NULL, NULL, NULL, 'COR1 DOMAIN-CONTAINING PROTEIN', 241309),
(320665, 'PTHR19368:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM9B', 241309),
(320666, 'PTHR19368:SF15', NULL, NULL, NULL, NULL, 'COR1 DOMAIN-CONTAINING PROTEIN', 241309),
(320667, 'PTHR19368:SF16', NULL, NULL, NULL, NULL, 'PROTEIN FAM9A', 241309),
(320668, 'PTHR19368:SF10', NULL, NULL, NULL, NULL, 'EG546282 PROTEIN-RELATED', 241309),
(320669, 'PTHR19368:SF12', NULL, NULL, NULL, NULL, 'SYNAPTONEMAL COMPLEX PROTEIN 3', 241309),
(320670, 'PTHR19368:SF7', NULL, NULL, NULL, NULL, 'X-LINKED LYMPHOCYTE REGULATED GENE 4-RELATED', 241309),
(320671, 'PTHR19368:SF6', NULL, NULL, NULL, NULL, 'PROTEIN FAM9C', 241309),
(320672, 'PTHR19368:SF9', NULL, NULL, NULL, NULL, 'X-LINKED LYMPHOCYTE-REGULATED 5A-RELATED', 241309),
(320673, 'PTHR19368:SF8', NULL, NULL, NULL, NULL, 'GENE 1140-RELATED', 241309),
(320674, 'PTHR19368', NULL, NULL, NULL, NULL, 'XLR/SCP3/FAM9', 241309),
(320675, 'PTHR37828', NULL, NULL, NULL, NULL, 'GSR2449 PROTEIN', 241310),
(320676, 'PTHR37828:SF1', NULL, NULL, NULL, NULL, 'YCII DOMAIN-CONTAINING PROTEIN', 241310),
(320677, 'PTHR35563:SF2', NULL, NULL, NULL, NULL, 'BARREL METAL-DEPENDENT HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G16240)-RELATED', 241311); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(320678, 'PTHR35563', NULL, NULL, NULL, NULL, 'BARREL METAL-DEPENDENT HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G16240)-RELATED', 241311),
(320679, 'PTHR42899:SF1', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 20', 241312),
(320680, 'PTHR42899', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 20', 241312),
(320681, 'PTHR48189:SF1', NULL, NULL, NULL, NULL, 'BNAANNG25290D PROTEIN', 241313),
(320682, 'PTHR48189:SF2', NULL, NULL, NULL, NULL, 'BNAC01G20260D PROTEIN', 241313),
(320683, 'PTHR48189:SF3', NULL, NULL, NULL, NULL, 'BNAA10G07240D PROTEIN', 241313),
(320684, 'PTHR48189', NULL, NULL, NULL, NULL, 'BNAA10G07240D PROTEIN', 241313),
(320685, 'PTHR47555:SF2', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINYL TRANSFERASE COMPONENT FAMILY PROTEIN / GPI1 FAMILY PROTEIN', 241314),
(320686, 'PTHR47555', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINYL TRANSFERASE COMPONENT FAMILY PROTEIN / GPI1 FAMILY PROTEIN', 241314),
(320687, 'PTHR11164:SF0', NULL, NULL, NULL, NULL, 'GLUTAMATE--CYSTEINE LIGASE CATALYTIC SUBUNIT', 241315),
(320688, 'PTHR11164', NULL, NULL, NULL, NULL, 'GLUTAMATE CYSTEINE LIGASE', 241315),
(320689, 'PTHR24377:SF969', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 773', 241316),
(320690, 'PTHR24377:SF848', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 806', 241316),
(320691, 'PTHR24377:SF849', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 614', 241316),
(320692, 'PTHR24377:SF725', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 776', 241316),
(320693, 'PTHR24377:SF604', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 285', 241316),
(320694, 'PTHR24377:SF967', NULL, NULL, NULL, NULL, 'RIKEN CDNA 5430403G16 GENE-RELATED', 241316),
(320695, 'PTHR24377:SF968', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 58-RELATED', 241316),
(320696, 'PTHR24377:SF608', NULL, NULL, NULL, NULL, 'REGULATOR OF SEX-LIMITATION CANDIDATE 1-RELATED', 241316),
(320697, 'PTHR24377:SF282', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 470', 241316),
(320698, 'PTHR24377:SF162', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 873', 241316),
(320699, 'PTHR24377:SF165', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 432', 241316),
(320700, 'PTHR24377:SF287', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 780A', 241316),
(320701, 'PTHR24377:SF284', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 655', 241316),
(320702, 'PTHR24377:SF164', NULL, NULL, NULL, NULL, 'KRAB-CONTAINING ZINC-FINGER PROTEIN KRAZ1-RELATED', 241316),
(320703, 'PTHR24377:SF961', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 300', 241316),
(320704, 'PTHR24377:SF720', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 570', 241316),
(320705, 'PTHR24377:SF962', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 548', 241316),
(320706, 'PTHR24377:SF960', NULL, NULL, NULL, NULL, '', 241316),
(320707, 'PTHR24377:SF965', NULL, NULL, NULL, NULL, '', 241316),
(320708, 'PTHR24377:SF966', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 251', 241316),
(320709, 'PTHR24377:SF724', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 416', 241316),
(320710, 'PTHR24377:SF963', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 454', 241316),
(320711, 'PTHR24377:SF964', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 408', 241316),
(320712, 'PTHR24377:SF843', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 869', 241316),
(320713, 'PTHR24377:SF859', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 578', 241316),
(320714, 'PTHR24377:SF739', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 728', 241316),
(320715, 'PTHR24377:SF978', NULL, NULL, NULL, NULL, 'KRAB-CONTAINING ZINC-FINGER PROTEIN KRAZ2', 241316),
(320716, 'PTHR24377:SF979', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 670', 241316),
(320717, 'PTHR24377:SF619', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 345-LIKE', 241316),
(320718, 'PTHR24377:SF180', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 23', 241316),
(320719, 'PTHR24377:SF972', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 777', 241316),
(320720, 'PTHR24377:SF730', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 548', 241316),
(320721, 'PTHR24377:SF851', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 271', 241316);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(320722, 'PTHR24377:SF973', NULL, NULL, NULL, NULL, 'SI:DKEY-111K8.2-RELATED', 241316),
(320723, 'PTHR24377:SF610', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 772', 241316),
(320724, 'PTHR24377:SF852', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 59', 241316),
(320725, 'PTHR24377:SF970', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN OZF', 241316),
(320726, 'PTHR24377:SF971', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 766', 241316),
(320727, 'PTHR24377:SF734', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 82 HOMOLOG', 241316),
(320728, 'PTHR24377:SF976', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 333', 241316),
(320729, 'PTHR24377:SF614', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 775', 241316),
(320730, 'PTHR24377:SF977', NULL, NULL, NULL, NULL, 'SI:ZFOS-932H1.3', 241316),
(320731, 'PTHR24377:SF974', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 386 (KRUPPEL-LIKE)', 241316),
(320732, 'PTHR24377:SF853', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 888', 241316),
(320733, 'PTHR24377:SF611', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 584', 241316),
(320734, 'PTHR24377:SF975', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 79', 241316),
(320735, 'PTHR24377:SF612', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 222', 241316),
(320736, 'PTHR24377:SF854', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 534', 241316),
(320737, 'PTHR24377:SF705', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 233', 241316),
(320738, 'PTHR24377:SF826', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 30', 241316),
(320739, 'PTHR24377:SF947', NULL, NULL, NULL, NULL, 'RIKEN CDNA E430018J23 GENE', 241316),
(320740, 'PTHR24377:SF827', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 852', 241316),
(320741, 'PTHR24377:SF703', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 610', 241316),
(320742, 'PTHR24377:SF945', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 544', 241316),
(320743, 'PTHR24377:SF825', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 761', 241316),
(320744, 'PTHR24377:SF704', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 87', 241316),
(320745, 'PTHR24377:SF709', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 230', 241316),
(320746, 'PTHR24377:SF828', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 37A', 241316),
(320747, 'PTHR24377:SF707', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 569', 241316),
(320748, 'PTHR24377:SF708', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 586', 241316),
(320749, 'PTHR24377:SF829', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 542', 241316),
(320750, 'PTHR24377:SF70', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 565', 241316),
(320751, 'PTHR24377:SF143', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 880', 241316),
(320752, 'PTHR24377:SF141', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 571', 241316),
(320753, 'PTHR24377:SF262', NULL, NULL, NULL, NULL, 'GENE MODEL 1008, (NCBI)', 241316),
(320754, 'PTHR24377:SF384', NULL, NULL, NULL, NULL, 'GENE 12258-RELATED', 241316),
(320755, 'PTHR24377:SF142', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 546', 241316),
(320756, 'PTHR24377:SF940', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 14 HOMOLOG', 241316),
(320757, 'PTHR24377:SF146', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 354A', 241316),
(320758, 'PTHR24377:SF822', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 846', 241316),
(320759, 'PTHR24377:SF943', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 866', 241316),
(320760, 'PTHR24377:SF702', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 552', 241316),
(320761, 'PTHR24377:SF823', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 624', 241316),
(320762, 'PTHR24377:SF941', NULL, NULL, NULL, NULL, '', 241316),
(320763, 'PTHR24377:SF821', NULL, NULL, NULL, NULL, 'MYONEURIN', 241316),
(320764, 'PTHR24377:SF837', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 20', 241316),
(320765, 'PTHR24377:SF716', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 551', 241316),
(320766, 'PTHR24377:SF838', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 319', 241316),
(320767, 'PTHR24377:SF956', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 2', 241316),
(320768, 'PTHR24377:SF718', NULL, NULL, NULL, NULL, 'ZINC FINGER PRTOEIN 943', 241316);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(320769, 'PTHR24377:SF719', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 790', 241316),
(320770, 'PTHR24377:SF273', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 311', 241316),
(320771, 'PTHR24377:SF395', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 181', 241316),
(320772, 'PTHR24377:SF950', NULL, NULL, NULL, NULL, '', 241316),
(320773, 'PTHR24377:SF951', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 471', 241316),
(320774, 'PTHR24377:SF830', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 45', 241316),
(320775, 'PTHR24377:SF277', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 461', 241316),
(320776, 'PTHR24377:SF954', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 235', 241316),
(320777, 'PTHR24377:SF712', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 472', 241316),
(320778, 'PTHR24377:SF710', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 543-RELATED', 241316),
(320779, 'PTHR24377:SF804', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 585A', 241316),
(320780, 'PTHR24377:SF923', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 573', 241316),
(320781, 'PTHR24377:SF924', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 774', 241316),
(320782, 'PTHR24377:SF929', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 665', 241316),
(320783, 'PTHR24377:SF808', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 547', 241316),
(320784, 'PTHR24377:SF806', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 530', 241316),
(320785, 'PTHR24377:SF1001', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 490', 241316),
(320786, 'PTHR24377:SF1000', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 302', 241316),
(320787, 'PTHR24377:SF243', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 677', 241316),
(320788, 'PTHR24377:SF120', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 605', 241316),
(320789, 'PTHR24377:SF246', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 30 HOMOLOG', 241316),
(320790, 'PTHR24377:SF244', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 623', 241316),
(320791, 'PTHR24377:SF800', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 701', 241316),
(320792, 'PTHR24377:SF922', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 820-RELATED', 241316),
(320793, 'PTHR24377:SF369', NULL, NULL, NULL, NULL, 'ZINC FINGER AND SCAN DOMAIN-CONTAINING PROTEIN 10', 241316),
(320794, 'PTHR24377:SF248', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 1 HOMOLOG', 241316),
(320795, 'PTHR24377:SF920', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 606', 241316),
(320796, 'PTHR24377:SF936', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 275', 241316),
(320797, 'PTHR24377:SF934', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 154', 241316),
(320798, 'PTHR24377:SF935', NULL, NULL, NULL, NULL, '', 241316),
(320799, 'PTHR24377:SF814', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 264', 241316),
(320800, 'PTHR24377:SF819', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 607', 241316),
(320801, 'PTHR24377:SF938', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 429-RELATED', 241316),
(320802, 'PTHR24377:SF818', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 34', 241316),
(320803, 'PTHR24377:SF374', NULL, NULL, NULL, NULL, 'ZINC FINGER, IMPRINTED 1', 241316),
(320804, 'PTHR24377:SF932', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 3 ISOFORM 2', 241316),
(320805, 'PTHR24377:SF138', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 540', 241316),
(320806, 'PTHR24377:SF810', NULL, NULL, NULL, NULL, 'CDNA SEQUENCE BC024063-RELATED', 241316),
(320807, 'PTHR24377:SF931', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 613', 241316),
(320808, 'PTHR24377:SF5', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 81', 241316),
(320809, 'PTHR24377:SF907', NULL, NULL, NULL, NULL, 'OTTMUSG00000016588 PROTEIN-RELATED', 241316),
(320810, 'PTHR24377:SF908', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 514', 241316),
(320811, 'PTHR24377:SF107', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 568', 241316),
(320812, 'PTHR24377:SF900', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 577', 241316),
(320813, 'PTHR24377:SF914', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 177', 241316),
(320814, 'PTHR24377:SF915', NULL, NULL, NULL, NULL, 'LD05664P', 241316); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(320815, 'PTHR24377:SF912', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 254-RELATED', 241316),
(320816, 'PTHR24377:SF913', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 12', 241316),
(320817, 'PTHR24377:SF918', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 528', 241316),
(320818, 'PTHR24377:SF919', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 160', 241316),
(320819, 'PTHR24377:SF232', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 26', 241316),
(320820, 'PTHR24377:SF356', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 681', 241316),
(320821, 'PTHR24377:SF112', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 250', 241316),
(320822, 'PTHR24377:SF911', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 816', 241316),
(320823, 'PTHR24377:SF116', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 334', 241316),
(320824, 'PTHR24377:SF681', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 304', 241316),
(320825, 'PTHR24377:SF685', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 256', 241316),
(320826, 'PTHR24377:SF688', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN INTERACTING WITH RIBONUCLEOPROTEIN K', 241316),
(320827, 'PTHR24377:SF22', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 317', 241316),
(320828, 'PTHR24377:SF690', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 549', 241316),
(320829, 'PTHR24377:SF693', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 287', 241316),
(320830, 'PTHR24377:SF691', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 419', 241316),
(320831, 'PTHR24377:SF214', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN WITH KRAB AND SCAN DOMAINS 5', 241316),
(320832, 'PTHR24377:SF698', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 677', 241316),
(320833, 'PTHR24377:SF695', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 689', 241316),
(320834, 'PTHR24377:SF212', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 28 HOMOLOG', 241316),
(320835, 'PTHR24377:SF217', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 286A-RELATED', 241316),
(320836, 'PTHR24377:SF338', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 561', 241316),
(320837, 'PTHR24377:SF218', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 182', 241316),
(320838, 'PTHR24377:SF336', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 74', 241316),
(320839, 'PTHR24377:SF216', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 630', 241316),
(320840, 'PTHR24377', NULL, NULL, NULL, NULL, 'IP01015P-RELATED', 241316),
(320841, 'PTHR24377:SF660', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 214', 241316),
(320842, 'PTHR24377:SF661', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 211', 241316),
(320843, 'PTHR24377:SF782', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 782', 241316),
(320844, 'PTHR24377:SF780', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 871', 241316),
(320845, 'PTHR24377:SF301', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 28', 241316),
(320846, 'PTHR24377:SF662', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 792', 241316),
(320847, 'PTHR24377:SF663', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 868', 241316),
(320848, 'PTHR24377:SF669', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 41', 241316),
(320849, 'PTHR24377:SF787', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 473', 241316),
(320850, 'PTHR24377:SF303', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 595', 241316),
(320851, 'PTHR24377:SF667', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 184', 241316),
(320852, 'PTHR24377:SF425', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 483', 241316),
(320853, 'PTHR24377:SF430', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 155', 241316),
(320854, 'PTHR24377:SF670', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 324B', 241316),
(320855, 'PTHR24377:SF675', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4930522L14 GENE', 241316),
(320856, 'PTHR24377:SF794', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 836', 241316),
(320857, 'PTHR24377:SF316', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 189', 241316),
(320858, 'PTHR24377:SF679', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 563', 241316),
(320859, 'PTHR24377:SF799', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 426', 241316),
(320860, 'PTHR24377:SF436', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 940', 241316);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(320861, 'PTHR24377:SF678', NULL, NULL, NULL, NULL, 'REDUCED EXPRESSION 2-RELATED', 241316),
(320862, 'PTHR24377:SF409', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 860', 241316),
(320863, 'PTHR24377:SF649', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 415-RELATED', 241316),
(320864, 'PTHR24377:SF407', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 93', 241316),
(320865, 'PTHR24377:SF885', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 2', 241316),
(320866, 'PTHR24377:SF882', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN WITH KRAB AND SCAN DOMAINS 7', 241316),
(320867, 'PTHR24377:SF640', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 994-RELATED', 241316),
(320868, 'PTHR24377:SF641', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 354B', 241316),
(320869, 'PTHR24377:SF647', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 793', 241316),
(320870, 'PTHR24377:SF644', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 813', 241316),
(320871, 'PTHR24377:SF765', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 765', 241316),
(320872, 'PTHR24377:SF645', NULL, NULL, NULL, NULL, '', 241316),
(320873, 'PTHR24377:SF417', NULL, NULL, NULL, NULL, 'RIKEN CDNA 9130019O22 GENE-RELATED', 241316),
(320874, 'PTHR24377:SF63', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 283', 241316),
(320875, 'PTHR24377:SF891', NULL, NULL, NULL, NULL, '', 241316),
(320876, 'PTHR24377:SF770', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 526', 241316),
(320877, 'PTHR24377:SF771', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 284', 241316),
(320878, 'PTHR24377:SF650', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 867', 241316),
(320879, 'PTHR24377:SF653', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 708', 241316),
(320880, 'PTHR24377:SF412', NULL, NULL, NULL, NULL, 'REGULATOR OF SEX LIMITED PROTEIN 1-RELATED', 241316),
(320881, 'PTHR24377:SF778', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 260', 241316),
(320882, 'PTHR24377:SF899', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 699', 241316),
(320883, 'PTHR24377:SF655', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 417-RELATED', 241316),
(320884, 'PTHR24377:SF897', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 707', 241316),
(320885, 'PTHR24377:SF989', NULL, NULL, NULL, NULL, 'FINGER PROTEIN, PUTATIVE-RELATED', 241316),
(320886, 'PTHR24377:SF626', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 879', 241316),
(320887, 'PTHR24377:SF868', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 850', 241316),
(320888, 'PTHR24377:SF34', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 157', 241316),
(320889, 'PTHR24377:SF627', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 84', 241316),
(320890, 'PTHR24377:SF36', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 140', 241316),
(320891, 'PTHR24377:SF37', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 175', 241316),
(320892, 'PTHR24377:SF30', NULL, NULL, NULL, NULL, 'ZINC FINGER IMPRINTED 3', 241316),
(320893, 'PTHR24377:SF187', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 480', 241316),
(320894, 'PTHR24377:SF980', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 420', 241316),
(320895, 'PTHR24377:SF741', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 611', 241316),
(320896, 'PTHR24377:SF620', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 527', 241316),
(320897, 'PTHR24377:SF983', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 180', 241316),
(320898, 'PTHR24377:SF621', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 324A', 241316),
(320899, 'PTHR24377:SF984', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 136', 241316),
(320900, 'PTHR24377:SF863', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 583', 241316),
(320901, 'PTHR24377:SF981', NULL, NULL, NULL, NULL, 'FI01202P', 241316),
(320902, 'PTHR24377:SF189', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 7', 241316),
(320903, 'PTHR24377:SF982', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 223', 241316),
(320904, 'PTHR24377:SF987', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 837', 241316),
(320905, 'PTHR24377:SF867', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 485', 241316),
(320906, 'PTHR24377:SF988', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 870', 241316);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(320907, 'PTHR24377:SF625', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 347-RELATED', 241316),
(320908, 'PTHR24377:SF985', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 234', 241316),
(320909, 'PTHR24377:SF622', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 8', 241316),
(320910, 'PTHR24377:SF986', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 607A-RELATED', 241316),
(320911, 'PTHR24377:SF879', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 16', 241316),
(320912, 'PTHR24377:SF759', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 418', 241316),
(320913, 'PTHR24377:SF990', NULL, NULL, NULL, NULL, '', 241316),
(320914, 'PTHR24377:SF991', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 354C', 241316),
(320915, 'PTHR24377:SF196', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 789', 241316),
(320916, 'PTHR24377:SF197', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 320', 241316),
(320917, 'PTHR24377:SF873', NULL, NULL, NULL, NULL, '', 241316),
(320918, 'PTHR24377:SF994', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 433', 241316),
(320919, 'PTHR24377:SF995', NULL, NULL, NULL, NULL, 'LD25464P', 241316),
(320920, 'PTHR24377:SF992', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 17', 241316),
(320921, 'PTHR24377:SF993', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 568', 241316),
(320922, 'PTHR24377:SF998', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 135', 241316),
(320923, 'PTHR24377:SF636', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 132', 241316),
(320924, 'PTHR24377:SF999', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 467', 241316),
(320925, 'PTHR24377:SF878', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 121', 241316),
(320926, 'PTHR24377:SF875', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 468', 241316),
(320927, 'PTHR24377:SF996', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 182-LIKE', 241316),
(320928, 'PTHR24377:SF634', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 92 HOMOLOG', 241316),
(320929, 'PTHR24377:SF997', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 529', 241316),
(320930, 'PTHR43230:SF1', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE ABC TRANSPORTER, ATP-BINDING PROTEIN', 241317),
(320931, 'PTHR43230:SF2', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE ABC TRANSPORTER, ATP-BINDING PROTEIN', 241317),
(320932, 'PTHR43230', NULL, NULL, NULL, NULL, 'ABC-TYPE DIPEPTIDE/OLIGOPEPTIDE TRANSPORT SYSTEM, ATPASE COMPONENT', 241317),
(320933, 'PTHR43230:SF3', NULL, NULL, NULL, NULL, 'ABC-TYPE DIPEPTIDE/OLIGOPEPTIDE TRANSPORT SYSTEM, ATPASE COMPONENT', 241317),
(320934, 'PTHR35312:SF1', NULL, NULL, NULL, NULL, 'OS07G0641800 PROTEIN', 241318),
(320935, 'PTHR35312:SF2', NULL, NULL, NULL, NULL, 'S2 SELF-INCOMPATIBILITY LOCUS-LINKED POLLEN 3.2 PROTEIN', 241318),
(320936, 'PTHR35312', NULL, NULL, NULL, NULL, 'OS07G0641800 PROTEIN', 241318),
(320937, 'PTHR46411:SF3', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 241319),
(320938, 'PTHR46411:SF1', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN-RELATED', 241319),
(320939, 'PTHR46411:SF2', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 241319),
(320940, 'PTHR46411', NULL, NULL, NULL, NULL, 'FAMILY ATPASE, PUTATIVE-RELATED', 241319),
(320941, 'PTHR37911', NULL, NULL, NULL, NULL, 'OSJNBA0067K08.20 PROTEIN', 241320),
(320942, 'PTHR37911:SF1', NULL, NULL, NULL, NULL, 'OS04G0497900 PROTEIN', 241320),
(320943, 'PTHR46823', NULL, NULL, NULL, NULL, 'CALCINEURIN B HOMOLOGOUS PROTEIN 3', 241321),
(320944, 'PTHR46823:SF1', NULL, NULL, NULL, NULL, 'TESCALCIN-LIKE', 241321),
(320945, 'PTHR46823:SF2', NULL, NULL, NULL, NULL, 'CALCINEURIN B HOMOLOGOUS PROTEIN 3', 241321),
(320946, 'PTHR36494:SF2', NULL, NULL, NULL, NULL, '', 241322),
(320947, 'PTHR36494', NULL, NULL, NULL, NULL, '', 241322),
(320948, 'PTHR12848:SF20', NULL, NULL, NULL, NULL, 'REGULATORY-ASSOCIATED PROTEIN OF TOR 1', 241323),
(320949, 'PTHR12848', NULL, NULL, NULL, NULL, 'REGULATORY-ASSOCIATED PROTEIN OF MTOR', 241323),
(320950, 'PTHR12848:SF19', NULL, NULL, NULL, NULL, 'RAPTOR_N DOMAIN-CONTAINING PROTEIN', 241323),
(320951, 'PTHR12848:SF18', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 241323);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(320952, 'PTHR12848:SF16', NULL, NULL, NULL, NULL, 'REGULATORY-ASSOCIATED PROTEIN OF MTOR', 241323),
(320953, 'PTHR13202:SF0', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE COMPLEX SUBUNIT 1', 241324),
(320954, 'PTHR13202', NULL, NULL, NULL, NULL, 'MICROSOMAL SIGNAL PEPTIDASE 12 KDA SUBUNIT', 241324),
(320955, 'PTHR13202:SF4', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE COMPLEX SUBUNIT 1-RELATED', 241324),
(320956, 'PTHR12200:SF5', NULL, NULL, NULL, NULL, 'GAMMA-INTERFERON-INDUCIBLE PROTEIN 16', 241325),
(320957, 'PTHR12200:SF17', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCIBLE PROTEIN AIM2', 241325),
(320958, 'PTHR12200:SF27', NULL, NULL, NULL, NULL, 'MYELOID CELL NUCLEAR DIFFERENTIATION ANTIGEN', 241325),
(320959, 'PTHR12200:SF25', NULL, NULL, NULL, NULL, 'PYRIN AND HIN DOMAIN-CONTAINING PROTEIN 1', 241325),
(320960, 'PTHR12200:SF24', NULL, NULL, NULL, NULL, 'INTERFERON-ACTIVABLE PROTEIN 203-RELATED', 241325),
(320961, 'PTHR12200', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCIBLE PROTEIN AIM2 FAMILY MEMBER', 241325),
(320962, 'PTHR42690', NULL, NULL, NULL, NULL, 'THREONINE SYNTHASE FAMILY MEMBER', 241326),
(320963, 'PTHR42690:SF1', NULL, NULL, NULL, NULL, 'THREONINE SYNTHASE-LIKE 2', 241326),
(320964, 'PTHR13878:SF140', NULL, NULL, NULL, NULL, 'CYTOKININ DEHYDROGENASE', 241327),
(320965, 'PTHR13878:SF142', NULL, NULL, NULL, NULL, 'CYTOKININ DEHYDROGENASE', 241327),
(320966, 'PTHR13878:SF141', NULL, NULL, NULL, NULL, 'CYTOKININ DEHYDROGENASE', 241327),
(320967, 'PTHR13878:SF102', NULL, NULL, NULL, NULL, 'CYTOKININ DEHYDROGENASE 5', 241327),
(320968, 'PTHR13878:SF67', NULL, NULL, NULL, NULL, 'L-GULONOLACTONE OXIDASE 1-RELATED', 241327),
(320969, 'PTHR13878:SF104', NULL, NULL, NULL, NULL, 'ALO DOMAIN-CONTAINING PROTEIN', 241327),
(320970, 'PTHR13878:SF147', NULL, NULL, NULL, NULL, 'L-GULONOLACTONE OXIDASE', 241327),
(320971, 'PTHR13878:SF105', NULL, NULL, NULL, NULL, 'CYTOKININ DEHYDROGENASE 9', 241327),
(320972, 'PTHR13878:SF108', NULL, NULL, NULL, NULL, 'CYTOKININ DEHYDROGENASE 2', 241327),
(320973, 'PTHR13878:SF107', NULL, NULL, NULL, NULL, 'CYTOKININ DEHYDROGENASE 3', 241327),
(320974, 'PTHR13878:SF65', NULL, NULL, NULL, NULL, 'CYTOKININ DEHYDROGENASE 10', 241327),
(320975, 'PTHR13878:SF109', NULL, NULL, NULL, NULL, 'L-GULONOLACTONE OXIDASE', 241327),
(320976, 'PTHR13878:SF131', NULL, NULL, NULL, NULL, 'L-GULONOLACTONE OXIDASE', 241327),
(320977, 'PTHR13878:SF133', NULL, NULL, NULL, NULL, 'L-GULONOLACTONE OXIDASE', 241327),
(320978, 'PTHR13878:SF160', NULL, NULL, NULL, NULL, 'L-GULONOLACTONE OXIDASE 6-RELATED', 241327),
(320979, 'PTHR13878:SF162', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 241327),
(320980, 'PTHR13878:SF91', NULL, NULL, NULL, NULL, 'FAD BINDING DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_6G12070)-RELATED', 241327),
(320981, 'PTHR13878:SF161', NULL, NULL, NULL, NULL, 'CYTOKININ DEHYDROGENASE 2', 241327),
(320982, 'PTHR13878:SF164', NULL, NULL, NULL, NULL, 'CYTOKININ DEHYDROGENASE', 241327),
(320983, 'PTHR13878:SF120', NULL, NULL, NULL, NULL, 'CYTOKININ DEHYDROGENASE', 241327),
(320984, 'PTHR13878:SF163', NULL, NULL, NULL, NULL, 'CYTOKININ DEHYDROGENASE', 241327),
(320985, 'PTHR13878:SF166', NULL, NULL, NULL, NULL, 'L-GULONOLACTONE OXIDASE', 241327),
(320986, 'PTHR13878:SF121', NULL, NULL, NULL, NULL, 'CYTOKININ DEHYDROGENASE 4', 241327),
(320987, 'PTHR13878:SF165', NULL, NULL, NULL, NULL, 'CYTOKININ DEHYDROGENASE', 241327),
(320988, 'PTHR13878:SF124', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 241327),
(320989, 'PTHR13878:SF90', NULL, NULL, NULL, NULL, 'L-GULONOLACTONE OXIDASE', 241327),
(320990, 'PTHR13878:SF167', NULL, NULL, NULL, NULL, 'CYTOKININ DEHYDROGENASE', 241327),
(320991, 'PTHR13878:SF126', NULL, NULL, NULL, NULL, 'L-GULONOLACTONE OXIDASE', 241327),
(320992, 'PTHR13878:SF125', NULL, NULL, NULL, NULL, 'L-GULONOLACTONE OXIDASE 3', 241327),
(320993, 'PTHR13878:SF127', NULL, NULL, NULL, NULL, 'CYTOKININ DEHYDROGENASE 3', 241327),
(320994, 'PTHR13878', NULL, NULL, NULL, NULL, 'GULONOLACTONE OXIDASE', 241327),
(320995, 'PTHR13878:SF129', NULL, NULL, NULL, NULL, 'CYTOKININ DEHYDROGENASE', 241327);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(320996, 'PTHR13878:SF42', NULL, NULL, NULL, NULL, 'CYTOKININ DEHYDROGENASE 1', 241327),
(320997, 'PTHR13878:SF49', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 241327),
(320998, 'PTHR13878:SF150', NULL, NULL, NULL, NULL, 'CYTOKININ DEHYDROGENASE', 241327),
(320999, 'PTHR13878:SF153', NULL, NULL, NULL, NULL, 'L-GULONOLACTONE OXIDASE 5', 241327),
(321000, 'PTHR13878:SF155', NULL, NULL, NULL, NULL, 'ALCOHOL OXIDASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G00430)-RELATED', 241327),
(321001, 'PTHR13878:SF154', NULL, NULL, NULL, NULL, 'CYTOKININ DEHYDROGENASE', 241327),
(321002, 'PTHR13878:SF110', NULL, NULL, NULL, NULL, 'L-GULONOLACTONE OXIDASE', 241327),
(321003, 'PTHR13878:SF157', NULL, NULL, NULL, NULL, 'L-GULONOLACTONE OXIDASE', 241327),
(321004, 'PTHR13878:SF112', NULL, NULL, NULL, NULL, 'CYTOKININ DEHYDROGENASE 7', 241327),
(321005, 'PTHR13878:SF159', NULL, NULL, NULL, NULL, 'L-GULONOLACTONE OXIDASE 2', 241327),
(321006, 'PTHR13878:SF115', NULL, NULL, NULL, NULL, 'CYTOKININ DEHYDROGENASE', 241327),
(321007, 'PTHR13878:SF114', NULL, NULL, NULL, NULL, 'CYTOKININ DEHYDROGENASE 1', 241327),
(321008, 'PTHR13878:SF117', NULL, NULL, NULL, NULL, 'OS08G0519100 PROTEIN', 241327),
(321009, 'PTHR13878:SF98', NULL, NULL, NULL, NULL, 'FAD-LINKED OXIDOREDUCTASE ASQF', 241327),
(321010, 'PTHR13878:SF53', NULL, NULL, NULL, NULL, 'CYTOKININ DEHYDROGENASE 6', 241327),
(321011, 'PTHR13878:SF97', NULL, NULL, NULL, NULL, 'ISOAMYL ALCOHOL OXIDASE', 241327),
(321012, 'PTHR13878:SF59', NULL, NULL, NULL, NULL, 'CYTOKININ DEHYDROGENASE 8', 241327),
(321013, 'PTHR12262:SF0', NULL, NULL, NULL, NULL, 'CCR4-NOT TRANSCRIPTION COMPLEX SUBUNIT 9', 241328),
(321014, 'PTHR12262', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 241328),
(321015, 'PTHR12262:SF5', NULL, NULL, NULL, NULL, 'CELL DIFFERENTIATION PROTEIN RCD1-LIKE', 241328),
(321016, 'PTHR12262:SF22', NULL, NULL, NULL, NULL, 'CELL DIFFERENTIATION FAMILY, RCD1-LIKE PROTEIN', 241328),
(321017, 'PTHR12262:SF11', NULL, NULL, NULL, NULL, 'DIFFERENTIATION PROTEIN RCD1, PUTATIVE, EXPRESSED-RELATED', 241328),
(321018, 'PTHR12262:SF8', NULL, NULL, NULL, NULL, 'CELL DIFFERENTIATION, RCD1-LIKE PROTEIN', 241328),
(321019, 'PTHR12262:SF23', NULL, NULL, NULL, NULL, 'CCR4-NOT TRANSCRIPTION COMPLEX SUBUNIT 9-LIKE ISOFORM X1', 241328),
(321020, 'PTHR12262:SF12', NULL, NULL, NULL, NULL, 'BNAA05G20110D PROTEIN', 241328),
(321021, 'PTHR12262:SF9', NULL, NULL, NULL, NULL, 'CELL DIFFERENTIATION PROTEIN RCD1-LIKE ISOFORM X1', 241328),
(321022, 'PTHR12262:SF20', NULL, NULL, NULL, NULL, 'DIFFERENTIATION PROTEIN RCD1, PUTATIVE-RELATED', 241328),
(321023, 'PTHR12262:SF19', NULL, NULL, NULL, NULL, 'CELL DIFFERENTIATION, RCD1-LIKE PROTEIN', 241328),
(321024, 'PTHR12262:SF15', NULL, NULL, NULL, NULL, 'BNAC04G12270D PROTEIN', 241328),
(321025, 'PTHR12262:SF16', NULL, NULL, NULL, NULL, 'BNAANNG26140D PROTEIN', 241328),
(321026, 'PTHR12262:SF13', NULL, NULL, NULL, NULL, 'CELL DIFFERENTIATION PROTEIN RCD1 HOMOLOG', 241328),
(321027, 'PTHR12262:SF24', NULL, NULL, NULL, NULL, 'CELL DIFFERENTIATION PROTEIN RCD1', 241328),
(321028, 'PTHR12262:SF25', NULL, NULL, NULL, NULL, 'RCD1/CAF40-RELATED', 241328),
(321029, 'PTHR12388:SF0', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM16', 241329),
(321030, 'PTHR12388', NULL, NULL, NULL, NULL, 'MITOCHONDRIA ASSOCIATED GRANULOCYTE MACROPHAGE CSF SIGNALING MOLECULE', 241329),
(321031, 'PTHR12388:SF5', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM16-LIKE', 241329),
(321032, 'PTHR12388:SF6', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT PAM16 LIKE 1', 241329),
(321033, 'PTHR12388:SF4', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM16-LIKE', 241329),
(321034, 'PTHR12388:SF2', NULL, NULL, NULL, NULL, 'OS01G0960800 PROTEIN', 241329),
(321035, 'PTHR22255:SF1', NULL, NULL, NULL, NULL, 'LD32918P', 241330),
(321036, 'PTHR22255:SF4', NULL, NULL, NULL, NULL, 'UROPORPHYRINOGEN DECARBOXYLASE', 241330),
(321037, 'PTHR22255:SF9', NULL, NULL, NULL, NULL, 'LP06548P', 241330);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(321038, 'PTHR22255', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 241330),
(321039, 'PTHR35323:SF5', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 62', 241331),
(321040, 'PTHR35323:SF2', NULL, NULL, NULL, NULL, 'SAP DOMAIN-CONTAINING PROTEIN', 241331),
(321041, 'PTHR35323', NULL, NULL, NULL, NULL, 'SAP DOMAIN-CONTAINING PROTEIN', 241331),
(321042, 'PTHR43491', NULL, NULL, NULL, NULL, 'UDP-N-ACETYL-D-MANNOSAMINE DEHYDROGENASE', 241332),
(321043, 'PTHR43491:SF2', NULL, NULL, NULL, NULL, 'UDP-N-ACETYL-D-MANNOSAMINE DEHYDROGENASE', 241332),
(321044, 'PTHR43491:SF5', NULL, NULL, NULL, NULL, 'UDP-MANNAC 6-DEHYDROGENASE', 241332),
(321045, 'PTHR43491:SF1', NULL, NULL, NULL, NULL, 'UDP-N-ACETYL-D-MANNOSAMINE DEHYDROGENASE', 241332),
(321046, 'PTHR12292:SF2', NULL, NULL, NULL, NULL, 'RWD DOMAIN-CONTAINING PROTEIN 1', 241333),
(321047, 'PTHR12292', NULL, NULL, NULL, NULL, 'RWD DOMAIN-CONTAINING PROTEIN', 241333),
(321048, 'PTHR12292:SF4', NULL, NULL, NULL, NULL, 'RWD DOMAIN-CONTAINING PROTEIN 1-RELATED', 241333),
(321049, 'PTHR12292:SF5', NULL, NULL, NULL, NULL, 'RWD DOMAIN-CONTAINING PROTEIN', 241333),
(321050, 'PTHR12292:SF6', NULL, NULL, NULL, NULL, 'BNAA06G02130D PROTEIN', 241333),
(321051, 'PTHR47814', NULL, NULL, NULL, NULL, 'PEPTIDYL-TRNA HYDROLASE ARFB', 241334),
(321052, 'PTHR47814:SF1', NULL, NULL, NULL, NULL, 'PEPTIDYL-TRNA HYDROLASE ARFB', 241334),
(321053, 'PTHR14938', NULL, NULL, NULL, NULL, 'HCLS1-ASSOCIATED PROTEIN X-1', 241335),
(321054, 'PTHR14938:SF2', NULL, NULL, NULL, NULL, 'HCLS1-ASSOCIATED PROTEIN X-1', 241335),
(321055, 'PTHR15360:SF1', NULL, NULL, NULL, NULL, 'PLATELET-DERIVED GROWTH FACTOR RECEPTOR-LIKE PROTEIN', 241336),
(321056, 'PTHR15360', NULL, NULL, NULL, NULL, 'PLATELET-DERIVED GROWTH FACTOR RECEPTOR LIKE', 241336),
(321057, 'PTHR15360:SF4', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241336),
(321058, 'PTHR15360:SF2', NULL, NULL, NULL, NULL, 'SI:ZFOS-1069F5.1', 241336),
(321059, 'PTHR37695:SF4', NULL, NULL, NULL, NULL, 'BNAC05G00390D PROTEIN', 241337),
(321060, 'PTHR37695:SF1', NULL, NULL, NULL, NULL, 'RECOMBINATION INITIATION DEFECTS 3-RELATED', 241337),
(321061, 'PTHR37695:SF6', NULL, NULL, NULL, NULL, '', 241337),
(321062, 'PTHR37695', NULL, NULL, NULL, NULL, 'RECOMBINATION INITIATION DEFECTS 3-RELATED', 241337),
(321063, 'PTHR36984:SF1', NULL, NULL, NULL, NULL, 'CRISPR-ASSOCIATED ENDORIBONUCLEASE CAS6 1', 241338),
(321064, 'PTHR36984:SF3', NULL, NULL, NULL, NULL, 'CRISPR-ASSOCIATED PROTEIN CAS6', 241338),
(321065, 'PTHR36984', NULL, NULL, NULL, NULL, 'CRISPR-ASSOCIATED ENDORIBONUCLEASE CAS6 1', 241338),
(321066, 'PTHR31722:SF77', NULL, NULL, NULL, NULL, '', 241339),
(321067, 'PTHR31722:SF33', NULL, NULL, NULL, NULL, 'COPPER-BINDING PERIPLASMIC PROTEIN', 241339),
(321068, 'PTHR31722:SF78', NULL, NULL, NULL, NULL, 'BNAA07G24670D PROTEIN', 241339),
(321069, 'PTHR31722:SF56', NULL, NULL, NULL, NULL, 'BNAC03G73740D PROTEIN', 241339),
(321070, 'PTHR31722:SF34', NULL, NULL, NULL, NULL, 'F1O19.11 PROTEIN', 241339),
(321071, 'PTHR31722:SF75', NULL, NULL, NULL, NULL, '', 241339),
(321072, 'PTHR31722:SF32', NULL, NULL, NULL, NULL, '', 241339),
(321073, 'PTHR31722:SF76', NULL, NULL, NULL, NULL, '', 241339),
(321074, 'PTHR31722:SF54', NULL, NULL, NULL, NULL, 'OS04G0618950 PROTEIN', 241339),
(321075, 'PTHR31722:SF59', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN DDB_G0274915-LIKE', 241339),
(321076, 'PTHR31722:SF79', NULL, NULL, NULL, NULL, 'PLANT PROTEIN MATCH IS: (TAIR:PLANT.1) PROTEIN, PUTATIVE-RELATED', 241339),
(321077, 'PTHR31722:SF36', NULL, NULL, NULL, NULL, '', 241339),
(321078, 'PTHR31722:SF39', NULL, NULL, NULL, NULL, 'OS08G0474100 PROTEIN', 241339),
(321079, 'PTHR31722', NULL, NULL, NULL, NULL, 'OS06G0675200 PROTEIN', 241339),
(321080, 'PTHR31722:SF62', NULL, NULL, NULL, NULL, 'EMB|CAB62433.1|', 241339),
(321081, 'PTHR31722:SF63', NULL, NULL, NULL, NULL, 'BNAANNG03030D PROTEIN', 241339),
(321082, 'PTHR31722:SF61', NULL, NULL, NULL, NULL, '', 241339),
(321083, 'PTHR31722:SF44', NULL, NULL, NULL, NULL, 'BNAC03G66120D PROTEIN', 241339);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(321084, 'PTHR31722:SF45', NULL, NULL, NULL, NULL, 'BNAA09G52580D PROTEIN', 241339),
(321085, 'PTHR31722:SF67', NULL, NULL, NULL, NULL, 'BNACNNG26630D PROTEIN', 241339),
(321086, 'PTHR31722:SF42', NULL, NULL, NULL, NULL, 'BNAC09G38350D PROTEIN', 241339),
(321087, 'PTHR31722:SF64', NULL, NULL, NULL, NULL, '', 241339),
(321088, 'PTHR31722:SF43', NULL, NULL, NULL, NULL, 'BNAA05G26250D PROTEIN', 241339),
(321089, 'PTHR31722:SF48', NULL, NULL, NULL, NULL, 'BNAA02G19090D PROTEIN', 241339),
(321090, 'PTHR31722:SF2', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SETD1A-LIKE', 241339),
(321091, 'PTHR31722:SF46', NULL, NULL, NULL, NULL, '', 241339),
(321092, 'PTHR31722:SF28', NULL, NULL, NULL, NULL, 'OS09G0459200 PROTEIN', 241339),
(321093, 'PTHR31722:SF70', NULL, NULL, NULL, NULL, 'OSJNBA0058K23.8-LIKE PROTEIN', 241339),
(321094, 'PTHR31722:SF0', NULL, NULL, NULL, NULL, 'OS06G0675200 PROTEIN', 241339),
(321095, 'PTHR31722:SF73', NULL, NULL, NULL, NULL, '', 241339),
(321096, 'PTHR31722:SF52', NULL, NULL, NULL, NULL, 'BNAANNG11160D PROTEIN', 241339),
(321097, 'PTHR31722:SF74', NULL, NULL, NULL, NULL, 'OS02G0165500 PROTEIN', 241339),
(321098, 'PTHR31722:SF71', NULL, NULL, NULL, NULL, '', 241339),
(321099, 'PTHR31722:SF50', NULL, NULL, NULL, NULL, 'BNAC08G22030D PROTEIN', 241339),
(321100, 'PTHR37804', NULL, NULL, NULL, NULL, 'CDAA REGULATORY PROTEIN CDAR', 241340),
(321101, 'PTHR37804:SF1', NULL, NULL, NULL, NULL, 'CDAA REGULATORY PROTEIN CDAR', 241340),
(321102, 'PTHR31612', NULL, NULL, NULL, NULL, 'MULTIVESICULAR BODY SUBUNIT 12A', 241341),
(321103, 'PTHR31612:SF2', NULL, NULL, NULL, NULL, 'MULTIVESICULAR BODY SUBUNIT 12A', 241341),
(321104, 'PTHR19306:SF6', NULL, NULL, NULL, NULL, 'STRUCTURAL MAINTENANCE OF CHROMOSOMES PROTEIN 6', 241342),
(321105, 'PTHR19306:SF7', NULL, NULL, NULL, NULL, 'SI:DKEY-119F1.1', 241342),
(321106, 'PTHR19306:SF8', NULL, NULL, NULL, NULL, 'STRUCTURAL MAINTENANCE OF CHROMOSOMES 6', 241342),
(321107, 'PTHR19306:SF9', NULL, NULL, NULL, NULL, 'STRUCTURAL MAINTENANCE OF CHROMOSOMES PROTEIN 6B', 241342),
(321108, 'PTHR19306', NULL, NULL, NULL, NULL, 'STRUCTURAL MAINTENANCE OF CHROMOSOMES 5,6  SMC5, SMC6', 241342),
(321109, 'PTHR19306:SF11', NULL, NULL, NULL, NULL, 'GRIP DOMAIN-CONTAINING PROTEIN', 241342),
(321110, 'PTHR28467:SF1', NULL, NULL, NULL, NULL, 'PAXIP1-ASSOCIATED GLUTAMATE-RICH PROTEIN 1', 241343),
(321111, 'PTHR28467', NULL, NULL, NULL, NULL, 'PAXIP1-ASSOCIATED GLUTAMATE-RICH PROTEIN 1', 241343),
(321112, 'PTHR34826:SF2', NULL, NULL, NULL, NULL, 'UPF0590 PROTEIN C409.17C', 241344),
(321113, 'PTHR34826:SF1', NULL, NULL, NULL, NULL, 'UPF0590 PROTEIN C594.01', 241344),
(321114, 'PTHR34826', NULL, NULL, NULL, NULL, 'UPF0590 PROTEIN C409.17C', 241344),
(321115, 'PTHR22935', NULL, NULL, NULL, NULL, 'PENICILLIN-BINDING PROTEIN', 241345),
(321116, 'PTHR22935:SF95', NULL, NULL, NULL, NULL, 'BETA-LACTAMASE-LIKE 1-RELATED', 241345),
(321117, 'PTHR22935:SF97', NULL, NULL, NULL, NULL, 'BETA-LACTAMASE DOMAIN-CONTAINING PROTEIN', 241345),
(321118, 'PTHR22935:SF98', NULL, NULL, NULL, NULL, 'BETA-LACTAMASE FAMILY PROTEIN', 241345),
(321119, 'PTHR22935:SF94', NULL, NULL, NULL, NULL, 'BETA-LACTAMASE-LIKE PROTEIN 2', 241345),
(321120, 'PTHR33066', NULL, NULL, NULL, NULL, 'INTEGRASE_SAM-LIKE_N DOMAIN-CONTAINING PROTEIN', 241346),
(321121, 'PTHR33066:SF1', NULL, NULL, NULL, NULL, 'INTEGRASE_SAM-LIKE_N DOMAIN-CONTAINING PROTEIN', 241346),
(321122, 'PTHR46496:SF1', NULL, NULL, NULL, NULL, 'ZEAXANTHIN EPOXIDASE, CHLOROPLASTIC', 241347),
(321123, 'PTHR46496:SF10', NULL, NULL, NULL, NULL, 'ZEAXANTHIN EPOXIDASE, CHLOROPLASTIC', 241347),
(321124, 'PTHR46496', NULL, NULL, NULL, NULL, '', 241347),
(321125, 'PTHR46496:SF9', NULL, NULL, NULL, NULL, 'ZEAXANTHIN EPOXIDASE, CHLOROPLASTIC', 241347),
(321126, 'PTHR46496:SF8', NULL, NULL, NULL, NULL, 'FAD_BINDING_3 DOMAIN-CONTAINING PROTEIN', 241347),
(321127, 'PTHR46496:SF6', NULL, NULL, NULL, NULL, 'ZEAXANTHIN EPOXIDASE, CHLOROPLASTIC-LIKE ISOFORM X1', 241347),
(321128, 'PTHR46496:SF4', NULL, NULL, NULL, NULL, 'ZEAXANTHIN EPOXIDASE', 241347);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(321129, 'PTHR33204:SF34', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, MARR FAMILY', 241348),
(321130, 'PTHR33204:SF12', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, MARR FAMILY', 241348),
(321131, 'PTHR33204:SF35', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR YODB', 241348),
(321132, 'PTHR33204:SF32', NULL, NULL, NULL, NULL, 'HTH HXLR-TYPE DOMAIN-CONTAINING PROTEIN', 241348),
(321133, 'PTHR33204:SF33', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, MARR FAMILY', 241348),
(321134, 'PTHR33204:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, MARR FAMILY', 241348),
(321135, 'PTHR33204:SF17', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 241348),
(321136, 'PTHR33204:SF28', NULL, NULL, NULL, NULL, 'HTH HXLR-TYPE DOMAIN-CONTAINING PROTEIN', 241348),
(321137, 'PTHR33204:SF36', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 241348),
(321138, 'PTHR33204:SF26', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 241348),
(321139, 'PTHR33204:SF29', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL ACTIVATOR HXLR', 241348),
(321140, 'PTHR33204:SF18', NULL, NULL, NULL, NULL, 'HTH HXLR-TYPE DOMAIN-CONTAINING PROTEIN', 241348),
(321141, 'PTHR33204', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, MARR FAMILY', 241348),
(321142, 'PTHR33204:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', 241348),
(321143, 'PTHR11564:SF7', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE 54 KDA PROTEIN, CHLOROPLASTIC', 241349),
(321144, 'PTHR11564:SF29', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE 54 KDA PROTEIN 1', 241349),
(321145, 'PTHR11564:SF28', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE 54 KDA PROTEIN', 241349),
(321146, 'PTHR11564:SF5', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE 54 KDA PROTEIN', 241349),
(321147, 'PTHR11564:SF38', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE 54 KDA PROTEIN', 241349),
(321148, 'PTHR11564:SF37', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE 54 KDA PROTEIN', 241349),
(321149, 'PTHR11564:SF36', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE 54 KDA PROTEIN', 241349),
(321150, 'PTHR11564:SF35', NULL, NULL, NULL, NULL, 'SRP54 DOMAIN-CONTAINING PROTEIN', 241349),
(321151, 'PTHR11564:SF34', NULL, NULL, NULL, NULL, 'SRP54 DOMAIN-CONTAINING PROTEIN', 241349),
(321152, 'PTHR11564:SF32', NULL, NULL, NULL, NULL, 'OS11G0153700 PROTEIN', 241349),
(321153, 'PTHR11564', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE 54K PROTEIN SRP54', 241349),
(321154, 'PTHR11564:SF31', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE 54 KDA PROTEIN', 241349),
(321155, 'PTHR45871:SF4', NULL, NULL, NULL, NULL, '', 241350),
(321156, 'PTHR45871:SF3', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL N-ACETYLGLUCOSAMINYLTRANSFERASE SUBUNIT A', 241350),
(321157, 'PTHR45871:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL N-ACETYLGLUCOSAMINYLTRANSFERASE SUBUNIT A', 241350),
(321158, 'PTHR45871', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINYL-PHOSPHATIDYLINOSITOL BIOSYNTHETIC PROTEIN', 241350),
(321159, 'PTHR28525', NULL, NULL, NULL, NULL, 'REACTIVE OXYGEN SPECIES MODULATOR 1', 241351),
(321160, 'PTHR28525:SF6', NULL, NULL, NULL, NULL, 'BNAC03G35570D PROTEIN', 241351),
(321161, 'PTHR28525:SF5', NULL, NULL, NULL, NULL, 'BNAC01G39580D PROTEIN', 241351),
(321162, 'PTHR28525:SF4', NULL, NULL, NULL, NULL, 'REACTIVE OXYGEN SPECIES MODULATOR 1', 241351),
(321163, 'PTHR28525:SF1', NULL, NULL, NULL, NULL, 'REACTIVE OXYGEN SPECIES MODULATOR 1', 241351),
(321164, 'PTHR36291', NULL, NULL, NULL, NULL, 'UBAP1-MVB12-ASSOCIATED (UMA)-DOMAIN CONTAINING PROTEIN 1', 241352),
(321165, 'PTHR36291:SF1', NULL, NULL, NULL, NULL, 'UBAP1-MVB12-ASSOCIATED (UMA)-DOMAIN CONTAINING PROTEIN 1', 241352),
(321166, 'PTHR10225', NULL, NULL, NULL, NULL, 'HYALURONAN  RECEPTOR', 241353),
(321167, 'PTHR10225:SF5', NULL, NULL, NULL, NULL, '', 241353),
(321168, 'PTHR10225:SF6', NULL, NULL, NULL, NULL, 'CD44 ANTIGEN', 241353),
(321169, 'PTHR10225:SF2', NULL, NULL, NULL, NULL, 'LYMPHATIC VESSEL ENDOTHELIAL HYALURONIC ACID RECEPTOR 1', 241353);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(321170, 'PTHR47022:SF3', NULL, NULL, NULL, NULL, 'BTB AND MATH DOMAIN-CONTAINING PROTEIN 39', 241354),
(321171, 'PTHR47022:SF2', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 241354),
(321172, 'PTHR47022:SF4', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 241354),
(321173, 'PTHR47022:SF1', NULL, NULL, NULL, NULL, 'BTB AND MATH DOMAIN-CONTAINING PROTEIN 36-RELATED', 241354),
(321174, 'PTHR47022', NULL, NULL, NULL, NULL, 'BTB AND MATH DOMAIN-CONTAINING PROTEIN 36-RELATED', 241354),
(321175, 'PTHR43027', NULL, NULL, NULL, NULL, 'DOXORUBICIN RESISTANCE ABC TRANSPORTER PERMEASE PROTEIN DRRC-RELATED', 241355),
(321176, 'PTHR43027:SF2', NULL, NULL, NULL, NULL, 'TRANSPORT PERMEASE PROTEIN', 241355),
(321177, 'PTHR43027:SF1', NULL, NULL, NULL, NULL, 'DOXORUBICIN RESISTANCE ABC TRANSPORTER PERMEASE PROTEIN DRRC-RELATED', 241355),
(321178, 'PTHR22878', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 241356),
(321179, 'PTHR22878:SF62', NULL, NULL, NULL, NULL, 'DHC_N1 DOMAIN-CONTAINING PROTEIN-RELATED', 241356),
(321180, 'PTHR22878:SF63', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL HEAVY CHAIN 10', 241356),
(321181, 'PTHR10113:SF40', NULL, NULL, NULL, NULL, 'EUKARYOTIC PEPTIDE CHAIN RELEASE FACTOR SUBUNIT 1-3', 241357),
(321182, 'PTHR10113:SF10', NULL, NULL, NULL, NULL, 'EUKARYOTIC PEPTIDE CHAIN RELEASE FACTOR SUBUNIT 1', 241357),
(321183, 'PTHR10113:SF21', NULL, NULL, NULL, NULL, 'EUKARYOTIC PEPTIDE CHAIN RELEASE FACTOR SUBUNIT 1', 241357),
(321184, 'PTHR10113:SF41', NULL, NULL, NULL, NULL, 'PEPTIDE CHAIN RELEASE FACTOR SUBUNIT 1-2, PUTATIVE, EXPRESSED-RELATED', 241357),
(321185, 'PTHR10113:SF42', NULL, NULL, NULL, NULL, 'EUKARYOTIC PEPTIDE CHAIN RELEASE FACTOR SUBUNIT 1-1', 241357),
(321186, 'PTHR10113:SF31', NULL, NULL, NULL, NULL, 'EUKARYOTIC PEPTIDE CHAIN RELEASE FACTOR SUBUNIT 1-2', 241357),
(321187, 'PTHR10113:SF26', NULL, NULL, NULL, NULL, 'EUKARYOTIC PEPTIDE CHAIN RELEASE FACTOR SUBUNIT 1-3-LIKE', 241357),
(321188, 'PTHR10113', NULL, NULL, NULL, NULL, 'PEPTIDE CHAIN RELEASE FACTOR SUBUNIT 1', 241357),
(321189, 'PTHR10113:SF12', NULL, NULL, NULL, NULL, 'OS01G0939500 PROTEIN', 241357),
(321190, 'PTHR10113:SF35', NULL, NULL, NULL, NULL, 'EUKARYOTIC PEPTIDE CHAIN RELEASE FACTOR SUBUNIT 1-3', 241357),
(321191, 'PTHR10113:SF29', NULL, NULL, NULL, NULL, 'OS05G0373900 PROTEIN', 241357),
(321192, 'PTHR10113:SF27', NULL, NULL, NULL, NULL, 'EUKARYOTIC PEPTIDE CHAIN RELEASE FACTOR SUBUNIT 1', 241357),
(321193, 'PTHR10113:SF28', NULL, NULL, NULL, NULL, 'ERF1_1 DOMAIN-CONTAINING PROTEIN', 241357),
(321194, 'PTHR10113:SF39', NULL, NULL, NULL, NULL, 'EUKARYOTIC PEPTIDE CHAIN RELEASE FACTOR SUBUNIT 1-1', 241357),
(321195, 'PTHR10339', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLTRANSFERASE', 241358),
(321196, 'PTHR10339:SF19', NULL, NULL, NULL, NULL, 'GPI-LINKED NAD(P)(+)--ARGININE ADP-RIBOSYLTRANSFERASE 1', 241358),
(321197, 'PTHR10339:SF4', NULL, NULL, NULL, NULL, 'ECTO-ADP-RIBOSYLTRANSFERASE 3', 241358),
(321198, 'PTHR10339:SF1', NULL, NULL, NULL, NULL, 'ECTO-ADP-RIBOSYLTRANSFERASE 4', 241358),
(321199, 'PTHR10339:SF25', NULL, NULL, NULL, NULL, 'NAD(P)(+)--ARGININE ADP-RIBOSYLTRANSFERASE', 241358),
(321200, 'PTHR10339:SF2', NULL, NULL, NULL, NULL, 'ECTO-ADP-RIBOSYLTRANSFERASE 5', 241358),
(321201, 'PTHR10339:SF24', NULL, NULL, NULL, NULL, 'T-CELL ECTO-ADP-RIBOSYLTRANSFERASE 1-RELATED', 241358),
(321202, 'PTHR47898:SF1', NULL, NULL, NULL, NULL, 'KUNITZ-TYPE PROTEASE INHIBITOR 4', 241359),
(321203, 'PTHR47898', NULL, NULL, NULL, NULL, 'KUNITZ-TYPE PROTEASE INHIBITOR 4', 241359),
(321204, 'PTHR38697:SF1', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN SIMILAR TO S. CEREVISIAE NUP2 (EUROFUNG)', 241360),
(321205, 'PTHR38697', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN SIMILAR TO S. CEREVISIAE NUP2 (EUROFUNG)', 241360),
(321206, 'PTHR34067:SF20', NULL, NULL, NULL, NULL, 'OS04G0193200 PROTEIN', 241361),
(321207, 'PTHR34067:SF21', NULL, NULL, NULL, NULL, 'BNAC09G51260D PROTEIN', 241361),
(321208, 'PTHR34067:SF22', NULL, NULL, NULL, NULL, 'METHYL-CPG-BINDING DOMAIN-CONTAINING PROTEIN 13-LIKE', 241361);
INSERT INTO "PUBLIC"."MODEL" VALUES
(321209, 'PTHR34067:SF23', NULL, NULL, NULL, NULL, 'DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 241361),
(321210, 'PTHR34067:SF24', NULL, NULL, NULL, NULL, 'METHYL-CPG-BINDING DOMAIN-CONTAINING PROTEIN 13', 241361),
(321211, 'PTHR34067', NULL, NULL, NULL, NULL, 'OS04G0193200 PROTEIN', 241361),
(321212, 'PTHR34067:SF9', NULL, NULL, NULL, NULL, 'OS04G0266400 PROTEIN', 241361),
(321213, 'PTHR34067:SF19', NULL, NULL, NULL, NULL, 'OS04G0613800 PROTEIN', 241361),
(321214, 'PTHR34067:SF3', NULL, NULL, NULL, NULL, 'METHYL-CPG-BINDING DOMAIN-CONTAINING PROTEIN 13', 241361),
(321215, 'PTHR31907:SF50', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321216, 'PTHR31907:SF51', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321217, 'PTHR31907:SF53', NULL, NULL, NULL, NULL, 'MLP-LIKE PROTEIN 165-RELATED', 241362),
(321218, 'PTHR31907:SF54', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321219, 'PTHR31907:SF55', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321220, 'PTHR31907:SF56', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321221, 'PTHR31907:SF12', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321222, 'PTHR31907:SF57', NULL, NULL, NULL, NULL, 'BNAA08G20220D PROTEIN', 241362),
(321223, 'PTHR31907:SF13', NULL, NULL, NULL, NULL, 'MAJOR LATEX-LIKE PROTEIN-RELATED', 241362),
(321224, 'PTHR31907:SF58', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321225, 'PTHR31907:SF14', NULL, NULL, NULL, NULL, 'KIROLA-LIKE', 241362),
(321226, 'PTHR31907:SF15', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED PROTEIN BET V I FAMILY PROTEIN', 241362),
(321227, 'PTHR31907:SF59', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321228, 'PTHR31907:SF17', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321229, 'PTHR31907:SF19', NULL, NULL, NULL, NULL, 'KIROLA-LIKE', 241362),
(321230, 'PTHR31907:SF60', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321231, 'PTHR31907:SF61', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321232, 'PTHR31907:SF62', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321233, 'PTHR31907:SF63', NULL, NULL, NULL, NULL, 'BNAA04G13370D PROTEIN', 241362),
(321234, 'PTHR31907:SF64', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321235, 'PTHR31907:SF20', NULL, NULL, NULL, NULL, 'KIROLA-LIKE ISOFORM X1', 241362),
(321236, 'PTHR31907:SF21', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321237, 'PTHR31907:SF66', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321238, 'PTHR31907:SF22', NULL, NULL, NULL, NULL, 'POLYKETIDE CYCLASE/DEHYDRASE AND LIPID TRANSPORT SUPERFAMILY PROTEIN', 241362),
(321239, 'PTHR31907:SF67', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321240, 'PTHR31907:SF23', NULL, NULL, NULL, NULL, 'KIROLA-LIKE ISOFORM X1', 241362),
(321241, 'PTHR31907:SF24', NULL, NULL, NULL, NULL, 'MLP-LIKE PROTEIN 28-RELATED', 241362),
(321242, 'PTHR31907:SF68', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321243, 'PTHR31907:SF25', NULL, NULL, NULL, NULL, 'SN-2 PROTEIN', 241362),
(321244, 'PTHR31907:SF69', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321245, 'PTHR31907:SF26', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321246, 'PTHR31907:SF27', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321247, 'PTHR31907:SF28', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321248, 'PTHR31907:SF29', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321249, 'PTHR31907:SF4', NULL, NULL, NULL, NULL, 'MLP-LIKE PROTEIN 34-RELATED', 241362),
(321250, 'PTHR31907:SF1', NULL, NULL, NULL, NULL, 'MLP-LIKE PROTEIN 423', 241362),
(321251, 'PTHR31907:SF2', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED PROTEIN BET V I FAMILY PROTEIN', 241362); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(321252, 'PTHR31907', NULL, NULL, NULL, NULL, 'MLP-LIKE PROTEIN 423', 241362),
(321253, 'PTHR31907:SF72', NULL, NULL, NULL, NULL, 'MLP-LIKE PROTEIN 31', 241362),
(321254, 'PTHR31907:SF73', NULL, NULL, NULL, NULL, 'POLYKETIDE CYCLASE/DEHYDRASE AND LIPID TRANSPORTER', 241362),
(321255, 'PTHR31907:SF74', NULL, NULL, NULL, NULL, 'MAJOR LATEX PROTEIN', 241362),
(321256, 'PTHR31907:SF30', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321257, 'PTHR31907:SF31', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321258, 'PTHR31907:SF33', NULL, NULL, NULL, NULL, 'KIROLA-LIKE', 241362),
(321259, 'PTHR31907:SF34', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321260, 'PTHR31907:SF35', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321261, 'PTHR31907:SF36', NULL, NULL, NULL, NULL, 'BET V I/MAJOR LATEX PROTEIN, START-LIKE DOMAIN PROTEIN-RELATED', 241362),
(321262, 'PTHR31907:SF37', NULL, NULL, NULL, NULL, 'SN-2 PROTEIN', 241362),
(321263, 'PTHR31907:SF38', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321264, 'PTHR31907:SF39', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321265, 'PTHR31907:SF40', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321266, 'PTHR31907:SF41', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321267, 'PTHR31907:SF42', NULL, NULL, NULL, NULL, 'MLP-LIKE PROTEIN 43', 241362),
(321268, 'PTHR31907:SF43', NULL, NULL, NULL, NULL, 'START-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 241362),
(321269, 'PTHR31907:SF44', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321270, 'PTHR31907:SF45', NULL, NULL, NULL, NULL, 'MAJOR LATEX', 241362),
(321271, 'PTHR31907:SF46', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321272, 'PTHR31907:SF47', NULL, NULL, NULL, NULL, 'BNAA04G13380D PROTEIN', 241362),
(321273, 'PTHR31907:SF48', NULL, NULL, NULL, NULL, 'BET V I/MAJOR LATEX PROTEIN, START-LIKE DOMAIN PROTEIN-RELATED', 241362),
(321274, 'PTHR31907:SF49', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 241362),
(321275, 'PTHR42716', NULL, NULL, NULL, NULL, 'L-ASPARTATE OXIDASE', 241363),
(321276, 'PTHR42716:SF3', NULL, NULL, NULL, NULL, 'SLL1913 PROTEIN', 241363),
(321277, 'PTHR42716:SF1', NULL, NULL, NULL, NULL, 'SLL0471 PROTEIN', 241363),
(321278, 'PTHR42716:SF2', NULL, NULL, NULL, NULL, 'L-ASPARTATE OXIDASE, CHLOROPLASTIC', 241363),
(321279, 'PTHR37714', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 241364),
(321280, 'PTHR37714:SF1', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 241364),
(321281, 'PTHR37714:SF2', NULL, NULL, NULL, NULL, 'SMALL HYDROPHOBIC PROTEIN', 241364),
(321282, 'PTHR24168:SF0', NULL, NULL, NULL, NULL, 'KN MOTIF AND ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 2', 241365),
(321283, 'PTHR24168:SF19', NULL, NULL, NULL, NULL, 'KN MOTIF AND ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 1', 241365),
(321284, 'PTHR24168:SF24', NULL, NULL, NULL, NULL, 'KN MOTIF AND ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 4', 241365),
(321285, 'PTHR24168:SF21', NULL, NULL, NULL, NULL, 'KANK, ISOFORM D', 241365),
(321286, 'PTHR24168:SF23', NULL, NULL, NULL, NULL, 'KN MOTIF AND ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 3', 241365),
(321287, 'PTHR24168', NULL, NULL, NULL, NULL, 'KN MOTIF AND ANKYRIN REPEAT DOMAIN-CONTAINING', 241365),
(321288, 'PTHR13405:SF11', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP133', 241366),
(321289, 'PTHR13405:SF12', NULL, NULL, NULL, NULL, 'NUCLEOPORIN NUP132', 241366),
(321290, 'PTHR13405', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP133', 241366),
(321291, 'PTHR31464:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG01266', 241367),
(321292, 'PTHR31464:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG13660', 241367),
(321293, 'PTHR31464', NULL, NULL, NULL, NULL, 'PROTEIN CBG01266', 241367),
(321294, 'PTHR31464:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG11668', 241367),
(321295, 'PTHR45707:SF50', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241368);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(321296, 'PTHR45707:SF51', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241368),
(321297, 'PTHR45707:SF43', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241368),
(321298, 'PTHR45707:SF53', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241368),
(321299, 'PTHR45707:SF56', NULL, NULL, NULL, NULL, 'OS11G0608700 PROTEIN', 241368),
(321300, 'PTHR45707', NULL, NULL, NULL, NULL, 'C2 CALCIUM/LIPID-BINDING PLANT PHOSPHORIBOSYLTRANSFERASE FAMILY PROTEIN', 241368),
(321301, 'PTHR45707:SF69', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT LIPID-BINDING (CALB DOMAIN) PLANT PHOSPHORIBOSYLTRANSFERASE FAMILY PROTEIN', 241368),
(321302, 'PTHR45707:SF68', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241368),
(321303, 'PTHR45707:SF46', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241368),
(321304, 'PTHR45707:SF59', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241368),
(321305, 'PTHR45707:SF70', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241368),
(321306, 'PTHR13691:SF63', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L2', 241369),
(321307, 'PTHR13691:SF52', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L8-LIKE', 241369),
(321308, 'PTHR13691:SF44', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L2, MITOCHONDRIAL-RELATED', 241369),
(321309, 'PTHR13691:SF66', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L2_C DOMAIN-CONTAINING PROTEIN', 241369),
(321310, 'PTHR13691', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L2', 241369),
(321311, 'PTHR13691:SF54', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L8-LIKE', 241369),
(321312, 'PTHR13691:SF65', NULL, NULL, NULL, NULL, '', 241369),
(321313, 'PTHR13691:SF60', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L2_C DOMAIN-CONTAINING PROTEIN', 241369),
(321314, 'PTHR13691:SF70', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L2_C DOMAIN-CONTAINING PROTEIN', 241369),
(321315, 'PTHR13691:SF40', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L2_C DOMAIN-CONTAINING PROTEIN', 241369),
(321316, 'PTHR13691:SF50', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L2_C DOMAIN-CONTAINING PROTEIN', 241369),
(321317, 'PTHR13691:SF5', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L2, MITOCHONDRIAL', 241369),
(321318, 'PTHR13691:SF49', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L2 DOMAIN-CONTAINING PROTEIN', 241369),
(321319, 'PTHR13691:SF16', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L8', 241369),
(321320, 'PTHR13691:SF68', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL L2 RIBOSOMAL PROTEIN', 241369),
(321321, 'PTHR13691:SF57', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L2, CHLOROPLASTIC', 241369),
(321322, 'PTHR13691:SF67', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L2_C DOMAIN-CONTAINING PROTEIN', 241369),
(321323, 'PTHR13691:SF48', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L8', 241369),
(321324, 'PTHR13691:SF59', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L2, CHLOROPLASTIC', 241369),
(321325, 'PTHR13691:SF69', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L2_C DOMAIN-CONTAINING PROTEIN', 241369),
(321326, 'PTHR34551', NULL, NULL, NULL, NULL, 'GLUTAMATE-RICH 3', 241370),
(321327, 'PTHR34551:SF2', NULL, NULL, NULL, NULL, 'GLUTAMATE-RICH 3', 241370),
(321328, 'PTHR23513:SF6', NULL, NULL, NULL, NULL, 'MULTIDRUG EFFLUX PUMP TAP', 241371),
(321329, 'PTHR23513:SF18', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN-RELATED', 241371),
(321330, 'PTHR23513:SF19', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 241371),
(321331, 'PTHR23513', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE EFFLUX PROTEIN-RELATED', 241371),
(321332, 'PTHR23513:SF9', NULL, NULL, NULL, NULL, 'ENTEROBACTIN EXPORTER ENTS', 241371),
(321333, 'PTHR23513:SF17', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 241371),
(321334, 'PTHR23513:SF11', NULL, NULL, NULL, NULL, 'STAPHYLOFERRIN A TRANSPORTER', 241371),
(321335, 'PTHR31084:SF0', NULL, NULL, NULL, NULL, 'ALPHA-L-FUCOSIDASE 2', 241372),
(321336, 'PTHR31084:SF3', NULL, NULL, NULL, NULL, 'ALPHA-FUCOSIDASE A', 241372),
(321337, 'PTHR31084:SF13', NULL, NULL, NULL, NULL, 'GLYCO_HYD_65N_2 DOMAIN-CONTAINING PROTEIN', 241372);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(321338, 'PTHR31084:SF15', NULL, NULL, NULL, NULL, 'ALPHA-L-FUCOSIDASE 2-LIKE', 241372),
(321339, 'PTHR31084:SF14', NULL, NULL, NULL, NULL, 'SECRETED PROTEIN, PUTATIVE, EXPRESSED-RELATED', 241372),
(321340, 'PTHR31084', NULL, NULL, NULL, NULL, 'ALPHA-L-FUCOSIDASE 2', 241372),
(321341, 'PTHR31084:SF17', NULL, NULL, NULL, NULL, 'GLYCO_HYD_65N_2 DOMAIN-CONTAINING PROTEIN', 241372),
(321342, 'PTHR31084:SF16', NULL, NULL, NULL, NULL, 'ALPHA-FUCOSIDASE A-RELATED', 241372),
(321343, 'PTHR31084:SF18', NULL, NULL, NULL, NULL, 'GLYCO_HYD_65N_2 DOMAIN-CONTAINING PROTEIN', 241372),
(321344, 'PTHR12393:SF6', NULL, NULL, NULL, NULL, 'SPHINGOMYELIN PHOSPHODIESTERASE 2', 241373),
(321345, 'PTHR12393', NULL, NULL, NULL, NULL, 'SPHINGOMYELIN PHOSPHODIESTERASE RELATED', 241373),
(321346, 'PTHR22237:SF3', NULL, NULL, NULL, NULL, 'SI:CH211-244C8.4', 241374),
(321347, 'PTHR22237:SF1', NULL, NULL, NULL, NULL, 'APC MEMBRANE RECRUITMENT PROTEIN 2', 241374),
(321348, 'PTHR22237', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 241374),
(321349, 'PTHR22237:SF2', NULL, NULL, NULL, NULL, 'APC MEMBRANE RECRUITMENT PROTEIN 3', 241374),
(321350, 'PTHR22237:SF0', NULL, NULL, NULL, NULL, 'APC MEMBRANE RECRUITMENT PROTEIN 1', 241374),
(321351, 'PTHR21024:SF0', NULL, NULL, NULL, NULL, 'ELECTRON TRANSFER FLAVOPROTEIN REGULATORY FACTOR 1', 241375),
(321352, 'PTHR21024', NULL, NULL, NULL, NULL, 'GROWTH HORMONE-INDUCIBLE SOLUBLE PROTEIN-RELATED', 241375),
(321353, 'PTHR23321:SF26', NULL, NULL, NULL, NULL, '37S RIBOSOMAL PROTEIN S28, MITOCHONDRIAL', 241376),
(321354, 'PTHR23321', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S15, BACTERIAL AND ORGANELLAR', 241376),
(321355, 'PTHR40065:SF3', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN YHBY', 241377),
(321356, 'PTHR40065', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN YHBY', 241377),
(321357, 'PTHR46407', NULL, NULL, NULL, NULL, 'OS02G0208700 PROTEIN', 241378),
(321358, 'PTHR46407:SF19', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 241378),
(321359, 'PTHR46407:SF17', NULL, NULL, NULL, NULL, 'GALACTOSE OXIDASE/KELCH REPEAT PROTEIN', 241378),
(321360, 'PTHR46407:SF18', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 241378),
(321361, 'PTHR46407:SF4', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 241378),
(321362, 'PTHR46407:SF11', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 241378),
(321363, 'PTHR46407:SF2', NULL, NULL, NULL, NULL, 'OS02G0563000 PROTEIN', 241378),
(321364, 'PTHR46407:SF20', NULL, NULL, NULL, NULL, 'BNAA06G10320D PROTEIN', 241378),
(321365, 'PTHR46407:SF21', NULL, NULL, NULL, NULL, 'F-BOX/KELCH-REPEAT PROTEIN SKIP20', 241378),
(321366, 'PTHR46407:SF10', NULL, NULL, NULL, NULL, 'OS06G0594400 PROTEIN', 241378),
(321367, 'PTHR46407:SF3', NULL, NULL, NULL, NULL, 'OS02G0208700 PROTEIN', 241378),
(321368, 'PTHR46407:SF8', NULL, NULL, NULL, NULL, 'OXIDASE/KELCH REPEAT SUPERFAMILY PROTEIN, PUTATIVE-RELATED', 241378),
(321369, 'PTHR46407:SF16', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 241378),
(321370, 'PTHR46407:SF6', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 241378),
(321371, 'PTHR46407:SF14', NULL, NULL, NULL, NULL, 'BNACNNG64790D PROTEIN', 241378),
(321372, 'PTHR21219', NULL, NULL, NULL, NULL, 'FI19613P1', 241379),
(321373, 'PTHR21219:SF4', NULL, NULL, NULL, NULL, 'PID DOMAIN-CONTAINING PROTEIN', 241379),
(321374, 'PTHR21219:SF3', NULL, NULL, NULL, NULL, 'FI19613P1', 241379),
(321375, 'PTHR37886:SF1', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 241380),
(321376, 'PTHR37886:SF2', NULL, NULL, NULL, NULL, 'BNAC05G46710D PROTEIN', 241380),
(321377, 'PTHR37886', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 241380),
(321378, 'PTHR31284:SF33', NULL, NULL, NULL, NULL, 'STEM 28 KDA GLYCOPROTEIN', 241381),
(321379, 'PTHR31284:SF55', NULL, NULL, NULL, NULL, '', 241381),
(321380, 'PTHR31284:SF9', NULL, NULL, NULL, NULL, 'HAD SUPERFAMILY, SUBFAMILY IIIB ACID PHOSPHATASE', 241381),
(321381, 'PTHR31284:SF32', NULL, NULL, NULL, NULL, 'OS07G0681200 PROTEIN', 241381);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(321382, 'PTHR31284:SF10', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE-LIKE PROTEIN', 241381),
(321383, 'PTHR31284:SF54', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE 1-LIKE', 241381),
(321384, 'PTHR31284:SF31', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE', 241381),
(321385, 'PTHR31284:SF53', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE 1-LIKE', 241381),
(321386, 'PTHR31284:SF7', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE-LIKE PROTEIN', 241381),
(321387, 'PTHR31284:SF36', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE 1-RELATED', 241381),
(321388, 'PTHR31284:SF57', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE 1', 241381),
(321389, 'PTHR31284:SF35', NULL, NULL, NULL, NULL, 'BNAC03G77680D PROTEIN', 241381),
(321390, 'PTHR31284:SF56', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE-LIKE PROTEIN', 241381),
(321391, 'PTHR31284:SF34', NULL, NULL, NULL, NULL, 'BNAC09G17820D PROTEIN', 241381),
(321392, 'PTHR31284:SF19', NULL, NULL, NULL, NULL, 'VEGETATIVE STORAGE PROTEIN 1-RELATED', 241381),
(321393, 'PTHR31284:SF39', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE-LIKE PROTEIN', 241381),
(321394, 'PTHR31284', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE-LIKE PROTEIN', 241381),
(321395, 'PTHR31284:SF22', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE-LIKE PROTEIN', 241381),
(321396, 'PTHR31284:SF21', NULL, NULL, NULL, NULL, 'PLANT ACID PHOSPHATASE', 241381),
(321397, 'PTHR31284:SF43', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE 1-LIKE', 241381),
(321398, 'PTHR31284:SF42', NULL, NULL, NULL, NULL, 'HAD SUPERFAMILY, SUBFAMILY IIIB ACID PHOSPHATASE', 241381),
(321399, 'PTHR31284:SF20', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE 1-LIKE', 241381),
(321400, 'PTHR31284:SF41', NULL, NULL, NULL, NULL, 'BNAA08G13480D PROTEIN', 241381),
(321401, 'PTHR31284:SF48', NULL, NULL, NULL, NULL, 'BNAA08G27690D PROTEIN', 241381),
(321402, 'PTHR31284:SF24', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE 1', 241381),
(321403, 'PTHR31284:SF46', NULL, NULL, NULL, NULL, 'BNAA02G22460D PROTEIN', 241381),
(321404, 'PTHR31284:SF40', NULL, NULL, NULL, NULL, 'BNAA03G17920D PROTEIN', 241381),
(321405, 'PTHR31284:SF28', NULL, NULL, NULL, NULL, 'VEGETATIVE STORAGE PROTEIN 2', 241381),
(321406, 'PTHR31284:SF49', NULL, NULL, NULL, NULL, '', 241381),
(321407, 'PTHR46138:SF1', NULL, NULL, NULL, NULL, 'PROTEIN DR1', 241382),
(321408, 'PTHR46138', NULL, NULL, NULL, NULL, 'PROTEIN DR1', 241382),
(321409, 'PTHR21645:SF21', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 241383),
(321410, 'PTHR21645', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 241383),
(321411, 'PTHR21645:SF22', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 241383),
(321412, 'PTHR21645:SF14', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN-RELATED', 241383),
(321413, 'PTHR21645:SF15', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN F55C10.4', 241383),
(321414, 'PTHR21645:SF12', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 241383),
(321415, 'PTHR21645:SF18', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 241383),
(321416, 'PTHR21645:SF19', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN R07B7.12', 241383),
(321417, 'PTHR21645:SF16', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 241383),
(321418, 'PTHR21645:SF8', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN F13G3.3', 241383),
(321419, 'PTHR21645:SF17', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN-RELATED', 241383),
(321420, 'PTHR21645:SF7', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 241383),
(321421, 'PTHR21645:SF5', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN C35A5.5', 241383),
(321422, 'PTHR21645:SF4', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 241383),
(321423, 'PTHR21645:SF3', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 241383),
(321424, 'PTHR21645:SF2', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN F59C6.8', 241383),
(321425, 'PTHR38614:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG09954', 241384),
(321426, 'PTHR38614:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG03529', 241384);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(321427, 'PTHR38614:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG04040', 241384),
(321428, 'PTHR38614', NULL, NULL, NULL, NULL, 'PROTEIN CBG09954', 241384),
(321429, 'PTHR46395:SF1', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN 1', 241385),
(321430, 'PTHR46395', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN 1', 241385),
(321431, 'PTHR31689:SF0', NULL, NULL, NULL, NULL, 'DIAMINOPIMELATE EPIMERASE', 241386),
(321432, 'PTHR31689', NULL, NULL, NULL, NULL, 'DIAMINOPIMELATE EPIMERASE, CHLOROPLASTIC', 241386),
(321433, 'PTHR31689:SF9', NULL, NULL, NULL, NULL, 'DIAMINOPIMELATE EPIMERASE', 241386),
(321434, 'PTHR31689:SF8', NULL, NULL, NULL, NULL, 'DIAMINOPIMELATE EPIMERASE', 241386),
(321435, 'PTHR31689:SF2', NULL, NULL, NULL, NULL, 'DIAMINOPIMELATE EPIMERASE', 241386),
(321436, 'PTHR47607', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUBFAMILY MEMBER 3', 241387),
(321437, 'PTHR47607:SF1', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 3', 241387),
(321438, 'PTHR38834:SF3', NULL, NULL, NULL, NULL, '1-(5-PHOSPHORIBOSYL)-5-((5-PHOSPHORIBOSYLAMINO)METHYLIDENEAMINO)IMIDAZOLE-4-CARBOXAMIDEISOMERASE', 241388),
(321439, 'PTHR38834', NULL, NULL, NULL, NULL, 'PERIPLASMIC SUBSTRATE BINDING PROTEIN FAMILY 3', 241388),
(321440, 'PTHR21235:SF22', NULL, NULL, NULL, NULL, 'GERANYLGERANYLGLYCERYL PHOSPHATE SYNTHASE', 241389),
(321441, 'PTHR21235', NULL, NULL, NULL, NULL, 'IMIDAZOLE GLYCEROL PHOSPHATE SYNTHASE SUBUNIT HISF/H  IGP SYNTHASE SUBUNIT HISF/H', 241389),
(321442, 'PTHR21235:SF2', NULL, NULL, NULL, NULL, 'IMIDAZOLE GLYCEROL PHOSPHATE SYNTHASE HISHF', 241389),
(321443, 'PTHR46891:SF7', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 241390),
(321444, 'PTHR46891:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG05001', 241390),
(321445, 'PTHR46891:SF5', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 241390),
(321446, 'PTHR46891:SF6', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 241390),
(321447, 'PTHR46891:SF9', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 241390),
(321448, 'PTHR46891', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H-RELATED', 241390),
(321449, 'PTHR46891:SF3', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 241390),
(321450, 'PTHR46891:SF4', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 241390),
(321451, 'PTHR46891:SF1', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 241390),
(321452, 'PTHR46891:SF2', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 241390),
(321453, 'PTHR46891:SF11', NULL, NULL, NULL, NULL, 'PROTEIN CBG04978', 241390),
(321454, 'PTHR46891:SF10', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 241390),
(321455, 'PTHR46891:SF13', NULL, NULL, NULL, NULL, 'PROTEIN CBG04997', 241390),
(321456, 'PTHR46891:SF12', NULL, NULL, NULL, NULL, 'PROTEIN CBG27063', 241390),
(321457, 'PTHR19367:SF11', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 8-6', 241391),
(321458, 'PTHR19367:SF33', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 6-4-RELATED', 241391),
(321459, 'PTHR19367:SF32', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 17', 241391),
(321460, 'PTHR19367:SF21', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 8-2', 241391),
(321461, 'PTHR19367:SF31', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 8-1', 241391),
(321462, 'PTHR19367:SF41', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 241391),
(321463, 'PTHR19367:SF40', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 241391),
(321464, 'PTHR19367:SF5', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 8-3', 241391),
(321465, 'PTHR19367:SF18', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 18', 241391),
(321466, 'PTHR19367:SF17', NULL, NULL, NULL, NULL, 'IGV DOMAIN-CONTAINING PROTEIN', 241391),
(321467, 'PTHR19367:SF39', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR DELTA VARIABLE 3', 241391),
(321468, 'PTHR19367:SF38', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 241391);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(321469, 'PTHR19367:SF37', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 16-RELATED', 241391),
(321470, 'PTHR19367:SF36', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 9-1', 241391),
(321471, 'PTHR19367:SF9', NULL, NULL, NULL, NULL, 'IG DOMAIN-CONTAINING PROTEIN', 241391),
(321472, 'PTHR19367', NULL, NULL, NULL, NULL, 'T-CELL RECEPTOR ALPHA CHAIN V REGION', 241391),
(321473, 'PTHR19367:SF24', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 8-4', 241391),
(321474, 'PTHR19367:SF35', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 40', 241391),
(321475, 'PTHR19367:SF8', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 3', 241391),
(321476, 'PTHR19367:SF34', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 241391),
(321477, 'PTHR36037', NULL, NULL, NULL, NULL, 'RNA-DIRECTED DNA POLYMERASE (REVERSE TRANSCRIPTASE)-RELATED FAMILY PROTEIN', 241392),
(321478, 'PTHR36037:SF1', NULL, NULL, NULL, NULL, 'RNA-DIRECTED DNA POLYMERASE (REVERSE TRANSCRIPTASE)-RELATED FAMILY PROTEIN-RELATED', 241392),
(321479, 'PTHR43483', NULL, NULL, NULL, NULL, 'MEMBRANE TRANSPORTER PROTEIN HI_0806-RELATED', 241393),
(321480, 'PTHR43483:SF3', NULL, NULL, NULL, NULL, 'MEMBRANE TRANSPORTER PROTEIN HI_0806-RELATED', 241393),
(321481, 'PTHR48249:SF6', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 13', 241394),
(321482, 'PTHR48249:SF4', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 13', 241394),
(321483, 'PTHR48249:SF3', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 13', 241394),
(321484, 'PTHR48249:SF1', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 13-LIKE', 241394),
(321485, 'PTHR48249', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 13', 241394),
(321486, 'PTHR12373:SF8', NULL, NULL, NULL, NULL, 'ENHANCER OF RUDIMENTARY HOMOLOG', 241395),
(321487, 'PTHR12373:SF7', NULL, NULL, NULL, NULL, 'ENHANCER OF RUDIMENTARY HOMOLOG', 241395),
(321488, 'PTHR12373:SF9', NULL, NULL, NULL, NULL, 'ENHANCER OF RUDIMENTARY HOMOLOG', 241395),
(321489, 'PTHR12373:SF0', NULL, NULL, NULL, NULL, 'ENHANCER OF RUDIMENTARY HOMOLOG', 241395),
(321490, 'PTHR12373:SF3', NULL, NULL, NULL, NULL, 'ENHANCER OF RUDIMENTARY HOMOLOG 2', 241395),
(321491, 'PTHR12373', NULL, NULL, NULL, NULL, 'ENHANCER OF RUDIMENTARY ERH', 241395),
(321492, 'PTHR12373:SF10', NULL, NULL, NULL, NULL, 'ENHANCER OF RUDIMENTARY-LIKE PROTEIN', 241395),
(321493, 'PTHR38658:SF1', NULL, NULL, NULL, NULL, 'OXPP CYCLE PROTEIN OPCA-RELATED', 241396),
(321494, 'PTHR38658', NULL, NULL, NULL, NULL, 'OXPP CYCLE PROTEIN OPCA-RELATED', 241396),
(321495, 'PTHR30222:SF17', NULL, NULL, NULL, NULL, 'SPERMIDINE/PUTRESCINE-BINDING PERIPLASMIC PROTEIN', 241397),
(321496, 'PTHR30222:SF18', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL POLYHYDROXYBUTYRATE SYNTHASE / ABC TRANSPORTER PERIPLASMIC BINDING PROTEIN-RELATED', 241397),
(321497, 'PTHR30222:SF2', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER SUBSTRATE-BINDING PROTEIN', 241397),
(321498, 'PTHR30222', NULL, NULL, NULL, NULL, 'SPERMIDINE/PUTRESCINE-BINDING PERIPLASMIC PROTEIN', 241397),
(321499, 'PTHR30222:SF12', NULL, NULL, NULL, NULL, 'NORSPERMIDINE SENSOR', 241397),
(321500, 'PTHR43130:SF7', NULL, NULL, NULL, NULL, 'DJ-1_PFPI DOMAIN-CONTAINING PROTEIN', 241398),
(321501, 'PTHR43130:SF13', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR RV1931C', 241398),
(321502, 'PTHR43130:SF11', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 241398),
(321503, 'PTHR43130:SF3', NULL, NULL, NULL, NULL, 'THIJ/PFPI FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_5G14240)', 241398),
(321504, 'PTHR43130:SF2', NULL, NULL, NULL, NULL, 'DJ-1_PFPI DOMAIN-CONTAINING PROTEIN', 241398),
(321505, 'PTHR43130', NULL, NULL, NULL, NULL, 'ARAC-FAMILY TRANSCRIPTIONAL REGULATOR', 241398),
(321506, 'PTHR35262', NULL, NULL, NULL, NULL, 'NHL REPEAT-CONTAINING PROTEIN-RELATED', 241399),
(321507, 'PTHR35262:SF1', NULL, NULL, NULL, NULL, '', 241399),
(321508, 'PTHR35262:SF2', NULL, NULL, NULL, NULL, '', 241399);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(321509, 'PTHR28628', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 88-RELATED', 241400),
(321510, 'PTHR28628:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 88', 241400),
(321511, 'PTHR28628:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 88', 241400),
(321512, 'PTHR28628:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 88B', 241400),
(321513, 'PTHR38044', NULL, NULL, NULL, NULL, 'BOUQUET FORMATION PROTEIN 4', 241401),
(321514, 'PTHR38044:SF1', NULL, NULL, NULL, NULL, 'BOUQUET FORMATION PROTEIN 4', 241401),
(321515, 'PTHR37825:SF1', NULL, NULL, NULL, NULL, 'TRNA(MET) CYTIDINE ACETATE LIGASE', 241402),
(321516, 'PTHR37825', NULL, NULL, NULL, NULL, 'TRNA(MET) CYTIDINE ACETATE LIGASE', 241402),
(321517, 'PTHR45951:SF2', NULL, NULL, NULL, NULL, 'PROTEIN DISPATCHED HOMOLOG 2', 241403),
(321518, 'PTHR45951:SF4', NULL, NULL, NULL, NULL, 'PROTEIN DISPATCHED HOMOLOG 1', 241403),
(321519, 'PTHR45951:SF3', NULL, NULL, NULL, NULL, 'PROTEIN DISPATCHED', 241403),
(321520, 'PTHR45951:SF8', NULL, NULL, NULL, NULL, 'CHE-14 PROTEIN', 241403),
(321521, 'PTHR45951:SF7', NULL, NULL, NULL, NULL, 'DISPATCHED-LIKE PROTEIN', 241403),
(321522, 'PTHR45951', NULL, NULL, NULL, NULL, 'PROTEIN DISPATCHED-RELATED', 241403),
(321523, 'PTHR16742:SF1', NULL, NULL, NULL, NULL, 'CYLICIN-1', 241404),
(321524, 'PTHR16742:SF2', NULL, NULL, NULL, NULL, 'CYLICIN-2', 241404),
(321525, 'PTHR16742', NULL, NULL, NULL, NULL, 'CYCLICIN', 241404),
(321526, 'PTHR35871', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241405),
(321527, 'PTHR35871:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241405),
(321528, 'PTHR43711:SF28', NULL, NULL, NULL, NULL, 'SENSOR PROTEIN CUTS', 241406),
(321529, 'PTHR43711:SF16', NULL, NULL, NULL, NULL, 'SIGNAL TRANSDUCTION HISTIDINE-PROTEIN KINASE BAES', 241406),
(321530, 'PTHR43711', NULL, NULL, NULL, NULL, 'TWO-COMPONENT HISTIDINE KINASE', 241406),
(321531, 'PTHR43711:SF18', NULL, NULL, NULL, NULL, '', 241406),
(321532, 'PTHR43711:SF29', NULL, NULL, NULL, NULL, 'HYBRID SENSORY KINASE', 241406),
(321533, 'PTHR43711:SF1', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE 1', 241406),
(321534, 'PTHR43711:SF30', NULL, NULL, NULL, NULL, 'SENSORY TRANSDUCTION HISTIDINE KINASE', 241406),
(321535, 'PTHR43711:SF13', NULL, NULL, NULL, NULL, 'DRUG SENSORY PROTEIN A', 241406),
(321536, 'PTHR43711:SF24', NULL, NULL, NULL, NULL, 'SENSOR HISTIDINE KINASE RPPB', 241406),
(321537, 'PTHR43711:SF26', NULL, NULL, NULL, NULL, 'SENSOR HISTIDINE KINASE RCSC', 241406),
(321538, 'PTHR43711:SF15', NULL, NULL, NULL, NULL, 'OSMOSENSOR HISTIDINE KINASE', 241406),
(321539, 'PTHR31932', NULL, NULL, NULL, NULL, 'TUBULIN POLYGLUTAMYLASE COMPLEX SUBUNIT 1', 241407),
(321540, 'PTHR31932:SF2', NULL, NULL, NULL, NULL, 'TUBULIN POLYGLUTAMYLASE COMPLEX SUBUNIT 1', 241407),
(321541, 'PTHR11668:SF10', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321542, 'PTHR11668:SF472', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP1-ALPHA CATALYTIC SUBUNIT-RELATED', 241408),
(321543, 'PTHR11668:SF231', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321544, 'PTHR11668:SF396', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321545, 'PTHR11668:SF199', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321546, 'PTHR11668:SF398', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321547, 'PTHR11668:SF194', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE-RELATED', 241408),
(321548, 'PTHR11668:SF470', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321549, 'PTHR11668:SF437', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321550, 'PTHR11668:SF438', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321551, 'PTHR11668:SF432', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP1 ISOZYME 8', 241408),
(321552, 'PTHR11668:SF311', NULL, NULL, NULL, NULL, 'SER_THR_PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 241408),
(321553, 'PTHR11668:SF477', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(321554, 'PTHR11668:SF236', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321555, 'PTHR11668:SF461', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321556, 'PTHR11668:SF385', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321557, 'PTHR11668:SF463', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321558, 'PTHR11668:SF464', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP1 ISOZYME 5', 241408),
(321559, 'PTHR11668:SF460', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321560, 'PTHR11668:SF502', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321561, 'PTHR11668:SF469', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321562, 'PTHR11668:SF425', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321563, 'PTHR11668:SF503', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321564, 'PTHR11668:SF426', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321565, 'PTHR11668:SF427', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP1 ISOZYME 1', 241408),
(321566, 'PTHR11668:SF504', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP1 ISOZYME 6', 241408),
(321567, 'PTHR11668:SF505', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321568, 'PTHR11668:SF300', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321569, 'PTHR11668:SF422', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321570, 'PTHR11668:SF466', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321571, 'PTHR11668:SF423', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PPQ', 241408),
(321572, 'PTHR11668:SF467', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321573, 'PTHR11668:SF500', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP1 ISOZYME 7', 241408),
(321574, 'PTHR11668:SF501', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321575, 'PTHR11668', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE', 241408),
(321576, 'PTHR11668:SF429', NULL, NULL, NULL, NULL, 'SER_THR_PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 241408),
(321577, 'PTHR11668:SF506', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321578, 'PTHR11668:SF507', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321579, 'PTHR11668:SF290', NULL, NULL, NULL, NULL, 'SER_THR_PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 241408),
(321580, 'PTHR11668:SF494', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE, PUTATIVE-RELATED', 241408),
(321581, 'PTHR11668:SF450', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321582, 'PTHR11668:SF495', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP1', 241408),
(321583, 'PTHR11668:SF496', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321584, 'PTHR11668:SF299', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321585, 'PTHR11668:SF211', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE C23G10.1', 241408),
(321586, 'PTHR11668:SF453', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321587, 'PTHR11668:SF497', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP1-BETA CATALYTIC SUBUNIT', 241408),
(321588, 'PTHR11668:SF490', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP1 ISOZYME 4', 241408),
(321589, 'PTHR11668:SF491', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321590, 'PTHR11668:SF492', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP1-DELTA-RELATED', 241408),
(321591, 'PTHR11668:SF493', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE, PUTATIVE-RELATED', 241408),
(321592, 'PTHR11668:SF458', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(321593, 'PTHR11668:SF459', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP1 ISOZYME 1', 241408),
(321594, 'PTHR11668:SF416', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321595, 'PTHR11668:SF498', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321596, 'PTHR11668:SF454', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321597, 'PTHR11668:SF377', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP1-ALPHA CATALYTIC SUBUNIT', 241408),
(321598, 'PTHR11668:SF499', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321599, 'PTHR11668:SF456', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321600, 'PTHR11668:SF285', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE-RELATED', 241408),
(321601, 'PTHR11668:SF484', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP-Z1-RELATED', 241408),
(321602, 'PTHR11668:SF485', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321603, 'PTHR11668:SF441', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP1 ISOZYME 2', 241408),
(321604, 'PTHR11668:SF442', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP1 ISOZYME 3', 241408),
(321605, 'PTHR11668:SF480', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321606, 'PTHR11668:SF481', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321607, 'PTHR11668:SF448', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321608, 'PTHR11668:SF449', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321609, 'PTHR11668:SF488', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321610, 'PTHR11668:SF246', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321611, 'PTHR11668:SF445', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321612, 'PTHR11668:SF489', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321613, 'PTHR11668:SF204', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP1-GAMMA CATALYTIC SUBUNIT', 241408),
(321614, 'PTHR11668:SF5', NULL, NULL, NULL, NULL, 'SER_THR_PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 241408),
(321615, 'PTHR11668:SF409', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 241408),
(321616, 'PTHR11668:SF4', NULL, NULL, NULL, NULL, 'SER_THR_PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 241408),
(321617, 'PTHR23211:SF0', NULL, NULL, NULL, NULL, 'TRANS-GOLGI NETWORK INTEGRAL MEMBRANE PROTEIN 2', 241409),
(321618, 'PTHR23211', NULL, NULL, NULL, NULL, 'TRANS-GOLGI NETWORK INTEGRAL MEMBRANE PROTEIN TGN38', 241409),
(321619, 'PTHR42860', NULL, NULL, NULL, NULL, 'VITAMIN B12-BINDING PROTEIN', 241410),
(321620, 'PTHR42860:SF1', NULL, NULL, NULL, NULL, 'VITAMIN B12-BINDING PROTEIN', 241410),
(321621, 'PTHR42860:SF2', NULL, NULL, NULL, NULL, 'SUBSTRATE BINDING PROTEIN OF AN ABC TRANSPORTER COMPLEX', 241410),
(321622, 'PTHR42860:SF3', NULL, NULL, NULL, NULL, 'FE/B12 PERIPLASMIC-BINDING DOMAIN-CONTAINING PROTEIN', 241410),
(321623, 'PTHR28207', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT H, MITOCHONDRIAL', 241411),
(321624, 'PTHR28207:SF1', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT H, MITOCHONDRIAL', 241411),
(321625, 'PTHR10846:SF2', NULL, NULL, NULL, NULL, 'RE48874P', 241412),
(321626, 'PTHR10846:SF28', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 24 MEMBER 6A', 241412),
(321627, 'PTHR10846:SF8', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YRBG', 241412),
(321628, 'PTHR10846:SF68', NULL, NULL, NULL, NULL, '', 241412),
(321629, 'PTHR10846:SF69', NULL, NULL, NULL, NULL, 'NA_CA_EX DOMAIN-CONTAINING PROTEIN', 241412),
(321630, 'PTHR10846:SF36', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM/CALCIUM EXCHANGER 1', 241412),
(321631, 'PTHR10846', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM/CALCIUM EXCHANGER', 241412),
(321632, 'PTHR10846:SF41', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM/CALCIUM EXCHANGER 2', 241412);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(321633, 'PTHR10846:SF42', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM/CALCIUM EXCHANGER 3', 241412),
(321634, 'PTHR10846:SF65', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 24 MEMBER 2', 241412),
(321635, 'PTHR10846:SF21', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM/CALCIUM EXCHANGER 4', 241412),
(321636, 'PTHR10846:SF70', NULL, NULL, NULL, NULL, 'ZYDECO, ISOFORM F', 241412),
(321637, 'PTHR10846:SF72', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM/CALCIUM EXCHANGER NCKX30C', 241412),
(321638, 'PTHR10846:SF61', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM/CALCIUM EXCHANGER 5', 241412),
(321639, 'PTHR33354:SF9', NULL, NULL, NULL, NULL, 'JACALIN-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 241413),
(321640, 'PTHR33354', NULL, NULL, NULL, NULL, 'ENDONUCLEASE/EXONUCLEASE/PHOSPHATASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_1G01540)', 241413),
(321641, 'PTHR43148:SF13', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE GAPA1, CHLOROPLASTIC', 241414),
(321642, 'PTHR43148', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE 2', 241414),
(321643, 'PTHR43148:SF12', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE', 241414),
(321644, 'PTHR43148:SF11', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE 1', 241414),
(321645, 'PTHR43148:SF10', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE', 241414),
(321646, 'PTHR43148:SF6', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE', 241414),
(321647, 'PTHR43148:SF5', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE GAPB, CHLOROPLASTIC', 241414),
(321648, 'PTHR43148:SF2', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE', 241414),
(321649, 'PTHR43148:SF3', NULL, NULL, NULL, NULL, 'D-ERYTHROSE-4-PHOSPHATE DEHYDROGENASE', 241414),
(321650, 'PTHR43148:SF18', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE GAPA2, CHLOROPLASTIC', 241414),
(321651, 'PTHR43148:SF17', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE', 241414),
(321652, 'PTHR43148:SF14', NULL, NULL, NULL, NULL, 'GP_DH_N DOMAIN-CONTAINING PROTEIN', 241414),
(321653, 'PTHR38140:SF7', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 19-7', 241415),
(321654, 'PTHR38140:SF8', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 19-6', 241415),
(321655, 'PTHR38140:SF5', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 19-3-RELATED', 241415),
(321656, 'PTHR38140:SF6', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 19-1', 241415),
(321657, 'PTHR38140', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 19-3-RELATED', 241415),
(321658, 'PTHR38140:SF3', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 19-8', 241415),
(321659, 'PTHR38140:SF4', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 19-5', 241415),
(321660, 'PTHR37077', NULL, NULL, NULL, NULL, '', 241416),
(321661, 'PTHR37077:SF3', NULL, NULL, NULL, NULL, '', 241416),
(321662, 'PTHR37077:SF2', NULL, NULL, NULL, NULL, '', 241416),
(321663, 'PTHR37077:SF1', NULL, NULL, NULL, NULL, '', 241416),
(321664, 'PTHR46472', NULL, NULL, NULL, NULL, 'NUCLEOREDOXIN', 241417),
(321665, 'PTHR46472:SF1', NULL, NULL, NULL, NULL, 'NUCLEOREDOXIN', 241417),
(321666, 'PTHR46328', NULL, NULL, NULL, NULL, 'FAR-RED IMPAIRED RESPONSIVE (FAR1) FAMILY PROTEIN-RELATED', 241418),
(321667, 'PTHR46328:SF28', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE 5-LIKE', 241418),
(321668, 'PTHR46328:SF29', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 241418),
(321669, 'PTHR46328:SF26', NULL, NULL, NULL, NULL, 'FAR1 DNA-BINDING DOMAIN PROTEIN', 241418),
(321670, 'PTHR46328:SF27', NULL, NULL, NULL, NULL, 'OS12G0287500 PROTEIN', 241418),
(321671, 'PTHR46328:SF24', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE 2-LIKE ISOFORM X1', 241418),
(321672, 'PTHR46328:SF23', NULL, NULL, NULL, NULL, 'FAR1 DOMAIN-CONTAINING PROTEIN', 241418),
(321673, 'PTHR46328:SF7', NULL, NULL, NULL, NULL, 'FAR-RED IMPAIRED RESPONSIVE (FAR1) FAMILY PROTEIN', 241418),
(321674, 'PTHR46328:SF6', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE 5-LIKE', 241418);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(321675, 'PTHR46328:SF5', NULL, NULL, NULL, NULL, 'FAR1 DNA-BINDING DOMAIN PROTEIN', 241418),
(321676, 'PTHR46328:SF9', NULL, NULL, NULL, NULL, 'FAR-RED IMPAIRED RESPONSIVE (FAR1) FAMILY PROTEIN', 241418),
(321677, 'PTHR46328:SF8', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE 2-LIKE', 241418),
(321678, 'PTHR46328:SF17', NULL, NULL, NULL, NULL, 'FAR-RED IMPAIRED RESPONSIVE (FAR1) FAMILY PROTEIN', 241418),
(321679, 'PTHR46328:SF15', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE 5-LIKE', 241418),
(321680, 'PTHR46328:SF2', NULL, NULL, NULL, NULL, 'FAR1 DOMAIN-CONTAINING PROTEIN', 241418),
(321681, 'PTHR46328:SF19', NULL, NULL, NULL, NULL, 'FAR1 DOMAIN-CONTAINING PROTEIN', 241418),
(321682, 'PTHR46328:SF31', NULL, NULL, NULL, NULL, 'FAR1 DOMAIN-CONTAINING PROTEIN', 241418),
(321683, 'PTHR46328:SF32', NULL, NULL, NULL, NULL, 'FAR1 DNA-BINDING DOMAIN PROTEIN', 241418),
(321684, 'PTHR46328:SF10', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE 12-LIKE ISOFORM X1', 241418),
(321685, 'PTHR46328:SF30', NULL, NULL, NULL, NULL, 'FAR-RED IMPAIRED RESPONSIVE (FAR1) FAMILY PROTEIN', 241418),
(321686, 'PTHR46328:SF35', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 241418),
(321687, 'PTHR46328:SF14', NULL, NULL, NULL, NULL, 'FAR-RED IMPAIRED RESPONSIVE (FAR1) FAMILY PROTEIN', 241418),
(321688, 'PTHR46328:SF36', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 241418),
(321689, 'PTHR46328:SF33', NULL, NULL, NULL, NULL, 'FAR1 DNA-BINDING DOMAIN PROTEIN', 241418),
(321690, 'PTHR46328:SF34', NULL, NULL, NULL, NULL, 'FAR1 DNA-BINDING DOMAIN PROTEIN', 241418),
(321691, 'PTHR47410:SF4', NULL, NULL, NULL, NULL, 'TOLL-LIKE RECEPTOR 9', 241419),
(321692, 'PTHR47410:SF3', NULL, NULL, NULL, NULL, 'TOLL-LIKE RECEPTOR 9', 241419),
(321693, 'PTHR47410', NULL, NULL, NULL, NULL, 'TOLL-LIKE RECEPTOR 7-RELATED', 241419),
(321694, 'PTHR47410:SF2', NULL, NULL, NULL, NULL, 'TOLL-LIKE RECEPTOR 7', 241419),
(321695, 'PTHR47410:SF1', NULL, NULL, NULL, NULL, 'TOLL-LIKE RECEPTOR 8', 241419),
(321696, 'PTHR21681', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT J', 241420),
(321697, 'PTHR21681:SF1', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT J', 241420),
(321698, 'PTHR21681:SF2', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT J', 241420),
(321699, 'PTHR21681:SF0', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT J', 241420),
(321700, 'PTHR13088:SF2', NULL, NULL, NULL, NULL, 'FAS APOPTOTIC INHIBITORY MOLECULE-LIKE', 241421),
(321701, 'PTHR13088:SF4', NULL, NULL, NULL, NULL, 'FAS APOPTOTIC INHIBITORY MOLECULE 1', 241421),
(321702, 'PTHR13088:SF3', NULL, NULL, NULL, NULL, 'FAS APOPTOTIC INHIBITORY MOLECULE 1', 241421),
(321703, 'PTHR13088', NULL, NULL, NULL, NULL, 'FAS APOPTOTIC INHIBITORY MOLECULE FAIM', 241421),
(321704, 'PTHR37368', NULL, NULL, NULL, NULL, 'TSSK6-ACTIVATING CO-CHAPERONE PROTEIN', 241422),
(321705, 'PTHR37368:SF1', NULL, NULL, NULL, NULL, 'TSSK6-ACTIVATING CO-CHAPERONE PROTEIN', 241422),
(321706, 'PTHR37188', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT-RELATED', 241423),
(321707, 'PTHR37188:SF1', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT-RELATED', 241423),
(321708, 'PTHR37188:SF3', NULL, NULL, NULL, NULL, 'BNAA07G07820D PROTEIN', 241423),
(321709, 'PTHR37188:SF2', NULL, NULL, NULL, NULL, 'BNAA05G13940D PROTEIN', 241423),
(321710, 'PTHR23206:SF7', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND KH DOMAIN-CONTAINING 1', 241424),
(321711, 'PTHR23206:SF6', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SAM DOMAIN-CONTAINING PROTEIN 6', 241424),
(321712, 'PTHR23206:SF5', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND KH DOMAIN-CONTAINING PROTEIN 1', 241424),
(321713, 'PTHR23206', NULL, NULL, NULL, NULL, 'MASK PROTEIN', 241424),
(321714, 'PTHR23206:SF1', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 17', 241424),
(321715, 'PTHR31531:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE E3D', 241425);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(321716, 'PTHR31531', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE E3D FAMILY MEMBER', 241425),
(321717, 'PTHR40029:SF2', NULL, NULL, NULL, NULL, 'HEPTAPRENYLGLYCERYL PHOSPHATE SYNTHASE', 241426),
(321718, 'PTHR40029', NULL, NULL, NULL, NULL, '', 241426),
(321719, 'PTHR34724', NULL, NULL, NULL, NULL, 'OS12G0596101 PROTEIN', 241427),
(321720, 'PTHR34724:SF4', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241427),
(321721, 'PTHR34724:SF2', NULL, NULL, NULL, NULL, 'OS12G0596101 PROTEIN', 241427),
(321722, 'PTHR37456:SF3', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(XXV) CHAIN', 241428),
(321723, 'PTHR37456', NULL, NULL, NULL, NULL, 'SI:CH211-266K2.1', 241428),
(321724, 'PTHR43337:SF1', NULL, NULL, NULL, NULL, 'XANTHINE/URACIL PERMEASE C887.17-RELATED', 241429),
(321725, 'PTHR43337:SF2', NULL, NULL, NULL, NULL, 'XANTHINE/URACIL PERMEASE-RELATED', 241429),
(321726, 'PTHR43337', NULL, NULL, NULL, NULL, 'XANTHINE/URACIL PERMEASE C887.17-RELATED', 241429),
(321727, 'PTHR43337:SF18', NULL, NULL, NULL, NULL, 'ADENINE/GUANINE PERMEASE AZG1-LIKE', 241429),
(321728, 'PTHR43337:SF16', NULL, NULL, NULL, NULL, 'AZA-GUANINE RESISTANT1-RELATED', 241429),
(321729, 'PTHR43337:SF17', NULL, NULL, NULL, NULL, 'XANTHINE URACIL VITAMIN C PERMEASE', 241429),
(321730, 'PTHR43337:SF13', NULL, NULL, NULL, NULL, 'ADENINE/GUANINE PERMEASE AZG2', 241429),
(321731, 'PTHR43337:SF5', NULL, NULL, NULL, NULL, 'GUANINE/HYPOXANTHINE PERMEASE GHXP', 241429),
(321732, 'PTHR43337:SF11', NULL, NULL, NULL, NULL, 'GUANINE/HYPOXANTHINE PERMEASE PBUG', 241429),
(321733, 'PTHR43337:SF3', NULL, NULL, NULL, NULL, 'PURINE TRANSPORTER', 241429),
(321734, 'PTHR43337:SF4', NULL, NULL, NULL, NULL, 'GUANINE/HYPOXANTHINE PERMEASE GHXQ', 241429),
(321735, 'PTHR13063', NULL, NULL, NULL, NULL, 'ENOS INTERACTING PROTEIN', 241430),
(321736, 'PTHR13063:SF10', NULL, NULL, NULL, NULL, 'NITRIC OXIDE SYNTHASE-INTERACTING PROTEIN', 241430),
(321737, 'PTHR35970:SF1', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL AND CLATHRIN LINKER 1', 241431),
(321738, 'PTHR35970', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL AND CLATHRIN LINKER 1', 241431),
(321739, 'PTHR47193', NULL, NULL, NULL, NULL, 'CATION CHANNEL SPERM-ASSOCIATED PROTEIN 1', 241432),
(321740, 'PTHR47193:SF1', NULL, NULL, NULL, NULL, 'CATION CHANNEL SPERM-ASSOCIATED PROTEIN 1', 241432),
(321741, 'PTHR13018:SF127', NULL, NULL, NULL, NULL, 'BNAA08G05680D PROTEIN', 241433),
(321742, 'PTHR13018:SF128', NULL, NULL, NULL, NULL, 'CALCIUM PERMEABLE STRESS-GATED CATION CHANNEL 1', 241433),
(321743, 'PTHR13018:SF38', NULL, NULL, NULL, NULL, 'CSC1-LIKE PROTEIN 2', 241433),
(321744, 'PTHR13018:SF36', NULL, NULL, NULL, NULL, '', 241433),
(321745, 'PTHR13018:SF125', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT CHANNEL, 7TM REGION, PUTATIVE PHOSPHATE-RELATED', 241433),
(321746, 'PTHR13018:SF80', NULL, NULL, NULL, NULL, '', 241433),
(321747, 'PTHR13018:SF126', NULL, NULL, NULL, NULL, 'BNAC04G18540D PROTEIN', 241433),
(321748, 'PTHR13018:SF123', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT CHANNEL, 7TM REGION, PUTATIVE PHOSPHATE-RELATED', 241433),
(321749, 'PTHR13018', NULL, NULL, NULL, NULL, 'PROBABLE MEMBRANE PROTEIN DUF221-RELATED', 241433),
(321750, 'PTHR13018:SF124', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT CHANNEL, 7TM REGION, PUTATIVE PHOSPHATE-RELATED', 241433),
(321751, 'PTHR13018:SF122', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 241433),
(321752, 'PTHR13018:SF20', NULL, NULL, NULL, NULL, 'SPORULATION-SPECIFIC PROTEIN 75', 241433),
(321753, 'PTHR13018:SF21', NULL, NULL, NULL, NULL, 'CALCIUM PERMEABLE STRESS-GATED CATION CHANNEL 1', 241433),
(321754, 'PTHR13018:SF119', NULL, NULL, NULL, NULL, 'BNAA03G60360D PROTEIN', 241433),
(321755, 'PTHR13018:SF116', NULL, NULL, NULL, NULL, 'EARLY-RESPONSIVE TO DEHYDRATION PROTEIN', 241433),
(321756, 'PTHR13018:SF117', NULL, NULL, NULL, NULL, 'CSC1-LIKE PROTEIN RXW8', 241433),
(321757, 'PTHR13018:SF26', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G10920)-RELATED', 241433),
(321758, 'PTHR13018:SF24', NULL, NULL, NULL, NULL, 'CSC1-LIKE PROTEIN 1', 241433);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(321759, 'PTHR13018:SF114', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241433),
(321760, 'PTHR13018:SF115', NULL, NULL, NULL, NULL, 'BNAC09G13620D PROTEIN', 241433),
(321761, 'PTHR13018:SF113', NULL, NULL, NULL, NULL, '', 241433),
(321762, 'PTHR13018:SF110', NULL, NULL, NULL, NULL, 'BNAA08G25990D PROTEIN', 241433),
(321763, 'PTHR13018:SF111', NULL, NULL, NULL, NULL, 'CALCIUM PERMEABLE STRESS-GATED CATION CHANNEL 1', 241433),
(321764, 'PTHR13018:SF99', NULL, NULL, NULL, NULL, 'TO DEHYDRATION PROTEIN, PUTATIVE, EXPRESSED-RELATED', 241433),
(321765, 'PTHR13018:SF53', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE-RELATED', 241433),
(321766, 'PTHR13018:SF109', NULL, NULL, NULL, NULL, 'CSC1-LIKE PROTEIN HYP1', 241433),
(321767, 'PTHR13018:SF98', NULL, NULL, NULL, NULL, 'TO DEHYDRATION PROTEIN, PUTATIVE, EXPRESSED-RELATED', 241433),
(321768, 'PTHR13018:SF108', NULL, NULL, NULL, NULL, 'PROTEIN OSCA1', 241433),
(321769, 'PTHR13018:SF96', NULL, NULL, NULL, NULL, 'OS05G0393800 PROTEIN', 241433),
(321770, 'PTHR13018:SF93', NULL, NULL, NULL, NULL, 'PROTEIN OSCA1', 241433),
(321771, 'PTHR13018:SF105', NULL, NULL, NULL, NULL, 'BNAC05G09770D PROTEIN', 241433),
(321772, 'PTHR13018:SF140', NULL, NULL, NULL, NULL, '', 241433),
(321773, 'PTHR13018:SF103', NULL, NULL, NULL, NULL, 'BNAA01G18580D PROTEIN', 241433),
(321774, 'PTHR13018:SF104', NULL, NULL, NULL, NULL, 'BNAC06G30620D PROTEIN', 241433),
(321775, 'PTHR13018:SF145', NULL, NULL, NULL, NULL, 'CSC1-LIKE PROTEIN RXW8', 241433),
(321776, 'PTHR13018:SF101', NULL, NULL, NULL, NULL, 'ERD (EARLY-RESPONSIVE TO DEHYDRATION STRESS) FAMILY PROTEIN', 241433),
(321777, 'PTHR13018:SF102', NULL, NULL, NULL, NULL, 'ERD (EARLY-RESPONSIVE TO DEHYDRATION STRESS) FAMILY PROTEIN', 241433),
(321778, 'PTHR13018:SF143', NULL, NULL, NULL, NULL, '', 241433),
(321779, 'PTHR13018:SF144', NULL, NULL, NULL, NULL, 'RSN1_7TM DOMAIN-CONTAINING PROTEIN', 241433),
(321780, 'PTHR13018:SF100', NULL, NULL, NULL, NULL, 'CSC1-LIKE PROTEIN ERD4', 241433),
(321781, 'PTHR13018:SF141', NULL, NULL, NULL, NULL, 'OS01G0950900 PROTEIN', 241433),
(321782, 'PTHR13018:SF142', NULL, NULL, NULL, NULL, 'CALCIUM PERMEABLE STRESS-GATED CATION CHANNEL 1', 241433),
(321783, 'PTHR13018:SF138', NULL, NULL, NULL, NULL, '', 241433),
(321784, 'PTHR13018:SF83', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 241433),
(321785, 'PTHR13018:SF139', NULL, NULL, NULL, NULL, 'PHOSPHATE METABOLISM PROTEIN 7', 241433),
(321786, 'PTHR13018:SF5', NULL, NULL, NULL, NULL, 'RE44586P', 241433),
(321787, 'PTHR13018:SF48', NULL, NULL, NULL, NULL, 'OS05G0594700 PROTEIN', 241433),
(321788, 'PTHR13018:SF90', NULL, NULL, NULL, NULL, '', 241433),
(321789, 'PTHR13018:SF135', NULL, NULL, NULL, NULL, 'RSN1_7TM DOMAIN-CONTAINING PROTEIN', 241433),
(321790, 'PTHR13018:SF132', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT CHANNEL, 7TM REGION, PUTATIVE PHOSPHATE-RELATED', 241433),
(321791, 'PTHR11941:SF27', NULL, NULL, NULL, NULL, 'ETHYLMALONYL-COA DECARBOXYLASE', 241434),
(321792, 'PTHR11941:SF150', NULL, NULL, NULL, NULL, 'RACEMASE, PUTATIVE-RELATED', 241434),
(321793, 'PTHR11941:SF171', NULL, NULL, NULL, NULL, '3-HYDROXYBUTYRYL-COA DEHYDRATASE-LIKE PROTEIN, MITOCHONDRIAL', 241434),
(321794, 'PTHR11941:SF170', NULL, NULL, NULL, NULL, 'FI23914P1', 241434),
(321795, 'PTHR11941:SF84', NULL, NULL, NULL, NULL, 'ENOYL-COA DELTA ISOMERASE 1, PEROXISOMAL', 241434),
(321796, 'PTHR11941:SF153', NULL, NULL, NULL, NULL, 'ENOYL-COA DELTA ISOMERASE 2, PEROXISOMAL-LIKE', 241434),
(321797, 'PTHR11941:SF152', NULL, NULL, NULL, NULL, 'ENOYL-COA HYDRATASE/ISOMERASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_3G03410)', 241434),
(321798, 'PTHR11941:SF130', NULL, NULL, NULL, NULL, 'ENOYL-COA HYDRATASE ECHA12-RELATED', 241434),
(321799, 'PTHR11941:SF158', NULL, NULL, NULL, NULL, 'ENOYL-COA HYDRATASE (AFU_ORTHOLOGUE AFUA_2G10650)', 241434),
(321800, 'PTHR11941:SF44', NULL, NULL, NULL, NULL, 'ENOYL-COA HYDRATASE DOMAIN-CONTAINING PROTEIN 2, MITOCHONDRIAL', 241434),
(321801, 'PTHR11941:SF22', NULL, NULL, NULL, NULL, '', 241434),
(321802, 'PTHR11941:SF156', NULL, NULL, NULL, NULL, 'ISOMERASE, MITOCHONDRIAL, PUTATIVE-RELATED', 241434);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(321803, 'PTHR11941:SF68', NULL, NULL, NULL, NULL, 'ENOYL-COA HYDRATASE', 241434),
(321804, 'PTHR11941:SF133', NULL, NULL, NULL, NULL, '1,2-EPOXYPHENYLACETYL-COA ISOMERASE', 241434),
(321805, 'PTHR11941:SF45', NULL, NULL, NULL, NULL, 'ENOYL-COA DELTA ISOMERASE 1, MITOCHONDRIAL', 241434),
(321806, 'PTHR11941:SF143', NULL, NULL, NULL, NULL, 'CARNITINE RACEMASE LIKE PROTEIN', 241434),
(321807, 'PTHR11941:SF165', NULL, NULL, NULL, NULL, 'CARNITINYL-COA DEHYDRATASE', 241434),
(321808, 'PTHR11941:SF142', NULL, NULL, NULL, NULL, '', 241434),
(321809, 'PTHR11941:SF164', NULL, NULL, NULL, NULL, 'ENOYL-COA DELTA ISOMERASE 1, PEROXISOMAL-LIKE', 241434),
(321810, 'PTHR11941:SF75', NULL, NULL, NULL, NULL, 'ENOYL-COA DELTA ISOMERASE 2, PEROXISOMAL', 241434),
(321811, 'PTHR11941:SF163', NULL, NULL, NULL, NULL, 'SD19268P', 241434),
(321812, 'PTHR11941:SF141', NULL, NULL, NULL, NULL, 'ENOYL-COA HYDRATASE/ISOMERASE-RELATED', 241434),
(321813, 'PTHR11941:SF31', NULL, NULL, NULL, NULL, 'ENOYL-COA HYDRATASE', 241434),
(321814, 'PTHR11941:SF169', NULL, NULL, NULL, NULL, '(7AS)-7A-METHYL-1,5-DIOXO-2,3,5,6,7,7A-HEXAHYDRO-1H-INDENE-CARBOXYL-COA HYDROLASE', 241434),
(321815, 'PTHR11941:SF147', NULL, NULL, NULL, NULL, 'OS01G0205600 PROTEIN', 241434),
(321816, 'PTHR11941:SF168', NULL, NULL, NULL, NULL, '', 241434),
(321817, 'PTHR11941:SF124', NULL, NULL, NULL, NULL, 'ENOYL-COA HYDRATASE ECHA13-RELATED', 241434),
(321818, 'PTHR11941:SF54', NULL, NULL, NULL, NULL, 'ENOYL-COA HYDRATASE, MITOCHONDRIAL', 241434),
(321819, 'PTHR11941:SF146', NULL, NULL, NULL, NULL, 'ENOYL-COA DELTA ISOMERASE 2, PEROXISOMAL-LIKE', 241434),
(321820, 'PTHR11941:SF167', NULL, NULL, NULL, NULL, 'ENOYL-COA HYDRATASE/ISOMERASE YNGF-RELATED', 241434),
(321821, 'PTHR11941:SF12', NULL, NULL, NULL, NULL, 'METHYLGLUTACONYL-COA HYDRATASE, MITOCHONDRIAL', 241434),
(321822, 'PTHR11941:SF144', NULL, NULL, NULL, NULL, 'ENOYL-COA DELTA ISOMERASE 3', 241434),
(321823, 'PTHR11941:SF100', NULL, NULL, NULL, NULL, '', 241434),
(321824, 'PTHR11941:SF166', NULL, NULL, NULL, NULL, 'ENOYL-COA HYDRATASE/ISOMERASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_8G01210)', 241434),
(321825, 'PTHR11941:SF129', NULL, NULL, NULL, NULL, 'OS02G0654000 PROTEIN', 241434),
(321826, 'PTHR11941:SF149', NULL, NULL, NULL, NULL, 'BNAA09G02820D PROTEIN', 241434),
(321827, 'PTHR11941:SF127', NULL, NULL, NULL, NULL, 'ENOYL-COA HYDRATASE ECHA18 (ENOYL HYDRASE) (UNSATURATED ACYL-COA HYDRATASE) (CROTONASE)-RELATED', 241434),
(321828, 'PTHR11941', NULL, NULL, NULL, NULL, 'ENOYL-COA HYDRATASE-RELATED', 241434),
(321829, 'PTHR10434:SF2', NULL, NULL, NULL, NULL, '1-ACYL-SN-GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE BETA', 241435),
(321830, 'PTHR10434:SF60', NULL, NULL, NULL, NULL, '1-ACYL-SN-GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE LPAT1, CHLOROPLASTIC', 241435),
(321831, 'PTHR10434:SF57', NULL, NULL, NULL, NULL, '1-ACYLGLYCEROL-3-PHOSPHATE O-ACYLTRANSFERASE', 241435),
(321832, 'PTHR10434:SF11', NULL, NULL, NULL, NULL, '1-ACYL-SN-GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE ALPHA', 241435),
(321833, 'PTHR10434:SF55', NULL, NULL, NULL, NULL, 'POSSIBLE ACYLTRANSFERASE', 241435),
(321834, 'PTHR10434:SF10', NULL, NULL, NULL, NULL, '1-ACYL-SN-GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE ACL-1-RELATED', 241435),
(321835, 'PTHR10434:SF53', NULL, NULL, NULL, NULL, '1-ACYL-SN-GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE', 241435),
(321836, 'PTHR10434', NULL, NULL, NULL, NULL, '1-ACYL-SN-GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE', 241435),
(321837, 'PTHR10434:SF63', NULL, NULL, NULL, NULL, '1-ACYL-SN-GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE', 241435),
(321838, 'PTHR10434:SF62', NULL, NULL, NULL, NULL, '1-ACYL-SN-GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE', 241435),
(321839, 'PTHR10434:SF40', NULL, NULL, NULL, NULL, '1-ACYL-SN-GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE', 241435),
(321840, 'PTHR10434:SF61', NULL, NULL, NULL, NULL, '1-ACYL-SN-GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE', 241435),
(321841, 'PTHR10434:SF59', NULL, NULL, NULL, NULL, '1-ACYL-SN-GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE', 241435),
(321842, 'PTHR10434:SF9', NULL, NULL, NULL, NULL, 'PLSC DOMAIN-CONTAINING PROTEIN', 241435);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(321843, 'PTHR10434:SF48', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 241435),
(321844, 'PTHR10434:SF15', NULL, NULL, NULL, NULL, 'PLSC DOMAIN-CONTAINING PROTEIN', 241435),
(321845, 'PTHR12106:SF20', NULL, NULL, NULL, NULL, 'SORTILIN-RELATED RECEPTOR', 241436),
(321846, 'PTHR12106:SF41', NULL, NULL, NULL, NULL, 'SORTILIN', 241436),
(321847, 'PTHR12106:SF9', NULL, NULL, NULL, NULL, 'VPS10 DOMAIN-CONTAINING RECEPTOR SORCS2', 241436),
(321848, 'PTHR12106:SF8', NULL, NULL, NULL, NULL, 'VPS10 DOMAIN-CONTAINING RECEPTOR SORCS1', 241436),
(321849, 'PTHR12106:SF23', NULL, NULL, NULL, NULL, 'SORTILIN', 241436),
(321850, 'PTHR12106', NULL, NULL, NULL, NULL, 'SORTILIN RELATED', 241436),
(321851, 'PTHR12106:SF45', NULL, NULL, NULL, NULL, 'SORTILIN-RELATED VPS10 DOMAIN-CONTAINING RECEPTOR 3B', 241436),
(321852, 'PTHR12106:SF44', NULL, NULL, NULL, NULL, 'SI:DKEY-159A18.1-RELATED', 241436),
(321853, 'PTHR12106:SF10', NULL, NULL, NULL, NULL, 'VPS10 DOMAIN-CONTAINING RECEPTOR SORCS3', 241436),
(321854, 'PTHR12106:SF27', NULL, NULL, NULL, NULL, 'VPS10 HOMOLOG 1-RELATED', 241436),
(321855, 'PTHR34482:SF36', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 241437),
(321856, 'PTHR34482:SF47', NULL, NULL, NULL, NULL, '', 241437),
(321857, 'PTHR34482:SF46', NULL, NULL, NULL, NULL, 'RETROTRANS_GAG DOMAIN-CONTAINING PROTEIN', 241437),
(321858, 'PTHR34482:SF49', NULL, NULL, NULL, NULL, 'RETROTRANS_GAG DOMAIN-CONTAINING PROTEIN', 241437),
(321859, 'PTHR34482:SF38', NULL, NULL, NULL, NULL, 'RETROTRANSPOSON GAG DOMAIN-CONTAINING PROTEIN-RELATED', 241437),
(321860, 'PTHR34482:SF48', NULL, NULL, NULL, NULL, 'OS02G0566300 PROTEIN', 241437),
(321861, 'PTHR34482', NULL, NULL, NULL, NULL, 'DNA DAMAGE-INDUCIBLE PROTEIN 1-LIKE', 241437),
(321862, 'PTHR34482:SF50', NULL, NULL, NULL, NULL, 'RETROTRANS_GAG DOMAIN-CONTAINING PROTEIN', 241437),
(321863, 'PTHR34482:SF52', NULL, NULL, NULL, NULL, '', 241437),
(321864, 'PTHR34482:SF51', NULL, NULL, NULL, NULL, '', 241437),
(321865, 'PTHR34482:SF54', NULL, NULL, NULL, NULL, 'RETROTRANSPOSON PROTEIN', 241437),
(321866, 'PTHR34482:SF53', NULL, NULL, NULL, NULL, 'RETROTRANS_GAG DOMAIN-CONTAINING PROTEIN', 241437),
(321867, 'PTHR34482:SF45', NULL, NULL, NULL, NULL, 'RETROTRANS_GAG DOMAIN-CONTAINING PROTEIN', 241437),
(321868, 'PTHR34482:SF55', NULL, NULL, NULL, NULL, '', 241437),
(321869, 'PTHR34482:SF33', NULL, NULL, NULL, NULL, '''CHROMO'' DOMAIN CONTAINING PROTEIN', 241437),
(321870, 'PTHR42241', NULL, NULL, NULL, NULL, 'HYPOTHETICAL MEMBRANE PROTEIN, CONSERVED, DUF998 FAMILY', 241438),
(321871, 'PTHR42241:SF2', NULL, NULL, NULL, NULL, 'HYPOTHETICAL MEMBRANE PROTEIN, CONSERVED, DUF998 FAMILY', 241438),
(321872, 'PTHR45725', NULL, NULL, NULL, NULL, 'FORMIN HOMOLOGY 2 FAMILY MEMBER', 241439),
(321873, 'PTHR45725:SF1', NULL, NULL, NULL, NULL, 'DISHEVELLED ASSOCIATED ACTIVATOR OF MORPHOGENESIS, ISOFORM D', 241439),
(321874, 'PTHR45725:SF17', NULL, NULL, NULL, NULL, 'POLYPEPTIDE N-ACETYLGALACTOSAMINYLTRANSFERASE', 241439),
(321875, 'PTHR45725:SF18', NULL, NULL, NULL, NULL, 'VPS9 DOMAIN-CONTAINING PROTEIN', 241439),
(321876, 'PTHR45725:SF13', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR, IONOTROPIC, DELTA 2 (GRID2)-INTERACTING PROTEIN, A', 241439),
(321877, 'PTHR45725:SF3', NULL, NULL, NULL, NULL, 'DELPHILIN', 241439),
(321878, 'PTHR45725:SF5', NULL, NULL, NULL, NULL, 'FORMIN-H', 241439),
(321879, 'PTHR45725:SF16', NULL, NULL, NULL, NULL, 'DISHEVELED-ASSOCIATED ACTIVATOR OF MORPHOGENESIS 1', 241439),
(321880, 'PTHR45725:SF7', NULL, NULL, NULL, NULL, 'DISHEVELED-ASSOCIATED ACTIVATOR OF MORPHOGENESIS 2', 241439),
(321881, 'PTHR45725:SF10', NULL, NULL, NULL, NULL, 'FORMIN-H-LIKE', 241439),
(321882, 'PTHR45725:SF11', NULL, NULL, NULL, NULL, 'FORMIN-D', 241439),
(321883, 'PTHR45725:SF8', NULL, NULL, NULL, NULL, 'FORMIN-B', 241439),
(321884, 'PTHR45725:SF12', NULL, NULL, NULL, NULL, 'DELPHILIN', 241439),
(321885, 'PTHR47671', NULL, NULL, NULL, NULL, 'PLECKSTRIN DOMAIN-CONTAINING FAMILY G MEMBER 6', 241440),
(321886, 'PTHR47671:SF1', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY G MEMBER 6', 241440);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(321887, 'PTHR12381', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN U FAMILY MEMBER', 241441),
(321888, 'PTHR12381:SF41', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN U-LIKE PROTEIN 1', 241441),
(321889, 'PTHR12381:SF56', NULL, NULL, NULL, NULL, 'B30.2/SPRY DOMAIN-CONTAINING PROTEIN-RELATED', 241441),
(321890, 'PTHR12381:SF11', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN U', 241441),
(321891, 'PTHR12381:SF66', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN U-LIKE PROTEIN 2', 241441),
(321892, 'PTHR11618:SF13', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIB', 241442),
(321893, 'PTHR11618:SF4', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR IIIB 90 KDA SUBUNIT', 241442),
(321894, 'PTHR11618:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR IIIB 50 KDA SUBUNIT', 241442),
(321895, 'PTHR11618', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIB-RELATED', 241442),
(321896, 'PTHR11618:SF43', NULL, NULL, NULL, NULL, '', 241442),
(321897, 'PTHR11618:SF64', NULL, NULL, NULL, NULL, 'TFIIB DOMAIN-CONTAINING PROTEIN', 241442),
(321898, 'PTHR11618:SF67', NULL, NULL, NULL, NULL, 'TFIIB DOMAIN-CONTAINING PROTEIN', 241442),
(321899, 'PTHR11618:SF66', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIB-2-LIKE', 241442),
(321900, 'PTHR11618:SF60', NULL, NULL, NULL, NULL, 'TFIIB-TYPE DOMAIN-CONTAINING PROTEIN', 241442),
(321901, 'PTHR11618:SF29', NULL, NULL, NULL, NULL, '', 241442),
(321902, 'PTHR11618:SF69', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIB-RELATED', 241442),
(321903, 'PTHR11618:SF68', NULL, NULL, NULL, NULL, 'TFIIB-TYPE DOMAIN-CONTAINING PROTEIN', 241442),
(321904, 'PTHR11618:SF24', NULL, NULL, NULL, NULL, 'OS03G0193600 PROTEIN', 241442),
(321905, 'PTHR11618:SF70', NULL, NULL, NULL, NULL, 'PLANT-SPECIFIC TFIIB-RELATED PROTEIN PTF2', 241442),
(321906, 'PTHR11618:SF76', NULL, NULL, NULL, NULL, 'PLANT-SPECIFIC TFIIB-RELATED PROTEIN 2', 241442),
(321907, 'PTHR11618:SF54', NULL, NULL, NULL, NULL, 'TFIIB-TYPE DOMAIN-CONTAINING PROTEIN', 241442),
(321908, 'PTHR11618:SF75', NULL, NULL, NULL, NULL, 'PLANT-SPECIFIC TFIIB-RELATED PROTEIN 2-RELATED', 241442),
(321909, 'PTHR11618:SF78', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIB-2', 241442),
(321910, 'PTHR11618:SF77', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIB', 241442),
(321911, 'PTHR11618:SF50', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIB-1', 241442),
(321912, 'PTHR11618:SF72', NULL, NULL, NULL, NULL, 'TFIIB-TYPE DOMAIN-CONTAINING PROTEIN', 241442),
(321913, 'PTHR11618:SF74', NULL, NULL, NULL, NULL, 'CYCLIN FAMILY PROTEIN', 241442),
(321914, 'PTHR11618:SF52', NULL, NULL, NULL, NULL, '', 241442),
(321915, 'PTHR11618:SF73', NULL, NULL, NULL, NULL, '', 241442),
(321916, 'PTHR11618:SF51', NULL, NULL, NULL, NULL, 'TFIIB-TYPE DOMAIN-CONTAINING PROTEIN', 241442),
(321917, 'PTHR24364:SF26', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 241443),
(321918, 'PTHR24364:SF16', NULL, NULL, NULL, NULL, 'TROPHOBLAST GLYCOPROTEIN-LIKE', 241443),
(321919, 'PTHR24364:SF17', NULL, NULL, NULL, NULL, 'TROPHOBLAST GLYCOPROTEIN', 241443),
(321920, 'PTHR24364:SF18', NULL, NULL, NULL, NULL, 'LP06937P', 241443),
(321921, 'PTHR24364:SF22', NULL, NULL, NULL, NULL, 'TROPHOBLAST GLYCOPROTEIN A-RELATED', 241443),
(321922, 'PTHR24364', NULL, NULL, NULL, NULL, 'LP06937P', 241443),
(321923, 'PTHR24364:SF21', NULL, NULL, NULL, NULL, 'TROPHOBLAST GLYCOPROTEIN B', 241443),
(321924, 'PTHR43707:SF6', NULL, NULL, NULL, NULL, 'ATP PHOSPHORIBOSYLTRANSFERASE REGULATORY SUBUNIT', 241444),
(321925, 'PTHR43707', NULL, NULL, NULL, NULL, 'HISTIDYL-TRNA SYNTHETASE', 241444),
(321926, 'PTHR43707:SF1', NULL, NULL, NULL, NULL, 'HISTIDINE--TRNA LIGASE, MITOCHONDRIAL-RELATED', 241444),
(321927, 'PTHR39380', NULL, NULL, NULL, NULL, 'FIP (FUNGUS-INDUCED PROTEIN) RELATED-RELATED-RELATED', 241445),
(321928, 'PTHR39380:SF2', NULL, NULL, NULL, NULL, 'FIP (FUNGUS-INDUCED PROTEIN) RELATED', 241445),
(321929, 'PTHR39380:SF1', NULL, NULL, NULL, NULL, 'FIP (FUNGUS-INDUCED PROTEIN) RELATED-RELATED', 241445);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(321930, 'PTHR34564:SF5', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241446),
(321931, 'PTHR34564:SF1', NULL, NULL, NULL, NULL, 'OS07G0250300 PROTEIN', 241446),
(321932, 'PTHR34564:SF3', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE G', 241446),
(321933, 'PTHR34564:SF10', NULL, NULL, NULL, NULL, 'HYALURONAN MEDIATED MOTILITY RECEPTOR-LIKE PROTEIN', 241446),
(321934, 'PTHR34564:SF9', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE G', 241446),
(321935, 'PTHR34564', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE G', 241446),
(321936, 'PTHR40265', NULL, NULL, NULL, NULL, 'BLL2707 PROTEIN', 241447),
(321937, 'PTHR40265:SF1', NULL, NULL, NULL, NULL, 'GLYOXALASE-LIKE_DOM DOMAIN-CONTAINING PROTEIN', 241447),
(321938, 'PTHR14058:SF8', NULL, NULL, NULL, NULL, 'PROTEIN FE65 HOMOLOG', 241448),
(321939, 'PTHR14058', NULL, NULL, NULL, NULL, 'AMYLOID BETA A4 PRECURSOR PROTEIN-BINDING FAMILY B', 241448),
(321940, 'PTHR14058:SF5', NULL, NULL, NULL, NULL, 'AMYLOID-BETA A4 PRECURSOR PROTEIN-BINDING FAMILY B MEMBER 1', 241448),
(321941, 'PTHR14058:SF10', NULL, NULL, NULL, NULL, 'AMYLOID-BETA A4 PRECURSOR PROTEIN-BINDING FAMILY B MEMBER 3', 241448),
(321942, 'PTHR14058:SF11', NULL, NULL, NULL, NULL, 'AMYLOID-BETA A4 PRECURSOR PROTEIN-BINDING FAMILY B MEMBER 2', 241448),
(321943, 'PTHR15337:SF11', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN CONTAINING PROTEIN HOMOLOG', 241449),
(321944, 'PTHR15337:SF23', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 241449),
(321945, 'PTHR15337:SF1', NULL, NULL, NULL, NULL, 'ANTERIOR GRADIENT PROTEIN 2 HOMOLOG', 241449),
(321946, 'PTHR15337', NULL, NULL, NULL, NULL, 'ANTERIOR GRADIENT PROTEIN-RELATED', 241449),
(321947, 'PTHR15337:SF10', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN 12', 241449),
(321948, 'PTHR15337:SF5', NULL, NULL, NULL, NULL, 'ANTERIOR GRADIENT PROTEIN 3', 241449),
(321949, 'PTHR10271:SF23', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED PROTEIN WITH TETRATRICOPEPTIDE REPEATS 1', 241450),
(321950, 'PTHR10271:SF4', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED PROTEIN WITH TETRATRICOPEPTIDE REPEATS 2', 241450),
(321951, 'PTHR10271:SF32', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED PROTEIN WITH TETRATRICOPEPTIDE REPEATS 1B', 241450),
(321952, 'PTHR10271:SF3', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED PROTEIN WITH TETRATRICOPEPTIDE REPEATS 3', 241450),
(321953, 'PTHR10271', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED PROTEIN WITH TETRATRICOPEPTIDE REPEATS', 241450),
(321954, 'PTHR10271:SF0', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ACTIVATOR GUTR', 241450),
(321955, 'PTHR10271:SF29', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED PROTEIN WITH TETRATRICOPEPTIDE REPEATS-RELATED', 241450),
(321956, 'PTHR10271:SF28', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED PROTEIN WITH TETRATRICOPEPTIDE REPEATS 5', 241450),
(321957, 'PTHR10271:SF16', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED PROTEIN WITH TETRATRICOPEPTIDE REPEATS 1', 241450),
(321958, 'PTHR10271:SF25', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED PROTEIN WITH TETRATRICOPEPTIDE REPEATS 8', 241450),
(321959, 'PTHR10271:SF14', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED PROTEIN WITH TETRATRICOPEPTIDE REPEATS 14-RELATED', 241450),
(321960, 'PTHR22904:SF519', NULL, NULL, NULL, NULL, '', 241451),
(321961, 'PTHR22904:SF529', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 241451),
(321962, 'PTHR22904:SF517', NULL, NULL, NULL, NULL, 'STRESS-INDUCED-PHOSPHOPROTEIN 1', 241451),
(321963, 'PTHR22904:SF516', NULL, NULL, NULL, NULL, '', 241451),
(321964, 'PTHR22904', NULL, NULL, NULL, NULL, 'TPR REPEAT CONTAINING PROTEIN', 241451),
(321965, 'PTHR22904:SF536', NULL, NULL, NULL, NULL, 'HSP70-HSP90 ORGANIZING PROTEIN 1-RELATED', 241451),
(321966, 'PTHR22904:SF513', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 241451),
(321967, 'PTHR22904:SF524', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 241451),
(321968, 'PTHR22904:SF535', NULL, NULL, NULL, NULL, 'OS06G0159400 PROTEIN', 241451),
(321969, 'PTHR22904:SF523', NULL, NULL, NULL, NULL, 'STRESS-INDUCED-PHOSPHOPROTEIN 1', 241451);
INSERT INTO "PUBLIC"."MODEL" VALUES
(321970, 'PTHR22904:SF534', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 241451),
(321971, 'PTHR22904:SF533', NULL, NULL, NULL, NULL, 'HSP70-HSP90 ORGANIZING PROTEIN 3', 241451),
(321972, 'PTHR22904:SF532', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 241451),
(321973, 'PTHR22904:SF530', NULL, NULL, NULL, NULL, 'HSP70-HSP90 ORGANIZING PROTEIN 2-LIKE', 241451),
(321974, 'PTHR36358:SF1', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE SUBUNIT 4, MITOCHONDRIAL', 241452),
(321975, 'PTHR36358', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE SUBUNIT 4, MITOCHONDRIAL', 241452),
(321976, 'PTHR36358:SF2', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE SUBUNIT 4, MITOCHONDRIAL', 241452),
(321977, 'PTHR31319:SF47', NULL, NULL, NULL, NULL, 'CCT DOMAIN-CONTAINING PROTEIN', 241453),
(321978, 'PTHR31319:SF68', NULL, NULL, NULL, NULL, 'CCT MOTIF FAMILY PROTEIN, EXPRESSED', 241453),
(321979, 'PTHR31319:SF72', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CONSTANS-LIKE 2-LIKE', 241453),
(321980, 'PTHR31319:SF94', NULL, NULL, NULL, NULL, 'CONSTANS-LIKE PROTEIN CO8', 241453),
(321981, 'PTHR31319:SF71', NULL, NULL, NULL, NULL, 'CCT MOTIF FAMILY PROTEIN', 241453),
(321982, 'PTHR31319:SF96', NULL, NULL, NULL, NULL, 'HD1-LIKE PROTEIN', 241453),
(321983, 'PTHR31319:SF95', NULL, NULL, NULL, NULL, 'CCT MOTIF FAMILY PROTEIN', 241453),
(321984, 'PTHR31319:SF100', NULL, NULL, NULL, NULL, 'OS01G0835700 PROTEIN', 241453),
(321985, 'PTHR31319:SF98', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GHD7', 241453),
(321986, 'PTHR31319:SF101', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR-LIKE APRR5', 241453),
(321987, 'PTHR31319:SF54', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CONSTANS-LIKE 3', 241453),
(321988, 'PTHR31319:SF102', NULL, NULL, NULL, NULL, 'CCT DOMAIN-CONTAINING PROTEIN', 241453),
(321989, 'PTHR31319:SF53', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CONSTANS-LIKE 5', 241453),
(321990, 'PTHR31319:SF97', NULL, NULL, NULL, NULL, 'CCT DOMAIN-CONTAINING PROTEIN', 241453),
(321991, 'PTHR31319:SF78', NULL, NULL, NULL, NULL, 'CCT DOMAIN-CONTAINING PROTEIN', 241453),
(321992, 'PTHR31319:SF103', NULL, NULL, NULL, NULL, 'CCT MOTIF FAMILY PROTEIN', 241453),
(321993, 'PTHR31319:SF104', NULL, NULL, NULL, NULL, 'CCT MOTIF FAMILY PROTEIN', 241453),
(321994, 'PTHR31319:SF99', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CONSTANS-LIKE 4-LIKE', 241453),
(321995, 'PTHR31319:SF77', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CONSTANS-LIKE 4', 241453),
(321996, 'PTHR31319:SF105', NULL, NULL, NULL, NULL, 'OS04G0497700 PROTEIN', 241453),
(321997, 'PTHR31319:SF106', NULL, NULL, NULL, NULL, 'CCT DOMAIN-CONTAINING PROTEIN', 241453),
(321998, 'PTHR31319:SF107', NULL, NULL, NULL, NULL, 'CCT MOTIF PROTEIN', 241453),
(321999, 'PTHR31319:SF108', NULL, NULL, NULL, NULL, 'OS02G0610500 PROTEIN', 241453),
(322000, 'PTHR31319:SF109', NULL, NULL, NULL, NULL, 'CCT', 241453),
(322001, 'PTHR31319:SF70', NULL, NULL, NULL, NULL, 'OS12G0262400 PROTEIN', 241453),
(322002, 'PTHR31319:SF39', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CONSTANS-LIKE 1', 241453),
(322003, 'PTHR31319:SF61', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CONSTANS-LIKE 5', 241453),
(322004, 'PTHR31319:SF83', NULL, NULL, NULL, NULL, 'C2C2-CO-LIKE TRANSCRIPTION FACTOR', 241453),
(322005, 'PTHR31319:SF82', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CONSTANS', 241453),
(322006, 'PTHR31319:SF84', NULL, NULL, NULL, NULL, '', 241453),
(322007, 'PTHR31319:SF86', NULL, NULL, NULL, NULL, 'CCT DOMAIN-CONTAINING PROTEIN-RELATED', 241453),
(322008, 'PTHR31319', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CONSTANS-LIKE 4', 241453),
(322009, 'PTHR31319:SF89', NULL, NULL, NULL, NULL, 'CCT MOTIF PROTEIN', 241453),
(322010, 'PTHR31319:SF45', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN HD1-LIKE', 241453),
(322011, 'PTHR31319:SF88', NULL, NULL, NULL, NULL, 'CONSTANS-LIKE 5-RELATED', 241453),
(322012, 'PTHR31319:SF44', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CONSTANS-LIKE 2', 241453),
(322013, 'PTHR31319:SF81', NULL, NULL, NULL, NULL, 'CCT DOMAIN-CONTAINING PROTEIN', 241453);
INSERT INTO "PUBLIC"."MODEL" VALUES
(322014, 'PTHR31319:SF80', NULL, NULL, NULL, NULL, 'CCT PROTEIN', 241453),
(322015, 'PTHR38709', NULL, NULL, NULL, NULL, 'SI:CH73-193C12.2-RELATED', 241454),
(322016, 'PTHR38709:SF1', NULL, NULL, NULL, NULL, 'DREBRIN', 241454),
(322017, 'PTHR34227:SF6', NULL, NULL, NULL, NULL, 'TAT PROOFREADING CHAPERONE DMSD', 241455),
(322018, 'PTHR34227', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN YCDY', 241455),
(322019, 'PTHR34227:SF11', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN TORD', 241455),
(322020, 'PTHR34227:SF12', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN YCDY', 241455),
(322021, 'PTHR34227:SF1', NULL, NULL, NULL, NULL, 'TAT PROOFREADING CHAPERONE DMSD-RELATED', 241455),
(322022, 'PTHR34227:SF4', NULL, NULL, NULL, NULL, 'BLL5480 PROTEIN', 241455),
(322023, 'PTHR24217:SF9', NULL, NULL, NULL, NULL, 'SYNAPTOPODIN-2', 241456),
(322024, 'PTHR24217', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 241456),
(322025, 'PTHR24217:SF13', NULL, NULL, NULL, NULL, 'SYNAPTOPODIN', 241456),
(322026, 'PTHR24217:SF10', NULL, NULL, NULL, NULL, 'SYNAPTOPODIN 2-LIKE PROTEIN', 241456),
(322027, 'PTHR24217:SF14', NULL, NULL, NULL, NULL, 'SYNAPTOPODIN 2-LIKE A', 241456),
(322028, 'PTHR24217:SF0', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN', 241456),
(322029, 'PTHR10609:SF15', NULL, NULL, NULL, NULL, 'VASCULAR NON-INFLAMMATORY MOLECULE 2', 241457),
(322030, 'PTHR10609:SF14', NULL, NULL, NULL, NULL, 'BIOTINIDASE', 241457),
(322031, 'PTHR10609:SF4', NULL, NULL, NULL, NULL, 'VASCULAR NON-INFLAMMATORY MOLECULE 3', 241457),
(322032, 'PTHR10609', NULL, NULL, NULL, NULL, 'BIOTINIDASE-RELATED', 241457),
(322033, 'PTHR10609:SF16', NULL, NULL, NULL, NULL, 'PANTETHEINASE', 241457),
(322034, 'PTHR10609:SF27', NULL, NULL, NULL, NULL, 'CN HYDROLASE DOMAIN-CONTAINING PROTEIN', 241457),
(322035, 'PTHR46502:SF1', NULL, NULL, NULL, NULL, 'OS02G0640000 PROTEIN', 241458),
(322036, 'PTHR46502:SF2', NULL, NULL, NULL, NULL, '16 KDA PHLOEM PROTEIN 2', 241458),
(322037, 'PTHR46502', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING', 241458),
(322038, 'PTHR46502:SF22', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 241458),
(322039, 'PTHR46502:SF11', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT LIPID-BINDING (CALB DOMAIN) FAMILY PROTEIN', 241458),
(322040, 'PTHR46502:SF21', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT LIPID-BINDING (CALB DOMAIN) FAMILY PROTEIN', 241458),
(322041, 'PTHR46502:SF20', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 241458),
(322042, 'PTHR46502:SF16', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN-RELATED', 241458),
(322043, 'PTHR46502:SF7', NULL, NULL, NULL, NULL, 'ELICITOR-RESPONSIVE-LIKE PROTEIN', 241458),
(322044, 'PTHR46502:SF15', NULL, NULL, NULL, NULL, '16 KDA PHLOEM PROTEIN 1', 241458),
(322045, 'PTHR46502:SF6', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 241458),
(322046, 'PTHR46502:SF9', NULL, NULL, NULL, NULL, 'ELICITOR-RESPONSIVE PROTEIN 3-LIKE ISOFORM X1', 241458),
(322047, 'PTHR46502:SF14', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT LIPID-BINDING (CALB DOMAIN) FAMILY PROTEIN', 241458),
(322048, 'PTHR46502:SF19', NULL, NULL, NULL, NULL, 'ELICITOR-RESPONSIVE PROTEIN 3-LIKE', 241458),
(322049, 'PTHR46502:SF18', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN-RELATED', 241458),
(322050, 'PTHR46502:SF17', NULL, NULL, NULL, NULL, 'OS04G0682100 PROTEIN', 241458),
(322051, 'PTHR20920:SF2', NULL, NULL, NULL, NULL, 'SOMATOMEDIN-B AND THROMBOSPONDIN TYPE-1 DOMAIN-CONTAINING PROTEIN', 241459),
(322052, 'PTHR20920', NULL, NULL, NULL, NULL, 'RPE-SPONDIN', 241459),
(322053, 'PTHR20920:SF4', NULL, NULL, NULL, NULL, 'SMB DOMAIN-CONTAINING PROTEIN', 241459),
(322054, 'PTHR20920:SF5', NULL, NULL, NULL, NULL, 'SMB DOMAIN-CONTAINING PROTEIN', 241459),
(322055, 'PTHR20920:SF6', NULL, NULL, NULL, NULL, 'SMB DOMAIN-CONTAINING PROTEIN', 241459),
(322056, 'PTHR36108', NULL, NULL, NULL, NULL, 'COLOSSIN-B-RELATED', 241460),
(322057, 'PTHR36108:SF13', NULL, NULL, NULL, NULL, 'COLOSSIN-B', 241460),
(322058, 'PTHR36108:SF16', NULL, NULL, NULL, NULL, 'COLOSSIN-D', 241460),
(322059, 'PTHR36108:SF17', NULL, NULL, NULL, NULL, 'COLOSSIN-C', 241460);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(322060, 'PTHR45339:SF1', NULL, NULL, NULL, NULL, 'HYBRID SIGNAL TRANSDUCTION HISTIDINE KINASE J', 241461),
(322061, 'PTHR45339', NULL, NULL, NULL, NULL, 'HYBRID SIGNAL TRANSDUCTION HISTIDINE KINASE J', 241461),
(322062, 'PTHR45339:SF4', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE CONTAINING CHEY-HOMOLOGOUS RECEIVER DOMAIN AND PAS DOMAIN-RELATED', 241461),
(322063, 'PTHR45339:SF3', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE', 241461),
(322064, 'PTHR28051:SF3', NULL, NULL, NULL, NULL, '', 241462),
(322065, 'PTHR28051:SF1', NULL, NULL, NULL, NULL, 'PROTEIN MTL1-RELATED', 241462),
(322066, 'PTHR28051', NULL, NULL, NULL, NULL, 'PROTEIN MTL1-RELATED', 241462),
(322067, 'PTHR11066:SF49', NULL, NULL, NULL, NULL, 'PROTEIN CBG08110', 241463),
(322068, 'PTHR11066:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG02441', 241463),
(322069, 'PTHR11066:SF61', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 241463),
(322070, 'PTHR11066:SF66', NULL, NULL, NULL, NULL, 'PROTEIN CBG22797', 241463),
(322071, 'PTHR11066:SF65', NULL, NULL, NULL, NULL, 'ACYL-COA THIOESTERASE', 241463),
(322072, 'PTHR11066:SF64', NULL, NULL, NULL, NULL, 'ACYL-COA THIOESTERASE (AFU_ORTHOLOGUE AFUA_1G12060)', 241463),
(322073, 'PTHR11066:SF48', NULL, NULL, NULL, NULL, 'PROTEIN CBG08841', 241463),
(322074, 'PTHR11066:SF37', NULL, NULL, NULL, NULL, 'PROTEIN CBG08033', 241463),
(322075, 'PTHR11066:SF59', NULL, NULL, NULL, NULL, 'ACYL-COA THIOESTERASE, RMLC-LIKE JELLY ROLL FOLD, HOTDOG DOMAIN PROTEIN-RELATED', 241463),
(322076, 'PTHR11066', NULL, NULL, NULL, NULL, 'ACYL-COA THIOESTERASE', 241463),
(322077, 'PTHR11066:SF35', NULL, NULL, NULL, NULL, '', 241463),
(322078, 'PTHR11066:SF56', NULL, NULL, NULL, NULL, 'ACYL-COA THIOESTERASE FAMILY PROTEIN', 241463),
(322079, 'PTHR11066:SF34', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A THIOESTERASE 8', 241463),
(322080, 'PTHR37476', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 171', 241464),
(322081, 'PTHR37476:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 171', 241464),
(322082, 'PTHR39233:SF1', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE III DOMAIN-CONTAINING PROTEIN 10', 241465),
(322083, 'PTHR39233', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE III DOMAIN-CONTAINING PROTEIN 10', 241465),
(322084, 'PTHR31123:SF6', NULL, NULL, NULL, NULL, 'MEMBRANE AMMONIUM TRANSPORTER (ATO3), PUTATIVE (AFU_ORTHOLOGUE AFUA_5G01140)-RELATED', 241466),
(322085, 'PTHR31123:SF3', NULL, NULL, NULL, NULL, 'AMMONIA TRANSPORT OUTWARD PROTEIN 3', 241466),
(322086, 'PTHR31123:SF4', NULL, NULL, NULL, NULL, 'PROTEIN ALCS', 241466),
(322087, 'PTHR31123:SF1', NULL, NULL, NULL, NULL, 'ACCUMULATION OF DYADS PROTEIN 2-RELATED', 241466),
(322088, 'PTHR31123', NULL, NULL, NULL, NULL, 'ACCUMULATION OF DYADS PROTEIN 2-RELATED', 241466),
(322089, 'PTHR14085', NULL, NULL, NULL, NULL, 'WD-REPEAT PROTEIN BING4', 241467),
(322090, 'PTHR14085:SF3', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 46', 241467),
(322091, 'PTHR14085:SF4', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 241467),
(322092, 'PTHR21593:SF18', NULL, NULL, NULL, NULL, 'DUF148 DOMAIN-CONTAINING PROTEIN', 241468),
(322093, 'PTHR21593:SF29', NULL, NULL, NULL, NULL, 'DUF148 DOMAIN-CONTAINING PROTEIN', 241468),
(322094, 'PTHR21593:SF27', NULL, NULL, NULL, NULL, 'PROTEIN CBG23956', 241468),
(322095, 'PTHR21593:SF38', NULL, NULL, NULL, NULL, 'DUF148 DOMAIN-CONTAINING PROTEIN', 241468),
(322096, 'PTHR21593:SF17', NULL, NULL, NULL, NULL, 'DUF148 DOMAIN-CONTAINING PROTEIN', 241468),
(322097, 'PTHR21593:SF8', NULL, NULL, NULL, NULL, 'DUF148 DOMAIN-CONTAINING PROTEIN', 241468),
(322098, 'PTHR21593', NULL, NULL, NULL, NULL, 'PRION-LIKE- Q/N-RICH -DOMAIN-BEARING PROTEIN PROTEIN', 241468),
(322099, 'PTHR21593:SF4', NULL, NULL, NULL, NULL, 'DUF148 DOMAIN-CONTAINING PROTEIN', 241468),
(322100, 'PTHR21593:SF6', NULL, NULL, NULL, NULL, 'DUF148 DOMAIN-CONTAINING PROTEIN', 241468),
(322101, 'PTHR21593:SF14', NULL, NULL, NULL, NULL, 'DUF148 DOMAIN-CONTAINING PROTEIN', 241468),
(322102, 'PTHR21593:SF36', NULL, NULL, NULL, NULL, 'DUF148 DOMAIN-CONTAINING PROTEIN', 241468);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(322103, 'PTHR21593:SF37', NULL, NULL, NULL, NULL, 'PROTEIN CBG08979', 241468),
(322104, 'PTHR21593:SF15', NULL, NULL, NULL, NULL, 'DUF148 DOMAIN-CONTAINING PROTEIN', 241468),
(322105, 'PTHR21593:SF23', NULL, NULL, NULL, NULL, 'ONCHOCERCA RELATED ANTIGEN FAMILY', 241468),
(322106, 'PTHR21593:SF13', NULL, NULL, NULL, NULL, 'DUF148 DOMAIN-CONTAINING PROTEIN', 241468),
(322107, 'PTHR21593:SF35', NULL, NULL, NULL, NULL, 'PROTEIN CBG05431', 241468),
(322108, 'PTHR21593:SF22', NULL, NULL, NULL, NULL, 'PROTEIN CBG18492', 241468),
(322109, 'PTHR21593:SF11', NULL, NULL, NULL, NULL, 'DUF148 DOMAIN-CONTAINING PROTEIN', 241468),
(322110, 'PTHR21593:SF20', NULL, NULL, NULL, NULL, 'DUF148 DOMAIN-CONTAINING PROTEIN', 241468),
(322111, 'PTHR21593:SF31', NULL, NULL, NULL, NULL, 'DUF148 DOMAIN-CONTAINING PROTEIN', 241468),
(322112, 'PTHR16299', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN KIZUNA', 241469),
(322113, 'PTHR16299:SF2', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN KIZUNA', 241469),
(322114, 'PTHR10343:SF87', NULL, NULL, NULL, NULL, 'SNF1 PROTEIN KINASE SUBUNIT BETA-1', 241470),
(322115, 'PTHR10343:SF84', NULL, NULL, NULL, NULL, '5''-AMP-ACTIVATED PROTEIN KINASE SUBUNIT BETA-1', 241470),
(322116, 'PTHR10343:SF95', NULL, NULL, NULL, NULL, 'PROTEIN KINASE, AMP-ACTIVATED, BETA 1 NON-CATALYTIC SUBUNIT, A', 241470),
(322117, 'PTHR10343:SF94', NULL, NULL, NULL, NULL, 'MDG1P', 241470),
(322118, 'PTHR10343:SF93', NULL, NULL, NULL, NULL, 'PROTEIN KINASE, AMP-ACTIVATED, BETA 1 NON-CATALYTIC SUBUNIT, B', 241470),
(322119, 'PTHR10343:SF81', NULL, NULL, NULL, NULL, 'CRUCIFORM DNA-RECOGNIZING PROTEIN 1-RELATED', 241470),
(322120, 'PTHR10343:SF92', NULL, NULL, NULL, NULL, '5''-AMP-ACTIVATED PROTEIN KINASE SUBUNIT BETA-2', 241470),
(322121, 'PTHR10343:SF91', NULL, NULL, NULL, NULL, 'PROTEIN CBG11004', 241470),
(322122, 'PTHR10343', NULL, NULL, NULL, NULL, '5''-AMP-ACTIVATED PROTEIN KINASE , BETA SUBUNIT', 241470),
(322123, 'PTHR10343:SF49', NULL, NULL, NULL, NULL, 'AMPKBI DOMAIN-CONTAINING PROTEIN', 241470),
(322124, 'PTHR13799', NULL, NULL, NULL, NULL, 'NGG1 INTERACTING FACTOR 3', 241471),
(322125, 'PTHR13799:SF14', NULL, NULL, NULL, NULL, 'GTP CYCLOHYDROLASE 1 TYPE 2 HOMOLOG', 241471),
(322126, 'PTHR13799:SF13', NULL, NULL, NULL, NULL, 'NIF3-LIKE PROTEIN 1', 241471),
(322127, 'PTHR31618:SF25', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN', 241472),
(322128, 'PTHR31618:SF24', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN 8', 241472),
(322129, 'PTHR31618:SF23', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN', 241472),
(322130, 'PTHR31618:SF22', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN', 241472),
(322131, 'PTHR31618:SF21', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN 4', 241472),
(322132, 'PTHR31618:SF20', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN 10', 241472),
(322133, 'PTHR31618:SF8', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN', 241472),
(322134, 'PTHR31618:SF19', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL DOMAIN-CONTAINING PROTEIN', 241472),
(322135, 'PTHR31618:SF18', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN 7', 241472),
(322136, 'PTHR31618:SF7', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN', 241472),
(322137, 'PTHR31618:SF17', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN 9', 241472),
(322138, 'PTHR31618:SF6', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN', 241472),
(322139, 'PTHR31618:SF16', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN', 241472),
(322140, 'PTHR31618:SF1', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN 6', 241472),
(322141, 'PTHR31618', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN 5', 241472),
(322142, 'PTHR31618:SF12', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN', 241472),
(322143, 'PTHR31618:SF11', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN', 241472),
(322144, 'PTHR31618:SF33', NULL, NULL, NULL, NULL, '', 241472); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(322145, 'PTHR31618:SF32', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN 5', 241472),
(322146, 'PTHR31618:SF10', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN', 241472),
(322147, 'PTHR31618:SF31', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN', 241472),
(322148, 'PTHR31618:SF30', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN', 241472),
(322149, 'PTHR31618:SF29', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN', 241472),
(322150, 'PTHR31618:SF28', NULL, NULL, NULL, NULL, 'BNAC02G08790D PROTEIN', 241472),
(322151, 'PTHR31618:SF27', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN', 241472),
(322152, 'PTHR31618:SF26', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN', 241472),
(322153, 'PTHR45586:SF13', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 241473),
(322154, 'PTHR45586:SF16', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE-RELATED', 241473),
(322155, 'PTHR45586', NULL, NULL, NULL, NULL, 'TPR REPEAT-CONTAINING PROTEIN PA4667', 241473),
(322156, 'PTHR45586:SF15', NULL, NULL, NULL, NULL, 'TPR REPEAT-CONTAINING PROTEIN YPIA', 241473),
(322157, 'PTHR45586:SF14', NULL, NULL, NULL, NULL, 'SECRETED PROTEIN-RELATED', 241473),
(322158, 'PTHR45586:SF1', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE ASSEMBLY PROTEIN B', 241473),
(322159, 'PTHR15934:SF4', NULL, NULL, NULL, NULL, 'AKAP7_NLS DOMAIN-CONTAINING PROTEIN', 241474),
(322160, 'PTHR15934:SF2', NULL, NULL, NULL, NULL, 'AKAP7_NLS DOMAIN-CONTAINING PROTEIN', 241474),
(322161, 'PTHR15934', NULL, NULL, NULL, NULL, 'RNA 2'',3''-CYCLIC PHOSPHODIESTERASE', 241474),
(322162, 'PTHR15934:SF6', NULL, NULL, NULL, NULL, 'A-KINASE ANCHOR PROTEIN 7 ISOFORM GAMMA', 241474),
(322163, 'PTHR32205', NULL, NULL, NULL, NULL, 'ARCHAEMETZINCIN-2-RELATED', 241475),
(322164, 'PTHR32205:SF4', NULL, NULL, NULL, NULL, 'ARCHAEMETZINCIN-1', 241475),
(322165, 'PTHR32205:SF5', NULL, NULL, NULL, NULL, 'ARCHAEMETZINCIN-2', 241475),
(322166, 'PTHR21641', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR-RELATED', 241476),
(322167, 'PTHR21641:SF0', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN EIF1AD-RELATED', 241476),
(322168, 'PTHR34781:SF7', NULL, NULL, NULL, NULL, 'BNAA07G08940D PROTEIN', 241477),
(322169, 'PTHR34781:SF8', NULL, NULL, NULL, NULL, 'BNAA09G28030D PROTEIN', 241477),
(322170, 'PTHR34781', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 241477),
(322171, 'PTHR34781:SF10', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 241477),
(322172, 'PTHR34781:SF11', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 241477),
(322173, 'PTHR34781:SF1', NULL, NULL, NULL, NULL, 'OS01G0923000 PROTEIN', 241477),
(322174, 'PTHR34781:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 241477),
(322175, 'PTHR34781:SF3', NULL, NULL, NULL, NULL, '', 241477),
(322176, 'PTHR46770:SF1', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN ORTHOPEDIA', 241478),
(322177, 'PTHR46770', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN ORTHOPEDIA', 241478),
(322178, 'PTHR43578:SF1', NULL, NULL, NULL, NULL, 'NADH-QUINONE OXIDOREDUCTASE SUBUNIT F', 241479),
(322179, 'PTHR43578', NULL, NULL, NULL, NULL, 'NADH-QUINONE OXIDOREDUCTASE SUBUNIT F', 241479),
(322180, 'PTHR43578:SF2', NULL, NULL, NULL, NULL, 'FE-HYDROGENASE, SUBUNIT BETA', 241479),
(322181, 'PTHR43578:SF3', NULL, NULL, NULL, NULL, 'HYDROGENASE SUBUNIT', 241479),
(322182, 'PTHR24028:SF272', NULL, NULL, NULL, NULL, 'PROTOCADHERIN GAMMA-C4', 241480),
(322183, 'PTHR24028:SF312', NULL, NULL, NULL, NULL, 'PROTOCADHERIN GAMMA-C5', 241480),
(322184, 'PTHR24028:SF311', NULL, NULL, NULL, NULL, 'CADHERIN-87A', 241480),
(322185, 'PTHR24028:SF314', NULL, NULL, NULL, NULL, 'CADHERIN-RELATED FAMILY MEMBER 2', 241480),
(322186, 'PTHR24028:SF313', NULL, NULL, NULL, NULL, 'GENE 28710-RELATED', 241480),
(322187, 'PTHR24028:SF153', NULL, NULL, NULL, NULL, 'PROTOCADHERIN ALPHA-C1', 241480),
(322188, 'PTHR24028:SF310', NULL, NULL, NULL, NULL, 'FAT-LIKE CADHERIN-RELATED TUMOR SUPPRESSOR HOMOLOG', 241480),
(322189, 'PTHR24028:SF276', NULL, NULL, NULL, NULL, 'PROTOCADHERIN 20', 241480);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(322190, 'PTHR24028:SF319', NULL, NULL, NULL, NULL, 'NEURAL-CADHERIN-LIKE', 241480),
(322191, 'PTHR24028:SF316', NULL, NULL, NULL, NULL, '', 241480),
(322192, 'PTHR24028:SF315', NULL, NULL, NULL, NULL, 'CADHERIN EGF LAG SEVEN-PASS G-TYPE RECEPTOR 2', 241480),
(322193, 'PTHR24028:SF318', NULL, NULL, NULL, NULL, 'PROTOCADHERIN BETA-12', 241480),
(322194, 'PTHR24028:SF317', NULL, NULL, NULL, NULL, 'PROTOCADHERIN-16-LIKE', 241480),
(322195, 'PTHR24028:SF73', NULL, NULL, NULL, NULL, 'PROTOCADHERIN GAMMA SUBFAMILY B, 8', 241480),
(322196, 'PTHR24028:SF72', NULL, NULL, NULL, NULL, 'PROTOCADHERIN GAMMA-A8', 241480),
(322197, 'PTHR24028:SF71', NULL, NULL, NULL, NULL, 'PROTOCADHERIN BETA-16', 241480),
(322198, 'PTHR24028:SF70', NULL, NULL, NULL, NULL, 'PROTOCADHERIN GAMMA-C3', 241480),
(322199, 'PTHR24028:SF76', NULL, NULL, NULL, NULL, 'PROTOCADHERIN ALPHA-12', 241480),
(322200, 'PTHR24028:SF281', NULL, NULL, NULL, NULL, 'PROTOCADHERIN BETA-2', 241480),
(322201, 'PTHR24028:SF90', NULL, NULL, NULL, NULL, 'PROTOCADHERIN BETA-5', 241480),
(322202, 'PTHR24028:SF323', NULL, NULL, NULL, NULL, 'NEURAL-CADHERIN-LIKE PROTEIN', 241480),
(322203, 'PTHR24028:SF322', NULL, NULL, NULL, NULL, 'PROTEIN CBG16382', 241480),
(322204, 'PTHR24028:SF325', NULL, NULL, NULL, NULL, 'FAT ATYPICAL CADHERIN 3', 241480),
(322205, 'PTHR24028:SF324', NULL, NULL, NULL, NULL, 'PROTOCADHERIN-11 Y-LINKED', 241480),
(322206, 'PTHR24028:SF286', NULL, NULL, NULL, NULL, 'PROTOCADHERIN BETA-11', 241480),
(322207, 'PTHR24028:SF321', NULL, NULL, NULL, NULL, 'CADHERIN RELATED 23', 241480),
(322208, 'PTHR24028:SF288', NULL, NULL, NULL, NULL, 'SI:CH73-233F7.3-RELATED', 241480),
(322209, 'PTHR24028:SF287', NULL, NULL, NULL, NULL, 'PROTOCADHERIN 2 ALPHA B 3-RELATED', 241480),
(322210, 'PTHR24028:SF320', NULL, NULL, NULL, NULL, 'PROTOCADHERIN BETA-13', 241480),
(322211, 'PTHR24028:SF327', NULL, NULL, NULL, NULL, 'PROTOCADHERIN ALPHA-3', 241480),
(322212, 'PTHR24028:SF326', NULL, NULL, NULL, NULL, 'CADHERIN EGF LAG SEVEN-PASS G-TYPE RECEPTOR 3', 241480),
(322213, 'PTHR24028:SF328', NULL, NULL, NULL, NULL, 'CADHERIN-3', 241480),
(322214, 'PTHR24028:SF84', NULL, NULL, NULL, NULL, 'PROTOCADHERIN GAMMA-A11', 241480),
(322215, 'PTHR24028:SF81', NULL, NULL, NULL, NULL, 'PROTOCADHERIN BETA-14', 241480),
(322216, 'PTHR24028:SF87', NULL, NULL, NULL, NULL, 'PROTOCADHERIN BETA 4', 241480),
(322217, 'PTHR24028:SF86', NULL, NULL, NULL, NULL, 'PROTOCADHERIN GAMMA-A9', 241480),
(322218, 'PTHR24028:SF293', NULL, NULL, NULL, NULL, 'SI:CH73-379J16.2', 241480),
(322219, 'PTHR24028:SF290', NULL, NULL, NULL, NULL, 'PROTOCADHERIN 2 ALPHA A 15', 241480),
(322220, 'PTHR24028:SF297', NULL, NULL, NULL, NULL, 'PROTOCADHERIN 15A', 241480),
(322221, 'PTHR24028:SF296', NULL, NULL, NULL, NULL, 'PROTOCADHERIN DELTA 1', 241480),
(322222, 'PTHR24028:SF58', NULL, NULL, NULL, NULL, 'PROTOCADHERIN BETA 11', 241480),
(322223, 'PTHR24028:SF57', NULL, NULL, NULL, NULL, 'PROTOCADHERIN B', 241480),
(322224, 'PTHR24028:SF56', NULL, NULL, NULL, NULL, 'PROTOCADHERIN GAMMA-A7', 241480),
(322225, 'PTHR24028:SF55', NULL, NULL, NULL, NULL, 'PROTOCADHERIN BETA-4', 241480),
(322226, 'PTHR24028:SF54', NULL, NULL, NULL, NULL, 'PROTOCADHERIN BETA-10', 241480),
(322227, 'PTHR24028', NULL, NULL, NULL, NULL, 'CADHERIN-87A', 241480),
(322228, 'PTHR24028:SF105', NULL, NULL, NULL, NULL, 'PROTOCADHERIN GAMMA-A5', 241480),
(322229, 'PTHR24028:SF225', NULL, NULL, NULL, NULL, 'PROTOCADHERIN ALPHA-7', 241480),
(322230, 'PTHR24028:SF104', NULL, NULL, NULL, NULL, 'PROTOCADHERIN BETA-6', 241480),
(322231, 'PTHR24028:SF101', NULL, NULL, NULL, NULL, 'PROTOCADHERIN ALPHA-13', 241480),
(322232, 'PTHR24028:SF69', NULL, NULL, NULL, NULL, 'PROTOCADHERIN BETA-7', 241480),
(322233, 'PTHR24028:SF68', NULL, NULL, NULL, NULL, 'PROTOCADHERIN ALPHA-11', 241480),
(322234, 'PTHR24028:SF107', NULL, NULL, NULL, NULL, 'PROTOCADHERIN GAMMA-A6', 241480),
(322235, 'PTHR24028:SF227', NULL, NULL, NULL, NULL, 'PROTOCADHERIN GAMMA-A12', 241480),
(322236, 'PTHR24028:SF106', NULL, NULL, NULL, NULL, 'PROTOCADHERIN GAMMA-B1', 241480),
(322237, 'PTHR24028:SF108', NULL, NULL, NULL, NULL, 'PROTOCADHERIN GAMMA-A1', 241480);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(322238, 'PTHR24028:SF61', NULL, NULL, NULL, NULL, 'PROTOCADHERIN BETA-8', 241480),
(322239, 'PTHR24028:SF60', NULL, NULL, NULL, NULL, 'PROTOCADHERIN ALPHA-2', 241480),
(322240, 'PTHR24028:SF66', NULL, NULL, NULL, NULL, 'PROTOCADHERIN GAMMA-B6', 241480),
(322241, 'PTHR24028:SF114', NULL, NULL, NULL, NULL, 'PROTOCADHERIN 1 GAMMA 1-RELATED', 241480),
(322242, 'PTHR24028:SF234', NULL, NULL, NULL, NULL, 'PROTOCADHERIN GAMMA-A3', 241480),
(322243, 'PTHR24028:SF113', NULL, NULL, NULL, NULL, 'PROTOCADHERIN GAMMA-B7', 241480),
(322244, 'PTHR24028:SF236', NULL, NULL, NULL, NULL, 'PROTOCADHERIN 1 GAMMA 22-RELATED', 241480),
(322245, 'PTHR24028:SF110', NULL, NULL, NULL, NULL, 'PROTOCADHERIN GAMMA-A10', 241480),
(322246, 'PTHR24028:SF111', NULL, NULL, NULL, NULL, 'PROTOCADHERIN ALPHA-5', 241480),
(322247, 'PTHR24028:SF239', NULL, NULL, NULL, NULL, 'PROTOCADHERIN BETA 9', 241480),
(322248, 'PTHR24028:SF118', NULL, NULL, NULL, NULL, 'PROTOCADHERIN BETA-1', 241480),
(322249, 'PTHR24028:SF117', NULL, NULL, NULL, NULL, 'PROTOCADHERIN GAMMA-B4', 241480),
(322250, 'PTHR24028:SF119', NULL, NULL, NULL, NULL, 'PROTOCADHERIN ALPHA-C2', 241480),
(322251, 'PTHR24028:SF32', NULL, NULL, NULL, NULL, 'PROTOCADHERIN 1 ALPHA 3-RELATED', 241480),
(322252, 'PTHR24028:SF124', NULL, NULL, NULL, NULL, 'PROTOCADHERIN ALPHA-10', 241480),
(322253, 'PTHR24028:SF248', NULL, NULL, NULL, NULL, 'PROTOCADHERIN-9', 241480),
(322254, 'PTHR24028:SF247', NULL, NULL, NULL, NULL, 'PROTOCADHERIN-1', 241480),
(322255, 'PTHR24028:SF241', NULL, NULL, NULL, NULL, 'PROTOCADHERIN 2 ALPHA A 1', 241480),
(322256, 'PTHR24028:SF244', NULL, NULL, NULL, NULL, 'PROTOCADHERIN 8', 241480),
(322257, 'PTHR24028:SF123', NULL, NULL, NULL, NULL, 'CADHERIN-RELATED FAMILY MEMBER 4', 241480),
(322258, 'PTHR24028:SF243', NULL, NULL, NULL, NULL, 'CADHERIN-RELATED FAMILY MEMBER 5', 241480),
(322259, 'PTHR24028:SF9', NULL, NULL, NULL, NULL, 'PROTOCADHERIN-18', 241480),
(322260, 'PTHR24028:SF46', NULL, NULL, NULL, NULL, 'PROTOCADHERIN-8', 241480),
(322261, 'PTHR24028:SF0', NULL, NULL, NULL, NULL, 'PROTOCADHERIN-10', 241480),
(322262, 'PTHR24028:SF128', NULL, NULL, NULL, NULL, 'PROTOCADHERIN BETA-9', 241480),
(322263, 'PTHR24028:SF1', NULL, NULL, NULL, NULL, 'CADHERIN-16', 241480),
(322264, 'PTHR24028:SF40', NULL, NULL, NULL, NULL, 'PROTOCADHERIN-19', 241480),
(322265, 'PTHR24028:SF42', NULL, NULL, NULL, NULL, 'PROTOCADHERIN-12', 241480),
(322266, 'PTHR24028:SF41', NULL, NULL, NULL, NULL, 'PROTOCADHERIN-17', 241480),
(322267, 'PTHR24028:SF259', NULL, NULL, NULL, NULL, 'PROTOCADHERIN GAMMA-B3-RELATED', 241480),
(322268, 'PTHR24028:SF253', NULL, NULL, NULL, NULL, 'PROTOCADHERIN-7', 241480),
(322269, 'PTHR24028:SF134', NULL, NULL, NULL, NULL, 'PROTOCADHERIN GAMMA-A2', 241480),
(322270, 'PTHR24028:SF255', NULL, NULL, NULL, NULL, 'PROTOCADHERIN ALPHA-9', 241480),
(322271, 'PTHR24028:SF133', NULL, NULL, NULL, NULL, 'PROTOCADHERIN ALPHA-4', 241480),
(322272, 'PTHR24028:SF254', NULL, NULL, NULL, NULL, 'PROTOCADHERIN-11 X-LINKED', 241480),
(322273, 'PTHR24028:SF139', NULL, NULL, NULL, NULL, 'PROTOCADHERIN BETA-14', 241480),
(322274, 'PTHR24028:SF95', NULL, NULL, NULL, NULL, 'PROTOCADHERIN BETA 12', 241480),
(322275, 'PTHR24028:SF94', NULL, NULL, NULL, NULL, 'PROTOCADHERIN GAMMA-A4', 241480),
(322276, 'PTHR24028:SF92', NULL, NULL, NULL, NULL, 'PROTOCADHERIN ALPHA-1', 241480),
(322277, 'PTHR24028:SF11', NULL, NULL, NULL, NULL, 'PROTOCADHERIN-15', 241480),
(322278, 'PTHR24028:SF98', NULL, NULL, NULL, NULL, 'PROTOCADHERIN BETA-18-RELATED', 241480),
(322279, 'PTHR24028:SF97', NULL, NULL, NULL, NULL, 'PROTOCADHERIN BETA-15', 241480),
(322280, 'PTHR24028:SF260', NULL, NULL, NULL, NULL, 'PROTOCADHERIN-20', 241480),
(322281, 'PTHR24028:SF262', NULL, NULL, NULL, NULL, 'CADHERIN-RELATED FAMILY MEMBER 3', 241480),
(322282, 'PTHR24028:SF261', NULL, NULL, NULL, NULL, 'PROTOCADHERIN 7A', 241480),
(322283, 'PTHR24028:SF146', NULL, NULL, NULL, NULL, 'CADHERIN 88C-RELATED', 241480),
(322284, 'PTHR24028:SF303', NULL, NULL, NULL, NULL, 'PROTOCADHERIN ALPHA-10', 241480),
(322285, 'PTHR24028:SF302', NULL, NULL, NULL, NULL, 'PROTOCADHERIN BETA-3', 241480);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(322286, 'PTHR24028:SF148', NULL, NULL, NULL, NULL, 'PROTOCADHERIN BETA 7', 241480),
(322287, 'PTHR24028:SF264', NULL, NULL, NULL, NULL, 'PROTOCADHERIN 1 GAMMA 32', 241480),
(322288, 'PTHR24028:SF263', NULL, NULL, NULL, NULL, 'CADHERIN-RELATED FAMILY MEMBER 1', 241480),
(322289, 'PTHR24028:SF144', NULL, NULL, NULL, NULL, 'PROTOCADHERIN GAMMA-B2', 241480),
(322290, 'PTHR24028:SF308', NULL, NULL, NULL, NULL, 'PROTOCADHERIN BETA-6-RELATED', 241480),
(322291, 'PTHR24028:SF305', NULL, NULL, NULL, NULL, 'PROTOCADHERIN ALPHA-6-RELATED', 241480),
(322292, 'PTHR24028:SF304', NULL, NULL, NULL, NULL, '', 241480),
(322293, 'PTHR24028:SF307', NULL, NULL, NULL, NULL, 'SI:CH73-233F7.1', 241480),
(322294, 'PTHR24028:SF306', NULL, NULL, NULL, NULL, 'PROTOCADHERIN 18B', 241480),
(322295, 'PTHR43749', NULL, NULL, NULL, NULL, 'RNA-SPLICING LIGASE RTCB', 241481),
(322296, 'PTHR43749:SF2', NULL, NULL, NULL, NULL, 'RNA-SPLICING LIGASE RTCB', 241481),
(322297, 'PTHR11224:SF50', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241482),
(322298, 'PTHR11224:SF44', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 16', 241482),
(322299, 'PTHR11224:SF55', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241482),
(322300, 'PTHR11224:SF10', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241482),
(322301, 'PTHR11224:SF43', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE C3H69-RELATED', 241482),
(322302, 'PTHR11224:SF53', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MAKORIN-4-RELATED', 241482),
(322303, 'PTHR11224:SF42', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241482),
(322304, 'PTHR11224:SF37', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MAKORIN-1', 241482),
(322305, 'PTHR11224:SF47', NULL, NULL, NULL, NULL, '', 241482),
(322306, 'PTHR11224:SF46', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MAKORIN', 241482),
(322307, 'PTHR11224', NULL, NULL, NULL, NULL, 'MAKORIN-RELATED', 241482),
(322308, 'PTHR11224:SF56', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241482),
(322309, 'PTHR11224:SF45', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241482),
(322310, 'PTHR11224:SF39', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241482),
(322311, 'PTHR11224:SF17', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MAKORIN-2-RELATED', 241482),
(322312, 'PTHR11224:SF38', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MAKORIN-3-RELATED', 241482),
(322313, 'PTHR46139:SF1', NULL, NULL, NULL, NULL, 'ALKALINE CERAMIDASE 2', 241483),
(322314, 'PTHR46139:SF2', NULL, NULL, NULL, NULL, 'ALKALINE CERAMIDASE 1', 241483),
(322315, 'PTHR46139', NULL, NULL, NULL, NULL, 'ALKALINE CERAMIDASE', 241483),
(322316, 'PTHR46139:SF3', NULL, NULL, NULL, NULL, 'ALKALINE CERAMIDASE', 241483),
(322317, 'PTHR36389:SF1', NULL, NULL, NULL, NULL, 'OS05G0110100 PROTEIN', 241484),
(322318, 'PTHR36389', NULL, NULL, NULL, NULL, 'OS05G0110100 PROTEIN', 241484),
(322319, 'PTHR43128:SF29', NULL, NULL, NULL, NULL, 'L-LACTATE DEHYDROGENASE B CHAIN', 241485),
(322320, 'PTHR43128:SF18', NULL, NULL, NULL, NULL, 'L-LACTATE DEHYDROGENASE', 241485),
(322321, 'PTHR43128:SF19', NULL, NULL, NULL, NULL, '', 241485),
(322322, 'PTHR43128:SF16', NULL, NULL, NULL, NULL, 'L-LACTATE DEHYDROGENASE', 241485),
(322323, 'PTHR43128', NULL, NULL, NULL, NULL, 'L-2-HYDROXYCARBOXYLATE DEHYDROGENASE (NAD(P)(+))', 241485),
(322324, 'PTHR43128:SF17', NULL, NULL, NULL, NULL, '', 241485),
(322325, 'PTHR43128:SF28', NULL, NULL, NULL, NULL, 'L-LACTATE DEHYDROGENASE', 241485),
(322326, 'PTHR43128:SF2', NULL, NULL, NULL, NULL, 'L-LACTATE DEHYDROGENASE B CHAIN', 241485),
(322327, 'PTHR43128:SF10', NULL, NULL, NULL, NULL, 'L-LACTATE DEHYDROGENASE A CHAIN', 241485),
(322328, 'PTHR43128:SF21', NULL, NULL, NULL, NULL, 'L-LACTATE DEHYDROGENASE', 241485),
(322329, 'PTHR43128:SF32', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 VARIANT 3-LIKE', 241485),
(322330, 'PTHR43128:SF22', NULL, NULL, NULL, NULL, 'L-LACTATE DEHYDROGENASE-LIKE', 241485);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(322331, 'PTHR43128:SF30', NULL, NULL, NULL, NULL, 'L-LACTATE DEHYDROGENASE', 241485),
(322332, 'PTHR43128:SF31', NULL, NULL, NULL, NULL, 'L-LACTATE DEHYDROGENASE', 241485),
(322333, 'PTHR43128:SF14', NULL, NULL, NULL, NULL, 'L-LACTATE DEHYDROGENASE', 241485),
(322334, 'PTHR43128:SF15', NULL, NULL, NULL, NULL, 'L-LACTATE DEHYDROGENASE', 241485),
(322335, 'PTHR43128:SF26', NULL, NULL, NULL, NULL, 'L-LACTATE DEHYDROGENASE', 241485),
(322336, 'PTHR43128:SF23', NULL, NULL, NULL, NULL, 'L-LACTATE DEHYDROGENASE', 241485),
(322337, 'PTHR43128:SF24', NULL, NULL, NULL, NULL, 'LDH_1_N DOMAIN-CONTAINING PROTEIN', 241485),
(322338, 'PTHR43128:SF5', NULL, NULL, NULL, NULL, 'L-LACTATE DEHYDROGENASE C CHAIN', 241485),
(322339, 'PTHR43128:SF9', NULL, NULL, NULL, NULL, 'L-LACTATE DEHYDROGENASE A-LIKE 6A', 241485),
(322340, 'PTHR43128:SF8', NULL, NULL, NULL, NULL, 'L-LACTATE DEHYDROGENASE A-LIKE 6B', 241485),
(322341, 'PTHR11592:SF49', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE 1', 241486),
(322342, 'PTHR11592:SF27', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE 8-RELATED', 241486),
(322343, 'PTHR11592:SF119', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE 3, MITOCHONDRIAL-RELATED', 241486),
(322344, 'PTHR11592:SF40', NULL, NULL, NULL, NULL, 'THIOREDOXIN/GLUTATHIONE PEROXIDASE BTUE', 241486),
(322345, 'PTHR11592:SF41', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE 1', 241486),
(322346, 'PTHR11592:SF86', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE', 241486),
(322347, 'PTHR11592:SF116', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE', 241486),
(322348, 'PTHR11592:SF44', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE', 241486),
(322349, 'PTHR11592:SF88', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE-RELATED', 241486),
(322350, 'PTHR11592:SF115', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE', 241486),
(322351, 'PTHR11592:SF118', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID HYDROPEROXIDE GLUTATHIONE PEROXIDASE 6, MITOCHONDRIAL-RELATED', 241486),
(322352, 'PTHR11592:SF117', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE', 241486),
(322353, 'PTHR11592:SF133', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE', 241486),
(322354, 'PTHR11592:SF111', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE', 241486),
(322355, 'PTHR11592:SF114', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE', 241486),
(322356, 'PTHR11592:SF113', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE', 241486),
(322357, 'PTHR11592:SF130', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE', 241486),
(322358, 'PTHR11592', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE', 241486),
(322359, 'PTHR11592:SF132', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE 7, CHLOROPLASTIC-RELATED', 241486),
(322360, 'PTHR11592:SF81', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE', 241486),
(322361, 'PTHR11592:SF131', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE 4-RELATED', 241486),
(322362, 'PTHR11592:SF36', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE 2', 241486),
(322363, 'PTHR11592:SF15', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE 6', 241486),
(322364, 'PTHR11592:SF17', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE 5-RELATED', 241486),
(322365, 'PTHR11592:SF109', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE', 241486),
(322366, 'PTHR11592:SF94', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE', 241486),
(322367, 'PTHR11592:SF108', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE', 241486),
(322368, 'PTHR11592:SF51', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE', 241486),
(322369, 'PTHR11592:SF95', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE', 241486),
(322370, 'PTHR11592:SF96', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID HYDROPEROXIDE GLUTATHIONE PEROXIDASE ISOFORM X1-RELATED', 241486),
(322371, 'PTHR11592:SF75', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE', 241486),
(322372, 'PTHR11592:SF127', NULL, NULL, NULL, NULL, 'EPIDIDYMAL SECRETORY GLUTATHIONE PEROXIDASE', 241486),
(322373, 'PTHR11592:SF98', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE', 241486),
(322374, 'PTHR11592:SF32', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE 3', 241486);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(322375, 'PTHR11592:SF99', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID HYDROPEROXIDE GLUTATHIONE PEROXIDASE 1, CHLOROPLASTIC', 241486),
(322376, 'PTHR11592:SF78', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID HYDROPEROXIDE GLUTATHIONE PEROXIDASE', 241486),
(322377, 'PTHR11592:SF129', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE', 241486),
(322378, 'PTHR11592:SF2', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE 2', 241486),
(322379, 'PTHR11592:SF128', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE', 241486),
(322380, 'PTHR11592:SF106', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE', 241486),
(322381, 'PTHR11592:SF7', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE 8-RELATED', 241486),
(322382, 'PTHR11592:SF122', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE', 241486),
(322383, 'PTHR11592:SF5', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE 7', 241486),
(322384, 'PTHR11592:SF102', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE', 241486),
(322385, 'PTHR11592:SF92', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID HYDROPEROXIDE GLUTATHIONE PEROXIDASE-RELATED', 241486),
(322386, 'PTHR31638', NULL, NULL, NULL, NULL, 'DAZ-ASSOCIATED PROTEIN 2', 241487),
(322387, 'PTHR31638:SF3', NULL, NULL, NULL, NULL, 'DAZ-ASSOCIATED PROTEIN 2', 241487),
(322388, 'PTHR31638:SF4', NULL, NULL, NULL, NULL, 'DAZ-ASSOCIATED PROTEIN 2', 241487),
(322389, 'PTHR31638:SF5', NULL, NULL, NULL, NULL, 'DAZ-ASSOCIATED PROTEIN 2', 241487),
(322390, 'PTHR47194', NULL, NULL, NULL, NULL, 'SORTING NEXIN-29-RELATED', 241488),
(322391, 'PTHR47194:SF3', NULL, NULL, NULL, NULL, 'SORTING NEXIN 29', 241488),
(322392, 'PTHR47194:SF5', NULL, NULL, NULL, NULL, 'RUN DOMAIN-CONTAINING PROTEIN 1', 241488),
(322393, 'PTHR47194:SF4', NULL, NULL, NULL, NULL, 'SORTING NEXIN-29', 241488),
(322394, 'PTHR46636', NULL, NULL, NULL, NULL, 'CDK2-ASSOCIATED AND CULLIN DOMAIN-CONTAINING PROTEIN 1', 241489),
(322395, 'PTHR46636:SF1', NULL, NULL, NULL, NULL, 'CDK2-ASSOCIATED AND CULLIN DOMAIN-CONTAINING PROTEIN 1', 241489),
(322396, 'PTHR33747', NULL, NULL, NULL, NULL, 'UPF0225 PROTEIN SCO1677', 241490),
(322397, 'PTHR33747:SF1', NULL, NULL, NULL, NULL, 'CAP_C DOMAIN-CONTAINING PROTEIN', 241490),
(322398, 'PTHR33747:SF3', NULL, NULL, NULL, NULL, '', 241490),
(322399, 'PTHR33747:SF8', NULL, NULL, NULL, NULL, 'UPF0225 PROTEIN YCHJ', 241490),
(322400, 'PTHR13082:SF4', NULL, NULL, NULL, NULL, 'DEACETYLASE COMPLEX SUBUNIT SAP18, PUTATIVE-RELATED', 241491),
(322401, 'PTHR13082', NULL, NULL, NULL, NULL, 'SAP18', 241491),
(322402, 'PTHR13082:SF0', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE COMPLEX SUBUNIT SAP18', 241491),
(322403, 'PTHR13082:SF1', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE COMPLEX SUBUNIT SAP18', 241491),
(322404, 'PTHR13082:SF2', NULL, NULL, NULL, NULL, '', 241491),
(322405, 'PTHR12842:SF3', NULL, NULL, NULL, NULL, 'PROTEIN FAM114A2', 241492),
(322406, 'PTHR12842:SF4', NULL, NULL, NULL, NULL, 'PROTEIN NOXP20', 241492),
(322407, 'PTHR12842', NULL, NULL, NULL, NULL, 'FI01459P', 241492),
(322408, 'PTHR12842:SF6', NULL, NULL, NULL, NULL, 'FI01459P', 241492),
(322409, 'PTHR45958', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241493),
(322410, 'PTHR45958:SF8', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 44-LIKE', 241493),
(322411, 'PTHR45958:SF19', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241493),
(322412, 'PTHR45958:SF18', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN', 241493),
(322413, 'PTHR45958:SF6', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 43', 241493),
(322414, 'PTHR45958:SF17', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241493),
(322415, 'PTHR45958:SF7', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241493),
(322416, 'PTHR45958:SF16', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241493),
(322417, 'PTHR45958:SF4', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 42-RELATED', 241493),
(322418, 'PTHR45958:SF5', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241493),
(322419, 'PTHR45958:SF15', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241493);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(322420, 'PTHR45958:SF2', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241493),
(322421, 'PTHR45958:SF14', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241493),
(322422, 'PTHR45958:SF13', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 44', 241493),
(322423, 'PTHR45958:SF3', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 24', 241493),
(322424, 'PTHR45958:SF12', NULL, NULL, NULL, NULL, 'OS01G0948500 PROTEIN', 241493),
(322425, 'PTHR45958:SF11', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241493),
(322426, 'PTHR37698', NULL, NULL, NULL, NULL, 'PHOTOSYNTHETIC NDH SUBUNIT OF SUBCOMPLEX B 1, CHLOROPLASTIC', 241494),
(322427, 'PTHR37698:SF1', NULL, NULL, NULL, NULL, 'PHOTOSYNTHETIC NDH SUBUNIT OF SUBCOMPLEX B 1, CHLOROPLASTIC', 241494),
(322428, 'PTHR30161:SF1', NULL, NULL, NULL, NULL, 'FLAGELLAR BIOSYNTHESIS PROTEIN FLHA-RELATED', 241495),
(322429, 'PTHR30161:SF2', NULL, NULL, NULL, NULL, 'INVASION PROTEIN INVA', 241495),
(322430, 'PTHR30161:SF3', NULL, NULL, NULL, NULL, 'SECRETION SYSTEM APPARATUS PROTEIN SSAV', 241495),
(322431, 'PTHR30161', NULL, NULL, NULL, NULL, 'FLAGELLAR EXPORT PROTEIN, MEMBRANE FLHA SUBUNIT-RELATED', 241495),
(322432, 'PTHR46744', NULL, NULL, NULL, NULL, 'PROTEIN UNC-93 HOMOLOG B1', 241496),
(322433, 'PTHR46744:SF1', NULL, NULL, NULL, NULL, 'PROTEIN UNC-93 HOMOLOG B1', 241496),
(322434, 'PTHR11417:SF29', NULL, NULL, NULL, NULL, 'PROLACTIN-7C1', 241497),
(322435, 'PTHR11417:SF69', NULL, NULL, NULL, NULL, 'PROLACTIN-8A6-RELATED', 241497),
(322436, 'PTHR11417:SF67', NULL, NULL, NULL, NULL, 'CHORIONIC SOMATOMAMMOTROPIN HORMONE 1-RELATED', 241497),
(322437, 'PTHR11417', NULL, NULL, NULL, NULL, 'SOMATOTROPIN,PROLACTIN', 241497),
(322438, 'PTHR11417:SF31', NULL, NULL, NULL, NULL, 'GROWTH HORMONE D5-RELATED', 241497),
(322439, 'PTHR11417:SF71', NULL, NULL, NULL, NULL, 'PROLACTIN-8A9', 241497),
(322440, 'PTHR11417:SF70', NULL, NULL, NULL, NULL, '', 241497),
(322441, 'PTHR11417:SF37', NULL, NULL, NULL, NULL, 'PROLACTIN-3B1', 241497),
(322442, 'PTHR11417:SF17', NULL, NULL, NULL, NULL, 'PROLACTIN-7B1', 241497),
(322443, 'PTHR11417:SF39', NULL, NULL, NULL, NULL, 'GROWTH HORMONE D22-RELATED', 241497),
(322444, 'PTHR11417:SF16', NULL, NULL, NULL, NULL, 'DECIDUAL PRL-RELATED PROTEIN-RELATED', 241497),
(322445, 'PTHR11417:SF33', NULL, NULL, NULL, NULL, 'PROLACTIN 2', 241497),
(322446, 'PTHR11417:SF11', NULL, NULL, NULL, NULL, 'PROLACTIN-4A1', 241497),
(322447, 'PTHR11417:SF10', NULL, NULL, NULL, NULL, 'PROLACTIN-6A1', 241497),
(322448, 'PTHR11417:SF13', NULL, NULL, NULL, NULL, 'GROWTH HORMONE D9', 241497),
(322449, 'PTHR11417:SF35', NULL, NULL, NULL, NULL, 'PROLACTIN-2B1', 241497),
(322450, 'PTHR11417:SF34', NULL, NULL, NULL, NULL, 'PROLACTIN-3C1', 241497),
(322451, 'PTHR11417:SF12', NULL, NULL, NULL, NULL, 'PROLACTIN-2A1', 241497),
(322452, 'PTHR11417:SF40', NULL, NULL, NULL, NULL, 'GROWTH HORMONE VARIANT', 241497),
(322453, 'PTHR11417:SF20', NULL, NULL, NULL, NULL, 'PROLACTIN-7D1', 241497),
(322454, 'PTHR11417:SF9', NULL, NULL, NULL, NULL, 'PROLACTIN-7A1-RELATED', 241497),
(322455, 'PTHR11417:SF3', NULL, NULL, NULL, NULL, 'SOMATOLACTIN ALPHA-RELATED', 241497),
(322456, 'PTHR11417:SF2', NULL, NULL, NULL, NULL, 'SOMATOTROPIN', 241497),
(322457, 'PTHR11417:SF7', NULL, NULL, NULL, NULL, 'PROLACTIN-5A1', 241497),
(322458, 'PTHR11417:SF5', NULL, NULL, NULL, NULL, 'PROLACTIN', 241497),
(322459, 'PTHR42068', NULL, NULL, NULL, NULL, 'YALI0B18964P', 241498),
(322460, 'PTHR42068:SF1', NULL, NULL, NULL, NULL, 'YALI0B18964P', 241498),
(322461, 'PTHR45732:SF9', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 8A', 241499),
(322462, 'PTHR45732:SF8', NULL, NULL, NULL, NULL, '', 241499),
(322463, 'PTHR45732:SF7', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 8', 241499),
(322464, 'PTHR45732:SF12', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 8C', 241499),
(322465, 'PTHR45732:SF15', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 8B', 241499),
(322466, 'PTHR45732:SF14', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 8A-RELATED', 241499);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(322467, 'PTHR45732:SF13', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 8B', 241499),
(322468, 'PTHR45732:SF19', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 8C', 241499),
(322469, 'PTHR45732:SF18', NULL, NULL, NULL, NULL, 'BNAA09G07300D PROTEIN', 241499),
(322470, 'PTHR45732', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 8', 241499),
(322471, 'PTHR45732:SF17', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 8A-RELATED', 241499),
(322472, 'PTHR45732:SF1', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 8B', 241499),
(322473, 'PTHR45732:SF4', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 8A', 241499),
(322474, 'PTHR45732:SF2', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR LIKE PROTEIN', 241499),
(322475, 'PTHR11135', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE-RELATED', 241500),
(322476, 'PTHR11135:SF7', NULL, NULL, NULL, NULL, 'TRNA URIDINE(34) ACETYLTRANSFERASE', 241500),
(322477, 'PTHR11135:SF2', NULL, NULL, NULL, NULL, 'ELONGATOR COMPLEX PROTEIN 3', 241500),
(322478, 'PTHR11135:SF3', NULL, NULL, NULL, NULL, 'ELONGATOR COMPLEX PROTEIN 3', 241500),
(322479, 'PTHR11135:SF0', NULL, NULL, NULL, NULL, 'ELONGATOR COMPLEX PROTEIN 3', 241500),
(322480, 'PTHR11135:SF1', NULL, NULL, NULL, NULL, 'PROTEIN YHCC', 241500),
(322481, 'PTHR15885:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 174', 241501),
(322482, 'PTHR15885', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 241501),
(322483, 'PTHR31759:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 167', 241502),
(322484, 'PTHR31759', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 167', 241502),
(322485, 'PTHR12357:SF9', NULL, NULL, NULL, NULL, 'YTH DOMAIN-CONTAINING FAMILY PROTEIN 3', 241503),
(322486, 'PTHR12357:SF107', NULL, NULL, NULL, NULL, 'EVOLUTIONARILY CARBOXY-TERMINAL REGION PROTEIN', 241503),
(322487, 'PTHR12357:SF95', NULL, NULL, NULL, NULL, 'OS04G0129300 PROTEIN', 241503),
(322488, 'PTHR12357:SF92', NULL, NULL, NULL, NULL, 'YTH DOMAIN-CONTAINING PROTEIN', 241503),
(322489, 'PTHR12357:SF8', NULL, NULL, NULL, NULL, 'YTH DOMAIN-CONTAINING FAMILY PROTEIN 2', 241503),
(322490, 'PTHR12357:SF71', NULL, NULL, NULL, NULL, 'YTH DOMAIN-CONTAINING PROTEIN', 241503),
(322491, 'PTHR12357:SF109', NULL, NULL, NULL, NULL, 'YTH DOMAIN-CONTAINING PROTEIN', 241503),
(322492, 'PTHR12357:SF93', NULL, NULL, NULL, NULL, 'YTH DOMAIN-CONTAINING PROTEIN ECT3', 241503),
(322493, 'PTHR12357:SF98', NULL, NULL, NULL, NULL, 'YTH DOMAIN-CONTAINING PROTEIN', 241503),
(322494, 'PTHR12357:SF77', NULL, NULL, NULL, NULL, 'EVOLUTIONARILY CONSERVED C-TERMINAL REGION 10', 241503),
(322495, 'PTHR12357:SF99', NULL, NULL, NULL, NULL, 'YTH DOMAIN-CONTAINING PROTEIN ECT2-RELATED', 241503),
(322496, 'PTHR12357:SF74', NULL, NULL, NULL, NULL, 'YTH DOMAIN-CONTAINING PROTEIN', 241503),
(322497, 'PTHR12357:SF30', NULL, NULL, NULL, NULL, 'OS03G0158500 PROTEIN', 241503),
(322498, 'PTHR12357:SF120', NULL, NULL, NULL, NULL, 'EVOLUTIONARILY CONSERVED C-TERMINAL REGION 5-LIKE PROTEIN ISOFORM 1', 241503),
(322499, 'PTHR12357:SF121', NULL, NULL, NULL, NULL, 'OS03G0317000 PROTEIN', 241503),
(322500, 'PTHR12357:SF122', NULL, NULL, NULL, NULL, 'YTH DOMAIN-CONTAINING PROTEIN', 241503),
(322501, 'PTHR12357:SF100', NULL, NULL, NULL, NULL, 'YTH DOMAIN-CONTAINING PROTEIN', 241503),
(322502, 'PTHR12357:SF123', NULL, NULL, NULL, NULL, 'YTH DOMAIN-CONTAINING PROTEIN ECT1', 241503),
(322503, 'PTHR12357:SF101', NULL, NULL, NULL, NULL, 'YTH DOMAIN-CONTAINING PROTEIN', 241503),
(322504, 'PTHR12357:SF124', NULL, NULL, NULL, NULL, 'EVOLUTIONARILY CONSERVED C-TERMINAL REGION 5', 241503),
(322505, 'PTHR12357:SF103', NULL, NULL, NULL, NULL, 'YTH DOMAIN-CONTAINING PROTEIN', 241503),
(322506, 'PTHR12357:SF125', NULL, NULL, NULL, NULL, 'YTH DOMAIN-CONTAINING PROTEIN', 241503),
(322507, 'PTHR12357:SF3', NULL, NULL, NULL, NULL, 'YTH DOMAIN-CONTAINING PROTEIN 1', 241503),
(322508, 'PTHR12357:SF89', NULL, NULL, NULL, NULL, 'YTH DOMAIN-CONTAINING FAMILY PROTEIN', 241503);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(322509, 'PTHR12357:SF67', NULL, NULL, NULL, NULL, 'OS07G0170300 PROTEIN', 241503),
(322510, 'PTHR12357:SF118', NULL, NULL, NULL, NULL, 'YTH DOMAIN-CONTAINING PROTEIN', 241503),
(322511, 'PTHR12357:SF84', NULL, NULL, NULL, NULL, 'EVOLUTIONARILY CARBOXY-TERMINAL REGION PROTEIN', 241503),
(322512, 'PTHR12357:SF119', NULL, NULL, NULL, NULL, '30-KDA CLEAVAGE AND POLYADENYLATION SPECIFICITY FACTOR 30', 241503),
(322513, 'PTHR12357:SF82', NULL, NULL, NULL, NULL, 'YTH DOMAIN-CONTAINING PROTEIN', 241503),
(322514, 'PTHR12357:SF65', NULL, NULL, NULL, NULL, 'YTH DOMAIN-CONTAINING FAMILY PROTEIN 1', 241503),
(322515, 'PTHR12357:SF88', NULL, NULL, NULL, NULL, 'OS01G0329800 PROTEIN', 241503),
(322516, 'PTHR12357:SF86', NULL, NULL, NULL, NULL, 'EVOLUTIONARILY CONSERVED C-TERMINAL REGION 10', 241503),
(322517, 'PTHR12357:SF64', NULL, NULL, NULL, NULL, 'OS08G0224200 PROTEIN', 241503),
(322518, 'PTHR12357:SF111', NULL, NULL, NULL, NULL, 'EVOLUTIONARILY CONSERVED C-TERMINAL REGION 11', 241503),
(322519, 'PTHR12357:SF90', NULL, NULL, NULL, NULL, 'YTH DOMAIN-CONTAINING PROTEIN', 241503),
(322520, 'PTHR12357:SF114', NULL, NULL, NULL, NULL, '30-KDA CLEAVAGE AND POLYADENYLATION SPECIFICITY FACTOR 30-LIKE', 241503),
(322521, 'PTHR12357', NULL, NULL, NULL, NULL, 'YTH  YT521-B HOMOLOGY  DOMAIN-CONTAINING', 241503),
(322522, 'PTHR31660:SF76', NULL, NULL, NULL, NULL, 'CORE-BINDING (CB) DOMAIN-CONTAINING PROTEIN-RELATED', 241504),
(322523, 'PTHR31660:SF79', NULL, NULL, NULL, NULL, 'TYR RECOMBINASE DOMAIN-CONTAINING PROTEIN', 241504),
(322524, 'PTHR31660', NULL, NULL, NULL, NULL, 'GAG-POL POLYPROTEIN-LIKE PROTEIN-RELATED', 241504),
(322525, 'PTHR46688:SF1', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 16', 241505),
(322526, 'PTHR46688', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 16', 241505),
(322527, 'PTHR43320', NULL, NULL, NULL, NULL, 'SUGAR KINASE', 241506),
(322528, 'PTHR43320:SF3', NULL, NULL, NULL, NULL, 'PFKB DOMAIN-CONTAINING PROTEIN', 241506),
(322529, 'PTHR43320:SF2', NULL, NULL, NULL, NULL, '2-DEHYDRO-3-DEOXYGLUCONOKINASE/2-DEHYDRO-3-DEOXYGALACTONOKINASE', 241506),
(322530, 'PTHR43320:SF1', NULL, NULL, NULL, NULL, 'OS01G0105900 PROTEIN', 241506),
(322531, 'PTHR46115:SF1', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE PROTEIN 1', 241507),
(322532, 'PTHR46115:SF4', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 241507),
(322533, 'PTHR46115', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE PROTEIN 1', 241507),
(322534, 'PTHR38593', NULL, NULL, NULL, NULL, 'BLR2558 PROTEIN', 241508),
(322535, 'PTHR38593:SF1', NULL, NULL, NULL, NULL, 'BLR2558 PROTEIN', 241508),
(322536, 'PTHR34835:SF50', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 241509),
(322537, 'PTHR34835:SF72', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 241509),
(322538, 'PTHR34835:SF9', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 241509),
(322539, 'PTHR34835:SF71', NULL, NULL, NULL, NULL, 'OS06G0475900 PROTEIN', 241509),
(322540, 'PTHR34835:SF52', NULL, NULL, NULL, NULL, 'OS08G0555500 PROTEIN', 241509),
(322541, 'PTHR34835:SF74', NULL, NULL, NULL, NULL, '', 241509),
(322542, 'PTHR34835:SF73', NULL, NULL, NULL, NULL, '', 241509),
(322543, 'PTHR34835:SF70', NULL, NULL, NULL, NULL, '', 241509),
(322544, 'PTHR34835:SF69', NULL, NULL, NULL, NULL, 'PHD DOMAIN-CONTAINING PROTEIN', 241509),
(322545, 'PTHR34835:SF68', NULL, NULL, NULL, NULL, '', 241509),
(322546, 'PTHR34835', NULL, NULL, NULL, NULL, 'OS07G0283600 PROTEIN-RELATED', 241509),
(322547, 'PTHR34835:SF43', NULL, NULL, NULL, NULL, 'OS01G0152500 PROTEIN', 241509),
(322548, 'PTHR34835:SF65', NULL, NULL, NULL, NULL, 'OS09G0105200 PROTEIN', 241509),
(322549, 'PTHR34835:SF64', NULL, NULL, NULL, NULL, '', 241509),
(322550, 'PTHR34835:SF67', NULL, NULL, NULL, NULL, 'FAR1 DOMAIN-CONTAINING PROTEIN', 241509),
(322551, 'PTHR34835:SF66', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 241509),
(322552, 'PTHR34835:SF61', NULL, NULL, NULL, NULL, 'OS04G0133200 PROTEIN', 241509),
(322553, 'PTHR34835:SF60', NULL, NULL, NULL, NULL, 'OS01G0826651 PROTEIN', 241509);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(322554, 'PTHR34835:SF63', NULL, NULL, NULL, NULL, '', 241509),
(322555, 'PTHR34835:SF62', NULL, NULL, NULL, NULL, '', 241509),
(322556, 'PTHR34835:SF14', NULL, NULL, NULL, NULL, 'PMD DOMAIN-CONTAINING PROTEIN', 241509),
(322557, 'PTHR34835:SF57', NULL, NULL, NULL, NULL, 'OS02G0622900 PROTEIN', 241509),
(322558, 'PTHR34835:SF79', NULL, NULL, NULL, NULL, 'DUF1985 DOMAIN-CONTAINING PROTEIN', 241509),
(322559, 'PTHR34835:SF37', NULL, NULL, NULL, NULL, 'OS07G0283600 PROTEIN', 241509),
(322560, 'PTHR34835:SF59', NULL, NULL, NULL, NULL, '', 241509),
(322561, 'PTHR34835:SF54', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 241509),
(322562, 'PTHR34835:SF76', NULL, NULL, NULL, NULL, '', 241509),
(322563, 'PTHR34835:SF75', NULL, NULL, NULL, NULL, '', 241509),
(322564, 'PTHR34835:SF34', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 241509),
(322565, 'PTHR34835:SF78', NULL, NULL, NULL, NULL, '', 241509),
(322566, 'PTHR34835:SF77', NULL, NULL, NULL, NULL, 'OS08G0365200 PROTEIN', 241509),
(322567, 'PTHR34835:SF11', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 241509),
(322568, 'PTHR34835:SF33', NULL, NULL, NULL, NULL, '', 241509),
(322569, 'PTHR42959', NULL, NULL, NULL, NULL, 'CARBAMOYLTRANSFERASE', 241510),
(322570, 'PTHR42959:SF1', NULL, NULL, NULL, NULL, 'CARBAMOYLTRANSFERASE HYPF', 241510),
(322571, 'PTHR42053', NULL, NULL, NULL, NULL, '', 241511),
(322572, 'PTHR42053:SF1', NULL, NULL, NULL, NULL, '', 241511),
(322573, 'PTHR42053:SF2', NULL, NULL, NULL, NULL, '', 241511),
(322574, 'PTHR47535:SF8', NULL, NULL, NULL, NULL, 'SI:CH211-207I1.2-RELATED', 241512),
(322575, 'PTHR47535:SF7', NULL, NULL, NULL, NULL, 'CALMIN', 241512),
(322576, 'PTHR47535:SF2', NULL, NULL, NULL, NULL, 'NESPRIN-3', 241512),
(322577, 'PTHR47535:SF1', NULL, NULL, NULL, NULL, 'MUSCLE-SPECIFIC PROTEIN 300 KDA, ISOFORM G', 241512),
(322578, 'PTHR47535', NULL, NULL, NULL, NULL, 'MUSCLE-SPECIFIC PROTEIN 300 KDA, ISOFORM G', 241512),
(322579, 'PTHR42891', NULL, NULL, NULL, NULL, 'D-GLYCERO-BETA-D-MANNO-HEPTOSE-1,7-BISPHOSPHATE 7-PHOSPHATASE', 241513),
(322580, 'PTHR42891:SF1', NULL, NULL, NULL, NULL, 'D-GLYCERO-BETA-D-MANNO-HEPTOSE-1,7-BISPHOSPHATE 7-PHOSPHATASE', 241513),
(322581, 'PTHR21308:SF2', NULL, NULL, NULL, NULL, 'ZGC:174917', 241514),
(322582, 'PTHR21308:SF1', NULL, NULL, NULL, NULL, 'PHYTANOYL-COA DIOXYGENASE, PEROXISOMAL', 241514),
(322583, 'PTHR21308', NULL, NULL, NULL, NULL, 'PHYTANOYL-COA ALPHA-HYDROXYLASE', 241514),
(322584, 'PTHR21308:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG00368', 241514),
(322585, 'PTHR21308:SF8', NULL, NULL, NULL, NULL, 'PHYTANOYL-COA DIOXYGENASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_2G09620)', 241514),
(322586, 'PTHR30367', NULL, NULL, NULL, NULL, 'P-HYDROXYBENZOIC ACID EFFLUX PUMP SUBUNIT AAEA-RELATED', 241515),
(322587, 'PTHR30367:SF6', NULL, NULL, NULL, NULL, 'SECRETION PROTEIN-RELATED', 241515),
(322588, 'PTHR30367:SF1', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN MDTN', 241515),
(322589, 'PTHR30367:SF13', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE EFFLUX PUMP-RELATED', 241515),
(322590, 'PTHR30367:SF12', NULL, NULL, NULL, NULL, 'P-HYDROXYBENZOIC ACID EFFLUX PUMP SUBUNIT AAEA', 241515),
(322591, 'PTHR22529', NULL, NULL, NULL, NULL, 'EPITHELIAL-STROMAL INTERACTION PROTEIN 1', 241516),
(322592, 'PTHR22529:SF1', NULL, NULL, NULL, NULL, 'EPITHELIAL-STROMAL INTERACTION PROTEIN 1', 241516),
(322593, 'PTHR22529:SF2', NULL, NULL, NULL, NULL, 'ZGC:194621', 241516),
(322594, 'PTHR42252', NULL, NULL, NULL, NULL, 'DUF5616 DOMAIN-CONTAINING PROTEIN', 241517),
(322595, 'PTHR42252:SF1', NULL, NULL, NULL, NULL, 'DUF5616 DOMAIN-CONTAINING PROTEIN', 241517),
(322596, 'PTHR34370', NULL, NULL, NULL, NULL, 'OS04G0600100 PROTEIN', 241518),
(322597, 'PTHR34370:SF1', NULL, NULL, NULL, NULL, 'OS04G0600100 PROTEIN', 241518),
(322598, 'PTHR34370:SF2', NULL, NULL, NULL, NULL, 'GAG-POL POLYPROTEIN/RETROTRANSPOSON', 241518),
(322599, 'PTHR47869', NULL, NULL, NULL, NULL, 'OS03G0410700 PROTEIN', 241519),
(322600, 'PTHR47869:SF2', NULL, NULL, NULL, NULL, 'OS03G0410700 PROTEIN', 241519);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(322601, 'PTHR43977:SF4', NULL, NULL, NULL, NULL, 'SMC HINGE DOMAIN-CONTAINING PROTEIN', 241520),
(322602, 'PTHR43977', NULL, NULL, NULL, NULL, 'STRUCTURAL MAINTENANCE OF CHROMOSOMES PROTEIN 3', 241520),
(322603, 'PTHR43977:SF2', NULL, NULL, NULL, NULL, 'STRUCTURAL MAINTENANCE OF CHROMOSOMES PROTEIN', 241520),
(322604, 'PTHR43977:SF1', NULL, NULL, NULL, NULL, 'STRUCTURAL MAINTENANCE OF CHROMOSOMES PROTEIN 3', 241520),
(322605, 'PTHR21286:SF0', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP160', 241521),
(322606, 'PTHR21286', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP160', 241521),
(322607, 'PTHR30535:SF7', NULL, NULL, NULL, NULL, 'IRON(III) DICITRATE-BINDING PROTEIN-RELATED', 241522),
(322608, 'PTHR30535:SF33', NULL, NULL, NULL, NULL, 'PERIPLASMIC BINDING PROTEIN', 241522),
(322609, 'PTHR30535:SF34', NULL, NULL, NULL, NULL, 'MOLYBDATE-BINDING PROTEIN MOLA', 241522),
(322610, 'PTHR30535:SF35', NULL, NULL, NULL, NULL, 'PERIPLASMIC BINDING PROTEIN', 241522),
(322611, 'PTHR30535', NULL, NULL, NULL, NULL, 'VITAMIN B12-BINDING PROTEIN', 241522),
(322612, 'PTHR30535:SF4', NULL, NULL, NULL, NULL, 'HEMIN-BINDING PERIPLASMIC PROTEIN HMUT', 241522),
(322613, 'PTHR30535:SF36', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY HEME UPTAKE SYSTEM PROTEIN ISDE', 241522),
(322614, 'PTHR33442:SF5', NULL, NULL, NULL, NULL, 'TRANS-3-HYDROXY-L-PROLINE DEHYDRATASE-RELATED', 241523),
(322615, 'PTHR33442:SF1', NULL, NULL, NULL, NULL, 'TRANS-3-HYDROXY-L-PROLINE DEHYDRATASE', 241523),
(322616, 'PTHR33442', NULL, NULL, NULL, NULL, 'TRANS-3-HYDROXY-L-PROLINE DEHYDRATASE', 241523),
(322617, 'PTHR43091', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE', 241524),
(322618, 'PTHR43091:SF2', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE 3 PROTEIN 2', 241524),
(322619, 'PTHR43091:SF3', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE III, CHLOROPLASTIC-LIKE ISOFORM X1', 241524),
(322620, 'PTHR43091:SF4', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE 3-RELATED', 241524),
(322621, 'PTHR43091:SF1', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE III, CHLOROPLASTIC', 241524),
(322622, 'PTHR30480:SF15', NULL, NULL, NULL, NULL, 'BETA-HEXOSAMINIDASE LPQI', 241525),
(322623, 'PTHR30480:SF13', NULL, NULL, NULL, NULL, 'BETA-HEXOSAMINIDASE', 241525),
(322624, 'PTHR30480', NULL, NULL, NULL, NULL, 'BETA-HEXOSAMINIDASE-RELATED', 241525),
(322625, 'PTHR30480:SF14', NULL, NULL, NULL, NULL, 'HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G13770)-RELATED', 241525),
(322626, 'PTHR30480:SF8', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_8G04060)-RELATED', 241525),
(322627, 'PTHR30480:SF9', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 241525),
(322628, 'PTHR31382:SF5', NULL, NULL, NULL, NULL, 'SODIUM ION/PROTON EXCHANGER (EUROFUNG)', 241526),
(322629, 'PTHR31382:SF4', NULL, NULL, NULL, NULL, 'NA(+)/H(+) ANTIPORTER', 241526),
(322630, 'PTHR31382', NULL, NULL, NULL, NULL, 'NA(+)/H(+) ANTIPORTER', 241526),
(322631, 'PTHR31382:SF1', NULL, NULL, NULL, NULL, 'SODIUM ION/PROTON EXCHANGER (EUROFUNG)', 241526),
(322632, 'PTHR31382:SF3', NULL, NULL, NULL, NULL, 'SODIUM ION/PROTON EXCHANGER (EUROFUNG)', 241526),
(322633, 'PTHR31382:SF2', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 241526),
(322634, 'PTHR36177:SF1', NULL, NULL, NULL, NULL, '', 241527),
(322635, 'PTHR36177', NULL, NULL, NULL, NULL, '', 241527),
(322636, 'PTHR33022:SF18', NULL, NULL, NULL, NULL, 'DUF1985 DOMAIN-CONTAINING PROTEIN', 241528),
(322637, 'PTHR33022:SF19', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 241528),
(322638, 'PTHR33022:SF17', NULL, NULL, NULL, NULL, '', 241528),
(322639, 'PTHR33022:SF21', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 241528),
(322640, 'PTHR33022', NULL, NULL, NULL, NULL, 'DUF1985 DOMAIN-CONTAINING PROTEIN', 241528),
(322641, 'PTHR33022:SF22', NULL, NULL, NULL, NULL, '', 241528),
(322642, 'PTHR33022:SF20', NULL, NULL, NULL, NULL, 'DUF1985 DOMAIN-CONTAINING PROTEIN', 241528);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(322643, 'PTHR33022:SF25', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 241528),
(322644, 'PTHR33022:SF23', NULL, NULL, NULL, NULL, 'ULP1 PROTEASE FAMILY, C-TERMINAL CATALYTIC DOMAIN CONTAINING PROTEIN', 241528),
(322645, 'PTHR33022:SF13', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 241528),
(322646, 'PTHR33022:SF24', NULL, NULL, NULL, NULL, 'ULP1 PROTEASE FAMILY, C-TERMINAL CATALYTIC DOMAIN CONTAINING PROTEIN', 241528),
(322647, 'PTHR43024:SF1', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLMURAMOYL-TRIPEPTIDE--D-ALANYL-D-ALANINE LIGASE', 241529),
(322648, 'PTHR43024', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLMURAMOYL-TRIPEPTIDE--D-ALANYL-D-ALANINE LIGASE', 241529),
(322649, 'PTHR24057', NULL, NULL, NULL, NULL, 'GLYCOGEN SYNTHASE KINASE-3 ALPHA', 241530),
(322650, 'PTHR24057:SF41', NULL, NULL, NULL, NULL, 'SHAGGY-RELATED PROTEIN KINASE ALPHA', 241530),
(322651, 'PTHR24057:SF64', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 241530),
(322652, 'PTHR24057:SF20', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241530),
(322653, 'PTHR24057:SF42', NULL, NULL, NULL, NULL, 'SHAGGY-RELATED PROTEIN KINASE ETA', 241530),
(322654, 'PTHR24057:SF43', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 241530),
(322655, 'PTHR24057:SF66', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 241530),
(322656, 'PTHR24057:SF67', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 241530),
(322657, 'PTHR24057:SF68', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 241530),
(322658, 'PTHR24057:SF69', NULL, NULL, NULL, NULL, 'SHAGGY-RELATED PROTEIN KINASE GAMMA', 241530),
(322659, 'PTHR24057:SF60', NULL, NULL, NULL, NULL, 'SHAGGY-RELATED PROTEIN KINASE THETA', 241530),
(322660, 'PTHR24057:SF40', NULL, NULL, NULL, NULL, 'SHAGGY-RELATED PROTEIN KINASE DELTA-RELATED', 241530),
(322661, 'PTHR24057:SF62', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 241530),
(322662, 'PTHR24057:SF8', NULL, NULL, NULL, NULL, 'GLYCOGEN SYNTHASE KINASE-3 BETA', 241530),
(322663, 'PTHR24057:SF5', NULL, NULL, NULL, NULL, 'SHAGGY-RELATED PROTEIN KINASE IOTA-RELATED', 241530),
(322664, 'PTHR24057:SF4', NULL, NULL, NULL, NULL, 'PROTEIN KINASE MCK1', 241530),
(322665, 'PTHR24057:SF38', NULL, NULL, NULL, NULL, 'SHAGGY-RELATED PROTEIN KINASE GSK4', 241530),
(322666, 'PTHR24057:SF18', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE R03D7.5-RELATED', 241530),
(322667, 'PTHR24057:SF0', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SHAGGY-RELATED', 241530),
(322668, 'PTHR24057:SF74', NULL, NULL, NULL, NULL, 'SHAGGY-RELATED PROTEIN KINASE GSK2', 241530),
(322669, 'PTHR24057:SF52', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 241530),
(322670, 'PTHR24057:SF75', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 241530),
(322671, 'PTHR24057:SF53', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 241530),
(322672, 'PTHR24057:SF76', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 241530),
(322673, 'PTHR24057:SF54', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 241530),
(322674, 'PTHR24057:SF55', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 241530),
(322675, 'PTHR24057:SF34', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 241530),
(322676, 'PTHR24057:SF56', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 241530),
(322677, 'PTHR24057:SF57', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 241530),
(322678, 'PTHR24057:SF36', NULL, NULL, NULL, NULL, 'SHAGGY-RELATED PROTEIN KINASE EPSILON', 241530),
(322679, 'PTHR24057:SF14', NULL, NULL, NULL, NULL, 'GLYCOGEN SYNTHASE KINASE-3 ALPHA', 241530),
(322680, 'PTHR24057:SF70', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 241530),
(322681, 'PTHR24057:SF71', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 241530);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(322682, 'PTHR24057:SF72', NULL, NULL, NULL, NULL, 'PROTEIN KINASE GSK31', 241530),
(322683, 'PTHR24057:SF73', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 241530),
(322684, 'PTHR24057:SF51', NULL, NULL, NULL, NULL, 'SHAGGY-RELATED PROTEIN KINASE BETA', 241530),
(322685, 'PTHR43311:SF1', NULL, NULL, NULL, NULL, 'GLUTAMYL-Q TRNA(ASP) SYNTHETASE', 241531),
(322686, 'PTHR43311:SF2', NULL, NULL, NULL, NULL, 'GLUTAMATE--TRNA LIGASE, MITOCHONDRIAL-RELATED', 241531),
(322687, 'PTHR43311', NULL, NULL, NULL, NULL, 'GLUTAMATE--TRNA LIGASE', 241531),
(322688, 'PTHR48061:SF2', NULL, NULL, NULL, NULL, 'OS12G0212366 PROTEIN', 241532),
(322689, 'PTHR48061:SF13', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241532),
(322690, 'PTHR48061:SF35', NULL, NULL, NULL, NULL, '', 241532),
(322691, 'PTHR48061:SF14', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241532),
(322692, 'PTHR48061:SF36', NULL, NULL, NULL, NULL, 'SERINE-THREONINE PROTEIN KINASE, PLANT-TYPE', 241532),
(322693, 'PTHR48061:SF34', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241532),
(322694, 'PTHR48061:SF12', NULL, NULL, NULL, NULL, 'VOC DOMAIN-CONTAINING PROTEIN', 241532),
(322695, 'PTHR48061:SF10', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241532),
(322696, 'PTHR48061:SF19', NULL, NULL, NULL, NULL, 'VERTICILLIUM WILT DISEASE RESISTANCE PROTEIN', 241532),
(322697, 'PTHR48061:SF39', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241532),
(322698, 'PTHR48061:SF18', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241532),
(322699, 'PTHR48061:SF37', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241532),
(322700, 'PTHR48061:SF16', NULL, NULL, NULL, NULL, 'CF-2.2', 241532),
(322701, 'PTHR48061:SF38', NULL, NULL, NULL, NULL, 'SMP-LTD DOMAIN-CONTAINING PROTEIN', 241532),
(322702, 'PTHR48061:SF46', NULL, NULL, NULL, NULL, 'BNAC07G06620D PROTEIN', 241532),
(322703, 'PTHR48061:SF44', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241532),
(322704, 'PTHR48061:SF23', NULL, NULL, NULL, NULL, 'VERTICILLIUM WILT RESISTANCE-LIKE PROTEIN', 241532),
(322705, 'PTHR48061', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR PROTEIN KINASE EMS1-LIKE-RELATED', 241532),
(322706, 'PTHR48061:SF45', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241532),
(322707, 'PTHR48061:SF20', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR PROTEIN KINASE MSP1-LIKE', 241532),
(322708, 'PTHR48061:SF42', NULL, NULL, NULL, NULL, 'HCR9-9E', 241532),
(322709, 'PTHR48061:SF43', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241532),
(322710, 'PTHR48061:SF40', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 7', 241532),
(322711, 'PTHR48061:SF41', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE LIKE PROTEIN', 241532),
(322712, 'PTHR48061:SF8', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241532),
(322713, 'PTHR48061:SF5', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN', 241532),
(322714, 'PTHR48061:SF29', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE FAMILY PROTEIN, PUTATIVE-RELATED', 241532),
(322715, 'PTHR13386', NULL, NULL, NULL, NULL, 'HISTONE PARYLATION FACTOR 1', 241533),
(322716, 'PTHR13386:SF3', NULL, NULL, NULL, NULL, 'HISTONE PARYLATION FACTOR 1-LIKE-RELATED', 241533),
(322717, 'PTHR13386:SF2', NULL, NULL, NULL, NULL, 'HISTONE PARYLATION FACTOR 1', 241533),
(322718, 'PTHR13386:SF1', NULL, NULL, NULL, NULL, 'HISTONE PARYLATION FACTOR 1', 241533),
(322719, 'PTHR10408:SF10', NULL, NULL, NULL, NULL, 'STEROL O-ACYLTRANSFERASE 2', 241534),
(322720, 'PTHR10408:SF21', NULL, NULL, NULL, NULL, 'O-ACYLTRANSFERASE', 241534),
(322721, 'PTHR10408:SF22', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE 1A', 241534),
(322722, 'PTHR10408:SF23', NULL, NULL, NULL, NULL, 'STEROL O-ACYLTRANSFERASE 1-RELATED', 241534),
(322723, 'PTHR10408:SF12', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE 1-1', 241534),
(322724, 'PTHR10408', NULL, NULL, NULL, NULL, 'STEROL O-ACYLTRANSFERASE', 241534);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(322725, 'PTHR10408:SF9', NULL, NULL, NULL, NULL, 'STEROL O-ACYLTRANSFERASE 2-RELATED', 241534),
(322726, 'PTHR10408:SF8', NULL, NULL, NULL, NULL, 'O-ACYLTRANSFERASE', 241534),
(322727, 'PTHR10408:SF7', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE 1', 241534),
(322728, 'PTHR10408:SF6', NULL, NULL, NULL, NULL, 'STEROL O-ACYLTRANSFERASE 1', 241534),
(322729, 'PTHR10408:SF16', NULL, NULL, NULL, NULL, 'O-ACYLTRANSFERASE', 241534),
(322730, 'PTHR10408:SF18', NULL, NULL, NULL, NULL, 'O-ACYLTRANSFERASE', 241534),
(322731, 'PTHR10408:SF19', NULL, NULL, NULL, NULL, 'O-ACYLTRANSFERASE', 241534),
(322732, 'PTHR30624', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN TLDD AND PMBA', 241535),
(322733, 'PTHR30624:SF11', NULL, NULL, NULL, NULL, 'ZINC-DEPENDENT PROTEASE, TLDD/PMBA FAMILY', 241535),
(322734, 'PTHR30624:SF10', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', 241535),
(322735, 'PTHR30624:SF0', NULL, NULL, NULL, NULL, 'METALLOPROTEASE SLR0863', 241535),
(322736, 'PTHR30624:SF4', NULL, NULL, NULL, NULL, 'METALLOPROTEASE TLDD', 241535),
(322737, 'PTHR22907:SF11', NULL, NULL, NULL, NULL, 'CUTICLIN-5', 241536),
(322738, 'PTHR22907:SF32', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 241536),
(322739, 'PTHR22907:SF54', NULL, NULL, NULL, NULL, 'GH04558P', 241536),
(322740, 'PTHR22907:SF53', NULL, NULL, NULL, NULL, 'CUTICLIN-LIKE', 241536),
(322741, 'PTHR22907:SF59', NULL, NULL, NULL, NULL, 'CUTICLIN-LIKE PROTEIN 19', 241536),
(322742, 'PTHR22907:SF15', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 241536),
(322743, 'PTHR22907:SF14', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 241536),
(322744, 'PTHR22907:SF9', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 241536),
(322745, 'PTHR22907:SF58', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 241536),
(322746, 'PTHR22907:SF57', NULL, NULL, NULL, NULL, 'CUTICLIN-4', 241536),
(322747, 'PTHR22907:SF13', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 241536),
(322748, 'PTHR22907:SF34', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 241536),
(322749, 'PTHR22907:SF12', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 241536),
(322750, 'PTHR22907:SF56', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN RAM-5', 241536),
(322751, 'PTHR22907:SF7', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 241536),
(322752, 'PTHR22907:SF51', NULL, NULL, NULL, NULL, 'CUTICLIN-3', 241536),
(322753, 'PTHR22907:SF1', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 241536),
(322754, 'PTHR22907:SF27', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 241536),
(322755, 'PTHR22907:SF26', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 241536),
(322756, 'PTHR22907:SF48', NULL, NULL, NULL, NULL, 'CUTICLIN-1', 241536),
(322757, 'PTHR22907:SF47', NULL, NULL, NULL, NULL, 'CUTICLIN-6', 241536),
(322758, 'PTHR22907:SF24', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 241536),
(322759, 'PTHR22907:SF46', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 241536),
(322760, 'PTHR22907:SF23', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 241536),
(322761, 'PTHR22907:SF40', NULL, NULL, NULL, NULL, 'DUMPY: SHORTER THAN WILD-TYPE', 241536),
(322762, 'PTHR22907', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 241536),
(322763, 'PTHR22907:SF17', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 241536),
(322764, 'PTHR22907:SF39', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 241536),
(322765, 'PTHR22907:SF16', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 241536),
(322766, 'PTHR30134:SF1', NULL, NULL, NULL, NULL, 'COBW DOMAIN-CONTAINING PROTEIN', 241537),
(322767, 'PTHR30134:SF2', NULL, NULL, NULL, NULL, 'HYDROGENASE MATURATION FACTOR HYPB', 241537),
(322768, 'PTHR30134', NULL, NULL, NULL, NULL, 'HYDROGENASE PROTEIN ASSEMBLY PROTEIN, NICKEL CHAPERONE', 241537),
(322769, 'PTHR31777', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 169', 241538),
(322770, 'PTHR31777:SF0', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 169', 241538),
(322771, 'PTHR31151:SF0', NULL, NULL, NULL, NULL, 'PROLINE-TRNA LIGASE (DUF1680)', 241539);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(322772, 'PTHR31151:SF3', NULL, NULL, NULL, NULL, 'OS02G0195500 PROTEIN', 241539),
(322773, 'PTHR31151', NULL, NULL, NULL, NULL, 'PROLINE-TRNA LIGASE (DUF1680)', 241539),
(322774, 'PTHR31151:SF5', NULL, NULL, NULL, NULL, '', 241539),
(322775, 'PTHR31151:SF6', NULL, NULL, NULL, NULL, '', 241539),
(322776, 'PTHR38585', NULL, NULL, NULL, NULL, '', 241540),
(322777, 'PTHR38585:SF1', NULL, NULL, NULL, NULL, '', 241540),
(322778, 'PTHR16199', NULL, NULL, NULL, NULL, 'CONDENSIN-2 COMPLEX SUBUNIT G2', 241541),
(322779, 'PTHR16199:SF4', NULL, NULL, NULL, NULL, 'CONDENSIN-2 COMPLEX SUBUNIT G2', 241541),
(322780, 'PTHR12202', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 241542),
(322781, 'PTHR12202:SF0', NULL, NULL, NULL, NULL, 'ESF1 HOMOLOG', 241542),
(322782, 'PTHR43569', NULL, NULL, NULL, NULL, 'AMIDOHYDROLASE', 241543),
(322783, 'PTHR43569:SF2', NULL, NULL, NULL, NULL, 'AMIDOHYDRO-REL DOMAIN-CONTAINING PROTEIN', 241543),
(322784, 'PTHR43569:SF1', NULL, NULL, NULL, NULL, 'BLL3371 PROTEIN', 241543),
(322785, 'PTHR48063:SF86', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241544),
(322786, 'PTHR48063:SF87', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE FAMILY PROTEIN', 241544),
(322787, 'PTHR48063:SF88', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE GSO1', 241544),
(322788, 'PTHR48063:SF44', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241544),
(322789, 'PTHR48063:SF45', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE GSO1', 241544),
(322790, 'PTHR48063:SF46', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241544),
(322791, 'PTHR48063:SF48', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE FLS2', 241544),
(322792, 'PTHR48063:SF3', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241544),
(322793, 'PTHR48063:SF4', NULL, NULL, NULL, NULL, 'OS01G0601675 PROTEIN', 241544),
(322794, 'PTHR48063:SF80', NULL, NULL, NULL, NULL, 'MDIS1-INTERACTING RECEPTOR LIKE KINASE 2-LIKE', 241544),
(322795, 'PTHR48063:SF81', NULL, NULL, NULL, NULL, 'RECEPTOR LIKE PROTEIN 30-LIKE', 241544),
(322796, 'PTHR48063:SF82', NULL, NULL, NULL, NULL, '', 241544),
(322797, 'PTHR48063:SF83', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241544),
(322798, 'PTHR48063:SF40', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241544),
(322799, 'PTHR48063:SF84', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE FLS2', 241544),
(322800, 'PTHR48063:SF85', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE GSO2', 241544),
(322801, 'PTHR48063:SF9', NULL, NULL, NULL, NULL, 'LRR PROTEIN WM1.10', 241544),
(322802, 'PTHR48063:SF55', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241544),
(322803, 'PTHR48063:SF11', NULL, NULL, NULL, NULL, 'OS01G0601625 PROTEIN', 241544),
(322804, 'PTHR48063:SF12', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 12', 241544),
(322805, 'PTHR48063:SF14', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241544),
(322806, 'PTHR48063:SF1', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241544),
(322807, 'PTHR48063:SF16', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE GSO1', 241544),
(322808, 'PTHR48063:SF19', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN, PLANT-TYPE-RELATED', 241544),
(322809, 'PTHR48063:SF50', NULL, NULL, NULL, NULL, 'OS01G0603500 PROTEIN', 241544),
(322810, 'PTHR48063:SF51', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241544),
(322811, 'PTHR48063:SF52', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE FAMILY PROTEIN', 241544),
(322812, 'PTHR48063:SF21', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241544),
(322813, 'PTHR48063:SF22', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241544),
(322814, 'PTHR48063:SF66', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241544),
(322815, 'PTHR48063:SF67', NULL, NULL, NULL, NULL, 'OS11G0564900 PROTEIN', 241544),
(322816, 'PTHR48063:SF68', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE-RELATED', 241544);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(322817, 'PTHR48063:SF24', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE FAMILY PROTEIN / LRR FAMILY PROTEIN', 241544),
(322818, 'PTHR48063:SF69', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE BRI1', 241544),
(322819, 'PTHR48063:SF28', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241544),
(322820, 'PTHR48063:SF29', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE-RELATED', 241544),
(322821, 'PTHR48063:SF63', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241544),
(322822, 'PTHR48063:SF75', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241544),
(322823, 'PTHR48063:SF31', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241544),
(322824, 'PTHR48063:SF76', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN EIX2', 241544),
(322825, 'PTHR48063:SF77', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241544),
(322826, 'PTHR48063:SF78', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241544),
(322827, 'PTHR48063:SF79', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241544),
(322828, 'PTHR48063:SF35', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241544),
(322829, 'PTHR48063:SF38', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241544),
(322830, 'PTHR48063', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE', 241544),
(322831, 'PTHR48063:SF70', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241544),
(322832, 'PTHR48063:SF71', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241544),
(322833, 'PTHR48063:SF72', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241544),
(322834, 'PTHR48063:SF73', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241544),
(322835, 'PTHR48063:SF30', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241544),
(322836, 'PTHR48063:SF74', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 241544),
(322837, 'PTHR14738:SF32', NULL, NULL, NULL, NULL, 'RNA BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 241545),
(322838, 'PTHR14738:SF36', NULL, NULL, NULL, NULL, 'RNA BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 241545),
(322839, 'PTHR14738', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 14', 241545),
(322840, 'PTHR14738:SF37', NULL, NULL, NULL, NULL, 'PWI DOMAIN-CONTAINING PROTEIN', 241545),
(322841, 'PTHR14738:SF29', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 14', 241545),
(322842, 'PTHR22014:SF2', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 33', 241546),
(322843, 'PTHR22014', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 33', 241546),
(322844, 'PTHR21650:SF2', NULL, NULL, NULL, NULL, 'KINETOCHORE PROTEIN NUF2', 241547),
(322845, 'PTHR21650:SF4', NULL, NULL, NULL, NULL, 'MEMBRALIN', 241547),
(322846, 'PTHR21650', NULL, NULL, NULL, NULL, 'MEMBRALIN/KINETOCHORE PROTEIN NUF2', 241547),
(322847, 'PTHR39383', NULL, NULL, NULL, NULL, 'PROTEIN CBG16996', 241548),
(322848, 'PTHR39383:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG16996', 241548),
(322849, 'PTHR33491', NULL, NULL, NULL, NULL, 'OSJNBA0016N04.9 PROTEIN', 241549),
(322850, 'PTHR33491:SF19', NULL, NULL, NULL, NULL, 'OS10G0162840 PROTEIN', 241549),
(322851, 'PTHR33491:SF49', NULL, NULL, NULL, NULL, 'OS12G0266200 PROTEIN', 241549),
(322852, 'PTHR33491:SF39', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE-LIKE PROTEIN', 241549),
(322853, 'PTHR33491:SF47', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE 2-LIKE', 241549),
(322854, 'PTHR33491:SF25', NULL, NULL, NULL, NULL, 'OS04G0286300 PROTEIN', 241549),
(322855, 'PTHR33491:SF14', NULL, NULL, NULL, NULL, 'OS02G0632800 PROTEIN', 241549),
(322856, 'PTHR33491:SF48', NULL, NULL, NULL, NULL, 'OS08G0501700 PROTEIN', 241549),
(322857, 'PTHR33491:SF45', NULL, NULL, NULL, NULL, 'OS04G0651200 PROTEIN', 241549),
(322858, 'PTHR33491:SF5', NULL, NULL, NULL, NULL, 'OS02G0624100 PROTEIN', 241549),
(322859, 'PTHR33491:SF46', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE, GALACTURONAN-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 241549);
INSERT INTO "PUBLIC"."MODEL" VALUES
(322860, 'PTHR33491:SF13', NULL, NULL, NULL, NULL, 'OS10G0116701 PROTEIN', 241549),
(322861, 'PTHR33491:SF32', NULL, NULL, NULL, NULL, 'OS11G0691400 PROTEIN', 241549),
(322862, 'PTHR33491:SF43', NULL, NULL, NULL, NULL, 'GUB_WAK_BIND DOMAIN-CONTAINING PROTEIN', 241549),
(322863, 'PTHR33491:SF33', NULL, NULL, NULL, NULL, 'OS11G0693700 PROTEIN', 241549),
(322864, 'PTHR33491:SF44', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE-LIKE 6 ISOFORM X1', 241549),
(322865, 'PTHR33491:SF41', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 241549),
(322866, 'PTHR33491:SF42', NULL, NULL, NULL, NULL, 'GUB_WAK_BIND DOMAIN-CONTAINING PROTEIN', 241549),
(322867, 'PTHR33491:SF50', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED KINASE FAMILY PROTEIN-RELATED', 241549),
(322868, 'PTHR33491:SF51', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 241549),
(322869, 'PTHR33491:SF40', NULL, NULL, NULL, NULL, '', 241549),
(322870, 'PTHR31179:SF5', NULL, NULL, NULL, NULL, 'RAB GTPASE-BINDING EFFECTOR PROTEIN 1', 241550),
(322871, 'PTHR31179:SF7', NULL, NULL, NULL, NULL, 'FYVE-TYPE DOMAIN-CONTAINING PROTEIN', 241550),
(322872, 'PTHR31179:SF6', NULL, NULL, NULL, NULL, 'RAB GTPASE-BINDING EFFECTOR PROTEIN 2', 241550),
(322873, 'PTHR31179', NULL, NULL, NULL, NULL, 'RAB GTPASE-BINDING EFFECTOR PROTEIN', 241550),
(322874, 'PTHR33823', NULL, NULL, NULL, NULL, 'RNA POLYMERASE-BINDING TRANSCRIPTION FACTOR DKSA-RELATED', 241551),
(322875, 'PTHR33823:SF2', NULL, NULL, NULL, NULL, 'RNA POLYMERASE-BINDING TRANSCRIPTION FACTOR DKSA', 241551),
(322876, 'PTHR33823:SF4', NULL, NULL, NULL, NULL, 'GENERAL STRESS PROTEIN 16O', 241551),
(322877, 'PTHR37393', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 1A-LIKE', 241552),
(322878, 'PTHR37393:SF1', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 241552),
(322879, 'PTHR13180:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 50B', 241553),
(322880, 'PTHR13180', NULL, NULL, NULL, NULL, 'SMALL MEMBRANE PROTEIN-RELATED', 241553),
(322881, 'PTHR13180:SF3', NULL, NULL, NULL, NULL, 'OS02G0566900 PROTEIN', 241553),
(322882, 'PTHR13180:SF0', NULL, NULL, NULL, NULL, 'GEO04055P1', 241553),
(322883, 'PTHR13180:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 50A', 241553),
(322884, 'PTHR31750:SF13', NULL, NULL, NULL, NULL, 'STAYGREEN DOMAIN-CONTAINING PROTEIN', 241554),
(322885, 'PTHR31750:SF19', NULL, NULL, NULL, NULL, 'STAY-GREEN-LIKE PROTEIN', 241554),
(322886, 'PTHR31750:SF4', NULL, NULL, NULL, NULL, 'LP06106P', 241554),
(322887, 'PTHR31750:SF18', NULL, NULL, NULL, NULL, 'MAGNESIUM DECHELATASE SGRL, CHLOROPLASTIC', 241554),
(322888, 'PTHR31750:SF17', NULL, NULL, NULL, NULL, 'MAGNESIUM DECHELATASE SGR2, CHLOROPLASTIC', 241554),
(322889, 'PTHR31750:SF28', NULL, NULL, NULL, NULL, '', 241554),
(322890, 'PTHR31750:SF27', NULL, NULL, NULL, NULL, '', 241554),
(322891, 'PTHR31750:SF22', NULL, NULL, NULL, NULL, 'BNAA01G12570D PROTEIN', 241554),
(322892, 'PTHR31750', NULL, NULL, NULL, NULL, 'PROTEIN STAY-GREEN 1, CHLOROPLASTIC-RELATED', 241554),
(322893, 'PTHR40623:SF1', NULL, NULL, NULL, NULL, '', 241555),
(322894, 'PTHR40623:SF2', NULL, NULL, NULL, NULL, '', 241555),
(322895, 'PTHR40623', NULL, NULL, NULL, NULL, '', 241555),
(322896, 'PTHR40861:SF1', NULL, NULL, NULL, NULL, 'DUF2183 DOMAIN-CONTAINING PROTEIN', 241556),
(322897, 'PTHR40861', NULL, NULL, NULL, NULL, 'DUF2183 DOMAIN-CONTAINING PROTEIN', 241556),
(322898, 'PTHR46081', NULL, NULL, NULL, NULL, 'PEPTIDE METHIONINE SULFOXIDE REDUCTASE 2', 241557),
(322899, 'PTHR46081:SF4', NULL, NULL, NULL, NULL, 'PEPTIDE METHIONINE SULFOXIDE REDUCTASE B4-RELATED', 241557),
(322900, 'PTHR46081:SF9', NULL, NULL, NULL, NULL, 'PEPTIDE-METHIONINE (R)-S-OXIDE REDUCTASE', 241557),
(322901, 'PTHR46081:SF8', NULL, NULL, NULL, NULL, 'PEPTIDE METHIONINE SULFOXIDE REDUCTASE 2', 241557),
(322902, 'PTHR46081:SF3', NULL, NULL, NULL, NULL, 'PEPTIDE METHIONINE SULFOXIDE REDUCTASE B6-RELATED', 241557),
(322903, 'PTHR46081:SF1', NULL, NULL, NULL, NULL, 'PEPTIDE METHIONINE SULFOXIDE REDUCTASE B2, CHLOROPLASTIC-RELATED', 241557);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(322904, 'PTHR43680:SF3', NULL, NULL, NULL, NULL, 'NITRATE REDUCTASE MOLYBDENUM COFACTOR ASSEMBLY CHAPERONE NARJ', 241558),
(322905, 'PTHR43680:SF2', NULL, NULL, NULL, NULL, 'NITRATE REDUCTASE MOLYBDENUM COFACTOR ASSEMBLY CHAPERONE NARW-RELATED', 241558),
(322906, 'PTHR43680', NULL, NULL, NULL, NULL, 'NITRATE REDUCTASE MOLYBDENUM COFACTOR ASSEMBLY CHAPERONE', 241558),
(322907, 'PTHR14186:SF21', NULL, NULL, NULL, NULL, 'KAZAL-TYPE SERINE PROTEASE INHIBITOR DOMAIN-CONTAINING PROTEIN 1', 241559),
(322908, 'PTHR14186', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR BINDING PROTEIN-RELATED', 241559),
(322909, 'PTHR14186:SF22', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR-BINDING PROTEIN 7', 241559),
(322910, 'PTHR14186:SF20', NULL, NULL, NULL, NULL, 'SI:CH73-330K17.3', 241559),
(322911, 'PTHR14186:SF19', NULL, NULL, NULL, NULL, 'KAZAL TYPE SERINE PEPTIDASE INHIBITOR DOMAIN 1', 241559),
(322912, 'PTHR14186:SF16', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR-BINDING PROTEIN-LIKE 1', 241559),
(322913, 'PTHR14186:SF25', NULL, NULL, NULL, NULL, 'KAZAL-TYPE SERINE PEPTIDASE INHIBITOR DOMAIN 3', 241559),
(322914, 'PTHR14186:SF14', NULL, NULL, NULL, NULL, '', 241559),
(322915, 'PTHR14186:SF15', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR-BINDING PROTEIN 7', 241559),
(322916, 'PTHR14186:SF23', NULL, NULL, NULL, NULL, 'KAZAL-TYPE SERINE PEPTIDASE INHIBITOR DOMAIN 2', 241559),
(322917, 'PTHR30028:SF1', NULL, NULL, NULL, NULL, 'ALUMINUM SENSITIVE-LIKE PROTEIN', 241560),
(322918, 'PTHR30028:SF0', NULL, NULL, NULL, NULL, 'PROTEIN ALUMINUM SENSITIVE 3', 241560),
(322919, 'PTHR30028', NULL, NULL, NULL, NULL, 'UPF0014 INNER MEMBRANE PROTEIN YBBM-RELATED', 241560),
(322920, 'PTHR22629', NULL, NULL, NULL, NULL, 'ARP2/3 COMPLEX 20 KD SUBUNIT', 241561),
(322921, 'PTHR22629:SF0', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 2/3 COMPLEX SUBUNIT 4', 241561),
(322922, 'PTHR31720:SF15', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS Z', 241562),
(322923, 'PTHR31720', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS Z-RELATED', 241562),
(322924, 'PTHR31720:SF3', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS Z', 241562),
(322925, 'PTHR31720:SF4', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS Z', 241562),
(322926, 'PTHR31720:SF12', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS Z', 241562),
(322927, 'PTHR31720:SF14', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS Z', 241562),
(322928, 'PTHR35097', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE', 241563),
(322929, 'PTHR35097:SF2', NULL, NULL, NULL, NULL, 'OS10G0438300 PROTEIN', 241563),
(322930, 'PTHR35097:SF1', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE', 241563),
(322931, 'PTHR36775:SF1', NULL, NULL, NULL, NULL, 'LYR MOTIF PROTEIN', 241564),
(322932, 'PTHR36775', NULL, NULL, NULL, NULL, 'LYR MOTIF PROTEIN', 241564),
(322933, 'PTHR28304:SF1', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN PEX28', 241565),
(322934, 'PTHR28304:SF2', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN PEX29', 241565),
(322935, 'PTHR28304', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN PEX29', 241565),
(322936, 'PTHR33304:SF42', NULL, NULL, NULL, NULL, 'E4/E8 BINDING PROTEIN-1', 241566),
(322937, 'PTHR33304:SF41', NULL, NULL, NULL, NULL, 'EIN3-BINDING F-BOX PROTEIN 1', 241566),
(322938, 'PTHR33304:SF9', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER SUPERFAMILY PROTEIN', 241566),
(322939, 'PTHR33304:SF49', NULL, NULL, NULL, NULL, 'OS12G0161900 PROTEIN', 241566),
(322940, 'PTHR33304:SF48', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER SUPERFAMILY PROTEIN', 241566),
(322941, 'PTHR33304', NULL, NULL, NULL, NULL, '', 241566),
(322942, 'PTHR33304:SF50', NULL, NULL, NULL, NULL, '', 241566),
(322943, 'PTHR33304:SF3', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241566),
(322944, 'PTHR33304:SF54', NULL, NULL, NULL, NULL, 'BNAUNNG02140D PROTEIN', 241566),
(322945, 'PTHR33304:SF53', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', 241566),
(322946, 'PTHR33304:SF31', NULL, NULL, NULL, NULL, 'GB|AAF19536.1', 241566); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(322947, 'PTHR33304:SF52', NULL, NULL, NULL, NULL, '', 241566),
(322948, 'PTHR33304:SF51', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN, PUTATIVE-RELATED', 241566),
(322949, 'PTHR33304:SF58', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER SUPERFAMILY PROTEIN', 241566),
(322950, 'PTHR33304:SF36', NULL, NULL, NULL, NULL, 'GB|AAF26970.1-RELATED', 241566),
(322951, 'PTHR33304:SF57', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241566),
(322952, 'PTHR33304:SF56', NULL, NULL, NULL, NULL, 'E4/E8 BINDING PROTEIN-1', 241566),
(322953, 'PTHR33304:SF33', NULL, NULL, NULL, NULL, '', 241566),
(322954, 'PTHR33304:SF55', NULL, NULL, NULL, NULL, 'PHD DOMAIN-CONTAINING PROTEIN', 241566),
(322955, 'PTHR33304:SF18', NULL, NULL, NULL, NULL, 'PHD DOMAIN-CONTAINING PROTEIN', 241566),
(322956, 'PTHR33304:SF38', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', 241566),
(322957, 'PTHR33304:SF59', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER SUPERFAMILY PROTEIN', 241566),
(322958, 'PTHR33304:SF37', NULL, NULL, NULL, NULL, 'BNAANNG06740D PROTEIN', 241566),
(322959, 'PTHR33304:SF15', NULL, NULL, NULL, NULL, 'PHD DOMAIN-CONTAINING PROTEIN', 241566),
(322960, 'PTHR33304:SF60', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 2B-LIKE ISOFORM X1', 241566),
(322961, 'PTHR41700:SF1', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 241567),
(322962, 'PTHR41700', NULL, NULL, NULL, NULL, 'GCN5-RELATED N-ACETYLTRANSFERASE', 241567),
(322963, 'PTHR37687', NULL, NULL, NULL, NULL, 'AGAP006772-PA', 241568),
(322964, 'PTHR37687:SF1', NULL, NULL, NULL, NULL, 'AGAP006772-PA', 241568),
(322965, 'PTHR47425:SF1', NULL, NULL, NULL, NULL, 'MISCELLANEOUS ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)', 241569),
(322966, 'PTHR47425:SF2', NULL, NULL, NULL, NULL, 'FARB-RELATED', 241569),
(322967, 'PTHR47425:SF3', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 241569),
(322968, 'PTHR47425', NULL, NULL, NULL, NULL, 'FARB-RELATED', 241569),
(322969, 'PTHR31774', NULL, NULL, NULL, NULL, 'PROTEIN SHISA-9-RELATED', 241570),
(322970, 'PTHR31774:SF0', NULL, NULL, NULL, NULL, 'PROTEIN SHISA-6', 241570),
(322971, 'PTHR31774:SF14', NULL, NULL, NULL, NULL, 'PROTEIN SHISA-8', 241570),
(322972, 'PTHR31774:SF1', NULL, NULL, NULL, NULL, 'PROTEIN SHISA-9', 241570),
(322973, 'PTHR31774:SF2', NULL, NULL, NULL, NULL, 'PROTEIN SHISA-7', 241570),
(322974, 'PTHR47279', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SOX-30', 241571),
(322975, 'PTHR47279:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SOX-30', 241571),
(322976, 'PTHR47938', NULL, NULL, NULL, NULL, 'RESPIRATORY COMPLEX I CHAPERONE (CIA84), PUTATIVE (AFU_ORTHOLOGUE AFUA_2G06020)-RELATED', 241572),
(322977, 'PTHR47938:SF26', NULL, NULL, NULL, NULL, 'OS10G0578500 PROTEIN', 241572),
(322978, 'PTHR47938:SF27', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 241572),
(322979, 'PTHR47938:SF28', NULL, NULL, NULL, NULL, 'OS07G0249100 PROTEIN', 241572),
(322980, 'PTHR47938:SF22', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 241572),
(322981, 'PTHR47938:SF44', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT DOMAIN CONTAINING PROTEIN-RELATED', 241572),
(322982, 'PTHR47938:SF23', NULL, NULL, NULL, NULL, 'REPEAT (PPR) SUPERFAMILY PROTEIN, PUTATIVE-RELATED', 241572),
(322983, 'PTHR47938:SF24', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN MITOCHONDRIAL-RELATED', 241572),
(322984, 'PTHR47938:SF25', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 241572),
(322985, 'PTHR47938:SF10', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 241572),
(322986, 'PTHR47938:SF7', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 241572),
(322987, 'PTHR47938:SF6', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE (PPR) REPEAT PROTEIN', 241572),
(322988, 'PTHR47938:SF5', NULL, NULL, NULL, NULL, 'OS07G0213300 PROTEIN', 241572),
(322989, 'PTHR47938:SF3', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 241572);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(322990, 'PTHR47938:SF19', NULL, NULL, NULL, NULL, 'OS02G0127600 PROTEIN', 241572),
(322991, 'PTHR47938:SF2', NULL, NULL, NULL, NULL, 'OS06G0184866 PROTEIN', 241572),
(322992, 'PTHR47938:SF1', NULL, NULL, NULL, NULL, 'OS02G0304800 PROTEIN', 241572),
(322993, 'PTHR47938:SF15', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 241572),
(322994, 'PTHR47938:SF37', NULL, NULL, NULL, NULL, '', 241572),
(322995, 'PTHR47938:SF16', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 241572),
(322996, 'PTHR47938:SF38', NULL, NULL, NULL, NULL, '', 241572),
(322997, 'PTHR47938:SF17', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN-CONTAINING PROTEIN-RELATED', 241572),
(322998, 'PTHR47938:SF39', NULL, NULL, NULL, NULL, '', 241572),
(322999, 'PTHR47938:SF18', NULL, NULL, NULL, NULL, 'OS10G0358700 PROTEIN', 241572),
(323000, 'PTHR47938:SF33', NULL, NULL, NULL, NULL, 'BNAA06G28500D PROTEIN', 241572),
(323001, 'PTHR47938:SF11', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 241572),
(323002, 'PTHR47938:SF34', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 241572),
(323003, 'PTHR47938:SF9', NULL, NULL, NULL, NULL, 'OS10G0422300 PROTEIN', 241572),
(323004, 'PTHR47938:SF13', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN MITOCHONDRIAL', 241572),
(323005, 'PTHR47938:SF35', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN 4, MITOCHONDRIAL-RELATED', 241572),
(323006, 'PTHR47938:SF36', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 241572),
(323007, 'PTHR47938:SF40', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241572),
(323008, 'PTHR47938:SF41', NULL, NULL, NULL, NULL, '', 241572),
(323009, 'PTHR47938:SF42', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 241572),
(323010, 'PTHR47938:SF21', NULL, NULL, NULL, NULL, 'OS02G0827900 PROTEIN', 241572),
(323011, 'PTHR47938:SF43', NULL, NULL, NULL, NULL, '', 241572),
(323012, 'PTHR21178:SF8', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 61', 241573),
(323013, 'PTHR21178', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 61', 241573),
(323014, 'PTHR37300:SF2', NULL, NULL, NULL, NULL, 'UPF0291 PROTEIN BC_1827', 241574),
(323015, 'PTHR37300', NULL, NULL, NULL, NULL, 'UPF0291 PROTEIN CBO2609/CLC_2481', 241574),
(323016, 'PTHR37300:SF1', NULL, NULL, NULL, NULL, 'UPF0291 PROTEIN YNZC', 241574),
(323017, 'PTHR11988:SF24', NULL, NULL, NULL, NULL, 'THYROTROPH EMBRYONIC FACTOR', 241575),
(323018, 'PTHR11988:SF47', NULL, NULL, NULL, NULL, 'TEF TRANSCRIPTION FACTOR, PAR BZIP FAMILY MEMBER B', 241575),
(323019, 'PTHR11988:SF48', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 241575),
(323020, 'PTHR11988:SF27', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 241575),
(323021, 'PTHR11988:SF53', NULL, NULL, NULL, NULL, 'GH27708P', 241575),
(323022, 'PTHR11988:SF42', NULL, NULL, NULL, NULL, 'PROTEIN GIANT', 241575),
(323023, 'PTHR11988:SF54', NULL, NULL, NULL, NULL, 'D SITE ALBUMIN PROMOTER-BINDING PROTEIN B', 241575),
(323024, 'PTHR11988', NULL, NULL, NULL, NULL, 'THYROTROPH EMBRYONIC FACTOR RELATED', 241575),
(323025, 'PTHR11988:SF51', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 241575),
(323026, 'PTHR11988:SF52', NULL, NULL, NULL, NULL, 'D SITE ALBUMIN PROMOTER-BINDING PROTEIN A', 241575),
(323027, 'PTHR11988:SF28', NULL, NULL, NULL, NULL, 'HEPATIC LEUKEMIA FACTOR', 241575),
(323028, 'PTHR11988:SF7', NULL, NULL, NULL, NULL, 'D SITE-BINDING PROTEIN', 241575),
(323029, 'PTHR35504', NULL, NULL, NULL, NULL, 'PROTEIN EMBRYONIC FLOWER 1', 241576),
(323030, 'PTHR35504:SF1', NULL, NULL, NULL, NULL, 'PROTEIN EMBRYONIC FLOWER 1', 241576),
(323031, 'PTHR35504:SF2', NULL, NULL, NULL, NULL, '', 241576),
(323032, 'PTHR43086:SF2', NULL, NULL, NULL, NULL, 'HYDROXYSTEROID DEHYDROGENASE-LIKE PROTEIN 1', 241577),
(323033, 'PTHR43086:SF3', NULL, NULL, NULL, NULL, 'NADP-DEPENDENT 3-HYDROXY ACID DEHYDROGENASE YDFG', 241577),
(323034, 'PTHR43086:SF1', NULL, NULL, NULL, NULL, 'STEROID DEHYDROGENASE 1-RELATED', 241577);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(323035, 'PTHR43086', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN 3-OXOOACYL-COA REDUCTASE', 241577),
(323036, 'PTHR15576:SF1', NULL, NULL, NULL, NULL, 'RIBITOL-5-PHOSPHATE XYLOSYLTRANSFERASE 1', 241578),
(323037, 'PTHR15576', NULL, NULL, NULL, NULL, 'RIBITOL-5-PHOSPHATE XYLOSYLTRANSFERASE 1', 241578),
(323038, 'PTHR48101:SF1', NULL, NULL, NULL, NULL, 'METHYLMALONYL-COA MUTASE, LARGE SUBUNIT', 241579),
(323039, 'PTHR48101:SF4', NULL, NULL, NULL, NULL, 'METHYLMALONYL-COA MUTASE, MITOCHONDRIAL', 241579),
(323040, 'PTHR48101:SF3', NULL, NULL, NULL, NULL, 'COENZYME B12-DEPENDENT MUTASE', 241579),
(323041, 'PTHR48101', NULL, NULL, NULL, NULL, 'METHYLMALONYL-COA MUTASE, MITOCHONDRIAL-RELATED', 241579),
(323042, 'PTHR34078:SF3', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241580),
(323043, 'PTHR34078:SF9', NULL, NULL, NULL, NULL, '', 241580),
(323044, 'PTHR34078:SF7', NULL, NULL, NULL, NULL, '', 241580),
(323045, 'PTHR34078:SF8', NULL, NULL, NULL, NULL, '', 241580),
(323046, 'PTHR34078', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241580),
(323047, 'PTHR34078:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN DDB_G0267530-RELATED', 241580),
(323048, 'PTHR34078:SF2', NULL, NULL, NULL, NULL, '', 241580),
(323049, 'PTHR44314:SF1', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 70', 241581),
(323050, 'PTHR44314', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 70', 241581),
(323051, 'PTHR46446:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PRE3', 241582),
(323052, 'PTHR46446', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PRE', 241582),
(323053, 'PTHR46446:SF29', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 241582),
(323054, 'PTHR46446:SF19', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN-CONTAINING PROTEIN-RELATED', 241582),
(323055, 'PTHR46446:SF28', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PRE5', 241582),
(323056, 'PTHR46446:SF17', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PRE4', 241582),
(323057, 'PTHR46446:SF25', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR ILI1', 241582),
(323058, 'PTHR46446:SF26', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PRE2', 241582),
(323059, 'PTHR46446:SF23', NULL, NULL, NULL, NULL, 'BANQUO 2-RELATED', 241582),
(323060, 'PTHR46446:SF21', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 241582),
(323061, 'PTHR46446:SF32', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR ILI6', 241582),
(323062, 'PTHR46446:SF11', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PRE6', 241582),
(323063, 'PTHR46446:SF22', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN-CONTAINING PROTEIN-RELATED', 241582),
(323064, 'PTHR46446:SF33', NULL, NULL, NULL, NULL, 'BASIC HELIX-LOOP-HELIX (BHLH) DNA-BINDING FAMILY PROTEIN-RELATED', 241582),
(323065, 'PTHR46446:SF30', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PRE1', 241582),
(323066, 'PTHR46446:SF20', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 241582),
(323067, 'PTHR46446:SF31', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR ILI4', 241582),
(323068, 'PTHR46446:SF9', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PRE6-LIKE', 241582),
(323069, 'PTHR46446:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR ILI5', 241582),
(323070, 'PTHR37519', NULL, NULL, NULL, NULL, '', 241583),
(323071, 'PTHR37519:SF1', NULL, NULL, NULL, NULL, 'DIHYDROXYBIPHENYL DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 241583),
(323072, 'PTHR23113:SF99', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE EXCHANGE FACTOR LTE1', 241584),
(323073, 'PTHR23113:SF184', NULL, NULL, NULL, NULL, 'RAS GUANINE NUCLEOTIDE EXCHANGE FACTOR V', 241584),
(323074, 'PTHR23113:SF186', NULL, NULL, NULL, NULL, 'RAS-GEF DOMAIN-CONTAINING FAMILY MEMBER 1C', 241584),
(323075, 'PTHR23113:SF341', NULL, NULL, NULL, NULL, 'PROTEIN SON OF SEVENLESS', 241584),
(323076, 'PTHR23113:SF187', NULL, NULL, NULL, NULL, 'RAS-SPECIFIC GUANINE NUCLEOTIDE-RELEASING FACTOR 2', 241584),
(323077, 'PTHR23113:SF16', NULL, NULL, NULL, NULL, 'RAS GUANYL-RELEASING PROTEIN 2', 241584),
(323078, 'PTHR23113:SF220', NULL, NULL, NULL, NULL, 'RAL GUANINE NUCLEOTIDE DISSOCIATION STIMULATOR-LIKE 3', 241584);
INSERT INTO "PUBLIC"."MODEL" VALUES
(323079, 'PTHR23113:SF222', NULL, NULL, NULL, NULL, 'RAP GUANINE NUCLEOTIDE EXCHANGE FACTOR 6', 241584),
(323080, 'PTHR23113:SF223', NULL, NULL, NULL, NULL, 'RAL-GDS-RELATED PROTEIN', 241584),
(323081, 'PTHR23113:SF224', NULL, NULL, NULL, NULL, 'RAP GUANINE NUCLEOTIDE EXCHANGE FACTOR 1', 241584),
(323082, 'PTHR23113:SF346', NULL, NULL, NULL, NULL, 'RAS GUANINE NUCLEOTIDE EXCHANGE FACTOR L', 241584),
(323083, 'PTHR23113:SF347', NULL, NULL, NULL, NULL, 'RAS GUANINE NUCLEOTIDE EXCHANGE FACTOR O', 241584),
(323084, 'PTHR23113:SF348', NULL, NULL, NULL, NULL, 'GUANYL-NUCLEOTIDE EXCHANGE FACTOR RASGEF, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G04700)-RELATED', 241584),
(323085, 'PTHR23113:SF349', NULL, NULL, NULL, NULL, 'RASGEF DOMAIN FAMILY, MEMBER 1B', 241584),
(323086, 'PTHR23113:SF170', NULL, NULL, NULL, NULL, 'RAS GUANINE NUCLEOTIDE EXCHANGE FACTOR F', 241584),
(323087, 'PTHR23113:SF24', NULL, NULL, NULL, NULL, 'RAP GUANINE NUCLEOTIDE EXCHANGE FACTOR 3', 241584),
(323088, 'PTHR23113:SF172', NULL, NULL, NULL, NULL, 'RAS-GEF DOMAIN-CONTAINING FAMILY MEMBER 1A', 241584),
(323089, 'PTHR23113:SF26', NULL, NULL, NULL, NULL, 'RAP GUANINE NUCLEOTIDE EXCHANGE FACTOR 5', 241584),
(323090, 'PTHR23113:SF174', NULL, NULL, NULL, NULL, 'RAS GUANYL-RELEASING PROTEIN 1', 241584),
(323091, 'PTHR23113:SF175', NULL, NULL, NULL, NULL, 'RAP GUANINE NUCLEOTIDE EXCHANGE FACTOR 4', 241584),
(323092, 'PTHR23113:SF252', NULL, NULL, NULL, NULL, 'RAP GUANINE NUCLEOTIDE EXCHANGE FACTOR HOMOLOG', 241584),
(323093, 'PTHR23113:SF331', NULL, NULL, NULL, NULL, 'RAS GUANINE NUCLEOTIDE EXCHANGE FACTOR I', 241584),
(323094, 'PTHR23113:SF254', NULL, NULL, NULL, NULL, 'CYCLIC GMP-BINDING PROTEIN D', 241584),
(323095, 'PTHR23113:SF178', NULL, NULL, NULL, NULL, 'RAS GUANYL-RELEASING PROTEIN 3', 241584),
(323096, 'PTHR23113:SF333', NULL, NULL, NULL, NULL, 'RAS GUANINE NUCLEOTIDE EXCHANGE FACTOR A', 241584),
(323097, 'PTHR23113', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE EXCHANGE FACTOR', 241584),
(323098, 'PTHR23113:SF217', NULL, NULL, NULL, NULL, 'RAP GUANINE NUCLEOTIDE EXCHANGE FACTOR 2', 241584),
(323099, 'PTHR23113:SF35', NULL, NULL, NULL, NULL, 'RAL GUANINE NUCLEOTIDE DISSOCIATION STIMULATOR', 241584),
(323100, 'PTHR23113:SF160', NULL, NULL, NULL, NULL, 'RAS GUANINE NUCLEOTIDE EXCHANGE FACTOR C', 241584),
(323101, 'PTHR23113:SF360', NULL, NULL, NULL, NULL, 'RAS GUANINE NUCLEOTIDE EXCHANGE FACTOR B', 241584),
(323102, 'PTHR23113:SF162', NULL, NULL, NULL, NULL, 'RAS GUANINE NUCLEOTIDE EXCHANGE FACTOR R', 241584),
(323103, 'PTHR23113:SF361', NULL, NULL, NULL, NULL, 'RAS GUANINE NUCLEOTIDE EXCHANGE FACTOR P', 241584),
(323104, 'PTHR23113:SF241', NULL, NULL, NULL, NULL, 'RAS GUANINE NUCLEOTIDE EXCHANGE FACTOR M', 241584),
(323105, 'PTHR23113:SF167', NULL, NULL, NULL, NULL, 'RAS-SPECIFIC GUANINE NUCLEOTIDE-RELEASING FACTOR RALGPS1', 241584),
(323106, 'PTHR23113:SF200', NULL, NULL, NULL, NULL, '', 241584),
(323107, 'PTHR23113:SF168', NULL, NULL, NULL, NULL, 'SON OF SEVENLESS HOMOLOG 1', 241584),
(323108, 'PTHR23113:SF201', NULL, NULL, NULL, NULL, 'RAS GUANINE NUCLEOTIDE EXCHANGE FACTOR G', 241584),
(323109, 'PTHR23113:SF203', NULL, NULL, NULL, NULL, 'RAS GUANINE NUCLEOTIDE EXCHANGE FACTOR H', 241584),
(323110, 'PTHR23113:SF324', NULL, NULL, NULL, NULL, 'RAS-GEF DOMAIN-CONTAINING PROTEIN', 241584),
(323111, 'PTHR23113:SF204', NULL, NULL, NULL, NULL, 'RAS GUANINE NUCLEOTIDE EXCHANGE FACTOR Q', 241584),
(323112, 'PTHR23113:SF249', NULL, NULL, NULL, NULL, 'DIZZY ISOFORM AII', 241584),
(323113, 'PTHR23113:SF327', NULL, NULL, NULL, NULL, 'EXCHANGE PROTEIN DIRECTLY ACTIVATED BY CAMP, ISOFORM E', 241584),
(323114, 'PTHR23113:SF193', NULL, NULL, NULL, NULL, 'RAS-SPECIFIC GUANINE NUCLEOTIDE-RELEASING FACTOR 1', 241584),
(323115, 'PTHR23113:SF150', NULL, NULL, NULL, NULL, 'SON OF SEVENLESS HOMOLOG 2', 241584),
(323116, 'PTHR23113:SF151', NULL, NULL, NULL, NULL, 'RAS GUANINE NUCLEOTIDE EXCHANGE FACTOR S', 241584),
(323117, 'PTHR23113:SF350', NULL, NULL, NULL, NULL, 'RAL GUANINE NUCLEOTIDE DISSOCIATION STIMULATOR-LIKE 2', 241584),
(323118, 'PTHR23113:SF197', NULL, NULL, NULL, NULL, 'RAS-GEF DOMAIN-CONTAINING FAMILY MEMBER 1B', 241584);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(323119, 'PTHR23113:SF230', NULL, NULL, NULL, NULL, 'RAP GUANINE NUCLEOTIDE EXCHANGE FACTOR-LIKE 1', 241584),
(323120, 'PTHR23113:SF351', NULL, NULL, NULL, NULL, 'RAS GUANINE NUCLEOTIDE EXCHANGE FACTOR J', 241584),
(323121, 'PTHR23113:SF199', NULL, NULL, NULL, NULL, 'RAL GUANINE NUCLEOTIDE DISSOCIATION STIMULATOR-LIKE 1', 241584),
(323122, 'PTHR23113:SF354', NULL, NULL, NULL, NULL, 'GUANINE-NUCLEOTIDE EXCHANGE PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G06570)-RELATED', 241584),
(323123, 'PTHR23113:SF355', NULL, NULL, NULL, NULL, 'RAS GUANINE NUCLEOTIDE EXCHANGE FACTOR E', 241584),
(323124, 'PTHR23113:SF157', NULL, NULL, NULL, NULL, 'RAS GUANYL-RELEASING PROTEIN 4', 241584),
(323125, 'PTHR23113:SF356', NULL, NULL, NULL, NULL, 'FI05912P-RELATED', 241584),
(323126, 'PTHR23113:SF158', NULL, NULL, NULL, NULL, 'RAS GUANINE NUCLEOTIDE EXCHANGE FACTOR N', 241584),
(323127, 'PTHR23113:SF312', NULL, NULL, NULL, NULL, 'RAL GUANINE NUCLEOTIDE DISSOCIATION STIMULATOR-LIKE, ISOFORM E', 241584),
(323128, 'PTHR23113:SF357', NULL, NULL, NULL, NULL, 'RAS-SPECIFIC GUANINE NUCLEOTIDE-RELEASING FACTOR RALGPS2', 241584),
(323129, 'PTHR23113:SF358', NULL, NULL, NULL, NULL, 'ZGC:171558', 241584),
(323130, 'PTHR23113:SF237', NULL, NULL, NULL, NULL, '', 241584),
(323131, 'PTHR23113:SF359', NULL, NULL, NULL, NULL, 'RAS PROTEIN-SPECIFIC GUANINE NUCLEOTIDE-RELEASING FACTOR 2A', 241584),
(323132, 'PTHR23113:SF319', NULL, NULL, NULL, NULL, 'RAS GUANINE NUCLEOTIDE EXCHANGE FACTOR Y', 241584),
(323133, 'PTHR14909:SF6', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 6 COMPLEX LOCUS PROTEIN G5C', 241585),
(323134, 'PTHR14909', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 6 COMPLEX LOCUS PROTEIN G5C', 241585),
(323135, 'PTHR37273:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 8, WHOLE GENOME SHOTGUN SEQUENCE', 241586),
(323136, 'PTHR37273', NULL, NULL, NULL, NULL, 'CHROMOSOME 8, WHOLE GENOME SHOTGUN SEQUENCE', 241586),
(323137, 'PTHR23062:SF9', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 241587),
(323138, 'PTHR23062', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN  C.ELEGANS', 241587),
(323139, 'PTHR23062:SF3', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 241587),
(323140, 'PTHR23062:SF2', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN', 241587),
(323141, 'PTHR23062:SF7', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 241587),
(323142, 'PTHR23062:SF6', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN', 241587),
(323143, 'PTHR23062:SF10', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 241587),
(323144, 'PTHR23062:SF4', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 241587),
(323145, 'PTHR47703', NULL, NULL, NULL, NULL, 'D-AMINOACID AMINOTRANSFERASE-LIKE PLP-DEPENDENT ENZYMES SUPERFAMILY PROTEIN', 241588),
(323146, 'PTHR47703:SF2', NULL, NULL, NULL, NULL, 'D-AMINOACID AMINOTRANSFERASE-LIKE PLP-DEPENDENT ENZYMES SUPERFAMILY PROTEIN', 241588),
(323147, 'PTHR21716:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 245', 241589),
(323148, 'PTHR21716', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 241589),
(323149, 'PTHR21716:SF15', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN YRRI-RELATED', 241589),
(323150, 'PTHR21716:SF16', NULL, NULL, NULL, NULL, 'BLL1467 PROTEIN', 241589),
(323151, 'PTHR21716:SF68', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN YTVI-RELATED', 241589),
(323152, 'PTHR21716:SF47', NULL, NULL, NULL, NULL, '', 241589),
(323153, 'PTHR21716:SF69', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN YUBA-RELATED', 241589),
(323154, 'PTHR21716:SF66', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN SLL0063-RELATED', 241589),
(323155, 'PTHR21716:SF56', NULL, NULL, NULL, NULL, '', 241589),
(323156, 'PTHR21716:SF67', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN YDIK-RELATED', 241589),
(323157, 'PTHR21716:SF64', NULL, NULL, NULL, NULL, 'AI-2 TRANSPORT PROTEIN TQSA', 241589),
(323158, 'PTHR21716:SF53', NULL, NULL, NULL, NULL, 'PERMEASE PERM-RELATED', 241589),
(323159, 'PTHR21716:SF65', NULL, NULL, NULL, NULL, '', 241589),
(323160, 'PTHR21716:SF21', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN YHHT-RELATED', 241589);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(323161, 'PTHR21716:SF62', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN YDBI-RELATED', 241589),
(323162, 'PTHR21716:SF63', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN TM_1349-RELATED', 241589),
(323163, 'PTHR21716:SF61', NULL, NULL, NULL, NULL, 'BLR8064 PROTEIN', 241589),
(323164, 'PTHR45717:SF55', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN, MITOCHONDRIAL', 241590),
(323165, 'PTHR45717:SF11', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN MITOCHONDRIAL', 241590),
(323166, 'PTHR45717:SF54', NULL, NULL, NULL, NULL, 'BNACNNG67990D PROTEIN', 241590),
(323167, 'PTHR45717:SF10', NULL, NULL, NULL, NULL, 'OS10G0501200 PROTEIN', 241590),
(323168, 'PTHR45717:SF53', NULL, NULL, NULL, NULL, 'LMO0941 PROTEIN', 241590),
(323169, 'PTHR45717:SF52', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 241590),
(323170, 'PTHR45717:SF30', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT (PPR) SUPERFAMILY PROTEIN', 241590),
(323171, 'PTHR45717:SF51', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 241590),
(323172, 'PTHR45717:SF50', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN-RELATED', 241590),
(323173, 'PTHR45717', NULL, NULL, NULL, NULL, 'OS12G0527900 PROTEIN', 241590),
(323174, 'PTHR45717:SF28', NULL, NULL, NULL, NULL, 'REPEAT-LIKE SUPERFAMILY PROTEIN, PUTATIVE ISOFORM 1-RELATED', 241590),
(323175, 'PTHR45717:SF27', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 241590),
(323176, 'PTHR45717:SF49', NULL, NULL, NULL, NULL, 'BNAC02G39730D PROTEIN', 241590),
(323177, 'PTHR45717:SF26', NULL, NULL, NULL, NULL, 'BNAC05G37740D PROTEIN', 241590),
(323178, 'PTHR45717:SF47', NULL, NULL, NULL, NULL, 'BNAA07G00520D PROTEIN', 241590),
(323179, 'PTHR45717:SF46', NULL, NULL, NULL, NULL, 'BNACNNG24870D PROTEIN', 241590),
(323180, 'PTHR45717:SF24', NULL, NULL, NULL, NULL, '', 241590),
(323181, 'PTHR45717:SF23', NULL, NULL, NULL, NULL, '', 241590),
(323182, 'PTHR45717:SF45', NULL, NULL, NULL, NULL, 'OS12G0527900 PROTEIN', 241590),
(323183, 'PTHR45717:SF22', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT (PPR) SUPERFAMILY PROTEIN', 241590),
(323184, 'PTHR45717:SF21', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 241590),
(323185, 'PTHR45717:SF42', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 241590),
(323186, 'PTHR45717:SF20', NULL, NULL, NULL, NULL, 'OS07G0598500 PROTEIN', 241590),
(323187, 'PTHR45717:SF41', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 241590),
(323188, 'PTHR45717:SF40', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN-CONTAINING PROTEIN-RELATED', 241590),
(323189, 'PTHR45717:SF3', NULL, NULL, NULL, NULL, 'OS04G0544400 PROTEIN', 241590),
(323190, 'PTHR45717:SF4', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN MITOCHONDRIAL', 241590),
(323191, 'PTHR45717:SF5', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 241590),
(323192, 'PTHR45717:SF6', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 241590),
(323193, 'PTHR45717:SF7', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 241590),
(323194, 'PTHR45717:SF8', NULL, NULL, NULL, NULL, 'OS01G0301500 PROTEIN', 241590),
(323195, 'PTHR45717:SF9', NULL, NULL, NULL, NULL, 'OS01G0301700 PROTEIN', 241590),
(323196, 'PTHR45717:SF18', NULL, NULL, NULL, NULL, '', 241590),
(323197, 'PTHR45717:SF17', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN MITOCHONDRIAL', 241590),
(323198, 'PTHR45717:SF39', NULL, NULL, NULL, NULL, 'BNAC09G18920D PROTEIN', 241590),
(323199, 'PTHR45717:SF38', NULL, NULL, NULL, NULL, '', 241590),
(323200, 'PTHR45717:SF16', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN', 241590),
(323201, 'PTHR45717:SF37', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN-CONTAINING PROTEIN-RELATED', 241590),
(323202, 'PTHR45717:SF15', NULL, NULL, NULL, NULL, 'OS01G0280400 PROTEIN', 241590),
(323203, 'PTHR45717:SF36', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN-CONTAINING PROTEIN-RELATED', 241590);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(323204, 'PTHR45717:SF14', NULL, NULL, NULL, NULL, 'OS04G0320200 PROTEIN', 241590),
(323205, 'PTHR45717:SF35', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN-RELATED', 241590),
(323206, 'PTHR45717:SF13', NULL, NULL, NULL, NULL, 'OS02G0796400 PROTEIN', 241590),
(323207, 'PTHR45717:SF34', NULL, NULL, NULL, NULL, 'BNAA07G01620D PROTEIN', 241590),
(323208, 'PTHR45717:SF56', NULL, NULL, NULL, NULL, 'BNAA09G13070D PROTEIN', 241590),
(323209, 'PTHR39224:SF1', NULL, NULL, NULL, NULL, 'IGA-INDUCING PROTEIN HOMOLOG', 241591),
(323210, 'PTHR39224', NULL, NULL, NULL, NULL, 'IGA-INDUCING PROTEIN HOMOLOG', 241591),
(323211, 'PTHR31221:SF124', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 24-RELATED', 241592),
(323212, 'PTHR31221:SF243', NULL, NULL, NULL, NULL, 'WRKY FAMILY TRANSCRIPTION FACTOR', 241592),
(323213, 'PTHR31221:SF242', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 241592),
(323214, 'PTHR31221:SF127', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 71-RELATED', 241592),
(323215, 'PTHR31221:SF126', NULL, NULL, NULL, NULL, 'OS07G0583700 PROTEIN', 241592),
(323216, 'PTHR31221:SF125', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 1', 241592),
(323217, 'PTHR31221:SF240', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 241592),
(323218, 'PTHR31221:SF1', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR PROTEIN 1-RELATED', 241592),
(323219, 'PTHR31221:SF133', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 3-RELATED', 241592),
(323220, 'PTHR31221:SF132', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 50-RELATED', 241592),
(323221, 'PTHR31221:SF137', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 12-RELATED', 241592),
(323222, 'PTHR31221:SF257', NULL, NULL, NULL, NULL, 'BNAA02G36910D PROTEIN', 241592),
(323223, 'PTHR31221:SF252', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR WRKY FAMILY-RELATED', 241592),
(323224, 'PTHR31221:SF251', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 241592),
(323225, 'PTHR31221:SF130', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 4-RELATED', 241592),
(323226, 'PTHR31221:SF250', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 13-RELATED', 241592),
(323227, 'PTHR31221:SF344', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 26 ISOFORM X1-RELATED', 241592),
(323228, 'PTHR31221:SF189', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR', 241592),
(323229, 'PTHR31221:SF343', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 58-RELATED', 241592),
(323230, 'PTHR31221:SF86', NULL, NULL, NULL, NULL, 'WRKY DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 241592),
(323231, 'PTHR31221:SF221', NULL, NULL, NULL, NULL, 'BNAC03G16740D PROTEIN', 241592),
(323232, 'PTHR31221:SF342', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 33-RELATED', 241592),
(323233, 'PTHR31221:SF341', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 241592),
(323234, 'PTHR31221:SF187', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR', 241592),
(323235, 'PTHR31221:SF227', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 241592),
(323236, 'PTHR31221:SF83', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 75-RELATED', 241592),
(323237, 'PTHR31221:SF348', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 241592),
(323238, 'PTHR31221:SF347', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 23-RELATED', 241592),
(323239, 'PTHR31221:SF346', NULL, NULL, NULL, NULL, 'WRKY DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 241592),
(323240, 'PTHR31221:SF224', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 241592),
(323241, 'PTHR31221:SF345', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN-RELATED', 241592),
(323242, 'PTHR31221:SF182', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 241592),
(323243, 'PTHR31221:SF181', NULL, NULL, NULL, NULL, 'BNAA09G45940D PROTEIN', 241592),
(323244, 'PTHR31221:SF340', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 50-RELATED', 241592),
(323245, 'PTHR31221:SF186', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 71', 241592);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(323246, 'PTHR31221:SF185', NULL, NULL, NULL, NULL, 'BNACNNG39610D PROTEIN', 241592),
(323247, 'PTHR31221:SF184', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 241592),
(323248, 'PTHR31221:SF90', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 44', 241592),
(323249, 'PTHR31221:SF229', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 25-RELATED', 241592),
(323250, 'PTHR31221:SF228', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR', 241592),
(323251, 'PTHR31221:SF349', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 51-RELATED', 241592),
(323252, 'PTHR31221', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR PROTEIN 1-RELATED', 241592),
(323253, 'PTHR31221:SF112', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 50-RELATED', 241592),
(323254, 'PTHR31221:SF233', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 241592),
(323255, 'PTHR31221:SF111', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 43-RELATED', 241592),
(323256, 'PTHR31221:SF198', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN-RELATED', 241592),
(323257, 'PTHR31221:SF110', NULL, NULL, NULL, NULL, 'OS05G0565900 PROTEIN', 241592),
(323258, 'PTHR31221:SF236', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 241592),
(323259, 'PTHR31221:SF235', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 20-RELATED', 241592),
(323260, 'PTHR31221:SF193', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 20 ISOFORM X1-RELATED', 241592),
(323261, 'PTHR31221:SF191', NULL, NULL, NULL, NULL, 'BNAA03G17820D PROTEIN', 241592),
(323262, 'PTHR31221:SF230', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 241592),
(323263, 'PTHR31221:SF196', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 241592),
(323264, 'PTHR31221:SF239', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 10-RELATED', 241592),
(323265, 'PTHR31221:SF322', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, PUTATIVE-RELATED', 241592),
(323266, 'PTHR31221:SF168', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 241592),
(323267, 'PTHR31221:SF289', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 68', 241592),
(323268, 'PTHR31221:SF201', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 241592),
(323269, 'PTHR31221:SF288', NULL, NULL, NULL, NULL, 'BNAA08G12810D PROTEIN', 241592),
(323270, 'PTHR31221:SF321', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 71-RELATED', 241592),
(323271, 'PTHR31221:SF167', NULL, NULL, NULL, NULL, 'OS07G0596900 PROTEIN', 241592),
(323272, 'PTHR31221:SF320', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 20', 241592),
(323273, 'PTHR31221:SF326', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 50-RELATED', 241592),
(323274, 'PTHR31221:SF205', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR', 241592),
(323275, 'PTHR31221:SF325', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 28', 241592),
(323276, 'PTHR31221:SF324', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 241592),
(323277, 'PTHR31221:SF203', NULL, NULL, NULL, NULL, 'BNAA04G17420D PROTEIN', 241592),
(323278, 'PTHR31221:SF202', NULL, NULL, NULL, NULL, 'WRKY DNA-BINDING PROTEIN', 241592),
(323279, 'PTHR31221:SF169', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 26-RELATED', 241592),
(323280, 'PTHR31221:SF323', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 23', 241592),
(323281, 'PTHR31221:SF160', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 45-RELATED', 241592),
(323282, 'PTHR31221:SF285', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR WRKY24-LIKE ISOFORM X1', 241592),
(323283, 'PTHR31221:SF164', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 51 ISOFORM X1-RELATED', 241592),
(323284, 'PTHR31221:SF284', NULL, NULL, NULL, NULL, 'BNACNNG66020D PROTEIN', 241592),
(323285, 'PTHR31221:SF283', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 59-RELATED', 241592),
(323286, 'PTHR31221:SF329', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 241592),
(323287, 'PTHR31221:SF208', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 56-RELATED', 241592),
(323288, 'PTHR31221:SF328', NULL, NULL, NULL, NULL, 'OS01G0714800 PROTEIN', 241592);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(323289, 'PTHR31221:SF206', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 3-RELATED', 241592),
(323290, 'PTHR31221:SF327', NULL, NULL, NULL, NULL, 'WRKY DNA-BINDING PROTEIN 25-RELATED', 241592),
(323291, 'PTHR31221:SF333', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 3-RELATED', 241592),
(323292, 'PTHR31221:SF332', NULL, NULL, NULL, NULL, 'WRKY DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 241592),
(323293, 'PTHR31221:SF299', NULL, NULL, NULL, NULL, 'OS01G0626400 PROTEIN', 241592),
(323294, 'PTHR31221:SF298', NULL, NULL, NULL, NULL, 'OS04G0471700 PROTEIN', 241592),
(323295, 'PTHR31221:SF96', NULL, NULL, NULL, NULL, 'OS05G0343400 PROTEIN', 241592),
(323296, 'PTHR31221:SF331', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 241592),
(323297, 'PTHR31221:SF330', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 241592),
(323298, 'PTHR31221:SF337', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 57-RELATED', 241592),
(323299, 'PTHR31221:SF336', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 32', 241592),
(323300, 'PTHR31221:SF215', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN-RELATED', 241592),
(323301, 'PTHR31221:SF335', NULL, NULL, NULL, NULL, 'OS01G0584900 PROTEIN', 241592),
(323302, 'PTHR31221:SF334', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 57-RELATED', 241592),
(323303, 'PTHR31221:SF292', NULL, NULL, NULL, NULL, 'BNAA10G10500D PROTEIN', 241592),
(323304, 'PTHR31221:SF171', NULL, NULL, NULL, NULL, 'OS05G0537100 PROTEIN', 241592),
(323305, 'PTHR31221:SF17', NULL, NULL, NULL, NULL, 'OS01G0182700 PROTEIN', 241592),
(323306, 'PTHR31221:SF291', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 20-RELATED', 241592),
(323307, 'PTHR31221:SF174', NULL, NULL, NULL, NULL, 'OS05G0474800 PROTEIN', 241592),
(323308, 'PTHR31221:SF295', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 48-RELATED', 241592),
(323309, 'PTHR31221:SF339', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 50-RELATED', 241592),
(323310, 'PTHR31221:SF338', NULL, NULL, NULL, NULL, 'OS08G0499300 PROTEIN', 241592),
(323311, 'PTHR31221:SF300', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 71-RELATED', 241592),
(323312, 'PTHR31221:SF42', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 49-RELATED', 241592),
(323313, 'PTHR31221:SF265', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR', 241592),
(323314, 'PTHR31221:SF304', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN-RELATED', 241592),
(323315, 'PTHR31221:SF303', NULL, NULL, NULL, NULL, 'BNAA03G48160D PROTEIN', 241592),
(323316, 'PTHR31221:SF49', NULL, NULL, NULL, NULL, 'OS03G0758950 PROTEIN', 241592),
(323317, 'PTHR31221:SF262', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 241592),
(323318, 'PTHR31221:SF141', NULL, NULL, NULL, NULL, 'WRKY PROTEIN', 241592),
(323319, 'PTHR31221:SF261', NULL, NULL, NULL, NULL, 'OS03G0657400 PROTEIN', 241592),
(323320, 'PTHR31221:SF260', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 34-RELATED', 241592),
(323321, 'PTHR31221:SF308', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 241592),
(323322, 'PTHR31221:SF307', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR WRKY FAMILY-RELATED', 241592),
(323323, 'PTHR31221:SF306', NULL, NULL, NULL, NULL, 'BNAA03G48030D PROTEIN', 241592),
(323324, 'PTHR31221:SF305', NULL, NULL, NULL, NULL, 'OS05G0583000 PROTEIN', 241592),
(323325, 'PTHR31221:SF309', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 32-RELATED', 241592),
(323326, 'PTHR31221:SF311', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 241592),
(323327, 'PTHR31221:SF310', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 51-RELATED', 241592),
(323328, 'PTHR31221:SF277', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 43-RELATED', 241592),
(323329, 'PTHR31221:SF315', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 2 ISOFORM X1-RELATED', 241592),
(323330, 'PTHR31221:SF314', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR WRKY FAMILY-RELATED', 241592),
(323331, 'PTHR31221:SF313', NULL, NULL, NULL, NULL, 'OS09G0481700 PROTEIN', 241592);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(323332, 'PTHR31221:SF159', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 241592),
(323333, 'PTHR31221:SF279', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 241592),
(323334, 'PTHR31221:SF312', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 241592),
(323335, 'PTHR31221:SF38', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 241592),
(323336, 'PTHR31221:SF273', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 241592),
(323337, 'PTHR31221:SF152', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 8', 241592),
(323338, 'PTHR31221:SF272', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN-RELATED', 241592),
(323339, 'PTHR31221:SF150', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 32-RELATED', 241592),
(323340, 'PTHR31221:SF319', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN-RELATED', 241592),
(323341, 'PTHR31221:SF318', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 2-RELATED', 241592),
(323342, 'PTHR31221:SF317', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 2 ISOFORM X1-RELATED', 241592),
(323343, 'PTHR31221:SF316', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 241592),
(323344, 'PTHR33995:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG07696', 241593),
(323345, 'PTHR33995:SF12', NULL, NULL, NULL, NULL, '', 241593),
(323346, 'PTHR33995:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG19312', 241593),
(323347, 'PTHR33995:SF8', NULL, NULL, NULL, NULL, 'PRION-LIKE-(Q/N-RICH)-DOMAIN-BEARING PROTEIN', 241593),
(323348, 'PTHR33995', NULL, NULL, NULL, NULL, 'PROTEIN CBG18546', 241593),
(323349, 'PTHR33995:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG09882', 241593),
(323350, 'PTHR28161:SF1', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT F, MITOCHONDRIAL', 241594),
(323351, 'PTHR28161', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT F, MITOCHONDRIAL', 241594),
(323352, 'PTHR28164', NULL, NULL, NULL, NULL, 'PROTEIN STB3', 241595),
(323353, 'PTHR28164:SF1', NULL, NULL, NULL, NULL, 'PROTEIN STB3', 241595),
(323354, 'PTHR39168:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 241596),
(323355, 'PTHR39168', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', 241596),
(323356, 'PTHR39168:SF2', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR CMTR', 241596),
(323357, 'PTHR19134:SF285', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE NON-RECEPTOR TYPE 9', 241597),
(323358, 'PTHR19134:SF461', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE TYROSINE-PROTEIN PHOSPHATASE ZETA', 241597),
(323359, 'PTHR19134:SF538', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE 2', 241597),
(323360, 'PTHR19134:SF339', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE-PHOSPHATASE', 241597),
(323361, 'PTHR19134:SF537', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE', 241597),
(323362, 'PTHR19134:SF518', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE-PHOSPHATASE', 241597),
(323363, 'PTHR19134:SF539', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE TYROSINE-PROTEIN PHOSPHATASE C', 241597),
(323364, 'PTHR19134:SF534', NULL, NULL, NULL, NULL, 'LD27988P', 241597),
(323365, 'PTHR19134:SF533', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE LAR-LIKE PROTEIN', 241597),
(323366, 'PTHR19134:SF536', NULL, NULL, NULL, NULL, '', 241597),
(323367, 'PTHR19134:SF535', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE 3', 241597),
(323368, 'PTHR19134:SF211', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE TYROSINE-PROTEIN PHOSPHATASE ETA', 241597),
(323369, 'PTHR19134:SF530', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE 1', 241597),
(323370, 'PTHR19134', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE TYROSINE-PROTEIN PHOSPHATASE', 241597),
(323371, 'PTHR19134:SF430', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE TYROSINE-PROTEIN PHOSPHATASE DELTA', 241597),
(323372, 'PTHR19134:SF331', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE TYROSINE-PROTEIN PHOSPHATASE V', 241597),
(323373, 'PTHR19134:SF499', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE TYROSINE-PROTEIN PHOSPHATASE EPSILON', 241597),
(323374, 'PTHR19134:SF532', NULL, NULL, NULL, NULL, 'TYROSINE PHOSPHATASE (PYP1), PUTATIVE (AFU_ORTHOLOGUE AFUA_4G04710)-RELATED', 241597);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(323375, 'PTHR19134:SF477', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE', 241597),
(323376, 'PTHR19134:SF433', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE TYROSINE-PROTEIN PHOSPHATASE ALPHA', 241597),
(323377, 'PTHR19134:SF531', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE LAR', 241597),
(323378, 'PTHR19134:SF492', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE-PHOSPHATASE PTP1', 241597),
(323379, 'PTHR19134:SF495', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE 69D', 241597),
(323380, 'PTHR19134:SF297', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE TYROSINE-PROTEIN PHOSPHATASE H', 241597),
(323381, 'PTHR19134:SF451', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE TYROSINE-PROTEIN PHOSPHATASE', 241597),
(323382, 'PTHR19134:SF208', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE TYROSINE-PROTEIN PHOSPHATASE T', 241597),
(323383, 'PTHR19134:SF527', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE NON-RECEPTOR TYPE 7', 241597),
(323384, 'PTHR19134:SF526', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE 1', 241597),
(323385, 'PTHR19134:SF328', NULL, NULL, NULL, NULL, 'PROTEIN TYROSINE PHOSPHATASE NON-RECEPTOR TYPE 9B', 241597),
(323386, 'PTHR19134:SF207', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE TYROSINE-PROTEIN PHOSPHATASE U', 241597),
(323387, 'PTHR19134:SF449', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE TYROSINE-PROTEIN PHOSPHATASE S', 241597),
(323388, 'PTHR19134:SF529', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE 1', 241597),
(323389, 'PTHR19134:SF528', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE TYROSINE-PROTEIN PHOSPHATASE MU-LIKE', 241597),
(323390, 'PTHR19134:SF209', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE TYROSINE-PROTEIN PHOSPHATASE KAPPA', 241597),
(323391, 'PTHR19134:SF523', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE 3', 241597),
(323392, 'PTHR19134:SF468', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE TYROSINE-PROTEIN PHOSPHATASE GAMMA', 241597),
(323393, 'PTHR19134:SF445', NULL, NULL, NULL, NULL, 'INACTIVE PROTEIN-TYROSINE PHOSPHATASE EGG-4-RELATED', 241597),
(323394, 'PTHR19134:SF522', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE-PHOSPHATASE', 241597),
(323395, 'PTHR19134:SF203', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE TYROSINE-PROTEIN PHOSPHATASE F', 241597),
(323396, 'PTHR19134:SF206', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE TYROSINE-PROTEIN PHOSPHATASE MU', 241597),
(323397, 'PTHR19134:SF525', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 241597),
(323398, 'PTHR19134:SF524', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 241597),
(323399, 'PTHR19134:SF541', NULL, NULL, NULL, NULL, 'IP14232P-RELATED', 241597),
(323400, 'PTHR19134:SF540', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE 99A', 241597),
(323401, 'PTHR19134:SF521', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE-RELATED', 241597),
(323402, 'PTHR19134:SF487', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE-PHOSPHATASE PTP1-LIKE ISOFORM X1', 241597),
(323403, 'PTHR42780', NULL, NULL, NULL, NULL, 'SOLEUCYL-TRNA SYNTHETASE', 241598),
(323404, 'PTHR42780:SF2', NULL, NULL, NULL, NULL, 'ISOLEUCYL-TRNA SYNTHETASE', 241598),
(323405, 'PTHR42780:SF1', NULL, NULL, NULL, NULL, 'ISOLEUCINE--TRNA LIGASE, CYTOPLASMIC', 241598),
(323406, 'PTHR48173', NULL, NULL, NULL, NULL, 'GNK2-HOMOLOGOUS DOMAIN-CONTAINING PROTEIN', 241599),
(323407, 'PTHR48173:SF4', NULL, NULL, NULL, NULL, '', 241599),
(323408, 'PTHR48173:SF3', NULL, NULL, NULL, NULL, 'PROCESSING PROTEIN PRP39, PUTATIVE-RELATED', 241599),
(323409, 'PTHR48173:SF2', NULL, NULL, NULL, NULL, 'GNK2-HOMOLOGOUS DOMAIN-CONTAINING PROTEIN', 241599),
(323410, 'PTHR48173:SF1', NULL, NULL, NULL, NULL, 'PROCESSING PROTEIN PRP39, PUTATIVE-RELATED', 241599),
(323411, 'PTHR23336', NULL, NULL, NULL, NULL, 'ZINC FINGER CW-TYPE COILED-COIL DOMAIN PROTEIN 3.', 241600),
(323412, 'PTHR23336:SF77', NULL, NULL, NULL, NULL, 'PROTEIN MICRORCHIDIA 4', 241600),
(323413, 'PTHR23336:SF44', NULL, NULL, NULL, NULL, 'PROTEIN MICRORCHIDIA 6', 241600),
(323414, 'PTHR23336:SF11', NULL, NULL, NULL, NULL, 'OS06G0622000 PROTEIN', 241600);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(323415, 'PTHR23336:SF22', NULL, NULL, NULL, NULL, 'MORC FAMILY CW-TYPE ZINC FINGER PROTEIN 4', 241600),
(323416, 'PTHR23336:SF56', NULL, NULL, NULL, NULL, 'MORC6_S5 DOMAIN-CONTAINING PROTEIN', 241600),
(323417, 'PTHR23336:SF67', NULL, NULL, NULL, NULL, 'MORC6_S5 DOMAIN-CONTAINING PROTEIN', 241600),
(323418, 'PTHR23336:SF75', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE-, DNA GYRASE B', 241600),
(323419, 'PTHR23336:SF54', NULL, NULL, NULL, NULL, 'OS02G0469300 PROTEIN', 241600),
(323420, 'PTHR23336:SF65', NULL, NULL, NULL, NULL, 'PROTEIN MICRORCHIDIA 6', 241600),
(323421, 'PTHR23336:SF76', NULL, NULL, NULL, NULL, 'CW-TYPE DOMAIN-CONTAINING PROTEIN', 241600),
(323422, 'PTHR23336:SF73', NULL, NULL, NULL, NULL, 'PROTEIN MICRORCHIDIA 6', 241600),
(323423, 'PTHR23336:SF74', NULL, NULL, NULL, NULL, 'MORC6_S5 DOMAIN-CONTAINING PROTEIN', 241600),
(323424, 'PTHR23336:SF60', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE-LIKE ATPASE, C-TERMINAL DOMAIN-CONTAINING PROTEIN-RELATED', 241600),
(323425, 'PTHR23336:SF50', NULL, NULL, NULL, NULL, 'PROTEIN MICRORCHIDIA 1-RELATED', 241600),
(323426, 'PTHR23336:SF72', NULL, NULL, NULL, NULL, 'PROTEIN MICRORCHIDIA 5', 241600),
(323427, 'PTHR23336:SF61', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE-LIKE ATPASE, C-TERMINAL DOMAIN-CONTAINING PROTEIN-RELATED', 241600),
(323428, 'PTHR23336:SF17', NULL, NULL, NULL, NULL, 'MORC FAMILY CW-TYPE ZINC FINGER PROTEIN 3', 241600),
(323429, 'PTHR23336:SF59', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE-, DNA GYRASE B-, AND HSP90-LIKE ATPASE FAMILY PROTEIN-RELATED', 241600),
(323430, 'PTHR23336:SF68', NULL, NULL, NULL, NULL, 'MORC6_S5 DOMAIN-CONTAINING PROTEIN', 241600),
(323431, 'PTHR23336:SF57', NULL, NULL, NULL, NULL, 'MORC6_S5 DOMAIN-CONTAINING PROTEIN', 241600),
(323432, 'PTHR23336:SF69', NULL, NULL, NULL, NULL, 'PROTEIN MICRORCHIDIA 7-LIKE', 241600),
(323433, 'PTHR23336:SF58', NULL, NULL, NULL, NULL, 'PROTEIN MICRORCHIDIA 7', 241600),
(323434, 'PTHR42305:SF1', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN RV1733C-RELATED', 241601),
(323435, 'PTHR42305', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN RV1733C-RELATED', 241601),
(323436, 'PTHR42827', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER-BINDING PROTEIN-RELATED', 241602),
(323437, 'PTHR42827:SF1', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER BINDING PROTEIN', 241602),
(323438, 'PTHR36419', NULL, NULL, NULL, NULL, 'ARRESTIN FAMILY PROTEIN 1', 241603),
(323439, 'PTHR36419:SF1', NULL, NULL, NULL, NULL, 'RHO1 GEF LOCALIZING PROTEIN 1', 241603),
(323440, 'PTHR35351:SF1', NULL, NULL, NULL, NULL, 'GERMINAL CENTER-ASSOCIATED SIGNALING AND MOTILITY-LIKE PROTEIN', 241604),
(323441, 'PTHR35351', NULL, NULL, NULL, NULL, 'GERMINAL CENTER-ASSOCIATED SIGNALING AND MOTILITY-LIKE PROTEIN', 241604),
(323442, 'PTHR35351:SF2', NULL, NULL, NULL, NULL, 'GERMINAL CENTER-ASSOCIATED SIGNALING AND MOTILITY PROTEIN', 241604),
(323443, 'PTHR43255:SF6', NULL, NULL, NULL, NULL, 'IRON-SULFUR-BINDING OXIDOREDUCTASE FADF-RELATED', 241605),
(323444, 'PTHR43255:SF2', NULL, NULL, NULL, NULL, 'HETERODISULFIDE REDUCTASE RELATED PROTEIN', 241605),
(323445, 'PTHR43255', NULL, NULL, NULL, NULL, 'IRON-SULFUR-BINDING OXIDOREDUCTASE FADF-RELATED-RELATED', 241605),
(323446, 'PTHR43255:SF1', NULL, NULL, NULL, NULL, 'FERREDOXIN:COB-COM HETERODISULFIDE REDUCTASE SUBUNIT C', 241605),
(323447, 'PTHR11311:SF29', NULL, NULL, NULL, NULL, 'THROMBOSPONDIN, TYPE I, DOMAIN-CONTAINING 7AB', 241606),
(323448, 'PTHR11311:SF8', NULL, NULL, NULL, NULL, 'THROMBOSPONDIN TYPE-1 DOMAIN-CONTAINING PROTEIN 7A', 241606),
(323449, 'PTHR11311:SF16', NULL, NULL, NULL, NULL, 'SPONDIN-1', 241606),
(323450, 'PTHR11311:SF15', NULL, NULL, NULL, NULL, 'SPONDIN-2', 241606),
(323451, 'PTHR11311:SF23', NULL, NULL, NULL, NULL, 'F-SPONDIN', 241606),
(323452, 'PTHR11311', NULL, NULL, NULL, NULL, 'SPONDIN', 241606),
(323453, 'PTHR11311:SF31', NULL, NULL, NULL, NULL, '', 241606),
(323454, 'PTHR11311:SF30', NULL, NULL, NULL, NULL, 'TSP1_SPONDIN DOMAIN-CONTAINING PROTEIN', 241606),
(323455, 'PTHR11311:SF7', NULL, NULL, NULL, NULL, 'THROMBOSPONDIN TYPE-1 DOMAIN-CONTAINING PROTEIN 7B', 241606);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(323456, 'PTHR46643:SF1', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN GOOSECOID-2', 241607),
(323457, 'PTHR46643:SF3', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN GOOSECOID', 241607),
(323458, 'PTHR46643:SF2', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN GOOSECOID', 241607),
(323459, 'PTHR46643', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN GOOSECOID-RELATED', 241607),
(323460, 'PTHR47407', NULL, NULL, NULL, NULL, 'PROTEIN CBG15905-RELATED', 241608),
(323461, 'PTHR47407:SF2', NULL, NULL, NULL, NULL, 'CUB_2 DOMAIN-CONTAINING PROTEIN', 241608),
(323462, 'PTHR47407:SF1', NULL, NULL, NULL, NULL, 'CUB_2 DOMAIN-CONTAINING PROTEIN', 241608),
(323463, 'PTHR14347', NULL, NULL, NULL, NULL, 'CLAUDIN DOMAIN-CONTAINING PROTEIN 1', 241609),
(323464, 'PTHR14347:SF3', NULL, NULL, NULL, NULL, 'CLAUDIN DOMAIN-CONTAINING PROTEIN 1', 241609),
(323465, 'PTHR28556:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 106B', 241610),
(323466, 'PTHR28556:SF6', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 106A', 241610),
(323467, 'PTHR28556:SF5', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 106C', 241610),
(323468, 'PTHR28556:SF4', NULL, NULL, NULL, NULL, '', 241610),
(323469, 'PTHR28556:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 106A', 241610),
(323470, 'PTHR28556', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 106B', 241610),
(323471, 'PTHR46689:SF1', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN, PUTATIVE-RELATED', 241611),
(323472, 'PTHR46689:SF3', NULL, NULL, NULL, NULL, '', 241611),
(323473, 'PTHR46689:SF2', NULL, NULL, NULL, NULL, 'WW DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_6G06520)', 241611),
(323474, 'PTHR46689', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN, PUTATIVE-RELATED', 241611),
(323475, 'PTHR38009:SF1', NULL, NULL, NULL, NULL, 'CONSERVED HYPOTHETICAL PHAGE TAIL PROTEIN', 241612),
(323476, 'PTHR38009', NULL, NULL, NULL, NULL, 'CONSERVED HYPOTHETICAL PHAGE TAIL PROTEIN', 241612),
(323477, 'PTHR43456', NULL, NULL, NULL, NULL, 'RIESKE (2FE-2S) DOMAIN-CONTAINING PROTEIN', 241613),
(323478, 'PTHR43456:SF2', NULL, NULL, NULL, NULL, 'RIESKE (2FE-2S) DOMAIN-CONTAINING PROTEIN', 241613),
(323479, 'PTHR13093', NULL, NULL, NULL, NULL, 'ZINC FINGER HIT DOMAIN CONTAINING PROTEIN 1', 241614),
(323480, 'PTHR13093:SF2', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX59-RELATED', 241614),
(323481, 'PTHR13093:SF1', NULL, NULL, NULL, NULL, 'HIT-TYPE DOMAIN-CONTAINING PROTEIN', 241614),
(323482, 'PTHR13093:SF0', NULL, NULL, NULL, NULL, 'ZINC FINGER HIT DOMAIN-CONTAINING PROTEIN 1', 241614),
(323483, 'PTHR13371:SF0', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 104 KDA', 241615),
(323484, 'PTHR13371', NULL, NULL, NULL, NULL, 'GLYCINE-, GLUTAMATE-, THIENYLCYCLOHEXYLPIPERIDINE-BINDING PROTEIN', 241615),
(323485, 'PTHR13371:SF3', NULL, NULL, NULL, NULL, '', 241615),
(323486, 'PTHR13371:SF11', NULL, NULL, NULL, NULL, 'PROTEIN CBG12963', 241615),
(323487, 'PTHR33355:SF10', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 241616),
(323488, 'PTHR33355:SF18', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 241616),
(323489, 'PTHR33355:SF5', NULL, NULL, NULL, NULL, 'F12F1.23 PROTEIN', 241616),
(323490, 'PTHR33355:SF15', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE-LIKE 20', 241616),
(323491, 'PTHR33355:SF14', NULL, NULL, NULL, NULL, 'GUB_WAK_BIND DOMAIN-CONTAINING PROTEIN', 241616),
(323492, 'PTHR33355:SF3', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE GALACTURONAN-BINDING PROTEIN', 241616),
(323493, 'PTHR33355:SF13', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE 3-LIKE', 241616),
(323494, 'PTHR33355:SF1', NULL, NULL, NULL, NULL, 'GUB_WAK_BIND DOMAIN-CONTAINING PROTEIN', 241616),
(323495, 'PTHR33355:SF12', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE CARBOXY-TERMINAL PROTEIN', 241616),
(323496, 'PTHR33355:SF11', NULL, NULL, NULL, NULL, '', 241616),
(323497, 'PTHR33355', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE CARBOXY-TERMINAL PROTEIN-RELATED', 241616),
(323498, 'PTHR37720:SF2', NULL, NULL, NULL, NULL, 'OS10G0481400 PROTEIN', 241617),
(323499, 'PTHR37720', NULL, NULL, NULL, NULL, 'OS10G0481400 PROTEIN', 241617);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(323500, 'PTHR37720:SF4', NULL, NULL, NULL, NULL, 'BNAA04G28390D PROTEIN', 241617),
(323501, 'PTHR37264', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L31', 241618),
(323502, 'PTHR37264:SF2', NULL, NULL, NULL, NULL, 'BNAA10G09370D PROTEIN', 241618),
(323503, 'PTHR37264:SF1', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L31', 241618),
(323504, 'PTHR43301:SF5', NULL, NULL, NULL, NULL, 'ARABINAN ENDO-1,5-ALPHA-L-ARABINOSIDASE D-RELATED', 241619),
(323505, 'PTHR43301:SF4', NULL, NULL, NULL, NULL, 'ARABINAN ENDO-1,5-ALPHA-L-ARABINOSIDASE B', 241619),
(323506, 'PTHR43301:SF3', NULL, NULL, NULL, NULL, 'ARABINAN ENDO-1,5-ALPHA-L-ARABINOSIDASE A-RELATED', 241619),
(323507, 'PTHR43301:SF7', NULL, NULL, NULL, NULL, 'ARABINAN ENDO-1,5-ALPHA-L-ARABINOSIDASE C', 241619),
(323508, 'PTHR43301', NULL, NULL, NULL, NULL, 'ARABINAN ENDO-1,5-ALPHA-L-ARABINOSIDASE', 241619),
(323509, 'PTHR24220:SF614', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN SCO2324-RELATED', 241620),
(323510, 'PTHR24220:SF659', NULL, NULL, NULL, NULL, 'BLL1002 PROTEIN', 241620),
(323511, 'PTHR24220:SF676', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORT ATP-BINDING PROTEIN AMIE', 241620),
(323512, 'PTHR24220:SF654', NULL, NULL, NULL, NULL, 'LIPOPROTEIN-RELEASING SYSTEM ATP-BINDING PROTEIN LOLD', 241620),
(323513, 'PTHR24220:SF611', NULL, NULL, NULL, NULL, 'ATP-BINDING COMPONENT OF ABC TRANSPORTER-RELATED', 241620),
(323514, 'PTHR24220:SF677', NULL, NULL, NULL, NULL, 'LIPOPROTEIN-RELEASING SYSTEM ATP-BINDING PROTEIN LOLD 2', 241620),
(323515, 'PTHR24220:SF678', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, ATP-BINDING PROTEIN', 241620),
(323516, 'PTHR24220:SF612', NULL, NULL, NULL, NULL, 'FE(3+) IONS IMPORT ATP-BINDING PROTEIN FBPC 2', 241620),
(323517, 'PTHR24220:SF679', NULL, NULL, NULL, NULL, 'FE(3+) IONS IMPORT ATP-BINDING PROTEIN FBPC', 241620),
(323518, 'PTHR24220:SF452', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN', 241620),
(323519, 'PTHR24220:SF376', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER', 241620),
(323520, 'PTHR24220:SF674', NULL, NULL, NULL, NULL, 'BACITRACIN EXPORT ATP-BINDING PROTEIN BCEA', 241620),
(323521, 'PTHR24220:SF470', NULL, NULL, NULL, NULL, 'CELL DIVISION ATP-BINDING PROTEIN FTSE', 241620),
(323522, 'PTHR24220:SF86', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER H FAMILY MEMBER 2', 241620),
(323523, 'PTHR24220:SF494', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN YXDL', 241620),
(323524, 'PTHR24220:SF607', NULL, NULL, NULL, NULL, 'NICKEL IMPORT ATP-BINDING PROTEIN NIKD', 241620),
(323525, 'PTHR24220', NULL, NULL, NULL, NULL, 'IMPORT ATP-BINDING PROTEIN', 241620),
(323526, 'PTHR24220:SF648', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN', 241620),
(323527, 'PTHR24220:SF666', NULL, NULL, NULL, NULL, 'HEMIN IMPORT ATP-BINDING PROTEIN HRTA-RELATED', 241620),
(323528, 'PTHR24220:SF667', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN-PEP EXPORT', 241620),
(323529, 'PTHR24220:SF364', NULL, NULL, NULL, NULL, 'FLUOROQUINOLONES EXPORT ATP-BINDING PROTEIN RV2688C', 241620),
(323530, 'PTHR24220:SF662', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN', 241620),
(323531, 'PTHR24220:SF680', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN', 241620),
(323532, 'PTHR24220:SF681', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ABCH.1', 241620),
(323533, 'PTHR24220:SF682', NULL, NULL, NULL, NULL, 'LIPOPROTEIN-RELEASING SYSTEM ATP-BINDING PROTEIN LOLD', 241620),
(323534, 'PTHR43816:SF3', NULL, NULL, NULL, NULL, 'NICOTINAMIDE PHOSPHORIBOSYLTRANSFERASE', 241621),
(323535, 'PTHR43816:SF1', NULL, NULL, NULL, NULL, 'NICOTINAMIDE PHOSPHORIBOSYLTRANSFERASE', 241621),
(323536, 'PTHR43816:SF2', NULL, NULL, NULL, NULL, 'NICOTINAMIDE PHOSPHORIBOSYLTRANSFERASE', 241621),
(323537, 'PTHR43816', NULL, NULL, NULL, NULL, 'NICOTINAMIDE PHOSPHORIBOSYLTRANSFERASE', 241621),
(323538, 'PTHR13412', NULL, NULL, NULL, NULL, 'T-CELL IMMUNOMODULATORY PROTEIN HOMOLOG', 241622),
(323539, 'PTHR13412:SF0', NULL, NULL, NULL, NULL, 'T-CELL IMMUNOMODULATORY PROTEIN', 241622),
(323540, 'PTHR11895:SF158', NULL, NULL, NULL, NULL, 'FATTY ACID AMIDE HYDROLASE-LIKE PROTEIN', 241623);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(323541, 'PTHR11895:SF135', NULL, NULL, NULL, NULL, 'AMIDASE FAMILY PROTEIN, EXPRESSED', 241623),
(323542, 'PTHR11895:SF157', NULL, NULL, NULL, NULL, 'FATTY ACID AMIDE HYDROLASE-LIKE', 241623),
(323543, 'PTHR11895:SF67', NULL, NULL, NULL, NULL, 'AMIDASE DOMAIN-CONTAINING PROTEIN', 241623),
(323544, 'PTHR11895:SF176', NULL, NULL, NULL, NULL, 'AMIDASE AMID-RELATED', 241623),
(323545, 'PTHR11895:SF175', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA(GLN) AMIDOTRANSFERASE SUBUNIT A-RELATED', 241623),
(323546, 'PTHR11895:SF153', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA(GLN) AMIDOTRANSFERASE SUBUNIT A, MITOCHONDRIAL', 241623),
(323547, 'PTHR11895:SF156', NULL, NULL, NULL, NULL, 'FATTY ACID AMIDE HYDROLASE', 241623),
(323548, 'PTHR11895:SF172', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA(GLN) AMIDOTRANSFERASE', 241623),
(323549, 'PTHR11895:SF150', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA(GLN) AMIDOTRANSFERASE SUBUNIT A-LIKE ISOFORM X1', 241623),
(323550, 'PTHR11895:SF83', NULL, NULL, NULL, NULL, 'AMIDASE', 241623),
(323551, 'PTHR11895:SF171', NULL, NULL, NULL, NULL, '', 241623),
(323552, 'PTHR11895:SF174', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA AMIDOTRANSFERASE, SUBUNIT A (GATA-1)', 241623),
(323553, 'PTHR11895:SF152', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA(GLN) AMIDOTRANSFERASE, SUBUNIT A (AFU_ORTHOLOGUE AFUA_7G06800)', 241623),
(323554, 'PTHR11895:SF173', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA AMIDOTRANSFERASE SUBUNIT A', 241623),
(323555, 'PTHR11895:SF151', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA(GLN) AMIDOTRANSFERASE SUBUNIT A', 241623),
(323556, 'PTHR11895', NULL, NULL, NULL, NULL, 'TRANSAMIDASE', 241623),
(323557, 'PTHR11895:SF170', NULL, NULL, NULL, NULL, 'AMIDASE DOMAIN-CONTAINING PROTEIN', 241623),
(323558, 'PTHR11895:SF7', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA(GLN) AMIDOTRANSFERASE SUBUNIT A, MITOCHONDRIAL', 241623),
(323559, 'PTHR11895:SF109', NULL, NULL, NULL, NULL, 'AMIDASE', 241623),
(323560, 'PTHR11895:SF169', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA(GLN) AMIDOTRANSFERASE', 241623),
(323561, 'PTHR11895:SF149', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA(GLN) AMIDOTRANSFERASE SUBUNIT A, MITOCHONDRIAL', 241623),
(323562, 'PTHR11895:SF165', NULL, NULL, NULL, NULL, 'FATTY ACID AMIDE HYDROLASE-LIKE ISOFORM X1', 241623),
(323563, 'PTHR11895:SF164', NULL, NULL, NULL, NULL, 'AMIDASE DOMAIN-CONTAINING PROTEIN', 241623),
(323564, 'PTHR11895:SF167', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA(GLN) AMIDOTRANSFERASE SUBUNIT A-RELATED', 241623),
(323565, 'PTHR11895:SF73', NULL, NULL, NULL, NULL, 'AMIDASE FAMILY PROTEIN', 241623),
(323566, 'PTHR11895:SF76', NULL, NULL, NULL, NULL, 'BLL2914 PROTEIN', 241623),
(323567, 'PTHR31652:SF2', NULL, NULL, NULL, NULL, 'BNAC05G43630D PROTEIN', 241624),
(323568, 'PTHR31652:SF0', NULL, NULL, NULL, NULL, 'LIMR FAMILY PROTEIN DDB_G0283707-RELATED', 241624),
(323569, 'PTHR31652:SF1', NULL, NULL, NULL, NULL, '', 241624),
(323570, 'PTHR31652', NULL, NULL, NULL, NULL, 'LIMR FAMILY PROTEIN DDB_G0283707-RELATED', 241624),
(323571, 'PTHR37305', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN-RELATED', 241625),
(323572, 'PTHR37305:SF1', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, MEMBRANE PROTEIN-RELATED', 241625),
(323573, 'PTHR37305:SF2', NULL, NULL, NULL, NULL, 'BACITRACIN TRANSPORT PERMEASE PROTEIN BCRB', 241625),
(323574, 'PTHR35112:SF1', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER SUPERFAMILY PROTEIN', 241626),
(323575, 'PTHR35112:SF2', NULL, NULL, NULL, NULL, '', 241626),
(323576, 'PTHR35112', NULL, NULL, NULL, NULL, 'OS08G0360500 PROTEIN', 241626),
(323577, 'PTHR45798:SF55', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN-RELATED', 241627),
(323578, 'PTHR45798:SF53', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 241627),
(323579, 'PTHR45798:SF97', NULL, NULL, NULL, NULL, 'ALCOHOL-SENSITIVE RING FINGER PROTEIN 1', 241627),
(323580, 'PTHR45798:SF98', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT 11 RING-H2 FINGER PROTEIN', 241627),
(323581, 'PTHR45798:SF54', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 241627),
(323582, 'PTHR45798:SF95', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 241627);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(323583, 'PTHR45798:SF96', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 241627),
(323584, 'PTHR45798:SF93', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL72-LIKE', 241627),
(323585, 'PTHR45798:SF94', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL8-RELATED', 241627),
(323586, 'PTHR45798:SF17', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL73-LIKE', 241627),
(323587, 'PTHR45798:SF16', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ATL23', 241627),
(323588, 'PTHR45798:SF57', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 241627),
(323589, 'PTHR45798:SF13', NULL, NULL, NULL, NULL, 'OS01G0866000 PROTEIN', 241627),
(323590, 'PTHR45798:SF14', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 241627),
(323591, 'PTHR45798:SF58', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL79', 241627),
(323592, 'PTHR45798:SF88', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL61-RELATED', 241627),
(323593, 'PTHR45798:SF44', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL74', 241627),
(323594, 'PTHR45798:SF89', NULL, NULL, NULL, NULL, 'ZINC FINGER, C3HC4 TYPE (RING FINGER) PROTEIN', 241627),
(323595, 'PTHR45798:SF45', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 241627),
(323596, 'PTHR45798:SF86', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 241627),
(323597, 'PTHR45798:SF87', NULL, NULL, NULL, NULL, 'OS12G0148000 PROTEIN', 241627),
(323598, 'PTHR45798:SF43', NULL, NULL, NULL, NULL, 'OS03G0398250 PROTEIN', 241627),
(323599, 'PTHR45798:SF84', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ATL23-LIKE', 241627),
(323600, 'PTHR45798:SF40', NULL, NULL, NULL, NULL, 'OS02G0686100 PROTEIN', 241627),
(323601, 'PTHR45798:SF85', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 241627),
(323602, 'PTHR45798:SF49', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 241627),
(323603, 'PTHR45798:SF46', NULL, NULL, NULL, NULL, 'RING ZINC FINGER DOMAIN SUPERFAMILY PROTEIN-RELATED', 241627),
(323604, 'PTHR45798:SF91', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 241627),
(323605, 'PTHR45798:SF92', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 241627),
(323606, 'PTHR45798:SF90', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL8-LIKE', 241627),
(323607, 'PTHR45798:SF77', NULL, NULL, NULL, NULL, 'OS02G0645000 PROTEIN', 241627),
(323608, 'PTHR45798:SF33', NULL, NULL, NULL, NULL, 'OS06G0666500 PROTEIN', 241627),
(323609, 'PTHR45798:SF78', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 241627),
(323610, 'PTHR45798:SF75', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 241627),
(323611, 'PTHR45798:SF71', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL80-LIKE', 241627),
(323612, 'PTHR45798:SF72', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 241627),
(323613, 'PTHR45798:SF37', NULL, NULL, NULL, NULL, 'OS05G0478000 PROTEIN', 241627),
(323614, 'PTHR45798', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL61-RELATED-RELATED', 241627),
(323615, 'PTHR45798:SF79', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ATL44-RELATED', 241627),
(323616, 'PTHR45798:SF36', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 241627),
(323617, 'PTHR45798:SF80', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241627),
(323618, 'PTHR45798:SF81', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 241627),
(323619, 'PTHR45798:SF66', NULL, NULL, NULL, NULL, 'OS02G0541500 PROTEIN', 241627),
(323620, 'PTHR45798:SF23', NULL, NULL, NULL, NULL, 'OS09G0554200 PROTEIN', 241627),
(323621, 'PTHR45798:SF64', NULL, NULL, NULL, NULL, 'OS01G0822800 PROTEIN', 241627),
(323622, 'PTHR45798:SF20', NULL, NULL, NULL, NULL, 'OS09G0535500 PROTEIN', 241627),
(323623, 'PTHR45798:SF60', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 241627),
(323624, 'PTHR45798:SF28', NULL, NULL, NULL, NULL, 'RING ZINC FINGER DOMAIN SUPERFAMILY PROTEIN-RELATED', 241627),
(323625, 'PTHR45798:SF26', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 241627);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(323626, 'PTHR45798:SF68', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 241627),
(323627, 'PTHR45798:SF69', NULL, NULL, NULL, NULL, 'OS02G0832150 PROTEIN', 241627),
(323628, 'PTHR45798:SF9', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 241627),
(323629, 'PTHR45798:SF8', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL72-RELATED', 241627),
(323630, 'PTHR45798:SF70', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ATL45-RELATED', 241627),
(323631, 'PTHR28520', NULL, NULL, NULL, NULL, 'MITOTIC-SPINDLE ORGANIZING PROTEIN 1', 241628),
(323632, 'PTHR28520:SF2', NULL, NULL, NULL, NULL, 'MITOTIC-SPINDLE ORGANIZING PROTEIN 1', 241628),
(323633, 'PTHR28520:SF12', NULL, NULL, NULL, NULL, 'BNAA07G39080D PROTEIN', 241628),
(323634, 'PTHR28520:SF9', NULL, NULL, NULL, NULL, 'MITOTIC-SPINDLE ORGANIZING PROTEIN 1B-LIKE', 241628),
(323635, 'PTHR31862', NULL, NULL, NULL, NULL, 'UPF0261 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_1G10120)', 241629),
(323636, 'PTHR31862:SF1', NULL, NULL, NULL, NULL, 'UPF0261 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_1G10120)', 241629),
(323637, 'PTHR47620', NULL, NULL, NULL, NULL, 'CHROMOSOME 2 OPEN READING FRAME 66', 241630),
(323638, 'PTHR47620:SF1', NULL, NULL, NULL, NULL, 'GENE, 34066-RELATED', 241630),
(323639, 'PTHR37338:SF1', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 32', 241631),
(323640, 'PTHR37338', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 32', 241631),
(323641, 'PTHR47947:SF50', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 82A3', 241632),
(323642, 'PTHR47947:SF30', NULL, NULL, NULL, NULL, 'CYP81B2V1', 241632),
(323643, 'PTHR47947:SF29', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP82D47-LIKE', 241632),
(323644, 'PTHR47947:SF47', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 81 SUBFAMILY D POLYPEPTIDE 8', 241632),
(323645, 'PTHR47947:SF25', NULL, NULL, NULL, NULL, 'DIMETHYLNONATRIENE SYNTHASE', 241632),
(323646, 'PTHR47947:SF24', NULL, NULL, NULL, NULL, 'ISOFLAVONE 2''-HYDROXYLASE-LIKE', 241632),
(323647, 'PTHR47947:SF46', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 82C2-LIKE', 241632),
(323648, 'PTHR47947:SF49', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 241632),
(323649, 'PTHR47947:SF48', NULL, NULL, NULL, NULL, '', 241632),
(323650, 'PTHR47947:SF26', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 241632),
(323651, 'PTHR47947:SF43', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 82A3-RELATED', 241632),
(323652, 'PTHR47947:SF42', NULL, NULL, NULL, NULL, 'OS02G0503700 PROTEIN', 241632),
(323653, 'PTHR47947:SF20', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 241632),
(323654, 'PTHR47947:SF23', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN, EXPRESSED', 241632),
(323655, 'PTHR47947:SF45', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 81 SUBFAMILY D POLYPEPTIDE 8', 241632),
(323656, 'PTHR47947:SF44', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP82D47-LIKE', 241632),
(323657, 'PTHR47947', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 82C3-RELATED', 241632),
(323658, 'PTHR47947:SF41', NULL, NULL, NULL, NULL, 'CYTOCHROME P450-RELATED', 241632),
(323659, 'PTHR47947:SF40', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 81, SUBFAMILY D, POLYPEPTIDE 5', 241632),
(323660, 'PTHR47947:SF6', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 241632),
(323661, 'PTHR47947:SF9', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 81 SUBFAMILY D POLYPEPTIDE 8', 241632),
(323662, 'PTHR47947:SF8', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 82A1-LIKE', 241632),
(323663, 'PTHR47947:SF3', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN, EXPRESSED', 241632),
(323664, 'PTHR47947:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP82D47-LIKE', 241632),
(323665, 'PTHR47947:SF4', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP81A1', 241632),
(323666, 'PTHR47947:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 241632),
(323667, 'PTHR47947:SF18', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 82A2', 241632),
(323668, 'PTHR47947:SF39', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 241632),
(323669, 'PTHR47947:SF19', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 82C3-RELATED', 241632);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(323670, 'PTHR47947:SF13', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 81, SUBFAMILY K, POLYPEPTIDE 1-RELATED', 241632),
(323671, 'PTHR47947:SF38', NULL, NULL, NULL, NULL, 'P450 82A3, PUTATIVE-RELATED', 241632),
(323672, 'PTHR47947:SF31', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP81N5', 241632),
(323673, 'PTHR47947:SF34', NULL, NULL, NULL, NULL, '', 241632),
(323674, 'PTHR39289', NULL, NULL, NULL, NULL, '', 241633),
(323675, 'PTHR39289:SF1', NULL, NULL, NULL, NULL, 'L-ECTOINE SYNTHASE', 241633),
(323676, 'PTHR12586', NULL, NULL, NULL, NULL, 'CDP-DIACYLGLYCEROL--SERINE O-PHOSPHATIDYLTRANSFERASE', 241634),
(323677, 'PTHR12586:SF1', NULL, NULL, NULL, NULL, 'CDP-DIACYLGLYCEROL--GLYCEROL-3-PHOSPHATE 3-PHOSPHATIDYLTRANSFERASE, MITOCHONDRIAL', 241634),
(323678, 'PTHR42044', NULL, NULL, NULL, NULL, '', 241635),
(323679, 'PTHR42044:SF2', NULL, NULL, NULL, NULL, '', 241635),
(323680, 'PTHR42044:SF1', NULL, NULL, NULL, NULL, '', 241635),
(323681, 'PTHR35204:SF1', NULL, NULL, NULL, NULL, 'YALI0A21131P', 241636),
(323682, 'PTHR35204', NULL, NULL, NULL, NULL, 'YALI0A21131P', 241636),
(323683, 'PTHR43599', NULL, NULL, NULL, NULL, 'MULTIFUNCTIONAL PROTEIN ADE2', 241637),
(323684, 'PTHR43599:SF9', NULL, NULL, NULL, NULL, '', 241637),
(323685, 'PTHR43599:SF6', NULL, NULL, NULL, NULL, 'SI:DKEY-261J15.2-RELATED', 241637),
(323686, 'PTHR43599:SF7', NULL, NULL, NULL, NULL, 'NOVEL PROTEIN', 241637),
(323687, 'PTHR43599:SF8', NULL, NULL, NULL, NULL, '', 241637),
(323688, 'PTHR43599:SF1', NULL, NULL, NULL, NULL, 'ATP-GRASP DOMAIN-CONTAINING PROTEIN', 241637),
(323689, 'PTHR43599:SF3', NULL, NULL, NULL, NULL, 'MULTIFUNCTIONAL PROTEIN ADE2', 241637),
(323690, 'PTHR43599:SF10', NULL, NULL, NULL, NULL, '', 241637),
(323691, 'PTHR11587:SF8', NULL, NULL, NULL, NULL, 'ARGININOSUCCINATE SYNTHASE', 241638),
(323692, 'PTHR11587:SF7', NULL, NULL, NULL, NULL, 'ARGININOSUCCINATE SYNTHASE', 241638),
(323693, 'PTHR11587:SF2', NULL, NULL, NULL, NULL, 'ARGININOSUCCINATE SYNTHASE', 241638),
(323694, 'PTHR11587', NULL, NULL, NULL, NULL, 'ARGININOSUCCINATE SYNTHASE', 241638),
(323695, 'PTHR11587:SF6', NULL, NULL, NULL, NULL, 'CITRULLINE--ASPARTATE LIGASE', 241638),
(323696, 'PTHR11587:SF10', NULL, NULL, NULL, NULL, 'CITRULLINE--ASPARTATE LIGASE', 241638),
(323697, 'PTHR11587:SF5', NULL, NULL, NULL, NULL, 'ARGININOSUCCINATE SYNTHASE', 241638),
(323698, 'PTHR38684:SF1', NULL, NULL, NULL, NULL, 'PROTEIN AMPE', 241639),
(323699, 'PTHR38684', NULL, NULL, NULL, NULL, 'PROTEIN AMPE', 241639),
(323700, 'PTHR37841', NULL, NULL, NULL, NULL, 'GLR2918 PROTEIN', 241640),
(323701, 'PTHR37841:SF1', NULL, NULL, NULL, NULL, 'DUF3298 DOMAIN-CONTAINING PROTEIN', 241640),
(323702, 'PTHR33601:SF26', NULL, NULL, NULL, NULL, 'BNACNNG65040D PROTEIN', 241641),
(323703, 'PTHR33601:SF28', NULL, NULL, NULL, NULL, '', 241641),
(323704, 'PTHR33601:SF29', NULL, NULL, NULL, NULL, 'BNAC04G55270D PROTEIN', 241641),
(323705, 'PTHR33601:SF18', NULL, NULL, NULL, NULL, 'PROTEIN LITTLE ZIPPER 2', 241641),
(323706, 'PTHR33601:SF6', NULL, NULL, NULL, NULL, 'OS12G0151600 PROTEIN', 241641),
(323707, 'PTHR33601:SF4', NULL, NULL, NULL, NULL, 'PROTEIN LITTLE ZIPPER 4-LIKE', 241641),
(323708, 'PTHR33601:SF31', NULL, NULL, NULL, NULL, 'BNAC04G04210D PROTEIN', 241641),
(323709, 'PTHR33601:SF20', NULL, NULL, NULL, NULL, 'BNAC06G14080D PROTEIN', 241641),
(323710, 'PTHR33601:SF32', NULL, NULL, NULL, NULL, 'BNAC04G50200D PROTEIN', 241641),
(323711, 'PTHR33601:SF21', NULL, NULL, NULL, NULL, 'OS09G0520500 PROTEIN', 241641),
(323712, 'PTHR33601:SF33', NULL, NULL, NULL, NULL, 'PROTEIN LITTLE ZIPPER 3', 241641),
(323713, 'PTHR33601:SF22', NULL, NULL, NULL, NULL, 'PROTEIN LITTLE ZIPPER 1', 241641),
(323714, 'PTHR33601:SF23', NULL, NULL, NULL, NULL, 'PROTEIN LITTLE ZIPPER 4-LIKE', 241641),
(323715, 'PTHR33601:SF35', NULL, NULL, NULL, NULL, 'PROTEIN LITTLE ZIPPER 3', 241641),
(323716, 'PTHR33601:SF24', NULL, NULL, NULL, NULL, '', 241641),
(323717, 'PTHR33601:SF36', NULL, NULL, NULL, NULL, '', 241641),
(323718, 'PTHR33601:SF25', NULL, NULL, NULL, NULL, '', 241641),
(323719, 'PTHR33601', NULL, NULL, NULL, NULL, 'PROTEIN LITTLE ZIPPER 4', 241641);
INSERT INTO "PUBLIC"."MODEL" VALUES
(323720, 'PTHR33601:SF1', NULL, NULL, NULL, NULL, 'PROTEIN LITTLE ZIPPER 4', 241641),
(323721, 'PTHR47761:SF2', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN', 241642),
(323722, 'PTHR47761:SF3', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN', 241642),
(323723, 'PTHR47761:SF1', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN', 241642),
(323724, 'PTHR47761', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN-RELATED', 241642),
(323725, 'PTHR47761:SF4', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN', 241642),
(323726, 'PTHR13557', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 241643),
(323727, 'PTHR13557:SF2', NULL, NULL, NULL, NULL, 'BNAA04G18300D PROTEIN', 241643),
(323728, 'PTHR13557:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 86', 241643),
(323729, 'PTHR15600:SF37', NULL, NULL, NULL, NULL, 'SACSIN', 241644),
(323730, 'PTHR15600', NULL, NULL, NULL, NULL, 'SACSIN', 241644),
(323731, 'PTHR15600:SF42', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 241644),
(323732, 'PTHR15600:SF41', NULL, NULL, NULL, NULL, 'HEPN DOMAIN-CONTAINING PROTEIN', 241644),
(323733, 'PTHR47922:SF1', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 241645),
(323734, 'PTHR47922', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 241645),
(323735, 'PTHR23131:SF2', NULL, NULL, NULL, NULL, 'LACTAMASE-LIKE PROTEIN APTB-RELATED', 241646),
(323736, 'PTHR23131:SF1', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G00280)-RELATED', 241646),
(323737, 'PTHR23131:SF4', NULL, NULL, NULL, NULL, 'METALLO-BETA-LACTAMASE SUPERFAMILY POTEIN', 241646),
(323738, 'PTHR23131:SF3', NULL, NULL, NULL, NULL, 'ATROCHRYSONE CARBOXYL ACP THIOESTERASE', 241646),
(323739, 'PTHR23131:SF0', NULL, NULL, NULL, NULL, 'ENDORIBONUCLEASE LACTB2', 241646),
(323740, 'PTHR23131', NULL, NULL, NULL, NULL, 'ENDORIBONUCLEASE LACTB2', 241646),
(323741, 'PTHR21314', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 241647),
(323742, 'PTHR21314:SF1', NULL, NULL, NULL, NULL, 'QUEUOSINE SALVAGE PROTEIN', 241647),
(323743, 'PTHR21314:SF0', NULL, NULL, NULL, NULL, 'QUEUOSINE SALVAGE PROTEIN', 241647),
(323744, 'PTHR28605:SF1', NULL, NULL, NULL, NULL, 'CTF8, CHROMOSOME TRANSMISSION FIDELITY FACTOR 8 HOMOLOG (S. CEREVISIAE)', 241648),
(323745, 'PTHR28605', NULL, NULL, NULL, NULL, 'CTF8, CHROMOSOME TRANSMISSION FIDELITY FACTOR 8 HOMOLOG (S. CEREVISIAE)', 241648),
(323746, 'PTHR28605:SF3', NULL, NULL, NULL, NULL, 'CHROMOSOME TRANSMISSION FIDELITY PROTEIN 8 HOMOLOG', 241648),
(323747, 'PTHR28605:SF2', NULL, NULL, NULL, NULL, 'DECREASED EXPRESSION IN RENAL AND PROSTATE CANCER PROTEIN', 241648),
(323748, 'PTHR31804:SF3', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 15', 241649),
(323749, 'PTHR31804', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 15', 241649),
(323750, 'PTHR31804:SF2', NULL, NULL, NULL, NULL, 'PID DOMAIN-CONTAINING PROTEIN', 241649),
(323751, 'PTHR32382:SF82', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 2', 241650),
(323752, 'PTHR32382:SF81', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 1', 241650),
(323753, 'PTHR32382:SF80', NULL, NULL, NULL, NULL, 'OS08G0321000 PROTEIN', 241650),
(323754, 'PTHR32382:SF67', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 3', 241650),
(323755, 'PTHR32382:SF66', NULL, NULL, NULL, NULL, 'FAS1 DOMAIN-CONTAINING PROTEIN', 241650),
(323756, 'PTHR32382:SF64', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 2', 241650),
(323757, 'PTHR32382:SF86', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN-RELATED', 241650),
(323758, 'PTHR32382:SF85', NULL, NULL, NULL, NULL, 'FAS1 DOMAIN-CONTAINING PROTEIN-RELATED', 241650),
(323759, 'PTHR32382:SF41', NULL, NULL, NULL, NULL, 'OS04G0283600 PROTEIN', 241650),
(323760, 'PTHR32382:SF84', NULL, NULL, NULL, NULL, 'OS01G0841100 PROTEIN', 241650),
(323761, 'PTHR32382:SF83', NULL, NULL, NULL, NULL, 'FAS1 DOMAIN-CONTAINING PROTEIN-RELATED', 241650),
(323762, 'PTHR32382:SF7', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN PROTEIN 8, PUTATIVE, EXPRESSED-RELATED', 241650);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(323763, 'PTHR32382:SF6', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 5', 241650),
(323764, 'PTHR32382:SF5', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 8', 241650),
(323765, 'PTHR32382:SF0', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 4', 241650),
(323766, 'PTHR32382:SF4', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 1', 241650),
(323767, 'PTHR32382:SF71', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 10', 241650),
(323768, 'PTHR32382:SF79', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 14', 241650),
(323769, 'PTHR32382:SF35', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 2', 241650),
(323770, 'PTHR32382:SF57', NULL, NULL, NULL, NULL, 'FAS1 DOMAIN-CONTAINING PROTEIN', 241650),
(323771, 'PTHR32382:SF34', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 3', 241650),
(323772, 'PTHR32382:SF78', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 14', 241650),
(323773, 'PTHR32382:SF33', NULL, NULL, NULL, NULL, 'OS02G0726000 PROTEIN', 241650),
(323774, 'PTHR32382:SF76', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 4', 241650),
(323775, 'PTHR32382:SF54', NULL, NULL, NULL, NULL, 'FAS1 DOMAIN-CONTAINING PROTEIN', 241650),
(323776, 'PTHR32382:SF53', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 241650),
(323777, 'PTHR32382:SF74', NULL, NULL, NULL, NULL, 'FAS1 DOMAIN-CONTAINING PROTEIN', 241650),
(323778, 'PTHR32382:SF52', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 241650),
(323779, 'PTHR32382:SF50', NULL, NULL, NULL, NULL, 'FAS1 DOMAIN-CONTAINING PROTEIN', 241650),
(323780, 'PTHR32382:SF37', NULL, NULL, NULL, NULL, 'OS02G0461000 PROTEIN', 241650),
(323781, 'PTHR32382:SF58', NULL, NULL, NULL, NULL, 'BNAA02G08870D PROTEIN', 241650),
(323782, 'PTHR32382', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN', 241650),
(323783, 'PTHR37938', NULL, NULL, NULL, NULL, 'BLL0215 PROTEIN', 241651),
(323784, 'PTHR37938:SF1', NULL, NULL, NULL, NULL, 'BLL0215 PROTEIN', 241651),
(323785, 'PTHR28189', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT GAMMA', 241652),
(323786, 'PTHR28189:SF1', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT GAMMA', 241652),
(323787, 'PTHR24193:SF124', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 241653),
(323788, 'PTHR24193:SF123', NULL, NULL, NULL, NULL, 'REPEAT PROTEIN, PUTATIVE-RELATED', 241653),
(323789, 'PTHR24193', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT PROTEIN', 241653),
(323790, 'PTHR24193:SF122', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 23', 241653),
(323791, 'PTHR24193:SF121', NULL, NULL, NULL, NULL, 'ADA2A-CONTAINING COMPLEX COMPONENT 3, ISOFORM D', 241653),
(323792, 'PTHR24193:SF120', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 241653),
(323793, 'PTHR24193:SF76', NULL, NULL, NULL, NULL, 'GA-BINDING PROTEIN SUBUNIT BETA-1', 241653),
(323794, 'PTHR24193:SF86', NULL, NULL, NULL, NULL, 'GA-BINDING PROTEIN SUBUNIT BETA-2', 241653),
(323795, 'PTHR22899:SF0', NULL, NULL, NULL, NULL, 'F-BOX B PROTEIN-RELATED', 241654),
(323796, 'PTHR22899', NULL, NULL, NULL, NULL, 'CYCLIN-RELATED F-BOX FAMILY', 241654),
(323797, 'PTHR10730:SF45', NULL, NULL, NULL, NULL, 'PROCOLLAGEN-LYSINE,2-OXOGLUTARATE 5-DIOXYGENASE', 241655),
(323798, 'PTHR10730:SF55', NULL, NULL, NULL, NULL, 'PROCOLLAGEN GALACTOSYLTRANSFERASE 1', 241655),
(323799, 'PTHR10730:SF54', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G00650)-RELATED', 241655),
(323800, 'PTHR10730:SF53', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE 25 FAMILY MEMBER', 241655),
(323801, 'PTHR10730:SF6', NULL, NULL, NULL, NULL, 'PROCOLLAGEN-LYSINE,2-OXOGLUTARATE 5-DIOXYGENASE 2', 241655),
(323802, 'PTHR10730:SF7', NULL, NULL, NULL, NULL, 'MULTIFUNCTIONAL PROCOLLAGEN LYSINE HYDROXYLASE AND GLYCOSYLTRANSFERASE LH3', 241655),
(323803, 'PTHR10730:SF8', NULL, NULL, NULL, NULL, 'PROCOLLAGEN GALACTOSYLTRANSFERASE 2', 241655);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(323804, 'PTHR10730:SF9', NULL, NULL, NULL, NULL, 'INACTIVE GLYCOSYLTRANSFERASE 25 FAMILY MEMBER 3', 241655),
(323805, 'PTHR10730', NULL, NULL, NULL, NULL, 'PROCOLLAGEN-LYSINE,2-OXOGLUTARATE 5-DIOXYGENASE/GLYCOSYLTRANSFERASE 25 FAMILY MEMBER', 241655),
(323806, 'PTHR10730:SF5', NULL, NULL, NULL, NULL, 'PROCOLLAGEN-LYSINE,2-OXOGLUTARATE 5-DIOXYGENASE 1', 241655),
(323807, 'PTHR10730:SF28', NULL, NULL, NULL, NULL, 'PROCOLLAGEN GALACTOSYLTRANSFERASE 1', 241655),
(323808, 'PTHR10730:SF48', NULL, NULL, NULL, NULL, 'FAMILY-LIKE PROTEIN, PUTATIVE-RELATED', 241655),
(323809, 'PTHR36251', NULL, NULL, NULL, NULL, 'FELS-1 PROPHAGE HOST SPECIFICITY PROTEIN-RELATED', 241656),
(323810, 'PTHR36251:SF2', NULL, NULL, NULL, NULL, 'FELS-1 PROPHAGE HOST SPECIFICITY PROTEIN-RELATED', 241656),
(323811, 'PTHR37845:SF1', NULL, NULL, NULL, NULL, '', 241657),
(323812, 'PTHR37845', NULL, NULL, NULL, NULL, '', 241657),
(323813, 'PTHR45906:SF5', NULL, NULL, NULL, NULL, 'ALPHA-N-ACETYLGALACTOSAMINIDE ALPHA-2,6-SIALYLTRANSFERASE 5', 241658),
(323814, 'PTHR45906:SF6', NULL, NULL, NULL, NULL, 'ALPHA-N-ACETYLGALACTOSAMINIDE ALPHA-2,6-SIALYLTRANSFERASE 6', 241658),
(323815, 'PTHR45906', NULL, NULL, NULL, NULL, '', 241658),
(323816, 'PTHR45906:SF4', NULL, NULL, NULL, NULL, 'ALPHA-N-ACETYL-NEURAMINYL-2,3-BETA-GALACTOSYL-1,3-N-ACETYL-GALACTOSAMINIDE ALPHA-2,6-SIALYLTRANSFERASE', 241658),
(323817, 'PTHR45906:SF1', NULL, NULL, NULL, NULL, '', 241658),
(323818, 'PTHR45906:SF2', NULL, NULL, NULL, NULL, 'ALPHA-N-ACETYLGALACTOSAMINIDE ALPHA-2,6-SIALYLTRANSFERASE 3', 241658),
(323819, 'PTHR31390', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241659),
(323820, 'PTHR31390:SF19', NULL, NULL, NULL, NULL, 'BNAA10G27440D PROTEIN', 241659),
(323821, 'PTHR31390:SF29', NULL, NULL, NULL, NULL, '', 241659),
(323822, 'PTHR31390:SF17', NULL, NULL, NULL, NULL, '', 241659),
(323823, 'PTHR31390:SF28', NULL, NULL, NULL, NULL, 'BNAA05G10210D PROTEIN', 241659),
(323824, 'PTHR31390:SF27', NULL, NULL, NULL, NULL, 'DUF3527 DOMAIN PROTEIN', 241659),
(323825, 'PTHR31390:SF15', NULL, NULL, NULL, NULL, 'BNAA04G21690D PROTEIN', 241659),
(323826, 'PTHR31390:SF14', NULL, NULL, NULL, NULL, 'BNAA09G11020D PROTEIN', 241659),
(323827, 'PTHR31390:SF24', NULL, NULL, NULL, NULL, 'TUBBY C-TERMINAL-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 241659),
(323828, 'PTHR31390:SF12', NULL, NULL, NULL, NULL, 'PUTATIVE (DUF3527)-RELATED', 241659),
(323829, 'PTHR31390:SF11', NULL, NULL, NULL, NULL, 'OS10G0550750 PROTEIN', 241659),
(323830, 'PTHR31390:SF22', NULL, NULL, NULL, NULL, 'BNAA10G12100D PROTEIN', 241659),
(323831, 'PTHR31390:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241659),
(323832, 'PTHR31390:SF0', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (DUF3527)-RELATED', 241659),
(323833, 'PTHR31390:SF4', NULL, NULL, NULL, NULL, 'DUF3527 DOMAIN PROTEIN', 241659),
(323834, 'PTHR48299:SF1', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN ACR9', 241660),
(323835, 'PTHR48299', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN ACR9', 241660),
(323836, 'PTHR16537', NULL, NULL, NULL, NULL, 'SJOEGREN SYNDROME/SCLERODERMA AUTOANTIGEN 1', 241661),
(323837, 'PTHR16537:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ZNRD2', 241661),
(323838, 'PTHR16505:SF8', NULL, NULL, NULL, NULL, 'PROTEIN LZIC', 241662),
(323839, 'PTHR16505', NULL, NULL, NULL, NULL, 'PROTEIN LZIC', 241662),
(323840, 'PTHR46857', NULL, NULL, NULL, NULL, 'EPITHELIAL CELL-TRANSFORMING SEQUENCE 2 ONCOGENE-LIKE', 241663),
(323841, 'PTHR46857:SF2', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 16', 241663),
(323842, 'PTHR46857:SF1', NULL, NULL, NULL, NULL, 'EPITHELIAL CELL-TRANSFORMING SEQUENCE 2 ONCOGENE-LIKE', 241663),
(323843, 'PTHR42958', NULL, NULL, NULL, NULL, 'HYDROGENASE-2 LARGE CHAIN', 241664),
(323844, 'PTHR42958:SF3', NULL, NULL, NULL, NULL, 'HYDROGENASE-1 LARGE CHAIN', 241664),
(323845, 'PTHR42958:SF4', NULL, NULL, NULL, NULL, 'HYDROGENASE EXPRESSION/FORMATION PROTEIN HUPK', 241664),
(323846, 'PTHR42958:SF1', NULL, NULL, NULL, NULL, 'HYDROGENASE-2 LARGE CHAIN', 241664),
(323847, 'PTHR42958:SF2', NULL, NULL, NULL, NULL, 'UPTAKE HYDROGENASE LARGE SUBUNIT', 241664);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(323848, 'PTHR31865:SF62', NULL, NULL, NULL, NULL, '', 241665),
(323849, 'PTHR31865:SF63', NULL, NULL, NULL, NULL, 'BNAA09G39650D PROTEIN', 241665),
(323850, 'PTHR31865:SF41', NULL, NULL, NULL, NULL, 'BNAC04G02880D PROTEIN', 241665),
(323851, 'PTHR31865:SF60', NULL, NULL, NULL, NULL, '', 241665),
(323852, 'PTHR31865:SF3', NULL, NULL, NULL, NULL, 'PHOSPHODIESTERASE EPSILON-1, PUTATIVE (DUF1685)-RELATED', 241665),
(323853, 'PTHR31865:SF2', NULL, NULL, NULL, NULL, 'FOLD PROTEIN', 241665),
(323854, 'PTHR31865:SF5', NULL, NULL, NULL, NULL, 'OS05G0140300 PROTEIN', 241665),
(323855, 'PTHR31865:SF4', NULL, NULL, NULL, NULL, 'OS01G0898800 PROTEIN', 241665),
(323856, 'PTHR31865', NULL, NULL, NULL, NULL, 'OSJNBA0071G03.3 PROTEIN', 241665),
(323857, 'PTHR31865:SF1', NULL, NULL, NULL, NULL, 'OS02G0766600 PROTEIN', 241665),
(323858, 'PTHR31865:SF0', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241665),
(323859, 'PTHR31865:SF56', NULL, NULL, NULL, NULL, 'DUF1685 FAMILY PROTEIN', 241665),
(323860, 'PTHR31865:SF31', NULL, NULL, NULL, NULL, 'BNAC04G48880D PROTEIN', 241665),
(323861, 'PTHR31865:SF54', NULL, NULL, NULL, NULL, 'BNAA08G11680D PROTEIN', 241665),
(323862, 'PTHR31865:SF59', NULL, NULL, NULL, NULL, '', 241665),
(323863, 'PTHR31865:SF37', NULL, NULL, NULL, NULL, 'BNAC03G24120D PROTEIN', 241665),
(323864, 'PTHR31865:SF38', NULL, NULL, NULL, NULL, '', 241665),
(323865, 'PTHR31865:SF36', NULL, NULL, NULL, NULL, '', 241665),
(323866, 'PTHR31865:SF70', NULL, NULL, NULL, NULL, '', 241665),
(323867, 'PTHR31865:SF73', NULL, NULL, NULL, NULL, 'BNAA09G52150D PROTEIN', 241665),
(323868, 'PTHR31865:SF52', NULL, NULL, NULL, NULL, 'BNAA04G18200D PROTEIN', 241665),
(323869, 'PTHR31865:SF30', NULL, NULL, NULL, NULL, 'BNAC04G52040D PROTEIN', 241665),
(323870, 'PTHR31865:SF71', NULL, NULL, NULL, NULL, 'BNAA09G54110D PROTEIN', 241665),
(323871, 'PTHR31865:SF72', NULL, NULL, NULL, NULL, 'BNAC03G17590D PROTEIN', 241665),
(323872, 'PTHR31865:SF50', NULL, NULL, NULL, NULL, '', 241665),
(323873, 'PTHR31865:SF29', NULL, NULL, NULL, NULL, 'DUF1685 FAMILY PROTEIN', 241665),
(323874, 'PTHR31865:SF22', NULL, NULL, NULL, NULL, 'DUF1685 FAMILY PROTEIN', 241665),
(323875, 'PTHR31865:SF67', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL-4,5-BISPHOSPHATE PHOSPHODIESTERASE EPSILON-1', 241665),
(323876, 'PTHR31865:SF42', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR-RELATED', 241665),
(323877, 'PTHR31865:SF65', NULL, NULL, NULL, NULL, '', 241665),
(323878, 'PTHR31865:SF26', NULL, NULL, NULL, NULL, 'PUTATIVE (DUF1685)-RELATED', 241665),
(323879, 'PTHR31865:SF48', NULL, NULL, NULL, NULL, 'BNAC05G47130D PROTEIN', 241665),
(323880, 'PTHR31865:SF27', NULL, NULL, NULL, NULL, '', 241665),
(323881, 'PTHR31865:SF46', NULL, NULL, NULL, NULL, 'BNAC08G44460D PROTEIN', 241665),
(323882, 'PTHR31865:SF68', NULL, NULL, NULL, NULL, 'INSERTASE, PUTATIVE (DUF1685)-RELATED', 241665),
(323883, 'PTHR31865:SF24', NULL, NULL, NULL, NULL, 'BNAC03G33860D PROTEIN', 241665),
(323884, 'PTHR31865:SF69', NULL, NULL, NULL, NULL, '', 241665),
(323885, 'PTHR31865:SF25', NULL, NULL, NULL, NULL, '', 241665),
(323886, 'PTHR13121:SF0', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL GLYCAN ANCHOR BIOSYNTHESIS CLASS U PROTEIN', 241666),
(323887, 'PTHR13121', NULL, NULL, NULL, NULL, 'GPI TRANSAMIDASE COMPONENT PIG-U', 241666),
(323888, 'PTHR11089:SF38', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN-RELATED', 241667),
(323889, 'PTHR11089:SF36', NULL, NULL, NULL, NULL, 'CP-TYPE G DOMAIN-CONTAINING PROTEIN', 241667),
(323890, 'PTHR11089:SF33', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN-LIKE 3-LIKE PROTEIN', 241667),
(323891, 'PTHR11089:SF11', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN-LIKE 3', 241667),
(323892, 'PTHR11089:SF34', NULL, NULL, NULL, NULL, 'CP-TYPE G DOMAIN-CONTAINING PROTEIN', 241667),
(323893, 'PTHR11089:SF40', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN-LIKE NSN1', 241667),
(323894, 'PTHR11089:SF30', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN-LIKE 3 HOMOLOG', 241667);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(323895, 'PTHR11089', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN-RELATED', 241667),
(323896, 'PTHR11089:SF9', NULL, NULL, NULL, NULL, 'NUCLEOLAR GTP-BINDING PROTEIN 2', 241667),
(323897, 'PTHR35730:SF4', NULL, NULL, NULL, NULL, 'BNAA02G23760D PROTEIN', 241668),
(323898, 'PTHR35730:SF3', NULL, NULL, NULL, NULL, 'BNAC01G39290D PROTEIN', 241668),
(323899, 'PTHR35730:SF2', NULL, NULL, NULL, NULL, 'KINETOCHORE PROTEIN SPC24 HOMOLOG-RELATED', 241668),
(323900, 'PTHR35730', NULL, NULL, NULL, NULL, 'KINETOCHORE PROTEIN SPC24 HOMOLOG-RELATED', 241668),
(323901, 'PTHR40940:SF2', NULL, NULL, NULL, NULL, 'BATD', 241669),
(323902, 'PTHR40940:SF1', NULL, NULL, NULL, NULL, '', 241669),
(323903, 'PTHR40940', NULL, NULL, NULL, NULL, '', 241669),
(323904, 'PTHR47920:SF2', NULL, NULL, NULL, NULL, 'CUB_2 DOMAIN-CONTAINING PROTEIN', 241670),
(323905, 'PTHR47920:SF1', NULL, NULL, NULL, NULL, 'CUB_2 DOMAIN-CONTAINING PROTEIN', 241670),
(323906, 'PTHR47920', NULL, NULL, NULL, NULL, 'PROTEIN CBG13378-RELATED', 241670),
(323907, 'PTHR47077', NULL, NULL, NULL, NULL, 'ION_TRANS DOMAIN-CONTAINING PROTEIN', 241671),
(323908, 'PTHR47077:SF1', NULL, NULL, NULL, NULL, 'CATION CHANNEL SPERM-ASSOCIATED PROTEIN 4', 241671),
(323909, 'PTHR13723:SF37', NULL, NULL, NULL, NULL, 'A DISINTEGRIN AND METALLOPROTEINASE WITH THROMBOSPONDIN MOTIFS 5', 241672),
(323910, 'PTHR13723:SF39', NULL, NULL, NULL, NULL, 'A DISINTEGRIN AND METALLOPROTEINASE WITH THROMBOSPONDIN MOTIFS 15', 241672),
(323911, 'PTHR13723:SF38', NULL, NULL, NULL, NULL, 'A DISINTEGRIN AND METALLOPROTEINASE WITH THROMBOSPONDIN MOTIFS 4', 241672),
(323912, 'PTHR13723:SF159', NULL, NULL, NULL, NULL, 'SI:CH211-267E7.3', 241672),
(323913, 'PTHR13723:SF16', NULL, NULL, NULL, NULL, 'THROMBOSPONDIN TYPE-1 DOMAIN-CONTAINING PROTEIN 4', 241672),
(323914, 'PTHR13723:SF33', NULL, NULL, NULL, NULL, 'A DISINTEGRIN AND METALLOPROTEINASE WITH THROMBOSPONDIN MOTIFS 9', 241672),
(323915, 'PTHR13723:SF293', NULL, NULL, NULL, NULL, '', 241672),
(323916, 'PTHR13723:SF291', NULL, NULL, NULL, NULL, 'PEPTIDASE M12B DOMAIN-CONTAINING PROTEIN', 241672),
(323917, 'PTHR13723:SF158', NULL, NULL, NULL, NULL, 'A DISINTEGRIN AND METALLOPROTEINASE WITH THROMBOSPONDIN MOTIFS 3', 241672),
(323918, 'PTHR13723:SF312', NULL, NULL, NULL, NULL, 'PLAC DOMAIN-CONTAINING PROTEIN', 241672),
(323919, 'PTHR13723:SF157', NULL, NULL, NULL, NULL, 'ADAMTS-LIKE PROTEIN 1', 241672),
(323920, 'PTHR13723:SF179', NULL, NULL, NULL, NULL, 'PAPILIN', 241672),
(323921, 'PTHR13723:SF311', NULL, NULL, NULL, NULL, 'ACR DOMAIN-CONTAINING PROTEIN', 241672),
(323922, 'PTHR13723:SF278', NULL, NULL, NULL, NULL, 'ADAM METALLOPEPTIDASE WITH THROMBOSPONDIN TYPE 1 MOTIF A, ISOFORM B', 241672),
(323923, 'PTHR13723:SF310', NULL, NULL, NULL, NULL, 'ADAMTS-LIKE 5', 241672),
(323924, 'PTHR13723:SF275', NULL, NULL, NULL, NULL, 'STALL, ISOFORM C', 241672),
(323925, 'PTHR13723:SF197', NULL, NULL, NULL, NULL, 'A DISINTEGRIN AND METALLOPROTEINASE WITH THROMBOSPONDIN MOTIFS 19', 241672),
(323926, 'PTHR13723:SF151', NULL, NULL, NULL, NULL, 'A DISINTEGRIN AND METALLOPROTEINASE WITH THROMBOSPONDIN MOTIFS 17', 241672),
(323927, 'PTHR13723:SF173', NULL, NULL, NULL, NULL, 'ADAMTS-LIKE PROTEIN 5', 241672),
(323928, 'PTHR13723:SF294', NULL, NULL, NULL, NULL, 'A DISINTEGRIN AND METALLOPROTEINASE WITH THROMBOSPONDIN MOTIFS 7-LIKE PROTEIN', 241672),
(323929, 'PTHR13723:SF309', NULL, NULL, NULL, NULL, 'GON DOMAIN-CONTAINING PROTEIN', 241672),
(323930, 'PTHR13723:SF308', NULL, NULL, NULL, NULL, 'PAPILIN', 241672),
(323931, 'PTHR13723:SF307', NULL, NULL, NULL, NULL, 'PAPILIN B, PROTEOGLYCAN-LIKE SULFATED GLYCOPROTEIN', 241672),
(323932, 'PTHR13723:SF306', NULL, NULL, NULL, NULL, 'PEPTIDASE M12B DOMAIN-CONTAINING PROTEIN', 241672),
(323933, 'PTHR13723:SF26', NULL, NULL, NULL, NULL, 'A DISINTEGRIN AND METALLOPROTEINASE WITH THROMBOSPONDIN MOTIFS 10', 241672),
(323934, 'PTHR13723:SF305', NULL, NULL, NULL, NULL, 'PROTEIN MADD-4', 241672),
(323935, 'PTHR13723:SF304', NULL, NULL, NULL, NULL, 'NO LONG NERVE CORD, ISOFORM C', 241672),
(323936, 'PTHR13723:SF303', NULL, NULL, NULL, NULL, '', 241672);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(323937, 'PTHR13723:SF27', NULL, NULL, NULL, NULL, 'A DISINTEGRIN AND METALLOPROTEINASE WITH THROMBOSPONDIN MOTIFS 6', 241672),
(323938, 'PTHR13723:SF24', NULL, NULL, NULL, NULL, 'A DISINTEGRIN AND METALLOPROTEINASE WITH THROMBOSPONDIN MOTIFS 14', 241672),
(323939, 'PTHR13723:SF40', NULL, NULL, NULL, NULL, 'A DISINTEGRIN AND METALLOPROTEINASE WITH THROMBOSPONDIN MOTIFS 1', 241672),
(323940, 'PTHR13723:SF20', NULL, NULL, NULL, NULL, 'A DISINTEGRIN AND METALLOPROTEINASE WITH THROMBOSPONDIN MOTIFS 13', 241672),
(323941, 'PTHR13723:SF41', NULL, NULL, NULL, NULL, 'A DISINTEGRIN AND METALLOPROTEINASE WITH THROMBOSPONDIN MOTIFS 8', 241672),
(323942, 'PTHR13723:SF281', NULL, NULL, NULL, NULL, 'RANDOM SLUG CDNA22 PROTEIN', 241672),
(323943, 'PTHR13723', NULL, NULL, NULL, NULL, 'ADAMTS  A DISINTEGRIN AND METALLOPROTEASE WITH THROMBOSPONDIN MOTIFS  PROTEASE', 241672),
(323944, 'PTHR13723:SF169', NULL, NULL, NULL, NULL, 'ADAMTS-LIKE PROTEIN 3', 241672),
(323945, 'PTHR13723:SF147', NULL, NULL, NULL, NULL, 'ADAMTS-LIKE PROTEIN 2', 241672),
(323946, 'PTHR13723:SF167', NULL, NULL, NULL, NULL, 'A DISINTEGRIN AND METALLOPROTEINASE WITH THROMBOSPONDIN MOTIFS 18', 241672),
(323947, 'PTHR13723:SF189', NULL, NULL, NULL, NULL, 'A DISINTEGRIN AND METALLOPROTEINASE WITH THROMBOSPONDIN MOTIFS 12', 241672),
(323948, 'PTHR13723:SF200', NULL, NULL, NULL, NULL, 'ADAM METALLOPEPTIDASE WITH THROMBOSPONDIN TYPE 1 MOTIF B, ISOFORM B-RELATED', 241672),
(323949, 'PTHR13723:SF144', NULL, NULL, NULL, NULL, 'ADAMTS-LIKE PROTEIN 4', 241672),
(323950, 'PTHR13723:SF165', NULL, NULL, NULL, NULL, 'A DISINTEGRIN AND METALLOPROTEINASE WITH THROMBOSPONDIN MOTIFS 20', 241672),
(323951, 'PTHR13723:SF142', NULL, NULL, NULL, NULL, 'A DISINTEGRIN AND METALLOPROTEINASE WITH THROMBOSPONDIN MOTIFS 7', 241672),
(323952, 'PTHR13723:SF141', NULL, NULL, NULL, NULL, 'A DISINTEGRIN AND METALLOPROTEINASE WITH THROMBOSPONDIN MOTIFS 2', 241672),
(323953, 'PTHR13723:SF140', NULL, NULL, NULL, NULL, 'A DISINTEGRIN AND METALLOPROTEINASE WITH THROMBOSPONDIN MOTIFS 16', 241672),
(323954, 'PTHR15093', NULL, NULL, NULL, NULL, 'PROSTATE APOPTOSIS RESPONSE PROTEIN PAR-4', 241673),
(323955, 'PTHR15093:SF1', NULL, NULL, NULL, NULL, 'PRKC APOPTOSIS WT1 REGULATOR PROTEIN', 241673),
(323956, 'PTHR46008:SF49', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241674),
(323957, 'PTHR46008', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 1.4', 241674),
(323958, 'PTHR46008:SF25', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241674),
(323959, 'PTHR46008:SF47', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 1.4 ISOFORM X1', 241674),
(323960, 'PTHR46008:SF48', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241674),
(323961, 'PTHR46008:SF26', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241674),
(323962, 'PTHR46008:SF29', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 1.1', 241674),
(323963, 'PTHR46008:SF20', NULL, NULL, NULL, NULL, 'OS01G0136400 PROTEIN', 241674),
(323964, 'PTHR46008:SF9', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 1.1', 241674),
(323965, 'PTHR46008:SF40', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 1.4', 241674),
(323966, 'PTHR46008:SF45', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 1.1', 241674),
(323967, 'PTHR46008:SF46', NULL, NULL, NULL, NULL, 'WALL ASSOCIATED KINASE-LIKE PROTEIN', 241674),
(323968, 'PTHR46008:SF21', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241674),
(323969, 'PTHR46008:SF6', NULL, NULL, NULL, NULL, 'TYROSINE KINASE FAMILY PROTEIN', 241674),
(323970, 'PTHR46008:SF22', NULL, NULL, NULL, NULL, 'CONCANAVALIN A-LIKE LECTIN/GLUCANASE DOMAIN-CONTAINING PROTEIN-RELATED', 241674),
(323971, 'PTHR46008:SF4', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 1.2', 241674);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(323972, 'PTHR46008:SF2', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 1.1', 241674),
(323973, 'PTHR46008:SF16', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 1.3', 241674),
(323974, 'PTHR46008:SF38', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241674),
(323975, 'PTHR46008:SF39', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 1.2', 241674),
(323976, 'PTHR46008:SF37', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 1.2 ISOFORM X1', 241674),
(323977, 'PTHR46008:SF15', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 1.1 ISOFORM X1', 241674),
(323978, 'PTHR46008:SF18', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 1.5', 241674),
(323979, 'PTHR46008:SF19', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241674),
(323980, 'PTHR46008:SF52', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 1.1', 241674),
(323981, 'PTHR46008:SF30', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241674),
(323982, 'PTHR46008:SF53', NULL, NULL, NULL, NULL, 'OS05G0550800 PROTEIN', 241674),
(323983, 'PTHR46008:SF31', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241674),
(323984, 'PTHR46008:SF50', NULL, NULL, NULL, NULL, 'WALL ASSOCIATED KINASE-LIKE PROTEIN', 241674),
(323985, 'PTHR46008:SF51', NULL, NULL, NULL, NULL, 'WALL ASSOCIATED KINASE-LIKE PROTEIN', 241674),
(323986, 'PTHR46008:SF34', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241674),
(323987, 'PTHR46008:SF12', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 1.1', 241674),
(323988, 'PTHR46008:SF35', NULL, NULL, NULL, NULL, 'CONCANAVALIN A-LIKE LECTIN/GLUCANASE DOMAIN-CONTAINING PROTEIN-RELATED', 241674),
(323989, 'PTHR46008:SF33', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241674),
(323990, 'PTHR18444:SF9', NULL, NULL, NULL, NULL, 'UPF0538 PROTEIN C2ORF76', 241675),
(323991, 'PTHR18444', NULL, NULL, NULL, NULL, 'UPF0538 FAMILY MEMBER', 241675),
(323992, 'PTHR44414', NULL, NULL, NULL, NULL, 'PROTEIN NEDD1', 241676),
(323993, 'PTHR44414:SF1', NULL, NULL, NULL, NULL, 'PROTEIN NEDD1', 241676),
(323994, 'PTHR42846:SF1', NULL, NULL, NULL, NULL, 'NI-SIROHYDROCHLORIN A,C-DIAMIDE REDUCTIVE CYCLASE COMPLEX, COMPONENT CFBD', 241677),
(323995, 'PTHR42846', NULL, NULL, NULL, NULL, 'NI-SIROHYDROCHLORIN A,C-DIAMIDE REDUCTIVE CYCLASE COMPLEX, COMPONENT CFBD', 241677),
(323996, 'PTHR31038', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', 241678),
(323997, 'PTHR31038:SF19', NULL, NULL, NULL, NULL, 'PROTEIN RETICULATA, CHLOROPLASTIC', 241678),
(323998, 'PTHR31038:SF15', NULL, NULL, NULL, NULL, '', 241678),
(323999, 'PTHR31038:SF18', NULL, NULL, NULL, NULL, 'PROTEIN RETICULATA-RELATED 1, CHLOROPLASTIC', 241678),
(324000, 'PTHR31038:SF14', NULL, NULL, NULL, NULL, 'OS07G0240300 PROTEIN', 241678),
(324001, 'PTHR31038:SF2', NULL, NULL, NULL, NULL, 'PROTEIN RETICULATA-RELATED 1, CHLOROPLASTIC-LIKE', 241678),
(324002, 'PTHR31038:SF21', NULL, NULL, NULL, NULL, 'PROTEIN RETICULATA-RELATED 1, CHLOROPLASTIC-LIKE', 241678),
(324003, 'PTHR31038:SF10', NULL, NULL, NULL, NULL, 'OS04G0524400 PROTEIN', 241678),
(324004, 'PTHR30614:SF34', NULL, NULL, NULL, NULL, 'BLR6398 PROTEIN', 241679),
(324005, 'PTHR30614:SF45', NULL, NULL, NULL, NULL, 'L-CYSTINE TRANSPORT SYSTEM PERMEASE PROTEIN TCYL', 241679),
(324006, 'PTHR30614:SF35', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN', 241679),
(324007, 'PTHR30614:SF46', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER MEMBRANE SPANNING PERMEASE-GLUTAMINE TRANSPORT', 241679),
(324008, 'PTHR30614:SF47', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE', 241679),
(324009, 'PTHR30614:SF36', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER MEMBRANE-SPANNING PERMEASE-GLUTAMINE TRANSPORT', 241679);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(324010, 'PTHR30614:SF37', NULL, NULL, NULL, NULL, 'AMINO-ACID ABC TRANSPORTER PERMEASE PROTEIN YHDX-RELATED', 241679),
(324011, 'PTHR30614:SF0', NULL, NULL, NULL, NULL, 'L-CYSTINE TRANSPORT SYSTEM PERMEASE PROTEIN TCYL', 241679),
(324012, 'PTHR30614:SF1', NULL, NULL, NULL, NULL, 'GLUTAMATE/ASPARTATE IMPORT PERMEASE PROTEIN GLTK', 241679),
(324013, 'PTHR30614:SF7', NULL, NULL, NULL, NULL, 'GLUTAMINE ABC TRANSPORTER PERMEASE PROTEIN GLNM-RELATED', 241679),
(324014, 'PTHR30614', NULL, NULL, NULL, NULL, 'MEMBRANE COMPONENT OF AMINO ACID ABC TRANSPORTER', 241679),
(324015, 'PTHR30614:SF41', NULL, NULL, NULL, NULL, 'INNER MEMBRANE AMINO-ACID ABC TRANSPORTER PERMEASE PROTEIN YHDY', 241679),
(324016, 'PTHR30614:SF20', NULL, NULL, NULL, NULL, 'GLUTAMINE TRANSPORT SYSTEM PERMEASE PROTEIN GLNP', 241679),
(324017, 'PTHR30614:SF42', NULL, NULL, NULL, NULL, 'GLUTAMATE/ASPARTATE IMPORT PERMEASE PROTEIN GLTJ', 241679),
(324018, 'PTHR30614:SF21', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORT SYSTEM PERMEASE-RELATED', 241679),
(324019, 'PTHR30614:SF10', NULL, NULL, NULL, NULL, 'ARGININE ABC TRANSPORTER PERMEASE PROTEIN ARTM', 241679),
(324020, 'PTHR30614:SF43', NULL, NULL, NULL, NULL, 'L-CYSTINE TRANSPORT SYSTEM PERMEASE PROTEIN TCYM', 241679),
(324021, 'PTHR33383', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN INSERTION EFFICIENCY FACTOR-RELATED', 241680),
(324022, 'PTHR33383:SF1', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN INSERTION EFFICIENCY FACTOR-RELATED', 241680),
(324023, 'PTHR47419', NULL, NULL, NULL, NULL, 'DROMYOSUPPRESSIN RECEPTOR RELATED-RELATED', 241681),
(324024, 'PTHR47419:SF1', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 241681),
(324025, 'PTHR47419:SF2', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 241681),
(324026, 'PTHR28067', NULL, NULL, NULL, NULL, 'DNA REPLICATION REGULATOR SLD3', 241682),
(324027, 'PTHR28067:SF1', NULL, NULL, NULL, NULL, 'DNA REPLICATION REGULATOR SLD3', 241682),
(324028, 'PTHR13622:SF11', NULL, NULL, NULL, NULL, 'THIAMIN PYROPHOSPHOKINASE', 241683),
(324029, 'PTHR13622:SF6', NULL, NULL, NULL, NULL, 'THIAMINE PYROPHOSPHOKINASE 2', 241683),
(324030, 'PTHR13622:SF8', NULL, NULL, NULL, NULL, 'THIAMIN PYROPHOSPHOKINASE 1', 241683),
(324031, 'PTHR13622', NULL, NULL, NULL, NULL, 'THIAMIN PYROPHOSPHOKINASE', 241683),
(324032, 'PTHR13622:SF13', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 241683),
(324033, 'PTHR13622:SF12', NULL, NULL, NULL, NULL, 'THIAMINE PYROPHOSPHOKINASE 1', 241683),
(324034, 'PTHR10725', NULL, NULL, NULL, NULL, 'THAP DOMAIN-CONTAINING PROTEIN 9', 241684),
(324035, 'PTHR10725:SF72', NULL, NULL, NULL, NULL, '', 241684),
(324036, 'PTHR10725:SF74', NULL, NULL, NULL, NULL, 'DNA TRANSPOSASE THAP9', 241684),
(324037, 'PTHR10725:SF73', NULL, NULL, NULL, NULL, 'TRANSPOSABLE ELEMENT P TRANSPOSASE-LIKE PROTEIN', 241684),
(324038, 'PTHR10725:SF76', NULL, NULL, NULL, NULL, '', 241684),
(324039, 'PTHR10725:SF75', NULL, NULL, NULL, NULL, 'TRANSPOSABLE ELEMENT P TRANSPOSASE-LIKE PROTEIN', 241684),
(324040, 'PTHR10725:SF78', NULL, NULL, NULL, NULL, 'TRANSPOSABLE ELEMENT P TRANSPOSASE-LIKE PROTEIN', 241684),
(324041, 'PTHR10725:SF77', NULL, NULL, NULL, NULL, '', 241684),
(324042, 'PTHR10725:SF57', NULL, NULL, NULL, NULL, 'THAP-TYPE DOMAIN-CONTAINING PROTEIN', 241684),
(324043, 'PTHR32023:SF2', NULL, NULL, NULL, NULL, 'PILR ALPHA-ASSOCIATED NEURAL PROTEIN', 241685),
(324044, 'PTHR32023', NULL, NULL, NULL, NULL, 'PILR ALPHA-ASSOCIATED NEURAL PROTEIN', 241685),
(324045, 'PTHR21226', NULL, NULL, NULL, NULL, 'ABPA10-RELATED', 241686),
(324046, 'PTHR21226:SF8', NULL, NULL, NULL, NULL, 'ABPA10-RELATED', 241686),
(324047, 'PTHR31370:SF5', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 241687),
(324048, 'PTHR31370:SF6', NULL, NULL, NULL, NULL, '', 241687),
(324049, 'PTHR31370', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN FAMILY-LIKE', 241687),
(324050, 'PTHR31370:SF2', NULL, NULL, NULL, NULL, 'OS08G0105100 PROTEIN', 241687),
(324051, 'PTHR31370:SF4', NULL, NULL, NULL, NULL, 'BNAC04G31530D PROTEIN', 241687);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(324052, 'PTHR43400:SF8', NULL, NULL, NULL, NULL, 'FUMARATE REDUCTASE 1-RELATED', 241688),
(324053, 'PTHR43400:SF7', NULL, NULL, NULL, NULL, 'FAD_BINDING_2 DOMAIN-CONTAINING PROTEIN', 241688),
(324054, 'PTHR43400:SF1', NULL, NULL, NULL, NULL, 'FUMARATE REDUCTASE', 241688),
(324055, 'PTHR43400:SF11', NULL, NULL, NULL, NULL, 'ANAEROBIC GLYCEROL-3-PHOSPHATE DEHYDROGENASE SUBUNIT B', 241688),
(324056, 'PTHR43400', NULL, NULL, NULL, NULL, 'FUMARATE REDUCTASE', 241688),
(324057, 'PTHR43400:SF10', NULL, NULL, NULL, NULL, '3-OXOSTEROID 1-DEHYDROGENASE', 241688),
(324058, 'PTHR31589:SF125', NULL, NULL, NULL, NULL, 'NEPROSIN DOMAIN-CONTAINING PROTEIN', 241689),
(324059, 'PTHR31589:SF129', NULL, NULL, NULL, NULL, 'OS07G0422700 PROTEIN', 241689),
(324060, 'PTHR31589:SF128', NULL, NULL, NULL, NULL, 'BNACNNG55750D PROTEIN', 241689),
(324061, 'PTHR31589:SF2', NULL, NULL, NULL, NULL, 'ASLB (DUF239)-RELATED', 241689),
(324062, 'PTHR31589:SF24', NULL, NULL, NULL, NULL, 'OS07G0205500 PROTEIN', 241689),
(324063, 'PTHR31589:SF123', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF239)-RELATED', 241689),
(324064, 'PTHR31589:SF122', NULL, NULL, NULL, NULL, 'BNAC02G33500D PROTEIN', 241689),
(324065, 'PTHR31589:SF135', NULL, NULL, NULL, NULL, 'OS05G0341100 PROTEIN', 241689),
(324066, 'PTHR31589:SF139', NULL, NULL, NULL, NULL, '', 241689),
(324067, 'PTHR31589:SF132', NULL, NULL, NULL, NULL, 'BNAC06G31720D PROTEIN', 241689),
(324068, 'PTHR31589:SF131', NULL, NULL, NULL, NULL, 'OS05G0169800 PROTEIN', 241689),
(324069, 'PTHR31589:SF147', NULL, NULL, NULL, NULL, 'NEPROSIN DOMAIN-CONTAINING PROTEIN', 241689),
(324070, 'PTHR31589:SF149', NULL, NULL, NULL, NULL, 'BNAA01G13010D PROTEIN', 241689),
(324071, 'PTHR31589:SF148', NULL, NULL, NULL, NULL, 'BNAC03G23900D PROTEIN', 241689),
(324072, 'PTHR31589:SF95', NULL, NULL, NULL, NULL, 'BNAC04G22520D PROTEIN', 241689),
(324073, 'PTHR31589:SF93', NULL, NULL, NULL, NULL, 'NEPROSIN DOMAIN-CONTAINING PROTEIN', 241689),
(324074, 'PTHR31589:SF91', NULL, NULL, NULL, NULL, 'NEPROSIN DOMAIN-CONTAINING PROTEIN', 241689),
(324075, 'PTHR31589:SF89', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 241689),
(324076, 'PTHR31589', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF239)-RELATED-RELATED', 241689),
(324077, 'PTHR31589:SF86', NULL, NULL, NULL, NULL, 'BNACNNG63630D PROTEIN', 241689),
(324078, 'PTHR31589:SF141', NULL, NULL, NULL, NULL, 'NEPROSIN DOMAIN-CONTAINING PROTEIN', 241689),
(324079, 'PTHR31589:SF140', NULL, NULL, NULL, NULL, 'NEPROSIN DOMAIN-CONTAINING PROTEIN', 241689),
(324080, 'PTHR31589:SF144', NULL, NULL, NULL, NULL, 'NEPROSIN DOMAIN-CONTAINING PROTEIN', 241689),
(324081, 'PTHR31589:SF157', NULL, NULL, NULL, NULL, 'BNAC06G01070D PROTEIN', 241689),
(324082, 'PTHR31589:SF159', NULL, NULL, NULL, NULL, 'NEPROSIN DOMAIN-CONTAINING PROTEIN', 241689),
(324083, 'PTHR31589:SF99', NULL, NULL, NULL, NULL, 'CARBOXYL-TERMINAL PEPTIDASE', 241689),
(324084, 'PTHR31589:SF98', NULL, NULL, NULL, NULL, 'LIGASE, PUTATIVE (DUF239)-RELATED', 241689),
(324085, 'PTHR31589:SF97', NULL, NULL, NULL, NULL, 'BNAA09G31120D PROTEIN', 241689),
(324086, 'PTHR31589:SF96', NULL, NULL, NULL, NULL, 'NEPROSIN DOMAIN-CONTAINING PROTEIN', 241689),
(324087, 'PTHR31589:SF152', NULL, NULL, NULL, NULL, 'BNAC01G14960D PROTEIN', 241689),
(324088, 'PTHR31589:SF153', NULL, NULL, NULL, NULL, 'BNAC07G15710D PROTEIN', 241689),
(324089, 'PTHR31589:SF156', NULL, NULL, NULL, NULL, 'BNAA04G25610D PROTEIN', 241689),
(324090, 'PTHR31589:SF16', NULL, NULL, NULL, NULL, 'PEPTIDASE, PUTATIVE, EXPRESSED-RELATED', 241689),
(324091, 'PTHR31589:SF202', NULL, NULL, NULL, NULL, 'CARBOXYL-TERMINAL PEPTIDASE', 241689),
(324092, 'PTHR31589:SF201', NULL, NULL, NULL, NULL, 'NEPROSIN DOMAIN-CONTAINING PROTEIN', 241689),
(324093, 'PTHR31589:SF204', NULL, NULL, NULL, NULL, '', 241689),
(324094, 'PTHR31589:SF203', NULL, NULL, NULL, NULL, '', 241689),
(324095, 'PTHR31589:SF206', NULL, NULL, NULL, NULL, 'NEPROSIN DOMAIN-CONTAINING PROTEIN', 241689),
(324096, 'PTHR31589:SF205', NULL, NULL, NULL, NULL, 'BNAC09G33050D PROTEIN', 241689),
(324097, 'PTHR31589:SF208', NULL, NULL, NULL, NULL, 'NEPROSIN DOMAIN-CONTAINING PROTEIN', 241689);
INSERT INTO "PUBLIC"."MODEL" VALUES
(324098, 'PTHR31589:SF207', NULL, NULL, NULL, NULL, 'NEPROSIN DOMAIN-CONTAINING PROTEIN', 241689),
(324099, 'PTHR31589:SF209', NULL, NULL, NULL, NULL, '', 241689),
(324100, 'PTHR31589:SF68', NULL, NULL, NULL, NULL, 'CARBOXYL-TERMINAL PEPTIDASE', 241689),
(324101, 'PTHR31589:SF67', NULL, NULL, NULL, NULL, 'POLYPROTEIN/RETROTRANSPOSON, PUTATIVE (DUF239)-RELATED', 241689),
(324102, 'PTHR31589:SF64', NULL, NULL, NULL, NULL, 'NEPROSIN DOMAIN-CONTAINING PROTEIN', 241689),
(324103, 'PTHR31589:SF63', NULL, NULL, NULL, NULL, 'BNAA05G37050D PROTEIN', 241689),
(324104, 'PTHR31589:SF160', NULL, NULL, NULL, NULL, 'NEPROSIN DOMAIN-CONTAINING PROTEIN', 241689),
(324105, 'PTHR31589:SF163', NULL, NULL, NULL, NULL, 'CARBOXYL-TERMINAL PROTEINASE-LIKE PROTEIN (DUF239)-RELATED', 241689),
(324106, 'PTHR31589:SF162', NULL, NULL, NULL, NULL, 'NEPROSIN DOMAIN-CONTAINING PROTEIN', 241689),
(324107, 'PTHR31589:SF165', NULL, NULL, NULL, NULL, 'NEPROSIN DOMAIN-CONTAINING PROTEIN', 241689),
(324108, 'PTHR31589:SF167', NULL, NULL, NULL, NULL, 'SIMILARITY TO CARBOXYL-TERMINAL PROTEINASE', 241689),
(324109, 'PTHR31589:SF200', NULL, NULL, NULL, NULL, 'NEPROSIN DOMAIN-CONTAINING PROTEIN', 241689),
(324110, 'PTHR31589:SF213', NULL, NULL, NULL, NULL, 'BNAA08G20520D PROTEIN', 241689),
(324111, 'PTHR31589:SF212', NULL, NULL, NULL, NULL, 'CARBOXYL-TERMINAL PROTEINASE-LIKE PROTEIN (DUF239)-RELATED', 241689),
(324112, 'PTHR31589:SF215', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF239)-RELATED', 241689),
(324113, 'PTHR31589:SF214', NULL, NULL, NULL, NULL, '', 241689),
(324114, 'PTHR31589:SF217', NULL, NULL, NULL, NULL, 'CARBOXYL-TERMINAL PEPTIDASE', 241689),
(324115, 'PTHR31589:SF216', NULL, NULL, NULL, NULL, '', 241689),
(324116, 'PTHR31589:SF219', NULL, NULL, NULL, NULL, 'OS06G0144400 PROTEIN', 241689),
(324117, 'PTHR31589:SF218', NULL, NULL, NULL, NULL, '', 241689),
(324118, 'PTHR31589:SF170', NULL, NULL, NULL, NULL, 'NEPROSIN DOMAIN-CONTAINING PROTEIN', 241689),
(324119, 'PTHR31589:SF172', NULL, NULL, NULL, NULL, '', 241689),
(324120, 'PTHR31589:SF171', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF239)-RELATED', 241689),
(324121, 'PTHR31589:SF176', NULL, NULL, NULL, NULL, 'NEPROSIN_AP DOMAIN-CONTAINING PROTEIN-RELATED', 241689),
(324122, 'PTHR31589:SF175', NULL, NULL, NULL, NULL, 'OS11G0284600 PROTEIN', 241689),
(324123, 'PTHR31589:SF211', NULL, NULL, NULL, NULL, 'OS06G0682600 PROTEIN', 241689),
(324124, 'PTHR31589:SF178', NULL, NULL, NULL, NULL, 'NEPROSIN DOMAIN-CONTAINING PROTEIN', 241689),
(324125, 'PTHR31589:SF210', NULL, NULL, NULL, NULL, 'OS07G0573400 PROTEIN', 241689),
(324126, 'PTHR31589:SF224', NULL, NULL, NULL, NULL, 'NEP-INTERACTING PROTEIN (DUF239)', 241689),
(324127, 'PTHR31589:SF223', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF239)-RELATED', 241689),
(324128, 'PTHR31589:SF105', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF239)-RELATED', 241689),
(324129, 'PTHR31589:SF226', NULL, NULL, NULL, NULL, 'BNAA02G35170D PROTEIN', 241689),
(324130, 'PTHR31589:SF104', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 241689),
(324131, 'PTHR31589:SF225', NULL, NULL, NULL, NULL, '', 241689),
(324132, 'PTHR31589:SF228', NULL, NULL, NULL, NULL, 'OS01G0170500 PROTEIN', 241689),
(324133, 'PTHR31589:SF227', NULL, NULL, NULL, NULL, 'BNAC08G42590D PROTEIN', 241689),
(324134, 'PTHR31589:SF229', NULL, NULL, NULL, NULL, '', 241689),
(324135, 'PTHR31589:SF108', NULL, NULL, NULL, NULL, 'NEP-INTERACTING PROTEIN 1', 241689),
(324136, 'PTHR31589:SF181', NULL, NULL, NULL, NULL, 'NEPROSIN DOMAIN-CONTAINING PROTEIN', 241689),
(324137, 'PTHR31589:SF180', NULL, NULL, NULL, NULL, 'NEPROSIN DOMAIN-CONTAINING PROTEIN', 241689),
(324138, 'PTHR31589:SF220', NULL, NULL, NULL, NULL, 'NEPROSIN DOMAIN-CONTAINING PROTEIN', 241689),
(324139, 'PTHR31589:SF222', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 241689),
(324140, 'PTHR31589:SF221', NULL, NULL, NULL, NULL, 'LIGASE, PUTATIVE (DUF239)-RELATED', 241689),
(324141, 'PTHR31589:SF100', NULL, NULL, NULL, NULL, 'NEPROSIN DOMAIN-CONTAINING PROTEIN', 241689),
(324142, 'PTHR31589:SF116', NULL, NULL, NULL, NULL, 'NEPROSIN DOMAIN-CONTAINING PROTEIN', 241689);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(324143, 'PTHR31589:SF119', NULL, NULL, NULL, NULL, 'BNACNNG55760D PROTEIN', 241689),
(324144, 'PTHR31589:SF61', NULL, NULL, NULL, NULL, 'CARBOXYL-TERMINAL PEPTIDASE-RELATED', 241689),
(324145, 'PTHR31589:SF60', NULL, NULL, NULL, NULL, 'NEPROSIN DOMAIN-CONTAINING PROTEIN-RELATED', 241689),
(324146, 'PTHR31589:SF59', NULL, NULL, NULL, NULL, 'NEPROSIN DOMAIN-CONTAINING PROTEIN', 241689),
(324147, 'PTHR31589:SF57', NULL, NULL, NULL, NULL, 'OS06G0474500 PROTEIN', 241689),
(324148, 'PTHR31589:SF56', NULL, NULL, NULL, NULL, 'NEPROSIN DOMAIN-CONTAINING PROTEIN', 241689),
(324149, 'PTHR31589:SF190', NULL, NULL, NULL, NULL, 'NEPROSIN DOMAIN-CONTAINING PROTEIN', 241689),
(324150, 'PTHR31589:SF192', NULL, NULL, NULL, NULL, 'NEPROSIN DOMAIN-CONTAINING PROTEIN', 241689),
(324151, 'PTHR31589:SF110', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF239)-RELATED', 241689),
(324152, 'PTHR31589:SF198', NULL, NULL, NULL, NULL, 'NEP-INTERACTING PROTEIN 1', 241689),
(324153, 'PTHR31589:SF197', NULL, NULL, NULL, NULL, 'CARBOXYL-TERMINAL PROTEINASE', 241689),
(324154, 'PTHR31589:SF112', NULL, NULL, NULL, NULL, 'OS01G0834300 PROTEIN', 241689),
(324155, 'PTHR31589:SF111', NULL, NULL, NULL, NULL, 'CARBOXYL-TERMINAL PEPTIDASE', 241689),
(324156, 'PTHR24083:SF39', NULL, NULL, NULL, NULL, 'RETINOIC ACID RECEPTOR RXR-ALPHA', 241690),
(324157, 'PTHR24083:SF75', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY-RELATED', 241690),
(324158, 'PTHR24083:SF98', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR SUBFAMILY 2 GROUP E MEMBER 1', 241690),
(324159, 'PTHR24083:SF76', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-153', 241690),
(324160, 'PTHR24083:SF54', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR HR78', 241690),
(324161, 'PTHR24083:SF157', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-40', 241690),
(324162, 'PTHR24083:SF179', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 241690),
(324163, 'PTHR24083:SF156', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-10', 241690),
(324164, 'PTHR24083:SF159', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-1', 241690),
(324165, 'PTHR24083:SF158', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR 114', 241690),
(324166, 'PTHR24083:SF164', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-68', 241690),
(324167, 'PTHR24083:SF163', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 241690),
(324168, 'PTHR24083:SF90', NULL, NULL, NULL, NULL, 'RETINOIC ACID RECEPTOR RXR-BETA', 241690),
(324169, 'PTHR24083:SF100', NULL, NULL, NULL, NULL, 'RETINOIC ACID RECEPTOR RXR-GAMMA', 241690),
(324170, 'PTHR24083:SF70', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 241690),
(324171, 'PTHR24083:SF71', NULL, NULL, NULL, NULL, 'NR LBD DOMAIN-CONTAINING PROTEIN', 241690),
(324172, 'PTHR24083:SF182', NULL, NULL, NULL, NULL, 'RETINOIC ACID RECEPTOR RXR-BETA', 241690),
(324173, 'PTHR24083:SF160', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-47', 241690),
(324174, 'PTHR24083:SF181', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-35', 241690),
(324175, 'PTHR24083:SF73', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 241690),
(324176, 'PTHR24083:SF183', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-49', 241690),
(324177, 'PTHR24083:SF74', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 241690),
(324178, 'PTHR24083', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR', 241690),
(324179, 'PTHR24083:SF42', NULL, NULL, NULL, NULL, 'HEPATOCYTE NUCLEAR FACTOR 4-GAMMA', 241690),
(324180, 'PTHR24083:SF87', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR DOMAIN-CONTAINING PROTEIN', 241690),
(324181, 'PTHR24083:SF149', NULL, NULL, NULL, NULL, 'NR LBD DOMAIN-CONTAINING PROTEIN-RELATED', 241690),
(324182, 'PTHR24083:SF88', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY-RELATED', 241690),
(324183, 'PTHR24083:SF44', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR SUBFAMILY 2 GROUP F MEMBER 6', 241690);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(324184, 'PTHR24083:SF67', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-14', 241690),
(324185, 'PTHR24083:SF45', NULL, NULL, NULL, NULL, 'COUP TRANSCRIPTION FACTOR 2', 241690),
(324186, 'PTHR24083:SF46', NULL, NULL, NULL, NULL, 'STEROID RECEPTOR SEVEN-UP, ISOFORM A', 241690),
(324187, 'PTHR24083:SF168', NULL, NULL, NULL, NULL, 'COUP TRANSCRIPTION FACTOR 1', 241690),
(324188, 'PTHR24083:SF68', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 241690),
(324189, 'PTHR24083:SF47', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR SUBFAMILY 2 GROUP F MEMBER 5', 241690),
(324190, 'PTHR24083:SF104', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR HNF-4 HOMOLOG', 241690),
(324191, 'PTHR24083:SF48', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR SUBFAMILY 2 GROUP C MEMBER 2', 241690),
(324192, 'PTHR24083:SF49', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR SUBFAMILY 2 GROUP C MEMBER 1', 241690),
(324193, 'PTHR24083:SF103', NULL, NULL, NULL, NULL, 'PROTEIN ULTRASPIRACLE', 241690),
(324194, 'PTHR24083:SF174', NULL, NULL, NULL, NULL, 'HEPATIC NUCLEAR FACTOR 4, BETA', 241690),
(324195, 'PTHR24083:SF155', NULL, NULL, NULL, NULL, 'HORMONE RECEPTOR 83', 241690),
(324196, 'PTHR24083:SF80', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 241690),
(324197, 'PTHR24083:SF81', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 241690),
(324198, 'PTHR24083:SF154', NULL, NULL, NULL, NULL, 'PROTEIN DISSATISFACTION', 241690),
(324199, 'PTHR24083:SF171', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-136', 241690),
(324200, 'PTHR24083:SF173', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-69', 241690),
(324201, 'PTHR24083:SF4', NULL, NULL, NULL, NULL, 'PHOTORECEPTOR-SPECIFIC NUCLEAR RECEPTOR', 241690),
(324202, 'PTHR24083:SF41', NULL, NULL, NULL, NULL, 'HEPATOCYTE NUCLEAR FACTOR 4-ALPHA', 241690),
(324203, 'PTHR24083:SF85', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 241690),
(324204, 'PTHR47957', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT HELICASE HRQ1', 241691),
(324205, 'PTHR47957:SF3', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT HELICASE HRQ1', 241691),
(324206, 'PTHR47957:SF4', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT HELICASE', 241691),
(324207, 'PTHR47957:SF2', NULL, NULL, NULL, NULL, 'OS02G0111900 PROTEIN', 241691),
(324208, 'PTHR23058:SF11', NULL, NULL, NULL, NULL, 'PEROXIN-14', 241692),
(324209, 'PTHR23058:SF10', NULL, NULL, NULL, NULL, 'PEROXIN-14', 241692),
(324210, 'PTHR23058:SF12', NULL, NULL, NULL, NULL, 'PEROXIN-14', 241692),
(324211, 'PTHR23058:SF14', NULL, NULL, NULL, NULL, 'PEROXIN-14', 241692),
(324212, 'PTHR23058:SF5', NULL, NULL, NULL, NULL, 'PEROXIN-14', 241692),
(324213, 'PTHR23058:SF0', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN PEX14', 241692),
(324214, 'PTHR23058', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN PEX14', 241692),
(324215, 'PTHR31573:SF4', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 241693),
(324216, 'PTHR31573:SF1', NULL, NULL, NULL, NULL, 'DNA OXIDATIVE DEMETHYLASE ALKBH2', 241693),
(324217, 'PTHR31573', NULL, NULL, NULL, NULL, 'ALPHA-KETOGLUTARATE-DEPENDENT DIOXYGENASE ALKB HOMOLOG 2', 241693),
(324218, 'PTHR46896:SF1', NULL, NULL, NULL, NULL, 'SENTRIN-SPECIFIC PROTEASE 6', 241694),
(324219, 'PTHR46896:SF2', NULL, NULL, NULL, NULL, 'SENTRIN-SPECIFIC PROTEASE 7', 241694),
(324220, 'PTHR46896:SF3', NULL, NULL, NULL, NULL, 'FI06413P-RELATED', 241694),
(324221, 'PTHR46896:SF4', NULL, NULL, NULL, NULL, 'SUMO-SPECIFIC PEPTIDASE 7B', 241694),
(324222, 'PTHR46896', NULL, NULL, NULL, NULL, 'SENTRIN-SPECIFIC PROTEASE', 241694),
(324223, 'PTHR39662', NULL, NULL, NULL, NULL, '', 241695),
(324224, 'PTHR39662:SF1', NULL, NULL, NULL, NULL, '', 241695),
(324225, 'PTHR39662:SF2', NULL, NULL, NULL, NULL, 'LIPID-A-DISACCHARIDE SYNTHASE RELATED GLYCOSYLTRANSFERASE', 241695),
(324226, 'PTHR12315:SF0', NULL, NULL, NULL, NULL, '7SK SNRNA METHYLPHOSPHATE CAPPING ENZYME', 241696),
(324227, 'PTHR12315:SF4', NULL, NULL, NULL, NULL, 'RNA METHYLTRANSFERASE', 241696),
(324228, 'PTHR12315', NULL, NULL, NULL, NULL, 'BICOID-INTERACTING PROTEIN RELATED', 241696);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(324229, 'PTHR12315:SF1', NULL, NULL, NULL, NULL, 'RNA 5''-MONOPHOSPHATE METHYLTRANSFERASE', 241696),
(324230, 'PTHR43493:SF5', NULL, NULL, NULL, NULL, 'DNA GYRASE SUBUNIT A, CHLOROPLASTIC/MITOCHONDRIAL', 241697),
(324231, 'PTHR43493:SF9', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE 4 SUBUNIT A', 241697),
(324232, 'PTHR43493', NULL, NULL, NULL, NULL, 'DNA GYRASE/TOPOISOMERASE SUBUNIT A', 241697),
(324233, 'PTHR43493:SF1', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE 4 SUBUNIT A', 241697),
(324234, 'PTHR43731', NULL, NULL, NULL, NULL, 'RHOMBOID PROTEASE', 241698),
(324235, 'PTHR43731:SF32', NULL, NULL, NULL, NULL, 'RHOMBOID DOMAIN-CONTAINING PROTEIN', 241698),
(324236, 'PTHR43731:SF30', NULL, NULL, NULL, NULL, 'RHOMBOID-LIKE PROTEIN 9, CHLOROPLASTIC', 241698),
(324237, 'PTHR43731:SF31', NULL, NULL, NULL, NULL, 'PRESENILINS-ASSOCIATED RHOMBOID-LIKE PROTEIN, MITOCHONDRIAL', 241698),
(324238, 'PTHR43731:SF9', NULL, NULL, NULL, NULL, 'SLR1461 PROTEIN', 241698),
(324239, 'PTHR43731:SF29', NULL, NULL, NULL, NULL, 'PRESENILINS-ASSOCIATED RHOMBOID-LIKE PROTEIN, MITOCHONDRIAL', 241698),
(324240, 'PTHR43731:SF16', NULL, NULL, NULL, NULL, 'RHOMBOSORTASE', 241698),
(324241, 'PTHR43731:SF28', NULL, NULL, NULL, NULL, 'PRESENILINS-ASSOCIATED RHOMBOID-LIKE PROTEIN, MITOCHONDRIAL', 241698),
(324242, 'PTHR43731:SF14', NULL, NULL, NULL, NULL, 'RHOMBOID DOMAIN-CONTAINING PROTEIN', 241698),
(324243, 'PTHR43731:SF26', NULL, NULL, NULL, NULL, 'RHOMBOID-LIKE PROTEIN 10, CHLOROPLASTIC', 241698),
(324244, 'PTHR13430:SF15', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 13B', 241699),
(324245, 'PTHR13430:SF18', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 13A-LIKE', 241699),
(324246, 'PTHR13430:SF17', NULL, NULL, NULL, NULL, 'ATG13 DOMAIN-CONTAINING PROTEIN', 241699),
(324247, 'PTHR13430:SF19', NULL, NULL, NULL, NULL, 'OS02G0644500 PROTEIN', 241699),
(324248, 'PTHR13430', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 241699),
(324249, 'PTHR13430:SF4', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 13', 241699),
(324250, 'PTHR47436:SF1', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 241700),
(324251, 'PTHR47436', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE ATXR2', 241700),
(324252, 'PTHR21012:SF0', NULL, NULL, NULL, NULL, 'ASPARTATE 1-DECARBOXYLASE', 241701),
(324253, 'PTHR21012', NULL, NULL, NULL, NULL, 'ASPARTATE 1-DECARBOXYLASE', 241701),
(324254, 'PTHR45180', NULL, NULL, NULL, NULL, 'OS01G0307686 PROTEIN', 241702),
(324255, 'PTHR45180:SF1', NULL, NULL, NULL, NULL, 'OS01G0307686 PROTEIN', 241702),
(324256, 'PTHR12542:SF150', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324257, 'PTHR12542:SF152', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324258, 'PTHR12542:SF151', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324259, 'PTHR12542:SF154', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324260, 'PTHR12542:SF156', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324261, 'PTHR12542:SF112', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324262, 'PTHR12542:SF155', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324263, 'PTHR12542:SF111', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324264, 'PTHR12542:SF158', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324265, 'PTHR12542:SF114', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324266, 'PTHR12542:SF157', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324267, 'PTHR12542:SF113', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324268, 'PTHR12542:SF115', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324269, 'PTHR12542:SF118', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324270, 'PTHR12542:SF117', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(324271, 'PTHR12542:SF119', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324272, 'PTHR12542:SF49', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324273, 'PTHR12542:SF44', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324274, 'PTHR12542:SF88', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324275, 'PTHR12542:SF87', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324276, 'PTHR12542:SF45', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324277, 'PTHR12542:SF40', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324278, 'PTHR12542:SF83', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 241703),
(324279, 'PTHR12542:SF86', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324280, 'PTHR12542:SF41', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT 7', 241703),
(324281, 'PTHR12542:SF85', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324282, 'PTHR12542:SF81', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324283, 'PTHR12542:SF161', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324284, 'PTHR12542:SF160', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324285, 'PTHR12542:SF162', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324286, 'PTHR12542:SF165', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324287, 'PTHR12542:SF121', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324288, 'PTHR12542:SF164', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324289, 'PTHR12542:SF167', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324290, 'PTHR12542:SF123', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324291, 'PTHR12542:SF166', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324292, 'PTHR12542:SF122', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324293, 'PTHR12542:SF169', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324294, 'PTHR12542:SF168', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324295, 'PTHR12542:SF127', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324296, 'PTHR12542:SF129', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324297, 'PTHR12542:SF38', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324298, 'PTHR12542:SF170', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324299, 'PTHR12542:SF172', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324300, 'PTHR12542:SF171', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324301, 'PTHR12542:SF130', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324302, 'PTHR12542:SF173', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324303, 'PTHR12542:SF7', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324304, 'PTHR12542:SF131', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324305, 'PTHR12542:SF134', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324306, 'PTHR12542:SF136', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324307, 'PTHR12542:SF135', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT EXO70A3-RELATED', 241703),
(324308, 'PTHR12542:SF138', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324309, 'PTHR12542:SF137', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324310, 'PTHR12542:SF139', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 241703),
(324311, 'PTHR12542:SF26', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(324312, 'PTHR12542:SF25', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324313, 'PTHR12542:SF28', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324314, 'PTHR12542:SF24', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324315, 'PTHR12542:SF23', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324316, 'PTHR12542', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX PROTEIN EXO70', 241703),
(324317, 'PTHR12542:SF140', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324318, 'PTHR12542:SF143', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324319, 'PTHR12542:SF142', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324320, 'PTHR12542:SF145', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324321, 'PTHR12542:SF101', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324322, 'PTHR12542:SF103', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT EXO70B2', 241703),
(324323, 'PTHR12542:SF147', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324324, 'PTHR12542:SF102', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324325, 'PTHR12542:SF146', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324326, 'PTHR12542:SF105', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324327, 'PTHR12542:SF148', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324328, 'PTHR12542:SF104', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324329, 'PTHR12542:SF106', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT EXO70H1', 241703),
(324330, 'PTHR12542:SF108', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324331, 'PTHR12542:SF17', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324332, 'PTHR12542:SF99', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324333, 'PTHR12542:SF98', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324334, 'PTHR12542:SF95', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324335, 'PTHR12542:SF94', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324336, 'PTHR12542:SF96', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT EXO70B1', 241703),
(324337, 'PTHR12542:SF90', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT EXO70I', 241703),
(324338, 'PTHR12542:SF93', NULL, NULL, NULL, NULL, 'EXOCYST SUBUNIT EXO70 FAMILY PROTEIN', 241703),
(324339, 'PTHR12542:SF92', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT EXO70E2', 241703),
(324340, 'PTHR47524:SF1', NULL, NULL, NULL, NULL, '20S RRNA ACCUMULATION PROTEIN 4', 241704),
(324341, 'PTHR47524', NULL, NULL, NULL, NULL, '20S RRNA ACCUMULATION PROTEIN 4', 241704),
(324342, 'PTHR12653', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE 13 KD-B SUBUNIT', 241705),
(324343, 'PTHR12653:SF0', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX SUBUNIT 5', 241705),
(324344, 'PTHR12653:SF1', NULL, NULL, NULL, NULL, 'BNAA03G12510D PROTEIN', 241705),
(324345, 'PTHR12653:SF2', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE', 241705),
(324346, 'PTHR24060:SF171', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F3_4 DOMAIN-CONTAINING PROTEIN', 241706),
(324347, 'PTHR24060:SF160', NULL, NULL, NULL, NULL, 'METABOTROPIC GLUTAMATE RECEPTOR 3', 241706),
(324348, 'PTHR24060:SF172', NULL, NULL, NULL, NULL, 'CELF35-1', 241706),
(324349, 'PTHR24060:SF162', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F3_4 DOMAIN-CONTAINING PROTEIN', 241706),
(324350, 'PTHR24060:SF173', NULL, NULL, NULL, NULL, 'PROTEIN BRIDE OF SEVENLESS', 241706),
(324351, 'PTHR24060:SF174', NULL, NULL, NULL, NULL, 'ANF_RECEPTOR DOMAIN-CONTAINING PROTEIN', 241706),
(324352, 'PTHR24060:SF165', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR, METABOTROPIC 5A', 241706),
(324353, 'PTHR24060:SF143', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR, METABOTROPIC 2B', 241706);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(324354, 'PTHR24060:SF166', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F3_4 DOMAIN-CONTAINING PROTEIN', 241706),
(324355, 'PTHR24060:SF134', NULL, NULL, NULL, NULL, 'MANGETOUT, ISOFORM G', 241706),
(324356, 'PTHR24060:SF170', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR, METABOTROPIC 6B', 241706),
(324357, 'PTHR24060', NULL, NULL, NULL, NULL, 'METABOTROPIC GLUTAMATE RECEPTOR', 241706),
(324358, 'PTHR24060:SF29', NULL, NULL, NULL, NULL, 'METABOTROPIC GLUTAMATE RECEPTOR 1', 241706),
(324359, 'PTHR24060:SF168', NULL, NULL, NULL, NULL, 'ANF_RECEPTOR DOMAIN-CONTAINING PROTEIN', 241706),
(324360, 'PTHR24060:SF24', NULL, NULL, NULL, NULL, 'METABOTROPIC GLUTAMATE RECEPTOR 6', 241706),
(324361, 'PTHR24060:SF136', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F3_4 DOMAIN-CONTAINING PROTEIN', 241706),
(324362, 'PTHR24060:SF147', NULL, NULL, NULL, NULL, 'METABOTROPIC GLUTAMATE RECEPTOR 2', 241706),
(324363, 'PTHR24060:SF23', NULL, NULL, NULL, NULL, 'METABOTROPIC GLUTAMATE RECEPTOR 4', 241706),
(324364, 'PTHR24060:SF158', NULL, NULL, NULL, NULL, 'METABOTROPIC GLUTAMATE RECEPTOR', 241706),
(324365, 'PTHR24060:SF169', NULL, NULL, NULL, NULL, '', 241706),
(324366, 'PTHR24060:SF26', NULL, NULL, NULL, NULL, 'METABOTROPIC GLUTAMATE RECEPTOR 8', 241706),
(324367, 'PTHR24060:SF30', NULL, NULL, NULL, NULL, 'METABOTROPIC GLUTAMATE RECEPTOR 5', 241706),
(324368, 'PTHR24060:SF98', NULL, NULL, NULL, NULL, 'METABOTROPIC GLUTAMATE RECEPTOR 7', 241706),
(324369, 'PTHR36046:SF1', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 241707),
(324370, 'PTHR36046', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 241707),
(324371, 'PTHR15039:SF11', NULL, NULL, NULL, NULL, 'DOLICHOL PHOSPHATE-MANNOSE BIOSYNTHESIS REGULATORY PROTEIN', 241708),
(324372, 'PTHR15039', NULL, NULL, NULL, NULL, 'DOLICHOL PHOSPHATE-MANNOSE BIOSYNTHESIS REGULATORY PROTEIN', 241708),
(324373, 'PTHR15039:SF12', NULL, NULL, NULL, NULL, 'DOLICHOL PHOSPHATE-MANNOSE BIOSYNTHESIS REGULATORY PROTEIN', 241708),
(324374, 'PTHR33960:SF1', NULL, NULL, NULL, NULL, 'SIMILAR TO KIAA0825 PROTEIN', 241709),
(324375, 'PTHR33960', NULL, NULL, NULL, NULL, 'SIMILAR TO KIAA0825 PROTEIN', 241709),
(324376, 'PTHR10816:SF11', NULL, NULL, NULL, NULL, 'MYELIN TRANSCRIPTION FACTOR 1-LIKE PROTEIN', 241710),
(324377, 'PTHR10816:SF10', NULL, NULL, NULL, NULL, 'MYELIN TRANSCRIPTION FACTOR 1', 241710),
(324378, 'PTHR10816:SF15', NULL, NULL, NULL, NULL, 'AGAP000874-PA', 241710),
(324379, 'PTHR10816:SF9', NULL, NULL, NULL, NULL, 'SUPPRESSION OF TUMORIGENICITY 18 PROTEIN', 241710),
(324380, 'PTHR10816:SF14', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE IRF2BPL-RELATED', 241710),
(324381, 'PTHR10816:SF17', NULL, NULL, NULL, NULL, 'INTERFERON REGULATORY FACTOR 2-BINDING PROTEIN 1', 241710),
(324382, 'PTHR10816:SF19', NULL, NULL, NULL, NULL, 'PROTEIN INTERACTING WITH TTK69 AND SIN3A, ISOFORM D', 241710),
(324383, 'PTHR10816', NULL, NULL, NULL, NULL, 'MYELIN TRANSCRIPTION FACTOR 1-RELATED', 241710),
(324384, 'PTHR10816:SF18', NULL, NULL, NULL, NULL, 'INTERFERON REGULATORY FACTOR 2-BINDING PROTEIN 2', 241710),
(324385, 'PTHR11092:SF2', NULL, NULL, NULL, NULL, 'BNAA06G40070D PROTEIN', 241711),
(324386, 'PTHR11092', NULL, NULL, NULL, NULL, 'SUGAR NUCLEOTIDE EPIMERASE RELATED', 241711),
(324387, 'PTHR11092:SF0', NULL, NULL, NULL, NULL, 'EPIMERASE FAMILY PROTEIN SDR39U1', 241711),
(324388, 'PTHR33404', NULL, NULL, NULL, NULL, 'CELL DIVISION TOPOLOGICAL SPECIFICITY FACTOR HOMOLOG, CHLOROPLASTIC', 241712),
(324389, 'PTHR33404:SF9', NULL, NULL, NULL, NULL, 'BNAC06G30560D PROTEIN', 241712),
(324390, 'PTHR33404:SF3', NULL, NULL, NULL, NULL, 'NMDA RECEPTOR SUBUNIT EPSILON-1, PUTATIVE (DUF3598)-RELATED', 241712),
(324391, 'PTHR33404:SF2', NULL, NULL, NULL, NULL, 'CELL DIVISION TOPOLOGICAL SPECIFICITY FACTOR HOMOLOG, CHLOROPLASTIC', 241712),
(324392, 'PTHR33404:SF1', NULL, NULL, NULL, NULL, 'SLL0497 PROTEIN', 241712),
(324393, 'PTHR11910:SF20', NULL, NULL, NULL, NULL, '', 241713),
(324394, 'PTHR11910:SF22', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT DELTA, CHLOROPLASTIC', 241713),
(324395, 'PTHR11910:SF21', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT O, MITOCHONDRIAL', 241713);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(324396, 'PTHR11910:SF1', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT O, MITOCHONDRIAL', 241713),
(324397, 'PTHR11910', NULL, NULL, NULL, NULL, 'ATP SYNTHASE DELTA CHAIN', 241713),
(324398, 'PTHR11910:SF17', NULL, NULL, NULL, NULL, 'BNAC07G13560D PROTEIN', 241713),
(324399, 'PTHR11910:SF16', NULL, NULL, NULL, NULL, 'ATP SYNTHASE F1, DELTA SUBUNIT FAMILY PROTEIN, EXPRESSED', 241713),
(324400, 'PTHR11910:SF19', NULL, NULL, NULL, NULL, 'ATP SYNTHASE-RELATED', 241713),
(324401, 'PTHR11910:SF18', NULL, NULL, NULL, NULL, 'BNACNNG66500D PROTEIN', 241713),
(324402, 'PTHR11910:SF8', NULL, NULL, NULL, NULL, 'OS06G0714700 PROTEIN', 241713),
(324403, 'PTHR20661:SF0', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-GLYCAN BIOSYNTHESIS CLASS W PROTEIN', 241714),
(324404, 'PTHR20661', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-GLYCAN BIOSYNTHESIS CLASS W PROTEIN', 241714),
(324405, 'PTHR34053:SF8', NULL, NULL, NULL, NULL, 'PROTEIN ULTRAPETALA 2', 241715),
(324406, 'PTHR34053:SF6', NULL, NULL, NULL, NULL, 'DEVELOPMENTAL REGULATOR, ULTRAPETALA-RELATED', 241715),
(324407, 'PTHR34053:SF7', NULL, NULL, NULL, NULL, 'SAND DOMAIN-CONTAINING PROTEIN', 241715),
(324408, 'PTHR34053', NULL, NULL, NULL, NULL, 'PROTEIN ULTRAPETALA 1', 241715),
(324409, 'PTHR34053:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ULTRAPETALA 1', 241715),
(324410, 'PTHR34053:SF4', NULL, NULL, NULL, NULL, 'PROTEIN ULTRAPETALA 2-LIKE', 241715),
(324411, 'PTHR34053:SF5', NULL, NULL, NULL, NULL, 'DEVELOPMENTAL REGULATOR, ULTRAPETALA-RELATED', 241715),
(324412, 'PTHR34053:SF2', NULL, NULL, NULL, NULL, 'CW-TYPE DOMAIN-CONTAINING PROTEIN', 241715),
(324413, 'PTHR34053:SF3', NULL, NULL, NULL, NULL, 'PROTEIN ULTRAPETALA 2', 241715),
(324414, 'PTHR31149:SF19', NULL, NULL, NULL, NULL, 'BNAA09G05280D PROTEIN', 241716),
(324415, 'PTHR31149:SF18', NULL, NULL, NULL, NULL, 'OS01G0108000 PROTEIN', 241716),
(324416, 'PTHR31149', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241716),
(324417, 'PTHR31149:SF7', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241716),
(324418, 'PTHR31149:SF9', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 241716),
(324419, 'PTHR31149:SF11', NULL, NULL, NULL, NULL, '187-KDA MICROTUBULE-ASSOCIATED PROTEIN AIR9', 241716),
(324420, 'PTHR31149:SF10', NULL, NULL, NULL, NULL, 'OS05G0100900 PROTEIN', 241716),
(324421, 'PTHR31149:SF13', NULL, NULL, NULL, NULL, '', 241716),
(324422, 'PTHR31149:SF14', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241716),
(324423, 'PTHR46196:SF3', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 241717),
(324424, 'PTHR46196:SF4', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR LHW', 241717),
(324425, 'PTHR46196:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR EMB1444-RELATED', 241717),
(324426, 'PTHR46196:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH157', 241717),
(324427, 'PTHR46196:SF12', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR LHW-LIKE', 241717),
(324428, 'PTHR46196:SF15', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN, TRANSCRIPTION FACTOR MYC/MYB N-TERMINAL-RELATED', 241717),
(324429, 'PTHR46196:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH157', 241717),
(324430, 'PTHR46196:SF16', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 241717),
(324431, 'PTHR46196:SF18', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN, TRANSCRIPTION FACTOR MYC/MYB N-TERMINAL-RELATED', 241717),
(324432, 'PTHR46196:SF20', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 241717),
(324433, 'PTHR46196:SF11', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTION FACTOR-LIKE PROTEIN', 241717),
(324434, 'PTHR46196:SF22', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241717),
(324435, 'PTHR46196:SF21', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTION FACTOR-LIKE PROTEIN', 241717),
(324436, 'PTHR46196', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH155-LIKE ISOFORM X1-RELATED', 241717),
(324437, 'PTHR42692:SF1', NULL, NULL, NULL, NULL, 'NUCLEOTIDE PYROPHOSPHOHYDROLASE', 241718),
(324438, 'PTHR42692', NULL, NULL, NULL, NULL, 'NUCLEOTIDE PYROPHOSPHOHYDROLASE', 241718);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(324439, 'PTHR42692:SF2', NULL, NULL, NULL, NULL, 'IG HYPOTHETICAL 16995', 241718),
(324440, 'PTHR37753', NULL, NULL, NULL, NULL, 'OS01G0940600 PROTEIN', 241719),
(324441, 'PTHR37753:SF1', NULL, NULL, NULL, NULL, 'OS01G0940600 PROTEIN', 241719),
(324442, 'PTHR22803:SF147', NULL, NULL, NULL, NULL, 'REGENERATING ISLET-DERIVED PROTEIN 4', 241720),
(324443, 'PTHR22803:SF126', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN 161', 241720),
(324444, 'PTHR22803:SF148', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 241720),
(324445, 'PTHR22803:SF104', NULL, NULL, NULL, NULL, 'MACROPHAGE MANNOSE RECEPTOR 1', 241720),
(324446, 'PTHR22803:SF137', NULL, NULL, NULL, NULL, 'REGENERATING ISLET-DERIVED PROTEIN 3-GAMMA', 241720),
(324447, 'PTHR22803:SF116', NULL, NULL, NULL, NULL, 'REGENERATING ISLET-DERIVED PROTEIN 3-GAMMA', 241720),
(324448, 'PTHR22803:SF149', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING 19A', 241720),
(324449, 'PTHR22803:SF132', NULL, NULL, NULL, NULL, 'REG III DELTA', 241720),
(324450, 'PTHR22803:SF143', NULL, NULL, NULL, NULL, '', 241720),
(324451, 'PTHR22803:SF69', NULL, NULL, NULL, NULL, 'C-TYPE MANNOSE RECEPTOR 2', 241720),
(324452, 'PTHR22803:SF144', NULL, NULL, NULL, NULL, 'CD302 ANTIGEN', 241720),
(324453, 'PTHR22803:SF145', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 241720),
(324454, 'PTHR22803:SF123', NULL, NULL, NULL, NULL, 'REGENERATING ISLET-DERIVED PROTEIN 3-ALPHA', 241720),
(324455, 'PTHR22803', NULL, NULL, NULL, NULL, 'MANNOSE, PHOSPHOLIPASE, LECTIN RECEPTOR RELATED', 241720),
(324456, 'PTHR22803:SF124', NULL, NULL, NULL, NULL, 'ACCESSORY GLAND PROTEIN ACP29AB-RELATED', 241720),
(324457, 'PTHR22803:SF146', NULL, NULL, NULL, NULL, 'COLLECTIN-12', 241720),
(324458, 'PTHR22803:SF113', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN-RELATED', 241720),
(324459, 'PTHR22803:SF129', NULL, NULL, NULL, NULL, 'LITHOSTATHINE-1-BETA', 241720),
(324460, 'PTHR22803:SF150', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 241720),
(324461, 'PTHR22803:SF65', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 75', 241720),
(324462, 'PTHR22803:SF130', NULL, NULL, NULL, NULL, 'REGENERATING ISLET-DERIVED PROTEIN 3-ALPHA', 241720),
(324463, 'PTHR22803:SF141', NULL, NULL, NULL, NULL, 'LECTIN-RELATED', 241720),
(324464, 'PTHR22803:SF131', NULL, NULL, NULL, NULL, 'LITHOSTATHINE-1-ALPHA', 241720),
(324465, 'PTHR22803:SF74', NULL, NULL, NULL, NULL, 'SECRETORY PHOSPHOLIPASE A2 RECEPTOR', 241720),
(324466, 'PTHR47364:SF11', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR 5-LIKE', 241721),
(324467, 'PTHR47364:SF22', NULL, NULL, NULL, NULL, 'CYSTATIN DOMAIN-CONTAINING PROTEIN', 241721),
(324468, 'PTHR47364:SF12', NULL, NULL, NULL, NULL, 'CYSTATIN DOMAIN-CONTAINING PROTEIN', 241721),
(324469, 'PTHR47364', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR 5', 241721),
(324470, 'PTHR47364:SF30', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR', 241721),
(324471, 'PTHR47364:SF20', NULL, NULL, NULL, NULL, 'CYSTATIN DOMAIN-CONTAINING PROTEIN', 241721),
(324472, 'PTHR47364:SF31', NULL, NULL, NULL, NULL, 'PHYTOCYSTATIN 5', 241721),
(324473, 'PTHR47364:SF18', NULL, NULL, NULL, NULL, 'CYSTATIN DOMAIN-CONTAINING PROTEIN', 241721),
(324474, 'PTHR47364:SF19', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR 1-LIKE', 241721),
(324475, 'PTHR47364:SF2', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR 5', 241721),
(324476, 'PTHR47364:SF14', NULL, NULL, NULL, NULL, 'CYSTATIN-RELATED', 241721),
(324477, 'PTHR47364:SF25', NULL, NULL, NULL, NULL, 'CYSTATIN DOMAIN-CONTAINING PROTEIN', 241721),
(324478, 'PTHR47364:SF15', NULL, NULL, NULL, NULL, 'PHYTOCYSTATIN 5-2', 241721),
(324479, 'PTHR47364:SF26', NULL, NULL, NULL, NULL, 'CYSTATIN DOMAIN-CONTAINING PROTEIN', 241721),
(324480, 'PTHR47364:SF27', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR 1-LIKE', 241721),
(324481, 'PTHR47364:SF16', NULL, NULL, NULL, NULL, 'CYSTATIN DOMAIN-CONTAINING PROTEIN', 241721),
(324482, 'PTHR47364:SF17', NULL, NULL, NULL, NULL, 'CYSTATIN DOMAIN-CONTAINING PROTEIN', 241721); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(324483, 'PTHR47364:SF28', NULL, NULL, NULL, NULL, 'CYSTATIN DOMAIN-CONTAINING PROTEIN', 241721),
(324484, 'PTHR47364:SF9', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR 5-LIKE', 241721),
(324485, 'PTHR47364:SF8', NULL, NULL, NULL, NULL, 'CYSTATIN DOMAIN-CONTAINING PROTEIN', 241721),
(324486, 'PTHR47364:SF5', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR 4', 241721),
(324487, 'PTHR24323:SF3', NULL, NULL, NULL, NULL, 'VISUAL SYSTEM HOMEOBOX 1', 241722),
(324488, 'PTHR24323:SF7', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 241722),
(324489, 'PTHR24323:SF8', NULL, NULL, NULL, NULL, 'CONE-ROD HOMEOBOX, OPPOSITE STRAND-RELATED', 241722),
(324490, 'PTHR24323:SF6', NULL, NULL, NULL, NULL, 'VISUAL SYSTEM HOMEOBOX 2', 241722),
(324491, 'PTHR24323', NULL, NULL, NULL, NULL, 'CEH-10 HOMEODOMAIN-CONTAINING HOMOLOG', 241722),
(324492, 'PTHR16705:SF7', NULL, NULL, NULL, NULL, 'COMPLEXIN-4', 241723),
(324493, 'PTHR16705:SF6', NULL, NULL, NULL, NULL, 'COMPLEXIN-1', 241723),
(324494, 'PTHR16705:SF13', NULL, NULL, NULL, NULL, 'COMPLEXIN 2', 241723),
(324495, 'PTHR16705:SF5', NULL, NULL, NULL, NULL, 'COMPLEXIN-3', 241723),
(324496, 'PTHR16705:SF12', NULL, NULL, NULL, NULL, 'COMPLEXIN 4C', 241723),
(324497, 'PTHR16705:SF4', NULL, NULL, NULL, NULL, 'COMPLEXIN', 241723),
(324498, 'PTHR16705', NULL, NULL, NULL, NULL, 'COMPLEXIN', 241723),
(324499, 'PTHR16705:SF9', NULL, NULL, NULL, NULL, 'COMPLEXIN-2', 241723),
(324500, 'PTHR42812:SF5', NULL, NULL, NULL, NULL, 'ENDO-ARABINASE', 241724),
(324501, 'PTHR42812:SF13', NULL, NULL, NULL, NULL, 'XYLANASE-RELATED', 241724),
(324502, 'PTHR42812', NULL, NULL, NULL, NULL, 'BETA-XYLOSIDASE', 241724),
(324503, 'PTHR42812:SF12', NULL, NULL, NULL, NULL, 'BETA-XYLOSIDASE-RELATED', 241724),
(324504, 'PTHR42812:SF2', NULL, NULL, NULL, NULL, 'HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G00930)-RELATED', 241724),
(324505, 'PTHR21577', NULL, NULL, NULL, NULL, 'SHUGOSHIN', 241725),
(324506, 'PTHR21577:SF3', NULL, NULL, NULL, NULL, 'SHUGOSHIN 1-RELATED', 241725),
(324507, 'PTHR33248:SF18', NULL, NULL, NULL, NULL, 'ZINC FINGER, GRF-TYPE', 241726),
(324508, 'PTHR33248:SF16', NULL, NULL, NULL, NULL, 'BNAANNG07810D PROTEIN', 241726),
(324509, 'PTHR33248:SF14', NULL, NULL, NULL, NULL, 'GRF-TYPE DOMAIN-CONTAINING PROTEIN', 241726),
(324510, 'PTHR33248:SF36', NULL, NULL, NULL, NULL, 'GRF-TYPE DOMAIN-CONTAINING PROTEIN', 241726),
(324511, 'PTHR33248:SF37', NULL, NULL, NULL, NULL, 'GRF-TYPE DOMAIN-CONTAINING PROTEIN', 241726),
(324512, 'PTHR33248:SF12', NULL, NULL, NULL, NULL, 'GRF-TYPE DOMAIN-CONTAINING PROTEIN', 241726),
(324513, 'PTHR33248:SF13', NULL, NULL, NULL, NULL, 'GRF-TYPE DOMAIN-CONTAINING PROTEIN', 241726),
(324514, 'PTHR33248:SF11', NULL, NULL, NULL, NULL, 'GRF-TYPE DOMAIN-CONTAINING PROTEIN', 241726),
(324515, 'PTHR33248:SF52', NULL, NULL, NULL, NULL, 'GRF ZINC FINGER PROTEIN', 241726),
(324516, 'PTHR33248:SF53', NULL, NULL, NULL, NULL, 'BNAA06G37630D PROTEIN', 241726),
(324517, 'PTHR33248:SF50', NULL, NULL, NULL, NULL, '', 241726),
(324518, 'PTHR33248:SF51', NULL, NULL, NULL, NULL, 'GRF-TYPE DOMAIN-CONTAINING PROTEIN', 241726),
(324519, 'PTHR33248', NULL, NULL, NULL, NULL, 'ZINC ION-BINDING PROTEIN', 241726),
(324520, 'PTHR33248:SF29', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 241726),
(324521, 'PTHR33248:SF8', NULL, NULL, NULL, NULL, 'GRF-TYPE DOMAIN-CONTAINING PROTEIN', 241726),
(324522, 'PTHR33248:SF49', NULL, NULL, NULL, NULL, 'GRF-TYPE DOMAIN-CONTAINING PROTEIN', 241726),
(324523, 'PTHR33248:SF47', NULL, NULL, NULL, NULL, 'GRF ZINC FINGER PROTEIN-RELATED', 241726),
(324524, 'PTHR33248:SF48', NULL, NULL, NULL, NULL, 'ZINC ION BINDING PROTEIN-RELATED', 241726),
(324525, 'PTHR33248:SF45', NULL, NULL, NULL, NULL, 'ZINC ION BINDING PROTEIN', 241726),
(324526, 'PTHR33248:SF46', NULL, NULL, NULL, NULL, 'GRF-TYPE DOMAIN-CONTAINING PROTEIN', 241726),
(324527, 'PTHR33248:SF43', NULL, NULL, NULL, NULL, 'GRF-TYPE DOMAIN-CONTAINING PROTEIN', 241726),
(324528, 'PTHR33248:SF21', NULL, NULL, NULL, NULL, 'GRF-TYPE DOMAIN-CONTAINING PROTEIN', 241726);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(324529, 'PTHR33248:SF22', NULL, NULL, NULL, NULL, 'GRF-TYPE DOMAIN-CONTAINING PROTEIN', 241726),
(324530, 'PTHR33248:SF44', NULL, NULL, NULL, NULL, 'GRF-TYPE DOMAIN-CONTAINING PROTEIN', 241726),
(324531, 'PTHR33248:SF41', NULL, NULL, NULL, NULL, 'ZINC FINGER, GRF-TYPE-RELATED', 241726),
(324532, 'PTHR33248:SF42', NULL, NULL, NULL, NULL, 'GRF-TYPE DOMAIN-CONTAINING PROTEIN', 241726),
(324533, 'PTHR33248:SF20', NULL, NULL, NULL, NULL, 'GRF-TYPE DOMAIN-CONTAINING PROTEIN', 241726),
(324534, 'PTHR33248:SF40', NULL, NULL, NULL, NULL, 'BNAC09G43580D PROTEIN', 241726),
(324535, 'PTHR33248:SF3', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 241726),
(324536, 'PTHR11247:SF8', NULL, NULL, NULL, NULL, 'PALMITOYL-PROTEIN THIOESTERASE 1', 241727),
(324537, 'PTHR11247:SF59', NULL, NULL, NULL, NULL, 'BNAC07G34360D PROTEIN', 241727),
(324538, 'PTHR11247:SF1', NULL, NULL, NULL, NULL, 'DOLICHYLDIPHOSPHATASE 1', 241727),
(324539, 'PTHR11247:SF77', NULL, NULL, NULL, NULL, 'LIPID PHOSPHATE PHOSPHATASE EPSILON 2, CHLOROPLASTIC', 241727),
(324540, 'PTHR11247:SF55', NULL, NULL, NULL, NULL, '', 241727),
(324541, 'PTHR11247:SF56', NULL, NULL, NULL, NULL, 'BNAA06G40130D PROTEIN', 241727),
(324542, 'PTHR11247:SF78', NULL, NULL, NULL, NULL, 'OS10G0563000 PROTEIN', 241727),
(324543, 'PTHR11247:SF75', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 241727),
(324544, 'PTHR11247:SF53', NULL, NULL, NULL, NULL, 'DOLICHYLDIPHOSPHATASE 1-RELATED', 241727),
(324545, 'PTHR11247:SF76', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 241727),
(324546, 'PTHR11247:SF73', NULL, NULL, NULL, NULL, 'ACIDPPC DOMAIN-CONTAINING PROTEIN', 241727),
(324547, 'PTHR11247:SF74', NULL, NULL, NULL, NULL, 'PALMITOYL-PROTEIN THIOESTERASE 2', 241727),
(324548, 'PTHR11247:SF71', NULL, NULL, NULL, NULL, 'ZGC:55413-RELATED', 241727),
(324549, 'PTHR11247:SF72', NULL, NULL, NULL, NULL, 'PHOSPHATIDIC ACID PHOSPHATASE TYPE 2/HALOPEROXIDASE-RELATED', 241727),
(324550, 'PTHR11247:SF50', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 241727),
(324551, 'PTHR11247:SF27', NULL, NULL, NULL, NULL, 'LYSOSOMAL THIOESTERASE PPT2', 241727),
(324552, 'PTHR11247:SF66', NULL, NULL, NULL, NULL, 'OS03G0101100 PROTEIN', 241727),
(324553, 'PTHR11247:SF67', NULL, NULL, NULL, NULL, 'PALMITOYL-PROTEIN THIOESTERASE 3', 241727),
(324554, 'PTHR11247:SF45', NULL, NULL, NULL, NULL, '', 241727),
(324555, 'PTHR11247:SF64', NULL, NULL, NULL, NULL, 'LIPID PHOSPHATE PHOSPHATASE EPSILON 2, CHLOROPLASTIC-LIKE', 241727),
(324556, 'PTHR11247', NULL, NULL, NULL, NULL, 'PALMITOYL-PROTEIN THIOESTERASE/DOLICHYLDIPHOSPHATASE 1', 241727),
(324557, 'PTHR11247:SF65', NULL, NULL, NULL, NULL, 'ACIDPPC DOMAIN-CONTAINING PROTEIN', 241727),
(324558, 'PTHR11247:SF40', NULL, NULL, NULL, NULL, 'LIPID PHOSPHATE PHOSPHATASE EPSILON 1, CHLOROPLASTIC', 241727),
(324559, 'PTHR11247:SF63', NULL, NULL, NULL, NULL, 'ACIDPPC DOMAIN-CONTAINING PROTEIN', 241727),
(324560, 'PTHR11247:SF60', NULL, NULL, NULL, NULL, 'PALMITOYL-PROTEIN THIOESTERASE 1-LIKE', 241727),
(324561, 'PTHR11247:SF61', NULL, NULL, NULL, NULL, 'ACIDPPC DOMAIN-CONTAINING PROTEIN', 241727),
(324562, 'PTHR47837', NULL, NULL, NULL, NULL, 'GTP PYROPHOSPHOKINASE YJBM', 241728),
(324563, 'PTHR47837:SF2', NULL, NULL, NULL, NULL, 'GTP PYROPHOSPHOKINASE YWAC', 241728),
(324564, 'PTHR47837:SF1', NULL, NULL, NULL, NULL, 'GTP PYROPHOSPHOKINASE YJBM', 241728),
(324565, 'PTHR11374:SF3', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 6-DEHYDROGENASE', 241729),
(324566, 'PTHR11374:SF51', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 6-DEHYDROGENASE', 241729),
(324567, 'PTHR11374:SF40', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 6-DEHYDROGENASE', 241729),
(324568, 'PTHR11374:SF50', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 6-DEHYDROGENASE', 241729),
(324569, 'PTHR11374:SF60', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 6-DEHYDROGENASE 3', 241729),
(324570, 'PTHR11374:SF55', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 6-DEHYDROGENASE 4', 241729),
(324571, 'PTHR11374:SF44', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 6-DEHYDROGENASE 2', 241729),
(324572, 'PTHR11374:SF54', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 6-DEHYDROGENASE', 241729);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(324573, 'PTHR11374:SF53', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 6-DEHYDROGENASE 1', 241729),
(324574, 'PTHR11374:SF48', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 6-DEHYDROGENASE 4', 241729),
(324575, 'PTHR11374:SF59', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 6-DEHYDROGENASE', 241729),
(324576, 'PTHR11374:SF58', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 6-DEHYDROGENASE', 241729),
(324577, 'PTHR11374:SF57', NULL, NULL, NULL, NULL, 'DEHYDROGENASE UGD1, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G00920)-RELATED', 241729),
(324578, 'PTHR11374', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE DEHYDROGENASE/UDP-MANNAC DEHYDROGENASE', 241729),
(324579, 'PTHR11374:SF56', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 6-DEHYDROGENASE', 241729),
(324580, 'PTHR15741:SF23', NULL, NULL, NULL, NULL, 'MLX-INTERACTING PROTEIN', 241730),
(324581, 'PTHR15741:SF14', NULL, NULL, NULL, NULL, 'CARBOHYDRATE-RESPONSIVE ELEMENT-BINDING PROTEIN', 241730),
(324582, 'PTHR15741:SF25', NULL, NULL, NULL, NULL, 'MAX-LIKE PROTEIN X', 241730),
(324583, 'PTHR15741:SF37', NULL, NULL, NULL, NULL, 'LD38259P', 241730),
(324584, 'PTHR15741:SF38', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 241730),
(324585, 'PTHR15741:SF27', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR AP-4', 241730),
(324586, 'PTHR15741:SF39', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 241730),
(324587, 'PTHR15741', NULL, NULL, NULL, NULL, 'BASIC HELIX-LOOP-HELIX ZIP TRANSCRIPTION FACTOR', 241730),
(324588, 'PTHR15741:SF40', NULL, NULL, NULL, NULL, 'MLX-INTERACTING PROTEIN', 241730),
(324589, 'PTHR31497:SF2', NULL, NULL, NULL, NULL, '', 241731),
(324590, 'PTHR31497:SF1', NULL, NULL, NULL, NULL, '', 241731),
(324591, 'PTHR31497:SF0', NULL, NULL, NULL, NULL, 'AUTOCRINE PROLIFERATION REPRESSOR PROTEIN A', 241731),
(324592, 'PTHR31497', NULL, NULL, NULL, NULL, 'AUTOCRINE PROLIFERATION REPRESSOR PROTEIN A', 241731),
(324593, 'PTHR24245:SF5', NULL, NULL, NULL, NULL, '', 241732),
(324594, 'PTHR24245:SF4', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 45-RELATED', 241732),
(324595, 'PTHR24245:SF7', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 78', 241732),
(324596, 'PTHR24245:SF6', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 26', 241732),
(324597, 'PTHR24245:SF1', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 63-RELATED', 241732),
(324598, 'PTHR24245', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR', 241732),
(324599, 'PTHR24245:SF0', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 241732),
(324600, 'PTHR30126:SF18', NULL, NULL, NULL, NULL, 'LYSR FAMILY TRANSCRIPTIONAL REGULATOR-RELATED', 241733),
(324601, 'PTHR30126:SF39', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR ABGR', 241733),
(324602, 'PTHR30126:SF2', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR YJIE', 241733),
(324603, 'PTHR30126:SF77', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 241733),
(324604, 'PTHR30126:SF78', NULL, NULL, NULL, NULL, 'HTH LYSR-TYPE DOMAIN-CONTAINING PROTEIN', 241733),
(324605, 'PTHR30126:SF80', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', 241733),
(324606, 'PTHR30126:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 241733),
(324607, 'PTHR30126:SF6', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR CYSB-RELATED', 241733),
(324608, 'PTHR30126:SF40', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR GLTR', 241733),
(324609, 'PTHR30126:SF84', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR PTXR', 241733),
(324610, 'PTHR30126:SF5', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL ACTIVATOR CMPR', 241733),
(324611, 'PTHR30126:SF4', NULL, NULL, NULL, NULL, 'LYSR FAMILY TRANSCRIPTIONAL REGULATOR-RELATED', 241733),
(324612, 'PTHR30126:SF81', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR ILVY', 241733),
(324613, 'PTHR30126:SF87', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL ACTIVATOR AAER', 241733),
(324614, 'PTHR30126:SF21', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', 241733),
(324615, 'PTHR30126:SF88', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', 241733);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(324616, 'PTHR30126:SF22', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR YHAJ-RELATED', 241733),
(324617, 'PTHR30126:SF42', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 241733),
(324618, 'PTHR30126:SF64', NULL, NULL, NULL, NULL, 'LYSR-FAMILY TRANSCRIPTIONAL REGULATOR', 241733),
(324619, 'PTHR30126:SF25', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR METR', 241733),
(324620, 'PTHR30126:SF90', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL ACTIVATOR BAUR', 241733),
(324621, 'PTHR30126:SF91', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', 241733),
(324622, 'PTHR30126', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR', 241733),
(324623, 'PTHR30126:SF94', NULL, NULL, NULL, NULL, 'LYSR FAMILY TRANSCRIPTIONAL REGULATOR-RELATED', 241733),
(324624, 'PTHR30126:SF95', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', 241733),
(324625, 'PTHR30126:SF92', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR CITR', 241733),
(324626, 'PTHR30126:SF93', NULL, NULL, NULL, NULL, 'HTH LYSR-TYPE DOMAIN-CONTAINING PROTEIN', 241733),
(324627, 'PTHR43883:SF2', NULL, NULL, NULL, NULL, 'TYR_PHOSPHATASE_2 DOMAIN-CONTAINING PROTEIN', 241734),
(324628, 'PTHR43883:SF1', NULL, NULL, NULL, NULL, 'GLUCONOKINASE', 241734),
(324629, 'PTHR43883', NULL, NULL, NULL, NULL, 'SLR0207 PROTEIN', 241734),
(324630, 'PTHR10607:SF1', NULL, NULL, NULL, NULL, 'OSTEOPONTIN', 241735),
(324631, 'PTHR10607', NULL, NULL, NULL, NULL, 'OSTEOPONTIN', 241735),
(324632, 'PTHR13309:SF0', NULL, NULL, NULL, NULL, 'NUCLEAR FRAGILE X MENTAL RETARDATION-INTERACTING PROTEIN 1', 241736),
(324633, 'PTHR13309', NULL, NULL, NULL, NULL, 'NUCLEAR FRAGILE X MENTAL RETARDATION PROTEIN INTERACTING PROTEIN 1', 241736),
(324634, 'PTHR13309:SF2', NULL, NULL, NULL, NULL, '', 241736),
(324635, 'PTHR13309:SF1', NULL, NULL, NULL, NULL, 'NUCLEAR FRAGILE X MENTAL RETARDATION-INTERACTING PROTEIN 1', 241736),
(324636, 'PTHR36437:SF2', NULL, NULL, NULL, NULL, 'GLYOXALASE/BLEOMYCIN RESISTANCE PROTEIN/DIOXYGENASE', 241737),
(324637, 'PTHR36437', NULL, NULL, NULL, NULL, 'GLYOXALASE/BLEOMYCIN RESISTANCE PROTEIN/DIOXYGENASE', 241737),
(324638, 'PTHR11027', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN A-II', 241738),
(324639, 'PTHR11027:SF0', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN A-II', 241738),
(324640, 'PTHR48146:SF3', NULL, NULL, NULL, NULL, '', 241739),
(324641, 'PTHR48146:SF2', NULL, NULL, NULL, NULL, 'K-STIMULATED PYROPHOSPHATE-ENERGIZED SODIUM PUMP PROTEIN', 241739),
(324642, 'PTHR48146', NULL, NULL, NULL, NULL, 'K-STIMULATED PYROPHOSPHATE-ENERGIZED SODIUM PUMP PROTEIN', 241739),
(324643, 'PTHR43384:SF15', NULL, NULL, NULL, NULL, 'ATP-BINDING PROTEIN-RELATED', 241740),
(324644, 'PTHR43384:SF7', NULL, NULL, NULL, NULL, 'CARBON-MONOXIDE DEHYDROGENASE ACCESSORY PROTEIN', 241740),
(324645, 'PTHR43384:SF14', NULL, NULL, NULL, NULL, 'ESX-1 SECRETION-ASSOCIATED PROTEIN ESPI', 241740),
(324646, 'PTHR43384:SF13', NULL, NULL, NULL, NULL, 'SLR0110 PROTEIN', 241740),
(324647, 'PTHR43384:SF11', NULL, NULL, NULL, NULL, 'SEPTUM SITE DETERMINING PROTEIN-RELATED', 241740),
(324648, 'PTHR43384:SF3', NULL, NULL, NULL, NULL, 'CODH NICKEL-INSERTION ACCESSORY PROTEIN', 241740),
(324649, 'PTHR43384:SF10', NULL, NULL, NULL, NULL, 'ATPASE INVOLVED IN CHROMOSOME PARTITIONING, PARA/MIND FAMILY', 241740),
(324650, 'PTHR43384:SF4', NULL, NULL, NULL, NULL, 'FLAGELLUM SITE-DETERMINING PROTEIN YLXH', 241740),
(324651, 'PTHR43384:SF6', NULL, NULL, NULL, NULL, 'SEPTUM SITE-DETERMINING PROTEIN MIND HOMOLOG, CHLOROPLASTIC-RELATED', 241740),
(324652, 'PTHR43384', NULL, NULL, NULL, NULL, 'SEPTUM SITE-DETERMINING PROTEIN MIND HOMOLOG, CHLOROPLASTIC-RELATED', 241740),
(324653, 'PTHR47723:SF4', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING-LIKE PROTEIN', 241741),
(324654, 'PTHR47723:SF1', NULL, NULL, NULL, NULL, 'OS05G0353850 PROTEIN', 241741),
(324655, 'PTHR47723', NULL, NULL, NULL, NULL, 'OS05G0353850 PROTEIN', 241741),
(324656, 'PTHR47723:SF16', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 241741);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(324657, 'PTHR47723:SF15', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 241741),
(324658, 'PTHR47723:SF14', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 241741),
(324659, 'PTHR47723:SF13', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 241741),
(324660, 'PTHR47723:SF9', NULL, NULL, NULL, NULL, 'RNASE H FAMILY PROTEIN', 241741),
(324661, 'PTHR47723:SF12', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 241741),
(324662, 'PTHR47723:SF11', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 241741),
(324663, 'PTHR47723:SF8', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDYL TRANSFERASE, RIBONUCLEASE H-LIKE SUPERFAMILY PROTEIN', 241741),
(324664, 'PTHR47723:SF7', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 241741),
(324665, 'PTHR47723:SF10', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE-LIKE PROTEIN', 241741),
(324666, 'PTHR34925:SF2', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 241742),
(324667, 'PTHR34925', NULL, NULL, NULL, NULL, '', 241742),
(324668, 'PTHR10219:SF80', NULL, NULL, NULL, NULL, 'GLYCOLIPID TRANSFER PROTEIN 2', 241743),
(324669, 'PTHR10219:SF81', NULL, NULL, NULL, NULL, 'GLYCOLIPID TRANSFER PROTEIN (GLTP) FAMILY PROTEIN', 241743),
(324670, 'PTHR10219:SF83', NULL, NULL, NULL, NULL, 'GLTP DOMAIN-CONTAINING PROTEIN', 241743),
(324671, 'PTHR10219:SF84', NULL, NULL, NULL, NULL, 'GLYCOLIPID TRANSFER PROTEIN 1-LIKE', 241743),
(324672, 'PTHR10219:SF85', NULL, NULL, NULL, NULL, 'GLTP DOMAIN-CONTAINING PROTEIN', 241743),
(324673, 'PTHR10219:SF86', NULL, NULL, NULL, NULL, 'GLTP DOMAIN-CONTAINING PROTEIN', 241743),
(324674, 'PTHR10219:SF20', NULL, NULL, NULL, NULL, 'CERAMIDE-1-PHOSPHATE TRANSFER PROTEIN', 241743),
(324675, 'PTHR10219:SF43', NULL, NULL, NULL, NULL, 'GLTP DOMAIN-CONTAINING PROTEIN', 241743),
(324676, 'PTHR10219:SF87', NULL, NULL, NULL, NULL, 'GLTP DOMAIN-CONTAINING PROTEIN', 241743),
(324677, 'PTHR10219:SF99', NULL, NULL, NULL, NULL, 'GLTP DOMAIN-CONTAINING PROTEIN', 241743),
(324678, 'PTHR10219:SF34', NULL, NULL, NULL, NULL, 'GLYCOLIPID TRANSFER PROTEIN 3', 241743),
(324679, 'PTHR10219:SF79', NULL, NULL, NULL, NULL, 'GLTP DOMAIN-CONTAINING PROTEIN', 241743),
(324680, 'PTHR10219:SF39', NULL, NULL, NULL, NULL, 'OS07G0445800 PROTEIN', 241743),
(324681, 'PTHR10219:SF19', NULL, NULL, NULL, NULL, 'GLYCOLIPID TRANSFER PROTEIN DOMAIN-CONTAINING PROTEIN 2', 241743),
(324682, 'PTHR10219:SF100', NULL, NULL, NULL, NULL, 'OS08G0108700 PROTEIN', 241743),
(324683, 'PTHR10219:SF102', NULL, NULL, NULL, NULL, 'GLYCOLIPID TRANSFER PROTEIN (GLTP) FAMILY PROTEIN-RELATED', 241743),
(324684, 'PTHR10219:SF101', NULL, NULL, NULL, NULL, 'GLYCOLIPID TRANSFER PROTEIN', 241743),
(324685, 'PTHR10219:SF104', NULL, NULL, NULL, NULL, 'GLYCOLIPID TRANSFER PROTEIN (GLTP) FAMILY PROTEIN', 241743),
(324686, 'PTHR10219:SF103', NULL, NULL, NULL, NULL, 'GLTP DOMAIN-CONTAINING PROTEIN', 241743),
(324687, 'PTHR10219:SF105', NULL, NULL, NULL, NULL, 'CERAMIDE TRANSFER PROTEIN', 241743),
(324688, 'PTHR10219:SF90', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY A MEMBER 8', 241743),
(324689, 'PTHR10219:SF92', NULL, NULL, NULL, NULL, 'GLTP DOMAIN-CONTAINING PROTEIN', 241743),
(324690, 'PTHR10219:SF93', NULL, NULL, NULL, NULL, 'GLYCOLIPID TRANSFER PROTEIN DOMAIN-CONTAINING 2', 241743),
(324691, 'PTHR10219:SF94', NULL, NULL, NULL, NULL, 'GLYCOLIPID TRANSFER PROTEIN (GLTP) FAMILY PROTEIN-RELATED', 241743),
(324692, 'PTHR10219:SF95', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY A MEMBER 8', 241743),
(324693, 'PTHR10219:SF74', NULL, NULL, NULL, NULL, 'GLYCOLIPID TRANSFER PROTEIN', 241743),
(324694, 'PTHR10219:SF96', NULL, NULL, NULL, NULL, 'TRANSFER PROTEIN, PUTATIVE-RELATED', 241743),
(324695, 'PTHR10219:SF75', NULL, NULL, NULL, NULL, 'PROTEIN PLEKHA9-RELATED', 241743),
(324696, 'PTHR10219:SF97', NULL, NULL, NULL, NULL, 'GLYCOLIPID TRANSFER PROTEIN', 241743),
(324697, 'PTHR10219', NULL, NULL, NULL, NULL, 'GLYCOLIPID TRANSFER PROTEIN-RELATED', 241743),
(324698, 'PTHR10219:SF25', NULL, NULL, NULL, NULL, 'RH52220P', 241743);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(324699, 'PTHR10219:SF28', NULL, NULL, NULL, NULL, 'ACD11 HOMOLOG PROTEIN', 241743),
(324700, 'PTHR46735:SF3', NULL, NULL, NULL, NULL, 'CALPAIN, SMALL SUBUNIT 1 A-RELATED', 241744),
(324701, 'PTHR46735', NULL, NULL, NULL, NULL, 'CALPAIN, SMALL SUBUNIT 1 A-RELATED', 241744),
(324702, 'PTHR46735:SF1', NULL, NULL, NULL, NULL, 'CALPAIN SMALL SUBUNIT 1', 241744),
(324703, 'PTHR46735:SF7', NULL, NULL, NULL, NULL, 'SORCIN', 241744),
(324704, 'PTHR46735:SF6', NULL, NULL, NULL, NULL, '', 241744),
(324705, 'PTHR46735:SF5', NULL, NULL, NULL, NULL, 'GRANCALCIN', 241744),
(324706, 'PTHR46735:SF4', NULL, NULL, NULL, NULL, 'CALPAIN SMALL SUBUNIT 2', 241744),
(324707, 'PTHR34347:SF1', NULL, NULL, NULL, NULL, 'DNA REPAIR-SCAFFOLDING PROTEIN', 241745),
(324708, 'PTHR34347', NULL, NULL, NULL, NULL, 'DNA REPAIR-SCAFFOLDING PROTEIN SPIDR', 241745),
(324709, 'PTHR15852:SF29', NULL, NULL, NULL, NULL, 'PLASTID TRANSCRIPTIONALLY ACTIVE PROTEIN', 241746),
(324710, 'PTHR15852:SF60', NULL, NULL, NULL, NULL, 'BNAC01G42740D PROTEIN', 241746),
(324711, 'PTHR15852:SF63', NULL, NULL, NULL, NULL, 'BNAA02G17140D PROTEIN', 241746),
(324712, 'PTHR15852:SF62', NULL, NULL, NULL, NULL, 'BNAA04G20410D PROTEIN', 241746),
(324713, 'PTHR15852:SF8', NULL, NULL, NULL, NULL, 'PROTEIN ORANGE-LIKE, CHLOROPLASTIC', 241746),
(324714, 'PTHR15852:SF68', NULL, NULL, NULL, NULL, 'BNAA06G17240D PROTEIN', 241746),
(324715, 'PTHR15852:SF24', NULL, NULL, NULL, NULL, 'OS02G0651300 PROTEIN', 241746),
(324716, 'PTHR15852:SF27', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE LQY1, CHLOROPLASTIC', 241746),
(324717, 'PTHR15852:SF49', NULL, NULL, NULL, NULL, 'PROTEIN SSUH2 HOMOLOG', 241746),
(324718, 'PTHR15852', NULL, NULL, NULL, NULL, 'PLASTID TRANSCRIPTIONALLY ACTIVE PROTEIN', 241746),
(324719, 'PTHR15852:SF66', NULL, NULL, NULL, NULL, 'OS09G0423700 PROTEIN', 241746),
(324720, 'PTHR15852:SF72', NULL, NULL, NULL, NULL, '', 241746),
(324721, 'PTHR15852:SF74', NULL, NULL, NULL, NULL, 'PROTEIN ORANGE, CHLOROPLASTIC', 241746),
(324722, 'PTHR15852:SF52', NULL, NULL, NULL, NULL, 'THYLAKOID LUMENAL P17.1 PROTEIN', 241746),
(324723, 'PTHR15852:SF51', NULL, NULL, NULL, NULL, 'PROTEIN BUNDLE SHEATH DEFECTIVE 2, CHLOROPLASTIC', 241746),
(324724, 'PTHR15852:SF13', NULL, NULL, NULL, NULL, 'DNAJ/HSP40 CYSTEINE-RICH DOMAIN SUPERFAMILY PROTEIN', 241746),
(324725, 'PTHR15852:SF57', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ-LIKE PROTEIN', 241746),
(324726, 'PTHR15852:SF16', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE ISOMERASE PTAC5, CHLOROPLASTIC', 241746),
(324727, 'PTHR15852:SF59', NULL, NULL, NULL, NULL, 'BNAA02G17390D PROTEIN', 241746),
(324728, 'PTHR15852:SF76', NULL, NULL, NULL, NULL, '', 241746),
(324729, 'PTHR15852:SF54', NULL, NULL, NULL, NULL, 'PROTEIN BUNDLE SHEATH DEFECTIVE 2, CHLOROPLASTIC', 241746),
(324730, 'PTHR15852:SF75', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ-RELATED', 241746),
(324731, 'PTHR15852:SF56', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF STOMATIN MUTANT UNCOORDINATION', 241746),
(324732, 'PTHR15852:SF78', NULL, NULL, NULL, NULL, 'PROTEIN SSUH2 HOMOLOG', 241746),
(324733, 'PTHR15852:SF11', NULL, NULL, NULL, NULL, 'SSU-2 HOMOLOG, TANDEM DUPLICATE 2-RELATED', 241746),
(324734, 'PTHR15852:SF77', NULL, NULL, NULL, NULL, 'PROTEIN P13.9, PUTATIVE-RELATED', 241746),
(324735, 'PTHR15852:SF55', NULL, NULL, NULL, NULL, 'PROTEIN EMBRYO SAC DEVELOPMENT ARREST 3, CHLOROPLASTIC ISOFORM X1', 241746),
(324736, 'PTHR13620:SF59', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDYL TRANSFERASE, RIBONUCLEASE H-LIKE SUPERFAMILY PROTEIN', 241747),
(324737, 'PTHR13620:SF58', NULL, NULL, NULL, NULL, 'PROTEIN CBG10060', 241747),
(324738, 'PTHR13620:SF39', NULL, NULL, NULL, NULL, 'OS04G0225100 PROTEIN', 241747),
(324739, 'PTHR13620:SF99', NULL, NULL, NULL, NULL, 'WERNER SYNDROME-LIKE EXONUCLEASE', 241747),
(324740, 'PTHR13620:SF77', NULL, NULL, NULL, NULL, 'BNAC01G38340D PROTEIN', 241747),
(324741, 'PTHR13620:SF54', NULL, NULL, NULL, NULL, 'OS01G0566000 PROTEIN', 241747),
(324742, 'PTHR13620:SF76', NULL, NULL, NULL, NULL, 'WERNER SYNDROME-LIKE EXONUCLEASE', 241747);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(324743, 'PTHR13620:SF79', NULL, NULL, NULL, NULL, '', 241747),
(324744, 'PTHR13620:SF57', NULL, NULL, NULL, NULL, 'OS07G0112400 PROTEIN', 241747),
(324745, 'PTHR13620:SF51', NULL, NULL, NULL, NULL, '3-5 EXONUCLEASE/ NUCLEIC ACID BINDING PROTEIN', 241747),
(324746, 'PTHR13620:SF100', NULL, NULL, NULL, NULL, '', 241747),
(324747, 'PTHR13620:SF72', NULL, NULL, NULL, NULL, '', 241747),
(324748, 'PTHR13620:SF102', NULL, NULL, NULL, NULL, 'PROTEIN RISC-INTERACTING CLEARING 3''-5'' EXORIBONUCLEASE 2', 241747),
(324749, 'PTHR13620:SF97', NULL, NULL, NULL, NULL, '3''-5'' EXONUCLEASE DOMAIN-CONTAINING PROTEIN', 241747),
(324750, 'PTHR13620:SF75', NULL, NULL, NULL, NULL, 'EMB|CAB82946.1-RELATED', 241747),
(324751, 'PTHR13620:SF104', NULL, NULL, NULL, NULL, 'EXONUCLEASE 3''-5'' DOMAIN-CONTAINING PROTEIN 2', 241747),
(324752, 'PTHR13620:SF90', NULL, NULL, NULL, NULL, '3''-5'' EXONUCLEASE DOMAIN-CONTAINING PROTEIN', 241747),
(324753, 'PTHR13620:SF105', NULL, NULL, NULL, NULL, 'OS01G0660500 PROTEIN', 241747),
(324754, 'PTHR13620:SF106', NULL, NULL, NULL, NULL, '3''-5'' EXONUCLEASE DOMAIN-CONTAINING PROTEIN', 241747),
(324755, 'PTHR13620:SF107', NULL, NULL, NULL, NULL, '3''-5'' EXONUCLEASE DOMAIN-CONTAINING PROTEIN', 241747),
(324756, 'PTHR13620:SF108', NULL, NULL, NULL, NULL, '3''-5'' EXONUCLEASE DOMAIN-CONTAINING PROTEIN', 241747),
(324757, 'PTHR13620:SF109', NULL, NULL, NULL, NULL, 'WERNER SYNDROME-LIKE EXONUCLEASE', 241747),
(324758, 'PTHR13620:SF5', NULL, NULL, NULL, NULL, 'WERNER SYNDROME ATP-DEPENDENT HELICASE-LIKE', 241747),
(324759, 'PTHR13620:SF44', NULL, NULL, NULL, NULL, '3''-5'' EXONUCLEASE DOMAIN-CONTAINING PROTEIN', 241747),
(324760, 'PTHR13620:SF43', NULL, NULL, NULL, NULL, 'WERNER SYNDROME ATP-DEPENDENT HELICASE', 241747),
(324761, 'PTHR13620:SF68', NULL, NULL, NULL, NULL, '3''-5'' EXONUCLEASE DOMAIN-CONTAINING PROTEIN', 241747),
(324762, 'PTHR13620:SF46', NULL, NULL, NULL, NULL, 'PROTEIN RISC-INTERACTING CLEARING 3''-5'' EXORIBONUCLEASE 1', 241747),
(324763, 'PTHR13620:SF89', NULL, NULL, NULL, NULL, 'BNAC01G44900D PROTEIN', 241747),
(324764, 'PTHR13620:SF110', NULL, NULL, NULL, NULL, '3''-5'' EXONUCLEASE DOMAIN-CONTAINING PROTEIN', 241747),
(324765, 'PTHR13620:SF111', NULL, NULL, NULL, NULL, '3''-5'' EXONUCLEASE DOMAIN-CONTAINING PROTEIN', 241747),
(324766, 'PTHR13620:SF83', NULL, NULL, NULL, NULL, 'OS01G0660800 PROTEIN', 241747),
(324767, 'PTHR13620:SF112', NULL, NULL, NULL, NULL, 'OS01G0737600 PROTEIN', 241747),
(324768, 'PTHR13620:SF113', NULL, NULL, NULL, NULL, '', 241747),
(324769, 'PTHR13620:SF85', NULL, NULL, NULL, NULL, 'WERNER SYNDROME-LIKE EXONUCLEASE', 241747),
(324770, 'PTHR13620:SF114', NULL, NULL, NULL, NULL, '', 241747),
(324771, 'PTHR13620:SF80', NULL, NULL, NULL, NULL, '3''-5'' EXONUCLEASE DOMAIN-CONTAINING PROTEIN', 241747),
(324772, 'PTHR13620:SF115', NULL, NULL, NULL, NULL, 'BNAC05G01380D PROTEIN', 241747),
(324773, 'PTHR13620:SF116', NULL, NULL, NULL, NULL, '', 241747),
(324774, 'PTHR13620:SF117', NULL, NULL, NULL, NULL, 'WERNER SYNDROME-LIKE EXONUCLEASE', 241747),
(324775, 'PTHR13620:SF82', NULL, NULL, NULL, NULL, 'BNAA09G39800D PROTEIN', 241747),
(324776, 'PTHR13620:SF118', NULL, NULL, NULL, NULL, '3''-5'' EXONUCLEASE DOMAIN-CONTAINING PROTEIN', 241747),
(324777, 'PTHR13620:SF119', NULL, NULL, NULL, NULL, 'BNAC01G38360D PROTEIN', 241747),
(324778, 'PTHR13620', NULL, NULL, NULL, NULL, '3-5 EXONUCLEASE', 241747),
(324779, 'PTHR13459:SF2', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 241748),
(324780, 'PTHR13459:SF1', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 220A', 241748),
(324781, 'PTHR13459:SF3', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF220', 241748),
(324782, 'PTHR13459', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 241748),
(324783, 'PTHR35023:SF1', NULL, NULL, NULL, NULL, 'MG-PROTOPORPHYRIN IX CHELATASE', 241749),
(324784, 'PTHR35023', NULL, NULL, NULL, NULL, 'CHELATASE-RELATED', 241749),
(324785, 'PTHR23337', NULL, NULL, NULL, NULL, 'ZINC FINGER CW-TYPE COILED-COIL DOMAIN PROTEIN 1', 241750),
(324786, 'PTHR23337:SF7', NULL, NULL, NULL, NULL, 'ATPASE MORC2', 241750);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(324787, 'PTHR23337:SF5', NULL, NULL, NULL, NULL, 'ATPASE MORC2B', 241750),
(324788, 'PTHR23337:SF6', NULL, NULL, NULL, NULL, 'MORC FAMILY CW-TYPE ZINC FINGER PROTEIN 1', 241750),
(324789, 'PTHR23337:SF3', NULL, NULL, NULL, NULL, 'MORC FAMILY CW-TYPE ZINC FINGER 2', 241750),
(324790, 'PTHR39611:SF2', NULL, NULL, NULL, NULL, '', 241751),
(324791, 'PTHR39611:SF1', NULL, NULL, NULL, NULL, '', 241751),
(324792, 'PTHR39611', NULL, NULL, NULL, NULL, '', 241751),
(324793, 'PTHR10150', NULL, NULL, NULL, NULL, 'DNA REPAIR ENDONUCLEASE XPF', 241752),
(324794, 'PTHR10150:SF0', NULL, NULL, NULL, NULL, 'DNA REPAIR ENDONUCLEASE XPF', 241752),
(324795, 'PTHR37167:SF1', NULL, NULL, NULL, NULL, '1,4-DIHYDROXY-6-NAPHTOATE SYNTHASE', 241753),
(324796, 'PTHR37167', NULL, NULL, NULL, NULL, '1,4-DIHYDROXY-6-NAPHTOATE SYNTHASE', 241753),
(324797, 'PTHR38775:SF1', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', 241754),
(324798, 'PTHR38775', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', 241754),
(324799, 'PTHR28398', NULL, NULL, NULL, NULL, 'SYNAPTONEMAL COMPLEX CENTRAL ELEMENT PROTEIN 2', 241755),
(324800, 'PTHR28398:SF1', NULL, NULL, NULL, NULL, 'SYNAPTONEMAL COMPLEX CENTRAL ELEMENT PROTEIN 2', 241755),
(324801, 'PTHR46360', NULL, NULL, NULL, NULL, 'DISKS LARGE HOMOLOG 5', 241756),
(324802, 'PTHR46360:SF1', NULL, NULL, NULL, NULL, 'DISKS LARGE HOMOLOG 5', 241756),
(324803, 'PTHR43377:SF10', NULL, NULL, NULL, NULL, 'BILIVERDIN REDUCTASE', 241757),
(324804, 'PTHR43377:SF8', NULL, NULL, NULL, NULL, 'BLR3664 PROTEIN', 241757),
(324805, 'PTHR43377:SF1', NULL, NULL, NULL, NULL, 'BILIVERDIN REDUCTASE A', 241757),
(324806, 'PTHR43377:SF2', NULL, NULL, NULL, NULL, 'ZGC:154075', 241757),
(324807, 'PTHR43377:SF6', NULL, NULL, NULL, NULL, 'GFO_IDH_MOCA DOMAIN-CONTAINING PROTEIN', 241757),
(324808, 'PTHR43377', NULL, NULL, NULL, NULL, 'BILIVERDIN REDUCTASE A', 241757),
(324809, 'PTHR43377:SF12', NULL, NULL, NULL, NULL, 'BINDING ROSSMANN FOLD OXIDOREDUCTASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G11840)-RELATED', 241757),
(324810, 'PTHR47981:SF16', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-RELATED', 241758),
(324811, 'PTHR47981:SF38', NULL, NULL, NULL, NULL, 'YPT/RAB-TYPE GTPASE YPT71', 241758),
(324812, 'PTHR47981:SF37', NULL, NULL, NULL, NULL, 'SMALL GTPASE SUPERFAMILY, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 241758),
(324813, 'PTHR47981:SF15', NULL, NULL, NULL, NULL, 'BNAA09G55930D PROTEIN', 241758),
(324814, 'PTHR47981:SF17', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-9B', 241758),
(324815, 'PTHR47981:SF19', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-7B', 241758),
(324816, 'PTHR47981:SF30', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN-RELATED', 241758),
(324817, 'PTHR47981:SF10', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB7-LIKE ISOFORM X1', 241758),
(324818, 'PTHR47981:SF34', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN-RELATED', 241758),
(324819, 'PTHR47981:SF14', NULL, NULL, NULL, NULL, 'BNAA05G14990D PROTEIN', 241758),
(324820, 'PTHR47981:SF36', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABG1-RELATED', 241758),
(324821, 'PTHR47981:SF35', NULL, NULL, NULL, NULL, 'BNAA01G26470D PROTEIN', 241758),
(324822, 'PTHR47981:SF13', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-7A', 241758),
(324823, 'PTHR47981:SF27', NULL, NULL, NULL, NULL, 'BNAC03G69320D PROTEIN', 241758),
(324824, 'PTHR47981:SF26', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABG3E', 241758),
(324825, 'PTHR47981', NULL, NULL, NULL, NULL, 'RAB FAMILY', 241758),
(324826, 'PTHR47981:SF9', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-9A', 241758),
(324827, 'PTHR47981:SF20', NULL, NULL, NULL, NULL, 'RAB FAMILY', 241758),
(324828, 'PTHR47981:SF4', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABG3F', 241758),
(324829, 'PTHR47981:SF22', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-7B', 241758),
(324830, 'PTHR47981:SF6', NULL, NULL, NULL, NULL, 'SI:DKEY-13A21.4', 241758),
(324831, 'PTHR47981:SF25', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABG2', 241758),
(324832, 'PTHR47981:SF7', NULL, NULL, NULL, NULL, 'OS05G0536900 PROTEIN', 241758);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(324833, 'PTHR47981:SF24', NULL, NULL, NULL, NULL, 'OS05G0516600 PROTEIN', 241758),
(324834, 'PTHR47981:SF1', NULL, NULL, NULL, NULL, 'RE17845P', 241758),
(324835, 'PTHR47981:SF2', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABG3B', 241758),
(324836, 'PTHR47981:SF3', NULL, NULL, NULL, NULL, 'RAB7B, MEMBER RAS ONCOGENE FAMILY-RELATED', 241758),
(324837, 'PTHR34665:SF1', NULL, NULL, NULL, NULL, 'OS02G0595200 PROTEIN', 241759),
(324838, 'PTHR34665', NULL, NULL, NULL, NULL, '', 241759),
(324839, 'PTHR34665:SF3', NULL, NULL, NULL, NULL, 'BNACNNG18970D PROTEIN', 241759),
(324840, 'PTHR34665:SF4', NULL, NULL, NULL, NULL, '', 241759),
(324841, 'PTHR31545:SF2', NULL, NULL, NULL, NULL, 'SPEEDY PROTEIN C', 241760),
(324842, 'PTHR31545', NULL, NULL, NULL, NULL, 'SEEDY PROTEIN A/C FAMILY MEMBER', 241760),
(324843, 'PTHR31545:SF4', NULL, NULL, NULL, NULL, 'SPEEDY PROTEIN A', 241760),
(324844, 'PTHR31545:SF5', NULL, NULL, NULL, NULL, '', 241760),
(324845, 'PTHR11795:SF452', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN', 241761),
(324846, 'PTHR11795:SF451', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN', 241761),
(324847, 'PTHR11795:SF442', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN', 241761),
(324848, 'PTHR11795:SF445', NULL, NULL, NULL, NULL, 'AMINO ACID ABC TRANSPORTER PERMEASE PROTEIN', 241761),
(324849, 'PTHR11795:SF447', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN', 241761),
(324850, 'PTHR11795:SF449', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN AMINO ACID TRANSPORT PERMEASE PROTEIN LIVH-RELATED', 241761),
(324851, 'PTHR11795', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN AMINO ACID TRANSPORT SYSTEM PERMEASE PROTEIN LIVH', 241761),
(324852, 'PTHR11795:SF371', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY BRANCHED-CHAIN AMINO ACID TRANSPORT SYSTEM PERMEASE PROTEIN LIVH', 241761),
(324853, 'PTHR11795:SF450', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN', 241761),
(324854, 'PTHR12475:SF9', NULL, NULL, NULL, NULL, 'PROTEIN THEM6', 241762),
(324855, 'PTHR12475:SF11', NULL, NULL, NULL, NULL, 'PROTEIN THEM6-LIKE PROTEIN', 241762),
(324856, 'PTHR12475:SF4', NULL, NULL, NULL, NULL, 'PROTEIN THEM6', 241762),
(324857, 'PTHR12475:SF10', NULL, NULL, NULL, NULL, 'PROTEIN THEM6', 241762),
(324858, 'PTHR12475', NULL, NULL, NULL, NULL, '', 241762),
(324859, 'PTHR31544:SF3', NULL, NULL, NULL, NULL, 'OS02G0141000 PROTEIN', 241763),
(324860, 'PTHR31544:SF2', NULL, NULL, NULL, NULL, 'AIG2-LIKE PROTEIN D', 241763),
(324861, 'PTHR31544', NULL, NULL, NULL, NULL, 'AIG2-LIKE PROTEIN D', 241763),
(324862, 'PTHR31544:SF13', NULL, NULL, NULL, NULL, 'GGACT DOMAIN-CONTAINING PROTEIN', 241763),
(324863, 'PTHR31544:SF14', NULL, NULL, NULL, NULL, 'GGACT DOMAIN-CONTAINING PROTEIN', 241763),
(324864, 'PTHR31544:SF11', NULL, NULL, NULL, NULL, 'AIG2-LIKE PROTEIN', 241763),
(324865, 'PTHR31544:SF12', NULL, NULL, NULL, NULL, 'PROTEIN AIG2 A-RELATED', 241763),
(324866, 'PTHR31544:SF10', NULL, NULL, NULL, NULL, 'BUTIROSIN BIOSYNTHESIS, BTRG-LIKE PROTEIN-RELATED', 241763),
(324867, 'PTHR31544:SF9', NULL, NULL, NULL, NULL, 'AIG2-LIKE PROTEIN C', 241763),
(324868, 'PTHR31544:SF8', NULL, NULL, NULL, NULL, 'GGACT DOMAIN-CONTAINING PROTEIN', 241763),
(324869, 'PTHR31544:SF7', NULL, NULL, NULL, NULL, 'GGACT DOMAIN-CONTAINING PROTEIN', 241763),
(324870, 'PTHR31544:SF6', NULL, NULL, NULL, NULL, 'AIG2-LIKE PROTEIN A-RELATED', 241763),
(324871, 'PTHR31544:SF5', NULL, NULL, NULL, NULL, 'PROTEIN AIG2 C', 241763),
(324872, 'PTHR31544:SF4', NULL, NULL, NULL, NULL, 'GGACT DOMAIN-CONTAINING PROTEIN', 241763),
(324873, 'PTHR28376', NULL, NULL, NULL, NULL, 'RGD1562914', 241764),
(324874, 'PTHR28376:SF1', NULL, NULL, NULL, NULL, 'RGD1562914', 241764),
(324875, 'PTHR48198:SF1', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN-LIKE PROTEIN 4A-RELATED', 241765),
(324876, 'PTHR48198', NULL, NULL, NULL, NULL, 'EC PROTEIN HOMOLOG', 241765),
(324877, 'PTHR37425:SF1', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN-RELATED', 241766),
(324878, 'PTHR37425', NULL, NULL, NULL, NULL, '', 241766),
(324879, 'PTHR31183', NULL, NULL, NULL, NULL, 'TRICHOPLEIN KERATIN FILAMENT-BINDING PROTEIN FAMILY MEMBER', 241767);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(324880, 'PTHR31183:SF2', NULL, NULL, NULL, NULL, 'TRICHOPLEIN KERATIN FILAMENT-BINDING PROTEIN', 241767),
(324881, 'PTHR31183:SF1', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 53', 241767),
(324882, 'PTHR40891', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 241768),
(324883, 'PTHR40891:SF2', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE ETA', 241768),
(324884, 'PTHR40891:SF1', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 241768),
(324885, 'PTHR40891:SF3', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 241768),
(324886, 'PTHR37880:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 54', 241769),
(324887, 'PTHR37880', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 54', 241769),
(324888, 'PTHR11063', NULL, NULL, NULL, NULL, 'GLUTAMATE SEMIALDEHYDE DEHYDROGENASE', 241770),
(324889, 'PTHR11063:SF13', NULL, NULL, NULL, NULL, 'DELTA-1-PYRROLINE-5-CARBOXYLATE SYNTHASE 2', 241770),
(324890, 'PTHR11063:SF25', NULL, NULL, NULL, NULL, 'DELTA-1-PYRROLINE-5-CARBOXYLATE SYNTHASE', 241770),
(324891, 'PTHR11063:SF26', NULL, NULL, NULL, NULL, 'DELTA-1-PYRROLINE-5-CARBOXYLATE SYNTHASE', 241770),
(324892, 'PTHR11063:SF27', NULL, NULL, NULL, NULL, 'DELTA-1-PYRROLINE-5-CARBOXYLATE SYNTHASE', 241770),
(324893, 'PTHR11063:SF16', NULL, NULL, NULL, NULL, 'DELTA-1-PYRROLINE-5-CARBOXYLATE SYNTHASE', 241770),
(324894, 'PTHR11063:SF20', NULL, NULL, NULL, NULL, 'DELTA-1-PYRROLINE-5-CARBOXYLATE SYNTHASE A', 241770),
(324895, 'PTHR11063:SF8', NULL, NULL, NULL, NULL, 'DELTA-1-PYRROLINE-5-CARBOXYLATE SYNTHASE', 241770),
(324896, 'PTHR11063:SF22', NULL, NULL, NULL, NULL, 'DELTA-1-PYRROLINE-5-CARBOXYLATE SYNTHASE', 241770),
(324897, 'PTHR11063:SF23', NULL, NULL, NULL, NULL, 'DELTA-1-PYRROLINE-5-CARBOXYLATE SYNTHASE', 241770),
(324898, 'PTHR40137', NULL, NULL, NULL, NULL, 'PROTEIN GVPK 1', 241771),
(324899, 'PTHR40137:SF2', NULL, NULL, NULL, NULL, 'PROTEIN GVPK 1', 241771),
(324900, 'PTHR31912', NULL, NULL, NULL, NULL, 'IP13529P', 241772),
(324901, 'PTHR31912:SF16', NULL, NULL, NULL, NULL, 'ZGC:113210', 241772),
(324902, 'PTHR31912:SF34', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 241772),
(324903, 'PTHR31912:SF35', NULL, NULL, NULL, NULL, 'ZINC FINGER, C2H2 TYPE DOMAINCONTAINING PROTEIN', 241772),
(324904, 'PTHR13667', NULL, NULL, NULL, NULL, 'HOMOLOC-13', 241773),
(324905, 'PTHR13667:SF5', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING AND PLANAR CELL POLARITY EFFECTOR PROTEIN FRITZ HOMOLOG', 241773),
(324906, 'PTHR14037:SF4', NULL, NULL, NULL, NULL, 'MAMMAGLOBIN-B', 241774),
(324907, 'PTHR14037', NULL, NULL, NULL, NULL, 'MAMMAGLOBIN-RELATED', 241774),
(324908, 'PTHR14037:SF7', NULL, NULL, NULL, NULL, 'MAMMAGLOBIN-A', 241774),
(324909, 'PTHR11556:SF42', NULL, NULL, NULL, NULL, 'D-FRUCTOSE-1,6-BISPHOSPHATE 1-PHOSPHOHYDROLASE', 241775),
(324910, 'PTHR11556:SF41', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATASE', 241775),
(324911, 'PTHR11556:SF40', NULL, NULL, NULL, NULL, 'D-FRUCTOSE-1,6-BISPHOSPHATE 1-PHOSPHOHYDROLASE', 241775),
(324912, 'PTHR11556:SF13', NULL, NULL, NULL, NULL, 'FRUCTOSE-1,6-BISPHOSPHATASE ISOZYME 2', 241775),
(324913, 'PTHR11556:SF35', NULL, NULL, NULL, NULL, 'SEDOHEPTULOSE-1,7-BISPHOSPHATASE, CHLOROPLASTIC', 241775),
(324914, 'PTHR11556', NULL, NULL, NULL, NULL, 'FRUCTOSE-1,6-BISPHOSPHATASE-RELATED', 241775),
(324915, 'PTHR11556:SF34', NULL, NULL, NULL, NULL, 'D-FRUCTOSE-1,6-BISPHOSPHATE 1-PHOSPHOHYDROLASE', 241775),
(324916, 'PTHR11556:SF12', NULL, NULL, NULL, NULL, 'D-FRUCTOSE-1,6-BISPHOSPHATE 1-PHOSPHOHYDROLASE', 241775),
(324917, 'PTHR11556:SF11', NULL, NULL, NULL, NULL, 'FRUCTOSE-1,6-BISPHOSPHATASE 1', 241775),
(324918, 'PTHR11556:SF43', NULL, NULL, NULL, NULL, 'D-FRUCTOSE-1,6-BISPHOSPHATE 1-PHOSPHOHYDROLASE', 241775),
(324919, 'PTHR11556:SF39', NULL, NULL, NULL, NULL, 'D-FRUCTOSE-1,6-BISPHOSPHATE 1-PHOSPHOHYDROLASE', 241775),
(324920, 'PTHR11556:SF1', NULL, NULL, NULL, NULL, 'FRUCTOSE-1,6-BISPHOSPHATASE 1, CHLOROPLASTIC', 241775),
(324921, 'PTHR11556:SF36', NULL, NULL, NULL, NULL, 'D-FRUCTOSE-1,6-BISPHOSPHATE 1-PHOSPHOHYDROLASE', 241775);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(324922, 'PTHR11556:SF18', NULL, NULL, NULL, NULL, 'D-FRUCTOSE-1,6-BISPHOSPHATE 1-PHOSPHOHYDROLASE', 241775),
(324923, 'PTHR13865:SF31', NULL, NULL, NULL, NULL, 'TIGHT JUNCTION PROTEIN 1A', 241776),
(324924, 'PTHR13865:SF11', NULL, NULL, NULL, NULL, 'TIGHT JUNCTION PROTEIN ZO-3', 241776),
(324925, 'PTHR13865:SF25', NULL, NULL, NULL, NULL, 'TIGHT JUNCTION PROTEIN ZO-1', 241776),
(324926, 'PTHR13865:SF26', NULL, NULL, NULL, NULL, 'TIGHT JUNCTION PROTEIN ZO-2', 241776),
(324927, 'PTHR13865', NULL, NULL, NULL, NULL, 'TIGHT JUNCTION PROTEIN', 241776),
(324928, 'PTHR13865:SF28', NULL, NULL, NULL, NULL, 'POLYCHAETOID, ISOFORM O', 241776),
(324929, 'PTHR34846', NULL, NULL, NULL, NULL, '4-CARBOXYMUCONOLACTONE DECARBOXYLASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_6G11590)', 241777),
(324930, 'PTHR34846:SF5', NULL, NULL, NULL, NULL, '4-CARBOXYMUCONOLACTONE DECARBOXYLASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_6G11590)', 241777),
(324931, 'PTHR34846:SF7', NULL, NULL, NULL, NULL, 'BLL7811 PROTEIN', 241777),
(324932, 'PTHR34846:SF9', NULL, NULL, NULL, NULL, '4-CARBOXYMUCONOLACTONE DECARBOXYLASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_1G03690)', 241777),
(324933, 'PTHR45708:SF29', NULL, NULL, NULL, NULL, 'OS04G0347200 PROTEIN', 241778),
(324934, 'PTHR45708:SF27', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_18 DOMAIN-CONTAINING PROTEIN', 241778),
(324935, 'PTHR45708:SF49', NULL, NULL, NULL, NULL, 'ENDOCHITINASE', 241778),
(324936, 'PTHR45708:SF28', NULL, NULL, NULL, NULL, 'A, PUTATIVE-RELATED', 241778),
(324937, 'PTHR45708:SF25', NULL, NULL, NULL, NULL, 'OS01G0691000 PROTEIN', 241778),
(324938, 'PTHR45708:SF47', NULL, NULL, NULL, NULL, 'ENDOCHITINASE A', 241778),
(324939, 'PTHR45708:SF35', NULL, NULL, NULL, NULL, 'OS01G0687400 PROTEIN', 241778),
(324940, 'PTHR45708:SF54', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_18 DOMAIN-CONTAINING PROTEIN', 241778),
(324941, 'PTHR45708:SF11', NULL, NULL, NULL, NULL, 'XYLANASE INHIBITOR PROTEIN XIP', 241778),
(324942, 'PTHR45708:SF33', NULL, NULL, NULL, NULL, 'CHITINASE', 241778),
(324943, 'PTHR45708:SF30', NULL, NULL, NULL, NULL, 'ACIDIC ENDOCHITINASE', 241778),
(324944, 'PTHR45708:SF52', NULL, NULL, NULL, NULL, 'OS11G0702200 PROTEIN', 241778),
(324945, 'PTHR45708:SF31', NULL, NULL, NULL, NULL, 'III ACIDIC ENDOCHITINASE, PUTATIVE-RELATED', 241778),
(324946, 'PTHR45708:SF50', NULL, NULL, NULL, NULL, 'OS01G0303100 PROTEIN', 241778),
(324947, 'PTHR45708:SF18', NULL, NULL, NULL, NULL, 'XYLANASE INHIBITOR PROTEIN 1', 241778),
(324948, 'PTHR45708:SF19', NULL, NULL, NULL, NULL, 'ACIDIC ENDOCHITINASE', 241778),
(324949, 'PTHR45708:SF39', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_18 DOMAIN-CONTAINING PROTEIN', 241778),
(324950, 'PTHR45708:SF58', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_18 DOMAIN-CONTAINING PROTEIN', 241778),
(324951, 'PTHR45708:SF36', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_18 DOMAIN-CONTAINING PROTEIN', 241778),
(324952, 'PTHR45708:SF37', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_18 DOMAIN-CONTAINING PROTEIN', 241778),
(324953, 'PTHR45708:SF59', NULL, NULL, NULL, NULL, 'OS11G0701900 PROTEIN', 241778),
(324954, 'PTHR45708:SF23', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_18 DOMAIN-CONTAINING PROTEIN', 241778),
(324955, 'PTHR45708:SF21', NULL, NULL, NULL, NULL, 'ACIDIC ENDOCHITINASE', 241778),
(324956, 'PTHR45708:SF8', NULL, NULL, NULL, NULL, 'OS01G0860400 PROTEIN', 241778),
(324957, 'PTHR45708:SF43', NULL, NULL, NULL, NULL, 'HEVAMINE-A-LIKE', 241778),
(324958, 'PTHR45708:SF22', NULL, NULL, NULL, NULL, 'ACIDIC ENDOCHITINASE', 241778),
(324959, 'PTHR45708:SF63', NULL, NULL, NULL, NULL, 'CHITINASE', 241778),
(324960, 'PTHR45708:SF64', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_18 DOMAIN-CONTAINING PROTEIN', 241778),
(324961, 'PTHR45708:SF9', NULL, NULL, NULL, NULL, 'XYLANASE INHIBITOR PROTEIN 1', 241778),
(324962, 'PTHR45708:SF61', NULL, NULL, NULL, NULL, 'CHITINASE', 241778),
(324963, 'PTHR45708:SF40', NULL, NULL, NULL, NULL, 'BASIC ENDOCHITINASE', 241778),
(324964, 'PTHR45708:SF62', NULL, NULL, NULL, NULL, 'ACIDIC ENDOCHITINASE', 241778),
(324965, 'PTHR45708', NULL, NULL, NULL, NULL, 'ENDOCHITINASE', 241778),
(324966, 'PTHR45708:SF60', NULL, NULL, NULL, NULL, 'CHITINASE', 241778);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(324967, 'PTHR45708:SF4', NULL, NULL, NULL, NULL, 'XYLANASE INHIBITOR PROTEIN 1', 241778),
(324968, 'PTHR38689', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE HYDROPHOBIC MEMBRANE ANCHOR SUBUNIT', 241779),
(324969, 'PTHR38689:SF1', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE HYDROPHOBIC MEMBRANE ANCHOR SUBUNIT', 241779),
(324970, 'PTHR45971:SF5', NULL, NULL, NULL, NULL, '', 241780),
(324971, 'PTHR45971:SF2', NULL, NULL, NULL, NULL, 'PROTEIN ASSOCIATED WITH UVRAG AS AUTOPHAGY ENHANCER', 241780),
(324972, 'PTHR45971', NULL, NULL, NULL, NULL, 'PHOX (PX) DOMAIN-CONTAINING PROTEIN', 241780),
(324973, 'PTHR45971:SF1', NULL, NULL, NULL, NULL, 'RUBICON, ISOFORM A', 241780),
(324974, 'PTHR45971:SF4', NULL, NULL, NULL, NULL, 'RUN DOMAIN-CONTAINING PROTEIN', 241780),
(324975, 'PTHR45971:SF3', NULL, NULL, NULL, NULL, 'RUN DOMAIN BECLIN-1-INTERACTING AND CYSTEINE-RICH DOMAIN-CONTAINING PROTEIN', 241780),
(324976, 'PTHR30557', NULL, NULL, NULL, NULL, 'THIAMINE BIOSYNTHESIS PROTEIN THIC', 241781),
(324977, 'PTHR30557:SF2', NULL, NULL, NULL, NULL, '', 241781),
(324978, 'PTHR30557:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOMETHYLPYRIMIDINE SYNTHASE, CHLOROPLASTIC', 241781),
(324979, 'PTHR10505', NULL, NULL, NULL, NULL, 'CALCITONIN-RELATED', 241782),
(324980, 'PTHR10505:SF13', NULL, NULL, NULL, NULL, 'CALCITONIN RECEPTOR-STIMULATING PEPTIDE 1', 241782),
(324981, 'PTHR10505:SF11', NULL, NULL, NULL, NULL, 'CALCITONIN DOMAIN-CONTAINING PROTEIN', 241782),
(324982, 'PTHR10505:SF4', NULL, NULL, NULL, NULL, 'ISLET AMYLOID POLYPEPTIDE', 241782),
(324983, 'PTHR10505:SF17', NULL, NULL, NULL, NULL, 'CALCITONIN RECEPTOR-STIMULATING PEPTIDE 1', 241782),
(324984, 'PTHR10505:SF3', NULL, NULL, NULL, NULL, 'CALCITONIN GENE-RELATED PEPTIDE 2', 241782),
(324985, 'PTHR10505:SF16', NULL, NULL, NULL, NULL, 'CALCITONIN', 241782),
(324986, 'PTHR11834:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ENHANCER FACTOR TEF-5', 241783),
(324987, 'PTHR11834:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ENHANCER FACTOR TEF-3', 241783),
(324988, 'PTHR11834', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ENHANCER FACTOR  TEF  RELATED', 241783),
(324989, 'PTHR11834:SF4', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ENHANCER FACTOR TEF-1', 241783),
(324990, 'PTHR11834:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ENHANCER FACTOR TEF-4', 241783),
(324991, 'PTHR11834:SF0', NULL, NULL, NULL, NULL, 'PROTEIN SCALLOPED', 241783),
(324992, 'PTHR10075:SF82', NULL, NULL, NULL, NULL, 'NEURONAL IMMUNOGLOBULIN DOMAIN-CONTAINING PROTEIN RIG-3', 241784),
(324993, 'PTHR10075:SF83', NULL, NULL, NULL, NULL, 'CONTACTIN', 241784),
(324994, 'PTHR10075:SF63', NULL, NULL, NULL, NULL, 'CONTACTIN-4', 241784),
(324995, 'PTHR10075:SF85', NULL, NULL, NULL, NULL, 'NCAM (NEURAL CELL ADHESION MOLECULE) HOMOLOG', 241784),
(324996, 'PTHR10075:SF43', NULL, NULL, NULL, NULL, 'CELL ADHESION MOLECULE L1 LIKE', 241784),
(324997, 'PTHR10075:SF44', NULL, NULL, NULL, NULL, 'NEURONAL CELL ADHESION MOLECULE', 241784),
(324998, 'PTHR10075:SF45', NULL, NULL, NULL, NULL, 'CONTACTIN-6', 241784),
(324999, 'PTHR10075:SF23', NULL, NULL, NULL, NULL, 'MYOTILIN', 241784),
(325000, 'PTHR10075:SF46', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 241784),
(325001, 'PTHR10075:SF25', NULL, NULL, NULL, NULL, 'PROTEIN TURTLE HOMOLOG A', 241784),
(325002, 'PTHR10075:SF28', NULL, NULL, NULL, NULL, 'MYOPALLADIN', 241784),
(325003, 'PTHR10075:SF92', NULL, NULL, NULL, NULL, 'PROTEIN TURTLE', 241784),
(325004, 'PTHR10075:SF93', NULL, NULL, NULL, NULL, 'NEURAL/ECTODERMAL DEVELOPMENT FACTOR IMP-L2', 241784),
(325005, 'PTHR10075:SF94', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 241784),
(325006, 'PTHR10075:SF72', NULL, NULL, NULL, NULL, 'DOWN SYNDROME CELL ADHESION MOLECULE-LIKE PROTEIN 1', 241784),
(325007, 'PTHR10075:SF51', NULL, NULL, NULL, NULL, 'DOWN SYNDROME CELL ADHESION MOLECULE', 241784),
(325008, 'PTHR10075:SF101', NULL, NULL, NULL, NULL, 'ZWEI IG DOMAIN PROTEIN ZIG-3', 241784),
(325009, 'PTHR10075:SF95', NULL, NULL, NULL, NULL, 'DOWN SYNDROME CELL ADHESION MOLECULE 3, ISOFORM E-RELATED', 241784);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(325010, 'PTHR10075:SF96', NULL, NULL, NULL, NULL, 'NEURAL CELL ADHESION MOLECULE 1', 241784),
(325011, 'PTHR10075:SF52', NULL, NULL, NULL, NULL, 'NEXILIN', 241784),
(325012, 'PTHR10075:SF30', NULL, NULL, NULL, NULL, 'PALLADIN', 241784),
(325013, 'PTHR10075:SF97', NULL, NULL, NULL, NULL, '', 241784),
(325014, 'PTHR10075:SF53', NULL, NULL, NULL, NULL, 'DOWN SYNDROME CELL ADHESION MOLECULE 1, ISOFORM BQ', 241784),
(325015, 'PTHR10075:SF75', NULL, NULL, NULL, NULL, 'PROTOGENIN', 241784),
(325016, 'PTHR10075:SF98', NULL, NULL, NULL, NULL, '', 241784),
(325017, 'PTHR10075:SF100', NULL, NULL, NULL, NULL, 'BASIGIN, ISOFORM G', 241784),
(325018, 'PTHR10075:SF55', NULL, NULL, NULL, NULL, 'CONTACTIN-2', 241784),
(325019, 'PTHR10075:SF77', NULL, NULL, NULL, NULL, 'NEURONAL-GLIAL CELL ADHESION MOLECULE', 241784),
(325020, 'PTHR10075:SF99', NULL, NULL, NULL, NULL, 'OFF-TRACK2-RELATED', 241784),
(325021, 'PTHR10075:SF78', NULL, NULL, NULL, NULL, 'PROTEIN BORDERLESS', 241784),
(325022, 'PTHR10075:SF35', NULL, NULL, NULL, NULL, 'NEUROFASCIN', 241784),
(325023, 'PTHR10075:SF14', NULL, NULL, NULL, NULL, 'ROUNDABOUT HOMOLOG 4', 241784),
(325024, 'PTHR10075:SF37', NULL, NULL, NULL, NULL, 'ROUNDABOUT HOMOLOG 3', 241784),
(325025, 'PTHR10075:SF4', NULL, NULL, NULL, NULL, 'EMBIGIN', 241784),
(325026, 'PTHR10075', NULL, NULL, NULL, NULL, 'BASIGIN RELATED', 241784),
(325027, 'PTHR36507', NULL, NULL, NULL, NULL, 'BLL1555 PROTEIN', 241785),
(325028, 'PTHR36507:SF1', NULL, NULL, NULL, NULL, 'CELL SURFACE LIPOPROTEIN', 241785),
(325029, 'PTHR36507:SF2', NULL, NULL, NULL, NULL, 'BLL1555 PROTEIN', 241785),
(325030, 'PTHR14025:SF29', NULL, NULL, NULL, NULL, 'TRANSCRIPTION-REPAIR-COUPLING FACTOR', 241786),
(325031, 'PTHR14025:SF32', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE FML2-RELATED', 241786),
(325032, 'PTHR14025:SF20', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA GROUP M PROTEIN', 241786),
(325033, 'PTHR14025', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA GROUP M FANCM FAMILY MEMBER', 241786),
(325034, 'PTHR14064:SF5', NULL, NULL, NULL, NULL, '', 241787),
(325035, 'PTHR14064:SF6', NULL, NULL, NULL, NULL, 'LEUKOCYTE CELL-DERIVED CHEMOTAXIN 1', 241787),
(325036, 'PTHR14064', NULL, NULL, NULL, NULL, 'CHONDROMODULIN-RELATED', 241787),
(325037, 'PTHR14064:SF3', NULL, NULL, NULL, NULL, 'TENOMODULIN', 241787),
(325038, 'PTHR42854:SF17', NULL, NULL, NULL, NULL, 'PROTEIN-SYNTHESIZING GTPASE', 241788),
(325039, 'PTHR42854:SF14', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 2 SUBUNIT 3-RELATED', 241788),
(325040, 'PTHR42854:SF13', NULL, NULL, NULL, NULL, 'PROTEIN-SYNTHESIZING GTPASE', 241788),
(325041, 'PTHR42854:SF8', NULL, NULL, NULL, NULL, 'PROTEIN-SYNTHESIZING GTPASE', 241788),
(325042, 'PTHR42854:SF16', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 2 SUBUNIT 3, X-LINKED', 241788),
(325043, 'PTHR42854:SF9', NULL, NULL, NULL, NULL, 'PROTEIN-SYNTHESIZING GTPASE', 241788),
(325044, 'PTHR42854:SF15', NULL, NULL, NULL, NULL, 'PROTEIN-SYNTHESIZING GTPASE', 241788),
(325045, 'PTHR42854', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 2 SUBUNIT 3 FAMILY MEMBER', 241788),
(325046, 'PTHR42854:SF10', NULL, NULL, NULL, NULL, 'PROTEIN-SYNTHESIZING GTPASE', 241788),
(325047, 'PTHR42854:SF3', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 2 SUBUNIT 3-RELATED', 241788),
(325048, 'PTHR42854:SF4', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 2 SUBUNIT 3, Y-LINKED', 241788),
(325049, 'PTHR42854:SF11', NULL, NULL, NULL, NULL, 'PROTEIN-SYNTHESIZING GTPASE', 241788),
(325050, 'PTHR11193', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN E', 241789),
(325051, 'PTHR11193:SF6', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN E', 241789),
(325052, 'PTHR11193:SF5', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN E', 241789),
(325053, 'PTHR11193:SF0', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN E', 241789),
(325054, 'PTHR11193:SF11', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN FAMILY PROTEIN', 241789);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(325055, 'PTHR11193:SF13', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN E', 241789),
(325056, 'PTHR11193:SF14', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN E', 241789),
(325057, 'PTHR11193:SF9', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN E', 241789),
(325058, 'PTHR11193:SF8', NULL, NULL, NULL, NULL, 'SM PROTEIN E', 241789),
(325059, 'PTHR14678', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 241790),
(325060, 'PTHR14678:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 750', 241790),
(325061, 'PTHR14678:SF2', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 35', 241790),
(325062, 'PTHR22538:SF0', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 74', 241791),
(325063, 'PTHR22538', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 241791),
(325064, 'PTHR22538:SF1', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 241791),
(325065, 'PTHR31620:SF8', NULL, NULL, NULL, NULL, 'OS05G0388600 PROTEIN', 241792),
(325066, 'PTHR31620', NULL, NULL, NULL, NULL, 'PROTEIN RETICULATA-RELATED 2, CHLOROPLASTIC-RELATED', 241792),
(325067, 'PTHR31620:SF6', NULL, NULL, NULL, NULL, 'PROTEIN RETICULATA-RELATED 6 CHLOROPLASTIC', 241792),
(325068, 'PTHR31620:SF20', NULL, NULL, NULL, NULL, 'BNAA05G29600D PROTEIN', 241792),
(325069, 'PTHR31620:SF17', NULL, NULL, NULL, NULL, 'ALPHAVIRUS CORE PROTEIN FAMILY', 241792),
(325070, 'PTHR31620:SF2', NULL, NULL, NULL, NULL, 'PROTEIN RETICULATA-RELATED 6, CHLOROPLASTIC', 241792),
(325071, 'PTHR31620:SF15', NULL, NULL, NULL, NULL, 'PROTEIN RETICULATA-RELATED 2, CHLOROPLASTIC-RELATED', 241792),
(325072, 'PTHR31620:SF26', NULL, NULL, NULL, NULL, '', 241792),
(325073, 'PTHR31620:SF14', NULL, NULL, NULL, NULL, 'PROTEIN RETICULATA-RELATED 4, CHLOROPLASTIC', 241792),
(325074, 'PTHR31620:SF25', NULL, NULL, NULL, NULL, 'PROTEIN RETICULATA-RELATED 5, CHLOROPLASTIC', 241792),
(325075, 'PTHR36680', NULL, NULL, NULL, NULL, 'HYPOTHETICAL LOC498675', 241793),
(325076, 'PTHR36680:SF1', NULL, NULL, NULL, NULL, 'HYPOTHETICAL LOC498675', 241793),
(325077, 'PTHR11624:SF108', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT SUBUNIT BETA', 241794),
(325078, 'PTHR11624:SF109', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT SUBUNIT BETA', 241794),
(325079, 'PTHR11624:SF107', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT SUBUNIT BETA', 241794),
(325080, 'PTHR11624:SF104', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT SUBUNIT BETA', 241794),
(325081, 'PTHR11624:SF98', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT SUBUNIT BETA-4, CHLOROPLASTIC', 241794),
(325082, 'PTHR11624:SF113', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT SUBUNIT BETA', 241794),
(325083, 'PTHR11624', NULL, NULL, NULL, NULL, 'DEHYDROGENASE RELATED', 241794),
(325084, 'PTHR11624:SF96', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT SUBUNIT BETA, MITOCHONDRIAL', 241794),
(325085, 'PTHR11624:SF111', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT SUBUNIT BETA', 241794),
(325086, 'PTHR11624:SF112', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT SUBUNIT BETA-1, MITOCHONDRIAL', 241794),
(325087, 'PTHR11624:SF110', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT SUBUNIT BETA', 241794),
(325088, 'PTHR39605:SF1', NULL, NULL, NULL, NULL, '', 241795),
(325089, 'PTHR39605', NULL, NULL, NULL, NULL, '', 241795),
(325090, 'PTHR47449', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE GDPD4', 241796),
(325091, 'PTHR47449:SF2', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE GDPD4', 241796),
(325092, 'PTHR11977:SF120', NULL, NULL, NULL, NULL, 'ACTIN FILAMENT BUNDLING PROTEIN P-115-ABP', 241797),
(325093, 'PTHR11977:SF121', NULL, NULL, NULL, NULL, 'HP DOMAIN-CONTAINING PROTEIN', 241797),
(325094, 'PTHR11977:SF100', NULL, NULL, NULL, NULL, 'HP DOMAIN-CONTAINING PROTEIN', 241797),
(325095, 'PTHR11977:SF85', NULL, NULL, NULL, NULL, 'VILLIN-2', 241797),
(325096, 'PTHR11977', NULL, NULL, NULL, NULL, 'VILLIN', 241797),
(325097, 'PTHR11977:SF127', NULL, NULL, NULL, NULL, 'MACROPHAGE-CAPPING PROTEIN', 241797);
INSERT INTO "PUBLIC"."MODEL" VALUES
(325098, 'PTHR11977:SF98', NULL, NULL, NULL, NULL, 'VILLIN-2', 241797),
(325099, 'PTHR11977:SF105', NULL, NULL, NULL, NULL, 'VILLIN/GELSOLIN, ADF-H/GELSOLIN-LIKE DOMAIN PROTEIN-RELATED', 241797),
(325100, 'PTHR11977:SF31', NULL, NULL, NULL, NULL, 'PROTOVILLIN', 241797),
(325101, 'PTHR11977:SF128', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 241797),
(325102, 'PTHR11977:SF78', NULL, NULL, NULL, NULL, 'ADSEVERIN', 241797),
(325103, 'PTHR11977:SF129', NULL, NULL, NULL, NULL, 'GELSOLIN-RELATED PROTEIN OF 125 KDA', 241797),
(325104, 'PTHR11977:SF107', NULL, NULL, NULL, NULL, 'VILLIN/GELSOLIN, ADF-H/GELSOLIN-LIKE DOMAIN PROTEIN-RELATED', 241797),
(325105, 'PTHR11977:SF33', NULL, NULL, NULL, NULL, 'ADVILLIN', 241797),
(325106, 'PTHR11977:SF101', NULL, NULL, NULL, NULL, 'VILLIN-3', 241797),
(325107, 'PTHR11977:SF123', NULL, NULL, NULL, NULL, 'GELSOLIN', 241797),
(325108, 'PTHR11977:SF57', NULL, NULL, NULL, NULL, 'VILLIN-LIKE PROTEIN QUAIL', 241797),
(325109, 'PTHR11977:SF35', NULL, NULL, NULL, NULL, 'VILLIN-1', 241797),
(325110, 'PTHR11977:SF103', NULL, NULL, NULL, NULL, 'VILLIN-5', 241797),
(325111, 'PTHR11977:SF38', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 241797),
(325112, 'PTHR11977:SF125', NULL, NULL, NULL, NULL, 'VILLIDIN', 241797),
(325113, 'PTHR11977:SF126', NULL, NULL, NULL, NULL, 'VILLIN-2-LIKE', 241797),
(325114, 'PTHR11977:SF130', NULL, NULL, NULL, NULL, 'HP DOMAIN-CONTAINING PROTEIN-RELATED', 241797),
(325115, 'PTHR11977:SF131', NULL, NULL, NULL, NULL, 'ACTIN-DEPOLYMERIZING FACTOR', 241797),
(325116, 'PTHR11977:SF132', NULL, NULL, NULL, NULL, 'VILLIN HEADPIECE, VILLIN/GELSOLIN, ADF-H/GELSOLIN-LIKE DOMAIN PROTEIN-RELATED', 241797),
(325117, 'PTHR11977:SF110', NULL, NULL, NULL, NULL, 'HP DOMAIN-CONTAINING PROTEIN', 241797),
(325118, 'PTHR11977:SF91', NULL, NULL, NULL, NULL, 'VILLIN-3', 241797),
(325119, 'PTHR11977:SF30', NULL, NULL, NULL, NULL, 'VILLIN-LIKE PROTEIN', 241797),
(325120, 'PTHR11977:SF51', NULL, NULL, NULL, NULL, 'PROTEIN FLIGHTLESS-1 HOMOLOG', 241797),
(325121, 'PTHR11977:SF29', NULL, NULL, NULL, NULL, 'GELSOLIN', 241797),
(325122, 'PTHR11977:SF116', NULL, NULL, NULL, NULL, 'HP DOMAIN-CONTAINING PROTEIN', 241797),
(325123, 'PTHR11977:SF87', NULL, NULL, NULL, NULL, 'SUPERVILLIN D', 241797),
(325124, 'PTHR11977:SF117', NULL, NULL, NULL, NULL, 'HP DOMAIN-CONTAINING PROTEIN', 241797),
(325125, 'PTHR11977:SF86', NULL, NULL, NULL, NULL, 'SUPERVILLIN A', 241797),
(325126, 'PTHR11977:SF118', NULL, NULL, NULL, NULL, 'VILLIN-3', 241797),
(325127, 'PTHR11977:SF45', NULL, NULL, NULL, NULL, 'SUPERVILLIN', 241797),
(325128, 'PTHR11977:SF119', NULL, NULL, NULL, NULL, 'SUPERVILLIN C', 241797),
(325129, 'PTHR11977:SF112', NULL, NULL, NULL, NULL, 'GELSOLIN-LIKE DOMAIN-CONTAINING PROTEIN', 241797),
(325130, 'PTHR11977:SF25', NULL, NULL, NULL, NULL, 'VILLIN-1', 241797),
(325131, 'PTHR11977:SF49', NULL, NULL, NULL, NULL, 'VILLIN-4', 241797),
(325132, 'PTHR11977:SF27', NULL, NULL, NULL, NULL, 'ACTIN-DEPOLYMERIZING FACTOR', 241797),
(325133, 'PTHR11977:SF114', NULL, NULL, NULL, NULL, 'HP DOMAIN-CONTAINING PROTEIN', 241797),
(325134, 'PTHR33875', NULL, NULL, NULL, NULL, 'OS09G0542200 PROTEIN', 241798),
(325135, 'PTHR33875:SF2', NULL, NULL, NULL, NULL, 'OS09G0542200 PROTEIN', 241798),
(325136, 'PTHR33875:SF3', NULL, NULL, NULL, NULL, 'OS04G0227500 PROTEIN', 241798),
(325137, 'PTHR33875:SF4', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE_FOLD DOMAIN-CONTAINING PROTEIN', 241798),
(325138, 'PTHR37469:SF2', NULL, NULL, NULL, NULL, 'CELLOBIONIC ACID PHOSPHORYLASE', 241799),
(325139, 'PTHR37469:SF3', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 241799),
(325140, 'PTHR37469', NULL, NULL, NULL, NULL, 'CELLOBIONIC ACID PHOSPHORYLASE-RELATED', 241799),
(325141, 'PTHR14156:SF0', NULL, NULL, NULL, NULL, 'PROMOTILIN', 241800),
(325142, 'PTHR14156', NULL, NULL, NULL, NULL, 'MOTILIN', 241800),
(325143, 'PTHR35281', NULL, NULL, NULL, NULL, 'BNAA02G34170D PROTEIN', 241801),
(325144, 'PTHR35281:SF4', NULL, NULL, NULL, NULL, '', 241801),
(325145, 'PTHR35281:SF2', NULL, NULL, NULL, NULL, 'BNAA02G34170D PROTEIN', 241801);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(325146, 'PTHR35281:SF3', NULL, NULL, NULL, NULL, 'BNAA07G07520D PROTEIN', 241801),
(325147, 'PTHR47936', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 241802),
(325148, 'PTHR47936:SF1', NULL, NULL, NULL, NULL, 'SMR DOMAIN-CONTAINING PROTEIN', 241802),
(325149, 'PTHR47936:SF4', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN MITOCHONDRIAL', 241802),
(325150, 'PTHR47936:SF5', NULL, NULL, NULL, NULL, '', 241802),
(325151, 'PTHR47936:SF3', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 241802),
(325152, 'PTHR47936:SF6', NULL, NULL, NULL, NULL, 'BNACNNG30750D PROTEIN', 241802),
(325153, 'PTHR11999:SF148', NULL, NULL, NULL, NULL, 'OS10G0400500 PROTEIN', 241803),
(325154, 'PTHR11999:SF169', NULL, NULL, NULL, NULL, 'TYROSINE DECARBOXYLASE 1-LIKE', 241803),
(325155, 'PTHR11999:SF59', NULL, NULL, NULL, NULL, 'AROMATIC-L-AMINO-ACID DECARBOXYLASE-RELATED', 241803),
(325156, 'PTHR11999:SF168', NULL, NULL, NULL, NULL, 'TYROSINE DECARBOXYLASE', 241803),
(325157, 'PTHR11999:SF167', NULL, NULL, NULL, NULL, 'AROMATIC-L-AMINO-ACID DECARBOXYLASE', 241803),
(325158, 'PTHR11999:SF145', NULL, NULL, NULL, NULL, '', 241803),
(325159, 'PTHR11999:SF76', NULL, NULL, NULL, NULL, 'FI02861P', 241803),
(325160, 'PTHR11999:SF149', NULL, NULL, NULL, NULL, '', 241803),
(325161, 'PTHR11999:SF140', NULL, NULL, NULL, NULL, 'HISTIDINE DECARBOXYASE LIKE', 241803),
(325162, 'PTHR11999:SF161', NULL, NULL, NULL, NULL, 'BNAA07G00220D PROTEIN', 241803),
(325163, 'PTHR11999:SF160', NULL, NULL, NULL, NULL, 'BNAA07G00240D PROTEIN', 241803),
(325164, 'PTHR11999:SF60', NULL, NULL, NULL, NULL, '3,4-DIHYDROXYPHENYLACETALDEHYDE SYNTHASE', 241803),
(325165, 'PTHR11999:SF166', NULL, NULL, NULL, NULL, '', 241803),
(325166, 'PTHR11999:SF165', NULL, NULL, NULL, NULL, 'DECARBOXYLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G04980)-RELATED', 241803),
(325167, 'PTHR11999:SF164', NULL, NULL, NULL, NULL, '', 241803),
(325168, 'PTHR11999', NULL, NULL, NULL, NULL, 'GROUP II PYRIDOXAL-5-PHOSPHATE DECARBOXYLASE', 241803),
(325169, 'PTHR11999:SF163', NULL, NULL, NULL, NULL, '', 241803),
(325170, 'PTHR11999:SF159', NULL, NULL, NULL, NULL, '', 241803),
(325171, 'PTHR11999:SF158', NULL, NULL, NULL, NULL, 'BNAA09G52950D PROTEIN', 241803),
(325172, 'PTHR11999:SF157', NULL, NULL, NULL, NULL, 'TRYPTOPHAN DECARBOXYLASE 1', 241803),
(325173, 'PTHR11999:SF156', NULL, NULL, NULL, NULL, 'PHENYLACETALDEHYDE SYNTHASE', 241803),
(325174, 'PTHR11999:SF68', NULL, NULL, NULL, NULL, 'HISTIDINE DECARBOXYLASE', 241803),
(325175, 'PTHR11999:SF151', NULL, NULL, NULL, NULL, 'TYROSINE/DOPA DECARBOXYLASE', 241803),
(325176, 'PTHR11999:SF96', NULL, NULL, NULL, NULL, 'OS05G0510600 PROTEIN', 241803),
(325177, 'PTHR11999:SF93', NULL, NULL, NULL, NULL, '', 241803),
(325178, 'PTHR11999:SF170', NULL, NULL, NULL, NULL, 'OS08G0140500 PROTEIN', 241803),
(325179, 'PTHR11999:SF70', NULL, NULL, NULL, NULL, 'MIP05841P', 241803),
(325180, 'PTHR11999:SF153', NULL, NULL, NULL, NULL, 'TYROSINE DECARBOXYLASE 1', 241803),
(325181, 'PTHR11999:SF152', NULL, NULL, NULL, NULL, 'TYROSINE DECARBOXYLASE 2', 241803),
(325182, 'PTHR13005:SF4', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH HYDROPHOBIC PROTEIN', 241804),
(325183, 'PTHR13005', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH HYDROPHOBIC DOMAIN PROTEIN  BRAIN X-LINKED PROTEIN', 241804),
(325184, 'PTHR13005:SF2', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH HYDROPHOBIC DOMAIN-CONTAINING PROTEIN 1', 241804),
(325185, 'PTHR13005:SF3', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH HYDROPHOBIC DOMAIN-CONTAINING PROTEIN 2', 241804),
(325186, 'PTHR43352:SF1', NULL, NULL, NULL, NULL, 'ANTHRANILATE--COA LIGASE', 241805),
(325187, 'PTHR43352', NULL, NULL, NULL, NULL, 'ACETYL-COA SYNTHETASE', 241805),
(325188, 'PTHR46828', NULL, NULL, NULL, NULL, 'ENDO-1,4-BETA-XYLANASE A-RELATED', 241806),
(325189, 'PTHR46828:SF2', NULL, NULL, NULL, NULL, 'ENDO-1,4-BETA-XYLANASE A-RELATED', 241806),
(325190, 'PTHR46828:SF3', NULL, NULL, NULL, NULL, 'ENDO-1,4-BETA-XYLANASE', 241806),
(325191, 'PTHR35120', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE KAT6B-LIKE', 241807);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(325192, 'PTHR35120:SF1', NULL, NULL, NULL, NULL, 'OS01G0756000 PROTEIN', 241807),
(325193, 'PTHR35120:SF2', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE KAT6B-LIKE', 241807),
(325194, 'PTHR15730:SF5', NULL, NULL, NULL, NULL, 'SI:CH211-210B2.2-RELATED', 241808),
(325195, 'PTHR15730:SF3', NULL, NULL, NULL, NULL, 'TRPM8 CHANNEL-ASSOCIATED FACTOR 3', 241808),
(325196, 'PTHR15730:SF4', NULL, NULL, NULL, NULL, 'TRPM8 CHANNEL-ASSOCIATED FACTOR 2', 241808),
(325197, 'PTHR15730', NULL, NULL, NULL, NULL, 'EXPERIMENTAL AUTOIMMUNE PROSTATITIS ANTIGEN 2-RELATED', 241808),
(325198, 'PTHR15730:SF1', NULL, NULL, NULL, NULL, 'TRPM8 CHANNEL-ASSOCIATED FACTOR 1', 241808),
(325199, 'PTHR34670:SF16', NULL, NULL, NULL, NULL, 'BNAA05G34890D PROTEIN', 241809),
(325200, 'PTHR34670:SF15', NULL, NULL, NULL, NULL, 'BNAA03G54980D PROTEIN', 241809),
(325201, 'PTHR34670:SF9', NULL, NULL, NULL, NULL, 'OS05G0456900 PROTEIN', 241809),
(325202, 'PTHR34670:SF14', NULL, NULL, NULL, NULL, '', 241809),
(325203, 'PTHR34670:SF8', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241809),
(325204, 'PTHR34670', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241809),
(325205, 'PTHR34670:SF2', NULL, NULL, NULL, NULL, 'OS01G0847100 PROTEIN', 241809),
(325206, 'PTHR34670:SF13', NULL, NULL, NULL, NULL, '', 241809),
(325207, 'PTHR34670:SF12', NULL, NULL, NULL, NULL, 'BNACNNG03710D PROTEIN', 241809),
(325208, 'PTHR34670:SF10', NULL, NULL, NULL, NULL, 'LEGUME-SPECIFIC PROTEIN', 241809),
(325209, 'PTHR43459', NULL, NULL, NULL, NULL, 'ENOYL-COA HYDRATASE', 241810),
(325210, 'PTHR43459:SF1', NULL, NULL, NULL, NULL, 'EG:BACN32G11.4 PROTEIN', 241810),
(325211, 'PTHR43459:SF5', NULL, NULL, NULL, NULL, 'OS11G0270000 PROTEIN', 241810),
(325212, 'PTHR43459:SF4', NULL, NULL, NULL, NULL, 'OS11G0269900 PROTEIN', 241810),
(325213, 'PTHR43459:SF3', NULL, NULL, NULL, NULL, 'ENOYL-COA HYDRATASE ECHA15 (ENOYL HYDRASE) (UNSATURATED ACYL-COA HYDRATASE) (CROTONASE)-RELATED', 241810),
(325214, 'PTHR10992:SF938', NULL, NULL, NULL, NULL, 'OS05G0370700 PROTEIN', 241811),
(325215, 'PTHR10992:SF1005', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 241811),
(325216, 'PTHR10992:SF1049', NULL, NULL, NULL, NULL, 'METHYLESTERASE 14, CHLOROPLASTIC-RELATED', 241811),
(325217, 'PTHR10992:SF1008', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 241811),
(325218, 'PTHR10992:SF1007', NULL, NULL, NULL, NULL, 'METHYLESTERASE 3-RELATED', 241811),
(325219, 'PTHR10992:SF1046', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 241811),
(325220, 'PTHR10992:SF1002', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 241811),
(325221, 'PTHR10992:SF1045', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 241811),
(325222, 'PTHR10992:SF1004', NULL, NULL, NULL, NULL, 'ESTERASE PIR7B', 241811),
(325223, 'PTHR10992:SF1048', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 241811),
(325224, 'PTHR10992:SF1047', NULL, NULL, NULL, NULL, 'METHYLKETONE SYNTHASE I', 241811),
(325225, 'PTHR10992:SF1003', NULL, NULL, NULL, NULL, 'OS11G0492800 PROTEIN', 241811),
(325226, 'PTHR10992:SF1042', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 241811),
(325227, 'PTHR10992:SF1044', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 241811),
(325228, 'PTHR10992:SF1082', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 241811),
(325229, 'PTHR10992:SF1081', NULL, NULL, NULL, NULL, 'METHYLESTERASE 2-RELATED', 241811),
(325230, 'PTHR10992:SF1040', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 241811),
(325231, 'PTHR10992:SF1084', NULL, NULL, NULL, NULL, 'METHYLESTERASE 17-LIKE', 241811),
(325232, 'PTHR10992:SF1083', NULL, NULL, NULL, NULL, 'METHYLESTERASE 1', 241811),
(325233, 'PTHR10992:SF1017', NULL, NULL, NULL, NULL, 'METHYL ESTERASE 10', 241811),
(325234, 'PTHR10992:SF1019', NULL, NULL, NULL, NULL, 'METHYLESTERASE 13, CHLOROPLASTIC-RELATED', 241811),
(325235, 'PTHR10992:SF1018', NULL, NULL, NULL, NULL, 'ESTERASE PIR7B', 241811);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(325236, 'PTHR10992:SF1013', NULL, NULL, NULL, NULL, 'ALPHA-HYDROXYNITRILE LYASE', 241811),
(325237, 'PTHR10992:SF1057', NULL, NULL, NULL, NULL, 'BNAA04G13770D PROTEIN', 241811),
(325238, 'PTHR10992:SF1056', NULL, NULL, NULL, NULL, 'BNAA04G13740D PROTEIN', 241811),
(325239, 'PTHR10992:SF1058', NULL, NULL, NULL, NULL, 'METHYLKETONE SYNTHASE IB', 241811),
(325240, 'PTHR10992:SF1014', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 241811),
(325241, 'PTHR10992:SF1055', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 241811),
(325242, 'PTHR10992:SF1011', NULL, NULL, NULL, NULL, 'METHYLESTERASE 12, CHLOROPLASTIC-RELATED', 241811),
(325243, 'PTHR10992:SF1054', NULL, NULL, NULL, NULL, 'METHYLKETONE SYNTHASE IE', 241811),
(325244, 'PTHR10992:SF1010', NULL, NULL, NULL, NULL, 'METHYLESTERASE 17-LIKE', 241811),
(325245, 'PTHR10992:SF872', NULL, NULL, NULL, NULL, 'METHYLESTERASE 11, CHLOROPLASTIC-RELATED', 241811),
(325246, 'PTHR10992:SF1028', NULL, NULL, NULL, NULL, 'METHYLESTERASE 9', 241811),
(325247, 'PTHR10992:SF1029', NULL, NULL, NULL, NULL, 'METHYLESTERASE 18', 241811),
(325248, 'PTHR10992:SF1067', NULL, NULL, NULL, NULL, 'ESTERASE PIR7A-RELATED', 241811),
(325249, 'PTHR10992:SF1023', NULL, NULL, NULL, NULL, 'METHYLESTERASE 11, CHLOROPLASTIC ISOFORM X1-RELATED', 241811),
(325250, 'PTHR10992:SF1026', NULL, NULL, NULL, NULL, 'PHEOPHORBIDASE-RELATED', 241811),
(325251, 'PTHR10992:SF1025', NULL, NULL, NULL, NULL, 'METHYLESTERASE 15, CHLOROPLASTIC-RELATED', 241811),
(325252, 'PTHR10992:SF1064', NULL, NULL, NULL, NULL, 'METHYLKETONE SYNTHASE IB', 241811),
(325253, 'PTHR10992:SF1020', NULL, NULL, NULL, NULL, 'METHYLESTERASE 19-RELATED', 241811),
(325254, 'PTHR10992:SF1022', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 241811),
(325255, 'PTHR10992:SF1066', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 241811),
(325256, 'PTHR10992:SF1062', NULL, NULL, NULL, NULL, 'SALICYLIC ACID-BINDING PROTEIN 2-LIKE', 241811),
(325257, 'PTHR10992:SF1061', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 241811),
(325258, 'PTHR10992:SF780', NULL, NULL, NULL, NULL, 'HYDROLASE, ALPHA/BETA FOLD FAMILY PROTEIN, EXPRESSED', 241811),
(325259, 'PTHR10992:SF1080', NULL, NULL, NULL, NULL, 'METHYLESTERASE 10-LIKE', 241811),
(325260, 'PTHR10992:SF785', NULL, NULL, NULL, NULL, 'METHYLESTERASE 14, CHLOROPLASTIC-RELATED', 241811),
(325261, 'PTHR10992:SF1039', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 241811),
(325262, 'PTHR10992:SF1035', NULL, NULL, NULL, NULL, 'ESTERASE PIR7A-RELATED', 241811),
(325263, 'PTHR10992:SF1079', NULL, NULL, NULL, NULL, 'ESTERASE PIR7A', 241811),
(325264, 'PTHR10992:SF1078', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 241811),
(325265, 'PTHR10992:SF1034', NULL, NULL, NULL, NULL, 'METHYL ESTERASE 11-RELATED', 241811),
(325266, 'PTHR10992:SF943', NULL, NULL, NULL, NULL, 'METHYLESTERASE 10', 241811),
(325267, 'PTHR10992:SF1037', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 241811),
(325268, 'PTHR10992:SF1036', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 241811),
(325269, 'PTHR10992:SF1075', NULL, NULL, NULL, NULL, 'OS01G0557100 PROTEIN', 241811),
(325270, 'PTHR10992', NULL, NULL, NULL, NULL, 'METHYLESTERASE FAMILY MEMBER', 241811),
(325271, 'PTHR10992:SF1030', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 241811),
(325272, 'PTHR10992:SF1077', NULL, NULL, NULL, NULL, 'ALPHA/BETA FOLD HYDROLASE', 241811),
(325273, 'PTHR10992:SF1032', NULL, NULL, NULL, NULL, 'METHYLESTERASE 17', 241811),
(325274, 'PTHR10992:SF1076', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 241811),
(325275, 'PTHR10992:SF1070', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 241811),
(325276, 'PTHR13105:SF21', NULL, NULL, NULL, NULL, 'BNACNNG23140D PROTEIN', 241812),
(325277, 'PTHR13105:SF20', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN-RELATED', 241812),
(325278, 'PTHR13105:SF4', NULL, NULL, NULL, NULL, 'MYELOID LEUKEMIA FACTOR 2', 241812);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(325279, 'PTHR13105:SF7', NULL, NULL, NULL, NULL, 'MYELOID LEUKEMIA FACTOR 1', 241812),
(325280, 'PTHR13105', NULL, NULL, NULL, NULL, 'MYELOID LEUKEMIA FACTOR', 241812),
(325281, 'PTHR13105:SF18', NULL, NULL, NULL, NULL, 'MYELOID LEUKEMIA FACTOR-RELATED', 241812),
(325282, 'PTHR13105:SF17', NULL, NULL, NULL, NULL, 'OS06G0134900 PROTEIN', 241812),
(325283, 'PTHR13105:SF16', NULL, NULL, NULL, NULL, 'MYELOID LEUKEMIA FACTOR', 241812),
(325284, 'PTHR31210:SF49', NULL, NULL, NULL, NULL, 'TRIMETHYLGUANOSINE SYNTHASE (DUF707)', 241813),
(325285, 'PTHR31210:SF88', NULL, NULL, NULL, NULL, '', 241813),
(325286, 'PTHR31210:SF67', NULL, NULL, NULL, NULL, '', 241813),
(325287, 'PTHR31210:SF89', NULL, NULL, NULL, NULL, 'OS05G0108100 PROTEIN', 241813),
(325288, 'PTHR31210:SF68', NULL, NULL, NULL, NULL, 'BNAC06G26320D PROTEIN', 241813),
(325289, 'PTHR31210:SF47', NULL, NULL, NULL, NULL, 'OS06G0731900 PROTEIN', 241813),
(325290, 'PTHR31210:SF84', NULL, NULL, NULL, NULL, 'OS07G0414700 PROTEIN', 241813),
(325291, 'PTHR31210:SF40', NULL, NULL, NULL, NULL, '', 241813),
(325292, 'PTHR31210:SF62', NULL, NULL, NULL, NULL, '', 241813),
(325293, 'PTHR31210:SF64', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF707)-RELATED', 241813),
(325294, 'PTHR31210:SF86', NULL, NULL, NULL, NULL, '', 241813),
(325295, 'PTHR31210:SF43', NULL, NULL, NULL, NULL, 'STORAGE PROTEIN-RELATED', 241813),
(325296, 'PTHR31210:SF80', NULL, NULL, NULL, NULL, '', 241813),
(325297, 'PTHR31210:SF81', NULL, NULL, NULL, NULL, 'BNAANNG28070D PROTEIN', 241813),
(325298, 'PTHR31210:SF82', NULL, NULL, NULL, NULL, 'BNACNNG10010D PROTEIN', 241813),
(325299, 'PTHR31210:SF60', NULL, NULL, NULL, NULL, 'STORAGE PROTEIN', 241813),
(325300, 'PTHR31210:SF61', NULL, NULL, NULL, NULL, 'KETOGLUTARATE REDUCTASE TRANS-SPLICING-RELATED PROTEIN, PUTATIVE-RELATED', 241813),
(325301, 'PTHR31210:SF90', NULL, NULL, NULL, NULL, 'BNAA06G32080D PROTEIN', 241813),
(325302, 'PTHR31210:SF8', NULL, NULL, NULL, NULL, 'BNAA04G07220D PROTEIN', 241813),
(325303, 'PTHR31210:SF38', NULL, NULL, NULL, NULL, 'BNAA09G02060D PROTEIN', 241813),
(325304, 'PTHR31210:SF77', NULL, NULL, NULL, NULL, 'BNAA09G28270D PROTEIN', 241813),
(325305, 'PTHR31210:SF11', NULL, NULL, NULL, NULL, 'KETOGLUTARATE REDUCTASE TRANS-SPLICING-LIKE PROTEIN, PUTATIVE (DUF707)-RELATED', 241813),
(325306, 'PTHR31210:SF78', NULL, NULL, NULL, NULL, 'BNAA04G16360D PROTEIN', 241813),
(325307, 'PTHR31210:SF57', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN-RELATED', 241813),
(325308, 'PTHR31210:SF79', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 241813),
(325309, 'PTHR31210:SF58', NULL, NULL, NULL, NULL, 'BNAC05G08550D PROTEIN', 241813),
(325310, 'PTHR31210:SF51', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN', 241813),
(325311, 'PTHR31210:SF73', NULL, NULL, NULL, NULL, 'OS06G0727800 PROTEIN', 241813),
(325312, 'PTHR31210:SF52', NULL, NULL, NULL, NULL, 'LYSINE KETOGLUTARATE REDUCTASE TRANS-SPLICING PROTEIN', 241813),
(325313, 'PTHR31210:SF74', NULL, NULL, NULL, NULL, 'OS01G0919600 PROTEIN', 241813),
(325314, 'PTHR31210:SF53', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF707)-RELATED', 241813),
(325315, 'PTHR31210:SF91', NULL, NULL, NULL, NULL, '', 241813),
(325316, 'PTHR31210:SF70', NULL, NULL, NULL, NULL, 'BNAA02G13400D PROTEIN', 241813),
(325317, 'PTHR31210:SF92', NULL, NULL, NULL, NULL, 'STORAGE PROTEIN', 241813),
(325318, 'PTHR31210:SF71', NULL, NULL, NULL, NULL, 'BNAA08G25430D PROTEIN', 241813),
(325319, 'PTHR31210:SF93', NULL, NULL, NULL, NULL, 'OS07G0564800 PROTEIN', 241813),
(325320, 'PTHR31210:SF94', NULL, NULL, NULL, NULL, 'LYSINE KETOGLUTARATE REDUCTASE TRANS-SPLICING-LIKE PROTEIN', 241813),
(325321, 'PTHR31210:SF50', NULL, NULL, NULL, NULL, '', 241813),
(325322, 'PTHR31210:SF72', NULL, NULL, NULL, NULL, 'OS02G0297600 PROTEIN', 241813),
(325323, 'PTHR31210', NULL, NULL, NULL, NULL, 'OS06G0731900 PROTEIN', 241813),
(325324, 'PTHR24331:SF0', NULL, NULL, NULL, NULL, 'DBX', 241814),
(325325, 'PTHR24331:SF6', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN DBX1', 241814),
(325326, 'PTHR24331:SF4', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN DBX2', 241814);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(325327, 'PTHR24331', NULL, NULL, NULL, NULL, 'DBX', 241814),
(325328, 'PTHR38425', NULL, NULL, NULL, NULL, 'LONG CHRONOLOGICAL LIFESPAN PROTEIN 2', 241815),
(325329, 'PTHR38425:SF1', NULL, NULL, NULL, NULL, 'LONG CHRONOLOGICAL LIFESPAN PROTEIN 2', 241815),
(325330, 'PTHR46086:SF8', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 241816),
(325331, 'PTHR46086:SF25', NULL, NULL, NULL, NULL, 'TRIACYLGLYCEROL LIPASE OBL1', 241816),
(325332, 'PTHR46086:SF26', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 241816),
(325333, 'PTHR46086:SF9', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 241816),
(325334, 'PTHR46086:SF13', NULL, NULL, NULL, NULL, 'TRIACYLGLYCEROL LIPASE-RELATED', 241816),
(325335, 'PTHR46086:SF24', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 241816),
(325336, 'PTHR46086:SF18', NULL, NULL, NULL, NULL, 'OS04G0657500 PROTEIN', 241816),
(325337, 'PTHR46086:SF29', NULL, NULL, NULL, NULL, 'SUPERFAMILY PROTEIN, PUTATIVE ISOFORM 1-RELATED', 241816),
(325338, 'PTHR46086:SF19', NULL, NULL, NULL, NULL, 'TRIACYLGLYCEROL LIPASE-LIKE 1-RELATED', 241816),
(325339, 'PTHR46086:SF17', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 241816),
(325340, 'PTHR46086:SF28', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 241816),
(325341, 'PTHR46086:SF4', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 241816),
(325342, 'PTHR46086:SF3', NULL, NULL, NULL, NULL, 'TRIACYLGLYCEROL LIPASE OBL1', 241816),
(325343, 'PTHR46086', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 241816),
(325344, 'PTHR46086:SF21', NULL, NULL, NULL, NULL, 'TRIACYLGLYCEROL LIPASE-LIKE 1', 241816),
(325345, 'PTHR46086:SF10', NULL, NULL, NULL, NULL, 'OS06G0210900 PROTEIN', 241816),
(325346, 'PTHR46086:SF22', NULL, NULL, NULL, NULL, 'TRIACYLGLYCEROL LIPASE OBL1', 241816),
(325347, 'PTHR46086:SF30', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 241816),
(325348, 'PTHR46086:SF31', NULL, NULL, NULL, NULL, 'TRIACYLGLYCEROL LIPASE', 241816),
(325349, 'PTHR46086:SF20', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 241816),
(325350, 'PTHR19211:SF108', NULL, NULL, NULL, NULL, '', 241817),
(325351, 'PTHR19211:SF15', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY F MEMBER 2', 241817),
(325352, 'PTHR19211:SF14', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY F MEMBER 1', 241817),
(325353, 'PTHR19211:SF126', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY F MEMBER 1', 241817),
(325354, 'PTHR19211:SF127', NULL, NULL, NULL, NULL, '', 241817),
(325355, 'PTHR19211:SF128', NULL, NULL, NULL, NULL, 'BNAA04G27790D PROTEIN', 241817),
(325356, 'PTHR19211:SF107', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER F FAMILY MEMBER 5', 241817),
(325357, 'PTHR19211:SF129', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN', 241817),
(325358, 'PTHR19211:SF122', NULL, NULL, NULL, NULL, 'OS08G0564100 PROTEIN', 241817),
(325359, 'PTHR19211:SF100', NULL, NULL, NULL, NULL, 'RIBOSOME PROTECTION PROTEIN VMLR', 241817),
(325360, 'PTHR19211:SF123', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER-RELATED', 241817),
(325361, 'PTHR19211:SF5', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 3A-RELATED', 241817),
(325362, 'PTHR19211:SF130', NULL, NULL, NULL, NULL, 'ATP BINDING CASSETTE SUBFAMILY F MEMBER 1', 241817),
(325363, 'PTHR19211:SF6', NULL, NULL, NULL, NULL, 'BLL7188 PROTEIN', 241817),
(325364, 'PTHR19211:SF131', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS ATPASE', 241817),
(325365, 'PTHR19211:SF132', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT TRANSPORTER', 241817),
(325366, 'PTHR19211', NULL, NULL, NULL, NULL, 'ATP-BINDING TRANSPORT PROTEIN-RELATED', 241817),
(325367, 'PTHR19211:SF95', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER F FAMILY MEMBER 2', 241817),
(325368, 'PTHR19211:SF52', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER F FAMILY MEMBER 1', 241817),
(325369, 'PTHR19211:SF96', NULL, NULL, NULL, NULL, 'ATP-BINDING PROTEIN YBIT-RELATED', 241817),
(325370, 'PTHR19211:SF65', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN UUP', 241817);
INSERT INTO "PUBLIC"."MODEL" VALUES
(325371, 'PTHR19211:SF69', NULL, NULL, NULL, NULL, 'ATP-BINDING PROTEIN UUP', 241817),
(325372, 'PTHR19211:SF117', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY F MEMBER 3', 241817),
(325373, 'PTHR19211:SF133', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER FAMILY PROTEIN', 241817),
(325374, 'PTHR19211:SF134', NULL, NULL, NULL, NULL, '', 241817),
(325375, 'PTHR19211:SF135', NULL, NULL, NULL, NULL, 'ATPASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G16440)-RELATED', 241817),
(325376, 'PTHR19211:SF121', NULL, NULL, NULL, NULL, '', 241817),
(325377, 'PTHR19211:SF62', NULL, NULL, NULL, NULL, '', 241817),
(325378, 'PTHR13206:SF0', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE FANCL', 241818),
(325379, 'PTHR13206', NULL, NULL, NULL, NULL, 'UBIQUITIN LIGASE PROTEIN PHF9  FANCONI ANEMIA GROUP L PROTEIN', 241818),
(325380, 'PTHR46341:SF1', NULL, NULL, NULL, NULL, 'PROTEIN LRATD1', 241819),
(325381, 'PTHR46341:SF2', NULL, NULL, NULL, NULL, 'PROTEIN LRATD2', 241819),
(325382, 'PTHR46341', NULL, NULL, NULL, NULL, 'PROTEIN FAM84B-RELATED', 241819),
(325383, 'PTHR36769', NULL, NULL, NULL, NULL, '2,3-BISPHOSPHOGLYCERATE-DEPENDENT PHOSPHOGLYCERATE MUTASE', 241820),
(325384, 'PTHR36769:SF1', NULL, NULL, NULL, NULL, '2,3-BISPHOSPHOGLYCERATE-DEPENDENT PHOSPHOGLYCERATE MUTASE', 241820),
(325385, 'PTHR36769:SF2', NULL, NULL, NULL, NULL, 'BNAC07G32650D PROTEIN', 241820),
(325386, 'PTHR31605:SF0', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE O-ACYLTRANSFERASE 1', 241821),
(325387, 'PTHR31605:SF2', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE O-ACYLTRANSFERASE 2', 241821),
(325388, 'PTHR31605', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE O-ACYLTRANSFERASE 1', 241821),
(325389, 'PTHR45665:SF9', NULL, NULL, NULL, NULL, 'AQUAPORIN-8', 241822),
(325390, 'PTHR45665:SF8', NULL, NULL, NULL, NULL, 'AQUAPORIN TIP4-2-RELATED', 241822),
(325391, 'PTHR45665:SF51', NULL, NULL, NULL, NULL, 'AQUAPORIN TIP2_3', 241822),
(325392, 'PTHR45665:SF55', NULL, NULL, NULL, NULL, 'MAJOR INTRINSIC PROTEIN, AQUAPORIN-LIKE PROTEIN-RELATED', 241822),
(325393, 'PTHR45665:SF11', NULL, NULL, NULL, NULL, 'AQUAPORIN 8A, TANDEM DUPLICATE 2-RELATED', 241822),
(325394, 'PTHR45665:SF32', NULL, NULL, NULL, NULL, 'MAJOR INTRINSIC PROTEIN-RELATED', 241822),
(325395, 'PTHR45665:SF54', NULL, NULL, NULL, NULL, 'AQUAPORIN TIP1-1', 241822),
(325396, 'PTHR45665:SF53', NULL, NULL, NULL, NULL, 'AQUAPORIN TIP2-3', 241822),
(325397, 'PTHR45665:SF31', NULL, NULL, NULL, NULL, 'BNAC02G46870D PROTEIN', 241822),
(325398, 'PTHR45665:SF52', NULL, NULL, NULL, NULL, 'AQUAPORIN OR AQUAGLYCEROPORIN RELATED', 241822),
(325399, 'PTHR45665:SF30', NULL, NULL, NULL, NULL, 'MAJOR INTRINSIC PROTEIN, AQUAPORIN-LIKE PROTEIN-RELATED', 241822),
(325400, 'PTHR45665:SF37', NULL, NULL, NULL, NULL, 'AQUAPORIN TIP2-3-RELATED', 241822),
(325401, 'PTHR45665:SF14', NULL, NULL, NULL, NULL, 'AQUAPORIN TIP3-2-RELATED', 241822),
(325402, 'PTHR45665:SF6', NULL, NULL, NULL, NULL, 'AQP8A PROTEIN', 241822),
(325403, 'PTHR45665:SF58', NULL, NULL, NULL, NULL, 'AQUAPORIN TIP3-1', 241822),
(325404, 'PTHR45665:SF57', NULL, NULL, NULL, NULL, 'AQUAPORIN TIP1-1-RELATED', 241822),
(325405, 'PTHR45665:SF13', NULL, NULL, NULL, NULL, 'AQUAPORIN TIP4-1-RELATED', 241822),
(325406, 'PTHR45665:SF56', NULL, NULL, NULL, NULL, '', 241822),
(325407, 'PTHR45665:SF34', NULL, NULL, NULL, NULL, 'BNACNNG50290D PROTEIN', 241822),
(325408, 'PTHR45665:SF12', NULL, NULL, NULL, NULL, 'AQUAPORIN OR AQUAGLYCEROPORIN RELATED', 241822),
(325409, 'PTHR45665:SF18', NULL, NULL, NULL, NULL, 'AQUAPORIN TIP3.1', 241822),
(325410, 'PTHR45665:SF38', NULL, NULL, NULL, NULL, 'BNAA09G44820D PROTEIN', 241822),
(325411, 'PTHR45665:SF16', NULL, NULL, NULL, NULL, 'AQUAPORIN TIP1-2', 241822),
(325412, 'PTHR45665', NULL, NULL, NULL, NULL, 'AQUAPORIN-8', 241822),
(325413, 'PTHR45665:SF40', NULL, NULL, NULL, NULL, '', 241822),
(325414, 'PTHR45665:SF44', NULL, NULL, NULL, NULL, 'MAJOR INTRINSIC PROTEIN, AQUAPORIN-LIKE PROTEIN-RELATED', 241822),
(325415, 'PTHR45665:SF22', NULL, NULL, NULL, NULL, 'INTRINSIC PROTEIN, PUTATIVE-RELATED', 241822),
(325416, 'PTHR45665:SF43', NULL, NULL, NULL, NULL, 'BNAA06G40020D PROTEIN', 241822);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(325417, 'PTHR45665:SF21', NULL, NULL, NULL, NULL, 'AQUAPORIN TIP1-3', 241822),
(325418, 'PTHR45665:SF42', NULL, NULL, NULL, NULL, 'BNAA01G28120D PROTEIN', 241822),
(325419, 'PTHR45665:SF20', NULL, NULL, NULL, NULL, 'MAJOR INTRINSIC PROTEIN (MIP) FAMILY TRANSPORTER', 241822),
(325420, 'PTHR45665:SF41', NULL, NULL, NULL, NULL, 'AQUAPORIN TIP2-5S', 241822),
(325421, 'PTHR45665:SF26', NULL, NULL, NULL, NULL, 'AQUAPORIN TIP4-1', 241822),
(325422, 'PTHR45665:SF25', NULL, NULL, NULL, NULL, 'AQUAPORIN TIP3-2-RELATED', 241822),
(325423, 'PTHR45665:SF23', NULL, NULL, NULL, NULL, 'AQUAPORIN TIP3-2-RELATED', 241822),
(325424, 'PTHR45665:SF45', NULL, NULL, NULL, NULL, 'BNAA02G28130D PROTEIN', 241822),
(325425, 'PTHR45665:SF29', NULL, NULL, NULL, NULL, 'AQUAPORIN', 241822),
(325426, 'PTHR45665:SF49', NULL, NULL, NULL, NULL, 'AQUAPORIN TIP1-1T', 241822),
(325427, 'PTHR45665:SF27', NULL, NULL, NULL, NULL, 'AQUAPORIN TIP5-1-RELATED', 241822),
(325428, 'PTHR28553', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE B', 241823),
(325429, 'PTHR28553:SF1', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE B', 241823),
(325430, 'PTHR28553:SF2', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE W', 241823),
(325431, 'PTHR43813:SF8', NULL, NULL, NULL, NULL, 'LONG-CHAIN-FATTY-ACID--[ACYL-CARRIER-PROTEIN] LIGASE AEE15, CHLOROPLASTIC', 241824),
(325432, 'PTHR43813', NULL, NULL, NULL, NULL, 'ACYL-ACTIVATING ENZYME 16, CHLOROPLASTIC-RELATED', 241824),
(325433, 'PTHR43813:SF4', NULL, NULL, NULL, NULL, 'LONG-CHAIN-FATTY-ACID COA LIGASE (AMP-FORMING)', 241824),
(325434, 'PTHR43813:SF1', NULL, NULL, NULL, NULL, 'ACYL-ACTIVATING ENZYME 16, CHLOROPLASTIC-RELATED', 241824),
(325435, 'PTHR24210:SF0', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING PROTEIN', 241825),
(325436, 'PTHR24210:SF10', NULL, NULL, NULL, NULL, 'LIM AND SENESCENT CELL ANTIGEN-LIKE-CONTAINING DOMAIN PROTEIN 2', 241825),
(325437, 'PTHR24210:SF11', NULL, NULL, NULL, NULL, 'LIM AND SENESCENT CELL ANTIGEN-LIKE-CONTAINING DOMAIN PROTEIN 1', 241825),
(325438, 'PTHR24210', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING PROTEIN', 241825),
(325439, 'PTHR24210:SF7', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING PROTEIN PIN-2', 241825),
(325440, 'PTHR13077:SF7', NULL, NULL, NULL, NULL, 'SELENOPROTEIN M', 241826),
(325441, 'PTHR13077:SF8', NULL, NULL, NULL, NULL, 'SEP15_SELM DOMAIN-CONTAINING PROTEIN', 241826),
(325442, 'PTHR13077:SF6', NULL, NULL, NULL, NULL, 'SELENOPROTEIN F', 241826),
(325443, 'PTHR13077', NULL, NULL, NULL, NULL, 'SELENOPROTEIN F', 241826),
(325444, 'PTHR36757', NULL, NULL, NULL, NULL, 'BNAANNG22500D PROTEIN', 241827),
(325445, 'PTHR36757:SF1', NULL, NULL, NULL, NULL, 'BNAANNG22500D PROTEIN', 241827),
(325446, 'PTHR36757:SF2', NULL, NULL, NULL, NULL, 'BNAC06G02230D PROTEIN', 241827),
(325447, 'PTHR36757:SF3', NULL, NULL, NULL, NULL, '', 241827),
(325448, 'PTHR36757:SF4', NULL, NULL, NULL, NULL, '', 241827),
(325449, 'PTHR44889', NULL, NULL, NULL, NULL, 'INACTIVE HYDROXYSTEROID DEHYDROGENASE-LIKE PROTEIN 1', 241828),
(325450, 'PTHR44889:SF1', NULL, NULL, NULL, NULL, 'INACTIVE HYDROXYSTEROID DEHYDROGENASE-LIKE PROTEIN 1', 241828),
(325451, 'PTHR34439', NULL, NULL, NULL, NULL, 'CENTROBIN', 241829),
(325452, 'PTHR34439:SF1', NULL, NULL, NULL, NULL, 'CENTROBIN', 241829),
(325453, 'PTHR48011:SF99', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 241830),
(325454, 'PTHR48011:SF55', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325455, 'PTHR48011:SF54', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325456, 'PTHR48011:SF98', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325457, 'PTHR48011:SF10', NULL, NULL, NULL, NULL, 'OS10G0130000 PROTEIN', 241830),
(325458, 'PTHR48011:SF53', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 241830),
(325459, 'PTHR48011:SF97', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325460, 'PTHR48011:SF100', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE YODA', 241830),
(325461, 'PTHR48011:SF96', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 17', 241830);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(325462, 'PTHR48011:SF52', NULL, NULL, NULL, NULL, 'PROTEIN KINASE FAMILY PROTEIN-RELATED', 241830),
(325463, 'PTHR48011:SF101', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 14', 241830),
(325464, 'PTHR48011:SF95', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 3', 241830),
(325465, 'PTHR48011:SF102', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325466, 'PTHR48011:SF51', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 241830),
(325467, 'PTHR48011:SF50', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325468, 'PTHR48011:SF94', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325469, 'PTHR48011:SF93', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325470, 'PTHR48011:SF92', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 2-RELATED', 241830),
(325471, 'PTHR48011:SF19', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325472, 'PTHR48011:SF1', NULL, NULL, NULL, NULL, 'NPK1-RELATED PROTEIN KINASE-LIKE PROTEIN', 241830),
(325473, 'PTHR48011:SF18', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 19-RELATED', 241830),
(325474, 'PTHR48011:SF17', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE YODA', 241830),
(325475, 'PTHR48011:SF16', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 241830),
(325476, 'PTHR48011:SF15', NULL, NULL, NULL, NULL, 'PROTEIN KINASE FAMILY PROTEIN-RELATED', 241830),
(325477, 'PTHR48011:SF6', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325478, 'PTHR48011', NULL, NULL, NULL, NULL, 'CCR4-NOT TRANSCRIPTIONAL COMPLEX SUBUNIT CAF120-RELATED', 241830),
(325479, 'PTHR48011:SF5', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE NPK1-LIKE', 241830),
(325480, 'PTHR48011:SF13', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325481, 'PTHR48011:SF57', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325482, 'PTHR48011:SF4', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 19', 241830),
(325483, 'PTHR48011:SF3', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325484, 'PTHR48011:SF12', NULL, NULL, NULL, NULL, 'OS08G0421800 PROTEIN', 241830),
(325485, 'PTHR48011:SF56', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325486, 'PTHR48011:SF9', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325487, 'PTHR48011:SF8', NULL, NULL, NULL, NULL, 'MAP KINASE KINASE KINASE', 241830),
(325488, 'PTHR48011:SF7', NULL, NULL, NULL, NULL, 'F10K1.14 PROTEIN', 241830),
(325489, 'PTHR48011:SF80', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325490, 'PTHR48011:SF88', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 3', 241830),
(325491, 'PTHR48011:SF44', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325492, 'PTHR48011:SF42', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE YODA', 241830),
(325493, 'PTHR48011:SF86', NULL, NULL, NULL, NULL, 'PROTEIN KINASE BYR2-LIKE', 241830),
(325494, 'PTHR48011:SF85', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 241830),
(325495, 'PTHR48011:SF84', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 241830),
(325496, 'PTHR48011:SF40', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325497, 'PTHR48011:SF81', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325498, 'PTHR48011:SF49', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325499, 'PTHR48011:SF48', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325500, 'PTHR48011:SF46', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325501, 'PTHR48011:SF89', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE YODA', 241830);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(325502, 'PTHR48011:SF76', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 15', 241830),
(325503, 'PTHR48011:SF32', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE FHKE-RELATED', 241830),
(325504, 'PTHR48011:SF75', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325505, 'PTHR48011:SF31', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE NPK1-LIKE', 241830),
(325506, 'PTHR48011:SF74', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325507, 'PTHR48011:SF72', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325508, 'PTHR48011:SF71', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325509, 'PTHR48011:SF70', NULL, NULL, NULL, NULL, 'SERINE/THREONINE/DUAL SPECIFICITY PROTEIN KINASE, CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 241830),
(325510, 'PTHR48011:SF39', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325511, 'PTHR48011:SF38', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325512, 'PTHR48011:SF37', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 241830),
(325513, 'PTHR48011:SF36', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325514, 'PTHR48011:SF35', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 3-LIKE', 241830),
(325515, 'PTHR48011:SF34', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325516, 'PTHR48011:SF78', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325517, 'PTHR48011:SF66', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325518, 'PTHR48011:SF21', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN (MAP) KINASE, ERK3/4-RELATED', 241830),
(325519, 'PTHR48011:SF65', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 241830),
(325520, 'PTHR48011:SF64', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 17A-LIKE', 241830),
(325521, 'PTHR48011:SF20', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325522, 'PTHR48011:SF62', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325523, 'PTHR48011:SF61', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 16', 241830),
(325524, 'PTHR48011:SF60', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325525, 'PTHR48011:SF29', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325526, 'PTHR48011:SF28', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325527, 'PTHR48011:SF27', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325528, 'PTHR48011:SF25', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325529, 'PTHR48011:SF68', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 21', 241830),
(325530, 'PTHR48011:SF24', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325531, 'PTHR48011:SF23', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241830),
(325532, 'PTHR37310:SF1', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 241831),
(325533, 'PTHR37310', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 241831),
(325534, 'PTHR43376:SF1', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORT SYSTEM PERMEASE PROTEIN', 241832),
(325535, 'PTHR43376', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORT SYSTEM PERMEASE PROTEIN', 241832),
(325536, 'PTHR12489:SF22', NULL, NULL, NULL, NULL, 'SI:DKEY-35M8.1', 241833),
(325537, 'PTHR12489:SF21', NULL, NULL, NULL, NULL, 'LHFPL TETRASPAN SUBFAMILY MEMBER 5B', 241833),
(325538, 'PTHR12489:SF20', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 211', 241833),
(325539, 'PTHR12489:SF19', NULL, NULL, NULL, NULL, 'LHFPL TETRASPAN SUBFAMILY MEMBER 2 PROTEIN', 241833),
(325540, 'PTHR12489:SF18', NULL, NULL, NULL, NULL, 'LHFPL TETRASPAN SUBFAMILY MEMBER 5 PROTEIN', 241833);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(325541, 'PTHR12489:SF17', NULL, NULL, NULL, NULL, 'LHFPL TETRASPAN SUBFAMILY MEMBER 4B', 241833),
(325542, 'PTHR12489:SF16', NULL, NULL, NULL, NULL, 'LIPOMA HMGIC FUSION PARTNER HOMOLOG-LIKE PROTEIN', 241833),
(325543, 'PTHR12489:SF15', NULL, NULL, NULL, NULL, 'LHFPL TETRASPAN SUBFAMILY MEMBER 1 PROTEIN', 241833),
(325544, 'PTHR12489:SF14', NULL, NULL, NULL, NULL, 'LHFPL TETRASPAN SUBFAMILY MEMBER 4 PROTEIN', 241833),
(325545, 'PTHR12489:SF13', NULL, NULL, NULL, NULL, 'LHFPL TETRASPAN SUBFAMILY MEMBER 3 PROTEIN', 241833),
(325546, 'PTHR12489:SF12', NULL, NULL, NULL, NULL, 'LHFPL TETRASPAN SUBFAMILY MEMBER 6 PROTEIN', 241833),
(325547, 'PTHR12489:SF1', NULL, NULL, NULL, NULL, 'LP10272P', 241833),
(325548, 'PTHR12489', NULL, NULL, NULL, NULL, 'LIPOMA HMGIC FUSION PARTNER-LIKE PROTEIN', 241833),
(325549, 'PTHR47466', NULL, NULL, NULL, NULL, '', 241834),
(325550, 'PTHR47466:SF1', NULL, NULL, NULL, NULL, 'METALLOPROTEASE MEP1 (AFU_ORTHOLOGUE AFUA_1G07730)-RELATED', 241834),
(325551, 'PTHR33844', NULL, NULL, NULL, NULL, 'SULFOTRANSFER_1 DOMAIN-CONTAINING PROTEIN', 241835),
(325552, 'PTHR33844:SF1', NULL, NULL, NULL, NULL, 'SULFOTRANSFER_1 DOMAIN-CONTAINING PROTEIN', 241835),
(325553, 'PTHR43394:SF1', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT PERMEASE MDL1, MITOCHONDRIAL', 241836),
(325554, 'PTHR43394:SF2', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT PERMEASE MDL2, MITOCHONDRIAL', 241836),
(325555, 'PTHR43394:SF5', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY', 241836),
(325556, 'PTHR43394:SF11', NULL, NULL, NULL, NULL, 'ABC TRANSMEMBRANE TYPE-1 DOMAIN-CONTAINING PROTEIN', 241836),
(325557, 'PTHR43394', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT PERMEASE MDL1, MITOCHONDRIAL', 241836),
(325558, 'PTHR43394:SF4', NULL, NULL, NULL, NULL, 'TOXIN SECRETION ABC TRANSPORTER ATP-BINDING PROTEIN', 241836),
(325559, 'PTHR43394:SF7', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 28', 241836),
(325560, 'PTHR43394:SF6', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY', 241836),
(325561, 'PTHR43394:SF9', NULL, NULL, NULL, NULL, '', 241836),
(325562, 'PTHR43394:SF8', NULL, NULL, NULL, NULL, 'ATP BINDING CASSETTE SUBFAMILY B MEMBER 9', 241836),
(325563, 'PTHR43394:SF10', NULL, NULL, NULL, NULL, 'ALPHA-FACTOR-TRANSPORTING ATPASE', 241836),
(325564, 'PTHR34648', NULL, NULL, NULL, NULL, 'CLOCK-INTERACTING PACEMAKER', 241837),
(325565, 'PTHR34648:SF7', NULL, NULL, NULL, NULL, 'SI:CH211-132B12.7', 241837),
(325566, 'PTHR34648:SF6', NULL, NULL, NULL, NULL, 'CLOCK-INTERACTING PACEMAKER B', 241837),
(325567, 'PTHR34648:SF8', NULL, NULL, NULL, NULL, 'CLOCK-INTERACTING PACEMAKER A', 241837),
(325568, 'PTHR34648:SF1', NULL, NULL, NULL, NULL, 'CLOCK-INTERACTING PACEMAKER', 241837),
(325569, 'PTHR42733:SF8', NULL, NULL, NULL, NULL, 'DJ-1 PROTEIN HOMOLOG F', 241838),
(325570, 'PTHR42733:SF12', NULL, NULL, NULL, NULL, 'PROTEIN/NUCLEIC ACID DEGLYCASE 2', 241838),
(325571, 'PTHR42733:SF9', NULL, NULL, NULL, NULL, 'DJ-1 PROTEIN HOMOLOG E', 241838),
(325572, 'PTHR42733', NULL, NULL, NULL, NULL, 'DJ-1 PROTEIN', 241838),
(325573, 'PTHR42733:SF2', NULL, NULL, NULL, NULL, 'DJ-1/THIJ/PFPI FAMILY PROTEIN', 241838),
(325574, 'PTHR46553:SF27', NULL, NULL, NULL, NULL, 'UNIVERSAL STRESS PROTEIN A-LIKE PROTEIN', 241839),
(325575, 'PTHR46553:SF16', NULL, NULL, NULL, NULL, 'UNIVERSAL STRESS A-LIKE PROTEIN', 241839),
(325576, 'PTHR46553:SF26', NULL, NULL, NULL, NULL, 'UNIVERSAL STRESS PROTEIN YXIE-LIKE', 241839),
(325577, 'PTHR46553:SF3', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN', 241839),
(325578, 'PTHR46553', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN', 241839),
(325579, 'PTHR46553:SF14', NULL, NULL, NULL, NULL, 'UNIVERSAL STRESS PROTEIN A-LIKE PROTEIN', 241839),
(325580, 'PTHR46553:SF24', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 241839),
(325581, 'PTHR46553:SF23', NULL, NULL, NULL, NULL, 'PROTEIN FB19, PUTATIVE, EXPRESSED-RELATED', 241839),
(325582, 'PTHR46553:SF12', NULL, NULL, NULL, NULL, 'UNIVERSAL STRESS PROTEIN A-LIKE PROTEIN', 241839);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(325583, 'PTHR46553:SF22', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 241839),
(325584, 'PTHR46553:SF11', NULL, NULL, NULL, NULL, 'OS07G0673400 PROTEIN', 241839),
(325585, 'PTHR46553:SF21', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASE-LIKE SUPERFAMILY PROTEIN', 241839),
(325586, 'PTHR46553:SF10', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 241839),
(325587, 'PTHR46553:SF9', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 241839),
(325588, 'PTHR46553:SF19', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 241839),
(325589, 'PTHR46553:SF29', NULL, NULL, NULL, NULL, 'OS10G0437500 PROTEIN', 241839),
(325590, 'PTHR46553:SF17', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 241839),
(325591, 'PTHR46553:SF28', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 241839),
(325592, 'PTHR10371:SF3', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] FLAVOPROTEIN 2, MITOCHONDRIAL', 241840),
(325593, 'PTHR10371', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE  UBIQUINONE  FLAVOPROTEIN 2, MITOCHONDRIAL', 241840),
(325594, 'PTHR20923', NULL, NULL, NULL, NULL, 'BAT4 PROTEIN-RELATED', 241841),
(325595, 'PTHR20923:SF1', NULL, NULL, NULL, NULL, 'G PATCH DOMAIN AND ANKYRIN REPEAT-CONTAINING PROTEIN 1', 241841),
(325596, 'PTHR12521', NULL, NULL, NULL, NULL, 'PROTEIN C6ORF130', 241842),
(325597, 'PTHR12521:SF0', NULL, NULL, NULL, NULL, 'ADP-RIBOSE GLYCOHYDROLASE OARD1', 241842),
(325598, 'PTHR13129:SF4', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 1', 241843),
(325599, 'PTHR13129', NULL, NULL, NULL, NULL, 'VPRBP PROTEIN-RELATED', 241843),
(325600, 'PTHR13129:SF5', NULL, NULL, NULL, NULL, 'BNAA03G51310D PROTEIN', 241843),
(325601, 'PTHR38648', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4930451I11 GENE', 241844),
(325602, 'PTHR38648:SF1', NULL, NULL, NULL, NULL, 'FERTILIZATION-INFLUENCING MEMBRANE PROTEIN', 241844),
(325603, 'PTHR12782:SF5', NULL, NULL, NULL, NULL, 'PROSTAGLANDIN E SYNTHASE 2', 241845),
(325604, 'PTHR12782:SF11', NULL, NULL, NULL, NULL, 'MICROSOMAL PROSTAGLANDIN E SYNTHASE 2', 241845),
(325605, 'PTHR12782:SF9', NULL, NULL, NULL, NULL, 'MICROSOMAL PROSTAGLANDIN E SYNTHASE 2', 241845),
(325606, 'PTHR12782', NULL, NULL, NULL, NULL, 'MICROSOMAL PROSTAGLANDIN E SYNTHASE-2', 241845),
(325607, 'PTHR22234:SF0', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 3', 241846),
(325608, 'PTHR22234:SF1', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS ASSOCIATED 3', 241846),
(325609, 'PTHR22234', NULL, NULL, NULL, NULL, 'TESTIS SPERMATOCYTE APOPTOSIS-RELATED GENE 1 PROTEIN', 241846),
(325610, 'PTHR15081:SF9', NULL, NULL, NULL, NULL, 'SHNI-TPR DOMAIN-CONTAINING PROTEIN', 241847),
(325611, 'PTHR15081', NULL, NULL, NULL, NULL, 'NUCLEAR AUTOANTIGENIC SPERM PROTEIN  NASP -RELATED', 241847),
(325612, 'PTHR15081:SF1', NULL, NULL, NULL, NULL, 'NUCLEAR AUTOANTIGENIC SPERM PROTEIN', 241847),
(325613, 'PTHR28158:SF1', NULL, NULL, NULL, NULL, '37S RIBOSOMAL PROTEIN S35, MITOCHONDRIAL', 241848),
(325614, 'PTHR28158', NULL, NULL, NULL, NULL, '37S RIBOSOMAL PROTEIN S35, MITOCHONDRIAL', 241848),
(325615, 'PTHR33431:SF5', NULL, NULL, NULL, NULL, 'BNAA10G12740D PROTEIN', 241849),
(325616, 'PTHR33431:SF6', NULL, NULL, NULL, NULL, '', 241849),
(325617, 'PTHR33431:SF8', NULL, NULL, NULL, NULL, 'DUF1635 FAMILY PROTEIN', 241849),
(325618, 'PTHR33431:SF2', NULL, NULL, NULL, NULL, 'DUF1635 FAMILY PROTEIN', 241849),
(325619, 'PTHR33431:SF3', NULL, NULL, NULL, NULL, 'ENABLED-LIKE PROTEIN (DUF1635)', 241849),
(325620, 'PTHR33431:SF19', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 241849),
(325621, 'PTHR33431:SF18', NULL, NULL, NULL, NULL, 'ENABLED-LIKE PROTEIN (DUF1635)', 241849),
(325622, 'PTHR33431:SF13', NULL, NULL, NULL, NULL, 'BNACNNG50910D PROTEIN', 241849),
(325623, 'PTHR33431:SF12', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP BOX PROTEIN, PUTATIVE (DUF1635)-RELATED', 241849),
(325624, 'PTHR33431:SF17', NULL, NULL, NULL, NULL, 'BNAC02G00610D PROTEIN', 241849),
(325625, 'PTHR33431:SF9', NULL, NULL, NULL, NULL, 'ENABLED-LIKE PROTEIN (DUF1635)', 241849);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(325626, 'PTHR33431', NULL, NULL, NULL, NULL, 'ENABLED-LIKE PROTEIN (DUF1635)', 241849),
(325627, 'PTHR33431:SF20', NULL, NULL, NULL, NULL, 'GB|AAD24366.1', 241849),
(325628, 'PTHR15641:SF1', NULL, NULL, NULL, NULL, 'ELONGATOR COMPLEX PROTEIN 5', 241850),
(325629, 'PTHR15641', NULL, NULL, NULL, NULL, 'ELONGATOR COMPLEX PROTEIN 5', 241850),
(325630, 'PTHR28594', NULL, NULL, NULL, NULL, 'ATR-INTERACTING PROTEIN', 241851),
(325631, 'PTHR28594:SF1', NULL, NULL, NULL, NULL, 'ATR-INTERACTING PROTEIN', 241851),
(325632, 'PTHR12841:SF6', NULL, NULL, NULL, NULL, 'PROTEIN UNC-50 HOMOLOG', 241852),
(325633, 'PTHR12841', NULL, NULL, NULL, NULL, 'PROTEIN UNC-50 HOMOLOG', 241852),
(325634, 'PTHR12841:SF7', NULL, NULL, NULL, NULL, 'BNAA07G03880D PROTEIN', 241852),
(325635, 'PTHR42920:SF28', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 241853),
(325636, 'PTHR42920:SF10', NULL, NULL, NULL, NULL, '', 241853),
(325637, 'PTHR42920:SF11', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YTFF', 241853),
(325638, 'PTHR42920:SF23', NULL, NULL, NULL, NULL, 'EAMA DOMAIN-CONTAINING PROTEIN', 241853),
(325639, 'PTHR42920:SF24', NULL, NULL, NULL, NULL, 'BLR3407 PROTEIN', 241853),
(325640, 'PTHR42920', NULL, NULL, NULL, NULL, 'OS03G0707200 PROTEIN-RELATED', 241853),
(325641, 'PTHR42920:SF14', NULL, NULL, NULL, NULL, 'TRANSPORTER, DRUG/METABOLITE EXPORTER FAMILY', 241853),
(325642, 'PTHR42920:SF25', NULL, NULL, NULL, NULL, 'AROMATIC AMINO ACID EXPORTER YDDG', 241853),
(325643, 'PTHR42920:SF15', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 241853),
(325644, 'PTHR42920:SF26', NULL, NULL, NULL, NULL, 'OS03G0707200 PROTEIN', 241853),
(325645, 'PTHR42920:SF27', NULL, NULL, NULL, NULL, 'EAMA DOMAIN-CONTAINING PROTEIN', 241853),
(325646, 'PTHR42920:SF5', NULL, NULL, NULL, NULL, 'EAMA DOMAIN-CONTAINING PROTEIN', 241853),
(325647, 'PTHR42920:SF9', NULL, NULL, NULL, NULL, 'BLR8172 PROTEIN', 241853),
(325648, 'PTHR42920:SF7', NULL, NULL, NULL, NULL, '', 241853),
(325649, 'PTHR31916:SF40', NULL, NULL, NULL, NULL, 'ALKALINE/NEUTRAL INVERTASE B-RELATED', 241854),
(325650, 'PTHR31916:SF42', NULL, NULL, NULL, NULL, 'ALKALINE/NEUTRAL INVERTASE', 241854),
(325651, 'PTHR31916:SF52', NULL, NULL, NULL, NULL, 'ALKALINE/NEUTRAL INVERTASE', 241854),
(325652, 'PTHR31916:SF41', NULL, NULL, NULL, NULL, 'ALKALINE/NEUTRAL INVERTASE F-RELATED', 241854),
(325653, 'PTHR31916:SF44', NULL, NULL, NULL, NULL, 'ALKALINE/NEUTRAL INVERTASE A, CHLOROPLASTIC-RELATED', 241854),
(325654, 'PTHR31916:SF43', NULL, NULL, NULL, NULL, 'ALKALINE/NEUTRAL INVERTASE', 241854),
(325655, 'PTHR31916:SF54', NULL, NULL, NULL, NULL, 'ALKALINE/NEUTRAL INVERTASE', 241854),
(325656, 'PTHR31916', NULL, NULL, NULL, NULL, '', 241854),
(325657, 'PTHR31916:SF35', NULL, NULL, NULL, NULL, 'ALKALINE/NEUTRAL INVERTASE', 241854),
(325658, 'PTHR31916:SF46', NULL, NULL, NULL, NULL, 'ALKALINE/NEUTRAL INVERTASE A, MITOCHONDRIAL', 241854),
(325659, 'PTHR31916:SF57', NULL, NULL, NULL, NULL, 'ALKALINE/NEUTRAL INVERTASE', 241854),
(325660, 'PTHR31916:SF45', NULL, NULL, NULL, NULL, 'ALKALINE/NEUTRAL INVERTASE', 241854),
(325661, 'PTHR31916:SF37', NULL, NULL, NULL, NULL, 'ALKALINE/NEUTRAL INVERTASE', 241854),
(325662, 'PTHR31916:SF15', NULL, NULL, NULL, NULL, 'ALKALINE/NEUTRAL INVERTASE D-RELATED', 241854),
(325663, 'PTHR31916:SF48', NULL, NULL, NULL, NULL, 'ALKALINE/NEUTRAL INVERTASE', 241854),
(325664, 'PTHR31916:SF58', NULL, NULL, NULL, NULL, 'ALKALINE/NEUTRAL INVERTASE', 241854),
(325665, 'PTHR31916:SF36', NULL, NULL, NULL, NULL, 'ALKALINE/NEUTRAL INVERTASE E, CHLOROPLASTIC', 241854),
(325666, 'PTHR31916:SF39', NULL, NULL, NULL, NULL, 'ALKALINE/NEUTRAL INVERTASE CINV2', 241854),
(325667, 'PTHR31916:SF28', NULL, NULL, NULL, NULL, 'ALKALINE/NEUTRAL INVERTASE CINV1', 241854),
(325668, 'PTHR31916:SF49', NULL, NULL, NULL, NULL, 'ALKALINE/NEUTRAL INVERTASE C, MITOCHONDRIAL', 241854),
(325669, 'PTHR31916:SF8', NULL, NULL, NULL, NULL, 'ALKALINE/NEUTRAL INVERTASE', 241854),
(325670, 'PTHR31916:SF5', NULL, NULL, NULL, NULL, 'ALKALINE/NEUTRAL INVERTASE', 241854),
(325671, 'PTHR14725:SF0', NULL, NULL, NULL, NULL, 'RIBOSOME-BINDING FACTOR A, MITOCHONDRIAL-RELATED', 241855);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(325672, 'PTHR14725', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 241855),
(325673, 'PTHR10517:SF14', NULL, NULL, NULL, NULL, 'FOLATE_REC DOMAIN-CONTAINING PROTEIN', 241856),
(325674, 'PTHR10517:SF8', NULL, NULL, NULL, NULL, 'FOLATE RECEPTOR BETA', 241856),
(325675, 'PTHR10517:SF15', NULL, NULL, NULL, NULL, 'FOLATE RECEPTOR ALPHA', 241856),
(325676, 'PTHR10517:SF23', NULL, NULL, NULL, NULL, 'FOLATE_REC DOMAIN-CONTAINING PROTEIN', 241856),
(325677, 'PTHR10517:SF24', NULL, NULL, NULL, NULL, 'FOLATE_REC DOMAIN-CONTAINING PROTEIN', 241856),
(325678, 'PTHR10517:SF19', NULL, NULL, NULL, NULL, 'RETBINDIN', 241856),
(325679, 'PTHR10517:SF16', NULL, NULL, NULL, NULL, '', 241856),
(325680, 'PTHR10517:SF17', NULL, NULL, NULL, NULL, 'FOLATE RECEPTOR GAMMA', 241856),
(325681, 'PTHR10517', NULL, NULL, NULL, NULL, 'FOLATE RECEPTOR', 241856),
(325682, 'PTHR10517:SF21', NULL, NULL, NULL, NULL, 'FOLATE_REC DOMAIN-CONTAINING PROTEIN-RELATED', 241856),
(325683, 'PTHR10517:SF10', NULL, NULL, NULL, NULL, 'SPERM-EGG FUSION PROTEIN JUNO', 241856),
(325684, 'PTHR10517:SF22', NULL, NULL, NULL, NULL, 'FOLATE_REC DOMAIN-CONTAINING PROTEIN', 241856),
(325685, 'PTHR10517:SF20', NULL, NULL, NULL, NULL, 'FOLATE_REC DOMAIN-CONTAINING PROTEIN', 241856),
(325686, 'PTHR34341', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 107', 241857),
(325687, 'PTHR34341:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 107', 241857),
(325688, 'PTHR37969:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG13105', 241858),
(325689, 'PTHR37969', NULL, NULL, NULL, NULL, 'PROTEIN CBG07421-RELATED', 241858),
(325690, 'PTHR37969:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG07421', 241858),
(325691, 'PTHR37969:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG13131', 241858),
(325692, 'PTHR28607:SF4', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241859),
(325693, 'PTHR28607', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241859),
(325694, 'PTHR28607:SF1', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN FAM174A', 241859),
(325695, 'PTHR28607:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM174C', 241859),
(325696, 'PTHR28607:SF3', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN FAM174B', 241859),
(325697, 'PTHR36773:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241860),
(325698, 'PTHR36773', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241860),
(325699, 'PTHR36781', NULL, NULL, NULL, NULL, 'OS05G0114600 PROTEIN', 241861),
(325700, 'PTHR36781:SF1', NULL, NULL, NULL, NULL, 'OS05G0114600 PROTEIN', 241861),
(325701, 'PTHR33086:SF49', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 4', 241862),
(325702, 'PTHR33086:SF42', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 241862),
(325703, 'PTHR33086:SF86', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 241862),
(325704, 'PTHR33086:SF41', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 241862),
(325705, 'PTHR33086:SF63', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 241862),
(325706, 'PTHR33086:SF85', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 241862),
(325707, 'PTHR33086:SF62', NULL, NULL, NULL, NULL, 'OS01G0182100 PROTEIN', 241862),
(325708, 'PTHR33086:SF83', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 241862),
(325709, 'PTHR33086:SF46', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241862),
(325710, 'PTHR33086:SF68', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 241862),
(325711, 'PTHR33086:SF89', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 241862),
(325712, 'PTHR33086:SF44', NULL, NULL, NULL, NULL, 'OS03G0683600 PROTEIN', 241862),
(325713, 'PTHR33086:SF88', NULL, NULL, NULL, NULL, 'OS05G0250200 PROTEIN', 241862),
(325714, 'PTHR33086:SF66', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 241862),
(325715, 'PTHR33086:SF43', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 241862),
(325716, 'PTHR33086:SF87', NULL, NULL, NULL, NULL, 'OS03G0384400 PROTEIN', 241862),
(325717, 'PTHR33086:SF65', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN CONTAINING FAMILY PROTEIN-RELATED', 241862),
(325718, 'PTHR33086', NULL, NULL, NULL, NULL, 'OS05G0468200 PROTEIN-RELATED', 241862);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(325719, 'PTHR33086:SF82', NULL, NULL, NULL, NULL, 'OS01G0245901 PROTEIN', 241862),
(325720, 'PTHR33086:SF81', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241862),
(325721, 'PTHR33086:SF4', NULL, NULL, NULL, NULL, 'OS05G0467700 PROTEIN', 241862),
(325722, 'PTHR33086:SF6', NULL, NULL, NULL, NULL, 'OS01G0245532 PROTEIN', 241862),
(325723, 'PTHR33086:SF5', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 241862),
(325724, 'PTHR33086:SF59', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241862),
(325725, 'PTHR33086:SF58', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN CONTAINING FAMILY PROTEIN-RELATED', 241862),
(325726, 'PTHR33086:SF75', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 241862),
(325727, 'PTHR33086:SF52', NULL, NULL, NULL, NULL, 'OS09G0128900 PROTEIN', 241862),
(325728, 'PTHR33086:SF30', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 241862),
(325729, 'PTHR33086:SF51', NULL, NULL, NULL, NULL, 'OS06G0307900 PROTEIN', 241862),
(325730, 'PTHR33086:SF73', NULL, NULL, NULL, NULL, 'OS01G0244000 PROTEIN', 241862),
(325731, 'PTHR33086:SF79', NULL, NULL, NULL, NULL, 'OS05G0250000 PROTEIN', 241862),
(325732, 'PTHR33086:SF56', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 241862),
(325733, 'PTHR33086:SF54', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 241862),
(325734, 'PTHR33086:SF10', NULL, NULL, NULL, NULL, 'OS05G0468200 PROTEIN', 241862),
(325735, 'PTHR33086:SF71', NULL, NULL, NULL, NULL, 'DUF1618 DOMAIN-CONTAINING PROTEIN', 241862),
(325736, 'PTHR37751:SF5', NULL, NULL, NULL, NULL, '', 241863),
(325737, 'PTHR37751:SF4', NULL, NULL, NULL, NULL, 'DUF4378 DOMAIN PROTEIN', 241863),
(325738, 'PTHR37751:SF6', NULL, NULL, NULL, NULL, 'VARLMGL DOMAIN-CONTAINING PROTEIN', 241863),
(325739, 'PTHR37751:SF1', NULL, NULL, NULL, NULL, 'LOW PROTEIN: M-PHASE INDUCER PHOSPHATASE-LIKE PROTEIN', 241863),
(325740, 'PTHR37751:SF3', NULL, NULL, NULL, NULL, 'VARLMGL DOMAIN-CONTAINING PROTEIN', 241863),
(325741, 'PTHR37751', NULL, NULL, NULL, NULL, 'LOW PROTEIN: M-PHASE INDUCER PHOSPHATASE-LIKE PROTEIN', 241863),
(325742, 'PTHR37751:SF2', NULL, NULL, NULL, NULL, 'VARLMGL DOMAIN-CONTAINING PROTEIN', 241863),
(325743, 'PTHR44372:SF6', NULL, NULL, NULL, NULL, 'BNACNNG19790D PROTEIN', 241864),
(325744, 'PTHR44372:SF8', NULL, NULL, NULL, NULL, 'BNAC08G13770D PROTEIN', 241864),
(325745, 'PTHR44372:SF7', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-GAMMA-RELATED', 241864),
(325746, 'PTHR44372', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-GAMMA 1-RELATED', 241864),
(325747, 'PTHR44372:SF1', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-GAMMA 1-RELATED', 241864),
(325748, 'PTHR44372:SF4', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-GAMMA', 241864),
(325749, 'PTHR44372:SF3', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-GAMMA 3', 241864),
(325750, 'PTHR44372:SF11', NULL, NULL, NULL, NULL, 'GAMMA CLASS GLUTATHIONE TRANSFERASE EF1BGAMMA1', 241864),
(325751, 'PTHR44372:SF10', NULL, NULL, NULL, NULL, 'TRANSLATION ELONGATION FACTOR EF1B, GAMMA CHAIN', 241864),
(325752, 'PTHR34959:SF3', NULL, NULL, NULL, NULL, 'PROTEIN LAZY 1', 241865),
(325753, 'PTHR34959:SF4', NULL, NULL, NULL, NULL, 'PROTEIN LAZY 1', 241865),
(325754, 'PTHR34959', NULL, NULL, NULL, NULL, 'PROTEIN LAZY 1', 241865),
(325755, 'PTHR34959:SF12', NULL, NULL, NULL, NULL, 'BNAC07G49010D PROTEIN', 241865),
(325756, 'PTHR34959:SF13', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR-LIKE PROTEIN', 241865),
(325757, 'PTHR34959:SF11', NULL, NULL, NULL, NULL, '', 241865),
(325758, 'PTHR34959:SF7', NULL, NULL, NULL, NULL, '', 241865),
(325759, 'PTHR34959:SF8', NULL, NULL, NULL, NULL, 'BNAA02G28530D PROTEIN', 241865),
(325760, 'PTHR12390:SF0', NULL, NULL, NULL, NULL, 'UROPORPHYRINOGEN-III SYNTHASE', 241866),
(325761, 'PTHR12390', NULL, NULL, NULL, NULL, 'UROPORPHYRINOGEN III SYNTHASE', 241866),
(325762, 'PTHR12830:SF11', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT 5', 241867),
(325763, 'PTHR12830:SF10', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF SPINDLE CHECKPOINT DEFECT 1', 241867),
(325764, 'PTHR12830', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT 5', 241867);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(325765, 'PTHR12830:SF9', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT 5', 241867),
(325766, 'PTHR13218:SF16', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 11', 241868),
(325767, 'PTHR13218:SF15', NULL, NULL, NULL, NULL, 'TAF11-LIKE PROTEIN ENSP00000332601-RELATED', 241868),
(325768, 'PTHR13218:SF18', NULL, NULL, NULL, NULL, 'HCG1809904-RELATED', 241868),
(325769, 'PTHR13218:SF17', NULL, NULL, NULL, NULL, 'HCG1807616', 241868),
(325770, 'PTHR13218', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 11-RELATED', 241868),
(325771, 'PTHR13218:SF21', NULL, NULL, NULL, NULL, 'TAFII28 DOMAIN-CONTAINING PROTEIN', 241868),
(325772, 'PTHR13218:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 11', 241868),
(325773, 'PTHR13218:SF23', NULL, NULL, NULL, NULL, 'TAFII28 DOMAIN-CONTAINING PROTEIN', 241868),
(325774, 'PTHR13218:SF22', NULL, NULL, NULL, NULL, 'TAFII28 DOMAIN-CONTAINING PROTEIN', 241868),
(325775, 'PTHR13218:SF25', NULL, NULL, NULL, NULL, 'TAFII28-LIKE PROTEIN-RELATED', 241868),
(325776, 'PTHR13218:SF24', NULL, NULL, NULL, NULL, 'TAF11 RNA POLYMERASE II, TATA BOX BINDING PROTEIN (TBP)-ASSOCIATED FACTOR, 28KDA', 241868),
(325777, 'PTHR13774:SF40', NULL, NULL, NULL, NULL, 'OS03G0434400 PROTEIN', 241869),
(325778, 'PTHR13774:SF42', NULL, NULL, NULL, NULL, '', 241869),
(325779, 'PTHR13774:SF41', NULL, NULL, NULL, NULL, 'BNAC03G30570D PROTEIN', 241869),
(325780, 'PTHR13774:SF33', NULL, NULL, NULL, NULL, 'BNAC08G10830D PROTEIN', 241869),
(325781, 'PTHR13774:SF32', NULL, NULL, NULL, NULL, 'ANTISENSE-ENHANCING SEQUENCE 1', 241869),
(325782, 'PTHR13774:SF35', NULL, NULL, NULL, NULL, 'BNAA04G21450D PROTEIN', 241869),
(325783, 'PTHR13774:SF26', NULL, NULL, NULL, NULL, 'PHENAZINE BIOSYNTHESIS PHZC/PHZF PROTEIN', 241869),
(325784, 'PTHR13774:SF25', NULL, NULL, NULL, NULL, '', 241869),
(325785, 'PTHR13774:SF14', NULL, NULL, NULL, NULL, 'PROTEIN CBG03343', 241869),
(325786, 'PTHR13774:SF17', NULL, NULL, NULL, NULL, 'PHENAZINE BIOSYNTHESIS-LIKE DOMAIN-CONTAINING PROTEIN', 241869),
(325787, 'PTHR13774:SF39', NULL, NULL, NULL, NULL, 'BIOSYNTHESIS PROTEIN, PUTATIVE-RELATED', 241869),
(325788, 'PTHR13774:SF38', NULL, NULL, NULL, NULL, '', 241869),
(325789, 'PTHR13774:SF29', NULL, NULL, NULL, NULL, '', 241869),
(325790, 'PTHR13774', NULL, NULL, NULL, NULL, 'PHENAZINE BIOSYNTHESIS PROTEIN', 241869),
(325791, 'PTHR15670:SF4', NULL, NULL, NULL, NULL, 'INACTIVE RHO GTPASE-ACTIVATING PROTEIN 11B-RELATED', 241870),
(325792, 'PTHR15670', NULL, NULL, NULL, NULL, 'RHO GTPASE ACTIVATING PROTEIN 11A', 241870),
(325793, 'PTHR10121:SF3', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT DELTA-3', 241871),
(325794, 'PTHR10121:SF4', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT DELTA', 241871),
(325795, 'PTHR10121:SF5', NULL, NULL, NULL, NULL, 'MULTIFUNCTIONAL FUSION PROTEIN', 241871),
(325796, 'PTHR10121:SF6', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT DELTA', 241871),
(325797, 'PTHR10121:SF0', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT DELTA', 241871),
(325798, 'PTHR10121', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT DELTA', 241871),
(325799, 'PTHR30399', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN YGJP', 241872),
(325800, 'PTHR30399:SF5', NULL, NULL, NULL, NULL, 'SLR6103 PROTEIN', 241872),
(325801, 'PTHR30399:SF1', NULL, NULL, NULL, NULL, 'SLL8048 PROTEIN', 241872),
(325802, 'PTHR30399:SF4', NULL, NULL, NULL, NULL, 'UTP PYROPHOSPHATASE', 241872),
(325803, 'PTHR12389', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 294', 241873),
(325804, 'PTHR12389:SF0', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE LISTERIN', 241873),
(325805, 'PTHR12389:SF1', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 241873),
(325806, 'PTHR46629', NULL, NULL, NULL, NULL, 'OS01G0917900 PROTEIN', 241874),
(325807, 'PTHR46629:SF9', NULL, NULL, NULL, NULL, 'OS09G0505000 PROTEIN', 241874),
(325808, 'PTHR46629:SF5', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL UBIQUITIN LIGASE ACTIVATOR OF NFKB 1-LIKE', 241874),
(325809, 'PTHR46629:SF6', NULL, NULL, NULL, NULL, 'LON PEPTIDASE N-TERMINAL DOMAIN AND RING FINGER PROTEIN 3-LIKE', 241874);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(325810, 'PTHR46629:SF7', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 241874),
(325811, 'PTHR46629:SF31', NULL, NULL, NULL, NULL, '', 241874),
(325812, 'PTHR46629:SF10', NULL, NULL, NULL, NULL, 'F2401.10', 241874),
(325813, 'PTHR46629:SF32', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C2H2 FAMILY-RELATED', 241874),
(325814, 'PTHR46629:SF2', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 241874),
(325815, 'PTHR46629:SF30', NULL, NULL, NULL, NULL, 'ZINC FINGER, C3HC4 TYPE (RING FINGER) PROTEIN', 241874),
(325816, 'PTHR46629:SF13', NULL, NULL, NULL, NULL, 'OS01G0917900 PROTEIN', 241874),
(325817, 'PTHR46629:SF22', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 241874),
(325818, 'PTHR46629:SF33', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 241874),
(325819, 'PTHR46629:SF28', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 241874),
(325820, 'PTHR46629:SF17', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 241874),
(325821, 'PTHR46629:SF18', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 241874),
(325822, 'PTHR46629:SF29', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 241874),
(325823, 'PTHR23420:SF0', NULL, NULL, NULL, NULL, 'ADENOSYLHOMOCYSTEINASE', 241875),
(325824, 'PTHR23420:SF17', NULL, NULL, NULL, NULL, 'ADOHCYASE_NAD DOMAIN-CONTAINING PROTEIN', 241875),
(325825, 'PTHR23420:SF28', NULL, NULL, NULL, NULL, 'ADENOSYLHOMOCYSTEINASE', 241875),
(325826, 'PTHR23420:SF29', NULL, NULL, NULL, NULL, 'ADENOSYLHOMOCYSTEINASE 1', 241875),
(325827, 'PTHR23420:SF19', NULL, NULL, NULL, NULL, 'ADOHCYASE_NAD DOMAIN-CONTAINING PROTEIN', 241875),
(325828, 'PTHR23420:SF2', NULL, NULL, NULL, NULL, 'ADENOSYLHOMOCYSTEINASE 3', 241875),
(325829, 'PTHR23420:SF3', NULL, NULL, NULL, NULL, 'S-ADENOSYLHOMOCYSTEINE HYDROLASE-LIKE PROTEIN 1', 241875),
(325830, 'PTHR23420', NULL, NULL, NULL, NULL, 'ADENOSYLHOMOCYSTEINASE', 241875),
(325831, 'PTHR23420:SF30', NULL, NULL, NULL, NULL, 'ADENOSYLHOMOCYSTEINASE', 241875),
(325832, 'PTHR23420:SF26', NULL, NULL, NULL, NULL, 'ADENOSYLHOMOCYSTEINASE', 241875),
(325833, 'PTHR23420:SF27', NULL, NULL, NULL, NULL, 'ADENOSYLHOMOCYSTEINASE', 241875),
(325834, 'PTHR23420:SF16', NULL, NULL, NULL, NULL, 'ADENOSYLHOMOCYSTEINASE 2', 241875),
(325835, 'PTHR23420:SF20', NULL, NULL, NULL, NULL, 'ADENOSYLHOMOCYSTEINASE', 241875),
(325836, 'PTHR23420:SF21', NULL, NULL, NULL, NULL, 'ADENOSYLHOMOCYSTEINASE', 241875),
(325837, 'PTHR23420:SF22', NULL, NULL, NULL, NULL, 'ADENOSYLHOMOCYSTEINASE', 241875),
(325838, 'PTHR33696:SF23', NULL, NULL, NULL, NULL, 'OS03G0674900 PROTEIN', 241876),
(325839, 'PTHR33696:SF22', NULL, NULL, NULL, NULL, '', 241876),
(325840, 'PTHR33696:SF14', NULL, NULL, NULL, NULL, '', 241876),
(325841, 'PTHR33696:SF24', NULL, NULL, NULL, NULL, '', 241876),
(325842, 'PTHR33696:SF16', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241876),
(325843, 'PTHR33696:SF18', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241876),
(325844, 'PTHR33696:SF8', NULL, NULL, NULL, NULL, '', 241876),
(325845, 'PTHR33696:SF10', NULL, NULL, NULL, NULL, 'BNACNNG07700D PROTEIN', 241876),
(325846, 'PTHR33696:SF20', NULL, NULL, NULL, NULL, '', 241876),
(325847, 'PTHR33696:SF5', NULL, NULL, NULL, NULL, 'OS02G0551600 PROTEIN', 241876),
(325848, 'PTHR33696:SF6', NULL, NULL, NULL, NULL, '', 241876),
(325849, 'PTHR33696:SF1', NULL, NULL, NULL, NULL, 'T22J18.15', 241876),
(325850, 'PTHR33696:SF3', NULL, NULL, NULL, NULL, 'BNAA08G25910D PROTEIN', 241876),
(325851, 'PTHR33696', NULL, NULL, NULL, NULL, 'T22J18.15-RELATED', 241876),
(325852, 'PTHR14143', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCIBLE GTPASE FAMILY MEMBER', 241877),
(325853, 'PTHR14143:SF1', NULL, NULL, NULL, NULL, 'IRG-TYPE G DOMAIN-CONTAINING PROTEIN', 241877),
(325854, 'PTHR14143:SF2', NULL, NULL, NULL, NULL, 'IMMUNITY-RELATED GTPASE FAMILY, Q2', 241877),
(325855, 'PTHR14143:SF3', NULL, NULL, NULL, NULL, 'IRG-TYPE G DOMAIN-CONTAINING PROTEIN-RELATED', 241877),
(325856, 'PTHR31641:SF2', NULL, NULL, NULL, NULL, 'RENAL CANCER DIFFERENTIATION GENE 1 PROTEIN', 241878);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(325857, 'PTHR31641', NULL, NULL, NULL, NULL, 'RENAL CANCER DIFFERENTIATION GENE 1 PROTEIN', 241878),
(325858, 'PTHR43899:SF9', NULL, NULL, NULL, NULL, 'MIP25013P-RELATED', 241879),
(325859, 'PTHR43899:SF7', NULL, NULL, NULL, NULL, 'TESTOSTERONE 17-BETA-DEHYDROGENASE 3', 241879),
(325860, 'PTHR43899', NULL, NULL, NULL, NULL, 'RH59310P', 241879),
(325861, 'PTHR43899:SF4', NULL, NULL, NULL, NULL, '17 BETA-HYDROXYSTEROID DEHYDROGENASE TYPE 3', 241879),
(325862, 'PTHR43899:SF34', NULL, NULL, NULL, NULL, '', 241879),
(325863, 'PTHR43899:SF33', NULL, NULL, NULL, NULL, '', 241879),
(325864, 'PTHR43899:SF10', NULL, NULL, NULL, NULL, '20BETA-HYDROXYSTEROID DEHYDROGENASE TYPE 2', 241879),
(325865, 'PTHR43899:SF32', NULL, NULL, NULL, NULL, 'OS11G0432600 PROTEIN', 241879),
(325866, 'PTHR43899:SF31', NULL, NULL, NULL, NULL, '', 241879),
(325867, 'PTHR43899:SF38', NULL, NULL, NULL, NULL, 'OS06G0300200 PROTEIN', 241879),
(325868, 'PTHR43899:SF37', NULL, NULL, NULL, NULL, 'BETA-KETOACYL REDUCTASE 1-RELATED', 241879),
(325869, 'PTHR43899:SF36', NULL, NULL, NULL, NULL, '', 241879),
(325870, 'PTHR43899:SF14', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN 3-OXOACYL-COA REDUCTASE', 241879),
(325871, 'PTHR43899:SF35', NULL, NULL, NULL, NULL, 'OS06G0300000 PROTEIN', 241879),
(325872, 'PTHR43899:SF13', NULL, NULL, NULL, NULL, 'RH59310P', 241879),
(325873, 'PTHR43899:SF19', NULL, NULL, NULL, NULL, '', 241879),
(325874, 'PTHR43899:SF18', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN 3-OXOACYL-COA REDUCTASE-B', 241879),
(325875, 'PTHR43899:SF17', NULL, NULL, NULL, NULL, 'OS06G0299200 PROTEIN', 241879),
(325876, 'PTHR43899:SF22', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 241879),
(325877, 'PTHR43899:SF21', NULL, NULL, NULL, NULL, 'OS04G0116600 PROTEIN', 241879),
(325878, 'PTHR43899:SF20', NULL, NULL, NULL, NULL, '', 241879),
(325879, 'PTHR43899:SF27', NULL, NULL, NULL, NULL, 'B-KETO ACYL REDUCTASE-RELATED', 241879),
(325880, 'PTHR43899:SF26', NULL, NULL, NULL, NULL, 'ENOYL-(ACYL CARRIER) REDUCTASE', 241879),
(325881, 'PTHR43899:SF25', NULL, NULL, NULL, NULL, 'ENOYL-(ACYL CARRIER) REDUCTASE', 241879),
(325882, 'PTHR43899:SF24', NULL, NULL, NULL, NULL, '', 241879),
(325883, 'PTHR43899:SF29', NULL, NULL, NULL, NULL, '', 241879),
(325884, 'PTHR44154:SF1', NULL, NULL, NULL, NULL, 'QUINONE OXIDOREDUCTASE', 241880),
(325885, 'PTHR44154', NULL, NULL, NULL, NULL, 'QUINONE OXIDOREDUCTASE', 241880),
(325886, 'PTHR45679', NULL, NULL, NULL, NULL, 'ER DEGRADATION-ENHANCING ALPHA-MANNOSIDASE-LIKE PROTEIN 2', 241881),
(325887, 'PTHR45679:SF6', NULL, NULL, NULL, NULL, 'ER DEGRADATION-ENHANCING ALPHA-MANNOSIDASE-LIKE PROTEIN 2', 241881),
(325888, 'PTHR45679:SF5', NULL, NULL, NULL, NULL, 'ER DEGRADATION-ENHANCING ALPHA-MANNOSIDASE-LIKE PROTEIN 1', 241881),
(325889, 'PTHR45679:SF4', NULL, NULL, NULL, NULL, 'ALPHA-1,2-MANNOSIDASE', 241881),
(325890, 'PTHR45679:SF8', NULL, NULL, NULL, NULL, 'ALPHA-1,2-MANNOSIDASE', 241881),
(325891, 'PTHR45679:SF3', NULL, NULL, NULL, NULL, 'ALPHA-MANNOSIDASE I MNS5', 241881),
(325892, 'PTHR45679:SF2', NULL, NULL, NULL, NULL, 'ER DEGRADATION-ENHANCING ALPHA-MANNOSIDASE-LIKE PROTEIN 3', 241881),
(325893, 'PTHR45679:SF1', NULL, NULL, NULL, NULL, 'ALPHA-1,2-MANNOSIDASE', 241881),
(325894, 'PTHR47011:SF1', NULL, NULL, NULL, NULL, 'CD226 ANTIGEN', 241882),
(325895, 'PTHR47011', NULL, NULL, NULL, NULL, 'CD226 ANTIGEN', 241882),
(325896, 'PTHR33167:SF51', NULL, NULL, NULL, NULL, '', 241883),
(325897, 'PTHR33167:SF31', NULL, NULL, NULL, NULL, '', 241883),
(325898, 'PTHR33167:SF53', NULL, NULL, NULL, NULL, 'BNAA08G24890D PROTEIN', 241883),
(325899, 'PTHR33167:SF52', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241883),
(325900, 'PTHR33167:SF37', NULL, NULL, NULL, NULL, 'DUF863 FAMILY PROTEIN', 241883),
(325901, 'PTHR33167:SF36', NULL, NULL, NULL, NULL, 'BNAC08G40020D PROTEIN', 241883),
(325902, 'PTHR33167:SF33', NULL, NULL, NULL, NULL, 'ANCHOR PROTEIN 9, PUTATIVE ISOFORM 1-RELATED', 241883),
(325903, 'PTHR33167:SF56', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241883),
(325904, 'PTHR33167:SF19', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, PUTATIVE (DUF863)-RELATED', 241883);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(325905, 'PTHR33167:SF18', NULL, NULL, NULL, NULL, 'GB|AAF67766.1', 241883),
(325906, 'PTHR33167', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, PUTATIVE (DUF863)-RELATED', 241883),
(325907, 'PTHR33167:SF40', NULL, NULL, NULL, NULL, 'BNAA09G29050D PROTEIN', 241883),
(325908, 'PTHR33167:SF61', NULL, NULL, NULL, NULL, 'OS06G0694400 PROTEIN', 241883),
(325909, 'PTHR33167:SF64', NULL, NULL, NULL, NULL, 'F16A14.15', 241883),
(325910, 'PTHR33167:SF7', NULL, NULL, NULL, NULL, '', 241883),
(325911, 'PTHR33167:SF20', NULL, NULL, NULL, NULL, '', 241883),
(325912, 'PTHR33167:SF63', NULL, NULL, NULL, NULL, '', 241883),
(325913, 'PTHR33167:SF41', NULL, NULL, NULL, NULL, 'BNAA09G47370D PROTEIN', 241883),
(325914, 'PTHR33167:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241883),
(325915, 'PTHR33167:SF60', NULL, NULL, NULL, NULL, '', 241883),
(325916, 'PTHR33167:SF4', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, PUTATIVE (DUF863)-RELATED', 241883),
(325917, 'PTHR33167:SF26', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241883),
(325918, 'PTHR33167:SF48', NULL, NULL, NULL, NULL, '', 241883),
(325919, 'PTHR33167:SF47', NULL, NULL, NULL, NULL, 'BNAC03G57370D PROTEIN', 241883),
(325920, 'PTHR33167:SF25', NULL, NULL, NULL, NULL, '', 241883),
(325921, 'PTHR33167:SF66', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241883),
(325922, 'PTHR33167:SF44', NULL, NULL, NULL, NULL, 'BNAC02G16680D PROTEIN', 241883),
(325923, 'PTHR33167:SF43', NULL, NULL, NULL, NULL, '', 241883),
(325924, 'PTHR33167:SF65', NULL, NULL, NULL, NULL, '', 241883),
(325925, 'PTHR33167:SF67', NULL, NULL, NULL, NULL, '', 241883),
(325926, 'PTHR33167:SF29', NULL, NULL, NULL, NULL, 'T28K15.14 PROTEIN', 241883),
(325927, 'PTHR46140', NULL, NULL, NULL, NULL, 'VACUOLAR TRANSPORTER CHAPERONE 1-RELATED', 241884),
(325928, 'PTHR46140:SF1', NULL, NULL, NULL, NULL, 'VACUOLAR TRANSPORTER CHAPERONE 4', 241884),
(325929, 'PTHR46140:SF2', NULL, NULL, NULL, NULL, 'VACUOLAR TRANSPORTER CHAPERONE 2-RELATED', 241884),
(325930, 'PTHR31181:SF62', NULL, NULL, NULL, NULL, 'PROLAMIN-LIKE PROTEIN (DUF1278)', 241885),
(325931, 'PTHR31181:SF51', NULL, NULL, NULL, NULL, 'EGG CELL-SECRETED PROTEIN 1.4', 241885),
(325932, 'PTHR31181:SF73', NULL, NULL, NULL, NULL, 'EGG CELL-SECRETED PROTEIN 1.1', 241885),
(325933, 'PTHR31181:SF72', NULL, NULL, NULL, NULL, 'PROLAMIN_LIKE DOMAIN-CONTAINING PROTEIN', 241885),
(325934, 'PTHR31181:SF61', NULL, NULL, NULL, NULL, 'EGG CELL-SECRETED-LIKE PROTEIN (DUF1278)', 241885),
(325935, 'PTHR31181:SF71', NULL, NULL, NULL, NULL, 'PROLAMIN_LIKE DOMAIN-CONTAINING PROTEIN', 241885),
(325936, 'PTHR31181:SF60', NULL, NULL, NULL, NULL, 'PROLAMIN_LIKE DOMAIN-CONTAINING PROTEIN', 241885),
(325937, 'PTHR31181:SF82', NULL, NULL, NULL, NULL, 'PROLAMIN-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 241885),
(325938, 'PTHR31181:SF70', NULL, NULL, NULL, NULL, 'PROLAMIN_LIKE DOMAIN-CONTAINING PROTEIN', 241885),
(325939, 'PTHR31181:SF81', NULL, NULL, NULL, NULL, 'ECA1 GAMETOGENESIS FAMILY PROTEIN-RELATED', 241885),
(325940, 'PTHR31181:SF66', NULL, NULL, NULL, NULL, 'PROLAMIN_LIKE DOMAIN-CONTAINING PROTEIN', 241885),
(325941, 'PTHR31181:SF65', NULL, NULL, NULL, NULL, 'PROLAMIN_LIKE DOMAIN-CONTAINING PROTEIN', 241885),
(325942, 'PTHR31181:SF54', NULL, NULL, NULL, NULL, 'CYSTEINE RICH PEPTIDE-RELATED', 241885),
(325943, 'PTHR31181:SF76', NULL, NULL, NULL, NULL, 'PROLAMIN_LIKE DOMAIN-CONTAINING PROTEIN', 241885),
(325944, 'PTHR31181:SF53', NULL, NULL, NULL, NULL, 'EGG CELL-SECRETED-LIKE PROTEIN-RELATED', 241885),
(325945, 'PTHR31181:SF75', NULL, NULL, NULL, NULL, 'EGG CELL-SECRETED-LIKE PROTEIN (DUF1278)', 241885),
(325946, 'PTHR31181:SF64', NULL, NULL, NULL, NULL, 'ECA1 GAMETOGENESIS FAMILY PROTEIN-RELATED', 241885),
(325947, 'PTHR31181:SF52', NULL, NULL, NULL, NULL, 'EGG CELL-SECRETED PROTEIN 1.4-LIKE', 241885),
(325948, 'PTHR31181', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 241885),
(325949, 'PTHR31181:SF80', NULL, NULL, NULL, NULL, 'PROLAMIN_LIKE DOMAIN-CONTAINING PROTEIN', 241885),
(325950, 'PTHR31181:SF69', NULL, NULL, NULL, NULL, 'PROLAMIN_LIKE DOMAIN-CONTAINING PROTEIN', 241885);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(325951, 'PTHR31181:SF68', NULL, NULL, NULL, NULL, 'PROLAMIN_LIKE DOMAIN-CONTAINING PROTEIN', 241885),
(325952, 'PTHR31181:SF67', NULL, NULL, NULL, NULL, 'PROLAMIN-LIKE PROTEIN (DUF1278)', 241885),
(325953, 'PTHR48312:SF1', NULL, NULL, NULL, NULL, '', 241886),
(325954, 'PTHR48312', NULL, NULL, NULL, NULL, '', 241886),
(325955, 'PTHR15335:SF7', NULL, NULL, NULL, NULL, 'PROTEIN TFG', 241887),
(325956, 'PTHR15335', NULL, NULL, NULL, NULL, 'PROTEIN TFG', 241887),
(325957, 'PTHR10715:SF15', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L6E_N DOMAIN-CONTAINING PROTEIN', 241888),
(325958, 'PTHR10715:SF14', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L6E_N DOMAIN-CONTAINING PROTEIN', 241888),
(325959, 'PTHR10715:SF13', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L6E_N DOMAIN-CONTAINING PROTEIN', 241888),
(325960, 'PTHR10715:SF12', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L6E_N DOMAIN-CONTAINING PROTEIN', 241888),
(325961, 'PTHR10715:SF16', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L6', 241888),
(325962, 'PTHR10715:SF0', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L6', 241888),
(325963, 'PTHR10715', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L6', 241888),
(325964, 'PTHR10715:SF6', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L6', 241888),
(325965, 'PTHR10715:SF8', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L6', 241888),
(325966, 'PTHR10715:SF7', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L6', 241888),
(325967, 'PTHR10715:SF9', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L6', 241888),
(325968, 'PTHR10715:SF11', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L6', 241888),
(325969, 'PTHR10715:SF10', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L6-2-RELATED', 241888),
(325970, 'PTHR32125:SF4', NULL, NULL, NULL, NULL, '2-C-METHYL-D-ERYTHRITOL 4-PHOSPHATE CYTIDYLYLTRANSFERASE, CHLOROPLASTIC', 241889),
(325971, 'PTHR32125:SF8', NULL, NULL, NULL, NULL, 'RIBITOL-5-PHOSPHATE CYTIDYLYLTRANSFERASE', 241889),
(325972, 'PTHR32125', NULL, NULL, NULL, NULL, '2-C-METHYL-D-ERYTHRITOL 4-PHOSPHATE CYTIDYLYLTRANSFERASE, CHLOROPLASTIC', 241889),
(325973, 'PTHR12734:SF1', NULL, NULL, NULL, NULL, 'WBS_METHYLT DOMAIN-CONTAINING PROTEIN', 241890),
(325974, 'PTHR12734:SF0', NULL, NULL, NULL, NULL, '18S RRNA (GUANINE-N(7))-METHYLTRANSFERASE-RELATED', 241890),
(325975, 'PTHR12734', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE-RELATED', 241890),
(325976, 'PTHR28258:SF1', NULL, NULL, NULL, NULL, 'VACUOLAR SEGREGATION PROTEIN 7', 241891),
(325977, 'PTHR28258', NULL, NULL, NULL, NULL, 'VACUOLAR SEGREGATION PROTEIN 7', 241891),
(325978, 'PTHR48253', NULL, NULL, NULL, NULL, '', 241892),
(325979, 'PTHR48253:SF3', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 241892),
(325980, 'PTHR48253:SF2', NULL, NULL, NULL, NULL, '', 241892),
(325981, 'PTHR48253:SF1', NULL, NULL, NULL, NULL, 'DIOX_N DOMAIN-CONTAINING PROTEIN', 241892),
(325982, 'PTHR34687:SF3', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ-RELATED', 241893),
(325983, 'PTHR34687:SF4', NULL, NULL, NULL, NULL, 'BNAC09G17400D PROTEIN', 241893),
(325984, 'PTHR34687', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ-LIKE PROTEIN', 241893),
(325985, 'PTHR34687:SF1', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ-LIKE PROTEIN', 241893),
(325986, 'PTHR34687:SF2', NULL, NULL, NULL, NULL, 'OS04G0385900 PROTEIN', 241893),
(325987, 'PTHR31941:SF1', NULL, NULL, NULL, NULL, 'ACTIVATOR OF SKN7 PROTEIN 10-RELATED', 241894),
(325988, 'PTHR31941', NULL, NULL, NULL, NULL, 'CYTOSKELETAL SIGNALING PROTEIN SLM1', 241894),
(325989, 'PTHR31941:SF13', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4,5-BISPHOSPHATE-BINDING PROTEIN SLM1-RELATED', 241894),
(325990, 'PTHR31941:SF14', NULL, NULL, NULL, NULL, 'CYTOSKELETAL SIGNALING PROTEIN SLM1', 241894),
(325991, 'PTHR15496', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR 3C POLYPEPTIDE 4 FAMILY', 241895),
(325992, 'PTHR15496:SF2', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR 3C POLYPEPTIDE 4', 241895),
(325993, 'PTHR15496:SF5', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 241895);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(325994, 'PTHR42250', NULL, NULL, NULL, NULL, 'ASCH DOMAIN-CONTAINING PROTEIN', 241896),
(325995, 'PTHR42250:SF1', NULL, NULL, NULL, NULL, 'ASCH DOMAIN-CONTAINING PROTEIN', 241896),
(325996, 'PTHR46667:SF8', NULL, NULL, NULL, NULL, 'DUF1664 DOMAIN-CONTAINING PROTEIN', 241897),
(325997, 'PTHR46667:SF7', NULL, NULL, NULL, NULL, 'DUF1664 DOMAIN-CONTAINING PROTEIN', 241897),
(325998, 'PTHR46667:SF6', NULL, NULL, NULL, NULL, 'OS05G0182700 PROTEIN', 241897),
(325999, 'PTHR46667:SF1', NULL, NULL, NULL, NULL, 'OS09G0482740 PROTEIN', 241897),
(326000, 'PTHR46667:SF5', NULL, NULL, NULL, NULL, 'DUF1664 DOMAIN-CONTAINING PROTEIN', 241897),
(326001, 'PTHR46667:SF4', NULL, NULL, NULL, NULL, 'DUF1664 DOMAIN-CONTAINING PROTEIN', 241897),
(326002, 'PTHR46667', NULL, NULL, NULL, NULL, 'OS05G0182700 PROTEIN', 241897),
(326003, 'PTHR44936:SF5', NULL, NULL, NULL, NULL, 'SENSOR HISTIDINE KINASE ENVZ', 241898),
(326004, 'PTHR44936', NULL, NULL, NULL, NULL, 'SENSOR PROTEIN CREC', 241898),
(326005, 'PTHR44936:SF9', NULL, NULL, NULL, NULL, 'SENSOR PROTEIN RSTB', 241898),
(326006, 'PTHR44936:SF8', NULL, NULL, NULL, NULL, 'SENSOR PROTEIN CREC', 241898),
(326007, 'PTHR23505', NULL, NULL, NULL, NULL, 'SPINSTER', 241899),
(326008, 'PTHR23505:SF81', NULL, NULL, NULL, NULL, 'TETRACYCLINE RESISTANCE PROTEIN, CLASS B-LIKE', 241899),
(326009, 'PTHR23505:SF80', NULL, NULL, NULL, NULL, 'SPHINGOLIPID TRANSPORTER SPINSTER HOMOLOG 1-RELATED', 241899),
(326010, 'PTHR23505:SF83', NULL, NULL, NULL, NULL, 'SPHINGOLIPID TRANSPORTER SPINSTER HOMOLOG 2-RELATED', 241899),
(326011, 'PTHR23505:SF85', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY DOMAIN PROTEIN-RELATED', 241899),
(326012, 'PTHR23505:SF62', NULL, NULL, NULL, NULL, 'OS09G0371400 PROTEIN', 241899),
(326013, 'PTHR23505:SF84', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY DOMAIN PROTEIN-RELATED', 241899),
(326014, 'PTHR23505:SF76', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 241899),
(326015, 'PTHR23505:SF97', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY DOMAIN PROTEIN-RELATED', 241899),
(326016, 'PTHR23505:SF78', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN', 241899),
(326017, 'PTHR23505:SF55', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN', 241899),
(326018, 'PTHR23505:SF11', NULL, NULL, NULL, NULL, 'OS09G0371200 PROTEIN', 241899),
(326019, 'PTHR23505:SF58', NULL, NULL, NULL, NULL, 'PROTEIN SPINSTER-LIKE', 241899),
(326020, 'PTHR23505:SF13', NULL, NULL, NULL, NULL, 'PROTEIN SPINSTER HOMOLOG 1', 241899),
(326021, 'PTHR23505:SF79', NULL, NULL, NULL, NULL, 'SPHINGOLIPID TRANSPORTER SPINSTER HOMOLOG 3-RELATED', 241899),
(326022, 'PTHR23505:SF59', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN', 241899),
(326023, 'PTHR23505:SF1', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 241899),
(326024, 'PTHR23505:SF90', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 241899),
(326025, 'PTHR23505:SF70', NULL, NULL, NULL, NULL, 'OLIGOSACCHARIDE TRANSFERASE1', 241899),
(326026, 'PTHR23505:SF92', NULL, NULL, NULL, NULL, 'PROTEIN SPINSTER', 241899),
(326027, 'PTHR23505:SF91', NULL, NULL, NULL, NULL, 'SPHINGOLIPID TRANSPORTER SPINSTER HOMOLOG 2-RELATED', 241899),
(326028, 'PTHR23505:SF72', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 241899),
(326029, 'PTHR23505:SF52', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN', 241899),
(326030, 'PTHR23505:SF96', NULL, NULL, NULL, NULL, 'LP14756P', 241899),
(326031, 'PTHR23505:SF74', NULL, NULL, NULL, NULL, 'OS08G0409900 PROTEIN', 241899),
(326032, 'PTHR23505:SF73', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 241899),
(326033, 'PTHR23505:SF51', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 241899),
(326034, 'PTHR23505:SF9', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 241899),
(326035, 'PTHR23505:SF87', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN', 241899),
(326036, 'PTHR23505:SF65', NULL, NULL, NULL, NULL, 'OS08G0410500 PROTEIN', 241899),
(326037, 'PTHR23505:SF86', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN', 241899);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(326038, 'PTHR23505:SF64', NULL, NULL, NULL, NULL, 'PROTEIN SPINSTER-LIKE ISOFORM X1', 241899),
(326039, 'PTHR23505:SF67', NULL, NULL, NULL, NULL, 'PROTEIN SPINSTER HOMOLOG 3', 241899),
(326040, 'PTHR23505:SF88', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 241899),
(326041, 'PTHR23505:SF68', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN', 241899),
(326042, 'PTHR23505:SF4', NULL, NULL, NULL, NULL, 'PROTEIN SPINSTER HOMOLOG 2', 241899),
(326043, 'PTHR23505:SF3', NULL, NULL, NULL, NULL, 'PROTEIN SPINSTER HOMOLOG 3', 241899),
(326044, 'PTHR36893:SF1', NULL, NULL, NULL, NULL, '', 241900),
(326045, 'PTHR36893', NULL, NULL, NULL, NULL, 'OS01G0275950 PROTEIN', 241900),
(326046, 'PTHR10078:SF28', NULL, NULL, NULL, NULL, 'INTERLEUKIN-1 RECEPTOR ANTAGONIST PROTEIN', 241901),
(326047, 'PTHR10078:SF27', NULL, NULL, NULL, NULL, 'INTERLEUKIN-36 GAMMA', 241901),
(326048, 'PTHR10078:SF25', NULL, NULL, NULL, NULL, 'INTERLEUKIN-36 ALPHA', 241901),
(326049, 'PTHR10078:SF24', NULL, NULL, NULL, NULL, 'INTERLEUKIN-36 BETA', 241901),
(326050, 'PTHR10078:SF34', NULL, NULL, NULL, NULL, '', 241901),
(326051, 'PTHR10078:SF33', NULL, NULL, NULL, NULL, 'INTERLEUKIN-1 ALPHA', 241901),
(326052, 'PTHR10078:SF32', NULL, NULL, NULL, NULL, 'INTERLEUKIN-36 RECEPTOR ANTAGONIST PROTEIN', 241901),
(326053, 'PTHR10078:SF31', NULL, NULL, NULL, NULL, 'INTERLEUKIN-37', 241901),
(326054, 'PTHR10078', NULL, NULL, NULL, NULL, 'INTERLEUKIN-1 FAMILY MEMBER', 241901),
(326055, 'PTHR10078:SF30', NULL, NULL, NULL, NULL, 'INTERLEUKIN-1 BETA', 241901),
(326056, 'PTHR10078:SF29', NULL, NULL, NULL, NULL, 'INTERLEUKIN-1 FAMILY MEMBER 10', 241901),
(326057, 'PTHR12463:SF0', NULL, NULL, NULL, NULL, 'ALPHA-KETOGLUTARATE-DEPENDENT DIOXYGENASE ALKB HOMOLOG 4', 241902),
(326058, 'PTHR12463:SF1', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 241902),
(326059, 'PTHR12463', NULL, NULL, NULL, NULL, 'OXYGENASE-RELATED', 241902),
(326060, 'PTHR46425:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR RHO', 241903),
(326061, 'PTHR46425', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR RHO', 241903),
(326062, 'PTHR35842:SF1', NULL, NULL, NULL, NULL, 'SI:CH211-67E16.11', 241904),
(326063, 'PTHR35842', NULL, NULL, NULL, NULL, 'SI:CH211-67E16.11', 241904),
(326064, 'PTHR37492', NULL, NULL, NULL, NULL, 'SI:CH211-171H4.7-RELATED', 241905),
(326065, 'PTHR37492:SF4', NULL, NULL, NULL, NULL, 'SI:CH211-171H4.7-RELATED', 241905),
(326066, 'PTHR46587:SF8', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR DOMAIN-CONTAINING PROTEIN', 241906),
(326067, 'PTHR46587:SF7', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-19', 241906),
(326068, 'PTHR46587:SF6', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 241906),
(326069, 'PTHR46587:SF5', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 241906),
(326070, 'PTHR46587:SF4', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 241906),
(326071, 'PTHR46587:SF3', NULL, NULL, NULL, NULL, 'NR LBD DOMAIN-CONTAINING PROTEIN', 241906),
(326072, 'PTHR46587', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 241906),
(326073, 'PTHR46587:SF1', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY-RELATED', 241906),
(326074, 'PTHR31736:SF11', NULL, NULL, NULL, NULL, 'EXOPOLYGALACTURONASE C-RELATED', 241907),
(326075, 'PTHR31736:SF6', NULL, NULL, NULL, NULL, 'EXOPOLYGALACTURONASE B-RELATED', 241907),
(326076, 'PTHR31736:SF20', NULL, NULL, NULL, NULL, 'BNAANNG05300D PROTEIN', 241907),
(326077, 'PTHR31736', NULL, NULL, NULL, NULL, '', 241907),
(326078, 'PTHR31736:SF9', NULL, NULL, NULL, NULL, 'ENDO-XYLOGALACTURONAN HYDROLASE A-RELATED', 241907),
(326079, 'PTHR31736:SF14', NULL, NULL, NULL, NULL, 'EXOPOLYGALACTURONASE X-1-RELATED', 241907),
(326080, 'PTHR31736:SF12', NULL, NULL, NULL, NULL, 'EXO-POLYGALACTURONASE, PUTATIVE-RELATED', 241907),
(326081, 'PTHR31736:SF8', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_7G06410)-RELATED', 241907),
(326082, 'PTHR31736:SF19', NULL, NULL, NULL, NULL, 'PECTIN LYASE SUPERFAMILY PROTEIN-RELATED', 241907);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(326083, 'PTHR31736:SF18', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 241907),
(326084, 'PTHR15481:SF0', NULL, NULL, NULL, NULL, 'LD23870P-RELATED', 241908),
(326085, 'PTHR15481', NULL, NULL, NULL, NULL, 'RIBONUCLEIC ACID BINDING PROTEIN S1', 241908),
(326086, 'PTHR15481:SF6', NULL, NULL, NULL, NULL, 'OS05G0105900 PROTEIN', 241908),
(326087, 'PTHR15481:SF11', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 241908),
(326088, 'PTHR15481:SF2', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN WITH SERINE-RICH DOMAIN 1', 241908),
(326089, 'PTHR15481:SF5', NULL, NULL, NULL, NULL, 'SQUAMOUS CELL CARCINOMA ANTIGEN RECOGNIZED BY T-CELLS 3', 241908),
(326090, 'PTHR15481:SF10', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN WITH SERINE-RICH DOMAIN 1', 241908),
(326091, 'PTHR31816', NULL, NULL, NULL, NULL, 'MICOS COMPLEX SUBUNIT MIC13', 241909),
(326092, 'PTHR31816:SF3', NULL, NULL, NULL, NULL, 'MICOS COMPLEX SUBUNIT MIC13', 241909),
(326093, 'PTHR44094:SF17', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ 10', 241910),
(326094, 'PTHR44094:SF18', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 241910),
(326095, 'PTHR44094', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK N-TERMINAL DOMAIN-CONTAINING PROTEIN', 241910),
(326096, 'PTHR44094:SF14', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK N-TERMINAL DOMAIN-CONTAINING PROTEIN', 241910),
(326097, 'PTHR44094:SF22', NULL, NULL, NULL, NULL, 'OS09G0493800 PROTEIN', 241910),
(326098, 'PTHR44094:SF6', NULL, NULL, NULL, NULL, 'OS01G0702450 PROTEIN', 241910),
(326099, 'PTHR44094:SF11', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 241910),
(326100, 'PTHR44094:SF7', NULL, NULL, NULL, NULL, 'PROTEIN DNAJ, PUTATIVE-RELATED', 241910),
(326101, 'PTHR44094:SF8', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 241910),
(326102, 'PTHR44094:SF9', NULL, NULL, NULL, NULL, 'PROTEIN DNAJ, PUTATIVE-RELATED', 241910),
(326103, 'PTHR44094:SF21', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK N-TERMINAL DOMAIN-CONTAINING PROTEIN', 241910),
(326104, 'PTHR44094:SF19', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK N-TERMINAL DOMAIN-CONTAINING PROTEIN', 241910),
(326105, 'PTHR34039', NULL, NULL, NULL, NULL, 'UPF0102 PROTEIN YRAN', 241911),
(326106, 'PTHR34039:SF1', NULL, NULL, NULL, NULL, 'UPF0102 PROTEIN YRAN', 241911),
(326107, 'PTHR36473', NULL, NULL, NULL, NULL, 'CHROMOSOME 3 OPEN READING FRAME 49', 241912),
(326108, 'PTHR36473:SF1', NULL, NULL, NULL, NULL, 'GENE 11100-RELATED', 241912),
(326109, 'PTHR15296', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED PROTEIN MAP17', 241913),
(326110, 'PTHR15296:SF0', NULL, NULL, NULL, NULL, 'PDZK1-INTERACTING PROTEIN 1', 241913),
(326111, 'PTHR15296:SF1', NULL, NULL, NULL, NULL, 'PDZK1-INTERACTING PROTEIN 1-RELATED', 241913),
(326112, 'PTHR15296:SF2', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 24', 241913),
(326113, 'PTHR43404', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE CHOLINEPHOSPHOTRANSFERASE LICD', 241914),
(326114, 'PTHR43404:SF1', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE CHOLINEPHOSPHOTRANSFERASE LICD', 241914),
(326115, 'PTHR21557', NULL, NULL, NULL, NULL, 'CORDON-BLEU', 241915),
(326116, 'PTHR21557:SF2', NULL, NULL, NULL, NULL, 'CORDON-BLEU PROTEIN-LIKE 1', 241915),
(326117, 'PTHR39203:SF1', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 241916),
(326118, 'PTHR39203', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 241916),
(326119, 'PTHR31415:SF173', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 241917),
(326120, 'PTHR31415:SF9', NULL, NULL, NULL, NULL, 'OS05G0367900 PROTEIN', 241917),
(326121, 'PTHR31415:SF130', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 241917),
(326122, 'PTHR31415:SF174', NULL, NULL, NULL, NULL, 'NDR1/HIN1-LIKE PROTEIN 10', 241917),
(326123, 'PTHR31415:SF175', NULL, NULL, NULL, NULL, 'OS05G0203150 PROTEIN', 241917),
(326124, 'PTHR31415:SF170', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 241917),
(326125, 'PTHR31415:SF171', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN', 241917),
(326126, 'PTHR31415:SF172', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 241917); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(326127, 'PTHR31415:SF85', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY', 241917),
(326128, 'PTHR31415:SF3', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY', 241917),
(326129, 'PTHR31415:SF4', NULL, NULL, NULL, NULL, 'NDR1/HIN1-LIKE PROTEIN 3', 241917),
(326130, 'PTHR31415:SF82', NULL, NULL, NULL, NULL, '', 241917),
(326131, 'PTHR31415:SF81', NULL, NULL, NULL, NULL, 'OS09G0532200 PROTEIN', 241917),
(326132, 'PTHR31415:SF6', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 241917),
(326133, 'PTHR31415:SF7', NULL, NULL, NULL, NULL, 'OS08G0102700 PROTEIN', 241917),
(326134, 'PTHR31415:SF80', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 241917),
(326135, 'PTHR31415:SF8', NULL, NULL, NULL, NULL, 'HARPIN INDUCED PROTEIN 5', 241917),
(326136, 'PTHR31415:SF78', NULL, NULL, NULL, NULL, 'OS07G0250501 PROTEIN', 241917),
(326137, 'PTHR31415:SF76', NULL, NULL, NULL, NULL, 'YLS9', 241917),
(326138, 'PTHR31415:SF139', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY-RELATED', 241917),
(326139, 'PTHR31415:SF133', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 241917),
(326140, 'PTHR31415:SF136', NULL, NULL, NULL, NULL, 'BNAA03G55330D PROTEIN', 241917),
(326141, 'PTHR31415:SF140', NULL, NULL, NULL, NULL, '', 241917),
(326142, 'PTHR31415:SF141', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 241917),
(326143, 'PTHR31415:SF142', NULL, NULL, NULL, NULL, '', 241917),
(326144, 'PTHR31415:SF53', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 241917),
(326145, 'PTHR31415:SF96', NULL, NULL, NULL, NULL, 'NDR1/HIN1-LIKE PROTEIN 2', 241917),
(326146, 'PTHR31415:SF52', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY-RELATED', 241917),
(326147, 'PTHR31415:SF51', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN-RELATED', 241917),
(326148, 'PTHR31415:SF95', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 241917),
(326149, 'PTHR31415:SF91', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY', 241917),
(326150, 'PTHR31415:SF90', NULL, NULL, NULL, NULL, 'NDR1/HIN1-LIKE PROTEIN 3-LIKE', 241917),
(326151, 'PTHR31415', NULL, NULL, NULL, NULL, 'OS05G0367900 PROTEIN', 241917),
(326152, 'PTHR31415:SF89', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 241917),
(326153, 'PTHR31415:SF109', NULL, NULL, NULL, NULL, 'NDR1/HIN1-LIKE PROTEIN 3', 241917),
(326154, 'PTHR31415:SF104', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 241917),
(326155, 'PTHR31415:SF106', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 241917),
(326156, 'PTHR31415:SF100', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 241917),
(326157, 'PTHR31415:SF101', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN', 241917),
(326158, 'PTHR31415:SF146', NULL, NULL, NULL, NULL, 'NDR1-LIKE PROTEIN', 241917),
(326159, 'PTHR31415:SF147', NULL, NULL, NULL, NULL, 'OS01G0864500 PROTEIN', 241917),
(326160, 'PTHR31415:SF151', NULL, NULL, NULL, NULL, '', 241917),
(326161, 'PTHR31415:SF152', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 241917),
(326162, 'PTHR31415:SF150', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 241917),
(326163, 'PTHR31415:SF20', NULL, NULL, NULL, NULL, 'NDR1/HIN1-LIKE PROTEIN 26', 241917),
(326164, 'PTHR31415:SF64', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 241917),
(326165, 'PTHR31415:SF62', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN', 241917),
(326166, 'PTHR31415:SF61', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN', 241917),
(326167, 'PTHR31415:SF60', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 241917),
(326168, 'PTHR31415:SF16', NULL, NULL, NULL, NULL, 'HARPIN-INDUCED PROTEIN 1 CONTAINING PROTEIN', 241917),
(326169, 'PTHR31415:SF15', NULL, NULL, NULL, NULL, 'OS02G0538700 PROTEIN', 241917);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(326170, 'PTHR31415:SF59', NULL, NULL, NULL, NULL, 'HARPIN-INDUCED 1', 241917),
(326171, 'PTHR31415:SF58', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 241917),
(326172, 'PTHR31415:SF119', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 241917),
(326173, 'PTHR31415:SF12', NULL, NULL, NULL, NULL, 'OS04G0416700 PROTEIN', 241917),
(326174, 'PTHR31415:SF98', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 241917),
(326175, 'PTHR31415:SF54', NULL, NULL, NULL, NULL, 'HARPIN-INDUCED PROTEIN 1 CONTAINING PROTEIN', 241917),
(326176, 'PTHR31415:SF115', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 241917),
(326177, 'PTHR31415:SF159', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY', 241917),
(326178, 'PTHR31415:SF116', NULL, NULL, NULL, NULL, '', 241917),
(326179, 'PTHR31415:SF118', NULL, NULL, NULL, NULL, 'OS04G0685300 PROTEIN', 241917),
(326180, 'PTHR31415:SF112', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 241917),
(326181, 'PTHR31415:SF156', NULL, NULL, NULL, NULL, 'OS01G0864300 PROTEIN', 241917),
(326182, 'PTHR31415:SF157', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 241917),
(326183, 'PTHR31415:SF162', NULL, NULL, NULL, NULL, 'OS07G0250900 PROTEIN', 241917),
(326184, 'PTHR31415:SF163', NULL, NULL, NULL, NULL, 'PROTEIN YLS9-LIKE', 241917),
(326185, 'PTHR31415:SF165', NULL, NULL, NULL, NULL, 'HIN1', 241917),
(326186, 'PTHR31415:SF121', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 241917),
(326187, 'PTHR31415:SF161', NULL, NULL, NULL, NULL, 'NDR1/HIN1-LIKE PROTEIN 3-LIKE', 241917),
(326188, 'PTHR31415:SF75', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 241917),
(326189, 'PTHR31415:SF74', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY-RELATED', 241917),
(326190, 'PTHR31415:SF71', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 241917),
(326191, 'PTHR31415:SF68', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY', 241917),
(326192, 'PTHR31415:SF67', NULL, NULL, NULL, NULL, 'OS04G0114300 PROTEIN', 241917),
(326193, 'PTHR31415:SF66', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT HYDROXYPROLINE-RICH GLYCOPROTEIN', 241917),
(326194, 'PTHR31415:SF21', NULL, NULL, NULL, NULL, 'OS08G0102551 PROTEIN', 241917),
(326195, 'PTHR31415:SF126', NULL, NULL, NULL, NULL, '', 241917),
(326196, 'PTHR31415:SF127', NULL, NULL, NULL, NULL, 'PROTEIN YLS9-LIKE', 241917),
(326197, 'PTHR31415:SF129', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY-RELATED', 241917),
(326198, 'PTHR31415:SF166', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY', 241917),
(326199, 'PTHR31415:SF122', NULL, NULL, NULL, NULL, 'OS01G0864632 PROTEIN', 241917),
(326200, 'PTHR31415:SF123', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 241917),
(326201, 'PTHR31415:SF167', NULL, NULL, NULL, NULL, 'VAMP PROTEIN SEC22', 241917),
(326202, 'PTHR31415:SF168', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 241917),
(326203, 'PTHR31415:SF124', NULL, NULL, NULL, NULL, 'OS07G0531500 PROTEIN', 241917),
(326204, 'PTHR31415:SF125', NULL, NULL, NULL, NULL, 'PROTEIN NDR1-LIKE', 241917),
(326205, 'PTHR31415:SF169', NULL, NULL, NULL, NULL, 'OS04G0628300 PROTEIN', 241917),
(326206, 'PTHR10177:SF71', NULL, NULL, NULL, NULL, 'G1/S-SPECIFIC CYCLIN-E1', 241918),
(326207, 'PTHR10177:SF70', NULL, NULL, NULL, NULL, 'G1/S-SPECIFIC CYCLIN-E2', 241918),
(326208, 'PTHR10177:SF419', NULL, NULL, NULL, NULL, 'CYCLIN-B1-5', 241918),
(326209, 'PTHR10177:SF418', NULL, NULL, NULL, NULL, 'CYCLIN-D5-1', 241918),
(326210, 'PTHR10177:SF416', NULL, NULL, NULL, NULL, 'CYCLIN-A1-2', 241918),
(326211, 'PTHR10177:SF533', NULL, NULL, NULL, NULL, 'CYCLIN-D3-2', 241918),
(326212, 'PTHR10177:SF378', NULL, NULL, NULL, NULL, 'B-LIKE CYCLIN', 241918),
(326213, 'PTHR10177:SF532', NULL, NULL, NULL, NULL, 'CYCLIN-B1-2-RELATED', 241918); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(326214, 'PTHR10177:SF257', NULL, NULL, NULL, NULL, 'CYCLIN-P', 241918),
(326215, 'PTHR10177:SF531', NULL, NULL, NULL, NULL, 'CYCLIN-A2-1-RELATED', 241918),
(326216, 'PTHR10177:SF496', NULL, NULL, NULL, NULL, 'CYCLIN-F', 241918),
(326217, 'PTHR10177:SF254', NULL, NULL, NULL, NULL, 'CYCLIN-A1', 241918),
(326218, 'PTHR10177:SF253', NULL, NULL, NULL, NULL, 'CYCLIN-B1-4', 241918),
(326219, 'PTHR10177:SF372', NULL, NULL, NULL, NULL, 'CYCLIN-B1-3', 241918),
(326220, 'PTHR10177:SF493', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 241918),
(326221, 'PTHR10177:SF492', NULL, NULL, NULL, NULL, 'BNAA03G57140D PROTEIN', 241918),
(326222, 'PTHR10177:SF491', NULL, NULL, NULL, NULL, 'B-LIKE CYCLIN', 241918),
(326223, 'PTHR10177:SF67', NULL, NULL, NULL, NULL, 'G1/S-SPECIFIC CYCLIN-D1', 241918),
(326224, 'PTHR10177:SF66', NULL, NULL, NULL, NULL, 'G1/S-SPECIFIC CYCLIN-D2', 241918),
(326225, 'PTHR10177:SF65', NULL, NULL, NULL, NULL, 'G1/S-SPECIFIC CYCLIN-D3', 241918),
(326226, 'PTHR10177:SF60', NULL, NULL, NULL, NULL, 'CYCLIN-G2', 241918),
(326227, 'PTHR10177:SF409', NULL, NULL, NULL, NULL, 'CYCLIN-B3-1-RELATED', 241918),
(326228, 'PTHR10177:SF63', NULL, NULL, NULL, NULL, 'CYCLIN-J-LIKE PROTEIN', 241918),
(326229, 'PTHR10177:SF62', NULL, NULL, NULL, NULL, 'CYCLIN-J', 241918),
(326230, 'PTHR10177:SF527', NULL, NULL, NULL, NULL, 'CYCLIN D, ISOFORM D', 241918),
(326231, 'PTHR10177:SF405', NULL, NULL, NULL, NULL, 'CYCLIN-D7-1-RELATED', 241918),
(326232, 'PTHR10177:SF525', NULL, NULL, NULL, NULL, '', 241918),
(326233, 'PTHR10177:SF523', NULL, NULL, NULL, NULL, 'G1/S-SPECIFIC CYCLIN CLN1-RELATED', 241918),
(326234, 'PTHR10177:SF402', NULL, NULL, NULL, NULL, 'CYCLIN-B2-4', 241918),
(326235, 'PTHR10177:SF489', NULL, NULL, NULL, NULL, 'BNAA06G10270D PROTEIN', 241918),
(326236, 'PTHR10177:SF401', NULL, NULL, NULL, NULL, 'CYCLIN-O', 241918),
(326237, 'PTHR10177:SF400', NULL, NULL, NULL, NULL, 'CYCLIN-D5-1', 241918),
(326238, 'PTHR10177:SF521', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 241918),
(326239, 'PTHR10177:SF487', NULL, NULL, NULL, NULL, 'BNAA09G56610D PROTEIN', 241918),
(326240, 'PTHR10177:SF520', NULL, NULL, NULL, NULL, 'G2/MITOTIC-SPECIFIC CYCLIN-1-RELATED', 241918),
(326241, 'PTHR10177:SF486', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 241918),
(326242, 'PTHR10177:SF363', NULL, NULL, NULL, NULL, 'CYCLIN D3', 241918),
(326243, 'PTHR10177:SF483', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 241918),
(326244, 'PTHR10177:SF240', NULL, NULL, NULL, NULL, 'CYCLIN-D6-1', 241918),
(326245, 'PTHR10177:SF482', NULL, NULL, NULL, NULL, 'CYCLIN DOMAIN-CONTAINING PROTEIN', 241918),
(326246, 'PTHR10177:SF439', NULL, NULL, NULL, NULL, 'CYCLIN D3,2-RELATED', 241918),
(326247, 'PTHR10177:SF559', NULL, NULL, NULL, NULL, 'G2/MITOTIC-SPECIFIC CYCLIN-B', 241918),
(326248, 'PTHR10177:SF558', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 241918),
(326249, 'PTHR10177:SF557', NULL, NULL, NULL, NULL, 'CYCLIN A-LIKE PROTEIN', 241918),
(326250, 'PTHR10177:SF435', NULL, NULL, NULL, NULL, 'CYCLIN-A2-3', 241918),
(326251, 'PTHR10177:SF556', NULL, NULL, NULL, NULL, 'A-TYPE CYCLIN', 241918),
(326252, 'PTHR10177:SF555', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 241918),
(326253, 'PTHR10177:SF434', NULL, NULL, NULL, NULL, 'CYCLIN-A2-4', 241918),
(326254, 'PTHR10177:SF433', NULL, NULL, NULL, NULL, 'B-LIKE CYCLIN', 241918),
(326255, 'PTHR10177:SF554', NULL, NULL, NULL, NULL, 'CYCLIN-D2-1', 241918),
(326256, 'PTHR10177:SF553', NULL, NULL, NULL, NULL, 'G1/S-SPECIFIC CYCLIN CLN3', 241918),
(326257, 'PTHR10177:SF398', NULL, NULL, NULL, NULL, 'CYCLIN-D3-3', 241918),
(326258, 'PTHR10177:SF552', NULL, NULL, NULL, NULL, 'CYCLIN-A3-2', 241918),
(326259, 'PTHR10177:SF397', NULL, NULL, NULL, NULL, 'CYCLIN-D6-1 ISOFORM X1-RELATED', 241918),
(326260, 'PTHR10177:SF430', NULL, NULL, NULL, NULL, 'CYCLIN A2, CHORDATE-RELATED', 241918),
(326261, 'PTHR10177:SF551', NULL, NULL, NULL, NULL, 'CYCLIN-A1-1', 241918);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(326262, 'PTHR10177:SF550', NULL, NULL, NULL, NULL, 'CYCLIN, N-TERMINAL DOMAIN CONTAINING PROTEIN', 241918),
(326263, 'PTHR10177:SF392', NULL, NULL, NULL, NULL, 'CYCLIN-D1-1', 241918),
(326264, 'PTHR10177:SF391', NULL, NULL, NULL, NULL, '', 241918),
(326265, 'PTHR10177:SF429', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 241918),
(326266, 'PTHR10177:SF549', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 241918),
(326267, 'PTHR10177:SF427', NULL, NULL, NULL, NULL, 'CYCLIN-D3-2', 241918),
(326268, 'PTHR10177:SF548', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 241918),
(326269, 'PTHR10177:SF547', NULL, NULL, NULL, NULL, 'CYCLIN-D4-1-LIKE', 241918),
(326270, 'PTHR10177:SF426', NULL, NULL, NULL, NULL, 'G2/MITOTIC-SPECIFIC CYCLIN-1-LIKE', 241918),
(326271, 'PTHR10177:SF425', NULL, NULL, NULL, NULL, 'CYCLIN-J18', 241918),
(326272, 'PTHR10177:SF546', NULL, NULL, NULL, NULL, 'G2/MITOTIC-SPECIFIC CYCLIN C13-1-RELATED', 241918),
(326273, 'PTHR10177:SF545', NULL, NULL, NULL, NULL, 'G2/MITOTIC-SPECIFIC CYCLIN S13-7-LIKE', 241918),
(326274, 'PTHR10177:SF544', NULL, NULL, NULL, NULL, 'CYCLIN-D3-2-LIKE', 241918),
(326275, 'PTHR10177:SF543', NULL, NULL, NULL, NULL, 'CYCLIN-LIKE PROTEIN-RELATED', 241918),
(326276, 'PTHR10177:SF389', NULL, NULL, NULL, NULL, 'SUPERFAMILY PROTEIN, PUTATIVE-RELATED', 241918),
(326277, 'PTHR10177:SF542', NULL, NULL, NULL, NULL, 'G2/MITOTIC-SPECIFIC CYCLIN-2-LIKE', 241918),
(326278, 'PTHR10177:SF388', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 241918),
(326279, 'PTHR10177:SF387', NULL, NULL, NULL, NULL, 'CYCLIN-A3-4', 241918),
(326280, 'PTHR10177:SF541', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 241918),
(326281, 'PTHR10177:SF540', NULL, NULL, NULL, NULL, 'G2/MITOTIC-SPECIFIC CYCLIN-2-LIKE', 241918),
(326282, 'PTHR10177:SF386', NULL, NULL, NULL, NULL, 'CYCLIN-A3-2-RELATED', 241918),
(326283, 'PTHR10177:SF385', NULL, NULL, NULL, NULL, 'CYCLIN-A1-4', 241918),
(326284, 'PTHR10177:SF384', NULL, NULL, NULL, NULL, 'CYCLIN-D3-1', 241918),
(326285, 'PTHR10177:SF262', NULL, NULL, NULL, NULL, '', 241918),
(326286, 'PTHR10177:SF261', NULL, NULL, NULL, NULL, 'CYCLIN-B2-2', 241918),
(326287, 'PTHR10177:SF459', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 241918),
(326288, 'PTHR10177:SF338', NULL, NULL, NULL, NULL, 'CYCLIN-B2-2', 241918),
(326289, 'PTHR10177:SF579', NULL, NULL, NULL, NULL, 'CYCLIN-LIKE PROTEIN-RELATED', 241918),
(326290, 'PTHR10177:SF578', NULL, NULL, NULL, NULL, 'CYCLIN-LIKE, CYCLIN A, PLANT-RELATED', 241918),
(326291, 'PTHR10177:SF457', NULL, NULL, NULL, NULL, 'CYCLIN-D4-2', 241918),
(326292, 'PTHR10177:SF456', NULL, NULL, NULL, NULL, 'OS02G0600266 PROTEIN', 241918),
(326293, 'PTHR10177:SF214', NULL, NULL, NULL, NULL, 'G2/MITOTIC-SPECIFIC CYCLIN-B3', 241918),
(326294, 'PTHR10177:SF577', NULL, NULL, NULL, NULL, 'CYCLIN-D4-1', 241918),
(326295, 'PTHR10177:SF576', NULL, NULL, NULL, NULL, 'B-LIKE CYCLIN', 241918),
(326296, 'PTHR10177:SF575', NULL, NULL, NULL, NULL, 'CYCLIN DOMAIN-CONTAINING PROTEIN', 241918),
(326297, 'PTHR10177:SF574', NULL, NULL, NULL, NULL, 'G2/MITOTIC-SPECIFIC CYCLIN S13-7-LIKE', 241918),
(326298, 'PTHR10177:SF453', NULL, NULL, NULL, NULL, 'CYCLIN-LIKE PROTEIN-RELATED', 241918),
(326299, 'PTHR10177:SF210', NULL, NULL, NULL, NULL, 'AGAP002532-PA', 241918),
(326300, 'PTHR10177:SF573', NULL, NULL, NULL, NULL, 'B-LIKE CYCLIN', 241918),
(326301, 'PTHR10177:SF572', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 241918),
(326302, 'PTHR10177:SF450', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 241918),
(326303, 'PTHR10177:SF571', NULL, NULL, NULL, NULL, 'CYCLIN-D1-1', 241918),
(326304, 'PTHR10177:SF570', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 241918),
(326305, 'PTHR10177:SF207', NULL, NULL, NULL, NULL, 'CYCLIN-D2-3-RELATED', 241918),
(326306, 'PTHR10177:SF569', NULL, NULL, NULL, NULL, 'CYCLIN-D4-2-LIKE ISOFORM X1', 241918),
(326307, 'PTHR10177:SF568', NULL, NULL, NULL, NULL, 'CYCLIN A2,3-RELATED', 241918);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(326308, 'PTHR10177:SF447', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 241918),
(326309, 'PTHR10177:SF567', NULL, NULL, NULL, NULL, 'B-LIKE CYCLIN', 241918),
(326310, 'PTHR10177:SF203', NULL, NULL, NULL, NULL, 'MEIOSIS-SPECIFIC CYCLIN CRS1', 241918),
(326311, 'PTHR10177:SF566', NULL, NULL, NULL, NULL, 'CYCLIN DOMAIN-CONTAINING PROTEIN', 241918),
(326312, 'PTHR10177:SF565', NULL, NULL, NULL, NULL, 'BNAA02G19780D PROTEIN', 241918),
(326313, 'PTHR10177:SF202', NULL, NULL, NULL, NULL, 'CYCLIN-SDS', 241918),
(326314, 'PTHR10177:SF444', NULL, NULL, NULL, NULL, 'CYCLIN-A2', 241918),
(326315, 'PTHR10177:SF564', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 241918),
(326316, 'PTHR10177:SF563', NULL, NULL, NULL, NULL, 'CYCLIN-F2-2', 241918),
(326317, 'PTHR10177:SF441', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 241918),
(326318, 'PTHR10177:SF562', NULL, NULL, NULL, NULL, 'CYCLIN-B1-1', 241918),
(326319, 'PTHR10177:SF561', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 241918),
(326320, 'PTHR10177', NULL, NULL, NULL, NULL, 'CYCLINS', 241918),
(326321, 'PTHR10177:SF560', NULL, NULL, NULL, NULL, 'CYCLIN DOMAIN-CONTAINING PROTEIN', 241918),
(326322, 'PTHR10177:SF57', NULL, NULL, NULL, NULL, 'CYCLIN-I2', 241918),
(326323, 'PTHR10177:SF59', NULL, NULL, NULL, NULL, 'CYCLIN-G1', 241918),
(326324, 'PTHR10177:SF519', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 241918),
(326325, 'PTHR10177:SF518', NULL, NULL, NULL, NULL, 'G2/MITOTIC-SPECIFIC CYCLIN S13-7-LIKE ISOFORM X1', 241918),
(326326, 'PTHR10177:SF514', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 241918),
(326327, 'PTHR10177:SF512', NULL, NULL, NULL, NULL, 'CYCLIN-D5-1-LIKE', 241918),
(326328, 'PTHR10177:SF511', NULL, NULL, NULL, NULL, 'CYCLIN-D3-3-LIKE ISOFORM X1', 241918),
(326329, 'PTHR10177:SF478', NULL, NULL, NULL, NULL, 'B-LIKE CYCLIN', 241918),
(326330, 'PTHR10177:SF477', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 241918),
(326331, 'PTHR10177:SF235', NULL, NULL, NULL, NULL, 'CYCLIN-D2-2', 241918),
(326332, 'PTHR10177:SF476', NULL, NULL, NULL, NULL, 'BNAC06G40620D PROTEIN', 241918),
(326333, 'PTHR10177:SF475', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 241918),
(326334, 'PTHR10177:SF474', NULL, NULL, NULL, NULL, 'CYCLIN-D4-1-LIKE', 241918),
(326335, 'PTHR10177:SF231', NULL, NULL, NULL, NULL, 'CYCLIN-F3-2-RELATED', 241918),
(326336, 'PTHR10177:SF198', NULL, NULL, NULL, NULL, 'CYCLIN B', 241918),
(326337, 'PTHR10177:SF472', NULL, NULL, NULL, NULL, 'G2/MITOTIC-SPECIFIC CYCLIN-3-RELATED', 241918),
(326338, 'PTHR10177:SF470', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 241918),
(326339, 'PTHR10177:SF193', NULL, NULL, NULL, NULL, 'G2/MITOTIC-SPECIFIC CYCLIN-B1', 241918),
(326340, 'PTHR10177:SF505', NULL, NULL, NULL, NULL, 'B-LIKE CYCLIN', 241918),
(326341, 'PTHR10177:SF504', NULL, NULL, NULL, NULL, 'CYCLIN-A3-1-RELATED', 241918),
(326342, 'PTHR10177:SF503', NULL, NULL, NULL, NULL, '', 241918),
(326343, 'PTHR10177:SF469', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 241918),
(326344, 'PTHR10177:SF227', NULL, NULL, NULL, NULL, 'B-LIKE CYCLIN', 241918),
(326345, 'PTHR10177:SF502', NULL, NULL, NULL, NULL, 'CYCLIN_C DOMAIN-CONTAINING PROTEIN', 241918),
(326346, 'PTHR10177:SF347', NULL, NULL, NULL, NULL, 'CYCLIN J, ISOFORM A-RELATED', 241918),
(326347, 'PTHR10177:SF500', NULL, NULL, NULL, NULL, 'CYCLIN-B2-3-RELATED', 241918),
(326348, 'PTHR10177:SF344', NULL, NULL, NULL, NULL, 'G1/S-SPECIFIC CYCLIN-E', 241918),
(326349, 'PTHR10177:SF586', NULL, NULL, NULL, NULL, 'CYCLIN-D4-1', 241918),
(326350, 'PTHR10177:SF585', NULL, NULL, NULL, NULL, 'B-LIKE CYCLIN', 241918),
(326351, 'PTHR10177:SF188', NULL, NULL, NULL, NULL, 'CYCLIN-D6-1-RELATED', 241918),
(326352, 'PTHR10177:SF584', NULL, NULL, NULL, NULL, 'CYCLIN G', 241918),
(326353, 'PTHR10177:SF463', NULL, NULL, NULL, NULL, 'CYCLIN-B2-1', 241918),
(326354, 'PTHR10177:SF462', NULL, NULL, NULL, NULL, 'CYCLIN-D4-1-RELATED', 241918);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(326355, 'PTHR10177:SF583', NULL, NULL, NULL, NULL, 'G2/MITOTIC-SPECIFIC CYCLIN-A', 241918),
(326356, 'PTHR10177:SF187', NULL, NULL, NULL, NULL, 'CYCLIN-I', 241918),
(326357, 'PTHR10177:SF461', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 241918),
(326358, 'PTHR10177:SF582', NULL, NULL, NULL, NULL, 'B-LIKE CYCLIN', 241918),
(326359, 'PTHR10177:SF581', NULL, NULL, NULL, NULL, 'G2/MITOTIC-SPECIFIC CYCLIN CIG2', 241918),
(326360, 'PTHR10177:SF460', NULL, NULL, NULL, NULL, 'CYCLIN-D5-2', 241918),
(326361, 'PTHR10177:SF580', NULL, NULL, NULL, NULL, 'CYCLIN-A1-1', 241918),
(326362, 'PTHR10177:SF184', NULL, NULL, NULL, NULL, 'G2/MITOTIC-SPECIFIC CYCLIN-B2', 241918),
(326363, 'PTHR23358:SF3', NULL, NULL, NULL, NULL, 'METHYLCYTOSINE DIOXYGENASE TET2', 241919),
(326364, 'PTHR23358:SF2', NULL, NULL, NULL, NULL, 'METHYLCYTOSINE DIOXYGENASE TET1', 241919),
(326365, 'PTHR23358:SF4', NULL, NULL, NULL, NULL, 'METHYLCYTOSINE DIOXYGENASE TET3', 241919),
(326366, 'PTHR23358', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 241919),
(326367, 'PTHR23358:SF6', NULL, NULL, NULL, NULL, 'DNA N6-METHYL ADENINE DEMETHYLASE', 241919),
(326368, 'PTHR23409:SF37', NULL, NULL, NULL, NULL, '', 241920),
(326369, 'PTHR23409:SF36', NULL, NULL, NULL, NULL, 'R2-LIKE LIGAND BINDING OXIDASE', 241920),
(326370, 'PTHR23409:SF35', NULL, NULL, NULL, NULL, 'RIBONUCLEOSIDE-DIPHOSPHATE REDUCTASE SMALL CHAIN A', 241920),
(326371, 'PTHR23409', NULL, NULL, NULL, NULL, 'RIBONUCLEOSIDE-DIPHOSPHATE REDUCTASE SMALL CHAIN', 241920),
(326372, 'PTHR23409:SF19', NULL, NULL, NULL, NULL, 'RIBONUCLEOSIDE-DIPHOSPHATE REDUCTASE SUBUNIT M2 B', 241920),
(326373, 'PTHR23409:SF18', NULL, NULL, NULL, NULL, 'RIBONUCLEOSIDE-DIPHOSPHATE REDUCTASE SUBUNIT M2', 241920),
(326374, 'PTHR23409:SF40', NULL, NULL, NULL, NULL, 'RIBONUCLEOSIDE-DIPHOSPHATE REDUCTASE SMALL CHAIN', 241920),
(326375, 'PTHR23409:SF21', NULL, NULL, NULL, NULL, '', 241920),
(326376, 'PTHR23409:SF20', NULL, NULL, NULL, NULL, 'RIBONUCLEOSIDE-DIPHOSPHATE REDUCTASE SUBUNIT M2', 241920),
(326377, 'PTHR23409:SF41', NULL, NULL, NULL, NULL, 'RIBONUCLEOSIDE-DIPHOSPHATE REDUCTASE SMALL CHAIN-RELATED', 241920),
(326378, 'PTHR32309:SF29', NULL, NULL, NULL, NULL, 'CHAIN LENGTH DETERMINANT PROTEIN', 241921),
(326379, 'PTHR32309:SF28', NULL, NULL, NULL, NULL, 'FERRIC ENTEROBACTIN TRANSPORT PROTEIN FEPE', 241921),
(326380, 'PTHR32309:SF16', NULL, NULL, NULL, NULL, 'ECA POLYSACCHARIDE CHAIN LENGTH MODULATION PROTEIN', 241921),
(326381, 'PTHR32309', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', 241921),
(326382, 'PTHR32309:SF13', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE ETK-RELATED', 241921),
(326383, 'PTHR32309:SF30', NULL, NULL, NULL, NULL, 'EXOPOLYSACCHARIDE POLYMERIZATION PROTEIN-RELATED', 241921),
(326384, 'PTHR18929:SF238', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 241922),
(326385, 'PTHR18929:SF215', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE 5-2-LIKE', 241922),
(326386, 'PTHR18929:SF45', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE', 241922),
(326387, 'PTHR18929:SF218', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE 5-2', 241922),
(326388, 'PTHR18929:SF217', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE ISOMERASE-LIKE 1-3', 241922),
(326389, 'PTHR18929:SF239', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE', 241922),
(326390, 'PTHR18929:SF212', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE', 241922),
(326391, 'PTHR18929:SF211', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE ISOMERASE-LIKE 1-2', 241922),
(326392, 'PTHR18929:SF236', NULL, NULL, NULL, NULL, 'BNAC06G41290D PROTEIN', 241922),
(326393, 'PTHR18929:SF214', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 241922),
(326394, 'PTHR18929:SF235', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 241922),
(326395, 'PTHR18929:SF69', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE 1', 241922),
(326396, 'PTHR18929:SF219', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 241922),
(326397, 'PTHR18929:SF197', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 241922);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(326398, 'PTHR18929:SF252', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 241922),
(326399, 'PTHR18929:SF251', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE', 241922),
(326400, 'PTHR18929:SF210', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE A4', 241922),
(326401, 'PTHR18929:SF198', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE', 241922),
(326402, 'PTHR18929:SF132', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE A3', 241922),
(326403, 'PTHR18929:SF193', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM RESIDENT PROTEIN 27', 241922),
(326404, 'PTHR18929:SF93', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE A2', 241922),
(326405, 'PTHR18929:SF250', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE', 241922),
(326406, 'PTHR18929:SF249', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 241922),
(326407, 'PTHR18929:SF248', NULL, NULL, NULL, NULL, '', 241922),
(326408, 'PTHR18929:SF226', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE', 241922),
(326409, 'PTHR18929:SF229', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE ISOMERASE-LIKE 1-2', 241922),
(326410, 'PTHR18929:SF207', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE 5-2-LIKE', 241922),
(326411, 'PTHR18929:SF206', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE ISOMERASE-LIKE 1-3', 241922),
(326412, 'PTHR18929:SF245', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE', 241922),
(326413, 'PTHR18929:SF189', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE ISOMERASE-LIKE 1-5-RELATED', 241922),
(326414, 'PTHR18929:SF167', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE ISOMERASE-LIKE 5-3', 241922),
(326415, 'PTHR18929:SF101', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE', 241922),
(326416, 'PTHR18929:SF225', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE', 241922),
(326417, 'PTHR18929:SF247', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE', 241922),
(326418, 'PTHR18929:SF58', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE-LIKE PROTEIN OF THE TESTIS', 241922),
(326419, 'PTHR18929:SF224', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE', 241922),
(326420, 'PTHR18929:SF246', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE ISOMERASE-LIKE 1-4', 241922),
(326421, 'PTHR18929', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE ISOMERASE', 241922),
(326422, 'PTHR18929:SF209', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE', 241922),
(326423, 'PTHR18929:SF208', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE', 241922),
(326424, 'PTHR18929:SF240', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE', 241922),
(326425, 'PTHR18929:SF243', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 241922),
(326426, 'PTHR18929:SF242', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE A3', 241922),
(326427, 'PTHR18929:SF60', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE', 241922),
(326428, 'PTHR46120', NULL, NULL, NULL, NULL, 'BETAINE--HOMOCYSTEINE S-METHYLTRANSFERASE 1', 241923),
(326429, 'PTHR46120:SF4', NULL, NULL, NULL, NULL, 'HCY-BINDING DOMAIN-CONTAINING PROTEIN', 241923),
(326430, 'PTHR46120:SF2', NULL, NULL, NULL, NULL, 'BETAINE--HOMOCYSTEINE S-METHYLTRANSFERASE 1', 241923),
(326431, 'PTHR46120:SF3', NULL, NULL, NULL, NULL, 'S-METHYLMETHIONINE--HOMOCYSTEINE S-METHYLTRANSFERASE BHMT2', 241923),
(326432, 'PTHR46120:SF1', NULL, NULL, NULL, NULL, 'HCY-BINDING DOMAIN-CONTAINING PROTEIN', 241923),
(326433, 'PTHR16064', NULL, NULL, NULL, NULL, 'BTB  POZ  DOMAIN CONTAINING 7', 241924),
(326434, 'PTHR16064:SF4', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 241924),
(326435, 'PTHR16064:SF5', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN 7', 241924),
(326436, 'PTHR16064:SF3', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN 7', 241924),
(326437, 'PTHR15151:SF25', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 241925),
(326438, 'PTHR15151:SF24', NULL, NULL, NULL, NULL, 'TNF SUPERFAMILY MEMBER 12', 241925),
(326439, 'PTHR15151:SF13', NULL, NULL, NULL, NULL, 'ECTODYSPLASIN-A', 241925),
(326440, 'PTHR15151:SF12', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR LIGAND SUPERFAMILY MEMBER 13', 241925);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(326441, 'PTHR15151', NULL, NULL, NULL, NULL, 'PROTEIN EIGER', 241925),
(326442, 'PTHR15151:SF20', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR LIGAND SUPERFAMILY MEMBER 12', 241925),
(326443, 'PTHR15151:SF2', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR LIGAND SUPERFAMILY MEMBER 13B', 241925),
(326444, 'PTHR37815', NULL, NULL, NULL, NULL, 'UPF0397 PROTEIN BC_2624-RELATED', 241926),
(326445, 'PTHR37815:SF3', NULL, NULL, NULL, NULL, 'UPF0397 PROTEIN SPR0429', 241926),
(326446, 'PTHR46578:SF1', NULL, NULL, NULL, NULL, 'ARM-REPEAT/TETRATRICOPEPTIDE REPEAT (TPR)-LIKE PROTEIN', 241927),
(326447, 'PTHR46578:SF2', NULL, NULL, NULL, NULL, 'ARM-REPEAT/TETRATRICOPEPTIDE REPEAT (TPR)-LIKE PROTEIN', 241927),
(326448, 'PTHR46578:SF4', NULL, NULL, NULL, NULL, 'ARM-REPEAT/TETRATRICOPEPTIDE REPEAT (TPR)-LIKE PROTEIN', 241927),
(326449, 'PTHR46578', NULL, NULL, NULL, NULL, 'ARM-REPEAT/TETRATRICOPEPTIDE REPEAT (TPR)-LIKE PROTEIN', 241927),
(326450, 'PTHR24139:SF34', NULL, NULL, NULL, NULL, '85/88 KDA CALCIUM-INDEPENDENT PHOSPHOLIPASE A2', 241928),
(326451, 'PTHR24139', NULL, NULL, NULL, NULL, 'CALCIUM-INDEPENDENT PHOSPHOLIPASE A2', 241928),
(326452, 'PTHR24139:SF35', NULL, NULL, NULL, NULL, 'PNPLA DOMAIN-CONTAINING PROTEIN', 241928),
(326453, 'PTHR15720:SF14', NULL, NULL, NULL, NULL, '', 241929),
(326454, 'PTHR15720:SF13', NULL, NULL, NULL, NULL, 'PROTEIN GREB1', 241929),
(326455, 'PTHR15720:SF12', NULL, NULL, NULL, NULL, 'GREB1-LIKE PROTEIN', 241929),
(326456, 'PTHR15720', NULL, NULL, NULL, NULL, 'GREB1-RELATED', 241929),
(326457, 'PTHR46858:SF11', NULL, NULL, NULL, NULL, 'LIGASE, PUTATIVE-RELATED', 241930),
(326458, 'PTHR46858:SF12', NULL, NULL, NULL, NULL, 'PROTEIN MDM4', 241930),
(326459, 'PTHR46858', NULL, NULL, NULL, NULL, 'OS05G0521000 PROTEIN', 241930),
(326460, 'PTHR46858:SF13', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MDM2', 241930),
(326461, 'PTHR46858:SF5', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MDM2', 241930),
(326462, 'PTHR46858:SF4', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 241930),
(326463, 'PTHR46858:SF7', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 241930),
(326464, 'PTHR46858:SF6', NULL, NULL, NULL, NULL, 'LIGASE, PUTATIVE-RELATED', 241930),
(326465, 'PTHR46858:SF8', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE APD2', 241930),
(326466, 'PTHR43351:SF2', NULL, NULL, NULL, NULL, 'L(+)-TARTRATE DEHYDRATASE SUBUNIT BETA', 241931),
(326467, 'PTHR43351', NULL, NULL, NULL, NULL, 'L(+)-TARTRATE DEHYDRATASE SUBUNIT BETA', 241931),
(326468, 'PTHR39113:SF1', NULL, NULL, NULL, NULL, 'MEMBRANE LIPOPROTEIN-RELATED', 241932),
(326469, 'PTHR39113', NULL, NULL, NULL, NULL, 'MEMBRANE LIPOPROTEIN-RELATED', 241932),
(326470, 'PTHR39113:SF2', NULL, NULL, NULL, NULL, '', 241932),
(326471, 'PTHR33916:SF7', NULL, NULL, NULL, NULL, 'BNAC05G13140D PROTEIN', 241933),
(326472, 'PTHR33916:SF8', NULL, NULL, NULL, NULL, 'OS05G0272800 PROTEIN', 241933),
(326473, 'PTHR33916:SF12', NULL, NULL, NULL, NULL, '', 241933),
(326474, 'PTHR33916:SF11', NULL, NULL, NULL, NULL, '', 241933),
(326475, 'PTHR33916', NULL, NULL, NULL, NULL, '', 241933),
(326476, 'PTHR33916:SF1', NULL, NULL, NULL, NULL, '', 241933),
(326477, 'PTHR13164:SF6', NULL, NULL, NULL, NULL, 'CS DOMAIN-CONTAINING PROTEIN', 241934),
(326478, 'PTHR13164', NULL, NULL, NULL, NULL, 'CALICYLIN BINDING PROTEIN', 241934),
(326479, 'PTHR13164:SF3', NULL, NULL, NULL, NULL, 'CALCYCLIN-BINDING PROTEIN', 241934),
(326480, 'PTHR10533:SF5', NULL, NULL, NULL, NULL, 'PRO-NEUROPEPTIDE Y', 241935),
(326481, 'PTHR10533', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE Y/PANCREATIC HORMONE/PEPTIDE YY', 241935),
(326482, 'PTHR10533:SF12', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 241935),
(326483, 'PTHR10533:SF15', NULL, NULL, NULL, NULL, '', 241935),
(326484, 'PTHR10533:SF14', NULL, NULL, NULL, NULL, 'PEPTIDE YY-RELATED', 241935),
(326485, 'PTHR10533:SF2', NULL, NULL, NULL, NULL, 'PANCREATIC PROHORMONE', 241935),
(326486, 'PTHR28436:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM5 HOMOLOG', 241936);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(326487, 'PTHR28436', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM5 HOMOLOG', 241936),
(326488, 'PTHR18874', NULL, NULL, NULL, NULL, 'CMF/LEK/CENP CELL DIVISION-RELATED', 241937),
(326489, 'PTHR18874:SF10', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN F', 241937),
(326490, 'PTHR46606', NULL, NULL, NULL, NULL, 'SHOOTIN-1', 241938),
(326491, 'PTHR46606:SF1', NULL, NULL, NULL, NULL, 'SHOOTIN-1', 241938),
(326492, 'PTHR46606:SF3', NULL, NULL, NULL, NULL, 'SHOOTIN-1', 241938),
(326493, 'PTHR46606:SF4', NULL, NULL, NULL, NULL, 'SHOOTIN-1', 241938),
(326494, 'PTHR46606:SF5', NULL, NULL, NULL, NULL, 'SHOOTIN-1', 241938),
(326495, 'PTHR11550:SF2', NULL, NULL, NULL, NULL, 'CTP SYNTHASE 2', 241939),
(326496, 'PTHR11550:SF0', NULL, NULL, NULL, NULL, 'CTP SYNTHASE-RELATED', 241939),
(326497, 'PTHR11550:SF39', NULL, NULL, NULL, NULL, 'CTP SYNTHASE', 241939),
(326498, 'PTHR11550:SF28', NULL, NULL, NULL, NULL, 'CTP SYNTHASE', 241939),
(326499, 'PTHR11550:SF8', NULL, NULL, NULL, NULL, 'CTP SYNTHASE 1', 241939),
(326500, 'PTHR11550:SF40', NULL, NULL, NULL, NULL, 'CTP SYNTHASE', 241939),
(326501, 'PTHR11550:SF25', NULL, NULL, NULL, NULL, 'CTP SYNTHASE', 241939),
(326502, 'PTHR11550:SF36', NULL, NULL, NULL, NULL, 'CTP SYNTHASE', 241939),
(326503, 'PTHR11550:SF37', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 241939),
(326504, 'PTHR11550:SF34', NULL, NULL, NULL, NULL, 'CTP SYNTHASE', 241939),
(326505, 'PTHR11550:SF13', NULL, NULL, NULL, NULL, 'CTP SYNTHASE', 241939),
(326506, 'PTHR11550:SF21', NULL, NULL, NULL, NULL, 'CTP SYNTHASE', 241939),
(326507, 'PTHR11550:SF41', NULL, NULL, NULL, NULL, 'CTP SYNTHASE', 241939),
(326508, 'PTHR11550', NULL, NULL, NULL, NULL, 'CTP SYNTHASE', 241939),
(326509, 'PTHR11550:SF31', NULL, NULL, NULL, NULL, 'CTP SYNTHASE', 241939),
(326510, 'PTHR11550:SF42', NULL, NULL, NULL, NULL, 'CTP SYNTHASE', 241939),
(326511, 'PTHR10894:SF31', NULL, NULL, NULL, NULL, 'NOP DOMAIN-CONTAINING PROTEIN', 241940),
(326512, 'PTHR10894:SF30', NULL, NULL, NULL, NULL, 'NOP DOMAIN-CONTAINING PROTEIN', 241940),
(326513, 'PTHR10894:SF35', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE, EXPRESSED-RELATED', 241940),
(326514, 'PTHR10894:SF13', NULL, NULL, NULL, NULL, 'NOP DOMAIN-CONTAINING PROTEIN', 241940),
(326515, 'PTHR10894:SF24', NULL, NULL, NULL, NULL, '(BREAD WHEAT) HYPOTHETICAL PROTEIN', 241940),
(326516, 'PTHR10894:SF34', NULL, NULL, NULL, NULL, 'NOP DOMAIN-CONTAINING PROTEIN', 241940),
(326517, 'PTHR10894:SF12', NULL, NULL, NULL, NULL, 'OS06G0355900 PROTEIN', 241940),
(326518, 'PTHR10894:SF23', NULL, NULL, NULL, NULL, 'NOP DOMAIN-CONTAINING PROTEIN', 241940),
(326519, 'PTHR10894:SF0', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 56', 241940),
(326520, 'PTHR10894:SF1', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 58', 241940),
(326521, 'PTHR10894:SF36', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 5-1-RELATED', 241940),
(326522, 'PTHR10894:SF25', NULL, NULL, NULL, NULL, 'NOP DOMAIN-CONTAINING PROTEIN', 241940),
(326523, 'PTHR10894:SF14', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241940),
(326524, 'PTHR10894:SF27', NULL, NULL, NULL, NULL, 'NOP56-LIKE PRE RNA PROCESSING RIBONUCLEOPROTEIN', 241940),
(326525, 'PTHR10894:SF19', NULL, NULL, NULL, NULL, 'PROTEIN NOP56, PUTATIVE, EXPRESSED-RELATED', 241940),
(326526, 'PTHR10894:SF29', NULL, NULL, NULL, NULL, '', 241940),
(326527, 'PTHR10894', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 5  NUCLEOLAR PROTEIN NOP5  NOP58', 241940),
(326528, 'PTHR33137:SF4', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE IRF2BPL-RELATED', 241941),
(326529, 'PTHR33137:SF44', NULL, NULL, NULL, NULL, '', 241941),
(326530, 'PTHR33137:SF23', NULL, NULL, NULL, NULL, 'BNAA06G10430D PROTEIN', 241941),
(326531, 'PTHR33137:SF45', NULL, NULL, NULL, NULL, 'OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 15A, PUTATIVE-RELATED', 241941),
(326532, 'PTHR33137:SF42', NULL, NULL, NULL, NULL, '', 241941),
(326533, 'PTHR33137:SF31', NULL, NULL, NULL, NULL, 'KIX_2 DOMAIN-CONTAINING PROTEIN', 241941),
(326534, 'PTHR33137:SF43', NULL, NULL, NULL, NULL, 'KIX_2 DOMAIN-CONTAINING PROTEIN', 241941);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(326535, 'PTHR33137:SF32', NULL, NULL, NULL, NULL, 'KIX_2 DOMAIN-CONTAINING PROTEIN', 241941),
(326536, 'PTHR33137:SF10', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241941),
(326537, 'PTHR33137:SF37', NULL, NULL, NULL, NULL, 'KIX_2 DOMAIN-CONTAINING PROTEIN', 241941),
(326538, 'PTHR33137:SF15', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 241941),
(326539, 'PTHR33137:SF16', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 15C-RELATED', 241941),
(326540, 'PTHR33137:SF35', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 15A-LIKE PROTEIN', 241941),
(326541, 'PTHR33137:SF46', NULL, NULL, NULL, NULL, 'KIX_2 DOMAIN-CONTAINING PROTEIN', 241941),
(326542, 'PTHR33137:SF36', NULL, NULL, NULL, NULL, 'BNAA06G10480D PROTEIN', 241941),
(326543, 'PTHR33137:SF47', NULL, NULL, NULL, NULL, 'KIX_2 DOMAIN-CONTAINING PROTEIN', 241941),
(326544, 'PTHR33137:SF25', NULL, NULL, NULL, NULL, 'KIX_2 DOMAIN-CONTAINING PROTEIN', 241941),
(326545, 'PTHR33137', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 15A-RELATED', 241941),
(326546, 'PTHR33137:SF28', NULL, NULL, NULL, NULL, 'BNAC05G49900D PROTEIN', 241941),
(326547, 'PTHR33137:SF29', NULL, NULL, NULL, NULL, 'KIX_2 DOMAIN-CONTAINING PROTEIN', 241941),
(326548, 'PTHR33699:SF24', NULL, NULL, NULL, NULL, 'BNAA09G03070D PROTEIN', 241942),
(326549, 'PTHR33699:SF23', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241942),
(326550, 'PTHR33699:SF22', NULL, NULL, NULL, NULL, '', 241942),
(326551, 'PTHR33699:SF21', NULL, NULL, NULL, NULL, '', 241942),
(326552, 'PTHR33699:SF20', NULL, NULL, NULL, NULL, '', 241942),
(326553, 'PTHR33699:SF3', NULL, NULL, NULL, NULL, 'BNAC09G54310D PROTEIN', 241942),
(326554, 'PTHR33699:SF19', NULL, NULL, NULL, NULL, 'OS01G0914000 PROTEIN', 241942),
(326555, 'PTHR33699:SF1', NULL, NULL, NULL, NULL, 'OS12G0418200 PROTEIN', 241942),
(326556, 'PTHR33699:SF29', NULL, NULL, NULL, NULL, '', 241942),
(326557, 'PTHR33699:SF2', NULL, NULL, NULL, NULL, 'PATHOGENIC TYPE III EFFECTOR AVIRULENCE FACTOR AVR AVRRPT-CLEAVAGE: CLEAVAGE SITE PROTEIN-RELATED', 241942),
(326558, 'PTHR33699:SF17', NULL, NULL, NULL, NULL, '', 241942),
(326559, 'PTHR33699:SF28', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241942),
(326560, 'PTHR33699:SF16', NULL, NULL, NULL, NULL, '', 241942),
(326561, 'PTHR33699:SF27', NULL, NULL, NULL, NULL, 'BNAA02G30220D PROTEIN', 241942),
(326562, 'PTHR33699:SF14', NULL, NULL, NULL, NULL, '', 241942),
(326563, 'PTHR33699', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241942),
(326564, 'PTHR30559', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE CLASS 2', 241943),
(326565, 'PTHR30559:SF0', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE', 241943),
(326566, 'PTHR34773:SF1', NULL, NULL, NULL, NULL, 'FLAGELLAR SECRETION CHAPERONE FLIS', 241944),
(326567, 'PTHR34773', NULL, NULL, NULL, NULL, 'FLAGELLAR SECRETION CHAPERONE FLIS', 241944),
(326568, 'PTHR35667:SF1', NULL, NULL, NULL, NULL, 'LEUKEMIA NUP98 FUSION PARTNER 1', 241945),
(326569, 'PTHR35667', NULL, NULL, NULL, NULL, 'LEUKEMIA NUP98 FUSION PARTNER 1', 241945),
(326570, 'PTHR43625:SF91', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 241946),
(326571, 'PTHR43625:SF90', NULL, NULL, NULL, NULL, 'ALDO/KETO REDUCTASE/POTASSIUM CHANNEL SUBUNIT BETA-RELATED', 241946),
(326572, 'PTHR43625:SF93', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE 1-RELATED', 241946),
(326573, 'PTHR43625:SF92', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 241946),
(326574, 'PTHR43625:SF50', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE 2-RELATED', 241946),
(326575, 'PTHR43625:SF94', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN PCNT115-LIKE', 241946),
(326576, 'PTHR43625:SF53', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 241946),
(326577, 'PTHR43625:SF75', NULL, NULL, NULL, NULL, 'PERAKINE REDUCTASE-LIKE', 241946),
(326578, 'PTHR43625:SF52', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 241946),
(326579, 'PTHR43625:SF44', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE 6-RELATED', 241946);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(326580, 'PTHR43625:SF66', NULL, NULL, NULL, NULL, 'ALDO/KETO REDUCTASE/POTASSIUM CHANNEL SUBUNIT BETA-RELATED', 241946),
(326581, 'PTHR43625:SF88', NULL, NULL, NULL, NULL, 'OS07G0143000 PROTEIN', 241946),
(326582, 'PTHR43625:SF87', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE 4-RELATED', 241946),
(326583, 'PTHR43625:SF65', NULL, NULL, NULL, NULL, 'ALDO/KETO REDUCTASE FAMILY OXIDOREDUCTASE', 241946),
(326584, 'PTHR43625:SF68', NULL, NULL, NULL, NULL, 'ALDO/KETO REDUCTASE', 241946),
(326585, 'PTHR43625:SF89', NULL, NULL, NULL, NULL, 'REDUCTASE (GLIO), PUTATIVE-RELATED', 241946),
(326586, 'PTHR43625:SF4', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 241946),
(326587, 'PTHR43625:SF5', NULL, NULL, NULL, NULL, 'PYRIDOXAL REDUCTASE, CHLOROPLASTIC', 241946),
(326588, 'PTHR43625:SF69', NULL, NULL, NULL, NULL, 'ALDO/KETO REDUCTASE/POTASSIUM CHANNEL SUBUNIT BETA-RELATED', 241946),
(326589, 'PTHR43625:SF7', NULL, NULL, NULL, NULL, 'REDUCTASE (YAKC), PUTATIVE (AFU_ORTHOLOGUE AFUA_8G01560)-RELATED', 241946),
(326590, 'PTHR43625:SF27', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE', 241946),
(326591, 'PTHR43625:SF29', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 241946),
(326592, 'PTHR43625', NULL, NULL, NULL, NULL, 'AFLATOXIN B1 ALDEHYDE REDUCTASE', 241946),
(326593, 'PTHR43625:SF80', NULL, NULL, NULL, NULL, 'ALDO/KETO REDUCTASE FAMILY OXIDOREDUCTASE', 241946),
(326594, 'PTHR43625:SF82', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 241946),
(326595, 'PTHR43625:SF81', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE 1-RELATED', 241946),
(326596, 'PTHR43625:SF40', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE YAKC [NADP(+)]', 241946),
(326597, 'PTHR43625:SF84', NULL, NULL, NULL, NULL, 'ALDO/KETO REDUCTASE/POTASSIUM CHANNEL SUBUNIT BETA-RELATED', 241946),
(326598, 'PTHR43625:SF83', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 241946),
(326599, 'PTHR43625:SF61', NULL, NULL, NULL, NULL, 'OS01G0618100 PROTEIN', 241946),
(326600, 'PTHR43625:SF42', NULL, NULL, NULL, NULL, 'PERAKINE REDUCTASE-LIKE', 241946),
(326601, 'PTHR43625:SF86', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 241946),
(326602, 'PTHR43625:SF85', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE 2-RELATED', 241946),
(326603, 'PTHR43625:SF55', NULL, NULL, NULL, NULL, 'ALDO/KETO REDUCTASE/POTASSIUM CHANNEL SUBUNIT BETA-RELATED', 241946),
(326604, 'PTHR43625:SF77', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE', 241946),
(326605, 'PTHR43625:SF33', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE 2 ISOFORM X1-RELATED', 241946),
(326606, 'PTHR43625:SF11', NULL, NULL, NULL, NULL, 'AFLATOXIN B1 ALDEHYDE REDUCTASE MEMBER 3-RELATED', 241946),
(326607, 'PTHR43625:SF76', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE, ALDO/KETO REDUCTASE FAMILY PROTEIN-RELATED', 241946),
(326608, 'PTHR43625:SF79', NULL, NULL, NULL, NULL, 'PROTEIN PCNT115, PUTATIVE, EXPRESSED-RELATED', 241946),
(326609, 'PTHR43625:SF12', NULL, NULL, NULL, NULL, 'AFLATOXIN B1 ALDEHYDE REDUCTASE MEMBER 2', 241946),
(326610, 'PTHR43625:SF78', NULL, NULL, NULL, NULL, 'PYRIDOXAL REDUCTASE-RELATED', 241946),
(326611, 'PTHR43625:SF37', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE 3-RELATED', 241946),
(326612, 'PTHR43625:SF58', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 241946),
(326613, 'PTHR43625:SF16', NULL, NULL, NULL, NULL, 'OS07G0142900 PROTEIN', 241946),
(326614, 'PTHR43625:SF19', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 241946),
(326615, 'PTHR47071:SF3', NULL, NULL, NULL, NULL, 'DUF4378 DOMAIN PROTEIN', 241947),
(326616, 'PTHR47071', NULL, NULL, NULL, NULL, 'PROTEIN TRM32', 241947),
(326617, 'PTHR47071:SF2', NULL, NULL, NULL, NULL, 'PROTEIN TRM32', 241947),
(326618, 'PTHR47071:SF9', NULL, NULL, NULL, NULL, 'TRM32-LIKE PROTEIN (DUF3741)', 241947),
(326619, 'PTHR47071:SF10', NULL, NULL, NULL, NULL, 'PROTEIN TRM32-LIKE', 241947),
(326620, 'PTHR47071:SF7', NULL, NULL, NULL, NULL, 'BNAA03G54870D PROTEIN', 241947),
(326621, 'PTHR47071:SF11', NULL, NULL, NULL, NULL, 'BNAA08G29060D PROTEIN', 241947);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(326622, 'PTHR47071:SF4', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241947),
(326623, 'PTHR13154:SF2', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN-INTERACTING PROTEIN 2', 241948),
(326624, 'PTHR13154:SF5', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN-INTERACTING PROTEIN 2B', 241948),
(326625, 'PTHR13154', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN-INTERACTING PROTEIN 2', 241948),
(326626, 'PTHR13154:SF6', NULL, NULL, NULL, NULL, 'GEO05078P1', 241948),
(326627, 'PTHR13144:SF0', NULL, NULL, NULL, NULL, 'PROTEIN TEX261', 241949),
(326628, 'PTHR13144', NULL, NULL, NULL, NULL, 'TEX261 PROTEIN', 241949),
(326629, 'PTHR45286:SF1', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', 241950),
(326630, 'PTHR45286', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', 241950),
(326631, 'PTHR22089', NULL, NULL, NULL, NULL, 'MIRROR-IMAGE POLYDACTYLY GENE 1 PROTEIN', 241951),
(326632, 'PTHR22089:SF2', NULL, NULL, NULL, NULL, 'MIRROR-IMAGE POLYDACTYLY GENE 1 PROTEIN', 241951),
(326633, 'PTHR35467:SF3', NULL, NULL, NULL, NULL, 'BNAC05G51130D PROTEIN', 241952),
(326634, 'PTHR35467:SF2', NULL, NULL, NULL, NULL, 'PROTEIN NEOXANTHIN-DEFICIENT 1', 241952),
(326635, 'PTHR35467', NULL, NULL, NULL, NULL, '', 241952),
(326636, 'PTHR31334', NULL, NULL, NULL, NULL, 'SMITH-MAGENIS SYNDROME REGION GENE 8 PROTEIN', 241953),
(326637, 'PTHR31334:SF1', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE EXCHANGE PROTEIN SMCR8', 241953),
(326638, 'PTHR15010', NULL, NULL, NULL, NULL, 'ACYLOXYACYL HYDROLASE', 241954),
(326639, 'PTHR15010:SF0', NULL, NULL, NULL, NULL, 'ACYLOXYACYL HYDROLASE', 241954),
(326640, 'PTHR10740:SF16', NULL, NULL, NULL, NULL, 'AMPHIREGULIN', 241955),
(326641, 'PTHR10740:SF1', NULL, NULL, NULL, NULL, 'PROTRANSFORMING GROWTH FACTOR ALPHA', 241955),
(326642, 'PTHR10740:SF4', NULL, NULL, NULL, NULL, 'PROHEPARIN-BINDING EGF-LIKE GROWTH FACTOR', 241955),
(326643, 'PTHR10740:SF3', NULL, NULL, NULL, NULL, 'PROBETACELLULIN', 241955),
(326644, 'PTHR10740:SF12', NULL, NULL, NULL, NULL, 'AMPHIREGULIN', 241955),
(326645, 'PTHR10740:SF15', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 241955),
(326646, 'PTHR10740:SF14', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 241955),
(326647, 'PTHR10740:SF11', NULL, NULL, NULL, NULL, 'PROEPIREGULIN', 241955),
(326648, 'PTHR10740', NULL, NULL, NULL, NULL, 'TRANSFORMING GROWTH FACTOR ALPHA', 241955),
(326649, 'PTHR10740:SF10', NULL, NULL, NULL, NULL, 'EPIGEN', 241955),
(326650, 'PTHR11256:SF48', NULL, NULL, NULL, NULL, 'BCL-2-RELATED OVARIAN KILLER PROTEIN', 241956),
(326651, 'PTHR11256:SF59', NULL, NULL, NULL, NULL, 'BCL-2 HOMOLOGOUS ANTAGONIST/KILLER', 241956),
(326652, 'PTHR11256:SF47', NULL, NULL, NULL, NULL, 'BCL-2-LIKE PROTEIN 10', 241956),
(326653, 'PTHR11256:SF13', NULL, NULL, NULL, NULL, 'BCL-2-LIKE PROTEIN 2', 241956),
(326654, 'PTHR11256:SF46', NULL, NULL, NULL, NULL, 'INDUCED MYELOID LEUKEMIA CELL DIFFERENTIATION PROTEIN MCL-1', 241956),
(326655, 'PTHR11256:SF56', NULL, NULL, NULL, NULL, 'APOPTOSIS REGULATOR CED-9', 241956),
(326656, 'PTHR11256:SF12', NULL, NULL, NULL, NULL, 'BCL-2-LIKE PROTEIN 1', 241956),
(326657, 'PTHR11256:SF11', NULL, NULL, NULL, NULL, 'APOPTOSIS REGULATOR BCL-2', 241956),
(326658, 'PTHR11256:SF21', NULL, NULL, NULL, NULL, '', 241956),
(326659, 'PTHR11256:SF10', NULL, NULL, NULL, NULL, 'BCL-2-RELATED PROTEIN A1', 241956),
(326660, 'PTHR11256:SF32', NULL, NULL, NULL, NULL, 'BCL-WAV', 241956),
(326661, 'PTHR11256:SF54', NULL, NULL, NULL, NULL, '', 241956),
(326662, 'PTHR11256:SF42', NULL, NULL, NULL, NULL, 'APOPTOSIS REGULATOR BAX', 241956),
(326663, 'PTHR11256:SF63', NULL, NULL, NULL, NULL, 'BG1', 241956),
(326664, 'PTHR11256:SF41', NULL, NULL, NULL, NULL, 'BCL-2 HOMOLOGOUS ANTAGONIST/KILLER', 241956),
(326665, 'PTHR11256:SF62', NULL, NULL, NULL, NULL, '', 241956),
(326666, 'PTHR11256:SF50', NULL, NULL, NULL, NULL, '', 241956),
(326667, 'PTHR11256:SF61', NULL, NULL, NULL, NULL, 'BCL2-LIKE 10', 241956),
(326668, 'PTHR11256:SF60', NULL, NULL, NULL, NULL, 'APOPTOSIS REGULATOR BCL-2', 241956);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(326669, 'PTHR11256', NULL, NULL, NULL, NULL, 'BCL-2 RELATED', 241956),
(326670, 'PTHR47985:SF27', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241957),
(326671, 'PTHR47985:SF29', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241957),
(326672, 'PTHR47985:SF66', NULL, NULL, NULL, NULL, 'OS07G0668900 PROTEIN', 241957),
(326673, 'PTHR47985:SF22', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241957),
(326674, 'PTHR47985:SF23', NULL, NULL, NULL, NULL, 'OS07G0695300 PROTEIN', 241957),
(326675, 'PTHR47985:SF67', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE RLCKVII-RELATED', 241957),
(326676, 'PTHR47985:SF24', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 241957),
(326677, 'PTHR47985:SF69', NULL, NULL, NULL, NULL, 'CONCANAVALIN A-LIKE LECTIN/GLUCANASE DOMAIN, SERINE/THREONINE-PROTEIN KINASE UNC-51-RELATED', 241957),
(326678, 'PTHR47985:SF25', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE CDL1-LIKE', 241957),
(326679, 'PTHR47985:SF62', NULL, NULL, NULL, NULL, 'OS01G0259200 PROTEIN', 241957),
(326680, 'PTHR47985:SF63', NULL, NULL, NULL, NULL, 'OS05G0463000 PROTEIN', 241957),
(326681, 'PTHR47985:SF20', NULL, NULL, NULL, NULL, 'RECEPTOR SERINE/THREONINE KINASE', 241957),
(326682, 'PTHR47985:SF64', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241957),
(326683, 'PTHR47985:SF21', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241957),
(326684, 'PTHR47985:SF61', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241957),
(326685, 'PTHR47985:SF59', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBL25-RELATED', 241957),
(326686, 'PTHR47985:SF15', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241957),
(326687, 'PTHR47985:SF16', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE CYTOPLASMIC KINASE 185', 241957),
(326688, 'PTHR47985:SF17', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE CDL1-LIKE', 241957),
(326689, 'PTHR47985:SF18', NULL, NULL, NULL, NULL, 'OS05G0498900 PROTEIN', 241957),
(326690, 'PTHR47985:SF55', NULL, NULL, NULL, NULL, 'OS05G0125300 PROTEIN', 241957),
(326691, 'PTHR47985:SF9', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241957),
(326692, 'PTHR47985:SF11', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241957),
(326693, 'PTHR47985:SF13', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE LIP2', 241957),
(326694, 'PTHR47985:SF14', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE CDL1-LIKE', 241957),
(326695, 'PTHR47985:SF51', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE LIP2', 241957),
(326696, 'PTHR47985:SF52', NULL, NULL, NULL, NULL, 'OS02G0833000 PROTEIN', 241957),
(326697, 'PTHR47985:SF10', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241957),
(326698, 'PTHR47985:SF54', NULL, NULL, NULL, NULL, 'CONCANAVALIN A-LIKE LECTIN/GLUCANASE DOMAIN-CONTAINING PROTEIN-RELATED', 241957),
(326699, 'PTHR47985:SF50', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE CDL1-LIKE', 241957),
(326700, 'PTHR47985', NULL, NULL, NULL, NULL, 'OS07G0668900 PROTEIN', 241957),
(326701, 'PTHR47985:SF4', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBL27', 241957),
(326702, 'PTHR47985:SF7', NULL, NULL, NULL, NULL, 'OS03G0283900 PROTEIN', 241957),
(326703, 'PTHR47985:SF1', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 241957),
(326704, 'PTHR47985:SF19', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE CDL1-LIKE', 241957),
(326705, 'PTHR47985:SF3', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBL21-RELATED', 241957),
(326706, 'PTHR47985:SF2', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBL7-RELATED', 241957),
(326707, 'PTHR47985:SF48', NULL, NULL, NULL, NULL, 'CGMP-DEPENDENT KINASE, CONCANAVALIN A-LIKE LECTIN/GLUCANASE DOMAIN PROTEIN-RELATED', 241957),
(326708, 'PTHR47985:SF49', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241957),
(326709, 'PTHR47985:SF88', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBS1-LIKE', 241957);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(326710, 'PTHR47985:SF44', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBS1', 241957),
(326711, 'PTHR47985:SF45', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBL22-RELATED', 241957),
(326712, 'PTHR47985:SF89', NULL, NULL, NULL, NULL, 'OS01G0789200 PROTEIN', 241957),
(326713, 'PTHR47985:SF46', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241957),
(326714, 'PTHR47985:SF47', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241957),
(326715, 'PTHR47985:SF40', NULL, NULL, NULL, NULL, 'RECEPTOR KINASE-LIKE PROTEIN', 241957),
(326716, 'PTHR47985:SF84', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241957),
(326717, 'PTHR47985:SF41', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBL5-RELATED', 241957),
(326718, 'PTHR47985:SF85', NULL, NULL, NULL, NULL, 'OS09G0572600 PROTEIN', 241957),
(326719, 'PTHR47985:SF86', NULL, NULL, NULL, NULL, 'OS04G0393900 PROTEIN', 241957),
(326720, 'PTHR47985:SF87', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241957),
(326721, 'PTHR47985:SF81', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE CDL1-LIKE', 241957),
(326722, 'PTHR47985:SF82', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE CDG1', 241957),
(326723, 'PTHR47985:SF90', NULL, NULL, NULL, NULL, 'RECEPTOR SERINE/THREONINE KINASE', 241957),
(326724, 'PTHR47985:SF37', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 241957),
(326725, 'PTHR47985:SF38', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241957),
(326726, 'PTHR47985:SF39', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBL23-RELATED', 241957),
(326727, 'PTHR47985:SF33', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE CDL1-LIKE ISOFORM X1', 241957),
(326728, 'PTHR47985:SF77', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE LIP1', 241957),
(326729, 'PTHR47985:SF78', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241957),
(326730, 'PTHR47985:SF34', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBL24-RELATED', 241957),
(326731, 'PTHR47985:SF74', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241957),
(326732, 'PTHR47985:SF31', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBL26-RELATED', 241957),
(326733, 'PTHR47985:SF76', NULL, NULL, NULL, NULL, 'RECEPTOR SERINE/THREONINE KINASE', 241957),
(326734, 'PTHR47985:SF32', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE LIP2', 241957),
(326735, 'PTHR47985:SF70', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE CDL1-LIKE', 241957),
(326736, 'PTHR47985:SF71', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE CDL1-LIKE', 241957),
(326737, 'PTHR47985:SF72', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 241957),
(326738, 'PTHR47727', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 9 MEMBER A', 241958),
(326739, 'PTHR47727:SF1', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 9 MEMBER A', 241958),
(326740, 'PTHR15727', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 214', 241959),
(326741, 'PTHR15727:SF3', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 214', 241959),
(326742, 'PTHR15727:SF4', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE DZIP3', 241959),
(326743, 'PTHR31927:SF13', NULL, NULL, NULL, NULL, 'TWEEDLEBETA', 241960),
(326744, 'PTHR31927', NULL, NULL, NULL, NULL, 'FI07246P-RELATED-RELATED', 241960),
(326745, 'PTHR31927:SF16', NULL, NULL, NULL, NULL, 'LP07342P', 241960),
(326746, 'PTHR31927:SF2', NULL, NULL, NULL, NULL, 'FI07246P-RELATED', 241960),
(326747, 'PTHR39327:SF1', NULL, NULL, NULL, NULL, 'BLR5470 PROTEIN', 241961),
(326748, 'PTHR39327', NULL, NULL, NULL, NULL, '', 241961),
(326749, 'PTHR43479:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, TETR FAMILY', 241962),
(326750, 'PTHR43479', NULL, NULL, NULL, NULL, 'ACREF/ENVCD OPERON REPRESSOR-RELATED', 241962),
(326751, 'PTHR43479:SF11', NULL, NULL, NULL, NULL, 'ACREF/ENVCD OPERON REPRESSOR-RELATED', 241962),
(326752, 'PTHR43479:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, TETR FAMILY', 241962);
INSERT INTO "PUBLIC"."MODEL" VALUES
(326753, 'PTHR43479:SF12', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR TETR FAMILY', 241962),
(326754, 'PTHR43479:SF17', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR (TETR/ACRR FAMILY)', 241962),
(326755, 'PTHR43479:SF18', NULL, NULL, NULL, NULL, 'HTH TETR-TYPE DOMAIN-CONTAINING PROTEIN', 241962),
(326756, 'PTHR43479:SF16', NULL, NULL, NULL, NULL, 'HTH TETR-TYPE DOMAIN-CONTAINING PROTEIN', 241962),
(326757, 'PTHR43479:SF19', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR SAOUHSC_02897', 241962),
(326758, 'PTHR36845', NULL, NULL, NULL, NULL, 'HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G05090)-RELATED', 241963),
(326759, 'PTHR36845:SF1', NULL, NULL, NULL, NULL, 'HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G05090)-RELATED', 241963),
(326760, 'PTHR39614', NULL, NULL, NULL, NULL, '', 241964),
(326761, 'PTHR39614:SF2', NULL, NULL, NULL, NULL, '', 241964),
(326762, 'PTHR39614:SF3', NULL, NULL, NULL, NULL, '', 241964),
(326763, 'PTHR22963', NULL, NULL, NULL, NULL, 'ENDOGLIN-RELATED', 241965),
(326764, 'PTHR22963:SF39', NULL, NULL, NULL, NULL, '', 241965),
(326765, 'PTHR22963:SF38', NULL, NULL, NULL, NULL, 'LP13770P', 241965),
(326766, 'PTHR46545:SF1', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 51', 241966),
(326767, 'PTHR46545', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 51', 241966),
(326768, 'PTHR46907', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN BETA-7-RELATED', 241967),
(326769, 'PTHR46907:SF2', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN BETA-7', 241967),
(326770, 'PTHR46907:SF1', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 241967),
(326771, 'PTHR13167:SF39', NULL, NULL, NULL, NULL, 'PIEZO-TYPE MECHANOSENSITIVE ION CHANNEL COMPONENT', 241968),
(326772, 'PTHR13167:SF40', NULL, NULL, NULL, NULL, 'PIEZO-TYPE MECHANOSENSITIVE ION CHANNEL COMPONENT 1', 241968),
(326773, 'PTHR13167:SF43', NULL, NULL, NULL, NULL, 'PIEZO NON-SPECIFIC CATION CHANNEL, R-RAS-BINDING DOMAIN PROTEIN-RELATED', 241968),
(326774, 'PTHR13167:SF42', NULL, NULL, NULL, NULL, 'PIEZO_RRAS_BDG DOMAIN-CONTAINING PROTEIN', 241968),
(326775, 'PTHR13167:SF25', NULL, NULL, NULL, NULL, 'PIEZO-TYPE MECHANOSENSITIVE ION CHANNEL COMPONENT', 241968),
(326776, 'PTHR13167:SF24', NULL, NULL, NULL, NULL, 'PIEZO-TYPE MECHANOSENSITIVE ION CHANNEL COMPONENT 2', 241968),
(326777, 'PTHR13167:SF46', NULL, NULL, NULL, NULL, 'DUF3595 FAMILY PROTEIN', 241968),
(326778, 'PTHR13167', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 241968),
(326779, 'PTHR46861', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 1A', 241969),
(326780, 'PTHR46861:SF1', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 1A', 241969),
(326781, 'PTHR45463:SF7', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 241970),
(326782, 'PTHR45463:SF4', NULL, NULL, NULL, NULL, 'OS09G0392200 PROTEIN', 241970),
(326783, 'PTHR45463:SF5', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN-RELATED', 241970),
(326784, 'PTHR45463', NULL, NULL, NULL, NULL, 'OS09G0392200 PROTEIN', 241970),
(326785, 'PTHR33172:SF91', NULL, NULL, NULL, NULL, 'OS08G0516900 PROTEIN', 241971),
(326786, 'PTHR33172', NULL, NULL, NULL, NULL, 'OS08G0516900 PROTEIN', 241971),
(326787, 'PTHR33172:SF90', NULL, NULL, NULL, NULL, 'OS06G0698748 PROTEIN', 241971),
(326788, 'PTHR33172:SF95', NULL, NULL, NULL, NULL, 'BNAA08G12440D PROTEIN', 241971),
(326789, 'PTHR33172:SF51', NULL, NULL, NULL, NULL, 'BNACNNG28890D PROTEIN', 241971),
(326790, 'PTHR33172:SF94', NULL, NULL, NULL, NULL, '', 241971),
(326791, 'PTHR33172:SF72', NULL, NULL, NULL, NULL, 'BNAANNG33350D PROTEIN', 241971),
(326792, 'PTHR33172:SF93', NULL, NULL, NULL, NULL, 'BNAA09G04750D PROTEIN', 241971),
(326793, 'PTHR33172:SF71', NULL, NULL, NULL, NULL, '', 241971),
(326794, 'PTHR33172:SF92', NULL, NULL, NULL, NULL, 'OSJNBA0088A01.13-LIKE PROTEIN', 241971),
(326795, 'PTHR33172:SF99', NULL, NULL, NULL, NULL, 'EMB|CAB83157.1', 241971),
(326796, 'PTHR33172:SF11', NULL, NULL, NULL, NULL, '', 241971),
(326797, 'PTHR33172:SF54', NULL, NULL, NULL, NULL, 'BNAC04G49880D PROTEIN', 241971);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(326798, 'PTHR33172:SF98', NULL, NULL, NULL, NULL, 'OXIDATIVE STRESS 3', 241971),
(326799, 'PTHR33172:SF53', NULL, NULL, NULL, NULL, 'BNAA05G32410D PROTEIN', 241971),
(326800, 'PTHR33172:SF75', NULL, NULL, NULL, NULL, 'BNAC02G12160D PROTEIN', 241971),
(326801, 'PTHR33172:SF97', NULL, NULL, NULL, NULL, '', 241971),
(326802, 'PTHR33172:SF74', NULL, NULL, NULL, NULL, 'MAJOR CENTROMERE AUTOANTIGEN B-LIKE PROTEIN', 241971),
(326803, 'PTHR33172:SF96', NULL, NULL, NULL, NULL, 'OS08G0458200 PROTEIN', 241971),
(326804, 'PTHR33172:SF37', NULL, NULL, NULL, NULL, 'MYOSIN LIGHT CHAIN KINASE DDB_G0279831 ISOFORM X1-RELATED', 241971),
(326805, 'PTHR33172:SF35', NULL, NULL, NULL, NULL, '', 241971),
(326806, 'PTHR33172:SF57', NULL, NULL, NULL, NULL, 'OS02G0778700 PROTEIN', 241971),
(326807, 'PTHR33172:SF34', NULL, NULL, NULL, NULL, 'OS09G0499000 PROTEIN', 241971),
(326808, 'PTHR33172:SF38', NULL, NULL, NULL, NULL, 'BNAA01G05330D PROTEIN', 241971),
(326809, 'PTHR33172:SF62', NULL, NULL, NULL, NULL, '', 241971),
(326810, 'PTHR33172:SF40', NULL, NULL, NULL, NULL, 'BNAA03G51540D PROTEIN', 241971),
(326811, 'PTHR33172:SF61', NULL, NULL, NULL, NULL, 'BNAA02G05360D PROTEIN', 241971),
(326812, 'PTHR33172:SF66', NULL, NULL, NULL, NULL, '', 241971),
(326813, 'PTHR33172:SF44', NULL, NULL, NULL, NULL, 'OS02G0684400 PROTEIN', 241971),
(326814, 'PTHR33172:SF88', NULL, NULL, NULL, NULL, '', 241971),
(326815, 'PTHR33172:SF87', NULL, NULL, NULL, NULL, '', 241971),
(326816, 'PTHR33172:SF65', NULL, NULL, NULL, NULL, 'OS06G0559400 PROTEIN', 241971),
(326817, 'PTHR33172:SF64', NULL, NULL, NULL, NULL, '', 241971),
(326818, 'PTHR33172:SF42', NULL, NULL, NULL, NULL, 'OXIDATIVE STRESS 3', 241971),
(326819, 'PTHR33172:SF48', NULL, NULL, NULL, NULL, 'BNAC09G36670D PROTEIN', 241971),
(326820, 'PTHR33172:SF68', NULL, NULL, NULL, NULL, '', 241971),
(326821, 'PTHR33172:SF89', NULL, NULL, NULL, NULL, '', 241971),
(326822, 'PTHR33172:SF29', NULL, NULL, NULL, NULL, 'OS04G0583200 PROTEIN', 241971),
(326823, 'PTHR19143:SF40', NULL, NULL, NULL, NULL, 'ANGIOPOIETIN-RELATED PROTEIN 7', 241972),
(326824, 'PTHR19143:SF254', NULL, NULL, NULL, NULL, 'TENASCIN-R', 241972),
(326825, 'PTHR19143:SF332', NULL, NULL, NULL, NULL, 'FIBRINOGEN BETA CHAIN', 241972),
(326826, 'PTHR19143:SF255', NULL, NULL, NULL, NULL, 'ANGIOPOIETIN-LIKE 1B', 241972),
(326827, 'PTHR19143:SF209', NULL, NULL, NULL, NULL, 'ANGIOPOIETIN-RELATED PROTEIN 6', 241972),
(326828, 'PTHR19143:SF45', NULL, NULL, NULL, NULL, 'FIBRINOGEN C DOMAIN-CONTAINING PROTEIN 1', 241972),
(326829, 'PTHR19143:SF402', NULL, NULL, NULL, NULL, 'FIBRINOGEN C-TERMINAL DOMAIN-CONTAINING PROTEIN', 241972),
(326830, 'PTHR19143:SF47', NULL, NULL, NULL, NULL, 'SI:CH211-157B11.8', 241972),
(326831, 'PTHR19143:SF327', NULL, NULL, NULL, NULL, 'APPLE DOMAIN-CONTAINING PROTEIN', 241972),
(326832, 'PTHR19143:SF263', NULL, NULL, NULL, NULL, 'FIBRINOGEN-LIKE PROTEIN 1', 241972),
(326833, 'PTHR19143:SF385', NULL, NULL, NULL, NULL, 'TENASCIN XBA', 241972),
(326834, 'PTHR19143:SF420', NULL, NULL, NULL, NULL, 'FIBRINOGEN C-TERMINAL DOMAIN-CONTAINING PROTEIN', 241972),
(326835, 'PTHR19143:SF222', NULL, NULL, NULL, NULL, 'ANGIOPOIETIN-RELATED PROTEIN 3', 241972),
(326836, 'PTHR19143:SF189', NULL, NULL, NULL, NULL, 'FIBROLEUKIN', 241972),
(326837, 'PTHR19143:SF185', NULL, NULL, NULL, NULL, 'ANGIOPOIETIN-RELATED PROTEIN 5', 241972),
(326838, 'PTHR19143:SF256', NULL, NULL, NULL, NULL, 'ANGIOPOIETIN-RELATED PROTEIN 4', 241972),
(326839, 'PTHR19143:SF377', NULL, NULL, NULL, NULL, 'FICOLIN-1', 241972),
(326840, 'PTHR19143:SF379', NULL, NULL, NULL, NULL, 'FIBRINOGEN C-TERMINAL DOMAIN-CONTAINING PROTEIN', 241972),
(326841, 'PTHR19143', NULL, NULL, NULL, NULL, 'FIBRINOGEN/TENASCIN/ANGIOPOEITIN', 241972),
(326842, 'PTHR19143:SF337', NULL, NULL, NULL, NULL, 'FICOLIN-1', 241972),
(326843, 'PTHR19143:SF338', NULL, NULL, NULL, NULL, 'FIBRINOGEN GAMMA CHAIN', 241972),
(326844, 'PTHR19143:SF415', NULL, NULL, NULL, NULL, 'FICOLIN-3', 241972),
(326845, 'PTHR19143:SF272', NULL, NULL, NULL, NULL, 'FIBRINOGEN C-TERMINAL DOMAIN-CONTAINING PROTEIN', 241972);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(326846, 'PTHR19143:SF394', NULL, NULL, NULL, NULL, 'FIBRINOGEN C-TERMINAL DOMAIN-CONTAINING PROTEIN', 241972),
(326847, 'PTHR19143:SF430', NULL, NULL, NULL, NULL, 'B, PUTATIVE-RELATED', 241972),
(326848, 'PTHR19143:SF431', NULL, NULL, NULL, NULL, 'PROTEIN SCABROUS', 241972),
(326849, 'PTHR19143:SF156', NULL, NULL, NULL, NULL, 'ANGIOPOIETIN-1', 241972),
(326850, 'PTHR19143:SF199', NULL, NULL, NULL, NULL, 'ANGIOPOIETIN-2', 241972),
(326851, 'PTHR19143:SF429', NULL, NULL, NULL, NULL, 'ANGIOPOIETIN LIKE 6', 241972),
(326852, 'PTHR19143:SF24', NULL, NULL, NULL, NULL, 'ANGIOPOIETIN-RELATED PROTEIN 2', 241972),
(326853, 'PTHR19143:SF422', NULL, NULL, NULL, NULL, 'FIBRINOGEN C-TERMINAL DOMAIN-CONTAINING PROTEIN', 241972),
(326854, 'PTHR19143:SF225', NULL, NULL, NULL, NULL, 'MICROFIBRIL-ASSOCIATED GLYCOPROTEIN 4', 241972),
(326855, 'PTHR19143:SF423', NULL, NULL, NULL, NULL, 'PROTEIN SCABROUS-LIKE PROTEIN', 241972),
(326856, 'PTHR19143:SF25', NULL, NULL, NULL, NULL, 'ANGIOPOIETIN-RELATED PROTEIN 1', 241972),
(326857, 'PTHR19143:SF424', NULL, NULL, NULL, NULL, 'FIBRINOGEN C-TERMINAL DOMAIN-CONTAINING PROTEIN', 241972),
(326858, 'PTHR19143:SF425', NULL, NULL, NULL, NULL, 'FIBRINOGEN C-TERMINAL DOMAIN-CONTAINING PROTEIN', 241972),
(326859, 'PTHR19143:SF348', NULL, NULL, NULL, NULL, 'TENASCIN-N', 241972),
(326860, 'PTHR19143:SF426', NULL, NULL, NULL, NULL, 'FI21813P1-RELATED', 241972),
(326861, 'PTHR19143:SF427', NULL, NULL, NULL, NULL, 'FIBRINOGEN C-TERMINAL DOMAIN-CONTAINING PROTEIN', 241972),
(326862, 'PTHR19143:SF428', NULL, NULL, NULL, NULL, 'FIBRINOGEN C-TERMINAL DOMAIN-CONTAINING PROTEIN-RELATED', 241972),
(326863, 'PTHR19143:SF440', NULL, NULL, NULL, NULL, 'FIBRINOGEN C-TERMINAL DOMAIN-CONTAINING PROTEIN', 241972),
(326864, 'PTHR19143:SF441', NULL, NULL, NULL, NULL, 'FIBRINOGEN C-TERMINAL DOMAIN-CONTAINING PROTEIN', 241972),
(326865, 'PTHR19143:SF243', NULL, NULL, NULL, NULL, 'ANGIOPOIETIN 2', 241972),
(326866, 'PTHR19143:SF442', NULL, NULL, NULL, NULL, 'FIBRINOGEN C-TERMINAL DOMAIN-CONTAINING PROTEIN', 241972),
(326867, 'PTHR19143:SF432', NULL, NULL, NULL, NULL, 'FIBRINOGEN C-TERMINAL DOMAIN-CONTAINING PROTEIN', 241972),
(326868, 'PTHR19143:SF433', NULL, NULL, NULL, NULL, 'FICOLIN-2', 241972),
(326869, 'PTHR19143:SF434', NULL, NULL, NULL, NULL, 'SI:CH211-203K16.3', 241972),
(326870, 'PTHR19143:SF435', NULL, NULL, NULL, NULL, 'FIBRINOGEN C-TERMINAL DOMAIN-CONTAINING PROTEIN', 241972),
(326871, 'PTHR19143:SF31', NULL, NULL, NULL, NULL, 'ANGIOPOIETIN-4', 241972),
(326872, 'PTHR19143:SF436', NULL, NULL, NULL, NULL, 'FIBRINOGEN C-TERMINAL DOMAIN-CONTAINING PROTEIN', 241972),
(326873, 'PTHR19143:SF437', NULL, NULL, NULL, NULL, 'FIBRINOGEN C-TERMINAL DOMAIN-CONTAINING PROTEIN', 241972),
(326874, 'PTHR19143:SF438', NULL, NULL, NULL, NULL, 'FIBRINOGEN C-TERMINAL DOMAIN-CONTAINING PROTEIN', 241972),
(326875, 'PTHR19143:SF439', NULL, NULL, NULL, NULL, 'FIBRINOGEN C-TERMINAL DOMAIN-CONTAINING PROTEIN', 241972),
(326876, 'PTHR11710:SF0', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S19', 241973),
(326877, 'PTHR11710:SF19', NULL, NULL, NULL, NULL, 'BNAC07G31040D PROTEIN', 241973),
(326878, 'PTHR11710:SF18', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S19-3-LIKE', 241973),
(326879, 'PTHR11710:SF29', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S19-1-RELATED', 241973),
(326880, 'PTHR11710:SF28', NULL, NULL, NULL, NULL, '', 241973),
(326881, 'PTHR11710', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S19', 241973),
(326882, 'PTHR11710:SF27', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S19', 241973),
(326883, 'PTHR11710:SF26', NULL, NULL, NULL, NULL, 'LOW QUALITY PROTEIN: 40S RIBOSOMAL PROTEIN S19-3-LIKE', 241973),
(326884, 'PTHR11710:SF15', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S19', 241973),
(326885, 'PTHR11710:SF13', NULL, NULL, NULL, NULL, '', 241973),
(326886, 'PTHR11710:SF24', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S19-3', 241973),
(326887, 'PTHR11710:SF22', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S19E, WINGED HELIX-TURN-HELIX DNA-BINDING DOMAIN PROTEIN-RELATED', 241973),
(326888, 'PTHR11710:SF32', NULL, NULL, NULL, NULL, '', 241973);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(326889, 'PTHR11710:SF21', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S19', 241973),
(326890, 'PTHR11710:SF31', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S19', 241973),
(326891, 'PTHR11710:SF30', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S19', 241973),
(326892, 'PTHR46826', NULL, NULL, NULL, NULL, '', 241974),
(326893, 'PTHR46826:SF1', NULL, NULL, NULL, NULL, 'TVP38/TMEM64 FAMILY MEMBRANE PROTEIN YDJX', 241974),
(326894, 'PTHR30381', NULL, NULL, NULL, NULL, 'FLAGELLAR P-RING PERIPLASMIC PROTEIN FLGI', 241975),
(326895, 'PTHR30381:SF0', NULL, NULL, NULL, NULL, 'FLAGELLAR P-RING PROTEIN', 241975),
(326896, 'PTHR13003:SF2', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP107', 241976),
(326897, 'PTHR13003:SF4', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN', 241976),
(326898, 'PTHR13003', NULL, NULL, NULL, NULL, 'NUP107-RELATED', 241976),
(326899, 'PTHR47767:SF1', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F2_4 DOMAIN-CONTAINING PROTEIN', 241977),
(326900, 'PTHR47767', NULL, NULL, NULL, NULL, 'ADHESION G PROTEIN-COUPLED RECEPTOR G7', 241977),
(326901, 'PTHR10739:SF27', NULL, NULL, NULL, NULL, 'PHOSPHATE CYTIDYLYLTRANSFERASE 1, CHOLINE, BETA B', 241978),
(326902, 'PTHR10739:SF48', NULL, NULL, NULL, NULL, 'CTP_TRANSF_LIKE DOMAIN-CONTAINING PROTEIN', 241978),
(326903, 'PTHR10739:SF47', NULL, NULL, NULL, NULL, 'OS08G0161800 PROTEIN', 241978),
(326904, 'PTHR10739:SF19', NULL, NULL, NULL, NULL, 'CHOLINE-PHOSPHATE CYTIDYLYLTRANSFERASE A', 241978),
(326905, 'PTHR10739', NULL, NULL, NULL, NULL, 'CYTIDYLYLTRANSFERASE', 241978),
(326906, 'PTHR10739:SF60', NULL, NULL, NULL, NULL, 'CHOLINE-PHOSPHATE CYTIDYLYLTRANSFERASE 2', 241978),
(326907, 'PTHR10739:SF53', NULL, NULL, NULL, NULL, 'CTP_TRANSF_LIKE DOMAIN-CONTAINING PROTEIN', 241978),
(326908, 'PTHR10739:SF20', NULL, NULL, NULL, NULL, 'CHOLINE-PHOSPHATE CYTIDYLYLTRANSFERASE B', 241978),
(326909, 'PTHR10739:SF62', NULL, NULL, NULL, NULL, 'CHOLINE-PHOSPHATE CYTIDYLYLTRANSFERASE 2-LIKE ISOFORM X1', 241978),
(326910, 'PTHR10739:SF50', NULL, NULL, NULL, NULL, 'PHOSPHORYLCHOLINE CYTIDYLYLTRANSFERASE-RELATED', 241978),
(326911, 'PTHR10739:SF61', NULL, NULL, NULL, NULL, 'CHOLINEPHOSPHATE CYTIDYLYLTRANSFERASE', 241978),
(326912, 'PTHR10739:SF13', NULL, NULL, NULL, NULL, 'GH25855P-RELATED', 241978),
(326913, 'PTHR10739:SF57', NULL, NULL, NULL, NULL, 'CHOLINE-PHOSPHATE CYTIDYLYLTRANSFERASE-RELATED', 241978),
(326914, 'PTHR10739:SF56', NULL, NULL, NULL, NULL, 'CHOLINE-PHOSPHATE CYTIDYLYLTRANSFERASE 1', 241978),
(326915, 'PTHR10739:SF55', NULL, NULL, NULL, NULL, 'CTP_TRANSF_LIKE DOMAIN-CONTAINING PROTEIN', 241978),
(326916, 'PTHR34295:SF3', NULL, NULL, NULL, NULL, 'BIOTIN TRANSPORTER BIOYB-RELATED', 241979),
(326917, 'PTHR34295:SF1', NULL, NULL, NULL, NULL, 'BIOTIN TRANSPORTER BIOY', 241979),
(326918, 'PTHR34295', NULL, NULL, NULL, NULL, 'BIOTIN TRANSPORTER BIOY', 241979),
(326919, 'PTHR36004:SF1', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN PROTEIN', 241980),
(326920, 'PTHR36004', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN PROTEIN', 241980),
(326921, 'PTHR36004:SF3', NULL, NULL, NULL, NULL, 'BNAA02G16590D PROTEIN', 241980),
(326922, 'PTHR36576:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CON-6, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G03615)-RELATED', 241981),
(326923, 'PTHR36576', NULL, NULL, NULL, NULL, 'UPF0654 PROTEIN C11D3.01C-RELATED', 241981),
(326924, 'PTHR36576:SF1', NULL, NULL, NULL, NULL, 'UPF0654 PROTEIN C11D3.01C-RELATED', 241981),
(326925, 'PTHR44575:SF9', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 241982),
(326926, 'PTHR44575:SF8', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 241982),
(326927, 'PTHR44575:SF3', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 241982),
(326928, 'PTHR44575:SF2', NULL, NULL, NULL, NULL, 'OS01G0589200 PROTEIN', 241982),
(326929, 'PTHR44575:SF1', NULL, NULL, NULL, NULL, 'OS01G0716500 PROTEIN', 241982),
(326930, 'PTHR44575:SF7', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 241982); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(326931, 'PTHR44575:SF6', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 241982),
(326932, 'PTHR44575', NULL, NULL, NULL, NULL, 'OS01G0589200 PROTEIN', 241982),
(326933, 'PTHR44575:SF5', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 241982),
(326934, 'PTHR44575:SF4', NULL, NULL, NULL, NULL, 'EMBRYONIC ABUNDANT PROTEIN-LIKE', 241982),
(326935, 'PTHR35481:SF4', NULL, NULL, NULL, NULL, '', 241983),
(326936, 'PTHR35481:SF5', NULL, NULL, NULL, NULL, 'BNAA04G22020D PROTEIN', 241983),
(326937, 'PTHR35481:SF2', NULL, NULL, NULL, NULL, 'BNAC03G21320D PROTEIN', 241983),
(326938, 'PTHR35481:SF3', NULL, NULL, NULL, NULL, 'BNAANNG13270D PROTEIN', 241983),
(326939, 'PTHR35481', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT ALPHA', 241983),
(326940, 'PTHR35481:SF1', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT ALPHA', 241983),
(326941, 'PTHR31354:SF12', NULL, NULL, NULL, NULL, 'BNAA07G28690D PROTEIN', 241984),
(326942, 'PTHR31354:SF13', NULL, NULL, NULL, NULL, '', 241984),
(326943, 'PTHR31354:SF9', NULL, NULL, NULL, NULL, '', 241984),
(326944, 'PTHR31354:SF8', NULL, NULL, NULL, NULL, 'INOSITOL-1,4,5-TRISPHOSPHATE 5-PHOSPHATASE', 241984),
(326945, 'PTHR31354:SF7', NULL, NULL, NULL, NULL, 'OS09G0392000 PROTEIN', 241984),
(326946, 'PTHR31354:SF6', NULL, NULL, NULL, NULL, '', 241984),
(326947, 'PTHR31354:SF4', NULL, NULL, NULL, NULL, 'OS08G0425000 PROTEIN', 241984),
(326948, 'PTHR31354:SF2', NULL, NULL, NULL, NULL, 'OS01G0793500 PROTEIN', 241984),
(326949, 'PTHR31354:SF11', NULL, NULL, NULL, NULL, 'BNAC09G31390D PROTEIN', 241984),
(326950, 'PTHR31354', NULL, NULL, NULL, NULL, 'OS01G0793500 PROTEIN', 241984),
(326951, 'PTHR43283:SF7', NULL, NULL, NULL, NULL, 'BETA-LACTAMASE DOMAIN-CONTAINING PROTEIN', 241985),
(326952, 'PTHR43283:SF11', NULL, NULL, NULL, NULL, 'BETA-LACTAMASE DOMAIN-CONTAINING PROTEIN', 241985),
(326953, 'PTHR43283:SF14', NULL, NULL, NULL, NULL, 'BLL8153 PROTEIN', 241985),
(326954, 'PTHR43283', NULL, NULL, NULL, NULL, 'BETA-LACTAMASE-RELATED', 241985),
(326955, 'PTHR43283:SF15', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', 241985),
(326956, 'PTHR43283:SF16', NULL, NULL, NULL, NULL, '(LOVD), PUTATIVE (AFU_ORTHOLOGUE AFUA_5G00920)-RELATED', 241985),
(326957, 'PTHR43283:SF3', NULL, NULL, NULL, NULL, 'BETA-LACTAMASE DOMAIN-CONTAINING PROTEIN', 241985),
(326958, 'PTHR36234:SF5', NULL, NULL, NULL, NULL, 'LYSYL ENDOPEPTIDASE', 241986),
(326959, 'PTHR36234', NULL, NULL, NULL, NULL, 'LYSYL ENDOPEPTIDASE', 241986),
(326960, 'PTHR16509:SF1', NULL, NULL, NULL, NULL, 'MANGANESE-DEPENDENT ADP-RIBOSE/CDP-ALCOHOL DIPHOSPHATASE', 241987),
(326961, 'PTHR16509', NULL, NULL, NULL, NULL, '', 241987),
(326962, 'PTHR16509:SF8', NULL, NULL, NULL, NULL, 'MANGANESE-DEPENDENT ADP-RIBOSE/CDP-ALCOHOL DIPHOSPHATASE', 241987),
(326963, 'PTHR16509:SF7', NULL, NULL, NULL, NULL, 'ADPRIBASE-MN', 241987),
(326964, 'PTHR16509:SF6', NULL, NULL, NULL, NULL, 'MANGANESE-DEPENDENT ADP-RIBOSE/CDP-ALCOHOL DIPHOSPHATASE', 241987),
(326965, 'PTHR22921', NULL, NULL, NULL, NULL, 'PROTEIN CBG20088-RELATED', 241988),
(326966, 'PTHR22921:SF27', NULL, NULL, NULL, NULL, 'PROTEIN CBG20088', 241988),
(326967, 'PTHR43534', NULL, NULL, NULL, NULL, 'MIND SUPERFAMILY P-LOOP ATPASE CONTAINING AN INSERTED FERREDOXIN DOMAIN', 241989),
(326968, 'PTHR43534:SF1', NULL, NULL, NULL, NULL, '4FE-4S CLUSTER CONTAINING PARA FAMILY ATPASE PROTEIN', 241989),
(326969, 'PTHR21508:SF5', NULL, NULL, NULL, NULL, 'MITOGUARDIN', 241990),
(326970, 'PTHR21508:SF4', NULL, NULL, NULL, NULL, 'MITOGUARDIN 2', 241990),
(326971, 'PTHR21508:SF3', NULL, NULL, NULL, NULL, 'MITOGUARDIN 1', 241990),
(326972, 'PTHR21508', NULL, NULL, NULL, NULL, 'MITOGUARDIN', 241990),
(326973, 'PTHR36121', NULL, NULL, NULL, NULL, 'PROTEIN SXY', 241991),
(326974, 'PTHR36121:SF1', NULL, NULL, NULL, NULL, 'PROTEIN SXY', 241991),
(326975, 'PTHR46449', NULL, NULL, NULL, NULL, 'ZGC:158260', 241992),
(326976, 'PTHR46449:SF1', NULL, NULL, NULL, NULL, 'FAMILY WITH SEQUENCE SIMILARITY 47, MEMBER A', 241992);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(326977, 'PTHR46449:SF3', NULL, NULL, NULL, NULL, 'PROTEIN FAM47E', 241992),
(326978, 'PTHR46449:SF2', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4930402K13 GENE', 241992),
(326979, 'PTHR46449:SF5', NULL, NULL, NULL, NULL, 'ZGC:158260', 241992),
(326980, 'PTHR46449:SF4', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4930480E11 GENE', 241992),
(326981, 'PTHR43152:SF1', NULL, NULL, NULL, NULL, 'UVRA PROTEIN', 241993),
(326982, 'PTHR43152:SF3', NULL, NULL, NULL, NULL, 'UVRABC SYSTEM PROTEIN A', 241993),
(326983, 'PTHR43152:SF2', NULL, NULL, NULL, NULL, 'ANTIBIOTIC/DRUG RESISTANCE ABC TRANSPORTER-RELATED', 241993),
(326984, 'PTHR43152', NULL, NULL, NULL, NULL, 'UVRABC SYSTEM PROTEIN A', 241993),
(326985, 'PTHR43152:SF4', NULL, NULL, NULL, NULL, 'UVRABC SYSTEM PROTEIN A', 241993),
(326986, 'PTHR45739:SF5', NULL, NULL, NULL, NULL, 'FRAS1-RELATED EXTRACELLULAR MATRIX PROTEIN 3', 241994),
(326987, 'PTHR45739:SF3', NULL, NULL, NULL, NULL, 'FRAS1-RELATED EXTRACELLULAR MATRIX 1B', 241994),
(326988, 'PTHR45739:SF4', NULL, NULL, NULL, NULL, 'FRAS1-RELATED EXTRACELLULAR MATRIX PROTEIN 2', 241994),
(326989, 'PTHR45739:SF1', NULL, NULL, NULL, NULL, 'EXTRACELLULAR MATRIX ORGANIZING PROTEIN FRAS1', 241994),
(326990, 'PTHR45739', NULL, NULL, NULL, NULL, 'MATRIX PROTEIN, PUTATIVE-RELATED', 241994),
(326991, 'PTHR45739:SF11', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 241994),
(326992, 'PTHR45739:SF7', NULL, NULL, NULL, NULL, 'FRAS1-RELATED EXTRACELLULAR MATRIX PROTEIN 1', 241994),
(326993, 'PTHR45739:SF8', NULL, NULL, NULL, NULL, 'TNFR-CYS DOMAIN-CONTAINING PROTEIN', 241994),
(326994, 'PTHR17085:SF3', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR COACTIVATOR 4', 241995),
(326995, 'PTHR17085', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR COACTIVATOR 4', 241995),
(326996, 'PTHR17085:SF6', NULL, NULL, NULL, NULL, '', 241995),
(326997, 'PTHR17085:SF5', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR COACTIVATOR 4', 241995),
(326998, 'PTHR11035:SF35', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN (3R)-3-HYDROXYACYL-COA DEHYDRATASE', 241996),
(326999, 'PTHR11035:SF24', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN (3R)-3-HYDROXYACYL-COA DEHYDRATASE', 241996),
(327000, 'PTHR11035:SF22', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN (3R)-3-HYDROXYACYL-COA DEHYDRATASE 1', 241996),
(327001, 'PTHR11035:SF17', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN (3R)-3-HYDROXYACYL-COA DEHYDRATASE 2', 241996),
(327002, 'PTHR11035:SF39', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN (3R)-3-HYDROXYACYL-COA DEHYDRATASE', 241996),
(327003, 'PTHR11035:SF16', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN (3R)-3-HYDROXYACYL-COA DEHYDRATASE 4', 241996),
(327004, 'PTHR11035:SF38', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN (3R)-3-HYDROXYACYL-COA DEHYDRATASE', 241996),
(327005, 'PTHR11035:SF37', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN (3R)-3-HYDROXYACYL-COA DEHYDRATASE', 241996),
(327006, 'PTHR11035:SF36', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN (3R)-3-HYDROXYACYL-COA DEHYDRATASE', 241996),
(327007, 'PTHR11035', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN (3R)-3-HYDROXYACYL-COA DEHYDRATASE', 241996),
(327008, 'PTHR11035:SF3', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN (3R)-3-HYDROXYACYL-COA DEHYDRATASE', 241996),
(327009, 'PTHR11035:SF20', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN (3R)-3-HYDROXYACYL-COA DEHYDRATASE 3', 241996),
(327010, 'PTHR48224', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 270-RELATED', 241997),
(327011, 'PTHR48224:SF1', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 270-RELATED', 241997),
(327012, 'PTHR24120', NULL, NULL, NULL, NULL, 'GH07239P', 241998),
(327013, 'PTHR24120:SF4', NULL, NULL, NULL, NULL, 'GH07239P', 241998),
(327014, 'PTHR24120:SF3', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 29', 241998),
(327015, 'PTHR24120:SF8', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX PROTEIN 12', 241998),
(327016, 'PTHR31807:SF27', NULL, NULL, NULL, NULL, 'QWRF MOTIF-CONTAINING PROTEIN 7', 241999),
(327017, 'PTHR31807:SF38', NULL, NULL, NULL, NULL, 'QWRF MOTIF-CONTAINING PROTEIN 9', 241999),
(327018, 'PTHR31807:SF2', NULL, NULL, NULL, NULL, 'PROTEIN SNOWY COTYLEDON 3', 241999);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(327019, 'PTHR31807:SF48', NULL, NULL, NULL, NULL, '', 241999),
(327020, 'PTHR31807:SF37', NULL, NULL, NULL, NULL, 'HAUS AUGMIN-LIKE COMPLEX SUBUNIT 8', 241999),
(327021, 'PTHR31807:SF36', NULL, NULL, NULL, NULL, 'QWRF MOTIF-CONTAINING PROTEIN 4', 241999),
(327022, 'PTHR31807:SF47', NULL, NULL, NULL, NULL, 'QWRF FAMILY-RELATED', 241999),
(327023, 'PTHR31807:SF25', NULL, NULL, NULL, NULL, 'QWRF MOTIF-CONTAINING PROTEIN 6', 241999),
(327024, 'PTHR31807:SF46', NULL, NULL, NULL, NULL, 'QWRF FAMILY-RELATED', 241999),
(327025, 'PTHR31807:SF35', NULL, NULL, NULL, NULL, 'DUF566 DOMAIN CONTAINING FAMILY PROTEIN-RELATED', 241999),
(327026, 'PTHR31807:SF45', NULL, NULL, NULL, NULL, 'BNAA04G25600D PROTEIN', 241999),
(327027, 'PTHR31807:SF6', NULL, NULL, NULL, NULL, 'PROTEIN ENDOSPERM DEFECTIVE 1-RELATED', 241999),
(327028, 'PTHR31807:SF44', NULL, NULL, NULL, NULL, 'AUGMIN SUBUNIT 8', 241999),
(327029, 'PTHR31807:SF22', NULL, NULL, NULL, NULL, 'OS07G0115600 PROTEIN', 241999),
(327030, 'PTHR31807:SF43', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 241999),
(327031, 'PTHR31807:SF32', NULL, NULL, NULL, NULL, 'QWRF MOTIF-CONTAINING PROTEIN 2', 241999),
(327032, 'PTHR31807:SF53', NULL, NULL, NULL, NULL, 'QWRF FAMILY-RELATED', 241999),
(327033, 'PTHR31807:SF31', NULL, NULL, NULL, NULL, 'QWRF MOTIF PROTEIN (DUF566)-RELATED', 241999),
(327034, 'PTHR31807:SF52', NULL, NULL, NULL, NULL, 'QWRF FAMILY-RELATED', 241999),
(327035, 'PTHR31807:SF30', NULL, NULL, NULL, NULL, 'BNAA04G14090D PROTEIN', 241999),
(327036, 'PTHR31807:SF41', NULL, NULL, NULL, NULL, 'BNAA08G29650D PROTEIN', 241999),
(327037, 'PTHR31807:SF51', NULL, NULL, NULL, NULL, 'QWRF MOTIF-CONTAINING PROTEIN 2-LIKE ISOFORM X1', 241999),
(327038, 'PTHR31807', NULL, NULL, NULL, NULL, 'AUGMIN FAMILY MEMBER', 241999),
(327039, 'PTHR31807:SF50', NULL, NULL, NULL, NULL, 'QWRF MOTIF-CONTAINING PROTEIN 6', 241999),
(327040, 'PTHR14562:SF3', NULL, NULL, NULL, NULL, 'TATA BOX-BINDING PROTEIN-ASSOCIATED FACTOR RNA POLYMERASE I SUBUNIT D', 242000),
(327041, 'PTHR14562', NULL, NULL, NULL, NULL, 'TATA BOX-BINDING PROTEIN ASSOCIATED FACTOR RNA POLYMERASE I SUBUNIT D', 242000),
(327042, 'PTHR13317', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 242001),
(327043, 'PTHR13317:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE ANTERIOR POSTERIOR TRANSFORMATION PROTEIN 1 HOMOLOG', 242001),
(327044, 'PTHR35703:SF1', NULL, NULL, NULL, NULL, 'INACTIVE HEME OXYGENASE 2, CHLOROPLASTIC-RELATED', 242002),
(327045, 'PTHR35703:SF2', NULL, NULL, NULL, NULL, 'HEME OXYGENASE 1, CHLOROPLASTIC-RELATED', 242002),
(327046, 'PTHR35703', NULL, NULL, NULL, NULL, 'HEME OXYGENASE 1, CHLOROPLASTIC-RELATED', 242002),
(327047, 'PTHR35703:SF7', NULL, NULL, NULL, NULL, 'BNAC06G17920D PROTEIN', 242002),
(327048, 'PTHR35703:SF5', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 242002),
(327049, 'PTHR35703:SF6', NULL, NULL, NULL, NULL, 'HEME OXYGENASE-LIKE PROTEIN-RELATED', 242002),
(327050, 'PTHR35703:SF3', NULL, NULL, NULL, NULL, 'HEME OXYGENASE3', 242002),
(327051, 'PTHR35703:SF4', NULL, NULL, NULL, NULL, 'BNAC09G15420D PROTEIN', 242002),
(327052, 'PTHR35631:SF3', NULL, NULL, NULL, NULL, 'OS08G0114150 PROTEIN', 242003),
(327053, 'PTHR35631:SF6', NULL, NULL, NULL, NULL, '', 242003),
(327054, 'PTHR35631:SF11', NULL, NULL, NULL, NULL, '', 242003),
(327055, 'PTHR35631:SF12', NULL, NULL, NULL, NULL, '', 242003),
(327056, 'PTHR35631', NULL, NULL, NULL, NULL, 'OS08G0114150 PROTEIN', 242003),
(327057, 'PTHR46548', NULL, NULL, NULL, NULL, 'BAH AND TFIIS DOMAIN-CONTAINING PROTEIN-RELATED', 242004),
(327058, 'PTHR46548:SF5', NULL, NULL, NULL, NULL, 'BNAANNG26470D PROTEIN', 242004),
(327059, 'PTHR46548:SF7', NULL, NULL, NULL, NULL, '', 242004),
(327060, 'PTHR46548:SF10', NULL, NULL, NULL, NULL, '', 242004),
(327061, 'PTHR46548:SF1', NULL, NULL, NULL, NULL, 'BAH AND TFIIS DOMAIN-CONTAINING PROTEIN-RELATED', 242004),
(327062, 'PTHR46548:SF3', NULL, NULL, NULL, NULL, 'BAH DOMAIN-CONTAINING PROTEIN', 242004),
(327063, 'PTHR46548:SF2', NULL, NULL, NULL, NULL, 'BAH DOMAIN-CONTAINING PROTEIN', 242004),
(327064, 'PTHR28586:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PAXX', 242005);
INSERT INTO "PUBLIC"."MODEL" VALUES
(327065, 'PTHR28586', NULL, NULL, NULL, NULL, 'PROTEIN PAXX', 242005),
(327066, 'PTHR34071', NULL, NULL, NULL, NULL, '5-NITROIMIDAZOLE ANTIBIOTICS RESISTANCE PROTEIN, NIMA-FAMILY-RELATED PROTEIN-RELATED', 242006),
(327067, 'PTHR34071:SF3', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 242006),
(327068, 'PTHR34071:SF2', NULL, NULL, NULL, NULL, '5-NITROIMIDAZOLE ANTIBIOTICS RESISTANCE PROTEIN, NIMA-FAMILY-RELATED PROTEIN', 242006),
(327069, 'PTHR18901:SF39', NULL, NULL, NULL, NULL, '', 242007),
(327070, 'PTHR18901:SF38', NULL, NULL, NULL, NULL, 'PSEUDOURIDINE-5''-PHOSPHATASE', 242007),
(327071, 'PTHR18901', NULL, NULL, NULL, NULL, '2-DEOXYGLUCOSE-6-PHOSPHATE PHOSPHATASE 2', 242007),
(327072, 'PTHR18901:SF46', NULL, NULL, NULL, NULL, 'HALOACID DEHALOGENASE-LIKE HYDROLASE', 242007),
(327073, 'PTHR18901:SF44', NULL, NULL, NULL, NULL, 'OS01G0757900 PROTEIN', 242007),
(327074, 'PTHR18901:SF43', NULL, NULL, NULL, NULL, 'PSEUDOURIDINE-5''-PHOSPHATASE', 242007),
(327075, 'PTHR18901:SF42', NULL, NULL, NULL, NULL, 'SUPERFAMILY HYDROLASE, PUTATIVE-RELATED', 242007),
(327076, 'PTHR18901:SF41', NULL, NULL, NULL, NULL, '(DL)-GLYCEROL-3-PHOSPHATASE 1, MITOCHONDRIAL', 242007),
(327077, 'PTHR18901:SF40', NULL, NULL, NULL, NULL, '(DL)-GLYCEROL-3-PHOSPHATASE 2', 242007),
(327078, 'PTHR47157:SF1', NULL, NULL, NULL, NULL, 'CHROMODOMAIN-HELICASE-DNA-BINDING PROTEIN 1-LIKE', 242008),
(327079, 'PTHR47157', NULL, NULL, NULL, NULL, 'CHROMODOMAIN-HELICASE-DNA-BINDING PROTEIN 1-LIKE', 242008),
(327080, 'PTHR31051', NULL, NULL, NULL, NULL, 'PROTEASOME ASSEMBLY CHAPERONE 3', 242009),
(327081, 'PTHR31051:SF1', NULL, NULL, NULL, NULL, 'PROTEASOME ASSEMBLY CHAPERONE 3', 242009),
(327082, 'PTHR10224:SF17', NULL, NULL, NULL, NULL, '', 242010),
(327083, 'PTHR10224:SF18', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 242010),
(327084, 'PTHR10224:SF15', NULL, NULL, NULL, NULL, 'ES1 PROTEIN, MITOCHONDRIAL', 242010),
(327085, 'PTHR10224:SF16', NULL, NULL, NULL, NULL, 'GLUTAMINE AMIDOTRANSFERASE-LIKE CLASS 1 DOMAIN-CONTAINING PROTEIN 3A, MITOCHONDRIAL', 242010),
(327086, 'PTHR10224:SF5', NULL, NULL, NULL, NULL, 'ZGC:162944', 242010),
(327087, 'PTHR10224:SF11', NULL, NULL, NULL, NULL, 'SI:CH211-153B23.5', 242010),
(327088, 'PTHR10224:SF12', NULL, NULL, NULL, NULL, 'GLYOXALASE ELBB', 242010),
(327089, 'PTHR10224', NULL, NULL, NULL, NULL, 'ES1 PROTEIN HOMOLOG, MITOCHONDRIAL', 242010),
(327090, 'PTHR10224:SF9', NULL, NULL, NULL, NULL, 'GLUTAMINE AMIDOTRANSFERASE-LIKE CLASS 1 DOMAIN-CONTAINING PROTEIN 3A, MITOCHONDRIAL-RELATED', 242010),
(327091, 'PTHR44688:SF16', NULL, NULL, NULL, NULL, 'DNA-BINDING TRANSCRIPTIONAL ACTIVATOR DEVR/DOSR', 242011),
(327092, 'PTHR44688', NULL, NULL, NULL, NULL, '', 242011),
(327093, 'PTHR44688:SF18', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN FIXJ', 242011),
(327094, 'PTHR44688:SF7', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR MALT', 242011),
(327095, 'PTHR44688:SF23', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR PROTEIN BJAR1', 242011),
(327096, 'PTHR44688:SF13', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN SDIA', 242011),
(327097, 'PTHR44688:SF9', NULL, NULL, NULL, NULL, 'CSGBAC OPERON TRANSCRIPTIONAL REGULATORY PROTEIN', 242011),
(327098, 'PTHR44688:SF24', NULL, NULL, NULL, NULL, 'DNA-BINDING TRANSCRIPTIONAL ACTIVATOR EVGA-RELATED', 242011),
(327099, 'PTHR46499:SF2', NULL, NULL, NULL, NULL, 'ARCHAEOSINE SYNTHASE', 242012),
(327100, 'PTHR46499:SF1', NULL, NULL, NULL, NULL, 'QUEUINE TRNA-RIBOSYLTRANSFERASE', 242012),
(327101, 'PTHR46499', NULL, NULL, NULL, NULL, 'QUEUINE TRNA-RIBOSYLTRANSFERASE', 242012),
(327102, 'PTHR34967:SF1', NULL, NULL, NULL, NULL, 'OS02G0257200 PROTEIN', 242013),
(327103, 'PTHR34967', NULL, NULL, NULL, NULL, 'OS02G0257200 PROTEIN', 242013),
(327104, 'PTHR34967:SF4', NULL, NULL, NULL, NULL, '', 242013),
(327105, 'PTHR34967:SF2', NULL, NULL, NULL, NULL, 'OS05G0586700 PROTEIN', 242013),
(327106, 'PTHR34943:SF2', NULL, NULL, NULL, NULL, 'PROTEIN COFACTOR ASSEMBLY OF COMPLEX C SUBUNIT B CCB4, CHLOROPLASTIC', 242014),
(327107, 'PTHR34943', NULL, NULL, NULL, NULL, '', 242014);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(327108, 'PTHR42637:SF1', NULL, NULL, NULL, NULL, 'TRNA-(MS[2]IO[6]A)-HYDROXYLASE', 242015),
(327109, 'PTHR42637', NULL, NULL, NULL, NULL, 'TRNA-(MS[2]IO[6]A)-HYDROXYLASE', 242015),
(327110, 'PTHR37377:SF2', NULL, NULL, NULL, NULL, '', 242016),
(327111, 'PTHR37377:SF3', NULL, NULL, NULL, NULL, '', 242016),
(327112, 'PTHR37377', NULL, NULL, NULL, NULL, 'RIBULOSE BISPHOSPHATE CARBOXYLASE LARGE CHAIN', 242016),
(327113, 'PTHR37377:SF4', NULL, NULL, NULL, NULL, '', 242016),
(327114, 'PTHR11716:SF52', NULL, NULL, NULL, NULL, 'OS11G0546600 PROTEIN', 242017),
(327115, 'PTHR11716:SF1', NULL, NULL, NULL, NULL, 'OTOCONIN-90', 242017),
(327116, 'PTHR11716:SF10', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A2 GROUP V', 242017),
(327117, 'PTHR11716:SF87', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A2 HOMOLOG 2-RELATED', 242017),
(327118, 'PTHR11716:SF102', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A2', 242017),
(327119, 'PTHR11716:SF103', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A2', 242017),
(327120, 'PTHR11716:SF99', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A2-BETA', 242017),
(327121, 'PTHR11716:SF92', NULL, NULL, NULL, NULL, 'BNAA09G09940D PROTEIN', 242017),
(327122, 'PTHR11716:SF100', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A2', 242017),
(327123, 'PTHR11716:SF4', NULL, NULL, NULL, NULL, 'GROUP 10 SECRETORY PHOSPHOLIPASE A2', 242017),
(327124, 'PTHR11716:SF101', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A2', 242017),
(327125, 'PTHR11716:SF93', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A2-DELTA-RELATED', 242017),
(327126, 'PTHR11716:SF94', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A2', 242017),
(327127, 'PTHR11716:SF5', NULL, NULL, NULL, NULL, 'INACTIVE GROUP IIC SECRETORY PHOSPHOLIPASE A2-RELATED', 242017),
(327128, 'PTHR11716:SF51', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A2', 242017),
(327129, 'PTHR11716:SF95', NULL, NULL, NULL, NULL, 'BNAA08G13410D PROTEIN', 242017),
(327130, 'PTHR11716:SF6', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A2', 242017),
(327131, 'PTHR11716:SF8', NULL, NULL, NULL, NULL, 'GROUP IIF SECRETORY PHOSPHOLIPASE A2', 242017),
(327132, 'PTHR11716:SF9', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A2, MEMBRANE ASSOCIATED', 242017),
(327133, 'PTHR11716', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A2 FAMILY MEMBER', 242017),
(327134, 'PTHR11716:SF56', NULL, NULL, NULL, NULL, 'GROUP IIE SECRETORY PHOSPHOLIPASE A2', 242017),
(327135, 'PTHR11716:SF57', NULL, NULL, NULL, NULL, 'GROUP IID SECRETORY PHOSPHOLIPASE A2', 242017),
(327136, 'PTHR11716:SF47', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A2', 242017),
(327137, 'PTHR47470', NULL, NULL, NULL, NULL, 'CHOLESTEROL OXIDASE', 242018),
(327138, 'PTHR47470:SF1', NULL, NULL, NULL, NULL, 'FAD_BINDING_2 DOMAIN-CONTAINING PROTEIN', 242018),
(327139, 'PTHR24264:SF63', NULL, NULL, NULL, NULL, 'UROKINASE-TYPE PLASMINOGEN ACTIVATOR', 242019),
(327140, 'PTHR24264:SF64', NULL, NULL, NULL, NULL, 'TRYPSIN-6-RELATED', 242019),
(327141, 'PTHR24264:SF20', NULL, NULL, NULL, NULL, 'ZMP:0000001088', 242019),
(327142, 'PTHR24264:SF42', NULL, NULL, NULL, NULL, 'TISSUE-TYPE PLASMINOGEN ACTIVATOR', 242019),
(327143, 'PTHR24264:SF62', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 242019),
(327144, 'PTHR24264:SF40', NULL, NULL, NULL, NULL, 'HYALURONAN-BINDING PROTEIN 2', 242019),
(327145, 'PTHR24264:SF67', NULL, NULL, NULL, NULL, 'SI:DKEY-33M11.7', 242019),
(327146, 'PTHR24264', NULL, NULL, NULL, NULL, 'TRYPSIN-RELATED', 242019),
(327147, 'PTHR24264:SF6', NULL, NULL, NULL, NULL, 'TRYPSINOGEN', 242019),
(327148, 'PTHR24264:SF13', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1810009J06 GENE-RELATED', 242019),
(327149, 'PTHR24264:SF57', NULL, NULL, NULL, NULL, 'TRYPSIN-1', 242019),
(327150, 'PTHR24264:SF46', NULL, NULL, NULL, NULL, 'COAGULATION FACTOR XII', 242019),
(327151, 'PTHR24264:SF54', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 242019),
(327152, 'PTHR24264:SF43', NULL, NULL, NULL, NULL, 'HEPATOCYTE GROWTH FACTOR ACTIVATOR', 242019),
(327153, 'PTHR24264:SF10', NULL, NULL, NULL, NULL, 'PROTEASE, SERINE 1 (TRYPSIN 1)-RELATED', 242019),
(327154, 'PTHR24264:SF65', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 242019);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(327155, 'PTHR24264:SF55', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 242019),
(327156, 'PTHR24264:SF66', NULL, NULL, NULL, NULL, 'TRYPSIN-2', 242019),
(327157, 'PTHR24264:SF7', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN-RELATED', 242019),
(327158, 'PTHR24264:SF38', NULL, NULL, NULL, NULL, 'UROKINASE-TYPE PLASMINOGEN ACTIVATOR', 242019),
(327159, 'PTHR24264:SF58', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN-RELATED', 242019),
(327160, 'PTHR24264:SF48', NULL, NULL, NULL, NULL, 'TRYPSIN-3', 242019),
(327161, 'PTHR24264:SF15', NULL, NULL, NULL, NULL, 'RIKEN CDNA 2210010C04 GENE', 242019),
(327162, 'PTHR12295:SF9', NULL, NULL, NULL, NULL, 'PROTEIN FURRY HOMOLOG-LIKE', 242020),
(327163, 'PTHR12295', NULL, NULL, NULL, NULL, 'FURRY-RELATED', 242020),
(327164, 'PTHR12295:SF30', NULL, NULL, NULL, NULL, 'PROTEIN FURRY', 242020),
(327165, 'PTHR12295:SF32', NULL, NULL, NULL, NULL, '', 242020),
(327166, 'PTHR12295:SF33', NULL, NULL, NULL, NULL, 'ARMADILLO-TYPE FOLD PROTEIN-RELATED', 242020),
(327167, 'PTHR12295:SF34', NULL, NULL, NULL, NULL, 'PROTEIN FURRY HOMOLOG-LIKE', 242020),
(327168, 'PTHR12295:SF29', NULL, NULL, NULL, NULL, 'PROTEIN FURRY HOMOLOG', 242020),
(327169, 'PTHR12843:SF12', NULL, NULL, NULL, NULL, 'PROTEIN-LYSINE N-METHYLTRANSFERASE 102587567', 242021),
(327170, 'PTHR12843', NULL, NULL, NULL, NULL, 'PROTEIN-LYSINE N-METHYLTRANSFERASE METTL10', 242021),
(327171, 'PTHR12843:SF5', NULL, NULL, NULL, NULL, 'EEF1A LYSINE METHYLTRANSFERASE 2', 242021),
(327172, 'PTHR12843:SF6', NULL, NULL, NULL, NULL, 'PROTEIN-LYSINE N-METHYLTRANSFERASE OS01G0121100', 242021),
(327173, 'PTHR10099:SF1', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLFORMYLGLYCINAMIDINE SYNTHASE', 242022),
(327174, 'PTHR10099:SF10', NULL, NULL, NULL, NULL, 'FORMYLGLYCINAMIDE RIBONUCLEOTIDE AMIDOTRANSFERASE', 242022),
(327175, 'PTHR10099:SF8', NULL, NULL, NULL, NULL, 'FORMYLGLYCINAMIDE RIBONUCLEOTIDE AMIDOTRANSFERASE', 242022),
(327176, 'PTHR10099:SF11', NULL, NULL, NULL, NULL, 'FORMYLGLYCINAMIDE RIBONUCLEOTIDE AMIDOTRANSFERASE', 242022),
(327177, 'PTHR10099:SF13', NULL, NULL, NULL, NULL, 'FORMYLGLYCINAMIDE RIBONUCLEOTIDE AMIDOTRANSFERASE', 242022),
(327178, 'PTHR10099:SF15', NULL, NULL, NULL, NULL, 'FORMYLGLYCINAMIDE RIBONUCLEOTIDE AMIDOTRANSFERASE', 242022),
(327179, 'PTHR10099', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLFORMYLGLYCINAMIDINE SYNTHASE', 242022),
(327180, 'PTHR23148:SF4', NULL, NULL, NULL, NULL, '', 242023),
(327181, 'PTHR23148:SF0', NULL, NULL, NULL, NULL, 'SERINE/ARGININE REPETITIVE MATRIX PROTEIN 1', 242023),
(327182, 'PTHR23148:SF1', NULL, NULL, NULL, NULL, '', 242023),
(327183, 'PTHR23148', NULL, NULL, NULL, NULL, 'SERINE/ARGININE REGULATED NUCLEAR MATRIX PROTEIN', 242023),
(327184, 'PTHR36396', NULL, NULL, NULL, NULL, 'MALTASE-GLUCOAMYLASE, INTESTINAL PROTEIN', 242024),
(327185, 'PTHR36396:SF1', NULL, NULL, NULL, NULL, 'MALTASE-GLUCOAMYLASE, INTESTINAL PROTEIN', 242024),
(327186, 'PTHR38339:SF1', NULL, NULL, NULL, NULL, 'TGC DOMAIN-CONTAINING PROTEIN', 242025),
(327187, 'PTHR38339', NULL, NULL, NULL, NULL, 'TRANSGLUTAMINASE DOMAIN PROTEIN', 242025),
(327188, 'PTHR47268:SF4', NULL, NULL, NULL, NULL, 'ACYLPHOSPHATASE', 242026),
(327189, 'PTHR47268:SF8', NULL, NULL, NULL, NULL, 'ACYLPHOSPHATASE', 242026),
(327190, 'PTHR47268:SF7', NULL, NULL, NULL, NULL, 'ACYLPHOSPHATASE', 242026),
(327191, 'PTHR47268', NULL, NULL, NULL, NULL, 'ACYLPHOSPHATASE', 242026),
(327192, 'PTHR22767', NULL, NULL, NULL, NULL, 'N-TERMINAL ACETYLTRANSFERASE-RELATED', 242027),
(327193, 'PTHR22767:SF2', NULL, NULL, NULL, NULL, 'N(ALPHA)-ACETYLTRANSFERASE 15/16, ISOFORM A', 242027),
(327194, 'PTHR22767:SF14', NULL, NULL, NULL, NULL, 'N-TERMINAL ACETYLTRANSFERASE A COMPLEX SUBUNIT-LIKE PROTEIN C418.02', 242027),
(327195, 'PTHR22767:SF8', NULL, NULL, NULL, NULL, 'N-ALPHA-ACETYLTRANSFERASE 15, NATA AUXILIARY SUBUNIT-RELATED', 242027),
(327196, 'PTHR22767:SF12', NULL, NULL, NULL, NULL, 'BNAC02G23120D PROTEIN', 242027),
(327197, 'PTHR22767:SF13', NULL, NULL, NULL, NULL, 'N-ALPHA-ACETYLTRANSFERASE 15, NATA AUXILIARY SUBUNIT-LIKE', 242027);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(327198, 'PTHR22767:SF10', NULL, NULL, NULL, NULL, 'BNAA02G19750D PROTEIN', 242027),
(327199, 'PTHR22767:SF3', NULL, NULL, NULL, NULL, 'N-ALPHA-ACETYLTRANSFERASE 25, NATB AUXILIARY SUBUNIT', 242027),
(327200, 'PTHR22767:SF5', NULL, NULL, NULL, NULL, 'N-ALPHA-ACETYLTRANSFERASE 16, NATA AUXILIARY SUBUNIT', 242027),
(327201, 'PTHR22767:SF6', NULL, NULL, NULL, NULL, 'N-ALPHA-ACETYLTRANSFERASE 15, NATA AUXILIARY SUBUNIT', 242027),
(327202, 'PTHR12025:SF5', NULL, NULL, NULL, NULL, 'VASCULAR ENDOTHELIAL GROWTH FACTOR A', 242028),
(327203, 'PTHR12025:SF12', NULL, NULL, NULL, NULL, 'VASCULAR ENDOTHELIAL GROWTH FACTOR B', 242028),
(327204, 'PTHR12025:SF11', NULL, NULL, NULL, NULL, 'VASCULAR ENDOTHELIAL GROWTH FACTOR D', 242028),
(327205, 'PTHR12025:SF14', NULL, NULL, NULL, NULL, 'VASCULAR ENDOTHELIAL GROWTH FACTOR BA', 242028),
(327206, 'PTHR12025:SF3', NULL, NULL, NULL, NULL, 'VASCULAR ENDOTHELIAL GROWTH FACTOR C', 242028),
(327207, 'PTHR12025:SF15', NULL, NULL, NULL, NULL, 'PDGF_2 DOMAIN-CONTAINING PROTEIN', 242028),
(327208, 'PTHR12025', NULL, NULL, NULL, NULL, 'VASCULAR ENDOTHELIAL GROWTH FACTOR', 242028),
(327209, 'PTHR12025:SF9', NULL, NULL, NULL, NULL, 'PLACENTA GROWTH FACTOR', 242028),
(327210, 'PTHR45893:SF1', NULL, NULL, NULL, NULL, 'POLYCOMB GROUP RING FINGER PROTEIN 5', 242029),
(327211, 'PTHR45893', NULL, NULL, NULL, NULL, 'POLYCOMB GROUP RING FINGER PROTEIN', 242029),
(327212, 'PTHR45893:SF3', NULL, NULL, NULL, NULL, 'POLYCOMB GROUP RING FINGER PROTEIN 3', 242029),
(327213, 'PTHR45893:SF2', NULL, NULL, NULL, NULL, 'POLYCOMB GROUP RING FINGER PROTEIN 6', 242029),
(327214, 'PTHR45893:SF4', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 242029),
(327215, 'PTHR23119', NULL, NULL, NULL, NULL, 'DISCS LARGE', 242030),
(327216, 'PTHR23119:SF48', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 7', 242030),
(327217, 'PTHR23119:SF56', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT CONTAINING 1', 242030),
(327218, 'PTHR23119:SF57', NULL, NULL, NULL, NULL, 'PROTEIN SCRIBBLE HOMOLOG', 242030),
(327219, 'PTHR23119:SF46', NULL, NULL, NULL, NULL, 'ERBB2-INTERACTING PROTEIN', 242030),
(327220, 'PTHR23119:SF44', NULL, NULL, NULL, NULL, 'PROTEIN LAP4', 242030),
(327221, 'PTHR23119:SF55', NULL, NULL, NULL, NULL, 'DISKS LARGE HOMOLOG 1-RELATED', 242030),
(327222, 'PTHR23119:SF33', NULL, NULL, NULL, NULL, 'DISKS LARGE HOMOLOG 4', 242030),
(327223, 'PTHR23119:SF5', NULL, NULL, NULL, NULL, 'DISKS LARGE HOMOLOG 1', 242030),
(327224, 'PTHR23119:SF6', NULL, NULL, NULL, NULL, 'DISKS LARGE HOMOLOG 2', 242030),
(327225, 'PTHR23119:SF28', NULL, NULL, NULL, NULL, 'DISKS LARGE HOMOLOG 3', 242030),
(327226, 'PTHR23119:SF50', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN', 242030),
(327227, 'PTHR23119:SF51', NULL, NULL, NULL, NULL, 'DISKS LARGE 1 TUMOR SUPPRESSOR PROTEIN', 242030),
(327228, 'PTHR35882:SF3', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_114 DOMAIN-CONTAINING PROTEIN', 242031),
(327229, 'PTHR35882', NULL, NULL, NULL, NULL, 'PELA', 242031),
(327230, 'PTHR35882:SF2', NULL, NULL, NULL, NULL, 'PELA', 242031),
(327231, 'PTHR35882:SF1', NULL, NULL, NULL, NULL, 'TM1410 HYPOTHETICAL-RELATED PROTEIN', 242031),
(327232, 'PTHR38048:SF1', NULL, NULL, NULL, NULL, 'HEMERYTHRIN DOMAIN-CONTAINING PROTEIN', 242032),
(327233, 'PTHR38048:SF2', NULL, NULL, NULL, NULL, 'HEMERYTHRIN DOMAIN-CONTAINING PROTEIN', 242032),
(327234, 'PTHR38048', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242032),
(327235, 'PTHR35135:SF6', NULL, NULL, NULL, NULL, '', 242033),
(327236, 'PTHR35135', NULL, NULL, NULL, NULL, 'OS05G0517800 PROTEIN', 242033),
(327237, 'PTHR35135:SF2', NULL, NULL, NULL, NULL, 'OS03G0733000 PROTEIN', 242033),
(327238, 'PTHR35135:SF3', NULL, NULL, NULL, NULL, 'OS05G0517800 PROTEIN', 242033),
(327239, 'PTHR35135:SF5', NULL, NULL, NULL, NULL, '', 242033),
(327240, 'PTHR24291:SF119', NULL, NULL, NULL, NULL, 'SI:CH211-113J14.1', 242034),
(327241, 'PTHR24291:SF39', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 4A11-RELATED', 242034),
(327242, 'PTHR24291:SF118', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY', 242034);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(327243, 'PTHR24291:SF161', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 315A1, MITOCHONDRIAL', 242034),
(327244, 'PTHR24291:SF167', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 MONOOXYGENASE GLIC', 242034),
(327245, 'PTHR24291:SF165', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 4A10-RELATED', 242034),
(327246, 'PTHR24291:SF120', NULL, NULL, NULL, NULL, 'SI:DKEY-91I10.3', 242034),
(327247, 'PTHR24291:SF20', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY', 242034),
(327248, 'PTHR24291:SF63', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 4X1-RELATED', 242034),
(327249, 'PTHR24291:SF105', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 4P1-RELATED', 242034),
(327250, 'PTHR24291:SF149', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 4B1', 242034),
(327251, 'PTHR24291:SF148', NULL, NULL, NULL, NULL, 'BNACNNG60990D PROTEIN', 242034),
(327252, 'PTHR24291:SF147', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP44-RELATED', 242034),
(327253, 'PTHR24291:SF146', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY', 242034),
(327254, 'PTHR24291:SF27', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 4F12', 242034),
(327255, 'PTHR24291:SF106', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 4G1-RELATED', 242034),
(327256, 'PTHR24291:SF151', NULL, NULL, NULL, NULL, 'EPI-ISOZIZAENE 5-MONOOXYGENASE/(E)-BETA-FARNESENE SYNTHASE', 242034),
(327257, 'PTHR24291:SF195', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71D7', 242034),
(327258, 'PTHR24291:SF194', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY', 242034),
(327259, 'PTHR24291:SF193', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 4V2', 242034),
(327260, 'PTHR24291:SF112', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 4F11', 242034),
(327261, 'PTHR24291:SF154', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 4, SUBFAMILY F, POLYPEPTIDE 40', 242034),
(327262, 'PTHR24291', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 4', 242034),
(327263, 'PTHR24291:SF192', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 4F8', 242034),
(327264, 'PTHR24291:SF191', NULL, NULL, NULL, NULL, 'STEROL 14-DEMETHYLASE', 242034),
(327265, 'PTHR24291:SF190', NULL, NULL, NULL, NULL, 'LEUKOTRIENE-B4 OMEGA-HYDROXYLASE 3', 242034),
(327266, 'PTHR24291:SF53', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 4F22', 242034),
(327267, 'PTHR24291:SF137', NULL, NULL, NULL, NULL, '', 242034),
(327268, 'PTHR24291:SF185', NULL, NULL, NULL, NULL, 'PREMNASPIRODIENE OXYGENASE-LIKE', 242034),
(327269, 'PTHR24291:SF141', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP4F13', 242034),
(327270, 'PTHR24291:SF184', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 4C3-RELATED', 242034),
(327271, 'PTHR24291:SF183', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 97B3, CHLOROPLASTIC', 242034),
(327272, 'PTHR24291:SF182', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 4F3', 242034),
(327273, 'PTHR24291:SF189', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 4D1-RELATED', 242034),
(327274, 'PTHR24291:SF188', NULL, NULL, NULL, NULL, '', 242034),
(327275, 'PTHR24291:SF144', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY', 242034),
(327276, 'PTHR24291:SF187', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 4AE1-RELATED', 242034),
(327277, 'PTHR24291:SF186', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A1-LIKE', 242034),
(327278, 'PTHR24291:SF50', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 12H1', 242034),
(327279, 'PTHR24291:SF181', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY', 242034),
(327280, 'PTHR24291:SF180', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 4, SUBFAMILY F, POLYPEPTIDE 17', 242034),
(327281, 'PTHR24291:SF48', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 301B1', 242034),
(327282, 'PTHR24291:SF47', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 4A14-RELATED', 242034),
(327283, 'PTHR24291:SF43', NULL, NULL, NULL, NULL, 'AROMATASE', 242034),
(327284, 'PTHR24291:SF124', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 4F2', 242034),
(327285, 'PTHR24291:SF168', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP4F16-RELATED', 242034),
(327286, 'PTHR24291:SF128', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY', 242034),
(327287, 'PTHR24291:SF130', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY', 242034),
(327288, 'PTHR24291:SF171', NULL, NULL, NULL, NULL, 'PROTEIN LUTEIN DEFICIENT 5, CHLOROPLASTIC', 242034);
INSERT INTO "PUBLIC"."MODEL" VALUES
(327289, 'PTHR24291:SF134', NULL, NULL, NULL, NULL, 'CAROTENE EPSILON-MONOOXYGENASE, CHLOROPLASTIC', 242034),
(327290, 'PTHR24291:SF177', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 4AA1-RELATED', 242034),
(327291, 'PTHR24291:SF132', NULL, NULL, NULL, NULL, '', 242034),
(327292, 'PTHR24291:SF175', NULL, NULL, NULL, NULL, '', 242034),
(327293, 'PTHR24291:SF3', NULL, NULL, NULL, NULL, '25-HYDROXYVITAMIN D-1 ALPHA HYDROXYLASE, MITOCHONDRIAL', 242034),
(327294, 'PTHR24291:SF6', NULL, NULL, NULL, NULL, 'STEROL 26-HYDROXYLASE, MITOCHONDRIAL', 242034),
(327295, 'PTHR24291:SF5', NULL, NULL, NULL, NULL, '1,25-DIHYDROXYVITAMIN D(3) 24-HYDROXYLASE, MITOCHONDRIAL', 242034),
(327296, 'PTHR24291:SF9', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 27C1', 242034),
(327297, 'PTHR13479:SF66', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN S18A, MITOCHONDRIAL', 242035),
(327298, 'PTHR13479:SF65', NULL, NULL, NULL, NULL, 'F10K1.8 PROTEIN', 242035),
(327299, 'PTHR13479:SF60', NULL, NULL, NULL, NULL, 'BNAC08G45180D PROTEIN', 242035),
(327300, 'PTHR13479:SF62', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S18 1', 242035),
(327301, 'PTHR13479:SF40', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S18C, MITOCHONDRIAL', 242035),
(327302, 'PTHR13479', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S18', 242035),
(327303, 'PTHR13479:SF57', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S18C, MITOCHONDRIAL', 242035),
(327304, 'PTHR13479:SF56', NULL, NULL, NULL, NULL, '', 242035),
(327305, 'PTHR13479:SF59', NULL, NULL, NULL, NULL, '', 242035),
(327306, 'PTHR32472:SF18', NULL, NULL, NULL, NULL, 'OS11G0576100 PROTEIN', 242036),
(327307, 'PTHR32472:SF19', NULL, NULL, NULL, NULL, 'DNA REPAIR-LIKE PROTEINRADA', 242036),
(327308, 'PTHR32472:SF21', NULL, NULL, NULL, NULL, 'BNAA03G45970D PROTEIN', 242036),
(327309, 'PTHR32472:SF10', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RADA-LIKE PROTEIN', 242036),
(327310, 'PTHR32472:SF11', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS CLASS)', 242036),
(327311, 'PTHR32472', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RADA', 242036),
(327312, 'PTHR32472:SF12', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN', 242036),
(327313, 'PTHR32472:SF13', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 242036),
(327314, 'PTHR37898:SF1', NULL, NULL, NULL, NULL, 'OS05G0540200 PROTEIN', 242037),
(327315, 'PTHR37898', NULL, NULL, NULL, NULL, 'OS05G0540200 PROTEIN', 242037),
(327316, 'PTHR37997:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN C1ORF162', 242038),
(327317, 'PTHR37997', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN C1ORF162', 242038),
(327318, 'PTHR34343', NULL, NULL, NULL, NULL, 'SEROLOGICALLY DEFINED COLON CANCER ANTIGEN 8', 242039),
(327319, 'PTHR34343:SF1', NULL, NULL, NULL, NULL, 'SEROLOGICALLY DEFINED COLON CANCER ANTIGEN 8', 242039),
(327320, 'PTHR30376:SF3', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA FACTOR RPOH', 242040),
(327321, 'PTHR30376', NULL, NULL, NULL, NULL, 'SIGMA FACTOR RPOH  HEAT SHOCK  RELATED', 242040),
(327322, 'PTHR36865:SF1', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1700001O22 GENE', 242041),
(327323, 'PTHR36865', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1700001O22 GENE', 242041),
(327324, 'PTHR31775:SF31', NULL, NULL, NULL, NULL, 'REMORIN_C DOMAIN-CONTAINING PROTEIN', 242042),
(327325, 'PTHR31775:SF21', NULL, NULL, NULL, NULL, 'REMORIN-LIKE', 242042),
(327326, 'PTHR31775:SF43', NULL, NULL, NULL, NULL, 'OS02G0824500 PROTEIN', 242042),
(327327, 'PTHR31775:SF32', NULL, NULL, NULL, NULL, 'BNAA04G26460D PROTEIN', 242042),
(327328, 'PTHR31775:SF44', NULL, NULL, NULL, NULL, 'CARBOXY-TERMINAL REGION REMORIN', 242042),
(327329, 'PTHR31775:SF23', NULL, NULL, NULL, NULL, 'REMORIN-LIKE', 242042),
(327330, 'PTHR31775:SF45', NULL, NULL, NULL, NULL, 'REMORIN-RELATED', 242042),
(327331, 'PTHR31775:SF34', NULL, NULL, NULL, NULL, 'REMORIN-RELATED', 242042),
(327332, 'PTHR31775:SF35', NULL, NULL, NULL, NULL, 'REMORIN-LIKE', 242042),
(327333, 'PTHR31775:SF24', NULL, NULL, NULL, NULL, 'REMORIN', 242042),
(327334, 'PTHR31775:SF25', NULL, NULL, NULL, NULL, 'REMORIN_C DOMAIN-CONTAINING PROTEIN', 242042);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(327335, 'PTHR31775:SF36', NULL, NULL, NULL, NULL, 'REMORIN-LIKE', 242042),
(327336, 'PTHR31775:SF27', NULL, NULL, NULL, NULL, 'REMORIN FAMILY PROTEIN', 242042),
(327337, 'PTHR31775:SF16', NULL, NULL, NULL, NULL, 'CARBOXY-TERMINAL REGION REMORIN', 242042),
(327338, 'PTHR31775:SF28', NULL, NULL, NULL, NULL, 'REMORIN-LIKE', 242042),
(327339, 'PTHR31775:SF39', NULL, NULL, NULL, NULL, 'REMORIN', 242042),
(327340, 'PTHR31775:SF17', NULL, NULL, NULL, NULL, 'OS02G0117200 PROTEIN', 242042),
(327341, 'PTHR31775:SF18', NULL, NULL, NULL, NULL, 'OS10G0503800 PROTEIN', 242042),
(327342, 'PTHR31775:SF29', NULL, NULL, NULL, NULL, 'CARBOXY-TERMINAL REGION REMORIN', 242042),
(327343, 'PTHR31775:SF19', NULL, NULL, NULL, NULL, 'REMORIN FAMILY PROTEIN', 242042),
(327344, 'PTHR31775', NULL, NULL, NULL, NULL, 'OS02G0117200 PROTEIN', 242042),
(327345, 'PTHR31775:SF5', NULL, NULL, NULL, NULL, 'REMORIN 1.4', 242042),
(327346, 'PTHR31775:SF6', NULL, NULL, NULL, NULL, 'OS03G0111200 PROTEIN', 242042),
(327347, 'PTHR48225:SF7', NULL, NULL, NULL, NULL, 'MEIOSIS-SPECIFIC PROTEIN HOP1', 242043),
(327348, 'PTHR48225:SF6', NULL, NULL, NULL, NULL, 'HORMA DOMAIN-CONTAINING PROTEIN 2', 242043),
(327349, 'PTHR48225:SF3', NULL, NULL, NULL, NULL, 'HORMA DOMAIN-CONTAINING PROTEIN 1', 242043),
(327350, 'PTHR48225:SF2', NULL, NULL, NULL, NULL, 'HORMA DOMAIN-CONTAINING PROTEIN', 242043),
(327351, 'PTHR48225:SF4', NULL, NULL, NULL, NULL, 'ZEBRAFISH TESTIS-EXPRESSED 38', 242043),
(327352, 'PTHR48225', NULL, NULL, NULL, NULL, 'HORMA DOMAIN-CONTAINING PROTEIN 1', 242043),
(327353, 'PTHR48225:SF1', NULL, NULL, NULL, NULL, 'HORMA DOMAIN-CONTAINING PROTEIN 1', 242043),
(327354, 'PTHR22950:SF663', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER, TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN-RELATED', 242044),
(327355, 'PTHR22950:SF301', NULL, NULL, NULL, NULL, 'ACID TRANSPORTER, PUTATIVE-RELATED', 242044),
(327356, 'PTHR22950:SF224', NULL, NULL, NULL, NULL, 'VACUOLAR AMINO ACID TRANSPORTER 7', 242044),
(327357, 'PTHR22950:SF665', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 38 MEMBER 5A', 242044),
(327358, 'PTHR22950:SF666', NULL, NULL, NULL, NULL, 'VACUOLAR AMINO ACID TRANSPORTER 4', 242044),
(327359, 'PTHR22950:SF226', NULL, NULL, NULL, NULL, 'SODIUM-COUPLED NEUTRAL AMINO ACID TRANSPORTER 8-RELATED', 242044),
(327360, 'PTHR22950:SF461', NULL, NULL, NULL, NULL, 'CHROMOSOME 7, WHOLE GENOME SHOTGUN SEQUENCE', 242044),
(327361, 'PTHR22950:SF340', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN-RELATED', 242044),
(327362, 'PTHR22950:SF188', NULL, NULL, NULL, NULL, 'PROTON-COUPLED AMINO ACID TRANSPORTER 1', 242044),
(327363, 'PTHR22950:SF662', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 242044),
(327364, 'PTHR22950:SF343', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER SKAT-1-RELATED', 242044),
(327365, 'PTHR22950:SF585', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER ANTL2-LIKE', 242044),
(327366, 'PTHR22950:SF222', NULL, NULL, NULL, NULL, 'SODIUM-COUPLED NEUTRAL AMINO ACID TRANSPORTER 4', 242044),
(327367, 'PTHR22950:SF184', NULL, NULL, NULL, NULL, 'SODIUM-COUPLED NEUTRAL AMINO ACID TRANSPORTER 1', 242044),
(327368, 'PTHR22950:SF460', NULL, NULL, NULL, NULL, 'PROTON-COUPLED AMINO ACID TRANSPORTER 4-LIKE PROTEIN', 242044),
(327369, 'PTHR22950:SF185', NULL, NULL, NULL, NULL, 'PROTON-COUPLED AMINO ACID TRANSPORTER 2', 242044),
(327370, 'PTHR22950:SF20', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER (EUROFUNG)', 242044),
(327371, 'PTHR22950:SF22', NULL, NULL, NULL, NULL, 'SODIUM-COUPLED NEUTRAL AMINO ACID TRANSPORTER 3', 242044),
(327372, 'PTHR22950:SF349', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 242044),
(327373, 'PTHR22950:SF668', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER (EUROFUNG)', 242044),
(327374, 'PTHR22950:SF625', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER AVT6D', 242044),
(327375, 'PTHR22950:SF674', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER AVT3A', 242044),
(327376, 'PTHR22950:SF553', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 242044),
(327377, 'PTHR22950:SF631', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER ANTL1-LIKE', 242044);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(327378, 'PTHR22950:SF675', NULL, NULL, NULL, NULL, 'SAP DOMAIN-CONTAINING PROTEIN', 242044),
(327379, 'PTHR22950:SF511', NULL, NULL, NULL, NULL, 'SODIUM-COUPLED NEUTRAL AMINO ACID TRANSPORTER 5-LIKE', 242044),
(327380, 'PTHR22950:SF676', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 242044),
(327381, 'PTHR22950:SF677', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 242044),
(327382, 'PTHR22950:SF479', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER (EUROFUNG)-RELATED', 242044),
(327383, 'PTHR22950:SF472', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 242044),
(327384, 'PTHR22950:SF671', NULL, NULL, NULL, NULL, 'CHROMOSOME 23, WHOLE GENOME SHOTGUN SEQUENCE', 242044),
(327385, 'PTHR22950:SF154', NULL, NULL, NULL, NULL, 'PROTON-COUPLED AMINO ACID TRANSPORTER-LIKE PROTEIN PATHETIC', 242044),
(327386, 'PTHR22950:SF193', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 242044),
(327387, 'PTHR22950:SF150', NULL, NULL, NULL, NULL, 'FI17861P1', 242044),
(327388, 'PTHR22950:SF74', NULL, NULL, NULL, NULL, 'SODIUM-COUPLED NEUTRAL AMINO ACID TRANSPORTER 5', 242044),
(327389, 'PTHR22950:SF190', NULL, NULL, NULL, NULL, 'PROTON-COUPLED AMINO ACID TRANSPORTER 4', 242044),
(327390, 'PTHR22950:SF192', NULL, NULL, NULL, NULL, 'SODIUM-COUPLED NEUTRAL AMINO ACID TRANSPORTER 7-RELATED', 242044),
(327391, 'PTHR22950:SF8', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER (EUROFUNG)', 242044),
(327392, 'PTHR22950:SF518', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER AVT6B', 242044),
(327393, 'PTHR22950:SF678', NULL, NULL, NULL, NULL, 'VACUOLAR AMINO ACID TRANSPORTER 5-RELATED', 242044),
(327394, 'PTHR22950:SF634', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AMINO ACID TRANSPORTER FAMILY PROTEIN', 242044),
(327395, 'PTHR22950:SF514', NULL, NULL, NULL, NULL, 'OS07G0598600 PROTEIN', 242044),
(327396, 'PTHR22950:SF679', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER ANTL1-LIKE', 242044),
(327397, 'PTHR22950:SF635', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER AVT3C', 242044),
(327398, 'PTHR22950:SF515', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER AVT6E', 242044),
(327399, 'PTHR22950:SF289', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 242044),
(327400, 'PTHR22950:SF685', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER PROTEIN', 242044),
(327401, 'PTHR22950:SF366', NULL, NULL, NULL, NULL, 'SODIUM-COUPLED NEUTRAL AMINO ACID TRANSPORTER 6-RELATED', 242044),
(327402, 'PTHR22950:SF323', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER AVT6C', 242044),
(327403, 'PTHR22950:SF686', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 242044),
(327404, 'PTHR22950:SF642', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 242044),
(327405, 'PTHR22950:SF643', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER AVT6A', 242044),
(327406, 'PTHR22950:SF687', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER PROTEIN', 242044),
(327407, 'PTHR22950:SF369', NULL, NULL, NULL, NULL, 'ACID TRANSPORTER 1, PUTATIVE-RELATED', 242044),
(327408, 'PTHR22950:SF688', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 242044),
(327409, 'PTHR22950:SF567', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 242044),
(327410, 'PTHR22950:SF681', NULL, NULL, NULL, NULL, 'SH2 DOMAIN-CONTAINING PROTEIN', 242044),
(327411, 'PTHR22950:SF682', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AMINO ACID TRANSPORTER FAMILY PROTEIN', 242044),
(327412, 'PTHR22950:SF683', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER (EUROFUNG)', 242044),
(327413, 'PTHR22950:SF244', NULL, NULL, NULL, NULL, 'SODIUM-COUPLED NEUTRAL AMINO ACID TRANSPORTER 9', 242044),
(327414, 'PTHR22950:SF684', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER, TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN-RELATED', 242044),
(327415, 'PTHR22950:SF680', NULL, NULL, NULL, NULL, 'PROTON-COUPLED AMINO ACID TRANSPORTER 4-LIKE PROTEIN', 242044),
(327416, 'PTHR22950', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER', 242044),
(327417, 'PTHR22950:SF649', NULL, NULL, NULL, NULL, 'ACID TRANSPORTER, PUTATIVE-RELATED', 242044);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(327418, 'PTHR22950:SF529', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER AVT3B', 242044),
(327419, 'PTHR22950:SF645', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 242044),
(327420, 'PTHR22950:SF689', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 242044),
(327421, 'PTHR22950:SF646', NULL, NULL, NULL, NULL, 'SODIUM-COUPLED NEUTRAL AMINO ACID TRANSPORTER 10-RELATED', 242044),
(327422, 'PTHR22950:SF647', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER ANTL2-LIKE', 242044),
(327423, 'PTHR22950:SF207', NULL, NULL, NULL, NULL, 'SODIUM-COUPLED NEUTRAL AMINO ACID TRANSPORTER 2', 242044),
(327424, 'PTHR22950:SF696', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 242044),
(327425, 'PTHR22950:SF652', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AMINO ACID TRANSPORTER FAMILY PROTEIN', 242044),
(327426, 'PTHR22950:SF653', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 242044),
(327427, 'PTHR22950:SF654', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 242044),
(327428, 'PTHR22950:SF577', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER, TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN-RELATED', 242044),
(327429, 'PTHR22950:SF258', NULL, NULL, NULL, NULL, 'PROTON-COUPLED AMINO ACID TRANSPORTER 3', 242044),
(327430, 'PTHR22950:SF259', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORT PROTEIN', 242044),
(327431, 'PTHR22950:SF655', NULL, NULL, NULL, NULL, 'OS02G0191300 PROTEIN', 242044),
(327432, 'PTHR22950:SF692', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AMINO ACID TRANSPORTER FAMILY PROTEIN', 242044),
(327433, 'PTHR22950:SF494', NULL, NULL, NULL, NULL, 'GH04538P', 242044),
(327434, 'PTHR22950:SF571', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AMINO ACID TRANSPORTER FAMILY PROTEIN', 242044),
(327435, 'PTHR22950:SF693', NULL, NULL, NULL, NULL, 'SODIUM-COUPLED NEUTRAL AMINO ACID TRANSPORTER 11-RELATED', 242044),
(327436, 'PTHR22950:SF694', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE, PUTATIVE-RELATED', 242044),
(327437, 'PTHR22950:SF695', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 242044),
(327438, 'PTHR22950:SF332', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER (EUROFUNG)', 242044),
(327439, 'PTHR22950:SF530', NULL, NULL, NULL, NULL, 'VACUOLAR AMINO ACID TRANSPORTER 3', 242044),
(327440, 'PTHR22950:SF690', NULL, NULL, NULL, NULL, 'ACID TRANSPORTER, PUTATIVE-RELATED', 242044),
(327441, 'PTHR22950:SF691', NULL, NULL, NULL, NULL, 'OS03G0817200 PROTEIN', 242044),
(327442, 'PTHR22950:SF617', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER, TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN-RELATED', 242044),
(327443, 'PTHR22950:SF458', NULL, NULL, NULL, NULL, 'OS06G0633800 PROTEIN', 242044),
(327444, 'PTHR22950:SF612', NULL, NULL, NULL, NULL, 'SODIUM-COUPLED NEUTRAL AMINO ACID TRANSPORTER 5-LIKE', 242044),
(327445, 'PTHR22950:SF657', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 242044),
(327446, 'PTHR22950:SF613', NULL, NULL, NULL, NULL, 'SODIUM-COUPLED NEUTRAL AMINO ACID TRANSPORTER 5-LIKE ISOFORM X1', 242044),
(327447, 'PTHR22950:SF217', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 242044),
(327448, 'PTHR22950:SF658', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 242044),
(327449, 'PTHR14115:SF0', NULL, NULL, NULL, NULL, 'AMELOBLASTIN', 242045),
(327450, 'PTHR14115', NULL, NULL, NULL, NULL, 'AMELOBLASTIN', 242045),
(327451, 'PTHR13028:SF0', NULL, NULL, NULL, NULL, 'RRNA-PROCESSING PROTEIN EBP2-RELATED', 242046),
(327452, 'PTHR13028:SF2', NULL, NULL, NULL, NULL, 'BNAA01G24550D PROTEIN', 242046),
(327453, 'PTHR13028:SF3', NULL, NULL, NULL, NULL, 'BNAC05G29840D PROTEIN', 242046),
(327454, 'PTHR13028', NULL, NULL, NULL, NULL, 'RRNA PROCESSING PROTEIN EBNA1-BINDING PROTEIN-RELATED', 242046),
(327455, 'PTHR31326:SF7', NULL, NULL, NULL, NULL, '(CHLOROQUINE-RESISTANCE TRANSPORTER)-LIKE TRANSPORTER, PUTATIVE-RELATED', 242047),
(327456, 'PTHR31326:SF12', NULL, NULL, NULL, NULL, 'PROTEIN CLT1, CHLOROPLASTIC', 242047),
(327457, 'PTHR31326', NULL, NULL, NULL, NULL, 'PROTEIN CLT2, CHLOROPLASTIC', 242047),
(327458, 'PTHR31326:SF11', NULL, NULL, NULL, NULL, 'PROTEIN CLT2 CHLOROPLASTIC', 242047);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(327459, 'PTHR31326:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CLT3, CHLOROPLASTIC', 242047),
(327460, 'PTHR31326:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CLT2, CHLOROPLASTIC', 242047),
(327461, 'PTHR45690:SF9', NULL, NULL, NULL, NULL, 'NACHT, LRR AND PYD DOMAINS-CONTAINING PROTEIN 4A', 242048),
(327462, 'PTHR45690:SF7', NULL, NULL, NULL, NULL, 'NACHT, LRR AND PYD DOMAINS-CONTAINING PROTEIN 5', 242048),
(327463, 'PTHR45690:SF8', NULL, NULL, NULL, NULL, 'NACHT, LRR AND PYD DOMAINS-CONTAINING PROTEIN 8', 242048),
(327464, 'PTHR45690:SF5', NULL, NULL, NULL, NULL, 'NACHT, LRR AND PYD DOMAINS-CONTAINING PROTEIN 11', 242048),
(327465, 'PTHR45690:SF6', NULL, NULL, NULL, NULL, 'NACHT, LRR AND PYD DOMAINS-CONTAINING PROTEIN 4', 242048),
(327466, 'PTHR45690:SF19', NULL, NULL, NULL, NULL, 'NACHT, LRR AND PYD DOMAINS-CONTAINING PROTEIN 3', 242048),
(327467, 'PTHR45690:SF3', NULL, NULL, NULL, NULL, 'NACHT DOMAIN-CONTAINING PROTEIN', 242048),
(327468, 'PTHR45690:SF16', NULL, NULL, NULL, NULL, 'NACHT, LRR AND PYD DOMAINS-CONTAINING PROTEIN 13', 242048),
(327469, 'PTHR45690:SF4', NULL, NULL, NULL, NULL, 'NACHT, LRR AND PYD DOMAINS-CONTAINING PROTEIN 10', 242048),
(327470, 'PTHR45690:SF17', NULL, NULL, NULL, NULL, 'NACHT, LRR AND PYD DOMAINS-CONTAINING PROTEIN 4F', 242048),
(327471, 'PTHR45690:SF14', NULL, NULL, NULL, NULL, 'NACHT, LRR AND PYD DOMAINS-CONTAINING PROTEIN 2', 242048),
(327472, 'PTHR45690:SF1', NULL, NULL, NULL, NULL, 'NACHT, LRR AND PYD DOMAINS-CONTAINING PROTEIN 6', 242048),
(327473, 'PTHR45690:SF15', NULL, NULL, NULL, NULL, 'NACHT, LRR AND PYD DOMAINS-CONTAINING PROTEIN 14', 242048),
(327474, 'PTHR45690:SF12', NULL, NULL, NULL, NULL, 'NACHT, LRR AND PYD DOMAINS-CONTAINING PROTEIN 4B', 242048),
(327475, 'PTHR45690:SF13', NULL, NULL, NULL, NULL, 'NACHT, LRR AND PYD DOMAINS-CONTAINING PROTEIN 9', 242048),
(327476, 'PTHR45690:SF11', NULL, NULL, NULL, NULL, 'NACHT, LRR AND PYD DOMAINS-CONTAINING PROTEIN 12', 242048),
(327477, 'PTHR45690:SF20', NULL, NULL, NULL, NULL, 'NACHT, LRR AND PYD DOMAINS-CONTAINING PROTEIN 7', 242048),
(327478, 'PTHR45690', NULL, NULL, NULL, NULL, 'NACHT, LRR AND PYD DOMAINS-CONTAINING PROTEIN 12', 242048),
(327479, 'PTHR48023:SF2', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 2, FACILITATED GLUCOSE TRANSPORTER MEMBER 12', 242049),
(327480, 'PTHR48023:SF4', NULL, NULL, NULL, NULL, 'D-XYLOSE-PROTON SYMPORTER-LIKE 2', 242049),
(327481, 'PTHR48023:SF5', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 242049),
(327482, 'PTHR48023', NULL, NULL, NULL, NULL, 'D-XYLOSE-PROTON SYMPORTER-LIKE 2', 242049),
(327483, 'PTHR48023:SF1', NULL, NULL, NULL, NULL, 'D-XYLOSE-PROTON SYMPORTER-LIKE 1', 242049),
(327484, 'PTHR48023:SF6', NULL, NULL, NULL, NULL, 'D-XYLOSE-PROTON SYMPORTER-LIKE 3, CHLOROPLASTIC', 242049),
(327485, 'PTHR48023:SF7', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 2, FACILITATED GLUCOSE TRANSPORTER MEMBER 10', 242049),
(327486, 'PTHR48023:SF8', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 242049),
(327487, 'PTHR48023:SF9', NULL, NULL, NULL, NULL, 'GALACTOSE-PROTON SYMPORTER', 242049),
(327488, 'PTHR35826', NULL, NULL, NULL, NULL, 'PROTEIN ATP6V1FNB-LIKE', 242050),
(327489, 'PTHR35826:SF2', NULL, NULL, NULL, NULL, 'PROTEIN ATP6V1FNB', 242050),
(327490, 'PTHR35826:SF1', NULL, NULL, NULL, NULL, 'SI:CH211-193L2.10', 242050),
(327491, 'PTHR35826:SF4', NULL, NULL, NULL, NULL, 'GENE 45521-RELATED', 242050),
(327492, 'PTHR23319', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 242051),
(327493, 'PTHR23319:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ASTER-C', 242051),
(327494, 'PTHR23319:SF34', NULL, NULL, NULL, NULL, '', 242051),
(327495, 'PTHR23319:SF3', NULL, NULL, NULL, NULL, 'PROTEIN ASTER-B', 242051),
(327496, 'PTHR23319:SF4', NULL, NULL, NULL, NULL, 'AT22714P-RELATED', 242051),
(327497, 'PTHR23319:SF13', NULL, NULL, NULL, NULL, 'GRAM DOMAIN-CONTAINING PROTEIN', 242051),
(327498, 'PTHR23319:SF36', NULL, NULL, NULL, NULL, 'MEMBRANE-ANCHORED LIPID-BINDING PROTEIN LAM4-RELATED', 242051),
(327499, 'PTHR23319:SF37', NULL, NULL, NULL, NULL, 'VAST DOMAIN-CONTAINING PROTEIN', 242051);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(327500, 'PTHR23319:SF8', NULL, NULL, NULL, NULL, 'PROTEIN ASTER-A', 242051),
(327501, 'PTHR12640:SF1', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE SUBUNIT 2', 242052),
(327502, 'PTHR12640:SF0', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE SUBUNIT 2', 242052),
(327503, 'PTHR12640', NULL, NULL, NULL, NULL, 'RIBOPHORIN II', 242052),
(327504, 'PTHR17357:SF0', NULL, NULL, NULL, NULL, 'GANGLIOSIDE GM2 ACTIVATOR', 242053),
(327505, 'PTHR17357', NULL, NULL, NULL, NULL, 'GM2 GANGLIOSIDE ACTIVATOR PROTEIN', 242053),
(327506, 'PTHR16768:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAM107B', 242054),
(327507, 'PTHR16768:SF5', NULL, NULL, NULL, NULL, 'FI14214P', 242054),
(327508, 'PTHR16768:SF3', NULL, NULL, NULL, NULL, 'ACTIN-ASSOCIATED PROTEIN FAM107A', 242054),
(327509, 'PTHR16768:SF4', NULL, NULL, NULL, NULL, 'SI:CH211-218O21.4', 242054),
(327510, 'PTHR16768', NULL, NULL, NULL, NULL, 'DOWN REGULATED IN RENAL CARCINOMA 1/TU3A', 242054),
(327511, 'PTHR16768:SF7', NULL, NULL, NULL, NULL, 'SI:CH211-160O17.6-RELATED', 242054),
(327512, 'PTHR37330', NULL, NULL, NULL, NULL, 'CONSERVED TRANSMEMBRANE PROTEIN-RELATED', 242055),
(327513, 'PTHR37330:SF1', NULL, NULL, NULL, NULL, 'CONSERVED TRANSMEMBRANE PROTEIN-RELATED', 242055),
(327514, 'PTHR33690:SF3', NULL, NULL, NULL, NULL, 'DUF4605 DOMAIN-CONTAINING PROTEIN', 242056),
(327515, 'PTHR33690:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM241B', 242056),
(327516, 'PTHR33690:SF1', NULL, NULL, NULL, NULL, 'FAMILY WITH SEQUENCE SIMILARITY 241 MEMBER A', 242056),
(327517, 'PTHR33690', NULL, NULL, NULL, NULL, 'DUF4605 DOMAIN-CONTAINING PROTEIN', 242056),
(327518, 'PTHR42470:SF1', NULL, NULL, NULL, NULL, '', 242057),
(327519, 'PTHR42470:SF2', NULL, NULL, NULL, NULL, '', 242057),
(327520, 'PTHR42470', NULL, NULL, NULL, NULL, '', 242057),
(327521, 'PTHR45764:SF70', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR 11-LIKE', 242058),
(327522, 'PTHR45764:SF71', NULL, NULL, NULL, NULL, 'BASIC-LEUCINE ZIPPER DOMAIN-CONTAINING PROTEIN-RELATED', 242058),
(327523, 'PTHR45764:SF50', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR', 242058),
(327524, 'PTHR45764:SF72', NULL, NULL, NULL, NULL, 'BASIC LEUCINE-ZIPPER 2-RELATED', 242058),
(327525, 'PTHR45764:SF51', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 242058),
(327526, 'PTHR45764:SF73', NULL, NULL, NULL, NULL, 'OCS ELEMENT-BINDING FACTOR 1', 242058),
(327527, 'PTHR45764:SF30', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR 53-LIKE', 242058),
(327528, 'PTHR45764:SF74', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR 53-LIKE', 242058),
(327529, 'PTHR45764:SF52', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER 4', 242058),
(327530, 'PTHR45764:SF53', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER 43-LIKE', 242058),
(327531, 'PTHR45764:SF75', NULL, NULL, NULL, NULL, 'LIGHT-INDUCIBLE PROTEIN CPRF-2', 242058),
(327532, 'PTHR45764:SF31', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER 1', 242058),
(327533, 'PTHR45764:SF76', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR 11', 242058),
(327534, 'PTHR45764:SF77', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 242058),
(327535, 'PTHR45764:SF55', NULL, NULL, NULL, NULL, 'BASIC LEUCINE-ZIPPER 5-RELATED', 242058),
(327536, 'PTHR45764:SF78', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR FAMILY PROTEIN EXPRESSED', 242058),
(327537, 'PTHR45764:SF56', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 242058),
(327538, 'PTHR45764:SF34', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR 53', 242058),
(327539, 'PTHR45764:SF35', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR', 242058),
(327540, 'PTHR45764:SF79', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR-LIKE PROTEIN', 242058),
(327541, 'PTHR45764:SF58', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR BZIP124', 242058),
(327542, 'PTHR45764:SF59', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 242058),
(327543, 'PTHR45764:SF15', NULL, NULL, NULL, NULL, 'OS01G0542700 PROTEIN', 242058),
(327544, 'PTHR45764:SF38', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 242058);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(327545, 'PTHR45764:SF39', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 242058),
(327546, 'PTHR45764:SF17', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR', 242058),
(327547, 'PTHR45764:SF18', NULL, NULL, NULL, NULL, 'OS07G0124300 PROTEIN', 242058),
(327548, 'PTHR45764:SF19', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR 53-LIKE', 242058),
(327549, 'PTHR45764:SF80', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 242058),
(327550, 'PTHR45764:SF81', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR 44', 242058),
(327551, 'PTHR45764:SF61', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 242058),
(327552, 'PTHR45764:SF62', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 242058),
(327553, 'PTHR45764:SF40', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 242058),
(327554, 'PTHR45764:SF4', NULL, NULL, NULL, NULL, 'OS09G0306400 PROTEIN', 242058),
(327555, 'PTHR45764:SF41', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR', 242058),
(327556, 'PTHR45764:SF42', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 242058),
(327557, 'PTHR45764:SF65', NULL, NULL, NULL, NULL, 'OS03G0770000 PROTEIN', 242058),
(327558, 'PTHR45764:SF21', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 242058),
(327559, 'PTHR45764:SF22', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 242058),
(327560, 'PTHR45764:SF45', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 242058),
(327561, 'PTHR45764:SF67', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR 2', 242058),
(327562, 'PTHR45764:SF46', NULL, NULL, NULL, NULL, 'BASIC-LEUCINE ZIPPER DOMAIN-CONTAINING PROTEIN-RELATED', 242058),
(327563, 'PTHR45764:SF68', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR 53-LIKE', 242058),
(327564, 'PTHR45764:SF24', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 242058),
(327565, 'PTHR45764:SF48', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 242058),
(327566, 'PTHR45764:SF49', NULL, NULL, NULL, NULL, 'BASIC-LEUCINE ZIPPER DOMAIN-CONTAINING PROTEIN-RELATED', 242058),
(327567, 'PTHR45764', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR 44', 242058),
(327568, 'PTHR45764:SF7', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR FAMILY PROTEIN', 242058),
(327569, 'PTHR24229:SF103', NULL, NULL, NULL, NULL, 'ALLATOSTATIN A RECEPTOR 1, ISOFORM B', 242059),
(327570, 'PTHR24229:SF104', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 242059),
(327571, 'PTHR24229:SF105', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 24', 242059),
(327572, 'PTHR24229:SF106', NULL, NULL, NULL, NULL, 'GH14208P', 242059),
(327573, 'PTHR24229:SF4', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 1', 242059),
(327574, 'PTHR24229:SF90', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 24', 242059),
(327575, 'PTHR24229:SF6', NULL, NULL, NULL, NULL, 'SOMATOSTATIN RECEPTOR TYPE 2', 242059),
(327576, 'PTHR24229:SF7', NULL, NULL, NULL, NULL, 'MU-TYPE OPIOID RECEPTOR', 242059),
(327577, 'PTHR24229:SF8', NULL, NULL, NULL, NULL, 'PROSTAGLANDIN D2 RECEPTOR 2', 242059),
(327578, 'PTHR24229:SF50', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 242059),
(327579, 'PTHR24229:SF91', NULL, NULL, NULL, NULL, 'MELANIN-CONCENTRATING HORMONE RECEPTOR 1', 242059),
(327580, 'PTHR24229:SF42', NULL, NULL, NULL, NULL, 'SOMATOSTATIN RECEPTOR TYPE 3', 242059),
(327581, 'PTHR24229:SF20', NULL, NULL, NULL, NULL, 'SOMATOSTATIN RECEPTOR TYPE 5', 242059),
(327582, 'PTHR24229:SF40', NULL, NULL, NULL, NULL, 'ALLATOSTATIN C RECEPTOR 1-RELATED', 242059),
(327583, 'PTHR24229:SF84', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 242059),
(327584, 'PTHR24229:SF85', NULL, NULL, NULL, NULL, 'MELANIN-CONCENTRATING HORMONE RECEPTOR 2', 242059),
(327585, 'PTHR24229:SF47', NULL, NULL, NULL, NULL, 'NEUROPEPTIDES B/W RECEPTOR TYPE 1', 242059),
(327586, 'PTHR24229:SF1', NULL, NULL, NULL, NULL, 'KAPPA-TYPE OPIOID RECEPTOR', 242059),
(327587, 'PTHR24229:SF25', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 242059);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(327588, 'PTHR24229:SF2', NULL, NULL, NULL, NULL, 'DELTA-TYPE OPIOID RECEPTOR', 242059),
(327589, 'PTHR24229:SF88', NULL, NULL, NULL, NULL, 'MELANIN CONCENTRATING HORMONE RECEPTOR 2-RELATED', 242059),
(327590, 'PTHR24229:SF100', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 242059),
(327591, 'PTHR24229:SF101', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 242059),
(327592, 'PTHR24229:SF102', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 242059),
(327593, 'PTHR24229', NULL, NULL, NULL, NULL, 'NEUROPEPTIDES RECEPTOR', 242059),
(327594, 'PTHR24229:SF82', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 242059),
(327595, 'PTHR24229:SF80', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 24', 242059),
(327596, 'PTHR24229:SF53', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE RECEPTOR 18', 242059),
(327597, 'PTHR24229:SF32', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 149-RELATED', 242059),
(327598, 'PTHR24229:SF95', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR C06G4.5-RELATED', 242059),
(327599, 'PTHR24229:SF96', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 242059),
(327600, 'PTHR24229:SF35', NULL, NULL, NULL, NULL, 'SOMATOSTATIN RECEPTOR TYPE 4', 242059),
(327601, 'PTHR24229:SF77', NULL, NULL, NULL, NULL, 'SI:ZFOS-169G10.2', 242059),
(327602, 'PTHR24229:SF11', NULL, NULL, NULL, NULL, 'NOCICEPTIN RECEPTOR', 242059),
(327603, 'PTHR24229:SF18', NULL, NULL, NULL, NULL, 'NEUROPEPTIDES B/W RECEPTOR TYPE 2', 242059),
(327604, 'PTHR24229:SF38', NULL, NULL, NULL, NULL, 'SOMATOSTATIN RECEPTOR TYPE 1', 242059),
(327605, 'PTHR45946', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN ROUGH-RELATED', 242060),
(327606, 'PTHR45946:SF5', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-B1', 242060),
(327607, 'PTHR45946:SF8', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-C1A', 242060),
(327608, 'PTHR45946:SF1', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-D1', 242060),
(327609, 'PTHR45946:SF4', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN ROUGH-RELATED', 242060),
(327610, 'PTHR45946:SF3', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-A1', 242060),
(327611, 'PTHR33214:SF57', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 242061),
(327612, 'PTHR33214:SF79', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', 242061),
(327613, 'PTHR33214:SF36', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 242061),
(327614, 'PTHR33214:SF58', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 242061),
(327615, 'PTHR33214:SF38', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 242061),
(327616, 'PTHR33214:SF71', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN 2-LIKE', 242061),
(327617, 'PTHR33214:SF50', NULL, NULL, NULL, NULL, 'LIPID-TRANSFER PROTEIN 2G, PUTATIVE, EXPRESSED-RELATED', 242061),
(327618, 'PTHR33214:SF51', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 242061),
(327619, 'PTHR33214:SF73', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 242061),
(327620, 'PTHR33214:SF52', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 242061),
(327621, 'PTHR33214:SF30', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', 242061),
(327622, 'PTHR33214:SF74', NULL, NULL, NULL, NULL, 'OS05G0550600 PROTEIN', 242061),
(327623, 'PTHR33214:SF31', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 242061),
(327624, 'PTHR33214:SF53', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', 242061),
(327625, 'PTHR33214:SF75', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN 2P', 242061),
(327626, 'PTHR33214:SF3', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 242061),
(327627, 'PTHR33214:SF76', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN-RELATED', 242061),
(327628, 'PTHR33214:SF54', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 242061);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(327629, 'PTHR33214:SF77', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 242061),
(327630, 'PTHR33214:SF78', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 242061),
(327631, 'PTHR33214:SF56', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 242061),
(327632, 'PTHR33214:SF34', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN 2', 242061),
(327633, 'PTHR33214:SF8', NULL, NULL, NULL, NULL, 'OS01G0691300 PROTEIN', 242061),
(327634, 'PTHR33214:SF46', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 242061),
(327635, 'PTHR33214:SF47', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', 242061),
(327636, 'PTHR33214:SF69', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', 242061),
(327637, 'PTHR33214:SF48', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN 2-LIKE', 242061),
(327638, 'PTHR33214:SF60', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 242061),
(327639, 'PTHR33214:SF62', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 242061),
(327640, 'PTHR33214:SF41', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 242061),
(327641, 'PTHR33214:SF64', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 242061),
(327642, 'PTHR33214:SF42', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 242061),
(327643, 'PTHR33214:SF65', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 242061),
(327644, 'PTHR33214:SF43', NULL, NULL, NULL, NULL, 'OS06G0705400 PROTEIN', 242061),
(327645, 'PTHR33214:SF44', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN-RELATED', 242061),
(327646, 'PTHR33214:SF66', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 242061),
(327647, 'PTHR33214:SF45', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', 242061),
(327648, 'PTHR33214:SF23', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN 2-RELATED', 242061),
(327649, 'PTHR33214', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', 242061),
(327650, 'PTHR31212', NULL, NULL, NULL, NULL, 'ALPHA-KETOGLUTARATE-DEPENDENT DIOXYGENASE ALKB HOMOLOG 3', 242062),
(327651, 'PTHR31212:SF5', NULL, NULL, NULL, NULL, 'ISOCHORISMATASE FAMILY PROTEIN FAMILY (AFU_ORTHOLOGUE AFUA_3G14500)', 242062),
(327652, 'PTHR31212:SF4', NULL, NULL, NULL, NULL, 'ALPHA-KETOGLUTARATE-DEPENDENT DIOXYGENASE ALKB HOMOLOG 3', 242062),
(327653, 'PTHR38108:SF1', NULL, NULL, NULL, NULL, 'UPF0319 PROTEIN YCCT', 242063),
(327654, 'PTHR38108', NULL, NULL, NULL, NULL, 'UPF0319 PROTEIN YCCT', 242063),
(327655, 'PTHR46529', NULL, NULL, NULL, NULL, 'TRNA WYBUTOSINE-SYNTHESIZING PROTEIN 4', 242064),
(327656, 'PTHR46529:SF1', NULL, NULL, NULL, NULL, 'TRNA WYBUTOSINE-SYNTHESIZING PROTEIN 4', 242064),
(327657, 'PTHR21197:SF0', NULL, NULL, NULL, NULL, 'UDP-GALACTOPYRANOSE MUTASE', 242065),
(327658, 'PTHR21197', NULL, NULL, NULL, NULL, 'UDP-GALACTOPYRANOSE MUTASE', 242065),
(327659, 'PTHR43683:SF1', NULL, NULL, NULL, NULL, 'MULTIDRUG EFFLUX PROTEIN YFMO', 242066),
(327660, 'PTHR43683', NULL, NULL, NULL, NULL, 'MULTIDRUG EFFLUX PROTEIN YFMO', 242066),
(327661, 'PTHR45733', NULL, NULL, NULL, NULL, 'FORMIN-J', 242067),
(327662, 'PTHR45733:SF3', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', 242067),
(327663, 'PTHR45733:SF25', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN 13', 242067),
(327664, 'PTHR45733:SF26', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 242067),
(327665, 'PTHR45733:SF5', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN 7', 242067),
(327666, 'PTHR45733:SF8', NULL, NULL, NULL, NULL, 'FORMIN-J', 242067),
(327667, 'PTHR45733:SF16', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 242067),
(327668, 'PTHR45733:SF27', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 242067),
(327669, 'PTHR45733:SF17', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN 14', 242067);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(327670, 'PTHR45733:SF28', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 242067),
(327671, 'PTHR45733:SF7', NULL, NULL, NULL, NULL, 'OS06G0184400 PROTEIN', 242067),
(327672, 'PTHR45733:SF29', NULL, NULL, NULL, NULL, '', 242067),
(327673, 'PTHR45733:SF9', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN 12', 242067),
(327674, 'PTHR45733:SF30', NULL, NULL, NULL, NULL, '', 242067),
(327675, 'PTHR45733:SF20', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 242067),
(327676, 'PTHR45733:SF10', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN 15A-RELATED', 242067),
(327677, 'PTHR45733:SF22', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 242067),
(327678, 'PTHR45733:SF13', NULL, NULL, NULL, NULL, 'OS03G0428400 PROTEIN', 242067),
(327679, 'PTHR34402:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG02762', 242068),
(327680, 'PTHR34402', NULL, NULL, NULL, NULL, 'PROTEIN CBG02762', 242068),
(327681, 'PTHR12922', NULL, NULL, NULL, NULL, 'UBIQUINONE BIOSYNTHESIS PROTEIN', 242069),
(327682, 'PTHR12922:SF9', NULL, NULL, NULL, NULL, 'UBIQUINONE BIOSYNTHESIS PROTEIN COQ4 HOMOLOG, MITOCHONDRIAL', 242069),
(327683, 'PTHR12922:SF7', NULL, NULL, NULL, NULL, 'UBIQUINONE BIOSYNTHESIS PROTEIN COQ4 HOMOLOG, MITOCHONDRIAL', 242069),
(327684, 'PTHR34714:SF2', NULL, NULL, NULL, NULL, '', 242070),
(327685, 'PTHR34714', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 242070),
(327686, 'PTHR34714:SF1', NULL, NULL, NULL, NULL, '', 242070),
(327687, 'PTHR12837', NULL, NULL, NULL, NULL, 'POLY ADP-RIBOSE  GLYCOHYDROLASE', 242071),
(327688, 'PTHR12837:SF14', NULL, NULL, NULL, NULL, 'POLY(ADP-RIBOSE) GLYCOHYDROLASE', 242071),
(327689, 'PTHR12837:SF13', NULL, NULL, NULL, NULL, 'POLY(ADP-RIBOSE) GLYCOHYDROLASE', 242071),
(327690, 'PTHR12837:SF12', NULL, NULL, NULL, NULL, 'POLY(ADP-RIBOSE) GLYCOHYDROLASE', 242071),
(327691, 'PTHR12837:SF11', NULL, NULL, NULL, NULL, 'POLY(ADP-RIBOSE) GLYCOHYDROLASE', 242071),
(327692, 'PTHR12837:SF9', NULL, NULL, NULL, NULL, 'POLY(ADP-RIBOSE) GLYCOHYDROLASE', 242071),
(327693, 'PTHR12837:SF8', NULL, NULL, NULL, NULL, 'POLY(ADP-RIBOSE) GLYCOHYDROLASE', 242071),
(327694, 'PTHR12837:SF15', NULL, NULL, NULL, NULL, 'POLY(ADP-RIBOSE) GLYCOHYDROLASE', 242071),
(327695, 'PTHR12837:SF7', NULL, NULL, NULL, NULL, 'POLY(ADP-RIBOSE) GLYCOHYDROLASE 2-RELATED', 242071),
(327696, 'PTHR12837:SF0', NULL, NULL, NULL, NULL, 'POLY(ADP-RIBOSE) GLYCOHYDROLASE', 242071),
(327697, 'PTHR35165:SF4', NULL, NULL, NULL, NULL, 'OS03G0126900 PROTEIN', 242072),
(327698, 'PTHR35165:SF1', NULL, NULL, NULL, NULL, 'OS04G0577375 PROTEIN', 242072),
(327699, 'PTHR35165', NULL, NULL, NULL, NULL, 'OS08G0113900 PROTEIN', 242072),
(327700, 'PTHR35165:SF5', NULL, NULL, NULL, NULL, '', 242072),
(327701, 'PTHR35165:SF6', NULL, NULL, NULL, NULL, 'OS08G0113900 PROTEIN', 242072),
(327702, 'PTHR12514', NULL, NULL, NULL, NULL, 'ENHANCER OF YELLOW 2 TRANSCRIPTION FACTOR', 242073),
(327703, 'PTHR12514:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION AND MRNA EXPORT FACTOR ENY2', 242073),
(327704, 'PTHR12514:SF4', NULL, NULL, NULL, NULL, 'BNAA06G32420D PROTEIN', 242073),
(327705, 'PTHR12514:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTION AND MRNA EXPORT FACTOR ENY2', 242073),
(327706, 'PTHR24329:SF543', NULL, NULL, NULL, NULL, 'DORSAL ROOT GANGLIA HOMEOBOX, ISOFORM E-RELATED', 242074),
(327707, 'PTHR24329:SF301', NULL, NULL, NULL, NULL, 'PAIRED MESODERM HOMEOBOX PROTEIN 2B', 242074),
(327708, 'PTHR24329:SF565', NULL, NULL, NULL, NULL, 'REPRODUCTIVE HOMEOBOX 10', 242074),
(327709, 'PTHR24329:SF542', NULL, NULL, NULL, NULL, 'DORSAL ROOT GANGLIA HOMEOBOX PROTEIN', 242074),
(327710, 'PTHR24329:SF322', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN ARISTALESS-LIKE 4', 242074),
(327711, 'PTHR24329:SF520', NULL, NULL, NULL, NULL, 'ALX HOMEOBOX PROTEIN 1-LIKE PROTEIN', 242074),
(327712, 'PTHR24329:SF564', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN ARX', 242074),
(327713, 'PTHR24329:SF545', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN ESX1', 242074),
(327714, 'PTHR24329:SF567', NULL, NULL, NULL, NULL, 'RHOX HOMEOBOX FAMILY MEMBER 2-RELATED', 242074),
(327715, 'PTHR24329:SF303', NULL, NULL, NULL, NULL, 'PAIRED MESODERM HOMEOBOX PROTEIN 2A', 242074); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(327716, 'PTHR24329:SF566', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN UNC-4', 242074),
(327717, 'PTHR24329:SF569', NULL, NULL, NULL, NULL, 'IP01065P', 242074),
(327718, 'PTHR24329:SF547', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN PROPHET OF PIT-1-LIKE', 242074),
(327719, 'PTHR24329:SF568', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN-RELATED', 242074),
(327720, 'PTHR24329:SF549', NULL, NULL, NULL, NULL, 'RHOX HOMEOBOX FAMILY MEMBER 1', 242074),
(327721, 'PTHR24329:SF92', NULL, NULL, NULL, NULL, 'REPRODUCTIVE HOMEOBOX 11', 242074),
(327722, 'PTHR24329:SF405', NULL, NULL, NULL, NULL, 'RETINAL HOMEOBOX PROTEIN RX', 242074),
(327723, 'PTHR24329:SF340', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN ARISTALESS-LIKE 3', 242074),
(327724, 'PTHR24329:SF362', NULL, NULL, NULL, NULL, 'INTESTINE-SPECIFIC HOMEOBOX', 242074),
(327725, 'PTHR24329:SF560', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 242074),
(327726, 'PTHR24329:SF563', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 242074),
(327727, 'PTHR24329:SF540', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 242074),
(327728, 'PTHR24329:SF562', NULL, NULL, NULL, NULL, 'SI:DKEY-43P13.5', 242074),
(327729, 'PTHR24329', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN ARISTALESS', 242074),
(327730, 'PTHR24329:SF556', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN DSC-1', 242074),
(327731, 'PTHR24329:SF557', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN RHOX13', 242074),
(327732, 'PTHR24329:SF359', NULL, NULL, NULL, NULL, 'ALX HOMEOBOX PROTEIN 1', 242074),
(327733, 'PTHR24329:SF337', NULL, NULL, NULL, NULL, 'ARISTALESS-RELATED HOMEOBOX PROTEIN-RELATED', 242074),
(327734, 'PTHR24329:SF516', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN GOOSECOID', 242074),
(327735, 'PTHR24329:SF559', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN ARX-LIKE', 242074),
(327736, 'PTHR24329:SF570', NULL, NULL, NULL, NULL, 'HOMEOBRAIN', 242074),
(327737, 'PTHR24329:SF572', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN ARX', 242074),
(327738, 'PTHR24329:SF571', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN CEH-17', 242074),
(327739, 'PTHR24329:SF552', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 242074),
(327740, 'PTHR24329:SF573', NULL, NULL, NULL, NULL, 'EXTRAEMBRYONIC, SPERMATOGENESIS, HOMEOBOX 1', 242074),
(327741, 'PTHR10102:SF22', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE', 242075),
(327742, 'PTHR10102:SF21', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE 2, CHLOROPLASTIC/MITOCHONDRIAL', 242075),
(327743, 'PTHR10102:SF20', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE 2B, CHLOROPLASTIC/MITOCHONDRIAL', 242075),
(327744, 'PTHR10102:SF0', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE, MITOCHONDRIAL', 242075),
(327745, 'PTHR10102:SF1', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE 3, CHLOROPLASTIC', 242075),
(327746, 'PTHR10102:SF19', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE', 242075),
(327747, 'PTHR10102', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE, MITOCHONDRIAL', 242075),
(327748, 'PTHR10102:SF8', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE', 242075),
(327749, 'PTHR10102:SF13', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE', 242075),
(327750, 'PTHR10102:SF23', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE', 242075),
(327751, 'PTHR46916:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 205', 242076),
(327752, 'PTHR46916:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 205', 242076),
(327753, 'PTHR46916', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 205', 242076),
(327754, 'PTHR31213:SF69', NULL, NULL, NULL, NULL, 'ABSCISIC ACID RECEPTOR PYL3', 242077),
(327755, 'PTHR31213:SF106', NULL, NULL, NULL, NULL, 'ABSCISIC ACID RECEPTOR PYL4', 242077),
(327756, 'PTHR31213:SF107', NULL, NULL, NULL, NULL, 'ABSCISIC ACID RECEPTOR PYL4-LIKE', 242077),
(327757, 'PTHR31213:SF148', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 242077),
(327758, 'PTHR31213:SF105', NULL, NULL, NULL, NULL, 'S-NORCOCLAURINE SYNTHASE 1-LIKE', 242077),
(327759, 'PTHR31213:SF149', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED PROTEIN STH-2', 242077);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(327760, 'PTHR31213:SF64', NULL, NULL, NULL, NULL, 'PHYTOHORMONE-BINDING PROTEIN', 242077),
(327761, 'PTHR31213:SF62', NULL, NULL, NULL, NULL, 'S-NORCOCLAURINE SYNTHASE 2-LIKE', 242077),
(327762, 'PTHR31213:SF61', NULL, NULL, NULL, NULL, 'ABSCISIC ACID RECEPTOR PYL10', 242077),
(327763, 'PTHR31213:SF24', NULL, NULL, NULL, NULL, 'OS08G0374000 PROTEIN', 242077),
(327764, 'PTHR31213:SF68', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 242077),
(327765, 'PTHR31213:SF67', NULL, NULL, NULL, NULL, 'MAJOR ALLERGEN PRU AV 1-LIKE', 242077),
(327766, 'PTHR31213:SF23', NULL, NULL, NULL, NULL, 'OS04G0593400 PROTEIN', 242077),
(327767, 'PTHR31213:SF183', NULL, NULL, NULL, NULL, 'ABSCISIC ACID RECEPTOR PYL5', 242077),
(327768, 'PTHR31213:SF70', NULL, NULL, NULL, NULL, 'MAJOR ALLERGEN PRU AR 1-LIKE', 242077),
(327769, 'PTHR31213:SF103', NULL, NULL, NULL, NULL, 'ABSCISIC ACID RECEPTOR PYL9', 242077),
(327770, 'PTHR31213:SF188', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 242077),
(327771, 'PTHR31213:SF189', NULL, NULL, NULL, NULL, 'OS04G0593500 PROTEIN', 242077),
(327772, 'PTHR31213:SF186', NULL, NULL, NULL, NULL, 'PYR1-LIKE 3', 242077),
(327773, 'PTHR31213:SF142', NULL, NULL, NULL, NULL, 'BNAC03G22610D PROTEIN', 242077),
(327774, 'PTHR31213:SF187', NULL, NULL, NULL, NULL, 'ABSCISIC ACID RECEPTOR PYL1', 242077),
(327775, 'PTHR31213:SF184', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED PROTEIN BET V I FAMILY PROTEIN', 242077),
(327776, 'PTHR31213:SF185', NULL, NULL, NULL, NULL, 'START-LIKE DOMAIN, BET V I TYPE ALLERGEN-RELATED', 242077),
(327777, 'PTHR31213:SF17', NULL, NULL, NULL, NULL, 'PR-10 TYPE PATHOGENESIS-RELATED PROTEIN-RELATED', 242077),
(327778, 'PTHR31213:SF139', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 242077),
(327779, 'PTHR31213:SF19', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 242077),
(327780, 'PTHR31213:SF138', NULL, NULL, NULL, NULL, 'ABSCISIC ACID RECEPTOR PYL6', 242077),
(327781, 'PTHR31213:SF96', NULL, NULL, NULL, NULL, 'S-NORCOCLAURINE SYNTHASE 2-LIKE', 242077),
(327782, 'PTHR31213:SF99', NULL, NULL, NULL, NULL, 'ABSCISIC ACID RECEPTOR PYL9', 242077),
(327783, 'PTHR31213:SF55', NULL, NULL, NULL, NULL, 'STRESS-INDUCED PROTEIN SAM22', 242077),
(327784, 'PTHR31213:SF171', NULL, NULL, NULL, NULL, 'BNAA07G38130D PROTEIN', 242077),
(327785, 'PTHR31213', NULL, NULL, NULL, NULL, '', 242077),
(327786, 'PTHR31213:SF170', NULL, NULL, NULL, NULL, 'S-NORCOCLAURINE SYNTHASE 2-LIKE', 242077),
(327787, 'PTHR31213:SF136', NULL, NULL, NULL, NULL, 'BNAA03G12450D PROTEIN', 242077),
(327788, 'PTHR31213:SF177', NULL, NULL, NULL, NULL, 'ROOT ALLERGEN PROTEIN-RELATED', 242077),
(327789, 'PTHR31213:SF178', NULL, NULL, NULL, NULL, 'OS01G0827800 PROTEIN', 242077),
(327790, 'PTHR31213:SF175', NULL, NULL, NULL, NULL, 'ABSCISIC ACID RECEPTOR PYL9-LIKE', 242077),
(327791, 'PTHR31213:SF176', NULL, NULL, NULL, NULL, 'MAJOR ALLERGEN PRU AV 1-LIKE', 242077),
(327792, 'PTHR31213:SF173', NULL, NULL, NULL, NULL, 'POLYKETIDE CYCLASE/DEHYDRASE, START-LIKE DOMAIN PROTEIN-RELATED', 242077),
(327793, 'PTHR31213:SF174', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED PROTEIN STH-21-LIKE', 242077),
(327794, 'PTHR31213:SF207', NULL, NULL, NULL, NULL, 'S-NORCOCLAURINE SYNTHASE', 242077),
(327795, 'PTHR31213:SF205', NULL, NULL, NULL, NULL, 'ABSCISIC ACID RECEPTOR PYL3', 242077),
(327796, 'PTHR31213:SF128', NULL, NULL, NULL, NULL, 'BNAA03G17720D PROTEIN', 242077),
(327797, 'PTHR31213:SF206', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 242077),
(327798, 'PTHR31213:SF203', NULL, NULL, NULL, NULL, 'POLYKETIDE CYCLASE/DEHYDRASE, START-LIKE DOMAIN PROTEIN-RELATED', 242077),
(327799, 'PTHR31213:SF127', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 242077),
(327800, 'PTHR31213:SF204', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 242077),
(327801, 'PTHR31213:SF86', NULL, NULL, NULL, NULL, 'POLYKETIDE CYCLASE/DEHYDRASE AND LIPID TRANSPORTER', 242077),
(327802, 'PTHR31213:SF84', NULL, NULL, NULL, NULL, 'ABSCISIC ACID RECEPTOR PYL2-LIKE', 242077);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(327803, 'PTHR31213:SF89', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED PROTEIN STH-2-LIKE', 242077),
(327804, 'PTHR31213:SF88', NULL, NULL, NULL, NULL, 'ABA-RESPONSIVE PROTEIN', 242077),
(327805, 'PTHR31213:SF87', NULL, NULL, NULL, NULL, 'NODULIN-13', 242077),
(327806, 'PTHR31213:SF161', NULL, NULL, NULL, NULL, 'ABSCISIC ACID RECEPTOR PYL4-LIKE', 242077),
(327807, 'PTHR31213:SF90', NULL, NULL, NULL, NULL, 'S-NORCOCLAURINE SYNTHASE 2-LIKE', 242077),
(327808, 'PTHR31213:SF201', NULL, NULL, NULL, NULL, 'OS03G0300400 PROTEIN', 242077),
(327809, 'PTHR31213:SF168', NULL, NULL, NULL, NULL, 'OS12G0555100 PROTEIN', 242077),
(327810, 'PTHR31213:SF124', NULL, NULL, NULL, NULL, 'ABSCISIC ACID RECEPTOR PYL8', 242077),
(327811, 'PTHR31213:SF169', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 242077),
(327812, 'PTHR31213:SF202', NULL, NULL, NULL, NULL, 'OS03G0297600 PROTEIN', 242077),
(327813, 'PTHR31213:SF123', NULL, NULL, NULL, NULL, '', 242077),
(327814, 'PTHR31213:SF200', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 242077),
(327815, 'PTHR31213:SF120', NULL, NULL, NULL, NULL, 'BNAANNG35310D PROTEIN', 242077),
(327816, 'PTHR31213:SF121', NULL, NULL, NULL, NULL, 'MAJOR ALLERGEN PRU AR', 242077),
(327817, 'PTHR31213:SF162', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 242077),
(327818, 'PTHR31213:SF4', NULL, NULL, NULL, NULL, 'ABSCISIC ACID RECEPTOR PYL8', 242077),
(327819, 'PTHR31213:SF3', NULL, NULL, NULL, NULL, 'ABSCISIC ACID RECEPTOR PYL2', 242077),
(327820, 'PTHR31213:SF119', NULL, NULL, NULL, NULL, 'ABSCISIC ACID RECEPTOR PYL4', 242077),
(327821, 'PTHR31213:SF116', NULL, NULL, NULL, NULL, 'BNAANNG26820D PROTEIN', 242077),
(327822, 'PTHR31213:SF74', NULL, NULL, NULL, NULL, 'ABSCISIC ACID RECEPTOR PYL9-LIKE', 242077),
(327823, 'PTHR31213:SF73', NULL, NULL, NULL, NULL, 'ABSCISIC ACID RECEPTOR PYL1', 242077),
(327824, 'PTHR31213:SF78', NULL, NULL, NULL, NULL, 'ABSCISIC ACID RECEPTOR PYL7', 242077),
(327825, 'PTHR31213:SF76', NULL, NULL, NULL, NULL, 'ABSCISIC ACID RECEPTOR', 242077),
(327826, 'PTHR31213:SF193', NULL, NULL, NULL, NULL, '', 242077),
(327827, 'PTHR31213:SF150', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED PROTEIN', 242077),
(327828, 'PTHR31213:SF194', NULL, NULL, NULL, NULL, 'ABSCISIC ACID RECEPTOR PYL4-LIKE', 242077),
(327829, 'PTHR31213:SF191', NULL, NULL, NULL, NULL, 'ABSCISIC ACID RECEPTOR PYR1', 242077),
(327830, 'PTHR31213:SF192', NULL, NULL, NULL, NULL, 'MAJOR ALLERGEN PRU AR 1-LIKE', 242077),
(327831, 'PTHR31213:SF82', NULL, NULL, NULL, NULL, 'ABSCISIC ACID RECEPTOR PYL11-RELATED', 242077),
(327832, 'PTHR31213:SF190', NULL, NULL, NULL, NULL, 'PYR1-LIKE 4-RELATED', 242077),
(327833, 'PTHR31213:SF81', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 242077),
(327834, 'PTHR31213:SF80', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED PROTEIN 10', 242077),
(327835, 'PTHR31213:SF157', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED PROTEIN', 242077),
(327836, 'PTHR31213:SF158', NULL, NULL, NULL, NULL, 'ABSCISIC ACID RECEPTOR PYL4-LIKE', 242077),
(327837, 'PTHR31213:SF199', NULL, NULL, NULL, NULL, 'POLYKETIDE CYCLASE/DEHYDRASE, START-LIKE DOMAIN PROTEIN-RELATED', 242077),
(327838, 'PTHR31213:SF112', NULL, NULL, NULL, NULL, 'ABSCISIC ACID RECEPTOR PYL13', 242077),
(327839, 'PTHR31213:SF197', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 242077),
(327840, 'PTHR31213:SF153', NULL, NULL, NULL, NULL, 'BNAANNG40650D PROTEIN', 242077),
(327841, 'PTHR31213:SF198', NULL, NULL, NULL, NULL, 'BNAC04G04830D PROTEIN', 242077),
(327842, 'PTHR31213:SF6', NULL, NULL, NULL, NULL, 'ABSCISIC ACID RECEPTOR PYR1', 242077),
(327843, 'PTHR31213:SF195', NULL, NULL, NULL, NULL, 'BNAA10G06520D PROTEIN', 242077),
(327844, 'PTHR31213:SF196', NULL, NULL, NULL, NULL, 'ABSCISIC ACID RECEPTOR PYL9-LIKE PROTEIN', 242077),
(327845, 'PTHR31213:SF152', NULL, NULL, NULL, NULL, 'BET_V_1 DOMAIN-CONTAINING PROTEIN', 242077),
(327846, 'PTHR22444', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 242078),
(327847, 'PTHR22444:SF1', NULL, NULL, NULL, NULL, 'GLUTAMATE-RICH PROTEIN 1', 242078);
INSERT INTO "PUBLIC"."MODEL" VALUES
(327848, 'PTHR15196', NULL, NULL, NULL, NULL, 'CILIARY NEUROTROPHIC FACTOR', 242079),
(327849, 'PTHR15196:SF1', NULL, NULL, NULL, NULL, 'CILIARY NEUROTROPHIC FACTOR', 242079),
(327850, 'PTHR15196:SF0', NULL, NULL, NULL, NULL, 'CILIARY NEUROTROPHIC FACTOR', 242079),
(327851, 'PTHR28147:SF1', NULL, NULL, NULL, NULL, 'N-GLYCOSYLATION PROTEIN EOS1', 242080),
(327852, 'PTHR28147', NULL, NULL, NULL, NULL, 'N-GLYCOSYLATION PROTEIN EOS1', 242080),
(327853, 'PTHR37283', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN YHR131C', 242081),
(327854, 'PTHR37283:SF1', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN YHR131C', 242081),
(327855, 'PTHR45835:SF89', NULL, NULL, NULL, NULL, 'RT_RNASEH_2 DOMAIN-CONTAINING PROTEIN', 242082),
(327856, 'PTHR45835:SF88', NULL, NULL, NULL, NULL, 'DNA/RNA POLYMERASES SUPERFAMILY PROTEIN', 242082),
(327857, 'PTHR45835:SF99', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE', 242082),
(327858, 'PTHR45835:SF98', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 242082),
(327859, 'PTHR45835:SF87', NULL, NULL, NULL, NULL, '', 242082),
(327860, 'PTHR45835', NULL, NULL, NULL, NULL, 'YALI0A06105P', 242082),
(327861, 'PTHR45835:SF97', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE', 242082),
(327862, 'PTHR45835:SF86', NULL, NULL, NULL, NULL, 'INTEGRASE_H2C2 DOMAIN-CONTAINING PROTEIN', 242082),
(327863, 'PTHR45835:SF100', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 242082),
(327864, 'PTHR45835:SF92', NULL, NULL, NULL, NULL, 'CHROMO DOMAIN-CONTAINING PROTEIN', 242082),
(327865, 'PTHR45835:SF91', NULL, NULL, NULL, NULL, 'RT_RNASEH_2 DOMAIN-CONTAINING PROTEIN', 242082),
(327866, 'PTHR45835:SF90', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 242082),
(327867, 'PTHR45835:SF96', NULL, NULL, NULL, NULL, 'COV1', 242082),
(327868, 'PTHR45835:SF95', NULL, NULL, NULL, NULL, 'INTEGRASE_H2C2 DOMAIN-CONTAINING PROTEIN', 242082),
(327869, 'PTHR45835:SF94', NULL, NULL, NULL, NULL, 'INTEGRASE_H2C2 DOMAIN-CONTAINING PROTEIN', 242082),
(327870, 'PTHR45835:SF93', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 242082),
(327871, 'PTHR16675:SF164', NULL, NULL, NULL, NULL, 'HLA CLASS I HISTOCOMPATIBILITY ANTIGEN, ALPHA CHAIN E', 242083),
(327872, 'PTHR16675:SF243', NULL, NULL, NULL, NULL, 'HISTOCOMPATIBILITY 2, M REGION LOCUS 5', 242083),
(327873, 'PTHR16675:SF242', NULL, NULL, NULL, NULL, 'ZINC-ALPHA-2-GLYCOPROTEIN', 242083),
(327874, 'PTHR16675:SF264', NULL, NULL, NULL, NULL, 'HISTOCOMPATIBILITY 2, T REGION LOCUS 10-RELATED', 242083),
(327875, 'PTHR16675:SF187', NULL, NULL, NULL, NULL, 'HLA CLASS I HISTOCOMPATIBILITY ANTIGEN, ALPHA CHAIN F', 242083),
(327876, 'PTHR16675:SF146', NULL, NULL, NULL, NULL, 'T-CELL SURFACE GLYCOPROTEIN CD1E, MEMBRANE-ASSOCIATED', 242083),
(327877, 'PTHR16675:SF267', NULL, NULL, NULL, NULL, 'MHC_I-LIKE_AG-RECOG DOMAIN-CONTAINING PROTEIN', 242083),
(327878, 'PTHR16675:SF145', NULL, NULL, NULL, NULL, 'HISTOCOMPATIBILITY 2, M REGION LOCUS 3', 242083),
(327879, 'PTHR16675:SF244', NULL, NULL, NULL, NULL, 'H-2 CLASS I HISTOCOMPATIBILITY ANTIGEN, D-37 ALPHA CHAIN', 242083),
(327880, 'PTHR16675:SF269', NULL, NULL, NULL, NULL, 'BOLA CLASS I HISTOCOMPATIBILITY ANTIGEN, ALPHA CHAIN BL3-7-LIKE', 242083),
(327881, 'PTHR16675:SF148', NULL, NULL, NULL, NULL, 'UL16-BINDING PROTEIN 6', 242083),
(327882, 'PTHR16675:SF169', NULL, NULL, NULL, NULL, 'HLA CLASS I HISTOCOMPATIBILITY ANTIGEN, ALPHA CHAIN G', 242083),
(327883, 'PTHR16675:SF147', NULL, NULL, NULL, NULL, 'HISTOCOMPATIBILITY ANTIGEN 60B-RELATED', 242083),
(327884, 'PTHR16675:SF268', NULL, NULL, NULL, NULL, 'UL16-BINDING PROTEIN 1', 242083),
(327885, 'PTHR16675:SF229', NULL, NULL, NULL, NULL, 'HLA CLASS I HISTOCOMPATIBILITY ANTIGEN, A ALPHA CHAIN', 242083),
(327886, 'PTHR16675:SF3', NULL, NULL, NULL, NULL, 'IGG RECEPTOR FCRN LARGE SUBUNIT P51', 242083),
(327887, 'PTHR16675:SF1', NULL, NULL, NULL, NULL, 'ULBP21', 242083),
(327888, 'PTHR16675:SF191', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 242083);
INSERT INTO "PUBLIC"."MODEL" VALUES
(327889, 'PTHR16675:SF190', NULL, NULL, NULL, NULL, 'MHC CLASS I-LIKE PROTEIN MILL2', 242083),
(327890, 'PTHR16675:SF270', NULL, NULL, NULL, NULL, 'HLA CLASS I HISTOCOMPATIBILITY ANTIGEN, B ALPHA CHAIN', 242083),
(327891, 'PTHR16675:SF193', NULL, NULL, NULL, NULL, 'MHC CLASS I ANTIGEN ZBA TRANSCRIPT VARIANT 1-RELATED', 242083),
(327892, 'PTHR16675:SF272', NULL, NULL, NULL, NULL, 'MAJOR HISTOCOMPATIBILITY COMPLEX CLASS I-RELATED GENE PROTEIN', 242083),
(327893, 'PTHR16675:SF250', NULL, NULL, NULL, NULL, 'HISTOCOMPATIBILITY 2, T REGION LOCUS 24', 242083),
(327894, 'PTHR16675:SF172', NULL, NULL, NULL, NULL, 'HEREDITARY HEMOCHROMATOSIS PROTEIN', 242083),
(327895, 'PTHR16675:SF271', NULL, NULL, NULL, NULL, 'UL16-BINDING PROTEIN 2', 242083),
(327896, 'PTHR16675:SF150', NULL, NULL, NULL, NULL, 'HISTOCOMPATIBILITY 2, M REGION LOCUS 2', 242083),
(327897, 'PTHR16675:SF252', NULL, NULL, NULL, NULL, 'HLA CLASS I HISTOCOMPATIBILITY ANTIGEN, C ALPHA CHAIN', 242083),
(327898, 'PTHR16675:SF175', NULL, NULL, NULL, NULL, 'ANTIGEN-PRESENTING GLYCOPROTEIN CD1D', 242083),
(327899, 'PTHR16675:SF130', NULL, NULL, NULL, NULL, 'T-CELL SURFACE GLYCOPROTEIN CD1B', 242083),
(327900, 'PTHR16675:SF251', NULL, NULL, NULL, NULL, 'CLASS IB MHC ANTIGEN QA-2-RELATED', 242083),
(327901, 'PTHR16675:SF199', NULL, NULL, NULL, NULL, 'UL16-BINDING PROTEIN 3', 242083),
(327902, 'PTHR16675:SF232', NULL, NULL, NULL, NULL, 'UL-16 BINDING PROTEIN 5', 242083),
(327903, 'PTHR16675:SF155', NULL, NULL, NULL, NULL, 'T-CELL SURFACE GLYCOPROTEIN CD1C', 242083),
(327904, 'PTHR16675:SF154', NULL, NULL, NULL, NULL, 'MHC CLASS I POLYPEPTIDE-RELATED SEQUENCE A-RELATED', 242083),
(327905, 'PTHR16675:SF256', NULL, NULL, NULL, NULL, 'HLA CLASS I HISTOCOMPATIBILITY ANTIGEN, ALPHA CHAIN H-RELATED', 242083),
(327906, 'PTHR16675:SF134', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 242083),
(327907, 'PTHR16675:SF64', NULL, NULL, NULL, NULL, 'RETINOIC ACID EARLY TRANSCRIPT 1E', 242083),
(327908, 'PTHR16675:SF257', NULL, NULL, NULL, NULL, 'IGC1 DOMAIN-CONTAINING PROTEIN', 242083),
(327909, 'PTHR16675:SF235', NULL, NULL, NULL, NULL, 'RETINA AND ANTERIOR NEURAL FOLD HOMEOBOX', 242083),
(327910, 'PTHR16675:SF139', NULL, NULL, NULL, NULL, 'MHC CLASS I-LIKE PROTEIN MILL1', 242083),
(327911, 'PTHR16675:SF237', NULL, NULL, NULL, NULL, 'MHC CLASS I ANTIGEN TRANSCRIPT VARIANT 1-RELATED', 242083),
(327912, 'PTHR16675:SF67', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 242083),
(327913, 'PTHR16675:SF160', NULL, NULL, NULL, NULL, 'T-CELL SURFACE GLYCOPROTEIN CD1A', 242083),
(327914, 'PTHR16675', NULL, NULL, NULL, NULL, 'MHC CLASS I-RELATED', 242083),
(327915, 'PTHR46646', NULL, NULL, NULL, NULL, 'TOM1-LIKE PROTEIN 1', 242084),
(327916, 'PTHR46646:SF4', NULL, NULL, NULL, NULL, '', 242084),
(327917, 'PTHR46646:SF10', NULL, NULL, NULL, NULL, '', 242084),
(327918, 'PTHR46646:SF1', NULL, NULL, NULL, NULL, 'TOM1-LIKE PROTEIN 1', 242084),
(327919, 'PTHR46646:SF6', NULL, NULL, NULL, NULL, 'BNAA10G04150D PROTEIN', 242084),
(327920, 'PTHR46646:SF5', NULL, NULL, NULL, NULL, 'TOM1-LIKE PROTEIN 2', 242084),
(327921, 'PTHR46646:SF9', NULL, NULL, NULL, NULL, 'BNAA06G39960D PROTEIN', 242084),
(327922, 'PTHR35290:SF5', NULL, NULL, NULL, NULL, 'BNAA03G52930D PROTEIN', 242085),
(327923, 'PTHR35290:SF4', NULL, NULL, NULL, NULL, 'OS11G0323860 PROTEIN', 242085),
(327924, 'PTHR35290:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CASPARIAN STRIP INTEGRITY FACTOR 2', 242085),
(327925, 'PTHR35290', NULL, NULL, NULL, NULL, 'PROTEIN CASPARIAN STRIP INTEGRITY FACTOR 1-RELATED', 242085),
(327926, 'PTHR35290:SF1', NULL, NULL, NULL, NULL, 'OS01G0260800 PROTEIN', 242085),
(327927, 'PTHR35290:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CASPARIAN STRIP INTEGRITY FACTOR 1', 242085),
(327928, 'PTHR24335:SF3', NULL, NULL, NULL, NULL, 'MOTOR NEURON AND PANCREAS HOMEOBOX PROTEIN 1', 242086),
(327929, 'PTHR24335', NULL, NULL, NULL, NULL, 'MOTOR NEURON AND PANCREAS HOMEOBOX PROTEIN', 242086),
(327930, 'PTHR37937', NULL, NULL, NULL, NULL, 'CONJUGATIVE TRANSFER: DNA TRANSPORT', 242087),
(327931, 'PTHR37937:SF1', NULL, NULL, NULL, NULL, 'CONJUGATIVE TRANSFER: DNA TRANSPORT', 242087);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(327932, 'PTHR24132:SF25', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX PROTEIN 6', 242088),
(327933, 'PTHR24132:SF24', NULL, NULL, NULL, NULL, 'BRCT DOMAIN-CONTAINING PROTEIN', 242088),
(327934, 'PTHR24132', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX PROTEIN 6', 242088),
(327935, 'PTHR19890:SF13', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR RECEPTOR', 242089),
(327936, 'PTHR19890:SF10', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR RECEPTOR-LIKE 1', 242089),
(327937, 'PTHR19890', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR RECEPTOR', 242089),
(327938, 'PTHR23302', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE CHANNEL-RELATED', 242090),
(327939, 'PTHR23302:SF62', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE CHANNEL-LIKE PROTEIN 2-B', 242090),
(327940, 'PTHR23302:SF40', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE CHANNEL-LIKE, ISOFORM C', 242090),
(327941, 'PTHR23302:SF42', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE CHANNEL-LIKE PROTEIN 7', 242090),
(327942, 'PTHR23302:SF65', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE CHANNEL-LIKE PROTEIN 2', 242090),
(327943, 'PTHR23302:SF43', NULL, NULL, NULL, NULL, 'TMC DOMAIN-CONTAINING PROTEIN', 242090),
(327944, 'PTHR23302:SF45', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE CHANNEL-LIKE PROTEIN 4', 242090),
(327945, 'PTHR23302:SF24', NULL, NULL, NULL, NULL, 'TMC DOMAIN-CONTAINING PROTEIN', 242090),
(327946, 'PTHR23302:SF35', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE CHANNEL-LIKE PROTEIN 3', 242090),
(327947, 'PTHR23302:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE CHANNEL-LIKE PROTEIN 6', 242090),
(327948, 'PTHR23302:SF39', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE CHANNEL-LIKE PROTEIN 8', 242090),
(327949, 'PTHR23302:SF17', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE CHANNEL-LIKE PROTEIN 2', 242090),
(327950, 'PTHR23302:SF18', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE CHANNEL-LIKE PROTEIN 1', 242090),
(327951, 'PTHR23302:SF5', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE CHANNEL-LIKE PROTEIN 5', 242090),
(327952, 'PTHR24392:SF40', NULL, NULL, NULL, NULL, 'ZINC FINGER Y-CHROMOSOMAL PROTEIN 1', 242091),
(327953, 'PTHR24392:SF31', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242091),
(327954, 'PTHR24392:SF41', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 518B', 242091),
(327955, 'PTHR24392:SF52', NULL, NULL, NULL, NULL, 'PROTEIN CHARLATAN', 242091),
(327956, 'PTHR24392', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 242091),
(327957, 'PTHR24392:SF18', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 510', 242091),
(327958, 'PTHR24392:SF39', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 518A', 242091),
(327959, 'PTHR24392:SF49', NULL, NULL, NULL, NULL, 'PROTEIN CBR-SPR-3', 242091),
(327960, 'PTHR24392:SF55', NULL, NULL, NULL, NULL, 'AGAP001525-PA', 242091),
(327961, 'PTHR24392:SF33', NULL, NULL, NULL, NULL, 'PROTEIN HUNCHBACK', 242091),
(327962, 'PTHR24392:SF54', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 407', 242091),
(327963, 'PTHR24392:SF57', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF PRESENILIN PROTEIN 4', 242091),
(327964, 'PTHR24392:SF45', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 142', 242091),
(327965, 'PTHR24392:SF56', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242091),
(327966, 'PTHR47850', NULL, NULL, NULL, NULL, 'F-BOX/KELCH-REPEAT PROTEIN OR23', 242092),
(327967, 'PTHR47850:SF2', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN, KELCH-TYPE BETA PROPELLER-RELATED', 242092),
(327968, 'PTHR47850:SF1', NULL, NULL, NULL, NULL, 'F-BOX/KELCH-REPEAT PROTEIN OR23', 242092),
(327969, 'PTHR23303', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE REGULATORY REGION-CONTAINING', 242093),
(327970, 'PTHR23303:SF14', NULL, NULL, NULL, NULL, 'NODAL MODULATOR 1-RELATED', 242093),
(327971, 'PTHR23303:SF15', NULL, NULL, NULL, NULL, 'COLOSSIN-A', 242093),
(327972, 'PTHR43696:SF9', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 157', 242094),
(327973, 'PTHR43696', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 157', 242094),
(327974, 'PTHR14918', NULL, NULL, NULL, NULL, 'KICSTOR COMPLEX PROTEIN SZT2', 242095),
(327975, 'PTHR14918:SF3', NULL, NULL, NULL, NULL, 'KICSTOR COMPLEX PROTEIN SZT2', 242095);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(327976, 'PTHR31709:SF3', NULL, NULL, NULL, NULL, 'LEUCINE ZIPPER PROTEIN 4-RELATED', 242096),
(327977, 'PTHR31709', NULL, NULL, NULL, NULL, 'LEUCINE ZIPPER PROTEIN 4-RELATED', 242096),
(327978, 'PTHR34310:SF9', NULL, NULL, NULL, NULL, 'BLR5716 PROTEIN', 242097),
(327979, 'PTHR34310:SF8', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', 242097),
(327980, 'PTHR34310:SF5', NULL, NULL, NULL, NULL, 'DUF427 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_3G02220)', 242097),
(327981, 'PTHR34310', NULL, NULL, NULL, NULL, 'DUF427 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_3G02220)', 242097),
(327982, 'PTHR16243', NULL, NULL, NULL, NULL, 'BTG3-ASSOCIATED NUCLEAR PROTEIN BANP', 242098),
(327983, 'PTHR16243:SF2', NULL, NULL, NULL, NULL, 'PROTEIN BANP', 242098),
(327984, 'PTHR18853', NULL, NULL, NULL, NULL, 'FORKHEAD-ASSOCIATED DOMAIN-CONTAINING PROTEIN 1-RELATED', 242099),
(327985, 'PTHR18853:SF9', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 27', 242099),
(327986, 'PTHR18853:SF7', NULL, NULL, NULL, NULL, 'FORKHEAD-ASSOCIATED DOMAIN-CONTAINING PROTEIN 1', 242099),
(327987, 'PTHR18853:SF10', NULL, NULL, NULL, NULL, 'FHA DOMAIN-CONTAINING PROTEIN', 242099),
(327988, 'PTHR31299:SF0', NULL, NULL, NULL, NULL, 'PRIBOSYLTRAN DOMAIN-CONTAINING PROTEIN', 242100),
(327989, 'PTHR31299', NULL, NULL, NULL, NULL, 'ESTERASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G05850)-RELATED', 242100),
(327990, 'PTHR24182:SF13', NULL, NULL, NULL, NULL, 'LD18443P', 242101),
(327991, 'PTHR24182', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX CONTAINING 4', 242101),
(327992, 'PTHR37834:SF2', NULL, NULL, NULL, NULL, 'ACETYLXYLAN ESTERASE', 242102),
(327993, 'PTHR37834', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_2G00620)', 242102),
(327994, 'PTHR37834:SF1', NULL, NULL, NULL, NULL, 'CE2_N DOMAIN-CONTAINING PROTEIN', 242102),
(327995, 'PTHR33180:SF30', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM ANTENNA PROTEIN-LIKE PROTEIN-RELATED', 242103),
(327996, 'PTHR33180', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II CP43 REACTION CENTER PROTEIN', 242103),
(327997, 'PTHR33180:SF29', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM ANTENNA PROTEIN-LIKE PROTEIN-RELATED', 242103),
(327998, 'PTHR33180:SF28', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM ANTENNA PROTEIN-LIKE PROTEIN-RELATED', 242103),
(327999, 'PTHR33180:SF27', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II CP47 REACTION CENTER PROTEIN', 242103),
(328000, 'PTHR33180:SF26', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II CP43 REACTION CENTER PROTEIN', 242103),
(328001, 'PTHR33180:SF34', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II CP43 REACTION CENTER PROTEIN', 242103),
(328002, 'PTHR33180:SF33', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II CP43 REACTION CENTER PROTEIN', 242103),
(328003, 'PTHR33180:SF32', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II CP43 REACTION CENTER PROTEIN', 242103),
(328004, 'PTHR33180:SF31', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II CP47 REACTION CENTER PROTEIN', 242103),
(328005, 'PTHR34311:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG14644', 242104),
(328006, 'PTHR34311:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG21578', 242104),
(328007, 'PTHR34311:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG09514', 242104),
(328008, 'PTHR34311:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG21704', 242104),
(328009, 'PTHR34311:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG15354', 242104),
(328010, 'PTHR34311:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG21698', 242104),
(328011, 'PTHR34311:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG01711', 242104),
(328012, 'PTHR34311:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG15143', 242104),
(328013, 'PTHR34311:SF10', NULL, NULL, NULL, NULL, 'PROTEIN CBG27706', 242104),
(328014, 'PTHR34311', NULL, NULL, NULL, NULL, 'PROTEIN CBG21698-RELATED', 242104),
(328015, 'PTHR23310:SF13', NULL, NULL, NULL, NULL, 'DIAZEPAM-BINDING INHIBITOR-LIKE 5', 242105),
(328016, 'PTHR23310:SF54', NULL, NULL, NULL, NULL, 'ACYL-COA-BINDING PROTEIN', 242105),
(328017, 'PTHR23310:SF53', NULL, NULL, NULL, NULL, 'ACYL-COA-BINDING DOMAIN-CONTAINING PROTEIN 4', 242105),
(328018, 'PTHR23310:SF77', NULL, NULL, NULL, NULL, 'LD25952P', 242105);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(328019, 'PTHR23310:SF94', NULL, NULL, NULL, NULL, 'ACYL-COA BINDING PROTEIN 1, ISOFORM A', 242105),
(328020, 'PTHR23310:SF51', NULL, NULL, NULL, NULL, 'ACYL-COA-BINDING DOMAIN-CONTAINING PROTEIN 7', 242105),
(328021, 'PTHR23310:SF122', NULL, NULL, NULL, NULL, 'ACYL-COA-BINDING DOMAIN-CONTAINING PROTEIN 3', 242105),
(328022, 'PTHR23310:SF120', NULL, NULL, NULL, NULL, 'ACYL-COA-BINDING PROTEIN HOMOLOG 3', 242105),
(328023, 'PTHR23310:SF129', NULL, NULL, NULL, NULL, 'ACYL-COA-BINDING PROTEIN1', 242105),
(328024, 'PTHR23310:SF107', NULL, NULL, NULL, NULL, 'ACYL-COA-BINDING PROTEIN-LIKE', 242105),
(328025, 'PTHR23310:SF127', NULL, NULL, NULL, NULL, 'ACB DOMAIN-CONTAINING PROTEIN', 242105),
(328026, 'PTHR23310:SF105', NULL, NULL, NULL, NULL, 'ACYL-COA-BINDING DOMAIN-CONTAINING PROTEIN 5', 242105),
(328027, 'PTHR23310:SF128', NULL, NULL, NULL, NULL, 'ACB DOMAIN-CONTAINING PROTEIN', 242105),
(328028, 'PTHR23310:SF126', NULL, NULL, NULL, NULL, 'DIAZEPAM-BINDING INHIBITOR (GABA RECEPTOR MODULATOR, ACYL-COA-BINDING PROTEIN)', 242105),
(328029, 'PTHR23310:SF124', NULL, NULL, NULL, NULL, 'ACB DOMAIN-CONTAINING PROTEIN', 242105),
(328030, 'PTHR23310:SF6', NULL, NULL, NULL, NULL, 'ACYL-COA-BINDING DOMAIN-CONTAINING PROTEIN 5', 242105),
(328031, 'PTHR23310:SF67', NULL, NULL, NULL, NULL, 'ACB DOMAIN-CONTAINING PROTEIN', 242105),
(328032, 'PTHR23310:SF62', NULL, NULL, NULL, NULL, 'ACYL-COA BINDING PROTEIN 3, ISOFORM A-RELATED', 242105),
(328033, 'PTHR23310', NULL, NULL, NULL, NULL, 'ACYL-COA-BINDING PROTEIN, ACBP', 242105),
(328034, 'PTHR23310:SF132', NULL, NULL, NULL, NULL, 'FERM/ACYL-COA-BINDING PROTEIN, 3-HELICAL BUNDLE-RELATED', 242105),
(328035, 'PTHR23310:SF110', NULL, NULL, NULL, NULL, 'ACB DOMAIN-CONTAINING PROTEIN', 242105),
(328036, 'PTHR23310:SF130', NULL, NULL, NULL, NULL, 'ACB DOMAIN-CONTAINING PROTEIN', 242105),
(328037, 'PTHR23310:SF131', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE-RELATED', 242105),
(328038, 'PTHR23310:SF116', NULL, NULL, NULL, NULL, 'ACB DOMAIN-CONTAINING PROTEIN', 242105),
(328039, 'PTHR23310:SF117', NULL, NULL, NULL, NULL, 'ACB DOMAIN-CONTAINING PROTEIN', 242105),
(328040, 'PTHR23310:SF115', NULL, NULL, NULL, NULL, 'ACB DOMAIN-CONTAINING PROTEIN', 242105),
(328041, 'PTHR23310:SF112', NULL, NULL, NULL, NULL, 'ACB DOMAIN-CONTAINING PROTEIN', 242105),
(328042, 'PTHR35291', NULL, NULL, NULL, NULL, 'PROTEIN SHROOM-LIKE', 242106),
(328043, 'PTHR35291:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 242106),
(328044, 'PTHR35291:SF10', NULL, NULL, NULL, NULL, 'PROTEIN SHROOM-LIKE', 242106),
(328045, 'PTHR35291:SF9', NULL, NULL, NULL, NULL, 'BNAC07G16740D PROTEIN', 242106),
(328046, 'PTHR35291:SF8', NULL, NULL, NULL, NULL, '', 242106),
(328047, 'PTHR35291:SF7', NULL, NULL, NULL, NULL, 'BNAC07G31940D PROTEIN', 242106),
(328048, 'PTHR35291:SF3', NULL, NULL, NULL, NULL, 'BNAANNG35820D PROTEIN', 242106),
(328049, 'PTHR23091:SF283', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASE-RELATED', 242107),
(328050, 'PTHR23091:SF282', NULL, NULL, NULL, NULL, 'N-ALPHA-ACETYLTRANSFERASE 11', 242107),
(328051, 'PTHR23091', NULL, NULL, NULL, NULL, 'N-TERMINAL ACETYLTRANSFERASE', 242107),
(328052, 'PTHR23091:SF284', NULL, NULL, NULL, NULL, 'N(ALPHA)-ACETYLTRANSFERASE 12, NATA CATALYTIC SUBUNIT', 242107),
(328053, 'PTHR23091:SF268', NULL, NULL, NULL, NULL, 'N-ALPHA-ACETYLTRANSFERASE 10', 242107),
(328054, 'PTHR23091:SF4', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 242107),
(328055, 'PTHR12356:SF19', NULL, NULL, NULL, NULL, 'NUDC DOMAIN-CONTAINING PROTEIN 3', 242108),
(328056, 'PTHR12356:SF3', NULL, NULL, NULL, NULL, 'NUCLEAR MIGRATION PROTEIN NUDC', 242108),
(328057, 'PTHR12356:SF32', NULL, NULL, NULL, NULL, 'PROTEIN BOBBER 2', 242108),
(328058, 'PTHR12356:SF31', NULL, NULL, NULL, NULL, 'PROTEIN BOBBER 1-LIKE', 242108),
(328059, 'PTHR12356', NULL, NULL, NULL, NULL, 'NUCLEAR MOVEMENT PROTEIN NUDC', 242108),
(328060, 'PTHR12356:SF29', NULL, NULL, NULL, NULL, 'CS DOMAIN-CONTAINING PROTEIN', 242108),
(328061, 'PTHR12356:SF18', NULL, NULL, NULL, NULL, 'NUDC DOMAIN-CONTAINING PROTEIN 2', 242108);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(328062, 'PTHR12356:SF17', NULL, NULL, NULL, NULL, 'CS DOMAIN-CONTAINING PROTEIN', 242108),
(328063, 'PTHR12356:SF28', NULL, NULL, NULL, NULL, 'PROTEIN BOBBER 2-LIKE', 242108),
(328064, 'PTHR12356:SF23', NULL, NULL, NULL, NULL, 'CS DOMAIN-CONTAINING PROTEIN', 242108),
(328065, 'PTHR12356:SF22', NULL, NULL, NULL, NULL, 'PROTEIN BOBBER 2-LIKE', 242108),
(328066, 'PTHR12356:SF14', NULL, NULL, NULL, NULL, 'MOVEMENT PROTEIN, PUTATIVE-RELATED', 242108),
(328067, 'PTHR12356:SF25', NULL, NULL, NULL, NULL, 'CS DOMAIN-CONTAINING PROTEIN', 242108),
(328068, 'PTHR37233:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 242109),
(328069, 'PTHR37233:SF3', NULL, NULL, NULL, NULL, 'BNAA05G28610D PROTEIN', 242109),
(328070, 'PTHR37233', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 242109),
(328071, 'PTHR31664:SF4', NULL, NULL, NULL, NULL, 'DUF4440 DOMAIN-CONTAINING PROTEIN', 242110),
(328072, 'PTHR31664', NULL, NULL, NULL, NULL, 'PROTEIN CBG16427', 242110),
(328073, 'PTHR31664:SF3', NULL, NULL, NULL, NULL, 'DUF4440 DOMAIN-CONTAINING PROTEIN', 242110),
(328074, 'PTHR31664:SF9', NULL, NULL, NULL, NULL, 'DUF4440 DOMAIN-CONTAINING PROTEIN', 242110),
(328075, 'PTHR31664:SF8', NULL, NULL, NULL, NULL, 'DUF4440 DOMAIN-CONTAINING PROTEIN', 242110),
(328076, 'PTHR31664:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG09301', 242110),
(328077, 'PTHR31664:SF5', NULL, NULL, NULL, NULL, 'DUF4440 DOMAIN-CONTAINING PROTEIN', 242110),
(328078, 'PTHR33786:SF3', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242111),
(328079, 'PTHR33786:SF2', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 242111),
(328080, 'PTHR33786:SF5', NULL, NULL, NULL, NULL, 'PROTEIN KINASE APK1B, CHLOROPLAST', 242111),
(328081, 'PTHR33786:SF12', NULL, NULL, NULL, NULL, '', 242111),
(328082, 'PTHR33786:SF11', NULL, NULL, NULL, NULL, '', 242111),
(328083, 'PTHR33786:SF10', NULL, NULL, NULL, NULL, '', 242111),
(328084, 'PTHR33786', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 242111),
(328085, 'PTHR33786:SF9', NULL, NULL, NULL, NULL, 'CRP7-CYSTEINE-RICH FAMILY PROTEIN EXPRESSED', 242111),
(328086, 'PTHR46285:SF6', NULL, NULL, NULL, NULL, 'PLANT VIRAL-RESPONSE FAMILY PROTEIN', 242112),
(328087, 'PTHR46285:SF7', NULL, NULL, NULL, NULL, 'OS06G0238900 PROTEIN', 242112),
(328088, 'PTHR46285:SF8', NULL, NULL, NULL, NULL, '', 242112),
(328089, 'PTHR46285:SF9', NULL, NULL, NULL, NULL, 'BNAC03G70340D PROTEIN', 242112),
(328090, 'PTHR46285:SF1', NULL, NULL, NULL, NULL, 'OS09G0444800 PROTEIN', 242112),
(328091, 'PTHR46285:SF15', NULL, NULL, NULL, NULL, '', 242112),
(328092, 'PTHR46285:SF3', NULL, NULL, NULL, NULL, 'PROTEINASE INHIBITOR I4, SERPIN (DUF716)', 242112),
(328093, 'PTHR46285:SF14', NULL, NULL, NULL, NULL, 'BNAC03G70350D PROTEIN', 242112),
(328094, 'PTHR46285:SF4', NULL, NULL, NULL, NULL, 'BNAC02G09150D PROTEIN', 242112),
(328095, 'PTHR46285:SF13', NULL, NULL, NULL, NULL, 'OS02G0167775 PROTEIN', 242112),
(328096, 'PTHR46285:SF5', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 45A-LIKE', 242112),
(328097, 'PTHR46285:SF12', NULL, NULL, NULL, NULL, 'OS08G0462800 PROTEIN', 242112),
(328098, 'PTHR46285:SF11', NULL, NULL, NULL, NULL, '', 242112),
(328099, 'PTHR46285:SF10', NULL, NULL, NULL, NULL, 'T1.3 PROTEIN', 242112),
(328100, 'PTHR46285', NULL, NULL, NULL, NULL, 'PROTEINASE INHIBITOR I4, SERPIN (DUF716)-RELATED', 242112),
(328101, 'PTHR30388', NULL, NULL, NULL, NULL, 'ALDEHYDE OXIDOREDUCTASE MOLYBDENUM COFACTOR ASSEMBLY PROTEIN', 242113),
(328102, 'PTHR30388:SF4', NULL, NULL, NULL, NULL, 'MOLYBDENUM COFACTOR INSERTION CHAPERONE PAOD', 242113),
(328103, 'PTHR30388:SF6', NULL, NULL, NULL, NULL, 'XANTHINE DEHYDROGENASE SUBUNIT A-RELATED', 242113),
(328104, 'PTHR47123:SF19', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 242114),
(328105, 'PTHR47123:SF7', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 242114),
(328106, 'PTHR47123:SF6', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 242114),
(328107, 'PTHR47123:SF26', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 242114),
(328108, 'PTHR47123:SF9', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SKIP23-LIKE', 242114);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(328109, 'PTHR47123:SF15', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SKIP23', 242114),
(328110, 'PTHR47123:SF27', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 242114),
(328111, 'PTHR47123:SF16', NULL, NULL, NULL, NULL, 'BNAA04G28250D PROTEIN', 242114),
(328112, 'PTHR47123:SF8', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 242114),
(328113, 'PTHR47123:SF17', NULL, NULL, NULL, NULL, 'BNACNNG42230D PROTEIN', 242114),
(328114, 'PTHR47123:SF18', NULL, NULL, NULL, NULL, 'BNAC04G37150D PROTEIN', 242114),
(328115, 'PTHR47123', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SKIP23', 242114),
(328116, 'PTHR47123:SF3', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 242114),
(328117, 'PTHR47123:SF11', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SKIP23-LIKE', 242114),
(328118, 'PTHR47123:SF12', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 242114),
(328119, 'PTHR47123:SF13', NULL, NULL, NULL, NULL, 'BNAC07G24720D PROTEIN', 242114),
(328120, 'PTHR47123:SF24', NULL, NULL, NULL, NULL, 'LOW PROTEIN: F-BOX/KELCH-REPEAT PROTEIN', 242114),
(328121, 'PTHR47123:SF14', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 242114),
(328122, 'PTHR47123:SF25', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN', 242114),
(328123, 'PTHR47123:SF21', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 242114),
(328124, 'PTHR47123:SF10', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 242114),
(328125, 'PTHR37030', NULL, NULL, NULL, NULL, 'NUCLEOTIDYLTRANSFERASE', 242115),
(328126, 'PTHR37030:SF1', NULL, NULL, NULL, NULL, 'NUCLEOTIDYLTRANSFERASE', 242115),
(328127, 'PTHR37030:SF3', NULL, NULL, NULL, NULL, 'NTP_TRANSF_2 DOMAIN-CONTAINING PROTEIN', 242115),
(328128, 'PTHR21427:SF20', NULL, NULL, NULL, NULL, 'UBIQUINONE BIOSYNTHESIS PROTEIN', 242116),
(328129, 'PTHR21427:SF19', NULL, NULL, NULL, NULL, 'UBIQUINONE BIOSYNTHESIS PROTEIN COQ9, MITOCHONDRIAL', 242116),
(328130, 'PTHR21427', NULL, NULL, NULL, NULL, 'UBIQUINONE BIOSYNTHESIS PROTEIN COQ9, MITOCHONDRIAL', 242116),
(328131, 'PTHR21427:SF22', NULL, NULL, NULL, NULL, 'UBIQUINONE BIOSYNTHESIS PROTEIN', 242116),
(328132, 'PTHR21427:SF21', NULL, NULL, NULL, NULL, 'UBIQUINONE BIOSYNTHESIS PROTEIN', 242116),
(328133, 'PTHR23207', NULL, NULL, NULL, NULL, 'CORNEODESMOSIN', 242117),
(328134, 'PTHR23207:SF2', NULL, NULL, NULL, NULL, 'CORNEODESMOSIN', 242117),
(328135, 'PTHR34661:SF3', NULL, NULL, NULL, NULL, 'INCREASED DNA METHYLATION 2', 242118),
(328136, 'PTHR34661:SF8', NULL, NULL, NULL, NULL, 'ALPHA-CRYSTALLIN DOMAIN-CONTAINING PROTEIN 22.3', 242118),
(328137, 'PTHR34661:SF10', NULL, NULL, NULL, NULL, 'BNAC07G15100D PROTEIN', 242118),
(328138, 'PTHR34661', NULL, NULL, NULL, NULL, 'INCREASED DNA METHYLATION 3', 242118),
(328139, 'PTHR34661:SF11', NULL, NULL, NULL, NULL, 'ALPHA-CRYSTALLIN DOMAIN-CONTAINING PROTEIN 22.3-LIKE', 242118),
(328140, 'PTHR34661:SF1', NULL, NULL, NULL, NULL, 'INCREASED DNA METHYLATION 3', 242118),
(328141, 'PTHR34661:SF2', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 242118),
(328142, 'PTHR48169:SF1', NULL, NULL, NULL, NULL, 'ASTROCYTIC PHOSPHOPROTEIN PEA-15', 242119),
(328143, 'PTHR48169', NULL, NULL, NULL, NULL, 'DED DOMAIN-CONTAINING PROTEIN', 242119),
(328144, 'PTHR48169:SF3', NULL, NULL, NULL, NULL, 'CASP8 AND FADD-LIKE APOPTOSIS REGULATOR A-RELATED', 242119),
(328145, 'PTHR38430:SF1', NULL, NULL, NULL, NULL, 'PROTEIN-ARGININE KINASE ACTIVATOR PROTEIN', 242120),
(328146, 'PTHR38430', NULL, NULL, NULL, NULL, 'PROTEIN-ARGININE KINASE ACTIVATOR PROTEIN', 242120),
(328147, 'PTHR23411:SF32', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA CONSTANT 2', 242121),
(328148, 'PTHR23411:SF31', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY CONSTANT ALPHA 1-RELATED', 242121),
(328149, 'PTHR23411:SF41', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LIGHT 3 VARIABLE 5-RELATED', 242121),
(328150, 'PTHR23411:SF30', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY CONSTANT EPSILON', 242121),
(328151, 'PTHR23411:SF40', NULL, NULL, NULL, NULL, 'SI:CH211-180A12.2', 242121),
(328152, 'PTHR23411:SF36', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN KAPPA CONSTANT', 242121);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(328153, 'PTHR23411:SF25', NULL, NULL, NULL, NULL, 'IG DELTA CHAIN C REGION MEMBRANE-BOUND FORM-RELATED', 242121),
(328154, 'PTHR23411', NULL, NULL, NULL, NULL, 'TAPASIN', 242121),
(328155, 'PTHR23411:SF35', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY CONSTANT MU', 242121),
(328156, 'PTHR23411:SF34', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA CONSTANT 1', 242121),
(328157, 'PTHR23411:SF33', NULL, NULL, NULL, NULL, 'NOVEL PROTEIN SIMILAR TO TAPASIN (TPSN)-RELATED', 242121),
(328158, 'PTHR23411:SF22', NULL, NULL, NULL, NULL, 'TAPASIN', 242121),
(328159, 'PTHR23411:SF29', NULL, NULL, NULL, NULL, 'IG GAMMA-3 CHAIN C REGION', 242121),
(328160, 'PTHR23411:SF18', NULL, NULL, NULL, NULL, 'TAPASIN-RELATED PROTEIN', 242121),
(328161, 'PTHR23411:SF28', NULL, NULL, NULL, NULL, 'IG GAMMA-2A CHAIN C REGION SECRETED FORM-RELATED', 242121),
(328162, 'PTHR23411:SF39', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY CONSTANT GAMMA 1-RELATED', 242121),
(328163, 'PTHR23411:SF27', NULL, NULL, NULL, NULL, 'NATURAL CYTOTOXICITY TRIGGERING RECEPTOR 3 LIGAND 1', 242121),
(328164, 'PTHR23411:SF38', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 242121),
(328165, 'PTHR23411:SF37', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 242121),
(328166, 'PTHR23411:SF2', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE (SDR FAMILY) MEMBER 13B.1-RELATED', 242121),
(328167, 'PTHR14710:SF2', NULL, NULL, NULL, NULL, 'GEM-ASSOCIATED PROTEIN 6', 242122),
(328168, 'PTHR14710', NULL, NULL, NULL, NULL, 'GEM-ASSOCIATED PROTEIN 6', 242122),
(328169, 'PTHR22397', NULL, NULL, NULL, NULL, 'JUNCTIONAL SARCOPLASMIC RETICULUM PROTEIN 1', 242123),
(328170, 'PTHR22397:SF2', NULL, NULL, NULL, NULL, 'JUNCTIONAL SARCOPLASMIC RETICULUM PROTEIN 1', 242123),
(328171, 'PTHR35391:SF7', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242124),
(328172, 'PTHR35391', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', 242124),
(328173, 'PTHR35391:SF6', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242124),
(328174, 'PTHR35391:SF3', NULL, NULL, NULL, NULL, 'FINGER DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G04300)-RELATED', 242124),
(328175, 'PTHR35391:SF5', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 242124),
(328176, 'PTHR31557:SF0', NULL, NULL, NULL, NULL, '5C820-RELATED', 242125),
(328177, 'PTHR31557:SF1', NULL, NULL, NULL, NULL, 'PROTEIN UP-REGULATED IN DAF-2(GF)', 242125),
(328178, 'PTHR31557', NULL, NULL, NULL, NULL, '5C820-RELATED-RELATED', 242125),
(328179, 'PTHR31557:SF2', NULL, NULL, NULL, NULL, 'PUD1_2 DOMAIN-CONTAINING PROTEIN', 242125),
(328180, 'PTHR31557:SF3', NULL, NULL, NULL, NULL, 'PUD1_2 DOMAIN-CONTAINING PROTEIN', 242125),
(328181, 'PTHR23205', NULL, NULL, NULL, NULL, 'SPLICING FACTOR 3A SUBUNIT 2', 242126),
(328182, 'PTHR23205:SF0', NULL, NULL, NULL, NULL, 'SPLICING FACTOR 3A SUBUNIT 2', 242126),
(328183, 'PTHR46973:SF1', NULL, NULL, NULL, NULL, 'GRAM DOMAIN-CONTAINING PROTEIN 2A', 242127),
(328184, 'PTHR46973', NULL, NULL, NULL, NULL, 'GRAM DOMAIN-CONTAINING PROTEIN 2A', 242127),
(328185, 'PTHR11223:SF3', NULL, NULL, NULL, NULL, 'EXPORTIN-5', 242128),
(328186, 'PTHR11223:SF2', NULL, NULL, NULL, NULL, 'EXPORTIN-1', 242128),
(328187, 'PTHR11223:SF15', NULL, NULL, NULL, NULL, 'EXPORTIN 1 (CRM1 HOMOLOG, YEAST) B', 242128),
(328188, 'PTHR11223:SF16', NULL, NULL, NULL, NULL, 'EXPORTIN 1 (CRM1 HOMOLOG, YEAST) A', 242128),
(328189, 'PTHR11223:SF7', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242128),
(328190, 'PTHR11223:SF6', NULL, NULL, NULL, NULL, '', 242128),
(328191, 'PTHR11223:SF14', NULL, NULL, NULL, NULL, 'IMPORTIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 242128),
(328192, 'PTHR11223:SF11', NULL, NULL, NULL, NULL, 'OS11G0519500 PROTEIN', 242128),
(328193, 'PTHR11223:SF12', NULL, NULL, NULL, NULL, 'BNACNNG06240D PROTEIN', 242128),
(328194, 'PTHR11223:SF10', NULL, NULL, NULL, NULL, 'PROTEIN EXPORTIN 1B', 242128),
(328195, 'PTHR11223', NULL, NULL, NULL, NULL, 'EXPORTIN 1/5', 242128),
(328196, 'PTHR11223:SF9', NULL, NULL, NULL, NULL, 'IMPORTIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 242128);
INSERT INTO "PUBLIC"."MODEL" VALUES
(328197, 'PTHR46850', NULL, NULL, NULL, NULL, 'CHROMODOMAIN-HELICASE-DNA-BINDING PROTEIN 9', 242129),
(328198, 'PTHR46850:SF1', NULL, NULL, NULL, NULL, 'CHROMODOMAIN-HELICASE-DNA-BINDING PROTEIN 9', 242129),
(328199, 'PTHR33447:SF19', NULL, NULL, NULL, NULL, 'GLUTATHIONE GAMMA-GLUTAMYLCYSTEINYLTRANSFERASE', 242130),
(328200, 'PTHR33447', NULL, NULL, NULL, NULL, 'GLUTATHIONE GAMMA-GLUTAMYLCYSTEINYLTRANSFERASE', 242130),
(328201, 'PTHR33447:SF16', NULL, NULL, NULL, NULL, 'GLUTATHIONE GAMMA-GLUTAMYLCYSTEINYLTRANSFERASE 1', 242130),
(328202, 'PTHR33447:SF11', NULL, NULL, NULL, NULL, 'GLUTATHIONE GAMMA-GLUTAMYLCYSTEINYLTRANSFERASE', 242130),
(328203, 'PTHR33447:SF13', NULL, NULL, NULL, NULL, 'GLUTATHIONE GAMMA-GLUTAMYLCYSTEINYLTRANSFERASE', 242130),
(328204, 'PTHR33447:SF2', NULL, NULL, NULL, NULL, 'GLUTATHIONE GAMMA-GLUTAMYLCYSTEINYLTRANSFERASE', 242130),
(328205, 'PTHR33447:SF14', NULL, NULL, NULL, NULL, 'GLUTATHIONE GAMMA-GLUTAMYLCYSTEINYLTRANSFERASE', 242130),
(328206, 'PTHR33447:SF20', NULL, NULL, NULL, NULL, 'GLUTATHIONE GAMMA-GLUTAMYLCYSTEINYLTRANSFERASE', 242130),
(328207, 'PTHR33447:SF21', NULL, NULL, NULL, NULL, 'GLUTATHIONE GAMMA-GLUTAMYLCYSTEINYLTRANSFERASE', 242130),
(328208, 'PTHR37722:SF2', NULL, NULL, NULL, NULL, 'OS01G0167700 PROTEIN', 242131),
(328209, 'PTHR37722', NULL, NULL, NULL, NULL, 'OS01G0167700 PROTEIN', 242131),
(328210, 'PTHR46844:SF1', NULL, NULL, NULL, NULL, 'SLR5058 PROTEIN', 242132),
(328211, 'PTHR46844', NULL, NULL, NULL, NULL, 'SLR5058 PROTEIN', 242132),
(328212, 'PTHR36479:SF10', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 242133),
(328213, 'PTHR36479', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 242133),
(328214, 'PTHR36479:SF11', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 242133),
(328215, 'PTHR36479:SF12', NULL, NULL, NULL, NULL, '', 242133),
(328216, 'PTHR32018:SF40', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN ENDOLYASE', 242134),
(328217, 'PTHR32018:SF35', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN ENDOLYASE', 242134),
(328218, 'PTHR32018:SF13', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN ENDOLYASE', 242134),
(328219, 'PTHR32018:SF34', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN ENDOLYASE', 242134),
(328220, 'PTHR32018', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONATE LYASE FAMILY PROTEIN', 242134),
(328221, 'PTHR32018:SF36', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN ENDOLYASE', 242134),
(328222, 'PTHR32018:SF14', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN ENDOLYASE', 242134),
(328223, 'PTHR32018:SF52', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN ENDOLYASE', 242134),
(328224, 'PTHR32018:SF30', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN ENDOLYASE', 242134),
(328225, 'PTHR32018:SF11', NULL, NULL, NULL, NULL, '', 242134),
(328226, 'PTHR32018:SF32', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN ENDOLYASE', 242134),
(328227, 'PTHR32018:SF10', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN ENDOLYASE', 242134),
(328228, 'PTHR32018:SF17', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN ENDOLYASE', 242134),
(328229, 'PTHR32018:SF39', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN ENDOLYASE', 242134),
(328230, 'PTHR32018:SF16', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN ENDOLYASE', 242134),
(328231, 'PTHR32018:SF18', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN ENDOLYASE', 242134),
(328232, 'PTHR32018:SF2', NULL, NULL, NULL, NULL, 'OS11G0134100 PROTEIN', 242134),
(328233, 'PTHR32018:SF1', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN ENDOLYASE', 242134),
(328234, 'PTHR32018:SF51', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN ENDOLYASE', 242134),
(328235, 'PTHR32018:SF50', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN ENDOLYASE', 242134),
(328236, 'PTHR32018:SF24', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN ENDOLYASE', 242134),
(328237, 'PTHR32018:SF23', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONATE LYASE FAMILY PROTEIN', 242134),
(328238, 'PTHR32018:SF48', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONATE LYASE FAMILY PROTEIN', 242134),
(328239, 'PTHR32018:SF26', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN ENDOLYASE', 242134);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(328240, 'PTHR32018:SF25', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN ENDOLYASE', 242134),
(328241, 'PTHR32018:SF42', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN ENDOLYASE', 242134),
(328242, 'PTHR32018:SF20', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN ENDOLYASE', 242134),
(328243, 'PTHR32018:SF41', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN ENDOLYASE', 242134),
(328244, 'PTHR32018:SF22', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN ENDOLYASE', 242134),
(328245, 'PTHR32018:SF21', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN ENDOLYASE', 242134),
(328246, 'PTHR32018:SF6', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN ENDOLYASE', 242134),
(328247, 'PTHR32018:SF49', NULL, NULL, NULL, NULL, '', 242134),
(328248, 'PTHR32018:SF9', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONATE LYASE B', 242134),
(328249, 'PTHR32018:SF8', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN ENDOLYASE', 242134),
(328250, 'PTHR32018:SF29', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN ENDOLYASE', 242134),
(328251, 'PTHR34046:SF7', NULL, NULL, NULL, NULL, 'AVR9/CF-9 RAPIDLY ELICITED PROTEIN 75', 242135),
(328252, 'PTHR34046:SF16', NULL, NULL, NULL, NULL, '', 242135),
(328253, 'PTHR34046:SF15', NULL, NULL, NULL, NULL, 'BNACNNG28320D PROTEIN', 242135),
(328254, 'PTHR34046:SF24', NULL, NULL, NULL, NULL, '', 242135),
(328255, 'PTHR34046:SF13', NULL, NULL, NULL, NULL, 'OS02G0758200 PROTEIN', 242135),
(328256, 'PTHR34046:SF23', NULL, NULL, NULL, NULL, 'BNAA05G18280D PROTEIN', 242135),
(328257, 'PTHR34046:SF22', NULL, NULL, NULL, NULL, 'OS06G0218800 PROTEIN', 242135),
(328258, 'PTHR34046:SF11', NULL, NULL, NULL, NULL, 'BNAA09G30640D PROTEIN', 242135),
(328259, 'PTHR34046:SF10', NULL, NULL, NULL, NULL, '', 242135),
(328260, 'PTHR34046:SF21', NULL, NULL, NULL, NULL, 'BNAC02G43690D PROTEIN', 242135),
(328261, 'PTHR34046:SF19', NULL, NULL, NULL, NULL, 'AVR9/CF-9 RAPIDLY ELICITED PROTEIN 75', 242135),
(328262, 'PTHR34046:SF18', NULL, NULL, NULL, NULL, 'AVR9/CF-9 RAPIDLY ELICITED PROTEIN 75', 242135),
(328263, 'PTHR34046', NULL, NULL, NULL, NULL, 'OS06G0218800 PROTEIN', 242135),
(328264, 'PTHR13308:SF5', NULL, NULL, NULL, NULL, 'NEDD4-BINDING PROTEIN 2-LIKE 1', 242136),
(328265, 'PTHR13308', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 242136),
(328266, 'PTHR13308:SF23', NULL, NULL, NULL, NULL, 'NEDD4-BINDING PROTEIN 2-LIKE 2', 242136),
(328267, 'PTHR13308:SF40', NULL, NULL, NULL, NULL, 'SMR DOMAIN-CONTAINING PROTEIN', 242136),
(328268, 'PTHR30425', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORT SYSTEM PERMEASE PROTEIN PST', 242137),
(328269, 'PTHR30425:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORT SYSTEM PERMEASE PROTEIN PSTC', 242137),
(328270, 'PTHR30425:SF2', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN YQGH-RELATED', 242137),
(328271, 'PTHR38887', NULL, NULL, NULL, NULL, 'CHROMOSOME 21, WHOLE GENOME SHOTGUN SEQUENCE', 242138),
(328272, 'PTHR38887:SF1', NULL, NULL, NULL, NULL, 'RAS MODIFICATION PROTEIN ERF4', 242138),
(328273, 'PTHR37821:SF1', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER YUIF-RELATED', 242139),
(328274, 'PTHR37821', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER YUIF-RELATED', 242139),
(328275, 'PTHR37799:SF1', NULL, NULL, NULL, NULL, '37S RIBOSOMAL PROTEIN S25, MITOCHONDRIAL', 242140),
(328276, 'PTHR37799', NULL, NULL, NULL, NULL, '37S RIBOSOMAL PROTEIN S25, MITOCHONDRIAL', 242140),
(328277, 'PTHR37301', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN-RELATED', 242141),
(328278, 'PTHR37301:SF1', NULL, NULL, NULL, NULL, 'HTH CRO/C1-TYPE DOMAIN-CONTAINING PROTEIN', 242141),
(328279, 'PTHR46835:SF8', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR FAMILY PROTEIN, EXPRESSED', 242142),
(328280, 'PTHR46835', NULL, NULL, NULL, NULL, 'BASIC-LEUCINE ZIPPER (BZIP) TRANSCRIPTION FACTOR FAMILY PROTEIN-RELATED', 242142),
(328281, 'PTHR46835:SF9', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR RF2A', 242142),
(328282, 'PTHR46835:SF4', NULL, NULL, NULL, NULL, 'B-ZIP PROTEIN', 242142),
(328283, 'PTHR46835:SF3', NULL, NULL, NULL, NULL, 'BASIC-LEUCINE ZIPPER (BZIP) TRANSCRIPTION FACTOR FAMILY PROTEIN', 242142),
(328284, 'PTHR46835:SF6', NULL, NULL, NULL, NULL, 'BNAA09G14950D PROTEIN', 242142);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(328285, 'PTHR46835:SF2', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 242142),
(328286, 'PTHR24106:SF64', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-BINDING OLIGOMERIZATION DOMAIN-CONTAINING PROTEIN 2', 242143),
(328287, 'PTHR24106', NULL, NULL, NULL, NULL, 'NACHT, LRR AND CARD DOMAINS-CONTAINING', 242143),
(328288, 'PTHR24106:SF18', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-BINDING OLIGOMERIZATION DOMAIN-CONTAINING PROTEIN 1', 242143),
(328289, 'PTHR24106:SF109', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN', 242143),
(328290, 'PTHR24106:SF276', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT FAMILY PROTEIN', 242143),
(328291, 'PTHR24106:SF152', NULL, NULL, NULL, NULL, 'NLR FAMILY MEMBER X1', 242143),
(328292, 'PTHR24106:SF279', NULL, NULL, NULL, NULL, 'NACHT DOMAIN-CONTAINING PROTEIN', 242143),
(328293, 'PTHR24106:SF278', NULL, NULL, NULL, NULL, 'NLR FAMILY CARD DOMAIN-CONTAINING PROTEIN 3', 242143),
(328294, 'PTHR24106:SF283', NULL, NULL, NULL, NULL, 'NACHT DOMAIN-CONTAINING PROTEIN', 242143),
(328295, 'PTHR24106:SF151', NULL, NULL, NULL, NULL, 'B30.2/SPRY DOMAIN-CONTAINING PROTEIN-RELATED', 242143),
(328296, 'PTHR24106:SF282', NULL, NULL, NULL, NULL, '', 242143),
(328297, 'PTHR24106:SF281', NULL, NULL, NULL, NULL, 'PROTEIN NLRC5', 242143),
(328298, 'PTHR24106:SF280', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT FAMILY PROTEIN', 242143),
(328299, 'PTHR46780:SF21', NULL, NULL, NULL, NULL, 'DEAD (ASP-GLU-ALA-ASP) BOX POLYPEPTIDE 41-RELATED', 242144),
(328300, 'PTHR46780:SF20', NULL, NULL, NULL, NULL, 'PROTEIN EVA-1 HOMOLOG B', 242144),
(328301, 'PTHR46780:SF2', NULL, NULL, NULL, NULL, 'PROTEIN EVA-1 HOMOLOG A', 242144),
(328302, 'PTHR46780:SF4', NULL, NULL, NULL, NULL, 'PROTEIN EVA-1 HOMOLOG C', 242144),
(328303, 'PTHR46780', NULL, NULL, NULL, NULL, 'PROTEIN EVA-1', 242144),
(328304, 'PTHR46780:SF5', NULL, NULL, NULL, NULL, 'SI:CH73-335M24.2', 242144),
(328305, 'PTHR46780:SF18', NULL, NULL, NULL, NULL, '', 242144),
(328306, 'PTHR46780:SF9', NULL, NULL, NULL, NULL, 'PROTEIN EVA-1', 242144),
(328307, 'PTHR46780:SF19', NULL, NULL, NULL, NULL, 'MIP32738P1', 242144),
(328308, 'PTHR47720:SF5', NULL, NULL, NULL, NULL, 'MAJOR INTRINSIC PROTEIN, AQUAPORIN-LIKE PROTEIN-RELATED', 242145),
(328309, 'PTHR47720:SF1', NULL, NULL, NULL, NULL, 'AQUAPORIN SIP2-1-RELATED', 242145),
(328310, 'PTHR47720', NULL, NULL, NULL, NULL, 'AQUAPORIN SIP2-1-RELATED', 242145),
(328311, 'PTHR47720:SF4', NULL, NULL, NULL, NULL, 'BNAA09G36250D PROTEIN', 242145),
(328312, 'PTHR47720:SF3', NULL, NULL, NULL, NULL, 'BNAC03G54990D PROTEIN', 242145),
(328313, 'PTHR38774:SF1', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 242146),
(328314, 'PTHR38774', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 242146),
(328315, 'PTHR43302', NULL, NULL, NULL, NULL, 'TRANSPORTER ARSB-RELATED', 242147),
(328316, 'PTHR43302:SF13', NULL, NULL, NULL, NULL, 'SILICON EFFLUX TRANSPORTER LSI2', 242147),
(328317, 'PTHR43302:SF12', NULL, NULL, NULL, NULL, 'TRANSPORTER ARSB-RELATED', 242147),
(328318, 'PTHR43302:SF1', NULL, NULL, NULL, NULL, 'NA(+)/H(+) ANTIPORTER NHAB', 242147),
(328319, 'PTHR43302:SF3', NULL, NULL, NULL, NULL, 'OS10G0447900 PROTEIN', 242147),
(328320, 'PTHR43302:SF6', NULL, NULL, NULL, NULL, 'ARSENICAL PUMP MEMBRANE PROTEIN-RELATED', 242147),
(328321, 'PTHR43302:SF5', NULL, NULL, NULL, NULL, 'TRANSPORTER ARSB-RELATED', 242147),
(328322, 'PTHR43302:SF8', NULL, NULL, NULL, NULL, 'SILICON EFFLUX TRANSPORTER LSI3', 242147),
(328323, 'PTHR43302:SF7', NULL, NULL, NULL, NULL, 'OS03G0147400 PROTEIN', 242147),
(328324, 'PTHR43302:SF14', NULL, NULL, NULL, NULL, 'CITMHS DOMAIN-CONTAINING PROTEIN', 242147),
(328325, 'PTHR43302:SF9', NULL, NULL, NULL, NULL, 'TRANSPORTER ARSB-RELATED', 242147),
(328326, 'PTHR10267', NULL, NULL, NULL, NULL, 'DNA POLYMERASE SUBUNIT GAMMA-1', 242148),
(328327, 'PTHR10267:SF0', NULL, NULL, NULL, NULL, 'DNA POLYMERASE SUBUNIT GAMMA-1', 242148),
(328328, 'PTHR30029', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 242149),
(328329, 'PTHR30029:SF2', NULL, NULL, NULL, NULL, 'STAGE V SPORULATION PROTEIN R', 242149);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(328330, 'PTHR45975:SF2', NULL, NULL, NULL, NULL, 'NUCLEOSOME-REMODELING FACTOR SUBUNIT BPTF', 242150),
(328331, 'PTHR45975', NULL, NULL, NULL, NULL, 'NUCLEOSOME-REMODELING FACTOR SUBUNIT BPTF', 242150),
(328332, 'PTHR45843:SF1', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE-LIKE 4', 242151),
(328333, 'PTHR45843', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE-LIKE 4', 242151),
(328334, 'PTHR45843:SF2', NULL, NULL, NULL, NULL, 'PPIASE CYCLOPHILIN-TYPE DOMAIN-CONTAINING PROTEIN', 242151),
(328335, 'PTHR45843:SF4', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 242151),
(328336, 'PTHR42723:SF1', NULL, NULL, NULL, NULL, 'CHLOROPHYLL SYNTHASE, CHLOROPLASTIC', 242152),
(328337, 'PTHR42723:SF4', NULL, NULL, NULL, NULL, 'DIGERANYLGERANYLGLYCERYL PHOSPHATE SYNTHASE', 242152),
(328338, 'PTHR42723', NULL, NULL, NULL, NULL, 'CHLOROPHYLL SYNTHASE', 242152),
(328339, 'PTHR37616', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR 60-LIKE', 242153),
(328340, 'PTHR37616:SF2', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 242153),
(328341, 'PTHR37616:SF3', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR 17-LIKE', 242153),
(328342, 'PTHR37616:SF1', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR', 242153),
(328343, 'PTHR37616:SF5', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 242153),
(328344, 'PTHR21093:SF4', NULL, NULL, NULL, NULL, 'DIVERGENT PROTEIN KINASE DOMAIN 1A', 242154),
(328345, 'PTHR21093:SF6', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 242154),
(328346, 'PTHR21093:SF13', NULL, NULL, NULL, NULL, 'PIP49_N DOMAIN-CONTAINING PROTEIN', 242154),
(328347, 'PTHR21093:SF3', NULL, NULL, NULL, NULL, 'DIVERGENT PROTEIN KINASE DOMAIN 1B', 242154),
(328348, 'PTHR21093', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 242154),
(328349, 'PTHR21093:SF2', NULL, NULL, NULL, NULL, 'DIVERGENT PROTEIN KINASE DOMAIN 1C', 242154),
(328350, 'PTHR21093:SF8', NULL, NULL, NULL, NULL, 'DIVERGENT PROTEIN KINASE DOMAIN 1A', 242154),
(328351, 'PTHR33544:SF15', NULL, NULL, NULL, NULL, 'DDE TNP4 DOMAIN-CONTAINING PROTEIN', 242155),
(328352, 'PTHR33544:SF16', NULL, NULL, NULL, NULL, '', 242155),
(328353, 'PTHR33544:SF13', NULL, NULL, NULL, NULL, 'OS02G0733400 PROTEIN', 242155),
(328354, 'PTHR33544:SF14', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 242155),
(328355, 'PTHR33544:SF3', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L36', 242155),
(328356, 'PTHR33544', NULL, NULL, NULL, NULL, '', 242155),
(328357, 'PTHR33544:SF5', NULL, NULL, NULL, NULL, '', 242155),
(328358, 'PTHR34574:SF3', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF HAND FAMILY PROTEIN', 242156),
(328359, 'PTHR34574:SF2', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF-HAND FAMILY PROTEIN', 242156),
(328360, 'PTHR34574', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF-HAND FAMILY PROTEIN-RELATED', 242156),
(328361, 'PTHR34574:SF5', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF-HAND FAMILY PROTEIN', 242156),
(328362, 'PTHR34574:SF13', NULL, NULL, NULL, NULL, '', 242156),
(328363, 'PTHR34574:SF11', NULL, NULL, NULL, NULL, 'OS09G0483100 PROTEIN', 242156),
(328364, 'PTHR34574:SF7', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF-HAND FAMILY PROTEIN', 242156),
(328365, 'PTHR34574:SF12', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF HAND FAMILY PROTEIN', 242156),
(328366, 'PTHR34574:SF9', NULL, NULL, NULL, NULL, '', 242156),
(328367, 'PTHR34574:SF8', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF-HAND PROTEIN', 242156),
(328368, 'PTHR34574:SF10', NULL, NULL, NULL, NULL, 'OS09G0482800 PROTEIN', 242156),
(328369, 'PTHR36315:SF2', NULL, NULL, NULL, NULL, 'PHOTOSYNTHETIC NDH SUBUNIT OF SUBCOMPLEX B 4, CHLOROPLASTIC', 242157),
(328370, 'PTHR36315:SF3', NULL, NULL, NULL, NULL, 'BNAC08G49490D PROTEIN', 242157),
(328371, 'PTHR36315', NULL, NULL, NULL, NULL, 'PHOTOSYNTHETIC NDH SUBUNIT OF SUBCOMPLEX B 4, CHLOROPLASTIC', 242157),
(328372, 'PTHR47460:SF1', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE-LIKE PROTEIN ACR4', 242158),
(328373, 'PTHR47460', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE-LIKE PROTEIN ACR4', 242158);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(328374, 'PTHR47460:SF2', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE', 242158),
(328375, 'PTHR31386:SF2', NULL, NULL, NULL, NULL, 'SIMILAR TO RIKEN CDNA 2510039O18', 242159),
(328376, 'PTHR31386', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN KIAA2013', 242159),
(328377, 'PTHR17130', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL OUTER MEMBRANE PROTEIN 25', 242160),
(328378, 'PTHR17130:SF14', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY PROTEIN COX16 HOMOLOG, MITOCHONDRIAL', 242160),
(328379, 'PTHR11361:SF34', NULL, NULL, NULL, NULL, 'DNA MISMATCH REPAIR PROTEIN MSH1, MITOCHONDRIAL', 242161),
(328380, 'PTHR11361:SF139', NULL, NULL, NULL, NULL, 'REPAIR PROTEIN, PUTATIVE-RELATED', 242161),
(328381, 'PTHR11361:SF35', NULL, NULL, NULL, NULL, 'DNA MISMATCH REPAIR PROTEIN MSH2', 242161),
(328382, 'PTHR11361:SF21', NULL, NULL, NULL, NULL, 'MUTS PROTEIN HOMOLOG 4', 242161),
(328383, 'PTHR11361:SF149', NULL, NULL, NULL, NULL, 'REPAIR PROTEIN MSH8, PUTATIVE-RELATED', 242161),
(328384, 'PTHR11361:SF137', NULL, NULL, NULL, NULL, 'REPAIR PROTEIN MSH5, PUTATIVE-RELATED', 242161),
(328385, 'PTHR11361:SF99', NULL, NULL, NULL, NULL, 'DNA MISMATCH REPAIR PROTEIN-RELATED', 242161),
(328386, 'PTHR11361:SF148', NULL, NULL, NULL, NULL, 'DNA MISMATCH REPAIR PROTEIN MSH6', 242161),
(328387, 'PTHR11361:SF20', NULL, NULL, NULL, NULL, 'MUTS PROTEIN HOMOLOG 5', 242161),
(328388, 'PTHR11361:SF143', NULL, NULL, NULL, NULL, 'BNAA05G20450D PROTEIN', 242161),
(328389, 'PTHR11361:SF82', NULL, NULL, NULL, NULL, 'DNA MISMATCH REPAIR PROTEIN MSH1, MITOCHONDRIAL', 242161),
(328390, 'PTHR11361:SF90', NULL, NULL, NULL, NULL, 'DNA MISMATCH REPAIR PROTEIN', 242161),
(328391, 'PTHR11361:SF152', NULL, NULL, NULL, NULL, 'DNA MISMATCH REPAIR PROTEIN-RELATED', 242161),
(328392, 'PTHR11361:SF151', NULL, NULL, NULL, NULL, 'DNA MISMATCH REPAIR PROTEIN MUTS, TYPE 2', 242161),
(328393, 'PTHR11361:SF125', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN MUTS2', 242161),
(328394, 'PTHR11361:SF147', NULL, NULL, NULL, NULL, 'DNA MISMATCH REPAIR PROTEIN MSH3', 242161),
(328395, 'PTHR11361:SF146', NULL, NULL, NULL, NULL, 'DNA MISMATCH REPAIR PROTEIN', 242161),
(328396, 'PTHR11361:SF145', NULL, NULL, NULL, NULL, 'DNA_MISMATCH_REPAIR_2 DOMAIN-CONTAINING PROTEIN', 242161),
(328397, 'PTHR11361:SF144', NULL, NULL, NULL, NULL, 'MISMATCH REPAIR PROTEIN, PUTATIVE-RELATED', 242161),
(328398, 'PTHR11361:SF122', NULL, NULL, NULL, NULL, 'DNA MISMATCH REPAIR PROTEIN MSH3', 242161),
(328399, 'PTHR11361:SF150', NULL, NULL, NULL, NULL, 'DNA MISMATCH REPAIR PROTEIN MSH6', 242161),
(328400, 'PTHR11361', NULL, NULL, NULL, NULL, 'DNA MISMATCH REPAIR PROTEIN MUTS FAMILY MEMBER', 242161),
(328401, 'PTHR11361:SF14', NULL, NULL, NULL, NULL, 'DNA MISMATCH REPAIR PROTEIN MUTS, TYPE 2', 242161),
(328402, 'PTHR33789', NULL, NULL, NULL, NULL, 'LACHRYMATORY-FACTOR SYNTHASE', 242162),
(328403, 'PTHR33789:SF9', NULL, NULL, NULL, NULL, 'OS01G0199300 PROTEIN', 242162),
(328404, 'PTHR33789:SF11', NULL, NULL, NULL, NULL, 'OS05G0202300 PROTEIN', 242162),
(328405, 'PTHR33789:SF14', NULL, NULL, NULL, NULL, 'BNAANNG27450D PROTEIN', 242162),
(328406, 'PTHR33789:SF5', NULL, NULL, NULL, NULL, 'LACHRYMATORY-FACTOR SYNTHASE', 242162),
(328407, 'PTHR33789:SF15', NULL, NULL, NULL, NULL, 'LACHRYMATORY-FACTOR SYNTHASE-LIKE', 242162),
(328408, 'PTHR33789:SF13', NULL, NULL, NULL, NULL, '', 242162),
(328409, 'PTHR33789:SF3', NULL, NULL, NULL, NULL, 'POLYKETIDE CYCLASE/DEHYDRASE AND LIPID TRANSPORTER', 242162),
(328410, 'PTHR33789:SF2', NULL, NULL, NULL, NULL, 'OS12G0529500 PROTEIN', 242162),
(328411, 'PTHR33789:SF1', NULL, NULL, NULL, NULL, 'OS05G0201700 PROTEIN', 242162),
(328412, 'PTHR33789:SF16', NULL, NULL, NULL, NULL, 'OS01G0724700 PROTEIN', 242162),
(328413, 'PTHR31425:SF50', NULL, NULL, NULL, NULL, 'FT-INTERACTING PROTEIN 3-RELATED', 242163),
(328414, 'PTHR31425:SF52', NULL, NULL, NULL, NULL, 'C2 CALCIUM/LIPID-BINDING PLANT PHOSPHORIBOSYLTRANSFERASE FAMILY PROTEIN', 242163),
(328415, 'PTHR31425:SF30', NULL, NULL, NULL, NULL, 'ANTHRANILATE PHOSPHORIBOSYLTRANSFERASE-LIKE PROTEIN', 242163);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(328416, 'PTHR31425:SF51', NULL, NULL, NULL, NULL, 'C2 DOMAIN, PHOSPHORIBOSYLTRANSFERASE-RELATED', 242163),
(328417, 'PTHR31425', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLANTHRANILATE TRANSFERASE ISOFORM 1', 242163),
(328418, 'PTHR31425:SF29', NULL, NULL, NULL, NULL, 'C2 DOMAIN, PHOSPHORIBOSYLTRANSFERASE-RELATED', 242163),
(328419, 'PTHR31425:SF28', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 242163),
(328420, 'PTHR31425:SF25', NULL, NULL, NULL, NULL, '', 242163),
(328421, 'PTHR31425:SF47', NULL, NULL, NULL, NULL, 'BNAA09G39430D PROTEIN', 242163),
(328422, 'PTHR31425:SF24', NULL, NULL, NULL, NULL, 'C2 CALCIUM/LIPID-BINDING PLANT PHOSPHORIBOSYLTRANSFERASE FAMILY PROTEIN', 242163),
(328423, 'PTHR31425:SF46', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT LIPID-BINDING (CALB DOMAIN) FAMILY PROTEIN', 242163),
(328424, 'PTHR31425:SF49', NULL, NULL, NULL, NULL, 'PROTEIN QUIRKY-LIKE', 242163),
(328425, 'PTHR31425:SF27', NULL, NULL, NULL, NULL, 'OS04G0691800 PROTEIN', 242163),
(328426, 'PTHR31425:SF48', NULL, NULL, NULL, NULL, 'C2 CALCIUM/LIPID-BINDING PLANT PHOSPHORIBOSYLTRANSFERASE FAMILY PROTEIN', 242163),
(328427, 'PTHR31425:SF26', NULL, NULL, NULL, NULL, 'PROTEIN QUIRKY-LIKE', 242163),
(328428, 'PTHR31425:SF43', NULL, NULL, NULL, NULL, 'C2 CALCIUM/LIPID-BINDING PLANT PHOSPHORIBOSYLTRANSFERASE FAMILY PROTEIN', 242163),
(328429, 'PTHR31425:SF21', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT LIPID-BINDING (CALB DOMAIN) FAMILY PROTEIN', 242163),
(328430, 'PTHR31425:SF20', NULL, NULL, NULL, NULL, '', 242163),
(328431, 'PTHR31425:SF42', NULL, NULL, NULL, NULL, '', 242163),
(328432, 'PTHR31425:SF23', NULL, NULL, NULL, NULL, '', 242163),
(328433, 'PTHR31425:SF45', NULL, NULL, NULL, NULL, 'ANTHRANILATE PHOSPHORIBOSYLTRANSFERASE-LIKE PROTEIN-RELATED', 242163),
(328434, 'PTHR31425:SF22', NULL, NULL, NULL, NULL, 'C2 CALCIUM/LIPID-BINDING PLANT PHOSPHORIBOSYLTRANSFERASE FAMILY PROTEIN', 242163),
(328435, 'PTHR31425:SF44', NULL, NULL, NULL, NULL, 'ANTHRANILATE PHOSPHORIBOSYLTRANSFERASE-LIKE PROTEIN', 242163),
(328436, 'PTHR31425:SF41', NULL, NULL, NULL, NULL, 'ANTHRANILATE PHOSPHORIBOSYLTRANSFERASE-LIKE PROTEIN', 242163),
(328437, 'PTHR31425:SF40', NULL, NULL, NULL, NULL, 'PROTEIN QUIRKY-LIKE ISOFORM X1', 242163),
(328438, 'PTHR31425:SF39', NULL, NULL, NULL, NULL, 'PROTEIN QUIRKY-LIKE', 242163),
(328439, 'PTHR31425:SF19', NULL, NULL, NULL, NULL, 'OS04G0472900 PROTEIN', 242163),
(328440, 'PTHR31425:SF36', NULL, NULL, NULL, NULL, 'PROTEIN QUIRKY', 242163),
(328441, 'PTHR31425:SF6', NULL, NULL, NULL, NULL, 'OS02G0663900 PROTEIN', 242163),
(328442, 'PTHR31425:SF35', NULL, NULL, NULL, NULL, 'C2 CALCIUM/LIPID-BINDING PLANT PHOSPHORIBOSYLTRANSFERASE FAMILY PROTEIN', 242163),
(328443, 'PTHR31425:SF38', NULL, NULL, NULL, NULL, 'ANTHRANILATE PHOSPHORIBOSYLTRANSFERASE', 242163),
(328444, 'PTHR31425:SF37', NULL, NULL, NULL, NULL, 'FT-INTERACTING PROTEIN 1', 242163),
(328445, 'PTHR31425:SF32', NULL, NULL, NULL, NULL, 'C2 CALCIUM/LIPID-BINDING PLANT PHOSPHORIBOSYLTRANSFERASE FAMILY PROTEIN', 242163),
(328446, 'PTHR31425:SF53', NULL, NULL, NULL, NULL, 'PROTEIN QUIRKY-LIKE', 242163),
(328447, 'PTHR31425:SF31', NULL, NULL, NULL, NULL, 'ANTHRANILATE PHOSPHORIBOSYLTRANSFERASE-LIKE PROTEIN', 242163),
(328448, 'PTHR31425:SF34', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN-RELATED', 242163),
(328449, 'PTHR31425:SF12', NULL, NULL, NULL, NULL, 'C2 CALCIUM/LIPID-BINDING PLANT PHOSPHORIBOSYLTRANSFERASE FAMILY PROTEIN', 242163),
(328450, 'PTHR31425:SF33', NULL, NULL, NULL, NULL, '', 242163),
(328451, 'PTHR15577:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 318', 242164),
(328452, 'PTHR15577', NULL, NULL, NULL, NULL, 'ZINC FINGER CONTAINING PROTEIN', 242164),
(328453, 'PTHR43802', NULL, NULL, NULL, NULL, 'ENOYL-COA HYDRATASE', 242165),
(328454, 'PTHR43802:SF1', NULL, NULL, NULL, NULL, 'ZGC:101569', 242165),
(328455, 'PTHR10442:SF19', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S21', 242166),
(328456, 'PTHR10442:SF9', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S21', 242166),
(328457, 'PTHR10442:SF14', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S21', 242166);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(328458, 'PTHR10442', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S21', 242166),
(328459, 'PTHR10442:SF0', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S21', 242166),
(328460, 'PTHR10442:SF23', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S21', 242166),
(328461, 'PTHR10442:SF22', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S21', 242166),
(328462, 'PTHR10442:SF17', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S21', 242166),
(328463, 'PTHR10442:SF16', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S21', 242166),
(328464, 'PTHR10442:SF15', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S21', 242166),
(328465, 'PTHR21084', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 242167),
(328466, 'PTHR21084:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 3 OPEN READING FRAME 38', 242167),
(328467, 'PTHR31185:SF0', NULL, NULL, NULL, NULL, 'FIN BUD INITIATION FACTOR HOMOLOG', 242168),
(328468, 'PTHR31185', NULL, NULL, NULL, NULL, 'FIN BUD INITIATION FACTOR FIBIN', 242168),
(328469, 'PTHR30433', NULL, NULL, NULL, NULL, 'CHEMOTAXIS PROTEIN MOTA', 242169),
(328470, 'PTHR30433:SF4', NULL, NULL, NULL, NULL, 'MOTILITY PROTEIN A', 242169),
(328471, 'PTHR30433:SF2', NULL, NULL, NULL, NULL, 'MOTILITY PROTEIN A', 242169),
(328472, 'PTHR30433:SF3', NULL, NULL, NULL, NULL, 'MOTILITY PROTEIN A', 242169),
(328473, 'PTHR15887:SF3', NULL, NULL, NULL, NULL, '', 242170),
(328474, 'PTHR15887:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 69', 242170),
(328475, 'PTHR15887:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 69', 242170),
(328476, 'PTHR15887', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 69', 242170),
(328477, 'PTHR42703', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE', 242171),
(328478, 'PTHR42703:SF1', NULL, NULL, NULL, NULL, 'NA(+)/H(+) ANTIPORTER SUBUNIT D1', 242171),
(328479, 'PTHR15571', NULL, NULL, NULL, NULL, 'GEM-ASSOCIATED PROTEIN 4', 242172),
(328480, 'PTHR15571:SF2', NULL, NULL, NULL, NULL, 'GEM-ASSOCIATED PROTEIN 4', 242172),
(328481, 'PTHR47762:SF2', NULL, NULL, NULL, NULL, 'OS04G0640800 PROTEIN', 242173),
(328482, 'PTHR47762', NULL, NULL, NULL, NULL, 'OSJNBB0079B02.4 PROTEIN', 242173),
(328483, 'PTHR37756:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 242174),
(328484, 'PTHR37756', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 242174),
(328485, 'PTHR46940:SF1', NULL, NULL, NULL, NULL, 'NKAP DOMAIN-CONTAINING 1', 242175),
(328486, 'PTHR46940', NULL, NULL, NULL, NULL, 'NKAP DOMAIN-CONTAINING 1', 242175),
(328487, 'PTHR34803:SF4', NULL, NULL, NULL, NULL, 'PSI SUBUNIT V', 242176),
(328488, 'PTHR34803:SF2', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I REACTION CENTER SUBUNIT XI, CHLOROPLASTIC', 242176),
(328489, 'PTHR34803', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I REACTION CENTER SUBUNIT XI, CHLOROPLASTIC', 242176),
(328490, 'PTHR34803:SF5', NULL, NULL, NULL, NULL, 'PSI SUBUNIT V', 242176),
(328491, 'PTHR31352:SF3', NULL, NULL, NULL, NULL, 'INACTIVE BETA-AMYLASE 9', 242177),
(328492, 'PTHR31352:SF1', NULL, NULL, NULL, NULL, 'BETA-AMYLASE 3, CHLOROPLASTIC', 242177),
(328493, 'PTHR31352:SF8', NULL, NULL, NULL, NULL, 'BETA-AMYLASE 8', 242177),
(328494, 'PTHR31352:SF51', NULL, NULL, NULL, NULL, 'BETA-AMYLASE 7', 242177),
(328495, 'PTHR31352:SF40', NULL, NULL, NULL, NULL, 'BETA-AMYLASE 6', 242177),
(328496, 'PTHR31352:SF7', NULL, NULL, NULL, NULL, 'BETA-AMYLASE', 242177),
(328497, 'PTHR31352:SF41', NULL, NULL, NULL, NULL, 'BETA-AMYLASE', 242177),
(328498, 'PTHR31352:SF42', NULL, NULL, NULL, NULL, 'BETA-AMYLASE', 242177),
(328499, 'PTHR31352:SF31', NULL, NULL, NULL, NULL, 'BETA-AMYLASE 1, CHLOROPLASTIC', 242177),
(328500, 'PTHR31352:SF32', NULL, NULL, NULL, NULL, 'BETA-AMYLASE', 242177),
(328501, 'PTHR31352:SF54', NULL, NULL, NULL, NULL, 'BETA-AMYLASE 2, CHLOROPLASTIC', 242177),
(328502, 'PTHR31352:SF55', NULL, NULL, NULL, NULL, 'BETA-AMYLASE 5', 242177),
(328503, 'PTHR31352:SF56', NULL, NULL, NULL, NULL, 'BETA-AMYLASE', 242177),
(328504, 'PTHR31352:SF35', NULL, NULL, NULL, NULL, 'BETA-AMYLASE', 242177),
(328505, 'PTHR31352:SF46', NULL, NULL, NULL, NULL, 'BETA-AMYLASE', 242177),
(328506, 'PTHR31352:SF47', NULL, NULL, NULL, NULL, 'BETA-AMYLASE 2, CHLOROPLASTIC', 242177);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(328507, 'PTHR31352', NULL, NULL, NULL, NULL, 'BETA-AMYLASE 1, CHLOROPLASTIC', 242177),
(328508, 'PTHR31352:SF48', NULL, NULL, NULL, NULL, 'BETA-AMYLASE', 242177),
(328509, 'PTHR31352:SF37', NULL, NULL, NULL, NULL, 'INACTIVE BETA-AMYLASE 4, CHLOROPLASTIC', 242177),
(328510, 'PTHR31352:SF49', NULL, NULL, NULL, NULL, 'BETA-AMYLASE', 242177),
(328511, 'PTHR31352:SF39', NULL, NULL, NULL, NULL, 'BETA-AMYLASE', 242177),
(328512, 'PTHR38499:SF1', NULL, NULL, NULL, NULL, 'ADIPOGENIN', 242178),
(328513, 'PTHR38499', NULL, NULL, NULL, NULL, 'ADIPOGENIN', 242178),
(328514, 'PTHR43428', NULL, NULL, NULL, NULL, 'ARSENATE REDUCTASE', 242179),
(328515, 'PTHR43428:SF1', NULL, NULL, NULL, NULL, 'ARSENATE REDUCTASE', 242179),
(328516, 'PTHR30442:SF0', NULL, NULL, NULL, NULL, 'FE(3+) DICITRATE TRANSPORT PROTEIN FECA', 242180),
(328517, 'PTHR30442', NULL, NULL, NULL, NULL, 'IRON III  DICITRATE TRANSPORT PROTEIN FECA', 242180),
(328518, 'PTHR14469', NULL, NULL, NULL, NULL, 'SARCOMA ANTIGEN NY-SAR-23', 242181),
(328519, 'PTHR14469:SF1', NULL, NULL, NULL, NULL, 'PC-ESTERASE DOMAIN-CONTAINING PROTEIN 1B', 242181),
(328520, 'PTHR14469:SF0', NULL, NULL, NULL, NULL, 'FAMILY WITH SEQUENCE SIMILARITY 113', 242181),
(328521, 'PTHR14469:SF4', NULL, NULL, NULL, NULL, 'SIMILAR TO CHROMOSOME 20 OPEN READING FRAME 81', 242181),
(328522, 'PTHR14469:SF3', NULL, NULL, NULL, NULL, 'PC-ESTERASE DOMAIN-CONTAINING PROTEIN 1A', 242181),
(328523, 'PTHR31252:SF12', NULL, NULL, NULL, NULL, '', 242182),
(328524, 'PTHR31252:SF11', NULL, NULL, NULL, NULL, '', 242182),
(328525, 'PTHR31252', NULL, NULL, NULL, NULL, '', 242182),
(328526, 'PTHR31252:SF4', NULL, NULL, NULL, NULL, '', 242182),
(328527, 'PTHR45820:SF1', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER 1', 242183),
(328528, 'PTHR45820:SF2', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER 63C, ISOFORM F', 242183),
(328529, 'PTHR45820:SF3', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER 10', 242183),
(328530, 'PTHR45820:SF4', NULL, NULL, NULL, NULL, 'FI23527P1', 242183),
(328531, 'PTHR45820:SF5', NULL, NULL, NULL, NULL, 'DIFFUSION FACILITATOR FAMILY METAL ION TRANSPORTER, PUTATIVE-RELATED', 242183),
(328532, 'PTHR45820:SF6', NULL, NULL, NULL, NULL, '', 242183),
(328533, 'PTHR45820:SF7', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER PROTEIN DDB_G0282067-RELATED', 242183),
(328534, 'PTHR45820', NULL, NULL, NULL, NULL, 'FI23527P1', 242183),
(328535, 'PTHR24029:SF0', NULL, NULL, NULL, NULL, 'UVRABC SYSTEM PROTEIN B', 242184),
(328536, 'PTHR24029', NULL, NULL, NULL, NULL, 'UVRABC SYSTEM PROTEIN B', 242184),
(328537, 'PTHR10133:SF27', NULL, NULL, NULL, NULL, 'DNA POLYMERASE NU', 242185),
(328538, 'PTHR10133:SF26', NULL, NULL, NULL, NULL, 'DNA-DIRECTED DNA POLYMERASE', 242185),
(328539, 'PTHR10133:SF23', NULL, NULL, NULL, NULL, 'DNA-DIRECTED DNA POLYMERASE', 242185),
(328540, 'PTHR10133:SF53', NULL, NULL, NULL, NULL, 'DNA POLYMERASE I A, CHLOROPLASTIC/MITOCHONDRIAL', 242185),
(328541, 'PTHR10133', NULL, NULL, NULL, NULL, 'DNA POLYMERASE I', 242185),
(328542, 'PTHR10133:SF40', NULL, NULL, NULL, NULL, 'DNA POLYMERASE I PROTEIN B, PUTATIVE-RELATED', 242185),
(328543, 'PTHR10133:SF62', NULL, NULL, NULL, NULL, 'DNA POLYMERASE THETA', 242185),
(328544, 'PTHR10133:SF61', NULL, NULL, NULL, NULL, 'UBIQUITIN CARRIER PROTEIN 7', 242185),
(328545, 'PTHR44444:SF1', NULL, NULL, NULL, NULL, 'PROTEIN SEL-1 HOMOLOG 3', 242186),
(328546, 'PTHR44444:SF4', NULL, NULL, NULL, NULL, 'SI:DKEY-24P1.6', 242186),
(328547, 'PTHR44444', NULL, NULL, NULL, NULL, 'PROTEIN SEL-1 HOMOLOG 3', 242186),
(328548, 'PTHR44444:SF5', NULL, NULL, NULL, NULL, 'SEL1L FAMILY MEMBER 3', 242186),
(328549, 'PTHR10306', NULL, NULL, NULL, NULL, 'SYNAPTOPHYSIN', 242187),
(328550, 'PTHR10306:SF29', NULL, NULL, NULL, NULL, 'SYNAPTOPHYSIN-LIKE 2A', 242187),
(328551, 'PTHR10306:SF8', NULL, NULL, NULL, NULL, 'SYNAPTOPHYSIN-LIKE PROTEIN 2', 242187),
(328552, 'PTHR10306:SF9', NULL, NULL, NULL, NULL, 'SYNAPTOPHYSIN-LIKE PROTEIN 1', 242187),
(328553, 'PTHR10306:SF17', NULL, NULL, NULL, NULL, 'MARVEL DOMAIN-CONTAINING PROTEIN', 242187),
(328554, 'PTHR10306:SF16', NULL, NULL, NULL, NULL, 'SYNAPTOPORIN', 242187); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(328555, 'PTHR10306:SF33', NULL, NULL, NULL, NULL, 'SYNAPTOPHYSIN-LIKE 1', 242187),
(328556, 'PTHR10306:SF10', NULL, NULL, NULL, NULL, 'SYNAPTOPHYSIN', 242187),
(328557, 'PTHR10306:SF32', NULL, NULL, NULL, NULL, 'SYNAPTOPHYSIN', 242187),
(328558, 'PTHR10306:SF34', NULL, NULL, NULL, NULL, 'NOVEL PROTEIN CONTAINING A MEMBRANE-ASSOCIATING DOMAIN (WU:FC22A07)', 242187),
(328559, 'PTHR37827', NULL, NULL, NULL, NULL, 'TUDOR DOMAIN-CONTAINING PROTEIN', 242188),
(328560, 'PTHR37827:SF1', NULL, NULL, NULL, NULL, 'TUDOR DOMAIN-CONTAINING PROTEIN', 242188),
(328561, 'PTHR47000:SF8', NULL, NULL, NULL, NULL, 'SUEL-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 242189),
(328562, 'PTHR47000', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN', 242189),
(328563, 'PTHR47000:SF7', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN', 242189),
(328564, 'PTHR47000:SF5', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN', 242189),
(328565, 'PTHR47000:SF10', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 242189),
(328566, 'PTHR47000:SF3', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN', 242189),
(328567, 'PTHR47000:SF1', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN', 242189),
(328568, 'PTHR46626:SF6', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 242190),
(328569, 'PTHR46626:SF3', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 242190),
(328570, 'PTHR46626:SF4', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 242190),
(328571, 'PTHR46626', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN B17', 242190),
(328572, 'PTHR46626:SF7', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 242190),
(328573, 'PTHR46626:SF8', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN B18', 242190),
(328574, 'PTHR46626:SF1', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN B21', 242190),
(328575, 'PTHR46626:SF2', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN B17', 242190),
(328576, 'PTHR36195:SF4', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G01990)-RELATED', 242191),
(328577, 'PTHR36195:SF7', NULL, NULL, NULL, NULL, 'SECRETED THAUMATIN-LIKE PROTEIN CETA', 242191),
(328578, 'PTHR36195:SF5', NULL, NULL, NULL, NULL, 'BYS1 FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_2G04533)', 242191),
(328579, 'PTHR36195:SF6', NULL, NULL, NULL, NULL, 'SECRETED THAUMATIN-LIKE PROTEIN CALA', 242191),
(328580, 'PTHR36195', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G01990)-RELATED-RELATED', 242191),
(328581, 'PTHR13460:SF0', NULL, NULL, NULL, NULL, 'MALECTIN', 242192),
(328582, 'PTHR13460', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 242192),
(328583, 'PTHR11886:SF69', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328584, 'PTHR11886:SF49', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328585, 'PTHR11886:SF2', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328586, 'PTHR11886:SF40', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328587, 'PTHR11886:SF110', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328588, 'PTHR11886:SF86', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328589, 'PTHR11886:SF85', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328590, 'PTHR11886:SF88', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328591, 'PTHR11886:SF87', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328592, 'PTHR11886:SF111', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328593, 'PTHR11886:SF112', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328594, 'PTHR11886:SF91', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN 1, CYTOPLASMIC', 242193),
(328595, 'PTHR11886:SF90', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328596, 'PTHR11886:SF93', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328597, 'PTHR11886:SF71', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328598, 'PTHR11886:SF70', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193);
INSERT INTO "PUBLIC"."MODEL" VALUES
(328599, 'PTHR11886:SF92', NULL, NULL, NULL, NULL, 'AXONEMAL DYNEIN LIGHT CHAIN', 242193),
(328600, 'PTHR11886:SF37', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN TYPE 1 FAMILY PROTEIN', 242193),
(328601, 'PTHR11886:SF36', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328602, 'PTHR11886:SF39', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328603, 'PTHR11886:SF38', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328604, 'PTHR11886:SF95', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328605, 'PTHR11886:SF72', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328606, 'PTHR11886:SF94', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328607, 'PTHR11886:SF97', NULL, NULL, NULL, NULL, 'OS02G0580400 PROTEIN', 242193),
(328608, 'PTHR11886:SF75', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328609, 'PTHR11886:SF96', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328610, 'PTHR11886:SF55', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN 2, CYTOPLASMIC-RELATED', 242193),
(328611, 'PTHR11886:SF77', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328612, 'PTHR11886:SF103', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328613, 'PTHR11886:SF35', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN 2, CYTOPLASMIC', 242193),
(328614, 'PTHR11886:SF78', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328615, 'PTHR11886:SF56', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328616, 'PTHR11886:SF106', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328617, 'PTHR11886:SF107', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328618, 'PTHR11886:SF104', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL LIGHT CHAIN 4', 242193),
(328619, 'PTHR11886:SF105', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328620, 'PTHR11886:SF80', NULL, NULL, NULL, NULL, 'OS01G0555600 PROTEIN', 242193),
(328621, 'PTHR11886', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328622, 'PTHR11886:SF108', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328623, 'PTHR11886:SF60', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328624, 'PTHR11886:SF109', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 242193),
(328625, 'PTHR47369:SF2', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN 2', 242194),
(328626, 'PTHR47369:SF1', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN', 242194),
(328627, 'PTHR47369', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN', 242194),
(328628, 'PTHR38378:SF3', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN-LIKE PROTEIN', 242195),
(328629, 'PTHR38378:SF2', NULL, NULL, NULL, NULL, '', 242195),
(328630, 'PTHR38378', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN-LIKE PROTEIN', 242195),
(328631, 'PTHR23510:SF18', NULL, NULL, NULL, NULL, 'PROTEIN CBG19164', 242196),
(328632, 'PTHR23510:SF17', NULL, NULL, NULL, NULL, 'PROTEIN CBG11509', 242196),
(328633, 'PTHR23510:SF16', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 242196),
(328634, 'PTHR23510:SF15', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 242196),
(328635, 'PTHR23510:SF58', NULL, NULL, NULL, NULL, 'SI:CH211-38M6.6', 242196),
(328636, 'PTHR23510:SF14', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 242196),
(328637, 'PTHR23510:SF56', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 242196),
(328638, 'PTHR23510:SF12', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 242196),
(328639, 'PTHR23510:SF78', NULL, NULL, NULL, NULL, 'SPX DOMAIN-CONTAINING MEMBRANE PROTEIN OS06G0129400', 242196),
(328640, 'PTHR23510:SF11', NULL, NULL, NULL, NULL, 'PROTEIN CBG08609', 242196),
(328641, 'PTHR23510:SF77', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS SX', 242196),
(328642, 'PTHR23510:SF76', NULL, NULL, NULL, NULL, 'MEMBRANE TRANSPORTER', 242196),
(328643, 'PTHR23510:SF75', NULL, NULL, NULL, NULL, 'SPX DOMAIN-CONTAINING PROTEIN', 242196),
(328644, 'PTHR23510:SF74', NULL, NULL, NULL, NULL, 'SPX DOMAIN-CONTAINING PROTEIN', 242196),
(328645, 'PTHR23510:SF73', NULL, NULL, NULL, NULL, 'PROTEIN CBG20861', 242196);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(328646, 'PTHR23510:SF72', NULL, NULL, NULL, NULL, 'SPX DOMAIN-CONTAINING MEMBRANE PROTEIN OS04G0573000', 242196),
(328647, 'PTHR23510:SF71', NULL, NULL, NULL, NULL, 'SPX DOMAIN-CONTAINING PROTEIN', 242196),
(328648, 'PTHR23510:SF70', NULL, NULL, NULL, NULL, 'SPX DOMAIN-CONTAINING PROTEIN', 242196),
(328649, 'PTHR23510:SF28', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 242196),
(328650, 'PTHR23510:SF27', NULL, NULL, NULL, NULL, 'PROTEIN CBG19165', 242196),
(328651, 'PTHR23510:SF25', NULL, NULL, NULL, NULL, 'PROTEIN CBG06591', 242196),
(328652, 'PTHR23510:SF68', NULL, NULL, NULL, NULL, 'SPX DOMAIN-CONTAINING PROTEIN', 242196),
(328653, 'PTHR23510:SF23', NULL, NULL, NULL, NULL, 'SPX DOMAIN-CONTAINING MEMBRANE PROTEIN OS02G45520', 242196),
(328654, 'PTHR23510:SF67', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 242196),
(328655, 'PTHR23510:SF9', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 242196),
(328656, 'PTHR23510:SF22', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 242196),
(328657, 'PTHR23510:SF21', NULL, NULL, NULL, NULL, 'SPX DOMAIN-CONTAINING PROTEIN', 242196),
(328658, 'PTHR23510:SF65', NULL, NULL, NULL, NULL, 'SPX DOMAIN-CONTAINING MEMBRANE PROTEIN OS09G0521800', 242196),
(328659, 'PTHR23510:SF20', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 242196),
(328660, 'PTHR23510', NULL, NULL, NULL, NULL, 'INNER MEMBRANE TRANSPORT PROTEIN YAJR', 242196),
(328661, 'PTHR23510:SF64', NULL, NULL, NULL, NULL, 'INNER MEMBRANE TRANSPORT PROTEIN YAJR', 242196),
(328662, 'PTHR23510:SF62', NULL, NULL, NULL, NULL, 'SPX DOMAIN-CONTAINING PROTEIN', 242196),
(328663, 'PTHR23510:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG03421', 242196),
(328664, 'PTHR23510:SF2', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 242196),
(328665, 'PTHR23510:SF3', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY DOMAIN-CONTAINING PROTEIN 8', 242196),
(328666, 'PTHR21521', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 242197),
(328667, 'PTHR21521:SF0', NULL, NULL, NULL, NULL, 'ZGC:112496', 242197),
(328668, 'PTHR30189:SF1', NULL, NULL, NULL, NULL, 'LPS-ASSEMBLY PROTEIN LPTD', 242198),
(328669, 'PTHR30189', NULL, NULL, NULL, NULL, 'LPS-ASSEMBLY PROTEIN', 242198),
(328670, 'PTHR15044', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE FF', 242199),
(328671, 'PTHR15044:SF0', NULL, NULL, NULL, NULL, 'PRO-FMRFAMIDE-RELATED NEUROPEPTIDE FF', 242199),
(328672, 'PTHR32121:SF0', NULL, NULL, NULL, NULL, 'PCNA-INTERACTING PARTNER', 242200),
(328673, 'PTHR32121', NULL, NULL, NULL, NULL, 'PCNA-INTERACTING PARTNER', 242200),
(328674, 'PTHR31569:SF0', NULL, NULL, NULL, NULL, 'ZINC FINGER SWIM DOMAIN-CONTAINING PROTEIN 1', 242201),
(328675, 'PTHR31569', NULL, NULL, NULL, NULL, 'SWIM-TYPE DOMAIN-CONTAINING PROTEIN', 242201),
(328676, 'PTHR31569:SF4', NULL, NULL, NULL, NULL, 'MULE DOMAIN-CONTAINING PROTEIN', 242201),
(328677, 'PTHR31569:SF3', NULL, NULL, NULL, NULL, 'ZINC FINGER SWIM DOMAIN-CONTAINING PROTEIN 3', 242201),
(328678, 'PTHR45730:SF120', NULL, NULL, NULL, NULL, 'DROUGHT AND SALT TOLERANCE PROTEIN', 242202),
(328679, 'PTHR45730:SF90', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242202),
(328680, 'PTHR45730:SF128', NULL, NULL, NULL, NULL, 'C2H2 AND C2HC ZINC FINGERS SUPERFAMILY PROTEIN-RELATED', 242202),
(328681, 'PTHR45730:SF127', NULL, NULL, NULL, NULL, 'PROTEIN LATE FLOWERING', 242202),
(328682, 'PTHR45730:SF126', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242202),
(328683, 'PTHR45730:SF125', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242202),
(328684, 'PTHR45730:SF124', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242202),
(328685, 'PTHR45730', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN JAGGED', 242202),
(328686, 'PTHR45730:SF123', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242202),
(328687, 'PTHR45730:SF122', NULL, NULL, NULL, NULL, 'C2H2 AND C2HC ZINC FINGERS SUPERFAMILY PROTEIN', 242202),
(328688, 'PTHR45730:SF121', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 2', 242202),
(328689, 'PTHR45730:SF88', NULL, NULL, NULL, NULL, 'PROTEIN LATE FLOWERING-LIKE', 242202);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(328690, 'PTHR45730:SF82', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242202),
(328691, 'PTHR45730:SF81', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242202),
(328692, 'PTHR45730:SF84', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 4-LIKE ISOFORM X1', 242202),
(328693, 'PTHR45730:SF117', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 242202),
(328694, 'PTHR45730:SF116', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242202),
(328695, 'PTHR45730:SF115', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 242202),
(328696, 'PTHR45730:SF114', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242202),
(328697, 'PTHR45730:SF113', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242202),
(328698, 'PTHR45730:SF112', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242202),
(328699, 'PTHR45730:SF111', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242202),
(328700, 'PTHR45730:SF110', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN JAGGED-LIKE', 242202),
(328701, 'PTHR45730:SF13', NULL, NULL, NULL, NULL, 'OS09G0431900 PROTEIN', 242202),
(328702, 'PTHR45730:SF99', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242202),
(328703, 'PTHR45730:SF119', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242202),
(328704, 'PTHR45730:SF59', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 1', 242202),
(328705, 'PTHR45730:SF118', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242202),
(328706, 'PTHR45730:SF50', NULL, NULL, NULL, NULL, 'OS12G0617000 PROTEIN', 242202),
(328707, 'PTHR45730:SF94', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 4', 242202),
(328708, 'PTHR45730:SF53', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242202),
(328709, 'PTHR45730:SF54', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242202),
(328710, 'PTHR45730:SF51', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242202),
(328711, 'PTHR45730:SF96', NULL, NULL, NULL, NULL, 'OS02G0182300 PROTEIN', 242202),
(328712, 'PTHR45730:SF106', NULL, NULL, NULL, NULL, 'PROTEIN LATE FLOWERING-RELATED', 242202),
(328713, 'PTHR45730:SF104', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 7', 242202),
(328714, 'PTHR45730:SF101', NULL, NULL, NULL, NULL, 'OS07G0153600 PROTEIN', 242202),
(328715, 'PTHR45730:SF68', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242202),
(328716, 'PTHR45730:SF25', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242202),
(328717, 'PTHR45730:SF22', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242202),
(328718, 'PTHR45730:SF66', NULL, NULL, NULL, NULL, 'ZINC FINGER, C2H2-RELATED', 242202),
(328719, 'PTHR45730:SF109', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN KNUCKLES', 242202),
(328720, 'PTHR45730:SF108', NULL, NULL, NULL, NULL, 'C2H2 ZINC FINGER MALFORMED SPIKELET', 242202),
(328721, 'PTHR45730:SF107', NULL, NULL, NULL, NULL, 'C2H2 AND C2HC ZINC FINGERS SUPERFAMILY PROTEIN', 242202),
(328722, 'PTHR45730:SF61', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242202),
(328723, 'PTHR45730:SF63', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242202),
(328724, 'PTHR45730:SF9', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 2', 242202),
(328725, 'PTHR45730:SF8', NULL, NULL, NULL, NULL, 'C2H2-TYPE ZINC FINGER PROTEIN', 242202),
(328726, 'PTHR45730:SF79', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242202),
(328727, 'PTHR45730:SF35', NULL, NULL, NULL, NULL, 'PROSTRATE GROWTH 1', 242202),
(328728, 'PTHR45730:SF36', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242202),
(328729, 'PTHR45730:SF34', NULL, NULL, NULL, NULL, 'C2H2 AND C2HC ZINC FINGERS SUPERFAMILY PROTEIN', 242202),
(328730, 'PTHR45730:SF78', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 2', 242202),
(328731, 'PTHR45730:SF6', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 7', 242202),
(328732, 'PTHR45730:SF75', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 4-LIKE', 242202);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(328733, 'PTHR45730:SF32', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN JAGGED', 242202),
(328734, 'PTHR36013', NULL, NULL, NULL, NULL, 'ATP SYNTHASE 24 KDA SUBUNIT, MITOCHONDRIAL-RELATED', 242203),
(328735, 'PTHR36013:SF2', NULL, NULL, NULL, NULL, 'ATP SYNTHASE 24 KDA SUBUNIT, MITOCHONDRIAL-RELATED', 242203),
(328736, 'PTHR28589:SF1', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S34, MITOCHONDRIAL', 242204),
(328737, 'PTHR28589', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S34, MITOCHONDRIAL', 242204),
(328738, 'PTHR33361:SF2', NULL, NULL, NULL, NULL, 'GLR0591 PROTEIN', 242205),
(328739, 'PTHR33361:SF16', NULL, NULL, NULL, NULL, '', 242205),
(328740, 'PTHR33361:SF14', NULL, NULL, NULL, NULL, '', 242205),
(328741, 'PTHR33361', NULL, NULL, NULL, NULL, 'GLR0591 PROTEIN', 242205),
(328742, 'PTHR33361:SF15', NULL, NULL, NULL, NULL, 'DUF885 FAMILY LIPOPROTEIN', 242205),
(328743, 'PTHR47447', NULL, NULL, NULL, NULL, 'OS03G0856100 PROTEIN', 242206),
(328744, 'PTHR47447:SF7', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 242206),
(328745, 'PTHR47447:SF11', NULL, NULL, NULL, NULL, 'SMR DOMAIN-CONTAINING PROTEIN', 242206),
(328746, 'PTHR47447:SF10', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE (PPR) REPEAT PROTEIN', 242206),
(328747, 'PTHR47447:SF20', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 242206),
(328748, 'PTHR47447:SF3', NULL, NULL, NULL, NULL, 'OS03G0856100 PROTEIN', 242206),
(328749, 'PTHR47447:SF19', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 242206),
(328750, 'PTHR47447:SF18', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE (PPR) REPEAT PROTEIN', 242206),
(328751, 'PTHR47447:SF17', NULL, NULL, NULL, NULL, 'OS12G0638900 PROTEIN', 242206),
(328752, 'PTHR47447:SF16', NULL, NULL, NULL, NULL, 'SMR DOMAIN-CONTAINING PROTEIN', 242206),
(328753, 'PTHR47447:SF15', NULL, NULL, NULL, NULL, 'OS02G0120000 PROTEIN', 242206),
(328754, 'PTHR47447:SF14', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 242206),
(328755, 'PTHR47447:SF13', NULL, NULL, NULL, NULL, 'SMR DOMAIN-CONTAINING PROTEIN', 242206),
(328756, 'PTHR47447:SF12', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN ATP4 HOMOLOG, CHLOROPLASTIC', 242206),
(328757, 'PTHR34492', NULL, NULL, NULL, NULL, 'GUSTATORY RECEPTOR FAMILY', 242207),
(328758, 'PTHR34492:SF2', NULL, NULL, NULL, NULL, 'GUSTATORY RECEPTOR FAMILY', 242207),
(328759, 'PTHR34492:SF5', NULL, NULL, NULL, NULL, 'GUSTATORY RECEPTOR FAMILY', 242207),
(328760, 'PTHR36008:SF1', NULL, NULL, NULL, NULL, 'OS09G0478400 PROTEIN', 242208),
(328761, 'PTHR36008', NULL, NULL, NULL, NULL, 'OS09G0478400 PROTEIN', 242208),
(328762, 'PTHR28627:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY FACTOR 5', 242209),
(328763, 'PTHR28627', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY FACTOR 5', 242209),
(328764, 'PTHR43700', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLAMINOIMIDAZOLE-SUCCINOCARBOXAMIDE SYNTHASE', 242210),
(328765, 'PTHR43700:SF3', NULL, NULL, NULL, NULL, 'SAICAR SYNTHETASE', 242210),
(328766, 'PTHR43700:SF1', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLAMINOIMIDAZOLE-SUCCINOCARBOXAMIDE SYNTHASE', 242210),
(328767, 'PTHR15067', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF8', 242211),
(328768, 'PTHR15067:SF7', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE DMA1-RELATED', 242211),
(328769, 'PTHR15067:SF6', NULL, NULL, NULL, NULL, 'BNAA03G47220D PROTEIN', 242211),
(328770, 'PTHR15067:SF5', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE AMFR', 242211),
(328771, 'PTHR15067:SF4', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF8', 242211),
(328772, 'PTHR10258:SF10', NULL, NULL, NULL, NULL, 'POTASSIUM LARGE CONDUCTANCE CALCIUM-ACTIVATED CHANNEL, SUBFAMILY M, BETA MEMBER 2', 242212),
(328773, 'PTHR10258:SF4', NULL, NULL, NULL, NULL, 'CALCIUM-ACTIVATED POTASSIUM CHANNEL SUBUNIT BETA-3', 242212),
(328774, 'PTHR10258:SF3', NULL, NULL, NULL, NULL, 'CALCIUM-ACTIVATED POTASSIUM CHANNEL SUBUNIT BETA-4', 242212),
(328775, 'PTHR10258:SF12', NULL, NULL, NULL, NULL, '', 242212);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(328776, 'PTHR10258:SF1', NULL, NULL, NULL, NULL, 'CALCIUM-ACTIVATED POTASSIUM CHANNEL SUBUNIT BETA-1', 242212),
(328777, 'PTHR10258', NULL, NULL, NULL, NULL, 'CALCIUM-ACTIVATED POTASSIUM CHANNEL SUBUNIT BETA', 242212),
(328778, 'PTHR10258:SF8', NULL, NULL, NULL, NULL, '', 242212),
(328779, 'PTHR10258:SF5', NULL, NULL, NULL, NULL, 'CALCIUM-ACTIVATED POTASSIUM CHANNEL SUBUNIT BETA-2', 242212),
(328780, 'PTHR36714:SF6', NULL, NULL, NULL, NULL, 'BNAA09G54570D PROTEIN', 242213),
(328781, 'PTHR36714:SF7', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 242213),
(328782, 'PTHR36714', NULL, NULL, NULL, NULL, 'T23E23.1', 242213),
(328783, 'PTHR36714:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 242213),
(328784, 'PTHR36714:SF5', NULL, NULL, NULL, NULL, 'BNAC05G18980D PROTEIN', 242213),
(328785, 'PTHR36714:SF2', NULL, NULL, NULL, NULL, '', 242213),
(328786, 'PTHR36714:SF1', NULL, NULL, NULL, NULL, 'T23E23.1', 242213),
(328787, 'PTHR12628:SF10', NULL, NULL, NULL, NULL, 'C. ELEGANS HOMEOBOX', 242214),
(328788, 'PTHR12628', NULL, NULL, NULL, NULL, 'POLYCOMB-LIKE TRANSCRIPTION FACTOR', 242214),
(328789, 'PTHR12628:SF21', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', 242214),
(328790, 'PTHR12628:SF20', NULL, NULL, NULL, NULL, 'BNAA05G20560D PROTEIN', 242214),
(328791, 'PTHR12628:SF19', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX1A', 242214),
(328792, 'PTHR12628:SF17', NULL, NULL, NULL, NULL, 'BNAA01G07010D PROTEIN', 242214),
(328793, 'PTHR12628:SF6', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN 19', 242214),
(328794, 'PTHR12628:SF13', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HAT3.1', 242214),
(328795, 'PTHR12628:SF12', NULL, NULL, NULL, NULL, 'METAL-RESPONSE ELEMENT-BINDING TRANSCRIPTION FACTOR 2', 242214),
(328796, 'PTHR12628:SF11', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN 1', 242214),
(328797, 'PTHR13659', NULL, NULL, NULL, NULL, 'AUTOSOMAL HIGHLY CONSERVED PROTEIN', 242215),
(328798, 'PTHR13659:SF5', NULL, NULL, NULL, NULL, 'PROTEIN FAM8A1', 242215),
(328799, 'PTHR13659:SF6', NULL, NULL, NULL, NULL, 'RDD DOMAIN-CONTAINING PROTEIN', 242215),
(328800, 'PTHR13659:SF7', NULL, NULL, NULL, NULL, 'RDD DOMAIN-CONTAINING PROTEIN', 242215),
(328801, 'PTHR35741:SF3', NULL, NULL, NULL, NULL, 'BNAA09G39120D PROTEIN', 242216),
(328802, 'PTHR35741:SF1', NULL, NULL, NULL, NULL, 'FACTOR CWC22-LIKE PROTEIN, PUTATIVE (DUF3245)-RELATED', 242216),
(328803, 'PTHR35741:SF2', NULL, NULL, NULL, NULL, '', 242216),
(328804, 'PTHR35741', NULL, NULL, NULL, NULL, 'FACTOR CWC22-LIKE PROTEIN, PUTATIVE (DUF3245)-RELATED', 242216),
(328805, 'PTHR22769', NULL, NULL, NULL, NULL, 'MUTT/NUDIX HYDROLASE', 242217),
(328806, 'PTHR22769:SF56', NULL, NULL, NULL, NULL, '8-OXO-DGDP PHOSPHATASE NUDT18', 242217),
(328807, 'PTHR43023:SF6', NULL, NULL, NULL, NULL, 'INTERMEMBRANE PHOSPHOLIPID TRANSPORT SYSTEM ATP-BINDING PROTEIN MLAF', 242218),
(328808, 'PTHR43023:SF4', NULL, NULL, NULL, NULL, 'AMINO ACID ABC TRANSPORTER ATP-BINDING PROTEIN', 242218),
(328809, 'PTHR43023:SF3', NULL, NULL, NULL, NULL, 'PROTEIN TRIGALACTOSYLDIACYLGLYCEROL 3, CHLOROPLASTIC', 242218),
(328810, 'PTHR43023', NULL, NULL, NULL, NULL, 'PROTEIN TRIGALACTOSYLDIACYLGLYCEROL 3, CHLOROPLASTIC', 242218),
(328811, 'PTHR21321:SF1', NULL, NULL, NULL, NULL, 'EXOSOME COMPLEX COMPONENT RRP40', 242219),
(328812, 'PTHR21321:SF4', NULL, NULL, NULL, NULL, 'EXOSOME COMPLEX COMPONENT RRP4', 242219),
(328813, 'PTHR21321', NULL, NULL, NULL, NULL, 'PNAS-3 RELATED', 242219),
(328814, 'PTHR12609:SF0', NULL, NULL, NULL, NULL, 'CYTOSKELETON-ASSOCIATED PROTEIN 5', 242220),
(328815, 'PTHR12609:SF6', NULL, NULL, NULL, NULL, '', 242220),
(328816, 'PTHR12609:SF7', NULL, NULL, NULL, NULL, 'PHOSPHOPROTEIN P93', 242220),
(328817, 'PTHR12609:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG21459', 242220),
(328818, 'PTHR12609', NULL, NULL, NULL, NULL, 'MICROTUBULE ASSOCIATED PROTEIN XMAP215', 242220),
(328819, 'PTHR28242:SF27', NULL, NULL, NULL, NULL, '', 242221),
(328820, 'PTHR28242:SF47', NULL, NULL, NULL, NULL, 'HISTIDINE-CONTAINING PHOSPHOTRANSFER PROTEIN 1', 242221),
(328821, 'PTHR28242:SF26', NULL, NULL, NULL, NULL, 'HISTIDINE-CONTAINING PHOSPHOTRANSFER PROTEIN 2-RELATED', 242221);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(328822, 'PTHR28242:SF45', NULL, NULL, NULL, NULL, '', 242221),
(328823, 'PTHR28242:SF46', NULL, NULL, NULL, NULL, 'PSEUDO HISTIDINE-CONTAINING PHOSPHOTRANSFER PROTEIN 6', 242221),
(328824, 'PTHR28242:SF65', NULL, NULL, NULL, NULL, 'HISTIDINE-CONTAINING PHOSPHOTRANSFER PROTEIN 3', 242221),
(328825, 'PTHR28242:SF43', NULL, NULL, NULL, NULL, 'HISTIDINE-CONTAINING PHOSPHOTRANSFER PROTEIN 4', 242221),
(328826, 'PTHR28242:SF63', NULL, NULL, NULL, NULL, 'HISTIDINE-CONTAINING PHOSPHOTRANSFER PROTEIN 2-LIKE', 242221),
(328827, 'PTHR28242:SF41', NULL, NULL, NULL, NULL, 'HISTIDINE CONTAINING PHOSPHOTRANSFER PROTEIN', 242221),
(328828, 'PTHR28242:SF42', NULL, NULL, NULL, NULL, 'PSEUDO HISTIDINE-CONTAINING PHOSPHOTRANSFER PROTEIN 5', 242221),
(328829, 'PTHR28242:SF64', NULL, NULL, NULL, NULL, 'HPT DOMAIN-CONTAINING PROTEIN', 242221),
(328830, 'PTHR28242', NULL, NULL, NULL, NULL, 'PHOSPHORELAY INTERMEDIATE PROTEIN YPD1', 242221),
(328831, 'PTHR28242:SF61', NULL, NULL, NULL, NULL, 'PSEUDO HISTIDINE-CONTAINING PHOSPHOTRANSFER PROTEIN 1', 242221),
(328832, 'PTHR28242:SF62', NULL, NULL, NULL, NULL, 'HISTIDINE PHOSPHOTRANSFER PROTEIN', 242221),
(328833, 'PTHR28242:SF40', NULL, NULL, NULL, NULL, 'HISTIDINE-CONTAINING PHOSPHOTRANSFER PROTEIN 1-LIKE ISOFORM X1', 242221),
(328834, 'PTHR28242:SF5', NULL, NULL, NULL, NULL, 'HISTIDINE-CONTAINING PHOSPHOTRANSFER PROTEIN 1', 242221),
(328835, 'PTHR28242:SF7', NULL, NULL, NULL, NULL, 'CONTAINING PHOSPHOTRANSFER PROTEIN, PUTATIVE-RELATED', 242221),
(328836, 'PTHR28242:SF39', NULL, NULL, NULL, NULL, 'HPT DOMAIN-CONTAINING PROTEIN', 242221),
(328837, 'PTHR28242:SF37', NULL, NULL, NULL, NULL, 'HISTIDINE-CONTAINING PHOSPHOTRANSFER PROTEIN 4-LIKE ISOFORM X1', 242221),
(328838, 'PTHR28242:SF34', NULL, NULL, NULL, NULL, 'HPT DOMAIN-CONTAINING PROTEIN', 242221),
(328839, 'PTHR28242:SF56', NULL, NULL, NULL, NULL, 'HPT DOMAIN-CONTAINING PROTEIN', 242221),
(328840, 'PTHR28242:SF35', NULL, NULL, NULL, NULL, 'HPT DOMAIN-CONTAINING PROTEIN', 242221),
(328841, 'PTHR28242:SF13', NULL, NULL, NULL, NULL, 'HISTIDINE-CONTAINING PHOSPHOTRANSFER PROTEIN 5', 242221),
(328842, 'PTHR28242:SF55', NULL, NULL, NULL, NULL, 'HPT DOMAIN-CONTAINING PROTEIN', 242221),
(328843, 'PTHR28242:SF30', NULL, NULL, NULL, NULL, 'HISTIDINE-CONTAINING PHOSPHOTRANSFER PROTEIN 2', 242221),
(328844, 'PTHR28242:SF52', NULL, NULL, NULL, NULL, 'PHOSPHORELAY INTERMEDIATE PROTEIN YPD1', 242221),
(328845, 'PTHR28242:SF53', NULL, NULL, NULL, NULL, 'HISTIDINE-CONTAINING PHOSPHOTRANSFER PROTEIN 4-LIKE ISOFORM X1', 242221),
(328846, 'PTHR28242:SF51', NULL, NULL, NULL, NULL, 'HPT DOMAIN-CONTAINING PROTEIN', 242221),
(328847, 'PTHR28221', NULL, NULL, NULL, NULL, 'RNA POLYMERASE I-SPECIFIC TRANSCRIPTION INITIATION FACTOR RRN6', 242222),
(328848, 'PTHR28221:SF2', NULL, NULL, NULL, NULL, 'RNA POLYMERASE I-SPECIFIC TRANSCRIPTION INITIATION FACTOR RRN6', 242222),
(328849, 'PTHR10558:SF2', NULL, NULL, NULL, NULL, 'SOMATOSTATIN', 242223),
(328850, 'PTHR10558:SF6', NULL, NULL, NULL, NULL, 'SOMATOSTATIN 1, TANDEM DUPLICATE 2', 242223),
(328851, 'PTHR10558', NULL, NULL, NULL, NULL, 'SOMATOSTATIN', 242223),
(328852, 'PTHR10558:SF1', NULL, NULL, NULL, NULL, 'CORTISTATIN', 242223),
(328853, 'PTHR15545:SF4', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN 4', 242224),
(328854, 'PTHR15545:SF6', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING RING FINGER PROTEIN 4', 242224),
(328855, 'PTHR15545:SF5', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE PDZRN3', 242224),
(328856, 'PTHR15545:SF8', NULL, NULL, NULL, NULL, 'SLO-INTERACTING PROTEIN 1', 242224),
(328857, 'PTHR15545', NULL, NULL, NULL, NULL, 'PDZ DOMAIN CONTAINING RING FINGER PROTEIN 3, 4', 242224),
(328858, 'PTHR11502:SF30', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S6', 242225),
(328859, 'PTHR11502:SF32', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S6', 242225),
(328860, 'PTHR11502:SF6', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S6', 242225),
(328861, 'PTHR11502', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S6', 242225),
(328862, 'PTHR11502:SF34', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S6', 242225);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(328863, 'PTHR11502:SF35', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S6', 242225),
(328864, 'PTHR11502:SF36', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S6', 242225),
(328865, 'PTHR11502:SF25', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S6', 242225),
(328866, 'PTHR11502:SF15', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S6', 242225),
(328867, 'PTHR11502:SF37', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S6-1', 242225),
(328868, 'PTHR11502:SF17', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S6-2', 242225),
(328869, 'PTHR11502:SF19', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S6', 242225),
(328870, 'PTHR36305:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLGLYCEROPHOSPHATASE A', 242226),
(328871, 'PTHR36305', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLGLYCEROPHOSPHATASE A', 242226),
(328872, 'PTHR37473:SF1', NULL, NULL, NULL, NULL, '', 242227),
(328873, 'PTHR37473', NULL, NULL, NULL, NULL, '', 242227),
(328874, 'PTHR14773:SF1', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 242228),
(328875, 'PTHR14773:SF2', NULL, NULL, NULL, NULL, 'CLEAVAGE STIMULATION FACTOR-RELATED WD40PROTEIN', 242228),
(328876, 'PTHR14773:SF0', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 76', 242228),
(328877, 'PTHR14773', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 242228),
(328878, 'PTHR38761:SF1', NULL, NULL, NULL, NULL, 'GLUTAMATE--CYSTEINE LIGASE', 242229),
(328879, 'PTHR38761', NULL, NULL, NULL, NULL, 'GLUTAMATE--CYSTEINE LIGASE', 242229),
(328880, 'PTHR20963', NULL, NULL, NULL, NULL, 'MULTIPLE INOSITOL POLYPHOSPHATE PHOSPHATASE-RELATED', 242230),
(328881, 'PTHR20963:SF12', NULL, NULL, NULL, NULL, 'ENDOCYTOSIS PROTEIN 3', 242230),
(328882, 'PTHR20963:SF23', NULL, NULL, NULL, NULL, '3-PHYTASE', 242230),
(328883, 'PTHR20963:SF24', NULL, NULL, NULL, NULL, '3-PHYTASE B', 242230),
(328884, 'PTHR20963:SF14', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE, PUTATIVE-RELATED', 242230),
(328885, 'PTHR20963:SF37', NULL, NULL, NULL, NULL, '2,3-BISPHOSPHOGLYCERATE 3-PHOSPHATASE', 242230),
(328886, 'PTHR20963:SF41', NULL, NULL, NULL, NULL, '2,3-BISPHOSPHOGLYCERATE 3-PHOSPHATASE', 242230),
(328887, 'PTHR20963:SF42', NULL, NULL, NULL, NULL, 'CHROMOSOME 12, WHOLE GENOME SHOTGUN SEQUENCE', 242230),
(328888, 'PTHR20963:SF53', NULL, NULL, NULL, NULL, '', 242230),
(328889, 'PTHR20963:SF43', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_7G01240)-RELATED', 242230),
(328890, 'PTHR20963:SF54', NULL, NULL, NULL, NULL, 'MULTIPLE INOSITOL POLYPHOSPHATE PHOSPHATASE 1-LIKE ISOFORM X1', 242230),
(328891, 'PTHR20963:SF55', NULL, NULL, NULL, NULL, 'PHOSPHATASE, PUTATIVE-RELATED', 242230),
(328892, 'PTHR20963:SF8', NULL, NULL, NULL, NULL, 'MULTIPLE INOSITOL POLYPHOSPHATE PHOSPHATASE 1', 242230),
(328893, 'PTHR20963:SF18', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE PHO11-RELATED', 242230),
(328894, 'PTHR20963:SF51', NULL, NULL, NULL, NULL, '2,3-BISPHOSPHOGLYCERATE 3-PHOSPHATASE', 242230),
(328895, 'PTHR32525', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE-PHOSPHATASE', 242231),
(328896, 'PTHR32525:SF3', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE-PHOSPHATASE-RELATED', 242231),
(328897, 'PTHR32525:SF0', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN-RELATED', 242231),
(328898, 'PTHR32525:SF1', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE-PHOSPHATASE-RELATED', 242231),
(328899, 'PTHR31651:SF6', NULL, NULL, NULL, NULL, 'PROTEIN PIN-LIKES 3-LIKE ISOFORM X1', 242232),
(328900, 'PTHR31651:SF29', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 242232),
(328901, 'PTHR31651:SF19', NULL, NULL, NULL, NULL, 'PROTEIN PIN-LIKES 3-RELATED', 242232),
(328902, 'PTHR31651:SF27', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER-RELATED', 242232),
(328903, 'PTHR31651:SF39', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER FAMILY PROTEIN ISOFORM 2', 242232),
(328904, 'PTHR31651:SF3', NULL, NULL, NULL, NULL, 'PROTEIN PIN-LIKES 7', 242232),
(328905, 'PTHR31651:SF25', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER-RELATED', 242232),
(328906, 'PTHR31651:SF36', NULL, NULL, NULL, NULL, '', 242232),
(328907, 'PTHR31651:SF15', NULL, NULL, NULL, NULL, 'PROTEIN PIN-LIKES 5', 242232); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(328908, 'PTHR31651:SF26', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER-RELATED', 242232),
(328909, 'PTHR31651:SF12', NULL, NULL, NULL, NULL, 'AUXIN:HYDROGEN SYMPORTER', 242232),
(328910, 'PTHR31651:SF34', NULL, NULL, NULL, NULL, '', 242232),
(328911, 'PTHR31651:SF32', NULL, NULL, NULL, NULL, 'BNAA09G09160D PROTEIN', 242232),
(328912, 'PTHR31651:SF21', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER FAMILY PROTEIN', 242232),
(328913, 'PTHR31651:SF43', NULL, NULL, NULL, NULL, 'SYMPORTER, PUTATIVE-RELATED', 242232),
(328914, 'PTHR31651:SF33', NULL, NULL, NULL, NULL, 'OS09G0491740 PROTEIN', 242232),
(328915, 'PTHR31651:SF11', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER FAMILY PROTEIN', 242232),
(328916, 'PTHR31651:SF22', NULL, NULL, NULL, NULL, '', 242232),
(328917, 'PTHR31651:SF30', NULL, NULL, NULL, NULL, 'AUXIN:HYDROGEN SYMPORTER', 242232),
(328918, 'PTHR31651:SF41', NULL, NULL, NULL, NULL, 'PROTEIN PIN-LIKES 3-LIKE ISOFORM X1', 242232),
(328919, 'PTHR31651:SF42', NULL, NULL, NULL, NULL, 'PROTEIN PIN-LIKES 1', 242232),
(328920, 'PTHR31651:SF20', NULL, NULL, NULL, NULL, 'EFFLUX CARRIER FAMILY PROTEIN, PUTATIVE-RELATED', 242232),
(328921, 'PTHR31651:SF40', NULL, NULL, NULL, NULL, 'PROTEIN PIN-LIKES 3-LIKE', 242232),
(328922, 'PTHR31651', NULL, NULL, NULL, NULL, '', 242232),
(328923, 'PTHR36455:SF1', NULL, NULL, NULL, NULL, 'BLR8292 PROTEIN', 242233),
(328924, 'PTHR36455', NULL, NULL, NULL, NULL, '', 242233),
(328925, 'PTHR46236:SF7', NULL, NULL, NULL, NULL, 'PROTEIN RESTRICTED TEV MOVEMENT 3', 242234),
(328926, 'PTHR46236:SF4', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 242234),
(328927, 'PTHR46236:SF5', NULL, NULL, NULL, NULL, 'UBIQUITIN-SPECIFIC PROTEASE FAMILY C19-RELATED PROTEIN', 242234),
(328928, 'PTHR46236:SF2', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE-LIKE PROTEIN (PEARLI 4) FAMILY PROTEIN', 242234),
(328929, 'PTHR46236:SF21', NULL, NULL, NULL, NULL, 'TRAF-LIKE FAMILY PROTEIN-RELATED', 242234),
(328930, 'PTHR46236:SF20', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 242234),
(328931, 'PTHR46236:SF27', NULL, NULL, NULL, NULL, 'BNAC03G13690D PROTEIN', 242234),
(328932, 'PTHR46236:SF26', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 242234),
(328933, 'PTHR46236:SF29', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 242234),
(328934, 'PTHR46236:SF28', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 242234),
(328935, 'PTHR46236:SF23', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 242234),
(328936, 'PTHR46236:SF22', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 242234),
(328937, 'PTHR46236:SF8', NULL, NULL, NULL, NULL, 'UBIQUITIN-SPECIFIC PROTEASE FAMILY C19-RELATED PROTEIN', 242234),
(328938, 'PTHR46236:SF24', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 242234),
(328939, 'PTHR46236:SF9', NULL, NULL, NULL, NULL, 'UBIQUITIN-SPECIFIC PROTEASE FAMILY C19-RELATED PROTEIN', 242234),
(328940, 'PTHR46236:SF19', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 242234),
(328941, 'PTHR46236', NULL, NULL, NULL, NULL, 'TRAF-LIKE SUPERFAMILY PROTEIN', 242234),
(328942, 'PTHR46236:SF30', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 242234),
(328943, 'PTHR46236:SF32', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 242234),
(328944, 'PTHR46236:SF31', NULL, NULL, NULL, NULL, '', 242234),
(328945, 'PTHR46236:SF16', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 242234),
(328946, 'PTHR46236:SF37', NULL, NULL, NULL, NULL, '', 242234),
(328947, 'PTHR46236:SF15', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 242234),
(328948, 'PTHR46236:SF18', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 242234),
(328949, 'PTHR46236:SF12', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 242234),
(328950, 'PTHR46236:SF34', NULL, NULL, NULL, NULL, 'BNAA08G08030D PROTEIN', 242234),
(328951, 'PTHR46236:SF33', NULL, NULL, NULL, NULL, 'MEPRIN AND TRAF-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 242234),
(328952, 'PTHR46236:SF11', NULL, NULL, NULL, NULL, 'TRAF-LIKE SUPERFAMILY PROTEIN', 242234);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(328953, 'PTHR46236:SF14', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 242234),
(328954, 'PTHR46236:SF36', NULL, NULL, NULL, NULL, 'MATH (MEPRIN AND TRAF-C-LIKE) DOMAIN PROTEIN', 242234),
(328955, 'PTHR46236:SF13', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 242234),
(328956, 'PTHR46236:SF35', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 242234),
(328957, 'PTHR23020:SF12', NULL, NULL, NULL, NULL, 'CHK DOMAIN-CONTAINING PROTEIN', 242235),
(328958, 'PTHR23020:SF9', NULL, NULL, NULL, NULL, 'CHK DOMAIN-CONTAINING PROTEIN', 242235),
(328959, 'PTHR23020:SF22', NULL, NULL, NULL, NULL, 'CHK DOMAIN-CONTAINING PROTEIN', 242235),
(328960, 'PTHR23020:SF11', NULL, NULL, NULL, NULL, 'CHK DOMAIN-CONTAINING PROTEIN', 242235),
(328961, 'PTHR23020:SF8', NULL, NULL, NULL, NULL, 'CHK DOMAIN-CONTAINING PROTEIN', 242235),
(328962, 'PTHR23020:SF10', NULL, NULL, NULL, NULL, 'CHK DOMAIN-CONTAINING PROTEIN', 242235),
(328963, 'PTHR23020:SF7', NULL, NULL, NULL, NULL, 'CHK DOMAIN-CONTAINING PROTEIN', 242235),
(328964, 'PTHR23020:SF21', NULL, NULL, NULL, NULL, 'CHK DOMAIN-CONTAINING PROTEIN', 242235),
(328965, 'PTHR23020:SF43', NULL, NULL, NULL, NULL, 'CHK DOMAIN-CONTAINING PROTEIN', 242235),
(328966, 'PTHR23020:SF20', NULL, NULL, NULL, NULL, 'CHK DOMAIN-CONTAINING PROTEIN', 242235),
(328967, 'PTHR23020:SF42', NULL, NULL, NULL, NULL, 'CHK DOMAIN-CONTAINING PROTEIN', 242235),
(328968, 'PTHR23020:SF41', NULL, NULL, NULL, NULL, 'APH DOMAIN-CONTAINING PROTEIN', 242235),
(328969, 'PTHR23020', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED NUCLEAR HORMONE RECEPTOR-RELATED', 242235),
(328970, 'PTHR23020:SF18', NULL, NULL, NULL, NULL, 'CHK DOMAIN-CONTAINING PROTEIN', 242235),
(328971, 'PTHR23020:SF17', NULL, NULL, NULL, NULL, 'CHK DOMAIN-CONTAINING PROTEIN', 242235),
(328972, 'PTHR23020:SF15', NULL, NULL, NULL, NULL, 'CHK DOMAIN-CONTAINING PROTEIN', 242235),
(328973, 'PTHR16043', NULL, NULL, NULL, NULL, 'DALRD3 PROTEIN', 242236),
(328974, 'PTHR16043:SF1', NULL, NULL, NULL, NULL, 'DALR ANTICODON-BINDING DOMAIN-CONTAINING PROTEIN 3', 242236),
(328975, 'PTHR21533:SF20', NULL, NULL, NULL, NULL, 'PROTEIN CHIBBY HOMOLOG 1', 242237),
(328976, 'PTHR21533', NULL, NULL, NULL, NULL, 'LEUCINE-RICH PROTEIN', 242237),
(328977, 'PTHR21533:SF22', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 70', 242237),
(328978, 'PTHR21533:SF13', NULL, NULL, NULL, NULL, 'PROTEIN CHIBBY HOMOLOG 2', 242237),
(328979, 'PTHR21533:SF23', NULL, NULL, NULL, NULL, '', 242237),
(328980, 'PTHR21533:SF17', NULL, NULL, NULL, NULL, 'PROTEIN CHIBBY HOMOLOG 3', 242237),
(328981, 'PTHR21533:SF19', NULL, NULL, NULL, NULL, 'CHIBBY HOMOLOG 1 (DROSOPHILA)', 242237),
(328982, 'PTHR39638', NULL, NULL, NULL, NULL, 'YCF35', 242238),
(328983, 'PTHR39638:SF2', NULL, NULL, NULL, NULL, 'YCF35', 242238),
(328984, 'PTHR12120:SF9', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER EDAR', 242239),
(328985, 'PTHR12120:SF8', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 27', 242239),
(328986, 'PTHR12120:SF1', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 19', 242239),
(328987, 'PTHR12120', NULL, NULL, NULL, NULL, 'TNFR-CYS DOMAIN-CONTAINING PROTEIN', 242239),
(328988, 'PTHR12120:SF10', NULL, NULL, NULL, NULL, 'TNFR-CYS DOMAIN-CONTAINING PROTEIN', 242239),
(328989, 'PTHR31150:SF21', NULL, NULL, NULL, NULL, 'OS02G0794000 PROTEIN', 242240),
(328990, 'PTHR31150:SF32', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 242240),
(328991, 'PTHR31150:SF22', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 242240),
(328992, 'PTHR31150:SF33', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 242240),
(328993, 'PTHR31150:SF23', NULL, NULL, NULL, NULL, 'MANDELONITRILE LYASE-RELATED', 242240),
(328994, 'PTHR31150:SF35', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 242240),
(328995, 'PTHR31150:SF40', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 242240),
(328996, 'PTHR31150:SF41', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 242240); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(328997, 'PTHR31150:SF29', NULL, NULL, NULL, NULL, 'RING FINGER FAMILY PROTEIN', 242240),
(328998, 'PTHR31150:SF19', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 242240),
(328999, 'PTHR31150:SF25', NULL, NULL, NULL, NULL, 'C3HC4-TYPE RING ZINC FINGER PROTEIN', 242240),
(329000, 'PTHR31150:SF36', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 242240),
(329001, 'PTHR31150:SF26', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 242240),
(329002, 'PTHR31150:SF37', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 242240),
(329003, 'PTHR31150:SF27', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 242240),
(329004, 'PTHR31150:SF2', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 242240),
(329005, 'PTHR31150', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242240),
(329006, 'PTHR31150:SF6', NULL, NULL, NULL, NULL, 'ZINC ION BINDING PROTEIN', 242240),
(329007, 'PTHR13011:SF0', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR IIF SUBUNIT 1', 242241),
(329008, 'PTHR13011:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIF SUBUNIT ALPHA', 242241),
(329009, 'PTHR13011:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIF SUBUNIT ALPHA', 242241),
(329010, 'PTHR13011', NULL, NULL, NULL, NULL, 'TFIIF-ALPHA', 242241),
(329011, 'PTHR47959:SF18', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DEAD BOX FAMILY', 242242),
(329012, 'PTHR47959', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE RHLE-RELATED', 242242),
(329013, 'PTHR47959:SF15', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE', 242242),
(329014, 'PTHR47959:SF14', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE-RELATED', 242242),
(329015, 'PTHR47959:SF17', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DEAD BOX FAMILY', 242242),
(329016, 'PTHR47959:SF16', NULL, NULL, NULL, NULL, 'CRISPR-ASSOCIATED NUCLEASE/HELICASE CAS3-RELATED', 242242),
(329017, 'PTHR47959:SF11', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DEAD BOX FAMILY', 242242),
(329018, 'PTHR47959:SF10', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE RHLB', 242242),
(329019, 'PTHR47959:SF13', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE RHLE', 242242),
(329020, 'PTHR47959:SF7', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DEAD BOX FAMILY', 242242),
(329021, 'PTHR47959:SF8', NULL, NULL, NULL, NULL, 'RNA HELICASE', 242242),
(329022, 'PTHR47959:SF3', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE SRMB', 242242),
(329023, 'PTHR47959:SF1', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DBPA', 242242),
(329024, 'PTHR47959:SF2', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DEAD BOX FAMILY', 242242),
(329025, 'PTHR46409', NULL, NULL, NULL, NULL, '', 242243),
(329026, 'PTHR46409:SF1', NULL, NULL, NULL, NULL, '', 242243),
(329027, 'PTHR36074:SF1', NULL, NULL, NULL, NULL, 'ISOPENTENYL-DIPHOSPHATE DELTA-ISOMERASE', 242244),
(329028, 'PTHR36074:SF2', NULL, NULL, NULL, NULL, 'BNAA02G08950D PROTEIN', 242244),
(329029, 'PTHR36074', NULL, NULL, NULL, NULL, 'ISOPENTENYL-DIPHOSPHATE DELTA-ISOMERASE', 242244),
(329030, 'PTHR12878:SF3', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX SUBUNIT 2-LIKE', 242245),
(329031, 'PTHR12878:SF6', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX SUBUNIT 2', 242245),
(329032, 'PTHR12878:SF5', NULL, NULL, NULL, NULL, 'L51_S25_CI-B8 DOMAIN-CONTAINING PROTEIN', 242245),
(329033, 'PTHR12878', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE B8 SUBUNIT', 242245),
(329034, 'PTHR12878:SF0', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX SUBUNIT 2', 242245),
(329035, 'PTHR12878:SF1', NULL, NULL, NULL, NULL, 'COMPLEX I-B8', 242245),
(329036, 'PTHR12490:SF2', NULL, NULL, NULL, NULL, 'DUF727 DOMAIN-CONTAINING PROTEIN', 242246),
(329037, 'PTHR12490', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 242246),
(329038, 'PTHR12490:SF4', NULL, NULL, NULL, NULL, 'GSK3B-INTERACTING PROTEIN', 242246),
(329039, 'PTHR12490:SF5', NULL, NULL, NULL, NULL, 'DUF727 DOMAIN-CONTAINING PROTEIN', 242246);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(329040, 'PTHR34966', NULL, NULL, NULL, NULL, 'OSJNBA0043L24.15 PROTEIN', 242247),
(329041, 'PTHR34966:SF1', NULL, NULL, NULL, NULL, 'OS04G0508100 PROTEIN', 242247),
(329042, 'PTHR36113:SF6', NULL, NULL, NULL, NULL, 'GLYOXALASE FAMILY PROTEIN', 242248),
(329043, 'PTHR36113:SF3', NULL, NULL, NULL, NULL, 'SLL5075 PROTEIN', 242248),
(329044, 'PTHR36113:SF1', NULL, NULL, NULL, NULL, 'FOSFOMYCIN RESISTANCE PROTEIN FOSX', 242248),
(329045, 'PTHR36113', NULL, NULL, NULL, NULL, 'LYASE, PUTATIVE-RELATED-RELATED', 242248),
(329046, 'PTHR38657:SF1', NULL, NULL, NULL, NULL, 'SLR1343 PROTEIN', 242249),
(329047, 'PTHR38657', NULL, NULL, NULL, NULL, 'SLR1343 PROTEIN', 242249),
(329048, 'PTHR12621:SF8', NULL, NULL, NULL, NULL, 'INTEGRIN BETA-1-BINDING PROTEIN 2', 242250),
(329049, 'PTHR12621:SF7', NULL, NULL, NULL, NULL, 'CYSTEINE AND HISTIDINE-RICH DOMAIN-CONTAINING PROTEIN', 242250),
(329050, 'PTHR12621:SF11', NULL, NULL, NULL, NULL, '', 242250),
(329051, 'PTHR12621', NULL, NULL, NULL, NULL, 'CYSTEINE AND HISTIDINE-RICH DOMAIN  CHORD -CONTAINING PROTEIN', 242250),
(329052, 'PTHR12621:SF9', NULL, NULL, NULL, NULL, 'CYSTEINE AND HISTIDINE-RICH DOMAIN-CONTAINING PROTEIN 1', 242250),
(329053, 'PTHR12621:SF10', NULL, NULL, NULL, NULL, '', 242250),
(329054, 'PTHR38443:SF2', NULL, NULL, NULL, NULL, 'NON-EXPRESSED ENTEROTOXIN C', 242251),
(329055, 'PTHR38443', NULL, NULL, NULL, NULL, '', 242251),
(329056, 'PTHR11738:SF4', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN ALPHA FC RECEPTOR', 242252),
(329057, 'PTHR11738:SF172', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 242252),
(329058, 'PTHR11738:SF88', NULL, NULL, NULL, NULL, 'LEUKOCYTE IMMUNOGLOBULIN-LIKE RECEPTOR SUBFAMILY A MEMBER 6-RELATED', 242252),
(329059, 'PTHR11738:SF170', NULL, NULL, NULL, NULL, 'LEUKOCYTE IMMUNOGLOBULIN-LIKE RECEPTOR SUBFAMILY A MEMBER 3-RELATED', 242252),
(329060, 'PTHR11738:SF86', NULL, NULL, NULL, NULL, 'LEUKOCYTE IMMUNOGLOBULIN-LIKE RECEPTOR SUBFAMILY A MEMBER 2', 242252),
(329061, 'PTHR11738:SF14', NULL, NULL, NULL, NULL, 'NATURAL CYTOTOXICITY TRIGGERING RECEPTOR 1', 242252),
(329062, 'PTHR11738:SF158', NULL, NULL, NULL, NULL, 'KILLER CELL IMMUNOGLOBULIN-LIKE RECEPTOR 2DL4', 242252),
(329063, 'PTHR11738:SF157', NULL, NULL, NULL, NULL, 'T-CELL-INTERACTING, ACTIVATING RECEPTOR ON MYELOID CELLS PROTEIN 1', 242252),
(329064, 'PTHR11738:SF113', NULL, NULL, NULL, NULL, 'KIR2DL PROTEIN-RELATED', 242252),
(329065, 'PTHR11738:SF179', NULL, NULL, NULL, NULL, 'LEUKOCYTE IMMUNOGLOBULIN-LIKE RECEPTOR SUBFAMILY A MEMBER 5', 242252),
(329066, 'PTHR11738:SF159', NULL, NULL, NULL, NULL, 'OSTEOCLAST-ASSOCIATED IMMUNOGLOBULIN-LIKE RECEPTOR', 242252),
(329067, 'PTHR11738', NULL, NULL, NULL, NULL, 'MHC CLASS I NK CELL RECEPTOR', 242252),
(329068, 'PTHR11738:SF153', NULL, NULL, NULL, NULL, 'KILLER CELL IMMUNOGLOBULIN-LIKE RECEPTOR-LIKE PROTEIN KIR3DX1-RELATED', 242252),
(329069, 'PTHR11738:SF178', NULL, NULL, NULL, NULL, 'LEUKOCYTE IMMUNOGLOBULIN-LIKE RECEPTOR SUBFAMILY B MEMBER 4', 242252),
(329070, 'PTHR11738:SF177', NULL, NULL, NULL, NULL, 'KILLER CELL IMMUNOGLOBULIN-LIKE RECEPTOR 3DL3', 242252),
(329071, 'PTHR11738:SF117', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 242252),
(329072, 'PTHR11738:SF183', NULL, NULL, NULL, NULL, 'LEUKOCYTE IMMUNOGLOBULIN-LIKE RECEPTOR, SUBFAMILY A (WITH TM DOMAIN), MEMBER 5', 242252),
(329073, 'PTHR11738:SF182', NULL, NULL, NULL, NULL, 'LEUKOCYTE IMMUNOGLOBULIN-LIKE RECEPTOR SUBFAMILY B MEMBER 3-RELATED', 242252),
(329074, 'PTHR11738:SF185', NULL, NULL, NULL, NULL, 'PLATELET GLYCOPROTEIN VI', 242252),
(329075, 'PTHR11738:SF163', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN SUPERFAMILY MEMBER 1', 242252),
(329076, 'PTHR11738:SF184', NULL, NULL, NULL, NULL, 'ALPHA-1B-GLYCOPROTEIN', 242252),
(329077, 'PTHR11738:SF98', NULL, NULL, NULL, NULL, 'LEUKOCYTE IMMUNOGLOBULIN-LIKE RECEPTOR SUBFAMILY A MEMBER 4', 242252),
(329078, 'PTHR11738:SF181', NULL, NULL, NULL, NULL, 'LEUKOCYTE IMMUNOGLOBULIN-LIKE RECEPTOR SUBFAMILY B MEMBER 4-RELATED', 242252),
(329079, 'PTHR11738:SF180', NULL, NULL, NULL, NULL, 'V-SET AND TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN 1', 242252);
INSERT INTO "PUBLIC"."MODEL" VALUES
(329080, 'PTHR11738:SF169', NULL, NULL, NULL, NULL, 'KILLER CELL IMMUNOGLOBULIN-LIKE RECEPTOR-RELATED', 242252),
(329081, 'PTHR11738:SF168', NULL, NULL, NULL, NULL, 'KILLER CELL IMMUNOGLOBULIN-LIKE RECEPTOR 2DL2-RELATED', 242252),
(329082, 'PTHR11738:SF165', NULL, NULL, NULL, NULL, 'LEUKOCYTE IMMUNOGLOBULIN-LIKE RECEPTOR SUBFAMILY A MEMBER 1-RELATED', 242252),
(329083, 'PTHR11738:SF186', NULL, NULL, NULL, NULL, 'LEUKOCYTE IMMUNOGLOBULIN-LIKE RECEPTOR SUBFAMILY A MEMBER 6', 242252),
(329084, 'PTHR11738:SF166', NULL, NULL, NULL, NULL, 'KILLER CELL IMMUNOGLOBULIN-LIKE RECEPTOR 3DL1-RELATED', 242252),
(329085, 'PTHR11738:SF129', NULL, NULL, NULL, NULL, 'LEUKOCYTE-ASSOCIATED IMMUNOGLOBULIN-LIKE RECEPTOR 1-RELATED', 242252),
(329086, 'PTHR11738:SF108', NULL, NULL, NULL, NULL, 'LEUKOCYTE IMMUNOGLOBULIN-LIKE RECEPTOR SUBFAMILY B MEMBER 5', 242252),
(329087, 'PTHR37349:SF1', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 12', 242253),
(329088, 'PTHR37349', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 12', 242253),
(329089, 'PTHR33668', NULL, NULL, NULL, NULL, 'PROTEIN BRICK1', 242254),
(329090, 'PTHR33668:SF1', NULL, NULL, NULL, NULL, 'PROTEIN BRICK1', 242254),
(329091, 'PTHR37297:SF1', NULL, NULL, NULL, NULL, 'PROTEIN NRDI', 242255),
(329092, 'PTHR37297', NULL, NULL, NULL, NULL, 'PROTEIN NRDI', 242255),
(329093, 'PTHR43743', NULL, NULL, NULL, NULL, 'POTASSIUM-TRANSPORTING ATPASE ATP-BINDING SUBUNIT', 242256),
(329094, 'PTHR43743:SF1', NULL, NULL, NULL, NULL, 'POTASSIUM-TRANSPORTING ATPASE ATP-BINDING SUBUNIT', 242256),
(329095, 'PTHR10019', NULL, NULL, NULL, NULL, 'SNF5', 242257),
(329096, 'PTHR10019:SF13', NULL, NULL, NULL, NULL, 'PB1 DOMAIN-CONTAINING PROTEIN-RELATED', 242257),
(329097, 'PTHR10019:SF11', NULL, NULL, NULL, NULL, 'SWI/SNF CHROMATIN-REMODELING COMPLEX SUBUNIT SNF5', 242257),
(329098, 'PTHR10019:SF12', NULL, NULL, NULL, NULL, 'AGAP004442-PA', 242257),
(329099, 'PTHR10019:SF5', NULL, NULL, NULL, NULL, 'SWI/SNF-RELATED MATRIX-ASSOCIATED ACTIN-DEPENDENT REGULATOR OF CHROMATIN SUBFAMILY B MEMBER 1', 242257),
(329100, 'PTHR34976', NULL, NULL, NULL, NULL, 'RIBONUCLEASE YQCG-RELATED', 242258),
(329101, 'PTHR34976:SF2', NULL, NULL, NULL, NULL, 'RIBONUCLEASE YQCG', 242258),
(329102, 'PTHR34976:SF1', NULL, NULL, NULL, NULL, 'RIBONUCLEASE BC_0920', 242258),
(329103, 'PTHR47996:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB58-RELATED', 242259),
(329104, 'PTHR47996:SF4', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN MYB4-LIKE', 242259),
(329105, 'PTHR47996:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR DUO1', 242259),
(329106, 'PTHR47996:SF2', NULL, NULL, NULL, NULL, 'BNAA09G38510D PROTEIN', 242259),
(329107, 'PTHR47996:SF1', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 242259),
(329108, 'PTHR47996', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR DUO1', 242259),
(329109, 'PTHR45769:SF6', NULL, NULL, NULL, NULL, 'ADENOSINE KINASE', 242260),
(329110, 'PTHR45769:SF7', NULL, NULL, NULL, NULL, 'ADENOSINE KINASE', 242260),
(329111, 'PTHR45769', NULL, NULL, NULL, NULL, 'ADENOSINE KINASE', 242260),
(329112, 'PTHR45769:SF8', NULL, NULL, NULL, NULL, 'ADENOSINE KINASE 2', 242260),
(329113, 'PTHR45769:SF9', NULL, NULL, NULL, NULL, 'ADENOSINE KINASE', 242260),
(329114, 'PTHR45769:SF2', NULL, NULL, NULL, NULL, 'ADENOSINE KINASE', 242260),
(329115, 'PTHR45769:SF3', NULL, NULL, NULL, NULL, 'ADENOSINE KINASE', 242260),
(329116, 'PTHR45769:SF5', NULL, NULL, NULL, NULL, 'ADY43A', 242260),
(329117, 'PTHR45769:SF10', NULL, NULL, NULL, NULL, 'ADENOSINE KINASE', 242260),
(329118, 'PTHR45769:SF1', NULL, NULL, NULL, NULL, 'ADENOSINE KINASE', 242260),
(329119, 'PTHR24383', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 242261),
(329120, 'PTHR24383:SF10', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 44', 242261),
(329121, 'PTHR24383:SF20', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242261),
(329122, 'PTHR24383:SF14', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 579', 242261),
(329123, 'PTHR24383:SF13', NULL, NULL, NULL, NULL, 'FLT3-INTERACTING ZINC FINGER PROTEIN 1', 242261); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(329124, 'PTHR24383:SF12', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 618', 242261),
(329125, 'PTHR42829:SF1', NULL, NULL, NULL, NULL, 'NADH-QUINONE OXIDOREDUCTASE SUBUNIT 5-RELATED', 242262),
(329126, 'PTHR42829', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE CHAIN 5', 242262),
(329127, 'PTHR42829:SF2', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE CHAIN 5', 242262),
(329128, 'PTHR46174', NULL, NULL, NULL, NULL, 'CXXC-TYPE ZINC FINGER PROTEIN 1', 242263),
(329129, 'PTHR46174:SF7', NULL, NULL, NULL, NULL, 'CXXC-TYPE ZINC FINGER PROTEIN 1', 242263),
(329130, 'PTHR46174:SF6', NULL, NULL, NULL, NULL, 'METHYL-CPG BINDING DOMAIN PROTEIN 1', 242263),
(329131, 'PTHR46174:SF5', NULL, NULL, NULL, NULL, 'CXXC-TYPE ZINC FINGER PROTEIN 1', 242263),
(329132, 'PTHR46174:SF4', NULL, NULL, NULL, NULL, 'CXXC-TYPE ZINC FINGER PROTEIN 1', 242263),
(329133, 'PTHR46174:SF3', NULL, NULL, NULL, NULL, 'CXXC-TYPE ZINC FINGER PROTEIN 1', 242263),
(329134, 'PTHR46174:SF1', NULL, NULL, NULL, NULL, 'AT26187P-RELATED', 242263),
(329135, 'PTHR17605:SF0', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS PROTEIN BOP1', 242264),
(329136, 'PTHR17605', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS PROTEIN BOP1  BLOCK OF PROLIFERATION 1 PROTEIN', 242264),
(329137, 'PTHR10880:SF50', NULL, NULL, NULL, NULL, 'MRG DOMAIN-CONTAINING PROTEIN', 242265),
(329138, 'PTHR10880:SF29', NULL, NULL, NULL, NULL, 'MORTALITY FACTOR 4-LIKE PROTEIN 1', 242265),
(329139, 'PTHR10880:SF49', NULL, NULL, NULL, NULL, 'C.ELEGANS CHROMODOMAIN PROTEIN', 242265),
(329140, 'PTHR10880:SF48', NULL, NULL, NULL, NULL, 'MRG DOMAIN-CONTAINING PROTEIN', 242265),
(329141, 'PTHR10880:SF37', NULL, NULL, NULL, NULL, 'MALE-SPECIFIC LETHAL-3 PROTEIN-LIKE 2-RELATED', 242265),
(329142, 'PTHR10880:SF15', NULL, NULL, NULL, NULL, 'MRG DOMAIN-CONTAINING PROTEIN', 242265),
(329143, 'PTHR10880:SF47', NULL, NULL, NULL, NULL, 'MALE-SPECIFIC LETHAL 3 HOMOLOG', 242265),
(329144, 'PTHR10880:SF25', NULL, NULL, NULL, NULL, 'MORTALITY FACTOR 4-LIKE PROTEIN 2', 242265),
(329145, 'PTHR10880:SF36', NULL, NULL, NULL, NULL, 'MALE-SPECIFIC LETHAL 3 HOMOLOG', 242265),
(329146, 'PTHR10880:SF46', NULL, NULL, NULL, NULL, 'MSL3-LIKE 2', 242265),
(329147, 'PTHR10880:SF44', NULL, NULL, NULL, NULL, 'PROTEIN MRG2', 242265),
(329148, 'PTHR10880', NULL, NULL, NULL, NULL, 'MORTALITY FACTOR 4-LIKE PROTEIN', 242265),
(329149, 'PTHR37882:SF1', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC690352', 242266),
(329150, 'PTHR37882', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC690352', 242266),
(329151, 'PTHR11449:SF28', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L30', 242267),
(329152, 'PTHR11449:SF29', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L30E-RELATED', 242267),
(329153, 'PTHR11449', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L30', 242267),
(329154, 'PTHR11449:SF1', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L30', 242267),
(329155, 'PTHR11449:SF20', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L30-2', 242267),
(329156, 'PTHR11449:SF10', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L30', 242267),
(329157, 'PTHR11449:SF21', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L7AE DOMAIN-CONTAINING PROTEIN', 242267),
(329158, 'PTHR11449:SF15', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L30-LIKE', 242267),
(329159, 'PTHR11449:SF27', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L30', 242267),
(329160, 'PTHR11449:SF14', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L30-2', 242267),
(329161, 'PTHR11449:SF25', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L30', 242267),
(329162, 'PTHR12384:SF2', NULL, NULL, NULL, NULL, 'MATERNAL PROTEIN EXUPERANTIA', 242268),
(329163, 'PTHR12384', NULL, NULL, NULL, NULL, 'MATERNAL PROTEIN EXUPERANTIA', 242268),
(329164, 'PTHR39226:SF1', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1700013G24 GENE', 242269),
(329165, 'PTHR39226', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1700013G24 GENE', 242269),
(329166, 'PTHR10073', NULL, NULL, NULL, NULL, 'DNA MISMATCH REPAIR PROTEIN  MLH, PMS, MUTL', 242270),
(329167, 'PTHR10073:SF47', NULL, NULL, NULL, NULL, 'DNA MISMATCH REPAIR PROTEIN MLH3', 242270); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(329168, 'PTHR10073:SF44', NULL, NULL, NULL, NULL, 'DNA MISMATCH REPAIR PROTEIN MLH2', 242270),
(329169, 'PTHR10073:SF12', NULL, NULL, NULL, NULL, 'DNA MISMATCH REPAIR PROTEIN MLH1', 242270),
(329170, 'PTHR10073:SF54', NULL, NULL, NULL, NULL, 'PMS1 PROTEIN HOMOLOG 1', 242270),
(329171, 'PTHR10073:SF52', NULL, NULL, NULL, NULL, 'MISMATCH REPAIR ENDONUCLEASE PMS2', 242270),
(329172, 'PTHR10073:SF41', NULL, NULL, NULL, NULL, 'MISMATCH REPAIR PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G05820)-RELATED', 242270),
(329173, 'PTHR13349', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 242271),
(329174, 'PTHR13349:SF2', NULL, NULL, NULL, NULL, 'TRANSLATION MACHINERY-ASSOCIATED PROTEIN 16', 242271),
(329175, 'PTHR11394:SF60', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 102', 242272),
(329176, 'PTHR11394:SF61', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 117', 242272),
(329177, 'PTHR11394:SF127', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 43', 242272),
(329178, 'PTHR11394:SF8', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 5', 242272),
(329179, 'PTHR11394:SF63', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 10', 242272),
(329180, 'PTHR11394:SF129', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 31', 242272),
(329181, 'PTHR11394:SF128', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2-RELATED', 242272),
(329182, 'PTHR11394:SF66', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 46', 242272),
(329183, 'PTHR11394:SF23', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 14', 242272),
(329184, 'PTHR11394:SF68', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 16', 242272),
(329185, 'PTHR11394:SF69', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 134', 242272),
(329186, 'PTHR11394:SF25', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 109', 242272),
(329187, 'PTHR11394:SF27', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 20', 242272),
(329188, 'PTHR11394:SF28', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 13', 242272),
(329189, 'PTHR11394:SF29', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 9', 242272),
(329190, 'PTHR11394', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2', 242272),
(329191, 'PTHR11394:SF50', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 114', 242272),
(329192, 'PTHR11394:SF51', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 116', 242272),
(329193, 'PTHR11394:SF52', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 38', 242272),
(329194, 'PTHR11394:SF55', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 4', 242272),
(329195, 'PTHR11394:SF57', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2', 242272),
(329196, 'PTHR11394:SF58', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 7', 242272),
(329197, 'PTHR11394:SF141', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 242272),
(329198, 'PTHR11394:SF140', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 106', 242272),
(329199, 'PTHR11394:SF142', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 39', 242272),
(329200, 'PTHR11394:SF80', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 123', 242272),
(329201, 'PTHR11394:SF81', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 136', 242272),
(329202, 'PTHR11394:SF42', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 113', 242272),
(329203, 'PTHR11394:SF43', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 50', 242272),
(329204, 'PTHR11394:SF47', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 1-RELATED', 242272),
(329205, 'PTHR11394:SF48', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 30', 242272),
(329206, 'PTHR11394:SF49', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 3', 242272),
(329207, 'PTHR11394:SF132', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 105', 242272),
(329208, 'PTHR11394:SF134', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 45', 242272),
(329209, 'PTHR11394:SF70', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 42', 242272),
(329210, 'PTHR11394:SF71', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 143', 242272);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(329211, 'PTHR11394:SF138', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2', 242272),
(329212, 'PTHR11394:SF72', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR CLASS A-LIKE PROTEIN 4', 242272),
(329213, 'PTHR11394:SF73', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 41', 242272),
(329214, 'PTHR11394:SF137', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN-RELATED', 242272),
(329215, 'PTHR11394:SF30', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 104', 242272),
(329216, 'PTHR11394:SF31', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 8', 242272),
(329217, 'PTHR11394:SF139', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 19-RELATED', 242272),
(329218, 'PTHR11394:SF75', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 103', 242272),
(329219, 'PTHR11394:SF76', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2', 242272),
(329220, 'PTHR11394:SF32', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 60', 242272),
(329221, 'PTHR11394:SF33', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 124', 242272),
(329222, 'PTHR11394:SF34', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 129', 242272),
(329223, 'PTHR11394:SF78', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2', 242272),
(329224, 'PTHR11394:SF37', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2 MEMBER 110', 242272),
(329225, 'PTHR32295:SF190', NULL, NULL, NULL, NULL, 'DUF4005 DOMAIN-CONTAINING PROTEIN', 242273),
(329226, 'PTHR32295:SF222', NULL, NULL, NULL, NULL, 'IQ-DOMAIN 30-RELATED', 242273),
(329227, 'PTHR32295:SF188', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 14-LIKE', 242273),
(329228, 'PTHR32295:SF100', NULL, NULL, NULL, NULL, 'IQ-DOMAIN 3', 242273),
(329229, 'PTHR32295:SF221', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 29', 242273),
(329230, 'PTHR32295:SF185', NULL, NULL, NULL, NULL, 'IQ MOTIF, EF-HAND BINDING SITE-RELATED', 242273),
(329231, 'PTHR32295', NULL, NULL, NULL, NULL, 'IQ-DOMAIN 5-RELATED', 242273),
(329232, 'PTHR32295:SF109', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 1-LIKE', 242273),
(329233, 'PTHR32295:SF228', NULL, NULL, NULL, NULL, 'IQ MOTIF, EF-HAND BINDING SITE-RELATED', 242273),
(329234, 'PTHR32295:SF108', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 20', 242273),
(329235, 'PTHR32295:SF227', NULL, NULL, NULL, NULL, 'DUF4005 DOMAIN-CONTAINING PROTEIN', 242273),
(329236, 'PTHR32295:SF104', NULL, NULL, NULL, NULL, 'OS01G0833800 PROTEIN', 242273),
(329237, 'PTHR32295:SF233', NULL, NULL, NULL, NULL, 'IQ CALMODULIN-BINDING MOTIF PROTEIN', 242273),
(329238, 'PTHR32295:SF112', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 14-LIKE', 242273),
(329239, 'PTHR32295:SF113', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 14', 242273),
(329240, 'PTHR32295:SF198', NULL, NULL, NULL, NULL, 'DUF4005 DOMAIN-CONTAINING PROTEIN', 242273),
(329241, 'PTHR32295:SF110', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 14-LIKE', 242273),
(329242, 'PTHR32295:SF199', NULL, NULL, NULL, NULL, 'IQ-DOMAIN 26-RELATED', 242273),
(329243, 'PTHR32295:SF232', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 13', 242273),
(329244, 'PTHR32295:SF230', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 16', 242273),
(329245, 'PTHR32295:SF197', NULL, NULL, NULL, NULL, 'BNAA05G09740D PROTEIN', 242273),
(329246, 'PTHR32295:SF239', NULL, NULL, NULL, NULL, 'IQ CALMODULIN-BINDING MOTIF PROTEIN', 242273),
(329247, 'PTHR32295:SF116', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 1-LIKE', 242273),
(329248, 'PTHR32295:SF10', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 26', 242273),
(329249, 'PTHR32295:SF97', NULL, NULL, NULL, NULL, 'OS01G0708700 PROTEIN', 242273),
(329250, 'PTHR32295:SF95', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 6', 242273),
(329251, 'PTHR32295:SF99', NULL, NULL, NULL, NULL, 'IQ CALMODULIN-BINDING MOTIF FAMILY PROTEIN, EXPRESSED', 242273),
(329252, 'PTHR32295:SF11', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 22', 242273),
(329253, 'PTHR32295:SF93', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 9', 242273),
(329254, 'PTHR32295:SF168', NULL, NULL, NULL, NULL, 'IQ MOTIF, EF-HAND BINDING SITE-RELATED', 242273),
(329255, 'PTHR32295:SF165', NULL, NULL, NULL, NULL, 'BNACNNG33700D PROTEIN', 242273);
INSERT INTO "PUBLIC"."MODEL" VALUES
(329256, 'PTHR32295:SF166', NULL, NULL, NULL, NULL, 'BNAC03G35860D PROTEIN', 242273),
(329257, 'PTHR32295:SF284', NULL, NULL, NULL, NULL, 'IQ MOTIF, EF-HAND BINDING SITE-RELATED', 242273),
(329258, 'PTHR32295:SF163', NULL, NULL, NULL, NULL, 'DUF4005 DOMAIN-CONTAINING PROTEIN', 242273),
(329259, 'PTHR32295:SF285', NULL, NULL, NULL, NULL, 'OS10G0420200 PROTEIN', 242273),
(329260, 'PTHR32295:SF282', NULL, NULL, NULL, NULL, 'IQ CALMODULIN-BINDING MOTIF PROTEIN', 242273),
(329261, 'PTHR32295:SF283', NULL, NULL, NULL, NULL, 'BNAC02G03410D PROTEIN', 242273),
(329262, 'PTHR32295:SF208', NULL, NULL, NULL, NULL, 'IQ CALMODULIN-BINDING MOTIF PROTEIN', 242273),
(329263, 'PTHR32295:SF206', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 1-LIKE', 242273),
(329264, 'PTHR32295:SF15', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 33', 242273),
(329265, 'PTHR32295:SF205', NULL, NULL, NULL, NULL, 'DUF4005 DOMAIN-CONTAINING PROTEIN', 242273),
(329266, 'PTHR32295:SF169', NULL, NULL, NULL, NULL, 'DUF4005 DOMAIN-CONTAINING PROTEIN', 242273),
(329267, 'PTHR32295:SF203', NULL, NULL, NULL, NULL, 'IQ-DOMAIN 15-RELATED', 242273),
(329268, 'PTHR32295:SF23', NULL, NULL, NULL, NULL, 'IQ CALMODULIN-BINDING MOTIF FAMILY PROTEIN, EXPRESSED', 242273),
(329269, 'PTHR32295:SF22', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 25', 242273),
(329270, 'PTHR32295:SF182', NULL, NULL, NULL, NULL, 'DUF4005 DOMAIN-CONTAINING PROTEIN', 242273),
(329271, 'PTHR32295:SF180', NULL, NULL, NULL, NULL, 'DUF4005 DOMAIN-CONTAINING PROTEIN', 242273),
(329272, 'PTHR32295:SF212', NULL, NULL, NULL, NULL, 'CALMODULIN BINDING PROTEIN-RELATED', 242273),
(329273, 'PTHR32295:SF179', NULL, NULL, NULL, NULL, 'OS06G0341800 PROTEIN', 242273),
(329274, 'PTHR32295:SF176', NULL, NULL, NULL, NULL, 'DUF4005 DOMAIN-CONTAINING PROTEIN', 242273),
(329275, 'PTHR32295:SF174', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 23', 242273),
(329276, 'PTHR32295:SF175', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 2', 242273),
(329277, 'PTHR32295:SF173', NULL, NULL, NULL, NULL, 'DUF4005 DOMAIN-CONTAINING PROTEIN', 242273),
(329278, 'PTHR32295:SF217', NULL, NULL, NULL, NULL, 'IQ MOTIF, EF-HAND BINDING SITE-RELATED', 242273),
(329279, 'PTHR32295:SF215', NULL, NULL, NULL, NULL, 'DUF4005 DOMAIN-CONTAINING PROTEIN', 242273),
(329280, 'PTHR32295:SF216', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 3', 242273),
(329281, 'PTHR32295:SF214', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 4', 242273),
(329282, 'PTHR32295:SF31', NULL, NULL, NULL, NULL, 'IQ CALMODULIN-BINDING MOTIF FAMILY PROTEIN, EXPRESSED', 242273),
(329283, 'PTHR32295:SF34', NULL, NULL, NULL, NULL, 'OS05G0541100 PROTEIN', 242273),
(329284, 'PTHR32295:SF33', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 21', 242273),
(329285, 'PTHR32295:SF270', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 31', 242273),
(329286, 'PTHR32295:SF266', NULL, NULL, NULL, NULL, 'OS01G0716200 PROTEIN', 242273),
(329287, 'PTHR32295:SF267', NULL, NULL, NULL, NULL, 'IQ MOTIF, EF-HAND BINDING SITE-RELATED', 242273),
(329288, 'PTHR32295:SF264', NULL, NULL, NULL, NULL, 'IQ MOTIF, EF-HAND BINDING SITE, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 242273),
(329289, 'PTHR32295:SF143', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 7', 242273),
(329290, 'PTHR32295:SF265', NULL, NULL, NULL, NULL, 'IQ MOTIF, EF-HAND BINDING SITE-RELATED', 242273),
(329291, 'PTHR32295:SF262', NULL, NULL, NULL, NULL, 'OS05G0187500 PROTEIN', 242273),
(329292, 'PTHR32295:SF141', NULL, NULL, NULL, NULL, 'IQ-DOMAIN 19', 242273),
(329293, 'PTHR32295:SF263', NULL, NULL, NULL, NULL, 'DUF4005 DOMAIN-CONTAINING PROTEIN', 242273),
(329294, 'PTHR32295:SF260', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN', 242273),
(329295, 'PTHR32295:SF261', NULL, NULL, NULL, NULL, 'DUF4005 DOMAIN-CONTAINING PROTEIN', 242273),
(329296, 'PTHR32295:SF149', NULL, NULL, NULL, NULL, 'IQ CALMODULIN-BINDING MOTIF PROTEIN', 242273),
(329297, 'PTHR32295:SF268', NULL, NULL, NULL, NULL, 'IQ MOTIF, EF-HAND BINDING SITE-RELATED', 242273),
(329298, 'PTHR32295:SF269', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 28', 242273);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(329299, 'PTHR32295:SF41', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 11', 242273),
(329300, 'PTHR32295:SF45', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 19', 242273),
(329301, 'PTHR32295:SF280', NULL, NULL, NULL, NULL, 'DUF4005 DOMAIN-CONTAINING PROTEIN', 242273),
(329302, 'PTHR32295:SF160', NULL, NULL, NULL, NULL, 'IQ MOTIF, EF-HAND BINDING SITE-RELATED', 242273),
(329303, 'PTHR32295:SF281', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 30', 242273),
(329304, 'PTHR32295:SF277', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 17', 242273),
(329305, 'PTHR32295:SF278', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 24', 242273),
(329306, 'PTHR32295:SF275', NULL, NULL, NULL, NULL, 'IQ CALMODULIN-BINDING MOTIF PROTEIN', 242273),
(329307, 'PTHR32295:SF154', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 32', 242273),
(329308, 'PTHR32295:SF276', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 14-LIKE', 242273),
(329309, 'PTHR32295:SF273', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 31-LIKE', 242273),
(329310, 'PTHR32295:SF274', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 1-LIKE', 242273),
(329311, 'PTHR32295:SF153', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 27', 242273),
(329312, 'PTHR32295:SF150', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 1', 242273),
(329313, 'PTHR32295:SF271', NULL, NULL, NULL, NULL, 'BNAA05G17440D PROTEIN', 242273),
(329314, 'PTHR32295:SF272', NULL, NULL, NULL, NULL, 'DUF4005 DOMAIN-CONTAINING PROTEIN', 242273),
(329315, 'PTHR32295:SF151', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 1-LIKE', 242273),
(329316, 'PTHR32295:SF279', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 31-LIKE', 242273),
(329317, 'PTHR32295:SF123', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 5', 242273),
(329318, 'PTHR32295:SF244', NULL, NULL, NULL, NULL, 'DUF4005 DOMAIN-CONTAINING PROTEIN', 242273),
(329319, 'PTHR32295:SF245', NULL, NULL, NULL, NULL, 'IQ CALMODULIN-BINDING MOTIF PROTEIN', 242273),
(329320, 'PTHR32295:SF121', NULL, NULL, NULL, NULL, 'DUF4005 DOMAIN-CONTAINING PROTEIN', 242273),
(329321, 'PTHR32295:SF122', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 15', 242273),
(329322, 'PTHR32295:SF126', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 8', 242273),
(329323, 'PTHR32295:SF134', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 10', 242273),
(329324, 'PTHR32295:SF255', NULL, NULL, NULL, NULL, 'DUF4005 DOMAIN-CONTAINING PROTEIN', 242273),
(329325, 'PTHR32295:SF256', NULL, NULL, NULL, NULL, 'DUF4005 DOMAIN-CONTAINING PROTEIN', 242273),
(329326, 'PTHR32295:SF253', NULL, NULL, NULL, NULL, 'DUF4005 DOMAIN-CONTAINING PROTEIN', 242273),
(329327, 'PTHR32295:SF133', NULL, NULL, NULL, NULL, 'DUF4005 DOMAIN-CONTAINING PROTEIN', 242273),
(329328, 'PTHR32295:SF254', NULL, NULL, NULL, NULL, 'OS01G0743100 PROTEIN', 242273),
(329329, 'PTHR32295:SF131', NULL, NULL, NULL, NULL, 'OS05G0521900 PROTEIN', 242273),
(329330, 'PTHR32295:SF250', NULL, NULL, NULL, NULL, 'IQ MOTIF, EF-HAND BINDING SITE-RELATED', 242273),
(329331, 'PTHR32295:SF6', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 18', 242273),
(329332, 'PTHR32295:SF259', NULL, NULL, NULL, NULL, 'IQ MOTIF, EF-HAND BINDING SITE, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 242273),
(329333, 'PTHR32295:SF138', NULL, NULL, NULL, NULL, 'DUF4005 DOMAIN-CONTAINING PROTEIN', 242273),
(329334, 'PTHR32295:SF139', NULL, NULL, NULL, NULL, 'IQ CALMODULIN-BINDING MOTIF PROTEIN', 242273),
(329335, 'PTHR32295:SF257', NULL, NULL, NULL, NULL, 'DUF4005 DOMAIN-CONTAINING PROTEIN', 242273),
(329336, 'PTHR32295:SF258', NULL, NULL, NULL, NULL, 'PROTEIN IQ-DOMAIN 1-LIKE', 242273),
(329337, 'PTHR34003:SF2', NULL, NULL, NULL, NULL, 'SNOAL-LIKE DOMAIN-CONTAINING PROTEIN', 242274),
(329338, 'PTHR34003', NULL, NULL, NULL, NULL, 'BLL2395 PROTEIN', 242274),
(329339, 'PTHR47593:SF3', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242275),
(329340, 'PTHR47593:SF4', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 7-LIKE', 242275),
(329341, 'PTHR47593:SF5', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 7-LIKE', 242275),
(329342, 'PTHR47593', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 4-LIKE', 242275);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(329343, 'PTHR47593:SF8', NULL, NULL, NULL, NULL, 'OS12G0581900 PROTEIN', 242275),
(329344, 'PTHR47593:SF9', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242275),
(329345, 'PTHR45837:SF10', NULL, NULL, NULL, NULL, 'BNAA09G47480D PROTEIN', 242276),
(329346, 'PTHR45837:SF3', NULL, NULL, NULL, NULL, 'VESICLE-TRAFFICKING PROTEIN SEC22B', 242276),
(329347, 'PTHR45837', NULL, NULL, NULL, NULL, 'VESICLE-TRAFFICKING PROTEIN SEC22B', 242276),
(329348, 'PTHR45837:SF5', NULL, NULL, NULL, NULL, '25.3 KDA VESICLE TRANSPORT PROTEIN', 242276),
(329349, 'PTHR45837:SF6', NULL, NULL, NULL, NULL, '25.3 KDA VESICLE TRANSPORT PROTEIN-LIKE', 242276),
(329350, 'PTHR45837:SF7', NULL, NULL, NULL, NULL, 'SNARE-LIKE SUPERFAMILY PROTEIN', 242276),
(329351, 'PTHR45837:SF8', NULL, NULL, NULL, NULL, '25.3 KDA VESICLE TRANSPORT PROTEIN', 242276),
(329352, 'PTHR45837:SF9', NULL, NULL, NULL, NULL, 'BNAC05G09870D PROTEIN', 242276),
(329353, 'PTHR45837:SF11', NULL, NULL, NULL, NULL, '', 242276),
(329354, 'PTHR37877:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL COILED-COIL DOMAIN PROTEIN 1', 242277),
(329355, 'PTHR37877', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL COILED-COIL DOMAIN PROTEIN 1', 242277),
(329356, 'PTHR19923', NULL, NULL, NULL, NULL, 'WD40 REPEAT PROTEINPRL1/PRL2-RELATED', 242278),
(329357, 'PTHR19923:SF0', NULL, NULL, NULL, NULL, 'PLEIOTROPIC REGULATOR 1', 242278),
(329358, 'PTHR19923:SF1', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 242278),
(329359, 'PTHR45628:SF30', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL PROTEIN TYPE 1 SUBUNIT ALPHA', 242279),
(329360, 'PTHR45628', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL TYPE A SUBUNIT ALPHA-1', 242279),
(329361, 'PTHR45628:SF32', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL PROTEIN TYPE 10 SUBUNIT ALPHA', 242279),
(329362, 'PTHR45628:SF10', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT L-TYPE CALCIUM CHANNEL SUBUNIT ALPHA-1C', 242279),
(329363, 'PTHR45628:SF21', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL PROTEIN TYPE 7 SUBUNIT ALPHA-RELATED', 242279),
(329364, 'PTHR45628:SF31', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT T-TYPE CALCIUM CHANNEL SUBUNIT ALPHA-1H', 242279),
(329365, 'PTHR45628:SF20', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL PROTEIN TYPE 4 SUBUNIT ALPHA', 242279),
(329366, 'PTHR45628:SF9', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT L-TYPE CALCIUM CHANNEL SUBUNIT ALPHA-1S', 242279),
(329367, 'PTHR45628:SF23', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT N-TYPE CALCIUM CHANNEL SUBUNIT ALPHA', 242279),
(329368, 'PTHR45628:SF5', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT R-TYPE CALCIUM CHANNEL SUBUNIT ALPHA-1E', 242279),
(329369, 'PTHR45628:SF22', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT T-TYPE CALCIUM CHANNEL SUBUNIT ALPHA', 242279),
(329370, 'PTHR45628:SF11', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT L-TYPE CALCIUM CHANNEL SUBUNIT ALPHA-1D', 242279),
(329371, 'PTHR45628:SF7', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL TYPE A SUBUNIT ALPHA-1', 242279),
(329372, 'PTHR45628:SF25', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT T-TYPE CALCIUM CHANNEL SUBUNIT ALPHA-1G', 242279),
(329373, 'PTHR45628:SF24', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT T-TYPE CALCIUM CHANNEL SUBUNIT ALPHA-1I', 242279),
(329374, 'PTHR45628:SF6', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT N-TYPE CALCIUM CHANNEL SUBUNIT ALPHA-1B', 242279),
(329375, 'PTHR45628:SF1', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL TYPE D SUBUNIT ALPHA-1', 242279),
(329376, 'PTHR45628:SF27', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL PROTEIN', 242279),
(329377, 'PTHR45628:SF26', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL PROTEIN TYPE 2 SUBUNIT ALPHA-RELATED', 242279),
(329378, 'PTHR45628:SF29', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL PROTEIN TYPE 8 SUBUNIT ALPHA', 242279),
(329379, 'PTHR45628:SF3', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT P/Q-TYPE CALCIUM CHANNEL SUBUNIT ALPHA-1A', 242279),
(329380, 'PTHR45628:SF18', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL PROTEIN TYPE 5 SUBUNIT ALPHA', 242279),
(329381, 'PTHR45628:SF28', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL PROTEIN TYPE 11 SUBUNIT ALPHA', 242279);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(329382, 'PTHR45628:SF2', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT L-TYPE CALCIUM CHANNEL SUBUNIT ALPHA-1F', 242279),
(329383, 'PTHR10537', NULL, NULL, NULL, NULL, 'DNA PRIMASE LARGE SUBUNIT', 242280),
(329384, 'PTHR10537:SF3', NULL, NULL, NULL, NULL, 'DNA PRIMASE LARGE SUBUNIT', 242280),
(329385, 'PTHR10537:SF4', NULL, NULL, NULL, NULL, '', 242280),
(329386, 'PTHR10537:SF6', NULL, NULL, NULL, NULL, 'DNA PRIMASE LARGE SUBUNIT', 242280),
(329387, 'PTHR34361:SF11', NULL, NULL, NULL, NULL, '', 242281),
(329388, 'PTHR34361:SF2', NULL, NULL, NULL, NULL, 'OS08G0157800 PROTEIN', 242281),
(329389, 'PTHR34361:SF10', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242281),
(329390, 'PTHR34361', NULL, NULL, NULL, NULL, 'OS08G0157800 PROTEIN', 242281),
(329391, 'PTHR34361:SF6', NULL, NULL, NULL, NULL, 'BNAA08G06710D PROTEIN', 242281),
(329392, 'PTHR34361:SF8', NULL, NULL, NULL, NULL, 'BNAA06G15880D PROTEIN', 242281),
(329393, 'PTHR21327', NULL, NULL, NULL, NULL, 'GTP CYCLOHYDROLASE II-RELATED', 242282),
(329394, 'PTHR21327:SF41', NULL, NULL, NULL, NULL, 'MONOFUNCTIONAL RIBOFLAVIN BIOSYNTHESIS PROTEIN RIBA 2, CHLOROPLASTIC', 242282),
(329395, 'PTHR21327:SF39', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL RIBOFLAVIN BIOSYNTHESIS PROTEIN RIBA 1, CHLOROPLASTIC-RELATED', 242282),
(329396, 'PTHR21327:SF18', NULL, NULL, NULL, NULL, '3,4-DIHYDROXY-2-BUTANONE 4-PHOSPHATE SYNTHASE', 242282),
(329397, 'PTHR21327:SF29', NULL, NULL, NULL, NULL, 'GTP CYCLOHYDROLASE-2', 242282),
(329398, 'PTHR21327:SF46', NULL, NULL, NULL, NULL, '3,4-DIHYDROXY-2-BUTANONE 4-PHOSPHATE SYNTHASE', 242282),
(329399, 'PTHR21327:SF47', NULL, NULL, NULL, NULL, 'GTP_CYCLOHYDRO2 DOMAIN-CONTAINING PROTEIN', 242282),
(329400, 'PTHR21327:SF37', NULL, NULL, NULL, NULL, 'GTP CYCLOHYDROLASE II', 242282),
(329401, 'PTHR21327:SF38', NULL, NULL, NULL, NULL, '3,4-DIHYDROXY-2-BUTANONE 4-PHOSPHATE SYNTHASE', 242282),
(329402, 'PTHR21327:SF42', NULL, NULL, NULL, NULL, 'GTP CYCLOHYDROLASE II', 242282),
(329403, 'PTHR21327:SF34', NULL, NULL, NULL, NULL, '3,4-DIHYDROXY-2-BUTANONE 4-PHOSPHATE SYNTHASE', 242282),
(329404, 'PTHR10459:SF108', NULL, NULL, NULL, NULL, 'POLY [ADP-RIBOSE] POLYMERASE TANKYRASE', 242283),
(329405, 'PTHR10459:SF116', NULL, NULL, NULL, NULL, 'POLY [ADP-RIBOSE] POLYMERASE', 242283),
(329406, 'PTHR10459:SF106', NULL, NULL, NULL, NULL, 'PROTEIN ADP-RIBOSYLTRANSFERASE PARP3', 242283),
(329407, 'PTHR10459:SF115', NULL, NULL, NULL, NULL, 'POLY [ADP-RIBOSE] POLYMERASE', 242283),
(329408, 'PTHR10459:SF104', NULL, NULL, NULL, NULL, 'POLY [ADP-RIBOSE] POLYMERASE', 242283),
(329409, 'PTHR10459:SF112', NULL, NULL, NULL, NULL, 'POLY [ADP-RIBOSE] POLYMERASE 1', 242283),
(329410, 'PTHR10459:SF113', NULL, NULL, NULL, NULL, 'POLY [ADP-RIBOSE] POLYMERASE 2', 242283),
(329411, 'PTHR10459:SF43', NULL, NULL, NULL, NULL, 'POLY [ADP-RIBOSE] POLYMERASE', 242283),
(329412, 'PTHR10459:SF109', NULL, NULL, NULL, NULL, 'POLY [ADP-RIBOSE] POLYMERASE', 242283),
(329413, 'PTHR10459:SF66', NULL, NULL, NULL, NULL, 'PROTEIN MONO-ADP-RIBOSYLTRANSFERASE PARP3', 242283),
(329414, 'PTHR10459:SF60', NULL, NULL, NULL, NULL, 'POLY [ADP-RIBOSE] POLYMERASE 2', 242283),
(329415, 'PTHR10459:SF73', NULL, NULL, NULL, NULL, 'POLY [ADP-RIBOSE] POLYMERASE', 242283),
(329416, 'PTHR10459:SF80', NULL, NULL, NULL, NULL, 'POLY [ADP-RIBOSE] POLYMERASE 1', 242283),
(329417, 'PTHR10459', NULL, NULL, NULL, NULL, 'DNA LIGASE', 242283),
(329418, 'PTHR10459:SF111', NULL, NULL, NULL, NULL, 'POLY [ADP-RIBOSE] POLYMERASE', 242283),
(329419, 'PTHR12369:SF5', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 242284),
(329420, 'PTHR12369:SF15', NULL, NULL, NULL, NULL, 'BETA-1,4-N-ACETYLGALACTOSAMINYLTRANSFERASE 3', 242284),
(329421, 'PTHR12369:SF46', NULL, NULL, NULL, NULL, 'N-ACETYL-BETA-GLUCOSAMINYL-GLYCOPROTEIN 4-BETA-N-ACETYLGALACTOSAMINYLTRANSFERASE 1', 242284),
(329422, 'PTHR12369:SF13', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 242284),
(329423, 'PTHR12369:SF14', NULL, NULL, NULL, NULL, 'CHONDROITIN SULFATE GLUCURONYLTRANSFERASE', 242284),
(329424, 'PTHR12369:SF19', NULL, NULL, NULL, NULL, 'CHONDROITIN SULFATE N-ACETYLGALACTOSAMINYLTRANSFERASE 1', 242284);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(329425, 'PTHR12369:SF17', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 242284),
(329426, 'PTHR12369:SF40', NULL, NULL, NULL, NULL, 'CHONDROITIN SULFATE SYNTHASE 3', 242284),
(329427, 'PTHR12369', NULL, NULL, NULL, NULL, 'CHONDROITIN SYNTHASE', 242284),
(329428, 'PTHR12369:SF11', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 242284),
(329429, 'PTHR12369:SF22', NULL, NULL, NULL, NULL, 'CHONDROITIN SULFATE SYNTHASE 2', 242284),
(329430, 'PTHR12369:SF45', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 242284),
(329431, 'PTHR12369:SF20', NULL, NULL, NULL, NULL, 'CHONDROITIN SULFATE N-ACETYLGALACTOSAMINYLTRANSFERASE 2', 242284),
(329432, 'PTHR12369:SF42', NULL, NULL, NULL, NULL, 'CHONDROITIN SULFATE SYNTHASE 1', 242284),
(329433, 'PTHR28021:SF1', NULL, NULL, NULL, NULL, 'PRESEQUENCE TRANSLOCATED-ASSOCIATED MOTOR SUBUNIT PAM17, MITOCHONDRIAL', 242285),
(329434, 'PTHR28021', NULL, NULL, NULL, NULL, 'PRESEQUENCE TRANSLOCATED-ASSOCIATED MOTOR SUBUNIT PAM17, MITOCHONDRIAL', 242285),
(329435, 'PTHR16967:SF1', NULL, NULL, NULL, NULL, 'LEYDIG CELL TUMOR 10 KDA PROTEIN HOMOLOG', 242286),
(329436, 'PTHR16967', NULL, NULL, NULL, NULL, 'LEYDIG CELL TUMOR 10 KDA PROTEIN HOMOLOG', 242286),
(329437, 'PTHR13329:SF2', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S18B, MITOCHONDRIAL', 242287),
(329438, 'PTHR13329', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOMAL PROTEIN S18B', 242287),
(329439, 'PTHR21297:SF4', NULL, NULL, NULL, NULL, 'RPOL4C DOMAIN-CONTAINING PROTEIN', 242288),
(329440, 'PTHR21297:SF2', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASES IV AND V SUBUNIT 4', 242288),
(329441, 'PTHR21297:SF3', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE II SUBUNIT 4-LIKE', 242288),
(329442, 'PTHR21297', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE II', 242288),
(329443, 'PTHR21297:SF0', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE II SUBUNIT RPB4', 242288),
(329444, 'PTHR42689:SF1', NULL, NULL, NULL, NULL, 'ACETYL-COA ACYLTRANSFERASE FADA2 (3-KETOACYL-COA THIOLASE) (BETA-KETOTHIOLASE)-RELATED', 242289),
(329445, 'PTHR42689', NULL, NULL, NULL, NULL, 'ACETYL-COA ACYLTRANSFERASE FADA2 (3-KETOACYL-COA THIOLASE) (BETA-KETOTHIOLASE)-RELATED', 242289),
(329446, 'PTHR21254:SF1', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN 3', 242290),
(329447, 'PTHR21254', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 242290),
(329448, 'PTHR33317', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDYL TRANSFERASE, RIBONUCLEASE H-LIKE SUPERFAMILY PROTEIN', 242291),
(329449, 'PTHR33317:SF4', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDYL TRANSFERASE, RIBONUCLEASE H-LIKE SUPERFAMILY PROTEIN', 242291),
(329450, 'PTHR33317:SF1', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDYL TRANSFERASE, RIBONUCLEASE H-LIKE SUPERFAMILY PROTEIN', 242291),
(329451, 'PTHR15004', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 242292),
(329452, 'PTHR15004:SF0', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA(GLN) AMIDOTRANSFERASE SUBUNIT C, MITOCHONDRIAL', 242292),
(329453, 'PTHR15004:SF2', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA(GLN) AMIDOTRANSFERASE SUBUNIT C, CHLOROPLASTIC/MITOCHONDRIAL', 242292),
(329454, 'PTHR36036:SF3', NULL, NULL, NULL, NULL, 'EXTENSIN-LIKE PROTEIN', 242293),
(329455, 'PTHR36036', NULL, NULL, NULL, NULL, 'PROLINE-RICH FAMILY PROTEIN', 242293),
(329456, 'PTHR36036:SF1', NULL, NULL, NULL, NULL, 'PROLINE-RICH FAMILY PROTEIN', 242293),
(329457, 'PTHR10553:SF2', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN G', 242294),
(329458, 'PTHR10553:SF5', NULL, NULL, NULL, NULL, 'U6 SNRNA-ASSOCIATED SM-LIKE PROTEIN LSM7', 242294),
(329459, 'PTHR10553:SF30', NULL, NULL, NULL, NULL, 'SM DOMAIN-CONTAINING PROTEIN', 242294),
(329460, 'PTHR10553:SF32', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN G', 242294),
(329461, 'PTHR10553:SF23', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN G', 242294),
(329462, 'PTHR10553:SF34', NULL, NULL, NULL, NULL, 'SM DOMAIN-CONTAINING PROTEIN', 242294),
(329463, 'PTHR10553:SF35', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN G', 242294),
(329464, 'PTHR10553:SF36', NULL, NULL, NULL, NULL, 'SM-LIKE PROTEIN LSM7', 242294);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(329465, 'PTHR10553', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN', 242294),
(329466, 'PTHR10553:SF25', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN G', 242294),
(329467, 'PTHR10553:SF26', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN G-RELATED', 242294),
(329468, 'PTHR10553:SF27', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN G', 242294),
(329469, 'PTHR10553:SF16', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN G', 242294),
(329470, 'PTHR31873', NULL, NULL, NULL, NULL, 'L-ASPARTATE DEHYDROGENASE-RELATED', 242295),
(329471, 'PTHR31873:SF6', NULL, NULL, NULL, NULL, 'L-ASPARTATE DEHYDROGENASE-RELATED', 242295),
(329472, 'PTHR48199:SF1', NULL, NULL, NULL, NULL, 'ALPHA KAFIRIN', 242296),
(329473, 'PTHR48199', NULL, NULL, NULL, NULL, 'ALPHA KAFIRIN', 242296),
(329474, 'PTHR48199:SF2', NULL, NULL, NULL, NULL, '', 242296),
(329475, 'PTHR31048:SF203', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242297),
(329476, 'PTHR31048:SF97', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED THAUMATIN SUPERFAMILY PROTEIN', 242297),
(329477, 'PTHR31048:SF126', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED THAUMATIN SUPERFAMILY PROTEIN', 242297),
(329478, 'PTHR31048:SF204', NULL, NULL, NULL, NULL, 'THAUMATIN-LIKE PROTEIN 1B', 242297),
(329479, 'PTHR31048:SF96', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED THAUMATIN FAMILY PROTEIN', 242297),
(329480, 'PTHR31048:SF205', NULL, NULL, NULL, NULL, 'OSMOTIN-LIKE PROTEIN OSM34', 242297),
(329481, 'PTHR31048:SF206', NULL, NULL, NULL, NULL, 'PROTEIN NP24', 242297),
(329482, 'PTHR31048:SF129', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED THAUMATIN SUPERFAMILY PROTEIN', 242297),
(329483, 'PTHR31048:SF99', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED THAUMATIN SUPERFAMILY PROTEIN', 242297),
(329484, 'PTHR31048:SF16', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED THAUMATIN SUPERFAMILY PROTEIN', 242297),
(329485, 'PTHR31048:SF18', NULL, NULL, NULL, NULL, 'OS11G0703000 PROTEIN', 242297),
(329486, 'PTHR31048', NULL, NULL, NULL, NULL, 'OS03G0233200 PROTEIN', 242297),
(329487, 'PTHR31048:SF161', NULL, NULL, NULL, NULL, 'THAUMATIN-RELATED', 242297),
(329488, 'PTHR31048:SF163', NULL, NULL, NULL, NULL, '', 242297),
(329489, 'PTHR31048:SF165', NULL, NULL, NULL, NULL, 'BNAA10G27340D PROTEIN', 242297),
(329490, 'PTHR31048:SF121', NULL, NULL, NULL, NULL, '', 242297),
(329491, 'PTHR31048:SF166', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED THAUMATIN SUPERFAMILY PROTEIN-RELATED', 242297),
(329492, 'PTHR31048:SF123', NULL, NULL, NULL, NULL, '', 242297),
(329493, 'PTHR31048:SF200', NULL, NULL, NULL, NULL, 'THAUMATIN-LIKE PROTEIN 1B', 242297),
(329494, 'PTHR31048:SF167', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED PROTEIN 5', 242297),
(329495, 'PTHR31048:SF168', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242297),
(329496, 'PTHR31048:SF124', NULL, NULL, NULL, NULL, 'OS03G0663400 PROTEIN', 242297),
(329497, 'PTHR31048:SF201', NULL, NULL, NULL, NULL, 'THAUMATIN-LIKE PROTEIN 1B', 242297),
(329498, 'PTHR31048:SF202', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED PROTEIN 5', 242297),
(329499, 'PTHR31048:SF169', NULL, NULL, NULL, NULL, '', 242297),
(329500, 'PTHR31048:SF125', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED THAUMATIN SUPERFAMILY PROTEIN', 242297),
(329501, 'PTHR31048:SF137', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE/TRYPSIN INHIBITOR', 242297),
(329502, 'PTHR31048:SF138', NULL, NULL, NULL, NULL, 'THAUMATIN-LIKE PROTEIN', 242297),
(329503, 'PTHR31048:SF139', NULL, NULL, NULL, NULL, '', 242297),
(329504, 'PTHR31048:SF40', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED THAUMATIN SUPERFAMILY PROTEIN', 242297),
(329505, 'PTHR31048:SF45', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED THAUMATIN SUPERFAMILY PROTEIN', 242297),
(329506, 'PTHR31048:SF44', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED PROTEIN R MINOR FORM', 242297),
(329507, 'PTHR31048:SF87', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED THAUMATIN FAMILY PROTEIN', 242297),
(329508, 'PTHR31048:SF49', NULL, NULL, NULL, NULL, 'THAUMATIN-LIKE PROTEIN 1', 242297);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(329509, 'PTHR31048:SF48', NULL, NULL, NULL, NULL, 'THAUMATIN-LIKE PROTEIN', 242297),
(329510, 'PTHR31048:SF47', NULL, NULL, NULL, NULL, 'PROTEIN P21', 242297),
(329511, 'PTHR31048:SF170', NULL, NULL, NULL, NULL, 'OS09G0536300 PROTEIN', 242297),
(329512, 'PTHR31048:SF171', NULL, NULL, NULL, NULL, 'THAUMATIN-LIKE PROTEIN 1', 242297),
(329513, 'PTHR31048:SF172', NULL, NULL, NULL, NULL, 'THAUMATIN-RELATED', 242297),
(329514, 'PTHR31048:SF173', NULL, NULL, NULL, NULL, '', 242297),
(329515, 'PTHR31048:SF174', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 242297),
(329516, 'PTHR31048:SF131', NULL, NULL, NULL, NULL, 'OS07G0417600 PROTEIN', 242297),
(329517, 'PTHR31048:SF132', NULL, NULL, NULL, NULL, 'PRU PROTEIN, PUTATIVE-RELATED', 242297),
(329518, 'PTHR31048:SF177', NULL, NULL, NULL, NULL, 'OSMOTIN', 242297),
(329519, 'PTHR31048:SF133', NULL, NULL, NULL, NULL, 'OSMOTIN-LIKE PROTEIN', 242297),
(329520, 'PTHR31048:SF178', NULL, NULL, NULL, NULL, 'THAUMATIN-LIKE PROTEIN', 242297),
(329521, 'PTHR31048:SF92', NULL, NULL, NULL, NULL, 'THAUMATIN-LIKE PROTEIN 1', 242297),
(329522, 'PTHR31048:SF134', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED THAUMATIN-LIKE PROTEIN 3.5', 242297),
(329523, 'PTHR31048:SF179', NULL, NULL, NULL, NULL, '', 242297),
(329524, 'PTHR31048:SF90', NULL, NULL, NULL, NULL, 'THAUMATIN-LIKE PROTEIN', 242297),
(329525, 'PTHR31048:SF181', NULL, NULL, NULL, NULL, 'BNACNNG08170D PROTEIN', 242297),
(329526, 'PTHR31048:SF140', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED THAUMATIN SUPERFAMILY PROTEIN', 242297),
(329527, 'PTHR31048:SF186', NULL, NULL, NULL, NULL, 'PATHOGENESIS RELATED PROTEIN5', 242297),
(329528, 'PTHR31048:SF143', NULL, NULL, NULL, NULL, 'BNAA02G17480D PROTEIN', 242297),
(329529, 'PTHR31048:SF144', NULL, NULL, NULL, NULL, 'THAUMATIN-LIKE PROTEIN 1', 242297),
(329530, 'PTHR31048:SF188', NULL, NULL, NULL, NULL, 'OS07G0419300 PROTEIN', 242297),
(329531, 'PTHR31048:SF100', NULL, NULL, NULL, NULL, '', 242297),
(329532, 'PTHR31048:SF145', NULL, NULL, NULL, NULL, 'BNAC06G07910D PROTEIN', 242297),
(329533, 'PTHR31048:SF146', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED THAUMATIN SUPERFAMILY PROTEIN', 242297),
(329534, 'PTHR31048:SF102', NULL, NULL, NULL, NULL, 'THAUMATIN DOMAIN FAMILY PROTEIN-RELATED', 242297),
(329535, 'PTHR31048:SF115', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED THAUMATIN SUPERFAMILY PROTEIN', 242297),
(329536, 'PTHR31048:SF159', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED THAUMATIN SUPERFAMILY PROTEIN', 242297),
(329537, 'PTHR31048:SF116', NULL, NULL, NULL, NULL, 'OSMOTIN-LIKE PROTEIN', 242297),
(329538, 'PTHR31048:SF117', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED THAUMATIN SUPERFAMILY PROTEIN', 242297),
(329539, 'PTHR31048:SF118', NULL, NULL, NULL, NULL, '', 242297),
(329540, 'PTHR31048:SF24', NULL, NULL, NULL, NULL, 'OS12G0568900 PROTEIN', 242297),
(329541, 'PTHR31048:SF1', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED THAUMATIN SUPERFAMILY PROTEIN', 242297),
(329542, 'PTHR31048:SF3', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED THAUMATIN FAMILY PROTEIN', 242297),
(329543, 'PTHR31048:SF26', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED THAUMATIN SUPERFAMILY PROTEIN', 242297),
(329544, 'PTHR31048:SF190', NULL, NULL, NULL, NULL, 'THAUMATIN-LIKE PROTEIN-RELATED', 242297),
(329545, 'PTHR31048:SF191', NULL, NULL, NULL, NULL, 'THAUMATIN-LIKE PROTEIN 1B', 242297),
(329546, 'PTHR31048:SF192', NULL, NULL, NULL, NULL, 'BNAA04G16680D PROTEIN', 242297),
(329547, 'PTHR31048:SF193', NULL, NULL, NULL, NULL, 'THAUMATIN-LIKE PROTEIN 1B', 242297),
(329548, 'PTHR31048:SF150', NULL, NULL, NULL, NULL, 'THAUMATIN-LIKE PROTEIN 1', 242297),
(329549, 'PTHR31048:SF194', NULL, NULL, NULL, NULL, 'OS03G0244200 PROTEIN', 242297),
(329550, 'PTHR31048:SF195', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED PROTEIN 5-LIKE', 242297),
(329551, 'PTHR31048:SF196', NULL, NULL, NULL, NULL, 'OSMOTIN-LIKE PROTEIN OSM34', 242297),
(329552, 'PTHR31048:SF152', NULL, NULL, NULL, NULL, 'BNAA06G13430D PROTEIN', 242297),
(329553, 'PTHR31048:SF197', NULL, NULL, NULL, NULL, 'INHIBITOR, PUTATIVE, EXPRESSED-RELATED', 242297); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(329554, 'PTHR31048:SF198', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED THAUMATIN FAMILY PROTEIN', 242297),
(329555, 'PTHR31048:SF154', NULL, NULL, NULL, NULL, 'THAUMATIN-RELATED', 242297),
(329556, 'PTHR31048:SF8', NULL, NULL, NULL, NULL, 'OS10G0412700 PROTEIN', 242297),
(329557, 'PTHR31048:SF155', NULL, NULL, NULL, NULL, 'BNAANNG19340D PROTEIN', 242297),
(329558, 'PTHR31048:SF111', NULL, NULL, NULL, NULL, 'OS12G0569300 PROTEIN', 242297),
(329559, 'PTHR31048:SF199', NULL, NULL, NULL, NULL, 'BNACNNG42000D PROTEIN', 242297),
(329560, 'PTHR31048:SF112', NULL, NULL, NULL, NULL, '', 242297),
(329561, 'PTHR31048:SF157', NULL, NULL, NULL, NULL, 'OS03G0243900 PROTEIN', 242297),
(329562, 'PTHR31048:SF114', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED THAUMATIN FAMILY PROTEIN', 242297),
(329563, 'PTHR31048:SF158', NULL, NULL, NULL, NULL, 'BNAC05G14950D PROTEIN', 242297),
(329564, 'PTHR35459', NULL, NULL, NULL, NULL, 'T1N6.14 PROTEIN', 242298),
(329565, 'PTHR35459:SF2', NULL, NULL, NULL, NULL, 'T1N6.14 PROTEIN', 242298),
(329566, 'PTHR35459:SF4', NULL, NULL, NULL, NULL, '', 242298),
(329567, 'PTHR35459:SF5', NULL, NULL, NULL, NULL, 'OS02G0664700 PROTEIN', 242298),
(329568, 'PTHR31044:SF119', NULL, NULL, NULL, NULL, 'PLASMODESMATA CALLOSE-BINDING PROTEIN 5', 242299),
(329569, 'PTHR31044:SF60', NULL, NULL, NULL, NULL, 'X8 DOMAIN-CONTAINING PROTEIN', 242299),
(329570, 'PTHR31044:SF61', NULL, NULL, NULL, NULL, 'PLASMODESMATA CALLOSE-BINDING PROTEIN 1', 242299),
(329571, 'PTHR31044:SF62', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242299),
(329572, 'PTHR31044:SF118', NULL, NULL, NULL, NULL, 'X8 DOMAIN-CONTAINING PROTEIN', 242299),
(329573, 'PTHR31044:SF117', NULL, NULL, NULL, NULL, 'OS07G0600700 PROTEIN', 242299),
(329574, 'PTHR31044:SF25', NULL, NULL, NULL, NULL, 'PLASMODESMATA CALLOSE-BINDING PROTEIN 3', 242299),
(329575, 'PTHR31044:SF113', NULL, NULL, NULL, NULL, 'X8 DOMAIN-CONTAINING PROTEIN', 242299),
(329576, 'PTHR31044', NULL, NULL, NULL, NULL, 'BETA-1,3 GLUCANASE', 242299),
(329577, 'PTHR31044:SF112', NULL, NULL, NULL, NULL, 'OS08G0135500 PROTEIN', 242299),
(329578, 'PTHR31044:SF28', NULL, NULL, NULL, NULL, 'CARBOHYDRATE-BINDING X8 DOMAIN SUPERFAMILY PROTEIN', 242299),
(329579, 'PTHR31044:SF111', NULL, NULL, NULL, NULL, 'CARBOHYDRATE-BINDING X8 DOMAIN SUPERFAMILY PROTEIN', 242299),
(329580, 'PTHR31044:SF109', NULL, NULL, NULL, NULL, 'CARBOHYDRATE-BINDING X8 DOMAIN SUPERFAMILY PROTEIN', 242299),
(329581, 'PTHR31044:SF71', NULL, NULL, NULL, NULL, 'MAJOR POLLEN ALLERGEN OLE E 10-LIKE', 242299),
(329582, 'PTHR31044:SF72', NULL, NULL, NULL, NULL, 'MAJOR POLLEN ALLERGEN OLE E-LIKE PROTEIN', 242299),
(329583, 'PTHR31044:SF73', NULL, NULL, NULL, NULL, 'OS09G0560850 PROTEIN', 242299),
(329584, 'PTHR31044:SF30', NULL, NULL, NULL, NULL, 'OS05G0512600 PROTEIN', 242299),
(329585, 'PTHR31044:SF74', NULL, NULL, NULL, NULL, 'X8 DOMAIN-CONTAINING PROTEIN', 242299),
(329586, 'PTHR31044:SF76', NULL, NULL, NULL, NULL, 'X8 DOMAIN-CONTAINING PROTEIN-RELATED', 242299),
(329587, 'PTHR31044:SF107', NULL, NULL, NULL, NULL, 'X8 DOMAIN-CONTAINING PROTEIN', 242299),
(329588, 'PTHR31044:SF106', NULL, NULL, NULL, NULL, 'X8 DOMAIN-CONTAINING PROTEIN-RELATED', 242299),
(329589, 'PTHR31044:SF77', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE-LIKE', 242299),
(329590, 'PTHR31044:SF33', NULL, NULL, NULL, NULL, 'OS06G0537700 PROTEIN', 242299),
(329591, 'PTHR31044:SF105', NULL, NULL, NULL, NULL, 'X8 DOMAIN-CONTAINING PROTEIN', 242299),
(329592, 'PTHR31044:SF78', NULL, NULL, NULL, NULL, 'X8 DOMAIN-CONTAINING PROTEIN', 242299),
(329593, 'PTHR31044:SF35', NULL, NULL, NULL, NULL, 'X8 DOMAIN-CONTAINING PROTEIN', 242299),
(329594, 'PTHR31044:SF103', NULL, NULL, NULL, NULL, 'MAJOR POLLEN ALLERGEN OLE E 10-LIKE', 242299),
(329595, 'PTHR31044:SF36', NULL, NULL, NULL, NULL, 'CARBOHYDRATE-BINDING X8 DOMAIN SUPERFAMILY PROTEIN', 242299),
(329596, 'PTHR31044:SF101', NULL, NULL, NULL, NULL, 'X8 DOMAIN-CONTAINING PROTEIN', 242299),
(329597, 'PTHR31044:SF39', NULL, NULL, NULL, NULL, 'CARBOHYDRATE-BINDING X8 DOMAIN PROTEIN', 242299);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(329598, 'PTHR31044:SF100', NULL, NULL, NULL, NULL, 'X8 DOMAIN-CONTAINING PROTEIN', 242299),
(329599, 'PTHR31044:SF132', NULL, NULL, NULL, NULL, 'X8 DOMAIN-CONTAINING PROTEIN', 242299),
(329600, 'PTHR31044:SF131', NULL, NULL, NULL, NULL, 'PLASMODESMATA CALLOSE-BINDING PROTEIN 3-LIKE', 242299),
(329601, 'PTHR31044:SF130', NULL, NULL, NULL, NULL, 'CARBOHYDRATE-BINDING X8 DOMAIN SUPERFAMILY PROTEIN', 242299),
(329602, 'PTHR31044:SF82', NULL, NULL, NULL, NULL, 'X8 DOMAIN-CONTAINING PROTEIN', 242299),
(329603, 'PTHR31044:SF85', NULL, NULL, NULL, NULL, 'OS05G0581900 PROTEIN', 242299),
(329604, 'PTHR31044:SF42', NULL, NULL, NULL, NULL, 'X8 DOMAIN-CONTAINING PROTEIN', 242299),
(329605, 'PTHR31044:SF43', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE 13-LIKE ISOFORM X1', 242299),
(329606, 'PTHR31044:SF87', NULL, NULL, NULL, NULL, 'CARBOHYDRATE-BINDING X8 DOMAIN-CONTAINING PROTEIN', 242299),
(329607, 'PTHR31044:SF139', NULL, NULL, NULL, NULL, 'CARBOHYDRATE-BINDING X8 DOMAIN PROTEIN', 242299),
(329608, 'PTHR31044:SF89', NULL, NULL, NULL, NULL, 'X8 DOMAIN-CONTAINING PROTEIN', 242299),
(329609, 'PTHR31044:SF138', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242299),
(329610, 'PTHR31044:SF137', NULL, NULL, NULL, NULL, 'PLASMODESMATA CALLOSE-BINDING PROTEIN 2', 242299),
(329611, 'PTHR31044:SF46', NULL, NULL, NULL, NULL, 'PLASMODESMATA CALLOSE-BINDING PROTEIN 3-LIKE', 242299),
(329612, 'PTHR31044:SF47', NULL, NULL, NULL, NULL, 'CARBOHYDRATE-BINDING X8 DOMAIN SUPERFAMILY PROTEIN', 242299),
(329613, 'PTHR31044:SF136', NULL, NULL, NULL, NULL, 'X8 DOMAIN-CONTAINING PROTEIN', 242299),
(329614, 'PTHR31044:SF135', NULL, NULL, NULL, NULL, 'X8 DOMAIN-CONTAINING PROTEIN', 242299),
(329615, 'PTHR31044:SF134', NULL, NULL, NULL, NULL, 'CARBOHYDRATE-BINDING X8 DOMAIN SUPERFAMILY PROTEIN', 242299),
(329616, 'PTHR31044:SF49', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242299),
(329617, 'PTHR31044:SF133', NULL, NULL, NULL, NULL, 'PLASMODESMATA CALLOSE-BINDING PROTEIN 4', 242299),
(329618, 'PTHR31044:SF121', NULL, NULL, NULL, NULL, 'X8 DOMAIN-CONTAINING PROTEIN', 242299),
(329619, 'PTHR31044:SF90', NULL, NULL, NULL, NULL, 'X8 DOMAIN-CONTAINING PROTEIN', 242299),
(329620, 'PTHR31044:SF91', NULL, NULL, NULL, NULL, 'X8 DOMAIN-CONTAINING PROTEIN-RELATED', 242299),
(329621, 'PTHR31044:SF120', NULL, NULL, NULL, NULL, 'CARBOHYDRATE-BINDING X8 DOMAIN SUPERFAMILY PROTEIN', 242299),
(329622, 'PTHR31044:SF93', NULL, NULL, NULL, NULL, 'X8 DOMAIN-CONTAINING PROTEIN', 242299),
(329623, 'PTHR31044:SF94', NULL, NULL, NULL, NULL, 'CBM43-CONTAINING PROTEIN', 242299),
(329624, 'PTHR31044:SF51', NULL, NULL, NULL, NULL, 'X8 DOMAIN-CONTAINING PROTEIN', 242299),
(329625, 'PTHR31044:SF52', NULL, NULL, NULL, NULL, 'CARBOHYDRATE-BINDING X8 DOMAIN SUPERFAMILY PROTEIN', 242299),
(329626, 'PTHR31044:SF96', NULL, NULL, NULL, NULL, 'X8 DOMAIN-CONTAINING PROTEIN', 242299),
(329627, 'PTHR31044:SF53', NULL, NULL, NULL, NULL, 'CARBOHYDRATE-BINDING X8 DOMAIN PROTEIN', 242299),
(329628, 'PTHR31044:SF129', NULL, NULL, NULL, NULL, 'X8 DOMAIN-CONTAINING PROTEIN', 242299),
(329629, 'PTHR31044:SF99', NULL, NULL, NULL, NULL, 'X8 DOMAIN-CONTAINING PROTEIN-RELATED', 242299),
(329630, 'PTHR31044:SF55', NULL, NULL, NULL, NULL, 'CARBOHYDRATE-BINDING X8 DOMAIN SUPERFAMILY PROTEIN', 242299),
(329631, 'PTHR31044:SF128', NULL, NULL, NULL, NULL, 'CARBOHYDRATE-BINDING X8 DOMAIN PROTEIN', 242299),
(329632, 'PTHR31044:SF56', NULL, NULL, NULL, NULL, 'PLASMODESMATA CALLOSE-BINDING PROTEIN 3-LIKE', 242299),
(329633, 'PTHR31044:SF127', NULL, NULL, NULL, NULL, 'BETA-1,3 GLUCANASE', 242299),
(329634, 'PTHR31044:SF57', NULL, NULL, NULL, NULL, 'CARBOHYDRATE-BINDING X8 DOMAIN SUPERFAMILY PROTEIN', 242299),
(329635, 'PTHR31044:SF126', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE FAMILY 17 PROTEIN', 242299),
(329636, 'PTHR31044:SF125', NULL, NULL, NULL, NULL, 'CARBOHYDRATE-BINDING X8 DOMAIN SUPERFAMILY PROTEIN-RELATED', 242299),
(329637, 'PTHR31044:SF58', NULL, NULL, NULL, NULL, 'X8 DOMAIN-CONTAINING PROTEIN', 242299),
(329638, 'PTHR31044:SF124', NULL, NULL, NULL, NULL, 'X8 DOMAIN-CONTAINING PROTEIN', 242299);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(329639, 'PTHR31044:SF123', NULL, NULL, NULL, NULL, 'X8 DOMAIN-CONTAINING PROTEIN-RELATED', 242299),
(329640, 'PTHR31044:SF122', NULL, NULL, NULL, NULL, 'PLASMODESMATA CALLOSE-BINDING PROTEIN 5-LIKE', 242299),
(329641, 'PTHR11416', NULL, NULL, NULL, NULL, 'PRO-OPIOMELANOCORTIN', 242300),
(329642, 'PTHR11416:SF7', NULL, NULL, NULL, NULL, 'PRO-OPIOMELANOCORTIN', 242300),
(329643, 'PTHR47501:SF5', NULL, NULL, NULL, NULL, 'ZGC:161969', 242301),
(329644, 'PTHR47501', NULL, NULL, NULL, NULL, 'TRANSPOSASE-RELATED', 242301),
(329645, 'PTHR36511:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', 242302),
(329646, 'PTHR36511:SF3', NULL, NULL, NULL, NULL, 'ANTITOXIN HIGA-2', 242302),
(329647, 'PTHR36511:SF4', NULL, NULL, NULL, NULL, 'ANTITOXIN MQSA', 242302),
(329648, 'PTHR36511', NULL, NULL, NULL, NULL, 'MERR FAMILY BACTERIAL REGULATORY PROTEIN', 242302),
(329649, 'PTHR38372', NULL, NULL, NULL, NULL, 'DENTIN SIALOPHOSPHOPROTEIN-LIKE PROTEIN', 242303),
(329650, 'PTHR38372:SF2', NULL, NULL, NULL, NULL, 'DENTIN SIALOPHOSPHOPROTEIN-LIKE PROTEIN', 242303),
(329651, 'PTHR30489', NULL, NULL, NULL, NULL, 'LIPOPROTEIN-RELEASING SYSTEM TRANSMEMBRANE PROTEIN LOLE', 242304),
(329652, 'PTHR30489:SF8', NULL, NULL, NULL, NULL, 'LIPOPROTEIN-RELEASING SYSTEM TRANSMEMBRANE PROTEIN LOLC', 242304),
(329653, 'PTHR30489:SF0', NULL, NULL, NULL, NULL, 'LIPOPROTEIN-RELEASING SYSTEM TRANSMEMBRANE PROTEIN LOLE', 242304),
(329654, 'PTHR10693:SF55', NULL, NULL, NULL, NULL, 'OS07G0603100 PROTEIN', 242305),
(329655, 'PTHR10693:SF78', NULL, NULL, NULL, NULL, 'BNAANNG06690D PROTEIN', 242305),
(329656, 'PTHR10693:SF75', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSPORT FACTOR 2', 242305),
(329657, 'PTHR10693:SF10', NULL, NULL, NULL, NULL, 'RAS GTPASE-ACTIVATING PROTEIN-BINDING PROTEIN 2', 242305),
(329658, 'PTHR10693:SF79', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSPORT FACTOR 2 (NTF2) FAMILY PROTEIN', 242305),
(329659, 'PTHR10693:SF58', NULL, NULL, NULL, NULL, 'OS02G0131700 PROTEIN', 242305),
(329660, 'PTHR10693:SF70', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-BINDING ALPHA-BETA PLAIT DOMAIN, NTF2-LIKE DOMAIN PROTEIN-RELATED', 242305),
(329661, 'PTHR10693:SF51', NULL, NULL, NULL, NULL, 'G3BP-LIKE PROTEIN ISOFORM X2-RELATED', 242305),
(329662, 'PTHR10693:SF74', NULL, NULL, NULL, NULL, 'NTF2 DOMAIN-CONTAINING PROTEIN', 242305),
(329663, 'PTHR10693:SF52', NULL, NULL, NULL, NULL, 'RAS GTPASE-ACTIVATING BINDING-LIKE PROTEIN', 242305),
(329664, 'PTHR10693:SF71', NULL, NULL, NULL, NULL, 'BNAA06G36440D PROTEIN', 242305),
(329665, 'PTHR10693:SF50', NULL, NULL, NULL, NULL, 'NTF2 DOMAIN-CONTAINING PROTEIN', 242305),
(329666, 'PTHR10693:SF72', NULL, NULL, NULL, NULL, 'BNAC06G30420D PROTEIN', 242305),
(329667, 'PTHR10693:SF22', NULL, NULL, NULL, NULL, 'OS04G0510500 PROTEIN', 242305),
(329668, 'PTHR10693:SF45', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSPORT FACTOR 2 (NTF2) FAMILY PROTEIN WITH RNA BINDING (RRM-RBD-RNP MOTIFS) DOMAIN-CONTAINING PROTEIN', 242305),
(329669, 'PTHR10693:SF67', NULL, NULL, NULL, NULL, 'BNAA07G24340D PROTEIN', 242305),
(329670, 'PTHR10693:SF20', NULL, NULL, NULL, NULL, 'AT27578P', 242305),
(329671, 'PTHR10693:SF64', NULL, NULL, NULL, NULL, 'RAS-GTPASE-ACTIVATING PROTEIN-BINDING PROTEIN', 242305),
(329672, 'PTHR10693:SF21', NULL, NULL, NULL, NULL, 'RAS GTPASE-ACTIVATING PROTEIN-BINDING PROTEIN 1', 242305),
(329673, 'PTHR10693:SF49', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSPORT FACTOR 2 (NTF2) FAMILY PROTEIN WITH RNA BINDING (RRM-RBD-RNP MOTIFS) DOMAIN-CONTAINING PROTEIN', 242305),
(329674, 'PTHR10693:SF69', NULL, NULL, NULL, NULL, 'BNAA09G05550D PROTEIN', 242305),
(329675, 'PTHR10693:SF47', NULL, NULL, NULL, NULL, 'RNA BINDING PROTEIN', 242305),
(329676, 'PTHR10693:SF80', NULL, NULL, NULL, NULL, '', 242305),
(329677, 'PTHR10693:SF81', NULL, NULL, NULL, NULL, 'RNA BINDING PROTEIN', 242305),
(329678, 'PTHR10693:SF62', NULL, NULL, NULL, NULL, 'BNAA07G24350D PROTEIN', 242305),
(329679, 'PTHR10693:SF84', NULL, NULL, NULL, NULL, 'BNAC05G10060D PROTEIN', 242305),
(329680, 'PTHR10693:SF85', NULL, NULL, NULL, NULL, 'G3BP-LIKE PROTEIN-RELATED', 242305);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(329681, 'PTHR10693:SF82', NULL, NULL, NULL, NULL, 'OS04G0372800 PROTEIN', 242305),
(329682, 'PTHR10693:SF83', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSPORT FACTOR 2, NTF2-LIKE DOMAIN PROTEIN-RELATED', 242305),
(329683, 'PTHR10693:SF29', NULL, NULL, NULL, NULL, 'GB|AAD20086.1', 242305),
(329684, 'PTHR10693', NULL, NULL, NULL, NULL, 'RAS GTPASE-ACTIVATING PROTEIN-BINDING PROTEIN', 242305),
(329685, 'PTHR33984:SF2', NULL, NULL, NULL, NULL, 'OS02G0717600 PROTEIN', 242306),
(329686, 'PTHR33984:SF13', NULL, NULL, NULL, NULL, 'OS08G0333100 PROTEIN', 242306),
(329687, 'PTHR33984:SF1', NULL, NULL, NULL, NULL, 'OS09G0281800 PROTEIN', 242306),
(329688, 'PTHR33984:SF10', NULL, NULL, NULL, NULL, 'RWP-RK DOMAIN-CONTAINING PROTEIN', 242306),
(329689, 'PTHR33984:SF11', NULL, NULL, NULL, NULL, '', 242306),
(329690, 'PTHR33984:SF12', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN CONTAINING PROTEIN, EXPRESSED', 242306),
(329691, 'PTHR33984', NULL, NULL, NULL, NULL, 'OS02G0717600 PROTEIN', 242306),
(329692, 'PTHR33297:SF4', NULL, NULL, NULL, NULL, 'AMASTIN-LIKE SURFACE PROTEIN-LIKE PROTEIN', 242307),
(329693, 'PTHR33297', NULL, NULL, NULL, NULL, 'AMASTIN-LIKE SURFACE PROTEIN-LIKE PROTEIN-RELATED', 242307),
(329694, 'PTHR33297:SF6', NULL, NULL, NULL, NULL, 'AMASTIN-LIKE PROTEIN', 242307),
(329695, 'PTHR46774:SF9', NULL, NULL, NULL, NULL, 'CHROMATIN MODIFICATION-RELATED PROTEIN EAF1 B-LIKE ISOFORM X1', 242308),
(329696, 'PTHR46774:SF5', NULL, NULL, NULL, NULL, 'CHROMATIN MODIFICATION-RELATED PROTEIN EAF1 B', 242308),
(329697, 'PTHR46774:SF6', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE, HELICASE/SANT-ASSOCIATED DOMAIN PROTEIN-RELATED', 242308),
(329698, 'PTHR46774:SF7', NULL, NULL, NULL, NULL, 'BNACNNG14720D PROTEIN', 242308),
(329699, 'PTHR46774:SF8', NULL, NULL, NULL, NULL, 'BNAC03G44730D PROTEIN', 242308),
(329700, 'PTHR46774', NULL, NULL, NULL, NULL, 'CHROMATIN MODIFICATION-RELATED PROTEIN EAF1 A-RELATED', 242308),
(329701, 'PTHR46774:SF3', NULL, NULL, NULL, NULL, 'CHROMATIN MODIFICATION-RELATED PROTEIN EAF1 A-RELATED', 242308),
(329702, 'PTHR28640', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 6-INTERACTING PROTEIN 6', 242309),
(329703, 'PTHR28640:SF1', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 6-INTERACTING PROTEIN 6', 242309),
(329704, 'PTHR12327', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 242310),
(329705, 'PTHR12327:SF1', NULL, NULL, NULL, NULL, 'ALPHA-TUBULIN N-ACETYLTRANSFERASE 2', 242310),
(329706, 'PTHR12327:SF0', NULL, NULL, NULL, NULL, 'ALPHA-TUBULIN N-ACETYLTRANSFERASE 1', 242310),
(329707, 'PTHR10030:SF45', NULL, NULL, NULL, NULL, 'PLASMA ALPHA-L-FUCOSIDASE', 242311),
(329708, 'PTHR10030:SF44', NULL, NULL, NULL, NULL, 'ALPHA-L-FUCOSIDASE', 242311),
(329709, 'PTHR10030', NULL, NULL, NULL, NULL, 'ALPHA-L-FUCOSIDASE', 242311),
(329710, 'PTHR10030:SF27', NULL, NULL, NULL, NULL, 'ALPHA-L-FUCOSIDASE 1', 242311),
(329711, 'PTHR10030:SF2', NULL, NULL, NULL, NULL, 'TISSUE ALPHA-L-FUCOSIDASE', 242311),
(329712, 'PTHR10030:SF37', NULL, NULL, NULL, NULL, 'ALPHA-L-FUCOSIDASE-RELATED', 242311),
(329713, 'PTHR47932:SF28', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN MITOCHONDRIAL', 242312),
(329714, 'PTHR47932:SF26', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 242312),
(329715, 'PTHR47932:SF24', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 242312),
(329716, 'PTHR47932:SF68', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 242312),
(329717, 'PTHR47932:SF25', NULL, NULL, NULL, NULL, 'OS01G0833000 PROTEIN', 242312),
(329718, 'PTHR47932:SF69', NULL, NULL, NULL, NULL, '', 242312),
(329719, 'PTHR47932:SF66', NULL, NULL, NULL, NULL, 'BNACNNG27990D PROTEIN', 242312),
(329720, 'PTHR47932:SF22', NULL, NULL, NULL, NULL, 'OS03G0225300 PROTEIN', 242312),
(329721, 'PTHR47932:SF23', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 242312),
(329722, 'PTHR47932:SF67', NULL, NULL, NULL, NULL, '', 242312),
(329723, 'PTHR47932:SF64', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 242312);
INSERT INTO "PUBLIC"."MODEL" VALUES
(329724, 'PTHR47932:SF21', NULL, NULL, NULL, NULL, 'OS03G0569800 PROTEIN', 242312),
(329725, 'PTHR47932:SF65', NULL, NULL, NULL, NULL, '', 242312),
(329726, 'PTHR47932:SF62', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242312),
(329727, 'PTHR47932:SF63', NULL, NULL, NULL, NULL, 'OS08G0290000 PROTEIN', 242312),
(329728, 'PTHR47932:SF70', NULL, NULL, NULL, NULL, 'GENOMES UNCOUPLED1', 242312),
(329729, 'PTHR47932:SF39', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT (PPR) SUPERFAMILY PROTEIN', 242312),
(329730, 'PTHR47932:SF35', NULL, NULL, NULL, NULL, 'OS10G0147250 PROTEIN', 242312),
(329731, 'PTHR47932:SF36', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 242312),
(329732, 'PTHR47932:SF33', NULL, NULL, NULL, NULL, 'OS02G0793200 PROTEIN', 242312),
(329733, 'PTHR47932:SF34', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 242312),
(329734, 'PTHR47932:SF31', NULL, NULL, NULL, NULL, '', 242312),
(329735, 'PTHR47932:SF75', NULL, NULL, NULL, NULL, '', 242312),
(329736, 'PTHR47932:SF32', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 242312),
(329737, 'PTHR47932:SF73', NULL, NULL, NULL, NULL, '', 242312),
(329738, 'PTHR47932:SF74', NULL, NULL, NULL, NULL, 'BOX HELICASE FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 242312),
(329739, 'PTHR47932:SF71', NULL, NULL, NULL, NULL, '', 242312),
(329740, 'PTHR47932:SF72', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN-RELATED', 242312),
(329741, 'PTHR47932:SF48', NULL, NULL, NULL, NULL, 'OS01G0263400 PROTEIN', 242312),
(329742, 'PTHR47932:SF46', NULL, NULL, NULL, NULL, 'OS01G0611900 PROTEIN', 242312),
(329743, 'PTHR47932:SF47', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 242312),
(329744, 'PTHR47932:SF44', NULL, NULL, NULL, NULL, 'MIOREX COMPLEX COMPONENT 1', 242312),
(329745, 'PTHR47932:SF45', NULL, NULL, NULL, NULL, 'OS02G0565400 PROTEIN', 242312),
(329746, 'PTHR47932:SF42', NULL, NULL, NULL, NULL, 'OS05G0583950 PROTEIN', 242312),
(329747, 'PTHR47932:SF43', NULL, NULL, NULL, NULL, 'OS04G0475800 PROTEIN', 242312),
(329748, 'PTHR47932', NULL, NULL, NULL, NULL, 'ATPASE EXPRESSION PROTEIN 3', 242312),
(329749, 'PTHR47932:SF41', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 242312),
(329750, 'PTHR47932:SF19', NULL, NULL, NULL, NULL, 'OS02G0470000 PROTEIN', 242312),
(329751, 'PTHR47932:SF17', NULL, NULL, NULL, NULL, 'OS06G0172000 PROTEIN', 242312),
(329752, 'PTHR47932:SF18', NULL, NULL, NULL, NULL, 'OS05G0132000 PROTEIN', 242312),
(329753, 'PTHR47932:SF15', NULL, NULL, NULL, NULL, 'OS02G0266200 PROTEIN', 242312),
(329754, 'PTHR47932:SF59', NULL, NULL, NULL, NULL, '', 242312),
(329755, 'PTHR47932:SF16', NULL, NULL, NULL, NULL, 'OS01G0153250 PROTEIN', 242312),
(329756, 'PTHR47932:SF13', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN PNM1, MITOCHONDRIAL', 242312),
(329757, 'PTHR47932:SF14', NULL, NULL, NULL, NULL, '', 242312),
(329758, 'PTHR47932:SF11', NULL, NULL, NULL, NULL, 'OS04G0477200 PROTEIN', 242312),
(329759, 'PTHR47932:SF1', NULL, NULL, NULL, NULL, '', 242312),
(329760, 'PTHR47932:SF12', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 242312),
(329761, 'PTHR47932:SF53', NULL, NULL, NULL, NULL, 'SMR DOMAIN-CONTAINING PROTEIN', 242312),
(329762, 'PTHR47932:SF10', NULL, NULL, NULL, NULL, 'OS07G0179000 PROTEIN', 242312),
(329763, 'PTHR47932:SF51', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN-RELATED', 242312),
(329764, 'PTHR47932:SF4', NULL, NULL, NULL, NULL, 'OS03G0309800 PROTEIN', 242312),
(329765, 'PTHR47932:SF52', NULL, NULL, NULL, NULL, '', 242312),
(329766, 'PTHR47932:SF2', NULL, NULL, NULL, NULL, 'OS10G0484300 PROTEIN', 242312),
(329767, 'PTHR47932:SF50', NULL, NULL, NULL, NULL, 'OS01G0908800 PROTEIN', 242312),
(329768, 'PTHR47932:SF8', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 242312),
(329769, 'PTHR47932:SF6', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN MITOCHONDRIAL', 242312),
(329770, 'PTHR47932:SF7', NULL, NULL, NULL, NULL, 'REPEAT-LIKE SUPERFAMILY PROTEIN, PUTATIVE ISOFORM 1-RELATED', 242312);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(329771, 'PTHR14948:SF18', NULL, NULL, NULL, NULL, 'PROLINE RICH TRANSMEMBRANE PROTEIN 1B', 242313),
(329772, 'PTHR14948:SF19', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 233', 242313),
(329773, 'PTHR14948', NULL, NULL, NULL, NULL, 'NG5', 242313),
(329774, 'PTHR14948:SF40', NULL, NULL, NULL, NULL, 'RIKEN CDNA 2200002J24 GENE', 242313),
(329775, 'PTHR14948:SF20', NULL, NULL, NULL, NULL, 'PROLINE-RICH TRANSMEMBRANE PROTEIN 2', 242313),
(329776, 'PTHR14948:SF21', NULL, NULL, NULL, NULL, 'PROLINE-RICH TRANSMEMBRANE PROTEIN 1', 242313),
(329777, 'PTHR14948:SF43', NULL, NULL, NULL, NULL, 'PROLINE-RICH TRANSMEMBRANE PROTEIN 2', 242313),
(329778, 'PTHR14948:SF44', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 242313),
(329779, 'PTHR14948:SF45', NULL, NULL, NULL, NULL, 'PROLINE-RICH TRANSMEMBRANE PROTEIN 1', 242313),
(329780, 'PTHR14948:SF1', NULL, NULL, NULL, NULL, 'TRAFFICKING REGULATOR OF GLUT4 1', 242313),
(329781, 'PTHR14948:SF25', NULL, NULL, NULL, NULL, 'SI:CH73-343G19.4-RELATED', 242313),
(329782, 'PTHR34860', NULL, NULL, NULL, NULL, 'REPRESSOR-LIKE PROTEIN SSO7C3', 242314),
(329783, 'PTHR34860:SF6', NULL, NULL, NULL, NULL, 'REPRESSOR-LIKE PROTEIN SSO7C3', 242314),
(329784, 'PTHR14843:SF2', NULL, NULL, NULL, NULL, 'DEUBIQUITINATING PROTEIN VCPIP1', 242315),
(329785, 'PTHR14843', NULL, NULL, NULL, NULL, 'DEUBIQUITINATING PROTEIN VCIP135', 242315),
(329786, 'PTHR33427', NULL, NULL, NULL, NULL, 'HNH ENDONUCLEASE', 242316),
(329787, 'PTHR33427:SF1', NULL, NULL, NULL, NULL, 'F6A14.21 PROTEIN', 242316),
(329788, 'PTHR33427:SF5', NULL, NULL, NULL, NULL, 'BNAA01G28640D PROTEIN', 242316),
(329789, 'PTHR33427:SF3', NULL, NULL, NULL, NULL, 'HNH ENDONUCLEASE', 242316),
(329790, 'PTHR33427:SF2', NULL, NULL, NULL, NULL, 'TRICHOHYALIN', 242316),
(329791, 'PTHR45678', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 2-OXODICARBOXYLATE CARRIER 1-RELATED', 242317),
(329792, 'PTHR45678:SF9', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING MITOCHONDRIAL CARRIER PROTEIN ARALAR1', 242317),
(329793, 'PTHR45678:SF15', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN X', 242317),
(329794, 'PTHR45678:SF6', NULL, NULL, NULL, NULL, 'SLC (SOLUTE CARRIER) HOMOLOG', 242317),
(329795, 'PTHR45678:SF5', NULL, NULL, NULL, NULL, 'AT03939P-RELATED', 242317),
(329796, 'PTHR45678:SF7', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING MITOCHONDRIAL CARRIER PROTEIN ARALAR1', 242317),
(329797, 'PTHR45678:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 2-OXODICARBOXYLATE CARRIER 1-RELATED', 242317),
(329798, 'PTHR45678:SF3', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL GLUTAMATE CARRIER 1', 242317),
(329799, 'PTHR45678:SF11', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL GLUTAMATE CARRIER 2', 242317),
(329800, 'PTHR45678:SF12', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING MITOCHONDRIAL CARRIER PROTEIN ARALAR2', 242317),
(329801, 'PTHR45678:SF13', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 25 (MITOCHONDRIAL CARRIER: GLUTAMATE), MEMBER 22-RELATED', 242317),
(329802, 'PTHR33802:SF1', NULL, NULL, NULL, NULL, 'SI:DKEY-29D8.3', 242318),
(329803, 'PTHR33802:SF2', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 242318),
(329804, 'PTHR33802', NULL, NULL, NULL, NULL, 'SI:CH211-161H7.5-RELATED', 242318),
(329805, 'PTHR10337:SF12', NULL, NULL, NULL, NULL, 'SHC-TRANSFORMING PROTEIN 4', 242319),
(329806, 'PTHR10337:SF2', NULL, NULL, NULL, NULL, 'SHC-TRANSFORMING PROTEIN 1', 242319),
(329807, 'PTHR10337', NULL, NULL, NULL, NULL, 'SHC TRANSFORMING PROTEIN', 242319),
(329808, 'PTHR10337:SF11', NULL, NULL, NULL, NULL, 'DSHC PROTEIN', 242319),
(329809, 'PTHR10337:SF5', NULL, NULL, NULL, NULL, 'SHC-TRANSFORMING PROTEIN 2', 242319),
(329810, 'PTHR10337:SF6', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 152 KDA', 242319),
(329811, 'PTHR10337:SF4', NULL, NULL, NULL, NULL, 'SHC-TRANSFORMING PROTEIN 3', 242319),
(329812, 'PTHR31902:SF7', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN 32', 242320),
(329813, 'PTHR31902:SF8', NULL, NULL, NULL, NULL, '', 242320),
(329814, 'PTHR31902:SF9', NULL, NULL, NULL, NULL, 'BNAA10G09990D PROTEIN', 242320);
INSERT INTO "PUBLIC"."MODEL" VALUES
(329815, 'PTHR31902:SF20', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN 32-LIKE', 242320),
(329816, 'PTHR31902:SF10', NULL, NULL, NULL, NULL, 'SUCRASE/FERREDOXIN-LIKE FAMILY PROTEIN', 242320),
(329817, 'PTHR31902', NULL, NULL, NULL, NULL, 'ACTIN PATCHES DISTAL PROTEIN 1', 242320),
(329818, 'PTHR31902:SF11', NULL, NULL, NULL, NULL, 'SUCRASE/FERREDOXIN-LIKE FAMILY PROTEIN', 242320),
(329819, 'PTHR31902:SF12', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 242320),
(329820, 'PTHR31902:SF14', NULL, NULL, NULL, NULL, 'ACTIN PATCHES DISTAL PROTEIN 1', 242320),
(329821, 'PTHR31902:SF18', NULL, NULL, NULL, NULL, 'SUCRASE/FERREDOXIN-LIKE FAMILY PROTEIN-RELATED', 242320),
(329822, 'PTHR31902:SF19', NULL, NULL, NULL, NULL, '', 242320),
(329823, 'PTHR42786:SF5', NULL, NULL, NULL, NULL, 'SPOU_METHYLASE DOMAIN-CONTAINING PROTEIN', 242321),
(329824, 'PTHR42786:SF1', NULL, NULL, NULL, NULL, 'TRNA (CYTIDINE/URIDINE-2''-O-)-METHYLTRANSFERASE TRMJ', 242321),
(329825, 'PTHR42786', NULL, NULL, NULL, NULL, 'TRNA/RRNA METHYLTRANSFERASE', 242321),
(329826, 'PTHR42786:SF2', NULL, NULL, NULL, NULL, 'TRNA (CYTIDINE/URIDINE-2''-O-)-METHYLTRANSFERASE TRMJ', 242321),
(329827, 'PTHR43818:SF12', NULL, NULL, NULL, NULL, 'NADH-DEPENDENT DEHYDROGENASE-RELATED', 242322),
(329828, 'PTHR43818:SF1', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE FAMILY 109 PROTEIN', 242322),
(329829, 'PTHR43818:SF2', NULL, NULL, NULL, NULL, 'GLUCOSE-FRUCTOSE OXIDOREDUCTASE DOMAIN-CONTAINING PROTEIN 1', 242322),
(329830, 'PTHR43818:SF10', NULL, NULL, NULL, NULL, 'NADH-DEPENDENT DEHYDROGENASE-RELATED', 242322),
(329831, 'PTHR43818:SF11', NULL, NULL, NULL, NULL, 'BCDNA.GH03377', 242322),
(329832, 'PTHR43818:SF5', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE FAMILY PROTEIN', 242322),
(329833, 'PTHR43818:SF3', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE-RELATED', 242322),
(329834, 'PTHR43818', NULL, NULL, NULL, NULL, 'BCDNA.GH03377', 242322),
(329835, 'PTHR43818:SF9', NULL, NULL, NULL, NULL, 'HYPOTHETICAL OXIDOREDUCTASE', 242322),
(329836, 'PTHR43818:SF7', NULL, NULL, NULL, NULL, 'DEHYDROGENASE', 242322),
(329837, 'PTHR43818:SF8', NULL, NULL, NULL, NULL, 'GLUCOSE-FRUCTOSE OXIDOREDUCTASE DOMAIN-CONTAINING PROTEIN 2', 242322),
(329838, 'PTHR11560:SF11', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L10', 242323),
(329839, 'PTHR11560:SF12', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L10, MITOCHONDRIAL', 242323),
(329840, 'PTHR11560:SF13', NULL, NULL, NULL, NULL, '', 242323),
(329841, 'PTHR11560:SF14', NULL, NULL, NULL, NULL, 'BNAC01G38310D PROTEIN', 242323),
(329842, 'PTHR11560:SF10', NULL, NULL, NULL, NULL, 'OS05G0121500 PROTEIN', 242323),
(329843, 'PTHR11560:SF8', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L10, MITOCHONDRIAL', 242323),
(329844, 'PTHR11560', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L10, MITOCHONDRIAL', 242323),
(329845, 'PTHR44006', NULL, NULL, NULL, NULL, 'U5 SMALL NUCLEAR RIBONUCLEOPROTEIN 40 KDA PROTEIN', 242324),
(329846, 'PTHR44006:SF1', NULL, NULL, NULL, NULL, 'U5 SMALL NUCLEAR RIBONUCLEOPROTEIN 40 KDA PROTEIN', 242324),
(329847, 'PTHR44006:SF3', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 242324),
(329848, 'PTHR44006:SF4', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 242324),
(329849, 'PTHR38081', NULL, NULL, NULL, NULL, '', 242325),
(329850, 'PTHR38081:SF1', NULL, NULL, NULL, NULL, '', 242325),
(329851, 'PTHR23317:SF71', NULL, NULL, NULL, NULL, 'DEDICATOR OF CYTOKINESIS PROTEIN 10', 242326),
(329852, 'PTHR23317:SF81', NULL, NULL, NULL, NULL, 'DEDICATOR OF CYTOKINESIS PROTEIN 11', 242326),
(329853, 'PTHR23317:SF80', NULL, NULL, NULL, NULL, '', 242326),
(329854, 'PTHR23317:SF108', NULL, NULL, NULL, NULL, '', 242326),
(329855, 'PTHR23317:SF109', NULL, NULL, NULL, NULL, '', 242326),
(329856, 'PTHR23317', NULL, NULL, NULL, NULL, 'DEDICATOR OF CYTOKINESIS  DOCK', 242326),
(329857, 'PTHR23317:SF26', NULL, NULL, NULL, NULL, 'ZIZIMIN, ISOFORM K', 242326),
(329858, 'PTHR23317:SF78', NULL, NULL, NULL, NULL, 'DEDICATOR OF CYTOKINESIS PROTEIN 7', 242326);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(329859, 'PTHR23317:SF77', NULL, NULL, NULL, NULL, 'DEDICATOR OF CYTOKINESIS PROTEIN 9', 242326),
(329860, 'PTHR23317:SF76', NULL, NULL, NULL, NULL, 'LD20667P', 242326),
(329861, 'PTHR23317:SF65', NULL, NULL, NULL, NULL, 'DEDICATOR OF CYTOKINESIS PROTEIN 6', 242326),
(329862, 'PTHR23317:SF74', NULL, NULL, NULL, NULL, 'DEDICATOR OF CYTOKINESIS PROTEIN 8', 242326),
(329863, 'PTHR37234:SF2', NULL, NULL, NULL, NULL, 'BNAA09G36090D PROTEIN', 242327),
(329864, 'PTHR37234:SF3', NULL, NULL, NULL, NULL, 'BNACNNG20390D PROTEIN', 242327),
(329865, 'PTHR37234', NULL, NULL, NULL, NULL, 'OS03G0319200 PROTEIN', 242327),
(329866, 'PTHR37234:SF1', NULL, NULL, NULL, NULL, 'OS03G0319200 PROTEIN', 242327),
(329867, 'PTHR48003:SF6', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242328),
(329868, 'PTHR48003:SF5', NULL, NULL, NULL, NULL, 'OS07G0626500 PROTEIN', 242328),
(329869, 'PTHR48003:SF4', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE GHR1', 242328),
(329870, 'PTHR48003', NULL, NULL, NULL, NULL, 'OS07G0626500 PROTEIN', 242328),
(329871, 'PTHR48003:SF3', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 242328),
(329872, 'PTHR48003:SF2', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242328),
(329873, 'PTHR47568:SF3', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 242329),
(329874, 'PTHR47568:SF4', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 242329),
(329875, 'PTHR47568:SF5', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 242329),
(329876, 'PTHR47568:SF6', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SPL1', 242329),
(329877, 'PTHR47568:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SP1', 242329),
(329878, 'PTHR47568', NULL, NULL, NULL, NULL, '', 242329),
(329879, 'PTHR15614', NULL, NULL, NULL, NULL, 'INTRAFLAGELLAR TRANSPORT PROTEIN 81 HOMOLOG', 242330),
(329880, 'PTHR15614:SF2', NULL, NULL, NULL, NULL, 'INTRAFLAGELLAR TRANSPORT PROTEIN 81 HOMOLOG', 242330),
(329881, 'PTHR18861:SF0', NULL, NULL, NULL, NULL, 'BRUCHPILOT, ISOFORM J', 242331),
(329882, 'PTHR18861:SF1', NULL, NULL, NULL, NULL, 'ELKS/RAB6-INTERACTING/CAST FAMILY MEMBER 1', 242331),
(329883, 'PTHR18861:SF3', NULL, NULL, NULL, NULL, 'ERC PROTEIN 2', 242331),
(329884, 'PTHR18861:SF4', NULL, NULL, NULL, NULL, 'SPINDLE-DEFECTIVE PROTEIN 5', 242331),
(329885, 'PTHR18861', NULL, NULL, NULL, NULL, 'ELKS/RAB6-INTERACTING/CAST PROTEIN', 242331),
(329886, 'PTHR35890:SF3', NULL, NULL, NULL, NULL, 'ECOTIN', 242332),
(329887, 'PTHR35890', NULL, NULL, NULL, NULL, '', 242332),
(329888, 'PTHR47298', NULL, NULL, NULL, NULL, 'OXIDIZED LOW-DENSITY LIPOPROTEIN RECEPTOR 1', 242333),
(329889, 'PTHR47298:SF1', NULL, NULL, NULL, NULL, 'OXIDIZED LOW-DENSITY LIPOPROTEIN RECEPTOR 1', 242333),
(329890, 'PTHR46168:SF18', NULL, NULL, NULL, NULL, 'ARMADILLO-TYPE FOLD PROTEIN-RELATED', 242334),
(329891, 'PTHR46168:SF19', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT ONLY 4-RELATED', 242334),
(329892, 'PTHR46168:SF1', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT ONLY 4', 242334),
(329893, 'PTHR46168:SF4', NULL, NULL, NULL, NULL, 'ARMADILLO/BETA-CATENIN-LIKE REPEAT FAMILY PROTEIN, EXPRESSED', 242334),
(329894, 'PTHR46168:SF5', NULL, NULL, NULL, NULL, 'OS08G0548500 PROTEIN', 242334),
(329895, 'PTHR46168', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT ONLY 4', 242334),
(329896, 'PTHR46168:SF8', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT ONLY 1', 242334),
(329897, 'PTHR46168:SF9', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT ONLY 2', 242334),
(329898, 'PTHR46168:SF7', NULL, NULL, NULL, NULL, 'ARMADILLO/BETA-CATENIN-LIKE REPEAT FAMILY PROTEIN, EXPRESSED', 242334),
(329899, 'PTHR46168:SF20', NULL, NULL, NULL, NULL, 'BNAA04G26900D PROTEIN', 242334),
(329900, 'PTHR46168:SF10', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT ONLY 3', 242334),
(329901, 'PTHR46168:SF11', NULL, NULL, NULL, NULL, 'ARO1 1', 242334),
(329902, 'PTHR46168:SF22', NULL, NULL, NULL, NULL, 'ARMADILLO-TYPE FOLD PROTEIN-RELATED', 242334),
(329903, 'PTHR46168:SF12', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT ONLY 4-LIKE PROTEIN', 242334);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(329904, 'PTHR46168:SF13', NULL, NULL, NULL, NULL, 'ARO1-LIKE PROTEIN 1', 242334),
(329905, 'PTHR46168:SF15', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT ONLY 1 PROTEIN', 242334),
(329906, 'PTHR46168:SF16', NULL, NULL, NULL, NULL, 'ARO1 1', 242334),
(329907, 'PTHR11510:SF17', NULL, NULL, NULL, NULL, 'INOSITOL 3-PHOSPHATE SYNTHASE ISOZYME 3-RELATED', 242335),
(329908, 'PTHR11510:SF16', NULL, NULL, NULL, NULL, 'INOSITOL-3-PHOSPHATE SYNTHASE', 242335),
(329909, 'PTHR11510:SF5', NULL, NULL, NULL, NULL, 'INOSITOL-3-PHOSPHATE SYNTHASE 1', 242335),
(329910, 'PTHR11510:SF18', NULL, NULL, NULL, NULL, 'INOSITOL-3-PHOSPHATE SYNTHASE ISOZYME 1', 242335),
(329911, 'PTHR11510:SF15', NULL, NULL, NULL, NULL, 'INOSITOL-3-PHOSPHATE SYNTHASE 1', 242335),
(329912, 'PTHR11510:SF20', NULL, NULL, NULL, NULL, 'INOSITOL-3-PHOSPHATE SYNTHASE', 242335),
(329913, 'PTHR11510', NULL, NULL, NULL, NULL, 'MYO-INOSITOL-1 PHOSPHATE SYNTHASE', 242335),
(329914, 'PTHR11510:SF21', NULL, NULL, NULL, NULL, 'INOSITOL-3-PHOSPHATE SYNTHASE', 242335),
(329915, 'PTHR36147', NULL, NULL, NULL, NULL, '', 242336),
(329916, 'PTHR36147:SF2', NULL, NULL, NULL, NULL, '', 242336),
(329917, 'PTHR35118', NULL, NULL, NULL, NULL, 'KINASE FAMILY PROTEIN', 242337),
(329918, 'PTHR35118:SF5', NULL, NULL, NULL, NULL, '', 242337),
(329919, 'PTHR35118:SF2', NULL, NULL, NULL, NULL, 'KINASE FAMILY PROTEIN', 242337),
(329920, 'PTHR35118:SF3', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 242337),
(329921, 'PTHR35118:SF4', NULL, NULL, NULL, NULL, 'BNAC04G52250D PROTEIN', 242337),
(329922, 'PTHR34859:SF2', NULL, NULL, NULL, NULL, 'AGAP005739-PA', 242338),
(329923, 'PTHR34859', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', 242338),
(329924, 'PTHR23164:SF24', NULL, NULL, NULL, NULL, 'FYVE DOMAIN-CONTAINING PROTEIN', 242339),
(329925, 'PTHR23164:SF30', NULL, NULL, NULL, NULL, 'LD23155P', 242339),
(329926, 'PTHR23164:SF29', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE PIB1', 242339),
(329927, 'PTHR23164', NULL, NULL, NULL, NULL, 'EARLY ENDOSOME ANTIGEN 1', 242339),
(329928, 'PTHR23164:SF28', NULL, NULL, NULL, NULL, '', 242339),
(329929, 'PTHR23164:SF17', NULL, NULL, NULL, NULL, 'EARLY ENDOSOME ANTIGEN 1', 242339),
(329930, 'PTHR31685:SF2', NULL, NULL, NULL, NULL, 'PROTEIN YTP1', 242340),
(329931, 'PTHR31685:SF3', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_6G12730)', 242340),
(329932, 'PTHR31685', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_6G12730)-RELATED', 242340),
(329933, 'PTHR11093:SF2', NULL, NULL, NULL, NULL, 'RUVB-LIKE 2', 242341),
(329934, 'PTHR11093', NULL, NULL, NULL, NULL, 'RUVB-RELATED REPTIN AND PONTIN', 242341),
(329935, 'PTHR11093:SF6', NULL, NULL, NULL, NULL, 'RUVB-LIKE 1', 242341),
(329936, 'PTHR11093:SF8', NULL, NULL, NULL, NULL, 'RUVB-LIKE HELICASE', 242341),
(329937, 'PTHR11093:SF9', NULL, NULL, NULL, NULL, 'RUVB-LIKE HELICASE', 242341),
(329938, 'PTHR39959:SF1', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 242342),
(329939, 'PTHR39959:SF2', NULL, NULL, NULL, NULL, 'RE44287P', 242342),
(329940, 'PTHR39959', NULL, NULL, NULL, NULL, 'RE44287P-RELATED', 242342),
(329941, 'PTHR33512:SF30', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN KINASE TMK1-LIKE', 242343),
(329942, 'PTHR33512:SF31', NULL, NULL, NULL, NULL, '', 242343),
(329943, 'PTHR33512:SF12', NULL, NULL, NULL, NULL, '', 242343),
(329944, 'PTHR33512:SF7', NULL, NULL, NULL, NULL, 'OS06G0158800 PROTEIN', 242343),
(329945, 'PTHR33512:SF23', NULL, NULL, NULL, NULL, 'F16P17.15', 242343),
(329946, 'PTHR33512:SF13', NULL, NULL, NULL, NULL, 'BNAA09G52980D PROTEIN', 242343),
(329947, 'PTHR33512:SF8', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF1191)-RELATED', 242343),
(329948, 'PTHR33512:SF10', NULL, NULL, NULL, NULL, 'PLANT/F17O14-7 PROTEIN', 242343),
(329949, 'PTHR33512:SF22', NULL, NULL, NULL, NULL, '', 242343),
(329950, 'PTHR33512:SF11', NULL, NULL, NULL, NULL, '', 242343),
(329951, 'PTHR33512:SF16', NULL, NULL, NULL, NULL, '', 242343),
(329952, 'PTHR33512:SF17', NULL, NULL, NULL, NULL, 'CONCANAVALIN A-LIKE LECTIN/GLUCANASE DOMAIN-CONTAINING PROTEIN-RELATED', 242343);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(329953, 'PTHR33512:SF28', NULL, NULL, NULL, NULL, '', 242343),
(329954, 'PTHR33512:SF14', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242343),
(329955, 'PTHR33512:SF29', NULL, NULL, NULL, NULL, 'BNAA05G29630D PROTEIN', 242343),
(329956, 'PTHR33512:SF18', NULL, NULL, NULL, NULL, '', 242343),
(329957, 'PTHR33512', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF1191)-RELATED', 242343),
(329958, 'PTHR33512:SF4', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF1191)-RELATED', 242343),
(329959, 'PTHR33512:SF1', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF1191)-RELATED', 242343),
(329960, 'PTHR35489:SF2', NULL, NULL, NULL, NULL, 'TITAN9', 242344),
(329961, 'PTHR35489', NULL, NULL, NULL, NULL, 'TITAN9', 242344),
(329962, 'PTHR33411:SF27', NULL, NULL, NULL, NULL, 'BNAC02G25500D PROTEIN', 242345),
(329963, 'PTHR33411:SF28', NULL, NULL, NULL, NULL, 'TRANSPOSASE EN/SPM', 242345),
(329964, 'PTHR33411:SF29', NULL, NULL, NULL, NULL, 'BNAC06G00090D PROTEIN', 242345),
(329965, 'PTHR33411:SF19', NULL, NULL, NULL, NULL, 'TRANSPOSASE EN/SPM', 242345),
(329966, 'PTHR33411:SF23', NULL, NULL, NULL, NULL, '', 242345),
(329967, 'PTHR33411:SF24', NULL, NULL, NULL, NULL, 'TRANSPOS_ASSOC DOMAIN-CONTAINING PROTEIN', 242345),
(329968, 'PTHR33411:SF25', NULL, NULL, NULL, NULL, 'TDCA1-ORF1-ORF2 PROTEIN', 242345),
(329969, 'PTHR33411:SF26', NULL, NULL, NULL, NULL, 'TRANSPOSASE, PTTA/EN/SPM, PLANT-RELATED', 242345),
(329970, 'PTHR33411:SF15', NULL, NULL, NULL, NULL, '', 242345),
(329971, 'PTHR33411:SF30', NULL, NULL, NULL, NULL, 'TRANSPOSASE', 242345),
(329972, 'PTHR33411:SF20', NULL, NULL, NULL, NULL, '', 242345),
(329973, 'PTHR33411:SF21', NULL, NULL, NULL, NULL, '', 242345),
(329974, 'PTHR33411:SF10', NULL, NULL, NULL, NULL, 'OS08G0392500 PROTEIN', 242345),
(329975, 'PTHR33411:SF22', NULL, NULL, NULL, NULL, 'MUCIN-1-LIKE ISOFORM X1', 242345),
(329976, 'PTHR33411:SF5', NULL, NULL, NULL, NULL, 'OS04G0610200 PROTEIN', 242345),
(329977, 'PTHR33411', NULL, NULL, NULL, NULL, 'OS08G0392500 PROTEIN', 242345),
(329978, 'PTHR40516:SF1', NULL, NULL, NULL, NULL, 'ANTITOXIN CHPS-RELATED', 242346),
(329979, 'PTHR40516', NULL, NULL, NULL, NULL, 'ANTITOXIN CHPS-RELATED', 242346),
(329980, 'PTHR47893:SF1', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN PCHR', 242347),
(329981, 'PTHR47893', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN PCHR', 242347),
(329982, 'PTHR38338:SF1', NULL, NULL, NULL, NULL, 'AGAP013079-PA', 242348),
(329983, 'PTHR38338', NULL, NULL, NULL, NULL, 'AGAP013079-PA', 242348),
(329984, 'PTHR48109', NULL, NULL, NULL, NULL, 'DIHYDROOROTATE DEHYDROGENASE (QUINONE), MITOCHONDRIAL-RELATED', 242349),
(329985, 'PTHR48109:SF6', NULL, NULL, NULL, NULL, 'DIHYDROOROTATE DEHYDROGENASE (QUINONE), MITOCHONDRIAL', 242349),
(329986, 'PTHR48109:SF2', NULL, NULL, NULL, NULL, 'DIHYDROOROTATE DEHYDROGENASE (QUINONE), MITOCHONDRIAL', 242349),
(329987, 'PTHR48109:SF1', NULL, NULL, NULL, NULL, 'DIHYDROOROTATE DEHYDROGENASE (FUMARATE)', 242349),
(329988, 'PTHR48109:SF4', NULL, NULL, NULL, NULL, 'DIHYDROOROTATE DEHYDROGENASE (QUINONE), MITOCHONDRIAL', 242349),
(329989, 'PTHR48109:SF3', NULL, NULL, NULL, NULL, 'SLL0744 PROTEIN', 242349),
(329990, 'PTHR39323:SF1', NULL, NULL, NULL, NULL, 'BLR1149 PROTEIN', 242350),
(329991, 'PTHR39323', NULL, NULL, NULL, NULL, 'BLR1149 PROTEIN', 242350),
(329992, 'PTHR39330', NULL, NULL, NULL, NULL, 'ETHANOLAMINE AMMONIA-LYASE LIGHT CHAIN', 242351),
(329993, 'PTHR39330:SF1', NULL, NULL, NULL, NULL, 'ETHANOLAMINE AMMONIA-LYASE SMALL SUBUNIT', 242351),
(329994, 'PTHR48070:SF13', NULL, NULL, NULL, NULL, 'FSH1 DOMAIN-CONTAINING PROTEIN', 242352),
(329995, 'PTHR48070:SF8', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 242352),
(329996, 'PTHR48070:SF14', NULL, NULL, NULL, NULL, 'UPF0483 PROTEIN C25G4.2-LIKE', 242352),
(329997, 'PTHR48070:SF9', NULL, NULL, NULL, NULL, 'FAMILY OF SERINE HYDROLASES 1', 242352),
(329998, 'PTHR48070:SF6', NULL, NULL, NULL, NULL, 'ESTERASE OVCA2', 242352),
(329999, 'PTHR48070:SF7', NULL, NULL, NULL, NULL, 'FSH1 DOMAIN-CONTAINING PROTEIN-RELATED', 242352),
(330000, 'PTHR48070:SF1', NULL, NULL, NULL, NULL, 'FSH1 DOMAIN-CONTAINING PROTEIN', 242352);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(330001, 'PTHR48070:SF4', NULL, NULL, NULL, NULL, 'ESTERASE ALNB', 242352),
(330002, 'PTHR48070:SF10', NULL, NULL, NULL, NULL, 'OS07G0687100 PROTEIN', 242352),
(330003, 'PTHR48070', NULL, NULL, NULL, NULL, 'ESTERASE OVCA2', 242352),
(330004, 'PTHR48070:SF3', NULL, NULL, NULL, NULL, 'ESTERASE DBAE-RELATED', 242352),
(330005, 'PTHR43275:SF2', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G04150)-RELATED', 242353),
(330006, 'PTHR43275:SF1', NULL, NULL, NULL, NULL, 'D-MALATE DEHYDROGENASE [DECARBOXYLATING]', 242353),
(330007, 'PTHR43275', NULL, NULL, NULL, NULL, 'D-MALATE DEHYDROGENASE [DECARBOXYLATING]', 242353),
(330008, 'PTHR35340', NULL, NULL, NULL, NULL, 'PQQ ENZYME REPEAT PROTEIN-RELATED', 242354),
(330009, 'PTHR35340:SF9', NULL, NULL, NULL, NULL, '', 242354),
(330010, 'PTHR35340:SF8', NULL, NULL, NULL, NULL, '', 242354),
(330011, 'PTHR35340:SF7', NULL, NULL, NULL, NULL, '', 242354),
(330012, 'PTHR35340:SF6', NULL, NULL, NULL, NULL, '', 242354),
(330013, 'PTHR35340:SF5', NULL, NULL, NULL, NULL, 'PQQ ENZYME REPEAT PROTEIN-RELATED', 242354),
(330014, 'PTHR35340:SF10', NULL, NULL, NULL, NULL, 'ARYLSULFATE SULFOTRANSFERASE-RELATED', 242354),
(330015, 'PTHR45844', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH30', 242355),
(330016, 'PTHR45844:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH30', 242355),
(330017, 'PTHR45844:SF3', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 242355),
(330018, 'PTHR45844:SF11', NULL, NULL, NULL, NULL, 'OS08G0432800 PROTEIN', 242355),
(330019, 'PTHR45844:SF23', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 242355),
(330020, 'PTHR45844:SF24', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN-CONTAINING PROTEIN-RELATED', 242355),
(330021, 'PTHR45844:SF13', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR AIG1', 242355),
(330022, 'PTHR45844:SF25', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH107-RELATED', 242355),
(330023, 'PTHR45844:SF20', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 242355),
(330024, 'PTHR45844:SF21', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 242355),
(330025, 'PTHR45844:SF19', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH106-RELATED', 242355),
(330026, 'PTHR45844:SF6', NULL, NULL, NULL, NULL, 'OS08G0477900 PROTEIN', 242355),
(330027, 'PTHR45844:SF7', NULL, NULL, NULL, NULL, 'OS05G0163900 PROTEIN', 242355),
(330028, 'PTHR45844:SF4', NULL, NULL, NULL, NULL, 'OS09G0410700 PROTEIN', 242355),
(330029, 'PTHR45844:SF27', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 242355),
(330030, 'PTHR45844:SF16', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 242355),
(330031, 'PTHR45844:SF28', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTION FACTOR', 242355),
(330032, 'PTHR45844:SF17', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH131', 242355),
(330033, 'PTHR45844:SF9', NULL, NULL, NULL, NULL, 'OS09G0463900 PROTEIN', 242355),
(330034, 'PTHR45844:SF29', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH FAMILY-RELATED', 242355),
(330035, 'PTHR45844:SF18', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH51', 242355),
(330036, 'PTHR39084:SF1', NULL, NULL, NULL, NULL, 'DUF4010 DOMAIN-CONTAINING PROTEIN', 242356),
(330037, 'PTHR39084', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 242356),
(330038, 'PTHR36874:SF1', NULL, NULL, NULL, NULL, 'EQUATORIN', 242357),
(330039, 'PTHR36874', NULL, NULL, NULL, NULL, 'EQUATORIN', 242357),
(330040, 'PTHR43620:SF13', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE', 242358),
(330041, 'PTHR43620:SF38', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE', 242358),
(330042, 'PTHR43620:SF37', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE', 242358),
(330043, 'PTHR43620:SF18', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE', 242358),
(330044, 'PTHR43620:SF39', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE', 242358),
(330045, 'PTHR43620:SF17', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE', 242358);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(330046, 'PTHR43620:SF19', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE', 242358),
(330047, 'PTHR43620:SF10', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE GDPDL5', 242358),
(330048, 'PTHR43620:SF32', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE GDPDL1-RELATED', 242358),
(330049, 'PTHR43620:SF31', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE', 242358),
(330050, 'PTHR43620:SF34', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE', 242358),
(330051, 'PTHR43620:SF11', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE GDPDL4', 242358),
(330052, 'PTHR43620:SF33', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE', 242358),
(330053, 'PTHR43620:SF25', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE', 242358),
(330054, 'PTHR43620:SF24', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE', 242358),
(330055, 'PTHR43620:SF27', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE', 242358),
(330056, 'PTHR43620:SF26', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE', 242358),
(330057, 'PTHR43620:SF28', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE', 242358),
(330058, 'PTHR43620:SF41', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE', 242358),
(330059, 'PTHR43620:SF6', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE', 242358),
(330060, 'PTHR43620:SF40', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE', 242358),
(330061, 'PTHR43620:SF7', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE GDPD5-RELATED', 242358),
(330062, 'PTHR43620:SF43', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE GDPD6', 242358),
(330063, 'PTHR43620:SF42', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE', 242358),
(330064, 'PTHR43620:SF23', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE', 242358),
(330065, 'PTHR43620:SF22', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE', 242358),
(330066, 'PTHR43620', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHORYL DIESTER PHOSPHODIESTERASE', 242358),
(330067, 'PTHR43620:SF4', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE', 242358),
(330068, 'PTHR33640:SF36', NULL, NULL, NULL, NULL, '', 242359),
(330069, 'PTHR33640:SF25', NULL, NULL, NULL, NULL, 'BNAC07G31980D PROTEIN', 242359),
(330070, 'PTHR33640:SF27', NULL, NULL, NULL, NULL, 'BNAA07G12620D PROTEIN', 242359),
(330071, 'PTHR33640:SF28', NULL, NULL, NULL, NULL, '', 242359),
(330072, 'PTHR33640:SF17', NULL, NULL, NULL, NULL, 'NUCLEOLAR-LIKE PROTEIN', 242359),
(330073, 'PTHR33640:SF21', NULL, NULL, NULL, NULL, 'BNAA06G40750D PROTEIN', 242359),
(330074, 'PTHR33640:SF32', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 242359),
(330075, 'PTHR33640:SF11', NULL, NULL, NULL, NULL, 'BNAA04G12250D PROTEIN', 242359),
(330076, 'PTHR33640:SF33', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 242359),
(330077, 'PTHR33640:SF22', NULL, NULL, NULL, NULL, 'BNAC01G23750D PROTEIN', 242359),
(330078, 'PTHR33640:SF23', NULL, NULL, NULL, NULL, 'BNAA07G32070D PROTEIN', 242359),
(330079, 'PTHR33640:SF34', NULL, NULL, NULL, NULL, 'BNAA09G27820D PROTEIN', 242359),
(330080, 'PTHR33640:SF13', NULL, NULL, NULL, NULL, 'NUCLEOLAR-LIKE PROTEIN', 242359),
(330081, 'PTHR33640:SF35', NULL, NULL, NULL, NULL, '', 242359),
(330082, 'PTHR33640:SF30', NULL, NULL, NULL, NULL, '', 242359),
(330083, 'PTHR33640:SF31', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 242359),
(330084, 'PTHR33640:SF20', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 242359),
(330085, 'PTHR33640:SF8', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 242359),
(330086, 'PTHR33640:SF3', NULL, NULL, NULL, NULL, 'DUF4408 DOMAIN-CONTAINING PROTEIN', 242359),
(330087, 'PTHR33640:SF29', NULL, NULL, NULL, NULL, 'OS05G0581700 PROTEIN', 242359),
(330088, 'PTHR33640:SF18', NULL, NULL, NULL, NULL, '', 242359),
(330089, 'PTHR33640', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 242359);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(330090, 'PTHR45005:SF2', NULL, NULL, NULL, NULL, 'PROTEIN HLB1', 242360),
(330091, 'PTHR45005:SF4', NULL, NULL, NULL, NULL, 'PLANT SPECIFIC MITOCHONDRIAL IMPORT RECEPTOR-RELATED', 242360),
(330092, 'PTHR45005', NULL, NULL, NULL, NULL, '', 242360),
(330093, 'PTHR45005:SF3', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242360),
(330094, 'PTHR33246:SF51', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 242361),
(330095, 'PTHR33246', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 242361),
(330096, 'PTHR12015:SF94', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE 18', 242362),
(330097, 'PTHR12015:SF72', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE 21', 242362),
(330098, 'PTHR12015:SF70', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE 25', 242362),
(330099, 'PTHR12015:SF92', NULL, NULL, NULL, NULL, 'FRACTALKINE', 242362),
(330100, 'PTHR12015:SF98', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE 2', 242362),
(330101, 'PTHR12015:SF73', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE 26', 242362),
(330102, 'PTHR12015:SF77', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE 15', 242362),
(330103, 'PTHR12015:SF157', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE 23', 242362),
(330104, 'PTHR12015:SF110', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE 14', 242362),
(330105, 'PTHR12015:SF155', NULL, NULL, NULL, NULL, 'CHEMOKINE (C-C MOTIF) LIGAND 44', 242362),
(330106, 'PTHR12015:SF177', NULL, NULL, NULL, NULL, 'CHEMOKINE (C-X-C MOTIF) LIGAND 32B, DUPLICATE 1', 242362),
(330107, 'PTHR12015:SF111', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE 17', 242362),
(330108, 'PTHR12015:SF117', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE 2', 242362),
(330109, 'PTHR12015:SF170', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE 5', 242362),
(330110, 'PTHR12015:SF171', NULL, NULL, NULL, NULL, 'CHEMOKINE (C-C MOTIF) LIGAND 34B, DUPLICATE 4-RELATED', 242362),
(330111, 'PTHR12015:SF151', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE 3-LIKE 1', 242362),
(330112, 'PTHR12015:SF80', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE 19', 242362),
(330113, 'PTHR12015:SF87', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE 6', 242362),
(330114, 'PTHR12015:SF21', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE 16', 242362),
(330115, 'PTHR12015:SF108', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE 20', 242362),
(330116, 'PTHR12015:SF101', NULL, NULL, NULL, NULL, 'CYTOKINE SCM-1 BETA-RELATED', 242362),
(330117, 'PTHR12015:SF168', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE 8', 242362),
(330118, 'PTHR12015:SF146', NULL, NULL, NULL, NULL, 'EOTAXIN', 242362),
(330119, 'PTHR12015:SF102', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE 22', 242362),
(330120, 'PTHR12015:SF187', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE', 242362),
(330121, 'PTHR12015:SF165', NULL, NULL, NULL, NULL, 'CHEMOKINE (C-C MOTIF) LIGAND 34A, DUPLICATE 3-RELATED', 242362),
(330122, 'PTHR12015:SF100', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE 24', 242362),
(330123, 'PTHR12015:SF149', NULL, NULL, NULL, NULL, 'REGAKINE-1', 242362),
(330124, 'PTHR12015:SF103', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE 4-RELATED', 242362),
(330125, 'PTHR12015:SF147', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE 13', 242362),
(330126, 'PTHR12015:SF181', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE 8', 242362),
(330127, 'PTHR12015', NULL, NULL, NULL, NULL, 'SMALL INDUCIBLE CYTOKINE A', 242362),
(330128, 'PTHR12015:SF182', NULL, NULL, NULL, NULL, 'CHEMOKINE (C-C MOTIF) LIGAND 33, DUPLICATE 2-RELATED', 242362),
(330129, 'PTHR12015:SF5', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE 1', 242362),
(330130, 'PTHR12015:SF180', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE', 242362),
(330131, 'PTHR12015:SF185', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE-RELATED', 242362),
(330132, 'PTHR12015:SF186', NULL, NULL, NULL, NULL, 'CHEMOKINE (C-C MOTIF) LIGAND 25A-RELATED', 242362),
(330133, 'PTHR12015:SF161', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE 7', 242362),
(330134, 'PTHR12015:SF183', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE 3', 242362),
(330135, 'PTHR12015:SF184', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE-RELATED', 242362); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(330136, 'PTHR31568:SF131', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH TRANSMEMBRANE CYSTM DOMAIN-CONTAINING PROTEIN-RELATED', 242363),
(330137, 'PTHR31568:SF130', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH TM MODULE STRESS TOLERANCE PROTEIN', 242363),
(330138, 'PTHR31568:SF111', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH/TRANSMEMBRANE DOMAIN A-LIKE PROTEIN', 242363),
(330139, 'PTHR31568:SF133', NULL, NULL, NULL, NULL, '', 242363),
(330140, 'PTHR31568:SF132', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH TM MODULE STRESS TOLERANCE PROTEIN', 242363),
(330141, 'PTHR31568:SF63', NULL, NULL, NULL, NULL, 'BNAANNG03970D PROTEIN', 242363),
(330142, 'PTHR31568:SF62', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH TM MODULE STRESS TOLERANCE PROTEIN', 242363),
(330143, 'PTHR31568:SF81', NULL, NULL, NULL, NULL, 'BNAC02G16810D PROTEIN', 242363),
(330144, 'PTHR31568:SF79', NULL, NULL, NULL, NULL, 'CYSTM DOMAIN-CONTAINING PROTEIN', 242363),
(330145, 'PTHR31568', NULL, NULL, NULL, NULL, 'RCG49325, ISOFORM CRA_A', 242363),
(330146, 'PTHR31568:SF76', NULL, NULL, NULL, NULL, 'CYSTM DOMAIN-CONTAINING PROTEIN', 242363),
(330147, 'PTHR31568:SF99', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH AND TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN PCC1', 242363),
(330148, 'PTHR31568:SF134', NULL, NULL, NULL, NULL, 'UV-INDUCED PROTEIN UVI15-RELATED', 242363),
(330149, 'PTHR31568:SF112', NULL, NULL, NULL, NULL, 'CYSTM DOMAIN-CONTAINING PROTEIN', 242363),
(330150, 'PTHR31568:SF116', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH TM MODULE STRESS TOLERANCE PROTEIN', 242363),
(330151, 'PTHR31568:SF122', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH/TRANSMEMBRANE DOMAIN PCC1-LIKE PROTEIN', 242363),
(330152, 'PTHR31568:SF94', NULL, NULL, NULL, NULL, 'CYSTM DOMAIN-CONTAINING PROTEIN', 242363),
(330153, 'PTHR31568:SF90', NULL, NULL, NULL, NULL, 'ADHESIVE/PROLINE-RICH PROTEIN', 242363),
(330154, 'PTHR31568:SF49', NULL, NULL, NULL, NULL, 'OS08G0536400 PROTEIN', 242363),
(330155, 'PTHR31568:SF21', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH AND TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN YDR210W', 242363),
(330156, 'PTHR31568:SF64', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH AND TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN A-LIKE', 242363),
(330157, 'PTHR31568:SF89', NULL, NULL, NULL, NULL, 'CYSTM DOMAIN-CONTAINING PROTEIN', 242363),
(330158, 'PTHR31568:SF66', NULL, NULL, NULL, NULL, 'CYSTM DOMAIN-CONTAINING PROTEIN', 242363),
(330159, 'PTHR31568:SF124', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH AND TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN A-LIKE', 242363),
(330160, 'PTHR31568:SF123', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH AND TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN WIH1', 242363),
(330161, 'PTHR31568:SF101', NULL, NULL, NULL, NULL, 'CYSTM DOMAIN-CONTAINING PROTEIN', 242363),
(330162, 'PTHR31568:SF126', NULL, NULL, NULL, NULL, 'PROLINE-RICH FAMILY PROTEIN', 242363),
(330163, 'PTHR31568:SF125', NULL, NULL, NULL, NULL, 'RHODOPSIN', 242363),
(330164, 'PTHR31568:SF103', NULL, NULL, NULL, NULL, 'CYSTM DOMAIN-CONTAINING PROTEIN', 242363),
(330165, 'PTHR31568:SF128', NULL, NULL, NULL, NULL, 'RHODOPSIN', 242363),
(330166, 'PTHR31568:SF127', NULL, NULL, NULL, NULL, 'CYSTM DOMAIN-CONTAINING PROTEIN', 242363),
(330167, 'PTHR31568:SF105', NULL, NULL, NULL, NULL, 'ADHESIVE/PROLINE-RICH-LIKE PROTEIN', 242363),
(330168, 'PTHR31568:SF108', NULL, NULL, NULL, NULL, 'ADHESIVE/PROLINE-RICH PROTEIN', 242363),
(330169, 'PTHR31568:SF129', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH TM MODULE STRESS TOLERANCE PROTEIN', 242363),
(330170, 'PTHR31568:SF107', NULL, NULL, NULL, NULL, 'CYSTM DOMAIN-CONTAINING PROTEIN', 242363),
(330171, 'PTHR34180', NULL, NULL, NULL, NULL, 'PEPTIDASE C45', 242364),
(330172, 'PTHR34180:SF1', NULL, NULL, NULL, NULL, 'MUTANT TAN', 242364),
(330173, 'PTHR36745:SF2', NULL, NULL, NULL, NULL, 'BNAC04G04560D PROTEIN', 242365),
(330174, 'PTHR36745:SF1', NULL, NULL, NULL, NULL, 'OS02G0824400 PROTEIN', 242365),
(330175, 'PTHR36745', NULL, NULL, NULL, NULL, 'OS02G0824400 PROTEIN', 242365),
(330176, 'PTHR36051', NULL, NULL, NULL, NULL, 'DYNAMIN', 242366),
(330177, 'PTHR36051:SF2', NULL, NULL, NULL, NULL, 'DYNAMIN', 242366);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(330178, 'PTHR10773:SF19', NULL, NULL, NULL, NULL, '', 242367),
(330179, 'PTHR10773', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASES I, II, AND III SUBUNIT RPABC2', 242367),
(330180, 'PTHR48150', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE-ASSEMBLY FACTOR COX23, MITOCHONDRIAL', 242368),
(330181, 'PTHR48150:SF1', NULL, NULL, NULL, NULL, 'COX19 FAMILY PROTEIN (CHCH MOTIF)', 242368),
(330182, 'PTHR47580:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE FAMILY PROTEIN', 242369),
(330183, 'PTHR47580', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE FAMILY PROTEIN', 242369),
(330184, 'PTHR11561:SF0', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYKINASE, CYTOSOLIC [GTP]', 242370),
(330185, 'PTHR11561:SF17', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYKINASE (GTP)', 242370),
(330186, 'PTHR11561:SF16', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYKINASE (GTP)', 242370),
(330187, 'PTHR11561:SF2', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYKINASE (GTP)', 242370),
(330188, 'PTHR11561:SF11', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYKINASE [GTP], MITOCHONDRIAL', 242370),
(330189, 'PTHR11561', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYKINASE', 242370),
(330190, 'PTHR38074', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN 24, MITOCHONDRIAL', 242371),
(330191, 'PTHR38074:SF1', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN 24, MITOCHONDRIAL', 242371),
(330192, 'PTHR10009', NULL, NULL, NULL, NULL, 'PROTEIN YELLOW-RELATED', 242372),
(330193, 'PTHR10009:SF18', NULL, NULL, NULL, NULL, 'PROTEIN YELLOW-LIKE PROTEIN', 242372),
(330194, 'PTHR10009:SF19', NULL, NULL, NULL, NULL, 'RE55542P', 242372),
(330195, 'PTHR10009:SF10', NULL, NULL, NULL, NULL, 'L-DOPACHROME TAUTOMERASE YELLOW-F-RELATED', 242372),
(330196, 'PTHR10009:SF11', NULL, NULL, NULL, NULL, 'RH54244P', 242372),
(330197, 'PTHR10009:SF12', NULL, NULL, NULL, NULL, 'LD43175P', 242372),
(330198, 'PTHR10009:SF13', NULL, NULL, NULL, NULL, 'YELLOW-H', 242372),
(330199, 'PTHR10009:SF6', NULL, NULL, NULL, NULL, 'FI16876P1', 242372),
(330200, 'PTHR10009:SF14', NULL, NULL, NULL, NULL, 'PROTEIN YELLOW', 242372),
(330201, 'PTHR10009:SF8', NULL, NULL, NULL, NULL, 'IP19120P', 242372),
(330202, 'PTHR10009:SF17', NULL, NULL, NULL, NULL, '', 242372),
(330203, 'PTHR10009:SF7', NULL, NULL, NULL, NULL, 'GH10609P-RELATED', 242372),
(330204, 'PTHR11616:SF166', NULL, NULL, NULL, NULL, 'TRANSPORTER', 242373),
(330205, 'PTHR11616:SF286', NULL, NULL, NULL, NULL, 'SODIUM- AND CHLORIDE-DEPENDENT NEUTRAL AND BASIC AMINO ACID TRANSPORTER B(0+)', 242373),
(330206, 'PTHR11616:SF289', NULL, NULL, NULL, NULL, 'TRANSPORTER', 242373),
(330207, 'PTHR11616:SF124', NULL, NULL, NULL, NULL, 'SODIUM- AND CHLORIDE-DEPENDENT GABA TRANSPORTER 3', 242373),
(330208, 'PTHR11616:SF126', NULL, NULL, NULL, NULL, 'TRANSPORTER', 242373),
(330209, 'PTHR11616:SF125', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT NEUTRAL AMINO ACID TRANSPORTER B(0)AT1', 242373),
(330210, 'PTHR11616:SF20', NULL, NULL, NULL, NULL, 'SODIUM- AND CHLORIDE-DEPENDENT BETAINE TRANSPORTER', 242373),
(330211, 'PTHR11616:SF249', NULL, NULL, NULL, NULL, 'TRANSPORTER', 242373),
(330212, 'PTHR11616:SF129', NULL, NULL, NULL, NULL, 'TRANSPORTER', 242373),
(330213, 'PTHR11616:SF280', NULL, NULL, NULL, NULL, 'TRANSPORTER', 242373),
(330214, 'PTHR11616:SF285', NULL, NULL, NULL, NULL, 'TRANSPORTER', 242373),
(330215, 'PTHR11616:SF241', NULL, NULL, NULL, NULL, 'TRANSPORTER', 242373),
(330216, 'PTHR11616:SF240', NULL, NULL, NULL, NULL, 'TRANSPORTER', 242373),
(330217, 'PTHR11616:SF111', NULL, NULL, NULL, NULL, 'SODIUM- AND CHLORIDE-DEPENDENT GABA TRANSPORTER 2', 242373),
(330218, 'PTHR11616:SF231', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT PROLINE TRANSPORTER', 242373),
(330219, 'PTHR11616:SF311', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT DOPAMINE TRANSPORTER', 242373),
(330220, 'PTHR11616:SF233', NULL, NULL, NULL, NULL, 'ORPHAN SODIUM- AND CHLORIDE-DEPENDENT NEUROTRANSMITTER TRANSPORTER NTT5', 242373),
(330221, 'PTHR11616:SF277', NULL, NULL, NULL, NULL, 'TRANSPORTER', 242373);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(330222, 'PTHR11616:SF310', NULL, NULL, NULL, NULL, 'FI17140P1-RELATED', 242373),
(330223, 'PTHR11616:SF236', NULL, NULL, NULL, NULL, 'TRANSPORTER', 242373),
(330224, 'PTHR11616:SF98', NULL, NULL, NULL, NULL, 'TRANSPORTER', 242373),
(330225, 'PTHR11616:SF313', NULL, NULL, NULL, NULL, 'TRANSPORTER', 242373),
(330226, 'PTHR11616:SF312', NULL, NULL, NULL, NULL, 'TRANSPORTER', 242373),
(330227, 'PTHR11616:SF279', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT SEROTONIN TRANSPORTER', 242373),
(330228, 'PTHR11616:SF315', NULL, NULL, NULL, NULL, 'SODIUM- AND CHLORIDE-DEPENDENT GLYCINE TRANSPORTER 2', 242373),
(330229, 'PTHR11616:SF96', NULL, NULL, NULL, NULL, 'SODIUM- AND CHLORIDE-DEPENDENT CREATINE TRANSPORTER 1', 242373),
(330230, 'PTHR11616:SF314', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT ACETYLCHOLINE TRANSPORTER', 242373),
(330231, 'PTHR11616:SF237', NULL, NULL, NULL, NULL, 'TRANSPORTER', 242373),
(330232, 'PTHR11616:SF316', NULL, NULL, NULL, NULL, 'TRANSPORTER', 242373),
(330233, 'PTHR11616:SF118', NULL, NULL, NULL, NULL, 'SODIUM- AND CHLORIDE-DEPENDENT BETAINE TRANSPORTER', 242373),
(330234, 'PTHR11616:SF44', NULL, NULL, NULL, NULL, 'SODIUM- AND CHLORIDE-DEPENDENT TRANSPORTER XTRP3', 242373),
(330235, 'PTHR11616:SF265', NULL, NULL, NULL, NULL, 'TRANSPORTER', 242373),
(330236, 'PTHR11616:SF100', NULL, NULL, NULL, NULL, 'TRANSPORTER', 242373),
(330237, 'PTHR11616:SF102', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT NEUTRAL AMINO ACID TRANSPORTER SLC6A17', 242373),
(330238, 'PTHR11616:SF101', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT NEUTRAL AMINO ACID TRANSPORTER B(0)AT2', 242373),
(330239, 'PTHR11616:SF302', NULL, NULL, NULL, NULL, 'TRANSPORTER', 242373),
(330240, 'PTHR11616:SF304', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT TRANSPORTER BEDRAGGLED', 242373),
(330241, 'PTHR11616:SF303', NULL, NULL, NULL, NULL, 'SODIUM- AND CHLORIDE-DEPENDENT GABA TRANSPORTER INE', 242373),
(330242, 'PTHR11616:SF105', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT SEROTONIN TRANSPORTER', 242373),
(330243, 'PTHR11616:SF306', NULL, NULL, NULL, NULL, 'TRANSPORTER', 242373),
(330244, 'PTHR11616:SF305', NULL, NULL, NULL, NULL, 'TRANSPORTER', 242373),
(330245, 'PTHR11616:SF308', NULL, NULL, NULL, NULL, 'TRANSPORTER', 242373),
(330246, 'PTHR11616:SF307', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT NORADRENALINE TRANSPORTER', 242373),
(330247, 'PTHR11616:SF109', NULL, NULL, NULL, NULL, 'INACTIVE SODIUM-DEPENDENT NEUTRAL AMINO ACID TRANSPORTER B(0)AT3', 242373),
(330248, 'PTHR11616:SF309', NULL, NULL, NULL, NULL, 'TRANSPORTER', 242373),
(330249, 'PTHR11616', NULL, NULL, NULL, NULL, 'SODIUM/CHLORIDE DEPENDENT TRANSPORTER', 242373),
(330250, 'PTHR11616:SF182', NULL, NULL, NULL, NULL, 'TRANSPORTER', 242373),
(330251, 'PTHR11616:SF261', NULL, NULL, NULL, NULL, 'TRANSPORTER', 242373),
(330252, 'PTHR11616:SF263', NULL, NULL, NULL, NULL, 'SODIUM- AND CHLORIDE-DEPENDENT GLYCINE TRANSPORTER 1', 242373),
(330253, 'PTHR11616:SF38', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT DOPAMINE TRANSPORTER', 242373),
(330254, 'PTHR11616:SF141', NULL, NULL, NULL, NULL, 'SODIUM- AND CHLORIDE-DEPENDENT TAURINE TRANSPORTER', 242373),
(330255, 'PTHR11616:SF133', NULL, NULL, NULL, NULL, 'TRANSPORTER', 242373),
(330256, 'PTHR11616:SF254', NULL, NULL, NULL, NULL, 'TRANSPORTER', 242373),
(330257, 'PTHR11616:SF297', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT TRANSPORTER SNF-5', 242373),
(330258, 'PTHR11616:SF138', NULL, NULL, NULL, NULL, 'SODIUM- AND CHLORIDE-DEPENDENT GABA TRANSPORTER 1', 242373),
(330259, 'PTHR11616:SF292', NULL, NULL, NULL, NULL, 'BLOATED TUBULES, ISOFORM B', 242373),
(330260, 'PTHR11616:SF170', NULL, NULL, NULL, NULL, 'TRANSPORTER', 242373),
(330261, 'PTHR11616:SF295', NULL, NULL, NULL, NULL, 'SODIUM: NEUROTRANSMITTER SYMPORTER FAMILY', 242373),
(330262, 'PTHR32448:SF100', NULL, NULL, NULL, NULL, 'OS06G0549633 PROTEIN', 242374),
(330263, 'PTHR32448:SF144', NULL, NULL, NULL, NULL, 'BBE DOMAIN-CONTAINING PROTEIN', 242374),
(330264, 'PTHR32448:SF141', NULL, NULL, NULL, NULL, 'FAD-BINDING BERBERINE FAMILY PROTEIN-RELATED', 242374),
(330265, 'PTHR32448:SF35', NULL, NULL, NULL, NULL, 'BERBERINE BRIDGE ENZYME-LIKE 26', 242374);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(330266, 'PTHR32448:SF79', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 242374),
(330267, 'PTHR32448:SF37', NULL, NULL, NULL, NULL, 'OS06G0549900 PROTEIN', 242374),
(330268, 'PTHR32448:SF75', NULL, NULL, NULL, NULL, 'BERBERINE BRIDGE ENZYME-LIKE 16', 242374),
(330269, 'PTHR32448:SF32', NULL, NULL, NULL, NULL, 'OS06G0549600 PROTEIN', 242374),
(330270, 'PTHR32448:SF76', NULL, NULL, NULL, NULL, 'CANNABIDIOLIC ACID SYNTHASE-LIKE 1', 242374),
(330271, 'PTHR32448:SF77', NULL, NULL, NULL, NULL, 'BERBERINE BRIDGE ENZYME-LIKE 4', 242374),
(330272, 'PTHR32448:SF34', NULL, NULL, NULL, NULL, 'BERBERINE BRIDGE ENZYME-LIKE 19-RELATED', 242374),
(330273, 'PTHR32448:SF78', NULL, NULL, NULL, NULL, 'BBE DOMAIN-CONTAINING PROTEIN', 242374),
(330274, 'PTHR32448:SF82', NULL, NULL, NULL, NULL, 'BERBERINE BRIDGE ENZYME-LIKE 10', 242374),
(330275, 'PTHR32448:SF83', NULL, NULL, NULL, NULL, 'BERBERINE BRIDGE ENZYME-LIKE 11', 242374),
(330276, 'PTHR32448:SF109', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 242374),
(330277, 'PTHR32448:SF80', NULL, NULL, NULL, NULL, 'BBE DOMAIN-CONTAINING PROTEIN', 242374),
(330278, 'PTHR32448:SF104', NULL, NULL, NULL, NULL, 'OXIDASE, PUTATIVE-RELATED', 242374),
(330279, 'PTHR32448:SF103', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 242374),
(330280, 'PTHR32448:SF147', NULL, NULL, NULL, NULL, 'FLAVIN-DEPENDENT OXIDOREDUCTASE FOX2-LIKE', 242374),
(330281, 'PTHR32448:SF102', NULL, NULL, NULL, NULL, 'CANNABIDIOLIC ACID SYNTHASE-LIKE 1', 242374),
(330282, 'PTHR32448:SF146', NULL, NULL, NULL, NULL, 'OS06G0548200 PROTEIN', 242374),
(330283, 'PTHR32448:SF145', NULL, NULL, NULL, NULL, 'TETRAHYDROCANNABINOLIC ACID SYNTHASE-LIKE', 242374),
(330284, 'PTHR32448:SF106', NULL, NULL, NULL, NULL, 'TETRAHYDROCANNABINOLIC ACID SYNTHASE-LIKE', 242374),
(330285, 'PTHR32448:SF105', NULL, NULL, NULL, NULL, 'FLAVIN-DEPENDENT OXIDOREDUCTASE FOX1-LIKE', 242374),
(330286, 'PTHR32448:SF133', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 242374),
(330287, 'PTHR32448:SF132', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 242374),
(330288, 'PTHR32448:SF29', NULL, NULL, NULL, NULL, 'OS11G0495950 PROTEIN', 242374),
(330289, 'PTHR32448:SF68', NULL, NULL, NULL, NULL, 'BERBERINE BRIDGE ENZYME-LIKE 14-RELATED', 242374),
(330290, 'PTHR32448:SF69', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 242374),
(330291, 'PTHR32448:SF25', NULL, NULL, NULL, NULL, 'BERBERINE BRIDGE ENZYME-LIKE 8', 242374),
(330292, 'PTHR32448:SF64', NULL, NULL, NULL, NULL, 'BERBERINE BRIDGE ENZYME-LIKE 2', 242374),
(330293, 'PTHR32448:SF23', NULL, NULL, NULL, NULL, 'FAD-BINDING BERBERINE FAMILY PROTEIN-RELATED', 242374),
(330294, 'PTHR32448:SF67', NULL, NULL, NULL, NULL, 'RETICULINE OXIDASE-LIKE PROTEIN', 242374),
(330295, 'PTHR32448:SF72', NULL, NULL, NULL, NULL, 'BERBERINE BRIDGE ENZYME-LIKE 22', 242374),
(330296, 'PTHR32448:SF73', NULL, NULL, NULL, NULL, 'BERBERINE BRIDGE ENZYME-LIKE 15', 242374),
(330297, 'PTHR32448:SF70', NULL, NULL, NULL, NULL, 'BERBERINE BRIDGE ENZYME-LIKE 27-RELATED', 242374),
(330298, 'PTHR32448:SF137', NULL, NULL, NULL, NULL, 'FAD-BINDING BERBERINE FAMILY PROTEIN-RELATED', 242374),
(330299, 'PTHR32448:SF135', NULL, NULL, NULL, NULL, 'BERBERINE BRIDGE ENZYME-LIKE 13', 242374),
(330300, 'PTHR32448:SF134', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 242374),
(330301, 'PTHR32448:SF139', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 242374),
(330302, 'PTHR32448:SF161', NULL, NULL, NULL, NULL, 'FLAVIN-DEPENDENT OXIDOREDUCTASE FOX1-LIKE', 242374),
(330303, 'PTHR32448:SF160', NULL, NULL, NULL, NULL, 'FAD LINKED OXIDASE, N-TERMINAL', 242374),
(330304, 'PTHR32448:SF122', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 242374),
(330305, 'PTHR32448:SF121', NULL, NULL, NULL, NULL, 'FAD-BINDING BERBERINE FAMILY PROTEIN', 242374),
(330306, 'PTHR32448:SF19', NULL, NULL, NULL, NULL, 'OS06G0548100 PROTEIN', 242374);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(330307, 'PTHR32448:SF120', NULL, NULL, NULL, NULL, 'FAD-BINDING BERBERINE FAMILY PROTEIN', 242374),
(330308, 'PTHR32448:SF13', NULL, NULL, NULL, NULL, 'OS08G0158400 PROTEIN', 242374),
(330309, 'PTHR32448:SF59', NULL, NULL, NULL, NULL, 'FLAVIN-DEPENDENT OXIDOREDUCTASE FOX2-LIKE', 242374),
(330310, 'PTHR32448:SF16', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 242374),
(330311, 'PTHR32448:SF99', NULL, NULL, NULL, NULL, 'BERBERINE BRIDGE ENZYME-LIKE 1', 242374),
(330312, 'PTHR32448:SF12', NULL, NULL, NULL, NULL, 'RETICULINE OXIDASE-LIKE PROTEIN', 242374),
(330313, 'PTHR32448:SF61', NULL, NULL, NULL, NULL, 'TETRAHYDROCANNABINOLIC ACID SYNTHASE-LIKE', 242374),
(330314, 'PTHR32448:SF125', NULL, NULL, NULL, NULL, 'BERBERINE/BERBERINE-LIKE, XANTHINE DEHYDROGENASE, SMALL SUBUNIT, FAD-BINDING, TYPE 2-RELATED', 242374),
(330315, 'PTHR32448:SF124', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 242374),
(330316, 'PTHR32448:SF123', NULL, NULL, NULL, NULL, 'TETRAHYDROCANNABINOLIC ACID SYNTHASE-LIKE', 242374),
(330317, 'PTHR32448:SF129', NULL, NULL, NULL, NULL, 'TETRAHYDROCANNABINOLIC ACID SYNTHASE-LIKE', 242374),
(330318, 'PTHR32448:SF128', NULL, NULL, NULL, NULL, 'RETICULINE OXIDASE-LIKE PROTEIN', 242374),
(330319, 'PTHR32448:SF127', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 242374),
(330320, 'PTHR32448:SF151', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 242374),
(330321, 'PTHR32448:SF150', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 242374),
(330322, 'PTHR32448:SF111', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 242374),
(330323, 'PTHR32448:SF155', NULL, NULL, NULL, NULL, 'BERBERINE BRIDGE ENZYME-LIKE 3-RELATED', 242374),
(330324, 'PTHR32448:SF110', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 242374),
(330325, 'PTHR32448:SF154', NULL, NULL, NULL, NULL, 'FAD-BINDING BERBERINE FAMILY PROTEIN', 242374),
(330326, 'PTHR32448:SF153', NULL, NULL, NULL, NULL, 'BBE DOMAIN-CONTAINING PROTEIN', 242374),
(330327, 'PTHR32448:SF152', NULL, NULL, NULL, NULL, 'FAD-BINDING BERBERINE FAMILY PROTEIN-RELATED', 242374),
(330328, 'PTHR32448:SF86', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 242374),
(330329, 'PTHR32448:SF89', NULL, NULL, NULL, NULL, 'CANNABIDIOLIC ACID SYNTHASE-LIKE 1', 242374),
(330330, 'PTHR32448:SF93', NULL, NULL, NULL, NULL, 'BERBERINE BRIDGE ENZYME-LIKE 12', 242374),
(330331, 'PTHR32448:SF94', NULL, NULL, NULL, NULL, 'BERBERINE BRIDGE ENZYME-LIKE 24-RELATED', 242374),
(330332, 'PTHR32448:SF95', NULL, NULL, NULL, NULL, 'BERBERINE BRIDGE ENZYME-LIKE 23', 242374),
(330333, 'PTHR32448', NULL, NULL, NULL, NULL, 'OS08G0158400 PROTEIN', 242374),
(330334, 'PTHR32448:SF96', NULL, NULL, NULL, NULL, 'BERBERINE/BERBERINE-LIKE, ALDEHYDE OXIDASE, FAD-BINDING, TYPE 2-RELATED', 242374),
(330335, 'PTHR32448:SF52', NULL, NULL, NULL, NULL, 'OS08G0158200 PROTEIN', 242374),
(330336, 'PTHR32448:SF91', NULL, NULL, NULL, NULL, 'TETRAHYDROCANNABINOLIC ACID SYNTHASE-LIKE', 242374),
(330337, 'PTHR32448:SF92', NULL, NULL, NULL, NULL, 'FAD-BINDING BERBERINE FAMILY PROTEIN', 242374),
(330338, 'PTHR32448:SF115', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 242374),
(330339, 'PTHR32448:SF159', NULL, NULL, NULL, NULL, 'BERBERINE BRIDGE ENZYME-LIKE 17', 242374),
(330340, 'PTHR32448:SF158', NULL, NULL, NULL, NULL, 'RETICULINE OXIDASE-LIKE PROTEIN', 242374),
(330341, 'PTHR32448:SF114', NULL, NULL, NULL, NULL, 'OS08G0158300 PROTEIN', 242374),
(330342, 'PTHR32448:SF113', NULL, NULL, NULL, NULL, 'BERBERINE BRIDGE ENZYME-LIKE 18', 242374),
(330343, 'PTHR32448:SF157', NULL, NULL, NULL, NULL, 'FAD-BINDING BERBERINE FAMILY PROTEIN-RELATED', 242374),
(330344, 'PTHR32448:SF112', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 242374),
(330345, 'PTHR32448:SF156', NULL, NULL, NULL, NULL, 'CANNABIDIOLIC ACID SYNTHASE-LIKE', 242374),
(330346, 'PTHR32448:SF119', NULL, NULL, NULL, NULL, 'OS06G0548800 PROTEIN', 242374);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(330347, 'PTHR32448:SF116', NULL, NULL, NULL, NULL, 'FAD-BINDING BERBERINE FAMILY PROTEIN', 242374),
(330348, 'PTHR39965:SF1', NULL, NULL, NULL, NULL, 'CRISPR SYSTEM CMR SUBUNIT CMR6', 242375),
(330349, 'PTHR39965', NULL, NULL, NULL, NULL, 'CRISPR SYSTEM CMR SUBUNIT CMR6', 242375),
(330350, 'PTHR12812:SF1', NULL, NULL, NULL, NULL, 'HEPARAN-SULFATE 6-O-SULFOTRANSFERASE 1', 242376),
(330351, 'PTHR12812:SF0', NULL, NULL, NULL, NULL, 'HEPARAN-SULFATE 6-O-SULFOTRANSFERASE', 242376),
(330352, 'PTHR12812', NULL, NULL, NULL, NULL, 'HEPARAN SULFATE 6-O-SULFOTRANSFERASE 3', 242376),
(330353, 'PTHR12812:SF12', NULL, NULL, NULL, NULL, 'TYROSYLPROTEIN SULFOTRANSFERASE-RELATED', 242376),
(330354, 'PTHR12812:SF10', NULL, NULL, NULL, NULL, 'BNAANNG15430D PROTEIN', 242376),
(330355, 'PTHR12812:SF6', NULL, NULL, NULL, NULL, 'HEPARAN-SULFATE 6-O-SULFOTRANSFERASE 2', 242376),
(330356, 'PTHR12812:SF3', NULL, NULL, NULL, NULL, 'HEPARAN-SULFATE 6-O-SULFOTRANSFERASE 3', 242376),
(330357, 'PTHR34958', NULL, NULL, NULL, NULL, 'CONDITIONAL LOSS-OF-GROWTH 1', 242377),
(330358, 'PTHR34958:SF1', NULL, NULL, NULL, NULL, 'CONDITIONAL LOSS-OF-GROWTH 1', 242377),
(330359, 'PTHR12565:SF428', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 242378),
(330360, 'PTHR12565:SF429', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 242378),
(330361, 'PTHR12565:SF426', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTION FACTOR', 242378),
(330362, 'PTHR12565:SF340', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BEE 3', 242378),
(330363, 'PTHR12565:SF184', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTION FACTOR', 242378),
(330364, 'PTHR12565:SF382', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 242378),
(330365, 'PTHR12565:SF380', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 242378),
(330366, 'PTHR12565:SF424', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN-CONTAINING PROTEIN-RELATED', 242378),
(330367, 'PTHR12565', NULL, NULL, NULL, NULL, 'STEROL REGULATORY ELEMENT-BINDING PROTEIN', 242378),
(330368, 'PTHR12565:SF389', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BEE 3-LIKE', 242378),
(330369, 'PTHR12565:SF423', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 242378),
(330370, 'PTHR12565:SF302', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTION FACTOR', 242378),
(330371, 'PTHR12565:SF420', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN-CONTAINING PROTEIN-RELATED', 242378),
(330372, 'PTHR12565:SF343', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 242378),
(330373, 'PTHR12565:SF418', NULL, NULL, NULL, NULL, 'BHLH-TRANSCRIPTION FACTOR', 242378),
(330374, 'PTHR12565:SF415', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 242378),
(330375, 'PTHR12565:SF339', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH77-LIKE', 242378),
(330376, 'PTHR12565:SF372', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 242378),
(330377, 'PTHR12565:SF450', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH78-LIKE', 242378),
(330378, 'PTHR12565:SF373', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 242378),
(330379, 'PTHR12565:SF414', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BEE 1', 242378),
(330380, 'PTHR12565:SF411', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH79-LIKE ISOFORM X1', 242378),
(330381, 'PTHR12565:SF378', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 242378),
(330382, 'PTHR12565:SF334', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH49-RELATED', 242378),
(330383, 'PTHR12565:SF412', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN-CONTAINING PROTEIN-RELATED', 242378),
(330384, 'PTHR12565:SF335', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BEE 2-LIKE ISOFORM X1', 242378),
(330385, 'PTHR12565:SF376', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 242378),
(330386, 'PTHR12565:SF453', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH77', 242378),
(330387, 'PTHR12565:SF451', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTION FACTOR', 242378),
(330388, 'PTHR12565:SF452', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 242378);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(330389, 'PTHR12565:SF409', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 242378),
(330390, 'PTHR12565:SF406', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH79', 242378),
(330391, 'PTHR12565:SF407', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN-CONTAINING PROTEIN-RELATED', 242378),
(330392, 'PTHR12565:SF448', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTION FACTOR', 242378),
(330393, 'PTHR12565:SF404', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BEE 2', 242378),
(330394, 'PTHR12565:SF449', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN-CONTAINING PROTEIN-RELATED', 242378),
(330395, 'PTHR12565:SF328', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH77-LIKE', 242378),
(330396, 'PTHR12565:SF362', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 242378),
(330397, 'PTHR12565:SF446', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 242378),
(330398, 'PTHR12565:SF325', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH78', 242378),
(330399, 'PTHR12565:SF369', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 242378),
(330400, 'PTHR12565:SF403', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTION FACTOR', 242378),
(330401, 'PTHR12565:SF447', NULL, NULL, NULL, NULL, 'BR ENHANCED EXPRESSION 3-RELATED', 242378),
(330402, 'PTHR12565:SF444', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH63', 242378),
(330403, 'PTHR12565:SF400', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 242378),
(330404, 'PTHR12565:SF367', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH75', 242378),
(330405, 'PTHR12565:SF169', NULL, NULL, NULL, NULL, 'OS08G0524800 PROTEIN', 242378),
(330406, 'PTHR12565:SF445', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN-CONTAINING PROTEIN-RELATED', 242378),
(330407, 'PTHR12565:SF368', NULL, NULL, NULL, NULL, 'OS03G0231950 PROTEIN', 242378),
(330408, 'PTHR12565:SF321', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BPE', 242378),
(330409, 'PTHR12565:SF442', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR HBI1', 242378),
(330410, 'PTHR12565:SF443', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH62', 242378),
(330411, 'PTHR12565:SF440', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 242378),
(330412, 'PTHR12565:SF441', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH49-LIKE ISOFORM X1', 242378),
(330413, 'PTHR12565:SF439', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN-CONTAINING PROTEIN-RELATED', 242378),
(330414, 'PTHR12565:SF319', NULL, NULL, NULL, NULL, 'OS02G0705500 PROTEIN', 242378),
(330415, 'PTHR12565:SF437', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH49-LIKE', 242378),
(330416, 'PTHR12565:SF438', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN-CONTAINING PROTEIN-RELATED', 242378),
(330417, 'PTHR12565:SF393', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH63-LIKE ISOFORM X1', 242378),
(330418, 'PTHR12565:SF390', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 242378),
(330419, 'PTHR12565:SF358', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH FAMILY-RELATED', 242378),
(330420, 'PTHR12565:SF315', NULL, NULL, NULL, NULL, 'OS09G0501600 PROTEIN', 242378),
(330421, 'PTHR12565:SF436', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BEE 2-LIKE ISOFORM X1', 242378),
(330422, 'PTHR12565:SF433', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN-CONTAINING PROTEIN-RELATED', 242378),
(330423, 'PTHR12565:SF312', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH74', 242378),
(330424, 'PTHR12565:SF354', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 242378),
(330425, 'PTHR12565:SF112', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH48-RELATED', 242378),
(330426, 'PTHR12565:SF431', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH137', 242378),
(330427, 'PTHR12565:SF432', NULL, NULL, NULL, NULL, 'OS06G0275600 PROTEIN', 242378),
(330428, 'PTHR12565:SF399', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH78-LIKE', 242378),
(330429, 'PTHR12565:SF430', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN-CONTAINING PROTEIN-RELATED', 242378);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(330430, 'PTHR21558', NULL, NULL, NULL, NULL, 'SPEER/SPETEX', 242379),
(330431, 'PTHR21558:SF13', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4930572O03 GENE-RELATED', 242379),
(330432, 'PTHR21558:SF12', NULL, NULL, NULL, NULL, '2610042L04RIK PROTEIN-RELATED', 242379),
(330433, 'PTHR21558:SF40', NULL, NULL, NULL, NULL, 'ENSMUSG00000072602 PROTEIN-RELATED', 242379),
(330434, 'PTHR46856', NULL, NULL, NULL, NULL, 'PX DOMAIN-CONTAINING PROTEIN EREL1-RELATED', 242380),
(330435, 'PTHR46856:SF1', NULL, NULL, NULL, NULL, 'PX DOMAIN-CONTAINING PROTEIN EREL1-RELATED', 242380),
(330436, 'PTHR46856:SF3', NULL, NULL, NULL, NULL, 'PX DOMAIN-CONTAINING PROTEIN EREX', 242380),
(330437, 'PTHR46856:SF4', NULL, NULL, NULL, NULL, 'BNAA03G51930D PROTEIN', 242380),
(330438, 'PTHR41403:SF3', NULL, NULL, NULL, NULL, 'RCG43477-RELATED', 242381),
(330439, 'PTHR41403:SF2', NULL, NULL, NULL, NULL, '', 242381),
(330440, 'PTHR41403', NULL, NULL, NULL, NULL, 'RCG43477-RELATED', 242381),
(330441, 'PTHR35408:SF3', NULL, NULL, NULL, NULL, 'GLYCO_TRANS_2-LIKE DOMAIN-CONTAINING PROTEIN', 242382),
(330442, 'PTHR35408:SF1', NULL, NULL, NULL, NULL, 'GLYCO_TRANS_2-LIKE DOMAIN-CONTAINING PROTEIN', 242382),
(330443, 'PTHR35408:SF2', NULL, NULL, NULL, NULL, 'GLYCO_TRANS_2-LIKE DOMAIN-CONTAINING PROTEIN', 242382),
(330444, 'PTHR35408', NULL, NULL, NULL, NULL, 'CHROMOSOME 15, WHOLE GENOME SHOTGUN SEQUENCE', 242382),
(330445, 'PTHR33588:SF1', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 299', 242383),
(330446, 'PTHR33588', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 299', 242383),
(330447, 'PTHR46725', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 57', 242384),
(330448, 'PTHR46725:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 57', 242384),
(330449, 'PTHR43807:SF6', NULL, NULL, NULL, NULL, 'KYNURENINE--OXOGLUTARATE TRANSAMINASE 3', 242385),
(330450, 'PTHR43807:SF20', NULL, NULL, NULL, NULL, 'FI04487P', 242385),
(330451, 'PTHR43807', NULL, NULL, NULL, NULL, 'FI04487P', 242385),
(330452, 'PTHR43807:SF12', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE, CLASSES I AND II FAMILY PROTEIN, EXPRESSED', 242385),
(330453, 'PTHR43807:SF14', NULL, NULL, NULL, NULL, 'KYNURENINE--OXOGLUTARATE TRANSAMINASE 1', 242385),
(330454, 'PTHR28184:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL HOMOLOGOUS RECOMBINATION PROTEIN 1', 242386),
(330455, 'PTHR28184', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL HOMOLOGOUS RECOMBINATION PROTEIN 1', 242386),
(330456, 'PTHR46185:SF1', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-1', 242387),
(330457, 'PTHR46185', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-1', 242387),
(330458, 'PTHR42955:SF1', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE', 242388),
(330459, 'PTHR42955', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE', 242388),
(330460, 'PTHR18914:SF21', NULL, NULL, NULL, NULL, 'CATENIN ALPHA-3', 242389),
(330461, 'PTHR18914:SF33', NULL, NULL, NULL, NULL, 'RE47911P-RELATED', 242389),
(330462, 'PTHR18914:SF23', NULL, NULL, NULL, NULL, 'CATENIN ALPHA-2', 242389),
(330463, 'PTHR18914', NULL, NULL, NULL, NULL, 'ALPHA CATENIN', 242389),
(330464, 'PTHR18914:SF30', NULL, NULL, NULL, NULL, 'VINCULIN/ALPHA-CATENIN FAMILY MEMBER 1', 242389),
(330465, 'PTHR18914:SF9', NULL, NULL, NULL, NULL, 'CATENIN ALPHA', 242389),
(330466, 'PTHR18914:SF24', NULL, NULL, NULL, NULL, 'CATENIN ALPHA-1', 242389),
(330467, 'PTHR10612:SF11', NULL, NULL, NULL, NULL, 'KARL, ISOFORM A', 242390),
(330468, 'PTHR10612:SF55', NULL, NULL, NULL, NULL, 'TEMPERATURE-INDUCED LIPOCALIN', 242390),
(330469, 'PTHR10612:SF44', NULL, NULL, NULL, NULL, 'TEMPERATURE-INDUCED LIPOCALIN-1-LIKE', 242390),
(330470, 'PTHR10612:SF54', NULL, NULL, NULL, NULL, 'TEMPERATURE-INDUCED LIPOCALIN', 242390),
(330471, 'PTHR10612:SF41', NULL, NULL, NULL, NULL, 'GLIAL LAZARILLO, ISOFORM A', 242390),
(330472, 'PTHR10612:SF15', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN D', 242390),
(330473, 'PTHR10612:SF59', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE LIPOPROTEIN BLC', 242390),
(330474, 'PTHR10612:SF58', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN D', 242390);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(330475, 'PTHR10612:SF14', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN D', 242390),
(330476, 'PTHR10612:SF47', NULL, NULL, NULL, NULL, 'LIPOCALIN-RELATED', 242390),
(330477, 'PTHR10612:SF57', NULL, NULL, NULL, NULL, 'LIPOCLN_CYTOSOLIC_FA-BD_DOM DOMAIN-CONTAINING PROTEIN', 242390),
(330478, 'PTHR10612:SF34', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN D', 242390),
(330479, 'PTHR10612:SF56', NULL, NULL, NULL, NULL, 'LIPOCLN_CYTOSOLIC_FA-BD_DOM DOMAIN-CONTAINING PROTEIN', 242390),
(330480, 'PTHR10612:SF49', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN D', 242390),
(330481, 'PTHR10612', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN D', 242390),
(330482, 'PTHR10612:SF51', NULL, NULL, NULL, NULL, 'LIPOCLN_CYTOSOLIC_FA-BD_DOM DOMAIN-CONTAINING PROTEIN', 242390),
(330483, 'PTHR10612:SF61', NULL, NULL, NULL, NULL, 'OS02G0612900 PROTEIN', 242390),
(330484, 'PTHR10612:SF50', NULL, NULL, NULL, NULL, 'LIPOCLN_CYTOSOLIC_FA-BD_DOM DOMAIN-CONTAINING PROTEIN', 242390),
(330485, 'PTHR10612:SF60', NULL, NULL, NULL, NULL, 'LIPOCLN_CYTOSOLIC_FA-BD_DOM DOMAIN-CONTAINING PROTEIN', 242390),
(330486, 'PTHR48201', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 242391),
(330487, 'PTHR48201:SF12', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 242391),
(330488, 'PTHR21425', NULL, NULL, NULL, NULL, 'NICE-3', 242392),
(330489, 'PTHR21425:SF2', NULL, NULL, NULL, NULL, 'PROTEIN C1ORF43', 242392),
(330490, 'PTHR34236', NULL, NULL, NULL, NULL, 'DIMETHYL SULFOXIDE REDUCTASE TRANSCRIPTIONAL ACTIVATOR', 242393),
(330491, 'PTHR34236:SF1', NULL, NULL, NULL, NULL, 'DIMETHYL SULFOXIDE REDUCTASE TRANSCRIPTIONAL ACTIVATOR', 242393),
(330492, 'PTHR46909:SF2', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN', 242394),
(330493, 'PTHR46909:SF1', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L36, MITOCHONDRIAL', 242394),
(330494, 'PTHR46909', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L36, MITOCHONDRIAL', 242394),
(330495, 'PTHR46909:SF3', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L36, MITOCHONDRIAL', 242394),
(330496, 'PTHR46203', NULL, NULL, NULL, NULL, 'PROBABLE PEPTIDE CHAIN RELEASE FACTOR C12ORF65', 242395),
(330497, 'PTHR46203:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL TRANSLATION RELEASE FACTOR IN RESCUE', 242395),
(330498, 'PTHR33591', NULL, NULL, NULL, NULL, 'BETA-CAROTENE ISOMERASE D27', 242396),
(330499, 'PTHR33591:SF7', NULL, NULL, NULL, NULL, 'DUF4033 DOMAIN-CONTAINING PROTEIN', 242396),
(330500, 'PTHR33591:SF6', NULL, NULL, NULL, NULL, 'DUF4033 DOMAIN-CONTAINING PROTEIN', 242396),
(330501, 'PTHR33591:SF5', NULL, NULL, NULL, NULL, 'DUF4033 DOMAIN-CONTAINING PROTEIN', 242396),
(330502, 'PTHR33591:SF4', NULL, NULL, NULL, NULL, 'OS08G0114100 PROTEIN', 242396),
(330503, 'PTHR33591:SF2', NULL, NULL, NULL, NULL, 'BETA-CAROTENE ISOMERASE D27', 242396),
(330504, 'PTHR33591:SF1', NULL, NULL, NULL, NULL, 'BETA-CAROTENE ISOMERASE D27, CHLOROPLASTIC', 242396),
(330505, 'PTHR22991:SF40', NULL, NULL, NULL, NULL, 'PROTEIN CBG13490', 242397),
(330506, 'PTHR22991:SF41', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN', 242397),
(330507, 'PTHR22991', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 242397),
(330508, 'PTHR22991:SF44', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN-RELATED', 242397),
(330509, 'PTHR22991:SF42', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN', 242397),
(330510, 'PTHR22991:SF43', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN', 242397),
(330511, 'PTHR24256:SF451', NULL, NULL, NULL, NULL, 'SERINE PROTEASE P12', 242398),
(330512, 'PTHR24256:SF173', NULL, NULL, NULL, NULL, 'TESTISIN', 242398),
(330513, 'PTHR24256:SF458', NULL, NULL, NULL, NULL, 'AGAP005686-PA', 242398),
(330514, 'PTHR24256:SF534', NULL, NULL, NULL, NULL, 'SERINE PROTEASE 30', 242398),
(330515, 'PTHR24256:SF537', NULL, NULL, NULL, NULL, 'CLIP DOMAIN-CONTAINING SERINE PROTEASE-RELATED', 242398),
(330516, 'PTHR24256:SF453', NULL, NULL, NULL, NULL, 'SERINE PROTEASE H57', 242398),
(330517, 'PTHR24256:SF214', NULL, NULL, NULL, NULL, 'SERINE PROTEASE 47-RELATED', 242398),
(330518, 'PTHR24256:SF532', NULL, NULL, NULL, NULL, 'TRYPTASE ALPHA/BETA-1-RELATED', 242398),
(330519, 'PTHR24256:SF219', NULL, NULL, NULL, NULL, 'SERINE PROTEASE 33', 242398);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(330520, 'PTHR24256:SF560', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 242398),
(330521, 'PTHR24256:SF562', NULL, NULL, NULL, NULL, 'IP09525P-RELATED', 242398),
(330522, 'PTHR24256:SF441', NULL, NULL, NULL, NULL, 'SERINE PROTEASE 29-RELATED', 242398),
(330523, 'PTHR24256:SF561', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 242398),
(330524, 'PTHR24256:SF205', NULL, NULL, NULL, NULL, 'SERINE PROTEASE 46', 242398),
(330525, 'PTHR24256:SF524', NULL, NULL, NULL, NULL, 'HAPTOGLOBIN', 242398),
(330526, 'PTHR24256:SF523', NULL, NULL, NULL, NULL, 'PROTEASE, SERINE 32', 242398),
(330527, 'PTHR24256:SF446', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 242398),
(330528, 'PTHR24256:SF525', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 242398),
(330529, 'PTHR24256:SF487', NULL, NULL, NULL, NULL, 'TRYPTASE GAMMA', 242398),
(330530, 'PTHR24256:SF563', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 242398),
(330531, 'PTHR24256:SF521', NULL, NULL, NULL, NULL, 'TRYPTASE DELTA', 242398),
(330532, 'PTHR24256:SF246', NULL, NULL, NULL, NULL, 'SERINE PROTEASE 42-RELATED', 242398),
(330533, 'PTHR24256:SF329', NULL, NULL, NULL, NULL, 'MAST CELL PROTEASE-11', 242398),
(330534, 'PTHR24256:SF527', NULL, NULL, NULL, NULL, 'SERINE PROTEASE EASTER', 242398),
(330535, 'PTHR24256:SF551', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 242398),
(330536, 'PTHR24256:SF550', NULL, NULL, NULL, NULL, 'SERINE PROTEASE SP24D', 242398),
(330537, 'PTHR24256:SF470', NULL, NULL, NULL, NULL, 'IP10114P-RELATED', 242398),
(330538, 'PTHR24256:SF151', NULL, NULL, NULL, NULL, 'SERINE PROTEASE 44-RELATED', 242398),
(330539, 'PTHR24256:SF557', NULL, NULL, NULL, NULL, 'MIP04821P', 242398),
(330540, 'PTHR24256:SF556', NULL, NULL, NULL, NULL, 'SERINE PROTEASE P52', 242398),
(330541, 'PTHR24256:SF559', NULL, NULL, NULL, NULL, 'SERINE PROTEASE P11', 242398),
(330542, 'PTHR24256:SF558', NULL, NULL, NULL, NULL, 'SERINE PROTEASE H164', 242398),
(330543, 'PTHR24256:SF316', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 242398),
(330544, 'PTHR24256:SF553', NULL, NULL, NULL, NULL, 'IP20273P-RELATED', 242398),
(330545, 'PTHR24256:SF552', NULL, NULL, NULL, NULL, 'ENZYME PRECURSOR, PUTATIVE-RELATED', 242398),
(330546, 'PTHR24256:SF555', NULL, NULL, NULL, NULL, 'FI19801P1-RELATED', 242398),
(330547, 'PTHR24256:SF477', NULL, NULL, NULL, NULL, 'LD47230P-RELATED', 242398),
(330548, 'PTHR24256', NULL, NULL, NULL, NULL, 'TRYPTASE-RELATED', 242398),
(330549, 'PTHR24256:SF554', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 242398),
(330550, 'PTHR24256:SF519', NULL, NULL, NULL, NULL, 'INACTIVE SERINE PROTEASE 54', 242398),
(330551, 'PTHR24256:SF540', NULL, NULL, NULL, NULL, 'LETHAL (2) K05911', 242398),
(330552, 'PTHR24256:SF462', NULL, NULL, NULL, NULL, 'FI06461P-RELATED', 242398),
(330553, 'PTHR24256:SF140', NULL, NULL, NULL, NULL, 'SERINE PROTEASE 45-RELATED', 242398),
(330554, 'PTHR24256:SF546', NULL, NULL, NULL, NULL, 'MIP11562P-RELATED', 242398),
(330555, 'PTHR24256:SF545', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 242398),
(330556, 'PTHR24256:SF548', NULL, NULL, NULL, NULL, 'CLIP DOMAIN-CONTAINING SERINE PROTEASE', 242398),
(330557, 'PTHR24256:SF547', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 242398),
(330558, 'PTHR24256:SF542', NULL, NULL, NULL, NULL, 'SERINE PROTEASE H129', 242398),
(330559, 'PTHR24256:SF541', NULL, NULL, NULL, NULL, 'INACTIVE SERINE PROTEASE 39-RELATED', 242398),
(330560, 'PTHR24256:SF544', NULL, NULL, NULL, NULL, 'SI:DKEY-16L2.17-RELATED', 242398),
(330561, 'PTHR24256:SF301', NULL, NULL, NULL, NULL, 'SERINE PROTEASE 28', 242398),
(330562, 'PTHR24256:SF543', NULL, NULL, NULL, NULL, 'SERINE PROTEASE H65', 242398),
(330563, 'PTHR24256:SF549', NULL, NULL, NULL, NULL, '', 242398),
(330564, 'PTHR24256:SF309', NULL, NULL, NULL, NULL, 'SERINE PROTEASE 48', 242398),
(330565, 'PTHR34541:SF2', NULL, NULL, NULL, NULL, 'OS01G0729900 PROTEIN', 242399);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(330566, 'PTHR34541:SF3', NULL, NULL, NULL, NULL, 'OS05G0530300 PROTEIN', 242399),
(330567, 'PTHR34541:SF4', NULL, NULL, NULL, NULL, 'EPSTEIN-BARR NUCLEAR ANTIGEN', 242399),
(330568, 'PTHR34541', NULL, NULL, NULL, NULL, 'OS01G0729900 PROTEIN', 242399),
(330569, 'PTHR34541:SF1', NULL, NULL, NULL, NULL, 'OS06G0152800 PROTEIN', 242399),
(330570, 'PTHR25462:SF295', NULL, NULL, NULL, NULL, 'B BOX-TYPE DOMAIN-CONTAINING PROTEIN', 242400),
(330571, 'PTHR25462:SF274', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INTERMEDIARY FACTOR 1-BETA', 242400),
(330572, 'PTHR25462:SF285', NULL, NULL, NULL, NULL, 'B BOX-TYPE DOMAIN-CONTAINING PROTEIN', 242400),
(330573, 'PTHR25462:SF296', NULL, NULL, NULL, NULL, 'PROTEIN PML', 242400),
(330574, 'PTHR25462:SF297', NULL, NULL, NULL, NULL, 'CONSERVED ZINC-FINGER PROTEIN', 242400),
(330575, 'PTHR25462:SF276', NULL, NULL, NULL, NULL, 'MEIOTIC P26, ISOFORM F', 242400),
(330576, 'PTHR25462:SF298', NULL, NULL, NULL, NULL, '', 242400),
(330577, 'PTHR25462:SF255', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF CONTAINING 42', 242400),
(330578, 'PTHR25462:SF266', NULL, NULL, NULL, NULL, 'BONUS, ISOFORM C', 242400),
(330579, 'PTHR25462:SF229', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM56', 242400),
(330580, 'PTHR25462', NULL, NULL, NULL, NULL, 'BONUS, ISOFORM C-RELATED', 242400),
(330581, 'PTHR25462:SF291', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 45', 242400),
(330582, 'PTHR25462:SF292', NULL, NULL, NULL, NULL, 'B BOX-TYPE DOMAIN-CONTAINING PROTEIN', 242400),
(330583, 'PTHR25462:SF293', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING 63A', 242400),
(330584, 'PTHR25462:SF294', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING 59', 242400),
(330585, 'PTHR43579', NULL, NULL, NULL, NULL, '', 242401),
(330586, 'PTHR43579:SF1', NULL, NULL, NULL, NULL, 'NEUTRAL METALLOPROTEINASE', 242401),
(330587, 'PTHR42038:SF3', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_5G14600)', 242402),
(330588, 'PTHR42038:SF2', NULL, NULL, NULL, NULL, 'TERPENE CYCLASE AUSL', 242402),
(330589, 'PTHR42038:SF4', NULL, NULL, NULL, NULL, '', 242402),
(330590, 'PTHR42038', NULL, NULL, NULL, NULL, '', 242402),
(330591, 'PTHR10293:SF70', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-LIKE PROTEIN', 242403),
(330592, 'PTHR10293', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN FAMILY MEMBER', 242403),
(330593, 'PTHR10293:SF58', NULL, NULL, NULL, NULL, 'MONOTHIOL GLUTAREDOXIN-S1, MITOCHONDRIAL', 242403),
(330594, 'PTHR10293:SF16', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-RELATED PROTEIN 5, MITOCHONDRIAL', 242403),
(330595, 'PTHR10293:SF65', NULL, NULL, NULL, NULL, '', 242403),
(330596, 'PTHR10293:SF45', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL MONOTHIOL GLUTAREDOXIN-S16, CHLOROPLASTIC', 242403),
(330597, 'PTHR10293:SF67', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 242403),
(330598, 'PTHR10293:SF72', NULL, NULL, NULL, NULL, 'MONOTHIOL GLUTAREDOXIN-S14, CHLOROPLASTIC', 242403),
(330599, 'PTHR10293:SF71', NULL, NULL, NULL, NULL, 'BNAA09G20130D PROTEIN', 242403),
(330600, 'PTHR10293:SF73', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-3', 242403),
(330601, 'PTHR10293:SF62', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-LIKE PROTEIN', 242403),
(330602, 'PTHR43503', NULL, NULL, NULL, NULL, 'MCG48959-RELATED', 242404),
(330603, 'PTHR43503:SF9', NULL, NULL, NULL, NULL, 'PEROXIREDOXIN PRX1, MITOCHONDRIAL', 242404),
(330604, 'PTHR43503:SF2', NULL, NULL, NULL, NULL, 'NEGATIVE REGULATOR OF SPORULATION MDS3-RELATED', 242404),
(330605, 'PTHR43503:SF3', NULL, NULL, NULL, NULL, 'DI01187P-RELATED', 242404),
(330606, 'PTHR43503:SF4', NULL, NULL, NULL, NULL, 'PEROXIREDOXIN-6', 242404),
(330607, 'PTHR43503:SF11', NULL, NULL, NULL, NULL, 'PEROXIREDOXIN-6', 242404),
(330608, 'PTHR43503:SF12', NULL, NULL, NULL, NULL, 'PEROXIREDOXIN', 242404),
(330609, 'PTHR43503:SF10', NULL, NULL, NULL, NULL, 'PEROXIREDOXIN-6', 242404),
(330610, 'PTHR13859:SF31', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SUPERFAMILY PROTEIN, PUTATIVE-RELATED', 242405),
(330611, 'PTHR13859:SF9', NULL, NULL, NULL, NULL, 'ATROPHIN-1', 242405);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(330612, 'PTHR13859', NULL, NULL, NULL, NULL, 'ATROPHIN-RELATED', 242405),
(330613, 'PTHR13859:SF19', NULL, NULL, NULL, NULL, 'BNAA08G26650D PROTEIN', 242405),
(330614, 'PTHR13859:SF27', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 242405),
(330615, 'PTHR13859:SF25', NULL, NULL, NULL, NULL, 'ARGININE-GLUTAMIC ACID DIPEPTIDE REPEAT PROTEIN', 242405),
(330616, 'PTHR13859:SF34', NULL, NULL, NULL, NULL, 'SANT DOMAIN-CONTAINING PROTEIN', 242405),
(330617, 'PTHR13859:SF23', NULL, NULL, NULL, NULL, 'SANT DOMAIN-CONTAINING PROTEIN', 242405),
(330618, 'PTHR13859:SF12', NULL, NULL, NULL, NULL, 'ARGININE-GLUTAMIC ACID DIPEPTIDE REPEATS PROTEIN', 242405),
(330619, 'PTHR13859:SF32', NULL, NULL, NULL, NULL, 'ELM2 DOMAIN-CONTAINING PROTEIN', 242405),
(330620, 'PTHR13859:SF21', NULL, NULL, NULL, NULL, 'SANT DOMAIN-CONTAINING PROTEIN', 242405),
(330621, 'PTHR13859:SF11', NULL, NULL, NULL, NULL, 'GRUNGE, ISOFORM J', 242405),
(330622, 'PTHR13859:SF33', NULL, NULL, NULL, NULL, 'SANT DOMAIN-CONTAINING PROTEIN', 242405),
(330623, 'PTHR13353:SF14', NULL, NULL, NULL, NULL, 'PROTEIN PGR', 242406),
(330624, 'PTHR13353:SF5', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 19', 242406),
(330625, 'PTHR13353', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 19', 242406),
(330626, 'PTHR13353:SF8', NULL, NULL, NULL, NULL, 'OS01G0178200 PROTEIN', 242406),
(330627, 'PTHR43732', NULL, NULL, NULL, NULL, 'RIBOSE 5-PHOSPHATE ISOMERASE-RELATED', 242407),
(330628, 'PTHR43732:SF1', NULL, NULL, NULL, NULL, 'RIBOSE 5-PHOSPHATE ISOMERASE', 242407),
(330629, 'PTHR38000', NULL, NULL, NULL, NULL, 'RIKEN CDNA 2900092C05', 242408),
(330630, 'PTHR38000:SF1', NULL, NULL, NULL, NULL, 'RIKEN CDNA 2900092C05 GENE', 242408),
(330631, 'PTHR24350:SF32', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE AURORA-1-RELATED', 242409),
(330632, 'PTHR24350:SF30', NULL, NULL, NULL, NULL, 'AURORA KINASE', 242409),
(330633, 'PTHR24350:SF31', NULL, NULL, NULL, NULL, 'AURORA KINASE', 242409),
(330634, 'PTHR24350', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE IAL-RELATED', 242409),
(330635, 'PTHR24350:SF8', NULL, NULL, NULL, NULL, 'AURORA KINASE', 242409),
(330636, 'PTHR24350:SF25', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE AURORA-3', 242409),
(330637, 'PTHR24350:SF5', NULL, NULL, NULL, NULL, 'AURORA KINASE A', 242409),
(330638, 'PTHR24350:SF26', NULL, NULL, NULL, NULL, 'AURORA KINASE', 242409),
(330639, 'PTHR24350:SF3', NULL, NULL, NULL, NULL, 'AURORA KINASE C', 242409),
(330640, 'PTHR24350:SF24', NULL, NULL, NULL, NULL, 'AURORA KINASE B', 242409),
(330641, 'PTHR24350:SF4', NULL, NULL, NULL, NULL, 'AURORA KINASE B', 242409),
(330642, 'PTHR24350:SF29', NULL, NULL, NULL, NULL, 'AURORA KINASE', 242409),
(330643, 'PTHR24350:SF27', NULL, NULL, NULL, NULL, 'AURORA KINASE', 242409),
(330644, 'PTHR24350:SF0', NULL, NULL, NULL, NULL, 'AURORA KINASE', 242409),
(330645, 'PTHR35136:SF1', NULL, NULL, NULL, NULL, 'CYCLOEUCALENOL CYCLOISOMERASE', 242410),
(330646, 'PTHR35136:SF2', NULL, NULL, NULL, NULL, 'BNAA09G41120D PROTEIN', 242410),
(330647, 'PTHR35136', NULL, NULL, NULL, NULL, 'CYCLOEUCALENOL CYCLOISOMERASE', 242410),
(330648, 'PTHR12302:SF2', NULL, NULL, NULL, NULL, 'STAPHYLOCOCCAL NUCLEASE DOMAIN-CONTAINING PROTEIN 1', 242411),
(330649, 'PTHR12302:SF10', NULL, NULL, NULL, NULL, 'RIBONUCLEASE', 242411),
(330650, 'PTHR12302:SF22', NULL, NULL, NULL, NULL, 'OS01G0166300 PROTEIN', 242411),
(330651, 'PTHR12302:SF3', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 31', 242411),
(330652, 'PTHR12302:SF25', NULL, NULL, NULL, NULL, 'TNASE-LIKE DOMAIN-CONTAINING PROTEIN', 242411),
(330653, 'PTHR12302:SF9', NULL, NULL, NULL, NULL, 'RIBONUCLEASE TUDOR 1', 242411),
(330654, 'PTHR12302:SF26', NULL, NULL, NULL, NULL, 'SUCCINOGLYCAN BIOSYNTHESIS PROTEIN', 242411),
(330655, 'PTHR12302:SF23', NULL, NULL, NULL, NULL, 'TNASE-LIKE DOMAIN-CONTAINING PROTEIN', 242411),
(330656, 'PTHR12302:SF12', NULL, NULL, NULL, NULL, 'STAPHYLOCOCCAL-LIKE NUCLEASE CAN2', 242411),
(330657, 'PTHR12302:SF24', NULL, NULL, NULL, NULL, 'STAPHYLOCOCCAL-LIKE NUCLEASE CAN1', 242411); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(330658, 'PTHR12302', NULL, NULL, NULL, NULL, 'EBNA2 BINDING PROTEIN P100', 242411),
(330659, 'PTHR12302:SF17', NULL, NULL, NULL, NULL, 'STAPHYLOCOCCAL-LIKE NUCLEASE CAN3-RELATED', 242411),
(330660, 'PTHR44191:SF61', NULL, NULL, NULL, NULL, 'OS08G0151000 PROTEIN', 242412),
(330661, 'PTHR44191:SF40', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 242412),
(330662, 'PTHR44191:SF62', NULL, NULL, NULL, NULL, 'MYB DOMAIN PROTEIN', 242412),
(330663, 'PTHR44191:SF63', NULL, NULL, NULL, NULL, '', 242412),
(330664, 'PTHR44191', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR KUA1', 242412),
(330665, 'PTHR44191:SF42', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 242412),
(330666, 'PTHR44191:SF64', NULL, NULL, NULL, NULL, 'F25A4.19 PROTEIN', 242412),
(330667, 'PTHR44191:SF43', NULL, NULL, NULL, NULL, 'BNAC01G21010D PROTEIN', 242412),
(330668, 'PTHR44191:SF65', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB1R1-LIKE ISOFORM X1', 242412),
(330669, 'PTHR44191:SF21', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SRM1', 242412),
(330670, 'PTHR44191:SF7', NULL, NULL, NULL, NULL, 'BNACNNG62030D PROTEIN', 242412),
(330671, 'PTHR44191:SF66', NULL, NULL, NULL, NULL, 'MYB-LIKE TRANSCRIPTION FACTOR FAMILY PROTEIN', 242412),
(330672, 'PTHR44191:SF44', NULL, NULL, NULL, NULL, 'MYBR DOMAIN CLASS TRANSCRIPTION FACTOR', 242412),
(330673, 'PTHR44191:SF67', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SRM1-LIKE', 242412),
(330674, 'PTHR44191:SF45', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 242412),
(330675, 'PTHR44191:SF23', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE TRANSCRIPTIONAL REGULATOR-RELATED', 242412),
(330676, 'PTHR44191:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYBS1', 242412),
(330677, 'PTHR44191:SF68', NULL, NULL, NULL, NULL, 'DNA BINDING PROTEIN', 242412),
(330678, 'PTHR44191:SF25', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB1R1-LIKE', 242412),
(330679, 'PTHR44191:SF69', NULL, NULL, NULL, NULL, 'MYB-LIKE DNA-BINDING DOMAIN, SHAQKYF CLASS PROTEIN', 242412),
(330680, 'PTHR44191:SF26', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR KUA1', 242412),
(330681, 'PTHR44191:SF4', NULL, NULL, NULL, NULL, 'OS01G0187900 PROTEIN', 242412),
(330682, 'PTHR44191:SF70', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYBS2', 242412),
(330683, 'PTHR44191:SF71', NULL, NULL, NULL, NULL, 'MYB DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 242412),
(330684, 'PTHR44191:SF72', NULL, NULL, NULL, NULL, 'BNAA03G55780D PROTEIN', 242412),
(330685, 'PTHR44191:SF73', NULL, NULL, NULL, NULL, 'I-BOX BINDING FACTOR', 242412),
(330686, 'PTHR44191:SF30', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 242412),
(330687, 'PTHR44191:SF74', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 242412),
(330688, 'PTHR44191:SF17', NULL, NULL, NULL, NULL, 'I-BOX BINDING FACTOR', 242412),
(330689, 'PTHR44191:SF18', NULL, NULL, NULL, NULL, 'OS04G0341900 PROTEIN', 242412),
(330690, 'PTHR44191:SF75', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE TRANSCRIPTIONAL REGULATOR', 242412),
(330691, 'PTHR44191:SF31', NULL, NULL, NULL, NULL, 'BNAC02G02590D PROTEIN', 242412),
(330692, 'PTHR44191:SF53', NULL, NULL, NULL, NULL, 'MYB-LIKE TRANSCRIPTION FACTOR FAMILY PROTEIN', 242412),
(330693, 'PTHR44191:SF32', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 242412),
(330694, 'PTHR44191:SF76', NULL, NULL, NULL, NULL, 'BNACNNG46710D PROTEIN', 242412),
(330695, 'PTHR44191:SF77', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 242412),
(330696, 'PTHR44191:SF33', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 242412),
(330697, 'PTHR44191:SF34', NULL, NULL, NULL, NULL, 'BNAC07G34310D PROTEIN', 242412),
(330698, 'PTHR44191:SF78', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB1R1', 242412),
(330699, 'PTHR44191:SF13', NULL, NULL, NULL, NULL, 'DUPLICATED HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN', 242412),
(330700, 'PTHR44191:SF35', NULL, NULL, NULL, NULL, 'I-BOX BINDING FACTOR', 242412),
(330701, 'PTHR44191:SF57', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB1R1-LIKE', 242412);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(330702, 'PTHR44191:SF36', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN', 242412),
(330703, 'PTHR44191:SF16', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 242412),
(330704, 'PTHR10536:SF0', NULL, NULL, NULL, NULL, 'DNA PRIMASE SMALL SUBUNIT', 242413),
(330705, 'PTHR10536:SF1', NULL, NULL, NULL, NULL, 'DNA PRIMASE', 242413),
(330706, 'PTHR10536', NULL, NULL, NULL, NULL, 'DNA PRIMASE SMALL SUBUNIT', 242413),
(330707, 'PTHR21057:SF2', NULL, NULL, NULL, NULL, '2-DEHYDRO-3-DEOXYPHOSPHOOCTONATE ALDOLASE 1-RELATED', 242414),
(330708, 'PTHR21057', NULL, NULL, NULL, NULL, 'PHOSPHO-2-DEHYDRO-3-DEOXYHEPTONATE ALDOLASE', 242414),
(330709, 'PTHR30272:SF8', NULL, NULL, NULL, NULL, '3-HYDROXYDECANOYL-[ACYL-CARRIER-PROTEIN] DEHYDRATASE', 242415),
(330710, 'PTHR30272:SF3', NULL, NULL, NULL, NULL, '(3R)-HYDROXYMYRISTOYL-[ACYL CARRIER PROTEIN] DEHYDRATASE', 242415),
(330711, 'PTHR30272:SF16', NULL, NULL, NULL, NULL, '(3R)-HYDROXYMYRISTOYL-[ACYL-CARRIER-PROTEIN] DEHYDRATASE', 242415),
(330712, 'PTHR30272:SF15', NULL, NULL, NULL, NULL, '(3R)-HYDROXYMYRISTOYL-[ACYL-CARRIER-PROTEIN] DEHYDRATASE', 242415),
(330713, 'PTHR30272', NULL, NULL, NULL, NULL, '3-HYDROXYACYL-[ACYL-CARRIER-PROTEIN] DEHYDRATASE', 242415),
(330714, 'PTHR30272:SF13', NULL, NULL, NULL, NULL, '(3R)-HYDROXYMYRISTOYL-[ACYL-CARRIER-PROTEIN] DEHYDRATASE', 242415),
(330715, 'PTHR30272:SF1', NULL, NULL, NULL, NULL, '(3R)-HYDROXYMYRISTOYL-[ACYL-CARRIER-PROTEIN] DEHYDRATASE', 242415),
(330716, 'PTHR30272:SF11', NULL, NULL, NULL, NULL, '(3R)-HYDROXYMYRISTOYL-[ACYL-CARRIER-PROTEIN] DEHYDRATASE', 242415),
(330717, 'PTHR10110:SF116', NULL, NULL, NULL, NULL, 'NA+/H+ EXCHANGER', 242416),
(330718, 'PTHR10110:SF117', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER 2', 242416),
(330719, 'PTHR10110:SF112', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER', 242416),
(330720, 'PTHR10110:SF179', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER 4', 242416),
(330721, 'PTHR10110:SF159', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER 3', 242416),
(330722, 'PTHR10110:SF174', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER 8-LIKE', 242416),
(330723, 'PTHR10110:SF153', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER', 242416),
(330724, 'PTHR10110:SF154', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER', 242416),
(330725, 'PTHR10110:SF177', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER', 242416),
(330726, 'PTHR10110:SF192', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER', 242416),
(330727, 'PTHR10110:SF170', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 242416),
(330728, 'PTHR10110:SF171', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 242416),
(330729, 'PTHR10110:SF193', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER', 242416),
(330730, 'PTHR10110:SF172', NULL, NULL, NULL, NULL, 'NA+/H+ EXCHANGER, CATION/H+ EXCHANGER, CATION/H+ EXCHANGER, CPA1 FAMILY-RELATED', 242416),
(330731, 'PTHR10110:SF194', NULL, NULL, NULL, NULL, 'NA(+)/H(+) ANTIPORTER NHX-3-RELATED', 242416),
(330732, 'PTHR10110:SF195', NULL, NULL, NULL, NULL, 'LOW-AFFINITY NA(+)/H(+) ANTIPORTER NHAS1', 242416),
(330733, 'PTHR10110:SF94', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER 6', 242416),
(330734, 'PTHR10110:SF180', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER', 242416),
(330735, 'PTHR10110:SF90', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER 3', 242416),
(330736, 'PTHR10110:SF91', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER 11', 242416),
(330737, 'PTHR10110:SF92', NULL, NULL, NULL, NULL, 'NA(+)/H(+) EXCHANGER PROTEIN 2-RELATED', 242416),
(330738, 'PTHR10110:SF59', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER 1', 242416),
(330739, 'PTHR10110:SF98', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER', 242416),
(330740, 'PTHR10110:SF99', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER', 242416),
(330741, 'PTHR10110:SF56', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER 5', 242416),
(330742, 'PTHR10110:SF127', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER 5-RELATED', 242416);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(330743, 'PTHR10110:SF128', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER 1', 242416),
(330744, 'PTHR10110:SF167', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 242416),
(330745, 'PTHR10110:SF103', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER 4', 242416),
(330746, 'PTHR10110:SF169', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER', 242416),
(330747, 'PTHR10110:SF125', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER', 242416),
(330748, 'PTHR10110:SF126', NULL, NULL, NULL, NULL, 'NA(+)/H(+) EXCHANGER PROTEIN 7', 242416),
(330749, 'PTHR10110:SF163', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER 1', 242416),
(330750, 'PTHR10110:SF186', NULL, NULL, NULL, NULL, 'CATION/H+ EXCHANGER, CATION/H+ EXCHANGER, CPA1 FAMILY-RELATED', 242416),
(330751, 'PTHR10110:SF187', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER', 242416),
(330752, 'PTHR10110:SF165', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER 8', 242416),
(330753, 'PTHR10110:SF188', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER', 242416),
(330754, 'PTHR10110:SF181', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER 6', 242416),
(330755, 'PTHR10110:SF162', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER 2-LIKE', 242416),
(330756, 'PTHR10110:SF61', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER 9', 242416),
(330757, 'PTHR10110:SF190', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER', 242416),
(330758, 'PTHR10110:SF62', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER 7', 242416),
(330759, 'PTHR10110:SF191', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER 8', 242416),
(330760, 'PTHR10110:SF86', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER 7', 242416),
(330761, 'PTHR10110:SF87', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER 10', 242416),
(330762, 'PTHR10110:SF89', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER 2', 242416),
(330763, 'PTHR10110', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER', 242416),
(330764, 'PTHR36793', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA SMALL SUBUNIT METHYLTRANSFERASE J', 242417),
(330765, 'PTHR36793:SF2', NULL, NULL, NULL, NULL, 'BNAA06G24390D PROTEIN', 242417),
(330766, 'PTHR36793:SF1', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA SMALL SUBUNIT METHYLTRANSFERASE J', 242417),
(330767, 'PTHR37375', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242418),
(330768, 'PTHR37375:SF1', NULL, NULL, NULL, NULL, 'DUF2470 DOMAIN-CONTAINING PROTEIN', 242418),
(330769, 'PTHR35184', NULL, NULL, NULL, NULL, 'YALI0C10208P', 242419),
(330770, 'PTHR35184:SF1', NULL, NULL, NULL, NULL, 'YALI0C10208P', 242419),
(330771, 'PTHR46571', NULL, NULL, NULL, NULL, 'SORTING NEXIN-8', 242420),
(330772, 'PTHR46571:SF1', NULL, NULL, NULL, NULL, 'SORTING NEXIN-8', 242420),
(330773, 'PTHR31765', NULL, NULL, NULL, NULL, 'PROTEIN CBG12783', 242421),
(330774, 'PTHR31765:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG04161', 242421),
(330775, 'PTHR14150:SF19', NULL, NULL, NULL, NULL, 'BNAA09G00760D PROTEIN', 242422),
(330776, 'PTHR14150', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RNA-ASSOCIATED PROTEIN 14', 242422),
(330777, 'PTHR14150:SF16', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RNA-ASSOCIATED PROTEIN 14 HOMOLOG C', 242422),
(330778, 'PTHR14150:SF14', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RNA-ASSOCIATED PROTEIN 14 HOMOLOG A', 242422),
(330779, 'PTHR14150:SF12', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RNA-ASSOCIATED PROTEIN 14 HOMOLOG A-RELATED', 242422),
(330780, 'PTHR35813', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YBAN', 242423),
(330781, 'PTHR35813:SF1', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YBAN', 242423),
(330782, 'PTHR15924', NULL, NULL, NULL, NULL, 'CLE', 242424),
(330783, 'PTHR15924:SF11', NULL, NULL, NULL, NULL, 'RNA TRANSCRIPTION, TRANSLATION AND TRANSPORT FACTOR PROTEIN', 242424),
(330784, 'PTHR15924:SF10', NULL, NULL, NULL, NULL, 'RNA TRANSCRIPTION, TRANSLATION AND TRANSPORT FACTOR PROTEIN', 242424),
(330785, 'PTHR15924:SF9', NULL, NULL, NULL, NULL, 'RNA TRANSCRIPTION, TRANSLATION AND TRANSPORT FACTOR PROTEIN', 242424),
(330786, 'PTHR46327:SF2', NULL, NULL, NULL, NULL, 'SEQUENCE-SPECIFIC DNA BINDING TRANSCRIPTION FACTOR', 242425);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(330787, 'PTHR46327', NULL, NULL, NULL, NULL, 'F16F4.11 PROTEIN-RELATED', 242425),
(330788, 'PTHR46327:SF10', NULL, NULL, NULL, NULL, 'DNA BINDING TRANSCRIPTION FACTORS, PUTATIVE-RELATED', 242425),
(330789, 'PTHR46327:SF21', NULL, NULL, NULL, NULL, 'BNAANNG16550D PROTEIN', 242425),
(330790, 'PTHR46327:SF13', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR', 242425),
(330791, 'PTHR46327:SF4', NULL, NULL, NULL, NULL, 'OS02G0542400 PROTEIN', 242425),
(330792, 'PTHR46327:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR', 242425),
(330793, 'PTHR46327:SF20', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242425),
(330794, 'PTHR46327:SF19', NULL, NULL, NULL, NULL, 'F16F4.11 PROTEIN', 242425),
(330795, 'PTHR46327:SF18', NULL, NULL, NULL, NULL, '', 242425),
(330796, 'PTHR46327:SF15', NULL, NULL, NULL, NULL, 'FACTOR, PUTATIVE-RELATED', 242425),
(330797, 'PTHR46327:SF17', NULL, NULL, NULL, NULL, '', 242425),
(330798, 'PTHR46327:SF16', NULL, NULL, NULL, NULL, '', 242425),
(330799, 'PTHR46327:SF9', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TRIHELIX FAMILY-RELATED', 242425),
(330800, 'PTHR46327:SF5', NULL, NULL, NULL, NULL, '', 242425),
(330801, 'PTHR46327:SF8', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DNA-BINDING DOMAIN PROTEIN', 242425),
(330802, 'PTHR42972:SF8', NULL, NULL, NULL, NULL, 'TOL-PAL SYSTEM PROTEIN TOLB', 242426),
(330803, 'PTHR42972:SF11', NULL, NULL, NULL, NULL, 'PEPTIDASE_S9 DOMAIN-CONTAINING PROTEIN', 242426),
(330804, 'PTHR42972:SF9', NULL, NULL, NULL, NULL, '', 242426),
(330805, 'PTHR42972:SF10', NULL, NULL, NULL, NULL, 'ACETYLXYLAN ESTERASE A', 242426),
(330806, 'PTHR42972:SF3', NULL, NULL, NULL, NULL, '', 242426),
(330807, 'PTHR42972', NULL, NULL, NULL, NULL, 'TOL-PAL SYSTEM PROTEIN TOLB', 242426),
(330808, 'PTHR21450:SF19', NULL, NULL, NULL, NULL, 'F5M15.15', 242427),
(330809, 'PTHR21450:SF38', NULL, NULL, NULL, NULL, 'OS04G0562800 PROTEIN', 242427),
(330810, 'PTHR21450:SF16', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR', 242427),
(330811, 'PTHR21450:SF17', NULL, NULL, NULL, NULL, 'OS09G0542500 PROTEIN', 242427),
(330812, 'PTHR21450:SF39', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR', 242427),
(330813, 'PTHR21450:SF58', NULL, NULL, NULL, NULL, 'DUF630 DOMAIN-CONTAINING PROTEIN', 242427),
(330814, 'PTHR21450:SF36', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE (DUF630 AND DUF632)-RELATED', 242427),
(330815, 'PTHR21450:SF59', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE_ 48652-45869-RELATED', 242427),
(330816, 'PTHR21450:SF34', NULL, NULL, NULL, NULL, '', 242427),
(330817, 'PTHR21450:SF35', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, PUTATIVE (DUF630 AND DUF632)-RELATED', 242427),
(330818, 'PTHR21450:SF57', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR-LIKE', 242427),
(330819, 'PTHR21450:SF10', NULL, NULL, NULL, NULL, 'OS09G0368900 PROTEIN', 242427),
(330820, 'PTHR21450:SF32', NULL, NULL, NULL, NULL, 'DUF630 FAMILY PROTEIN (DUF630 AND DUF632)', 242427),
(330821, 'PTHR21450:SF11', NULL, NULL, NULL, NULL, 'OS02G0654600 PROTEIN', 242427),
(330822, 'PTHR21450:SF55', NULL, NULL, NULL, NULL, '', 242427),
(330823, 'PTHR21450:SF30', NULL, NULL, NULL, NULL, '', 242427),
(330824, 'PTHR21450:SF52', NULL, NULL, NULL, NULL, '', 242427),
(330825, 'PTHR21450:SF53', NULL, NULL, NULL, NULL, '', 242427),
(330826, 'PTHR21450:SF51', NULL, NULL, NULL, NULL, 'OS07G0211900 PROTEIN', 242427),
(330827, 'PTHR21450:SF2', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE (DUF630 AND DUF632)-RELATED', 242427),
(330828, 'PTHR21450:SF3', NULL, NULL, NULL, NULL, 'DUF630 FAMILY PROTEIN (DUF630 AND DUF632)', 242427),
(330829, 'PTHR21450', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 242427),
(330830, 'PTHR21450:SF6', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242427),
(330831, 'PTHR21450:SF7', NULL, NULL, NULL, NULL, 'DNA LIGASE (DUF630 AND DUF632)', 242427),
(330832, 'PTHR21450:SF9', NULL, NULL, NULL, NULL, 'BZIP DOMAIN CLASS TRANSCRIPTION FACTOR (DUF630 AND DUF632)-RELATED', 242427),
(330833, 'PTHR21450:SF49', NULL, NULL, NULL, NULL, '', 242427),
(330834, 'PTHR21450:SF47', NULL, NULL, NULL, NULL, 'OS01G0500500 PROTEIN', 242427);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(330835, 'PTHR21450:SF26', NULL, NULL, NULL, NULL, 'LEUCINE ZIPPER PROTEIN-LIKE', 242427),
(330836, 'PTHR21450:SF48', NULL, NULL, NULL, NULL, 'OS08G0551200 PROTEIN', 242427),
(330837, 'PTHR21450:SF23', NULL, NULL, NULL, NULL, 'PROTEIN ALTERED PHOSPHATE STARVATION RESPONSE 1', 242427),
(330838, 'PTHR21450:SF45', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SUBUNIT BETA, PUTATIVE (DUF630 AND DUF632)-RELATED', 242427),
(330839, 'PTHR21450:SF46', NULL, NULL, NULL, NULL, 'BNAA09G38370D PROTEIN', 242427),
(330840, 'PTHR21450:SF43', NULL, NULL, NULL, NULL, 'DUF630 FAMILY PROTEIN', 242427),
(330841, 'PTHR21450:SF21', NULL, NULL, NULL, NULL, 'REDUCTASE SUBUNIT C, PUTATIVE (DUF630 AND DUF632)-RELATED', 242427),
(330842, 'PTHR21450:SF44', NULL, NULL, NULL, NULL, '', 242427),
(330843, 'PTHR21450:SF41', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SUBUNIT BETA, PUTATIVE (DUF630 AND DUF632)-RELATED', 242427),
(330844, 'PTHR21450:SF42', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BZIP80, PUTATIVE-RELATED', 242427),
(330845, 'PTHR21450:SF60', NULL, NULL, NULL, NULL, 'DUF630 FAMILY PROTEIN', 242427),
(330846, 'PTHR43433:SF3', NULL, NULL, NULL, NULL, 'NON-HEME CHLOROPEROXIDASE', 242428),
(330847, 'PTHR43433:SF4', NULL, NULL, NULL, NULL, 'NON-HEME CHLOROPEROXIDASE-RELATED', 242428),
(330848, 'PTHR43433:SF5', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 242428),
(330849, 'PTHR43433:SF1', NULL, NULL, NULL, NULL, 'BLL5160 PROTEIN', 242428),
(330850, 'PTHR43433:SF10', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 242428),
(330851, 'PTHR43433:SF7', NULL, NULL, NULL, NULL, 'ALPHA/BETA FOLD FAMILY, PUTATIVE-RELATED', 242428),
(330852, 'PTHR43433:SF8', NULL, NULL, NULL, NULL, 'BLL8011 PROTEIN', 242428),
(330853, 'PTHR43433', NULL, NULL, NULL, NULL, 'HYDROLASE, ALPHA/BETA FOLD FAMILY PROTEIN', 242428),
(330854, 'PTHR46954', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242429),
(330855, 'PTHR46954:SF1', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242429),
(330856, 'PTHR18842', NULL, NULL, NULL, NULL, 'INTERLEUKIN-1 RECEPTOR-ASSOCIATED KINASE 1-BINDING PROTEIN 1', 242430),
(330857, 'PTHR18842:SF2', NULL, NULL, NULL, NULL, 'INTERLEUKIN-1 RECEPTOR-ASSOCIATED KINASE 1-BINDING PROTEIN 1', 242430),
(330858, 'PTHR45267:SF2', NULL, NULL, NULL, NULL, 'NADPH-DEPENDENT PTERIN ALDEHYDE REDUCTASE', 242431),
(330859, 'PTHR45267', NULL, NULL, NULL, NULL, '', 242431),
(330860, 'PTHR28139:SF1', NULL, NULL, NULL, NULL, 'UPF0768 PROTEIN YBL029C-A', 242432),
(330861, 'PTHR28139', NULL, NULL, NULL, NULL, 'UPF0768 PROTEIN YBL029C-A', 242432),
(330862, 'PTHR33989:SF8', NULL, NULL, NULL, NULL, 'PERMEASE IIC COMPONENT', 242433),
(330863, 'PTHR33989:SF10', NULL, NULL, NULL, NULL, 'PERMEASE IIC COMPONENT', 242433),
(330864, 'PTHR33989:SF11', NULL, NULL, NULL, NULL, 'LICHENAN PERMEASE IIC COMPONENT', 242433),
(330865, 'PTHR33989', NULL, NULL, NULL, NULL, '', 242433),
(330866, 'PTHR33989:SF4', NULL, NULL, NULL, NULL, 'PTS SYSTEM N,N''-DIACETYLCHITOBIOSE-SPECIFIC EIIC COMPONENT', 242433),
(330867, 'PTHR33472:SF1', NULL, NULL, NULL, NULL, 'BROMO AND FHA DOMAIN-CONTAINING PROTEIN DDB_G0267958', 242434),
(330868, 'PTHR33472:SF24', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN RP/EB FAMILY MEMBER 1-LIKE', 242434),
(330869, 'PTHR33472:SF13', NULL, NULL, NULL, NULL, 'BNAA09G55540D PROTEIN', 242434),
(330870, 'PTHR33472:SF25', NULL, NULL, NULL, NULL, 'MUCIN-5AC-LIKE', 242434),
(330871, 'PTHR33472:SF22', NULL, NULL, NULL, NULL, '', 242434),
(330872, 'PTHR33472:SF3', NULL, NULL, NULL, NULL, 'BNAA09G12530D PROTEIN', 242434),
(330873, 'PTHR33472:SF23', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASES, ACTING ON NADH OR NADPH', 242434),
(330874, 'PTHR33472:SF20', NULL, NULL, NULL, NULL, 'BNAA04G27120D PROTEIN', 242434),
(330875, 'PTHR33472:SF21', NULL, NULL, NULL, NULL, 'BNAC09G11180D PROTEIN', 242434),
(330876, 'PTHR33472:SF10', NULL, NULL, NULL, NULL, '', 242434),
(330877, 'PTHR33472:SF17', NULL, NULL, NULL, NULL, 'BNACNNG45880D PROTEIN', 242434),
(330878, 'PTHR33472:SF18', NULL, NULL, NULL, NULL, 'OS09G0327500 PROTEIN', 242434);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(330879, 'PTHR33472:SF26', NULL, NULL, NULL, NULL, '', 242434),
(330880, 'PTHR33472:SF15', NULL, NULL, NULL, NULL, 'MUCIN-2-LIKE', 242434),
(330881, 'PTHR33472:SF27', NULL, NULL, NULL, NULL, 'RRM_8 DOMAIN-CONTAINING PROTEIN', 242434),
(330882, 'PTHR33472:SF16', NULL, NULL, NULL, NULL, '', 242434),
(330883, 'PTHR33472', NULL, NULL, NULL, NULL, 'OS01G0106600 PROTEIN', 242434),
(330884, 'PTHR48306:SF1', NULL, NULL, NULL, NULL, 'XYLOSE ISOMERASE', 242435),
(330885, 'PTHR48306', NULL, NULL, NULL, NULL, 'XYLOSE ISOMERASE', 242435),
(330886, 'PTHR30013:SF6', NULL, NULL, NULL, NULL, 'HYDROGENASE-1 SMALL CHAIN', 242436),
(330887, 'PTHR30013:SF7', NULL, NULL, NULL, NULL, 'HYDROGENASE-2 SMALL CHAIN', 242436),
(330888, 'PTHR30013:SF5', NULL, NULL, NULL, NULL, 'HYDROGENASE SMALL SUBUNIT', 242436),
(330889, 'PTHR30013', NULL, NULL, NULL, NULL, 'NIFE / NIFESE HYDROGENASE SMALL SUBUNIT FAMILY MEMBER', 242436),
(330890, 'PTHR35128:SF1', NULL, NULL, NULL, NULL, 'SECRETION-REGULATING GUANINE NUCLEOTIDE EXCHANGE FACTOR', 242437),
(330891, 'PTHR35128:SF5', NULL, NULL, NULL, NULL, 'OS02G0230200 PROTEIN', 242437),
(330892, 'PTHR35128:SF7', NULL, NULL, NULL, NULL, '', 242437),
(330893, 'PTHR35128', NULL, NULL, NULL, NULL, 'SECRETION-REGULATING GUANINE NUCLEOTIDE EXCHANGE FACTOR', 242437),
(330894, 'PTHR33745', NULL, NULL, NULL, NULL, 'RSBT ANTAGONIST PROTEIN RSBS-RELATED', 242438),
(330895, 'PTHR33745:SF1', NULL, NULL, NULL, NULL, 'RSBT ANTAGONIST PROTEIN RSBS', 242438),
(330896, 'PTHR33745:SF8', NULL, NULL, NULL, NULL, 'BLUE-LIGHT PHOTORECEPTOR', 242438),
(330897, 'PTHR33745:SF3', NULL, NULL, NULL, NULL, 'RSBT CO-ANTAGONIST PROTEIN RSBRC', 242438),
(330898, 'PTHR35218', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 242439),
(330899, 'PTHR35218:SF2', NULL, NULL, NULL, NULL, 'ENDONUCLEASE/EXONUCLEASE/PHOSPHATASE FAMILY PROTEIN', 242439),
(330900, 'PTHR35218:SF7', NULL, NULL, NULL, NULL, '', 242439),
(330901, 'PTHR35218:SF6', NULL, NULL, NULL, NULL, '', 242439),
(330902, 'PTHR35218:SF4', NULL, NULL, NULL, NULL, 'RNA-DIRECTED DNA POLYMERASE (REVERSE TRANSCRIPTASE)_ RIBONUCLEASE H', 242439),
(330903, 'PTHR35665:SF1', NULL, NULL, NULL, NULL, 'PROTEIN LKAAEAR1', 242440),
(330904, 'PTHR35665', NULL, NULL, NULL, NULL, 'PROTEIN LKAAEAR1', 242440),
(330905, 'PTHR15057:SF0', NULL, NULL, NULL, NULL, 'HISTATIN-3', 242441),
(330906, 'PTHR15057:SF3', NULL, NULL, NULL, NULL, 'STATHERIN', 242441),
(330907, 'PTHR15057', NULL, NULL, NULL, NULL, 'STATHERIN', 242441),
(330908, 'PTHR15057:SF2', NULL, NULL, NULL, NULL, 'HISTATIN-1', 242441),
(330909, 'PTHR12001:SF55', NULL, NULL, NULL, NULL, 'ALL TRANS-POLYPRENYL-DIPHOSPHATE SYNTHASE PDSS2', 242442),
(330910, 'PTHR12001:SF44', NULL, NULL, NULL, NULL, 'GERANYLGERANYL PYROPHOSPHATE SYNTHASE', 242442),
(330911, 'PTHR12001:SF85', NULL, NULL, NULL, NULL, 'SHORT CHAIN ISOPRENYL DIPHOSPHATE SYNTHASE', 242442),
(330912, 'PTHR12001:SF74', NULL, NULL, NULL, NULL, 'SOLANESYL-DIPHOSPHATE SYNTHASE 1, MITOCHONDRIAL-LIKE ISOFORM X1', 242442),
(330913, 'PTHR12001:SF75', NULL, NULL, NULL, NULL, 'SOLANESYL DIPHOSPHATE SYNTHASE 2 CHLOROPLASTIC', 242442),
(330914, 'PTHR12001:SF86', NULL, NULL, NULL, NULL, 'GERANYLGERANYL DIPHOSPHATE SYNTHASE', 242442),
(330915, 'PTHR12001:SF69', NULL, NULL, NULL, NULL, 'ALL TRANS-POLYPRENYL-DIPHOSPHATE SYNTHASE PDSS1', 242442),
(330916, 'PTHR12001:SF78', NULL, NULL, NULL, NULL, 'ALL TRANS-POLYPRENYL-DIPHOSPHATE SYNTHASE PDSS1', 242442),
(330917, 'PTHR12001:SF79', NULL, NULL, NULL, NULL, 'SOLANESYL DIPHOSPHATE SYNTHASE 2, CHLOROPLASTIC', 242442),
(330918, 'PTHR12001:SF83', NULL, NULL, NULL, NULL, 'SOLANESYL-DIPHOSPHATE SYNTHASE 2, CHLOROPLASTIC', 242442),
(330919, 'PTHR12001:SF72', NULL, NULL, NULL, NULL, 'THIJ/PFPI FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_3G01210)-RELATED', 242442),
(330920, 'PTHR12001:SF84', NULL, NULL, NULL, NULL, 'DECAPRENYL-DIPHOSPHATE SYNTHASE SUBUNIT 2', 242442),
(330921, 'PTHR12001:SF73', NULL, NULL, NULL, NULL, '', 242442),
(330922, 'PTHR12001:SF70', NULL, NULL, NULL, NULL, 'PYROPHOSPHATE SYNTHETASE ATMG, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G02400)-RELATED', 242442);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(330923, 'PTHR12001:SF81', NULL, NULL, NULL, NULL, '', 242442),
(330924, 'PTHR12001:SF71', NULL, NULL, NULL, NULL, '(2E,6E)-FARNESYL DIPHOSPHATE SYNTHASE', 242442),
(330925, 'PTHR12001', NULL, NULL, NULL, NULL, 'GERANYLGERANYL PYROPHOSPHATE SYNTHASE', 242442),
(330926, 'PTHR45712', NULL, NULL, NULL, NULL, 'AGAP008170-PA', 242443),
(330927, 'PTHR45712:SF2', NULL, NULL, NULL, NULL, 'ASPORIN', 242443),
(330928, 'PTHR45712:SF3', NULL, NULL, NULL, NULL, 'OSTEOMODULIN', 242443),
(330929, 'PTHR45712:SF1', NULL, NULL, NULL, NULL, 'NEPHROCAN', 242443),
(330930, 'PTHR45712:SF14', NULL, NULL, NULL, NULL, 'DECORIN', 242443),
(330931, 'PTHR45712:SF13', NULL, NULL, NULL, NULL, 'KERATOCAN', 242443),
(330932, 'PTHR45712:SF12', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT TRANSMEMBRANE PROTEIN FLRT3', 242443),
(330933, 'PTHR45712:SF22', NULL, NULL, NULL, NULL, 'PODOCAN', 242443),
(330934, 'PTHR45712:SF11', NULL, NULL, NULL, NULL, 'BIGLYCAN', 242443),
(330935, 'PTHR45712:SF20', NULL, NULL, NULL, NULL, 'PODOCAN', 242443),
(330936, 'PTHR45712:SF6', NULL, NULL, NULL, NULL, 'LUMICAN', 242443),
(330937, 'PTHR45712:SF4', NULL, NULL, NULL, NULL, 'FIBROMODULIN', 242443),
(330938, 'PTHR45712:SF5', NULL, NULL, NULL, NULL, 'PODOCAN-LIKE PROTEIN 1', 242443),
(330939, 'PTHR45712:SF19', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT TRANSMEMBRANE NEURONAL PROTEIN 2', 242443),
(330940, 'PTHR45712:SF18', NULL, NULL, NULL, NULL, 'WU:FC23C09', 242443),
(330941, 'PTHR45712:SF17', NULL, NULL, NULL, NULL, 'ZGC:113307', 242443),
(330942, 'PTHR45712:SF27', NULL, NULL, NULL, NULL, '', 242443),
(330943, 'PTHR45712:SF16', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT TRANSMEMBRANE PROTEIN FLRT2', 242443),
(330944, 'PTHR45712:SF8', NULL, NULL, NULL, NULL, 'PROLARGIN', 242443),
(330945, 'PTHR45712:SF15', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT TRANSMEMBRANE PROTEIN FLRT1', 242443),
(330946, 'PTHR45712:SF26', NULL, NULL, NULL, NULL, 'LRRNT DOMAIN-CONTAINING PROTEIN', 242443),
(330947, 'PTHR11562:SF40', NULL, NULL, NULL, NULL, 'CATION EFFLUX SYSTEM PROTEIN', 242444),
(330948, 'PTHR11562:SF84', NULL, NULL, NULL, NULL, 'LD05335P', 242444),
(330949, 'PTHR11562:SF51', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER 2', 242444),
(330950, 'PTHR11562:SF30', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER 3', 242444),
(330951, 'PTHR11562:SF94', NULL, NULL, NULL, NULL, 'BNAC04G00620D PROTEIN', 242444),
(330952, 'PTHR11562:SF37', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER 8', 242444),
(330953, 'PTHR11562:SF27', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER 4', 242444),
(330954, 'PTHR11562:SF99', NULL, NULL, NULL, NULL, '', 242444),
(330955, 'PTHR11562:SF88', NULL, NULL, NULL, NULL, 'METAL TOLERANCE PROTEIN 1', 242444),
(330956, 'PTHR11562:SF97', NULL, NULL, NULL, NULL, 'METAL TOLERANCE PROTEIN A1', 242444),
(330957, 'PTHR11562:SF54', NULL, NULL, NULL, NULL, 'METAL TOLERANCE PROTEIN B', 242444),
(330958, 'PTHR11562:SF17', NULL, NULL, NULL, NULL, 'RE54080P-RELATED', 242444),
(330959, 'PTHR11562', NULL, NULL, NULL, NULL, 'CATION EFFLUX PROTEIN/ ZINC TRANSPORTER', 242444),
(330960, 'PTHR47545:SF1', NULL, NULL, NULL, NULL, 'MULTIFUNCTIONAL CCA PROTEIN', 242445),
(330961, 'PTHR47545:SF2', NULL, NULL, NULL, NULL, 'CC-ADDING TRNA NUCLEOTIDYLTRANSFERASE', 242445),
(330962, 'PTHR47545', NULL, NULL, NULL, NULL, 'MULTIFUNCTIONAL CCA PROTEIN', 242445),
(330963, 'PTHR45080:SF20', NULL, NULL, NULL, NULL, 'WRAPPER/REGA-1/KLINGON HOMOLOG', 242446),
(330964, 'PTHR45080:SF21', NULL, NULL, NULL, NULL, 'INACTIVE TYROSINE-PROTEIN KINASE 7', 242446),
(330965, 'PTHR45080:SF22', NULL, NULL, NULL, NULL, 'TWITCHIN-LIKE PROTEIN', 242446),
(330966, 'PTHR45080:SF23', NULL, NULL, NULL, NULL, 'MAM DOMAIN-CONTAINING GLYCOSYLPHOSPHATIDYLINOSITOL ANCHOR PROTEIN 1', 242446),
(330967, 'PTHR45080:SF24', NULL, NULL, NULL, NULL, 'PROTEIN AMALGAM-LIKE PROTEIN', 242446),
(330968, 'PTHR45080:SF25', NULL, NULL, NULL, NULL, 'FI23916P1-RELATED', 242446),
(330969, 'PTHR45080:SF15', NULL, NULL, NULL, NULL, 'NEURAL CELL ADHESION MOLECULE L1', 242446),
(330970, 'PTHR45080:SF26', NULL, NULL, NULL, NULL, 'PALLADIN', 242446);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(330971, 'PTHR45080:SF27', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN ISET DOMAIN-CONTAINING PROTEIN', 242446),
(330972, 'PTHR45080:SF2', NULL, NULL, NULL, NULL, 'IP11255P', 242446),
(330973, 'PTHR45080:SF28', NULL, NULL, NULL, NULL, 'HEMICENTIN-2-RELATED', 242446),
(330974, 'PTHR45080:SF29', NULL, NULL, NULL, NULL, 'NEURAL CELL ADHESION MOLECULE 3', 242446),
(330975, 'PTHR45080:SF8', NULL, NULL, NULL, NULL, 'ROUNDABOUT HOMOLOG 1', 242446),
(330976, 'PTHR45080', NULL, NULL, NULL, NULL, 'CONTACTIN 5', 242446),
(330977, 'PTHR45080:SF4', NULL, NULL, NULL, NULL, 'GH03113P', 242446),
(330978, 'PTHR45080:SF5', NULL, NULL, NULL, NULL, 'PROTEIN TURTLE-LIKE PROTEIN', 242446),
(330979, 'PTHR43061:SF1', NULL, NULL, NULL, NULL, 'GTP DIPHOSPHOKINASE RSH1, CHLOROPLASTIC-RELATED', 242447),
(330980, 'PTHR43061', NULL, NULL, NULL, NULL, 'GTP DIPHOSPHOKINASE RSH1, CHLOROPLASTIC-RELATED', 242447),
(330981, 'PTHR33874:SF6', NULL, NULL, NULL, NULL, 'BNAA08G14680D PROTEIN', 242448),
(330982, 'PTHR33874:SF7', NULL, NULL, NULL, NULL, 'BNAA01G13970D PROTEIN', 242448),
(330983, 'PTHR33874:SF1', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN', 242448),
(330984, 'PTHR33874:SF4', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242448),
(330985, 'PTHR33874:SF5', NULL, NULL, NULL, NULL, 'OS09G0465500 PROTEIN', 242448),
(330986, 'PTHR33874', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN', 242448),
(330987, 'PTHR33874:SF2', NULL, NULL, NULL, NULL, 'MADS BOX INTERACTOR-LIKE', 242448),
(330988, 'PTHR36985:SF1', NULL, NULL, NULL, NULL, 'TRANSLOCATION AND ASSEMBLY MODULE SUBUNIT TAMB', 242449),
(330989, 'PTHR36985', NULL, NULL, NULL, NULL, 'TRANSLOCATION AND ASSEMBLY MODULE SUBUNIT TAMB', 242449),
(330990, 'PTHR30598', NULL, NULL, NULL, NULL, 'NITRATE REDUCTASE PRIVATE CHAPERONE, REDOX ENZYME MATURATION PROTEIN  REMP  FAMILY', 242450),
(330991, 'PTHR30598:SF3', NULL, NULL, NULL, NULL, 'RESPIRATORY NITRATE REDUCTASE 1 GAMMA CHAIN', 242450),
(330992, 'PTHR30598:SF4', NULL, NULL, NULL, NULL, 'RESPIRATORY NITRATE REDUCTASE 2 GAMMA CHAIN', 242450),
(330993, 'PTHR36575:SF2', NULL, NULL, NULL, NULL, 'CHITIN-BINDING TYPE-4 DOMAIN-CONTAINING PROTEIN-RELATED', 242451),
(330994, 'PTHR36575', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G14430)-RELATED', 242451),
(330995, 'PTHR14944', NULL, NULL, NULL, NULL, 'RPA-RELATED PROTEIN RADX', 242452),
(330996, 'PTHR14944:SF3', NULL, NULL, NULL, NULL, 'SI:CH73-71D17.2', 242452),
(330997, 'PTHR14944:SF4', NULL, NULL, NULL, NULL, 'RPA1 RELATED SINGLE STRANDED DNA BINDING PROTEIN', 242452),
(330998, 'PTHR14944:SF2', NULL, NULL, NULL, NULL, 'RPA-RELATED PROTEIN RADX', 242452),
(330999, 'PTHR46863:SF6', NULL, NULL, NULL, NULL, 'OS09G0572100 PROTEIN', 242453),
(331000, 'PTHR46863:SF5', NULL, NULL, NULL, NULL, 'LYSM DOMAIN RECEPTOR-LIKE KINASE 3', 242453),
(331001, 'PTHR46863', NULL, NULL, NULL, NULL, 'OS09G0572100 PROTEIN', 242453),
(331002, 'PTHR46863:SF2', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242453),
(331003, 'PTHR46863:SF1', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 242453),
(331004, 'PTHR46151:SF19', NULL, NULL, NULL, NULL, 'NEP1-INTERACTING PROTEIN 1-LIKE ISOFORM X1', 242454),
(331005, 'PTHR46151:SF9', NULL, NULL, NULL, NULL, 'OS08G0550400 PROTEIN', 242454),
(331006, 'PTHR46151:SF8', NULL, NULL, NULL, NULL, 'OS07G0479100 PROTEIN', 242454),
(331007, 'PTHR46151:SF22', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 242454),
(331008, 'PTHR46151:SF11', NULL, NULL, NULL, NULL, 'NEP1-INTERACTING PROTEIN-LIKE 1', 242454),
(331009, 'PTHR46151:SF23', NULL, NULL, NULL, NULL, 'HTH LA-TYPE RNA-BINDING DOMAIN-CONTAINING PROTEIN', 242454),
(331010, 'PTHR46151:SF12', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 242454),
(331011, 'PTHR46151:SF13', NULL, NULL, NULL, NULL, 'NEP1-INTERACTING PROTEIN-LIKE 1', 242454),
(331012, 'PTHR46151:SF1', NULL, NULL, NULL, NULL, 'OS09G0542600 PROTEIN', 242454),
(331013, 'PTHR46151:SF24', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN-RELATED', 242454),
(331014, 'PTHR46151:SF14', NULL, NULL, NULL, NULL, 'OS06G0717600 PROTEIN', 242454);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(331015, 'PTHR46151:SF25', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 242454),
(331016, 'PTHR46151:SF26', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 242454),
(331017, 'PTHR46151:SF7', NULL, NULL, NULL, NULL, 'NEP1-INTERACTING PROTEIN 1', 242454),
(331018, 'PTHR46151:SF16', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 242454),
(331019, 'PTHR46151:SF6', NULL, NULL, NULL, NULL, 'OS06G0231600 PROTEIN', 242454),
(331020, 'PTHR46151:SF17', NULL, NULL, NULL, NULL, 'NEP1-INTERACTING PROTEIN-LIKE 1', 242454),
(331021, 'PTHR46151:SF28', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 242454),
(331022, 'PTHR46151:SF18', NULL, NULL, NULL, NULL, 'NEP1-INTERACTING PROTEIN-LIKE 2', 242454),
(331023, 'PTHR46151:SF29', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE, YMGG-LIKE GLY-ZIPPER-RELATED', 242454),
(331024, 'PTHR46151', NULL, NULL, NULL, NULL, 'NEP1-INTERACTING PROTEIN-LIKE 2', 242454),
(331025, 'PTHR46151:SF30', NULL, NULL, NULL, NULL, 'NEP1-INTERACTING PROTEIN 2', 242454),
(331026, 'PTHR46151:SF20', NULL, NULL, NULL, NULL, 'NEP1-INTERACTING PROTEIN 1-LIKE', 242454),
(331027, 'PTHR46151:SF21', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 242454),
(331028, 'PTHR23346:SF19', NULL, NULL, NULL, NULL, 'PROTEASOME ADAPTER AND SCAFFOLD PROTEIN ECM29', 242455),
(331029, 'PTHR23346', NULL, NULL, NULL, NULL, 'TRANSLATIONAL ACTIVATOR GCN1-RELATED', 242455),
(331030, 'PTHR23346:SF7', NULL, NULL, NULL, NULL, 'EIF-2-ALPHA KINASE ACTIVATOR GCN1', 242455),
(331031, 'PTHR36399:SF1', NULL, NULL, NULL, NULL, 'PHOTOSYNTHETIC NDH SUBUNIT OF SUBCOMPLEX B 5, CHLOROPLASTIC', 242456),
(331032, 'PTHR36399', NULL, NULL, NULL, NULL, 'PHOTOSYNTHETIC NDH SUBUNIT OF SUBCOMPLEX B 5, CHLOROPLASTIC', 242456),
(331033, 'PTHR39473', NULL, NULL, NULL, NULL, '', 242457),
(331034, 'PTHR39473:SF1', NULL, NULL, NULL, NULL, 'C3H1-TYPE DOMAIN-CONTAINING PROTEIN', 242457),
(331035, 'PTHR48242', NULL, NULL, NULL, NULL, 'BNAA02G09820D PROTEIN', 242458),
(331036, 'PTHR48242:SF3', NULL, NULL, NULL, NULL, 'BNAC07G50440D PROTEIN', 242458),
(331037, 'PTHR48242:SF4', NULL, NULL, NULL, NULL, 'BNAA08G14020D PROTEIN', 242458),
(331038, 'PTHR48242:SF5', NULL, NULL, NULL, NULL, '', 242458),
(331039, 'PTHR48242:SF1', NULL, NULL, NULL, NULL, 'BNAA02G09820D PROTEIN', 242458),
(331040, 'PTHR48242:SF2', NULL, NULL, NULL, NULL, 'BNAA03G48750D PROTEIN', 242458),
(331041, 'PTHR35564:SF3', NULL, NULL, NULL, NULL, 'TYPE VI SECRETION SYSTEM PROTEIN TSSG', 242459),
(331042, 'PTHR35564:SF4', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 242459),
(331043, 'PTHR35564', NULL, NULL, NULL, NULL, '', 242459),
(331044, 'PTHR12159:SF11', NULL, NULL, NULL, NULL, 'TDG PROTEIN', 242460),
(331045, 'PTHR12159:SF10', NULL, NULL, NULL, NULL, 'THYMINE DNA GLYCOSYLASE, TANDEM DUPLICATE 2', 242460),
(331046, 'PTHR12159:SF9', NULL, NULL, NULL, NULL, 'G/T MISMATCH-SPECIFIC THYMINE DNA GLYCOSYLASE', 242460),
(331047, 'PTHR12159', NULL, NULL, NULL, NULL, 'G/T AND G/U MISMATCH-SPECIFIC DNA GLYCOSYLASE', 242460),
(331048, 'PTHR47517', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN-RELATED', 242461),
(331049, 'PTHR47517:SF3', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 242461),
(331050, 'PTHR47517:SF1', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 242461),
(331051, 'PTHR47517:SF2', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN-RELATED', 242461),
(331052, 'PTHR13264:SF6', NULL, NULL, NULL, NULL, 'OS06G0711100 PROTEIN', 242462),
(331053, 'PTHR13264:SF5', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR SYF2', 242462),
(331054, 'PTHR13264', NULL, NULL, NULL, NULL, 'GCIP-INTERACTING PROTEIN P29', 242462),
(331055, 'PTHR42202:SF1', NULL, NULL, NULL, NULL, 'GTP CYCLOHYDROLASE III', 242463),
(331056, 'PTHR42202', NULL, NULL, NULL, NULL, 'GTP CYCLOHYDROLASE III', 242463),
(331057, 'PTHR10954:SF18', NULL, NULL, NULL, NULL, 'RIBONUCLEASE HII', 242464),
(331058, 'PTHR10954:SF19', NULL, NULL, NULL, NULL, 'RIBONUCLEASE', 242464),
(331059, 'PTHR10954:SF7', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H2 SUBUNIT A', 242464);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(331060, 'PTHR10954', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H2 SUBUNIT A', 242464),
(331061, 'PTHR10954:SF23', NULL, NULL, NULL, NULL, 'RIBONUCLEASE', 242464),
(331062, 'PTHR22552:SF37', NULL, NULL, NULL, NULL, 'CAENACIN (CAENORHABDITIS BACTERIOCIN)', 242465),
(331063, 'PTHR22552:SF14', NULL, NULL, NULL, NULL, 'FIP (FUNGUS-INDUCED PROTEIN) RELATED', 242465),
(331064, 'PTHR22552:SF25', NULL, NULL, NULL, NULL, 'PROTEIN CBG21849', 242465),
(331065, 'PTHR22552:SF36', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE-LIKE PROTEIN', 242465),
(331066, 'PTHR22552:SF39', NULL, NULL, NULL, NULL, 'PROTEIN CBR-FIPR-13', 242465),
(331067, 'PTHR22552:SF16', NULL, NULL, NULL, NULL, 'FIP (FUNGUS-INDUCED PROTEIN) RELATED', 242465),
(331068, 'PTHR22552:SF38', NULL, NULL, NULL, NULL, 'PROTEIN CBG23118', 242465),
(331069, 'PTHR22552:SF32', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE-LIKE PROTEIN-RELATED', 242465),
(331070, 'PTHR22552:SF35', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE-LIKE PROTEIN', 242465),
(331071, 'PTHR22552:SF24', NULL, NULL, NULL, NULL, 'RE35358P', 242465),
(331072, 'PTHR22552:SF13', NULL, NULL, NULL, NULL, 'PROTEIN CBG04410', 242465),
(331073, 'PTHR22552:SF23', NULL, NULL, NULL, NULL, 'FIP (FUNGUS-INDUCED PROTEIN) RELATED', 242465),
(331074, 'PTHR22552:SF34', NULL, NULL, NULL, NULL, 'GEO11429P1-RELATED', 242465),
(331075, 'PTHR22552', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 242465),
(331076, 'PTHR33746', NULL, NULL, NULL, NULL, 'RUBRERYTHRIN', 242466),
(331077, 'PTHR33746:SF4', NULL, NULL, NULL, NULL, 'RUBRERYTHRIN', 242466),
(331078, 'PTHR22738:SF12', NULL, NULL, NULL, NULL, 'RAS ASSOCIATION DOMAIN-CONTAINING PROTEIN 1', 242467),
(331079, 'PTHR22738:SF9', NULL, NULL, NULL, NULL, 'RAS ASSOCIATION DOMAIN-CONTAINING PROTEIN 5', 242467),
(331080, 'PTHR22738:SF14', NULL, NULL, NULL, NULL, 'RAS ASSOCIATION DOMAIN-CONTAINING PROTEIN 2', 242467),
(331081, 'PTHR22738:SF8', NULL, NULL, NULL, NULL, 'RAS ASSOCIATION DOMAIN-CONTAINING PROTEIN 3', 242467),
(331082, 'PTHR22738:SF15', NULL, NULL, NULL, NULL, 'LD40758P', 242467),
(331083, 'PTHR22738', NULL, NULL, NULL, NULL, 'RASSF', 242467),
(331084, 'PTHR22738:SF10', NULL, NULL, NULL, NULL, 'RAS ASSOCIATION DOMAIN-CONTAINING PROTEIN 1 HOMOLOG', 242467),
(331085, 'PTHR22738:SF4', NULL, NULL, NULL, NULL, 'RAS ASSOCIATION DOMAIN-CONTAINING PROTEIN 4', 242467),
(331086, 'PTHR22738:SF3', NULL, NULL, NULL, NULL, 'RAS ASSOCIATION DOMAIN-CONTAINING PROTEIN 6', 242467),
(331087, 'PTHR28079', NULL, NULL, NULL, NULL, 'RNA POLYMERASE I-SPECIFIC TRANSCRIPTION INITIATION FACTOR RRN5', 242468),
(331088, 'PTHR28079:SF1', NULL, NULL, NULL, NULL, 'RNA POLYMERASE I-SPECIFIC TRANSCRIPTION INITIATION FACTOR RRN5', 242468),
(331089, 'PTHR12111:SF2', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 130', 242469),
(331090, 'PTHR12111:SF1', NULL, NULL, NULL, NULL, 'SPLICING FACTOR YJU2', 242469),
(331091, 'PTHR12111:SF8', NULL, NULL, NULL, NULL, 'SPLICING FACTOR YJU2', 242469),
(331092, 'PTHR12111:SF10', NULL, NULL, NULL, NULL, 'BNAA04G11300D PROTEIN', 242469),
(331093, 'PTHR12111:SF4', NULL, NULL, NULL, NULL, 'SPLICING FACTOR YJU2', 242469),
(331094, 'PTHR12111:SF13', NULL, NULL, NULL, NULL, '', 242469),
(331095, 'PTHR12111:SF12', NULL, NULL, NULL, NULL, 'BNAA09G28730D PROTEIN', 242469),
(331096, 'PTHR12111:SF3', NULL, NULL, NULL, NULL, 'SPLICING FACTOR YJU2', 242469),
(331097, 'PTHR12111:SF15', NULL, NULL, NULL, NULL, 'SPLICING FACTOR YJU2', 242469),
(331098, 'PTHR12111:SF14', NULL, NULL, NULL, NULL, 'SPLICING FACTOR YJU2', 242469),
(331099, 'PTHR12111', NULL, NULL, NULL, NULL, 'SPLICING FACTOR YJU2', 242469),
(331100, 'PTHR12995:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 39A', 242470),
(331101, 'PTHR12995:SF4', NULL, NULL, NULL, NULL, 'FI21814P1', 242470),
(331102, 'PTHR12995', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 242470),
(331103, 'PTHR12995:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 39B', 242470),
(331104, 'PTHR33067:SF30', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 242471),
(331105, 'PTHR33067:SF35', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 242471);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(331106, 'PTHR33067:SF9', NULL, NULL, NULL, NULL, 'GAG PROTEIN, PUTATIVE-RELATED', 242471),
(331107, 'PTHR33067', NULL, NULL, NULL, NULL, '', 242471),
(331108, 'PTHR33067:SF36', NULL, NULL, NULL, NULL, '', 242471),
(331109, 'PTHR33067:SF15', NULL, NULL, NULL, NULL, '', 242471),
(331110, 'PTHR33067:SF31', NULL, NULL, NULL, NULL, 'RETROTRANS_GAG DOMAIN-CONTAINING PROTEIN', 242471),
(331111, 'PTHR33067:SF32', NULL, NULL, NULL, NULL, '', 242471),
(331112, 'PTHR33067:SF33', NULL, NULL, NULL, NULL, '', 242471),
(331113, 'PTHR33067:SF22', NULL, NULL, NULL, NULL, 'RETROTRANSPOSON GAG DOMAIN, ASPARTIC PEPTIDASE DOMAIN PROTEIN-RELATED', 242471),
(331114, 'PTHR33067:SF34', NULL, NULL, NULL, NULL, '', 242471),
(331115, 'PTHR42810:SF2', NULL, NULL, NULL, NULL, 'PURINE PERMEASE C1399.01C-RELATED', 242472),
(331116, 'PTHR42810:SF4', NULL, NULL, NULL, NULL, 'URIC ACID TRANSPORTER UACT', 242472),
(331117, 'PTHR42810:SF5', NULL, NULL, NULL, NULL, 'XANTHINE PERMEASE XANQ', 242472),
(331118, 'PTHR42810:SF6', NULL, NULL, NULL, NULL, 'PURINE PERMEASE YBBY-RELATED', 242472),
(331119, 'PTHR42810', NULL, NULL, NULL, NULL, 'PURINE PERMEASE C1399.01C-RELATED', 242472),
(331120, 'PTHR42810:SF1', NULL, NULL, NULL, NULL, 'PURINE PERMEASE YWDJ-RELATED', 242472),
(331121, 'PTHR23007:SF11', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE CBL', 242473),
(331122, 'PTHR23007:SF13', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE CBL', 242473),
(331123, 'PTHR23007', NULL, NULL, NULL, NULL, 'CBL', 242473),
(331124, 'PTHR23007:SF12', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE CBL-C', 242473),
(331125, 'PTHR23007:SF5', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE CBL', 242473),
(331126, 'PTHR23007:SF3', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE CBL-B', 242473),
(331127, 'PTHR37315:SF1', NULL, NULL, NULL, NULL, 'UPF0311 PROTEIN YVEG', 242474),
(331128, 'PTHR37315', NULL, NULL, NULL, NULL, 'UPF0311 PROTEIN BLR7842', 242474),
(331129, 'PTHR42758', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLGLYCEROL PHOSPHOLIPASE C', 242475),
(331130, 'PTHR42758:SF3', NULL, NULL, NULL, NULL, 'LYSOPHOSPHOLIPASE D GDPD3', 242475),
(331131, 'PTHR42758:SF1', NULL, NULL, NULL, NULL, 'LYSOPHOSPHOLIPASE D GDPD1', 242475),
(331132, 'PTHR42758:SF2', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLGLYCEROL PHOSPHOLIPASE C', 242475),
(331133, 'PTHR12203:SF118', NULL, NULL, NULL, NULL, 'BETA-1,2-XYLOSYLTRANSFERASE 1', 242476),
(331134, 'PTHR12203:SF119', NULL, NULL, NULL, NULL, 'CAP10 DOMAIN-CONTAINING PROTEIN', 242476),
(331135, 'PTHR12203:SF90', NULL, NULL, NULL, NULL, 'O-GLUCOSYLTRANSFERASE RUMI HOMOLOG', 242476),
(331136, 'PTHR12203:SF21', NULL, NULL, NULL, NULL, 'PROTEIN O-GLUCOSYLTRANSFERASE 2', 242476),
(331137, 'PTHR12203:SF87', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE-MODIFYING PROTEIN-RELATED', 242476),
(331138, 'PTHR12203:SF22', NULL, NULL, NULL, NULL, 'CAPSULE ASSOCIATED PROTEIN', 242476),
(331139, 'PTHR12203:SF85', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 90 PROTEIN', 242476),
(331140, 'PTHR12203:SF63', NULL, NULL, NULL, NULL, 'CAP10 DOMAIN-CONTAINING PROTEIN', 242476),
(331141, 'PTHR12203:SF61', NULL, NULL, NULL, NULL, 'CAPSULE PROTEIN', 242476),
(331142, 'PTHR12203:SF113', NULL, NULL, NULL, NULL, 'O-GLUCOSYLTRANSFERASE RUMI-LIKE PROTEIN (DUF821)', 242476),
(331143, 'PTHR12203', NULL, NULL, NULL, NULL, 'KDEL  LYS-ASP-GLU-LEU  CONTAINING - RELATED', 242476),
(331144, 'PTHR12203:SF115', NULL, NULL, NULL, NULL, 'CAP10 DOMAIN-CONTAINING PROTEIN', 242476),
(331145, 'PTHR12203:SF112', NULL, NULL, NULL, NULL, 'DUF821 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_2G14740)', 242476),
(331146, 'PTHR12203:SF107', NULL, NULL, NULL, NULL, 'CAP10 DOMAIN-CONTAINING PROTEIN', 242476),
(331147, 'PTHR12203:SF106', NULL, NULL, NULL, NULL, 'DOWNSTREAM TARGET OF AGL15 2', 242476),
(331148, 'PTHR12203:SF108', NULL, NULL, NULL, NULL, 'CAP10 DOMAIN-CONTAINING PROTEIN', 242476),
(331149, 'PTHR12203:SF80', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 242476),
(331150, 'PTHR12203:SF98', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 242476),
(331151, 'PTHR12203:SF76', NULL, NULL, NULL, NULL, 'CAP10 DOMAIN-CONTAINING PROTEIN', 242476); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(331152, 'PTHR12203:SF99', NULL, NULL, NULL, NULL, 'OS04G0534100 PROTEIN', 242476),
(331153, 'PTHR12203:SF74', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 242476),
(331154, 'PTHR12203:SF30', NULL, NULL, NULL, NULL, 'OS04G0534000 PROTEIN', 242476),
(331155, 'PTHR12203:SF96', NULL, NULL, NULL, NULL, 'DOWNSTREAM TARGET OF AGL15 2', 242476),
(331156, 'PTHR12203:SF97', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 242476),
(331157, 'PTHR12203:SF70', NULL, NULL, NULL, NULL, 'OS06G0152700 PROTEIN', 242476),
(331158, 'PTHR12203:SF93', NULL, NULL, NULL, NULL, 'CAP10 DOMAIN-CONTAINING PROTEIN', 242476),
(331159, 'PTHR12203:SF18', NULL, NULL, NULL, NULL, 'PROTEIN O-GLUCOSYLTRANSFERASE 3', 242476),
(331160, 'PTHR12203:SF103', NULL, NULL, NULL, NULL, 'CAP10 DOMAIN-CONTAINING PROTEIN', 242476),
(331161, 'PTHR12203:SF102', NULL, NULL, NULL, NULL, 'CAP10 DOMAIN-CONTAINING PROTEIN', 242476),
(331162, 'PTHR12203:SF105', NULL, NULL, NULL, NULL, 'OS08G0101800 PROTEIN', 242476),
(331163, 'PTHR12203:SF104', NULL, NULL, NULL, NULL, 'PROTEIN CAP1, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G05595)-RELATED', 242476),
(331164, 'PTHR12203:SF121', NULL, NULL, NULL, NULL, 'CAP10 DOMAIN-CONTAINING PROTEIN', 242476),
(331165, 'PTHR12203:SF120', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 242476),
(331166, 'PTHR12203:SF78', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 90 PROTEIN', 242476),
(331167, 'PTHR12203:SF101', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE-MODIFYING PROTEIN-RELATED', 242476),
(331168, 'PTHR12203:SF35', NULL, NULL, NULL, NULL, 'PROTEIN O-GLUCOSYLTRANSFERASE 1', 242476),
(331169, 'PTHR12203:SF122', NULL, NULL, NULL, NULL, 'CAP10 DOMAIN-CONTAINING PROTEIN', 242476),
(331170, 'PTHR35974:SF1', NULL, NULL, NULL, NULL, 'NONCOMPACT MYELIN-ASSOCIATED PROTEIN', 242477),
(331171, 'PTHR35974', NULL, NULL, NULL, NULL, 'NONCOMPACT MYELIN-ASSOCIATED PROTEIN', 242477),
(331172, 'PTHR21765:SF2', NULL, NULL, NULL, NULL, 'CHD2 PROTEIN', 242478),
(331173, 'PTHR21765', NULL, NULL, NULL, NULL, 'SIMILAR TO CHROMODOMAIN-HELICASE-DNA-BINDING PROTEIN 1 (CHD-1)', 242478),
(331174, 'PTHR21765:SF1', NULL, NULL, NULL, NULL, 'SIMILAR TO CHROMODOMAIN-HELICASE-DNA-BINDING PROTEIN 1 (CHD-1)', 242478),
(331175, 'PTHR33332:SF47', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 242479),
(331176, 'PTHR33332:SF36', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 242479),
(331177, 'PTHR33332:SF48', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE, PUTATIVE-RELATED', 242479),
(331178, 'PTHR33332:SF39', NULL, NULL, NULL, NULL, 'LON PEPTIDASE N-TERMINAL DOMAIN AND RING FINGER 2', 242479),
(331179, 'PTHR33332:SF43', NULL, NULL, NULL, NULL, '', 242479),
(331180, 'PTHR33332:SF44', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 242479),
(331181, 'PTHR33332:SF45', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 242479),
(331182, 'PTHR33332:SF46', NULL, NULL, NULL, NULL, 'TRANSCRIPTASE, PUTATIVE-RELATED', 242479),
(331183, 'PTHR33332:SF40', NULL, NULL, NULL, NULL, '', 242479),
(331184, 'PTHR33332:SF41', NULL, NULL, NULL, NULL, 'RNA-DIRECTED DNA POLYMERASE FROM MOBILE ELEMENT JOCKEY-LIKE PROTEIN', 242479),
(331185, 'PTHR33332:SF42', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 242479),
(331186, 'PTHR33332:SF31', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 242479),
(331187, 'PTHR33332:SF6', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 242479),
(331188, 'PTHR33332:SF29', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 242479),
(331189, 'PTHR33332', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 242479),
(331190, 'PTHR19447', NULL, NULL, NULL, NULL, 'OOCYTE-EXPRESSED PROTEIN HOMOLOG-RELATED', 242480),
(331191, 'PTHR19447:SF15', NULL, NULL, NULL, NULL, 'KH DOMAIN-CONTAINING PROTEIN 3', 242480),
(331192, 'PTHR19447:SF14', NULL, NULL, NULL, NULL, 'OOCYTE-EXPRESSED PROTEIN HOMOLOG', 242480),
(331193, 'PTHR30502:SF0', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYLASE FAMILY PROTEIN', 242481);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(331194, 'PTHR30502', NULL, NULL, NULL, NULL, '2-KETO-3-DEOXY-L-RHAMNONATE ALDOLASE', 242481),
(331195, 'PTHR30502:SF9', NULL, NULL, NULL, NULL, 'HPCH_HPAI DOMAIN-CONTAINING PROTEIN', 242481),
(331196, 'PTHR30502:SF7', NULL, NULL, NULL, NULL, 'ALDOLASE LIKE', 242481),
(331197, 'PTHR30502:SF8', NULL, NULL, NULL, NULL, 'SYNTHASE, PUTATIVE-RELATED', 242481),
(331198, 'PTHR30502:SF5', NULL, NULL, NULL, NULL, '2-KETO-3-DEOXY-L-RHAMNONATE ALDOLASE', 242481),
(331199, 'PTHR30502:SF4', NULL, NULL, NULL, NULL, '5-KETO-4-DEOXY-D-GLUCARATE ALDOLASE', 242481),
(331200, 'PTHR38341', NULL, NULL, NULL, NULL, 'FRUCTOSE-1,6-BISPHOSPHATE ALDOLASE/PHOSPHATASE', 242482),
(331201, 'PTHR38341:SF1', NULL, NULL, NULL, NULL, 'FRUCTOSE-1,6-BISPHOSPHATE ALDOLASE/PHOSPHATASE', 242482),
(331202, 'PTHR28023', NULL, NULL, NULL, NULL, 'UPF0357 PROTEIN YCL012C', 242483),
(331203, 'PTHR28023:SF1', NULL, NULL, NULL, NULL, 'UPF0357 PROTEIN YCL012C', 242483),
(331204, 'PTHR45024:SF3', NULL, NULL, NULL, NULL, 'BLL2957 PROTEIN', 242484),
(331205, 'PTHR45024:SF2', NULL, NULL, NULL, NULL, 'SCP2 DOMAIN-CONTAINING PROTEIN', 242484),
(331206, 'PTHR45024', NULL, NULL, NULL, NULL, 'DEHYDROGENASES, SHORT CHAIN', 242484),
(331207, 'PTHR47852', NULL, NULL, NULL, NULL, 'OS06G0298400 PROTEIN', 242485),
(331208, 'PTHR47852:SF2', NULL, NULL, NULL, NULL, 'WW DOMAIN-CONTAINING PROTEIN', 242485),
(331209, 'PTHR33845', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242486),
(331210, 'PTHR33845:SF1', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242486),
(331211, 'PTHR44548:SF1', NULL, NULL, NULL, NULL, 'GST N-TERMINAL DOMAIN-CONTAINING PROTEIN', 242487),
(331212, 'PTHR44548', NULL, NULL, NULL, NULL, 'GST N-TERMINAL DOMAIN-CONTAINING PROTEIN', 242487),
(331213, 'PTHR44548:SF4', NULL, NULL, NULL, NULL, 'S-TRANSFERASE, PUTATIVE-RELATED', 242487),
(331214, 'PTHR44548:SF3', NULL, NULL, NULL, NULL, 'GST N-TERMINAL DOMAIN-CONTAINING PROTEIN', 242487),
(331215, 'PTHR44548:SF2', NULL, NULL, NULL, NULL, 'GST N-TERMINAL DOMAIN-CONTAINING PROTEIN', 242487),
(331216, 'PTHR14680', NULL, NULL, NULL, NULL, 'SI:DKEY-126G1.9-RELATED', 242488),
(331217, 'PTHR14680:SF1', NULL, NULL, NULL, NULL, 'SI:DKEY-126G1.9-RELATED', 242488),
(331218, 'PTHR21541:SF3', NULL, NULL, NULL, NULL, 'STRUCTURE-SPECIFIC ENDONUCLEASE SUBUNIT SLX4', 242489),
(331219, 'PTHR21541', NULL, NULL, NULL, NULL, 'BTB  POZ  DOMAIN CONTAINING 12', 242489),
(331220, 'PTHR38607', NULL, NULL, NULL, NULL, 'PROTEIN CBG00180-RELATED', 242490),
(331221, 'PTHR38607:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG06239', 242490),
(331222, 'PTHR38607:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG26298', 242490),
(331223, 'PTHR38607:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG26296', 242490),
(331224, 'PTHR28005:SF1', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 17', 242491),
(331225, 'PTHR28005', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 17', 242491),
(331226, 'PTHR37285:SF5', NULL, NULL, NULL, NULL, 'SPORE WALL MATURATION PROTEIN DIT1', 242492),
(331227, 'PTHR37285:SF6', NULL, NULL, NULL, NULL, 'BIOSYNTHESIS PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G02660)-RELATED', 242492),
(331228, 'PTHR37285:SF7', NULL, NULL, NULL, NULL, 'PAERUCUMARIN BIOSYNTHESIS PROTEIN PVCA', 242492),
(331229, 'PTHR37285', NULL, NULL, NULL, NULL, '', 242492),
(331230, 'PTHR31530:SF2', NULL, NULL, NULL, NULL, 'MAJOR INTRINSICALLY DISORDERED NOTCH2-BINDING RECEPTOR 1', 242493),
(331231, 'PTHR31530:SF4', NULL, NULL, NULL, NULL, 'MAJOR INTRINSICALLY DISORDERED NOTCH2-BINDING RECEPTOR 1-LIKE', 242493),
(331232, 'PTHR31530', NULL, NULL, NULL, NULL, 'MAJOR INTRINSICALLY DISORDERED NOTCH2-BINDING RECEPTOR 1 MINAR1 FAMILY MEMBER', 242493),
(331233, 'PTHR43662:SF3', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G11970)-RELATED', 242494),
(331234, 'PTHR43662:SF2', NULL, NULL, NULL, NULL, 'DUF1996 DOMAIN-CONTAINING PROTEIN', 242494),
(331235, 'PTHR43662:SF11', NULL, NULL, NULL, NULL, 'WSC DOMAIN-CONTAINING PROTEIN', 242494),
(331236, 'PTHR43662:SF5', NULL, NULL, NULL, NULL, 'DUF1996 DOMAIN-CONTAINING PROTEIN', 242494);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(331237, 'PTHR43662:SF4', NULL, NULL, NULL, NULL, 'DUF1996 DOMAIN-CONTAINING PROTEIN', 242494),
(331238, 'PTHR43662:SF12', NULL, NULL, NULL, NULL, 'DUF1996 DOMAIN-CONTAINING PROTEIN-RELATED', 242494),
(331239, 'PTHR43662:SF7', NULL, NULL, NULL, NULL, 'DUF1996 DOMAIN-CONTAINING PROTEIN', 242494),
(331240, 'PTHR43662:SF13', NULL, NULL, NULL, NULL, 'DUF1996 DOMAIN-CONTAINING PROTEIN', 242494),
(331241, 'PTHR43662:SF6', NULL, NULL, NULL, NULL, 'DUF1996 DOMAIN-CONTAINING PROTEIN', 242494),
(331242, 'PTHR43662:SF9', NULL, NULL, NULL, NULL, 'DUF1996 DOMAIN-CONTAINING PROTEIN', 242494),
(331243, 'PTHR43662', NULL, NULL, NULL, NULL, '', 242494),
(331244, 'PTHR34838:SF7', NULL, NULL, NULL, NULL, '', 242495),
(331245, 'PTHR34838:SF8', NULL, NULL, NULL, NULL, '', 242495),
(331246, 'PTHR34838:SF9', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 242495),
(331247, 'PTHR34838', NULL, NULL, NULL, NULL, 'OS08G0142100 PROTEIN-RELATED', 242495),
(331248, 'PTHR34838:SF1', NULL, NULL, NULL, NULL, 'OS08G0143150 PROTEIN', 242495),
(331249, 'PTHR34838:SF10', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 242495),
(331250, 'PTHR34838:SF2', NULL, NULL, NULL, NULL, 'OS08G0142900 PROTEIN', 242495),
(331251, 'PTHR34838:SF3', NULL, NULL, NULL, NULL, 'OS08G0142100 PROTEIN', 242495),
(331252, 'PTHR34838:SF5', NULL, NULL, NULL, NULL, '', 242495),
(331253, 'PTHR34838:SF6', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 242495),
(331254, 'PTHR12221:SF6', NULL, NULL, NULL, NULL, 'PESCADILLO HOMOLOG', 242496),
(331255, 'PTHR12221:SF7', NULL, NULL, NULL, NULL, '', 242496),
(331256, 'PTHR12221:SF8', NULL, NULL, NULL, NULL, 'PESCADILLO HOMOLOG', 242496),
(331257, 'PTHR12221', NULL, NULL, NULL, NULL, 'PESCADILLO - RELATED', 242496),
(331258, 'PTHR21363', NULL, NULL, NULL, NULL, 'PREPHENATE DEHYDROGENASE', 242497),
(331259, 'PTHR21363:SF0', NULL, NULL, NULL, NULL, 'PREPHENATE DEHYDROGENASE [NADP(+)]', 242497),
(331260, 'PTHR36362:SF3', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN, STRIATED MUSCLE-LIKE', 242498),
(331261, 'PTHR36362:SF1', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT BETA', 242498),
(331262, 'PTHR36362', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT BETA', 242498),
(331263, 'PTHR36362:SF2', NULL, NULL, NULL, NULL, 'BNAC05G37190D PROTEIN', 242498),
(331264, 'PTHR36328', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 242499),
(331265, 'PTHR36328:SF6', NULL, NULL, NULL, NULL, 'CRYPTDIN PROTEIN-LIKE PROTEIN-RELATED', 242499),
(331266, 'PTHR36328:SF5', NULL, NULL, NULL, NULL, '', 242499),
(331267, 'PTHR36328:SF4', NULL, NULL, NULL, NULL, '', 242499),
(331268, 'PTHR36328:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 242499),
(331269, 'PTHR36328:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 242499),
(331270, 'PTHR35369:SF3', NULL, NULL, NULL, NULL, 'CELL DIVISION INHIBITOR SULA', 242500),
(331271, 'PTHR35369:SF2', NULL, NULL, NULL, NULL, 'BLR3025 PROTEIN', 242500),
(331272, 'PTHR35369', NULL, NULL, NULL, NULL, 'BLR3025 PROTEIN-RELATED', 242500),
(331273, 'PTHR37221', NULL, NULL, NULL, NULL, 'OS02G0582400 PROTEIN', 242501),
(331274, 'PTHR37221:SF1', NULL, NULL, NULL, NULL, 'OS02G0582400 PROTEIN', 242501),
(331275, 'PTHR35989', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 32', 242502),
(331276, 'PTHR35989:SF1', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 32', 242502),
(331277, 'PTHR35989:SF2', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 32-LIKE', 242502),
(331278, 'PTHR33593:SF30', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN', 242503),
(331279, 'PTHR33593:SF32', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASE-RELATED', 242503),
(331280, 'PTHR33593:SF21', NULL, NULL, NULL, NULL, 'BNAA08G24800D PROTEIN', 242503),
(331281, 'PTHR33593:SF31', NULL, NULL, NULL, NULL, 'BNAA09G06020D PROTEIN', 242503),
(331282, 'PTHR33593:SF20', NULL, NULL, NULL, NULL, '', 242503),
(331283, 'PTHR33593:SF12', NULL, NULL, NULL, NULL, '', 242503);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(331284, 'PTHR33593:SF22', NULL, NULL, NULL, NULL, 'BNAA03G59600D PROTEIN', 242503),
(331285, 'PTHR33593:SF11', NULL, NULL, NULL, NULL, 'BNAA09G38740D PROTEIN', 242503),
(331286, 'PTHR33593:SF25', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASE-RELATED', 242503),
(331287, 'PTHR33593:SF14', NULL, NULL, NULL, NULL, '', 242503),
(331288, 'PTHR33593:SF13', NULL, NULL, NULL, NULL, '', 242503),
(331289, 'PTHR33593:SF3', NULL, NULL, NULL, NULL, 'DUF1442 FAMILY PROTEIN', 242503),
(331290, 'PTHR33593:SF2', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT/KH DOMAIN PROTEIN (DUF1442)', 242503),
(331291, 'PTHR33593:SF1', NULL, NULL, NULL, NULL, 'DUF1442 FAMILY PROTEIN', 242503),
(331292, 'PTHR33593:SF27', NULL, NULL, NULL, NULL, 'BNAA09G38980D PROTEIN', 242503),
(331293, 'PTHR33593:SF16', NULL, NULL, NULL, NULL, 'OS08G0110600 PROTEIN', 242503),
(331294, 'PTHR33593:SF26', NULL, NULL, NULL, NULL, 'BNAC08G41310D PROTEIN', 242503),
(331295, 'PTHR33593:SF29', NULL, NULL, NULL, NULL, '', 242503),
(331296, 'PTHR33593:SF17', NULL, NULL, NULL, NULL, 'DUF1442 FAMILY PROTEIN', 242503),
(331297, 'PTHR33593:SF28', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT/KH DOMAIN PROTEIN (DUF1442)', 242503),
(331298, 'PTHR33593', NULL, NULL, NULL, NULL, 'DUF1442 FAMILY PROTEIN', 242503),
(331299, 'PTHR33593:SF19', NULL, NULL, NULL, NULL, 'BNAANNG32220D PROTEIN', 242503),
(331300, 'PTHR12715:SF4', NULL, NULL, NULL, NULL, 'TRANSPORTER, DRUG/METABOLITE EXPORTER FAMILY', 242504),
(331301, 'PTHR12715', NULL, NULL, NULL, NULL, 'TRANSPORTER, DRUG/METABOLITE EXPORTER FAMILY', 242504),
(331302, 'PTHR45810:SF9', NULL, NULL, NULL, NULL, 'HISTONE DOMAIN-CONTAINING PROTEIN', 242505),
(331303, 'PTHR45810', NULL, NULL, NULL, NULL, 'HISTONE H3.2', 242505),
(331304, 'PTHR45810:SF17', NULL, NULL, NULL, NULL, 'HISTONE DOMAIN-CONTAINING PROTEIN', 242505),
(331305, 'PTHR45810:SF14', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN A', 242505),
(331306, 'PTHR45810:SF15', NULL, NULL, NULL, NULL, 'HISTONE H3', 242505),
(331307, 'PTHR45810:SF1', NULL, NULL, NULL, NULL, 'HISTONE H3-LIKE CENTROMERIC PROTEIN A', 242505),
(331308, 'PTHR45810:SF12', NULL, NULL, NULL, NULL, 'HISTONE H3', 242505),
(331309, 'PTHR45810:SF13', NULL, NULL, NULL, NULL, 'HISTONE H3', 242505),
(331310, 'PTHR45810:SF10', NULL, NULL, NULL, NULL, 'HISTONE H3', 242505),
(331311, 'PTHR46935', NULL, NULL, NULL, NULL, 'OS01G0674700 PROTEIN', 242506),
(331312, 'PTHR46935:SF1', NULL, NULL, NULL, NULL, 'OS01G0674700 PROTEIN', 242506),
(331313, 'PTHR46935:SF2', NULL, NULL, NULL, NULL, 'EMBRYO SPECIFIC2', 242506),
(331314, 'PTHR15321:SF3', NULL, NULL, NULL, NULL, 'TP53-BINDING PROTEIN 1', 242507),
(331315, 'PTHR15321', NULL, NULL, NULL, NULL, 'TUMOR SUPPRESSOR P53-BINDING PROTEIN 1', 242507),
(331316, 'PTHR16103:SF0', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 140', 242508),
(331317, 'PTHR16103', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 140', 242508),
(331318, 'PTHR46635', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE FAMILY 1 PROTEIN', 242509),
(331319, 'PTHR46635:SF1', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE FAMILY 1 PROTEIN', 242509),
(331320, 'PTHR46635:SF2', NULL, NULL, NULL, NULL, 'GLYCOS_TRANSF_1 DOMAIN-CONTAINING PROTEIN', 242509),
(331321, 'PTHR46635:SF3', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE, FAMILY 1-RELATED', 242509),
(331322, 'PTHR46635:SF4', NULL, NULL, NULL, NULL, '', 242509),
(331323, 'PTHR21348', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 242510),
(331324, 'PTHR21348:SF2', NULL, NULL, NULL, NULL, 'SULFIREDOXIN-1', 242510),
(331325, 'PTHR39937', NULL, NULL, NULL, NULL, 'ATP SYNTHASE PROTEIN 8', 242511),
(331326, 'PTHR39937:SF1', NULL, NULL, NULL, NULL, 'ATP SYNTHASE PROTEIN 8', 242511),
(331327, 'PTHR35731:SF1', NULL, NULL, NULL, NULL, '8-AMINO-7-OXONONANOATE SYNTHASE', 242512),
(331328, 'PTHR35731:SF3', NULL, NULL, NULL, NULL, '', 242512),
(331329, 'PTHR35731:SF5', NULL, NULL, NULL, NULL, 'BNAC01G39220D PROTEIN', 242512),
(331330, 'PTHR35731:SF4', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 242512),
(331331, 'PTHR35731', NULL, NULL, NULL, NULL, '8-AMINO-7-OXONONANOATE SYNTHASE', 242512);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(331332, 'PTHR35731:SF6', NULL, NULL, NULL, NULL, '', 242512),
(331333, 'PTHR43723', NULL, NULL, NULL, NULL, 'COBALT TRANSPORT PROTEIN CBIQ', 242513),
(331334, 'PTHR43723:SF1', NULL, NULL, NULL, NULL, 'COBALT TRANSPORT PROTEIN CBIQ', 242513),
(331335, 'PTHR22793:SF13', NULL, NULL, NULL, NULL, 'SAP DOMAIN-CONTAINING PROTEIN', 242514),
(331336, 'PTHR22793:SF12', NULL, NULL, NULL, NULL, 'MYOCARDIN-RELATED TRANSCRIPTION FACTOR, ISOFORM H', 242514),
(331337, 'PTHR22793:SF11', NULL, NULL, NULL, NULL, 'MYOCARDIN', 242514),
(331338, 'PTHR22793', NULL, NULL, NULL, NULL, 'MYOCARDIN-RELATED TRANSCRIPTION FACTOR-RELATED', 242514),
(331339, 'PTHR22793:SF5', NULL, NULL, NULL, NULL, 'MYOCARDIN-RELATED TRANSCRIPTION FACTOR B', 242514),
(331340, 'PTHR22793:SF6', NULL, NULL, NULL, NULL, 'MYOCARDIN-RELATED TRANSCRIPTION FACTOR A', 242514),
(331341, 'PTHR46445:SF11', NULL, NULL, NULL, NULL, 'DUF1296 DOMAIN-CONTAINING PROTEIN', 242515),
(331342, 'PTHR46445:SF14', NULL, NULL, NULL, NULL, 'DUF1296 FAMILY PROTEIN', 242515),
(331343, 'PTHR46445:SF13', NULL, NULL, NULL, NULL, 'DUF1296 DOMAIN-CONTAINING PROTEIN', 242515),
(331344, 'PTHR46445:SF16', NULL, NULL, NULL, NULL, 'DUF1296 DOMAIN-CONTAINING PROTEIN', 242515),
(331345, 'PTHR46445:SF15', NULL, NULL, NULL, NULL, 'DUF1296 DOMAIN-CONTAINING PROTEIN', 242515),
(331346, 'PTHR46445:SF3', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II DEGRADATION FACTOR-LIKE PROTEIN (DUF1296)-RELATED', 242515),
(331347, 'PTHR46445', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II DEGRADATION FACTOR-LIKE PROTEIN (DUF1296)', 242515),
(331348, 'PTHR46445:SF5', NULL, NULL, NULL, NULL, 'DUF1296 DOMAIN-CONTAINING PROTEIN', 242515),
(331349, 'PTHR46445:SF4', NULL, NULL, NULL, NULL, 'PUTATIVE (DUF1296)-RELATED', 242515),
(331350, 'PTHR46445:SF7', NULL, NULL, NULL, NULL, 'DUF1296 DOMAIN-CONTAINING PROTEIN', 242515),
(331351, 'PTHR46445:SF10', NULL, NULL, NULL, NULL, 'DUF1296 DOMAIN-CONTAINING PROTEIN', 242515),
(331352, 'PTHR46445:SF6', NULL, NULL, NULL, NULL, 'OS01G0663800 PROTEIN', 242515),
(331353, 'PTHR46445:SF9', NULL, NULL, NULL, NULL, 'DUF1296 DOMAIN-CONTAINING PROTEIN', 242515),
(331354, 'PTHR46445:SF8', NULL, NULL, NULL, NULL, 'OS05G0581800 PROTEIN', 242515),
(331355, 'PTHR45766', NULL, NULL, NULL, NULL, 'DNA ANNEALING HELICASE AND ENDONUCLEASE ZRANB3 FAMILY MEMBER', 242516),
(331356, 'PTHR45766:SF3', NULL, NULL, NULL, NULL, 'SWI/SNF-RELATED MATRIX-ASSOCIATED ACTIN-DEPENDENT REGULATOR OF CHROMATIN SUBFAMILY A-LIKE PROTEIN 1', 242516),
(331357, 'PTHR45766:SF5', NULL, NULL, NULL, NULL, 'DNA ANNEALING HELICASE AND ENDONUCLEASE ZRANB3', 242516),
(331358, 'PTHR42871:SF1', NULL, NULL, NULL, NULL, 'CITRATE SYNTHASE', 242517),
(331359, 'PTHR42871', NULL, NULL, NULL, NULL, 'CITRATE SYNTHASE', 242517),
(331360, 'PTHR15951:SF2', NULL, NULL, NULL, NULL, 'T-CELL RECEPTOR-ASSOCIATED TRANSMEMBRANE ADAPTER 1', 242518),
(331361, 'PTHR15951', NULL, NULL, NULL, NULL, 'T-CELL RECEPTOR-ASSOCIATED TRANSMEMBRANE ADAPTER 1', 242518),
(331362, 'PTHR32122:SF1', NULL, NULL, NULL, NULL, 'TATA BOX-BINDING PROTEIN-ASSOCIATED FACTOR RNA POLYMERASE I SUBUNIT A', 242519),
(331363, 'PTHR32122', NULL, NULL, NULL, NULL, 'TATA BOX-BINDING PROTEIN ASSOCIATED FACTOR RNA POLYMERASE I SUBUNIT A', 242519),
(331364, 'PTHR35807', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR REDD-RELATED', 242520),
(331365, 'PTHR35807:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR REDD', 242520),
(331366, 'PTHR15904', NULL, NULL, NULL, NULL, 'FAM13', 242521),
(331367, 'PTHR15904:SF16', NULL, NULL, NULL, NULL, 'PROTEIN FAM13B', 242521),
(331368, 'PTHR15904:SF17', NULL, NULL, NULL, NULL, 'RHO-GAP DOMAIN-CONTAINING PROTEIN', 242521),
(331369, 'PTHR15904:SF18', NULL, NULL, NULL, NULL, 'PROTEIN FAM13A', 242521),
(331370, 'PTHR15904:SF19', NULL, NULL, NULL, NULL, 'PROTEIN FAM13C', 242521),
(331371, 'PTHR12084', NULL, NULL, NULL, NULL, 'NUCLEAR PORE GLYCOPROTEIN P62-RELATED', 242522),
(331372, 'PTHR12084:SF13', NULL, NULL, NULL, NULL, 'NUCLEOPORIN 62 C-TERMINAL-LIKE', 242522),
(331373, 'PTHR12084:SF14', NULL, NULL, NULL, NULL, 'NUCLEAR PORE GLYCOPROTEIN P62', 242522);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(331374, 'PTHR12084:SF1', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN', 242522),
(331375, 'PTHR12084:SF0', NULL, NULL, NULL, NULL, 'NUCLEAR PORE GLYCOPROTEIN P62', 242522),
(331376, 'PTHR22806:SF0', NULL, NULL, NULL, NULL, 'NUCLEOPORIN NUP37', 242523),
(331377, 'PTHR22806', NULL, NULL, NULL, NULL, 'NUCLEOPORIN NUP37  P37 -RELATED', 242523),
(331378, 'PTHR36756:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242524),
(331379, 'PTHR36756', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242524),
(331380, 'PTHR43693:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE CHEZ', 242525),
(331381, 'PTHR43693', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE CHEZ', 242525),
(331382, 'PTHR13222:SF1', NULL, NULL, NULL, NULL, 'RB1-INDUCIBLE COILED-COIL PROTEIN 1', 242526),
(331383, 'PTHR13222:SF2', NULL, NULL, NULL, NULL, 'ATG11 DOMAIN-CONTAINING PROTEIN', 242526),
(331384, 'PTHR13222:SF4', NULL, NULL, NULL, NULL, 'ATG11 DOMAIN-CONTAINING PROTEIN', 242526),
(331385, 'PTHR13222:SF5', NULL, NULL, NULL, NULL, 'ATG11 DOMAIN-CONTAINING PROTEIN', 242526),
(331386, 'PTHR13222', NULL, NULL, NULL, NULL, 'RB1-INDUCIBLE COILED-COIL', 242526),
(331387, 'PTHR47897:SF1', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 124', 242527),
(331388, 'PTHR47897', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 124', 242527),
(331389, 'PTHR12124:SF72', NULL, NULL, NULL, NULL, '3''-5'' EXONUCLEASE', 242528),
(331390, 'PTHR12124:SF70', NULL, NULL, NULL, NULL, 'HRDC DOMAIN-CONTAINING PROTEIN', 242528),
(331391, 'PTHR12124:SF71', NULL, NULL, NULL, NULL, 'HRDC DOMAIN-CONTAINING PROTEIN', 242528),
(331392, 'PTHR12124', NULL, NULL, NULL, NULL, 'POLYMYOSITIS/SCLERODERMA AUTOANTIGEN-RELATED', 242528),
(331393, 'PTHR12124:SF69', NULL, NULL, NULL, NULL, 'PROTEIN RRP6-LIKE 1', 242528),
(331394, 'PTHR12124:SF47', NULL, NULL, NULL, NULL, 'EXOSOME COMPONENT 10', 242528),
(331395, 'PTHR12124:SF67', NULL, NULL, NULL, NULL, '3''-5'' EXONUCLEASE FAMILY PROTEIN, EXPRESSED', 242528),
(331396, 'PTHR12124:SF68', NULL, NULL, NULL, NULL, 'PROTEIN RRP6-LIKE 3', 242528),
(331397, 'PTHR37239:SF3', NULL, NULL, NULL, NULL, 'STOMAGEN-RELATED', 242529),
(331398, 'PTHR37239', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN 9', 242529),
(331399, 'PTHR37239:SF2', NULL, NULL, NULL, NULL, 'OS01G0914400 PROTEIN', 242529),
(331400, 'PTHR37239:SF1', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN 9', 242529),
(331401, 'PTHR45098', NULL, NULL, NULL, NULL, 'DNAJ DOMAIN CONTAINING PROTEIN, EXPRESSED', 242530),
(331402, 'PTHR45098:SF2', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR CWC23', 242530),
(331403, 'PTHR45098:SF1', NULL, NULL, NULL, NULL, 'DNAJ DOMAIN CONTAINING PROTEIN, EXPRESSED', 242530),
(331404, 'PTHR45098:SF3', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK N-TERMINAL DOMAIN-CONTAINING PROTEIN', 242530),
(331405, 'PTHR11432:SF20', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE CHAIN 1', 242531),
(331406, 'PTHR11432:SF3', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE CHAIN 1', 242531),
(331407, 'PTHR11432', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE SUBUNIT 1', 242531),
(331408, 'PTHR11432:SF22', NULL, NULL, NULL, NULL, 'NADH-QUINONE OXIDOREDUCTASE PROTEIN', 242531),
(331409, 'PTHR11432:SF23', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT 1, CHLOROPLASTIC', 242531),
(331410, 'PTHR47770', NULL, NULL, NULL, NULL, 'PLANT UBX DOMAIN-CONTAINING PROTEIN 11', 242532),
(331411, 'PTHR47770:SF1', NULL, NULL, NULL, NULL, 'PLANT UBX DOMAIN-CONTAINING PROTEIN 11', 242532),
(331412, 'PTHR36109:SF2', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 242533),
(331413, 'PTHR36109:SF1', NULL, NULL, NULL, NULL, 'SLR0613 PROTEIN', 242533),
(331414, 'PTHR36109', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 242533),
(331415, 'PTHR47930:SF2', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT PROTEIN (AFU_ORTHOLOGUE AFUA_8G04250)', 242534),
(331416, 'PTHR47930', NULL, NULL, NULL, NULL, 'YALI0C12947P', 242534),
(331417, 'PTHR28118', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDE 5''-TRIPHOSPHATASE-RELATED', 242535),
(331418, 'PTHR28118:SF1', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDE 5''-TRIPHOSPHATASE-RELATED', 242535);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(331419, 'PTHR37833', NULL, NULL, NULL, NULL, 'LIPOPROTEIN-RELATED', 242536),
(331420, 'PTHR37833:SF1', NULL, NULL, NULL, NULL, 'LIPOPROTEIN-RELATED', 242536),
(331421, 'PTHR36372', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242537),
(331422, 'PTHR36372:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242537),
(331423, 'PTHR36372:SF3', NULL, NULL, NULL, NULL, '', 242537),
(331424, 'PTHR15898:SF13', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL APOPTOSIS REGULATOR', 242538),
(331425, 'PTHR15898:SF18', NULL, NULL, NULL, NULL, 'GLUCOSE-INDUCED DEGRADATION PROTEIN 4 HOMOLOG', 242538),
(331426, 'PTHR15898:SF17', NULL, NULL, NULL, NULL, 'BNACNNG21820D PROTEIN', 242538),
(331427, 'PTHR15898:SF15', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE PRT1-LIKE', 242538),
(331428, 'PTHR15898', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 242538),
(331429, 'PTHR15898:SF19', NULL, NULL, NULL, NULL, 'ZINC FINGER, ZZ-TYPE, ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 242538),
(331430, 'PTHR15898:SF20', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE PRT1-LIKE PROTEIN', 242538),
(331431, 'PTHR37838', NULL, NULL, NULL, NULL, 'NA(+)-TRANSLOCATING NADH-QUINONE REDUCTASE SUBUNIT C', 242539),
(331432, 'PTHR37838:SF1', NULL, NULL, NULL, NULL, 'NA(+)-TRANSLOCATING NADH-QUINONE REDUCTASE SUBUNIT C', 242539),
(331433, 'PTHR22973:SF12', NULL, NULL, NULL, NULL, 'LD35087P', 242540),
(331434, 'PTHR22973:SF11', NULL, NULL, NULL, NULL, 'GOLGI RESIDENT PROTEIN GCP60', 242540),
(331435, 'PTHR22973:SF3', NULL, NULL, NULL, NULL, 'PROTEIN TMED8', 242540),
(331436, 'PTHR22973:SF14', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A-BINDING DOMAIN-CONTAINING 3-RELATED', 242540),
(331437, 'PTHR22973:SF13', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE P24-TRAFFICKING PROTEIN 8', 242540),
(331438, 'PTHR22973', NULL, NULL, NULL, NULL, 'LD35087P', 242540),
(331439, 'PTHR34968', NULL, NULL, NULL, NULL, 'AUGMIN SUBUNIT 5', 242541),
(331440, 'PTHR34968:SF2', NULL, NULL, NULL, NULL, 'BNAA09G02750D PROTEIN', 242541),
(331441, 'PTHR34968:SF1', NULL, NULL, NULL, NULL, 'AUGMIN SUBUNIT 5', 242541),
(331442, 'PTHR31060:SF31', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN PROTEIN', 242542),
(331443, 'PTHR31060:SF4', NULL, NULL, NULL, NULL, '1,8-CINEOLE SYNTHASE', 242542),
(331444, 'PTHR31060:SF3', NULL, NULL, NULL, NULL, 'OS04G0579700 PROTEIN', 242542),
(331445, 'PTHR31060:SF30', NULL, NULL, NULL, NULL, 'OS07G0668800 PROTEIN', 242542),
(331446, 'PTHR31060:SF6', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242542),
(331447, 'PTHR31060:SF33', NULL, NULL, NULL, NULL, 'OS04G0278000 PROTEIN', 242542),
(331448, 'PTHR31060:SF32', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 242542),
(331449, 'PTHR31060', NULL, NULL, NULL, NULL, 'OSJNBA0011J08.25 PROTEIN-RELATED', 242542),
(331450, 'PTHR31060:SF5', NULL, NULL, NULL, NULL, 'PRLI-INTERACTING FACTOR G, PUTATIVE, EXPRESSED-RELATED', 242542),
(331451, 'PTHR31060:SF7', NULL, NULL, NULL, NULL, 'OS06G0129200 PROTEIN', 242542),
(331452, 'PTHR31060:SF9', NULL, NULL, NULL, NULL, 'OS12G0188500 PROTEIN', 242542),
(331453, 'PTHR31060:SF35', NULL, NULL, NULL, NULL, 'BNAC03G41230D PROTEIN', 242542),
(331454, 'PTHR31060:SF37', NULL, NULL, NULL, NULL, '', 242542),
(331455, 'PTHR31060:SF36', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN-RELATED', 242542),
(331456, 'PTHR31060:SF28', NULL, NULL, NULL, NULL, 'OS07G0123500 PROTEIN', 242542),
(331457, 'PTHR31060:SF27', NULL, NULL, NULL, NULL, 'OS07G0259700 PROTEIN', 242542),
(331458, 'PTHR31060:SF29', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN', 242542),
(331459, 'PTHR31672:SF5', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 242543),
(331460, 'PTHR31672:SF4', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 242543),
(331461, 'PTHR31672', NULL, NULL, NULL, NULL, 'BNACNNG10540D PROTEIN', 242543),
(331462, 'PTHR31672:SF3', NULL, NULL, NULL, NULL, 'F-BOX ASSOCIATED UBIQUITINATION EFFECTOR FAMILY PROTEIN', 242543),
(331463, 'PTHR31672:SF2', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 242543),
(331464, 'PTHR47096', NULL, NULL, NULL, NULL, 'MISSHAPEN LIKE KINASE 1', 242544);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(331465, 'PTHR47096:SF3', NULL, NULL, NULL, NULL, 'MISSHAPEN LIKE KINASE 1', 242544),
(331466, 'PTHR47096:SF2', NULL, NULL, NULL, NULL, 'NIK-RELATED PROTEIN KINASE', 242544),
(331467, 'PTHR47096:SF1', NULL, NULL, NULL, NULL, 'CNH DOMAIN-CONTAINING PROTEIN', 242544),
(331468, 'PTHR10819:SF3', NULL, NULL, NULL, NULL, 'PHOSPHOTRIESTERASE-RELATED PROTEIN', 242545),
(331469, 'PTHR10819', NULL, NULL, NULL, NULL, 'PHOSPHOTRIESTERASE-RELATED', 242545),
(331470, 'PTHR48005', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT KINASE 2', 242546),
(331471, 'PTHR48005:SF61', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242546),
(331472, 'PTHR48005:SF62', NULL, NULL, NULL, NULL, 'OS02G0116700 PROTEIN', 242546),
(331473, 'PTHR48005:SF63', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242546),
(331474, 'PTHR48005:SF68', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE GSO1 ISOFORM X1', 242546),
(331475, 'PTHR48005:SF24', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242546),
(331476, 'PTHR48005:SF25', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242546),
(331477, 'PTHR48005:SF69', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 242546),
(331478, 'PTHR48005:SF64', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242546),
(331479, 'PTHR48005:SF65', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE SERINE/THREONINE/TYROSINE-PROTEIN KINASE SOBIR1', 242546),
(331480, 'PTHR48005:SF66', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242546),
(331481, 'PTHR48005:SF67', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242546),
(331482, 'PTHR48005:SF23', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE HSL1', 242546),
(331483, 'PTHR48005:SF39', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242546),
(331484, 'PTHR48005:SF71', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242546),
(331485, 'PTHR48005:SF72', NULL, NULL, NULL, NULL, 'MDIS1-INTERACTING RECEPTOR LIKE KINASE 2-LIKE', 242546),
(331486, 'PTHR48005:SF73', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242546),
(331487, 'PTHR48005:SF30', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242546),
(331488, 'PTHR48005:SF74', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE IRK-RELATED', 242546),
(331489, 'PTHR48005:SF70', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242546),
(331490, 'PTHR48005:SF79', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242546),
(331491, 'PTHR48005:SF37', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242546),
(331492, 'PTHR48005:SF38', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 242546),
(331493, 'PTHR48005:SF31', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242546),
(331494, 'PTHR48005:SF75', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242546),
(331495, 'PTHR48005:SF76', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 242546),
(331496, 'PTHR48005:SF32', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242546),
(331497, 'PTHR48005:SF77', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242546),
(331498, 'PTHR48005:SF78', NULL, NULL, NULL, NULL, 'OS02G0154200 PROTEIN', 242546),
(331499, 'PTHR48005:SF34', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT RECEPTOR KINASE', 242546),
(331500, 'PTHR48005:SF82', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT TRANSMEMBRANE PROTEIN KINASE 1-LIKE PROTEIN', 242546),
(331501, 'PTHR48005:SF83', NULL, NULL, NULL, NULL, 'REPEAT RECEPTOR-LIKE PROTEIN KINASE FAMILY PROTEIN, PUTATIVE-RELATED', 242546),
(331502, 'PTHR48005:SF84', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE-RELATED', 242546),
(331503, 'PTHR48005:SF41', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242546);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(331504, 'PTHR48005:SF80', NULL, NULL, NULL, NULL, 'OS10G0155700 PROTEIN', 242546),
(331505, 'PTHR48005:SF81', NULL, NULL, NULL, NULL, 'OS02G0153400 PROTEIN', 242546),
(331506, 'PTHR48005:SF43', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242546),
(331507, 'PTHR48005:SF44', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242546),
(331508, 'PTHR48005:SF17', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242546),
(331509, 'PTHR48005:SF19', NULL, NULL, NULL, NULL, 'OS06G0692500 PROTEIN', 242546),
(331510, 'PTHR48005:SF51', NULL, NULL, NULL, NULL, 'MDIS1-INTERACTING RECEPTOR LIKE KINASE 2', 242546),
(331511, 'PTHR48005:SF57', NULL, NULL, NULL, NULL, 'RECEPTOR KINASE-LIKE PROTEIN XA21', 242546),
(331512, 'PTHR48005:SF13', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0278509-RELATED', 242546),
(331513, 'PTHR48005:SF9', NULL, NULL, NULL, NULL, 'SERINE-THREONINE PROTEIN KINASE, PLANT-TYPE', 242546),
(331514, 'PTHR48005:SF14', NULL, NULL, NULL, NULL, 'PROTEIN STRUBBELIG-RECEPTOR FAMILY 7', 242546),
(331515, 'PTHR48005:SF15', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242546),
(331516, 'PTHR48005:SF16', NULL, NULL, NULL, NULL, 'OS02G0553000 PROTEIN', 242546),
(331517, 'PTHR48005:SF6', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242546),
(331518, 'PTHR48005:SF5', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242546),
(331519, 'PTHR48005:SF54', NULL, NULL, NULL, NULL, 'OS02G0153200 PROTEIN', 242546),
(331520, 'PTHR48005:SF10', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE TYROSINE-PROTEIN KINASE PXC3 ISOFORM X1', 242546),
(331521, 'PTHR48005:SF55', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242546),
(331522, 'PTHR48005:SF3', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242546),
(331523, 'PTHR48005:SF2', NULL, NULL, NULL, NULL, 'OS06G0691800 PROTEIN', 242546),
(331524, 'PTHR45915:SF1', NULL, NULL, NULL, NULL, 'BROMODOMAIN ADJACENT TO ZINC FINGER DOMAIN PROTEIN 2B', 242547),
(331525, 'PTHR45915:SF2', NULL, NULL, NULL, NULL, 'IP14655P-RELATED', 242547),
(331526, 'PTHR45915:SF3', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM33', 242547),
(331527, 'PTHR45915:SF4', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INTERMEDIARY FACTOR 1-ALPHA', 242547),
(331528, 'PTHR45915:SF5', NULL, NULL, NULL, NULL, 'BROMODOMAIN ADJACENT TO ZINC FINGER DOMAIN PROTEIN 2A', 242547),
(331529, 'PTHR45915:SF6', NULL, NULL, NULL, NULL, 'INTERMEDIARY FACTOR 1-ALPHA, PUTATIVE-RELATED', 242547),
(331530, 'PTHR45915', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INTERMEDIARY FACTOR', 242547),
(331531, 'PTHR45915:SF7', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 66', 242547),
(331532, 'PTHR21859:SF6', NULL, NULL, NULL, NULL, 'GENE MODEL 906, (NCBI)-RELATED', 242548),
(331533, 'PTHR21859:SF55', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 31A1-RELATED', 242548),
(331534, 'PTHR21859:SF44', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 31C1-RELATED', 242548),
(331535, 'PTHR21859:SF12', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 31D1', 242548),
(331536, 'PTHR21859:SF56', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 242548),
(331537, 'PTHR21859:SF53', NULL, NULL, NULL, NULL, 'GENE 597-RELATED', 242548),
(331538, 'PTHR21859', NULL, NULL, NULL, NULL, 'ACROSOME-SPECIFIC PROTEIN', 242548),
(331539, 'PTHR21859:SF51', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1700014D04 GENE', 242548),
(331540, 'PTHR21859:SF52', NULL, NULL, NULL, NULL, '', 242548),
(331541, 'PTHR21859:SF50', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 31D3-RELATED', 242548),
(331542, 'PTHR21859:SF3', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED 31 SUBFAMILY D, MEMBER 1D', 242548),
(331543, 'PTHR21859:SF59', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED 31 SUBFAMILY D, MEMBER 1C', 242548),
(331544, 'PTHR21859:SF15', NULL, NULL, NULL, NULL, 'PROTEIN FAM205A-RELATED', 242548);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(331545, 'PTHR21859:SF57', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4931408C20 GENE', 242548),
(331546, 'PTHR21859:SF58', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 31E1', 242548),
(331547, 'PTHR12027:SF100', NULL, NULL, NULL, NULL, 'PROTEIN WNT', 242549),
(331548, 'PTHR12027:SF101', NULL, NULL, NULL, NULL, 'PROTEIN WNT-4', 242549),
(331549, 'PTHR12027:SF102', NULL, NULL, NULL, NULL, 'PROTEIN WNT-4', 242549),
(331550, 'PTHR12027:SF104', NULL, NULL, NULL, NULL, 'PROTEIN WNT', 242549),
(331551, 'PTHR12027:SF105', NULL, NULL, NULL, NULL, 'PROTEIN WNT-4A', 242549),
(331552, 'PTHR12027:SF73', NULL, NULL, NULL, NULL, 'PROTEIN WNT-7B', 242549),
(331553, 'PTHR12027:SF72', NULL, NULL, NULL, NULL, 'PROTEIN WNT-6', 242549),
(331554, 'PTHR12027:SF94', NULL, NULL, NULL, NULL, 'PROTEIN WNT-8B', 242549),
(331555, 'PTHR12027:SF93', NULL, NULL, NULL, NULL, 'PROTEIN WNT-2B', 242549),
(331556, 'PTHR12027:SF70', NULL, NULL, NULL, NULL, 'PROTEIN WNT-16', 242549),
(331557, 'PTHR12027:SF92', NULL, NULL, NULL, NULL, 'PROTEIN WNT-8A', 242549),
(331558, 'PTHR12027:SF77', NULL, NULL, NULL, NULL, 'PROTEIN WNT-5', 242549),
(331559, 'PTHR12027:SF33', NULL, NULL, NULL, NULL, 'PROTEIN WNT-5A', 242549),
(331560, 'PTHR12027:SF99', NULL, NULL, NULL, NULL, 'PROTEIN WNT', 242549),
(331561, 'PTHR12027:SF98', NULL, NULL, NULL, NULL, 'PROTEIN WNT', 242549),
(331562, 'PTHR12027:SF76', NULL, NULL, NULL, NULL, 'PROTEIN WNT-10B', 242549),
(331563, 'PTHR12027:SF97', NULL, NULL, NULL, NULL, 'PROTEIN WNT', 242549),
(331564, 'PTHR12027:SF75', NULL, NULL, NULL, NULL, 'PROTEIN WNT-9A', 242549),
(331565, 'PTHR12027:SF37', NULL, NULL, NULL, NULL, 'PROTEIN WNT', 242549),
(331566, 'PTHR12027', NULL, NULL, NULL, NULL, 'WNT RELATED', 242549),
(331567, 'PTHR12027:SF78', NULL, NULL, NULL, NULL, 'PROTEIN WNT-7A', 242549),
(331568, 'PTHR12027:SF34', NULL, NULL, NULL, NULL, 'PROTEIN WNT', 242549),
(331569, 'PTHR12027:SF110', NULL, NULL, NULL, NULL, 'PROTEIN WNT', 242549),
(331570, 'PTHR12027:SF112', NULL, NULL, NULL, NULL, 'PROTEIN WNT-2', 242549),
(331571, 'PTHR12027:SF114', NULL, NULL, NULL, NULL, 'PROTEIN MOM-2', 242549),
(331572, 'PTHR12027:SF91', NULL, NULL, NULL, NULL, 'PROTO-ONCOGENE WNT-1', 242549),
(331573, 'PTHR12027:SF84', NULL, NULL, NULL, NULL, 'PROTEIN WNT-9B', 242549),
(331574, 'PTHR12027:SF82', NULL, NULL, NULL, NULL, 'PROTO-ONCOGENE WNT-3', 242549),
(331575, 'PTHR12027:SF81', NULL, NULL, NULL, NULL, 'WNT INHIBITOR OF DORSAL PROTEIN', 242549),
(331576, 'PTHR12027:SF88', NULL, NULL, NULL, NULL, 'PROTEIN WNT-3A', 242549),
(331577, 'PTHR12027:SF87', NULL, NULL, NULL, NULL, 'PROTEIN WNT-5B', 242549),
(331578, 'PTHR12027:SF86', NULL, NULL, NULL, NULL, 'PROTEIN WNT-2', 242549),
(331579, 'PTHR12027:SF7', NULL, NULL, NULL, NULL, 'PROTEIN WNT-11', 242549),
(331580, 'PTHR12027:SF89', NULL, NULL, NULL, NULL, 'PROTEIN WNT-10A', 242549),
(331581, 'PTHR32024:SF4', NULL, NULL, NULL, NULL, 'KTR SYSTEM POTASSIUM UPTAKE PROTEIN D', 242550),
(331582, 'PTHR32024:SF3', NULL, NULL, NULL, NULL, 'TRK SYSTEM POTASSIUM UPTAKE PROTEIN', 242550),
(331583, 'PTHR32024', NULL, NULL, NULL, NULL, 'TRK SYSTEM POTASSIUM UPTAKE PROTEIN TRKG-RELATED', 242550),
(331584, 'PTHR32024:SF2', NULL, NULL, NULL, NULL, 'TRK SYSTEM POTASSIUM UPTAKE PROTEIN TRKG-RELATED', 242550),
(331585, 'PTHR32024:SF1', NULL, NULL, NULL, NULL, 'KTR SYSTEM POTASSIUM UPTAKE PROTEIN B', 242550),
(331586, 'PTHR36452:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 12, WHOLE GENOME SHOTGUN SEQUENCE', 242551),
(331587, 'PTHR36452', NULL, NULL, NULL, NULL, 'CHROMOSOME 12, WHOLE GENOME SHOTGUN SEQUENCE', 242551),
(331588, 'PTHR47679', NULL, NULL, NULL, NULL, 'PROTEIN TORNADO 1', 242552),
(331589, 'PTHR47679:SF1', NULL, NULL, NULL, NULL, 'PROTEIN TORNADO 1', 242552),
(331590, 'PTHR31975', NULL, NULL, NULL, NULL, 'BUD SITE SELECTION PROTEIN 7-RELATED', 242553),
(331591, 'PTHR31975:SF2', NULL, NULL, NULL, NULL, 'CHITIN BIOSYNTHESIS PROTEIN CHS6-RELATED', 242553),
(331592, 'PTHR31975:SF1', NULL, NULL, NULL, NULL, 'BUD SITE SELECTION PROTEIN 7-RELATED', 242553),
(331593, 'PTHR46592:SF6', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL67', 242554);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(331594, 'PTHR46592:SF5', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT 11 RING-H2 FINGER PROTEIN', 242554),
(331595, 'PTHR46592:SF10', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 242554),
(331596, 'PTHR46592', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL67', 242554),
(331597, 'PTHR46592:SF1', NULL, NULL, NULL, NULL, 'OS01G0736600 PROTEIN', 242554),
(331598, 'PTHR46592:SF15', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C2H2 FAMILY-RELATED', 242554),
(331599, 'PTHR46592:SF14', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 242554),
(331600, 'PTHR46592:SF13', NULL, NULL, NULL, NULL, 'BNAANNG20290D PROTEIN', 242554),
(331601, 'PTHR46592:SF9', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL68', 242554),
(331602, 'PTHR37739:SF14', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-12E', 242555),
(331603, 'PTHR37739', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-12D', 242555),
(331604, 'PTHR37739:SF13', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 242555),
(331605, 'PTHR37739:SF8', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-12D', 242555),
(331606, 'PTHR37739:SF16', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 242555),
(331607, 'PTHR37739:SF15', NULL, NULL, NULL, NULL, 'KINESIN', 242555),
(331608, 'PTHR37739:SF10', NULL, NULL, NULL, NULL, '', 242555),
(331609, 'PTHR37739:SF18', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-12C', 242555),
(331610, 'PTHR37739:SF17', NULL, NULL, NULL, NULL, 'PAKRP1L', 242555),
(331611, 'PTHR37739:SF19', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-12E', 242555),
(331612, 'PTHR13100:SF10', NULL, NULL, NULL, NULL, 'CELL GROWTH-REGULATING NUCLEOLAR PROTEIN', 242556),
(331613, 'PTHR13100', NULL, NULL, NULL, NULL, 'CELL GROWTH-REGULATING NUCLEOLAR PROTEIN LYAR', 242556),
(331614, 'PTHR39414:SF1', NULL, NULL, NULL, NULL, 'SERINE/ARGININE REPETITIVE MATRIX PROTEIN 5', 242557),
(331615, 'PTHR39414:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG02561', 242557),
(331616, 'PTHR39414', NULL, NULL, NULL, NULL, 'SERINE/ARGININE REPETITIVE MATRIX PROTEIN 5-RELATED', 242557),
(331617, 'PTHR36866:SF1', NULL, NULL, NULL, NULL, 'GENE 1043-RELATED', 242558),
(331618, 'PTHR36866', NULL, NULL, NULL, NULL, 'CHROMOSOME 4 OPEN READING FRAME 50', 242558),
(331619, 'PTHR47070', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN-LIKE', 242559),
(331620, 'PTHR47070:SF2', NULL, NULL, NULL, NULL, 'OS06G0206100 PROTEIN', 242559),
(331621, 'PTHR47070:SF4', NULL, NULL, NULL, NULL, 'DUF1296 DOMAIN-CONTAINING PROTEIN', 242559),
(331622, 'PTHR47070:SF3', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 242559),
(331623, 'PTHR34501:SF9', NULL, NULL, NULL, NULL, 'MAJOR OUTER MEMBRANE PROTEIN P.IA', 242560),
(331624, 'PTHR34501:SF8', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PORIN F-RELATED', 242560),
(331625, 'PTHR34501:SF2', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PORIN PROTEIN NMPC-RELATED', 242560),
(331626, 'PTHR34501:SF5', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PORIN PHOE', 242560),
(331627, 'PTHR34501', NULL, NULL, NULL, NULL, 'PROTEIN YDDL-RELATED', 242560),
(331628, 'PTHR34501:SF1', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PORIN C', 242560),
(331629, 'PTHR31951', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN-RELATED', 242561),
(331630, 'PTHR31951:SF24', NULL, NULL, NULL, NULL, 'ECA1 GAMETOGENESIS RELATED FAMILY', 242561),
(331631, 'PTHR31951:SF25', NULL, NULL, NULL, NULL, 'PROLAMIN_LIKE DOMAIN-CONTAINING PROTEIN', 242561),
(331632, 'PTHR31951:SF22', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN-RELATED', 242561),
(331633, 'PTHR31951:SF28', NULL, NULL, NULL, NULL, 'PROLAMIN_LIKE DOMAIN-CONTAINING PROTEIN', 242561),
(331634, 'PTHR31951:SF26', NULL, NULL, NULL, NULL, 'ECA1 GAMETOGENESIS RELATED FAMILY', 242561),
(331635, 'PTHR31951:SF27', NULL, NULL, NULL, NULL, 'PROLAMIN_LIKE DOMAIN-CONTAINING PROTEIN', 242561),
(331636, 'PTHR42967:SF1', NULL, NULL, NULL, NULL, 'METAL DEPENDENT HYDROLASE', 242562);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(331637, 'PTHR42967', NULL, NULL, NULL, NULL, 'METAL DEPENDENT HYDROLASE', 242562),
(331638, 'PTHR14374', NULL, NULL, NULL, NULL, 'FOIE GRAS', 242563),
(331639, 'PTHR14374:SF0', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT 11', 242563),
(331640, 'PTHR40106:SF1', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN RCLC', 242564),
(331641, 'PTHR40106', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN RCLC', 242564),
(331642, 'PTHR39191:SF1', NULL, NULL, NULL, NULL, 'GALACTOSE-1-PHOSPHATE URIDYLYLTRANSFERASE', 242565),
(331643, 'PTHR39191', NULL, NULL, NULL, NULL, 'GALACTOSE-1-PHOSPHATE URIDYLYLTRANSFERASE', 242565),
(331644, 'PTHR46731', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 15', 242566),
(331645, 'PTHR46731:SF1', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 15', 242566),
(331646, 'PTHR44656:SF2', NULL, NULL, NULL, NULL, 'FLJ13639', 242567),
(331647, 'PTHR44656', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE SDR FAMILY MEMBER 12', 242567),
(331648, 'PTHR44656:SF6', NULL, NULL, NULL, NULL, 'SI:CH211-165B10.3', 242567),
(331649, 'PTHR44656:SF7', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE SDR FAMILY MEMBER 12', 242567),
(331650, 'PTHR44656:SF5', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE (SDR FAMILY) MEMBER 12', 242567),
(331651, 'PTHR45977:SF48', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE', 242568),
(331652, 'PTHR45977:SF26', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 242568),
(331653, 'PTHR45977:SF47', NULL, NULL, NULL, NULL, 'BNAA02G13540D PROTEIN', 242568),
(331654, 'PTHR45977:SF46', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 242568),
(331655, 'PTHR45977', NULL, NULL, NULL, NULL, 'TARGET OF ERK KINASE MPK-1', 242568),
(331656, 'PTHR45977:SF45', NULL, NULL, NULL, NULL, 'BNAC02G39560D PROTEIN', 242568),
(331657, 'PTHR45977:SF22', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C2H2 FAMILY-RELATED', 242568),
(331658, 'PTHR45977:SF43', NULL, NULL, NULL, NULL, 'OS07G0463400 PROTEIN', 242568),
(331659, 'PTHR45977:SF21', NULL, NULL, NULL, NULL, 'ZINC FINGER FAMILY PROTEIN', 242568),
(331660, 'PTHR45977:SF42', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 242568),
(331661, 'PTHR45977:SF29', NULL, NULL, NULL, NULL, 'BNAC06G13710D PROTEIN', 242568),
(331662, 'PTHR45977:SF28', NULL, NULL, NULL, NULL, 'OS02G0674700 PROTEIN', 242568),
(331663, 'PTHR45977:SF49', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 242568),
(331664, 'PTHR45977:SF51', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C2H2 FAMILY-RELATED', 242568),
(331665, 'PTHR45977:SF50', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 242568),
(331666, 'PTHR45977:SF14', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN PROTEIN LIGASE RIE1', 242568),
(331667, 'PTHR45977:SF35', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 242568),
(331668, 'PTHR45977:SF13', NULL, NULL, NULL, NULL, 'GB|AAF27103.1', 242568),
(331669, 'PTHR45977:SF12', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C2H2 FAMILY-RELATED', 242568),
(331670, 'PTHR45977:SF33', NULL, NULL, NULL, NULL, 'BNACNNG67740D PROTEIN', 242568),
(331671, 'PTHR45977:SF11', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 242568),
(331672, 'PTHR45977:SF4', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 242568),
(331673, 'PTHR45977:SF19', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 242568),
(331674, 'PTHR45977:SF39', NULL, NULL, NULL, NULL, 'BNAA09G46850D PROTEIN', 242568),
(331675, 'PTHR45977:SF7', NULL, NULL, NULL, NULL, 'OS03G0380700 PROTEIN', 242568),
(331676, 'PTHR45977:SF16', NULL, NULL, NULL, NULL, 'BNACNNG32440D PROTEIN', 242568),
(331677, 'PTHR45977:SF38', NULL, NULL, NULL, NULL, 'BNAA04G26400D PROTEIN', 242568),
(331678, 'PTHR45977:SF40', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 242568),
(331679, 'PTHR34216:SF12', NULL, NULL, NULL, NULL, 'CARBOHYDRATE ESTERASE FAMILY 4', 242569),
(331680, 'PTHR34216', NULL, NULL, NULL, NULL, '', 242569),
(331681, 'PTHR34216:SF3', NULL, NULL, NULL, NULL, 'POLY-BETA-1,6-N-ACETYL-D-GLUCOSAMINE N-DEACETYLASE', 242569); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(331682, 'PTHR34216:SF11', NULL, NULL, NULL, NULL, 'CHITOOLIGOSACCHARIDE DEACETYLASE', 242569),
(331683, 'PTHR34216:SF8', NULL, NULL, NULL, NULL, 'POLYSACCHARIDE DEACETYLASE-LIKE PROTEIN', 242569),
(331684, 'PTHR34216:SF7', NULL, NULL, NULL, NULL, 'POLY-BETA-1,6-N-ACETYL-D-GLUCOSAMINE N-DEACETYLASE', 242569),
(331685, 'PTHR33395:SF20', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 242570),
(331686, 'PTHR33395', NULL, NULL, NULL, NULL, 'TRANSCRIPTASE, PUTATIVE-RELATED-RELATED', 242570),
(331687, 'PTHR42826:SF8', NULL, NULL, NULL, NULL, 'GLUTAMATE/MALATE TRANSLOCATOR', 242571),
(331688, 'PTHR42826:SF7', NULL, NULL, NULL, NULL, 'DICARBOXYLIC ACID TRANSPORTER2', 242571),
(331689, 'PTHR42826:SF9', NULL, NULL, NULL, NULL, 'SODIUM/SULFATE SYMPORTER-RELATED', 242571),
(331690, 'PTHR42826', NULL, NULL, NULL, NULL, 'DICARBOXYLATE TRANSPORTER 2.1, CHLOROPLASTIC', 242571),
(331691, 'PTHR42826:SF10', NULL, NULL, NULL, NULL, 'DICARBOXYLATE TRANSPORTER 2.2, CHLOROPLASTIC', 242571),
(331692, 'PTHR42826:SF11', NULL, NULL, NULL, NULL, 'DICARBOXYLATE TRANSPORTER 2.1, CHLOROPLASTIC-LIKE', 242571),
(331693, 'PTHR42826:SF12', NULL, NULL, NULL, NULL, 'BNAA09G06780D PROTEIN', 242571),
(331694, 'PTHR42826:SF2', NULL, NULL, NULL, NULL, 'CITRATE/SUCCINATE ANTIPORTER-RELATED', 242571),
(331695, 'PTHR42826:SF1', NULL, NULL, NULL, NULL, 'DICARBOXYLATE TRANSPORTER 2.1, CHLOROPLASTIC', 242571),
(331696, 'PTHR42826:SF3', NULL, NULL, NULL, NULL, 'DICARBOXYLATE TRANSPORTER 1, CHLOROPLASTIC', 242571),
(331697, 'PTHR22731:SF3', NULL, NULL, NULL, NULL, 'RIBONUCLEASES P/MRP PROTEIN SUBUNIT POP1', 242572),
(331698, 'PTHR22731:SF4', NULL, NULL, NULL, NULL, 'DUF676 DOMAIN-CONTAINING PROTEIN', 242572),
(331699, 'PTHR22731', NULL, NULL, NULL, NULL, 'RIBONUCLEASES P/MRP PROTEIN SUBUNIT POP1', 242572),
(331700, 'PTHR36727', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT L, CHLOROPLASTIC', 242573),
(331701, 'PTHR36727:SF2', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT L, CHLOROPLASTIC', 242573),
(331702, 'PTHR36727:SF3', NULL, NULL, NULL, NULL, 'BNAC02G20220D PROTEIN', 242573),
(331703, 'PTHR47021:SF6', NULL, NULL, NULL, NULL, 'ARF-GAP DOMAIN-CONTAINING PROTEIN', 242574),
(331704, 'PTHR47021:SF4', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN AGD6-RELATED', 242574),
(331705, 'PTHR47021:SF3', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN AGD7', 242574),
(331706, 'PTHR47021:SF2', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN AGD6-RELATED', 242574),
(331707, 'PTHR47021:SF10', NULL, NULL, NULL, NULL, 'ARF GTPASE ACTIVATING PROTEIN-RELATED', 242574),
(331708, 'PTHR47021', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN AGD6-RELATED', 242574),
(331709, 'PTHR47021:SF9', NULL, NULL, NULL, NULL, 'ARF-GAP DOMAIN-CONTAINING PROTEIN', 242574),
(331710, 'PTHR47021:SF7', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN AGD6-RELATED', 242574),
(331711, 'PTHR34218', NULL, NULL, NULL, NULL, 'PEPTIDASE S45 PENICILLIN AMIDASE', 242575),
(331712, 'PTHR34218:SF2', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 242575),
(331713, 'PTHR34218:SF4', NULL, NULL, NULL, NULL, 'ACYL-HOMOSERINE LACTONE ACYLASE QUIP', 242575),
(331714, 'PTHR34218:SF3', NULL, NULL, NULL, NULL, 'ACYL-HOMOSERINE LACTONE ACYLASE PVDQ', 242575),
(331715, 'PTHR38409', NULL, NULL, NULL, NULL, 'MDM10-COMPLEMENTING PROTEIN 1', 242576),
(331716, 'PTHR38409:SF1', NULL, NULL, NULL, NULL, 'MDM10-COMPLEMENTING PROTEIN 1', 242576),
(331717, 'PTHR14401:SF6', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN K', 242577),
(331718, 'PTHR14401', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN K', 242577),
(331719, 'PTHR15853:SF0', NULL, NULL, NULL, NULL, 'THIOREDOXIN-RELATED TRANSMEMBRANE PROTEIN 2', 242578),
(331720, 'PTHR15853', NULL, NULL, NULL, NULL, 'THIOREDOXIN-RELATED', 242578),
(331721, 'PTHR31961', NULL, NULL, NULL, NULL, 'SENSITIVE TO HIGH EXPRESSION PROTEIN 9, MITOCHONDRIAL', 242579),
(331722, 'PTHR31961:SF3', NULL, NULL, NULL, NULL, 'SENSITIVE TO HIGH EXPRESSION PROTEIN 9, MITOCHONDRIAL', 242579);
INSERT INTO "PUBLIC"."MODEL" VALUES
(331723, 'PTHR15976', NULL, NULL, NULL, NULL, 'CONSTITUTIVE COACTIVATOR OF PEROXISOME PROLIFERATOR-ACTIVATED RECEPTOR GAMMA', 242580),
(331724, 'PTHR15976:SF16', NULL, NULL, NULL, NULL, 'XPG_I_2 DOMAIN-CONTAINING PROTEIN', 242580),
(331725, 'PTHR15976:SF17', NULL, NULL, NULL, NULL, 'CONSTITUTIVE COACTIVATOR OF PEROXISOME PROLIFERATOR-ACTIVATED RECEPTOR GAMMA', 242580),
(331726, 'PTHR15976:SF14', NULL, NULL, NULL, NULL, 'CONSTITUTIVE COACTIVATOR OF PPAR-GAMMA-LIKE PROTEIN 1', 242580),
(331727, 'PTHR15976:SF15', NULL, NULL, NULL, NULL, 'CONSTITUTIVE COACTIVATOR OF PPAR-GAMMA-LIKE PROTEIN 2', 242580),
(331728, 'PTHR47437:SF3', NULL, NULL, NULL, NULL, 'C-JUN-AMINO-TERMINAL KINASE-INTERACTING PROTEIN 1', 242581),
(331729, 'PTHR47437:SF2', NULL, NULL, NULL, NULL, 'C-JUN-AMINO-TERMINAL KINASE-INTERACTING PROTEIN 2', 242581),
(331730, 'PTHR47437:SF4', NULL, NULL, NULL, NULL, 'JNK-INTERACTING PROTEIN 1-LIKE PROTEIN', 242581),
(331731, 'PTHR47437', NULL, NULL, NULL, NULL, 'JNK-INTERACTING PROTEIN 1-LIKE PROTEIN', 242581),
(331732, 'PTHR43852', NULL, NULL, NULL, NULL, 'NUCLEOTIDYLTRANSFERASE', 242582),
(331733, 'PTHR43852:SF2', NULL, NULL, NULL, NULL, 'PROTEIN ADENYLYLTRANSFERASE MNTA', 242582),
(331734, 'PTHR43852:SF3', NULL, NULL, NULL, NULL, 'SLR5017 PROTEIN', 242582),
(331735, 'PTHR37960:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG22893', 242583),
(331736, 'PTHR37960:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG20683', 242583),
(331737, 'PTHR37960:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG02859', 242583),
(331738, 'PTHR37960:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG06493', 242583),
(331739, 'PTHR37960', NULL, NULL, NULL, NULL, 'PROTEIN CBG06493-RELATED', 242583),
(331740, 'PTHR28011', NULL, NULL, NULL, NULL, 'NON-CLASSICAL EXPORT PROTEIN 1', 242584),
(331741, 'PTHR28011:SF1', NULL, NULL, NULL, NULL, 'NON-CLASSICAL EXPORT PROTEIN 1', 242584),
(331742, 'PTHR47308', NULL, NULL, NULL, NULL, 'NUCLEAR GTPASE SLIP-GC', 242585),
(331743, 'PTHR47308:SF1', NULL, NULL, NULL, NULL, 'NUCLEAR GTPASE SLIP-GC', 242585),
(331744, 'PTHR21726:SF64', NULL, NULL, NULL, NULL, 'SERINE-RICH ADHESIN FOR PLATELETS-LIKE PROTEIN', 242586),
(331745, 'PTHR21726:SF65', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242586),
(331746, 'PTHR21726', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL N-ACETYLGLUCOSAMINYLTRANSFERASE SUBUNIT P  DOWN SYNDROME CRITICAL REGION PROTEIN 5 -RELATED', 242586),
(331747, 'PTHR21726:SF72', NULL, NULL, NULL, NULL, 'VARLMGL DOMAIN-CONTAINING PROTEIN', 242586),
(331748, 'PTHR21726:SF61', NULL, NULL, NULL, NULL, 'DNAA INITIATOR-ASSOCIATING PROTEIN', 242586),
(331749, 'PTHR21726:SF73', NULL, NULL, NULL, NULL, 'DUF3741-ASSOCIATED SEQUENCE MOTIF PROTEIN-RELATED', 242586),
(331750, 'PTHR21726:SF29', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242586),
(331751, 'PTHR21726:SF67', NULL, NULL, NULL, NULL, 'BNAC02G48370D PROTEIN', 242586),
(331752, 'PTHR21726:SF57', NULL, NULL, NULL, NULL, 'GPI-ANCHORED ADHESIN-LIKE PROTEIN', 242586),
(331753, 'PTHR21726:SF69', NULL, NULL, NULL, NULL, 'BNAA09G04050D PROTEIN', 242586),
(331754, 'PTHR21726:SF58', NULL, NULL, NULL, NULL, '', 242586),
(331755, 'PTHR21726:SF59', NULL, NULL, NULL, NULL, 'DUF4378 DOMAIN PROTEIN', 242586),
(331756, 'PTHR31396', NULL, NULL, NULL, NULL, 'PROTEIN FAM163B MEMBER', 242587),
(331757, 'PTHR31396:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM163B', 242587),
(331758, 'PTHR47561', NULL, NULL, NULL, NULL, 'POLYSACCHARIDE DEACETYLASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_6G05030)', 242588),
(331759, 'PTHR47561:SF1', NULL, NULL, NULL, NULL, 'POLYSACCHARIDE DEACETYLASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_6G05030)', 242588),
(331760, 'PTHR47561:SF2', NULL, NULL, NULL, NULL, 'HYPOTHETICAL POLYSACCHARIDE DEACETYLASE (EUROFUNG)', 242588),
(331761, 'PTHR37998:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 262', 242589),
(331762, 'PTHR37998', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 262', 242589),
(331763, 'PTHR15356:SF0', NULL, NULL, NULL, NULL, 'NEUROTENSIN/NEUROMEDIN N', 242590),
(331764, 'PTHR15356', NULL, NULL, NULL, NULL, 'NEUROTENSIN/NEUROMEDIN N', 242590); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(331765, 'PTHR43796:SF4', NULL, NULL, NULL, NULL, 'SACCHRP_DH_NADP DOMAIN-CONTAINING PROTEIN', 242591),
(331766, 'PTHR43796:SF2', NULL, NULL, NULL, NULL, 'CARBOXYNORSPERMIDINE SYNTHASE', 242591),
(331767, 'PTHR43796', NULL, NULL, NULL, NULL, 'CARBOXYNORSPERMIDINE SYNTHASE', 242591),
(331768, 'PTHR13391:SF0', NULL, NULL, NULL, NULL, 'PROTEIN MISATO HOMOLOG 1', 242592),
(331769, 'PTHR13391', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL DISTRIBUTION REGULATOR MISATO', 242592),
(331770, 'PTHR10194', NULL, NULL, NULL, NULL, 'RAS GTPASE-ACTIVATING PROTEINS', 242593),
(331771, 'PTHR10194:SF129', NULL, NULL, NULL, NULL, 'NEUROFIBROMIN-A', 242593),
(331772, 'PTHR10194:SF25', NULL, NULL, NULL, NULL, 'RAS/RAP GTPASE-ACTIVATING PROTEIN SYNGAP', 242593),
(331773, 'PTHR10194:SF147', NULL, NULL, NULL, NULL, 'RAS-GAP DOMAIN-CONTAINING PROTEIN', 242593),
(331774, 'PTHR10194:SF125', NULL, NULL, NULL, NULL, 'RAS GTPASE-ACTIVATING PROTEIN RASKOL', 242593),
(331775, 'PTHR10194:SF146', NULL, NULL, NULL, NULL, 'RAS GTPASE-ACTIVATING PROTEIN 1', 242593),
(331776, 'PTHR10194:SF145', NULL, NULL, NULL, NULL, 'SYNAPTIC RAS GTPASE-ACTIVATING PROTEIN 1A', 242593),
(331777, 'PTHR10194:SF26', NULL, NULL, NULL, NULL, 'DISABLED HOMOLOG 2-INTERACTING PROTEIN', 242593),
(331778, 'PTHR10194:SF144', NULL, NULL, NULL, NULL, '', 242593),
(331779, 'PTHR10194:SF132', NULL, NULL, NULL, NULL, 'RAS-GAP DOMAIN-CONTAINING PROTEIN', 242593),
(331780, 'PTHR10194:SF142', NULL, NULL, NULL, NULL, 'NEUROFIBROMIN', 242593),
(331781, 'PTHR10194:SF3', NULL, NULL, NULL, NULL, 'RASGAP-ACTIVATING-LIKE PROTEIN 1', 242593),
(331782, 'PTHR10194:SF60', NULL, NULL, NULL, NULL, 'GTPASE-ACTIVATING PROTEIN', 242593),
(331783, 'PTHR10194:SF4', NULL, NULL, NULL, NULL, 'RAS GTPASE-ACTIVATING PROTEIN 4-RELATED', 242593),
(331784, 'PTHR10194:SF96', NULL, NULL, NULL, NULL, 'RAS PROTEIN ACTIVATOR LIKE-3', 242593),
(331785, 'PTHR10194:SF52', NULL, NULL, NULL, NULL, 'RAS GTPASE-ACTIVATING PROTEIN NGAP', 242593),
(331786, 'PTHR10194:SF21', NULL, NULL, NULL, NULL, 'RAS GTPASE-ACTIVATING PROTEIN 2', 242593),
(331787, 'PTHR10194:SF53', NULL, NULL, NULL, NULL, 'RAS GTPASE-ACTIVATING PROTEIN 3', 242593),
(331788, 'PTHR10194:SF75', NULL, NULL, NULL, NULL, 'RAS-GAP DOMAIN-CONTAINING PROTEIN', 242593),
(331789, 'PTHR13395', NULL, NULL, NULL, NULL, 'SISTER CHROMATID COHESION PROTEIN DCC1-RELATED', 242594),
(331790, 'PTHR13395:SF6', NULL, NULL, NULL, NULL, 'SISTER CHROMATID COHESION PROTEIN DCC1', 242594),
(331791, 'PTHR47016:SF2', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE ATP-BINDING SUBUNIT CLPT2, CHLOROPLASTIC', 242595),
(331792, 'PTHR47016:SF1', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE ATP-BINDING SUBUNIT CLPT1, CHLOROPLASTIC', 242595),
(331793, 'PTHR47016:SF4', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE ATP-BINDING SUBUNIT CLPT2, CHLOROPLASTIC-LIKE', 242595),
(331794, 'PTHR47016', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE ATP-BINDING SUBUNIT CLPT1, CHLOROPLASTIC', 242595),
(331795, 'PTHR23415', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASES REGULATORY SUBUNIT/60S RIBOSOME SUBUNIT BIOGENESIS PROTEIN NIP7', 242596),
(331796, 'PTHR23415:SF4', NULL, NULL, NULL, NULL, '60S RIBOSOME SUBUNIT BIOGENESIS PROTEIN NIP7 HOMOLOG', 242596),
(331797, 'PTHR23415:SF35', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASES REGULATORY SUBUNIT', 242596),
(331798, 'PTHR23415:SF46', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASES REGULATORY SUBUNIT', 242596),
(331799, 'PTHR23415:SF47', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASES REGULATORY SUBUNIT 2', 242596),
(331800, 'PTHR23415:SF34', NULL, NULL, NULL, NULL, '60S RIBOSOME SUBUNIT BIOGENESIS PROTEIN NIP7 HOMOLOG', 242596),
(331801, 'PTHR23415:SF45', NULL, NULL, NULL, NULL, '60S RIBOSOME SUBUNIT BIOGENESIS PROTEIN NIP7 HOMOLOG', 242596),
(331802, 'PTHR23415:SF42', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASES REGULATORY SUBUNIT 1', 242596),
(331803, 'PTHR23415:SF31', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASES REGULATORY SUBUNIT', 242596),
(331804, 'PTHR23415:SF32', NULL, NULL, NULL, NULL, '60S RIBOSOME SUBUNIT BIOGENESIS PROTEIN NIP7 HOMOLOG', 242596);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(331805, 'PTHR23415:SF30', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASES REGULATORY SUBUNIT', 242596),
(331806, 'PTHR23415:SF41', NULL, NULL, NULL, NULL, '60S RIBOSOME SUBUNIT BIOGENESIS PROTEIN NIP7 HOMOLOG', 242596),
(331807, 'PTHR23415:SF29', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASES REGULATORY SUBUNIT-RELATED', 242596),
(331808, 'PTHR23415:SF48', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASES REGULATORY SUBUNIT 2', 242596),
(331809, 'PTHR38784:SF1', NULL, NULL, NULL, NULL, 'SUCROSE PHOSPHORYLASE', 242597),
(331810, 'PTHR38784', NULL, NULL, NULL, NULL, 'SUCROSE PHOSPHORYLASE', 242597),
(331811, 'PTHR36549', NULL, NULL, NULL, NULL, 'LYSINE-RICH ARABINOGALACTAN PROTEIN 19', 242598),
(331812, 'PTHR36549:SF3', NULL, NULL, NULL, NULL, 'LYSINE-RICH ARABINOGALACTAN PROTEIN 19', 242598),
(331813, 'PTHR36549:SF4', NULL, NULL, NULL, NULL, '', 242598),
(331814, 'PTHR33662:SF2', NULL, NULL, NULL, NULL, 'UBIQUITIN THIOESTERASE OTULIN', 242599),
(331815, 'PTHR33662:SF1', NULL, NULL, NULL, NULL, 'INACTIVE UBIQUITIN THIOESTERASE OTULINL', 242599),
(331816, 'PTHR33662', NULL, NULL, NULL, NULL, 'OTU DEUBIQUITINASE WITH LINEAR LINKAGE-SPECIFICITY A-RELATED', 242599),
(331817, 'PTHR33662:SF3', NULL, NULL, NULL, NULL, 'OTU DEUBIQUITINASE WITH LINEAR LINKAGE-SPECIFICITY A-RELATED', 242599),
(331818, 'PTHR46971:SF1', NULL, NULL, NULL, NULL, 'CALCINEURIN B SUBUNIT (PROTEIN PHOSPHATASE 2B REGULATORY SUBUNIT)-LIKE PROTEIN', 242600),
(331819, 'PTHR46971', NULL, NULL, NULL, NULL, 'CALCINEURIN B SUBUNIT (PROTEIN PHOSPHATASE 2B REGULATORY SUBUNIT)-LIKE PROTEIN', 242600),
(331820, 'PTHR46971:SF4', NULL, NULL, NULL, NULL, 'OS08G0442300 PROTEIN', 242600),
(331821, 'PTHR46971:SF5', NULL, NULL, NULL, NULL, 'BNAA05G09640D PROTEIN', 242600),
(331822, 'PTHR46971:SF3', NULL, NULL, NULL, NULL, '', 242600),
(331823, 'PTHR13214', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 330', 242601),
(331824, 'PTHR13214:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 330', 242601),
(331825, 'PTHR21630:SF10', NULL, NULL, NULL, NULL, 'VENTRICULAR ZONE-EXPRESSED PH DOMAIN-CONTAINING PROTEIN HOMOLOG 1', 242602),
(331826, 'PTHR21630', NULL, NULL, NULL, NULL, 'VEPH-A/MELTED', 242602),
(331827, 'PTHR31959:SF2', NULL, NULL, NULL, NULL, '', 242603),
(331828, 'PTHR31959', NULL, NULL, NULL, NULL, '', 242603),
(331829, 'PTHR10179:SF80', NULL, NULL, NULL, NULL, 'C-X-C MOTIF CHEMOKINE 2', 242604),
(331830, 'PTHR10179:SF90', NULL, NULL, NULL, NULL, 'C-X-C MOTIF CHEMOKINE 15', 242604),
(331831, 'PTHR10179:SF42', NULL, NULL, NULL, NULL, 'INTERLEUKIN-8', 242604),
(331832, 'PTHR10179:SF86', NULL, NULL, NULL, NULL, 'C-X-C MOTIF CHEMOKINE 5', 242604),
(331833, 'PTHR10179:SF52', NULL, NULL, NULL, NULL, 'PLATELET BASIC PROTEIN', 242604),
(331834, 'PTHR10179:SF88', NULL, NULL, NULL, NULL, 'CHEMOKINE (C-X-C MOTIF) LIGAND 18B-RELATED', 242604),
(331835, 'PTHR10179:SF44', NULL, NULL, NULL, NULL, 'C-X-C MOTIF CHEMOKINE 9', 242604),
(331836, 'PTHR10179:SF43', NULL, NULL, NULL, NULL, 'PLATELET FACTOR 4', 242604),
(331837, 'PTHR10179:SF82', NULL, NULL, NULL, NULL, 'C-X-C MOTIF CHEMOKINE 3', 242604),
(331838, 'PTHR10179:SF84', NULL, NULL, NULL, NULL, 'C-X-C MOTIF CHEMOKINE 11', 242604),
(331839, 'PTHR10179:SF38', NULL, NULL, NULL, NULL, 'PLATELET FACTOR 4 VARIANT', 242604),
(331840, 'PTHR10179:SF27', NULL, NULL, NULL, NULL, 'C-X-C MOTIF CHEMOKINE 13', 242604),
(331841, 'PTHR10179', NULL, NULL, NULL, NULL, 'CXC CHEMOKINE', 242604),
(331842, 'PTHR10179:SF79', NULL, NULL, NULL, NULL, 'C-X-C MOTIF CHEMOKINE 2', 242604),
(331843, 'PTHR10179:SF12', NULL, NULL, NULL, NULL, 'C-X-C MOTIF CHEMOKINE 6', 242604),
(331844, 'PTHR10179:SF89', NULL, NULL, NULL, NULL, 'CHEMOKINE (C-X-C MOTIF) LIGAND 20-RELATED', 242604),
(331845, 'PTHR10179:SF34', NULL, NULL, NULL, NULL, 'C-X-C MOTIF CHEMOKINE 3', 242604),
(331846, 'PTHR10179:SF47', NULL, NULL, NULL, NULL, 'C-X-C MOTIF CHEMOKINE 10', 242604),
(331847, 'PTHR10179:SF69', NULL, NULL, NULL, NULL, 'GROWTH-REGULATED ALPHA PROTEIN', 242604),
(331848, 'PTHR43647:SF5', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE-RELATED', 242605);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(331849, 'PTHR43647', NULL, NULL, NULL, NULL, 'DEHYDROGENASE', 242605),
(331850, 'PTHR43647:SF4', NULL, NULL, NULL, NULL, '', 242605),
(331851, 'PTHR43647:SF1', NULL, NULL, NULL, NULL, '3-KETO-STEROID REDUCTASE', 242605),
(331852, 'PTHR43647:SF2', NULL, NULL, NULL, NULL, 'DEHYDROGENASE', 242605),
(331853, 'PTHR46808:SF1', NULL, NULL, NULL, NULL, 'H2.0-LIKE HOMEOBOX PROTEIN', 242606),
(331854, 'PTHR46808', NULL, NULL, NULL, NULL, 'H2.0-LIKE HOMEOBOX PROTEIN', 242606),
(331855, 'PTHR12174:SF39', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDE PEPTIDASE-LIKE 2B', 242607),
(331856, 'PTHR12174', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDE PEPTIDASE', 242607),
(331857, 'PTHR12174:SF79', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDE PEPTIDASE-LIKE 5', 242607),
(331858, 'PTHR12174:SF35', NULL, NULL, NULL, NULL, 'INTRAMEMBRANE PROTEASE (IMPAS) FAMILY', 242607),
(331859, 'PTHR12174:SF38', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDE PEPTIDASE-LIKE 2C', 242607),
(331860, 'PTHR12174:SF90', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDE PEPTIDASE-LIKE 3', 242607),
(331861, 'PTHR12174:SF92', NULL, NULL, NULL, NULL, 'PA DOMAIN, PRESENILIN/SIGNAL PEPTIDE PEPTIDASE-RELATED', 242607),
(331862, 'PTHR12174:SF106', NULL, NULL, NULL, NULL, 'PA DOMAIN-CONTAINING PROTEIN', 242607),
(331863, 'PTHR12174:SF105', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDE PEPTIDASE-LIKE', 242607),
(331864, 'PTHR12174:SF104', NULL, NULL, NULL, NULL, 'EGF_CA DOMAIN-CONTAINING PROTEIN', 242607),
(331865, 'PTHR12174:SF103', NULL, NULL, NULL, NULL, 'INTRAMEMBRANE PROTEASE (IMPAS) FAMILY', 242607),
(331866, 'PTHR12174:SF97', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDE PEPTIDASE-LIKE 4', 242607),
(331867, 'PTHR12174:SF75', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDE PEPTIDASE-LIKE 2', 242607),
(331868, 'PTHR12174:SF78', NULL, NULL, NULL, NULL, 'PA DOMAIN-CONTAINING PROTEIN', 242607),
(331869, 'PTHR12174:SF34', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDE PEPTIDASE-LIKE 2A', 242607),
(331870, 'PTHR12174:SF102', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDE PEPTIDASE-LIKE 4', 242607),
(331871, 'PTHR12174:SF101', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDE PEPTIDASE FAMILY PROTEIN', 242607),
(331872, 'PTHR12174:SF77', NULL, NULL, NULL, NULL, '', 242607),
(331873, 'PTHR12174:SF100', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDE PEPTIDASE-LIKE 5', 242607),
(331874, 'PTHR12174:SF72', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDE PEPTIDASE-LIKE 3', 242607),
(331875, 'PTHR12174:SF74', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDE PEPTIDASE-LIKE PROTEIN', 242607),
(331876, 'PTHR12174:SF95', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDE PEPTIDASE 2-RELATED', 242607),
(331877, 'PTHR12174:SF73', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDE PEPTIDASE DOMAIN CONTAINING PROTEIN', 242607),
(331878, 'PTHR12174:SF86', NULL, NULL, NULL, NULL, 'PA DOMAIN, PRESENILIN/SIGNAL PEPTIDE PEPTIDASE-RELATED', 242607),
(331879, 'PTHR12174:SF89', NULL, NULL, NULL, NULL, 'PA DOMAIN-CONTAINING PROTEIN', 242607),
(331880, 'PTHR12174:SF23', NULL, NULL, NULL, NULL, 'MINOR HISTOCOMPATIBILITY ANTIGEN H13', 242607),
(331881, 'PTHR12174:SF88', NULL, NULL, NULL, NULL, 'BNAC02G47930D PROTEIN', 242607),
(331882, 'PTHR12174:SF22', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDE PEPTIDASE-LIKE 3', 242607),
(331883, 'PTHR12174:SF62', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDE PEPTIDASE-LIKE 5', 242607),
(331884, 'PTHR36044:SF2', NULL, NULL, NULL, NULL, 'EB_DH DOMAIN-CONTAINING PROTEIN', 242608),
(331885, 'PTHR36044', NULL, NULL, NULL, NULL, 'HEME BINDING PROTEIN', 242608),
(331886, 'PTHR36044:SF1', NULL, NULL, NULL, NULL, 'HEME BINDING PROTEIN', 242608),
(331887, 'PTHR11471:SF29', NULL, NULL, NULL, NULL, 'LYMPHOTOXIN-BETA', 242609),
(331888, 'PTHR11471:SF27', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR LIGAND SUPERFAMILY MEMBER 10', 242609),
(331889, 'PTHR11471:SF28', NULL, NULL, NULL, NULL, 'TNF_2 DOMAIN-CONTAINING PROTEIN', 242609),
(331890, 'PTHR11471:SF3', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR LIGAND SUPERFAMILY MEMBER 11', 242609),
(331891, 'PTHR11471:SF34', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR LIGAND SUPERFAMILY MEMBER 14', 242609),
(331892, 'PTHR11471:SF23', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR', 242609);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(331893, 'PTHR11471:SF13', NULL, NULL, NULL, NULL, 'TNF_2 DOMAIN-CONTAINING PROTEIN', 242609),
(331894, 'PTHR11471:SF24', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR LIGAND SUPERFAMILY MEMBER 15', 242609),
(331895, 'PTHR11471:SF54', NULL, NULL, NULL, NULL, 'TNF SUPERFAMILY MEMBER 11', 242609),
(331896, 'PTHR11471:SF33', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR LIGAND SUPERFAMILY MEMBER 6', 242609),
(331897, 'PTHR11471:SF5', NULL, NULL, NULL, NULL, 'CD40 LIGAND', 242609),
(331898, 'PTHR11471:SF31', NULL, NULL, NULL, NULL, 'LYMPHOTOXIN-ALPHA', 242609),
(331899, 'PTHR11471', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR FAMILY MEMBER', 242609),
(331900, 'PTHR32288:SF0', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN C-IV', 242610),
(331901, 'PTHR32288', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN C-IV', 242610),
(331902, 'PTHR33919:SF12', NULL, NULL, NULL, NULL, 'BNAA02G21910D PROTEIN', 242611),
(331903, 'PTHR33919:SF11', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242611),
(331904, 'PTHR33919:SF1', NULL, NULL, NULL, NULL, 'OS09G0127700 PROTEIN', 242611),
(331905, 'PTHR33919:SF16', NULL, NULL, NULL, NULL, '', 242611),
(331906, 'PTHR33919:SF15', NULL, NULL, NULL, NULL, '', 242611),
(331907, 'PTHR33919', NULL, NULL, NULL, NULL, 'OS09G0127700 PROTEIN', 242611),
(331908, 'PTHR33919:SF17', NULL, NULL, NULL, NULL, '', 242611),
(331909, 'PTHR33919:SF9', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS NEP1-LIKE PROTEIN', 242611),
(331910, 'PTHR33919:SF7', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 242611),
(331911, 'PTHR13958', NULL, NULL, NULL, NULL, 'CENTROSOME-ASSOCIATED PROTEIN 350', 242612),
(331912, 'PTHR13958:SF5', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 187', 242612),
(331913, 'PTHR13958:SF3', NULL, NULL, NULL, NULL, 'CAP-GLY DOMAIN-CONTAINING PROTEIN', 242612),
(331914, 'PTHR13958:SF4', NULL, NULL, NULL, NULL, 'CENTROSOME-ASSOCIATED PROTEIN 350', 242612),
(331915, 'PTHR36948:SF1', NULL, NULL, NULL, NULL, 'LRAT DOMAIN-CONTAINING PROTEIN', 242613),
(331916, 'PTHR36948', NULL, NULL, NULL, NULL, 'PROTEIN CBG04856', 242613),
(331917, 'PTHR19972:SF16', NULL, NULL, NULL, NULL, '', 242614),
(331918, 'PTHR19972:SF14', NULL, NULL, NULL, NULL, 'CALBINDIN', 242614),
(331919, 'PTHR19972:SF15', NULL, NULL, NULL, NULL, 'SECRETAGOGIN', 242614),
(331920, 'PTHR19972:SF10', NULL, NULL, NULL, NULL, 'CALBINDIN-32', 242614),
(331921, 'PTHR19972', NULL, NULL, NULL, NULL, 'CALBINDIN', 242614),
(331922, 'PTHR19972:SF4', NULL, NULL, NULL, NULL, 'CALRETININ', 242614),
(331923, 'PTHR31798:SF2', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 242615),
(331924, 'PTHR31798', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN-LIKE', 242615),
(331925, 'PTHR31798:SF10', NULL, NULL, NULL, NULL, 'OS02G0822000 PROTEIN', 242615),
(331926, 'PTHR31798:SF8', NULL, NULL, NULL, NULL, 'BNAA02G17660D PROTEIN', 242615),
(331927, 'PTHR31798:SF3', NULL, NULL, NULL, NULL, 'OS01G0103800 PROTEIN', 242615),
(331928, 'PTHR31798:SF14', NULL, NULL, NULL, NULL, '', 242615),
(331929, 'PTHR31798:SF5', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 242615),
(331930, 'PTHR31798:SF12', NULL, NULL, NULL, NULL, 'BNAA08G04450D PROTEIN', 242615),
(331931, 'PTHR31798:SF6', NULL, NULL, NULL, NULL, 'BNAC09G28410D PROTEIN', 242615),
(331932, 'PTHR45224:SF3', NULL, NULL, NULL, NULL, 'OS11G0506300 PROTEIN', 242616),
(331933, 'PTHR45224:SF10', NULL, NULL, NULL, NULL, 'OS09G0317700 PROTEIN', 242616),
(331934, 'PTHR45224:SF5', NULL, NULL, NULL, NULL, 'TRANSPOSON PROTEIN PONG SUB-CLASS', 242616),
(331935, 'PTHR45224:SF4', NULL, NULL, NULL, NULL, 'OS01G0873000 PROTEIN', 242616),
(331936, 'PTHR45224:SF12', NULL, NULL, NULL, NULL, 'OS01G0527900 PROTEIN', 242616),
(331937, 'PTHR45224:SF8', NULL, NULL, NULL, NULL, 'MYB-LIKE DOMAIN-CONTAINING PROTEIN', 242616),
(331938, 'PTHR45224', NULL, NULL, NULL, NULL, 'OS01G0527900 PROTEIN-RELATED', 242616),
(331939, 'PTHR45224:SF15', NULL, NULL, NULL, NULL, 'OS10G0563100 PROTEIN', 242616),
(331940, 'PTHR16076:SF8', NULL, NULL, NULL, NULL, 'CYTOSKELETON-ASSOCIATED PROTEIN 2', 242617);
INSERT INTO "PUBLIC"."MODEL" VALUES
(331941, 'PTHR16076', NULL, NULL, NULL, NULL, 'CYTOSKELETON ASSOCIATED PROTEIN 2-RELATED', 242617),
(331942, 'PTHR10903:SF7', NULL, NULL, NULL, NULL, 'GTPASE IMAP FAMILY MEMBER 2', 242618),
(331943, 'PTHR10903:SF160', NULL, NULL, NULL, NULL, 'AIG1-TYPE G DOMAIN-CONTAINING PROTEIN', 242618),
(331944, 'PTHR10903:SF162', NULL, NULL, NULL, NULL, 'AIG1-TYPE G DOMAIN-CONTAINING PROTEIN', 242618),
(331945, 'PTHR10903:SF74', NULL, NULL, NULL, NULL, 'GTPASE IMAP FAMILY MEMBER 1', 242618),
(331946, 'PTHR10903:SF73', NULL, NULL, NULL, NULL, 'GTPASE IMAP FAMILY MEMBER 8', 242618),
(331947, 'PTHR10903:SF164', NULL, NULL, NULL, NULL, 'IMMUNE-ASSOCIATED NUCLEOTIDE-BINDING PROTEIN 7', 242618),
(331948, 'PTHR10903:SF120', NULL, NULL, NULL, NULL, 'TRANSLOCASE OF CHLOROPLAST 159, CHLOROPLASTIC', 242618),
(331949, 'PTHR10903:SF163', NULL, NULL, NULL, NULL, 'GTPASE IMAP FAMILY MEMBER 7', 242618),
(331950, 'PTHR10903:SF141', NULL, NULL, NULL, NULL, 'PROTEIN AIG1-LIKE', 242618),
(331951, 'PTHR10903:SF144', NULL, NULL, NULL, NULL, 'GTPASE IMAP FAMILY MEMBER 6', 242618),
(331952, 'PTHR10903:SF122', NULL, NULL, NULL, NULL, 'IMMUNE-ASSOCIATED NUCLEOTIDE-BINDING PROTEIN 11-RELATED', 242618),
(331953, 'PTHR10903:SF166', NULL, NULL, NULL, NULL, 'AIG1-TYPE G DOMAIN-CONTAINING PROTEIN', 242618),
(331954, 'PTHR10903', NULL, NULL, NULL, NULL, 'GTPASE, IMAP FAMILY MEMBER-RELATED', 242618),
(331955, 'PTHR10903:SF69', NULL, NULL, NULL, NULL, 'GTPASE IMAP FAMILY MEMBER 5', 242618),
(331956, 'PTHR10903:SF168', NULL, NULL, NULL, NULL, 'AIG1-TYPE G DOMAIN-CONTAINING PROTEIN-RELATED', 242618),
(331957, 'PTHR10903:SF124', NULL, NULL, NULL, NULL, '50S RIBOSOME-BINDING GTPASE', 242618),
(331958, 'PTHR10903:SF102', NULL, NULL, NULL, NULL, 'OS04G0441600 PROTEIN', 242618),
(331959, 'PTHR10903:SF146', NULL, NULL, NULL, NULL, 'AIG1-LIKE PROTEIN_ 48352-49494-RELATED', 242618),
(331960, 'PTHR10903:SF167', NULL, NULL, NULL, NULL, 'SI:DKEYP-69E1.8', 242618),
(331961, 'PTHR10903:SF68', NULL, NULL, NULL, NULL, 'TRANSLOCASE OF CHLOROPLAST 90, CHLOROPLASTIC', 242618),
(331962, 'PTHR10903:SF148', NULL, NULL, NULL, NULL, 'SI:DKEY-185M8.2', 242618),
(331963, 'PTHR10903:SF125', NULL, NULL, NULL, NULL, 'TRANSLOCASE OF CHLOROPLAST', 242618),
(331964, 'PTHR10903:SF103', NULL, NULL, NULL, NULL, 'GTPASE IMAP FAMILY MEMBER GIMD1', 242618),
(331965, 'PTHR10903:SF127', NULL, NULL, NULL, NULL, 'TRANSLOCASE OF CHLOROPLAST 159, CHLOROPLASTIC-LIKE', 242618),
(331966, 'PTHR10903:SF149', NULL, NULL, NULL, NULL, 'TRANSLOCASE OF CHLOROPLAST 33, CHLOROPLASTIC', 242618),
(331967, 'PTHR10903:SF107', NULL, NULL, NULL, NULL, 'AIG1-TYPE G DOMAIN-CONTAINING PROTEIN-RELATED', 242618),
(331968, 'PTHR10903:SF64', NULL, NULL, NULL, NULL, 'AIG1 FAMILY PROTEIN, EXPRESSED', 242618),
(331969, 'PTHR10903:SF171', NULL, NULL, NULL, NULL, 'GTPASE IMAP FAMILY MEMBER 9', 242618),
(331970, 'PTHR10903:SF170', NULL, NULL, NULL, NULL, 'GTPASE IMAP FAMILY MEMBER 4', 242618),
(331971, 'PTHR10903:SF173', NULL, NULL, NULL, NULL, 'AIG1-TYPE G DOMAIN-CONTAINING PROTEIN', 242618),
(331972, 'PTHR10903:SF172', NULL, NULL, NULL, NULL, 'TRANSLOCASE OF CHLOROPLAST 34, CHLOROPLASTIC', 242618),
(331973, 'PTHR10903:SF150', NULL, NULL, NULL, NULL, 'AIG1-TYPE G DOMAIN-CONTAINING PROTEIN', 242618),
(331974, 'PTHR10903:SF62', NULL, NULL, NULL, NULL, 'AIG1-TYPE G DOMAIN-CONTAINING PROTEIN-RELATED', 242618),
(331975, 'PTHR10903:SF153', NULL, NULL, NULL, NULL, 'TRANSLOCASE OF CHLOROPLAST', 242618),
(331976, 'PTHR10903:SF175', NULL, NULL, NULL, NULL, 'TRANSLOCASE OF CHLOROPLAST 132, CHLOROPLASTIC', 242618),
(331977, 'PTHR10903:SF152', NULL, NULL, NULL, NULL, 'PROTEIN AIG1-LIKE', 242618),
(331978, 'PTHR10903:SF174', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 242618),
(331979, 'PTHR10903:SF177', NULL, NULL, NULL, NULL, 'SI:DKEY-120C6.5', 242618),
(331980, 'PTHR10903:SF176', NULL, NULL, NULL, NULL, 'SI:CH211-280C16.1-RELATED', 242618),
(331981, 'PTHR10903:SF135', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN A', 242618),
(331982, 'PTHR10903:SF178', NULL, NULL, NULL, NULL, 'TRANSLOCASE OF CHLOROPLAST 120, CHLOROPLASTIC-LIKE', 242618);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(331983, 'PTHR10903:SF112', NULL, NULL, NULL, NULL, 'AIG1-TYPE G DOMAIN-CONTAINING PROTEIN-RELATED', 242618),
(331984, 'PTHR10903:SF156', NULL, NULL, NULL, NULL, 'TRANSLOCASE OF CHLOROPLAST', 242618),
(331985, 'PTHR10903:SF137', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN', 242618),
(331986, 'PTHR10903:SF136', NULL, NULL, NULL, NULL, 'AIG1-TYPE G DOMAIN-CONTAINING PROTEIN', 242618),
(331987, 'PTHR10903:SF139', NULL, NULL, NULL, NULL, 'SI:DKEY-110G7.8', 242618),
(331988, 'PTHR10903:SF138', NULL, NULL, NULL, NULL, 'AIG1-TYPE G DOMAIN-CONTAINING PROTEIN', 242618),
(331989, 'PTHR10903:SF119', NULL, NULL, NULL, NULL, 'AIG1-TYPE G DOMAIN-CONTAINING PROTEIN', 242618),
(331990, 'PTHR35542:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 168', 242619),
(331991, 'PTHR35542', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 168', 242619),
(331992, 'PTHR21721', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 242620),
(331993, 'PTHR21721:SF25', NULL, NULL, NULL, NULL, 'LP18071P', 242620),
(331994, 'PTHR21721:SF26', NULL, NULL, NULL, NULL, 'DUF753 DOMAIN-CONTAINING PROTEIN-RELATED', 242620),
(331995, 'PTHR21721:SF27', NULL, NULL, NULL, NULL, 'GH09876P', 242620),
(331996, 'PTHR35918:SF1', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 242621),
(331997, 'PTHR35918', NULL, NULL, NULL, NULL, 'OS06G0674800 PROTEIN', 242621),
(331998, 'PTHR28181', NULL, NULL, NULL, NULL, 'UPF0655 PROTEIN YCR015C', 242622),
(331999, 'PTHR28181:SF2', NULL, NULL, NULL, NULL, 'PHOSPHORIC MONOESTER HYDROLASE', 242622),
(332000, 'PTHR28181:SF1', NULL, NULL, NULL, NULL, 'COLD TOLERANCE PROTEIN 1', 242622),
(332001, 'PTHR34384:SF6', NULL, NULL, NULL, NULL, 'STAPHYLOFERRIN B SYNTHASE', 242623),
(332002, 'PTHR34384:SF5', NULL, NULL, NULL, NULL, 'L-2,3-DIAMINOPROPANOATE--CITRATE LIGASE', 242623),
(332003, 'PTHR34384', NULL, NULL, NULL, NULL, 'L-2,3-DIAMINOPROPANOATE--CITRATE LIGASE', 242623),
(332004, 'PTHR45956:SF4', NULL, NULL, NULL, NULL, 'RUN AND FYVE DOMAIN-CONTAINING PROTEIN 1', 242624),
(332005, 'PTHR45956:SF5', NULL, NULL, NULL, NULL, 'RUN DOMAIN-CONTAINING PROTEIN', 242624),
(332006, 'PTHR45956', NULL, NULL, NULL, NULL, 'RUN AND FYVE DOMAIN-CONTAINING PROTEIN 2-LIKE PROTEIN', 242624),
(332007, 'PTHR45956:SF3', NULL, NULL, NULL, NULL, 'RUN AND FYVE DOMAIN-CONTAINING PROTEIN 2', 242624),
(332008, 'PTHR45956:SF6', NULL, NULL, NULL, NULL, 'RUN DOMAIN-CONTAINING PROTEIN', 242624),
(332009, 'PTHR45956:SF1', NULL, NULL, NULL, NULL, 'PROTEIN RUFY3', 242624),
(332010, 'PTHR21447:SF1', NULL, NULL, NULL, NULL, 'CUB_2 DOMAIN-CONTAINING PROTEIN', 242625),
(332011, 'PTHR21447', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 242625),
(332012, 'PTHR21447:SF9', NULL, NULL, NULL, NULL, 'CUB_2 DOMAIN-CONTAINING PROTEIN', 242625),
(332013, 'PTHR21447:SF11', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 242625),
(332014, 'PTHR21447:SF7', NULL, NULL, NULL, NULL, 'CUB_2 DOMAIN-CONTAINING PROTEIN', 242625),
(332015, 'PTHR21447:SF8', NULL, NULL, NULL, NULL, 'CUB_2 DOMAIN-CONTAINING PROTEIN', 242625),
(332016, 'PTHR21447:SF5', NULL, NULL, NULL, NULL, 'CUB_2 DOMAIN-CONTAINING PROTEIN', 242625),
(332017, 'PTHR21447:SF6', NULL, NULL, NULL, NULL, 'CUB_2 DOMAIN-CONTAINING PROTEIN', 242625),
(332018, 'PTHR21447:SF12', NULL, NULL, NULL, NULL, 'CUB_2 DOMAIN-CONTAINING PROTEIN', 242625),
(332019, 'PTHR21447:SF3', NULL, NULL, NULL, NULL, 'CUB_2 DOMAIN-CONTAINING PROTEIN', 242625),
(332020, 'PTHR21447:SF4', NULL, NULL, NULL, NULL, 'CUB_2 DOMAIN-CONTAINING PROTEIN', 242625),
(332021, 'PTHR31389', NULL, NULL, NULL, NULL, 'LD39211P', 242626),
(332022, 'PTHR31389:SF4', NULL, NULL, NULL, NULL, 'LD39211P', 242626),
(332023, 'PTHR31389:SF0', NULL, NULL, NULL, NULL, 'PROTEIN CBG06353', 242626),
(332024, 'PTHR31389:SF9', NULL, NULL, NULL, NULL, '', 242626),
(332025, 'PTHR31389:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG06623', 242626),
(332026, 'PTHR31389:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG11316', 242626),
(332027, 'PTHR31389:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG11318', 242626);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(332028, 'PTHR35767:SF11', NULL, NULL, NULL, NULL, '', 242627),
(332029, 'PTHR35767:SF9', NULL, NULL, NULL, NULL, 'HAPLESS 8', 242627),
(332030, 'PTHR35767:SF10', NULL, NULL, NULL, NULL, 'BNAA10G10470D PROTEIN', 242627),
(332031, 'PTHR35767', NULL, NULL, NULL, NULL, 'HAPLESS PROTEIN', 242627),
(332032, 'PTHR35767:SF5', NULL, NULL, NULL, NULL, 'BNAA02G08800D PROTEIN', 242627),
(332033, 'PTHR35767:SF6', NULL, NULL, NULL, NULL, 'BNAC03G13770D PROTEIN', 242627),
(332034, 'PTHR35767:SF1', NULL, NULL, NULL, NULL, 'HAPLESS PROTEIN', 242627),
(332035, 'PTHR35767:SF4', NULL, NULL, NULL, NULL, 'BNAA10G10400D PROTEIN', 242627),
(332036, 'PTHR30532:SF1', NULL, NULL, NULL, NULL, 'FE(3+) DICITRATE-BINDING PERIPLASMIC PROTEIN', 242628),
(332037, 'PTHR30532', NULL, NULL, NULL, NULL, 'IRON III  DICITRATE-BINDING PERIPLASMIC PROTEIN', 242628),
(332038, 'PTHR30532:SF10', NULL, NULL, NULL, NULL, 'IRON-UPTAKE SYSTEM-BINDING PROTEIN', 242628),
(332039, 'PTHR30532:SF21', NULL, NULL, NULL, NULL, 'SIDEROPHORE-BINDING LIPOPROTEIN YFIY-RELATED', 242628),
(332040, 'PTHR30532:SF2', NULL, NULL, NULL, NULL, 'FERRIENTEROBACTIN-BINDING PERIPLASMIC PROTEIN', 242628),
(332041, 'PTHR30532:SF23', NULL, NULL, NULL, NULL, 'HEMIN-BINDING PERIPLASMIC PROTEIN HMUT', 242628),
(332042, 'PTHR30532:SF25', NULL, NULL, NULL, NULL, 'IRON(III) DICITRATE-BINDING PERIPLASMIC PROTEIN', 242628),
(332043, 'PTHR30532:SF24', NULL, NULL, NULL, NULL, 'IRON-UPTAKE SYSTEM BINDING PROTEIN', 242628),
(332044, 'PTHR30532:SF27', NULL, NULL, NULL, NULL, 'IRON(3+)-HYDROXAMATE-BINDING PROTEIN FHUD', 242628),
(332045, 'PTHR30532:SF26', NULL, NULL, NULL, NULL, 'IRON(3+)-HYDROXAMATE-BINDING PROTEIN FHUD', 242628),
(332046, 'PTHR30532:SF4', NULL, NULL, NULL, NULL, 'PETROBACTIN-BINDING PROTEIN YCLQ', 242628),
(332047, 'PTHR41286', NULL, NULL, NULL, NULL, 'HNH NUCLEASE YAJD-RELATED', 242629),
(332048, 'PTHR41286:SF1', NULL, NULL, NULL, NULL, 'HNH NUCLEASE YAJD-RELATED', 242629),
(332049, 'PTHR42781:SF4', NULL, NULL, NULL, NULL, 'SPERMIDINE/PUTRESCINE IMPORT ATP-BINDING PROTEIN POTA', 242630),
(332050, 'PTHR42781:SF1', NULL, NULL, NULL, NULL, 'THIAMINE IMPORT ATP-BINDING PROTEIN THIQ', 242630),
(332051, 'PTHR42781', NULL, NULL, NULL, NULL, 'SPERMIDINE/PUTRESCINE IMPORT ATP-BINDING PROTEIN POTA', 242630),
(332052, 'PTHR42781:SF7', NULL, NULL, NULL, NULL, 'MOLYBDENUM ABC TRANSPORTER, ATP-BINDING PROTEIN', 242630),
(332053, 'PTHR42781:SF8', NULL, NULL, NULL, NULL, 'BICARBONATE TRANSPORT ATP-BINDING PROTEIN CMPC', 242630),
(332054, 'PTHR42781:SF5', NULL, NULL, NULL, NULL, 'PUTRESCINE TRANSPORT ATP-BINDING PROTEIN POTG', 242630),
(332055, 'PTHR42781:SF6', NULL, NULL, NULL, NULL, 'SPERMIDINE/PUTRESCINE IMPORT ATP-BINDING PROTEIN POTA', 242630),
(332056, 'PTHR42781:SF9', NULL, NULL, NULL, NULL, 'AMINO ACID ABC TRANSPORTER, ATP-BINDING PROTEIN-RELATED', 242630),
(332057, 'PTHR28251:SF1', NULL, NULL, NULL, NULL, 'V-TYPE ATPASE ASSEMBLY FACTOR PKR1', 242631),
(332058, 'PTHR28251', NULL, NULL, NULL, NULL, 'V-TYPE ATPASE ASSEMBLY FACTOR PKR1', 242631),
(332059, 'PTHR34971:SF5', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REACTION CENTER PROTEIN Z', 242632),
(332060, 'PTHR34971:SF4', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REACTION CENTER PROTEIN Z', 242632),
(332061, 'PTHR34971:SF3', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REACTION CENTER PROTEIN Z', 242632),
(332062, 'PTHR34971:SF2', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REACTION CENTER PROTEIN Z', 242632),
(332063, 'PTHR34971', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REACTION CENTER PROTEIN Z', 242632),
(332064, 'PTHR31917:SF107', NULL, NULL, NULL, NULL, 'AGENET DOMAIN-CONTAINING PROTEIN', 242633),
(332065, 'PTHR31917:SF149', NULL, NULL, NULL, NULL, 'BNAANNG18030D PROTEIN', 242633),
(332066, 'PTHR31917:SF106', NULL, NULL, NULL, NULL, 'ENT DOMAIN-CONTAINING PROTEIN', 242633),
(332067, 'PTHR31917:SF147', NULL, NULL, NULL, NULL, 'ENT DOMAIN-CONTAINING PROTEIN', 242633),
(332068, 'PTHR31917:SF125', NULL, NULL, NULL, NULL, 'AGENET DOMAIN-CONTAINING PROTEIN-RELATED', 242633),
(332069, 'PTHR31917:SF80', NULL, NULL, NULL, NULL, 'PROTEIN AGENET DOMAIN (AGD)-CONTAINING P1', 242633);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(332070, 'PTHR31917:SF103', NULL, NULL, NULL, NULL, 'BNAANNG03210D PROTEIN', 242633),
(332071, 'PTHR31917:SF148', NULL, NULL, NULL, NULL, 'DUF724 DOMAIN-CONTAINING PROTEIN 3-LIKE', 242633),
(332072, 'PTHR31917:SF145', NULL, NULL, NULL, NULL, 'AGENET DOMAIN-CONTAINING PROTEIN', 242633),
(332073, 'PTHR31917:SF101', NULL, NULL, NULL, NULL, 'OS07G0607300 PROTEIN', 242633),
(332074, 'PTHR31917:SF146', NULL, NULL, NULL, NULL, 'AGENET DOMAIN PROTEIN', 242633),
(332075, 'PTHR31917:SF143', NULL, NULL, NULL, NULL, 'BAH DOMAIN-CONTAINING PROTEIN', 242633),
(332076, 'PTHR31917:SF144', NULL, NULL, NULL, NULL, 'BNAA01G33820D PROTEIN', 242633),
(332077, 'PTHR31917:SF68', NULL, NULL, NULL, NULL, 'PLANT TUDOR-LIKE RNA-BINDING PROTEIN-RELATED', 242633),
(332078, 'PTHR31917:SF46', NULL, NULL, NULL, NULL, 'ENT DOMAIN-CONTAINING PROTEIN', 242633),
(332079, 'PTHR31917:SF141', NULL, NULL, NULL, NULL, '', 242633),
(332080, 'PTHR31917:SF142', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE-RELATED', 242633),
(332081, 'PTHR31917:SF140', NULL, NULL, NULL, NULL, 'ENT DOMAIN-CONTAINING PROTEIN', 242633),
(332082, 'PTHR31917:SF65', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE-RELATED', 242633),
(332083, 'PTHR31917:SF5', NULL, NULL, NULL, NULL, 'PLANT TUDOR-LIKE RNA-BINDING PROTEIN-RELATED', 242633),
(332084, 'PTHR31917', NULL, NULL, NULL, NULL, 'AGENET DOMAIN-CONTAINING PROTEIN-RELATED', 242633),
(332085, 'PTHR31917:SF3', NULL, NULL, NULL, NULL, 'BAH DOMAIN-CONTAINING PROTEIN', 242633),
(332086, 'PTHR31917:SF9', NULL, NULL, NULL, NULL, 'G2484-1 PROTEIN', 242633),
(332087, 'PTHR31917:SF74', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242633),
(332088, 'PTHR31917:SF138', NULL, NULL, NULL, NULL, 'AGENET DOMAIN-CONTAINING PROTEIN', 242633),
(332089, 'PTHR31917:SF50', NULL, NULL, NULL, NULL, 'DUF724 DOMAIN-CONTAINING PROTEIN 1-RELATED', 242633),
(332090, 'PTHR31917:SF139', NULL, NULL, NULL, NULL, 'ENT DOMAIN-CONTAINING PROTEIN', 242633),
(332091, 'PTHR31917:SF136', NULL, NULL, NULL, NULL, 'DUF724 DOMAIN-CONTAINING PROTEIN 7', 242633),
(332092, 'PTHR31917:SF114', NULL, NULL, NULL, NULL, 'AGENET-LIKE DOMAIN, AGENET DOMAIN, PLANT TYPE-RELATED', 242633),
(332093, 'PTHR31917:SF134', NULL, NULL, NULL, NULL, 'BNAC04G52320D PROTEIN', 242633),
(332094, 'PTHR31917:SF112', NULL, NULL, NULL, NULL, 'AGENET DOMAIN-CONTAINING PROTEIN', 242633),
(332095, 'PTHR31917:SF90', NULL, NULL, NULL, NULL, 'BNAC04G52330D PROTEIN', 242633),
(332096, 'PTHR31917:SF110', NULL, NULL, NULL, NULL, 'BNAANNG03200D PROTEIN', 242633),
(332097, 'PTHR31917:SF154', NULL, NULL, NULL, NULL, 'BAH DOMAIN-CONTAINING PROTEIN', 242633),
(332098, 'PTHR31917:SF59', NULL, NULL, NULL, NULL, 'ENT DOMAIN-CONTAINING PROTEIN', 242633),
(332099, 'PTHR31917:SF152', NULL, NULL, NULL, NULL, '', 242633),
(332100, 'PTHR31917:SF58', NULL, NULL, NULL, NULL, 'AGENET AND BROMO-ADJACENT HOMOLOGY (BAH) DOMAIN-CONTAINING PROTEIN', 242633),
(332101, 'PTHR31917:SF153', NULL, NULL, NULL, NULL, 'DUF724 DOMAIN-CONTAINING PROTEIN 3-RELATED', 242633),
(332102, 'PTHR31917:SF77', NULL, NULL, NULL, NULL, 'DUF724 DOMAIN-CONTAINING PROTEIN 2-RELATED', 242633),
(332103, 'PTHR31917:SF150', NULL, NULL, NULL, NULL, 'OS01G0556800 PROTEIN', 242633),
(332104, 'PTHR31917:SF151', NULL, NULL, NULL, NULL, 'AGENET DOMAIN-CONTAINING PROTEIN', 242633),
(332105, 'PTHR24278:SF28', NULL, NULL, NULL, NULL, 'COAGULATION FACTOR X', 242634),
(332106, 'PTHR24278:SF39', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE GAMMA-CARBOXYGLUTAMIC ACID PROTEIN 3', 242634),
(332107, 'PTHR24278:SF29', NULL, NULL, NULL, NULL, 'HYALURONAN-BINDING PROTEIN 2', 242634),
(332108, 'PTHR24278:SF19', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 242634),
(332109, 'PTHR24278', NULL, NULL, NULL, NULL, 'COAGULATION FACTOR', 242634),
(332110, 'PTHR24278:SF35', NULL, NULL, NULL, NULL, 'COAGULATION FACTOR VII', 242634),
(332111, 'PTHR24278:SF36', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 242634),
(332112, 'PTHR24278:SF25', NULL, NULL, NULL, NULL, 'VENOM PROTHROMBIN ACTIVATOR PORPHARIN-D-LIKE', 242634),
(332113, 'PTHR24278:SF37', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE GAMMA-CARBOXYGLUTAMIC ACID PROTEIN 1', 242634);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(332114, 'PTHR24278:SF26', NULL, NULL, NULL, NULL, 'COAGULATION FACTOR VII', 242634),
(332115, 'PTHR24278:SF38', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE GAMMA-CARBOXYGLUTAMIC ACID PROTEIN 4', 242634),
(332116, 'PTHR24278:SF27', NULL, NULL, NULL, NULL, 'COAGULATION FACTOR XII', 242634),
(332117, 'PTHR24278:SF20', NULL, NULL, NULL, NULL, 'VITAMIN K-DEPENDENT PROTEIN Z', 242634),
(332118, 'PTHR24278:SF0', NULL, NULL, NULL, NULL, 'VITAMIN K-DEPENDENT PROTEIN C', 242634),
(332119, 'PTHR24278:SF31', NULL, NULL, NULL, NULL, 'COAGULATION FACTOR IX', 242634),
(332120, 'PTHR24278:SF32', NULL, NULL, NULL, NULL, 'SERINE PROTEASE 56', 242634),
(332121, 'PTHR24278:SF33', NULL, NULL, NULL, NULL, 'PROTEIN Z, VITAMIN K-DEPENDENT PLASMA GLYCOPROTEIN A', 242634),
(332122, 'PTHR24278:SF34', NULL, NULL, NULL, NULL, 'COAGULATION FACTOR VII,-LIKE', 242634),
(332123, 'PTHR24278:SF30', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE GAMMA-CARBOXYGLUTAMIC ACID PROTEIN 2', 242634),
(332124, 'PTHR21353:SF9', NULL, NULL, NULL, NULL, '', 242635),
(332125, 'PTHR21353:SF6', NULL, NULL, NULL, NULL, '', 242635),
(332126, 'PTHR21353:SF8', NULL, NULL, NULL, NULL, 'CARDIOTROPHIN-2', 242635),
(332127, 'PTHR21353:SF7', NULL, NULL, NULL, NULL, 'CARDIOTROPHIN-LIKE CYTOKINE FACTOR 1', 242635),
(332128, 'PTHR21353:SF2', NULL, NULL, NULL, NULL, 'CARDIOTROPHIN-1', 242635),
(332129, 'PTHR21353', NULL, NULL, NULL, NULL, '', 242635),
(332130, 'PTHR13305', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS PROTEIN NOP10', 242636),
(332131, 'PTHR13305:SF5', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 10', 242636),
(332132, 'PTHR13305:SF3', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 10', 242636),
(332133, 'PTHR13305:SF4', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 10', 242636),
(332134, 'PTHR13305:SF2', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 10', 242636),
(332135, 'PTHR13305:SF0', NULL, NULL, NULL, NULL, 'H/ACA RIBONUCLEOPROTEIN COMPLEX SUBUNIT 3', 242636),
(332136, 'PTHR43740:SF2', NULL, NULL, NULL, NULL, 'LEUCINE--TRNA LIGASE, MITOCHONDRIAL-RELATED', 242637),
(332137, 'PTHR43740', NULL, NULL, NULL, NULL, 'LEUCYL-TRNA SYNTHETASE', 242637),
(332138, 'PTHR31767:SF0', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL GAMMA-LIKE SUBUNIT', 242638),
(332139, 'PTHR31767', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL GAMMA-LIKE SUBUNIT', 242638),
(332140, 'PTHR24173:SF67', NULL, NULL, NULL, NULL, '', 242639),
(332141, 'PTHR24173:SF23', NULL, NULL, NULL, NULL, 'UVEAL AUTOANTIGEN WITH COILED-COIL DOMAINS AND ANKYRIN REPEATS', 242639),
(332142, 'PTHR24173:SF44', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX PROTEIN 13', 242639),
(332143, 'PTHR24173:SF66', NULL, NULL, NULL, NULL, 'PROTEIN FEM-1 HOMOLOG B', 242639),
(332144, 'PTHR24173:SF29', NULL, NULL, NULL, NULL, 'PHOTORECEPTOR ANKYRIN REPEAT PROTEIN', 242639),
(332145, 'PTHR24173:SF1', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 33B', 242639),
(332146, 'PTHR24173:SF27', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX PROTEIN 1', 242639),
(332147, 'PTHR24173:SF61', NULL, NULL, NULL, NULL, 'ANKYRIN 2', 242639),
(332148, 'PTHR24173:SF83', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 242639),
(332149, 'PTHR24173:SF82', NULL, NULL, NULL, NULL, 'FI19351P1', 242639),
(332150, 'PTHR24173:SF80', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX-CONTAINING 15A-RELATED', 242639),
(332151, 'PTHR24173:SF86', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX PROTEIN 3', 242639),
(332152, 'PTHR24173:SF85', NULL, NULL, NULL, NULL, 'PROTEIN FEM-1 HOMOLOG CG6966', 242639),
(332153, 'PTHR24173:SF84', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN 33AB', 242639),
(332154, 'PTHR24173:SF40', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 242639),
(332155, 'PTHR24173:SF14', NULL, NULL, NULL, NULL, 'PROTEIN FEM-1 HOMOLOG C', 242639),
(332156, 'PTHR24173:SF78', NULL, NULL, NULL, NULL, 'PROTEIN FEM-1 HOMOLOG B', 242639),
(332157, 'PTHR24173:SF12', NULL, NULL, NULL, NULL, 'PROTEIN FEM-1 HOMOLOG A', 242639),
(332158, 'PTHR24173:SF33', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX PROTEIN 2', 242639);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(332159, 'PTHR24173:SF16', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 24', 242639),
(332160, 'PTHR24173:SF59', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 242639),
(332161, 'PTHR24173', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT CONTAINING', 242639),
(332162, 'PTHR24173:SF72', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 16', 242639),
(332163, 'PTHR24173:SF71', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 242639),
(332164, 'PTHR24173:SF76', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 242639),
(332165, 'PTHR24173:SF74', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN 16', 242639),
(332166, 'PTHR45627:SF26', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE TYPE 1', 242640),
(332167, 'PTHR45627:SF15', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE', 242640),
(332168, 'PTHR45627:SF27', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE TYPE 2', 242640),
(332169, 'PTHR45627:SF16', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE', 242640),
(332170, 'PTHR45627:SF28', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE', 242640),
(332171, 'PTHR45627:SF10', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE TYPE 4', 242640),
(332172, 'PTHR45627', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE TYPE 1', 242640),
(332173, 'PTHR45627:SF11', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE TYPE 6', 242640),
(332174, 'PTHR45627:SF22', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE TYPE 1', 242640),
(332175, 'PTHR45627:SF12', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE TYPE 3', 242640),
(332176, 'PTHR45627:SF23', NULL, NULL, NULL, NULL, 'AT30656P-RELATED', 242640),
(332177, 'PTHR45627:SF24', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE 1B', 242640),
(332178, 'PTHR45627:SF9', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE TYPE 7', 242640),
(332179, 'PTHR45627:SF8', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE TYPE 9', 242640),
(332180, 'PTHR45627:SF7', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE TYPE 5', 242640),
(332181, 'PTHR45627:SF6', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE TYPE 2', 242640),
(332182, 'PTHR45627:SF5', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE 8 (BRAIN)', 242640),
(332183, 'PTHR45627:SF29', NULL, NULL, NULL, NULL, 'ADENYLYL CYCLASE', 242640),
(332184, 'PTHR45627:SF2', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE TYPE 2', 242640),
(332185, 'PTHR45627:SF1', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE TYPE 8', 242640),
(332186, 'PTHR35969', NULL, NULL, NULL, NULL, 'PROTEIN FAM243A-RELATED', 242641),
(332187, 'PTHR35969:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAM243A-RELATED', 242641),
(332188, 'PTHR34820', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YEBZ', 242642),
(332189, 'PTHR34820:SF4', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YEBZ', 242642),
(332190, 'PTHR10131:SF143', NULL, NULL, NULL, NULL, 'TRAF-TYPE DOMAIN-CONTAINING PROTEIN', 242643),
(332191, 'PTHR10131:SF83', NULL, NULL, NULL, NULL, 'TNF RECEPTOR-ASSOCIATED FACTOR 5', 242643),
(332192, 'PTHR10131:SF144', NULL, NULL, NULL, NULL, 'TNF RECEPTOR-ASSOCIATED FACTOR 4', 242643),
(332193, 'PTHR10131:SF141', NULL, NULL, NULL, NULL, 'TNF RECEPTOR-ASSOCIATED FACTOR FAMILY PROTEIN DDB_G0273433/DDB_G0273509', 242643),
(332194, 'PTHR10131:SF69', NULL, NULL, NULL, NULL, 'TNF RECEPTOR-ASSOCIATED FACTOR FAMILY PROTEIN DDB_G0272098-RELATED', 242643),
(332195, 'PTHR10131:SF146', NULL, NULL, NULL, NULL, 'TNF RECEPTOR-ASSOCIATED FACTOR', 242643),
(332196, 'PTHR10131:SF149', NULL, NULL, NULL, NULL, 'TNF RECEPTOR-ASSOCIATED FACTOR FAMILY PROTEIN DDB_G0277243', 242643),
(332197, 'PTHR10131:SF148', NULL, NULL, NULL, NULL, '', 242643),
(332198, 'PTHR10131:SF65', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN DG17-RELATED', 242643),
(332199, 'PTHR10131:SF21', NULL, NULL, NULL, NULL, 'TNF RECEPTOR-ASSOCIATED FACTOR 2', 242643),
(332200, 'PTHR10131:SF154', NULL, NULL, NULL, NULL, 'OS02G0605500 PROTEIN', 242643),
(332201, 'PTHR10131:SF92', NULL, NULL, NULL, NULL, '', 242643),
(332202, 'PTHR10131:SF153', NULL, NULL, NULL, NULL, '', 242643),
(332203, 'PTHR10131:SF131', NULL, NULL, NULL, NULL, 'TNF RECEPTOR-ASSOCIATED FACTOR 6', 242643);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(332204, 'PTHR10131:SF156', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', 242643),
(332205, 'PTHR10131:SF133', NULL, NULL, NULL, NULL, 'TRAF-TYPE DOMAIN-CONTAINING PROTEIN', 242643),
(332206, 'PTHR10131:SF155', NULL, NULL, NULL, NULL, 'TRAF-TYPE DOMAIN-CONTAINING PROTEIN', 242643),
(332207, 'PTHR10131:SF94', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 242643),
(332208, 'PTHR10131:SF150', NULL, NULL, NULL, NULL, 'TNF RECEPTOR-ASSOCIATED FACTOR FAMILY PROTEIN DDB_G0272340-RELATED', 242643),
(332209, 'PTHR10131:SF152', NULL, NULL, NULL, NULL, 'TNF RECEPTOR-ASSOCIATED FACTOR 6', 242643),
(332210, 'PTHR10131:SF151', NULL, NULL, NULL, NULL, 'TNF RECEPTOR ASSOCIATED FACTOR (TRAF) HOMOLOG', 242643),
(332211, 'PTHR10131:SF136', NULL, NULL, NULL, NULL, 'TRAF-TYPE DOMAIN-CONTAINING PROTEIN', 242643),
(332212, 'PTHR10131:SF96', NULL, NULL, NULL, NULL, 'TNF RECEPTOR-ASSOCIATED FACTOR 1', 242643),
(332213, 'PTHR10131:SF135', NULL, NULL, NULL, NULL, 'TNF RECEPTOR-ASSOCIATED FACTOR', 242643),
(332214, 'PTHR10131', NULL, NULL, NULL, NULL, 'TNF RECEPTOR ASSOCIATED FACTOR', 242643),
(332215, 'PTHR10131:SF138', NULL, NULL, NULL, NULL, 'RE66324P', 242643),
(332216, 'PTHR10131:SF76', NULL, NULL, NULL, NULL, 'TNF RECEPTOR-ASSOCIATED FACTOR 3', 242643),
(332217, 'PTHR45714:SF75', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 242644),
(332218, 'PTHR45714:SF76', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HOX1', 242644),
(332219, 'PTHR45714:SF54', NULL, NULL, NULL, NULL, 'LEUCINE ZIPPER, HOMEOBOX-ASSOCIATED, HOMEODOMAIN-LIKE PROTEIN-RELATED', 242644),
(332220, 'PTHR45714:SF11', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-4', 242644),
(332221, 'PTHR45714:SF77', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 242644),
(332222, 'PTHR45714', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HAT14', 242644),
(332223, 'PTHR45714:SF78', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HOX18', 242644),
(332224, 'PTHR45714:SF34', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HAT9', 242644),
(332225, 'PTHR45714:SF56', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 242644),
(332226, 'PTHR45714:SF57', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 242644),
(332227, 'PTHR45714:SF79', NULL, NULL, NULL, NULL, 'HOMEOBOX ASSOCIATED LEUCINE ZIPPER PROTEIN', 242644),
(332228, 'PTHR45714:SF13', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-X', 242644),
(332229, 'PTHR45714:SF58', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 242644),
(332230, 'PTHR45714:SF36', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HAT4-LIKE', 242644),
(332231, 'PTHR45714:SF16', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HAT4', 242644),
(332232, 'PTHR45714:SF38', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HAT2', 242644),
(332233, 'PTHR45714:SF39', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HAT14', 242644),
(332234, 'PTHR45714:SF1', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HOX26-RELATED', 242644),
(332235, 'PTHR45714:SF18', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HOX28', 242644),
(332236, 'PTHR45714:SF8', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-17', 242644),
(332237, 'PTHR45714:SF7', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HOX2', 242644),
(332238, 'PTHR45714:SF80', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN', 242644),
(332239, 'PTHR45714:SF81', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HAT22-LIKE', 242644),
(332240, 'PTHR45714:SF82', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HAT4', 242644),
(332241, 'PTHR45714:SF61', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 242644),
(332242, 'PTHR45714:SF83', NULL, NULL, NULL, NULL, 'HOMEOBOX ASSOCIATED LEUCINE ZIPPER PROTEIN', 242644),
(332243, 'PTHR45714:SF84', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 242644),
(332244, 'PTHR45714:SF62', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 242644);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(332245, 'PTHR45714:SF40', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 242644),
(332246, 'PTHR45714:SF63', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HAT3-LIKE', 242644),
(332247, 'PTHR45714:SF85', NULL, NULL, NULL, NULL, 'HOMEOBOX ASSOCIATED LEUCINE ZIPPER PROTEIN', 242644),
(332248, 'PTHR45714:SF42', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HAT22-LIKE', 242644),
(332249, 'PTHR45714:SF20', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HAT1', 242644),
(332250, 'PTHR45714:SF64', NULL, NULL, NULL, NULL, 'LEUCINE ZIPPER, HOMEOBOX-ASSOCIATED, HOMEODOMAIN-LIKE PROTEIN-RELATED', 242644),
(332251, 'PTHR45714:SF21', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HOX7', 242644),
(332252, 'PTHR45714:SF65', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 242644),
(332253, 'PTHR45714:SF44', NULL, NULL, NULL, NULL, 'LEUCINE ZIPPER, HOMEOBOX-ASSOCIATED, HOMEODOMAIN-LIKE PROTEIN-RELATED', 242644),
(332254, 'PTHR45714:SF22', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HOX27', 242644),
(332255, 'PTHR45714:SF45', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 242644),
(332256, 'PTHR45714:SF24', NULL, NULL, NULL, NULL, 'HOMEOBOX ASSOCIATED LEUCINE ZIPPER PROTEIN', 242644),
(332257, 'PTHR45714:SF46', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 242644),
(332258, 'PTHR45714:SF68', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HAT3', 242644),
(332259, 'PTHR45714:SF25', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HOX15', 242644),
(332260, 'PTHR45714:SF48', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN FAMILY-RELATED', 242644),
(332261, 'PTHR45714:SF49', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HOX19', 242644),
(332262, 'PTHR45714:SF72', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HAT9-LIKE', 242644),
(332263, 'PTHR45714:SF73', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 242644),
(332264, 'PTHR45714:SF74', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HAT22', 242644),
(332265, 'PTHR33985:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242645),
(332266, 'PTHR33985', NULL, NULL, NULL, NULL, 'OS02G0491300 PROTEIN-RELATED', 242645),
(332267, 'PTHR33985:SF31', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 20-RELATED', 242645),
(332268, 'PTHR33985:SF20', NULL, NULL, NULL, NULL, '', 242645),
(332269, 'PTHR33985:SF33', NULL, NULL, NULL, NULL, 'FAS1 DOMAIN-CONTAINING PROTEIN-RELATED', 242645),
(332270, 'PTHR33985:SF32', NULL, NULL, NULL, NULL, 'BNAANNG37970D PROTEIN', 242645),
(332271, 'PTHR33985:SF21', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 20-RELATED', 242645),
(332272, 'PTHR33985:SF13', NULL, NULL, NULL, NULL, 'FAS1 DOMAIN-CONTAINING PROTEIN', 242645),
(332273, 'PTHR33985:SF35', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 21', 242645),
(332274, 'PTHR33985:SF23', NULL, NULL, NULL, NULL, 'BNAA02G27190D PROTEIN', 242645),
(332275, 'PTHR33985:SF34', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN', 242645),
(332276, 'PTHR33985:SF15', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 19', 242645),
(332277, 'PTHR33985:SF26', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 20-RELATED', 242645),
(332278, 'PTHR33985:SF37', NULL, NULL, NULL, NULL, 'BNAA03G60480D PROTEIN', 242645),
(332279, 'PTHR33985:SF36', NULL, NULL, NULL, NULL, 'FAS1 DOMAIN-CONTAINING PROTEIN', 242645),
(332280, 'PTHR33985:SF17', NULL, NULL, NULL, NULL, 'FAS1 DOMAIN-CONTAINING PROTEIN', 242645),
(332281, 'PTHR33985:SF28', NULL, NULL, NULL, NULL, 'BNAC07G42260D PROTEIN', 242645),
(332282, 'PTHR33985:SF5', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN FAMILY PROTEIN', 242645),
(332283, 'PTHR33985:SF16', NULL, NULL, NULL, NULL, 'FAS1 DOMAIN-CONTAINING PROTEIN', 242645),
(332284, 'PTHR33985:SF19', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 21', 242645),
(332285, 'PTHR33985:SF29', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 20-RELATED', 242645);
INSERT INTO "PUBLIC"."MODEL" VALUES
(332286, 'PTHR47063', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H2 SUBUNIT C', 242646),
(332287, 'PTHR47063:SF1', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H2 SUBUNIT C', 242646),
(332288, 'PTHR37220:SF2', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 242647),
(332289, 'PTHR37220:SF1', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 23', 242647),
(332290, 'PTHR37220:SF4', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 242647),
(332291, 'PTHR37220:SF3', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 242647),
(332292, 'PTHR37220', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 23', 242647),
(332293, 'PTHR39352', NULL, NULL, NULL, NULL, 'PROTEIN CBG14251', 242648),
(332294, 'PTHR39352:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG14251', 242648),
(332295, 'PTHR39352:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG01542', 242648),
(332296, 'PTHR18820', NULL, NULL, NULL, NULL, 'LEG1', 242649),
(332297, 'PTHR18820:SF4', NULL, NULL, NULL, NULL, 'CHROMOSOME B2 C6ORF58 HOMOLOG', 242649),
(332298, 'PTHR18820:SF2', NULL, NULL, NULL, NULL, 'PROTEIN LEG1 HOMOLOG', 242649),
(332299, 'PTHR18820:SF1', NULL, NULL, NULL, NULL, 'PROTEIN LEG1 HOMOLOG', 242649),
(332300, 'PTHR21240:SF19', NULL, NULL, NULL, NULL, 'CATALYTIC/ HYDROLASE', 242650),
(332301, 'PTHR21240:SF27', NULL, NULL, NULL, NULL, '2-AMINO-3-CARBOXYMUCONATE-6-SEMIALDEHYDE DECARBOXYLASE', 242650),
(332302, 'PTHR21240:SF29', NULL, NULL, NULL, NULL, 'AMIDOHYDRO-REL DOMAIN-CONTAINING PROTEIN', 242650),
(332303, 'PTHR21240:SF28', NULL, NULL, NULL, NULL, 'ISO-OROTATE DECARBOXYLASE (EUROFUNG)', 242650),
(332304, 'PTHR21240', NULL, NULL, NULL, NULL, '2-AMINO-3-CARBOXYLMUCONATE-6-SEMIALDEHYDE DECARBOXYLASE', 242650),
(332305, 'PTHR21240:SF30', NULL, NULL, NULL, NULL, 'AMIDOHYDRO-REL DOMAIN-CONTAINING PROTEIN-RELATED', 242650),
(332306, 'PTHR21240:SF31', NULL, NULL, NULL, NULL, 'AMIDOHYDROLASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_7G05840)', 242650),
(332307, 'PTHR42041', NULL, NULL, NULL, NULL, '', 242651),
(332308, 'PTHR42041:SF1', NULL, NULL, NULL, NULL, '', 242651),
(332309, 'PTHR43719:SF27', NULL, NULL, NULL, NULL, 'AEROBIC RESPIRATION CONTROL SENSOR PROTEIN ARCB', 242652),
(332310, 'PTHR43719:SF28', NULL, NULL, NULL, NULL, 'PEROXIDE STRESS-ACTIVATED HISTIDINE KINASE MAK1-RELATED', 242652),
(332311, 'PTHR43719:SF3', NULL, NULL, NULL, NULL, 'HYBRID SIGNAL TRANSDUCTION HISTIDINE KINASE F', 242652),
(332312, 'PTHR43719:SF4', NULL, NULL, NULL, NULL, 'PHYTOCHROME C', 242652),
(332313, 'PTHR43719:SF70', NULL, NULL, NULL, NULL, 'SIGNAL TRANSDUCTION HISTIDINE-PROTEIN KINASE BARA', 242652),
(332314, 'PTHR43719:SF71', NULL, NULL, NULL, NULL, 'SENSOR PROTEIN TORS', 242652),
(332315, 'PTHR43719:SF72', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE/RESPONSE REGULATOR, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G06140)-RELATED', 242652),
(332316, 'PTHR43719:SF50', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE CKI1-LIKE', 242652),
(332317, 'PTHR43719:SF51', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE 4', 242652),
(332318, 'PTHR43719:SF73', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE 3-RELATED', 242652),
(332319, 'PTHR43719:SF30', NULL, NULL, NULL, NULL, 'TWO-COMPONENT SYSTEM RESPONSE REGULATOR', 242652),
(332320, 'PTHR43719:SF52', NULL, NULL, NULL, NULL, '', 242652),
(332321, 'PTHR43719:SF31', NULL, NULL, NULL, NULL, '', 242652),
(332322, 'PTHR43719:SF53', NULL, NULL, NULL, NULL, 'HYBRID SIGNAL TRANSDUCTION HISTIDINE KINASE M-RELATED', 242652),
(332323, 'PTHR43719:SF32', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 242652),
(332324, 'PTHR43719:SF10', NULL, NULL, NULL, NULL, 'HYBRID SIGNAL TRANSDUCTION HISTIDINE KINASE A', 242652),
(332325, 'PTHR43719', NULL, NULL, NULL, NULL, 'TWO-COMPONENT HISTIDINE KINASE', 242652),
(332326, 'PTHR43719:SF11', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE/RESPONSE REGULATOR, PUTATIVE-RELATED', 242652),
(332327, 'PTHR43719:SF34', NULL, NULL, NULL, NULL, 'TWO-COMPONENT SYSTEM PROTEIN B', 242652),
(332328, 'PTHR43719:SF1', NULL, NULL, NULL, NULL, 'HYBRID SIGNAL TRANSDUCTION HISTIDINE KINASE I', 242652),
(332329, 'PTHR43719:SF12', NULL, NULL, NULL, NULL, 'PHYTOCHROME B-RELATED', 242652);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(332330, 'PTHR43719:SF35', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE 2', 242652),
(332331, 'PTHR43719:SF57', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE', 242652),
(332332, 'PTHR43719:SF58', NULL, NULL, NULL, NULL, 'PHYTOCHROME', 242652),
(332333, 'PTHR43719:SF17', NULL, NULL, NULL, NULL, 'PHYTOCHROME E', 242652),
(332334, 'PTHR43719:SF18', NULL, NULL, NULL, NULL, 'HYBRID SIGNAL TRANSDUCTION HISTIDINE KINASE B', 242652),
(332335, 'PTHR43719:SF60', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE G2', 242652),
(332336, 'PTHR43719:SF42', NULL, NULL, NULL, NULL, 'AUTOINDUCER 2 SENSOR KINASE/PHOSPHATASE LUXQ', 242652),
(332337, 'PTHR43719:SF65', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE 6-RELATED', 242652),
(332338, 'PTHR43719:SF67', NULL, NULL, NULL, NULL, '', 242652),
(332339, 'PTHR43719:SF24', NULL, NULL, NULL, NULL, 'HYBRID SIGNAL TRANSDUCTION HISTIDINE KINASE L', 242652),
(332340, 'PTHR43719:SF46', NULL, NULL, NULL, NULL, 'PHYTOCHROME A', 242652),
(332341, 'PTHR43719:SF68', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE 3', 242652),
(332342, 'PTHR43719:SF47', NULL, NULL, NULL, NULL, 'PHYTOCHROME', 242652),
(332343, 'PTHR43719:SF25', NULL, NULL, NULL, NULL, 'HYBRID SIGNAL TRANSDUCTION HISTIDINE KINASE K', 242652),
(332344, 'PTHR43719:SF69', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE G7', 242652),
(332345, 'PTHR43719:SF26', NULL, NULL, NULL, NULL, 'HYBRID SIGNAL TRANSDUCTION PROTEIN DOKA', 242652),
(332346, 'PTHR33265:SF35', NULL, NULL, NULL, NULL, 'BNAA08G11990D PROTEIN', 242653),
(332347, 'PTHR33265:SF36', NULL, NULL, NULL, NULL, 'AVR9/CF-9 RAPIDLY ELICITED PROTEIN 146', 242653),
(332348, 'PTHR33265:SF37', NULL, NULL, NULL, NULL, 'BNAA05G15010D PROTEIN', 242653),
(332349, 'PTHR33265:SF53', NULL, NULL, NULL, NULL, '', 242653),
(332350, 'PTHR33265:SF31', NULL, NULL, NULL, NULL, '', 242653),
(332351, 'PTHR33265:SF54', NULL, NULL, NULL, NULL, 'OS06G0554600 PROTEIN', 242653),
(332352, 'PTHR33265:SF10', NULL, NULL, NULL, NULL, 'OS01G0133200 PROTEIN', 242653),
(332353, 'PTHR33265:SF33', NULL, NULL, NULL, NULL, '', 242653),
(332354, 'PTHR33265:SF55', NULL, NULL, NULL, NULL, 'COTTON FIBER PROTEIN', 242653),
(332355, 'PTHR33265:SF34', NULL, NULL, NULL, NULL, 'BNAC03G73780D PROTEIN', 242653),
(332356, 'PTHR33265', NULL, NULL, NULL, NULL, 'AVR9/CF-9 RAPIDLY ELICITED PROTEIN-RELATED', 242653),
(332357, 'PTHR33265:SF51', NULL, NULL, NULL, NULL, 'AVR9/CF-9 RAPIDLY ELICITED PROTEIN 146', 242653),
(332358, 'PTHR33265:SF30', NULL, NULL, NULL, NULL, 'LONG CELL-LINKED LOCUS PROTEIN', 242653),
(332359, 'PTHR33265:SF52', NULL, NULL, NULL, NULL, 'DUF761 DOMAIN PROTEIN', 242653),
(332360, 'PTHR33265:SF28', NULL, NULL, NULL, NULL, 'BNAC03G66880D PROTEIN', 242653),
(332361, 'PTHR33265:SF24', NULL, NULL, NULL, NULL, '', 242653),
(332362, 'PTHR33265:SF46', NULL, NULL, NULL, NULL, 'BNAC05G01360D PROTEIN', 242653),
(332363, 'PTHR33265:SF1', NULL, NULL, NULL, NULL, 'OS01G0198500 PROTEIN', 242653),
(332364, 'PTHR33265:SF26', NULL, NULL, NULL, NULL, 'OS02G0229800 PROTEIN', 242653),
(332365, 'PTHR33265:SF42', NULL, NULL, NULL, NULL, 'BNAC05G37030D PROTEIN', 242653),
(332366, 'PTHR33265:SF22', NULL, NULL, NULL, NULL, 'OS02G0517700 PROTEIN', 242653),
(332367, 'PTHR33265:SF45', NULL, NULL, NULL, NULL, 'AVR9/CF-9 RAPIDLY ELICITED PROTEIN', 242653),
(332368, 'PTHR33265:SF23', NULL, NULL, NULL, NULL, 'OS02G0523100 PROTEIN', 242653),
(332369, 'PTHR33265:SF8', NULL, NULL, NULL, NULL, 'AVR9/CF-9 RAPIDLY ELICITED PROTEIN', 242653),
(332370, 'PTHR33265:SF9', NULL, NULL, NULL, NULL, 'OS05G0520600 PROTEIN', 242653),
(332371, 'PTHR33265:SF40', NULL, NULL, NULL, NULL, '', 242653),
(332372, 'PTHR33265:SF6', NULL, NULL, NULL, NULL, 'OS01G0930500 PROTEIN', 242653),
(332373, 'PTHR33265:SF7', NULL, NULL, NULL, NULL, 'OS05G0200700 PROTEIN', 242653),
(332374, 'PTHR33265:SF5', NULL, NULL, NULL, NULL, 'COTTON FIBER PROTEIN', 242653),
(332375, 'PTHR37390', NULL, NULL, NULL, NULL, 'OS02G0592500 PROTEIN', 242654),
(332376, 'PTHR37390:SF2', NULL, NULL, NULL, NULL, 'FOLATE_REC DOMAIN-CONTAINING PROTEIN', 242654),
(332377, 'PTHR37390:SF1', NULL, NULL, NULL, NULL, 'FOLATE RECEPTOR FAMILY PROTEIN', 242654);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(332378, 'PTHR37390:SF4', NULL, NULL, NULL, NULL, 'FOLATE_REC DOMAIN-CONTAINING PROTEIN', 242654),
(332379, 'PTHR37390:SF3', NULL, NULL, NULL, NULL, 'FOLATE_REC DOMAIN-CONTAINING PROTEIN', 242654),
(332380, 'PTHR13110:SF15', NULL, NULL, NULL, NULL, 'U6 SNRNA-ASSOCIATED SM-LIKE PROTEIN LSM3', 242655),
(332381, 'PTHR13110:SF14', NULL, NULL, NULL, NULL, '', 242655),
(332382, 'PTHR13110:SF7', NULL, NULL, NULL, NULL, '', 242655),
(332383, 'PTHR13110:SF9', NULL, NULL, NULL, NULL, 'SM-LIKE PROTEIN LSM3A', 242655),
(332384, 'PTHR13110:SF0', NULL, NULL, NULL, NULL, 'U6 SNRNA-ASSOCIATED SM-LIKE PROTEIN LSM3', 242655),
(332385, 'PTHR13110:SF1', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN SM D-LIKE PROTEIN', 242655),
(332386, 'PTHR13110', NULL, NULL, NULL, NULL, 'U6 SNRNA-ASSOCIATED SM-LIKE PROTEIN LSM3', 242655),
(332387, 'PTHR13110:SF12', NULL, NULL, NULL, NULL, 'SM-LIKE PROTEIN LSM3B', 242655),
(332388, 'PTHR37856:SF1', NULL, NULL, NULL, NULL, 'MAST CELL-EXPRESSED MEMBRANE PROTEIN 1', 242656),
(332389, 'PTHR37856', NULL, NULL, NULL, NULL, 'MAST CELL-EXPRESSED MEMBRANE PROTEIN 1', 242656),
(332390, 'PTHR12216', NULL, NULL, NULL, NULL, 'UROCANATE HYDRATASE', 242657),
(332391, 'PTHR12216:SF3', NULL, NULL, NULL, NULL, 'UROCANATE HYDRATASE', 242657),
(332392, 'PTHR12216:SF4', NULL, NULL, NULL, NULL, 'UROCANATE HYDRATASE', 242657),
(332393, 'PTHR36361', NULL, NULL, NULL, NULL, 'PROTEIN APEM9', 242658),
(332394, 'PTHR36361:SF1', NULL, NULL, NULL, NULL, 'PROTEIN APEM9', 242658),
(332395, 'PTHR33307:SF10', NULL, NULL, NULL, NULL, 'ALPHA-L-RHAMNOSIDASE', 242659),
(332396, 'PTHR33307:SF9', NULL, NULL, NULL, NULL, 'ALPHA-L-RHAMNOSIDASE', 242659),
(332397, 'PTHR33307', NULL, NULL, NULL, NULL, 'ALPHA-RHAMNOSIDASE (EUROFUNG)', 242659),
(332398, 'PTHR33307:SF8', NULL, NULL, NULL, NULL, 'ALPHA-L-RHAMNOSIDASE', 242659),
(332399, 'PTHR33307:SF6', NULL, NULL, NULL, NULL, 'ALPHA-L-RHAMNOSIDASE', 242659),
(332400, 'PTHR33307:SF5', NULL, NULL, NULL, NULL, '', 242659),
(332401, 'PTHR11640:SF148', NULL, NULL, NULL, NULL, 'ACTIVATED LEUKOCYTE CELL ADHESION MOLECULE', 242660),
(332402, 'PTHR11640:SF136', NULL, NULL, NULL, NULL, 'NEPHRIN', 242660),
(332403, 'PTHR11640:SF157', NULL, NULL, NULL, NULL, 'V-SET AND IMMUNOGLOBULIN DOMAIN-CONTAINING PROTEIN 10', 242660),
(332404, 'PTHR11640:SF134', NULL, NULL, NULL, NULL, 'ECHINOID, ISOFORM A-RELATED', 242660),
(332405, 'PTHR11640:SF156', NULL, NULL, NULL, NULL, 'HEPARAN SULFATE PROTEOGLYCAN 2', 242660),
(332406, 'PTHR11640:SF155', NULL, NULL, NULL, NULL, 'AGAP011094-PA', 242660),
(332407, 'PTHR11640:SF154', NULL, NULL, NULL, NULL, 'IRREGULAR CHIASM C-ROUGHEST PROTEIN-LIKE PROTEIN', 242660),
(332408, 'PTHR11640:SF153', NULL, NULL, NULL, NULL, 'IRREGULAR CHIASM C-ROUGHEST PROTEIN-RELATED', 242660),
(332409, 'PTHR11640:SF150', NULL, NULL, NULL, NULL, 'V-SET AND IMMUNOGLOBULIN DOMAIN-CONTAINING PROTEIN 10-LIKE 2', 242660),
(332410, 'PTHR11640:SF51', NULL, NULL, NULL, NULL, 'KIN OF IRRE-LIKE PROTEIN 2', 242660),
(332411, 'PTHR11640:SF31', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN-LIKE CELL ADHESION MOLECULE FAMILY', 242660),
(332412, 'PTHR11640', NULL, NULL, NULL, NULL, 'NEPHRIN', 242660),
(332413, 'PTHR11640:SF14', NULL, NULL, NULL, NULL, 'KIN OF IRRE-LIKE PROTEIN 1', 242660),
(332414, 'PTHR11640:SF49', NULL, NULL, NULL, NULL, 'KIN OF IRRE-LIKE PROTEIN 3', 242660),
(332415, 'PTHR38453:SF3', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 242661),
(332416, 'PTHR38453', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 242661),
(332417, 'PTHR38453:SF1', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 242661),
(332418, 'PTHR43405', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE DIGH', 242662),
(332419, 'PTHR43405:SF1', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE DIGH', 242662),
(332420, 'PTHR37592:SF1', NULL, NULL, NULL, NULL, '', 242663),
(332421, 'PTHR37592', NULL, NULL, NULL, NULL, '', 242663),
(332422, 'PTHR31661', NULL, NULL, NULL, NULL, 'SIMILAR TO CDNA SEQUENCE BC052040', 242664),
(332423, 'PTHR31661:SF1', NULL, NULL, NULL, NULL, 'CDAN1-INTERACTING NUCLEASE 1', 242664);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(332424, 'PTHR13054', NULL, NULL, NULL, NULL, 'DIGEORGE SYNDROME CRITICAL REGION 6 DGCR6 FAMILY MEMBER', 242665),
(332425, 'PTHR13054:SF6', NULL, NULL, NULL, NULL, 'PROTEIN DGCR6L', 242665),
(332426, 'PTHR13054:SF7', NULL, NULL, NULL, NULL, 'PROTEIN DGCR6', 242665),
(332427, 'PTHR13054:SF2', NULL, NULL, NULL, NULL, 'PROTEIN DGCR6', 242665),
(332428, 'PTHR33727:SF14', NULL, NULL, NULL, NULL, '', 242666),
(332429, 'PTHR33727:SF13', NULL, NULL, NULL, NULL, '', 242666),
(332430, 'PTHR33727', NULL, NULL, NULL, NULL, 'OS07G0446900 PROTEIN', 242666),
(332431, 'PTHR33727:SF18', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF3317)-RELATED', 242666),
(332432, 'PTHR33727:SF17', NULL, NULL, NULL, NULL, 'BNAC05G25270D PROTEIN', 242666),
(332433, 'PTHR33727:SF8', NULL, NULL, NULL, NULL, 'OS03G0780200 PROTEIN', 242666),
(332434, 'PTHR33727:SF5', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF3317)-RELATED', 242666),
(332435, 'PTHR33727:SF11', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 242666),
(332436, 'PTHR33727:SF10', NULL, NULL, NULL, NULL, '', 242666),
(332437, 'PTHR13076', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 242667),
(332438, 'PTHR13076:SF5', NULL, NULL, NULL, NULL, 'COILED-COIL AND C2 DOMAIN-CONTAINING PROTEIN 1B', 242667),
(332439, 'PTHR13076:SF8', NULL, NULL, NULL, NULL, 'COILED-COIL AND C2 DOMAIN-CONTAINING PROTEIN 1A', 242667),
(332440, 'PTHR13076:SF9', NULL, NULL, NULL, NULL, 'COILED-COIL AND C2 DOMAIN-CONTAINING PROTEIN 1-LIKE', 242667),
(332441, 'PTHR12957:SF22', NULL, NULL, NULL, NULL, 'INTEGRATOR COMPLEX SUBUNIT 6-LIKE', 242668),
(332442, 'PTHR12957', NULL, NULL, NULL, NULL, 'DEAD/H BOX POLYPEPTIDE 26/DICE1-RELATED', 242668),
(332443, 'PTHR12957:SF23', NULL, NULL, NULL, NULL, 'INTEGRATOR COMPLEX SUBUNIT 6', 242668),
(332444, 'PTHR12957:SF36', NULL, NULL, NULL, NULL, 'SAGE1-LIKE PROTEIN-RELATED', 242668),
(332445, 'PTHR12957:SF2', NULL, NULL, NULL, NULL, 'INTEGRATOR COMPLEX SUBUNIT 6', 242668),
(332446, 'PTHR34926', NULL, NULL, NULL, NULL, '', 242669),
(332447, 'PTHR34926:SF3', NULL, NULL, NULL, NULL, '', 242669),
(332448, 'PTHR34926:SF1', NULL, NULL, NULL, NULL, '', 242669),
(332449, 'PTHR11986:SF18', NULL, NULL, NULL, NULL, 'ORNITHINE AMINOTRANSFERASE, MITOCHONDRIAL', 242670),
(332450, 'PTHR11986:SF113', NULL, NULL, NULL, NULL, 'SUCCINYLORNITHINE TRANSAMINASE', 242670),
(332451, 'PTHR11986:SF112', NULL, NULL, NULL, NULL, 'PUTRESCINE AMINOTRANSFERASE', 242670),
(332452, 'PTHR11986:SF122', NULL, NULL, NULL, NULL, 'ACETYLORNITHINE/SUCCINYLDIAMINOPIMELATE AMINOTRANSFERASE', 242670),
(332453, 'PTHR11986:SF121', NULL, NULL, NULL, NULL, 'BLR3010 PROTEIN', 242670),
(332454, 'PTHR11986:SF120', NULL, NULL, NULL, NULL, 'ACETYLORNITHINE TRANSAMINASE', 242670),
(332455, 'PTHR11986:SF79', NULL, NULL, NULL, NULL, 'ACETYLORNITHINE AMINOTRANSFERASE, MITOCHONDRIAL', 242670),
(332456, 'PTHR11986:SF58', NULL, NULL, NULL, NULL, 'ORNITHINE AMINOTRANSFERASE', 242670),
(332457, 'PTHR11986:SF119', NULL, NULL, NULL, NULL, 'BNAA02G36300D PROTEIN', 242670),
(332458, 'PTHR11986:SF118', NULL, NULL, NULL, NULL, 'ORNITHINE AMINOTRANSFERASE, MITOCHONDRIAL', 242670),
(332459, 'PTHR11986', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE CLASS III', 242670),
(332460, 'PTHR11986:SF117', NULL, NULL, NULL, NULL, 'ORNITHINE--OXO-ACID AMINOTRANSFERASE', 242670),
(332461, 'PTHR11986:SF116', NULL, NULL, NULL, NULL, 'ACETYLORNITHINE TRANSAMINASE', 242670),
(332462, 'PTHR10398:SF1', NULL, NULL, NULL, NULL, 'CANOE, ISOFORM E', 242671),
(332463, 'PTHR10398:SF3', NULL, NULL, NULL, NULL, 'KINESIN FAMILY MEMBER 13B', 242671),
(332464, 'PTHR10398:SF2', NULL, NULL, NULL, NULL, 'AFADIN', 242671),
(332465, 'PTHR10398:SF4', NULL, NULL, NULL, NULL, 'SI:CH73-375G18.1', 242671),
(332466, 'PTHR10398', NULL, NULL, NULL, NULL, 'AFADIN', 242671),
(332467, 'PTHR40094', NULL, NULL, NULL, NULL, 'ALPHA-2-MACROGLOBULIN HOMOLOG', 242672),
(332468, 'PTHR40094:SF1', NULL, NULL, NULL, NULL, 'UBIQUITIN DOMAIN-CONTAINING PROTEIN', 242672),
(332469, 'PTHR47768', NULL, NULL, NULL, NULL, 'GLOBIN RELATED-RELATED', 242673),
(332470, 'PTHR47768:SF2', NULL, NULL, NULL, NULL, 'GLOBIN DOMAIN-CONTAINING PROTEIN', 242673);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(332471, 'PTHR47768:SF1', NULL, NULL, NULL, NULL, 'GLOBIN DOMAIN-CONTAINING PROTEIN', 242673),
(332472, 'PTHR47768:SF3', NULL, NULL, NULL, NULL, 'GLOBIN DOMAIN-CONTAINING PROTEIN', 242673),
(332473, 'PTHR14942:SF15', NULL, NULL, NULL, NULL, 'UBIQUITIN-RELATED DOMAIN-CONTAINING PROTEIN-RELATED', 242674),
(332474, 'PTHR14942:SF19', NULL, NULL, NULL, NULL, 'UBIQUITIN_4 DOMAIN-CONTAINING PROTEIN', 242674),
(332475, 'PTHR14942:SF9', NULL, NULL, NULL, NULL, 'OS02G0188500 PROTEIN', 242674),
(332476, 'PTHR14942:SF18', NULL, NULL, NULL, NULL, 'U11/U12 SMALL NUCLEAR RIBONUCLEOPROTEIN 25 KDA PROTEIN-LIKE', 242674),
(332477, 'PTHR14942:SF17', NULL, NULL, NULL, NULL, 'UBIQUITIN_4 DOMAIN-CONTAINING PROTEIN', 242674),
(332478, 'PTHR14942:SF16', NULL, NULL, NULL, NULL, 'UBIQUITIN_4 DOMAIN-CONTAINING PROTEIN', 242674),
(332479, 'PTHR14942', NULL, NULL, NULL, NULL, 'U11/U12 SMALL NUCLEAR RIBONUCLEOPROTEIN 25 KDA PROTEIN', 242674),
(332480, 'PTHR14942:SF2', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE SUPERFAMILY PROTEIN', 242674),
(332481, 'PTHR14942:SF10', NULL, NULL, NULL, NULL, 'UBIQUITIN_4 DOMAIN-CONTAINING PROTEIN', 242674),
(332482, 'PTHR14942:SF0', NULL, NULL, NULL, NULL, 'U11/U12 SMALL NUCLEAR RIBONUCLEOPROTEIN 25 KDA PROTEIN', 242674),
(332483, 'PTHR48013:SF26', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY MITOGEN-ACTIVATED PROTEIN KINASE KINASE 5', 242675),
(332484, 'PTHR48013:SF25', NULL, NULL, NULL, NULL, 'MAP KINASE KINASE PBS2', 242675),
(332485, 'PTHR48013:SF28', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY MITOGEN-ACTIVATED PROTEIN KINASE KINASE SEK-1', 242675),
(332486, 'PTHR48013:SF27', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE 3', 242675),
(332487, 'PTHR48013:SF29', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY MITOGEN-ACTIVATED PROTEIN KINASE KINASE 4', 242675),
(332488, 'PTHR48013:SF22', NULL, NULL, NULL, NULL, '', 242675),
(332489, 'PTHR48013:SF21', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY MITOGEN-ACTIVATED PROTEIN KINASE KINASE 3', 242675),
(332490, 'PTHR48013:SF24', NULL, NULL, NULL, NULL, 'SI:CH211-171H4.3', 242675),
(332491, 'PTHR48013:SF15', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY MITOGEN-ACTIVATED PROTEIN KINASE KINASE 4', 242675),
(332492, 'PTHR48013:SF14', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY MITOGEN-ACTIVATED PROTEIN KINASE KINASE JKK-1', 242675),
(332493, 'PTHR48013:SF17', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY MITOGEN-ACTIVATED PROTEIN KINASE KINASE 7', 242675),
(332494, 'PTHR48013:SF16', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242675),
(332495, 'PTHR48013:SF18', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 242675),
(332496, 'PTHR48013', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY MITOGEN-ACTIVATED PROTEIN KINASE KINASE 5-RELATED', 242675),
(332497, 'PTHR48013:SF2', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-BINDING KINASE FAMILY, MEMBER 3', 242675),
(332498, 'PTHR48013:SF3', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242675),
(332499, 'PTHR48013:SF5', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY MITOGEN-ACTIVATED PROTEIN KINASE KINASE 1', 242675),
(332500, 'PTHR48013:SF6', NULL, NULL, NULL, NULL, 'MAP KINASE KINASE MKK1/SSP32-RELATED', 242675),
(332501, 'PTHR48013:SF7', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SBK2', 242675),
(332502, 'PTHR48013:SF30', NULL, NULL, NULL, NULL, 'STE20-RELATED KINASE ADAPTER PROTEIN STRD-1', 242675),
(332503, 'PTHR48013:SF8', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY MITOGEN-ACTIVATED PROTEIN KINASE KINASE 2', 242675),
(332504, 'PTHR48013:SF11', NULL, NULL, NULL, NULL, 'LICORNE', 242675),
(332505, 'PTHR48013:SF9', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY MITOGEN-ACTIVATED PROTEIN KINASE KINASE DSOR1', 242675),
(332506, 'PTHR48013:SF13', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 242675),
(332507, 'PTHR48013:SF12', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY MITOGEN-ACTIVATED PROTEIN KINASE KINASE 6', 242675),
(332508, 'PTHR46370:SF1', NULL, NULL, NULL, NULL, 'GPALPP MOTIFS-CONTAINING PROTEIN 1', 242676),
(332509, 'PTHR46370', NULL, NULL, NULL, NULL, 'GPALPP MOTIFS-CONTAINING PROTEIN 1', 242676); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(332510, 'PTHR43107:SF4', NULL, NULL, NULL, NULL, 'BILE ACYL-COA SYNTHETASE', 242677),
(332511, 'PTHR43107', NULL, NULL, NULL, NULL, 'LONG-CHAIN FATTY ACID TRANSPORT PROTEIN', 242677),
(332512, 'PTHR43107:SF7', NULL, NULL, NULL, NULL, 'LONG-CHAIN FATTY ACID TRANSPORT PROTEIN 1', 242677),
(332513, 'PTHR43107:SF6', NULL, NULL, NULL, NULL, 'ACYL-COA SYNTHETASE FAMILY PROTEIN (CEFD1), PUTATIVE (AFU_ORTHOLOGUE AFUA_6G03630)-RELATED', 242677),
(332514, 'PTHR43107:SF21', NULL, NULL, NULL, NULL, 'FATTY ACID TRANSPORT PROTEIN 1, ISOFORM F-RELATED', 242677),
(332515, 'PTHR43107:SF10', NULL, NULL, NULL, NULL, 'LONG-CHAIN FATTY ACID TRANSPORT PROTEIN 6', 242677),
(332516, 'PTHR43107:SF20', NULL, NULL, NULL, NULL, 'FATTY ACID TRANSPORTER/ACYL-COA SYNTHETASE (FAT1), PUTATIVE (AFU_ORTHOLOGUE AFUA_2G11360)-RELATED', 242677),
(332517, 'PTHR43107:SF23', NULL, NULL, NULL, NULL, 'ZGC:101540-RELATED', 242677),
(332518, 'PTHR43107:SF12', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 27 MEMBER 3', 242677),
(332519, 'PTHR43107:SF11', NULL, NULL, NULL, NULL, 'LONG-CHAIN FATTY ACID TRANSPORT PROTEIN 4', 242677),
(332520, 'PTHR43107:SF22', NULL, NULL, NULL, NULL, 'AMP-BINDING DOMAIN-CONTAINING PROTEIN', 242677),
(332521, 'PTHR43107:SF13', NULL, NULL, NULL, NULL, 'VERY LONG-CHAIN ACYL-COA SYNTHETASE', 242677),
(332522, 'PTHR43107:SF24', NULL, NULL, NULL, NULL, 'FATTY ACID COA SYNTHETASE FAMILY', 242677),
(332523, 'PTHR43107:SF16', NULL, NULL, NULL, NULL, 'AMP-BINDING DOMAIN-CONTAINING PROTEIN', 242677),
(332524, 'PTHR43107:SF15', NULL, NULL, NULL, NULL, 'FATTY ACID TRANSPORT PROTEIN 3, ISOFORM A', 242677),
(332525, 'PTHR31219:SF2', NULL, NULL, NULL, NULL, 'CHROMOSOME 12 OPEN READING FRAME 29', 242678),
(332526, 'PTHR31219', NULL, NULL, NULL, NULL, 'CHROMOSOME 28 C12ORF29 HOMOLOG', 242678),
(332527, 'PTHR47271', NULL, NULL, NULL, NULL, 'ARGININE DEIMINASE', 242679),
(332528, 'PTHR47271:SF2', NULL, NULL, NULL, NULL, 'ARGININE DEIMINASE', 242679),
(332529, 'PTHR47271:SF3', NULL, NULL, NULL, NULL, 'ARGININE DEIMINASE', 242679),
(332530, 'PTHR10509:SF28', NULL, NULL, NULL, NULL, 'CAFFEOYL-COA O-METHYLTRANSFERASE', 242680),
(332531, 'PTHR10509', NULL, NULL, NULL, NULL, 'O-METHYLTRANSFERASE-RELATED', 242680),
(332532, 'PTHR10509:SF57', NULL, NULL, NULL, NULL, '', 242680),
(332533, 'PTHR10509:SF58', NULL, NULL, NULL, NULL, '', 242680),
(332534, 'PTHR10509:SF14', NULL, NULL, NULL, NULL, 'CAFFEOYL-COA O-METHYLTRANSFERASE 1-RELATED', 242680),
(332535, 'PTHR10509:SF11', NULL, NULL, NULL, NULL, 'CAFFEOYL-COA O-METHYLTRANSFERASE 3-RELATED', 242680),
(332536, 'PTHR10509:SF77', NULL, NULL, NULL, NULL, 'CAFFEOYL-COA O-METHYLTRANSFERASE', 242680),
(332537, 'PTHR10509:SF33', NULL, NULL, NULL, NULL, 'CATECHOL-O-METHYLTRANSFERASE FAMILY', 242680),
(332538, 'PTHR10509:SF34', NULL, NULL, NULL, NULL, 'TAPETUM-SPECIFIC METHYLTRANSFERASE 1', 242680),
(332539, 'PTHR10509:SF78', NULL, NULL, NULL, NULL, 'CAFFEOYL-COA O-METHYLTRANSFERASE', 242680),
(332540, 'PTHR10509:SF97', NULL, NULL, NULL, NULL, 'CAFFEOYL-COA O-METHYLTRANSFERASE 5', 242680),
(332541, 'PTHR10509:SF98', NULL, NULL, NULL, NULL, '', 242680),
(332542, 'PTHR10509:SF76', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 242680),
(332543, 'PTHR10509:SF95', NULL, NULL, NULL, NULL, 'FLAVONOID 3'',5''-METHYLTRANSFERASE-LIKE', 242680),
(332544, 'PTHR10509:SF74', NULL, NULL, NULL, NULL, 'CAFFEOYL-COA O-METHYLTRANSFERASE 2', 242680),
(332545, 'PTHR10509:SF96', NULL, NULL, NULL, NULL, 'CAFFEOYL-COA O-METHYLTRANSFERASE', 242680),
(332546, 'PTHR10509:SF30', NULL, NULL, NULL, NULL, 'TRICIN SYNTHASE 2', 242680),
(332547, 'PTHR10509:SF93', NULL, NULL, NULL, NULL, 'CATECHOL O-METHYLTRANSFERASE DOMAIN-CONTAINING PROTEIN 1', 242680),
(332548, 'PTHR10509:SF71', NULL, NULL, NULL, NULL, 'BNAANNG06470D PROTEIN', 242680),
(332549, 'PTHR10509:SF94', NULL, NULL, NULL, NULL, 'CAFFEOYL-COA O-METHYLTRANSFERASE 3', 242680),
(332550, 'PTHR10509:SF70', NULL, NULL, NULL, NULL, 'BNAA02G13470D PROTEIN', 242680),
(332551, 'PTHR10509:SF92', NULL, NULL, NULL, NULL, 'OS09G0481400 PROTEIN', 242680);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(332552, 'PTHR10509:SF90', NULL, NULL, NULL, NULL, 'CATECHOL-O-METHYLTRANSFERASE FAMILY', 242680),
(332553, 'PTHR10509:SF69', NULL, NULL, NULL, NULL, 'BNAC08G09610D PROTEIN', 242680),
(332554, 'PTHR10509:SF66', NULL, NULL, NULL, NULL, 'TRICIN SYNTHASE 1', 242680),
(332555, 'PTHR10509:SF64', NULL, NULL, NULL, NULL, 'CAFFEOYL-COA O-METHYLTRANSFERASE', 242680),
(332556, 'PTHR10509:SF87', NULL, NULL, NULL, NULL, 'CAFFEOYL-COA 3-O-METHYLTRANSFERASE', 242680),
(332557, 'PTHR10509:SF84', NULL, NULL, NULL, NULL, 'CAFFEOYL-COA O-METHYLTRANSFERASE 1', 242680),
(332558, 'PTHR10509:SF85', NULL, NULL, NULL, NULL, 'O-METHYLTRANSFERASE RV1220C-RELATED', 242680),
(332559, 'PTHR10509:SF63', NULL, NULL, NULL, NULL, 'CAFFEOYL-COA 3-O-METHYLTRANSFERASE', 242680),
(332560, 'PTHR10509:SF82', NULL, NULL, NULL, NULL, 'CAFFEOYL-COA O-METHYLTRANSFERASE', 242680),
(332561, 'PTHR10509:SF61', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASES SUPERFAMILY PROTEIN, PUTATIVE ISOFORM 1-RELATED', 242680),
(332562, 'PTHR10509:SF83', NULL, NULL, NULL, NULL, 'BNAA02G13460D PROTEIN', 242680),
(332563, 'PTHR10509:SF81', NULL, NULL, NULL, NULL, 'CAFFEOYL-COA O-METHYLTRANSFERASE 1', 242680),
(332564, 'PTHR46219:SF15', NULL, NULL, NULL, NULL, 'PROTEIN CBG27015', 242681),
(332565, 'PTHR46219:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG10467', 242681),
(332566, 'PTHR46219:SF14', NULL, NULL, NULL, NULL, 'PHARYNGEAL GLAND TOXIN-RELATED', 242681),
(332567, 'PTHR46219:SF13', NULL, NULL, NULL, NULL, 'PROTEIN CBG23485', 242681),
(332568, 'PTHR46219', NULL, NULL, NULL, NULL, 'PROTEIN CBG11138', 242681),
(332569, 'PTHR46219:SF10', NULL, NULL, NULL, NULL, 'PROTEIN CBG04629', 242681),
(332570, 'PTHR46219:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG11139', 242681),
(332571, 'PTHR46219:SF8', NULL, NULL, NULL, NULL, 'PHARYNGEAL GLAND TOXIN-RELATED', 242681),
(332572, 'PTHR46219:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG11138', 242681),
(332573, 'PTHR46219:SF17', NULL, NULL, NULL, NULL, 'PHARYNGEAL GLAND TOXIN-RELATED', 242681),
(332574, 'PTHR46219:SF16', NULL, NULL, NULL, NULL, 'PROTEIN CBG17919', 242681),
(332575, 'PTHR46219:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG11142', 242681),
(332576, 'PTHR13193', NULL, NULL, NULL, NULL, 'CGI-140', 242682),
(332577, 'PTHR13193:SF0', NULL, NULL, NULL, NULL, 'PAT COMPLEX SUBUNIT ASTERIX', 242682),
(332578, 'PTHR47507', NULL, NULL, NULL, NULL, 'BARRIER TO AUTOINTEGRATION FACTOR 2', 242683),
(332579, 'PTHR47507:SF2', NULL, NULL, NULL, NULL, 'BARRIER-TO-AUTOINTEGRATION FACTOR-LIKE PROTEIN', 242683),
(332580, 'PTHR47507:SF5', NULL, NULL, NULL, NULL, 'BARRIER-TO-AUTOINTEGRATION FACTOR-RELATED', 242683),
(332581, 'PTHR47507:SF4', NULL, NULL, NULL, NULL, 'BARRIER-TO-AUTOINTEGRATION FACTOR-LIKE PROTEIN', 242683),
(332582, 'PTHR47507:SF7', NULL, NULL, NULL, NULL, 'BARRIER-TO-AUTOINTEGRATION FACTOR', 242683),
(332583, 'PTHR47507:SF6', NULL, NULL, NULL, NULL, 'BARRIER-TO-AUTOINTEGRATION FACTOR', 242683),
(332584, 'PTHR47507:SF8', NULL, NULL, NULL, NULL, '', 242683),
(332585, 'PTHR21174:SF0', NULL, NULL, NULL, NULL, 'PHOSPHOPANTETHEINE ADENYLYLTRANSFERASE / DEPHOSPHO-COA KINASE', 242684),
(332586, 'PTHR21174', NULL, NULL, NULL, NULL, '', 242684),
(332587, 'PTHR15510', NULL, NULL, NULL, NULL, 'SPERM-ASSOCIATED ANTIGEN 8', 242685),
(332588, 'PTHR15510:SF5', NULL, NULL, NULL, NULL, 'SPERM-ASSOCIATED ANTIGEN 8', 242685),
(332589, 'PTHR46046:SF2', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP9', 242686),
(332590, 'PTHR46046', NULL, NULL, NULL, NULL, '', 242686),
(332591, 'PTHR46046:SF5', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 242686),
(332592, 'PTHR46046:SF6', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 242686),
(332593, 'PTHR46046:SF3', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP10', 242686),
(332594, 'PTHR46046:SF4', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 242686),
(332595, 'PTHR43630:SF3', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE-RELATED', 242687),
(332596, 'PTHR43630:SF1', NULL, NULL, NULL, NULL, 'POLY-BETA-1,6-N-ACETYL-D-GLUCOSAMINE SYNTHASE', 242687);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(332597, 'PTHR43630:SF2', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE-RELATED', 242687),
(332598, 'PTHR43630', NULL, NULL, NULL, NULL, 'POLY-BETA-1,6-N-ACETYL-D-GLUCOSAMINE SYNTHASE', 242687),
(332599, 'PTHR21463:SF0', NULL, NULL, NULL, NULL, 'ANGIOPOIETIN-LIKE PROTEIN 8', 242688),
(332600, 'PTHR21463', NULL, NULL, NULL, NULL, 'ANGIOPOIETIN-LIKE PROTEIN 8', 242688),
(332601, 'PTHR37336:SF1', NULL, NULL, NULL, NULL, 'SIMILAR TO 9930012K11RIK PROTEIN', 242689),
(332602, 'PTHR37336', NULL, NULL, NULL, NULL, 'SIMILAR TO 9930012K11RIK PROTEIN', 242689),
(332603, 'PTHR15425:SF0', NULL, NULL, NULL, NULL, 'CD160 ANTIGEN', 242690),
(332604, 'PTHR15425', NULL, NULL, NULL, NULL, 'CD160 ANTIGEN', 242690),
(332605, 'PTHR34808:SF6', NULL, NULL, NULL, NULL, '', 242691),
(332606, 'PTHR34808:SF7', NULL, NULL, NULL, NULL, '', 242691),
(332607, 'PTHR34808:SF4', NULL, NULL, NULL, NULL, '', 242691),
(332608, 'PTHR34808:SF5', NULL, NULL, NULL, NULL, '', 242691),
(332609, 'PTHR34808:SF9', NULL, NULL, NULL, NULL, 'OS04G0458800 PROTEIN', 242691),
(332610, 'PTHR34808', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242691),
(332611, 'PTHR34808:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242691),
(332612, 'PTHR33232:SF12', NULL, NULL, NULL, NULL, 'PROTEIN SIEVE ELEMENT OCCLUSION B-LIKE ISOFORM X1', 242692),
(332613, 'PTHR33232:SF23', NULL, NULL, NULL, NULL, 'MEDIATOR COMPLEX SUBUNIT MED28-RELATED', 242692),
(332614, 'PTHR33232:SF22', NULL, NULL, NULL, NULL, '', 242692),
(332615, 'PTHR33232:SF11', NULL, NULL, NULL, NULL, 'PROTEIN SIEVE ELEMENT OCCLUSION C', 242692),
(332616, 'PTHR33232:SF9', NULL, NULL, NULL, NULL, 'PROTEIN SIEVE ELEMENT OCCLUSION B', 242692),
(332617, 'PTHR33232:SF10', NULL, NULL, NULL, NULL, 'SIEVE ELEMENT OCCLUSION-RELATED', 242692),
(332618, 'PTHR33232:SF21', NULL, NULL, NULL, NULL, 'SIEVE ELEMENT OCCLUSION-RELATED', 242692),
(332619, 'PTHR33232:SF20', NULL, NULL, NULL, NULL, 'PROTEIN SIEVE ELEMENT OCCLUSION B-LIKE', 242692),
(332620, 'PTHR33232:SF27', NULL, NULL, NULL, NULL, 'PROTEIN SIEVE ELEMENT OCCLUSION B-LIKE', 242692),
(332621, 'PTHR33232:SF16', NULL, NULL, NULL, NULL, 'PROTEIN SIEVE ELEMENT OCCLUSION A', 242692),
(332622, 'PTHR33232:SF15', NULL, NULL, NULL, NULL, 'PROTEIN SIEVE ELEMENT OCCLUSION B-LIKE', 242692),
(332623, 'PTHR33232:SF14', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE, SIEVE ELEMENT OCCLUSION-RELATED', 242692),
(332624, 'PTHR33232', NULL, NULL, NULL, NULL, 'PROTEIN SIEVE ELEMENT OCCLUSION B-LIKE', 242692),
(332625, 'PTHR33232:SF19', NULL, NULL, NULL, NULL, 'SIEVE ELEMENT OCCLUSION-RELATED', 242692),
(332626, 'PTHR33232:SF18', NULL, NULL, NULL, NULL, 'SIEVE ELEMENT OCCLUSION-RELATED', 242692),
(332627, 'PTHR33232:SF29', NULL, NULL, NULL, NULL, 'BNAA05G33720D PROTEIN', 242692),
(332628, 'PTHR33232:SF28', NULL, NULL, NULL, NULL, 'BNAC03G30640D PROTEIN', 242692),
(332629, 'PTHR33232:SF17', NULL, NULL, NULL, NULL, 'SIEVE ELEMENT OCCLUSION-RELATED', 242692),
(332630, 'PTHR47824', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 242693),
(332631, 'PTHR47824:SF3', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 242693),
(332632, 'PTHR47824:SF2', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 242693),
(332633, 'PTHR47824:SF1', NULL, NULL, NULL, NULL, '', 242693),
(332634, 'PTHR42966:SF3', NULL, NULL, NULL, NULL, 'BLR5971 PROTEIN', 242694),
(332635, 'PTHR42966:SF2', NULL, NULL, NULL, NULL, 'PSEUDAMINIC ACID SYNTHASE', 242694),
(332636, 'PTHR42966:SF1', NULL, NULL, NULL, NULL, 'SIALIC ACID SYNTHASE', 242694),
(332637, 'PTHR42966', NULL, NULL, NULL, NULL, 'N-ACETYLNEURAMINATE SYNTHASE', 242694),
(332638, 'PTHR23417:SF21', NULL, NULL, NULL, NULL, 'TRNA (GUANINE-N(7)-)-METHYLTRANSFERASE', 242695),
(332639, 'PTHR23417:SF23', NULL, NULL, NULL, NULL, 'TRNA (GUANINE-N(7)-)-METHYLTRANSFERASE', 242695),
(332640, 'PTHR23417:SF24', NULL, NULL, NULL, NULL, 'TRNA (GUANINE-N(7)-)-METHYLTRANSFERASE', 242695),
(332641, 'PTHR23417:SF14', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 242695),
(332642, 'PTHR23417', NULL, NULL, NULL, NULL, '3-DEOXY-D-MANNO-OCTULOSONIC-ACID TRANSFERASE/TRNA  GUANINE-N 7 - -METHYLTRANSFERASE', 242695);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(332643, 'PTHR23417:SF16', NULL, NULL, NULL, NULL, 'TRNA (GUANINE-N(7)-)-METHYLTRANSFERASE', 242695),
(332644, 'PTHR43332:SF1', NULL, NULL, NULL, NULL, 'TRANSPORT PERMEASE PROTEIN', 242696),
(332645, 'PTHR43332:SF2', NULL, NULL, NULL, NULL, 'INNER MEMBRANE TRANSPORT PERMEASE YADH', 242696),
(332646, 'PTHR43332', NULL, NULL, NULL, NULL, 'INNER MEMBRANE TRANSPORT PERMEASE YADH-RELATED', 242696),
(332647, 'PTHR32002:SF60', NULL, NULL, NULL, NULL, 'PLANT REGULATOR RWP-RK FAMILY PROTEIN-RELATED', 242697),
(332648, 'PTHR32002:SF64', NULL, NULL, NULL, NULL, 'BNAC04G02980D PROTEIN', 242697),
(332649, 'PTHR32002:SF62', NULL, NULL, NULL, NULL, 'PROTEIN NLP6-LIKE ISOFORM X1', 242697),
(332650, 'PTHR32002:SF41', NULL, NULL, NULL, NULL, 'PROTEIN NLP8', 242697),
(332651, 'PTHR32002:SF63', NULL, NULL, NULL, NULL, 'BNAC08G19370D PROTEIN', 242697),
(332652, 'PTHR32002:SF46', NULL, NULL, NULL, NULL, 'PROTEIN NLP2', 242697),
(332653, 'PTHR32002:SF47', NULL, NULL, NULL, NULL, 'PROTEIN NLP9', 242697),
(332654, 'PTHR32002:SF44', NULL, NULL, NULL, NULL, 'PROTEIN NLP4', 242697),
(332655, 'PTHR32002:SF45', NULL, NULL, NULL, NULL, '', 242697),
(332656, 'PTHR32002:SF28', NULL, NULL, NULL, NULL, 'PROTEIN NLP6', 242697),
(332657, 'PTHR32002:SF49', NULL, NULL, NULL, NULL, 'PB1 DOMAIN, RWP-RK DOMAIN PROTEIN-RELATED', 242697),
(332658, 'PTHR32002:SF50', NULL, NULL, NULL, NULL, 'BNAC03G47510D PROTEIN', 242697),
(332659, 'PTHR32002:SF72', NULL, NULL, NULL, NULL, 'PLANT REGULATOR RWP-RK FAMILY PROTEIN', 242697),
(332660, 'PTHR32002:SF31', NULL, NULL, NULL, NULL, 'PROTEIN NLP3', 242697),
(332661, 'PTHR32002:SF75', NULL, NULL, NULL, NULL, 'PLANT REGULATOR RWP-RK FAMILY PROTEIN', 242697),
(332662, 'PTHR32002:SF53', NULL, NULL, NULL, NULL, 'BNAC07G15260D PROTEIN', 242697),
(332663, 'PTHR32002:SF54', NULL, NULL, NULL, NULL, 'FACTOR, PUTATIVE-RELATED', 242697),
(332664, 'PTHR32002:SF76', NULL, NULL, NULL, NULL, 'PB1 DOMAIN-CONTAINING PROTEIN-RELATED', 242697),
(332665, 'PTHR32002:SF73', NULL, NULL, NULL, NULL, 'FACTOR, PUTATIVE-RELATED', 242697),
(332666, 'PTHR32002:SF51', NULL, NULL, NULL, NULL, 'BNAC04G48980D PROTEIN', 242697),
(332667, 'PTHR32002:SF74', NULL, NULL, NULL, NULL, 'OS02G0136000 PROTEIN', 242697),
(332668, 'PTHR32002:SF52', NULL, NULL, NULL, NULL, 'PROTEIN NLP9-LIKE', 242697),
(332669, 'PTHR32002:SF57', NULL, NULL, NULL, NULL, 'BNAA03G53210D PROTEIN', 242697),
(332670, 'PTHR32002:SF79', NULL, NULL, NULL, NULL, 'OS09G0549450 PROTEIN', 242697),
(332671, 'PTHR32002:SF35', NULL, NULL, NULL, NULL, 'PROTEIN NLP6', 242697),
(332672, 'PTHR32002:SF36', NULL, NULL, NULL, NULL, 'PROTEIN NLP5', 242697),
(332673, 'PTHR32002:SF77', NULL, NULL, NULL, NULL, 'PROTEIN NLP6-LIKE ISOFORM X1', 242697),
(332674, 'PTHR32002:SF33', NULL, NULL, NULL, NULL, 'BNAA01G35090D PROTEIN', 242697),
(332675, 'PTHR32002:SF55', NULL, NULL, NULL, NULL, 'NODULE INCEPTION PROTEIN', 242697),
(332676, 'PTHR32002:SF78', NULL, NULL, NULL, NULL, 'PROTEIN NLP6-LIKE ISOFORM X1', 242697),
(332677, 'PTHR32002:SF56', NULL, NULL, NULL, NULL, 'PB1 DOMAIN, RWP-RK DOMAIN PROTEIN-RELATED', 242697),
(332678, 'PTHR32002', NULL, NULL, NULL, NULL, 'PROTEIN NLP8', 242697),
(332679, 'PTHR32002:SF39', NULL, NULL, NULL, NULL, 'PROTEIN NLP1', 242697),
(332680, 'PTHR32002:SF59', NULL, NULL, NULL, NULL, 'PROTEIN NLP7', 242697),
(332681, 'PTHR35793', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YJIG', 242698),
(332682, 'PTHR35793:SF2', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YJIG', 242698),
(332683, 'PTHR46401:SF8', NULL, NULL, NULL, NULL, 'BLL6006 PROTEIN', 242699),
(332684, 'PTHR46401', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE WBBK-RELATED', 242699),
(332685, 'PTHR46401:SF2', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE WBBK-RELATED', 242699),
(332686, 'PTHR34753', NULL, NULL, NULL, NULL, 'TELOMERASE RNA COMPONENT INTERACTING RNASE', 242700),
(332687, 'PTHR34753:SF1', NULL, NULL, NULL, NULL, 'TELOMERASE RNA COMPONENT INTERACTING RNASE', 242700),
(332688, 'PTHR31953:SF1', NULL, NULL, NULL, NULL, 'ACID BETA-FRUCTOFURANOSIDASE 4, VACUOLAR', 242701),
(332689, 'PTHR31953:SF39', NULL, NULL, NULL, NULL, 'BETA-FRUCTOFURANOSIDASE, INSOLUBLE ISOENZYME 1-LIKE ISOFORM X1', 242701);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(332690, 'PTHR31953:SF79', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASES FAMILY 32 PROTEIN-RELATED', 242701),
(332691, 'PTHR31953:SF75', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE, FAMILY 32-RELATED', 242701),
(332692, 'PTHR31953:SF76', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE, FAMILY 32-RELATED', 242701),
(332693, 'PTHR31953:SF77', NULL, NULL, NULL, NULL, 'BNAA09G10570D PROTEIN', 242701),
(332694, 'PTHR31953:SF78', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE, FAMILY 32-RELATED', 242701),
(332695, 'PTHR31953:SF82', NULL, NULL, NULL, NULL, '', 242701),
(332696, 'PTHR31953:SF83', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_32N DOMAIN-CONTAINING PROTEIN', 242701),
(332697, 'PTHR31953:SF84', NULL, NULL, NULL, NULL, 'ACID BETA-FRUCTOFURANOSIDASE', 242701),
(332698, 'PTHR31953:SF40', NULL, NULL, NULL, NULL, 'FRUCTAN 1-EXOHYDROLASE W2', 242701),
(332699, 'PTHR31953:SF85', NULL, NULL, NULL, NULL, 'SUCROSE:SUCROSE 1-FRUCTOSYLTRANSFERASE', 242701),
(332700, 'PTHR31953:SF41', NULL, NULL, NULL, NULL, 'ACID BETA-FRUCTOFURANOSIDASE 3, VACUOLAR', 242701),
(332701, 'PTHR31953:SF80', NULL, NULL, NULL, NULL, 'BETA-FRUCTOFURANOSIDASE', 242701),
(332702, 'PTHR31953:SF109', NULL, NULL, NULL, NULL, 'BETA-FRUCTOFURANOSIDASE, INSOLUBLE ISOENZYME 3', 242701),
(332703, 'PTHR31953:SF68', NULL, NULL, NULL, NULL, 'BETA-FRUCTOFURANOSIDASE, INSOLUBLE ISOENZYME 4', 242701),
(332704, 'PTHR31953:SF103', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE, FAMILY 32-RELATED', 242701),
(332705, 'PTHR31953:SF104', NULL, NULL, NULL, NULL, 'BETA-FRUCTOFURANOSIDASE, INSOLUBLE ISOENZYME CWINV1-LIKE', 242701),
(332706, 'PTHR31953:SF102', NULL, NULL, NULL, NULL, 'BETA-FRUCTOFURANOSIDASE, INSOLUBLE ISOENZYME CWINV2', 242701),
(332707, 'PTHR31953:SF64', NULL, NULL, NULL, NULL, 'BETA-FRUCTOFURANOSIDASE, INSOLUBLE ISOENZYME 1-LIKE', 242701),
(332708, 'PTHR31953:SF107', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_32N DOMAIN-CONTAINING PROTEIN', 242701),
(332709, 'PTHR31953:SF108', NULL, NULL, NULL, NULL, 'BETA-FRUCTOFURANOSIDASE', 242701),
(332710, 'PTHR31953:SF105', NULL, NULL, NULL, NULL, 'BETA-FRUCTOFURANOSIDASE, INSOLUBLE ISOENZYME 1-LIKE ISOFORM X2', 242701),
(332711, 'PTHR31953:SF66', NULL, NULL, NULL, NULL, 'BETA-FRUCTOFURANOSIDASE, INSOLUBLE ISOENZYME CWINV6', 242701),
(332712, 'PTHR31953:SF106', NULL, NULL, NULL, NULL, 'FRUCTAN 6-EXOHYDROLASE-RELATED', 242701),
(332713, 'PTHR31953:SF71', NULL, NULL, NULL, NULL, 'FRUCTAN 6-EXOHYDROLASE', 242701),
(332714, 'PTHR31953:SF72', NULL, NULL, NULL, NULL, 'BETA-FRUCTOFURANOSIDASE, INSOLUBLE ISOENZYME CWINV5', 242701),
(332715, 'PTHR31953:SF73', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE, FAMILY 32-RELATED', 242701),
(332716, 'PTHR31953:SF74', NULL, NULL, NULL, NULL, '', 242701),
(332717, 'PTHR31953:SF100', NULL, NULL, NULL, NULL, 'BETA-FRUCTOFURANOSIDASE, INSOLUBLE ISOENZYME CWINV1', 242701),
(332718, 'PTHR31953:SF70', NULL, NULL, NULL, NULL, 'VACUOLAR INVERTASE', 242701),
(332719, 'PTHR31953:SF18', NULL, NULL, NULL, NULL, 'BETA-FRUCTOFURANOSIDASE, INSOLUBLE ISOENZYME 2', 242701),
(332720, 'PTHR31953:SF13', NULL, NULL, NULL, NULL, 'BETA-FRUCTOFURANOSIDASE, INSOLUBLE ISOENZYME 7', 242701),
(332721, 'PTHR31953:SF15', NULL, NULL, NULL, NULL, 'BETA-FRUCTOFURANOSIDASE, INSOLUBLE ISOENZYME 6', 242701),
(332722, 'PTHR31953:SF53', NULL, NULL, NULL, NULL, '', 242701),
(332723, 'PTHR31953:SF54', NULL, NULL, NULL, NULL, '', 242701),
(332724, 'PTHR31953:SF55', NULL, NULL, NULL, NULL, 'BETA-FRUCTOFURANOSIDASE, INSOLUBLE PROTEIN', 242701),
(332725, 'PTHR31953:SF99', NULL, NULL, NULL, NULL, 'BETA-FRUCTOFURANOSIDASE, INSOLUBLE ISOENZYME 2', 242701),
(332726, 'PTHR31953:SF60', NULL, NULL, NULL, NULL, 'BETA-FRUCTOFURANOSIDASE, INSOLUBLE ISOENZYME CWINV3', 242701),
(332727, 'PTHR31953:SF61', NULL, NULL, NULL, NULL, '', 242701),
(332728, 'PTHR31953:SF62', NULL, NULL, NULL, NULL, '', 242701),
(332729, 'PTHR31953:SF63', NULL, NULL, NULL, NULL, 'VACUOLAR INVERTASE', 242701),
(332730, 'PTHR31953:SF46', NULL, NULL, NULL, NULL, 'SUCROSE:FRUCTAN 6-FRUCTOSYLTRANSFERASE', 242701),
(332731, 'PTHR31953:SF47', NULL, NULL, NULL, NULL, '', 242701);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(332732, 'PTHR31953:SF48', NULL, NULL, NULL, NULL, 'CELL WALL INVERTASE 1', 242701),
(332733, 'PTHR31953:SF49', NULL, NULL, NULL, NULL, 'DEFECTIVE INVERTASE NIN88', 242701),
(332734, 'PTHR31953:SF42', NULL, NULL, NULL, NULL, 'OS02G0106100 PROTEIN', 242701),
(332735, 'PTHR31953:SF86', NULL, NULL, NULL, NULL, 'BNAC05G39500D PROTEIN', 242701),
(332736, 'PTHR31953:SF43', NULL, NULL, NULL, NULL, 'BETA-FRUCTOFURANOSIDASE, INSOLUBLE ISOENZYME CWINV4', 242701),
(332737, 'PTHR31953:SF45', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_32N DOMAIN-CONTAINING PROTEIN', 242701),
(332738, 'PTHR31953:SF89', NULL, NULL, NULL, NULL, 'BETA-FRUCTOFURANOSIDASE 5-RELATED', 242701),
(332739, 'PTHR31953:SF50', NULL, NULL, NULL, NULL, 'BETA-FRUCTOFURANOSIDASE, INSOLUBLE ISOENZYME 5', 242701),
(332740, 'PTHR31953:SF95', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE, FAMILY 32-RELATED', 242701),
(332741, 'PTHR31953', NULL, NULL, NULL, NULL, 'BETA-FRUCTOFURANOSIDASE, INSOLUBLE ISOENZYME CWINV1-RELATED', 242701),
(332742, 'PTHR31953:SF51', NULL, NULL, NULL, NULL, 'CELL-WALL INVERTASE', 242701),
(332743, 'PTHR31953:SF52', NULL, NULL, NULL, NULL, 'BETA-FRUCTOFURANOSIDASE, INSOLUBLE ISOENZYME 1-LIKE', 242701),
(332744, 'PTHR31953:SF91', NULL, NULL, NULL, NULL, 'BETA-FRUCTOSIDASE (BETA-FRUCTOFURANOSIDASE)', 242701),
(332745, 'PTHR31953:SF92', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE, FAMILY 32-RELATED', 242701),
(332746, 'PTHR47039:SF1', NULL, NULL, NULL, NULL, 'INOSITOL POLYPHOSPHATE 5-PHOSPHATASE E', 242702),
(332747, 'PTHR47039', NULL, NULL, NULL, NULL, 'INOSITOL POLYPHOSPHATE 5-PHOSPHATASE E', 242702),
(332748, 'PTHR47548', NULL, NULL, NULL, NULL, 'BNAA06G32370D PROTEIN', 242703),
(332749, 'PTHR47548:SF1', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 242703),
(332750, 'PTHR37206:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 242704),
(332751, 'PTHR37206:SF5', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 242704),
(332752, 'PTHR37206:SF1', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 242704),
(332753, 'PTHR37206', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 242704),
(332754, 'PTHR47939:SF4', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 242705),
(332755, 'PTHR47939:SF3', NULL, NULL, NULL, NULL, 'OS03G0201400 PROTEIN', 242705),
(332756, 'PTHR47939:SF6', NULL, NULL, NULL, NULL, '', 242705),
(332757, 'PTHR47939:SF5', NULL, NULL, NULL, NULL, 'BNAC02G25990D PROTEIN', 242705),
(332758, 'PTHR47939', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED SALT-INDUCIBLE PROTEIN-LIKE', 242705),
(332759, 'PTHR47939:SF2', NULL, NULL, NULL, NULL, 'FERTILITY RESTORER', 242705),
(332760, 'PTHR47939:SF1', NULL, NULL, NULL, NULL, 'OS04G0684500 PROTEIN', 242705),
(332761, 'PTHR47939:SF8', NULL, NULL, NULL, NULL, 'BNAA01G29990D PROTEIN', 242705),
(332762, 'PTHR47939:SF7', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 242705),
(332763, 'PTHR47939:SF10', NULL, NULL, NULL, NULL, '', 242705),
(332764, 'PTHR47939:SF9', NULL, NULL, NULL, NULL, '', 242705),
(332765, 'PTHR15526:SF5', NULL, NULL, NULL, NULL, 'MUSKELIN', 242706),
(332766, 'PTHR15526', NULL, NULL, NULL, NULL, 'MUSKELIN', 242706),
(332767, 'PTHR15526:SF6', NULL, NULL, NULL, NULL, '', 242706),
(332768, 'PTHR33088:SF82', NULL, NULL, NULL, NULL, 'PEARLI1-LIKE LIPID TRANSFER PROTEIN 2', 242707),
(332769, 'PTHR33088:SF62', NULL, NULL, NULL, NULL, 'LIPID BINDING PROTEIN', 242707),
(332770, 'PTHR33088:SF84', NULL, NULL, NULL, NULL, 'BNAA03G55830D PROTEIN', 242707),
(332771, 'PTHR33088:SF83', NULL, NULL, NULL, NULL, 'PERIAXIN-LIKE PROTEIN', 242707),
(332772, 'PTHR33088:SF68', NULL, NULL, NULL, NULL, '', 242707),
(332773, 'PTHR33088:SF89', NULL, NULL, NULL, NULL, 'PROTEIN APP1-LIKE', 242707),
(332774, 'PTHR33088:SF69', NULL, NULL, NULL, NULL, 'STRUCTURAL CONSTITUENT OF CELL WALL', 242707),
(332775, 'PTHR33088:SF47', NULL, NULL, NULL, NULL, 'OS07G0600200 PROTEIN', 242707),
(332776, 'PTHR33088:SF86', NULL, NULL, NULL, NULL, '', 242707),
(332777, 'PTHR33088:SF64', NULL, NULL, NULL, NULL, '', 242707);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(332778, 'PTHR33088:SF42', NULL, NULL, NULL, NULL, 'OS07G0142200 PROTEIN', 242707),
(332779, 'PTHR33088:SF85', NULL, NULL, NULL, NULL, 'GAMMA-GLIADIN', 242707),
(332780, 'PTHR33088:SF88', NULL, NULL, NULL, NULL, 'OS04G0521900 PROTEIN', 242707),
(332781, 'PTHR33088:SF44', NULL, NULL, NULL, NULL, '', 242707),
(332782, 'PTHR33088:SF66', NULL, NULL, NULL, NULL, 'PROLINE-RICH RECEPTOR-LIKE PROTEIN KINASE PERK2', 242707),
(332783, 'PTHR33088:SF87', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN-RELATED', 242707),
(332784, 'PTHR33088:SF28', NULL, NULL, NULL, NULL, 'PROTEIN PELPK1-RELATED', 242707),
(332785, 'PTHR33088', NULL, NULL, NULL, NULL, 'MUCIN-2', 242707),
(332786, 'PTHR33088:SF93', NULL, NULL, NULL, NULL, 'OS07G0599300 PROTEIN', 242707),
(332787, 'PTHR33088:SF92', NULL, NULL, NULL, NULL, 'MUCIN-2', 242707),
(332788, 'PTHR33088:SF95', NULL, NULL, NULL, NULL, 'PRE-MRNA POLYADENYLATION FACTOR FIP1-LIKE', 242707),
(332789, 'PTHR33088:SF51', NULL, NULL, NULL, NULL, '', 242707),
(332790, 'PTHR33088:SF94', NULL, NULL, NULL, NULL, 'PROLINE-RICH RECEPTOR-LIKE PROTEIN KINASE PERK2', 242707),
(332791, 'PTHR33088:SF91', NULL, NULL, NULL, NULL, '', 242707),
(332792, 'PTHR33088:SF90', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 242707),
(332793, 'PTHR33088:SF35', NULL, NULL, NULL, NULL, 'ESX-1 SECRETION-ASSOCIATED PROTEIN ESPE', 242707),
(332794, 'PTHR33088:SF78', NULL, NULL, NULL, NULL, 'LEGUMINOSIN GROUP485 SECRETED PEPTIDE', 242707),
(332795, 'PTHR33088:SF58', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242707),
(332796, 'PTHR33088:SF97', NULL, NULL, NULL, NULL, '', 242707),
(332797, 'PTHR33088:SF52', NULL, NULL, NULL, NULL, '', 242707),
(332798, 'PTHR33088:SF96', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN', 242707),
(332799, 'PTHR33088:SF30', NULL, NULL, NULL, NULL, 'PROTEIN PELPK1-LIKE', 242707),
(332800, 'PTHR33088:SF99', NULL, NULL, NULL, NULL, 'LEGUMINOSIN GROUP485 SECRETED PEPTIDE', 242707),
(332801, 'PTHR33088:SF100', NULL, NULL, NULL, NULL, 'PROLINE-RICH RECEPTOR-LIKE PROTEIN KINASE PERK9', 242707),
(332802, 'PTHR33088:SF98', NULL, NULL, NULL, NULL, 'PROTEIN APP1-LIKE', 242707),
(332803, 'PTHR33088:SF76', NULL, NULL, NULL, NULL, 'BNAC09G47070D PROTEIN', 242707),
(332804, 'PTHR32011:SF2', NULL, NULL, NULL, NULL, 'OS08G0472400 PROTEIN', 242708),
(332805, 'PTHR32011:SF4', NULL, NULL, NULL, NULL, 'OS09G0456700 PROTEIN', 242708),
(332806, 'PTHR32011:SF5', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242708),
(332807, 'PTHR32011:SF6', NULL, NULL, NULL, NULL, 'SMI1_KNR4 DOMAIN-CONTAINING PROTEIN', 242708),
(332808, 'PTHR32011:SF7', NULL, NULL, NULL, NULL, 'BNAC07G16360D PROTEIN', 242708),
(332809, 'PTHR32011:SF8', NULL, NULL, NULL, NULL, 'BNAC08G21750D PROTEIN', 242708),
(332810, 'PTHR32011', NULL, NULL, NULL, NULL, 'OS08G0472400 PROTEIN', 242708),
(332811, 'PTHR33964:SF9', NULL, NULL, NULL, NULL, '', 242709),
(332812, 'PTHR33964', NULL, NULL, NULL, NULL, 'RE45066P-RELATED', 242709),
(332813, 'PTHR33964:SF1', NULL, NULL, NULL, NULL, 'RE45066P', 242709),
(332814, 'PTHR33964:SF2', NULL, NULL, NULL, NULL, 'IP09356P', 242709),
(332815, 'PTHR21631:SF13', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 2-METHYLISOCITRATE LYASE', 242710),
(332816, 'PTHR21631', NULL, NULL, NULL, NULL, 'ISOCITRATE LYASE/MALATE SYNTHASE', 242710),
(332817, 'PTHR21631:SF3', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL GLYOXYLATE CYCLE PROTEIN', 242710),
(332818, 'PTHR36080:SF1', NULL, NULL, NULL, NULL, 'DBJ|BAA96220.1', 242711),
(332819, 'PTHR36080:SF2', NULL, NULL, NULL, NULL, '', 242711),
(332820, 'PTHR36080', NULL, NULL, NULL, NULL, 'DBJ|BAA96220.1', 242711),
(332821, 'PTHR36080:SF3', NULL, NULL, NULL, NULL, 'BNAA06G23330D PROTEIN', 242711),
(332822, 'PTHR38899:SF1', NULL, NULL, NULL, NULL, 'DOMAIN OOKINETE PROTEIN, PUTATIVE-RELATED', 242712),
(332823, 'PTHR38899:SF2', NULL, NULL, NULL, NULL, '', 242712),
(332824, 'PTHR38899', NULL, NULL, NULL, NULL, 'DOMAIN OOKINETE PROTEIN, PUTATIVE-RELATED', 242712),
(332825, 'PTHR14332:SF3', NULL, NULL, NULL, NULL, 'DISRUPTED IN SCHIZOPHRENIA 1 PROTEIN', 242713);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(332826, 'PTHR14332', NULL, NULL, NULL, NULL, 'DISRUPTED IN SCHIZOPHRENIA 1 PROTEIN', 242713),
(332827, 'PTHR43372:SF4', NULL, NULL, NULL, NULL, 'FATTY-ACID AMIDE HYDROLASE 2', 242714),
(332828, 'PTHR43372', NULL, NULL, NULL, NULL, 'FATTY-ACID AMIDE HYDROLASE', 242714),
(332829, 'PTHR43372:SF3', NULL, NULL, NULL, NULL, 'AT07710P-RELATED', 242714),
(332830, 'PTHR43372:SF2', NULL, NULL, NULL, NULL, 'IP13792P', 242714),
(332831, 'PTHR43372:SF1', NULL, NULL, NULL, NULL, 'LD38433P', 242714),
(332832, 'PTHR38616', NULL, NULL, NULL, NULL, 'PROTEIN CBG03925', 242715),
(332833, 'PTHR38616:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG03925', 242715),
(332834, 'PTHR32091:SF25', NULL, NULL, NULL, NULL, 'OS01G0306100 PROTEIN', 242716),
(332835, 'PTHR32091:SF24', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4B2-LIKE', 242716),
(332836, 'PTHR32091', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4B', 242716),
(332837, 'PTHR32091:SF27', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4B1', 242716),
(332838, 'PTHR32091:SF26', NULL, NULL, NULL, NULL, '', 242716),
(332839, 'PTHR32091:SF20', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4B2', 242716),
(332840, 'PTHR32091:SF22', NULL, NULL, NULL, NULL, 'BNAA09G46710D PROTEIN', 242716),
(332841, 'PTHR32091:SF17', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4B3', 242716),
(332842, 'PTHR32091:SF4', NULL, NULL, NULL, NULL, 'OS07G0546100 PROTEIN', 242716),
(332843, 'PTHR32091:SF19', NULL, NULL, NULL, NULL, 'OS02G0595800 PROTEIN', 242716),
(332844, 'PTHR11973:SF21', NULL, NULL, NULL, NULL, '', 242717),
(332845, 'PTHR11973:SF20', NULL, NULL, NULL, NULL, 'ADVANCED GLYCOSYLATION END PRODUCT-SPECIFIC RECEPTOR', 242717),
(332846, 'PTHR11973:SF23', NULL, NULL, NULL, NULL, 'SI:CH211-79K12.1', 242717),
(332847, 'PTHR11973:SF2', NULL, NULL, NULL, NULL, 'CD166 ANTIGEN', 242717),
(332848, 'PTHR11973:SF18', NULL, NULL, NULL, NULL, 'CELL SURFACE GLYCOPROTEIN MUC18', 242717),
(332849, 'PTHR11973:SF17', NULL, NULL, NULL, NULL, 'BASAL CELL ADHESION MOLECULE', 242717),
(332850, 'PTHR11973', NULL, NULL, NULL, NULL, 'CELL SURFACE GLYCOPROTEIN MUC18-RELATED', 242717),
(332851, 'PTHR11973:SF24', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 242717),
(332852, 'PTHR45760:SF12', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CARRIER PROTEIN MTM1-LIKE ISOFORM X1', 242718),
(332853, 'PTHR45760:SF1', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 25 MEMBER 39', 242718),
(332854, 'PTHR45760:SF2', NULL, NULL, NULL, NULL, 'FI19922P1-RELATED', 242718),
(332855, 'PTHR45760:SF11', NULL, NULL, NULL, NULL, 'BNACNNG35730D PROTEIN', 242718),
(332856, 'PTHR45760:SF7', NULL, NULL, NULL, NULL, 'CARRIER PROTEIN CGI-69', 242718),
(332857, 'PTHR45760', NULL, NULL, NULL, NULL, 'FI19922P1-RELATED', 242718),
(332858, 'PTHR45760:SF5', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 25 MEMBER 40', 242718),
(332859, 'PTHR45760:SF6', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN', 242718),
(332860, 'PTHR38596', NULL, NULL, NULL, NULL, 'UPF0114 PROTEIN YQHA', 242719),
(332861, 'PTHR38596:SF1', NULL, NULL, NULL, NULL, 'UPF0114 PROTEIN YQHA', 242719),
(332862, 'PTHR34565:SF2', NULL, NULL, NULL, NULL, 'ATP SYNTHASE 6 KDA SUBUNIT', 242720),
(332863, 'PTHR34565:SF3', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ATP SYNTHASE 6KDA SUBUNIT', 242720),
(332864, 'PTHR34565:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 242720),
(332865, 'PTHR34565', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 242720),
(332866, 'PTHR23017:SF7', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 242721),
(332867, 'PTHR23017:SF6', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN', 242721),
(332868, 'PTHR23017', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS X', 242721),
(332869, 'PTHR23017:SF14', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN-RELATED', 242721),
(332870, 'PTHR23017:SF25', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS X 45', 242721);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(332871, 'PTHR23017:SF46', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN-RELATED', 242721),
(332872, 'PTHR23017:SF24', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN-RELATED', 242721),
(332873, 'PTHR23017:SF3', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 242721),
(332874, 'PTHR23017:SF2', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 242721),
(332875, 'PTHR23017:SF19', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN', 242721),
(332876, 'PTHR23017:SF5', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN-RELATED', 242721),
(332877, 'PTHR23017:SF18', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 242721),
(332878, 'PTHR23017:SF4', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 242721),
(332879, 'PTHR23017:SF17', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 242721),
(332880, 'PTHR23017:SF45', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN', 242721),
(332881, 'PTHR23017:SF44', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 242721),
(332882, 'PTHR23017:SF11', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN', 242721),
(332883, 'PTHR23017:SF22', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 242721),
(332884, 'PTHR23017:SF43', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 242721),
(332885, 'PTHR23017:SF21', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN', 242721),
(332886, 'PTHR23017:SF42', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 242721),
(332887, 'PTHR23017:SF20', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 242721),
(332888, 'PTHR34133:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242722),
(332889, 'PTHR34133:SF9', NULL, NULL, NULL, NULL, 'BNAC04G31630D PROTEIN', 242722),
(332890, 'PTHR34133', NULL, NULL, NULL, NULL, 'OS07G0633000 PROTEIN', 242722),
(332891, 'PTHR34133:SF10', NULL, NULL, NULL, NULL, '', 242722),
(332892, 'PTHR34133:SF8', NULL, NULL, NULL, NULL, 'OS07G0633000 PROTEIN', 242722),
(332893, 'PTHR34133:SF12', NULL, NULL, NULL, NULL, 'BNAC04G31620D PROTEIN', 242722),
(332894, 'PTHR44586:SF18', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 242723),
(332895, 'PTHR44586:SF17', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 242723),
(332896, 'PTHR44586:SF16', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', 242723),
(332897, 'PTHR44586:SF14', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 242723),
(332898, 'PTHR44586:SF24', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 242723),
(332899, 'PTHR44586:SF23', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', 242723),
(332900, 'PTHR44586:SF22', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 242723),
(332901, 'PTHR44586:SF11', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 242723),
(332902, 'PTHR44586:SF21', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 242723),
(332903, 'PTHR44586:SF10', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 242723),
(332904, 'PTHR44586:SF6', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 242723),
(332905, 'PTHR44586:SF20', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 242723),
(332906, 'PTHR44586', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', 242723),
(332907, 'PTHR44586:SF19', NULL, NULL, NULL, NULL, 'OS11G0576400 PROTEIN', 242723),
(332908, 'PTHR44281', NULL, NULL, NULL, NULL, 'SPINDLE ASSEMBLY ABNORMAL PROTEIN 6 HOMOLOG', 242724),
(332909, 'PTHR44281:SF4', NULL, NULL, NULL, NULL, 'SPINDLE ASSEMBLY ABNORMAL PROTEIN 6 HOMOLOG', 242724),
(332910, 'PTHR44281:SF3', NULL, NULL, NULL, NULL, 'SPINDLE ASSEMBLY ABNORMAL PROTEIN 6 HOMOLOG', 242724),
(332911, 'PTHR44281:SF2', NULL, NULL, NULL, NULL, 'SPINDLE ASSEMBLY ABNORMAL PROTEIN 6 HOMOLOG', 242724);
INSERT INTO "PUBLIC"."MODEL" VALUES
(332912, 'PTHR11943', NULL, NULL, NULL, NULL, 'GALACTOSE-1-PHOSPHATE URIDYLYLTRANSFERASE', 242725),
(332913, 'PTHR11943:SF1', NULL, NULL, NULL, NULL, 'GALACTOSE-1-PHOSPHATE URIDYLYLTRANSFERASE', 242725),
(332914, 'PTHR12835:SF5', NULL, NULL, NULL, NULL, 'BIOTIN--PROTEIN LIGASE', 242726),
(332915, 'PTHR12835', NULL, NULL, NULL, NULL, 'BIOTIN PROTEIN LIGASE', 242726),
(332916, 'PTHR47782:SF7', NULL, NULL, NULL, NULL, 'PROTEIN STB5', 242727),
(332917, 'PTHR47782:SF12', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 242727),
(332918, 'PTHR47782:SF8', NULL, NULL, NULL, NULL, 'ZN(2)-C6 FUNGAL-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', 242727),
(332919, 'PTHR47782:SF10', NULL, NULL, NULL, NULL, 'PROTEIN SIP4', 242727),
(332920, 'PTHR47782:SF1', NULL, NULL, NULL, NULL, 'PYRIMIDINE PATHWAY REGULATORY PROTEIN 1', 242727),
(332921, 'PTHR47782', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 242727),
(332922, 'PTHR47782:SF14', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 242727),
(332923, 'PTHR47782:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G12570)-RELATED', 242727),
(332924, 'PTHR42051:SF1', NULL, NULL, NULL, NULL, 'MEIOTICALLY UP-REGULATED PROTEIN PB1A10.08', 242728),
(332925, 'PTHR42051', NULL, NULL, NULL, NULL, 'MEIOTICALLY UP-REGULATED PROTEIN PB1A10.08', 242728),
(332926, 'PTHR46504', NULL, NULL, NULL, NULL, 'TRNASE Z TRZ1', 242729),
(332927, 'PTHR46504:SF4', NULL, NULL, NULL, NULL, 'LACTAMASE_B DOMAIN-CONTAINING PROTEIN', 242729),
(332928, 'PTHR46504:SF2', NULL, NULL, NULL, NULL, 'TRNASE Z TRZ1', 242729),
(332929, 'PTHR46504:SF1', NULL, NULL, NULL, NULL, 'TRNASE Z TRZ2, CHLOROPLASTIC', 242729),
(332930, 'PTHR12889:SF7', NULL, NULL, NULL, NULL, 'ZGC:114200', 242730),
(332931, 'PTHR12889:SF3', NULL, NULL, NULL, NULL, 'GAMMA-SECRETASE SUBUNIT APH-1A', 242730),
(332932, 'PTHR12889', NULL, NULL, NULL, NULL, 'GAMMA-SECRETASE SUBUNIT APH-1', 242730),
(332933, 'PTHR12889:SF6', NULL, NULL, NULL, NULL, 'BNAANNG37220D PROTEIN', 242730),
(332934, 'PTHR12889:SF0', NULL, NULL, NULL, NULL, 'GAMMA-SECRETASE SUBUNIT APH-1', 242730),
(332935, 'PTHR12889:SF1', NULL, NULL, NULL, NULL, 'GAMMA-SECRETASE SUBUNIT APH-1B', 242730),
(332936, 'PTHR34931:SF3', NULL, NULL, NULL, NULL, 'FI02976P-RELATED', 242731),
(332937, 'PTHR34931', NULL, NULL, NULL, NULL, 'FI02976P-RELATED', 242731),
(332938, 'PTHR34931:SF4', NULL, NULL, NULL, NULL, 'GEO12049P1-RELATED', 242731),
(332939, 'PTHR35335:SF1', NULL, NULL, NULL, NULL, 'UPF0716 PROTEIN FXSA', 242732),
(332940, 'PTHR35335', NULL, NULL, NULL, NULL, 'UPF0716 PROTEIN FXSA', 242732),
(332941, 'PTHR28096:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAF1', 242733),
(332942, 'PTHR28096', NULL, NULL, NULL, NULL, 'PROTEIN FAF1', 242733),
(332943, 'PTHR13373', NULL, NULL, NULL, NULL, 'FROUNT PROTEIN-RELATED', 242734),
(332944, 'PTHR13373:SF21', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP85', 242734),
(332945, 'PTHR22730:SF1', NULL, NULL, NULL, NULL, 'PROMININ-LIKE PROTEIN', 242735),
(332946, 'PTHR22730:SF6', NULL, NULL, NULL, NULL, 'PROMININ-2', 242735),
(332947, 'PTHR22730:SF4', NULL, NULL, NULL, NULL, 'PROMININ 2', 242735),
(332948, 'PTHR22730:SF3', NULL, NULL, NULL, NULL, 'PROMININ-1', 242735),
(332949, 'PTHR22730:SF8', NULL, NULL, NULL, NULL, 'PROMININ 1 B', 242735),
(332950, 'PTHR22730', NULL, NULL, NULL, NULL, 'PROMININ  PROM  PROTEIN', 242735),
(332951, 'PTHR28092:SF1', NULL, NULL, NULL, NULL, 'FACTOR-INDUCED GENE 1 PROTEIN', 242736),
(332952, 'PTHR28092', NULL, NULL, NULL, NULL, 'FACTOR-INDUCED GENE 1 PROTEIN', 242736),
(332953, 'PTHR12695:SF2', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR IIH SUBUNIT 2-RELATED', 242737),
(332954, 'PTHR12695', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR IIH SUBUNIT 2', 242737),
(332955, 'PTHR33505', NULL, NULL, NULL, NULL, 'ZGC:162634', 242738),
(332956, 'PTHR33505:SF6', NULL, NULL, NULL, NULL, '', 242738),
(332957, 'PTHR33505:SF7', NULL, NULL, NULL, NULL, 'PROTEIN PREY, MITOCHONDRIAL', 242738);
INSERT INTO "PUBLIC"."MODEL" VALUES
(332958, 'PTHR33505:SF4', NULL, NULL, NULL, NULL, 'PROTEIN PREY, MITOCHONDRIAL', 242738),
(332959, 'PTHR23083:SF475', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 7A', 242739),
(332960, 'PTHR23083:SF365', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 7B', 242739),
(332961, 'PTHR23083:SF464', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT DOMAIN 7, ISOFORM A', 242739),
(332962, 'PTHR23083', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN, TPR', 242739),
(332963, 'PTHR34763:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM104B', 242740),
(332964, 'PTHR34763:SF3', NULL, NULL, NULL, NULL, '', 242740),
(332965, 'PTHR34763:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAM104A', 242740),
(332966, 'PTHR34763', NULL, NULL, NULL, NULL, 'PROTEIN FAM104A', 242740),
(332967, 'PTHR34068:SF1', NULL, NULL, NULL, NULL, 'UPF0145 PROTEIN YBJQ', 242741),
(332968, 'PTHR34068', NULL, NULL, NULL, NULL, 'UPF0145 PROTEIN YBJQ', 242741),
(332969, 'PTHR34068:SF2', NULL, NULL, NULL, NULL, 'UPF0145 PROTEIN SCO3412', 242741),
(332970, 'PTHR32439:SF9', NULL, NULL, NULL, NULL, 'BLR3264 PROTEIN', 242742),
(332971, 'PTHR32439:SF8', NULL, NULL, NULL, NULL, 'BNAA09G08530D PROTEIN', 242742),
(332972, 'PTHR32439', NULL, NULL, NULL, NULL, 'FERREDOXIN--NITRITE REDUCTASE, CHLOROPLASTIC', 242742),
(332973, 'PTHR32439:SF0', NULL, NULL, NULL, NULL, 'FERREDOXIN--NITRITE REDUCTASE, CHLOROPLASTIC', 242742),
(332974, 'PTHR32439:SF6', NULL, NULL, NULL, NULL, 'FERREDOXIN--NITRITE REDUCTASE, CHLOROPLASTIC-LIKE ISOFORM X1', 242742),
(332975, 'PTHR15168:SF0', NULL, NULL, NULL, NULL, 'CYTOCHROME B-245 LIGHT CHAIN', 242743),
(332976, 'PTHR15168', NULL, NULL, NULL, NULL, 'CYTOCHROME B-245 LIGHT CHAIN', 242743),
(332977, 'PTHR40593', NULL, NULL, NULL, NULL, 'PENICILLIN-BINDING PROTEIN ACTIVATOR LPOB', 242744),
(332978, 'PTHR40593:SF1', NULL, NULL, NULL, NULL, 'PENICILLIN-BINDING PROTEIN ACTIVATOR LPOB', 242744),
(332979, 'PTHR31884:SF9', NULL, NULL, NULL, NULL, 'ENDOPOLYGALACTURONASE D-RELATED', 242745),
(332980, 'PTHR31884', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE', 242745),
(332981, 'PTHR31884:SF12', NULL, NULL, NULL, NULL, 'ENDOPOLYGALACTURONASE AN8327', 242745),
(332982, 'PTHR31884:SF1', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE', 242745),
(332983, 'PTHR37415:SF2', NULL, NULL, NULL, NULL, 'EFF-1A', 242746),
(332984, 'PTHR37415:SF1', NULL, NULL, NULL, NULL, 'CELL FUSION PROTEIN AFF-1', 242746),
(332985, 'PTHR37415', NULL, NULL, NULL, NULL, 'EFF-1A', 242746),
(332986, 'PTHR24159', NULL, NULL, NULL, NULL, '', 242747),
(332987, 'PTHR24159:SF5', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 242747),
(332988, 'PTHR23293', NULL, NULL, NULL, NULL, 'FAD SYNTHETASE-RELATED  FMN ADENYLYLTRANSFERASE', 242748),
(332989, 'PTHR23293:SF11', NULL, NULL, NULL, NULL, 'MOCF_BIOSYNTH DOMAIN-CONTAINING PROTEIN', 242748),
(332990, 'PTHR23293:SF9', NULL, NULL, NULL, NULL, 'FAD SYNTHASE', 242748),
(332991, 'PTHR23293:SF13', NULL, NULL, NULL, NULL, 'FAD SYNTHASE-LIKE', 242748),
(332992, 'PTHR43440:SF1', NULL, NULL, NULL, NULL, 'UREASE', 242749),
(332993, 'PTHR43440', NULL, NULL, NULL, NULL, 'UREASE', 242749),
(332994, 'PTHR21601', NULL, NULL, NULL, NULL, 'SPA2 PROTEIN', 242750),
(332995, 'PTHR21601:SF0', NULL, NULL, NULL, NULL, 'PROTEIN SPA2-RELATED', 242750),
(332996, 'PTHR37364:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 182', 242751),
(332997, 'PTHR37364', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 182', 242751),
(332998, 'PTHR10426:SF92', NULL, NULL, NULL, NULL, 'STR_SYNTH DOMAIN-CONTAINING PROTEIN', 242752),
(332999, 'PTHR10426:SF90', NULL, NULL, NULL, NULL, 'PROTEIN STRICTOSIDINE SYNTHASE-LIKE 9', 242752),
(333000, 'PTHR10426:SF95', NULL, NULL, NULL, NULL, 'OS06G0623700 PROTEIN', 242752),
(333001, 'PTHR10426:SF96', NULL, NULL, NULL, NULL, 'STR_SYNTH DOMAIN-CONTAINING PROTEIN', 242752),
(333002, 'PTHR10426:SF93', NULL, NULL, NULL, NULL, 'PROTEIN STRICTOSIDINE SYNTHASE-LIKE 5-LIKE', 242752),
(333003, 'PTHR10426:SF110', NULL, NULL, NULL, NULL, 'STR_SYNTH DOMAIN-CONTAINING PROTEIN', 242752);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(333004, 'PTHR10426:SF111', NULL, NULL, NULL, NULL, 'PROTEIN STRICTOSIDINE SYNTHASE-LIKE 1', 242752),
(333005, 'PTHR10426:SF112', NULL, NULL, NULL, NULL, 'STR_SYNTH DOMAIN-CONTAINING PROTEIN', 242752),
(333006, 'PTHR10426:SF113', NULL, NULL, NULL, NULL, 'STR_SYNTH DOMAIN-CONTAINING PROTEIN', 242752),
(333007, 'PTHR10426:SF114', NULL, NULL, NULL, NULL, 'SGL DOMAIN-CONTAINING PROTEIN', 242752),
(333008, 'PTHR10426:SF117', NULL, NULL, NULL, NULL, 'STRICTOSIDINE SYNTHASE-RELATED', 242752),
(333009, 'PTHR10426:SF118', NULL, NULL, NULL, NULL, 'STR_SYNTH DOMAIN-CONTAINING PROTEIN', 242752),
(333010, 'PTHR10426', NULL, NULL, NULL, NULL, 'STRICTOSIDINE SYNTHASE-RELATED', 242752),
(333011, 'PTHR10426:SF119', NULL, NULL, NULL, NULL, 'PROTEIN STRICTOSIDINE SYNTHASE-LIKE 10-LIKE', 242752),
(333012, 'PTHR10426:SF88', NULL, NULL, NULL, NULL, 'ADIPOCYTE PLASMA MEMBRANE-ASSOCIATED PROTEIN', 242752),
(333013, 'PTHR10426:SF89', NULL, NULL, NULL, NULL, 'PROTEIN STRICTOSIDINE SYNTHASE-LIKE 11-LIKE', 242752),
(333014, 'PTHR10426:SF86', NULL, NULL, NULL, NULL, 'OS09G0374900 PROTEIN', 242752),
(333015, 'PTHR10426:SF62', NULL, NULL, NULL, NULL, 'OS08G0175000 PROTEIN', 242752),
(333016, 'PTHR10426:SF124', NULL, NULL, NULL, NULL, 'ADIPOCYTE PLASMA MEMBRANE-ASSOCIATED PROTEIN', 242752),
(333017, 'PTHR10426:SF126', NULL, NULL, NULL, NULL, 'STRICTOSIDINE SYNTHASE TRANSCRIPTION FACTOR WD40-LIKE FAMILY-RELATED', 242752),
(333018, 'PTHR10426:SF127', NULL, NULL, NULL, NULL, 'STR_SYNTH DOMAIN-CONTAINING PROTEIN', 242752),
(333019, 'PTHR10426:SF128', NULL, NULL, NULL, NULL, 'OS12G0138800 PROTEIN', 242752),
(333020, 'PTHR10426:SF129', NULL, NULL, NULL, NULL, 'OS01G0698200 PROTEIN', 242752),
(333021, 'PTHR10426:SF57', NULL, NULL, NULL, NULL, 'STRICTOSIDINE SYNTHASE', 242752),
(333022, 'PTHR10426:SF72', NULL, NULL, NULL, NULL, 'PROTEIN STRICTOSIDINE SYNTHASE-LIKE 8', 242752),
(333023, 'PTHR10426:SF130', NULL, NULL, NULL, NULL, 'ADIPOCYTE PLASMA MEMBRANE-ASSOCIATED PROTEIN', 242752),
(333024, 'PTHR10426:SF131', NULL, NULL, NULL, NULL, 'STR_SYNTH DOMAIN-CONTAINING PROTEIN', 242752),
(333025, 'PTHR10426:SF132', NULL, NULL, NULL, NULL, 'PROTEIN STRICTOSIDINE SYNTHASE-LIKE 12', 242752),
(333026, 'PTHR10426:SF133', NULL, NULL, NULL, NULL, 'STR_SYNTH DOMAIN-CONTAINING PROTEIN', 242752),
(333027, 'PTHR10426:SF134', NULL, NULL, NULL, NULL, 'PROTEIN STRICTOSIDINE SYNTHASE-LIKE 3-LIKE', 242752),
(333028, 'PTHR10426:SF135', NULL, NULL, NULL, NULL, '', 242752),
(333029, 'PTHR10426:SF136', NULL, NULL, NULL, NULL, 'STR_SYNTH DOMAIN-CONTAINING PROTEIN', 242752),
(333030, 'PTHR10426:SF67', NULL, NULL, NULL, NULL, 'PROTEIN STRICTOSIDINE SYNTHASE-LIKE 10-LIKE', 242752),
(333031, 'PTHR10426:SF20', NULL, NULL, NULL, NULL, 'ADIPOCYTE PLASMA MEMBRANE-ASSOCIATED PROTEIN', 242752),
(333032, 'PTHR10426:SF21', NULL, NULL, NULL, NULL, 'PROTEIN STRICTOSIDINE SYNTHASE-LIKE 13', 242752),
(333033, 'PTHR10426:SF68', NULL, NULL, NULL, NULL, 'OS07G0614000 PROTEIN', 242752),
(333034, 'PTHR10426:SF69', NULL, NULL, NULL, NULL, 'PROTEIN STRICTOSIDINE SYNTHASE-LIKE 10', 242752),
(333035, 'PTHR10426:SF85', NULL, NULL, NULL, NULL, 'STR_SYNTH DOMAIN-CONTAINING PROTEIN', 242752),
(333036, 'PTHR10426:SF82', NULL, NULL, NULL, NULL, 'PROTEIN STRICTOSIDINE SYNTHASE-LIKE 11', 242752),
(333037, 'PTHR10426:SF100', NULL, NULL, NULL, NULL, 'STR_SYNTH DOMAIN-CONTAINING PROTEIN', 242752),
(333038, 'PTHR10426:SF101', NULL, NULL, NULL, NULL, 'STR_SYNTH DOMAIN-CONTAINING PROTEIN', 242752),
(333039, 'PTHR10426:SF102', NULL, NULL, NULL, NULL, 'PROTEIN STRICTOSIDINE SYNTHASE-LIKE 11', 242752),
(333040, 'PTHR10426:SF105', NULL, NULL, NULL, NULL, 'STRICTOSIDINE SYNTHASE-RELATED', 242752),
(333041, 'PTHR10426:SF106', NULL, NULL, NULL, NULL, 'PROTEIN STRICTOSIDINE SYNTHASE-LIKE 3', 242752),
(333042, 'PTHR10426:SF108', NULL, NULL, NULL, NULL, 'STR_SYNTH DOMAIN-CONTAINING PROTEIN', 242752),
(333043, 'PTHR10426:SF109', NULL, NULL, NULL, NULL, 'SMP-30/GLUCONOLACONASE/LRE-LIKE REGION PROTEIN', 242752),
(333044, 'PTHR10426:SF31', NULL, NULL, NULL, NULL, 'STRICTOSIDINE SYNTHASE 3', 242752),
(333045, 'PTHR10426:SF76', NULL, NULL, NULL, NULL, 'STR_SYNTH DOMAIN-CONTAINING PROTEIN', 242752);
INSERT INTO "PUBLIC"."MODEL" VALUES
(333046, 'PTHR10426:SF79', NULL, NULL, NULL, NULL, 'PROTEIN STRICTOSIDINE SYNTHASE-LIKE 2', 242752),
(333047, 'PTHR39652', NULL, NULL, NULL, NULL, 'UPF0201 PROTEIN TK1335', 242753),
(333048, 'PTHR39652:SF1', NULL, NULL, NULL, NULL, 'UPF0201 PROTEIN TK1335', 242753),
(333049, 'PTHR31563:SF1', NULL, NULL, NULL, NULL, 'ION CHANNEL CASTOR-RELATED', 242754),
(333050, 'PTHR31563:SF16', NULL, NULL, NULL, NULL, 'BNAA09G42380D PROTEIN', 242754),
(333051, 'PTHR31563:SF13', NULL, NULL, NULL, NULL, 'ION CHANNEL POLLUX-LIKE 1-RELATED', 242754),
(333052, 'PTHR31563:SF15', NULL, NULL, NULL, NULL, 'ION CHANNEL DMI1-LIKE', 242754),
(333053, 'PTHR31563:SF10', NULL, NULL, NULL, NULL, 'ION CHANNEL POLLUX-RELATED', 242754),
(333054, 'PTHR31563', NULL, NULL, NULL, NULL, 'ION CHANNEL POLLUX-RELATED', 242754),
(333055, 'PTHR30217:SF7', NULL, NULL, NULL, NULL, 'TRNA HYDROXYLATION PROTEIN P2', 242755),
(333056, 'PTHR30217:SF6', NULL, NULL, NULL, NULL, 'TRNA HYDROXYLATION PROTEIN P', 242755),
(333057, 'PTHR30217:SF3', NULL, NULL, NULL, NULL, 'UBIQUINONE BIOSYNTHESIS PROTEIN UBIU', 242755),
(333058, 'PTHR30217:SF10', NULL, NULL, NULL, NULL, '23S RRNA 5-HYDROXYCYTIDINE C2501 SYNTHASE', 242755),
(333059, 'PTHR30217', NULL, NULL, NULL, NULL, 'PEPTIDASE U32 FAMILY', 242755),
(333060, 'PTHR30217:SF11', NULL, NULL, NULL, NULL, 'UBIQUINONE BIOSYNTHESIS PROTEIN UBIV', 242755),
(333061, 'PTHR30217:SF12', NULL, NULL, NULL, NULL, 'LMO0960 PROTEIN', 242755),
(333062, 'PTHR47093', NULL, NULL, NULL, NULL, 'PROTEIN JSN1-RELATED', 242756),
(333063, 'PTHR47093:SF1', NULL, NULL, NULL, NULL, 'PROTEIN JSN1-RELATED', 242756),
(333064, 'PTHR47093:SF3', NULL, NULL, NULL, NULL, '', 242756),
(333065, 'PTHR47093:SF2', NULL, NULL, NULL, NULL, 'PUMILIO DOMAIN-CONTAINING PROTEIN P35G2.14', 242756),
(333066, 'PTHR12459:SF22', NULL, NULL, NULL, NULL, '', 242757),
(333067, 'PTHR12459:SF23', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_2G12300)', 242757),
(333068, 'PTHR12459:SF24', NULL, NULL, NULL, NULL, 'TMEM135_C_RICH DOMAIN-CONTAINING PROTEIN', 242757),
(333069, 'PTHR12459', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 242757),
(333070, 'PTHR12459:SF20', NULL, NULL, NULL, NULL, 'TMEM135_C_RICH DOMAIN-CONTAINING PROTEIN', 242757),
(333071, 'PTHR12459:SF19', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 242757),
(333072, 'PTHR12459:SF15', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242757),
(333073, 'PTHR12459:SF6', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 135', 242757),
(333074, 'PTHR46331', NULL, NULL, NULL, NULL, 'VALACYCLOVIR HYDROLASE', 242758),
(333075, 'PTHR46331:SF2', NULL, NULL, NULL, NULL, 'VALACYCLOVIR HYDROLASE', 242758),
(333076, 'PTHR35728', NULL, NULL, NULL, NULL, 'MICROTUBULE-BINDING PROTEIN TANGLED-RELATED', 242759),
(333077, 'PTHR35728:SF2', NULL, NULL, NULL, NULL, 'BNAA05G31850D PROTEIN', 242759),
(333078, 'PTHR35728:SF1', NULL, NULL, NULL, NULL, 'MICROTUBULE-BINDING PROTEIN TANGLED-RELATED', 242759),
(333079, 'PTHR43026:SF1', NULL, NULL, NULL, NULL, '2-HYDROXYACID DEHYDROGENASE HOMOLOG 1-RELATED', 242760),
(333080, 'PTHR43026', NULL, NULL, NULL, NULL, '2-HYDROXYACID DEHYDROGENASE HOMOLOG 1-RELATED', 242760),
(333081, 'PTHR31972:SF75', NULL, NULL, NULL, NULL, '', 242761),
(333082, 'PTHR31972:SF52', NULL, NULL, NULL, NULL, '', 242761),
(333083, 'PTHR31972:SF74', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242761),
(333084, 'PTHR31972:SF51', NULL, NULL, NULL, NULL, '', 242761),
(333085, 'PTHR31972:SF79', NULL, NULL, NULL, NULL, 'DUF868 FAMILY PROTEIN', 242761),
(333086, 'PTHR31972:SF57', NULL, NULL, NULL, NULL, 'BNAA02G30050D PROTEIN', 242761),
(333087, 'PTHR31972:SF78', NULL, NULL, NULL, NULL, 'DUF868 FAMILY PROTEIN', 242761),
(333088, 'PTHR31972:SF12', NULL, NULL, NULL, NULL, 'OS01G0909400 PROTEIN', 242761),
(333089, 'PTHR31972:SF11', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 242761),
(333090, 'PTHR31972:SF77', NULL, NULL, NULL, NULL, '', 242761),
(333091, 'PTHR31972:SF76', NULL, NULL, NULL, NULL, 'OS08G0439600 PROTEIN', 242761),
(333092, 'PTHR31972:SF54', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN (DUF868)', 242761);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(333093, 'PTHR31972:SF39', NULL, NULL, NULL, NULL, '', 242761),
(333094, 'PTHR31972:SF16', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE (DUF868)-RELATED', 242761),
(333095, 'PTHR31972:SF38', NULL, NULL, NULL, NULL, 'OS12G0149000 PROTEIN', 242761),
(333096, 'PTHR31972:SF15', NULL, NULL, NULL, NULL, 'OS07G0572300 PROTEIN', 242761),
(333097, 'PTHR31972:SF59', NULL, NULL, NULL, NULL, 'BNAC01G39880D PROTEIN', 242761),
(333098, 'PTHR31972:SF58', NULL, NULL, NULL, NULL, '', 242761),
(333099, 'PTHR31972:SF60', NULL, NULL, NULL, NULL, '', 242761),
(333100, 'PTHR31972:SF82', NULL, NULL, NULL, NULL, '', 242761),
(333101, 'PTHR31972:SF81', NULL, NULL, NULL, NULL, '', 242761),
(333102, 'PTHR31972:SF80', NULL, NULL, NULL, NULL, 'DUF868 FAMILY PROTEIN', 242761),
(333103, 'PTHR31972:SF62', NULL, NULL, NULL, NULL, '', 242761),
(333104, 'PTHR31972:SF83', NULL, NULL, NULL, NULL, '', 242761),
(333105, 'PTHR31972:SF46', NULL, NULL, NULL, NULL, 'DUF868 FAMILY PROTEIN (DUF868)', 242761),
(333106, 'PTHR31972:SF3', NULL, NULL, NULL, NULL, 'OS09G0416600 PROTEIN', 242761),
(333107, 'PTHR31972:SF4', NULL, NULL, NULL, NULL, 'PLANT/T24G3-80 PROTEIN', 242761),
(333108, 'PTHR31972:SF45', NULL, NULL, NULL, NULL, 'BNAC05G52260D PROTEIN', 242761),
(333109, 'PTHR31972:SF66', NULL, NULL, NULL, NULL, 'BNACNNG20030D PROTEIN', 242761),
(333110, 'PTHR31972:SF2', NULL, NULL, NULL, NULL, 'DUF868 FAMILY PROTEIN (DUF868)', 242761),
(333111, 'PTHR31972:SF65', NULL, NULL, NULL, NULL, '', 242761),
(333112, 'PTHR31972:SF49', NULL, NULL, NULL, NULL, 'PLANT/T24G3-80 PROTEIN', 242761),
(333113, 'PTHR31972:SF48', NULL, NULL, NULL, NULL, 'DUF868 FAMILY PROTEIN', 242761),
(333114, 'PTHR31972', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242761),
(333115, 'PTHR31972:SF8', NULL, NULL, NULL, NULL, 'OS06G0181800 PROTEIN', 242761),
(333116, 'PTHR31972:SF6', NULL, NULL, NULL, NULL, 'SULFATE/THIOSULFATE IMPORT ATP-BINDING PROTEIN CYSA', 242761),
(333117, 'PTHR31972:SF71', NULL, NULL, NULL, NULL, 'BNAA09G51660D PROTEIN', 242761),
(333118, 'PTHR31972:SF70', NULL, NULL, NULL, NULL, 'BNAA09G02900D PROTEIN', 242761),
(333119, 'PTHR31972:SF9', NULL, NULL, NULL, NULL, 'OS05G0108400 PROTEIN', 242761),
(333120, 'PTHR43343:SF3', NULL, NULL, NULL, NULL, 'PROTEASE DO-LIKE 8, CHLOROPLASTIC', 242762),
(333121, 'PTHR43343:SF2', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN', 242762),
(333122, 'PTHR43343:SF7', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN', 242762),
(333123, 'PTHR43343:SF6', NULL, NULL, NULL, NULL, 'PROTEASE DO-LIKE 5, CHLOROPLASTIC ISOFORM X1', 242762),
(333124, 'PTHR43343', NULL, NULL, NULL, NULL, 'PEPTIDASE S12', 242762),
(333125, 'PTHR46340', NULL, NULL, NULL, NULL, 'UBX DOMAIN-CONTAINING PROTEIN 1', 242763),
(333126, 'PTHR46340:SF1', NULL, NULL, NULL, NULL, 'UBX DOMAIN-CONTAINING PROTEIN 1', 242763),
(333127, 'PTHR21411:SF0', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN ZESTE', 242764),
(333128, 'PTHR21411', NULL, NULL, NULL, NULL, 'APONTIC', 242764),
(333129, 'PTHR21312:SF28', NULL, NULL, NULL, NULL, 'KAZAL-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 242765),
(333130, 'PTHR21312:SF36', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR KAZAL-TYPE 13', 242765),
(333131, 'PTHR21312:SF27', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR KAZAL-TYPE 1', 242765),
(333132, 'PTHR21312:SF37', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR KAZAL-TYPE 8', 242765),
(333133, 'PTHR21312:SF34', NULL, NULL, NULL, NULL, 'DOUBLE-HEADED PROTEASE INHIBITOR, SUBMANDIBULAR GLAND', 242765),
(333134, 'PTHR21312:SF33', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR KAZAL-TYPE 11-RELATED', 242765),
(333135, 'PTHR21312', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR', 242765),
(333136, 'PTHR21312:SF30', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR KAZAL-TYPE 10', 242765),
(333137, 'PTHR36936', NULL, NULL, NULL, NULL, 'PROTEIN CBG25168', 242766),
(333138, 'PTHR36936:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG25168', 242766),
(333139, 'PTHR42083', NULL, NULL, NULL, NULL, 'MARVEL DOMAIN-CONTAINING PROTEIN', 242767),
(333140, 'PTHR42083:SF1', NULL, NULL, NULL, NULL, 'MARVEL DOMAIN-CONTAINING PROTEIN', 242767);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(333141, 'PTHR13006:SF10', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 395B', 242768),
(333142, 'PTHR13006:SF9', NULL, NULL, NULL, NULL, 'GLUCOSE TRANSPORTER 4 ENHANCER FACTOR, ISOFORM G', 242768),
(333143, 'PTHR13006:SF7', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 704', 242768),
(333144, 'PTHR13006:SF8', NULL, NULL, NULL, NULL, 'SLC2A4 REGULATOR', 242768),
(333145, 'PTHR13006', NULL, NULL, NULL, NULL, 'PAPILLOMAVIRUS REGULATORY FACTOR PRF-1', 242768),
(333146, 'PTHR13006:SF6', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 395', 242768),
(333147, 'PTHR40080', NULL, NULL, NULL, NULL, 'LMO1763 PROTEIN', 242769),
(333148, 'PTHR40080:SF1', NULL, NULL, NULL, NULL, 'LMO1763 PROTEIN', 242769),
(333149, 'PTHR19863:SF5', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 47', 242770),
(333150, 'PTHR19863:SF10', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 47-LIKE PROTEIN', 242770),
(333151, 'PTHR19863', NULL, NULL, NULL, NULL, 'NEMITIN (NEURONAL ENRICHED MAP INTERACTING PROTEIN) HOMOLOG', 242770),
(333152, 'PTHR39475', NULL, NULL, NULL, NULL, '', 242771),
(333153, 'PTHR39475:SF1', NULL, NULL, NULL, NULL, '', 242771),
(333154, 'PTHR36886:SF10', NULL, NULL, NULL, NULL, 'PROTEIN FRIGIDA-ESSENTIAL 1-LIKE ISOFORM X1', 242772),
(333155, 'PTHR36886:SF9', NULL, NULL, NULL, NULL, '', 242772),
(333156, 'PTHR36886:SF8', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 38', 242772),
(333157, 'PTHR36886:SF7', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242772),
(333158, 'PTHR36886:SF11', NULL, NULL, NULL, NULL, 'C3H1-TYPE DOMAIN-CONTAINING PROTEIN', 242772),
(333159, 'PTHR36886:SF12', NULL, NULL, NULL, NULL, 'C3H1-TYPE DOMAIN-CONTAINING PROTEIN', 242772),
(333160, 'PTHR36886:SF3', NULL, NULL, NULL, NULL, 'PROTEIN FRIGIDA-ESSENTIAL 1', 242772),
(333161, 'PTHR36886', NULL, NULL, NULL, NULL, 'PROTEIN FRIGIDA-ESSENTIAL 1', 242772),
(333162, 'PTHR23030:SF39', NULL, NULL, NULL, NULL, 'PROGRAMMED CELL DEATH 6-INTERACTING PROTEIN', 242773),
(333163, 'PTHR23030', NULL, NULL, NULL, NULL, 'PCD6 INTERACTING PROTEIN-RELATED', 242773),
(333164, 'PTHR23030:SF34', NULL, NULL, NULL, NULL, 'PROGRAMMED CELL DEATH 6-INTERACTING PROTEIN-LIKE', 242773),
(333165, 'PTHR23030:SF32', NULL, NULL, NULL, NULL, 'BRO1 DOMAIN-CONTAINING PROTEIN', 242773),
(333166, 'PTHR23030:SF43', NULL, NULL, NULL, NULL, 'BRO1 DOMAIN-CONTAINING PROTEIN', 242773),
(333167, 'PTHR23030:SF44', NULL, NULL, NULL, NULL, 'BRO1 DOMAIN-CONTAINING PROTEIN', 242773),
(333168, 'PTHR23030:SF33', NULL, NULL, NULL, NULL, 'OS02G0638400 PROTEIN', 242773),
(333169, 'PTHR23030:SF30', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE NON-RECEPTOR TYPE 23', 242773),
(333170, 'PTHR23030:SF42', NULL, NULL, NULL, NULL, '', 242773),
(333171, 'PTHR31674:SF25', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 242774),
(333172, 'PTHR31674:SF47', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS10G0323000', 242774),
(333173, 'PTHR31674:SF68', NULL, NULL, NULL, NULL, 'BNAA04G14580D PROTEIN', 242774),
(333174, 'PTHR31674:SF24', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 242774),
(333175, 'PTHR31674:SF27', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 242774),
(333176, 'PTHR31674:SF28', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 242774),
(333177, 'PTHR31674:SF61', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS01G0905400', 242774),
(333178, 'PTHR31674:SF83', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN REM10-LIKE', 242774),
(333179, 'PTHR31674:SF82', NULL, NULL, NULL, NULL, 'BNAA08G12400D PROTEIN', 242774),
(333180, 'PTHR31674:SF85', NULL, NULL, NULL, NULL, 'DNA-BINDING PSEUDOBARREL DOMAIN-CONTAINING PROTEIN-RELATED', 242774),
(333181, 'PTHR31674:SF41', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN REM-LIKE 1-RELATED', 242774),
(333182, 'PTHR31674:SF62', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN REM10-RELATED', 242774),
(333183, 'PTHR31674:SF40', NULL, NULL, NULL, NULL, 'BNAA05G27900D PROTEIN', 242774),
(333184, 'PTHR31674:SF84', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN REM17-LIKE', 242774);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(333185, 'PTHR31674:SF21', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN REM8-LIKE', 242774),
(333186, 'PTHR31674:SF87', NULL, NULL, NULL, NULL, '', 242774),
(333187, 'PTHR31674:SF64', NULL, NULL, NULL, NULL, 'BNAC07G12370D PROTEIN', 242774),
(333188, 'PTHR31674:SF20', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN REM2-RELATED', 242774),
(333189, 'PTHR31674:SF86', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 242774),
(333190, 'PTHR31674:SF42', NULL, NULL, NULL, NULL, 'BNAC03G67480D PROTEIN', 242774),
(333191, 'PTHR31674:SF67', NULL, NULL, NULL, NULL, 'BNAA09G41270D PROTEIN', 242774),
(333192, 'PTHR31674:SF89', NULL, NULL, NULL, NULL, 'BNAA10G28180D PROTEIN', 242774),
(333193, 'PTHR31674:SF22', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN REM17', 242774),
(333194, 'PTHR31674:SF66', NULL, NULL, NULL, NULL, 'BNAA04G14550D PROTEIN', 242774),
(333195, 'PTHR31674:SF88', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 242774),
(333196, 'PTHR31674:SF90', NULL, NULL, NULL, NULL, 'BNAC03G26790D PROTEIN', 242774),
(333197, 'PTHR31674:SF70', NULL, NULL, NULL, NULL, 'BNAA05G27890D PROTEIN', 242774),
(333198, 'PTHR31674:SF92', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS06G0632500-RELATED', 242774),
(333199, 'PTHR31674:SF91', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN REM10-LIKE', 242774),
(333200, 'PTHR31674:SF36', NULL, NULL, NULL, NULL, '', 242774),
(333201, 'PTHR31674:SF38', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN REM1', 242774),
(333202, 'PTHR31674:SF59', NULL, NULL, NULL, NULL, 'BNAA05G17050D PROTEIN', 242774),
(333203, 'PTHR31674:SF18', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN REM4-RELATED', 242774),
(333204, 'PTHR31674:SF94', NULL, NULL, NULL, NULL, '', 242774),
(333205, 'PTHR31674:SF72', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN REM17-LIKE', 242774),
(333206, 'PTHR31674:SF93', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN REM13', 242774),
(333207, 'PTHR31674:SF52', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN REM15-RELATED', 242774),
(333208, 'PTHR31674:SF74', NULL, NULL, NULL, NULL, 'BNAC03G17610D PROTEIN', 242774),
(333209, 'PTHR31674:SF51', NULL, NULL, NULL, NULL, '', 242774),
(333210, 'PTHR31674:SF53', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN REM14-RELATED', 242774),
(333211, 'PTHR31674:SF31', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 242774),
(333212, 'PTHR31674:SF75', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 242774),
(333213, 'PTHR31674:SF56', NULL, NULL, NULL, NULL, 'BNAA01G34830D PROTEIN', 242774),
(333214, 'PTHR31674:SF78', NULL, NULL, NULL, NULL, 'DNA BINDING PROTEIN', 242774),
(333215, 'PTHR31674:SF77', NULL, NULL, NULL, NULL, 'DNA-BINDING PSEUDOBARREL DOMAIN-CONTAINING PROTEIN-RELATED', 242774),
(333216, 'PTHR31674:SF55', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN REM-LIKE 3', 242774),
(333217, 'PTHR31674:SF81', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS04G0347400-RELATED', 242774),
(333218, 'PTHR31674', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN REM-LIKE 3-RELATED', 242774),
(333219, 'PTHR15466', NULL, NULL, NULL, NULL, 'V-SET AND IMMUNOGLOBULIN DOMAIN CONTAINING 4', 242775),
(333220, 'PTHR15466:SF2', NULL, NULL, NULL, NULL, 'V-SET AND IMMUNOGLOBULIN DOMAIN-CONTAINING PROTEIN 4', 242775),
(333221, 'PTHR11570:SF20', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE DECARBOXYLASE PROENZYME', 242776),
(333222, 'PTHR11570:SF31', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE DECARBOXYLASE PROENZYME', 242776),
(333223, 'PTHR11570:SF2', NULL, NULL, NULL, NULL, 'DECARBOXYLASE PROENZYME-LIKE, PUTATIVE-RELATED', 242776),
(333224, 'PTHR11570:SF3', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE DECARBOXYLASE PROENZYME', 242776),
(333225, 'PTHR11570:SF23', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE DECARBOXYLASE PROENZYME', 242776),
(333226, 'PTHR11570:SF34', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE DECARBOXYLASE PROENZYME 1', 242776),
(333227, 'PTHR11570:SF24', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE DECARBOXYLASE PROENZYME', 242776);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(333228, 'PTHR11570:SF35', NULL, NULL, NULL, NULL, 'ADENOSYLMETHIONINE DECARBOXYLASE', 242776),
(333229, 'PTHR11570:SF32', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE DECARBOXYLASE PROENZYME 2', 242776),
(333230, 'PTHR11570:SF21', NULL, NULL, NULL, NULL, 'ADENOSYLMETHIONINE DECARBOXYLASE', 242776),
(333231, 'PTHR11570:SF33', NULL, NULL, NULL, NULL, 'ADENOSYLMETHIONINE DECARBOXYLASE', 242776),
(333232, 'PTHR11570:SF0', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE DECARBOXYLASE PROENZYME', 242776),
(333233, 'PTHR11570:SF27', NULL, NULL, NULL, NULL, 'BNAC01G34670D PROTEIN', 242776),
(333234, 'PTHR11570:SF36', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE DECARBOXYLASE ALPHA CHAIN', 242776),
(333235, 'PTHR11570:SF37', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE DECARBOXYLASE PROENZYME', 242776),
(333236, 'PTHR11570:SF15', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE DECARBOXYLASE PROENZYME 3', 242776),
(333237, 'PTHR11570:SF19', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE DECARBOXYLASE PROENZYME', 242776),
(333238, 'PTHR11570', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE DECARBOXYLASE', 242776),
(333239, 'PTHR43134:SF1', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE RECEPTOR SUBUNIT ALPHA', 242777),
(333240, 'PTHR43134:SF3', NULL, NULL, NULL, NULL, 'FLAGELLAR BIOSYNTHESIS PROTEIN FLHF', 242777),
(333241, 'PTHR43134:SF6', NULL, NULL, NULL, NULL, 'SRP54 DOMAIN-CONTAINING PROTEIN', 242777),
(333242, 'PTHR43134:SF7', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN FTSY HOMOLOG, CHLOROPLASTIC', 242777),
(333243, 'PTHR43134:SF8', NULL, NULL, NULL, NULL, 'SRP54 DOMAIN-CONTAINING PROTEIN', 242777),
(333244, 'PTHR43134:SF10', NULL, NULL, NULL, NULL, 'SRP54 DOMAIN-CONTAINING PROTEIN', 242777),
(333245, 'PTHR43134', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE RECEPTOR SUBUNIT ALPHA', 242777),
(333246, 'PTHR43085:SF15', NULL, NULL, NULL, NULL, '2-DEHYDRO-3-DEOXYGLUCONOKINASE', 242778),
(333247, 'PTHR43085:SF37', NULL, NULL, NULL, NULL, 'GUANOSINE-INOSINE KINASE', 242778),
(333248, 'PTHR43085:SF18', NULL, NULL, NULL, NULL, 'PFKB FAMILY CARBOHYDRATE KINASE', 242778),
(333249, 'PTHR43085:SF6', NULL, NULL, NULL, NULL, 'FRUCTOKINASE-5-RELATED', 242778),
(333250, 'PTHR43085:SF7', NULL, NULL, NULL, NULL, 'FRUCTOKINASE-7-RELATED', 242778),
(333251, 'PTHR43085:SF51', NULL, NULL, NULL, NULL, 'PSEUDOURIDINE KINASE-LIKE', 242778),
(333252, 'PTHR43085:SF52', NULL, NULL, NULL, NULL, 'FRUCTOKINASE', 242778),
(333253, 'PTHR43085:SF30', NULL, NULL, NULL, NULL, 'PFKB FAMILY CARBOHYDRATE KINASE', 242778),
(333254, 'PTHR43085:SF53', NULL, NULL, NULL, NULL, 'PFKB DOMAIN-CONTAINING PROTEIN', 242778),
(333255, 'PTHR43085:SF1', NULL, NULL, NULL, NULL, 'PFKB DOMAIN-CONTAINING PROTEIN', 242778),
(333256, 'PTHR43085:SF54', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 242778),
(333257, 'PTHR43085:SF10', NULL, NULL, NULL, NULL, 'FRUCTOKINASE-LIKE 1, CHLOROPLASTIC', 242778),
(333258, 'PTHR43085:SF33', NULL, NULL, NULL, NULL, 'PFKB DOMAIN-CONTAINING PROTEIN', 242778),
(333259, 'PTHR43085:SF55', NULL, NULL, NULL, NULL, 'KETOHEXOKINASE', 242778),
(333260, 'PTHR43085:SF2', NULL, NULL, NULL, NULL, 'FRUCTOKINASE-LIKE 2, CHLOROPLASTIC', 242778),
(333261, 'PTHR43085:SF56', NULL, NULL, NULL, NULL, 'PFKB DOMAIN-CONTAINING PROTEIN', 242778),
(333262, 'PTHR43085:SF34', NULL, NULL, NULL, NULL, 'PFKB DOMAIN-CONTAINING PROTEIN', 242778),
(333263, 'PTHR43085:SF13', NULL, NULL, NULL, NULL, 'INOSITOL 3-KINASE', 242778),
(333264, 'PTHR43085:SF47', NULL, NULL, NULL, NULL, 'FRUCTOKINASE-2-RELATED', 242778),
(333265, 'PTHR43085:SF27', NULL, NULL, NULL, NULL, 'CYTIDINE KINASE', 242778),
(333266, 'PTHR43085:SF49', NULL, NULL, NULL, NULL, '5-DEHYDRO-2-DEOXYGLUCONOKINASE', 242778),
(333267, 'PTHR43085', NULL, NULL, NULL, NULL, 'HEXOKINASE FAMILY MEMBER', 242778),
(333268, 'PTHR43085:SF40', NULL, NULL, NULL, NULL, 'SMR DOMAIN-CONTAINING PROTEIN', 242778),
(333269, 'PTHR43085:SF41', NULL, NULL, NULL, NULL, 'FRUCTOSELYSINE 6-KINASE', 242778),
(333270, 'PTHR43085:SF21', NULL, NULL, NULL, NULL, 'FRUCTOKINASE-1-RELATED', 242778),
(333271, 'PTHR43085:SF22', NULL, NULL, NULL, NULL, 'FRUCTOKINASE', 242778);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(333272, 'PTHR43085:SF24', NULL, NULL, NULL, NULL, 'FRUCTOKINASE-4-RELATED', 242778),
(333273, 'PTHR43085:SF46', NULL, NULL, NULL, NULL, 'ADENOSINE KINASE', 242778),
(333274, 'PTHR47531:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C2H2 FAMILY-RELATED', 242779),
(333275, 'PTHR47531', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 242779),
(333276, 'PTHR47531:SF2', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 242779),
(333277, 'PTHR34917:SF1', NULL, NULL, NULL, NULL, 'RBPJ-INTERACTING AND TUBULIN-ASSOCIATED PROTEIN 1', 242780),
(333278, 'PTHR34917', NULL, NULL, NULL, NULL, 'RBPJ-INTERACTING AND TUBULIN-ASSOCIATED PROTEIN 1', 242780),
(333279, 'PTHR45842:SF16', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEATS AND IMMUNOGLOBULIN-LIKE DOMAINS 3', 242781),
(333280, 'PTHR45842:SF4', NULL, NULL, NULL, NULL, 'MATRIX-REMODELING-ASSOCIATED PROTEIN 5', 242781),
(333281, 'PTHR45842:SF5', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND FIBRONECTIN TYPE-III DOMAIN-CONTAINING PROTEIN 3', 242781),
(333282, 'PTHR45842:SF2', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN SUPERFAMILY MEMBER 10', 242781),
(333283, 'PTHR45842:SF14', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT, IMMUNOGLOBULIN-LIKE DOMAIN AND TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN 2', 242781),
(333284, 'PTHR45842:SF3', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND FIBRONECTIN TYPE-III DOMAIN-CONTAINING PROTEIN 4', 242781),
(333285, 'PTHR45842:SF18', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND FIBRONECTIN TYPE III DOMAIN-CONTAINING PROTEIN 1', 242781),
(333286, 'PTHR45842:SF12', NULL, NULL, NULL, NULL, 'KEKKON 5, ISOFORM A', 242781),
(333287, 'PTHR45842:SF10', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND FIBRONECTIN TYPE-III DOMAIN-CONTAINING PROTEIN 5', 242781),
(333288, 'PTHR45842', NULL, NULL, NULL, NULL, 'SYNAPTIC ADHESION-LIKE MOLECULE SALM', 242781),
(333289, 'PTHR45842:SF8', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT, IMMUNOGLOBULIN-LIKE DOMAIN AND TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN 3', 242781),
(333290, 'PTHR45842:SF9', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT, IMMUNOGLOBULIN-LIKE DOMAIN AND TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN 1', 242781),
(333291, 'PTHR45842:SF6', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND FIBRONECTIN TYPE-III DOMAIN-CONTAINING PROTEIN 2', 242781),
(333292, 'PTHR45842:SF7', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND FIBRONECTIN TYPE III DOMAIN-CONTAINING PROTEIN 1', 242781),
(333293, 'PTHR47152', NULL, NULL, NULL, NULL, 'SLR2084 PROTEIN-RELATED', 242782),
(333294, 'PTHR47152:SF2', NULL, NULL, NULL, NULL, 'SLR2084 PROTEIN', 242782),
(333295, 'PTHR47152:SF3', NULL, NULL, NULL, NULL, 'SLR1613 PROTEIN', 242782),
(333296, 'PTHR47152:SF1', NULL, NULL, NULL, NULL, 'SLL1186 PROTEIN', 242782),
(333297, 'PTHR47152:SF4', NULL, NULL, NULL, NULL, 'SLR0445 PROTEIN', 242782),
(333298, 'PTHR15332:SF175', NULL, NULL, NULL, NULL, 'MATRIX PROTEIN, PUTATIVE-RELATED', 242783),
(333299, 'PTHR15332', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 242783),
(333300, 'PTHR14074', NULL, NULL, NULL, NULL, 'HELICASE WITH DEATH DOMAIN-RELATED', 242784),
(333301, 'PTHR14074:SF29', NULL, NULL, NULL, NULL, 'DICER-RELATED HELICASE', 242784),
(333302, 'PTHR14074:SF37', NULL, NULL, NULL, NULL, 'RNA HELICASE', 242784),
(333303, 'PTHR14074:SF36', NULL, NULL, NULL, NULL, 'RNA HELICASE', 242784),
(333304, 'PTHR14074:SF14', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED HELICASE C DOMAIN-CONTAINING PROTEIN 1', 242784),
(333305, 'PTHR14074:SF39', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA GROUP M PROTEIN', 242784),
(333306, 'PTHR14074:SF16', NULL, NULL, NULL, NULL, 'ANTIVIRAL INNATE IMMUNE RESPONSE RECEPTOR RIG-I', 242784),
(333307, 'PTHR14074:SF7', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DHX58-RELATED', 242784),
(333308, 'PTHR11250:SF0', NULL, NULL, NULL, NULL, 'C-TERMINAL-FLANKING PEPTIDE', 242785),
(333309, 'PTHR11250', NULL, NULL, NULL, NULL, 'TACHYKININ', 242785),
(333310, 'PTHR11250:SF2', NULL, NULL, NULL, NULL, 'TACHYKININ-4', 242785),
(333311, 'PTHR11250:SF3', NULL, NULL, NULL, NULL, 'PROTACHYKININ-1', 242785);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(333312, 'PTHR11250:SF4', NULL, NULL, NULL, NULL, 'C-TERMINAL-FLANKING PEPTIDE', 242785),
(333313, 'PTHR11250:SF5', NULL, NULL, NULL, NULL, 'SI:CH211-131K2.2-RELATED', 242785),
(333314, 'PTHR32198:SF2', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ESCAPE PROTEIN 2', 242786),
(333315, 'PTHR32198:SF3', NULL, NULL, NULL, NULL, 'RNA12 DOMAIN-CONTAINING PROTEIN', 242786),
(333316, 'PTHR32198', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ESCAPE PROTEIN 2', 242786),
(333317, 'PTHR31925:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 251', 242787),
(333318, 'PTHR31925', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 251', 242787),
(333319, 'PTHR35575:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG23599', 242788),
(333320, 'PTHR35575', NULL, NULL, NULL, NULL, 'PROTEIN CBG23599-RELATED', 242788),
(333321, 'PTHR35575:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG23597', 242788),
(333322, 'PTHR36860', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 35', 242789),
(333323, 'PTHR36860:SF1', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 35', 242789),
(333324, 'PTHR35469:SF5', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 242790),
(333325, 'PTHR35469:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 242790),
(333326, 'PTHR35469', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 242790),
(333327, 'PTHR35469:SF6', NULL, NULL, NULL, NULL, '', 242790),
(333328, 'PTHR46423:SF1', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II-ASSOCIATED PROTEIN 3', 242791),
(333329, 'PTHR46423:SF4', NULL, NULL, NULL, NULL, 'OUTER ENVELOPE PROTEIN 61', 242791),
(333330, 'PTHR46423', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II-ASSOCIATED PROTEIN 3', 242791),
(333331, 'PTHR36683:SF1', NULL, NULL, NULL, NULL, 'CELL CYCLE EXIT AND NEURONAL DIFFERENTIATION PROTEIN 1', 242792),
(333332, 'PTHR36683:SF2', NULL, NULL, NULL, NULL, '', 242792),
(333333, 'PTHR36683', NULL, NULL, NULL, NULL, 'CELL CYCLE EXIT AND NEURONAL DIFFERENTIATION PROTEIN 1', 242792),
(333334, 'PTHR30335', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN OF SOXR-REDUCING COMPLEX', 242793),
(333335, 'PTHR30335:SF1', NULL, NULL, NULL, NULL, 'NA(+)-TRANSLOCATING NADH-QUINONE REDUCTASE SUBUNIT E', 242793),
(333336, 'PTHR30335:SF0', NULL, NULL, NULL, NULL, 'ION-TRANSLOCATING OXIDOREDUCTASE COMPLEX SUBUNIT A', 242793),
(333337, 'PTHR34385:SF1', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN L-ALANYL-D-GLUTAMATE ENDOPEPTIDASE CWLK', 242794),
(333338, 'PTHR34385', NULL, NULL, NULL, NULL, 'D-ALANYL-D-ALANINE CARBOXYPEPTIDASE', 242794),
(333339, 'PTHR42093', NULL, NULL, NULL, NULL, '', 242795),
(333340, 'PTHR42093:SF1', NULL, NULL, NULL, NULL, '', 242795),
(333341, 'PTHR13966:SF5', NULL, NULL, NULL, NULL, 'ENDONUCLEASE G, MITOCHONDRIAL', 242796),
(333342, 'PTHR13966', NULL, NULL, NULL, NULL, 'ENDONUCLEASE RELATED', 242796),
(333343, 'PTHR13966:SF19', NULL, NULL, NULL, NULL, 'NUCLEASE EXOG, MITOCHONDRIAL', 242796),
(333344, 'PTHR13966:SF17', NULL, NULL, NULL, NULL, 'ENDONUCLEASE-RELATED', 242796),
(333345, 'PTHR10026:SF147', NULL, NULL, NULL, NULL, 'CYCLIN-C1-2-LIKE', 242797),
(333346, 'PTHR10026:SF148', NULL, NULL, NULL, NULL, 'CYCLIN-C1-1', 242797),
(333347, 'PTHR10026:SF124', NULL, NULL, NULL, NULL, 'CYCLIN-T1-3', 242797),
(333348, 'PTHR10026:SF121', NULL, NULL, NULL, NULL, 'CYCLIN-T1-2', 242797),
(333349, 'PTHR10026:SF143', NULL, NULL, NULL, NULL, '', 242797),
(333350, 'PTHR10026:SF122', NULL, NULL, NULL, NULL, '', 242797),
(333351, 'PTHR10026:SF144', NULL, NULL, NULL, NULL, 'CYCLIN-K', 242797),
(333352, 'PTHR10026:SF70', NULL, NULL, NULL, NULL, 'CYCLIN-Q', 242797),
(333353, 'PTHR10026:SF7', NULL, NULL, NULL, NULL, 'CYCLIN-C', 242797),
(333354, 'PTHR10026:SF8', NULL, NULL, NULL, NULL, 'CYCLIN-H', 242797),
(333355, 'PTHR10026:SF67', NULL, NULL, NULL, NULL, 'CYCLIN DOMAIN-CONTAINING PROTEIN', 242797),
(333356, 'PTHR10026:SF45', NULL, NULL, NULL, NULL, 'CYCLIN-L2', 242797),
(333357, 'PTHR10026:SF42', NULL, NULL, NULL, NULL, 'CYCLIN-T1', 242797),
(333358, 'PTHR10026:SF64', NULL, NULL, NULL, NULL, 'CYCLIN-L1', 242797),
(333359, 'PTHR10026:SF43', NULL, NULL, NULL, NULL, 'CYCLIN-T2', 242797),
(333360, 'PTHR10026:SF62', NULL, NULL, NULL, NULL, 'PROTEIN TEX24', 242797); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(333361, 'PTHR10026:SF61', NULL, NULL, NULL, NULL, 'CYCLIN-T1.2', 242797),
(333362, 'PTHR10026', NULL, NULL, NULL, NULL, 'CYCLIN', 242797),
(333363, 'PTHR10026:SF149', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 242797),
(333364, 'PTHR10026:SF127', NULL, NULL, NULL, NULL, 'CYCLIN-T1-5', 242797),
(333365, 'PTHR10026:SF128', NULL, NULL, NULL, NULL, 'CYCLIN DOMAIN-CONTAINING PROTEIN', 242797),
(333366, 'PTHR10026:SF136', NULL, NULL, NULL, NULL, 'BNAC03G58020D PROTEIN', 242797),
(333367, 'PTHR10026:SF112', NULL, NULL, NULL, NULL, 'CTD KINASE SUBUNIT BETA', 242797),
(333368, 'PTHR10026:SF135', NULL, NULL, NULL, NULL, 'CYCLIN DOMAIN-CONTAINING PROTEIN', 242797),
(333369, 'PTHR10026:SF132', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 242797),
(333370, 'PTHR10026:SF154', NULL, NULL, NULL, NULL, 'BNAANNG05470D PROTEIN', 242797),
(333371, 'PTHR10026:SF152', NULL, NULL, NULL, NULL, '', 242797),
(333372, 'PTHR10026:SF153', NULL, NULL, NULL, NULL, 'CYCLIN-H', 242797),
(333373, 'PTHR10026:SF150', NULL, NULL, NULL, NULL, 'CYCLIN L FAMILY CYCLIN', 242797),
(333374, 'PTHR10026:SF151', NULL, NULL, NULL, NULL, 'CYCLIN-Q', 242797),
(333375, 'PTHR10026:SF76', NULL, NULL, NULL, NULL, 'CYCLIN-T1-1', 242797),
(333376, 'PTHR10026:SF51', NULL, NULL, NULL, NULL, 'CYCLIN-T', 242797),
(333377, 'PTHR10026:SF13', NULL, NULL, NULL, NULL, 'LD24704P', 242797),
(333378, 'PTHR10026:SF116', NULL, NULL, NULL, NULL, '', 242797),
(333379, 'PTHR10026:SF139', NULL, NULL, NULL, NULL, 'CYCLIN-T1-4', 242797),
(333380, 'PTHR10026:SF117', NULL, NULL, NULL, NULL, 'CYCLIN-T1-1-RELATED', 242797),
(333381, 'PTHR10529:SF368', NULL, NULL, NULL, NULL, 'MHD DOMAIN-CONTAINING PROTEIN', 242798),
(333382, 'PTHR10529:SF345', NULL, NULL, NULL, NULL, 'STONIN-2', 242798),
(333383, 'PTHR10529:SF344', NULL, NULL, NULL, NULL, 'PROTEIN STONED-B', 242798),
(333384, 'PTHR10529:SF366', NULL, NULL, NULL, NULL, 'CLATHRIN-ADAPTOR MEDIUM CHAIN AP-2', 242798),
(333385, 'PTHR10529:SF364', NULL, NULL, NULL, NULL, 'MHD DOMAIN-CONTAINING PROTEIN', 242798),
(333386, 'PTHR10529:SF342', NULL, NULL, NULL, NULL, 'AP-3 COMPLEX SUBUNIT MU-1', 242798),
(333387, 'PTHR10529:SF341', NULL, NULL, NULL, NULL, 'AP-3 COMPLEX SUBUNIT MU-2', 242798),
(333388, 'PTHR10529:SF363', NULL, NULL, NULL, NULL, 'MHD DOMAIN-CONTAINING PROTEIN', 242798),
(333389, 'PTHR10529:SF340', NULL, NULL, NULL, NULL, 'CARMINE, ISOFORM A', 242798),
(333390, 'PTHR10529:SF361', NULL, NULL, NULL, NULL, 'MHD DOMAIN-CONTAINING PROTEIN', 242798),
(333391, 'PTHR10529:SF262', NULL, NULL, NULL, NULL, 'ADAPTOR PROTEIN COMPLEX 1, MU SUBUNIT', 242798),
(333392, 'PTHR10529:SF349', NULL, NULL, NULL, NULL, 'AP-1 COMPLEX SUBUNIT MU-1-RELATED', 242798),
(333393, 'PTHR10529:SF347', NULL, NULL, NULL, NULL, 'AP-4 COMPLEX SUBUNIT MU-LIKE', 242798),
(333394, 'PTHR10529:SF369', NULL, NULL, NULL, NULL, 'AP-1 COMPLEX SUBUNIT MU-1', 242798),
(333395, 'PTHR10529', NULL, NULL, NULL, NULL, 'AP COMPLEX SUBUNIT MU', 242798),
(333396, 'PTHR10529:SF360', NULL, NULL, NULL, NULL, 'AP-2 COMPLEX SUBUNIT MU-LIKE', 242798),
(333397, 'PTHR10529:SF236', NULL, NULL, NULL, NULL, 'AP-2 COMPLEX SUBUNIT MU', 242798),
(333398, 'PTHR10529:SF356', NULL, NULL, NULL, NULL, 'AP-1 COMPLEX SUBUNIT MU-2-LIKE ISOFORM X1', 242798),
(333399, 'PTHR10529:SF257', NULL, NULL, NULL, NULL, 'AP-1 COMPLEX SUBUNIT MU-1', 242798),
(333400, 'PTHR10529:SF234', NULL, NULL, NULL, NULL, 'AP-1 COMPLEX SUBUNIT MU-2', 242798),
(333401, 'PTHR10529:SF354', NULL, NULL, NULL, NULL, 'MHD DOMAIN-CONTAINING PROTEIN', 242798),
(333402, 'PTHR10529:SF353', NULL, NULL, NULL, NULL, 'AP-1 COMPLEX SUBUNIT MU-1-RELATED', 242798),
(333403, 'PTHR10529:SF350', NULL, NULL, NULL, NULL, 'ASSEMBLY PROTEIN AP47, PUTATIVE-RELATED', 242798),
(333404, 'PTHR10529:SF339', NULL, NULL, NULL, NULL, 'STONIN-1', 242798),
(333405, 'PTHR10529:SF338', NULL, NULL, NULL, NULL, 'OS05G0543100 PROTEIN', 242798),
(333406, 'PTHR10529:SF371', NULL, NULL, NULL, NULL, 'AP-2 COMPLEX SUBUNIT MU-A', 242798),
(333407, 'PTHR10529:SF271', NULL, NULL, NULL, NULL, 'ADAPTIN MEDIUM CHAIN HOMOLOG APM2', 242798);
INSERT INTO "PUBLIC"."MODEL" VALUES
(333408, 'PTHR10529:SF370', NULL, NULL, NULL, NULL, 'ADAPTOR-RELATED PROTEIN COMPLEX 1 SUBUNIT MU 3', 242798),
(333409, 'PTHR10529:SF270', NULL, NULL, NULL, NULL, 'AP-4 COMPLEX SUBUNIT MU-1', 242798),
(333410, 'PTHR20996', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 242799),
(333411, 'PTHR20996:SF3', NULL, NULL, NULL, NULL, 'NUCLEAR ENVELOPE PHOSPHATASE-REGULATORY SUBUNIT 1', 242799),
(333412, 'PTHR20996:SF1', NULL, NULL, NULL, NULL, 'NUCLEAR ENVELOPE PHOSPHATASE-REGULATORY SUBUNIT 1', 242799),
(333413, 'PTHR20996:SF2', NULL, NULL, NULL, NULL, 'NUCLEAR ENVELOPE PHOSPHATASE-REGULATORY SUBUNIT 1', 242799),
(333414, 'PTHR39340', NULL, NULL, NULL, NULL, 'SULFOFRUCTOSEPHOSPHATE ALDOLASE', 242800),
(333415, 'PTHR39340:SF1', NULL, NULL, NULL, NULL, 'SULFOFRUCTOSEPHOSPHATE ALDOLASE', 242800),
(333416, 'PTHR14700:SF0', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN 2, MITOCHONDRIAL', 242801),
(333417, 'PTHR14700', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN 2, MITOCHONDRIAL', 242801),
(333418, 'PTHR47488:SF14', NULL, NULL, NULL, NULL, 'BNAC07G33620D PROTEIN', 242802),
(333419, 'PTHR47488:SF2', NULL, NULL, NULL, NULL, 'OS07G0682000 PROTEIN', 242802),
(333420, 'PTHR47488', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORT/DETOXIFICATION SUPERFAMILY PROTEIN', 242802),
(333421, 'PTHR47488:SF3', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORT/DETOXIFICATION SUPERFAMILY PROTEIN', 242802),
(333422, 'PTHR47488:SF13', NULL, NULL, NULL, NULL, 'BNAA01G17470D PROTEIN', 242802),
(333423, 'PTHR47488:SF4', NULL, NULL, NULL, NULL, 'OS03G0412300 PROTEIN', 242802),
(333424, 'PTHR47488:SF5', NULL, NULL, NULL, NULL, '', 242802),
(333425, 'PTHR47488:SF10', NULL, NULL, NULL, NULL, 'BNAA08G05970D PROTEIN', 242802),
(333426, 'PTHR47488:SF7', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORT/DETOXIFICATION SUPERFAMILY PROTEIN', 242802),
(333427, 'PTHR47488:SF20', NULL, NULL, NULL, NULL, '', 242802),
(333428, 'PTHR47488:SF12', NULL, NULL, NULL, NULL, 'PROTEIN PYRICULARIA ORYZAE RESISTANCE 21', 242802),
(333429, 'PTHR47488:SF18', NULL, NULL, NULL, NULL, 'HEAVY-METAL-ASSOCIATED DOMAIN PROTEIN', 242802),
(333430, 'PTHR47488:SF19', NULL, NULL, NULL, NULL, 'PISTIL-SPECIFIC EXTENSIN-LIKE PROTEIN', 242802),
(333431, 'PTHR37313:SF2', NULL, NULL, NULL, NULL, 'UPF0749 PROTEIN YLXX', 242803),
(333432, 'PTHR37313:SF4', NULL, NULL, NULL, NULL, 'CONSERVED MEMBRANE PROTEIN-RELATED', 242803),
(333433, 'PTHR37313', NULL, NULL, NULL, NULL, 'UPF0749 PROTEIN RV1825', 242803),
(333434, 'PTHR37313:SF1', NULL, NULL, NULL, NULL, 'UPF0749 PROTEIN RV1823', 242803),
(333435, 'PTHR34208:SF6', NULL, NULL, NULL, NULL, '', 242804),
(333436, 'PTHR34208', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASE-RELATED', 242804),
(333437, 'PTHR34208:SF17', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASE-RELATED', 242804),
(333438, 'PTHR34208:SF9', NULL, NULL, NULL, NULL, '', 242804),
(333439, 'PTHR34208:SF2', NULL, NULL, NULL, NULL, 'PECTIN METHYLESTERASE CGR2-RELATED', 242804),
(333440, 'PTHR34208:SF3', NULL, NULL, NULL, NULL, '', 242804),
(333441, 'PTHR34208:SF5', NULL, NULL, NULL, NULL, 'PECTIN METHYLESTERASE CGR3-RELATED', 242804),
(333442, 'PTHR34208:SF11', NULL, NULL, NULL, NULL, '', 242804),
(333443, 'PTHR34208:SF12', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASE-RELATED', 242804),
(333444, 'PTHR34208:SF15', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 242804),
(333445, 'PTHR34208:SF16', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASE-RELATED', 242804),
(333446, 'PTHR34208:SF13', NULL, NULL, NULL, NULL, 'BNACNNG21600D PROTEIN', 242804),
(333447, 'PTHR12086', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN  C-TERMINAL  CONTAINING PROTEIN', 242805),
(333448, 'PTHR12086:SF15', NULL, NULL, NULL, NULL, '', 242805),
(333449, 'PTHR12086:SF11', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING FAMILY MEMBER C2', 242805),
(333450, 'PTHR12086:SF12', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING FAMILY MEMBER B', 242805);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(333451, 'PTHR12086:SF9', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN 1', 242805),
(333452, 'PTHR32347', NULL, NULL, NULL, NULL, 'EFFLUX SYSTEM COMPONENT YKNX-RELATED', 242806),
(333453, 'PTHR32347:SF14', NULL, NULL, NULL, NULL, 'EFFLUX SYSTEM COMPONENT YKNX-RELATED', 242806),
(333454, 'PTHR32347:SF23', NULL, NULL, NULL, NULL, 'UPF0194 MEMBRANE PROTEIN YBHG', 242806),
(333455, 'PTHR32347:SF19', NULL, NULL, NULL, NULL, 'HLYD_D23 DOMAIN-CONTAINING PROTEIN', 242806),
(333456, 'PTHR32347:SF28', NULL, NULL, NULL, NULL, 'EXPORTED PROTEIN-RELATED', 242806),
(333457, 'PTHR32347:SF27', NULL, NULL, NULL, NULL, 'HLYD_D23 DOMAIN-CONTAINING PROTEIN', 242806),
(333458, 'PTHR13722:SF0', NULL, NULL, NULL, NULL, 'ATP SYNTHASE PROTEIN 8', 242807),
(333459, 'PTHR13722', NULL, NULL, NULL, NULL, 'ATP SYNTHASE PROTEIN 8', 242807),
(333460, 'PTHR48018:SF56', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 8G1', 242808),
(333461, 'PTHR48018:SF55', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333462, 'PTHR48018:SF58', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 9I1', 242808),
(333463, 'PTHR48018:SF57', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333464, 'PTHR48018:SF142', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 143', 242808),
(333465, 'PTHR48018:SF141', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333466, 'PTHR48018:SF59', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 891', 242808),
(333467, 'PTHR48018:SF140', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333468, 'PTHR48018:SF146', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333469, 'PTHR48018:SF145', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333470, 'PTHR48018:SF144', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 9Q2', 242808),
(333471, 'PTHR48018:SF50', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333472, 'PTHR48018:SF143', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333473, 'PTHR48018:SF52', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333474, 'PTHR48018:SF51', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5B12', 242808),
(333475, 'PTHR48018:SF149', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333476, 'PTHR48018:SF148', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333477, 'PTHR48018:SF147', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5M3', 242808),
(333478, 'PTHR48018:SF53', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333479, 'PTHR48018:SF67', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333480, 'PTHR48018:SF69', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333481, 'PTHR48018:SF68', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR K41', 242808),
(333482, 'PTHR48018:SF153', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 8H3', 242808),
(333483, 'PTHR48018:SF152', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR K26', 242808),
(333484, 'PTHR48018:SF151', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1089', 242808),
(333485, 'PTHR48018:SF150', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333486, 'PTHR48018:SF157', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333487, 'PTHR48018:SF156', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR K4H17-RELATED', 242808),
(333488, 'PTHR48018:SF155', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR-RELATED', 242808),
(333489, 'PTHR48018:SF61', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 8B2-RELATED', 242808),
(333490, 'PTHR48018:SF60', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 9Q1', 242808),
(333491, 'PTHR48018:SF63', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333492, 'PTHR48018:SF62', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 881', 242808),
(333493, 'PTHR48018:SF159', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333494, 'PTHR48018:SF65', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5D14', 242808),
(333495, 'PTHR48018:SF158', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333496, 'PTHR48018:SF64', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333497, 'PTHR48018:SF78', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333498, 'PTHR48018:SF160', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(333499, 'PTHR48018:SF77', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333500, 'PTHR48018:SF79', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333501, 'PTHR48018:SF164', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333502, 'PTHR48018:SF162', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333503, 'PTHR48018:SF161', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 983', 242808),
(333504, 'PTHR48018:SF70', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333505, 'PTHR48018:SF168', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333506, 'PTHR48018:SF167', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333507, 'PTHR48018:SF72', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 8D1', 242808),
(333508, 'PTHR48018:SF166', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1030', 242808),
(333509, 'PTHR48018:SF71', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333510, 'PTHR48018:SF165', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333511, 'PTHR48018:SF74', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333512, 'PTHR48018:SF73', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 8I2', 242808),
(333513, 'PTHR48018:SF76', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5I1', 242808),
(333514, 'PTHR48018:SF75', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333515, 'PTHR48018:SF169', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333516, 'PTHR48018:SF90', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5AK3-RELATED', 242808),
(333517, 'PTHR48018:SF8', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5B21', 242808),
(333518, 'PTHR48018:SF9', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333519, 'PTHR48018:SF89', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333520, 'PTHR48018:SF171', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333521, 'PTHR48018:SF88', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333522, 'PTHR48018:SF170', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333523, 'PTHR48018:SF175', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 8H2', 242808),
(333524, 'PTHR48018:SF173', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 8D2', 242808),
(333525, 'PTHR48018:SF172', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 8G3 PSEUDOGENE-RELATED', 242808),
(333526, 'PTHR48018:SF6', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333527, 'PTHR48018:SF179', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5AK2', 242808),
(333528, 'PTHR48018:SF81', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 8K1', 242808),
(333529, 'PTHR48018:SF7', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 8B8', 242808),
(333530, 'PTHR48018:SF80', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333531, 'PTHR48018:SF177', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333532, 'PTHR48018:SF83', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5M8', 242808),
(333533, 'PTHR48018:SF4', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333534, 'PTHR48018:SF5', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 8A1', 242808),
(333535, 'PTHR48018:SF82', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333536, 'PTHR48018:SF176', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333537, 'PTHR48018:SF2', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333538, 'PTHR48018:SF85', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5M10', 242808),
(333539, 'PTHR48018:SF3', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5D16', 242808),
(333540, 'PTHR48018:SF84', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333541, 'PTHR48018:SF87', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333542, 'PTHR48018:SF86', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333543, 'PTHR48018:SF1', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333544, 'PTHR48018:SF109', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 8U3', 242808),
(333545, 'PTHR48018:SF108', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333546, 'PTHR48018:SF107', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5B17', 242808),
(333547, 'PTHR48018:SF19', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(333548, 'PTHR48018:SF182', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333549, 'PTHR48018:SF12', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333550, 'PTHR48018:SF99', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333551, 'PTHR48018:SF181', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 8H1', 242808),
(333552, 'PTHR48018:SF11', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333553, 'PTHR48018:SF14', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 8B4', 242808),
(333554, 'PTHR48018:SF13', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 8K5', 242808),
(333555, 'PTHR48018:SF16', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5L2', 242808),
(333556, 'PTHR48018:SF186', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 472', 242808),
(333557, 'PTHR48018:SF185', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333558, 'PTHR48018:SF15', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333559, 'PTHR48018:SF184', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333560, 'PTHR48018:SF18', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333561, 'PTHR48018:SF183', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333562, 'PTHR48018:SF102', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5B3', 242808),
(333563, 'PTHR48018:SF92', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333564, 'PTHR48018:SF101', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333565, 'PTHR48018:SF91', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 8U1-RELATED', 242808),
(333566, 'PTHR48018:SF189', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5T2', 242808),
(333567, 'PTHR48018:SF94', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333568, 'PTHR48018:SF100', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5M1', 242808),
(333569, 'PTHR48018:SF188', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333570, 'PTHR48018:SF93', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333571, 'PTHR48018:SF187', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333572, 'PTHR48018:SF106', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5M11', 242808),
(333573, 'PTHR48018:SF96', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333574, 'PTHR48018:SF105', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333575, 'PTHR48018:SF95', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333576, 'PTHR48018:SF98', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333577, 'PTHR48018:SF10', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333578, 'PTHR48018:SF104', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR-RELATED', 242808),
(333579, 'PTHR48018:SF97', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333580, 'PTHR48018:SF119', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333581, 'PTHR48018:SF118', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333582, 'PTHR48018:SF23', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333583, 'PTHR48018:SF193', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 473-RELATED', 242808),
(333584, 'PTHR48018:SF22', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1022', 242808),
(333585, 'PTHR48018:SF192', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333586, 'PTHR48018:SF191', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR FAMILY 5 SUBFAMILY T MEMBER 8', 242808),
(333587, 'PTHR48018:SF25', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333588, 'PTHR48018:SF24', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333589, 'PTHR48018:SF190', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 150', 242808),
(333590, 'PTHR48018:SF27', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 8G2-RELATED', 242808),
(333591, 'PTHR48018:SF197', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333592, 'PTHR48018:SF196', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1094-RELATED', 242808),
(333593, 'PTHR48018:SF26', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333594, 'PTHR48018:SF29', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333595, 'PTHR48018:SF195', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 901', 242808);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(333596, 'PTHR48018:SF194', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5T1-RELATED', 242808),
(333597, 'PTHR48018:SF28', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 8K3', 242808),
(333598, 'PTHR48018:SF113', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333599, 'PTHR48018:SF112', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333600, 'PTHR48018:SF199', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333601, 'PTHR48018:SF111', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333602, 'PTHR48018:SF110', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333603, 'PTHR48018:SF198', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333604, 'PTHR48018:SF117', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR-RELATED', 242808),
(333605, 'PTHR48018:SF116', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5B2', 242808),
(333606, 'PTHR48018:SF21', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5AP2', 242808),
(333607, 'PTHR48018:SF20', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333608, 'PTHR48018:SF114', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR-RELATED', 242808),
(333609, 'PTHR48018:SF129', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 9G4', 242808),
(333610, 'PTHR48018:SF34', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR-RELATED', 242808),
(333611, 'PTHR48018:SF33', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5D13', 242808),
(333612, 'PTHR48018:SF36', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333613, 'PTHR48018:SF35', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333614, 'PTHR48018:SF120', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 242808),
(333615, 'PTHR48018:SF37', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR-RELATED', 242808),
(333616, 'PTHR48018:SF39', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 8B12', 242808),
(333617, 'PTHR48018:SF124', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333618, 'PTHR48018:SF123', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR K25-RELATED', 242808),
(333619, 'PTHR48018:SF122', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333620, 'PTHR48018:SF121', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5D18', 242808),
(333621, 'PTHR48018:SF30', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333622, 'PTHR48018:SF128', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333623, 'PTHR48018:SF127', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR-RELATED', 242808),
(333624, 'PTHR48018:SF126', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR-RELATED', 242808),
(333625, 'PTHR48018:SF32', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5L1', 242808),
(333626, 'PTHR48018:SF31', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR-RELATED', 242808),
(333627, 'PTHR48018', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333628, 'PTHR48018:SF45', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333629, 'PTHR48018:SF44', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 8J1', 242808),
(333630, 'PTHR48018:SF47', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR-RELATED', 242808),
(333631, 'PTHR48018:SF46', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1008', 242808),
(333632, 'PTHR48018:SF49', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333633, 'PTHR48018:SF131', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 8J2', 242808),
(333634, 'PTHR48018:SF130', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333635, 'PTHR48018:SF48', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 8G5', 242808),
(333636, 'PTHR48018:SF133', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5AL1', 242808),
(333637, 'PTHR48018:SF132', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5M9', 242808),
(333638, 'PTHR48018:SF41', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 8J3', 242808),
(333639, 'PTHR48018:SF139', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1442', 242808),
(333640, 'PTHR48018:SF40', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333641, 'PTHR48018:SF138', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 974', 242808),
(333642, 'PTHR48018:SF137', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 8D4', 242808);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(333643, 'PTHR48018:SF43', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333644, 'PTHR48018:SF42', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 242808),
(333645, 'PTHR48018:SF136', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 883', 242808),
(333646, 'PTHR31930', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS R', 242809),
(333647, 'PTHR31930:SF1', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS R', 242809),
(333648, 'PTHR31930:SF2', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS R', 242809),
(333649, 'PTHR31930:SF5', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS R', 242809),
(333650, 'PTHR31930:SF3', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS R', 242809),
(333651, 'PTHR31930:SF4', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS R', 242809),
(333652, 'PTHR13808:SF38', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE', 242810),
(333653, 'PTHR13808:SF39', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE HAC-LIKE 3-RELATED', 242810),
(333654, 'PTHR13808:SF58', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE', 242810),
(333655, 'PTHR13808', NULL, NULL, NULL, NULL, 'CBP/P300-RELATED', 242810),
(333656, 'PTHR13808:SF29', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE P300', 242810),
(333657, 'PTHR13808:SF30', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE HAC5', 242810),
(333658, 'PTHR13808:SF41', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE', 242810),
(333659, 'PTHR13808:SF42', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE', 242810),
(333660, 'PTHR13808:SF53', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE HAC2', 242810),
(333661, 'PTHR13808:SF50', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE', 242810),
(333662, 'PTHR13808:SF1', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE', 242810),
(333663, 'PTHR13808:SF34', NULL, NULL, NULL, NULL, 'CREB-BINDING PROTEIN', 242810),
(333664, 'PTHR13808:SF56', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE', 242810),
(333665, 'PTHR13808:SF57', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE', 242810),
(333666, 'PTHR13808:SF24', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE', 242810),
(333667, 'PTHR13808:SF33', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE', 242810),
(333668, 'PTHR43162', NULL, NULL, NULL, NULL, '', 242811),
(333669, 'PTHR43162:SF1', NULL, NULL, NULL, NULL, 'PRESTALK A DIFFERENTIATION PROTEIN A', 242811),
(333670, 'PTHR14522:SF0', NULL, NULL, NULL, NULL, 'PROTEIN PRR14L', 242812),
(333671, 'PTHR14522:SF2', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 14', 242812),
(333672, 'PTHR14522', NULL, NULL, NULL, NULL, 'EMO2-RELATED', 242812),
(333673, 'PTHR34401:SF6', NULL, NULL, NULL, NULL, 'SRE-38', 242813),
(333674, 'PTHR34401:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG12388', 242813),
(333675, 'PTHR34401:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG13337', 242813),
(333676, 'PTHR34401:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG13710', 242813),
(333677, 'PTHR34401:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG01832', 242813),
(333678, 'PTHR34401', NULL, NULL, NULL, NULL, 'PROTEIN CBG12388-RELATED', 242813),
(333679, 'PTHR21037', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L14, MITOCHONDRIAL', 242814),
(333680, 'PTHR21037:SF3', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L14, MITOCHONDRIAL', 242814),
(333681, 'PTHR21037:SF2', NULL, NULL, NULL, NULL, 'SIMILAR TO NOVEL PROTEIN', 242814),
(333682, 'PTHR23199:SF12', NULL, NULL, NULL, NULL, 'NEUROTROPHIN 1-RELATED', 242815),
(333683, 'PTHR23199:SF13', NULL, NULL, NULL, NULL, 'PROTEIN SPAETZLE 3', 242815),
(333684, 'PTHR23199:SF5', NULL, NULL, NULL, NULL, 'PROTEIN SPAETZLE 4', 242815),
(333685, 'PTHR23199:SF16', NULL, NULL, NULL, NULL, 'PROTEIN SPAETZLE 5', 242815),
(333686, 'PTHR23199:SF17', NULL, NULL, NULL, NULL, 'NGF DOMAIN-CONTAINING PROTEIN', 242815),
(333687, 'PTHR23199', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 242815),
(333688, 'PTHR23199:SF7', NULL, NULL, NULL, NULL, 'RE45222P', 242815),
(333689, 'PTHR34975', NULL, NULL, NULL, NULL, 'SPORE GERMINATION PROTEIN A2', 242816),
(333690, 'PTHR34975:SF2', NULL, NULL, NULL, NULL, 'SPORE GERMINATION PROTEIN A2', 242816);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(333691, 'PTHR32055:SF1', NULL, NULL, NULL, NULL, 'INTEGRIN BETA-1-BINDING PROTEIN 1', 242817),
(333692, 'PTHR32055', NULL, NULL, NULL, NULL, 'INTEGRIN BETA-1-BINDING PROTEIN 1', 242817),
(333693, 'PTHR45972:SF3', NULL, NULL, NULL, NULL, 'KELCH REPEAT AND BTB DOMAIN-CONTAINING PROTEIN 11', 242818),
(333694, 'PTHR45972:SF2', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 42', 242818),
(333695, 'PTHR45972:SF1', NULL, NULL, NULL, NULL, 'KELCH DOMAIN-CONTAINING PROTEIN 7A', 242818),
(333696, 'PTHR45972', NULL, NULL, NULL, NULL, 'BTB_2 DOMAIN-CONTAINING PROTEIN', 242818),
(333697, 'PTHR45972:SF6', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 242818),
(333698, 'PTHR45972:SF5', NULL, NULL, NULL, NULL, 'KELCH DOMAIN-CONTAINING PROTEIN 7B', 242818),
(333699, 'PTHR45972:SF4', NULL, NULL, NULL, NULL, 'BTB_2 DOMAIN-CONTAINING PROTEIN', 242818),
(333700, 'PTHR32061:SF4', NULL, NULL, NULL, NULL, 'NMDA RECEPTOR SYNAPTONUCLEAR SIGNALING AND NEURONAL MIGRATION FACTOR', 242819),
(333701, 'PTHR32061', NULL, NULL, NULL, NULL, 'NMDA RECEPTOR SYNAPTONUCLEAR SIGNALING AND NEURONAL MIGRATION FACTOR', 242819),
(333702, 'PTHR23023:SF62', NULL, NULL, NULL, NULL, 'FLAVIN-BINDING MONOOXYGENASE-LIKE PROTEIN (AFU_ORTHOLOGUE AFUA_6G14280)', 242820),
(333703, 'PTHR23023', NULL, NULL, NULL, NULL, 'DIMETHYLANILINE MONOOXYGENASE', 242820),
(333704, 'PTHR23023:SF239', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333705, 'PTHR23023:SF118', NULL, NULL, NULL, NULL, 'DIMETHYLANILINE MONOOXYGENASE [N-OXIDE-FORMING]', 242820),
(333706, 'PTHR23023:SF279', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333707, 'PTHR23023:SF234', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333708, 'PTHR23023:SF278', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE FMO GS-OX-LIKE 3-RELATED', 242820),
(333709, 'PTHR23023:SF237', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333710, 'PTHR23023:SF236', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333711, 'PTHR23023:SF154', NULL, NULL, NULL, NULL, 'DIMETHYLANILINE MONOOXYGENASE [N-OXIDE-FORMING] 1', 242820),
(333712, 'PTHR23023:SF110', NULL, NULL, NULL, NULL, 'PYR_REDOX_2 DOMAIN-CONTAINING PROTEIN', 242820),
(333713, 'PTHR23023:SF277', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333714, 'PTHR23023:SF270', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333715, 'PTHR23023:SF78', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE 5', 242820),
(333716, 'PTHR23023:SF74', NULL, NULL, NULL, NULL, 'DIMETHYLANILINE MONOOXYGENASE [N-OXIDE-FORMING] 4', 242820),
(333717, 'PTHR23023:SF70', NULL, NULL, NULL, NULL, 'DIMETHYLANILINE MONOOXYGENASE [N-OXIDE-FORMING]', 242820),
(333718, 'PTHR23023:SF228', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333719, 'PTHR23023:SF301', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333720, 'PTHR23023:SF223', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333721, 'PTHR23023:SF267', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333722, 'PTHR23023:SF300', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333723, 'PTHR23023:SF226', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333724, 'PTHR23023:SF143', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE 1-RELATED', 242820),
(333725, 'PTHR23023:SF220', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333726, 'PTHR23023:SF266', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333727, 'PTHR23023:SF265', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333728, 'PTHR23023:SF38', NULL, NULL, NULL, NULL, 'DIMETHYLANILINE MONOOXYGENASE [N-OXIDE-FORMING]', 242820),
(333729, 'PTHR23023:SF44', NULL, NULL, NULL, NULL, 'DIMETHYLANILINE MONOOXYGENASE [N-OXIDE-FORMING] 3', 242820),
(333730, 'PTHR23023:SF85', NULL, NULL, NULL, NULL, 'DIMETHYLANILINE MONOOXYGENASE [N-OXIDE-FORMING]', 242820);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(333731, 'PTHR23023:SF84', NULL, NULL, NULL, NULL, 'DIMETHYLANILINE MONOOXYGENASE [N-OXIDE-FORMING] 2', 242820),
(333732, 'PTHR23023:SF81', NULL, NULL, NULL, NULL, 'DIMETHYLANILINE MONOOXYGENASE [N-OXIDE-FORMING] 6-RELATED', 242820),
(333733, 'PTHR23023:SF217', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333734, 'PTHR23023:SF219', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333735, 'PTHR23023:SF213', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE FMO GS-OX-LIKE 1-RELATED', 242820),
(333736, 'PTHR23023:SF256', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333737, 'PTHR23023:SF215', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333738, 'PTHR23023:SF259', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333739, 'PTHR23023:SF258', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333740, 'PTHR23023:SF137', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333741, 'PTHR23023:SF297', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333742, 'PTHR23023:SF131', NULL, NULL, NULL, NULL, 'DIMETHYLANILINE MONOOXYGENASE [N-OXIDE-FORMING]', 242820),
(333743, 'PTHR23023:SF296', NULL, NULL, NULL, NULL, 'YALI0D21076P', 242820),
(333744, 'PTHR23023:SF299', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333745, 'PTHR23023:SF255', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333746, 'PTHR23023:SF254', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333747, 'PTHR23023:SF210', NULL, NULL, NULL, NULL, 'DIMETHYLANILINE MONOOXYGENASE [N-OXIDE-FORMING]', 242820),
(333748, 'PTHR23023:SF298', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333749, 'PTHR23023:SF293', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333750, 'PTHR23023:SF292', NULL, NULL, NULL, NULL, 'FLAVIN-BINDING MONOOXYGENASE-LIKE PROTEIN (AFU_ORTHOLOGUE AFUA_6G01900)', 242820),
(333751, 'PTHR23023:SF295', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333752, 'PTHR23023:SF251', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333753, 'PTHR23023:SF294', NULL, NULL, NULL, NULL, 'CHROMOSOME 9, WHOLE GENOME SHOTGUN SEQUENCE', 242820),
(333754, 'PTHR23023:SF291', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333755, 'PTHR23023:SF290', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333756, 'PTHR23023:SF99', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333757, 'PTHR23023:SF50', NULL, NULL, NULL, NULL, '', 242820),
(333758, 'PTHR23023:SF51', NULL, NULL, NULL, NULL, 'DIMETHYLANILINE MONOOXYGENASE [N-OXIDE-FORMING]', 242820),
(333759, 'PTHR23023:SF249', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333760, 'PTHR23023:SF208', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333761, 'PTHR23023:SF245', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333762, 'PTHR23023:SF289', NULL, NULL, NULL, NULL, 'DIMETHYLANILINE MONOOXYGENASE [N-OXIDE-FORMING]', 242820),
(333763, 'PTHR23023:SF204', NULL, NULL, NULL, NULL, 'DIMETHYLANILINE MONOOXYGENASE [N-OXIDE-FORMING]', 242820),
(333764, 'PTHR23023:SF248', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333765, 'PTHR23023:SF286', NULL, NULL, NULL, NULL, 'DIMETHYLANILINE MONOOXYGENASE [N-OXIDE-FORMING]', 242820),
(333766, 'PTHR23023:SF242', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE FMO GS-OX-LIKE 8', 242820),
(333767, 'PTHR23023:SF241', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333768, 'PTHR23023:SF120', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333769, 'PTHR23023:SF244', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE FMO GS-OX1-RELATED', 242820),
(333770, 'PTHR23023:SF288', NULL, NULL, NULL, NULL, '', 242820),
(333771, 'PTHR23023:SF287', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(333772, 'PTHR23023:SF166', NULL, NULL, NULL, NULL, 'DIMETHYLANILINE MONOOXYGENASE [N-OXIDE-FORMING]', 242820),
(333773, 'PTHR23023:SF243', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333774, 'PTHR23023:SF161', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE FMO GS-OX-LIKE 9', 242820),
(333775, 'PTHR23023:SF281', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 242820),
(333776, 'PTHR31367', NULL, NULL, NULL, NULL, 'CYTOSOLIC 5''-NUCLEOTIDASE 1 FAMILY MEMBER', 242821),
(333777, 'PTHR31367:SF5', NULL, NULL, NULL, NULL, '5''-NUCLEOTIDASE', 242821),
(333778, 'PTHR31367:SF3', NULL, NULL, NULL, NULL, '', 242821),
(333779, 'PTHR31367:SF4', NULL, NULL, NULL, NULL, '5''-NUCLEOTIDASE, CYTOSOLIC IAA', 242821),
(333780, 'PTHR31367:SF2', NULL, NULL, NULL, NULL, 'CYTOSOLIC 5''-NUCLEOTIDASE 1A', 242821),
(333781, 'PTHR31367:SF0', NULL, NULL, NULL, NULL, 'CYTOSOLIC 5''-NUCLEOTIDASE 1B', 242821),
(333782, 'PTHR43169:SF3', NULL, NULL, NULL, NULL, 'ATPASE, PP-LOOP SUPERFAMILY-RELATED', 242822),
(333783, 'PTHR43169:SF2', NULL, NULL, NULL, NULL, 'NAD_SYNTHASE DOMAIN-CONTAINING PROTEIN', 242822),
(333784, 'PTHR43169:SF4', NULL, NULL, NULL, NULL, 'ATPASE, PP-LOOP SUPERFAMILY-RELATED', 242822),
(333785, 'PTHR43169:SF1', NULL, NULL, NULL, NULL, 'ATPASE, PP-LOOP SUPERFAMILY-RELATED', 242822),
(333786, 'PTHR43169', NULL, NULL, NULL, NULL, 'EXSB FAMILY PROTEIN', 242822),
(333787, 'PTHR36737', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242823),
(333788, 'PTHR36737:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242823),
(333789, 'PTHR21399:SF3', NULL, NULL, NULL, NULL, 'METHYLOSOME SUBUNIT PICLN', 242824),
(333790, 'PTHR21399:SF4', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL, NUCLEOTIDE SENSITIVE 1A', 242824),
(333791, 'PTHR21399:SF5', NULL, NULL, NULL, NULL, 'BNAA02G33340D PROTEIN', 242824),
(333792, 'PTHR21399:SF0', NULL, NULL, NULL, NULL, 'METHYLOSOME SUBUNIT PICLN', 242824),
(333793, 'PTHR21399:SF2', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-SENSITIVE CHLORIDE CONDUCTANCE REGULATOR FAMILY PROTEIN, EXPRESSED', 242824),
(333794, 'PTHR21399', NULL, NULL, NULL, NULL, 'CHLORIDE CONDUCTANCE REGULATORY PROTEIN ICLN', 242824),
(333795, 'PTHR23186:SF4', NULL, NULL, NULL, NULL, 'GH22790P', 242825),
(333796, 'PTHR23186:SF3', NULL, NULL, NULL, NULL, 'RETINOIC ACID-INDUCED PROTEIN 2', 242825),
(333797, 'PTHR23186:SF2', NULL, NULL, NULL, NULL, 'SINE OCULIS-BINDING PROTEIN HOMOLOG', 242825),
(333798, 'PTHR23186', NULL, NULL, NULL, NULL, 'RETINOIC ACID-INDUCED PROTEIN 2', 242825),
(333799, 'PTHR23186:SF5', NULL, NULL, NULL, NULL, 'SINE OCULIS-BINDING PROTEIN HOMOLOG B', 242825),
(333800, 'PTHR38459:SF4', NULL, NULL, NULL, NULL, 'CONSERVED TRANSMEMBRANE PROTEIN-RELATED', 242826),
(333801, 'PTHR38459:SF5', NULL, NULL, NULL, NULL, 'CELL WALL TEICHOIC ACID GLYCOSYLATION PROTEIN GTCA', 242826),
(333802, 'PTHR38459:SF1', NULL, NULL, NULL, NULL, 'PROPHAGE BACTOPRENOL-LINKED GLUCOSE TRANSLOCASE HOMOLOG', 242826),
(333803, 'PTHR38459', NULL, NULL, NULL, NULL, 'PROPHAGE BACTOPRENOL-LINKED GLUCOSE TRANSLOCASE HOMOLOG', 242826),
(333804, 'PTHR13486:SF2', NULL, NULL, NULL, NULL, 'TELOMERE LENGTH AND SILENCING PROTEIN 1 HOMOLOG', 242827),
(333805, 'PTHR13486', NULL, NULL, NULL, NULL, 'TELOMERE LENGTH AND SILENCING PROTEIN 1 TLS1 FAMILY MEMBER', 242827),
(333806, 'PTHR34064:SF11', NULL, NULL, NULL, NULL, '', 242828),
(333807, 'PTHR34064:SF7', NULL, NULL, NULL, NULL, 'BNAA03G58480D PROTEIN', 242828),
(333808, 'PTHR34064:SF6', NULL, NULL, NULL, NULL, 'OS07G0530700 PROTEIN', 242828),
(333809, 'PTHR34064:SF12', NULL, NULL, NULL, NULL, '', 242828),
(333810, 'PTHR34064', NULL, NULL, NULL, NULL, 'OS04G0672300 PROTEIN', 242828),
(333811, 'PTHR34064:SF8', NULL, NULL, NULL, NULL, 'BNAA01G34640D PROTEIN', 242828),
(333812, 'PTHR34064:SF3', NULL, NULL, NULL, NULL, 'OS04G0672300 PROTEIN', 242828),
(333813, 'PTHR34064:SF5', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 242828),
(333814, 'PTHR34064:SF4', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 242828),
(333815, 'PTHR34064:SF1', NULL, NULL, NULL, NULL, '', 242828);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(333816, 'PTHR13059', NULL, NULL, NULL, NULL, 'HMG-BOX TRANSCRIPTION FACTOR BBX', 242829),
(333817, 'PTHR13059:SF10', NULL, NULL, NULL, NULL, 'HMG BOX TRANSCRIPTION FACTOR BBX', 242829),
(333818, 'PTHR13059:SF13', NULL, NULL, NULL, NULL, 'PROTEIN CAPICUA HOMOLOG', 242829),
(333819, 'PTHR46539', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ATL42', 242830),
(333820, 'PTHR46539:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ATL42', 242830),
(333821, 'PTHR46539:SF16', NULL, NULL, NULL, NULL, 'BNAA03G59080D PROTEIN', 242830),
(333822, 'PTHR46539:SF13', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 242830),
(333823, 'PTHR46539:SF12', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 242830),
(333824, 'PTHR46539:SF11', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 242830),
(333825, 'PTHR46539:SF10', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL12-RELATED', 242830),
(333826, 'PTHR46539:SF20', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 242830),
(333827, 'PTHR46539:SF5', NULL, NULL, NULL, NULL, 'RING ZINC FINGER DOMAIN SUPERFAMILY PROTEIN-RELATED', 242830),
(333828, 'PTHR46539:SF2', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL43', 242830),
(333829, 'PTHR46539:SF9', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL56', 242830),
(333830, 'PTHR46539:SF19', NULL, NULL, NULL, NULL, 'BNAA01G08010D PROTEIN', 242830),
(333831, 'PTHR46539:SF8', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 242830),
(333832, 'PTHR46539:SF18', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL4J', 242830),
(333833, 'PTHR46539:SF17', NULL, NULL, NULL, NULL, 'BNAA08G13100D PROTEIN', 242830),
(333834, 'PTHR46539:SF6', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL14', 242830),
(333835, 'PTHR46371:SF1', NULL, NULL, NULL, NULL, 'OS04G0469300 PROTEIN', 242831),
(333836, 'PTHR46371:SF3', NULL, NULL, NULL, NULL, 'OS04G0469000 PROTEIN', 242831),
(333837, 'PTHR46371:SF5', NULL, NULL, NULL, NULL, '', 242831),
(333838, 'PTHR46371:SF7', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 46', 242831),
(333839, 'PTHR46371:SF6', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORT/DETOXIFICATION PROTEIN', 242831),
(333840, 'PTHR46371:SF32', NULL, NULL, NULL, NULL, '', 242831),
(333841, 'PTHR46371:SF21', NULL, NULL, NULL, NULL, 'METAL ION BINDING PROTEIN', 242831),
(333842, 'PTHR46371:SF10', NULL, NULL, NULL, NULL, '', 242831),
(333843, 'PTHR46371:SF20', NULL, NULL, NULL, NULL, '', 242831),
(333844, 'PTHR46371:SF17', NULL, NULL, NULL, NULL, 'ION BINDING PROTEIN, PUTATIVE-RELATED', 242831),
(333845, 'PTHR46371:SF28', NULL, NULL, NULL, NULL, 'METAL ION BINDING PROTEIN', 242831),
(333846, 'PTHR46371:SF16', NULL, NULL, NULL, NULL, 'METAL ION BINDING PROTEIN', 242831),
(333847, 'PTHR46371:SF26', NULL, NULL, NULL, NULL, 'BNAA06G35190D PROTEIN', 242831),
(333848, 'PTHR46371', NULL, NULL, NULL, NULL, 'OS04G0464100 PROTEIN', 242831),
(333849, 'PTHR46371:SF14', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 16', 242831),
(333850, 'PTHR46371:SF25', NULL, NULL, NULL, NULL, 'BNAA05G30010D PROTEIN', 242831),
(333851, 'PTHR46371:SF13', NULL, NULL, NULL, NULL, 'ATFP4', 242831),
(333852, 'PTHR46371:SF34', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED DOMAIN CONTAINING PROTEIN', 242831),
(333853, 'PTHR46371:SF23', NULL, NULL, NULL, NULL, 'METAL ION BINDING PROTEIN', 242831),
(333854, 'PTHR46371:SF12', NULL, NULL, NULL, NULL, 'OS02G0582600 PROTEIN', 242831),
(333855, 'PTHR46371:SF22', NULL, NULL, NULL, NULL, 'BNAA05G32990D PROTEIN', 242831),
(333856, 'PTHR46371:SF33', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED DOMAIN, HMA-RELATED', 242831),
(333857, 'PTHR34567:SF8', NULL, NULL, NULL, NULL, '', 242832),
(333858, 'PTHR34567:SF9', NULL, NULL, NULL, NULL, 'CONTAINING PROTEIN, PUTATIVE-RELATED', 242832),
(333859, 'PTHR34567:SF6', NULL, NULL, NULL, NULL, '', 242832),
(333860, 'PTHR34567:SF7', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING-LIKE PROTEIN', 242832),
(333861, 'PTHR34567:SF11', NULL, NULL, NULL, NULL, '', 242832);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(333862, 'PTHR34567:SF5', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE/TRANSITION METAL ION-BINDING PROTEIN', 242832),
(333863, 'PTHR34567:SF12', NULL, NULL, NULL, NULL, '', 242832),
(333864, 'PTHR34567:SF10', NULL, NULL, NULL, NULL, 'OS11G0140900 PROTEIN', 242832),
(333865, 'PTHR34567:SF3', NULL, NULL, NULL, NULL, 'FK506-BINDING-LIKE PROTEIN', 242832),
(333866, 'PTHR34567', NULL, NULL, NULL, NULL, 'FK506-BINDING-LIKE PROTEIN', 242832),
(333867, 'PTHR12960:SF0', NULL, NULL, NULL, NULL, 'NUCLEOPORIN GLE1', 242833),
(333868, 'PTHR12960', NULL, NULL, NULL, NULL, 'GLE-1-RELATED', 242833),
(333869, 'PTHR12420:SF40', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN 7', 242834),
(333870, 'PTHR12420:SF41', NULL, NULL, NULL, NULL, 'SI:CH211-57F7.7', 242834),
(333871, 'PTHR12420:SF4', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN 11', 242834),
(333872, 'PTHR12420:SF15', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN 6', 242834),
(333873, 'PTHR12420:SF37', NULL, NULL, NULL, NULL, 'G2/M PHASE-SPECIFIC E3 UBIQUITIN-PROTEIN LIGASE', 242834),
(333874, 'PTHR12420:SF44', NULL, NULL, NULL, NULL, 'G2/M-PHASE-SPECIFIC E3 UBIQUITIN PROTEIN LIGASE', 242834),
(333875, 'PTHR12420:SF45', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', 242834),
(333876, 'PTHR12420', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN', 242834),
(333877, 'PTHR12420:SF42', NULL, NULL, NULL, NULL, 'G2/M PHASE-SPECIFIC E3 UBIQUITIN-PROTEIN LIGASE-RELATED', 242834),
(333878, 'PTHR12420:SF43', NULL, NULL, NULL, NULL, 'SI:DKEY-14O1.20-RELATED', 242834),
(333879, 'PTHR47621:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH-TYPE ANTIVIRAL PROTEIN 1-LIKE', 242835),
(333880, 'PTHR47621', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH-TYPE ANTIVIRAL PROTEIN 1-LIKE', 242835),
(333881, 'PTHR46482:SF9', NULL, NULL, NULL, NULL, '5''-ADENYLYLSULFATE REDUCTASE 1, CHLOROPLASTIC', 242836),
(333882, 'PTHR46482:SF14', NULL, NULL, NULL, NULL, '5''-ADENYLYLSULFATE REDUCTASE 3, CHLOROPLASTIC', 242836),
(333883, 'PTHR46482:SF13', NULL, NULL, NULL, NULL, '5''-ADENYLYLSULFATE REDUCTASE 1, CHLOROPLASTIC-LIKE', 242836),
(333884, 'PTHR46482', NULL, NULL, NULL, NULL, '5''-ADENYLYLSULFATE REDUCTASE 3, CHLOROPLASTIC', 242836),
(333885, 'PTHR46482:SF3', NULL, NULL, NULL, NULL, '5''-ADENYLYLSULFATE REDUCTASE 2, CHLOROPLASTIC', 242836),
(333886, 'PTHR46482:SF4', NULL, NULL, NULL, NULL, '5''-ADENYLYLSULFATE REDUCTASE 1, CHLOROPLASTIC-LIKE', 242836),
(333887, 'PTHR19268:SF8', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 27-RELATED', 242837),
(333888, 'PTHR19268:SF7', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 85-RELATED', 242837),
(333889, 'PTHR19268:SF4', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 173-RELATED', 242837),
(333890, 'PTHR19268:SF2', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 242837),
(333891, 'PTHR19268', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR', 242837),
(333892, 'PTHR13318:SF190', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 14', 242838),
(333893, 'PTHR13318:SF76', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SKIP2', 242838),
(333894, 'PTHR13318:SF77', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 4-LIKE', 242838),
(333895, 'PTHR13318:SF74', NULL, NULL, NULL, NULL, 'OS02G0658500 PROTEIN', 242838),
(333896, 'PTHR13318:SF193', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 16', 242838),
(333897, 'PTHR13318:SF75', NULL, NULL, NULL, NULL, 'RNI-LIKE SUPERFAMILY PROTEIN', 242838),
(333898, 'PTHR13318:SF233', NULL, NULL, NULL, NULL, '', 242838),
(333899, 'PTHR13318:SF232', NULL, NULL, NULL, NULL, '', 242838),
(333900, 'PTHR13318:SF231', NULL, NULL, NULL, NULL, '', 242838),
(333901, 'PTHR13318:SF230', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 242838),
(333902, 'PTHR13318:SF237', NULL, NULL, NULL, NULL, 'OS04G0503500 PROTEIN', 242838),
(333903, 'PTHR13318:SF236', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 242838),
(333904, 'PTHR13318:SF235', NULL, NULL, NULL, NULL, '', 242838),
(333905, 'PTHR13318:SF234', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RAD7, PROTEIN', 242838);
INSERT INTO "PUBLIC"."MODEL" VALUES
(333906, 'PTHR13318:SF119', NULL, NULL, NULL, NULL, 'RNI-LIKE SUPERFAMILY PROTEIN', 242838),
(333907, 'PTHR13318:SF239', NULL, NULL, NULL, NULL, 'FGR51P', 242838),
(333908, 'PTHR13318:SF238', NULL, NULL, NULL, NULL, '', 242838),
(333909, 'PTHR13318:SF240', NULL, NULL, NULL, NULL, 'DYNEIN REGULATORY COMPLEX SUBUNIT 6', 242838),
(333910, 'PTHR13318:SF88', NULL, NULL, NULL, NULL, 'EIN3-BINDING F-BOX PROTEIN 1', 242838),
(333911, 'PTHR13318:SF85', NULL, NULL, NULL, NULL, 'F-BOX FAMILY PROTEIN', 242838),
(333912, 'PTHR13318:SF86', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 10', 242838),
(333913, 'PTHR13318:SF244', NULL, NULL, NULL, NULL, 'F-BOX PLANT-LIKE PROTEIN', 242838),
(333914, 'PTHR13318:SF243', NULL, NULL, NULL, NULL, 'VIER F-BOX PROTEIN 2-RELATED', 242838),
(333915, 'PTHR13318:SF242', NULL, NULL, NULL, NULL, 'F-BOX SKP2A-LIKE PROTEIN', 242838),
(333916, 'PTHR13318:SF121', NULL, NULL, NULL, NULL, 'RICH REPEAT PROTEIN, PUTATIVE-RELATED', 242838),
(333917, 'PTHR13318:SF241', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 242838),
(333918, 'PTHR13318:SF248', NULL, NULL, NULL, NULL, '', 242838),
(333919, 'PTHR13318:SF247', NULL, NULL, NULL, NULL, 'GH16156P-RELATED', 242838),
(333920, 'PTHR13318:SF246', NULL, NULL, NULL, NULL, 'PROTEIN CBG00897', 242838),
(333921, 'PTHR13318:SF245', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT MAX2 HOMOLOG', 242838),
(333922, 'PTHR13318:SF124', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 242838),
(333923, 'PTHR13318:SF95', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT FAMILY PROTEIN', 242838),
(333924, 'PTHR13318:SF92', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 8-RELATED', 242838),
(333925, 'PTHR13318:SF129', NULL, NULL, NULL, NULL, 'EIN3-BINDING F-BOX-LIKE PROTEIN', 242838),
(333926, 'PTHR13318:SF249', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 242838),
(333927, 'PTHR13318:SF19', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 5', 242838),
(333928, 'PTHR13318:SF170', NULL, NULL, NULL, NULL, 'OS04G0371600 PROTEIN', 242838),
(333929, 'PTHR13318:SF98', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 14-LIKE', 242838),
(333930, 'PTHR13318:SF99', NULL, NULL, NULL, NULL, 'EIN3-BINDING F-BOX PROTEIN 2-LIKE', 242838),
(333931, 'PTHR13318:SF173', NULL, NULL, NULL, NULL, 'OS06G0605900 PROTEIN', 242838),
(333932, 'PTHR13318:SF171', NULL, NULL, NULL, NULL, 'OS01G0881900 PROTEIN', 242838),
(333933, 'PTHR13318:SF178', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 242838),
(333934, 'PTHR13318:SF176', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN AT-B', 242838),
(333935, 'PTHR13318:SF175', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN, LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 242838),
(333936, 'PTHR13318:SF212', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 17', 242838),
(333937, 'PTHR13318:SF179', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 15', 242838),
(333938, 'PTHR13318:SF217', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SKP2B', 242838),
(333939, 'PTHR13318', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 242838),
(333940, 'PTHR13318:SF216', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN', 242838),
(333941, 'PTHR13318:SF28', NULL, NULL, NULL, NULL, 'CORONATINE-INSENSITIVE PROTEIN HOMOLOG 2', 242838),
(333942, 'PTHR13318:SF184', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN, LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 242838),
(333943, 'PTHR13318:SF182', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 14', 242838),
(333944, 'PTHR13318:SF101', NULL, NULL, NULL, NULL, 'F-BOX/LRR PROTEIN', 242838),
(333945, 'PTHR13318:SF26', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 12', 242838),
(333946, 'PTHR13318:SF188', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 242838),
(333947, 'PTHR13318:SF186', NULL, NULL, NULL, NULL, 'DISTAL MEMBRANE-ARM ASSEMBLY COMPLEX PROTEIN 2', 242838),
(333948, 'PTHR13318:SF105', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 3', 242838),
(333949, 'PTHR13318:SF226', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-CONTAINING PROTEIN-RELATED', 242838);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(333950, 'PTHR13318:SF225', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 242838),
(333951, 'PTHR13318:SF224', NULL, NULL, NULL, NULL, 'F-BOX_5 DOMAIN-CONTAINING PROTEIN', 242838),
(333952, 'PTHR13318:SF223', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 20-LIKE', 242838),
(333953, 'PTHR13318:SF229', NULL, NULL, NULL, NULL, '', 242838),
(333954, 'PTHR13318:SF228', NULL, NULL, NULL, NULL, '', 242838),
(333955, 'PTHR13318:SF227', NULL, NULL, NULL, NULL, 'ANTAGONIST OF MITOTIC EXIT NETWORK PROTEIN 1', 242838),
(333956, 'PTHR13318:SF106', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 242838),
(333957, 'PTHR13318:SF152', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 4', 242838),
(333958, 'PTHR13318:SF151', NULL, NULL, NULL, NULL, 'SI:DKEY-192L18.9', 242838),
(333959, 'PTHR13318:SF156', NULL, NULL, NULL, NULL, 'F-BOX/LRR-LIKE PROTEIN', 242838),
(333960, 'PTHR13318:SF155', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 242838),
(333961, 'PTHR13318:SF37', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 3-LIKE', 242838),
(333962, 'PTHR13318:SF163', NULL, NULL, NULL, NULL, 'EIN3-BINDING F-BOX PROTEIN 2-LIKE', 242838),
(333963, 'PTHR13318:SF162', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT FAMILY PROTEIN', 242838),
(333964, 'PTHR13318:SF44', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 2', 242838),
(333965, 'PTHR13318:SF41', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 4', 242838),
(333966, 'PTHR13318:SF47', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 20', 242838),
(333967, 'PTHR13318:SF165', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN FBXL-1', 242838),
(333968, 'PTHR13318:SF164', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 242838),
(333969, 'PTHR13318:SF202', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN', 242838),
(333970, 'PTHR13318:SF169', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 29', 242838),
(333971, 'PTHR13318:SF168', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 242838),
(333972, 'PTHR13318:SF50', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 7', 242838),
(333973, 'PTHR13318:SF208', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 242838),
(333974, 'PTHR13318:SF205', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN YLR352W', 242838),
(333975, 'PTHR13318:SF251', NULL, NULL, NULL, NULL, 'REPEAT PROTEIN (LRRP), PUTATIVE-RELATED', 242838),
(333976, 'PTHR13318:SF250', NULL, NULL, NULL, NULL, 'EIN3-BINDING F-BOX PROTEIN 2', 242838),
(333977, 'PTHR13318:SF255', NULL, NULL, NULL, NULL, 'OS08G0459100 PROTEIN', 242838),
(333978, 'PTHR13318:SF254', NULL, NULL, NULL, NULL, 'PROTEIN AMN1 HOMOLOG', 242838),
(333979, 'PTHR13318:SF133', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SKIP2', 242838),
(333980, 'PTHR13318:SF132', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 242838),
(333981, 'PTHR13318:SF253', NULL, NULL, NULL, NULL, 'F-BOX_5 DOMAIN-CONTAINING PROTEIN', 242838),
(333982, 'PTHR13318:SF252', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 242838),
(333983, 'PTHR13318:SF131', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 242838),
(333984, 'PTHR13318:SF259', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 242838),
(333985, 'PTHR13318:SF258', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SKP2A', 242838),
(333986, 'PTHR13318:SF257', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 242838),
(333987, 'PTHR13318:SF256', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SKIP2-LIKE', 242838),
(333988, 'PTHR13318:SF262', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 16', 242838),
(333989, 'PTHR13318:SF261', NULL, NULL, NULL, NULL, '', 242838),
(333990, 'PTHR13318:SF260', NULL, NULL, NULL, NULL, 'AGAP004683-PA', 242838),
(333991, 'PTHR13318:SF145', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 4-LIKE', 242838),
(333992, 'PTHR13318:SF266', NULL, NULL, NULL, NULL, 'F-BOX AND LEUCINE-RICH REPEAT PROTEIN 6, ISOFORM A-RELATED', 242838),
(333993, 'PTHR13318:SF265', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT DOMAIN-CONTAINING PROTEIN', 242838);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(333994, 'PTHR13318:SF264', NULL, NULL, NULL, NULL, 'F-BOX/RNI-LIKE SUPERFAMILY PROTEIN-RELATED', 242838),
(333995, 'PTHR13318:SF142', NULL, NULL, NULL, NULL, 'BNAA10G30250D PROTEIN', 242838),
(333996, 'PTHR13318:SF263', NULL, NULL, NULL, NULL, 'BNAA09G03940D PROTEIN', 242838),
(333997, 'PTHR13318:SF149', NULL, NULL, NULL, NULL, 'F-BOX FAMILY PROTEIN', 242838),
(333998, 'PTHR13318:SF148', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN MAX2', 242838),
(333999, 'PTHR13318:SF267', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT MAX2 HOMOLOG A-LIKE', 242838),
(334000, 'PTHR13318:SF71', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN FBL11', 242838),
(334001, 'PTHR41328:SF3', NULL, NULL, NULL, NULL, 'PBSX PHAGE TERMINASE SMALL SUBUNIT', 242839),
(334002, 'PTHR41328:SF2', NULL, NULL, NULL, NULL, 'TERMINASE SMALL SUBUNIT', 242839),
(334003, 'PTHR41328', NULL, NULL, NULL, NULL, 'TERMINASE SMALL SUBUNIT-RELATED', 242839),
(334004, 'PTHR46281:SF30', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 6B-LIKE-RELATED', 242840),
(334005, 'PTHR46281:SF8', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 6B-2', 242840),
(334006, 'PTHR46281:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 12, MITOCHONDRIAL', 242840),
(334007, 'PTHR46281', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 6B', 242840),
(334008, 'PTHR46281:SF28', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE, SUBUNIT VIB FAMILY PROTEIN-RELATED', 242840),
(334009, 'PTHR46281:SF29', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 6B', 242840),
(334010, 'PTHR46281:SF13', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT', 242840),
(334011, 'PTHR46281:SF24', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE POLYPEPTIDE VIB', 242840),
(334012, 'PTHR46281:SF25', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 6B-3', 242840),
(334013, 'PTHR46281:SF26', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE, SUBUNIT VIB-RELATED', 242840),
(334014, 'PTHR46281:SF27', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE, SUBUNIT VIB FAMILY PROTEIN', 242840),
(334015, 'PTHR46281:SF22', NULL, NULL, NULL, NULL, '', 242840),
(334016, 'PTHR46281:SF11', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 6B-LIKE-RELATED', 242840),
(334017, 'PTHR46281:SF23', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 6B-2-LIKE', 242840),
(334018, 'PTHR46281:SF12', NULL, NULL, NULL, NULL, 'BNAANNG38290D PROTEIN', 242840),
(334019, 'PTHR12735:SF27', NULL, NULL, NULL, NULL, 'BOLA-LIKE PROTEIN 2', 242841),
(334020, 'PTHR12735:SF40', NULL, NULL, NULL, NULL, '', 242841),
(334021, 'PTHR12735', NULL, NULL, NULL, NULL, 'BOLA-LIKE PROTEIN-RELATED', 242841),
(334022, 'PTHR12735:SF41', NULL, NULL, NULL, NULL, '', 242841),
(334023, 'PTHR12735:SF42', NULL, NULL, NULL, NULL, 'BOLA-LIKE PROTEIN 2', 242841),
(334024, 'PTHR12735:SF43', NULL, NULL, NULL, NULL, 'BNAA09G06960D PROTEIN', 242841),
(334025, 'PTHR36868', NULL, NULL, NULL, NULL, 'NUTRITIONALLY-REGULATED ADIPOSE AND CARDIAC ENRICHED PROTEIN HOMOLOG', 242842),
(334026, 'PTHR36868:SF1', NULL, NULL, NULL, NULL, 'NUTRITIONALLY-REGULATED ADIPOSE AND CARDIAC ENRICHED PROTEIN HOMOLOG', 242842),
(334027, 'PTHR34730:SF1', NULL, NULL, NULL, NULL, 'BPI1 DOMAIN-CONTAINING PROTEIN', 242843),
(334028, 'PTHR34730', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', 242843),
(334029, 'PTHR15437:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR 2, MITOCHONDRIAL', 242844),
(334030, 'PTHR15437:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR 1, MITOCHONDRIAL', 242844),
(334031, 'PTHR15437:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR, MITOCHONDRIAL', 242844),
(334032, 'PTHR15437', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR, MITOCHONDRIAL', 242844),
(334033, 'PTHR15437:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR 5, MITOCHONDRIAL', 242844),
(334034, 'PTHR36156', NULL, NULL, NULL, NULL, 'SLR2101 PROTEIN', 242845),
(334035, 'PTHR36156:SF3', NULL, NULL, NULL, NULL, 'CUPIN_2 DOMAIN-CONTAINING PROTEIN', 242845),
(334036, 'PTHR36156:SF2', NULL, NULL, NULL, NULL, 'CUPIN_2 DOMAIN-CONTAINING PROTEIN', 242845);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(334037, 'PTHR12936', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX 10', 242846),
(334038, 'PTHR12936:SF5', NULL, NULL, NULL, NULL, 'DOC DOMAIN-CONTAINING PROTEIN', 242846),
(334039, 'PTHR12936:SF4', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT 10', 242846),
(334040, 'PTHR12936:SF2', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT 10', 242846),
(334041, 'PTHR12936:SF0', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT 10', 242846),
(334042, 'PTHR31675:SF49', NULL, NULL, NULL, NULL, 'AXIAL REGULATOR YABBY 5', 242847),
(334043, 'PTHR31675:SF28', NULL, NULL, NULL, NULL, 'AXIAL REGULATOR YABBY 5-LIKE', 242847),
(334044, 'PTHR31675:SF47', NULL, NULL, NULL, NULL, 'AXIAL REGULATOR YABBY 1-LIKE', 242847),
(334045, 'PTHR31675:SF25', NULL, NULL, NULL, NULL, 'PLANT-SPECIFIC TRANSCRIPTION FACTOR YABBY FAMILY PROTEIN', 242847),
(334046, 'PTHR31675:SF48', NULL, NULL, NULL, NULL, 'PROTEIN YABBY 6', 242847),
(334047, 'PTHR31675:SF46', NULL, NULL, NULL, NULL, 'PROTEIN YABBY 4', 242847),
(334048, 'PTHR31675:SF43', NULL, NULL, NULL, NULL, 'AXIAL REGULATOR YABBY 3', 242847),
(334049, 'PTHR31675:SF41', NULL, NULL, NULL, NULL, '', 242847),
(334050, 'PTHR31675:SF42', NULL, NULL, NULL, NULL, 'YABBY DOMAIN CLASS TRANSCRIPTION FACTOR', 242847),
(334051, 'PTHR31675:SF40', NULL, NULL, NULL, NULL, 'YABBY PROTEIN-RELATED', 242847),
(334052, 'PTHR31675:SF0', NULL, NULL, NULL, NULL, 'AXIAL REGULATOR YABBY 1', 242847),
(334053, 'PTHR31675:SF4', NULL, NULL, NULL, NULL, 'AXIAL REGULATOR YABBY1', 242847),
(334054, 'PTHR31675:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CRABS CLAW', 242847),
(334055, 'PTHR31675:SF7', NULL, NULL, NULL, NULL, 'PROTEIN YABBY 5', 242847),
(334056, 'PTHR31675', NULL, NULL, NULL, NULL, 'PROTEIN YABBY 6-RELATED', 242847),
(334057, 'PTHR31675:SF8', NULL, NULL, NULL, NULL, 'AXIAL REGULATOR YABBY 4', 242847),
(334058, 'PTHR31675:SF6', NULL, NULL, NULL, NULL, 'AXIAL REGULATOR YABBY 5-LIKE', 242847),
(334059, 'PTHR31675:SF38', NULL, NULL, NULL, NULL, 'PROTEIN YABBY 2', 242847),
(334060, 'PTHR31675:SF39', NULL, NULL, NULL, NULL, 'BNAA09G31050D PROTEIN', 242847),
(334061, 'PTHR31675:SF37', NULL, NULL, NULL, NULL, 'FAS PROTEIN', 242847),
(334062, 'PTHR31675:SF34', NULL, NULL, NULL, NULL, 'BNAC08G43150D PROTEIN', 242847),
(334063, 'PTHR31675:SF32', NULL, NULL, NULL, NULL, 'MALE STERILE PROTEIN-RELATED', 242847),
(334064, 'PTHR31675:SF33', NULL, NULL, NULL, NULL, 'YABBY PROTEIN-RELATED', 242847),
(334065, 'PTHR31675:SF30', NULL, NULL, NULL, NULL, 'AXIAL REGULATOR YABBY 2-RELATED', 242847),
(334066, 'PTHR31675:SF50', NULL, NULL, NULL, NULL, '', 242847),
(334067, 'PTHR45432:SF2', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 242848),
(334068, 'PTHR45432:SF6', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 242848),
(334069, 'PTHR45432:SF5', NULL, NULL, NULL, NULL, 'PROTEIN DNAJ, PUTATIVE-RELATED', 242848),
(334070, 'PTHR45432', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ 11, CHLOROPLASTIC-LIKE', 242848),
(334071, 'PTHR45432:SF8', NULL, NULL, NULL, NULL, 'DNAJ DOMAIN-CONTAINING PROTEIN-RELATED', 242848),
(334072, 'PTHR45432:SF7', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ', 242848),
(334073, 'PTHR12886:SF0', NULL, NULL, NULL, NULL, 'GPI MANNOSYLTRANSFERASE 1', 242849),
(334074, 'PTHR12886', NULL, NULL, NULL, NULL, 'PIG-M MANNOSYLTRANSFERASE', 242849),
(334075, 'PTHR24033:SF223', NULL, NULL, NULL, NULL, 'NOTCH 3', 242850),
(334076, 'PTHR24033:SF212', NULL, NULL, NULL, NULL, 'NETRIN-G1-RELATED', 242850),
(334077, 'PTHR24033:SF211', NULL, NULL, NULL, NULL, 'PROTEIN GLP-1', 242850),
(334078, 'PTHR24033:SF222', NULL, NULL, NULL, NULL, 'NOTCH RECEPTOR 2', 242850),
(334079, 'PTHR24033:SF221', NULL, NULL, NULL, NULL, '', 242850),
(334080, 'PTHR24033:SF220', NULL, NULL, NULL, NULL, 'DELTA/NOTCH-LIKE EGF REPEAT-CONTAINING', 242850),
(334081, 'PTHR24033:SF151', NULL, NULL, NULL, NULL, 'LAMININ SUBUNIT GAMMA-2', 242850),
(334082, 'PTHR24033:SF219', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN-RELATED', 242850),
(334083, 'PTHR24033:SF218', NULL, NULL, NULL, NULL, '', 242850);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(334084, 'PTHR24033:SF217', NULL, NULL, NULL, NULL, 'MULTIPLE EPIDERMAL GROWTH FACTOR-LIKE DOMAINS PROTEIN 8', 242850),
(334085, 'PTHR24033', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 242850),
(334086, 'PTHR24033:SF205', NULL, NULL, NULL, NULL, 'SPERM TRANSMEMBRANE PROTEIN 9', 242850),
(334087, 'PTHR24033:SF216', NULL, NULL, NULL, NULL, 'NOTCH RECEPTOR 4', 242850),
(334088, 'PTHR24033:SF215', NULL, NULL, NULL, NULL, '', 242850),
(334089, 'PTHR24033:SF214', NULL, NULL, NULL, NULL, 'DUMPY, ISOFORM Q', 242850),
(334090, 'PTHR24033:SF193', NULL, NULL, NULL, NULL, 'PROTEIN EYES SHUT HOMOLOG', 242850),
(334091, 'PTHR46849:SF1', NULL, NULL, NULL, NULL, 'RCC1 DOMAIN-CONTAINING PROTEIN 1', 242851),
(334092, 'PTHR46849', NULL, NULL, NULL, NULL, 'RCC1 DOMAIN-CONTAINING PROTEIN 1', 242851),
(334093, 'PTHR31515', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN-RELATED', 242852),
(334094, 'PTHR31515:SF8', NULL, NULL, NULL, NULL, '', 242852),
(334095, 'PTHR31515:SF9', NULL, NULL, NULL, NULL, 'BNAC07G33530D PROTEIN', 242852),
(334096, 'PTHR31515:SF6', NULL, NULL, NULL, NULL, '', 242852),
(334097, 'PTHR31515:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 242852),
(334098, 'PTHR31515:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 242852),
(334099, 'PTHR31515:SF0', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 242852),
(334100, 'PTHR10281:SF24', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED PROGESTERONE RECEPTOR COMPONENT 2', 242853),
(334101, 'PTHR10281:SF23', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED PROGESTERONE RECEPTOR COMPONENT 1', 242853),
(334102, 'PTHR10281:SF45', NULL, NULL, NULL, NULL, 'MEMBRANE STEROID-BINDING PROTEIN 2', 242853),
(334103, 'PTHR10281:SF109', NULL, NULL, NULL, NULL, 'DAMAGE RESPONSE PROTEIN 1', 242853),
(334104, 'PTHR10281:SF108', NULL, NULL, NULL, NULL, 'STEROID BINDING PROTEIN 1, PUTATIVE, EXPRESSED-RELATED', 242853),
(334105, 'PTHR10281:SF107', NULL, NULL, NULL, NULL, 'VACUOLE MEMBRANE PROTEIN-RELATED', 242853),
(334106, 'PTHR10281:SF106', NULL, NULL, NULL, NULL, 'IP06960P-RELATED', 242853),
(334107, 'PTHR10281:SF105', NULL, NULL, NULL, NULL, 'MEMBRANE STEROID-BINDING PROTEIN 2-LIKE ISOFORM X1', 242853),
(334108, 'PTHR10281:SF1', NULL, NULL, NULL, NULL, 'VACUOLE MEMBRANE PROTEIN 1', 242853),
(334109, 'PTHR10281:SF104', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 HEME-BINDING DOMAIN-CONTAINING PROTEIN', 242853),
(334110, 'PTHR10281:SF103', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 HEME-BINDING DOMAIN-CONTAINING PROTEIN', 242853),
(334111, 'PTHR10281:SF4', NULL, NULL, NULL, NULL, 'NEUFERRICIN', 242853),
(334112, 'PTHR10281', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED PROGESTERONE RECEPTOR COMPONENT-RELATED', 242853),
(334113, 'PTHR10281:SF97', NULL, NULL, NULL, NULL, 'VACUOLE MEMBRANE PROTEIN KMS1-LIKE', 242853),
(334114, 'PTHR10281:SF74', NULL, NULL, NULL, NULL, 'MEMBRANE STEROID-BINDING PROTEIN 1', 242853),
(334115, 'PTHR10281:SF96', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED PROGESTERONE BINDING PROTEIN 3-RELATED', 242853),
(334116, 'PTHR10281:SF76', NULL, NULL, NULL, NULL, 'CALCUTTA CUP-RELATED', 242853),
(334117, 'PTHR10281:SF112', NULL, NULL, NULL, NULL, 'VACUOLE MEMBRANE PROTEIN KMS1-LIKE', 242853),
(334118, 'PTHR10281:SF111', NULL, NULL, NULL, NULL, 'VACUOLE MEMBRANE PROTEIN KMS1', 242853),
(334119, 'PTHR10281:SF70', NULL, NULL, NULL, NULL, 'OS02G0640300 PROTEIN', 242853),
(334120, 'PTHR10281:SF73', NULL, NULL, NULL, NULL, 'OS07G0571500 PROTEIN', 242853),
(334121, 'PTHR10281:SF95', NULL, NULL, NULL, NULL, 'BNAC01G22640D PROTEIN', 242853),
(334122, 'PTHR10281:SF110', NULL, NULL, NULL, NULL, '', 242853),
(334123, 'PTHR10281:SF94', NULL, NULL, NULL, NULL, 'MEMBRANE STEROID-BINDING PROTEIN 2', 242853),
(334124, 'PTHR10281:SF72', NULL, NULL, NULL, NULL, 'NEUDESIN', 242853),
(334125, 'PTHR43656:SF2', NULL, NULL, NULL, NULL, 'BINDING OXIDOREDUCTASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G08260)-RELATED', 242854),
(334126, 'PTHR43656', NULL, NULL, NULL, NULL, 'BINDING OXIDOREDUCTASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G08260)-RELATED', 242854),
(334127, 'PTHR43656:SF5', NULL, NULL, NULL, NULL, 'OXIDORED_FMN DOMAIN-CONTAINING PROTEIN', 242854); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(334128, 'PTHR46936', NULL, NULL, NULL, NULL, 'ARABINOSYLTRANSFERASE XEG113', 242855),
(334129, 'PTHR46936:SF1', NULL, NULL, NULL, NULL, 'ARABINOSYLTRANSFERASE XEG113', 242855),
(334130, 'PTHR46936:SF4', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-DIPHOSPHO-SUGAR TRANSFERASE FAMILY PROTEIN', 242855),
(334131, 'PTHR46936:SF3', NULL, NULL, NULL, NULL, 'NUCLEOTID_TRANS DOMAIN-CONTAINING PROTEIN', 242855),
(334132, 'PTHR37532:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ISCX', 242856),
(334133, 'PTHR37532', NULL, NULL, NULL, NULL, 'PROTEIN ISCX', 242856),
(334134, 'PTHR30105', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED YIBQ-RELATED', 242857),
(334135, 'PTHR30105:SF2', NULL, NULL, NULL, NULL, 'DIVERGENT POLYSACCHARIDE DEACETYLASE SUPERFAMILY', 242857),
(334136, 'PTHR42976:SF1', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_18 DOMAIN-CONTAINING PROTEIN', 242858),
(334137, 'PTHR42976', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL CHITINASE/LYSOZYME-RELATED', 242858),
(334138, 'PTHR13354:SF11', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE 9', 242859),
(334139, 'PTHR13354:SF8', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE 9', 242859),
(334140, 'PTHR13354:SF9', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE RSBN1L', 242859),
(334141, 'PTHR13354', NULL, NULL, NULL, NULL, 'ROUND SPERMATID BASIC PROTEIN 1', 242859),
(334142, 'PTHR13038:SF19', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 9', 242860),
(334143, 'PTHR13038:SF10', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 9', 242860),
(334144, 'PTHR13038:SF14', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 9B', 242860),
(334145, 'PTHR13038', NULL, NULL, NULL, NULL, 'APG9 AUTOPHAGY 9', 242860),
(334146, 'PTHR13038:SF13', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 9A', 242860),
(334147, 'PTHR13038:SF18', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 9', 242860),
(334148, 'PTHR28632:SF11', NULL, NULL, NULL, NULL, 'TRANSLATION MACHINERY-ASSOCIATED PROTEIN 7', 242861),
(334149, 'PTHR28632:SF12', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 72', 242861),
(334150, 'PTHR28632:SF7', NULL, NULL, NULL, NULL, 'BNAC05G37320D PROTEIN', 242861),
(334151, 'PTHR28632:SF8', NULL, NULL, NULL, NULL, 'BNAA06G09940D PROTEIN', 242861),
(334152, 'PTHR28632:SF9', NULL, NULL, NULL, NULL, 'F9L1.21 PROTEIN', 242861),
(334153, 'PTHR28632:SF2', NULL, NULL, NULL, NULL, 'TRANSLATION MACHINERY-ASSOCIATED PROTEIN 7', 242861),
(334154, 'PTHR28632', NULL, NULL, NULL, NULL, 'TRANSLATION MACHINERY-ASSOCIATED PROTEIN 7', 242861),
(334155, 'PTHR31931', NULL, NULL, NULL, NULL, 'PROTEIN CHURCHILL', 242862),
(334156, 'PTHR31931:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CHURCHILL', 242862),
(334157, 'PTHR11435:SF1', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE CHAIN 6', 242863),
(334158, 'PTHR11435', NULL, NULL, NULL, NULL, 'NADH UBIQUINONE OXIDOREDUCTASE SUBUNIT ND6', 242863),
(334159, 'PTHR32282:SF29', NULL, NULL, NULL, NULL, 'PENICILLIN-BINDING PROTEIN 1A/1B', 242864),
(334160, 'PTHR32282:SF15', NULL, NULL, NULL, NULL, 'PENICILLIN-BINDING PROTEIN 1C', 242864),
(334161, 'PTHR32282:SF27', NULL, NULL, NULL, NULL, 'PENICILLIN-BINDING PROTEIN 1A', 242864),
(334162, 'PTHR32282', NULL, NULL, NULL, NULL, 'BINDING PROTEIN TRANSPEPTIDASE, PUTATIVE-RELATED', 242864),
(334163, 'PTHR32282:SF24', NULL, NULL, NULL, NULL, 'TRANSGLY DOMAIN-CONTAINING PROTEIN', 242864),
(334164, 'PTHR32282:SF33', NULL, NULL, NULL, NULL, 'PENICILLIN-INSENSITIVE TRANSGLYCOSYLASE', 242864),
(334165, 'PTHR32282:SF11', NULL, NULL, NULL, NULL, 'PENICILLIN-BINDING PROTEIN 1B', 242864),
(334166, 'PTHR32282:SF34', NULL, NULL, NULL, NULL, 'PENICILLIN-BINDING PROTEIN 1A', 242864),
(334167, 'PTHR32282:SF31', NULL, NULL, NULL, NULL, 'PENICILLIN-INSENSITIVE TRANSGLYCOSYLASE', 242864),
(334168, 'PTHR32282:SF32', NULL, NULL, NULL, NULL, 'PENICILLIN-BINDING PROTEIN 1F', 242864),
(334169, 'PTHR46998:SF7', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 242865),
(334170, 'PTHR46998', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 11', 242865),
(334171, 'PTHR46998:SF5', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 12', 242865);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(334172, 'PTHR46998:SF6', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 242865),
(334173, 'PTHR46998:SF9', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 6', 242865),
(334174, 'PTHR46998:SF1', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 10', 242865),
(334175, 'PTHR46998:SF2', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 11', 242865),
(334176, 'PTHR19359:SF124', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 HEME-BINDING DOMAIN-CONTAINING PROTEIN', 242866),
(334177, 'PTHR19359:SF146', NULL, NULL, NULL, NULL, 'BINDING DOMAIN CONTAINING PROTEIN, PUTATIVE-RELATED', 242866),
(334178, 'PTHR19359:SF18', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 DOMAIN-CONTAINING PROTEIN', 242866),
(334179, 'PTHR19359:SF145', NULL, NULL, NULL, NULL, 'B5, PUTATIVE-RELATED', 242866),
(334180, 'PTHR19359:SF101', NULL, NULL, NULL, NULL, 'CYTOCHROME B5-LIKE HEME/STEROID BINDING DOMAIN CONTAINING PROTEIN, EXPRESSED', 242866),
(334181, 'PTHR19359:SF123', NULL, NULL, NULL, NULL, 'CYTOCHROME B5', 242866),
(334182, 'PTHR19359:SF144', NULL, NULL, NULL, NULL, 'CYTOCHROME B5', 242866),
(334183, 'PTHR19359:SF121', NULL, NULL, NULL, NULL, 'CYB5A PROTEIN', 242866),
(334184, 'PTHR19359:SF143', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 HEME-BINDING DOMAIN-CONTAINING PROTEIN', 242866),
(334185, 'PTHR19359:SF120', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 HEME-BINDING DOMAIN-CONTAINING PROTEIN', 242866),
(334186, 'PTHR19359:SF142', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 HEME-BINDING DOMAIN-CONTAINING PROTEIN', 242866),
(334187, 'PTHR19359:SF141', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 HEME-BINDING DOMAIN-CONTAINING PROTEIN', 242866),
(334188, 'PTHR19359:SF140', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 HEME-BINDING DOMAIN-CONTAINING PROTEIN', 242866),
(334189, 'PTHR19359:SF107', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 ISOFORM B', 242866),
(334190, 'PTHR19359:SF129', NULL, NULL, NULL, NULL, 'CYTOCHROME B5', 242866),
(334191, 'PTHR19359:SF106', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 HEME-BINDING DOMAIN-CONTAINING PROTEIN', 242866),
(334192, 'PTHR19359:SF149', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 HEME-BINDING DOMAIN-CONTAINING PROTEIN', 242866),
(334193, 'PTHR19359:SF127', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 ISOFORM D', 242866),
(334194, 'PTHR19359:SF148', NULL, NULL, NULL, NULL, 'CYTOCHROME B5-LIKE HEME/STEROID-BINDING DOMAIN PROTEIN', 242866),
(334195, 'PTHR19359:SF126', NULL, NULL, NULL, NULL, 'CYTOCHROME B5', 242866),
(334196, 'PTHR19359:SF147', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 2-RELATED', 242866),
(334197, 'PTHR19359:SF75', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 A', 242866),
(334198, 'PTHR19359:SF95', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 HEME-BINDING DOMAIN-CONTAINING PROTEIN', 242866),
(334199, 'PTHR19359:SF30', NULL, NULL, NULL, NULL, 'OS02G0649800 PROTEIN', 242866),
(334200, 'PTHR19359:SF74', NULL, NULL, NULL, NULL, 'B5, PUTATIVE-RELATED', 242866),
(334201, 'PTHR19359:SF79', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 ISOFORM C', 242866),
(334202, 'PTHR19359:SF14', NULL, NULL, NULL, NULL, 'CYTOCHROME B5-RELATED', 242866),
(334203, 'PTHR19359:SF77', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 ISOFORM D', 242866),
(334204, 'PTHR19359:SF135', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 ISOFORM E', 242866),
(334205, 'PTHR19359:SF112', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 HEME-BINDING DOMAIN-CONTAINING PROTEIN', 242866),
(334206, 'PTHR19359', NULL, NULL, NULL, NULL, 'CYTOCHROME B5', 242866),
(334207, 'PTHR19359:SF111', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 HEME-BINDING DOMAIN-CONTAINING PROTEIN', 242866),
(334208, 'PTHR19359:SF132', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 TYPE B', 242866),
(334209, 'PTHR19359:SF130', NULL, NULL, NULL, NULL, 'CYTOCHROME B5-LIKE', 242866),
(334210, 'PTHR19359:SF119', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 C', 242866),
(334211, 'PTHR19359:SF118', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 TYPE B', 242866),
(334212, 'PTHR19359:SF139', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 HEME-BINDING DOMAIN-CONTAINING PROTEIN', 242866),
(334213, 'PTHR19359:SF117', NULL, NULL, NULL, NULL, 'CYTOCHROME B5-LIKE', 242866);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(334214, 'PTHR19359:SF116', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 HEME-BINDING DOMAIN-CONTAINING PROTEIN', 242866),
(334215, 'PTHR19359:SF138', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 HEME-BINDING DOMAIN-CONTAINING PROTEIN', 242866),
(334216, 'PTHR19359:SF137', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 HEME-BINDING DOMAIN-CONTAINING PROTEIN', 242866),
(334217, 'PTHR19359:SF136', NULL, NULL, NULL, NULL, 'CYTOCHROME B5-LIKE HEME/STEROID BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 242866),
(334218, 'PTHR19359:SF41', NULL, NULL, NULL, NULL, 'GEO08203P1', 242866),
(334219, 'PTHR19359:SF25', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 HEME-BINDING DOMAIN-CONTAINING PROTEIN', 242866),
(334220, 'PTHR30176:SF6', NULL, NULL, NULL, NULL, 'FERREDOXIN-TYPE PROTEIN NAPG', 242867),
(334221, 'PTHR30176:SF3', NULL, NULL, NULL, NULL, 'FERREDOXIN-TYPE PROTEIN NAPH', 242867),
(334222, 'PTHR30176', NULL, NULL, NULL, NULL, 'FERREDOXIN-TYPE PROTEIN NAPH', 242867),
(334223, 'PTHR45750:SF1', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE KAT2A', 242868),
(334224, 'PTHR45750:SF3', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE', 242868),
(334225, 'PTHR45750:SF2', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE KAT2B', 242868),
(334226, 'PTHR45750', NULL, NULL, NULL, NULL, 'GH11602P', 242868),
(334227, 'PTHR45750:SF4', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE', 242868),
(334228, 'PTHR47554:SF1', NULL, NULL, NULL, NULL, 'SORTING NEXIN MVP1', 242869),
(334229, 'PTHR47554', NULL, NULL, NULL, NULL, 'SORTING NEXIN MVP1', 242869),
(334230, 'PTHR35831:SF2', NULL, NULL, NULL, NULL, 'OS01G0642200 PROTEIN', 242870),
(334231, 'PTHR35831', NULL, NULL, NULL, NULL, 'OS01G0642200 PROTEIN', 242870),
(334232, 'PTHR35831:SF1', NULL, NULL, NULL, NULL, '', 242870),
(334233, 'PTHR15494', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING TYROSINE PHOSPHORYLATION-REGULATED PROTEIN', 242871),
(334234, 'PTHR15494:SF0', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING TYROSINE PHOSPHORYLATION-REGULATED PROTEIN', 242871),
(334235, 'PTHR18839:SF4', NULL, NULL, NULL, NULL, 'MISP FAMILY MEMBER 3', 242872),
(334236, 'PTHR18839:SF5', NULL, NULL, NULL, NULL, 'SI:CH211-262I1.3', 242872),
(334237, 'PTHR18839', NULL, NULL, NULL, NULL, 'MITOTIC INTERACTOR AND SUBSTRATE OF PLK1 MISP FAMILY MEMBER', 242872),
(334238, 'PTHR18839:SF3', NULL, NULL, NULL, NULL, 'MITOTIC INTERACTOR AND SUBSTRATE OF PLK1', 242872),
(334239, 'PTHR18839:SF0', NULL, NULL, NULL, NULL, 'AKAP2_C DOMAIN-CONTAINING PROTEIN', 242872),
(334240, 'PTHR37544:SF1', NULL, NULL, NULL, NULL, '', 242873),
(334241, 'PTHR37544', NULL, NULL, NULL, NULL, '', 242873),
(334242, 'PTHR37544:SF4', NULL, NULL, NULL, NULL, '', 242873),
(334243, 'PTHR37544:SF3', NULL, NULL, NULL, NULL, 'SPRAY', 242873),
(334244, 'PTHR15925', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOMAL PROTEIN S23', 242874),
(334245, 'PTHR15925:SF2', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S23, MITOCHONDRIAL', 242874),
(334246, 'PTHR31848', NULL, NULL, NULL, NULL, '', 242875),
(334247, 'PTHR31848:SF0', NULL, NULL, NULL, NULL, 'REFILIN-A', 242875),
(334248, 'PTHR31848:SF1', NULL, NULL, NULL, NULL, '', 242875),
(334249, 'PTHR31848:SF2', NULL, NULL, NULL, NULL, 'REFILIN-B', 242875),
(334250, 'PTHR15379:SF2', NULL, NULL, NULL, NULL, 'CELL GROWTH REGULATOR WITH RING FINGER DOMAIN PROTEIN 1', 242876),
(334251, 'PTHR15379', NULL, NULL, NULL, NULL, 'CELL GROWTH REGULATOR WITH RING FINGER DOMAIN PROTEIN 1', 242876),
(334252, 'PTHR21559', NULL, NULL, NULL, NULL, 'DYSTROGLYCAN-RELATED', 242877),
(334253, 'PTHR21559:SF24', NULL, NULL, NULL, NULL, 'ALPHA-DYSTROGLYCAN', 242877),
(334254, 'PTHR21559:SF22', NULL, NULL, NULL, NULL, 'DYSTROGLYCAN', 242877),
(334255, 'PTHR21559:SF21', NULL, NULL, NULL, NULL, 'ALPHA-DYSTROGLYCAN', 242877),
(334256, 'PTHR45776:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR EB', 242878),
(334257, 'PTHR45776:SF4', NULL, NULL, NULL, NULL, 'MICROPHTHALMIA-ASSOCIATED TRANSCRIPTION FACTOR', 242878),
(334258, 'PTHR45776:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR E3', 242878),
(334259, 'PTHR45776:SF2', NULL, NULL, NULL, NULL, 'MIP04163P', 242878);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(334260, 'PTHR45776:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR EC', 242878),
(334261, 'PTHR45776', NULL, NULL, NULL, NULL, 'MIP04163P', 242878),
(334262, 'PTHR14758:SF5', NULL, NULL, NULL, NULL, 'PROTEIN FAM110C', 242879),
(334263, 'PTHR14758:SF4', NULL, NULL, NULL, NULL, 'PROTEIN FAM110A', 242879),
(334264, 'PTHR14758', NULL, NULL, NULL, NULL, 'AGAP005440-PA', 242879),
(334265, 'PTHR14758:SF3', NULL, NULL, NULL, NULL, 'PROTEIN FAM110D', 242879),
(334266, 'PTHR14758:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM110B', 242879),
(334267, 'PTHR14758:SF1', NULL, NULL, NULL, NULL, 'FAM110_C DOMAIN-CONTAINING PROTEIN', 242879),
(334268, 'PTHR21339:SF0', NULL, NULL, NULL, NULL, 'RADICAL S-ADENOSYL METHIONINE DOMAIN-CONTAINING PROTEIN 2', 242880),
(334269, 'PTHR21339', NULL, NULL, NULL, NULL, 'RADICAL S-ADENOSYL METHIONINE DOMAIN-CONTAINING PROTEIN 2', 242880),
(334270, 'PTHR37258:SF1', NULL, NULL, NULL, NULL, 'FANTOM PROTEIN', 242881),
(334271, 'PTHR37258', NULL, NULL, NULL, NULL, 'FANTOM PROTEIN', 242881),
(334272, 'PTHR37258:SF2', NULL, NULL, NULL, NULL, '', 242881),
(334273, 'PTHR33178:SF8', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 242882),
(334274, 'PTHR33178:SF7', NULL, NULL, NULL, NULL, 'STRESS RESPONSIVE A/B BARREL DOMAIN PROTEIN', 242882),
(334275, 'PTHR33178:SF5', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242882),
(334276, 'PTHR33178:SF4', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242882),
(334277, 'PTHR33178:SF3', NULL, NULL, NULL, NULL, 'STRESS-RESPONSE A/B BARREL DOMAIN-CONTAINING PROTEIN UP3', 242882),
(334278, 'PTHR33178:SF10', NULL, NULL, NULL, NULL, 'STRESS-RESPONSE A/B BARREL DOMAIN-CONTAINING PROTEIN', 242882),
(334279, 'PTHR33178:SF11', NULL, NULL, NULL, NULL, 'STRESS-RESPONSE A/B BARREL DOMAIN-CONTAINING PROTEIN', 242882),
(334280, 'PTHR33178:SF12', NULL, NULL, NULL, NULL, 'STRESS-RESPONSE A/B BARREL DOMAIN-CONTAINING PROTEIN DABB1', 242882),
(334281, 'PTHR33178:SF13', NULL, NULL, NULL, NULL, 'STRESS-RESPONSE A/B BARREL DOMAIN-CONTAINING PROTEIN', 242882),
(334282, 'PTHR33178:SF15', NULL, NULL, NULL, NULL, 'STRESS-RESPONSE A/B BARREL DOMAIN-CONTAINING PROTEIN', 242882),
(334283, 'PTHR33178:SF16', NULL, NULL, NULL, NULL, 'STRESS-RESPONSE A/B BARREL DOMAIN-CONTAINING PROTEIN', 242882),
(334284, 'PTHR33178:SF17', NULL, NULL, NULL, NULL, 'STRESS-RESPONSE A/B BARREL DOMAIN-CONTAINING PROTEIN', 242882),
(334285, 'PTHR33178:SF19', NULL, NULL, NULL, NULL, 'STRESS-RESPONSE A/B BARREL DOMAIN-CONTAINING PROTEIN', 242882),
(334286, 'PTHR33178', NULL, NULL, NULL, NULL, '', 242882),
(334287, 'PTHR33569', NULL, NULL, NULL, NULL, 'UREASE', 242883),
(334288, 'PTHR33569:SF1', NULL, NULL, NULL, NULL, 'UREASE', 242883),
(334289, 'PTHR47171', NULL, NULL, NULL, NULL, 'FARA-RELATED', 242884),
(334290, 'PTHR47171:SF4', NULL, NULL, NULL, NULL, 'ACETAMIDASE REGULATORY PROTEIN', 242884),
(334291, 'PTHR47171:SF3', NULL, NULL, NULL, NULL, 'FARA-RELATED', 242884),
(334292, 'PTHR47171:SF6', NULL, NULL, NULL, NULL, 'SPECIFIC TRANSCRIPTION FACTOR, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G06130)-RELATED', 242884),
(334293, 'PTHR47171:SF5', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 242884),
(334294, 'PTHR47171:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, PUTATIVE-RELATED', 242884),
(334295, 'PTHR47171:SF1', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 242884),
(334296, 'PTHR16140:SF20', NULL, NULL, NULL, NULL, 'NON-STRUCTURAL MAINTENANCE OF CHROMOSOMES ELEMENT 4', 242885),
(334297, 'PTHR16140:SF21', NULL, NULL, NULL, NULL, 'NON-STRUCTURAL MAINTENANCE OF CHROMOSOMES ELEMENT 4', 242885),
(334298, 'PTHR16140:SF1', NULL, NULL, NULL, NULL, 'EP300-INTERACTING INHIBITOR OF DIFFERENTIATION 3', 242885),
(334299, 'PTHR16140', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 242885),
(334300, 'PTHR16140:SF2', NULL, NULL, NULL, NULL, 'NON-STRUCTURAL MAINTENANCE OF CHROMOSOMES ELEMENT 4 HOMOLOG A', 242885),
(334301, 'PTHR16140:SF15', NULL, NULL, NULL, NULL, 'NON-STRUCTURAL MAINTENANCE OF CHROMOSOMES ELEMENT 4', 242885),
(334302, 'PTHR16140:SF0', NULL, NULL, NULL, NULL, 'NON-STRUCTURAL MAINTENANCE OF CHROMOSOMES ELEMENT 4', 242885);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(334303, 'PTHR16140:SF17', NULL, NULL, NULL, NULL, 'NON-STRUCTURAL MAINTENANCE OF CHROMOSOMES ELEMENT 4', 242885),
(334304, 'PTHR16140:SF16', NULL, NULL, NULL, NULL, 'NON-STRUCTURAL MAINTENANCE OF CHROMOSOMES ELEMENT 4', 242885),
(334305, 'PTHR16140:SF19', NULL, NULL, NULL, NULL, 'NON-STRUCTURAL MAINTENANCE OF CHROMOSOMES ELEMENT 4', 242885),
(334306, 'PTHR16140:SF4', NULL, NULL, NULL, NULL, 'NON-STRUCTURAL MAINTENANCE OF CHROMOSOMES ELEMENT 4', 242885),
(334307, 'PTHR16140:SF18', NULL, NULL, NULL, NULL, 'NON-STRUCTURAL MAINTENANCE OF CHROMOSOMES ELEMENT 4', 242885),
(334308, 'PTHR38444:SF1', NULL, NULL, NULL, NULL, 'ENTEROBACTIN BIOSYNTHESIS PROTEIN YBDZ', 242886),
(334309, 'PTHR38444', NULL, NULL, NULL, NULL, 'ENTEROBACTIN BIOSYNTHESIS PROTEIN YBDZ', 242886),
(334310, 'PTHR32297:SF1', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL MODIFIER 1', 242887),
(334311, 'PTHR32297', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL MODIFIER 1', 242887),
(334312, 'PTHR18895:SF74', NULL, NULL, NULL, NULL, 'MTRF1L RELEASE FACTOR GLUTAMINE METHYLTRANSFERASE', 242888),
(334313, 'PTHR18895', NULL, NULL, NULL, NULL, 'HEMK METHYLTRANSFERASE', 242888),
(334314, 'PTHR36342:SF1', NULL, NULL, NULL, NULL, 'PTB DOMAIN ENGULFMENT ADAPTER', 242889),
(334315, 'PTHR36342', NULL, NULL, NULL, NULL, 'PTB DOMAIN ENGULFMENT ADAPTER', 242889),
(334316, 'PTHR33560:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM227B', 242890),
(334317, 'PTHR33560:SF3', NULL, NULL, NULL, NULL, '', 242890),
(334318, 'PTHR33560:SF1', NULL, NULL, NULL, NULL, 'FAMILY WITH SEQUENCE SIMILARITY 227 MEMBER A', 242890),
(334319, 'PTHR33560:SF4', NULL, NULL, NULL, NULL, 'PROTEIN FAM227A', 242890),
(334320, 'PTHR33560', NULL, NULL, NULL, NULL, 'PROTEIN FAM227B', 242890),
(334321, 'PTHR45687:SF35', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP2-7', 242891),
(334322, 'PTHR45687:SF79', NULL, NULL, NULL, NULL, '', 242891),
(334323, 'PTHR45687:SF36', NULL, NULL, NULL, NULL, '', 242891),
(334324, 'PTHR45687:SF106', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE INTRINSIC PROTEIN', 242891),
(334325, 'PTHR45687:SF39', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP2-4-RELATED', 242891),
(334326, 'PTHR45687:SF107', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP2 5', 242891),
(334327, 'PTHR45687:SF108', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP-TYPE PTOM75-RELATED', 242891),
(334328, 'PTHR45687:SF109', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP1-3', 242891),
(334329, 'PTHR45687:SF70', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE INTRINSIC PROTEIN', 242891),
(334330, 'PTHR45687:SF73', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP2-1', 242891),
(334331, 'PTHR45687:SF75', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP2-2-RELATED', 242891),
(334332, 'PTHR45687:SF74', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP1.1', 242891),
(334333, 'PTHR45687:SF77', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP1-1', 242891),
(334334, 'PTHR45687:SF76', NULL, NULL, NULL, NULL, 'BNAA02G06180D PROTEIN', 242891),
(334335, 'PTHR45687:SF102', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP2-2-RELATED', 242891),
(334336, 'PTHR45687:SF103', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP1-2-RELATED', 242891),
(334337, 'PTHR45687:SF104', NULL, NULL, NULL, NULL, 'PIP2.1, PUTATIVE-RELATED', 242891),
(334338, 'PTHR45687:SF105', NULL, NULL, NULL, NULL, '', 242891),
(334339, 'PTHR45687:SF100', NULL, NULL, NULL, NULL, 'PLASMA INTRINSIC PROTEIN 2-4', 242891),
(334340, 'PTHR45687:SF101', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP2-5-RELATED', 242891),
(334341, 'PTHR45687:SF68', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP-TYPE PTOM75-RELATED', 242891),
(334342, 'PTHR45687:SF26', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP2-6-RELATED', 242891),
(334343, 'PTHR45687:SF69', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP2-5-RELATED', 242891),
(334344, 'PTHR45687:SF62', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP2-1-LIKE', 242891),
(334345, 'PTHR45687:SF61', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE INTRINSIC PROTEIN 2,4-RELATED', 242891),
(334346, 'PTHR45687', NULL, NULL, NULL, NULL, 'AQUAPORIN OR AQUAGLYCEROPORIN RELATED', 242891),
(334347, 'PTHR45687:SF113', NULL, NULL, NULL, NULL, 'MAJOR INTRINSIC PROTEIN, AQUAPORIN-LIKE PROTEIN-RELATED', 242891);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(334348, 'PTHR45687:SF110', NULL, NULL, NULL, NULL, 'AQUAPORIN', 242891),
(334349, 'PTHR45687:SF111', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP2-5', 242891),
(334350, 'PTHR45687:SF112', NULL, NULL, NULL, NULL, 'MAJOR INTRINSIC PROTEIN (MIP) FAMILY TRANSPORTER', 242891),
(334351, 'PTHR45687:SF57', NULL, NULL, NULL, NULL, 'MAJOR INTRINSIC PROTEIN, AQUAPORIN-LIKE PROTEIN-RELATED', 242891),
(334352, 'PTHR45687:SF56', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP1-5S', 242891),
(334353, 'PTHR45687:SF12', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP 1-3', 242891),
(334354, 'PTHR45687:SF58', NULL, NULL, NULL, NULL, 'BNAC03G65520D PROTEIN', 242891),
(334355, 'PTHR45687:SF19', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP2-7-RELATED', 242891),
(334356, 'PTHR45687:SF93', NULL, NULL, NULL, NULL, 'BNAA07G02320D PROTEIN', 242891),
(334357, 'PTHR45687:SF92', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP1-1-LIKE', 242891),
(334358, 'PTHR45687:SF51', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP1-4-RELATED', 242891),
(334359, 'PTHR45687:SF95', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP1-5-RELATED', 242891),
(334360, 'PTHR45687:SF94', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP2-1-RELATED', 242891),
(334361, 'PTHR45687:SF53', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP1-6', 242891),
(334362, 'PTHR45687:SF97', NULL, NULL, NULL, NULL, 'BNAA03G17030D PROTEIN', 242891),
(334363, 'PTHR45687:SF96', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP2-1-LIKE', 242891),
(334364, 'PTHR45687:SF8', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP2-3-RELATED', 242891),
(334365, 'PTHR45687:SF99', NULL, NULL, NULL, NULL, 'BNAA09G39170D PROTEIN', 242891),
(334366, 'PTHR45687:SF10', NULL, NULL, NULL, NULL, '', 242891),
(334367, 'PTHR45687:SF98', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP2 10', 242891),
(334368, 'PTHR45687:SF54', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP-TYPE-RELATED', 242891),
(334369, 'PTHR45687:SF6', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP2-7-RELATED', 242891),
(334370, 'PTHR45687:SF45', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP1-2', 242891),
(334371, 'PTHR45687:SF48', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP2 7A', 242891),
(334372, 'PTHR45687:SF47', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP1-1', 242891),
(334373, 'PTHR45687:SF49', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP2-7-LIKE', 242891),
(334374, 'PTHR45687:SF82', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP1-2-RELATED', 242891),
(334375, 'PTHR45687:SF81', NULL, NULL, NULL, NULL, '', 242891),
(334376, 'PTHR45687:SF83', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP2-8-RELATED', 242891),
(334377, 'PTHR45687:SF41', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP2-11T', 242891),
(334378, 'PTHR45687:SF85', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP1-3/PIP1-4', 242891),
(334379, 'PTHR45687:SF44', NULL, NULL, NULL, NULL, '', 242891),
(334380, 'PTHR45687:SF43', NULL, NULL, NULL, NULL, 'AQUAPORIN PIP1 2A', 242891),
(334381, 'PTHR45687:SF91', NULL, NULL, NULL, NULL, 'AQUAPORIN OR AQUAGLYCEROPORIN RELATED', 242891),
(334382, 'PTHR36808', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR ATRX-LIKE PROTEIN', 242892),
(334383, 'PTHR36808:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR ATRX-LIKE PROTEIN', 242892),
(334384, 'PTHR22093', NULL, NULL, NULL, NULL, 'LEUKOCYTE RECEPTOR CLUSTER  LRC  MEMBER 1', 242893),
(334385, 'PTHR22093:SF0', NULL, NULL, NULL, NULL, 'LEUKOCYTE RECEPTOR CLUSTER MEMBER 1', 242893),
(334386, 'PTHR34929:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN INAFM2-RELATED', 242894),
(334387, 'PTHR34929', NULL, NULL, NULL, NULL, 'ZGC:153157', 242894),
(334388, 'PTHR34929:SF1', NULL, NULL, NULL, NULL, 'ZGC:153157', 242894),
(334389, 'PTHR34929:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN INAFM1-RELATED', 242894),
(334390, 'PTHR32258:SF3', NULL, NULL, NULL, NULL, 'PROTEIN NETWORKED 4A', 242895),
(334391, 'PTHR32258:SF40', NULL, NULL, NULL, NULL, 'NAB DOMAIN-CONTAINING PROTEIN', 242895),
(334392, 'PTHR32258', NULL, NULL, NULL, NULL, 'PROTEIN NETWORKED 4A', 242895),
(334393, 'PTHR32258:SF41', NULL, NULL, NULL, NULL, 'PROTEIN NETWORKED 1C', 242895),
(334394, 'PTHR32258:SF42', NULL, NULL, NULL, NULL, 'NAB DOMAIN-CONTAINING PROTEIN', 242895),
(334395, 'PTHR32258:SF20', NULL, NULL, NULL, NULL, 'KINASE INTERACTING (KIP1-LIKE) FAMILY PROTEIN', 242895);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(334396, 'PTHR32258:SF21', NULL, NULL, NULL, NULL, 'KINASE INTERACTING (KIP1-LIKE) FAMILY PROTEIN', 242895),
(334397, 'PTHR32258:SF22', NULL, NULL, NULL, NULL, 'PROTEIN NETWORKED 3A-LIKE', 242895),
(334398, 'PTHR32258:SF45', NULL, NULL, NULL, NULL, 'PROTEIN NETWORKED 1B', 242895),
(334399, 'PTHR32258:SF48', NULL, NULL, NULL, NULL, 'CHROMOSOME SEGREGATION ATPASE-LIKE PROTEIN', 242895),
(334400, 'PTHR32258:SF26', NULL, NULL, NULL, NULL, 'KINASE INTERACTING (KIP1-LIKE) FAMILY PROTEIN', 242895),
(334401, 'PTHR32258:SF8', NULL, NULL, NULL, NULL, 'PROTEIN NETWORKED 1A', 242895),
(334402, 'PTHR32258:SF27', NULL, NULL, NULL, NULL, 'INTERACTING (KIP1-LIKE) FAMILY PROTEIN, PUTATIVE-RELATED', 242895),
(334403, 'PTHR32258:SF5', NULL, NULL, NULL, NULL, 'OS01G0167900 PROTEIN', 242895),
(334404, 'PTHR32258:SF49', NULL, NULL, NULL, NULL, 'NUCLEAR MITOTIC APPARATUS PROTEIN 1-LIKE ISOFORM X1', 242895),
(334405, 'PTHR32258:SF6', NULL, NULL, NULL, NULL, 'PROTEIN NETWORKED 1A', 242895),
(334406, 'PTHR32258:SF28', NULL, NULL, NULL, NULL, 'PROTEIN NETWORKED 3A-RELATED', 242895),
(334407, 'PTHR32258:SF29', NULL, NULL, NULL, NULL, 'PROTEIN NETWORKED 4B', 242895),
(334408, 'PTHR32258:SF9', NULL, NULL, NULL, NULL, 'PROTEIN NETWORKED 1A', 242895),
(334409, 'PTHR32258:SF50', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT BETA', 242895),
(334410, 'PTHR32258:SF51', NULL, NULL, NULL, NULL, '', 242895),
(334411, 'PTHR32258:SF52', NULL, NULL, NULL, NULL, 'KH_DOM_TYPE_1 DOMAIN-CONTAINING PROTEIN', 242895),
(334412, 'PTHR32258:SF10', NULL, NULL, NULL, NULL, 'OS03G0161100 PROTEIN', 242895),
(334413, 'PTHR32258:SF32', NULL, NULL, NULL, NULL, 'PROTEIN NETWORKED 1D', 242895),
(334414, 'PTHR32258:SF11', NULL, NULL, NULL, NULL, 'OS05G0168800 PROTEIN', 242895),
(334415, 'PTHR32258:SF34', NULL, NULL, NULL, NULL, 'PROTEIN NETWORKED 3A-LIKE', 242895),
(334416, 'PTHR32258:SF14', NULL, NULL, NULL, NULL, 'GB|AAF19561.1', 242895),
(334417, 'PTHR32258:SF15', NULL, NULL, NULL, NULL, 'KINASE INTERACTING (KIP1-LIKE) FAMILY PROTEIN', 242895),
(334418, 'PTHR32258:SF37', NULL, NULL, NULL, NULL, 'NAB DOMAIN-CONTAINING PROTEIN', 242895),
(334419, 'PTHR32258:SF17', NULL, NULL, NULL, NULL, 'PROTEIN NETWORKED 1A-LIKE', 242895),
(334420, 'PTHR32258:SF18', NULL, NULL, NULL, NULL, 'NAB DOMAIN-CONTAINING PROTEIN', 242895),
(334421, 'PTHR47525:SF1', NULL, NULL, NULL, NULL, 'OS07G0295200 PROTEIN', 242896),
(334422, 'PTHR47525', NULL, NULL, NULL, NULL, 'OS07G0295200 PROTEIN', 242896),
(334423, 'PTHR39560:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ADENYLYLTRANSFERASE FIC-RELATED', 242897),
(334424, 'PTHR39560', NULL, NULL, NULL, NULL, 'PROTEIN ADENYLYLTRANSFERASE FIC-RELATED', 242897),
(334425, 'PTHR46511:SF1', NULL, NULL, NULL, NULL, 'MORN REPEAT-CONTAINING PROTEIN 3', 242898),
(334426, 'PTHR46511', NULL, NULL, NULL, NULL, 'MORN REPEAT-CONTAINING PROTEIN 3', 242898),
(334427, 'PTHR42921:SF1', NULL, NULL, NULL, NULL, 'ACETOACETYL-COA SYNTHETASE', 242899),
(334428, 'PTHR42921:SF4', NULL, NULL, NULL, NULL, 'ACETOACETYL-COA SYNTHASE (AFU_ORTHOLOGUE AFUA_8G04770)', 242899),
(334429, 'PTHR42921', NULL, NULL, NULL, NULL, 'ACETOACETYL-COA SYNTHETASE', 242899),
(334430, 'PTHR11953', NULL, NULL, NULL, NULL, 'EXOSOME COMPLEX COMPONENT', 242900),
(334431, 'PTHR11953:SF1', NULL, NULL, NULL, NULL, 'EXOSOME COMPLEX COMPONENT RRP46', 242900),
(334432, 'PTHR11953:SF0', NULL, NULL, NULL, NULL, 'EXOSOME COMPLEX COMPONENT RRP41', 242900),
(334433, 'PTHR11953:SF2', NULL, NULL, NULL, NULL, 'EXOSOME COMPLEX COMPONENT MTR3', 242900),
(334434, 'PTHR12199:SF4', NULL, NULL, NULL, NULL, 'INTERPHOTORECEPTOR MATRIX PROTEOGLYCAN 2', 242901),
(334435, 'PTHR12199:SF3', NULL, NULL, NULL, NULL, 'INTERPHOTORECEPTOR MATRIX PROTEOGLYCAN 1', 242901),
(334436, 'PTHR12199', NULL, NULL, NULL, NULL, 'INTERPHOTORECEPTOR MATRIX PROTEOGLYCAN', 242901),
(334437, 'PTHR46269:SF4', NULL, NULL, NULL, NULL, 'OPTICIN', 242902),
(334438, 'PTHR46269', NULL, NULL, NULL, NULL, 'EPIPHYCAN-RELATED', 242902),
(334439, 'PTHR46269:SF3', NULL, NULL, NULL, NULL, 'EPIPHYCAN', 242902),
(334440, 'PTHR46269:SF1', NULL, NULL, NULL, NULL, 'MIMECAN', 242902);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(334441, 'PTHR46524:SF5', NULL, NULL, NULL, NULL, 'CW-TYPE DOMAIN-CONTAINING PROTEIN', 242903),
(334442, 'PTHR46524:SF13', NULL, NULL, NULL, NULL, 'CW-TYPE DOMAIN-CONTAINING PROTEIN', 242903),
(334443, 'PTHR46524:SF16', NULL, NULL, NULL, NULL, 'BNAA09G51070D PROTEIN', 242903),
(334444, 'PTHR46524:SF15', NULL, NULL, NULL, NULL, 'ZINC FINGER, CW-TYPE-RELATED', 242903),
(334445, 'PTHR46524:SF2', NULL, NULL, NULL, NULL, 'CYSTEINE-TRYPTOPHAN DOMAIN-CONTAINING ZINC FINGER PROTEIN 5', 242903),
(334446, 'PTHR46524:SF18', NULL, NULL, NULL, NULL, 'CW-TYPE ZINC FINGER', 242903),
(334447, 'PTHR46524:SF17', NULL, NULL, NULL, NULL, 'ZINC FINGER, CW-TYPE-RELATED', 242903),
(334448, 'PTHR46524:SF8', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 242903),
(334449, 'PTHR46524:SF7', NULL, NULL, NULL, NULL, 'CW-TYPE ZINC FINGER', 242903),
(334450, 'PTHR46524:SF12', NULL, NULL, NULL, NULL, 'CW-TYPE DOMAIN-CONTAINING PROTEIN', 242903),
(334451, 'PTHR46524', NULL, NULL, NULL, NULL, 'CW-TYPE ZINC FINGER', 242903),
(334452, 'PTHR46220:SF1', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN AGD12', 242904),
(334453, 'PTHR46220:SF16', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN AGD10', 242904),
(334454, 'PTHR46220:SF2', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN AGD11-RELATED', 242904),
(334455, 'PTHR46220:SF17', NULL, NULL, NULL, NULL, 'OS02G0198300 PROTEIN', 242904),
(334456, 'PTHR46220:SF14', NULL, NULL, NULL, NULL, 'BNAC05G44090D PROTEIN', 242904),
(334457, 'PTHR46220:SF15', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT ARF-TYPE GTPASE ACTIVATING FAMILY PROTEIN', 242904),
(334458, 'PTHR46220:SF18', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 242904),
(334459, 'PTHR46220:SF9', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT LIPID-BINDING (CALB DOMAIN) FAMILY PROTEIN-RELATED', 242904),
(334460, 'PTHR46220', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN AGD12', 242904),
(334461, 'PTHR46220:SF5', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN AGD13-RELATED', 242904),
(334462, 'PTHR46220:SF7', NULL, NULL, NULL, NULL, 'OS05G0382000 PROTEIN', 242904),
(334463, 'PTHR46220:SF12', NULL, NULL, NULL, NULL, 'C2 DOMAIN, ARF GTPASE ACTIVATING PROTEIN-RELATED', 242904),
(334464, 'PTHR46220:SF13', NULL, NULL, NULL, NULL, 'BNAA03G58510D PROTEIN', 242904),
(334465, 'PTHR14778:SF2', NULL, NULL, NULL, NULL, 'KINETOCHORE-ASSOCIATED PROTEIN DSN1 HOMOLOG', 242905),
(334466, 'PTHR14778', NULL, NULL, NULL, NULL, 'KINETOCHORE-ASSOCIATED PROTEIN DSN1 HOMOLOG', 242905),
(334467, 'PTHR46361', NULL, NULL, NULL, NULL, 'ELECTRON CARRIER/ PROTEIN DISULFIDE OXIDOREDUCTASE', 242906),
(334468, 'PTHR46361:SF3', NULL, NULL, NULL, NULL, 'ELECTRON CARRIER/ PROTEIN DISULFIDE OXIDOREDUCTASE', 242906),
(334469, 'PTHR46361:SF4', NULL, NULL, NULL, NULL, 'DISHEVELLED/EGL-10/LECKSTRIN DOMAIN PROTEIN', 242906),
(334470, 'PTHR46361:SF5', NULL, NULL, NULL, NULL, 'ZGC:152951', 242906),
(334471, 'PTHR46361:SF1', NULL, NULL, NULL, NULL, 'F26K24.21 PROTEIN', 242906),
(334472, 'PTHR35896:SF3', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 242907),
(334473, 'PTHR35896', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 242907),
(334474, 'PTHR36450', NULL, NULL, NULL, NULL, 'THIOREDOXIN', 242908),
(334475, 'PTHR36450:SF1', NULL, NULL, NULL, NULL, 'THIOREDOXIN', 242908),
(334476, 'PTHR10066:SF67', NULL, NULL, NULL, NULL, 'BETA-GLUCURONIDASE', 242909),
(334477, 'PTHR10066', NULL, NULL, NULL, NULL, 'BETA-GLUCURONIDASE', 242909),
(334478, 'PTHR33148:SF6', NULL, NULL, NULL, NULL, 'OS06G0260000 PROTEIN', 242910),
(334479, 'PTHR33148:SF39', NULL, NULL, NULL, NULL, '', 242910),
(334480, 'PTHR33148:SF37', NULL, NULL, NULL, NULL, '', 242910),
(334481, 'PTHR33148:SF54', NULL, NULL, NULL, NULL, 'BNAA09G18570D PROTEIN', 242910),
(334482, 'PTHR33148:SF32', NULL, NULL, NULL, NULL, 'OS09G0403000 PROTEIN', 242910),
(334483, 'PTHR33148:SF53', NULL, NULL, NULL, NULL, '', 242910),
(334484, 'PTHR33148:SF56', NULL, NULL, NULL, NULL, 'BNAANNG16590D PROTEIN', 242910); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(334485, 'PTHR33148:SF33', NULL, NULL, NULL, NULL, 'DUF4228 DOMAIN PROTEIN', 242910),
(334486, 'PTHR33148:SF55', NULL, NULL, NULL, NULL, 'OS01G0219300 PROTEIN', 242910),
(334487, 'PTHR33148:SF72', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242910),
(334488, 'PTHR33148:SF50', NULL, NULL, NULL, NULL, '', 242910),
(334489, 'PTHR33148:SF71', NULL, NULL, NULL, NULL, 'BNACNNG59600D PROTEIN', 242910),
(334490, 'PTHR33148:SF30', NULL, NULL, NULL, NULL, '', 242910),
(334491, 'PTHR33148:SF74', NULL, NULL, NULL, NULL, '', 242910),
(334492, 'PTHR33148:SF73', NULL, NULL, NULL, NULL, 'BNAC01G38850D PROTEIN', 242910),
(334493, 'PTHR33148:SF51', NULL, NULL, NULL, NULL, 'BNAA06G35000D PROTEIN', 242910),
(334494, 'PTHR33148:SF2', NULL, NULL, NULL, NULL, 'DUF4228 DOMAIN PROTEIN', 242910),
(334495, 'PTHR33148:SF3', NULL, NULL, NULL, NULL, 'PLASTID MOVEMENT IMPAIRED PROTEIN', 242910),
(334496, 'PTHR33148', NULL, NULL, NULL, NULL, 'PLASTID MOVEMENT IMPAIRED PROTEIN-RELATED', 242910),
(334497, 'PTHR33148:SF4', NULL, NULL, NULL, NULL, 'OS02G0667100 PROTEIN', 242910),
(334498, 'PTHR33148:SF69', NULL, NULL, NULL, NULL, 'DUF4228 DOMAIN PROTEIN', 242910),
(334499, 'PTHR33148:SF47', NULL, NULL, NULL, NULL, 'BNAC02G20520D PROTEIN', 242910),
(334500, 'PTHR33148:SF46', NULL, NULL, NULL, NULL, 'EMB|CAB85509.1', 242910),
(334501, 'PTHR33148:SF68', NULL, NULL, NULL, NULL, '', 242910),
(334502, 'PTHR33148:SF49', NULL, NULL, NULL, NULL, 'BNACNNG10630D PROTEIN', 242910),
(334503, 'PTHR33148:SF48', NULL, NULL, NULL, NULL, 'DUF4228 DOMAIN PROTEIN', 242910),
(334504, 'PTHR33148:SF64', NULL, NULL, NULL, NULL, 'OS02G0667300 PROTEIN', 242910),
(334505, 'PTHR33148:SF67', NULL, NULL, NULL, NULL, 'DUF4228 DOMAIN PROTEIN', 242910),
(334506, 'PTHR33148:SF61', NULL, NULL, NULL, NULL, '', 242910),
(334507, 'PTHR33148:SF41', NULL, NULL, NULL, NULL, 'DUF4228 DOMAIN PROTEIN', 242910),
(334508, 'PTHR33148:SF62', NULL, NULL, NULL, NULL, '', 242910),
(334509, 'PTHR33148:SF70', NULL, NULL, NULL, NULL, 'PLASTID MOVEMENT IMPAIRED PROTEIN', 242910),
(334510, 'PTHR40389:SF2', NULL, NULL, NULL, NULL, 'ENDOGENOUS RETROVIRUS GROUP K MEMBER 24 GAG POLYPROTEIN-RELATED', 242911),
(334511, 'PTHR40389', NULL, NULL, NULL, NULL, 'ENDOGENOUS RETROVIRUS GROUP K MEMBER 24 GAG POLYPROTEIN-RELATED', 242911),
(334512, 'PTHR40389:SF4', NULL, NULL, NULL, NULL, 'GAG_P10 DOMAIN-CONTAINING PROTEIN', 242911),
(334513, 'PTHR40389:SF3', NULL, NULL, NULL, NULL, 'IGE-BINDING PROTEIN', 242911),
(334514, 'PTHR36394:SF1', NULL, NULL, NULL, NULL, 'OS01G0277700 PROTEIN', 242912),
(334515, 'PTHR36394:SF2', NULL, NULL, NULL, NULL, 'BNAC09G36810D PROTEIN', 242912),
(334516, 'PTHR36394:SF3', NULL, NULL, NULL, NULL, '', 242912),
(334517, 'PTHR36394', NULL, NULL, NULL, NULL, 'OS01G0277700 PROTEIN', 242912),
(334518, 'PTHR23406:SF69', NULL, NULL, NULL, NULL, 'NADP-DEPENDENT MALIC ENZYME, CHLOROPLASTIC', 242913),
(334519, 'PTHR23406:SF68', NULL, NULL, NULL, NULL, 'MALIC ENZYME', 242913),
(334520, 'PTHR23406:SF27', NULL, NULL, NULL, NULL, 'NAD-DEPENDENT MALIC ENZYME, MITOCHONDRIAL', 242913),
(334521, 'PTHR23406:SF64', NULL, NULL, NULL, NULL, 'NADP-DEPENDENT MALIC ENZYME 3', 242913),
(334522, 'PTHR23406:SF20', NULL, NULL, NULL, NULL, 'NADP-DEPENDENT MALIC ENZYME, MITOCHONDRIAL', 242913),
(334523, 'PTHR23406:SF89', NULL, NULL, NULL, NULL, 'NADP-DEPENDENT MALIC ENZYME 1', 242913),
(334524, 'PTHR23406:SF66', NULL, NULL, NULL, NULL, 'MALIC ENZYME', 242913),
(334525, 'PTHR23406', NULL, NULL, NULL, NULL, 'MALIC ENZYME-RELATED', 242913),
(334526, 'PTHR23406:SF72', NULL, NULL, NULL, NULL, 'MALIC ENZYME', 242913),
(334527, 'PTHR23406:SF74', NULL, NULL, NULL, NULL, 'MALIC ENZYME', 242913),
(334528, 'PTHR23406:SF73', NULL, NULL, NULL, NULL, 'NAD-DEPENDENT MALIC ENZYME 2, MITOCHONDRIAL', 242913),
(334529, 'PTHR23406:SF90', NULL, NULL, NULL, NULL, 'MALIC ENZYME-RELATED', 242913),
(334530, 'PTHR23406:SF70', NULL, NULL, NULL, NULL, 'NADP-DEPENDENT MALIC ENZYME 2', 242913),
(334531, 'PTHR23406:SF91', NULL, NULL, NULL, NULL, 'MALIC ENZYME', 242913),
(334532, 'PTHR23406:SF79', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE (OXALOACETATE-DECARBOXYLATING)', 242913); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(334533, 'PTHR23406:SF76', NULL, NULL, NULL, NULL, 'NADP-DEPENDENT MALIC ENZYME 4, CHLOROPLASTIC', 242913),
(334534, 'PTHR23406:SF32', NULL, NULL, NULL, NULL, 'NADP-DEPENDENT MALIC ENZYME', 242913),
(334535, 'PTHR23406:SF75', NULL, NULL, NULL, NULL, 'MALIC ENZYME', 242913),
(334536, 'PTHR23406:SF78', NULL, NULL, NULL, NULL, 'MALIC ENZYME', 242913),
(334537, 'PTHR23406:SF34', NULL, NULL, NULL, NULL, 'NAD-DEPENDENT MALIC ENZYME, MITOCHONDRIAL', 242913),
(334538, 'PTHR23406:SF77', NULL, NULL, NULL, NULL, 'MALIC ENZYME', 242913),
(334539, 'PTHR23406:SF17', NULL, NULL, NULL, NULL, 'NADP-DEPENDENT MALIC ENZYME', 242913),
(334540, 'PTHR23406:SF85', NULL, NULL, NULL, NULL, 'MALIC ENZYME', 242913),
(334541, 'PTHR23406:SF81', NULL, NULL, NULL, NULL, 'MALIC ENZYME', 242913),
(334542, 'PTHR23406:SF80', NULL, NULL, NULL, NULL, 'GH17657P-RELATED', 242913),
(334543, 'PTHR15316:SF12', NULL, NULL, NULL, NULL, 'SURP MOTIF DOMAIN-CONTAINING PROTEIN', 242914),
(334544, 'PTHR15316:SF6', NULL, NULL, NULL, NULL, 'BNAA09G44470D PROTEIN', 242914),
(334545, 'PTHR15316:SF1', NULL, NULL, NULL, NULL, 'SPLICING FACTOR 3A SUBUNIT 1', 242914),
(334546, 'PTHR15316', NULL, NULL, NULL, NULL, 'SPLICEOSOME ASSOCIATED PROTEIN 114/SWAP SPLICING FACTOR-RELATED', 242914),
(334547, 'PTHR15316:SF9', NULL, NULL, NULL, NULL, 'SPLICEOSOME ASSOCIATED PROTEIN', 242914),
(334548, 'PTHR15316:SF10', NULL, NULL, NULL, NULL, 'BNAA09G55450D PROTEIN', 242914),
(334549, 'PTHR12684:SF2', NULL, NULL, NULL, NULL, 'TRNA 2''-PHOSPHOTRANSFERASE 1', 242915),
(334550, 'PTHR12684', NULL, NULL, NULL, NULL, 'PUTATIVE PHOSPHOTRANSFERASE', 242915),
(334551, 'PTHR43367:SF1', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR-LIKE APRR6-RELATED', 242916),
(334552, 'PTHR43367', NULL, NULL, NULL, NULL, '', 242916),
(334553, 'PTHR31762:SF16', NULL, NULL, NULL, NULL, 'COILED-COIL PROTEIN', 242917),
(334554, 'PTHR31762:SF13', NULL, NULL, NULL, NULL, 'OS11G0520500 PROTEIN', 242917),
(334555, 'PTHR31762:SF4', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN SCD2', 242917),
(334556, 'PTHR31762:SF8', NULL, NULL, NULL, NULL, 'CALDESMON-LIKE PROTEIN', 242917),
(334557, 'PTHR31762:SF11', NULL, NULL, NULL, NULL, 'MYOSIN', 242917),
(334558, 'PTHR31762:SF10', NULL, NULL, NULL, NULL, 'FAS-BINDING FACTOR-LIKE PROTEIN', 242917),
(334559, 'PTHR31762', NULL, NULL, NULL, NULL, 'FAS-BINDING FACTOR-LIKE PROTEIN', 242917),
(334560, 'PTHR39646:SF1', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE, SUBUNIT F (RPOF)', 242918),
(334561, 'PTHR39646', NULL, NULL, NULL, NULL, 'RNA POLYMERASE RPB4', 242918),
(334562, 'PTHR37813:SF1', NULL, NULL, NULL, NULL, 'FELS-2 PROPHAGE PROTEIN', 242919),
(334563, 'PTHR37813', NULL, NULL, NULL, NULL, 'FELS-2 PROPHAGE PROTEIN', 242919),
(334564, 'PTHR34280:SF14', NULL, NULL, NULL, NULL, 'BNAC02G36770D PROTEIN', 242920),
(334565, 'PTHR34280', NULL, NULL, NULL, NULL, 'OS01G0920100 PROTEIN', 242920),
(334566, 'PTHR34280:SF16', NULL, NULL, NULL, NULL, '', 242920),
(334567, 'PTHR34280:SF15', NULL, NULL, NULL, NULL, '', 242920),
(334568, 'PTHR34280:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242920),
(334569, 'PTHR34280:SF12', NULL, NULL, NULL, NULL, 'BNAA06G32320D PROTEIN', 242920),
(334570, 'PTHR34280:SF11', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 242920),
(334571, 'PTHR34280:SF5', NULL, NULL, NULL, NULL, 'DSR6', 242920),
(334572, 'PTHR34280:SF2', NULL, NULL, NULL, NULL, 'OS01G0920100 PROTEIN', 242920),
(334573, 'PTHR34280:SF8', NULL, NULL, NULL, NULL, '', 242920),
(334574, 'PTHR34280:SF17', NULL, NULL, NULL, NULL, '', 242920),
(334575, 'PTHR34280:SF7', NULL, NULL, NULL, NULL, 'OS04G0380200 PROTEIN', 242920),
(334576, 'PTHR31839:SF77', NULL, NULL, NULL, NULL, 'AP2 DOMAIN CBF PROTEIN', 242921),
(334577, 'PTHR31839:SF55', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 1F', 242921),
(334578, 'PTHR31839:SF11', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 1D', 242921),
(334579, 'PTHR31839:SF54', NULL, NULL, NULL, NULL, 'DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 242921);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(334580, 'PTHR31839:SF10', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 1A', 242921),
(334581, 'PTHR31839:SF32', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 1F-LIKE', 242921),
(334582, 'PTHR31839:SF31', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 1H', 242921),
(334583, 'PTHR31839:SF74', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 242921),
(334584, 'PTHR31839:SF30', NULL, NULL, NULL, NULL, 'CBF2-LIKE PROTEIN-RELATED', 242921),
(334585, 'PTHR31839:SF2', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 1D', 242921),
(334586, 'PTHR31839:SF59', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 242921),
(334587, 'PTHR31839:SF58', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 1C', 242921),
(334588, 'PTHR31839:SF79', NULL, NULL, NULL, NULL, 'AP2 DOMAIN CBF PROTEIN', 242921),
(334589, 'PTHR31839:SF57', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 1B', 242921),
(334590, 'PTHR31839:SF78', NULL, NULL, NULL, NULL, 'AP2 DOMAIN CBF PROTEIN', 242921),
(334591, 'PTHR31839:SF5', NULL, NULL, NULL, NULL, 'CBF2', 242921),
(334592, 'PTHR31839:SF51', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 242921),
(334593, 'PTHR31839:SF27', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 1E', 242921),
(334594, 'PTHR31839:SF21', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 1E', 242921),
(334595, 'PTHR31839:SF43', NULL, NULL, NULL, NULL, 'CBFIVA-A2', 242921),
(334596, 'PTHR31839:SF42', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 1F', 242921),
(334597, 'PTHR31839:SF41', NULL, NULL, NULL, NULL, 'CBFIVB-D21', 242921),
(334598, 'PTHR31839:SF63', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 242921),
(334599, 'PTHR31839:SF26', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN', 242921),
(334600, 'PTHR31839:SF48', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 242921),
(334601, 'PTHR31839:SF69', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 1B', 242921),
(334602, 'PTHR31839:SF25', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 1F', 242921),
(334603, 'PTHR31839:SF47', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 1F-LIKE', 242921),
(334604, 'PTHR31839:SF46', NULL, NULL, NULL, NULL, 'AP2 DOMAIN CBF PROTEIN', 242921),
(334605, 'PTHR31839:SF45', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 242921),
(334606, 'PTHR31839:SF67', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 242921),
(334607, 'PTHR31839:SF23', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 1A-RELATED', 242921),
(334608, 'PTHR31839:SF80', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 242921),
(334609, 'PTHR31839', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 1D', 242921),
(334610, 'PTHR31839:SF62', NULL, NULL, NULL, NULL, 'DEHYDRATION RESPONSE ELEMENT B1A-RELATED', 242921),
(334611, 'PTHR31839:SF83', NULL, NULL, NULL, NULL, 'DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 242921),
(334612, 'PTHR31839:SF82', NULL, NULL, NULL, NULL, 'AP2-EREBP TRANSCRIPTION FACTOR', 242921),
(334613, 'PTHR31839:SF60', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 242921),
(334614, 'PTHR31839:SF81', NULL, NULL, NULL, NULL, 'CBF/DREB1 TRANSCRIPTION FACTOR', 242921),
(334615, 'PTHR31839:SF39', NULL, NULL, NULL, NULL, 'CBF3 PROTEIN', 242921),
(334616, 'PTHR31839:SF38', NULL, NULL, NULL, NULL, 'AP2 DOMAIN CBF PROTEIN', 242921),
(334617, 'PTHR38504', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 7-1', 242922),
(334618, 'PTHR38504:SF1', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 7-1', 242922),
(334619, 'PTHR31450', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 19 LRRC19 FAMILY MEMBER', 242923),
(334620, 'PTHR31450:SF3', NULL, NULL, NULL, NULL, 'TYPE III ENDOSOME MEMBRANE PROTEIN TEMP', 242923);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(334621, 'PTHR31450:SF4', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 19', 242923),
(334622, 'PTHR31526:SF2', NULL, NULL, NULL, NULL, 'SOSS COMPLEX SUBUNIT C', 242924),
(334623, 'PTHR31526', NULL, NULL, NULL, NULL, 'SOSS COMPLEX SUBUNIT C', 242924),
(334624, 'PTHR30613', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN YBIU-RELATED', 242925),
(334625, 'PTHR30613:SF1', NULL, NULL, NULL, NULL, 'DUF1479 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_5G09280)', 242925),
(334626, 'PTHR35253:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 152', 242926),
(334627, 'PTHR35253', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 152', 242926),
(334628, 'PTHR22593:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 18', 242927),
(334629, 'PTHR22593:SF14', NULL, NULL, NULL, NULL, 'FHA DOMAIN-CONTAINING PROTEIN', 242927),
(334630, 'PTHR22593:SF13', NULL, NULL, NULL, NULL, 'FHA DOMAIN-CONTAINING PROTEIN', 242927),
(334631, 'PTHR22593:SF8', NULL, NULL, NULL, NULL, 'FHA DOMAIN-CONTAINING PROTEIN PS1', 242927),
(334632, 'PTHR22593', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 18', 242927),
(334633, 'PTHR22593:SF16', NULL, NULL, NULL, NULL, 'FHA DOMAIN-CONTAINING PROTEIN', 242927),
(334634, 'PTHR22593:SF15', NULL, NULL, NULL, NULL, 'FHA DOMAIN-CONTAINING PROTEIN PS1-LIKE', 242927),
(334635, 'PTHR22593:SF9', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 18', 242927),
(334636, 'PTHR21506:SF0', NULL, NULL, NULL, NULL, 'CONSERVED OLIGOMERIC GOLGI COMPLEX SUBUNIT 6', 242928),
(334637, 'PTHR21506', NULL, NULL, NULL, NULL, 'COMPONENT OF OLIGOMERIC GOLGI COMPLEX 6', 242928),
(334638, 'PTHR31712', NULL, NULL, NULL, NULL, 'DIETARY RESTRICTION OVER EXPRESSED', 242929),
(334639, 'PTHR31712:SF0', NULL, NULL, NULL, NULL, 'DIETARY RESTRICTION OVER EXPRESSED', 242929),
(334640, 'PTHR31024:SF9', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN', 242930),
(334641, 'PTHR31024:SF11', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN', 242930),
(334642, 'PTHR31024:SF7', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN', 242930),
(334643, 'PTHR31024:SF8', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN', 242930),
(334644, 'PTHR31024:SF5', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN', 242930),
(334645, 'PTHR31024:SF14', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN', 242930),
(334646, 'PTHR31024:SF6', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN-RELATED', 242930),
(334647, 'PTHR31024:SF3', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 242930),
(334648, 'PTHR31024:SF13', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN 160', 242930),
(334649, 'PTHR31024:SF12', NULL, NULL, NULL, NULL, 'PROTEIN CBG06646', 242930),
(334650, 'PTHR31024', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN', 242930),
(334651, 'PTHR43566', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', 242931),
(334652, 'PTHR43566:SF2', NULL, NULL, NULL, NULL, 'DUF4143 DOMAIN-CONTAINING PROTEIN', 242931),
(334653, 'PTHR43566:SF1', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 242931),
(334654, 'PTHR41521', NULL, NULL, NULL, NULL, '', 242932),
(334655, 'PTHR41521:SF4', NULL, NULL, NULL, NULL, 'BLR0684 PROTEIN', 242932),
(334656, 'PTHR42798:SF4', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 242933),
(334657, 'PTHR42798:SF6', NULL, NULL, NULL, NULL, 'CELL DIVISION ATP-BINDING PROTEIN FTSE', 242933),
(334658, 'PTHR42798:SF7', NULL, NULL, NULL, NULL, 'ALPHA-D-RIBOSE 1-METHYLPHOSPHONATE 5-TRIPHOSPHATE SYNTHASE SUBUNIT PHNL', 242933),
(334659, 'PTHR42798', NULL, NULL, NULL, NULL, 'LIPOPROTEIN-RELEASING SYSTEM ATP-BINDING PROTEIN LOLD', 242933),
(334660, 'PTHR42798:SF2', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN MG467-RELATED', 242933),
(334661, 'PTHR12655:SF7', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A THIOESTERASE 9, MITOCHONDRIAL-LIKE ISOFORM X1', 242934),
(334662, 'PTHR12655:SF8', NULL, NULL, NULL, NULL, 'HOTDOG ACOT-TYPE DOMAIN-CONTAINING PROTEIN', 242934),
(334663, 'PTHR12655:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG18926', 242934),
(334664, 'PTHR12655:SF0', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A THIOESTERASE 9, MITOCHONDRIAL', 242934);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(334665, 'PTHR12655', NULL, NULL, NULL, NULL, 'ACYL-COA THIOESTERASE', 242934),
(334666, 'PTHR12655:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG14719', 242934),
(334667, 'PTHR12655:SF3', NULL, NULL, NULL, NULL, 'THIOESTERASE, PUTATIVE-RELATED', 242934),
(334668, 'PTHR36385', NULL, NULL, NULL, NULL, 'OS07G0562900 PROTEIN', 242935),
(334669, 'PTHR36385:SF1', NULL, NULL, NULL, NULL, 'OS07G0562900 PROTEIN', 242935),
(334670, 'PTHR35822', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 45', 242936),
(334671, 'PTHR35822:SF1', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 45', 242936),
(334672, 'PTHR15197', NULL, NULL, NULL, NULL, 'COILIN P80', 242937),
(334673, 'PTHR15197:SF0', NULL, NULL, NULL, NULL, 'COILIN', 242937),
(334674, 'PTHR15197:SF1', NULL, NULL, NULL, NULL, 'COILIN', 242937),
(334675, 'PTHR15197:SF3', NULL, NULL, NULL, NULL, 'COILIN', 242937),
(334676, 'PTHR43042', NULL, NULL, NULL, NULL, 'SAM-DEPENDENT METHYLTRANSFERASE', 242938),
(334677, 'PTHR43042:SF2', NULL, NULL, NULL, NULL, 'SAM-DEPENDENT METHYLTRANSFERASE-RELATED', 242938),
(334678, 'PTHR43042:SF3', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA LARGE SUBUNIT METHYLTRANSFERASE YWBD-RELATED', 242938),
(334679, 'PTHR43042:SF1', NULL, NULL, NULL, NULL, 'METHYLTRANS_SAM DOMAIN-CONTAINING PROTEIN', 242938),
(334680, 'PTHR12869', NULL, NULL, NULL, NULL, 'SMALL SEVEN TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN', 242939),
(334681, 'PTHR12869:SF0', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 147', 242939),
(334682, 'PTHR12869:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 147', 242939),
(334683, 'PTHR33638', NULL, NULL, NULL, NULL, 'SELENOPROTEIN H', 242940),
(334684, 'PTHR33638:SF1', NULL, NULL, NULL, NULL, 'SELENOPROTEIN H', 242940),
(334685, 'PTHR33638:SF7', NULL, NULL, NULL, NULL, 'BNAC04G36410D PROTEIN', 242940),
(334686, 'PTHR33638:SF6', NULL, NULL, NULL, NULL, 'SELENIUM BINDING PROTEIN', 242940),
(334687, 'PTHR13465:SF2', NULL, NULL, NULL, NULL, 'PHAGOSOME ASSEMBLY FACTOR 1', 242941),
(334688, 'PTHR13465:SF3', NULL, NULL, NULL, NULL, 'PROTEIN BROAD-MINDED', 242941),
(334689, 'PTHR13465', NULL, NULL, NULL, NULL, 'UPF0183 PROTEIN', 242941),
(334690, 'PTHR47324:SF1', NULL, NULL, NULL, NULL, 'PROTEIN IRG-7', 242942),
(334691, 'PTHR47324:SF2', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 242942),
(334692, 'PTHR47324:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG04432', 242942),
(334693, 'PTHR47324', NULL, NULL, NULL, NULL, 'PROTEIN IRG-7-RELATED', 242942),
(334694, 'PTHR47324:SF4', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 242942),
(334695, 'PTHR45944:SF3', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 40', 242943),
(334696, 'PTHR45944:SF6', NULL, NULL, NULL, NULL, 'HIVEP ZINC FINGER 3A', 242943),
(334697, 'PTHR45944:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR HIVEP3', 242943),
(334698, 'PTHR45944', NULL, NULL, NULL, NULL, 'SCHNURRI, ISOFORM F', 242943),
(334699, 'PTHR45944:SF2', NULL, NULL, NULL, NULL, 'SCHNURRI, ISOFORM F', 242943),
(334700, 'PTHR45944:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR HIVEP2', 242943),
(334701, 'PTHR20916:SF18', NULL, NULL, NULL, NULL, 'IPT/TIG DOMAIN-CONTAINING PROTEIN', 242944),
(334702, 'PTHR20916:SF29', NULL, NULL, NULL, NULL, 'SERINE-LEUCINE-RICH REPEAT PROTEIN (AFU_ORTHOLOGUE AFUA_8G02230)', 242944),
(334703, 'PTHR20916:SF17', NULL, NULL, NULL, NULL, '', 242944),
(334704, 'PTHR20916:SF28', NULL, NULL, NULL, NULL, '', 242944),
(334705, 'PTHR20916:SF27', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 242944),
(334706, 'PTHR20916:SF3', NULL, NULL, NULL, NULL, '', 242944),
(334707, 'PTHR20916', NULL, NULL, NULL, NULL, 'CYSTEINE AND GLYCINE-RICH PROTEIN 2 BINDING PROTEIN', 242944),
(334708, 'PTHR20916:SF20', NULL, NULL, NULL, NULL, '', 242944),
(334709, 'PTHR20916:SF26', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH PROTEIN 2-BINDING PROTEIN', 242944),
(334710, 'PTHR20916:SF12', NULL, NULL, NULL, NULL, 'C2 NT-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', 242944),
(334711, 'PTHR33669:SF1', NULL, NULL, NULL, NULL, 'PROTEIN NIM1-INTERACTING 1-LIKE', 242945);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(334712, 'PTHR33669:SF13', NULL, NULL, NULL, NULL, '', 242945),
(334713, 'PTHR33669:SF24', NULL, NULL, NULL, NULL, '', 242945),
(334714, 'PTHR33669:SF25', NULL, NULL, NULL, NULL, '', 242945),
(334715, 'PTHR33669:SF14', NULL, NULL, NULL, NULL, 'PROTEIN NIM1-INTERACTING 3', 242945),
(334716, 'PTHR33669', NULL, NULL, NULL, NULL, 'PROTEIN NEGATIVE REGULATOR OF RESISTANCE', 242945),
(334717, 'PTHR33669:SF15', NULL, NULL, NULL, NULL, '', 242945),
(334718, 'PTHR33669:SF4', NULL, NULL, NULL, NULL, 'NRR REPRESSOR HOMOLOG 3', 242945),
(334719, 'PTHR33669:SF21', NULL, NULL, NULL, NULL, 'BNAA09G51300D PROTEIN', 242945),
(334720, 'PTHR33669:SF11', NULL, NULL, NULL, NULL, 'PROTEIN NIM1-INTERACTING 1', 242945),
(334721, 'PTHR33669:SF22', NULL, NULL, NULL, NULL, '', 242945),
(334722, 'PTHR33669:SF12', NULL, NULL, NULL, NULL, 'PROTEIN NEGATIVE REGULATOR OF RESISTANCE', 242945),
(334723, 'PTHR33669:SF17', NULL, NULL, NULL, NULL, '', 242945),
(334724, 'PTHR45885:SF5', NULL, NULL, NULL, NULL, '', 242946),
(334725, 'PTHR45885:SF1', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE 5-LIKE PROTEIN', 242946),
(334726, 'PTHR45885', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE 5-LIKE PROTEIN', 242946),
(334727, 'PTHR47536:SF1', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 5 MEMBER A', 242947),
(334728, 'PTHR47536', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 5 MEMBER A', 242947),
(334729, 'PTHR22913', NULL, NULL, NULL, NULL, 'HYALURONAN SYNTHASE', 242948),
(334730, 'PTHR22913:SF4', NULL, NULL, NULL, NULL, 'HYALURONAN SYNTHASE 1', 242948),
(334731, 'PTHR22913:SF6', NULL, NULL, NULL, NULL, 'HYALURONAN SYNTHASE 3', 242948),
(334732, 'PTHR22913:SF7', NULL, NULL, NULL, NULL, 'HYALURONAN SYNTHASE 2', 242948),
(334733, 'PTHR22913:SF12', NULL, NULL, NULL, NULL, 'MANNURONAN SYNTHASE', 242948),
(334734, 'PTHR36134:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN C16ORF54', 242949),
(334735, 'PTHR36134', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN C16ORF54', 242949),
(334736, 'PTHR43546:SF5', NULL, NULL, NULL, NULL, 'L-ASCORBATE-6-PHOSPHATE LACTONASE ULAG-RELATED', 242950),
(334737, 'PTHR43546:SF3', NULL, NULL, NULL, NULL, 'UPF0173 METAL-DEPENDENT HYDROLASE TM_1162', 242950),
(334738, 'PTHR43546', NULL, NULL, NULL, NULL, 'UPF0173 METAL-DEPENDENT HYDROLASE MJ1163-RELATED', 242950),
(334739, 'PTHR43546:SF4', NULL, NULL, NULL, NULL, 'UPF0282 PROTEIN TK1681', 242950),
(334740, 'PTHR43546:SF7', NULL, NULL, NULL, NULL, 'LACTAMASE_B DOMAIN-CONTAINING PROTEIN', 242950),
(334741, 'PTHR43546:SF8', NULL, NULL, NULL, NULL, 'LACTAMASE_B DOMAIN-CONTAINING PROTEIN', 242950),
(334742, 'PTHR37241', NULL, NULL, NULL, NULL, 'NEUROFILAMENT HEAVY PROTEIN', 242951),
(334743, 'PTHR37241:SF1', NULL, NULL, NULL, NULL, 'NEUROFILAMENT HEAVY PROTEIN', 242951),
(334744, 'PTHR13385:SF5', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE PROTEIN ATG12', 242952),
(334745, 'PTHR13385:SF7', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE PROTEIN ATG12B', 242952),
(334746, 'PTHR13385:SF4', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE PROTEIN ATG12', 242952),
(334747, 'PTHR13385:SF3', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE PROTEIN ATG12', 242952),
(334748, 'PTHR13385', NULL, NULL, NULL, NULL, 'AUTOPHAGY PROTEIN 12', 242952),
(334749, 'PTHR13385:SF0', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE PROTEIN ATG12', 242952),
(334750, 'PTHR24166:SF21', NULL, NULL, NULL, NULL, 'PROTEIN TANC2', 242953),
(334751, 'PTHR24166:SF30', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 63', 242953),
(334752, 'PTHR24166:SF52', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 65', 242953),
(334753, 'PTHR24166:SF58', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 242953),
(334754, 'PTHR24166:SF47', NULL, NULL, NULL, NULL, 'M-PHASE PHOSPHOPROTEIN 8', 242953),
(334755, 'PTHR24166:SF23', NULL, NULL, NULL, NULL, 'PROTEIN TANC1', 242953),
(334756, 'PTHR24166:SF45', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 242953),
(334757, 'PTHR24166:SF55', NULL, NULL, NULL, NULL, 'ROLLING PEBBLES, ISOFORM B', 242953),
(334758, 'PTHR24166:SF50', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE XBAT34-RELATED', 242953);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(334759, 'PTHR24166:SF60', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 242953),
(334760, 'PTHR24166', NULL, NULL, NULL, NULL, 'ROLLING PEBBLES, ISOFORM B', 242953),
(334761, 'PTHR24166:SF28', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 46', 242953),
(334762, 'PTHR24166:SF27', NULL, NULL, NULL, NULL, 'CORTACTIN-BINDING PROTEIN 2', 242953),
(334763, 'PTHR24166:SF59', NULL, NULL, NULL, NULL, 'ANKYRIN 2', 242953),
(334764, 'PTHR24166:SF48', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE TNNI3K', 242953),
(334765, 'PTHR47813', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE SUPERFAMILY PROTEIN', 242954),
(334766, 'PTHR47813:SF2', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE SUPERFAMILY PROTEIN', 242954),
(334767, 'PTHR43669:SF9', NULL, NULL, NULL, NULL, '5-KETO-D-GLUCONATE 5-REDUCTASE', 242955),
(334768, 'PTHR43669', NULL, NULL, NULL, NULL, '5-KETO-D-GLUCONATE 5-REDUCTASE', 242955),
(334769, 'PTHR43669:SF6', NULL, NULL, NULL, NULL, 'DECAPRENYLPHOSPHORYL-2-KETO-BETA-D-ERYTHRO-PENTOSE REDUCTASE', 242955),
(334770, 'PTHR43669:SF14', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE-RELATED', 242955),
(334771, 'PTHR43669:SF8', NULL, NULL, NULL, NULL, 'SHORT-CHAIN TYPE DEHYDROGENASE/REDUCTASE-RELATED', 242955),
(334772, 'PTHR43669:SF12', NULL, NULL, NULL, NULL, 'BLR5618 PROTEIN', 242955),
(334773, 'PTHR43669:SF13', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G03445)-RELATED', 242955),
(334774, 'PTHR43669:SF3', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE, SHORT-CHAIN DEHYDROGENASE/REDUCTASE FAMILY (AFU_ORTHOLOGUE AFUA_1G01330)', 242955),
(334775, 'PTHR43669:SF11', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/OXIDOREDUCTASE', 242955),
(334776, 'PTHR43669:SF4', NULL, NULL, NULL, NULL, '', 242955),
(334777, 'PTHR38737:SF2', NULL, NULL, NULL, NULL, 'ACTIN-FRAGMIN KINASE DDB_G0268748-RELATED', 242956),
(334778, 'PTHR38737', NULL, NULL, NULL, NULL, 'ACTIN-FRAGMIN KINASE DDB_G0279609-RELATED', 242956),
(334779, 'PTHR38737:SF1', NULL, NULL, NULL, NULL, 'ACTIN-FRAGMIN KINASE DDB_G0279609-RELATED', 242956),
(334780, 'PTHR43646', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 242957),
(334781, 'PTHR43646:SF2', NULL, NULL, NULL, NULL, 'GLYCO_TRANS_2-LIKE DOMAIN-CONTAINING PROTEIN', 242957),
(334782, 'PTHR43646:SF3', NULL, NULL, NULL, NULL, 'SLR1566 PROTEIN', 242957),
(334783, 'PTHR43646:SF6', NULL, NULL, NULL, NULL, 'PRE-MYCOFACTOCIN GLYCOSYLTRANSFERASE', 242957),
(334784, 'PTHR16048:SF3', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MSL2', 242958),
(334785, 'PTHR16048', NULL, NULL, NULL, NULL, 'MSL2-RELATED', 242958),
(334786, 'PTHR12800:SF2', NULL, NULL, NULL, NULL, 'HSP90 CO-CHAPERONE CDC37-LIKE 1', 242959),
(334787, 'PTHR12800:SF3', NULL, NULL, NULL, NULL, 'HSP90 CO-CHAPERONE CDC37', 242959),
(334788, 'PTHR12800', NULL, NULL, NULL, NULL, 'CDC37-RELATED', 242959),
(334789, 'PTHR12800:SF4', NULL, NULL, NULL, NULL, 'HSP90 CO-CHAPERONE CDC37', 242959),
(334790, 'PTHR12800:SF5', NULL, NULL, NULL, NULL, 'HSP90 CHAPERONE PROTEIN KINASE-TARGETING SUBUNIT', 242959),
(334791, 'PTHR36321:SF19', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 242960),
(334792, 'PTHR36321:SF17', NULL, NULL, NULL, NULL, 'CLASSICAL ARABINOGALACTAN PROTEIN 5', 242960),
(334793, 'PTHR36321:SF18', NULL, NULL, NULL, NULL, 'CLASSICAL ARABINOGALACTAN PROTEIN 10', 242960),
(334794, 'PTHR36321:SF16', NULL, NULL, NULL, NULL, 'BNAC02G00870D PROTEIN', 242960),
(334795, 'PTHR36321:SF13', NULL, NULL, NULL, NULL, 'BNAA04G12920D PROTEIN', 242960),
(334796, 'PTHR36321:SF14', NULL, NULL, NULL, NULL, 'CLASSICAL ARABINOGALACTAN PROTEIN 4-RELATED', 242960),
(334797, 'PTHR36321:SF22', NULL, NULL, NULL, NULL, 'RESERVOIR, PUTATIVE-RELATED', 242960),
(334798, 'PTHR36321:SF2', NULL, NULL, NULL, NULL, 'CLASSICAL ARABINOGALACTAN PROTEIN 1', 242960),
(334799, 'PTHR36321:SF11', NULL, NULL, NULL, NULL, 'BNAA06G23430D PROTEIN', 242960),
(334800, 'PTHR36321:SF20', NULL, NULL, NULL, NULL, 'CLASSICAL ARABINOGALACTAN PROTEIN 2-LIKE', 242960),
(334801, 'PTHR36321:SF10', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN-PROTEIN', 242960);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(334802, 'PTHR36321:SF21', NULL, NULL, NULL, NULL, 'CLASSICAL ARABINOGALACTAN PROTEIN 11', 242960),
(334803, 'PTHR36321:SF8', NULL, NULL, NULL, NULL, 'CLASSICAL ARABINOGALACTAN PROTEIN 3', 242960),
(334804, 'PTHR36321', NULL, NULL, NULL, NULL, 'CLASSICAL ARABINOGALACTAN PROTEIN 9', 242960),
(334805, 'PTHR36321:SF6', NULL, NULL, NULL, NULL, 'CLASSICAL ARABINOGALACTAN PROTEIN 2', 242960),
(334806, 'PTHR36321:SF7', NULL, NULL, NULL, NULL, 'CLASSICAL ARABINOGALACTAN PROTEIN 5-LIKE', 242960),
(334807, 'PTHR38645:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 9, WHOLE GENOME SHOTGUN SEQUENCE', 242961),
(334808, 'PTHR38645', NULL, NULL, NULL, NULL, 'CHROMOSOME 9, WHOLE GENOME SHOTGUN SEQUENCE', 242961),
(334809, 'PTHR46512:SF5', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT DOMAIN 9', 242962),
(334810, 'PTHR46512:SF6', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 242962),
(334811, 'PTHR46512:SF3', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP8', 242962),
(334812, 'PTHR46512:SF4', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 242962),
(334813, 'PTHR46512:SF1', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 242962),
(334814, 'PTHR46512:SF2', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 242962),
(334815, 'PTHR46512:SF9', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 242962),
(334816, 'PTHR46512:SF7', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 242962),
(334817, 'PTHR46512', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 242962),
(334818, 'PTHR46512:SF10', NULL, NULL, NULL, NULL, 'FKBP PROLYL ISOMERASE-LIKE', 242962),
(334819, 'PTHR46512:SF8', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 242962),
(334820, 'PTHR22683:SF1', NULL, NULL, NULL, NULL, 'ESX SECRETION SYSTEM PROTEIN YUKB', 242963),
(334821, 'PTHR22683:SF41', NULL, NULL, NULL, NULL, 'DNA TRANSLOCASE FTSK', 242963),
(334822, 'PTHR22683', NULL, NULL, NULL, NULL, 'SPORULATION PROTEIN RELATED', 242963),
(334823, 'PTHR22683:SF47', NULL, NULL, NULL, NULL, 'FTSK DOMAIN-CONTAINING PROTEIN YDCQ', 242963),
(334824, 'PTHR22683:SF42', NULL, NULL, NULL, NULL, 'DNA TRANSLOCASE SFTA', 242963),
(334825, 'PTHR10362:SF69', NULL, NULL, NULL, NULL, 'PHENYLALANINE AMMONIA-LYASE', 242964),
(334826, 'PTHR10362:SF68', NULL, NULL, NULL, NULL, 'PHENYLALANINE AMMONIA-LYASE', 242964),
(334827, 'PTHR10362:SF67', NULL, NULL, NULL, NULL, 'HISTIDINE AMMONIA-LYASE-RELATED', 242964),
(334828, 'PTHR10362:SF66', NULL, NULL, NULL, NULL, 'PHENYLALANINE AMMONIA-LYASE', 242964),
(334829, 'PTHR10362:SF44', NULL, NULL, NULL, NULL, 'PHENYLALANINE AMMONIA-LYASE', 242964),
(334830, 'PTHR10362:SF65', NULL, NULL, NULL, NULL, 'PHENYLALANINE AMMONIA-LYASE 4', 242964),
(334831, 'PTHR10362:SF20', NULL, NULL, NULL, NULL, 'PHENYLALANINE AMMONIA-LYASE', 242964),
(334832, 'PTHR10362:SF42', NULL, NULL, NULL, NULL, 'PHENYLALANINE AMMONIA-LYASE', 242964),
(334833, 'PTHR10362:SF64', NULL, NULL, NULL, NULL, 'PHENYLALANINE AMMONIA-LYASE', 242964),
(334834, 'PTHR10362:SF63', NULL, NULL, NULL, NULL, 'PHENYLALANINE AMMONIA-LYASE', 242964),
(334835, 'PTHR10362:SF41', NULL, NULL, NULL, NULL, 'PHENYLALANINE AMMONIA-LYASE 2', 242964),
(334836, 'PTHR10362:SF60', NULL, NULL, NULL, NULL, 'PHENYLALANINE AMMONIA-LYASE', 242964),
(334837, 'PTHR10362', NULL, NULL, NULL, NULL, 'HISTIDINE AMMONIA-LYASE', 242964),
(334838, 'PTHR10362:SF7', NULL, NULL, NULL, NULL, 'HISTIDINE AMMONIA-LYASE', 242964),
(334839, 'PTHR10362:SF39', NULL, NULL, NULL, NULL, 'PHENYLALANINE AMMONIA-LYASE', 242964),
(334840, 'PTHR10362:SF59', NULL, NULL, NULL, NULL, 'PHENYLALANINE AMMONIA-LYASE', 242964),
(334841, 'PTHR10362:SF37', NULL, NULL, NULL, NULL, 'PHENYLALANINE AMMONIA-LYASE 3', 242964),
(334842, 'PTHR10362:SF58', NULL, NULL, NULL, NULL, 'PHENYLALANINE AMMONIA-LYASE', 242964),
(334843, 'PTHR10362:SF36', NULL, NULL, NULL, NULL, 'PHENYLALANINE AMMONIA-LYASE', 242964),
(334844, 'PTHR10362:SF34', NULL, NULL, NULL, NULL, 'PHENYLALANINE AMMONIA-LYASE', 242964),
(334845, 'PTHR10362:SF56', NULL, NULL, NULL, NULL, 'PHENYLALANINE AMMONIA-LYASE', 242964),
(334846, 'PTHR10362:SF55', NULL, NULL, NULL, NULL, 'PHENYLALANINE AMMONIA-LYASE', 242964);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(334847, 'PTHR10362:SF11', NULL, NULL, NULL, NULL, 'PHENYLALANINE AMMONIA-LYASE', 242964),
(334848, 'PTHR10362:SF53', NULL, NULL, NULL, NULL, 'PHENYLALANINE AMMONIA-LYASE', 242964),
(334849, 'PTHR10362:SF52', NULL, NULL, NULL, NULL, 'PHENYLALANINE AMMONIA-LYASE', 242964),
(334850, 'PTHR10362:SF73', NULL, NULL, NULL, NULL, 'PHENYLALANINE AMMONIA-LYASE', 242964),
(334851, 'PTHR10362:SF50', NULL, NULL, NULL, NULL, 'PHENYLALANINE AMMONIA-LYASE', 242964),
(334852, 'PTHR10362:SF72', NULL, NULL, NULL, NULL, 'PHENYLALANINE AMMONIA-LYASE', 242964),
(334853, 'PTHR10362:SF71', NULL, NULL, NULL, NULL, '', 242964),
(334854, 'PTHR10362:SF70', NULL, NULL, NULL, NULL, 'PHENYLALANINE AMMONIA-LYASE', 242964),
(334855, 'PTHR47667', NULL, NULL, NULL, NULL, 'REGULATOR OF TY1 TRANSPOSITION PROTEIN 107', 242965),
(334856, 'PTHR47667:SF1', NULL, NULL, NULL, NULL, 'REGULATOR OF TY1 TRANSPOSITION PROTEIN 107', 242965),
(334857, 'PTHR22889', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 242966),
(334858, 'PTHR22889:SF0', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 89', 242966),
(334859, 'PTHR47689:SF2', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 242967),
(334860, 'PTHR47689:SF3', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 242967),
(334861, 'PTHR47689', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 242967),
(334862, 'PTHR47259:SF2', NULL, NULL, NULL, NULL, 'URACIL-REGULATED PROTEIN 1', 242968),
(334863, 'PTHR47259', NULL, NULL, NULL, NULL, '', 242968),
(334864, 'PTHR47235:SF1', NULL, NULL, NULL, NULL, 'BLR6548 PROTEIN', 242969),
(334865, 'PTHR47235', NULL, NULL, NULL, NULL, 'BLR6548 PROTEIN', 242969),
(334866, 'PTHR42861', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 242970),
(334867, 'PTHR42861:SF21', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE', 242970),
(334868, 'PTHR42861:SF20', NULL, NULL, NULL, NULL, 'ATPASE 10, PLASMA MEMBRANE-TYPE', 242970),
(334869, 'PTHR42861:SF23', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE TYPE 2C MEMBER 2', 242970),
(334870, 'PTHR42861:SF67', NULL, NULL, NULL, NULL, 'ATPASE 3, PLASMA MEMBRANE-TYPE-RELATED', 242970),
(334871, 'PTHR42861:SF29', NULL, NULL, NULL, NULL, 'SECRETORY PATHWAY CALCIUM ATPASE, ISOFORM G', 242970),
(334872, 'PTHR42861:SF25', NULL, NULL, NULL, NULL, 'ATPASE 6, PLASMA MEMBRANE-TYPE', 242970),
(334873, 'PTHR42861:SF69', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE', 242970),
(334874, 'PTHR42861:SF24', NULL, NULL, NULL, NULL, 'SARCOPLASMIC/ENDOPLASMIC RETICULUM CALCIUM ATPASE 1', 242970),
(334875, 'PTHR42861:SF68', NULL, NULL, NULL, NULL, 'ATPASE 5, PLASMA MEMBRANE-TYPE', 242970),
(334876, 'PTHR42861:SF26', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE 1-RELATED', 242970),
(334877, 'PTHR42861:SF127', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE 3, ENDOPLASMIC RETICULUM-TYPE', 242970),
(334878, 'PTHR42861:SF128', NULL, NULL, NULL, NULL, 'CATION_ATPASE_N DOMAIN-CONTAINING PROTEIN', 242970),
(334879, 'PTHR42861:SF81', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE', 242970),
(334880, 'PTHR42861:SF129', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE', 242970),
(334881, 'PTHR42861:SF31', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE-RELATED', 242970),
(334882, 'PTHR42861:SF75', NULL, NULL, NULL, NULL, 'CALCIUM PUMP1', 242970),
(334883, 'PTHR42861:SF78', NULL, NULL, NULL, NULL, 'CATION_ATPASE_N DOMAIN-CONTAINING PROTEIN', 242970),
(334884, 'PTHR42861:SF77', NULL, NULL, NULL, NULL, 'SODIUM ION P-TYPE ATPASE (EUROFUNG)', 242970),
(334885, 'PTHR42861:SF122', NULL, NULL, NULL, NULL, 'ER-TYPE CA2+-ATPASE 2-RELATED', 242970),
(334886, 'PTHR42861:SF123', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE', 242970),
(334887, 'PTHR42861:SF72', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE', 242970),
(334888, 'PTHR42861:SF124', NULL, NULL, NULL, NULL, 'ATPASE 2, PLASMA MEMBRANE-TYPE', 242970),
(334889, 'PTHR42861:SF125', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE', 242970),
(334890, 'PTHR42861:SF126', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE', 242970);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(334891, 'PTHR42861:SF38', NULL, NULL, NULL, NULL, 'CATION_ATPASE_N DOMAIN-CONTAINING PROTEIN', 242970),
(334892, 'PTHR42861:SF138', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE', 242970),
(334893, 'PTHR42861:SF90', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE', 242970),
(334894, 'PTHR42861:SF139', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE 3', 242970),
(334895, 'PTHR42861:SF92', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 242970),
(334896, 'PTHR42861:SF91', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE', 242970),
(334897, 'PTHR42861:SF130', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE', 242970),
(334898, 'PTHR42861:SF43', NULL, NULL, NULL, NULL, 'OS11G0489600 PROTEIN', 242970),
(334899, 'PTHR42861:SF86', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE', 242970),
(334900, 'PTHR42861:SF131', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE', 242970),
(334901, 'PTHR42861:SF132', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE', 242970),
(334902, 'PTHR42861:SF89', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE', 242970),
(334903, 'PTHR42861:SF133', NULL, NULL, NULL, NULL, 'ATPASE 9, PLASMA MEMBRANE-TYPE', 242970),
(334904, 'PTHR42861:SF88', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE', 242970),
(334905, 'PTHR42861:SF134', NULL, NULL, NULL, NULL, 'ATPASE 1, PLASMA MEMBRANE-TYPE', 242970),
(334906, 'PTHR42861:SF135', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE', 242970),
(334907, 'PTHR42861:SF85', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE 3', 242970),
(334908, 'PTHR42861:SF136', NULL, NULL, NULL, NULL, 'ATPASE 8, PLASMA MEMBRANE-TYPE', 242970),
(334909, 'PTHR42861:SF137', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE', 242970),
(334910, 'PTHR42861:SF48', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE', 242970),
(334911, 'PTHR42861:SF105', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE', 242970),
(334912, 'PTHR42861:SF4', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE 1, ENDOPLASMIC RETICULUM-TYPE-RELATED', 242970),
(334913, 'PTHR42861:SF106', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE', 242970),
(334914, 'PTHR42861:SF2', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE TYPE 2C MEMBER 1', 242970),
(334915, 'PTHR42861:SF108', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 242970),
(334916, 'PTHR42861:SF141', NULL, NULL, NULL, NULL, 'CATION_ATPASE_N DOMAIN-CONTAINING PROTEIN', 242970),
(334917, 'PTHR42861:SF54', NULL, NULL, NULL, NULL, 'ATPASE 7, PLASMA MEMBRANE-TYPE', 242970),
(334918, 'PTHR42861:SF53', NULL, NULL, NULL, NULL, 'RETICULUM [ER]-TYPE CALCIUM ATPASE, PUTATIVE-RELATED', 242970),
(334919, 'PTHR42861:SF97', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE', 242970),
(334920, 'PTHR42861:SF142', NULL, NULL, NULL, NULL, 'CA2+ TRANSPORTING ATPASE', 242970),
(334921, 'PTHR42861:SF12', NULL, NULL, NULL, NULL, 'SODIUM ION P-TYPE ATPASE (EUROFUNG)', 242970),
(334922, 'PTHR42861:SF56', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE', 242970),
(334923, 'PTHR42861:SF143', NULL, NULL, NULL, NULL, 'CATION_ATPASE_N DOMAIN-CONTAINING PROTEIN', 242970),
(334924, 'PTHR42861:SF144', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE', 242970),
(334925, 'PTHR42861:SF94', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE', 242970),
(334926, 'PTHR42861:SF145', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE', 242970),
(334927, 'PTHR42861:SF146', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE', 242970),
(334928, 'PTHR42861:SF102', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE SARCOPLASMIC/ENDOPLASMIC RETICULUM TYPE', 242970),
(334929, 'PTHR42861:SF93', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE', 242970),
(334930, 'PTHR42861:SF6', NULL, NULL, NULL, NULL, 'SARCOPLASMIC/ENDOPLASMIC RETICULUM CALCIUM ATPASE 3', 242970),
(334931, 'PTHR42861:SF104', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE', 242970),
(334932, 'PTHR42861:SF18', NULL, NULL, NULL, NULL, 'SARCOPLASMIC/ENDOPLASMIC RETICULUM CALCIUM ATPASE 2', 242970),
(334933, 'PTHR42861:SF14', NULL, NULL, NULL, NULL, 'SODIUM TRANSPORT ATPASE 1-RELATED', 242970),
(334934, 'PTHR42861:SF58', NULL, NULL, NULL, NULL, 'ATPASE 11, PLASMA MEMBRANE-TYPE-RELATED', 242970);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(334935, 'PTHR42861:SF57', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE', 242970),
(334936, 'PTHR42861:SF140', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ATPASE 1', 242970),
(334937, 'PTHR13871:SF18', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 242971),
(334938, 'PTHR13871:SF101', NULL, NULL, NULL, NULL, 'NUCLEOREDOXIN 1-RELATED', 242971),
(334939, 'PTHR13871:SF7', NULL, NULL, NULL, NULL, 'NUCLEOREDOXIN 2-RELATED', 242971),
(334940, 'PTHR13871:SF100', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 242971),
(334941, 'PTHR13871:SF27', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 242971),
(334942, 'PTHR13871:SF81', NULL, NULL, NULL, NULL, 'NUCLEOREDOXIN 3-RELATED', 242971),
(334943, 'PTHR13871:SF88', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 242971),
(334944, 'PTHR13871:SF96', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 242971),
(334945, 'PTHR13871:SF102', NULL, NULL, NULL, NULL, '', 242971),
(334946, 'PTHR13871:SF23', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 242971),
(334947, 'PTHR13871', NULL, NULL, NULL, NULL, 'THIOREDOXIN', 242971),
(334948, 'PTHR13871:SF34', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 242971),
(334949, 'PTHR31549:SF65', NULL, NULL, NULL, NULL, 'OS12G0481000 PROTEIN', 242972),
(334950, 'PTHR31549:SF63', NULL, NULL, NULL, NULL, 'OS09G0304500 PROTEIN', 242972),
(334951, 'PTHR31549:SF129', NULL, NULL, NULL, NULL, '', 242972),
(334952, 'PTHR31549:SF124', NULL, NULL, NULL, NULL, '', 242972),
(334953, 'PTHR31549:SF245', NULL, NULL, NULL, NULL, 'BNAC08G21580D PROTEIN', 242972),
(334954, 'PTHR31549:SF246', NULL, NULL, NULL, NULL, '', 242972),
(334955, 'PTHR31549:SF247', NULL, NULL, NULL, NULL, 'DUF247 DOMAIN PROTEIN', 242972),
(334956, 'PTHR31549:SF248', NULL, NULL, NULL, NULL, '', 242972),
(334957, 'PTHR31549:SF120', NULL, NULL, NULL, NULL, 'UPF0481 PROTEIN-RELATED', 242972),
(334958, 'PTHR31549:SF242', NULL, NULL, NULL, NULL, '', 242972),
(334959, 'PTHR31549:SF243', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242972),
(334960, 'PTHR31549:SF244', NULL, NULL, NULL, NULL, 'OS08G0120900 PROTEIN', 242972),
(334961, 'PTHR31549:SF250', NULL, NULL, NULL, NULL, '', 242972),
(334962, 'PTHR31549:SF251', NULL, NULL, NULL, NULL, 'OS09G0300150 PROTEIN', 242972),
(334963, 'PTHR31549:SF139', NULL, NULL, NULL, NULL, '', 242972),
(334964, 'PTHR31549:SF256', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242972),
(334965, 'PTHR31549:SF257', NULL, NULL, NULL, NULL, '', 242972),
(334966, 'PTHR31549:SF258', NULL, NULL, NULL, NULL, '', 242972),
(334967, 'PTHR31549:SF259', NULL, NULL, NULL, NULL, '', 242972),
(334968, 'PTHR31549:SF253', NULL, NULL, NULL, NULL, 'OS08G0337800 PROTEIN', 242972),
(334969, 'PTHR31549:SF134', NULL, NULL, NULL, NULL, '', 242972),
(334970, 'PTHR31549:SF87', NULL, NULL, NULL, NULL, '', 242972),
(334971, 'PTHR31549:SF260', NULL, NULL, NULL, NULL, '', 242972),
(334972, 'PTHR31549:SF88', NULL, NULL, NULL, NULL, '', 242972),
(334973, 'PTHR31549:SF261', NULL, NULL, NULL, NULL, 'OS08G0167400 PROTEIN', 242972),
(334974, 'PTHR31549:SF262', NULL, NULL, NULL, NULL, '', 242972),
(334975, 'PTHR31549:SF83', NULL, NULL, NULL, NULL, 'OS09G0268700 PROTEIN', 242972),
(334976, 'PTHR31549:SF84', NULL, NULL, NULL, NULL, 'UPF0481 PLANT-LIKE PROTEIN', 242972),
(334977, 'PTHR31549:SF81', NULL, NULL, NULL, NULL, 'DUF247 DOMAIN PROTEIN', 242972),
(334978, 'PTHR31549:SF80', NULL, NULL, NULL, NULL, 'OS12G0480800 PROTEIN', 242972),
(334979, 'PTHR31549:SF267', NULL, NULL, NULL, NULL, 'UPF0481 PROTEIN', 242972),
(334980, 'PTHR31549:SF146', NULL, NULL, NULL, NULL, 'OS01G0564600 PROTEIN', 242972),
(334981, 'PTHR31549:SF147', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF247)-RELATED', 242972),
(334982, 'PTHR31549:SF268', NULL, NULL, NULL, NULL, '', 242972),
(334983, 'PTHR31549:SF148', NULL, NULL, NULL, NULL, '', 242972),
(334984, 'PTHR31549:SF269', NULL, NULL, NULL, NULL, '', 242972),
(334985, 'PTHR31549:SF149', NULL, NULL, NULL, NULL, '', 242972),
(334986, 'PTHR31549:SF263', NULL, NULL, NULL, NULL, '', 242972);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(334987, 'PTHR31549:SF264', NULL, NULL, NULL, NULL, '', 242972),
(334988, 'PTHR31549:SF265', NULL, NULL, NULL, NULL, '', 242972),
(334989, 'PTHR31549:SF266', NULL, NULL, NULL, NULL, '', 242972),
(334990, 'PTHR31549:SF270', NULL, NULL, NULL, NULL, 'OS08G0356800 PROTEIN', 242972),
(334991, 'PTHR31549:SF271', NULL, NULL, NULL, NULL, 'OS05G0197900 PROTEIN', 242972),
(334992, 'PTHR31549:SF150', NULL, NULL, NULL, NULL, '', 242972),
(334993, 'PTHR31549:SF151', NULL, NULL, NULL, NULL, '', 242972),
(334994, 'PTHR31549:SF272', NULL, NULL, NULL, NULL, '', 242972),
(334995, 'PTHR31549:SF74', NULL, NULL, NULL, NULL, '', 242972),
(334996, 'PTHR31549:SF273', NULL, NULL, NULL, NULL, '', 242972),
(334997, 'PTHR31549:SF152', NULL, NULL, NULL, NULL, 'DUF247 DOMAIN PROTEIN', 242972),
(334998, 'PTHR31549:SF278', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF247)-RELATED', 242972),
(334999, 'PTHR31549:SF279', NULL, NULL, NULL, NULL, '', 242972),
(335000, 'PTHR31549:SF158', NULL, NULL, NULL, NULL, '', 242972),
(335001, 'PTHR31549:SF159', NULL, NULL, NULL, NULL, '', 242972),
(335002, 'PTHR31549:SF274', NULL, NULL, NULL, NULL, '', 242972),
(335003, 'PTHR31549:SF69', NULL, NULL, NULL, NULL, 'OS12G0513700 PROTEIN', 242972),
(335004, 'PTHR31549:SF153', NULL, NULL, NULL, NULL, '', 242972),
(335005, 'PTHR31549:SF275', NULL, NULL, NULL, NULL, 'OS03G0591600 PROTEIN', 242972),
(335006, 'PTHR31549:SF155', NULL, NULL, NULL, NULL, '', 242972),
(335007, 'PTHR31549:SF276', NULL, NULL, NULL, NULL, 'OS02G0253502 PROTEIN', 242972),
(335008, 'PTHR31549:SF277', NULL, NULL, NULL, NULL, 'UPF0481 PLANT-LIKE PROTEIN', 242972),
(335009, 'PTHR31549:SF281', NULL, NULL, NULL, NULL, '', 242972),
(335010, 'PTHR31549:SF282', NULL, NULL, NULL, NULL, '', 242972),
(335011, 'PTHR31549:SF22', NULL, NULL, NULL, NULL, '', 242972),
(335012, 'PTHR31549:SF162', NULL, NULL, NULL, NULL, '', 242972),
(335013, 'PTHR31549:SF283', NULL, NULL, NULL, NULL, 'BNAC07G31680D PROTEIN', 242972),
(335014, 'PTHR31549:SF163', NULL, NULL, NULL, NULL, '', 242972),
(335015, 'PTHR31549:SF284', NULL, NULL, NULL, NULL, 'OS05G0131000 PROTEIN', 242972),
(335016, 'PTHR31549:SF280', NULL, NULL, NULL, NULL, '', 242972),
(335017, 'PTHR31549:SF209', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 242972),
(335018, 'PTHR31549:SF168', NULL, NULL, NULL, NULL, '', 242972),
(335019, 'PTHR31549:SF203', NULL, NULL, NULL, NULL, 'PPPDE THIOL PEPTIDASE FAMILY PROTEIN-RELATED', 242972),
(335020, 'PTHR31549:SF285', NULL, NULL, NULL, NULL, 'DUF247 DOMAIN PROTEIN', 242972),
(335021, 'PTHR31549:SF164', NULL, NULL, NULL, NULL, '', 242972),
(335022, 'PTHR31549:SF14', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242972),
(335023, 'PTHR31549:SF286', NULL, NULL, NULL, NULL, '', 242972),
(335024, 'PTHR31549:SF165', NULL, NULL, NULL, NULL, '', 242972),
(335025, 'PTHR31549:SF287', NULL, NULL, NULL, NULL, 'BNAC07G31670D PROTEIN', 242972),
(335026, 'PTHR31549:SF167', NULL, NULL, NULL, NULL, '', 242972),
(335027, 'PTHR31549:SF200', NULL, NULL, NULL, NULL, '', 242972),
(335028, 'PTHR31549:SF4', NULL, NULL, NULL, NULL, 'OS09G0255900 PROTEIN', 242972),
(335029, 'PTHR31549:SF98', NULL, NULL, NULL, NULL, '', 242972),
(335030, 'PTHR31549:SF171', NULL, NULL, NULL, NULL, 'GI15025', 242972),
(335031, 'PTHR31549:SF99', NULL, NULL, NULL, NULL, 'OS08G0395800 PROTEIN', 242972),
(335032, 'PTHR31549:SF96', NULL, NULL, NULL, NULL, '', 242972),
(335033, 'PTHR31549:SF174', NULL, NULL, NULL, NULL, 'DUF247 DOMAIN PROTEIN', 242972),
(335034, 'PTHR31549:SF97', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 242972),
(335035, 'PTHR31549:SF170', NULL, NULL, NULL, NULL, '', 242972),
(335036, 'PTHR31549:SF217', NULL, NULL, NULL, NULL, '', 242972),
(335037, 'PTHR31549:SF219', NULL, NULL, NULL, NULL, 'BNAANNG07320D PROTEIN', 242972),
(335038, 'PTHR31549:SF213', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF247)-RELATED', 242972),
(335039, 'PTHR31549:SF175', NULL, NULL, NULL, NULL, '', 242972),
(335040, 'PTHR31549:SF210', NULL, NULL, NULL, NULL, 'EMB|CAB72473.1', 242972),
(335041, 'PTHR31549:SF89', NULL, NULL, NULL, NULL, '', 242972);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(335042, 'PTHR31549:SF178', NULL, NULL, NULL, NULL, '', 242972),
(335043, 'PTHR31549:SF211', NULL, NULL, NULL, NULL, 'OS05G0130400 PROTEIN', 242972),
(335044, 'PTHR31549:SF180', NULL, NULL, NULL, NULL, '', 242972),
(335045, 'PTHR31549:SF181', NULL, NULL, NULL, NULL, '', 242972),
(335046, 'PTHR31549:SF106', NULL, NULL, NULL, NULL, 'BNAC07G31720D PROTEIN', 242972),
(335047, 'PTHR31549:SF108', NULL, NULL, NULL, NULL, 'DUF247 DOMAIN PROTEIN', 242972),
(335048, 'PTHR31549', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF247)-RELATED-RELATED', 242972),
(335049, 'PTHR31549:SF102', NULL, NULL, NULL, NULL, '', 242972),
(335050, 'PTHR31549:SF224', NULL, NULL, NULL, NULL, '', 242972),
(335051, 'PTHR31549:SF225', NULL, NULL, NULL, NULL, 'DUF247 DOMAIN PROTEIN', 242972),
(335052, 'PTHR31549:SF226', NULL, NULL, NULL, NULL, '', 242972),
(335053, 'PTHR31549:SF186', NULL, NULL, NULL, NULL, '', 242972),
(335054, 'PTHR31549:SF187', NULL, NULL, NULL, NULL, '', 242972),
(335055, 'PTHR31549:SF222', NULL, NULL, NULL, NULL, '', 242972),
(335056, 'PTHR31549:SF32', NULL, NULL, NULL, NULL, '', 242972),
(335057, 'PTHR31549:SF194', NULL, NULL, NULL, NULL, '', 242972),
(335058, 'PTHR31549:SF195', NULL, NULL, NULL, NULL, '', 242972),
(335059, 'PTHR31549:SF196', NULL, NULL, NULL, NULL, '', 242972),
(335060, 'PTHR31549:SF190', NULL, NULL, NULL, NULL, 'DUF247 DOMAIN PROTEIN', 242972),
(335061, 'PTHR31549:SF191', NULL, NULL, NULL, NULL, 'DUF247 DOMAIN PROTEIN', 242972),
(335062, 'PTHR31549:SF117', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 242972),
(335063, 'PTHR31549:SF239', NULL, NULL, NULL, NULL, 'UPF0481 PLANT-LIKE PROTEIN', 242972),
(335064, 'PTHR31549:SF118', NULL, NULL, NULL, NULL, '', 242972),
(335065, 'PTHR31549:SF29', NULL, NULL, NULL, NULL, 'OS11G0541300 PROTEIN', 242972),
(335066, 'PTHR31549:SF197', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF247)-RELATED', 242972),
(335067, 'PTHR31549:SF25', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF247)-RELATED', 242972),
(335068, 'PTHR31549:SF110', NULL, NULL, NULL, NULL, 'UPF0481 PROTEIN', 242972),
(335069, 'PTHR31549:SF199', NULL, NULL, NULL, NULL, '', 242972),
(335070, 'PTHR31549:SF23', NULL, NULL, NULL, NULL, 'OS06G0179500 PROTEIN', 242972),
(335071, 'PTHR31549:SF232', NULL, NULL, NULL, NULL, '', 242972),
(335072, 'PTHR31549:SF233', NULL, NULL, NULL, NULL, '', 242972),
(335073, 'PTHR31549:SF24', NULL, NULL, NULL, NULL, 'OS06G0160600 PROTEIN', 242972),
(335074, 'PTHR45999:SF2', NULL, NULL, NULL, NULL, 'PROTEIN UNC-13 HOMOLOG 4B', 242973),
(335075, 'PTHR45999:SF1', NULL, NULL, NULL, NULL, 'BAI1-ASSOCIATED PROTEIN 3', 242973),
(335076, 'PTHR45999', NULL, NULL, NULL, NULL, 'UNC-13-4A, ISOFORM B', 242973),
(335077, 'PTHR45999:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG02073', 242973),
(335078, 'PTHR45999:SF8', NULL, NULL, NULL, NULL, 'MHD2 DOMAIN-CONTAINING PROTEIN', 242973),
(335079, 'PTHR45999:SF6', NULL, NULL, NULL, NULL, 'MHD2 DOMAIN-CONTAINING PROTEIN', 242973),
(335080, 'PTHR45999:SF4', NULL, NULL, NULL, NULL, 'UNC-13-4A, ISOFORM B', 242973),
(335081, 'PTHR45999:SF3', NULL, NULL, NULL, NULL, 'PROTEIN UNC-13 HOMOLOG D', 242973),
(335082, 'PTHR43008', NULL, NULL, NULL, NULL, 'BENZIL REDUCTASE', 242974),
(335083, 'PTHR43008:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 19, WHOLE GENOME SHOTGUN SEQUENCE', 242974),
(335084, 'PTHR43008:SF14', NULL, NULL, NULL, NULL, 'DEHYDROGENASE ARBD, PUTATIVE-RELATED', 242974),
(335085, 'PTHR43008:SF13', NULL, NULL, NULL, NULL, 'SHORT CHAIN DEHYDROGENASE (EUROFUNG)', 242974),
(335086, 'PTHR43008:SF4', NULL, NULL, NULL, NULL, 'CHAIN DEHYDROGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G08710)-RELATED', 242974),
(335087, 'PTHR43008:SF3', NULL, NULL, NULL, NULL, 'L-XYLULOSE REDUCTASE', 242974),
(335088, 'PTHR43008:SF9', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE-RELATED', 242974),
(335089, 'PTHR43008:SF10', NULL, NULL, NULL, NULL, 'CHAIN DEHYDROGENASE/OXIDOREDUCTASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G15740)-RELATED', 242974),
(335090, 'PTHR43008:SF8', NULL, NULL, NULL, NULL, 'BENZIL REDUCTASE ((S)-BENZOIN FORMING) IRC24', 242974),
(335091, 'PTHR43008:SF12', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE, SHORT CHAIN DEHYDROGENASE/REDUCTASE FAMILY (AFU_ORTHOLOGUE AFUA_6G13830)', 242974);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(335092, 'PTHR43008:SF7', NULL, NULL, NULL, NULL, 'SHORT CHAIN DEHYDROGENASE/REDUCTASE (AFU_ORTHOLOGUE AFUA_2G00830)', 242974),
(335093, 'PTHR43008:SF6', NULL, NULL, NULL, NULL, 'NADP-DEPENDENT MANNITOL DEHYDROGENASE', 242974),
(335094, 'PTHR37863:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 196-RELATED', 242975),
(335095, 'PTHR37863', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 196-RELATED', 242975),
(335096, 'PTHR36975:SF5', NULL, NULL, NULL, NULL, 'TRANSLOCATED ACTIN-RECRUITING PHOSPHOPROTEIN', 242976),
(335097, 'PTHR36975:SF3', NULL, NULL, NULL, NULL, '', 242976),
(335098, 'PTHR36975:SF4', NULL, NULL, NULL, NULL, '', 242976),
(335099, 'PTHR36975', NULL, NULL, NULL, NULL, '', 242976),
(335100, 'PTHR31355:SF19', NULL, NULL, NULL, NULL, 'TORTIFOLIA1-LIKE PROTEIN 5', 242977),
(335101, 'PTHR31355:SF28', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN TORTIFOLIA1-LIKE', 242977),
(335102, 'PTHR31355:SF18', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 242977),
(335103, 'PTHR31355:SF29', NULL, NULL, NULL, NULL, 'OS02G0739900 PROTEIN', 242977),
(335104, 'PTHR31355:SF26', NULL, NULL, NULL, NULL, 'CLATHRIN/COATOMER ADAPTOR, ADAPTIN-LIKE, ARMADILLO-TYPE FOLD PROTEIN-RELATED', 242977),
(335105, 'PTHR31355:SF27', NULL, NULL, NULL, NULL, 'BNAA09G06140D PROTEIN', 242977),
(335106, 'PTHR31355:SF25', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN-RELATED', 242977),
(335107, 'PTHR31355:SF22', NULL, NULL, NULL, NULL, 'TORTIFOLIA1-LIKE PROTEIN 2', 242977),
(335108, 'PTHR31355:SF23', NULL, NULL, NULL, NULL, 'BNAANNG18180D PROTEIN', 242977),
(335109, 'PTHR31355:SF20', NULL, NULL, NULL, NULL, 'TORTIFOLIA1-LIKE PROTEIN 1', 242977),
(335110, 'PTHR31355:SF31', NULL, NULL, NULL, NULL, '', 242977),
(335111, 'PTHR31355:SF4', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 242977),
(335112, 'PTHR31355:SF30', NULL, NULL, NULL, NULL, 'TORTIFOLIA1-LIKE PROTEIN 3', 242977),
(335113, 'PTHR31355:SF7', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN TORTIFOLIA1', 242977),
(335114, 'PTHR31355:SF8', NULL, NULL, NULL, NULL, 'TORTIFOLIA1-LIKE PROTEIN 4', 242977),
(335115, 'PTHR31355', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN TORTIFOLIA1', 242977),
(335116, 'PTHR41791', NULL, NULL, NULL, NULL, 'SSL7039 PROTEIN', 242978),
(335117, 'PTHR41791:SF1', NULL, NULL, NULL, NULL, 'SSL7039 PROTEIN', 242978),
(335118, 'PTHR34939:SF6', NULL, NULL, NULL, NULL, 'PSI-F', 242979),
(335119, 'PTHR34939:SF5', NULL, NULL, NULL, NULL, 'PSI-F', 242979),
(335120, 'PTHR34939:SF1', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I REACTION CENTER SUBUNIT III, CHLOROPLASTIC', 242979),
(335121, 'PTHR34939', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I REACTION CENTER SUBUNIT III, CHLOROPLASTIC', 242979),
(335122, 'PTHR31226:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 117', 242980),
(335123, 'PTHR31226', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 117', 242980),
(335124, 'PTHR47530:SF5', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 242981),
(335125, 'PTHR47530:SF4', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE BIG BROTHER-RELATED', 242981),
(335126, 'PTHR47530:SF3', NULL, NULL, NULL, NULL, 'OS08G0548300 PROTEIN', 242981),
(335127, 'PTHR47530', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE BIG BROTHER-RELATED', 242981),
(335128, 'PTHR35457:SF1', NULL, NULL, NULL, NULL, 'HEME A SYNTHASE', 242982),
(335129, 'PTHR35457', NULL, NULL, NULL, NULL, 'HEME A SYNTHASE', 242982),
(335130, 'PTHR15583', NULL, NULL, NULL, NULL, 'INTERLEUKIN-17 RECEPTOR', 242983),
(335131, 'PTHR15583:SF20', NULL, NULL, NULL, NULL, 'INTERLEUKIN CYTOKINE RECEPTOR-RELATED PROTEIN 1', 242983),
(335132, 'PTHR15583:SF11', NULL, NULL, NULL, NULL, 'INTERLEUKIN-17 RECEPTOR B', 242983),
(335133, 'PTHR15583:SF5', NULL, NULL, NULL, NULL, 'INTERLEUKIN-17 RECEPTOR E', 242983),
(335134, 'PTHR15583:SF10', NULL, NULL, NULL, NULL, 'INTERLEUKIN-17 RECEPTOR E-LIKE-RELATED', 242983),
(335135, 'PTHR15583:SF13', NULL, NULL, NULL, NULL, 'INTERLEUKIN-17 RECEPTOR A', 242983),
(335136, 'PTHR15583:SF7', NULL, NULL, NULL, NULL, 'INTERLEUKIN CYTOKINE RECEPTOR-RELATED PROTEIN 2', 242983);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(335137, 'PTHR15583:SF12', NULL, NULL, NULL, NULL, 'INTERLEUKIN-17 RECEPTOR C', 242983),
(335138, 'PTHR15583:SF14', NULL, NULL, NULL, NULL, 'INTERLEUKIN-17 RECEPTOR D', 242983),
(335139, 'PTHR15583:SF17', NULL, NULL, NULL, NULL, 'SI:CH211-207E14.4', 242983),
(335140, 'PTHR15583:SF19', NULL, NULL, NULL, NULL, 'INTERLEUKIN-17 RECEPTOR D', 242983),
(335141, 'PTHR30026:SF5', NULL, NULL, NULL, NULL, 'ABC-TYPE EFFLUX SYSTEM SECRETIN COMPONENT', 242984),
(335142, 'PTHR30026:SF15', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN TOLC', 242984),
(335143, 'PTHR30026', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN TOLC', 242984),
(335144, 'PTHR30026:SF21', NULL, NULL, NULL, NULL, 'SLR1270 PROTEIN', 242984),
(335145, 'PTHR30026:SF20', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE EFFLUX PROTEIN-RELATED', 242984),
(335146, 'PTHR30026:SF13', NULL, NULL, NULL, NULL, 'MEMBRANE EFFLUX PROTEIN, PUTATIVE-RELATED', 242984),
(335147, 'PTHR23189:SF118', NULL, NULL, NULL, NULL, 'PROTEIN MEI2-LIKE 2 ISOFORM X1', 242985),
(335148, 'PTHR23189:SF119', NULL, NULL, NULL, NULL, 'PROTEIN MEI2-LIKE 2', 242985),
(335149, 'PTHR23189:SF116', NULL, NULL, NULL, NULL, 'RNA RECOGNITION MOTIF 2, NUCLEOTIDE-BINDING ALPHA-BETA PLAIT DOMAIN-CONTAINING PROTEIN-RELATED', 242985),
(335150, 'PTHR23189:SF117', NULL, NULL, NULL, NULL, 'PROTEIN MEI2-LIKE 5', 242985),
(335151, 'PTHR23189:SF114', NULL, NULL, NULL, NULL, 'SAP DNA-BINDING DOMAIN-CONTAINING PROTEIN', 242985),
(335152, 'PTHR23189:SF115', NULL, NULL, NULL, NULL, 'FLOWERING TIME CONTROL PROTEIN FPA', 242985),
(335153, 'PTHR23189:SF112', NULL, NULL, NULL, NULL, 'PROTEIN MEI2-LIKE 5', 242985),
(335154, 'PTHR23189:SF113', NULL, NULL, NULL, NULL, 'PROTEIN MEI2', 242985),
(335155, 'PTHR23189:SF110', NULL, NULL, NULL, NULL, '', 242985),
(335156, 'PTHR23189', NULL, NULL, NULL, NULL, 'RNA RECOGNITION MOTIF-CONTAINING', 242985),
(335157, 'PTHR23189:SF111', NULL, NULL, NULL, NULL, 'PROTEIN MEI2-LIKE 1', 242985),
(335158, 'PTHR23189:SF51', NULL, NULL, NULL, NULL, 'SPLICING FACTOR, PROLINE- AND GLUTAMINE-RICH', 242985),
(335159, 'PTHR23189:SF99', NULL, NULL, NULL, NULL, 'PROTEIN MEI2-LIKE 1', 242985),
(335160, 'PTHR23189:SF98', NULL, NULL, NULL, NULL, 'PROTEIN MEI2-LIKE 4', 242985),
(335161, 'PTHR23189:SF15', NULL, NULL, NULL, NULL, 'NON-POU DOMAIN-CONTAINING OCTAMER-BINDING PROTEIN', 242985),
(335162, 'PTHR23189:SF14', NULL, NULL, NULL, NULL, 'PARASPECKLE COMPONENT 1', 242985),
(335163, 'PTHR23189:SF108', NULL, NULL, NULL, NULL, 'PROTEIN MEI2', 242985),
(335164, 'PTHR23189:SF6', NULL, NULL, NULL, NULL, 'RIBONUCLEOPROTEIN PTB-BINDING 2', 242985),
(335165, 'PTHR23189:SF125', NULL, NULL, NULL, NULL, 'PROTEIN MEI2-LIKE 3', 242985),
(335166, 'PTHR23189:SF123', NULL, NULL, NULL, NULL, 'PROTEIN MEI2-LIKE 5 ISOFORM X1', 242985),
(335167, 'PTHR23189:SF124', NULL, NULL, NULL, NULL, 'PROTEIN MEI2-LIKE 4', 242985),
(335168, 'PTHR23189:SF102', NULL, NULL, NULL, NULL, 'FI21126P1-RELATED', 242985),
(335169, 'PTHR23189:SF121', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 242985),
(335170, 'PTHR23189:SF122', NULL, NULL, NULL, NULL, 'BNAA07G08020D PROTEIN', 242985),
(335171, 'PTHR23189:SF120', NULL, NULL, NULL, NULL, 'BNACNNG35790D PROTEIN', 242985),
(335172, 'PTHR23189:SF40', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 15B-RELATED', 242985),
(335173, 'PTHR23189:SF45', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN SPENITO', 242985),
(335174, 'PTHR23189:SF89', NULL, NULL, NULL, NULL, 'PROTEIN MEI2-LIKE 3', 242985),
(335175, 'PTHR23189:SF43', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 15', 242985),
(335176, 'PTHR23189:SF48', NULL, NULL, NULL, NULL, 'MSX2-INTERACTING PROTEIN', 242985),
(335177, 'PTHR23189:SF49', NULL, NULL, NULL, NULL, 'SPEN FAMILY TRANSCRIPTIONAL REPRESSOR', 242985),
(335178, 'PTHR23189:SF46', NULL, NULL, NULL, NULL, 'RIBONUCLEOPROTEIN PTB-BINDING 1', 242985),
(335179, 'PTHR23189:SF109', NULL, NULL, NULL, NULL, 'PROTEIN MEI2-LIKE 2', 242985),
(335180, 'PTHR23189:SF47', NULL, NULL, NULL, NULL, 'SI:CH1073-335M2.2', 242985),
(335181, 'PTHR13158:SF5', NULL, NULL, NULL, NULL, 'NAD KINASE 2, MITOCHONDRIAL', 242986);
INSERT INTO "PUBLIC"."MODEL" VALUES
(335182, 'PTHR13158:SF4', NULL, NULL, NULL, NULL, 'NAD(+) KINASE', 242986),
(335183, 'PTHR13158', NULL, NULL, NULL, NULL, '', 242986),
(335184, 'PTHR31007', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-DEPENDENT PROTEIN KINASE II INHIBITOR 2', 242987),
(335185, 'PTHR31007:SF4', NULL, NULL, NULL, NULL, 'SI:DKEY-112A7.4-RELATED', 242987),
(335186, 'PTHR31007:SF5', NULL, NULL, NULL, NULL, 'SI:DKEY-33M11.6', 242987),
(335187, 'PTHR31007:SF3', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-DEPENDENT PROTEIN KINASE II INHIBITOR 1', 242987),
(335188, 'PTHR31007:SF1', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-DEPENDENT PROTEIN KINASE II INHIBITOR 2', 242987),
(335189, 'PTHR31551:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 12', 242988),
(335190, 'PTHR31551', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR CWF18', 242988),
(335191, 'PTHR33517', NULL, NULL, NULL, NULL, 'PROTEIN FAM170B-RELATED', 242989),
(335192, 'PTHR33517:SF5', NULL, NULL, NULL, NULL, 'PROTEIN FAM170A-LIKE', 242989),
(335193, 'PTHR33517:SF4', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 46', 242989),
(335194, 'PTHR33517:SF3', NULL, NULL, NULL, NULL, 'PROTEIN FAM170A', 242989),
(335195, 'PTHR33517:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM170B', 242989),
(335196, 'PTHR20952', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION-LIKE FACTOR 6-INTERACTING PROTEIN', 242990),
(335197, 'PTHR20952:SF0', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 6-INTERACTING PROTEIN 1', 242990),
(335198, 'PTHR20952:SF4', NULL, NULL, NULL, NULL, 'RETICULOPHAGY REGULATOR 2', 242990),
(335199, 'PTHR43689:SF49', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 242991),
(335200, 'PTHR43689:SF28', NULL, NULL, NULL, NULL, 'HALOALKANE DEHALOGENASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_8G01700)', 242991),
(335201, 'PTHR43689:SF25', NULL, NULL, NULL, NULL, 'LYSOPHOSPHOLIPASE BODYGUARD 1-RELATED', 242991),
(335202, 'PTHR43689:SF45', NULL, NULL, NULL, NULL, 'EPOXIDE HYDROLASE-RELATED', 242991),
(335203, 'PTHR43689:SF51', NULL, NULL, NULL, NULL, 'SLR1917 PROTEIN', 242991),
(335204, 'PTHR43689:SF9', NULL, NULL, NULL, NULL, 'LYSOPHOSPHOLIPASE BODYGUARD 3-RELATED', 242991),
(335205, 'PTHR43689:SF38', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 242991),
(335206, 'PTHR43689', NULL, NULL, NULL, NULL, 'HYDROLASE', 242991),
(335207, 'PTHR43689:SF8', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 242991),
(335208, 'PTHR43689:SF17', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 242991),
(335209, 'PTHR43689:SF54', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 242991),
(335210, 'PTHR43689:SF55', NULL, NULL, NULL, NULL, 'ALPHA/BETA FOLD HYDROLASE', 242991),
(335211, 'PTHR43689:SF33', NULL, NULL, NULL, NULL, 'ALPHA/BETA FOLD HYDROLASE', 242991),
(335212, 'PTHR43689:SF52', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN-RELATED', 242991),
(335213, 'PTHR43689:SF53', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 242991),
(335214, 'PTHR43689:SF14', NULL, NULL, NULL, NULL, 'LYSOPHOSPHOLIPASE BODYGUARD 4-RELATED', 242991),
(335215, 'PTHR43689:SF36', NULL, NULL, NULL, NULL, 'LYSOPHOSPHOLIPASE BODYGUARD 2-RELATED', 242991),
(335216, 'PTHR43689:SF58', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 242991),
(335217, 'PTHR43689:SF59', NULL, NULL, NULL, NULL, 'OS07G0685500 PROTEIN', 242991),
(335218, 'PTHR43689:SF37', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 242991),
(335219, 'PTHR43689:SF56', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 242991),
(335220, 'PTHR43689:SF35', NULL, NULL, NULL, NULL, 'LYSOPHOSPHOLIPASE BODYGUARD 5-RELATED', 242991),
(335221, 'PTHR43689:SF57', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 242991),
(335222, 'PTHR43689:SF40', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 242991),
(335223, 'PTHR43689:SF60', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 242991);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(335224, 'PTHR43689:SF1', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 242991),
(335225, 'PTHR48131:SF1', NULL, NULL, NULL, NULL, 'RESIII DOMAIN-CONTAINING PROTEIN', 242992),
(335226, 'PTHR48131', NULL, NULL, NULL, NULL, 'RESIII DOMAIN-CONTAINING PROTEIN', 242992),
(335227, 'PTHR14550', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 109', 242993),
(335228, 'PTHR14550:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 109', 242993),
(335229, 'PTHR13246:SF4', NULL, NULL, NULL, NULL, 'MANNOSYL-GLYCOPROTEIN ENDO-BETA-N-ACETYLGLUCOSAMINIDASE', 242994),
(335230, 'PTHR13246', NULL, NULL, NULL, NULL, 'ENDO BETA N-ACETYLGLUCOSAMINIDASE', 242994),
(335231, 'PTHR13246:SF1', NULL, NULL, NULL, NULL, 'CYTOSOLIC ENDO-BETA-N-ACETYLGLUCOSAMINIDASE', 242994),
(335232, 'PTHR13246:SF6', NULL, NULL, NULL, NULL, 'CYTOSOLIC ENDO-BETA-N-ACETYLGLUCOSAMINIDASE 2', 242994),
(335233, 'PTHR23127:SF2', NULL, NULL, NULL, NULL, 'PUA DOMAIN-CONTAINING PROTEIN', 242995),
(335234, 'PTHR23127:SF3', NULL, NULL, NULL, NULL, 'H/ACA RIBONUCLEOPROTEIN COMPLEX SUBUNIT 4', 242995),
(335235, 'PTHR23127', NULL, NULL, NULL, NULL, 'CENTROMERE/MICROTUBULE BINDING PROTEIN CBF5', 242995),
(335236, 'PTHR23127:SF0', NULL, NULL, NULL, NULL, 'H/ACA RIBONUCLEOPROTEIN COMPLEX SUBUNIT DKC1', 242995),
(335237, 'PTHR47615', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 158', 242996),
(335238, 'PTHR47615:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 158', 242996),
(335239, 'PTHR37406', NULL, NULL, NULL, NULL, 'T4-TYPE LYSOZYME 1-RELATED', 242997),
(335240, 'PTHR37406:SF1', NULL, NULL, NULL, NULL, 'T4-TYPE LYSOZYME 1-RELATED', 242997),
(335241, 'PTHR11567:SF29', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE FAMILY', 242998),
(335242, 'PTHR11567:SF28', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE FAMILY', 242998),
(335243, 'PTHR11567:SF25', NULL, NULL, NULL, NULL, 'PROTEIN FRA10AC1', 242998),
(335244, 'PTHR11567:SF138', NULL, NULL, NULL, NULL, 'INTESTINAL ACID PHOSPHATASE', 242998),
(335245, 'PTHR11567:SF137', NULL, NULL, NULL, NULL, 'PHOSPHATASE, PUTATIVE-RELATED', 242998),
(335246, 'PTHR11567:SF196', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE FAMILY', 242998),
(335247, 'PTHR11567:SF195', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G14570)-RELATED', 242998),
(335248, 'PTHR11567:SF110', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE 1, ISOFORM B', 242998),
(335249, 'PTHR11567:SF198', NULL, NULL, NULL, NULL, 'INTESTINAL ACID PHOSPHATASE', 242998),
(335250, 'PTHR11567:SF113', NULL, NULL, NULL, NULL, 'PROTEIN CBG06098', 242998),
(335251, 'PTHR11567:SF135', NULL, NULL, NULL, NULL, 'GLUCOSE-1-PHOSPHATASE', 242998),
(335252, 'PTHR11567:SF191', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE 1-RELATED', 242998),
(335253, 'PTHR11567:SF172', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE FAMILY', 242998),
(335254, 'PTHR11567:SF194', NULL, NULL, NULL, NULL, 'INTESTINAL ACID PHOSPHATASE', 242998),
(335255, 'PTHR11567:SF193', NULL, NULL, NULL, NULL, 'RH44874P', 242998),
(335256, 'PTHR11567:SF171', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE FAMILY', 242998),
(335257, 'PTHR11567:SF19', NULL, NULL, NULL, NULL, 'GH19849P', 242998),
(335258, 'PTHR11567:SF34', NULL, NULL, NULL, NULL, 'INTESTINAL ACID PHOSPHATASE', 242998),
(335259, 'PTHR11567:SF204', NULL, NULL, NULL, NULL, 'INTESTINAL ACID PHOSPHATASE', 242998),
(335260, 'PTHR11567:SF127', NULL, NULL, NULL, NULL, '', 242998),
(335261, 'PTHR11567:SF203', NULL, NULL, NULL, NULL, 'COUNTING FACTOR 60', 242998),
(335262, 'PTHR11567:SF206', NULL, NULL, NULL, NULL, 'INTESTINAL ACID PHOSPHATASE-RELATED', 242998),
(335263, 'PTHR11567:SF32', NULL, NULL, NULL, NULL, 'PROSTATIC ACID PHOSPHATASE', 242998),
(335264, 'PTHR11567:SF205', NULL, NULL, NULL, NULL, 'GH28721P-RELATED', 242998),
(335265, 'PTHR11567:SF187', NULL, NULL, NULL, NULL, 'PROTEIN CBG06099', 242998),
(335266, 'PTHR11567:SF142', NULL, NULL, NULL, NULL, '', 242998),
(335267, 'PTHR11567:SF189', NULL, NULL, NULL, NULL, 'INTESTINAL ACID PHOSPHATASE', 242998),
(335268, 'PTHR11567:SF145', NULL, NULL, NULL, NULL, 'TESTICULAR ACID PHOSPHATASE', 242998);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(335269, 'PTHR11567', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE-RELATED', 242998),
(335270, 'PTHR11567:SF125', NULL, NULL, NULL, NULL, '2-PHOSPHOXYLOSE PHOSPHATASE 1', 242998),
(335271, 'PTHR11567:SF202', NULL, NULL, NULL, NULL, 'LYSOPHOSPHATIDIC ACID PHOSPHATASE TYPE 6', 242998),
(335272, 'PTHR11567:SF201', NULL, NULL, NULL, NULL, 'INTESTINAL ACID PHOSPHATASE', 242998),
(335273, 'PTHR11567:SF181', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE 10-RELATED', 242998),
(335274, 'PTHR11567:SF180', NULL, NULL, NULL, NULL, 'LYSOSOMAL ACID PHOSPHATASE', 242998),
(335275, 'PTHR47391', NULL, NULL, NULL, NULL, 'BIORIENTATION OF CHROMOSOMES IN CELL DIVISION 1 LIKE 1', 242999),
(335276, 'PTHR47391:SF1', NULL, NULL, NULL, NULL, 'BIORIENTATION OF CHROMOSOMES IN CELL DIVISION 1 LIKE 1', 242999),
(335277, 'PTHR28074', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT K, MITOCHONDRIAL', 243000),
(335278, 'PTHR28074:SF1', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT K, MITOCHONDRIAL', 243000),
(335279, 'PTHR30183:SF6', NULL, NULL, NULL, NULL, 'INNER MEMBRANE ABC TRANSPORTER PERMEASE PROTEIN YNJC', 243001),
(335280, 'PTHR30183:SF7', NULL, NULL, NULL, NULL, 'FERRIC TRANSPORT SYSTEM PERMEASE PROTEIN FBPB 1-RELATED', 243001),
(335281, 'PTHR30183:SF8', NULL, NULL, NULL, NULL, 'MOLYBDENUM TRANSPORT SYSTEM PERMEASE', 243001),
(335282, 'PTHR30183:SF9', NULL, NULL, NULL, NULL, 'THIAMINE TRANSPORT SYSTEM PERMEASE PROTEIN THIP', 243001),
(335283, 'PTHR30183', NULL, NULL, NULL, NULL, 'MOLYBDENUM TRANSPORT SYSTEM PERMEASE PROTEIN MODB', 243001),
(335284, 'PTHR30183:SF2', NULL, NULL, NULL, NULL, 'IRON UTILIZATION PROTEIN', 243001),
(335285, 'PTHR30183:SF3', NULL, NULL, NULL, NULL, 'MOLYBDENUM TRANSPORT SYSTEM PERMEASE PROTEIN MODB', 243001),
(335286, 'PTHR46876:SF2', NULL, NULL, NULL, NULL, 'LDL RECEPTOR RELATED PROTEIN 11', 243002),
(335287, 'PTHR46876:SF3', NULL, NULL, NULL, NULL, 'MANSC DOMAIN CONTAINING 1', 243002),
(335288, 'PTHR46876:SF1', NULL, NULL, NULL, NULL, 'LOW-DENSITY LIPOPROTEIN RECEPTOR-RELATED PROTEIN 11', 243002),
(335289, 'PTHR46876', NULL, NULL, NULL, NULL, 'LOW-DENSITY LIPOPROTEIN RECEPTOR-RELATED PROTEIN 11', 243002),
(335290, 'PTHR37977:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG26449', 243003),
(335291, 'PTHR37977:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG25408', 243003),
(335292, 'PTHR37977', NULL, NULL, NULL, NULL, 'PROTEIN CBG18402-RELATED', 243003),
(335293, 'PTHR37977:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG18402', 243003),
(335294, 'PTHR42688:SF1', NULL, NULL, NULL, NULL, 'BLR5212 PROTEIN', 243004),
(335295, 'PTHR42688', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', 243004),
(335296, 'PTHR23197:SF10', NULL, NULL, NULL, NULL, 'TARGET OF NESH-SH3', 243005),
(335297, 'PTHR23197:SF11', NULL, NULL, NULL, NULL, 'RE03558P', 243005),
(335298, 'PTHR23197', NULL, NULL, NULL, NULL, 'TARSH-RELATED FIBRONECTIN DOMAIN-CONTAINING', 243005),
(335299, 'PTHR23197:SF8', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE III DOMAIN-CONTAINING PROTEIN 1', 243005),
(335300, 'PTHR24118', NULL, NULL, NULL, NULL, 'POTE ANKYRIN DOMAIN', 243006),
(335301, 'PTHR24118:SF82', NULL, NULL, NULL, NULL, 'RABANKYRIN-5', 243006),
(335302, 'PTHR24118:SF93', NULL, NULL, NULL, NULL, 'ANKYRIN 2', 243006),
(335303, 'PTHR24118:SF99', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX PROTEIN 15', 243006),
(335304, 'PTHR24118:SF65', NULL, NULL, NULL, NULL, 'POTE ANKYRIN DOMAIN FAMILY MEMBER B-RELATED', 243006),
(335305, 'PTHR24118:SF98', NULL, NULL, NULL, NULL, 'GENE 7697-RELATED', 243006),
(335306, 'PTHR24118:SF76', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX PROTEIN 18', 243006),
(335307, 'PTHR24118:SF56', NULL, NULL, NULL, NULL, 'POTE ANKYRIN DOMAIN FAMILY MEMBER G-RELATED', 243006),
(335308, 'PTHR24118:SF95', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX PROTEIN 7', 243006),
(335309, 'PTHR24118:SF51', NULL, NULL, NULL, NULL, 'B-CELL LYMPHOMA 3 PROTEIN', 243006),
(335310, 'PTHR24118:SF72', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX PROTEIN 16', 243006),
(335311, 'PTHR24118:SF97', NULL, NULL, NULL, NULL, 'REPEAT PROTEIN, PUTATIVE-RELATED', 243006);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(335312, 'PTHR24118:SF96', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G03252)-RELATED', 243006),
(335313, 'PTHR24118:SF85', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX-CONTAINING 10', 243006),
(335314, 'PTHR24118:SF37', NULL, NULL, NULL, NULL, 'NF-KAPPA-B INHIBITOR EPSILON', 243006),
(335315, 'PTHR30576', NULL, NULL, NULL, NULL, 'COLANIC BIOSYNTHESIS UDP-GLUCOSE LIPID CARRIER TRANSFERASE', 243007),
(335316, 'PTHR30576:SF0', NULL, NULL, NULL, NULL, 'UNDECAPRENYL-PHOSPHATE N-ACETYLGALACTOSAMINYL 1-PHOSPHATE TRANSFERASE-RELATED', 243007),
(335317, 'PTHR30576:SF4', NULL, NULL, NULL, NULL, 'UNDECAPRENYL-PHOSPHATE GALACTOSE PHOSPHOTRANSFERASE', 243007),
(335318, 'PTHR30576:SF23', NULL, NULL, NULL, NULL, 'GLUCOSYLTRANSFERASE', 243007),
(335319, 'PTHR30576:SF20', NULL, NULL, NULL, NULL, 'QUINOVOSAMINEPHOSPHOTRANSFERAE-RELATED', 243007),
(335320, 'PTHR30576:SF8', NULL, NULL, NULL, NULL, 'UNDECAPRENYL-PHOSPHATE GALACTOSE PHOSPHOTRANSFERASE', 243007),
(335321, 'PTHR30576:SF21', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE:UNDECAPRENYL-PHOSPHATE GLUCOSE-1-PHOSPHATE TRANSFERASE', 243007),
(335322, 'PTHR30576:SF10', NULL, NULL, NULL, NULL, 'SLL5057 PROTEIN', 243007),
(335323, 'PTHR34969', NULL, NULL, NULL, NULL, 'OS01G0621700 PROTEIN', 243008),
(335324, 'PTHR34969:SF1', NULL, NULL, NULL, NULL, 'TH1 DOMAIN-CONTAINING PROTEIN', 243008),
(335325, 'PTHR34969:SF5', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN-LIKE PROTEIN', 243008),
(335326, 'PTHR34969:SF4', NULL, NULL, NULL, NULL, 'TH1 DOMAIN-CONTAINING PROTEIN', 243008),
(335327, 'PTHR22876', NULL, NULL, NULL, NULL, 'ZGC:101016', 243009),
(335328, 'PTHR22876:SF5', NULL, NULL, NULL, NULL, 'ZGC:101016', 243009),
(335329, 'PTHR24416:SF294', NULL, NULL, NULL, NULL, 'LEUKOCYTE TYROSINE KINASE RECEPTOR', 243010),
(335330, 'PTHR24416:SF370', NULL, NULL, NULL, NULL, 'HIGH AFFINITY NERVE GROWTH FACTOR RECEPTOR', 243010),
(335331, 'PTHR24416:SF131', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR RECEPTOR 1', 243010),
(335332, 'PTHR24416:SF296', NULL, NULL, NULL, NULL, 'EPHRIN TYPE-B RECEPTOR 4', 243010),
(335333, 'PTHR24416:SF130', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR RECEPTOR 2', 243010),
(335334, 'PTHR24416:SF295', NULL, NULL, NULL, NULL, 'DISCOIDIN DOMAIN-CONTAINING RECEPTOR 2', 243010),
(335335, 'PTHR24416:SF297', NULL, NULL, NULL, NULL, 'DISCOIDIN DOMAIN RECEPTOR FAMILY, MEMBER 2,-LIKE', 243010),
(335336, 'PTHR24416:SF132', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE TRANSMEMBRANE RECEPTOR ROR2', 243010),
(335337, 'PTHR24416:SF575', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE RECEPTOR', 243010),
(335338, 'PTHR24416:SF531', NULL, NULL, NULL, NULL, 'DERAILED 2, ISOFORM B', 243010),
(335339, 'PTHR24416:SF333', NULL, NULL, NULL, NULL, 'EPITHELIAL DISCOIDIN DOMAIN-CONTAINING RECEPTOR 1', 243010),
(335340, 'PTHR24416:SF134', NULL, NULL, NULL, NULL, 'INACTIVE TYROSINE-PROTEIN KINASE TRANSMEMBRANE RECEPTOR ROR1', 243010),
(335341, 'PTHR24416:SF573', NULL, NULL, NULL, NULL, 'PROTEIN TYROSINE KINASE 7 (INACTIVE)', 243010),
(335342, 'PTHR24416:SF53', NULL, NULL, NULL, NULL, 'PLATELET-DERIVED GROWTH FACTOR RECEPTOR BETA', 243010),
(335343, 'PTHR24416:SF52', NULL, NULL, NULL, NULL, 'PLATELET-DERIVED GROWTH FACTOR RECEPTOR ALPHA', 243010),
(335344, 'PTHR24416:SF137', NULL, NULL, NULL, NULL, 'RECEPTOR TYROSINE-PROTEIN KINASE ERBB-2', 243010),
(335345, 'PTHR24416:SF611', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE TRANSMEMBRANE RECEPTOR ROR', 243010),
(335346, 'PTHR24416:SF579', NULL, NULL, NULL, NULL, '', 243010),
(335347, 'PTHR24416:SF535', NULL, NULL, NULL, NULL, 'INSULIN RECEPTOR', 243010),
(335348, 'PTHR24416:SF612', NULL, NULL, NULL, NULL, 'EPH RECEPTOR A10', 243010),
(335349, 'PTHR24416:SF136', NULL, NULL, NULL, NULL, 'BDNF/NT-3 GROWTH FACTORS RECEPTOR', 243010),
(335350, 'PTHR24416:SF257', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE MER', 243010),
(335351, 'PTHR24416:SF610', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243010),
(335352, 'PTHR24416:SF533', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN-TYROSINE KINASE', 243010);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(335353, 'PTHR24416:SF338', NULL, NULL, NULL, NULL, 'INSULIN RECEPTOR-RELATED PROTEIN', 243010),
(335354, 'PTHR24416:SF539', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN-TYROSINE KINASE', 243010),
(335355, 'PTHR24416:SF613', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243010),
(335356, 'PTHR24416:SF481', NULL, NULL, NULL, NULL, 'TIE-LIKE RECEPTOR TYROSINE KINASE', 243010),
(335357, 'PTHR24416:SF480', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243010),
(335358, 'PTHR24416:SF483', NULL, NULL, NULL, NULL, 'HEPATOCYTE GROWTH FACTOR RECEPTOR', 243010),
(335359, 'PTHR24416:SF485', NULL, NULL, NULL, NULL, 'PROTO-ONCOGENE TYROSINE-PROTEIN KINASE RECEPTOR RET', 243010),
(335360, 'PTHR24416:SF28', NULL, NULL, NULL, NULL, 'EPHRIN TYPE-A RECEPTOR 1', 243010),
(335361, 'PTHR24416:SF520', NULL, NULL, NULL, NULL, 'DISCOIDIN DOMAIN RECEPTOR TYROSINE KINASE 2B', 243010),
(335362, 'PTHR24416:SF564', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243010),
(335363, 'PTHR24416:SF486', NULL, NULL, NULL, NULL, 'EPHRIN TYPE-A RECEPTOR 3-RELATED', 243010),
(335364, 'PTHR24416:SF66', NULL, NULL, NULL, NULL, 'NT-3 GROWTH FACTOR RECEPTOR', 243010),
(335365, 'PTHR24416:SF608', NULL, NULL, NULL, NULL, 'EPHRIN TYPE-B RECEPTOR 4A-RELATED', 243010),
(335366, 'PTHR24416:SF609', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243010),
(335367, 'PTHR24416:SF606', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243010),
(335368, 'PTHR24416:SF607', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE RECEPTOR SVH-2', 243010),
(335369, 'PTHR24416:SF567', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243010),
(335370, 'PTHR24416:SF600', NULL, NULL, NULL, NULL, 'PDGF-AND VEGF-RECEPTOR RELATED, ISOFORM J', 243010),
(335371, 'PTHR24416:SF489', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243010),
(335372, 'PTHR24416:SF488', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243010),
(335373, 'PTHR24416:SF323', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE RECEPTOR UFO', 243010),
(335374, 'PTHR24416:SF601', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE RECEPTOR CAM-1', 243010),
(335375, 'PTHR24416:SF125', NULL, NULL, NULL, NULL, 'ANGIOPOIETIN-1 RECEPTOR', 243010),
(335376, 'PTHR24416:SF402', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE RECEPTOR TORSO', 243010),
(335377, 'PTHR24416:SF566', NULL, NULL, NULL, NULL, 'EPIDERMAL GROWTH FACTOR RECEPTOR', 243010),
(335378, 'PTHR24416:SF604', NULL, NULL, NULL, NULL, 'ANAPLASTIC LYMPHOMA KINASE, ISOFORM A', 243010),
(335379, 'PTHR24416:SF527', NULL, NULL, NULL, NULL, 'PROTO-ONCOGENE TYROSINE-PROTEIN KINASE ROS', 243010),
(335380, 'PTHR24416:SF605', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN-TYROSINE KINASE', 243010),
(335381, 'PTHR24416:SF602', NULL, NULL, NULL, NULL, 'PROTEIN VER-1-RELATED', 243010),
(335382, 'PTHR24416:SF525', NULL, NULL, NULL, NULL, 'INSULIN-LIKE RECEPTOR', 243010),
(335383, 'PTHR24416:SF603', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN-TYROSINE KINASE', 243010),
(335384, 'PTHR24416:SF592', NULL, NULL, NULL, NULL, 'SERINE/THREONINE/TYROSINE KINASE 1', 243010),
(335385, 'PTHR24416:SF596', NULL, NULL, NULL, NULL, 'MYOBLAST GROWTH FACTOR RECEPTOR EGL-15-RELATED', 243010),
(335386, 'PTHR24416:SF552', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN-TYROSINE KINASE', 243010),
(335387, 'PTHR24416:SF276', NULL, NULL, NULL, NULL, 'ALK TYROSINE KINASE RECEPTOR', 243010),
(335388, 'PTHR24416:SF597', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243010),
(335389, 'PTHR24416', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE RECEPTOR', 243010),
(335390, 'PTHR24416:SF550', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR RECEPTOR HOMOLOG 1-RELATED', 243010),
(335391, 'PTHR24416:SF113', NULL, NULL, NULL, NULL, 'MACROPHAGE-STIMULATING PROTEIN RECEPTOR', 243010),
(335392, 'PTHR24416:SF594', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243010),
(335393, 'PTHR24416:SF390', NULL, NULL, NULL, NULL, 'VASCULAR ENDOTHELIAL GROWTH FACTOR RECEPTOR 1', 243010);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(335394, 'PTHR24416:SF356', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE TYROSINE-PROTEIN KINASE FLT3', 243010),
(335395, 'PTHR24416:SF279', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE RECEPTOR TYRO3', 243010),
(335396, 'PTHR24416:SF598', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE RECEPTOR', 243010),
(335397, 'PTHR24416:SF599', NULL, NULL, NULL, NULL, 'MAST/STEM CELL GROWTH FACTOR RECEPTOR', 243010),
(335398, 'PTHR24416:SF317', NULL, NULL, NULL, NULL, 'MUSCLE, SKELETAL RECEPTOR TYROSINE-PROTEIN KINASE', 243010),
(335399, 'PTHR24416:SF580', NULL, NULL, NULL, NULL, 'DISCOIDIN DOMAIN RECEPTOR, ISOFORM F', 243010),
(335400, 'PTHR24416:SF541', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE RECEPTOR', 243010),
(335401, 'PTHR24416:SF341', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE RECEPTOR TIE-1', 243010),
(335402, 'PTHR24416:SF49', NULL, NULL, NULL, NULL, 'VASCULAR ENDOTHELIAL GROWTH FACTOR RECEPTOR 3', 243010),
(335403, 'PTHR24416:SF583', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN-TYROSINE KINASE', 243010),
(335404, 'PTHR24416:SF343', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR RECEPTOR 4', 243010),
(335405, 'PTHR24416:SF47', NULL, NULL, NULL, NULL, 'MACROPHAGE COLONY-STIMULATING FACTOR 1 RECEPTOR', 243010),
(335406, 'PTHR24416:SF46', NULL, NULL, NULL, NULL, 'MAST/STEM CELL GROWTH FACTOR RECEPTOR KIT', 243010),
(335407, 'PTHR24416:SF45', NULL, NULL, NULL, NULL, 'VASCULAR ENDOTHELIAL GROWTH FACTOR RECEPTOR 2', 243010),
(335408, 'PTHR24416:SF88', NULL, NULL, NULL, NULL, 'RECEPTOR TYROSINE-PROTEIN KINASE ERBB-3', 243010),
(335409, 'PTHR24416:SF509', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN-TYROSINE KINASE', 243010),
(335410, 'PTHR24416:SF91', NULL, NULL, NULL, NULL, 'EPIDERMAL GROWTH FACTOR RECEPTOR', 243010),
(335411, 'PTHR24416:SF90', NULL, NULL, NULL, NULL, 'RECEPTOR TYROSINE-PROTEIN KINASE ERBB-4', 243010),
(335412, 'PTHR24416:SF589', NULL, NULL, NULL, NULL, 'PROTEIN SEVENLESS-RELATED', 243010),
(335413, 'PTHR24416:SF106', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR 1 RECEPTOR', 243010),
(335414, 'PTHR24416:SF306', NULL, NULL, NULL, NULL, 'EPHRIN TYPE-A RECEPTOR 2', 243010),
(335415, 'PTHR24416:SF505', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR RECEPTOR 3', 243010),
(335416, 'PTHR24416:SF349', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE RYK', 243010),
(335417, 'PTHR24416:SF503', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN-RELATED', 243010),
(335418, 'PTHR24416:SF548', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243010),
(335419, 'PTHR47786', NULL, NULL, NULL, NULL, 'ALPHA-1,4-GLUCAN:MALTOSE-1-PHOSPHATE MALTOSYLTRANSFERASE', 243011),
(335420, 'PTHR47786:SF2', NULL, NULL, NULL, NULL, 'AAMY DOMAIN-CONTAINING PROTEIN', 243011),
(335421, 'PTHR47651:SF7', NULL, NULL, NULL, NULL, 'NAD-DEPENDENT PROTEIN DEACYLASE SIR-2.2', 243012),
(335422, 'PTHR47651:SF6', NULL, NULL, NULL, NULL, 'SIRTUIN-RELATED', 243012),
(335423, 'PTHR47651:SF5', NULL, NULL, NULL, NULL, 'SIRTUIN 3', 243012),
(335424, 'PTHR47651:SF4', NULL, NULL, NULL, NULL, 'NAD-DEPENDENT PROTEIN DEACETYLASE SIRTUIN-1', 243012),
(335425, 'PTHR47651:SF9', NULL, NULL, NULL, NULL, 'SI:DKEY-103I16.6', 243012),
(335426, 'PTHR47651:SF8', NULL, NULL, NULL, NULL, 'NAD-DEPENDENT PROTEIN DEACETYLASE SIRTUIN-3, MITOCHONDRIAL', 243012),
(335427, 'PTHR47651:SF10', NULL, NULL, NULL, NULL, 'DEACETYLASE SIRTUIN-TYPE DOMAIN-CONTAINING PROTEIN', 243012),
(335428, 'PTHR47651', NULL, NULL, NULL, NULL, 'NAD-DEPENDENT HISTONE DEACETYLASE HST4', 243012),
(335429, 'PTHR47651:SF3', NULL, NULL, NULL, NULL, 'NAD-DEPENDENT PROTEIN DEACETYLASE HST2-2', 243012),
(335430, 'PTHR47651:SF14', NULL, NULL, NULL, NULL, 'SIRTUIN FAMILY, DHS-LIKE NAD/FAD-BINDING DOMAIN PROTEIN-RELATED', 243012),
(335431, 'PTHR47651:SF13', NULL, NULL, NULL, NULL, 'NAD-DEPENDENT PROTEIN DEACYLASE', 243012),
(335432, 'PTHR47651:SF2', NULL, NULL, NULL, NULL, 'NAD-DEPENDENT HISTONE DEACETYLASE HST4', 243012),
(335433, 'PTHR47651:SF12', NULL, NULL, NULL, NULL, 'NAD-DEPENDENT PROTEIN DEACETYLASE SIRTUIN-6', 243012),
(335434, 'PTHR47651:SF11', NULL, NULL, NULL, NULL, 'NAD-DEPENDENT PROTEIN DEACETYLASE SIRTUIN-2', 243012);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(335435, 'PTHR47651:SF16', NULL, NULL, NULL, NULL, 'NAD-DEPENDENT PROTEIN DEACYLASE SIRTUIN-5, MITOCHONDRIAL', 243012),
(335436, 'PTHR47651:SF15', NULL, NULL, NULL, NULL, 'NAD-DEPENDENT HISTONE DEACETYLASE HST3', 243012),
(335437, 'PTHR47692', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 243013),
(335438, 'PTHR47692:SF2', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 243013),
(335439, 'PTHR46990:SF3', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN AND CYSTEINE-RICH DOMAIN-CONTAINING 1 A', 243014),
(335440, 'PTHR46990:SF1', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING CYSTEINE-RICH PROTEIN 1', 243014),
(335441, 'PTHR46990:SF2', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN AND CYSTEINE-RICH DOMAIN-CONTAINING 1 B', 243014),
(335442, 'PTHR46990', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING CYSTEINE-RICH PROTEIN 1', 243014),
(335443, 'PTHR33979', NULL, NULL, NULL, NULL, 'OS02G0221600 PROTEIN', 243015),
(335444, 'PTHR33979:SF5', NULL, NULL, NULL, NULL, '', 243015),
(335445, 'PTHR33979:SF3', NULL, NULL, NULL, NULL, '', 243015),
(335446, 'PTHR33979:SF2', NULL, NULL, NULL, NULL, 'OS02G0221600 PROTEIN', 243015),
(335447, 'PTHR10514:SF40', NULL, NULL, NULL, NULL, 'ANGIOTENSIN-CONVERTING ENZYME', 243016),
(335448, 'PTHR10514:SF41', NULL, NULL, NULL, NULL, 'ANGIOTENSIN-CONVERTING ENZYME-LIKE PROTEIN ACE3', 243016),
(335449, 'PTHR10514', NULL, NULL, NULL, NULL, 'ANGIOTENSIN-CONVERTING ENZYME', 243016),
(335450, 'PTHR10514:SF24', NULL, NULL, NULL, NULL, 'ANGIOTENSIN-CONVERTING ENZYME 2', 243016),
(335451, 'PTHR10514:SF25', NULL, NULL, NULL, NULL, 'ANGIOTENSIN-CONVERTING ENZYME', 243016),
(335452, 'PTHR10514:SF27', NULL, NULL, NULL, NULL, 'ANGIOTENSIN-CONVERTING ENZYME', 243016),
(335453, 'PTHR10514:SF43', NULL, NULL, NULL, NULL, 'ANGIOTENSIN-CONVERTING ENZYME', 243016),
(335454, 'PTHR10514:SF44', NULL, NULL, NULL, NULL, 'ANGIOTENSIN-CONVERTING ENZYME-RELATED', 243016),
(335455, 'PTHR43558', NULL, NULL, NULL, NULL, 'REDUCTASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G10540)-RELATED', 243017),
(335456, 'PTHR43558:SF7', NULL, NULL, NULL, NULL, 'REDUCTASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G10540)-RELATED', 243017),
(335457, 'PTHR43558:SF6', NULL, NULL, NULL, NULL, '', 243017),
(335458, 'PTHR42698:SF2', NULL, NULL, NULL, NULL, 'GTPASE ERA-LIKE, CHLOROPLASTIC', 243018),
(335459, 'PTHR42698:SF1', NULL, NULL, NULL, NULL, 'GTPASE ERA, MITOCHONDRIAL', 243018),
(335460, 'PTHR42698', NULL, NULL, NULL, NULL, 'GTPASE ERA', 243018),
(335461, 'PTHR47960:SF1', NULL, NULL, NULL, NULL, 'RNA HELICASE', 243019),
(335462, 'PTHR47960:SF2', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX6-RELATED', 243019),
(335463, 'PTHR47960:SF19', NULL, NULL, NULL, NULL, 'DEAD-LIKE HELICASE', 243019),
(335464, 'PTHR47960:SF18', NULL, NULL, NULL, NULL, 'BNAA02G36470D PROTEIN', 243019),
(335465, 'PTHR47960:SF17', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX6-RELATED', 243019),
(335466, 'PTHR47960:SF16', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 6', 243019),
(335467, 'PTHR47960', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 50', 243019),
(335468, 'PTHR47960:SF7', NULL, NULL, NULL, NULL, 'RNA HELICASE', 243019),
(335469, 'PTHR47960:SF8', NULL, NULL, NULL, NULL, 'RNA HELICASE', 243019),
(335470, 'PTHR47960:SF3', NULL, NULL, NULL, NULL, '', 243019),
(335471, 'PTHR47960:SF4', NULL, NULL, NULL, NULL, 'BNACNNG13670D PROTEIN', 243019),
(335472, 'PTHR47960:SF6', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 39-LIKE', 243019),
(335473, 'PTHR47960:SF14', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 6-RELATED', 243019),
(335474, 'PTHR47960:SF13', NULL, NULL, NULL, NULL, '', 243019),
(335475, 'PTHR47960:SF24', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 12', 243019),
(335476, 'PTHR47960:SF23', NULL, NULL, NULL, NULL, 'HELICASE C-TERMINAL DOMAIN-CONTAINING PROTEIN', 243019),
(335477, 'PTHR47960:SF12', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 12', 243019),
(335478, 'PTHR47960:SF11', NULL, NULL, NULL, NULL, 'RNA HELICASE', 243019);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(335479, 'PTHR47960:SF22', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 8', 243019),
(335480, 'PTHR47960:SF21', NULL, NULL, NULL, NULL, '', 243019),
(335481, 'PTHR47960:SF10', NULL, NULL, NULL, NULL, 'DEAD DOMAIN-CONTAINING PROTEIN', 243019),
(335482, 'PTHR28071:SF1', NULL, NULL, NULL, NULL, 'REDOX PROTEIN FMP46, MITOCHONDRIAL-RELATED', 243020),
(335483, 'PTHR28071', NULL, NULL, NULL, NULL, 'REDOX PROTEIN FMP46, MITOCHONDRIAL-RELATED', 243020),
(335484, 'PTHR28027:SF1', NULL, NULL, NULL, NULL, 'CAMP INDEPENDENT REGULATORY PROTEIN (AFU_ORTHOLOGUE AFUA_3G09640)', 243021),
(335485, 'PTHR28027:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR MIT1', 243021),
(335486, 'PTHR28027', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR MIT1', 243021),
(335487, 'PTHR47205:SF1', NULL, NULL, NULL, NULL, 'OS07G0599000 PROTEIN', 243022),
(335488, 'PTHR47205', NULL, NULL, NULL, NULL, 'OS07G0599000 PROTEIN', 243022),
(335489, 'PTHR35213:SF3', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 243023),
(335490, 'PTHR35213', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', 243023),
(335491, 'PTHR35213:SF4', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 243023),
(335492, 'PTHR23202:SF64', NULL, NULL, NULL, NULL, 'OS02G0308300 PROTEIN', 243024),
(335493, 'PTHR23202:SF108', NULL, NULL, NULL, NULL, 'LETHAL (3) PERSISTENT SALIVARY GLAND 2', 243024),
(335494, 'PTHR23202:SF107', NULL, NULL, NULL, NULL, 'PROTEIN CBG13677', 243024),
(335495, 'PTHR23202', NULL, NULL, NULL, NULL, 'WASP INTERACTING PROTEIN-RELATED', 243024),
(335496, 'PTHR23202:SF109', NULL, NULL, NULL, NULL, 'MULTI SEX COMBS, ISOFORM A-RELATED', 243024),
(335497, 'PTHR23202:SF115', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243024),
(335498, 'PTHR23202:SF104', NULL, NULL, NULL, NULL, '', 243024),
(335499, 'PTHR23202:SF103', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 15', 243024),
(335500, 'PTHR23202:SF114', NULL, NULL, NULL, NULL, 'HELITRON_LIKE_N DOMAIN-CONTAINING PROTEIN', 243024),
(335501, 'PTHR23202:SF117', NULL, NULL, NULL, NULL, 'MIP04801P-RELATED', 243024),
(335502, 'PTHR23202:SF106', NULL, NULL, NULL, NULL, 'GLYCINE--TRNA LIGASE', 243024),
(335503, 'PTHR23202:SF116', NULL, NULL, NULL, NULL, 'WASP ACTIN NUCLEATION-PROMOTING FACTOR A-RELATED', 243024),
(335504, 'PTHR23202:SF105', NULL, NULL, NULL, NULL, '', 243024),
(335505, 'PTHR23202:SF111', NULL, NULL, NULL, NULL, 'AGAP005399-PA', 243024),
(335506, 'PTHR23202:SF110', NULL, NULL, NULL, NULL, 'MULTIPLE EPIDERMAL GROWTH FACTOR-LIKE DOMAINS PROTEIN 9', 243024),
(335507, 'PTHR23202:SF102', NULL, NULL, NULL, NULL, '', 243024),
(335508, 'PTHR23202:SF113', NULL, NULL, NULL, NULL, '', 243024),
(335509, 'PTHR23202:SF112', NULL, NULL, NULL, NULL, 'OF TRANSCRIPTION FROM POL II PROMOTER-RELATED PROTEIN, PUTATIVE-RELATED', 243024),
(335510, 'PTHR23202:SF101', NULL, NULL, NULL, NULL, 'FI03313P', 243024),
(335511, 'PTHR13097:SF9', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIE SUBUNIT ALPHA', 243025),
(335512, 'PTHR13097:SF8', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR IIE SUBUNIT 1', 243025),
(335513, 'PTHR13097', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIE, ALPHA SUBUNIT', 243025),
(335514, 'PTHR13097:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIE SUBUNIT ALPHA', 243025),
(335515, 'PTHR12549:SF17', NULL, NULL, NULL, NULL, 'JMJC DOMAIN PROTEIN JMJ24', 243026),
(335516, 'PTHR12549:SF49', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE JMJ25-LIKE ISOFORM X1', 243026),
(335517, 'PTHR12549:SF38', NULL, NULL, NULL, NULL, 'JMJC DOMAIN-CONTAINING HISTONE DEMETHYLASE 2, ISOFORM A', 243026),
(335518, 'PTHR12549:SF37', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE JMJ25-LIKE', 243026),
(335519, 'PTHR12549:SF59', NULL, NULL, NULL, NULL, 'JMJC DOMAIN-CONTAINING PROTEIN', 243026),
(335520, 'PTHR12549:SF36', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE JMJ25-LIKE', 243026),
(335521, 'PTHR12549:SF56', NULL, NULL, NULL, NULL, 'JMJC DOMAIN-CONTAINING PROTEIN-RELATED', 243026);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(335522, 'PTHR12549:SF33', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR JUMONJI (JMJC) DOMAIN-CONTAINING PROTEIN', 243026),
(335523, 'PTHR12549:SF11', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE JMJ25', 243026),
(335524, 'PTHR12549:SF44', NULL, NULL, NULL, NULL, 'BNAA09G13360D PROTEIN', 243026),
(335525, 'PTHR12549:SF65', NULL, NULL, NULL, NULL, 'JMJC DOMAIN, WRC DOMAIN PROTEIN-RELATED', 243026),
(335526, 'PTHR12549:SF42', NULL, NULL, NULL, NULL, 'PROTEIN B160', 243026),
(335527, 'PTHR12549:SF53', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR JUMONJI (JMJC) DOMAIN-CONTAINING PROTEIN', 243026),
(335528, 'PTHR12549:SF64', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR JUMONJI (JMJC) DOMAIN-CONTAINING PROTEIN', 243026),
(335529, 'PTHR12549:SF63', NULL, NULL, NULL, NULL, 'OS02G0828900 PROTEIN', 243026),
(335530, 'PTHR12549:SF51', NULL, NULL, NULL, NULL, 'JMJC DOMAIN-CONTAINING PROTEIN', 243026),
(335531, 'PTHR12549:SF62', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE JMJ25-LIKE', 243026),
(335532, 'PTHR12549:SF50', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR JUMONJI (JMJC) DOMAIN PROTEIN', 243026),
(335533, 'PTHR12549', NULL, NULL, NULL, NULL, 'JMJC DOMAIN-CONTAINING HISTONE DEMETHYLATION PROTEIN', 243026),
(335534, 'PTHR12549:SF7', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE 3A', 243026),
(335535, 'PTHR12549:SF6', NULL, NULL, NULL, NULL, 'JMJC DOMAIN-CONTAINING HISTONE DEMETHYLATION PROTEIN 2C-RELATED', 243026),
(335536, 'PTHR12549:SF8', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE 3B', 243026),
(335537, 'PTHR12549:SF4', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE HAIRLESS', 243026),
(335538, 'PTHR44699:SF1', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN SUPERFAMILY MEMBER 11', 243027),
(335539, 'PTHR44699', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN SUPERFAMILY MEMBER 11', 243027),
(335540, 'PTHR44699:SF2', NULL, NULL, NULL, NULL, 'ZGC:165604', 243027),
(335541, 'PTHR43468', NULL, NULL, NULL, NULL, '', 243028),
(335542, 'PTHR43468:SF1', NULL, NULL, NULL, NULL, 'QUEUINE TRNA-RIBOSYLTRANSFERASE', 243028),
(335543, 'PTHR33785:SF6', NULL, NULL, NULL, NULL, 'BNAC03G69450D PROTEIN', 243029),
(335544, 'PTHR33785:SF5', NULL, NULL, NULL, NULL, 'SERINE/ARGININE REPETITIVE MATRIX PROTEIN', 243029),
(335545, 'PTHR33785:SF2', NULL, NULL, NULL, NULL, 'OS06G0550800 PROTEIN', 243029),
(335546, 'PTHR33785:SF12', NULL, NULL, NULL, NULL, 'BNAC04G48490D PROTEIN', 243029),
(335547, 'PTHR33785:SF11', NULL, NULL, NULL, NULL, '', 243029),
(335548, 'PTHR33785', NULL, NULL, NULL, NULL, 'OS06G0550800 PROTEIN', 243029),
(335549, 'PTHR33785:SF9', NULL, NULL, NULL, NULL, 'BNAC06G10010D PROTEIN', 243029),
(335550, 'PTHR33785:SF8', NULL, NULL, NULL, NULL, '', 243029),
(335551, 'PTHR36397', NULL, NULL, NULL, NULL, 'OSJNBA0081L15.1 PROTEIN', 243030),
(335552, 'PTHR36397:SF1', NULL, NULL, NULL, NULL, 'OS04G0482900 PROTEIN', 243030),
(335553, 'PTHR47182', NULL, NULL, NULL, NULL, 'CELL WALL ALPHA-1,3-GLUCAN SYNTHASE AGS1-RELATED', 243031),
(335554, 'PTHR47182:SF1', NULL, NULL, NULL, NULL, 'ALPHA-1,3-GLUCAN SYNTHASE', 243031),
(335555, 'PTHR47182:SF2', NULL, NULL, NULL, NULL, 'CELL WALL ALPHA-1,3-GLUCAN SYNTHASE AGS1', 243031),
(335556, 'PTHR47182:SF3', NULL, NULL, NULL, NULL, 'CELL WALL ALPHA-1,3-GLUCAN SYNTHASE MOK14', 243031),
(335557, 'PTHR47182:SF4', NULL, NULL, NULL, NULL, 'CELL WALL ALPHA-1,3-GLUCAN SYNTHASE MOK13', 243031),
(335558, 'PTHR47182:SF5', NULL, NULL, NULL, NULL, 'CELL WALL ALPHA-1,3-GLUCAN SYNTHASE MOK12', 243031),
(335559, 'PTHR47182:SF6', NULL, NULL, NULL, NULL, 'CELL WALL ALPHA-1,3-GLUCAN SYNTHASE MOK11', 243031),
(335560, 'PTHR32153:SF73', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335561, 'PTHR32153:SF51', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335562, 'PTHR32153:SF72', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 25', 243032),
(335563, 'PTHR32153:SF50', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335564, 'PTHR32153:SF71', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(335565, 'PTHR32153:SF70', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335566, 'PTHR32153:SF15', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335567, 'PTHR32153:SF37', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335568, 'PTHR32153:SF59', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335569, 'PTHR32153:SF13', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335570, 'PTHR32153:SF35', NULL, NULL, NULL, NULL, 'OS02G0786600 PROTEIN', 243032),
(335571, 'PTHR32153:SF56', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335572, 'PTHR32153:SF33', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335573, 'PTHR32153:SF55', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335574, 'PTHR32153:SF11', NULL, NULL, NULL, NULL, 'F-BOX/LRR PROTEIN', 243032),
(335575, 'PTHR32153:SF10', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335576, 'PTHR32153:SF54', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335577, 'PTHR32153:SF74', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335578, 'PTHR32153:SF19', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335579, 'PTHR32153:SF16', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335580, 'PTHR32153:SF38', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335581, 'PTHR32153', NULL, NULL, NULL, NULL, 'OJ000223_09.16 PROTEIN', 243032),
(335582, 'PTHR32153:SF62', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335583, 'PTHR32153:SF40', NULL, NULL, NULL, NULL, 'OS02G0793500 PROTEIN', 243032),
(335584, 'PTHR32153:SF61', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335585, 'PTHR32153:SF60', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335586, 'PTHR32153:SF48', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335587, 'PTHR32153:SF47', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335588, 'PTHR32153:SF69', NULL, NULL, NULL, NULL, 'BNAANNG28410D PROTEIN', 243032),
(335589, 'PTHR32153:SF24', NULL, NULL, NULL, NULL, '', 243032),
(335590, 'PTHR32153:SF68', NULL, NULL, NULL, NULL, 'BNAC05G35090D PROTEIN', 243032),
(335591, 'PTHR32153:SF46', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335592, 'PTHR32153:SF67', NULL, NULL, NULL, NULL, 'OS02G0826000 PROTEIN', 243032),
(335593, 'PTHR32153:SF66', NULL, NULL, NULL, NULL, 'OS05G0106900 PROTEIN', 243032),
(335594, 'PTHR32153:SF44', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335595, 'PTHR32153:SF22', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335596, 'PTHR32153:SF43', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335597, 'PTHR32153:SF65', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335598, 'PTHR32153:SF20', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335599, 'PTHR32153:SF64', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335600, 'PTHR32153:SF42', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335601, 'PTHR32153:SF41', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335602, 'PTHR32153:SF63', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335603, 'PTHR32153:SF49', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243032),
(335604, 'PTHR14154', NULL, NULL, NULL, NULL, 'UPF0041 BRAIN PROTEIN 44-RELATED', 243033),
(335605, 'PTHR14154:SF79', NULL, NULL, NULL, NULL, 'LHC-RELATED PROTEIN', 243033),
(335606, 'PTHR14154:SF73', NULL, NULL, NULL, NULL, 'EARLY LIGHT-INDUCED PROTEIN 3', 243033),
(335607, 'PTHR14154:SF116', NULL, NULL, NULL, NULL, 'BNAA02G25020D PROTEIN', 243033),
(335608, 'PTHR14154:SF118', NULL, NULL, NULL, NULL, '(BREAD WHEAT) HYPOTHETICAL PROTEIN', 243033),
(335609, 'PTHR14154:SF76', NULL, NULL, NULL, NULL, 'BNAA05G16860D PROTEIN', 243033);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(335610, 'PTHR14154:SF141', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II 22 KDA PROTEIN 1, CHLOROPLASTIC', 243033),
(335611, 'PTHR14154:SF142', NULL, NULL, NULL, NULL, 'EARLY LIGHT-INDUCED PROTEIN 1, CHLOROPLASTIC-LIKE', 243033),
(335612, 'PTHR14154:SF80', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PYRUVATE CARRIER', 243033),
(335613, 'PTHR14154:SF101', NULL, NULL, NULL, NULL, '', 243033),
(335614, 'PTHR14154:SF84', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PYRUVATE CARRIER', 243033),
(335615, 'PTHR14154:SF105', NULL, NULL, NULL, NULL, '', 243033),
(335616, 'PTHR14154:SF109', NULL, NULL, NULL, NULL, '', 243033),
(335617, 'PTHR14154:SF86', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PYRUVATE CARRIER', 243033),
(335618, 'PTHR14154:SF15', NULL, NULL, NULL, NULL, 'FKBP-TYPE PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 243033),
(335619, 'PTHR14154:SF14', NULL, NULL, NULL, NULL, 'LIGHT-HARVESTING COMPLEX-LIKE PROTEIN 3 ISOTYPE 1, CHLOROPLASTIC', 243033),
(335620, 'PTHR14154:SF18', NULL, NULL, NULL, NULL, 'STRESS ENHANCED PROTEIN 1, CHLOROPLASTIC', 243033),
(335621, 'PTHR14154:SF140', NULL, NULL, NULL, NULL, '', 243033),
(335622, 'PTHR14154:SF130', NULL, NULL, NULL, NULL, 'BNAC09G20020D PROTEIN', 243033),
(335623, 'PTHR14154:SF131', NULL, NULL, NULL, NULL, '', 243033),
(335624, 'PTHR14154:SF132', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PYRUVATE CARRIER', 243033),
(335625, 'PTHR14154:SF133', NULL, NULL, NULL, NULL, '', 243033),
(335626, 'PTHR14154:SF134', NULL, NULL, NULL, NULL, 'BNACNNG37300D PROTEIN', 243033),
(335627, 'PTHR14154:SF135', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II 22 KDA PROTEIN, CHLOROPLASTIC', 243033),
(335628, 'PTHR14154:SF136', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II 22 KDA PROTEIN, CHLOROPLASTIC-LIKE', 243033),
(335629, 'PTHR14154:SF137', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PYRUVATE CARRIER 1', 243033),
(335630, 'PTHR14154:SF90', NULL, NULL, NULL, NULL, 'ONE-HELIX PROTEIN 2-RELATED', 243033),
(335631, 'PTHR14154:SF138', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PYRUVATE CARRIER', 243033),
(335632, 'PTHR14154:SF51', NULL, NULL, NULL, NULL, 'OS05G0292800 PROTEIN', 243033),
(335633, 'PTHR14154:SF96', NULL, NULL, NULL, NULL, 'EARLY LIGHT-INDUCED PROTEIN 2, CHLOROPLASTIC', 243033),
(335634, 'PTHR14154:SF139', NULL, NULL, NULL, NULL, '', 243033),
(335635, 'PTHR14154:SF93', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PYRUVATE CARRIER 2', 243033),
(335636, 'PTHR14154:SF50', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PYRUVATE CARRIER', 243033),
(335637, 'PTHR14154:SF55', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PYRUVATE CARRIER', 243033),
(335638, 'PTHR14154:SF56', NULL, NULL, NULL, NULL, 'FACTOR, PUTATIVE-RELATED', 243033),
(335639, 'PTHR14154:SF3', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PYRUVATE CARRIER', 243033),
(335640, 'PTHR14154:SF2', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PYRUVATE CARRIER 2', 243033),
(335641, 'PTHR14154:SF5', NULL, NULL, NULL, NULL, 'EARLY LIGHT-INDUCED PROTEIN 1, CHLOROPLASTIC', 243033),
(335642, 'PTHR14154:SF68', NULL, NULL, NULL, NULL, 'LIGHT-HARVESTING COMPLEX-LIKE PROTEIN OHP2, CHLOROPLASTIC', 243033),
(335643, 'PTHR14154:SF9', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PYRUVATE CARRIER 1-LIKE PROTEIN', 243033),
(335644, 'PTHR14154:SF8', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PYRUVATE CARRIER 1', 243033),
(335645, 'PTHR14154:SF120', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PYRUVATE CARRIER', 243033),
(335646, 'PTHR14154:SF121', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PYRUVATE CARRIER', 243033),
(335647, 'PTHR14154:SF122', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II 22 KDA PROTEIN, CHLOROPLASTIC', 243033),
(335648, 'PTHR14154:SF123', NULL, NULL, NULL, NULL, 'BNAA08G06530D PROTEIN', 243033),
(335649, 'PTHR14154:SF124', NULL, NULL, NULL, NULL, 'LIGHT-HARVESTING COMPLEX-LIKE PROTEIN 3 ISOTYPE 2, CHLOROPLASTIC', 243033),
(335650, 'PTHR14154:SF125', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PYRUVATE CARRIER 3', 243033),
(335651, 'PTHR14154:SF126', NULL, NULL, NULL, NULL, 'LIGHT-HARVESTING COMPLEX I CHLOROPHYLL A/B-BINDING PROTEIN', 243033),
(335652, 'PTHR14154:SF127', NULL, NULL, NULL, NULL, 'LIGHT HARVESTING 3', 243033);
INSERT INTO "PUBLIC"."MODEL" VALUES
(335653, 'PTHR14154:SF128', NULL, NULL, NULL, NULL, 'LIGHT-HARVESTING COMPLEX-LIKE PROTEIN OHP1, CHLOROPLASTIC', 243033),
(335654, 'PTHR14154:SF129', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PYRUVATE CARRIER', 243033),
(335655, 'PTHR14154:SF66', NULL, NULL, NULL, NULL, 'STRESS ENHANCED PROTEIN 1 CHLOROPLASTIC', 243033),
(335656, 'PTHR14154:SF64', NULL, NULL, NULL, NULL, '(BREAD WHEAT) HYPOTHETICAL PROTEIN', 243033),
(335657, 'PTHR14154:SF65', NULL, NULL, NULL, NULL, 'EARLY LIGHT INDUCIBLE PROTEIN2', 243033),
(335658, 'PTHR15926', NULL, NULL, NULL, NULL, 'ALL-TRANS RETINOIC ACID-INDUCED DIFFERENTIATION FACTOR', 243034),
(335659, 'PTHR15926:SF1', NULL, NULL, NULL, NULL, 'ALL-TRANS RETINOIC ACID-INDUCED DIFFERENTIATION FACTOR', 243034),
(335660, 'PTHR22936:SF84', NULL, NULL, NULL, NULL, 'RHOMBOID-LIKE PROTEIN', 243035),
(335661, 'PTHR22936:SF86', NULL, NULL, NULL, NULL, 'RHOMBOID-LIKE PROTEIN 3', 243035),
(335662, 'PTHR22936:SF85', NULL, NULL, NULL, NULL, 'RHOMBOID-LIKE PROTEIN', 243035),
(335663, 'PTHR22936', NULL, NULL, NULL, NULL, 'RHOMBOID-RELATED', 243035),
(335664, 'PTHR22936:SF87', NULL, NULL, NULL, NULL, 'RHOMBOID-LIKE PROTEIN 5', 243035),
(335665, 'PTHR22936:SF80', NULL, NULL, NULL, NULL, 'RHOMBOID-LIKE PROTEIN 6, MITOCHONDRIAL', 243035),
(335666, 'PTHR22936:SF79', NULL, NULL, NULL, NULL, 'RHOMBOID-LIKE PROTEIN 4', 243035),
(335667, 'PTHR22936:SF93', NULL, NULL, NULL, NULL, 'RHOMBOID-LIKE PROTEIN', 243035),
(335668, 'PTHR22936:SF73', NULL, NULL, NULL, NULL, 'RHOMBOID-LIKE PROTEIN 2', 243035),
(335669, 'PTHR22936:SF72', NULL, NULL, NULL, NULL, 'RHOMBOID-LIKE PROTEIN', 243035),
(335670, 'PTHR22936:SF94', NULL, NULL, NULL, NULL, 'RHOMBOID-LIKE PROTEIN 7', 243035),
(335671, 'PTHR22936:SF75', NULL, NULL, NULL, NULL, 'RHOMBOID-LIKE PROTEIN 8', 243035),
(335672, 'PTHR22936:SF31', NULL, NULL, NULL, NULL, 'RHOMBOID-LIKE PROTEIN', 243035),
(335673, 'PTHR22936:SF77', NULL, NULL, NULL, NULL, 'RHOMBOID-LIKE PROTEIN 1', 243035),
(335674, 'PTHR22936:SF99', NULL, NULL, NULL, NULL, 'RHOMBOID-LIKE PROTEIN', 243035),
(335675, 'PTHR22936:SF98', NULL, NULL, NULL, NULL, 'RHOMBOID-LIKE PROTEIN', 243035),
(335676, 'PTHR22936:SF106', NULL, NULL, NULL, NULL, 'RHOMBOID-LIKE PROTEIN', 243035),
(335677, 'PTHR22936:SF105', NULL, NULL, NULL, NULL, 'RHOMBOID-LIKE PROTEIN', 243035),
(335678, 'PTHR22936:SF89', NULL, NULL, NULL, NULL, 'RHOMBOID-LIKE PROTEIN', 243035),
(335679, 'PTHR22936:SF104', NULL, NULL, NULL, NULL, 'RHOMBOID-LIKE PROTEIN', 243035),
(335680, 'PTHR22936:SF103', NULL, NULL, NULL, NULL, 'RHOMBOID-LIKE PROTEIN', 243035),
(335681, 'PTHR22936:SF102', NULL, NULL, NULL, NULL, 'RHOMBOID-LIKE PROTEIN', 243035),
(335682, 'PTHR22936:SF69', NULL, NULL, NULL, NULL, 'RHOMBOID-LIKE PROTEIN', 243035),
(335683, 'PTHR22936:SF101', NULL, NULL, NULL, NULL, 'RHOMBOID-LIKE PROTEIN', 243035),
(335684, 'PTHR22936:SF100', NULL, NULL, NULL, NULL, 'RHOMBOID-LIKE PROTEIN', 243035),
(335685, 'PTHR22773:SF112', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT 2 B, CHLOROPLASTIC', 243036),
(335686, 'PTHR22773:SF113', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE SUBUNIT 2-RELATED', 243036),
(335687, 'PTHR22773:SF41', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE CHAIN 2', 243036),
(335688, 'PTHR22773:SF114', NULL, NULL, NULL, NULL, 'NADH:QUINONE OXIDOREDUCTASE/MRP ANTIPORTER, MEMBRANE SUBUNIT-RELATED', 243036),
(335689, 'PTHR22773:SF115', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT 2 A PROTEIN-RELATED', 243036),
(335690, 'PTHR22773:SF116', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT 2 A, CHLOROPLASTIC-RELATED', 243036),
(335691, 'PTHR22773', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE', 243036),
(335692, 'PTHR16059:SF16', NULL, NULL, NULL, NULL, 'ANTHRAX TOXIN RECEPTOR-LIKE', 243037),
(335693, 'PTHR16059:SF27', NULL, NULL, NULL, NULL, 'ANTHRAX TOXIN RECEPTOR', 243037),
(335694, 'PTHR16059:SF28', NULL, NULL, NULL, NULL, 'ANTXR CELL ADHESION MOLECULE 1B', 243037),
(335695, 'PTHR16059:SF11', NULL, NULL, NULL, NULL, 'ANTHRAX TOXIN RECEPTOR 1', 243037),
(335696, 'PTHR16059', NULL, NULL, NULL, NULL, 'ANTHRAX TOXIN RECEPTOR', 243037);
INSERT INTO "PUBLIC"."MODEL" VALUES
(335697, 'PTHR16059:SF25', NULL, NULL, NULL, NULL, 'THROMBOSPONDIN-RELATED ANONYMOUS PROTEIN', 243037),
(335698, 'PTHR16059:SF13', NULL, NULL, NULL, NULL, 'ANTHRAX TOXIN RECEPTOR 2', 243037),
(335699, 'PTHR30472:SF1', NULL, NULL, NULL, NULL, 'FE(3+) DICITRATE TRANSPORT SYSTEM PERMEASE PROTEIN FECC-RELATED', 243038),
(335700, 'PTHR30472:SF2', NULL, NULL, NULL, NULL, 'FE(3+) DICITRATE TRANSPORT SYSTEM PERMEASE PROTEIN FECD', 243038),
(335701, 'PTHR30472:SF19', NULL, NULL, NULL, NULL, 'PETROBACTIN IMPORT SYSTEM PERMEASE PROTEIN YCLO', 243038),
(335702, 'PTHR30472:SF18', NULL, NULL, NULL, NULL, 'IRON(III) DICITRATE ABC TRANSPORTER,PERMEASE PROTEIN-RELATED', 243038),
(335703, 'PTHR30472:SF29', NULL, NULL, NULL, NULL, 'VITAMIN B12 IMPORT SYSTEM PERMEASE PROTEIN BTUC', 243038),
(335704, 'PTHR30472:SF65', NULL, NULL, NULL, NULL, 'SIDEROPHORE TRANSPORT SYSTEM PERMEASE PROTEIN YFIZ-RELATED', 243038),
(335705, 'PTHR30472:SF21', NULL, NULL, NULL, NULL, 'HEME-IRON TRANSPORT SYSTEM PERMEASE PROTEIN ISDF-RELATED', 243038),
(335706, 'PTHR30472:SF24', NULL, NULL, NULL, NULL, 'FERRIC ENTEROBACTIN TRANSPORT SYSTEM PERMEASE PROTEIN FEPG', 243038),
(335707, 'PTHR30472:SF67', NULL, NULL, NULL, NULL, 'FE UPTAKE SYSTEM INTEGRAL MEMBRANE PROTEIN', 243038),
(335708, 'PTHR30472:SF23', NULL, NULL, NULL, NULL, 'IRON-UPTAKE SYSTEM PERMEASE PROTEIN FEUC', 243038),
(335709, 'PTHR30472:SF37', NULL, NULL, NULL, NULL, 'IRON(3+)-HYDROXAMATE IMPORT SYSTEM PERMEASE PROTEIN FHUB', 243038),
(335710, 'PTHR30472:SF25', NULL, NULL, NULL, NULL, 'MOLYBDATE IMPORT SYSTEM PERMEASE PROTEIN MOLB', 243038),
(335711, 'PTHR30472:SF58', NULL, NULL, NULL, NULL, 'IRON(3+)-HYDROXAMATE IMPORT SYSTEM PERMEASE PROTEIN FHUB', 243038),
(335712, 'PTHR30472:SF27', NULL, NULL, NULL, NULL, 'PETROBACTIN IMPORT SYSTEM PERMEASE PROTEIN YCLN', 243038),
(335713, 'PTHR30472', NULL, NULL, NULL, NULL, 'FERRIC ENTEROBACTIN TRANSPORT SYSTEM PERMEASE PROTEIN', 243038),
(335714, 'PTHR30472:SF64', NULL, NULL, NULL, NULL, 'IRON(3+)-HYDROXAMATE IMPORT SYSTEM PERMEASE PROTEIN FHUG', 243038),
(335715, 'PTHR30472:SF30', NULL, NULL, NULL, NULL, 'IRON-UPTAKE SYSTEM PERMEASE PROTEIN FEUB', 243038),
(335716, 'PTHR30472:SF41', NULL, NULL, NULL, NULL, 'TRANSPORT SYSTEM PERMEASE PROTEIN', 243038),
(335717, 'PTHR43513', NULL, NULL, NULL, NULL, 'DIHYDROOROTATE DEHYDROGENASE B (NAD(+)), ELECTRON TRANSFER SUBUNIT', 243039),
(335718, 'PTHR43513:SF1', NULL, NULL, NULL, NULL, 'ANAEROBIC SULFITE REDUCTASE SUBUNIT B', 243039),
(335719, 'PTHR43513:SF3', NULL, NULL, NULL, NULL, 'DIHYDROOROTATE DEHYDROGENASE B (NAD(+)), ELECTRON TRANSFER SUBUNIT-RELATED', 243039),
(335720, 'PTHR37740', NULL, NULL, NULL, NULL, 'OS02G0193500 PROTEIN', 243040),
(335721, 'PTHR37740:SF1', NULL, NULL, NULL, NULL, 'OS02G0193500 PROTEIN', 243040),
(335722, 'PTHR12656', NULL, NULL, NULL, NULL, 'BRG-1 ASSOCIATED FACTOR 250  BAF250', 243041),
(335723, 'PTHR12656:SF11', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 1B', 243041),
(335724, 'PTHR12656:SF12', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 1A', 243041),
(335725, 'PTHR12656:SF5', NULL, NULL, NULL, NULL, 'TRITHORAX GROUP PROTEIN OSA', 243041),
(335726, 'PTHR12656:SF13', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING PROTEIN LFR-LIKE', 243041),
(335727, 'PTHR44783:SF1', NULL, NULL, NULL, NULL, 'CXADR-LIKE MEMBRANE PROTEIN', 243042),
(335728, 'PTHR44783', NULL, NULL, NULL, NULL, 'CXADR-LIKE MEMBRANE PROTEIN', 243042),
(335729, 'PTHR18902:SF30', NULL, NULL, NULL, NULL, 'FI04457P-RELATED', 243043),
(335730, 'PTHR18902:SF31', NULL, NULL, NULL, NULL, 'NUF1, PUTATIVE-RELATED', 243043),
(335731, 'PTHR18902', NULL, NULL, NULL, NULL, 'NUCLEAR MITOTIC APPARATUS PROTEIN 1-RELATED', 243043),
(335732, 'PTHR18902:SF27', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 164 KDA', 243043),
(335733, 'PTHR18902:SF24', NULL, NULL, NULL, NULL, 'NUCLEAR MITOTIC APPARATUS PROTEIN 1', 243043),
(335734, 'PTHR18902:SF25', NULL, NULL, NULL, NULL, 'GRIP AND COILED-COIL DOMAIN-CONTAINING PROTEIN 2', 243043),
(335735, 'PTHR18902:SF26', NULL, NULL, NULL, NULL, 'GOLGIN SUBFAMILY A MEMBER 3', 243043);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(335736, 'PTHR13402:SF24', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC-16A.1', 243044),
(335737, 'PTHR13402:SF13', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC16A', 243044),
(335738, 'PTHR13402:SF26', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC16', 243044),
(335739, 'PTHR13402:SF27', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC16B HOMOLOG', 243044),
(335740, 'PTHR13402:SF28', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC16', 243044),
(335741, 'PTHR13402:SF17', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC16', 243044),
(335742, 'PTHR13402:SF29', NULL, NULL, NULL, NULL, 'SEC16_C DOMAIN-CONTAINING PROTEIN', 243044),
(335743, 'PTHR13402', NULL, NULL, NULL, NULL, 'RGPR-RELATED', 243044),
(335744, 'PTHR13402:SF6', NULL, NULL, NULL, NULL, 'SECRETORY 16, ISOFORM I', 243044),
(335745, 'PTHR13402:SF11', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC16B', 243044),
(335746, 'PTHR13402:SF22', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC16', 243044),
(335747, 'PTHR26451:SF980', NULL, NULL, NULL, NULL, 'GENE 7582-RELATED', 243045),
(335748, 'PTHR26451:SF71', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243045),
(335749, 'PTHR26451:SF860', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR-RELATED', 243045),
(335750, 'PTHR26451:SF225', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243045),
(335751, 'PTHR26451:SF146', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243045),
(335752, 'PTHR26451:SF344', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10J1', 243045),
(335753, 'PTHR26451:SF862', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243045),
(335754, 'PTHR26451:SF345', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243045),
(335755, 'PTHR26451:SF109', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR-RELATED', 243045),
(335756, 'PTHR26451:SF107', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10J4', 243045),
(335757, 'PTHR26451:SF866', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN-RELATED', 243045),
(335758, 'PTHR26451:SF904', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243045),
(335759, 'PTHR26451:SF905', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243045),
(335760, 'PTHR26451:SF869', NULL, NULL, NULL, NULL, 'LOC791954 PROTEIN-RELATED', 243045),
(335761, 'PTHR26451:SF470', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243045),
(335762, 'PTHR26451:SF196', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR FAMILY 1 SUBFAMILY R MEMBER 1 PSEUDOGENE', 243045),
(335763, 'PTHR26451:SF233', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4E1', 243045),
(335764, 'PTHR26451:SF871', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR-RELATED', 243045),
(335765, 'PTHR26451:SF237', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 13G1', 243045),
(335766, 'PTHR26451:SF476', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR FAMILY 10 SUBFAMILY K MEMBER 1', 243045),
(335767, 'PTHR26451:SF950', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR FAMILY 10 SUBFAMILY K MEMBER 1C', 243045),
(335768, 'PTHR26451:SF956', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 6K3', 243045),
(335769, 'PTHR26451:SF876', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR-RELATED', 243045),
(335770, 'PTHR26451:SF68', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 6K2', 243045),
(335771, 'PTHR26451:SF280', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243045),
(335772, 'PTHR26451:SF28', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10J3', 243045),
(335773, 'PTHR26451:SF160', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4E2', 243045),
(335774, 'PTHR26451:SF122', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243045),
(335775, 'PTHR26451:SF881', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR-RELATED', 243045),
(335776, 'PTHR26451:SF882', NULL, NULL, NULL, NULL, 'ZGC:194312', 243045),
(335777, 'PTHR26451:SF365', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243045),
(335778, 'PTHR26451:SF489', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR FAMILY 10 SUBFAMILY K MEMBER 1', 243045),
(335779, 'PTHR26451:SF885', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243045),
(335780, 'PTHR26451:SF325', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10K2', 243045);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(335781, 'PTHR26451:SF886', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR-RELATED', 243045),
(335782, 'PTHR26451:SF52', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 12D2', 243045),
(335783, 'PTHR26451:SF98', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10T2', 243045),
(335784, 'PTHR26451:SF889', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243045),
(335785, 'PTHR26451:SF405', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 530-RELATED', 243045),
(335786, 'PTHR26451:SF966', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR-RELATED', 243045),
(335787, 'PTHR26451:SF967', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 148-RELATED', 243045),
(335788, 'PTHR26451:SF887', NULL, NULL, NULL, NULL, 'SI:DKEYP-3F10.17', 243045),
(335789, 'PTHR26451:SF403', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243045),
(335790, 'PTHR26451:SF920', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243045),
(335791, 'PTHR26451:SF965', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1K1', 243045),
(335792, 'PTHR26451:SF404', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243045),
(335793, 'PTHR26451:SF968', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 12D1', 243045),
(335794, 'PTHR26451:SF847', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR-RELATED', 243045),
(335795, 'PTHR26451:SF969', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR', 243045),
(335796, 'PTHR26451:SF848', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR-RELATED', 243045),
(335797, 'PTHR26451:SF928', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 148-RELATED', 243045),
(335798, 'PTHR26451:SF210', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243045),
(335799, 'PTHR26451:SF970', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243045),
(335800, 'PTHR26451:SF175', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1404', 243045),
(335801, 'PTHR26451:SF132', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 6K6', 243045),
(335802, 'PTHR26451:SF896', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR-RELATED', 243045),
(335803, 'PTHR26451:SF42', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10R2', 243045),
(335804, 'PTHR26451:SF897', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243045),
(335805, 'PTHR26451:SF974', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR', 243045),
(335806, 'PTHR26451:SF971', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2A4-RELATED', 243045),
(335807, 'PTHR26451:SF972', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 6N2', 243045),
(335808, 'PTHR26451:SF977', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10K1', 243045),
(335809, 'PTHR26451:SF978', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2A25', 243045),
(335810, 'PTHR26451:SF854', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR-RELATED', 243045),
(335811, 'PTHR26451:SF975', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN-RELATED', 243045),
(335812, 'PTHR26451:SF976', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243045),
(335813, 'PTHR26451:SF979', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243045),
(335814, 'PTHR26451', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243045),
(335815, 'PTHR26451:SF819', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 12D3', 243045),
(335816, 'PTHR26451:SF49', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10Z1', 243045),
(335817, 'PTHR26451:SF381', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 527-RELATED', 243045),
(335818, 'PTHR46461:SF1', NULL, NULL, NULL, NULL, 'KELCH DOMAIN-CONTAINING PROTEIN 3', 243046),
(335819, 'PTHR46461', NULL, NULL, NULL, NULL, 'KELCH DOMAIN-CONTAINING PROTEIN 3', 243046),
(335820, 'PTHR46461:SF2', NULL, NULL, NULL, NULL, 'ATTRACTIN', 243046),
(335821, 'PTHR36816:SF1', NULL, NULL, NULL, NULL, 'ATP SYNTHASE PROTEIN YMF19', 243047),
(335822, 'PTHR36816', NULL, NULL, NULL, NULL, 'ATP SYNTHASE PROTEIN YMF19', 243047),
(335823, 'PTHR16021:SF18', NULL, NULL, NULL, NULL, 'TFIIS N-TERMINAL DOMAIN-CONTAINING PROTEIN', 243048),
(335824, 'PTHR16021:SF19', NULL, NULL, NULL, NULL, 'MANSC DOMAIN-CONTAINING PROTEIN', 243048),
(335825, 'PTHR16021:SF9', NULL, NULL, NULL, NULL, 'CHROMOSOME 11 OPEN READING FRAME 24', 243048);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(335826, 'PTHR16021', NULL, NULL, NULL, NULL, 'MANSC DOMAIN CONTAINING PROTEIN 1', 243048),
(335827, 'PTHR16021:SF20', NULL, NULL, NULL, NULL, '', 243048),
(335828, 'PTHR16021:SF21', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 243048),
(335829, 'PTHR16021:SF22', NULL, NULL, NULL, NULL, 'OXIDANT-INDUCED CELL-CYCLE ARREST PROTEIN 5', 243048),
(335830, 'PTHR16021:SF23', NULL, NULL, NULL, NULL, 'EARTHBOUND 1-RELATED', 243048),
(335831, 'PTHR16021:SF24', NULL, NULL, NULL, NULL, '', 243048),
(335832, 'PTHR16021:SF13', NULL, NULL, NULL, NULL, 'FI18411P1', 243048),
(335833, 'PTHR16021:SF25', NULL, NULL, NULL, NULL, 'MANSC DOMAIN-CONTAINING 1', 243048),
(335834, 'PTHR16021:SF7', NULL, NULL, NULL, NULL, 'MANSC DOMAIN-CONTAINING PROTEIN 1', 243048),
(335835, 'PTHR36968', NULL, NULL, NULL, NULL, 'HOMEOBOX-DDT DOMAIN PROTEIN RLT2', 243049),
(335836, 'PTHR36968:SF5', NULL, NULL, NULL, NULL, 'HOMEOBOX-DDT DOMAIN PROTEIN RLT2', 243049),
(335837, 'PTHR36968:SF12', NULL, NULL, NULL, NULL, 'BNAA09G27250D PROTEIN', 243049),
(335838, 'PTHR36968:SF13', NULL, NULL, NULL, NULL, 'HOMEOBOX-DDT DOMAIN PROTEIN RLT1', 243049),
(335839, 'PTHR36968:SF8', NULL, NULL, NULL, NULL, 'HOMEOBOX-DDT DOMAIN PROTEIN RLT3 ISOFORM X1', 243049),
(335840, 'PTHR36968:SF14', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN PROTEIN', 243049),
(335841, 'PTHR36968:SF15', NULL, NULL, NULL, NULL, '', 243049),
(335842, 'PTHR36968:SF16', NULL, NULL, NULL, NULL, 'HOMEOBOX-DDT DOMAIN PROTEIN RLT1', 243049),
(335843, 'PTHR46666:SF8', NULL, NULL, NULL, NULL, 'BNAA03G47810D PROTEIN', 243050),
(335844, 'PTHR46666:SF7', NULL, NULL, NULL, NULL, '', 243050),
(335845, 'PTHR46666:SF9', NULL, NULL, NULL, NULL, 'BNAC03G70050D PROTEIN', 243050),
(335846, 'PTHR46666:SF6', NULL, NULL, NULL, NULL, 'BNAC08G12080D PROTEIN', 243050),
(335847, 'PTHR46666:SF10', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L18AE FAMILY', 243050),
(335848, 'PTHR46666:SF2', NULL, NULL, NULL, NULL, '60S RIBOSOMAL L18A-LIKE PROTEIN', 243050),
(335849, 'PTHR46666:SF1', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L18AE FAMILY', 243050),
(335850, 'PTHR46666', NULL, NULL, NULL, NULL, '60S RIBOSOMAL L18A-LIKE PROTEIN', 243050),
(335851, 'PTHR37069:SF2', NULL, NULL, NULL, NULL, 'DDE_TNP_1_7 DOMAIN-CONTAINING PROTEIN', 243051),
(335852, 'PTHR37069', NULL, NULL, NULL, NULL, 'DDE_TNP_1_7 DOMAIN-CONTAINING PROTEIN', 243051),
(335853, 'PTHR24051', NULL, NULL, NULL, NULL, 'SUSHI DOMAIN-CONTAINING PROTEIN 1', 243052),
(335854, 'PTHR24051:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG04582', 243052),
(335855, 'PTHR24051:SF10', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE-PHOSPHATASE-RELATED', 243052),
(335856, 'PTHR24051:SF6', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE-III DOMAIN-CONTAINING PROTEIN', 243052),
(335857, 'PTHR24051:SF5', NULL, NULL, NULL, NULL, 'SUSHI DOMAIN-CONTAINING PROTEIN 1', 243052),
(335858, 'PTHR24051:SF8', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE-PHOSPHATASE', 243052),
(335859, 'PTHR33968', NULL, NULL, NULL, NULL, 'PROTEIN PET100 HOMOLOG, MITOCHONDRIAL', 243053),
(335860, 'PTHR33968:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PET100 HOMOLOG, MITOCHONDRIAL', 243053),
(335861, 'PTHR43030', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE SYNTHASE', 243054),
(335862, 'PTHR43030:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE SYNTHASE', 243054),
(335863, 'PTHR47416:SF7', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR 60', 243055),
(335864, 'PTHR47416:SF8', NULL, NULL, NULL, NULL, 'BASIC-LEUCINE ZIPPER TRANSCRIPTION FACTOR E-RELATED', 243055),
(335865, 'PTHR47416', NULL, NULL, NULL, NULL, 'BASIC-LEUCINE ZIPPER TRANSCRIPTION FACTOR F-RELATED', 243055),
(335866, 'PTHR47416:SF6', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 243055),
(335867, 'PTHR47416:SF9', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR 28', 243055),
(335868, 'PTHR47416:SF11', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 243055),
(335869, 'PTHR47416:SF10', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 243055),
(335870, 'PTHR47416:SF3', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR 17-RELATED', 243055);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(335871, 'PTHR47416:SF4', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 243055),
(335872, 'PTHR33830:SF24', NULL, NULL, NULL, NULL, 'BNACNNG45740D PROTEIN', 243056),
(335873, 'PTHR33830:SF25', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 128-RELATED', 243056),
(335874, 'PTHR33830:SF26', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 122-RELATED', 243056),
(335875, 'PTHR33830:SF16', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 127-RELATED', 243056),
(335876, 'PTHR33830:SF27', NULL, NULL, NULL, NULL, '', 243056),
(335877, 'PTHR33830:SF28', NULL, NULL, NULL, NULL, '', 243056),
(335878, 'PTHR33830:SF29', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH 16, PUTATIVE ISOFORM 1-RELATED', 243056),
(335879, 'PTHR33830:SF19', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 159-RELATED', 243056),
(335880, 'PTHR33830:SF7', NULL, NULL, NULL, NULL, 'OS02G0776000 PROTEIN', 243056),
(335881, 'PTHR33830:SF30', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 184-RELATED', 243056),
(335882, 'PTHR33830:SF31', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 156', 243056),
(335883, 'PTHR33830:SF20', NULL, NULL, NULL, NULL, 'BNAA01G07560D PROTEIN', 243056),
(335884, 'PTHR33830:SF32', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 119-RELATED', 243056),
(335885, 'PTHR33830:SF21', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 155-RELATED', 243056),
(335886, 'PTHR33830:SF10', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 118-RELATED', 243056),
(335887, 'PTHR33830:SF22', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 165-RELATED', 243056),
(335888, 'PTHR33830:SF33', NULL, NULL, NULL, NULL, 'BNAA09G27490D PROTEIN', 243056),
(335889, 'PTHR33830:SF11', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 163-RELATED', 243056),
(335890, 'PTHR33830:SF23', NULL, NULL, NULL, NULL, 'BNAC03G62260D PROTEIN', 243056),
(335891, 'PTHR33830:SF12', NULL, NULL, NULL, NULL, 'BNAA04G15230D PROTEIN', 243056),
(335892, 'PTHR33830:SF3', NULL, NULL, NULL, NULL, 'S-LOCUS CYSTEINE-RICH PROTEIN (SCR)', 243056),
(335893, 'PTHR33830', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 184-RELATED', 243056),
(335894, 'PTHR13219', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243057),
(335895, 'PTHR13219:SF6', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 94', 243057),
(335896, 'PTHR32161:SF16', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243058),
(335897, 'PTHR32161:SF24', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243058),
(335898, 'PTHR32161:SF19', NULL, NULL, NULL, NULL, 'DPP6 AMINO-TERMINAL DOMAIN PROTEIN', 243058),
(335899, 'PTHR32161:SF18', NULL, NULL, NULL, NULL, '', 243058),
(335900, 'PTHR32161', NULL, NULL, NULL, NULL, 'DPP6 N-TERMINAL DOMAIN-LIKE PROTEIN', 243058),
(335901, 'PTHR32161:SF23', NULL, NULL, NULL, NULL, '', 243058),
(335902, 'PTHR32161:SF8', NULL, NULL, NULL, NULL, 'DPP6 N-TERMINAL DOMAIN-LIKE PROTEIN', 243058),
(335903, 'PTHR32161:SF22', NULL, NULL, NULL, NULL, '', 243058),
(335904, 'PTHR32161:SF9', NULL, NULL, NULL, NULL, 'TOLB PROTEIN-LIKE PROTEIN', 243058),
(335905, 'PTHR32161:SF21', NULL, NULL, NULL, NULL, 'OS03G0403400 PROTEIN', 243058),
(335906, 'PTHR48126:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG18254', 243059),
(335907, 'PTHR48126', NULL, NULL, NULL, NULL, 'RE24507P', 243059),
(335908, 'PTHR37103', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 243060),
(335909, 'PTHR37103:SF1', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 243060),
(335910, 'PTHR42870:SF7', NULL, NULL, NULL, NULL, 'ACETYL-COA C-ACETYLTRANSFERASE (ACETOACETYL-COA THIOLASE) (ACAB-3)', 243061),
(335911, 'PTHR42870', NULL, NULL, NULL, NULL, 'ACETYL-COA C-ACETYLTRANSFERASE', 243061),
(335912, 'PTHR42870:SF6', NULL, NULL, NULL, NULL, 'ACETYL-COA C-ACYLTRANSFERASE', 243061),
(335913, 'PTHR42870:SF1', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN-LIKE 2', 243061),
(335914, 'PTHR42870:SF2', NULL, NULL, NULL, NULL, 'LIPID-TRANSFER PROTEIN, PUTATIVE-RELATED', 243061),
(335915, 'PTHR30537:SF68', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', 243062),
(335916, 'PTHR30537:SF35', NULL, NULL, NULL, NULL, 'LYSR-FAMILY TRANSCRIPTIONAL REGULATORY PROTEIN', 243062);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(335917, 'PTHR30537:SF78', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR PTXR, PUTATIVE-RELATED', 243062),
(335918, 'PTHR30537:SF26', NULL, NULL, NULL, NULL, 'GLYCINE CLEAVAGE SYSTEM TRANSCRIPTIONAL ACTIVATOR', 243062),
(335919, 'PTHR30537:SF58', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR PERR', 243062),
(335920, 'PTHR30537:SF14', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR LYSR FAMILY', 243062),
(335921, 'PTHR30537:SF17', NULL, NULL, NULL, NULL, 'LYSR FAMILY TRANSCRIPTIONAL REGULATOR-RELATED', 243062),
(335922, 'PTHR30537:SF71', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 243062),
(335923, 'PTHR30537:SF70', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL ACTIVATOR AMPR', 243062),
(335924, 'PTHR30537:SF1', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR PGRR', 243062),
(335925, 'PTHR30537:SF72', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR SINR-RELATED', 243062),
(335926, 'PTHR30537:SF20', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 243062),
(335927, 'PTHR30537:SF31', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, LYSR FAMILY-RELATED', 243062),
(335928, 'PTHR30537:SF30', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', 243062),
(335929, 'PTHR30537:SF74', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR TRPI', 243062),
(335930, 'PTHR30537:SF5', NULL, NULL, NULL, NULL, 'LYSR_SUBSTRATE DOMAIN-CONTAINING PROTEIN', 243062),
(335931, 'PTHR30537:SF66', NULL, NULL, NULL, NULL, 'LYSR FAMILY TRANSCRIPTIONAL REGULATOR-RELATED', 243062),
(335932, 'PTHR30537:SF77', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL ACTIVATOR TTDR-RELATED', 243062),
(335933, 'PTHR30537', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR', 243062),
(335934, 'PTHR30537:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 243062),
(335935, 'PTHR30537:SF32', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR DSDC', 243062),
(335936, 'PTHR30537:SF10', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', 243062),
(335937, 'PTHR30537:SF21', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', 243062),
(335938, 'PTHR42061:SF4', NULL, NULL, NULL, NULL, 'ENDO-CHITOSANASE', 243063),
(335939, 'PTHR42061', NULL, NULL, NULL, NULL, 'ENDO-CHITOSANASE', 243063),
(335940, 'PTHR42061:SF7', NULL, NULL, NULL, NULL, 'ENDO-CHITOSANASE', 243063),
(335941, 'PTHR42061:SF6', NULL, NULL, NULL, NULL, 'ENDO-CHITOSANASE', 243063),
(335942, 'PTHR36861:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 116', 243064),
(335943, 'PTHR36861', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 116', 243064),
(335944, 'PTHR32077:SF83', NULL, NULL, NULL, NULL, 'OS06G0285100 PROTEIN', 243065),
(335945, 'PTHR32077:SF60', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN', 243065),
(335946, 'PTHR32077:SF82', NULL, NULL, NULL, NULL, 'OS09G0482780 PROTEIN', 243065),
(335947, 'PTHR32077:SF41', NULL, NULL, NULL, NULL, 'FAS1 DOMAIN-CONTAINING PROTEIN', 243065),
(335948, 'PTHR32077:SF85', NULL, NULL, NULL, NULL, 'FAS1 DOMAIN-CONTAINING PROTEIN', 243065),
(335949, 'PTHR32077:SF63', NULL, NULL, NULL, NULL, 'FAS1 DOMAIN-CONTAINING PROTEIN', 243065),
(335950, 'PTHR32077:SF84', NULL, NULL, NULL, NULL, 'OS05G0163300 PROTEIN', 243065),
(335951, 'PTHR32077:SF62', NULL, NULL, NULL, NULL, 'FAS1 DOMAIN-CONTAINING PROTEIN', 243065),
(335952, 'PTHR32077:SF40', NULL, NULL, NULL, NULL, 'FAS1 DOMAIN-CONTAINING PROTEIN', 243065),
(335953, 'PTHR32077:SF81', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN', 243065),
(335954, 'PTHR32077:SF80', NULL, NULL, NULL, NULL, 'BNAA03G00780D PROTEIN', 243065),
(335955, 'PTHR32077:SF69', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE AGP 12', 243065),
(335956, 'PTHR32077:SF46', NULL, NULL, NULL, NULL, 'FAS1 DOMAIN-CONTAINING PROTEIN', 243065),
(335957, 'PTHR32077:SF49', NULL, NULL, NULL, NULL, 'FAS1 DOMAIN-CONTAINING PROTEIN', 243065),
(335958, 'PTHR32077:SF48', NULL, NULL, NULL, NULL, 'FASCICLIN DOMAIN PROTEIN', 243065),
(335959, 'PTHR32077:SF43', NULL, NULL, NULL, NULL, 'OS04G0472200 PROTEIN', 243065);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(335960, 'PTHR32077:SF65', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 11', 243065),
(335961, 'PTHR32077:SF42', NULL, NULL, NULL, NULL, 'OS02G0308800 PROTEIN', 243065),
(335962, 'PTHR32077:SF64', NULL, NULL, NULL, NULL, 'BNAA06G36300D PROTEIN', 243065),
(335963, 'PTHR32077:SF45', NULL, NULL, NULL, NULL, 'FASCICLIN DOMAIN PROTEIN', 243065),
(335964, 'PTHR32077:SF67', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN PROTEIN 3', 243065),
(335965, 'PTHR32077:SF44', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 10', 243065),
(335966, 'PTHR32077:SF3', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 7', 243065),
(335967, 'PTHR32077:SF6', NULL, NULL, NULL, NULL, 'FAS1 DOMAIN-CONTAINING PROTEIN SELMODRAFT_448915', 243065),
(335968, 'PTHR32077:SF9', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 7', 243065),
(335969, 'PTHR32077', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN', 243065),
(335970, 'PTHR32077:SF72', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 9', 243065),
(335971, 'PTHR32077:SF71', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN PROTEIN 3', 243065),
(335972, 'PTHR32077:SF52', NULL, NULL, NULL, NULL, 'FAS1 DOMAIN-CONTAINING PROTEIN', 243065),
(335973, 'PTHR32077:SF51', NULL, NULL, NULL, NULL, 'FASCICLIN DOMAIN PROTEIN', 243065),
(335974, 'PTHR32077:SF59', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 12', 243065),
(335975, 'PTHR32077:SF37', NULL, NULL, NULL, NULL, 'OS09G0476800 PROTEIN', 243065),
(335976, 'PTHR32077:SF54', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 13-RELATED', 243065),
(335977, 'PTHR32077:SF53', NULL, NULL, NULL, NULL, 'FASCICLIN DOMAIN PROTEIN', 243065),
(335978, 'PTHR32077:SF75', NULL, NULL, NULL, NULL, 'FAS1 DOMAIN-CONTAINING PROTEIN', 243065),
(335979, 'PTHR32077:SF12', NULL, NULL, NULL, NULL, 'OS05G0563600 PROTEIN', 243065),
(335980, 'PTHR32077:SF56', NULL, NULL, NULL, NULL, 'FASCICLIN DOMAIN PROTEIN', 243065),
(335981, 'PTHR32077:SF78', NULL, NULL, NULL, NULL, 'FAS1 DOMAIN-CONTAINING PROTEIN', 243065),
(335982, 'PTHR32077:SF33', NULL, NULL, NULL, NULL, 'OS05G0563550 PROTEIN', 243065),
(335983, 'PTHR32077:SF39', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN', 243065),
(335984, 'PTHR32077:SF19', NULL, NULL, NULL, NULL, 'OS01G0668100 PROTEIN', 243065),
(335985, 'PTHR37832', NULL, NULL, NULL, NULL, 'BLL2683 PROTEIN', 243066),
(335986, 'PTHR37832:SF1', NULL, NULL, NULL, NULL, 'STRESS-RESPONSE A/B BARREL DOMAIN-CONTAINING PROTEIN', 243066),
(335987, 'PTHR13361', NULL, NULL, NULL, NULL, 'WW DOMAIN-BINDING PROTEIN 11', 243067),
(335988, 'PTHR13361:SF1', NULL, NULL, NULL, NULL, 'WW DOMAIN-BINDING PROTEIN 11', 243067),
(335989, 'PTHR36488:SF4', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 243068),
(335990, 'PTHR36488:SF8', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 1U1', 243068),
(335991, 'PTHR36488:SF9', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 243068),
(335992, 'PTHR36488:SF6', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 1U4', 243068),
(335993, 'PTHR36488:SF7', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 1U3', 243068),
(335994, 'PTHR36488', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 1U1', 243068),
(335995, 'PTHR36488:SF1', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 1U2', 243068),
(335996, 'PTHR36488:SF10', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 243068),
(335997, 'PTHR43580:SF2', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE GLYR1-RELATED', 243069),
(335998, 'PTHR43580:SF3', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONATE DEHYDROGENASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_2G11600)', 243069),
(335999, 'PTHR43580', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE GLYR1-RELATED', 243069),
(336000, 'PTHR43580:SF8', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONATE DEHYDROGENASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_1G13320)-RELATED', 243069),
(336001, 'PTHR43580:SF9', NULL, NULL, NULL, NULL, 'GLYOXYLATE/SUCCINIC SEMIALDEHYDE REDUCTASE 1', 243069),
(336002, 'PTHR24356:SF157', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 32B', 243070),
(336003, 'PTHR24356:SF158', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C BETA TYPE', 243070);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(336004, 'PTHR24356:SF397', NULL, NULL, NULL, NULL, 'AGC (CAMP-DEPENDENT, CGMP-DEPENDENT AND PROTEIN KINASE C) KINASE FAMILY PROTEIN-RELATED', 243070),
(336005, 'PTHR24356:SF232', NULL, NULL, NULL, NULL, '3-PHOSPHOINOSITIDE-DEPENDENT PROTEIN KINASE B', 243070),
(336006, 'PTHR24356:SF398', NULL, NULL, NULL, NULL, 'AGC (CAMP-DEPENDENT, CGMP-DEPENDENT AND PROTEIN KINASE C) KINASE FAMILY PROTEIN', 243070),
(336007, 'PTHR24356:SF354', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE IRE4-RELATED', 243070),
(336008, 'PTHR24356:SF359', NULL, NULL, NULL, NULL, 'AGC (CAMP-DEPENDENT, CGMP-DEPENDENT AND PROTEIN KINASE C) KINASE FAMILY PROTEIN', 243070),
(336009, 'PTHR24356:SF316', NULL, NULL, NULL, NULL, 'AGC (CAMP-DEPENDENT CGMP-DEPENDENT AND PROTEIN KINASE C) KINASE FAMILY PROTEIN', 243070),
(336010, 'PTHR24356:SF159', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C EPSILON TYPE', 243070),
(336011, 'PTHR24356:SF237', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 243070),
(336012, 'PTHR24356:SF391', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 243070),
(336013, 'PTHR24356', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE', 243070),
(336014, 'PTHR24356:SF193', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C ALPHA TYPE', 243070),
(336015, 'PTHR24356:SF392', NULL, NULL, NULL, NULL, 'MYOTONIN-PROTEIN KINASE', 243070),
(336016, 'PTHR24356:SF150', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED SERINE/THREONINE-PROTEIN KINASE 1', 243070),
(336017, 'PTHR24356:SF390', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C, BRAIN ISOZYME-RELATED', 243070),
(336018, 'PTHR24356:SF192', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C ETA TYPE', 243070),
(336019, 'PTHR24356:SF197', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SGK2', 243070),
(336020, 'PTHR24356:SF230', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C', 243070),
(336021, 'PTHR24356:SF153', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 32C', 243070),
(336022, 'PTHR24356:SF395', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE IRE-RELATED', 243070),
(336023, 'PTHR24356:SF396', NULL, NULL, NULL, NULL, 'PROTEIN KINASE FAMILY PROTEIN', 243070),
(336024, 'PTHR24356:SF352', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE IRE3-RELATED', 243070),
(336025, 'PTHR24356:SF1', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE GREATWALL', 243070),
(336026, 'PTHR24356:SF318', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE N3', 243070),
(336027, 'PTHR24356:SF300', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SGK1', 243070),
(336028, 'PTHR24356:SF421', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE YPK1', 243070),
(336029, 'PTHR24356:SF345', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE IREH1-RELATED', 243070),
(336030, 'PTHR24356:SF224', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED SERINE/THREONINE-PROTEIN KINASE 4', 243070),
(336031, 'PTHR24356:SF342', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 38-LIKE', 243070),
(336032, 'PTHR24356:SF221', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 38', 243070),
(336033, 'PTHR24356:SF386', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 243070),
(336034, 'PTHR24356:SF420', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PPK35', 243070),
(336035, 'PTHR24356:SF228', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 243070),
(336036, 'PTHR24356:SF302', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0290859-RELATED', 243070),
(336037, 'PTHR24356:SF346', NULL, NULL, NULL, NULL, 'PROTEIN KINASE FAMILY PROTEIN', 243070),
(336038, 'PTHR24356:SF303', NULL, NULL, NULL, NULL, 'ATYPICAL PROTEIN KINASE C', 243070),
(336039, 'PTHR24356:SF149', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE LATS2', 243070),
(336040, 'PTHR24356:SF347', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C DELTA TYPE HOMOLOG-RELATED', 243070),
(336041, 'PTHR24356:SF181', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C THETA TYPE', 243070),
(336042, 'PTHR24356:SF384', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 243070);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(336043, 'PTHR24356:SF143', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 32A', 243070),
(336044, 'PTHR24356:SF385', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PKGA-RELATED', 243070),
(336045, 'PTHR24356:SF184', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE TRICORNERED', 243070),
(336046, 'PTHR24356:SF140', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED SERINE/THREONINE-PROTEIN KINASE 3', 243070),
(336047, 'PTHR24356:SF190', NULL, NULL, NULL, NULL, 'RAC-GAMMA SERINE/THREONINE-PROTEIN KINASE', 243070),
(336048, 'PTHR24356:SF333', NULL, NULL, NULL, NULL, 'RAC SERINE/THREONINE-PROTEIN KINASE', 243070),
(336049, 'PTHR24356:SF410', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE TRICORNER ISOFORM X1', 243070),
(336050, 'PTHR24356:SF135', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0293276-RELATED', 243070),
(336051, 'PTHR24356:SF411', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PPK21', 243070),
(336052, 'PTHR24356:SF136', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED SERINE/THREONINE-PROTEIN KINASE 2', 243070),
(336053, 'PTHR24356:SF210', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE N', 243070),
(336054, 'PTHR24356:SF332', NULL, NULL, NULL, NULL, 'AGC (CAMP-DEPENDENT, CGMP-DEPENDENT AND PROTEIN KINASE C) KINASE FAMILY PROTEIN', 243070),
(336055, 'PTHR24356:SF376', NULL, NULL, NULL, NULL, 'BNAA09G56040D PROTEIN', 243070),
(336056, 'PTHR24356:SF337', NULL, NULL, NULL, NULL, 'AGC (CAMP-DEPENDENT, CGMP-DEPENDENT AND PROTEIN KINASE C) KINASE FAMILY PROTEIN', 243070),
(336057, 'PTHR24356:SF414', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 243070),
(336058, 'PTHR24356:SF415', NULL, NULL, NULL, NULL, 'AGC (CAMP-DEPENDENT, CGMP-DEPENDENT AND PROTEIN KINASE C) KINASE FAMILY PROTEIN-RELATED', 243070),
(336059, 'PTHR24356:SF412', NULL, NULL, NULL, NULL, 'BNACNNG54240D PROTEIN', 243070),
(336060, 'PTHR24356:SF379', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE TRICORNER-LIKE', 243070),
(336061, 'PTHR24356:SF214', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C IOTA TYPE', 243070),
(336062, 'PTHR24356:SF336', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0288795-RELATED', 243070),
(336063, 'PTHR24356:SF138', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE LATS1', 243070),
(336064, 'PTHR24356:SF413', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE CEK1-RELATED', 243070),
(336065, 'PTHR24356:SF171', NULL, NULL, NULL, NULL, 'RAC-ALPHA SERINE/THREONINE-PROTEIN KINASE', 243070),
(336066, 'PTHR24356:SF170', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C ZETA TYPE', 243070),
(336067, 'PTHR24356:SF373', NULL, NULL, NULL, NULL, 'BNAC06G02020D PROTEIN', 243070),
(336068, 'PTHR24356:SF330', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C', 243070),
(336069, 'PTHR24356:SF374', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243070),
(336070, 'PTHR24356:SF176', NULL, NULL, NULL, NULL, 'RAC-BETA SERINE/THREONINE-PROTEIN KINASE', 243070),
(336071, 'PTHR24356:SF418', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE WARTS', 243070),
(336072, 'PTHR24356:SF419', NULL, NULL, NULL, NULL, 'AGC KINASE', 243070),
(336073, 'PTHR24356:SF416', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 243070),
(336074, 'PTHR24356:SF417', NULL, NULL, NULL, NULL, 'CELL CYCLE PROTEIN KINASE DBF2-RELATED', 243070),
(336075, 'PTHR24356:SF322', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE N2', 243070),
(336076, 'PTHR24356:SF246', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE N1', 243070),
(336077, 'PTHR24356:SF400', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE CBK1', 243070),
(336078, 'PTHR24356:SF365', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C DELTA TYPE', 243070),
(336079, 'PTHR24356:SF402', NULL, NULL, NULL, NULL, '', 243070),
(336080, 'PTHR24356:SF369', NULL, NULL, NULL, NULL, 'AGC (CAMP-DEPENDENT, CGMP-DEPENDENT AND PROTEIN KINASE C) KINASE FAMILY PROTEIN', 243070),
(336081, 'PTHR24356:SF160', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 38-LIKE', 243070);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(336082, 'PTHR24356:SF121', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SGK3', 243070),
(336083, 'PTHR24356:SF162', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C GAMMA TYPE', 243070),
(336084, 'PTHR24356:SF163', NULL, NULL, NULL, NULL, '3-PHOSPHOINOSITIDE-DEPENDENT PROTEIN KINASE 1-RELATED', 243070),
(336085, 'PTHR24356:SF361', NULL, NULL, NULL, NULL, 'BNAA01G23180D PROTEIN', 243070),
(336086, 'PTHR24356:SF240', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C', 243070),
(336087, 'PTHR24356:SF407', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SGK-1', 243070),
(336088, 'PTHR24356:SF408', NULL, NULL, NULL, NULL, 'OS01G0186700 PROTEIN', 243070),
(336089, 'PTHR24356:SF405', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PKH3', 243070),
(336090, 'PTHR24356:SF406', NULL, NULL, NULL, NULL, '3-PHOSPHOINOSITIDE-DEPENDENT PROTEIN KINASE 1', 243070),
(336091, 'PTHR24356:SF409', NULL, NULL, NULL, NULL, 'PROTEIN KINASE FAMILY PROTEIN', 243070),
(336092, 'PTHR36900', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT M, CHLOROPLASTIC', 243071),
(336093, 'PTHR36900:SF1', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT M, CHLOROPLASTIC', 243071),
(336094, 'PTHR37387:SF1', NULL, NULL, NULL, NULL, 'PROTEIN SAMBA', 243072),
(336095, 'PTHR37387', NULL, NULL, NULL, NULL, 'PROTEIN SAMBA', 243072),
(336096, 'PTHR45197:SF1', NULL, NULL, NULL, NULL, 'SYNTHASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G04190)-RELATED', 243073),
(336097, 'PTHR45197', NULL, NULL, NULL, NULL, 'SYNTHASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G04190)-RELATED', 243073),
(336098, 'PTHR47158:SF4', NULL, NULL, NULL, NULL, '', 243074),
(336099, 'PTHR47158:SF5', NULL, NULL, NULL, NULL, 'BNAC07G31090D PROTEIN', 243074),
(336100, 'PTHR47158:SF2', NULL, NULL, NULL, NULL, 'BNAA03G01640D PROTEIN', 243074),
(336101, 'PTHR47158:SF3', NULL, NULL, NULL, NULL, 'COMPLEX 1 LYR PROTEIN-RELATED', 243074),
(336102, 'PTHR47158:SF1', NULL, NULL, NULL, NULL, 'OS08G0239000 PROTEIN', 243074),
(336103, 'PTHR47158', NULL, NULL, NULL, NULL, 'OS08G0239000 PROTEIN', 243074),
(336104, 'PTHR46617', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN G1', 243075),
(336105, 'PTHR46617:SF3', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN G1', 243075),
(336106, 'PTHR46617:SF1', NULL, NULL, NULL, NULL, 'FORKHEAD BOX G1B-RELATED', 243075),
(336107, 'PTHR46617:SF6', NULL, NULL, NULL, NULL, 'FORKHEAD BOX G1C', 243075),
(336108, 'PTHR46617:SF5', NULL, NULL, NULL, NULL, 'FORKHEAD BOX G1', 243075),
(336109, 'PTHR47414', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP20-2, CHLOROPLASTIC', 243076),
(336110, 'PTHR47414:SF1', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP20-2, CHLOROPLASTIC', 243076),
(336111, 'PTHR38973:SF1', NULL, NULL, NULL, NULL, 'PLASMID PARTITION PROTEIN B', 243077),
(336112, 'PTHR38973:SF2', NULL, NULL, NULL, NULL, 'PARB DOMAIN-CONTAINING PROTEIN', 243077),
(336113, 'PTHR38973', NULL, NULL, NULL, NULL, 'PLASMID PARTITIONING CONTROL PROTEIN-RELATED', 243077),
(336114, 'PTHR43655:SF22', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT ZINC METALLOPROTEASE FTSH 10, MITOCHONDRIAL-LIKE', 243078),
(336115, 'PTHR43655:SF33', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 243078),
(336116, 'PTHR43655:SF11', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 243078),
(336117, 'PTHR43655', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT PROTEASE', 243078),
(336118, 'PTHR43655:SF35', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT ZINC METALLOPROTEASE FTSH 3, MITOCHONDRIAL', 243078),
(336119, 'PTHR43655:SF36', NULL, NULL, NULL, NULL, 'ZINC METALLOPEPTIDASE, PUTATIVE-RELATED', 243078),
(336120, 'PTHR43655:SF25', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT ZINC METALLOPROTEASE FTSH 3, MITOCHONDRIAL', 243078),
(336121, 'PTHR43655:SF14', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RESPIRATORY CHAIN COMPLEXES ASSEMBLY PROTEIN YTA12', 243078),
(336122, 'PTHR43655:SF30', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 243078),
(336123, 'PTHR43655:SF21', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT ZINC METALLOPROTEASE FTSH 8, MITOCHONDRIAL-LIKE', 243078);
INSERT INTO "PUBLIC"."MODEL" VALUES
(336124, 'PTHR43655:SF19', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT ZINC METALLOPROTEASE FTSH 12, CHLOROPLASTIC', 243078),
(336125, 'PTHR43655:SF9', NULL, NULL, NULL, NULL, 'AFG3-LIKE PROTEIN 2', 243078),
(336126, 'PTHR43655:SF8', NULL, NULL, NULL, NULL, 'PARAPLEGIN', 243078),
(336127, 'PTHR43655:SF26', NULL, NULL, NULL, NULL, 'METALLOPEPTIDASE, PUTATIVE-RELATED', 243078),
(336128, 'PTHR43655:SF7', NULL, NULL, NULL, NULL, 'AFG3-LIKE PROTEIN 1', 243078),
(336129, 'PTHR43655:SF37', NULL, NULL, NULL, NULL, 'AFG3-LIKE PROTEIN 2-RELATED', 243078),
(336130, 'PTHR43655:SF29', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 243078),
(336131, 'PTHR43655:SF2', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT ZINC METALLOPROTEASE YME1L-RELATED', 243078),
(336132, 'PTHR43655:SF1', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT ZINC METALLOPEPTIDASE, PUTATIVE-RELATED', 243078),
(336133, 'PTHR14198:SF22', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 4 L6 FAMILY MEMBER 19', 243079),
(336134, 'PTHR14198', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 4 L6 FAMILY MEMBER 1-RELATED', 243079),
(336135, 'PTHR14198:SF23', NULL, NULL, NULL, NULL, 'SI:CH211-137I24.10', 243079),
(336136, 'PTHR14198:SF20', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 4 L6 FAMILY MEMBER 1-LIKE', 243079),
(336137, 'PTHR14198:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 4 L6 FAMILY MEMBER 5', 243079),
(336138, 'PTHR14198:SF17', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 4 L6 FAMILY MEMBER 20', 243079),
(336139, 'PTHR14198:SF18', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 4 L6 FAMILY MEMBER 1', 243079),
(336140, 'PTHR14198:SF15', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 4 L6 FAMILY MEMBER 4', 243079),
(336141, 'PTHR14198:SF14', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 4 L6 FAMILY MEMBER 18', 243079),
(336142, 'PTHR35037:SF3', NULL, NULL, NULL, NULL, 'C-TERMINAL REGION OF AIDA-LIKE PROTEIN', 243080),
(336143, 'PTHR35037:SF2', NULL, NULL, NULL, NULL, '', 243080),
(336144, 'PTHR35037:SF7', NULL, NULL, NULL, NULL, 'EXPORTED PROTEIN-RELATED', 243080),
(336145, 'PTHR35037', NULL, NULL, NULL, NULL, 'C-TERMINAL REGION OF AIDA-LIKE PROTEIN', 243080),
(336146, 'PTHR28652', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 59-LIKE PROTEIN', 243081),
(336147, 'PTHR28652:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 59-LIKE', 243081),
(336148, 'PTHR28652:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 59', 243081),
(336149, 'PTHR28652:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 59-LIKE PROTEIN', 243081),
(336150, 'PTHR47790:SF2', NULL, NULL, NULL, NULL, 'TRNA/TMRNA (URACIL-C(5))-METHYLTRANSFERASE', 243082),
(336151, 'PTHR47790', NULL, NULL, NULL, NULL, 'TRNA/TMRNA (URACIL-C(5))-METHYLTRANSFERASE', 243082),
(336152, 'PTHR46866', NULL, NULL, NULL, NULL, 'GH12955P', 243083),
(336153, 'PTHR46866:SF1', NULL, NULL, NULL, NULL, 'GH12955P', 243083),
(336154, 'PTHR47778:SF5', NULL, NULL, NULL, NULL, 'GLYCOS_TRANSF_1 DOMAIN-CONTAINING PROTEIN', 243084),
(336155, 'PTHR47778:SF2', NULL, NULL, NULL, NULL, 'GLYCOS_TRANSF_1 DOMAIN-CONTAINING PROTEIN', 243084),
(336156, 'PTHR47778', NULL, NULL, NULL, NULL, 'BNAA05G14870D PROTEIN', 243084),
(336157, 'PTHR14513:SF4', NULL, NULL, NULL, NULL, 'PROTECTION OF TELOMERES PROTEIN 1', 243085),
(336158, 'PTHR14513:SF6', NULL, NULL, NULL, NULL, 'PROTECTION OF TELOMERES PROTEIN 1B', 243085),
(336159, 'PTHR14513:SF0', NULL, NULL, NULL, NULL, 'PROTECTION OF TELOMERES PROTEIN 1', 243085),
(336160, 'PTHR14513:SF2', NULL, NULL, NULL, NULL, 'PROTECTION OF TELOMERES PROTEIN 1', 243085),
(336161, 'PTHR14513:SF1', NULL, NULL, NULL, NULL, 'PROTECTION OF TELOMERES PROTEIN 1', 243085),
(336162, 'PTHR14513', NULL, NULL, NULL, NULL, 'PROTECTION OF TELOMERES 1', 243085),
(336163, 'PTHR21662:SF19', NULL, NULL, NULL, NULL, 'INSULIN/EGF-RECEPTOR L DOMAIN PROTEIN', 243086),
(336164, 'PTHR21662', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243086),
(336165, 'PTHR21662:SF6', NULL, NULL, NULL, NULL, 'INSULIN/EGF-RECEPTOR L DOMAIN PROTEIN', 243086),
(336166, 'PTHR21662:SF7', NULL, NULL, NULL, NULL, 'INSULIN/EGF-RECEPTOR L DOMAIN PROTEIN', 243086),
(336167, 'PTHR21662:SF60', NULL, NULL, NULL, NULL, 'INSULIN/EGF-RECEPTOR L DOMAIN PROTEIN', 243086); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(336168, 'PTHR21662:SF5', NULL, NULL, NULL, NULL, 'RECEP_L_DOMAIN DOMAIN-CONTAINING PROTEIN', 243086),
(336169, 'PTHR21662:SF3', NULL, NULL, NULL, NULL, 'INSULIN/EGF-RECEPTOR L DOMAIN PROTEIN-RELATED', 243086),
(336170, 'PTHR21662:SF20', NULL, NULL, NULL, NULL, 'RECEP_L_DOMAIN DOMAIN-CONTAINING PROTEIN', 243086),
(336171, 'PTHR21662:SF53', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN-TYROSINE KINASE', 243086),
(336172, 'PTHR21662:SF54', NULL, NULL, NULL, NULL, 'INSULIN/EGF-RECEPTOR L DOMAIN PROTEIN', 243086),
(336173, 'PTHR21662:SF33', NULL, NULL, NULL, NULL, 'RECEP_L_DOMAIN DOMAIN-CONTAINING PROTEIN', 243086),
(336174, 'PTHR21662:SF55', NULL, NULL, NULL, NULL, 'RECEP_L_DOMAIN DOMAIN-CONTAINING PROTEIN', 243086),
(336175, 'PTHR21662:SF23', NULL, NULL, NULL, NULL, 'INSULIN/EGF-RECEPTOR L DOMAIN PROTEIN', 243086),
(336176, 'PTHR21662:SF57', NULL, NULL, NULL, NULL, 'HIGH PERFORMANCE IN ADVANCED AGE-RELATED', 243086),
(336177, 'PTHR21662:SF14', NULL, NULL, NULL, NULL, 'INSULIN/EGF-RECEPTOR L DOMAIN PROTEIN', 243086),
(336178, 'PTHR21662:SF58', NULL, NULL, NULL, NULL, 'RECEP_L_DOMAIN DOMAIN-CONTAINING PROTEIN', 243086),
(336179, 'PTHR21662:SF26', NULL, NULL, NULL, NULL, 'INSULIN/EGF-RECEPTOR L DOMAIN PROTEIN', 243086),
(336180, 'PTHR21662:SF59', NULL, NULL, NULL, NULL, 'INSULIN/EGF-RECEPTOR L DOMAIN PROTEIN-RELATED', 243086),
(336181, 'PTHR21662:SF28', NULL, NULL, NULL, NULL, 'PROTEIN IRLD-34', 243086),
(336182, 'PTHR21662:SF18', NULL, NULL, NULL, NULL, 'INSULIN/EGF-RECEPTOR L DOMAIN PROTEIN', 243086),
(336183, 'PTHR21662:SF29', NULL, NULL, NULL, NULL, 'RECEP_L_DOMAIN DOMAIN-CONTAINING PROTEIN', 243086),
(336184, 'PTHR47053:SF3', NULL, NULL, NULL, NULL, 'GAMMA-D-GLUTAMYL-L-LYSINE DIPEPTIDYL-PEPTIDASE', 243087),
(336185, 'PTHR47053:SF1', NULL, NULL, NULL, NULL, 'MUREIN DD-ENDOPEPTIDASE MEPH-RELATED', 243087),
(336186, 'PTHR47053', NULL, NULL, NULL, NULL, 'MUREIN DD-ENDOPEPTIDASE MEPH-RELATED', 243087),
(336187, 'PTHR11081:SF49', NULL, NULL, NULL, NULL, 'FLAP ENDONUCLEASE 1 HOMOLOG-RELATED', 243088),
(336188, 'PTHR11081:SF59', NULL, NULL, NULL, NULL, 'FLAP ENDONUCLEASE GEN HOMOLOG 1', 243088),
(336189, 'PTHR11081:SF58', NULL, NULL, NULL, NULL, 'FLAP ENDONUCLEASE 1', 243088),
(336190, 'PTHR11081:SF69', NULL, NULL, NULL, NULL, 'XP-G FAMILY NUCLEASE', 243088),
(336191, 'PTHR11081:SF46', NULL, NULL, NULL, NULL, 'POST-TRANSCRIPTIONAL REGULATOR MKT1', 243088),
(336192, 'PTHR11081:SF68', NULL, NULL, NULL, NULL, 'XPG I-REGION FAMILY PROTEIN', 243088),
(336193, 'PTHR11081:SF67', NULL, NULL, NULL, NULL, 'EXONUCLEASE 1', 243088),
(336194, 'PTHR11081:SF56', NULL, NULL, NULL, NULL, 'FLAP ENDONUCLEASE 1-B', 243088),
(336195, 'PTHR11081:SF55', NULL, NULL, NULL, NULL, 'FLAP ENDONUCLEASE 1', 243088),
(336196, 'PTHR11081:SF66', NULL, NULL, NULL, NULL, 'XPGI DOMAIN-CONTAINING PROTEIN', 243088),
(336197, 'PTHR11081:SF65', NULL, NULL, NULL, NULL, 'EXONUCLEASE 1', 243088),
(336198, 'PTHR11081:SF54', NULL, NULL, NULL, NULL, 'SINGLE-STRAND DNA ENDONUCLEASE 1', 243088),
(336199, 'PTHR11081:SF32', NULL, NULL, NULL, NULL, 'POST-TRANSCRIPTIONAL REGULATOR MKT1', 243088),
(336200, 'PTHR11081', NULL, NULL, NULL, NULL, 'FLAP ENDONUCLEASE FAMILY MEMBER', 243088),
(336201, 'PTHR11081:SF64', NULL, NULL, NULL, NULL, 'GEN1 HOLLIDAY JUNCTION RESOLVASE HOMOLOG', 243088),
(336202, 'PTHR11081:SF1', NULL, NULL, NULL, NULL, 'FI23547P1', 243088),
(336203, 'PTHR11081:SF28', NULL, NULL, NULL, NULL, 'POST-TRANSCRIPTIONAL REGULATOR MKT1L', 243088),
(336204, 'PTHR11081:SF8', NULL, NULL, NULL, NULL, 'EXONUCLEASE 1', 243088),
(336205, 'PTHR11081:SF9', NULL, NULL, NULL, NULL, 'FLAP ENDONUCLEASE 1', 243088),
(336206, 'PTHR11081:SF62', NULL, NULL, NULL, NULL, 'XPGI DOMAIN-CONTAINING PROTEIN', 243088),
(336207, 'PTHR11081:SF51', NULL, NULL, NULL, NULL, 'FLAP ENDONUCLEASE 1', 243088),
(336208, 'PTHR10106:SF18', NULL, NULL, NULL, NULL, 'CYTOCHROME B561', 243089),
(336209, 'PTHR10106:SF38', NULL, NULL, NULL, NULL, 'LYSOSOMAL MEMBRANE ASCORBATE-DEPENDENT FERRIREDUCTASE CYB561A3', 243089),
(336210, 'PTHR10106:SF49', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 DOMAIN-CONTAINING PROTEIN', 243089);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(336211, 'PTHR10106:SF17', NULL, NULL, NULL, NULL, 'ASCORBATE-SPECIFIC TRANSMEMBRANE ELECTRON TRANSPORTER 2-RELATED', 243089),
(336212, 'PTHR10106:SF10', NULL, NULL, NULL, NULL, 'OS08G0101700 PROTEIN', 243089),
(336213, 'PTHR10106:SF43', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 FAMILY PROTEIN, EXPRESSED', 243089),
(336214, 'PTHR10106:SF22', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE ASCORBATE FERRIREDUCTASE 1', 243089),
(336215, 'PTHR10106:SF44', NULL, NULL, NULL, NULL, 'CYTOCHROME B561/FERRIC REDUCTASE TRANSMEMBRANE-RELATED', 243089),
(336216, 'PTHR10106:SF41', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE ASCORBATE FERRIREDUCTASE 4-RELATED', 243089),
(336217, 'PTHR10106:SF42', NULL, NULL, NULL, NULL, 'OS10G0118350 PROTEIN', 243089),
(336218, 'PTHR10106:SF47', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 DOMAIN-CONTAINING PROTEIN', 243089),
(336219, 'PTHR10106:SF14', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE ASCORBATE-DEPENDENT REDUCTASE CYB561', 243089),
(336220, 'PTHR10106:SF15', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE ASCORBATE FERRIREDUCTASE 3-RELATED', 243089),
(336221, 'PTHR10106:SF48', NULL, NULL, NULL, NULL, 'CYTOCHROME B561/FERRIC REDUCTASE TRANSMEMBRANE-RELATED', 243089),
(336222, 'PTHR10106:SF12', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE ASCORBATE-DEPENDENT REDUCTASE CYBRD1', 243089),
(336223, 'PTHR10106:SF46', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 DOMAIN-CONTAINING PROTEIN', 243089),
(336224, 'PTHR10106:SF24', NULL, NULL, NULL, NULL, 'NO EXTENDED MEMORY, ISOFORM A', 243089),
(336225, 'PTHR10106:SF50', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 DOMAIN-CONTAINING PROTEIN', 243089),
(336226, 'PTHR10106', NULL, NULL, NULL, NULL, 'CYTOCHROME B561-RELATED', 243089),
(336227, 'PTHR10106:SF0', NULL, NULL, NULL, NULL, 'LD36721P', 243089),
(336228, 'PTHR47886:SF1', NULL, NULL, NULL, NULL, 'CYSTATIN-11', 243090),
(336229, 'PTHR47886', NULL, NULL, NULL, NULL, 'CYSTATIN-11', 243090),
(336230, 'PTHR14292', NULL, NULL, NULL, NULL, 'INTERLEUKIN-18-BINDING PROTEIN', 243091),
(336231, 'PTHR14292:SF2', NULL, NULL, NULL, NULL, 'INTERLEUKIN-18-BINDING PROTEIN', 243091),
(336232, 'PTHR47614', NULL, NULL, NULL, NULL, 'GLYCOPHORIN-C', 243092),
(336233, 'PTHR47614:SF4', NULL, NULL, NULL, NULL, '4.1M DOMAIN-CONTAINING PROTEIN', 243092),
(336234, 'PTHR47614:SF2', NULL, NULL, NULL, NULL, 'GLYCOPHORIN-C', 243092),
(336235, 'PTHR15088', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR RIP140', 243093),
(336236, 'PTHR15088:SF0', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR-INTERACTING PROTEIN 1', 243093),
(336237, 'PTHR38046', NULL, NULL, NULL, NULL, 'CRYPTIC LOCI REGULATOR 2', 243094),
(336238, 'PTHR38046:SF1', NULL, NULL, NULL, NULL, 'CRYPTIC LOCI REGULATOR 2', 243094),
(336239, 'PTHR38002', NULL, NULL, NULL, NULL, 'C4ORF36 ISOFORM 11', 243095),
(336240, 'PTHR38002:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 4 C4ORF36 HOMOLOG', 243095),
(336241, 'PTHR31676:SF190', NULL, NULL, NULL, NULL, 'BNAC02G08860D PROTEIN', 243096),
(336242, 'PTHR31676:SF152', NULL, NULL, NULL, NULL, '', 243096),
(336243, 'PTHR31676:SF153', NULL, NULL, NULL, NULL, '', 243096),
(336244, 'PTHR31676:SF150', NULL, NULL, NULL, NULL, 'BNAA03G46470D PROTEIN', 243096),
(336245, 'PTHR31676:SF151', NULL, NULL, NULL, NULL, 'DUF538 FAMILY PROTEIN', 243096),
(336246, 'PTHR31676:SF156', NULL, NULL, NULL, NULL, 'F22D16.19 PROTEIN', 243096),
(336247, 'PTHR31676:SF83', NULL, NULL, NULL, NULL, '', 243096),
(336248, 'PTHR31676:SF112', NULL, NULL, NULL, NULL, '', 243096),
(336249, 'PTHR31676:SF82', NULL, NULL, NULL, NULL, 'BNAC05G43680D PROTEIN', 243096),
(336250, 'PTHR31676:SF110', NULL, NULL, NULL, NULL, 'OS01G0913100 PROTEIN', 243096),
(336251, 'PTHR31676:SF155', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243096),
(336252, 'PTHR31676:SF76', NULL, NULL, NULL, NULL, 'OS05G0362300 PROTEIN', 243096),
(336253, 'PTHR31676:SF117', NULL, NULL, NULL, NULL, '', 243096),
(336254, 'PTHR31676:SF158', NULL, NULL, NULL, NULL, 'BNAC03G35290D PROTEIN', 243096),
(336255, 'PTHR31676:SF114', NULL, NULL, NULL, NULL, 'DUF538 FAMILY PROTEIN', 243096),
(336256, 'PTHR31676:SF74', NULL, NULL, NULL, NULL, 'DUF538 FAMILY PROTEIN', 243096);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(336257, 'PTHR31676:SF30', NULL, NULL, NULL, NULL, 'OS05G0421100 PROTEIN', 243096),
(336258, 'PTHR31676:SF73', NULL, NULL, NULL, NULL, 'SIMILARITY TO UNKNOWN PROTEIN', 243096),
(336259, 'PTHR31676:SF115', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 243096),
(336260, 'PTHR31676:SF159', NULL, NULL, NULL, NULL, 'BNAA06G33720D PROTEIN', 243096),
(336261, 'PTHR31676:SF118', NULL, NULL, NULL, NULL, '', 243096),
(336262, 'PTHR31676:SF78', NULL, NULL, NULL, NULL, 'BNAA09G17900D PROTEIN', 243096),
(336263, 'PTHR31676:SF77', NULL, NULL, NULL, NULL, 'BNAA03G00250D PROTEIN', 243096),
(336264, 'PTHR31676:SF119', NULL, NULL, NULL, NULL, '', 243096),
(336265, 'PTHR31676:SF7', NULL, NULL, NULL, NULL, 'OS01G0210600 PROTEIN', 243096),
(336266, 'PTHR31676:SF160', NULL, NULL, NULL, NULL, 'OS01G0652700 PROTEIN', 243096),
(336267, 'PTHR31676:SF161', NULL, NULL, NULL, NULL, '', 243096),
(336268, 'PTHR31676:SF162', NULL, NULL, NULL, NULL, '', 243096),
(336269, 'PTHR31676:SF123', NULL, NULL, NULL, NULL, 'BNAA04G21950D PROTEIN', 243096),
(336270, 'PTHR31676:SF71', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243096),
(336271, 'PTHR31676:SF124', NULL, NULL, NULL, NULL, '', 243096),
(336272, 'PTHR31676:SF20', NULL, NULL, NULL, NULL, 'T19F6.7 PROTEIN', 243096),
(336273, 'PTHR31676:SF64', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 243096),
(336274, 'PTHR31676:SF128', NULL, NULL, NULL, NULL, 'BNAANNG09680D PROTEIN', 243096),
(336275, 'PTHR31676:SF125', NULL, NULL, NULL, NULL, 'BNAC03G30980D PROTEIN', 243096),
(336276, 'PTHR31676:SF126', NULL, NULL, NULL, NULL, 'BNAA03G59570D PROTEIN', 243096),
(336277, 'PTHR31676:SF25', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243096),
(336278, 'PTHR31676:SF24', NULL, NULL, NULL, NULL, 'DUF538 FAMILY PROTEIN', 243096),
(336279, 'PTHR31676:SF129', NULL, NULL, NULL, NULL, '', 243096),
(336280, 'PTHR31676:SF29', NULL, NULL, NULL, NULL, 'OS11G0683600 PROTEIN', 243096),
(336281, 'PTHR31676:SF28', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 243096),
(336282, 'PTHR31676:SF27', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243096),
(336283, 'PTHR31676:SF0', NULL, NULL, NULL, NULL, 'CP PROTEIN', 243096),
(336284, 'PTHR31676:SF3', NULL, NULL, NULL, NULL, '', 243096),
(336285, 'PTHR31676:SF174', NULL, NULL, NULL, NULL, 'BNAA05G30170D PROTEIN', 243096),
(336286, 'PTHR31676:SF130', NULL, NULL, NULL, NULL, '', 243096),
(336287, 'PTHR31676:SF175', NULL, NULL, NULL, NULL, '', 243096),
(336288, 'PTHR31676:SF131', NULL, NULL, NULL, NULL, '', 243096),
(336289, 'PTHR31676:SF172', NULL, NULL, NULL, NULL, 'OS01G0595400 PROTEIN', 243096),
(336290, 'PTHR31676:SF173', NULL, NULL, NULL, NULL, '', 243096),
(336291, 'PTHR31676:SF134', NULL, NULL, NULL, NULL, '', 243096),
(336292, 'PTHR31676:SF178', NULL, NULL, NULL, NULL, '', 243096),
(336293, 'PTHR31676:SF179', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243096),
(336294, 'PTHR31676:SF135', NULL, NULL, NULL, NULL, 'PLANT/F25P12-18 PROTEIN', 243096),
(336295, 'PTHR31676:SF176', NULL, NULL, NULL, NULL, 'OS07G0120600-LIKE PROTEIN', 243096),
(336296, 'PTHR31676:SF132', NULL, NULL, NULL, NULL, '', 243096),
(336297, 'PTHR31676:SF133', NULL, NULL, NULL, NULL, '', 243096),
(336298, 'PTHR31676:SF177', NULL, NULL, NULL, NULL, 'OS07G0120600-LIKE PROTEIN', 243096),
(336299, 'PTHR31676:SF10', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243096),
(336300, 'PTHR31676:SF96', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243096),
(336301, 'PTHR31676:SF136', NULL, NULL, NULL, NULL, '', 243096),
(336302, 'PTHR31676:SF137', NULL, NULL, NULL, NULL, 'BNAA09G03030D PROTEIN', 243096),
(336303, 'PTHR31676:SF14', NULL, NULL, NULL, NULL, 'OS03G0393600 PROTEIN', 243096),
(336304, 'PTHR31676:SF18', NULL, NULL, NULL, NULL, 'OS04G0443200 PROTEIN', 243096),
(336305, 'PTHR31676:SF16', NULL, NULL, NULL, NULL, 'OS01G0565800 PROTEIN', 243096),
(336306, 'PTHR31676:SF181', NULL, NULL, NULL, NULL, 'DUF538 FAMILY PROTEIN', 243096),
(336307, 'PTHR31676:SF182', NULL, NULL, NULL, NULL, '', 243096),
(336308, 'PTHR31676:SF180', NULL, NULL, NULL, NULL, 'T31J12.3 PROTEIN', 243096);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(336309, 'PTHR31676:SF185', NULL, NULL, NULL, NULL, '', 243096),
(336310, 'PTHR31676:SF186', NULL, NULL, NULL, NULL, 'DUF538 FAMILY PROTEIN', 243096),
(336311, 'PTHR31676:SF183', NULL, NULL, NULL, NULL, '', 243096),
(336312, 'PTHR31676:SF184', NULL, NULL, NULL, NULL, 'T14P8.17', 243096),
(336313, 'PTHR31676:SF145', NULL, NULL, NULL, NULL, 'BNAA08G26490D PROTEIN', 243096),
(336314, 'PTHR31676:SF189', NULL, NULL, NULL, NULL, '', 243096),
(336315, 'PTHR31676:SF146', NULL, NULL, NULL, NULL, '', 243096),
(336316, 'PTHR31676:SF143', NULL, NULL, NULL, NULL, 'BNAA10G27660D PROTEIN', 243096),
(336317, 'PTHR31676:SF92', NULL, NULL, NULL, NULL, '', 243096),
(336318, 'PTHR31676:SF187', NULL, NULL, NULL, NULL, '', 243096),
(336319, 'PTHR31676:SF188', NULL, NULL, NULL, NULL, '', 243096),
(336320, 'PTHR31676:SF105', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 243096),
(336321, 'PTHR31676:SF87', NULL, NULL, NULL, NULL, 'OS07G0120600-LIKE PROTEIN', 243096),
(336322, 'PTHR31676', NULL, NULL, NULL, NULL, 'T31J12.3 PROTEIN-RELATED', 243096),
(336323, 'PTHR31676:SF86', NULL, NULL, NULL, NULL, 'BNAA02G36500D PROTEIN', 243096),
(336324, 'PTHR31676:SF147', NULL, NULL, NULL, NULL, 'BNAA06G36100D PROTEIN', 243096),
(336325, 'PTHR31676:SF85', NULL, NULL, NULL, NULL, 'DUF538 FAMILY PROTEIN', 243096),
(336326, 'PTHR31676:SF148', NULL, NULL, NULL, NULL, 'BNAA02G24380D PROTEIN', 243096),
(336327, 'PTHR31676:SF84', NULL, NULL, NULL, NULL, '', 243096),
(336328, 'PTHR31676:SF109', NULL, NULL, NULL, NULL, 'OS05G0346400 PROTEIN', 243096),
(336329, 'PTHR31676:SF89', NULL, NULL, NULL, NULL, 'OS07G0120650 PROTEIN', 243096),
(336330, 'PTHR31676:SF108', NULL, NULL, NULL, NULL, '', 243096),
(336331, 'PTHR22894:SF10', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF170', 243097),
(336332, 'PTHR22894:SF8', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 243097),
(336333, 'PTHR22894:SF9', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 243097),
(336334, 'PTHR22894:SF6', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING PROTEIN', 243097),
(336335, 'PTHR22894:SF4', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 243097),
(336336, 'PTHR22894:SF5', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF170', 243097),
(336337, 'PTHR22894:SF2', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 243097),
(336338, 'PTHR22894', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243097),
(336339, 'PTHR22894:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF170', 243097),
(336340, 'PTHR46467', NULL, NULL, NULL, NULL, 'TETHER CONTAINING UBX DOMAIN FOR GLUT4', 243098),
(336341, 'PTHR46467:SF1', NULL, NULL, NULL, NULL, 'TETHER CONTAINING UBX DOMAIN FOR GLUT4', 243098),
(336342, 'PTHR12758:SF23', NULL, NULL, NULL, NULL, 'APOPTOSIS INHIBITOR 5', 243099),
(336343, 'PTHR12758:SF22', NULL, NULL, NULL, NULL, '', 243099),
(336344, 'PTHR12758:SF21', NULL, NULL, NULL, NULL, '', 243099),
(336345, 'PTHR12758:SF20', NULL, NULL, NULL, NULL, 'APOPTOSIS INHIBITOR 5-LIKE ISOFORM X1', 243099),
(336346, 'PTHR12758', NULL, NULL, NULL, NULL, 'APOPTOSIS INHIBITOR 5-RELATED', 243099),
(336347, 'PTHR12758:SF24', NULL, NULL, NULL, NULL, 'BNAA05G09720D PROTEIN', 243099),
(336348, 'PTHR12758:SF19', NULL, NULL, NULL, NULL, 'APOPTOSIS INHIBITOR 5', 243099),
(336349, 'PTHR45993:SF4', NULL, NULL, NULL, NULL, 'B-CELL LYMPHOMA/LEUKEMIA 11B', 243100),
(336350, 'PTHR45993:SF3', NULL, NULL, NULL, NULL, 'BAF CHROMATIN-REMODELING COMPLEX SUBUNIT BCL11A B', 243100),
(336351, 'PTHR45993:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 296', 243100),
(336352, 'PTHR45993:SF8', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 296', 243100),
(336353, 'PTHR45993:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR KEN', 243100),
(336354, 'PTHR45993:SF6', NULL, NULL, NULL, NULL, 'MAMMALIAN BCL (B CELL LYMPHOMA) GENE HOMOLOGS', 243100),
(336355, 'PTHR45993:SF5', NULL, NULL, NULL, NULL, 'B-CELL LYMPHOMA/LEUKEMIA 11A', 243100),
(336356, 'PTHR45993:SF9', NULL, NULL, NULL, NULL, 'IM:7142702', 243100),
(336357, 'PTHR45993', NULL, NULL, NULL, NULL, 'B-CELL LYMPHOMA/LEUKEMIA 11', 243100);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(336358, 'PTHR30136:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 243101),
(336359, 'PTHR30136:SF7', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR XYNR-RELATED', 243101),
(336360, 'PTHR30136', NULL, NULL, NULL, NULL, 'HELIX-TURN-HELIX TRANSCRIPTIONAL REGULATOR, ICLR FAMILY', 243101),
(336361, 'PTHR30136:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR ICLR', 243101),
(336362, 'PTHR30136:SF33', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 243101),
(336363, 'PTHR30136:SF22', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR ICLR', 243101),
(336364, 'PTHR30136:SF23', NULL, NULL, NULL, NULL, 'DNA-BINDING TRANSCRIPTIONAL ACTIVATOR MHPR', 243101),
(336365, 'PTHR30136:SF34', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 243101),
(336366, 'PTHR30136:SF24', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REPRESSOR ALLR', 243101),
(336367, 'PTHR30136:SF35', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 243101),
(336368, 'PTHR30136:SF38', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', 243101),
(336369, 'PTHR30136:SF39', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 243101),
(336370, 'PTHR30136:SF19', NULL, NULL, NULL, NULL, 'DNA-BINDING TRANSCRIPTIONAL REPRESSOR YIAJ', 243101),
(336371, 'PTHR34549', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I REACTION CENTER SUBUNIT IV A, CHLOROPLASTIC-RELATED', 243102),
(336372, 'PTHR34549:SF3', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I PSAE, REACTION CENTRE SUBUNIT IV-RELATED', 243102),
(336373, 'PTHR34549:SF2', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I SUBUNIT IV', 243102),
(336374, 'PTHR34549:SF10', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I REACTION CENTER SUBUNIT IV A, CHLOROPLASTIC-RELATED', 243102),
(336375, 'PTHR34549:SF5', NULL, NULL, NULL, NULL, 'BNAA08G30780D PROTEIN', 243102),
(336376, 'PTHR34549:SF9', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I REACTION CENTER SUBUNIT IV A PROTEIN-RELATED', 243102),
(336377, 'PTHR34549:SF8', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I REACTION CENTER SUBUNIT IV B ISOFORM 2', 243102),
(336378, 'PTHR17314:SF0', NULL, NULL, NULL, NULL, 'REGULATED ENDOCRINE-SPECIFIC PROTEIN 18', 243103),
(336379, 'PTHR17314', NULL, NULL, NULL, NULL, 'REGULATED ENDOCRINE SPECIFIC PROTEIN 18', 243103),
(336380, 'PTHR32331:SF0', NULL, NULL, NULL, NULL, 'UPF0313 PROTEIN YGIQ', 243104),
(336381, 'PTHR32331', NULL, NULL, NULL, NULL, 'UPF0313 PROTEIN YGIQ', 243104),
(336382, 'PTHR23300:SF0', NULL, NULL, NULL, NULL, 'METHANETHIOL OXIDASE', 243105),
(336383, 'PTHR23300', NULL, NULL, NULL, NULL, 'METHANETHIOL OXIDASE', 243105),
(336384, 'PTHR23300:SF16', NULL, NULL, NULL, NULL, 'BNAA08G07560D PROTEIN', 243105),
(336385, 'PTHR23300:SF14', NULL, NULL, NULL, NULL, 'SELENIUM-BINDING PROTEIN 2', 243105),
(336386, 'PTHR23300:SF15', NULL, NULL, NULL, NULL, 'BNACNNG60210D PROTEIN', 243105),
(336387, 'PTHR23300:SF13', NULL, NULL, NULL, NULL, 'BNAA08G07570D PROTEIN', 243105),
(336388, 'PTHR23300:SF3', NULL, NULL, NULL, NULL, 'SELENIUM-BINDING PROTEIN-RELATED', 243105),
(336389, 'PTHR23300:SF10', NULL, NULL, NULL, NULL, 'BNAC04G29120D PROTEIN', 243105),
(336390, 'PTHR23300:SF11', NULL, NULL, NULL, NULL, 'SELENIUM-BINDING PROTEIN 1', 243105),
(336391, 'PTHR42345:SF1', NULL, NULL, NULL, NULL, '', 243106),
(336392, 'PTHR42345:SF2', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 243106),
(336393, 'PTHR42345', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 243106),
(336394, 'PTHR36982:SF1', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 18', 243107),
(336395, 'PTHR36982', NULL, NULL, NULL, NULL, 'CLCA DOMAIN-CONTAINING PROTEIN', 243107),
(336396, 'PTHR36982:SF4', NULL, NULL, NULL, NULL, 'CLCA DOMAIN-CONTAINING PROTEIN', 243107),
(336397, 'PTHR36982:SF3', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 22', 243107),
(336398, 'PTHR43191:SF14', NULL, NULL, NULL, NULL, 'SPOU_METHYLASE DOMAIN-CONTAINING PROTEIN', 243108),
(336399, 'PTHR43191:SF9', NULL, NULL, NULL, NULL, 'SPOU_METHYLASE DOMAIN-CONTAINING PROTEIN', 243108);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(336400, 'PTHR43191', NULL, NULL, NULL, NULL, 'RRNA METHYLTRANSFERASE 3,', 243108),
(336401, 'PTHR43191:SF10', NULL, NULL, NULL, NULL, 'SPOU_METHYLASE DOMAIN-CONTAINING PROTEIN', 243108),
(336402, 'PTHR43191:SF12', NULL, NULL, NULL, NULL, 'RRNA METHYLASE-RELATED', 243108),
(336403, 'PTHR43191:SF13', NULL, NULL, NULL, NULL, 'POSSIBLE 23S RRNA METHYLTRANSFERASE TSNR', 243108),
(336404, 'PTHR43191:SF2', NULL, NULL, NULL, NULL, 'RRNA METHYLTRANSFERASE 3, MITOCHONDRIAL', 243108),
(336405, 'PTHR43191:SF7', NULL, NULL, NULL, NULL, 'OBP33PEP LIKE PROTEIN', 243108),
(336406, 'PTHR38932:SF2', NULL, NULL, NULL, NULL, '', 243109),
(336407, 'PTHR38932:SF1', NULL, NULL, NULL, NULL, 'BNAC03G64660D PROTEIN', 243109),
(336408, 'PTHR38932', NULL, NULL, NULL, NULL, 'BNAC03G64660D PROTEIN', 243109),
(336409, 'PTHR11540:SF16', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE, MITOCHONDRIAL', 243110),
(336410, 'PTHR11540:SF48', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE-RELATED', 243110),
(336411, 'PTHR11540:SF69', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE', 243110),
(336412, 'PTHR11540:SF47', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE', 243110),
(336413, 'PTHR11540:SF58', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE 1, MITOCHONDRIAL-RELATED', 243110),
(336414, 'PTHR11540:SF68', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE', 243110),
(336415, 'PTHR11540:SF67', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE', 243110),
(336416, 'PTHR11540:SF66', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE', 243110),
(336417, 'PTHR11540:SF65', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE', 243110),
(336418, 'PTHR11540:SF54', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE', 243110),
(336419, 'PTHR11540:SF64', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE', 243110),
(336420, 'PTHR11540:SF52', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE 2, PEROXISOMAL', 243110),
(336421, 'PTHR11540:SF73', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE, MITOCHONDRIAL', 243110),
(336422, 'PTHR11540:SF62', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE', 243110),
(336423, 'PTHR11540:SF72', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE, PEROXISOMAL', 243110),
(336424, 'PTHR11540:SF61', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE', 243110),
(336425, 'PTHR11540:SF71', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE 1, PEROXISOMAL', 243110),
(336426, 'PTHR11540:SF60', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE', 243110),
(336427, 'PTHR11540:SF70', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE', 243110),
(336428, 'PTHR11540:SF18', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE', 243110),
(336429, 'PTHR11540', NULL, NULL, NULL, NULL, 'MALATE AND LACTATE DEHYDROGENASE', 243110),
(336430, 'PTHR44156:SF6', NULL, NULL, NULL, NULL, 'TNF RECEPTOR-ASSOCIATED FACTOR 7', 243111),
(336431, 'PTHR44156:SF5', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 55', 243111),
(336432, 'PTHR44156:SF2', NULL, NULL, NULL, NULL, 'F-BOX/WD REPEAT-CONTAINING PROTEIN 1A', 243111),
(336433, 'PTHR44156:SF1', NULL, NULL, NULL, NULL, 'DYNEIN ASSEMBLY FACTOR WITH WDR REPEAT DOMAINS 1', 243111),
(336434, 'PTHR44156', NULL, NULL, NULL, NULL, 'SUPERNUMERARY LIMBS, ISOFORM B-RELATED', 243111),
(336435, 'PTHR44156:SF21', NULL, NULL, NULL, NULL, 'PROTEASOMAL ATPASE-ASSOCIATED FACTOR 1', 243111),
(336436, 'PTHR44156:SF22', NULL, NULL, NULL, NULL, '', 243111),
(336437, 'PTHR44156:SF23', NULL, NULL, NULL, NULL, 'WD REPEAT PROTEIN (AFU_ORTHOLOGUE AFUA_5G08320)', 243111),
(336438, 'PTHR44156:SF24', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT BETA-LIKE PROTEIN', 243111),
(336439, 'PTHR44156:SF25', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SPT8', 243111),
(336440, 'PTHR44156:SF15', NULL, NULL, NULL, NULL, '', 243111),
(336441, 'PTHR44156:SF26', NULL, NULL, NULL, NULL, 'DENN/MADD DOMAIN-CONTAINING 3B-RELATED', 243111),
(336442, 'PTHR44156:SF16', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTIONAL COREPRESSOR TUP1', 243111),
(336443, 'PTHR44156:SF9', NULL, NULL, NULL, NULL, 'F-BOX AND WD REPEAT DOMAIN CONTAINING 11', 243111),
(336444, 'PTHR44156:SF20', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT BETA-LIKE PROTEIN', 243111); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(336445, 'PTHR47940:SF1', NULL, NULL, NULL, NULL, 'PROTEIN LOW PHOTOSYNTHETIC EFFICIENCY 1, CHLOROPLASTIC', 243112),
(336446, 'PTHR47940', NULL, NULL, NULL, NULL, 'OS12G0283900 PROTEIN', 243112),
(336447, 'PTHR47972:SF30', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 243113),
(336448, 'PTHR47972:SF52', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN-RELATED', 243113),
(336449, 'PTHR47972:SF51', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE-RELATED', 243113),
(336450, 'PTHR47972:SF50', NULL, NULL, NULL, NULL, 'KINESIN-4-LIKE', 243113),
(336451, 'PTHR47972:SF16', NULL, NULL, NULL, NULL, 'MYOSIN-RELATED PROTEIN', 243113),
(336452, 'PTHR47972:SF59', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-14P', 243113),
(336453, 'PTHR47972:SF37', NULL, NULL, NULL, NULL, 'BNAA09G11080D PROTEIN', 243113),
(336454, 'PTHR47972', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KLP-3', 243113),
(336455, 'PTHR47972:SF15', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-14D', 243113),
(336456, 'PTHR47972:SF14', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-14J', 243113),
(336457, 'PTHR47972:SF58', NULL, NULL, NULL, NULL, 'KINESIN-4-LIKE', 243113),
(336458, 'PTHR47972:SF57', NULL, NULL, NULL, NULL, 'P-LOOP NUCLEOSIDE TRIPHOSPHATE HYDROLASE SUPERFAMILY PROTEIN', 243113),
(336459, 'PTHR47972:SF35', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-14Q', 243113),
(336460, 'PTHR47972:SF13', NULL, NULL, NULL, NULL, 'HEAVY CHAIN, PUTATIVE-RELATED', 243113),
(336461, 'PTHR47972:SF56', NULL, NULL, NULL, NULL, 'HEAVY CHAIN, PUTATIVE-RELATED', 243113),
(336462, 'PTHR47972:SF12', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-14H', 243113),
(336463, 'PTHR47972:SF33', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-14O', 243113),
(336464, 'PTHR47972:SF11', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF3A', 243113),
(336465, 'PTHR47972:SF55', NULL, NULL, NULL, NULL, 'MINUS-END-DIRECTED KINESIN ATPASE-RELATED', 243113),
(336466, 'PTHR47972:SF32', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-14K', 243113),
(336467, 'PTHR47972:SF54', NULL, NULL, NULL, NULL, 'OS04G0467901 PROTEIN', 243113),
(336468, 'PTHR47972:SF53', NULL, NULL, NULL, NULL, 'KINESIN-4-LIKE', 243113),
(336469, 'PTHR47972:SF31', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-14Q', 243113),
(336470, 'PTHR47972:SF18', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-14R', 243113),
(336471, 'PTHR47972:SF39', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-14I', 243113),
(336472, 'PTHR47972:SF17', NULL, NULL, NULL, NULL, 'KINESIN MOTOR CATALYTIC DOMAIN PROTEIN', 243113),
(336473, 'PTHR47972:SF41', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-14P', 243113),
(336474, 'PTHR47972:SF60', NULL, NULL, NULL, NULL, 'P-LOOP NUCLEOSIDE TRIPHOSPHATE HYDROLASE SUPERFAMILY PROTEIN', 243113),
(336475, 'PTHR47972:SF49', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-14M', 243113),
(336476, 'PTHR47972:SF25', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-14R ISOFORM X1', 243113),
(336477, 'PTHR47972:SF47', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 243113),
(336478, 'PTHR47972:SF24', NULL, NULL, NULL, NULL, 'P-LOOP NUCLEOSIDE TRIPHOSPHATE HYDROLASE SUPERFAMILY PROTEIN', 243113),
(336479, 'PTHR47972:SF46', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 243113),
(336480, 'PTHR47972:SF45', NULL, NULL, NULL, NULL, 'PROTEIN CLARET SEGREGATIONAL', 243113),
(336481, 'PTHR47972:SF23', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 243113),
(336482, 'PTHR47972:SF44', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-14K', 243113),
(336483, 'PTHR47972:SF22', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-14A-RELATED', 243113),
(336484, 'PTHR47972:SF43', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 243113),
(336485, 'PTHR47972:SF42', NULL, NULL, NULL, NULL, 'CALPONIN-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 243113),
(336486, 'PTHR47972:SF29', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-14G', 243113),
(336487, 'PTHR47972:SF28', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KLP-3', 243113);
INSERT INTO "PUBLIC"."MODEL" VALUES
(336488, 'PTHR47972:SF6', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 243113),
(336489, 'PTHR47972:SF9', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 243113),
(336490, 'PTHR47972:SF2', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 243113),
(336491, 'PTHR47972:SF5', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIFC3', 243113),
(336492, 'PTHR47972:SF4', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-14L', 243113),
(336493, 'PTHR32193:SF3', NULL, NULL, NULL, NULL, 'REGULATOR OF CELL CYCLE RGCC', 243114),
(336494, 'PTHR32193', NULL, NULL, NULL, NULL, 'REGULATOR OF CELL CYCLE RGCC', 243114),
(336495, 'PTHR32193:SF5', NULL, NULL, NULL, NULL, 'SI:DKEY-27I16.2', 243114),
(336496, 'PTHR47181', NULL, NULL, NULL, NULL, 'BRCA1 C TERMINUS DOMAIN CONTAINING PROTEIN, EXPRESSED', 243115),
(336497, 'PTHR47181:SF2', NULL, NULL, NULL, NULL, 'BRCA1 C TERMINUS DOMAIN CONTAINING PROTEIN, EXPRESSED', 243115),
(336498, 'PTHR47181:SF3', NULL, NULL, NULL, NULL, '', 243115),
(336499, 'PTHR47181:SF6', NULL, NULL, NULL, NULL, 'BRCT DOMAIN-CONTAINING PROTEIN', 243115),
(336500, 'PTHR47181:SF4', NULL, NULL, NULL, NULL, 'BRCT DOMAIN-CONTAINING PROTEIN', 243115),
(336501, 'PTHR15556:SF5', NULL, NULL, NULL, NULL, 'EP300-INTERACTING INHIBITOR OF DIFFERENTIATION 1', 243116),
(336502, 'PTHR15556:SF3', NULL, NULL, NULL, NULL, 'EP300-INTERACTING INHIBITOR OF DIFFERENTIATION 2', 243116),
(336503, 'PTHR15556:SF4', NULL, NULL, NULL, NULL, 'EP300-INTERACTING INHIBITOR OF DIFFERENTIATION 2B', 243116),
(336504, 'PTHR15556', NULL, NULL, NULL, NULL, 'EP300-INTERACTING INHIBITOR OF DIFFERENTIATION 2-RELATED', 243116),
(336505, 'PTHR46652:SF3', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 9', 243117),
(336506, 'PTHR46652:SF6', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT AND COILED-COIL CENTROSOMAL PROTEIN 1', 243117),
(336507, 'PTHR46652:SF7', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND IQ DOMAIN-CONTAINING PROTEIN 1', 243117),
(336508, 'PTHR46652', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND IQ DOMAIN-CONTAINING PROTEIN 1-RELATED', 243117),
(336509, 'PTHR11715:SF29', NULL, NULL, NULL, NULL, 'GLYCINE CLEAVAGE SYSTEM H PROTEIN', 243118),
(336510, 'PTHR11715:SF39', NULL, NULL, NULL, NULL, 'GLYCINE CLEAVAGE SYSTEM H PROTEIN', 243118),
(336511, 'PTHR11715:SF28', NULL, NULL, NULL, NULL, 'GLYCINE CLEAVAGE SYSTEM H PROTEIN, MITOCHONDRIAL', 243118),
(336512, 'PTHR11715:SF27', NULL, NULL, NULL, NULL, 'GLYCINE CLEAVAGE SYSTEM H PROTEIN 1, MITOCHONDRIAL-RELATED', 243118),
(336513, 'PTHR11715:SF38', NULL, NULL, NULL, NULL, 'GLYCINE CLEAVAGE SYSTEM H PROTEIN', 243118),
(336514, 'PTHR11715:SF26', NULL, NULL, NULL, NULL, 'GLYCINE CLEAVAGE SYSTEM H PROTEIN', 243118),
(336515, 'PTHR11715:SF37', NULL, NULL, NULL, NULL, 'GLYCINE CLEAVAGE SYSTEM H PROTEIN', 243118),
(336516, 'PTHR11715:SF25', NULL, NULL, NULL, NULL, 'GLYCINE CLEAVAGE SYSTEM H PROTEIN', 243118),
(336517, 'PTHR11715:SF23', NULL, NULL, NULL, NULL, '', 243118),
(336518, 'PTHR11715', NULL, NULL, NULL, NULL, 'GLYCINE CLEAVAGE SYSTEM H PROTEIN', 243118),
(336519, 'PTHR11715:SF3', NULL, NULL, NULL, NULL, 'GLYCINE CLEAVAGE SYSTEM H PROTEIN, MITOCHONDRIAL', 243118),
(336520, 'PTHR11715:SF7', NULL, NULL, NULL, NULL, 'GLYCINE CLEAVAGE SYSTEM H-LIKE PROTEIN GCVH2', 243118),
(336521, 'PTHR11715:SF5', NULL, NULL, NULL, NULL, 'GLYCINE CLEAVAGE SYSTEM H PROTEIN', 243118),
(336522, 'PTHR11715:SF32', NULL, NULL, NULL, NULL, 'GLYCINE CLEAVAGE SYSTEM H PROTEIN', 243118),
(336523, 'PTHR11715:SF10', NULL, NULL, NULL, NULL, 'GLYCINE CLEAVAGE SYSTEM H PROTEIN', 243118),
(336524, 'PTHR11715:SF8', NULL, NULL, NULL, NULL, 'GLYCINE CLEAVAGE SYSTEM H-LIKE PROTEIN GCVH4', 243118),
(336525, 'PTHR14340', NULL, NULL, NULL, NULL, 'MICROFIBRIL-ASSOCIATED GLYCOPROTEIN 3', 243119),
(336526, 'PTHR14340:SF4', NULL, NULL, NULL, NULL, 'MICROFIBRIL-ASSOCIATED GLYCOPROTEIN 3', 243119),
(336527, 'PTHR14340:SF2', NULL, NULL, NULL, NULL, 'MICROFIBRILLAR-ASSOCIATED PROTEIN 3-LIKE', 243119),
(336528, 'PTHR14340:SF14', NULL, NULL, NULL, NULL, '', 243119),
(336529, 'PTHR14340:SF15', NULL, NULL, NULL, NULL, '', 243119);
INSERT INTO "PUBLIC"."MODEL" VALUES
(336530, 'PTHR14340:SF12', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243119),
(336531, 'PTHR14340:SF13', NULL, NULL, NULL, NULL, 'TITIN', 243119),
(336532, 'PTHR14340:SF18', NULL, NULL, NULL, NULL, '', 243119),
(336533, 'PTHR14340:SF19', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 243119),
(336534, 'PTHR14340:SF16', NULL, NULL, NULL, NULL, '', 243119),
(336535, 'PTHR14340:SF9', NULL, NULL, NULL, NULL, '', 243119),
(336536, 'PTHR14340:SF17', NULL, NULL, NULL, NULL, '', 243119),
(336537, 'PTHR14340:SF11', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 243119),
(336538, 'PTHR14340:SF20', NULL, NULL, NULL, NULL, '', 243119),
(336539, 'PTHR35722:SF1', NULL, NULL, NULL, NULL, 'MAL D 1-ASSOCIATED PROTEIN', 243120),
(336540, 'PTHR35722', NULL, NULL, NULL, NULL, 'MAL D 1-ASSOCIATED PROTEIN', 243120),
(336541, 'PTHR21578', NULL, NULL, NULL, NULL, 'PROTEIN CBG03826', 243121),
(336542, 'PTHR21578:SF9', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 243121),
(336543, 'PTHR21578:SF11', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 243121),
(336544, 'PTHR10598', NULL, NULL, NULL, NULL, 'SET1/ASH2 HISTONE METHYLTRANSFERASE COMPLEX SUBUNIT ASH2', 243122),
(336545, 'PTHR10598:SF0', NULL, NULL, NULL, NULL, 'SET1/ASH2 HISTONE METHYLTRANSFERASE COMPLEX SUBUNIT ASH2', 243122),
(336546, 'PTHR12976', NULL, NULL, NULL, NULL, 'RETINAL ROD RHODOPSIN-SENSITIVE CGMP 3'',5''-CYCLIC PHOSPHODIESTERASE DELTA-SUBUNIT', 243123),
(336547, 'PTHR12976:SF0', NULL, NULL, NULL, NULL, 'RETINAL ROD RHODOPSIN-SENSITIVE CGMP 3'',5''-CYCLIC PHOSPHODIESTERASE SUBUNIT DELTA', 243123),
(336548, 'PTHR11733:SF192', NULL, NULL, NULL, NULL, 'NEPRILYSIN-21', 243124),
(336549, 'PTHR11733:SF199', NULL, NULL, NULL, NULL, 'NEPRILYSIN-4', 243124),
(336550, 'PTHR11733:SF232', NULL, NULL, NULL, NULL, 'NEPRILYSIN METALLOPEPTIDASE FAMILY', 243124),
(336551, 'PTHR11733:SF133', NULL, NULL, NULL, NULL, 'PHOSPHATE-REGULATING NEUTRAL ENDOPEPTIDASE PHEX', 243124),
(336552, 'PTHR11733:SF231', NULL, NULL, NULL, NULL, 'LD31822P', 243124),
(336553, 'PTHR11733:SF234', NULL, NULL, NULL, NULL, 'PROTEIN CBG01942', 243124),
(336554, 'PTHR11733:SF211', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDASE LIPOPROTEIN M13 FAMILY', 243124),
(336555, 'PTHR11733:SF233', NULL, NULL, NULL, NULL, 'PEPTIDASE_M13 DOMAIN-CONTAINING PROTEIN', 243124),
(336556, 'PTHR11733:SF195', NULL, NULL, NULL, NULL, 'ENDOTHELIN-CONVERTING ENZYME-LIKE 1', 243124),
(336557, 'PTHR11733:SF230', NULL, NULL, NULL, NULL, 'NEPRILYSIN-2', 243124),
(336558, 'PTHR11733:SF130', NULL, NULL, NULL, NULL, 'ENDOTHELIN-CONVERTING ENZYME 1', 243124),
(336559, 'PTHR11733:SF196', NULL, NULL, NULL, NULL, 'NEPRILYSIN METALLOPEPTIDASE FAMILY', 243124),
(336560, 'PTHR11733', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEASE FAMILY M13 NEPRILYSIN-RELATED', 243124),
(336561, 'PTHR11733:SF236', NULL, NULL, NULL, NULL, 'PROTEIN CBG01943', 243124),
(336562, 'PTHR11733:SF214', NULL, NULL, NULL, NULL, 'NEPRILYSIN-1', 243124),
(336563, 'PTHR11733:SF114', NULL, NULL, NULL, NULL, 'NEPRILYSIN', 243124),
(336564, 'PTHR11733:SF235', NULL, NULL, NULL, NULL, 'ENDOTHELIN-CONVERTING ENZYME 2-LIKE PROTEIN', 243124),
(336565, 'PTHR11733:SF7', NULL, NULL, NULL, NULL, 'NEPRILYSIN METALLOPEPTIDASE FAMILY-RELATED', 243124),
(336566, 'PTHR11733:SF17', NULL, NULL, NULL, NULL, 'NEPRILYSIN METALLOPEPTIDASE FAMILY', 243124),
(336567, 'PTHR11733:SF221', NULL, NULL, NULL, NULL, 'NEPRILYSIN METALLOPEPTIDASE FAMILY', 243124),
(336568, 'PTHR11733:SF188', NULL, NULL, NULL, NULL, 'NEPRILYSIN METALLOPEPTIDASE FAMILY', 243124),
(336569, 'PTHR11733:SF167', NULL, NULL, NULL, NULL, 'FI07649P-RELATED', 243124),
(336570, 'PTHR11733:SF222', NULL, NULL, NULL, NULL, 'IP12942P', 243124),
(336571, 'PTHR11733:SF164', NULL, NULL, NULL, NULL, 'NEPRILYSIN METALLOPEPTIDASE FAMILY', 243124),
(336572, 'PTHR11733:SF186', NULL, NULL, NULL, NULL, 'NEPRILYSIN 5, ISOFORM D', 243124),
(336573, 'PTHR11733:SF185', NULL, NULL, NULL, NULL, 'NEPRILYSIN METALLOPEPTIDASE FAMILY', 243124),
(336574, 'PTHR11733:SF141', NULL, NULL, NULL, NULL, 'MEMBRANE METALLO-ENDOPEPTIDASE-LIKE 1', 243124);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(336575, 'PTHR11733:SF229', NULL, NULL, NULL, NULL, 'NEPRILYSIN-2-LIKE PROTEIN', 243124),
(336576, 'PTHR11733:SF206', NULL, NULL, NULL, NULL, 'PEPTIDASE_M13_N DOMAIN-CONTAINING PROTEIN', 243124),
(336577, 'PTHR11733:SF228', NULL, NULL, NULL, NULL, 'PROTEIN GONE EARLY', 243124),
(336578, 'PTHR11733:SF209', NULL, NULL, NULL, NULL, 'FI20018P1', 243124),
(336579, 'PTHR11733:SF208', NULL, NULL, NULL, NULL, 'PEPTIDASE_M13 DOMAIN-CONTAINING PROTEIN', 243124),
(336580, 'PTHR11733:SF224', NULL, NULL, NULL, NULL, 'NEPRILYSIN-2', 243124),
(336581, 'PTHR11733:SF227', NULL, NULL, NULL, NULL, 'NEPRILYSIN-LIKE 4', 243124),
(336582, 'PTHR11733:SF128', NULL, NULL, NULL, NULL, 'KELL BLOOD GROUP GLYCOPROTEIN', 243124),
(336583, 'PTHR11733:SF127', NULL, NULL, NULL, NULL, 'EEF1AKMT4-ECE2 READTHROUGH TRANSCRIPT PROTEIN-RELATED', 243124),
(336584, 'PTHR44924', NULL, NULL, NULL, NULL, 'DNAJ SUBFAMILY A MEMBER 2', 243125),
(336585, 'PTHR44924:SF1', NULL, NULL, NULL, NULL, 'DNAJ SUBFAMILY A MEMBER 2', 243125),
(336586, 'PTHR13000:SF1', NULL, NULL, NULL, NULL, '', 243126),
(336587, 'PTHR13000', NULL, NULL, NULL, NULL, 'NUCLEOPORIN P54', 243126),
(336588, 'PTHR13000:SF0', NULL, NULL, NULL, NULL, 'NUCLEOPORIN P54', 243126),
(336589, 'PTHR28128:SF3', NULL, NULL, NULL, NULL, 'ASSOCIATED PROTEIN, PUTATIVE-RELATED', 243127),
(336590, 'PTHR28128', NULL, NULL, NULL, NULL, 'GOLGI APPARATUS MEMBRANE PROTEIN TVP15', 243127),
(336591, 'PTHR28128:SF1', NULL, NULL, NULL, NULL, 'GOLGI APPARATUS MEMBRANE PROTEIN TVP15', 243127),
(336592, 'PTHR34056:SF1', NULL, NULL, NULL, NULL, 'GPI-ANCHORED PROTEIN', 243128),
(336593, 'PTHR34056:SF7', NULL, NULL, NULL, NULL, 'SPARK DOMAIN-CONTAINING PROTEIN', 243128),
(336594, 'PTHR34056', NULL, NULL, NULL, NULL, 'GPI-ANCHORED PROTEIN', 243128),
(336595, 'PTHR34056:SF8', NULL, NULL, NULL, NULL, 'SPARK DOMAIN-CONTAINING PROTEIN', 243128),
(336596, 'PTHR34056:SF9', NULL, NULL, NULL, NULL, 'SPARK DOMAIN-CONTAINING PROTEIN', 243128),
(336597, 'PTHR34056:SF3', NULL, NULL, NULL, NULL, 'OS07G0557700 PROTEIN', 243128),
(336598, 'PTHR34056:SF4', NULL, NULL, NULL, NULL, 'OS02G0710700 PROTEIN', 243128),
(336599, 'PTHR34056:SF5', NULL, NULL, NULL, NULL, 'SPARK DOMAIN-CONTAINING PROTEIN', 243128),
(336600, 'PTHR34056:SF6', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 243128),
(336601, 'PTHR31584:SF1', NULL, NULL, NULL, NULL, 'TUMOR PROTEIN P53-INDUCIBLE PROTEIN 11', 243129),
(336602, 'PTHR31584', NULL, NULL, NULL, NULL, 'TUMOR PROTEIN P53-INDUCIBLE PROTEIN 11', 243129),
(336603, 'PTHR31010:SF3', NULL, NULL, NULL, NULL, 'RANBD1 DOMAIN-CONTAINING PROTEIN C584.03C', 243130),
(336604, 'PTHR31010:SF2', NULL, NULL, NULL, NULL, 'RAN-SPECIFIC GTPASE-ACTIVATING PROTEIN 30', 243130),
(336605, 'PTHR31010', NULL, NULL, NULL, NULL, 'RAN-SPECIFIC GTPASE-ACTIVATING PROTEIN 30-RELATED', 243130),
(336606, 'PTHR13314:SF2', NULL, NULL, NULL, NULL, 'CALCIUM CHANNEL FLOWER HOMOLOG', 243131),
(336607, 'PTHR13314', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243131),
(336608, 'PTHR30290:SF9', NULL, NULL, NULL, NULL, 'D,D-DIPEPTIDE-BINDING PERIPLASMIC PROTEIN DDPA-RELATED', 243132),
(336609, 'PTHR30290', NULL, NULL, NULL, NULL, 'PERIPLASMIC BINDING COMPONENT OF ABC TRANSPORTER', 243132),
(336610, 'PTHR30290:SF79', NULL, NULL, NULL, NULL, 'DIPEPTIDE-BINDING PROTEIN DPPE', 243132),
(336611, 'PTHR30290:SF23', NULL, NULL, NULL, NULL, 'PERIPLASMIC MUREIN PEPTIDE-BINDING PROTEIN', 243132),
(336612, 'PTHR30290:SF34', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, PERIPLASMIC OLIGO-PEPTIDE BINDING PROTEIN, PUTATIVE-RELATED', 243132),
(336613, 'PTHR30290:SF78', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE-BINDING LIPOPROTEIN-RELATED', 243132),
(336614, 'PTHR30290:SF37', NULL, NULL, NULL, NULL, 'NICKEL-BINDING PERIPLASMIC PROTEIN', 243132),
(336615, 'PTHR30290:SF59', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE ABC TRANSPORTER,SUBSTRATE-BINDING PROTEIN-RELATED', 243132),
(336616, 'PTHR30290:SF28', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERIPLASMIC-BINDING PROTEIN SAPA-RELATED', 243132),
(336617, 'PTHR30290:SF38', NULL, NULL, NULL, NULL, 'DIPEPTIDE-BINDING PROTEIN', 243132);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(336618, 'PTHR30290:SF16', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE ABC TRANSPORTER, PERIPLASMIC OLIGOPEPTIDE-BINDING PROTEIN', 243132),
(336619, 'PTHR30290:SF19', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERIPLASMIC BINDING PROTEIN-RELATED', 243132),
(336620, 'PTHR30290:SF62', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE ABC TRANSPORTER, PERIPLASMIC OLIGOPEPTIDE-BINDING PROTEIN', 243132),
(336621, 'PTHR30290:SF72', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR SGRR', 243132),
(336622, 'PTHR30290:SF75', NULL, NULL, NULL, NULL, 'MONOACYL PHOSPHATIDYLINOSITOL TETRAMANNOSIDE-BINDING PROTEIN LPQW-RELATED', 243132),
(336623, 'PTHR30290:SF64', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERIPLASMIC BINDING PROTEIN-RELATED', 243132),
(336624, 'PTHR30290:SF77', NULL, NULL, NULL, NULL, 'PEPTIDE TRANSPORT SYSTEM SECRETED PEPTIDE-BINDING PROTEIN-RELATED', 243132),
(336625, 'PTHR30290:SF32', NULL, NULL, NULL, NULL, 'GLUTATHIONE-BINDING PROTEIN GSIB', 243132),
(336626, 'PTHR30290:SF10', NULL, NULL, NULL, NULL, 'PERIPLASMIC OLIGOPEPTIDE-BINDING PROTEIN-RELATED', 243132),
(336627, 'PTHR30290:SF65', NULL, NULL, NULL, NULL, 'EXTRACELLULAR SOLUTE-BINDING PROTEIN', 243132),
(336628, 'PTHR30290:SF80', NULL, NULL, NULL, NULL, 'DIPEPTIDE BINDING PROTEIN', 243132),
(336629, 'PTHR15326:SF9', NULL, NULL, NULL, NULL, 'SI:CH211-189A15.5', 243133),
(336630, 'PTHR15326:SF8', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 2', 243133),
(336631, 'PTHR15326', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 2/TAMOZHENNIC', 243133),
(336632, 'PTHR15326:SF2', NULL, NULL, NULL, NULL, 'PROTEIN TAMOZHENNIC', 243133),
(336633, 'PTHR15326:SF7', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 2-LIKE PROTEIN', 243133),
(336634, 'PTHR23172:SF19', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 243134),
(336635, 'PTHR23172:SF34', NULL, NULL, NULL, NULL, 'CYCLIN-G-ASSOCIATED KINASE', 243134),
(336636, 'PTHR23172:SF99', NULL, NULL, NULL, NULL, 'AUXILIN-LIKE PROTEIN', 243134),
(336637, 'PTHR23172:SF70', NULL, NULL, NULL, NULL, 'DNAJ DOMAIN-CONTAINING PROTEIN-RELATED', 243134),
(336638, 'PTHR23172:SF92', NULL, NULL, NULL, NULL, 'OS06G0678100 PROTEIN', 243134),
(336639, 'PTHR23172:SF91', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 243134),
(336640, 'PTHR23172:SF94', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN REQUIRED FOR CHLOROPLAST ACCUMULATION RESPONSE 1-LIKE ISOFORM X1', 243134),
(336641, 'PTHR23172:SF72', NULL, NULL, NULL, NULL, 'BNAC03G27290D PROTEIN', 243134),
(336642, 'PTHR23172:SF50', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243134),
(336643, 'PTHR23172:SF93', NULL, NULL, NULL, NULL, 'AUXILIN-LIKE PROTEIN', 243134),
(336644, 'PTHR23172:SF96', NULL, NULL, NULL, NULL, 'AUXIN-LIKE 1 PROTEIN', 243134),
(336645, 'PTHR23172:SF95', NULL, NULL, NULL, NULL, 'BNAA06G15380D PROTEIN', 243134),
(336646, 'PTHR23172:SF76', NULL, NULL, NULL, NULL, 'DENTIN SIALOPHOSPHOPROTEIN-LIKE', 243134),
(336647, 'PTHR23172:SF98', NULL, NULL, NULL, NULL, 'AUXILIN', 243134),
(336648, 'PTHR23172', NULL, NULL, NULL, NULL, 'AUXILIN/CYCLIN G-ASSOCIATED KINASE-RELATED', 243134),
(336649, 'PTHR23172:SF97', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243134),
(336650, 'PTHR23172:SF90', NULL, NULL, NULL, NULL, '', 243134),
(336651, 'PTHR23172:SF89', NULL, NULL, NULL, NULL, 'DNAJ DOMAIN-CONTAINING PROTEIN-RELATED', 243134),
(336652, 'PTHR23172:SF67', NULL, NULL, NULL, NULL, 'AUXILIN-LIKE PROTEIN 1', 243134),
(336653, 'PTHR23172:SF88', NULL, NULL, NULL, NULL, 'DNAJ-DOMAIN PROTEIN, PUTATIVE-RELATED', 243134),
(336654, 'PTHR23172:SF69', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', 243134),
(336655, 'PTHR23172:SF68', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 243134),
(336656, 'PTHR23172:SF83', NULL, NULL, NULL, NULL, 'AUXILIN-RELATED PROTEIN 2-LIKE', 243134),
(336657, 'PTHR23172:SF4', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE AUXILIN-RELATED', 243134),
(336658, 'PTHR23172:SF60', NULL, NULL, NULL, NULL, 'OS01G0355500 PROTEIN', 243134),
(336659, 'PTHR23172:SF85', NULL, NULL, NULL, NULL, 'AUXILIN-LIKE PROTEIN 1', 243134);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(336660, 'PTHR23172:SF84', NULL, NULL, NULL, NULL, 'AUXILIN-LIKE PROTEIN 1', 243134),
(336661, 'PTHR23172:SF87', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', 243134),
(336662, 'PTHR23172:SF64', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN REQUIRED FOR CHLOROPLAST ACCUMULATION RESPONSE 1', 243134),
(336663, 'PTHR36792', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243135),
(336664, 'PTHR36792:SF7', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN-CONTAINING PROTEIN-RELATED', 243135),
(336665, 'PTHR36792:SF15', NULL, NULL, NULL, NULL, '', 243135),
(336666, 'PTHR36792:SF16', NULL, NULL, NULL, NULL, 'OS05G0342900 PROTEIN', 243135),
(336667, 'PTHR36792:SF5', NULL, NULL, NULL, NULL, 'SEL1 REPEAT PROTEIN', 243135),
(336668, 'PTHR36792:SF12', NULL, NULL, NULL, NULL, '', 243135),
(336669, 'PTHR24408', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 243136),
(336670, 'PTHR24408:SF60', NULL, NULL, NULL, NULL, 'RELATIVE OF WOC, ISOFORM C', 243136),
(336671, 'PTHR24408:SF20', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN PLAGL2', 243136),
(336672, 'PTHR24408:SF31', NULL, NULL, NULL, NULL, 'E4F TRANSCRIPTION FACTOR 1', 243136),
(336673, 'PTHR24408:SF64', NULL, NULL, NULL, NULL, 'LINKING IMMUNITY AND METABOLISM-RELATED', 243136),
(336674, 'PTHR24408:SF63', NULL, NULL, NULL, NULL, 'FINGER PUTATIVE TRANSCRIPTION FACTOR FAMILY-RELATED', 243136),
(336675, 'PTHR24408:SF30', NULL, NULL, NULL, NULL, 'VASCULAR ENDOTHELIAL ZINC FINGER 1', 243136),
(336676, 'PTHR24408:SF62', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 243136),
(336677, 'PTHR24408:SF61', NULL, NULL, NULL, NULL, 'E3 SUMO-PROTEIN LIGASE ZNF451', 243136),
(336678, 'PTHR24408:SF23', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 438', 243136),
(336679, 'PTHR24408:SF34', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 672', 243136),
(336680, 'PTHR24408:SF45', NULL, NULL, NULL, NULL, 'ZINC FINGER TRANSCRIPTION FACTOR FAMILY PROTEIN 30', 243136),
(336681, 'PTHR24408:SF56', NULL, NULL, NULL, NULL, 'PAIRED ZINC FINGER PROTEIN-RELATED', 243136),
(336682, 'PTHR24408:SF21', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 243136),
(336683, 'PTHR24408:SF54', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 316', 243136),
(336684, 'PTHR24408:SF28', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 423', 243136),
(336685, 'PTHR24408:SF37', NULL, NULL, NULL, NULL, '', 243136),
(336686, 'PTHR24408:SF59', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 243136),
(336687, 'PTHR24408:SF36', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 243136),
(336688, 'PTHR24408:SF47', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN HAM-2', 243136),
(336689, 'PTHR24408:SF25', NULL, NULL, NULL, NULL, 'ZINC FINGER Y-CHROMOSOMAL PROTEIN', 243136),
(336690, 'PTHR24408:SF58', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR (TFIIIA), PUTATIVE (AFU_ORTHOLOGUE AFUA_1G05150)-RELATED', 243136),
(336691, 'PTHR24408:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 787', 243136),
(336692, 'PTHR30349:SF36', NULL, NULL, NULL, NULL, 'PROPHAGE INTEGRASE INTR-RELATED', 243137),
(336693, 'PTHR30349:SF79', NULL, NULL, NULL, NULL, 'INTEGRASE/RECOMBINASE PROTEIN MJ0367-RELATED', 243137),
(336694, 'PTHR30349', NULL, NULL, NULL, NULL, 'PHAGE INTEGRASE-RELATED', 243137),
(336695, 'PTHR30349:SF77', NULL, NULL, NULL, NULL, 'TYROSINE RECOMBINASE XERC', 243137),
(336696, 'PTHR30349:SF64', NULL, NULL, NULL, NULL, 'PROPHAGE INTEGRASE INTD', 243137),
(336697, 'PTHR30349:SF41', NULL, NULL, NULL, NULL, 'INTEGRASE/RECOMBINASE HI_1414-RELATED', 243137),
(336698, 'PTHR30349:SF62', NULL, NULL, NULL, NULL, 'TYPE 1 FIMBRIAE REGULATORY PROTEIN FIMB-RELATED', 243137),
(336699, 'PTHR30349:SF83', NULL, NULL, NULL, NULL, 'INTEGRASE-RELATED', 243137),
(336700, 'PTHR30349:SF82', NULL, NULL, NULL, NULL, 'TYROSINE RECOMBINASE XERD-LIKE', 243137),
(336701, 'PTHR30349:SF71', NULL, NULL, NULL, NULL, 'PROPHAGE INTEGRASE INTE', 243137),
(336702, 'PTHR30349:SF81', NULL, NULL, NULL, NULL, 'TYROSINE RECOMBINASE XERD', 243137),
(336703, 'PTHR30349:SF80', NULL, NULL, NULL, NULL, 'INTEGRASE/RECOMBINASE AQ_AA09-RELATED', 243137);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(336704, 'PTHR46732:SF7', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT PROTEASE LA (LON) DOMAIN PROTEIN', 243138),
(336705, 'PTHR46732:SF8', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT PROTEASE LA (LON) DOMAIN PROTEIN', 243138),
(336706, 'PTHR46732:SF9', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT PROTEASE LA (LON) DOMAIN PROTEIN', 243138),
(336707, 'PTHR46732:SF3', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT PROTEASE LA DOMAIN CONTAINING PROTEIN, EXPRESSED', 243138),
(336708, 'PTHR46732:SF5', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT PROTEASE LA (LON) DOMAIN PROTEIN', 243138),
(336709, 'PTHR46732', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT PROTEASE LA (LON) DOMAIN PROTEIN', 243138),
(336710, 'PTHR10174:SF228', NULL, NULL, NULL, NULL, 'ALPHA-TOCOPHEROL TRANSFER PROTEIN-LIKE', 243139),
(336711, 'PTHR10174:SF229', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 243139),
(336712, 'PTHR10174:SF208', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN DDB_G0278031', 243139),
(336713, 'PTHR10174:SF73', NULL, NULL, NULL, NULL, 'CLAVESIN-2', 243139),
(336714, 'PTHR10174:SF224', NULL, NULL, NULL, NULL, 'RETINOL-BINDING PROTEIN PINTA', 243139),
(336715, 'PTHR10174:SF213', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 243139),
(336716, 'PTHR10174:SF225', NULL, NULL, NULL, NULL, 'ALPHA-TOCOPHEROL TRANSFER PROTEIN', 243139),
(336717, 'PTHR10174:SF226', NULL, NULL, NULL, NULL, 'ALPHA-TOCOPHEROL TRANSFER PROTEIN-LIKE', 243139),
(336718, 'PTHR10174:SF216', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN-RELATED', 243139),
(336719, 'PTHR10174:SF231', NULL, NULL, NULL, NULL, 'CLAVESIN-1', 243139),
(336720, 'PTHR10174:SF220', NULL, NULL, NULL, NULL, 'LD41874P', 243139),
(336721, 'PTHR10174:SF166', NULL, NULL, NULL, NULL, 'LD40136P', 243139),
(336722, 'PTHR10174:SF200', NULL, NULL, NULL, NULL, 'RETINALDEHYDE-BINDING PROTEIN 1', 243139),
(336723, 'PTHR10174:SF222', NULL, NULL, NULL, NULL, 'GH10083P-RELATED', 243139),
(336724, 'PTHR10174:SF72', NULL, NULL, NULL, NULL, 'CLAVESIN-1', 243139),
(336725, 'PTHR10174:SF212', NULL, NULL, NULL, NULL, 'MIP26555P1', 243139),
(336726, 'PTHR10174:SF130', NULL, NULL, NULL, NULL, 'SD01558P', 243139),
(336727, 'PTHR10174:SF120', NULL, NULL, NULL, NULL, 'CELLULAR RETINALDEHYDE BINDING PROTEIN', 243139),
(336728, 'PTHR10174:SF230', NULL, NULL, NULL, NULL, 'ALPHA-TOCOPHEROL TRANSFER PROTEIN-LIKE', 243139),
(336729, 'PTHR10174', NULL, NULL, NULL, NULL, 'ALPHA-TOCOPHEROL TRANSFER PROTEIN-RELATED', 243139),
(336730, 'PTHR10174:SF38', NULL, NULL, NULL, NULL, 'HL01515P', 243139),
(336731, 'PTHR12988', NULL, NULL, NULL, NULL, 'SPHINGOMYELIN PHOSPHODIESTERASE 4', 243140),
(336732, 'PTHR12988:SF6', NULL, NULL, NULL, NULL, 'SPHINGOMYELIN PHOSPHODIESTERASE 4', 243140),
(336733, 'PTHR45929:SF7', NULL, NULL, NULL, NULL, 'LAS SEVENTEEN-BINDING PROTEIN 1', 243141),
(336734, 'PTHR45929:SF6', NULL, NULL, NULL, NULL, 'SH3 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_2G10320)', 243141),
(336735, 'PTHR45929:SF1', NULL, NULL, NULL, NULL, 'HEMATOPOIETIC LINEAGE CELL-SPECIFIC PROTEIN-RELATED', 243141),
(336736, 'PTHR45929', NULL, NULL, NULL, NULL, 'JAK PATHWAY SIGNAL TRANSDUCTION ADAPTOR MOLECULE', 243141),
(336737, 'PTHR45929:SF3', NULL, NULL, NULL, NULL, 'JAK PATHWAY SIGNAL TRANSDUCTION ADAPTOR MOLECULE', 243141),
(336738, 'PTHR45929:SF2', NULL, NULL, NULL, NULL, 'SIGNAL TRANSDUCING ADAPTER MOLECULE 1', 243141),
(336739, 'PTHR38694', NULL, NULL, NULL, NULL, 'CONSERVED EXPRESSED PROTEIN', 243142),
(336740, 'PTHR38694:SF2', NULL, NULL, NULL, NULL, '', 243142),
(336741, 'PTHR38694:SF1', NULL, NULL, NULL, NULL, 'CONSERVED EXPRESSED PROTEIN', 243142),
(336742, 'PTHR10265:SF44', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR 1C', 243143),
(336743, 'PTHR10265:SF45', NULL, NULL, NULL, NULL, 'DACAPO', 243143),
(336744, 'PTHR10265:SF46', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR 1', 243143),
(336745, 'PTHR10265', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR 1', 243143),
(336746, 'PTHR10265:SF9', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR 1B', 243143);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(336747, 'PTHR35830:SF1', NULL, NULL, NULL, NULL, 'OS05G0299200 PROTEIN', 243144),
(336748, 'PTHR35830', NULL, NULL, NULL, NULL, 'OS05G0299200 PROTEIN', 243144),
(336749, 'PTHR37909:SF1', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 243145),
(336750, 'PTHR37909', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 243145),
(336751, 'PTHR35360', NULL, NULL, NULL, NULL, 'OS01G0324125 PROTEIN-RELATED', 243146),
(336752, 'PTHR35360:SF2', NULL, NULL, NULL, NULL, 'OS01G0324125 PROTEIN', 243146),
(336753, 'PTHR35360:SF3', NULL, NULL, NULL, NULL, 'OS07G0492700 PROTEIN', 243146),
(336754, 'PTHR48002:SF49', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4D5', 243147),
(336755, 'PTHR48002:SF159', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4A16', 243147),
(336756, 'PTHR48002:SF48', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336757, 'PTHR48002:SF155', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336758, 'PTHR48002:SF158', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336759, 'PTHR48002', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336760, 'PTHR48002:SF157', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336761, 'PTHR48002:SF152', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336762, 'PTHR48002:SF151', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336763, 'PTHR48002:SF154', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336764, 'PTHR48002:SF153', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336765, 'PTHR48002:SF161', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4A5-RELATED', 243147),
(336766, 'PTHR48002:SF160', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1230', 243147),
(336767, 'PTHR48002:SF45', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336768, 'PTHR48002:SF46', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336769, 'PTHR48002:SF44', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4X1', 243147),
(336770, 'PTHR48002:SF42', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336771, 'PTHR48002:SF40', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4C3', 243147),
(336772, 'PTHR48002:SF38', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336773, 'PTHR48002:SF39', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336774, 'PTHR48002:SF36', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336775, 'PTHR48002:SF37', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336776, 'PTHR48002:SF163', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336777, 'PTHR48002:SF162', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336778, 'PTHR48002:SF165', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336779, 'PTHR48002:SF164', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336780, 'PTHR48002:SF34', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4K17', 243147),
(336781, 'PTHR48002:SF35', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336782, 'PTHR48002:SF32', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336783, 'PTHR48002:SF33', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336784, 'PTHR48002:SF30', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336785, 'PTHR48002:SF31', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336786, 'PTHR48002:SF29', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336787, 'PTHR48002:SF27', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336788, 'PTHR48002:SF138', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336789, 'PTHR48002:SF137', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336790, 'PTHR48002:SF28', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336791, 'PTHR48002:SF25', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336792, 'PTHR48002:SF26', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336793, 'PTHR48002:SF139', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4K13', 243147),
(336794, 'PTHR48002:SF134', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(336795, 'PTHR48002:SF133', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336796, 'PTHR48002:SF136', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336797, 'PTHR48002:SF130', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336798, 'PTHR48002:SF132', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4D2', 243147),
(336799, 'PTHR48002:SF131', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4S2', 243147),
(336800, 'PTHR48002:SF23', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4D6', 243147),
(336801, 'PTHR48002:SF24', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4K3', 243147),
(336802, 'PTHR48002:SF21', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336803, 'PTHR48002:SF22', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336804, 'PTHR48002:SF20', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336805, 'PTHR48002:SF18', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336806, 'PTHR48002:SF19', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336807, 'PTHR48002:SF149', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336808, 'PTHR48002:SF16', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336809, 'PTHR48002:SF17', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4N5', 243147),
(336810, 'PTHR48002:SF14', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336811, 'PTHR48002:SF15', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4D1', 243147),
(336812, 'PTHR48002:SF145', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336813, 'PTHR48002:SF144', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336814, 'PTHR48002:SF147', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR-RELATED', 243147),
(336815, 'PTHR48002:SF146', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4X2', 243147),
(336816, 'PTHR48002:SF141', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336817, 'PTHR48002:SF140', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 140', 243147),
(336818, 'PTHR48002:SF143', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336819, 'PTHR48002:SF142', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4C46', 243147),
(336820, 'PTHR48002:SF92', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336821, 'PTHR48002:SF93', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336822, 'PTHR48002:SF90', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336823, 'PTHR48002:SF150', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336824, 'PTHR48002:SF12', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336825, 'PTHR48002:SF13', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4C5', 243147),
(336826, 'PTHR48002:SF10', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336827, 'PTHR48002:SF99', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336828, 'PTHR48002:SF11', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR-RELATED', 243147),
(336829, 'PTHR48002:SF96', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336830, 'PTHR48002:SF97', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336831, 'PTHR48002:SF94', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4F15', 243147),
(336832, 'PTHR48002:SF95', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336833, 'PTHR48002:SF119', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336834, 'PTHR48002:SF9', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4K1', 243147),
(336835, 'PTHR48002:SF116', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336836, 'PTHR48002:SF6', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336837, 'PTHR48002:SF5', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336838, 'PTHR48002:SF115', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4K14', 243147),
(336839, 'PTHR48002:SF118', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336840, 'PTHR48002:SF8', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336841, 'PTHR48002:SF117', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336842, 'PTHR48002:SF7', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4C13', 243147),
(336843, 'PTHR48002:SF112', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4Q3', 243147);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(336844, 'PTHR48002:SF2', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4B1', 243147),
(336845, 'PTHR48002:SF111', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336846, 'PTHR48002:SF1', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4F21-RELATED', 243147),
(336847, 'PTHR48002:SF4', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR-RELATED', 243147),
(336848, 'PTHR48002:SF114', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336849, 'PTHR48002:SF3', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336850, 'PTHR48002:SF113', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336851, 'PTHR48002:SF110', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336852, 'PTHR48002:SF81', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4S1', 243147),
(336853, 'PTHR48002:SF82', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336854, 'PTHR48002:SF80', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336855, 'PTHR48002:SF89', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4D11', 243147),
(336856, 'PTHR48002:SF87', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336857, 'PTHR48002:SF88', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336858, 'PTHR48002:SF85', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336859, 'PTHR48002:SF86', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336860, 'PTHR48002:SF83', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243147),
(336861, 'PTHR48002:SF84', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336862, 'PTHR48002:SF127', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4Q2', 243147),
(336863, 'PTHR48002:SF126', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336864, 'PTHR48002:SF129', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336865, 'PTHR48002:SF128', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4C6', 243147),
(336866, 'PTHR48002:SF123', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336867, 'PTHR48002:SF122', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4F6', 243147),
(336868, 'PTHR48002:SF125', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336869, 'PTHR48002:SF124', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336870, 'PTHR48002:SF121', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4A4-RELATED', 243147),
(336871, 'PTHR48002:SF120', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4N2', 243147),
(336872, 'PTHR48002:SF70', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336873, 'PTHR48002:SF71', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336874, 'PTHR48002:SF78', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336875, 'PTHR48002:SF79', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4A15', 243147),
(336876, 'PTHR48002:SF76', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4C11', 243147),
(336877, 'PTHR48002:SF77', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336878, 'PTHR48002:SF74', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336879, 'PTHR48002:SF75', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4C45', 243147),
(336880, 'PTHR48002:SF72', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336881, 'PTHR48002:SF73', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336882, 'PTHR48002:SF69', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336883, 'PTHR48002:SF60', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336884, 'PTHR48002:SF67', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336885, 'PTHR48002:SF68', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4D10', 243147),
(336886, 'PTHR48002:SF65', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336887, 'PTHR48002:SF63', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336888, 'PTHR48002:SF109', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4K15', 243147),
(336889, 'PTHR48002:SF108', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4D9', 243147),
(336890, 'PTHR48002:SF105', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4C12', 243147),
(336891, 'PTHR48002:SF104', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4K2', 243147);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(336892, 'PTHR48002:SF107', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336893, 'PTHR48002:SF106', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4C16', 243147),
(336894, 'PTHR48002:SF59', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4L1', 243147),
(336895, 'PTHR48002:SF101', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4P4', 243147),
(336896, 'PTHR48002:SF103', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4M1-RELATED', 243147),
(336897, 'PTHR48002:SF102', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4A47', 243147),
(336898, 'PTHR48002:SF56', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4K5', 243147),
(336899, 'PTHR48002:SF54', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336900, 'PTHR48002:SF55', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336901, 'PTHR48002:SF52', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243147),
(336902, 'PTHR48002:SF53', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4C15', 243147),
(336903, 'PTHR48002:SF50', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243147),
(336904, 'PTHR48002:SF51', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 4F17-RELATED', 243147),
(336905, 'PTHR33112:SF6', NULL, NULL, NULL, NULL, 'HETEROKARYON INCOMPATIBILITY PROTEIN', 243148),
(336906, 'PTHR33112:SF7', NULL, NULL, NULL, NULL, 'HET DOMAIN-CONTAINING PROTEIN', 243148),
(336907, 'PTHR33112:SF1', NULL, NULL, NULL, NULL, 'HET DOMAIN-CONTAINING PROTEIN', 243148),
(336908, 'PTHR33112', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE-RELATED', 243148),
(336909, 'PTHR46618', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING PROTEIN 3', 243149),
(336910, 'PTHR46618:SF1', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING PROTEIN 3', 243149),
(336911, 'PTHR47681', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL N-ACETYLGLUCOSAMINYLTRANSFERASE SUBUNIT P-RELATED', 243150),
(336912, 'PTHR47681:SF4', NULL, NULL, NULL, NULL, 'PIG-P DOMAIN-CONTAINING PROTEIN', 243150),
(336913, 'PTHR47681:SF3', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL N-ACETYLGLUCOSAMINYLTRANSFERASE SUBUNIT P-RELATED', 243150),
(336914, 'PTHR45699:SF3', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P0', 243151),
(336915, 'PTHR45699:SF4', NULL, NULL, NULL, NULL, 'RL10P_INSERT DOMAIN-CONTAINING PROTEIN', 243151),
(336916, 'PTHR45699:SF1', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P0-RELATED', 243151),
(336917, 'PTHR45699', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P0', 243151),
(336918, 'PTHR45699:SF25', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P0-2-RELATED', 243151),
(336919, 'PTHR45699:SF24', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L10P-RELATED', 243151),
(336920, 'PTHR45699:SF15', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P0', 243151),
(336921, 'PTHR45699:SF17', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P0', 243151),
(336922, 'PTHR45699:SF21', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P0', 243151),
(336923, 'PTHR45699:SF20', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P0', 243151),
(336924, 'PTHR45699:SF23', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P0', 243151),
(336925, 'PTHR45699:SF9', NULL, NULL, NULL, NULL, 'RL10P_INSERT DOMAIN-CONTAINING PROTEIN', 243151),
(336926, 'PTHR45699:SF8', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P0', 243151),
(336927, 'PTHR45699:SF11', NULL, NULL, NULL, NULL, 'RL10P_INSERT DOMAIN-CONTAINING PROTEIN', 243151),
(336928, 'PTHR22931:SF41', NULL, NULL, NULL, NULL, 'PYRUVATE, PHOSPHATE DIKINASE', 243152),
(336929, 'PTHR22931:SF9', NULL, NULL, NULL, NULL, 'PYRUVATE, PHOSPHATE DIKINASE 1, CHLOROPLASTIC', 243152),
(336930, 'PTHR22931:SF40', NULL, NULL, NULL, NULL, 'PYRUVATE, PHOSPHATE DIKINASE', 243152),
(336931, 'PTHR22931', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE DIKINASE-RELATED', 243152),
(336932, 'PTHR22931:SF39', NULL, NULL, NULL, NULL, 'PYRUVATE, PHOSPHATE DIKINASE 2', 243152),
(336933, 'PTHR23221', NULL, NULL, NULL, NULL, 'GLYCOSYLPHOSPHATIDYLINOSITOL PHOSPHOLIPASE D', 243153),
(336934, 'PTHR23221:SF7', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-GLYCAN-SPECIFIC PHOSPHOLIPASE D', 243153);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(336935, 'PTHR46366:SF1', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN C1685.05', 243154),
(336936, 'PTHR46366:SF4', NULL, NULL, NULL, NULL, 'PEPTIDASE S1C, PEPTIDASE S1, PA CLAN, PDZ-LIKE DOMAIN PROTEIN-RELATED', 243154),
(336937, 'PTHR46366:SF5', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN', 243154),
(336938, 'PTHR46366', NULL, NULL, NULL, NULL, 'PRO-APOPTOTIC SERINE PROTEASE NMA111', 243154),
(336939, 'PTHR46366:SF3', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN', 243154),
(336940, 'PTHR46366:SF8', NULL, NULL, NULL, NULL, 'PRO-APOPTOTIC SERINE PROTEASE NMA111', 243154),
(336941, 'PTHR46366:SF7', NULL, NULL, NULL, NULL, 'PROTEASE DO-LIKE 7', 243154),
(336942, 'PTHR37027', NULL, NULL, NULL, NULL, 'KDE4', 243155),
(336943, 'PTHR37027:SF2', NULL, NULL, NULL, NULL, 'KDE4', 243155),
(336944, 'PTHR45090:SF13', NULL, NULL, NULL, NULL, 'DNAJ DOMAIN-CONTAINING PROTEIN-RELATED', 243156),
(336945, 'PTHR45090:SF12', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 243156),
(336946, 'PTHR45090:SF22', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ 20, CHLOROPLASTIC-LIKE', 243156),
(336947, 'PTHR45090:SF10', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 243156),
(336948, 'PTHR45090:SF21', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 243156),
(336949, 'PTHR45090:SF20', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ 20, CHLOROPLASTIC-LIKE', 243156),
(336950, 'PTHR45090:SF6', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 243156),
(336951, 'PTHR45090:SF8', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 243156),
(336952, 'PTHR45090:SF18', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ 20 CHLOROPLASTIC', 243156),
(336953, 'PTHR45090:SF17', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ DOMAIN PROTEIN', 243156),
(336954, 'PTHR45090:SF14', NULL, NULL, NULL, NULL, 'DNAJ-LIKE 20-RELATED', 243156),
(336955, 'PTHR45090', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ 20 CHLOROPLASTIC', 243156),
(336956, 'PTHR45090:SF4', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ 20, CHLOROPLASTIC', 243156),
(336957, 'PTHR45090:SF3', NULL, NULL, NULL, NULL, 'OS09G0368800 PROTEIN', 243156),
(336958, 'PTHR36111:SF2', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', 243157),
(336959, 'PTHR36111', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', 243157),
(336960, 'PTHR47357:SF5', NULL, NULL, NULL, NULL, 'PROTEIN NETWORKED 4B-LIKE', 243158),
(336961, 'PTHR47357:SF7', NULL, NULL, NULL, NULL, 'NAB DOMAIN-CONTAINING PROTEIN', 243158),
(336962, 'PTHR47357:SF10', NULL, NULL, NULL, NULL, 'COP1-INTERACTIVE PROTEIN 1', 243158),
(336963, 'PTHR47357:SF11', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE-RELATED', 243158),
(336964, 'PTHR47357:SF1', NULL, NULL, NULL, NULL, 'SPINDLE POLE BODY COMPONENT 110', 243158),
(336965, 'PTHR47357:SF4', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN-LIKE', 243158),
(336966, 'PTHR47357:SF9', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN-LIKE PROTEIN', 243158),
(336967, 'PTHR47357', NULL, NULL, NULL, NULL, 'COP1-INTERACTIVE PROTEIN 1', 243158),
(336968, 'PTHR10182', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN 39-RELATED', 243159),
(336969, 'PTHR10182:SF20', NULL, NULL, NULL, NULL, 'BNAC09G21490D PROTEIN', 243159),
(336970, 'PTHR10182:SF31', NULL, NULL, NULL, NULL, 'BNAA02G25530D PROTEIN', 243159),
(336971, 'PTHR10182:SF30', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 243159),
(336972, 'PTHR10182:SF11', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN 39', 243159),
(336973, 'PTHR10182:SF33', NULL, NULL, NULL, NULL, 'HEAT REPEAT FAMILY PROTEIN, EXPRESSED', 243159),
(336974, 'PTHR10182:SF21', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN', 243159),
(336975, 'PTHR10182:SF3', NULL, NULL, NULL, NULL, 'PROTEIN MO25', 243159),
(336976, 'PTHR10182:SF32', NULL, NULL, NULL, NULL, 'MO25-LIKE PROTEIN 3', 243159),
(336977, 'PTHR10182:SF9', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN 39-LIKE', 243159),
(336978, 'PTHR10182:SF13', NULL, NULL, NULL, NULL, 'MO25-LIKE PROTEIN 2', 243159),
(336979, 'PTHR10182:SF35', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN', 243159);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(336980, 'PTHR10182:SF34', NULL, NULL, NULL, NULL, 'MO25-LIKE PROTEIN-RELATED', 243159),
(336981, 'PTHR10182:SF12', NULL, NULL, NULL, NULL, 'OS07G0585100 PROTEIN', 243159),
(336982, 'PTHR10182:SF26', NULL, NULL, NULL, NULL, 'ARMADILLO-LIKE HELICAL, MO25-LIKE PROTEIN-RELATED', 243159),
(336983, 'PTHR10182:SF25', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN 39', 243159),
(336984, 'PTHR10182:SF28', NULL, NULL, NULL, NULL, 'BNAC09G20270D PROTEIN', 243159),
(336985, 'PTHR10182:SF17', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 243159),
(336986, 'PTHR10182:SF27', NULL, NULL, NULL, NULL, 'PROTEIN 39, PUTATIVE, EXPRESSED-RELATED', 243159),
(336987, 'PTHR10182:SF19', NULL, NULL, NULL, NULL, 'BNAC07G34260D PROTEIN', 243159),
(336988, 'PTHR10182:SF18', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN 39,-LIKE 1', 243159),
(336989, 'PTHR10182:SF29', NULL, NULL, NULL, NULL, 'ARMADILLO-LIKE HELICAL, MO25-LIKE PROTEIN-RELATED', 243159),
(336990, 'PTHR45862:SF10', NULL, NULL, NULL, NULL, 'PROTEIN SGT1 HOMOLOG A', 243160),
(336991, 'PTHR45862:SF1', NULL, NULL, NULL, NULL, 'PROTEIN SGT1 HOMOLOG', 243160),
(336992, 'PTHR45862:SF2', NULL, NULL, NULL, NULL, 'SGS DOMAIN, HSP20-LIKE CHAPERONE, ACETYLTRANSFERASE A, AUXILIARY SUBUNIT-RELATED', 243160),
(336993, 'PTHR45862:SF4', NULL, NULL, NULL, NULL, '', 243160),
(336994, 'PTHR45862:SF6', NULL, NULL, NULL, NULL, 'SGT1', 243160),
(336995, 'PTHR45862:SF7', NULL, NULL, NULL, NULL, 'PHOSPHATASE-RELATED', 243160),
(336996, 'PTHR45862:SF9', NULL, NULL, NULL, NULL, 'BNAC01G15070D PROTEIN', 243160),
(336997, 'PTHR45862', NULL, NULL, NULL, NULL, 'PROTEIN SGT1 HOMOLOG', 243160),
(336998, 'PTHR45862:SF11', NULL, NULL, NULL, NULL, 'SGS DOMAIN CONTAINING PROTEIN', 243160),
(336999, 'PTHR35119', NULL, NULL, NULL, NULL, 'PROTEIN POLYCHOME', 243161),
(337000, 'PTHR35119:SF10', NULL, NULL, NULL, NULL, 'PROTEIN POLYCHOME', 243161),
(337001, 'PTHR35119:SF11', NULL, NULL, NULL, NULL, 'OSJNBB0022F23.8-LIKE PROTEIN', 243161),
(337002, 'PTHR35119:SF12', NULL, NULL, NULL, NULL, 'OS04G0472700 PROTEIN', 243161),
(337003, 'PTHR35119:SF1', NULL, NULL, NULL, NULL, 'PROTEIN GIGAS CELL1', 243161),
(337004, 'PTHR12789:SF0', NULL, NULL, NULL, NULL, 'DENSITY-REGULATED PROTEIN', 243162),
(337005, 'PTHR12789:SF2', NULL, NULL, NULL, NULL, 'TRANSLATION MACHINERY-ASSOCIATED PROTEIN 22', 243162),
(337006, 'PTHR12789', NULL, NULL, NULL, NULL, 'DENSITY-REGULATED PROTEIN HOMOLOG', 243162),
(337007, 'PTHR12789:SF5', NULL, NULL, NULL, NULL, 'TRANSLATION MACHINERY-ASSOCIATED PROTEIN 22', 243162),
(337008, 'PTHR22069:SF0', NULL, NULL, NULL, NULL, 'RADIAL SPOKE HEAD PROTEIN 9 HOMOLOG', 243163),
(337009, 'PTHR22069:SF1', NULL, NULL, NULL, NULL, '', 243163),
(337010, 'PTHR22069', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOMAL PROTEIN S18', 243163),
(337011, 'PTHR12629:SF12', NULL, NULL, NULL, NULL, 'HYDROLASE 13, MITOCHONDRIAL, PUTATIVE, EXPRESSED-RELATED', 243164),
(337012, 'PTHR12629:SF56', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 243164),
(337013, 'PTHR12629:SF35', NULL, NULL, NULL, NULL, 'DIPHOSPHOINOSITOL POLYPHOSPHATE PHOSPHOHYDROLASE 3-BETA', 243164),
(337014, 'PTHR12629:SF57', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 243164),
(337015, 'PTHR12629:SF58', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 12, MITOCHONDRIAL', 243164),
(337016, 'PTHR12629:SF15', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 4', 243164),
(337017, 'PTHR12629:SF59', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 243164),
(337018, 'PTHR12629', NULL, NULL, NULL, NULL, 'DIPHOSPHOINOSITOL POLYPHOSPHATE PHOSPHOHYDROLASE', 243164),
(337019, 'PTHR12629:SF41', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 243164),
(337020, 'PTHR12629:SF42', NULL, NULL, NULL, NULL, 'MUTT-LIKE PROTEIN', 243164),
(337021, 'PTHR12629:SF64', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 243164),
(337022, 'PTHR12629:SF43', NULL, NULL, NULL, NULL, 'DIPHOSPHOINOSITOL POLYPHOSPHATE PHOSPHOHYDROLASE 3-ALPHA', 243164),
(337023, 'PTHR12629:SF44', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE-LIKE PROTEIN', 243164);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(337024, 'PTHR12629:SF60', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 243164),
(337025, 'PTHR12629:SF61', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 16, MITOCHONDRIAL', 243164),
(337026, 'PTHR12629:SF40', NULL, NULL, NULL, NULL, 'OS07G0212300 PROTEIN', 243164),
(337027, 'PTHR12629:SF62', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 17, MITOCHONDRIAL', 243164),
(337028, 'PTHR12629:SF49', NULL, NULL, NULL, NULL, 'TMV RESISTANCE PROTEIN N-LIKE', 243164),
(337029, 'PTHR12629:SF67', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 18, MITOCHONDRIAL-LIKE', 243164),
(337030, 'PTHR12629:SF46', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 13, MITOCHONDRIAL-LIKE', 243164),
(337031, 'PTHR12629:SF68', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 18, MITOCHONDRIAL', 243164),
(337032, 'PTHR12629:SF69', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 243164),
(337033, 'PTHR12629:SF48', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 18, MITOCHONDRIAL-LIKE', 243164),
(337034, 'PTHR12629:SF52', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 21, CHLOROPLASTIC', 243164),
(337035, 'PTHR12629:SF74', NULL, NULL, NULL, NULL, 'OS04G0399300 PROTEIN', 243164),
(337036, 'PTHR12629:SF75', NULL, NULL, NULL, NULL, 'NUDIX (NUCLEOSIDE DIPHOSPHATE-LINKED MOIETY X)-TYPE MOTIF 3B', 243164),
(337037, 'PTHR12629:SF53', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 243164),
(337038, 'PTHR12629:SF76', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 13, MITOCHONDRIAL', 243164),
(337039, 'PTHR12629:SF54', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 16, MITOCHONDRIAL-LIKE ISOFORM X1', 243164),
(337040, 'PTHR12629:SF10', NULL, NULL, NULL, NULL, 'OS06G0255400 PROTEIN', 243164),
(337041, 'PTHR12629:SF0', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 243164),
(337042, 'PTHR12629:SF5', NULL, NULL, NULL, NULL, 'DIPHOSPHOINOSITOL POLYPHOSPHATE PHOSPHOHYDROLASE 1', 243164),
(337043, 'PTHR12629:SF6', NULL, NULL, NULL, NULL, 'DIPHOSPHOINOSITOL POLYPHOSPHATE PHOSPHOHYDROLASE 2-RELATED', 243164),
(337044, 'PTHR12629:SF71', NULL, NULL, NULL, NULL, 'OS02G0520100 PROTEIN', 243164),
(337045, 'PTHR15435:SF2', NULL, NULL, NULL, NULL, 'KICSTOR COMPLEX PROTEIN KAPTIN', 243165),
(337046, 'PTHR15435', NULL, NULL, NULL, NULL, 'KICSTOR COMPLEX PROTEIN KAPTIN', 243165),
(337047, 'PTHR45093', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ACTIVATOR MSS11', 243166),
(337048, 'PTHR45093:SF3', NULL, NULL, NULL, NULL, 'OS01G0177100 PROTEIN', 243166),
(337049, 'PTHR45093:SF2', NULL, NULL, NULL, NULL, 'LISH DOMAIN-CONTAINING PROTEIN', 243166),
(337050, 'PTHR14667', NULL, NULL, NULL, NULL, 'BARDET-BIEDL SYNDROME 10 PROTEIN', 243167),
(337051, 'PTHR14667:SF2', NULL, NULL, NULL, NULL, 'BARDET-BIEDL SYNDROME 10 PROTEIN', 243167),
(337052, 'PTHR15597:SF48', NULL, NULL, NULL, NULL, 'SEX DETERMINATION PROTEIN FOX-1', 243168),
(337053, 'PTHR15597:SF26', NULL, NULL, NULL, NULL, 'RNA BINDING PROTEIN FOX-1 HOMOLOG 1', 243168),
(337054, 'PTHR15597:SF31', NULL, NULL, NULL, NULL, 'RNA BINDING PROTEIN FOX-1 HOMOLOG 2', 243168),
(337055, 'PTHR15597:SF40', NULL, NULL, NULL, NULL, 'RNA BINDING PROTEIN FOX-1 HOMOLOG 1-LIKE', 243168),
(337056, 'PTHR15597:SF25', NULL, NULL, NULL, NULL, 'RNA BINDING PROTEIN FOX-1 HOMOLOG 3', 243168),
(337057, 'PTHR15597:SF22', NULL, NULL, NULL, NULL, 'RNA-BINDING FOX PROTEIN 1, ISOFORM H', 243168),
(337058, 'PTHR15597:SF44', NULL, NULL, NULL, NULL, 'PIP-1', 243168),
(337059, 'PTHR15597:SF45', NULL, NULL, NULL, NULL, 'RNA BINDING PROTEIN FOX-1 HOMOLOG 1', 243168),
(337060, 'PTHR15597', NULL, NULL, NULL, NULL, 'ATAXIN 2-BINDING PROTEIN 1-RELATED', 243168),
(337061, 'PTHR36180', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN-RELATED-RELATED', 243169),
(337062, 'PTHR36180:SF2', NULL, NULL, NULL, NULL, 'BRO FAMILY PROTEIN', 243169),
(337063, 'PTHR36180:SF1', NULL, NULL, NULL, NULL, 'ANTI REPRESSOR', 243169),
(337064, 'PTHR19845:SF15', NULL, NULL, NULL, NULL, 'KATANIN P80 WD40 REPEAT-CONTAINING SUBUNIT B1 HOMOLOG KTN80.2', 243170),
(337065, 'PTHR19845:SF14', NULL, NULL, NULL, NULL, 'KATANIN P80 WD40 REPEAT-CONTAINING SUBUNIT B1 HOMOLOG', 243170);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(337066, 'PTHR19845:SF25', NULL, NULL, NULL, NULL, 'KATANIN P80 WD40 REPEAT-CONTAINING SUBUNIT B1 HOMOLOG', 243170),
(337067, 'PTHR19845:SF24', NULL, NULL, NULL, NULL, 'REPEAT-LIKE SUPERFAMILY PROTEIN, PUTATIVE-RELATED', 243170),
(337068, 'PTHR19845', NULL, NULL, NULL, NULL, 'KATANIN P80 SUBUNIT', 243170),
(337069, 'PTHR19845:SF22', NULL, NULL, NULL, NULL, 'KATANIN P80 WD40 REPEAT-CONTAINING SUBUNIT B1 HOMOLOG', 243170),
(337070, 'PTHR19845:SF0', NULL, NULL, NULL, NULL, 'KATANIN P80 WD40 REPEAT-CONTAINING SUBUNIT B1', 243170),
(337071, 'PTHR19845:SF21', NULL, NULL, NULL, NULL, 'KATANIN P80 WD40 REPEAT-CONTAINING SUBUNIT B1 HOMOLOG KTN80.3', 243170),
(337072, 'PTHR19845:SF19', NULL, NULL, NULL, NULL, 'KATANIN P80 WD40 REPEAT-CONTAINING SUBUNIT B1 HOMOLOG KTN80.1', 243170),
(337073, 'PTHR19845:SF17', NULL, NULL, NULL, NULL, 'KATANIN P80 WD40 REPEAT-CONTAINING SUBUNIT B1 HOMOLOG', 243170),
(337074, 'PTHR21581:SF27', NULL, NULL, NULL, NULL, 'D-ALANYL-D-ALANINE CARBOXYPEPTIDASE DACA', 243171),
(337075, 'PTHR21581:SF26', NULL, NULL, NULL, NULL, 'D-ALANYL-D-ALANINE ENDOPEPTIDASE', 243171),
(337076, 'PTHR21581:SF6', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT 12', 243171),
(337077, 'PTHR21581', NULL, NULL, NULL, NULL, 'D-ALANYL-D-ALANINE CARBOXYPEPTIDASE', 243171),
(337078, 'PTHR21581:SF5', NULL, NULL, NULL, NULL, 'D-ALANYL-D-ALANINE CARBOXYPEPTIDASE DACD', 243171),
(337079, 'PTHR21581:SF11', NULL, NULL, NULL, NULL, 'D-ALANYL-D-ALANINE CARBOXYPEPTIDASE DACA', 243171),
(337080, 'PTHR21581:SF32', NULL, NULL, NULL, NULL, 'D-ALANYL-D-ALANINE CARBOXYPEPTIDASE DACB', 243171),
(337081, 'PTHR21581:SF31', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN, TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN PROTEIN-RELATED', 243171),
(337082, 'PTHR43336:SF4', NULL, NULL, NULL, NULL, 'GAF DOMAIN CONTAINING PROTEIN', 243172),
(337083, 'PTHR43336', NULL, NULL, NULL, NULL, 'OXYGEN SENSOR HISTIDINE KINASE RESPONSE REGULATOR DEVS/DOSS', 243172),
(337084, 'PTHR43336:SF3', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE DOMAIN-CONTAINING PROTEIN', 243172),
(337085, 'PTHR31906:SF3', NULL, NULL, NULL, NULL, 'PLASTID-LIPID-ASSOCIATED PROTEIN 11, CHLOROPLASTIC-RELATED', 243173),
(337086, 'PTHR31906', NULL, NULL, NULL, NULL, 'PLASTID-LIPID-ASSOCIATED PROTEIN 4, CHLOROPLASTIC-RELATED', 243173),
(337087, 'PTHR31906:SF4', NULL, NULL, NULL, NULL, 'FIBRILLIN-5, CHLOROPLASTIC', 243173),
(337088, 'PTHR31906:SF28', NULL, NULL, NULL, NULL, 'PLASTID-LIPID-ASSOCIATED PROTEIN 13, CHLOROPLASTIC-RELATED', 243173),
(337089, 'PTHR31906:SF5', NULL, NULL, NULL, NULL, 'PLASTID-LIPID-ASSOCIATED PROTEIN 3, CHLOROPLASTIC-RELATED', 243173),
(337090, 'PTHR31906:SF17', NULL, NULL, NULL, NULL, 'PLASTID-LIPID-ASSOCIATED PROTEIN 1, CHLOROPLASTIC-RELATED', 243173),
(337091, 'PTHR31906:SF6', NULL, NULL, NULL, NULL, 'PLASTID-LIPID-ASSOCIATED PROTEIN 10, CHLOROPLASTIC-RELATED', 243173),
(337092, 'PTHR31906:SF23', NULL, NULL, NULL, NULL, 'PAP_FIBRILLIN DOMAIN-CONTAINING PROTEIN', 243173),
(337093, 'PTHR31906:SF22', NULL, NULL, NULL, NULL, 'PLASTID-LIPID-ASSOCIATED PROTEIN 9, CHLOROPLASTIC-RELATED', 243173),
(337094, 'PTHR31906:SF31', NULL, NULL, NULL, NULL, 'PAP_FIBRILLIN DOMAIN-CONTAINING PROTEIN', 243173),
(337095, 'PTHR31906:SF27', NULL, NULL, NULL, NULL, 'PLASTOGLOBULIN-1, CHLOROPLASTIC-LIKE', 243173),
(337096, 'PTHR31906:SF16', NULL, NULL, NULL, NULL, 'PLASTID-LIPID-ASSOCIATED PROTEIN 13, CHLOROPLASTIC-RELATED', 243173),
(337097, 'PTHR31906:SF38', NULL, NULL, NULL, NULL, 'PLASTID-LIPID-ASSOCIATED PROTEIN 2, CHLOROPLASTIC-RELATED', 243173),
(337098, 'PTHR31906:SF37', NULL, NULL, NULL, NULL, 'PLASTID-LIPID-ASSOCIATED PROTEIN 4, CHLOROPLASTIC ISOFORM X1-RELATED', 243173),
(337099, 'PTHR31906:SF15', NULL, NULL, NULL, NULL, 'PLASTID-LIPID-ASSOCIATED PROTEIN 6, CHLOROPLASTIC', 243173),
(337100, 'PTHR31906:SF14', NULL, NULL, NULL, NULL, 'PLASTID-LIPID-ASSOCIATED PROTEIN 12, CHLOROPLASTIC-RELATED', 243173),
(337101, 'PTHR31906:SF25', NULL, NULL, NULL, NULL, 'PLASTID-LIPID-ASSOCIATED PROTEIN 8, CHLOROPLASTIC-RELATED', 243173),
(337102, 'PTHR38622:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG11328', 243174);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(337103, 'PTHR38622:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG07046', 243174),
(337104, 'PTHR38622', NULL, NULL, NULL, NULL, 'PROTEIN CBG07046', 243174),
(337105, 'PTHR38622:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG25801', 243174),
(337106, 'PTHR21248', NULL, NULL, NULL, NULL, 'CARDIOLIPIN SYNTHASE', 243175),
(337107, 'PTHR21248:SF7', NULL, NULL, NULL, NULL, 'MINOR CARDIOLIPIN SYNTHASE CLSB', 243175),
(337108, 'PTHR21248:SF11', NULL, NULL, NULL, NULL, 'PLD PHOSPHODIESTERASE DOMAIN-CONTAINING PROTEIN', 243175),
(337109, 'PTHR21248:SF22', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 243175),
(337110, 'PTHR21248:SF12', NULL, NULL, NULL, NULL, 'CARDIOLIPIN SYNTHASE C', 243175),
(337111, 'PTHR21248:SF23', NULL, NULL, NULL, NULL, 'CARDIOLIPIN SYNTHASE B', 243175),
(337112, 'PTHR21248:SF20', NULL, NULL, NULL, NULL, 'CARDIOLIPIN SYNTHASE YWIE-RELATED', 243175),
(337113, 'PTHR12659', NULL, NULL, NULL, NULL, 'RHO-TYPE GTPASE ACTIVATING PROTEIN', 243176),
(337114, 'PTHR12659:SF3', NULL, NULL, NULL, NULL, 'STAR-RELATED LIPID TRANSFER PROTEIN 8', 243176),
(337115, 'PTHR12659:SF2', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 7', 243176),
(337116, 'PTHR12659:SF4', NULL, NULL, NULL, NULL, 'RHO-GAP DOMAIN-CONTAINING PROTEIN', 243176),
(337117, 'PTHR12659:SF7', NULL, NULL, NULL, NULL, 'CROSSVEINLESS C, ISOFORM C', 243176),
(337118, 'PTHR12659:SF6', NULL, NULL, NULL, NULL, 'STAR-RELATED LIPID TRANSFER PROTEIN 13', 243176),
(337119, 'PTHR12659:SF8', NULL, NULL, NULL, NULL, 'STAR-RELATED LIPID TRANSFER (START) DOMAIN-CONTAINING 13A', 243176),
(337120, 'PTHR13817:SF123', NULL, NULL, NULL, NULL, 'L1 CELL ADHESION MOLECULE, PARALOG A', 243177),
(337121, 'PTHR13817:SF73', NULL, NULL, NULL, NULL, 'IG-LIKE AND FIBRONECTIN TYPE-III DOMAIN-CONTAINING PROTEIN 1-RELATED', 243177),
(337122, 'PTHR13817:SF167', NULL, NULL, NULL, NULL, '', 243177),
(337123, 'PTHR13817:SF166', NULL, NULL, NULL, NULL, 'NEURONAL IGCAM', 243177),
(337124, 'PTHR13817:SF121', NULL, NULL, NULL, NULL, 'PROTEIN SIDEKICK-LIKE PROTEIN', 243177),
(337125, 'PTHR13817:SF165', NULL, NULL, NULL, NULL, 'HEMICENTIN 2-RELATED', 243177),
(337126, 'PTHR13817:SF164', NULL, NULL, NULL, NULL, 'ZORMIN, ISOFORM J', 243177),
(337127, 'PTHR13817:SF77', NULL, NULL, NULL, NULL, 'CONTACTIN 1', 243177),
(337128, 'PTHR13817:SF169', NULL, NULL, NULL, NULL, 'MYOSIN-BINDING PROTEIN HB', 243177),
(337129, 'PTHR13817:SF75', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN SUPERFAMILY MEMBER 9B', 243177),
(337130, 'PTHR13817:SF168', NULL, NULL, NULL, NULL, '', 243177),
(337131, 'PTHR13817', NULL, NULL, NULL, NULL, 'TITIN', 243177),
(337132, 'PTHR13817:SF69', NULL, NULL, NULL, NULL, 'ROUNDABOUT GUIDANCE RECEPTOR 2', 243177),
(337133, 'PTHR13817:SF68', NULL, NULL, NULL, NULL, 'DOWN SYNDROME CELL ADHESION MOLECULE HOMOLOG', 243177),
(337134, 'PTHR13817:SF67', NULL, NULL, NULL, NULL, 'MYOPALLADIN', 243177),
(337135, 'PTHR13817:SF163', NULL, NULL, NULL, NULL, 'OBSCURIN', 243177),
(337136, 'PTHR13817:SF162', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN-LIKE AND FIBRONECTIN TYPE III DOMAIN-CONTAINING 1, TANDEM DUPLICATE 2-RELATED', 243177),
(337137, 'PTHR13817:SF160', NULL, NULL, NULL, NULL, 'PROTEIN SIDEKICK HOMOLOG', 243177),
(337138, 'PTHR13817:SF27', NULL, NULL, NULL, NULL, 'MYOSIN-BINDING PROTEIN C, SLOW-TYPE', 243177),
(337139, 'PTHR13817:SF155', NULL, NULL, NULL, NULL, '', 243177),
(337140, 'PTHR13817:SF154', NULL, NULL, NULL, NULL, 'SIDEKICK CELL ADHESION MOLECULE 2A', 243177),
(337141, 'PTHR13817:SF153', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN SUPERFAMILY MEMBER 22', 243177),
(337142, 'PTHR13817:SF22', NULL, NULL, NULL, NULL, 'MYOMESIN-2', 243177),
(337143, 'PTHR13817:SF65', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE-III DOMAIN-CONTAINING PROTEIN 3A', 243177),
(337144, 'PTHR13817:SF20', NULL, NULL, NULL, NULL, 'MYOSIN-BINDING PROTEIN C, CARDIAC-TYPE', 243177),
(337145, 'PTHR13817:SF59', NULL, NULL, NULL, NULL, 'PROTEIN SIDEKICK-2', 243177),
(337146, 'PTHR13817:SF151', NULL, NULL, NULL, NULL, 'TITIN', 243177),
(337147, 'PTHR13817:SF17', NULL, NULL, NULL, NULL, 'MYOSIN-BINDING PROTEIN C, FAST-TYPE', 243177);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(337148, 'PTHR13817:SF16', NULL, NULL, NULL, NULL, 'MYOMESIN-1', 243177),
(337149, 'PTHR13817:SF101', NULL, NULL, NULL, NULL, 'PROTEIN TURTLE HOMOLOG A-LIKE', 243177),
(337150, 'PTHR13817:SF95', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN SUPERFAMILY DCC SUBCLASS MEMBER 4', 243177),
(337151, 'PTHR13817:SF143', NULL, NULL, NULL, NULL, 'KETTIN (DROSOPHILA ACTIN-BINDING) HOMOLOG', 243177),
(337152, 'PTHR13817:SF55', NULL, NULL, NULL, NULL, 'PROTEIN SIDEKICK-1', 243177),
(337153, 'PTHR13817:SF54', NULL, NULL, NULL, NULL, 'DOWN SYNDROME CELL ADHESION MOLECULE-LIKE PROTEIN 1 HOMOLOG', 243177),
(337154, 'PTHR13817:SF147', NULL, NULL, NULL, NULL, 'CONTACTIN-4-LIKE', 243177),
(337155, 'PTHR13817:SF103', NULL, NULL, NULL, NULL, 'ROUNDABOUT, AXON GUIDANCE RECEPTOR, HOMOLOG 3 (DROSOPHILA)', 243177),
(337156, 'PTHR13817:SF52', NULL, NULL, NULL, NULL, 'ROUNDABOUT GUIDANCE RECEPTOR 1', 243177),
(337157, 'PTHR13817:SF102', NULL, NULL, NULL, NULL, 'DOWN SYNDROME CELL ADHESION MOLECULE-LIKE PROTEIN DSCAM2', 243177),
(337158, 'PTHR13817:SF96', NULL, NULL, NULL, NULL, 'NEURAL CELL ADHESION MOLECULE 1', 243177),
(337159, 'PTHR13817:SF106', NULL, NULL, NULL, NULL, 'PALLADIN, CYTOSKELETAL ASSOCIATED PROTEIN', 243177),
(337160, 'PTHR13817:SF89', NULL, NULL, NULL, NULL, 'MYOMESIN-3', 243177),
(337161, 'PTHR13817:SF49', NULL, NULL, NULL, NULL, 'MYOSIN-BINDING PROTEIN H', 243177),
(337162, 'PTHR13817:SF84', NULL, NULL, NULL, NULL, 'CONTACTIN 6', 243177),
(337163, 'PTHR13817:SF176', NULL, NULL, NULL, NULL, 'FASCICLIN-2-LIKE PROTEIN', 243177),
(337164, 'PTHR13817:SF81', NULL, NULL, NULL, NULL, 'CONTACTIN-2', 243177),
(337165, 'PTHR13817:SF175', NULL, NULL, NULL, NULL, 'IG-LIKE AND FIBRONECTIN TYPE-III DOMAIN-CONTAINING PROTEIN C27B7.7', 243177),
(337166, 'PTHR13817:SF138', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN-LIKE AND FIBRONECTIN TYPE III DOMAIN-CONTAINING PROTEIN 1', 243177),
(337167, 'PTHR13817:SF44', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE III DOMAIN CONTAINING 3B', 243177),
(337168, 'PTHR13817:SF88', NULL, NULL, NULL, NULL, 'CONTACTIN 3', 243177),
(337169, 'PTHR13817:SF43', NULL, NULL, NULL, NULL, 'MYOSIN-BINDING PROTEIN CB', 243177),
(337170, 'PTHR13817:SF136', NULL, NULL, NULL, NULL, 'NEURAL CELL ADHESION MOLECULE L1-LIKE PROTEIN', 243177),
(337171, 'PTHR13817:SF85', NULL, NULL, NULL, NULL, 'DCC NETRIN 1 RECEPTOR', 243177),
(337172, 'PTHR13817:SF80', NULL, NULL, NULL, NULL, 'INACTIVE TYROSINE-PROTEIN KINASE 7', 243177),
(337173, 'PTHR13817:SF170', NULL, NULL, NULL, NULL, '', 243177),
(337174, 'PTHR13817:SF174', NULL, NULL, NULL, NULL, 'PROTEIN CBR-TTN-1', 243177),
(337175, 'PTHR13817:SF173', NULL, NULL, NULL, NULL, 'FRAZZLED', 243177),
(337176, 'PTHR13817:SF172', NULL, NULL, NULL, NULL, 'LP22668P', 243177),
(337177, 'PTHR13817:SF171', NULL, NULL, NULL, NULL, 'STRETCHIN-MLCK, ISOFORM U', 243177),
(337178, 'PTHR34793:SF8', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II BIOGENESIS PROTEIN', 243178),
(337179, 'PTHR34793', NULL, NULL, NULL, NULL, 'PROTEIN THYLAKOID FORMATION 1, CHLOROPLASTIC', 243178),
(337180, 'PTHR34793:SF1', NULL, NULL, NULL, NULL, 'PROTEIN THYLAKOID FORMATION 1, CHLOROPLASTIC', 243178),
(337181, 'PTHR45897:SF2', NULL, NULL, NULL, NULL, 'HIGH AFFINITY CHOLINE TRANSPORTER 1', 243179),
(337182, 'PTHR45897:SF5', NULL, NULL, NULL, NULL, 'HIGH AFFINITY CHOLINE TRANSPORTER 1-LIKE', 243179),
(337183, 'PTHR45897:SF4', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY CHOLINE TRANSPORTER 1', 243179),
(337184, 'PTHR45897', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY CHOLINE TRANSPORTER 1', 243179),
(337185, 'PTHR16017', NULL, NULL, NULL, NULL, 'GASTRULATION DEFECTIVE PROTEIN 1-RELATED', 243180),
(337186, 'PTHR16017:SF0', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 70', 243180),
(337187, 'PTHR46146:SF7', NULL, NULL, NULL, NULL, 'OS11G0664000 PROTEIN', 243181),
(337188, 'PTHR46146:SF12', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243181),
(337189, 'PTHR46146:SF8', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243181),
(337190, 'PTHR46146:SF9', NULL, NULL, NULL, NULL, 'OS06G0151700 PROTEIN', 243181);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(337191, 'PTHR46146:SF2', NULL, NULL, NULL, NULL, 'OS11G0222000 PROTEIN', 243181),
(337192, 'PTHR46146:SF16', NULL, NULL, NULL, NULL, 'OS08G0109800 PROTEIN', 243181),
(337193, 'PTHR46146:SF3', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE-LIKE PROTEIN CCR3-RELATED', 243181),
(337194, 'PTHR46146:SF13', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243181),
(337195, 'PTHR46146:SF4', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE-LIKE PROTEIN CCR4', 243181),
(337196, 'PTHR46146:SF14', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-KINASE CCR4-LIKE PROTEIN', 243181),
(337197, 'PTHR46146', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE-LIKE PROTEIN CCR4', 243181),
(337198, 'PTHR46146:SF1', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243181),
(337199, 'PTHR36076:SF1', NULL, NULL, NULL, NULL, 'THIOREDOXIN SUPERFAMILY PROTEIN', 243182),
(337200, 'PTHR36076', NULL, NULL, NULL, NULL, 'THIOREDOXIN SUPERFAMILY PROTEIN', 243182),
(337201, 'PTHR37559:SF1', NULL, NULL, NULL, NULL, 'PAREP6 PART 2, AUTHENTIC FRAMESHIFT', 243183),
(337202, 'PTHR37559', NULL, NULL, NULL, NULL, 'PAREP6 PART 2, AUTHENTIC FRAMESHIFT', 243183),
(337203, 'PTHR36771:SF2', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243184),
(337204, 'PTHR36771:SF3', NULL, NULL, NULL, NULL, 'BNAA09G35750D PROTEIN', 243184),
(337205, 'PTHR36771', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243184),
(337206, 'PTHR22891', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 2C', 243185),
(337207, 'PTHR22891:SF181', NULL, NULL, NULL, NULL, 'PIWI DOMAIN-CONTAINING PROTEIN', 243185),
(337208, 'PTHR22891:SF180', NULL, NULL, NULL, NULL, '', 243185),
(337209, 'PTHR22891:SF174', NULL, NULL, NULL, NULL, 'ARGONAUTE-1, ISOFORM A', 243185),
(337210, 'PTHR22891:SF130', NULL, NULL, NULL, NULL, 'PROTEIN ARGONAUTE 8', 243185),
(337211, 'PTHR22891:SF171', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR 2C, PUTATIVE-RELATED', 243185),
(337212, 'PTHR22891:SF134', NULL, NULL, NULL, NULL, 'PROTEIN ARGONAUTE 4B-LIKE', 243185),
(337213, 'PTHR22891:SF178', NULL, NULL, NULL, NULL, 'PROTEIN ARGONAUTE 4-LIKE', 243185),
(337214, 'PTHR22891:SF177', NULL, NULL, NULL, NULL, 'PIWI DOMAIN-CONTAINING PROTEIN', 243185),
(337215, 'PTHR22891:SF133', NULL, NULL, NULL, NULL, 'ARGONAUTE108', 243185),
(337216, 'PTHR22891:SF176', NULL, NULL, NULL, NULL, 'PROTEIN ARGONAUTE 9', 243185),
(337217, 'PTHR22891:SF131', NULL, NULL, NULL, NULL, '', 243185),
(337218, 'PTHR22891:SF137', NULL, NULL, NULL, NULL, 'ARGONAUTE18B', 243185),
(337219, 'PTHR22891:SF179', NULL, NULL, NULL, NULL, 'OS03G0252750 PROTEIN', 243185),
(337220, 'PTHR22891:SF139', NULL, NULL, NULL, NULL, 'PROTEIN ARGONAUTE 1-LIKE', 243185),
(337221, 'PTHR22891:SF170', NULL, NULL, NULL, NULL, '', 243185),
(337222, 'PTHR22891:SF161', NULL, NULL, NULL, NULL, 'BNACNNG35060D PROTEIN', 243185),
(337223, 'PTHR22891:SF160', NULL, NULL, NULL, NULL, 'PIWI DOMAIN-CONTAINING PROTEIN', 243185),
(337224, 'PTHR22891:SF167', NULL, NULL, NULL, NULL, 'PIWI-LIKE PROTEIN', 243185),
(337225, 'PTHR22891:SF122', NULL, NULL, NULL, NULL, 'PROTEIN ARGONAUTE 10', 243185),
(337226, 'PTHR22891:SF165', NULL, NULL, NULL, NULL, 'PIWI DOMAIN-CONTAINING PROTEIN', 243185),
(337227, 'PTHR22891:SF164', NULL, NULL, NULL, NULL, 'PIWI-LIKE PROTEIN 1', 243185),
(337228, 'PTHR22891:SF24', NULL, NULL, NULL, NULL, 'PROTEIN ARGONAUTE 5', 243185),
(337229, 'PTHR22891:SF23', NULL, NULL, NULL, NULL, 'PIWI-LIKE PROTEIN', 243185),
(337230, 'PTHR22891:SF26', NULL, NULL, NULL, NULL, 'PROTEIN ARGONAUTE-4', 243185),
(337231, 'PTHR22891:SF124', NULL, NULL, NULL, NULL, 'PROTEIN ARGONAUTE 11', 243185),
(337232, 'PTHR22891:SF66', NULL, NULL, NULL, NULL, 'PROTEIN ARGONAUTE-2', 243185),
(337233, 'PTHR22891:SF128', NULL, NULL, NULL, NULL, 'ARGONAUTE1', 243185),
(337234, 'PTHR22891:SF17', NULL, NULL, NULL, NULL, 'PROTEIN ARGONAUTE-1', 243185),
(337235, 'PTHR22891:SF16', NULL, NULL, NULL, NULL, 'PIWI-LIKE PROTEIN', 243185),
(337236, 'PTHR22891:SF152', NULL, NULL, NULL, NULL, 'BNAA08G03260D PROTEIN', 243185);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(337237, 'PTHR22891:SF8', NULL, NULL, NULL, NULL, 'NUCLEAR RNAI DEFECTIVE-3 PROTEIN', 243185),
(337238, 'PTHR22891:SF151', NULL, NULL, NULL, NULL, '', 243185),
(337239, 'PTHR22891:SF9', NULL, NULL, NULL, NULL, 'PROTEIN ARGONAUTE 7', 243185),
(337240, 'PTHR22891:SF150', NULL, NULL, NULL, NULL, 'BNAC09G36780D PROTEIN', 243185),
(337241, 'PTHR22891:SF3', NULL, NULL, NULL, NULL, 'PROTEIN ARGONAUTE-3', 243185),
(337242, 'PTHR22891:SF156', NULL, NULL, NULL, NULL, 'PROTEIN ARGONAUTE 4-LIKE', 243185),
(337243, 'PTHR22891:SF111', NULL, NULL, NULL, NULL, 'PIWI-LIKE PROTEIN 2', 243185),
(337244, 'PTHR22891:SF4', NULL, NULL, NULL, NULL, 'PROTEIN ARGONAUTE 2-RELATED', 243185),
(337245, 'PTHR22891:SF154', NULL, NULL, NULL, NULL, 'PIWI DOMAIN-CONTAINING PROTEIN', 243185),
(337246, 'PTHR22891:SF6', NULL, NULL, NULL, NULL, 'ARGONAUTE PROTEIN WAGO-1-RELATED', 243185),
(337247, 'PTHR22891:SF57', NULL, NULL, NULL, NULL, 'PROTEIN ARGONAUTE 1D', 243185),
(337248, 'PTHR22891:SF159', NULL, NULL, NULL, NULL, 'BNAA05G14760D PROTEIN', 243185),
(337249, 'PTHR22891:SF12', NULL, NULL, NULL, NULL, 'ARGONAUTE PROTEIN WAGO-4-RELATED', 243185),
(337250, 'PTHR22891:SF15', NULL, NULL, NULL, NULL, 'PIWI-LIKE PROTEIN ERGO-1', 243185),
(337251, 'PTHR22891:SF59', NULL, NULL, NULL, NULL, 'PROTEIN ARGONAUTE-2', 243185),
(337252, 'PTHR22891:SF158', NULL, NULL, NULL, NULL, 'PAZ DOMAIN-CONTAINING PROTEIN-RELATED', 243185),
(337253, 'PTHR22891:SF113', NULL, NULL, NULL, NULL, 'MEIOTIC SILENCING SUPPRESSOR 2', 243185),
(337254, 'PTHR22891:SF157', NULL, NULL, NULL, NULL, 'PROTEIN ARGONAUTE 4', 243185),
(337255, 'PTHR22891:SF11', NULL, NULL, NULL, NULL, 'PROTEIN ARGONAUTE', 243185),
(337256, 'PTHR22891:SF118', NULL, NULL, NULL, NULL, '', 243185),
(337257, 'PTHR22891:SF183', NULL, NULL, NULL, NULL, 'PROTEIN ARGONAUTE PNH1', 243185),
(337258, 'PTHR22891:SF182', NULL, NULL, NULL, NULL, 'PROTEIN ARGONAUTE 4A', 243185),
(337259, 'PTHR22891:SF143', NULL, NULL, NULL, NULL, 'PIWI DOMAIN PROTEIN', 243185),
(337260, 'PTHR22891:SF142', NULL, NULL, NULL, NULL, 'PROTEIN ARGONAUTE 1C', 243185),
(337261, 'PTHR22891:SF149', NULL, NULL, NULL, NULL, 'PROTEIN ARGONAUTE 6', 243185),
(337262, 'PTHR22891:SF46', NULL, NULL, NULL, NULL, 'PIWI-LIKE PROTEIN 1', 243185),
(337263, 'PTHR22891:SF148', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR 2C, PUTATIVE-RELATED', 243185),
(337264, 'PTHR22891:SF147', NULL, NULL, NULL, NULL, 'PROTEIN ARGONAUTE MEL1', 243185),
(337265, 'PTHR22891:SF146', NULL, NULL, NULL, NULL, 'BNAC06G43420D PROTEIN', 243185),
(337266, 'PTHR22891:SF41', NULL, NULL, NULL, NULL, 'PIWI-LIKE PROTEIN 3', 243185),
(337267, 'PTHR22891:SF107', NULL, NULL, NULL, NULL, 'ARGONAUT-LIKE PROTEIN', 243185),
(337268, 'PTHR22891:SF106', NULL, NULL, NULL, NULL, 'ARGONAUTE (PLANT)-LIKE PROTEIN-RELATED', 243185),
(337269, 'PTHR22891:SF43', NULL, NULL, NULL, NULL, 'PIWI-LIKE PROTEIN 4', 243185),
(337270, 'PTHR36882', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED SEQUENCE 37 PROTEIN', 243186),
(337271, 'PTHR36882:SF1', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED SEQUENCE 37 PROTEIN', 243186),
(337272, 'PTHR33941:SF11', NULL, NULL, NULL, NULL, 'PROPANEDIOL UTILIZATION PROTEIN PDUA', 243187),
(337273, 'PTHR33941:SF10', NULL, NULL, NULL, NULL, 'BACTERIAL MICROCOMPARTMENT SHELL PROTEIN EUTM', 243187),
(337274, 'PTHR33941:SF6', NULL, NULL, NULL, NULL, 'BACTERIAL MICROCOMPARTMENT SHELL PROTEIN EUTK', 243187),
(337275, 'PTHR33941:SF13', NULL, NULL, NULL, NULL, 'CARBOXYSOME SHELL PROTEIN CCMK4', 243187),
(337276, 'PTHR33941', NULL, NULL, NULL, NULL, 'PROPANEDIOL UTILIZATION PROTEIN PDUA', 243187),
(337277, 'PTHR22777:SF4', NULL, NULL, NULL, NULL, 'UPF0053 PROTEIN SLL1254', 243188),
(337278, 'PTHR22777', NULL, NULL, NULL, NULL, 'HEMOLYSIN-RELATED', 243188),
(337279, 'PTHR22777:SF30', NULL, NULL, NULL, NULL, 'UPF0053 PROTEIN YEGH', 243188),
(337280, 'PTHR22777:SF31', NULL, NULL, NULL, NULL, 'FAD-BINDING, TYPE 2, GLIDING MOTILITY-ASSOCIATED PROTEIN GLDE-RELATED', 243188),
(337281, 'PTHR22777:SF32', NULL, NULL, NULL, NULL, 'UPF0053 INNER MEMBRANE PROTEIN YFJD', 243188),
(337282, 'PTHR22777:SF15', NULL, NULL, NULL, NULL, 'UPF0053 INNER MEMBRANE PROTEIN YOAE', 243188);
INSERT INTO "PUBLIC"."MODEL" VALUES
(337283, 'PTHR22777:SF27', NULL, NULL, NULL, NULL, 'MAGNESIUM AND COBALT EFFLUX PROTEIN CORC', 243188),
(337284, 'PTHR22777:SF16', NULL, NULL, NULL, NULL, 'UPF0053 INNER MEMBRANE PROTEIN YTFL', 243188),
(337285, 'PTHR22777:SF17', NULL, NULL, NULL, NULL, 'UPF0053 PROTEIN SLL0260', 243188),
(337286, 'PTHR22777:SF28', NULL, NULL, NULL, NULL, 'BNAC03G73630D PROTEIN', 243188),
(337287, 'PTHR48176', NULL, NULL, NULL, NULL, 'DDRGK DOMAIN-CONTAINING PROTEIN 1', 243189),
(337288, 'PTHR48176:SF3', NULL, NULL, NULL, NULL, 'BNAA03G48440D PROTEIN', 243189),
(337289, 'PTHR48176:SF1', NULL, NULL, NULL, NULL, 'DDRGK DOMAIN-CONTAINING PROTEIN 1', 243189),
(337290, 'PTHR45965', NULL, NULL, NULL, NULL, 'INACTIVE RHOMBOID PROTEIN', 243190),
(337291, 'PTHR45965:SF3', NULL, NULL, NULL, NULL, 'INACTIVE RHOMBOID PROTEIN 1', 243190),
(337292, 'PTHR45965:SF2', NULL, NULL, NULL, NULL, 'INACTIVE RHOMBOID PROTEIN 2', 243190),
(337293, 'PTHR48203:SF1', NULL, NULL, NULL, NULL, 'BNAC01G40110D PROTEIN', 243191),
(337294, 'PTHR48203', NULL, NULL, NULL, NULL, 'BNAC01G40110D PROTEIN', 243191),
(337295, 'PTHR48203:SF2', NULL, NULL, NULL, NULL, '', 243191),
(337296, 'PTHR13743:SF139', NULL, NULL, NULL, NULL, 'BEACH DOMAIN-CONTAINING PROTEIN LVSB', 243192),
(337297, 'PTHR13743:SF154', NULL, NULL, NULL, NULL, 'AGAP003389-PA', 243192),
(337298, 'PTHR13743:SF153', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 243192),
(337299, 'PTHR13743:SF156', NULL, NULL, NULL, NULL, 'WD-40 REPEAT PROTEIN/BEIGE PROTEIN', 243192),
(337300, 'PTHR13743:SF112', NULL, NULL, NULL, NULL, 'NEUROBEACHIN', 243192),
(337301, 'PTHR13743:SF155', NULL, NULL, NULL, NULL, 'BEACH DOMAIN-CONTAINING PROTEIN LVSF', 243192),
(337302, 'PTHR13743:SF111', NULL, NULL, NULL, NULL, 'NEUROBEACHIN-LIKE PROTEIN 2', 243192),
(337303, 'PTHR13743:SF158', NULL, NULL, NULL, NULL, 'BEIGE/BEACH DOMAIN CONTAINING PROTEIN', 243192),
(337304, 'PTHR13743:SF136', NULL, NULL, NULL, NULL, 'BEACH DOMAIN-CONTAINING PROTEIN-RELATED', 243192),
(337305, 'PTHR13743:SF157', NULL, NULL, NULL, NULL, 'BEACH DOMAIN-CONTAINING PROTEIN C2', 243192),
(337306, 'PTHR13743:SF138', NULL, NULL, NULL, NULL, 'BNAC04G55290D PROTEIN', 243192),
(337307, 'PTHR13743:SF159', NULL, NULL, NULL, NULL, 'BEACH DOMAIN-CONTAINING PROTEIN', 243192),
(337308, 'PTHR13743:SF115', NULL, NULL, NULL, NULL, 'NEUROBEACHIN-LIKE PROTEIN 1', 243192),
(337309, 'PTHR13743:SF151', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 243192),
(337310, 'PTHR13743:SF129', NULL, NULL, NULL, NULL, 'BEACH DOMAIN-CONTAINING PROTEIN C2', 243192),
(337311, 'PTHR13743:SF108', NULL, NULL, NULL, NULL, 'BEACH DOMAIN-CONTAINING PROTEIN LVSE', 243192),
(337312, 'PTHR13743:SF143', NULL, NULL, NULL, NULL, 'BNAA09G38890D PROTEIN', 243192),
(337313, 'PTHR13743:SF121', NULL, NULL, NULL, NULL, 'BEACH DOMAIN-CONTAINING PROTEIN C2', 243192),
(337314, 'PTHR13743:SF123', NULL, NULL, NULL, NULL, 'PROTEIN FAN', 243192),
(337315, 'PTHR13743:SF144', NULL, NULL, NULL, NULL, 'BEIGE/BEACH/WD DOMAIN CONTAINING PROTEIN-RELATED', 243192),
(337316, 'PTHR13743:SF147', NULL, NULL, NULL, NULL, 'LYSOSOMAL-TRAFFICKING REGULATOR', 243192),
(337317, 'PTHR13743:SF146', NULL, NULL, NULL, NULL, 'BEACH DOMAIN-CONTAINING PROTEIN A2', 243192),
(337318, 'PTHR13743:SF149', NULL, NULL, NULL, NULL, 'WD40 AND FYVE DOMAIN PROTEIN', 243192),
(337319, 'PTHR13743:SF62', NULL, NULL, NULL, NULL, 'NEUROBEACHIN', 243192),
(337320, 'PTHR13743', NULL, NULL, NULL, NULL, 'BEIGE/BEACH-RELATED', 243192),
(337321, 'PTHR13743:SF86', NULL, NULL, NULL, NULL, 'LYSOSOMAL-TRAFFICKING REGULATOR', 243192),
(337322, 'PTHR13743:SF64', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE-RESPONSIVE AND BEIGE-LIKE ANCHOR PROTEIN', 243192),
(337323, 'PTHR13743:SF140', NULL, NULL, NULL, NULL, 'BEACH DOMAIN-CONTAINING PROTEIN LVSD', 243192),
(337324, 'PTHR12777:SF1', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN SM D2', 243193),
(337325, 'PTHR12777', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN SM D2', 243193),
(337326, 'PTHR12777:SF0', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN SM D2', 243193);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(337327, 'PTHR12777:SF6', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN SM D2', 243193),
(337328, 'PTHR40691', NULL, NULL, NULL, NULL, '', 243194),
(337329, 'PTHR40691:SF3', NULL, NULL, NULL, NULL, '', 243194),
(337330, 'PTHR40691:SF1', NULL, NULL, NULL, NULL, 'EXPORTED PROTEIN-RELATED', 243194),
(337331, 'PTHR34537', NULL, NULL, NULL, NULL, 'OS08G0459300 PROTEIN', 243195),
(337332, 'PTHR34537:SF1', NULL, NULL, NULL, NULL, 'OS08G0459300 PROTEIN', 243195),
(337333, 'PTHR34537:SF2', NULL, NULL, NULL, NULL, 'FERREDOXIN-LIKE PROTEIN', 243195),
(337334, 'PTHR45742:SF1', NULL, NULL, NULL, NULL, 'COMPLEMENT COMPONENT C8 ALPHA CHAIN', 243196),
(337335, 'PTHR45742:SF2', NULL, NULL, NULL, NULL, 'COMPLEMENT COMPONENT C7', 243196),
(337336, 'PTHR45742:SF3', NULL, NULL, NULL, NULL, 'COMPLEMENT COMPONENT C9', 243196),
(337337, 'PTHR45742:SF4', NULL, NULL, NULL, NULL, 'COMPLEMENT COMPONENT C6', 243196),
(337338, 'PTHR45742:SF5', NULL, NULL, NULL, NULL, 'COMPLEMENT COMPONENT C8 BETA CHAIN', 243196),
(337339, 'PTHR45742:SF8', NULL, NULL, NULL, NULL, 'MACPF DOMAIN-CONTAINING PROTEIN', 243196),
(337340, 'PTHR45742', NULL, NULL, NULL, NULL, 'COMPLEMENT COMPONENT C6', 243196),
(337341, 'PTHR34795:SF6', NULL, NULL, NULL, NULL, 'BNAC04G05370D PROTEIN', 243197),
(337342, 'PTHR34795:SF5', NULL, NULL, NULL, NULL, 'BNAC04G56750D PROTEIN', 243197),
(337343, 'PTHR34795:SF2', NULL, NULL, NULL, NULL, 'NEMATODE RESISTANCE HSPRO2-LIKE PROTEIN', 243197),
(337344, 'PTHR34795:SF1', NULL, NULL, NULL, NULL, 'NEMATODE RESISTANCE PROTEIN-LIKE HSPRO1', 243197),
(337345, 'PTHR34795', NULL, NULL, NULL, NULL, 'NEMATODE RESISTANCE PROTEIN-LIKE HSPRO1', 243197),
(337346, 'PTHR34795:SF4', NULL, NULL, NULL, NULL, 'NEMATODE RESISTANCE PROTEIN-LIKE HSPRO2', 243197),
(337347, 'PTHR46701', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE-LIKE KOBITO 1', 243198),
(337348, 'PTHR46701:SF10', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 243198),
(337349, 'PTHR46701:SF6', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 243198),
(337350, 'PTHR46701:SF7', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE-LIKE KOBITO 1', 243198),
(337351, 'PTHR46701:SF8', NULL, NULL, NULL, NULL, 'BNAC04G47690D PROTEIN', 243198),
(337352, 'PTHR46701:SF9', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 243198),
(337353, 'PTHR35515', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT N, CHLOROPLASTIC', 243199),
(337354, 'PTHR35515:SF1', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT N, CHLOROPLASTIC', 243199),
(337355, 'PTHR22835:SF660', NULL, NULL, NULL, NULL, '', 243200),
(337356, 'PTHR22835:SF260', NULL, NULL, NULL, NULL, 'OS05G0209600 PROTEIN', 243200),
(337357, 'PTHR22835:SF665', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE', 243200),
(337358, 'PTHR22835:SF544', NULL, NULL, NULL, NULL, 'OS10G0393700 PROTEIN', 243200),
(337359, 'PTHR22835:SF666', NULL, NULL, NULL, NULL, 'OS02G0608801 PROTEIN', 243200),
(337360, 'PTHR22835:SF667', NULL, NULL, NULL, NULL, 'OS01G0215700 PROTEIN', 243200),
(337361, 'PTHR22835:SF546', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 243200),
(337362, 'PTHR22835:SF668', NULL, NULL, NULL, NULL, '', 243200),
(337363, 'PTHR22835:SF661', NULL, NULL, NULL, NULL, '', 243200),
(337364, 'PTHR22835:SF662', NULL, NULL, NULL, NULL, '', 243200),
(337365, 'PTHR22835:SF663', NULL, NULL, NULL, NULL, 'OS01G0649900 PROTEIN', 243200),
(337366, 'PTHR22835:SF542', NULL, NULL, NULL, NULL, '', 243200),
(337367, 'PTHR22835:SF664', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE FAMILY PROTEIN, EXPRESSED', 243200),
(337368, 'PTHR22835:SF543', NULL, NULL, NULL, NULL, 'BNAA07G36520D PROTEIN', 243200),
(337369, 'PTHR22835:SF669', NULL, NULL, NULL, NULL, 'ACETYLCHOLINESTERASE', 243200),
(337370, 'PTHR22835:SF549', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE', 243200),
(337371, 'PTHR22835:SF309', NULL, NULL, NULL, NULL, '', 243200),
(337372, 'PTHR22835:SF272', NULL, NULL, NULL, NULL, '', 243200),
(337373, 'PTHR22835:SF273', NULL, NULL, NULL, NULL, 'ALPHA-L-FUCOSIDASE 2', 243200);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(337374, 'PTHR22835:SF275', NULL, NULL, NULL, NULL, 'OS01G0331100 PROTEIN', 243200),
(337375, 'PTHR22835:SF555', NULL, NULL, NULL, NULL, 'ALPHA-L-FUCOSIDASE 2', 243200),
(337376, 'PTHR22835:SF556', NULL, NULL, NULL, NULL, '', 243200),
(337377, 'PTHR22835:SF557', NULL, NULL, NULL, NULL, 'LIPASE/HYDROLASE FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 243200),
(337378, 'PTHR22835:SF552', NULL, NULL, NULL, NULL, 'OS05G0133401 PROTEIN', 243200),
(337379, 'PTHR22835:SF158', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE', 243200),
(337380, 'PTHR22835:SF554', NULL, NULL, NULL, NULL, '', 243200),
(337381, 'PTHR22835:SF317', NULL, NULL, NULL, NULL, 'OS06G0694200 PROTEIN', 243200),
(337382, 'PTHR22835:SF559', NULL, NULL, NULL, NULL, 'OS01G0215500 PROTEIN', 243200),
(337383, 'PTHR22835:SF241', NULL, NULL, NULL, NULL, 'OS01G0650900 PROTEIN', 243200),
(337384, 'PTHR22835:SF522', NULL, NULL, NULL, NULL, 'BNACNNG44680D PROTEIN', 243200),
(337385, 'PTHR22835:SF523', NULL, NULL, NULL, NULL, '', 243200),
(337386, 'PTHR22835:SF645', NULL, NULL, NULL, NULL, '', 243200),
(337387, 'PTHR22835:SF646', NULL, NULL, NULL, NULL, 'OS01G0612900 PROTEIN', 243200),
(337388, 'PTHR22835:SF244', NULL, NULL, NULL, NULL, 'ALPHA-L-FUCOSIDASE 2', 243200),
(337389, 'PTHR22835:SF520', NULL, NULL, NULL, NULL, 'BNAC05G21980D PROTEIN', 243200),
(337390, 'PTHR22835:SF526', NULL, NULL, NULL, NULL, '', 243200),
(337391, 'PTHR22835:SF647', NULL, NULL, NULL, NULL, 'ALPHA-L-FUCOSIDASE 2', 243200),
(337392, 'PTHR22835:SF648', NULL, NULL, NULL, NULL, 'GDSL LIPASE/ACYLHYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G00510)-RELATED', 243200),
(337393, 'PTHR22835:SF527', NULL, NULL, NULL, NULL, 'OS06G0531900 PROTEIN', 243200),
(337394, 'PTHR22835:SF649', NULL, NULL, NULL, NULL, 'OS01G0651000 PROTEIN', 243200),
(337395, 'PTHR22835:SF528', NULL, NULL, NULL, NULL, 'OS05G0210100 PROTEIN', 243200),
(337396, 'PTHR22835:SF492', NULL, NULL, NULL, NULL, 'ALPHA-L-FUCOSIDASE 2', 243200),
(337397, 'PTHR22835:SF490', NULL, NULL, NULL, NULL, 'OS06G0157000 PROTEIN', 243200),
(337398, 'PTHR22835:SF654', NULL, NULL, NULL, NULL, '2, PUTATIVE-RELATED', 243200),
(337399, 'PTHR22835:SF533', NULL, NULL, NULL, NULL, '', 243200),
(337400, 'PTHR22835:SF655', NULL, NULL, NULL, NULL, 'ACETYLAJMALAN ESTERASE-LIKE', 243200),
(337401, 'PTHR22835:SF535', NULL, NULL, NULL, NULL, '', 243200),
(337402, 'PTHR22835:SF656', NULL, NULL, NULL, NULL, 'LANATOSIDE 15''-O-ACETYLESTERASE', 243200),
(337403, 'PTHR22835:SF657', NULL, NULL, NULL, NULL, '', 243200),
(337404, 'PTHR22835:SF536', NULL, NULL, NULL, NULL, 'OS05G0401000 PROTEIN', 243200),
(337405, 'PTHR22835:SF650', NULL, NULL, NULL, NULL, '', 243200),
(337406, 'PTHR22835:SF651', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 243200),
(337407, 'PTHR22835:SF530', NULL, NULL, NULL, NULL, '', 243200),
(337408, 'PTHR22835:SF498', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE FAMILY PROTEIN, EXPRESSED', 243200),
(337409, 'PTHR22835:SF532', NULL, NULL, NULL, NULL, 'ALPHA-L-FUCOSIDASE 2', 243200),
(337410, 'PTHR22835:SF653', NULL, NULL, NULL, NULL, 'BNAA09G27150D PROTEIN', 243200),
(337411, 'PTHR22835:SF658', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_19_CAT DOMAIN-CONTAINING PROTEIN', 243200),
(337412, 'PTHR22835:SF538', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 243200),
(337413, 'PTHR22835:SF659', NULL, NULL, NULL, NULL, 'OS01G0216300 PROTEIN', 243200),
(337414, 'PTHR22835:SF539', NULL, NULL, NULL, NULL, '', 243200),
(337415, 'PTHR22835:SF220', NULL, NULL, NULL, NULL, 'OS06G0156600 PROTEIN', 243200),
(337416, 'PTHR22835:SF583', NULL, NULL, NULL, NULL, 'BNAC03G58800D PROTEIN', 243200),
(337417, 'PTHR22835:SF588', NULL, NULL, NULL, NULL, 'ALPHA-L-FUCOSIDASE 3', 243200),
(337418, 'PTHR22835:SF621', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 243200),
(337419, 'PTHR22835:SF226', NULL, NULL, NULL, NULL, 'OS07G0586100 PROTEIN', 243200),
(337420, 'PTHR22835:SF622', NULL, NULL, NULL, NULL, 'OS05G0506800 PROTEIN', 243200),
(337421, 'PTHR22835:SF589', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE SUPERFAMILY PROTEIN-RELATED', 243200);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(337422, 'PTHR22835:SF501', NULL, NULL, NULL, NULL, '', 243200),
(337423, 'PTHR22835:SF623', NULL, NULL, NULL, NULL, 'BNAC05G21950D PROTEIN', 243200),
(337424, 'PTHR22835:SF503', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE', 243200),
(337425, 'PTHR22835:SF587', NULL, NULL, NULL, NULL, 'ESTERASE-RELATED', 243200),
(337426, 'PTHR22835:SF620', NULL, NULL, NULL, NULL, '', 243200),
(337427, 'PTHR22835:SF629', NULL, NULL, NULL, NULL, 'BNAA07G08280D PROTEIN', 243200),
(337428, 'PTHR22835:SF509', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 243200),
(337429, 'PTHR22835:SF504', NULL, NULL, NULL, NULL, '', 243200),
(337430, 'PTHR22835:SF505', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 243200),
(337431, 'PTHR22835:SF506', NULL, NULL, NULL, NULL, 'OS01G0223200 PROTEIN', 243200),
(337432, 'PTHR22835:SF507', NULL, NULL, NULL, NULL, 'BNAC06G18430D PROTEIN', 243200),
(337433, 'PTHR22835:SF591', NULL, NULL, NULL, NULL, 'BNAA06G16520D PROTEIN', 243200),
(337434, 'PTHR22835:SF592', NULL, NULL, NULL, NULL, 'BNAC02G17620D PROTEIN', 243200),
(337435, 'PTHR22835:SF593', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE LIP-4', 243200),
(337436, 'PTHR22835:SF599', NULL, NULL, NULL, NULL, '', 243200),
(337437, 'PTHR22835:SF632', NULL, NULL, NULL, NULL, 'ALPHA-L-FUCOSIDASE 2', 243200),
(337438, 'PTHR22835:SF237', NULL, NULL, NULL, NULL, 'OS06G0156700 PROTEIN', 243200),
(337439, 'PTHR22835:SF634', NULL, NULL, NULL, NULL, 'OS01G0329900 PROTEIN', 243200),
(337440, 'PTHR22835:SF117', NULL, NULL, NULL, NULL, 'ALPHA-L-FUCOSIDASE 2', 243200),
(337441, 'PTHR22835:SF514', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE SUPERFAMILY PROTEIN ISOFORM 1', 243200),
(337442, 'PTHR22835:SF595', NULL, NULL, NULL, NULL, 'SGNH HYDROLASE-TYPE ESTERASE DOMAIN-CONTAINING PROTEIN-RELATED', 243200),
(337443, 'PTHR22835:SF233', NULL, NULL, NULL, NULL, 'OS06G0531600 PROTEIN', 243200),
(337444, 'PTHR22835:SF596', NULL, NULL, NULL, NULL, '', 243200),
(337445, 'PTHR22835:SF597', NULL, NULL, NULL, NULL, '', 243200),
(337446, 'PTHR22835:SF234', NULL, NULL, NULL, NULL, 'OS05G0159200 PROTEIN', 243200),
(337447, 'PTHR22835:SF476', NULL, NULL, NULL, NULL, 'OS06G0160200 PROTEIN', 243200),
(337448, 'PTHR22835:SF631', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE SUPERFAMILY PROTEIN-RELATED', 243200),
(337449, 'PTHR22835:SF235', NULL, NULL, NULL, NULL, 'OS07G0642200 PROTEIN', 243200),
(337450, 'PTHR22835:SF510', NULL, NULL, NULL, NULL, '2, PUTATIVE-RELATED', 243200),
(337451, 'PTHR22835:SF519', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE', 243200),
(337452, 'PTHR22835:SF515', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE FAMILY PROTEIN', 243200),
(337453, 'PTHR22835:SF516', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE FAMILY PROTEIN', 243200),
(337454, 'PTHR22835:SF517', NULL, NULL, NULL, NULL, 'ALPHA-L-FUCOSIDASE 2', 243200),
(337455, 'PTHR22835:SF518', NULL, NULL, NULL, NULL, '', 243200),
(337456, 'PTHR22835', NULL, NULL, NULL, NULL, 'ZINC FINGER FYVE DOMAIN CONTAINING PROTEIN', 243200),
(337457, 'PTHR22835:SF561', NULL, NULL, NULL, NULL, '', 243200),
(337458, 'PTHR22835:SF286', NULL, NULL, NULL, NULL, 'OS01G0214600 PROTEIN', 243200),
(337459, 'PTHR22835:SF568', NULL, NULL, NULL, NULL, '', 243200),
(337460, 'PTHR22835:SF601', NULL, NULL, NULL, NULL, 'BNACNNG24650D PROTEIN', 243200),
(337461, 'PTHR22835:SF569', NULL, NULL, NULL, NULL, 'OS05G0210400 PROTEIN', 243200),
(337462, 'PTHR22835:SF166', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE FAMILY PROTEIN, EXPRESSED', 243200),
(337463, 'PTHR22835:SF562', NULL, NULL, NULL, NULL, '', 243200),
(337464, 'PTHR22835:SF565', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE', 243200),
(337465, 'PTHR22835:SF607', NULL, NULL, NULL, NULL, 'BNAA05G31970D PROTEIN', 243200),
(337466, 'PTHR22835:SF609', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE', 243200),
(337467, 'PTHR22835:SF603', NULL, NULL, NULL, NULL, '', 243200),
(337468, 'PTHR22835:SF606', NULL, NULL, NULL, NULL, '', 243200),
(337469, 'PTHR22835:SF571', NULL, NULL, NULL, NULL, '', 243200);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(337470, 'PTHR22835:SF572', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE', 243200),
(337471, 'PTHR22835:SF292', NULL, NULL, NULL, NULL, 'ESTERASE-LIKE ISOFORM X1', 243200),
(337472, 'PTHR22835:SF577', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 243200),
(337473, 'PTHR22835:SF611', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE SUPERFAMILY PROTEIN-RELATED', 243200),
(337474, 'PTHR22835:SF612', NULL, NULL, NULL, NULL, 'OS02G0604000 PROTEIN', 243200),
(337475, 'PTHR22835:SF458', NULL, NULL, NULL, NULL, '2, PUTATIVE-RELATED', 243200),
(337476, 'PTHR22835:SF574', NULL, NULL, NULL, NULL, 'OS01G0214800 PROTEIN', 243200),
(337477, 'PTHR22835:SF576', NULL, NULL, NULL, NULL, '', 243200),
(337478, 'PTHR22835:SF213', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE', 243200),
(337479, 'PTHR22835:SF219', NULL, NULL, NULL, NULL, 'BNAC09G43060D PROTEIN', 243200),
(337480, 'PTHR22835:SF616', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 243200),
(337481, 'PTHR31233:SF10', NULL, NULL, NULL, NULL, 'BICD CARGO ADAPTOR 2 LIKE', 243201),
(337482, 'PTHR31233:SF3', NULL, NULL, NULL, NULL, 'PROTEIN BICAUDAL D HOMOLOG 1', 243201),
(337483, 'PTHR31233:SF6', NULL, NULL, NULL, NULL, 'PROTEIN BICAUDAL D', 243201),
(337484, 'PTHR31233:SF7', NULL, NULL, NULL, NULL, 'PROTEIN BICAUDAL D HOMOLOG 2', 243201),
(337485, 'PTHR31233:SF13', NULL, NULL, NULL, NULL, 'BICAUDAL D HOMOLOG 2 (DROSOPHILA)', 243201),
(337486, 'PTHR31233:SF12', NULL, NULL, NULL, NULL, 'MGC162200 PROTEIN', 243201),
(337487, 'PTHR31233', NULL, NULL, NULL, NULL, 'BICAUDAL D FAMILY MEMBER', 243201),
(337488, 'PTHR46580', NULL, NULL, NULL, NULL, 'SENSOR KINASE-RELATED', 243202),
(337489, 'PTHR46580:SF2', NULL, NULL, NULL, NULL, 'SENSOR KINASE-RELATED', 243202),
(337490, 'PTHR46580:SF3', NULL, NULL, NULL, NULL, 'ATP/GTP-BINDING PROTEIN-RELATED', 243202),
(337491, 'PTHR33775:SF1', NULL, NULL, NULL, NULL, 'PROLINE-RICH BASIC PROTEIN 1', 243203),
(337492, 'PTHR33775:SF4', NULL, NULL, NULL, NULL, 'SI:DKEY-38L22.2', 243203),
(337493, 'PTHR33775:SF2', NULL, NULL, NULL, NULL, 'CARDIAC-ENRICHED FHL2-INTERACTING PROTEIN', 243203),
(337494, 'PTHR33775', NULL, NULL, NULL, NULL, 'CARDIAC-ENRICHED FHL2-INTERACTING PROTEIN-RELATED', 243203),
(337495, 'PTHR45996:SF3', NULL, NULL, NULL, NULL, 'CREB-H TRANSCRIPTION FACTOR HOMOLOG LET-607', 243204),
(337496, 'PTHR45996:SF2', NULL, NULL, NULL, NULL, 'CYCLIC AMP-RESPONSIVE ELEMENT-BINDING PROTEIN 3-LIKE PROTEIN 4', 243204),
(337497, 'PTHR45996:SF4', NULL, NULL, NULL, NULL, 'CYCLIC AMP-RESPONSIVE ELEMENT-BINDING PROTEIN 3', 243204),
(337498, 'PTHR45996:SF1', NULL, NULL, NULL, NULL, 'CYCLIC AMP-RESPONSIVE ELEMENT-BINDING PROTEIN 3-LIKE PROTEIN 3', 243204),
(337499, 'PTHR45996', NULL, NULL, NULL, NULL, 'AGAP001464-PB', 243204),
(337500, 'PTHR25480', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 73', 243205),
(337501, 'PTHR25480:SF0', NULL, NULL, NULL, NULL, 'C-MAF-INDUCING PROTEIN', 243205),
(337502, 'PTHR24351:SF218', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243206),
(337503, 'PTHR24351:SF217', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE ATPK2/ATPK19', 243206),
(337504, 'PTHR24351:SF216', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C', 243206),
(337505, 'PTHR24351:SF215', NULL, NULL, NULL, NULL, 'BNAC01G39350D PROTEIN', 243206),
(337506, 'PTHR24351:SF175', NULL, NULL, NULL, NULL, 'CHROMOSOMAL SERINE/THREONINE-PROTEIN KINASE JIL-1', 243206),
(337507, 'PTHR24351:SF214', NULL, NULL, NULL, NULL, 'BNAC05G43840D PROTEIN', 243206),
(337508, 'PTHR24351:SF213', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S6 KINASE ALPHA-2', 243206),
(337509, 'PTHR24351:SF180', NULL, NULL, NULL, NULL, 'SERUM/GLUCOCORTICOID REGULATED KINASE 2A', 243206),
(337510, 'PTHR24351:SF184', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SGK1', 243206),
(337511, 'PTHR24351:SF182', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C EPSILON TYPE', 243206),
(337512, 'PTHR24351:SF206', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE ATPK2/ATPK19-LIKE', 243206),
(337513, 'PTHR24351:SF209', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 243206);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(337514, 'PTHR24351:SF241', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C', 243206),
(337515, 'PTHR24351:SF240', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 243206),
(337516, 'PTHR24351:SF202', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE FAMILY PROTEIN', 243206),
(337517, 'PTHR24351:SF201', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243206),
(337518, 'PTHR24351:SF168', NULL, NULL, NULL, NULL, 'PROTEIN CBG24789', 243206),
(337519, 'PTHR24351:SF58', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S6 KINASE ALPHA-3', 243206),
(337520, 'PTHR24351:SF200', NULL, NULL, NULL, NULL, 'V-AKT MURINE THYMOMA VIRAL ONCOGENE HOMOLOG 1', 243206),
(337521, 'PTHR24351:SF99', NULL, NULL, NULL, NULL, 'PROTEIN CBG08151', 243206),
(337522, 'PTHR24351:SF98', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S6 KINASE ALPHA-6', 243206),
(337523, 'PTHR24351:SF171', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S6 KINASE BETA-2', 243206),
(337524, 'PTHR24351:SF239', NULL, NULL, NULL, NULL, 'OS03G0334000 PROTEIN', 243206),
(337525, 'PTHR24351:SF238', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C', 243206),
(337526, 'PTHR24351:SF237', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243206),
(337527, 'PTHR24351:SF232', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0277449-RELATED', 243206),
(337528, 'PTHR24351:SF199', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 243206),
(337529, 'PTHR24351:SF110', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 243206),
(337530, 'PTHR24351:SF231', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C', 243206),
(337531, 'PTHR24351:SF198', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C ETA TYPE', 243206),
(337532, 'PTHR24351:SF230', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S6 KINASE', 243206),
(337533, 'PTHR24351:SF197', NULL, NULL, NULL, NULL, 'SERUM/GLUCOCORTICOID REGULATED KINASE FAMILY MEMBER 3', 243206),
(337534, 'PTHR24351:SF236', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C IOTA TYPE', 243206),
(337535, 'PTHR24351:SF115', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S6 KINASE ALPHA-5', 243206),
(337536, 'PTHR24351:SF48', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S6 KINASE BETA-1', 243206),
(337537, 'PTHR24351:SF114', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE S6KL', 243206),
(337538, 'PTHR24351:SF235', NULL, NULL, NULL, NULL, 'AGC/AKT PROTEIN KINASE SCK1', 243206),
(337539, 'PTHR24351:SF234', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE YPK2/YKR2', 243206),
(337540, 'PTHR24351:SF233', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE ATPK2/ATPK19-LIKE ISOFORM X1', 243206),
(337541, 'PTHR24351:SF43', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S6 KINASE ALPHA-1', 243206),
(337542, 'PTHR24351:SF41', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S6 KINASE ALPHA-4', 243206),
(337543, 'PTHR24351:SF229', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C', 243206),
(337544, 'PTHR24351:SF228', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C', 243206),
(337545, 'PTHR24351:SF227', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S6 KINASE', 243206),
(337546, 'PTHR24351:SF226', NULL, NULL, NULL, NULL, '', 243206),
(337547, 'PTHR24351:SF188', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SGK1-LIKE', 243206),
(337548, 'PTHR24351:SF221', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE ATPK1/ATPK6', 243206),
(337549, 'PTHR24351:SF102', NULL, NULL, NULL, NULL, 'AGC PROTEIN KINASE', 243206),
(337550, 'PTHR24351:SF222', NULL, NULL, NULL, NULL, 'SERUM/GLUCOCORTICOID REGULATED KINASE 2', 243206),
(337551, 'PTHR24351', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S6 KINASE', 243206),
(337552, 'PTHR24351:SF192', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 243206),
(337553, 'PTHR13348', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P SUBUNIT P29', 243207),
(337554, 'PTHR13348:SF0', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P PROTEIN SUBUNIT P29', 243207),
(337555, 'PTHR22810', NULL, NULL, NULL, NULL, 'TESTIS DEVELOPMENT PROTEIN NYD-SP26', 243208),
(337556, 'PTHR22810:SF1', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING AND SPERMATID-SPECIFIC PROTEIN 1', 243208);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(337557, 'PTHR23153:SF38', NULL, NULL, NULL, NULL, 'UBX DOMAIN-CONTAINING PROTEIN 6', 243209),
(337558, 'PTHR23153', NULL, NULL, NULL, NULL, 'UBX-RELATED', 243209),
(337559, 'PTHR35490', NULL, NULL, NULL, NULL, 'BACTERIOPHAGE N4 ADSORPTION B PROTEIN', 243210),
(337560, 'PTHR35490:SF7', NULL, NULL, NULL, NULL, 'BNAC01G42400D PROTEIN', 243210),
(337561, 'PTHR35490:SF6', NULL, NULL, NULL, NULL, '', 243210),
(337562, 'PTHR35490:SF3', NULL, NULL, NULL, NULL, '', 243210),
(337563, 'PTHR35490:SF2', NULL, NULL, NULL, NULL, 'BACTERIOPHAGE N4 ADSORPTION B PROTEIN', 243210),
(337564, 'PTHR35490:SF5', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 243210),
(337565, 'PTHR35490:SF4', NULL, NULL, NULL, NULL, '', 243210),
(337566, 'PTHR13415:SF5', NULL, NULL, NULL, NULL, 'INTEGRATOR COMPLEX SUBUNIT 12', 243211),
(337567, 'PTHR13415', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR-RELATED', 243211),
(337568, 'PTHR13415:SF2', NULL, NULL, NULL, NULL, 'INTEGRATOR COMPLEX SUBUNIT 12', 243211),
(337569, 'PTHR13415:SF3', NULL, NULL, NULL, NULL, 'BROMODOMAIN ADJACENT TO ZINC FINGER DOMAIN 2B', 243211),
(337570, 'PTHR36691', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 247', 243212),
(337571, 'PTHR36691:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 247', 243212),
(337572, 'PTHR14200:SF16', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 5A, MITOCHONDRIAL', 243213),
(337573, 'PTHR14200:SF17', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE POLYPEPTIDE VA', 243213),
(337574, 'PTHR14200:SF18', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE POLYPEPTIDE VA', 243213),
(337575, 'PTHR14200:SF11', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE POLYPEPTIDE VA', 243213),
(337576, 'PTHR14200:SF12', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE POLYPEPTIDE VA', 243213),
(337577, 'PTHR14200:SF14', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE POLYPEPTIDE VA', 243213),
(337578, 'PTHR14200', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE POLYPEPTIDE', 243213),
(337579, 'PTHR31068:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL DISTRIBUTION AND MORPHOLOGY PROTEIN 32', 243214),
(337580, 'PTHR31068:SF0', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL DISTRIBUTION AND MORPHOLOGY PROTEIN 31', 243214),
(337581, 'PTHR31068', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL DISTRIBUTION AND MORPHOLOGY PROTEIN 31', 243214),
(337582, 'PTHR37394:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PARTING DANCERS', 243215),
(337583, 'PTHR37394', NULL, NULL, NULL, NULL, 'PROTEIN PARTING DANCERS', 243215),
(337584, 'PTHR22133', NULL, NULL, NULL, NULL, 'AT01821P-RELATED', 243216),
(337585, 'PTHR22133:SF2', NULL, NULL, NULL, NULL, 'AT01821P-RELATED', 243216),
(337586, 'PTHR31194:SF185', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337587, 'PTHR31194:SF141', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337588, 'PTHR31194:SF184', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN TRANSCRIPTION FACTOR', 243217),
(337589, 'PTHR31194:SF140', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR CRF2', 243217),
(337590, 'PTHR31194:SF187', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF118-LIKE', 243217),
(337591, 'PTHR31194:SF142', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF069', 243217),
(337592, 'PTHR31194:SF186', NULL, NULL, NULL, NULL, 'AP2 DOMAIN CLASS TRANSCRIPTION FACTOR', 243217),
(337593, 'PTHR31194:SF189', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337594, 'PTHR31194:SF188', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR', 243217),
(337595, 'PTHR31194:SF147', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337596, 'PTHR31194:SF109', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337597, 'PTHR31194:SF108', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337598, 'PTHR31194:SF82', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337599, 'PTHR31194:SF190', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR SHINE 3', 243217);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(337600, 'PTHR31194:SF192', NULL, NULL, NULL, NULL, 'OS02G0797100 PROTEIN', 243217),
(337601, 'PTHR31194:SF191', NULL, NULL, NULL, NULL, 'AP2/ERF TRANSCRIPTION FACTOR ERF/PTI6-RELATED', 243217),
(337602, 'PTHR31194:SF194', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337603, 'PTHR31194:SF150', NULL, NULL, NULL, NULL, '', 243217),
(337604, 'PTHR31194:SF193', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337605, 'PTHR31194:SF175', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337606, 'PTHR31194:SF131', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337607, 'PTHR31194:SF211', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337608, 'PTHR31194:SF210', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR WIN1-LIKE', 243217),
(337609, 'PTHR31194:SF177', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337610, 'PTHR31194:SF133', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337611, 'PTHR31194:SF213', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR SHINE 3-LIKE', 243217),
(337612, 'PTHR31194:SF136', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337613, 'PTHR31194:SF135', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337614, 'PTHR31194:SF179', NULL, NULL, NULL, NULL, 'OS07G0575000 PROTEIN', 243217),
(337615, 'PTHR31194:SF212', NULL, NULL, NULL, NULL, 'INTEGRASE-TYPE DNA-BINDING SUPERFAMILY PROTEIN', 243217),
(337616, 'PTHR31194:SF215', NULL, NULL, NULL, NULL, 'AP2/ERF TRANSCRIPTION FACTOR ERF/PTI6-RELATED', 243217),
(337617, 'PTHR31194:SF138', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337618, 'PTHR31194:SF214', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337619, 'PTHR31194:SF216', NULL, NULL, NULL, NULL, 'AP2/EREBP TRANSCRIPTION FACTOR SUPERFAMILY PROTEIN-RELATED', 243217),
(337620, 'PTHR31194:SF70', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF116', 243217),
(337621, 'PTHR31194:SF74', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337622, 'PTHR31194:SF75', NULL, NULL, NULL, NULL, 'AP2-EREBP TRANSCRIPTION FACTOR', 243217),
(337623, 'PTHR31194:SF183', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337624, 'PTHR31194:SF69', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337625, 'PTHR31194:SF162', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR CRF4-LIKE', 243217),
(337626, 'PTHR31194:SF165', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337627, 'PTHR31194:SF200', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337628, 'PTHR31194:SF166', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED GENES TRANSCRIPTIONAL ACTIVATOR PTI6', 243217),
(337629, 'PTHR31194:SF202', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337630, 'PTHR31194:SF125', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337631, 'PTHR31194:SF201', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337632, 'PTHR31194:SF204', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR WIN1', 243217),
(337633, 'PTHR31194:SF203', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337634, 'PTHR31194:SF206', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF070', 243217),
(337635, 'PTHR31194:SF129', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR CRF2-LIKE', 243217),
(337636, 'PTHR31194:SF205', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF118', 243217),
(337637, 'PTHR31194:SF208', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337638, 'PTHR31194:SF207', NULL, NULL, NULL, NULL, 'AP2 DOMAIN CLASS TRANSCRIPTION FACTOR', 243217),
(337639, 'PTHR31194:SF209', NULL, NULL, NULL, NULL, 'AP2/ERF TRANSCRIPTION FACTOR ERF/PTI6-RELATED', 243217);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(337640, 'PTHR31194:SF61', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF003', 243217),
(337641, 'PTHR31194:SF62', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF118-RELATED', 243217),
(337642, 'PTHR31194:SF172', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337643, 'PTHR31194:SF67', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF118', 243217),
(337644, 'PTHR31194:SF196', NULL, NULL, NULL, NULL, 'ETHYLENE RESPONSE FACTOR', 243217),
(337645, 'PTHR31194:SF152', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR CRF5-RELATED', 243217),
(337646, 'PTHR31194:SF151', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337647, 'PTHR31194:SF195', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337648, 'PTHR31194:SF59', NULL, NULL, NULL, NULL, 'AP2-EREBP TRANSCRIPTION FACTOR', 243217),
(337649, 'PTHR31194:SF198', NULL, NULL, NULL, NULL, 'AP2/ERF TRANSCRIPTION FACTOR ERF/PTI6-RELATED', 243217),
(337650, 'PTHR31194:SF197', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337651, 'PTHR31194:SF199', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337652, 'PTHR31194:SF113', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337653, 'PTHR31194:SF159', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337654, 'PTHR31194:SF117', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR CRF3-RELATED', 243217),
(337655, 'PTHR31194:SF119', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337656, 'PTHR31194:SF90', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR RAP2-11', 243217),
(337657, 'PTHR31194:SF93', NULL, NULL, NULL, NULL, 'OS06G0181700 PROTEIN', 243217),
(337658, 'PTHR31194:SF95', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337659, 'PTHR31194', NULL, NULL, NULL, NULL, 'SHN  SHINE , DNA BINDING / TRANSCRIPTION FACTOR', 243217),
(337660, 'PTHR31194:SF1', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERN2', 243217),
(337661, 'PTHR31194:SF98', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF120-RELATED', 243217),
(337662, 'PTHR31194:SF161', NULL, NULL, NULL, NULL, 'AP2/ERF TRANSCRIPTION FACTOR ERF/PTI6-RELATED', 243217),
(337663, 'PTHR31194:SF12', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR SHINE 2', 243217),
(337664, 'PTHR31194:SF56', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR CRF6-LIKE', 243217),
(337665, 'PTHR31194:SF160', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 243217),
(337666, 'PTHR34446:SF1', NULL, NULL, NULL, NULL, 'FAMILY WITH SEQUENCE SIMILARITY 220 MEMBER A', 243218),
(337667, 'PTHR34446:SF3', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 10-LIKE PROTEIN 2A-RELATED', 243218),
(337668, 'PTHR34446:SF4', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 10', 243218),
(337669, 'PTHR34446:SF5', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 10-LIKE PROTEIN 1', 243218),
(337670, 'PTHR34446', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 10', 243218),
(337671, 'PTHR13617', NULL, NULL, NULL, NULL, 'PROTEIN ABHD18', 243219),
(337672, 'PTHR13617:SF14', NULL, NULL, NULL, NULL, 'PROTEIN ABHD18', 243219),
(337673, 'PTHR46460:SF1', NULL, NULL, NULL, NULL, 'METHYLATED-DNA--PROTEIN-CYSTEINE METHYLTRANSFERASE', 243220),
(337674, 'PTHR46460', NULL, NULL, NULL, NULL, 'METHYLATED-DNA--PROTEIN-CYSTEINE METHYLTRANSFERASE', 243220),
(337675, 'PTHR28025', NULL, NULL, NULL, NULL, 'DASH COMPLEX SUBUNIT DAD1', 243221),
(337676, 'PTHR28025:SF1', NULL, NULL, NULL, NULL, 'DASH COMPLEX SUBUNIT DAD1', 243221),
(337677, 'PTHR40252:SF2', NULL, NULL, NULL, NULL, 'BLR0328 PROTEIN', 243222),
(337678, 'PTHR40252', NULL, NULL, NULL, NULL, '', 243222),
(337679, 'PTHR15031', NULL, NULL, NULL, NULL, 'CARTILAGE INTERMEDIATE LAYER PROTEIN  CLIP', 243223),
(337680, 'PTHR15031:SF0', NULL, NULL, NULL, NULL, 'CARTILAGE INTERMEDIATE LAYER PROTEIN 2', 243223);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(337681, 'PTHR15031:SF5', NULL, NULL, NULL, NULL, 'CARTILAGE INTERMEDIATE LAYER PROTEIN, NUCLEOTIDE PYROPHOSPHOHYDROLASE', 243223),
(337682, 'PTHR15031:SF6', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 243223),
(337683, 'PTHR15031:SF7', NULL, NULL, NULL, NULL, 'CARTILAGE INTERMEDIATE LAYER PROTEIN 2', 243223),
(337684, 'PTHR15031:SF3', NULL, NULL, NULL, NULL, 'CARTILAGE INTERMEDIATE LAYER PROTEIN 1', 243223),
(337685, 'PTHR15031:SF4', NULL, NULL, NULL, NULL, 'SI:DKEY-205H13.2', 243223),
(337686, 'PTHR23418:SF1', NULL, NULL, NULL, NULL, '1,2-DIHYDROXY-3-KETO-5-METHYLTHIOPENTENE DIOXYGENASE HOMOLOG 2', 243224),
(337687, 'PTHR23418:SF15', NULL, NULL, NULL, NULL, '1,2-DIHYDROXY-3-KETO-5-METHYLTHIOPENTENE DIOXYGENASE', 243224),
(337688, 'PTHR23418', NULL, NULL, NULL, NULL, 'ACIREDUCTONE DIOXYGENASE', 243224),
(337689, 'PTHR23418:SF14', NULL, NULL, NULL, NULL, '1,2-DIHYDROXY-3-KETO-5-METHYLTHIOPENTENE DIOXYGENASE', 243224),
(337690, 'PTHR23418:SF17', NULL, NULL, NULL, NULL, '1,2-DIHYDROXY-3-KETO-5-METHYLTHIOPENTENE DIOXYGENASE 2', 243224),
(337691, 'PTHR23418:SF16', NULL, NULL, NULL, NULL, '1,2-DIHYDROXY-3-KETO-5-METHYLTHIOPENTENE DIOXYGENASE', 243224),
(337692, 'PTHR23418:SF4', NULL, NULL, NULL, NULL, '1,2-DIHYDROXY-3-KETO-5-METHYLTHIOPENTENE DIOXYGENASE 4', 243224),
(337693, 'PTHR23418:SF5', NULL, NULL, NULL, NULL, '1,2-DIHYDROXY-3-KETO-5-METHYLTHIOPENTENE DIOXYGENASE-RELATED', 243224),
(337694, 'PTHR23418:SF10', NULL, NULL, NULL, NULL, '1,2-DIHYDROXY-3-KETO-5-METHYLTHIOPENTENE DIOXYGENASE HOMOLOG 1', 243224),
(337695, 'PTHR23418:SF12', NULL, NULL, NULL, NULL, '1,2-DIHYDROXY-3-KETO-5-METHYLTHIOPENTENE DIOXYGENASE 3', 243224),
(337696, 'PTHR23418:SF0', NULL, NULL, NULL, NULL, '1,2-DIHYDROXY-3-KETO-5-METHYLTHIOPENTENE DIOXYGENASE', 243224),
(337697, 'PTHR10072:SF57', NULL, NULL, NULL, NULL, 'FE-S_BIOSYN DOMAIN-CONTAINING PROTEIN', 243225),
(337698, 'PTHR10072', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER ASSEMBLY PROTEIN', 243225),
(337699, 'PTHR10072:SF58', NULL, NULL, NULL, NULL, 'IRON-SULFUR ASSEMBLY PROTEIN ISCA-LIKE 1, MITOCHONDRIAL', 243225),
(337700, 'PTHR10072:SF47', NULL, NULL, NULL, NULL, 'PROTEIN SUFA', 243225),
(337701, 'PTHR10072:SF60', NULL, NULL, NULL, NULL, 'IRON-SULFUR ASSEMBLY PROTEIN ISCA-LIKE 3, MITOCHONDRIAL', 243225),
(337702, 'PTHR10072:SF51', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 243225),
(337703, 'PTHR10072:SF41', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER ASSEMBLY 1 HOMOLOG, MITOCHONDRIAL', 243225),
(337704, 'PTHR43161:SF25', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G14390)-RELATED', 243226),
(337705, 'PTHR43161:SF24', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 243226),
(337706, 'PTHR43161:SF13', NULL, NULL, NULL, NULL, 'L-ARABINITOL 4-DEHYDROGENASE (AFU_ORTHOLOGUE AFUA_1G11020)', 243226),
(337707, 'PTHR43161:SF17', NULL, NULL, NULL, NULL, 'L-IDONATE 5-DEHYDROGENASE', 243226),
(337708, 'PTHR43161:SF7', NULL, NULL, NULL, NULL, 'SORBITOL DEHYDROGENASE', 243226),
(337709, 'PTHR43161', NULL, NULL, NULL, NULL, 'SORBITOL DEHYDROGENASE', 243226),
(337710, 'PTHR43161:SF9', NULL, NULL, NULL, NULL, 'SORBITOL DEHYDROGENASE', 243226),
(337711, 'PTHR43161:SF3', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G02000)-RELATED', 243226),
(337712, 'PTHR43161:SF4', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G01490)-RELATED', 243226),
(337713, 'PTHR43161:SF12', NULL, NULL, NULL, NULL, 'L-ARABINITOL 4-DEHYDROGENASE', 243226),
(337714, 'PTHR43161:SF23', NULL, NULL, NULL, NULL, '(R,R)-BUTANEDIOL DEHYDROGENASE-RELATED', 243226),
(337715, 'PTHR43161:SF11', NULL, NULL, NULL, NULL, 'STARVATION-SENSING PROTEIN RSPB', 243226),
(337716, 'PTHR33872:SF14', NULL, NULL, NULL, NULL, '', 243227),
(337717, 'PTHR33872:SF13', NULL, NULL, NULL, NULL, 'BNAC03G47950D PROTEIN', 243227),
(337718, 'PTHR33872:SF11', NULL, NULL, NULL, NULL, '', 243227),
(337719, 'PTHR33872:SF8', NULL, NULL, NULL, NULL, 'ST225', 243227),
(337720, 'PTHR33872:SF16', NULL, NULL, NULL, NULL, 'ST225', 243227);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(337721, 'PTHR33872:SF7', NULL, NULL, NULL, NULL, 'OSJNBA0084K11.10-LIKE PROTEIN', 243227),
(337722, 'PTHR33872:SF4', NULL, NULL, NULL, NULL, '', 243227),
(337723, 'PTHR33872:SF2', NULL, NULL, NULL, NULL, 'DNA POLYMERASE EPSILON CATALYTIC SUBUNIT A', 243227),
(337724, 'PTHR33872', NULL, NULL, NULL, NULL, 'DNA POLYMERASE EPSILON CATALYTIC SUBUNIT A', 243227),
(337725, 'PTHR31888', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 19', 243228),
(337726, 'PTHR31888:SF1', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 19', 243228),
(337727, 'PTHR37884', NULL, NULL, NULL, NULL, 'SEPTIN 4', 243229),
(337728, 'PTHR37884:SF1', NULL, NULL, NULL, NULL, 'SEPTIN 4', 243229),
(337729, 'PTHR43611', NULL, NULL, NULL, NULL, 'ALPHA-D-GLUCOSE 1-PHOSPHATE PHOSPHATASE', 243230),
(337730, 'PTHR43611:SF3', NULL, NULL, NULL, NULL, 'FLAVIN MONONUCLEOTIDE HYDROLASE 1, CHLOROPLATIC', 243230),
(337731, 'PTHR44229:SF2', NULL, NULL, NULL, NULL, '15-HYDROXYPROSTAGLANDIN DEHYDROGENASE', 243231),
(337732, 'PTHR44229:SF5', NULL, NULL, NULL, NULL, 'ZGC:56585', 243231),
(337733, 'PTHR44229', NULL, NULL, NULL, NULL, '15-HYDROXYPROSTAGLANDIN DEHYDROGENASE [NAD(+)]', 243231),
(337734, 'PTHR44229:SF4', NULL, NULL, NULL, NULL, '15-HYDROXYPROSTAGLANDIN DEHYDROGENASE [NAD(+)]', 243231),
(337735, 'PTHR44229:SF8', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE-RELATED', 243231),
(337736, 'PTHR11959:SF6', NULL, NULL, NULL, NULL, '', 243232),
(337737, 'PTHR11959', NULL, NULL, NULL, NULL, '4-HYDROXYPHENYLPYRUVATE DIOXYGENASE', 243232),
(337738, 'PTHR11959:SF7', NULL, NULL, NULL, NULL, 'PHYTOENE DESATURATION 1', 243232),
(337739, 'PTHR11959:SF15', NULL, NULL, NULL, NULL, '4-HYDROXYPHENYLPYRUVATE DIOXYGENASE-RELATED', 243232),
(337740, 'PTHR11959:SF13', NULL, NULL, NULL, NULL, '4-HYDROXYPHENYLPYRUVATE DIOXYGENASE', 243232),
(337741, 'PTHR11959:SF14', NULL, NULL, NULL, NULL, '4-HYDROXYPHENYLPYRUVATE DIOXYGENASE', 243232),
(337742, 'PTHR11959:SF11', NULL, NULL, NULL, NULL, '4-HYDROXYPHENYLPYRUVATE DIOXYGENASE', 243232),
(337743, 'PTHR11959:SF1', NULL, NULL, NULL, NULL, '4-HYDROXYPHENYLPYRUVATE DIOXYGENASE', 243232),
(337744, 'PTHR11959:SF12', NULL, NULL, NULL, NULL, '4-HYDROXYPHENYLPYRUVATE DIOXYGENASE', 243232),
(337745, 'PTHR11959:SF10', NULL, NULL, NULL, NULL, '4-HYDROXYPHENYLPYRUVATE DIOXYGENASE-LIKE PROTEIN', 243232),
(337746, 'PTHR11959:SF3', NULL, NULL, NULL, NULL, 'PROTEIN C31H2.4-RELATED', 243232),
(337747, 'PTHR36058:SF1', NULL, NULL, NULL, NULL, 'NUCLEOPHOSMIN', 243233),
(337748, 'PTHR36058', NULL, NULL, NULL, NULL, 'NUCLEOPHOSMIN', 243233),
(337749, 'PTHR36058:SF3', NULL, NULL, NULL, NULL, 'SAPOSIN B-TYPE DOMAIN-CONTAINING PROTEIN', 243233),
(337750, 'PTHR47274:SF5', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 243234),
(337751, 'PTHR47274:SF6', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 243234),
(337752, 'PTHR47274:SF3', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 243234),
(337753, 'PTHR47274:SF4', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 243234),
(337754, 'PTHR47274:SF1', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN CONTAINING PROTEIN, EXPRESSED', 243234),
(337755, 'PTHR47274:SF11', NULL, NULL, NULL, NULL, 'BNAA04G21030D PROTEIN', 243234),
(337756, 'PTHR47274:SF10', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 243234),
(337757, 'PTHR47274:SF9', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 243234),
(337758, 'PTHR47274:SF7', NULL, NULL, NULL, NULL, 'BNAA03G54520D PROTEIN', 243234),
(337759, 'PTHR47274:SF8', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 243234),
(337760, 'PTHR47274', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN CONTAINING PROTEIN, EXPRESSED-RELATED', 243234),
(337761, 'PTHR47274:SF13', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 243234),
(337762, 'PTHR47274:SF12', NULL, NULL, NULL, NULL, 'BNAC06G15820D PROTEIN', 243234),
(337763, 'PTHR47274:SF15', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 243234),
(337764, 'PTHR47274:SF17', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 243234);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(337765, 'PTHR47274:SF16', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 243234),
(337766, 'PTHR47274:SF19', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 243234),
(337767, 'PTHR47274:SF18', NULL, NULL, NULL, NULL, 'DOMAIN-CONTAINING PROTEIN, PUTATIVE ISOFORM 1-RELATED', 243234),
(337768, 'PTHR37412', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN 5', 243235),
(337769, 'PTHR37412:SF2', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN 5', 243235),
(337770, 'PTHR46428', NULL, NULL, NULL, NULL, 'KELCH DOMAIN-CONTAINING PROTEIN 10', 243236),
(337771, 'PTHR46428:SF1', NULL, NULL, NULL, NULL, 'KELCH DOMAIN-CONTAINING PROTEIN 10', 243236),
(337772, 'PTHR16270', NULL, NULL, NULL, NULL, 'HYPOTHETICAL LOC287798', 243237),
(337773, 'PTHR16270:SF5', NULL, NULL, NULL, NULL, 'HYPOTHETICAL LOC287798', 243237),
(337774, 'PTHR33191', NULL, NULL, NULL, NULL, 'RIPENING-RELATED PROTEIN 2-RELATED', 243238),
(337775, 'PTHR33191:SF44', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 243238),
(337776, 'PTHR33191:SF66', NULL, NULL, NULL, NULL, '', 243238),
(337777, 'PTHR33191:SF64', NULL, NULL, NULL, NULL, '', 243238),
(337778, 'PTHR33191:SF21', NULL, NULL, NULL, NULL, '', 243238),
(337779, 'PTHR33191:SF26', NULL, NULL, NULL, NULL, '', 243238),
(337780, 'PTHR33191:SF27', NULL, NULL, NULL, NULL, 'RIPENING-RELATED PROTEIN 3', 243238),
(337781, 'PTHR33191:SF46', NULL, NULL, NULL, NULL, 'RLPA-LIKE DOUBLE-PSI BETA-BARREL DOMAIN-CONTAINING PROTEIN-RELATED', 243238),
(337782, 'PTHR33191:SF68', NULL, NULL, NULL, NULL, '', 243238),
(337783, 'PTHR33191:SF24', NULL, NULL, NULL, NULL, 'RIPENING-RELATED PROTEIN 1-RELATED', 243238),
(337784, 'PTHR33191:SF80', NULL, NULL, NULL, NULL, 'RIPENING-RELATED PROTEIN 6-RELATED', 243238),
(337785, 'PTHR33191:SF81', NULL, NULL, NULL, NULL, '', 243238),
(337786, 'PTHR33191:SF9', NULL, NULL, NULL, NULL, 'RIPENING-RELATED PROTEIN 2-RELATED', 243238),
(337787, 'PTHR33191:SF84', NULL, NULL, NULL, NULL, 'RLPA-LIKE DOUBLE-PSI BETA-BARREL DOMAIN-CONTAINING PROTEIN-RELATED', 243238),
(337788, 'PTHR33191:SF40', NULL, NULL, NULL, NULL, 'RIPENING-RELATED PROTEIN 2-RELATED', 243238),
(337789, 'PTHR33191:SF63', NULL, NULL, NULL, NULL, 'RLPA-LIKE DOUBLE-PSI BETA-BARREL DOMAIN-CONTAINING PROTEIN-RELATED', 243238),
(337790, 'PTHR33191:SF60', NULL, NULL, NULL, NULL, 'KIWELLIN', 243238),
(337791, 'PTHR33191:SF82', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 243238),
(337792, 'PTHR33191:SF83', NULL, NULL, NULL, NULL, 'RIPENING-RELATED PROTEIN 1-RELATED', 243238),
(337793, 'PTHR33191:SF19', NULL, NULL, NULL, NULL, 'RIPENING-RELATED PROTEIN GRIP22', 243238),
(337794, 'PTHR33191:SF77', NULL, NULL, NULL, NULL, 'RIPENING-RELATED PROTEIN 1-RELATED', 243238),
(337795, 'PTHR33191:SF56', NULL, NULL, NULL, NULL, 'RIPENING-RELATED PROTEIN 7-RELATED', 243238),
(337796, 'PTHR33191:SF78', NULL, NULL, NULL, NULL, '', 243238),
(337797, 'PTHR33191:SF53', NULL, NULL, NULL, NULL, 'KIWELLIN', 243238),
(337798, 'PTHR33191:SF32', NULL, NULL, NULL, NULL, 'KIWELLIN-LIKE', 243238),
(337799, 'PTHR33191:SF76', NULL, NULL, NULL, NULL, 'RIPENING-RELATED PROTEIN 5-RELATED', 243238),
(337800, 'PTHR33191:SF79', NULL, NULL, NULL, NULL, 'RIPENING-RELATED PROTEIN 3', 243238),
(337801, 'PTHR33191:SF57', NULL, NULL, NULL, NULL, '', 243238),
(337802, 'PTHR33191:SF36', NULL, NULL, NULL, NULL, '', 243238),
(337803, 'PTHR33191:SF58', NULL, NULL, NULL, NULL, 'LIPID TRANSFER PROTEIN', 243238),
(337804, 'PTHR33191:SF51', NULL, NULL, NULL, NULL, '', 243238),
(337805, 'PTHR33191:SF30', NULL, NULL, NULL, NULL, '', 243238),
(337806, 'PTHR33191:SF74', NULL, NULL, NULL, NULL, 'RIPENING RELATED PROTEIN FAMILY', 243238),
(337807, 'PTHR33191:SF71', NULL, NULL, NULL, NULL, 'RIPENING-RELATED PROTEIN 4-RELATED', 243238),
(337808, 'PTHR33191:SF50', NULL, NULL, NULL, NULL, '', 243238),
(337809, 'PTHR13780:SF107', NULL, NULL, NULL, NULL, 'CBS DOMAIN-CONTAINING PROTEIN', 243239),
(337810, 'PTHR13780:SF106', NULL, NULL, NULL, NULL, 'CBS/OCTICOSAPEPTIDE/PHOX/BEMP1 (PB1) DOMAIN PROTEIN', 243239),
(337811, 'PTHR13780:SF25', NULL, NULL, NULL, NULL, '', 243239);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(337812, 'PTHR13780', NULL, NULL, NULL, NULL, 'AMP-ACTIVATED PROTEIN KINASE, GAMMA REGULATORY SUBUNIT', 243239),
(337813, 'PTHR13780:SF24', NULL, NULL, NULL, NULL, '', 243239),
(337814, 'PTHR13780:SF109', NULL, NULL, NULL, NULL, 'OS01G0961200 PROTEIN', 243239),
(337815, 'PTHR13780:SF143', NULL, NULL, NULL, NULL, 'BNACNNG50100D PROTEIN', 243239),
(337816, 'PTHR13780:SF148', NULL, NULL, NULL, NULL, '', 243239),
(337817, 'PTHR13780:SF104', NULL, NULL, NULL, NULL, 'CBS/OCTICOSAPEPTIDE/PHOX/BEMP1 (PB1) DOMAIN PROTEIN', 243239),
(337818, 'PTHR13780:SF102', NULL, NULL, NULL, NULL, 'SNF1-RELATED PROTEIN KINASE REGULATORY SUBUNIT GAMMA-LIKE PV42B', 243239),
(337819, 'PTHR13780:SF146', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 243239),
(337820, 'PTHR13780:SF101', NULL, NULL, NULL, NULL, 'SNF1-RELATED PROTEIN KINASE REGULATORY SUBUNIT GAMMA-LIKE PV42A', 243239),
(337821, 'PTHR13780:SF145', NULL, NULL, NULL, NULL, 'SNF1-RELATED PROTEIN KINASE REGULATORY SUBUNIT GAMMA 1-RELATED', 243239),
(337822, 'PTHR13780:SF21', NULL, NULL, NULL, NULL, '', 243239),
(337823, 'PTHR13780:SF118', NULL, NULL, NULL, NULL, 'CBS DOMAIN, IMMUNOGLOBULIN E-SET-RELATED', 243239),
(337824, 'PTHR13780:SF116', NULL, NULL, NULL, NULL, 'CBS DOMAIN-CONTAINING PROTEIN CBSCBSPB3', 243239),
(337825, 'PTHR13780:SF57', NULL, NULL, NULL, NULL, 'OS08G0529200 PROTEIN', 243239),
(337826, 'PTHR13780:SF19', NULL, NULL, NULL, NULL, 'AMP-ACTIVATED PROTEIN KINASE GAMMA SUBUNIT', 243239),
(337827, 'PTHR13780:SF18', NULL, NULL, NULL, NULL, '', 243239),
(337828, 'PTHR13780:SF155', NULL, NULL, NULL, NULL, '', 243239),
(337829, 'PTHR13780:SF154', NULL, NULL, NULL, NULL, 'BNAC08G42850D PROTEIN', 243239),
(337830, 'PTHR13780:SF153', NULL, NULL, NULL, NULL, '', 243239),
(337831, 'PTHR13780:SF159', NULL, NULL, NULL, NULL, 'CBS DOMAIN-CONTAINING PROTEIN CBSX5', 243239),
(337832, 'PTHR13780:SF114', NULL, NULL, NULL, NULL, 'DOMAIN-CONTAINING PROTEIN, PUTATIVE, EXPRESSED-RELATED', 243239),
(337833, 'PTHR13780:SF158', NULL, NULL, NULL, NULL, 'CBS DOMAIN CONTAINING PROTEIN', 243239),
(337834, 'PTHR13780:SF157', NULL, NULL, NULL, NULL, 'AMP-ACTIVATED PROTEIN KINASE GAMMA SUBUNIT', 243239),
(337835, 'PTHR13780:SF112', NULL, NULL, NULL, NULL, 'AKINBETAGAMMA', 243239),
(337836, 'PTHR13780:SF156', NULL, NULL, NULL, NULL, '', 243239),
(337837, 'PTHR13780:SF162', NULL, NULL, NULL, NULL, 'CBS', 243239),
(337838, 'PTHR13780:SF161', NULL, NULL, NULL, NULL, 'CBS / OCTICOSAPEPTIDE/PHOX/BEMP1 (PB1) DOMAINS-CONTAINING PROTEIN-RELATED', 243239),
(337839, 'PTHR13780:SF160', NULL, NULL, NULL, NULL, 'CBS DOMAIN-CONTAINING PROTEIN CBSCBSPB4-RELATED', 243239),
(337840, 'PTHR13780:SF99', NULL, NULL, NULL, NULL, 'AMP-ACTIVATED PROTEIN KINASE GAMMA SUBUNIT', 243239),
(337841, 'PTHR13780:SF56', NULL, NULL, NULL, NULL, 'CBS DOMAIN-CONTAINING PROTEIN CBSX5', 243239),
(337842, 'PTHR13780:SF93', NULL, NULL, NULL, NULL, 'OJ1485_B09.7 PROTEIN', 243239),
(337843, 'PTHR13780:SF96', NULL, NULL, NULL, NULL, '', 243239),
(337844, 'PTHR13780:SF48', NULL, NULL, NULL, NULL, 'CBS DOMAIN-CONTAINING PROTEIN CBSCBSPB1', 243239),
(337845, 'PTHR13780:SF47', NULL, NULL, NULL, NULL, 'SNF1-RELATED PROTEIN KINASE REGULATORY SUBUNIT GAMMA-1-LIKE', 243239),
(337846, 'PTHR13780:SF128', NULL, NULL, NULL, NULL, 'CBS DOMAIN-CONTAINING PROTEIN', 243239),
(337847, 'PTHR13780:SF46', NULL, NULL, NULL, NULL, 'CBS DOMAIN-CONTAINING PROTEIN CBSX6', 243239),
(337848, 'PTHR13780:SF122', NULL, NULL, NULL, NULL, '5''-AMP-ACTIVATED PROTEIN KINASE SUBUNIT GAMMA-2', 243239),
(337849, 'PTHR13780:SF126', NULL, NULL, NULL, NULL, 'BNAA02G10090D PROTEIN', 243239),
(337850, 'PTHR13780:SF125', NULL, NULL, NULL, NULL, 'MEIOTICALLY UP-REGULATED GENE 70 PROTEIN', 243239),
(337851, 'PTHR13780:SF124', NULL, NULL, NULL, NULL, 'OS01G0633400 PROTEIN', 243239),
(337852, 'PTHR13780:SF41', NULL, NULL, NULL, NULL, 'PROTEIN KINASE, AMP-ACTIVATED, GAMMA 3A NON-CATALYTIC SUBUNIT', 243239),
(337853, 'PTHR13780:SF38', NULL, NULL, NULL, NULL, '5''-AMP-ACTIVATED PROTEIN KINASE SUBUNIT GAMMA-1', 243239),
(337854, 'PTHR13780:SF36', NULL, NULL, NULL, NULL, 'PROTEIN SDS23-RELATED', 243239);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(337855, 'PTHR13780:SF35', NULL, NULL, NULL, NULL, 'LD22662P', 243239),
(337856, 'PTHR13780:SF138', NULL, NULL, NULL, NULL, 'BNAA06G16460D PROTEIN', 243239),
(337857, 'PTHR13780:SF39', NULL, NULL, NULL, NULL, 'CBS', 243239),
(337858, 'PTHR13780:SF133', NULL, NULL, NULL, NULL, 'BNAANNG21130D PROTEIN', 243239),
(337859, 'PTHR13780:SF132', NULL, NULL, NULL, NULL, 'CYSTATHIONINE BETA-SYNTHASE (CBS) FAMILY PROTEIN-RELATED', 243239),
(337860, 'PTHR13780:SF131', NULL, NULL, NULL, NULL, 'AMP-ACTIVATED PROTEIN KINASE, GAMMA REGULATORY SUBUNIT', 243239),
(337861, 'PTHR13780:SF130', NULL, NULL, NULL, NULL, 'PB1 DOMAIN, CBS DOMAIN PROTEIN-RELATED', 243239),
(337862, 'PTHR13780:SF136', NULL, NULL, NULL, NULL, 'BNAANNG38820D PROTEIN', 243239),
(337863, 'PTHR13780:SF135', NULL, NULL, NULL, NULL, 'CBS DOMAIN-CONTAINING PROTEIN-RELATED', 243239),
(337864, 'PTHR13780:SF140', NULL, NULL, NULL, NULL, 'BNAC02G42530D PROTEIN', 243239),
(337865, 'PTHR13780:SF34', NULL, NULL, NULL, NULL, '', 243239),
(337866, 'PTHR13780:SF32', NULL, NULL, NULL, NULL, 'AMP-ACTIVATED PROTEIN KINASE GAMMA SUBUNIT', 243239),
(337867, 'PTHR13780:SF31', NULL, NULL, NULL, NULL, '5''-AMP-ACTIVATED PROTEIN KINASE SUBUNIT GAMMA-3', 243239),
(337868, 'PTHR23061', NULL, NULL, NULL, NULL, 'DNA POLYMERASE 2 ALPHA 70 KDA SUBUNIT', 243240),
(337869, 'PTHR23061:SF12', NULL, NULL, NULL, NULL, 'DNA POLYMERASE ALPHA SUBUNIT B', 243240),
(337870, 'PTHR38772', NULL, NULL, NULL, NULL, '', 243241),
(337871, 'PTHR38772:SF1', NULL, NULL, NULL, NULL, 'NUCLEOID-ASSOCIATED PROTEIN YEJK', 243241),
(337872, 'PTHR37460:SF1', NULL, NULL, NULL, NULL, 'ENDONUCLEASE III', 243242),
(337873, 'PTHR37460', NULL, NULL, NULL, NULL, 'ENDONUCLEASE III', 243242),
(337874, 'PTHR15020:SF42', NULL, NULL, NULL, NULL, 'NAD(P)-BD_DOM DOMAIN-CONTAINING PROTEIN', 243243),
(337875, 'PTHR15020', NULL, NULL, NULL, NULL, 'FLAVIN REDUCTASE-RELATED', 243243),
(337876, 'PTHR15020:SF49', NULL, NULL, NULL, NULL, 'NAD(P)-BD_DOM DOMAIN-CONTAINING PROTEIN', 243243),
(337877, 'PTHR15020:SF48', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 243243),
(337878, 'PTHR15020:SF37', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE MDPK', 243243),
(337879, 'PTHR15020:SF47', NULL, NULL, NULL, NULL, '', 243243),
(337880, 'PTHR15020:SF45', NULL, NULL, NULL, NULL, 'NAD(P)-BD_DOM DOMAIN-CONTAINING PROTEIN', 243243),
(337881, 'PTHR15020:SF11', NULL, NULL, NULL, NULL, 'UPF0659 PROTEIN YMR090W', 243243),
(337882, 'PTHR15020:SF43', NULL, NULL, NULL, NULL, 'NAD(P)-BD_DOM DOMAIN-CONTAINING PROTEIN', 243243),
(337883, 'PTHR12429', NULL, NULL, NULL, NULL, 'NEURALIZED', 243244),
(337884, 'PTHR12429:SF35', NULL, NULL, NULL, NULL, 'CI-NEURALIZED-B PROTEIN', 243244),
(337885, 'PTHR12429:SF13', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE NEURL1', 243244),
(337886, 'PTHR12429:SF10', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE NEURL1B', 243244),
(337887, 'PTHR12429:SF14', NULL, NULL, NULL, NULL, 'NEURALIZED-LIKE PROTEIN 4', 243244),
(337888, 'PTHR12429:SF9', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE NEURL3', 243244),
(337889, 'PTHR12429:SF8', NULL, NULL, NULL, NULL, 'NEURALIZED-LIKE PROTEIN 2', 243244),
(337890, 'PTHR12429:SF6', NULL, NULL, NULL, NULL, 'PROTEIN NEURALIZED', 243244),
(337891, 'PTHR22970:SF14', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 2', 243245),
(337892, 'PTHR22970', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 2', 243245),
(337893, 'PTHR21592:SF28', NULL, NULL, NULL, NULL, 'PROTEIN CBG14943', 243246),
(337894, 'PTHR21592:SF32', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR', 243246),
(337895, 'PTHR21592', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243246),
(337896, 'PTHR21592:SF8', NULL, NULL, NULL, NULL, 'TIMM-23', 243246),
(337897, 'PTHR21592:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG20831', 243246),
(337898, 'PTHR21592:SF4', NULL, NULL, NULL, NULL, 'MATH (MEPRIN-ASSOCIATED TRAF HOMOLOGY) DOMAIN CONTAINING', 243246),
(337899, 'PTHR21592:SF33', NULL, NULL, NULL, NULL, 'PROTEIN CBG03732', 243246);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(337900, 'PTHR21592:SF12', NULL, NULL, NULL, NULL, 'C3H1-TYPE DOMAIN-CONTAINING PROTEIN', 243246),
(337901, 'PTHR21592:SF23', NULL, NULL, NULL, NULL, 'PROTEIN CBG12311', 243246),
(337902, 'PTHR17416', NULL, NULL, NULL, NULL, 'SMALL MUSCULAR PROTEIN', 243247),
(337903, 'PTHR17416:SF0', NULL, NULL, NULL, NULL, 'SMALL MUSCULAR PROTEIN', 243247),
(337904, 'PTHR43272:SF22', NULL, NULL, NULL, NULL, 'LONG-CHAIN-FATTY-ACID--COA LIGASE 4', 243248),
(337905, 'PTHR43272:SF43', NULL, NULL, NULL, NULL, 'FATTY ACID COA SYNTHETASE FAMILY', 243248),
(337906, 'PTHR43272:SF87', NULL, NULL, NULL, NULL, 'AMP-BINDING DOMAIN-CONTAINING PROTEIN', 243248),
(337907, 'PTHR43272:SF65', NULL, NULL, NULL, NULL, 'AMP-DEPENDENT SYNTHETASE AND LIGASE FAMILY PROTEIN-RELATED', 243248),
(337908, 'PTHR43272:SF89', NULL, NULL, NULL, NULL, 'AMP-BINDING DOMAIN-CONTAINING PROTEIN', 243248),
(337909, 'PTHR43272:SF45', NULL, NULL, NULL, NULL, 'LONG CHAIN ACYL-COA SYNTHETASE 6 PEROXISOMAL', 243248),
(337910, 'PTHR43272:SF83', NULL, NULL, NULL, NULL, 'ACYL-COA SYNTHETASE LONG-CHAIN, ISOFORM J', 243248),
(337911, 'PTHR43272:SF86', NULL, NULL, NULL, NULL, 'LONG-CHAIN-FATTY-ACID--COA LIGASE 2', 243248),
(337912, 'PTHR43272:SF42', NULL, NULL, NULL, NULL, 'LONG CHAIN ACYL-COA SYNTHETASE 3', 243248),
(337913, 'PTHR43272:SF63', NULL, NULL, NULL, NULL, 'LONG CHAIN ACYL-COA SYNTHETASE 9 CHLOROPLASTIC', 243248),
(337914, 'PTHR43272:SF80', NULL, NULL, NULL, NULL, 'AMP-BINDING DOMAIN-CONTAINING PROTEIN', 243248),
(337915, 'PTHR43272', NULL, NULL, NULL, NULL, 'LONG-CHAIN-FATTY-ACID--COA LIGASE', 243248),
(337916, 'PTHR43272:SF82', NULL, NULL, NULL, NULL, 'BACTERIAL LONG-CHAIN FATTY ACID COA SYNTHETASE', 243248),
(337917, 'PTHR43272:SF69', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA SYNTHETASE A', 243248),
(337918, 'PTHR43272:SF28', NULL, NULL, NULL, NULL, 'LONG-CHAIN-FATTY-ACID--COA LIGASE 1', 243248),
(337919, 'PTHR43272:SF55', NULL, NULL, NULL, NULL, 'LONG CHAIN ACYL-COA SYNTHETASE 5', 243248),
(337920, 'PTHR43272:SF33', NULL, NULL, NULL, NULL, 'LONG CHAIN ACYL-COA SYNTHETASE 6, PEROXISOMAL', 243248),
(337921, 'PTHR43272:SF77', NULL, NULL, NULL, NULL, 'AMP-DEPENDENT SYNTHETASE/LIGASE-RELATED', 243248),
(337922, 'PTHR43272:SF11', NULL, NULL, NULL, NULL, 'AMP-BINDING DOMAIN-CONTAINING PROTEIN', 243248),
(337923, 'PTHR43272:SF99', NULL, NULL, NULL, NULL, 'FATTY ACYL COA SYNTETASE 1', 243248),
(337924, 'PTHR43272:SF98', NULL, NULL, NULL, NULL, 'LONG-CHAIN FATTY ACYL COA LIGASE', 243248),
(337925, 'PTHR43272:SF32', NULL, NULL, NULL, NULL, 'AMP-BINDING DOMAIN-CONTAINING PROTEIN', 243248),
(337926, 'PTHR43272:SF54', NULL, NULL, NULL, NULL, 'LONG-CHAIN-FATTY-ACID--COA LIGASE 6', 243248),
(337927, 'PTHR43272:SF79', NULL, NULL, NULL, NULL, 'OS06G0158000 PROTEIN', 243248),
(337928, 'PTHR43272:SF13', NULL, NULL, NULL, NULL, 'LONG-CHAIN-FATTY-ACID--COA LIGASE 3', 243248),
(337929, 'PTHR43272:SF4', NULL, NULL, NULL, NULL, 'LONG CHAIN ACYL-COA SYNTHETASE 2', 243248),
(337930, 'PTHR43272:SF3', NULL, NULL, NULL, NULL, 'LONG-CHAIN-FATTY-ACID--COA LIGASE 5', 243248),
(337931, 'PTHR43272:SF95', NULL, NULL, NULL, NULL, 'AMP-BINDING DOMAIN-CONTAINING PROTEIN', 243248),
(337932, 'PTHR43272:SF73', NULL, NULL, NULL, NULL, 'AMP-BINDING DOMAIN-CONTAINING PROTEIN', 243248),
(337933, 'PTHR43272:SF94', NULL, NULL, NULL, NULL, 'LONG-CHAIN FATTY ACYL COA LIGASE', 243248),
(337934, 'PTHR43272:SF97', NULL, NULL, NULL, NULL, 'LONG-CHAIN-FATTY-ACID--COA LIGASE 2', 243248),
(337935, 'PTHR43272:SF104', NULL, NULL, NULL, NULL, 'FATTY ACID COA SYNTHETASE FAMILY', 243248),
(337936, 'PTHR43272:SF52', NULL, NULL, NULL, NULL, 'AMP-BINDING DOMAIN-CONTAINING PROTEIN', 243248),
(337937, 'PTHR43272:SF96', NULL, NULL, NULL, NULL, 'ACYL-COA SYNTHETASE LONG CHAIN FAMILY MEMBER 3A', 243248),
(337938, 'PTHR43272:SF103', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE', 243248),
(337939, 'PTHR43272:SF91', NULL, NULL, NULL, NULL, '', 243248),
(337940, 'PTHR43272:SF102', NULL, NULL, NULL, NULL, 'LONG CHAIN ACYL-COA SYNTHETASE 5', 243248),
(337941, 'PTHR43272:SF90', NULL, NULL, NULL, NULL, 'LONG CHAIN ACYL-COA SYNTHETASE 7, PEROXISOMAL', 243248);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(337942, 'PTHR43272:SF101', NULL, NULL, NULL, NULL, 'LONG-CHAIN-FATTY-ACID--COA LIGASE ACSBG2', 243248),
(337943, 'PTHR43272:SF93', NULL, NULL, NULL, NULL, 'ACYL-COA SYNTHETASE BUBBLEGUM FAMILY MEMBER 1', 243248),
(337944, 'PTHR43272:SF92', NULL, NULL, NULL, NULL, 'LONG CHAIN ACYL-COA SYNTHETASE 8', 243248),
(337945, 'PTHR43272:SF70', NULL, NULL, NULL, NULL, 'BNAC07G50530D PROTEIN', 243248),
(337946, 'PTHR43272:SF100', NULL, NULL, NULL, NULL, 'ACYL COA SYNTHETASE, PUTATIVE-RELATED', 243248),
(337947, 'PTHR43272:SF6', NULL, NULL, NULL, NULL, 'LONG CHAIN ACYL-COA SYNTHETASE 1', 243248),
(337948, 'PTHR43272:SF7', NULL, NULL, NULL, NULL, 'AMP-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 243248),
(337949, 'PTHR43272:SF36', NULL, NULL, NULL, NULL, 'ACYL-COA SYNTHETASE LONG CHAIN FAMILY MEMBER 2', 243248),
(337950, 'PTHR43272:SF58', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE', 243248),
(337951, 'PTHR48235:SF1', NULL, NULL, NULL, NULL, 'OS01G0916700 PROTEIN', 243249),
(337952, 'PTHR48235', NULL, NULL, NULL, NULL, 'OS01G0916700 PROTEIN', 243249),
(337953, 'PTHR35117:SF4', NULL, NULL, NULL, NULL, 'MYOSIN-M HEAVY PROTEIN', 243250),
(337954, 'PTHR35117:SF3', NULL, NULL, NULL, NULL, '', 243250),
(337955, 'PTHR35117', NULL, NULL, NULL, NULL, 'MYOSIN-M HEAVY PROTEIN', 243250),
(337956, 'PTHR35117:SF1', NULL, NULL, NULL, NULL, 'MYOSIN-M HEAVY PROTEIN', 243250),
(337957, 'PTHR40517', NULL, NULL, NULL, NULL, 'METAL-DEPENDENT PHOSPHOHYDROLASE, HD SUPERFAMILY-RELATED', 243251),
(337958, 'PTHR40517:SF1', NULL, NULL, NULL, NULL, 'METAL-DEPENDENT PHOSPHOHYDROLASE, HD SUPERFAMILY-RELATED', 243251),
(337959, 'PTHR37994:SF1', NULL, NULL, NULL, NULL, 'YALI0C01694P', 243252),
(337960, 'PTHR37994:SF4', NULL, NULL, NULL, NULL, 'ARAE_2_N DOMAIN-CONTAINING PROTEIN', 243252),
(337961, 'PTHR37994', NULL, NULL, NULL, NULL, 'ARAE_2_N DOMAIN-CONTAINING PROTEIN-RELATED', 243252),
(337962, 'PTHR37994:SF3', NULL, NULL, NULL, NULL, 'ARAE_2_N DOMAIN-CONTAINING PROTEIN', 243252),
(337963, 'PTHR45968:SF20', NULL, NULL, NULL, NULL, 'PROTEIN HOTHEAD-LIKE ISOFORM X1', 243253),
(337964, 'PTHR45968:SF15', NULL, NULL, NULL, NULL, 'PROTEIN HOTHEAD-LIKE ISOFORM X1', 243253),
(337965, 'PTHR45968:SF14', NULL, NULL, NULL, NULL, 'OS02G0678300 PROTEIN', 243253),
(337966, 'PTHR45968:SF17', NULL, NULL, NULL, NULL, 'PROTEIN HOTHEAD-LIKE ISOFORM X1', 243253),
(337967, 'PTHR45968:SF16', NULL, NULL, NULL, NULL, 'GMC_OXRDTASE_N DOMAIN-CONTAINING PROTEIN', 243253),
(337968, 'PTHR45968:SF33', NULL, NULL, NULL, NULL, 'LONG-CHAIN-ALCOHOL OXIDASE, FAD/NAD(P)-BINDING DOMAIN PROTEIN-RELATED', 243253),
(337969, 'PTHR45968:SF32', NULL, NULL, NULL, NULL, 'BNACNNG55990D PROTEIN', 243253),
(337970, 'PTHR45968:SF10', NULL, NULL, NULL, NULL, 'OS03G0118700 PROTEIN', 243253),
(337971, 'PTHR45968:SF34', NULL, NULL, NULL, NULL, 'GMC_OXRDTASE_N DOMAIN-CONTAINING PROTEIN', 243253),
(337972, 'PTHR45968:SF12', NULL, NULL, NULL, NULL, 'GLUCOSE-METHANOL-CHOLINE (GMC) OXIDOREDUCTASE FAMILY PROTEIN', 243253),
(337973, 'PTHR45968:SF19', NULL, NULL, NULL, NULL, 'GLUCOSE-METHANOL-CHOLINE (GMC) OXIDOREDUCTASE FAMILY PROTEIN', 243253),
(337974, 'PTHR45968:SF18', NULL, NULL, NULL, NULL, 'GLUCOSE-METHANOL-CHOLINE (GMC) OXIDOREDUCTASE FAMILY PROTEIN', 243253),
(337975, 'PTHR45968:SF3', NULL, NULL, NULL, NULL, 'OS04G0573100 PROTEIN', 243253),
(337976, 'PTHR45968:SF2', NULL, NULL, NULL, NULL, '(R)-MANDELONITRILE LYASE-LIKE', 243253),
(337977, 'PTHR45968:SF1', NULL, NULL, NULL, NULL, 'OS09G0363900 PROTEIN', 243253),
(337978, 'PTHR45968', NULL, NULL, NULL, NULL, 'OSJNBA0019K04.7 PROTEIN', 243253),
(337979, 'PTHR45968:SF6', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE, EXPRESSED-RELATED', 243253),
(337980, 'PTHR45968:SF5', NULL, NULL, NULL, NULL, 'PROTEIN HOTHEAD', 243253),
(337981, 'PTHR45968:SF31', NULL, NULL, NULL, NULL, 'GMC_OXRDTASE_N DOMAIN-CONTAINING PROTEIN', 243253),
(337982, 'PTHR45968:SF30', NULL, NULL, NULL, NULL, 'GMC_OXRDTASE_N DOMAIN-CONTAINING PROTEIN', 243253),
(337983, 'PTHR45968:SF26', NULL, NULL, NULL, NULL, 'GMC_OXRDTASE_N DOMAIN-CONTAINING PROTEIN', 243253),
(337984, 'PTHR45968:SF25', NULL, NULL, NULL, NULL, 'OXYGEN-DEPENDENT CHOLINE DEHYDROGENASE, FAD/NAD(P)-BINDING DOMAIN PROTEIN-RELATED', 243253);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(337985, 'PTHR45968:SF27', NULL, NULL, NULL, NULL, 'GMC_OXRDTASE_N DOMAIN-CONTAINING PROTEIN', 243253),
(337986, 'PTHR45968:SF23', NULL, NULL, NULL, NULL, 'GMC_OXRDTASE_N DOMAIN-CONTAINING PROTEIN', 243253),
(337987, 'PTHR45968:SF29', NULL, NULL, NULL, NULL, 'GMC_OXRDTASE_N DOMAIN-CONTAINING PROTEIN', 243253),
(337988, 'PTHR14234:SF18', NULL, NULL, NULL, NULL, 'RIMS-BINDING PROTEIN 2', 243254),
(337989, 'PTHR14234:SF19', NULL, NULL, NULL, NULL, 'RIM-BINDING PROTEIN, ISOFORM F', 243254),
(337990, 'PTHR14234', NULL, NULL, NULL, NULL, 'RIM BINDING PROTEIN-RELATED', 243254),
(337991, 'PTHR14234:SF21', NULL, NULL, NULL, NULL, 'RIMS-BINDING PROTEIN 3A-RELATED', 243254),
(337992, 'PTHR14234:SF20', NULL, NULL, NULL, NULL, 'PERIPHERAL-TYPE BENZODIAZEPINE RECEPTOR-ASSOCIATED PROTEIN 1', 243254),
(337993, 'PTHR34563:SF8', NULL, NULL, NULL, NULL, '', 243255),
(337994, 'PTHR34563:SF12', NULL, NULL, NULL, NULL, '', 243255),
(337995, 'PTHR34563:SF9', NULL, NULL, NULL, NULL, 'BNAA07G38720D PROTEIN', 243255),
(337996, 'PTHR34563:SF11', NULL, NULL, NULL, NULL, '', 243255),
(337997, 'PTHR34563:SF6', NULL, NULL, NULL, NULL, 'BNACNNG33880D PROTEIN', 243255),
(337998, 'PTHR34563:SF10', NULL, NULL, NULL, NULL, '', 243255),
(337999, 'PTHR34563:SF7', NULL, NULL, NULL, NULL, 'BNAA01G25980D PROTEIN', 243255),
(338000, 'PTHR34563:SF5', NULL, NULL, NULL, NULL, 'OS09G0380100 PROTEIN', 243255),
(338001, 'PTHR34563', NULL, NULL, NULL, NULL, 'BNACNNG33880D PROTEIN', 243255),
(338002, 'PTHR10572:SF52', NULL, NULL, NULL, NULL, '3-HYDROXY-3-METHYLGLUTARYL-COENZYME A REDUCTASE 1', 243256),
(338003, 'PTHR10572:SF30', NULL, NULL, NULL, NULL, '3-HYDROXY-3-METHYLGLUTARYL COENZYME A REDUCTASE', 243256),
(338004, 'PTHR10572:SF51', NULL, NULL, NULL, NULL, '3-HYDROXY-3-METHYLGLUTARYL-COENZYME A REDUCTASE 2', 243256),
(338005, 'PTHR10572:SF50', NULL, NULL, NULL, NULL, '3-HYDROXY-3-METHYLGLUTARYL COENZYME A REDUCTASE', 243256),
(338006, 'PTHR10572:SF27', NULL, NULL, NULL, NULL, '3-HYDROXY-3-METHYLGLUTARYL-COENZYME A REDUCTASE 2', 243256),
(338007, 'PTHR10572:SF49', NULL, NULL, NULL, NULL, '3-HYDROXY-3-METHYLGLUTARYL COENZYME A REDUCTASE', 243256),
(338008, 'PTHR10572:SF38', NULL, NULL, NULL, NULL, '3-HYDROXY-3-METHYLGLUTARYL-COENZYME A REDUCTASE 3', 243256),
(338009, 'PTHR10572:SF14', NULL, NULL, NULL, NULL, '3-HYDROXY-3-METHYLGLUTARYL-COENZYME A REDUCTASE 1', 243256),
(338010, 'PTHR10572:SF47', NULL, NULL, NULL, NULL, '3-HYDROXY-3-METHYLGLUTARYL COENZYME A REDUCTASE', 243256),
(338011, 'PTHR10572:SF24', NULL, NULL, NULL, NULL, '3-HYDROXY-3-METHYLGLUTARYL-COENZYME A REDUCTASE', 243256),
(338012, 'PTHR10572:SF44', NULL, NULL, NULL, NULL, '3-HYDROXY-3-METHYLGLUTARYL-COENZYME A REDUCTASE 1', 243256),
(338013, 'PTHR10572:SF10', NULL, NULL, NULL, NULL, '3-HYDROXY-3-METHYLGLUTARYL COENZYME A REDUCTASE', 243256),
(338014, 'PTHR10572:SF54', NULL, NULL, NULL, NULL, '3-HYDROXY-3-METHYLGLUTARYL COENZYME A REDUCTASE', 243256),
(338015, 'PTHR10572:SF43', NULL, NULL, NULL, NULL, '3-HYDROXY-3-METHYLGLUTARYL COENZYME A REDUCTASE', 243256),
(338016, 'PTHR10572:SF53', NULL, NULL, NULL, NULL, '3-HYDROXY-3-METHYLGLUTARYL COENZYME A REDUCTASE', 243256),
(338017, 'PTHR10572', NULL, NULL, NULL, NULL, '3-HYDROXY-3-METHYLGLUTARYL-COENZYME A REDUCTASE', 243256),
(338018, 'PTHR31350:SF27', NULL, NULL, NULL, NULL, 'YCCV-LIKE DOMAIN-CONTAINING PROTEIN', 243257),
(338019, 'PTHR31350:SF28', NULL, NULL, NULL, NULL, 'TRANSGLUT_CORE2 DOMAIN-CONTAINING PROTEIN', 243257),
(338020, 'PTHR31350:SF25', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN-CONTAINING PROTEIN-RELATED', 243257),
(338021, 'PTHR31350:SF26', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 243257),
(338022, 'PTHR31350:SF24', NULL, NULL, NULL, NULL, 'TRANSGLUT_CORE2 DOMAIN-CONTAINING PROTEIN', 243257),
(338023, 'PTHR31350', NULL, NULL, NULL, NULL, 'SI:DKEY-261L7.2', 243257),
(338024, 'PTHR31350:SF21', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 21', 243257),
(338025, 'PTHR36983', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 13', 243258),
(338026, 'PTHR36983:SF3', NULL, NULL, NULL, NULL, '', 243258);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(338027, 'PTHR36983:SF2', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 13', 243258),
(338028, 'PTHR34618:SF1', NULL, NULL, NULL, NULL, 'SURFACE PROTEIN MAS1, PUTATIVE-RELATED', 243259),
(338029, 'PTHR34618', NULL, NULL, NULL, NULL, 'SURFACE PROTEIN MAS1, PUTATIVE-RELATED', 243259),
(338030, 'PTHR34618:SF3', NULL, NULL, NULL, NULL, '', 243259),
(338031, 'PTHR34618:SF4', NULL, NULL, NULL, NULL, 'CAS1', 243259),
(338032, 'PTHR30616:SF2', NULL, NULL, NULL, NULL, 'PURINE NUCLEOSIDE PHOSPHORYLASE LACC1', 243260),
(338033, 'PTHR30616:SF3', NULL, NULL, NULL, NULL, 'PURINE NUCLEOSIDE PHOSPHORYLASE', 243260),
(338034, 'PTHR30616', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN YFIH', 243260),
(338035, 'PTHR24250:SF50', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 243261),
(338036, 'PTHR24250:SF61', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 243261),
(338037, 'PTHR24250:SF60', NULL, NULL, NULL, NULL, 'CHYMOTRYPSINOGEN 2', 243261),
(338038, 'PTHR24250:SF52', NULL, NULL, NULL, NULL, 'CHYMOTRYPSINOGEN B', 243261),
(338039, 'PTHR24250:SF63', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 243261),
(338040, 'PTHR24250:SF30', NULL, NULL, NULL, NULL, 'SERINE PROTEASE 38', 243261),
(338041, 'PTHR24250:SF62', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 243261),
(338042, 'PTHR24250:SF54', NULL, NULL, NULL, NULL, 'ZGC:112160', 243261),
(338043, 'PTHR24250:SF53', NULL, NULL, NULL, NULL, 'CHYMOTRYPSINOGEN B2', 243261),
(338044, 'PTHR24250:SF31', NULL, NULL, NULL, NULL, 'CHYMOTRYPSINOGEN B', 243261),
(338045, 'PTHR24250', NULL, NULL, NULL, NULL, 'CHYMOTRYPSIN-RELATED', 243261),
(338046, 'PTHR24250:SF45', NULL, NULL, NULL, NULL, 'INACTIVE SERINE PROTEASE 54', 243261),
(338047, 'PTHR24250:SF35', NULL, NULL, NULL, NULL, 'CHYMOTRYPSIN-C', 243261),
(338048, 'PTHR24250:SF27', NULL, NULL, NULL, NULL, 'ELASTASE 2-LIKE', 243261),
(338049, 'PTHR24250:SF59', NULL, NULL, NULL, NULL, 'CHYMOTRYPSINOGEN B1-RELATED', 243261),
(338050, 'PTHR24250:SF29', NULL, NULL, NULL, NULL, 'CHYMOTRYPSINOGEN B', 243261),
(338051, 'PTHR24250:SF28', NULL, NULL, NULL, NULL, 'CHYMOTRYPSIN-LIKE PROTEASE CTRL-1', 243261),
(338052, 'PTHR35985:SF1', NULL, NULL, NULL, NULL, 'OS07G0675200 PROTEIN', 243262),
(338053, 'PTHR35985', NULL, NULL, NULL, NULL, 'OS07G0675200 PROTEIN', 243262),
(338054, 'PTHR43205:SF64', NULL, NULL, NULL, NULL, 'ALLYL ALCOHOL DEHYDROGENASE', 243263),
(338055, 'PTHR43205:SF42', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE, ZINC-CONTAINING (AFU_ORTHOLOGUE AFUA_7G04530)', 243263),
(338056, 'PTHR43205:SF67', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 243263),
(338057, 'PTHR43205:SF23', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE P1, PUTATIVE, EXPRESSED-RELATED', 243263),
(338058, 'PTHR43205:SF24', NULL, NULL, NULL, NULL, 'ALLYL ALCOHOL DEHYDROGENASE_ NADP-DEPENDENT OXIDOREDUCTASE-LIKE PROTEIN-RELATED', 243263),
(338059, 'PTHR43205:SF25', NULL, NULL, NULL, NULL, '15-OXOPROSTAGLANDIN 13-REDUCTASE', 243263),
(338060, 'PTHR43205:SF47', NULL, NULL, NULL, NULL, 'NADP-DEPENDENT ALKENAL DOUBLE BOND REDUCTASE', 243263),
(338061, 'PTHR43205:SF26', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 243263),
(338062, 'PTHR43205:SF71', NULL, NULL, NULL, NULL, '2-ALKENAL REDUCTASE (NADP(+)-DEPENDENT)-LIKE', 243263),
(338063, 'PTHR43205:SF72', NULL, NULL, NULL, NULL, 'NADP-DEPENDENT OXIDOREDUCTASE-RELATED', 243263),
(338064, 'PTHR43205:SF50', NULL, NULL, NULL, NULL, '2-ALKENAL REDUCTASE (NADP(+)-DEPENDENT)-LIKE', 243263),
(338065, 'PTHR43205:SF73', NULL, NULL, NULL, NULL, '2-ALKENAL REDUCTASE (NADP(+)-DEPENDENT)-LIKE', 243263),
(338066, 'PTHR43205:SF52', NULL, NULL, NULL, NULL, 'NADP-DEPENDENT ALKENAL DOUBLE BOND REDUCTASE', 243263),
(338067, 'PTHR43205:SF30', NULL, NULL, NULL, NULL, 'NADP-DEPENDENT ALKENAL DOUBLE BOND REDUCTASE P2-RELATED', 243263),
(338068, 'PTHR43205:SF74', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 243263),
(338069, 'PTHR43205:SF75', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE P1, PUTATIVE, EXPRESSED-RELATED', 243263);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(338070, 'PTHR43205:SF32', NULL, NULL, NULL, NULL, '2-ALKENAL REDUCTASE (NADP(+)-DEPENDENT)-LIKE', 243263),
(338071, 'PTHR43205:SF76', NULL, NULL, NULL, NULL, '2-ALKENAL REDUCTASE (NADP(+)-DEPENDENT)-LIKE', 243263),
(338072, 'PTHR43205:SF54', NULL, NULL, NULL, NULL, 'ALLYL ALCOHOL DEHYDROGENASE', 243263),
(338073, 'PTHR43205', NULL, NULL, NULL, NULL, 'PROSTAGLANDIN REDUCTASE', 243263),
(338074, 'PTHR43205:SF33', NULL, NULL, NULL, NULL, 'PROSTAGLANDIN REDUCTASE 1', 243263),
(338075, 'PTHR43205:SF77', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 243263),
(338076, 'PTHR43205:SF12', NULL, NULL, NULL, NULL, 'OS06G0602900 PROTEIN', 243263),
(338077, 'PTHR43205:SF78', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 243263),
(338078, 'PTHR43205:SF79', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 243263),
(338079, 'PTHR43205:SF35', NULL, NULL, NULL, NULL, 'ZINC-BINDING DEHYDROGENASE FAMILY PROTEIN', 243263),
(338080, 'PTHR43205:SF36', NULL, NULL, NULL, NULL, 'ALLYL ALCOHOL DEHYDROGENASE-LIKE PROTEIN', 243263),
(338081, 'PTHR43205:SF7', NULL, NULL, NULL, NULL, 'PROSTAGLANDIN REDUCTASE 1', 243263),
(338082, 'PTHR43205:SF19', NULL, NULL, NULL, NULL, 'AGL360WP', 243263),
(338083, 'PTHR43205:SF5', NULL, NULL, NULL, NULL, 'PROSTAGLANDIN REDUCTASE 2', 243263),
(338084, 'PTHR43205:SF2', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 243263),
(338085, 'PTHR43205:SF80', NULL, NULL, NULL, NULL, '2-ALKENAL REDUCTASE (NADP(+)-DEPENDENT)-LIKE', 243263),
(338086, 'PTHR43205:SF60', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 243263),
(338087, 'PTHR43205:SF40', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE SUPERFAMILY PROTEIN-RELATED', 243263),
(338088, 'PTHR22739:SF18', NULL, NULL, NULL, NULL, 'COSTARS DOMAIN-CONTAINING PROTEIN', 243264),
(338089, 'PTHR22739:SF7', NULL, NULL, NULL, NULL, 'COSTARS DOMAIN-CONTAINING PROTEIN', 243264),
(338090, 'PTHR22739', NULL, NULL, NULL, NULL, 'STRIATED MUSCLE ACTIVATOR OF RHO-DEPENDENT SIGNALING-RELATED', 243264),
(338091, 'PTHR22739:SF21', NULL, NULL, NULL, NULL, 'COSTARS DOMAIN-CONTAINING PROTEIN', 243264),
(338092, 'PTHR22739:SF20', NULL, NULL, NULL, NULL, 'ACTIN-BINDING RHO-ACTIVATING PROTEIN', 243264),
(338093, 'PTHR33659:SF1', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 243265),
(338094, 'PTHR33659:SF8', NULL, NULL, NULL, NULL, '', 243265),
(338095, 'PTHR33659:SF7', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 243265),
(338096, 'PTHR33659', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED-RELATED', 243265),
(338097, 'PTHR33659:SF6', NULL, NULL, NULL, NULL, '', 243265),
(338098, 'PTHR33659:SF9', NULL, NULL, NULL, NULL, '', 243265),
(338099, 'PTHR33659:SF12', NULL, NULL, NULL, NULL, '', 243265),
(338100, 'PTHR33659:SF10', NULL, NULL, NULL, NULL, '', 243265),
(338101, 'PTHR33659:SF11', NULL, NULL, NULL, NULL, '', 243265),
(338102, 'PTHR42729', NULL, NULL, NULL, NULL, 'OLIGO/DIPEPTIDE TRANSPORT, PERMEASE PROTEIN (DPPC-2)', 243266),
(338103, 'PTHR42729:SF1', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE ABC TRANSPORTER, PERMEASE PROTEIN', 243266),
(338104, 'PTHR42729:SF2', NULL, NULL, NULL, NULL, 'OLIGO/DIPEPTIDE TRANSPORT, PERMEASE PROTEIN (DPPC-2)', 243266),
(338105, 'PTHR34685:SF3', NULL, NULL, NULL, NULL, 'RED CHLOROPHYLL CATABOLITE REDUCTASE-LIKE', 243267),
(338106, 'PTHR34685:SF1', NULL, NULL, NULL, NULL, '', 243267),
(338107, 'PTHR34685:SF2', NULL, NULL, NULL, NULL, 'RED CHLOROPHYLL CATABOLITE REDUCTASE, CHLOROPLASTIC', 243267),
(338108, 'PTHR34685', NULL, NULL, NULL, NULL, 'RED CHLOROPHYLL CATABOLITE REDUCTASE, CHLOROPLASTIC', 243267),
(338109, 'PTHR12738', NULL, NULL, NULL, NULL, 'NEUROENDOCRINE PROTEIN 7B2', 243268),
(338110, 'PTHR12738:SF0', NULL, NULL, NULL, NULL, 'NEUROENDOCRINE PROTEIN 7B2', 243268),
(338111, 'PTHR24156:SF1', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 34B', 243269),
(338112, 'PTHR24156:SF6', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 243269),
(338113, 'PTHR24156:SF3', NULL, NULL, NULL, NULL, '', 243269),
(338114, 'PTHR24156', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 243269);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(338115, 'PTHR24156:SF4', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN 34A', 243269),
(338116, 'PTHR28188', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM5', 243270),
(338117, 'PTHR28188:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM5', 243270),
(338118, 'PTHR24341:SF4', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN ENGRAILED-1', 243271),
(338119, 'PTHR24341:SF1', NULL, NULL, NULL, NULL, 'CYTOPLASMIC POLYADENYLATED HOMEOBOX-LIKE', 243271),
(338120, 'PTHR24341:SF9', NULL, NULL, NULL, NULL, 'SEGMENTATION POLARITY HOMEOBOX PROTEIN ENGRAILED', 243271),
(338121, 'PTHR24341', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN ENGRAILED', 243271),
(338122, 'PTHR24341:SF8', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 243271),
(338123, 'PTHR24341:SF6', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN INVECTED', 243271),
(338124, 'PTHR24341:SF5', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN ENGRAILED-2', 243271),
(338125, 'PTHR34292', NULL, NULL, NULL, NULL, 'OUTER SPORE WALL PROTEIN LDS1', 243272),
(338126, 'PTHR34292:SF1', NULL, NULL, NULL, NULL, '', 243272),
(338127, 'PTHR34292:SF2', NULL, NULL, NULL, NULL, 'OUTER SPORE WALL PROTEIN LDS1', 243272),
(338128, 'PTHR34292:SF3', NULL, NULL, NULL, NULL, 'OUTER SPORE WALL PROTEIN LDS2-RELATED', 243272),
(338129, 'PTHR43559:SF2', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', 243273),
(338130, 'PTHR43559:SF1', NULL, NULL, NULL, NULL, 'HYDROLASE', 243273),
(338131, 'PTHR43559:SF3', NULL, NULL, NULL, NULL, 'HYDROLASE YCAC-RELATED', 243273),
(338132, 'PTHR43559', NULL, NULL, NULL, NULL, 'HYDROLASE YCAC-RELATED', 243273),
(338133, 'PTHR14963:SF6', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 18', 243274),
(338134, 'PTHR14963:SF7', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 19', 243274),
(338135, 'PTHR14963:SF4', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 40', 243274),
(338136, 'PTHR14963:SF5', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 28', 243274),
(338137, 'PTHR14963:SF1', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN CONUNDRUM', 243274),
(338138, 'PTHR14963', NULL, NULL, NULL, NULL, 'RHO GTPASE ACTIVATING PROTEIN 18,19-RELATED', 243274),
(338139, 'PTHR39220', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN PVRIG', 243275),
(338140, 'PTHR39220:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN PVRIG', 243275),
(338141, 'PTHR13587:SF7', NULL, NULL, NULL, NULL, 'INTEGRATOR COMPLEX SUBUNIT 3', 243276),
(338142, 'PTHR13587', NULL, NULL, NULL, NULL, 'INTEGRATOR COMPLEX SUBUNIT 3', 243276),
(338143, 'PTHR13237:SF10', NULL, NULL, NULL, NULL, 'SAS10 DOMAIN-CONTAINING PROTEIN', 243277),
(338144, 'PTHR13237:SF9', NULL, NULL, NULL, NULL, 'NEUROGUIDIN', 243277),
(338145, 'PTHR13237:SF8', NULL, NULL, NULL, NULL, 'SOMETHING ABOUT SILENCING PROTEIN 10', 243277),
(338146, 'PTHR13237', NULL, NULL, NULL, NULL, 'SOMETHING ABOUT SILENCING PROTEIN 10-RELATED', 243277),
(338147, 'PTHR41694', NULL, NULL, NULL, NULL, 'ENDOGENOUS RETROVIRUS GROUP K MEMBER POL PROTEIN', 243278),
(338148, 'PTHR41694:SF3', NULL, NULL, NULL, NULL, 'INTEGRASE-RELATED', 243278),
(338149, 'PTHR41694:SF4', NULL, NULL, NULL, NULL, 'ENDOGENOUS RETROVIRUS GROUP K MEMBER 10 POL PROTEIN-RELATED', 243278),
(338150, 'PTHR38098', NULL, NULL, NULL, NULL, 'LPS-ASSEMBLY LIPOPROTEIN LPTE', 243279),
(338151, 'PTHR38098:SF1', NULL, NULL, NULL, NULL, 'LPS-ASSEMBLY LIPOPROTEIN LPTE', 243279),
(338152, 'PTHR43976', NULL, NULL, NULL, NULL, 'SHORT CHAIN DEHYDROGENASE', 243280),
(338153, 'PTHR43976:SF1', NULL, NULL, NULL, NULL, '', 243280),
(338154, 'PTHR43976:SF3', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/REDUCTASE FAMILY PROTEIN', 243280),
(338155, 'PTHR43976:SF20', NULL, NULL, NULL, NULL, 'AGROPINE SYNTHESIS REDUCTASE', 243280),
(338156, 'PTHR43976:SF5', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/REDUCTASE FAMILY PROTEIN', 243280),
(338157, 'PTHR43976:SF11', NULL, NULL, NULL, NULL, '', 243280),
(338158, 'PTHR43976:SF22', NULL, NULL, NULL, NULL, '', 243280),
(338159, 'PTHR43976:SF7', NULL, NULL, NULL, NULL, '', 243280);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(338160, 'PTHR43976:SF6', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G13950)-RELATED', 243280),
(338161, 'PTHR43976:SF16', NULL, NULL, NULL, NULL, 'SHORT CHAIN DEHYDROGENASE', 243280),
(338162, 'PTHR43976:SF9', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE', 243280),
(338163, 'PTHR43976:SF8', NULL, NULL, NULL, NULL, '', 243280),
(338164, 'PTHR35779', NULL, NULL, NULL, NULL, 'PH-RESPONSE REGULATOR PROTEIN PALH/RIM21', 243281),
(338165, 'PTHR35779:SF1', NULL, NULL, NULL, NULL, 'PH-RESPONSE REGULATOR PROTEIN PALH/RIM21', 243281),
(338166, 'PTHR35779:SF2', NULL, NULL, NULL, NULL, 'PROTEIN DFG16', 243281),
(338167, 'PTHR38736:SF1', NULL, NULL, NULL, NULL, '', 243282),
(338168, 'PTHR38736:SF3', NULL, NULL, NULL, NULL, '', 243282),
(338169, 'PTHR38736:SF2', NULL, NULL, NULL, NULL, '', 243282),
(338170, 'PTHR38736', NULL, NULL, NULL, NULL, '', 243282),
(338171, 'PTHR14199:SF39', NULL, NULL, NULL, NULL, 'MYOMEGALIN', 243283),
(338172, 'PTHR14199:SF38', NULL, NULL, NULL, NULL, 'NEUROBLASTOMA BREAKPOINT FAMILY MEMBER 6-LIKE PROTEIN', 243283),
(338173, 'PTHR14199:SF29', NULL, NULL, NULL, NULL, 'NEUROBLASTOMA BREAKPOINT FAMILY MEMBER 4-RELATED', 243283),
(338174, 'PTHR14199:SF42', NULL, NULL, NULL, NULL, 'NEUROBLASTOMA BREAKPOINT FAMILY MEMBER 7-RELATED', 243283),
(338175, 'PTHR14199:SF35', NULL, NULL, NULL, NULL, 'NEUROBLASTOMA BREAKPOINT FAMILY MEMBER 1-RELATED', 243283),
(338176, 'PTHR14199:SF45', NULL, NULL, NULL, NULL, 'NEUROBLASTOMA BREAKPOINT FAMILY MEMBER 3', 243283),
(338177, 'PTHR14199:SF34', NULL, NULL, NULL, NULL, '', 243283),
(338178, 'PTHR14199:SF44', NULL, NULL, NULL, NULL, '', 243283),
(338179, 'PTHR14199', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243283),
(338180, 'PTHR14199:SF21', NULL, NULL, NULL, NULL, 'OLDUVAI DOMAIN-CONTAINING PROTEIN', 243283),
(338181, 'PTHR14199:SF43', NULL, NULL, NULL, NULL, '', 243283),
(338182, 'PTHR43530:SF1', NULL, NULL, NULL, NULL, 'QUEUINE TRNA-RIBOSYLTRANSFERASE CATALYTIC SUBUNIT 1', 243284),
(338183, 'PTHR43530', NULL, NULL, NULL, NULL, 'QUEUINE TRNA-RIBOSYLTRANSFERASE CATALYTIC SUBUNIT 1', 243284),
(338184, 'PTHR44321', NULL, NULL, NULL, NULL, 'TRANSDUCIN BETA-LIKE PROTEIN 2', 243285),
(338185, 'PTHR44321:SF1', NULL, NULL, NULL, NULL, 'TRANSDUCIN BETA-LIKE PROTEIN 2', 243285),
(338186, 'PTHR35862:SF1', NULL, NULL, NULL, NULL, 'FELS-2 PROPHAGE PROTEIN', 243286),
(338187, 'PTHR35862:SF2', NULL, NULL, NULL, NULL, 'FELS-2 PROPHAGE PROTEIN', 243286),
(338188, 'PTHR35862:SF3', NULL, NULL, NULL, NULL, 'FELS-2 PROPHAGE PROTEIN', 243286),
(338189, 'PTHR35862', NULL, NULL, NULL, NULL, 'FELS-2 PROPHAGE PROTEIN', 243286),
(338190, 'PTHR15298', NULL, NULL, NULL, NULL, 'L-COA N-ACYLTRANSFERASE-RELATED', 243287),
(338191, 'PTHR15298:SF11', NULL, NULL, NULL, NULL, 'GLYCINE N-ACYLTRANSFERASE-LIKE PROTEIN', 243287),
(338192, 'PTHR15298:SF6', NULL, NULL, NULL, NULL, 'GLYCINE N-ACYLTRANSFERASE-LIKE PROTEIN 3', 243287),
(338193, 'PTHR15298:SF16', NULL, NULL, NULL, NULL, 'GLYCINE N-ACYLTRANSFERASE-LIKE PROTEIN 1B-RELATED', 243287),
(338194, 'PTHR15298:SF7', NULL, NULL, NULL, NULL, 'GLYCINE N-ACYLTRANSFERASE-LIKE PROTEIN 1', 243287),
(338195, 'PTHR15298:SF15', NULL, NULL, NULL, NULL, 'GLYCINE N-ACYLTRANSFERASE-LIKE PROTEIN', 243287),
(338196, 'PTHR15298:SF13', NULL, NULL, NULL, NULL, 'GLYCINE N-ACYLTRANSFERASE-LIKE PROTEIN KEG1', 243287),
(338197, 'PTHR15298:SF9', NULL, NULL, NULL, NULL, 'GLYCINE N-ACYLTRANSFERASE', 243287),
(338198, 'PTHR15298:SF19', NULL, NULL, NULL, NULL, 'GLYCINE N-ACYLTRANSFERASE-LIKE PROTEIN', 243287),
(338199, 'PTHR15298:SF17', NULL, NULL, NULL, NULL, 'GLYCINE N-ACYLTRANSFERASE-LIKE PROTEIN', 243287),
(338200, 'PTHR15298:SF1', NULL, NULL, NULL, NULL, 'GLYCINE N-ACYLTRANSFERASE-LIKE PROTEIN', 243287),
(338201, 'PTHR15298:SF2', NULL, NULL, NULL, NULL, 'GLYCINE N-ACYLTRANSFERASE-LIKE PROTEIN', 243287),
(338202, 'PTHR15298:SF4', NULL, NULL, NULL, NULL, 'GLYCINE N-ACYLTRANSFERASE-LIKE PROTEIN 2', 243287),
(338203, 'PTHR12146:SF25', NULL, NULL, NULL, NULL, 'S10_PLECTIN DOMAIN-CONTAINING PROTEIN', 243288),
(338204, 'PTHR12146:SF27', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S10-3', 243288);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(338205, 'PTHR12146:SF28', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S10-2', 243288),
(338206, 'PTHR12146:SF17', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S10-1-LIKE', 243288),
(338207, 'PTHR12146:SF7', NULL, NULL, NULL, NULL, 'OS01G0962600 PROTEIN', 243288),
(338208, 'PTHR12146:SF10', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S10', 243288),
(338209, 'PTHR12146:SF21', NULL, NULL, NULL, NULL, 'BNAC06G13490D PROTEIN', 243288),
(338210, 'PTHR12146:SF8', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S10-LIKE-RELATED', 243288),
(338211, 'PTHR12146:SF23', NULL, NULL, NULL, NULL, 'S10_PLECTIN DOMAIN-CONTAINING PROTEIN', 243288),
(338212, 'PTHR12146:SF24', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S10-1', 243288),
(338213, 'PTHR12146', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S10', 243288),
(338214, 'PTHR12146:SF0', NULL, NULL, NULL, NULL, 'S10_PLECTIN DOMAIN-CONTAINING PROTEIN', 243288),
(338215, 'PTHR47565:SF4', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY PROTEIN COX19', 243289),
(338216, 'PTHR47565', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE 19-1', 243289),
(338217, 'PTHR47565:SF5', NULL, NULL, NULL, NULL, 'BNAA07G24120D PROTEIN', 243289),
(338218, 'PTHR47565:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE 19-1', 243289),
(338219, 'PTHR47565:SF3', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE 19-2', 243289),
(338220, 'PTHR21040:SF5', NULL, NULL, NULL, NULL, 'BETA-N-ACETYLHEXOSAMINIDASE', 243290),
(338221, 'PTHR21040', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243290),
(338222, 'PTHR21040:SF4', NULL, NULL, NULL, NULL, 'BETA-N-ACETYLHEXOSAMINIDASE', 243290),
(338223, 'PTHR21040:SF8', NULL, NULL, NULL, NULL, 'BCDNA.GH04120', 243290),
(338224, 'PTHR21040:SF6', NULL, NULL, NULL, NULL, 'HEXOSAMINIDASE D', 243290),
(338225, 'PTHR21040:SF12', NULL, NULL, NULL, NULL, 'BETA-N-ACETYLHEXOSAMINIDASE', 243290),
(338226, 'PTHR21040:SF11', NULL, NULL, NULL, NULL, 'BETA-N-ACETYLHEXOSAMINIDASE', 243290),
(338227, 'PTHR37614:SF2', NULL, NULL, NULL, NULL, 'OS02G0121400 PROTEIN', 243291),
(338228, 'PTHR37614', NULL, NULL, NULL, NULL, 'OS02G0121400 PROTEIN', 243291),
(338229, 'PTHR34300:SF1', NULL, NULL, NULL, NULL, 'QUEUOSINE PRECURSOR TRANSPORTER', 243292),
(338230, 'PTHR34300:SF2', NULL, NULL, NULL, NULL, 'QUEUOSINE PRECURSOR TRANSPORTER-RELATED', 243292),
(338231, 'PTHR34300', NULL, NULL, NULL, NULL, 'QUEUOSINE PRECURSOR TRANSPORTER-RELATED', 243292),
(338232, 'PTHR24206:SF68', NULL, NULL, NULL, NULL, 'LIM DOMAIN CONTAINING PROTEIN, EXPRESSED', 243293),
(338233, 'PTHR24206:SF89', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING PROTEIN PLIM2C-LIKE ISOFORM X1', 243293),
(338234, 'PTHR24206:SF67', NULL, NULL, NULL, NULL, 'LIM ZINC-BINDING DOMAIN-CONTAINING PROTEIN', 243293),
(338235, 'PTHR24206:SF64', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING PROTEIN D', 243293),
(338236, 'PTHR24206:SF86', NULL, NULL, NULL, NULL, 'BNACNNG08890D PROTEIN', 243293),
(338237, 'PTHR24206:SF84', NULL, NULL, NULL, NULL, 'BNAANNG26690D PROTEIN', 243293),
(338238, 'PTHR24206:SF62', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING PROTEIN WLIM2B-LIKE', 243293),
(338239, 'PTHR24206:SF109', NULL, NULL, NULL, NULL, 'BNAANNG14450D PROTEIN', 243293),
(338240, 'PTHR24206:SF108', NULL, NULL, NULL, NULL, 'OS06G0237300 PROTEIN', 243293),
(338241, 'PTHR24206:SF107', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING PROTEIN WLIM2B-LIKE', 243293),
(338242, 'PTHR24206:SF106', NULL, NULL, NULL, NULL, '', 243293),
(338243, 'PTHR24206:SF105', NULL, NULL, NULL, NULL, 'ZINC FINGER, LIM-TYPE-RELATED', 243293),
(338244, 'PTHR24206:SF69', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING PROTEIN PLIM2B', 243293),
(338245, 'PTHR24206:SF104', NULL, NULL, NULL, NULL, '', 243293),
(338246, 'PTHR24206:SF103', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING PROTEIN 2', 243293),
(338247, 'PTHR24206:SF93', NULL, NULL, NULL, NULL, 'BNAC04G50470D PROTEIN', 243293),
(338248, 'PTHR24206:SF92', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING PROTEIN WLIM1', 243293),
(338249, 'PTHR24206:SF90', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING PROTEIN WLIM2A', 243293);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(338250, 'PTHR24206:SF57', NULL, NULL, NULL, NULL, 'LIM DOMAIN AND ACTIN-BINDING PROTEIN 1', 243293),
(338251, 'PTHR24206:SF35', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING PROTEIN WLIM1-LIKE', 243293),
(338252, 'PTHR24206:SF56', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING PROTEIN E', 243293),
(338253, 'PTHR24206:SF77', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING PROTEIN WLIM1-LIKE', 243293),
(338254, 'PTHR24206:SF99', NULL, NULL, NULL, NULL, 'GATA TYPE ZINC FINGER TRANSCRIPTION FACTOR FAMILY PROTEIN', 243293),
(338255, 'PTHR24206:SF54', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING PROTEIN WLIM2B-LIKE', 243293),
(338256, 'PTHR24206:SF76', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING PROTEIN WLIM1-LIKE', 243293),
(338257, 'PTHR24206:SF75', NULL, NULL, NULL, NULL, 'LIM DOMAIN PROTEIN PLIM-2', 243293),
(338258, 'PTHR24206:SF97', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING PROTEIN PLIM2C', 243293),
(338259, 'PTHR24206', NULL, NULL, NULL, NULL, 'OS06G0237300 PROTEIN', 243293),
(338260, 'PTHR24206:SF30', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING PROTEIN PLIM2B', 243293),
(338261, 'PTHR24206:SF74', NULL, NULL, NULL, NULL, 'GATA TYPE ZINC FINGER TRANSCRIPTION FACTOR FAMILY PROTEIN', 243293),
(338262, 'PTHR24206:SF95', NULL, NULL, NULL, NULL, 'LIM DOMAIN AND ACTIN-BINDING 1A-RELATED', 243293),
(338263, 'PTHR24206:SF94', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING PROTEIN WLIM2B', 243293),
(338264, 'PTHR24206:SF59', NULL, NULL, NULL, NULL, '[F-ACTIN]-MONOOXYGENASE MICAL1', 243293),
(338265, 'PTHR24206:SF111', NULL, NULL, NULL, NULL, 'OS02G0641000 PROTEIN', 243293),
(338266, 'PTHR24206:SF110', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING PROTEIN PLIM2A', 243293),
(338267, 'PTHR24206:SF81', NULL, NULL, NULL, NULL, 'BNAA09G39010D PROTEIN', 243293),
(338268, 'PTHR33109:SF77', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN', 243294),
(338269, 'PTHR33109:SF99', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN', 243294),
(338270, 'PTHR33109:SF55', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN 4', 243294),
(338271, 'PTHR33109:SF76', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN', 243294),
(338272, 'PTHR33109:SF98', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN', 243294),
(338273, 'PTHR33109:SF14', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN', 243294),
(338274, 'PTHR33109:SF80', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN', 243294),
(338275, 'PTHR33109:SF60', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN 8', 243294),
(338276, 'PTHR33109:SF82', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN', 243294),
(338277, 'PTHR33109:SF81', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN', 243294),
(338278, 'PTHR33109:SF62', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN', 243294),
(338279, 'PTHR33109', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN 4', 243294),
(338280, 'PTHR33109:SF63', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN', 243294),
(338281, 'PTHR33109:SF41', NULL, NULL, NULL, NULL, 'PROTEIN EPIDERMAL PATTERNING FACTOR 1', 243294),
(338282, 'PTHR33109:SF4', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN 6', 243294),
(338283, 'PTHR33109:SF3', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN 1', 243294),
(338284, 'PTHR33109:SF100', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN', 243294),
(338285, 'PTHR33109:SF7', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN 2', 243294),
(338286, 'PTHR33109:SF6', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN 7-RELATED', 243294),
(338287, 'PTHR33109:SF88', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN', 243294),
(338288, 'PTHR33109:SF87', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN', 243294),
(338289, 'PTHR33109:SF65', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN', 243294); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(338290, 'PTHR33109:SF46', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN', 243294),
(338291, 'PTHR33109:SF67', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN 5', 243294),
(338292, 'PTHR33109:SF45', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN', 243294),
(338293, 'PTHR33109:SF89', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN', 243294),
(338294, 'PTHR33109:SF49', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN', 243294),
(338295, 'PTHR33109:SF91', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN', 243294),
(338296, 'PTHR33109:SF90', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN', 243294),
(338297, 'PTHR33109:SF93', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN', 243294),
(338298, 'PTHR33109:SF92', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN', 243294),
(338299, 'PTHR33109:SF95', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN', 243294),
(338300, 'PTHR33109:SF94', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN', 243294),
(338301, 'PTHR33109:SF75', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN', 243294),
(338302, 'PTHR33109:SF97', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN', 243294),
(338303, 'PTHR33109:SF96', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN 3', 243294),
(338304, 'PTHR33109:SF74', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN', 243294),
(338305, 'PTHR21391', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243295),
(338306, 'PTHR21391:SF0', NULL, NULL, NULL, NULL, 'AT04489P-RELATED', 243295),
(338307, 'PTHR35154:SF3', NULL, NULL, NULL, NULL, 'GBP PROTEIN', 243296),
(338308, 'PTHR35154', NULL, NULL, NULL, NULL, 'GBP PROTEIN', 243296),
(338309, 'PTHR35154:SF2', NULL, NULL, NULL, NULL, 'GSK-3-BINDING PROTEIN FRAT2', 243296),
(338310, 'PTHR35154:SF1', NULL, NULL, NULL, NULL, 'PROTO-ONCOGENE FRAT1', 243296),
(338311, 'PTHR47175', NULL, NULL, NULL, NULL, 'LIPASE ATG15-RELATED', 243297),
(338312, 'PTHR47175:SF2', NULL, NULL, NULL, NULL, 'LIPASE ATG15-RELATED', 243297),
(338313, 'PTHR13663:SF2', NULL, NULL, NULL, NULL, 'SIMILAR TO RIKEN CDNA 6430548M08', 243298),
(338314, 'PTHR13663', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243298),
(338315, 'PTHR13555:SF65', NULL, NULL, NULL, NULL, 'DZANK-TYPE DOMAIN-CONTAINING PROTEIN', 243299),
(338316, 'PTHR13555:SF64', NULL, NULL, NULL, NULL, '', 243299),
(338317, 'PTHR13555:SF63', NULL, NULL, NULL, NULL, 'ZINC_RIBBON_2 DOMAIN-CONTAINING PROTEIN', 243299),
(338318, 'PTHR13555:SF62', NULL, NULL, NULL, NULL, 'PROTEIN CBG21933', 243299),
(338319, 'PTHR13555:SF60', NULL, NULL, NULL, NULL, '', 243299),
(338320, 'PTHR13555:SF5', NULL, NULL, NULL, NULL, 'ZINC FINGER C2HC DOMAIN-CONTAINING PROTEIN 1B', 243299),
(338321, 'PTHR13555', NULL, NULL, NULL, NULL, 'C2H2 ZINC FINGER CGI-62-RELATED', 243299),
(338322, 'PTHR13555:SF25', NULL, NULL, NULL, NULL, 'ZINC FINGER C2HC DOMAIN-CONTAINING PROTEIN 1A', 243299),
(338323, 'PTHR13555:SF36', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 474', 243299),
(338324, 'PTHR13555:SF47', NULL, NULL, NULL, NULL, '', 243299),
(338325, 'PTHR13555:SF66', NULL, NULL, NULL, NULL, '', 243299),
(338326, 'PTHR23034', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243300),
(338327, 'PTHR23034:SF2', NULL, NULL, NULL, NULL, 'GLUTAMATE-RICH PROTEIN 3', 243300),
(338328, 'PTHR47299:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAM166A', 243301),
(338329, 'PTHR47299', NULL, NULL, NULL, NULL, 'PROTEIN FAM166A', 243301),
(338330, 'PTHR38731:SF1', NULL, NULL, NULL, NULL, 'BLL6125 PROTEIN', 243302),
(338331, 'PTHR38731:SF2', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 243302),
(338332, 'PTHR38731', NULL, NULL, NULL, NULL, 'LIPL45-RELATED LIPOPROTEIN-RELATED', 243302),
(338333, 'PTHR47329', NULL, NULL, NULL, NULL, 'OS05G0129900 PROTEIN', 243303),
(338334, 'PTHR47329:SF2', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 243303),
(338335, 'PTHR47329:SF1', NULL, NULL, NULL, NULL, 'OS05G0129900 PROTEIN', 243303);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(338336, 'PTHR31617:SF0', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 171', 243304),
(338337, 'PTHR31617', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 171', 243304),
(338338, 'PTHR43667', NULL, NULL, NULL, NULL, 'CYCLOPROPANE-FATTY-ACYL-PHOSPHOLIPID SYNTHASE', 243305),
(338339, 'PTHR43667:SF1', NULL, NULL, NULL, NULL, 'CYCLOPROPANE-FATTY-ACYL-PHOSPHOLIPID SYNTHASE', 243305),
(338340, 'PTHR43667:SF2', NULL, NULL, NULL, NULL, 'TUBERCULOSTEARIC ACID METHYLTRANSFERASE UFAA1', 243305),
(338341, 'PTHR15083', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 BETA SUBCOMPLEX SUBUNIT 6', 243306),
(338342, 'PTHR15083:SF0', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 BETA SUBCOMPLEX SUBUNIT 6', 243306),
(338343, 'PTHR31034:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 101', 243307),
(338344, 'PTHR31034', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 101', 243307),
(338345, 'PTHR38169:SF2', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 243308),
(338346, 'PTHR38169', NULL, NULL, NULL, NULL, 'OS12G0178300 PROTEIN', 243308),
(338347, 'PTHR47013', NULL, NULL, NULL, NULL, 'SPLICING FACTOR, ARGININE/SERINE-RICH 19', 243309),
(338348, 'PTHR47013:SF1', NULL, NULL, NULL, NULL, 'SPLICING FACTOR, ARGININE/SERINE-RICH 19', 243309),
(338349, 'PTHR13155:SF1', NULL, NULL, NULL, NULL, 'A-KINASE ANCHOR PROTEIN 10, MITOCHONDRIAL', 243310),
(338350, 'PTHR13155', NULL, NULL, NULL, NULL, 'A-KINASE ANCHOR PROTEINS', 243310),
(338351, 'PTHR22924:SF92', NULL, NULL, NULL, NULL, 'NON-SYMBIOTIC HEMOGLOBIN 2', 243311),
(338352, 'PTHR22924:SF93', NULL, NULL, NULL, NULL, 'HEMOGLOBIN-1-RELATED', 243311),
(338353, 'PTHR22924:SF95', NULL, NULL, NULL, NULL, 'OS05G0517600 PROTEIN', 243311),
(338354, 'PTHR22924', NULL, NULL, NULL, NULL, 'LEGHEMOGLOBIN-RELATED', 243311),
(338355, 'PTHR22924:SF97', NULL, NULL, NULL, NULL, 'GLOBIN DOMAIN-CONTAINING PROTEIN', 243311),
(338356, 'PTHR22924:SF89', NULL, NULL, NULL, NULL, 'NON-SYMBIOTIC HEMOGLOBIN', 243311),
(338357, 'PTHR22924:SF39', NULL, NULL, NULL, NULL, 'NON-SYMBIOTIC HEMOGLOBIN 1', 243311),
(338358, 'PTHR31167:SF3', NULL, NULL, NULL, NULL, 'SPINDLE AND CENTRIOLE-ASSOCIATED PROTEIN 1', 243312),
(338359, 'PTHR31167', NULL, NULL, NULL, NULL, 'SPINDLE AND CENTRIOLE ASSOCIATED PROTEIN 1 SPICE1', 243312),
(338360, 'PTHR10652:SF18', NULL, NULL, NULL, NULL, 'C-CAP/COFACTOR C-LIKE DOMAIN-CONTAINING PROTEIN', 243313),
(338361, 'PTHR10652:SF19', NULL, NULL, NULL, NULL, 'C-CAP/COFACTOR C-LIKE DOMAIN-CONTAINING PROTEIN', 243313),
(338362, 'PTHR10652:SF23', NULL, NULL, NULL, NULL, 'WH2 DOMAIN-CONTAINING PROTEIN', 243313),
(338363, 'PTHR10652:SF14', NULL, NULL, NULL, NULL, 'CYCLASE-ASSOCIATED PROTEIN 1-LIKE', 243313),
(338364, 'PTHR10652:SF20', NULL, NULL, NULL, NULL, 'C-CAP/COFACTOR C-LIKE DOMAIN-CONTAINING PROTEIN', 243313),
(338365, 'PTHR10652:SF21', NULL, NULL, NULL, NULL, 'ADENYLYL CYCLASE-ASSOCIATED PROTEIN', 243313),
(338366, 'PTHR10652', NULL, NULL, NULL, NULL, 'ADENYLYL CYCLASE-ASSOCIATED PROTEIN', 243313),
(338367, 'PTHR10652:SF22', NULL, NULL, NULL, NULL, 'ADENYLYL CYCLASE-ASSOCIATED PROTEIN', 243313),
(338368, 'PTHR10652:SF0', NULL, NULL, NULL, NULL, 'ADENYLYL CYCLASE-ASSOCIATED PROTEIN', 243313),
(338369, 'PTHR10652:SF1', NULL, NULL, NULL, NULL, 'ADENYLYL CYCLASE-ASSOCIATED PROTEIN 1', 243313),
(338370, 'PTHR10652:SF2', NULL, NULL, NULL, NULL, 'ADENYLYL CYCLASE-ASSOCIATED PROTEIN 2', 243313),
(338371, 'PTHR46594:SF2', NULL, NULL, NULL, NULL, 'COPPER-TRANSPORTING ATPASE HMA4', 243314),
(338372, 'PTHR46594:SF4', NULL, NULL, NULL, NULL, 'P-TYPE CATION-TRANSPORTING ATPASE', 243314),
(338373, 'PTHR46594:SF6', NULL, NULL, NULL, NULL, 'COPPER-TRANSPORTING ATPASE RAN1', 243314),
(338374, 'PTHR46594', NULL, NULL, NULL, NULL, 'P-TYPE CATION-TRANSPORTING ATPASE', 243314),
(338375, 'PTHR46594:SF7', NULL, NULL, NULL, NULL, '', 243314),
(338376, 'PTHR37731:SF1', NULL, NULL, NULL, NULL, 'PEPTIDE TRANSPORTER FAMILY PROTEIN', 243315),
(338377, 'PTHR37731', NULL, NULL, NULL, NULL, 'PEPTIDE TRANSPORTER FAMILY PROTEIN', 243315),
(338378, 'PTHR43859:SF52', NULL, NULL, NULL, NULL, 'BENZOATE-COA LIGASE-RELATED', 243316);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(338379, 'PTHR43859:SF50', NULL, NULL, NULL, NULL, 'DEPENDENT LIGASE, PUTATIVE-RELATED', 243316),
(338380, 'PTHR43859:SF11', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA SYNTHETASE FAMILY PROTEIN', 243316),
(338381, 'PTHR43859:SF56', NULL, NULL, NULL, NULL, 'ACYL-ACTIVATING ENZYME 5, PEROXISOMAL-RELATED', 243316),
(338382, 'PTHR43859:SF12', NULL, NULL, NULL, NULL, 'OS09G0555800 PROTEIN', 243316),
(338383, 'PTHR43859:SF53', NULL, NULL, NULL, NULL, 'ACYL-ACTIVATING ENZYME 4-RELATED', 243316),
(338384, 'PTHR43859', NULL, NULL, NULL, NULL, 'ACYL-ACTIVATING ENZYME', 243316),
(338385, 'PTHR43859:SF10', NULL, NULL, NULL, NULL, 'AMP-BINDING ENZYME FAMILY PROTEIN, EXPRESSED', 243316),
(338386, 'PTHR43859:SF54', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE', 243316),
(338387, 'PTHR43859:SF5', NULL, NULL, NULL, NULL, 'ISOVALERATE--COA LIGASE AAE2', 243316),
(338388, 'PTHR43859:SF4', NULL, NULL, NULL, NULL, 'BUTANOATE--COA LIGASE AAE1-RELATED', 243316),
(338389, 'PTHR43859:SF2', NULL, NULL, NULL, NULL, 'BUTYRATE--COA LIGASE AAE11, PEROXISOMAL', 243316),
(338390, 'PTHR43859:SF26', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE', 243316),
(338391, 'PTHR43859:SF46', NULL, NULL, NULL, NULL, 'SYNTHETASE AND LIGASE FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 243316),
(338392, 'PTHR43859:SF24', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE', 243316),
(338393, 'PTHR43859:SF7', NULL, NULL, NULL, NULL, 'ACETATE/BUTYRATE--COA LIGASE AAE7, PEROXISOMAL', 243316),
(338394, 'PTHR43859:SF68', NULL, NULL, NULL, NULL, 'MEDIUM-CHAIN FATTY-ACID--COA LIGASE', 243316),
(338395, 'PTHR43859:SF25', NULL, NULL, NULL, NULL, 'BENZOATE--COA LIGASE, PEROXISOMAL-RELATED', 243316),
(338396, 'PTHR43859:SF47', NULL, NULL, NULL, NULL, 'BNAANNG22570D PROTEIN', 243316),
(338397, 'PTHR43859:SF28', NULL, NULL, NULL, NULL, 'ACYL-ACTIVATING ENZYME 10-RELATED', 243316),
(338398, 'PTHR43859:SF29', NULL, NULL, NULL, NULL, 'AMP-DEPENDENT SYNTHETASE AND LIGASE SUPERFAMILY PROTEIN-RELATED', 243316),
(338399, 'PTHR43859:SF40', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE', 243316),
(338400, 'PTHR43859:SF62', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE', 243316),
(338401, 'PTHR43859:SF41', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE', 243316),
(338402, 'PTHR43859:SF63', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE', 243316),
(338403, 'PTHR43859:SF61', NULL, NULL, NULL, NULL, 'ACETATE/BUTYRATE--COA LIGASE AAE7, PEROXISOMAL-LIKE', 243316),
(338404, 'PTHR43859:SF22', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 243316),
(338405, 'PTHR43859:SF66', NULL, NULL, NULL, NULL, 'LONG-CHAIN ACYL-COA SYNTHETASE', 243316),
(338406, 'PTHR43859:SF44', NULL, NULL, NULL, NULL, 'DEPENDENT LIGASE, PUTATIVE-RELATED', 243316),
(338407, 'PTHR43859:SF67', NULL, NULL, NULL, NULL, 'MEDIUM-CHAIN-FATTY-ACID--COA LIGASE (ALKK-3)', 243316),
(338408, 'PTHR43859:SF20', NULL, NULL, NULL, NULL, '', 243316),
(338409, 'PTHR43859:SF64', NULL, NULL, NULL, NULL, '', 243316),
(338410, 'PTHR43859:SF65', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE', 243316),
(338411, 'PTHR43859:SF21', NULL, NULL, NULL, NULL, 'ACYL-ACTIVATING ENZYME 2-RELATED', 243316),
(338412, 'PTHR43859:SF37', NULL, NULL, NULL, NULL, 'ACYL-ACTIVATING ENZYME 9-RELATED', 243316),
(338413, 'PTHR43859:SF38', NULL, NULL, NULL, NULL, 'AMP-DEPENDENT SYNTHETASE/LIGASE, AMP-BINDING ENZYME C-TERMINAL DOMAIN PROTEIN-RELATED', 243316),
(338414, 'PTHR43859:SF57', NULL, NULL, NULL, NULL, 'ACYL-ACTIVATING ENZYME 8-RELATED', 243316),
(338415, 'PTHR43859:SF35', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE', 243316),
(338416, 'PTHR43859:SF36', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE', 243316),
(338417, 'PTHR43859:SF58', NULL, NULL, NULL, NULL, 'ACYL-ACTIVATING ENZYME 6-RELATED', 243316),
(338418, 'PTHR43859:SF19', NULL, NULL, NULL, NULL, 'ACYL-ACTIVATING ENZYME 5 PEROXISOMAL-RELATED', 243316),
(338419, 'PTHR43859:SF17', NULL, NULL, NULL, NULL, '', 243316),
(338420, 'PTHR43859:SF18', NULL, NULL, NULL, NULL, '', 243316),
(338421, 'PTHR47910:SF2', NULL, NULL, NULL, NULL, 'RUBISCO_LARGE DOMAIN-CONTAINING PROTEIN', 243317);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(338422, 'PTHR47910:SF1', NULL, NULL, NULL, NULL, 'RIBULOSE BISPHOSPHATE CARBOXYLASE LARGE CHAIN, CATALYTIC DOMAIN-CONTAINING PROTEIN', 243317),
(338423, 'PTHR47910', NULL, NULL, NULL, NULL, 'RIBULOSE BISPHOSPHATE CARBOXYLASE LARGE CHAIN, CATALYTIC DOMAIN-CONTAINING PROTEIN', 243317),
(338424, 'PTHR45854:SF4', NULL, NULL, NULL, NULL, 'ARF-GAP WITH SH3 DOMAIN, ANK REPEAT AND PH DOMAIN-CONTAINING PROTEIN 2', 243318),
(338425, 'PTHR45854', NULL, NULL, NULL, NULL, 'ASAP FAMILY MEMBER', 243318),
(338426, 'PTHR45854:SF3', NULL, NULL, NULL, NULL, 'ARFGAP WITH SH3 DOMAIN, ANK REPEAT AND PH DOMAIN-CONTAINING PROTEIN', 243318),
(338427, 'PTHR45854:SF2', NULL, NULL, NULL, NULL, 'ARF-GAP WITH SH3 DOMAIN, ANK REPEAT AND PH DOMAIN-CONTAINING PROTEIN 1', 243318),
(338428, 'PTHR45854:SF1', NULL, NULL, NULL, NULL, 'ARF-GAP WITH SH3 DOMAIN, ANK REPEAT AND PH DOMAIN-CONTAINING PROTEIN 3', 243318),
(338429, 'PTHR45854:SF5', NULL, NULL, NULL, NULL, 'UN-NAMED SA1614', 243318),
(338430, 'PTHR30606:SF9', NULL, NULL, NULL, NULL, 'LIPID A BIOSYNTHESIS LAUROYLTRANSFERASE', 243319),
(338431, 'PTHR30606:SF4', NULL, NULL, NULL, NULL, 'LIPID A BIOSYNTHESIS MYRISTOYLTRANSFERASE', 243319),
(338432, 'PTHR30606:SF7', NULL, NULL, NULL, NULL, 'LIPID A BIOSYNTHESIS PALMITOLEOYLTRANSFERASE', 243319),
(338433, 'PTHR30606', NULL, NULL, NULL, NULL, 'LIPID A BIOSYNTHESIS LAUROYL ACYLTRANSFERASE', 243319),
(338434, 'PTHR47348:SF3', NULL, NULL, NULL, NULL, 'MEIOTICALLY UP-REGULATED GENE 190 PROTEIN', 243320),
(338435, 'PTHR47348', NULL, NULL, NULL, NULL, 'MEIOTICALLY UP-REGULATED GENE 190 PROTEIN', 243320),
(338436, 'PTHR47348:SF2', NULL, NULL, NULL, NULL, 'MEIOTICALLY UP-REGULATED 190 PROTEIN', 243320),
(338437, 'PTHR11864:SF20', NULL, NULL, NULL, NULL, 'PRE-MRNA-PROCESSING FACTOR 40 HOMOLOG A', 243321),
(338438, 'PTHR11864:SF31', NULL, NULL, NULL, NULL, 'PRE-MRNA-PROCESSING PROTEIN 40A-LIKE ISOFORM X1', 243321),
(338439, 'PTHR11864:SF30', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR URN1', 243321),
(338440, 'PTHR11864:SF35', NULL, NULL, NULL, NULL, '', 243321),
(338441, 'PTHR11864:SF34', NULL, NULL, NULL, NULL, 'PRE-MRNA-PROCESSING PROTEIN 40A-LIKE ISOFORM X1', 243321),
(338442, 'PTHR11864', NULL, NULL, NULL, NULL, 'PRE-MRNA-PROCESSING PROTEIN PRP40', 243321),
(338443, 'PTHR11864:SF23', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR DRE4', 243321),
(338444, 'PTHR11864:SF33', NULL, NULL, NULL, NULL, 'PRE-MRNA-PROCESSING PROTEIN 40B', 243321),
(338445, 'PTHR11864:SF32', NULL, NULL, NULL, NULL, 'PRE-MRNA-PROCESSING PROTEIN 40A-LIKE', 243321),
(338446, 'PTHR11864:SF0', NULL, NULL, NULL, NULL, 'PRP40 PRE-MRNA PROCESSING FACTOR 40 HOMOLOG A (YEAST)', 243321),
(338447, 'PTHR11864:SF27', NULL, NULL, NULL, NULL, 'WW DOMAIN, FF DOMAIN PROTEIN-RELATED', 243321),
(338448, 'PTHR11864:SF1', NULL, NULL, NULL, NULL, 'PRE-MRNA-PROCESSING FACTOR 40 HOMOLOG B', 243321),
(338449, 'PTHR47358:SF3', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HOS1-LIKE', 243322),
(338450, 'PTHR47358:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HOS1', 243322),
(338451, 'PTHR47358', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HOS1', 243322),
(338452, 'PTHR28358:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 127', 243323),
(338453, 'PTHR28358', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 127', 243323),
(338454, 'PTHR15273', NULL, NULL, NULL, NULL, 'DAN DOMAIN FAMILY MEMBER 5', 243324),
(338455, 'PTHR15273:SF4', NULL, NULL, NULL, NULL, 'CERBERUS', 243324),
(338456, 'PTHR15273:SF5', NULL, NULL, NULL, NULL, 'DAN DOMAIN FAMILY MEMBER 5', 243324),
(338457, 'PTHR37229:SF2', NULL, NULL, NULL, NULL, '6,7-DIMETHYL-8-RIBITYLLUMAZINE SYNTHASE', 243325),
(338458, 'PTHR37229', NULL, NULL, NULL, NULL, '6,7-DIMETHYL-8-RIBITYLLUMAZINE SYNTHASE', 243325),
(338459, 'PTHR16291', NULL, NULL, NULL, NULL, 'NUCLEAR CAP-BINDING PROTEIN SUBUNIT 3', 243326),
(338460, 'PTHR16291:SF0', NULL, NULL, NULL, NULL, 'NUCLEAR CAP-BINDING PROTEIN SUBUNIT 3', 243326),
(338461, 'PTHR23021:SF76', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS T', 243327),
(338462, 'PTHR23021:SF32', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS T', 243327);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(338463, 'PTHR23021:SF11', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS T', 243327),
(338464, 'PTHR23021:SF33', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS T', 243327),
(338465, 'PTHR23021:SF78', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS T', 243327),
(338466, 'PTHR23021', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS T', 243327),
(338467, 'PTHR23021:SF31', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS T', 243327),
(338468, 'PTHR23021:SF18', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS T', 243327),
(338469, 'PTHR23021:SF19', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS T', 243327),
(338470, 'PTHR23021:SF14', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS T', 243327),
(338471, 'PTHR23021:SF36', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS T', 243327),
(338472, 'PTHR23021:SF37', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS T', 243327),
(338473, 'PTHR23021:SF38', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS T', 243327),
(338474, 'PTHR23021:SF16', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS T', 243327),
(338475, 'PTHR23021:SF17', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS T', 243327),
(338476, 'PTHR23021:SF82', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS T', 243327),
(338477, 'PTHR23021:SF43', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS T', 243327),
(338478, 'PTHR23021:SF87', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS T', 243327),
(338479, 'PTHR23021:SF22', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS T', 243327),
(338480, 'PTHR23021:SF23', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS T', 243327),
(338481, 'PTHR23021:SF24', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS T', 243327),
(338482, 'PTHR23021:SF83', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS T', 243327),
(338483, 'PTHR23021:SF86', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS T', 243327),
(338484, 'PTHR23021:SF47', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS T', 243327),
(338485, 'PTHR23021:SF26', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS T', 243327),
(338486, 'PTHR23021:SF48', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS T', 243327),
(338487, 'PTHR23021:SF49', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS T', 243327),
(338488, 'PTHR23021:SF28', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS T-RELATED', 243327),
(338489, 'PTHR47569:SF2', NULL, NULL, NULL, NULL, 'NO-ASSOCIATED PROTEIN 1, CHLOROPLASTIC/MITOCHONDRIAL', 243328),
(338490, 'PTHR47569', NULL, NULL, NULL, NULL, 'NO-ASSOCIATED PROTEIN 1, CHLOROPLASTIC/MITOCHONDRIAL', 243328),
(338491, 'PTHR37516', NULL, NULL, NULL, NULL, 'SCA1 COMPLEX SCAFFOLD PROTEIN SCAA', 243329),
(338492, 'PTHR37516:SF2', NULL, NULL, NULL, NULL, '', 243329),
(338493, 'PTHR37516:SF1', NULL, NULL, NULL, NULL, 'SCA1 COMPLEX SCAFFOLD PROTEIN SCAA', 243329),
(338494, 'PTHR36447:SF2', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE YESZ', 243330),
(338495, 'PTHR36447:SF1', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE GANA', 243330),
(338496, 'PTHR36447', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE GANA', 243330),
(338497, 'PTHR21459', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243331),
(338498, 'PTHR21459:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG08968', 243331),
(338499, 'PTHR36902:SF1', NULL, NULL, NULL, NULL, '', 243332),
(338500, 'PTHR36902', NULL, NULL, NULL, NULL, '', 243332),
(338501, 'PTHR19865', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RNA INTERACTING PROTEIN 2', 243333),
(338502, 'PTHR19865:SF8', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 243333),
(338503, 'PTHR19865:SF11', NULL, NULL, NULL, NULL, 'BNAA08G02260D PROTEIN', 243333),
(338504, 'PTHR19865:SF2', NULL, NULL, NULL, NULL, 'F-BOX AND WD REPEAT DOMAIN-CONTAINING 11-A', 243333),
(338505, 'PTHR19865:SF0', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RNA-INTERACTING PROTEIN 2', 243333),
(338506, 'PTHR19865:SF1', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 243333),
(338507, 'PTHR31601', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S36, MITOCHONDRIAL', 243334);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(338508, 'PTHR31601:SF3', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S36, MITOCHONDRIAL', 243334),
(338509, 'PTHR31601:SF2', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S36, MITOCHONDRIAL', 243334),
(338510, 'PTHR30503', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243335),
(338511, 'PTHR30503:SF3', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YEDI', 243335),
(338512, 'PTHR22670:SF8', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 243336),
(338513, 'PTHR22670', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243336),
(338514, 'PTHR22670:SF1', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 243336),
(338515, 'PTHR10412:SF20', NULL, NULL, NULL, NULL, 'MANNOSYL-OLIGOSACCHARIDE GLUCOSIDASE GCS1', 243337),
(338516, 'PTHR10412', NULL, NULL, NULL, NULL, 'MANNOSYL-OLIGOSACCHARIDE GLUCOSIDASE', 243337),
(338517, 'PTHR10412:SF11', NULL, NULL, NULL, NULL, 'MANNOSYL-OLIGOSACCHARIDE GLUCOSIDASE', 243337),
(338518, 'PTHR10412:SF10', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_63 DOMAIN-CONTAINING PROTEIN', 243337),
(338519, 'PTHR10412:SF21', NULL, NULL, NULL, NULL, 'ALPHA,ALPHA-TREHALASE', 243337),
(338520, 'PTHR10412:SF17', NULL, NULL, NULL, NULL, 'ALPHA-GLUCOSIDASE 2', 243337),
(338521, 'PTHR10412:SF16', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_63 DOMAIN-CONTAINING PROTEIN', 243337),
(338522, 'PTHR10412:SF19', NULL, NULL, NULL, NULL, 'BNAANNG25530D PROTEIN', 243337),
(338523, 'PTHR37824:SF1', NULL, NULL, NULL, NULL, 'IRON-REGULATED SURFACE DETERMINANT PROTEIN C', 243338),
(338524, 'PTHR37824', NULL, NULL, NULL, NULL, 'IRON-REGULATED SURFACE DETERMINANT PROTEIN C', 243338),
(338525, 'PTHR21402:SF9', NULL, NULL, NULL, NULL, 'GAMETOCYTE-SPECIFIC FACTOR 1', 243339),
(338526, 'PTHR21402', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243339),
(338527, 'PTHR21402:SF5', NULL, NULL, NULL, NULL, 'ZGC:56699', 243339),
(338528, 'PTHR21402:SF6', NULL, NULL, NULL, NULL, 'GAMETOCYTE-SPECIFIC FACTOR 2', 243339),
(338529, 'PTHR21402:SF3', NULL, NULL, NULL, NULL, 'GAMETOCYTE-SPECIFIC FACTOR 1-LIKE', 243339),
(338530, 'PTHR21402:SF10', NULL, NULL, NULL, NULL, 'U11/U12 SMALL NUCLEAR RIBONUCLEOPROTEIN 48 KDA PROTEIN', 243339),
(338531, 'PTHR21402:SF12', NULL, NULL, NULL, NULL, 'BNAA05G33160D PROTEIN', 243339),
(338532, 'PTHR21402:SF13', NULL, NULL, NULL, NULL, 'GAMETOCYTE SPECIFIC FACTOR 2', 243339),
(338533, 'PTHR44436', NULL, NULL, NULL, NULL, 'F-BOX/WD REPEAT-CONTAINING PROTEIN 2', 243340),
(338534, 'PTHR44436:SF1', NULL, NULL, NULL, NULL, 'F-BOX/WD REPEAT-CONTAINING PROTEIN 2', 243340),
(338535, 'PTHR20991:SF0', NULL, NULL, NULL, NULL, 'PROTEIN PTHB1', 243341),
(338536, 'PTHR20991', NULL, NULL, NULL, NULL, 'PARATHYROID HORMONE-RESPONSIVE B1 GENE', 243341),
(338537, 'PTHR45891:SF4', NULL, NULL, NULL, NULL, 'ZINC FINGER HOMEOBOX PROTEIN 3', 243342),
(338538, 'PTHR45891', NULL, NULL, NULL, NULL, 'ZINC FINGER HOMEOBOX PROTEIN', 243342),
(338539, 'PTHR45891:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER HOMEOBOX PROTEIN 2', 243342),
(338540, 'PTHR45891:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER HOMEOBOX PROTEIN 4', 243342),
(338541, 'PTHR45891:SF3', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 2', 243342),
(338542, 'PTHR37314:SF4', NULL, NULL, NULL, NULL, 'UPF0700 TRANSMEMBRANE PROTEIN YOAK', 243343),
(338543, 'PTHR37314:SF5', NULL, NULL, NULL, NULL, 'SLR0142 PROTEIN', 243343),
(338544, 'PTHR37314', NULL, NULL, NULL, NULL, 'SLR0142 PROTEIN', 243343),
(338545, 'PTHR30540:SF123', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 11', 243344),
(338546, 'PTHR30540:SF121', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 3-RELATED', 243344),
(338547, 'PTHR30540:SF120', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243344),
(338548, 'PTHR30540:SF127', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243344),
(338549, 'PTHR30540:SF126', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243344),
(338550, 'PTHR30540:SF125', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243344),
(338551, 'PTHR30540:SF19', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 15-RELATED', 243344),
(338552, 'PTHR30540:SF17', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 24', 243344);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(338553, 'PTHR30540:SF14', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 1', 243344),
(338554, 'PTHR30540:SF15', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 19', 243344),
(338555, 'PTHR30540:SF13', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 17-RELATED', 243344),
(338556, 'PTHR30540:SF10', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 8', 243344),
(338557, 'PTHR30540:SF98', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 6', 243344),
(338558, 'PTHR30540:SF99', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243344),
(338559, 'PTHR30540:SF129', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243344),
(338560, 'PTHR30540:SF97', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243344),
(338561, 'PTHR30540:SF94', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 5', 243344),
(338562, 'PTHR30540:SF95', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 10', 243344),
(338563, 'PTHR30540:SF93', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 12-RELATED', 243344),
(338564, 'PTHR30540:SF112', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 27', 243344),
(338565, 'PTHR30540:SF110', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243344),
(338566, 'PTHR30540:SF116', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243344),
(338567, 'PTHR30540:SF115', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243344),
(338568, 'PTHR30540:SF114', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243344),
(338569, 'PTHR30540:SF27', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243344),
(338570, 'PTHR30540:SF28', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 21', 243344),
(338571, 'PTHR30540:SF23', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 16-RELATED', 243344),
(338572, 'PTHR30540:SF24', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 22', 243344),
(338573, 'PTHR30540:SF119', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243344),
(338574, 'PTHR30540:SF20', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 6', 243344),
(338575, 'PTHR30540:SF117', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243344),
(338576, 'PTHR30540:SF101', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243344),
(338577, 'PTHR30540:SF100', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 13', 243344),
(338578, 'PTHR30540:SF142', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 9-RELATED', 243344),
(338579, 'PTHR30540:SF105', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243344),
(338580, 'PTHR30540:SF104', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243344),
(338581, 'PTHR30540:SF103', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 25', 243344),
(338582, 'PTHR30540:SF102', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 1', 243344),
(338583, 'PTHR30540:SF141', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243344),
(338584, 'PTHR30540:SF140', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 2-RELATED', 243344),
(338585, 'PTHR30540:SF79', NULL, NULL, NULL, NULL, 'LOW AFFINITY POTASSIUM TRANSPORT SYSTEM PROTEIN KUP', 243344),
(338586, 'PTHR30540:SF109', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243344),
(338587, 'PTHR30540:SF108', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 3', 243344),
(338588, 'PTHR30540:SF33', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 4-RELATED', 243344),
(338589, 'PTHR30540:SF31', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 18', 243344),
(338590, 'PTHR30540:SF106', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 26', 243344),
(338591, 'PTHR30540:SF90', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243344),
(338592, 'PTHR30540:SF134', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243344),
(338593, 'PTHR30540:SF8', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 7', 243344),
(338594, 'PTHR30540:SF138', NULL, NULL, NULL, NULL, 'OS02G0681800 PROTEIN', 243344),
(338595, 'PTHR30540:SF137', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243344),
(338596, 'PTHR30540:SF136', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243344),
(338597, 'PTHR30540:SF135', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243344),
(338598, 'PTHR30540:SF130', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243344);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(338599, 'PTHR30540:SF4', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 12-RELATED', 243344),
(338600, 'PTHR30540:SF87', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243344),
(338601, 'PTHR30540:SF88', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 13-RELATED', 243344),
(338602, 'PTHR30540:SF6', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 2', 243344),
(338603, 'PTHR30540:SF85', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 9', 243344),
(338604, 'PTHR30540:SF139', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243344),
(338605, 'PTHR30540:SF83', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER 4', 243344),
(338606, 'PTHR30540:SF84', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243344),
(338607, 'PTHR30540:SF81', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243344),
(338608, 'PTHR30540', NULL, NULL, NULL, NULL, 'OSMOTIC STRESS POTASSIUM TRANSPORTER', 243344),
(338609, 'PTHR30540:SF82', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 243344),
(338610, 'PTHR10648:SF32', NULL, NULL, NULL, NULL, 'BNACNNG04640D PROTEIN', 243345),
(338611, 'PTHR10648:SF36', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 65 KDA REGULATORY SUBUNIT A BETA ISOFORM-RELATED', 243345),
(338612, 'PTHR10648:SF35', NULL, NULL, NULL, NULL, 'ARMADILLO-TYPE FOLD PROTEIN-RELATED', 243345),
(338613, 'PTHR10648', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP2A 65 KDA REGULATORY SUBUNIT', 243345),
(338614, 'PTHR10648:SF2', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 65 KDA REGULATORY SUBUNIT A ALPHA ISOFORM', 243345),
(338615, 'PTHR10648:SF24', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 65 KDA REGULATORY SUBUNIT A BETA ISOFORM', 243345),
(338616, 'PTHR10648:SF34', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT, PUTATIVE-RELATED', 243345),
(338617, 'PTHR10648:SF1', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 4 REGULATORY SUBUNIT 1', 243345),
(338618, 'PTHR10648:SF23', NULL, NULL, NULL, NULL, 'PHOSPHATASE 2A REGULATORY SUBUNIT, PUTATIVE-RELATED', 243345),
(338619, 'PTHR10648:SF33', NULL, NULL, NULL, NULL, 'ARMADILLO-TYPE FOLD PROTEIN-RELATED', 243345),
(338620, 'PTHR10648:SF29', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 65 KDA REGULATORY SUBUNIT A ALPHA ISOFORM', 243345),
(338621, 'PTHR10648:SF7', NULL, NULL, NULL, NULL, 'WRNPLPNID DOMAIN-CONTAINING PROTEIN', 243345),
(338622, 'PTHR10648:SF4', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2 (FORMERLY 2A), REGULATORY SUBUNIT A, BETA ISOFORM-RELATED', 243345),
(338623, 'PTHR10648:SF37', NULL, NULL, NULL, NULL, 'RRP12-LIKE PROTEIN', 243345),
(338624, 'PTHR10648:SF9', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 65 KDA REGULATORY SUBUNIT A BETA ISOFORM', 243345),
(338625, 'PTHR10648:SF8', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 4 REGULATORY SUBUNIT 1', 243345),
(338626, 'PTHR33970:SF1', NULL, NULL, NULL, NULL, 'VIOLAXANTHIN DE-EPOXIDASE, CHLOROPLASTIC', 243346),
(338627, 'PTHR33970:SF2', NULL, NULL, NULL, NULL, 'OS01G0716400 PROTEIN', 243346),
(338628, 'PTHR33970', NULL, NULL, NULL, NULL, 'VIOLAXANTHIN DE-EPOXIDASE, CHLOROPLASTIC-RELATED', 243346),
(338629, 'PTHR39532:SF4', NULL, NULL, NULL, NULL, '', 243347),
(338630, 'PTHR39532:SF3', NULL, NULL, NULL, NULL, '', 243347),
(338631, 'PTHR39532:SF1', NULL, NULL, NULL, NULL, '', 243347),
(338632, 'PTHR39532', NULL, NULL, NULL, NULL, '', 243347),
(338633, 'PTHR46487:SF1', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN XRCC3', 243348),
(338634, 'PTHR46487:SF2', NULL, NULL, NULL, NULL, 'BNAC03G12950D PROTEIN', 243348),
(338635, 'PTHR46487', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN XRCC3', 243348),
(338636, 'PTHR28524:SF3', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE ASSEMBLY FACTOR 4, MITOCHONDRIAL', 243349),
(338637, 'PTHR28524', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE ASSEMBLY FACTOR 4, MITOCHONDRIAL', 243349),
(338638, 'PTHR30002:SF4', NULL, NULL, NULL, NULL, 'EPOXYQUEUOSINE REDUCTASE', 243350),
(338639, 'PTHR30002', NULL, NULL, NULL, NULL, 'EPOXYQUEUOSINE REDUCTASE', 243350);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(338640, 'PTHR31947:SF42', NULL, NULL, NULL, NULL, 'ALBA DNA/RNA-BINDING PROTEIN', 243351),
(338641, 'PTHR31947:SF31', NULL, NULL, NULL, NULL, 'ALBA DOMAIN-CONTAINING PROTEIN', 243351),
(338642, 'PTHR31947:SF30', NULL, NULL, NULL, NULL, 'DNA/RNA-BINDING PROTEIN ALBA-LIKE PROTEIN-RELATED', 243351),
(338643, 'PTHR31947:SF44', NULL, NULL, NULL, NULL, 'ALBA DOMAIN-CONTAINING PROTEIN', 243351),
(338644, 'PTHR31947:SF43', NULL, NULL, NULL, NULL, 'ALBA DNA/RNA-BINDING PROTEIN', 243351),
(338645, 'PTHR31947:SF46', NULL, NULL, NULL, NULL, 'ALBA DOMAIN-CONTAINING PROTEIN', 243351),
(338646, 'PTHR31947:SF24', NULL, NULL, NULL, NULL, 'ALBA DNA/RNA-BINDING-LIKE PROTEIN', 243351),
(338647, 'PTHR31947:SF35', NULL, NULL, NULL, NULL, 'ALBA DOMAIN-CONTAINING PROTEIN', 243351),
(338648, 'PTHR31947:SF45', NULL, NULL, NULL, NULL, 'ALBA DOMAIN-CONTAINING PROTEIN', 243351),
(338649, 'PTHR31947:SF34', NULL, NULL, NULL, NULL, 'BNAC05G09730D PROTEIN', 243351),
(338650, 'PTHR31947:SF23', NULL, NULL, NULL, NULL, 'ALBA DOMAIN-CONTAINING PROTEIN', 243351),
(338651, 'PTHR31947', NULL, NULL, NULL, NULL, 'DNA/RNA-BINDING PROTEIN ALBA 3', 243351),
(338652, 'PTHR31947:SF37', NULL, NULL, NULL, NULL, 'ALBA DOMAIN-CONTAINING PROTEIN', 243351),
(338653, 'PTHR31947:SF15', NULL, NULL, NULL, NULL, 'ALBA DOMAIN-CONTAINING PROTEIN', 243351),
(338654, 'PTHR31947:SF36', NULL, NULL, NULL, NULL, 'ALBA DOMAIN-CONTAINING PROTEIN', 243351),
(338655, 'PTHR31947:SF14', NULL, NULL, NULL, NULL, 'OS01G0173100 PROTEIN', 243351),
(338656, 'PTHR31947:SF17', NULL, NULL, NULL, NULL, 'ALBA DOMAIN-CONTAINING PROTEIN', 243351),
(338657, 'PTHR31947:SF28', NULL, NULL, NULL, NULL, 'DNA/RNA-BINDING PROTEIN ALBA-LIKE PROTEIN-RELATED', 243351),
(338658, 'PTHR31947:SF19', NULL, NULL, NULL, NULL, 'ALBA DNA/RNA-BINDING PROTEIN', 243351),
(338659, 'PTHR31947:SF18', NULL, NULL, NULL, NULL, 'ALBA DNA/RNA-BINDING PROTEIN', 243351),
(338660, 'PTHR31947:SF29', NULL, NULL, NULL, NULL, 'ALBA DOMAIN-CONTAINING PROTEIN', 243351),
(338661, 'PTHR22888:SF20', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 2', 243352),
(338662, 'PTHR22888', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE, SUBUNIT II', 243352),
(338663, 'PTHR22888:SF10', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 2', 243352),
(338664, 'PTHR22888:SF24', NULL, NULL, NULL, NULL, 'COX2_TM DOMAIN-CONTAINING PROTEIN', 243352),
(338665, 'PTHR22888:SF25', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 2', 243352),
(338666, 'PTHR22888:SF18', NULL, NULL, NULL, NULL, 'CYTOCHROME BO(3) UBIQUINOL OXIDASE SUBUNIT 2', 243352),
(338667, 'PTHR22888:SF9', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 2', 243352),
(338668, 'PTHR34981:SF1', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN ZAPA', 243353),
(338669, 'PTHR34981', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN ZAPA', 243353),
(338670, 'PTHR46125:SF18', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 24', 243354),
(338671, 'PTHR46125:SF7', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 28 ISOFORM X1', 243354),
(338672, 'PTHR46125', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 28', 243354),
(338673, 'PTHR46125:SF22', NULL, NULL, NULL, NULL, 'BNAA05G19840D PROTEIN', 243354),
(338674, 'PTHR46125:SF11', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 24-LIKE', 243354),
(338675, 'PTHR46125:SF10', NULL, NULL, NULL, NULL, 'TIFY DOMAIN-CONTAINING PROTEIN', 243354),
(338676, 'PTHR46125:SF21', NULL, NULL, NULL, NULL, 'BNAA03G46720D PROTEIN', 243354),
(338677, 'PTHR46125:SF13', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 19', 243354),
(338678, 'PTHR46125:SF24', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 17', 243354),
(338679, 'PTHR46125:SF23', NULL, NULL, NULL, NULL, 'OS11G0572901 PROTEIN', 243354),
(338680, 'PTHR46125:SF15', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR', 243354),
(338681, 'PTHR46125:SF9', NULL, NULL, NULL, NULL, '', 243354),
(338682, 'PTHR46125:SF26', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 18', 243354),
(338683, 'PTHR46125:SF25', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 28', 243354);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(338684, 'PTHR46125:SF20', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 25', 243354),
(338685, 'PTHR27009:SF283', NULL, NULL, NULL, NULL, 'MALECTIN/RECEPTOR-LIKE KINASE FAMILY PROTEIN', 243355),
(338686, 'PTHR27009:SF284', NULL, NULL, NULL, NULL, 'RUST RESISTANCE KINASE LR10-LIKE', 243355),
(338687, 'PTHR27009:SF280', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355),
(338688, 'PTHR27009:SF324', NULL, NULL, NULL, NULL, 'OS01G0113800 PROTEIN', 243355),
(338689, 'PTHR27009:SF325', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 2.5', 243355),
(338690, 'PTHR27009:SF168', NULL, NULL, NULL, NULL, 'G-TYPE LECTIN S-RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE RLK1', 243355),
(338691, 'PTHR27009:SF322', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 243355),
(338692, 'PTHR27009:SF323', NULL, NULL, NULL, NULL, 'OS01G0113200 PROTEIN', 243355),
(338693, 'PTHR27009:SF287', NULL, NULL, NULL, NULL, 'OS01G0117700 PROTEIN', 243355),
(338694, 'PTHR27009:SF320', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE', 243355),
(338695, 'PTHR27009:SF321', NULL, NULL, NULL, NULL, 'TYROSINE KINASE FAMILY PROTEIN', 243355),
(338696, 'PTHR27009:SF288', NULL, NULL, NULL, NULL, 'RUST RESISTANCE KINASE LR10-LIKE', 243355),
(338697, 'PTHR27009:SF328', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355),
(338698, 'PTHR27009:SF329', NULL, NULL, NULL, NULL, 'OS01G0113700 PROTEIN', 243355),
(338699, 'PTHR27009:SF326', NULL, NULL, NULL, NULL, 'STRESS-INDUCED RECEPTOR-LIKE KINASE', 243355),
(338700, 'PTHR27009:SF327', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE', 243355),
(338701, 'PTHR27009:SF171', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 243355),
(338702, 'PTHR27009:SF292', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355),
(338703, 'PTHR27009:SF172', NULL, NULL, NULL, NULL, 'RECEPTOR KINASE', 243355),
(338704, 'PTHR27009:SF290', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355),
(338705, 'PTHR27009:SF170', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 243355),
(338706, 'PTHR27009:SF291', NULL, NULL, NULL, NULL, 'RUST RESISTANCE KINASE LR10-LIKE', 243355),
(338707, 'PTHR27009:SF335', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 2.1', 243355),
(338708, 'PTHR27009:SF336', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355),
(338709, 'PTHR27009:SF333', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 2.1 ISOFORM X1', 243355),
(338710, 'PTHR27009:SF179', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 243355),
(338711, 'PTHR27009:SF334', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 2.5', 243355),
(338712, 'PTHR27009:SF213', NULL, NULL, NULL, NULL, 'S-LOCUS RECEPTOR-LIKE PROTEIN KINASE FAMILY PROTEIN-RELATED', 243355),
(338713, 'PTHR27009:SF331', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355),
(338714, 'PTHR27009:SF299', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 243355),
(338715, 'PTHR27009:SF332', NULL, NULL, NULL, NULL, 'RECEPTOR SERINE/THREONINE KINASE-LIKE PROTEIN', 243355),
(338716, 'PTHR27009:SF178', NULL, NULL, NULL, NULL, 'RUST RESISTANCE KINASE LR10-LIKE ISOFORM X1', 243355),
(338717, 'PTHR27009:SF296', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355),
(338718, 'PTHR27009:SF175', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 243355),
(338719, 'PTHR27009:SF330', NULL, NULL, NULL, NULL, 'KINASE', 243355),
(338720, 'PTHR27009:SF218', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 243355),
(338721, 'PTHR27009:SF339', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE', 243355),
(338722, 'PTHR27009:SF337', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(338723, 'PTHR27009:SF338', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 2.4', 243355),
(338724, 'PTHR27009:SF346', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355),
(338725, 'PTHR27009:SF105', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355),
(338726, 'PTHR27009:SF347', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 2.4', 243355),
(338727, 'PTHR27009:SF344', NULL, NULL, NULL, NULL, 'RUST RESISTANCE KINASE LR10-LIKE ISOFORM X1', 243355),
(338728, 'PTHR27009:SF224', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 243355),
(338729, 'PTHR27009', NULL, NULL, NULL, NULL, 'RUST RESISTANCE KINASE LR10-RELATED', 243355),
(338730, 'PTHR27009:SF345', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 2.4', 243355),
(338731, 'PTHR27009:SF100', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RLK (RECEPTOR-LIKE KINASE) PROTEIN', 243355),
(338732, 'PTHR27009:SF342', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355),
(338733, 'PTHR27009:SF343', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 2.5', 243355),
(338734, 'PTHR27009:SF340', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355),
(338735, 'PTHR27009:SF341', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 243355),
(338736, 'PTHR27009:SF61', NULL, NULL, NULL, NULL, 'RUST RESISTANCE KINASE LR10-LIKE ISOFORM X1', 243355),
(338737, 'PTHR27009:SF64', NULL, NULL, NULL, NULL, 'OS11G0441900 PROTEIN', 243355),
(338738, 'PTHR27009:SF106', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 2.1', 243355),
(338739, 'PTHR27009:SF348', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355),
(338740, 'PTHR27009:SF107', NULL, NULL, NULL, NULL, 'OS01G0113300 PROTEIN', 243355),
(338741, 'PTHR27009:SF349', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 243355),
(338742, 'PTHR27009:SF228', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355),
(338743, 'PTHR27009:SF350', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355),
(338744, 'PTHR27009:SF191', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 243355),
(338745, 'PTHR27009:SF113', NULL, NULL, NULL, NULL, 'PR5-LIKE RECEPTOR KINASE', 243355),
(338746, 'PTHR27009:SF234', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 2.1', 243355),
(338747, 'PTHR27009:SF353', NULL, NULL, NULL, NULL, 'OS01G0137250 PROTEIN', 243355),
(338748, 'PTHR27009:SF354', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR KINASE-LIKE PROTEIN', 243355),
(338749, 'PTHR27009:SF351', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355),
(338750, 'PTHR27009:SF230', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 243355),
(338751, 'PTHR27009:SF80', NULL, NULL, NULL, NULL, 'RECEPTOR SERINE/THREONINE KINASE', 243355),
(338752, 'PTHR27009:SF352', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 243355),
(338753, 'PTHR27009:SF110', NULL, NULL, NULL, NULL, 'RUST RESISTANCE KINASE LR10-LIKE', 243355),
(338754, 'PTHR27009:SF73', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355),
(338755, 'PTHR27009:SF74', NULL, NULL, NULL, NULL, 'OS01G0114600 PROTEIN', 243355),
(338756, 'PTHR27009:SF119', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 2.2-RELATED', 243355),
(338757, 'PTHR27009:SF75', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 2.4-RELATED', 243355),
(338758, 'PTHR27009:SF117', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE, PROTEIN KINASE RLK-PELLE-LRK10L-2 FAMILY-RELATED', 243355),
(338759, 'PTHR27009:SF118', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(338760, 'PTHR27009:SF77', NULL, NULL, NULL, NULL, '', 243355),
(338761, 'PTHR27009:SF240', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE 4', 243355),
(338762, 'PTHR27009:SF126', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RLK (RECEPTOR-LIKE KINASE) PROTEIN', 243355),
(338763, 'PTHR27009:SF246', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 243355),
(338764, 'PTHR27009:SF123', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355),
(338765, 'PTHR27009:SF121', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355),
(338766, 'PTHR27009:SF242', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 243355),
(338767, 'PTHR27009:SF82', NULL, NULL, NULL, NULL, 'RUST RESISTANCE KINASE LR10-LIKE', 243355),
(338768, 'PTHR27009:SF128', NULL, NULL, NULL, NULL, 'RECEPTOR SERINE/THREONINE KINASE', 243355),
(338769, 'PTHR27009:SF250', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 243355),
(338770, 'PTHR27009:SF130', NULL, NULL, NULL, NULL, 'OS08G0335500 PROTEIN', 243355),
(338771, 'PTHR27009:SF256', NULL, NULL, NULL, NULL, 'OSJNBB0022F16.11-LIKE PROTEIN', 243355),
(338772, 'PTHR27009:SF254', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 243355),
(338773, 'PTHR27009:SF134', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE', 243355),
(338774, 'PTHR27009:SF96', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 2.7-RELATED', 243355),
(338775, 'PTHR27009:SF97', NULL, NULL, NULL, NULL, 'OS01G0138300 PROTEIN', 243355),
(338776, 'PTHR27009:SF99', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE', 243355),
(338777, 'PTHR27009:SF12', NULL, NULL, NULL, NULL, 'OS06G0241100 PROTEIN', 243355),
(338778, 'PTHR27009:SF13', NULL, NULL, NULL, NULL, 'OS01G0138400 PROTEIN', 243355),
(338779, 'PTHR27009:SF140', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355),
(338780, 'PTHR27009:SF141', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355),
(338781, 'PTHR27009:SF260', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 243355),
(338782, 'PTHR27009:SF269', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355),
(338783, 'PTHR27009:SF303', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 243355),
(338784, 'PTHR27009:SF267', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355),
(338785, 'PTHR27009:SF301', NULL, NULL, NULL, NULL, 'TYROSINE KINASE FAMILY PROTEIN', 243355),
(338786, 'PTHR27009:SF265', NULL, NULL, NULL, NULL, 'MALECTIN/RECEPTOR-LIKE KINASE FAMILY PROTEIN', 243355),
(338787, 'PTHR27009:SF266', NULL, NULL, NULL, NULL, 'ACIDIC ENDOCHITINASE', 243355),
(338788, 'PTHR27009:SF263', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 243355),
(338789, 'PTHR27009:SF264', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355),
(338790, 'PTHR27009:SF143', NULL, NULL, NULL, NULL, 'OSJNBB0022F16.11-LIKE PROTEIN', 243355),
(338791, 'PTHR27009:SF306', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355),
(338792, 'PTHR27009:SF304', NULL, NULL, NULL, NULL, 'RUST RESISTANCE KINASE LR10-LIKE ISOFORM X1', 243355),
(338793, 'PTHR27009:SF26', NULL, NULL, NULL, NULL, 'OS04G0655300 PROTEIN', 243355),
(338794, 'PTHR27009:SF151', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 243355),
(338795, 'PTHR27009:SF273', NULL, NULL, NULL, NULL, 'OS01G0690800 PROTEIN', 243355),
(338796, 'PTHR27009:SF150', NULL, NULL, NULL, NULL, 'RUST RESISTANCE KINASE LR10', 243355),
(338797, 'PTHR27009:SF271', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355),
(338798, 'PTHR27009:SF313', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355),
(338799, 'PTHR27009:SF159', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 243355),
(338800, 'PTHR27009:SF314', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(338801, 'PTHR27009:SF311', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 243355),
(338802, 'PTHR27009:SF312', NULL, NULL, NULL, NULL, 'SUPERFAMILY PROTEIN, PUTATIVE-RELATED', 243355),
(338803, 'PTHR27009:SF276', NULL, NULL, NULL, NULL, 'MALECTIN/RECEPTOR-LIKE KINASE FAMILY PROTEIN', 243355),
(338804, 'PTHR27009:SF277', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355),
(338805, 'PTHR27009:SF310', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 243355),
(338806, 'PTHR27009:SF156', NULL, NULL, NULL, NULL, 'RUST RESISTANCE KINASE LR10-LIKE', 243355),
(338807, 'PTHR27009:SF274', NULL, NULL, NULL, NULL, 'MALECTIN/RECEPTOR-LIKE KINASE FAMILY PROTEIN', 243355),
(338808, 'PTHR27009:SF154', NULL, NULL, NULL, NULL, 'OS07G0141100 PROTEIN', 243355),
(338809, 'PTHR27009:SF319', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355),
(338810, 'PTHR27009:SF317', NULL, NULL, NULL, NULL, 'PR5-LIKE RECEPTOR KINASE', 243355),
(338811, 'PTHR27009:SF318', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE UNC-51-RELATED', 243355),
(338812, 'PTHR27009:SF315', NULL, NULL, NULL, NULL, 'OS01G0117200 PROTEIN', 243355),
(338813, 'PTHR27009:SF316', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243355),
(338814, 'PTHR47928:SF17', NULL, NULL, NULL, NULL, 'OS03G0441400 PROTEIN', 243356),
(338815, 'PTHR47928:SF167', NULL, NULL, NULL, NULL, 'FACTOR, PUTATIVE-RELATED', 243356),
(338816, 'PTHR47928:SF16', NULL, NULL, NULL, NULL, 'HORMA DOMAIN-CONTAINING PROTEIN', 243356),
(338817, 'PTHR47928:SF166', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338818, 'PTHR47928:SF165', NULL, NULL, NULL, NULL, 'OS02G0164600 PROTEIN', 243356),
(338819, 'PTHR47928:SF19', NULL, NULL, NULL, NULL, 'OS03G0795200 PROTEIN', 243356),
(338820, 'PTHR47928:SF18', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338821, 'PTHR47928:SF164', NULL, NULL, NULL, NULL, 'OS02G0625100 PROTEIN', 243356),
(338822, 'PTHR47928:SF15', NULL, NULL, NULL, NULL, 'OS05G0409800 PROTEIN', 243356),
(338823, 'PTHR47928:SF169', NULL, NULL, NULL, NULL, 'OS03G0169300 PROTEIN', 243356),
(338824, 'PTHR47928:SF14', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 243356),
(338825, 'PTHR47928:SF168', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338826, 'PTHR47928:SF20', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338827, 'PTHR47928:SF22', NULL, NULL, NULL, NULL, '', 243356),
(338828, 'PTHR47928:SF21', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338829, 'PTHR47928:SF163', NULL, NULL, NULL, NULL, 'REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN, PUTATIVE-RELATED', 243356),
(338830, 'PTHR47928:SF162', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338831, 'PTHR47928:SF161', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 243356),
(338832, 'PTHR47928:SF160', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 243356),
(338833, 'PTHR47928:SF175', NULL, NULL, NULL, NULL, 'OS07G0662700 PROTEIN', 243356),
(338834, 'PTHR47928:SF89', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 243356),
(338835, 'PTHR47928:SF91', NULL, NULL, NULL, NULL, 'OS06G0231400 PROTEIN', 243356),
(338836, 'PTHR47928:SF97', NULL, NULL, NULL, NULL, 'OS03G0635000 PROTEIN', 243356),
(338837, 'PTHR47928:SF96', NULL, NULL, NULL, NULL, '', 243356),
(338838, 'PTHR47928:SF11', NULL, NULL, NULL, NULL, 'OS01G0715900 PROTEIN', 243356),
(338839, 'PTHR47928:SF93', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 243356),
(338840, 'PTHR47928:SF92', NULL, NULL, NULL, NULL, '', 243356),
(338841, 'PTHR47928:SF95', NULL, NULL, NULL, NULL, 'OS11G0483950 PROTEIN', 243356),
(338842, 'PTHR47928:SF172', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338843, 'PTHR47928:SF94', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 243356); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(338844, 'PTHR47928:SF39', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338845, 'PTHR47928:SF189', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN MITOCHONDRIAL', 243356),
(338846, 'PTHR47928:SF38', NULL, NULL, NULL, NULL, 'OS10G0442700 PROTEIN', 243356),
(338847, 'PTHR47928:SF100', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN CHLOROPLASTIC/MITOCHONDRIAL', 243356),
(338848, 'PTHR47928:SF188', NULL, NULL, NULL, NULL, 'OS06G0112000 PROTEIN', 243356),
(338849, 'PTHR47928:SF186', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338850, 'PTHR47928:SF35', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 243356),
(338851, 'PTHR47928:SF34', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN, DYW DOMAIN PROTEIN-RELATED', 243356),
(338852, 'PTHR47928:SF104', NULL, NULL, NULL, NULL, 'OS01G0800400 PROTEIN', 243356),
(338853, 'PTHR47928:SF37', NULL, NULL, NULL, NULL, 'OS06G0216400 PROTEIN', 243356),
(338854, 'PTHR47928:SF103', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 243356),
(338855, 'PTHR47928:SF102', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 243356),
(338856, 'PTHR47928:SF36', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338857, 'PTHR47928:SF109', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338858, 'PTHR47928:SF107', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 243356),
(338859, 'PTHR47928:SF106', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338860, 'PTHR47928:SF42', NULL, NULL, NULL, NULL, 'OS03G0314400 PROTEIN', 243356),
(338861, 'PTHR47928:SF41', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338862, 'PTHR47928:SF44', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN OGR1, MITOCHONDRIAL', 243356),
(338863, 'PTHR47928:SF43', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN CHLOROPLASTIC', 243356),
(338864, 'PTHR47928:SF184', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE (PPR) REPEAT PROTEIN', 243356),
(338865, 'PTHR47928:SF40', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338866, 'PTHR47928:SF112', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338867, 'PTHR47928:SF28', NULL, NULL, NULL, NULL, 'OS01G0545900 PROTEIN', 243356),
(338868, 'PTHR47928:SF27', NULL, NULL, NULL, NULL, '', 243356),
(338869, 'PTHR47928:SF199', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 243356),
(338870, 'PTHR47928:SF111', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338871, 'PTHR47928:SF110', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 243356),
(338872, 'PTHR47928:SF198', NULL, NULL, NULL, NULL, '', 243356),
(338873, 'PTHR47928:SF29', NULL, NULL, NULL, NULL, 'OS06G0231100 PROTEIN', 243356),
(338874, 'PTHR47928:SF197', NULL, NULL, NULL, NULL, 'OS05G0586900 PROTEIN', 243356),
(338875, 'PTHR47928:SF24', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338876, 'PTHR47928', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 243356),
(338877, 'PTHR47928:SF116', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN-CONTAINING PROTEIN-RELATED', 243356),
(338878, 'PTHR47928:SF23', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 243356),
(338879, 'PTHR47928:SF115', NULL, NULL, NULL, NULL, 'OS02G0126500 PROTEIN', 243356),
(338880, 'PTHR47928:SF26', NULL, NULL, NULL, NULL, 'OS11G0109600 PROTEIN', 243356),
(338881, 'PTHR47928:SF114', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338882, 'PTHR47928:SF113', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 243356),
(338883, 'PTHR47928:SF25', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 243356),
(338884, 'PTHR47928:SF119', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 243356);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(338885, 'PTHR47928:SF118', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243356),
(338886, 'PTHR47928:SF117', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338887, 'PTHR47928:SF1', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338888, 'PTHR47928:SF2', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT PROTEIN-RELATED', 243356),
(338889, 'PTHR47928:SF5', NULL, NULL, NULL, NULL, 'OS02G0830000 PROTEIN', 243356),
(338890, 'PTHR47928:SF6', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 243356),
(338891, 'PTHR47928:SF3', NULL, NULL, NULL, NULL, 'REPEAT SUPERFAMILY PROTEIN, PUTATIVE-RELATED', 243356),
(338892, 'PTHR47928:SF4', NULL, NULL, NULL, NULL, 'OS04G0463800 PROTEIN', 243356),
(338893, 'PTHR47928:SF31', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338894, 'PTHR47928:SF192', NULL, NULL, NULL, NULL, 'OS09G0573000 PROTEIN', 243356),
(338895, 'PTHR47928:SF30', NULL, NULL, NULL, NULL, 'OS10G0400250 PROTEIN', 243356),
(338896, 'PTHR47928:SF191', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338897, 'PTHR47928:SF190', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN ELI1, CHLOROPLASTIC', 243356),
(338898, 'PTHR47928:SF33', NULL, NULL, NULL, NULL, 'OS01G0912900 PROTEIN', 243356),
(338899, 'PTHR47928:SF7', NULL, NULL, NULL, NULL, 'OS06G0143500 PROTEIN', 243356),
(338900, 'PTHR47928:SF8', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338901, 'PTHR47928:SF32', NULL, NULL, NULL, NULL, 'HELIX LOOP HELIX PROTEIN, PUTATIVE-RELATED', 243356),
(338902, 'PTHR47928:SF196', NULL, NULL, NULL, NULL, '', 243356),
(338903, 'PTHR47928:SF195', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 243356),
(338904, 'PTHR47928:SF194', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338905, 'PTHR47928:SF193', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338906, 'PTHR47928:SF123', NULL, NULL, NULL, NULL, 'OS06G0597500 PROTEIN', 243356),
(338907, 'PTHR47928:SF122', NULL, NULL, NULL, NULL, 'OS06G0700100 PROTEIN', 243356),
(338908, 'PTHR47928:SF120', NULL, NULL, NULL, NULL, 'OS05G0107000 PROTEIN', 243356),
(338909, 'PTHR47928:SF127', NULL, NULL, NULL, NULL, 'OS12G0128200 PROTEIN', 243356),
(338910, 'PTHR47928:SF57', NULL, NULL, NULL, NULL, 'OS07G0191500 PROTEIN', 243356),
(338911, 'PTHR47928:SF56', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338912, 'PTHR47928:SF125', NULL, NULL, NULL, NULL, 'OS04G0110500 PROTEIN', 243356),
(338913, 'PTHR47928:SF58', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 243356),
(338914, 'PTHR47928:SF124', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE (PPR) REPEAT PROTEIN', 243356),
(338915, 'PTHR47928:SF129', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE SMALL DOMAIN', 243356),
(338916, 'PTHR47928:SF128', NULL, NULL, NULL, NULL, '', 243356),
(338917, 'PTHR47928:SF64', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338918, 'PTHR47928:SF63', NULL, NULL, NULL, NULL, 'OS08G0434000 PROTEIN', 243356),
(338919, 'PTHR47928:SF66', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 243356),
(338920, 'PTHR47928:SF65', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338921, 'PTHR47928:SF60', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 243356),
(338922, 'PTHR47928:SF62', NULL, NULL, NULL, NULL, 'OS04G0488200 PROTEIN', 243356),
(338923, 'PTHR47928:SF61', NULL, NULL, NULL, NULL, 'OS01G0818200 PROTEIN', 243356),
(338924, 'PTHR47928:SF134', NULL, NULL, NULL, NULL, 'OS10G0444500 PROTEIN', 243356),
(338925, 'PTHR47928:SF133', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338926, 'PTHR47928:SF49', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338927, 'PTHR47928:SF132', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE (PPR) REPEAT PROTEIN', 243356),
(338928, 'PTHR47928:SF131', NULL, NULL, NULL, NULL, 'OS05G0307200 PROTEIN', 243356);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(338929, 'PTHR47928:SF46', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338930, 'PTHR47928:SF138', NULL, NULL, NULL, NULL, 'OS03G0216400 PROTEIN', 243356),
(338931, 'PTHR47928:SF137', NULL, NULL, NULL, NULL, 'OS06G0493801 PROTEIN', 243356),
(338932, 'PTHR47928:SF45', NULL, NULL, NULL, NULL, 'OS09G0474051 PROTEIN', 243356),
(338933, 'PTHR47928:SF136', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338934, 'PTHR47928:SF48', NULL, NULL, NULL, NULL, 'TRANSCRIPT PROCESSING PROTEIN, PUTATIVE-RELATED', 243356),
(338935, 'PTHR47928:SF47', NULL, NULL, NULL, NULL, 'OS11G0114800 PROTEIN', 243356),
(338936, 'PTHR47928:SF135', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 243356),
(338937, 'PTHR47928:SF52', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338938, 'PTHR47928:SF54', NULL, NULL, NULL, NULL, 'OS09G0411600 PROTEIN', 243356),
(338939, 'PTHR47928:SF130', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 243356),
(338940, 'PTHR47928:SF51', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE (PPR) REPEAT PROTEIN', 243356),
(338941, 'PTHR47928:SF50', NULL, NULL, NULL, NULL, 'OS01G0390600 PROTEIN', 243356),
(338942, 'PTHR47928:SF145', NULL, NULL, NULL, NULL, 'OS02G0555100 PROTEIN', 243356),
(338943, 'PTHR47928:SF144', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338944, 'PTHR47928:SF143', NULL, NULL, NULL, NULL, 'AMIDASE DOMAIN-CONTAINING PROTEIN', 243356),
(338945, 'PTHR47928:SF79', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 243356),
(338946, 'PTHR47928:SF149', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN DOT4, CHLOROPLASTIC', 243356),
(338947, 'PTHR47928:SF148', NULL, NULL, NULL, NULL, 'OS11G0673000 PROTEIN', 243356),
(338948, 'PTHR47928:SF146', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338949, 'PTHR47928:SF80', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 243356),
(338950, 'PTHR47928:SF85', NULL, NULL, NULL, NULL, 'OS12G0552300 PROTEIN', 243356),
(338951, 'PTHR47928:SF88', NULL, NULL, NULL, NULL, 'OS03G0701400 PROTEIN', 243356),
(338952, 'PTHR47928:SF87', NULL, NULL, NULL, NULL, '', 243356),
(338953, 'PTHR47928:SF82', NULL, NULL, NULL, NULL, 'OS01G0715700 PROTEIN', 243356),
(338954, 'PTHR47928:SF141', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 243356),
(338955, 'PTHR47928:SF140', NULL, NULL, NULL, NULL, 'OS06G0705350 PROTEIN', 243356),
(338956, 'PTHR47928:SF81', NULL, NULL, NULL, NULL, 'OS01G0754700 PROTEIN', 243356),
(338957, 'PTHR47928:SF83', NULL, NULL, NULL, NULL, 'OS01G0176300 PROTEIN', 243356),
(338958, 'PTHR47928:SF156', NULL, NULL, NULL, NULL, 'OS07G0163900 PROTEIN', 243356),
(338959, 'PTHR47928:SF155', NULL, NULL, NULL, NULL, 'OS05G0439300 PROTEIN', 243356),
(338960, 'PTHR47928:SF154', NULL, NULL, NULL, NULL, '', 243356),
(338961, 'PTHR47928:SF153', NULL, NULL, NULL, NULL, 'OS11G0661000 PROTEIN', 243356),
(338962, 'PTHR47928:SF68', NULL, NULL, NULL, NULL, '', 243356),
(338963, 'PTHR47928:SF159', NULL, NULL, NULL, NULL, 'OS05G0572900 PROTEIN', 243356),
(338964, 'PTHR47928:SF67', NULL, NULL, NULL, NULL, 'REPEAT (PPR) SUPERFAMILY PROTEIN, PUTATIVE-RELATED', 243356),
(338965, 'PTHR47928:SF158', NULL, NULL, NULL, NULL, 'OS02G0116100 PROTEIN', 243356),
(338966, 'PTHR47928:SF69', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338967, 'PTHR47928:SF157', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE (PPR) REPEAT-CONTAINING PROTEIN-LIKE', 243356),
(338968, 'PTHR47928:SF75', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 243356),
(338969, 'PTHR47928:SF74', NULL, NULL, NULL, NULL, 'OS08G0494350 PROTEIN', 243356),
(338970, 'PTHR47928:SF76', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338971, 'PTHR47928:SF152', NULL, NULL, NULL, NULL, 'OS02G0468800 PROTEIN', 243356),
(338972, 'PTHR47928:SF71', NULL, NULL, NULL, NULL, 'OS02G0552100 PROTEIN', 243356);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(338973, 'PTHR47928:SF151', NULL, NULL, NULL, NULL, 'OS03G0168550 PROTEIN', 243356),
(338974, 'PTHR47928:SF150', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT PROTEIN PPR868-14 ISOFORM 1', 243356),
(338975, 'PTHR47928:SF73', NULL, NULL, NULL, NULL, 'OS07G0299800 PROTEIN', 243356),
(338976, 'PTHR47928:SF72', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 243356),
(338977, 'PTHR14009:SF9', NULL, NULL, NULL, NULL, 'LETM1-LIKE PROTEIN', 243357),
(338978, 'PTHR14009:SF6', NULL, NULL, NULL, NULL, 'LETM1 RBD DOMAIN-CONTAINING PROTEIN', 243357),
(338979, 'PTHR14009:SF8', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PROTON/CALCIUM EXCHANGER PROTEIN', 243357),
(338980, 'PTHR14009:SF7', NULL, NULL, NULL, NULL, 'LETM1 DOMAIN-CONTAINING PROTEIN LETM2, MITOCHONDRIAL', 243357),
(338981, 'PTHR14009:SF37', NULL, NULL, NULL, NULL, 'LETM1 DOMAIN-CONTAINING PROTEIN', 243357),
(338982, 'PTHR14009:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PROTON/CALCIUM EXCHANGER PROTEIN', 243357),
(338983, 'PTHR14009:SF36', NULL, NULL, NULL, NULL, 'LEUCINE ZIPPER-EF-HAND-CONTAINING TRANSMEMBRANE PROTEIN 1', 243357),
(338984, 'PTHR14009:SF39', NULL, NULL, NULL, NULL, 'LEUCINE ZIPPER-EF-HAND-CONTAINING TRANSMEMBRANE PROTEIN 1', 243357),
(338985, 'PTHR14009:SF38', NULL, NULL, NULL, NULL, 'LETM1 DOMAIN-CONTAINING PROTEIN', 243357),
(338986, 'PTHR14009:SF27', NULL, NULL, NULL, NULL, 'LETM1 DOMAIN-CONTAINING PROTEIN', 243357),
(338987, 'PTHR14009', NULL, NULL, NULL, NULL, 'LEUCINE ZIPPER-EF-HAND CONTAINING TRANSMEMBRANE PROTEIN', 243357),
(338988, 'PTHR14009:SF31', NULL, NULL, NULL, NULL, 'LEUCINE ZIPPER-EF-HAND-CONTAINING TRANSMEMBRANE PROTEIN 1', 243357),
(338989, 'PTHR14009:SF11', NULL, NULL, NULL, NULL, 'LETM1 DOMAIN-CONTAINING PROTEIN YLH47, MITOCHONDRIAL', 243357),
(338990, 'PTHR14009:SF35', NULL, NULL, NULL, NULL, 'LEUCINE ZIPPER-EF-HAND-CONTAINING TRANSMEMBRANE PROTEIN 1', 243357),
(338991, 'PTHR14009:SF13', NULL, NULL, NULL, NULL, 'LETM1 DOMAIN-CONTAINING PROTEIN 1', 243357),
(338992, 'PTHR14009:SF34', NULL, NULL, NULL, NULL, 'LETM1 DOMAIN-CONTAINING PROTEIN', 243357),
(338993, 'PTHR43694:SF5', NULL, NULL, NULL, NULL, 'RNA-METABOLISING METALLO-BETA-LACTAMASE', 243358),
(338994, 'PTHR43694', NULL, NULL, NULL, NULL, 'RIBONUCLEASE J', 243358),
(338995, 'PTHR43694:SF1', NULL, NULL, NULL, NULL, 'RIBONUCLEASE J', 243358),
(338996, 'PTHR43694:SF4', NULL, NULL, NULL, NULL, 'RIBONUCLEASE J2', 243358),
(338997, 'PTHR15615:SF105', NULL, NULL, NULL, NULL, 'CYCLIN', 243359),
(338998, 'PTHR15615:SF104', NULL, NULL, NULL, NULL, 'OS02G0652000 PROTEIN', 243359),
(338999, 'PTHR15615:SF106', NULL, NULL, NULL, NULL, 'CYCLIN DOMAIN-CONTAINING PROTEIN-RELATED', 243359),
(339000, 'PTHR15615:SF108', NULL, NULL, NULL, NULL, 'PROTEIN CNPPD1', 243359),
(339001, 'PTHR15615:SF80', NULL, NULL, NULL, NULL, 'CYCLIN', 243359),
(339002, 'PTHR15615:SF36', NULL, NULL, NULL, NULL, 'PHO85 CYCLIN-5', 243359),
(339003, 'PTHR15615:SF15', NULL, NULL, NULL, NULL, 'CYCLIN-U2-1', 243359),
(339004, 'PTHR15615:SF37', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 243359),
(339005, 'PTHR15615', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243359),
(339006, 'PTHR15615:SF94', NULL, NULL, NULL, NULL, 'PHO85 CYCLIN-6-RELATED', 243359),
(339007, 'PTHR15615:SF95', NULL, NULL, NULL, NULL, 'CYCLIN', 243359),
(339008, 'PTHR15615:SF121', NULL, NULL, NULL, NULL, 'CYCLIN-U1-1', 243359),
(339009, 'PTHR15615:SF120', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243359),
(339010, 'PTHR15615:SF32', NULL, NULL, NULL, NULL, 'PHO85 CYCLIN-10-RELATED', 243359),
(339011, 'PTHR15615:SF10', NULL, NULL, NULL, NULL, 'PHO85 CYCLIN-2-RELATED', 243359),
(339012, 'PTHR15615:SF101', NULL, NULL, NULL, NULL, 'CYCLIN-U4-1', 243359),
(339013, 'PTHR15615:SF122', NULL, NULL, NULL, NULL, '', 243359),
(339014, 'PTHR15615:SF33', NULL, NULL, NULL, NULL, 'CYCLIN', 243359),
(339015, 'PTHR15615:SF77', NULL, NULL, NULL, NULL, '', 243359),
(339016, 'PTHR15615:SF99', NULL, NULL, NULL, NULL, 'CYCLIN', 243359),
(339017, 'PTHR15615:SF103', NULL, NULL, NULL, NULL, 'CYCLIN-U4-2', 243359);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(339018, 'PTHR15615:SF35', NULL, NULL, NULL, NULL, '', 243359),
(339019, 'PTHR15615:SF116', NULL, NULL, NULL, NULL, 'CYCLIN', 243359),
(339020, 'PTHR15615:SF115', NULL, NULL, NULL, NULL, 'CYCLIN-U4-3', 243359),
(339021, 'PTHR15615:SF118', NULL, NULL, NULL, NULL, 'CYCLIN, HYPOTHETICAL (EUROFUNG)', 243359),
(339022, 'PTHR15615:SF117', NULL, NULL, NULL, NULL, 'PHO85 CYCLIN PHO80', 243359),
(339023, 'PTHR15615:SF91', NULL, NULL, NULL, NULL, 'CYCLIN-P4-1', 243359),
(339024, 'PTHR15615:SF119', NULL, NULL, NULL, NULL, 'CYCLIN', 243359),
(339025, 'PTHR15615:SF92', NULL, NULL, NULL, NULL, 'CYCLIN', 243359),
(339026, 'PTHR15615:SF93', NULL, NULL, NULL, NULL, 'CYCLIN', 243359),
(339027, 'PTHR15615:SF69', NULL, NULL, NULL, NULL, 'CYCLIN DOMAIN-CONTAINING PROTEIN', 243359),
(339028, 'PTHR15615:SF26', NULL, NULL, NULL, NULL, '', 243359),
(339029, 'PTHR15615:SF27', NULL, NULL, NULL, NULL, 'PHO85 CYCLIN CLG1', 243359),
(339030, 'PTHR15615:SF84', NULL, NULL, NULL, NULL, 'OS05G0325200 PROTEIN', 243359),
(339031, 'PTHR15615:SF85', NULL, NULL, NULL, NULL, 'CYCLIN-U2-2', 243359),
(339032, 'PTHR15615:SF112', NULL, NULL, NULL, NULL, 'CYCLIN, PUTATIVE-RELATED', 243359),
(339033, 'PTHR15615:SF44', NULL, NULL, NULL, NULL, '', 243359),
(339034, 'PTHR15615:SF114', NULL, NULL, NULL, NULL, 'PHO85 CYCLIN-1', 243359),
(339035, 'PTHR15615:SF68', NULL, NULL, NULL, NULL, 'OS02G0125400 PROTEIN', 243359),
(339036, 'PTHR22545:SF0', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 95 KDA', 243360),
(339037, 'PTHR22545', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243360),
(339038, 'PTHR37900:SF9', NULL, NULL, NULL, NULL, 'OS06G0686900 PROTEIN', 243361),
(339039, 'PTHR37900:SF7', NULL, NULL, NULL, NULL, '', 243361),
(339040, 'PTHR37900', NULL, NULL, NULL, NULL, '', 243361),
(339041, 'PTHR37900:SF5', NULL, NULL, NULL, NULL, 'OS02G0159250 PROTEIN', 243361),
(339042, 'PTHR37900:SF3', NULL, NULL, NULL, NULL, '', 243361),
(339043, 'PTHR30153:SF2', NULL, NULL, NULL, NULL, 'REPLICATIVE DNA HELICASE', 243362),
(339044, 'PTHR30153', NULL, NULL, NULL, NULL, 'REPLICATIVE DNA HELICASE DNAB', 243362),
(339045, 'PTHR11692', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL PURINE BIOSYNTHESIS PROTEIN PURH', 243363),
(339046, 'PTHR11692:SF0', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL PURINE BIOSYNTHESIS PROTEIN ATIC', 243363),
(339047, 'PTHR11692:SF1', NULL, NULL, NULL, NULL, 'AICAR TRANSFORMYLASE', 243363),
(339048, 'PTHR11692:SF2', NULL, NULL, NULL, NULL, 'MGS-LIKE DOMAIN-CONTAINING PROTEIN', 243363),
(339049, 'PTHR34993:SF1', NULL, NULL, NULL, NULL, '', 243364),
(339050, 'PTHR34993', NULL, NULL, NULL, NULL, '', 243364),
(339051, 'PTHR41533', NULL, NULL, NULL, NULL, 'L,D-TRANSPEPTIDASE HI_1667-RELATED', 243365),
(339052, 'PTHR41533:SF1', NULL, NULL, NULL, NULL, 'L,D-TRANSPEPTIDASE YCBB-RELATED', 243365),
(339053, 'PTHR41533:SF2', NULL, NULL, NULL, NULL, 'BLR7131 PROTEIN', 243365),
(339054, 'PTHR12442:SF7', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL INTERMEDIATE CHAIN 2', 243366),
(339055, 'PTHR12442:SF5', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL INTERMEDIATE CHAIN 3', 243366),
(339056, 'PTHR12442:SF26', NULL, NULL, NULL, NULL, 'CYTOPLASMIC DYNEIN 2 INTERMEDIATE CHAIN 2', 243366),
(339057, 'PTHR12442:SF37', NULL, NULL, NULL, NULL, 'CYTOPLASMIC DYNEIN 1 INTERMEDIATE CHAIN 2', 243366),
(339058, 'PTHR12442:SF42', NULL, NULL, NULL, NULL, 'DYNEIN CYTOPLASMIC 1 INTERMEDIATE CHAIN 2', 243366),
(339059, 'PTHR12442:SF43', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 243366),
(339060, 'PTHR12442:SF22', NULL, NULL, NULL, NULL, 'CYTOPLASMIC DYNEIN 1 INTERMEDIATE CHAIN-RELATED', 243366),
(339061, 'PTHR12442:SF44', NULL, NULL, NULL, NULL, 'DYNEIN, CYTOPLASMIC 1, INTERMEDIATE CHAIN 2B', 243366),
(339062, 'PTHR12442:SF11', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL INTERMEDIATE CHAIN 1', 243366),
(339063, 'PTHR12442:SF12', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL INTERMEDIATE CHAIN 4', 243366),
(339064, 'PTHR12442:SF34', NULL, NULL, NULL, NULL, 'CYTOPLASMIC DYNEIN 1 INTERMEDIATE CHAIN 1', 243366),
(339065, 'PTHR12442:SF45', NULL, NULL, NULL, NULL, 'WD REPEAT PROTEIN', 243366);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(339066, 'PTHR12442', NULL, NULL, NULL, NULL, 'DYNEIN INTERMEDIATE CHAIN', 243366),
(339067, 'PTHR43349:SF37', NULL, NULL, NULL, NULL, 'NMRA DOMAIN-CONTAINING PROTEIN', 243367),
(339068, 'PTHR43349:SF16', NULL, NULL, NULL, NULL, 'LEUCANTHOCYANIDIN REDUCTASE', 243367),
(339069, 'PTHR43349:SF57', NULL, NULL, NULL, NULL, 'NMRA DOMAIN-CONTAINING PROTEIN', 243367),
(339070, 'PTHR43349:SF35', NULL, NULL, NULL, NULL, 'PHENYLCOUMARAN BENZYLIC ETHER REDUCTASE 1', 243367),
(339071, 'PTHR43349:SF34', NULL, NULL, NULL, NULL, 'PINORESINOL-LARICIRESINOL REDUCTASE 3-RELATED', 243367),
(339072, 'PTHR43349:SF78', NULL, NULL, NULL, NULL, 'NMRA DOMAIN-CONTAINING PROTEIN', 243367),
(339073, 'PTHR43349:SF53', NULL, NULL, NULL, NULL, 'ISOFLAVONE REDUCTASE', 243367),
(339074, 'PTHR43349:SF76', NULL, NULL, NULL, NULL, 'ISOFLAVONE REDUCTASE HOMOLOG P3-RELATED', 243367),
(339075, 'PTHR43349:SF40', NULL, NULL, NULL, NULL, 'PHENYLCOUMARAN BENZYLIC ETHER REDUCTASE-LIKE PROTEIN FI1', 243367),
(339076, 'PTHR43349:SF62', NULL, NULL, NULL, NULL, 'NMRA DOMAIN-CONTAINING PROTEIN', 243367),
(339077, 'PTHR43349:SF83', NULL, NULL, NULL, NULL, 'NMRA DOMAIN-CONTAINING PROTEIN', 243367),
(339078, 'PTHR43349:SF1', NULL, NULL, NULL, NULL, 'ISOFLAVONE REDUCTASE HOMOLOG IRL', 243367),
(339079, 'PTHR43349', NULL, NULL, NULL, NULL, 'PINORESINOL REDUCTASE-RELATED', 243367),
(339080, 'PTHR43349:SF49', NULL, NULL, NULL, NULL, 'ISOFLAVONE REDUCTASE HOMOLOG A622', 243367),
(339081, 'PTHR43349:SF47', NULL, NULL, NULL, NULL, 'NMRA DOMAIN-CONTAINING PROTEIN', 243367),
(339082, 'PTHR43349:SF44', NULL, NULL, NULL, NULL, '2''-HYDROXYISOFLAVONE REDUCTASE-RELATED', 243367),
(339083, 'PTHR43349:SF89', NULL, NULL, NULL, NULL, 'LEUCANTHOCYANIDIN REDUCTASE', 243367),
(339084, 'PTHR43349:SF45', NULL, NULL, NULL, NULL, 'PINORESINOL-LARICIRESINOL REDUCTASE-LIKE PROTEIN', 243367),
(339085, 'PTHR43349:SF64', NULL, NULL, NULL, NULL, 'NMRA DOMAIN-CONTAINING PROTEIN', 243367),
(339086, 'PTHR43349:SF43', NULL, NULL, NULL, NULL, 'ISOEUGENOL SYNTHASE 1-LIKE', 243367),
(339087, 'PTHR43349:SF30', NULL, NULL, NULL, NULL, 'NMRA-LIKE NEGATIVE TRANSCRIPTIONAL REGULATOR FAMILY PROTEIN', 243367),
(339088, 'PTHR43349:SF93', NULL, NULL, NULL, NULL, 'HYPOTHETICAL OXIDOREDUCTASE (EUROFUNG)', 243367),
(339089, 'PTHR43349:SF94', NULL, NULL, NULL, NULL, 'NMRA DOMAIN-CONTAINING PROTEIN', 243367),
(339090, 'PTHR43349:SF72', NULL, NULL, NULL, NULL, 'NMRA DOMAIN-CONTAINING PROTEIN', 243367),
(339091, 'PTHR43349:SF70', NULL, NULL, NULL, NULL, 'ISOFLAVONE REDUCTASE-RELATED', 243367),
(339092, 'PTHR43349:SF9', NULL, NULL, NULL, NULL, 'PHENYLCOUMARAN BENZYLIC ETHER REDUCTASE-LIKE PROTEIN', 243367),
(339093, 'PTHR43349:SF4', NULL, NULL, NULL, NULL, 'PINORESINOL REDUCTASE 1-RELATED', 243367),
(339094, 'PTHR31144:SF8', NULL, NULL, NULL, NULL, '', 243368),
(339095, 'PTHR31144:SF6', NULL, NULL, NULL, NULL, '', 243368),
(339096, 'PTHR31144', NULL, NULL, NULL, NULL, 'UPF0602 PROTEIN C4ORF47', 243368),
(339097, 'PTHR31144:SF1', NULL, NULL, NULL, NULL, 'UPF0602 PROTEIN C4ORF47', 243368),
(339098, 'PTHR47206:SF7', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 243369),
(339099, 'PTHR47206:SF8', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 243369),
(339100, 'PTHR47206:SF1', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN', 243369),
(339101, 'PTHR47206:SF2', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 243369),
(339102, 'PTHR47206:SF3', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 243369),
(339103, 'PTHR47206', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN', 243369),
(339104, 'PTHR47206:SF5', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 243369),
(339105, 'PTHR21564:SF4', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 608', 243370),
(339106, 'PTHR21564:SF5', NULL, NULL, NULL, NULL, 'SCRIBBLER, ISOFORM J', 243370),
(339107, 'PTHR21564', NULL, NULL, NULL, NULL, 'BRAKELESS PROTEIN', 243370),
(339108, 'PTHR21564:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 609', 243370),
(339109, 'PTHR48054:SF17', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243371);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(339110, 'PTHR48054:SF39', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 243371),
(339111, 'PTHR48054:SF59', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243371),
(339112, 'PTHR48054:SF37', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE FAMILY PROTEIN', 243371),
(339113, 'PTHR48054:SF38', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN FASCIATED EAR2', 243371),
(339114, 'PTHR48054:SF13', NULL, NULL, NULL, NULL, 'OS08G0446200 PROTEIN', 243371),
(339115, 'PTHR48054:SF35', NULL, NULL, NULL, NULL, 'INSENSITIVE 1-ASSOCIATED RECEPTOR KINASE 1, PUTATIVE, EXPRESSED-RELATED', 243371),
(339116, 'PTHR48054:SF14', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE 2', 243371),
(339117, 'PTHR48054:SF77', NULL, NULL, NULL, NULL, 'RECEPTOR KINASE-LIKE PROTEIN XA21', 243371),
(339118, 'PTHR48054:SF12', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243371),
(339119, 'PTHR48054:SF78', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN CLAVATA2', 243371),
(339120, 'PTHR48054:SF75', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243371),
(339121, 'PTHR48054:SF1', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243371),
(339122, 'PTHR48054:SF53', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243371),
(339123, 'PTHR48054:SF10', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243371),
(339124, 'PTHR48054:SF76', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243371),
(339125, 'PTHR48054:SF73', NULL, NULL, NULL, NULL, '', 243371),
(339126, 'PTHR48054:SF3', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 243371),
(339127, 'PTHR48054:SF74', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 243371),
(339128, 'PTHR48054:SF52', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 243371),
(339129, 'PTHR48054:SF30', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 243371),
(339130, 'PTHR48054:SF71', NULL, NULL, NULL, NULL, 'OS06G0179800 PROTEIN', 243371),
(339131, 'PTHR48054:SF72', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243371),
(339132, 'PTHR48054:SF50', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243371),
(339133, 'PTHR48054:SF7', NULL, NULL, NULL, NULL, 'RECEPTOR KINASE', 243371),
(339134, 'PTHR48054', NULL, NULL, NULL, NULL, 'RECEPTOR KINASE-LIKE PROTEIN XA21', 243371),
(339135, 'PTHR48054:SF6', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE FAMILY PROTEIN', 243371),
(339136, 'PTHR48054:SF70', NULL, NULL, NULL, NULL, 'SYSTEMIN RECEPTOR SR160-LIKE', 243371),
(339137, 'PTHR48054:SF9', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243371),
(339138, 'PTHR48054:SF8', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243371),
(339139, 'PTHR48054:SF26', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN 1-RELATED', 243371),
(339140, 'PTHR48054:SF27', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243371),
(339141, 'PTHR48054:SF68', NULL, NULL, NULL, NULL, '', 243371),
(339142, 'PTHR48054:SF47', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243371),
(339143, 'PTHR48054:SF25', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT (LRR) FAMILY PROTEIN', 243371),
(339144, 'PTHR48054:SF69', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 243371),
(339145, 'PTHR48054:SF66', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243371),
(339146, 'PTHR48054:SF23', NULL, NULL, NULL, NULL, 'PIRIFORMOSPORA INDICA-INSENSITIVE PROTEIN 2-LIKE', 243371),
(339147, 'PTHR48054:SF67', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 243371),
(339148, 'PTHR48054:SF64', NULL, NULL, NULL, NULL, 'OS05G0530701 PROTEIN', 243371),
(339149, 'PTHR48054:SF42', NULL, NULL, NULL, NULL, 'OS01G0279800 PROTEIN', 243371),
(339150, 'PTHR48054:SF20', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE PEPR1', 243371),
(339151, 'PTHR48054:SF65', NULL, NULL, NULL, NULL, '', 243371);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(339152, 'PTHR48054:SF21', NULL, NULL, NULL, NULL, 'KINASE FAMILY WITH LEUCINE-RICH REPEAT DOMAIN-CONTAINING PROTEIN', 243371),
(339153, 'PTHR48054:SF62', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE PEPR1', 243371),
(339154, 'PTHR48054:SF60', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE FAMILY PROTEIN', 243371),
(339155, 'PTHR47380', NULL, NULL, NULL, NULL, 'OS02G0533000 PROTEIN', 243372),
(339156, 'PTHR47380:SF4', NULL, NULL, NULL, NULL, 'OS02G0533000 PROTEIN', 243372),
(339157, 'PTHR10120:SF26', NULL, NULL, NULL, NULL, 'STE24 ENDOPEPTIDASE', 243373),
(339158, 'PTHR10120:SF23', NULL, NULL, NULL, NULL, 'STE24 ENDOPEPTIDASE', 243373),
(339159, 'PTHR10120:SF24', NULL, NULL, NULL, NULL, 'CAAX PRENYL PROTEASE 1 HOMOLOG', 243373),
(339160, 'PTHR10120:SF18', NULL, NULL, NULL, NULL, 'STE24 ENDOPEPTIDASE', 243373),
(339161, 'PTHR10120:SF27', NULL, NULL, NULL, NULL, 'CAAX PRENYL PROTEASE', 243373),
(339162, 'PTHR10120', NULL, NULL, NULL, NULL, 'CAAX PRENYL PROTEASE 1', 243373),
(339163, 'PTHR33748:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG29112', 243374),
(339164, 'PTHR33748:SF4', NULL, NULL, NULL, NULL, 'MOLO-1', 243374),
(339165, 'PTHR33748:SF5', NULL, NULL, NULL, NULL, 'DOMAIN-CONTAINING PROTEIN, PUTATIVE-RELATED', 243374),
(339166, 'PTHR33748:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG14815', 243374),
(339167, 'PTHR33748:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG20827', 243374),
(339168, 'PTHR33748', NULL, NULL, NULL, NULL, 'PROTEIN CBG04600', 243374),
(339169, 'PTHR33748:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG07404', 243374),
(339170, 'PTHR33748:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG04600', 243374),
(339171, 'PTHR15258:SF1', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR-BINDING PROTEIN 2', 243375),
(339172, 'PTHR15258:SF3', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR-BINDING PROTEIN 3', 243375),
(339173, 'PTHR15258:SF2', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR-BINDING PROTEIN 1', 243375),
(339174, 'PTHR15258', NULL, NULL, NULL, NULL, 'FGF BINDING PROTEIN-RELATED', 243375),
(339175, 'PTHR15258:SF4', NULL, NULL, NULL, NULL, '', 243375),
(339176, 'PTHR13624:SF6', NULL, NULL, NULL, NULL, 'RE42071P', 243376),
(339177, 'PTHR13624', NULL, NULL, NULL, NULL, 'RE42071P', 243376),
(339178, 'PTHR13624:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 161A', 243376),
(339179, 'PTHR13624:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 161B', 243376),
(339180, 'PTHR24070:SF263', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAP1', 243377),
(339181, 'PTHR24070:SF384', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAPC', 243377),
(339182, 'PTHR24070:SF221', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAP-2A', 243377),
(339183, 'PTHR24070:SF264', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN RHEB', 243377),
(339184, 'PTHR24070:SF385', NULL, NULL, NULL, NULL, 'GTPASE HRAS', 243377),
(339185, 'PTHR24070:SF388', NULL, NULL, NULL, NULL, 'GTPASE KRAS', 243377),
(339186, 'PTHR24070:SF189', NULL, NULL, NULL, NULL, 'GTPASE NRAS', 243377),
(339187, 'PTHR24070:SF266', NULL, NULL, NULL, NULL, 'SMALL MONOMERIC GTPASE', 243377),
(339188, 'PTHR24070:SF380', NULL, NULL, NULL, NULL, 'RAS-LIKE PROTEIN RASS', 243377),
(339189, 'PTHR24070:SF258', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAL-A', 243377),
(339190, 'PTHR24070:SF213', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN DI-RAS1', 243377),
(339191, 'PTHR24070:SF414', NULL, NULL, NULL, NULL, 'SMALL MONOMERIC GTPASE', 243377),
(339192, 'PTHR24070:SF416', NULL, NULL, NULL, NULL, 'RAS-LIKE PROTEIN 1', 243377),
(339193, 'PTHR24070:SF252', NULL, NULL, NULL, NULL, 'RAS-LIKE PROTEIN FAMILY MEMBER 12', 243377),
(339194, 'PTHR24070:SF373', NULL, NULL, NULL, NULL, 'RAS-RELATED AND ESTROGEN-REGULATED GROWTH INHIBITOR', 243377),
(339195, 'PTHR24070:SF251', NULL, NULL, NULL, NULL, 'RAS GTPASE-RELATED', 243377),
(339196, 'PTHR24070:SF174', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAL-A', 243377),
(339197, 'PTHR24070:SF253', NULL, NULL, NULL, NULL, 'GTPASE RHEBL1', 243377),
(339198, 'PTHR24070:SF178', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN DI-RAS2', 243377);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(339199, 'PTHR24070:SF290', NULL, NULL, NULL, NULL, 'EG:BACR37P7.8 PROTEIN', 243377),
(339200, 'PTHR24070:SF409', NULL, NULL, NULL, NULL, 'CIRCULARLY PERMUTATED RAS PROTEIN 1', 243377),
(339201, 'PTHR24070:SF408', NULL, NULL, NULL, NULL, 'RAB FAMILY GTPASE', 243377),
(339202, 'PTHR24070:SF368', NULL, NULL, NULL, NULL, 'SMALL GTPASE', 243377),
(339203, 'PTHR24070:SF203', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN RIT2', 243377),
(339204, 'PTHR24070:SF445', NULL, NULL, NULL, NULL, 'SMALL MONOMERIC GTPASE', 243377),
(339205, 'PTHR24070:SF444', NULL, NULL, NULL, NULL, 'SMALL GTPASE', 243377),
(339206, 'PTHR24070:SF400', NULL, NULL, NULL, NULL, 'FI21445P1', 243377),
(339207, 'PTHR24070:SF447', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-21', 243377),
(339208, 'PTHR24070:SF446', NULL, NULL, NULL, NULL, 'RAS-LIKE PROTEIN RASG', 243377),
(339209, 'PTHR24070:SF369', NULL, NULL, NULL, NULL, 'GTPASE ERAS', 243377),
(339210, 'PTHR24070:SF405', NULL, NULL, NULL, NULL, 'RAS-LIKE PROTEIN RASU-RELATED', 243377),
(339211, 'PTHR24070:SF448', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-42', 243377),
(339212, 'PTHR24070:SF206', NULL, NULL, NULL, NULL, 'RAS-LIKE PROTEIN RASB', 243377),
(339213, 'PTHR24070:SF404', NULL, NULL, NULL, NULL, '', 243377),
(339214, 'PTHR24070:SF407', NULL, NULL, NULL, NULL, '', 243377),
(339215, 'PTHR24070:SF406', NULL, NULL, NULL, NULL, 'RE63021P', 243377),
(339216, 'PTHR24070:SF208', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN RIT1', 243377),
(339217, 'PTHR24070:SF285', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAPB', 243377),
(339218, 'PTHR24070:SF441', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 243377),
(339219, 'PTHR24070:SF69', NULL, NULL, NULL, NULL, 'FI18258P1', 243377),
(339220, 'PTHR24070:SF440', NULL, NULL, NULL, NULL, 'SMALL MONOMERIC GTPASE', 243377),
(339221, 'PTHR24070:SF245', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN R-RAS', 243377),
(339222, 'PTHR24070:SF443', NULL, NULL, NULL, NULL, 'NEUROBLASTOMA RAS VIRAL ONCOGENE-LIKE PROTEIN', 243377),
(339223, 'PTHR24070:SF442', NULL, NULL, NULL, NULL, 'PROTEIN CBG03280', 243377),
(339224, 'PTHR24070:SF200', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAP-2C', 243377),
(339225, 'PTHR24070:SF436', NULL, NULL, NULL, NULL, 'RAS GTPASE-RELATED', 243377),
(339226, 'PTHR24070:SF438', NULL, NULL, NULL, NULL, 'SMALL MONOMERIC GTPASE', 243377),
(339227, 'PTHR24070:SF437', NULL, NULL, NULL, NULL, 'SMALL MONOMERIC GTPASE', 243377),
(339228, 'PTHR24070:SF393', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAP-1B-RELATED', 243377),
(339229, 'PTHR24070:SF194', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAP-2B', 243377),
(339230, 'PTHR24070:SF392', NULL, NULL, NULL, NULL, 'SMALL MONOMERIC GTPASE', 243377),
(339231, 'PTHR24070:SF395', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAP-1A', 243377),
(339232, 'PTHR24070:SF430', NULL, NULL, NULL, NULL, 'GTPASE KRAS', 243377),
(339233, 'PTHR24070:SF199', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAL-B', 243377),
(339234, 'PTHR24070:SF154', NULL, NULL, NULL, NULL, 'GENE MODEL 266, (NCBI)', 243377),
(339235, 'PTHR24070:SF396', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN R-RAS2', 243377),
(339236, 'PTHR24070:SF17', NULL, NULL, NULL, NULL, 'RAS-LIKE PROTEIN 2', 243377),
(339237, 'PTHR24070', NULL, NULL, NULL, NULL, 'RAS, DI-RAS, AND RHEB FAMILY MEMBERS OF SMALL GTPASE SUPERFAMILY', 243377),
(339238, 'PTHR24070:SF269', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN DI-RAS3', 243377),
(339239, 'PTHR24070:SF268', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN M-RAS', 243377),
(339240, 'PTHR24070:SF226', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN RHEB HOMOLOG', 243377),
(339241, 'PTHR24070:SF427', NULL, NULL, NULL, NULL, 'SMALL MONOMERIC GTPASE', 243377),
(339242, 'PTHR24070:SF428', NULL, NULL, NULL, NULL, 'SMALL MONOMERIC GTPASE', 243377),
(339243, 'PTHR33499:SF33', NULL, NULL, NULL, NULL, '', 243378),
(339244, 'PTHR33499:SF11', NULL, NULL, NULL, NULL, 'TRANSPOSASE, PTTA/EN/SPM, PLANT-RELATED', 243378),
(339245, 'PTHR33499:SF10', NULL, NULL, NULL, NULL, 'PROTEIN KINASE-CODING RESISTANCE PROTEIN', 243378); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(339246, 'PTHR33499:SF28', NULL, NULL, NULL, NULL, 'TRANSPOS_ASSOC DOMAIN-CONTAINING PROTEIN', 243378),
(339247, 'PTHR33499:SF27', NULL, NULL, NULL, NULL, 'TRANSPOS_ASSOC DOMAIN-CONTAINING PROTEIN', 243378),
(339248, 'PTHR33499:SF35', NULL, NULL, NULL, NULL, 'TRANSPOSON PROTEIN, CACTA, EN/SPM SUB-CLASS', 243378),
(339249, 'PTHR33499', NULL, NULL, NULL, NULL, 'OS12G0282400 PROTEIN-RELATED', 243378),
(339250, 'PTHR33499:SF34', NULL, NULL, NULL, NULL, '', 243378),
(339251, 'PTHR33499:SF37', NULL, NULL, NULL, NULL, '', 243378),
(339252, 'PTHR33499:SF26', NULL, NULL, NULL, NULL, 'DUF4216 DOMAIN-CONTAINING PROTEIN', 243378),
(339253, 'PTHR33499:SF36', NULL, NULL, NULL, NULL, '', 243378),
(339254, 'PTHR22890:SF4', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 11', 243379),
(339255, 'PTHR22890:SF5', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 11', 243379),
(339256, 'PTHR22890:SF2', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 11', 243379),
(339257, 'PTHR22890', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243379),
(339258, 'PTHR38703:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 8, WHOLE GENOME SHOTGUN SEQUENCE', 243380),
(339259, 'PTHR38703', NULL, NULL, NULL, NULL, 'CHROMOSOME 8, WHOLE GENOME SHOTGUN SEQUENCE', 243380),
(339260, 'PTHR37194', NULL, NULL, NULL, NULL, 'T2E6.7-RELATED', 243381),
(339261, 'PTHR37194:SF2', NULL, NULL, NULL, NULL, 'T2E6.7-RELATED', 243381),
(339262, 'PTHR34093', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL CLIC-LIKE PROTEIN 1', 243382),
(339263, 'PTHR34093:SF1', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL CLIC-LIKE PROTEIN 1', 243382),
(339264, 'PTHR47567:SF1', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 243383),
(339265, 'PTHR47567', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE/SOLUTE CARRIER', 243383),
(339266, 'PTHR12422:SF3', NULL, NULL, NULL, NULL, 'CYFIP-RELATED RAC1 INTERACTOR B', 243384),
(339267, 'PTHR12422:SF2', NULL, NULL, NULL, NULL, 'DUF1394 DOMAIN-CONTAINING PROTEIN', 243384),
(339268, 'PTHR12422:SF1', NULL, NULL, NULL, NULL, 'GH09096P', 243384),
(339269, 'PTHR12422:SF5', NULL, NULL, NULL, NULL, 'FAMILY WITH SEQUENCE SIMILARITY 49 MEMBER BA', 243384),
(339270, 'PTHR12422:SF4', NULL, NULL, NULL, NULL, 'CYFIP-RELATED RAC1 INTERACTOR A', 243384),
(339271, 'PTHR12422', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243384),
(339272, 'PTHR10633:SF0', NULL, NULL, NULL, NULL, 'LEUKEMIA INHIBITORY FACTOR', 243385),
(339273, 'PTHR10633', NULL, NULL, NULL, NULL, 'LEUKEMIA INHIBITORY FACTOR', 243385),
(339274, 'PTHR15896:SF10', NULL, NULL, NULL, NULL, 'PROTEIN CBG16112', 243386),
(339275, 'PTHR15896:SF11', NULL, NULL, NULL, NULL, 'GOLGI MEMBRANE PROTEIN 2', 243386),
(339276, 'PTHR15896:SF8', NULL, NULL, NULL, NULL, 'GOLGI MEMBRANE PROTEIN 1', 243386),
(339277, 'PTHR15896', NULL, NULL, NULL, NULL, 'GOLGI PHOSPHOPROTEIN 2/GP73-RELATED', 243386),
(339278, 'PTHR15896:SF7', NULL, NULL, NULL, NULL, 'PROTEIN GOLM2', 243386),
(339279, 'PTHR10589:SF19', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE ISOZYME L1', 243387),
(339280, 'PTHR10589:SF29', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 243387),
(339281, 'PTHR10589:SF17', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 243387),
(339282, 'PTHR10589', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 243387),
(339283, 'PTHR10589:SF28', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE BAP1', 243387),
(339284, 'PTHR10589:SF16', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE ISOZYME L5', 243387),
(339285, 'PTHR10589:SF49', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 243387),
(339286, 'PTHR10589:SF48', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 243387),
(339287, 'PTHR10589:SF47', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 243387),
(339288, 'PTHR10589:SF24', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE ISOZYME L3', 243387),
(339289, 'PTHR10589:SF46', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 243387);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(339290, 'PTHR10589:SF45', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 243387),
(339291, 'PTHR10589:SF43', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 243387),
(339292, 'PTHR10589:SF31', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1', 243387),
(339293, 'PTHR10589:SF30', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 243387),
(339294, 'PTHR10589:SF41', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 243387),
(339295, 'PTHR22854:SF17', NULL, NULL, NULL, NULL, 'INDOLE-3-GLYCEROL PHOSPHATE SYNTHASE, CHLOROPLASTIC', 243388),
(339296, 'PTHR22854:SF18', NULL, NULL, NULL, NULL, 'INDOLE-3-GLYCEROL-PHOSPHATE SYNTHASE', 243388),
(339297, 'PTHR22854', NULL, NULL, NULL, NULL, 'TRYPTOPHAN BIOSYNTHESIS PROTEIN', 243388),
(339298, 'PTHR22854:SF13', NULL, NULL, NULL, NULL, 'INDOLE-3-GLYCEROL-PHOSPHATE SYNTHASE', 243388),
(339299, 'PTHR22854:SF14', NULL, NULL, NULL, NULL, 'INDOLE-3-GLYCEROL-PHOSPHATE SYNTHASE', 243388),
(339300, 'PTHR22854:SF2', NULL, NULL, NULL, NULL, 'INDOLE-3-GLYCEROL-PHOSPHATE SYNTHASE', 243388),
(339301, 'PTHR36493:SF8', NULL, NULL, NULL, NULL, '', 243389),
(339302, 'PTHR36493:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG24031', 243389),
(339303, 'PTHR36493:SF11', NULL, NULL, NULL, NULL, '', 243389),
(339304, 'PTHR36493', NULL, NULL, NULL, NULL, 'NEUROBLAST DIFFERENTIATION-ASSOCIATED PROTEIN AHNAK-LIKE PROTEIN', 243389),
(339305, 'PTHR36493:SF10', NULL, NULL, NULL, NULL, '', 243389),
(339306, 'PTHR36493:SF3', NULL, NULL, NULL, NULL, 'NEUROBLAST DIFFERENTIATION-ASSOCIATED PROTEIN AHNAK-LIKE PROTEIN', 243389),
(339307, 'PTHR36493:SF4', NULL, NULL, NULL, NULL, '', 243389),
(339308, 'PTHR21229:SF1', NULL, NULL, NULL, NULL, 'GH17801P', 243390),
(339309, 'PTHR21229:SF21', NULL, NULL, NULL, NULL, 'OS04G0508600 PROTEIN', 243390),
(339310, 'PTHR21229:SF2', NULL, NULL, NULL, NULL, 'RE59932P', 243390),
(339311, 'PTHR21229:SF22', NULL, NULL, NULL, NULL, 'DBJ|BAA84809.1', 243390),
(339312, 'PTHR21229:SF23', NULL, NULL, NULL, NULL, 'OS02G0618700 PROTEIN', 243390),
(339313, 'PTHR21229:SF68', NULL, NULL, NULL, NULL, 'PTM1', 243390),
(339314, 'PTHR21229', NULL, NULL, NULL, NULL, 'LUNG SEVEN TRANSMEMBRANE RECEPTOR', 243390),
(339315, 'PTHR21229:SF72', NULL, NULL, NULL, NULL, 'BNAA03G00570D PROTEIN', 243390),
(339316, 'PTHR21229:SF73', NULL, NULL, NULL, NULL, 'PROTEIN GPR107-LIKE', 243390),
(339317, 'PTHR21229:SF74', NULL, NULL, NULL, NULL, 'BNAA02G27210D PROTEIN', 243390),
(339318, 'PTHR21229:SF52', NULL, NULL, NULL, NULL, 'ZGC:162698', 243390),
(339319, 'PTHR21229:SF75', NULL, NULL, NULL, NULL, 'PROTEIN CANDIDATE G-PROTEIN COUPLED RECEPTOR 6-RELATED', 243390),
(339320, 'PTHR21229:SF71', NULL, NULL, NULL, NULL, 'LUNG SEVEN TRANSMEMBRANE RECEPTOR', 243390),
(339321, 'PTHR21229:SF15', NULL, NULL, NULL, NULL, 'LUNG SEVEN TRANSMEMBRANE RECEPTOR FAMILY PROTEIN', 243390),
(339322, 'PTHR21229:SF16', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 87B', 243390),
(339323, 'PTHR21229:SF76', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 87B-LIKE ISOFORM X1', 243390),
(339324, 'PTHR21229:SF54', NULL, NULL, NULL, NULL, 'OS05G0462500 PROTEIN', 243390),
(339325, 'PTHR21229:SF55', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', 243390),
(339326, 'PTHR21229:SF77', NULL, NULL, NULL, NULL, 'HYPOTHETICAL MEMBRANE-SPANNING PROTEIN', 243390),
(339327, 'PTHR21229:SF11', NULL, NULL, NULL, NULL, 'PROTEIN GPR108', 243390),
(339328, 'PTHR21229:SF56', NULL, NULL, NULL, NULL, 'LUNG SEVEN TRANSMEMBRANE RECEPTOR FAMILY PROTEIN', 243390),
(339329, 'PTHR21229:SF12', NULL, NULL, NULL, NULL, 'PROTEIN GPR107', 243390),
(339330, 'PTHR21229:SF78', NULL, NULL, NULL, NULL, '', 243390),
(339331, 'PTHR21229:SF79', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 87B-LIKE ISOFORM X1', 243390),
(339332, 'PTHR21229:SF57', NULL, NULL, NULL, NULL, '', 243390),
(339333, 'PTHR21229:SF19', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 87A', 243390),
(339334, 'PTHR21229:SF20', NULL, NULL, NULL, NULL, 'OS07G0614600 PROTEIN', 243390),
(339335, 'PTHR21229:SF60', NULL, NULL, NULL, NULL, 'PROTEIN GPR107-LIKE', 243390);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(339336, 'PTHR41693', NULL, NULL, NULL, NULL, 'HEME-BINDING PROTEIN 1', 243391),
(339337, 'PTHR41693:SF3', NULL, NULL, NULL, NULL, 'SI:CH211-76L23.4', 243391),
(339338, 'PTHR41693:SF2', NULL, NULL, NULL, NULL, 'SI:DKEY-282H22.5', 243391),
(339339, 'PTHR41693:SF1', NULL, NULL, NULL, NULL, 'HEME-BINDING PROTEIN 1', 243391),
(339340, 'PTHR41693:SF4', NULL, NULL, NULL, NULL, 'SI:DKEY-282H22.5', 243391),
(339341, 'PTHR32247', NULL, NULL, NULL, NULL, 'DIABLO HOMOLOG, MITOCHONDRIAL', 243392),
(339342, 'PTHR32247:SF4', NULL, NULL, NULL, NULL, 'DIABLO HOMOLOG, MITOCHONDRIAL', 243392),
(339343, 'PTHR32247:SF3', NULL, NULL, NULL, NULL, 'DIABLO HOMOLOG, MITOCHONDRIAL', 243392),
(339344, 'PTHR48140', NULL, NULL, NULL, NULL, 'FATTY ACID DESATURASE 4, CHLOROPLASTIC-RELATED', 243393),
(339345, 'PTHR48140:SF1', NULL, NULL, NULL, NULL, 'FATTY ACID DESATURASE 4, CHLOROPLASTIC-RELATED', 243393),
(339346, 'PTHR48140:SF4', NULL, NULL, NULL, NULL, 'TMEM189_B_DMAIN DOMAIN-CONTAINING PROTEIN', 243393),
(339347, 'PTHR48140:SF2', NULL, NULL, NULL, NULL, 'FATTY ACID DESATURASE 4-LIKE 2, CHLOROPLASTIC', 243393),
(339348, 'PTHR48140:SF3', NULL, NULL, NULL, NULL, 'TMEM189_B_DMAIN DOMAIN-CONTAINING PROTEIN', 243393),
(339349, 'PTHR43652:SF7', NULL, NULL, NULL, NULL, 'BASIC AMINO ACID ANTIPORTER YFCC-RELATED', 243394),
(339350, 'PTHR43652:SF8', NULL, NULL, NULL, NULL, 'NA+/DICARBOXYLATE, NA+/TRICARBOXYLATE AND PHOSPHATE TRANSPORTERS', 243394),
(339351, 'PTHR43652:SF6', NULL, NULL, NULL, NULL, 'ARGININE REPRESSOR-RELATED', 243394),
(339352, 'PTHR43652', NULL, NULL, NULL, NULL, 'BASIC AMINO ACID ANTIPORTER YFCC-RELATED', 243394),
(339353, 'PTHR43652:SF1', NULL, NULL, NULL, NULL, 'CATION TRANSPORTER-RELATED', 243394),
(339354, 'PTHR43652:SF2', NULL, NULL, NULL, NULL, 'NA+/DICARBOXYLATE', 243394),
(339355, 'PTHR37366:SF1', NULL, NULL, NULL, NULL, 'SPERM ACROSOME MEMBRANE-ASSOCIATED PROTEIN 6', 243395),
(339356, 'PTHR37366', NULL, NULL, NULL, NULL, 'SPERM ACROSOME MEMBRANE-ASSOCIATED PROTEIN 6', 243395),
(339357, 'PTHR34732:SF4', NULL, NULL, NULL, NULL, 'ROD COMPONENT, PUTATIVE-RELATED', 243396),
(339358, 'PTHR34732:SF5', NULL, NULL, NULL, NULL, 'ROD PROTEIN, PUTATIVE-RELATED', 243396),
(339359, 'PTHR34732:SF2', NULL, NULL, NULL, NULL, '73 KDA PARAFLAGELLAR ROD PROTEIN', 243396),
(339360, 'PTHR34732:SF3', NULL, NULL, NULL, NULL, 'ROD PROTEIN, PUTATIVE-RELATED', 243396),
(339361, 'PTHR34732:SF1', NULL, NULL, NULL, NULL, '69 KDA PARAFLAGELLAR ROD PROTEIN', 243396),
(339362, 'PTHR34732', NULL, NULL, NULL, NULL, '69 KDA PARAFLAGELLAR ROD PROTEIN-RELATED', 243396),
(339363, 'PTHR40051', NULL, NULL, NULL, NULL, 'IG HYPOTHETICAL 15966', 243397),
(339364, 'PTHR40051:SF1', NULL, NULL, NULL, NULL, 'IG HYPOTHETICAL 15966', 243397),
(339365, 'PTHR35315:SF2', NULL, NULL, NULL, NULL, 'RAB6-INTERACTING GOLGIN', 243398),
(339366, 'PTHR35315', NULL, NULL, NULL, NULL, 'ACI13', 243398),
(339367, 'PTHR35315:SF1', NULL, NULL, NULL, NULL, 'RAB6-INTERACTING GOLGIN', 243398),
(339368, 'PTHR10830:SF0', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE 48 KDA SUBUNIT', 243399),
(339369, 'PTHR10830', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE 48 KDA SUBUNIT', 243399),
(339370, 'PTHR10830:SF4', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE 48 KDA SUBUNIT', 243399),
(339371, 'PTHR10830:SF5', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE 48 KDA SUBUNIT', 243399),
(339372, 'PTHR35116:SF12', NULL, NULL, NULL, NULL, '', 243400),
(339373, 'PTHR35116:SF2', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT HELICASE FAMILY PROTEIN-RELATED', 243400),
(339374, 'PTHR35116:SF6', NULL, NULL, NULL, NULL, 'OS02G0625900 PROTEIN', 243400),
(339375, 'PTHR35116:SF8', NULL, NULL, NULL, NULL, 'HELICASE PROTEIN MOM1-LIKE ISOFORM X1', 243400),
(339376, 'PTHR35116:SF9', NULL, NULL, NULL, NULL, 'HELICASE MOM1', 243400),
(339377, 'PTHR35116', NULL, NULL, NULL, NULL, 'HELICASE PROTEIN MOM1', 243400),
(339378, 'PTHR35116:SF11', NULL, NULL, NULL, NULL, '', 243400);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(339379, 'PTHR21355:SF11', NULL, NULL, NULL, NULL, 'LMBR1 DOMAIN-CONTAINING PROTEIN 2 HOMOLOG B', 243401),
(339380, 'PTHR21355:SF0', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR-ASSOCIATED PROTEIN LMBRD2', 243401),
(339381, 'PTHR21355:SF16', NULL, NULL, NULL, NULL, 'LMBR1-LIKE MEMBRANE PROTEIN', 243401),
(339382, 'PTHR21355:SF18', NULL, NULL, NULL, NULL, 'LMBR1 INTEGRAL MEMBRANE-LIKE PROTEIN', 243401),
(339383, 'PTHR21355', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243401),
(339384, 'PTHR21355:SF15', NULL, NULL, NULL, NULL, 'BNAA06G24220D PROTEIN', 243401),
(339385, 'PTHR21355:SF14', NULL, NULL, NULL, NULL, 'LMBR1 INTEGRAL MEMBRANE-LIKE PROTEIN', 243401),
(339386, 'PTHR40619', NULL, NULL, NULL, NULL, '', 243402),
(339387, 'PTHR40619:SF2', NULL, NULL, NULL, NULL, '', 243402),
(339388, 'PTHR40619:SF3', NULL, NULL, NULL, NULL, '', 243402),
(339389, 'PTHR47367:SF1', NULL, NULL, NULL, NULL, 'OS07G0486500 PROTEIN', 243403),
(339390, 'PTHR47367', NULL, NULL, NULL, NULL, 'AUXIN-REGULATED PROTEIN-LIKE', 243403),
(339391, 'PTHR47367:SF2', NULL, NULL, NULL, NULL, 'RHO-GAP DOMAIN-CONTAINING PROTEIN', 243403),
(339392, 'PTHR37697', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR SNZ', 243404),
(339393, 'PTHR37697:SF2', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR SNZ', 243404),
(339394, 'PTHR43622', NULL, NULL, NULL, NULL, '3-DEHYDROQUINATE SYNTHASE', 243405),
(339395, 'PTHR43622:SF7', NULL, NULL, NULL, NULL, '3-DEHYDROQUINATE SYNTHASE, CHLOROPLASTIC', 243405),
(339396, 'PTHR43622:SF3', NULL, NULL, NULL, NULL, '2-EPI-5-EPI-VALIOLONE SYNTHASE', 243405),
(339397, 'PTHR43622:SF1', NULL, NULL, NULL, NULL, '3-DEHYDROQUINATE SYNTHASE', 243405),
(339398, 'PTHR33373:SF28', NULL, NULL, NULL, NULL, 'OS07G0479600 PROTEIN', 243406),
(339399, 'PTHR33373:SF29', NULL, NULL, NULL, NULL, '', 243406),
(339400, 'PTHR33373:SF18', NULL, NULL, NULL, NULL, 'OS01G0172300 PROTEIN', 243406),
(339401, 'PTHR33373:SF26', NULL, NULL, NULL, NULL, 'BNAC03G67340D PROTEIN', 243406),
(339402, 'PTHR33373:SF27', NULL, NULL, NULL, NULL, 'DUF4050 FAMILY PROTEIN', 243406),
(339403, 'PTHR33373:SF31', NULL, NULL, NULL, NULL, '', 243406),
(339404, 'PTHR33373:SF1', NULL, NULL, NULL, NULL, 'DUF4050 DOMAIN-CONTAINING PROTEIN', 243406),
(339405, 'PTHR33373:SF20', NULL, NULL, NULL, NULL, 'DUF4050 DOMAIN-CONTAINING PROTEIN', 243406),
(339406, 'PTHR33373:SF32', NULL, NULL, NULL, NULL, '', 243406),
(339407, 'PTHR33373:SF21', NULL, NULL, NULL, NULL, '', 243406),
(339408, 'PTHR33373:SF30', NULL, NULL, NULL, NULL, 'DUF4050 FAMILY PROTEIN', 243406),
(339409, 'PTHR33373:SF13', NULL, NULL, NULL, NULL, 'DUF4050 FAMILY PROTEIN', 243406),
(339410, 'PTHR33373:SF25', NULL, NULL, NULL, NULL, 'BNAA09G56760D PROTEIN', 243406),
(339411, 'PTHR33373:SF14', NULL, NULL, NULL, NULL, '', 243406),
(339412, 'PTHR33373:SF22', NULL, NULL, NULL, NULL, 'DUF4050 FAMILY PROTEIN', 243406),
(339413, 'PTHR33373:SF33', NULL, NULL, NULL, NULL, '', 243406),
(339414, 'PTHR33373:SF23', NULL, NULL, NULL, NULL, 'DUF4050 DOMAIN-CONTAINING PROTEIN', 243406),
(339415, 'PTHR33373:SF12', NULL, NULL, NULL, NULL, '', 243406),
(339416, 'PTHR33373', NULL, NULL, NULL, NULL, 'OS07G0479600 PROTEIN', 243406),
(339417, 'PTHR31741:SF6', NULL, NULL, NULL, NULL, 'PROTEIN EMBRYO SAC DEVELOPMENT ARREST 30', 243407),
(339418, 'PTHR31741:SF8', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 35', 243407),
(339419, 'PTHR31741:SF93', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339420, 'PTHR31741:SF83', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339421, 'PTHR31741:SF86', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339422, 'PTHR31741:SF42', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339423, 'PTHR31741:SF88', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339424, 'PTHR31741:SF44', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339425, 'PTHR31741:SF2', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 13', 243407);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(339426, 'PTHR31741:SF1', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 7', 243407),
(339427, 'PTHR31741:SF87', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339428, 'PTHR31741:SF46', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 27', 243407),
(339429, 'PTHR31741:SF4', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 28', 243407),
(339430, 'PTHR31741:SF45', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339431, 'PTHR31741:SF3', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339432, 'PTHR31741:SF60', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339433, 'PTHR31741:SF100', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339434, 'PTHR31741:SF15', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 38', 243407),
(339435, 'PTHR31741:SF14', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 1', 243407),
(339436, 'PTHR31741:SF58', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN I RHAMNOSYLTRANSFERASE 1', 243407),
(339437, 'PTHR31741:SF95', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339438, 'PTHR31741:SF51', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN I RHAMNOSYLTRANSFERASE 1', 243407),
(339439, 'PTHR31741:SF53', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 19', 243407),
(339440, 'PTHR31741:SF97', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339441, 'PTHR31741:SF96', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339442, 'PTHR31741:SF99', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339443, 'PTHR31741:SF54', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339444, 'PTHR31741:SF98', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339445, 'PTHR31741:SF57', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 24', 243407),
(339446, 'PTHR31741:SF71', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339447, 'PTHR31741', NULL, NULL, NULL, NULL, 'OS02G0726500 PROTEIN-RELATED', 243407),
(339448, 'PTHR31741:SF69', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN I RHAMNOSYLTRANSFERASE 1', 243407),
(339449, 'PTHR31741:SF62', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339450, 'PTHR31741:SF20', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339451, 'PTHR31741:SF63', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 37', 243407),
(339452, 'PTHR31741:SF22', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339453, 'PTHR31741:SF66', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 20', 243407),
(339454, 'PTHR31741:SF65', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339455, 'PTHR31741:SF68', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN I RHAMNOSYLTRANSFERASE 4', 243407),
(339456, 'PTHR31741:SF67', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339457, 'PTHR31741:SF80', NULL, NULL, NULL, NULL, 'PROTEIN FRIABLE 1', 243407),
(339458, 'PTHR31741:SF82', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339459, 'PTHR31741:SF81', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339460, 'PTHR31741:SF73', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339461, 'PTHR31741:SF72', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339462, 'PTHR31741:SF75', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339463, 'PTHR31741:SF77', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339464, 'PTHR31741:SF76', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339465, 'PTHR31741:SF79', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339466, 'PTHR31741:SF78', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 243407),
(339467, 'PTHR19422', NULL, NULL, NULL, NULL, 'GAG RETROVIRAL POLYPROTEIN', 243408),
(339468, 'PTHR19422:SF123', NULL, NULL, NULL, NULL, 'PROTEASE', 243408); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(339469, 'PTHR45805:SF3', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR ROR-ALPHA', 243409),
(339470, 'PTHR45805:SF6', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR ROR-BETA', 243409),
(339471, 'PTHR45805:SF2', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR HR3-RELATED', 243409),
(339472, 'PTHR45805:SF1', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR ROR-GAMMA', 243409),
(339473, 'PTHR45805', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR HR3-RELATED', 243409),
(339474, 'PTHR45805:SF7', NULL, NULL, NULL, NULL, 'RAR-RELATED ORPHAN RECEPTOR C B', 243409),
(339475, 'PTHR45805:SF10', NULL, NULL, NULL, NULL, 'ECDYSONE-INDUCED PROTEIN 78C', 243409),
(339476, 'PTHR45805:SF9', NULL, NULL, NULL, NULL, 'RAR-RELATED ORPHAN RECEPTOR C A', 243409),
(339477, 'PTHR45805:SF11', NULL, NULL, NULL, NULL, 'RAR-RELATED ORPHAN RECEPTOR C', 243409),
(339478, 'PTHR13903:SF23', NULL, NULL, NULL, NULL, 'OS09G0484800 PROTEIN', 243410),
(339479, 'PTHR13903:SF11', NULL, NULL, NULL, NULL, 'OS08G0364900 PROTEIN', 243410),
(339480, 'PTHR13903', NULL, NULL, NULL, NULL, 'PIRIN-RELATED', 243410),
(339481, 'PTHR13903:SF22', NULL, NULL, NULL, NULL, 'PIRIN-1', 243410),
(339482, 'PTHR13903:SF17', NULL, NULL, NULL, NULL, 'PIRIN', 243410),
(339483, 'PTHR13903:SF8', NULL, NULL, NULL, NULL, 'PIRIN', 243410),
(339484, 'PTHR13903:SF25', NULL, NULL, NULL, NULL, 'PIRIN-LIKE PROTEIN', 243410),
(339485, 'PTHR13903:SF19', NULL, NULL, NULL, NULL, '', 243410),
(339486, 'PTHR13903:SF31', NULL, NULL, NULL, NULL, 'CUPIN-DOMAIN CONTAINING PROTEIN', 243410),
(339487, 'PTHR13903:SF20', NULL, NULL, NULL, NULL, 'BNAC08G48910D PROTEIN', 243410),
(339488, 'PTHR13903:SF30', NULL, NULL, NULL, NULL, 'BNAA05G34480D PROTEIN', 243410),
(339489, 'PTHR12893:SF0', NULL, NULL, NULL, NULL, 'GRASP65', 243411),
(339490, 'PTHR12893:SF1', NULL, NULL, NULL, NULL, 'GOLGI REASSEMBLY-STACKING PROTEIN 2', 243411),
(339491, 'PTHR12893:SF2', NULL, NULL, NULL, NULL, 'GOLGI REASSEMBLY-STACKING PROTEIN 1', 243411),
(339492, 'PTHR12893', NULL, NULL, NULL, NULL, 'GOLGI REASSEMBLY STACKING PROTEIN  GRASP', 243411),
(339493, 'PTHR28629:SF4', NULL, NULL, NULL, NULL, 'TRIOKINASE/FMN CYCLASE', 243412),
(339494, 'PTHR28629', NULL, NULL, NULL, NULL, 'TRIOKINASE/FMN CYCLASE', 243412),
(339495, 'PTHR28629:SF1', NULL, NULL, NULL, NULL, 'YALI0F01606P', 243412),
(339496, 'PTHR28629:SF11', NULL, NULL, NULL, NULL, '', 243412),
(339497, 'PTHR28629:SF12', NULL, NULL, NULL, NULL, 'DIHYDROXYACETONE KINASE 2', 243412),
(339498, 'PTHR28629:SF13', NULL, NULL, NULL, NULL, 'DIHYDROXYACETONE KINASE', 243412),
(339499, 'PTHR34785:SF3', NULL, NULL, NULL, NULL, 'ECA1 GAMETOGENESIS RELATED FAMILY PROTEIN-RELATED', 243413),
(339500, 'PTHR34785:SF4', NULL, NULL, NULL, NULL, 'ECA1 GAMETOGENESIS RELATED FAMILY PROTEIN', 243413),
(339501, 'PTHR34785', NULL, NULL, NULL, NULL, 'ECA1 GAMETOGENESIS RELATED FAMILY PROTEIN-RELATED', 243413),
(339502, 'PTHR15950:SF23', NULL, NULL, NULL, NULL, 'SI:CH73-52F15.5-RELATED', 243414),
(339503, 'PTHR15950:SF15', NULL, NULL, NULL, NULL, 'PROTEIN VESTIGIAL', 243414),
(339504, 'PTHR15950:SF20', NULL, NULL, NULL, NULL, 'TRANSCRIPTION COFACTOR VESTIGIAL-LIKE PROTEIN 1', 243414),
(339505, 'PTHR15950:SF22', NULL, NULL, NULL, NULL, 'VESTIGIAL-LIKE FAMILY MEMBER 2B', 243414),
(339506, 'PTHR15950:SF16', NULL, NULL, NULL, NULL, 'TRANSCRIPTION COFACTOR VESTIGIAL-LIKE PROTEIN 3', 243414),
(339507, 'PTHR15950', NULL, NULL, NULL, NULL, 'TRANSCRIPTION COFACTOR VESTIGIAL-LIKE PROTEIN', 243414),
(339508, 'PTHR15950:SF17', NULL, NULL, NULL, NULL, 'TRANSCRIPTION COFACTOR VESTIGIAL-LIKE PROTEIN 2', 243414),
(339509, 'PTHR46043:SF7', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 243415),
(339510, 'PTHR46043:SF9', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 243415),
(339511, 'PTHR46043:SF16', NULL, NULL, NULL, NULL, 'BNAC03G16340D PROTEIN', 243415),
(339512, 'PTHR46043:SF2', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 243415),
(339513, 'PTHR46043:SF15', NULL, NULL, NULL, NULL, 'ARMADILLO-TYPE FOLD PROTEIN-RELATED', 243415),
(339514, 'PTHR46043:SF3', NULL, NULL, NULL, NULL, 'OS02G0160250 PROTEIN', 243415);
INSERT INTO "PUBLIC"."MODEL" VALUES
(339515, 'PTHR46043:SF14', NULL, NULL, NULL, NULL, 'ARMADILLO-TYPE FOLD PROTEIN-RELATED', 243415),
(339516, 'PTHR46043:SF5', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 243415),
(339517, 'PTHR46043:SF13', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 243415),
(339518, 'PTHR46043:SF18', NULL, NULL, NULL, NULL, 'BNAC04G04430D PROTEIN', 243415),
(339519, 'PTHR46043:SF1', NULL, NULL, NULL, NULL, 'OS03G0116900 PROTEIN', 243415),
(339520, 'PTHR46043:SF12', NULL, NULL, NULL, NULL, '', 243415),
(339521, 'PTHR46043:SF11', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 243415),
(339522, 'PTHR46043:SF22', NULL, NULL, NULL, NULL, 'ARMADILLO/BETA-CATENIN-LIKE REPEAT PROTEIN', 243415),
(339523, 'PTHR46043:SF21', NULL, NULL, NULL, NULL, 'ARMADILLO-TYPE FOLD PROTEIN-RELATED', 243415),
(339524, 'PTHR46043', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 243415),
(339525, 'PTHR47213', NULL, NULL, NULL, NULL, 'OS07G0567300 PROTEIN', 243416),
(339526, 'PTHR47213:SF1', NULL, NULL, NULL, NULL, 'OS07G0567300 PROTEIN', 243416),
(339527, 'PTHR21445', NULL, NULL, NULL, NULL, 'ENDONUCLEASE IV  ENDODEOXYRIBONUCLEASE IV', 243417),
(339528, 'PTHR21445:SF0', NULL, NULL, NULL, NULL, 'AP_ENDONUC_2 DOMAIN-CONTAINING PROTEIN-RELATED', 243417),
(339529, 'PTHR30133:SF1', NULL, NULL, NULL, NULL, 'HISTIDINE TRANSPORT SYSTEM PERMEASE PROTEIN HISQ', 243418),
(339530, 'PTHR30133:SF2', NULL, NULL, NULL, NULL, 'ARGININE ABC TRANSPORTER PERMEASE PROTEIN ARTQ', 243418),
(339531, 'PTHR30133', NULL, NULL, NULL, NULL, 'CATIONIC AMINO ACID TRANSPORTER, MEMBRANE COMPONENT', 243418),
(339532, 'PTHR30133:SF4', NULL, NULL, NULL, NULL, 'ARGININE/ORNITHINE TRANSPORT PROTEIN AOTQ', 243418),
(339533, 'PTHR34483:SF2', NULL, NULL, NULL, NULL, 'OS09G0130700 PROTEIN', 243419),
(339534, 'PTHR34483:SF1', NULL, NULL, NULL, NULL, '', 243419),
(339535, 'PTHR34483:SF4', NULL, NULL, NULL, NULL, 'OS08G0256000 PROTEIN', 243419),
(339536, 'PTHR34483:SF6', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 243419),
(339537, 'PTHR34483:SF5', NULL, NULL, NULL, NULL, '', 243419),
(339538, 'PTHR34483', NULL, NULL, NULL, NULL, 'OS09G0129800 PROTEIN', 243419),
(339539, 'PTHR31885', NULL, NULL, NULL, NULL, 'GH04784P', 243420),
(339540, 'PTHR31885:SF7', NULL, NULL, NULL, NULL, 'LYSOPLASMALOGENASE', 243420),
(339541, 'PTHR31885:SF6', NULL, NULL, NULL, NULL, 'GH04784P', 243420),
(339542, 'PTHR31885:SF11', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 86B', 243420),
(339543, 'PTHR31885:SF10', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 86A', 243420),
(339544, 'PTHR31885:SF9', NULL, NULL, NULL, NULL, 'LYSOPLASMALOGENASE-LIKE PROTEIN TMEM86A', 243420),
(339545, 'PTHR20951', NULL, NULL, NULL, NULL, 'C13ORF1 PROTEIN-RELATED', 243421),
(339546, 'PTHR20951:SF2', NULL, NULL, NULL, NULL, 'SPRY DOMAIN-CONTAINING PROTEIN 7', 243421),
(339547, 'PTHR35778', NULL, NULL, NULL, NULL, 'SIGNALING MUCIN HKR1-RELATED', 243422),
(339548, 'PTHR35778:SF1', NULL, NULL, NULL, NULL, 'SIGNALING MUCIN HKR1-RELATED', 243422),
(339549, 'PTHR28518:SF1', NULL, NULL, NULL, NULL, 'TRNA-SPLICING ENDONUCLEASE SUBUNIT SEN15', 243423),
(339550, 'PTHR28518', NULL, NULL, NULL, NULL, 'TRNA-SPLICING ENDONUCLEASE SUBUNIT SEN15', 243423),
(339551, 'PTHR42740', NULL, NULL, NULL, NULL, 'RIBONUCLEASE VAPC3', 243424),
(339552, 'PTHR42740:SF1', NULL, NULL, NULL, NULL, 'RIBONUCLEASE VAPC3', 243424),
(339553, 'PTHR42740:SF2', NULL, NULL, NULL, NULL, 'RIBONUCLEASE VAPC1', 243424),
(339554, 'PTHR46345:SF4', NULL, NULL, NULL, NULL, 'FH2 DOMAIN-CONTAINING PROTEIN', 243425),
(339555, 'PTHR46345:SF8', NULL, NULL, NULL, NULL, 'FORMIN 3, ISOFORM B', 243425),
(339556, 'PTHR46345:SF7', NULL, NULL, NULL, NULL, 'FH2 DOMAIN-CONTAINING 3', 243425),
(339557, 'PTHR46345:SF6', NULL, NULL, NULL, NULL, 'FH2 DOMAIN-CONTAINING 4', 243425),
(339558, 'PTHR46345:SF5', NULL, NULL, NULL, NULL, 'INVERTED FORMIN-2', 243425),
(339559, 'PTHR46345:SF9', NULL, NULL, NULL, NULL, 'GBD/FH3 DOMAIN-CONTAINING PROTEIN', 243425),
(339560, 'PTHR46345', NULL, NULL, NULL, NULL, 'INVERTED FORMIN-2', 243425);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(339561, 'PTHR47664', NULL, NULL, NULL, NULL, 'NLPC_P60 DOMAIN-CONTAINING PROTEIN', 243426),
(339562, 'PTHR47664:SF1', NULL, NULL, NULL, NULL, 'NLPC_P60 DOMAIN-CONTAINING PROTEIN', 243426),
(339563, 'PTHR21879', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243427),
(339564, 'PTHR21879:SF25', NULL, NULL, NULL, NULL, 'OSIRIS 24', 243427),
(339565, 'PTHR21879:SF14', NULL, NULL, NULL, NULL, 'OSIRIS 8', 243427),
(339566, 'PTHR21879:SF13', NULL, NULL, NULL, NULL, 'OSIRIS 18', 243427),
(339567, 'PTHR21879:SF24', NULL, NULL, NULL, NULL, 'OSIRIS 10B', 243427),
(339568, 'PTHR21879:SF12', NULL, NULL, NULL, NULL, 'OSIRIS 12', 243427),
(339569, 'PTHR21879:SF23', NULL, NULL, NULL, NULL, 'IP06949P', 243427),
(339570, 'PTHR21879:SF22', NULL, NULL, NULL, NULL, 'FI03362P-RELATED', 243427),
(339571, 'PTHR21879:SF18', NULL, NULL, NULL, NULL, 'LD17368P', 243427),
(339572, 'PTHR21879:SF17', NULL, NULL, NULL, NULL, 'LD24139P', 243427),
(339573, 'PTHR21879:SF27', NULL, NULL, NULL, NULL, 'OSIRIS 10A', 243427),
(339574, 'PTHR21879:SF26', NULL, NULL, NULL, NULL, 'OSIRIS 1', 243427),
(339575, 'PTHR21879:SF15', NULL, NULL, NULL, NULL, 'OSIRIS 21', 243427),
(339576, 'PTHR21879:SF2', NULL, NULL, NULL, NULL, 'OSIRIS 20', 243427),
(339577, 'PTHR21879:SF3', NULL, NULL, NULL, NULL, 'FI03378P', 243427),
(339578, 'PTHR21879:SF1', NULL, NULL, NULL, NULL, 'FI01546P', 243427),
(339579, 'PTHR21879:SF10', NULL, NULL, NULL, NULL, 'LP14110P', 243427),
(339580, 'PTHR21879:SF6', NULL, NULL, NULL, NULL, 'OSIRIS 19, ISOFORM A', 243427),
(339581, 'PTHR21879:SF21', NULL, NULL, NULL, NULL, 'OSIRIS 4, ISOFORM B', 243427),
(339582, 'PTHR21879:SF7', NULL, NULL, NULL, NULL, 'OSIRIS 11', 243427),
(339583, 'PTHR21879:SF4', NULL, NULL, NULL, NULL, 'OSIRIS 17, ISOFORM C', 243427),
(339584, 'PTHR21879:SF5', NULL, NULL, NULL, NULL, 'OSIRIS 15', 243427),
(339585, 'PTHR21879:SF8', NULL, NULL, NULL, NULL, 'OSIRIS 23', 243427),
(339586, 'PTHR21879:SF9', NULL, NULL, NULL, NULL, 'OSIRIS 16', 243427),
(339587, 'PTHR47842:SF1', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 243428),
(339588, 'PTHR47842:SF3', NULL, NULL, NULL, NULL, 'DUF676 DOMAIN-CONTAINING PROTEIN', 243428),
(339589, 'PTHR47842:SF2', NULL, NULL, NULL, NULL, '', 243428),
(339590, 'PTHR47842', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243428),
(339591, 'PTHR12992:SF9', NULL, NULL, NULL, NULL, 'OS05G0209400 PROTEIN', 243429),
(339592, 'PTHR12992:SF41', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 11', 243429),
(339593, 'PTHR12992:SF32', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 243429),
(339594, 'PTHR12992:SF43', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 15, MITOCHONDRIAL', 243429),
(339595, 'PTHR12992:SF42', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 243429),
(339596, 'PTHR12992:SF11', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE-LINKED MOIETY X MOTIF 8', 243429),
(339597, 'PTHR12992:SF44', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 243429),
(339598, 'PTHR12992:SF24', NULL, NULL, NULL, NULL, 'PEROXISOMAL COENZYME A DIPHOSPHATASE NUDT7', 243429),
(339599, 'PTHR12992', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE', 243429),
(339600, 'PTHR12992:SF26', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 15, MITOCHONDRIAL-LIKE ISOFORM X1', 243429),
(339601, 'PTHR47250:SF5', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 243430),
(339602, 'PTHR47250:SF6', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SET-6', 243430),
(339603, 'PTHR47250:SF1', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 243430),
(339604, 'PTHR47250', NULL, NULL, NULL, NULL, '', 243430),
(339605, 'PTHR47250:SF2', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 243430),
(339606, 'PTHR47250:SF3', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 243430),
(339607, 'PTHR48039:SF5', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 28', 243431),
(339608, 'PTHR48039:SF6', NULL, NULL, NULL, NULL, 'BNAA04G12180D PROTEIN', 243431),
(339609, 'PTHR48039:SF3', NULL, NULL, NULL, NULL, '', 243431),
(339610, 'PTHR48039:SF4', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 243431);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(339611, 'PTHR48039:SF1', NULL, NULL, NULL, NULL, 'RNA-BINDING MOTIF PROTEIN 14B', 243431),
(339612, 'PTHR48039', NULL, NULL, NULL, NULL, 'RNA-BINDING MOTIF PROTEIN 14B', 243431),
(339613, 'PTHR45931', NULL, NULL, NULL, NULL, 'SI:CH211-59O9.10', 243432),
(339614, 'PTHR45931:SF5', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RHY1A-RELATED', 243432),
(339615, 'PTHR45931:SF13', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 243432),
(339616, 'PTHR45931:SF12', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 243432),
(339617, 'PTHR45931:SF15', NULL, NULL, NULL, NULL, 'SI:CH211-59O9.10', 243432),
(339618, 'PTHR45931:SF17', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 243432),
(339619, 'PTHR45931:SF16', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 243432),
(339620, 'PTHR45931:SF3', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 243432),
(339621, 'PTHR45931:SF19', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 243432),
(339622, 'PTHR45931:SF18', NULL, NULL, NULL, NULL, 'OS04G0511600 PROTEIN', 243432),
(339623, 'PTHR45931:SF4', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RLIM', 243432),
(339624, 'PTHR45931:SF1', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 243432),
(339625, 'PTHR45931:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF6', 243432),
(339626, 'PTHR46268:SF18', NULL, NULL, NULL, NULL, 'UNIVERSAL STRESS PROTEIN F', 243433),
(339627, 'PTHR46268:SF19', NULL, NULL, NULL, NULL, 'SLR0670 PROTEIN', 243433),
(339628, 'PTHR46268:SF6', NULL, NULL, NULL, NULL, 'UNIVERSAL STRESS PROTEIN A-RELATED', 243433),
(339629, 'PTHR46268:SF20', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 243433),
(339630, 'PTHR46268:SF8', NULL, NULL, NULL, NULL, 'SENSOR PROTEIN KDPD-RELATED', 243433),
(339631, 'PTHR46268:SF13', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 243433),
(339632, 'PTHR46268:SF21', NULL, NULL, NULL, NULL, 'UNIVERSAL STRESS PROTEIN UP12', 243433),
(339633, 'PTHR46268:SF22', NULL, NULL, NULL, NULL, 'UNIVERSAL STRESS PROTEIN FAMILY', 243433),
(339634, 'PTHR46268:SF16', NULL, NULL, NULL, NULL, 'UNIVERSAL STRESS PROTEIN C', 243433),
(339635, 'PTHR46268', NULL, NULL, NULL, NULL, 'STRESS RESPONSE PROTEIN NHAX', 243433),
(339636, 'PTHR46268:SF15', NULL, NULL, NULL, NULL, 'UNIVERSAL STRESS PROTEIN HP_0031', 243433),
(339637, 'PTHR33138:SF24', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 243434),
(339638, 'PTHR33138:SF67', NULL, NULL, NULL, NULL, 'OS01G0113900 PROTEIN', 243434),
(339639, 'PTHR33138:SF65', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 2.1', 243434),
(339640, 'PTHR33138:SF86', NULL, NULL, NULL, NULL, 'GUB_WAK_BIND DOMAIN-CONTAINING PROTEIN', 243434),
(339641, 'PTHR33138:SF85', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 2.7 ISOFORM X1', 243434),
(339642, 'PTHR33138:SF84', NULL, NULL, NULL, NULL, 'OS01G0136500 PROTEIN', 243434),
(339643, 'PTHR33138:SF83', NULL, NULL, NULL, NULL, 'OS01G0137700 PROTEIN', 243434),
(339644, 'PTHR33138:SF28', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 2.1', 243434),
(339645, 'PTHR33138:SF49', NULL, NULL, NULL, NULL, '', 243434),
(339646, 'PTHR33138:SF27', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE GALACTURONAN-BINDING PROTEIN', 243434),
(339647, 'PTHR33138:SF48', NULL, NULL, NULL, NULL, 'RECEPTOR KINASE', 243434),
(339648, 'PTHR33138:SF69', NULL, NULL, NULL, NULL, '', 243434),
(339649, 'PTHR33138:SF71', NULL, NULL, NULL, NULL, 'GUB_WAK_BIND DOMAIN-CONTAINING PROTEIN', 243434),
(339650, 'PTHR33138:SF70', NULL, NULL, NULL, NULL, '', 243434),
(339651, 'PTHR33138:SF79', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE CARBOXY-TERMINAL PROTEIN', 243434),
(339652, 'PTHR33138:SF78', NULL, NULL, NULL, NULL, 'GUB_WAK_BIND DOMAIN-CONTAINING PROTEIN', 243434),
(339653, 'PTHR33138:SF56', NULL, NULL, NULL, NULL, 'OS01G0137282 PROTEIN', 243434);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(339654, 'PTHR33138:SF11', NULL, NULL, NULL, NULL, 'KINASE-LIKE PROTEIN', 243434),
(339655, 'PTHR33138:SF77', NULL, NULL, NULL, NULL, 'KINASE SUPERFAMILY PROTEIN', 243434),
(339656, 'PTHR33138:SF54', NULL, NULL, NULL, NULL, 'OS01G0690900 PROTEIN', 243434),
(339657, 'PTHR33138:SF76', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE CARBOXY-TERMINAL PROTEIN', 243434),
(339658, 'PTHR33138:SF75', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 1.2', 243434),
(339659, 'PTHR33138:SF74', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE, GALACTURONAN-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 243434),
(339660, 'PTHR33138:SF52', NULL, NULL, NULL, NULL, 'GUB_WAK_BIND DOMAIN-CONTAINING PROTEIN', 243434),
(339661, 'PTHR33138:SF30', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 2.7', 243434),
(339662, 'PTHR33138:SF73', NULL, NULL, NULL, NULL, 'GUB_WAK_BIND DOMAIN-CONTAINING PROTEIN', 243434),
(339663, 'PTHR33138:SF51', NULL, NULL, NULL, NULL, '', 243434),
(339664, 'PTHR33138:SF72', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE CARBOXY-TERMINAL PROTEIN', 243434),
(339665, 'PTHR33138:SF9', NULL, NULL, NULL, NULL, 'OS01G0137200 PROTEIN', 243434),
(339666, 'PTHR33138:SF59', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 1.2', 243434),
(339667, 'PTHR33138:SF1', NULL, NULL, NULL, NULL, 'OS01G0690200 PROTEIN', 243434),
(339668, 'PTHR33138', NULL, NULL, NULL, NULL, 'OS01G0690200 PROTEIN', 243434),
(339669, 'PTHR33138:SF82', NULL, NULL, NULL, NULL, 'OS01G0117266 PROTEIN', 243434),
(339670, 'PTHR33138:SF60', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 243434),
(339671, 'PTHR33138:SF81', NULL, NULL, NULL, NULL, 'GUB_WAK_BIND DOMAIN-CONTAINING PROTEIN', 243434),
(339672, 'PTHR33138:SF80', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE CARBOXY-TERMINAL PROTEIN', 243434),
(339673, 'PTHR36002:SF1', NULL, NULL, NULL, NULL, 'PYRD', 243435),
(339674, 'PTHR36002', NULL, NULL, NULL, NULL, 'PYRD', 243435),
(339675, 'PTHR36002:SF4', NULL, NULL, NULL, NULL, '', 243435),
(339676, 'PTHR33237:SF5', NULL, NULL, NULL, NULL, 'OS02G0711400 PROTEIN', 243436),
(339677, 'PTHR33237:SF7', NULL, NULL, NULL, NULL, '', 243436),
(339678, 'PTHR33237:SF31', NULL, NULL, NULL, NULL, 'F2P16.13 PROTEIN', 243436),
(339679, 'PTHR33237:SF30', NULL, NULL, NULL, NULL, 'BNAA01G26690D PROTEIN', 243436),
(339680, 'PTHR33237:SF51', NULL, NULL, NULL, NULL, '', 243436),
(339681, 'PTHR33237', NULL, NULL, NULL, NULL, 'F2P16.13 PROTEIN-RELATED', 243436),
(339682, 'PTHR33237:SF40', NULL, NULL, NULL, NULL, '', 243436),
(339683, 'PTHR33237:SF50', NULL, NULL, NULL, NULL, '', 243436),
(339684, 'PTHR33237:SF35', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 243436),
(339685, 'PTHR33237:SF46', NULL, NULL, NULL, NULL, 'OS06G0499100 PROTEIN', 243436),
(339686, 'PTHR33237:SF33', NULL, NULL, NULL, NULL, 'OS05G0588400 PROTEIN', 243436),
(339687, 'PTHR33237:SF21', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 243436),
(339688, 'PTHR33237:SF39', NULL, NULL, NULL, NULL, '', 243436),
(339689, 'PTHR33237:SF49', NULL, NULL, NULL, NULL, '', 243436),
(339690, 'PTHR33237:SF38', NULL, NULL, NULL, NULL, 'OS01G0606100 PROTEIN', 243436),
(339691, 'PTHR33237:SF48', NULL, NULL, NULL, NULL, 'BNAA06G03360D PROTEIN', 243436),
(339692, 'PTHR33237:SF47', NULL, NULL, NULL, NULL, '', 243436),
(339693, 'PTHR33237:SF36', NULL, NULL, NULL, NULL, '', 243436),
(339694, 'PTHR33237:SF25', NULL, NULL, NULL, NULL, 'OS02G0321600 PROTEIN', 243436),
(339695, 'PTHR33237:SF4', NULL, NULL, NULL, NULL, 'F14O23.12', 243436),
(339696, 'PTHR33237:SF29', NULL, NULL, NULL, NULL, '', 243436),
(339697, 'PTHR48085:SF15', NULL, NULL, NULL, NULL, 'BNAA06G25070D PROTEIN', 243437),
(339698, 'PTHR48085:SF1', NULL, NULL, NULL, NULL, 'CATION TRANSPORTING ATPASE (E1-E2 FAMILY)', 243437),
(339699, 'PTHR48085', NULL, NULL, NULL, NULL, 'CADMIUM/ZINC-TRANSPORTING ATPASE HMA2-RELATED', 243437),
(339700, 'PTHR48085:SF13', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 243437);
INSERT INTO "PUBLIC"."MODEL" VALUES
(339701, 'PTHR48085:SF14', NULL, NULL, NULL, NULL, 'CADMIUM/ZINC-TRANSPORTING ATPASE HMA2', 243437),
(339702, 'PTHR48085:SF12', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 243437),
(339703, 'PTHR48085:SF8', NULL, NULL, NULL, NULL, 'CADMIUM/ZINC-TRANSPORTING ATPASE HMA3', 243437),
(339704, 'PTHR48085:SF6', NULL, NULL, NULL, NULL, 'INACTIVE CADMIUM/ZINC-TRANSPORTING ATPASE HMA3-RELATED', 243437),
(339705, 'PTHR48085:SF7', NULL, NULL, NULL, NULL, 'CADMIUM/ZINC-TRANSPORTING ATPASE HMA2', 243437),
(339706, 'PTHR48085:SF5', NULL, NULL, NULL, NULL, 'CADMIUM/ZINC-TRANSPORTING ATPASE HMA4-RELATED', 243437),
(339707, 'PTHR48085:SF2', NULL, NULL, NULL, NULL, 'BNAC07G50890D PROTEIN', 243437),
(339708, 'PTHR48085:SF3', NULL, NULL, NULL, NULL, 'HEAVY METAL ATPASE TRANSPORTER', 243437),
(339709, 'PTHR39664', NULL, NULL, NULL, NULL, '', 243438),
(339710, 'PTHR39664:SF2', NULL, NULL, NULL, NULL, 'NUCLEIC ACID-BINDING PROTEIN, CONTAINING PIN DOMAIN-RELATED', 243438),
(339711, 'PTHR34755', NULL, NULL, NULL, NULL, 'SERINE/ARGININE REPETITIVE MATRIX PROTEIN 3-RELATED', 243439),
(339712, 'PTHR34755:SF3', NULL, NULL, NULL, NULL, 'SERINE/ARGININE REPETITIVE MATRIX PROTEIN 2', 243439),
(339713, 'PTHR34755:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG24672', 243439),
(339714, 'PTHR34755:SF1', NULL, NULL, NULL, NULL, 'SERINE/ARGININE REPETITIVE MATRIX PROTEIN 4', 243439),
(339715, 'PTHR34755:SF2', NULL, NULL, NULL, NULL, 'SERINE/ARGININE REPETITIVE MATRIX PROTEIN 3', 243439),
(339716, 'PTHR12949', NULL, NULL, NULL, NULL, 'RNA POLYMERASE III  DNA DIRECTED -RELATED', 243440),
(339717, 'PTHR12949:SF0', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE III SUBUNIT RPC3', 243440),
(339718, 'PTHR23431:SF9', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT 10-LIKE PROTEIN', 243441),
(339719, 'PTHR23431:SF8', NULL, NULL, NULL, NULL, '', 243441),
(339720, 'PTHR23431:SF6', NULL, NULL, NULL, NULL, '', 243441),
(339721, 'PTHR23431:SF5', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASES II, IV AND V SUBUNIT 10', 243441),
(339722, 'PTHR23431:SF3', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASES I, II, AND III SUBUNIT RPABC5', 243441),
(339723, 'PTHR23431', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASES I, II, AND III SUBUNIT RPABC5 FAMILY MEMBER', 243441),
(339724, 'PTHR30574:SF11', NULL, NULL, NULL, NULL, 'SULF_TRANSP DOMAIN-CONTAINING PROTEIN', 243442),
(339725, 'PTHR30574:SF1', NULL, NULL, NULL, NULL, 'UPF0394 INNER MEMBRANE PROTEIN YEEE', 243442),
(339726, 'PTHR30574', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YEDE', 243442),
(339727, 'PTHR24131:SF5', NULL, NULL, NULL, NULL, 'APOPTOSIS-STIMULATING OF P53 PROTEIN 1', 243443),
(339728, 'PTHR24131:SF15', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1, REGULATORY SUBUNIT 13BA', 243443),
(339729, 'PTHR24131:SF16', NULL, NULL, NULL, NULL, 'TUMOR PROTEIN P53-BINDING PROTEIN, 2B', 243443),
(339730, 'PTHR24131', NULL, NULL, NULL, NULL, 'APOPTOSIS-STIMULATING OF P53 PROTEIN', 243443),
(339731, 'PTHR24131:SF8', NULL, NULL, NULL, NULL, 'APOPTOSIS-STIMULATING OF P53 PROTEIN 2', 243443),
(339732, 'PTHR24131:SF10', NULL, NULL, NULL, NULL, 'ANKYRIN-REPEAT, SH3-DOMAIN, AND PROLINE-RICH-REGION CONTAINING PROTEIN, ISOFORM B', 243443),
(339733, 'PTHR28661', NULL, NULL, NULL, NULL, 'SJOEGREN SYNDROME NUCLEAR AUTOANTIGEN 1', 243444),
(339734, 'PTHR28661:SF1', NULL, NULL, NULL, NULL, 'SJOEGREN SYNDROME NUCLEAR AUTOANTIGEN 1', 243444),
(339735, 'PTHR47052:SF5', NULL, NULL, NULL, NULL, 'EXTENSIN-LIKE', 243445),
(339736, 'PTHR47052:SF11', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 243445),
(339737, 'PTHR47052:SF8', NULL, NULL, NULL, NULL, 'BNAC03G77080D PROTEIN', 243445),
(339738, 'PTHR47052', NULL, NULL, NULL, NULL, 'CONSERVED SERINE PROLINE-RICH PROTEIN (AFU_ORTHOLOGUE AFUA_2G01790)', 243445),
(339739, 'PTHR47052:SF3', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 243445),
(339740, 'PTHR47052:SF4', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 243445),
(339741, 'PTHR34128', NULL, NULL, NULL, NULL, 'CYTOCHROME C-TYPE BIOGENESIS PROTEIN CCME HOMOLOG, MITOCHONDRIAL', 243446);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(339742, 'PTHR34128:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME C-TYPE BIOGENESIS PROTEIN CCME HOMOLOG, MITOCHONDRIAL', 243446),
(339743, 'PTHR14113:SF1', NULL, NULL, NULL, NULL, 'PROTEIN BASSOON', 243447),
(339744, 'PTHR14113:SF13', NULL, NULL, NULL, NULL, '', 243447),
(339745, 'PTHR14113', NULL, NULL, NULL, NULL, 'PICCOLO/BASSOON', 243447),
(339746, 'PTHR14113:SF11', NULL, NULL, NULL, NULL, 'PICCOLO PRESYNAPTIC CYTOMATRIX PROTEIN A', 243447),
(339747, 'PTHR14113:SF6', NULL, NULL, NULL, NULL, 'PROTEIN PICCOLO', 243447),
(339748, 'PTHR10681:SF170', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 243448),
(339749, 'PTHR10681:SF161', NULL, NULL, NULL, NULL, 'PEROXIREDOXIN-2', 243448),
(339750, 'PTHR10681:SF172', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 243448),
(339751, 'PTHR10681:SF171', NULL, NULL, NULL, NULL, 'PEROXIREDOXIN-4', 243448),
(339752, 'PTHR10681:SF152', NULL, NULL, NULL, NULL, 'THIOREDOXIN-DEPENDENT PEROXIREDOXIN', 243448),
(339753, 'PTHR10681:SF163', NULL, NULL, NULL, NULL, 'AT16346P-RELATED', 243448),
(339754, 'PTHR10681:SF162', NULL, NULL, NULL, NULL, 'PEROXIREDOXIN 4', 243448),
(339755, 'PTHR10681:SF151', NULL, NULL, NULL, NULL, 'PEROXIREDOXIN-1', 243448),
(339756, 'PTHR10681:SF121', NULL, NULL, NULL, NULL, 'ALKYL HYDROPEROXIDE REDUCTASE C', 243448),
(339757, 'PTHR10681:SF153', NULL, NULL, NULL, NULL, 'THIOREDOXIN-DEPENDENT PEROXIREDOXIN', 243448),
(339758, 'PTHR10681:SF164', NULL, NULL, NULL, NULL, 'THIOREDOXIN PEROXIDASE 1', 243448),
(339759, 'PTHR10681:SF156', NULL, NULL, NULL, NULL, 'THIOREDOXIN-DEPENDENT PEROXIREDOXIN', 243448),
(339760, 'PTHR10681:SF167', NULL, NULL, NULL, NULL, 'TRYPAREDOXIN PEROXIDASE', 243448),
(339761, 'PTHR10681:SF111', NULL, NULL, NULL, NULL, 'PEROXIREDOXIN-1', 243448),
(339762, 'PTHR10681:SF166', NULL, NULL, NULL, NULL, 'PEROXIREDOXIN-4', 243448),
(339763, 'PTHR10681:SF169', NULL, NULL, NULL, NULL, '2-CYS PEROXIREDOXIN BAS1-LIKE, CHLOROPLASTIC', 243448),
(339764, 'PTHR10681:SF168', NULL, NULL, NULL, NULL, '2-CYS PEROXIREDOXIN BAS1, CHLOROPLASTIC', 243448),
(339765, 'PTHR10681:SF149', NULL, NULL, NULL, NULL, 'THIOREDOXIN-DEPENDENT PEROXIREDOXIN', 243448),
(339766, 'PTHR10681:SF128', NULL, NULL, NULL, NULL, 'THIOREDOXIN-DEPENDENT PEROXIDE REDUCTASE, MITOCHONDRIAL', 243448),
(339767, 'PTHR10681', NULL, NULL, NULL, NULL, 'THIOREDOXIN PEROXIDASE', 243448),
(339768, 'PTHR42942', NULL, NULL, NULL, NULL, '6-O-METHYLGUANINE DNA METHYLTRANSFERASE', 243449),
(339769, 'PTHR42942:SF1', NULL, NULL, NULL, NULL, 'ALKYLTRANSFERASE-LIKE PROTEIN 1', 243449),
(339770, 'PTHR30414', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243450),
(339771, 'PTHR30414:SF0', NULL, NULL, NULL, NULL, 'MINICONDUCTANCE MECHANOSENSITIVE CHANNEL YBDG', 243450),
(339772, 'PTHR31849', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH PDF MOTIF DOMAIN-CONTAINING PROTEIN 1', 243451),
(339773, 'PTHR31849:SF1', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH DPF MOTIF DOMAIN-CONTAINING PROTEIN 1', 243451),
(339774, 'PTHR12947', NULL, NULL, NULL, NULL, 'AMSH-LIKE PROTEASE', 243452),
(339775, 'PTHR12947:SF19', NULL, NULL, NULL, NULL, 'AMSH-LIKE UBIQUITIN THIOESTERASE 1', 243452),
(339776, 'PTHR12947:SF8', NULL, NULL, NULL, NULL, 'STAM-BINDING PROTEIN', 243452),
(339777, 'PTHR12947:SF13', NULL, NULL, NULL, NULL, 'FI19924P1', 243452),
(339778, 'PTHR12947:SF14', NULL, NULL, NULL, NULL, 'AMSH-LIKE UBIQUITIN THIOESTERASE', 243452),
(339779, 'PTHR12947:SF11', NULL, NULL, NULL, NULL, 'OS01G0338200 PROTEIN', 243452),
(339780, 'PTHR12947:SF17', NULL, NULL, NULL, NULL, 'AMSH-LIKE UBIQUITIN THIOESTERASE 3', 243452),
(339781, 'PTHR12947:SF18', NULL, NULL, NULL, NULL, 'AMSH-LIKE UBIQUITIN THIOESTERASE 3', 243452),
(339782, 'PTHR12947:SF7', NULL, NULL, NULL, NULL, 'AMSH-LIKE PROTEASE', 243452),
(339783, 'PTHR12947:SF15', NULL, NULL, NULL, NULL, 'MPN DOMAIN-CONTAINING PROTEIN', 243452),
(339784, 'PTHR12947:SF16', NULL, NULL, NULL, NULL, 'BNAA01G17680D PROTEIN', 243452),
(339785, 'PTHR15025:SF1', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL GAMMA-1 SUBUNIT', 243453),
(339786, 'PTHR15025:SF6', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL GAMMA-6 SUBUNIT', 243453);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(339787, 'PTHR15025:SF7', NULL, NULL, NULL, NULL, 'CALCIUM CHANNEL, VOLTAGE-DEPENDENT, GAMMA SUBUNIT 6A', 243453),
(339788, 'PTHR15025:SF8', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL GAMMA-1 SUBUNIT', 243453),
(339789, 'PTHR15025', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL GAMMA-1 SUBUNIT-RELATED', 243453),
(339790, 'PTHR48156:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 243454),
(339791, 'PTHR48156', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 243454),
(339792, 'PTHR33293', NULL, NULL, NULL, NULL, 'INSERTION ELEMENT IS1 1 PROTEIN INSB-RELATED', 243455),
(339793, 'PTHR33293:SF1', NULL, NULL, NULL, NULL, 'INSERTION ELEMENT IS1 1 PROTEIN INSB-RELATED', 243455),
(339794, 'PTHR33293:SF2', NULL, NULL, NULL, NULL, '', 243455),
(339795, 'PTHR46305', NULL, NULL, NULL, NULL, '', 243456),
(339796, 'PTHR46305:SF3', NULL, NULL, NULL, NULL, 'NADPH:QUINONE OXIDOREDUCTASE MDAB', 243456),
(339797, 'PTHR31442:SF37', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 243457),
(339798, 'PTHR31442:SF25', NULL, NULL, NULL, NULL, '', 243457),
(339799, 'PTHR31442:SF35', NULL, NULL, NULL, NULL, 'TYPE-B RESPONSE REGULATOR', 243457),
(339800, 'PTHR31442:SF24', NULL, NULL, NULL, NULL, 'SANT DOMAIN-CONTAINING PROTEIN', 243457),
(339801, 'PTHR31442:SF23', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PCL1-LIKE', 243457),
(339802, 'PTHR31442:SF19', NULL, NULL, NULL, NULL, 'OS01G0844900 PROTEIN', 243457),
(339803, 'PTHR31442:SF29', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN', 243457),
(339804, 'PTHR31442:SF28', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ARR12-LIKE', 243457),
(339805, 'PTHR31442:SF17', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ORR26', 243457),
(339806, 'PTHR31442:SF39', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN', 243457),
(339807, 'PTHR31442:SF27', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PCL1-LIKE', 243457),
(339808, 'PTHR31442:SF38', NULL, NULL, NULL, NULL, 'APRR6 (PSEUDO-RESPONSE REGULATOR 6)', 243457),
(339809, 'PTHR31442:SF32', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ORR21-LIKE', 243457),
(339810, 'PTHR31442:SF21', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BOA-RELATED', 243457),
(339811, 'PTHR31442:SF31', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 243457),
(339812, 'PTHR31442:SF30', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYBC1', 243457),
(339813, 'PTHR31442', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN-RELATED', 243457),
(339814, 'PTHR34276', NULL, NULL, NULL, NULL, 'MINI-RIBONUCLEASE 3', 243458),
(339815, 'PTHR34276:SF1', NULL, NULL, NULL, NULL, 'MINI-RIBONUCLEASE 3', 243458),
(339816, 'PTHR34276:SF2', NULL, NULL, NULL, NULL, 'RNASE III DOMAIN-CONTAINING PROTEIN', 243458),
(339817, 'PTHR41291', NULL, NULL, NULL, NULL, '', 243459),
(339818, 'PTHR41291:SF1', NULL, NULL, NULL, NULL, '', 243459),
(339819, 'PTHR34400:SF4', NULL, NULL, NULL, NULL, 'FERRITIN-LIKE DOMAIN-CONTAINING PROTEIN', 243460),
(339820, 'PTHR34400', NULL, NULL, NULL, NULL, '', 243460),
(339821, 'PTHR10746', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L4', 243461),
(339822, 'PTHR10746:SF6', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L4, MITOCHONDRIAL', 243461),
(339823, 'PTHR10746:SF16', NULL, NULL, NULL, NULL, '', 243461),
(339824, 'PTHR10746:SF17', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L4, CHLOROPLASTIC', 243461),
(339825, 'PTHR47780:SF1', NULL, NULL, NULL, NULL, 'PROTEIN SET DOMAIN GROUP 41', 243462),
(339826, 'PTHR47780', NULL, NULL, NULL, NULL, 'PROTEIN SET DOMAIN GROUP 41', 243462),
(339827, 'PTHR45746:SF3', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING 11', 243463),
(339828, 'PTHR45746:SF5', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING 7-LIKE PROTEIN', 243463),
(339829, 'PTHR45746', NULL, NULL, NULL, NULL, 'LP21163P', 243463),
(339830, 'PTHR45746:SF6', NULL, NULL, NULL, NULL, 'LP21163P', 243463),
(339831, 'PTHR45746:SF7', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING 7', 243463); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(339832, 'PTHR45746:SF8', NULL, NULL, NULL, NULL, 'REGULATOR OF G PROTEIN-SIGNALING 9A', 243463),
(339833, 'PTHR45746:SF1', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING 9', 243463),
(339834, 'PTHR45746:SF2', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING 6', 243463),
(339835, 'PTHR30096:SF16', NULL, NULL, NULL, NULL, 'LIGB DOMAIN-CONTAINING PROTEIN', 243464),
(339836, 'PTHR30096:SF17', NULL, NULL, NULL, NULL, 'LIGB DOMAIN-CONTAINING PROTEIN', 243464),
(339837, 'PTHR30096:SF1', NULL, NULL, NULL, NULL, 'AROMATIC RING-OPENING DIOXYGENASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_7G00640)', 243464),
(339838, 'PTHR30096:SF0', NULL, NULL, NULL, NULL, '4,5-DOPA DIOXYGENASE EXTRADIOL-LIKE PROTEIN', 243464),
(339839, 'PTHR30096:SF19', NULL, NULL, NULL, NULL, 'LIGB DOMAIN-CONTAINING PROTEIN', 243464),
(339840, 'PTHR30096:SF14', NULL, NULL, NULL, NULL, 'AROMATIC RING-OPENING DIOXYGENASE, CATALYTIC PROTEIN', 243464),
(339841, 'PTHR30096', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243464),
(339842, 'PTHR30096:SF9', NULL, NULL, NULL, NULL, '4-HYDROXYPHENYLACETATE CATABOLISM PROTEIN', 243464),
(339843, 'PTHR30096:SF20', NULL, NULL, NULL, NULL, 'LIGB DOMAIN-CONTAINING PROTEIN', 243464),
(339844, 'PTHR30096:SF21', NULL, NULL, NULL, NULL, 'LIGB DOMAIN-CONTAINING PROTEIN', 243464),
(339845, 'PTHR30096:SF11', NULL, NULL, NULL, NULL, 'LIGB DOMAIN-CONTAINING PROTEIN', 243464),
(339846, 'PTHR42794', NULL, NULL, NULL, NULL, 'HEMIN IMPORT ATP-BINDING PROTEIN HMUV', 243465),
(339847, 'PTHR42794:SF2', NULL, NULL, NULL, NULL, 'TRANSPORT ATP-BINDING PROTEIN-RELATED', 243465),
(339848, 'PTHR42794:SF1', NULL, NULL, NULL, NULL, 'HEMIN IMPORT ATP-BINDING PROTEIN HMUV', 243465),
(339849, 'PTHR24149:SF16', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 12', 243466),
(339850, 'PTHR24149:SF15', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 11', 243466),
(339851, 'PTHR24149:SF14', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN 12', 243466),
(339852, 'PTHR24149', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 12', 243466),
(339853, 'PTHR46476:SF17', NULL, NULL, NULL, NULL, 'CHITINASE 2-LIKE', 243467),
(339854, 'PTHR46476:SF18', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_18 DOMAIN-CONTAINING PROTEIN', 243467),
(339855, 'PTHR46476:SF9', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_18 DOMAIN-CONTAINING PROTEIN', 243467),
(339856, 'PTHR46476:SF19', NULL, NULL, NULL, NULL, '2S GLOBULIN, GLYCOSIDE HYDROLASE, CHITINASE ACTIVE SITE PROTEIN-RELATED', 243467),
(339857, 'PTHR46476:SF8', NULL, NULL, NULL, NULL, 'CHITINASE 2-LIKE', 243467),
(339858, 'PTHR46476:SF3', NULL, NULL, NULL, NULL, 'CHITINASE 2-LIKE', 243467),
(339859, 'PTHR46476', NULL, NULL, NULL, NULL, 'CHITINASE 2-LIKE', 243467),
(339860, 'PTHR46476:SF20', NULL, NULL, NULL, NULL, 'CHITIN-BINDING TYPE-1 DOMAIN-CONTAINING PROTEIN', 243467),
(339861, 'PTHR46476:SF10', NULL, NULL, NULL, NULL, 'CHITINASE 2', 243467),
(339862, 'PTHR46476:SF21', NULL, NULL, NULL, NULL, 'CHITINASE 1', 243467),
(339863, 'PTHR46476:SF11', NULL, NULL, NULL, NULL, 'CHITINASE 1', 243467),
(339864, 'PTHR46476:SF12', NULL, NULL, NULL, NULL, 'RUBISCO-ASSOCIATED PROTEIN', 243467),
(339865, 'PTHR46476:SF13', NULL, NULL, NULL, NULL, '2, PUTATIVE, EXPRESSED-RELATED', 243467),
(339866, 'PTHR46476:SF14', NULL, NULL, NULL, NULL, 'CHITINASE 2-LIKE', 243467),
(339867, 'PTHR46476:SF15', NULL, NULL, NULL, NULL, '1, PUTATIVE, EXPRESSED-RELATED', 243467),
(339868, 'PTHR10534:SF15', NULL, NULL, NULL, NULL, 'PYRIDOXINE/PYRIDOXAL/PYRIDOXAMINE KINASE', 243468),
(339869, 'PTHR10534:SF16', NULL, NULL, NULL, NULL, 'PYRIDOXAL KINASE C6F6.11C-RELATED', 243468),
(339870, 'PTHR10534', NULL, NULL, NULL, NULL, 'PYRIDOXAL KINASE', 243468),
(339871, 'PTHR10534:SF12', NULL, NULL, NULL, NULL, 'PYRIDOXAL KINASE BUD17-RELATED', 243468),
(339872, 'PTHR10534:SF2', NULL, NULL, NULL, NULL, 'PYRIDOXAL KINASE', 243468),
(339873, 'PTHR21112:SF12', NULL, NULL, NULL, NULL, 'CHEMOSENSORY PROTEIN A 7A-RELATED', 243469),
(339874, 'PTHR21112:SF10', NULL, NULL, NULL, NULL, 'CHEMOSENSORY PROTEIN A 87A', 243469);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(339875, 'PTHR21112', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243469),
(339876, 'PTHR21112:SF0', NULL, NULL, NULL, NULL, 'CHEMOSENSORY PROTEIN A 29A-RELATED', 243469),
(339877, 'PTHR15691', NULL, NULL, NULL, NULL, 'WASH COMPLEX SUBUNIT 5', 243470),
(339878, 'PTHR15691:SF6', NULL, NULL, NULL, NULL, 'WASH COMPLEX SUBUNIT 5', 243470),
(339879, 'PTHR43014:SF1', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE)', 243471),
(339880, 'PTHR43014:SF2', NULL, NULL, NULL, NULL, 'MERCURIC REDUCTASE', 243471),
(339881, 'PTHR43014:SF4', NULL, NULL, NULL, NULL, 'PYRIDINE NUCLEOTIDE-DISULFIDE OXIDOREDUCTASE RCLA-RELATED', 243471),
(339882, 'PTHR43014', NULL, NULL, NULL, NULL, 'MERCURIC REDUCTASE', 243471),
(339883, 'PTHR42898:SF70', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', 243472),
(339884, 'PTHR42898:SF30', NULL, NULL, NULL, NULL, '', 243472),
(339885, 'PTHR42898:SF74', NULL, NULL, NULL, NULL, 'OS03G0268900 PROTEIN', 243472),
(339886, 'PTHR42898:SF71', NULL, NULL, NULL, NULL, 'BNAC09G51630D PROTEIN', 243472),
(339887, 'PTHR42898:SF72', NULL, NULL, NULL, NULL, 'TROPINONE REDUCTASE 1', 243472),
(339888, 'PTHR42898:SF28', NULL, NULL, NULL, NULL, 'OS11G0652900 PROTEIN', 243472),
(339889, 'PTHR42898:SF29', NULL, NULL, NULL, NULL, 'BNAA05G12670D PROTEIN', 243472),
(339890, 'PTHR42898:SF66', NULL, NULL, NULL, NULL, 'BNAC04G14050D PROTEIN', 243472),
(339891, 'PTHR42898:SF67', NULL, NULL, NULL, NULL, 'SHORT CHAIN ALCOHOL DEHYDROGENASE', 243472),
(339892, 'PTHR42898:SF20', NULL, NULL, NULL, NULL, 'BNAC04G56400D PROTEIN', 243472),
(339893, 'PTHR42898:SF65', NULL, NULL, NULL, NULL, 'BNAA05G12660D PROTEIN', 243472),
(339894, 'PTHR42898:SF21', NULL, NULL, NULL, NULL, '', 243472),
(339895, 'PTHR42898:SF27', NULL, NULL, NULL, NULL, 'TROPINONE REDUCTASE HOMOLOG', 243472),
(339896, 'PTHR42898:SF25', NULL, NULL, NULL, NULL, 'TROPINONE REDUCTASE-LIKE PROTEIN', 243472),
(339897, 'PTHR42898:SF62', NULL, NULL, NULL, NULL, 'BNAA04G17090D PROTEIN', 243472),
(339898, 'PTHR42898:SF63', NULL, NULL, NULL, NULL, 'BNAANNG26060D PROTEIN', 243472),
(339899, 'PTHR42898:SF60', NULL, NULL, NULL, NULL, 'BNAC04G14070D PROTEIN', 243472),
(339900, 'PTHR42898:SF61', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', 243472),
(339901, 'PTHR42898', NULL, NULL, NULL, NULL, 'TROPINONE REDUCTASE', 243472),
(339902, 'PTHR42898:SF18', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', 243472),
(339903, 'PTHR42898:SF55', NULL, NULL, NULL, NULL, 'TROPINONE REDUCTASE II', 243472),
(339904, 'PTHR42898:SF12', NULL, NULL, NULL, NULL, 'RETROVIRUS-RELATED POL POLYPROTEIN LINE-1', 243472),
(339905, 'PTHR42898:SF56', NULL, NULL, NULL, NULL, 'BNAA04G17100D PROTEIN', 243472),
(339906, 'PTHR42898:SF53', NULL, NULL, NULL, NULL, 'BNAA05G29590D PROTEIN', 243472),
(339907, 'PTHR42898:SF54', NULL, NULL, NULL, NULL, 'BNAC04G14030D PROTEIN', 243472),
(339908, 'PTHR42898:SF59', NULL, NULL, NULL, NULL, 'BNAC04G14160D PROTEIN', 243472),
(339909, 'PTHR42898:SF57', NULL, NULL, NULL, NULL, '', 243472),
(339910, 'PTHR42898:SF58', NULL, NULL, NULL, NULL, 'BNAC04G14130D PROTEIN', 243472),
(339911, 'PTHR42898:SF91', NULL, NULL, NULL, NULL, 'TROPINONE REDUCTASE 1-LIKE', 243472),
(339912, 'PTHR42898:SF90', NULL, NULL, NULL, NULL, '', 243472),
(339913, 'PTHR42898:SF52', NULL, NULL, NULL, NULL, 'BNAA04G17040D PROTEIN', 243472),
(339914, 'PTHR42898:SF88', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 243472),
(339915, 'PTHR42898:SF2', NULL, NULL, NULL, NULL, 'ENOYL-(ACYL CARRIER) REDUCTASE', 243472),
(339916, 'PTHR42898:SF89', NULL, NULL, NULL, NULL, 'TROPINONE REDUCTASE-LIKE PROTEIN', 243472),
(339917, 'PTHR42898:SF45', NULL, NULL, NULL, NULL, 'TROPINONE REDUCTASE-LIKE PROTEIN', 243472),
(339918, 'PTHR42898:SF86', NULL, NULL, NULL, NULL, 'BNAA05G12690D PROTEIN', 243472),
(339919, 'PTHR42898:SF87', NULL, NULL, NULL, NULL, '', 243472),
(339920, 'PTHR42898:SF5', NULL, NULL, NULL, NULL, 'OS01G0930900 PROTEIN', 243472),
(339921, 'PTHR42898:SF43', NULL, NULL, NULL, NULL, 'BNAC04G40340D PROTEIN', 243472);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(339922, 'PTHR42898:SF6', NULL, NULL, NULL, NULL, 'OS03G0269100 PROTEIN', 243472),
(339923, 'PTHR42898:SF46', NULL, NULL, NULL, NULL, '', 243472),
(339924, 'PTHR42898:SF80', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', 243472),
(339925, 'PTHR42898:SF84', NULL, NULL, NULL, NULL, 'SENESCENCE-ASSOCIATED PROTEIN 13', 243472),
(339926, 'PTHR42898:SF40', NULL, NULL, NULL, NULL, '', 243472),
(339927, 'PTHR42898:SF85', NULL, NULL, NULL, NULL, 'TROPINONE REDUCTASE 1-LIKE ISOFORM X1', 243472),
(339928, 'PTHR42898:SF82', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', 243472),
(339929, 'PTHR42898:SF83', NULL, NULL, NULL, NULL, 'TROPINONE REDUCTASE 2', 243472),
(339930, 'PTHR42898:SF39', NULL, NULL, NULL, NULL, '', 243472),
(339931, 'PTHR42898:SF77', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD PROTEIN', 243472),
(339932, 'PTHR42898:SF76', NULL, NULL, NULL, NULL, 'ROSSMANN-FOLD SUPERFAMILY PROTEIN, PUTATIVE ISOFORM 2-RELATED', 243472),
(339933, 'PTHR42898:SF32', NULL, NULL, NULL, NULL, 'BNAA04G17080D PROTEIN', 243472),
(339934, 'PTHR42898:SF38', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD PROTEIN', 243472),
(339935, 'PTHR42898:SF79', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', 243472),
(339936, 'PTHR13869:SF24', NULL, NULL, NULL, NULL, 'SUSHI DOMAIN-CONTAINING PROTEIN', 243473),
(339937, 'PTHR13869:SF14', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL SUBUNIT BETA-4', 243473),
(339938, 'PTHR13869:SF38', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 243473),
(339939, 'PTHR13869:SF20', NULL, NULL, NULL, NULL, 'MYELIN PROTEIN ZERO-LIKE PROTEIN 3', 243473),
(339940, 'PTHR13869:SF21', NULL, NULL, NULL, NULL, 'MYELIN PROTEIN ZERO-LIKE PROTEIN 2', 243473),
(339941, 'PTHR13869:SF22', NULL, NULL, NULL, NULL, 'JUNCTIONAL ADHESION MOLECULE-LIKE', 243473),
(339942, 'PTHR13869', NULL, NULL, NULL, NULL, 'MYELIN P0 RELATED', 243473),
(339943, 'PTHR13869:SF3', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL SUBUNIT BETA-2', 243473),
(339944, 'PTHR13869:SF40', NULL, NULL, NULL, NULL, 'SCN4BA PROTEIN-RELATED', 243473),
(339945, 'PTHR13869:SF41', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL SUBUNIT BETA-2', 243473),
(339946, 'PTHR13869:SF7', NULL, NULL, NULL, NULL, 'MYELIN PROTEIN P0', 243473),
(339947, 'PTHR13869:SF19', NULL, NULL, NULL, NULL, 'MYELIN PROTEIN ZERO-LIKE PROTEIN 1', 243473),
(339948, 'PTHR33692:SF1', NULL, NULL, NULL, NULL, 'RIBOSOME MATURATION FACTOR RIMM', 243474),
(339949, 'PTHR33692', NULL, NULL, NULL, NULL, 'RIBOSOME MATURATION FACTOR RIMM', 243474),
(339950, 'PTHR46674:SF1', NULL, NULL, NULL, NULL, 'INACTIVE PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP6', 243475),
(339951, 'PTHR46674', NULL, NULL, NULL, NULL, 'INACTIVE PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP6', 243475),
(339952, 'PTHR46768', NULL, NULL, NULL, NULL, 'TWO PORE CALCIUM CHANNEL PROTEIN 2', 243476),
(339953, 'PTHR46768:SF1', NULL, NULL, NULL, NULL, 'TWO PORE CALCIUM CHANNEL PROTEIN 2', 243476),
(339954, 'PTHR37954', NULL, NULL, NULL, NULL, 'BLL4979 PROTEIN', 243477),
(339955, 'PTHR37954:SF3', NULL, NULL, NULL, NULL, 'BLL4979 PROTEIN', 243477),
(339956, 'PTHR34471:SF1', NULL, NULL, NULL, NULL, 'ARGININE REPRESSOR', 243478),
(339957, 'PTHR34471', NULL, NULL, NULL, NULL, 'ARGININE REPRESSOR', 243478),
(339958, 'PTHR10981:SF8', NULL, NULL, NULL, NULL, 'BATTENIN', 243479),
(339959, 'PTHR10981:SF7', NULL, NULL, NULL, NULL, 'BATTENIN', 243479),
(339960, 'PTHR10981', NULL, NULL, NULL, NULL, 'BATTENIN', 243479),
(339961, 'PTHR10981:SF3', NULL, NULL, NULL, NULL, 'RNAI-INDUCED LONGEVITY', 243479),
(339962, 'PTHR10981:SF1', NULL, NULL, NULL, NULL, 'BATTENIN', 243479),
(339963, 'PTHR10981:SF0', NULL, NULL, NULL, NULL, 'BATTENIN', 243479),
(339964, 'PTHR41517', NULL, NULL, NULL, NULL, '1,2-DIOXYGENASE PROTEIN-RELATED', 243480),
(339965, 'PTHR41517:SF1', NULL, NULL, NULL, NULL, '1,2-DIOXYGENASE PROTEIN-RELATED', 243480),
(339966, 'PTHR17614:SF11', NULL, NULL, NULL, NULL, 'G PATCH DOMAIN-CONTAINING PROTEIN 8', 243481),
(339967, 'PTHR17614:SF12', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 804B', 243481);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(339968, 'PTHR17614:SF13', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 804A', 243481),
(339969, 'PTHR17614', NULL, NULL, NULL, NULL, 'ZINC FINGER-CONTAINING', 243481),
(339970, 'PTHR37733:SF1', NULL, NULL, NULL, NULL, 'SMAD/FHA DOMAIN-CONTAINING PROTEIN', 243482),
(339971, 'PTHR37733', NULL, NULL, NULL, NULL, 'SMAD/FHA DOMAIN-CONTAINING PROTEIN', 243482),
(339972, 'PTHR45705', NULL, NULL, NULL, NULL, 'FI20236P1', 243483),
(339973, 'PTHR45705:SF9', NULL, NULL, NULL, NULL, 'PROTEIN GTS1', 243483),
(339974, 'PTHR45705:SF8', NULL, NULL, NULL, NULL, 'STROMAL MEMBRANE-ASSOCIATED PROTEIN 1', 243483),
(339975, 'PTHR45705:SF7', NULL, NULL, NULL, NULL, 'ACTIVATING PROTEIN FOR ARF, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G09120)-RELATED', 243483),
(339976, 'PTHR45705:SF4', NULL, NULL, NULL, NULL, 'STROMAL MEMBRANE-ASSOCIATED PROTEIN 2', 243483),
(339977, 'PTHR45705:SF13', NULL, NULL, NULL, NULL, 'ARF-GAP DOMAIN-CONTAINING PROTEIN', 243483),
(339978, 'PTHR45705:SF12', NULL, NULL, NULL, NULL, 'UBA DOMAIN-CONTAINING PROTEIN 3', 243483),
(339979, 'PTHR45705:SF1', NULL, NULL, NULL, NULL, 'FI20236P1', 243483),
(339980, 'PTHR45705:SF11', NULL, NULL, NULL, NULL, '', 243483),
(339981, 'PTHR43540:SF6', NULL, NULL, NULL, NULL, 'ISOCHORISMATASE DOMAIN-CONTAINING PROTEIN', 243484),
(339982, 'PTHR43540:SF7', NULL, NULL, NULL, NULL, 'ISOCHORISMATASE FAMILY PROTEIN YECD', 243484),
(339983, 'PTHR43540:SF1', NULL, NULL, NULL, NULL, 'ISOCHORISMATASE HYDROLASE', 243484),
(339984, 'PTHR43540:SF3', NULL, NULL, NULL, NULL, 'ENTEROBACTIN SYNTHASE COMPONENT B', 243484),
(339985, 'PTHR43540:SF15', NULL, NULL, NULL, NULL, 'BLR5631 PROTEIN', 243484),
(339986, 'PTHR43540:SF14', NULL, NULL, NULL, NULL, 'ISOCHORISMATASE-RELATED', 243484),
(339987, 'PTHR43540:SF16', NULL, NULL, NULL, NULL, 'ISOCHORISMATASE DOMAIN-CONTAINING PROTEIN', 243484),
(339988, 'PTHR43540', NULL, NULL, NULL, NULL, 'PEROXYUREIDOACRYLATE/UREIDOACRYLATE AMIDOHYDROLASE-RELATED', 243484),
(339989, 'PTHR43540:SF10', NULL, NULL, NULL, NULL, 'ISOCHORISMATASE', 243484),
(339990, 'PTHR43540:SF9', NULL, NULL, NULL, NULL, 'FAMILY HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G08700)-RELATED', 243484),
(339991, 'PTHR31454:SF2', NULL, NULL, NULL, NULL, 'ACTIVE REGULATOR OF SIRT1', 243485),
(339992, 'PTHR31454', NULL, NULL, NULL, NULL, 'ACTIVE REGULATOR OF SIRT1', 243485),
(339993, 'PTHR47592:SF6', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 243486),
(339994, 'PTHR47592:SF21', NULL, NULL, NULL, NULL, 'FBA_1 DOMAIN-CONTAINING PROTEIN', 243486),
(339995, 'PTHR47592', NULL, NULL, NULL, NULL, 'PBF68 PROTEIN', 243486),
(339996, 'PTHR47592:SF18', NULL, NULL, NULL, NULL, 'ZINC FINGER, CCHC-TYPE-RELATED', 243486),
(339997, 'PTHR47592:SF28', NULL, NULL, NULL, NULL, '', 243486),
(339998, 'PTHR47592:SF27', NULL, NULL, NULL, NULL, 'GAG-POL POLYPROTEIN', 243486),
(339999, 'PTHR47592:SF16', NULL, NULL, NULL, NULL, 'ZINC FINGER, CCHC-TYPE-RELATED', 243486),
(340000, 'PTHR47592:SF26', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 243486),
(340001, 'PTHR47592:SF25', NULL, NULL, NULL, NULL, 'OS08G0421300 PROTEIN', 243486),
(340002, 'PTHR47592:SF24', NULL, NULL, NULL, NULL, 'GAG-POL POLYPROTEIN-LIKE PROTEIN', 243486),
(340003, 'PTHR47592:SF23', NULL, NULL, NULL, NULL, 'BNACNNG30200D PROTEIN', 243486),
(340004, 'PTHR47592:SF22', NULL, NULL, NULL, NULL, '', 243486),
(340005, 'PTHR47592:SF11', NULL, NULL, NULL, NULL, 'OS08G0421700 PROTEIN', 243486),
(340006, 'PTHR16049', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN C', 243487),
(340007, 'PTHR16049:SF8', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN C', 243487),
(340008, 'PTHR11207:SF26', NULL, NULL, NULL, NULL, 'DOUBLE-STRANDED RNA-BINDING PROTEIN 4', 243488),
(340009, 'PTHR11207:SF32', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN L3, MITOCHONDRIAL', 243488),
(340010, 'PTHR11207:SF0', NULL, NULL, NULL, NULL, 'RIBONUCLEASE 3', 243488),
(340011, 'PTHR11207:SF1', NULL, NULL, NULL, NULL, 'DOUBLE-STRANDED RNA-BINDING PROTEIN 1', 243488),
(340012, 'PTHR11207:SF34', NULL, NULL, NULL, NULL, 'RIBONUCLEASE III DOMAIN-CONTAINING PROTEIN RNC1, CHLOROPLASTIC', 243488);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(340013, 'PTHR11207:SF22', NULL, NULL, NULL, NULL, '', 243488),
(340014, 'PTHR11207', NULL, NULL, NULL, NULL, 'RIBONUCLEASE III', 243488),
(340015, 'PTHR11207:SF5', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L44, MITOCHONDRIAL', 243488),
(340016, 'PTHR11207:SF28', NULL, NULL, NULL, NULL, 'DOUBLE-STRANDED RNA-BINDING PROTEIN 4-LIKE', 243488),
(340017, 'PTHR43407:SF1', NULL, NULL, NULL, NULL, 'LENGSIN', 243489),
(340018, 'PTHR43407:SF2', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE', 243489),
(340019, 'PTHR43407', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE', 243489),
(340020, 'PTHR23168:SF0', NULL, NULL, NULL, NULL, 'MITOTIC SPINDLE ASSEMBLY CHECKPOINT PROTEIN MAD1', 243490),
(340021, 'PTHR23168', NULL, NULL, NULL, NULL, 'MITOTIC SPINDLE ASSEMBLY CHECKPOINT PROTEIN MAD1  MITOTIC ARREST DEFICIENT-LIKE PROTEIN 1', 243490),
(340022, 'PTHR23279:SF37', NULL, NULL, NULL, NULL, 'DEFECTIVE PROBOSCIS EXTENSION RESPONSE 13, ISOFORM B', 243491),
(340023, 'PTHR23279:SF44', NULL, NULL, NULL, NULL, 'DEFECTIVE PROBOSCIS EXTENSION RESPONSE 12, ISOFORM C', 243491),
(340024, 'PTHR23279:SF12', NULL, NULL, NULL, NULL, 'DEFECTIVE PROBOSCIS EXTENSION RESPONSE 14, ISOFORM A-RELATED', 243491),
(340025, 'PTHR23279:SF13', NULL, NULL, NULL, NULL, 'DEFECTIVE PROBOSCIS EXTENSION RESPONSE 21', 243491),
(340026, 'PTHR23279:SF36', NULL, NULL, NULL, NULL, 'DEFECTIVE PROBOSCIS EXTENSION RESPONSE 9, ISOFORM A', 243491),
(340027, 'PTHR23279:SF41', NULL, NULL, NULL, NULL, 'DEFECTIVE PROBOSCIS EXTENSION RESPONSE 4-RELATED', 243491),
(340028, 'PTHR23279:SF43', NULL, NULL, NULL, NULL, 'DEFECTIVE PROBOSCIS EXTENSION RESPONSE 10, ISOFORM A-RELATED', 243491),
(340029, 'PTHR23279:SF21', NULL, NULL, NULL, NULL, 'DEFECTIVE PROBOSCIS EXTENSION RESPONSE 11, ISOFORM B-RELATED', 243491),
(340030, 'PTHR23279', NULL, NULL, NULL, NULL, 'DEFECTIVE PROBOSCIS EXTENSION RESPONSE  DPR -RELATED', 243491),
(340031, 'PTHR23279:SF7', NULL, NULL, NULL, NULL, 'DEFECTIVE PROBOSCIS EXTENSION RESPONSE 1, ISOFORM A', 243491),
(340032, 'PTHR23279:SF6', NULL, NULL, NULL, NULL, 'DEFECTIVE PROBOSCIS EXTENSION RESPONSE 7, ISOFORM F', 243491),
(340033, 'PTHR23279:SF5', NULL, NULL, NULL, NULL, 'DEFECTIVE PROBOSCIS EXTENSION RESPONSE 8, ISOFORM A', 243491),
(340034, 'PTHR23279:SF4', NULL, NULL, NULL, NULL, 'DEFECTIVE PROBOSCIS EXTENSION RESPONSE 2, ISOFORM F-RELATED', 243491),
(340035, 'PTHR23279:SF3', NULL, NULL, NULL, NULL, 'DEFECTIVE PROBOSCIS EXTENSION RESPONSE 18', 243491),
(340036, 'PTHR23279:SF2', NULL, NULL, NULL, NULL, 'DEFECTIVE PROBOSCIS EXTENSION RESPONSE 19, ISOFORM A', 243491),
(340037, 'PTHR31520:SF1', NULL, NULL, NULL, NULL, 'VEXIN', 243492),
(340038, 'PTHR31520', NULL, NULL, NULL, NULL, 'VEXIN', 243492),
(340039, 'PTHR38099', NULL, NULL, NULL, NULL, 'LARGE RIBOSOMAL RNA SUBUNIT ACCUMULATION PROTEIN YCED', 243493),
(340040, 'PTHR38099:SF1', NULL, NULL, NULL, NULL, 'LARGE RIBOSOMAL RNA SUBUNIT ACCUMULATION PROTEIN YCED', 243493),
(340041, 'PTHR30135:SF3', NULL, NULL, NULL, NULL, 'GLUCONEOGENESIS FACTOR-RELATED', 243494),
(340042, 'PTHR30135', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN YVCK-RELATED', 243494),
(340043, 'PTHR33480:SF3', NULL, NULL, NULL, NULL, 'SI:DKEY-117M1.4', 243495),
(340044, 'PTHR33480:SF4', NULL, NULL, NULL, NULL, '', 243495),
(340045, 'PTHR33480', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN-RELATED', 243495),
(340046, 'PTHR33480:SF1', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 243495),
(340047, 'PTHR33480:SF2', NULL, NULL, NULL, NULL, 'SI:DKEY-51D8.9', 243495),
(340048, 'PTHR32419:SF23', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE (EUROFUNG)', 243496),
(340049, 'PTHR32419:SF30', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE FAMILY PROTEIN', 243496),
(340050, 'PTHR32419', NULL, NULL, NULL, NULL, 'GLUTATHIONYL-HYDROQUINONE REDUCTASE', 243496),
(340051, 'PTHR32419:SF28', NULL, NULL, NULL, NULL, 'GST C-TERMINAL DOMAIN-CONTAINING PROTEIN', 243496),
(340052, 'PTHR32419:SF6', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE OMEGA-LIKE 1-RELATED', 243496),
(340053, 'PTHR32419:SF29', NULL, NULL, NULL, NULL, 'GST C-TERMINAL DOMAIN-CONTAINING PROTEIN', 243496);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(340054, 'PTHR32419:SF26', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE FAMILY PROTEIN', 243496),
(340055, 'PTHR32419:SF24', NULL, NULL, NULL, NULL, '', 243496),
(340056, 'PTHR32419:SF25', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE (EUROFUNG)', 243496),
(340057, 'PTHR23128', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243497),
(340058, 'PTHR23128:SF140', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS E (EPSILON)', 243497),
(340059, 'PTHR23128:SF60', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS E (EPSILON)-RELATED', 243497),
(340060, 'PTHR23128:SF142', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS EPSILON-38', 243497),
(340061, 'PTHR23128:SF143', NULL, NULL, NULL, NULL, 'PROTEIN CBG02266', 243497),
(340062, 'PTHR23128:SF132', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS E (EPSILON)-RELATED', 243497),
(340063, 'PTHR23128:SF134', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS E (EPSILON)', 243497),
(340064, 'PTHR23128:SF135', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS E (EPSILON)-RELATED', 243497),
(340065, 'PTHR23128:SF136', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS EPSILON-21', 243497),
(340066, 'PTHR23128:SF35', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS E (EPSILON)', 243497),
(340067, 'PTHR23128:SF137', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS E (EPSILON)', 243497),
(340068, 'PTHR23128:SF138', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS E (EPSILON)', 243497),
(340069, 'PTHR23128:SF139', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS EPSILON-1-RELATED', 243497),
(340070, 'PTHR23128:SF64', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS E (EPSILON)', 243497),
(340071, 'PTHR47730', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 29', 243498),
(340072, 'PTHR47730:SF1', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 29', 243498),
(340073, 'PTHR31692:SF104', NULL, NULL, NULL, NULL, 'EXPANSIN-LIKE CBD DOMAIN-CONTAINING PROTEIN', 243499),
(340074, 'PTHR31692:SF79', NULL, NULL, NULL, NULL, 'EXPANSIN-LIKE CBD DOMAIN-CONTAINING PROTEIN', 243499),
(340075, 'PTHR31692:SF103', NULL, NULL, NULL, NULL, 'EXPANSIN-LIKE A3-RELATED', 243499),
(340076, 'PTHR31692:SF101', NULL, NULL, NULL, NULL, 'EXPANSIN-LIKE B1', 243499),
(340077, 'PTHR31692:SF108', NULL, NULL, NULL, NULL, 'BNAC04G03990D PROTEIN', 243499),
(340078, 'PTHR31692:SF75', NULL, NULL, NULL, NULL, 'EXPANSIN-LIKE CBD DOMAIN-CONTAINING PROTEIN', 243499),
(340079, 'PTHR31692:SF76', NULL, NULL, NULL, NULL, 'EXPANSIN-B15', 243499),
(340080, 'PTHR31692:SF106', NULL, NULL, NULL, NULL, 'EXPANSIN-B4-RELATED', 243499),
(340081, 'PTHR31692:SF77', NULL, NULL, NULL, NULL, 'EXPANSIN-B5', 243499),
(340082, 'PTHR31692:SF105', NULL, NULL, NULL, NULL, 'EXPANSIN-B11-LIKE', 243499),
(340083, 'PTHR31692:SF78', NULL, NULL, NULL, NULL, 'BETA-EXPANSIN 1A', 243499),
(340084, 'PTHR31692:SF71', NULL, NULL, NULL, NULL, 'EXPANSIN-B4', 243499),
(340085, 'PTHR31692:SF72', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 243499),
(340086, 'PTHR31692:SF73', NULL, NULL, NULL, NULL, 'EXPANSIN-B4', 243499),
(340087, 'PTHR31692:SF100', NULL, NULL, NULL, NULL, '', 243499),
(340088, 'PTHR31692:SF68', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 243499),
(340089, 'PTHR31692:SF25', NULL, NULL, NULL, NULL, 'EXPANSIN-LIKE A4', 243499),
(340090, 'PTHR31692:SF69', NULL, NULL, NULL, NULL, 'EXPANSIN-B3-LIKE', 243499),
(340091, 'PTHR31692:SF20', NULL, NULL, NULL, NULL, 'EXPANSIN-B8', 243499),
(340092, 'PTHR31692:SF21', NULL, NULL, NULL, NULL, 'EXPANSIN-B1', 243499),
(340093, 'PTHR31692:SF65', NULL, NULL, NULL, NULL, '', 243499),
(340094, 'PTHR31692:SF22', NULL, NULL, NULL, NULL, 'EXPANSIN-B5', 243499),
(340095, 'PTHR31692:SF66', NULL, NULL, NULL, NULL, 'EXPANSIN-LIKE B1', 243499),
(340096, 'PTHR31692:SF67', NULL, NULL, NULL, NULL, 'EXPANSIN-LIKE A3', 243499),
(340097, 'PTHR31692:SF23', NULL, NULL, NULL, NULL, 'EXPANSIN-B7', 243499),
(340098, 'PTHR31692:SF60', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 243499),
(340099, 'PTHR31692:SF2', NULL, NULL, NULL, NULL, 'EXPANSIN-LIKE B1', 243499);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(340100, 'PTHR31692:SF5', NULL, NULL, NULL, NULL, 'EXPANSIN-B3', 243499),
(340101, 'PTHR31692:SF62', NULL, NULL, NULL, NULL, '1A, PUTATIVE, EXPRESSED-RELATED', 243499),
(340102, 'PTHR31692:SF4', NULL, NULL, NULL, NULL, 'EXPANSIN-LIKE A1-RELATED', 243499),
(340103, 'PTHR31692:SF7', NULL, NULL, NULL, NULL, 'EXPANSIN-B9', 243499),
(340104, 'PTHR31692:SF132', NULL, NULL, NULL, NULL, 'EXPANSIN-B14-RELATED', 243499),
(340105, 'PTHR31692:SF9', NULL, NULL, NULL, NULL, 'EXPANSIN-B4', 243499),
(340106, 'PTHR31692:SF131', NULL, NULL, NULL, NULL, 'EXPANSIN-B4', 243499),
(340107, 'PTHR31692:SF130', NULL, NULL, NULL, NULL, 'EXPANSIN-LIKE EG45 DOMAIN-CONTAINING PROTEIN', 243499),
(340108, 'PTHR31692', NULL, NULL, NULL, NULL, 'EXPANSIN-B3', 243499),
(340109, 'PTHR31692:SF57', NULL, NULL, NULL, NULL, 'EXPANSIN-B2-RELATED', 243499),
(340110, 'PTHR31692:SF13', NULL, NULL, NULL, NULL, 'OS06G0662300 PROTEIN', 243499),
(340111, 'PTHR31692:SF14', NULL, NULL, NULL, NULL, 'EXPANSIN-B12', 243499),
(340112, 'PTHR31692:SF125', NULL, NULL, NULL, NULL, 'EXPANSIN-B4', 243499),
(340113, 'PTHR31692:SF58', NULL, NULL, NULL, NULL, 'EXPANSIN-LIKE B1', 243499),
(340114, 'PTHR31692:SF124', NULL, NULL, NULL, NULL, 'EXPANSIN-B14-RELATED', 243499),
(340115, 'PTHR31692:SF59', NULL, NULL, NULL, NULL, 'EXPANSIN-B1', 243499),
(340116, 'PTHR31692:SF129', NULL, NULL, NULL, NULL, 'EXPANSIN-LIKE PROTEIN B1', 243499),
(340117, 'PTHR31692:SF10', NULL, NULL, NULL, NULL, 'EXPANSIN-B1-LIKE PROTEIN', 243499),
(340118, 'PTHR31692:SF98', NULL, NULL, NULL, NULL, '', 243499),
(340119, 'PTHR31692:SF128', NULL, NULL, NULL, NULL, 'EXPANSIN-LIKE A1', 243499),
(340120, 'PTHR31692:SF99', NULL, NULL, NULL, NULL, 'POLLEN ALLERGEN ORY S 1, PUTATIVE-RELATED', 243499),
(340121, 'PTHR31692:SF55', NULL, NULL, NULL, NULL, 'BETA-EXPANSIN 1A', 243499),
(340122, 'PTHR31692:SF56', NULL, NULL, NULL, NULL, 'EXPANSIN-B2-RELATED', 243499),
(340123, 'PTHR31692:SF127', NULL, NULL, NULL, NULL, 'EXPANSIN-B5-LIKE', 243499),
(340124, 'PTHR31692:SF12', NULL, NULL, NULL, NULL, 'EXPANSIN-B6', 243499),
(340125, 'PTHR31692:SF93', NULL, NULL, NULL, NULL, 'BETA-EXPANSIN 5', 243499),
(340126, 'PTHR31692:SF50', NULL, NULL, NULL, NULL, 'EXPANSIN-B11', 243499),
(340127, 'PTHR31692:SF94', NULL, NULL, NULL, NULL, 'BETA-EXPANSIN 1A', 243499),
(340128, 'PTHR31692:SF95', NULL, NULL, NULL, NULL, 'EXPANSIN-B2-RELATED', 243499),
(340129, 'PTHR31692:SF96', NULL, NULL, NULL, NULL, 'EXPANSIN-LIKE PROTEIN B1', 243499),
(340130, 'PTHR31692:SF121', NULL, NULL, NULL, NULL, 'BNAC07G34020D PROTEIN', 243499),
(340131, 'PTHR31692:SF120', NULL, NULL, NULL, NULL, '1A, PUTATIVE, EXPRESSED-RELATED', 243499),
(340132, 'PTHR31692:SF91', NULL, NULL, NULL, NULL, 'EXPANSIN-LIKE CBD DOMAIN-CONTAINING PROTEIN', 243499),
(340133, 'PTHR31692:SF92', NULL, NULL, NULL, NULL, 'EXPANSIN-LIKE B1', 243499),
(340134, 'PTHR31692:SF17', NULL, NULL, NULL, NULL, 'EXPANSIN-B3', 243499),
(340135, 'PTHR31692:SF19', NULL, NULL, NULL, NULL, 'EXPANSIN-B2', 243499),
(340136, 'PTHR31692:SF115', NULL, NULL, NULL, NULL, '', 243499),
(340137, 'PTHR31692:SF114', NULL, NULL, NULL, NULL, 'BETA EXPANSIN4', 243499),
(340138, 'PTHR31692:SF113', NULL, NULL, NULL, NULL, 'BNACNNG23400D PROTEIN', 243499),
(340139, 'PTHR31692:SF49', NULL, NULL, NULL, NULL, 'EXPANSIN-B15-LIKE', 243499),
(340140, 'PTHR31692:SF112', NULL, NULL, NULL, NULL, 'MAJOR POLLEN ALLERGEN ORY S 1', 243499),
(340141, 'PTHR31692:SF119', NULL, NULL, NULL, NULL, 'BNAA03G58070D PROTEIN', 243499),
(340142, 'PTHR31692:SF86', NULL, NULL, NULL, NULL, 'EXPANSIN-B4', 243499),
(340143, 'PTHR31692:SF87', NULL, NULL, NULL, NULL, 'EXPANSIN-B4', 243499),
(340144, 'PTHR31692:SF118', NULL, NULL, NULL, NULL, '', 243499),
(340145, 'PTHR31692:SF117', NULL, NULL, NULL, NULL, 'BNAC04G22130D PROTEIN', 243499),
(340146, 'PTHR31692:SF116', NULL, NULL, NULL, NULL, '', 243499),
(340147, 'PTHR31692:SF89', NULL, NULL, NULL, NULL, 'BNAA02G22300D PROTEIN', 243499),
(340148, 'PTHR31692:SF82', NULL, NULL, NULL, NULL, 'EXPANSIN-B17', 243499),
(340149, 'PTHR31692:SF111', NULL, NULL, NULL, NULL, 'BNAC07G50680D PROTEIN', 243499);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(340150, 'PTHR31692:SF110', NULL, NULL, NULL, NULL, 'BETA-EXPANSIN 1A', 243499),
(340151, 'PTHR31692:SF80', NULL, NULL, NULL, NULL, 'POLLEN ALLERGEN HOMOLOG', 243499),
(340152, 'PTHR10642:SF28', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 243500),
(340153, 'PTHR10642', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H1', 243500),
(340154, 'PTHR10642:SF26', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H1', 243500),
(340155, 'PTHR10642:SF24', NULL, NULL, NULL, NULL, 'PROTEIN CBG03113', 243500),
(340156, 'PTHR10642:SF25', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 243500),
(340157, 'PTHR31829:SF8', NULL, NULL, NULL, NULL, 'SOR_SNZ DOMAIN-CONTAINING PROTEIN', 243501),
(340158, 'PTHR31829:SF9', NULL, NULL, NULL, NULL, 'SOR_SNZ DOMAIN-CONTAINING PROTEIN', 243501),
(340159, 'PTHR31829:SF6', NULL, NULL, NULL, NULL, 'SOR_SNZ DOMAIN-CONTAINING PROTEIN', 243501),
(340160, 'PTHR31829:SF4', NULL, NULL, NULL, NULL, 'PYRIDOXAL 5''-PHOSPHATE SYNTHASE SUBUNIT PDX1.1', 243501),
(340161, 'PTHR31829:SF2', NULL, NULL, NULL, NULL, 'PYRIDOXAL 5''-PHOSPHATE SYNTHASE-LIKE SUBUNIT PDX1.2', 243501),
(340162, 'PTHR31829:SF0', NULL, NULL, NULL, NULL, 'PYRIDOXAL 5''-PHOSPHATE SYNTHASE SUBUNIT SNZ1-RELATED', 243501),
(340163, 'PTHR31829', NULL, NULL, NULL, NULL, 'PYRIDOXAL 5''-PHOSPHATE SYNTHASE SUBUNIT SNZ1-RELATED', 243501),
(340164, 'PTHR31829:SF10', NULL, NULL, NULL, NULL, 'SOR_SNZ DOMAIN-CONTAINING PROTEIN', 243501),
(340165, 'PTHR12526:SF616', NULL, NULL, NULL, NULL, 'PSLH', 243502),
(340166, 'PTHR12526:SF617', NULL, NULL, NULL, NULL, 'TEICHURONIC ACID BIOSYNTHESIS GLYCOSYLTRANSFERASE TUAH-RELATED', 243502),
(340167, 'PTHR12526:SF618', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE, FAMILY 4', 243502),
(340168, 'PTHR12526:SF619', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE GROUP 1', 243502),
(340169, 'PTHR12526:SF597', NULL, NULL, NULL, NULL, 'COLANIC ACID BIOSYNTHESIS GLYCOSYLTRANSFERASE WCAL-RELATED', 243502),
(340170, 'PTHR12526:SF510', NULL, NULL, NULL, NULL, 'COLANIC ACID BIOSYNTHESIS GLYCOSYL TRANSFERASE WCAI-RELATED', 243502),
(340171, 'PTHR12526:SF599', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE 1,6-GALACTOSYLTRANSFERASE', 243502),
(340172, 'PTHR12526:SF610', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE 1,2-N-ACETYLGLUCOSAMINETRANSFERASE', 243502),
(340173, 'PTHR12526:SF611', NULL, NULL, NULL, NULL, 'BLL3647 PROTEIN', 243502),
(340174, 'PTHR12526:SF579', NULL, NULL, NULL, NULL, '', 243502),
(340175, 'PTHR12526:SF612', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE EPSD-RELATED', 243502),
(340176, 'PTHR12526:SF613', NULL, NULL, NULL, NULL, 'GDP-MANNOSE-DEPENDENT ALPHA-(1-6)-PHOSPHATIDYLINOSITOL MONOMANNOSIDE MANNOSYLTRANSFERASE', 243502),
(340177, 'PTHR12526:SF614', NULL, NULL, NULL, NULL, 'MANNOSYLTRANSFERASE', 243502),
(340178, 'PTHR12526:SF615', NULL, NULL, NULL, NULL, 'D-RHAMNOSYLTRANSFERASE WBPZ', 243502),
(340179, 'PTHR12526:SF590', NULL, NULL, NULL, NULL, 'ALPHA-MALTOSE-1-PHOSPHATE SYNTHASE', 243502),
(340180, 'PTHR12526:SF572', NULL, NULL, NULL, NULL, 'BLL5144 PROTEIN', 243502),
(340181, 'PTHR12526:SF594', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE GROUP 1', 243502),
(340182, 'PTHR12526:SF595', NULL, NULL, NULL, NULL, 'BLL5217 PROTEIN', 243502),
(340183, 'PTHR12526', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 243502),
(340184, 'PTHR12526:SF607', NULL, NULL, NULL, NULL, '1,2-DIACYLGLYCEROL 3-GLUCOSYLTRANSFERASE', 243502),
(340185, 'PTHR12526:SF608', NULL, NULL, NULL, NULL, 'PELF', 243502),
(340186, 'PTHR12526:SF609', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE BIOSYNTHESIS PROTEIN', 243502),
(340187, 'PTHR12526:SF586', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE GROUP 1', 243502),
(340188, 'PTHR12526:SF620', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE-RELATED', 243502),
(340189, 'PTHR12526:SF621', NULL, NULL, NULL, NULL, 'BLL2377 PROTEIN', 243502),
(340190, 'PTHR12526:SF588', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE CORE BIOSYNTHESIS PROTEIN RFAG', 243502),
(340191, 'PTHR12526:SF600', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE GROUP 1', 243502),
(340192, 'PTHR12526:SF622', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE-RELATED', 243502);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(340193, 'PTHR12526:SF604', NULL, NULL, NULL, NULL, 'TRANSFERASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G14070)-RELATED', 243502),
(340194, 'PTHR12526:SF527', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 243502),
(340195, 'PTHR12526:SF583', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE GROUP 1', 243502),
(340196, 'PTHR12526:SF584', NULL, NULL, NULL, NULL, 'COLANIC ACID BIOSYNTHESIS GLYCOSYL TRANSFERASE WCAC-RELATED', 243502),
(340197, 'PTHR12526:SF563', NULL, NULL, NULL, NULL, 'POLY(GLYCEROL-PHOSPHATE) ALPHA-GLUCOSYLTRANSFERASE', 243502),
(340198, 'PTHR31969', NULL, NULL, NULL, NULL, 'GEM-LIKE PROTEIN 2', 243503),
(340199, 'PTHR31969:SF49', NULL, NULL, NULL, NULL, 'FH INTERACTING PROTEIN 1-RELATED', 243503),
(340200, 'PTHR31969:SF47', NULL, NULL, NULL, NULL, 'GRAM DOMAIN-CONTAINING PROTEIN', 243503),
(340201, 'PTHR31969:SF13', NULL, NULL, NULL, NULL, 'GLABRA2 EXPRESSION MODULATOR', 243503),
(340202, 'PTHR31969:SF57', NULL, NULL, NULL, NULL, 'GRAM DOMAIN-CONTAINING PROTEIN', 243503),
(340203, 'PTHR31969:SF34', NULL, NULL, NULL, NULL, 'OS02G0636700 PROTEIN', 243503),
(340204, 'PTHR31969:SF56', NULL, NULL, NULL, NULL, 'GRAM DOMAIN-CONTAINING PROTEIN', 243503),
(340205, 'PTHR31969:SF54', NULL, NULL, NULL, NULL, 'GEM-LIKE PROTEIN 6-RELATED', 243503),
(340206, 'PTHR31969:SF10', NULL, NULL, NULL, NULL, 'OS04G0526800 PROTEIN', 243503),
(340207, 'PTHR31969:SF52', NULL, NULL, NULL, NULL, 'GRAM DOMAIN-CONTAINING PROTEIN', 243503),
(340208, 'PTHR31969:SF51', NULL, NULL, NULL, NULL, 'GRAM DOMAIN-CONTAINING PROTEIN', 243503),
(340209, 'PTHR31969:SF50', NULL, NULL, NULL, NULL, 'GRAM DOMAIN-CONTAINING PROTEIN', 243503),
(340210, 'PTHR31969:SF5', NULL, NULL, NULL, NULL, 'FIP1', 243503),
(340211, 'PTHR31969:SF9', NULL, NULL, NULL, NULL, 'GEM-LIKE PROTEIN 2', 243503),
(340212, 'PTHR31969:SF1', NULL, NULL, NULL, NULL, 'GRAM DOMAIN-CONTAINING PROTEIN', 243503),
(340213, 'PTHR31969:SF3', NULL, NULL, NULL, NULL, 'GEM-LIKE PROTEIN 5', 243503),
(340214, 'PTHR31969:SF59', NULL, NULL, NULL, NULL, 'GEM-LIKE PROTEIN 4', 243503),
(340215, 'PTHR31969:SF37', NULL, NULL, NULL, NULL, 'GRAM DOMAIN-CONTAINING PROTEIN', 243503),
(340216, 'PTHR31969:SF36', NULL, NULL, NULL, NULL, 'GEM-LIKE PROTEIN 3-RELATED', 243503),
(340217, 'PTHR31969:SF4', NULL, NULL, NULL, NULL, 'GEM-LIKE PROTEIN 1', 243503),
(340218, 'PTHR31969:SF58', NULL, NULL, NULL, NULL, 'GRAM DOMAIN-CONTAINING PROTEIN', 243503),
(340219, 'PTHR31969:SF46', NULL, NULL, NULL, NULL, 'OS02G0636600 PROTEIN', 243503),
(340220, 'PTHR31969:SF67', NULL, NULL, NULL, NULL, 'GRAM DOMAIN-CONTAINING PROTEIN', 243503),
(340221, 'PTHR31969:SF45', NULL, NULL, NULL, NULL, 'GRAM DOMAIN-CONTAINING PROTEIN-RELATED', 243503),
(340222, 'PTHR31969:SF66', NULL, NULL, NULL, NULL, 'OS04G0527000 PROTEIN', 243503),
(340223, 'PTHR31969:SF43', NULL, NULL, NULL, NULL, 'GEM-LIKE PROTEIN 5', 243503),
(340224, 'PTHR31969:SF65', NULL, NULL, NULL, NULL, 'GRAM DOMAIN PROTEIN/ABA-RESPONSIVE-LIKE PROTEIN', 243503),
(340225, 'PTHR31969:SF64', NULL, NULL, NULL, NULL, 'GEM-LIKE PROTEIN 8-RELATED', 243503),
(340226, 'PTHR31969:SF62', NULL, NULL, NULL, NULL, 'GRAM DOMAIN-CONTAINING PROTEIN', 243503),
(340227, 'PTHR47321', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS W', 243504),
(340228, 'PTHR47321:SF1', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN-RELATED', 243504),
(340229, 'PTHR43304', NULL, NULL, NULL, NULL, 'PHYTOCHROME-LIKE PROTEIN CPH1', 243505),
(340230, 'PTHR43304:SF1', NULL, NULL, NULL, NULL, 'PAC DOMAIN-CONTAINING PROTEIN', 243505),
(340231, 'PTHR10422:SF43', NULL, NULL, NULL, NULL, 'NITRIC OXIDE REDUCTASE SUBUNIT B', 243506),
(340232, 'PTHR10422:SF40', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT I', 243506),
(340233, 'PTHR10422:SF29', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 1 HOMOLOG, BACTEROID', 243506),
(340234, 'PTHR10422:SF18', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 1', 243506),
(340235, 'PTHR10422', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 1', 243506),
(340236, 'PTHR10422:SF38', NULL, NULL, NULL, NULL, 'CYTOCHROME B SUBUNIT OF NITRIC OXIDE REDUCTASE', 243506);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(340237, 'PTHR10422:SF35', NULL, NULL, NULL, NULL, 'CYTOCHROME BO(3) UBIQUINOL OXIDASE SUBUNIT 1', 243506),
(340238, 'PTHR43721:SF2', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR TU, MITOCHONDRIAL', 243507),
(340239, 'PTHR43721:SF3', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN 2', 243507),
(340240, 'PTHR43721', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR TU-RELATED', 243507),
(340241, 'PTHR43721:SF29', NULL, NULL, NULL, NULL, 'TRANSLATION ELONGATION FACTOR', 243507),
(340242, 'PTHR43721:SF28', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR TU FAMILY, PUTATIVE-RELATED', 243507),
(340243, 'PTHR43721:SF24', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR TU', 243507),
(340244, 'PTHR43721:SF34', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR TU, CHLOROPLASTIC', 243507),
(340245, 'PTHR43721:SF23', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR TU', 243507),
(340246, 'PTHR43721:SF33', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR TU, MITOCHONDRIAL', 243507),
(340247, 'PTHR43721:SF9', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN 1', 243507),
(340248, 'PTHR43721:SF11', NULL, NULL, NULL, NULL, 'SELENOCYSTEINE-SPECIFIC ELONGATION FACTOR', 243507),
(340249, 'PTHR43721:SF22', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR TU, MITOCHONDRIAL', 243507),
(340250, 'PTHR43721:SF32', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR TU', 243507),
(340251, 'PTHR43721:SF10', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN 2B', 243507),
(340252, 'PTHR43721:SF31', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR TU', 243507),
(340253, 'PTHR43721:SF30', NULL, NULL, NULL, NULL, 'TR-TYPE G DOMAIN-CONTAINING PROTEIN', 243507),
(340254, 'PTHR43721:SF5', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR TU, CHLOROPLASTIC', 243507),
(340255, 'PTHR30589', NULL, NULL, NULL, NULL, 'PROLIPOPROTEIN DIACYLGLYCERYL TRANSFERASE', 243508),
(340256, 'PTHR30589:SF0', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLGLYCEROL--PROLIPOPROTEIN DIACYLGLYCERYL TRANSFERASE', 243508),
(340257, 'PTHR38686:SF1', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN N-ACYLTRANSFERASE', 243509),
(340258, 'PTHR38686', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN N-ACYLTRANSFERASE', 243509),
(340259, 'PTHR15317:SF1', NULL, NULL, NULL, NULL, 'T-CELL SURFACE PROTEIN TACTILE', 243510),
(340260, 'PTHR15317', NULL, NULL, NULL, NULL, 'T-CELL SURFACE PROTEIN TACTILE', 243510),
(340261, 'PTHR43159', NULL, NULL, NULL, NULL, 'ENOYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', 243511),
(340262, 'PTHR43159:SF2', NULL, NULL, NULL, NULL, 'ENOYL-[ACYL-CARRIER-PROTEIN] REDUCTASE [NADH], CHLOROPLASTIC', 243511),
(340263, 'PTHR43159:SF10', NULL, NULL, NULL, NULL, 'ENOYL-ACYL-CARRIER REDUCTASE', 243511),
(340264, 'PTHR43159:SF6', NULL, NULL, NULL, NULL, 'ENOYL-ACYL-CARRIER REDUCTASE', 243511),
(340265, 'PTHR43159:SF7', NULL, NULL, NULL, NULL, 'ENOYL-[ACYL-CARRIER-PROTEIN] REDUCTASE [NADH] 2, CHLOROPLASTIC', 243511),
(340266, 'PTHR43159:SF8', NULL, NULL, NULL, NULL, 'ENOYL-[ACYL-CARRIER-PROTEIN] REDUCTASE [NADH] 2, CHLOROPLASTIC-LIKE', 243511),
(340267, 'PTHR44267:SF1', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 43', 243512),
(340268, 'PTHR44267', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 43', 243512),
(340269, 'PTHR15592', NULL, NULL, NULL, NULL, 'MATRIN 3/NUCLEAR PROTEIN 220-RELATED', 243513),
(340270, 'PTHR15592:SF41', NULL, NULL, NULL, NULL, 'MATRIN 3-LIKE 1.1', 243513),
(340271, 'PTHR15592:SF20', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN L', 243513),
(340272, 'PTHR15592:SF42', NULL, NULL, NULL, NULL, 'RBP50', 243513),
(340273, 'PTHR15592:SF18', NULL, NULL, NULL, NULL, 'SMOOTH, ISOFORM T', 243513),
(340274, 'PTHR15592:SF29', NULL, NULL, NULL, NULL, 'POLYPYRIMIDINE TRACT-BINDING PROTEIN HOMOLOG 2', 243513),
(340275, 'PTHR15592:SF19', NULL, NULL, NULL, NULL, 'POLYPYRIMIDINE TRACT-BINDING PROTEIN 1', 243513),
(340276, 'PTHR15592:SF2', NULL, NULL, NULL, NULL, 'MATRIN-3', 243513),
(340277, 'PTHR15592:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 638', 243513),
(340278, 'PTHR15592:SF13', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN L-LIKE', 243513),
(340279, 'PTHR15592:SF43', NULL, NULL, NULL, NULL, '', 243513);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(340280, 'PTHR15592:SF11', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 20', 243513),
(340281, 'PTHR15592:SF44', NULL, NULL, NULL, NULL, 'RRM_8 DOMAIN-CONTAINING PROTEIN', 243513),
(340282, 'PTHR15592:SF22', NULL, NULL, NULL, NULL, 'OS08G0436000 PROTEIN', 243513),
(340283, 'PTHR15592:SF16', NULL, NULL, NULL, NULL, 'POLYPYRIMIDINE TRACT-BINDING PROTEIN 2', 243513),
(340284, 'PTHR15592:SF27', NULL, NULL, NULL, NULL, 'HEPHAESTUS, ISOFORM Y', 243513),
(340285, 'PTHR15592:SF28', NULL, NULL, NULL, NULL, 'OS01G0867800 PROTEIN', 243513),
(340286, 'PTHR15592:SF39', NULL, NULL, NULL, NULL, 'POLYPYRIMIDINE TRACT-BINDING PROTEIN HOMOLOG 3-LIKE ISOFORM X1', 243513),
(340287, 'PTHR15592:SF17', NULL, NULL, NULL, NULL, 'POLYPYRIMIDINE TRACT-BINDING PROTEIN 3', 243513),
(340288, 'PTHR15592:SF14', NULL, NULL, NULL, NULL, 'POLYPYRIMIDINE TRACT-BINDING PROTEIN HOMOLOG 1', 243513),
(340289, 'PTHR15592:SF26', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 243513),
(340290, 'PTHR35745:SF1', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 243514),
(340291, 'PTHR35745', NULL, NULL, NULL, NULL, 'BNACNNG14650D PROTEIN', 243514),
(340292, 'PTHR11879:SF55', NULL, NULL, NULL, NULL, 'ASPARTATE TRANSAMINASE', 243515),
(340293, 'PTHR11879:SF54', NULL, NULL, NULL, NULL, 'ASPARTATE AMINOTRANSFERASE, MITOCHONDRIAL', 243515),
(340294, 'PTHR11879:SF57', NULL, NULL, NULL, NULL, 'ASPARTATE AMINOTRANSFERASE 3, CHLOROPLASTIC', 243515),
(340295, 'PTHR11879:SF56', NULL, NULL, NULL, NULL, 'ASPARTATE AMINOTRANSFERASE', 243515),
(340296, 'PTHR11879:SF37', NULL, NULL, NULL, NULL, 'AROMATIC-AMINO-ACID AMINOTRANSFERASE', 243515),
(340297, 'PTHR11879:SF36', NULL, NULL, NULL, NULL, 'ASPARTATE TRANSAMINASE', 243515),
(340298, 'PTHR11879:SF14', NULL, NULL, NULL, NULL, 'ASPARTATE AMINOTRANSFERASE', 243515),
(340299, 'PTHR11879:SF39', NULL, NULL, NULL, NULL, 'ASPARTATE AMINOTRANSFERASE, MITOCHONDRIAL', 243515),
(340300, 'PTHR11879:SF38', NULL, NULL, NULL, NULL, 'ASPARTATE AMINOTRANSFERASE', 243515),
(340301, 'PTHR11879:SF6', NULL, NULL, NULL, NULL, 'ASPARTATE AMINOTRANSFERASE, CYTOPLASMIC 2-RELATED', 243515),
(340302, 'PTHR11879:SF4', NULL, NULL, NULL, NULL, 'ASPARTATE AMINOTRANSFERASE', 243515),
(340303, 'PTHR11879:SF3', NULL, NULL, NULL, NULL, 'ASPARTATE AMINOTRANSFERASE, CYTOPLASMIC', 243515),
(340304, 'PTHR11879', NULL, NULL, NULL, NULL, 'ASPARTATE AMINOTRANSFERASE', 243515),
(340305, 'PTHR11879:SF20', NULL, NULL, NULL, NULL, 'ASPARTATE AMINOTRANSFERASE', 243515),
(340306, 'PTHR11879:SF41', NULL, NULL, NULL, NULL, 'ASPARTATE AMINOTRANSFERASE, CYTOPLASMIC ISOZYME 2', 243515),
(340307, 'PTHR11879:SF44', NULL, NULL, NULL, NULL, 'ASPARTATE AMINOTRANSFERASE', 243515),
(340308, 'PTHR11879:SF22', NULL, NULL, NULL, NULL, 'ASPARTATE AMINOTRANSFERASE, MITOCHONDRIAL', 243515),
(340309, 'PTHR11879:SF46', NULL, NULL, NULL, NULL, 'ASPARTATE AMINOTRANSFERASE, CYTOPLASMIC', 243515),
(340310, 'PTHR11879:SF45', NULL, NULL, NULL, NULL, 'ASPARTATE AMINOTRANSFERASE', 243515),
(340311, 'PTHR11879:SF47', NULL, NULL, NULL, NULL, 'ASPARTATE TRANSAMINASE', 243515),
(340312, 'PTHR11879:SF49', NULL, NULL, NULL, NULL, 'ASPARTATE AMINOTRANSFERASE', 243515),
(340313, 'PTHR11879:SF51', NULL, NULL, NULL, NULL, 'ASPARTATE AMINOTRANSFERASE', 243515),
(340314, 'PTHR11879:SF50', NULL, NULL, NULL, NULL, 'ASPARTATE AMINOTRANSFERASE', 243515),
(340315, 'PTHR11879:SF53', NULL, NULL, NULL, NULL, 'ASPARTATE AMINOTRANSFERASE', 243515),
(340316, 'PTHR11879:SF52', NULL, NULL, NULL, NULL, 'ASPARTATE AMINOTRANSFERASE, CYTOPLASMIC ISOZYME 1', 243515),
(340317, 'PTHR28254', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 10', 243516),
(340318, 'PTHR28254:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 10, MITOCHONDRIAL', 243516),
(340319, 'PTHR48134:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG08261', 243517),
(340320, 'PTHR48134', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN 96-92-RELATED-RELATED', 243517),
(340321, 'PTHR48134:SF2', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN 96-92-RELATED', 243517),
(340322, 'PTHR46100', NULL, NULL, NULL, NULL, 'IMP2''P', 243518);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(340323, 'PTHR46100:SF12', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN-RELATED', 243518),
(340324, 'PTHR46100:SF13', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 243518),
(340325, 'PTHR46100:SF10', NULL, NULL, NULL, NULL, 'UNIVERSAL STRESS PROTEIN A-LIKE PROTEIN', 243518),
(340326, 'PTHR46100:SF1', NULL, NULL, NULL, NULL, 'OS02G0773200 PROTEIN', 243518),
(340327, 'PTHR46100:SF2', NULL, NULL, NULL, NULL, 'OS05G0453700 PROTEIN', 243518),
(340328, 'PTHR46100:SF15', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 243518),
(340329, 'PTHR46100:SF17', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASE-LIKE SUPERFAMILY PROTEIN', 243518),
(340330, 'PTHR46100:SF18', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 243518),
(340331, 'PTHR46100:SF8', NULL, NULL, NULL, NULL, 'OS05G0170200 PROTEIN', 243518),
(340332, 'PTHR46100:SF4', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 243518),
(340333, 'PTHR46100:SF5', NULL, NULL, NULL, NULL, 'OS01G0849600 PROTEIN', 243518),
(340334, 'PTHR46100:SF7', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASE SUPERFAMILY PROTEIN', 243518),
(340335, 'PTHR46119', NULL, NULL, NULL, NULL, 'OS08G0405700 PROTEIN', 243519),
(340336, 'PTHR46119:SF24', NULL, NULL, NULL, NULL, 'METAL ION BINDING PROTEIN', 243519),
(340337, 'PTHR46119:SF14', NULL, NULL, NULL, NULL, 'PROTEIN SODIUM POTASSIUM ROOT DEFECTIVE 3', 243519),
(340338, 'PTHR46119:SF25', NULL, NULL, NULL, NULL, 'PROTEIN SODIUM POTASSIUM ROOT DEFECTIVE 2', 243519),
(340339, 'PTHR46119:SF22', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED DOMAIN CONTAINING PROTEIN, EXPRESSED', 243519),
(340340, 'PTHR46119:SF11', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORT/DETOXIFICATION SUPERFAMILY PROTEIN', 243519),
(340341, 'PTHR46119:SF23', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORT/DETOXIFICATION SUPERFAMILY PROTEIN', 243519),
(340342, 'PTHR46119:SF12', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 243519),
(340343, 'PTHR46119:SF21', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED DOMAIN, HMA-RELATED', 243519),
(340344, 'PTHR46119:SF17', NULL, NULL, NULL, NULL, 'COPPER CHAPERONE', 243519),
(340345, 'PTHR46119:SF18', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 243519),
(340346, 'PTHR46119:SF15', NULL, NULL, NULL, NULL, 'PROTEIN SODIUM POTASSIUM ROOT DEFECTIVE 1', 243519),
(340347, 'PTHR46119:SF26', NULL, NULL, NULL, NULL, 'PROTEIN SODIUM POTASSIUM ROOT DEFECTIVE 1-LIKE', 243519),
(340348, 'PTHR46119:SF16', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 243519),
(340349, 'PTHR46119:SF7', NULL, NULL, NULL, NULL, 'OS01G0595201 PROTEIN', 243519),
(340350, 'PTHR46119:SF8', NULL, NULL, NULL, NULL, 'OS08G0405700 PROTEIN', 243519),
(340351, 'PTHR46119:SF9', NULL, NULL, NULL, NULL, 'OS05G0534500 PROTEIN', 243519),
(340352, 'PTHR31197:SF27', NULL, NULL, NULL, NULL, '', 243520),
(340353, 'PTHR31197:SF26', NULL, NULL, NULL, NULL, 'BNAA07G38330D PROTEIN', 243520),
(340354, 'PTHR31197:SF25', NULL, NULL, NULL, NULL, 'BNAA02G19910D PROTEIN', 243520),
(340355, 'PTHR31197:SF24', NULL, NULL, NULL, NULL, 'BNAA02G28450D PROTEIN', 243520),
(340356, 'PTHR31197:SF45', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 243520),
(340357, 'PTHR31197:SF23', NULL, NULL, NULL, NULL, 'OS04G0448100 PROTEIN', 243520),
(340358, 'PTHR31197:SF44', NULL, NULL, NULL, NULL, 'BNAC02G36580D PROTEIN', 243520),
(340359, 'PTHR31197:SF21', NULL, NULL, NULL, NULL, 'DUF1644 FAMILY PROTEIN', 243520),
(340360, 'PTHR31197:SF43', NULL, NULL, NULL, NULL, 'BNAA06G10150D PROTEIN', 243520),
(340361, 'PTHR31197:SF42', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 243520),
(340362, 'PTHR31197:SF40', NULL, NULL, NULL, NULL, '', 243520),
(340363, 'PTHR31197:SF29', NULL, NULL, NULL, NULL, 'DUF1644 FAMILY PROTEIN', 243520),
(340364, 'PTHR31197:SF28', NULL, NULL, NULL, NULL, 'BNAA08G19270D PROTEIN', 243520),
(340365, 'PTHR31197:SF38', NULL, NULL, NULL, NULL, 'BNAA02G18630D PROTEIN', 243520),
(340366, 'PTHR31197:SF2', NULL, NULL, NULL, NULL, 'PLANT/K7P8-3 PROTEIN', 243520);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(340367, 'PTHR31197:SF37', NULL, NULL, NULL, NULL, 'BNAA07G37190D PROTEIN', 243520),
(340368, 'PTHR31197:SF36', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 243520),
(340369, 'PTHR31197:SF4', NULL, NULL, NULL, NULL, 'OS02G0150900 PROTEIN', 243520),
(340370, 'PTHR31197:SF14', NULL, NULL, NULL, NULL, 'OS06G0693700 PROTEIN', 243520),
(340371, 'PTHR31197:SF5', NULL, NULL, NULL, NULL, 'OS01G0612600 PROTEIN', 243520),
(340372, 'PTHR31197:SF35', NULL, NULL, NULL, NULL, 'BNAA02G27710D PROTEIN', 243520),
(340373, 'PTHR31197:SF34', NULL, NULL, NULL, NULL, 'BNAA02G28490D PROTEIN', 243520),
(340374, 'PTHR31197:SF12', NULL, NULL, NULL, NULL, 'OS02G0770600 PROTEIN', 243520),
(340375, 'PTHR31197:SF6', NULL, NULL, NULL, NULL, 'OS09G0451800 PROTEIN', 243520),
(340376, 'PTHR31197:SF7', NULL, NULL, NULL, NULL, 'OS07G0419800 PROTEIN', 243520),
(340377, 'PTHR31197:SF8', NULL, NULL, NULL, NULL, 'OS02G0566500 PROTEIN', 243520),
(340378, 'PTHR31197:SF31', NULL, NULL, NULL, NULL, 'BNAA09G56860D PROTEIN', 243520),
(340379, 'PTHR31197', NULL, NULL, NULL, NULL, 'OS01G0612600 PROTEIN', 243520),
(340380, 'PTHR31197:SF39', NULL, NULL, NULL, NULL, 'BNAA01G05830D PROTEIN', 243520),
(340381, 'PTHR21192', NULL, NULL, NULL, NULL, 'NUCLEAR PROTEIN E3-3', 243521),
(340382, 'PTHR21192:SF4', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX ASSEMBLY FACTOR 3', 243521),
(340383, 'PTHR21192:SF2', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX ASSEMBLY FACTOR 3', 243521),
(340384, 'PTHR13887:SF33', NULL, NULL, NULL, NULL, 'ISOMERASE-RELATED', 243522),
(340385, 'PTHR13887:SF54', NULL, NULL, NULL, NULL, 'DSBA DOMAIN-CONTAINING PROTEIN', 243522),
(340386, 'PTHR13887:SF53', NULL, NULL, NULL, NULL, 'SUPPRESSION OF COPPER SENSITIVITY PROTEIN', 243522),
(340387, 'PTHR13887:SF41', NULL, NULL, NULL, NULL, 'THIOREDOXIN SUPERFAMILY PROTEIN', 243522),
(340388, 'PTHR13887:SF52', NULL, NULL, NULL, NULL, 'DSBA DOMAIN-CONTAINING PROTEIN', 243522),
(340389, 'PTHR13887:SF51', NULL, NULL, NULL, NULL, 'DSBA DOMAIN-CONTAINING PROTEIN', 243522),
(340390, 'PTHR13887', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE KAPPA', 243522),
(340391, 'PTHR13887:SF47', NULL, NULL, NULL, NULL, 'CLPXP ADAPTER PROTEIN SPXH', 243522),
(340392, 'PTHR13887:SF14', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE REDUCTASE RV2466C', 243522),
(340393, 'PTHR13887:SF46', NULL, NULL, NULL, NULL, 'DSBA DOMAIN-CONTAINING PROTEIN', 243522),
(340394, 'PTHR12849:SF0', NULL, NULL, NULL, NULL, 'LARIAT DEBRANCHING ENZYME', 243523),
(340395, 'PTHR12849:SF1', NULL, NULL, NULL, NULL, 'DBR1 DOMAIN-CONTAINING PROTEIN', 243523),
(340396, 'PTHR12849', NULL, NULL, NULL, NULL, 'RNA LARIAT DEBRANCHING ENZYME', 243523),
(340397, 'PTHR47969', NULL, NULL, NULL, NULL, 'CHROMOSOME-ASSOCIATED KINESIN KIF4A-RELATED', 243524),
(340398, 'PTHR47969:SF1', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-4C', 243524),
(340399, 'PTHR47969:SF23', NULL, NULL, NULL, NULL, 'CHROMOSOME-ASSOCIATED KINESIN KIF4', 243524),
(340400, 'PTHR47969:SF12', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN-RELATED', 243524),
(340401, 'PTHR47969:SF5', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN-RELATED', 243524),
(340402, 'PTHR47969:SF11', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 243524),
(340403, 'PTHR47969:SF22', NULL, NULL, NULL, NULL, 'KINESIN FAMILY MEMBER 27', 243524),
(340404, 'PTHR47969:SF21', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 243524),
(340405, 'PTHR47969:SF3', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-4B', 243524),
(340406, 'PTHR47969:SF27', NULL, NULL, NULL, NULL, 'CHROMOSOME-ASSOCIATED KINESIN KIF4A-LIKE PROTEIN', 243524),
(340407, 'PTHR47969:SF9', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 243524),
(340408, 'PTHR47969:SF26', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 243524),
(340409, 'PTHR47969:SF8', NULL, NULL, NULL, NULL, 'KINESIN FAMILY MEMBER 7', 243524),
(340410, 'PTHR47969:SF15', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-4A', 243524);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(340411, 'PTHR47969:SF7', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 243524),
(340412, 'PTHR47969:SF25', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 243524),
(340413, 'PTHR47969:SF24', NULL, NULL, NULL, NULL, 'CHROMOSOME-ASSOCIATED KINESIN KIF4A-LIKE PROTEIN', 243524),
(340414, 'PTHR47969:SF6', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-4C', 243524),
(340415, 'PTHR47969:SF18', NULL, NULL, NULL, NULL, 'CHROMOSOME-ASSOCIATED KINESIN KIF4A', 243524),
(340416, 'PTHR47969:SF17', NULL, NULL, NULL, NULL, 'CHROMOSOME-ASSOCIATED KINESIN KIF4B', 243524),
(340417, 'PTHR37172', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 243525),
(340418, 'PTHR37172:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 243525),
(340419, 'PTHR37172:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 243525),
(340420, 'PTHR46412:SF12', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 243526),
(340421, 'PTHR46412:SF14', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BIM1-LIKE ISOFORM X1', 243526),
(340422, 'PTHR46412:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BIM1', 243526),
(340423, 'PTHR46412:SF4', NULL, NULL, NULL, NULL, 'OS02G0726700 PROTEIN', 243526),
(340424, 'PTHR46412:SF15', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTION FACTOR', 243526),
(340425, 'PTHR46412:SF16', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTION FACTOR', 243526),
(340426, 'PTHR46412:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BIM2', 243526),
(340427, 'PTHR46412:SF17', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 243526),
(340428, 'PTHR46412:SF18', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BIM2-LIKE ISOFORM X1', 243526),
(340429, 'PTHR46412:SF9', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BIM3', 243526),
(340430, 'PTHR46412', NULL, NULL, NULL, NULL, 'BES1-INTERACTING MYC-LIKE PROTEIN', 243526),
(340431, 'PTHR46412:SF10', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 243526),
(340432, 'PTHR18843', NULL, NULL, NULL, NULL, 'TORSIN-1A-INTERACTING PROTEIN', 243527),
(340433, 'PTHR18843:SF2', NULL, NULL, NULL, NULL, 'TORSIN-1A-INTERACTING PROTEIN 2', 243527),
(340434, 'PTHR18843:SF6', NULL, NULL, NULL, NULL, 'TORSIN-1A-INTERACTING PROTEIN 1', 243527),
(340435, 'PTHR18843:SF7', NULL, NULL, NULL, NULL, 'SI:DKEYP-82A1.6-RELATED', 243527),
(340436, 'PTHR34199:SF4', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 243528),
(340437, 'PTHR34199:SF5', NULL, NULL, NULL, NULL, 'IENR2 DOMAIN-CONTAINING PROTEIN', 243528),
(340438, 'PTHR34199:SF7', NULL, NULL, NULL, NULL, 'BNAA06G01030D PROTEIN', 243528),
(340439, 'PTHR34199', NULL, NULL, NULL, NULL, 'NUMOD3 MOTIF FAMILY PROTEIN, EXPRESSED', 243528),
(340440, 'PTHR34199:SF1', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE, H3 LYSINE-79 SPECIFIC-LIKE PROTEIN', 243528),
(340441, 'PTHR34199:SF2', NULL, NULL, NULL, NULL, 'NUMOD3 MOTIF FAMILY PROTEIN, EXPRESSED', 243528),
(340442, 'PTHR13199:SF13', NULL, NULL, NULL, NULL, 'PROTEIN FAM214A', 243529),
(340443, 'PTHR13199:SF22', NULL, NULL, NULL, NULL, 'MEIOSIS CHROMOSOME SEGREGATION FAMILY PROTEIN', 243529),
(340444, 'PTHR13199:SF11', NULL, NULL, NULL, NULL, 'DUF4210 DOMAIN-CONTAINING PROTEIN', 243529),
(340445, 'PTHR13199:SF12', NULL, NULL, NULL, NULL, 'PROTEIN FAM214B', 243529),
(340446, 'PTHR13199:SF21', NULL, NULL, NULL, NULL, 'DUF4210 DOMAIN-CONTAINING PROTEIN', 243529),
(340447, 'PTHR13199:SF19', NULL, NULL, NULL, NULL, 'DUF4210 DOMAIN-CONTAINING PROTEIN', 243529),
(340448, 'PTHR13199', NULL, NULL, NULL, NULL, 'GH03947P', 243529),
(340449, 'PTHR13199:SF18', NULL, NULL, NULL, NULL, 'DUF4210 DOMAIN-CONTAINING PROTEIN', 243529),
(340450, 'PTHR31308:SF5', NULL, NULL, NULL, NULL, 'ERGOSTERYL-BETA-GLUCOSIDASE', 243530),
(340451, 'PTHR31308:SF3', NULL, NULL, NULL, NULL, 'CELLULASE DOMAIN-CONTAINING PROTEIN', 243530),
(340452, 'PTHR31308:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 10, WHOLE GENOME SHOTGUN SEQUENCE', 243530),
(340453, 'PTHR31308', NULL, NULL, NULL, NULL, '', 243530),
(340454, 'PTHR16238:SF7', NULL, NULL, NULL, NULL, 'GEM-ASSOCIATED PROTEIN 8', 243531);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(340455, 'PTHR16238', NULL, NULL, NULL, NULL, 'GEM-ASSOCIATED PROTEIN 8', 243531),
(340456, 'PTHR23024:SF210', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340457, 'PTHR23024:SF571', NULL, NULL, NULL, NULL, 'PROTEIN CBG22774', 243532),
(340458, 'PTHR23024:SF577', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 2-RELATED', 243532),
(340459, 'PTHR23024:SF455', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 16-RELATED', 243532),
(340460, 'PTHR23024:SF212', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 9-RELATED', 243532),
(340461, 'PTHR23024:SF574', NULL, NULL, NULL, NULL, 'KYNURENINE FORMAMIDASE', 243532),
(340462, 'PTHR23024:SF211', NULL, NULL, NULL, NULL, 'B1065G12.16 PROTEIN', 243532),
(340463, 'PTHR23024:SF339', NULL, NULL, NULL, NULL, 'DLH DOMAIN-CONTAINING PROTEIN', 243532),
(340464, 'PTHR23024:SF458', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340465, 'PTHR23024:SF578', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340466, 'PTHR23024:SF441', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340467, 'PTHR23024:SF562', NULL, NULL, NULL, NULL, '2-HYDROXYISOFLAVANONE DEHYDRATASE', 243532),
(340468, 'PTHR23024:SF560', NULL, NULL, NULL, NULL, 'CXE CARBOXYLESTERASE', 243532),
(340469, 'PTHR23024:SF566', NULL, NULL, NULL, NULL, '2-HYDROXYISOFLAVANONE DEHYDRATASE-LIKE', 243532),
(340470, 'PTHR23024:SF445', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 2-RELATED', 243532),
(340471, 'PTHR23024:SF564', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN-RELATED', 243532),
(340472, 'PTHR23024:SF563', NULL, NULL, NULL, NULL, 'OS07G0501400 PROTEIN', 243532),
(340473, 'PTHR23024:SF442', NULL, NULL, NULL, NULL, 'OS07G0162400 PROTEIN', 243532),
(340474, 'PTHR23024:SF449', NULL, NULL, NULL, NULL, '2-HYDROXYISOFLAVANONE DEHYDRATASE', 243532),
(340475, 'PTHR23024:SF568', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 11-RELATED', 243532),
(340476, 'PTHR23024:SF204', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 15-RELATED', 243532),
(340477, 'PTHR23024:SF446', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 7-RELATED', 243532),
(340478, 'PTHR23024:SF567', NULL, NULL, NULL, NULL, 'OS11G0240600 PROTEIN', 243532),
(340479, 'PTHR23024:SF591', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340480, 'PTHR23024:SF470', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 18-RELATED', 243532),
(340481, 'PTHR23024:SF96', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340482, 'PTHR23024:SF473', NULL, NULL, NULL, NULL, 'RECEPTOR GID1, PUTATIVE-RELATED', 243532),
(340483, 'PTHR23024:SF594', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN-RELATED', 243532),
(340484, 'PTHR23024:SF230', NULL, NULL, NULL, NULL, 'OS03G0790500 PROTEIN', 243532),
(340485, 'PTHR23024:SF593', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340486, 'PTHR23024:SF472', NULL, NULL, NULL, NULL, 'OS09G0461700 PROTEIN', 243532),
(340487, 'PTHR23024:SF115', NULL, NULL, NULL, NULL, 'ARYLACETAMIDE DEACETYLASE-LIKE 3', 243532),
(340488, 'PTHR23024:SF356', NULL, NULL, NULL, NULL, 'AADACL2 FAMILY MEMBER 3', 243532),
(340489, 'PTHR23024:SF98', NULL, NULL, NULL, NULL, 'GIBBERELLIN RECEPTOR GID1B', 243532),
(340490, 'PTHR23024:SF113', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 8-RELATED', 243532),
(340491, 'PTHR23024:SF239', NULL, NULL, NULL, NULL, 'AADACL2 FAMILY MEMBER 2', 243532),
(340492, 'PTHR23024:SF358', NULL, NULL, NULL, NULL, 'OS09G0460300 PROTEIN', 243532),
(340493, 'PTHR23024:SF479', NULL, NULL, NULL, NULL, '2-HYDROXYISOFLAVANONE DEHYDRATASE-LIKE', 243532),
(340494, 'PTHR23024:SF463', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 17-RELATED', 243532),
(340495, 'PTHR23024:SF584', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G14530)-RELATED', 243532),
(340496, 'PTHR23024:SF462', NULL, NULL, NULL, NULL, 'GIBBERELLIN RECEPTOR GID1C-LIKE PROTEIN', 243532),
(340497, 'PTHR23024:SF583', NULL, NULL, NULL, NULL, 'ISOPRENYLCYSTEINE ALPHA-CARBONYL METHYLESTERASE ICME', 243532);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(340498, 'PTHR23024:SF582', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340499, 'PTHR23024:SF467', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 13-RELATED', 243532),
(340500, 'PTHR23024:SF224', NULL, NULL, NULL, NULL, 'OS01G0155000 PROTEIN', 243532),
(340501, 'PTHR23024:SF223', NULL, NULL, NULL, NULL, 'ARYLACETAMIDE DEACETYLASE-LIKE 2', 243532),
(340502, 'PTHR23024:SF465', NULL, NULL, NULL, NULL, '2-HYDROXYISOFLAVANONE DEHYDRATASE-LIKE', 243532),
(340503, 'PTHR23024:SF464', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 15-RELATED', 243532),
(340504, 'PTHR23024:SF222', NULL, NULL, NULL, NULL, 'ARYLACETAMIDE DEACETYLASE', 243532),
(340505, 'PTHR23024:SF108', NULL, NULL, NULL, NULL, 'NEUTRAL CHOLESTEROL ESTER HYDROLASE 1', 243532),
(340506, 'PTHR23024:SF106', NULL, NULL, NULL, NULL, 'ARYLACETAMIDE DEACETYLASE-LIKE 4', 243532),
(340507, 'PTHR23024:SF589', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 17-RELATED', 243532),
(340508, 'PTHR23024:SF468', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 2-RELATED', 243532),
(340509, 'PTHR23024:SF650', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340510, 'PTHR23024:SF533', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340511, 'PTHR23024:SF411', NULL, NULL, NULL, NULL, 'ISOPRENYLCYSTEINE ALPHA-CARBONYL METHYLESTERASE ICMEL2-RELATED', 243532),
(340512, 'PTHR23024:SF532', NULL, NULL, NULL, NULL, '2-HYDROXYISOFLAVANONE DEHYDRATASE-LIKE', 243532),
(340513, 'PTHR23024:SF652', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340514, 'PTHR23024:SF530', NULL, NULL, NULL, NULL, 'OS07G0643400 PROTEIN', 243532),
(340515, 'PTHR23024:SF651', NULL, NULL, NULL, NULL, 'GIBBERELLIN RECEPTOR GID1B-LIKE ISOFORM X1', 243532),
(340516, 'PTHR23024:SF416', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 15-RELATED', 243532),
(340517, 'PTHR23024:SF537', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340518, 'PTHR23024:SF415', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340519, 'PTHR23024:SF535', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340520, 'PTHR23024:SF413', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 2-RELATED', 243532),
(340521, 'PTHR23024:SF534', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340522, 'PTHR23024:SF418', NULL, NULL, NULL, NULL, 'OS09G0462100 PROTEIN', 243532),
(340523, 'PTHR23024:SF538', NULL, NULL, NULL, NULL, 'OS07G0643100 PROTEIN', 243532),
(340524, 'PTHR23024:SF522', NULL, NULL, NULL, NULL, '2-HYDROXYISOFLAVANONE DEHYDRATASE', 243532),
(340525, 'PTHR23024:SF643', NULL, NULL, NULL, NULL, 'AB HYDROLASE SUPERFAMILY PROTEIN B1A11.02', 243532),
(340526, 'PTHR23024:SF401', NULL, NULL, NULL, NULL, 'OS09G0460700 PROTEIN', 243532),
(340527, 'PTHR23024:SF642', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340528, 'PTHR23024:SF641', NULL, NULL, NULL, NULL, 'GIBBERELLIN RECEPTOR GID1L2', 243532),
(340529, 'PTHR23024:SF640', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 16-RELATED', 243532),
(340530, 'PTHR23024:SF647', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340531, 'PTHR23024:SF526', NULL, NULL, NULL, NULL, '2-HYDROXYISOFLAVANONE DEHYDRATASE-LIKE', 243532),
(340532, 'PTHR23024:SF646', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340533, 'PTHR23024:SF525', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340534, 'PTHR23024:SF403', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 243532),
(340535, 'PTHR23024:SF645', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340536, 'PTHR23024:SF644', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340537, 'PTHR23024:SF402', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340538, 'PTHR23024:SF409', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 6-RELATED', 243532),
(340539, 'PTHR23024:SF408', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(340540, 'PTHR23024:SF529', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 5-RELATED', 243532),
(340541, 'PTHR23024:SF407', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340542, 'PTHR23024:SF649', NULL, NULL, NULL, NULL, 'ISOPRENYLCYSTEINE ALPHA-CARBONYL METHYLESTERASE ICMEL2-RELATED', 243532),
(340543, 'PTHR23024:SF528', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340544, 'PTHR23024:SF648', NULL, NULL, NULL, NULL, 'ALPHA/BETA HYDROLASE FOLD PROTEIN', 243532),
(340545, 'PTHR23024:SF406', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 15-RELATED', 243532),
(340546, 'PTHR23024:SF527', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 11-RELATED', 243532),
(340547, 'PTHR23024:SF551', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340548, 'PTHR23024:SF430', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 15-RELATED', 243532),
(340549, 'PTHR23024:SF550', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 18-RELATED', 243532),
(340550, 'PTHR23024:SF555', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340551, 'PTHR23024:SF434', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340552, 'PTHR23024:SF432', NULL, NULL, NULL, NULL, 'OS11G0239500 PROTEIN', 243532),
(340553, 'PTHR23024:SF438', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340554, 'PTHR23024:SF558', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN-RELATED', 243532),
(340555, 'PTHR23024:SF557', NULL, NULL, NULL, NULL, 'AB HYDROLASE SUPERFAMILY PROTEIN C1039.03', 243532),
(340556, 'PTHR23024:SF556', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340557, 'PTHR23024:SF435', NULL, NULL, NULL, NULL, 'OS06G0214300 PROTEIN', 243532),
(340558, 'PTHR23024:SF544', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 1-RELATED', 243532),
(340559, 'PTHR23024:SF542', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340560, 'PTHR23024:SF421', NULL, NULL, NULL, NULL, '2-HYDROXYISOFLAVANONE DEHYDRATASE-LIKE', 243532),
(340561, 'PTHR23024:SF541', NULL, NULL, NULL, NULL, 'OS06G0214800 PROTEIN', 243532),
(340562, 'PTHR23024:SF547', NULL, NULL, NULL, NULL, 'ALPHA/BETA HYDROLASE FOLD PROTEIN-RELATED', 243532),
(340563, 'PTHR23024:SF546', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 120-RELATED', 243532),
(340564, 'PTHR23024:SF424', NULL, NULL, NULL, NULL, 'SI:DKEY-193C22.1', 243532),
(340565, 'PTHR23024:SF429', NULL, NULL, NULL, NULL, 'ALPHA/BETA HYDROLASE FOLD PROTEIN', 243532),
(340566, 'PTHR23024:SF171', NULL, NULL, NULL, NULL, 'OS09G0461900 PROTEIN', 243532),
(340567, 'PTHR23024:SF176', NULL, NULL, NULL, NULL, 'ACETYL ESTERASE', 243532),
(340568, 'PTHR23024:SF610', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340569, 'PTHR23024:SF178', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 2-RELATED', 243532),
(340570, 'PTHR23024:SF614', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 12-RELATED', 243532),
(340571, 'PTHR23024:SF613', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 15-RELATED', 243532),
(340572, 'PTHR23024:SF612', NULL, NULL, NULL, NULL, '', 243532),
(340573, 'PTHR23024:SF611', NULL, NULL, NULL, NULL, 'AADACL4 FAMILY MEMBER 4-RELATED', 243532),
(340574, 'PTHR23024:SF618', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE-LIKE PROTEIN', 243532),
(340575, 'PTHR23024:SF617', NULL, NULL, NULL, NULL, 'RECEPTOR GID1, PUTATIVE-RELATED', 243532),
(340576, 'PTHR23024:SF616', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340577, 'PTHR23024:SF615', NULL, NULL, NULL, NULL, 'ALPHA/BETA HYDROLASE FOLD PROTEIN-RELATED', 243532),
(340578, 'PTHR23024:SF619', NULL, NULL, NULL, NULL, 'CXE CARBOXYLESTERASE', 243532),
(340579, 'PTHR23024:SF180', NULL, NULL, NULL, NULL, 'OS02G0567800 PROTEIN', 243532),
(340580, 'PTHR23024:SF162', NULL, NULL, NULL, NULL, 'OS07G0162700 PROTEIN', 243532),
(340581, 'PTHR23024:SF166', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN-RELATED', 243532),
(340582, 'PTHR23024:SF165', NULL, NULL, NULL, NULL, 'OS09G0461500 PROTEIN', 243532);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(340583, 'PTHR23024:SF603', NULL, NULL, NULL, NULL, 'ARYLACETAMIDE DEACETYLASE-LIKE 4', 243532),
(340584, 'PTHR23024:SF600', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_1G02580)-RELATED', 243532),
(340585, 'PTHR23024:SF607', NULL, NULL, NULL, NULL, 'ISOPRENYLCYSTEINE ALPHA-CARBONYL METHYLESTERASE ICME-RELATED', 243532),
(340586, 'PTHR23024:SF609', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 18-RELATED', 243532),
(340587, 'PTHR23024:SF192', NULL, NULL, NULL, NULL, 'OS09G0455500 PROTEIN', 243532),
(340588, 'PTHR23024:SF511', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340589, 'PTHR23024:SF632', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 5-RELATED', 243532),
(340590, 'PTHR23024:SF631', NULL, NULL, NULL, NULL, 'PUTATIVE, EXPRESSED-RELATED', 243532),
(340591, 'PTHR23024:SF630', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340592, 'PTHR23024:SF636', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340593, 'PTHR23024:SF514', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340594, 'PTHR23024:SF635', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340595, 'PTHR23024:SF513', NULL, NULL, NULL, NULL, 'BNAA02G33300D PROTEIN', 243532),
(340596, 'PTHR23024:SF634', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340597, 'PTHR23024:SF633', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340598, 'PTHR23024:SF512', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340599, 'PTHR23024:SF639', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 11-RELATED', 243532),
(340600, 'PTHR23024:SF517', NULL, NULL, NULL, NULL, 'OS06G0306600 PROTEIN', 243532),
(340601, 'PTHR23024:SF638', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 12-RELATED', 243532),
(340602, 'PTHR23024:SF637', NULL, NULL, NULL, NULL, 'CHROMOSOME 15, WHOLE GENOME SHOTGUN SEQUENCE', 243532),
(340603, 'PTHR23024:SF182', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_3G14960)-RELATED', 243532),
(340604, 'PTHR23024:SF621', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 2-RELATED', 243532),
(340605, 'PTHR23024:SF500', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340606, 'PTHR23024:SF620', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 15-RELATED', 243532),
(340607, 'PTHR23024:SF504', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340608, 'PTHR23024:SF625', NULL, NULL, NULL, NULL, '', 243532),
(340609, 'PTHR23024:SF624', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340610, 'PTHR23024:SF623', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340611, 'PTHR23024:SF502', NULL, NULL, NULL, NULL, 'PEPPER ESTERASE', 243532),
(340612, 'PTHR23024:SF24', NULL, NULL, NULL, NULL, 'ARYLACETAMIDE DEACETYLASE', 243532),
(340613, 'PTHR23024:SF622', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 120-RELATED', 243532),
(340614, 'PTHR23024:SF629', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN-RELATED', 243532),
(340615, 'PTHR23024:SF508', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340616, 'PTHR23024:SF628', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340617, 'PTHR23024:SF507', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 3-RELATED', 243532),
(340618, 'PTHR23024:SF627', NULL, NULL, NULL, NULL, 'KYNURENINE FORMAMIDASE', 243532),
(340619, 'PTHR23024:SF626', NULL, NULL, NULL, NULL, '', 243532),
(340620, 'PTHR23024:SF492', NULL, NULL, NULL, NULL, 'GIBBERELLIN RECEPTOR GID1C', 243532),
(340621, 'PTHR23024:SF490', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340622, 'PTHR23024:SF496', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340623, 'PTHR23024:SF494', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340624, 'PTHR23024', NULL, NULL, NULL, NULL, 'ARYLACETAMIDE DEACETYLASE', 243532);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(340625, 'PTHR23024:SF379', NULL, NULL, NULL, NULL, 'OS07G0606800 PROTEIN', 243532),
(340626, 'PTHR23024:SF378', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340627, 'PTHR23024:SF257', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340628, 'PTHR23024:SF135', NULL, NULL, NULL, NULL, 'CELL DEATH ASSOCIATED PROTEIN', 243532),
(340629, 'PTHR23024:SF134', NULL, NULL, NULL, NULL, 'OS08G0475100 PROTEIN', 243532),
(340630, 'PTHR23024:SF139', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 15-RELATED', 243532),
(340631, 'PTHR23024:SF480', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340632, 'PTHR23024:SF485', NULL, NULL, NULL, NULL, 'GIBBERELLIN RECEPTOR GID1A', 243532),
(340633, 'PTHR23024:SF242', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN-RELATED', 243532),
(340634, 'PTHR23024:SF247', NULL, NULL, NULL, NULL, 'AADACL4 FAMILY MEMBER 2', 243532),
(340635, 'PTHR23024:SF368', NULL, NULL, NULL, NULL, '2-HYDROXYISOFLAVANONE DEHYDRATASE', 243532),
(340636, 'PTHR23024:SF488', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340637, 'PTHR23024:SF124', NULL, NULL, NULL, NULL, 'AADACL2 FAMILY MEMBER 1', 243532),
(340638, 'PTHR23024:SF366', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 2-RELATED', 243532),
(340639, 'PTHR23024:SF486', NULL, NULL, NULL, NULL, 'PROTEIN CBG16012', 243532),
(340640, 'PTHR23024:SF365', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 2-RELATED', 243532),
(340641, 'PTHR23024:SF393', NULL, NULL, NULL, NULL, 'OS08G0547800 PROTEIN', 243532),
(340642, 'PTHR23024:SF392', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 2-RELATED', 243532),
(340643, 'PTHR23024:SF397', NULL, NULL, NULL, NULL, 'PUTATIVE, EXPRESSED-RELATED', 243532),
(340644, 'PTHR23024:SF396', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340645, 'PTHR23024:SF152', NULL, NULL, NULL, NULL, 'OS07G0643700 PROTEIN', 243532),
(340646, 'PTHR23024:SF398', NULL, NULL, NULL, NULL, 'OS07G0526600 PROTEIN', 243532),
(340647, 'PTHR23024:SF140', NULL, NULL, NULL, NULL, 'OS07G0162600 PROTEIN', 243532),
(340648, 'PTHR23024:SF385', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 243532),
(340649, 'PTHR23024:SF384', NULL, NULL, NULL, NULL, '2-HYDROXYISOFLAVANONE DEHYDRATASE', 243532),
(340650, 'PTHR23024:SF146', NULL, NULL, NULL, NULL, 'OS08G0474866 PROTEIN', 243532),
(340651, 'PTHR23024:SF149', NULL, NULL, NULL, NULL, 'OS07G0162500 PROTEIN', 243532),
(340652, 'PTHR47110', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC EXPRESSED PROTEIN 55', 243533),
(340653, 'PTHR47110:SF1', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC EXPRESSED PROTEIN 55', 243533),
(340654, 'PTHR47110:SF2', NULL, NULL, NULL, NULL, 'UROPLAKIN-1B', 243533),
(340655, 'PTHR47110:SF3', NULL, NULL, NULL, NULL, '', 243533),
(340656, 'PTHR35630:SF2', NULL, NULL, NULL, NULL, 'LEGUMINOSIN GROUP486 SECRETED PEPTIDE', 243534),
(340657, 'PTHR35630', NULL, NULL, NULL, NULL, 'LEGUMINOSIN GROUP486 SECRETED PEPTIDE', 243534),
(340658, 'PTHR35630:SF1', NULL, NULL, NULL, NULL, 'LEGUMINOSIN GROUP486 SECRETED PEPTIDE', 243534),
(340659, 'PTHR48209:SF2', NULL, NULL, NULL, NULL, 'FI24008P1', 243535),
(340660, 'PTHR48209', NULL, NULL, NULL, NULL, 'AGL056WP', 243535),
(340661, 'PTHR34490', NULL, NULL, NULL, NULL, 'PROTEIN CBG12054-RELATED', 243536),
(340662, 'PTHR34490:SF1', NULL, NULL, NULL, NULL, '', 243536),
(340663, 'PTHR34490:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG12054', 243536),
(340664, 'PTHR36763', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243537),
(340665, 'PTHR36763:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243537),
(340666, 'PTHR34156:SF4', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', 243538),
(340667, 'PTHR34156:SF5', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN-RELATED', 243538),
(340668, 'PTHR34156:SF2', NULL, NULL, NULL, NULL, 'PROTEIN YDGH', 243538),
(340669, 'PTHR34156:SF3', NULL, NULL, NULL, NULL, 'PERIPLASMIC PROTEIN-RELATED', 243538),
(340670, 'PTHR34156:SF8', NULL, NULL, NULL, NULL, 'PERIPLASMIC PROTEIN-RELATED', 243538);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(340671, 'PTHR34156:SF11', NULL, NULL, NULL, NULL, 'LIPOPROTEIN BSMA', 243538),
(340672, 'PTHR34156:SF9', NULL, NULL, NULL, NULL, 'SECRETED PROTEIN-RELATED', 243538),
(340673, 'PTHR34156:SF6', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN-RELATED', 243538),
(340674, 'PTHR34156:SF10', NULL, NULL, NULL, NULL, 'MULTIPLE STRESS RESISTANCE PROTEIN BHSA', 243538),
(340675, 'PTHR34156', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN-RELATED-RELATED', 243538),
(340676, 'PTHR34156:SF1', NULL, NULL, NULL, NULL, 'PERIPLASMIC PROTEIN-RELATED', 243538),
(340677, 'PTHR24212:SF1', NULL, NULL, NULL, NULL, 'ZYXIN', 243539),
(340678, 'PTHR24212:SF7', NULL, NULL, NULL, NULL, 'THYROID RECEPTOR-INTERACTING PROTEIN 6', 243539),
(340679, 'PTHR24212:SF8', NULL, NULL, NULL, NULL, 'LIM DOMAIN CONTAINING PROTEIN', 243539),
(340680, 'PTHR24212', NULL, NULL, NULL, NULL, 'ZYXIN/TRIP6', 243539),
(340681, 'PTHR30409', NULL, NULL, NULL, NULL, 'CARBAMATE KINASE', 243540),
(340682, 'PTHR30409:SF1', NULL, NULL, NULL, NULL, 'CARBAMATE KINASE-RELATED', 243540),
(340683, 'PTHR22607', NULL, NULL, NULL, NULL, 'DELETED IN ORAL CANCER 1/CDK2-ASSOCIATED PROTEIN 1', 243541),
(340684, 'PTHR22607:SF3', NULL, NULL, NULL, NULL, 'CDK2-ASSOCIATED PROTEIN 1, ISOFORM B', 243541),
(340685, 'PTHR22607:SF2', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 2-ASSOCIATED PROTEIN 1', 243541),
(340686, 'PTHR22607:SF4', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 2-ASSOCIATED PROTEIN 2', 243541),
(340687, 'PTHR31836:SF21', NULL, NULL, NULL, NULL, 'EXPANSIN-LIKE PROTEIN 7', 243542),
(340688, 'PTHR31836:SF22', NULL, NULL, NULL, NULL, '', 243542),
(340689, 'PTHR31836:SF11', NULL, NULL, NULL, NULL, 'EXPANSIN-LIKE PROTEIN 8-RELATED', 243542),
(340690, 'PTHR31836', NULL, NULL, NULL, NULL, '', 243542),
(340691, 'PTHR31836:SF29', NULL, NULL, NULL, NULL, 'DPBB_1 DOMAIN-CONTAINING PROTEIN', 243542),
(340692, 'PTHR31836:SF28', NULL, NULL, NULL, NULL, 'SRCR DOMAIN-CONTAINING PROTEIN-RELATED', 243542),
(340693, 'PTHR31836:SF19', NULL, NULL, NULL, NULL, 'EXPANSIN-LIKE PROTEIN 1', 243542),
(340694, 'PTHR31836:SF3', NULL, NULL, NULL, NULL, 'EXPANSIN-LIKE PROTEIN 9', 243542),
(340695, 'PTHR31836:SF25', NULL, NULL, NULL, NULL, 'DPBB_1 DOMAIN-CONTAINING PROTEIN', 243542),
(340696, 'PTHR31836:SF24', NULL, NULL, NULL, NULL, 'DPBB_1 DOMAIN-CONTAINING PROTEIN', 243542),
(340697, 'PTHR31836:SF2', NULL, NULL, NULL, NULL, 'EXPANSIN-LIKE PROTEIN 3-RELATED', 243542),
(340698, 'PTHR31836:SF27', NULL, NULL, NULL, NULL, 'DPBB_1 DOMAIN-CONTAINING PROTEIN', 243542),
(340699, 'PTHR31836:SF26', NULL, NULL, NULL, NULL, 'EXPANSIN-LIKE PROTEIN 2', 243542),
(340700, 'PTHR21177:SF4', NULL, NULL, NULL, NULL, 'IP06524P', 243543),
(340701, 'PTHR21177:SF6', NULL, NULL, NULL, NULL, 'GH11627P', 243543),
(340702, 'PTHR21177', NULL, NULL, NULL, NULL, 'IP06524P-RELATED', 243543),
(340703, 'PTHR22198:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG14274', 243544),
(340704, 'PTHR22198:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG01202', 243544),
(340705, 'PTHR22198', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243544),
(340706, 'PTHR36069:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243545),
(340707, 'PTHR36069', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', 243545),
(340708, 'PTHR36069:SF6', NULL, NULL, NULL, NULL, 'FAS1 DOMAIN-CONTAINING PROTEIN', 243545),
(340709, 'PTHR36069:SF3', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN FAMILY PROTEIN, PUTATIVE-RELATED', 243545),
(340710, 'PTHR36069:SF4', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN FAMILY PROTEIN', 243545),
(340711, 'PTHR46212:SF8', NULL, NULL, NULL, NULL, '', 243546),
(340712, 'PTHR46212:SF9', NULL, NULL, NULL, NULL, 'PROGRAMMED CELL DEATH PROTEIN 6', 243546),
(340713, 'PTHR46212:SF3', NULL, NULL, NULL, NULL, 'PEFLIN', 243546),
(340714, 'PTHR46212', NULL, NULL, NULL, NULL, 'PEFLIN', 243546),
(340715, 'PTHR37210', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243547),
(340716, 'PTHR37210:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243547),
(340717, 'PTHR37210:SF5', NULL, NULL, NULL, NULL, '', 243547),
(340718, 'PTHR34108', NULL, NULL, NULL, NULL, 'SEPTUM SITE-DETERMINING PROTEIN MINC', 243548);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(340719, 'PTHR34108:SF1', NULL, NULL, NULL, NULL, 'SEPTUM SITE-DETERMINING PROTEIN MINC', 243548),
(340720, 'PTHR21243:SF18', NULL, NULL, NULL, NULL, 'TRANSDUCER, PUTATIVE (DUF3550/UPF0682)-RELATED', 243549),
(340721, 'PTHR21243:SF15', NULL, NULL, NULL, NULL, 'PROTEIN SCAI', 243549),
(340722, 'PTHR21243:SF22', NULL, NULL, NULL, NULL, '', 243549),
(340723, 'PTHR21243', NULL, NULL, NULL, NULL, 'PROTEIN SCAI', 243549),
(340724, 'PTHR48188', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L43', 243550),
(340725, 'PTHR48188:SF2', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L37A-LIKE PROTEIN-RELATED', 243550),
(340726, 'PTHR48188:SF3', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L37A', 243550),
(340727, 'PTHR48188:SF1', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L37A', 243550),
(340728, 'PTHR22245:SF4', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4921524L21 GENE', 243551),
(340729, 'PTHR22245:SF3', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 144A-RELATED', 243551),
(340730, 'PTHR22245', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243551),
(340731, 'PTHR31240:SF0', NULL, NULL, NULL, NULL, 'MATERNAL EFFECT EMBRYO ARREST 18', 243552),
(340732, 'PTHR31240', NULL, NULL, NULL, NULL, 'MATERNAL EFFECT EMBRYO ARREST 18', 243552),
(340733, 'PTHR45770:SF17', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE', 243553),
(340734, 'PTHR45770:SF39', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE', 243553),
(340735, 'PTHR45770:SF15', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE', 243553),
(340736, 'PTHR45770:SF38', NULL, NULL, NULL, NULL, 'PFK DOMAIN-CONTAINING PROTEIN', 243553),
(340737, 'PTHR45770:SF9', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE 2', 243553),
(340738, 'PTHR45770', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE 1', 243553),
(340739, 'PTHR45770:SF2', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE 4, CHLOROPLASTIC', 243553),
(340740, 'PTHR45770:SF31', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE', 243553),
(340741, 'PTHR45770:SF10', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE', 243553),
(340742, 'PTHR45770:SF30', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE', 243553),
(340743, 'PTHR45770:SF36', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE', 243553),
(340744, 'PTHR45770:SF14', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE', 243553),
(340745, 'PTHR45770:SF33', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE', 243553),
(340746, 'PTHR45770:SF11', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE 1', 243553),
(340747, 'PTHR45770:SF34', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE 7', 243553),
(340748, 'PTHR45770:SF12', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE', 243553),
(340749, 'PTHR45770:SF29', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE', 243553),
(340750, 'PTHR45770:SF26', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE 3', 243553),
(340751, 'PTHR45770:SF27', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE', 243553),
(340752, 'PTHR45770:SF20', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE', 243553),
(340753, 'PTHR45770:SF21', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE 3-LIKE', 243553),
(340754, 'PTHR45770:SF46', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE', 243553),
(340755, 'PTHR45770:SF25', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE 1', 243553),
(340756, 'PTHR45770:SF44', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE 6', 243553),
(340757, 'PTHR45770:SF23', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE 5, CHLOROPLASTIC', 243553),
(340758, 'PTHR45770:SF45', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE', 243553),
(340759, 'PTHR22906:SF29', NULL, NULL, NULL, NULL, 'PROTEIN CBG15924', 243554),
(340760, 'PTHR22906', NULL, NULL, NULL, NULL, 'PROPERDIN', 243554),
(340761, 'PTHR22906:SF44', NULL, NULL, NULL, NULL, '', 243554);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(340762, 'PTHR22906:SF34', NULL, NULL, NULL, NULL, 'APPLE DOMAIN-CONTAINING PROTEIN', 243554),
(340763, 'PTHR22906:SF45', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 243554),
(340764, 'PTHR22906:SF42', NULL, NULL, NULL, NULL, 'ABNORMAL CELL MIGRATION PROTEIN 21', 243554),
(340765, 'PTHR22906:SF21', NULL, NULL, NULL, NULL, 'ADHESION G PROTEIN-COUPLED RECEPTOR B1', 243554),
(340766, 'PTHR22906:SF43', NULL, NULL, NULL, NULL, 'PROPERDIN', 243554),
(340767, 'PTHR43760:SF1', NULL, NULL, NULL, NULL, 'YJGF_ENDORIBONC DOMAIN-CONTAINING PROTEIN', 243555),
(340768, 'PTHR43760', NULL, NULL, NULL, NULL, 'ENDORIBONUCLEASE-RELATED', 243555),
(340769, 'PTHR47132:SF1', NULL, NULL, NULL, NULL, 'MYOGLOBIN', 243556),
(340770, 'PTHR47132', NULL, NULL, NULL, NULL, 'MYOGLOBIN', 243556),
(340771, 'PTHR47677:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY FACTOR 6', 243557),
(340772, 'PTHR47677', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY FACTOR 6', 243557),
(340773, 'PTHR11947:SF19', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE KINASE', 243558),
(340774, 'PTHR11947:SF39', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE KINASE', 243558),
(340775, 'PTHR11947:SF14', NULL, NULL, NULL, NULL, '[PYRUVATE DEHYDROGENASE (ACETYL-TRANSFERRING)] KINASE ISOZYME 1, MITOCHONDRIAL', 243558),
(340776, 'PTHR11947:SF25', NULL, NULL, NULL, NULL, '[PYRUVATE DEHYDROGENASE (ACETYL-TRANSFERRING)] KINASE 2, MITOCHONDRIAL', 243558),
(340777, 'PTHR11947:SF15', NULL, NULL, NULL, NULL, '[PYRUVATE DEHYDROGENASE (ACETYL-TRANSFERRING)] KINASE ISOZYME 2, MITOCHONDRIAL', 243558),
(340778, 'PTHR11947:SF24', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE KINASE', 243558),
(340779, 'PTHR11947', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE KINASE', 243558),
(340780, 'PTHR11947:SF21', NULL, NULL, NULL, NULL, '[PYRUVATE DEHYDROGENASE (ACETYL-TRANSFERRING)] KINASE ISOZYME 3, MITOCHONDRIAL', 243558),
(340781, 'PTHR11947:SF22', NULL, NULL, NULL, NULL, '[PYRUVATE DEHYDROGENASE (ACETYL-TRANSFERRING)] KINASE ISOZYME 4, MITOCHONDRIAL', 243558),
(340782, 'PTHR11947:SF41', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE KINASE', 243558),
(340783, 'PTHR11947:SF20', NULL, NULL, NULL, NULL, '[3-METHYL-2-OXOBUTANOATE DEHYDROGENASE [LIPOAMIDE]] KINASE, MITOCHONDRIAL', 243558),
(340784, 'PTHR11947:SF42', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE KINASE', 243558),
(340785, 'PTHR11947:SF3', NULL, NULL, NULL, NULL, '[PYRUVATE DEHYDROGENASE (ACETYL-TRANSFERRING)] KINASE, MITOCHONDRIAL', 243558),
(340786, 'PTHR11947:SF40', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE KINASE', 243558),
(340787, 'PTHR10125:SF30', NULL, NULL, NULL, NULL, 'P2X PURINOCEPTOR', 243559),
(340788, 'PTHR10125:SF8', NULL, NULL, NULL, NULL, 'P2X PURINOCEPTOR 3', 243559),
(340789, 'PTHR10125:SF9', NULL, NULL, NULL, NULL, 'P2X PURINOCEPTOR 1', 243559),
(340790, 'PTHR10125:SF12', NULL, NULL, NULL, NULL, 'P2X PURINOCEPTOR 5', 243559),
(340791, 'PTHR10125:SF31', NULL, NULL, NULL, NULL, 'P2X RECEPTOR E', 243559),
(340792, 'PTHR10125:SF21', NULL, NULL, NULL, NULL, 'P2X PURINOCEPTOR 6', 243559),
(340793, 'PTHR10125:SF27', NULL, NULL, NULL, NULL, 'P2X RECEPTOR A-RELATED', 243559),
(340794, 'PTHR10125:SF13', NULL, NULL, NULL, NULL, 'P2X PURINOCEPTOR 7', 243559),
(340795, 'PTHR10125', NULL, NULL, NULL, NULL, 'P2X PURINOCEPTOR', 243559),
(340796, 'PTHR10125:SF4', NULL, NULL, NULL, NULL, 'P2X PURINOCEPTOR 2', 243559),
(340797, 'PTHR10125:SF29', NULL, NULL, NULL, NULL, '', 243559),
(340798, 'PTHR10125:SF18', NULL, NULL, NULL, NULL, 'P2X PURINOCEPTOR 4', 243559),
(340799, 'PTHR32145:SF11', NULL, NULL, NULL, NULL, 'DIFLAVIN FLAVOPROTEIN A 2-RELATED', 243560),
(340800, 'PTHR32145:SF31', NULL, NULL, NULL, NULL, 'FLAVIN REDUCTASE-LIKE FMN-BINDING PROTEIN', 243560),
(340801, 'PTHR32145', NULL, NULL, NULL, NULL, 'DIFLAVIN FLAVOPROTEIN A 2-RELATED', 243560),
(340802, 'PTHR32145:SF20', NULL, NULL, NULL, NULL, 'FLAVOPROTEIN-RELATED', 243560),
(340803, 'PTHR32145:SF32', NULL, NULL, NULL, NULL, 'DIFLAVIN FLAVOPROTEIN A 4-RELATED', 243560),
(340804, 'PTHR34478:SF2', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 243561);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(340805, 'PTHR34478:SF1', NULL, NULL, NULL, NULL, 'PROTEIN LEMA', 243561),
(340806, 'PTHR34478', NULL, NULL, NULL, NULL, 'PROTEIN LEMA', 243561),
(340807, 'PTHR33693:SF1', NULL, NULL, NULL, NULL, 'TYPE-4 URACIL-DNA GLYCOSYLASE', 243562),
(340808, 'PTHR33693', NULL, NULL, NULL, NULL, 'TYPE-5 URACIL-DNA GLYCOSYLASE', 243562),
(340809, 'PTHR33693:SF3', NULL, NULL, NULL, NULL, 'TYPE-5 URACIL-DNA GLYCOSYLASE', 243562),
(340810, 'PTHR33693:SF8', NULL, NULL, NULL, NULL, 'TYPE-4 URACIL-DNA GLYCOSYLASE', 243562),
(340811, 'PTHR28093:SF1', NULL, NULL, NULL, NULL, 'MORPHOGENESIS-RELATED PROTEIN MSB1', 243563),
(340812, 'PTHR28093', NULL, NULL, NULL, NULL, 'MORPHOGENESIS-RELATED PROTEIN MSB1', 243563),
(340813, 'PTHR46624', NULL, NULL, NULL, NULL, 'AGAP002036-PA', 243564),
(340814, 'PTHR46624:SF3', NULL, NULL, NULL, NULL, 'ZINC FINGER FYVE DOMAIN-CONTAINING PROTEIN 1', 243564),
(340815, 'PTHR46624:SF4', NULL, NULL, NULL, NULL, 'ZINC FINGER FYVE DOMAIN-CONTAINING PROTEIN 1-LIKE PROTEIN', 243564),
(340816, 'PTHR46624:SF2', NULL, NULL, NULL, NULL, 'SI:CH211-11N16.2', 243564),
(340817, 'PTHR46574', NULL, NULL, NULL, NULL, '43 KDA RECEPTOR-ASSOCIATED PROTEIN OF THE SYNAPSE', 243565),
(340818, 'PTHR46574:SF1', NULL, NULL, NULL, NULL, '43 KDA RECEPTOR-ASSOCIATED PROTEIN OF THE SYNAPSE', 243565),
(340819, 'PTHR16071', NULL, NULL, NULL, NULL, 'CHROMOSOME 1 OPEN READING FRAME 112', 243566),
(340820, 'PTHR16071:SF2', NULL, NULL, NULL, NULL, 'CHROMOSOME 1 OPEN READING FRAME 112', 243566),
(340821, 'PTHR43651:SF10', NULL, NULL, NULL, NULL, 'AAMY DOMAIN-CONTAINING PROTEIN', 243567),
(340822, 'PTHR43651:SF8', NULL, NULL, NULL, NULL, 'AAMY DOMAIN-CONTAINING PROTEIN', 243567),
(340823, 'PTHR43651:SF9', NULL, NULL, NULL, NULL, '1,4-ALPHA-GLUCAN-BRANCHING ENZYME 2-1, CHLOROPLASTIC/AMYLOPLASTIC', 243567),
(340824, 'PTHR43651:SF11', NULL, NULL, NULL, NULL, 'MALTO-OLIGOSYLTREHALOSE TREHALOHYDROLASE', 243567),
(340825, 'PTHR43651:SF4', NULL, NULL, NULL, NULL, '1,4-ALPHA-GLUCAN-BRANCHING ENZYME 3, CHLOROPLASTIC/AMYLOPLASTIC', 243567),
(340826, 'PTHR43651:SF13', NULL, NULL, NULL, NULL, '1,4-ALPHA-GLUCAN-BRANCHING ENZYME 2, CHLOROPLASTIC/AMYLOPLASTIC', 243567),
(340827, 'PTHR43651:SF2', NULL, NULL, NULL, NULL, '1,4-ALPHA-GLUCAN-BRANCHING ENZYME, CHLOROPLASTIC/AMYLOPLASTIC', 243567),
(340828, 'PTHR43651', NULL, NULL, NULL, NULL, '1,4-ALPHA-GLUCAN-BRANCHING ENZYME', 243567),
(340829, 'PTHR43651:SF3', NULL, NULL, NULL, NULL, '1,4-ALPHA-GLUCAN-BRANCHING ENZYME', 243567),
(340830, 'PTHR37024:SF5', NULL, NULL, NULL, NULL, 'IMPA_N DOMAIN-CONTAINING PROTEIN', 243568),
(340831, 'PTHR37024:SF3', NULL, NULL, NULL, NULL, 'IMPA_N DOMAIN-CONTAINING PROTEIN', 243568),
(340832, 'PTHR37024', NULL, NULL, NULL, NULL, 'TYPE VI SECRETION SYSTEM DUF2094 AND IMPA-RELATED DOMAIN PROTEIN', 243568),
(340833, 'PTHR28064:SF1', NULL, NULL, NULL, NULL, 'INNER KINETOCHORE SUBUNIT NKP2', 243569),
(340834, 'PTHR28064', NULL, NULL, NULL, NULL, 'INNER KINETOCHORE SUBUNIT NKP2', 243569),
(340835, 'PTHR13350', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243570),
(340836, 'PTHR13350:SF1', NULL, NULL, NULL, NULL, 'INTEGRATOR COMPLEX SUBUNIT 8', 243570),
(340837, 'PTHR15653:SF2', NULL, NULL, NULL, NULL, 'STRIATIN', 243571),
(340838, 'PTHR15653:SF1', NULL, NULL, NULL, NULL, 'STRIATIN-4', 243571),
(340839, 'PTHR15653:SF0', NULL, NULL, NULL, NULL, 'CONNECTOR OF KINASE TO AP-1, ISOFORM E', 243571),
(340840, 'PTHR15653', NULL, NULL, NULL, NULL, 'STRIATIN', 243571),
(340841, 'PTHR15653:SF3', NULL, NULL, NULL, NULL, 'STRIATIN-3', 243571),
(340842, 'PTHR12227', NULL, NULL, NULL, NULL, 'GLYCERATE KINASE', 243572),
(340843, 'PTHR12227:SF0', NULL, NULL, NULL, NULL, 'GLYCERATE KINASE', 243572),
(340844, 'PTHR11994:SF11', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L5, MITOCHONDRIAL', 243573),
(340845, 'PTHR11994:SF32', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L11-2', 243573),
(340846, 'PTHR11994:SF43', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L5-RELATED', 243573),
(340847, 'PTHR11994:SF31', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L11-1', 243573),
(340848, 'PTHR11994:SF20', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L5_C DOMAIN-CONTAINING PROTEIN', 243573);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(340849, 'PTHR11994:SF42', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 243573),
(340850, 'PTHR11994:SF30', NULL, NULL, NULL, NULL, 'BNAA09G55240D PROTEIN', 243573),
(340851, 'PTHR11994:SF41', NULL, NULL, NULL, NULL, '', 243573),
(340852, 'PTHR11994:SF28', NULL, NULL, NULL, NULL, 'OS01G0205500 PROTEIN', 243573),
(340853, 'PTHR11994:SF39', NULL, NULL, NULL, NULL, 'OS02G0235600 PROTEIN', 243573),
(340854, 'PTHR11994:SF4', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN L7, MITOCHONDRIAL', 243573),
(340855, 'PTHR11994:SF17', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L11-1', 243573),
(340856, 'PTHR11994:SF27', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L11', 243573),
(340857, 'PTHR11994:SF38', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L11-1', 243573),
(340858, 'PTHR11994:SF26', NULL, NULL, NULL, NULL, '', 243573),
(340859, 'PTHR11994:SF24', NULL, NULL, NULL, NULL, '', 243573),
(340860, 'PTHR11994:SF23', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L11', 243573),
(340861, 'PTHR11994:SF8', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L11', 243573),
(340862, 'PTHR11994', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L11-RELATED', 243573),
(340863, 'PTHR21451:SF19', NULL, NULL, NULL, NULL, 'ACTIVATED IN BLOCKED UNFOLDED PROTEIN RESPONSE', 243574),
(340864, 'PTHR21451', NULL, NULL, NULL, NULL, 'HISTONE H3 METHYLTRANSFERASE', 243574),
(340865, 'PTHR21451:SF22', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE, H3 LYSINE-79 SPECIFIC', 243574),
(340866, 'PTHR21451:SF0', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE, H3 LYSINE-79 SPECIFIC', 243574),
(340867, 'PTHR33606:SF3', NULL, NULL, NULL, NULL, 'PROTEIN YCII', 243575),
(340868, 'PTHR33606', NULL, NULL, NULL, NULL, 'PROTEIN YCII', 243575),
(340869, 'PTHR28012', NULL, NULL, NULL, NULL, 'NUCLEAR FUSION PROTEIN KAR5', 243576),
(340870, 'PTHR28012:SF1', NULL, NULL, NULL, NULL, 'NUCLEAR FUSION PROTEIN KAR5', 243576),
(340871, 'PTHR48112:SF5', NULL, NULL, NULL, NULL, 'BOX PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G04550)-RELATED', 243577),
(340872, 'PTHR48112:SF6', NULL, NULL, NULL, NULL, '', 243577),
(340873, 'PTHR48112:SF7', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP PROTEIN B4', 243577),
(340874, 'PTHR48112:SF8', NULL, NULL, NULL, NULL, '', 243577),
(340875, 'PTHR48112:SF18', NULL, NULL, NULL, NULL, '', 243577),
(340876, 'PTHR48112:SF15', NULL, NULL, NULL, NULL, 'HMG BOX DOMAIN-CONTAINING PROTEIN', 243577),
(340877, 'PTHR48112:SF14', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP PROTEIN B3', 243577),
(340878, 'PTHR48112:SF17', NULL, NULL, NULL, NULL, 'INTRASTRAND CROSS-LINK RECOGNITION PROTEIN', 243577),
(340879, 'PTHR48112:SF3', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP PROTEIN B2', 243577),
(340880, 'PTHR48112:SF4', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP PROTEIN B1-LIKE 1-RELATED', 243577),
(340881, 'PTHR48112:SF16', NULL, NULL, NULL, NULL, '', 243577),
(340882, 'PTHR48112:SF11', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP PROTEIN B1', 243577),
(340883, 'PTHR48112:SF33', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP PROTEIN B1', 243577),
(340884, 'PTHR48112:SF32', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP PROTEIN DSP1', 243577),
(340885, 'PTHR48112:SF13', NULL, NULL, NULL, NULL, 'NON-HISTONE PROTEIN 10', 243577),
(340886, 'PTHR48112:SF12', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP PROTEIN B1', 243577),
(340887, 'PTHR48112:SF34', NULL, NULL, NULL, NULL, 'HMG BOX-CONTAINING PROTEIN 5', 243577),
(340888, 'PTHR48112:SF31', NULL, NULL, NULL, NULL, '', 243577),
(340889, 'PTHR48112', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP PROTEIN DSP1', 243577),
(340890, 'PTHR48112:SF28', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP BOX 1B', 243577),
(340891, 'PTHR48112:SF22', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR A, MITOCHONDRIAL', 243577),
(340892, 'PTHR48112:SF21', NULL, NULL, NULL, NULL, 'HMG BOX DOMAIN-CONTAINING PROTEIN', 243577),
(340893, 'PTHR48112:SF24', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP PROTEIN 1', 243577),
(340894, 'PTHR48112:SF23', NULL, NULL, NULL, NULL, '', 243577);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(340895, 'PTHR48112:SF20', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP PROTEIN D-RELATED', 243577),
(340896, 'PTHR35484:SF2', NULL, NULL, NULL, NULL, 'OUTER ENVELOPE PORE PROTEIN 37, CHLOROPLASTIC', 243578),
(340897, 'PTHR35484:SF1', NULL, NULL, NULL, NULL, 'OUTER ENVELOPE PORE PROTEIN 37 CHLOROPLASTIC', 243578),
(340898, 'PTHR35484', NULL, NULL, NULL, NULL, 'OUTER ENVELOPE PORE PROTEIN 37, CHLOROPLASTIC', 243578),
(340899, 'PTHR23422:SF9', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 3', 243579),
(340900, 'PTHR23422:SF14', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE-RELATED', 243579),
(340901, 'PTHR23422:SF11', NULL, NULL, NULL, NULL, 'DIPEPTIDYL PEPTIDASE 3', 243579),
(340902, 'PTHR23422', NULL, NULL, NULL, NULL, 'DIPEPTIDYL PEPTIDASE III-RELATED', 243579),
(340903, 'PTHR10587:SF129', NULL, NULL, NULL, NULL, 'POLYSACCHARIDE DEACETYLASE', 243580),
(340904, 'PTHR10587:SF105', NULL, NULL, NULL, NULL, '4-DEOXY-4-FORMAMIDO-L-ARABINOSE-PHOSPHOUNDECAPRENOL DEFORMYLASE ARND-RELATED', 243580),
(340905, 'PTHR10587:SF128', NULL, NULL, NULL, NULL, 'POLYSACCHARIDE DEACETYLASE PDAB-RELATED', 243580),
(340906, 'PTHR10587:SF80', NULL, NULL, NULL, NULL, 'CHITOOLIGOSACCHARIDE DEACETYLASE', 243580),
(340907, 'PTHR10587:SF78', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN-N-ACETYLMURAMIC ACID DEACETYLASE PDAA', 243580),
(340908, 'PTHR10587:SF98', NULL, NULL, NULL, NULL, 'CHITIN DEACETYLASE', 243580),
(340909, 'PTHR10587:SF132', NULL, NULL, NULL, NULL, 'POSSIBLE GLYCOSYL HYDROLASE', 243580),
(340910, 'PTHR10587:SF133', NULL, NULL, NULL, NULL, 'CHITIN DEACETYLASE 1-RELATED', 243580),
(340911, 'PTHR10587', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE-RELATED', 243580),
(340912, 'PTHR10587:SF136', NULL, NULL, NULL, NULL, 'SECRETED DEACETYLASE-RELATED', 243580),
(340913, 'PTHR10587:SF125', NULL, NULL, NULL, NULL, 'POLYSACCHARIDE DEACETYLASE YHEN-RELATED', 243580),
(340914, 'PTHR10587:SF134', NULL, NULL, NULL, NULL, 'LIPOPROTEIN-RELATED', 243580),
(340915, 'PTHR10587:SF135', NULL, NULL, NULL, NULL, 'CHITIN DEACETYLASE 3', 243580),
(340916, 'PTHR23122:SF7', NULL, NULL, NULL, NULL, 'PERIPHERAL PLASMA MEMBRANE PROTEIN CASK', 243581),
(340917, 'PTHR23122', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED GUANYLATE KINASE  MAGUK', 243581),
(340918, 'PTHR23122:SF39', NULL, NULL, NULL, NULL, 'MAGUK P55 SUBFAMILY MEMBER 7', 243581),
(340919, 'PTHR23122:SF33', NULL, NULL, NULL, NULL, 'MAGUK P55 SUBFAMILY MEMBER 3', 243581),
(340920, 'PTHR23122:SF44', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN, PALMITOYLATED 6A (MAGUK P55 SUBFAMILY MEMBER 6)', 243581),
(340921, 'PTHR23122:SF42', NULL, NULL, NULL, NULL, 'MENAGE A TROIS, ISOFORM A', 243581),
(340922, 'PTHR23122:SF69', NULL, NULL, NULL, NULL, 'FI17352P1', 243581),
(340923, 'PTHR23122:SF47', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN, PALMITOYLATED 3B (MAGUK P55 SUBFAMILY MEMBER 3)', 243581),
(340924, 'PTHR23122:SF14', NULL, NULL, NULL, NULL, 'PROTEIN PALS1', 243581),
(340925, 'PTHR23122:SF37', NULL, NULL, NULL, NULL, '55 KDA ERYTHROCYTE MEMBRANE PROTEIN', 243581),
(340926, 'PTHR23122:SF45', NULL, NULL, NULL, NULL, 'PROTEIN PALS2', 243581),
(340927, 'PTHR23122:SF34', NULL, NULL, NULL, NULL, 'MAGUK P55 SUBFAMILY MEMBER 4', 243581),
(340928, 'PTHR23122:SF35', NULL, NULL, NULL, NULL, 'MAGUK P55 SUBFAMILY MEMBER 2', 243581),
(340929, 'PTHR23122:SF68', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN, PALMITOYLATED 2A (MAGUK P55 SUBFAMILY MEMBER 2)', 243581),
(340930, 'PTHR23122:SF72', NULL, NULL, NULL, NULL, 'DISKS LARGE 1 TUMOR SUPPRESSOR PROTEIN-LIKE PROTEIN', 243581),
(340931, 'PTHR23122:SF73', NULL, NULL, NULL, NULL, 'PROTEIN PALS1', 243581),
(340932, 'PTHR23122:SF40', NULL, NULL, NULL, NULL, 'PERIPHERAL PLASMA MEMBRANE PROTEIN CASK', 243581),
(340933, 'PTHR23122:SF71', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN, PALMITOYLATED 5B (MAGUK P55 SUBFAMILY MEMBER 5)', 243581),
(340934, 'PTHR33861:SF3', NULL, NULL, NULL, NULL, 'MEIOSIS-SPECIFIC COILED-COIL DOMAIN-CONTAINING PROTEIN MEIOC', 243582),
(340935, 'PTHR33861:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG18333', 243582),
(340936, 'PTHR33861', NULL, NULL, NULL, NULL, 'PROTEIN CBG18333', 243582);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(340937, 'PTHR33861:SF4', NULL, NULL, NULL, NULL, 'MINAMOTO', 243582),
(340938, 'PTHR34615', NULL, NULL, NULL, NULL, 'PX DOMAIN-CONTAINING PROTEIN', 243583),
(340939, 'PTHR34615:SF1', NULL, NULL, NULL, NULL, 'PX DOMAIN-CONTAINING PROTEIN', 243583),
(340940, 'PTHR11574:SF0', NULL, NULL, NULL, NULL, 'KIT LIGAND', 243584),
(340941, 'PTHR11574', NULL, NULL, NULL, NULL, 'KIT LIGAND', 243584),
(340942, 'PTHR30333:SF3', NULL, NULL, NULL, NULL, 'CYTOCHROME C-TYPE PROTEIN TORY', 243585),
(340943, 'PTHR30333', NULL, NULL, NULL, NULL, 'CYTOCHROME C-TYPE PROTEIN', 243585),
(340944, 'PTHR30333:SF4', NULL, NULL, NULL, NULL, 'CYTOCHROME C FAMILY PROTEIN', 243585),
(340945, 'PTHR30333:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME C-TYPE PROTEIN NAPC', 243585),
(340946, 'PTHR30333:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME C-TYPE PROTEIN TORC', 243585),
(340947, 'PTHR19431:SF10', NULL, NULL, NULL, NULL, 'RIBOS_L4_ASSO_C DOMAIN-CONTAINING PROTEIN', 243586),
(340948, 'PTHR19431:SF11', NULL, NULL, NULL, NULL, 'RIBOS_L4_ASSO_C DOMAIN-CONTAINING PROTEIN', 243586),
(340949, 'PTHR19431:SF12', NULL, NULL, NULL, NULL, 'RIBOS_L4_ASSO_C DOMAIN-CONTAINING PROTEIN', 243586),
(340950, 'PTHR19431:SF13', NULL, NULL, NULL, NULL, 'RIBOS_L4_ASSO_C DOMAIN-CONTAINING PROTEIN', 243586),
(340951, 'PTHR19431:SF0', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L4', 243586),
(340952, 'PTHR19431:SF3', NULL, NULL, NULL, NULL, 'RIBOS_L4_ASSO_C DOMAIN-CONTAINING PROTEIN', 243586),
(340953, 'PTHR19431:SF1', NULL, NULL, NULL, NULL, 'OS07G0180900 PROTEIN', 243586),
(340954, 'PTHR19431', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L4', 243586),
(340955, 'PTHR19431:SF8', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L4-LIKE', 243586),
(340956, 'PTHR19431:SF5', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L4', 243586),
(340957, 'PTHR19431:SF6', NULL, NULL, NULL, NULL, 'RIBOS_L4_ASSO_C DOMAIN-CONTAINING PROTEIN', 243586),
(340958, 'PTHR39427', NULL, NULL, NULL, NULL, '', 243587),
(340959, 'PTHR39427:SF1', NULL, NULL, NULL, NULL, 'PTS SYSTEM GLUCITOL/SORBITOL-SPECIFIC EIIB COMPONENT', 243587),
(340960, 'PTHR39677:SF4', NULL, NULL, NULL, NULL, 'RIBONUCLEASE VAPC6', 243588),
(340961, 'PTHR39677', NULL, NULL, NULL, NULL, 'RIBONUCLEASE VAPC6', 243588),
(340962, 'PTHR23314:SF0', NULL, NULL, NULL, NULL, 'SPERM-ASSOCIATED ANTIGEN 6', 243589),
(340963, 'PTHR23314:SF1', NULL, NULL, NULL, NULL, 'SPERM-ASSOCIATED ANTIGEN 6', 243589),
(340964, 'PTHR23314', NULL, NULL, NULL, NULL, 'SPERM-ASSOCIATED ANTIGEN 6  ARMADILLO REPEAT-CONTAINING', 243589),
(340965, 'PTHR23314:SF2', NULL, NULL, NULL, NULL, 'SPERM-ASSOCIATED ANTIGEN 6', 243589),
(340966, 'PTHR22055:SF9', NULL, NULL, NULL, NULL, 'BNAC09G52010D PROTEIN', 243590),
(340967, 'PTHR22055:SF5', NULL, NULL, NULL, NULL, '28 KDA HEAT- AND ACID-STABLE PHOSPHOPROTEIN', 243590),
(340968, 'PTHR22055:SF4', NULL, NULL, NULL, NULL, 'PP28 DOMAIN-CONTAINING PROTEIN', 243590),
(340969, 'PTHR22055:SF3', NULL, NULL, NULL, NULL, 'PP28 DOMAIN-CONTAINING PROTEIN', 243590),
(340970, 'PTHR22055:SF2', NULL, NULL, NULL, NULL, 'PP28 DOMAIN-CONTAINING PROTEIN', 243590),
(340971, 'PTHR22055:SF14', NULL, NULL, NULL, NULL, 'PP28 DOMAIN-CONTAINING PROTEIN', 243590),
(340972, 'PTHR22055', NULL, NULL, NULL, NULL, '28 KDA HEAT- AND ACID-STABLE PHOSPHOPROTEIN  PDGF-ASSOCIATED PROTEIN', 243590),
(340973, 'PTHR22055:SF12', NULL, NULL, NULL, NULL, '28 KDA HEAT/ACID-STABLE PHOSPHOPROTEIN-LIKE PROTEIN', 243590),
(340974, 'PTHR22055:SF0', NULL, NULL, NULL, NULL, '28 KDA HEAT- AND ACID-STABLE PHOSPHOPROTEIN', 243590),
(340975, 'PTHR22055:SF13', NULL, NULL, NULL, NULL, 'PP28 DOMAIN-CONTAINING PROTEIN', 243590),
(340976, 'PTHR33937', NULL, NULL, NULL, NULL, 'IRON-MOLYBDENUM PROTEIN-RELATED-RELATED', 243591),
(340977, 'PTHR33937:SF5', NULL, NULL, NULL, NULL, 'IRON-MOLYBDENUM COFACTOR-BINDING PROTEIN', 243591),
(340978, 'PTHR33937:SF2', NULL, NULL, NULL, NULL, 'NITRO_FEMO-CO DOMAIN-CONTAINING PROTEIN', 243591),
(340979, 'PTHR33937:SF1', NULL, NULL, NULL, NULL, 'IRON-MOLIBDENUM COFACTOR PROCESSING PROTEIN', 243591),
(340980, 'PTHR36595', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 243592);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(340981, 'PTHR36595:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 243592),
(340982, 'PTHR36595:SF2', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE FHKB-RELATED', 243592),
(340983, 'PTHR36595:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 243592),
(340984, 'PTHR22872:SF8', NULL, NULL, NULL, NULL, '', 243593),
(340985, 'PTHR22872:SF2', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN 1', 243593),
(340986, 'PTHR22872:SF3', NULL, NULL, NULL, NULL, 'RCC1 AND BTB DOMAIN CONTAINING PROTEIN 2', 243593),
(340987, 'PTHR22872:SF4', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 243593),
(340988, 'PTHR22872:SF5', NULL, NULL, NULL, NULL, 'INHIBITOR OF BRUTON TYROSINE KINASE', 243593),
(340989, 'PTHR22872:SF6', NULL, NULL, NULL, NULL, 'HECT AND RLD DOMAIN CONTAINING E3 UBIQUITIN PROTEIN LIGASE FAMILY MEMBER 1', 243593),
(340990, 'PTHR22872', NULL, NULL, NULL, NULL, 'BTK-BINDING PROTEIN-RELATED', 243593),
(340991, 'PTHR22872:SF7', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN / REGULATOR OF CHROMOSOME CONDENSATION (RCC1) FAMILY PROTEIN', 243593),
(340992, 'PTHR15359:SF5', NULL, NULL, NULL, NULL, 'PURKINJE CELL PROTEIN 4-LIKE PROTEIN 1', 243594),
(340993, 'PTHR15359:SF7', NULL, NULL, NULL, NULL, 'CALMODULIN REGULATOR PROTEIN PCP4', 243594),
(340994, 'PTHR15359:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG01055', 243594),
(340995, 'PTHR15359', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 243594),
(340996, 'PTHR15913', NULL, NULL, NULL, NULL, 'ACID CLUSTER PROTEIN 33', 243595),
(340997, 'PTHR15913:SF0', NULL, NULL, NULL, NULL, 'MASPARDIN', 243595),
(340998, 'PTHR32138', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLETHANOLAMINE N-METHYLTRANSFERASE', 243596),
(340999, 'PTHR32138:SF0', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLETHANOLAMINE N-METHYLTRANSFERASE', 243596),
(341000, 'PTHR48238:SF1', NULL, NULL, NULL, NULL, 'BNACNNG09570D PROTEIN', 243597),
(341001, 'PTHR48238', NULL, NULL, NULL, NULL, 'BNACNNG09570D PROTEIN', 243597),
(341002, 'PTHR34223:SF58', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243598),
(341003, 'PTHR34223:SF14', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243598),
(341004, 'PTHR34223:SF59', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243598),
(341005, 'PTHR34223:SF15', NULL, NULL, NULL, NULL, 'OS04G0440200 PROTEIN', 243598),
(341006, 'PTHR34223:SF11', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', 243598),
(341007, 'PTHR34223:SF96', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243598),
(341008, 'PTHR34223:SF53', NULL, NULL, NULL, NULL, '', 243598),
(341009, 'PTHR34223:SF94', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243598),
(341010, 'PTHR34223:SF50', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243598),
(341011, 'PTHR34223:SF51', NULL, NULL, NULL, NULL, 'OS04G0207100 PROTEIN', 243598),
(341012, 'PTHR34223:SF95', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243598),
(341013, 'PTHR34223:SF92', NULL, NULL, NULL, NULL, 'MEIOTIC F-BOX PROTEIN MOF', 243598),
(341014, 'PTHR34223:SF93', NULL, NULL, NULL, NULL, '', 243598),
(341015, 'PTHR34223:SF90', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243598),
(341016, 'PTHR34223:SF91', NULL, NULL, NULL, NULL, '', 243598),
(341017, 'PTHR34223:SF27', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243598),
(341018, 'PTHR34223:SF28', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243598),
(341019, 'PTHR34223:SF26', NULL, NULL, NULL, NULL, 'OS02G0188900 PROTEIN', 243598),
(341020, 'PTHR34223:SF67', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243598),
(341021, 'PTHR34223:SF24', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243598),
(341022, 'PTHR34223:SF65', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243598),
(341023, 'PTHR34223:SF66', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243598),
(341024, 'PTHR34223:SF22', NULL, NULL, NULL, NULL, 'OS11G0208300 PROTEIN', 243598),
(341025, 'PTHR34223:SF63', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243598);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(341026, 'PTHR34223:SF64', NULL, NULL, NULL, NULL, 'OS11G0201299 PROTEIN', 243598),
(341027, 'PTHR34223:SF60', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 5B MITOCHONDRIAL', 243598),
(341028, 'PTHR34223:SF8', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243598),
(341029, 'PTHR34223:SF36', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243598),
(341030, 'PTHR34223:SF34', NULL, NULL, NULL, NULL, 'OS08G0197100 PROTEIN', 243598),
(341031, 'PTHR34223:SF79', NULL, NULL, NULL, NULL, 'F-BOX/RNI/FBD-LIKE DOMAIN PROTEIN', 243598),
(341032, 'PTHR34223:SF35', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243598),
(341033, 'PTHR34223:SF72', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243598),
(341034, 'PTHR34223:SF73', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243598),
(341035, 'PTHR34223:SF70', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243598),
(341036, 'PTHR34223:SF47', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', 243598),
(341037, 'PTHR34223:SF48', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243598),
(341038, 'PTHR34223:SF89', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243598),
(341039, 'PTHR34223:SF43', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243598),
(341040, 'PTHR34223:SF87', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', 243598),
(341041, 'PTHR34223:SF44', NULL, NULL, NULL, NULL, 'OS01G0789000 PROTEIN', 243598),
(341042, 'PTHR34223:SF88', NULL, NULL, NULL, NULL, 'OS11G0200950 PROTEIN', 243598),
(341043, 'PTHR34223:SF85', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243598),
(341044, 'PTHR34223:SF86', NULL, NULL, NULL, NULL, 'OS06G0493266 PROTEIN', 243598),
(341045, 'PTHR34223:SF83', NULL, NULL, NULL, NULL, 'BNAC04G06000D PROTEIN', 243598),
(341046, 'PTHR34223:SF84', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243598),
(341047, 'PTHR34223:SF40', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243598),
(341048, 'PTHR34223:SF81', NULL, NULL, NULL, NULL, 'OS08G0281600 PROTEIN', 243598),
(341049, 'PTHR34223:SF82', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243598),
(341050, 'PTHR34223', NULL, NULL, NULL, NULL, 'OS11G0201299 PROTEIN', 243598),
(341051, 'PTHR34223:SF80', NULL, NULL, NULL, NULL, 'OS11G0201600 PROTEIN', 243598),
(341052, 'PTHR35167:SF12', NULL, NULL, NULL, NULL, '', 243599),
(341053, 'PTHR35167:SF13', NULL, NULL, NULL, NULL, '', 243599),
(341054, 'PTHR35167:SF5', NULL, NULL, NULL, NULL, '', 243599),
(341055, 'PTHR35167:SF10', NULL, NULL, NULL, NULL, '', 243599),
(341056, 'PTHR35167:SF11', NULL, NULL, NULL, NULL, '', 243599),
(341057, 'PTHR35167:SF6', NULL, NULL, NULL, NULL, '', 243599),
(341058, 'PTHR35167:SF3', NULL, NULL, NULL, NULL, 'OS05G0216466 PROTEIN', 243599),
(341059, 'PTHR35167:SF1', NULL, NULL, NULL, NULL, 'OS08G0549900 PROTEIN', 243599),
(341060, 'PTHR35167', NULL, NULL, NULL, NULL, 'OS05G0216466 PROTEIN', 243599),
(341061, 'PTHR34609:SF17', NULL, NULL, NULL, NULL, '', 243600),
(341062, 'PTHR34609:SF16', NULL, NULL, NULL, NULL, 'GEO08273P1-RELATED', 243600),
(341063, 'PTHR34609', NULL, NULL, NULL, NULL, 'GEO08273P1-RELATED', 243600),
(341064, 'PTHR28244', NULL, NULL, NULL, NULL, 'RNA POLYMERASE I-SPECIFIC TRANSCRIPTION INITIATION FACTOR RRN11', 243601),
(341065, 'PTHR28244:SF1', NULL, NULL, NULL, NULL, 'RNA POLYMERASE I-SPECIFIC TRANSCRIPTION INITIATION FACTOR RRN11', 243601),
(341066, 'PTHR28244:SF3', NULL, NULL, NULL, NULL, 'ECM11 DOMAIN-CONTAINING PROTEIN', 243601),
(341067, 'PTHR36987:SF1', NULL, NULL, NULL, NULL, 'BLE1 PROTEIN', 243602),
(341068, 'PTHR36987', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 BETA SUBCOMPLEX SUBUNIT 2-LIKE', 243602),
(341069, 'PTHR31802:SF3', NULL, NULL, NULL, NULL, 'MARTIK, ISOFORM A', 243603),
(341070, 'PTHR31802:SF44', NULL, NULL, NULL, NULL, 'PDDEXK_1 DOMAIN-CONTAINING PROTEIN', 243603),
(341071, 'PTHR31802:SF33', NULL, NULL, NULL, NULL, '32 KDA HEAT SHOCK PROTEIN', 243603),
(341072, 'PTHR31802:SF32', NULL, NULL, NULL, NULL, '', 243603);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(341073, 'PTHR31802:SF43', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 243603),
(341074, 'PTHR31802:SF42', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 243603),
(341075, 'PTHR31802:SF31', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA-PROCESSING 12 HOMOLOG', 243603),
(341076, 'PTHR31802:SF41', NULL, NULL, NULL, NULL, 'SRCR DOMAIN-CONTAINING PROTEIN', 243603),
(341077, 'PTHR31802:SF40', NULL, NULL, NULL, NULL, '', 243603),
(341078, 'PTHR31802:SF39', NULL, NULL, NULL, NULL, 'CYTOADHERENCE LINKED ASEXUAL PROTEIN 3.2', 243603),
(341079, 'PTHR31802:SF38', NULL, NULL, NULL, NULL, '', 243603),
(341080, 'PTHR31802:SF37', NULL, NULL, NULL, NULL, '', 243603),
(341081, 'PTHR31802:SF36', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 243603),
(341082, 'PTHR31802:SF35', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN-RELATED', 243603),
(341083, 'PTHR31802:SF34', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN, PUTATIVE-RELATED', 243603),
(341084, 'PTHR31802', NULL, NULL, NULL, NULL, '32 KDA HEAT SHOCK PROTEIN-RELATED', 243603),
(341085, 'PTHR31802:SF45', NULL, NULL, NULL, NULL, 'AGAP002961-PA', 243603),
(341086, 'PTHR10766:SF135', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341087, 'PTHR10766:SF14', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER 1', 243604),
(341088, 'PTHR10766:SF57', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341089, 'PTHR10766:SF55', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341090, 'PTHR10766:SF170', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER 4', 243604),
(341091, 'PTHR10766:SF53', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341092, 'PTHR10766:SF97', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341093, 'PTHR10766:SF173', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341094, 'PTHR10766:SF174', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341095, 'PTHR10766:SF171', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341096, 'PTHR10766:SF172', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341097, 'PTHR10766:SF133', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341098, 'PTHR10766:SF131', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341099, 'PTHR10766:SF175', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341100, 'PTHR10766:SF132', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341101, 'PTHR10766:SF149', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341102, 'PTHR10766:SF105', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341103, 'PTHR10766:SF102', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341104, 'PTHR10766:SF106', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341105, 'PTHR10766:SF107', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341106, 'PTHR10766:SF140', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341107, 'PTHR10766:SF141', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341108, 'PTHR10766:SF144', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341109, 'PTHR10766:SF142', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341110, 'PTHR10766:SF143', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER 4', 243604),
(341111, 'PTHR10766:SF116', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341112, 'PTHR10766:SF119', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER 5', 243604),
(341113, 'PTHR10766:SF117', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341114, 'PTHR10766:SF36', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER 2', 243604),
(341115, 'PTHR10766:SF35', NULL, NULL, NULL, NULL, 'PHAGOCYTIC RECEPTOR 1C-RELATED', 243604);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(341116, 'PTHR10766', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY PROTEIN', 243604),
(341117, 'PTHR10766:SF152', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341118, 'PTHR10766:SF111', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER 6-RELATED', 243604),
(341119, 'PTHR10766:SF110', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER 8-RELATED', 243604),
(341120, 'PTHR10766:SF154', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER 10', 243604),
(341121, 'PTHR10766:SF124', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341122, 'PTHR10766:SF168', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341123, 'PTHR10766:SF169', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341124, 'PTHR10766:SF125', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341125, 'PTHR10766:SF128', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341126, 'PTHR10766:SF129', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341127, 'PTHR10766:SF92', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341128, 'PTHR10766:SF91', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341129, 'PTHR10766:SF48', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341130, 'PTHR10766:SF45', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341131, 'PTHR10766:SF43', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341132, 'PTHR10766:SF41', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER 3', 243604),
(341133, 'PTHR10766:SF163', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER 12', 243604),
(341134, 'PTHR10766:SF160', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER 3', 243604),
(341135, 'PTHR10766:SF161', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341136, 'PTHR10766:SF166', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341137, 'PTHR10766:SF167', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341138, 'PTHR10766:SF123', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER 3', 243604),
(341139, 'PTHR10766:SF164', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341140, 'PTHR10766:SF165', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY MEMBER', 243604),
(341141, 'PTHR31281:SF3', NULL, NULL, NULL, NULL, '', 243605),
(341142, 'PTHR31281:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM219B', 243605),
(341143, 'PTHR31281:SF4', NULL, NULL, NULL, NULL, 'PROTEIN FAM219A', 243605),
(341144, 'PTHR31281', NULL, NULL, NULL, NULL, '', 243605),
(341145, 'PTHR31281:SF0', NULL, NULL, NULL, NULL, 'PROTEIN FAM219A', 243605),
(341146, 'PTHR15129:SF1', NULL, NULL, NULL, NULL, 'SRC KINASE-ASSOCIATED PHOSPHOPROTEIN 1', 243606),
(341147, 'PTHR15129:SF2', NULL, NULL, NULL, NULL, 'SRC KINASE-ASSOCIATED PHOSPHOPROTEIN 2', 243606),
(341148, 'PTHR15129:SF0', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 243606),
(341149, 'PTHR15129', NULL, NULL, NULL, NULL, 'SRC-ASSOCIATED ADAPTOR PROTEIN', 243606),
(341150, 'PTHR32414', NULL, NULL, NULL, NULL, 'NEUROMEDIN-S', 243607),
(341151, 'PTHR32414:SF2', NULL, NULL, NULL, NULL, 'NEUROMEDIN-S', 243607),
(341152, 'PTHR13179:SF8', NULL, NULL, NULL, NULL, 'GATOR COMPLEX PROTEIN DEPDC5', 243608),
(341153, 'PTHR13179', NULL, NULL, NULL, NULL, 'DEP DOMAIN CONTAINING PROTEIN 5', 243608),
(341154, 'PTHR10229:SF0', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN 6-RELATED', 243609),
(341155, 'PTHR10229', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN HFLX', 243609),
(341156, 'PTHR10229:SF7', NULL, NULL, NULL, NULL, 'GTP BINDING PROTEIN-LIKE', 243609),
(341157, 'PTHR10229:SF4', NULL, NULL, NULL, NULL, 'GTPASE HFLX', 243609),
(341158, 'PTHR43758', NULL, NULL, NULL, NULL, '7,8-DIHYDRO-8-OXOGUANINE TRIPHOSPHATASE', 243610),
(341159, 'PTHR43758:SF9', NULL, NULL, NULL, NULL, 'NUCLEOSIDE TRIPHOSPHATASE NUDI', 243610);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(341160, 'PTHR43758:SF8', NULL, NULL, NULL, NULL, '8-OXO-DGTP DIPHOSPHATASE YTKD-RELATED', 243610),
(341161, 'PTHR43758:SF6', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 3', 243610),
(341162, 'PTHR43758:SF2', NULL, NULL, NULL, NULL, '7,8-DIHYDRO-8-OXOGUANINE TRIPHOSPHATASE', 243610),
(341163, 'PTHR14463:SF5', NULL, NULL, NULL, NULL, 'LIPASE MATURATION FACTOR 2', 243611),
(341164, 'PTHR14463:SF10', NULL, NULL, NULL, NULL, 'LIPASE MATURATION FACTOR 1', 243611),
(341165, 'PTHR14463', NULL, NULL, NULL, NULL, 'LIPASE MATURATION FACTOR', 243611),
(341166, 'PTHR22792:SF43', NULL, NULL, NULL, NULL, 'LA-RELATED PROTEIN 4B', 243612),
(341167, 'PTHR22792:SF66', NULL, NULL, NULL, NULL, 'ACHILLES, ISOFORM A', 243612),
(341168, 'PTHR22792:SF48', NULL, NULL, NULL, NULL, 'LA-RELATED PROTEIN 4', 243612),
(341169, 'PTHR22792', NULL, NULL, NULL, NULL, 'LUPUS LA PROTEIN-RELATED', 243612),
(341170, 'PTHR22792:SF61', NULL, NULL, NULL, NULL, 'HTH LA-TYPE RNA-BINDING DOMAIN-CONTAINING PROTEIN', 243612),
(341171, 'PTHR22792:SF62', NULL, NULL, NULL, NULL, 'LA-RELATED PROTEIN 6C', 243612),
(341172, 'PTHR22792:SF164', NULL, NULL, NULL, NULL, 'HTH LA-TYPE RNA-BINDING DOMAIN-CONTAINING PROTEIN', 243612),
(341173, 'PTHR22792:SF165', NULL, NULL, NULL, NULL, 'LA-RELATED PROTEIN 6B', 243612),
(341174, 'PTHR22792:SF166', NULL, NULL, NULL, NULL, 'LUPUS LA PROTEIN HOMOLOG', 243612),
(341175, 'PTHR22792:SF101', NULL, NULL, NULL, NULL, 'LA-RELATED PROTEIN 1A', 243612),
(341176, 'PTHR22792:SF160', NULL, NULL, NULL, NULL, 'LA-RELATED PROTEIN 1C', 243612),
(341177, 'PTHR22792:SF161', NULL, NULL, NULL, NULL, 'HTH LA-TYPE RNA-BINDING DOMAIN-CONTAINING PROTEIN', 243612),
(341178, 'PTHR22792:SF140', NULL, NULL, NULL, NULL, 'LA PROTEIN 1', 243612),
(341179, 'PTHR22792:SF162', NULL, NULL, NULL, NULL, 'LA-RELATED PROTEIN 6B-LIKE', 243612),
(341180, 'PTHR22792:SF163', NULL, NULL, NULL, NULL, 'LA RIBONUCLEOPROTEIN 1B', 243612),
(341181, 'PTHR22792:SF108', NULL, NULL, NULL, NULL, 'LA DOMAIN CONTAINING PROTEIN, EXPRESSED', 243612),
(341182, 'PTHR22792:SF109', NULL, NULL, NULL, NULL, 'LA-RELATED PROTEIN 6C-LIKE', 243612),
(341183, 'PTHR22792:SF147', NULL, NULL, NULL, NULL, 'LA-RELATED PROTEIN 6 LA RNA-BINDING DOMAIN PROTEIN', 243612),
(341184, 'PTHR22792:SF148', NULL, NULL, NULL, NULL, 'WINGED HELIX-TURN-HELIX DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 243612),
(341185, 'PTHR22792:SF54', NULL, NULL, NULL, NULL, 'OS08G0542900 PROTEIN', 243612),
(341186, 'PTHR22792:SF79', NULL, NULL, NULL, NULL, 'OS02G0610400 PROTEIN', 243612),
(341187, 'PTHR22792:SF71', NULL, NULL, NULL, NULL, 'LA-RELATED PROTEIN 6', 243612),
(341188, 'PTHR22792:SF50', NULL, NULL, NULL, NULL, 'LA-RELATED PROTEIN 1B', 243612),
(341189, 'PTHR22792:SF51', NULL, NULL, NULL, NULL, 'LA-RELATED PROTEIN 1', 243612),
(341190, 'PTHR22792:SF131', NULL, NULL, NULL, NULL, 'LA-RELATED PROTEIN LARP4B', 243612),
(341191, 'PTHR22792:SF132', NULL, NULL, NULL, NULL, 'LA-RELATED PROTEIN 1', 243612),
(341192, 'PTHR22792:SF154', NULL, NULL, NULL, NULL, 'LA-RELATED PROTEIN 6B-LIKE', 243612),
(341193, 'PTHR22792:SF133', NULL, NULL, NULL, NULL, 'LA PROTEIN 2', 243612),
(341194, 'PTHR22792:SF155', NULL, NULL, NULL, NULL, 'HTH LA-TYPE RNA-BINDING DOMAIN-CONTAINING PROTEIN', 243612),
(341195, 'PTHR22792:SF134', NULL, NULL, NULL, NULL, 'BNACNNG57490D PROTEIN', 243612),
(341196, 'PTHR22792:SF156', NULL, NULL, NULL, NULL, 'HTH LA-TYPE RNA-BINDING DOMAIN-CONTAINING PROTEIN', 243612),
(341197, 'PTHR22792:SF150', NULL, NULL, NULL, NULL, 'HTH LA-TYPE RNA-BINDING DOMAIN-CONTAINING PROTEIN', 243612),
(341198, 'PTHR22792:SF152', NULL, NULL, NULL, NULL, 'LA-RELATED PROTEIN 1C-LIKE ISOFORM X1', 243612),
(341199, 'PTHR22792:SF130', NULL, NULL, NULL, NULL, 'HTH LA-TYPE RNA-BINDING DOMAIN-CONTAINING PROTEIN', 243612),
(341200, 'PTHR22792:SF139', NULL, NULL, NULL, NULL, 'HTH LA-TYPE RNA-BINDING DOMAIN-CONTAINING PROTEIN', 243612),
(341201, 'PTHR22792:SF113', NULL, NULL, NULL, NULL, 'OS03G0566500 PROTEIN', 243612),
(341202, 'PTHR22792:SF157', NULL, NULL, NULL, NULL, 'LA PROTEIN', 243612),
(341203, 'PTHR22792:SF158', NULL, NULL, NULL, NULL, 'LUPUS LA PROTEIN', 243612);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(341204, 'PTHR22792:SF136', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN-RELATED', 243612),
(341205, 'PTHR22792:SF115', NULL, NULL, NULL, NULL, 'LA-RELATED PROTEIN 7', 243612),
(341206, 'PTHR22792:SF159', NULL, NULL, NULL, NULL, 'LA-RELATED PROTEIN 1B-RELATED', 243612),
(341207, 'PTHR15546:SF8', NULL, NULL, NULL, NULL, 'OS02G0556900 PROTEIN', 243613),
(341208, 'PTHR15546', NULL, NULL, NULL, NULL, 'BROMODOMAIN ADJACENT TO ZINC FINGER DOMAIN, 2A', 243613),
(341209, 'PTHR15546:SF2', NULL, NULL, NULL, NULL, 'DDT DOMAIN-CONTAINING PROTEIN DDB_G0282237', 243613),
(341210, 'PTHR46648', NULL, NULL, NULL, NULL, 'HIT FAMILY PROTEIN 1', 243614),
(341211, 'PTHR46648:SF1', NULL, NULL, NULL, NULL, 'HIT FAMILY PROTEIN 1', 243614),
(341212, 'PTHR46648:SF2', NULL, NULL, NULL, NULL, 'HIT DOMAIN-CONTAINING PROTEIN', 243614),
(341213, 'PTHR33884:SF7', NULL, NULL, NULL, NULL, 'BSL8023 PROTEIN', 243615),
(341214, 'PTHR33884:SF4', NULL, NULL, NULL, NULL, 'UPF0410 PROTEIN YEAQ', 243615),
(341215, 'PTHR33884:SF3', NULL, NULL, NULL, NULL, 'UPF0410 PROTEIN YMGE', 243615),
(341216, 'PTHR33884', NULL, NULL, NULL, NULL, 'UPF0410 PROTEIN YMGE', 243615),
(341217, 'PTHR37372', NULL, NULL, NULL, NULL, 'OS06G0316800 PROTEIN', 243616),
(341218, 'PTHR37372:SF1', NULL, NULL, NULL, NULL, 'GEO07177P1', 243616),
(341219, 'PTHR37372:SF2', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN GRP5', 243616),
(341220, 'PTHR37372:SF3', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN A3', 243616),
(341221, 'PTHR22983:SF6', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 36', 243617),
(341222, 'PTHR22983', NULL, NULL, NULL, NULL, 'PROTEIN KINASE RELATED', 243617),
(341223, 'PTHR16156', NULL, NULL, NULL, NULL, 'AFTIPHILIN A-RELATED', 243618),
(341224, 'PTHR16156:SF10', NULL, NULL, NULL, NULL, 'AFTIPHILIN A-RELATED', 243618),
(341225, 'PTHR16156:SF7', NULL, NULL, NULL, NULL, 'CLATHRIN_BDG DOMAIN-CONTAINING PROTEIN', 243618),
(341226, 'PTHR16156:SF9', NULL, NULL, NULL, NULL, 'AFTIPHILIN', 243618),
(341227, 'PTHR36891', NULL, NULL, NULL, NULL, 'OS01G0127400 PROTEIN', 243619),
(341228, 'PTHR36891:SF1', NULL, NULL, NULL, NULL, 'OS01G0127400 PROTEIN', 243619),
(341229, 'PTHR31438', NULL, NULL, NULL, NULL, 'LYSINE N-ACYLTRANSFERASE C17G9.06C-RELATED', 243620),
(341230, 'PTHR31438:SF6', NULL, NULL, NULL, NULL, 'BIOSYNTHESIS ACETYLASE ACEI, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G03400)-RELATED', 243620),
(341231, 'PTHR31438:SF7', NULL, NULL, NULL, NULL, 'ALCB DOMAIN-CONTAINING PROTEIN', 243620),
(341232, 'PTHR31438:SF1', NULL, NULL, NULL, NULL, 'LYSINE N-ACYLTRANSFERASE C17G9.06C-RELATED', 243620),
(341233, 'PTHR47381', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 243621),
(341234, 'PTHR47381:SF4', NULL, NULL, NULL, NULL, 'PEPTIDASE_S9 DOMAIN-CONTAINING PROTEIN', 243621),
(341235, 'PTHR47381:SF3', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 243621),
(341236, 'PTHR47381:SF2', NULL, NULL, NULL, NULL, 'ESTERASE YITV-RELATED', 243621),
(341237, 'PTHR35354', NULL, NULL, NULL, NULL, 'RGD1561648', 243622),
(341238, 'PTHR35354:SF1', NULL, NULL, NULL, NULL, 'RGD1561648', 243622),
(341239, 'PTHR28187', NULL, NULL, NULL, NULL, 'PROTEIN RCR1-RELATED', 243623),
(341240, 'PTHR28187:SF1', NULL, NULL, NULL, NULL, 'PROTEIN RCR1-RELATED', 243623),
(341241, 'PTHR48125', NULL, NULL, NULL, NULL, 'LP07818P1', 243624),
(341242, 'PTHR48125:SF10', NULL, NULL, NULL, NULL, 'NYN DOMAIN-CONTAINING PROTEIN', 243624),
(341243, 'PTHR48125:SF9', NULL, NULL, NULL, NULL, 'CHROMOSOME 12, WHOLE GENOME SHOTGUN SEQUENCE', 243624),
(341244, 'PTHR48125:SF11', NULL, NULL, NULL, NULL, '', 243624),
(341245, 'PTHR48125:SF14', NULL, NULL, NULL, NULL, '', 243624),
(341246, 'PTHR48125:SF15', NULL, NULL, NULL, NULL, 'HYPOTHETICAL TRANSMEMBRANE PROTEIN P883.20', 243624),
(341247, 'PTHR48125:SF12', NULL, NULL, NULL, NULL, 'AT HOOK TRANSCRIPTION FACTOR FAMILY-RELATED', 243624),
(341248, 'PTHR48125:SF13', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE CHANNEL PROTEIN CPNT', 243624),
(341249, 'PTHR24240:SF2', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243625); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(341250, 'PTHR24240:SF0', NULL, NULL, NULL, NULL, 'OPSIN-5', 243625),
(341251, 'PTHR24240:SF180', NULL, NULL, NULL, NULL, 'LONG-WAVE-SENSITIVE OPSIN 1', 243625),
(341252, 'PTHR24240:SF90', NULL, NULL, NULL, NULL, 'RPE-RETINAL G PROTEIN-COUPLED RECEPTOR', 243625),
(341253, 'PTHR24240:SF92', NULL, NULL, NULL, NULL, 'RETINAL G PROTEIN-COUPLED RECEPTOR B', 243625),
(341254, 'PTHR24240:SF55', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243625),
(341255, 'PTHR24240:SF15', NULL, NULL, NULL, NULL, 'RHODOPSIN', 243625),
(341256, 'PTHR24240:SF58', NULL, NULL, NULL, NULL, 'OPSIN RH5', 243625),
(341257, 'PTHR24240', NULL, NULL, NULL, NULL, 'OPSIN', 243625),
(341258, 'PTHR24240:SF56', NULL, NULL, NULL, NULL, 'OPSIN 5-LIKE 2', 243625),
(341259, 'PTHR24240:SF19', NULL, NULL, NULL, NULL, 'BLUE-SENSITIVE OPSIN', 243625),
(341260, 'PTHR24240:SF17', NULL, NULL, NULL, NULL, 'MEDIUM-WAVE-SENSITIVE OPSIN 1-RELATED', 243625),
(341261, 'PTHR24240:SF16', NULL, NULL, NULL, NULL, 'SHORT-WAVE-SENSITIVE OPSIN 1', 243625),
(341262, 'PTHR24240:SF138', NULL, NULL, NULL, NULL, 'NOVOPSIN-2', 243625),
(341263, 'PTHR24240:SF211', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 52', 243625),
(341264, 'PTHR24240:SF178', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243625),
(341265, 'PTHR24240:SF133', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243625),
(341266, 'PTHR24240:SF210', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243625),
(341267, 'PTHR24240:SF152', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN-RELATED', 243625),
(341268, 'PTHR24240:SF196', NULL, NULL, NULL, NULL, '', 243625),
(341269, 'PTHR24240:SF151', NULL, NULL, NULL, NULL, 'NOVOPSIN-4-RELATED', 243625),
(341270, 'PTHR24240:SF195', NULL, NULL, NULL, NULL, 'MAMMALIAN-LIKE MELANOPSIN-3', 243625),
(341271, 'PTHR24240:SF192', NULL, NULL, NULL, NULL, 'OPSIN', 243625),
(341272, 'PTHR24240:SF190', NULL, NULL, NULL, NULL, '', 243625),
(341273, 'PTHR24240:SF22', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243625),
(341274, 'PTHR24240:SF65', NULL, NULL, NULL, NULL, 'NOVEL OPSIN-RELATED', 243625),
(341275, 'PTHR24240:SF67', NULL, NULL, NULL, NULL, 'TELEOST MULTIPLE TISSUE OPSIN 3A', 243625),
(341276, 'PTHR24240:SF148', NULL, NULL, NULL, NULL, 'NOVOPSIN-9', 243625),
(341277, 'PTHR24240:SF147', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243625),
(341278, 'PTHR24240:SF189', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243625),
(341279, 'PTHR24240:SF144', NULL, NULL, NULL, NULL, 'MELANOPSIN-LIKE', 243625),
(341280, 'PTHR24240:SF163', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243625),
(341281, 'PTHR24240:SF73', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243625),
(341282, 'PTHR24240:SF72', NULL, NULL, NULL, NULL, 'MELANOPSIN', 243625),
(341283, 'PTHR24240:SF77', NULL, NULL, NULL, NULL, 'VISUAL PIGMENT-LIKE RECEPTOR PEROPSIN', 243625),
(341284, 'PTHR24240:SF75', NULL, NULL, NULL, NULL, 'VERTEBRATE ANCIENT LONG OPSIN', 243625),
(341285, 'PTHR24240:SF78', NULL, NULL, NULL, NULL, 'MELATONIN RECEPTOR 1B', 243625),
(341286, 'PTHR24240:SF199', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243625),
(341287, 'PTHR24240:SF198', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243625),
(341288, 'PTHR24240:SF153', NULL, NULL, NULL, NULL, 'GREEN-SENSITIVE OPSIN', 243625),
(341289, 'PTHR24240:SF197', NULL, NULL, NULL, NULL, 'OPSIN-3', 243625),
(341290, 'PTHR24240:SF85', NULL, NULL, NULL, NULL, 'OPSIN RH1-RELATED', 243625),
(341291, 'PTHR24240:SF209', NULL, NULL, NULL, NULL, 'OPSIN RH3-RELATED', 243625),
(341292, 'PTHR24240:SF208', NULL, NULL, NULL, NULL, 'OPSIN', 243625),
(341293, 'PTHR24240:SF207', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243625),
(341294, 'PTHR24240:SF206', NULL, NULL, NULL, NULL, 'TELEOST MULTIPLE TISSUE OPSIN B', 243625);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(341295, 'PTHR24240:SF205', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243625),
(341296, 'PTHR24240:SF204', NULL, NULL, NULL, NULL, '', 243625),
(341297, 'PTHR24240:SF126', NULL, NULL, NULL, NULL, 'NOVOPSIN-10', 243625),
(341298, 'PTHR24240:SF203', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243625),
(341299, 'PTHR24240:SF169', NULL, NULL, NULL, NULL, 'TELEOST MULTIPLE TISSUE OPSIN 3B', 243625),
(341300, 'PTHR24240:SF202', NULL, NULL, NULL, NULL, 'SI:DKEY-9I23.8', 243625),
(341301, 'PTHR24240:SF201', NULL, NULL, NULL, NULL, 'RECEPTOR, PUTATIVE-RELATED', 243625),
(341302, 'PTHR24240:SF167', NULL, NULL, NULL, NULL, 'NOVOPSIN-7', 243625),
(341303, 'PTHR24240:SF200', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243625),
(341304, 'PTHR24240:SF166', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243625),
(341305, 'PTHR24240:SF165', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 88-RELATED', 243625),
(341306, 'PTHR13544:SF0', NULL, NULL, NULL, NULL, 'THIOREDOXIN REDUCTASE-LIKE SELENOPROTEIN T', 243626),
(341307, 'PTHR13544:SF11', NULL, NULL, NULL, NULL, 'BNAANNG17380D PROTEIN', 243626),
(341308, 'PTHR13544:SF5', NULL, NULL, NULL, NULL, 'OS01G0832200 PROTEIN', 243626),
(341309, 'PTHR13544:SF12', NULL, NULL, NULL, NULL, 'SELT-LIKE PROTEIN', 243626),
(341310, 'PTHR13544:SF6', NULL, NULL, NULL, NULL, 'SELENOPROTEIN T2', 243626),
(341311, 'PTHR13544:SF7', NULL, NULL, NULL, NULL, 'THIOREDOXIN REDUCTASE-LIKE SELENOPROTEIN T1A-RELATED', 243626),
(341312, 'PTHR13544', NULL, NULL, NULL, NULL, 'SELENOPROTEIN T', 243626),
(341313, 'PTHR21732', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DNA-BINDING DOMAIN-CONTAINING PROTEIN 4', 243627),
(341314, 'PTHR21732:SF0', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DNA-BINDING DOMAIN-CONTAINING PROTEIN 4', 243627),
(341315, 'PTHR15254', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA GROUP G PROTEIN FAMILY MEMBER', 243628),
(341316, 'PTHR15254:SF2', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA GROUP G PROTEIN', 243628),
(341317, 'PTHR46349', NULL, NULL, NULL, NULL, 'CINGULIN-LIKE PROTEIN 1-RELATED', 243629),
(341318, 'PTHR46349:SF5', NULL, NULL, NULL, NULL, 'CINGULIN', 243629),
(341319, 'PTHR46349:SF4', NULL, NULL, NULL, NULL, 'CINGULIN', 243629),
(341320, 'PTHR46349:SF2', NULL, NULL, NULL, NULL, 'CINGULIN-LIKE PROTEIN 1', 243629),
(341321, 'PTHR47261:SF4', NULL, NULL, NULL, NULL, '', 243630),
(341322, 'PTHR47261:SF3', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT LIPID-BINDING (CALB DOMAIN) FAMILY PROTEIN-RELATED', 243630),
(341323, 'PTHR47261', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT LIPID-BINDING (CALB DOMAIN) FAMILY PROTEIN', 243630),
(341324, 'PTHR47261:SF2', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT LIPID-BINDING (CALB DOMAIN) FAMILY PROTEIN', 243630),
(341325, 'PTHR21664:SF1', NULL, NULL, NULL, NULL, 'NUDC DOMAIN-CONTAINING PROTEIN 1', 243631),
(341326, 'PTHR21664', NULL, NULL, NULL, NULL, 'CHRONIC MYELOGENOUS LEUKEMIA TUMOR ANTIGEN 66', 243631),
(341327, 'PTHR21330:SF1', NULL, NULL, NULL, NULL, 'E3 SUMO-PROTEIN LIGASE NSE2', 243632),
(341328, 'PTHR21330', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243632),
(341329, 'PTHR33124:SF49', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR/TRANSCRIPTION REGULATOR', 243633),
(341330, 'PTHR33124:SF45', NULL, NULL, NULL, NULL, 'BNAC06G24740D PROTEIN', 243633),
(341331, 'PTHR33124:SF44', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN-CONTAINING PROTEIN-RELATED', 243633),
(341332, 'PTHR33124:SF88', NULL, NULL, NULL, NULL, 'BNAANNG02890D PROTEIN', 243633),
(341333, 'PTHR33124:SF46', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH150', 243633),
(341334, 'PTHR33124:SF41', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH149', 243633),
(341335, 'PTHR33124:SF40', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR IBH1', 243633),
(341336, 'PTHR33124:SF87', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH147', 243633),
(341337, 'PTHR33124:SF43', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PAR2', 243633),
(341338, 'PTHR33124:SF42', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH146', 243633);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(341339, 'PTHR33124:SF81', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH149-LIKE', 243633),
(341340, 'PTHR33124:SF90', NULL, NULL, NULL, NULL, 'OS02G0791300 PROTEIN', 243633),
(341341, 'PTHR33124:SF38', NULL, NULL, NULL, NULL, 'OS03G0312100 PROTEIN', 243633),
(341342, 'PTHR33124:SF39', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR UPBEAT1', 243633),
(341343, 'PTHR33124:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR IBH1-LIKE 1', 243633),
(341344, 'PTHR33124:SF2', NULL, NULL, NULL, NULL, 'OS06G0653200 PROTEIN', 243633),
(341345, 'PTHR33124:SF34', NULL, NULL, NULL, NULL, 'OS08G0444500 PROTEIN', 243633),
(341346, 'PTHR33124:SF77', NULL, NULL, NULL, NULL, 'BNAA09G55360D PROTEIN', 243633),
(341347, 'PTHR33124:SF79', NULL, NULL, NULL, NULL, 'OS05G0157400 PROTEIN', 243633),
(341348, 'PTHR33124:SF74', NULL, NULL, NULL, NULL, 'BNAA01G17610D PROTEIN', 243633),
(341349, 'PTHR33124:SF75', NULL, NULL, NULL, NULL, 'BNAC03G34370D PROTEIN', 243633),
(341350, 'PTHR33124:SF71', NULL, NULL, NULL, NULL, 'BNAC01G21940D PROTEIN', 243633),
(341351, 'PTHR33124:SF9', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR', 243633),
(341352, 'PTHR33124:SF103', NULL, NULL, NULL, NULL, 'BNACNNG30130D PROTEIN', 243633),
(341353, 'PTHR33124:SF104', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR', 243633),
(341354, 'PTHR33124:SF105', NULL, NULL, NULL, NULL, 'OS01G0630300 PROTEIN', 243633),
(341355, 'PTHR33124:SF106', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH149', 243633),
(341356, 'PTHR33124:SF67', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PAR1', 243633),
(341357, 'PTHR33124:SF66', NULL, NULL, NULL, NULL, 'BNAC07G33520D PROTEIN', 243633),
(341358, 'PTHR33124:SF100', NULL, NULL, NULL, NULL, '', 243633),
(341359, 'PTHR33124:SF101', NULL, NULL, NULL, NULL, 'BNACNNG19610D PROTEIN', 243633),
(341360, 'PTHR33124:SF102', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 243633),
(341361, 'PTHR33124:SF68', NULL, NULL, NULL, NULL, 'BNAC04G48570D PROTEIN', 243633),
(341362, 'PTHR33124:SF62', NULL, NULL, NULL, NULL, 'BNAA08G13180D PROTEIN', 243633),
(341363, 'PTHR33124:SF65', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH151', 243633),
(341364, 'PTHR33124:SF64', NULL, NULL, NULL, NULL, '', 243633),
(341365, 'PTHR33124:SF107', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR IBH1-LIKE', 243633),
(341366, 'PTHR33124:SF108', NULL, NULL, NULL, NULL, 'BNAC03G23880D PROTEIN', 243633),
(341367, 'PTHR33124', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR IBH1-LIKE 1', 243633),
(341368, 'PTHR33124:SF16', NULL, NULL, NULL, NULL, 'OS02G0178700 PROTEIN', 243633),
(341369, 'PTHR33124:SF12', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH148', 243633),
(341370, 'PTHR33124:SF99', NULL, NULL, NULL, NULL, 'HLH DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 243633),
(341371, 'PTHR33124:SF57', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR UPBEAT-LIKE PROTEIN', 243633),
(341372, 'PTHR33124:SF96', NULL, NULL, NULL, NULL, 'BNACNNG19630D PROTEIN', 243633),
(341373, 'PTHR33124:SF95', NULL, NULL, NULL, NULL, '', 243633),
(341374, 'PTHR33124:SF51', NULL, NULL, NULL, NULL, 'HLH DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 243633),
(341375, 'PTHR33124:SF98', NULL, NULL, NULL, NULL, '', 243633),
(341376, 'PTHR33124:SF97', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR/TRANSCRIPTION REGULATOR', 243633),
(341377, 'PTHR33124:SF92', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 243633),
(341378, 'PTHR33124:SF91', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 243633),
(341379, 'PTHR33124:SF93', NULL, NULL, NULL, NULL, 'BNAA08G13080D PROTEIN', 243633),
(341380, 'PTHR10489:SF928', NULL, NULL, NULL, NULL, 'C-C CHEMOKINE RECEPTOR TYPE 2', 243634),
(341381, 'PTHR10489:SF608', NULL, NULL, NULL, NULL, 'C-C CHEMOKINE RECEPTOR TYPE 4', 243634),
(341382, 'PTHR10489:SF689', NULL, NULL, NULL, NULL, 'C-X-C CHEMOKINE RECEPTOR TYPE 2', 243634),
(341383, 'PTHR10489:SF942', NULL, NULL, NULL, NULL, 'ATYPICAL CHEMOKINE RECEPTOR 2', 243634),
(341384, 'PTHR10489:SF921', NULL, NULL, NULL, NULL, 'C-X-C CHEMOKINE RECEPTOR TYPE 3-2', 243634);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(341385, 'PTHR10489:SF943', NULL, NULL, NULL, NULL, 'CHEMOKINE (C-C MOTIF) RECEPTOR 6B', 243634),
(341386, 'PTHR10489:SF946', NULL, NULL, NULL, NULL, 'CX3C CHEMOKINE RECEPTOR 1', 243634),
(341387, 'PTHR10489:SF649', NULL, NULL, NULL, NULL, 'C-C CHEMOKINE RECEPTOR TYPE 3', 243634),
(341388, 'PTHR10489:SF627', NULL, NULL, NULL, NULL, 'C-C CHEMOKINE RECEPTOR TYPE 8', 243634),
(341389, 'PTHR10489:SF705', NULL, NULL, NULL, NULL, 'C-X-C CHEMOKINE RECEPTOR TYPE 6', 243634),
(341390, 'PTHR10489:SF925', NULL, NULL, NULL, NULL, 'RELAXIN FAMILY PEPTIDE RECEPTOR 3', 243634),
(341391, 'PTHR10489:SF944', NULL, NULL, NULL, NULL, 'SI:CABZ01093077.1', 243634),
(341392, 'PTHR10489:SF922', NULL, NULL, NULL, NULL, 'CHEMOKINE (C-C MOTIF) RECEPTOR 12A-RELATED', 243634),
(341393, 'PTHR10489:SF945', NULL, NULL, NULL, NULL, 'B2 BRADYKININ RECEPTOR', 243634),
(341394, 'PTHR10489:SF923', NULL, NULL, NULL, NULL, 'C-C CHEMOKINE RECEPTOR 1-LIKE PROTEIN 1', 243634),
(341395, 'PTHR10489', NULL, NULL, NULL, NULL, 'CELL ADHESION MOLECULE', 243634),
(341396, 'PTHR10489:SF664', NULL, NULL, NULL, NULL, 'C-C CHEMOKINE RECEPTOR TYPE 9', 243634),
(341397, 'PTHR10489:SF686', NULL, NULL, NULL, NULL, 'C-C CHEMOKINE RECEPTOR TYPE 5', 243634),
(341398, 'PTHR10489:SF937', NULL, NULL, NULL, NULL, 'RELAXIN FAMILY PEPTIDE RECEPTOR 3.2B', 243634),
(341399, 'PTHR10489:SF618', NULL, NULL, NULL, NULL, 'C-X-C CHEMOKINE RECEPTOR TYPE 5', 243634),
(341400, 'PTHR10489:SF916', NULL, NULL, NULL, NULL, 'C-X-C CHEMOKINE RECEPTOR TYPE 1', 243634),
(341401, 'PTHR10489:SF711', NULL, NULL, NULL, NULL, 'C-C CHEMOKINE RECEPTOR TYPE 1', 243634),
(341402, 'PTHR10489:SF931', NULL, NULL, NULL, NULL, 'ATYPICAL CHEMOKINE RECEPTOR 3', 243634),
(341403, 'PTHR10489:SF733', NULL, NULL, NULL, NULL, 'ATYPICAL CHEMOKINE RECEPTOR 4', 243634),
(341404, 'PTHR10489:SF932', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243634),
(341405, 'PTHR10489:SF635', NULL, NULL, NULL, NULL, 'C-C CHEMOKINE RECEPTOR TYPE 7', 243634),
(341406, 'PTHR10489:SF910', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243634),
(341407, 'PTHR10489:SF930', NULL, NULL, NULL, NULL, 'CHEMOKINE (C-X-C MOTIF) RECEPTOR 1', 243634),
(341408, 'PTHR10489:SF611', NULL, NULL, NULL, NULL, 'C-C CHEMOKINE RECEPTOR TYPE 6', 243634),
(341409, 'PTHR10489:SF655', NULL, NULL, NULL, NULL, 'C-C CHEMOKINE RECEPTOR-LIKE 2', 243634),
(341410, 'PTHR10489:SF913', NULL, NULL, NULL, NULL, 'C-C CHEMOKINE RECEPTOR TYPE 2', 243634),
(341411, 'PTHR10489:SF935', NULL, NULL, NULL, NULL, 'RELAXIN FAMILY PEPTIDE RECEPTOR 3.3A1-RELATED', 243634),
(341412, 'PTHR10489:SF936', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243634),
(341413, 'PTHR10489:SF735', NULL, NULL, NULL, NULL, 'C-C CHEMOKINE RECEPTOR TYPE 10', 243634),
(341414, 'PTHR10489:SF594', NULL, NULL, NULL, NULL, 'C-X-C CHEMOKINE RECEPTOR TYPE 4', 243634),
(341415, 'PTHR10489:SF671', NULL, NULL, NULL, NULL, 'C-X-C CHEMOKINE RECEPTOR TYPE 3', 243634),
(341416, 'PTHR10489:SF730', NULL, NULL, NULL, NULL, 'CHEMOKINE XC RECEPTOR 1', 243634),
(341417, 'PTHR22901', NULL, NULL, NULL, NULL, 'SIALATE O-ACETYLESTERASE', 243635),
(341418, 'PTHR22901:SF0', NULL, NULL, NULL, NULL, 'SIALATE O-ACETYLESTERASE', 243635),
(341419, 'PTHR46554:SF7', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 26B-RELATED', 243636),
(341420, 'PTHR46554:SF8', NULL, NULL, NULL, NULL, 'TFIIS N-TERMINAL DOMAIN-CONTAINING PROTEIN', 243636),
(341421, 'PTHR46554:SF5', NULL, NULL, NULL, NULL, 'OS10G0327400 PROTEIN', 243636),
(341422, 'PTHR46554:SF6', NULL, NULL, NULL, NULL, 'TFIIS N-TERMINAL DOMAIN-CONTAINING PROTEIN', 243636),
(341423, 'PTHR46554:SF3', NULL, NULL, NULL, NULL, 'OS07G0642600 PROTEIN', 243636),
(341424, 'PTHR46554:SF1', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 26B-RELATED', 243636),
(341425, 'PTHR46554:SF2', NULL, NULL, NULL, NULL, 'TFIIS N-TERMINAL DOMAIN-CONTAINING PROTEIN', 243636),
(341426, 'PTHR46554', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 26A-RELATED', 243636);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(341427, 'PTHR46554:SF9', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR IIS-RELATED', 243636),
(341428, 'PTHR37904', NULL, NULL, NULL, NULL, 'OS10G0566900 PROTEIN', 243637),
(341429, 'PTHR37904:SF4', NULL, NULL, NULL, NULL, '', 243637),
(341430, 'PTHR37904:SF2', NULL, NULL, NULL, NULL, 'OS10G0566900 PROTEIN', 243637),
(341431, 'PTHR36928', NULL, NULL, NULL, NULL, 'PHOSPHATASE YCDX-RELATED', 243638),
(341432, 'PTHR36928:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATASE YCDX-RELATED', 243638),
(341433, 'PTHR23503:SF104', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 243639),
(341434, 'PTHR23503:SF126', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 243639),
(341435, 'PTHR23503:SF25', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 243639),
(341436, 'PTHR23503:SF125', NULL, NULL, NULL, NULL, 'PLASTIDIC GLUCOSE TRANSPORTER 3-RELATED', 243639),
(341437, 'PTHR23503:SF103', NULL, NULL, NULL, NULL, 'PLASTIDIC GLUCOSE TRANSPORTER 1-RELATED', 243639),
(341438, 'PTHR23503:SF46', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 243639),
(341439, 'PTHR23503:SF106', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 243639),
(341440, 'PTHR23503:SF128', NULL, NULL, NULL, NULL, 'GLUCOSE TRANSPORTER TYPE 1', 243639),
(341441, 'PTHR23503:SF22', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 2, FACILITATED GLUCOSE TRANSPORTER MEMBER 11', 243639),
(341442, 'PTHR23503:SF127', NULL, NULL, NULL, NULL, 'FI08437P-RELATED', 243639),
(341443, 'PTHR23503:SF105', NULL, NULL, NULL, NULL, 'PROTEIN CBG05043', 243639),
(341444, 'PTHR23503:SF108', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 243639),
(341445, 'PTHR23503:SF43', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 243639),
(341446, 'PTHR23503', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 2', 243639),
(341447, 'PTHR23503:SF42', NULL, NULL, NULL, NULL, 'FACILITATED GLUCOSE TRANSPORTER HOMOLOG', 243639),
(341448, 'PTHR23503:SF1', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 243639),
(341449, 'PTHR23503:SF29', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 243639),
(341450, 'PTHR23503:SF49', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 243639),
(341451, 'PTHR23503:SF27', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 2, FACILITATED GLUCOSE TRANSPORTER MEMBER 2', 243639),
(341452, 'PTHR23503:SF7', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 243639),
(341453, 'PTHR23503:SF50', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 243639),
(341454, 'PTHR23503:SF120', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 2, FACILITATED GLUCOSE TRANSPORTER MEMBER 4', 243639),
(341455, 'PTHR23503:SF91', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 2 MEMBER 3A', 243639),
(341456, 'PTHR23503:SF122', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 2 MEMBER 11,-LIKE', 243639),
(341457, 'PTHR23503:SF121', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 243639),
(341458, 'PTHR23503:SF124', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 2 MEMBER 3B', 243639),
(341459, 'PTHR23503:SF123', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 243639),
(341460, 'PTHR23503:SF8', NULL, NULL, NULL, NULL, 'FACILITATED GLUCOSE TRANSPORTER PROTEIN 1', 243639),
(341461, 'PTHR23503:SF115', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 243639),
(341462, 'PTHR23503:SF114', NULL, NULL, NULL, NULL, 'PLASTIDIC GLUCOSE TRANSPORTER 3-RELATED', 243639),
(341463, 'PTHR23503:SF35', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 2, FACILITATED GLUCOSE TRANSPORTER MEMBER 9', 243639),
(341464, 'PTHR23503:SF34', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 243639),
(341465, 'PTHR23503:SF99', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 2, FACILITATED GLUCOSE TRANSPORTER MEMBER 3', 243639),
(341466, 'PTHR23503:SF11', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 243639),
(341467, 'PTHR23503:SF32', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 2, FACILITATED GLUCOSE TRANSPORTER MEMBER 5', 243639),
(341468, 'PTHR23503:SF10', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 243639);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(341469, 'PTHR23503:SF54', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 243639),
(341470, 'PTHR23503:SF53', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 2, FACILITATED GLUCOSE TRANSPORTER MEMBER 14', 243639),
(341471, 'PTHR23503:SF30', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 2, FACILITATED GLUCOSE TRANSPORTER MEMBER 7', 243639),
(341472, 'PTHR23503:SF96', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 243639),
(341473, 'PTHR23503:SF51', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 2, FACILITATED GLUCOSE TRANSPORTER MEMBER 1', 243639),
(341474, 'PTHR23503:SF39', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 243639),
(341475, 'PTHR23503:SF17', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 243639),
(341476, 'PTHR12308:SF20', NULL, NULL, NULL, NULL, 'ANOCTAMIN-2', 243640),
(341477, 'PTHR12308:SF86', NULL, NULL, NULL, NULL, 'ANOCTAMIN', 243640),
(341478, 'PTHR12308:SF85', NULL, NULL, NULL, NULL, 'ANOCTAMIN', 243640),
(341479, 'PTHR12308:SF84', NULL, NULL, NULL, NULL, 'ANOCTAMIN', 243640),
(341480, 'PTHR12308:SF40', NULL, NULL, NULL, NULL, 'ANOCTAMIN-10', 243640),
(341481, 'PTHR12308:SF83', NULL, NULL, NULL, NULL, 'ANOCTAMIN', 243640),
(341482, 'PTHR12308:SF82', NULL, NULL, NULL, NULL, '', 243640),
(341483, 'PTHR12308:SF81', NULL, NULL, NULL, NULL, 'BNAC06G23840D PROTEIN', 243640),
(341484, 'PTHR12308:SF80', NULL, NULL, NULL, NULL, '', 243640),
(341485, 'PTHR12308', NULL, NULL, NULL, NULL, 'ANOCTAMIN', 243640),
(341486, 'PTHR12308:SF16', NULL, NULL, NULL, NULL, 'ANOCTAMIN-3', 243640),
(341487, 'PTHR12308:SF37', NULL, NULL, NULL, NULL, 'ANOCTAMIN-9', 243640),
(341488, 'PTHR12308:SF15', NULL, NULL, NULL, NULL, 'ANOCTAMIN', 243640),
(341489, 'PTHR12308:SF36', NULL, NULL, NULL, NULL, 'ANOCTAMIN', 243640),
(341490, 'PTHR12308:SF13', NULL, NULL, NULL, NULL, 'ANOCTAMIN-1', 243640),
(341491, 'PTHR12308:SF33', NULL, NULL, NULL, NULL, 'ANOCTAMIN', 243640),
(341492, 'PTHR12308:SF77', NULL, NULL, NULL, NULL, 'MEMBRANE STRESS RESPONSE PROTEIN (IST2), PUTATIVE (AFU_ORTHOLOGUE AFUA_4G03330)-RELATED', 243640),
(341493, 'PTHR12308:SF76', NULL, NULL, NULL, NULL, 'ANOCTAMIN', 243640),
(341494, 'PTHR12308:SF74', NULL, NULL, NULL, NULL, 'ANOCTAMIN', 243640),
(341495, 'PTHR12308:SF51', NULL, NULL, NULL, NULL, 'ANOCTAMIN-8', 243640),
(341496, 'PTHR12308:SF73', NULL, NULL, NULL, NULL, 'INCREASED SODIUM TOLERANCE PROTEIN 2', 243640),
(341497, 'PTHR12308:SF28', NULL, NULL, NULL, NULL, 'ANOCTAMIN-4', 243640),
(341498, 'PTHR12308:SF47', NULL, NULL, NULL, NULL, 'ANOCTAMIN', 243640),
(341499, 'PTHR12308:SF45', NULL, NULL, NULL, NULL, 'ANOCTAMIN', 243640),
(341500, 'PTHR12308:SF23', NULL, NULL, NULL, NULL, 'ANOCTAMIN-5', 243640),
(341501, 'PTHR12308:SF22', NULL, NULL, NULL, NULL, 'ANOCTAMIN-7', 243640),
(341502, 'PTHR12308:SF21', NULL, NULL, NULL, NULL, 'ANOCTAMIN-6', 243640),
(341503, 'PTHR32000', NULL, NULL, NULL, NULL, 'SIMILAR TO HYPOTHETICAL PROTEIN', 243641),
(341504, 'PTHR32000:SF3', NULL, NULL, NULL, NULL, 'SIMILAR TO HYPOTHETICAL PROTEIN', 243641),
(341505, 'PTHR11969:SF85', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTION FACTOR', 243642),
(341506, 'PTHR11969:SF86', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH71', 243642),
(341507, 'PTHR11969:SF64', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH57', 243642),
(341508, 'PTHR11969:SF87', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 243642),
(341509, 'PTHR11969:SF65', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 243642),
(341510, 'PTHR11969:SF88', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 243642),
(341511, 'PTHR11969:SF66', NULL, NULL, NULL, NULL, 'MAD-LIKE PROTEIN 1', 243642),
(341512, 'PTHR11969:SF60', NULL, NULL, NULL, NULL, 'HELIX-LOOP-HELIX DNA-BINDING DOMAIN CONTAINING PROTEIN, EXPRESSED', 243642),
(341513, 'PTHR11969:SF82', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH96', 243642),
(341514, 'PTHR11969:SF83', NULL, NULL, NULL, NULL, 'BASIC HELIX LOOP HELIX (BHLH) DNA-BINDING FAMILY PROTEIN', 243642),
(341515, 'PTHR11969:SF62', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTION FACTOR', 243642);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(341516, 'PTHR11969:SF84', NULL, NULL, NULL, NULL, 'OS03G0122100 PROTEIN', 243642),
(341517, 'PTHR11969:SF18', NULL, NULL, NULL, NULL, 'MAX DIMERIZATION PROTEIN 1', 243642),
(341518, 'PTHR11969:SF78', NULL, NULL, NULL, NULL, 'OS02G0691500 PROTEIN', 243642),
(341519, 'PTHR11969:SF57', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH67', 243642),
(341520, 'PTHR11969:SF13', NULL, NULL, NULL, NULL, 'MAX-INTERACTING PROTEIN 1', 243642),
(341521, 'PTHR11969:SF74', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH70', 243642),
(341522, 'PTHR11969:SF75', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH96-LIKE', 243642),
(341523, 'PTHR11969:SF54', NULL, NULL, NULL, NULL, 'MAX-BINDING PROTEIN MNT', 243642),
(341524, 'PTHR11969:SF77', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH94-LIKE', 243642),
(341525, 'PTHR11969:SF70', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 243642),
(341526, 'PTHR11969:SF92', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 243642),
(341527, 'PTHR11969:SF71', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 243642),
(341528, 'PTHR11969:SF93', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH94-LIKE', 243642),
(341529, 'PTHR11969:SF94', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH71', 243642),
(341530, 'PTHR11969:SF72', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH94-LIKE', 243642),
(341531, 'PTHR11969:SF73', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTION FACTOR', 243642),
(341532, 'PTHR11969:SF90', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN-CONTAINING PROTEIN-RELATED', 243642),
(341533, 'PTHR11969:SF91', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 243642),
(341534, 'PTHR11969', NULL, NULL, NULL, NULL, 'MAX DIMERIZATION, MAD', 243642),
(341535, 'PTHR11969:SF6', NULL, NULL, NULL, NULL, 'MAX DIMERIZATION PROTEIN 3', 243642),
(341536, 'PTHR11969:SF4', NULL, NULL, NULL, NULL, 'MAX DIMERIZATION PROTEIN 4', 243642),
(341537, 'PTHR11969:SF89', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH99', 243642),
(341538, 'PTHR11969:SF68', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 243642),
(341539, 'PTHR11969:SF46', NULL, NULL, NULL, NULL, 'OS05G0586300 PROTEIN', 243642),
(341540, 'PTHR11969:SF69', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH94', 243642),
(341541, 'PTHR15690', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR COACTIVATOR 6', 243643),
(341542, 'PTHR15690:SF0', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR COACTIVATOR 6', 243643),
(341543, 'PTHR46431:SF15', NULL, NULL, NULL, NULL, 'BNAC02G34430D PROTEIN', 243644),
(341544, 'PTHR46431:SF14', NULL, NULL, NULL, NULL, 'BNAC08G41160D PROTEIN', 243644),
(341545, 'PTHR46431:SF13', NULL, NULL, NULL, NULL, 'SNARE ASSOCIATED GOLGI PROTEIN-RELATED', 243644),
(341546, 'PTHR46431:SF12', NULL, NULL, NULL, NULL, 'SNARE ASSOCIATED GOLGI PROTEIN-RELATED', 243644),
(341547, 'PTHR46431:SF11', NULL, NULL, NULL, NULL, '', 243644),
(341548, 'PTHR46431', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243644),
(341549, 'PTHR46431:SF2', NULL, NULL, NULL, NULL, 'OS07G0634000 PROTEIN', 243644),
(341550, 'PTHR46431:SF7', NULL, NULL, NULL, NULL, 'SNARE ASSOCIATED GOLGI PROTEIN FAMILY', 243644),
(341551, 'PTHR46431:SF8', NULL, NULL, NULL, NULL, 'SNARE ASSOCIATED GOLGI PROTEIN FAMILY', 243644),
(341552, 'PTHR46431:SF9', NULL, NULL, NULL, NULL, 'SNARE ASSOCIATED GOLGI FAMILY PROTEIN-RELATED', 243644),
(341553, 'PTHR46431:SF4', NULL, NULL, NULL, NULL, 'ASSOCIATED GOLGI PROTEIN FAMILY, PUTATIVE-RELATED', 243644),
(341554, 'PTHR46431:SF5', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243644),
(341555, 'PTHR46431:SF6', NULL, NULL, NULL, NULL, 'BNAC05G09390D PROTEIN', 243644),
(341556, 'PTHR46431:SF16', NULL, NULL, NULL, NULL, 'BNACNNG33450D PROTEIN', 243644),
(341557, 'PTHR31665', NULL, NULL, NULL, NULL, 'FLYWCH FAMILY MEMBER 2-RELATED', 243645),
(341558, 'PTHR31665:SF0', NULL, NULL, NULL, NULL, 'FLYWCH FAMILY MEMBER 2', 243645),
(341559, 'PTHR31665:SF3', NULL, NULL, NULL, NULL, 'FLYWCH-TYPE ZINC FINGER-CONTAINING PROTEIN 1', 243645),
(341560, 'PTHR47888:SF1', NULL, NULL, NULL, NULL, 'UPF0730 PROTEIN ENCODED BY LINC00643-RELATED', 243646);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(341561, 'PTHR47888', NULL, NULL, NULL, NULL, 'UPF0730 PROTEIN ENCODED BY LINC00643-RELATED', 243646),
(341562, 'PTHR31446:SF40', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE/VANADIUM-DEPENDENT HALOPEROXIDASE-RELATED PROTEIN', 243647),
(341563, 'PTHR31446:SF2', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE/VANADIUM-DEPENDENT HALOPEROXIDASE-RELATED PROTEIN', 243647),
(341564, 'PTHR31446:SF8', NULL, NULL, NULL, NULL, 'OS04G0486900 PROTEIN', 243647),
(341565, 'PTHR31446', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE/VANADIUM-DEPENDENT HALOPEROXIDASE-RELATED PROTEIN', 243647),
(341566, 'PTHR31446:SF29', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE/VANADIUM-DEPENDENT HALOPEROXIDASE-RELATED PROTEIN', 243647),
(341567, 'PTHR31446:SF27', NULL, NULL, NULL, NULL, 'BNAA03G36360D PROTEIN', 243647),
(341568, 'PTHR31446:SF38', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE/VANADIUM-DEPENDENT HALOPEROXIDASE-RELATED PROTEIN-RELATED', 243647),
(341569, 'PTHR31446:SF39', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE/VANADIUM-DEPENDENT HALOPEROXIDASE-RELATED PROTEIN', 243647),
(341570, 'PTHR31446:SF36', NULL, NULL, NULL, NULL, 'BNAC06G18170D PROTEIN', 243647),
(341571, 'PTHR31446:SF37', NULL, NULL, NULL, NULL, '', 243647),
(341572, 'PTHR31446:SF32', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE/VANADIUM-DEPENDENT HALOPEROXIDASE-RELATED PROTEIN', 243647),
(341573, 'PTHR31446:SF22', NULL, NULL, NULL, NULL, 'BNAA08G19060D PROTEIN', 243647),
(341574, 'PTHR31446:SF41', NULL, NULL, NULL, NULL, 'OS01G0901800 PROTEIN', 243647),
(341575, 'PTHR31446:SF31', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE/VANADIUM-DEPENDENT HALOPEROXIDASE-RELATED PROTEIN-RELATED', 243647),
(341576, 'PTHR47390', NULL, NULL, NULL, NULL, 'PODOPLANIN', 243648),
(341577, 'PTHR47390:SF1', NULL, NULL, NULL, NULL, 'PODOPLANIN', 243648),
(341578, 'PTHR34995:SF1', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT BETA', 243649),
(341579, 'PTHR34995', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT BETA', 243649),
(341580, 'PTHR12592:SF0', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT (S)-NAD(P)H-HYDRATE DEHYDRATASE', 243650),
(341581, 'PTHR12592', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT (S)-NAD(P)H-HYDRATE DEHYDRATASE FAMILY MEMBER', 243650),
(341582, 'PTHR12592:SF2', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT (S)-NAD(P)H-HYDRATE DEHYDRATASE', 243650),
(341583, 'PTHR43204:SF2', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, ATP-BINDING PROTEIN', 243651),
(341584, 'PTHR43204', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER I FAMILY MEMBER 6, CHLOROPLASTIC', 243651),
(341585, 'PTHR43204:SF1', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER I FAMILY MEMBER 6, CHLOROPLASTIC', 243651),
(341586, 'PTHR40061:SF2', NULL, NULL, NULL, NULL, 'PRC DOMAIN-CONTAINING PROTEIN', 243652),
(341587, 'PTHR40061:SF1', NULL, NULL, NULL, NULL, 'SPORULATION PROTEIN YLMC-RELATED', 243652),
(341588, 'PTHR40061', NULL, NULL, NULL, NULL, 'SPORULATION PROTEIN YLMC-RELATED', 243652),
(341589, 'PTHR26453:SF329', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341590, 'PTHR26453:SF208', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341591, 'PTHR26453:SF205', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10S1', 243653),
(341592, 'PTHR26453:SF569', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341593, 'PTHR26453:SF203', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341594, 'PTHR26453:SF566', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 975', 243653),
(341595, 'PTHR26453:SF688', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341596, 'PTHR26453:SF204', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2M3', 243653),
(341597, 'PTHR26453:SF322', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 149', 243653),
(341598, 'PTHR26453:SF685', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341599, 'PTHR26453:SF202', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2B6', 243653),
(341600, 'PTHR26453:SF323', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2H1', 243653),
(341601, 'PTHR26453:SF683', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341602, 'PTHR26453:SF562', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 13F1', 243653);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(341603, 'PTHR26453:SF321', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341604, 'PTHR26453:SF682', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10G8', 243653),
(341605, 'PTHR26453:SF680', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2L3', 243653),
(341606, 'PTHR26453:SF82', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR-RELATED', 243653),
(341607, 'PTHR26453:SF81', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341608, 'PTHR26453:SF86', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341609, 'PTHR26453:SF84', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341610, 'PTHR26453:SF89', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341611, 'PTHR26453:SF88', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10G2', 243653),
(341612, 'PTHR26453:SF87', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 13C8', 243653),
(341613, 'PTHR26453:SF219', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341614, 'PTHR26453:SF216', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2I1-RELATED', 243653),
(341615, 'PTHR26453:SF217', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341616, 'PTHR26453:SF698', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341617, 'PTHR26453:SF214', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2AJ1', 243653),
(341618, 'PTHR26453:SF215', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10AD1', 243653),
(341619, 'PTHR26453:SF699', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341620, 'PTHR26453:SF696', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341621, 'PTHR26453:SF213', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341622, 'PTHR26453:SF697', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 6N1', 243653),
(341623, 'PTHR26453:SF694', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341624, 'PTHR26453:SF695', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341625, 'PTHR26453:SF692', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10A6', 243653),
(341626, 'PTHR26453:SF330', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341627, 'PTHR26453:SF693', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243653),
(341628, 'PTHR26453:SF690', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341629, 'PTHR26453:SF691', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341630, 'PTHR26453:SF570', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341631, 'PTHR26453:SF93', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341632, 'PTHR26453:SF92', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341633, 'PTHR26453:SF91', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2M4', 243653),
(341634, 'PTHR26453:SF97', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341635, 'PTHR26453:SF96', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2Z1', 243653),
(341636, 'PTHR26453:SF95', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR FAMILY 10 SUBFAMILY AI MEMBER 1', 243653),
(341637, 'PTHR26453:SF94', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341638, 'PTHR26453:SF669', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10C1', 243653),
(341639, 'PTHR26453:SF665', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341640, 'PTHR26453:SF302', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341641, 'PTHR26453:SF303', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2Y1', 243653),
(341642, 'PTHR26453:SF663', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341643, 'PTHR26453:SF301', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341644, 'PTHR26453:SF661', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341645, 'PTHR26453:SF660', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341646, 'PTHR26453:SF318', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2J2', 243653),
(341647, 'PTHR26453:SF678', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341648, 'PTHR26453:SF315', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 13C9', 243653),
(341649, 'PTHR26453:SF679', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341650, 'PTHR26453:SF316', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2T4', 243653);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(341651, 'PTHR26453:SF676', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341652, 'PTHR26453:SF677', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 978-RELATED', 243653),
(341653, 'PTHR26453:SF314', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2M7', 243653),
(341654, 'PTHR26453:SF674', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2G3', 243653),
(341655, 'PTHR26453:SF312', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2AG2', 243653),
(341656, 'PTHR26453:SF672', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341657, 'PTHR26453:SF673', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243653),
(341658, 'PTHR26453:SF671', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341659, 'PTHR26453:SF128', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341660, 'PTHR26453:SF249', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1511', 243653),
(341661, 'PTHR26453:SF247', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341662, 'PTHR26453:SF127', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341663, 'PTHR26453:SF245', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341664, 'PTHR26453:SF124', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1342', 243653),
(341665, 'PTHR26453:SF125', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2T1', 243653),
(341666, 'PTHR26453:SF122', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341667, 'PTHR26453:SF120', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 700', 243653),
(341668, 'PTHR26453:SF121', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 13C5', 243653),
(341669, 'PTHR26453:SF240', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 225', 243653),
(341670, 'PTHR26453:SF139', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341671, 'PTHR26453:SF138', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341672, 'PTHR26453:SF135', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341673, 'PTHR26453:SF136', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2D3', 243653),
(341674, 'PTHR26453:SF257', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341675, 'PTHR26453:SF254', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2B2', 243653),
(341676, 'PTHR26453:SF133', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341677, 'PTHR26453:SF255', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341678, 'PTHR26453:SF252', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341679, 'PTHR26453:SF132', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2G2', 243653),
(341680, 'PTHR26453:SF130', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 695', 243653),
(341681, 'PTHR26453:SF108', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341682, 'PTHR26453:SF109', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 6Y1', 243653),
(341683, 'PTHR26453:SF227', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1340', 243653),
(341684, 'PTHR26453:SF106', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341685, 'PTHR26453:SF228', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341686, 'PTHR26453:SF588', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341687, 'PTHR26453:SF225', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341688, 'PTHR26453:SF589', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1A1', 243653),
(341689, 'PTHR26453:SF105', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341690, 'PTHR26453:SF586', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 693-RELATED', 243653),
(341691, 'PTHR26453:SF223', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2W3', 243653),
(341692, 'PTHR26453:SF102', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2L13', 243653),
(341693, 'PTHR26453:SF224', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 62', 243653),
(341694, 'PTHR26453:SF103', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2B3-RELATED', 243653),
(341695, 'PTHR26453:SF221', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10D3-RELATED', 243653),
(341696, 'PTHR26453:SF222', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341697, 'PTHR26453:SF585', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 976', 243653);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(341698, 'PTHR26453:SF582', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341699, 'PTHR26453:SF220', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 699', 243653),
(341700, 'PTHR26453:SF580', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341701, 'PTHR26453:SF119', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR M34', 243653),
(341702, 'PTHR26453:SF238', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 148', 243653),
(341703, 'PTHR26453:SF117', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2C3', 243653),
(341704, 'PTHR26453:SF118', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1145', 243653),
(341705, 'PTHR26453:SF239', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341706, 'PTHR26453:SF115', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR-RELATED', 243653),
(341707, 'PTHR26453:SF237', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2C1', 243653),
(341708, 'PTHR26453:SF116', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2F1', 243653),
(341709, 'PTHR26453:SF234', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 6A2', 243653),
(341710, 'PTHR26453:SF235', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2V2', 243653),
(341711, 'PTHR26453:SF232', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2A5', 243653),
(341712, 'PTHR26453:SF112', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2B11', 243653),
(341713, 'PTHR26453:SF230', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341714, 'PTHR26453:SF231', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR M37', 243653),
(341715, 'PTHR26453:SF110', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2G6', 243653),
(341716, 'PTHR26453:SF603', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1338', 243653),
(341717, 'PTHR26453:SF601', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341718, 'PTHR26453:SF169', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2W1', 243653),
(341719, 'PTHR26453:SF166', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2L5', 243653),
(341720, 'PTHR26453:SF285', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341721, 'PTHR26453:SF164', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR-RELATED', 243653),
(341722, 'PTHR26453', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341723, 'PTHR26453:SF286', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2T33-RELATED', 243653),
(341724, 'PTHR26453:SF165', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341725, 'PTHR26453:SF163', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341726, 'PTHR26453:SF284', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 6B1', 243653),
(341727, 'PTHR26453:SF171', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341728, 'PTHR26453:SF293', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 13G1-LIKE', 243653),
(341729, 'PTHR26453:SF607', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 701', 243653),
(341730, 'PTHR26453:SF608', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR M32', 243653),
(341731, 'PTHR26453:SF616', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 13C2', 243653),
(341732, 'PTHR26453:SF17', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341733, 'PTHR26453:SF16', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341734, 'PTHR26453:SF617', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2H2', 243653),
(341735, 'PTHR26453:SF614', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341736, 'PTHR26453:SF15', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341737, 'PTHR26453:SF14', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 13C4', 243653),
(341738, 'PTHR26453:SF613', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10H4', 243653),
(341739, 'PTHR26453:SF19', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10D4-RELATED', 243653),
(341740, 'PTHR26453:SF18', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2T2-RELATED', 243653),
(341741, 'PTHR26453:SF179', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10G6', 243653),
(341742, 'PTHR26453:SF178', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341743, 'PTHR26453:SF299', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2AK2', 243653),
(341744, 'PTHR26453:SF175', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341745, 'PTHR26453:SF297', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(341746, 'PTHR26453:SF176', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2S2', 243653),
(341747, 'PTHR26453:SF294', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR FAMILY 10 SUBFAMILY K MEMBER 2', 243653),
(341748, 'PTHR26453:SF173', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2T11', 243653),
(341749, 'PTHR26453:SF295', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5V1', 243653),
(341750, 'PTHR26453:SF174', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341751, 'PTHR26453:SF183', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2AG1', 243653),
(341752, 'PTHR26453:SF13', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341753, 'PTHR26453:SF12', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341754, 'PTHR26453:SF618', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1D2', 243653),
(341755, 'PTHR26453:SF11', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 13', 243653),
(341756, 'PTHR26453:SF10', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 697-RELATED', 243653),
(341757, 'PTHR26453:SF619', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10J6-RELATED', 243653),
(341758, 'PTHR26453:SF28', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2M5', 243653),
(341759, 'PTHR26453:SF704', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341760, 'PTHR26453:SF27', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR-RELATED', 243653),
(341761, 'PTHR26453:SF705', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10H3', 243653),
(341762, 'PTHR26453:SF26', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341763, 'PTHR26453:SF702', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341764, 'PTHR26453:SF25', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341765, 'PTHR26453:SF703', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341766, 'PTHR26453:SF700', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10J5', 243653),
(341767, 'PTHR26453:SF701', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341768, 'PTHR26453:SF269', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341769, 'PTHR26453:SF148', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10A5', 243653),
(341770, 'PTHR26453:SF29', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1395', 243653),
(341771, 'PTHR26453:SF147', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341772, 'PTHR26453:SF265', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341773, 'PTHR26453:SF145', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341774, 'PTHR26453:SF263', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341775, 'PTHR26453:SF264', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341776, 'PTHR26453:SF261', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341777, 'PTHR26453:SF140', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 6Q1', 243653),
(341778, 'PTHR26453:SF270', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341779, 'PTHR26453:SF150', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341780, 'PTHR26453:SF271', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2V1', 243653),
(341781, 'PTHR26453:SF20', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 6', 243653),
(341782, 'PTHR26453:SF708', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341783, 'PTHR26453:SF23', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341784, 'PTHR26453:SF709', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR FAMILY 4 SUBFAMILY D MEMBER 5', 243653),
(341785, 'PTHR26453:SF706', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341786, 'PTHR26453:SF22', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10A7', 243653),
(341787, 'PTHR26453:SF707', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341788, 'PTHR26453:SF21', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2W6-RELATED', 243653),
(341789, 'PTHR26453:SF715', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243653),
(341790, 'PTHR26453:SF38', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 13J1', 243653),
(341791, 'PTHR26453:SF716', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341792, 'PTHR26453:SF713', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 509', 243653);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(341793, 'PTHR26453:SF36', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341794, 'PTHR26453:SF714', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341795, 'PTHR26453:SF711', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 479', 243653),
(341796, 'PTHR26453:SF712', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10H1-RELATED', 243653),
(341797, 'PTHR26453:SF159', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10AG1', 243653),
(341798, 'PTHR26453:SF710', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341799, 'PTHR26453:SF276', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341800, 'PTHR26453:SF156', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2D2', 243653),
(341801, 'PTHR26453:SF153', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341802, 'PTHR26453:SF154', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341803, 'PTHR26453:SF272', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341804, 'PTHR26453:SF273', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341805, 'PTHR26453:SF160', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341806, 'PTHR26453:SF161', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2T29-RELATED', 243653),
(341807, 'PTHR26453:SF31', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341808, 'PTHR26453:SF30', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10A3', 243653),
(341809, 'PTHR26453:SF34', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 13C3', 243653),
(341810, 'PTHR26453:SF717', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341811, 'PTHR26453:SF33', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341812, 'PTHR26453:SF32', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341813, 'PTHR26453:SF647', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341814, 'PTHR26453:SF645', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2L2', 243653),
(341815, 'PTHR26453:SF646', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341816, 'PTHR26453:SF643', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2T12', 243653),
(341817, 'PTHR26453:SF644', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341818, 'PTHR26453:SF641', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2J3', 243653),
(341819, 'PTHR26453:SF642', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341820, 'PTHR26453:SF0', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 13D1', 243653),
(341821, 'PTHR26453:SF4', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2T3-RELATED', 243653),
(341822, 'PTHR26453:SF3', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341823, 'PTHR26453:SF42', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341824, 'PTHR26453:SF6', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10G4-RELATED', 243653),
(341825, 'PTHR26453:SF8', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341826, 'PTHR26453:SF40', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341827, 'PTHR26453:SF7', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10G7', 243653),
(341828, 'PTHR26453:SF45', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341829, 'PTHR26453:SF9', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10A4', 243653),
(341830, 'PTHR26453:SF44', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1328-RELATED', 243653),
(341831, 'PTHR26453:SF43', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341832, 'PTHR26453:SF658', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341833, 'PTHR26453:SF59', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1341', 243653),
(341834, 'PTHR26453:SF58', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2D2-LIKE', 243653),
(341835, 'PTHR26453:SF659', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR FAMILY 2 SUBFAMILY L MEMBER 2', 243653),
(341836, 'PTHR26453:SF656', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR-RELATED', 243653),
(341837, 'PTHR26453:SF654', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341838, 'PTHR26453:SF655', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341839, 'PTHR26453:SF650', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341840, 'PTHR26453:SF651', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(341841, 'PTHR26453:SF52', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341842, 'PTHR26453:SF51', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341843, 'PTHR26453:SF50', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2A12', 243653),
(341844, 'PTHR26453:SF57', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2T6', 243653),
(341845, 'PTHR26453:SF56', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1339', 243653),
(341846, 'PTHR26453:SF627', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341847, 'PTHR26453:SF625', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10A2', 243653),
(341848, 'PTHR26453:SF69', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10G3', 243653),
(341849, 'PTHR26453:SF626', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 3A2', 243653),
(341850, 'PTHR26453:SF622', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341851, 'PTHR26453:SF188', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 706', 243653),
(341852, 'PTHR26453:SF186', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341853, 'PTHR26453:SF184', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2J1', 243653),
(341854, 'PTHR26453:SF185', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 703', 243653),
(341855, 'PTHR26453:SF193', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341856, 'PTHR26453:SF194', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10P1', 243653),
(341857, 'PTHR26453:SF192', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341858, 'PTHR26453:SF60', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341859, 'PTHR26453:SF190', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341860, 'PTHR26453:SF64', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341861, 'PTHR26453:SF63', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2F2', 243653),
(341862, 'PTHR26453:SF629', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341863, 'PTHR26453:SF65', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341864, 'PTHR26453:SF638', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10AC1', 243653),
(341865, 'PTHR26453:SF639', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2M2', 243653),
(341866, 'PTHR26453:SF636', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2B8-RELATED', 243653),
(341867, 'PTHR26453:SF637', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341868, 'PTHR26453:SF634', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341869, 'PTHR26453:SF635', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 13C7-RELATED', 243653),
(341870, 'PTHR26453:SF632', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2L8', 243653),
(341871, 'PTHR26453:SF633', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2T10', 243653),
(341872, 'PTHR26453:SF631', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341873, 'PTHR26453:SF199', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341874, 'PTHR26453:SF198', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2K2', 243653),
(341875, 'PTHR26453:SF195', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341876, 'PTHR26453:SF196', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2AE1', 243653),
(341877, 'PTHR26453:SF71', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 243653),
(341878, 'PTHR26453:SF75', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 960', 243653),
(341879, 'PTHR26453:SF73', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 6P1', 243653),
(341880, 'PTHR26453:SF79', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2W5 PSEUDOGENE-RELATED', 243653),
(341881, 'PTHR26453:SF78', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2T27-RELATED', 243653),
(341882, 'PTHR26453:SF76', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 13H1', 243653),
(341883, 'PTHR36862:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 428', 243654),
(341884, 'PTHR36862', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 428', 243654),
(341885, 'PTHR21137:SF40', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR 56A', 243655),
(341886, 'PTHR21137:SF41', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR 67D-RELATED', 243655),
(341887, 'PTHR21137', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR', 243655),
(341888, 'PTHR21137:SF9', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR CORECEPTOR', 243655);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(341889, 'PTHR21137:SF42', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR 83A', 243655),
(341890, 'PTHR21137:SF43', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR 47A-RELATED', 243655),
(341891, 'PTHR21137:SF44', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR 13A-RELATED', 243655),
(341892, 'PTHR21137:SF35', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR 19A-RELATED', 243655),
(341893, 'PTHR21137:SF37', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR 46A, ISOFORM B-RELATED', 243655),
(341894, 'PTHR21137:SF26', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR 10A-RELATED', 243655),
(341895, 'PTHR21137:SF3', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR 30A-RELATED', 243655),
(341896, 'PTHR23350', NULL, NULL, NULL, NULL, 'PEROXISOME ASSEMBLY PROTEIN 10', 243656),
(341897, 'PTHR23350:SF6', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 243656),
(341898, 'PTHR23350:SF5', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 243656),
(341899, 'PTHR23350:SF4', NULL, NULL, NULL, NULL, 'PEROXIN-2', 243656),
(341900, 'PTHR23350:SF0', NULL, NULL, NULL, NULL, 'PEROXISOME BIOGENESIS FACTOR 10', 243656),
(341901, 'PTHR12049:SF5', NULL, NULL, NULL, NULL, 'PROTEIN ARGININE METHYLTRANSFERASE NDUFAF7 HOMOLOG, MITOCHONDRIAL', 243657),
(341902, 'PTHR12049', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243657),
(341903, 'PTHR12049:SF7', NULL, NULL, NULL, NULL, 'PROTEIN ARGININE METHYLTRANSFERASE NDUFAF7, MITOCHONDRIAL', 243657),
(341904, 'PTHR12906:SF0', NULL, NULL, NULL, NULL, 'RESPIRASOME COMPLEX ASSEMBLY FACTOR 1', 243658),
(341905, 'PTHR12906:SF2', NULL, NULL, NULL, NULL, 'BNAA04G16800D PROTEIN', 243658),
(341906, 'PTHR12906:SF1', NULL, NULL, NULL, NULL, '', 243658),
(341907, 'PTHR12906', NULL, NULL, NULL, NULL, 'PROTEIN C20ORF24  RAB5-INTERACTING PROTEIN', 243658),
(341908, 'PTHR12906:SF3', NULL, NULL, NULL, NULL, 'BNAC04G15250D PROTEIN', 243658),
(341909, 'PTHR43785:SF9', NULL, NULL, NULL, NULL, 'GLN-SYNT_C DOMAIN-CONTAINING PROTEIN', 243659),
(341910, 'PTHR43785:SF14', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE', 243659),
(341911, 'PTHR43785:SF8', NULL, NULL, NULL, NULL, 'TYPE-1 GLUTAMINE SYNTHETASE 1-LIKE ISOFORM X1', 243659),
(341912, 'PTHR43785:SF7', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE-LIKE', 243659),
(341913, 'PTHR43785:SF3', NULL, NULL, NULL, NULL, 'GLN-SYNT_C DOMAIN-CONTAINING PROTEIN', 243659),
(341914, 'PTHR43785:SF11', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE', 243659),
(341915, 'PTHR43785:SF12', NULL, NULL, NULL, NULL, 'TYPE-1 GLUTAMINE SYNTHETASE 2', 243659),
(341916, 'PTHR43785:SF2', NULL, NULL, NULL, NULL, 'TYPE-1 GLUTAMINE SYNTHETASE 1', 243659),
(341917, 'PTHR43785', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYLPUTRESCINE SYNTHETASE', 243659),
(341918, 'PTHR46175:SF10', NULL, NULL, NULL, NULL, 'BNAA07G01250D PROTEIN', 243660),
(341919, 'PTHR46175', NULL, NULL, NULL, NULL, 'BACTERIOOPSIN TRANSCRIPTIONAL ACTIVATOR', 243660),
(341920, 'PTHR46175:SF9', NULL, NULL, NULL, NULL, 'LKP2', 243660),
(341921, 'PTHR46175:SF12', NULL, NULL, NULL, NULL, 'ADAGIO PROTEIN 2', 243660),
(341922, 'PTHR46175:SF2', NULL, NULL, NULL, NULL, 'ADAGIO PROTEIN 3', 243660),
(341923, 'PTHR46175:SF5', NULL, NULL, NULL, NULL, 'ADAGIO PROTEIN 1', 243660),
(341924, 'PTHR46175:SF4', NULL, NULL, NULL, NULL, 'BACTERIOOPSIN TRANSCRIPTIONAL ACTIVATOR', 243660),
(341925, 'PTHR46175:SF1', NULL, NULL, NULL, NULL, 'ADAGIO-LIKE PROTEIN 2-RELATED', 243660),
(341926, 'PTHR13503', NULL, NULL, NULL, NULL, 'NEGATIVE ELONGATION FACTOR COMPLEX MEMBER B', 243661),
(341927, 'PTHR13503:SF3', NULL, NULL, NULL, NULL, 'NEGATIVE ELONGATION FACTOR B', 243661),
(341928, 'PTHR32037:SF2', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 12A', 243662),
(341929, 'PTHR32037', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 12A', 243662),
(341930, 'PTHR12980:SF6', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 9-LIKE', 243663),
(341931, 'PTHR12980:SF8', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 9-LIKE', 243663),
(341932, 'PTHR12980:SF7', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 9-LIKE', 243663);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(341933, 'PTHR12980:SF0', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 9', 243663),
(341934, 'PTHR12980', NULL, NULL, NULL, NULL, 'UBIQUINOL-CYTOCHROME C REDUCTASE COMPLEX, SUBUNIT X', 243663),
(341935, 'PTHR16074', NULL, NULL, NULL, NULL, 'BARDET-BIEDL SYNDROME 7 PROTEIN', 243664),
(341936, 'PTHR16074:SF4', NULL, NULL, NULL, NULL, 'BARDET-BIEDL SYNDROME 7 PROTEIN', 243664),
(341937, 'PTHR47174:SF1', NULL, NULL, NULL, NULL, 'REDUCED VIABILITY UPON STARVATION PROTEIN 167', 243665),
(341938, 'PTHR47174:SF2', NULL, NULL, NULL, NULL, 'SH3 DOMAIN SIGNALLING PROTEIN (AFU_ORTHOLOGUE AFUA_5G07670)', 243665),
(341939, 'PTHR47174:SF3', NULL, NULL, NULL, NULL, 'BRIDGING INTEGRATOR 3', 243665),
(341940, 'PTHR47174', NULL, NULL, NULL, NULL, 'BRIDGING INTEGRATOR 3', 243665),
(341941, 'PTHR24073:SF897', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB', 243666),
(341942, 'PTHR24073:SF898', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA5D', 243666),
(341943, 'PTHR24073:SF1083', NULL, NULL, NULL, NULL, '', 243666),
(341944, 'PTHR24073:SF653', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-43', 243666),
(341945, 'PTHR24073:SF382', NULL, NULL, NULL, NULL, 'RABX6, ISOFORM B', 243666),
(341946, 'PTHR24073:SF1125', NULL, NULL, NULL, NULL, 'RE48347P', 243666),
(341947, 'PTHR24073:SF263', NULL, NULL, NULL, NULL, 'RAB-LIKE PROTEIN 2A-RELATED', 243666),
(341948, 'PTHR24073:SF1007', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABD1', 243666),
(341949, 'PTHR24073:SF1089', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-6A-RELATED', 243666),
(341950, 'PTHR24073:SF1000', NULL, NULL, NULL, NULL, 'SMALL MONOMERIC GTPASE-RELATED', 243666),
(341951, 'PTHR24073:SF1123', NULL, NULL, NULL, NULL, 'SMALL GTPASE SUPERFAMILY, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 243666),
(341952, 'PTHR24073:SF1009', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABC2B', 243666),
(341953, 'PTHR24073:SF1129', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-5A', 243666),
(341954, 'PTHR24073:SF528', NULL, NULL, NULL, NULL, 'INTRAFLAGELLAR TRANSPORT PROTEIN 22 HOMOLOG', 243666),
(341955, 'PTHR24073:SF643', NULL, NULL, NULL, NULL, 'SMALL GTPASE SUPERFAMILY, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 243666),
(341956, 'PTHR24073:SF1195', NULL, NULL, NULL, NULL, 'BNAANNG05430D PROTEIN', 243666),
(341957, 'PTHR24073:SF1194', NULL, NULL, NULL, NULL, '', 243666),
(341958, 'PTHR24073:SF128', NULL, NULL, NULL, NULL, 'RAB-LIKE PROTEIN 3', 243666),
(341959, 'PTHR24073:SF1197', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE, EXPRESSED-RELATED', 243666),
(341960, 'PTHR24073:SF1196', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN YPT10-RELATED', 243666),
(341961, 'PTHR24073:SF1191', NULL, NULL, NULL, NULL, 'SMALL GTPASE SUPERFAMILY, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 243666),
(341962, 'PTHR24073:SF1190', NULL, NULL, NULL, NULL, 'RAB GTPASE-RELATED', 243666),
(341963, 'PTHR24073:SF882', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABJ-RELATED', 243666),
(341964, 'PTHR24073:SF1193', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN, PUTATIVE-RELATED', 243666),
(341965, 'PTHR24073:SF366', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-5C', 243666),
(341966, 'PTHR24073:SF1192', NULL, NULL, NULL, NULL, 'SMALL GTPASE SUPERFAMILY, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 243666),
(341967, 'PTHR24073:SF1199', NULL, NULL, NULL, NULL, 'SMALL GTPASE FAMILY RAB PROTEIN', 243666),
(341968, 'PTHR24073:SF1198', NULL, NULL, NULL, NULL, 'SMALL GTPASE SUPERFAMILY, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 243666),
(341969, 'PTHR24073:SF1119', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN, PUTATIVE-RELATED', 243666),
(341970, 'PTHR24073:SF912', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-17', 243666),
(341971, 'PTHR24073:SF1142', NULL, NULL, NULL, NULL, 'BNAA09G07020D PROTEIN', 243666),
(341972, 'PTHR24073:SF997', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABC', 243666),
(341973, 'PTHR24073:SF910', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-22A', 243666);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(341974, 'PTHR24073:SF1148', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN YPTM1', 243666),
(341975, 'PTHR24073:SF362', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-19', 243666),
(341976, 'PTHR24073:SF509', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-21', 243666),
(341977, 'PTHR24073:SF1090', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABF2A', 243666),
(341978, 'PTHR24073:SF1096', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-1B', 243666),
(341979, 'PTHR24073:SF588', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-31', 243666),
(341980, 'PTHR24073:SF469', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-41', 243666),
(341981, 'PTHR24073:SF1130', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABH1D', 243666),
(341982, 'PTHR24073:SF1092', NULL, NULL, NULL, NULL, 'OS01G0667600 PROTEIN', 243666),
(341983, 'PTHR24073:SF343', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-6B', 243666),
(341984, 'PTHR24073:SF862', NULL, NULL, NULL, NULL, 'RAB32, ISOFORM B', 243666),
(341985, 'PTHR24073:SF471', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-24', 243666),
(341986, 'PTHR24073:SF1018', NULL, NULL, NULL, NULL, 'RAB-TYPE SMALL G PROTEIN', 243666),
(341987, 'PTHR24073:SF1139', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-32B', 243666),
(341988, 'PTHR24073:SF352', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB6', 243666),
(341989, 'PTHR24073:SF1138', NULL, NULL, NULL, NULL, 'SMALL MONOMERIC GTPASE-RELATED', 243666),
(341990, 'PTHR24073:SF618', NULL, NULL, NULL, NULL, 'OS10G0441800 PROTEIN', 243666),
(341991, 'PTHR24073:SF858', NULL, NULL, NULL, NULL, 'DRAB5', 243666),
(341992, 'PTHR24073:SF1162', NULL, NULL, NULL, NULL, 'GTP BINDING PROTEIN', 243666),
(341993, 'PTHR24073:SF974', NULL, NULL, NULL, NULL, 'RAB GTPASE-RELATED', 243666),
(341994, 'PTHR24073:SF212', NULL, NULL, NULL, NULL, 'FI01544P', 243666),
(341995, 'PTHR24073:SF1160', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABF1', 243666),
(341996, 'PTHR24073:SF1203', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN HOMOLOG1', 243666),
(341997, 'PTHR24073:SF1202', NULL, NULL, NULL, NULL, 'RAB6B, MEMBER RAS ONCOGENE FAMILY B', 243666),
(341998, 'PTHR24073:SF185', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-14', 243666),
(341999, 'PTHR24073:SF1205', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-5B-RELATED', 243666),
(342000, 'PTHR24073:SF1204', NULL, NULL, NULL, NULL, 'PROTEIN CBG25881', 243666),
(342001, 'PTHR24073:SF1168', NULL, NULL, NULL, NULL, 'CIRCULARLY PERMUTATED RAS PROTEIN 2', 243666),
(342002, 'PTHR24073:SF1201', NULL, NULL, NULL, NULL, '', 243666),
(342003, 'PTHR24073:SF1200', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-6.1', 243666),
(342004, 'PTHR24073:SF1207', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABH1C', 243666),
(342005, 'PTHR24073:SF1206', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABH1E', 243666),
(342006, 'PTHR24073:SF1209', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA5E-LIKE', 243666),
(342007, 'PTHR24073:SF1208', NULL, NULL, NULL, NULL, '', 243666),
(342008, 'PTHR24073:SF967', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABH1A', 243666),
(342009, 'PTHR24073:SF209', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-23', 243666),
(342010, 'PTHR24073:SF1151', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA1C', 243666),
(342011, 'PTHR24073:SF963', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-1A', 243666),
(342012, 'PTHR24073:SF1152', NULL, NULL, NULL, NULL, 'SMALL GTPASE', 243666),
(342013, 'PTHR24073:SF960', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA5C', 243666),
(342014, 'PTHR24073:SF1159', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABC2A', 243666),
(342015, 'PTHR24073:SF572', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-28', 243666),
(342016, 'PTHR24073:SF1156', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA1B', 243666),
(342017, 'PTHR24073:SF839', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-38', 243666),
(342018, 'PTHR24073:SF1184', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABH1E', 243666),
(342019, 'PTHR24073:SF555', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-5B', 243666);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(342020, 'PTHR24073:SF315', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-7L1', 243666),
(342021, 'PTHR24073:SF1180', NULL, NULL, NULL, NULL, 'OS03G0666500 PROTEIN', 243666),
(342022, 'PTHR24073:SF430', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA5A', 243666),
(342023, 'PTHR24073:SF1182', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABF1-LIKE', 243666),
(342024, 'PTHR24073:SF1061', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA5E', 243666),
(342025, 'PTHR24073:SF1060', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA6B', 243666),
(342026, 'PTHR24073:SF1181', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE, EXPRESSED-RELATED', 243666),
(342027, 'PTHR24073:SF285', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-18', 243666),
(342028, 'PTHR24073:SF1105', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-1C-RELATED', 243666),
(342029, 'PTHR24073:SF1188', NULL, NULL, NULL, NULL, 'OS05G0516800 PROTEIN', 243666),
(342030, 'PTHR24073:SF1066', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-11B-RELATED', 243666),
(342031, 'PTHR24073:SF1069', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA5B', 243666),
(342032, 'PTHR24073:SF1189', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABH1B', 243666),
(342033, 'PTHR24073:SF825', NULL, NULL, NULL, NULL, 'OS06G0687100 PROTEIN', 243666),
(342034, 'PTHR24073:SF269', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 27', 243666),
(342035, 'PTHR24073:SF941', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-20', 243666),
(342036, 'PTHR24073:SF1050', NULL, NULL, NULL, NULL, '', 243666),
(342037, 'PTHR24073', NULL, NULL, NULL, NULL, 'DRAB5-RELATED', 243666),
(342038, 'PTHR24073:SF1214', NULL, NULL, NULL, NULL, 'LD47384P', 243666),
(342039, 'PTHR24073:SF1213', NULL, NULL, NULL, NULL, 'SMALL MONOMERIC GTPASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G05770)-RELATED', 243666),
(342040, 'PTHR24073:SF1216', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN, PUTATIVE-RELATED', 243666),
(342041, 'PTHR24073:SF1215', NULL, NULL, NULL, NULL, 'RAS FAMILY PROTEIN', 243666),
(342042, 'PTHR24073:SF1210', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA6A', 243666),
(342043, 'PTHR24073:SF1177', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-32C', 243666),
(342044, 'PTHR24073:SF1176', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-32', 243666),
(342045, 'PTHR24073:SF1212', NULL, NULL, NULL, NULL, 'OS10G0456600 PROTEIN', 243666),
(342046, 'PTHR24073:SF1211', NULL, NULL, NULL, NULL, 'SMALL GTPASE SUPERFAMILY, RAN GTPASE, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 243666),
(342047, 'PTHR24073:SF1178', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABF2B', 243666),
(342048, 'PTHR37840:SF1', NULL, NULL, NULL, NULL, 'L-FUCOSE ISOMERASE', 243667),
(342049, 'PTHR37840', NULL, NULL, NULL, NULL, 'L-FUCOSE ISOMERASE', 243667),
(342050, 'PTHR42704:SF12', NULL, NULL, NULL, NULL, 'RIBULOSE BISPHOSPHATE CARBOXYLASE LARGE CHAIN', 243668),
(342051, 'PTHR42704:SF9', NULL, NULL, NULL, NULL, 'RIBULOSE BISPHOSPHATE CARBOXYLASE LARGE CHAIN', 243668),
(342052, 'PTHR42704', NULL, NULL, NULL, NULL, 'RIBULOSE BISPHOSPHATE CARBOXYLASE', 243668),
(342053, 'PTHR42704:SF13', NULL, NULL, NULL, NULL, 'RUBISCO_LARGE DOMAIN-CONTAINING PROTEIN', 243668),
(342054, 'PTHR12363:SF44', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 243669),
(342055, 'PTHR12363:SF33', NULL, NULL, NULL, NULL, 'IMPORTIN-13', 243669),
(342056, 'PTHR12363:SF52', NULL, NULL, NULL, NULL, 'IMPORTIN-13 HOMOLOG A', 243669),
(342057, 'PTHR12363:SF53', NULL, NULL, NULL, NULL, 'MRNA TRANSPORT REGULATOR MTR10', 243669),
(342058, 'PTHR12363:SF42', NULL, NULL, NULL, NULL, 'TRANSPORTIN-3', 243669),
(342059, 'PTHR12363:SF54', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSPORT RECEPTOR', 243669),
(342060, 'PTHR12363', NULL, NULL, NULL, NULL, 'TRANSPORTIN 3 AND IMPORTIN 13', 243669),
(342061, 'PTHR12363:SF28', NULL, NULL, NULL, NULL, 'IMPORTIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 243669),
(342062, 'PTHR16423:SF9', NULL, NULL, NULL, NULL, 'TREM-LIKE TRANSCRIPT 4 PROTEIN', 243670),
(342063, 'PTHR16423:SF7', NULL, NULL, NULL, NULL, 'NATURAL CYTOTOXICITY TRIGGERING RECEPTOR 2', 243670);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(342064, 'PTHR16423:SF6', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 243670),
(342065, 'PTHR16423:SF3', NULL, NULL, NULL, NULL, 'TREM-LIKE TRANSCRIPT 2 PROTEIN', 243670),
(342066, 'PTHR16423:SF10', NULL, NULL, NULL, NULL, 'CRKD-BINDING PROTEIN-RELATED', 243670),
(342067, 'PTHR16423', NULL, NULL, NULL, NULL, 'TREM-LIKE TRANSCRIPT PROTEIN', 243670),
(342068, 'PTHR16423:SF11', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 243670),
(342069, 'PTHR43572:SF29', NULL, NULL, NULL, NULL, 'PROTEIN SMAX1-LIKE 4', 243671),
(342070, 'PTHR43572', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN CLPD, CHLOROPLASTIC', 243671),
(342071, 'PTHR43572:SF3', NULL, NULL, NULL, NULL, 'PROTEIN SMAX1-LIKE 5', 243671),
(342072, 'PTHR43572:SF4', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN CLPD, CHLOROPLASTIC', 243671),
(342073, 'PTHR43572:SF5', NULL, NULL, NULL, NULL, 'OS02G0537800 PROTEIN', 243671),
(342074, 'PTHR43572:SF7', NULL, NULL, NULL, NULL, 'CLP R DOMAIN-CONTAINING PROTEIN', 243671),
(342075, 'PTHR43572:SF8', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN CLPC1, CHLOROPLASTIC', 243671),
(342076, 'PTHR43572:SF63', NULL, NULL, NULL, NULL, 'PROTEIN SMAX1-LIKE 3-LIKE', 243671),
(342077, 'PTHR43572:SF62', NULL, NULL, NULL, NULL, 'DOUBLE CLP-N MOTIF-CONTAINING P-LOOP NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN-RELATED', 243671),
(342078, 'PTHR43572:SF43', NULL, NULL, NULL, NULL, 'BNAA01G06680D PROTEIN', 243671),
(342079, 'PTHR43572:SF45', NULL, NULL, NULL, NULL, 'CLP R DOMAIN-CONTAINING PROTEIN', 243671),
(342080, 'PTHR43572:SF44', NULL, NULL, NULL, NULL, 'OS02G0464900 PROTEIN', 243671),
(342081, 'PTHR43572:SF47', NULL, NULL, NULL, NULL, 'CLP R DOMAIN-CONTAINING PROTEIN', 243671),
(342082, 'PTHR43572:SF68', NULL, NULL, NULL, NULL, 'CLP R DOMAIN-CONTAINING PROTEIN', 243671),
(342083, 'PTHR43572:SF27', NULL, NULL, NULL, NULL, 'PROTEIN SMAX1-LIKE 2', 243671),
(342084, 'PTHR43572:SF49', NULL, NULL, NULL, NULL, 'PROTEIN SMAX1-LIKE 8', 243671),
(342085, 'PTHR43572:SF48', NULL, NULL, NULL, NULL, 'CLP R DOMAIN-CONTAINING PROTEIN', 243671),
(342086, 'PTHR43572:SF1', NULL, NULL, NULL, NULL, 'PROTEIN SMAX1-LIKE 3', 243671),
(342087, 'PTHR43572:SF17', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN CLPD1, CHLOROPLASTIC', 243671),
(342088, 'PTHR43572:SF70', NULL, NULL, NULL, NULL, 'CLP R DOMAIN-CONTAINING PROTEIN', 243671),
(342089, 'PTHR43572:SF50', NULL, NULL, NULL, NULL, 'CLP, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 243671),
(342090, 'PTHR43572:SF72', NULL, NULL, NULL, NULL, '', 243671),
(342091, 'PTHR43572:SF71', NULL, NULL, NULL, NULL, 'CLP R DOMAIN-CONTAINING PROTEIN', 243671),
(342092, 'PTHR43572:SF74', NULL, NULL, NULL, NULL, 'DOUBLE CLP-N MOTIF-CONTAINING P-LOOP NUCLEOSIDE TRIPHOSPHATE HYDROLASE SUPERFAMILY PROTEIN', 243671),
(342093, 'PTHR43572:SF52', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN CLPC4, CHLOROPLASTIC', 243671),
(342094, 'PTHR43572:SF73', NULL, NULL, NULL, NULL, 'PROTEIN SMAX1-LIKE 3-LIKE', 243671),
(342095, 'PTHR43572:SF51', NULL, NULL, NULL, NULL, 'CLP R DOMAIN-CONTAINING PROTEIN', 243671),
(342096, 'PTHR43572:SF54', NULL, NULL, NULL, NULL, 'PROTEIN SMAX1-LIKE 7', 243671),
(342097, 'PTHR43572:SF31', NULL, NULL, NULL, NULL, 'PROTEIN SMAX1-LIKE 3', 243671),
(342098, 'PTHR43572:SF75', NULL, NULL, NULL, NULL, 'HEAT SHOCK-LIKE PROTEIN', 243671),
(342099, 'PTHR43572:SF12', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE ATP-BINDING SUBUNIT CLPE', 243671),
(342100, 'PTHR43572:SF58', NULL, NULL, NULL, NULL, 'CLP R DOMAIN-CONTAINING PROTEIN', 243671),
(342101, 'PTHR43572:SF14', NULL, NULL, NULL, NULL, 'OS02G0788600 PROTEIN', 243671),
(342102, 'PTHR43572:SF13', NULL, NULL, NULL, NULL, 'PROTEIN SUPPRESSOR OF MAX2 1', 243671),
(342103, 'PTHR43572:SF38', NULL, NULL, NULL, NULL, 'PROTEIN SMAX1-LIKE 6', 243671),
(342104, 'PTHR43572:SF37', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN CLPC2, CHLOROPLASTIC', 243671),
(342105, 'PTHR43572:SF59', NULL, NULL, NULL, NULL, 'PROTEIN SMAX1-LIKE 3', 243671),
(342106, 'PTHR46419', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN AGD5', 243672);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(342107, 'PTHR46419:SF12', NULL, NULL, NULL, NULL, 'ARF-GAP DOMAIN-CONTAINING PROTEIN', 243672),
(342108, 'PTHR46419:SF13', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN AGD5 ISOFORM X1-RELATED', 243672),
(342109, 'PTHR46419:SF3', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN AGD15-RELATED', 243672),
(342110, 'PTHR46419:SF10', NULL, NULL, NULL, NULL, 'ARF GTPASE ACTIVATING PROTEIN-RELATED', 243672),
(342111, 'PTHR46419:SF2', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN AGD5', 243672),
(342112, 'PTHR46419:SF1', NULL, NULL, NULL, NULL, 'ARF-GAP DOMAIN-CONTAINING PROTEIN', 243672),
(342113, 'PTHR46419:SF11', NULL, NULL, NULL, NULL, 'ARF-GAP DOMAIN-CONTAINING PROTEIN', 243672),
(342114, 'PTHR46419:SF5', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN AGD5 ISOFORM X1-RELATED', 243672),
(342115, 'PTHR37089:SF1', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 243673),
(342116, 'PTHR37089', NULL, NULL, NULL, NULL, 'PROTEIN U-RELATED', 243673),
(342117, 'PTHR37089:SF3', NULL, NULL, NULL, NULL, 'EXPORTED PROTEIN-RELATED', 243673),
(342118, 'PTHR37089:SF4', NULL, NULL, NULL, NULL, 'EXPORTED PROTEIN-RELATED', 243673),
(342119, 'PTHR21501:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAM-161', 243674),
(342120, 'PTHR21501:SF3', NULL, NULL, NULL, NULL, 'PROTEIN FAM161A', 243674),
(342121, 'PTHR21501', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243674),
(342122, 'PTHR21501:SF5', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC PROTEIN 10-INTERACTING PROTEIN', 243674),
(342123, 'PTHR21501:SF4', NULL, NULL, NULL, NULL, 'PROTEIN FAM161B', 243674),
(342124, 'PTHR45775:SF7', NULL, NULL, NULL, NULL, 'RAD, GEM/KIR FAMILY MEMBER 1, ISOFORM B', 243675),
(342125, 'PTHR45775:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG11333', 243675),
(342126, 'PTHR45775:SF2', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN REM 1', 243675),
(342127, 'PTHR45775:SF1', NULL, NULL, NULL, NULL, 'RAD, GEM/KIR FAMILY MEMBER 3, ISOFORM E', 243675),
(342128, 'PTHR45775:SF11', NULL, NULL, NULL, NULL, 'PROTEIN CBG08006', 243675),
(342129, 'PTHR45775:SF4', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN GEM', 243675),
(342130, 'PTHR45775:SF3', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN RAD', 243675),
(342131, 'PTHR45775:SF6', NULL, NULL, NULL, NULL, 'RAD, GEM/KIR FAMILY MEMBER 2, ISOFORM C', 243675),
(342132, 'PTHR45775:SF5', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN REM 2', 243675),
(342133, 'PTHR45775', NULL, NULL, NULL, NULL, 'RAD, GEM/KIR FAMILY MEMBER 2, ISOFORM C', 243675),
(342134, 'PTHR10963:SF27', NULL, NULL, NULL, NULL, 'GLYCOSIDASE CRH1-RELATED', 243676),
(342135, 'PTHR10963:SF60', NULL, NULL, NULL, NULL, 'GRAM-NEGATIVE BACTERIA-BINDING PROTEIN 1-RELATED', 243676),
(342136, 'PTHR10963', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE-RELATED', 243676),
(342137, 'PTHR10963:SF53', NULL, NULL, NULL, NULL, 'GH16 DOMAIN-CONTAINING PROTEIN', 243676),
(342138, 'PTHR10963:SF42', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_5G02280)-RELATED', 243676),
(342139, 'PTHR10963:SF62', NULL, NULL, NULL, NULL, 'GLUCAN 1,3-BETA-GLUCOSIDASE', 243676),
(342140, 'PTHR10963:SF69', NULL, NULL, NULL, NULL, 'GLYCOSIDASE CRR1-RELATED', 243676),
(342141, 'PTHR10963:SF58', NULL, NULL, NULL, NULL, 'ENDO-1,3(4)-BETA-GLUCANASE XGEA', 243676),
(342142, 'PTHR10963:SF68', NULL, NULL, NULL, NULL, 'GLYCOSIDASE', 243676),
(342143, 'PTHR10963:SF24', NULL, NULL, NULL, NULL, 'GLYCOSIDASE C21B10.07-RELATED', 243676),
(342144, 'PTHR10963:SF55', NULL, NULL, NULL, NULL, 'GH16 DOMAIN-CONTAINING PROTEIN', 243676),
(342145, 'PTHR10963:SF22', NULL, NULL, NULL, NULL, 'GLYCOSIDASE CRH2-RELATED', 243676),
(342146, 'PTHR47736:SF1', NULL, NULL, NULL, NULL, 'BPI FOLD-CONTAINING FAMILY A MEMBER 3', 243677),
(342147, 'PTHR47736', NULL, NULL, NULL, NULL, 'BPI FOLD-CONTAINING FAMILY A MEMBER 3', 243677),
(342148, 'PTHR42949:SF2', NULL, NULL, NULL, NULL, 'ANAEROBIC GLYCEROL-3-PHOSPHATE DEHYDROGENASE SUBUNIT B', 243678),
(342149, 'PTHR42949', NULL, NULL, NULL, NULL, 'ANAEROBIC GLYCEROL-3-PHOSPHATE DEHYDROGENASE SUBUNIT B', 243678);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(342150, 'PTHR42949:SF3', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE-RELATED', 243678),
(342151, 'PTHR11210:SF54', NULL, NULL, NULL, NULL, 'RING-BOX PROTEIN 1A', 243679),
(342152, 'PTHR11210:SF56', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE, ZINC FINGER, RING-H2-TYPE-RELATED', 243679),
(342153, 'PTHR11210:SF45', NULL, NULL, NULL, NULL, 'OS01G0106800 PROTEIN', 243679),
(342154, 'PTHR11210:SF55', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 243679),
(342155, 'PTHR11210:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RBX1-RELATED', 243679),
(342156, 'PTHR11210:SF49', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 243679),
(342157, 'PTHR11210:SF1', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT 11', 243679),
(342158, 'PTHR11210:SF50', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 243679),
(342159, 'PTHR11210:SF41', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 243679),
(342160, 'PTHR11210', NULL, NULL, NULL, NULL, 'RING BOX', 243679),
(342161, 'PTHR11210:SF51', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 243679),
(342162, 'PTHR30042:SF2', NULL, NULL, NULL, NULL, 'POTASSIUM-TRANSPORTING ATPASE KDPC SUBUNIT', 243680),
(342163, 'PTHR30042', NULL, NULL, NULL, NULL, 'POTASSIUM-TRANSPORTING ATPASE C CHAIN', 243680),
(342164, 'PTHR13602:SF2', NULL, NULL, NULL, NULL, 'UPF0488 PROTEIN C8ORF33', 243681),
(342165, 'PTHR13602', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243681),
(342166, 'PTHR40697:SF2', NULL, NULL, NULL, NULL, 'ATP-NAD KINASE-RELATED', 243682),
(342167, 'PTHR40697:SF3', NULL, NULL, NULL, NULL, 'ACETOIN CATABOLISM PROTEIN X', 243682),
(342168, 'PTHR40697', NULL, NULL, NULL, NULL, 'ACETOIN CATABOLISM PROTEIN X', 243682),
(342169, 'PTHR46213:SF23', NULL, NULL, NULL, NULL, 'RRM_DME DOMAIN-CONTAINING PROTEIN', 243683),
(342170, 'PTHR46213:SF12', NULL, NULL, NULL, NULL, 'PROTEIN ROS1', 243683),
(342171, 'PTHR46213:SF13', NULL, NULL, NULL, NULL, 'DEMETER-LIKE PROTEIN 2-RELATED', 243683),
(342172, 'PTHR46213:SF24', NULL, NULL, NULL, NULL, 'DEMETER-LIKE PROTEIN 3-RELATED', 243683),
(342173, 'PTHR46213:SF11', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR DEMETER-LIKE', 243683),
(342174, 'PTHR46213:SF16', NULL, NULL, NULL, NULL, 'ENDO3C DOMAIN-CONTAINING PROTEIN', 243683),
(342175, 'PTHR46213:SF17', NULL, NULL, NULL, NULL, 'DNA GLYCOSYLASE-RELATED', 243683),
(342176, 'PTHR46213:SF25', NULL, NULL, NULL, NULL, 'A/G-SPECIFIC ADENINE GLYCOSYLASE MUTY-RELATED', 243683),
(342177, 'PTHR46213:SF26', NULL, NULL, NULL, NULL, 'HHH-GPD BASE EXCISION DNA REPAIR FAMILY PROTEIN', 243683),
(342178, 'PTHR46213:SF9', NULL, NULL, NULL, NULL, 'PROTEIN ROS1-LIKE', 243683),
(342179, 'PTHR46213', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR DEMETER', 243683),
(342180, 'PTHR46213:SF20', NULL, NULL, NULL, NULL, 'RRM_DME DOMAIN-CONTAINING PROTEIN', 243683),
(342181, 'PTHR46213:SF4', NULL, NULL, NULL, NULL, 'OS02G0496500 PROTEIN', 243683),
(342182, 'PTHR46213:SF2', NULL, NULL, NULL, NULL, 'PROTEIN ROS1C', 243683),
(342183, 'PTHR46213:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR DEMETER-LIKE', 243683),
(342184, 'PTHR46213:SF18', NULL, NULL, NULL, NULL, 'DNA GLYCOSYLASE-RELATED', 243683),
(342185, 'PTHR43398:SF1', NULL, NULL, NULL, NULL, 'DOLICHOL-PHOSPHATE MANNOSYLTRANSFERASE SUBUNIT 1', 243684),
(342186, 'PTHR43398', NULL, NULL, NULL, NULL, 'DOLICHOL-PHOSPHATE MANNOSYLTRANSFERASE SUBUNIT 1', 243684),
(342187, 'PTHR47351', NULL, NULL, NULL, NULL, 'CHITIN BIOSYNTHESIS PROTEIN CHS5', 243685),
(342188, 'PTHR47351:SF1', NULL, NULL, NULL, NULL, 'CHITIN BIOSYNTHESIS PROTEIN CHS5', 243685),
(342189, 'PTHR10822:SF4', NULL, NULL, NULL, NULL, 'GLYPICAN-3', 243686),
(342190, 'PTHR10822:SF30', NULL, NULL, NULL, NULL, 'DALLY-LIKE, ISOFORM A', 243686),
(342191, 'PTHR10822:SF29', NULL, NULL, NULL, NULL, 'DIVISION ABNORMALLY DELAYED PROTEIN', 243686),
(342192, 'PTHR10822:SF19', NULL, NULL, NULL, NULL, 'GLYPICAN 5B-RELATED', 243686),
(342193, 'PTHR10822:SF8', NULL, NULL, NULL, NULL, 'GLYPICAN-1', 243686);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(342194, 'PTHR10822', NULL, NULL, NULL, NULL, 'GLYPICAN', 243686),
(342195, 'PTHR10822:SF24', NULL, NULL, NULL, NULL, 'GLYPICAN-2', 243686),
(342196, 'PTHR10822:SF25', NULL, NULL, NULL, NULL, 'GLYPICAN-4', 243686),
(342197, 'PTHR10822:SF31', NULL, NULL, NULL, NULL, 'GLYPICAN-6', 243686),
(342198, 'PTHR10822:SF12', NULL, NULL, NULL, NULL, 'GLYPICAN-5', 243686),
(342199, 'PTHR34765', NULL, NULL, NULL, NULL, 'CASPASE RECRUITMENT DOMAIN-CONTAINING PROTEIN 19', 243687),
(342200, 'PTHR34765:SF1', NULL, NULL, NULL, NULL, 'CASPASE RECRUITMENT DOMAIN-CONTAINING PROTEIN 19', 243687),
(342201, 'PTHR16770', NULL, NULL, NULL, NULL, '', 243688),
(342202, 'PTHR16770:SF4', NULL, NULL, NULL, NULL, 'PROTEIN RIPPLY3', 243688),
(342203, 'PTHR16770:SF5', NULL, NULL, NULL, NULL, 'PROTEIN RIPPLY1', 243688),
(342204, 'PTHR16770:SF3', NULL, NULL, NULL, NULL, 'PROTEIN RIPPLY2', 243688),
(342205, 'PTHR16770:SF1', NULL, NULL, NULL, NULL, '', 243688),
(342206, 'PTHR28448', NULL, NULL, NULL, NULL, 'UPF0728 PROTEIN C10ORF53', 243689),
(342207, 'PTHR28448:SF1', NULL, NULL, NULL, NULL, 'UPF0728 PROTEIN C10ORF53', 243689),
(342208, 'PTHR19051:SF34', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 27-1', 243690),
(342209, 'PTHR19051:SF26', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 23-1-LIKE', 243690),
(342210, 'PTHR19051:SF27', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 13-1', 243690),
(342211, 'PTHR19051', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN', 243690),
(342212, 'PTHR19051:SF30', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 13-3', 243690),
(342213, 'PTHR19051:SF20', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 14', 243690),
(342214, 'PTHR19051:SF32', NULL, NULL, NULL, NULL, 'PHAGE TAIL FIBER REPEAT FAMILY PROTEIN', 243690),
(342215, 'PTHR38599:SF1', NULL, NULL, NULL, NULL, 'CUPIN DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_3G13620)', 243691),
(342216, 'PTHR38599', NULL, NULL, NULL, NULL, 'CUPIN DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_3G13620)', 243691),
(342217, 'PTHR14517', NULL, NULL, NULL, NULL, 'RIB43A-RELATED', 243692),
(342218, 'PTHR14517:SF6', NULL, NULL, NULL, NULL, 'RE41410P', 243692),
(342219, 'PTHR14517:SF10', NULL, NULL, NULL, NULL, 'RIB43A-LIKE WITH COILED-COILS PROTEIN 2', 243692),
(342220, 'PTHR14517:SF11', NULL, NULL, NULL, NULL, 'RIB43A-LIKE WITH COILED-COILS PROTEIN 1', 243692),
(342221, 'PTHR37549:SF1', NULL, NULL, NULL, NULL, 'LIPOPROTEIN LPRI', 243693),
(342222, 'PTHR37549', NULL, NULL, NULL, NULL, 'LIPOPROTEIN LPRI', 243693),
(342223, 'PTHR42744', NULL, NULL, NULL, NULL, 'BINDING-PROTEIN-DEPENDENT TRANSPORT SYSTEMS INNER MEMBRANE COMPONENT', 243694),
(342224, 'PTHR42744:SF1', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE-RELATED', 243694),
(342225, 'PTHR11472:SF64', NULL, NULL, NULL, NULL, 'SLR1495 PROTEIN', 243695),
(342226, 'PTHR11472:SF41', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE DDX11-RELATED', 243695),
(342227, 'PTHR11472:SF63', NULL, NULL, NULL, NULL, 'HELICASE ATP-BINDING DOMAIN-CONTAINING PROTEIN', 243695),
(342228, 'PTHR11472:SF62', NULL, NULL, NULL, NULL, 'REGULATOR OF TELOMERE ELONGATION HELICASE 1', 243695),
(342229, 'PTHR11472:SF47', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA GROUP J PROTEIN', 243695),
(342230, 'PTHR11472:SF57', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT HELICASE YPVA-RELATED', 243695),
(342231, 'PTHR11472:SF34', NULL, NULL, NULL, NULL, 'REGULATOR OF TELOMERE ELONGATION HELICASE 1', 243695),
(342232, 'PTHR11472:SF1', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION AND DNA REPAIR FACTOR IIH HELICASE SUBUNIT XPD', 243695),
(342233, 'PTHR11472:SF59', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE DING', 243695),
(342234, 'PTHR11472:SF61', NULL, NULL, NULL, NULL, 'REGULATOR OF TELOMERE ELONGATION HELICASE 1', 243695),
(342235, 'PTHR11472', NULL, NULL, NULL, NULL, 'DNA REPAIR DEAD HELICASE RAD3/XP-D SUBFAMILY MEMBER', 243695),
(342236, 'PTHR48226:SF1', NULL, NULL, NULL, NULL, 'WAS/WASL-INTERACTING PROTEIN FAMILY MEMBER 1', 243696),
(342237, 'PTHR48226', NULL, NULL, NULL, NULL, 'OS06G0326200 PROTEIN', 243696),
(342238, 'PTHR37369:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 270', 243697);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(342239, 'PTHR37369', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 270', 243697),
(342240, 'PTHR46386:SF8', NULL, NULL, NULL, NULL, 'NUCLEAR BODY PROTEIN SP140', 243698),
(342241, 'PTHR46386:SF6', NULL, NULL, NULL, NULL, 'NUCLEAR BODY PROTEIN SP140-LIKE PROTEIN', 243698),
(342242, 'PTHR46386:SF7', NULL, NULL, NULL, NULL, 'SP110 NUCLEAR BODY PROTEIN', 243698),
(342243, 'PTHR46386', NULL, NULL, NULL, NULL, 'NUCLEAR BODY PROTEIN SP140', 243698),
(342244, 'PTHR46386:SF1', NULL, NULL, NULL, NULL, 'RIKEN CDNA A630001G21 GENE', 243698),
(342245, 'PTHR46386:SF10', NULL, NULL, NULL, NULL, 'NUCLEAR AUTOANTIGEN SP-100', 243698),
(342246, 'PTHR11559:SF185', NULL, NULL, NULL, NULL, 'GH04232P', 243699),
(342247, 'PTHR11559:SF361', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 1E-RELATED', 243699),
(342248, 'PTHR11559:SF240', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 243699),
(342249, 'PTHR11559:SF362', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 243699),
(342250, 'PTHR11559:SF386', NULL, NULL, NULL, NULL, 'COESTERASE DOMAIN-CONTAINING PROTEIN-RELATED', 243699),
(342251, 'PTHR11559:SF181', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 1F', 243699),
(342252, 'PTHR11559:SF360', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 243699),
(342253, 'PTHR11559:SF162', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 243699),
(342254, 'PTHR11559:SF43', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 5A', 243699),
(342255, 'PTHR11559:SF226', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 243699),
(342256, 'PTHR11559:SF420', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 243699),
(342257, 'PTHR11559:SF421', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 243699),
(342258, 'PTHR11559:SF389', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 243699),
(342259, 'PTHR11559:SF400', NULL, NULL, NULL, NULL, 'ACYLCARNITINE HYDROLASE', 243699),
(342260, 'PTHR11559:SF422', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE-RELATED', 243699),
(342261, 'PTHR11559', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE', 243699),
(342262, 'PTHR11559:SF367', NULL, NULL, NULL, NULL, 'COESTERASE DOMAIN-CONTAINING PROTEIN', 243699),
(342263, 'PTHR11559:SF368', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 243699),
(342264, 'PTHR11559:SF423', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 243699),
(342265, 'PTHR11559:SF407', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE-RELATED', 243699),
(342266, 'PTHR11559:SF408', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE-RELATED', 243699),
(342267, 'PTHR11559:SF174', NULL, NULL, NULL, NULL, 'PYRETHROID HYDROLASE CES2A', 243699),
(342268, 'PTHR11559:SF395', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 243699),
(342269, 'PTHR11559:SF353', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 243699),
(342270, 'PTHR11559:SF254', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 4A', 243699),
(342271, 'PTHR11559:SF192', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 1C-RELATED', 243699),
(342272, 'PTHR11559:SF390', NULL, NULL, NULL, NULL, 'CARBOXYL ESTERASE DOMAIN CONTAINING', 243699),
(342273, 'PTHR11559:SF170', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 243699),
(342274, 'PTHR11559:SF391', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 243699),
(342275, 'PTHR11559:SF370', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE-RELATED', 243699),
(342276, 'PTHR11559:SF392', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 243699),
(342277, 'PTHR11559:SF259', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE 3', 243699),
(342278, 'PTHR11559:SF413', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 243699),
(342279, 'PTHR11559:SF414', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 243699),
(342280, 'PTHR11559:SF416', NULL, NULL, NULL, NULL, 'COCAINE ESTERASE', 243699),
(342281, 'PTHR11559:SF398', NULL, NULL, NULL, NULL, 'COESTERASE DOMAIN-CONTAINING PROTEIN', 243699),
(342282, 'PTHR11559:SF376', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 243699),
(342283, 'PTHR11559:SF134', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE-RELATED', 243699);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(342284, 'PTHR11559:SF354', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_3G09230)-RELATED', 243699),
(342285, 'PTHR11559:SF410', NULL, NULL, NULL, NULL, 'COESTERASE DOMAIN-CONTAINING PROTEIN', 243699),
(342286, 'PTHR11559:SF377', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE', 243699),
(342287, 'PTHR11559:SF179', NULL, NULL, NULL, NULL, 'LIVER CARBOXYLESTERASE 1-RELATED', 243699),
(342288, 'PTHR11559:SF411', NULL, NULL, NULL, NULL, 'ACETYLCHOLINESTERASE', 243699),
(342289, 'PTHR11559:SF417', NULL, NULL, NULL, NULL, 'NEUROTACTIN', 243699),
(342290, 'PTHR11559:SF418', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 243699),
(342291, 'PTHR11559:SF419', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 243699),
(342292, 'PTHR31033:SF20', NULL, NULL, NULL, NULL, 'BNAA03G47080D PROTEIN', 243700),
(342293, 'PTHR31033:SF18', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243700),
(342294, 'PTHR31033:SF29', NULL, NULL, NULL, NULL, '', 243700),
(342295, 'PTHR31033:SF26', NULL, NULL, NULL, NULL, '', 243700),
(342296, 'PTHR31033:SF33', NULL, NULL, NULL, NULL, '', 243700),
(342297, 'PTHR31033', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 243700),
(342298, 'PTHR31033:SF21', NULL, NULL, NULL, NULL, 'BNAA03G47070D PROTEIN', 243700),
(342299, 'PTHR31033:SF32', NULL, NULL, NULL, NULL, 'BNAC05G29430D PROTEIN', 243700),
(342300, 'PTHR14456:SF5', NULL, NULL, NULL, NULL, 'INOSITOL-PENTAKISPHOSPHATE 2-KINASE', 243701),
(342301, 'PTHR14456:SF6', NULL, NULL, NULL, NULL, 'INOSITOL-PENTAKISPHOSPHATE 2-KINASE', 243701),
(342302, 'PTHR14456', NULL, NULL, NULL, NULL, 'INOSITOL POLYPHOSPHATE KINASE 1', 243701),
(342303, 'PTHR14456:SF7', NULL, NULL, NULL, NULL, 'INOSITOL-PENTAKISPHOSPHATE 2-KINASE', 243701),
(342304, 'PTHR14456:SF8', NULL, NULL, NULL, NULL, 'INOSITOL-PENTAKISPHOSPHATE 2-KINASE', 243701),
(342305, 'PTHR14456:SF2', NULL, NULL, NULL, NULL, 'INOSITOL-PENTAKISPHOSPHATE 2-KINASE', 243701),
(342306, 'PTHR46773:SF8', NULL, NULL, NULL, NULL, 'AUTOPHAGY_ACT_C DOMAIN-CONTAINING PROTEIN', 243702),
(342307, 'PTHR46773:SF6', NULL, NULL, NULL, NULL, 'OS08G0128000 PROTEIN', 243702),
(342308, 'PTHR46773', NULL, NULL, NULL, NULL, '', 243702),
(342309, 'PTHR46773:SF7', NULL, NULL, NULL, NULL, 'BNAC03G41890D PROTEIN', 243702),
(342310, 'PTHR46773:SF5', NULL, NULL, NULL, NULL, 'GALACTOSE OXIDASE/KELCH REPEAT PROTEIN', 243702),
(342311, 'PTHR46773:SF3', NULL, NULL, NULL, NULL, 'OS04G0487100 PROTEIN', 243702),
(342312, 'PTHR36402:SF2', NULL, NULL, NULL, NULL, 'BNACNNG70140D PROTEIN', 243703),
(342313, 'PTHR36402:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243703),
(342314, 'PTHR36402', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243703),
(342315, 'PTHR13542:SF0', NULL, NULL, NULL, NULL, 'PROTEIN LSM12 HOMOLOG', 243704),
(342316, 'PTHR13542:SF1', NULL, NULL, NULL, NULL, 'AD DOMAIN-CONTAINING PROTEIN', 243704),
(342317, 'PTHR13542', NULL, NULL, NULL, NULL, 'LSM12 HOMOLOG', 243704),
(342318, 'PTHR13585:SF30', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 243705),
(342319, 'PTHR13585:SF26', NULL, NULL, NULL, NULL, '', 243705),
(342320, 'PTHR13585:SF27', NULL, NULL, NULL, NULL, 'PROTEIN CBG02458', 243705),
(342321, 'PTHR13585:SF19', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 13', 243705),
(342322, 'PTHR13585:SF29', NULL, NULL, NULL, NULL, '', 243705),
(342323, 'PTHR13585', NULL, NULL, NULL, NULL, 'CHASCON, ISOFORM D-RELATED', 243705),
(342324, 'PTHR23108', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE-RELATED', 243706),
(342325, 'PTHR23108:SF0', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE-LIKE PROTEIN 22', 243706),
(342326, 'PTHR23108:SF3', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE FAMILY PROTEIN-RELATED', 243706),
(342327, 'PTHR14972:SF7', NULL, NULL, NULL, NULL, 'PROTEIN FAM117A', 243707),
(342328, 'PTHR14972:SF6', NULL, NULL, NULL, NULL, 'PROTEIN FAM117B', 243707),
(342329, 'PTHR14972:SF8', NULL, NULL, NULL, NULL, '', 243707),
(342330, 'PTHR14972:SF3', NULL, NULL, NULL, NULL, 'GLUCOCORTICOID-INDUCED TRANSCRIPT 1 PROTEIN', 243707),
(342331, 'PTHR14972', NULL, NULL, NULL, NULL, 'AGAP011572-PA', 243707);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(342332, 'PTHR45936', NULL, NULL, NULL, NULL, 'TRNA-DIHYDROURIDINE(20) SYNTHASE [NAD(P)+]-LIKE', 243708),
(342333, 'PTHR45936:SF1', NULL, NULL, NULL, NULL, 'TRNA-DIHYDROURIDINE(20) SYNTHASE [NAD(P)+]-LIKE', 243708),
(342334, 'PTHR45936:SF2', NULL, NULL, NULL, NULL, 'DUS DOMAIN-CONTAINING PROTEIN', 243708),
(342335, 'PTHR21377:SF15', NULL, NULL, NULL, NULL, 'DUF1279 DOMAIN-CONTAINING PROTEIN', 243709),
(342336, 'PTHR21377:SF19', NULL, NULL, NULL, NULL, 'DUF1279 DOMAIN-CONTAINING PROTEIN', 243709),
(342337, 'PTHR21377:SF18', NULL, NULL, NULL, NULL, 'DUF1279 DOMAIN-CONTAINING PROTEIN', 243709),
(342338, 'PTHR21377:SF16', NULL, NULL, NULL, NULL, 'PROTEIN FAM210B, MITOCHONDRIAL', 243709),
(342339, 'PTHR21377', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243709),
(342340, 'PTHR21377:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAM210A', 243709),
(342341, 'PTHR21377:SF0', NULL, NULL, NULL, NULL, 'PROTEIN FAM210B, MITOCHONDRIAL', 243709),
(342342, 'PTHR12485:SF1', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX SUBUNIT 7', 243710),
(342343, 'PTHR12485', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE SUBUNIT B', 243710),
(342344, 'PTHR15897:SF2', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND MYND DOMAIN-CONTAINING PROTEIN 1', 243711),
(342345, 'PTHR15897', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND MYND DOMAIN PROTEIN 1', 243711),
(342346, 'PTHR31283:SF19', NULL, NULL, NULL, NULL, 'EKC/KEOPS COMPLEX SUBUNIT LAGE3', 243712),
(342347, 'PTHR31283:SF18', NULL, NULL, NULL, NULL, 'BNAA10G06410D PROTEIN', 243712),
(342348, 'PTHR31283:SF15', NULL, NULL, NULL, NULL, 'CANCER/TESTIS ANTIGEN 2', 243712),
(342349, 'PTHR31283:SF16', NULL, NULL, NULL, NULL, 'CTAG2-LIKE 2', 243712),
(342350, 'PTHR31283', NULL, NULL, NULL, NULL, 'EKC/KEOPS COMPLEX SUBUNIT PCC1 FAMILY MEMBER', 243712),
(342351, 'PTHR31283:SF13', NULL, NULL, NULL, NULL, '', 243712),
(342352, 'PTHR31283:SF5', NULL, NULL, NULL, NULL, 'GEO08993P1', 243712),
(342353, 'PTHR31283:SF14', NULL, NULL, NULL, NULL, '', 243712),
(342354, 'PTHR31283:SF4', NULL, NULL, NULL, NULL, 'CANCER/TESTIS ANTIGEN 1', 243712),
(342355, 'PTHR31283:SF6', NULL, NULL, NULL, NULL, 'CANCER/TESTIS ANTIGEN 2', 243712),
(342356, 'PTHR31283:SF20', NULL, NULL, NULL, NULL, 'CTAG/PCC1 FAMILY-RELATED', 243712),
(342357, 'PTHR34408:SF1', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE FAMILY 19 DOMAIN-CONTAINING PROTEIN HI_1415', 243713),
(342358, 'PTHR34408', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE-RELATED', 243713),
(342359, 'PTHR46410:SF15', NULL, NULL, NULL, NULL, 'OS01G0852500 PROTEIN', 243714),
(342360, 'PTHR46410:SF14', NULL, NULL, NULL, NULL, 'BNAA04G26630D PROTEIN', 243714),
(342361, 'PTHR46410:SF22', NULL, NULL, NULL, NULL, 'ELM2 DOMAIN-CONTAINING PROTEIN-RELATED', 243714),
(342362, 'PTHR46410:SF11', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 2-LIKE', 243714),
(342363, 'PTHR46410:SF12', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE 2', 243714),
(342364, 'PTHR46410:SF20', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 2-LIKE ISOFORM X1', 243714),
(342365, 'PTHR46410:SF21', NULL, NULL, NULL, NULL, 'ARID/BRIGHT DNA-BINDING DOMAIN,ELM2 DOMAIN PROTEIN-RELATED', 243714),
(342366, 'PTHR46410:SF10', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 2', 243714),
(342367, 'PTHR46410', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 2', 243714),
(342368, 'PTHR46410:SF7', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 1-LIKE', 243714),
(342369, 'PTHR46410:SF8', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 1-LIKE', 243714),
(342370, 'PTHR46410:SF1', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 1', 243714),
(342371, 'PTHR46410:SF19', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 1-LIKE ISOFORM X1', 243714),
(342372, 'PTHR46410:SF17', NULL, NULL, NULL, NULL, 'DNA-BINDING DOMAIN-CONTAINING PROTEIN, PUTATIVE, EXPRESSED-RELATED', 243714),
(342373, 'PTHR46410:SF18', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 2', 243714);
INSERT INTO "PUBLIC"."MODEL" VALUES
(342374, 'PTHR20919:SF0', NULL, NULL, NULL, NULL, 'HOMOSERINE O-SUCCINYLTRANSFERASE', 243715),
(342375, 'PTHR20919', NULL, NULL, NULL, NULL, 'HOMOSERINE O-SUCCINYLTRANSFERASE', 243715),
(342376, 'PTHR43817:SF1', NULL, NULL, NULL, NULL, 'HYDROLASE, FAMILY 43, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G01660)-RELATED', 243716),
(342377, 'PTHR43817', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE', 243716),
(342378, 'PTHR37508', NULL, NULL, NULL, NULL, '', 243717),
(342379, 'PTHR37508:SF1', NULL, NULL, NULL, NULL, '', 243717),
(342380, 'PTHR10510:SF13', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 7A-LIKE-RELATED', 243718),
(342381, 'PTHR10510:SF5', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 7A1, MITOCHONDRIAL', 243718),
(342382, 'PTHR10510:SF14', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 7A3, MITOCHONDRIAL-RELATED', 243718),
(342383, 'PTHR10510:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 7A-RELATED PROTEIN, MITOCHONDRIAL', 243718),
(342384, 'PTHR10510:SF15', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 7A2, MITOCHONDRIAL', 243718),
(342385, 'PTHR10510', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE POLYPEPTIDE 7A', 243718),
(342386, 'PTHR10510:SF11', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 7A, MITOCHONDRIAL', 243718),
(342387, 'PTHR46632:SF20', NULL, NULL, NULL, NULL, '', 243719),
(342388, 'PTHR46632:SF28', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 243719),
(342389, 'PTHR46632:SF29', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 243719),
(342390, 'PTHR46632:SF27', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 243719),
(342391, 'PTHR46632:SF24', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 243719),
(342392, 'PTHR46632:SF25', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 243719),
(342393, 'PTHR46632:SF22', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 243719),
(342394, 'PTHR46632:SF23', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 243719),
(342395, 'PTHR46632:SF31', NULL, NULL, NULL, NULL, 'SIAH-TYPE DOMAIN-CONTAINING PROTEIN', 243719),
(342396, 'PTHR46632:SF6', NULL, NULL, NULL, NULL, 'SIAH-TYPE DOMAIN-CONTAINING PROTEIN', 243719),
(342397, 'PTHR46632:SF32', NULL, NULL, NULL, NULL, 'LIGASE, PUTATIVE-RELATED', 243719),
(342398, 'PTHR46632:SF10', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE', 243719),
(342399, 'PTHR46632:SF4', NULL, NULL, NULL, NULL, 'SIAH-TYPE DOMAIN-CONTAINING PROTEIN', 243719),
(342400, 'PTHR46632:SF30', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SINA-LIKE 4', 243719),
(342401, 'PTHR46632:SF3', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SINA-LIKE 7-RELATED', 243719),
(342402, 'PTHR46632:SF17', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 243719),
(342403, 'PTHR46632:SF18', NULL, NULL, NULL, NULL, 'OS01G0122200 PROTEIN', 243719),
(342404, 'PTHR46632:SF16', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SINA-LIKE 10', 243719),
(342405, 'PTHR46632', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SINA-LIKE 4', 243719),
(342406, 'PTHR46632:SF13', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 243719),
(342407, 'PTHR46632:SF35', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 243719),
(342408, 'PTHR46632:SF14', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 243719),
(342409, 'PTHR46632:SF33', NULL, NULL, NULL, NULL, 'SIAH-TYPE DOMAIN-CONTAINING PROTEIN', 243719),
(342410, 'PTHR46632:SF11', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SINA-LIKE 1-RELATED', 243719),
(342411, 'PTHR46632:SF34', NULL, NULL, NULL, NULL, '', 243719),
(342412, 'PTHR46632:SF19', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 243719),
(342413, 'PTHR46632:SF9', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 243719),
(342414, 'PTHR36531:SF2', NULL, NULL, NULL, NULL, 'CRISPR-ASSOCIATED EXONUCLEASE CAS4', 243720),
(342415, 'PTHR36531', NULL, NULL, NULL, NULL, 'CRISPR-ASSOCIATED EXONUCLEASE CAS4', 243720);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(342416, 'PTHR36531:SF6', NULL, NULL, NULL, NULL, 'CRISPR-ASSOCIATED EXONUCLEASE CAS4', 243720),
(342417, 'PTHR46627', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE O', 243721),
(342418, 'PTHR46627:SF1', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE O', 243721),
(342419, 'PTHR20939:SF1', NULL, NULL, NULL, NULL, 'SORTING NEXIN-20', 243722),
(342420, 'PTHR20939:SF11', NULL, NULL, NULL, NULL, 'LD12265P', 243722),
(342421, 'PTHR20939:SF10', NULL, NULL, NULL, NULL, 'SORTING NEXIN-21', 243722),
(342422, 'PTHR20939', NULL, NULL, NULL, NULL, 'SORTING NEXIN 20, 21', 243722),
(342423, 'PTHR37848', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243723),
(342424, 'PTHR37848:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243723),
(342425, 'PTHR22446', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243724),
(342426, 'PTHR22446:SF3', NULL, NULL, NULL, NULL, 'M-PHASE-SPECIFIC PLK1-INTERACTING PROTEIN', 243724),
(342427, 'PTHR34585', NULL, NULL, NULL, NULL, '', 243725),
(342428, 'PTHR34585:SF22', NULL, NULL, NULL, NULL, 'BACTERIAL REGULATORY PROTEIN, ME-LIKE PROTEIN', 243725),
(342429, 'PTHR35461', NULL, NULL, NULL, NULL, 'BNAANNG14610D PROTEIN', 243726),
(342430, 'PTHR35461:SF6', NULL, NULL, NULL, NULL, '', 243726),
(342431, 'PTHR35461:SF9', NULL, NULL, NULL, NULL, 'OVATE DOMAIN-CONTAINING PROTEIN', 243726),
(342432, 'PTHR35461:SF8', NULL, NULL, NULL, NULL, 'LOW PROTEIN: ATP-DEPENDENT RNA HELICASE-LIKE PROTEIN', 243726),
(342433, 'PTHR35461:SF3', NULL, NULL, NULL, NULL, 'BNAANNG14610D PROTEIN', 243726),
(342434, 'PTHR35461:SF5', NULL, NULL, NULL, NULL, 'RNA HELICASE DDX11-LIKE PROTEIN, PUTATIVE-RELATED', 243726),
(342435, 'PTHR35461:SF1', NULL, NULL, NULL, NULL, 'LOW PROTEIN: ATP-DEPENDENT RNA HELICASE-LIKE PROTEIN', 243726),
(342436, 'PTHR30296:SF0', NULL, NULL, NULL, NULL, 'LACTATE UTILIZATION PROTEIN A', 243727),
(342437, 'PTHR30296', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN YKGE', 243727),
(342438, 'PTHR46576:SF1', NULL, NULL, NULL, NULL, 'BROMO ADJACENT HOMOLOGY DOMAIN-CONTAINING 1 PROTEIN', 243728),
(342439, 'PTHR46576', NULL, NULL, NULL, NULL, 'BROMO ADJACENT HOMOLOGY DOMAIN-CONTAINING 1 PROTEIN', 243728),
(342440, 'PTHR11238:SF9', NULL, NULL, NULL, NULL, 'PROMININ, ISOFORM D', 243729),
(342441, 'PTHR11238', NULL, NULL, NULL, NULL, 'PROMININ ISOFORM D-RELATED', 243729),
(342442, 'PTHR21471:SF4', NULL, NULL, NULL, NULL, 'DUF1248 DOMAIN-CONTAINING PROTEIN', 243730),
(342443, 'PTHR21471:SF5', NULL, NULL, NULL, NULL, 'DUF1248 DOMAIN-CONTAINING PROTEIN', 243730),
(342444, 'PTHR21471:SF6', NULL, NULL, NULL, NULL, 'DUF1248 DOMAIN-CONTAINING PROTEIN', 243730),
(342445, 'PTHR21471', NULL, NULL, NULL, NULL, 'GNAT FAMILY ACETYLTRANSFERASE-RELATED', 243730),
(342446, 'PTHR21471:SF2', NULL, NULL, NULL, NULL, 'DUF1248 DOMAIN-CONTAINING PROTEIN', 243730),
(342447, 'PTHR21471:SF48', NULL, NULL, NULL, NULL, 'DUF1248 DOMAIN-CONTAINING PROTEIN', 243730),
(342448, 'PTHR17223:SF0', NULL, NULL, NULL, NULL, 'PARATHYROID HORMONE-RELATED PROTEIN', 243731),
(342449, 'PTHR17223', NULL, NULL, NULL, NULL, 'PARATHYROID HORMONE-RELATED', 243731),
(342450, 'PTHR17223:SF1', NULL, NULL, NULL, NULL, 'PARATHYROID HORMONE 4', 243731),
(342451, 'PTHR23244:SF437', NULL, NULL, NULL, NULL, '', 243732),
(342452, 'PTHR23244:SF459', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 243732),
(342453, 'PTHR23244:SF458', NULL, NULL, NULL, NULL, 'BNAA02G16730D PROTEIN', 243732),
(342454, 'PTHR23244:SF436', NULL, NULL, NULL, NULL, 'CONSERVED KELCH REPEAT PROTEIN TEAB (EUROFUNG)', 243732),
(342455, 'PTHR23244:SF356', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243732),
(342456, 'PTHR23244:SF455', NULL, NULL, NULL, NULL, 'OS01G0300900 PROTEIN', 243732),
(342457, 'PTHR23244:SF456', NULL, NULL, NULL, NULL, 'MULTIPLE EPIDERMAL GROWTH FACTOR-LIKE DOMAINS PROTEIN 8', 243732),
(342458, 'PTHR23244:SF310', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN B', 243732),
(342459, 'PTHR23244:SF497', NULL, NULL, NULL, NULL, 'WALL ANCHORED PROTEIN, PUTATIVE-RELATED', 243732),
(342460, 'PTHR23244', NULL, NULL, NULL, NULL, 'KELCH REPEAT DOMAIN', 243732);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(342461, 'PTHR23244:SF495', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT BETA 1-RELATED', 243732),
(342462, 'PTHR23244:SF430', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 243732),
(342463, 'PTHR23244:SF496', NULL, NULL, NULL, NULL, '', 243732),
(342464, 'PTHR23244:SF452', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243732),
(342465, 'PTHR23244:SF474', NULL, NULL, NULL, NULL, '', 243732),
(342466, 'PTHR23244:SF493', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 243732),
(342467, 'PTHR23244:SF471', NULL, NULL, NULL, NULL, 'F25I16.5 PROTEIN', 243732),
(342468, 'PTHR23244:SF494', NULL, NULL, NULL, NULL, '', 243732),
(342469, 'PTHR23244:SF491', NULL, NULL, NULL, NULL, 'SAM DOMAIN-CONTAINING PROTEIN', 243732),
(342470, 'PTHR23244:SF293', NULL, NULL, NULL, NULL, '', 243732),
(342471, 'PTHR23244:SF470', NULL, NULL, NULL, NULL, '', 243732),
(342472, 'PTHR23244:SF492', NULL, NULL, NULL, NULL, 'KELCH DOMAIN-CONTAINING PROTEIN-CONTAINING PROTEIN', 243732),
(342473, 'PTHR23244:SF490', NULL, NULL, NULL, NULL, 'KELCH REPEAT PROTEIN', 243732),
(342474, 'PTHR23244:SF446', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN GACHH', 243732),
(342475, 'PTHR23244:SF468', NULL, NULL, NULL, NULL, 'BTB_2 DOMAIN-CONTAINING PROTEIN', 243732),
(342476, 'PTHR23244:SF447', NULL, NULL, NULL, NULL, 'GALACTOSE OXIDASE/KELCH REPEAT SUPERFAMILY PROTEIN', 243732),
(342477, 'PTHR23244:SF425', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 243732),
(342478, 'PTHR23244:SF488', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 243732),
(342479, 'PTHR23244:SF466', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 243732),
(342480, 'PTHR23244:SF489', NULL, NULL, NULL, NULL, 'YALI0A10120P', 243732),
(342481, 'PTHR23244:SF467', NULL, NULL, NULL, NULL, '', 243732),
(342482, 'PTHR23244:SF486', NULL, NULL, NULL, NULL, 'F-BOX/KELCH-REPEAT PLANT PROTEIN', 243732),
(342483, 'PTHR23244:SF487', NULL, NULL, NULL, NULL, '', 243732),
(342484, 'PTHR23244:SF465', NULL, NULL, NULL, NULL, 'ZGC:163014', 243732),
(342485, 'PTHR23244:SF462', NULL, NULL, NULL, NULL, 'KELCH REPEAT-CONTAINING PROTEIN', 243732),
(342486, 'PTHR23244:SF484', NULL, NULL, NULL, NULL, '', 243732),
(342487, 'PTHR23244:SF441', NULL, NULL, NULL, NULL, '', 243732),
(342488, 'PTHR23244:SF485', NULL, NULL, NULL, NULL, 'MULTIPLE EGF LIKE DOMAINS 8, ISOFORM B', 243732),
(342489, 'PTHR23244:SF482', NULL, NULL, NULL, NULL, 'GALACTOSE OXIDASE/KELCH REPEAT PROTEIN', 243732),
(342490, 'PTHR23244:SF483', NULL, NULL, NULL, NULL, 'ATTRACTIN LIKE 1', 243732),
(342491, 'PTHR23244:SF481', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 243732),
(342492, 'PTHR47316:SF1', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN H1', 243733),
(342493, 'PTHR47316', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN H1', 243733),
(342494, 'PTHR10956:SF21', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L31', 243734),
(342495, 'PTHR10956:SF42', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L31', 243734),
(342496, 'PTHR10956:SF31', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L31', 243734),
(342497, 'PTHR10956:SF41', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L31', 243734),
(342498, 'PTHR10956:SF47', NULL, NULL, NULL, NULL, 'OS02G0717800 PROTEIN', 243734),
(342499, 'PTHR10956', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L31', 243734),
(342500, 'PTHR10956:SF46', NULL, NULL, NULL, NULL, 'OS06G0319700 PROTEIN', 243734),
(342501, 'PTHR10956:SF35', NULL, NULL, NULL, NULL, 'BNAA08G14400D PROTEIN', 243734),
(342502, 'PTHR10956:SF34', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L31-1', 243734),
(342503, 'PTHR10956:SF33', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L31B', 243734),
(342504, 'PTHR10956:SF44', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L31', 243734),
(342505, 'PTHR10956:SF29', NULL, NULL, NULL, NULL, '', 243734),
(342506, 'PTHR10956:SF17', NULL, NULL, NULL, NULL, '', 243734),
(342507, 'PTHR10956:SF39', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L31', 243734),
(342508, 'PTHR10956:SF38', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L31-LIKE', 243734);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(342509, 'PTHR10956:SF37', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L31', 243734),
(342510, 'PTHR10956:SF4', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L31', 243734),
(342511, 'PTHR10956:SF0', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L31', 243734),
(342512, 'PTHR38797:SF7', NULL, NULL, NULL, NULL, '', 243735),
(342513, 'PTHR38797:SF6', NULL, NULL, NULL, NULL, '', 243735),
(342514, 'PTHR38797', NULL, NULL, NULL, NULL, '', 243735),
(342515, 'PTHR38797:SF4', NULL, NULL, NULL, NULL, '', 243735),
(342516, 'PTHR12844:SF17', NULL, NULL, NULL, NULL, 'CONNECTOR ENHANCER OF KINASE SUPPRESSOR OF RAS 3', 243736),
(342517, 'PTHR12844', NULL, NULL, NULL, NULL, 'CONNECTOR ENCHANCER OF KINASE SUPPRESSOR OF RAS', 243736),
(342518, 'PTHR12844:SF21', NULL, NULL, NULL, NULL, 'CONNECTOR ENHANCER OF KINASE SUPPRESSOR OF RAS 2', 243736),
(342519, 'PTHR12844:SF10', NULL, NULL, NULL, NULL, 'CONNECTOR ENHANCER OF KINASE SUPPRESSOR OF RAS 1', 243736),
(342520, 'PTHR12844:SF42', NULL, NULL, NULL, NULL, 'CONNECTOR ENHANCER OF KSR PROTEIN CNK', 243736),
(342521, 'PTHR12844:SF46', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4933403O08 GENE', 243736),
(342522, 'PTHR12844:SF45', NULL, NULL, NULL, NULL, 'CNK3/IPCEF1 FUSION PROTEIN-RELATED', 243736),
(342523, 'PTHR12844:SF12', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN-RELATED', 243736),
(342524, 'PTHR46011:SF29', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-57', 243737),
(342525, 'PTHR46011:SF27', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-11', 243737),
(342526, 'PTHR46011:SF28', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-71', 243737),
(342527, 'PTHR46011:SF25', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 243737),
(342528, 'PTHR46011:SF26', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-22', 243737),
(342529, 'PTHR46011:SF23', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-121', 243737),
(342530, 'PTHR46011:SF24', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 243737),
(342531, 'PTHR46011:SF21', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-13', 243737),
(342532, 'PTHR46011:SF22', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 243737),
(342533, 'PTHR46011:SF2', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-28', 243737),
(342534, 'PTHR46011:SF20', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER ODR-7', 243737),
(342535, 'PTHR46011:SF4', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 243737),
(342536, 'PTHR46011:SF3', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 243737),
(342537, 'PTHR46011:SF6', NULL, NULL, NULL, NULL, 'HIGH ZINC ACTIVATED NUCLEAR RECEPTOR PROTEIN', 243737),
(342538, 'PTHR46011:SF5', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-42', 243737),
(342539, 'PTHR46011:SF7', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY-RELATED', 243737),
(342540, 'PTHR46011', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-86-RELATED', 243737),
(342541, 'PTHR46011:SF18', NULL, NULL, NULL, NULL, 'NR LBD DOMAIN-CONTAINING PROTEIN-RELATED', 243737),
(342542, 'PTHR46011:SF19', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 243737),
(342543, 'PTHR46011:SF16', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 243737),
(342544, 'PTHR46011:SF17', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY-RELATED', 243737),
(342545, 'PTHR46011:SF14', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 243737),
(342546, 'PTHR46011:SF15', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 243737),
(342547, 'PTHR46011:SF12', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 243737),
(342548, 'PTHR46011:SF13', NULL, NULL, NULL, NULL, 'NR LBD DOMAIN-CONTAINING PROTEIN', 243737),
(342549, 'PTHR46011:SF10', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-199-RELATED', 243737),
(342550, 'PTHR46011:SF32', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 243737);
INSERT INTO "PUBLIC"."MODEL" VALUES
(342551, 'PTHR46011:SF30', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-79', 243737),
(342552, 'PTHR46011:SF31', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-86', 243737),
(342553, 'PTHR11455:SF2', NULL, NULL, NULL, NULL, 'BLUE-LIGHT PHOTORECEPTOR PHR2', 243738),
(342554, 'PTHR11455:SF17', NULL, NULL, NULL, NULL, 'CRYPTOCHROME-1', 243738),
(342555, 'PTHR11455:SF9', NULL, NULL, NULL, NULL, '(6-4)-PHOTOLYASE, ISOFORM A', 243738),
(342556, 'PTHR11455:SF16', NULL, NULL, NULL, NULL, 'CRYPTOCHROME-1', 243738),
(342557, 'PTHR11455:SF18', NULL, NULL, NULL, NULL, 'SI:CH1073-390K14.1', 243738),
(342558, 'PTHR11455:SF56', NULL, NULL, NULL, NULL, 'CRY2A PROTEIN', 243738),
(342559, 'PTHR11455:SF15', NULL, NULL, NULL, NULL, 'CRYPTOCHROME-2', 243738),
(342560, 'PTHR11455:SF59', NULL, NULL, NULL, NULL, 'CRYPTOCHROME 1-RELATED', 243738),
(342561, 'PTHR11455:SF58', NULL, NULL, NULL, NULL, 'OS02G0573200 PROTEIN', 243738),
(342562, 'PTHR11455:SF30', NULL, NULL, NULL, NULL, 'CRYPTOCHROME 2', 243738),
(342563, 'PTHR11455:SF52', NULL, NULL, NULL, NULL, 'CRYPTOCHROME CIRCADIAN REGULATOR 5', 243738),
(342564, 'PTHR11455:SF22', NULL, NULL, NULL, NULL, 'CRYPTOCHROME DASH', 243738),
(342565, 'PTHR11455:SF55', NULL, NULL, NULL, NULL, 'CRYPTOCHROME-1-LIKE', 243738),
(342566, 'PTHR11455', NULL, NULL, NULL, NULL, 'CRYPTOCHROME', 243738),
(342567, 'PTHR11455:SF10', NULL, NULL, NULL, NULL, 'CRYPTOCHROME CIRCADIAN REGULATOR 3A-RELATED', 243738),
(342568, 'PTHR11455:SF60', NULL, NULL, NULL, NULL, 'CRYPTOCHROME 2B APOPROTEIN', 243738),
(342569, 'PTHR11455:SF62', NULL, NULL, NULL, NULL, 'DNA PHOTOLYASE CLASS 1, 8-HDF TYPE-RELATED', 243738),
(342570, 'PTHR11455:SF61', NULL, NULL, NULL, NULL, 'CRYPTOCHROME-LIKE PROTEIN', 243738),
(342571, 'PTHR11455:SF50', NULL, NULL, NULL, NULL, 'CRYPTOCHROME-1', 243738),
(342572, 'PTHR43208', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER SUBSTRATE-BINDING PROTEIN', 243739),
(342573, 'PTHR43208:SF1', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER SUBSTRATE-BINDING PROTEIN', 243739),
(342574, 'PTHR11781:SF4', NULL, NULL, NULL, NULL, 'THYROXINE 5-DEIODINASE', 243740),
(342575, 'PTHR11781:SF22', NULL, NULL, NULL, NULL, 'TYPE I IODOTHYRONINE DEIODINASE', 243740),
(342576, 'PTHR11781:SF20', NULL, NULL, NULL, NULL, 'TYPE II IODOTHYRONINE DEIODINASE', 243740),
(342577, 'PTHR11781:SF19', NULL, NULL, NULL, NULL, 'THYROXINE 5''-DEIODINASE', 243740),
(342578, 'PTHR11781', NULL, NULL, NULL, NULL, 'IODOTHYRONINE DEIODINASE', 243740),
(342579, 'PTHR13507:SF0', NULL, NULL, NULL, NULL, 'PRKR-INTERACTING PROTEIN 1', 243741),
(342580, 'PTHR13507', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243741),
(342581, 'PTHR13507:SF5', NULL, NULL, NULL, NULL, '', 243741),
(342582, 'PTHR47014:SF1', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY S MEMBER 1', 243742),
(342583, 'PTHR47014', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY S MEMBER 1', 243742),
(342584, 'PTHR11098:SF25', NULL, NULL, NULL, NULL, 'NICOTINATE PHOSPHORIBOSYLTRANSFERASE', 243743),
(342585, 'PTHR11098:SF23', NULL, NULL, NULL, NULL, 'NICOTINATE PHOSPHORIBOSYLTRANSFERASE', 243743),
(342586, 'PTHR11098:SF1', NULL, NULL, NULL, NULL, 'NICOTINATE PHOSPHORIBOSYLTRANSFERASE', 243743),
(342587, 'PTHR11098:SF22', NULL, NULL, NULL, NULL, 'NICOTINATE PHOSPHORIBOSYLTRANSFERASE', 243743),
(342588, 'PTHR11098:SF8', NULL, NULL, NULL, NULL, 'NICOTINATE PHOSPHORIBOSYLTRANSFERASE PNCB1', 243743),
(342589, 'PTHR11098:SF19', NULL, NULL, NULL, NULL, 'NICOTINATE PHOSPHORIBOSYLTRANSFERASE 1', 243743),
(342590, 'PTHR11098', NULL, NULL, NULL, NULL, 'NICOTINATE PHOSPHORIBOSYLTRANSFERASE', 243743),
(342591, 'PTHR35755:SF1', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 243744),
(342592, 'PTHR35755', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 243744),
(342593, 'PTHR35755:SF3', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243744),
(342594, 'PTHR23325', NULL, NULL, NULL, NULL, 'SERUM RESPONSE FACTOR-BINDING', 243745),
(342595, 'PTHR23325:SF1', NULL, NULL, NULL, NULL, 'SERUM RESPONSE FACTOR-BINDING PROTEIN 1', 243745);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(342596, 'PTHR12486:SF4', NULL, NULL, NULL, NULL, 'APRATAXIN', 243746),
(342597, 'PTHR12486:SF5', NULL, NULL, NULL, NULL, 'HISTIDINE TRIAD NUCLEOTIDE-BINDING PROTEIN 3', 243746),
(342598, 'PTHR12486', NULL, NULL, NULL, NULL, 'APRATAXIN-RELATED', 243746),
(342599, 'PTHR35007:SF1', NULL, NULL, NULL, NULL, 'PILUS ASSEMBLY PROTEIN', 243747),
(342600, 'PTHR35007:SF4', NULL, NULL, NULL, NULL, 'CONSERVED TRANSMEMBRANE PROTEIN-RELATED', 243747),
(342601, 'PTHR35007:SF3', NULL, NULL, NULL, NULL, 'POSSIBLE CONSERVED ALANINE RICH MEMBRANE PROTEIN', 243747),
(342602, 'PTHR35007:SF2', NULL, NULL, NULL, NULL, 'PILUS ASSEMBLE PROTEIN', 243747),
(342603, 'PTHR35007', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN-RELATED', 243747),
(342604, 'PTHR20863:SF74', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN', 243748),
(342605, 'PTHR20863:SF73', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN', 243748),
(342606, 'PTHR20863', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN', 243748),
(342607, 'PTHR20863:SF62', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN', 243748),
(342608, 'PTHR20863:SF69', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN', 243748),
(342609, 'PTHR20863:SF67', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN', 243748),
(342610, 'PTHR20863:SF66', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN', 243748),
(342611, 'PTHR20863:SF28', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN, MITOCHONDRIAL', 243748),
(342612, 'PTHR20863:SF27', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN', 243748),
(342613, 'PTHR20863:SF72', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN', 243748),
(342614, 'PTHR20863:SF71', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN 2, MITOCHONDRIAL', 243748),
(342615, 'PTHR20863:SF60', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN 3, MITOCHONDRIAL', 243748),
(342616, 'PTHR20863:SF70', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN', 243748),
(342617, 'PTHR14690:SF0', NULL, NULL, NULL, NULL, 'ATPASE_AAA_CORE DOMAIN-CONTAINING PROTEIN', 243749),
(342618, 'PTHR14690', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243749),
(342619, 'PTHR14690:SF9', NULL, NULL, NULL, NULL, 'GH08353P', 243749),
(342620, 'PTHR14690:SF8', NULL, NULL, NULL, NULL, 'DYNEIN REGULATORY COMPLEX PROTEIN 11', 243749),
(342621, 'PTHR14690:SF6', NULL, NULL, NULL, NULL, 'IQ AND AAA DOMAIN-CONTAINING PROTEIN 1-LIKE', 243749),
(342622, 'PTHR14690:SF11', NULL, NULL, NULL, NULL, 'IQ MOTIF-CONTAINING WITH AAA DOMAIN 1', 243749),
(342623, 'PTHR14690:SF10', NULL, NULL, NULL, NULL, 'ZGC:153738', 243749),
(342624, 'PTHR23354', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 7/ESTROGEN RECEPTOR COACTIVATOR-RELATED', 243750),
(342625, 'PTHR23354:SF65', NULL, NULL, NULL, NULL, 'TLD DOMAIN-CONTAINING PROTEIN 2', 243750),
(342626, 'PTHR23354:SF76', NULL, NULL, NULL, NULL, 'OS06G0221100 PROTEIN', 243750),
(342627, 'PTHR23354:SF120', NULL, NULL, NULL, NULL, 'SI:CH211-15D5.11', 243750),
(342628, 'PTHR23354:SF121', NULL, NULL, NULL, NULL, '', 243750),
(342629, 'PTHR23354:SF122', NULL, NULL, NULL, NULL, 'GTPASE-ACTIVATING PROTEIN SKYWALKER', 243750),
(342630, 'PTHR23354:SF69', NULL, NULL, NULL, NULL, 'OXIDATION RESISTANCE PROTEIN 1', 243750),
(342631, 'PTHR23354:SF68', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR COACTIVATOR 7', 243750),
(342632, 'PTHR23354:SF116', NULL, NULL, NULL, NULL, '', 243750),
(342633, 'PTHR23354:SF106', NULL, NULL, NULL, NULL, 'TLD DOMAIN-CONTAINING PROTEIN 2-LIKE ISOFORM X1', 243750),
(342634, 'PTHR23354:SF118', NULL, NULL, NULL, NULL, 'TLDC DOMAIN-CONTAINING PROTEIN-RELATED', 243750),
(342635, 'PTHR23354:SF119', NULL, NULL, NULL, NULL, 'TLDC DOMAIN-CONTAINING PROTEIN', 243750),
(342636, 'PTHR23354:SF108', NULL, NULL, NULL, NULL, 'RE10231P', 243750),
(342637, 'PTHR23354:SF123', NULL, NULL, NULL, NULL, '', 243750),
(342638, 'PTHR23354:SF74', NULL, NULL, NULL, NULL, 'TLD-DOMAIN CONTAINING NUCLEOLAR PROTEIN', 243750),
(342639, 'PTHR23354:SF104', NULL, NULL, NULL, NULL, 'TLD-DOMAIN CONTAINING NUCLEOLAR PROTEIN', 243750),
(342640, 'PTHR23354:SF62', NULL, NULL, NULL, NULL, 'MUSTARD, ISOFORM V', 243750),
(342641, 'PTHR23354:SF95', NULL, NULL, NULL, NULL, 'MTOR-ASSOCIATED PROTEIN MEAK7', 243750);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(342642, 'PTHR36205:SF4', NULL, NULL, NULL, NULL, '', 243751),
(342643, 'PTHR36205:SF3', NULL, NULL, NULL, NULL, '', 243751),
(342644, 'PTHR36205:SF2', NULL, NULL, NULL, NULL, 'CHROMOSOME 19, WHOLE GENOME SHOTGUN SEQUENCE', 243751),
(342645, 'PTHR36205:SF1', NULL, NULL, NULL, NULL, '', 243751),
(342646, 'PTHR36205', NULL, NULL, NULL, NULL, 'CHROMOSOME 19, WHOLE GENOME SHOTGUN SEQUENCE', 243751),
(342647, 'PTHR22912:SF214', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYL DEHYDROGENASE', 243752),
(342648, 'PTHR22912:SF204', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYL DEHYDROGENASE', 243752),
(342649, 'PTHR22912:SF93', NULL, NULL, NULL, NULL, 'SOLUBLE PYRIDINE NUCLEOTIDE TRANSHYDROGENASE', 243752),
(342650, 'PTHR22912:SF216', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYL DEHYDROGENASE 2, CHLOROPLASTIC-LIKE ISOFORM X1', 243752),
(342651, 'PTHR22912:SF217', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYL DEHYDROGENASE', 243752),
(342652, 'PTHR22912:SF210', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYL DEHYDROGENASE', 243752),
(342653, 'PTHR22912:SF221', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYL DEHYDROGENASE', 243752),
(342654, 'PTHR22912:SF211', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYL DEHYDROGENASE 2, MITOCHONDRIAL', 243752),
(342655, 'PTHR22912:SF222', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE-RELATED', 243752),
(342656, 'PTHR22912:SF94', NULL, NULL, NULL, NULL, 'DIHYDROLIPOAMIDE DEHYDROGENASE, POINT MUTATION', 243752),
(342657, 'PTHR22912:SF212', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYL DEHYDROGENASE', 243752),
(342658, 'PTHR22912:SF223', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYL DEHYDROGENASE 1, MITOCHONDRIAL', 243752),
(342659, 'PTHR22912:SF103', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE-RELATED', 243752),
(342660, 'PTHR22912:SF224', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYL DEHYDROGENASE', 243752),
(342661, 'PTHR22912', NULL, NULL, NULL, NULL, 'DISULFIDE OXIDOREDUCTASE', 243752),
(342662, 'PTHR22912:SF207', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYL DEHYDROGENASE 2, CHLOROPLASTIC', 243752),
(342663, 'PTHR22912:SF219', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYL DEHYDROGENASE', 243752),
(342664, 'PTHR22912:SF151', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYL DEHYDROGENASE, MITOCHONDRIAL', 243752),
(342665, 'PTHR22912:SF220', NULL, NULL, NULL, NULL, 'LEGHEMOGLOBIN REDUCTASE', 243752),
(342666, 'PTHR22912:SF160', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYL DEHYDROGENASE', 243752),
(342667, 'PTHR47854:SF1', NULL, NULL, NULL, NULL, 'SURFEIT LOCUS PROTEIN 2 (SURF2)', 243753),
(342668, 'PTHR47854:SF2', NULL, NULL, NULL, NULL, 'BNAANNG33100D PROTEIN', 243753),
(342669, 'PTHR47854', NULL, NULL, NULL, NULL, 'SURFEIT LOCUS PROTEIN 2 (SURF2)', 243753),
(342670, 'PTHR35736', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243754),
(342671, 'PTHR35736:SF3', NULL, NULL, NULL, NULL, '', 243754),
(342672, 'PTHR35736:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243754),
(342673, 'PTHR12910:SF13', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX SUBUNIT 12', 243755),
(342674, 'PTHR12910:SF12', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX SUBUNIT 12', 243755),
(342675, 'PTHR12910', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE SUBUNIT B17.2', 243755),
(342676, 'PTHR12910:SF1', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX SUBUNIT 12', 243755),
(342677, 'PTHR12910:SF10', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX SUBUNIT 12', 243755),
(342678, 'PTHR12910:SF2', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX SUBUNIT 12', 243755),
(342679, 'PTHR15185:SF3', NULL, NULL, NULL, NULL, 'B-CELL CLL/LYMPHOMA 9-LIKE PROTEIN', 243756),
(342680, 'PTHR15185', NULL, NULL, NULL, NULL, 'BCL9', 243756),
(342681, 'PTHR15185:SF6', NULL, NULL, NULL, NULL, 'BCL9 DOMAIN-CONTAINING PROTEIN', 243756),
(342682, 'PTHR15185:SF5', NULL, NULL, NULL, NULL, 'B-CELL CLL/LYMPHOMA 9 PROTEIN', 243756),
(342683, 'PTHR15251', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC BASIC PROTEIN Y 1-RELATED', 243757),
(342684, 'PTHR15251:SF2', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC BASIC PROTEIN Y 1-RELATED', 243757);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(342685, 'PTHR23142:SF3', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR 38', 243758),
(342686, 'PTHR23142:SF2', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR 38B', 243758),
(342687, 'PTHR23142:SF1', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR 38A', 243758),
(342688, 'PTHR23142', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243758),
(342689, 'PTHR23142:SF8', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR 38', 243758),
(342690, 'PTHR23142:SF7', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR 38A', 243758),
(342691, 'PTHR23142:SF6', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR 38A', 243758),
(342692, 'PTHR24274', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 161', 243759),
(342693, 'PTHR24274:SF1', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 161', 243759),
(342694, 'PTHR24274:SF2', NULL, NULL, NULL, NULL, 'CYSTEINE PEPTIDASE, PUTATIVE-RELATED', 243759),
(342695, 'PTHR47091:SF1', NULL, NULL, NULL, NULL, 'ALPHA-PROTEIN KINASE 3', 243760),
(342696, 'PTHR47091:SF2', NULL, NULL, NULL, NULL, 'ALPHA-PROTEIN KINASE 2', 243760),
(342697, 'PTHR47091', NULL, NULL, NULL, NULL, 'ALPHA-PROTEIN KINASE 2-RELATED', 243760),
(342698, 'PTHR46068:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG27172', 243761),
(342699, 'PTHR46068', NULL, NULL, NULL, NULL, 'PROTEIN CBG27172', 243761),
(342700, 'PTHR15941:SF11', NULL, NULL, NULL, NULL, 'MYOZENIN-1', 243762),
(342701, 'PTHR15941:SF15', NULL, NULL, NULL, NULL, 'MYOZENIN-3', 243762),
(342702, 'PTHR15941:SF14', NULL, NULL, NULL, NULL, 'MYOZENIN 1B', 243762),
(342703, 'PTHR15941:SF9', NULL, NULL, NULL, NULL, 'MYOZENIN-2', 243762),
(342704, 'PTHR15941', NULL, NULL, NULL, NULL, 'MYOZENIN', 243762),
(342705, 'PTHR42253:SF1', NULL, NULL, NULL, NULL, '', 243763),
(342706, 'PTHR42253:SF2', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PREDICTED MULTIPASS TRANSMEMBRANE PROTEIN', 243763),
(342707, 'PTHR42253', NULL, NULL, NULL, NULL, '', 243763),
(342708, 'PTHR13370:SF19', NULL, NULL, NULL, NULL, 'UPF0020 DOMAIN-CONTAINING PROTEIN', 243764),
(342709, 'PTHR13370:SF3', NULL, NULL, NULL, NULL, 'TRNA (GUANINE(10)-N2)-METHYLTRANSFERASE HOMOLOG', 243764),
(342710, 'PTHR13370', NULL, NULL, NULL, NULL, 'RNA METHYLASE-RELATED', 243764),
(342711, 'PTHR13370:SF31', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 243764),
(342712, 'PTHR13370:SF22', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 243764),
(342713, 'PTHR13370:SF32', NULL, NULL, NULL, NULL, 'DNA ADENINE METHYLTRANSFERASE YHDJ', 243764),
(342714, 'PTHR13370:SF24', NULL, NULL, NULL, NULL, 'TYPE III RESTRICTION-MODIFICATION SYSTEM HINDVIP ENZYME MOD-RELATED', 243764),
(342715, 'PTHR13370:SF26', NULL, NULL, NULL, NULL, 'UPF0020 DOMAIN-CONTAINING PROTEIN', 243764),
(342716, 'PTHR13370:SF16', NULL, NULL, NULL, NULL, 'TYPE III RESTRICTION-MODIFICATION SYSTEM STYLTI ENZYME MOD', 243764),
(342717, 'PTHR46021:SF5', NULL, NULL, NULL, NULL, 'ARF-GAP WITH DUAL PH DOMAIN-CONTAINING PROTEIN 1', 243765),
(342718, 'PTHR46021:SF2', NULL, NULL, NULL, NULL, 'ARF-GAP WITH DUAL PH DOMAIN-CONTAINING PROTEIN 1-LIKE PROTEIN', 243765),
(342719, 'PTHR46021:SF3', NULL, NULL, NULL, NULL, 'ZGC:92360', 243765),
(342720, 'PTHR46021:SF1', NULL, NULL, NULL, NULL, 'ARFGAP WITH DUAL PH DOMAINS 1-LIKE', 243765),
(342721, 'PTHR46021', NULL, NULL, NULL, NULL, 'ARF-GAP WITH DUAL PH DOMAIN-CONTAINING PROTEIN 1-LIKE PROTEIN', 243765),
(342722, 'PTHR46021:SF6', NULL, NULL, NULL, NULL, 'ARF-GAP WITH DUAL PH DOMAIN-CONTAINING PROTEIN 2', 243765),
(342723, 'PTHR11203:SF52', NULL, NULL, NULL, NULL, 'MRNA 3-END PROCESSING FACTOR', 243766),
(342724, 'PTHR11203:SF51', NULL, NULL, NULL, NULL, 'CLEAVAGE AND POLYADENYLATION SPECIFICITY FACTOR', 243766),
(342725, 'PTHR11203:SF11', NULL, NULL, NULL, NULL, 'CLEAVAGE AND POLYADENYLATION SPECIFICITY FACTOR SUBUNIT 3', 243766),
(342726, 'PTHR11203:SF49', NULL, NULL, NULL, NULL, 'BLL1145 PROTEIN', 243766),
(342727, 'PTHR11203:SF48', NULL, NULL, NULL, NULL, '', 243766),
(342728, 'PTHR11203:SF37', NULL, NULL, NULL, NULL, 'INTEGRATOR COMPLEX SUBUNIT 11', 243766),
(342729, 'PTHR11203', NULL, NULL, NULL, NULL, 'CLEAVAGE AND POLYADENYLATION SPECIFICITY FACTOR FAMILY MEMBER', 243766);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(342730, 'PTHR40625', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN ESDC-RELATED', 243767),
(342731, 'PTHR40625:SF2', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN ESDC', 243767),
(342732, 'PTHR40625:SF1', NULL, NULL, NULL, NULL, '', 243767),
(342733, 'PTHR36890:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CYCLOPS', 243768),
(342734, 'PTHR36890', NULL, NULL, NULL, NULL, 'PROTEIN CYCLOPS', 243768),
(342735, 'PTHR36316:SF2', NULL, NULL, NULL, NULL, '', 243769),
(342736, 'PTHR36316', NULL, NULL, NULL, NULL, 'OS06G0213900 PROTEIN', 243769),
(342737, 'PTHR36316:SF1', NULL, NULL, NULL, NULL, 'OS06G0213900 PROTEIN', 243769),
(342738, 'PTHR34721:SF13', NULL, NULL, NULL, NULL, 'PROTEIN CBG24511', 243770),
(342739, 'PTHR34721:SF14', NULL, NULL, NULL, NULL, 'PROTEIN CBG27134', 243770),
(342740, 'PTHR34721:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG09734', 243770),
(342741, 'PTHR34721:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG09158', 243770),
(342742, 'PTHR34721:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG20110', 243770),
(342743, 'PTHR34721:SF11', NULL, NULL, NULL, NULL, 'PROTEIN CBG23402', 243770),
(342744, 'PTHR34721:SF12', NULL, NULL, NULL, NULL, 'PROTEIN CBG18459', 243770),
(342745, 'PTHR34721', NULL, NULL, NULL, NULL, 'PROTEIN CBG09734', 243770),
(342746, 'PTHR34721:SF10', NULL, NULL, NULL, NULL, 'ACTIVIN_RECP DOMAIN-CONTAINING PROTEIN', 243770),
(342747, 'PTHR28082:SF2', NULL, NULL, NULL, NULL, 'CHY-TYPE DOMAIN-CONTAINING PROTEIN', 243771),
(342748, 'PTHR28082:SF1', NULL, NULL, NULL, NULL, 'HELPER OF TIM PROTEIN 13', 243771),
(342749, 'PTHR28082', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 243771),
(342750, 'PTHR45680:SF24', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY-RELATED', 243772),
(342751, 'PTHR45680:SF25', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 243772),
(342752, 'PTHR45680:SF26', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-127-RELATED', 243772),
(342753, 'PTHR45680:SF27', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 243772),
(342754, 'PTHR45680:SF28', NULL, NULL, NULL, NULL, 'NR LBD DOMAIN-CONTAINING PROTEIN-RELATED', 243772),
(342755, 'PTHR45680:SF29', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 243772),
(342756, 'PTHR45680:SF21', NULL, NULL, NULL, NULL, 'NR LBD DOMAIN-CONTAINING PROTEIN', 243772),
(342757, 'PTHR45680', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 243772),
(342758, 'PTHR45680:SF22', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 243772),
(342759, 'PTHR45680:SF23', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 243772),
(342760, 'PTHR45680:SF13', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 243772),
(342761, 'PTHR45680:SF14', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY-RELATED', 243772),
(342762, 'PTHR45680:SF15', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 243772),
(342763, 'PTHR45680:SF16', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 243772),
(342764, 'PTHR45680:SF17', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY-RELATED', 243772),
(342765, 'PTHR45680:SF18', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-130', 243772),
(342766, 'PTHR45680:SF7', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 243772),
(342767, 'PTHR45680:SF6', NULL, NULL, NULL, NULL, 'NR LBD DOMAIN-CONTAINING PROTEIN-RELATED', 243772),
(342768, 'PTHR45680:SF9', NULL, NULL, NULL, NULL, 'NR LBD DOMAIN-CONTAINING PROTEIN-RELATED', 243772),
(342769, 'PTHR45680:SF8', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 243772),
(342770, 'PTHR45680:SF30', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 243772),
(342771, 'PTHR45680:SF31', NULL, NULL, NULL, NULL, 'NR LBD DOMAIN-CONTAINING PROTEIN-RELATED', 243772),
(342772, 'PTHR45680:SF32', NULL, NULL, NULL, NULL, 'NR LBD DOMAIN-CONTAINING PROTEIN-RELATED', 243772),
(342773, 'PTHR45680:SF10', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY-RELATED', 243772),
(342774, 'PTHR45680:SF11', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 243772);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(342775, 'PTHR45680:SF33', NULL, NULL, NULL, NULL, 'NR LBD DOMAIN-CONTAINING PROTEIN-RELATED', 243772),
(342776, 'PTHR45680:SF12', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY-RELATED', 243772),
(342777, 'PTHR45680:SF34', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY-RELATED', 243772),
(342778, 'PTHR45680:SF1', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 243772),
(342779, 'PTHR45680:SF3', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 243772),
(342780, 'PTHR45680:SF2', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY-RELATED', 243772),
(342781, 'PTHR45680:SF5', NULL, NULL, NULL, NULL, 'NR LBD DOMAIN-CONTAINING PROTEIN-RELATED', 243772),
(342782, 'PTHR45680:SF4', NULL, NULL, NULL, NULL, 'NR LBD DOMAIN-CONTAINING PROTEIN', 243772),
(342783, 'PTHR37402:SF1', NULL, NULL, NULL, NULL, 'GRAM DOMAIN-CONTAINING PROTEIN 4', 243773),
(342784, 'PTHR37402', NULL, NULL, NULL, NULL, 'GRAM DOMAIN-CONTAINING PROTEIN 4', 243773),
(342785, 'PTHR15225:SF8', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 43', 243774),
(342786, 'PTHR15225:SF4', NULL, NULL, NULL, NULL, 'N-MYC-INTERACTOR', 243774),
(342787, 'PTHR15225:SF1', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED 35 KDA PROTEIN', 243774),
(342788, 'PTHR15225', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED PROTEIN 35/NMI N-MYC/STAT INTERACTING PROTEIN', 243774),
(342789, 'PTHR20842', NULL, NULL, NULL, NULL, 'PROTEASE S51 ALPHA-ASPARTYL DIPEPTIDASE', 243775),
(342790, 'PTHR20842:SF0', NULL, NULL, NULL, NULL, 'SI:DKEY-69O16.5', 243775),
(342791, 'PTHR43553:SF3', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN MODF', 243776),
(342792, 'PTHR43553:SF24', NULL, NULL, NULL, NULL, 'ENERGY-COUPLING FACTOR TRANSPORTER ATP-BINDING PROTEIN ECFA1', 243776),
(342793, 'PTHR43553:SF23', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING COMPONENT-RELATED', 243776),
(342794, 'PTHR43553:SF26', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN BC_2655-RELATED', 243776),
(342795, 'PTHR43553:SF25', NULL, NULL, NULL, NULL, 'ABC-TYPE COBALT TRANSPORT SYSTEM, ATPASE COMPONENT', 243776),
(342796, 'PTHR43553:SF27', NULL, NULL, NULL, NULL, 'ENERGY-COUPLING FACTOR TRANSPORTER ATP-BINDING PROTEIN ECFA2', 243776),
(342797, 'PTHR43553:SF1', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER I FAMILY MEMBER 11, CHLOROPLASTIC', 243776),
(342798, 'PTHR43553:SF19', NULL, NULL, NULL, NULL, 'HMP/THIAMINE IMPORT ATP-BINDING PROTEIN YKOD-RELATED', 243776),
(342799, 'PTHR43553:SF2', NULL, NULL, NULL, NULL, 'PEPTIDE EXPORT ATP-BINDING PROTEIN YYDI-RELATED', 243776),
(342800, 'PTHR43553', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORTER', 243776),
(342801, 'PTHR43553:SF11', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING/PERMEASE PROTEIN YOJI', 243776),
(342802, 'PTHR43553:SF21', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN MA_1418-RELATED', 243776),
(342803, 'PTHR38407:SF1', NULL, NULL, NULL, NULL, 'PROTEIN IVY1', 243777),
(342804, 'PTHR38407', NULL, NULL, NULL, NULL, 'PROTEIN IVY1', 243777),
(342805, 'PTHR45920:SF4', NULL, NULL, NULL, NULL, 'FORMIN HOMOLOGY 2 DOMAIN CONTAINING, ISOFORM I', 243778),
(342806, 'PTHR45920:SF3', NULL, NULL, NULL, NULL, 'FH1/FH2 DOMAIN-CONTAINING PROTEIN 3', 243778),
(342807, 'PTHR45920', NULL, NULL, NULL, NULL, 'FORMIN HOMOLOGY 2 DOMAIN CONTAINING, ISOFORM I', 243778),
(342808, 'PTHR45920:SF2', NULL, NULL, NULL, NULL, 'FH1/FH2 DOMAIN-CONTAINING PROTEIN 1', 243778),
(342809, 'PTHR45920:SF6', NULL, NULL, NULL, NULL, 'FORMIN-C', 243778),
(342810, 'PTHR13523:SF14', NULL, NULL, NULL, NULL, 'CHCH DOMAIN-CONTAINING PROTEIN', 243779),
(342811, 'PTHR13523:SF13', NULL, NULL, NULL, NULL, 'CHCH DOMAIN-CONTAINING PROTEIN', 243779),
(342812, 'PTHR13523:SF18', NULL, NULL, NULL, NULL, 'CHCH DOMAIN-CONTAINING PROTEIN', 243779),
(342813, 'PTHR13523:SF19', NULL, NULL, NULL, NULL, '', 243779),
(342814, 'PTHR13523:SF16', NULL, NULL, NULL, NULL, 'CHCH DOMAIN-CONTAINING PROTEIN', 243779),
(342815, 'PTHR13523:SF17', NULL, NULL, NULL, NULL, 'CHCH DOMAIN CONTAINING PROTEIN, EXPRESSED', 243779),
(342816, 'PTHR13523:SF2', NULL, NULL, NULL, NULL, 'COILED-COIL-HELIX-COILED-COIL-HELIX DOMAIN CONTAINING 2, ISOFORM A-RELATED', 243779);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(342817, 'PTHR13523', NULL, NULL, NULL, NULL, 'COILED-COIL-HELIX-COILED-COIL-HELIX DOMAIN CONTAINING 2/NUR77', 243779),
(342818, 'PTHR13523:SF3', NULL, NULL, NULL, NULL, 'COILED-COIL-HELIX-COILED-COIL-HELIX DOMAIN-CONTAINING PROTEIN 2-RELATED', 243779),
(342819, 'PTHR13523:SF4', NULL, NULL, NULL, NULL, 'COILED-COIL-HELIX-COILED-COIL-HELIX DOMAIN-CONTAINING PROTEIN 10, MITOCHONDRIAL', 243779),
(342820, 'PTHR13523:SF20', NULL, NULL, NULL, NULL, 'CHCH DOMAIN-CONTAINING PROTEIN', 243779),
(342821, 'PTHR21733:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG21949', 243780),
(342822, 'PTHR21733', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243780),
(342823, 'PTHR21733:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG09578', 243780),
(342824, 'PTHR21733:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG12168', 243780),
(342825, 'PTHR21733:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBR-TAG-244', 243780),
(342826, 'PTHR21733:SF4', NULL, NULL, NULL, NULL, 'DOWNSTREAM OF DAF-16 (REGULATED BY DAF-16)', 243780),
(342827, 'PTHR21733:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG13565', 243780),
(342828, 'PTHR21733:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBR-HPO-6', 243780),
(342829, 'PTHR21733:SF19', NULL, NULL, NULL, NULL, 'DOWNSTREAM OF DAF-16 (REGULATED BY DAF-16)', 243780),
(342830, 'PTHR21733:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG13564', 243780),
(342831, 'PTHR34776:SF1', NULL, NULL, NULL, NULL, 'F17F16.3 PROTEIN', 243781),
(342832, 'PTHR34776', NULL, NULL, NULL, NULL, 'F17F16.3 PROTEIN', 243781),
(342833, 'PTHR21686:SF12', NULL, NULL, NULL, NULL, 'DEOXYNUCLEOTIDYLTRANSFERASE TERMINAL-INTERACTING PROTEIN 2', 243782),
(342834, 'PTHR21686', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243782),
(342835, 'PTHR48034:SF15', NULL, NULL, NULL, NULL, 'OS06G0724600 PROTEIN', 243783),
(342836, 'PTHR48034:SF26', NULL, NULL, NULL, NULL, '', 243783),
(342837, 'PTHR48034:SF5', NULL, NULL, NULL, NULL, 'COLD-INDUCIBLE RNA-BINDING PROTEIN', 243783),
(342838, 'PTHR48034:SF4', NULL, NULL, NULL, NULL, 'NUCLEOLIN', 243783),
(342839, 'PTHR48034:SF27', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 243783),
(342840, 'PTHR48034:SF13', NULL, NULL, NULL, NULL, 'FLOWERING TIME CONTROL PROTEIN FCA', 243783),
(342841, 'PTHR48034:SF3', NULL, NULL, NULL, NULL, 'RNA-BINDING MOTIF PROTEIN, X-LINKED-LIKE 2', 243783),
(342842, 'PTHR48034:SF24', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR SR45A', 243783),
(342843, 'PTHR48034:SF14', NULL, NULL, NULL, NULL, 'TRANSFORMER-2 PROTEIN HOMOLOG ALPHA', 243783),
(342844, 'PTHR48034:SF1', NULL, NULL, NULL, NULL, 'TRANSFORMER-2 PROTEIN HOMOLOG BETA', 243783),
(342845, 'PTHR48034:SF17', NULL, NULL, NULL, NULL, 'RNA-BINDING MOTIF PROTEIN, Y CHROMOSOME, FAMILY 1 MEMBER A1-RELATED', 243783),
(342846, 'PTHR48034:SF28', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 243783),
(342847, 'PTHR48034:SF18', NULL, NULL, NULL, NULL, 'RNA-BINDING MOTIF PROTEIN, X CHROMOSOME', 243783),
(342848, 'PTHR48034:SF29', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR 2', 243783),
(342849, 'PTHR48034:SF9', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 243783),
(342850, 'PTHR48034:SF6', NULL, NULL, NULL, NULL, 'CIRBP PROTEIN-RELATED', 243783),
(342851, 'PTHR48034', NULL, NULL, NULL, NULL, 'TRANSFORMER-2 SEX-DETERMINING PROTEIN-RELATED', 243783),
(342852, 'PTHR48034:SF30', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 243783),
(342853, 'PTHR48034:SF22', NULL, NULL, NULL, NULL, 'RNA BINDING MOTIF PROTEIN, X-LINKED-LIKE-1-RELATED', 243783),
(342854, 'PTHR48034:SF12', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 3', 243783),
(342855, 'PTHR48034:SF31', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 243783),
(342856, 'PTHR48034:SF20', NULL, NULL, NULL, NULL, 'RNA BINDING MOTIF PROTEIN, X-LINKED-LIKE-1', 243783),
(342857, 'PTHR48034:SF21', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 243783),
(342858, 'PTHR48034:SF32', NULL, NULL, NULL, NULL, 'BNAC01G00650D PROTEIN', 243783),
(342859, 'PTHR48215:SF1', NULL, NULL, NULL, NULL, '', 243784),
(342860, 'PTHR48215', NULL, NULL, NULL, NULL, '', 243784);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(342861, 'PTHR28538', NULL, NULL, NULL, NULL, 'INTEGRAL INNER NUCLEAR MEMBRANE PROTEIN IMA1', 243785),
(342862, 'PTHR28538:SF1', NULL, NULL, NULL, NULL, 'INTEGRAL INNER NUCLEAR MEMBRANE PROTEIN IMA1', 243785),
(342863, 'PTHR13177:SF4', NULL, NULL, NULL, NULL, 'GEO09647P1', 243786),
(342864, 'PTHR13177', NULL, NULL, NULL, NULL, 'DEATH-ASSOCIATED PROTEIN 1', 243786),
(342865, 'PTHR13177:SF2', NULL, NULL, NULL, NULL, 'DEATH-ASSOCIATED PROTEIN-LIKE 1', 243786),
(342866, 'PTHR13177:SF3', NULL, NULL, NULL, NULL, 'DEATH-ASSOCIATED PROTEIN 1', 243786),
(342867, 'PTHR41686:SF1', NULL, NULL, NULL, NULL, 'PROTEIN MYOMIXER', 243787),
(342868, 'PTHR41686', NULL, NULL, NULL, NULL, 'MYOMIXER', 243787),
(342869, 'PTHR43557:SF8', NULL, NULL, NULL, NULL, 'APOPTOSIS-INDUCING FACTOR 3', 243788),
(342870, 'PTHR43557:SF7', NULL, NULL, NULL, NULL, 'RIESKE DOMAIN-CONTAINING PROTEIN', 243788),
(342871, 'PTHR43557', NULL, NULL, NULL, NULL, 'APOPTOSIS-INDUCING FACTOR 1', 243788),
(342872, 'PTHR43557:SF9', NULL, NULL, NULL, NULL, 'APOPTOSIS-INDUCING FACTOR MITOCHONDRIA-ASSOCIATED 5', 243788),
(342873, 'PTHR43557:SF17', NULL, NULL, NULL, NULL, 'MONODEHYDROASCORBATE REDUCTASE 4, CYTOSOLIC', 243788),
(342874, 'PTHR43557:SF4', NULL, NULL, NULL, NULL, 'APOPTOSIS-INDUCING FACTOR 1, MITOCHONDRIAL', 243788),
(342875, 'PTHR43557:SF16', NULL, NULL, NULL, NULL, 'FAD/NAD-LINKED REDUCTASE, DIMERIZATION DOMAIN, FAD/NAD(P)-BINDING DOMAIN PROTEIN-RELATED', 243788),
(342876, 'PTHR43557:SF6', NULL, NULL, NULL, NULL, 'MONODEHYDROASCORBATE REDUCTASE, CHLOROPLASTIC/MITOCHONDRIAL', 243788),
(342877, 'PTHR43557:SF19', NULL, NULL, NULL, NULL, 'MONODEHYDROASCORBATE REDUCTASE 1, PEROXISOMAL', 243788),
(342878, 'PTHR43557:SF5', NULL, NULL, NULL, NULL, 'MONODEHYDROASCORBATE REDUCTASE 1, PEROXISOMAL', 243788),
(342879, 'PTHR43557:SF13', NULL, NULL, NULL, NULL, 'MONODEHYDROASCORBATE REDUCTASE 2-RELATED', 243788),
(342880, 'PTHR43557:SF15', NULL, NULL, NULL, NULL, 'PYR_REDOX_2 DOMAIN-CONTAINING PROTEIN', 243788),
(342881, 'PTHR43557:SF14', NULL, NULL, NULL, NULL, 'PYR_REDOX_2 DOMAIN-CONTAINING PROTEIN', 243788),
(342882, 'PTHR43557:SF11', NULL, NULL, NULL, NULL, 'MONODEHYDROASCORBATE REDUCTASE-LIKE ISOFORM X1', 243788),
(342883, 'PTHR43557:SF2', NULL, NULL, NULL, NULL, 'RIESKE DOMAIN-CONTAINING PROTEIN-RELATED', 243788),
(342884, 'PTHR37805', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 243789),
(342885, 'PTHR37805:SF1', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 243789),
(342886, 'PTHR40035:SF1', NULL, NULL, NULL, NULL, 'ATP SYNTHASE PROTEIN I', 243790),
(342887, 'PTHR40035', NULL, NULL, NULL, NULL, 'ATP SYNTHASE PROTEIN I', 243790),
(342888, 'PTHR30188:SF13', NULL, NULL, NULL, NULL, 'CONSERVED HYPOTHETICAL INTEGRAL MEMBRANE PROTEIN YRBE3B', 243791),
(342889, 'PTHR30188:SF14', NULL, NULL, NULL, NULL, 'BNAA06G38530D PROTEIN', 243791),
(342890, 'PTHR30188:SF3', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN', 243791),
(342891, 'PTHR30188:SF4', NULL, NULL, NULL, NULL, 'PROTEIN TRIGALACTOSYLDIACYLGLYCEROL 1, CHLOROPLASTIC', 243791),
(342892, 'PTHR30188', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN-RELATED', 243791),
(342893, 'PTHR20971:SF10', NULL, NULL, NULL, NULL, 'U6 SNRNA-ASSOCIATED SM-LIKE PROTEIN LSM5', 243792),
(342894, 'PTHR20971:SF9', NULL, NULL, NULL, NULL, 'U6 SNRNA-ASSOCIATED SM-LIKE PROTEIN LSM5', 243792),
(342895, 'PTHR20971:SF0', NULL, NULL, NULL, NULL, 'U6 SNRNA-ASSOCIATED SM-LIKE PROTEIN LSM5', 243792),
(342896, 'PTHR20971', NULL, NULL, NULL, NULL, 'U6 SNRNA-ASSOCIATED PROTEIN', 243792),
(342897, 'PTHR21576:SF25', NULL, NULL, NULL, NULL, 'OS07G0187900 PROTEIN', 243793),
(342898, 'PTHR21576:SF26', NULL, NULL, NULL, NULL, 'OS03G0682100 PROTEIN', 243793),
(342899, 'PTHR21576:SF29', NULL, NULL, NULL, NULL, 'NODULIN-LIKE DOMAIN-CONTAINING PROTEIN', 243793),
(342900, 'PTHR21576:SF117', NULL, NULL, NULL, NULL, 'MFS TRANSPORTER', 243793),
(342901, 'PTHR21576:SF2', NULL, NULL, NULL, NULL, 'RRP12-LIKE PROTEIN', 243793),
(342902, 'PTHR21576:SF116', NULL, NULL, NULL, NULL, 'NODULIN-LIKE DOMAIN-CONTAINING PROTEIN', 243793);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(342903, 'PTHR21576:SF118', NULL, NULL, NULL, NULL, 'BNAA06G13140D PROTEIN', 243793),
(342904, 'PTHR21576:SF22', NULL, NULL, NULL, NULL, 'F25A4.25 PROTEIN', 243793),
(342905, 'PTHR21576:SF153', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN', 243793),
(342906, 'PTHR21576:SF152', NULL, NULL, NULL, NULL, 'PROTEIN NUCLEAR FUSION DEFECTIVE 4-LIKE', 243793),
(342907, 'PTHR21576:SF155', NULL, NULL, NULL, NULL, 'NODULIN-LIKE DOMAIN-CONTAINING PROTEIN', 243793),
(342908, 'PTHR21576:SF110', NULL, NULL, NULL, NULL, 'NODULIN FAMILY PROTEIN', 243793),
(342909, 'PTHR21576:SF154', NULL, NULL, NULL, NULL, 'NODULIN-LIKE DOMAIN-CONTAINING PROTEIN', 243793),
(342910, 'PTHR21576:SF7', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN', 243793),
(342911, 'PTHR21576:SF157', NULL, NULL, NULL, NULL, 'NODULIN-LIKE DOMAIN-CONTAINING PROTEIN', 243793),
(342912, 'PTHR21576:SF112', NULL, NULL, NULL, NULL, 'NODULIN-LIKE / MAJOR FACILITATOR SUPERFAMILY PROTEIN', 243793),
(342913, 'PTHR21576:SF156', NULL, NULL, NULL, NULL, 'PROTEIN NUCLEAR FUSION DEFECTIVE 4-LIKE', 243793),
(342914, 'PTHR21576:SF159', NULL, NULL, NULL, NULL, 'NODULIN-LIKE DOMAIN-CONTAINING PROTEIN', 243793),
(342915, 'PTHR21576:SF114', NULL, NULL, NULL, NULL, 'NODULIN-LIKE/MFS TRANSPORTER', 243793),
(342916, 'PTHR21576:SF158', NULL, NULL, NULL, NULL, 'NUC173 DOMAIN-CONTAINING PROTEIN', 243793),
(342917, 'PTHR21576:SF127', NULL, NULL, NULL, NULL, 'NODULIN-LIKE DOMAIN-CONTAINING PROTEIN', 243793),
(342918, 'PTHR21576:SF30', NULL, NULL, NULL, NULL, 'NODULIN-LIKE FAMILY PROTEIN, EXPRESSED', 243793),
(342919, 'PTHR21576:SF73', NULL, NULL, NULL, NULL, 'F1C9.29 PROTEIN-RELATED', 243793),
(342920, 'PTHR21576:SF129', NULL, NULL, NULL, NULL, 'NODULIN FAMILY PROTEIN', 243793),
(342921, 'PTHR21576', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED NODULIN-LIKE PROTEIN', 243793),
(342922, 'PTHR21576:SF31', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 243793),
(342923, 'PTHR21576:SF78', NULL, NULL, NULL, NULL, 'OS09G0536700 PROTEIN', 243793),
(342924, 'PTHR21576:SF120', NULL, NULL, NULL, NULL, 'NODULIN-LIKE', 243793),
(342925, 'PTHR21576:SF122', NULL, NULL, NULL, NULL, 'NODULIN-LIKE DOMAIN-CONTAINING PROTEIN', 243793),
(342926, 'PTHR21576:SF126', NULL, NULL, NULL, NULL, 'NODULIN-LIKE DOMAIN-CONTAINING PROTEIN', 243793),
(342927, 'PTHR21576:SF81', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 243793),
(342928, 'PTHR21576:SF80', NULL, NULL, NULL, NULL, 'NODULIN-LIKE DOMAIN-CONTAINING PROTEIN', 243793),
(342929, 'PTHR21576:SF125', NULL, NULL, NULL, NULL, 'BNAC06G40450D PROTEIN', 243793),
(342930, 'PTHR21576:SF160', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 243793),
(342931, 'PTHR21576:SF162', NULL, NULL, NULL, NULL, 'OS06G0179200 PROTEIN', 243793),
(342932, 'PTHR21576:SF161', NULL, NULL, NULL, NULL, 'BNAA03G18480D PROTEIN', 243793),
(342933, 'PTHR21576:SF46', NULL, NULL, NULL, NULL, 'NODULIN-LIKE DOMAIN-CONTAINING PROTEIN', 243793),
(342934, 'PTHR21576:SF83', NULL, NULL, NULL, NULL, 'OS05G0475700 PROTEIN', 243793),
(342935, 'PTHR21576:SF139', NULL, NULL, NULL, NULL, 'BNAC09G20610D PROTEIN', 243793),
(342936, 'PTHR21576:SF82', NULL, NULL, NULL, NULL, 'F4P13.17 PROTEIN', 243793),
(342937, 'PTHR21576:SF84', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 243793),
(342938, 'PTHR21576:SF87', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 243793),
(342939, 'PTHR21576:SF89', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN', 243793),
(342940, 'PTHR21576:SF45', NULL, NULL, NULL, NULL, 'TRANSPORTER MCH1-RELATED', 243793),
(342941, 'PTHR21576:SF44', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN', 243793),
(342942, 'PTHR21576:SF130', NULL, NULL, NULL, NULL, 'NITRATE AND CHLORIDE TRANSPORTER', 243793),
(342943, 'PTHR21576:SF133', NULL, NULL, NULL, NULL, 'NODULIN-LIKE DOMAIN-CONTAINING PROTEIN', 243793),
(342944, 'PTHR21576:SF135', NULL, NULL, NULL, NULL, 'BNAC04G06300D PROTEIN', 243793),
(342945, 'PTHR21576:SF90', NULL, NULL, NULL, NULL, 'NODULIN-LIKE DOMAIN-CONTAINING PROTEIN', 243793);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(342946, 'PTHR21576:SF134', NULL, NULL, NULL, NULL, 'NODULIN-LIKE DOMAIN-CONTAINING PROTEIN', 243793),
(342947, 'PTHR21576:SF137', NULL, NULL, NULL, NULL, 'BNAC03G16790D PROTEIN', 243793),
(342948, 'PTHR21576:SF92', NULL, NULL, NULL, NULL, 'MFS TRANSPORTER', 243793),
(342949, 'PTHR21576:SF91', NULL, NULL, NULL, NULL, 'PROTEIN NUCLEAR FUSION DEFECTIVE 4', 243793),
(342950, 'PTHR21576:SF136', NULL, NULL, NULL, NULL, 'NODULIN-LIKE DOMAIN-CONTAINING PROTEIN', 243793),
(342951, 'PTHR21576:SF106', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN', 243793),
(342952, 'PTHR21576:SF105', NULL, NULL, NULL, NULL, 'PROTEIN NUCLEAR FUSION DEFECTIVE 4-LIKE', 243793),
(342953, 'PTHR21576:SF96', NULL, NULL, NULL, NULL, 'OS04G0388700 PROTEIN', 243793),
(342954, 'PTHR21576:SF108', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 243793),
(342955, 'PTHR21576:SF107', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN', 243793),
(342956, 'PTHR21576:SF95', NULL, NULL, NULL, NULL, 'NODULIN-LIKE/MFS TRANSPORTER', 243793),
(342957, 'PTHR21576:SF98', NULL, NULL, NULL, NULL, 'BNAANNG22870D PROTEIN', 243793),
(342958, 'PTHR21576:SF109', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN', 243793),
(342959, 'PTHR21576:SF97', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN', 243793),
(342960, 'PTHR21576:SF11', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN', 243793),
(342961, 'PTHR21576:SF145', NULL, NULL, NULL, NULL, 'NODULIN-LIKE DOMAIN-CONTAINING PROTEIN', 243793),
(342962, 'PTHR21576:SF104', NULL, NULL, NULL, NULL, 'NODULIN-LIKE DOMAIN-CONTAINING PROTEIN', 243793),
(342963, 'PTHR21576:SF103', NULL, NULL, NULL, NULL, 'NODULIN-LIKE DOMAIN-CONTAINING PROTEIN', 243793),
(342964, 'PTHR46739:SF6', NULL, NULL, NULL, NULL, 'AQUAPORIN SIP1-1-LIKE', 243794),
(342965, 'PTHR46739:SF5', NULL, NULL, NULL, NULL, 'AQUAPORIN SIP1-2-RELATED', 243794),
(342966, 'PTHR46739:SF4', NULL, NULL, NULL, NULL, 'AQUAPORIN SIP1-2-LIKE ISOFORM X1', 243794),
(342967, 'PTHR46739', NULL, NULL, NULL, NULL, 'AQUAPORIN SIP1-1', 243794),
(342968, 'PTHR46739:SF3', NULL, NULL, NULL, NULL, 'AQUAPORIN SIP1-1', 243794),
(342969, 'PTHR46739:SF2', NULL, NULL, NULL, NULL, 'AQUAPORIN SIP1-1-LIKE', 243794),
(342970, 'PTHR46739:SF10', NULL, NULL, NULL, NULL, 'MAJOR INTRINSIC PROTEIN, AQUAPORIN-LIKE PROTEIN-RELATED', 243794),
(342971, 'PTHR46739:SF11', NULL, NULL, NULL, NULL, 'MAJOR INTRINSIC PROTEIN (MIP) FAMILY TRANSPORTER', 243794),
(342972, 'PTHR46739:SF9', NULL, NULL, NULL, NULL, 'AQUAPORIN SIP1-2-RELATED', 243794),
(342973, 'PTHR46739:SF8', NULL, NULL, NULL, NULL, 'AQUAPORIN SIP1-1', 243794),
(342974, 'PTHR39490:SF8', NULL, NULL, NULL, NULL, 'ZINC FINGER FYVE DOMAIN-CONTAINING PROTEIN 21', 243795),
(342975, 'PTHR39490:SF9', NULL, NULL, NULL, NULL, 'FYVE-TYPE DOMAIN-CONTAINING PROTEIN', 243795),
(342976, 'PTHR39490:SF12', NULL, NULL, NULL, NULL, 'ARRESTIN DOMAIN-CONTAINING PROTEIN D', 243795),
(342977, 'PTHR39490', NULL, NULL, NULL, NULL, 'ARRESTIN DOMAIN-CONTAINING PROTEIN D', 243795),
(342978, 'PTHR35560:SF3', NULL, NULL, NULL, NULL, 'BLL0132 PROTEIN', 243796),
(342979, 'PTHR35560', NULL, NULL, NULL, NULL, 'BLL0132 PROTEIN', 243796),
(342980, 'PTHR46864', NULL, NULL, NULL, NULL, 'LAFORIN', 243797),
(342981, 'PTHR46864:SF1', NULL, NULL, NULL, NULL, 'LAFORIN', 243797),
(342982, 'PTHR21194', NULL, NULL, NULL, NULL, 'CARDIAC PHOSPHOLAMBAN', 243798),
(342983, 'PTHR21194:SF1', NULL, NULL, NULL, NULL, 'CARDIAC PHOSPHOLAMBAN', 243798),
(342984, 'PTHR33448', NULL, NULL, NULL, NULL, 'CHLOROPLAST PROTEIN HCF243-RELATED', 243799),
(342985, 'PTHR33448:SF4', NULL, NULL, NULL, NULL, 'CHLOROPLAST PROTEIN HCF243', 243799),
(342986, 'PTHR33448:SF11', NULL, NULL, NULL, NULL, 'BNAA07G10610D PROTEIN', 243799),
(342987, 'PTHR33448:SF3', NULL, NULL, NULL, NULL, 'OS09G0370000 PROTEIN', 243799),
(342988, 'PTHR33448:SF10', NULL, NULL, NULL, NULL, 'PROTAMINE P1 FAMILY PROTEIN', 243799),
(342989, 'PTHR33448:SF13', NULL, NULL, NULL, NULL, '', 243799),
(342990, 'PTHR33448:SF14', NULL, NULL, NULL, NULL, 'ARABIDOPSIS THALIANA GENOMIC DNA, CHROMOSOME 5, P1 CLONE:MOK16', 243799);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(342991, 'PTHR33448:SF7', NULL, NULL, NULL, NULL, 'NUCLEOLAR GTP-BINDING PROTEIN', 243799),
(342992, 'PTHR33448:SF17', NULL, NULL, NULL, NULL, '', 243799),
(342993, 'PTHR33448:SF18', NULL, NULL, NULL, NULL, '', 243799),
(342994, 'PTHR33448:SF2', NULL, NULL, NULL, NULL, 'OS02G0753400 PROTEIN', 243799),
(342995, 'PTHR39463', NULL, NULL, NULL, NULL, 'MEDUSA', 243800),
(342996, 'PTHR39463:SF1', NULL, NULL, NULL, NULL, 'MEDUSA', 243800),
(342997, 'PTHR45919', NULL, NULL, NULL, NULL, 'GDP-MAN:MAN(3)GLCNAC(2)-PP-DOL ALPHA-1,2-MANNOSYLTRANSFERASE', 243801),
(342998, 'PTHR45919:SF1', NULL, NULL, NULL, NULL, 'GDP-MAN:MAN(3)GLCNAC(2)-PP-DOL ALPHA-1,2-MANNOSYLTRANSFERASE', 243801),
(342999, 'PTHR23252:SF24', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 145', 243802),
(343000, 'PTHR23252:SF22', NULL, NULL, NULL, NULL, 'GPCRRHOPSN4 DOMAIN-CONTAINING PROTEIN', 243802),
(343001, 'PTHR23252:SF41', NULL, NULL, NULL, NULL, 'GPCRRHOPSN4 DOMAIN-CONTAINING PROTEIN', 243802),
(343002, 'PTHR23252:SF42', NULL, NULL, NULL, NULL, 'GPCRRHOPSN4 DOMAIN-CONTAINING PROTEIN', 243802),
(343003, 'PTHR23252:SF29', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN GPR180', 243802),
(343004, 'PTHR23252', NULL, NULL, NULL, NULL, 'INTIMAL THICKNESS RECEPTOR-RELATED', 243802),
(343005, 'PTHR23252:SF28', NULL, NULL, NULL, NULL, 'GPCRRHOPSN4 DOMAIN-CONTAINING PROTEIN', 243802),
(343006, 'PTHR34123:SF1', NULL, NULL, NULL, NULL, 'OS04G0578200 PROTEIN', 243803),
(343007, 'PTHR34123:SF3', NULL, NULL, NULL, NULL, 'SOUL3-LIKE PROTEIN', 243803),
(343008, 'PTHR34123', NULL, NULL, NULL, NULL, 'OS04G0578200 PROTEIN', 243803),
(343009, 'PTHR34123:SF4', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLTRANSFERASE-LIKE PROTEIN, PUTATIVE (DUF2358)-RELATED', 243803),
(343010, 'PTHR48192:SF1', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 243804),
(343011, 'PTHR48192', NULL, NULL, NULL, NULL, 'ZN(2)-C6 FUNGAL-TYPE DOMAIN-CONTAINING PROTEIN', 243804),
(343012, 'PTHR12013:SF5', NULL, NULL, NULL, NULL, 'BNAC03G24370D PROTEIN', 243805),
(343013, 'PTHR12013:SF4', NULL, NULL, NULL, NULL, 'BNAA04G25280D PROTEIN', 243805),
(343014, 'PTHR12013:SF2', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE 14 KDA PROTEIN', 243805),
(343015, 'PTHR12013:SF1', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE 14 KDA PROTEIN', 243805),
(343016, 'PTHR12013:SF0', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE 14 KDA PROTEIN', 243805),
(343017, 'PTHR12013', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE 14 KD PROTEIN', 243805),
(343018, 'PTHR42251', NULL, NULL, NULL, NULL, 'UPF0147 PROTEIN MJ1419', 243806),
(343019, 'PTHR42251:SF1', NULL, NULL, NULL, NULL, 'UPF0147 PROTEIN TK2131', 243806),
(343020, 'PTHR15284', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR INTERLEUKIN-3-REGULATED PROTEIN', 243807),
(343021, 'PTHR15284:SF0', NULL, NULL, NULL, NULL, 'GH23983P', 243807),
(343022, 'PTHR15284:SF4', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR, INTERLEUKIN 3-REGULATED, MEMBER 5', 243807),
(343023, 'PTHR15284:SF1', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR INTERLEUKIN-3-REGULATED PROTEIN', 243807),
(343024, 'PTHR15284:SF6', NULL, NULL, NULL, NULL, 'NFIL3 LIKE PROTEIN', 243807),
(343025, 'PTHR31905:SF2', NULL, NULL, NULL, NULL, 'PROTEIN MIX23', 243808),
(343026, 'PTHR31905:SF3', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 58', 243808),
(343027, 'PTHR31905:SF4', NULL, NULL, NULL, NULL, 'PROTEIN MIX23', 243808),
(343028, 'PTHR31905', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 58', 243808),
(343029, 'PTHR33393', NULL, NULL, NULL, NULL, 'POLYGLUTAMINE SYNTHESIS ACCESSORY PROTEIN RV0574C-RELATED', 243809),
(343030, 'PTHR33393:SF11', NULL, NULL, NULL, NULL, 'PGA BIOSYNTHESIS PROTEIN CAPA', 243809),
(343031, 'PTHR33393:SF12', NULL, NULL, NULL, NULL, 'LIPOPROTEIN-RELATED', 243809),
(343032, 'PTHR12638:SF2', NULL, NULL, NULL, NULL, 'PROTEIN MAGO NASHI HOMOLOG', 243810),
(343033, 'PTHR12638', NULL, NULL, NULL, NULL, 'PROTEIN MAGO NASHI HOMOLOG', 243810),
(343034, 'PTHR12638:SF1', NULL, NULL, NULL, NULL, 'PROTEIN MAGO NASHI HOMOLOG 2', 243810);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(343035, 'PTHR12638:SF3', NULL, NULL, NULL, NULL, '', 243810),
(343036, 'PTHR12638:SF0', NULL, NULL, NULL, NULL, 'PROTEIN MAGO NASHI HOMOLOG', 243810),
(343037, 'PTHR35697:SF6', NULL, NULL, NULL, NULL, 'OS04G0438200 PROTEIN', 243811),
(343038, 'PTHR35697:SF7', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE, TESTIS-SPECIFIC-LIKE', 243811),
(343039, 'PTHR35697:SF8', NULL, NULL, NULL, NULL, '', 243811),
(343040, 'PTHR35697:SF1', NULL, NULL, NULL, NULL, 'PROTEIN TRACHEARY ELEMENT DIFFERENTIATION-RELATED 7', 243811),
(343041, 'PTHR35697:SF10', NULL, NULL, NULL, NULL, 'PROTEIN TRACHEARY ELEMENT DIFFERENTIATION-RELATED 6', 243811),
(343042, 'PTHR35697', NULL, NULL, NULL, NULL, 'OS08G0108300 PROTEIN', 243811),
(343043, 'PTHR35697:SF11', NULL, NULL, NULL, NULL, '', 243811),
(343044, 'PTHR43856', NULL, NULL, NULL, NULL, 'CARDIOLIPIN HYDROLASE', 243812),
(343045, 'PTHR43856:SF2', NULL, NULL, NULL, NULL, 'PLD PHOSPHODIESTERASE DOMAIN-CONTAINING PROTEIN', 243812),
(343046, 'PTHR43856:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CARDIOLIPIN HYDROLASE', 243812),
(343047, 'PTHR33149:SF52', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II PROTEIN D1', 243813),
(343048, 'PTHR33149:SF41', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II PROTEIN D1', 243813),
(343049, 'PTHR33149:SF42', NULL, NULL, NULL, NULL, 'PHOTOSYNTHETIC REACTION CENTRE, L/M-RELATED', 243813),
(343050, 'PTHR33149:SF53', NULL, NULL, NULL, NULL, 'Q(B) PROTEIN, PUTATIVE-RELATED', 243813),
(343051, 'PTHR33149:SF50', NULL, NULL, NULL, NULL, 'PHOTOSYNTHETIC REACTION CENTRE, L/M-RELATED', 243813),
(343052, 'PTHR33149:SF51', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REACTION CENTER PROTEIN', 243813),
(343053, 'PTHR33149:SF40', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II PROTEIN D1', 243813),
(343054, 'PTHR33149:SF12', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II D2 PROTEIN', 243813),
(343055, 'PTHR33149:SF45', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II PROTEIN D1', 243813),
(343056, 'PTHR33149:SF46', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II D2 PROTEIN', 243813),
(343057, 'PTHR33149:SF43', NULL, NULL, NULL, NULL, '', 243813),
(343058, 'PTHR33149:SF54', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II D2 PROTEIN', 243813),
(343059, 'PTHR33149:SF44', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II PROTEIN D1', 243813),
(343060, 'PTHR33149:SF49', NULL, NULL, NULL, NULL, 'Q(B) PROTEIN, PUTATIVE-RELATED', 243813),
(343061, 'PTHR33149:SF47', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II D2 PROTEIN', 243813),
(343062, 'PTHR33149:SF15', NULL, NULL, NULL, NULL, 'II D2 PROTEIN, PUTATIVE-RELATED', 243813),
(343063, 'PTHR33149:SF48', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II PROTEIN D1', 243813),
(343064, 'PTHR33149', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II PROTEIN D1', 243813),
(343065, 'PTHR33266:SF1', NULL, NULL, NULL, NULL, 'BRCT DOMAIN-CONTAINING PROTEIN', 243814),
(343066, 'PTHR33266', NULL, NULL, NULL, NULL, 'CHROMOSOME 15, WHOLE GENOME SHOTGUN SEQUENCE', 243814),
(343067, 'PTHR43597:SF2', NULL, NULL, NULL, NULL, 'SULFUR ACCEPTOR PROTEIN CSDE', 243815),
(343068, 'PTHR43597:SF3', NULL, NULL, NULL, NULL, 'CYSTEINE DESULFURATION PROTEIN SUFE', 243815),
(343069, 'PTHR43597:SF5', NULL, NULL, NULL, NULL, 'SUFE-LIKE PROTEIN 2, CHLOROPLASTIC', 243815),
(343070, 'PTHR43597:SF6', NULL, NULL, NULL, NULL, 'SUFE DOMAIN-CONTAINING PROTEIN', 243815),
(343071, 'PTHR43597', NULL, NULL, NULL, NULL, 'SULFUR ACCEPTOR PROTEIN CSDE', 243815),
(343072, 'PTHR20904:SF0', NULL, NULL, NULL, NULL, 'INDUCIBLE T-CELL COSTIMULATOR', 243816),
(343073, 'PTHR20904', NULL, NULL, NULL, NULL, 'INDUCIBLE T-CELL COSTIMULATOR ICOS', 243816),
(343074, 'PTHR21212:SF4', NULL, NULL, NULL, NULL, 'PROTEIN (SEIPIN), PUTATIVE-RELATED', 243817),
(343075, 'PTHR21212:SF6', NULL, NULL, NULL, NULL, 'SEIPIN-2-LIKE', 243817),
(343076, 'PTHR21212:SF5', NULL, NULL, NULL, NULL, 'SEIPIN-1', 243817),
(343077, 'PTHR21212:SF0', NULL, NULL, NULL, NULL, 'SEIPIN', 243817),
(343078, 'PTHR21212:SF10', NULL, NULL, NULL, NULL, 'SEIPIN FAMILY-RELATED', 243817),
(343079, 'PTHR21212:SF11', NULL, NULL, NULL, NULL, 'BNAC02G06620D PROTEIN', 243817),
(343080, 'PTHR21212:SF8', NULL, NULL, NULL, NULL, 'SEIPIN FAMILY-RELATED', 243817);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(343081, 'PTHR21212:SF7', NULL, NULL, NULL, NULL, 'SEIPIN-3', 243817),
(343082, 'PTHR21212', NULL, NULL, NULL, NULL, 'BERNARDINELLI-SEIP CONGENITAL LIPODYSTROPHY 2 HOMOLOG  BSCL2 PROTEIN', 243817),
(343083, 'PTHR45668', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 5-RELATED', 243818),
(343084, 'PTHR45668:SF5', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 5', 243818),
(343085, 'PTHR45668:SF6', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 243818),
(343086, 'PTHR45668:SF7', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 7 LONG FORM HOMOLOG', 243818),
(343087, 'PTHR45668:SF13', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 243818),
(343088, 'PTHR45668:SF14', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 7 INACTIVE HOMOLOG', 243818),
(343089, 'PTHR45668:SF9', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 7', 243818),
(343090, 'PTHR45668:SF11', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 243818),
(343091, 'PTHR45668:SF12', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 5', 243818),
(343092, 'PTHR45668:SF1', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE WITH EF-HANDS 1', 243818),
(343093, 'PTHR45668:SF2', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE WITH EF-HANDS 2', 243818),
(343094, 'PTHR45668:SF3', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE RDGC', 243818),
(343095, 'PTHR22716:SF5', NULL, NULL, NULL, NULL, 'INAPPROPRIATE VULVAL CELL PROLIFERATION HOMOLOG', 243819),
(343096, 'PTHR22716:SF3', NULL, NULL, NULL, NULL, 'DIMER_TNP_HAT DOMAIN-CONTAINING PROTEIN', 243819),
(343097, 'PTHR22716:SF1', NULL, NULL, NULL, NULL, 'ETS CLASS TRANSCRIPTION FACTOR-RELATED', 243819),
(343098, 'PTHR22716', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243819),
(343099, 'PTHR28495', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC100359752', 243820),
(343100, 'PTHR28495:SF1', NULL, NULL, NULL, NULL, 'GENE, 17266-RELATED', 243820),
(343101, 'PTHR36934', NULL, NULL, NULL, NULL, 'BLR0278 PROTEIN', 243821),
(343102, 'PTHR36934:SF1', NULL, NULL, NULL, NULL, '4HBT DOMAIN-CONTAINING PROTEIN', 243821),
(343103, 'PTHR47732:SF1', NULL, NULL, NULL, NULL, 'RUN AND FYVE DOMAIN-CONTAINING PROTEIN 4', 243822),
(343104, 'PTHR47732', NULL, NULL, NULL, NULL, 'RUN AND FYVE DOMAIN-CONTAINING PROTEIN 4', 243822),
(343105, 'PTHR42914', NULL, NULL, NULL, NULL, '7-CYANO-7-DEAZAGUANINE SYNTHASE', 243823),
(343106, 'PTHR42914:SF1', NULL, NULL, NULL, NULL, '7-CYANO-7-DEAZAGUANINE SYNTHASE', 243823),
(343107, 'PTHR37446:SF1', NULL, NULL, NULL, NULL, 'CLAUDIN-LIKE IN CAENORHABDITIS', 243824),
(343108, 'PTHR37446:SF2', NULL, NULL, NULL, NULL, 'CLAUDIN-LIKE IN CAENORHABDITIS', 243824),
(343109, 'PTHR37446', NULL, NULL, NULL, NULL, 'CLAUDIN-LIKE IN CAENORHABDITIS', 243824),
(343110, 'PTHR21727', NULL, NULL, NULL, NULL, 'PHOSPHORYLATED CTD INTERACTING FACTOR 1', 243825),
(343111, 'PTHR21727:SF1', NULL, NULL, NULL, NULL, 'PCIF1_WW DOMAIN-CONTAINING PROTEIN', 243825),
(343112, 'PTHR21727:SF0', NULL, NULL, NULL, NULL, 'MRNA (2''-O-METHYLADENOSINE-N(6)-)-METHYLTRANSFERASE', 243825),
(343113, 'PTHR45794:SF6', NULL, NULL, NULL, NULL, 'LEUCYL-TRNA SYNTHETASE', 243826),
(343114, 'PTHR45794:SF2', NULL, NULL, NULL, NULL, 'LEUCYL-TRNA SYNTHETASE', 243826),
(343115, 'PTHR45794:SF4', NULL, NULL, NULL, NULL, 'LEUCYL-TRNA SYNTHETASE', 243826),
(343116, 'PTHR45794:SF5', NULL, NULL, NULL, NULL, 'LEUCYL-TRNA SYNTHETASE', 243826),
(343117, 'PTHR45794', NULL, NULL, NULL, NULL, 'LEUCYL-TRNA SYNTHETASE', 243826),
(343118, 'PTHR45794:SF1', NULL, NULL, NULL, NULL, 'LEUCINE--TRNA LIGASE, CYTOPLASMIC', 243826),
(343119, 'PTHR43907:SF1', NULL, NULL, NULL, NULL, 'SLEI FAMILY PROTEIN', 243827),
(343120, 'PTHR43907', NULL, NULL, NULL, NULL, 'SLEI FAMILY PROTEIN', 243827),
(343121, 'PTHR43907:SF3', NULL, NULL, NULL, NULL, 'HEAVY CHAIN, PUTATIVE-RELATED', 243827),
(343122, 'PTHR43907:SF5', NULL, NULL, NULL, NULL, 'AGAP000789-PA', 243827),
(343123, 'PTHR43907:SF4', NULL, NULL, NULL, NULL, '', 243827);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(343124, 'PTHR47818:SF2', NULL, NULL, NULL, NULL, 'RNI-LIKE SUPERFAMILY PROTEIN', 243828),
(343125, 'PTHR47818', NULL, NULL, NULL, NULL, 'RNI-LIKE SUPERFAMILY PROTEIN', 243828),
(343126, 'PTHR36685', NULL, NULL, NULL, NULL, '', 243829),
(343127, 'PTHR36685:SF1', NULL, NULL, NULL, NULL, '', 243829),
(343128, 'PTHR34359:SF5', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 9', 243830),
(343129, 'PTHR34359:SF19', NULL, NULL, NULL, NULL, 'CLE FAMILY OSCLE508 PROTEIN', 243830),
(343130, 'PTHR34359', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 10', 243830),
(343131, 'PTHR34359:SF29', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 13-LIKE', 243830),
(343132, 'PTHR34359:SF17', NULL, NULL, NULL, NULL, 'BNAA07G09450D PROTEIN', 243830),
(343133, 'PTHR34359:SF28', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 12', 243830),
(343134, 'PTHR34359:SF27', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 11-RELATED', 243830),
(343135, 'PTHR34359:SF26', NULL, NULL, NULL, NULL, 'BNAA09G29030D PROTEIN', 243830),
(343136, 'PTHR34359:SF25', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE) GENE FAMILY MEMBER MTCLE18', 243830),
(343137, 'PTHR34359:SF24', NULL, NULL, NULL, NULL, 'INACTIVE PROTEIN FON2 SPARE1', 243830),
(343138, 'PTHR34359:SF23', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 10', 243830),
(343139, 'PTHR34359:SF30', NULL, NULL, NULL, NULL, 'CLE12', 243830),
(343140, 'PTHR35084', NULL, NULL, NULL, NULL, 'TCF3 FUSION PARTNER', 243831),
(343141, 'PTHR35084:SF1', NULL, NULL, NULL, NULL, 'TCF3 FUSION PARTNER', 243831),
(343142, 'PTHR45476:SF5', NULL, NULL, NULL, NULL, 'CHLORIDE INTRACELLULAR CHANNEL PROTEIN', 243832),
(343143, 'PTHR45476:SF6', NULL, NULL, NULL, NULL, 'GST N-TERMINAL DOMAIN-CONTAINING PROTEIN', 243832),
(343144, 'PTHR45476:SF1', NULL, NULL, NULL, NULL, 'CHLORIDE INTRACELLULAR CHANNEL PROTEIN 6', 243832),
(343145, 'PTHR45476:SF2', NULL, NULL, NULL, NULL, 'CHLORIDE INTRACELLULAR CHANNEL PROTEIN', 243832),
(343146, 'PTHR45476:SF3', NULL, NULL, NULL, NULL, 'CHLORIDE INTRACELLULAR CHANNEL PROTEIN', 243832),
(343147, 'PTHR45476:SF4', NULL, NULL, NULL, NULL, 'CHLORIDE INTRACELLULAR CHANNEL PROTEIN 5', 243832),
(343148, 'PTHR45476', NULL, NULL, NULL, NULL, 'CHLORIDE INTRACELLULAR CHANNEL PROTEIN 6-RELATED', 243832),
(343149, 'PTHR43741:SF2', NULL, NULL, NULL, NULL, 'FMN-DEPENDENT NADH:QUINONE OXIDOREDUCTASE', 243833),
(343150, 'PTHR43741:SF3', NULL, NULL, NULL, NULL, 'FMN_RED DOMAIN-CONTAINING PROTEIN', 243833),
(343151, 'PTHR43741:SF4', NULL, NULL, NULL, NULL, 'FMN-DEPENDENT NADH:QUINONE OXIDOREDUCTASE', 243833),
(343152, 'PTHR43741:SF7', NULL, NULL, NULL, NULL, 'FMN-DEPENDENT NADH:QUINONE OXIDOREDUCTASE', 243833),
(343153, 'PTHR43741', NULL, NULL, NULL, NULL, 'FMN-DEPENDENT NADH-AZOREDUCTASE 1', 243833),
(343154, 'PTHR46530:SF1', NULL, NULL, NULL, NULL, 'PROTEIN MONO-ADP-RIBOSYLTRANSFERASE PARP4', 243834),
(343155, 'PTHR46530', NULL, NULL, NULL, NULL, 'PROTEIN MONO-ADP-RIBOSYLTRANSFERASE PARP4', 243834),
(343156, 'PTHR10736:SF27', NULL, NULL, NULL, NULL, 'BESTROPHIN HOMOLOG', 243835),
(343157, 'PTHR10736:SF28', NULL, NULL, NULL, NULL, 'BESTROPHIN HOMOLOG 13', 243835),
(343158, 'PTHR10736:SF24', NULL, NULL, NULL, NULL, 'BESTROPHIN HOMOLOG 18', 243835),
(343159, 'PTHR10736:SF31', NULL, NULL, NULL, NULL, 'BESTROPHIN HOMOLOG 14', 243835),
(343160, 'PTHR10736:SF54', NULL, NULL, NULL, NULL, 'BESTROPHIN HOMOLOG 15', 243835),
(343161, 'PTHR10736:SF59', NULL, NULL, NULL, NULL, 'BESTROPHIN HOMOLOG 17', 243835),
(343162, 'PTHR10736:SF8', NULL, NULL, NULL, NULL, 'BESTROPHIN HOMOLOG 5', 243835),
(343163, 'PTHR10736:SF9', NULL, NULL, NULL, NULL, 'BESTROPHIN HOMOLOG 1-RELATED', 243835),
(343164, 'PTHR10736:SF11', NULL, NULL, NULL, NULL, 'BESTROPHIN 2', 243835),
(343165, 'PTHR10736:SF33', NULL, NULL, NULL, NULL, 'BESTROPHIN HOMOLOG', 243835),
(343166, 'PTHR10736:SF55', NULL, NULL, NULL, NULL, 'BESTROPHIN-4', 243835),
(343167, 'PTHR10736:SF58', NULL, NULL, NULL, NULL, 'BESTROPHIN HOMOLOG-RELATED', 243835),
(343168, 'PTHR10736:SF0', NULL, NULL, NULL, NULL, 'BESTROPHIN HOMOLOG', 243835);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(343169, 'PTHR10736:SF1', NULL, NULL, NULL, NULL, 'BESTROPHIN-2', 243835),
(343170, 'PTHR10736:SF2', NULL, NULL, NULL, NULL, 'BESTROPHIN-3', 243835),
(343171, 'PTHR10736:SF19', NULL, NULL, NULL, NULL, 'BESTROPHIN HOMOLOG', 243835),
(343172, 'PTHR10736:SF4', NULL, NULL, NULL, NULL, 'BESTROPHIN-1', 243835),
(343173, 'PTHR10736:SF7', NULL, NULL, NULL, NULL, 'BESTROPHIN HOMOLOG', 243835),
(343174, 'PTHR10736', NULL, NULL, NULL, NULL, 'BESTROPHIN', 243835),
(343175, 'PTHR10736:SF63', NULL, NULL, NULL, NULL, 'BESTROPHIN HOMOLOG', 243835),
(343176, 'PTHR10736:SF20', NULL, NULL, NULL, NULL, 'BESTROPHIN HOMOLOG 22', 243835),
(343177, 'PTHR10736:SF21', NULL, NULL, NULL, NULL, 'BESTROPHIN HOMOLOG', 243835),
(343178, 'PTHR10736:SF65', NULL, NULL, NULL, NULL, 'BESTROPHIN 1, ISOFORM C-RELATED', 243835),
(343179, 'PTHR10736:SF60', NULL, NULL, NULL, NULL, 'BESTROPHIN HOMOLOG 9', 243835),
(343180, 'PTHR10736:SF61', NULL, NULL, NULL, NULL, 'BESTROPHIN HOMOLOG 24', 243835),
(343181, 'PTHR36311:SF3', NULL, NULL, NULL, NULL, 'BNAANNG28120D PROTEIN', 243836),
(343182, 'PTHR36311', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I SUBUNIT O', 243836),
(343183, 'PTHR36311:SF1', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I SUBUNIT O', 243836),
(343184, 'PTHR12484:SF1', NULL, NULL, NULL, NULL, 'A-KINASE ANCHOR PROTEIN 17B', 243837),
(343185, 'PTHR12484:SF2', NULL, NULL, NULL, NULL, 'A-KINASE ANCHOR PROTEIN 17A', 243837),
(343186, 'PTHR12484:SF4', NULL, NULL, NULL, NULL, 'XE7, ISOFORM A', 243837),
(343187, 'PTHR12484', NULL, NULL, NULL, NULL, 'B-LYMPHOCYTE ANTIGEN-RELATED', 243837),
(343188, 'PTHR33377:SF4', NULL, NULL, NULL, NULL, 'OS07G0285800 PROTEIN', 243838),
(343189, 'PTHR33377:SF89', NULL, NULL, NULL, NULL, 'RX_N DOMAIN-CONTAINING PROTEIN', 243838),
(343190, 'PTHR33377:SF88', NULL, NULL, NULL, NULL, 'OS01G0721000 PROTEIN', 243838),
(343191, 'PTHR33377:SF3', NULL, NULL, NULL, NULL, 'WW DOMAIN-CONTAINING PROTEIN', 243838),
(343192, 'PTHR33377:SF46', NULL, NULL, NULL, NULL, 'OS10G0134033 PROTEIN', 243838),
(343193, 'PTHR33377:SF43', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 243838),
(343194, 'PTHR33377:SF87', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 243838),
(343195, 'PTHR33377:SF81', NULL, NULL, NULL, NULL, 'OSJNBB0004G23.8-LIKE PROTEIN', 243838),
(343196, 'PTHR33377:SF83', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 243838),
(343197, 'PTHR33377:SF82', NULL, NULL, NULL, NULL, '', 243838),
(343198, 'PTHR33377:SF90', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 243838),
(343199, 'PTHR33377:SF16', NULL, NULL, NULL, NULL, 'RX_N DOMAIN-CONTAINING PROTEIN', 243838),
(343200, 'PTHR33377:SF59', NULL, NULL, NULL, NULL, 'OSJNBB0004G23.8-LIKE PROTEIN', 243838),
(343201, 'PTHR33377:SF18', NULL, NULL, NULL, NULL, 'RX_N DOMAIN-CONTAINING PROTEIN', 243838),
(343202, 'PTHR33377:SF17', NULL, NULL, NULL, NULL, 'RX_N DOMAIN-CONTAINING PROTEIN', 243838),
(343203, 'PTHR33377:SF56', NULL, NULL, NULL, NULL, 'RX_N DOMAIN-CONTAINING PROTEIN', 243838),
(343204, 'PTHR33377:SF55', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 243838),
(343205, 'PTHR33377:SF11', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243838),
(343206, 'PTHR33377:SF99', NULL, NULL, NULL, NULL, 'OSJNBB0004G23.8-LIKE PROTEIN', 243838),
(343207, 'PTHR33377:SF57', NULL, NULL, NULL, NULL, '', 243838),
(343208, 'PTHR33377:SF13', NULL, NULL, NULL, NULL, 'OS10G0134700 PROTEIN', 243838),
(343209, 'PTHR33377:SF52', NULL, NULL, NULL, NULL, '', 243838),
(343210, 'PTHR33377:SF96', NULL, NULL, NULL, NULL, 'RX_N DOMAIN-CONTAINING PROTEIN', 243838),
(343211, 'PTHR33377:SF95', NULL, NULL, NULL, NULL, 'OSJNBB0004G23.8-LIKE PROTEIN', 243838),
(343212, 'PTHR33377:SF98', NULL, NULL, NULL, NULL, '', 243838),
(343213, 'PTHR33377:SF54', NULL, NULL, NULL, NULL, 'RX_N DOMAIN-CONTAINING PROTEIN', 243838),
(343214, 'PTHR33377:SF97', NULL, NULL, NULL, NULL, '', 243838),
(343215, 'PTHR33377:SF92', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 243838),
(343216, 'PTHR33377:SF91', NULL, NULL, NULL, NULL, 'RX_N DOMAIN-CONTAINING PROTEIN', 243838);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(343217, 'PTHR33377:SF94', NULL, NULL, NULL, NULL, 'OS01G0582300 PROTEIN', 243838),
(343218, 'PTHR33377:SF50', NULL, NULL, NULL, NULL, 'OS07G0117400 PROTEIN', 243838),
(343219, 'PTHR33377:SF93', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 243838),
(343220, 'PTHR33377:SF19', NULL, NULL, NULL, NULL, 'RX_N DOMAIN-CONTAINING PROTEIN', 243838),
(343221, 'PTHR33377:SF105', NULL, NULL, NULL, NULL, '', 243838),
(343222, 'PTHR33377:SF26', NULL, NULL, NULL, NULL, '', 243838),
(343223, 'PTHR33377:SF106', NULL, NULL, NULL, NULL, 'OS11G0474500 PROTEIN', 243838),
(343224, 'PTHR33377:SF103', NULL, NULL, NULL, NULL, 'OS07G0117900 PROTEIN', 243838),
(343225, 'PTHR33377:SF104', NULL, NULL, NULL, NULL, '', 243838),
(343226, 'PTHR33377:SF28', NULL, NULL, NULL, NULL, 'RX_N DOMAIN-CONTAINING PROTEIN', 243838),
(343227, 'PTHR33377:SF67', NULL, NULL, NULL, NULL, 'OSJNBB0004G23.8-LIKE PROTEIN', 243838),
(343228, 'PTHR33377:SF101', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN CONTAINING PROTEIN, EXPRESSED', 243838),
(343229, 'PTHR33377:SF23', NULL, NULL, NULL, NULL, 'OS07G0117800 PROTEIN', 243838),
(343230, 'PTHR33377:SF102', NULL, NULL, NULL, NULL, 'OS02G0199200 PROTEIN', 243838),
(343231, 'PTHR33377:SF66', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243838),
(343232, 'PTHR33377:SF25', NULL, NULL, NULL, NULL, 'OS10G0131500 PROTEIN', 243838),
(343233, 'PTHR33377:SF69', NULL, NULL, NULL, NULL, '', 243838),
(343234, 'PTHR33377:SF100', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 243838),
(343235, 'PTHR33377:SF68', NULL, NULL, NULL, NULL, '', 243838),
(343236, 'PTHR33377:SF24', NULL, NULL, NULL, NULL, 'OS10G0134900 PROTEIN', 243838),
(343237, 'PTHR33377:SF63', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 243838),
(343238, 'PTHR33377:SF62', NULL, NULL, NULL, NULL, 'OS10G0133166 PROTEIN', 243838),
(343239, 'PTHR33377:SF21', NULL, NULL, NULL, NULL, 'RX_N DOMAIN-CONTAINING PROTEIN', 243838),
(343240, 'PTHR33377:SF20', NULL, NULL, NULL, NULL, 'RX_N DOMAIN-CONTAINING PROTEIN', 243838),
(343241, 'PTHR33377:SF64', NULL, NULL, NULL, NULL, 'OS05G0533400 PROTEIN', 243838),
(343242, 'PTHR33377:SF61', NULL, NULL, NULL, NULL, 'RX_N DOMAIN-CONTAINING PROTEIN', 243838),
(343243, 'PTHR33377:SF60', NULL, NULL, NULL, NULL, 'RX_N DOMAIN-CONTAINING PROTEIN', 243838),
(343244, 'PTHR33377:SF107', NULL, NULL, NULL, NULL, 'OS12G0483450 PROTEIN', 243838),
(343245, 'PTHR33377:SF39', NULL, NULL, NULL, NULL, 'OS07G0122100 PROTEIN', 243838),
(343246, 'PTHR33377:SF33', NULL, NULL, NULL, NULL, 'RX_N DOMAIN-CONTAINING PROTEIN', 243838),
(343247, 'PTHR33377:SF36', NULL, NULL, NULL, NULL, 'OS01G0720900 PROTEIN', 243838),
(343248, 'PTHR33377:SF79', NULL, NULL, NULL, NULL, 'RX_N DOMAIN-CONTAINING PROTEIN', 243838),
(343249, 'PTHR33377:SF74', NULL, NULL, NULL, NULL, 'OS07G0121000 PROTEIN', 243838),
(343250, 'PTHR33377:SF30', NULL, NULL, NULL, NULL, 'OS07G0117600 PROTEIN', 243838),
(343251, 'PTHR33377:SF31', NULL, NULL, NULL, NULL, '', 243838),
(343252, 'PTHR33377:SF70', NULL, NULL, NULL, NULL, '', 243838),
(343253, 'PTHR33377', NULL, NULL, NULL, NULL, 'OS10G0134700 PROTEIN-RELATED', 243838),
(343254, 'PTHR14618', NULL, NULL, NULL, NULL, 'HOMEODOX-CONTAINING PROTEIN 1 HMBOX1', 243839),
(343255, 'PTHR14618:SF0', NULL, NULL, NULL, NULL, 'HOMEOBOX-CONTAINING PROTEIN 1', 243839),
(343256, 'PTHR14618:SF4', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN-RELATED', 243839),
(343257, 'PTHR14618:SF5', NULL, NULL, NULL, NULL, 'ZGC:91944', 243839),
(343258, 'PTHR31609', NULL, NULL, NULL, NULL, 'YDJC DEACETYLASE FAMILY MEMBER', 243840),
(343259, 'PTHR31609:SF1', NULL, NULL, NULL, NULL, 'CARBOHYDRATE DEACETYLASE', 243840),
(343260, 'PTHR43390:SF12', NULL, NULL, NULL, NULL, 'THYLAKOIDAL PROCESSING PEPTIDASE 1 CHLOROPLASTIC', 243841),
(343261, 'PTHR43390:SF8', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE I', 243841),
(343262, 'PTHR43390:SF14', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE I', 243841),
(343263, 'PTHR43390:SF13', NULL, NULL, NULL, NULL, 'PEPTIDASE_S26 DOMAIN-CONTAINING PROTEIN', 243841),
(343264, 'PTHR43390', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE I', 243841);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(343265, 'PTHR43390:SF15', NULL, NULL, NULL, NULL, 'THYLAKOIDAL PROCESSING PEPTIDASE 2, CHLOROPLASTIC-RELATED', 243841),
(343266, 'PTHR43390:SF1', NULL, NULL, NULL, NULL, 'CHLOROPLAST PROCESSING PEPTIDASE', 243841),
(343267, 'PTHR43390:SF2', NULL, NULL, NULL, NULL, 'THYLAKOIDAL PROCESSING PEPTIDASE 1, CHLOROPLASTIC', 243841),
(343268, 'PTHR43390:SF5', NULL, NULL, NULL, NULL, 'OS03G0765200 PROTEIN', 243841),
(343269, 'PTHR43390:SF10', NULL, NULL, NULL, NULL, 'PEPTIDASE_S26 DOMAIN-CONTAINING PROTEIN', 243841),
(343270, 'PTHR46728', NULL, NULL, NULL, NULL, 'AN1-TYPE ZINC FINGER PROTEIN 4', 243842),
(343271, 'PTHR46728:SF1', NULL, NULL, NULL, NULL, 'AN1-TYPE ZINC FINGER PROTEIN 4', 243842),
(343272, 'PTHR10300:SF4', NULL, NULL, NULL, NULL, 'CALCIPRESSIN-1', 243843),
(343273, 'PTHR10300:SF5', NULL, NULL, NULL, NULL, 'CALCIPRESSIN-2', 243843),
(343274, 'PTHR10300:SF6', NULL, NULL, NULL, NULL, 'CALCIPRESSIN-3', 243843),
(343275, 'PTHR10300', NULL, NULL, NULL, NULL, 'CALCIPRESSIN', 243843),
(343276, 'PTHR10300:SF14', NULL, NULL, NULL, NULL, 'PROTEIN SARAH', 243843),
(343277, 'PTHR28670:SF1', NULL, NULL, NULL, NULL, 'UV-STIMULATED SCAFFOLD PROTEIN A', 243844),
(343278, 'PTHR28670', NULL, NULL, NULL, NULL, 'UV-STIMULATED SCAFFOLD PROTEIN A', 243844),
(343279, 'PTHR31745', NULL, NULL, NULL, NULL, 'SINGLE-STRANDED DNA-BINDING PROTEIN WHY2, MITOCHONDRIAL', 243845),
(343280, 'PTHR31745:SF2', NULL, NULL, NULL, NULL, 'SINGLE-STRANDED DNA-BINDING PROTEIN WHY1, CHLOROPLASTIC', 243845),
(343281, 'PTHR31745:SF1', NULL, NULL, NULL, NULL, 'SINGLE-STRANDED DNA-BINDING PROTEIN WHY2, MITOCHONDRIAL', 243845),
(343282, 'PTHR31745:SF5', NULL, NULL, NULL, NULL, 'SINGLE-STRANDED DNA-BINDING PROTEIN WHY3, CHLOROPLASTIC', 243845),
(343283, 'PTHR14304:SF11', NULL, NULL, NULL, NULL, 'SAP DOMAIN-CONTAINING PROTEIN', 243846),
(343284, 'PTHR14304:SF17', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN PAIR-RELATED', 243846),
(343285, 'PTHR14304', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE AND APOPTOSIS REGULATOR PROTEIN', 243846),
(343286, 'PTHR14304:SF12', NULL, NULL, NULL, NULL, 'CELL CYCLE AND APOPTOSIS REGULATOR PROTEIN 2', 243846),
(343287, 'PTHR14304:SF15', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 243846),
(343288, 'PTHR14304:SF14', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE AND APOPTOSIS REGULATOR PROTEIN 1', 243846),
(343289, 'PTHR31879:SF6', NULL, NULL, NULL, NULL, 'DET1- AND DDB1-ASSOCIATED PROTEIN 1', 243847),
(343290, 'PTHR31879:SF2', NULL, NULL, NULL, NULL, 'DET1- AND DDB1-ASSOCIATED PROTEIN 1', 243847),
(343291, 'PTHR31879', NULL, NULL, NULL, NULL, 'DET1- AND DDB1-ASSOCIATED PROTEIN 1', 243847),
(343292, 'PTHR31879:SF10', NULL, NULL, NULL, NULL, 'DET1- AND DDB1-ASSOCIATED PROTEIN 1', 243847),
(343293, 'PTHR31879:SF9', NULL, NULL, NULL, NULL, 'DET1- AND DDB1-ASSOCIATED PROTEIN 1', 243847),
(343294, 'PTHR31879:SF7', NULL, NULL, NULL, NULL, 'DET1- AND DDB1-ASSOCIATED PROTEIN 1', 243847),
(343295, 'PTHR31879:SF8', NULL, NULL, NULL, NULL, 'DET1- AND DDB1-ASSOCIATED PROTEIN 1', 243847),
(343296, 'PTHR46609:SF4', NULL, NULL, NULL, NULL, 'RESTRICTION ENDONUCLEASE, TYPE II-LIKE SUPERFAMILY PROTEIN', 243848),
(343297, 'PTHR46609', NULL, NULL, NULL, NULL, 'EXONUCLEASE, PHAGE-TYPE/RECB, C-TERMINAL DOMAIN-CONTAINING PROTEIN', 243848),
(343298, 'PTHR46609:SF6', NULL, NULL, NULL, NULL, 'YQAJ DOMAIN-CONTAINING PROTEIN', 243848),
(343299, 'PTHR31086:SF49', NULL, NULL, NULL, NULL, 'ALUMINUM-ACTIVATED MALATE TRANSPORTER 12-LIKE', 243849),
(343300, 'PTHR31086:SF80', NULL, NULL, NULL, NULL, 'ALUMINUM-ACTIVATED MALATE TRANSPORTER-RELATED', 243849),
(343301, 'PTHR31086:SF9', NULL, NULL, NULL, NULL, 'OS06G0331900 PROTEIN', 243849),
(343302, 'PTHR31086:SF61', NULL, NULL, NULL, NULL, '', 243849),
(343303, 'PTHR31086:SF83', NULL, NULL, NULL, NULL, 'BNAA09G52080D PROTEIN', 243849),
(343304, 'PTHR31086:SF81', NULL, NULL, NULL, NULL, 'ALUMINUM-ACTIVATED MALATE TRANSPORTER 10', 243849),
(343305, 'PTHR31086:SF4', NULL, NULL, NULL, NULL, 'ALUMINUM ACTIVATED MALATE TRANSPORTER FAMILY PROTEIN', 243849),
(343306, 'PTHR31086:SF82', NULL, NULL, NULL, NULL, 'ALUMINUM ACTIVATED MALATE TRANSPORTER FAMILY PROTEIN-RELATED', 243849);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(343307, 'PTHR31086:SF87', NULL, NULL, NULL, NULL, 'ALUMINUM-ACTIVATED MALATE TRANSPORTER 2-LIKE', 243849),
(343308, 'PTHR31086:SF65', NULL, NULL, NULL, NULL, 'ALUMINIUM ACTIVATED MALATE TRANSPORTER FAMILY PROTEIN', 243849),
(343309, 'PTHR31086:SF2', NULL, NULL, NULL, NULL, 'ALUMINUM-ACTIVATED MALATE TRANSPORTER 12', 243849),
(343310, 'PTHR31086:SF22', NULL, NULL, NULL, NULL, 'ALUMINUM-ACTIVATED MALATE TRANSPORTER 8', 243849),
(343311, 'PTHR31086:SF66', NULL, NULL, NULL, NULL, 'ALUMINUM ACTIVATED MALATE TRANSPORTER FAMILY PROTEIN', 243849),
(343312, 'PTHR31086:SF85', NULL, NULL, NULL, NULL, 'ALUMINUM-ACTIVATED MALATE TRANSPORTER 7', 243849),
(343313, 'PTHR31086:SF63', NULL, NULL, NULL, NULL, 'ALUMINUM-ACTIVATED MALATE TRANSPORTER 14', 243849),
(343314, 'PTHR31086:SF20', NULL, NULL, NULL, NULL, 'ALUMINUM-ACTIVATED MALATE TRANSPORTER 4-RELATED', 243849),
(343315, 'PTHR31086', NULL, NULL, NULL, NULL, 'ALUMINUM-ACTIVATED MALATE TRANSPORTER 10', 243849),
(343316, 'PTHR31086:SF69', NULL, NULL, NULL, NULL, 'ALUMINUM-ACTIVATED MALATE TRANSPORTER-RELATED', 243849),
(343317, 'PTHR31086:SF67', NULL, NULL, NULL, NULL, 'ALUMINUM-ACTIVATED MALATE TRANSPORTER 2', 243849),
(343318, 'PTHR31086:SF89', NULL, NULL, NULL, NULL, 'OS02G0730600 PROTEIN', 243849),
(343319, 'PTHR31086:SF68', NULL, NULL, NULL, NULL, 'ALUMINUM-ACTIVATED MALATE TRANSPORTER 5-LIKE', 243849),
(343320, 'PTHR31086:SF18', NULL, NULL, NULL, NULL, 'ALUMINUM-ACTIVATED MALATE TRANSPORTER 4-LIKE', 243849),
(343321, 'PTHR31086:SF17', NULL, NULL, NULL, NULL, 'OS01G0221600 PROTEIN', 243849),
(343322, 'PTHR31086:SF90', NULL, NULL, NULL, NULL, 'ALUMINUM-ACTIVATED MALATE TRANSPORTER 9', 243849),
(343323, 'PTHR31086:SF91', NULL, NULL, NULL, NULL, 'ALUMINUM ACTIVATED MALATE TRANSPORTER', 243849),
(343324, 'PTHR31086:SF50', NULL, NULL, NULL, NULL, 'ALUMINUM-ACTIVATED MALATE TRANSPORTER 8-LIKE', 243849),
(343325, 'PTHR31086:SF94', NULL, NULL, NULL, NULL, 'ALUMINUM-ACTIVATED MALATE TRANSPORTER 8-LIKE', 243849),
(343326, 'PTHR31086:SF72', NULL, NULL, NULL, NULL, 'BNAA09G28580D PROTEIN', 243849),
(343327, 'PTHR31086:SF95', NULL, NULL, NULL, NULL, 'ALUMINUM ACTIVATED MALATE TRANSPORTER FAMILY PROTEIN', 243849),
(343328, 'PTHR31086:SF70', NULL, NULL, NULL, NULL, 'BNAA08G26960D PROTEIN', 243849),
(343329, 'PTHR31086:SF92', NULL, NULL, NULL, NULL, 'ALUMINUM-ACTIVATED MALATE TRANSPORTER 9', 243849),
(343330, 'PTHR31086:SF93', NULL, NULL, NULL, NULL, '', 243849),
(343331, 'PTHR31086:SF71', NULL, NULL, NULL, NULL, '', 243849),
(343332, 'PTHR31086:SF76', NULL, NULL, NULL, NULL, '', 243849),
(343333, 'PTHR31086:SF54', NULL, NULL, NULL, NULL, 'ALUMINUM ACTIVATED MALATE TRANSPORTER FAMILY PROTEIN', 243849),
(343334, 'PTHR31086:SF55', NULL, NULL, NULL, NULL, 'ALUMINUM-ACTIVATED MALATE TRANSPORTER 13', 243849),
(343335, 'PTHR31086:SF53', NULL, NULL, NULL, NULL, 'ALUMINUM ACTIVATED MALATE TRANSPORTER FAMILY PROTEIN', 243849),
(343336, 'PTHR31086:SF58', NULL, NULL, NULL, NULL, 'ALUMINUM-ACTIVATED MALATE TRANSPORTER 6', 243849),
(343337, 'PTHR31086:SF14', NULL, NULL, NULL, NULL, 'OS04G0567200 PROTEIN', 243849),
(343338, 'PTHR31086:SF59', NULL, NULL, NULL, NULL, 'ALUMINUM-ACTIVATED MALATE TRANSPORTER 3-RELATED', 243849),
(343339, 'PTHR31086:SF56', NULL, NULL, NULL, NULL, 'ALUMINUM-ACTIVATED MALATE TRANSPORTER 12-LIKE', 243849),
(343340, 'PTHR31086:SF78', NULL, NULL, NULL, NULL, 'ALUMINUM-ACTIVATED MALATE TRANSPORTER 1', 243849),
(343341, 'PTHR31086:SF79', NULL, NULL, NULL, NULL, '', 243849),
(343342, 'PTHR42935:SF1', NULL, NULL, NULL, NULL, 'DUF815 DOMAIN-CONTAINING PROTEIN', 243850),
(343343, 'PTHR42935', NULL, NULL, NULL, NULL, 'SLR0930 PROTEIN', 243850),
(343344, 'PTHR28606', NULL, NULL, NULL, NULL, 'INTERLEUKIN-34', 243851),
(343345, 'PTHR28606:SF1', NULL, NULL, NULL, NULL, 'INTERLEUKIN-34', 243851),
(343346, 'PTHR31781:SF1', NULL, NULL, NULL, NULL, 'PROTEIN UNC-80 HOMOLOG', 243852),
(343347, 'PTHR31781', NULL, NULL, NULL, NULL, 'UNC80', 243852),
(343348, 'PTHR43290:SF3', NULL, NULL, NULL, NULL, 'MEVALONATE KINASE', 243853),
(343349, 'PTHR43290:SF2', NULL, NULL, NULL, NULL, 'MEVALONATE KINASE', 243853);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(343350, 'PTHR43290:SF1', NULL, NULL, NULL, NULL, 'GLUCURONOKINASE 1-RELATED', 243853),
(343351, 'PTHR43290', NULL, NULL, NULL, NULL, 'MEVALONATE KINASE', 243853),
(343352, 'PTHR31020', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 174', 243854),
(343353, 'PTHR31020:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 174', 243854),
(343354, 'PTHR32267:SF2', NULL, NULL, NULL, NULL, 'T-CELL LEUKEMIA TRANSLOCATION-ALTERED GENE PROTEIN', 243855),
(343355, 'PTHR32267', NULL, NULL, NULL, NULL, 'T-CELL LEUKEMIA TRANSLOCATION-ALTERED GENE PROTEIN', 243855),
(343356, 'PTHR11145:SF19', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN-RELATED', 243856),
(343357, 'PTHR11145:SF18', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING ADAPTER FOR CUL3-MEDIATED RHOA DEGRADATION PROTEIN 1', 243856),
(343358, 'PTHR11145:SF8', NULL, NULL, NULL, NULL, 'RE57120P', 243856),
(343359, 'PTHR11145', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING ADAPTER FOR CUL3-MEDIATED RHOA DEGRADATION PROTEIN FAMILY MEMBER', 243856),
(343360, 'PTHR11145:SF12', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 243856),
(343361, 'PTHR11145:SF23', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 243856),
(343362, 'PTHR11145:SF17', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING ADAPTER FOR CUL3-MEDIATED RHOA DEGRADATION PROTEIN 2', 243856),
(343363, 'PTHR11145:SF14', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING ADAPTER FOR CUL3-MEDIATED RHOA DEGRADATION PROTEIN 3', 243856),
(343364, 'PTHR11145:SF25', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL TETRAMERIZATION DOMAIN-CONTAINING PROTEIN', 243856),
(343365, 'PTHR47872:SF3', NULL, NULL, NULL, NULL, 'DUF1771 DOMAIN-CONTAINING PROTEIN', 243857),
(343366, 'PTHR47872', NULL, NULL, NULL, NULL, 'NUCLEAR RNA EXPORT FACTOR SDE5-RELATED', 243857),
(343367, 'PTHR47872:SF1', NULL, NULL, NULL, NULL, 'NUCLEAR RNA EXPORT FACTOR SDE5-RELATED', 243857),
(343368, 'PTHR43045:SF6', NULL, NULL, NULL, NULL, 'METABOLITE TRANSPORT PROTEIN', 243858),
(343369, 'PTHR43045', NULL, NULL, NULL, NULL, 'SHIKIMATE TRANSPORTER', 243858),
(343370, 'PTHR43045:SF1', NULL, NULL, NULL, NULL, 'SHIKIMATE TRANSPORTER', 243858),
(343371, 'PTHR43045:SF2', NULL, NULL, NULL, NULL, 'INNER MEMBRANE METABOLITE TRANSPORT PROTEIN YHJE', 243858),
(343372, 'PTHR43045:SF4', NULL, NULL, NULL, NULL, 'TRANSPORTER YDFJ-RELATED', 243858),
(343373, 'PTHR34204:SF2', NULL, NULL, NULL, NULL, 'RNA-BINDING ASCH DOMAIN PROTEIN', 243859),
(343374, 'PTHR34204:SF3', NULL, NULL, NULL, NULL, 'ASCH DOMAIN-CONTAINING PROTEIN', 243859),
(343375, 'PTHR34204:SF4', NULL, NULL, NULL, NULL, 'ASCH DOMAIN-CONTAINING PROTEIN', 243859),
(343376, 'PTHR34204', NULL, NULL, NULL, NULL, 'RNA-BINDING ASCH DOMAIN PROTEIN', 243859),
(343377, 'PTHR13843:SF13', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN 1AA', 243860),
(343378, 'PTHR13843:SF5', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN 1B', 243860),
(343379, 'PTHR13843', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN', 243860),
(343380, 'PTHR13843:SF11', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN 1S', 243860),
(343381, 'PTHR13843:SF6', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN 1A', 243860),
(343382, 'PTHR13843:SF12', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN FUTSCH', 243860),
(343383, 'PTHR35671:SF1', NULL, NULL, NULL, NULL, 'PROTEIN TOPAZ1', 243861),
(343384, 'PTHR35671', NULL, NULL, NULL, NULL, 'PROTEIN TOPAZ1', 243861),
(343385, 'PTHR36355', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243862),
(343386, 'PTHR36355:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243862),
(343387, 'PTHR43830', NULL, NULL, NULL, NULL, 'PROTEIN PSP1', 243863),
(343388, 'PTHR43830:SF4', NULL, NULL, NULL, NULL, 'PSP1 C-TERMINAL DOMAIN-CONTAINING PROTEIN', 243863),
(343389, 'PTHR43830:SF13', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN (CYK3), PUTATIVE (AFU_ORTHOLOGUE AFUA_5G03400)-RELATED', 243863),
(343390, 'PTHR43830:SF3', NULL, NULL, NULL, NULL, 'PROTEIN PSP1', 243863),
(343391, 'PTHR43830:SF7', NULL, NULL, NULL, NULL, 'PSP1 C-TERMINAL DOMAIN-CONTAINING PROTEIN', 243863);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(343392, 'PTHR43830:SF14', NULL, NULL, NULL, NULL, 'PSP1 C-TERMINAL DOMAIN-CONTAINING PROTEIN', 243863),
(343393, 'PTHR43830:SF5', NULL, NULL, NULL, NULL, 'PSP1 C-TERMINAL DOMAIN-CONTAINING PROTEIN', 243863),
(343394, 'PTHR28271', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN L31, MITOCHONDRIAL', 243864),
(343395, 'PTHR28271:SF1', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN L31, MITOCHONDRIAL', 243864),
(343396, 'PTHR33223:SF8', NULL, NULL, NULL, NULL, 'GAG-PRO-LIKE PROTEIN', 243865),
(343397, 'PTHR33223:SF7', NULL, NULL, NULL, NULL, '', 243865),
(343398, 'PTHR33223:SF6', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 243865),
(343399, 'PTHR33223:SF5', NULL, NULL, NULL, NULL, 'ELEMENT PROTEIN, PUTATIVE-RELATED', 243865),
(343400, 'PTHR33223:SF4', NULL, NULL, NULL, NULL, 'OS04G0172440 PROTEIN', 243865),
(343401, 'PTHR33223:SF3', NULL, NULL, NULL, NULL, '', 243865),
(343402, 'PTHR33223:SF2', NULL, NULL, NULL, NULL, 'RETROTRANS_GAG DOMAIN-CONTAINING PROTEIN', 243865),
(343403, 'PTHR33223', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 243865),
(343404, 'PTHR10516:SF443', NULL, NULL, NULL, NULL, 'FK506-BINDING PROTEIN 59-RELATED', 243866),
(343405, 'PTHR10516:SF454', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 243866),
(343406, 'PTHR10516:SF26', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP5', 243866),
(343407, 'PTHR10516:SF453', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 243866),
(343408, 'PTHR10516', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 243866),
(343409, 'PTHR10516:SF430', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 243866),
(343410, 'PTHR10516:SF452', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 243866),
(343411, 'PTHR10516:SF451', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 243866),
(343412, 'PTHR10516:SF447', NULL, NULL, NULL, NULL, 'FK506-BINDING PROTEIN 1B', 243866),
(343413, 'PTHR10516:SF326', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 243866),
(343414, 'PTHR10516:SF457', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 243866),
(343415, 'PTHR10516:SF435', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 243866),
(343416, 'PTHR10516:SF25', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP4', 243866),
(343417, 'PTHR10516:SF456', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP65', 243866),
(343418, 'PTHR10516:SF412', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP20-1', 243866),
(343419, 'PTHR10516:SF445', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 243866),
(343420, 'PTHR10516:SF444', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 243866),
(343421, 'PTHR10516:SF455', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 243866),
(343422, 'PTHR10516:SF433', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP62', 243866),
(343423, 'PTHR10516:SF268', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE PASTICCINO1', 243866),
(343424, 'PTHR10516:SF301', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP1A-RELATED', 243866),
(343425, 'PTHR10516:SF429', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP1B', 243866),
(343426, 'PTHR10516:SF428', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 243866),
(343427, 'PTHR47297', NULL, NULL, NULL, NULL, '', 243867),
(343428, 'PTHR47297:SF2', NULL, NULL, NULL, NULL, 'OS02G0606800 PROTEIN', 243867),
(343429, 'PTHR47297:SF3', NULL, NULL, NULL, NULL, 'NICOTINAMIDASE 1', 243867),
(343430, 'PTHR28572', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 103', 243868),
(343431, 'PTHR28572:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 103', 243868),
(343432, 'PTHR21223:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM92', 243869),
(343433, 'PTHR21223:SF3', NULL, NULL, NULL, NULL, 'CBY1-INTERACTING BAR DOMAIN-CONTAINING PROTEIN 2', 243869),
(343434, 'PTHR21223:SF4', NULL, NULL, NULL, NULL, 'PROTEIN FAM92A', 243869),
(343435, 'PTHR21223', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243869);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(343436, 'PTHR46265:SF18', NULL, NULL, NULL, NULL, 'BNAA03G46810D PROTEIN', 243870),
(343437, 'PTHR46265:SF16', NULL, NULL, NULL, NULL, 'OS03G0256800 PROTEIN', 243870),
(343438, 'PTHR46265:SF19', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 7-LIKE', 243870),
(343439, 'PTHR46265', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 7', 243870),
(343440, 'PTHR46265:SF8', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 6', 243870),
(343441, 'PTHR46265:SF6', NULL, NULL, NULL, NULL, 'OS07G0658300 PROTEIN', 243870),
(343442, 'PTHR46265:SF7', NULL, NULL, NULL, NULL, 'RHO GTPASE ACTIVATION PROTEIN (RHOGAP) WITH PH DOMAIN', 243870),
(343443, 'PTHR46265:SF10', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN REN1', 243870),
(343444, 'PTHR46265:SF2', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 7', 243870),
(343445, 'PTHR46265:SF21', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN REN1-LIKE ISOFORM X1', 243870),
(343446, 'PTHR46265:SF20', NULL, NULL, NULL, NULL, 'RHO GTPASE ACTIVATION PROTEIN, PH DOMAIN-LIKE, TERNARY COMPLEX FACTOR MIP1, LEUCINE-ZIPPER-RELATED', 243870),
(343447, 'PTHR46265:SF25', NULL, NULL, NULL, NULL, '', 243870),
(343448, 'PTHR46265:SF24', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN REN1-LIKE ISOFORM X1', 243870),
(343449, 'PTHR46265:SF13', NULL, NULL, NULL, NULL, 'BNAC08G11680D PROTEIN', 243870),
(343450, 'PTHR46265:SF23', NULL, NULL, NULL, NULL, 'PROTEIN FOR RHO-LIKE GTPASE FAMILY PROTEIN, PUTATIVE-RELATED', 243870),
(343451, 'PTHR46265:SF22', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN REN1-LIKE ISOFORM X1', 243870),
(343452, 'PTHR46265:SF11', NULL, NULL, NULL, NULL, 'BNAC02G44250D PROTEIN', 243870),
(343453, 'PTHR30563:SF0', NULL, NULL, NULL, NULL, 'DNA RECOMBINATION PROTEIN RMUC', 243871),
(343454, 'PTHR30563', NULL, NULL, NULL, NULL, 'DNA RECOMBINATION PROTEIN RMUC', 243871),
(343455, 'PTHR46957:SF3', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE-PHOSPHATASE', 243872),
(343456, 'PTHR46957:SF2', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE TYROSINE-PROTEIN PHOSPHATASE BETA', 243872),
(343457, 'PTHR46957', NULL, NULL, NULL, NULL, 'CYTOKINE RECEPTOR', 243872),
(343458, 'PTHR46957:SF4', NULL, NULL, NULL, NULL, 'USHERIN', 243872),
(343459, 'PTHR46957:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL PHOSPHATASE PTPRQ', 243872),
(343460, 'PTHR33564:SF24', NULL, NULL, NULL, NULL, '', 243873),
(343461, 'PTHR33564:SF13', NULL, NULL, NULL, NULL, 'BNAC05G37530D PROTEIN', 243873),
(343462, 'PTHR33564:SF12', NULL, NULL, NULL, NULL, '', 243873),
(343463, 'PTHR33564:SF22', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 243873),
(343464, 'PTHR33564:SF11', NULL, NULL, NULL, NULL, 'OS06G0604600 PROTEIN', 243873),
(343465, 'PTHR33564:SF18', NULL, NULL, NULL, NULL, 'BNAC01G35820D PROTEIN', 243873),
(343466, 'PTHR33564:SF28', NULL, NULL, NULL, NULL, '', 243873),
(343467, 'PTHR33564:SF27', NULL, NULL, NULL, NULL, 'BNAA03G00170D PROTEIN', 243873),
(343468, 'PTHR33564:SF26', NULL, NULL, NULL, NULL, '', 243873),
(343469, 'PTHR33564:SF15', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 243873),
(343470, 'PTHR33564:SF8', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 243873),
(343471, 'PTHR33564:SF10', NULL, NULL, NULL, NULL, '', 243873),
(343472, 'PTHR33564:SF19', NULL, NULL, NULL, NULL, 'PGPS/D7', 243873),
(343473, 'PTHR33564', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 243873),
(343474, 'PTHR31153:SF19', NULL, NULL, NULL, NULL, 'P-LOOP NUCLEOSIDE TRIPHOSPHATE HYDROLASE SUPERFAMILY PROTEIN', 243874),
(343475, 'PTHR31153:SF17', NULL, NULL, NULL, NULL, 'OS01G0774500 PROTEIN', 243874),
(343476, 'PTHR31153:SF12', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN', 243874),
(343477, 'PTHR31153', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243874),
(343478, 'PTHR31153:SF20', NULL, NULL, NULL, NULL, 'ZETA_TOXIN DOMAIN-CONTAINING PROTEIN', 243874),
(343479, 'PTHR31153:SF21', NULL, NULL, NULL, NULL, 'OS05G0508800 PROTEIN', 243874),
(343480, 'PTHR31153:SF1', NULL, NULL, NULL, NULL, 'CALMODULIN CALCIUM-DEPENDENT NAD KINASE', 243874);
INSERT INTO "PUBLIC"."MODEL" VALUES
(343481, 'PTHR31153:SF16', NULL, NULL, NULL, NULL, 'ZETA_TOXIN DOMAIN-CONTAINING PROTEIN', 243874),
(343482, 'PTHR31153:SF13', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN', 243874),
(343483, 'PTHR11593:SF45', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L17', 243875),
(343484, 'PTHR11593:SF33', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L22, CHLOROPLASTIC', 243875),
(343485, 'PTHR11593:SF22', NULL, NULL, NULL, NULL, '', 243875),
(343486, 'PTHR11593:SF44', NULL, NULL, NULL, NULL, 'BNAA07G08800D PROTEIN', 243875),
(343487, 'PTHR11593:SF11', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L17', 243875),
(343488, 'PTHR11593:SF36', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L17A', 243875),
(343489, 'PTHR11593:SF24', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L17', 243875),
(343490, 'PTHR11593:SF30', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L17-1', 243875),
(343491, 'PTHR11593:SF41', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L17C', 243875),
(343492, 'PTHR11593:SF32', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L17-2', 243875),
(343493, 'PTHR11593:SF10', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L17', 243875),
(343494, 'PTHR11593:SF43', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L17', 243875),
(343495, 'PTHR11593:SF21', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L17-1 ISOFORM X1', 243875),
(343496, 'PTHR11593:SF31', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L22/L17-RELATED', 243875),
(343497, 'PTHR11593:SF42', NULL, NULL, NULL, NULL, 'BNAC06G26740D PROTEIN', 243875),
(343498, 'PTHR11593', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L17', 243875),
(343499, 'PTHR11593:SF29', NULL, NULL, NULL, NULL, 'BNAC05G51070D PROTEIN', 243875),
(343500, 'PTHR47572', NULL, NULL, NULL, NULL, 'LIPOPROTEIN-RELATED', 243876),
(343501, 'PTHR47572:SF3', NULL, NULL, NULL, NULL, 'BLR2233 PROTEIN', 243876),
(343502, 'PTHR47572:SF4', NULL, NULL, NULL, NULL, 'LACTONASE DRP35', 243876),
(343503, 'PTHR33334:SF10', NULL, NULL, NULL, NULL, 'PROTEIN LNK4', 243877),
(343504, 'PTHR33334:SF8', NULL, NULL, NULL, NULL, 'PROTEIN LNK1', 243877),
(343505, 'PTHR33334:SF9', NULL, NULL, NULL, NULL, 'PROTEIN LNK3', 243877),
(343506, 'PTHR33334', NULL, NULL, NULL, NULL, 'PROTEIN LNK1', 243877),
(343507, 'PTHR33334:SF14', NULL, NULL, NULL, NULL, 'PROTEIN LNK1-LIKE', 243877),
(343508, 'PTHR33334:SF3', NULL, NULL, NULL, NULL, '', 243877),
(343509, 'PTHR33334:SF5', NULL, NULL, NULL, NULL, 'PROTEIN LNK2', 243877),
(343510, 'PTHR33334:SF13', NULL, NULL, NULL, NULL, 'DENTIN SIALOPHOSPHOPROTEIN-RELATED PROTEIN-RELATED', 243877),
(343511, 'PTHR33334:SF6', NULL, NULL, NULL, NULL, 'OS01G0281100 PROTEIN', 243877),
(343512, 'PTHR47237:SF1', NULL, NULL, NULL, NULL, 'SLL0310 PROTEIN', 243878),
(343513, 'PTHR47237:SF2', NULL, NULL, NULL, NULL, 'BLL4206 PROTEIN', 243878),
(343514, 'PTHR47237', NULL, NULL, NULL, NULL, 'SLL0310 PROTEIN', 243878),
(343515, 'PTHR47585:SF1', NULL, NULL, NULL, NULL, '', 243879),
(343516, 'PTHR47585:SF2', NULL, NULL, NULL, NULL, 'DUF1446 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_6G11420)', 243879),
(343517, 'PTHR47585', NULL, NULL, NULL, NULL, '', 243879),
(343518, 'PTHR37523:SF1', NULL, NULL, NULL, NULL, 'METALLOPHOS DOMAIN-CONTAINING PROTEIN', 243880),
(343519, 'PTHR37523', NULL, NULL, NULL, NULL, 'METALLOPHOSPHOESTERASE', 243880),
(343520, 'PTHR15854:SF16', NULL, NULL, NULL, NULL, 'DUF1794 DOMAIN-CONTAINING PROTEIN', 243881),
(343521, 'PTHR15854:SF2', NULL, NULL, NULL, NULL, 'SHKT DOMAIN-CONTAINING PROTEIN', 243881),
(343522, 'PTHR15854:SF3', NULL, NULL, NULL, NULL, 'SHKT DOMAIN-CONTAINING PROTEIN', 243881),
(343523, 'PTHR15854:SF1', NULL, NULL, NULL, NULL, 'PROTEIN MALE ABNORMAL 7', 243881),
(343524, 'PTHR15854', NULL, NULL, NULL, NULL, 'THAP4 PROTEIN', 243881),
(343525, 'PTHR15854:SF4', NULL, NULL, NULL, NULL, 'PEROXYNITRITE ISOMERASE THAP4', 243881),
(343526, 'PTHR10046:SF70', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT LON PROTEASE-RELATED', 243882),
(343527, 'PTHR10046:SF64', NULL, NULL, NULL, NULL, 'LON PROTEASE', 243882),
(343528, 'PTHR10046:SF68', NULL, NULL, NULL, NULL, 'LON PROTEASE HOMOLOG 2, PEROXISOMAL', 243882);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(343529, 'PTHR10046:SF24', NULL, NULL, NULL, NULL, 'LON PROTEASE HOMOLOG 2, PEROXISOMAL', 243882),
(343530, 'PTHR10046:SF46', NULL, NULL, NULL, NULL, 'ENDOPEPTIDASE LA', 243882),
(343531, 'PTHR10046', NULL, NULL, NULL, NULL, 'ATP DEPENDENT LON PROTEASE FAMILY MEMBER', 243882),
(343532, 'PTHR10046:SF69', NULL, NULL, NULL, NULL, 'LON PROTEASE HOMOLOG 2, PEROXISOMAL', 243882),
(343533, 'PTHR10046:SF66', NULL, NULL, NULL, NULL, 'ARCHAEAL LON PROTEASE', 243882),
(343534, 'PTHR10046:SF56', NULL, NULL, NULL, NULL, 'LON PROTEASE', 243882),
(343535, 'PTHR10046:SF48', NULL, NULL, NULL, NULL, 'ENDOPEPTIDASE LA', 243882),
(343536, 'PTHR10046:SF49', NULL, NULL, NULL, NULL, 'LON PROTEASE HOMOLOG-RELATED', 243882),
(343537, 'PTHR47057', NULL, NULL, NULL, NULL, 'AFADIN/ALPHA-ACTININ-BINDING', 243883),
(343538, 'PTHR47057:SF2', NULL, NULL, NULL, NULL, 'AFADIN/ALPHA-ACTININ-BINDING PROTEIN', 243883),
(343539, 'PTHR47057:SF1', NULL, NULL, NULL, NULL, 'AFADIN/ALPHA-ACTININ-BINDING PROTEIN', 243883),
(343540, 'PTHR35846', NULL, NULL, NULL, NULL, 'PROTEIN CBG05131', 243884),
(343541, 'PTHR35846:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG05131', 243884),
(343542, 'PTHR35846:SF1', NULL, NULL, NULL, NULL, 'PRESAN DOMAIN-CONTAINING PROTEIN', 243884),
(343543, 'PTHR35846:SF2', NULL, NULL, NULL, NULL, '', 243884),
(343544, 'PTHR45006:SF1', NULL, NULL, NULL, NULL, 'DNAJ-LIKE PROTEIN 1', 243885),
(343545, 'PTHR45006:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CAJ1', 243885),
(343546, 'PTHR45006', NULL, NULL, NULL, NULL, 'DNAJ-LIKE PROTEIN 1', 243885),
(343547, 'PTHR23264:SF35', NULL, NULL, NULL, NULL, 'CYTOSOLIC FE-S CLUSTER ASSEMBLY FACTOR NUBP1', 243886),
(343548, 'PTHR23264:SF33', NULL, NULL, NULL, NULL, 'CYTOSOLIC FE-S CLUSTER ASSEMBLY FACTOR NBP35', 243886),
(343549, 'PTHR23264:SF34', NULL, NULL, NULL, NULL, 'CYTOSOLIC FE-S CLUSTER ASSEMBLY FACTOR NUBP1 HOMOLOG', 243886),
(343550, 'PTHR23264:SF21', NULL, NULL, NULL, NULL, '', 243886),
(343551, 'PTHR23264:SF19', NULL, NULL, NULL, NULL, 'CYTOSOLIC FE-S CLUSTER ASSEMBLY FACTOR NUBP2', 243886),
(343552, 'PTHR23264', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-BINDING PROTEIN NBP35 YEAST -RELATED', 243886),
(343553, 'PTHR23264:SF37', NULL, NULL, NULL, NULL, 'CYTOSOLIC FE-S CLUSTER ASSEMBLY FACTOR NBP35', 243886),
(343554, 'PTHR21624', NULL, NULL, NULL, NULL, 'STEROL DESATURASE-RELATED PROTEIN', 243887),
(343555, 'PTHR21624:SF3', NULL, NULL, NULL, NULL, 'FATTY ACID HYDROXYLASE DOMAIN-CONTAINING PROTEIN', 243887),
(343556, 'PTHR21624:SF1', NULL, NULL, NULL, NULL, 'ALKYLGLYCEROL MONOOXYGENASE', 243887),
(343557, 'PTHR33059:SF4', NULL, NULL, NULL, NULL, 'OS06G0223700 PROTEIN', 243888),
(343558, 'PTHR33059:SF100', NULL, NULL, NULL, NULL, 'ZF-FLZ DOMAIN-CONTAINING PROTEIN-RELATED', 243888),
(343559, 'PTHR33059:SF76', NULL, NULL, NULL, NULL, 'FCS-LIKE ZINC FINGER 5', 243888),
(343560, 'PTHR33059:SF87', NULL, NULL, NULL, NULL, 'OS08G0407600 PROTEIN', 243888),
(343561, 'PTHR33059:SF101', NULL, NULL, NULL, NULL, 'OS11G0659200 PROTEIN', 243888),
(343562, 'PTHR33059:SF75', NULL, NULL, NULL, NULL, 'FCS-LIKE ZINC FINGER 7', 243888),
(343563, 'PTHR33059:SF84', NULL, NULL, NULL, NULL, 'FCS-LIKE ZINC FINGER 15', 243888),
(343564, 'PTHR33059:SF95', NULL, NULL, NULL, NULL, 'FLZ-TYPE DOMAIN-CONTAINING PROTEIN', 243888),
(343565, 'PTHR33059:SF94', NULL, NULL, NULL, NULL, 'FLZ-TYPE DOMAIN-CONTAINING PROTEIN', 243888),
(343566, 'PTHR33059:SF102', NULL, NULL, NULL, NULL, 'PROTEIN INCREASED RESISTANCE TO MYZUS PERSICAE 1', 243888),
(343567, 'PTHR33059:SF2', NULL, NULL, NULL, NULL, 'OS09G0367900 PROTEIN', 243888),
(343568, 'PTHR33059:SF81', NULL, NULL, NULL, NULL, 'FLZ-TYPE DOMAIN-CONTAINING PROTEIN', 243888),
(343569, 'PTHR33059:SF79', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243888),
(343570, 'PTHR33059:SF80', NULL, NULL, NULL, NULL, 'FLZ-TYPE DOMAIN-CONTAINING PROTEIN', 243888),
(343571, 'PTHR33059:SF91', NULL, NULL, NULL, NULL, 'FLZ-TYPE DOMAIN-CONTAINING PROTEIN', 243888),
(343572, 'PTHR33059:SF90', NULL, NULL, NULL, NULL, 'FCS-LIKE ZINC FINGER 6', 243888),
(343573, 'PTHR33059', NULL, NULL, NULL, NULL, 'FCS-LIKE ZINC FINGER 5', 243888);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(343574, 'PTHR36754:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM37', 243889),
(343575, 'PTHR36754', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM37', 243889),
(343576, 'PTHR46964:SF2', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS I', 243890),
(343577, 'PTHR46964:SF3', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS I', 243890),
(343578, 'PTHR46964:SF4', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS I', 243890),
(343579, 'PTHR46964:SF1', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS I', 243890),
(343580, 'PTHR46964', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS I-RELATED', 243890),
(343581, 'PTHR34054:SF6', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 243891),
(343582, 'PTHR34054:SF15', NULL, NULL, NULL, NULL, 'MEMBRANE LIPOPROTEIN-RELATED', 243891),
(343583, 'PTHR34054:SF7', NULL, NULL, NULL, NULL, 'MEMBRANE LIPOPROTEIN-RELATED', 243891),
(343584, 'PTHR34054:SF14', NULL, NULL, NULL, NULL, 'BNAANNG32750D PROTEIN', 243891),
(343585, 'PTHR34054:SF8', NULL, NULL, NULL, NULL, 'BNAA10G12370D PROTEIN', 243891),
(343586, 'PTHR34054', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243891),
(343587, 'PTHR34054:SF13', NULL, NULL, NULL, NULL, '', 243891),
(343588, 'PTHR34054:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243891),
(343589, 'PTHR34054:SF4', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 243891),
(343590, 'PTHR34054:SF10', NULL, NULL, NULL, NULL, 'BNAC04G56680D PROTEIN', 243891),
(343591, 'PTHR21643:SF7', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243892),
(343592, 'PTHR21643:SF6', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243892),
(343593, 'PTHR21643', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243892),
(343594, 'PTHR21643:SF3', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243892),
(343595, 'PTHR21643:SF2', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR AEX-2', 243892),
(343596, 'PTHR17250', NULL, NULL, NULL, NULL, 'NEGATIVE ELONGATION FACTOR E', 243893),
(343597, 'PTHR17250:SF0', NULL, NULL, NULL, NULL, 'NEGATIVE ELONGATION FACTOR E', 243893),
(343598, 'PTHR47557:SF2', NULL, NULL, NULL, NULL, 'PLANT UBX DOMAIN-CONTAINING PROTEIN 1', 243894),
(343599, 'PTHR47557:SF4', NULL, NULL, NULL, NULL, 'BNAA09G01990D PROTEIN', 243894),
(343600, 'PTHR47557:SF3', NULL, NULL, NULL, NULL, 'UBX DOMAIN-CONTAINING PROTEIN', 243894),
(343601, 'PTHR47557', NULL, NULL, NULL, NULL, 'PLANT UBX DOMAIN-CONTAINING PROTEIN 1', 243894),
(343602, 'PTHR12919:SF39', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S16-2, CHLOROPLASTIC/MITOCHONDRIAL', 243895),
(343603, 'PTHR12919:SF20', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S16, MITOCHONDRIAL', 243895),
(343604, 'PTHR12919:SF30', NULL, NULL, NULL, NULL, 'OS08G0517900 PROTEIN', 243895),
(343605, 'PTHR12919:SF33', NULL, NULL, NULL, NULL, '30S RIBOSOMAL S16-LIKE PROTEIN', 243895),
(343606, 'PTHR12919:SF34', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S16-1, CHLOROPLASTIC', 243895),
(343607, 'PTHR12919:SF37', NULL, NULL, NULL, NULL, 'BNAA02G24190D PROTEIN', 243895),
(343608, 'PTHR12919', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S16', 243895),
(343609, 'PTHR12919:SF36', NULL, NULL, NULL, NULL, 'BNAC02G11990D PROTEIN', 243895),
(343610, 'PTHR21294:SF20', NULL, NULL, NULL, NULL, 'ELECTRON TRANSFER FLAVOPROTEIN, SUBUNIT BETA (ETFB)', 243896),
(343611, 'PTHR21294:SF21', NULL, NULL, NULL, NULL, 'ELECTRON TRANSFER FLAVOPROTEIN SUBUNIT YDIQ-RELATED', 243896),
(343612, 'PTHR21294:SF8', NULL, NULL, NULL, NULL, 'ELECTRON TRANSFER FLAVOPROTEIN SUBUNIT BETA', 243896),
(343613, 'PTHR21294:SF17', NULL, NULL, NULL, NULL, 'PROTEIN FIXA', 243896),
(343614, 'PTHR21294', NULL, NULL, NULL, NULL, 'ELECTRON TRANSFER FLAVOPROTEIN BETA-SUBUNIT', 243896),
(343615, 'PTHR31385:SF11', NULL, NULL, NULL, NULL, 'BNAA08G20430D PROTEIN', 243897),
(343616, 'PTHR31385:SF5', NULL, NULL, NULL, NULL, 'F5O8.12 PROTEIN', 243897),
(343617, 'PTHR31385:SF6', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', 243897),
(343618, 'PTHR31385:SF10', NULL, NULL, NULL, NULL, 'BNACNNG68830D PROTEIN', 243897);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(343619, 'PTHR31385:SF13', NULL, NULL, NULL, NULL, 'BNAA09G30980D PROTEIN', 243897),
(343620, 'PTHR31385:SF12', NULL, NULL, NULL, NULL, 'BNAA08G20420D PROTEIN', 243897),
(343621, 'PTHR31385:SF8', NULL, NULL, NULL, NULL, 'BNAA07G09840D PROTEIN', 243897),
(343622, 'PTHR31385:SF1', NULL, NULL, NULL, NULL, 'PUTATIVE (DUF220)-RELATED', 243897),
(343623, 'PTHR31385:SF15', NULL, NULL, NULL, NULL, '', 243897),
(343624, 'PTHR31385:SF2', NULL, NULL, NULL, NULL, 'F5O8.19 PROTEIN', 243897),
(343625, 'PTHR31385:SF14', NULL, NULL, NULL, NULL, 'BNAA09G05820D PROTEIN', 243897),
(343626, 'PTHR31385:SF3', NULL, NULL, NULL, NULL, 'F5O8.22 PROTEIN', 243897),
(343627, 'PTHR31385:SF16', NULL, NULL, NULL, NULL, 'POLYKETIDE_CYC DOMAIN-CONTAINING PROTEIN', 243897),
(343628, 'PTHR31385:SF4', NULL, NULL, NULL, NULL, 'F28C11.15-RELATED', 243897),
(343629, 'PTHR31385:SF9', NULL, NULL, NULL, NULL, 'BNACNNG35460D PROTEIN', 243897),
(343630, 'PTHR31385', NULL, NULL, NULL, NULL, 'PUTATIVE (DUF220)-RELATED', 243897),
(343631, 'PTHR34406', NULL, NULL, NULL, NULL, 'PROTEIN YCEI', 243898),
(343632, 'PTHR34406:SF2', NULL, NULL, NULL, NULL, 'PERIPLASMIC PROTEIN-RELATED', 243898),
(343633, 'PTHR34406:SF1', NULL, NULL, NULL, NULL, 'PROTEIN YCEI', 243898),
(343634, 'PTHR45287:SF2', NULL, NULL, NULL, NULL, 'A-TYPE INCLUSION PROTEIN, PUTATIVE-RELATED', 243899),
(343635, 'PTHR45287:SF4', NULL, NULL, NULL, NULL, 'OS03G0691500 PROTEIN', 243899),
(343636, 'PTHR45287', NULL, NULL, NULL, NULL, 'OS03G0691500 PROTEIN', 243899),
(343637, 'PTHR45287:SF3', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN', 243899),
(343638, 'PTHR10013:SF0', NULL, NULL, NULL, NULL, 'GENERAL VESICULAR TRANSPORT FACTOR P115', 243900),
(343639, 'PTHR10013:SF6', NULL, NULL, NULL, NULL, 'BNACNNG51860D PROTEIN', 243900),
(343640, 'PTHR10013', NULL, NULL, NULL, NULL, 'GENERAL VESICULAR TRANSPORT FACTOR P115', 243900),
(343641, 'PTHR12321:SF119', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN ALFIN-LIKE 1', 243901),
(343642, 'PTHR12321:SF118', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', 243901),
(343643, 'PTHR12321:SF138', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', 243901),
(343644, 'PTHR12321:SF116', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN ALFIN-LIKE 2', 243901),
(343645, 'PTHR12321:SF137', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', 243901),
(343646, 'PTHR12321:SF115', NULL, NULL, NULL, NULL, 'ALFIN-LIKE TRANSCRIPTION FACTOR', 243901),
(343647, 'PTHR12321:SF158', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', 243901),
(343648, 'PTHR12321:SF136', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', 243901),
(343649, 'PTHR12321:SF114', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', 243901),
(343650, 'PTHR12321:SF157', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE, ALFIN-RELATED', 243901),
(343651, 'PTHR12321:SF113', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', 243901),
(343652, 'PTHR12321:SF154', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', 243901),
(343653, 'PTHR12321:SF132', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', 243901),
(343654, 'PTHR12321:SF110', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN ALFIN-LIKE 7', 243901),
(343655, 'PTHR12321:SF39', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN ALFIN-LIKE 1', 243901),
(343656, 'PTHR12321:SF153', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', 243901),
(343657, 'PTHR12321:SF174', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN ALFIN-LIKE 6', 243901),
(343658, 'PTHR12321:SF173', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN ALFIN-LIKE 8', 243901),
(343659, 'PTHR12321:SF172', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN ALFIN-LIKE 4', 243901),
(343660, 'PTHR12321:SF171', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN ALFIN-LIKE 4-LIKE', 243901),
(343661, 'PTHR12321:SF170', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN ALFIN-LIKE 5', 243901),
(343662, 'PTHR12321:SF77', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN ALFIN-LIKE 6', 243901),
(343663, 'PTHR12321:SF98', NULL, NULL, NULL, NULL, 'OS01G0158800 PROTEIN', 243901);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(343664, 'PTHR12321', NULL, NULL, NULL, NULL, 'CPG BINDING PROTEIN', 243901),
(343665, 'PTHR12321:SF129', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', 243901),
(343666, 'PTHR12321:SF105', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN ALFIN-LIKE 7', 243901),
(343667, 'PTHR12321:SF169', NULL, NULL, NULL, NULL, 'ALFIN-LIKE TRANSCRIPTION FACTOR', 243901),
(343668, 'PTHR12321:SF146', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN ALFIN-LIKE 2-LIKE', 243901),
(343669, 'PTHR12321:SF168', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN ALFIN-LIKE 1-RELATED', 243901),
(343670, 'PTHR12321:SF167', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN ALFIN-LIKE 3', 243901),
(343671, 'PTHR12321:SF122', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN ALFIN-LIKE 2', 243901),
(343672, 'PTHR12321:SF166', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN ALFIN-LIKE 1-LIKE', 243901),
(343673, 'PTHR12321:SF165', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN ALFIN-LIKE 5', 243901),
(343674, 'PTHR12321:SF164', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', 243901),
(343675, 'PTHR12321:SF120', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN ALFIN-LIKE 4-LIKE', 243901),
(343676, 'PTHR12321:SF162', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', 243901),
(343677, 'PTHR12321:SF140', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN ALFIN-LIKE 3', 243901),
(343678, 'PTHR12321:SF60', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN ALFIN-LIKE 6', 243901),
(343679, 'PTHR23018', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS XA-RELATED', 243902),
(343680, 'PTHR23018:SF9', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243902),
(343681, 'PTHR23018:SF10', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS XA', 243902),
(343682, 'PTHR23018:SF11', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243902),
(343683, 'PTHR23018:SF6', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS XA', 243902),
(343684, 'PTHR23018:SF5', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS XA', 243902),
(343685, 'PTHR23018:SF13', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 243902),
(343686, 'PTHR23018:SF14', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS XA', 243902),
(343687, 'PTHR23018:SF4', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS XA', 243902),
(343688, 'PTHR23018:SF15', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN', 243902),
(343689, 'PTHR23018:SF3', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS XA 10', 243902),
(343690, 'PTHR23018:SF16', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS XA', 243902),
(343691, 'PTHR11453:SF108', NULL, NULL, NULL, NULL, 'BORON TRANSPORTER', 243903),
(343692, 'PTHR11453:SF82', NULL, NULL, NULL, NULL, 'BORON TRANSPORTER 1', 243903),
(343693, 'PTHR11453:SF124', NULL, NULL, NULL, NULL, 'BORON TRANSPORTER 6-RELATED', 243903),
(343694, 'PTHR11453:SF125', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE-RELATED', 243903),
(343695, 'PTHR11453:SF122', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE-RELATED', 243903),
(343696, 'PTHR11453:SF101', NULL, NULL, NULL, NULL, 'BNAA04G26910D PROTEIN', 243903),
(343697, 'PTHR11453:SF123', NULL, NULL, NULL, NULL, 'BORON TRANSPORTER', 243903),
(343698, 'PTHR11453:SF128', NULL, NULL, NULL, NULL, '', 243903),
(343699, 'PTHR11453:SF20', NULL, NULL, NULL, NULL, 'ELECTROGENIC SODIUM BICARBONATE COTRANSPORTER 4', 243903),
(343700, 'PTHR11453:SF106', NULL, NULL, NULL, NULL, 'BICARBONATE TRANSPORTER, EUKARYOTIC-RELATED', 243903),
(343701, 'PTHR11453:SF129', NULL, NULL, NULL, NULL, 'BORON TRANSPORTER 2-RELATED', 243903),
(343702, 'PTHR11453:SF126', NULL, NULL, NULL, NULL, 'HCO3_COTRANSP DOMAIN-CONTAINING PROTEIN', 243903),
(343703, 'PTHR11453:SF104', NULL, NULL, NULL, NULL, 'BNACNNG08280D PROTEIN', 243903),
(343704, 'PTHR11453:SF40', NULL, NULL, NULL, NULL, 'BORON TRANSPORTER 4-RELATED', 243903),
(343705, 'PTHR11453:SF105', NULL, NULL, NULL, NULL, 'SODIUM BICARBONATE COTRANSPORTER 3', 243903),
(343706, 'PTHR11453:SF127', NULL, NULL, NULL, NULL, 'SODIUM BICARBONATE TRANSPORTER-LIKE PROTEIN 11', 243903);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(343707, 'PTHR11453', NULL, NULL, NULL, NULL, 'ANION EXCHANGE PROTEIN', 243903),
(343708, 'PTHR11453:SF120', NULL, NULL, NULL, NULL, 'BICARBONATE TRANSPORTER, EUKARYOTIC-RELATED', 243903),
(343709, 'PTHR11453:SF121', NULL, NULL, NULL, NULL, 'ANION TRANSPORTER ABTS-2', 243903),
(343710, 'PTHR11453:SF47', NULL, NULL, NULL, NULL, 'ANION EXCHANGE PROTEIN', 243903),
(343711, 'PTHR11453:SF119', NULL, NULL, NULL, NULL, 'BNAC04G00350D PROTEIN', 243903),
(343712, 'PTHR11453:SF113', NULL, NULL, NULL, NULL, 'ANION EXCHANGE PROTEIN', 243903),
(343713, 'PTHR11453:SF114', NULL, NULL, NULL, NULL, 'BORON TRANSPORTER-LIKE PROTEIN', 243903),
(343714, 'PTHR11453:SF31', NULL, NULL, NULL, NULL, 'BORON TRANSPORTER', 243903),
(343715, 'PTHR11453:SF52', NULL, NULL, NULL, NULL, 'ANION EXCHANGE PROTEIN 4', 243903),
(343716, 'PTHR11453:SF118', NULL, NULL, NULL, NULL, 'BORON TRANSPORTER 4-LIKE ISOFORM X1', 243903),
(343717, 'PTHR11453:SF115', NULL, NULL, NULL, NULL, 'BORON TRANSPORTER 2-RELATED', 243903),
(343718, 'PTHR11453:SF12', NULL, NULL, NULL, NULL, 'BAND 3 ANION TRANSPORT PROTEIN', 243903),
(343719, 'PTHR11453:SF99', NULL, NULL, NULL, NULL, 'BICARBONATE TRANSPORTER, EUKARYOTIC-RELATED', 243903),
(343720, 'PTHR11453:SF32', NULL, NULL, NULL, NULL, 'SODIUM-DRIVEN CHLORIDE BICARBONATE EXCHANGER', 243903),
(343721, 'PTHR11453:SF10', NULL, NULL, NULL, NULL, 'ELECTROGENIC SODIUM BICARBONATE COTRANSPORTER 1', 243903),
(343722, 'PTHR11453:SF131', NULL, NULL, NULL, NULL, 'BORON TRANSPORTER 7-RELATED', 243903),
(343723, 'PTHR11453:SF38', NULL, NULL, NULL, NULL, 'ANION TRANSPORTER (EUROFUNG)', 243903),
(343724, 'PTHR11453:SF110', NULL, NULL, NULL, NULL, 'BORON TRANSPORTER 3-RELATED', 243903),
(343725, 'PTHR11453:SF37', NULL, NULL, NULL, NULL, 'ELECTRONEUTRAL SODIUM BICARBONATE EXCHANGER 1', 243903),
(343726, 'PTHR11453:SF15', NULL, NULL, NULL, NULL, 'ANION EXCHANGE PROTEIN 3', 243903),
(343727, 'PTHR11453:SF36', NULL, NULL, NULL, NULL, 'ANION EXCHANGE PROTEIN', 243903),
(343728, 'PTHR11453:SF58', NULL, NULL, NULL, NULL, 'ANION EXCHANGE PROTEIN', 243903),
(343729, 'PTHR11453:SF130', NULL, NULL, NULL, NULL, 'BORON TRANSPORTER 1', 243903),
(343730, 'PTHR11453:SF14', NULL, NULL, NULL, NULL, 'ANION EXCHANGE PROTEIN 2', 243903),
(343731, 'PTHR32429:SF41', NULL, NULL, NULL, NULL, 'RIBULOSE BISPHOSPHATE CARBOXYLASE/OXYGENASE ACTIVASE, CHLOROPLASTIC', 243904),
(343732, 'PTHR32429:SF11', NULL, NULL, NULL, NULL, 'OS04G0658300 PROTEIN', 243904),
(343733, 'PTHR32429:SF32', NULL, NULL, NULL, NULL, 'RIBULOSE BISPHOSPHATE CARBOXYLASE/OXYGENASE ACTIVASE, CHLOROPLASTIC', 243904),
(343734, 'PTHR32429:SF40', NULL, NULL, NULL, NULL, 'RIBULOSE BISPHOSPHATE CARBOXYLASE/OXYGENASE ACTIVASE 1 PROTEIN-RELATED', 243904),
(343735, 'PTHR32429:SF39', NULL, NULL, NULL, NULL, 'CHLOROPLAST RIBULOSE BISPHOSPHATE CARBOXYLASE/OXYGENASE ACTIVASE', 243904),
(343736, 'PTHR32429:SF27', NULL, NULL, NULL, NULL, 'RIBULOSE BISPHOSPHATE CARBOXYLASE/OXYGENASE ACTIVASE 1, CHLOROPLASTIC-LIKE', 243904),
(343737, 'PTHR32429:SF38', NULL, NULL, NULL, NULL, 'BETA-FORM RUBISCO ACTIVASE', 243904),
(343738, 'PTHR32429:SF19', NULL, NULL, NULL, NULL, 'ATPASE, AAA-TYPE, CORE, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 243904),
(343739, 'PTHR32429:SF29', NULL, NULL, NULL, NULL, 'ATPASE_AAA_CORE DOMAIN-CONTAINING PROTEIN', 243904),
(343740, 'PTHR32429:SF35', NULL, NULL, NULL, NULL, 'RIBULOSE BISPHOSPHATE CARBOXYLASE/OXYGENASE ACTIVASE, CHLOROPLASTIC-LIKE ISOFORM X1', 243904),
(343741, 'PTHR32429:SF24', NULL, NULL, NULL, NULL, 'ATPASE_AAA_CORE DOMAIN-CONTAINING PROTEIN', 243904),
(343742, 'PTHR32429:SF37', NULL, NULL, NULL, NULL, 'ATPASE_AAA_CORE DOMAIN-CONTAINING PROTEIN', 243904),
(343743, 'PTHR32429', NULL, NULL, NULL, NULL, '', 243904),
(343744, 'PTHR32429:SF36', NULL, NULL, NULL, NULL, 'BNAA03G57530D PROTEIN', 243904),
(343745, 'PTHR32429:SF9', NULL, NULL, NULL, NULL, 'PROTEIN POST-ILLUMINATION CHLOROPHYLL FLUORESCENCE INCREASE, CHLOROPLASTIC', 243904),
(343746, 'PTHR36041', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE SUBUNIT 7A, MITOCHONDRIAL-RELATED', 243905);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(343747, 'PTHR36041:SF2', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE SUBUNIT 7A, MITOCHONDRIAL-RELATED', 243905),
(343748, 'PTHR12175:SF6', NULL, NULL, NULL, NULL, 'PITH DOMAIN-CONTAINING PROTEIN', 243906),
(343749, 'PTHR12175:SF5', NULL, NULL, NULL, NULL, 'OS03G0795500 PROTEIN', 243906),
(343750, 'PTHR12175', NULL, NULL, NULL, NULL, 'AD039  HT014   THIOREDOXIN FAMILY TRP26', 243906),
(343751, 'PTHR12175:SF1', NULL, NULL, NULL, NULL, 'PITH DOMAIN-CONTAINING PROTEIN 1', 243906),
(343752, 'PTHR36513:SF1', NULL, NULL, NULL, NULL, 'LIPOPROTEIN-RELATED', 243907),
(343753, 'PTHR36513', NULL, NULL, NULL, NULL, 'ABC TRANSMEMBRANE TYPE-1 DOMAIN-CONTAINING PROTEIN', 243907),
(343754, 'PTHR11496:SF97', NULL, NULL, NULL, NULL, 'FE-ADH DOMAIN-CONTAINING PROTEIN', 243908),
(343755, 'PTHR11496:SF103', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE 3', 243908),
(343756, 'PTHR11496:SF104', NULL, NULL, NULL, NULL, '3-DEOXY-ALPHA-D-MANNO-OCTULOSONATE 8-OXIDASE', 243908),
(343757, 'PTHR11496:SF102', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE 4', 243908),
(343758, 'PTHR11496:SF107', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G06800)-RELATED', 243908),
(343759, 'PTHR11496:SF105', NULL, NULL, NULL, NULL, 'REDUCTASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G07090)-RELATED', 243908),
(343760, 'PTHR11496', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE', 243908),
(343761, 'PTHR11496:SF106', NULL, NULL, NULL, NULL, 'LACTALDEHYDE REDUCTASE', 243908),
(343762, 'PTHR11496:SF94', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE EUTG-RELATED', 243908),
(343763, 'PTHR11496:SF83', NULL, NULL, NULL, NULL, 'HYDROXYACID-OXOACID TRANSHYDROGENASE, MITOCHONDRIAL', 243908),
(343764, 'PTHR35796:SF2', NULL, NULL, NULL, NULL, '', 243909),
(343765, 'PTHR35796:SF3', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 243909),
(343766, 'PTHR35796', NULL, NULL, NULL, NULL, 'HYPOTHETICAL CYTOSOLIC PROTEIN', 243909),
(343767, 'PTHR14281:SF3', NULL, NULL, NULL, NULL, 'KINETOCHORE PROTEIN SPC25', 243910),
(343768, 'PTHR14281', NULL, NULL, NULL, NULL, 'KINETOCHORE PROTEIN SPC25-RELATED', 243910),
(343769, 'PTHR14281:SF0', NULL, NULL, NULL, NULL, 'KINETOCHORE PROTEIN SPC25', 243910),
(343770, 'PTHR14281:SF1', NULL, NULL, NULL, NULL, 'KINETOCHORE PROTEIN SPC25', 243910),
(343771, 'PTHR14281:SF2', NULL, NULL, NULL, NULL, 'KINETOCHORE PROTEIN SPC25', 243910),
(343772, 'PTHR44758:SF1', NULL, NULL, NULL, NULL, 'NAD(P) TRANSHYDROGENASE SUBUNIT BETA', 243911),
(343773, 'PTHR44758', NULL, NULL, NULL, NULL, 'NAD(P) TRANSHYDROGENASE SUBUNIT BETA', 243911),
(343774, 'PTHR45657', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN YKL091C-RELATED', 243912),
(343775, 'PTHR45657:SF61', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 243912),
(343776, 'PTHR45657:SF9', NULL, NULL, NULL, NULL, 'OS08G0497300 PROTEIN', 243912),
(343777, 'PTHR45657:SF60', NULL, NULL, NULL, NULL, 'OS02G0133200 PROTEIN', 243912),
(343778, 'PTHR45657:SF8', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL/PHOSPHATIDYLCHOLINE TRANSFER PROTEIN SFH13', 243912),
(343779, 'PTHR45657:SF5', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL/PHOSPHATIDYLCHOLINE TRANSFER PROTEIN SFH6', 243912),
(343780, 'PTHR45657:SF7', NULL, NULL, NULL, NULL, 'OS01G0701900 PROTEIN', 243912),
(343781, 'PTHR45657:SF1', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN YKL091C-RELATED', 243912),
(343782, 'PTHR45657:SF36', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL/PHOSPHATIDYLCHOLINE TRANSFER PROTEIN SFH14', 243912),
(343783, 'PTHR45657:SF13', NULL, NULL, NULL, NULL, 'OS09G0481100 PROTEIN', 243912),
(343784, 'PTHR45657:SF35', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL/PHOSPHATIDYLCHOLINE TRANSFER PROTEIN SFH12-LIKE ISOFORM X1', 243912),
(343785, 'PTHR45657:SF3', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G09260)-RELATED', 243912),
(343786, 'PTHR45657:SF56', NULL, NULL, NULL, NULL, 'CRAL-TRIO LIPID BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 243912),
(343787, 'PTHR45657:SF55', NULL, NULL, NULL, NULL, 'BNAA06G00190D PROTEIN', 243912);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(343788, 'PTHR45657:SF11', NULL, NULL, NULL, NULL, 'CELLULAR RETINALDEHYDE BINDING/ALPHA-TOCOPHEROL TRANSPORT, CRAL/TRIO-RELATED', 243912),
(343789, 'PTHR45657:SF54', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 243912),
(343790, 'PTHR45657:SF30', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL/PHOSPHATIDYLCHOLINE TRANSFER PROTEIN SFH12-LIKE', 243912),
(343791, 'PTHR45657:SF52', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 243912),
(343792, 'PTHR45657:SF19', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL/PHOSPHATIDYLCHOLINE TRANSFER PROTEIN SFH2', 243912),
(343793, 'PTHR45657:SF18', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL/PHOSPHATIDYLCHOLINE TRANSFER PROTEIN SFH4', 243912),
(343794, 'PTHR45657:SF17', NULL, NULL, NULL, NULL, 'CELLULAR RETINALDEHYDE BINDING/ALPHA-TOCOPHEROL TRANSPORT, CRAL/TRIO-RELATED', 243912),
(343795, 'PTHR45657:SF39', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL/PHOSPHATIDYLCHOLINE TRANSFER PROTEIN SFH1-RELATED', 243912),
(343796, 'PTHR45657:SF38', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 243912),
(343797, 'PTHR45657:SF16', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL/PHOSPHATIDYLCHOLINE TRANSFER PROTEIN SFH8', 243912),
(343798, 'PTHR45657:SF50', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL/PHOSPHATIDYLCHOLINE TRANSFER PROTEIN SFH11', 243912),
(343799, 'PTHR45657:SF25', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 243912),
(343800, 'PTHR45657:SF47', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 243912),
(343801, 'PTHR45657:SF69', NULL, NULL, NULL, NULL, 'SEC14P-LIKE PHOSPHATIDYLINOSITOL TRANSFER FAMILY PROTEIN-RELATED', 243912),
(343802, 'PTHR45657:SF68', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL/PHOSPHATIDYLCHOLINE TRANSFER PROTEIN SFH10', 243912),
(343803, 'PTHR45657:SF67', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 243912),
(343804, 'PTHR45657:SF66', NULL, NULL, NULL, NULL, 'SEC14P-LIKE PHOSPHATIDYLINOSITOL TRANSFER FAMILY PROTEIN-RELATED', 243912),
(343805, 'PTHR45657:SF43', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL/PHOSPHATIDYLCHOLINE TRANSFER PROTEIN SFH9', 243912),
(343806, 'PTHR45657:SF65', NULL, NULL, NULL, NULL, 'SEC14P-LIKE PHOSPHATIDYLINOSITOL TRANSFER FAMILY PROTEIN', 243912),
(343807, 'PTHR45657:SF42', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 243912),
(343808, 'PTHR45657:SF64', NULL, NULL, NULL, NULL, 'OS05G0545000 PROTEIN', 243912),
(343809, 'PTHR45657:SF20', NULL, NULL, NULL, NULL, 'CRAL/TRIO DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_5G00680)', 243912),
(343810, 'PTHR45657:SF41', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 243912),
(343811, 'PTHR45657:SF63', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 243912),
(343812, 'PTHR45657:SF40', NULL, NULL, NULL, NULL, 'SEC14P-LIKE PHOSPHATIDYLINOSITOL TRANSFER FAMILY PROTEIN-RELATED', 243912),
(343813, 'PTHR45657:SF62', NULL, NULL, NULL, NULL, 'OS08G0341700 PROTEIN', 243912),
(343814, 'PTHR45657:SF29', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL/PHOSPHATIDYLCHOLINE TRANSFER PROTEIN SFH12', 243912),
(343815, 'PTHR45657:SF28', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL/PHOSPHATIDYLCHOLINE TRANSFER PROTEIN SFH8-LIKE', 243912),
(343816, 'PTHR45657:SF49', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 243912),
(343817, 'PTHR45657:SF26', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL/PHOSPHATIDYLCHOLINE TRANSFER PROTEIN SFH12-LIKE ISOFORM X1', 243912),
(343818, 'PTHR45657:SF48', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL/PHOSPHATIDYLCHOLINE TRANSFER PROTEIN SFH5', 243912),
(343819, 'PTHR32001:SF2', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE SUBUNIT KCP2', 243913),
(343820, 'PTHR32001:SF1', NULL, NULL, NULL, NULL, 'KERATINOCYTE-ASSOCIATED PROTEIN 2', 243913),
(343821, 'PTHR32001', NULL, NULL, NULL, NULL, 'KERATINOCYTE-ASSOCIATED PROTEIN 2', 243913),
(343822, 'PTHR43564:SF1', NULL, NULL, NULL, NULL, 'BLR6059 PROTEIN', 243914),
(343823, 'PTHR43564', NULL, NULL, NULL, NULL, 'KYNURENINE FORMAMIDASE-LIKE PROTEIN', 243914);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(343824, 'PTHR30193:SF18', NULL, NULL, NULL, NULL, 'OSMOPROTECTIVE COMPOUNDS UPTAKE PERMEASE PROTEIN GGTC', 243915),
(343825, 'PTHR30193:SF37', NULL, NULL, NULL, NULL, 'INNER MEMBRANE ABC TRANSPORTER PERMEASE PROTEIN YCJO', 243915),
(343826, 'PTHR30193', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN', 243915),
(343827, 'PTHR30193:SF1', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN YESP-RELATED', 243915),
(343828, 'PTHR30193:SF43', NULL, NULL, NULL, NULL, 'MELIBIOSE/RAFFINOSE/STACHYOSE IMPORT PERMEASE PROTEIN MELD', 243915),
(343829, 'PTHR30193:SF42', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN', 243915),
(343830, 'PTHR30193:SF41', NULL, NULL, NULL, NULL, 'DIACETYLCHITOBIOSE UPTAKE SYSTEM PERMEASE PROTEIN NGCF', 243915),
(343831, 'PTHR33545:SF4', NULL, NULL, NULL, NULL, 'UPF0750 MEMBRANE PROTEIN YXKD', 243916),
(343832, 'PTHR33545:SF3', NULL, NULL, NULL, NULL, 'UPF0750 MEMBRANE PROTEIN YQFU', 243916),
(343833, 'PTHR33545', NULL, NULL, NULL, NULL, 'UPF0750 MEMBRANE PROTEIN YITT-RELATED', 243916),
(343834, 'PTHR33545:SF2', NULL, NULL, NULL, NULL, 'UPF0750 MEMBRANE PROTEIN YDEO', 243916),
(343835, 'PTHR33545:SF10', NULL, NULL, NULL, NULL, 'UPF0750 MEMBRANE PROTEIN YPJC', 243916),
(343836, 'PTHR33545:SF9', NULL, NULL, NULL, NULL, 'UPF0750 MEMBRANE PROTEIN YITE', 243916),
(343837, 'PTHR33545:SF5', NULL, NULL, NULL, NULL, 'UPF0750 MEMBRANE PROTEIN YITT', 243916),
(343838, 'PTHR48244', NULL, NULL, NULL, NULL, 'ZEIN-ALPHA A20-RELATED', 243917),
(343839, 'PTHR48244:SF2', NULL, NULL, NULL, NULL, 'ZEIN-ALPHA 19C1', 243917),
(343840, 'PTHR48244:SF3', NULL, NULL, NULL, NULL, '22 KDA ALPHA-ZEIN 8', 243917),
(343841, 'PTHR45747:SF1', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE EZH1', 243918),
(343842, 'PTHR45747:SF20', NULL, NULL, NULL, NULL, '[HISTONE H3]-LYSINE(27) N-TRIMETHYLTRANSFERASE', 243918),
(343843, 'PTHR45747', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE E(Z)', 243918),
(343844, 'PTHR45747:SF15', NULL, NULL, NULL, NULL, '[HISTONE H3]-LYSINE(27) N-TRIMETHYLTRANSFERASE', 243918),
(343845, 'PTHR45747:SF14', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE EZA1', 243918),
(343846, 'PTHR45747:SF19', NULL, NULL, NULL, NULL, 'CXC DOMAIN-CONTAINING PROTEIN-RELATED', 243918),
(343847, 'PTHR45747:SF8', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE', 243918),
(343848, 'PTHR45747:SF7', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE MEDEA', 243918),
(343849, 'PTHR45747:SF17', NULL, NULL, NULL, NULL, 'BNAC08G46050D PROTEIN', 243918),
(343850, 'PTHR45747:SF18', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE EZH2', 243918),
(343851, 'PTHR45747:SF4', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE E(Z)', 243918),
(343852, 'PTHR45747:SF3', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE EZH2', 243918),
(343853, 'PTHR35185', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-RICH PROTEIN ADG2-RELATED', 243919),
(343854, 'PTHR35185:SF1', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-RICH PROTEIN ADG2-RELATED', 243919),
(343855, 'PTHR35185:SF2', NULL, NULL, NULL, NULL, 'EXTRACELLULAR PROLINE-SERINE RICH PROTEIN (AFU_ORTHOLOGUE AFUA_8G07090)', 243919),
(343856, 'PTHR15551:SF3', NULL, NULL, NULL, NULL, 'LIM AND CALPONIN HOMOLOGY DOMAINS-CONTAINING PROTEIN 1', 243920),
(343857, 'PTHR15551', NULL, NULL, NULL, NULL, 'LIM DOMAIN ONLY 7', 243920),
(343858, 'PTHR15551:SF5', NULL, NULL, NULL, NULL, 'LIM AND CALPONIN HOMOLOGY DOMAINS 1B', 243920),
(343859, 'PTHR15551:SF4', NULL, NULL, NULL, NULL, 'LIM AND CALPONIN HOMOLOGY DOMAINS 1A', 243920),
(343860, 'PTHR24345:SF87', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN CONTAINING KINASE', 243921),
(343861, 'PTHR24345:SF43', NULL, NULL, NULL, NULL, 'INACTIVE SERINE/THREONINE-PROTEIN KINASE PLK5', 243921),
(343862, 'PTHR24345:SF44', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PLK2', 243921),
(343863, 'PTHR24345:SF89', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PLK4', 243921),
(343864, 'PTHR24345:SF0', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PLK1', 243921);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(343865, 'PTHR24345', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PLK', 243921),
(343866, 'PTHR24345:SF52', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PLK-1', 243921),
(343867, 'PTHR24345:SF42', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PLK3', 243921),
(343868, 'PTHR24345:SF91', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PLK4', 243921),
(343869, 'PTHR24345:SF92', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PLK', 243921),
(343870, 'PTHR46238:SF8', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 243922),
(343871, 'PTHR46238:SF6', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE', 243922),
(343872, 'PTHR46238:SF7', NULL, NULL, NULL, NULL, 'ENDONUCLEASE-REVERSE TRANSCRIPTASE HMRTE-E01', 243922),
(343873, 'PTHR46238', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 243922),
(343874, 'PTHR44916:SF5', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN-RELATED', 243923),
(343875, 'PTHR44916', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN-RELATED', 243923),
(343876, 'PTHR44916:SF1', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN-RELATED', 243923),
(343877, 'PTHR44916:SF4', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 243923),
(343878, 'PTHR44916:SF3', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ DOMAIN PROTEIN', 243923),
(343879, 'PTHR13773:SF24', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE CYTIDYLYLTRANSFERASE', 243924),
(343880, 'PTHR13773:SF25', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE CYTIDYLYLTRANSFERASE', 243924),
(343881, 'PTHR13773:SF26', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE CYTIDYLYLTRANSFERASE', 243924),
(343882, 'PTHR13773:SF16', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE CYTIDYLYLTRANSFERASE 1', 243924),
(343883, 'PTHR13773:SF31', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE CYTIDYLYLTRANSFERASE 1', 243924),
(343884, 'PTHR13773:SF22', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE CYTIDYLYLTRANSFERASE', 243924),
(343885, 'PTHR13773:SF23', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE CYTIDYLYLTRANSFERASE', 243924),
(343886, 'PTHR13773:SF8', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE CYTIDYLYLTRANSFERASE, PHOTORECEPTOR-SPECIFIC', 243924),
(343887, 'PTHR13773:SF30', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE CYTIDYLYLTRANSFERASE', 243924),
(343888, 'PTHR13773:SF4', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE CYTIDYLYLTRANSFERASE 2', 243924),
(343889, 'PTHR13773:SF29', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE CYTIDYLYLTRANSFERASE 2', 243924),
(343890, 'PTHR13773:SF19', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE CYTIDYLYLTRANSFERASE 1', 243924),
(343891, 'PTHR13773', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE CYTIDYLYLTRANSFERASE', 243924),
(343892, 'PTHR44404', NULL, NULL, NULL, NULL, 'HYDROXYSTEROID DEHYDROGENASE 1M', 243925),
(343893, 'PTHR44404:SF1', NULL, NULL, NULL, NULL, 'HYDROXYSTEROID DEHYDROGENASE 1M', 243925),
(343894, 'PTHR13793:SF160', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN RHINOCEROS', 243926),
(343895, 'PTHR13793:SF17', NULL, NULL, NULL, NULL, 'BROMODOMAIN-CONTAINING PROTEIN 1', 243926),
(343896, 'PTHR13793:SF19', NULL, NULL, NULL, NULL, 'BROMODOMAIN AND PHD FINGER-CONTAINING PROTEIN 3', 243926),
(343897, 'PTHR13793:SF139', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE ATX4-LIKE', 243926),
(343898, 'PTHR13793:SF159', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE ATX3', 243926),
(343899, 'PTHR13793:SF79', NULL, NULL, NULL, NULL, 'PROTEIN JADE-1', 243926),
(343900, 'PTHR13793:SF158', NULL, NULL, NULL, NULL, 'PHD FINGER FAMILY', 243926),
(343901, 'PTHR13793:SF135', NULL, NULL, NULL, NULL, 'ENHANCER OF POLYCOMB-LIKE TRANSCRIPTION FACTOR PROTEIN', 243926),
(343902, 'PTHR13793:SF157', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE ATX3', 243926),
(343903, 'PTHR13793:SF156', NULL, NULL, NULL, NULL, 'PROTEIN LIN-49', 243926),
(343904, 'PTHR13793:SF155', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZFP-1', 243926),
(343905, 'PTHR13793:SF133', NULL, NULL, NULL, NULL, 'BROMODOMAIN AND PHD FINGER-CONTAINING, 3A', 243926),
(343906, 'PTHR13793:SF132', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE ATX5', 243926);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(343907, 'PTHR13793:SF90', NULL, NULL, NULL, NULL, 'PROTEIN AF-17', 243926),
(343908, 'PTHR13793:SF153', NULL, NULL, NULL, NULL, 'HISTONE H3-LYSINE(4) N-TRIMETHYLTRANSFERASE ATX1', 243926),
(343909, 'PTHR13793:SF131', NULL, NULL, NULL, NULL, 'PHD-FINGER DOMAIN CONTAINING PROTEIN FAMILY-RELATED', 243926),
(343910, 'PTHR13793', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEINS', 243926),
(343911, 'PTHR13793:SF92', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE ATX3', 243926),
(343912, 'PTHR13793:SF152', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE ATX4', 243926),
(343913, 'PTHR13793:SF93', NULL, NULL, NULL, NULL, 'PROTEIN AF-10', 243926),
(343914, 'PTHR13793:SF150', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN 14', 243926),
(343915, 'PTHR13793:SF27', NULL, NULL, NULL, NULL, 'PROTEIN JADE-3', 243926),
(343916, 'PTHR13793:SF84', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE JADE-2', 243926),
(343917, 'PTHR13793:SF85', NULL, NULL, NULL, NULL, 'PEREGRIN', 243926),
(343918, 'PTHR13793:SF107', NULL, NULL, NULL, NULL, 'BROMODOMAIN-CONTAINING PROTEIN, 140KD, ISOFORM A', 243926),
(343919, 'PTHR13793:SF148', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER SUPERFAMILY PROTEIN', 243926),
(343920, 'PTHR13793:SF143', NULL, NULL, NULL, NULL, 'PHD FINGER FAMILY', 243926),
(343921, 'PTHR13793:SF163', NULL, NULL, NULL, NULL, 'BROMODOMAIN AND PHD FINGER-CONTAINING, 3B', 243926),
(343922, 'PTHR13793:SF140', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE ATX2', 243926),
(343923, 'PTHR13793:SF162', NULL, NULL, NULL, NULL, 'ALHAMBRA, ISOFORM P', 243926),
(343924, 'PTHR13793:SF161', NULL, NULL, NULL, NULL, 'PHD-ZINC-FINGER-LIKE DOMAIN PROTEIN', 243926),
(343925, 'PTHR12953:SF7', NULL, NULL, NULL, NULL, 'SUN DOMAIN-CONTAINING PROTEIN', 243927),
(343926, 'PTHR12953', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN CH1 RELATED', 243927),
(343927, 'PTHR12953:SF6', NULL, NULL, NULL, NULL, 'GALACTOSE-BINDING PROTEIN-RELATED', 243927),
(343928, 'PTHR12953:SF5', NULL, NULL, NULL, NULL, 'GALACTOSE-BINDING PROTEIN', 243927),
(343929, 'PTHR12953:SF3', NULL, NULL, NULL, NULL, 'SUN DOMAIN-CONTAINING PROTEIN 5', 243927),
(343930, 'PTHR12953:SF2', NULL, NULL, NULL, NULL, 'SUN DOMAIN-CONTAINING PROTEIN 4', 243927),
(343931, 'PTHR12953:SF0', NULL, NULL, NULL, NULL, 'SUN DOMAIN-CONTAINING OSSIFICATION FACTOR', 243927),
(343932, 'PTHR24332:SF27', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN CDX-2', 243928),
(343933, 'PTHR24332:SF16', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN CDX-1', 243928),
(343934, 'PTHR24332:SF15', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN CDX-4', 243928),
(343935, 'PTHR24332', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN CDX', 243928),
(343936, 'PTHR24332:SF9', NULL, NULL, NULL, NULL, 'HOMEOTIC PROTEIN CAUDAL', 243928),
(343937, 'PTHR42730:SF1', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE SYNTHASE SUBUNIT KORC', 243929),
(343938, 'PTHR42730', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE SYNTHASE SUBUNIT KORC', 243929),
(343939, 'PTHR12332:SF1', NULL, NULL, NULL, NULL, 'KEREN-RELATED', 243930),
(343940, 'PTHR12332', NULL, NULL, NULL, NULL, 'KEREN-RELATED', 243930),
(343941, 'PTHR43218', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLTRANSFERASE-RELATED', 243931),
(343942, 'PTHR43218:SF1', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLTRANSFERASE', 243931),
(343943, 'PTHR36337:SF1', NULL, NULL, NULL, NULL, 'OBSCURIN-LIKE PROTEIN', 243932),
(343944, 'PTHR36337', NULL, NULL, NULL, NULL, 'OBSCURIN-LIKE PROTEIN', 243932),
(343945, 'PTHR37524:SF1', NULL, NULL, NULL, NULL, 'FTSJ DOMAIN-CONTAINING PROTEIN', 243933),
(343946, 'PTHR37524:SF2', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA LARGE SUBUNIT METHYLTRANSFERASE M', 243933),
(343947, 'PTHR37524', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA LARGE SUBUNIT METHYLTRANSFERASE M', 243933),
(343948, 'PTHR43442:SF3', NULL, NULL, NULL, NULL, 'GLUCONOKINASE-RELATED', 243934),
(343949, 'PTHR43442:SF2', NULL, NULL, NULL, NULL, 'GLUCONATE KINASE', 243934),
(343950, 'PTHR43442:SF1', NULL, NULL, NULL, NULL, 'THERMORESISTANT GLUCONOKINASE', 243934),
(343951, 'PTHR43442', NULL, NULL, NULL, NULL, 'GLUCONOKINASE-RELATED', 243934);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(343952, 'PTHR36334:SF1', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF2358)-RELATED', 243935),
(343953, 'PTHR36334', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF2358)-RELATED', 243935),
(343954, 'PTHR43550:SF12', NULL, NULL, NULL, NULL, '', 243936),
(343955, 'PTHR43550:SF11', NULL, NULL, NULL, NULL, '', 243936),
(343956, 'PTHR43550:SF2', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE 2, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G02600)-RELATED', 243936),
(343957, 'PTHR43550:SF3', NULL, NULL, NULL, NULL, '3-KETODIHYDROSPHINGOSINE REDUCTASE', 243936),
(343958, 'PTHR43550', NULL, NULL, NULL, NULL, '3-KETODIHYDROSPHINGOSINE REDUCTASE', 243936),
(343959, 'PTHR43550:SF8', NULL, NULL, NULL, NULL, '3-DEHYDROSPHINGANINE REDUCTASE TSC10A', 243936),
(343960, 'PTHR43550:SF6', NULL, NULL, NULL, NULL, 'SHORT CHAIN DEHYDROGENASE/REDUCTASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_2G08050)', 243936),
(343961, 'PTHR22625', NULL, NULL, NULL, NULL, 'PLEXIN', 243937),
(343962, 'PTHR22625:SF9', NULL, NULL, NULL, NULL, 'PLEXIN-B2', 243937),
(343963, 'PTHR22625:SF7', NULL, NULL, NULL, NULL, 'PLEXIN-D1', 243937),
(343964, 'PTHR22625:SF4', NULL, NULL, NULL, NULL, 'PLEXIN-C1', 243937),
(343965, 'PTHR22625:SF61', NULL, NULL, NULL, NULL, 'HEPATOCYTE GROWTH FACTOR RECEPTOR', 243937),
(343966, 'PTHR22625:SF44', NULL, NULL, NULL, NULL, 'PLEXIN-B', 243937),
(343967, 'PTHR22625:SF33', NULL, NULL, NULL, NULL, 'PLEXIN-B3', 243937),
(343968, 'PTHR22625:SF66', NULL, NULL, NULL, NULL, 'PLEXIN-2', 243937),
(343969, 'PTHR22625:SF34', NULL, NULL, NULL, NULL, 'PLEXIN-A4', 243937),
(343970, 'PTHR22625:SF32', NULL, NULL, NULL, NULL, 'PLEXIN-A3', 243937),
(343971, 'PTHR22625:SF37', NULL, NULL, NULL, NULL, 'PLEXIN-A2', 243937),
(343972, 'PTHR22625:SF59', NULL, NULL, NULL, NULL, 'PLEXIN B1A', 243937),
(343973, 'PTHR22625:SF35', NULL, NULL, NULL, NULL, 'PLEXIN-A1', 243937),
(343974, 'PTHR22625:SF68', NULL, NULL, NULL, NULL, 'PLEXIN A, ISOFORM A', 243937),
(343975, 'PTHR22625:SF36', NULL, NULL, NULL, NULL, 'PLEXIN-B1', 243937),
(343976, 'PTHR45348', NULL, NULL, NULL, NULL, 'HYPOTHETICAL OXIDOREDUCTASE (EUROFUNG)', 243938),
(343977, 'PTHR45348:SF5', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G01420)-RELATED', 243938),
(343978, 'PTHR45348:SF6', NULL, NULL, NULL, NULL, 'TRANS-ENOYL REDUCTASE APDC', 243938),
(343979, 'PTHR45348:SF1', NULL, NULL, NULL, NULL, 'TRANS-ENOYL REDUCTASE STHE', 243938),
(343980, 'PTHR45348:SF2', NULL, NULL, NULL, NULL, 'ZINC-TYPE ALCOHOL DEHYDROGENASE-LIKE PROTEIN C2E1P3.01', 243938),
(343981, 'PTHR45348:SF3', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 243938),
(343982, 'PTHR11239:SF21', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT', 243939),
(343983, 'PTHR11239:SF13', NULL, NULL, NULL, NULL, 'ZN FINGER PROTEIN, HYPOTHETICAL', 243939),
(343984, 'PTHR11239:SF24', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT', 243939),
(343985, 'PTHR11239:SF12', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE III SUBUNIT RPC10', 243939),
(343986, 'PTHR11239', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE', 243939),
(343987, 'PTHR11239:SF14', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE I SUBUNIT RPA12', 243939),
(343988, 'PTHR11239:SF17', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT', 243939),
(343989, 'PTHR11239:SF16', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT', 243939),
(343990, 'PTHR11239:SF19', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT', 243939),
(343991, 'PTHR11239:SF1', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE II SUBUNIT RPB9', 243939),
(343992, 'PTHR11239:SF18', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT', 243939),
(343993, 'PTHR43087:SF1', NULL, NULL, NULL, NULL, 'LAO/AO TRANSPORT SYSTEM ATPASE', 243940),
(343994, 'PTHR43087', NULL, NULL, NULL, NULL, 'LYSINE/ARGININE/ORNITHINE TRANSPORT SYSTEM KINASE', 243940),
(343995, 'PTHR12058:SF0', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 2/3 COMPLEX SUBUNIT 2', 243941),
(343996, 'PTHR12058', NULL, NULL, NULL, NULL, 'ARP2/3 COMPLEX 34 KDA SUBUNIT', 243941);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(343997, 'PTHR12058:SF1', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 2/3 COMPLEX SUBUNIT 2B', 243941),
(343998, 'PTHR15992:SF5', NULL, NULL, NULL, NULL, 'HOLLIDAY JUNCTION RECOGNITION PROTEIN', 243942),
(343999, 'PTHR15992', NULL, NULL, NULL, NULL, 'HOLLIDAY JUNCTION RECOGNITION PROTEIN', 243942),
(344000, 'PTHR42999', NULL, NULL, NULL, NULL, 'ANTIBIOTIC RESISTANCE PROTEIN MCBG', 243943),
(344001, 'PTHR42999:SF1', NULL, NULL, NULL, NULL, 'ANTIBIOTIC RESISTANCE PROTEIN MCBG', 243943),
(344002, 'PTHR42999:SF2', NULL, NULL, NULL, NULL, '', 243943),
(344003, 'PTHR37707', NULL, NULL, NULL, NULL, 'MATERNAL EFFECT EMBRYO ARREST 9', 243944),
(344004, 'PTHR37707:SF1', NULL, NULL, NULL, NULL, 'MATERNAL EFFECT EMBRYO ARREST 9', 243944),
(344005, 'PTHR15568:SF0', NULL, NULL, NULL, NULL, 'PROTEIN EVI2A', 243945),
(344006, 'PTHR15568', NULL, NULL, NULL, NULL, 'ECOTROPIC VIRAL INTEGRATION SITE 2A', 243945),
(344007, 'PTHR47424:SF2', NULL, NULL, NULL, NULL, 'FUNGAL_TRANS DOMAIN-CONTAINING PROTEIN-RELATED', 243946),
(344008, 'PTHR47424:SF15', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 243946),
(344009, 'PTHR47424:SF3', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN GAL4', 243946),
(344010, 'PTHR47424:SF1', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 243946),
(344011, 'PTHR47424:SF11', NULL, NULL, NULL, NULL, 'MISCELLANEOUS ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)', 243946),
(344012, 'PTHR47424:SF6', NULL, NULL, NULL, NULL, 'PROLINE UTILIZATION TRANS-ACTIVATOR', 243946),
(344013, 'PTHR47424:SF12', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR ASQA', 243946),
(344014, 'PTHR47424:SF4', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 243946),
(344015, 'PTHR47424:SF14', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN GRT1', 243946),
(344016, 'PTHR47424:SF5', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 243946),
(344017, 'PTHR47424:SF9', NULL, NULL, NULL, NULL, 'FUNGAL_TRANS DOMAIN-CONTAINING PROTEIN', 243946),
(344018, 'PTHR47424', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN GAL4', 243946),
(344019, 'PTHR24091', NULL, NULL, NULL, NULL, 'LYMPHOCYTE TRANSMEMBRANE ADAPTER 1', 243947),
(344020, 'PTHR24091:SF0', NULL, NULL, NULL, NULL, 'LYMPHOCYTE TRANSMEMBRANE ADAPTER 1', 243947),
(344021, 'PTHR16779:SF2', NULL, NULL, NULL, NULL, '', 243948),
(344022, 'PTHR16779:SF1', NULL, NULL, NULL, NULL, 'BETA-1,4-MANNOSYLTRANSFERASE EGH', 243948),
(344023, 'PTHR16779', NULL, NULL, NULL, NULL, 'BETA-1,4-MANNOSYLTRANSFERASE EGH', 243948),
(344024, 'PTHR17502:SF2', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE 28', 243949),
(344025, 'PTHR17502:SF4', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE 27', 243949),
(344026, 'PTHR17502', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE 27 FAMILY MEMBER', 243949),
(344027, 'PTHR16676:SF0', NULL, NULL, NULL, NULL, 'SIGNAL TRANSDUCER CD24', 243950),
(344028, 'PTHR16676', NULL, NULL, NULL, NULL, 'SIGNAL TRANSDUCER CD24', 243950),
(344029, 'PTHR38566:SF1', NULL, NULL, NULL, NULL, 'RNA_LIG_T4_1 DOMAIN-CONTAINING PROTEIN', 243951),
(344030, 'PTHR38566', NULL, NULL, NULL, NULL, 'RNA_LIG_T4_1 DOMAIN-CONTAINING PROTEIN', 243951),
(344031, 'PTHR21512:SF5', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT 9', 243952),
(344032, 'PTHR21512', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT 9', 243952),
(344033, 'PTHR21512:SF6', NULL, NULL, NULL, NULL, 'TRAPP II COMPLEX, TRS120-RELATED', 243952),
(344034, 'PTHR44592:SF3', NULL, NULL, NULL, NULL, 'GENE 10521-RELATED', 243953),
(344035, 'PTHR44592', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 243953),
(344036, 'PTHR34568', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 243954),
(344037, 'PTHR34568:SF5', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 243954),
(344038, 'PTHR34568:SF7', NULL, NULL, NULL, NULL, '', 243954),
(344039, 'PTHR34568:SF1', NULL, NULL, NULL, NULL, 'DNA BINDING PROTEIN', 243954),
(344040, 'PTHR34568:SF3', NULL, NULL, NULL, NULL, '', 243954);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(344041, 'PTHR34568:SF4', NULL, NULL, NULL, NULL, 'OS02G0638000 PROTEIN', 243954),
(344042, 'PTHR20977', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243955),
(344043, 'PTHR20977:SF0', NULL, NULL, NULL, NULL, 'AT13385P-RELATED', 243955),
(344044, 'PTHR36308', NULL, NULL, NULL, NULL, 'DENTIN SIALOPHOSPHOPROTEIN-RELATED', 243956),
(344045, 'PTHR36308:SF2', NULL, NULL, NULL, NULL, 'BNAC05G03120D PROTEIN', 243956),
(344046, 'PTHR36308:SF1', NULL, NULL, NULL, NULL, 'DENTIN SIALOPHOSPHOPROTEIN-RELATED', 243956),
(344047, 'PTHR46610:SF19', NULL, NULL, NULL, NULL, 'OS06G0147400 PROTEIN', 243957),
(344048, 'PTHR46610:SF1', NULL, NULL, NULL, NULL, 'OS06G0147300 PROTEIN', 243957),
(344049, 'PTHR46610:SF2', NULL, NULL, NULL, NULL, 'OS01G0714600 PROTEIN', 243957),
(344050, 'PTHR46610:SF3', NULL, NULL, NULL, NULL, 'OS01G0238200 PROTEIN', 243957),
(344051, 'PTHR46610:SF6', NULL, NULL, NULL, NULL, 'OS06G0147100 PROTEIN', 243957),
(344052, 'PTHR46610:SF7', NULL, NULL, NULL, NULL, 'OS02G0216300 PROTEIN', 243957),
(344053, 'PTHR46610', NULL, NULL, NULL, NULL, 'OS05G0181300 PROTEIN', 243957),
(344054, 'PTHR46610:SF20', NULL, NULL, NULL, NULL, 'OS06G0580100 PROTEIN', 243957),
(344055, 'PTHR46610:SF10', NULL, NULL, NULL, NULL, '', 243957),
(344056, 'PTHR46610:SF21', NULL, NULL, NULL, NULL, '', 243957),
(344057, 'PTHR46610:SF11', NULL, NULL, NULL, NULL, '', 243957),
(344058, 'PTHR46610:SF22', NULL, NULL, NULL, NULL, '', 243957),
(344059, 'PTHR46610:SF8', NULL, NULL, NULL, NULL, 'OS06G0147000 PROTEIN', 243957),
(344060, 'PTHR46610:SF12', NULL, NULL, NULL, NULL, '', 243957),
(344061, 'PTHR46610:SF9', NULL, NULL, NULL, NULL, '', 243957),
(344062, 'PTHR46610:SF24', NULL, NULL, NULL, NULL, '', 243957),
(344063, 'PTHR46610:SF25', NULL, NULL, NULL, NULL, '', 243957),
(344064, 'PTHR46610:SF14', NULL, NULL, NULL, NULL, 'OS06G0146800 PROTEIN', 243957),
(344065, 'PTHR46610:SF26', NULL, NULL, NULL, NULL, 'OS05G0181300 PROTEIN', 243957),
(344066, 'PTHR46610:SF16', NULL, NULL, NULL, NULL, '', 243957),
(344067, 'PTHR46610:SF18', NULL, NULL, NULL, NULL, 'OS01G0183850 PROTEIN', 243957),
(344068, 'PTHR42160', NULL, NULL, NULL, NULL, 'URACIL-DNA GLYCOSYLASE SUPERFAMILY PROTEIN', 243958),
(344069, 'PTHR42160:SF1', NULL, NULL, NULL, NULL, 'URACIL-DNA GLYCOSYLASE SUPERFAMILY PROTEIN', 243958),
(344070, 'PTHR33791:SF16', NULL, NULL, NULL, NULL, 'CHAPERONIN-LIKE RBCX PROTEIN 2, CHLOROPLASTIC', 243959),
(344071, 'PTHR33791', NULL, NULL, NULL, NULL, 'CHAPERONIN-LIKE RBCX PROTEIN 1, CHLOROPLASTIC', 243959),
(344072, 'PTHR33791:SF12', NULL, NULL, NULL, NULL, 'CHAPERONIN-LIKE RBCX PROTEIN 1, CHLOROPLASTIC', 243959),
(344073, 'PTHR33791:SF11', NULL, NULL, NULL, NULL, '', 243959),
(344074, 'PTHR33791:SF2', NULL, NULL, NULL, NULL, 'OS07G0569600 PROTEIN', 243959),
(344075, 'PTHR33791:SF14', NULL, NULL, NULL, NULL, 'BNAC02G09090D PROTEIN', 243959),
(344076, 'PTHR33791:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243959),
(344077, 'PTHR33791:SF13', NULL, NULL, NULL, NULL, 'CHAPERONIN-LIKE RBCX-RELATED', 243959),
(344078, 'PTHR15572', NULL, NULL, NULL, NULL, 'GLIOMA TUMOR SUPPRESSOR CANDIDATE REGION GENE 1', 243960),
(344079, 'PTHR15572:SF4', NULL, NULL, NULL, NULL, 'SI:CH211-168D23.3', 243960),
(344080, 'PTHR15572:SF5', NULL, NULL, NULL, NULL, 'OS04G0393100 PROTEIN', 243960),
(344081, 'PTHR15572:SF0', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 243960),
(344082, 'PTHR15572:SF2', NULL, NULL, NULL, NULL, 'BRD4-INTERACTING CHROMATIN-REMODELING COMPLEX-ASSOCIATED PROTEIN-LIKE', 243960),
(344083, 'PTHR15572:SF1', NULL, NULL, NULL, NULL, 'BRD4-INTERACTING CHROMATIN-REMODELING COMPLEX-ASSOCIATED PROTEIN', 243960),
(344084, 'PTHR45880:SF2', NULL, NULL, NULL, NULL, 'GLYCINE-RICH RNA-BINDING PROTEIN 4, MITOCHONDRIAL ISOFORM X1', 243961),
(344085, 'PTHR45880:SF3', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 243961),
(344086, 'PTHR45880:SF1', NULL, NULL, NULL, NULL, 'RNA-BINDING MOTIF PROTEIN, X-LINKED 2', 243961),
(344087, 'PTHR45880', NULL, NULL, NULL, NULL, 'RNA-BINDING MOTIF PROTEIN, X-LINKED 2', 243961),
(344088, 'PTHR45880:SF4', NULL, NULL, NULL, NULL, 'RNA-BINDING MOTIF PROTEIN, X-LINKED 2', 243961);
INSERT INTO "PUBLIC"."MODEL" VALUES
(344089, 'PTHR10266:SF19', NULL, NULL, NULL, NULL, 'CYTOCHROME C1 1, HEME PROTEIN, MITOCHONDRIAL-RELATED', 243962),
(344090, 'PTHR10266:SF3', NULL, NULL, NULL, NULL, 'CYTOCHROME C1, HEME PROTEIN, MITOCHONDRIAL', 243962),
(344091, 'PTHR10266:SF20', NULL, NULL, NULL, NULL, 'OS01G0935700 PROTEIN', 243962),
(344092, 'PTHR10266:SF8', NULL, NULL, NULL, NULL, 'CYTOCHROME C1-2, HEME PROTEIN, MITOCHONDRIAL ISOFORM X1', 243962),
(344093, 'PTHR10266', NULL, NULL, NULL, NULL, 'CYTOCHROME C1', 243962),
(344094, 'PTHR10266:SF14', NULL, NULL, NULL, NULL, 'CYTOCHROME C DOMAIN-CONTAINING PROTEIN', 243962),
(344095, 'PTHR10266:SF18', NULL, NULL, NULL, NULL, 'CYTOCHROME C DOMAIN-CONTAINING PROTEIN', 243962),
(344096, 'PTHR10266:SF17', NULL, NULL, NULL, NULL, 'CYTOCHROME C1-1, HEME PROTEIN, MITOCHONDRIAL', 243962),
(344097, 'PTHR22699', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN 16', 243963),
(344098, 'PTHR22699:SF1', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN 16', 243963),
(344099, 'PTHR22699:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG18160', 243963),
(344100, 'PTHR31699:SF7', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 243964),
(344101, 'PTHR31699', NULL, NULL, NULL, NULL, 'NUDIX T16 FAMILY MEMBER', 243964),
(344102, 'PTHR31699:SF4', NULL, NULL, NULL, NULL, 'NUDIX (NUCLEOSIDE DIPHOSPHATE-LINKED MOIETY X)-TYPE MOTIF 16-LIKE 2', 243964),
(344103, 'PTHR31699:SF5', NULL, NULL, NULL, NULL, 'U8 SNORNA-DECAPPING ENZYME', 243964),
(344104, 'PTHR31699:SF6', NULL, NULL, NULL, NULL, 'TUDOR-INTERACTING REPAIR REGULATOR PROTEIN', 243964),
(344105, 'PTHR31699:SF1', NULL, NULL, NULL, NULL, 'ZGC:103759', 243964),
(344106, 'PTHR34547:SF1', NULL, NULL, NULL, NULL, 'YACP-LIKE NYN DOMAIN PROTEIN', 243965),
(344107, 'PTHR34547', NULL, NULL, NULL, NULL, 'YACP-LIKE NYN DOMAIN PROTEIN', 243965),
(344108, 'PTHR10378:SF40', NULL, NULL, NULL, NULL, '', 243966),
(344109, 'PTHR10378:SF30', NULL, NULL, NULL, NULL, 'COREPRESSOR SEUSS, PUTATIVE-RELATED', 243966),
(344110, 'PTHR10378:SF41', NULL, NULL, NULL, NULL, '', 243966),
(344111, 'PTHR10378:SF22', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR SLK1-RELATED', 243966),
(344112, 'PTHR10378:SF33', NULL, NULL, NULL, NULL, 'BNAA10G08930D PROTEIN', 243966),
(344113, 'PTHR10378:SF34', NULL, NULL, NULL, NULL, 'LIM-DOMAIN BINDING PROTEIN/SEUSS-RELATED', 243966),
(344114, 'PTHR10378:SF45', NULL, NULL, NULL, NULL, '', 243966),
(344115, 'PTHR10378:SF42', NULL, NULL, NULL, NULL, 'BNAC08G47250D PROTEIN', 243966),
(344116, 'PTHR10378:SF31', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL COREPRESSOR SEUSS-LIKE ISOFORM X1', 243966),
(344117, 'PTHR10378:SF21', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR SLK2-RELATED', 243966),
(344118, 'PTHR10378:SF26', NULL, NULL, NULL, NULL, 'LIM-DOMAIN BINDING PROTEIN/SEUSS-RELATED', 243966),
(344119, 'PTHR10378:SF37', NULL, NULL, NULL, NULL, 'BNAA03G47480D PROTEIN', 243966),
(344120, 'PTHR10378:SF27', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL COREPRESSOR SEUSS', 243966),
(344121, 'PTHR10378:SF24', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL COREPRESSOR SEUSS', 243966),
(344122, 'PTHR10378:SF35', NULL, NULL, NULL, NULL, 'THIOREDOXIN M1', 243966),
(344123, 'PTHR10378:SF46', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL COREPRESSOR SEUSS', 243966),
(344124, 'PTHR10378:SF47', NULL, NULL, NULL, NULL, 'COREPRESSOR SEUSS, PUTATIVE-RELATED', 243966),
(344125, 'PTHR10378:SF19', NULL, NULL, NULL, NULL, 'CHIP, ISOFORM B', 243966),
(344126, 'PTHR10378', NULL, NULL, NULL, NULL, 'LIM DOMAIN-BINDING PROTEIN', 243966),
(344127, 'PTHR10378:SF8', NULL, NULL, NULL, NULL, 'LIM DOMAIN-BINDING PROTEIN 2', 243966),
(344128, 'PTHR10378:SF7', NULL, NULL, NULL, NULL, 'LIM DOMAIN-BINDING PROTEIN 1', 243966),
(344129, 'PTHR23022:SF123', NULL, NULL, NULL, NULL, 'HTH_TNP_TC3_2 DOMAIN-CONTAINING PROTEIN', 243967),
(344130, 'PTHR23022:SF133', NULL, NULL, NULL, NULL, 'DDE_3 DOMAIN-CONTAINING PROTEIN', 243967),
(344131, 'PTHR23022:SF121', NULL, NULL, NULL, NULL, 'HTH_TNP_TC3_2 DOMAIN-CONTAINING PROTEIN-RELATED', 243967),
(344132, 'PTHR23022:SF132', NULL, NULL, NULL, NULL, 'HTH_TNP_TC3_2 DOMAIN-CONTAINING PROTEIN', 243967);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(344133, 'PTHR23022:SF131', NULL, NULL, NULL, NULL, 'DDE_3 DOMAIN-CONTAINING PROTEIN-RELATED', 243967),
(344134, 'PTHR23022:SF130', NULL, NULL, NULL, NULL, 'TRANSPOSABLE ELEMENT TC3 TRANSPOSASE-LIKE PROTEIN', 243967),
(344135, 'PTHR23022', NULL, NULL, NULL, NULL, 'TRANSPOSABLE ELEMENT-RELATED', 243967),
(344136, 'PTHR23022:SF119', NULL, NULL, NULL, NULL, 'DDE_3 DOMAIN-CONTAINING PROTEIN', 243967),
(344137, 'PTHR23022:SF129', NULL, NULL, NULL, NULL, 'TRANSPOSABLE ELEMENT TC3 TRANSPOSASE', 243967),
(344138, 'PTHR23022:SF128', NULL, NULL, NULL, NULL, 'HTH_TNP_TC3_2 DOMAIN-CONTAINING PROTEIN', 243967),
(344139, 'PTHR45833', NULL, NULL, NULL, NULL, 'METHIONINE SYNTHASE', 243968),
(344140, 'PTHR45833:SF1', NULL, NULL, NULL, NULL, 'METHIONINE SYNTHASE', 243968),
(344141, 'PTHR45833:SF2', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL HOMOCYSTEINE S-METHYLTRANSFERASE/5,10-METHYLENETETRAHYDROFOLATE REDUCTASE', 243968),
(344142, 'PTHR40386', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 26', 243969),
(344143, 'PTHR40386:SF1', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 26', 243969),
(344144, 'PTHR33103:SF19', NULL, NULL, NULL, NULL, 'OS09G0544700 PROTEIN', 243970),
(344145, 'PTHR33103:SF56', NULL, NULL, NULL, NULL, 'BNAA05G29220D PROTEIN', 243970),
(344146, 'PTHR33103:SF57', NULL, NULL, NULL, NULL, 'BNACNNG03830D PROTEIN', 243970),
(344147, 'PTHR33103:SF52', NULL, NULL, NULL, NULL, 'OS01G0154100 PROTEIN', 243970),
(344148, 'PTHR33103:SF96', NULL, NULL, NULL, NULL, 'OS01G0153900 PROTEIN', 243970),
(344149, 'PTHR33103:SF97', NULL, NULL, NULL, NULL, '', 243970),
(344150, 'PTHR33103:SF53', NULL, NULL, NULL, NULL, 'DUF674 FAMILY PROTEIN', 243970),
(344151, 'PTHR33103:SF98', NULL, NULL, NULL, NULL, '', 243970),
(344152, 'PTHR33103:SF99', NULL, NULL, NULL, NULL, '', 243970),
(344153, 'PTHR33103:SF55', NULL, NULL, NULL, NULL, 'BNAA07G28700D PROTEIN', 243970),
(344154, 'PTHR33103:SF93', NULL, NULL, NULL, NULL, 'DUF674 FAMILY PROTEIN', 243970),
(344155, 'PTHR33103:SF94', NULL, NULL, NULL, NULL, '', 243970),
(344156, 'PTHR33103:SF95', NULL, NULL, NULL, NULL, '', 243970),
(344157, 'PTHR33103', NULL, NULL, NULL, NULL, 'OS01G0153900 PROTEIN', 243970),
(344158, 'PTHR33103:SF45', NULL, NULL, NULL, NULL, 'OS01G0154600 PROTEIN', 243970),
(344159, 'PTHR33103:SF46', NULL, NULL, NULL, NULL, 'OS05G0115600 PROTEIN', 243970),
(344160, 'PTHR33103:SF48', NULL, NULL, NULL, NULL, '', 243970),
(344161, 'PTHR33103:SF102', NULL, NULL, NULL, NULL, 'DUF674 FAMILY PROTEIN', 243970),
(344162, 'PTHR33103:SF85', NULL, NULL, NULL, NULL, '', 243970),
(344163, 'PTHR33103:SF86', NULL, NULL, NULL, NULL, 'OS04G0594500 PROTEIN', 243970),
(344164, 'PTHR33103:SF103', NULL, NULL, NULL, NULL, 'DUF674 FAMILY PROTEIN', 243970),
(344165, 'PTHR33103:SF43', NULL, NULL, NULL, NULL, 'DUF674 FAMILY PROTEIN', 243970),
(344166, 'PTHR33103:SF104', NULL, NULL, NULL, NULL, '', 243970),
(344167, 'PTHR33103:SF44', NULL, NULL, NULL, NULL, '', 243970),
(344168, 'PTHR33103:SF105', NULL, NULL, NULL, NULL, 'OS01G0153600 PROTEIN', 243970),
(344169, 'PTHR33103:SF81', NULL, NULL, NULL, NULL, 'POLYMERASE ZETA CATALYTIC SUBUNIT, PUTATIVE-RELATED', 243970),
(344170, 'PTHR33103:SF100', NULL, NULL, NULL, NULL, 'DUF674 FAMILY PROTEIN', 243970),
(344171, 'PTHR33103:SF84', NULL, NULL, NULL, NULL, '', 243970),
(344172, 'PTHR33103:SF101', NULL, NULL, NULL, NULL, '', 243970),
(344173, 'PTHR33103:SF40', NULL, NULL, NULL, NULL, '', 243970),
(344174, 'PTHR33103:SF90', NULL, NULL, NULL, NULL, '', 243970),
(344175, 'PTHR33103:SF106', NULL, NULL, NULL, NULL, 'OS01G0154200 PROTEIN', 243970),
(344176, 'PTHR33103:SF107', NULL, NULL, NULL, NULL, '', 243970),
(344177, 'PTHR33103:SF108', NULL, NULL, NULL, NULL, '', 243970),
(344178, 'PTHR33103:SF109', NULL, NULL, NULL, NULL, '', 243970),
(344179, 'PTHR33103:SF38', NULL, NULL, NULL, NULL, '', 243970),
(344180, 'PTHR33103:SF39', NULL, NULL, NULL, NULL, 'BNACNNG24410D PROTEIN', 243970),
(344181, 'PTHR33103:SF78', NULL, NULL, NULL, NULL, '', 243970),
(344182, 'PTHR33103:SF37', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 243970);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(344183, 'PTHR33103:SF74', NULL, NULL, NULL, NULL, 'BNAA04G10230D PROTEIN', 243970),
(344184, 'PTHR33103:SF75', NULL, NULL, NULL, NULL, '', 243970),
(344185, 'PTHR33103:SF71', NULL, NULL, NULL, NULL, '', 243970),
(344186, 'PTHR33103:SF73', NULL, NULL, NULL, NULL, '', 243970),
(344187, 'PTHR33103:SF27', NULL, NULL, NULL, NULL, 'OS04G0594700 PROTEIN', 243970),
(344188, 'PTHR33103:SF68', NULL, NULL, NULL, NULL, '', 243970),
(344189, 'PTHR33103:SF69', NULL, NULL, NULL, NULL, 'BNAA05G29230D PROTEIN', 243970),
(344190, 'PTHR33103:SF26', NULL, NULL, NULL, NULL, '', 243970),
(344191, 'PTHR33103:SF63', NULL, NULL, NULL, NULL, 'EMB|CAB69840.1', 243970),
(344192, 'PTHR33103:SF64', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 243970),
(344193, 'PTHR33103:SF61', NULL, NULL, NULL, NULL, '', 243970),
(344194, 'PTHR33103:SF62', NULL, NULL, NULL, NULL, '', 243970),
(344195, 'PTHR16055', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 243971),
(344196, 'PTHR16055:SF2', NULL, NULL, NULL, NULL, 'INTEGRATOR COMPLEX SUBUNIT 10', 243971),
(344197, 'PTHR13342:SF2', NULL, NULL, NULL, NULL, 'RAGULATOR COMPLEX PROTEIN LAMTOR5', 243972),
(344198, 'PTHR13342', NULL, NULL, NULL, NULL, 'RAGULATOR COMPLEX PROTEIN LAMTOR5', 243972),
(344199, 'PTHR13493', NULL, NULL, NULL, NULL, 'ZINC FINGER CCHC DOMAIN-CONTAINING', 243973),
(344200, 'PTHR13493:SF3', NULL, NULL, NULL, NULL, 'RRNA N6-ADENOSINE-METHYLTRANSFERASE ZCCHC4', 243973),
(344201, 'PTHR34061:SF20', NULL, NULL, NULL, NULL, '', 243974),
(344202, 'PTHR34061', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 243974),
(344203, 'PTHR34061:SF19', NULL, NULL, NULL, NULL, 'OS10G0502100 PROTEIN', 243974),
(344204, 'PTHR34061:SF2', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 243974),
(344205, 'PTHR34061:SF18', NULL, NULL, NULL, NULL, 'BNAC07G38680D PROTEIN', 243974),
(344206, 'PTHR34061:SF7', NULL, NULL, NULL, NULL, 'BNAA01G35080D PROTEIN', 243974),
(344207, 'PTHR34061:SF23', NULL, NULL, NULL, NULL, 'BNACNNG37290D PROTEIN', 243974),
(344208, 'PTHR34061:SF9', NULL, NULL, NULL, NULL, '', 243974),
(344209, 'PTHR34061:SF11', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 243974),
(344210, 'PTHR34061:SF21', NULL, NULL, NULL, NULL, '', 243974),
(344211, 'PTHR34061:SF17', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243974),
(344212, 'PTHR34061:SF27', NULL, NULL, NULL, NULL, '', 243974),
(344213, 'PTHR34061:SF26', NULL, NULL, NULL, NULL, '', 243974),
(344214, 'PTHR34061:SF15', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243974),
(344215, 'PTHR34061:SF14', NULL, NULL, NULL, NULL, '', 243974),
(344216, 'PTHR13138', NULL, NULL, NULL, NULL, 'PROTEIN LIN1', 243975),
(344217, 'PTHR13138:SF3', NULL, NULL, NULL, NULL, 'CD2 ANTIGEN CYTOPLASMIC TAIL-BINDING PROTEIN 2', 243975),
(344218, 'PTHR13362', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOMAL PROTEIN S33', 243976),
(344219, 'PTHR13362:SF3', NULL, NULL, NULL, NULL, 'BNAA09G17220D PROTEIN', 243976),
(344220, 'PTHR13362:SF2', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S33, MITOCHONDRIAL', 243976),
(344221, 'PTHR13362:SF4', NULL, NULL, NULL, NULL, 'BNAANNG05200D PROTEIN', 243976),
(344222, 'PTHR20426', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS PROTEIN TSR3 HOMOLOG', 243977),
(344223, 'PTHR20426:SF0', NULL, NULL, NULL, NULL, '18S RRNA AMINOCARBOXYPROPYLTRANSFERASE', 243977),
(344224, 'PTHR42913:SF3', NULL, NULL, NULL, NULL, 'NADH:UBIQUINONE REDUCTASE (NON-ELECTROGENIC)', 243978),
(344225, 'PTHR42913:SF4', NULL, NULL, NULL, NULL, 'ALTERNATIVE NAD(P)H-UBIQUINONE OXIDOREDUCTASE C1, CHLOROPLASTIC/MITOCHONDRIAL', 243978),
(344226, 'PTHR42913', NULL, NULL, NULL, NULL, 'APOPTOSIS-INDUCING FACTOR 1', 243978),
(344227, 'PTHR42913:SF6', NULL, NULL, NULL, NULL, 'SULFIDE-QUINONE REDUCTASE', 243978),
(344228, 'PTHR42913:SF9', NULL, NULL, NULL, NULL, 'SLR1591 PROTEIN', 243978),
(344229, 'PTHR42913:SF10', NULL, NULL, NULL, NULL, 'SULFIDE DEHYDROGENASE, FLAVOPROTEIN SUBUNIT', 243978),
(344230, 'PTHR47722:SF1', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', 243979),
(344231, 'PTHR47722', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243979);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(344232, 'PTHR11469:SF5', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE ISOMERASE', 243980),
(344233, 'PTHR11469:SF12', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE ISOMERASE', 243980),
(344234, 'PTHR11469', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE ISOMERASE', 243980),
(344235, 'PTHR11469:SF1', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE ISOMERASE', 243980),
(344236, 'PTHR11469:SF3', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE ISOMERASE', 243980),
(344237, 'PTHR39158:SF1', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 28', 243981),
(344238, 'PTHR39158', NULL, NULL, NULL, NULL, 'OS08G0560600 PROTEIN', 243981),
(344239, 'PTHR33922', NULL, NULL, NULL, NULL, 'OS01G0888066 PROTEIN-RELATED', 243982),
(344240, 'PTHR33922:SF2', NULL, NULL, NULL, NULL, 'OS01G0888066 PROTEIN', 243982),
(344241, 'PTHR33922:SF17', NULL, NULL, NULL, NULL, 'BNAA04G19670D PROTEIN', 243982),
(344242, 'PTHR33922:SF4', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243982),
(344243, 'PTHR33922:SF14', NULL, NULL, NULL, NULL, '', 243982),
(344244, 'PTHR33922:SF13', NULL, NULL, NULL, NULL, 'BNAA09G07450D PROTEIN', 243982),
(344245, 'PTHR33922:SF16', NULL, NULL, NULL, NULL, 'BNAC04G44060D PROTEIN', 243982),
(344246, 'PTHR33922:SF15', NULL, NULL, NULL, NULL, '', 243982),
(344247, 'PTHR33922:SF10', NULL, NULL, NULL, NULL, '', 243982),
(344248, 'PTHR46672:SF3', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN PLANT PROTEIN', 243983),
(344249, 'PTHR46672:SF1', NULL, NULL, NULL, NULL, 'OS08G0103600 PROTEIN', 243983),
(344250, 'PTHR46672:SF6', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 243983),
(344251, 'PTHR46672', NULL, NULL, NULL, NULL, 'OS08G0495500 PROTEIN-RELATED', 243983),
(344252, 'PTHR46672:SF7', NULL, NULL, NULL, NULL, 'SKP1/BTB/POZ DOMAIN-CONTAINING PROTEIN-RELATED', 243983),
(344253, 'PTHR46672:SF4', NULL, NULL, NULL, NULL, 'OS08G0495500 PROTEIN', 243983),
(344254, 'PTHR46672:SF8', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 243983),
(344255, 'PTHR46295', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM RESIDENT PROTEIN 44', 243984),
(344256, 'PTHR46295:SF4', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM RESIDENT PROTEIN 44.2', 243984),
(344257, 'PTHR46295:SF3', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 243984),
(344258, 'PTHR46295:SF1', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM RESIDENT PROTEIN 44', 243984),
(344259, 'PTHR47763:SF1', NULL, NULL, NULL, NULL, 'ALPHA-PROTEIN KINASE VWKA', 243985),
(344260, 'PTHR47763', NULL, NULL, NULL, NULL, 'ALPHA-PROTEIN KINASE VWKA', 243985),
(344261, 'PTHR47763:SF3', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 243985),
(344262, 'PTHR11134:SF10', NULL, NULL, NULL, NULL, 'AP-3 COMPLEX SUBUNIT BETA-1', 243986),
(344263, 'PTHR11134:SF1', NULL, NULL, NULL, NULL, 'AP-3 COMPLEX SUBUNIT BETA', 243986),
(344264, 'PTHR11134:SF32', NULL, NULL, NULL, NULL, 'B2-ADAPT-APP_C DOMAIN-CONTAINING PROTEIN', 243986),
(344265, 'PTHR11134:SF11', NULL, NULL, NULL, NULL, 'AP-3 COMPLEX SUBUNIT BETA-2', 243986),
(344266, 'PTHR11134:SF33', NULL, NULL, NULL, NULL, 'AP-2 COMPLEX SUBUNIT BETA', 243986),
(344267, 'PTHR11134:SF3', NULL, NULL, NULL, NULL, 'AP COMPLEX SUBUNIT BETA', 243986),
(344268, 'PTHR11134:SF13', NULL, NULL, NULL, NULL, 'AP-2 COMPLEX SUBUNIT BETA', 243986),
(344269, 'PTHR11134:SF4', NULL, NULL, NULL, NULL, 'AP-4 COMPLEX SUBUNIT BETA-1', 243986),
(344270, 'PTHR11134', NULL, NULL, NULL, NULL, 'ADAPTOR COMPLEX SUBUNIT BETA FAMILY MEMBER', 243986),
(344271, 'PTHR11134:SF9', NULL, NULL, NULL, NULL, 'AP-2 COMPLEX SUBUNIT BETA', 243986),
(344272, 'PTHR11134:SF30', NULL, NULL, NULL, NULL, 'BETA-ADAPTIN-LIKE PROTEIN B', 243986),
(344273, 'PTHR11134:SF31', NULL, NULL, NULL, NULL, 'AP-1 COMPLEX SUBUNIT BETA-1', 243986),
(344274, 'PTHR47042', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN-LIKE', 243987),
(344275, 'PTHR47042:SF8', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE SINGLE C2 DOMAIN PROTEIN', 243987),
(344276, 'PTHR47042:SF7', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN-RELATED', 243987),
(344277, 'PTHR47042:SF5', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE SINGLE C2 DOMAIN PROTEIN', 243987);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(344278, 'PTHR47042:SF4', NULL, NULL, NULL, NULL, 'OS02G0313700 PROTEIN', 243987),
(344279, 'PTHR47042:SF3', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT LIPID-BINDING (CALB DOMAIN) FAMILY PROTEIN', 243987),
(344280, 'PTHR47042:SF1', NULL, NULL, NULL, NULL, 'OS01G0242600 PROTEIN', 243987),
(344281, 'PTHR35302', NULL, NULL, NULL, NULL, '', 243988),
(344282, 'PTHR35302:SF1', NULL, NULL, NULL, NULL, 'PROTEIN COFACTOR ASSEMBLY OF COMPLEX C SUBUNIT B CCB1, CHLOROPLASTIC', 243988),
(344283, 'PTHR15549:SF6', NULL, NULL, NULL, NULL, 'PROTEIN SKG6', 243989),
(344284, 'PTHR15549:SF7', NULL, NULL, NULL, NULL, 'PAIRED IMMUNOGLOBULIN-LIKE TYPE 2 RECEPTOR BETA', 243989),
(344285, 'PTHR15549:SF29', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN WSC4, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G09020)-RELATED', 243989),
(344286, 'PTHR15549:SF26', NULL, NULL, NULL, NULL, 'AXIAL BUDDING PATTERN PROTEIN 2-RELATED', 243989),
(344287, 'PTHR15549:SF15', NULL, NULL, NULL, NULL, 'PAIRED IMMUNOGLOBULIN-LIKE TYPE 2 RECEPTOR BETA-RELATED', 243989),
(344288, 'PTHR15549:SF14', NULL, NULL, NULL, NULL, 'PAIRED IMMUNOGLOBULIN-LIKE TYPE 2 RECEPTOR ALPHA', 243989),
(344289, 'PTHR15549', NULL, NULL, NULL, NULL, 'PAIRED IMMUNOGLOBULIN-LIKE TYPE 2 RECEPTOR', 243989),
(344290, 'PTHR15549:SF28', NULL, NULL, NULL, NULL, '', 243989),
(344291, 'PTHR15549:SF16', NULL, NULL, NULL, NULL, '', 243989),
(344292, 'PTHR15549:SF27', NULL, NULL, NULL, NULL, 'ENDOPEPTIDASE, PUTATIVE-RELATED', 243989),
(344293, 'PTHR15549:SF32', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-CONTAINING PROTEIN', 243989),
(344294, 'PTHR15549:SF1', NULL, NULL, NULL, NULL, 'PAIRED IMMUNOGLOBULIN-LIKE TYPE 2 RECEPTOR ALPHA', 243989),
(344295, 'PTHR15549:SF31', NULL, NULL, NULL, NULL, 'WSC DOMAIN-CONTAINING PROTEIN', 243989),
(344296, 'PTHR15549:SF30', NULL, NULL, NULL, NULL, '', 243989),
(344297, 'PTHR10000:SF57', NULL, NULL, NULL, NULL, 'KANOSAMINE-6-PHOSPHATE PHOSPHATASE', 243990),
(344298, 'PTHR10000:SF25', NULL, NULL, NULL, NULL, 'PHOSPHATASE YKRA-RELATED', 243990),
(344299, 'PTHR10000:SF8', NULL, NULL, NULL, NULL, 'PYRIDOXAL PHOSPHATE PHOSPHATASE YBHA-RELATED', 243990),
(344300, 'PTHR10000:SF53', NULL, NULL, NULL, NULL, '5-AMINO-6-(5-PHOSPHO-D-RIBITYLAMINO)URACIL PHOSPHATASE YBJI-RELATED', 243990),
(344301, 'PTHR10000:SF55', NULL, NULL, NULL, NULL, '5-AMINO-6-(5-PHOSPHO-D-RIBITYLAMINO)URACIL PHOSPHATASE YCSE', 243990),
(344302, 'PTHR10000:SF23', NULL, NULL, NULL, NULL, '5-AMINO-6-(5-PHOSPHO-D-RIBITYLAMINO)URACIL PHOSPHATASE YITU', 243990),
(344303, 'PTHR10000:SF56', NULL, NULL, NULL, NULL, 'MANNOSYL-3-PHOSPHOGLYCERATE PHOSPHATASE', 243990),
(344304, 'PTHR10000:SF50', NULL, NULL, NULL, NULL, 'STRESS RESPONSE PROTEIN YHAX', 243990),
(344305, 'PTHR10000', NULL, NULL, NULL, NULL, 'PHOSPHOSERINE PHOSPHATASE', 243990),
(344306, 'PTHR32227:SF407', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344307, 'PTHR32227:SF408', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE-RELATED', 243991),
(344308, 'PTHR32227:SF369', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344309, 'PTHR32227:SF248', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344310, 'PTHR32227:SF366', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344311, 'PTHR32227:SF367', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASES FAMILY 17 PROTEIN, EXPRESSED', 243991),
(344312, 'PTHR32227:SF405', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE, ACIDIC ISOFORM PR-Q''', 243991),
(344313, 'PTHR32227:SF406', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE A6-RELATED', 243991),
(344314, 'PTHR32227:SF403', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE 3', 243991),
(344315, 'PTHR32227:SF128', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE 9', 243991),
(344316, 'PTHR32227:SF129', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344317, 'PTHR32227:SF361', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344318, 'PTHR32227:SF240', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(344319, 'PTHR32227:SF364', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344320, 'PTHR32227:SF365', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344321, 'PTHR32227:SF120', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE 1', 243991),
(344322, 'PTHR32227:SF362', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE FAMILY 17-RELATED', 243991),
(344323, 'PTHR32227:SF363', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE FAMILY 17-RELATED', 243991),
(344324, 'PTHR32227:SF242', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE', 243991),
(344325, 'PTHR32227:SF236', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE 14', 243991),
(344326, 'PTHR32227:SF357', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344327, 'PTHR32227:SF237', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344328, 'PTHR32227:SF235', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344329, 'PTHR32227:SF356', NULL, NULL, NULL, NULL, 'BETA-1,3-GLUCANASE 28', 243991),
(344330, 'PTHR32227:SF119', NULL, NULL, NULL, NULL, 'OS05G0375400 PROTEIN', 243991),
(344331, 'PTHR32227:SF117', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344332, 'PTHR32227:SF238', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344333, 'PTHR32227:SF350', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344334, 'PTHR32227', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE BG1-RELATED-RELATED', 243991),
(344335, 'PTHR32227:SF232', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE, ACIDIC ISOFORM', 243991),
(344336, 'PTHR32227:SF354', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344337, 'PTHR32227:SF233', NULL, NULL, NULL, NULL, 'OS02G0532900 PROTEIN', 243991),
(344338, 'PTHR32227:SF351', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344339, 'PTHR32227:SF352', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344340, 'PTHR32227:SF225', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344341, 'PTHR32227:SF346', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344342, 'PTHR32227:SF347', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344343, 'PTHR32227:SF345', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344344, 'PTHR32227:SF348', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE FAMILY 17-RELATED', 243991),
(344345, 'PTHR32227:SF227', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344346, 'PTHR32227:SF349', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344347, 'PTHR32227:SF71', NULL, NULL, NULL, NULL, 'OS01G0860800 PROTEIN', 243991),
(344348, 'PTHR32227:SF343', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344349, 'PTHR32227:SF340', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344350, 'PTHR32227:SF341', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344351, 'PTHR32227:SF52', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE 2', 243991),
(344352, 'PTHR32227:SF336', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344353, 'PTHR32227:SF333', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344354, 'PTHR32227:SF339', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE FAMILY 17-RELATED', 243991),
(344355, 'PTHR32227:SF218', NULL, NULL, NULL, NULL, 'OS01G0940800 PROTEIN', 243991),
(344356, 'PTHR32227:SF337', NULL, NULL, NULL, NULL, '(1-3)-BETA-GLUCAN ENDOHYDROLASE', 243991),
(344357, 'PTHR32227:SF59', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344358, 'PTHR32227:SF294', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344359, 'PTHR32227:SF295', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344360, 'PTHR32227:SF293', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(344361, 'PTHR32227:SF298', NULL, NULL, NULL, NULL, '', 243991),
(344362, 'PTHR32227:SF332', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344363, 'PTHR32227:SF299', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344364, 'PTHR32227:SF62', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344365, 'PTHR32227:SF296', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344366, 'PTHR32227:SF450', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344367, 'PTHR32227:SF451', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE 7-LIKE', 243991),
(344368, 'PTHR32227:SF290', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344369, 'PTHR32227:SF291', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344370, 'PTHR32227:SF86', NULL, NULL, NULL, NULL, 'OS01G0947000 PROTEIN', 243991),
(344371, 'PTHR32227:SF445', NULL, NULL, NULL, NULL, 'X8 DOMAIN, GLYCOSIDE HYDROLASE, CATALYTIC DOMAIN PROTEIN-RELATED', 243991),
(344372, 'PTHR32227:SF324', NULL, NULL, NULL, NULL, '(1-3)-BETA-GLUCAN ENDOHYDROLASE', 243991),
(344373, 'PTHR32227:SF325', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344374, 'PTHR32227:SF446', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344375, 'PTHR32227:SF443', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE, ACIDIC ISOFORM', 243991),
(344376, 'PTHR32227:SF88', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE 13', 243991),
(344377, 'PTHR32227:SF322', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344378, 'PTHR32227:SF444', NULL, NULL, NULL, NULL, '(1-3)-BETA-GLUCAN ENDOHYDROLASE', 243991),
(344379, 'PTHR32227:SF449', NULL, NULL, NULL, NULL, '(1-3)-BETA-GLUCAN ENDOHYDROLASE', 243991),
(344380, 'PTHR32227:SF89', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344381, 'PTHR32227:SF447', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE 5', 243991),
(344382, 'PTHR32227:SF448', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE FAMILY 17-RELATED', 243991),
(344383, 'PTHR32227:SF327', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344384, 'PTHR32227:SF283', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-13-BETA-GLUCOSIDASE BG4-RELATED', 243991),
(344385, 'PTHR32227:SF282', NULL, NULL, NULL, NULL, '', 243991),
(344386, 'PTHR32227:SF287', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE 12', 243991),
(344387, 'PTHR32227:SF441', NULL, NULL, NULL, NULL, '(1-3)-BETA-GLUCAN ENDOHYDROLASE', 243991),
(344388, 'PTHR32227:SF320', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344389, 'PTHR32227:SF442', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344390, 'PTHR32227:SF321', NULL, NULL, NULL, NULL, '(1-3)-BETA-GLUCAN ENDOHYDROLASE', 243991),
(344391, 'PTHR32227:SF288', NULL, NULL, NULL, NULL, 'ENDO-1,3-BETA-GLUCOSIDASE GII,PUTATIVE, EXPRESSED-RELATED', 243991),
(344392, 'PTHR32227:SF95', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE-RELATED', 243991),
(344393, 'PTHR32227:SF440', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE, ACIDIC-LIKE', 243991),
(344394, 'PTHR32227:SF94', NULL, NULL, NULL, NULL, 'BETA 1,3-GLUCANASE', 243991),
(344395, 'PTHR32227:SF286', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344396, 'PTHR32227:SF280', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344397, 'PTHR32227:SF319', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344398, 'PTHR32227:SF434', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344399, 'PTHR32227:SF435', NULL, NULL, NULL, NULL, '(1-3)-BETA-GLUCAN ENDOHYDROLASE', 243991),
(344400, 'PTHR32227:SF314', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344401, 'PTHR32227:SF278', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344402, 'PTHR32227:SF432', NULL, NULL, NULL, NULL, '(1-3)-BETA-GLUCAN ENDOHYDROLASE', 243991);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(344403, 'PTHR32227:SF279', NULL, NULL, NULL, NULL, '(1-3)-BETA-GLUCAN ENDOHYDROLASE', 243991),
(344404, 'PTHR32227:SF312', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344405, 'PTHR32227:SF433', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344406, 'PTHR32227:SF438', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE FAMILY 17-RELATED', 243991),
(344407, 'PTHR32227:SF317', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE 14-LIKE', 243991),
(344408, 'PTHR32227:SF439', NULL, NULL, NULL, NULL, '(1-3)-BETA-GLUCAN ENDOHYDROLASE', 243991),
(344409, 'PTHR32227:SF436', NULL, NULL, NULL, NULL, '(1-3)-BETA-GLUCAN ENDOHYDROLASE', 243991),
(344410, 'PTHR32227:SF437', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344411, 'PTHR32227:SF316', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE 10', 243991),
(344412, 'PTHR32227:SF151', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344413, 'PTHR32227:SF394', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE FAMILY 17-RELATED', 243991),
(344414, 'PTHR32227:SF273', NULL, NULL, NULL, NULL, 'LICHENASE-2', 243991),
(344415, 'PTHR32227:SF270', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASES FAMILY 17 PROTEIN, EXPRESSED', 243991),
(344416, 'PTHR32227:SF430', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE BG1-RELATED', 243991),
(344417, 'PTHR32227:SF277', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE 11-LIKE', 243991),
(344418, 'PTHR32227:SF431', NULL, NULL, NULL, NULL, '(1-3)-BETA-GLUCAN ENDOHYDROLASE', 243991),
(344419, 'PTHR32227:SF274', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE 4', 243991),
(344420, 'PTHR32227:SF275', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344421, 'PTHR32227:SF308', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344422, 'PTHR32227:SF429', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344423, 'PTHR32227:SF29', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE 11', 243991),
(344424, 'PTHR32227:SF302', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-13-BETA-GLUCOSIDASE 7', 243991),
(344425, 'PTHR32227:SF423', NULL, NULL, NULL, NULL, '(1-3)-BETA-GLUCAN ENDOHYDROLASE', 243991),
(344426, 'PTHR32227:SF20', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE 6', 243991),
(344427, 'PTHR32227:SF303', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344428, 'PTHR32227:SF424', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-13-BETA-GLUCOSIDASE BG1-RELATED', 243991),
(344429, 'PTHR32227:SF267', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE', 243991),
(344430, 'PTHR32227:SF388', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344431, 'PTHR32227:SF422', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 243991),
(344432, 'PTHR32227:SF427', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE 7', 243991),
(344433, 'PTHR32227:SF307', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344434, 'PTHR32227:SF428', NULL, NULL, NULL, NULL, '(1-3)-BETA-GLUCAN ENDOHYDROLASE', 243991),
(344435, 'PTHR32227:SF425', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344436, 'PTHR32227:SF426', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344437, 'PTHR32227:SF261', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-13-BETA-GLUCOSIDASE 14', 243991),
(344438, 'PTHR32227:SF382', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344439, 'PTHR32227:SF383', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE A', 243991),
(344440, 'PTHR32227:SF380', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344441, 'PTHR32227:SF265', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344442, 'PTHR32227:SF386', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344443, 'PTHR32227:SF266', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE, ACIDIC ISOFORM GL153', 243991);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(344444, 'PTHR32227:SF420', NULL, NULL, NULL, NULL, 'LICHENASE-2', 243991),
(344445, 'PTHR32227:SF142', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344446, 'PTHR32227:SF263', NULL, NULL, NULL, NULL, 'O-GLYCOSYL HYDROLASE SUPERFAMILY PROTEIN-RELATED', 243991),
(344447, 'PTHR32227:SF385', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344448, 'PTHR32227:SF418', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344449, 'PTHR32227:SF379', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344450, 'PTHR32227:SF258', NULL, NULL, NULL, NULL, '', 243991),
(344451, 'PTHR32227:SF412', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344452, 'PTHR32227:SF413', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE BG3-RELATED', 243991),
(344453, 'PTHR32227:SF259', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344454, 'PTHR32227:SF377', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344455, 'PTHR32227:SF11', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344456, 'PTHR32227:SF257', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344457, 'PTHR32227:SF378', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE, BASIC VACUOLAR ISOFORM GLB', 243991),
(344458, 'PTHR32227:SF416', NULL, NULL, NULL, NULL, 'OS05G0495900 PROTEIN', 243991),
(344459, 'PTHR32227:SF414', NULL, NULL, NULL, NULL, '', 243991),
(344460, 'PTHR32227:SF415', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE SUPERFAMILY PROTEIN', 243991),
(344461, 'PTHR32227:SF250', NULL, NULL, NULL, NULL, 'OS01G0801500 PROTEIN', 243991),
(344462, 'PTHR32227:SF251', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE B', 243991),
(344463, 'PTHR32227:SF370', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-D-GLUCOSIDASE', 243991),
(344464, 'PTHR32227:SF373', NULL, NULL, NULL, NULL, '(1-3)-BETA-GLUCAN ENDOHYDROLASE', 243991),
(344465, 'PTHR35345:SF1', NULL, NULL, NULL, NULL, 'TELOMERE REPEATS-BINDING BOUQUET FORMATION PROTEIN 2', 243992),
(344466, 'PTHR35345', NULL, NULL, NULL, NULL, 'TELOMERE REPEATS-BINDING BOUQUET FORMATION PROTEIN 2', 243992),
(344467, 'PTHR46129:SF2', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN 14, ISOFORM D', 243993),
(344468, 'PTHR46129', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN 14, ISOFORM D', 243993),
(344469, 'PTHR46129:SF1', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN XIVB', 243993),
(344470, 'PTHR46129:SF4', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN-16', 243993),
(344471, 'PTHR46129:SF3', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN-14-RELATED', 243993),
(344472, 'PTHR31681:SF91', NULL, NULL, NULL, NULL, 'BNAA02G17410D PROTEIN', 243994),
(344473, 'PTHR31681:SF96', NULL, NULL, NULL, NULL, 'BNAA06G37140D PROTEIN', 243994),
(344474, 'PTHR31681:SF52', NULL, NULL, NULL, NULL, 'BNAA10G08260D PROTEIN', 243994),
(344475, 'PTHR31681:SF51', NULL, NULL, NULL, NULL, 'FINGER PROTEIN-RELATED, PUTATIVE-RELATED', 243994),
(344476, 'PTHR31681:SF98', NULL, NULL, NULL, NULL, 'OS06G0683000 PROTEIN', 243994),
(344477, 'PTHR31681:SF54', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 243994),
(344478, 'PTHR31681:SF53', NULL, NULL, NULL, NULL, 'T25N20.19', 243994),
(344479, 'PTHR31681:SF97', NULL, NULL, NULL, NULL, 'FACTOR, PUTATIVE-RELATED', 243994),
(344480, 'PTHR31681:SF12', NULL, NULL, NULL, NULL, 'C2H2-LIKE ZINC FINGER PROTEIN', 243994),
(344481, 'PTHR31681', NULL, NULL, NULL, NULL, 'C2H2-LIKE ZINC FINGER PROTEIN', 243994),
(344482, 'PTHR31681:SF57', NULL, NULL, NULL, NULL, 'BNAA02G09720D PROTEIN', 243994),
(344483, 'PTHR31681:SF29', NULL, NULL, NULL, NULL, 'C2H2-LIKE ZINC FINGER PROTEIN', 243994),
(344484, 'PTHR31681:SF4', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 243994),
(344485, 'PTHR31681:SF63', NULL, NULL, NULL, NULL, 'BNAA04G28490D PROTEIN', 243994),
(344486, 'PTHR31681:SF3', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 243994),
(344487, 'PTHR31681:SF62', NULL, NULL, NULL, NULL, 'BNAA07G02210D PROTEIN', 243994);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(344488, 'PTHR31681:SF65', NULL, NULL, NULL, NULL, 'BNAA10G06610D PROTEIN', 243994),
(344489, 'PTHR31681:SF64', NULL, NULL, NULL, NULL, 'BNAA02G09710D PROTEIN', 243994),
(344490, 'PTHR31681:SF67', NULL, NULL, NULL, NULL, 'BNACNNG07610D PROTEIN', 243994),
(344491, 'PTHR31681:SF66', NULL, NULL, NULL, NULL, 'BNAA07G02240D PROTEIN', 243994),
(344492, 'PTHR31681:SF68', NULL, NULL, NULL, NULL, 'BNAA08G03630D PROTEIN', 243994),
(344493, 'PTHR31681:SF39', NULL, NULL, NULL, NULL, 'OS01G0785900 PROTEIN', 243994),
(344494, 'PTHR31681:SF110', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 243994),
(344495, 'PTHR31681:SF111', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 243994),
(344496, 'PTHR31681:SF112', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243994),
(344497, 'PTHR31681:SF72', NULL, NULL, NULL, NULL, 'BNAA08G28300D PROTEIN', 243994),
(344498, 'PTHR31681:SF30', NULL, NULL, NULL, NULL, 'SULFATED SURFACE-LIKE GLYCOPROTEIN', 243994),
(344499, 'PTHR31681:SF73', NULL, NULL, NULL, NULL, 'BNAC03G60750D PROTEIN', 243994),
(344500, 'PTHR31681:SF32', NULL, NULL, NULL, NULL, 'BNAC03G59090D PROTEIN', 243994),
(344501, 'PTHR31681:SF31', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 243994),
(344502, 'PTHR31681:SF75', NULL, NULL, NULL, NULL, 'BNAA09G54160D PROTEIN', 243994),
(344503, 'PTHR31681:SF34', NULL, NULL, NULL, NULL, 'NUCLEIC ACID-BINDING PROTEIN', 243994),
(344504, 'PTHR31681:SF78', NULL, NULL, NULL, NULL, 'BNAC06G01230D PROTEIN', 243994),
(344505, 'PTHR31681:SF77', NULL, NULL, NULL, NULL, 'BNAA02G09770D PROTEIN', 243994),
(344506, 'PTHR31681:SF79', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 243994),
(344507, 'PTHR31681:SF38', NULL, NULL, NULL, NULL, 'BNAA09G20920D PROTEIN', 243994),
(344508, 'PTHR31681:SF100', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 243994),
(344509, 'PTHR31681:SF105', NULL, NULL, NULL, NULL, 'BNAC01G19380D PROTEIN', 243994),
(344510, 'PTHR31681:SF106', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 243994),
(344511, 'PTHR31681:SF107', NULL, NULL, NULL, NULL, 'BNACNNG17980D PROTEIN', 243994),
(344512, 'PTHR31681:SF108', NULL, NULL, NULL, NULL, 'FACTOR, PUTATIVE-RELATED', 243994),
(344513, 'PTHR31681:SF101', NULL, NULL, NULL, NULL, 'POLY(ADP-RIBOSE) POLYMERASE, CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 243994),
(344514, 'PTHR31681:SF102', NULL, NULL, NULL, NULL, 'C2H2 ZINC FINGER PROTEIN', 243994),
(344515, 'PTHR31681:SF103', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 243994),
(344516, 'PTHR31681:SF104', NULL, NULL, NULL, NULL, 'NUCLEIC ACID BINDING PROTEIN', 243994),
(344517, 'PTHR31681:SF80', NULL, NULL, NULL, NULL, 'BNACNNG07640D PROTEIN', 243994),
(344518, 'PTHR31681:SF109', NULL, NULL, NULL, NULL, 'C2H2-LIKE ZINC FINGER PROTEIN', 243994),
(344519, 'PTHR31681:SF83', NULL, NULL, NULL, NULL, 'BNAA10G03710D PROTEIN', 243994),
(344520, 'PTHR31681:SF85', NULL, NULL, NULL, NULL, 'BNACNNG07620D PROTEIN', 243994),
(344521, 'PTHR31681:SF84', NULL, NULL, NULL, NULL, 'BNAC03G58950D PROTEIN', 243994),
(344522, 'PTHR31681:SF87', NULL, NULL, NULL, NULL, 'BNAC03G60730D PROTEIN', 243994),
(344523, 'PTHR31681:SF43', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 243994),
(344524, 'PTHR31681:SF89', NULL, NULL, NULL, NULL, 'BNAA08G28290D PROTEIN', 243994),
(344525, 'PTHR31681:SF45', NULL, NULL, NULL, NULL, '', 243994),
(344526, 'PTHR31681:SF88', NULL, NULL, NULL, NULL, 'BNACNNG47010D PROTEIN', 243994),
(344527, 'PTHR31681:SF44', NULL, NULL, NULL, NULL, 'BNAC03G59100D PROTEIN', 243994),
(344528, 'PTHR31681:SF47', NULL, NULL, NULL, NULL, 'SULFATED SURFACE-LIKE GLYCOPROTEIN', 243994),
(344529, 'PTHR36508', NULL, NULL, NULL, NULL, 'PROTEIN SLYX', 243995),
(344530, 'PTHR36508:SF1', NULL, NULL, NULL, NULL, 'PROTEIN SLYX', 243995),
(344531, 'PTHR45389:SF4', NULL, NULL, NULL, NULL, '', 243996),
(344532, 'PTHR45389:SF1', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN RUP1', 243996),
(344533, 'PTHR45389', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN RUP1', 243996),
(344534, 'PTHR45389:SF3', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN RUP2', 243996);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(344535, 'PTHR43244:SF2', NULL, NULL, NULL, NULL, 'CONSERVED HYPOTHETICAL ALANINE AND PROLINE-RICH PROTEIN', 243997),
(344536, 'PTHR43244:SF1', NULL, NULL, NULL, NULL, '5,10-METHYLENETETRAHYDROMETHANOPTERIN REDUCTASE', 243997),
(344537, 'PTHR43244', NULL, NULL, NULL, NULL, '', 243997),
(344538, 'PTHR37691', NULL, NULL, NULL, NULL, 'BLR3518 PROTEIN', 243998),
(344539, 'PTHR37691:SF1', NULL, NULL, NULL, NULL, 'DRSE DOMAIN-CONTAINING PROTEIN', 243998),
(344540, 'PTHR43875:SF10', NULL, NULL, NULL, NULL, 'BLL2173 PROTEIN', 243999),
(344541, 'PTHR43875', NULL, NULL, NULL, NULL, 'MALTODEXTRIN IMPORT ATP-BINDING PROTEIN MSMX', 243999),
(344542, 'PTHR43875:SF4', NULL, NULL, NULL, NULL, 'GLUCOSE IMPORT ATP-BINDING PROTEIN GLCV', 243999),
(344543, 'PTHR43875:SF13', NULL, NULL, NULL, NULL, 'TREHALOSE IMPORT ATP-BINDING PROTEIN SUGC', 243999),
(344544, 'PTHR43875:SF12', NULL, NULL, NULL, NULL, 'SN-GLYCEROL-3-PHOSPHATE IMPORT ATP-BINDING PROTEIN UGPC', 243999),
(344545, 'PTHR43875:SF6', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN', 243999),
(344546, 'PTHR43875:SF1', NULL, NULL, NULL, NULL, 'OLIGOSACCHARIDES IMPORT ATP-BINDING PROTEIN MSMX', 243999),
(344547, 'PTHR43875:SF3', NULL, NULL, NULL, NULL, 'MALTOSE/MALTODEXTRIN IMPORT ATP-BINDING PROTEIN MALK', 243999),
(344548, 'PTHR12981', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN-LIKE 1', 244000),
(344549, 'PTHR12981:SF0', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN-LIKE 1', 244000),
(344550, 'PTHR28651', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 232', 244001),
(344551, 'PTHR28651:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 232', 244001),
(344552, 'PTHR46926', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING CYSTEINE-RICH PROTEIN 2', 244002),
(344553, 'PTHR46926:SF1', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING CYSTEINE-RICH PROTEIN 2', 244002),
(344554, 'PTHR42048:SF1', NULL, NULL, NULL, NULL, 'ARS-BINDING PROTEIN 2', 244003),
(344555, 'PTHR42048', NULL, NULL, NULL, NULL, 'ARS-BINDING PROTEIN 2', 244003),
(344556, 'PTHR32467:SF172', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR', 244004),
(344557, 'PTHR32467:SF99', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR AIL5', 244004),
(344558, 'PTHR32467:SF96', NULL, NULL, NULL, NULL, 'OS03G0313100 PROTEIN', 244004),
(344559, 'PTHR32467:SF97', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR WRI1', 244004),
(344560, 'PTHR32467:SF213', NULL, NULL, NULL, NULL, 'OS03G0770700 PROTEIN', 244004),
(344561, 'PTHR32467:SF212', NULL, NULL, NULL, NULL, 'AP2/EREBP TRANSCRIPTION FACTOR SUPERFAMILY PROTEIN-RELATED', 244004),
(344562, 'PTHR32467:SF135', NULL, NULL, NULL, NULL, 'BNAA05G20050D PROTEIN', 244004),
(344563, 'PTHR32467:SF9', NULL, NULL, NULL, NULL, 'APETALA2-LIKE PROTEIN 4', 244004),
(344564, 'PTHR32467:SF134', NULL, NULL, NULL, NULL, 'BNACNNG39690D PROTEIN', 244004),
(344565, 'PTHR32467:SF211', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ANT ISOFORM X1', 244004),
(344566, 'PTHR32467:SF133', NULL, NULL, NULL, NULL, 'BNAA08G15790D PROTEIN', 244004),
(344567, 'PTHR32467:SF210', NULL, NULL, NULL, NULL, 'OS04G0653600 PROTEIN', 244004),
(344568, 'PTHR32467:SF177', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR SMZ-RELATED', 244004),
(344569, 'PTHR32467:SF132', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ANT', 244004),
(344570, 'PTHR32467:SF176', NULL, NULL, NULL, NULL, 'BNAC02G44180D PROTEIN', 244004),
(344571, 'PTHR32467:SF175', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR', 244004),
(344572, 'PTHR32467:SF4', NULL, NULL, NULL, NULL, 'OS02G0499000 PROTEIN', 244004),
(344573, 'PTHR32467:SF219', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 244004),
(344574, 'PTHR32467:SF218', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR PLT2', 244004),
(344575, 'PTHR32467:SF217', NULL, NULL, NULL, NULL, 'OS12G0126300 PROTEIN', 244004),
(344576, 'PTHR32467:SF216', NULL, NULL, NULL, NULL, 'APETALA2-LIKE PROTEIN', 244004);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(344577, 'PTHR32467:SF215', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR TOE3 ISOFORM X1', 244004),
(344578, 'PTHR32467:SF138', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 244004),
(344579, 'PTHR32467:SF214', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 244004),
(344580, 'PTHR32467:SF183', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR TOE2', 244004),
(344581, 'PTHR32467:SF22', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR PLT2', 244004),
(344582, 'PTHR32467:SF67', NULL, NULL, NULL, NULL, 'OS03G0818800 PROTEIN', 244004),
(344583, 'PTHR32467:SF180', NULL, NULL, NULL, NULL, 'OS05G0536250 PROTEIN', 244004),
(344584, 'PTHR32467:SF147', NULL, NULL, NULL, NULL, 'AP2-EREBP TRANSCRIPTION FACTOR', 244004),
(344585, 'PTHR32467:SF224', NULL, NULL, NULL, NULL, '', 244004),
(344586, 'PTHR32467:SF223', NULL, NULL, NULL, NULL, 'BNAC09G40510D PROTEIN', 244004),
(344587, 'PTHR32467:SF102', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR PLT1', 244004),
(344588, 'PTHR32467:SF101', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR AIL7', 244004),
(344589, 'PTHR32467:SF222', NULL, NULL, NULL, NULL, 'OS06G0657500 PROTEIN', 244004),
(344590, 'PTHR32467:SF221', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR TOE3 ISOFORM X1', 244004),
(344591, 'PTHR32467:SF188', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR TOE3', 244004),
(344592, 'PTHR32467:SF220', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR AIL5 ISOFORM X1', 244004),
(344593, 'PTHR32467:SF142', NULL, NULL, NULL, NULL, 'FLORAL HOMEOTIC PROTEIN APETALA 2', 244004),
(344594, 'PTHR32467', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR', 244004),
(344595, 'PTHR32467:SF229', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR-RELATED', 244004),
(344596, 'PTHR32467:SF108', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR RAP2-7-LIKE', 244004),
(344597, 'PTHR32467:SF228', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR', 244004),
(344598, 'PTHR32467:SF227', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ANT ISOFORM X1', 244004),
(344599, 'PTHR32467:SF226', NULL, NULL, NULL, NULL, 'FLORAL HOMEOTIC PROTEIN APETALA 2-LIKE ISOFORM X1', 244004),
(344600, 'PTHR32467:SF104', NULL, NULL, NULL, NULL, 'OS04G0504500 PROTEIN', 244004),
(344601, 'PTHR32467:SF148', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR-RELATED', 244004),
(344602, 'PTHR32467:SF225', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 244004),
(344603, 'PTHR32467:SF32', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR SMOS1', 244004),
(344604, 'PTHR32467:SF72', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR BBM', 244004),
(344605, 'PTHR32467:SF235', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ANT', 244004),
(344606, 'PTHR32467:SF114', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR AIL1', 244004),
(344607, 'PTHR32467:SF113', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR RAP2-7-LIKE ISOFORM X1', 244004),
(344608, 'PTHR32467:SF157', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ANT', 244004),
(344609, 'PTHR32467:SF234', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 244004),
(344610, 'PTHR32467:SF112', NULL, NULL, NULL, NULL, '', 244004),
(344611, 'PTHR32467:SF233', NULL, NULL, NULL, NULL, 'BNAANNG40110D PROTEIN', 244004),
(344612, 'PTHR32467:SF232', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR-RELATED', 244004),
(344613, 'PTHR32467:SF155', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR AIL6', 244004),
(344614, 'PTHR32467:SF231', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR', 244004);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(344615, 'PTHR32467:SF154', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR-RELATED', 244004),
(344616, 'PTHR32467:SF230', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR-RELATED', 244004),
(344617, 'PTHR32467:SF152', NULL, NULL, NULL, NULL, 'APETALA2-LIKE PROTEIN 3', 244004),
(344618, 'PTHR32467:SF151', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR BBM ISOFORM X1', 244004),
(344619, 'PTHR32467:SF118', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR RAP2-7', 244004),
(344620, 'PTHR32467:SF116', NULL, NULL, NULL, NULL, 'INTEGRASE-TYPE DNA-BINDING SUPERFAMILY PROTEIN', 244004),
(344621, 'PTHR32467:SF81', NULL, NULL, NULL, NULL, 'AP2 DOMAIN TRANSCRIPTION FACTOR', 244004),
(344622, 'PTHR32467:SF83', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR AIL1', 244004),
(344623, 'PTHR32467:SF169', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR-RELATED', 244004),
(344624, 'PTHR32467:SF168', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR-RELATED', 244004),
(344625, 'PTHR32467:SF167', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 244004),
(344626, 'PTHR32467:SF122', NULL, NULL, NULL, NULL, 'AP2-TYPE TRANSCRIPTION FACTOR', 244004),
(344627, 'PTHR32467:SF209', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR', 244004),
(344628, 'PTHR32467:SF208', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ANT', 244004),
(344629, 'PTHR32467:SF207', NULL, NULL, NULL, NULL, 'AP2 DOMAIN TRANSCRIPTION FACTOR', 244004),
(344630, 'PTHR32467:SF204', NULL, NULL, NULL, NULL, 'PUTATIVE, EXPRESSED-RELATED', 244004),
(344631, 'PTHR32467:SF90', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR AIL1', 244004),
(344632, 'PTHR32467:SF91', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 244004),
(344633, 'PTHR32467:SF92', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 244004),
(344634, 'PTHR15963:SF5', NULL, NULL, NULL, NULL, 'SHORT SPINDLE 6, ISOFORM A', 244005),
(344635, 'PTHR15963:SF3', NULL, NULL, NULL, NULL, 'PROTEIN TAMALIN', 244005),
(344636, 'PTHR15963:SF1', NULL, NULL, NULL, NULL, 'CYTOHESIN-INTERACTING PROTEIN', 244005),
(344637, 'PTHR15963', NULL, NULL, NULL, NULL, 'GENERAL RECEPTOR FOR PHOSPHOINOSITIDES 1-ASSOCIATED SCAFFOLD PROTEIN-RELATED', 244005),
(344638, 'PTHR21856', NULL, NULL, NULL, NULL, 'FIBROUS SHEATH-INTERACTING PROTEIN 2', 244006),
(344639, 'PTHR21856:SF7', NULL, NULL, NULL, NULL, 'FIBROUS SHEATH-INTERACTING PROTEIN 2', 244006),
(344640, 'PTHR30081:SF1', NULL, NULL, NULL, NULL, 'PROTEIN TRANSLOCASE SUBUNIT SECD', 244007),
(344641, 'PTHR30081', NULL, NULL, NULL, NULL, 'PROTEIN-EXPORT MEMBRANE PROTEIN SEC', 244007),
(344642, 'PTHR30081:SF13', NULL, NULL, NULL, NULL, 'PROTEIN TRANSLOCASE SUBUNIT SECD', 244007),
(344643, 'PTHR30081:SF10', NULL, NULL, NULL, NULL, 'PROTEIN EXPORT MEMBRANE PROTEIN', 244007),
(344644, 'PTHR30081:SF11', NULL, NULL, NULL, NULL, 'PROTEIN-EXPORT MEMBRANE PROTEIN SECF', 244007),
(344645, 'PTHR30081:SF8', NULL, NULL, NULL, NULL, 'PROTEIN TRANSLOCASE SUBUNIT SECF', 244007),
(344646, 'PTHR30529:SF6', NULL, NULL, NULL, NULL, 'BLL0291 PROTEIN', 244008),
(344647, 'PTHR30529:SF7', NULL, NULL, NULL, NULL, 'NI_HYDR_CYTB DOMAIN-CONTAINING PROTEIN', 244008),
(344648, 'PTHR30529:SF4', NULL, NULL, NULL, NULL, 'CYTOCHROME B561', 244008),
(344649, 'PTHR30529', NULL, NULL, NULL, NULL, 'CYTOCHROME B561', 244008),
(344650, 'PTHR30529:SF3', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 HOMOLOG 1', 244008),
(344651, 'PTHR30529:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 HOMOLOG 2', 244008),
(344652, 'PTHR36759', NULL, NULL, NULL, NULL, 'DYNEIN BETA CHAIN, CILIARY PROTEIN', 244009),
(344653, 'PTHR36759:SF1', NULL, NULL, NULL, NULL, 'DYNEIN BETA CHAIN, CILIARY PROTEIN', 244009),
(344654, 'PTHR36759:SF2', NULL, NULL, NULL, NULL, 'BNAA05G36610D PROTEIN', 244009),
(344655, 'PTHR18034:SF9', NULL, NULL, NULL, NULL, 'MI DOMAIN-CONTAINING PROTEIN', 244010);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(344656, 'PTHR18034:SF10', NULL, NULL, NULL, NULL, 'MI DOMAIN-CONTAINING PROTEIN', 244010),
(344657, 'PTHR18034:SF3', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR CWC22 HOMOLOG', 244010),
(344658, 'PTHR18034:SF4', NULL, NULL, NULL, NULL, 'NUCLEOLAR MIF4G DOMAIN-CONTAINING PROTEIN 1', 244010),
(344659, 'PTHR18034', NULL, NULL, NULL, NULL, 'CELL CYCLE CONTROL PROTEIN CWF22-RELATED', 244010),
(344660, 'PTHR18034:SF8', NULL, NULL, NULL, NULL, 'MI DOMAIN-CONTAINING PROTEIN', 244010),
(344661, 'PTHR18034:SF5', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR CWC22 HOMOLOG', 244010),
(344662, 'PTHR18034:SF6', NULL, NULL, NULL, NULL, 'MI DOMAIN-CONTAINING PROTEIN', 244010),
(344663, 'PTHR15016:SF6', NULL, NULL, NULL, NULL, 'BREAST CARCINOMA-AMPLIFIED SEQUENCE 1', 244011),
(344664, 'PTHR15016', NULL, NULL, NULL, NULL, 'BREAST CARCINOMA-AMPLIFIED SEQUENCE 1', 244011),
(344665, 'PTHR12354:SF8', NULL, NULL, NULL, NULL, 'INTERFERON-RELATED DEVELOPMENTAL REGULATOR 2', 244012),
(344666, 'PTHR12354:SF11', NULL, NULL, NULL, NULL, 'OS02G0219050 PROTEIN', 244012),
(344667, 'PTHR12354:SF10', NULL, NULL, NULL, NULL, 'INTERFERON-RELATED DEVELOPMENTAL REGULATOR FAMILY PROTEIN, EXPRESSED', 244012),
(344668, 'PTHR12354:SF21', NULL, NULL, NULL, NULL, 'INTERFERON-RELATED DEVELOPMENTAL REGULATOR 1-LIKE', 244012),
(344669, 'PTHR12354:SF20', NULL, NULL, NULL, NULL, 'BNAC03G58130D PROTEIN', 244012),
(344670, 'PTHR12354:SF6', NULL, NULL, NULL, NULL, 'INTERFERON-RELATED DEVELOPMENTAL REGULATOR 1', 244012),
(344671, 'PTHR12354:SF27', NULL, NULL, NULL, NULL, 'INTERFERON-RELATED DEVELOPMENTAL REGULATOR 2-LIKE ISOFORM X1', 244012),
(344672, 'PTHR12354:SF15', NULL, NULL, NULL, NULL, 'IFRD DOMAIN-CONTAINING PROTEIN', 244012),
(344673, 'PTHR12354:SF26', NULL, NULL, NULL, NULL, 'IFRD DOMAIN-CONTAINING PROTEIN', 244012),
(344674, 'PTHR12354:SF25', NULL, NULL, NULL, NULL, 'INTERFERON-RELATED DEVELOPMENTAL REGULATOR, ARMADILLO-TYPE FOLD PROTEIN-RELATED', 244012),
(344675, 'PTHR12354:SF13', NULL, NULL, NULL, NULL, 'DEVELOPMENTAL REGULATOR FAMILY PROTEIN / IFRD FAMILY PROTEIN, PUTATIVE-RELATED', 244012),
(344676, 'PTHR12354:SF1', NULL, NULL, NULL, NULL, 'LP04564P', 244012),
(344677, 'PTHR12354:SF19', NULL, NULL, NULL, NULL, 'ARMADILLO-TYPE FOLD PROTEIN-RELATED', 244012),
(344678, 'PTHR12354', NULL, NULL, NULL, NULL, 'INTERFERON-RELATED DEVELOPMENTAL REGULATOR', 244012),
(344679, 'PTHR15207:SF1', NULL, NULL, NULL, NULL, 'GASDERMIN-E', 244013),
(344680, 'PTHR15207', NULL, NULL, NULL, NULL, 'NONSYNDROMIC HEARING IMPAIRMENT PROTEIN', 244013),
(344681, 'PTHR11557:SF8', NULL, NULL, NULL, NULL, 'HYDROXYMETHYLBILANE SYNTHASE', 244014),
(344682, 'PTHR11557', NULL, NULL, NULL, NULL, 'PORPHOBILINOGEN DEAMINASE', 244014),
(344683, 'PTHR11557:SF7', NULL, NULL, NULL, NULL, 'HYDROXYMETHYLBILANE SYNTHASE', 244014),
(344684, 'PTHR11557:SF0', NULL, NULL, NULL, NULL, 'PORPHOBILINOGEN DEAMINASE', 244014),
(344685, 'PTHR42707:SF3', NULL, NULL, NULL, NULL, 'ACYL-COA DEHYDROGENASE AIDB-RELATED', 244015),
(344686, 'PTHR42707', NULL, NULL, NULL, NULL, 'ACYL-COA DEHYDROGENASE', 244015),
(344687, 'PTHR42707:SF2', NULL, NULL, NULL, NULL, 'ACYL-COA DEHYDROGENASE FAMILY MEMBER 11', 244015),
(344688, 'PTHR45998', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 16', 244016),
(344689, 'PTHR45998:SF5', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244016),
(344690, 'PTHR45998:SF4', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244016),
(344691, 'PTHR45998:SF6', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244016),
(344692, 'PTHR45998:SF8', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244016),
(344693, 'PTHR45998:SF1', NULL, NULL, NULL, NULL, 'OS09G0237600 PROTEIN', 244016),
(344694, 'PTHR45998:SF3', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 16-LIKE', 244016),
(344695, 'PTHR45998:SF2', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 16', 244016),
(344696, 'PTHR45781:SF5', NULL, NULL, NULL, NULL, 'TOX HIGH MOBILITY GROUP BOX FAMILY MEMBER 2', 244017);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(344697, 'PTHR45781:SF4', NULL, NULL, NULL, NULL, 'THYMOCYTE SELECTION-ASSOCIATED HIGH MOBILITY GROUP BOX PROTEIN TOX', 244017),
(344698, 'PTHR45781:SF1', NULL, NULL, NULL, NULL, 'HMG BOX DOMAIN-CONTAINING PROTEIN', 244017),
(344699, 'PTHR45781', NULL, NULL, NULL, NULL, 'AGAP000281-PA', 244017),
(344700, 'PTHR45781:SF3', NULL, NULL, NULL, NULL, 'TOX HIGH MOBILITY GROUP BOX FAMILY MEMBER 3', 244017),
(344701, 'PTHR45781:SF2', NULL, NULL, NULL, NULL, 'TOX HIGH MOBILITY GROUP BOX FAMILY MEMBER 4', 244017),
(344702, 'PTHR13151', NULL, NULL, NULL, NULL, 'CBF1 INTERACTING COREPRESSOR CIR', 244018),
(344703, 'PTHR13151:SF2', NULL, NULL, NULL, NULL, 'COREPRESSOR INTERACTING WITH RBPJ 1', 244018),
(344704, 'PTHR13151:SF3', NULL, NULL, NULL, NULL, 'OS06G0708900 PROTEIN', 244018),
(344705, 'PTHR13147:SF5', NULL, NULL, NULL, NULL, 'FOUR-JOINTED BOX PROTEIN 1', 244019),
(344706, 'PTHR13147', NULL, NULL, NULL, NULL, 'FOUR-JOINTED BOX PROTEIN 1', 244019),
(344707, 'PTHR45084', NULL, NULL, NULL, NULL, 'ERAD-ASSOCIATED E3 UBIQUITIN-PROTEIN LIGASE COMPONENT HRD3A-RELATED', 244020),
(344708, 'PTHR45084:SF1', NULL, NULL, NULL, NULL, 'ERAD-ASSOCIATED E3 UBIQUITIN-PROTEIN LIGASE COMPONENT HRD3A-RELATED', 244020),
(344709, 'PTHR45084:SF2', NULL, NULL, NULL, NULL, 'BNAA02G18220D PROTEIN', 244020),
(344710, 'PTHR37874:SF1', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1500011B03 GENE-RELATED', 244021),
(344711, 'PTHR37874', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1500011B03 GENE-RELATED', 244021),
(344712, 'PTHR35615', NULL, NULL, NULL, NULL, '', 244022),
(344713, 'PTHR35615:SF2', NULL, NULL, NULL, NULL, '', 244022),
(344714, 'PTHR35615:SF6', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 244022),
(344715, 'PTHR35615:SF8', NULL, NULL, NULL, NULL, '', 244022),
(344716, 'PTHR35615:SF7', NULL, NULL, NULL, NULL, '', 244022),
(344717, 'PTHR35615:SF9', NULL, NULL, NULL, NULL, '', 244022),
(344718, 'PTHR36319:SF3', NULL, NULL, NULL, NULL, 'PROTEIN GIGANTEA-LIKE ISOFORM X1', 244023),
(344719, 'PTHR36319', NULL, NULL, NULL, NULL, 'PROTEIN GIGANTEA', 244023),
(344720, 'PTHR36319:SF1', NULL, NULL, NULL, NULL, 'PROTEIN GIGANTEA', 244023),
(344721, 'PTHR24056:SF529', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344722, 'PTHR24056:SF525', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344723, 'PTHR24056:SF129', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 4', 244024),
(344724, 'PTHR24056:SF404', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344725, 'PTHR24056:SF405', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE', 244024),
(344726, 'PTHR24056:SF526', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344727, 'PTHR24056:SF527', NULL, NULL, NULL, NULL, 'CELL DIVISION CONTROL PROTEIN 2 HOMOLOG 2', 244024),
(344728, 'PTHR24056:SF246', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 17', 244024),
(344729, 'PTHR24056:SF400', NULL, NULL, NULL, NULL, 'GLYCOGEN SYNTHASE KINASE-3 HOMOLOG YGK3', 244024),
(344730, 'PTHR24056:SF521', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 2', 244024),
(344731, 'PTHR24056:SF522', NULL, NULL, NULL, NULL, 'OS12G0577700 PROTEIN', 244024),
(344732, 'PTHR24056:SF368', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE G-2-LIKE', 244024),
(344733, 'PTHR24056:SF126', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 12', 244024),
(344734, 'PTHR24056:SF401', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE', 244024),
(344735, 'PTHR24056:SF128', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 17', 244024),
(344736, 'PTHR24056:SF403', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE G-1', 244024),
(344737, 'PTHR24056:SF243', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 8', 244024),
(344738, 'PTHR24056:SF486', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE F-2-RELATED', 244024),
(344739, 'PTHR24056:SF366', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE', 244024),
(344740, 'PTHR24056:SF487', NULL, NULL, NULL, NULL, 'F21B7.34', 244024),
(344741, 'PTHR24056:SF480', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(344742, 'PTHR24056:SF481', NULL, NULL, NULL, NULL, 'OS02G0559300 PROTEIN', 244024),
(344743, 'PTHR24056:SF120', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE-LIKE 4', 244024),
(344744, 'PTHR24056:SF241', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE-LIKE 2', 244024),
(344745, 'PTHR24056:SF380', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344746, 'PTHR24056:SF52', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 18', 244024),
(344747, 'PTHR24056:SF415', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE G1', 244024),
(344748, 'PTHR24056:SF536', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344749, 'PTHR24056:SF416', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 244024),
(344750, 'PTHR24056:SF537', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 244024),
(344751, 'PTHR24056:SF538', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PRP4 HOMOLOG', 244024),
(344752, 'PTHR24056:SF417', NULL, NULL, NULL, NULL, 'CONTROL PROTEIN 2 HOMOLOG 6, PUTATIVE-RELATED', 244024),
(344753, 'PTHR24056:SF539', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE B1-1', 244024),
(344754, 'PTHR24056:SF499', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344755, 'PTHR24056:SF412', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344756, 'PTHR24056:SF535', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344757, 'PTHR24056:SF495', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 19', 244024),
(344758, 'PTHR24056:SF375', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 7', 244024),
(344759, 'PTHR24056:SF254', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 2', 244024),
(344760, 'PTHR24056:SF376', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 244024),
(344761, 'PTHR24056:SF530', NULL, NULL, NULL, NULL, 'CELL DIVISION CONTROL PROTEIN 2', 244024),
(344762, 'PTHR24056:SF497', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT SERINE/THREONINE-PROTEIN KINASE DDB_G0278487-RELATED', 244024),
(344763, 'PTHR24056:SF410', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE B2-1', 244024),
(344764, 'PTHR24056:SF491', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344765, 'PTHR24056:SF492', NULL, NULL, NULL, NULL, 'BNAC05G46740D PROTEIN', 244024),
(344766, 'PTHR24056:SF372', NULL, NULL, NULL, NULL, 'BNAANNG02480D PROTEIN', 244024),
(344767, 'PTHR24056:SF130', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 6', 244024),
(344768, 'PTHR24056:SF190', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE G-1', 244024),
(344769, 'PTHR24056:SF192', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE-LIKE 1', 244024),
(344770, 'PTHR24056:SF507', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE C-2', 244024),
(344771, 'PTHR24056:SF508', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 10', 244024),
(344772, 'PTHR24056:SF503', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344773, 'PTHR24056:SF107', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 11A-RELATED', 244024),
(344774, 'PTHR24056:SF228', NULL, NULL, NULL, NULL, 'PROTEIN IMPAIRED IN BABA-INDUCED STERILITY 1', 244024),
(344775, 'PTHR24056:SF504', NULL, NULL, NULL, NULL, 'OS06G0693900 PROTEIN', 244024),
(344776, 'PTHR24056:SF506', NULL, NULL, NULL, NULL, 'OS08G0112500 PROTEIN', 244024),
(344777, 'PTHR24056:SF466', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344778, 'PTHR24056:SF225', NULL, NULL, NULL, NULL, 'OS11G0242500 PROTEIN', 244024),
(344779, 'PTHR24056:SF467', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344780, 'PTHR24056:SF468', NULL, NULL, NULL, NULL, 'BNAC06G07730D PROTEIN', 244024),
(344781, 'PTHR24056:SF501', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344782, 'PTHR24056:SF469', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344783, 'PTHR24056:SF462', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 3', 244024);
INSERT INTO "PUBLIC"."MODEL" VALUES
(344784, 'PTHR24056:SF188', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344785, 'PTHR24056:SF221', NULL, NULL, NULL, NULL, 'OS02G0304500 PROTEIN', 244024),
(344786, 'PTHR24056:SF189', NULL, NULL, NULL, NULL, 'ECDYSONE-INDUCED PROTEIN 63E, ISOFORM N', 244024),
(344787, 'PTHR24056:SF222', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344788, 'PTHR24056:SF465', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 244024),
(344789, 'PTHR24056:SF461', NULL, NULL, NULL, NULL, 'BNAC06G10110D PROTEIN', 244024),
(344790, 'PTHR24056:SF518', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344791, 'PTHR24056:SF510', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE-LIKE 1', 244024),
(344792, 'PTHR24056:SF511', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344793, 'PTHR24056:SF478', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344794, 'PTHR24056:SF358', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344795, 'PTHR24056:SF479', NULL, NULL, NULL, NULL, 'BNAA06G18950D PROTEIN', 244024),
(344796, 'PTHR24056:SF359', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 244024),
(344797, 'PTHR24056:SF473', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344798, 'PTHR24056:SF474', NULL, NULL, NULL, NULL, 'BNACNNG19830D PROTEIN', 244024),
(344799, 'PTHR24056:SF111', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE-LIKE 5', 244024),
(344800, 'PTHR24056:SF233', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 9', 244024),
(344801, 'PTHR24056:SF476', NULL, NULL, NULL, NULL, 'BNAC05G48590D PROTEIN', 244024),
(344802, 'PTHR24056:SF472', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 4, ISOFORM A', 244024),
(344803, 'PTHR24056:SF171', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 20', 244024),
(344804, 'PTHR24056:SF327', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE', 244024),
(344805, 'PTHR24056:SF329', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344806, 'PTHR24056:SF565', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE', 244024),
(344807, 'PTHR24056:SF445', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344808, 'PTHR24056:SF446', NULL, NULL, NULL, NULL, 'BNAC08G13720D PROTEIN', 244024),
(344809, 'PTHR24056:SF440', NULL, NULL, NULL, NULL, 'ATP BINDING PROTEIN', 244024),
(344810, 'PTHR24056:SF561', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344811, 'PTHR24056:SF441', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 244024),
(344812, 'PTHR24056:SF562', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344813, 'PTHR24056:SF166', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 11.2', 244024),
(344814, 'PTHR24056:SF442', NULL, NULL, NULL, NULL, 'BNACNNG54190D PROTEIN', 244024),
(344815, 'PTHR24056:SF563', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344816, 'PTHR24056:SF443', NULL, NULL, NULL, NULL, 'BNAA06G23890D PROTEIN', 244024),
(344817, 'PTHR24056:SF564', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE', 244024),
(344818, 'PTHR24056:SF164', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 21', 244024),
(344819, 'PTHR24056:SF560', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344820, 'PTHR24056:SF0', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 7', 244024),
(344821, 'PTHR24056:SF459', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 13', 244024),
(344822, 'PTHR24056:SF219', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344823, 'PTHR24056:SF455', NULL, NULL, NULL, NULL, 'BNAANNG12030D PROTEIN', 244024),
(344824, 'PTHR24056:SF334', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 1', 244024),
(344825, 'PTHR24056:SF457', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344826, 'PTHR24056:SF458', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 244024);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(344827, 'PTHR24056:SF337', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE', 244024),
(344828, 'PTHR24056:SF176', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344829, 'PTHR24056:SF451', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344830, 'PTHR24056:SF177', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE-LIKE 3', 244024),
(344831, 'PTHR24056:SF211', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE C-3', 244024),
(344832, 'PTHR24056:SF453', NULL, NULL, NULL, NULL, 'BNACNNG29900D PROTEIN', 244024),
(344833, 'PTHR24056:SF178', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE B2-2', 244024),
(344834, 'PTHR24056:SF174', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 16', 244024),
(344835, 'PTHR24056:SF390', NULL, NULL, NULL, NULL, 'OS12G0427450 PROTEIN', 244024),
(344836, 'PTHR24056:SF46', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT-LIKE KINASE 5', 244024),
(344837, 'PTHR24056', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN KINASE', 244024),
(344838, 'PTHR24056:SF547', NULL, NULL, NULL, NULL, 'CYCLIN DEPENDENT KINASE LIKE 5 LONG', 244024),
(344839, 'PTHR24056:SF548', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE A-1', 244024),
(344840, 'PTHR24056:SF549', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE A-1', 244024),
(344841, 'PTHR24056:SF543', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT PROTEIN KINASE PHO85', 244024),
(344842, 'PTHR24056:SF544', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE C-2', 244024),
(344843, 'PTHR24056:SF545', NULL, NULL, NULL, NULL, 'PLASTID-LIPID-ASSOCIATED PROTEIN 14, CHLOROPLASTIC-RELATED', 244024),
(344844, 'PTHR24056:SF546', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 12', 244024),
(344845, 'PTHR24056:SF425', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344846, 'PTHR24056:SF385', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344847, 'PTHR24056:SF540', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344848, 'PTHR24056:SF387', NULL, NULL, NULL, NULL, 'F8L10.9 PROTEIN', 244024),
(344849, 'PTHR24056:SF541', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT SERINE/THREONINE-PROTEIN KINASE DDB_G0272797/DDB_G0274007-RELATED', 244024),
(344850, 'PTHR24056:SF542', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE G-2-LIKE ISOFORM X1', 244024),
(344851, 'PTHR24056:SF421', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344852, 'PTHR24056:SF384', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 244024),
(344853, 'PTHR24056:SF558', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE', 244024),
(344854, 'PTHR24056:SF559', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344855, 'PTHR24056:SF554', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE D-1', 244024),
(344856, 'PTHR24056:SF159', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 15', 244024),
(344857, 'PTHR24056:SF555', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344858, 'PTHR24056:SF556', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 11', 244024),
(344859, 'PTHR24056:SF557', NULL, NULL, NULL, NULL, 'OS01G0367700 PROTEIN', 244024),
(344860, 'PTHR24056:SF436', NULL, NULL, NULL, NULL, 'BNACNNG51050D PROTEIN', 244024),
(344861, 'PTHR24056:SF154', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 14', 244024),
(344862, 'PTHR24056:SF550', NULL, NULL, NULL, NULL, 'CMGC FAMILY PROTEIN KINASE', 244024),
(344863, 'PTHR24056:SF397', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344864, 'PTHR24056:SF551', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344865, 'PTHR24056:SF430', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 244024),
(344866, 'PTHR24056:SF552', NULL, NULL, NULL, NULL, 'CELL DIVISION CONTROL PROTEIN 2 HOMOLOG 4', 244024),
(344867, 'PTHR24056:SF553', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE D-3', 244024),
(344868, 'PTHR24056:SF432', NULL, NULL, NULL, NULL, 'OS10G0154500 PROTEIN', 244024);
INSERT INTO "PUBLIC"."MODEL" VALUES
(344869, 'PTHR24056:SF392', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN KINASE 7', 244024),
(344870, 'PTHR24056:SF393', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 244024),
(344871, 'PTHR24056:SF394', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244024),
(344872, 'PTHR24056:SF395', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE G-1', 244024),
(344873, 'PTHR13306', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244025),
(344874, 'PTHR13306:SF6', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 138', 244025),
(344875, 'PTHR37702:SF9', NULL, NULL, NULL, NULL, 'PROLINE-RICH FAMILY PROTEIN', 244026),
(344876, 'PTHR37702:SF7', NULL, NULL, NULL, NULL, 'EXTENSIN-1-LIKE', 244026),
(344877, 'PTHR37702:SF10', NULL, NULL, NULL, NULL, 'BNAC07G49330D PROTEIN', 244026),
(344878, 'PTHR37702:SF11', NULL, NULL, NULL, NULL, 'F3E22.11 PROTEIN', 244026),
(344879, 'PTHR37702:SF12', NULL, NULL, NULL, NULL, 'BNAA02G30680D PROTEIN', 244026),
(344880, 'PTHR37702:SF1', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 244026),
(344881, 'PTHR37702:SF13', NULL, NULL, NULL, NULL, 'BNAA09G03280D PROTEIN', 244026),
(344882, 'PTHR37702:SF14', NULL, NULL, NULL, NULL, 'BNAC08G48080D PROTEIN', 244026),
(344883, 'PTHR37702:SF16', NULL, NULL, NULL, NULL, 'OS01G0112000 PROTEIN', 244026),
(344884, 'PTHR37702', NULL, NULL, NULL, NULL, 'PROLINE-RICH FAMILY PROTEIN', 244026),
(344885, 'PTHR37702:SF17', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT EXTENSIN-LIKE PROTEIN 1', 244026),
(344886, 'PTHR37702:SF5', NULL, NULL, NULL, NULL, 'EXTENSIN-LIKE', 244026),
(344887, 'PTHR37702:SF4', NULL, NULL, NULL, NULL, 'BNAA09G30130D PROTEIN', 244026),
(344888, 'PTHR37702:SF2', NULL, NULL, NULL, NULL, 'OS09G0332100 PROTEIN', 244026),
(344889, 'PTHR47537:SF5', NULL, NULL, NULL, NULL, 'SOL-2 PROTEIN', 244027),
(344890, 'PTHR47537:SF6', NULL, NULL, NULL, NULL, 'LEV-10A PROTEIN', 244027),
(344891, 'PTHR47537', NULL, NULL, NULL, NULL, 'CUBILIN', 244027),
(344892, 'PTHR47537:SF8', NULL, NULL, NULL, NULL, 'CUB DOMAIN-CONTAINING PROTEIN', 244027),
(344893, 'PTHR47537:SF1', NULL, NULL, NULL, NULL, '', 244027),
(344894, 'PTHR47537:SF2', NULL, NULL, NULL, NULL, 'CUBILIN', 244027),
(344895, 'PTHR47537:SF3', NULL, NULL, NULL, NULL, 'CUB DOMAIN-CONTAINING PROTEIN', 244027),
(344896, 'PTHR47537:SF4', NULL, NULL, NULL, NULL, 'GH12701P', 244027),
(344897, 'PTHR40660', NULL, NULL, NULL, NULL, '', 244028),
(344898, 'PTHR40660:SF1', NULL, NULL, NULL, NULL, 'DOMAIN-CONTAINING PROTEIN-RELATED', 244028),
(344899, 'PTHR15184:SF9', NULL, NULL, NULL, NULL, 'FLAGELLUM-SPECIFIC ATP SYNTHASE', 244029),
(344900, 'PTHR15184:SF81', NULL, NULL, NULL, NULL, 'FLAGELLUM-SPECIFIC ATP SYNTHASE', 244029),
(344901, 'PTHR15184:SF80', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT BETA-1, MITOCHONDRIAL-RELATED', 244029),
(344902, 'PTHR15184:SF83', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT BETA', 244029),
(344903, 'PTHR15184', NULL, NULL, NULL, NULL, 'ATP SYNTHASE', 244029),
(344904, 'PTHR15184:SF82', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT BETA, MITOCHONDRIAL', 244029),
(344905, 'PTHR15184:SF71', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT BETA, MITOCHONDRIAL', 244029),
(344906, 'PTHR15184:SF74', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT BETA', 244029),
(344907, 'PTHR15184:SF84', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT BETA', 244029),
(344908, 'PTHR15184:SF51', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT BETA', 244029),
(344909, 'PTHR15184:SF62', NULL, NULL, NULL, NULL, 'SPI-2 TYPE 3 SECRETION SYSTEM ATPASE', 244029),
(344910, 'PTHR15184:SF76', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT BETA, CHLOROPLASTIC', 244029),
(344911, 'PTHR15184:SF75', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT BETA', 244029),
(344912, 'PTHR15184:SF78', NULL, NULL, NULL, NULL, 'H(+)-TRANSPORTING TWO-SECTOR ATPASE', 244029),
(344913, 'PTHR15184:SF77', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT BETA', 244029),
(344914, 'PTHR15184:SF69', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT BETA, CHLOROPLASTIC', 244029),
(344915, 'PTHR15184:SF79', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT BETA', 244029);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(344916, 'PTHR24098', NULL, NULL, NULL, NULL, 'OUTER SEGMENT 5', 244030),
(344917, 'PTHR24098:SF14', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 59', 244030),
(344918, 'PTHR24098:SF11', NULL, NULL, NULL, NULL, 'INTRAFLAGELLAR TRANSPORT PROTEIN 80 HOMOLOG', 244030),
(344919, 'PTHR24098:SF0', NULL, NULL, NULL, NULL, 'OUTER SEGMENT 5', 244030),
(344920, 'PTHR33735:SF9', NULL, NULL, NULL, NULL, 'OS04G0450600 PROTEIN', 244031),
(344921, 'PTHR33735:SF8', NULL, NULL, NULL, NULL, '', 244031),
(344922, 'PTHR33735:SF7', NULL, NULL, NULL, NULL, 'OS08G0483600 PROTEIN', 244031),
(344923, 'PTHR33735:SF2', NULL, NULL, NULL, NULL, 'OS09G0468900 PROTEIN', 244031),
(344924, 'PTHR33735:SF27', NULL, NULL, NULL, NULL, '', 244031),
(344925, 'PTHR33735:SF16', NULL, NULL, NULL, NULL, '', 244031),
(344926, 'PTHR33735:SF26', NULL, NULL, NULL, NULL, 'PTP-1', 244031),
(344927, 'PTHR33735:SF14', NULL, NULL, NULL, NULL, 'PHAGE CAPSID SCAFFOLDING PROTEIN (GPO) SERINE PEPTIDASE', 244031),
(344928, 'PTHR33735:SF25', NULL, NULL, NULL, NULL, '', 244031),
(344929, 'PTHR33735:SF24', NULL, NULL, NULL, NULL, '', 244031),
(344930, 'PTHR33735:SF13', NULL, NULL, NULL, NULL, 'PTERIN-BINDING DOMAIN-CONTAINING PROTEIN', 244031),
(344931, 'PTHR33735:SF12', NULL, NULL, NULL, NULL, '', 244031),
(344932, 'PTHR33735:SF23', NULL, NULL, NULL, NULL, '', 244031),
(344933, 'PTHR33735:SF10', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244031),
(344934, 'PTHR33735:SF20', NULL, NULL, NULL, NULL, '', 244031),
(344935, 'PTHR33735', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244031),
(344936, 'PTHR12756:SF9', NULL, NULL, NULL, NULL, 'CYTOSOLIC CARBOXYPEPTIDASE 6', 244032),
(344937, 'PTHR12756', NULL, NULL, NULL, NULL, 'CYTOSOLIC CARBOXYPEPTIDASE', 244032),
(344938, 'PTHR12756:SF4', NULL, NULL, NULL, NULL, '', 244032),
(344939, 'PTHR12756:SF5', NULL, NULL, NULL, NULL, 'CYTOSOLIC CARBOXYPEPTIDASE 4', 244032),
(344940, 'PTHR12756:SF41', NULL, NULL, NULL, NULL, 'CYTOSOLIC CARBOXYPEPTIDASE 2', 244032),
(344941, 'PTHR12756:SF23', NULL, NULL, NULL, NULL, 'CYTOSOLIC CARBOXYPEPTIDASE 3', 244032),
(344942, 'PTHR12756:SF45', NULL, NULL, NULL, NULL, 'CYTOSOLIC CARBOXYPEPTIDASE NNA1', 244032),
(344943, 'PTHR12756:SF12', NULL, NULL, NULL, NULL, 'CYTOSOLIC CARBOXYPEPTIDASE-LIKE PROTEIN 5', 244032),
(344944, 'PTHR12756:SF11', NULL, NULL, NULL, NULL, 'CYTOSOLIC CARBOXYPEPTIDASE 1', 244032),
(344945, 'PTHR12756:SF46', NULL, NULL, NULL, NULL, 'ATP/GTP-BINDING PROTEIN-LIKE 5', 244032),
(344946, 'PTHR12756:SF24', NULL, NULL, NULL, NULL, 'CYTOSOLIC CARBOXYPEPTIDASE 1', 244032),
(344947, 'PTHR37153:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 19 C19ORF81 HOMOLOG', 244033),
(344948, 'PTHR37153', NULL, NULL, NULL, NULL, 'CHROMOSOME 19 C19ORF81 HOMOLOG', 244033),
(344949, 'PTHR48043:SF130', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE', 244034),
(344950, 'PTHR48043:SF131', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE', 244034),
(344951, 'PTHR48043:SF60', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE', 244034),
(344952, 'PTHR48043:SF64', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE', 244034),
(344953, 'PTHR48043:SF63', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE', 244034),
(344954, 'PTHR48043:SF62', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE', 244034),
(344955, 'PTHR48043:SF129', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE 2A2', 244034),
(344956, 'PTHR48043:SF24', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE 3A2', 244034),
(344957, 'PTHR48043:SF68', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE', 244034),
(344958, 'PTHR48043:SF23', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE', 244034),
(344959, 'PTHR48043:SF22', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE', 244034),
(344960, 'PTHR48043:SF27', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE', 244034),
(344961, 'PTHR48043:SF26', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE', 244034),
(344962, 'PTHR48043:SF127', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE', 244034),
(344963, 'PTHR48043:SF8', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE', 244034);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(344964, 'PTHR48043:SF9', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE', 244034),
(344965, 'PTHR48043:SF120', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE', 244034),
(344966, 'PTHR48043:SF71', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE', 244034),
(344967, 'PTHR48043:SF4', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE', 244034),
(344968, 'PTHR48043:SF5', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE UGT-58-RELATED', 244034),
(344969, 'PTHR48043:SF76', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE', 244034),
(344970, 'PTHR48043:SF32', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE', 244034),
(344971, 'PTHR48043:SF3', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE', 244034),
(344972, 'PTHR48043:SF1', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE UGT-48-RELATED', 244034),
(344973, 'PTHR48043:SF73', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE', 244034),
(344974, 'PTHR48043:SF36', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE', 244034),
(344975, 'PTHR48043:SF119', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE', 244034),
(344976, 'PTHR48043:SF78', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE 2A1-LIKE', 244034),
(344977, 'PTHR48043:SF34', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE UGT-55-RELATED', 244034),
(344978, 'PTHR48043:SF33', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE', 244034),
(344979, 'PTHR48043:SF77', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE', 244034),
(344980, 'PTHR48043:SF39', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE', 244034),
(344981, 'PTHR48043', NULL, NULL, NULL, NULL, 'EG:EG0003.4 PROTEIN-RELATED', 244034),
(344982, 'PTHR48043:SF154', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE', 244034),
(344983, 'PTHR48043:SF155', NULL, NULL, NULL, NULL, 'KH AND NYN DOMAIN-CONTAINING', 244034),
(344984, 'PTHR48043:SF112', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE 3A1', 244034),
(344985, 'PTHR48043:SF113', NULL, NULL, NULL, NULL, 'UDP GLUCURONOSYLTRANSFERASE 2 FAMILY, POLYPEPTIDE B38-RELATED', 244034),
(344986, 'PTHR48043:SF114', NULL, NULL, NULL, NULL, 'IP04436P-RELATED', 244034),
(344987, 'PTHR48043:SF116', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE', 244034),
(344988, 'PTHR48043:SF150', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE', 244034),
(344989, 'PTHR48043:SF151', NULL, NULL, NULL, NULL, 'ERYTHRITOL-MANNOSYL-TRANSFERASE 1', 244034),
(344990, 'PTHR48043:SF152', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE', 244034),
(344991, 'PTHR48043:SF153', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE', 244034),
(344992, 'PTHR48043:SF83', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE', 244034),
(344993, 'PTHR48043:SF82', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE', 244034),
(344994, 'PTHR48043:SF87', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE 2B7', 244034),
(344995, 'PTHR48043:SF86', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE 2B10-RELATED', 244034),
(344996, 'PTHR48043:SF42', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE', 244034),
(344997, 'PTHR48043:SF41', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE', 244034),
(344998, 'PTHR48043:SF85', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE UGT-46-RELATED', 244034),
(344999, 'PTHR48043:SF84', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE', 244034),
(345000, 'PTHR48043:SF40', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE', 244034),
(345001, 'PTHR48043:SF47', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE 2A3', 244034),
(345002, 'PTHR48043:SF46', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE UGT-60-RELATED', 244034),
(345003, 'PTHR48043:SF45', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE', 244034),
(345004, 'PTHR48043:SF89', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE', 244034),
(345005, 'PTHR48043:SF109', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE UGT-50-RELATED', 244034),
(345006, 'PTHR48043:SF48', NULL, NULL, NULL, NULL, 'UDP GLUCURONOSYLTRANSFERASE 5 FAMILY, POLYPEPTIDE C2-RELATED', 244034),
(345007, 'PTHR48043:SF143', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE', 244034); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(345008, 'PTHR48043:SF144', NULL, NULL, NULL, NULL, 'MACROLIDE GLYCOSYLTRANSFERASE', 244034),
(345009, 'PTHR48043:SF100', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE', 244034),
(345010, 'PTHR48043:SF145', NULL, NULL, NULL, NULL, 'EG:EG0003.4 PROTEIN-RELATED', 244034),
(345011, 'PTHR48043:SF146', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 244034),
(345012, 'PTHR48043:SF103', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE', 244034),
(345013, 'PTHR48043:SF147', NULL, NULL, NULL, NULL, 'UDP GLUCURONOSYLTRANSFERASE 1 FAMILY, POLYPEPTIDE A7', 244034),
(345014, 'PTHR48043:SF148', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 244034),
(345015, 'PTHR48043:SF104', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE', 244034),
(345016, 'PTHR48043:SF149', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE UGT-56-RELATED', 244034),
(345017, 'PTHR48043:SF105', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE', 244034),
(345018, 'PTHR48043:SF140', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE 2A1', 244034),
(345019, 'PTHR48043:SF50', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE', 244034),
(345020, 'PTHR48043:SF54', NULL, NULL, NULL, NULL, '2-HYDROXYACYLSPHINGOSINE 1-BETA-GALACTOSYLTRANSFERASE', 244034),
(345021, 'PTHR48043:SF98', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE', 244034),
(345022, 'PTHR48043:SF97', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE', 244034),
(345023, 'PTHR48043:SF52', NULL, NULL, NULL, NULL, 'UDP GLUCURONOSYLTRANSFERASE 5 FAMILY, POLYPEPTIDE B3-RELATED', 244034),
(345024, 'PTHR48043:SF95', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE', 244034),
(345025, 'PTHR48043:SF51', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE', 244034),
(345026, 'PTHR48043:SF14', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE-RELATED', 244034),
(345027, 'PTHR48043:SF58', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE 2B15', 244034),
(345028, 'PTHR48043:SF13', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE UGT-47-RELATED', 244034),
(345029, 'PTHR48043:SF12', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE 2B17-RELATED', 244034),
(345030, 'PTHR48043:SF55', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE', 244034),
(345031, 'PTHR48043:SF11', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE', 244034),
(345032, 'PTHR48043:SF18', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE', 244034),
(345033, 'PTHR48043:SF17', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE', 244034),
(345034, 'PTHR48043:SF137', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE 2A3', 244034),
(345035, 'PTHR12747:SF0', NULL, NULL, NULL, NULL, 'ELONGATOR COMPLEX PROTEIN 1', 244035),
(345036, 'PTHR12747', NULL, NULL, NULL, NULL, 'ELONGATOR COMPLEX PROTEIN 1', 244035),
(345037, 'PTHR36965', NULL, NULL, NULL, NULL, 'FE(2+)-TRAFFICKING PROTEIN-RELATED', 244036),
(345038, 'PTHR36965:SF1', NULL, NULL, NULL, NULL, 'FE(2+)-TRAFFICKING PROTEIN-RELATED', 244036),
(345039, 'PTHR31667', NULL, NULL, NULL, NULL, 'SPERM EQUATORIAL SEGMENT PROTEIN 1', 244037),
(345040, 'PTHR31667:SF2', NULL, NULL, NULL, NULL, 'SPERM EQUATORIAL SEGMENT PROTEIN 1', 244037),
(345041, 'PTHR47935', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN MRL1, CHLOROPLASTIC', 244038),
(345042, 'PTHR47935:SF1', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN MRL1, CHLOROPLASTIC', 244038),
(345043, 'PTHR16433:SF0', NULL, NULL, NULL, NULL, 'DOLICHOL-PHOSPHATE MANNOSYLTRANSFERASE SUBUNIT 3', 244039),
(345044, 'PTHR16433', NULL, NULL, NULL, NULL, 'DOLICHOL-PHOSPHATE MANNOSYLTRANSFERASE SUBUNIT 3', 244039),
(345045, 'PTHR43799', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE, PUTATIVE-RELATED', 244040),
(345046, 'PTHR43799:SF1', NULL, NULL, NULL, NULL, 'ASPARTATE AMINOTRANSFERASE', 244040),
(345047, 'PTHR45912', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 47', 244041),
(345048, 'PTHR45912:SF3', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 47', 244041),
(345049, 'PTHR31853', NULL, NULL, NULL, NULL, 'PSORIASIS SUSCEPTIBILITY 1 CANDIDATE GENE 2 PROTEIN', 244042);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(345050, 'PTHR31853:SF1', NULL, NULL, NULL, NULL, 'PSORIASIS SUSCEPTIBILITY 1 CANDIDATE GENE 2 PROTEIN', 244042),
(345051, 'PTHR45692', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F2_4 DOMAIN-CONTAINING PROTEIN', 244043),
(345052, 'PTHR45692:SF1', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F2_4 DOMAIN-CONTAINING PROTEIN', 244043),
(345053, 'PTHR10943:SF1', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 2', 244044),
(345054, 'PTHR10943:SF19', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 1 HOMOLOG', 244044),
(345055, 'PTHR10943:SF17', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 2 HOMOLOG', 244044),
(345056, 'PTHR10943', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT', 244044),
(345057, 'PTHR10943:SF18', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 1 HOMOLOG', 244044),
(345058, 'PTHR10943:SF15', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 2', 244044),
(345059, 'PTHR10943:SF13', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 1 HOMOLOG', 244044),
(345060, 'PTHR10943:SF24', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 2 HOMOLOG B', 244044),
(345061, 'PTHR10943:SF22', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 2 HOMOLOG', 244044),
(345062, 'PTHR10943:SF11', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 2', 244044),
(345063, 'PTHR10943:SF12', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 2 HOMOLOG', 244044),
(345064, 'PTHR10943:SF2', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 1', 244044),
(345065, 'PTHR45784:SF3', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN-RELATED', 244045),
(345066, 'PTHR45784:SF5', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 20 MEMBER A-RELATED', 244045),
(345067, 'PTHR45784:SF7', NULL, NULL, NULL, NULL, 'NOVEL IMMUNE-TYPE RECEPTOR 3,-RELATED 1-LIKE-RELATED', 244045),
(345068, 'PTHR45784', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 20 MEMBER A-RELATED', 244045),
(345069, 'PTHR42788:SF12', NULL, NULL, NULL, NULL, 'ATP-BINDING COMPONENT OF ABC TRANSPORTER-RELATED', 244046),
(345070, 'PTHR42788:SF20', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN', 244046),
(345071, 'PTHR42788:SF21', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN', 244046),
(345072, 'PTHR42788:SF10', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN', 244046),
(345073, 'PTHR42788:SF13', NULL, NULL, NULL, NULL, 'ALIPHATIC SULFONATES IMPORT ATP-BINDING PROTEIN SSUB', 244046),
(345074, 'PTHR42788:SF19', NULL, NULL, NULL, NULL, 'ALIPHATIC SULFONATES IMPORT ATP-BINDING PROTEIN SSUB 2', 244046),
(345075, 'PTHR42788:SF7', NULL, NULL, NULL, NULL, 'NITRATE ABC TRANSPORTER ATP-BINDING PROTEIN', 244046),
(345076, 'PTHR42788:SF17', NULL, NULL, NULL, NULL, 'ALIPHATIC SULFONATES IMPORT ATP-BINDING PROTEIN SSUB', 244046),
(345077, 'PTHR42788:SF18', NULL, NULL, NULL, NULL, 'TAURINE IMPORT ATP-BINDING PROTEIN TAUB', 244046),
(345078, 'PTHR42788', NULL, NULL, NULL, NULL, 'TAURINE IMPORT ATP-BINDING PROTEIN-RELATED', 244046),
(345079, 'PTHR42788:SF2', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN', 244046),
(345080, 'PTHR12471:SF3', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT S1-LIKE PROTEIN', 244047),
(345081, 'PTHR12471:SF2', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT S1', 244047),
(345082, 'PTHR12471', NULL, NULL, NULL, NULL, 'VACUOLAR ATP SYNTHASE SUBUNIT S1', 244047),
(345083, 'PTHR12471:SF4', NULL, NULL, NULL, NULL, 'AGAP001624-PA', 244047),
(345084, 'PTHR12471:SF7', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT S1', 244047),
(345085, 'PTHR12471:SF6', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT S1', 244047),
(345086, 'PTHR36029:SF1', NULL, NULL, NULL, NULL, 'PROTEIN TPLATE', 244048),
(345087, 'PTHR36029', NULL, NULL, NULL, NULL, 'TSET COMPLEX MEMBER TSTA', 244048),
(345088, 'PTHR47773:SF1', NULL, NULL, NULL, NULL, 'HEH DOMAIN-CONTAINING PROTEIN', 244049);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(345089, 'PTHR47773', NULL, NULL, NULL, NULL, 'SI:DKEY-9I5.2-RELATED', 244049),
(345090, 'PTHR24020:SF49', NULL, NULL, NULL, NULL, 'COLLAGEN, TYPE XXVIII, ALPHA 2A', 244050),
(345091, 'PTHR24020:SF16', NULL, NULL, NULL, NULL, 'CARTILAGE MATRIX PROTEIN', 244050),
(345092, 'PTHR24020:SF17', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(XII) CHAIN', 244050),
(345093, 'PTHR24020:SF39', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(XX) CHAIN', 244050),
(345094, 'PTHR24020:SF29', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-2(VI) CHAIN', 244050),
(345095, 'PTHR24020:SF18', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(VI) CHAIN', 244050),
(345096, 'PTHR24020:SF78', NULL, NULL, NULL, NULL, 'SI:CH211-106N13.3-RELATED', 244050),
(345097, 'PTHR24020:SF23', NULL, NULL, NULL, NULL, 'VITRIN', 244050),
(345098, 'PTHR24020:SF12', NULL, NULL, NULL, NULL, 'MATRILIN-3', 244050),
(345099, 'PTHR24020:SF35', NULL, NULL, NULL, NULL, 'MATRILIN-2', 244050),
(345100, 'PTHR24020:SF13', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-3(VI) CHAIN', 244050),
(345101, 'PTHR24020:SF36', NULL, NULL, NULL, NULL, 'COCHLIN', 244050),
(345102, 'PTHR24020:SF14', NULL, NULL, NULL, NULL, 'MATRILIN-4', 244050),
(345103, 'PTHR24020:SF15', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(XIV) CHAIN', 244050),
(345104, 'PTHR24020:SF37', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR A DOMAIN-CONTAINING PROTEIN 2', 244050),
(345105, 'PTHR24020', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA', 244050),
(345106, 'PTHR24020:SF74', NULL, NULL, NULL, NULL, '', 244050),
(345107, 'PTHR24020:SF20', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(XXI) CHAIN', 244050),
(345108, 'PTHR24020:SF76', NULL, NULL, NULL, NULL, 'COLLAGEN TYPE VI ALPHA 6 CHAIN', 244050),
(345109, 'PTHR24020:SF77', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR A DOMAIN-CONTAINING PROTEIN 1', 244050),
(345110, 'PTHR24020:SF81', NULL, NULL, NULL, NULL, 'COLLAGEN, TYPE XXI, ALPHA 1', 244050),
(345111, 'PTHR24020:SF70', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 244050),
(345112, 'PTHR24020:SF82', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 244050),
(345113, 'PTHR24020:SF83', NULL, NULL, NULL, NULL, 'COLLAGEN TYPE VII ALPHA 1-LIKE', 244050),
(345114, 'PTHR12186:SF3', NULL, NULL, NULL, NULL, 'FGFR1 ONCOGENE PARTNER 2', 244051),
(345115, 'PTHR12186:SF4', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF IKBKE 1', 244051),
(345116, 'PTHR12186:SF2', NULL, NULL, NULL, NULL, 'FGFR1 ONCOGENE PARTNER 2 HOMOLOG', 244051),
(345117, 'PTHR12186', NULL, NULL, NULL, NULL, 'SIKE FAMILY MEMBER', 244051),
(345118, 'PTHR31867:SF166', NULL, NULL, NULL, NULL, 'EXPANSIN-A4', 244052),
(345119, 'PTHR31867:SF201', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345120, 'PTHR31867:SF169', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345121, 'PTHR31867:SF77', NULL, NULL, NULL, NULL, 'EXPANSIN-A28', 244052),
(345122, 'PTHR31867:SF202', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345123, 'PTHR31867:SF207', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345124, 'PTHR31867:SF208', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345125, 'PTHR31867:SF209', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345126, 'PTHR31867:SF85', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345127, 'PTHR31867:SF86', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345128, 'PTHR31867:SF160', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345129, 'PTHR31867:SF161', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345130, 'PTHR31867:SF162', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345131, 'PTHR31867:SF82', NULL, NULL, NULL, NULL, 'EXPANSIN-A26', 244052),
(345132, 'PTHR31867:SF83', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345133, 'PTHR31867:SF177', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345134, 'PTHR31867:SF211', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345135, 'PTHR31867:SF178', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345136, 'PTHR31867:SF89', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345137, 'PTHR31867:SF217', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345138, 'PTHR31867:SF218', NULL, NULL, NULL, NULL, 'EXPANSIN-A8', 244052);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(345139, 'PTHR31867:SF96', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345140, 'PTHR31867:SF170', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345141, 'PTHR31867:SF171', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345142, 'PTHR31867:SF92', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345143, 'PTHR31867:SF175', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345144, 'PTHR31867:SF144', NULL, NULL, NULL, NULL, 'EXPANSIN-A5', 244052),
(345145, 'PTHR31867:SF149', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345146, 'PTHR31867', NULL, NULL, NULL, NULL, 'EXPANSIN-A15', 244052),
(345147, 'PTHR31867:SF140', NULL, NULL, NULL, NULL, 'EXPANSIN-A24', 244052),
(345148, 'PTHR31867:SF141', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345149, 'PTHR31867:SF158', NULL, NULL, NULL, NULL, 'EXPANSIN-A16', 244052),
(345150, 'PTHR31867:SF150', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345151, 'PTHR31867:SF151', NULL, NULL, NULL, NULL, 'EXPANSIN-A3', 244052),
(345152, 'PTHR31867:SF152', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345153, 'PTHR31867:SF72', NULL, NULL, NULL, NULL, 'EXPANSIN-A2', 244052),
(345154, 'PTHR31867:SF242', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345155, 'PTHR31867:SF243', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345156, 'PTHR31867:SF244', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345157, 'PTHR31867:SF245', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345158, 'PTHR31867:SF124', NULL, NULL, NULL, NULL, 'EXPANSIN-A12', 244052),
(345159, 'PTHR31867:SF246', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345160, 'PTHR31867:SF126', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345161, 'PTHR31867:SF247', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345162, 'PTHR31867:SF248', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345163, 'PTHR31867:SF127', NULL, NULL, NULL, NULL, 'EXPANSIN-A9', 244052),
(345164, 'PTHR31867:SF35', NULL, NULL, NULL, NULL, 'EXPANSIN-A15', 244052),
(345165, 'PTHR31867:SF249', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345166, 'PTHR31867:SF129', NULL, NULL, NULL, NULL, 'EXPANSIN-A17-RELATED', 244052),
(345167, 'PTHR31867:SF40', NULL, NULL, NULL, NULL, 'EXPANSIN-A20', 244052),
(345168, 'PTHR31867:SF240', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345169, 'PTHR31867:SF241', NULL, NULL, NULL, NULL, 'EXPANSIN-A2', 244052),
(345170, 'PTHR31867:SF120', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345171, 'PTHR31867:SF253', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345172, 'PTHR31867:SF132', NULL, NULL, NULL, NULL, 'EXPANSIN-A21-RELATED', 244052),
(345173, 'PTHR31867:SF4', NULL, NULL, NULL, NULL, 'EXPANSIN-A11', 244052),
(345174, 'PTHR31867:SF254', NULL, NULL, NULL, NULL, 'EXPANSIN-A6', 244052),
(345175, 'PTHR31867:SF133', NULL, NULL, NULL, NULL, 'EXPANSIN-A29', 244052),
(345176, 'PTHR31867:SF3', NULL, NULL, NULL, NULL, 'EXPANSIN-A13', 244052),
(345177, 'PTHR31867:SF139', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345178, 'PTHR31867:SF2', NULL, NULL, NULL, NULL, 'EXPANSIN-A18', 244052),
(345179, 'PTHR31867:SF250', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345180, 'PTHR31867:SF251', NULL, NULL, NULL, NULL, 'EXPANSIN-A7', 244052),
(345181, 'PTHR31867:SF252', NULL, NULL, NULL, NULL, 'EXPANSIN-A6', 244052),
(345182, 'PTHR31867:SF15', NULL, NULL, NULL, NULL, 'EXPANSIN-A9', 244052),
(345183, 'PTHR31867:SF220', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345184, 'PTHR31867:SF187', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345185, 'PTHR31867:SF188', NULL, NULL, NULL, NULL, 'EXPANSIN-A10', 244052),
(345186, 'PTHR31867:SF17', NULL, NULL, NULL, NULL, 'EXPANSIN-A25', 244052),
(345187, 'PTHR31867:SF222', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345188, 'PTHR31867:SF18', NULL, NULL, NULL, NULL, 'EXPANSIN-A13', 244052),
(345189, 'PTHR31867:SF102', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345190, 'PTHR31867:SF223', NULL, NULL, NULL, NULL, 'EXPANSIN-A11', 244052),
(345191, 'PTHR31867:SF99', NULL, NULL, NULL, NULL, 'EXPANSIN-A20', 244052),
(345192, 'PTHR31867:SF225', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345193, 'PTHR31867:SF104', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(345194, 'PTHR31867:SF226', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345195, 'PTHR31867:SF14', NULL, NULL, NULL, NULL, 'EXPANSIN-A31', 244052),
(345196, 'PTHR31867:SF227', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345197, 'PTHR31867:SF228', NULL, NULL, NULL, NULL, 'EXPANSIN-A3', 244052),
(345198, 'PTHR31867:SF229', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345199, 'PTHR31867:SF108', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345200, 'PTHR31867:SF109', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345201, 'PTHR31867:SF180', NULL, NULL, NULL, NULL, 'EXPANSIN-A8', 244052),
(345202, 'PTHR31867:SF20', NULL, NULL, NULL, NULL, 'EXPANSIN-A15', 244052),
(345203, 'PTHR31867:SF184', NULL, NULL, NULL, NULL, 'EXPANSIN-A24', 244052),
(345204, 'PTHR31867:SF185', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345205, 'PTHR31867:SF186', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345206, 'PTHR31867:SF231', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345207, 'PTHR31867:SF232', NULL, NULL, NULL, NULL, 'EXPANSIN-A1', 244052),
(345208, 'PTHR31867:SF199', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345209, 'PTHR31867:SF233', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345210, 'PTHR31867:SF234', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345211, 'PTHR31867:SF113', NULL, NULL, NULL, NULL, 'EXPANSIN-A32', 244052),
(345212, 'PTHR31867:SF235', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345213, 'PTHR31867:SF236', NULL, NULL, NULL, NULL, 'EXPANSIN-A21', 244052),
(345214, 'PTHR31867:SF23', NULL, NULL, NULL, NULL, 'EXPANSIN-A12', 244052),
(345215, 'PTHR31867:SF237', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345216, 'PTHR31867:SF117', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345217, 'PTHR31867:SF25', NULL, NULL, NULL, NULL, 'EXPANSIN-A17', 244052),
(345218, 'PTHR31867:SF238', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345219, 'PTHR31867:SF239', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345220, 'PTHR31867:SF118', NULL, NULL, NULL, NULL, 'EXPANSIN-A14', 244052),
(345221, 'PTHR31867:SF190', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345222, 'PTHR31867:SF191', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345223, 'PTHR31867:SF192', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345224, 'PTHR31867:SF193', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345225, 'PTHR31867:SF230', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345226, 'PTHR31867:SF197', NULL, NULL, NULL, NULL, 'EXPANSIN', 244052),
(345227, 'PTHR12358:SF39', NULL, NULL, NULL, NULL, 'OS04G0541500 PROTEIN', 244053),
(345228, 'PTHR12358:SF37', NULL, NULL, NULL, NULL, 'OS08G0152700 PROTEIN', 244053),
(345229, 'PTHR12358:SF110', NULL, NULL, NULL, NULL, 'SPHINGOSINE KINASE RELATED PROTEIN', 244053),
(345230, 'PTHR12358:SF31', NULL, NULL, NULL, NULL, 'LD11247P-RELATED', 244053),
(345231, 'PTHR12358:SF54', NULL, NULL, NULL, NULL, 'ACYLGLYCEROL KINASE, MITOCHONDRIAL', 244053),
(345232, 'PTHR12358:SF95', NULL, NULL, NULL, NULL, 'ZGC:158263', 244053),
(345233, 'PTHR12358:SF93', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE, CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 244053),
(345234, 'PTHR12358:SF109', NULL, NULL, NULL, NULL, 'SPHINGOSINE KINASE 1-RELATED', 244053),
(345235, 'PTHR12358:SF108', NULL, NULL, NULL, NULL, 'DAGKC DOMAIN-CONTAINING PROTEIN', 244053),
(345236, 'PTHR12358:SF107', NULL, NULL, NULL, NULL, 'LIPID KINASE BMRU-RELATED', 244053),
(345237, 'PTHR12358:SF106', NULL, NULL, NULL, NULL, 'LIPID KINASE YEGS', 244053),
(345238, 'PTHR12358:SF105', NULL, NULL, NULL, NULL, 'DAGKC DOMAIN-CONTAINING PROTEIN', 244053),
(345239, 'PTHR12358:SF104', NULL, NULL, NULL, NULL, 'DAGKC DOMAIN-CONTAINING PROTEIN', 244053),
(345240, 'PTHR12358:SF103', NULL, NULL, NULL, NULL, 'SPHINGOSINE KINASE B', 244053),
(345241, 'PTHR12358:SF102', NULL, NULL, NULL, NULL, 'SPHINGOSINE KINASE 1-LIKE ISOFORM X1', 244053),
(345242, 'PTHR12358:SF101', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM54', 244053),
(345243, 'PTHR12358:SF26', NULL, NULL, NULL, NULL, 'CERAMIDE KINASE-LIKE PROTEIN', 244053),
(345244, 'PTHR12358:SF47', NULL, NULL, NULL, NULL, 'SPHINGOSINE KINASE 1', 244053);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(345245, 'PTHR12358:SF25', NULL, NULL, NULL, NULL, 'CERAMIDE KINASE', 244053),
(345246, 'PTHR12358:SF88', NULL, NULL, NULL, NULL, 'SPHINGOSINE KINASE 1', 244053),
(345247, 'PTHR12358:SF6', NULL, NULL, NULL, NULL, 'CERAMIDE KINASE, ISOFORM A', 244053),
(345248, 'PTHR12358:SF89', NULL, NULL, NULL, NULL, 'DAGKC DOMAIN-CONTAINING PROTEIN', 244053),
(345249, 'PTHR12358', NULL, NULL, NULL, NULL, 'SPHINGOSINE KINASE', 244053),
(345250, 'PTHR12358:SF86', NULL, NULL, NULL, NULL, 'ACYLGLYCEROL KINASE, MITOCHONDRIAL', 244053),
(345251, 'PTHR12358:SF40', NULL, NULL, NULL, NULL, 'SPHINGOSINE KINASE 2', 244053),
(345252, 'PTHR36083', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L32, CHLOROPLASTIC', 244054),
(345253, 'PTHR36083:SF1', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L32, CHLOROPLASTIC', 244054),
(345254, 'PTHR37973:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG11275', 244055),
(345255, 'PTHR37973:SF1', NULL, NULL, NULL, NULL, 'CHONDROITIN PROTEOGLYCAN 3', 244055),
(345256, 'PTHR37973', NULL, NULL, NULL, NULL, 'CHONDROITIN PROTEOGLYCAN 3', 244055),
(345257, 'PTHR34212:SF5', NULL, NULL, NULL, NULL, 'BNAC03G74770D PROTEIN', 244056),
(345258, 'PTHR34212:SF2', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 8', 244056),
(345259, 'PTHR34212:SF1', NULL, NULL, NULL, NULL, 'OS06G0106900 PROTEIN', 244056),
(345260, 'PTHR34212', NULL, NULL, NULL, NULL, 'OS02G0104200 PROTEIN', 244056),
(345261, 'PTHR34212:SF4', NULL, NULL, NULL, NULL, '', 244056),
(345262, 'PTHR34212:SF3', NULL, NULL, NULL, NULL, '', 244056),
(345263, 'PTHR28494', NULL, NULL, NULL, NULL, 'UPF0600 PROTEIN C5ORF51', 244057),
(345264, 'PTHR28494:SF1', NULL, NULL, NULL, NULL, 'UPF0600 PROTEIN C5ORF51', 244057),
(345265, 'PTHR46659', NULL, NULL, NULL, NULL, 'SERINE/THREONINE/TYROSINE-INTERACTING-LIKE PROTEIN 1', 244058),
(345266, 'PTHR46659:SF1', NULL, NULL, NULL, NULL, 'SERINE/THREONINE/TYROSINE-INTERACTING-LIKE PROTEIN 1', 244058),
(345267, 'PTHR13572:SF4', NULL, NULL, NULL, NULL, 'RE57134P', 244059),
(345268, 'PTHR13572', NULL, NULL, NULL, NULL, 'ENDO-ALPHA-1,2-MANNOSIDASE', 244059),
(345269, 'PTHR13572:SF2', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN ENDO-ALPHA-1,2-MANNOSIDASE-LIKE PROTEIN', 244059),
(345270, 'PTHR13572:SF1', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN ENDO-ALPHA-1,2-MANNOSIDASE', 244059),
(345271, 'PTHR40115:SF1', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN WITH PEPSY TM HELIX', 244060),
(345272, 'PTHR40115', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN WITH PEPSY TM HELIX', 244060),
(345273, 'PTHR39150:SF1', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN L28, MITOCHONDRIAL', 244061),
(345274, 'PTHR39150', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN L28, MITOCHONDRIAL', 244061),
(345275, 'PTHR34679', NULL, NULL, NULL, NULL, '', 244062),
(345276, 'PTHR34679:SF2', NULL, NULL, NULL, NULL, 'OS02G0122500 PROTEIN', 244062),
(345277, 'PTHR47544:SF1', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR (GEF) 4', 244063),
(345278, 'PTHR47544', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 4', 244063),
(345279, 'PTHR45656:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBR-CLEC-78', 244064),
(345280, 'PTHR45656:SF3', NULL, NULL, NULL, NULL, 'CUB AND SUSHI DOMAIN-CONTAINING PROTEIN 1', 244064),
(345281, 'PTHR45656', NULL, NULL, NULL, NULL, 'PROTEIN CBR-CLEC-78', 244064),
(345282, 'PTHR45656:SF2', NULL, NULL, NULL, NULL, 'SEIZURE 6-LIKE PROTEIN 2', 244064),
(345283, 'PTHR45656:SF1', NULL, NULL, NULL, NULL, 'SEIZURE PROTEIN 6 HOMOLOG', 244064),
(345284, 'PTHR45656:SF13', NULL, NULL, NULL, NULL, 'CD55 MOLECULE', 244064),
(345285, 'PTHR45656:SF11', NULL, NULL, NULL, NULL, 'CUBILIN', 244064),
(345286, 'PTHR45656:SF9', NULL, NULL, NULL, NULL, 'CUB AND SUSHI DOMAIN-CONTAINING PROTEIN 3', 244064),
(345287, 'PTHR45656:SF8', NULL, NULL, NULL, NULL, 'SEIZURE 6-LIKE PROTEIN', 244064),
(345288, 'PTHR45656:SF6', NULL, NULL, NULL, NULL, 'CUB AND SUSHI DOMAIN-CONTAINING PROTEIN 2', 244064),
(345289, 'PTHR36068:SF1', NULL, NULL, NULL, NULL, 'OS01G0102500 PROTEIN', 244065),
(345290, 'PTHR36068', NULL, NULL, NULL, NULL, 'OS01G0102500 PROTEIN', 244065);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(345291, 'PTHR10166:SF63', NULL, NULL, NULL, NULL, 'STRAIGHTJACKET, ISOFORM C', 244066),
(345292, 'PTHR10166:SF64', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL UNC-36', 244066),
(345293, 'PTHR10166:SF31', NULL, NULL, NULL, NULL, 'CA[2+] CHANNEL MUSCLE-SPECIFIC ALPHA2/DELTA SUBUNIT, ISOFORM A', 244066),
(345294, 'PTHR10166:SF65', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 244066),
(345295, 'PTHR10166', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL SUBUNIT ALPHA-2/DELTA-RELATED', 244066),
(345296, 'PTHR10166:SF43', NULL, NULL, NULL, NULL, 'VWA_N DOMAIN-CONTAINING PROTEIN', 244066),
(345297, 'PTHR10166:SF56', NULL, NULL, NULL, NULL, 'CALCIUM CHANNEL, VOLTAGE-DEPENDENT, ALPHA2/DELTA SUBUNIT 3', 244066),
(345298, 'PTHR10166:SF25', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL SUBUNIT ALPHA-2/DELTA-3', 244066),
(345299, 'PTHR10166:SF7', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL SUBUNIT ALPHA-2/DELTA-2', 244066),
(345300, 'PTHR10166:SF37', NULL, NULL, NULL, NULL, 'VWFA AND CACHE DOMAIN-CONTAINING PROTEIN 1', 244066),
(345301, 'PTHR10166:SF59', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL SUBUNIT ALPHA-2/DELTA-4', 244066),
(345302, 'PTHR10166:SF6', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL SUBUNIT ALPHA-2/DELTA-1', 244066),
(345303, 'PTHR36064', NULL, NULL, NULL, NULL, 'EMBRYO DEFECTIVE 2735', 244067),
(345304, 'PTHR36064:SF3', NULL, NULL, NULL, NULL, 'BNAA03G01950D PROTEIN', 244067),
(345305, 'PTHR36064:SF1', NULL, NULL, NULL, NULL, 'EMBRYO DEFECTIVE 2735', 244067),
(345306, 'PTHR43296:SF2', NULL, NULL, NULL, NULL, 'PEROXISOMAL 2,4-DIENOYL-COA REDUCTASE [(3E)-ENOYL-COA-PRODUCING]', 244068),
(345307, 'PTHR43296:SF10', NULL, NULL, NULL, NULL, 'PEROXISOMAL 2,4-DIENOYL-COA REDUCTASE-LIKE', 244068),
(345308, 'PTHR43296', NULL, NULL, NULL, NULL, 'PEROXISOMAL 2,4-DIENOYL-COA REDUCTASE', 244068),
(345309, 'PTHR43296:SF7', NULL, NULL, NULL, NULL, 'BNAA05G26380D PROTEIN', 244068),
(345310, 'PTHR43296:SF6', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 244068),
(345311, 'PTHR47744', NULL, NULL, NULL, NULL, 'OS05G0526300 PROTEIN', 244069),
(345312, 'PTHR47744:SF1', NULL, NULL, NULL, NULL, 'OS05G0526300 PROTEIN', 244069),
(345313, 'PTHR21403', NULL, NULL, NULL, NULL, 'ATP PHOSPHORIBOSYLTRANSFERASE  ATP-PRTASE', 244070),
(345314, 'PTHR21403:SF9', NULL, NULL, NULL, NULL, 'ATP PHOSPHORIBOSYLTRANSFERASE', 244070),
(345315, 'PTHR21403:SF8', NULL, NULL, NULL, NULL, 'ATP PHOSPHORIBOSYLTRANSFERASE', 244070),
(345316, 'PTHR21403:SF7', NULL, NULL, NULL, NULL, 'ATP PHOSPHORIBOSYLTRANSFERASE 1, CHLOROPLASTIC', 244070),
(345317, 'PTHR21403:SF10', NULL, NULL, NULL, NULL, 'ATP PHOSPHORIBOSYLTRANSFERASE', 244070),
(345318, 'PTHR38324:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 158', 244071),
(345319, 'PTHR38324', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 158', 244071),
(345320, 'PTHR17125:SF2', NULL, NULL, NULL, NULL, 'OUTER DENSE FIBER PROTEIN 1', 244072),
(345321, 'PTHR17125', NULL, NULL, NULL, NULL, 'OUTER DENSE FIBER PROTEIN 1', 244072),
(345322, 'PTHR47558:SF1', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE HOS3', 244073),
(345323, 'PTHR47558', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE HOS3', 244073),
(345324, 'PTHR13748:SF65', NULL, NULL, NULL, NULL, '47 KD PROTEIN', 244074),
(345325, 'PTHR13748:SF31', NULL, NULL, NULL, NULL, 'COBW DOMAIN-CONTAINING PROTEIN 1-RELATED', 244074),
(345326, 'PTHR13748:SF69', NULL, NULL, NULL, NULL, 'COBW DOMAIN-CONTAINING PROTEIN', 244074),
(345327, 'PTHR13748:SF46', NULL, NULL, NULL, NULL, 'ZINC-BINDING GTPASE YEIR', 244074),
(345328, 'PTHR13748', NULL, NULL, NULL, NULL, 'COBW-RELATED', 244074),
(345329, 'PTHR13748:SF59', NULL, NULL, NULL, NULL, 'COBW C-TERMINAL DOMAIN-CONTAINING PROTEIN', 244074),
(345330, 'PTHR13748:SF60', NULL, NULL, NULL, NULL, 'COBW C-TERMINAL DOMAIN-CONTAINING PROTEIN', 244074),
(345331, 'PTHR13748:SF40', NULL, NULL, NULL, NULL, 'OS04G0599700 PROTEIN', 244074),
(345332, 'PTHR13748:SF62', NULL, NULL, NULL, NULL, 'OS02G0800000 PROTEIN', 244074);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(345333, 'PTHR11954:SF38', NULL, NULL, NULL, NULL, 'MACROPHAGE MIGRATION INHIBITION FACTOR-LIKE PROTEIN', 244075),
(345334, 'PTHR11954:SF39', NULL, NULL, NULL, NULL, 'D-DOPACHROME DECARBOXYLASE-LIKE PROTEIN', 244075),
(345335, 'PTHR11954:SF17', NULL, NULL, NULL, NULL, 'MIF-LIKE PROTEIN MIF-3', 244075),
(345336, 'PTHR11954:SF6', NULL, NULL, NULL, NULL, 'MACROPHAGE MIGRATION INHIBITORY FACTOR', 244075),
(345337, 'PTHR11954:SF25', NULL, NULL, NULL, NULL, 'LS1-LIKE PROTEIN', 244075),
(345338, 'PTHR11954:SF15', NULL, NULL, NULL, NULL, 'MIF (MACROPHAGE MIGRATION INHIBITORY FACTOR) RELATED', 244075),
(345339, 'PTHR11954:SF37', NULL, NULL, NULL, NULL, 'MIF-LIKE PROTEIN MIF-2', 244075),
(345340, 'PTHR11954:SF45', NULL, NULL, NULL, NULL, 'MACROPHAGE MIGRATION INHIBITORY FACTOR FAMILY PROTEIN, EXPRESSED', 244075),
(345341, 'PTHR11954:SF21', NULL, NULL, NULL, NULL, 'D-DOPACHROME DECARBOXYLASE', 244075),
(345342, 'PTHR11954:SF43', NULL, NULL, NULL, NULL, 'MACROPHAGE MIGRATION INHIBITION FACTOR-LIKE PROTEIN', 244075),
(345343, 'PTHR11954:SF22', NULL, NULL, NULL, NULL, 'D-DOPACHROME DECARBOXYLASE', 244075),
(345344, 'PTHR11954:SF41', NULL, NULL, NULL, NULL, '', 244075),
(345345, 'PTHR11954:SF42', NULL, NULL, NULL, NULL, 'TAUTOMERASE/MIF SUPERFAMILY PROTEIN', 244075),
(345346, 'PTHR11954', NULL, NULL, NULL, NULL, 'D-DOPACHROME DECARBOXYLASE', 244075),
(345347, 'PTHR21131:SF1', NULL, NULL, NULL, NULL, 'KAZAL-LIKE DOMAIN-CONTAINING PROTEIN', 244076),
(345348, 'PTHR21131:SF0', NULL, NULL, NULL, NULL, 'GEO10195P1-RELATED', 244076),
(345349, 'PTHR21131', NULL, NULL, NULL, NULL, 'SERINE-TYPE ENDOPEPTIDASE INHIBITOR', 244076),
(345350, 'PTHR47665:SF1', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE-LIKE PROTEIN', 244077),
(345351, 'PTHR47665', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE-LIKE PROTEIN', 244077),
(345352, 'PTHR13538', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE 6', 244078),
(345353, 'PTHR13538:SF4', NULL, NULL, NULL, NULL, 'N-ALPHA-ACETYLTRANSFERASE 80', 244078),
(345354, 'PTHR37009:SF1', NULL, NULL, NULL, NULL, 'CALCIUM-REGULATED ACTIN-BUNDLING PROTEIN', 244079),
(345355, 'PTHR37009:SF2', NULL, NULL, NULL, NULL, '', 244079),
(345356, 'PTHR37009', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 244079),
(345357, 'PTHR34215:SF1', NULL, NULL, NULL, NULL, 'YLXR DOMAIN-CONTAINING PROTEIN', 244080),
(345358, 'PTHR34215', NULL, NULL, NULL, NULL, 'BLL0784 PROTEIN', 244080),
(345359, 'PTHR11005:SF148', NULL, NULL, NULL, NULL, 'LIPASE', 244081),
(345360, 'PTHR11005:SF103', NULL, NULL, NULL, NULL, 'STEROL ESTERASE TGL1', 244081),
(345361, 'PTHR11005:SF147', NULL, NULL, NULL, NULL, 'LIPASE', 244081),
(345362, 'PTHR11005:SF124', NULL, NULL, NULL, NULL, 'LIPASE LIPL-1', 244081),
(345363, 'PTHR11005:SF146', NULL, NULL, NULL, NULL, 'ABHYDRO_LIPASE DOMAIN-CONTAINING PROTEIN', 244081),
(345364, 'PTHR11005:SF101', NULL, NULL, NULL, NULL, 'LIPASE', 244081),
(345365, 'PTHR11005:SF145', NULL, NULL, NULL, NULL, 'LIPASE-RELATED', 244081),
(345366, 'PTHR11005:SF144', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN-RELATED', 244081),
(345367, 'PTHR11005:SF100', NULL, NULL, NULL, NULL, 'LIPASE', 244081),
(345368, 'PTHR11005:SF143', NULL, NULL, NULL, NULL, 'LIPASE', 244081),
(345369, 'PTHR11005:SF142', NULL, NULL, NULL, NULL, 'ALPHA/BETA HYDROLASE FAMILY PROTEIN', 244081),
(345370, 'PTHR11005:SF80', NULL, NULL, NULL, NULL, 'LIPASE LIPL-4', 244081),
(345371, 'PTHR11005:SF160', NULL, NULL, NULL, NULL, 'STEROL ESTERASE 1-RELATED', 244081),
(345372, 'PTHR11005:SF14', NULL, NULL, NULL, NULL, 'LIPASE', 244081),
(345373, 'PTHR11005:SF13', NULL, NULL, NULL, NULL, 'LIPASE', 244081),
(345374, 'PTHR11005:SF16', NULL, NULL, NULL, NULL, 'LIPASE MEMBER N', 244081),
(345375, 'PTHR11005:SF15', NULL, NULL, NULL, NULL, 'GASTRIC TRIACYLGLYCEROL LIPASE', 244081),
(345376, 'PTHR11005:SF109', NULL, NULL, NULL, NULL, 'LIPASE', 244081),
(345377, 'PTHR11005:SF10', NULL, NULL, NULL, NULL, 'LIPASE LIPL-5', 244081),
(345378, 'PTHR11005:SF129', NULL, NULL, NULL, NULL, 'LIPASE', 244081),
(345379, 'PTHR11005:SF12', NULL, NULL, NULL, NULL, 'LIPASE MEMBER M', 244081); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(345380, 'PTHR11005:SF128', NULL, NULL, NULL, NULL, 'LIPASE', 244081),
(345381, 'PTHR11005:SF11', NULL, NULL, NULL, NULL, 'LIPASE MEMBER J', 244081),
(345382, 'PTHR11005:SF149', NULL, NULL, NULL, NULL, '', 244081),
(345383, 'PTHR11005:SF99', NULL, NULL, NULL, NULL, 'TRIACYLGLYCEROL LIPASE 2', 244081),
(345384, 'PTHR11005:SF137', NULL, NULL, NULL, NULL, 'LIPASE', 244081),
(345385, 'PTHR11005:SF159', NULL, NULL, NULL, NULL, 'LIPASE', 244081),
(345386, 'PTHR11005:SF158', NULL, NULL, NULL, NULL, 'LIPASE C1672.09-RELATED', 244081),
(345387, 'PTHR11005:SF136', NULL, NULL, NULL, NULL, 'ABHYDRO_LIPASE DOMAIN-CONTAINING PROTEIN', 244081),
(345388, 'PTHR11005:SF135', NULL, NULL, NULL, NULL, 'AB-HYDROLASE LIPASE DOMAIN, ALPHA/BETA HYDROLASE FOLD PROTEIN-RELATED', 244081),
(345389, 'PTHR11005:SF157', NULL, NULL, NULL, NULL, 'LIPASE', 244081),
(345390, 'PTHR11005:SF156', NULL, NULL, NULL, NULL, 'LIPASE', 244081),
(345391, 'PTHR11005:SF90', NULL, NULL, NULL, NULL, 'LIPASE', 244081),
(345392, 'PTHR11005:SF155', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 244081),
(345393, 'PTHR11005:SF111', NULL, NULL, NULL, NULL, 'LIPASE', 244081),
(345394, 'PTHR11005:SF132', NULL, NULL, NULL, NULL, 'ALPHA/BETA HYDROLASE FAMILY PROTEIN', 244081),
(345395, 'PTHR11005:SF154', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 244081),
(345396, 'PTHR11005:SF153', NULL, NULL, NULL, NULL, 'OS08G0359300 PROTEIN', 244081),
(345397, 'PTHR11005:SF152', NULL, NULL, NULL, NULL, 'BNAA09G45260D PROTEIN', 244081),
(345398, 'PTHR11005:SF151', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 244081),
(345399, 'PTHR11005:SF150', NULL, NULL, NULL, NULL, 'LIPASE C14C8.15-RELATED', 244081),
(345400, 'PTHR11005:SF3', NULL, NULL, NULL, NULL, 'LIPASE', 244081),
(345401, 'PTHR11005:SF26', NULL, NULL, NULL, NULL, 'LYSOSOMAL ACID LIPASE/CHOLESTERYL ESTER HYDROLASE', 244081),
(345402, 'PTHR11005', NULL, NULL, NULL, NULL, 'LYSOSOMAL ACID LIPASE-RELATED', 244081),
(345403, 'PTHR11005:SF118', NULL, NULL, NULL, NULL, 'TRIACYLGLYCEROL LIPASE 1', 244081),
(345404, 'PTHR11005:SF117', NULL, NULL, NULL, NULL, 'LIPASE LIPL-3', 244081),
(345405, 'PTHR11005:SF45', NULL, NULL, NULL, NULL, 'LIPASE MEMBER K', 244081),
(345406, 'PTHR11005:SF88', NULL, NULL, NULL, NULL, 'LIPASE', 244081),
(345407, 'PTHR36876:SF1', NULL, NULL, NULL, NULL, 'UROTENSIN-2B', 244082),
(345408, 'PTHR36876', NULL, NULL, NULL, NULL, 'UROTENSIN-2B', 244082),
(345409, 'PTHR38010', NULL, NULL, NULL, NULL, 'SLR0848 PROTEIN', 244083),
(345410, 'PTHR38010:SF1', NULL, NULL, NULL, NULL, 'SLR0848 PROTEIN', 244083),
(345411, 'PTHR11814:SF262', NULL, NULL, NULL, NULL, 'STAS DOMAIN-CONTAINING PROTEIN', 244084),
(345412, 'PTHR11814:SF263', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORTER YPR003C-RELATED', 244084),
(345413, 'PTHR11814:SF260', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORTER 1.3-LIKE', 244084),
(345414, 'PTHR11814:SF261', NULL, NULL, NULL, NULL, 'STAS DOMAIN-CONTAINING PROTEIN', 244084),
(345415, 'PTHR11814:SF181', NULL, NULL, NULL, NULL, 'STAS DOMAIN-CONTAINING PROTEIN', 244084),
(345416, 'PTHR11814:SF51', NULL, NULL, NULL, NULL, 'STAS DOMAIN-CONTAINING PROTEIN', 244084),
(345417, 'PTHR11814:SF54', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORTER 3.5-RELATED', 244084),
(345418, 'PTHR11814:SF7', NULL, NULL, NULL, NULL, 'ANION TRANSPORTER SULP-1A', 244084),
(345419, 'PTHR11814:SF93', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORTER 3.3-RELATED', 244084),
(345420, 'PTHR11814:SF228', NULL, NULL, NULL, NULL, 'STAS DOMAIN-CONTAINING PROTEIN', 244084),
(345421, 'PTHR11814:SF229', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORTER 1.2', 244084),
(345422, 'PTHR11814:SF105', NULL, NULL, NULL, NULL, 'STAS DOMAIN-CONTAINING PROTEIN', 244084),
(345423, 'PTHR11814:SF106', NULL, NULL, NULL, NULL, 'STAS DOMAIN-CONTAINING PROTEIN', 244084),
(345424, 'PTHR11814:SF227', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 244084),
(345425, 'PTHR11814:SF189', NULL, NULL, NULL, NULL, 'FI18412P1', 244084),
(345426, 'PTHR11814:SF266', NULL, NULL, NULL, NULL, 'LOW AFFINITY SULFATE TRANSPORTER-RELATED', 244084);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(345427, 'PTHR11814:SF223', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORTER FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_4G12440)', 244084),
(345428, 'PTHR11814:SF264', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORTER 3.4-RELATED', 244084),
(345429, 'PTHR11814:SF187', NULL, NULL, NULL, NULL, 'EPIDERMAL STRIPES AND PATCHES, ISOFORM A', 244084),
(345430, 'PTHR11814:SF188', NULL, NULL, NULL, NULL, 'SULFATE PERMEASE FAMILY PROTEIN 3', 244084),
(345431, 'PTHR11814:SF265', NULL, NULL, NULL, NULL, 'ANION TRANSPORTER SULP-2', 244084),
(345432, 'PTHR11814:SF252', NULL, NULL, NULL, NULL, 'ANION TRANSPORTER SULP-8A', 244084),
(345433, 'PTHR11814:SF250', NULL, NULL, NULL, NULL, 'STAS DOMAIN-CONTAINING PROTEIN', 244084),
(345434, 'PTHR11814:SF60', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORTER 3.1', 244084),
(345435, 'PTHR11814:SF61', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORTER 2.2', 244084),
(345436, 'PTHR11814:SF16', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORTER', 244084),
(345437, 'PTHR11814:SF17', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 26 MEMBER 9', 244084),
(345438, 'PTHR11814:SF219', NULL, NULL, NULL, NULL, 'SLC26A/SULP TRANSPORTER-RELATED', 244084),
(345439, 'PTHR11814:SF11', NULL, NULL, NULL, NULL, 'TESTIS ANION TRANSPORTER 1', 244084),
(345440, 'PTHR11814:SF99', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 26 MEMBER 10', 244084),
(345441, 'PTHR11814:SF55', NULL, NULL, NULL, NULL, 'SODIUM-INDEPENDENT SULFATE ANION TRANSPORTER', 244084),
(345442, 'PTHR11814:SF217', NULL, NULL, NULL, NULL, 'STAS DOMAIN-CONTAINING PROTEIN', 244084),
(345443, 'PTHR11814:SF215', NULL, NULL, NULL, NULL, 'C4-DICARBOXYLIC ACID TRANSPORTER DAUA', 244084),
(345444, 'PTHR11814:SF259', NULL, NULL, NULL, NULL, 'STAS DOMAIN-CONTAINING PROTEIN', 244084),
(345445, 'PTHR11814:SF216', NULL, NULL, NULL, NULL, 'HIGH AFFINITY SULFATE TRANSPORTER TYPE 1', 244084),
(345446, 'PTHR11814:SF257', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 26 MEMBER 10', 244084),
(345447, 'PTHR11814:SF214', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORTER 3.1-LIKE', 244084),
(345448, 'PTHR11814:SF258', NULL, NULL, NULL, NULL, 'SULFATE/BICARBONATE/OXALATE EXCHANGER AND TRANSPORTER SAT-1', 244084),
(345449, 'PTHR11814:SF19', NULL, NULL, NULL, NULL, 'CHLORIDE ANION EXCHANGER', 244084),
(345450, 'PTHR11814:SF134', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORTER 2.1', 244084),
(345451, 'PTHR11814:SF255', NULL, NULL, NULL, NULL, 'LOW AFFINITY SULFATE TRANSPORTER 3-LIKE', 244084),
(345452, 'PTHR11814:SF211', NULL, NULL, NULL, NULL, 'STAS DOMAIN-CONTAINING PROTEIN', 244084),
(345453, 'PTHR11814:SF256', NULL, NULL, NULL, NULL, 'SLC26A/SULP TRANSPORTER-RELATED', 244084),
(345454, 'PTHR11814:SF253', NULL, NULL, NULL, NULL, 'STAS DOMAIN-CONTAINING PROTEIN', 244084),
(345455, 'PTHR11814:SF132', NULL, NULL, NULL, NULL, 'LD38576P-RELATED', 244084),
(345456, 'PTHR11814:SF210', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORTER 1.1', 244084),
(345457, 'PTHR11814:SF254', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORTER 1.3', 244084),
(345458, 'PTHR11814:SF240', NULL, NULL, NULL, NULL, 'STAS DOMAIN-CONTAINING PROTEIN', 244084),
(345459, 'PTHR11814:SF31', NULL, NULL, NULL, NULL, 'SULFATE ANION TRANSPORTER 1', 244084),
(345460, 'PTHR11814:SF75', NULL, NULL, NULL, NULL, 'ANION EXCHANGE TRANSPORTER', 244084),
(345461, 'PTHR11814:SF32', NULL, NULL, NULL, NULL, 'PRESTIN', 244084),
(345462, 'PTHR11814', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORTER', 244084),
(345463, 'PTHR11814:SF207', NULL, NULL, NULL, NULL, 'STAS DOMAIN-CONTAINING PROTEIN', 244084),
(345464, 'PTHR11814:SF204', NULL, NULL, NULL, NULL, 'HIGH AFFINITY SULFATE TRANSPORTER', 244084),
(345465, 'PTHR11814:SF205', NULL, NULL, NULL, NULL, 'OS03G0195300 PROTEIN', 244084),
(345466, 'PTHR11814:SF200', NULL, NULL, NULL, NULL, 'SI:CH211-117C9.2', 244084),
(345467, 'PTHR11814:SF244', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORTER 4.1-RELATED', 244084),
(345468, 'PTHR11814:SF201', NULL, NULL, NULL, NULL, 'EARLY NODULIN-70', 244084),
(345469, 'PTHR11814:SF242', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORTER 1.2', 244084),
(345470, 'PTHR11814:SF243', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORTER 1,3-RELATED', 244084);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(345471, 'PTHR11814:SF196', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 26 MEMBER 6', 244084),
(345472, 'PTHR11814:SF230', NULL, NULL, NULL, NULL, 'SLC26A/SULP TRANSPORTER-RELATED', 244084),
(345473, 'PTHR11814:SF197', NULL, NULL, NULL, NULL, 'SLC26A/SULP TRANSPORTER-RELATED', 244084),
(345474, 'PTHR11814:SF195', NULL, NULL, NULL, NULL, 'GH25012P', 244084),
(345475, 'PTHR11814:SF85', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORTER 3.4-RELATED', 244084),
(345476, 'PTHR11814:SF80', NULL, NULL, NULL, NULL, 'SULFATE PERMEASE 2', 244084),
(345477, 'PTHR11814:SF37', NULL, NULL, NULL, NULL, 'ANION TRANSPORTER SULP-5', 244084),
(345478, 'PTHR11814:SF33', NULL, NULL, NULL, NULL, 'PENDRIN', 244084),
(345479, 'PTHR11814:SF233', NULL, NULL, NULL, NULL, 'ANION TRANSPORTER SULP-4', 244084),
(345480, 'PTHR11814:SF113', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 26 MEMBER 6', 244084),
(345481, 'PTHR11814:SF234', NULL, NULL, NULL, NULL, 'STAS DOMAIN-CONTAINING PROTEIN', 244084),
(345482, 'PTHR11814:SF198', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORTER 3.2', 244084),
(345483, 'PTHR11814:SF231', NULL, NULL, NULL, NULL, 'RE02508P', 244084),
(345484, 'PTHR22996:SF0', NULL, NULL, NULL, NULL, 'LP12254P-RELATED', 244085),
(345485, 'PTHR22996', NULL, NULL, NULL, NULL, 'MAHOGUNIN', 244085),
(345486, 'PTHR22996:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MGRN1', 244085),
(345487, 'PTHR22996:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE RNF157', 244085),
(345488, 'PTHR22996:SF4', NULL, NULL, NULL, NULL, 'OS05G0397650 PROTEIN', 244085),
(345489, 'PTHR22996:SF3', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 244085),
(345490, 'PTHR22996:SF19', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 244085),
(345491, 'PTHR22996:SF17', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 244085),
(345492, 'PTHR22996:SF14', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 244085),
(345493, 'PTHR22996:SF25', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE LUL3-RELATED', 244085),
(345494, 'PTHR22996:SF12', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE LUL4-RELATED', 244085),
(345495, 'PTHR22996:SF24', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE LUL4-RELATED', 244085),
(345496, 'PTHR22996:SF10', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE LUL1-RELATED', 244085),
(345497, 'PTHR22996:SF8', NULL, NULL, NULL, NULL, 'AMINOACYLTRANSFERASE, E1 UBIQUITIN-ACTIVATING ENZYME-RELATED', 244085),
(345498, 'PTHR22996:SF21', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 244085),
(345499, 'PTHR22996:SF11', NULL, NULL, NULL, NULL, 'OS01G0374900 PROTEIN', 244085),
(345500, 'PTHR22996:SF7', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE LOG2-RELATED', 244085),
(345501, 'PTHR22996:SF9', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE LUL2-RELATED', 244085),
(345502, 'PTHR22996:SF20', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN-RELATED', 244085),
(345503, 'PTHR16852:SF2', NULL, NULL, NULL, NULL, 'GTP CYCLOHYDROLASE 1 FEEDBACK REGULATORY PROTEIN', 244086),
(345504, 'PTHR16852', NULL, NULL, NULL, NULL, 'GTP CYCLOHYDROLASE 1 FEEDBACK REGULATORY PROTEIN', 244086),
(345505, 'PTHR35746:SF1', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT (PPR) SUPERFAMILY PROTEIN', 244087),
(345506, 'PTHR35746', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT (PPR) SUPERFAMILY PROTEIN', 244087),
(345507, 'PTHR35746:SF3', NULL, NULL, NULL, NULL, 'BNAC03G76040D PROTEIN', 244087),
(345508, 'PTHR35746:SF4', NULL, NULL, NULL, NULL, 'FK506-BINDING PROTEIN 2-1', 244087),
(345509, 'PTHR13182:SF8', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 622', 244088),
(345510, 'PTHR13182:SF26', NULL, NULL, NULL, NULL, 'CYTOPLASMIC 60S SUBUNIT BIOGENESIS FACTOR REI1 HOMOLOG 1-LIKE', 244088),
(345511, 'PTHR13182:SF24', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN-RELATED', 244088),
(345512, 'PTHR13182:SF22', NULL, NULL, NULL, NULL, 'BNAA09G41330D PROTEIN', 244088),
(345513, 'PTHR13182:SF20', NULL, NULL, NULL, NULL, 'CYTOPLASMIC 60S SUBUNIT BIOGENESIS FACTOR REI1 HOMOLOG 2', 244088);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(345514, 'PTHR13182', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 622', 244088),
(345515, 'PTHR13182:SF21', NULL, NULL, NULL, NULL, 'CYTOPLASMIC 60S SUBUNIT BIOGENESIS FACTOR REI1', 244088),
(345516, 'PTHR12806:SF0', NULL, NULL, NULL, NULL, 'VACUOLAR-SORTING PROTEIN SNF8', 244089),
(345517, 'PTHR12806:SF1', NULL, NULL, NULL, NULL, 'VACUOLAR-SORTING PROTEIN SNF8', 244089),
(345518, 'PTHR12806', NULL, NULL, NULL, NULL, 'EAP30 SUBUNIT OF ELL COMPLEX', 244089),
(345519, 'PTHR12806:SF2', NULL, NULL, NULL, NULL, 'ESCRT-II COMPLEX SUBUNIT VPS22', 244089),
(345520, 'PTHR42873:SF1', NULL, NULL, NULL, NULL, 'METHYLTRANS_SAM DOMAIN-CONTAINING PROTEIN', 244090),
(345521, 'PTHR42873', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA LARGE SUBUNIT METHYLTRANSFERASE', 244090),
(345522, 'PTHR38134', NULL, NULL, NULL, NULL, 'SLR1395 PROTEIN', 244091),
(345523, 'PTHR38134:SF2', NULL, NULL, NULL, NULL, 'GALACTOKINASE', 244091),
(345524, 'PTHR38222', NULL, NULL, NULL, NULL, '', 244092),
(345525, 'PTHR38222:SF1', NULL, NULL, NULL, NULL, '', 244092),
(345526, 'PTHR12283', NULL, NULL, NULL, NULL, 'GLUTAMINYL-PEPTIDE CYCLOTRANSFERASE', 244093),
(345527, 'PTHR12283:SF2', NULL, NULL, NULL, NULL, 'PEPTIDE HYDROLASE', 244093),
(345528, 'PTHR12283:SF5', NULL, NULL, NULL, NULL, 'GLUTAMINYL-PEPTIDE CYCLOTRANSFERASE', 244093),
(345529, 'PTHR12283:SF6', NULL, NULL, NULL, NULL, 'GLUTAMINYL-PEPTIDE CYCLOTRANSFERASE', 244093),
(345530, 'PTHR12283:SF3', NULL, NULL, NULL, NULL, 'GLUTAMINYL-PEPTIDE CYCLOTRANSFERASE-LIKE PROTEIN', 244093),
(345531, 'PTHR17602:SF8', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS REGULATORY PROTEIN', 244094),
(345532, 'PTHR17602', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS REGULATORY PROTEIN', 244094),
(345533, 'PTHR17602:SF4', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS REGULATORY PROTEIN HOMOLOG', 244094),
(345534, 'PTHR36005:SF1', NULL, NULL, NULL, NULL, 'DNA LIGASE-LIKE PROTEIN', 244095),
(345535, 'PTHR36005', NULL, NULL, NULL, NULL, 'DNA LIGASE-LIKE PROTEIN', 244095),
(345536, 'PTHR37201:SF1', NULL, NULL, NULL, NULL, 'WD REPEAT PROTEIN', 244096),
(345537, 'PTHR37201', NULL, NULL, NULL, NULL, 'WD REPEAT PROTEIN', 244096),
(345538, 'PTHR43166:SF4', NULL, NULL, NULL, NULL, 'GLUTAMINE TRANSPORT ATP-BINDING PROTEIN GLNQ', 244097),
(345539, 'PTHR43166:SF7', NULL, NULL, NULL, NULL, 'GLUTAMATE/ASPARTATE IMPORT ATP-BINDING PROTEIN GLTL', 244097),
(345540, 'PTHR43166', NULL, NULL, NULL, NULL, 'AMINO ACID IMPORT ATP-BINDING PROTEIN', 244097),
(345541, 'PTHR43166:SF5', NULL, NULL, NULL, NULL, 'METHIONINE IMPORT ATP-BINDING PROTEIN METN', 244097),
(345542, 'PTHR43166:SF6', NULL, NULL, NULL, NULL, 'PHOSPHONATES IMPORT ATP-BINDING PROTEIN PHNC', 244097),
(345543, 'PTHR43166:SF35', NULL, NULL, NULL, NULL, 'L-CYSTINE TRANSPORT SYSTEM ATP-BINDING PROTEIN TCYN', 244097),
(345544, 'PTHR43166:SF9', NULL, NULL, NULL, NULL, 'PHOSPHONATES IMPORT ATP-BINDING PROTEIN PHNC', 244097),
(345545, 'PTHR43166:SF34', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN-GLUTAMINE TRANSPORT', 244097),
(345546, 'PTHR43166:SF15', NULL, NULL, NULL, NULL, 'HISTIDINE TRANSPORT ATP-BINDING PROTEIN HISP', 244097),
(345547, 'PTHR43166:SF25', NULL, NULL, NULL, NULL, 'ARGININE TRANSPORT ATP-BINDING PROTEIN ARTP', 244097),
(345548, 'PTHR43166:SF14', NULL, NULL, NULL, NULL, 'GLUTAMINE TRANSPORT ATP-BINDING PROTEIN GLNQ', 244097),
(345549, 'PTHR43166:SF36', NULL, NULL, NULL, NULL, 'METHIONINE IMPORT ATP-BINDING PROTEIN METN 2', 244097),
(345550, 'PTHR43166:SF30', NULL, NULL, NULL, NULL, 'METHIONINE IMPORT ATP-BINDING PROTEIN METN 2', 244097),
(345551, 'PTHR33722', NULL, NULL, NULL, NULL, 'CATION CHANNEL SPERM-ASSOCIATED PROTEIN SUBUNIT DELTA-RELATED', 244098),
(345552, 'PTHR33722:SF1', NULL, NULL, NULL, NULL, 'CATION CHANNEL SPERM-ASSOCIATED PROTEIN SUBUNIT DELTA', 244098),
(345553, 'PTHR33722:SF3', NULL, NULL, NULL, NULL, 'CATION CHANNEL SPERM-ASSOCIATED PROTEIN SUBUNIT EPSILON', 244098),
(345554, 'PTHR14437:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 168B', 244099),
(345555, 'PTHR14437:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 168', 244099);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(345556, 'PTHR14437:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 168-A', 244099),
(345557, 'PTHR14437', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 168', 244099),
(345558, 'PTHR31602:SF51', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR 6', 244100),
(345559, 'PTHR31602:SF73', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR', 244100),
(345560, 'PTHR31602:SF74', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR', 244100),
(345561, 'PTHR31602:SF92', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR 9', 244100),
(345562, 'PTHR31602:SF101', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR 7', 244100),
(345563, 'PTHR31602:SF100', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR', 244100),
(345564, 'PTHR31602:SF103', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR', 244100),
(345565, 'PTHR31602:SF49', NULL, NULL, NULL, NULL, 'NAD-DEPENDENT PROTEIN DEACYLASE SRT2', 244100),
(345566, 'PTHR31602:SF102', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR 7', 244100),
(345567, 'PTHR31602:SF105', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR', 244100),
(345568, 'PTHR31602', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR 5', 244100),
(345569, 'PTHR31602:SF104', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR', 244100),
(345570, 'PTHR31602:SF89', NULL, NULL, NULL, NULL, 'WRC DOMAIN-CONTAINING PROTEIN', 244100),
(345571, 'PTHR31602:SF107', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR 5', 244100),
(345572, 'PTHR31602:SF46', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR 6', 244100),
(345573, 'PTHR31602:SF106', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR', 244100),
(345574, 'PTHR31602:SF109', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR', 244100),
(345575, 'PTHR31602:SF108', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR', 244100),
(345576, 'PTHR31602:SF83', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR', 244100),
(345577, 'PTHR31602:SF62', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR', 244100),
(345578, 'PTHR31602:SF85', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR', 244100),
(345579, 'PTHR31602:SF63', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR 3', 244100),
(345580, 'PTHR31602:SF64', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR 1', 244100),
(345581, 'PTHR31602:SF42', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR 2', 244100),
(345582, 'PTHR31602:SF80', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR', 244100),
(345583, 'PTHR31602:SF110', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR', 244100),
(345584, 'PTHR31602:SF81', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR 9', 244100),
(345585, 'PTHR31602:SF60', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR 5', 244100),
(345586, 'PTHR31602:SF14', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR 11', 244100),
(345587, 'PTHR31602:SF8', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR 4', 244100),
(345588, 'PTHR31602:SF98', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR', 244100),
(345589, 'PTHR31602:SF10', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR 2', 244100),
(345590, 'PTHR31602:SF99', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR', 244100),
(345591, 'PTHR31602:SF56', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR 4', 244100),
(345592, 'PTHR31602:SF3', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR 8', 244100),
(345593, 'PTHR31602:SF79', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR', 244100),
(345594, 'PTHR31602:SF19', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR', 244100),
(345595, 'PTHR33337:SF33', NULL, NULL, NULL, NULL, 'CENP-V/GFA DOMAIN-CONTAINING PROTEIN', 244101),
(345596, 'PTHR33337:SF35', NULL, NULL, NULL, NULL, 'DUF636 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_1G03180)', 244101),
(345597, 'PTHR33337', NULL, NULL, NULL, NULL, 'GFA DOMAIN-CONTAINING PROTEIN', 244101),
(345598, 'PTHR33337:SF36', NULL, NULL, NULL, NULL, 'DUF636 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_3G01340)', 244101),
(345599, 'PTHR33337:SF40', NULL, NULL, NULL, NULL, 'CENP-V/GFA DOMAIN-CONTAINING PROTEIN-RELATED', 244101),
(345600, 'PTHR33337:SF30', NULL, NULL, NULL, NULL, 'DUF636 DOMAIN PROTEIN', 244101);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(345601, 'PTHR33337:SF3', NULL, NULL, NULL, NULL, 'CENP-V/GFA DOMAIN-CONTAINING PROTEIN', 244101),
(345602, 'PTHR33337:SF31', NULL, NULL, NULL, NULL, 'DUF636 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_2G12650)', 244101),
(345603, 'PTHR33337:SF42', NULL, NULL, NULL, NULL, 'DUF636 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_2G15290)', 244101),
(345604, 'PTHR33337:SF32', NULL, NULL, NULL, NULL, 'DUF636 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_7G04120)', 244101),
(345605, 'PTHR33337:SF39', NULL, NULL, NULL, NULL, 'DUF636 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_6G11530)', 244101),
(345606, 'PTHR33337:SF8', NULL, NULL, NULL, NULL, 'CENP-V/GFA DOMAIN-CONTAINING PROTEIN', 244101),
(345607, 'PTHR46057:SF39', NULL, NULL, NULL, NULL, 'FLZ-TYPE DOMAIN-CONTAINING PROTEIN', 244102),
(345608, 'PTHR46057:SF18', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 244102),
(345609, 'PTHR46057:SF19', NULL, NULL, NULL, NULL, 'OS04G0585900 PROTEIN', 244102),
(345610, 'PTHR46057:SF50', NULL, NULL, NULL, NULL, 'FLZ-TYPE DOMAIN-CONTAINING PROTEIN', 244102),
(345611, 'PTHR46057:SF51', NULL, NULL, NULL, NULL, 'FCS-LIKE ZINC FINGER 3', 244102),
(345612, 'PTHR46057:SF34', NULL, NULL, NULL, NULL, 'FLZ-TYPE DOMAIN-CONTAINING PROTEIN', 244102),
(345613, 'PTHR46057:SF56', NULL, NULL, NULL, NULL, 'FLZ-TYPE DOMAIN-CONTAINING PROTEIN', 244102),
(345614, 'PTHR46057:SF57', NULL, NULL, NULL, NULL, 'ETHPHON-INDUCED PROTEIN', 244102),
(345615, 'PTHR46057:SF35', NULL, NULL, NULL, NULL, 'FLZ-TYPE DOMAIN-CONTAINING PROTEIN', 244102),
(345616, 'PTHR46057:SF13', NULL, NULL, NULL, NULL, 'OS04G0586200 PROTEIN', 244102),
(345617, 'PTHR46057:SF36', NULL, NULL, NULL, NULL, 'FLZ-TYPE DOMAIN-CONTAINING PROTEIN', 244102),
(345618, 'PTHR46057:SF14', NULL, NULL, NULL, NULL, 'OS02G0687200 PROTEIN', 244102),
(345619, 'PTHR46057:SF37', NULL, NULL, NULL, NULL, 'FLZ-TYPE DOMAIN-CONTAINING PROTEIN', 244102),
(345620, 'PTHR46057:SF15', NULL, NULL, NULL, NULL, 'FLZ-TYPE DOMAIN-CONTAINING PROTEIN', 244102),
(345621, 'PTHR46057:SF52', NULL, NULL, NULL, NULL, 'OS08G0451200 PROTEIN', 244102),
(345622, 'PTHR46057:SF53', NULL, NULL, NULL, NULL, 'FLZ-TYPE DOMAIN-CONTAINING PROTEIN', 244102),
(345623, 'PTHR46057:SF31', NULL, NULL, NULL, NULL, 'FLZ-TYPE DOMAIN-CONTAINING PROTEIN', 244102),
(345624, 'PTHR46057:SF54', NULL, NULL, NULL, NULL, 'FCS-LIKE ZINC FINGER 16', 244102),
(345625, 'PTHR46057:SF11', NULL, NULL, NULL, NULL, 'OS06G0714800 PROTEIN', 244102),
(345626, 'PTHR46057:SF55', NULL, NULL, NULL, NULL, 'OSJNBA0013K16.16-LIKE PROTEIN', 244102),
(345627, 'PTHR46057:SF33', NULL, NULL, NULL, NULL, 'OS09G0433800 PROTEIN', 244102),
(345628, 'PTHR46057:SF49', NULL, NULL, NULL, NULL, 'FLZ-TYPE DOMAIN-CONTAINING PROTEIN', 244102),
(345629, 'PTHR46057', NULL, NULL, NULL, NULL, 'FCS-LIKE ZINC FINGER 1-RELATED', 244102),
(345630, 'PTHR46057:SF40', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 244102),
(345631, 'PTHR46057:SF5', NULL, NULL, NULL, NULL, 'OS04G0586000 PROTEIN', 244102),
(345632, 'PTHR46057:SF8', NULL, NULL, NULL, NULL, 'OS04G0585700 PROTEIN', 244102),
(345633, 'PTHR46057:SF7', NULL, NULL, NULL, NULL, 'OS02G0686800 PROTEIN', 244102),
(345634, 'PTHR46057:SF9', NULL, NULL, NULL, NULL, 'FCS-LIKE ZINC FINGER 1', 244102),
(345635, 'PTHR46057:SF23', NULL, NULL, NULL, NULL, 'FCS-LIKE ZINC FINGER 2', 244102),
(345636, 'PTHR46057:SF47', NULL, NULL, NULL, NULL, 'OS02G0687100 PROTEIN', 244102),
(345637, 'PTHR46057:SF26', NULL, NULL, NULL, NULL, 'OS06G0125200 PROTEIN', 244102),
(345638, 'PTHR46057:SF48', NULL, NULL, NULL, NULL, 'ZF-FLZ DOMAIN-CONTAINING PROTEIN-RELATED', 244102),
(345639, 'PTHR46057:SF43', NULL, NULL, NULL, NULL, 'OSJNBA0013K16.16-LIKE PROTEIN', 244102),
(345640, 'PTHR40438', NULL, NULL, NULL, NULL, 'PYRUVOYL-DEPENDENT ARGININE DECARBOXYLASE', 244103),
(345641, 'PTHR40438:SF1', NULL, NULL, NULL, NULL, 'PYRUVOYL-DEPENDENT ARGININE DECARBOXYLASE', 244103),
(345642, 'PTHR30547', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN YHCG-RELATED', 244104),
(345643, 'PTHR30547:SF0', NULL, NULL, NULL, NULL, 'BLR8175 PROTEIN', 244104),
(345644, 'PTHR30547:SF5', NULL, NULL, NULL, NULL, 'NUCLEASE YHCG-RELATED', 244104);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(345645, 'PTHR21685:SF1', NULL, NULL, NULL, NULL, 'TAPERIN', 244105),
(345646, 'PTHR21685:SF2', NULL, NULL, NULL, NULL, '', 244105),
(345647, 'PTHR21685:SF0', NULL, NULL, NULL, NULL, 'PHOSTENSIN', 244105),
(345648, 'PTHR21685', NULL, NULL, NULL, NULL, 'TON-B BOX DOMAIN', 244105),
(345649, 'PTHR48318', NULL, NULL, NULL, NULL, 'PROTEIN EVA-1 HOMOLOG B', 244106),
(345650, 'PTHR48318:SF1', NULL, NULL, NULL, NULL, 'PROTEIN EVA-1 HOMOLOG B', 244106),
(345651, 'PTHR42107:SF1', NULL, NULL, NULL, NULL, 'WHIM1 DOMAIN-CONTAINING PROTEIN', 244107),
(345652, 'PTHR42107', NULL, NULL, NULL, NULL, 'YALI0D24453P', 244107),
(345653, 'PTHR13070:SF0', NULL, NULL, NULL, NULL, 'TRNA-SPLICING ENDONUCLEASE SUBUNIT SEN34', 244108),
(345654, 'PTHR13070', NULL, NULL, NULL, NULL, 'TRNA-SPLICING ENDONUCLEASE SUBUNIT SEN34-RELATED', 244108),
(345655, 'PTHR36006:SF5', NULL, NULL, NULL, NULL, 'OS02G0138100 PROTEIN', 244109),
(345656, 'PTHR36006:SF2', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM-10 ISOFORM 1', 244109),
(345657, 'PTHR36006', NULL, NULL, NULL, NULL, 'BNAC02G25390D PROTEIN', 244109),
(345658, 'PTHR34655:SF1', NULL, NULL, NULL, NULL, 'DRSE DOMAIN-CONTAINING PROTEIN', 244110),
(345659, 'PTHR34655:SF3', NULL, NULL, NULL, NULL, 'DRSE DOMAIN-CONTAINING PROTEIN', 244110),
(345660, 'PTHR34655:SF2', NULL, NULL, NULL, NULL, 'DRSE DOMAIN-CONTAINING PROTEIN', 244110),
(345661, 'PTHR34655', NULL, NULL, NULL, NULL, 'CONSERVED WITHIN P. AEROPHILUM', 244110),
(345662, 'PTHR46303:SF2', NULL, NULL, NULL, NULL, 'CHORDIN-LIKE PROTEIN 1', 244111),
(345663, 'PTHR46303:SF1', NULL, NULL, NULL, NULL, 'VWFC DOMAIN-CONTAINING PROTEIN', 244111),
(345664, 'PTHR46303:SF3', NULL, NULL, NULL, NULL, 'CHORDIN-LIKE PROTEIN 2', 244111),
(345665, 'PTHR46303', NULL, NULL, NULL, NULL, 'VWFC DOMAIN-CONTAINING PROTEIN', 244111),
(345666, 'PTHR46637', NULL, NULL, NULL, NULL, 'TIS1421-TRANSPOSASE PROTEIN A', 244112),
(345667, 'PTHR46637:SF1', NULL, NULL, NULL, NULL, 'BLL5188 PROTEIN', 244112),
(345668, 'PTHR47469', NULL, NULL, NULL, NULL, 'MONOOXYGENASE-LIKE', 244113),
(345669, 'PTHR47469:SF2', NULL, NULL, NULL, NULL, 'OS06G0597600 PROTEIN', 244113),
(345670, 'PTHR13596:SF8', NULL, NULL, NULL, NULL, '4F5 DOMAIN-CONTAINING PROTEIN', 244114),
(345671, 'PTHR13596:SF17', NULL, NULL, NULL, NULL, '4F5 DOMAIN-CONTAINING PROTEIN', 244114),
(345672, 'PTHR13596:SF6', NULL, NULL, NULL, NULL, 'RCG26176, ISOFORM CRA_A', 244114),
(345673, 'PTHR13596:SF12', NULL, NULL, NULL, NULL, 'OS11G0425600 PROTEIN', 244114),
(345674, 'PTHR13596:SF0', NULL, NULL, NULL, NULL, 'SI:CH211-39K3.2-RELATED', 244114),
(345675, 'PTHR13596:SF2', NULL, NULL, NULL, NULL, 'SMALL EDRK-RICH FACTOR 2', 244114),
(345676, 'PTHR13596:SF14', NULL, NULL, NULL, NULL, '4F5 FAMILY PROTEIN', 244114),
(345677, 'PTHR13596:SF1', NULL, NULL, NULL, NULL, 'SMALL EDRK-RICH FACTOR 1', 244114),
(345678, 'PTHR13596', NULL, NULL, NULL, NULL, 'SMALL EDRK-RICH FACTOR 1', 244114),
(345679, 'PTHR32057:SF14', NULL, NULL, NULL, NULL, 'PROTEIN ADENYLYLTRANSFERASE SELO, MITOCHONDRIAL', 244115),
(345680, 'PTHR32057:SF16', NULL, NULL, NULL, NULL, 'SELENOPROTEIN O', 244115),
(345681, 'PTHR32057:SF15', NULL, NULL, NULL, NULL, 'SELENOPROTEIN O', 244115),
(345682, 'PTHR32057', NULL, NULL, NULL, NULL, 'PROTEIN ADENYLYLTRANSFERASE SELO, MITOCHONDRIAL', 244115),
(345683, 'PTHR31945:SF5', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTION FACTOR', 244116),
(345684, 'PTHR31945:SF78', NULL, NULL, NULL, NULL, 'OS05G0337200 PROTEIN', 244116),
(345685, 'PTHR31945:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH93-LIKE PROTEIN', 244116),
(345686, 'PTHR31945:SF125', NULL, NULL, NULL, NULL, 'BNAA09G35700D PROTEIN', 244116),
(345687, 'PTHR31945:SF88', NULL, NULL, NULL, NULL, 'BNAC04G25110D PROTEIN', 244116),
(345688, 'PTHR31945:SF124', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 244116),
(345689, 'PTHR31945:SF87', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REGULATOR-RELATED', 244116),
(345690, 'PTHR31945:SF85', NULL, NULL, NULL, NULL, 'OS07G0676600 PROTEIN', 244116),
(345691, 'PTHR31945:SF84', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH27', 244116);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(345692, 'PTHR31945:SF82', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR ICE1', 244116),
(345693, 'PTHR31945:SF129', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SCREAM2', 244116),
(345694, 'PTHR31945:SF27', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH35-LIKE PROTEIN', 244116),
(345695, 'PTHR31945:SF26', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH35', 244116),
(345696, 'PTHR31945:SF68', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR UDT1', 244116),
(345697, 'PTHR31945:SF77', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH93-LIKE', 244116),
(345698, 'PTHR31945:SF76', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 244116),
(345699, 'PTHR31945:SF138', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTIONAL FACTOR', 244116),
(345700, 'PTHR31945:SF70', NULL, NULL, NULL, NULL, 'HLH DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 244116),
(345701, 'PTHR31945:SF133', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 244116),
(345702, 'PTHR31945:SF141', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SCREAM-LIKE PROTEIN', 244116),
(345703, 'PTHR31945:SF17', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR FER-LIKE IRON DEFICIENCY-INDUCED TRANSCRIPTION FACTOR', 244116),
(345704, 'PTHR31945:SF140', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN-CONTAINING PROTEIN-RELATED', 244116),
(345705, 'PTHR31945:SF15', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH61-RELATED', 244116),
(345706, 'PTHR31945:SF57', NULL, NULL, NULL, NULL, 'BNAANNG36760D PROTEIN', 244116),
(345707, 'PTHR31945:SF147', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 244116),
(345708, 'PTHR31945:SF146', NULL, NULL, NULL, NULL, '', 244116),
(345709, 'PTHR31945:SF149', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN-CONTAINING PROTEIN-RELATED', 244116),
(345710, 'PTHR31945:SF20', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR DYT1', 244116),
(345711, 'PTHR31945:SF105', NULL, NULL, NULL, NULL, 'BASIC HELIX-LOOP-HELIX (BHLH) DNA-BINDING SUPERFAMILY PROTEIN-RELATED', 244116),
(345712, 'PTHR31945:SF148', NULL, NULL, NULL, NULL, '', 244116),
(345713, 'PTHR31945:SF63', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH90', 244116),
(345714, 'PTHR31945:SF143', NULL, NULL, NULL, NULL, 'HELIX-LOOP-HELIX DNA-BINDING DOMAIN CONTAINING PROTEIN, EXPRESSED', 244116),
(345715, 'PTHR31945:SF61', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH3', 244116),
(345716, 'PTHR31945:SF142', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 244116),
(345717, 'PTHR31945:SF145', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH28', 244116),
(345718, 'PTHR31945', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SCREAM2-RELATED', 244116),
(345719, 'PTHR31945:SF144', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 244116),
(345720, 'PTHR31945:SF107', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 244116),
(345721, 'PTHR31945:SF109', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 244116),
(345722, 'PTHR31945:SF150', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH93-LIKE', 244116),
(345723, 'PTHR31945:SF152', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR ICE1-LIKE', 244116),
(345724, 'PTHR31945:SF151', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH93-LIKE', 244116),
(345725, 'PTHR31945:SF47', NULL, NULL, NULL, NULL, 'OS10G0104300 PROTEIN', 244116),
(345726, 'PTHR31945:SF46', NULL, NULL, NULL, NULL, 'OS03G0229100 PROTEIN', 244116),
(345727, 'PTHR31945:SF45', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244116),
(345728, 'PTHR31945:SF11', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR ABORTED MICROSPORES', 244116),
(345729, 'PTHR31945:SF113', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 244116),
(345730, 'PTHR31945:SF53', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 244116),
(345731, 'PTHR31945:SF52', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH FAMILY-RELATED', 244116),
(345732, 'PTHR31945:SF96', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 244116),
(345733, 'PTHR31945:SF93', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 244116);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(345734, 'PTHR31945:SF112', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 244116),
(345735, 'PTHR31945:SF90', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 244116),
(345736, 'PTHR31945:SF118', NULL, NULL, NULL, NULL, 'BNAA03G52850D PROTEIN', 244116),
(345737, 'PTHR31945:SF117', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN-CONTAINING PROTEIN-RELATED', 244116),
(345738, 'PTHR48124', NULL, NULL, NULL, NULL, 'GRF-TYPE DOMAIN-CONTAINING PROTEIN', 244117),
(345739, 'PTHR48124:SF1', NULL, NULL, NULL, NULL, 'GRF-TYPE DOMAIN-CONTAINING PROTEIN', 244117),
(345740, 'PTHR10146:SF15', NULL, NULL, NULL, NULL, 'PYRIDOXAL PHOSPHATE HOMEOSTASIS PROTEIN', 244118),
(345741, 'PTHR10146:SF14', NULL, NULL, NULL, NULL, 'PYRIDOXAL PHOSPHATE HOMEOSTASIS PROTEIN', 244118),
(345742, 'PTHR10146', NULL, NULL, NULL, NULL, 'PROLINE SYNTHETASE CO-TRANSCRIBED BACTERIAL HOMOLOG PROTEIN', 244118),
(345743, 'PTHR38590', NULL, NULL, NULL, NULL, 'BLL0828 PROTEIN', 244119),
(345744, 'PTHR38590:SF1', NULL, NULL, NULL, NULL, 'BLL0828 PROTEIN', 244119),
(345745, 'PTHR40079:SF4', NULL, NULL, NULL, NULL, 'GH26 DOMAIN-CONTAINING PROTEIN-RELATED', 244120),
(345746, 'PTHR40079:SF6', NULL, NULL, NULL, NULL, 'GH26 DOMAIN-CONTAINING PROTEIN', 244120),
(345747, 'PTHR40079', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE E-RELATED', 244120),
(345748, 'PTHR35337:SF1', NULL, NULL, NULL, NULL, 'SLR1478 PROTEIN', 244121),
(345749, 'PTHR35337', NULL, NULL, NULL, NULL, 'SLR1478 PROTEIN', 244121),
(345750, 'PTHR31011', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244122),
(345751, 'PTHR31011:SF2', NULL, NULL, NULL, NULL, 'PROTEIN STB2-RELATED', 244122),
(345752, 'PTHR37421:SF1', NULL, NULL, NULL, NULL, 'UPF0260 PROTEIN YCGN', 244123),
(345753, 'PTHR37421', NULL, NULL, NULL, NULL, 'UPF0260 PROTEIN YCGN', 244123),
(345754, 'PTHR14308', NULL, NULL, NULL, NULL, 'WAP FOUR-DISULFIDE CORE DOMAIN PROTEIN 1', 244124),
(345755, 'PTHR14308:SF0', NULL, NULL, NULL, NULL, 'WAP FOUR-DISULFIDE CORE DOMAIN PROTEIN 1', 244124),
(345756, 'PTHR35288:SF3', NULL, NULL, NULL, NULL, '', 244125),
(345757, 'PTHR35288', NULL, NULL, NULL, NULL, 'TAIL FIBER', 244125),
(345758, 'PTHR35288:SF1', NULL, NULL, NULL, NULL, 'TAIL FIBER', 244125),
(345759, 'PTHR35288:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 244125),
(345760, 'PTHR45966:SF7', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE 5-LIKE ISOFORM X1', 244126),
(345761, 'PTHR45966', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 244126),
(345762, 'PTHR45966:SF16', NULL, NULL, NULL, NULL, 'BNAC06G10380D PROTEIN', 244126),
(345763, 'PTHR45966:SF6', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE 4', 244126),
(345764, 'PTHR45966:SF27', NULL, NULL, NULL, NULL, 'BNAA06G01420D PROTEIN', 244126),
(345765, 'PTHR45966:SF28', NULL, NULL, NULL, NULL, 'INACTIVE GDSL ESTERASE/LIPASE-LIKE PROTEIN 25', 244126),
(345766, 'PTHR45966:SF4', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE 5', 244126),
(345767, 'PTHR45966:SF12', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE 1-LIKE ISOFORM X1', 244126),
(345768, 'PTHR45966:SF23', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 244126),
(345769, 'PTHR45966:SF13', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 244126),
(345770, 'PTHR45966:SF26', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE 5-LIKE ISOFORM X1', 244126),
(345771, 'PTHR45966:SF15', NULL, NULL, NULL, NULL, 'LIPASE SIL1', 244126),
(345772, 'PTHR45966:SF20', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE 5-LIKE', 244126),
(345773, 'PTHR45966:SF31', NULL, NULL, NULL, NULL, 'FINGER PROTEIN, PUTATIVE-RELATED', 244126),
(345774, 'PTHR45966:SF32', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE 2-LIKE', 244126),
(345775, 'PTHR45966:SF21', NULL, NULL, NULL, NULL, 'BNAA08G29200D PROTEIN', 244126),
(345776, 'PTHR45966:SF33', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE 3', 244126),
(345777, 'PTHR45966:SF22', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE 1-LIKE ISOFORM X1', 244126),
(345778, 'PTHR45966:SF1', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE 1-RELATED', 244126); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(345779, 'PTHR35286:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244127),
(345780, 'PTHR35286:SF2', NULL, NULL, NULL, NULL, '', 244127),
(345781, 'PTHR35286', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244127),
(345782, 'PTHR34252', NULL, NULL, NULL, NULL, 'UPF0705 PROTEIN C11ORF49', 244128),
(345783, 'PTHR34252:SF1', NULL, NULL, NULL, NULL, 'UPF0705 PROTEIN C11ORF49', 244128),
(345784, 'PTHR42771:SF11', NULL, NULL, NULL, NULL, 'FERRICHROME TRANSPORT ATP-BINDING PROTEIN FHUC', 244129),
(345785, 'PTHR42771', NULL, NULL, NULL, NULL, 'IRON(3+)-HYDROXAMATE IMPORT ATP-BINDING PROTEIN FHUC', 244129),
(345786, 'PTHR42771:SF12', NULL, NULL, NULL, NULL, 'FE(3+) DICITRATE TRANSPORT ATP-BINDING PROTEIN FECE-RELATED', 244129),
(345787, 'PTHR42771:SF4', NULL, NULL, NULL, NULL, 'IRON(3+)-HYDROXAMATE IMPORT ATP-BINDING PROTEIN FHUC', 244129),
(345788, 'PTHR42771:SF7', NULL, NULL, NULL, NULL, 'ABC-TYPE COBALAMIN/FE3+-SIDEROPHORES TRANSPORT SYSTEM, ATPASE COMPONENT-RELATED', 244129),
(345789, 'PTHR42771:SF10', NULL, NULL, NULL, NULL, 'FERRICHROME TRANSPORT ATP-BINDING PROTEIN FHUC', 244129),
(345790, 'PTHR42771:SF3', NULL, NULL, NULL, NULL, 'PETROBACTIN IMPORT ATP-BINDING PROTEIN YCLP', 244129),
(345791, 'PTHR42771:SF2', NULL, NULL, NULL, NULL, 'IRON(3+)-HYDROXAMATE IMPORT ATP-BINDING PROTEIN FHUC', 244129),
(345792, 'PTHR43267:SF3', NULL, NULL, NULL, NULL, 'THIF PROTEIN', 244130),
(345793, 'PTHR43267:SF2', NULL, NULL, NULL, NULL, 'TRNA THREONYLCARBAMOYLADENOSINE DEHYDRATASE 1-RELATED', 244130),
(345794, 'PTHR43267:SF1', NULL, NULL, NULL, NULL, 'TRNA THREONYLCARBAMOYLADENOSINE DEHYDRATASE', 244130),
(345795, 'PTHR43267', NULL, NULL, NULL, NULL, 'TRNA THREONYLCARBAMOYLADENOSINE DEHYDRATASE', 244130),
(345796, 'PTHR43853:SF3', NULL, NULL, NULL, NULL, 'ACETYL-COA C-ACETYLTRANSFERASE YHFS-RELATED', 244131),
(345797, 'PTHR43853', NULL, NULL, NULL, NULL, '3-KETOACYL-COA THIOLASE, PEROXISOMAL', 244131),
(345798, 'PTHR43853:SF2', NULL, NULL, NULL, NULL, '3-OXOADIPYL-COA/3-OXO-5,6-DEHYDROSUBERYL-COA THIOLASE', 244131),
(345799, 'PTHR43853:SF19', NULL, NULL, NULL, NULL, '3-KETOACYL-COA THIOLASE A, PEROXISOMAL', 244131),
(345800, 'PTHR43853:SF16', NULL, NULL, NULL, NULL, 'BNAC04G11470D PROTEIN', 244131),
(345801, 'PTHR43853:SF15', NULL, NULL, NULL, NULL, '3-KETOACYL-COA THIOLASE 5, PEROXISOMAL', 244131),
(345802, 'PTHR43853:SF18', NULL, NULL, NULL, NULL, 'BNAC04G43560D PROTEIN', 244131),
(345803, 'PTHR43853:SF17', NULL, NULL, NULL, NULL, '3-KETOACYL-COA THIOLASE B, PEROXISOMAL', 244131),
(345804, 'PTHR43853:SF12', NULL, NULL, NULL, NULL, '3-KETOACYL-COA THIOLASE (KAT1), PUTATIVE (AFU_ORTHOLOGUE AFUA_2G11350)-RELATED', 244131),
(345805, 'PTHR43853:SF11', NULL, NULL, NULL, NULL, '3-KETOACYL-COA THIOLASE FADA', 244131),
(345806, 'PTHR43853:SF9', NULL, NULL, NULL, NULL, 'POT1-2P', 244131),
(345807, 'PTHR43853:SF8', NULL, NULL, NULL, NULL, '3-KETOACYL-COA THIOLASE, PEROXISOMAL', 244131),
(345808, 'PTHR43853:SF13', NULL, NULL, NULL, NULL, '3-KETOACYL-COA THIOLASE 1, PEROXISOMAL', 244131),
(345809, 'PTHR43853:SF10', NULL, NULL, NULL, NULL, 'KETOTHIOLASE (KAT1), PUTATIVE (AFU_ORTHOLOGUE AFUA_1G12650)-RELATED', 244131),
(345810, 'PTHR43853:SF21', NULL, NULL, NULL, NULL, '3-KETOACYL-COA THIOLASE', 244131),
(345811, 'PTHR43853:SF5', NULL, NULL, NULL, NULL, 'THIOLASE (POT1), PUTATIVE (AFU_ORTHOLOGUE AFUA_7G04080)-RELATED', 244131),
(345812, 'PTHR43853:SF20', NULL, NULL, NULL, NULL, 'THIOLASE 2, PEROXISOMAL, PUTATIVE, EXPRESSED-RELATED', 244131),
(345813, 'PTHR24355:SF17', NULL, NULL, NULL, NULL, 'BETA-ADRENERGIC RECEPTOR KINASE 2', 244132),
(345814, 'PTHR24355:SF28', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR KINASE 2', 244132),
(345815, 'PTHR24355:SF29', NULL, NULL, NULL, NULL, 'RHODOPSIN KINASE GRK7-B', 244132),
(345816, 'PTHR24355:SF1', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S6 KINASE-RELATED PROTEIN', 244132),
(345817, 'PTHR24355:SF18', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR KINASE', 244132),
(345818, 'PTHR24355', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR KINASE/RIBOSOMAL PROTEIN S6 KINASE', 244132);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(345819, 'PTHR24355:SF30', NULL, NULL, NULL, NULL, 'SERINE/THREONINE KINASE 32A', 244132),
(345820, 'PTHR24355:SF22', NULL, NULL, NULL, NULL, 'BETA-ADRENERGIC RECEPTOR KINASE 1', 244132),
(345821, 'PTHR24355:SF11', NULL, NULL, NULL, NULL, 'RHODOPSIN KINASE GRK1', 244132),
(345822, 'PTHR24355:SF23', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR KINASE', 244132),
(345823, 'PTHR24355:SF12', NULL, NULL, NULL, NULL, 'RHODOPSIN KINASE GRK7', 244132),
(345824, 'PTHR24355:SF15', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR KINASE 6', 244132),
(345825, 'PTHR24355:SF26', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR KINASE', 244132),
(345826, 'PTHR24355:SF27', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR KINASE 5', 244132),
(345827, 'PTHR24355:SF14', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR KINASE 4', 244132),
(345828, 'PTHR21490:SF3', NULL, NULL, NULL, NULL, 'ENKURIN DOMAIN-CONTAINING PROTEIN', 244133),
(345829, 'PTHR21490:SF0', NULL, NULL, NULL, NULL, 'ENKURIN', 244133),
(345830, 'PTHR21490', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244133),
(345831, 'PTHR21490:SF2', NULL, NULL, NULL, NULL, 'ENKURIN DOMAIN-CONTAINING PROTEIN 1', 244133),
(345832, 'PTHR35090', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT I', 244134),
(345833, 'PTHR35090:SF1', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT I', 244134),
(345834, 'PTHR46533', NULL, NULL, NULL, NULL, 'ZINC FINGER MYND DOMAIN-CONTAINING PROTEIN 12', 244135),
(345835, 'PTHR46533:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER MYND DOMAIN-CONTAINING PROTEIN 12', 244135),
(345836, 'PTHR41148:SF1', NULL, NULL, NULL, NULL, 'LP09875P', 244136),
(345837, 'PTHR41148', NULL, NULL, NULL, NULL, 'LP09875P', 244136),
(345838, 'PTHR33155:SF29', NULL, NULL, NULL, NULL, 'PROTEIN FANTASTIC FOUR 1-LIKE', 244137),
(345839, 'PTHR33155:SF61', NULL, NULL, NULL, NULL, 'THE FANTASTIC FOUR FAMILY-RELATED', 244137),
(345840, 'PTHR33155:SF41', NULL, NULL, NULL, NULL, 'PROTEIN FAF-LIKE, CHLOROPLASTIC', 244137),
(345841, 'PTHR33155:SF63', NULL, NULL, NULL, NULL, '', 244137),
(345842, 'PTHR33155:SF40', NULL, NULL, NULL, NULL, 'BNAANNG08790D PROTEIN', 244137),
(345843, 'PTHR33155:SF62', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244137),
(345844, 'PTHR33155:SF69', NULL, NULL, NULL, NULL, 'PROTEIN FANTASTIC FOUR 2-LIKE', 244137),
(345845, 'PTHR33155:SF46', NULL, NULL, NULL, NULL, '', 244137),
(345846, 'PTHR33155:SF68', NULL, NULL, NULL, NULL, 'DUF3049 FAMILY PROTEIN', 244137),
(345847, 'PTHR33155:SF27', NULL, NULL, NULL, NULL, 'FANTASTIC FOUR-LIKE PROTEIN (DUF3049)', 244137),
(345848, 'PTHR33155:SF26', NULL, NULL, NULL, NULL, 'DUF3049 FAMILY PROTEIN', 244137),
(345849, 'PTHR33155:SF65', NULL, NULL, NULL, NULL, 'BNAA02G05450D PROTEIN', 244137),
(345850, 'PTHR33155:SF64', NULL, NULL, NULL, NULL, '', 244137),
(345851, 'PTHR33155:SF67', NULL, NULL, NULL, NULL, 'THE FANTASTIC FOUR FAMILY-RELATED', 244137),
(345852, 'PTHR33155:SF23', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244137),
(345853, 'PTHR33155:SF66', NULL, NULL, NULL, NULL, '', 244137),
(345854, 'PTHR33155:SF44', NULL, NULL, NULL, NULL, 'BNAA02G05610D PROTEIN', 244137),
(345855, 'PTHR33155:SF39', NULL, NULL, NULL, NULL, 'OS06G0224000 PROTEIN', 244137),
(345856, 'PTHR33155:SF17', NULL, NULL, NULL, NULL, 'F2E2.18-RELATED', 244137),
(345857, 'PTHR33155:SF19', NULL, NULL, NULL, NULL, 'PROTEIN FANTASTIC FOUR 2', 244137),
(345858, 'PTHR33155:SF50', NULL, NULL, NULL, NULL, 'BNACNNG43270D PROTEIN', 244137),
(345859, 'PTHR33155:SF5', NULL, NULL, NULL, NULL, '', 244137),
(345860, 'PTHR33155:SF72', NULL, NULL, NULL, NULL, '', 244137),
(345861, 'PTHR33155:SF4', NULL, NULL, NULL, NULL, 'PROTEIN FANTASTIC FOUR 3', 244137),
(345862, 'PTHR33155:SF71', NULL, NULL, NULL, NULL, 'PROTEIN FANTASTIC FOUR 1-LIKE', 244137),
(345863, 'PTHR33155:SF3', NULL, NULL, NULL, NULL, 'PROTEIN FAF-LIKE, CHLOROPLASTIC', 244137),
(345864, 'PTHR33155:SF73', NULL, NULL, NULL, NULL, 'BNAA03G57340D PROTEIN', 244137),
(345865, 'PTHR33155:SF9', NULL, NULL, NULL, NULL, 'FANTASTIC FOUR-LIKE PROTEIN (DUF3049)', 244137);
INSERT INTO "PUBLIC"."MODEL" VALUES
(345866, 'PTHR33155:SF8', NULL, NULL, NULL, NULL, 'PROTEIN FANTASTIC FOUR 1', 244137),
(345867, 'PTHR33155:SF70', NULL, NULL, NULL, NULL, 'OS02G0750800 PROTEIN', 244137),
(345868, 'PTHR33155:SF7', NULL, NULL, NULL, NULL, 'OS11G0643600 PROTEIN', 244137),
(345869, 'PTHR33155:SF58', NULL, NULL, NULL, NULL, 'DUF3049 FAMILY PROTEIN', 244137),
(345870, 'PTHR33155', NULL, NULL, NULL, NULL, 'FANTASTIC FOUR-LIKE PROTEIN (DUF3049)', 244137),
(345871, 'PTHR33155:SF15', NULL, NULL, NULL, NULL, 'PROTEIN FANTASTIC FOUR 4', 244137),
(345872, 'PTHR33155:SF37', NULL, NULL, NULL, NULL, 'PROTEIN FANTASTIC FOUR 3', 244137),
(345873, 'PTHR33155:SF54', NULL, NULL, NULL, NULL, '', 244137),
(345874, 'PTHR33155:SF32', NULL, NULL, NULL, NULL, 'PROTEIN FAF-LIKE, CHLOROPLASTIC', 244137),
(345875, 'PTHR33155:SF53', NULL, NULL, NULL, NULL, 'FANTASTIC FOUR-LIKE PROTEIN', 244137),
(345876, 'PTHR33155:SF56', NULL, NULL, NULL, NULL, 'CONSTITUENT OF RIBOSOME, PUTATIVE-RELATED', 244137),
(345877, 'PTHR33155:SF34', NULL, NULL, NULL, NULL, 'BNAA08G27370D PROTEIN', 244137),
(345878, 'PTHR33155:SF55', NULL, NULL, NULL, NULL, 'PROTEIN FANTASTIC FOUR 3-LIKE', 244137),
(345879, 'PTHR30632:SF11', NULL, NULL, NULL, NULL, 'BLR4797 PROTEIN', 244138),
(345880, 'PTHR30632', NULL, NULL, NULL, NULL, 'MOLYBDATE-BINDING PERIPLASMIC PROTEIN', 244138),
(345881, 'PTHR30632:SF14', NULL, NULL, NULL, NULL, 'MOLYBDATE PERIPLASMIC BINDING PROTEIN', 244138),
(345882, 'PTHR30632:SF16', NULL, NULL, NULL, NULL, 'MOLYBDATE/TUNGSTATE-BINDING PROTEIN WTPA', 244138),
(345883, 'PTHR30632:SF17', NULL, NULL, NULL, NULL, 'MOLYBDATE-BINDING PROTEIN MODA', 244138),
(345884, 'PTHR30632:SF0', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER SUBSTRATE-BINDING LIPOPROTEIN YVGL-RELATED', 244138),
(345885, 'PTHR10344:SF1', NULL, NULL, NULL, NULL, 'THYMIDYLATE KINASE', 244139),
(345886, 'PTHR10344:SF4', NULL, NULL, NULL, NULL, 'UMP-CMP KINASE 2, MITOCHONDRIAL', 244139),
(345887, 'PTHR10344', NULL, NULL, NULL, NULL, 'THYMIDYLATE KINASE', 244139),
(345888, 'PTHR48181:SF1', NULL, NULL, NULL, NULL, '', 244140),
(345889, 'PTHR48181', NULL, NULL, NULL, NULL, '', 244140),
(345890, 'PTHR13323:SF5', NULL, NULL, NULL, NULL, 'ROBL_LC7 DOMAIN-CONTAINING PROTEIN', 244141),
(345891, 'PTHR13323', NULL, NULL, NULL, NULL, 'LATE ENDOSOMAL/LYSOSOMAL MP1 INTERACTING PROTEIN', 244141),
(345892, 'PTHR13323:SF4', NULL, NULL, NULL, NULL, 'RAGULATOR COMPLEX PROTEIN LAMTOR2', 244141),
(345893, 'PTHR24270:SF3', NULL, NULL, NULL, NULL, 'LOW-DENSITY LIPOPROTEIN RECEPTOR-RELATED PROTEIN 8', 244142),
(345894, 'PTHR24270:SF47', NULL, NULL, NULL, NULL, 'LOW-DENSITY LIPOPROTEIN RECEPTOR-RELATED PROTEIN 12', 244142),
(345895, 'PTHR24270:SF2', NULL, NULL, NULL, NULL, 'ATRIAL NATRIURETIC PEPTIDE-CONVERTING ENZYME', 244142),
(345896, 'PTHR24270:SF46', NULL, NULL, NULL, NULL, 'PROLOW-DENSITY LIPOPROTEIN RECEPTOR-RELATED PROTEIN 1-LIKE PROTEIN', 244142),
(345897, 'PTHR24270:SF24', NULL, NULL, NULL, NULL, 'LOW-DENSITY LIPOPROTEIN RECEPTOR CLASS A DOMAIN-CONTAINING PROTEIN 3', 244142),
(345898, 'PTHR24270:SF49', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 244142),
(345899, 'PTHR24270:SF5', NULL, NULL, NULL, NULL, 'LOW-DENSITY LIPOPROTEIN RECEPTOR-RELATED PROTEIN 4', 244142),
(345900, 'PTHR24270:SF27', NULL, NULL, NULL, NULL, 'CD320 ANTIGEN', 244142),
(345901, 'PTHR24270:SF21', NULL, NULL, NULL, NULL, 'LOW-DENSITY LIPOPROTEIN RECEPTOR', 244142),
(345902, 'PTHR24270:SF42', NULL, NULL, NULL, NULL, 'LOW-DENSITY LIPOPROTEIN RECEPTOR RELATED', 244142),
(345903, 'PTHR24270:SF20', NULL, NULL, NULL, NULL, 'LOW DENSITY LIPOPROTEIN RECEPTOR-RELATED PROTEIN 1BA-RELATED', 244142),
(345904, 'PTHR24270:SF23', NULL, NULL, NULL, NULL, 'PROLOW-DENSITY LIPOPROTEIN RECEPTOR-RELATED PROTEIN 1', 244142),
(345905, 'PTHR24270:SF22', NULL, NULL, NULL, NULL, 'LOW-DENSITY LIPOPROTEIN RECEPTOR-RELATED PROTEIN 3', 244142),
(345906, 'PTHR24270:SF8', NULL, NULL, NULL, NULL, 'CUB AND LDLA DOMAIN, ISOFORM A-RELATED', 244142),
(345907, 'PTHR24270:SF16', NULL, NULL, NULL, NULL, 'VERY LOW-DENSITY LIPOPROTEIN RECEPTOR', 244142),
(345908, 'PTHR24270:SF32', NULL, NULL, NULL, NULL, 'LOW DENSITY LIPOPROTEIN RECEPTOR-RELATED PROTEIN 2A', 244142); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(345909, 'PTHR24270:SF54', NULL, NULL, NULL, NULL, 'GENE, 19410-RELATED', 244142),
(345910, 'PTHR24270:SF53', NULL, NULL, NULL, NULL, 'LAMININ EGF-LIKE DOMAIN-CONTAINING PROTEIN', 244142),
(345911, 'PTHR24270:SF56', NULL, NULL, NULL, NULL, 'LOW-DENSITY LIPOPROTEIN RECEPTOR-RELATED PROTEIN', 244142),
(345912, 'PTHR24270:SF55', NULL, NULL, NULL, NULL, 'VERY LOW-DENSITY LIPOPROTEIN RECEPTOR', 244142),
(345913, 'PTHR24270:SF17', NULL, NULL, NULL, NULL, 'LOW-DENSITY LIPOPROTEIN RECEPTOR-RELATED PROTEIN 10', 244142),
(345914, 'PTHR24270', NULL, NULL, NULL, NULL, 'LOW-DENSITY LIPOPROTEIN RECEPTOR-RELATED', 244142),
(345915, 'PTHR24270:SF50', NULL, NULL, NULL, NULL, '', 244142),
(345916, 'PTHR24270:SF52', NULL, NULL, NULL, NULL, 'CD320 ANTIGEN', 244142),
(345917, 'PTHR24270:SF51', NULL, NULL, NULL, NULL, 'LOW-DENSITY LIPOPROTEIN RECEPTOR-RELATED PROTEIN', 244142),
(345918, 'PTHR13482', NULL, NULL, NULL, NULL, 'MICRORNA PROCESSOR COMPLEX SUBUNIT DGCR8', 244143),
(345919, 'PTHR13482:SF3', NULL, NULL, NULL, NULL, 'MICROPROCESSOR COMPLEX SUBUNIT DGCR8', 244143),
(345920, 'PTHR45125:SF3', NULL, NULL, NULL, NULL, 'NAM-LIKE PROTEIN', 244144),
(345921, 'PTHR45125', NULL, NULL, NULL, NULL, 'F21J9.4-RELATED', 244144),
(345922, 'PTHR45125:SF40', NULL, NULL, NULL, NULL, 'OS06G0117800 PROTEIN', 244144),
(345923, 'PTHR45125:SF41', NULL, NULL, NULL, NULL, 'NO-APICAL-MERISTEM-ASSOCIATED CARBOXY-TERMINAL DOMAIN PROTEIN', 244144),
(345924, 'PTHR45125:SF42', NULL, NULL, NULL, NULL, 'NAM-ASSOCIATED DOMAIN-CONTAINING PROTEIN', 244144),
(345925, 'PTHR45125:SF8', NULL, NULL, NULL, NULL, 'OS05G0227800 PROTEIN', 244144),
(345926, 'PTHR45125:SF37', NULL, NULL, NULL, NULL, 'NAM-ASSOCIATED DOMAIN-CONTAINING PROTEIN', 244144),
(345927, 'PTHR45125:SF38', NULL, NULL, NULL, NULL, 'OS12G0543800 PROTEIN', 244144),
(345928, 'PTHR45125:SF28', NULL, NULL, NULL, NULL, 'OS02G0603500 PROTEIN', 244144),
(345929, 'PTHR45125:SF39', NULL, NULL, NULL, NULL, 'NAM-ASSOCIATED DOMAIN-CONTAINING PROTEIN', 244144),
(345930, 'PTHR45125:SF18', NULL, NULL, NULL, NULL, 'NAM-ASSOCIATED DOMAIN-CONTAINING PROTEIN', 244144),
(345931, 'PTHR45125:SF29', NULL, NULL, NULL, NULL, 'NAM-ASSOCIATED DOMAIN-CONTAINING PROTEIN', 244144),
(345932, 'PTHR45125:SF33', NULL, NULL, NULL, NULL, 'NAM-ASSOCIATED DOMAIN-CONTAINING PROTEIN', 244144),
(345933, 'PTHR45125:SF34', NULL, NULL, NULL, NULL, 'NAM-ASSOCIATED DOMAIN-CONTAINING PROTEIN', 244144),
(345934, 'PTHR45125:SF24', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 244144),
(345935, 'PTHR45125:SF35', NULL, NULL, NULL, NULL, 'NAM-ASSOCIATED DOMAIN-CONTAINING PROTEIN', 244144),
(345936, 'PTHR45125:SF36', NULL, NULL, NULL, NULL, 'BNAC01G27460D PROTEIN', 244144),
(345937, 'PTHR46958', NULL, NULL, NULL, NULL, 'B-CELL RECEPTOR CD22', 244145),
(345938, 'PTHR46958:SF1', NULL, NULL, NULL, NULL, 'B-CELL RECEPTOR CD22', 244145),
(345939, 'PTHR31148', NULL, NULL, NULL, NULL, 'U1 SMALL NUCLEAR RIBONUCLEOPROTEIN C', 244146),
(345940, 'PTHR31148:SF1', NULL, NULL, NULL, NULL, 'U1 SMALL NUCLEAR RIBONUCLEOPROTEIN C', 244146),
(345941, 'PTHR31148:SF6', NULL, NULL, NULL, NULL, 'U1 SMALL NUCLEAR RIBONUCLEOPROTEIN C', 244146),
(345942, 'PTHR31148:SF7', NULL, NULL, NULL, NULL, 'U1 SMALL NUCLEAR RIBONUCLEOPROTEIN C', 244146),
(345943, 'PTHR13815', NULL, NULL, NULL, NULL, 'GOLGIN-84', 244147),
(345944, 'PTHR13815:SF7', NULL, NULL, NULL, NULL, 'GOLGIN SUBFAMILY A MEMBER 5', 244147),
(345945, 'PTHR13815:SF5', NULL, NULL, NULL, NULL, 'GOLGIN CANDIDATE 2', 244147),
(345946, 'PTHR10032:SF220', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR OVO-LIKE PROTEIN 3-RELATED', 244148),
(345947, 'PTHR10032:SF271', NULL, NULL, NULL, NULL, 'RH12261P-RELATED', 244148),
(345948, 'PTHR10032:SF193', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR OVO-LIKE 2', 244148),
(345949, 'PTHR10032:SF217', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR OVO-LIKE 1-RELATED', 244148),
(345950, 'PTHR10032', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN WITH KRAB AND SCAN DOMAINS', 244148),
(345951, 'PTHR46003:SF2', NULL, NULL, NULL, NULL, 'HOST CELL FACTOR 2', 244149);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(345952, 'PTHR46003:SF3', NULL, NULL, NULL, NULL, 'HOST CELL FACTOR 1', 244149),
(345953, 'PTHR46003', NULL, NULL, NULL, NULL, 'HOST CELL FACTOR', 244149),
(345954, 'PTHR46003:SF1', NULL, NULL, NULL, NULL, 'HOST CELL FACTOR', 244149),
(345955, 'PTHR12708:SF0', NULL, NULL, NULL, NULL, 'DNA POLYMERASE EPSILON SUBUNIT 2', 244150),
(345956, 'PTHR12708', NULL, NULL, NULL, NULL, 'DNA POLYMERASE EPSILON SUBUNIT B', 244150),
(345957, 'PTHR46882:SF1', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY N MEMBER 1', 244151),
(345958, 'PTHR46882', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY N MEMBER 1', 244151),
(345959, 'PTHR13223:SF2', NULL, NULL, NULL, NULL, 'ACIDIC FIBROBLAST GROWTH FACTOR INTRACELLULAR-BINDING PROTEIN', 244152),
(345960, 'PTHR13223', NULL, NULL, NULL, NULL, 'ACIDIC FIBROBLAST GROWTH FACTOR INTRACELLULAR BINDING PROTEIN', 244152),
(345961, 'PTHR13284', NULL, NULL, NULL, NULL, 'GH01354P', 244153),
(345962, 'PTHR13284:SF9', NULL, NULL, NULL, NULL, 'SELENOCYSTEINE INSERTION SEQUENCE-BINDING PROTEIN 2', 244153),
(345963, 'PTHR13284:SF4', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L7AE DOMAIN-CONTAINING PROTEIN', 244153),
(345964, 'PTHR13284:SF10', NULL, NULL, NULL, NULL, 'SELENOCYSTEINE INSERTION SEQUENCE-BINDING PROTEIN 2-LIKE', 244153),
(345965, 'PTHR15937', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 7 SUPERFAMILY MEMBER 3', 244154),
(345966, 'PTHR15937:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 7 SUPERFAMILY MEMBER 3', 244154),
(345967, 'PTHR39328:SF1', NULL, NULL, NULL, NULL, 'BLL2871 PROTEIN', 244155),
(345968, 'PTHR39328', NULL, NULL, NULL, NULL, 'BLL2871 PROTEIN', 244155),
(345969, 'PTHR37381', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT (PPR) SUPERFAMILY PROTEIN', 244156),
(345970, 'PTHR37381:SF1', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT (PPR) SUPERFAMILY PROTEIN', 244156),
(345971, 'PTHR11334:SF3', NULL, NULL, NULL, NULL, 'MAS-RELATED G-PROTEIN COUPLED RECEPTOR MEMBER F', 244157),
(345972, 'PTHR11334:SF1', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 152-RELATED', 244157),
(345973, 'PTHR11334:SF36', NULL, NULL, NULL, NULL, 'MAS-RELATED G-PROTEIN COUPLED RECEPTOR MEMBER B4-RELATED', 244157),
(345974, 'PTHR11334:SF26', NULL, NULL, NULL, NULL, 'MAS-RELATED G-PROTEIN COUPLED RECEPTOR MEMBER E', 244157),
(345975, 'PTHR11334:SF59', NULL, NULL, NULL, NULL, 'MAS-RELATED G-PROTEIN COUPLED RECEPTOR MEMBER X4', 244157),
(345976, 'PTHR11334:SF34', NULL, NULL, NULL, NULL, 'MAS-RELATED G-PROTEIN COUPLED RECEPTOR MEMBER X3', 244157),
(345977, 'PTHR11334:SF57', NULL, NULL, NULL, NULL, 'MAS-RELATED G-PROTEIN COUPLED RECEPTOR MEMBER D', 244157),
(345978, 'PTHR11334:SF29', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN-RELATED', 244157),
(345979, 'PTHR11334:SF8', NULL, NULL, NULL, NULL, 'MAS-RELATED G-PROTEIN COUPLED RECEPTOR MEMBER B8', 244157),
(345980, 'PTHR11334:SF61', NULL, NULL, NULL, NULL, 'MAS-RELATED G-PROTEIN COUPLED RECEPTOR MRG-RELATED', 244157),
(345981, 'PTHR11334:SF62', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 244157),
(345982, 'PTHR11334', NULL, NULL, NULL, NULL, 'MAS-RELATED G-PROTEIN COUPLED RECEPTOR', 244157),
(345983, 'PTHR11334:SF60', NULL, NULL, NULL, NULL, 'MAS-RELATED G-PROTEIN COUPLED RECEPTOR MEMBER H', 244157),
(345984, 'PTHR11334:SF32', NULL, NULL, NULL, NULL, 'MAS-RELATED G-PROTEIN COUPLED RECEPTOR MEMBER G', 244157),
(345985, 'PTHR11334:SF22', NULL, NULL, NULL, NULL, 'MAS-RELATED G-PROTEIN COUPLED RECEPTOR MEMBER X1', 244157),
(345986, 'PTHR11334:SF33', NULL, NULL, NULL, NULL, 'MAS-RELATED GPR, MEMBER A2A-RELATED', 244157),
(345987, 'PTHR11334:SF63', NULL, NULL, NULL, NULL, 'MAS-RELATED G-PROTEIN COUPLED RECEPTOR MEMBER X2', 244157),
(345988, 'PTHR11334:SF31', NULL, NULL, NULL, NULL, 'MAS-RELATED G-PROTEIN COUPLED RECEPTOR MEMBER B3', 244157),
(345989, 'PTHR11334:SF64', NULL, NULL, NULL, NULL, 'MAS-RELATED G-PROTEIN COUPLED RECEPTOR MEMBER B2', 244157),
(345990, 'PTHR10858', NULL, NULL, NULL, NULL, 'DEOXYRIBONUCLEASE II', 244158),
(345991, 'PTHR10858:SF22', NULL, NULL, NULL, NULL, 'DEOXYRIBONUCLEASE II FAMILY PROTEIN', 244158);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(345992, 'PTHR10858:SF2', NULL, NULL, NULL, NULL, 'DEOXYRIBONUCLEASE-2-BETA', 244158),
(345993, 'PTHR10858:SF30', NULL, NULL, NULL, NULL, 'CELL-DEATH-RELATED NUCLEASE 7', 244158),
(345994, 'PTHR10858:SF25', NULL, NULL, NULL, NULL, 'DEOXYRIBONUCLEASE II FAMILY PROTEIN', 244158),
(345995, 'PTHR10858:SF24', NULL, NULL, NULL, NULL, 'CELL DEATH-RELATED NUCLEASE 6', 244158),
(345996, 'PTHR10858:SF23', NULL, NULL, NULL, NULL, 'DEOXYRIBONUCLEASE-2', 244158),
(345997, 'PTHR10858:SF29', NULL, NULL, NULL, NULL, 'DEOXYRIBONUCLEASE II', 244158),
(345998, 'PTHR10858:SF9', NULL, NULL, NULL, NULL, 'DEOXYRIBONUCLEASE-2-ALPHA', 244158),
(345999, 'PTHR31982:SF5', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I REACTION CENTER SUBUNIT II', 244159),
(346000, 'PTHR31982', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I REACTION CENTER SUBUNIT II-1, CHLOROPLASTIC-RELATED', 244159),
(346001, 'PTHR31982:SF6', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I REACTION CENTER SUBUNIT II-1, CHLOROPLASTIC-RELATED', 244159),
(346002, 'PTHR37872', NULL, NULL, NULL, NULL, 'SIMILAR TO RIKEN CDNA 1700029I15', 244160),
(346003, 'PTHR37872:SF1', NULL, NULL, NULL, NULL, 'SIMILAR TO RIKEN CDNA 1700029I15', 244160),
(346004, 'PTHR31260:SF64', NULL, NULL, NULL, NULL, 'BNAA01G07310D PROTEIN', 244161),
(346005, 'PTHR31260:SF42', NULL, NULL, NULL, NULL, 'CYSTATIN DOMAIN-CONTAINING PROTEIN', 244161),
(346006, 'PTHR31260:SF41', NULL, NULL, NULL, NULL, 'BNAA04G21710D PROTEIN', 244161),
(346007, 'PTHR31260:SF40', NULL, NULL, NULL, NULL, 'BNAA08G13290D PROTEIN', 244161),
(346008, 'PTHR31260:SF61', NULL, NULL, NULL, NULL, 'MULTICYSTATIN-LIKE ISOFORM X1', 244161),
(346009, 'PTHR31260:SF46', NULL, NULL, NULL, NULL, 'UPF0725 PROTEIN EMB2204', 244161),
(346010, 'PTHR31260:SF68', NULL, NULL, NULL, NULL, '', 244161),
(346011, 'PTHR31260:SF45', NULL, NULL, NULL, NULL, '', 244161),
(346012, 'PTHR31260:SF67', NULL, NULL, NULL, NULL, 'CYSTATIN DOMAIN-CONTAINING PROTEIN', 244161),
(346013, 'PTHR31260:SF66', NULL, NULL, NULL, NULL, 'CYSTATIN DOMAIN-CONTAINING PROTEIN', 244161),
(346014, 'PTHR31260:SF44', NULL, NULL, NULL, NULL, 'BNAA01G07080D PROTEIN', 244161),
(346015, 'PTHR31260:SF43', NULL, NULL, NULL, NULL, '', 244161),
(346016, 'PTHR31260:SF65', NULL, NULL, NULL, NULL, 'BNAANNG28850D PROTEIN', 244161),
(346017, 'PTHR31260:SF60', NULL, NULL, NULL, NULL, 'BNAANNG11310D PROTEIN', 244161),
(346018, 'PTHR31260:SF28', NULL, NULL, NULL, NULL, 'MULTICYSTATIN-LIKE', 244161),
(346019, 'PTHR31260:SF49', NULL, NULL, NULL, NULL, 'BNACNNG73910D PROTEIN', 244161),
(346020, 'PTHR31260', NULL, NULL, NULL, NULL, 'CYSTATIN/MONELLIN SUPERFAMILY PROTEIN', 244161),
(346021, 'PTHR31260:SF48', NULL, NULL, NULL, NULL, 'BNAC02G24000D PROTEIN', 244161),
(346022, 'PTHR31260:SF47', NULL, NULL, NULL, NULL, 'BNAA10G10980D PROTEIN', 244161),
(346023, 'PTHR31260:SF69', NULL, NULL, NULL, NULL, 'CYSTATIN/MONELLIN SUPERFAMILY PROTEIN', 244161),
(346024, 'PTHR31260:SF53', NULL, NULL, NULL, NULL, 'BNAA10G29010D PROTEIN', 244161),
(346025, 'PTHR31260:SF31', NULL, NULL, NULL, NULL, 'BNAC02G16770D PROTEIN', 244161),
(346026, 'PTHR31260:SF50', NULL, NULL, NULL, NULL, 'BNAC08G14090D PROTEIN', 244161),
(346027, 'PTHR31260:SF72', NULL, NULL, NULL, NULL, '', 244161),
(346028, 'PTHR31260:SF35', NULL, NULL, NULL, NULL, 'BNAC05G32080D PROTEIN', 244161),
(346029, 'PTHR31260:SF57', NULL, NULL, NULL, NULL, 'BNAA08G00220D PROTEIN', 244161),
(346030, 'PTHR31260:SF56', NULL, NULL, NULL, NULL, 'BNAA08G14180D PROTEIN', 244161),
(346031, 'PTHR31260:SF34', NULL, NULL, NULL, NULL, 'BNAA08G31070D PROTEIN', 244161),
(346032, 'PTHR31260:SF55', NULL, NULL, NULL, NULL, 'BNAA10G11000D PROTEIN', 244161),
(346033, 'PTHR31260:SF32', NULL, NULL, NULL, NULL, '', 244161),
(346034, 'PTHR31260:SF54', NULL, NULL, NULL, NULL, 'BNAC03G13230D PROTEIN', 244161),
(346035, 'PTHR31260:SF71', NULL, NULL, NULL, NULL, 'BNAC03G13210D PROTEIN', 244161),
(346036, 'PTHR31260:SF70', NULL, NULL, NULL, NULL, 'BNAC06G02610D PROTEIN', 244161),
(346037, 'PTHR31260:SF39', NULL, NULL, NULL, NULL, 'BNAA09G28770D PROTEIN', 244161),
(346038, 'PTHR31260:SF37', NULL, NULL, NULL, NULL, '', 244161);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(346039, 'PTHR31260:SF59', NULL, NULL, NULL, NULL, 'BNAA05G08490D PROTEIN', 244161),
(346040, 'PTHR31260:SF36', NULL, NULL, NULL, NULL, 'BNAC07G12930D PROTEIN', 244161),
(346041, 'PTHR31260:SF58', NULL, NULL, NULL, NULL, 'BNAANNG24590D PROTEIN', 244161),
(346042, 'PTHR31534', NULL, NULL, NULL, NULL, 'ATAXIN 7, ISOFORM A', 244162),
(346043, 'PTHR31534:SF3', NULL, NULL, NULL, NULL, 'ATAXIN 7, ISOFORM A', 244162),
(346044, 'PTHR31534:SF4', NULL, NULL, NULL, NULL, '', 244162),
(346045, 'PTHR31534:SF9', NULL, NULL, NULL, NULL, '', 244162),
(346046, 'PTHR31534:SF10', NULL, NULL, NULL, NULL, '', 244162),
(346047, 'PTHR38432:SF1', NULL, NULL, NULL, NULL, 'TELA-LIKE PROTEIN SAOUHSC_01408', 244163),
(346048, 'PTHR38432:SF2', NULL, NULL, NULL, NULL, 'TELLURITE RESISTANCE PROTEIN', 244163),
(346049, 'PTHR38432', NULL, NULL, NULL, NULL, 'TELA-LIKE PROTEIN SAOUHSC_01408', 244163),
(346050, 'PTHR34142:SF6', NULL, NULL, NULL, NULL, 'ENDO-BETA-1,4-GLUCANASE B', 244164),
(346051, 'PTHR34142:SF5', NULL, NULL, NULL, NULL, 'CBM1 DOMAIN-CONTAINING PROTEIN', 244164),
(346052, 'PTHR34142:SF2', NULL, NULL, NULL, NULL, 'CBM49 DOMAIN-CONTAINING PROTEIN', 244164),
(346053, 'PTHR34142:SF1', NULL, NULL, NULL, NULL, 'CELLULASE DOMAIN-CONTAINING PROTEIN', 244164),
(346054, 'PTHR34142', NULL, NULL, NULL, NULL, 'ENDO-BETA-1,4-GLUCANASE A', 244164),
(346055, 'PTHR34142:SF4', NULL, NULL, NULL, NULL, 'GALACTOSE-BINDING DOMAIN-CONTAINING PROTEIN', 244164),
(346056, 'PTHR48118:SF1', NULL, NULL, NULL, NULL, 'SPINDLE AND KINETOCHORE-ASSOCIATED PROTEIN 3', 244165),
(346057, 'PTHR48118', NULL, NULL, NULL, NULL, 'SPINDLE AND KINETOCHORE-ASSOCIATED PROTEIN 3', 244165),
(346058, 'PTHR46758:SF5', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN', 244166),
(346059, 'PTHR46758:SF4', NULL, NULL, NULL, NULL, 'MYND FINGER FAMILY PROTEIN, EXPRESSED', 244166),
(346060, 'PTHR46758', NULL, NULL, NULL, NULL, 'MYND DOMAIN-CONTAINING', 244166),
(346061, 'PTHR46758:SF9', NULL, NULL, NULL, NULL, 'MYND-TYPE DOMAIN-CONTAINING PROTEIN', 244166),
(346062, 'PTHR46758:SF7', NULL, NULL, NULL, NULL, 'HCP FAMILY PROTEIN WITH MYND-TYPE ZINC FINGER PROTEIN', 244166),
(346063, 'PTHR46758:SF20', NULL, NULL, NULL, NULL, 'HCP-LIKE SUPERFAMILY PROTEIN', 244166),
(346064, 'PTHR46758:SF10', NULL, NULL, NULL, NULL, 'MYND-TYPE DOMAIN-CONTAINING PROTEIN', 244166),
(346065, 'PTHR46758:SF13', NULL, NULL, NULL, NULL, 'OS02G0506400 PROTEIN', 244166),
(346066, 'PTHR46758:SF15', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN, ZINC FINGER, MYND-TYPE, TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN PROTEIN-RELATED', 244166),
(346067, 'PTHR46758:SF14', NULL, NULL, NULL, NULL, 'MYND-TYPE DOMAIN-CONTAINING PROTEIN', 244166),
(346068, 'PTHR46758:SF17', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN, ZINC FINGER, MYND-TYPE, TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN PROTEIN-RELATED', 244166),
(346069, 'PTHR46758:SF16', NULL, NULL, NULL, NULL, 'ZINC FINGER, MYND-TYPE, TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN PROTEIN-RELATED', 244166),
(346070, 'PTHR46758:SF19', NULL, NULL, NULL, NULL, 'ZINC FINGER, MYND-TYPE, TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN PROTEIN-RELATED', 244166),
(346071, 'PTHR46758:SF18', NULL, NULL, NULL, NULL, 'OS04G0385600 PROTEIN', 244166),
(346072, 'PTHR46758:SF2', NULL, NULL, NULL, NULL, 'OJ1485_B09.11 PROTEIN', 244166),
(346073, 'PTHR12304:SF25', NULL, NULL, NULL, NULL, 'IU_NUC_HYDRO DOMAIN-CONTAINING PROTEIN', 244167),
(346074, 'PTHR12304:SF58', NULL, NULL, NULL, NULL, 'INOSINE-URIDINE PREFERRING NUCLEOSIDE HYDROLASE FAMILY PROTEIN', 244167),
(346075, 'PTHR12304:SF15', NULL, NULL, NULL, NULL, 'NON-SPECIFIC RIBONUCLEOSIDE HYDROLASE RIHC', 244167),
(346076, 'PTHR12304:SF59', NULL, NULL, NULL, NULL, 'INOSINE-URIDINE PREFERRING NUCLEOSIDE HYDROLASE FAMILY PROTEIN', 244167),
(346077, 'PTHR12304:SF54', NULL, NULL, NULL, NULL, 'INOSINE-URIDINE PREFERRING NUCLEOSIDE HYDROLASE FAMILY PROTEIN', 244167),
(346078, 'PTHR12304:SF21', NULL, NULL, NULL, NULL, 'URIDINE NUCLEOSIDASE 2-RELATED', 244167),
(346079, 'PTHR12304:SF4', NULL, NULL, NULL, NULL, 'URIDINE NUCLEOSIDASE', 244167),
(346080, 'PTHR12304:SF55', NULL, NULL, NULL, NULL, 'URIDINE NUCLEOSIDASE 1-LIKE', 244167);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(346081, 'PTHR12304:SF56', NULL, NULL, NULL, NULL, 'HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G11790)-RELATED', 244167),
(346082, 'PTHR12304:SF57', NULL, NULL, NULL, NULL, 'IU_NUC_HYDRO DOMAIN-CONTAINING PROTEIN', 244167),
(346083, 'PTHR12304:SF1', NULL, NULL, NULL, NULL, 'URIDINE NUCLEOSIDASE 1', 244167),
(346084, 'PTHR12304:SF46', NULL, NULL, NULL, NULL, 'INOSINE-ADENOSINE-GUANOSINE-NUCLEOSIDE HYDROLASE', 244167),
(346085, 'PTHR12304:SF50', NULL, NULL, NULL, NULL, 'INOSINE/URIDINE-PREFERRING NUCLEOSIDE HYDROLASE DOMAIN-CONTAINING PROTEIN-RELATED', 244167),
(346086, 'PTHR12304:SF51', NULL, NULL, NULL, NULL, 'IU_NUC_HYDRO DOMAIN-CONTAINING PROTEIN', 244167),
(346087, 'PTHR12304', NULL, NULL, NULL, NULL, 'INOSINE-URIDINE PREFERRING NUCLEOSIDE HYDROLASE', 244167),
(346088, 'PTHR47943:SF7', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 MONOOXYGENASE CYP736B', 244168),
(346089, 'PTHR47943:SF6', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 MONOOXYGENASE CYP736B', 244168),
(346090, 'PTHR47943:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 71 PROTEIN', 244168),
(346091, 'PTHR47943:SF5', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 93A3-LIKE', 244168),
(346092, 'PTHR47943:SF4', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 71 PROTEIN', 244168),
(346093, 'PTHR47943', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 93A3-LIKE', 244168),
(346094, 'PTHR10404:SF46', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 70', 244169),
(346095, 'PTHR10404:SF79', NULL, NULL, NULL, NULL, 'TRANSFERRIN RECEPTOR 1B', 244169),
(346096, 'PTHR10404:SF36', NULL, NULL, NULL, NULL, 'GLUTAMATE CARBOXYPEPTIDASE 2', 244169),
(346097, 'PTHR10404:SF26', NULL, NULL, NULL, NULL, 'TRANSFERRIN RECEPTOR PROTEIN 1', 244169),
(346098, 'PTHR10404:SF38', NULL, NULL, NULL, NULL, 'N-ACETYLATED-ALPHA-LINKED ACIDIC DIPEPTIDASE 2', 244169),
(346099, 'PTHR10404:SF75', NULL, NULL, NULL, NULL, 'GLUTAMATE CARBOXYPEPTIDASE AMP1-RELATED', 244169),
(346100, 'PTHR10404:SF76', NULL, NULL, NULL, NULL, 'PA DOMAIN-CONTAINING PROTEIN', 244169),
(346101, 'PTHR10404:SF32', NULL, NULL, NULL, NULL, 'INACTIVE N-ACETYLATED-ALPHA-LINKED ACIDIC DIPEPTIDASE-LIKE PROTEIN 2', 244169),
(346102, 'PTHR10404:SF77', NULL, NULL, NULL, NULL, 'N-ACETYLATED ALPHA-LINKED ACIDIC DIPEPTIDASE 2', 244169),
(346103, 'PTHR10404:SF33', NULL, NULL, NULL, NULL, 'TRANSFERRIN RECEPTOR PROTEIN 2', 244169),
(346104, 'PTHR10404:SF67', NULL, NULL, NULL, NULL, 'PEPTIDASE M28 FAMILY PROTEIN', 244169),
(346105, 'PTHR10404:SF78', NULL, NULL, NULL, NULL, 'PEPTIDASE_M28 DOMAIN-CONTAINING PROTEIN', 244169),
(346106, 'PTHR10404:SF45', NULL, NULL, NULL, NULL, 'OS01G0740500 PROTEIN', 244169),
(346107, 'PTHR10404', NULL, NULL, NULL, NULL, 'N-ACETYLATED-ALPHA-LINKED ACIDIC DIPEPTIDASE', 244169),
(346108, 'PTHR10404:SF71', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE TRE2, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G10650)-RELATED', 244169),
(346109, 'PTHR10404:SF72', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEASE TRE2-RELATED', 244169),
(346110, 'PTHR10404:SF50', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE NAALADL1', 244169),
(346111, 'PTHR10404:SF41', NULL, NULL, NULL, NULL, 'GLUTAMATE CARBOXYPEPTIDASE 2 HOMOLOG', 244169),
(346112, 'PTHR10404:SF74', NULL, NULL, NULL, NULL, '', 244169),
(346113, 'PTHR34533:SF3', NULL, NULL, NULL, NULL, '', 244170),
(346114, 'PTHR34533:SF2', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING 163', 244170),
(346115, 'PTHR34533:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 159', 244170),
(346116, 'PTHR34533', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN CCDC163', 244170),
(346117, 'PTHR24281:SF279', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP81A4', 244171),
(346118, 'PTHR24281:SF158', NULL, NULL, NULL, NULL, '3,9-DIHYDROXYPTEROCARPAN 6A-MONOOXYGENASE-LIKE', 244171),
(346119, 'PTHR24281:SF159', NULL, NULL, NULL, NULL, '', 244171),
(346120, 'PTHR24281:SF156', NULL, NULL, NULL, NULL, '', 244171),
(346121, 'PTHR24281:SF277', NULL, NULL, NULL, NULL, 'P-COUMAROYL QUINATE/SHIKIMATE 3''-HYDROXYLASE', 244171),
(346122, 'PTHR24281:SF278', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(346123, 'PTHR24281:SF157', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A1-LIKE', 244171),
(346124, 'PTHR24281:SF161', NULL, NULL, NULL, NULL, 'FLAVONOID 3''-MONOOXYGENASE-LIKE', 244171),
(346125, 'PTHR24281:SF282', NULL, NULL, NULL, NULL, '', 244171),
(346126, 'PTHR24281:SF283', NULL, NULL, NULL, NULL, 'GERANIOL 8-HYDROXYLASE-LIKE', 244171),
(346127, 'PTHR24281:SF280', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346128, 'PTHR24281:SF281', NULL, NULL, NULL, NULL, '', 244171),
(346129, 'PTHR24281:SF286', NULL, NULL, NULL, NULL, '', 244171),
(346130, 'PTHR24281:SF166', NULL, NULL, NULL, NULL, 'BNACNNG66710D PROTEIN', 244171),
(346131, 'PTHR24281:SF287', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346132, 'PTHR24281:SF163', NULL, NULL, NULL, NULL, 'PHENYLALANINE N-MONOOXYGENASE', 244171),
(346133, 'PTHR24281:SF284', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A4', 244171),
(346134, 'PTHR24281:SF285', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A1', 244171),
(346135, 'PTHR24281:SF169', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346136, 'PTHR24281:SF288', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346137, 'PTHR24281:SF167', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 76T24-LIKE', 244171),
(346138, 'PTHR24281:SF168', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A4', 244171),
(346139, 'PTHR24281:SF289', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346140, 'PTHR24281:SF293', NULL, NULL, NULL, NULL, '', 244171),
(346141, 'PTHR24281:SF173', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346142, 'PTHR24281:SF291', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP82D47-LIKE', 244171),
(346143, 'PTHR24281:SF171', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 93A3-LIKE', 244171),
(346144, 'PTHR24281:SF292', NULL, NULL, NULL, NULL, 'BNAC03G65100D PROTEIN', 244171),
(346145, 'PTHR24281:SF177', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346146, 'PTHR24281:SF174', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 81C13-LIKE', 244171),
(346147, 'PTHR24281:SF175', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 93A2-LIKE', 244171),
(346148, 'PTHR24281:SF290', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A1-LIKE', 244171),
(346149, 'PTHR24281:SF178', NULL, NULL, NULL, NULL, '', 244171),
(346150, 'PTHR24281:SF179', NULL, NULL, NULL, NULL, '', 244171),
(346151, 'PTHR24281:SF181', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 89A2-LIKE', 244171),
(346152, 'PTHR24281:SF182', NULL, NULL, NULL, NULL, 'GERANIOL 8-HYDROXYLASE-LIKE', 244171),
(346153, 'PTHR24281:SF187', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 81E8-LIKE', 244171),
(346154, 'PTHR24281:SF185', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346155, 'PTHR24281:SF186', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 77A3', 244171),
(346156, 'PTHR24281:SF189', NULL, NULL, NULL, NULL, 'ISOFLAVONE 3''-HYDROXYLASE-LIKE', 244171),
(346157, 'PTHR24281:SF194', NULL, NULL, NULL, NULL, 'GERANIOL 10-HYDROXYLASE', 244171),
(346158, 'PTHR24281:SF192', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346159, 'PTHR24281:SF199', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 78A7-LIKE', 244171),
(346160, 'PTHR24281:SF196', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP82D47-LIKE', 244171),
(346161, 'PTHR24281:SF197', NULL, NULL, NULL, NULL, '', 244171),
(346162, 'PTHR24281:SF191', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 77A2-LIKE', 244171),
(346163, 'PTHR24281:SF11', NULL, NULL, NULL, NULL, 'TRIMETHYLTRIDECATETRAENE SYNTHASE-LIKE', 244171),
(346164, 'PTHR24281:SF12', NULL, NULL, NULL, NULL, 'LITTORINE MUTASE/MONOOXYGENASE', 244171),
(346165, 'PTHR24281:SF15', NULL, NULL, NULL, NULL, '', 244171),
(346166, 'PTHR24281:SF16', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 93A2-LIKE', 244171),
(346167, 'PTHR24281:SF17', NULL, NULL, NULL, NULL, 'GERANIOL 8-HYDROXYLASE-LIKE', 244171),
(346168, 'PTHR24281:SF18', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP82E4V2 NICOTINE DEMETHYLASE', 244171),
(346169, 'PTHR24281:SF19', NULL, NULL, NULL, NULL, '', 244171),
(346170, 'PTHR24281:SF20', NULL, NULL, NULL, NULL, '', 244171),
(346171, 'PTHR24281:SF21', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(346172, 'PTHR24281:SF22', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346173, 'PTHR24281:SF23', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 HYDROXYLASE', 244171),
(346174, 'PTHR24281:SF25', NULL, NULL, NULL, NULL, '', 244171),
(346175, 'PTHR24281:SF28', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 MONOOXYGENASE CYP736B', 244171),
(346176, 'PTHR24281:SF29', NULL, NULL, NULL, NULL, '', 244171),
(346177, 'PTHR24281', NULL, NULL, NULL, NULL, 'STEROID 21-HYDROXYLASE-RELATED', 244171),
(346178, 'PTHR24281:SF31', NULL, NULL, NULL, NULL, 'FLAVONOID 3-HYDROXYLASE', 244171),
(346179, 'PTHR24281:SF32', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346180, 'PTHR24281:SF33', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346181, 'PTHR24281:SF34', NULL, NULL, NULL, NULL, 'CYP81B36', 244171),
(346182, 'PTHR24281:SF36', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 HYDROXYLASE', 244171),
(346183, 'PTHR24281:SF38', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP82E4V2 NICOTINE DEMETHYLASE', 244171),
(346184, 'PTHR24281:SF200', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 244171),
(346185, 'PTHR24281:SF206', NULL, NULL, NULL, NULL, 'XANTHOTOXIN 5-HYDROXYLASE CYP82C4-LIKE', 244171),
(346186, 'PTHR24281:SF204', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 HYDROXYLASE', 244171),
(346187, 'PTHR24281:SF30', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346188, 'PTHR24281:SF42', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A9-LIKE', 244171),
(346189, 'PTHR24281:SF43', NULL, NULL, NULL, NULL, '', 244171),
(346190, 'PTHR24281:SF44', NULL, NULL, NULL, NULL, '', 244171),
(346191, 'PTHR24281:SF47', NULL, NULL, NULL, NULL, 'CYTOCHROME 81E8', 244171),
(346192, 'PTHR24281:SF49', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346193, 'PTHR24281:SF213', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346194, 'PTHR24281:SF214', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346195, 'PTHR24281:SF212', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 81E8-LIKE', 244171),
(346196, 'PTHR24281:SF215', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 HYDROXYLASE', 244171),
(346197, 'PTHR24281:SF216', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71D8-LIKE', 244171),
(346198, 'PTHR24281:SF221', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A1-LIKE', 244171),
(346199, 'PTHR24281:SF100', NULL, NULL, NULL, NULL, '', 244171),
(346200, 'PTHR24281:SF41', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 81Q32-LIKE', 244171),
(346201, 'PTHR24281:SF54', NULL, NULL, NULL, NULL, '3,9-DIHYDROXYPTEROCARPAN 6A-MONOOXYGENASE-LIKE', 244171),
(346202, 'PTHR24281:SF56', NULL, NULL, NULL, NULL, '', 244171),
(346203, 'PTHR24281:SF57', NULL, NULL, NULL, NULL, 'P-COUMAROYL QUINATE/SHIKIMATE 3''-HYDROXYLASE', 244171),
(346204, 'PTHR24281:SF103', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346205, 'PTHR24281:SF104', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346206, 'PTHR24281:SF222', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A4', 244171),
(346207, 'PTHR24281:SF223', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 76A2', 244171),
(346208, 'PTHR24281:SF102', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346209, 'PTHR24281:SF107', NULL, NULL, NULL, NULL, '', 244171),
(346210, 'PTHR24281:SF229', NULL, NULL, NULL, NULL, 'PREMNASPIRODIENE OXYGENASE-LIKE', 244171),
(346211, 'PTHR24281:SF108', NULL, NULL, NULL, NULL, 'GERANIOL 10-HYDROXYLASE', 244171),
(346212, 'PTHR24281:SF227', NULL, NULL, NULL, NULL, 'LICODIONE SYNTHASE-LIKE', 244171),
(346213, 'PTHR24281:SF232', NULL, NULL, NULL, NULL, '', 244171),
(346214, 'PTHR24281:SF50', NULL, NULL, NULL, NULL, '', 244171),
(346215, 'PTHR24281:SF51', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346216, 'PTHR24281:SF52', NULL, NULL, NULL, NULL, 'FLAVONOID 3'',5''-HYDROXYLASE 2-LIKE', 244171),
(346217, 'PTHR24281:SF65', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 MONOOXYGENASE CYP82E3', 244171),
(346218, 'PTHR24281:SF67', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 98A2', 244171),
(346219, 'PTHR24281:SF68', NULL, NULL, NULL, NULL, 'FLAVONOID 3-HYDROXYLASE', 244171),
(346220, 'PTHR24281:SF69', NULL, NULL, NULL, NULL, 'CYTOCHROME P450-RELATED', 244171);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(346221, 'PTHR24281:SF112', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 HYDROXYLASE', 244171),
(346222, 'PTHR24281:SF113', NULL, NULL, NULL, NULL, 'BRCT DOMAIN-CONTAINING PROTEIN', 244171),
(346223, 'PTHR24281:SF118', NULL, NULL, NULL, NULL, '', 244171),
(346224, 'PTHR24281:SF239', NULL, NULL, NULL, NULL, 'GERANIOL 8-HYDROXYLASE-LIKE', 244171),
(346225, 'PTHR24281:SF237', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP78A16-A', 244171),
(346226, 'PTHR24281:SF121', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346227, 'PTHR24281:SF242', NULL, NULL, NULL, NULL, '', 244171),
(346228, 'PTHR24281:SF122', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 HYDROXYLASE', 244171),
(346229, 'PTHR24281:SF243', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP82D47-LIKE', 244171),
(346230, 'PTHR24281:SF241', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP82D47-LIKE', 244171),
(346231, 'PTHR24281:SF120', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346232, 'PTHR24281:SF60', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346233, 'PTHR24281:SF61', NULL, NULL, NULL, NULL, '', 244171),
(346234, 'PTHR24281:SF63', NULL, NULL, NULL, NULL, 'DIMETHYLNONATRIENE SYNTHASE-LIKE', 244171),
(346235, 'PTHR24281:SF75', NULL, NULL, NULL, NULL, '', 244171),
(346236, 'PTHR24281:SF76', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A2', 244171),
(346237, 'PTHR24281:SF77', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A4', 244171),
(346238, 'PTHR24281:SF9', NULL, NULL, NULL, NULL, '', 244171),
(346239, 'PTHR24281:SF78', NULL, NULL, NULL, NULL, '', 244171),
(346240, 'PTHR24281:SF79', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346241, 'PTHR24281:SF5', NULL, NULL, NULL, NULL, '3-HYDROXYPHENYLACETATE 6 HYDROXYLASE', 244171),
(346242, 'PTHR24281:SF247', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A4', 244171),
(346243, 'PTHR24281:SF244', NULL, NULL, NULL, NULL, '', 244171),
(346244, 'PTHR24281:SF245', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A4', 244171),
(346245, 'PTHR24281:SF124', NULL, NULL, NULL, NULL, 'CYP71AU1', 244171),
(346246, 'PTHR24281:SF127', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346247, 'PTHR24281:SF248', NULL, NULL, NULL, NULL, 'GERANIOL 10-HYDROXYLASE', 244171),
(346248, 'PTHR24281:SF128', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346249, 'PTHR24281:SF250', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346250, 'PTHR24281:SF132', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346251, 'PTHR24281:SF253', NULL, NULL, NULL, NULL, '', 244171),
(346252, 'PTHR24281:SF254', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 92B1', 244171),
(346253, 'PTHR24281:SF133', NULL, NULL, NULL, NULL, 'FLAVONOID 3-HYDROXYLASE', 244171),
(346254, 'PTHR24281:SF130', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 77A1', 244171),
(346255, 'PTHR24281:SF251', NULL, NULL, NULL, NULL, 'FLAVONOID 3''-MONOOXYGENASE-LIKE', 244171),
(346256, 'PTHR24281:SF252', NULL, NULL, NULL, NULL, 'P-COUMAROYL QUINATE/SHIKIMATE 3''-HYDROXYLASE', 244171),
(346257, 'PTHR24281:SF131', NULL, NULL, NULL, NULL, '', 244171),
(346258, 'PTHR24281:SF70', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346259, 'PTHR24281:SF71', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 703A2', 244171),
(346260, 'PTHR24281:SF72', NULL, NULL, NULL, NULL, '', 244171),
(346261, 'PTHR24281:SF73', NULL, NULL, NULL, NULL, '', 244171),
(346262, 'PTHR24281:SF86', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 78A5-LIKE', 244171),
(346263, 'PTHR24281:SF89', NULL, NULL, NULL, NULL, 'FLAVONOID 3-HYDROXYLASE', 244171),
(346264, 'PTHR24281:SF136', NULL, NULL, NULL, NULL, '', 244171),
(346265, 'PTHR24281:SF257', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 244171),
(346266, 'PTHR24281:SF258', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346267, 'PTHR24281:SF255', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP82D47-LIKE', 244171),
(346268, 'PTHR24281:SF256', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A1-LIKE', 244171),
(346269, 'PTHR24281:SF259', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346270, 'PTHR24281:SF138', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 705A12-LIKE', 244171);
INSERT INTO "PUBLIC"."MODEL" VALUES
(346271, 'PTHR24281:SF139', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71D7', 244171),
(346272, 'PTHR24281:SF260', NULL, NULL, NULL, NULL, '', 244171),
(346273, 'PTHR24281:SF140', NULL, NULL, NULL, NULL, '', 244171),
(346274, 'PTHR24281:SF261', NULL, NULL, NULL, NULL, '(S)-N-METHYLCOCLAURINE 3''-HYDROXYLASE ISOZYME', 244171),
(346275, 'PTHR24281:SF143', NULL, NULL, NULL, NULL, 'ELICITOR-INDUCIBLE CYTOCHROME P450', 244171),
(346276, 'PTHR24281:SF264', NULL, NULL, NULL, NULL, '', 244171),
(346277, 'PTHR24281:SF144', NULL, NULL, NULL, NULL, 'CYTOCHROME P450-RELATED', 244171),
(346278, 'PTHR24281:SF265', NULL, NULL, NULL, NULL, 'BNAC03G17080D PROTEIN', 244171),
(346279, 'PTHR24281:SF262', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 MONOOXYGENASE CYP736B', 244171),
(346280, 'PTHR24281:SF141', NULL, NULL, NULL, NULL, 'GERANIOL 10-HYDROXYLASE', 244171),
(346281, 'PTHR24281:SF263', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 92B1', 244171),
(346282, 'PTHR24281:SF142', NULL, NULL, NULL, NULL, '(S)-CANADINE SYNTHASE-LIKE', 244171),
(346283, 'PTHR24281:SF80', NULL, NULL, NULL, NULL, '', 244171),
(346284, 'PTHR24281:SF82', NULL, NULL, NULL, NULL, '', 244171),
(346285, 'PTHR24281:SF83', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A1-LIKE', 244171),
(346286, 'PTHR24281:SF84', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346287, 'PTHR24281:SF85', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 HYDROXYLASE', 244171),
(346288, 'PTHR24281:SF98', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A1-LIKE', 244171),
(346289, 'PTHR24281:SF268', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346290, 'PTHR24281:SF147', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71D7', 244171),
(346291, 'PTHR24281:SF148', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A1-LIKE', 244171),
(346292, 'PTHR24281:SF269', NULL, NULL, NULL, NULL, '', 244171),
(346293, 'PTHR24281:SF145', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 78A7-LIKE', 244171),
(346294, 'PTHR24281:SF266', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346295, 'PTHR24281:SF146', NULL, NULL, NULL, NULL, '', 244171),
(346296, 'PTHR24281:SF267', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71AU50-LIKE', 244171),
(346297, 'PTHR24281:SF271', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346298, 'PTHR24281:SF272', NULL, NULL, NULL, NULL, '', 244171),
(346299, 'PTHR24281:SF151', NULL, NULL, NULL, NULL, 'P-COUMAROYL QUINATE/SHIKIMATE 3''-HYDROXYLASE', 244171),
(346300, 'PTHR24281:SF270', NULL, NULL, NULL, NULL, '', 244171),
(346301, 'PTHR24281:SF275', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 93A3-LIKE', 244171),
(346302, 'PTHR24281:SF276', NULL, NULL, NULL, NULL, '', 244171),
(346303, 'PTHR24281:SF155', NULL, NULL, NULL, NULL, 'STEROID 21-HYDROXYLASE', 244171),
(346304, 'PTHR24281:SF273', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346305, 'PTHR24281:SF152', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346306, 'PTHR24281:SF153', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346307, 'PTHR24281:SF274', NULL, NULL, NULL, NULL, 'GERANIOL 10-HYDROXYLASE', 244171),
(346308, 'PTHR24281:SF91', NULL, NULL, NULL, NULL, 'GERANIOL 10-HYDROXYLASE', 244171),
(346309, 'PTHR24281:SF92', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 244171),
(346310, 'PTHR36704:SF1', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 244172),
(346311, 'PTHR36704', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 244172),
(346312, 'PTHR36704:SF2', NULL, NULL, NULL, NULL, '', 244172),
(346313, 'PTHR46843:SF1', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN 16', 244173),
(346314, 'PTHR46843', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN 16', 244173),
(346315, 'PTHR12687:SF10', NULL, NULL, NULL, NULL, 'NUCLEOLAR COMPLEX PROTEIN 2 HOMOLOG', 244174),
(346316, 'PTHR12687:SF4', NULL, NULL, NULL, NULL, 'NUCLEOLAR COMPLEX PROTEIN 2 HOMOLOG', 244174),
(346317, 'PTHR12687:SF11', NULL, NULL, NULL, NULL, 'NOC2P-NOC3P COMPLEX SUBUNIT NOC2 FAMILY PROTEIN', 244174),
(346318, 'PTHR12687:SF9', NULL, NULL, NULL, NULL, 'NUCLEOLAR COMPLEX PROTEIN 2 HOMOLOG', 244174),
(346319, 'PTHR12687:SF8', NULL, NULL, NULL, NULL, 'NOC2P FAMILY', 244174);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(346320, 'PTHR12687', NULL, NULL, NULL, NULL, 'NUCLEOLAR COMPLEX 2 AND RAD4-RELATED', 244174),
(346321, 'PTHR43284:SF1', NULL, NULL, NULL, NULL, 'ASPARAGINE SYNTHETASE', 244175),
(346322, 'PTHR43284', NULL, NULL, NULL, NULL, 'ASPARAGINE SYNTHETASE (GLUTAMINE-HYDROLYZING)', 244175),
(346323, 'PTHR22094:SF0', NULL, NULL, NULL, NULL, 'MUCIN-LIKE PROTEIN 3', 244176),
(346324, 'PTHR22094', NULL, NULL, NULL, NULL, 'DIFFUSE PANBRONCHIOLITIS CRITICAL REGION GENE 1', 244176),
(346325, 'PTHR36761:SF2', NULL, NULL, NULL, NULL, 'ORF03 PROTEIN', 244177),
(346326, 'PTHR36761', NULL, NULL, NULL, NULL, 'ORF03 PROTEIN', 244177),
(346327, 'PTHR18806', NULL, NULL, NULL, NULL, 'RBM25 PROTEIN', 244178),
(346328, 'PTHR18806:SF4', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 25', 244178),
(346329, 'PTHR24258:SF129', NULL, NULL, NULL, NULL, 'LP15124P-RELATED', 244179),
(346330, 'PTHR24258:SF142', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 244179),
(346331, 'PTHR24258:SF140', NULL, NULL, NULL, NULL, 'BCDNA.GH08420-RELATED', 244179),
(346332, 'PTHR24258:SF134', NULL, NULL, NULL, NULL, 'AGAP011908-PA', 244179),
(346333, 'PTHR24258:SF145', NULL, NULL, NULL, NULL, 'SERINE PROTEASE EASTER-LIKE PROTEIN', 244179),
(346334, 'PTHR24258:SF146', NULL, NULL, NULL, NULL, '', 244179),
(346335, 'PTHR24258', NULL, NULL, NULL, NULL, 'SERINE PROTEASE-RELATED', 244179),
(346336, 'PTHR24258:SF143', NULL, NULL, NULL, NULL, '', 244179),
(346337, 'PTHR24258:SF144', NULL, NULL, NULL, NULL, 'GH14088P', 244179),
(346338, 'PTHR24258:SF116', NULL, NULL, NULL, NULL, 'FI16631P1-RELATED', 244179),
(346339, 'PTHR24258:SF128', NULL, NULL, NULL, NULL, 'TEQUILA, ISOFORM G', 244179),
(346340, 'PTHR24258:SF136', NULL, NULL, NULL, NULL, 'GH06673P-RELATED', 244179),
(346341, 'PTHR11017:SF527', NULL, NULL, NULL, NULL, 'TMV RESISTANCE PROTEIN N-LIKE', 244180),
(346342, 'PTHR11017:SF526', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS) FAMILY-RELATED', 244180),
(346343, 'PTHR11017:SF529', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN CHS1', 244180),
(346344, 'PTHR11017:SF528', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346345, 'PTHR11017:SF402', NULL, NULL, NULL, NULL, 'BNAA04G27840D PROTEIN', 244180),
(346346, 'PTHR11017:SF523', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RML1A-LIKE ISOFORM X1', 244180),
(346347, 'PTHR11017:SF369', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346348, 'PTHR11017:SF489', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS) FAMILY', 244180),
(346349, 'PTHR11017:SF522', NULL, NULL, NULL, NULL, 'RESISTANCE PROTEIN (TIR-NBS-LRR CLASS), PUTATIVE-RELATED', 244180),
(346350, 'PTHR11017:SF368', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 244180),
(346351, 'PTHR11017:SF401', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS) FAMILY', 244180),
(346352, 'PTHR11017:SF525', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346353, 'PTHR11017:SF524', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346354, 'PTHR11017:SF365', NULL, NULL, NULL, NULL, 'TMV RESISTANCE PROTEIN N-LIKE', 244180),
(346355, 'PTHR11017:SF364', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS) FAMILY', 244180),
(346356, 'PTHR11017:SF243', NULL, NULL, NULL, NULL, 'RESISTANCE PROTEIN (TIR-NBS-LRR CLASS), PUTATIVE-RELATED', 244180),
(346357, 'PTHR11017:SF521', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346358, 'PTHR11017:SF520', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS) FAMILY', 244180),
(346359, 'PTHR11017:SF366', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346360, 'PTHR11017:SF361', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346361, 'PTHR11017:SF482', NULL, NULL, NULL, NULL, 'BNAA01G18700D PROTEIN', 244180),
(346362, 'PTHR11017:SF484', NULL, NULL, NULL, NULL, 'TMV RESISTANCE PROTEIN N-LIKE', 244180),
(346363, 'PTHR11017:SF363', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180);
INSERT INTO "PUBLIC"."MODEL" VALUES
(346364, 'PTHR11017:SF362', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346365, 'PTHR11017:SF483', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346366, 'PTHR11017:SF241', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 244180),
(346367, 'PTHR11017:SF480', NULL, NULL, NULL, NULL, 'TIR-NBS-LRR CLASS DISEASE RESISTANCE PROTEIN', 244180),
(346368, 'PTHR11017:SF519', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 244180),
(346369, 'PTHR11017:SF516', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346370, 'PTHR11017:SF515', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS) FAMILY', 244180),
(346371, 'PTHR11017:SF518', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS)-RELATED', 244180),
(346372, 'PTHR11017:SF517', NULL, NULL, NULL, NULL, 'TMV RESISTANCE PROTEIN N', 244180),
(346373, 'PTHR11017:SF479', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE-LIKE PROTEIN DSC1', 244180),
(346374, 'PTHR11017:SF512', NULL, NULL, NULL, NULL, 'RESISTANCE PROTEIN (TIR-NBS-LRR CLASS), PUTATIVE-RELATED', 244180),
(346375, 'PTHR11017:SF236', NULL, NULL, NULL, NULL, 'TMV RESISTANCE PROTEIN N-LIKE', 244180),
(346376, 'PTHR11017:SF357', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346377, 'PTHR11017:SF511', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN-RELATED', 244180),
(346378, 'PTHR11017:SF514', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346379, 'PTHR11017:SF513', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346380, 'PTHR11017:SF238', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS CLASS)', 244180),
(346381, 'PTHR11017:SF354', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346382, 'PTHR11017:SF510', NULL, NULL, NULL, NULL, 'RECEPTOR, PUTATIVE-RELATED', 244180),
(346383, 'PTHR11017:SF355', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346384, 'PTHR11017:SF471', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346385, 'PTHR11017:SF230', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346386, 'PTHR11017:SF472', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 244180),
(346387, 'PTHR11017:SF509', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346388, 'PTHR11017:SF508', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 244180),
(346389, 'PTHR11017:SF505', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346390, 'PTHR11017:SF501', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS)-RELATED', 244180),
(346391, 'PTHR11017:SF468', NULL, NULL, NULL, NULL, 'TMV RESISTANCE PROTEIN N-LIKE', 244180),
(346392, 'PTHR11017:SF225', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS CLASS)-RELATED', 244180),
(346393, 'PTHR11017:SF467', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346394, 'PTHR11017:SF228', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (NBS-LRR CLASS) FAMILY-RELATED', 244180),
(346395, 'PTHR11017:SF469', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346396, 'PTHR11017:SF227', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RPS6', 244180),
(346397, 'PTHR11017:SF348', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346398, 'PTHR11017:SF502', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN', 244180),
(346399, 'PTHR11017:SF464', NULL, NULL, NULL, NULL, 'BACTERIAL SPOT DISEASE RESISTANCE PROTEIN 4', 244180),
(346400, 'PTHR11017:SF345', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 244180),
(346401, 'PTHR11017:SF344', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS) FAMILY', 244180),
(346402, 'PTHR11017', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN', 244180),
(346403, 'PTHR11017:SF461', NULL, NULL, NULL, NULL, 'TMV RESISTANCE PROTEIN N-LIKE', 244180),
(346404, 'PTHR11017:SF340', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS) FAMILY-RELATED', 244180);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(346405, 'PTHR11017:SF219', NULL, NULL, NULL, NULL, 'ARCHAEAL ATPASE', 244180),
(346406, 'PTHR11017:SF456', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RRS1', 244180),
(346407, 'PTHR11017:SF459', NULL, NULL, NULL, NULL, 'TOLL/INTERLEUKIN-1 RECEPTOR (TIR) DOMAIN-CONTAINING PROTEIN-RELATED', 244180),
(346408, 'PTHR11017:SF332', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346409, 'PTHR11017:SF452', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346410, 'PTHR11017:SF455', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN DISEASE RESISTANCE PROTEIN', 244180),
(346411, 'PTHR11017:SF334', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS) FAMILY', 244180),
(346412, 'PTHR11017:SF333', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS)-RELATED', 244180),
(346413, 'PTHR11017:SF294', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS) FAMILY-RELATED', 244180),
(346414, 'PTHR11017:SF451', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS)', 244180),
(346415, 'PTHR11017:SF297', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346416, 'PTHR11017:SF291', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS) FAMILY', 244180),
(346417, 'PTHR11017:SF290', NULL, NULL, NULL, NULL, 'RESISTANCE PROTEIN (TIR-NBS-LRR CLASS), PUTATIVE-RELATED', 244180),
(346418, 'PTHR11017:SF292', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 244180),
(346419, 'PTHR11017:SF207', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS CLASS)-RELATED', 244180),
(346420, 'PTHR11017:SF325', NULL, NULL, NULL, NULL, 'NB-ARC-RELATED', 244180),
(346421, 'PTHR11017:SF446', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346422, 'PTHR11017:SF324', NULL, NULL, NULL, NULL, 'TMV RESISTANCE PROTEIN N-LIKE', 244180),
(346423, 'PTHR11017:SF448', NULL, NULL, NULL, NULL, 'NB-ARC-RELATED', 244180),
(346424, 'PTHR11017:SF447', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN TAO1-LIKE ISOFORM X1', 244180),
(346425, 'PTHR11017:SF326', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346426, 'PTHR11017:SF442', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346427, 'PTHR11017:SF320', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 244180),
(346428, 'PTHR11017:SF444', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346429, 'PTHR11017:SF443', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346430, 'PTHR11017:SF440', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 244180),
(346431, 'PTHR11017:SF280', NULL, NULL, NULL, NULL, 'RESISTANCE PROTEIN (TIR-NBS-LRR CLASS), PUTATIVE-RELATED', 244180),
(346432, 'PTHR11017:SF317', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346433, 'PTHR11017:SF559', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS CLASS)', 244180),
(346434, 'PTHR11017:SF556', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RUN1-LIKE ISOFORM X1', 244180),
(346435, 'PTHR11017:SF314', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346436, 'PTHR11017:SF555', NULL, NULL, NULL, NULL, 'TIR-NBS-LRR RCT1-LIKE RESISTANCE PROTEIN', 244180),
(346437, 'PTHR11017:SF313', NULL, NULL, NULL, NULL, 'TOLL/INTERLEUKIN-1 RECEPTOR (TIR) DOMAIN-CONTAINING PROTEIN-RELATED', 244180),
(346438, 'PTHR11017:SF316', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN', 244180),
(346439, 'PTHR11017:SF558', NULL, NULL, NULL, NULL, 'RESISTANCE PROTEIN (TIR-NBS-LRR CLASS), PUTATIVE-RELATED', 244180),
(346440, 'PTHR11017:SF557', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS) FAMILY-RELATED', 244180),
(346441, 'PTHR11017:SF436', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346442, 'PTHR11017:SF398', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN DISEASE RESISTANCE PROTEIN', 244180),
(346443, 'PTHR11017:SF431', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN PROTEIN', 244180),
(346444, 'PTHR11017:SF552', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RPP2B', 244180);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(346445, 'PTHR11017:SF277', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RPS4-RELATED', 244180),
(346446, 'PTHR11017:SF551', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346447, 'PTHR11017:SF433', NULL, NULL, NULL, NULL, 'BACTERIAL SPOT DISEASE RESISTANCE PROTEIN 4', 244180),
(346448, 'PTHR11017:SF554', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346449, 'PTHR11017:SF553', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346450, 'PTHR11017:SF278', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 10', 244180),
(346451, 'PTHR11017:SF399', NULL, NULL, NULL, NULL, 'TMV RESISTANCE PROTEIN N-LIKE', 244180),
(346452, 'PTHR11017:SF432', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346453, 'PTHR11017:SF393', NULL, NULL, NULL, NULL, 'TMV RESISTANCE PROTEIN N-LIKE', 244180),
(346454, 'PTHR11017:SF275', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS) FAMILY', 244180),
(346455, 'PTHR11017:SF550', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346456, 'PTHR11017:SF274', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS)-RELATED', 244180),
(346457, 'PTHR11017:SF392', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346458, 'PTHR11017:SF271', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN PROTEIN', 244180),
(346459, 'PTHR11017:SF307', NULL, NULL, NULL, NULL, 'TOLL/INTERLEUKIN-1 RECEPTOR (TIR) DOMAIN-CONTAINING PROTEIN-RELATED', 244180),
(346460, 'PTHR11017:SF428', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346461, 'PTHR11017:SF549', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RPP2A', 244180),
(346462, 'PTHR11017:SF548', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346463, 'PTHR11017:SF427', NULL, NULL, NULL, NULL, 'TMV RESISTANCE PROTEIN N-LIKE', 244180),
(346464, 'PTHR11017:SF309', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346465, 'PTHR11017:SF308', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346466, 'PTHR11017:SF429', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346467, 'PTHR11017:SF545', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346468, 'PTHR11017:SF424', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE-LIKE PROTEIN CSA1', 244180),
(346469, 'PTHR11017:SF544', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS), PUTATIVE-RELATED', 244180),
(346470, 'PTHR11017:SF547', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346471, 'PTHR11017:SF305', NULL, NULL, NULL, NULL, 'TMV RESISTANCE PROTEIN N-LIKE', 244180),
(346472, 'PTHR11017:SF546', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN', 244180),
(346473, 'PTHR11017:SF541', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS) FAMILY', 244180),
(346474, 'PTHR11017:SF420', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346475, 'PTHR11017:SF540', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS)', 244180),
(346476, 'PTHR11017:SF422', NULL, NULL, NULL, NULL, 'RESISTANCE PROTEIN (TIR-NBS-LRR CLASS), PUTATIVE-RELATED', 244180),
(346477, 'PTHR11017:SF389', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS CLASS)', 244180),
(346478, 'PTHR11017:SF543', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS) FAMILY', 244180),
(346479, 'PTHR11017:SF267', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346480, 'PTHR11017:SF300', NULL, NULL, NULL, NULL, 'RESISTANCE PROTEIN (TIR-NBS-LRR CLASS), PUTATIVE-RELATED', 244180),
(346481, 'PTHR11017:SF421', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346482, 'PTHR11017:SF542', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346483, 'PTHR11017:SF388', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346484, 'PTHR11017:SF262', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN', 244180);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(346485, 'PTHR11017:SF382', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346486, 'PTHR11017:SF264', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS) FAMILY', 244180),
(346487, 'PTHR11017:SF385', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS)-RELATED', 244180),
(346488, 'PTHR11017:SF384', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS) FAMILY', 244180),
(346489, 'PTHR11017:SF263', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS)', 244180),
(346490, 'PTHR11017:SF381', NULL, NULL, NULL, NULL, 'TMV RESISTANCE PROTEIN N-LIKE', 244180),
(346491, 'PTHR11017:SF538', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346492, 'PTHR11017:SF537', NULL, NULL, NULL, NULL, 'TMV RESISTANCE PROTEIN N-LIKE', 244180),
(346493, 'PTHR11017:SF416', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN TAO1-LIKE', 244180),
(346494, 'PTHR11017:SF418', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS) FAMILY-RELATED', 244180),
(346495, 'PTHR11017:SF539', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346496, 'PTHR11017:SF259', NULL, NULL, NULL, NULL, 'RESISTANCE PROTEIN (TIR-NBS-LRR CLASS), PUTATIVE-RELATED', 244180),
(346497, 'PTHR11017:SF534', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346498, 'PTHR11017:SF533', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS)', 244180),
(346499, 'PTHR11017:SF379', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346500, 'PTHR11017:SF412', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS)', 244180),
(346501, 'PTHR11017:SF415', NULL, NULL, NULL, NULL, 'TOLL/INTERLEUKIN-1 RECEPTOR (TIR) DOMAIN-CONTAINING PROTEIN-RELATED', 244180),
(346502, 'PTHR11017:SF536', NULL, NULL, NULL, NULL, 'TMV RESISTANCE PROTEIN N-LIKE', 244180),
(346503, 'PTHR11017:SF535', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN CHL1', 244180),
(346504, 'PTHR11017:SF530', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346505, 'PTHR11017:SF532', NULL, NULL, NULL, NULL, 'TMV RESISTANCE PROTEIN N-LIKE', 244180),
(346506, 'PTHR11017:SF411', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (NBS-LRR CLASS) FAMILY-RELATED', 244180),
(346507, 'PTHR11017:SF378', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS) FAMILY', 244180),
(346508, 'PTHR11017:SF499', NULL, NULL, NULL, NULL, 'TMV RESISTANCE PROTEIN N-LIKE', 244180),
(346509, 'PTHR11017:SF531', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 244180),
(346510, 'PTHR11017:SF372', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (TIR-NBS-LRR CLASS) FAMILY', 244180),
(346511, 'PTHR11017:SF493', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 244180),
(346512, 'PTHR11017:SF492', NULL, NULL, NULL, NULL, 'TOLL/INTERLEUKIN-1 RECEPTOR (TIR) DOMAIN-CONTAINING PROTEIN-RELATED', 244180),
(346513, 'PTHR11017:SF252', NULL, NULL, NULL, NULL, 'RESISTANCE PROTEIN (TIR-NBS-LRR CLASS), PUTATIVE-RELATED', 244180),
(346514, 'PTHR13233:SF13', NULL, NULL, NULL, NULL, 'FHA DOMAIN-CONTAINING PROTEIN', 244181),
(346515, 'PTHR13233:SF15', NULL, NULL, NULL, NULL, 'FHA DOMAIN CONTAINING PROTEIN, EXPRESSED', 244181),
(346516, 'PTHR13233:SF14', NULL, NULL, NULL, NULL, 'SMAD/FHA DOMAIN-CONTAINING PROTEIN-RELATED', 244181),
(346517, 'PTHR13233:SF0', NULL, NULL, NULL, NULL, 'MICROSPHERULE PROTEIN 1', 244181),
(346518, 'PTHR13233:SF17', NULL, NULL, NULL, NULL, 'FHA DOMAIN PROTEIN', 244181),
(346519, 'PTHR13233:SF16', NULL, NULL, NULL, NULL, '', 244181),
(346520, 'PTHR13233:SF8', NULL, NULL, NULL, NULL, 'FORKHEAD-ASSOCIATED (FHA) DOMAIN-CONTAINING PROTEIN', 244181),
(346521, 'PTHR13233:SF19', NULL, NULL, NULL, NULL, 'SMAD/FHA DOMAIN-CONTAINING PROTEIN', 244181),
(346522, 'PTHR13233', NULL, NULL, NULL, NULL, 'MICROSPHERULE PROTEIN 1', 244181),
(346523, 'PTHR13233:SF18', NULL, NULL, NULL, NULL, 'FHA DOMAIN-CONTAINING PROTEIN', 244181),
(346524, 'PTHR43213:SF14', NULL, NULL, NULL, NULL, 'MAF-LIKE PROTEIN', 244182);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(346525, 'PTHR43213:SF13', NULL, NULL, NULL, NULL, 'BNAC07G16670D PROTEIN', 244182),
(346526, 'PTHR43213:SF10', NULL, NULL, NULL, NULL, '7-METHYL-GTP PYROPHOSPHATASE', 244182),
(346527, 'PTHR43213:SF4', NULL, NULL, NULL, NULL, '7-METHYL-GTP PYROPHOSPHATASE', 244182),
(346528, 'PTHR43213:SF5', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL DTTP/UTP PYROPHOSPHATASE/METHYLTRANSFERASE PROTEIN-RELATED', 244182),
(346529, 'PTHR43213:SF3', NULL, NULL, NULL, NULL, 'MAF-LIKE PROTEIN, EXPRESSED', 244182),
(346530, 'PTHR43213:SF11', NULL, NULL, NULL, NULL, 'MAF-LIKE PROTEIN, EXPRESSED', 244182),
(346531, 'PTHR43213', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL DTTP/UTP PYROPHOSPHATASE/METHYLTRANSFERASE PROTEIN-RELATED', 244182),
(346532, 'PTHR45651:SF113', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL 5-RELATED', 244183),
(346533, 'PTHR45651:SF112', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL-LIKE PROTEIN', 244183),
(346534, 'PTHR45651', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL 15-RELATED-RELATED', 244183),
(346535, 'PTHR45651:SF39', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL 16-RELATED', 244183),
(346536, 'PTHR45651:SF111', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL 2-LIKE', 244183),
(346537, 'PTHR45651:SF110', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL 10-RELATED', 244183),
(346538, 'PTHR45651:SF33', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL 12-RELATED', 244183),
(346539, 'PTHR45651:SF77', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL, VOLTAGE-DEPENDENT, EAG/ELK/ERG-RELATED', 244183),
(346540, 'PTHR45651:SF78', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 244183),
(346541, 'PTHR45651:SF75', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL, VOLTAGE-DEPENDENT, EAG-RELATED', 244183),
(346542, 'PTHR45651:SF76', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL 1-LIKE', 244183),
(346543, 'PTHR45651:SF37', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL 11', 244183),
(346544, 'PTHR45651:SF38', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED CATION CHANNEL PROTEIN', 244183),
(346545, 'PTHR45651:SF35', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL 3-RELATED', 244183),
(346546, 'PTHR45651:SF79', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL 1-LIKE', 244183),
(346547, 'PTHR45651:SF36', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 244183),
(346548, 'PTHR45651:SF70', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 244183),
(346549, 'PTHR45651:SF73', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 244183),
(346550, 'PTHR45651:SF74', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 244183),
(346551, 'PTHR45651:SF71', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL, VOLTAGE-DEPENDENT, EAG/ELK/ERG-RELATED', 244183),
(346552, 'PTHR45651:SF29', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL-LIKE PROTEIN', 244183),
(346553, 'PTHR45651:SF22', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED CHANNEL 9', 244183),
(346554, 'PTHR45651:SF66', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED CHANNEL 15-RELATED', 244183),
(346555, 'PTHR45651:SF23', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL 8-RELATED', 244183),
(346556, 'PTHR45651:SF67', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 244183),
(346557, 'PTHR45651:SF24', NULL, NULL, NULL, NULL, 'OS08G0254600 PROTEIN', 244183),
(346558, 'PTHR45651:SF68', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 244183),
(346559, 'PTHR45651:SF25', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL-LIKE PROTEIN', 244183),
(346560, 'PTHR45651:SF69', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL 17', 244183),
(346561, 'PTHR45651:SF61', NULL, NULL, NULL, NULL, 'OS06G0527100 PROTEIN', 244183),
(346562, 'PTHR45651:SF5', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL 1', 244183);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(346563, 'PTHR45651:SF4', NULL, NULL, NULL, NULL, 'OS12G0468500 PROTEIN', 244183),
(346564, 'PTHR45651:SF7', NULL, NULL, NULL, NULL, 'OS09G0558300 PROTEIN', 244183),
(346565, 'PTHR45651:SF9', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL 14-RELATED', 244183),
(346566, 'PTHR45651:SF1', NULL, NULL, NULL, NULL, 'OS06G0207700 PROTEIN', 244183),
(346567, 'PTHR45651:SF11', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL 20, CHLOROPLASTIC-RELATED', 244183),
(346568, 'PTHR45651:SF99', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL 17', 244183),
(346569, 'PTHR45651:SF55', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL-LIKE PROTEIN', 244183),
(346570, 'PTHR45651:SF12', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL 15-RELATED', 244183),
(346571, 'PTHR45651:SF56', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL 1-LIKE', 244183),
(346572, 'PTHR45651:SF97', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 244183),
(346573, 'PTHR45651:SF98', NULL, NULL, NULL, NULL, 'OS03G0646300 PROTEIN', 244183),
(346574, 'PTHR45651:SF16', NULL, NULL, NULL, NULL, 'PROTEIN CNGC15A', 244183),
(346575, 'PTHR45651:SF57', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL 9-RELATED', 244183),
(346576, 'PTHR45651:SF14', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL 4', 244183),
(346577, 'PTHR45651:SF92', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 244183),
(346578, 'PTHR45651:SF52', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL 7-RELATED', 244183),
(346579, 'PTHR45651:SF96', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 244183),
(346580, 'PTHR45651:SF94', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL 1-LIKE ISOFORM X1', 244183),
(346581, 'PTHR45651:SF50', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL 2', 244183),
(346582, 'PTHR45651:SF104', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 244183),
(346583, 'PTHR45651:SF103', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL-RELATED', 244183),
(346584, 'PTHR45651:SF102', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL 18', 244183),
(346585, 'PTHR45651:SF101', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL 4', 244183),
(346586, 'PTHR45651:SF108', NULL, NULL, NULL, NULL, 'PROTEIN CNGC15C', 244183),
(346587, 'PTHR45651:SF107', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL 16-RELATED', 244183),
(346588, 'PTHR45651:SF106', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED CATION CHANNEL PROTEIN', 244183),
(346589, 'PTHR45651:SF105', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL-LIKE PROTEIN', 244183),
(346590, 'PTHR45651:SF100', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 244183),
(346591, 'PTHR45651:SF44', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL 4-LIKE', 244183),
(346592, 'PTHR45651:SF88', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 244183),
(346593, 'PTHR45651:SF89', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 244183),
(346594, 'PTHR45651:SF42', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL 6-RELATED', 244183),
(346595, 'PTHR45651:SF87', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 244183),
(346596, 'PTHR45651:SF48', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL 8-RELATED', 244183),
(346597, 'PTHR45651:SF46', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 244183),
(346598, 'PTHR45651:SF81', NULL, NULL, NULL, NULL, 'ION_TRANS DOMAIN-CONTAINING PROTEIN', 244183),
(346599, 'PTHR45651:SF109', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED CHANNEL 16-RELATED', 244183),
(346600, 'PTHR45651:SF40', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL 19-RELATED', 244183),
(346601, 'PTHR45651:SF85', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 244183);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(346602, 'PTHR45651:SF82', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE GATED CHANNEL 5-RELATED', 244183),
(346603, 'PTHR45651:SF83', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL, VOLTAGE-DEPENDENT, EAG/ELK/ERG-RELATED', 244183),
(346604, 'PTHR12603:SF0', NULL, NULL, NULL, NULL, 'CCR4-NOT TRANSCRIPTION COMPLEX SUBUNIT 4', 244184),
(346605, 'PTHR12603:SF19', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 244184),
(346606, 'PTHR12603:SF38', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 244184),
(346607, 'PTHR12603:SF27', NULL, NULL, NULL, NULL, 'RNA RECOGNITION MOTIF DOMAIN, EUKARYOTE-RELATED', 244184),
(346608, 'PTHR12603', NULL, NULL, NULL, NULL, 'CCR4-NOT TRANSCRIPTION COMPLEX RELATED', 244184),
(346609, 'PTHR12603:SF22', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C2H2 FAMILY-RELATED', 244184),
(346610, 'PTHR12603:SF21', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN-RELATED', 244184),
(346611, 'PTHR12603:SF10', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-BINDING ALPHA-BETA PLAIT DOMAIN, ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 244184),
(346612, 'PTHR12603:SF20', NULL, NULL, NULL, NULL, 'BNAC04G15670D PROTEIN', 244184),
(346613, 'PTHR12603:SF9', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 244184),
(346614, 'PTHR12603:SF31', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 244184),
(346615, 'PTHR12603:SF37', NULL, NULL, NULL, NULL, 'RNA BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 244184),
(346616, 'PTHR12603:SF15', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 244184),
(346617, 'PTHR12603:SF36', NULL, NULL, NULL, NULL, 'RNA BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 244184),
(346618, 'PTHR12603:SF4', NULL, NULL, NULL, NULL, 'RNA BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 244184),
(346619, 'PTHR12603:SF35', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 244184),
(346620, 'PTHR12603:SF24', NULL, NULL, NULL, NULL, 'RNA BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 244184),
(346621, 'PTHR12603:SF23', NULL, NULL, NULL, NULL, '', 244184),
(346622, 'PTHR12603:SF34', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 244184),
(346623, 'PTHR10807:SF122', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-3,5-BISPHOSPHATE 3-PHOSPHATASE', 244185),
(346624, 'PTHR10807:SF121', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-3,5-BISPHOSPHATE 3-PHOSPHATASE', 244185),
(346625, 'PTHR10807:SF39', NULL, NULL, NULL, NULL, 'MYOTUBULARIN-RELATED PROTEIN 10', 244185),
(346626, 'PTHR10807:SF108', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-3-PHOSPHATASE', 244185),
(346627, 'PTHR10807:SF109', NULL, NULL, NULL, NULL, 'SET DOMAIN BINDING FACTOR, ISOFORM A', 244185),
(346628, 'PTHR10807:SF128', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-3,5-BISPHOSPHATE 3-PHOSPHATASE', 244185),
(346629, 'PTHR10807:SF126', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-3-PHOSPHATASE', 244185),
(346630, 'PTHR10807:SF124', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-3-PHOSPHATE PHOSPHATASE', 244185),
(346631, 'PTHR10807', NULL, NULL, NULL, NULL, 'MYOTUBULARIN-RELATED', 244185),
(346632, 'PTHR10807:SF125', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-3-PHOSPHATASE MYOTUBULARIN-2', 244185),
(346633, 'PTHR10807:SF40', NULL, NULL, NULL, NULL, 'MYOTUBULARIN-RELATED PROTEIN 1', 244185),
(346634, 'PTHR10807:SF83', NULL, NULL, NULL, NULL, '', 244185),
(346635, 'PTHR10807:SF80', NULL, NULL, NULL, NULL, 'MYOTUBULARIN PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 244185),
(346636, 'PTHR10807:SF69', NULL, NULL, NULL, NULL, 'MYOTUBULARIN', 244185),
(346637, 'PTHR10807:SF66', NULL, NULL, NULL, NULL, 'MYOTUBULARIN-RELATED PROTEIN 3', 244185),
(346638, 'PTHR10807:SF43', NULL, NULL, NULL, NULL, 'MYOTUBULARIN-RELATED PROTEIN 5', 244185),
(346639, 'PTHR10807:SF42', NULL, NULL, NULL, NULL, 'MYOTUBULARIN-RELATED PROTEIN 2', 244185),
(346640, 'PTHR10807:SF64', NULL, NULL, NULL, NULL, 'MYOTUBULARIN-RELATED PROTEIN 4', 244185),
(346641, 'PTHR10807:SF112', NULL, NULL, NULL, NULL, 'MYOTUBULARIN-RELATED PROTEIN DDB_G0290005', 244185),
(346642, 'PTHR10807:SF110', NULL, NULL, NULL, NULL, 'FI17948P1', 244185);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(346643, 'PTHR10807:SF117', NULL, NULL, NULL, NULL, '', 244185),
(346644, 'PTHR10807:SF113', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PATS1-RELATED', 244185),
(346645, 'PTHR10807:SF73', NULL, NULL, NULL, NULL, 'LD06050P', 244185),
(346646, 'PTHR10807:SF51', NULL, NULL, NULL, NULL, 'MYOTUBULARIN-RELATED PROTEIN 11', 244185),
(346647, 'PTHR10807:SF8', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-3-PHOSPHATE PHOSPHATASE', 244185),
(346648, 'PTHR10807:SF4', NULL, NULL, NULL, NULL, 'MYOTUBULARIN-RELATED PROTEIN 13', 244185),
(346649, 'PTHR10807:SF59', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-3-PHOSPHATASE', 244185),
(346650, 'PTHR10807:SF37', NULL, NULL, NULL, NULL, 'MYOTUBULARIN-RELATED PROTEIN 12', 244185),
(346651, 'PTHR10807:SF36', NULL, NULL, NULL, NULL, 'MYOTUBULARIN-RELATED PROTEIN 8', 244185),
(346652, 'PTHR10807:SF57', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-3-PHOSPHATASE', 244185),
(346653, 'PTHR10807:SF35', NULL, NULL, NULL, NULL, 'MYOTUBULARIN-RELATED PROTEIN 7', 244185),
(346654, 'PTHR10807:SF56', NULL, NULL, NULL, NULL, 'MYOTUBULARIN-RELATED PROTEIN 9', 244185),
(346655, 'PTHR10807:SF34', NULL, NULL, NULL, NULL, 'MYOTUBULARIN-RELATED PROTEIN 6', 244185),
(346656, 'PTHR10807:SF75', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-3-PHOSPHATE PHOSPHATASE', 244185),
(346657, 'PTHR10807:SF52', NULL, NULL, NULL, NULL, 'MYOTUBULARIN PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 244185),
(346658, 'PTHR24241:SF18', NULL, NULL, NULL, NULL, 'VASOPRESSIN V1B RECEPTOR', 244186),
(346659, 'PTHR24241:SF17', NULL, NULL, NULL, NULL, 'VASOPRESSIN V1A RECEPTOR', 244186),
(346660, 'PTHR24241:SF59', NULL, NULL, NULL, NULL, 'ADIPOKINETIC HORMONE RECEPTOR, ISOFORM C', 244186),
(346661, 'PTHR24241:SF155', NULL, NULL, NULL, NULL, 'PYROGLUTAMYLATED RF-AMIDE PEPTIDE RECEPTOR', 244186),
(346662, 'PTHR24241:SF117', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 244186),
(346663, 'PTHR24241:SF119', NULL, NULL, NULL, NULL, 'PYROGLUTAMYLATED RF-AMIDE PEPTIDE RECEPTOR', 244186),
(346664, 'PTHR24241:SF1', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 22', 244186),
(346665, 'PTHR24241', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE RECEPTOR-RELATED G-PROTEIN COUPLED RECEPTOR', 244186),
(346666, 'PTHR24241:SF4', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE FF RECEPTOR 1', 244186),
(346667, 'PTHR24241:SF161', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 244186),
(346668, 'PTHR24241:SF125', NULL, NULL, NULL, NULL, 'PROKINETICIN RECEPTOR 2', 244186),
(346669, 'PTHR24241:SF164', NULL, NULL, NULL, NULL, 'PYROGLUTAMYLATED RFAMIDE PEPTIDE RECEPTOR 4', 244186),
(346670, 'PTHR24241:SF120', NULL, NULL, NULL, NULL, 'CHOLECYSTOKININ RECEPTOR TYPE A', 244186),
(346671, 'PTHR24241:SF128', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE FF RECEPTOR 1-LIKE 1', 244186),
(346672, 'PTHR24241:SF127', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 244186),
(346673, 'PTHR24241:SF89', NULL, NULL, NULL, NULL, 'OXYTOCIN RECEPTOR', 244186),
(346674, 'PTHR24241:SF171', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 244186),
(346675, 'PTHR24241:SF170', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 244186),
(346676, 'PTHR24241:SF172', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 244186),
(346677, 'PTHR24241:SF83', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 150-RELATED', 244186),
(346678, 'PTHR24241:SF82', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE FF RECEPTOR 1 LIKE 2-RELATED', 244186),
(346679, 'PTHR24241:SF179', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 244186),
(346680, 'PTHR24241:SF135', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE Y RECEPTOR TYPE 1', 244186),
(346681, 'PTHR24241:SF178', NULL, NULL, NULL, NULL, 'NPY-Y2 RECEPTOR', 244186),
(346682, 'PTHR24241:SF137', NULL, NULL, NULL, NULL, 'PROKINETICIN RECEPTOR 1', 244186),
(346683, 'PTHR24241:SF131', NULL, NULL, NULL, NULL, 'GASTRIN/CHOLECYSTOKININ TYPE B RECEPTOR', 244186),
(346684, 'PTHR24241:SF175', NULL, NULL, NULL, NULL, 'PYROGLUTAMYLATED RFAMIDE PEPTIDE RECEPTOR-LIKE', 244186); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(346685, 'PTHR24241:SF133', NULL, NULL, NULL, NULL, 'SI:DKEY-178O16.4', 244186),
(346686, 'PTHR24241:SF132', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE FF RECEPTOR 2', 244186),
(346687, 'PTHR24241:SF139', NULL, NULL, NULL, NULL, 'NPY-Y5 RECEPTOR', 244186),
(346688, 'PTHR24241:SF182', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 244186),
(346689, 'PTHR24241:SF181', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 244186),
(346690, 'PTHR24241:SF76', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 244186),
(346691, 'PTHR24241:SF183', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 244186),
(346692, 'PTHR24241:SF75', NULL, NULL, NULL, NULL, 'OREXIN RECEPTOR TYPE 2', 244186),
(346693, 'PTHR24241:SF74', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 244186),
(346694, 'PTHR24241:SF30', NULL, NULL, NULL, NULL, 'OREXIN RECEPTOR TYPE 1', 244186),
(346695, 'PTHR24241:SF180', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 244186),
(346696, 'PTHR24241:SF146', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 244186),
(346697, 'PTHR24241:SF189', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 244186),
(346698, 'PTHR24241:SF145', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 244186),
(346699, 'PTHR24241:SF148', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 244186),
(346700, 'PTHR24241:SF186', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE Y RECEPTOR TYPE 6-LIKE', 244186),
(346701, 'PTHR24241:SF185', NULL, NULL, NULL, NULL, 'DCAR-1', 244186),
(346702, 'PTHR24241:SF188', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 244186),
(346703, 'PTHR24241:SF69', NULL, NULL, NULL, NULL, 'GONADOTROPIN-RELEASING HORMONE II RECEPTOR-RELATED', 244186),
(346704, 'PTHR24241:SF143', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN-RELATED', 244186),
(346705, 'PTHR24241:SF187', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE SIFAMIDE RECEPTOR', 244186),
(346706, 'PTHR24241:SF67', NULL, NULL, NULL, NULL, 'FREE FATTY ACID RECEPTOR 4', 244186),
(346707, 'PTHR24241:SF22', NULL, NULL, NULL, NULL, 'GONADOTROPIN-RELEASING HORMONE RECEPTOR', 244186),
(346708, 'PTHR24241:SF20', NULL, NULL, NULL, NULL, 'VASOPRESSIN V2 RECEPTOR', 244186),
(346709, 'PTHR24241:SF150', NULL, NULL, NULL, NULL, 'CHOLECYSTOKININ-2 RECEPTOR', 244186),
(346710, 'PTHR24241:SF191', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE RECEPTOR, PUTATIVE-RELATED', 244186),
(346711, 'PTHR24241:SF190', NULL, NULL, NULL, NULL, 'CARDIOACCELERATORY PEPTIDE RECEPTOR-LIKE PROTEIN', 244186),
(346712, 'PTHR47207:SF3', NULL, NULL, NULL, NULL, 'BNAC09G32930D PROTEIN', 244187),
(346713, 'PTHR47207', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P3-1-RELATED', 244187),
(346714, 'PTHR47207:SF2', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P3-1-RELATED', 244187),
(346715, 'PTHR14566:SF0', NULL, NULL, NULL, NULL, 'CELL CYCLE REGULATOR OF NON-HOMOLOGOUS END JOINING', 244188),
(346716, 'PTHR14566', NULL, NULL, NULL, NULL, 'CELL CYCLE REGULATOR OF NON-HOMOLOGOUS END JOINING', 244188),
(346717, 'PTHR11254:SF439', NULL, NULL, NULL, NULL, 'HECT DOMAIN-CONTAINING PROTEIN', 244189),
(346718, 'PTHR11254:SF79', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HECW1', 244189),
(346719, 'PTHR11254:SF418', NULL, NULL, NULL, NULL, 'HECT_ UBIQUITIN', 244189),
(346720, 'PTHR11254:SF398', NULL, NULL, NULL, NULL, 'HECT-TYPE E3 UBIQUITIN TRANSFERASE', 244189),
(346721, 'PTHR11254:SF310', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE NEDD4-LIKE', 244189),
(346722, 'PTHR11254:SF299', NULL, NULL, NULL, NULL, 'NEDD4-LIKE E3 UBIQUITIN-PROTEIN LIGASE WWP1', 244189),
(346723, 'PTHR11254:SF435', NULL, NULL, NULL, NULL, 'HECT-TYPE E3 UBIQUITIN TRANSFERASE', 244189),
(346724, 'PTHR11254:SF436', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE PUB3', 244189),
(346725, 'PTHR11254:SF437', NULL, NULL, NULL, NULL, 'UBIQUITIN PROTEIN LIGASE-RELATED', 244189);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(346726, 'PTHR11254:SF438', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE PUB2', 244189),
(346727, 'PTHR11254:SF293', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SMURF1', 244189),
(346728, 'PTHR11254:SF395', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SMURF1', 244189),
(346729, 'PTHR11254:SF396', NULL, NULL, NULL, NULL, 'NEDD4-LIKE E3 UBIQUITIN-PROTEIN LIGASE WWP2', 244189),
(346730, 'PTHR11254:SF430', NULL, NULL, NULL, NULL, 'HECT_ UBIQUITIN', 244189),
(346731, 'PTHR11254', NULL, NULL, NULL, NULL, 'HECT DOMAIN UBIQUITIN-PROTEIN LIGASE', 244189),
(346732, 'PTHR11254:SF429', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SU(DX)', 244189),
(346733, 'PTHR11254:SF67', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HUWE1', 244189),
(346734, 'PTHR11254:SF66', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ITCHY HOMOLOG', 244189),
(346735, 'PTHR11254:SF421', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE UPL5', 244189),
(346736, 'PTHR11254:SF300', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SMURF2', 244189),
(346737, 'PTHR11254:SF127', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HECW2', 244189),
(346738, 'PTHR11254:SF424', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE UPL5', 244189),
(346739, 'PTHR11254:SF426', NULL, NULL, NULL, NULL, 'HECT DOMAIN-CONTAINING PROTEIN', 244189),
(346740, 'PTHR11254:SF427', NULL, NULL, NULL, NULL, 'BNAC03G29640D PROTEIN', 244189),
(346741, 'PTHR11254:SF282', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE NEDD4', 244189),
(346742, 'PTHR11254:SF340', NULL, NULL, NULL, NULL, 'APOPTOSIS-RESISTANT E3 UBIQUITIN PROTEIN LIGASE 1', 244189),
(346743, 'PTHR11254:SF363', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HACE1', 244189),
(346744, 'PTHR11254:SF440', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE NEDD-4', 244189),
(346745, 'PTHR11254:SF320', NULL, NULL, NULL, NULL, 'HECT-TYPE E3 UBIQUITIN TRANSFERASE', 244189),
(346746, 'PTHR38040:SF1', NULL, NULL, NULL, NULL, 'UBIQUINONE BIOSYNTHESIS ACCESSORY FACTOR UBIK', 244190),
(346747, 'PTHR38040', NULL, NULL, NULL, NULL, 'UBIQUINONE BIOSYNTHESIS ACCESSORY FACTOR UBIK', 244190),
(346748, 'PTHR42799:SF18', NULL, NULL, NULL, NULL, 'PROTEIN-METHIONINE-S-OXIDE REDUCTASE', 244191),
(346749, 'PTHR42799:SF17', NULL, NULL, NULL, NULL, 'PROTEIN-METHIONINE-S-OXIDE REDUCTASE', 244191),
(346750, 'PTHR42799:SF25', NULL, NULL, NULL, NULL, 'PEPTIDE METHIONINE SULFOXIDE REDUCTASE A1', 244191),
(346751, 'PTHR42799:SF24', NULL, NULL, NULL, NULL, 'PROTEIN-METHIONINE-S-OXIDE REDUCTASE', 244191),
(346752, 'PTHR42799:SF13', NULL, NULL, NULL, NULL, 'PEPTIDE METHIONINE SULFOXIDE REDUCTASE', 244191),
(346753, 'PTHR42799:SF16', NULL, NULL, NULL, NULL, 'PEPTIDE METHIONINE SULFOXIDE REDUCTASE A2', 244191),
(346754, 'PTHR42799:SF15', NULL, NULL, NULL, NULL, 'PROTEIN-METHIONINE-S-OXIDE REDUCTASE', 244191),
(346755, 'PTHR42799:SF26', NULL, NULL, NULL, NULL, 'PROTEIN-METHIONINE-S-OXIDE REDUCTASE', 244191),
(346756, 'PTHR42799', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PEPTIDE METHIONINE SULFOXIDE REDUCTASE', 244191),
(346757, 'PTHR42799:SF20', NULL, NULL, NULL, NULL, 'PROTEIN-METHIONINE-S-OXIDE REDUCTASE', 244191),
(346758, 'PTHR42799:SF23', NULL, NULL, NULL, NULL, 'PEPTIDE-METHIONINE (S)-S-OXIDE REDUCTASE', 244191),
(346759, 'PTHR42799:SF22', NULL, NULL, NULL, NULL, 'PEPTIDE-METHIONINE (S)-S-OXIDE REDUCTASE', 244191),
(346760, 'PTHR42799:SF9', NULL, NULL, NULL, NULL, 'PEPTIDE METHIONINE SULFOXIDE REDUCTASE A3', 244191),
(346761, 'PTHR42799:SF8', NULL, NULL, NULL, NULL, 'PEPTIDE METHIONINE SULFOXIDE REDUCTASE A2-2', 244191),
(346762, 'PTHR42799:SF3', NULL, NULL, NULL, NULL, 'PEPTIDE METHIONINE SULFOXIDE REDUCTASE A5', 244191),
(346763, 'PTHR42799:SF2', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PEPTIDE METHIONINE SULFOXIDE REDUCTASE', 244191),
(346764, 'PTHR47562', NULL, NULL, NULL, NULL, '', 244192),
(346765, 'PTHR47562:SF2', NULL, NULL, NULL, NULL, 'CARBOXYMETHYLENEBUTENOLIDASE-RELATED', 244192),
(346766, 'PTHR11215:SF5', NULL, NULL, NULL, NULL, 'METAL-DEPENDENT PROTEIN HYDROLASE', 244193);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(346767, 'PTHR11215', NULL, NULL, NULL, NULL, 'METAL DEPENDENT HYDROLASE - RELATED', 244193),
(346768, 'PTHR11215:SF3', NULL, NULL, NULL, NULL, 'METAL-DEPENDENT PROTEIN HYDROLASE', 244193),
(346769, 'PTHR11215:SF1', NULL, NULL, NULL, NULL, 'MYG1 EXONUCLEASE', 244193),
(346770, 'PTHR14270:SF0', NULL, NULL, NULL, NULL, 'PROTEIN SMG9', 244194),
(346771, 'PTHR14270', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244194),
(346772, 'PTHR43168:SF6', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L33 1', 244195),
(346773, 'PTHR43168:SF5', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L33 2', 244195),
(346774, 'PTHR43168:SF2', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L33, CHLOROPLASTIC', 244195),
(346775, 'PTHR43168', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L33, CHLOROPLASTIC', 244195),
(346776, 'PTHR43168:SF7', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L33, CHLOROPLASTIC', 244195),
(346777, 'PTHR12677:SF9', NULL, NULL, NULL, NULL, '', 244196),
(346778, 'PTHR12677:SF59', NULL, NULL, NULL, NULL, 'TVP38/TMEM64 FAMILY INNER MEMBRANE PROTEIN YDJZ', 244196),
(346779, 'PTHR12677:SF49', NULL, NULL, NULL, NULL, 'TVP38/TMEM64 FAMILY MEMBRANE PROTEIN', 244196),
(346780, 'PTHR12677:SF57', NULL, NULL, NULL, NULL, 'BNAA04G18420D PROTEIN', 244196),
(346781, 'PTHR12677:SF24', NULL, NULL, NULL, NULL, 'OS07G0655900 PROTEIN', 244196),
(346782, 'PTHR12677:SF47', NULL, NULL, NULL, NULL, 'BNAC08G45730D PROTEIN', 244196),
(346783, 'PTHR12677:SF58', NULL, NULL, NULL, NULL, 'TVP38/TMEM64 FAMILY MEMBRANE PROTEIN RV0625C', 244196),
(346784, 'PTHR12677:SF51', NULL, NULL, NULL, NULL, '', 244196),
(346785, 'PTHR12677', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244196),
(346786, 'PTHR12677:SF50', NULL, NULL, NULL, NULL, 'BNAA09G50950D PROTEIN', 244196),
(346787, 'PTHR12677:SF55', NULL, NULL, NULL, NULL, 'TVP38/TMEM64 FAMILY MEMBRANE PROTEIN', 244196),
(346788, 'PTHR12677:SF56', NULL, NULL, NULL, NULL, 'TVP38/TMEM64 FAMILY MEMBRANE PROTEIN SLR0305-LIKE ISOFORM X1', 244196),
(346789, 'PTHR12677:SF53', NULL, NULL, NULL, NULL, '', 244196),
(346790, 'PTHR12677:SF54', NULL, NULL, NULL, NULL, 'SNARE ASSOCIATED GOLGI PROTEIN FAMILY-RELATED', 244196),
(346791, 'PTHR20383:SF11', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II SUBUNIT A C-TERMINAL DOMAIN PHOSPHATASE SSU72', 244197),
(346792, 'PTHR20383:SF10', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II SUBUNIT A C-TERMINAL DOMAIN PHOSPHATASE SSU72', 244197),
(346793, 'PTHR20383:SF12', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II SUBUNIT A C-TERMINAL DOMAIN PHOSPHATASE SSU72', 244197),
(346794, 'PTHR20383', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II SUBUNIT A C-TERMINAL DOMAIN PHOSPHATASE', 244197),
(346795, 'PTHR20383:SF9', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II SUBUNIT A C-TERMINAL DOMAIN PHOSPHATASE SSU72', 244197),
(346796, 'PTHR10070', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN J CHAIN', 244198),
(346797, 'PTHR10070:SF2', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN J CHAIN', 244198),
(346798, 'PTHR43189:SF2', NULL, NULL, NULL, NULL, 'GLUCOSE 1-DEHYDROGENASE', 244199),
(346799, 'PTHR43189', NULL, NULL, NULL, NULL, 'ZINC-TYPE ALCOHOL DEHYDROGENASE-LIKE PROTEIN C1198.01-RELATED', 244199),
(346800, 'PTHR43189:SF1', NULL, NULL, NULL, NULL, 'ZINC-TYPE ALCOHOL DEHYDROGENASE-LIKE PROTEIN C1198.01', 244199),
(346801, 'PTHR35493:SF2', NULL, NULL, NULL, NULL, 'EPIDERMAL GROWTH FACTOR RECEPTOR SUBSTRATE 15 HOMOLOG', 244200),
(346802, 'PTHR35493:SF1', NULL, NULL, NULL, NULL, 'STRUCTURAL MAINTENANCE OF CHROMOSOMES PROTEIN', 244200),
(346803, 'PTHR35493', NULL, NULL, NULL, NULL, 'STRUCTURAL MAINTENANCE OF CHROMOSOMES PROTEIN', 244200),
(346804, 'PTHR33264:SF51', NULL, NULL, NULL, NULL, '', 244201),
(346805, 'PTHR33264:SF50', NULL, NULL, NULL, NULL, '', 244201),
(346806, 'PTHR33264:SF37', NULL, NULL, NULL, NULL, 'BNAANNG39210D PROTEIN', 244201),
(346807, 'PTHR33264:SF59', NULL, NULL, NULL, NULL, 'BNAC03G72760D PROTEIN', 244201),
(346808, 'PTHR33264:SF58', NULL, NULL, NULL, NULL, '', 244201),
(346809, 'PTHR33264:SF57', NULL, NULL, NULL, NULL, '', 244201),
(346810, 'PTHR33264:SF56', NULL, NULL, NULL, NULL, '', 244201);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(346811, 'PTHR33264:SF55', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244201),
(346812, 'PTHR33264:SF54', NULL, NULL, NULL, NULL, '', 244201),
(346813, 'PTHR33264:SF31', NULL, NULL, NULL, NULL, '', 244201),
(346814, 'PTHR33264:SF53', NULL, NULL, NULL, NULL, '', 244201),
(346815, 'PTHR33264:SF52', NULL, NULL, NULL, NULL, '', 244201),
(346816, 'PTHR33264:SF38', NULL, NULL, NULL, NULL, '', 244201),
(346817, 'PTHR33264:SF16', NULL, NULL, NULL, NULL, 'OS03G0750500 PROTEIN', 244201),
(346818, 'PTHR33264', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244201),
(346819, 'PTHR33264:SF3', NULL, NULL, NULL, NULL, 'OS01G0638800 PROTEIN', 244201),
(346820, 'PTHR33264:SF62', NULL, NULL, NULL, NULL, 'OS01G0661650 PROTEIN', 244201),
(346821, 'PTHR33264:SF61', NULL, NULL, NULL, NULL, 'F24J5.7', 244201),
(346822, 'PTHR33264:SF60', NULL, NULL, NULL, NULL, 'BNAA05G27390D PROTEIN', 244201),
(346823, 'PTHR33264:SF6', NULL, NULL, NULL, NULL, '', 244201),
(346824, 'PTHR33264:SF8', NULL, NULL, NULL, NULL, 'GB|AAF02136.1', 244201),
(346825, 'PTHR33264:SF25', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 244201),
(346826, 'PTHR33264:SF24', NULL, NULL, NULL, NULL, 'BNAC02G02000D PROTEIN', 244201),
(346827, 'PTHR33264:SF46', NULL, NULL, NULL, NULL, 'BNAANNG41820D PROTEIN', 244201),
(346828, 'PTHR33264:SF44', NULL, NULL, NULL, NULL, 'BNACNNG34780D PROTEIN', 244201),
(346829, 'PTHR33264:SF42', NULL, NULL, NULL, NULL, 'BNAA05G33790D PROTEIN', 244201),
(346830, 'PTHR33264:SF63', NULL, NULL, NULL, NULL, '', 244201),
(346831, 'PTHR33264:SF28', NULL, NULL, NULL, NULL, '', 244201),
(346832, 'PTHR33264:SF49', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244201),
(346833, 'PTHR33264:SF27', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 244201),
(346834, 'PTHR34523:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 138', 244202),
(346835, 'PTHR34523', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 138', 244202),
(346836, 'PTHR14931:SF2', NULL, NULL, NULL, NULL, 'LIGAND DEPENDENT NUCLEAR RECEPTOR COREPRESSOR', 244203),
(346837, 'PTHR14931', NULL, NULL, NULL, NULL, 'GENE 340-RELATED', 244203),
(346838, 'PTHR14931:SF1', NULL, NULL, NULL, NULL, '', 244203),
(346839, 'PTHR37811:SF2', NULL, NULL, NULL, NULL, 'ABM DOMAIN-CONTAINING PROTEIN', 244204),
(346840, 'PTHR37811', NULL, NULL, NULL, NULL, 'BLL5343 PROTEIN', 244204),
(346841, 'PTHR36081:SF1', NULL, NULL, NULL, NULL, 'CELL WALL INTEGRITY/STRESS RESPONSE COMPONENT', 244205),
(346842, 'PTHR36081', NULL, NULL, NULL, NULL, 'CELL WALL INTEGRITY/STRESS RESPONSE COMPONENT', 244205),
(346843, 'PTHR48046:SF5', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 72E2-RELATED', 244206),
(346844, 'PTHR48046:SF6', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 244206),
(346845, 'PTHR48046:SF7', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 72E1', 244206),
(346846, 'PTHR48046:SF8', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 244206),
(346847, 'PTHR48046:SF9', NULL, NULL, NULL, NULL, 'ANTHOCYANIDIN 3-O-GLUCOSYLTRANSFERASE 5-LIKE', 244206),
(346848, 'PTHR48046', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 72E1', 244206),
(346849, 'PTHR48046:SF1', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE-RELATED', 244206),
(346850, 'PTHR48046:SF3', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 244206),
(346851, 'PTHR48046:SF4', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 244206),
(346852, 'PTHR11021:SF3', NULL, NULL, NULL, NULL, 'SM PROTEIN F', 244207),
(346853, 'PTHR11021:SF1', NULL, NULL, NULL, NULL, 'U6 SNRNA-ASSOCIATED SM-LIKE PROTEIN LSM6', 244207),
(346854, 'PTHR11021:SF0', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN F', 244207),
(346855, 'PTHR11021:SF10', NULL, NULL, NULL, NULL, 'SM-LIKE PROTEIN LSM6A', 244207),
(346856, 'PTHR11021:SF5', NULL, NULL, NULL, NULL, 'SM PROTEIN F', 244207),
(346857, 'PTHR11021', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN F  SNRNP-F', 244207),
(346858, 'PTHR11021:SF9', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN F', 244207),
(346859, 'PTHR11021:SF8', NULL, NULL, NULL, NULL, 'SM-LIKE PROTEIN LSM36B-RELATED', 244207);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(346860, 'PTHR46721:SF1', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN N1', 244208),
(346861, 'PTHR46721', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN N1', 244208),
(346862, 'PTHR42709', NULL, NULL, NULL, NULL, 'ALKALINE PHOSPHATASE LIKE PROTEIN', 244209),
(346863, 'PTHR42709:SF9', NULL, NULL, NULL, NULL, 'ALKALINE PHOSPHATASE LIKE PROTEIN', 244209),
(346864, 'PTHR42709:SF6', NULL, NULL, NULL, NULL, 'ALKALINE PHOSPHATASE LIKE PROTEIN', 244209),
(346865, 'PTHR42709:SF7', NULL, NULL, NULL, NULL, 'RHODANESE DOMAIN-CONTAINING PROTEIN', 244209),
(346866, 'PTHR42709:SF8', NULL, NULL, NULL, NULL, 'ALKALINE PHOSPHATASE LIKE PROTEIN', 244209),
(346867, 'PTHR42709:SF2', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YOHD', 244209),
(346868, 'PTHR42709:SF10', NULL, NULL, NULL, NULL, 'SNARE ASSOCIATED GOLGI PROTEIN', 244209),
(346869, 'PTHR42709:SF4', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YQAA', 244209),
(346870, 'PTHR20990:SF1', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN 11C', 244210),
(346871, 'PTHR20990', NULL, NULL, NULL, NULL, 'PEROXISOMAL BIOGENESIS FACTOR 11', 244210),
(346872, 'PTHR45296', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN', 244211),
(346873, 'PTHR45296:SF1', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN', 244211),
(346874, 'PTHR45000:SF5', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', 244212),
(346875, 'PTHR45000:SF4', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN-BINDING PROTEIN', 244212),
(346876, 'PTHR45000:SF6', NULL, NULL, NULL, NULL, 'OS07G0124800 PROTEIN', 244212),
(346877, 'PTHR45000', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', 244212),
(346878, 'PTHR44846:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR OF 2-AMINOETHYLPHOSPHONATE DEGRADATION OPERONS-RELATED', 244213),
(346879, 'PTHR44846:SF5', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR GMUR', 244213),
(346880, 'PTHR44846:SF6', NULL, NULL, NULL, NULL, 'HTH GNTR-TYPE DOMAIN-CONTAINING PROTEIN', 244213),
(346881, 'PTHR44846', NULL, NULL, NULL, NULL, 'MANNOSYL-D-GLYCERATE TRANSPORT/METABOLISM SYSTEM REPRESSOR MNGR-RELATED', 244213),
(346882, 'PTHR44846:SF4', NULL, NULL, NULL, NULL, 'HTH GNTR-TYPE DOMAIN-CONTAINING PROTEIN', 244213),
(346883, 'PTHR44846:SF1', NULL, NULL, NULL, NULL, 'MANNOSYL-D-GLYCERATE TRANSPORT/METABOLISM SYSTEM REPRESSOR MNGR', 244213),
(346884, 'PTHR44846:SF12', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR TRER', 244213),
(346885, 'PTHR44846:SF13', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REPRESSOR DASR', 244213),
(346886, 'PTHR44846:SF10', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', 244213),
(346887, 'PTHR44846:SF16', NULL, NULL, NULL, NULL, 'HISTIDINE UTILIZATION REPRESSOR', 244213),
(346888, 'PTHR44846:SF14', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR PHNF-RELATED', 244213),
(346889, 'PTHR44846:SF15', NULL, NULL, NULL, NULL, 'FRUCTOSELYSINE UTILIZATION OPERON TRANSCRIPTIONAL REPRESSOR-RELATED', 244213),
(346890, 'PTHR23088:SF54', NULL, NULL, NULL, NULL, 'OMEGA-AMIDASE, CHLOROPLASTIC-LIKE', 244214),
(346891, 'PTHR23088:SF53', NULL, NULL, NULL, NULL, 'CN HYDROLASE DOMAIN-CONTAINING PROTEIN', 244214),
(346892, 'PTHR23088:SF30', NULL, NULL, NULL, NULL, 'OMEGA-AMIDASE NIT2', 244214),
(346893, 'PTHR23088', NULL, NULL, NULL, NULL, 'NITRILASE-RELATED', 244214),
(346894, 'PTHR23088:SF27', NULL, NULL, NULL, NULL, 'DEAMINATED GLUTATHIONE AMIDASE', 244214),
(346895, 'PTHR23088:SF50', NULL, NULL, NULL, NULL, 'HYDROLASE YHCX', 244214),
(346896, 'PTHR37198', NULL, NULL, NULL, NULL, 'NUCLEOLIN', 244215),
(346897, 'PTHR37198:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 244215),
(346898, 'PTHR37198:SF1', NULL, NULL, NULL, NULL, 'NUCLEOLIN', 244215),
(346899, 'PTHR15530', NULL, NULL, NULL, NULL, 'SERTA DOMAIN-CONTAINING PROTEIN 3', 244216),
(346900, 'PTHR15530:SF0', NULL, NULL, NULL, NULL, 'SERTA DOMAIN-CONTAINING PROTEIN 3', 244216),
(346901, 'PTHR46044:SF13', NULL, NULL, NULL, NULL, 'NITRILASE-RELATED', 244217);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(346902, 'PTHR46044:SF8', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL NITRILASE/NITRILE HYDRATASE NIT4B-LIKE ISOFORM X1', 244217),
(346903, 'PTHR46044:SF12', NULL, NULL, NULL, NULL, 'HYDROLASE', 244217),
(346904, 'PTHR46044:SF11', NULL, NULL, NULL, NULL, 'NITRILASE 1-RELATED', 244217),
(346905, 'PTHR46044:SF6', NULL, NULL, NULL, NULL, 'OS02G0635000 PROTEIN', 244217),
(346906, 'PTHR46044', NULL, NULL, NULL, NULL, 'NITRILASE', 244217),
(346907, 'PTHR46044:SF4', NULL, NULL, NULL, NULL, 'CYANIDE HYDRATASE', 244217),
(346908, 'PTHR46044:SF1', NULL, NULL, NULL, NULL, 'CN HYDROLASE DOMAIN-CONTAINING PROTEIN', 244217),
(346909, 'PTHR46044:SF15', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL NITRILASE/NITRILE HYDRATASE NIT4B-RELATED', 244217),
(346910, 'PTHR46044:SF2', NULL, NULL, NULL, NULL, 'CN HYDROLASE DOMAIN-CONTAINING PROTEIN', 244217),
(346911, 'PTHR46044:SF14', NULL, NULL, NULL, NULL, 'ARYLACETONITRILASE', 244217),
(346912, 'PTHR44145:SF3', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY A MEMBER 3, MITOCHONDRIAL', 244218),
(346913, 'PTHR44145:SF4', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 244218),
(346914, 'PTHR44145', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY A MEMBER 3, MITOCHONDRIAL', 244218),
(346915, 'PTHR23130:SF192', NULL, NULL, NULL, NULL, 'DOMON DOMAIN-CONTAINING PROTEIN', 244219),
(346916, 'PTHR23130:SF195', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 AND DOMON DOMAIN-CONTAINING PROTEIN', 244219),
(346917, 'PTHR23130:SF185', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 AND DOMON DOMAIN-CONTAINING PROTEIN', 244219),
(346918, 'PTHR23130:SF187', NULL, NULL, NULL, NULL, 'DOMON DOMAIN-CONTAINING PROTEIN', 244219),
(346919, 'PTHR23130:SF144', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 AND DOMON DOMAIN-CONTAINING PROTEIN', 244219),
(346920, 'PTHR23130:SF189', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 AND DOMON DOMAIN-CONTAINING PROTEIN', 244219),
(346921, 'PTHR23130:SF180', NULL, NULL, NULL, NULL, 'DOMON DOMAIN-CONTAINING PROTEIN', 244219),
(346922, 'PTHR23130:SF182', NULL, NULL, NULL, NULL, 'BNAC01G39790D PROTEIN', 244219),
(346923, 'PTHR23130:SF183', NULL, NULL, NULL, NULL, 'DOMON DOMAIN-CONTAINING PROTEIN-RELATED', 244219),
(346924, 'PTHR23130:SF184', NULL, NULL, NULL, NULL, 'OS09G0501100 PROTEIN', 244219),
(346925, 'PTHR23130:SF174', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 AND DOMON DOMAIN-CONTAINING PROTEIN', 244219),
(346926, 'PTHR23130:SF175', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 AND DOMON DOMAIN-CONTAINING PROTEIN', 244219),
(346927, 'PTHR23130:SF176', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 AND DOMON DOMAIN-CONTAINING PROTEIN', 244219),
(346928, 'PTHR23130:SF210', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 AND DOMON DOMAIN-CONTAINING PROTEIN', 244219),
(346929, 'PTHR23130:SF177', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 AND DOMON DOMAIN-CONTAINING PROTEIN', 244219),
(346930, 'PTHR23130:SF178', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 AND DOMON DOMAIN-CONTAINING PROTEIN', 244219),
(346931, 'PTHR23130:SF211', NULL, NULL, NULL, NULL, 'BNAA09G39450D PROTEIN', 244219),
(346932, 'PTHR23130:SF212', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE FAMILY PROTEIN', 244219),
(346933, 'PTHR23130:SF179', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 DOMAIN-CONTAINING PROTEIN', 244219),
(346934, 'PTHR23130:SF213', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 AND DOMON DOMAIN-CONTAINING PROTEIN', 244219),
(346935, 'PTHR23130:SF214', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 AND DOMON DOMAIN-CONTAINING PROTEIN', 244219),
(346936, 'PTHR23130:SF215', NULL, NULL, NULL, NULL, '', 244219),
(346937, 'PTHR23130:SF89', NULL, NULL, NULL, NULL, 'OS08G0524400 PROTEIN', 244219),
(346938, 'PTHR23130:SF216', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE, EXPRESSED-RELATED', 244219),
(346939, 'PTHR23130:SF217', NULL, NULL, NULL, NULL, '', 244219),
(346940, 'PTHR23130:SF86', NULL, NULL, NULL, NULL, 'OS05G0556400 PROTEIN', 244219),
(346941, 'PTHR23130:SF218', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 AND DOMON DOMAIN-CONTAINING PROTEIN', 244219),
(346942, 'PTHR23130:SF170', NULL, NULL, NULL, NULL, 'DOPAMINE BETA-MONOOXYGENASE', 244219);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(346943, 'PTHR23130:SF171', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 AND DOMON DOMAIN-CONTAINING PROTEIN', 244219),
(346944, 'PTHR23130:SF172', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 AND DOMON DOMAIN-CONTAINING PROTEIN', 244219),
(346945, 'PTHR23130:SF173', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 AND DOMON DOMAIN-CONTAINING PROTEIN', 244219),
(346946, 'PTHR23130:SF165', NULL, NULL, NULL, NULL, '', 244219),
(346947, 'PTHR23130:SF167', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 AND DOMON DOMAIN-CONTAINING PROTEIN', 244219),
(346948, 'PTHR23130', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 AND DOMON DOMAIN-CONTAINING PROTEIN', 244219),
(346949, 'PTHR23130:SF200', NULL, NULL, NULL, NULL, 'DOMON DOMAIN-CONTAINING PROTEIN', 244219),
(346950, 'PTHR23130:SF203', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 AND DOMON DOMAIN-CONTAINING PROTEIN', 244219),
(346951, 'PTHR23130:SF204', NULL, NULL, NULL, NULL, 'DOMON DOMAIN-CONTAINING PROTEIN', 244219),
(346952, 'PTHR23130:SF205', NULL, NULL, NULL, NULL, 'DOMON DOMAIN-CONTAINING PROTEIN', 244219),
(346953, 'PTHR23130:SF206', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 AND DOMON DOMAIN-CONTAINING PROTEIN', 244219),
(346954, 'PTHR23130:SF207', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 AND DOMON DOMAIN-CONTAINING PROTEIN', 244219),
(346955, 'PTHR23130:SF162', NULL, NULL, NULL, NULL, '', 244219),
(346956, 'PTHR23130:SF196', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 AND DOMON DOMAIN-CONTAINING PROTEIN', 244219),
(346957, 'PTHR23130:SF153', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 DOMAIN-CONTAINING PROTEIN', 244219),
(346958, 'PTHR23130:SF154', NULL, NULL, NULL, NULL, 'OS01G0895200 PROTEIN', 244219),
(346959, 'PTHR23130:SF198', NULL, NULL, NULL, NULL, 'CYTOCHROME AND DOMON DOMAIN-CONTAINING PROTEIN', 244219),
(346960, 'PTHR23130:SF199', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 AND DOMON DOMAIN-CONTAINING PROTEIN', 244219),
(346961, 'PTHR23130:SF156', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE FAMILY PROTEIN', 244219),
(346962, 'PTHR23130:SF157', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED IN ROOT CULTURES PROTEIN 12', 244219),
(346963, 'PTHR23130:SF115', NULL, NULL, NULL, NULL, 'OS01G0680900 PROTEIN', 244219),
(346964, 'PTHR23130:SF159', NULL, NULL, NULL, NULL, 'OS08G0335600 PROTEIN', 244219),
(346965, 'PTHR23130:SF60', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 AND DOMON DOMAIN-CONTAINING PROTEIN', 244219),
(346966, 'PTHR34930:SF4', NULL, NULL, NULL, NULL, 'JUPITER MICROTUBULE ASSOCIATED HOMOLOG 1', 244220),
(346967, 'PTHR34930:SF5', NULL, NULL, NULL, NULL, 'JUPITER MICROTUBULE ASSOCIATED HOMOLOG 2', 244220),
(346968, 'PTHR34930:SF2', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN JUPITER', 244220),
(346969, 'PTHR34930:SF9', NULL, NULL, NULL, NULL, 'JUPITER MICROTUBULE ASSOCIATED HOMOLOG 1', 244220),
(346970, 'PTHR34930', NULL, NULL, NULL, NULL, 'GEO05313P1', 244220),
(346971, 'PTHR39639', NULL, NULL, NULL, NULL, 'CHROMOSOME 16, WHOLE GENOME SHOTGUN SEQUENCE', 244221),
(346972, 'PTHR39639:SF1', NULL, NULL, NULL, NULL, 'DUF262 DOMAIN-CONTAINING PROTEIN', 244221),
(346973, 'PTHR46551:SF1', NULL, NULL, NULL, NULL, 'SAP DOMAIN-CONTAINING RIBONUCLEOPROTEIN', 244222),
(346974, 'PTHR46551:SF2', NULL, NULL, NULL, NULL, 'SAP DOMAIN-CONTAINING RIBONUCLEOPROTEIN', 244222),
(346975, 'PTHR46551:SF3', NULL, NULL, NULL, NULL, 'SAP DOMAIN-CONTAINING PROTEIN', 244222),
(346976, 'PTHR46551', NULL, NULL, NULL, NULL, 'SAP DOMAIN-CONTAINING RIBONUCLEOPROTEIN', 244222),
(346977, 'PTHR11697:SF228', NULL, NULL, NULL, NULL, 'ZINC FINGER MYM-TYPE PROTEIN 1-LIKE', 244223),
(346978, 'PTHR11697:SF217', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR 2-RELATED ZINC FINGER PROTEIN-RELATED', 244223),
(346979, 'PTHR11697:SF227', NULL, NULL, NULL, NULL, 'ZINC FINGER, MYM DOMAIN-CONTAINING 1', 244223),
(346980, 'PTHR11697:SF229', NULL, NULL, NULL, NULL, 'TTF-TYPE ZINC FINGER PROTEIN WITH HAT DIMERIZATION DOMAIN', 244223),
(346981, 'PTHR11697', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR 2-RELATED ZINC FINGER PROTEIN', 244223),
(346982, 'PTHR12128:SF15', NULL, NULL, NULL, NULL, '4-HYDROXY-2-OXOGLUTARATE ALDOLASE, MITOCHONDRIAL', 244224);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(346983, 'PTHR12128:SF59', NULL, NULL, NULL, NULL, '4-HYDROXY-TETRAHYDRODIPICOLINATE SYNTHASE', 244224),
(346984, 'PTHR12128:SF69', NULL, NULL, NULL, NULL, '4-HYDROXY-TETRAHYDRODIPICOLINATE SYNTHASE', 244224),
(346985, 'PTHR12128:SF47', NULL, NULL, NULL, NULL, 'DIHYDRODIPICOLINATE SYNTHETASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_2G01230)', 244224),
(346986, 'PTHR12128:SF58', NULL, NULL, NULL, NULL, '4-HYDROXY-TETRAHYDRODIPICOLINATE SYNTHASE', 244224),
(346987, 'PTHR12128:SF28', NULL, NULL, NULL, NULL, '2-DEHYDRO-3-DEOXY-D-GLUCONATE ALDOLASE YAGE-RELATED', 244224),
(346988, 'PTHR12128:SF38', NULL, NULL, NULL, NULL, 'DIHYDRODIPICOLINATE SYNTHETASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_6G00110)', 244224),
(346989, 'PTHR12128:SF19', NULL, NULL, NULL, NULL, '5-DEHYDRO-4-DEOXYGLUCARATE DEHYDRATASE 2-RELATED', 244224),
(346990, 'PTHR12128:SF62', NULL, NULL, NULL, NULL, '4-HYDROXY-TETRAHYDRODIPICOLINATE SYNTHASE', 244224),
(346991, 'PTHR12128:SF51', NULL, NULL, NULL, NULL, 'BLL4205 PROTEIN', 244224),
(346992, 'PTHR12128:SF52', NULL, NULL, NULL, NULL, '4-HYDROXY-2-OXOGLUTARATE ALDOLASE, MITOCHONDRIAL-RELATED', 244224),
(346993, 'PTHR12128:SF55', NULL, NULL, NULL, NULL, '4-HYDROXY-TETRAHYDRODIPICOLINATE SYNTHASE 2, CHLOROPLASTIC', 244224),
(346994, 'PTHR12128:SF66', NULL, NULL, NULL, NULL, '4-HYDROXY-TETRAHYDRODIPICOLINATE SYNTHASE', 244224),
(346995, 'PTHR12128:SF21', NULL, NULL, NULL, NULL, 'N-ACETYLNEURAMINATE LYASE', 244224),
(346996, 'PTHR12128:SF24', NULL, NULL, NULL, NULL, 'DIHYDRODIPICOLINATE SYNTHETASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_3G11920)', 244224),
(346997, 'PTHR12128:SF57', NULL, NULL, NULL, NULL, '4-HYDROXY-TETRAHYDRODIPICOLINATE SYNTHASE, CHLOROPLASTIC', 244224),
(346998, 'PTHR12128:SF68', NULL, NULL, NULL, NULL, 'DIHYDRODIPICOLINATE SYNTHETASE', 244224),
(346999, 'PTHR12128:SF67', NULL, NULL, NULL, NULL, 'BLR3884 PROTEIN', 244224),
(347000, 'PTHR12128', NULL, NULL, NULL, NULL, 'DIHYDRODIPICOLINATE SYNTHASE', 244224),
(347001, 'PTHR12128:SF71', NULL, NULL, NULL, NULL, '4-HYDROXY-TETRAHYDRODIPICOLINATE SYNTHASE 2, CHLOROPLASTIC', 244224),
(347002, 'PTHR12128:SF60', NULL, NULL, NULL, NULL, '4-HYDROXY-TETRAHYDRODIPICOLINATE SYNTHASE', 244224),
(347003, 'PTHR12128:SF70', NULL, NULL, NULL, NULL, 'N-ACETYLNEURAMINATE LYASE-RELATED', 244224),
(347004, 'PTHR33238:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR MNTR', 244225),
(347005, 'PTHR33238', NULL, NULL, NULL, NULL, 'IRON (METAL) DEPENDENT REPRESSOR, DTXR FAMILY', 244225),
(347006, 'PTHR33238:SF10', NULL, NULL, NULL, NULL, 'IRON-DEPENDENT REPRESSOR IDER', 244225),
(347007, 'PTHR34209:SF4', NULL, NULL, NULL, NULL, 'BNAC01G24130D PROTEIN', 244226),
(347008, 'PTHR34209:SF3', NULL, NULL, NULL, NULL, 'RHODANESE/CELL CYCLE CONTROL PHOSPHATASE SUPERFAMILY PROTEIN', 244226),
(347009, 'PTHR34209:SF1', NULL, NULL, NULL, NULL, 'CALCIUM SENSING RECEPTOR, CHLOROPLASTIC', 244226),
(347010, 'PTHR34209', NULL, NULL, NULL, NULL, 'RHODANESE/CELL CYCLE CONTROL PHOSPHATASE SUPERFAMILY PROTEIN', 244226),
(347011, 'PTHR24036:SF17', NULL, NULL, NULL, NULL, 'DM13 DOMAIN-CONTAINING PROTEIN', 244227),
(347012, 'PTHR24036:SF16', NULL, NULL, NULL, NULL, 'KNICKKOPF', 244227),
(347013, 'PTHR24036:SF13', NULL, NULL, NULL, NULL, 'PROTEIN SKELETOR, ISOFORMS D/E', 244227),
(347014, 'PTHR24036:SF5', NULL, NULL, NULL, NULL, 'THROMBOMODULIN', 244227),
(347015, 'PTHR24036', NULL, NULL, NULL, NULL, 'SKELETOR-RELATED', 244227),
(347016, 'PTHR43273:SF3', NULL, NULL, NULL, NULL, 'RADICAL SAM DOMAIN PROTEIN', 244228),
(347017, 'PTHR43273:SF2', NULL, NULL, NULL, NULL, 'RADICAL SAM DOMAIN CONTAINING PROTEIN', 244228),
(347018, 'PTHR43273:SF7', NULL, NULL, NULL, NULL, 'ANAEROBIC SULFATASE-MATURATING ENZYME HOMOLOG YDEM', 244228),
(347019, 'PTHR43273:SF6', NULL, NULL, NULL, NULL, 'ANAEROBIC SULFATASE-MATURATING ENZYME HOMOLOG ASLB', 244228),
(347020, 'PTHR43273', NULL, NULL, NULL, NULL, 'ANAEROBIC SULFATASE-MATURATING ENZYME HOMOLOG ASLB-RELATED', 244228),
(347021, 'PTHR43273:SF8', NULL, NULL, NULL, NULL, 'ARYLSULFATASE REGULATOR', 244228),
(347022, 'PTHR31176:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG09313', 244229);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(347023, 'PTHR31176:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG12635', 244229),
(347024, 'PTHR31176:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG02297', 244229),
(347025, 'PTHR31176', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244229),
(347026, 'PTHR36435:SF1', NULL, NULL, NULL, NULL, 'ABORTIVE INFECTION PROTEIN', 244230),
(347027, 'PTHR36435:SF5', NULL, NULL, NULL, NULL, 'CAAX AMINO TERMINAL PROTEASE FAMILY', 244230),
(347028, 'PTHR36435', NULL, NULL, NULL, NULL, 'SLR1288 PROTEIN', 244230),
(347029, 'PTHR34491:SF90', NULL, NULL, NULL, NULL, 'GLUCOAMYLASE S1/S2', 244231),
(347030, 'PTHR34491:SF130', NULL, NULL, NULL, NULL, 'CORNETTO, ISOFORM C', 244231),
(347031, 'PTHR34491:SF131', NULL, NULL, NULL, NULL, 'A-TYPE INCLUSION PROTEIN, PUTATIVE-RELATED', 244231),
(347032, 'PTHR34491:SF93', NULL, NULL, NULL, NULL, 'PROTEIN LSD90', 244231),
(347033, 'PTHR34491:SF94', NULL, NULL, NULL, NULL, 'COILED-COIL PROTEIN', 244231),
(347034, 'PTHR34491:SF91', NULL, NULL, NULL, NULL, 'UBIQUITINATION NETWORK SIGNALING PROTEIN ACRB', 244231),
(347035, 'PTHR34491:SF92', NULL, NULL, NULL, NULL, 'SPORULATION-SPECIFIC PROTEIN 15', 244231),
(347036, 'PTHR34491:SF97', NULL, NULL, NULL, NULL, '', 244231),
(347037, 'PTHR34491:SF98', NULL, NULL, NULL, NULL, 'AXONEME-ASSOCIATED PROTEIN GASP-180', 244231),
(347038, 'PTHR34491:SF51', NULL, NULL, NULL, NULL, '', 244231),
(347039, 'PTHR34491:SF95', NULL, NULL, NULL, NULL, '', 244231),
(347040, 'PTHR34491:SF96', NULL, NULL, NULL, NULL, 'GOLD DOMAIN-CONTAINING PROTEIN', 244231),
(347041, 'PTHR34491:SF129', NULL, NULL, NULL, NULL, 'A-TYPE INCLUSION PROTEIN, PUTATIVE-RELATED', 244231),
(347042, 'PTHR34491:SF58', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 244231),
(347043, 'PTHR34491:SF99', NULL, NULL, NULL, NULL, 'PROTEIN CBG26821', 244231),
(347044, 'PTHR34491:SF121', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE-III DOMAIN-CONTAINING PROTEIN', 244231),
(347045, 'PTHR34491:SF122', NULL, NULL, NULL, NULL, '', 244231),
(347046, 'PTHR34491:SF123', NULL, NULL, NULL, NULL, 'COILED-COILS Y-RELATED', 244231),
(347047, 'PTHR34491:SF124', NULL, NULL, NULL, NULL, 'CEP57_MT_BD DOMAIN-CONTAINING PROTEIN', 244231),
(347048, 'PTHR34491:SF125', NULL, NULL, NULL, NULL, '', 244231),
(347049, 'PTHR34491:SF126', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN CONTAINING 110', 244231),
(347050, 'PTHR34491:SF127', NULL, NULL, NULL, NULL, 'PROTEIN CBG24769', 244231),
(347051, 'PTHR34491:SF128', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 244231),
(347052, 'PTHR34491', NULL, NULL, NULL, NULL, 'A-TYPE INCLUSION PROTEIN, PUTATIVE-RELATED', 244231),
(347053, 'PTHR34491:SF63', NULL, NULL, NULL, NULL, 'GAT DOMAIN-CONTAINING PROTEIN', 244231),
(347054, 'PTHR34491:SF68', NULL, NULL, NULL, NULL, 'ANUCLEATE PRIMARY STERIGMATA PROTEIN B', 244231),
(347055, 'PTHR34491:SF69', NULL, NULL, NULL, NULL, 'DUF4201 DOMAIN-CONTAINING PROTEIN', 244231),
(347056, 'PTHR34491:SF67', NULL, NULL, NULL, NULL, 'YALI0C03916P', 244231),
(347057, 'PTHR34491:SF132', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN', 244231),
(347058, 'PTHR34491:SF133', NULL, NULL, NULL, NULL, '', 244231),
(347059, 'PTHR34491:SF71', NULL, NULL, NULL, NULL, 'I/LWEQ DOMAIN-CONTAINING PROTEIN', 244231),
(347060, 'PTHR34491:SF72', NULL, NULL, NULL, NULL, 'GAR DOMAIN-CONTAINING PROTEIN', 244231),
(347061, 'PTHR34491:SF70', NULL, NULL, NULL, NULL, '', 244231),
(347062, 'PTHR34491:SF75', NULL, NULL, NULL, NULL, 'A-TYPE INCLUSION PROTEIN, PUTATIVE-RELATED', 244231),
(347063, 'PTHR34491:SF76', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN', 244231),
(347064, 'PTHR34491:SF73', NULL, NULL, NULL, NULL, '', 244231),
(347065, 'PTHR34491:SF74', NULL, NULL, NULL, NULL, 'MAML-1 DOMAIN-CONTAINING PROTEIN', 244231),
(347066, 'PTHR34491:SF107', NULL, NULL, NULL, NULL, 'COILED-COIL PROTEIN', 244231),
(347067, 'PTHR34491:SF79', NULL, NULL, NULL, NULL, '', 244231),
(347068, 'PTHR34491:SF108', NULL, NULL, NULL, NULL, 'PFTAIRE-INTERACTING FACTOR 1A, ISOFORM H', 244231),
(347069, 'PTHR34491:SF109', NULL, NULL, NULL, NULL, 'FYVE DOMAIN-CONTAINING PROTEIN', 244231);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(347070, 'PTHR34491:SF77', NULL, NULL, NULL, NULL, 'CHROMOSOME 21, WHOLE GENOME SHOTGUN SEQUENCE', 244231),
(347071, 'PTHR34491:SF78', NULL, NULL, NULL, NULL, '', 244231),
(347072, 'PTHR34491:SF38', NULL, NULL, NULL, NULL, 'COMBOVER, ISOFORM A', 244231),
(347073, 'PTHR34491:SF100', NULL, NULL, NULL, NULL, 'A-TYPE INCLUSION PROTEIN, PUTATIVE-RELATED', 244231),
(347074, 'PTHR34491:SF101', NULL, NULL, NULL, NULL, 'A-TYPE INCLUSION PROTEIN, PUTATIVE-RELATED', 244231),
(347075, 'PTHR34491:SF102', NULL, NULL, NULL, NULL, 'PROTEIN NNF2', 244231),
(347076, 'PTHR34491:SF103', NULL, NULL, NULL, NULL, 'FYVE-TYPE DOMAIN-CONTAINING PROTEIN', 244231),
(347077, 'PTHR34491:SF104', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 244231),
(347078, 'PTHR34491:SF105', NULL, NULL, NULL, NULL, 'FLAGELLUM TRANSITION ZONE COMPONENT', 244231),
(347079, 'PTHR34491:SF106', NULL, NULL, NULL, NULL, 'PPG3-RELATED PROTEIN-LIKE PROTEIN', 244231),
(347080, 'PTHR34491:SF120', NULL, NULL, NULL, NULL, 'YALI0D26950P', 244231),
(347081, 'PTHR34491:SF82', NULL, NULL, NULL, NULL, 'AF4/FMR2 FAMILY MEMBER LILLI', 244231),
(347082, 'PTHR34491:SF83', NULL, NULL, NULL, NULL, 'KAP NTPASE DOMAIN-CONTAINING PROTEIN', 244231),
(347083, 'PTHR34491:SF80', NULL, NULL, NULL, NULL, 'TSNAXIP1_N DOMAIN-CONTAINING PROTEIN', 244231),
(347084, 'PTHR34491:SF81', NULL, NULL, NULL, NULL, 'UDS1 DOMAIN-CONTAINING PROTEIN', 244231),
(347085, 'PTHR34491:SF86', NULL, NULL, NULL, NULL, 'DEATH DOMAIN-CONTAINING PROTEIN', 244231),
(347086, 'PTHR34491:SF87', NULL, NULL, NULL, NULL, 'UVRB/UVRC MOTIF FAMILY PROTEIN', 244231),
(347087, 'PTHR34491:SF84', NULL, NULL, NULL, NULL, 'CALMODULIN-REGULATED SPECTRIN-ASSOCIATED PROTEIN 1-RELATED', 244231),
(347088, 'PTHR34491:SF85', NULL, NULL, NULL, NULL, 'NON-CENTROSOMAL MICROTUBULE ARRAY PROTEIN 1', 244231),
(347089, 'PTHR34491:SF118', NULL, NULL, NULL, NULL, 'SNAD', 244231),
(347090, 'PTHR34491:SF119', NULL, NULL, NULL, NULL, 'ALPHA-TYPE PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244231),
(347091, 'PTHR34491:SF88', NULL, NULL, NULL, NULL, 'MYELIN TRANSCRIPTION FACTOR 1', 244231),
(347092, 'PTHR34491:SF89', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 244231),
(347093, 'PTHR34491:SF45', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 244231),
(347094, 'PTHR34491:SF48', NULL, NULL, NULL, NULL, 'HOLOCENTRIC CHROMOSOME BINDING PROTEIN', 244231),
(347095, 'PTHR34491:SF110', NULL, NULL, NULL, NULL, '', 244231),
(347096, 'PTHR34491:SF111', NULL, NULL, NULL, NULL, 'CHROMO DOMAIN-CONTAINING PROTEIN', 244231),
(347097, 'PTHR34491:SF112', NULL, NULL, NULL, NULL, '', 244231),
(347098, 'PTHR34491:SF113', NULL, NULL, NULL, NULL, '', 244231),
(347099, 'PTHR34491:SF114', NULL, NULL, NULL, NULL, '', 244231),
(347100, 'PTHR34491:SF115', NULL, NULL, NULL, NULL, 'CALCIUM RELEASE ACTIVATED CHANNEL REGULATOR 2B', 244231),
(347101, 'PTHR34491:SF116', NULL, NULL, NULL, NULL, '', 244231),
(347102, 'PTHR34491:SF117', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR COACTIVATOR 6, ISOFORM F', 244231),
(347103, 'PTHR21388:SF5', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 38', 244232),
(347104, 'PTHR21388:SF6', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 39', 244232),
(347105, 'PTHR21388:SF4', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 10-RELATED', 244232),
(347106, 'PTHR21388:SF9', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 1', 244232),
(347107, 'PTHR21388:SF7', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 40', 244232),
(347108, 'PTHR21388', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN-RELATED', 244232),
(347109, 'PTHR21388:SF12', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 37', 244232),
(347110, 'PTHR31095:SF3', NULL, NULL, NULL, NULL, 'RIKEN CDNA 9930021J03 GENE', 244233),
(347111, 'PTHR31095', NULL, NULL, NULL, NULL, 'RIKEN CDNA 9930021J03 GENE', 244233),
(347112, 'PTHR47867', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN', 244234),
(347113, 'PTHR47867:SF2', NULL, NULL, NULL, NULL, 'BNAA05G35570D PROTEIN', 244234),
(347114, 'PTHR47867:SF1', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN', 244234);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(347115, 'PTHR47867:SF3', NULL, NULL, NULL, NULL, 'BNAA08G05100D PROTEIN', 244234),
(347116, 'PTHR10015:SF294', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-7A-LIKE', 244235),
(347117, 'PTHR10015:SF173', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR C-1B', 244235),
(347118, 'PTHR10015:SF292', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-4C-LIKE', 244235),
(347119, 'PTHR10015:SF213', NULL, NULL, NULL, NULL, 'HEAT SHOCK FACTOR PROTEIN 4', 244235),
(347120, 'PTHR10015:SF334', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-6B', 244235),
(347121, 'PTHR10015:SF333', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR B-2A', 244235),
(347122, 'PTHR10015:SF332', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR C-1', 244235),
(347123, 'PTHR10015:SF298', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-9', 244235),
(347124, 'PTHR10015:SF452', NULL, NULL, NULL, NULL, 'HSF_DOMAIN DOMAIN-CONTAINING PROTEIN', 244235),
(347125, 'PTHR10015:SF331', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR C-2B', 244235),
(347126, 'PTHR10015:SF451', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-6B-LIKE ISOFORM X1', 244235),
(347127, 'PTHR10015:SF297', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-2D', 244235),
(347128, 'PTHR10015:SF450', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-2E', 244235),
(347129, 'PTHR10015:SF296', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-6A', 244235),
(347130, 'PTHR10015:SF295', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR B-3-LIKE', 244235),
(347131, 'PTHR10015:SF338', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-2', 244235),
(347132, 'PTHR10015:SF337', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-3', 244235),
(347133, 'PTHR10015:SF336', NULL, NULL, NULL, NULL, 'HEAT SHOCK TRANSCRIPTION FACTOR, Y-LINKED', 244235),
(347134, 'PTHR10015:SF161', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-4A', 244235),
(347135, 'PTHR10015:SF282', NULL, NULL, NULL, NULL, 'HEAT SHOCK TRANSCRIPTION FACTOR, X-LINKED', 244235),
(347136, 'PTHR10015:SF324', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-1E', 244235),
(347137, 'PTHR10015:SF445', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-4B-LIKE', 244235),
(347138, 'PTHR10015:SF444', NULL, NULL, NULL, NULL, 'HEAT SHOCK TRANSCRIPTION FACTOR A3', 244235),
(347139, 'PTHR10015:SF169', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR B-2B', 244235),
(347140, 'PTHR10015:SF443', NULL, NULL, NULL, NULL, 'HSF_DOMAIN DOMAIN-CONTAINING PROTEIN', 244235),
(347141, 'PTHR10015:SF322', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-7A', 244235),
(347142, 'PTHR10015:SF442', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-1', 244235),
(347143, 'PTHR10015:SF441', NULL, NULL, NULL, NULL, 'HSF_DOMAIN DOMAIN-CONTAINING PROTEIN', 244235),
(347144, 'PTHR10015:SF440', NULL, NULL, NULL, NULL, 'HSF_DOMAIN DOMAIN-CONTAINING PROTEIN', 244235),
(347145, 'PTHR10015:SF285', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR B-3', 244235),
(347146, 'PTHR10015:SF329', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR B-1', 244235),
(347147, 'PTHR10015:SF328', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR C-2A', 244235),
(347148, 'PTHR10015:SF449', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-7B', 244235),
(347149, 'PTHR10015:SF448', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-7A-LIKE', 244235),
(347150, 'PTHR10015:SF206', NULL, NULL, NULL, NULL, 'HSF_DOMAIN DOMAIN-CONTAINING PROTEIN', 244235),
(347151, 'PTHR10015:SF447', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-1A', 244235),
(347152, 'PTHR10015:SF446', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SFL2', 244235),
(347153, 'PTHR10015:SF325', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-8', 244235),
(347154, 'PTHR10015', NULL, NULL, NULL, NULL, 'HEAT SHOCK TRANSCRIPTION FACTOR', 244235),
(347155, 'PTHR10015:SF391', NULL, NULL, NULL, NULL, 'HSF_DOMAIN DOMAIN-CONTAINING PROTEIN', 244235);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(347156, 'PTHR10015:SF390', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-4D', 244235),
(347157, 'PTHR10015:SF434', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-4B-RELATED', 244235),
(347158, 'PTHR10015:SF433', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-6A-RELATED', 244235),
(347159, 'PTHR10015:SF279', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-2A', 244235),
(347160, 'PTHR10015:SF432', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-4B-LIKE', 244235),
(347161, 'PTHR10015:SF278', NULL, NULL, NULL, NULL, 'HEAT SHOCK FACTOR PROTEIN 5', 244235),
(347162, 'PTHR10015:SF431', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR B-2B', 244235),
(347163, 'PTHR10015:SF397', NULL, NULL, NULL, NULL, 'HEAT SHOCK TRANSCRIPTION FACTOR A4A-RELATED', 244235),
(347164, 'PTHR10015:SF430', NULL, NULL, NULL, NULL, 'HSF_DOMAIN DOMAIN-CONTAINING PROTEIN', 244235),
(347165, 'PTHR10015:SF396', NULL, NULL, NULL, NULL, 'FLOCCULATION SUPPRESSION PROTEIN', 244235),
(347166, 'PTHR10015:SF274', NULL, NULL, NULL, NULL, 'HEAT SHOCK FACTOR PROTEIN 1', 244235),
(347167, 'PTHR10015:SF273', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR B-2A', 244235),
(347168, 'PTHR10015:SF439', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR B-1', 244235),
(347169, 'PTHR10015:SF438', NULL, NULL, NULL, NULL, 'HEAT SHOCK TRANSCRIPTION FACTOR A4A', 244235),
(347170, 'PTHR10015:SF437', NULL, NULL, NULL, NULL, 'HEAT SHOCK TRANSCRIPTION FACTOR', 244235),
(347171, 'PTHR10015:SF436', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-1B', 244235),
(347172, 'PTHR10015:SF435', NULL, NULL, NULL, NULL, 'HSF_DOMAIN DOMAIN-CONTAINING PROTEIN', 244235),
(347173, 'PTHR10015:SF382', NULL, NULL, NULL, NULL, 'HSF_DOMAIN DOMAIN-CONTAINING PROTEIN', 244235),
(347174, 'PTHR10015:SF140', NULL, NULL, NULL, NULL, 'HEAT SHOCK TRANSCRIPTION FACTOR, X-LINKED MEMBER 3-RELATED', 244235),
(347175, 'PTHR10015:SF380', NULL, NULL, NULL, NULL, 'WINGED HELIX-TURN-HELIX DNA-BINDING DOMAIN, HEAT SHOCK TRANSCRIPTION FACTOR FAMILY-RELATED', 244235),
(347176, 'PTHR10015:SF148', NULL, NULL, NULL, NULL, 'HEAT SHOCK FACTOR PROTEIN 3', 244235),
(347177, 'PTHR10015:SF387', NULL, NULL, NULL, NULL, 'HSF_DOMAIN DOMAIN-CONTAINING PROTEIN', 244235),
(347178, 'PTHR10015:SF384', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN-RELATED', 244235),
(347179, 'PTHR10015:SF309', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR B-4D', 244235),
(347180, 'PTHR10015:SF308', NULL, NULL, NULL, NULL, 'HSF_DOMAIN DOMAIN-CONTAINING PROTEIN', 244235),
(347181, 'PTHR10015:SF429', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-6B-LIKE', 244235),
(347182, 'PTHR10015:SF428', NULL, NULL, NULL, NULL, 'HEAT SHOCK FACTOR PROTEIN HSF8-RELATED', 244235),
(347183, 'PTHR10015:SF427', NULL, NULL, NULL, NULL, 'HEAT SHOCK FACTOR PROTEIN', 244235),
(347184, 'PTHR10015:SF426', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-4B', 244235),
(347185, 'PTHR10015:SF304', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR B-4B', 244235),
(347186, 'PTHR10015:SF425', NULL, NULL, NULL, NULL, 'BNAA03G49000D PROTEIN', 244235),
(347187, 'PTHR10015:SF371', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-4B-LIKE', 244235),
(347188, 'PTHR10015:SF370', NULL, NULL, NULL, NULL, 'WINGED HELIX-TURN-HELIX DNA-BINDING DOMAIN, HEAT SHOCK TRANSCRIPTION FACTOR FAMILY-RELATED', 244235),
(347189, 'PTHR10015:SF411', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR B-4A-RELATED', 244235),
(347190, 'PTHR10015:SF378', NULL, NULL, NULL, NULL, 'HSF_DOMAIN DOMAIN-CONTAINING PROTEIN', 244235),
(347191, 'PTHR10015:SF377', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-5', 244235),
(347192, 'PTHR10015:SF376', NULL, NULL, NULL, NULL, 'HEAT SHOCK TRANSCRIPTION FACTOR A7A-RELATED', 244235),
(347193, 'PTHR10015:SF375', NULL, NULL, NULL, NULL, 'WINGED HELIX-TURN-HELIX DNA-BINDING DOMAIN, HEAT SHOCK TRANSCRIPTION FACTOR FAMILY-RELATED', 244235),
(347194, 'PTHR10015:SF374', NULL, NULL, NULL, NULL, 'HSF_DOMAIN DOMAIN-CONTAINING PROTEIN', 244235);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(347195, 'PTHR10015:SF373', NULL, NULL, NULL, NULL, 'HSF_DOMAIN DOMAIN-CONTAINING PROTEIN', 244235),
(347196, 'PTHR10015:SF372', NULL, NULL, NULL, NULL, 'HSF_DOMAIN DOMAIN-CONTAINING PROTEIN', 244235),
(347197, 'PTHR10015:SF419', NULL, NULL, NULL, NULL, 'HSF_DOMAIN DOMAIN-CONTAINING PROTEIN', 244235),
(347198, 'PTHR10015:SF418', NULL, NULL, NULL, NULL, 'HSF_DOMAIN DOMAIN-CONTAINING PROTEIN', 244235),
(347199, 'PTHR10015:SF415', NULL, NULL, NULL, NULL, 'E2F/DP FAMILY WINGED-HELIX DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 244235),
(347200, 'PTHR10015:SF360', NULL, NULL, NULL, NULL, 'HSF_DOMAIN DOMAIN-CONTAINING PROTEIN', 244235),
(347201, 'PTHR10015:SF401', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-1-LIKE', 244235),
(347202, 'PTHR10015:SF368', NULL, NULL, NULL, NULL, 'HSF_DOMAIN DOMAIN-CONTAINING PROTEIN', 244235),
(347203, 'PTHR10015:SF400', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR B-4', 244235),
(347204, 'PTHR10015:SF365', NULL, NULL, NULL, NULL, 'HSF_DOMAIN DOMAIN-CONTAINING PROTEIN', 244235),
(347205, 'PTHR10015:SF364', NULL, NULL, NULL, NULL, 'HSF_DOMAIN DOMAIN-CONTAINING PROTEIN', 244235),
(347206, 'PTHR10015:SF363', NULL, NULL, NULL, NULL, 'HSF_DOMAIN DOMAIN-CONTAINING PROTEIN', 244235),
(347207, 'PTHR10015:SF361', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SKN7', 244235),
(347208, 'PTHR10015:SF409', NULL, NULL, NULL, NULL, 'PROTEIN MGA1', 244235),
(347209, 'PTHR10015:SF408', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-4C', 244235),
(347210, 'PTHR10015:SF407', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-9', 244235),
(347211, 'PTHR10015:SF369', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR B-1-RELATED', 244235),
(347212, 'PTHR10015:SF402', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-2B', 244235),
(347213, 'PTHR10015:SF195', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-6A', 244235),
(347214, 'PTHR10015:SF357', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-9-LIKE', 244235),
(347215, 'PTHR10015:SF356', NULL, NULL, NULL, NULL, 'HSF_DOMAIN DOMAIN-CONTAINING PROTEIN', 244235),
(347216, 'PTHR10015:SF355', NULL, NULL, NULL, NULL, 'WINGED HELIX-TURN-HELIX DNA-BINDING DOMAIN, HEAT SHOCK TRANSCRIPTION FACTOR FAMILY-RELATED', 244235),
(347217, 'PTHR10015:SF350', NULL, NULL, NULL, NULL, 'HSF_DOMAIN DOMAIN-CONTAINING PROTEIN', 244235),
(347218, 'PTHR10015:SF358', NULL, NULL, NULL, NULL, 'HSF_DOMAIN DOMAIN-CONTAINING PROTEIN', 244235),
(347219, 'PTHR10015:SF344', NULL, NULL, NULL, NULL, 'HSF_DOMAIN DOMAIN-CONTAINING PROTEIN', 244235),
(347220, 'PTHR10015:SF343', NULL, NULL, NULL, NULL, 'HSF_DOMAIN DOMAIN-CONTAINING PROTEIN', 244235),
(347221, 'PTHR10015:SF340', NULL, NULL, NULL, NULL, 'HEAT STRESS TRANSCRIPTION FACTOR A-6A-LIKE', 244235),
(347222, 'PTHR10015:SF185', NULL, NULL, NULL, NULL, 'HEAT SHOCK FACTOR PROTEIN 2', 244235),
(347223, 'PTHR10015:SF348', NULL, NULL, NULL, NULL, 'HSF_DOMAIN DOMAIN-CONTAINING PROTEIN', 244235),
(347224, 'PTHR28342', NULL, NULL, NULL, NULL, 'MONOOXYGENASE P33MONOX-RELATED', 244236),
(347225, 'PTHR28342:SF2', NULL, NULL, NULL, NULL, 'MONOOXYGENASE P33MONOX-RELATED', 244236),
(347226, 'PTHR28342:SF3', NULL, NULL, NULL, NULL, 'MONOOXYGENASE P33MONOX-RELATED', 244236),
(347227, 'PTHR28342:SF1', NULL, NULL, NULL, NULL, 'MONOOXYGENASE P33MONOX-RELATED', 244236),
(347228, 'PTHR45870:SF2', NULL, NULL, NULL, NULL, 'TUBULIN MONOGLYCYLASE TTLL3', 244237),
(347229, 'PTHR45870:SF1', NULL, NULL, NULL, NULL, 'TUBULIN MONOGLYCYLASE TTLL3', 244237),
(347230, 'PTHR45870:SF3', NULL, NULL, NULL, NULL, 'PROTEIN MONOGLYCYLASE TTLL8', 244237),
(347231, 'PTHR45870', NULL, NULL, NULL, NULL, 'TUBULIN MONOGLYCYLASE TTLL3', 244237),
(347232, 'PTHR43975', NULL, NULL, NULL, NULL, 'ZGC:101858', 244238),
(347233, 'PTHR43975:SF2', NULL, NULL, NULL, NULL, 'ZGC:101858', 244238),
(347234, 'PTHR43975:SF4', NULL, NULL, NULL, NULL, '', 244238),
(347235, 'PTHR43975:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG14933', 244238),
(347236, 'PTHR13244:SF7', NULL, NULL, NULL, NULL, 'ZINC FINGER MYND DOMAIN-CONTAINING PROTEIN 10', 244239);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(347237, 'PTHR13244', NULL, NULL, NULL, NULL, 'ZINC FINGER MYND DOMAIN CONTAINING PROTEIN 10', 244239),
(347238, 'PTHR46960:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE KEG', 244240),
(347239, 'PTHR46960', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE KEG', 244240),
(347240, 'PTHR46960:SF3', NULL, NULL, NULL, NULL, 'OS05G0392050 PROTEIN', 244240),
(347241, 'PTHR46960:SF2', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 244240),
(347242, 'PTHR46232:SF1', NULL, NULL, NULL, NULL, 'SWI/SNF-RELATED MATRIX-ASSOCIATED ACTIN-DEPENDENT REGULATOR OF CHROMATIN SUBFAMILY E MEMBER 1', 244241),
(347243, 'PTHR46232:SF3', NULL, NULL, NULL, NULL, 'HMG BOX DOMAIN-CONTAINING PROTEIN', 244241),
(347244, 'PTHR46232:SF2', NULL, NULL, NULL, NULL, 'SWI/SNF-RELATED MATRIX-ASSOCIATED ACTIN-DEPENDENT REGULATOR OF CHROMATIN SUBFAMILY E MEMBER 1', 244241),
(347245, 'PTHR46232', NULL, NULL, NULL, NULL, 'SMARCE1 REGULATOR OF CHROMATIN', 244241),
(347246, 'PTHR46232:SF5', NULL, NULL, NULL, NULL, '', 244241),
(347247, 'PTHR46232:SF4', NULL, NULL, NULL, NULL, 'HMG BOX DOMAIN-CONTAINING PROTEIN', 244241),
(347248, 'PTHR31506:SF39', NULL, NULL, NULL, NULL, 'PROTEIN BRASSINAZOLE-RESISTANT 1', 244242),
(347249, 'PTHR31506:SF18', NULL, NULL, NULL, NULL, 'PROTEIN BRASSINAZOLE-RESISTANT 1', 244242),
(347250, 'PTHR31506:SF37', NULL, NULL, NULL, NULL, 'BES1_N DOMAIN-CONTAINING PROTEIN', 244242),
(347251, 'PTHR31506:SF15', NULL, NULL, NULL, NULL, 'BES1/BZR1 HOMOLOG PROTEIN 1', 244242),
(347252, 'PTHR31506:SF35', NULL, NULL, NULL, NULL, 'BES1_N DOMAIN-CONTAINING PROTEIN', 244242),
(347253, 'PTHR31506', NULL, NULL, NULL, NULL, 'BES1/BZR1 HOMOLOG PROTEIN 3-RELATED', 244242),
(347254, 'PTHR31506:SF22', NULL, NULL, NULL, NULL, 'PROTEIN BRASSINAZOLE-RESISTANT 2', 244242),
(347255, 'PTHR31506:SF44', NULL, NULL, NULL, NULL, 'OS01G0176900 PROTEIN', 244242),
(347256, 'PTHR31506:SF45', NULL, NULL, NULL, NULL, 'BES1/BZR1 HOMOLOG PROTEIN 3', 244242),
(347257, 'PTHR31506:SF42', NULL, NULL, NULL, NULL, 'BES1_N DOMAIN-CONTAINING PROTEIN', 244242),
(347258, 'PTHR31506:SF21', NULL, NULL, NULL, NULL, 'BES1_N DOMAIN-CONTAINING PROTEIN', 244242),
(347259, 'PTHR31506:SF43', NULL, NULL, NULL, NULL, 'BES1/BZR1 HOMOLOG PROTEIN 4-LIKE', 244242),
(347260, 'PTHR31506:SF4', NULL, NULL, NULL, NULL, 'BES1_N DOMAIN-CONTAINING PROTEIN', 244242),
(347261, 'PTHR31506:SF28', NULL, NULL, NULL, NULL, 'BZR1-LIKE PROTEIN-RELATED', 244242),
(347262, 'PTHR31506:SF29', NULL, NULL, NULL, NULL, 'BES1/BZR1-LIKE PROTEIN-RELATED', 244242),
(347263, 'PTHR31506:SF2', NULL, NULL, NULL, NULL, 'BES1/BZR1 HOMOLOG PROTEIN 4', 244242),
(347264, 'PTHR31506:SF48', NULL, NULL, NULL, NULL, 'PROTEIN BZR1 HOMOLOG 4', 244242),
(347265, 'PTHR31506:SF26', NULL, NULL, NULL, NULL, 'BES1/BZR1 PLANT TRANSCRIPTION FACTOR-RELATED', 244242),
(347266, 'PTHR31506:SF27', NULL, NULL, NULL, NULL, 'BES1_N DOMAIN-CONTAINING PROTEIN', 244242),
(347267, 'PTHR31506:SF46', NULL, NULL, NULL, NULL, 'BES1_N DOMAIN-CONTAINING PROTEIN', 244242),
(347268, 'PTHR31506:SF24', NULL, NULL, NULL, NULL, 'PROTEIN BRASSINAZOLE-RESISTANT 1-LIKE', 244242),
(347269, 'PTHR31506:SF47', NULL, NULL, NULL, NULL, 'BES1/BZR1 HOMOLOG PROTEIN 2', 244242),
(347270, 'PTHR31506:SF34', NULL, NULL, NULL, NULL, 'BZR1-LIKE PROTEIN-RELATED', 244242),
(347271, 'PTHR31506:SF31', NULL, NULL, NULL, NULL, 'BES1/BZR1 PLANT TRANSCRIPTION FACTOR-RELATED', 244242),
(347272, 'PTHR31506:SF32', NULL, NULL, NULL, NULL, 'BES1/BZR1 HOMOLOG PROTEIN 4-LIKE', 244242),
(347273, 'PTHR31506:SF30', NULL, NULL, NULL, NULL, 'PROTEIN BZR1 HOMOLOG 2', 244242),
(347274, 'PTHR11501:SF16', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN 4', 244243),
(347275, 'PTHR11501:SF15', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN 2', 244243),
(347276, 'PTHR11501:SF14', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN TAU', 244243),
(347277, 'PTHR11501', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN', 244243),
(347278, 'PTHR11501:SF18', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN', 244243),
(347279, 'PTHR11501:SF20', NULL, NULL, NULL, NULL, '', 244243);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(347280, 'PTHR23100', NULL, NULL, NULL, NULL, 'ARGININE BIOSYNTHESIS BIFUNCTIONAL PROTEIN ARGJ', 244244),
(347281, 'PTHR23100:SF0', NULL, NULL, NULL, NULL, 'ARGININE BIOSYNTHESIS BIFUNCTIONAL PROTEIN ARGJ, MITOCHONDRIAL', 244244),
(347282, 'PTHR43383:SF2', NULL, NULL, NULL, NULL, 'AMIDOHYDRO-REL DOMAIN-CONTAINING PROTEIN', 244245),
(347283, 'PTHR43383', NULL, NULL, NULL, NULL, 'NODULIN 6', 244245),
(347284, 'PTHR10983:SF67', NULL, NULL, NULL, NULL, '1-ACYLGLYCEROL-3-PHOSPHATE O-ACYLTRANSFERASE', 244246),
(347285, 'PTHR10983:SF66', NULL, NULL, NULL, NULL, '1-ACYLGLYCEROL-3-PHOSPHATE O-ACYLTRANSFERASE', 244246),
(347286, 'PTHR10983:SF64', NULL, NULL, NULL, NULL, '1-ACYLGLYCEROL-3-PHOSPHATE O-ACYLTRANSFERASE', 244246),
(347287, 'PTHR10983:SF20', NULL, NULL, NULL, NULL, 'LYSOPHOSPHATIDYLINOSITOL ACYLTRANSFERASE 10', 244246),
(347288, 'PTHR10983:SF63', NULL, NULL, NULL, NULL, '1-ACYLGLYCEROL-3-PHOSPHATE O-ACYLTRANSFERASE', 244246),
(347289, 'PTHR10983:SF60', NULL, NULL, NULL, NULL, '1-ACYLGLYCEROL-3-PHOSPHATE O-ACYLTRANSFERASE', 244246),
(347290, 'PTHR10983:SF28', NULL, NULL, NULL, NULL, '1-ACYLGLYCEROL-3-PHOSPHATE O-ACYLTRANSFERASE', 244246),
(347291, 'PTHR10983:SF69', NULL, NULL, NULL, NULL, 'PLSC DOMAIN-CONTAINING PROTEIN', 244246),
(347292, 'PTHR10983:SF2', NULL, NULL, NULL, NULL, 'ACYL-COA:LYSOPHOSPHATIDYLGLYCEROL ACYLTRANSFERASE 1', 244246),
(347293, 'PTHR10983:SF24', NULL, NULL, NULL, NULL, '1-ACYLGLYCEROL-3-PHOSPHATE O-ACYLTRANSFERASE 3, ISOFORM E-RELATED', 244246),
(347294, 'PTHR10983:SF9', NULL, NULL, NULL, NULL, '1-ACYL-SN-GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE GAMMA', 244246),
(347295, 'PTHR10983:SF8', NULL, NULL, NULL, NULL, '1-ACYL-SN-GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE DELTA', 244246),
(347296, 'PTHR10983:SF70', NULL, NULL, NULL, NULL, 'PROTEIN MUM3', 244246),
(347297, 'PTHR10983', NULL, NULL, NULL, NULL, '1-ACYLGLYCEROL-3-PHOSPHATE ACYLTRANSFERASE-RELATED', 244246),
(347298, 'PTHR10983:SF56', NULL, NULL, NULL, NULL, '1-ACYLGLYCEROL-3-PHOSPHATE O-ACYLTRANSFERASE', 244246),
(347299, 'PTHR10983:SF55', NULL, NULL, NULL, NULL, '1-ACYL-SN-GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE 3', 244246),
(347300, 'PTHR10983:SF75', NULL, NULL, NULL, NULL, '1-ACYL-SN-GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE PLS1', 244246),
(347301, 'PTHR10983:SF74', NULL, NULL, NULL, NULL, '1-ACYL-SN-GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE 5-RELATED', 244246),
(347302, 'PTHR10983:SF73', NULL, NULL, NULL, NULL, '1-ACYL-SN-GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE EPSILON', 244246),
(347303, 'PTHR10983:SF51', NULL, NULL, NULL, NULL, '1-ACYLGLYCEROL-3-PHOSPHATE O-ACYLTRANSFERASE', 244246),
(347304, 'PTHR10983:SF72', NULL, NULL, NULL, NULL, '1-ACYLGLYCEROL-3-PHOSPHATE O-ACYLTRANSFERASE', 244246),
(347305, 'PTHR10983:SF71', NULL, NULL, NULL, NULL, 'PLSC DOMAIN-CONTAINING PROTEIN', 244246),
(347306, 'PTHR10983:SF19', NULL, NULL, NULL, NULL, 'PLSC DOMAIN-CONTAINING PROTEIN', 244246),
(347307, 'PTHR10983:SF16', NULL, NULL, NULL, NULL, 'LYSOCARDIOLIPIN ACYLTRANSFERASE 1', 244246),
(347308, 'PTHR10983:SF15', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE YIHG-RELATED', 244246),
(347309, 'PTHR10983:SF14', NULL, NULL, NULL, NULL, '1-ACYL-SN-GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE ACL-12-RELATED', 244246),
(347310, 'PTHR10983:SF13', NULL, NULL, NULL, NULL, 'PLSC DOMAIN-CONTAINING PROTEIN', 244246),
(347311, 'PTHR31168:SF30', NULL, NULL, NULL, NULL, '', 244247),
(347312, 'PTHR31168:SF1', NULL, NULL, NULL, NULL, 'OS02G0292800 PROTEIN', 244247),
(347313, 'PTHR31168:SF21', NULL, NULL, NULL, NULL, 'EMB|CAB89385.1', 244247),
(347314, 'PTHR31168:SF32', NULL, NULL, NULL, NULL, '', 244247),
(347315, 'PTHR31168:SF20', NULL, NULL, NULL, NULL, '', 244247),
(347316, 'PTHR31168:SF34', NULL, NULL, NULL, NULL, '', 244247),
(347317, 'PTHR31168:SF23', NULL, NULL, NULL, NULL, '', 244247),
(347318, 'PTHR31168:SF22', NULL, NULL, NULL, NULL, 'OS08G0153900 PROTEIN', 244247),
(347319, 'PTHR31168:SF33', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 244247),
(347320, 'PTHR31168:SF25', NULL, NULL, NULL, NULL, '', 244247),
(347321, 'PTHR31168:SF27', NULL, NULL, NULL, NULL, 'BNAC05G35140D PROTEIN', 244247);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(347322, 'PTHR31168:SF26', NULL, NULL, NULL, NULL, '', 244247),
(347323, 'PTHR31168:SF17', NULL, NULL, NULL, NULL, 'OS09G0327000 PROTEIN', 244247),
(347324, 'PTHR31168', NULL, NULL, NULL, NULL, 'OS02G0292800 PROTEIN', 244247),
(347325, 'PTHR31168:SF19', NULL, NULL, NULL, NULL, 'OS01G0683700 PROTEIN', 244247),
(347326, 'PTHR24362', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NEK', 244248),
(347327, 'PTHR24362:SF309', NULL, NULL, NULL, NULL, 'DAMAGE RESPONSE PROTEIN KINASE, PUTATIVE-RELATED', 244248),
(347328, 'PTHR43767:SF8', NULL, NULL, NULL, NULL, 'LONG-CHAIN-FATTY-ACID--COA LIGASE', 244249),
(347329, 'PTHR43767:SF9', NULL, NULL, NULL, NULL, 'LONG-CHAIN-FATTY-ACID--COA LIGASE', 244249),
(347330, 'PTHR43767:SF7', NULL, NULL, NULL, NULL, 'MEDIUM/LONG-CHAIN-FATTY-ACID--COA LIGASE FADD8', 244249),
(347331, 'PTHR43767', NULL, NULL, NULL, NULL, 'LONG-CHAIN-FATTY-ACID--COA LIGASE', 244249),
(347332, 'PTHR43767:SF10', NULL, NULL, NULL, NULL, 'SURFACTIN SYNTHASE SUBUNIT 1', 244249),
(347333, 'PTHR43767:SF12', NULL, NULL, NULL, NULL, 'AMP-DEPENDENT SYNTHETASE AND LIGASE', 244249),
(347334, 'PTHR43767:SF3', NULL, NULL, NULL, NULL, 'LONG-CHAIN-FATTY-ACID--COA LIGASE', 244249),
(347335, 'PTHR43767:SF11', NULL, NULL, NULL, NULL, 'MEDIUM-CHAIN-FATTY-ACID--COA LIGASE', 244249),
(347336, 'PTHR43767:SF1', NULL, NULL, NULL, NULL, 'NONRIBOSOMAL PEPTIDE SYNTHASE PES1 (EUROFUNG)-RELATED', 244249),
(347337, 'PTHR46397:SF5', NULL, NULL, NULL, NULL, 'NR LBD DOMAIN-CONTAINING PROTEIN-RELATED', 244250),
(347338, 'PTHR46397:SF4', NULL, NULL, NULL, NULL, 'NR LBD DOMAIN-CONTAINING PROTEIN-RELATED', 244250),
(347339, 'PTHR46397', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY-RELATED', 244250),
(347340, 'PTHR46397:SF3', NULL, NULL, NULL, NULL, 'NR LBD DOMAIN-CONTAINING PROTEIN-RELATED', 244250),
(347341, 'PTHR46397:SF2', NULL, NULL, NULL, NULL, 'DAUER PHEROMONE RESPONSIVE', 244250),
(347342, 'PTHR30249:SF16', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', 244251),
(347343, 'PTHR30249:SF17', NULL, NULL, NULL, NULL, 'HOLIN-LIKE PROTEIN CIDB', 244251),
(347344, 'PTHR30249:SF15', NULL, NULL, NULL, NULL, 'BNAA05G16460D PROTEIN', 244251),
(347345, 'PTHR30249:SF3', NULL, NULL, NULL, NULL, 'MUREIN HYDROLASE EXPORT REGULATOR', 244251),
(347346, 'PTHR30249', NULL, NULL, NULL, NULL, 'PUTATIVE SEROTONIN TRANSPORTER', 244251),
(347347, 'PTHR30249:SF12', NULL, NULL, NULL, NULL, 'PLASTIDAL GLYCOLATE/GLYCERATE TRANSLOCATOR 1 CHLOROPLASTIC', 244251),
(347348, 'PTHR30249:SF13', NULL, NULL, NULL, NULL, 'LRGB-LIKE PROTEIN', 244251),
(347349, 'PTHR30249:SF0', NULL, NULL, NULL, NULL, 'PLASTIDAL GLYCOLATE/GLYCERATE TRANSLOCATOR 1, CHLOROPLASTIC', 244251),
(347350, 'PTHR32204', NULL, NULL, NULL, NULL, 'ATPASE RAVA', 244252),
(347351, 'PTHR32204:SF0', NULL, NULL, NULL, NULL, 'ATPASE RAVA', 244252),
(347352, 'PTHR31387:SF0', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 19', 244253),
(347353, 'PTHR31387:SF1', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 19.1', 244253),
(347354, 'PTHR31387', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 19', 244253),
(347355, 'PTHR12219:SF17', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 93', 244254),
(347356, 'PTHR12219', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE', 244254),
(347357, 'PTHR12219:SF8', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] IRON-SULFUR PROTEIN 4, MITOCHONDRIAL', 244254),
(347358, 'PTHR12219:SF23', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] IRON-SULFUR PROTEIN 4, MITOCHONDRIAL', 244254),
(347359, 'PTHR12219:SF27', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] IRON-SULFUR PROTEIN 4, MITOCHONDRIAL', 244254),
(347360, 'PTHR34883:SF4', NULL, NULL, NULL, NULL, '', 244255),
(347361, 'PTHR34883:SF12', NULL, NULL, NULL, NULL, '', 244255),
(347362, 'PTHR34883:SF17', NULL, NULL, NULL, NULL, '', 244255),
(347363, 'PTHR34883:SF8', NULL, NULL, NULL, NULL, 'EXTRACELLULAR SERINE-RICH PROTEIN (AFU_ORTHOLOGUE AFUA_6G00670)', 244255),
(347364, 'PTHR34883:SF16', NULL, NULL, NULL, NULL, 'RICH PROTEIN, PUTATIVE-RELATED', 244255);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(347365, 'PTHR34883:SF15', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 244255),
(347366, 'PTHR34883:SF19', NULL, NULL, NULL, NULL, '', 244255),
(347367, 'PTHR34883:SF18', NULL, NULL, NULL, NULL, '', 244255),
(347368, 'PTHR34883', NULL, NULL, NULL, NULL, 'SERINE-RICH PROTEIN, PUTATIVE-RELATED-RELATED', 244255),
(347369, 'PTHR15952', NULL, NULL, NULL, NULL, 'EXPORTIN-T/LOS1', 244256),
(347370, 'PTHR15952:SF12', NULL, NULL, NULL, NULL, 'EXPORTIN-T', 244256),
(347371, 'PTHR15952:SF13', NULL, NULL, NULL, NULL, 'EXPORTIN-T', 244256),
(347372, 'PTHR15952:SF11', NULL, NULL, NULL, NULL, 'EXPORTIN-T', 244256),
(347373, 'PTHR14052', NULL, NULL, NULL, NULL, 'ORIGIN RECOGNITION COMPLEX SUBUNIT 2', 244257),
(347374, 'PTHR14052:SF0', NULL, NULL, NULL, NULL, 'ORIGIN RECOGNITION COMPLEX SUBUNIT 2', 244257),
(347375, 'PTHR11226:SF9', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE GLYCOPROTEIN GLUCOSYLTRANSFERASE', 244258),
(347376, 'PTHR11226', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE GLYCOPROTEIN:GLUCOSYLTRANSFERASE', 244258),
(347377, 'PTHR11226:SF3', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE:GLYCOPROTEIN GLUCOSYLTRANSFERASE 1', 244258),
(347378, 'PTHR11226:SF1', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE:GLYCOPROTEIN GLUCOSYLTRANSFERASE 2', 244258),
(347379, 'PTHR11226:SF0', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE:GLYCOPROTEIN GLUCOSYLTRANSFERASE', 244258),
(347380, 'PTHR30354:SF20', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY GLUCONATE TRANSPORTER', 244259),
(347381, 'PTHR30354:SF23', NULL, NULL, NULL, NULL, 'GNTP FAMILY PERMEASE', 244259),
(347382, 'PTHR30354:SF22', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY GLUCONATE TRANSPORTER', 244259),
(347383, 'PTHR30354:SF11', NULL, NULL, NULL, NULL, 'PERMEASE-RELATED', 244259),
(347384, 'PTHR30354:SF8', NULL, NULL, NULL, NULL, 'LOW-AFFINITY GLUCONATE TRANSPORTER', 244259),
(347385, 'PTHR30354:SF9', NULL, NULL, NULL, NULL, 'GNT-II SYSTEM L-IDONATE TRANSPORTER', 244259),
(347386, 'PTHR30354:SF6', NULL, NULL, NULL, NULL, 'D-SERINE TRANSPORTER DSDX', 244259),
(347387, 'PTHR30354:SF7', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PERMEASE YGBN', 244259),
(347388, 'PTHR30354:SF24', NULL, NULL, NULL, NULL, 'GLUCONATE PERMEASE', 244259),
(347389, 'PTHR30354', NULL, NULL, NULL, NULL, 'GNT FAMILY GLUCONATE TRANSPORTER', 244259),
(347390, 'PTHR37481', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE EXPORT SYSTEM PROTEIN LPTC', 244260),
(347391, 'PTHR37481:SF1', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE EXPORT SYSTEM PROTEIN LPTC', 244260),
(347392, 'PTHR11712:SF339', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE', 244261),
(347393, 'PTHR11712:SF356', NULL, NULL, NULL, NULL, 'BETA-KETOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE I', 244261),
(347394, 'PTHR11712:SF355', NULL, NULL, NULL, NULL, 'BETA-KETOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE I', 244261),
(347395, 'PTHR11712:SF333', NULL, NULL, NULL, NULL, 'BETA-KETOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE I', 244261),
(347396, 'PTHR11712:SF336', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE, MITOCHONDRIAL', 244261),
(347397, 'PTHR11712:SF335', NULL, NULL, NULL, NULL, 'BETA-KETOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE I', 244261),
(347398, 'PTHR11712:SF297', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE, MITOCHONDRIAL', 244261),
(347399, 'PTHR11712:SF330', NULL, NULL, NULL, NULL, 'BETA-KETOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE I', 244261),
(347400, 'PTHR11712:SF352', NULL, NULL, NULL, NULL, 'BETA-KETOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE I', 244261),
(347401, 'PTHR11712:SF351', NULL, NULL, NULL, NULL, 'BETA-KETOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE I', 244261),
(347402, 'PTHR11712:SF354', NULL, NULL, NULL, NULL, 'BETA-KETOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE I', 244261),
(347403, 'PTHR11712:SF332', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE II, CHLOROPLASTIC', 244261),
(347404, 'PTHR11712:SF353', NULL, NULL, NULL, NULL, 'BETA-KETOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE I', 244261),
(347405, 'PTHR11712:SF350', NULL, NULL, NULL, NULL, 'BETA-KETOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE I', 244261);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(347406, 'PTHR11712', NULL, NULL, NULL, NULL, 'POLYKETIDE SYNTHASE-RELATED', 244261),
(347407, 'PTHR11712:SF327', NULL, NULL, NULL, NULL, 'BETA-KETOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE I', 244261),
(347408, 'PTHR11712:SF349', NULL, NULL, NULL, NULL, 'BETA-KETOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE I', 244261),
(347409, 'PTHR11712:SF348', NULL, NULL, NULL, NULL, 'BETA-KETOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE I', 244261),
(347410, 'PTHR11712:SF329', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE', 244261),
(347411, 'PTHR11712:SF306', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE 1', 244261),
(347412, 'PTHR11712:SF328', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE', 244261),
(347413, 'PTHR11712:SF322', NULL, NULL, NULL, NULL, 'POLYKETIDE BETA-KETOACYL SYNTHASE 2-RELATED', 244261),
(347414, 'PTHR11712:SF347', NULL, NULL, NULL, NULL, 'BETA KETOACYL-ACYL CARRIER PROTEIN SYNTHASE', 244261),
(347415, 'PTHR11712:SF325', NULL, NULL, NULL, NULL, '3-OXOACYL-(ACYL-CARRIER-PROTEIN) SYNTHASE II FABF', 244261),
(347416, 'PTHR11712:SF346', NULL, NULL, NULL, NULL, 'BETA-KETOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE I', 244261),
(347417, 'PTHR11712:SF341', NULL, NULL, NULL, NULL, 'BETA-KETOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE I', 244261),
(347418, 'PTHR11712:SF343', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE', 244261),
(347419, 'PTHR11712:SF321', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE 2', 244261),
(347420, 'PTHR11712:SF320', NULL, NULL, NULL, NULL, 'BETA-KETOACYL SYNTHASE', 244261),
(347421, 'PTHR35022:SF20', NULL, NULL, NULL, NULL, 'EXTENSIN DIF54', 244262),
(347422, 'PTHR35022:SF30', NULL, NULL, NULL, NULL, 'EXTENSIN DIF54', 244262),
(347423, 'PTHR35022:SF24', NULL, NULL, NULL, NULL, 'EXTENSIN EXT1', 244262),
(347424, 'PTHR35022:SF8', NULL, NULL, NULL, NULL, 'EXTENSIN EXT1', 244262),
(347425, 'PTHR35022:SF23', NULL, NULL, NULL, NULL, 'EXTENSIN EXT1', 244262),
(347426, 'PTHR35022:SF22', NULL, NULL, NULL, NULL, 'EXTENSIN EXT1', 244262),
(347427, 'PTHR35022:SF21', NULL, NULL, NULL, NULL, 'EXTENSIN EXT1', 244262),
(347428, 'PTHR35022:SF10', NULL, NULL, NULL, NULL, 'EXTENSIN DIF54', 244262),
(347429, 'PTHR35022:SF6', NULL, NULL, NULL, NULL, 'EXTENSIN-LIKE PROTEIN EXT1', 244262),
(347430, 'PTHR35022:SF28', NULL, NULL, NULL, NULL, 'SKIN-SPECIFIC PROTEIN 32', 244262),
(347431, 'PTHR35022:SF27', NULL, NULL, NULL, NULL, 'EXTENSIN EXT1', 244262),
(347432, 'PTHR35022', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 244262),
(347433, 'PTHR35022:SF26', NULL, NULL, NULL, NULL, 'EXTENSIN DIF54', 244262),
(347434, 'PTHR35022:SF25', NULL, NULL, NULL, NULL, '', 244262),
(347435, 'PTHR35022:SF19', NULL, NULL, NULL, NULL, 'EXTENSIN DIF10', 244262),
(347436, 'PTHR35022:SF29', NULL, NULL, NULL, NULL, 'EXTENSIN EXT1', 244262),
(347437, 'PTHR15505', NULL, NULL, NULL, NULL, 'RIIA DOMAIN-CONTAINING PROTEIN 1', 244263),
(347438, 'PTHR15505:SF1', NULL, NULL, NULL, NULL, 'BMP AND ACTIVIN MEMBRANE-BOUND INHIBITOR HOMOLOG', 244263),
(347439, 'PTHR15505:SF4', NULL, NULL, NULL, NULL, 'RIIA DOMAIN-CONTAINING PROTEIN 1', 244263),
(347440, 'PTHR15505:SF3', NULL, NULL, NULL, NULL, 'CILIOGENESIS-ASSOCIATED TTC17-INTERACTING PROTEIN', 244263),
(347441, 'PTHR20859:SF85', NULL, NULL, NULL, NULL, 'INTERLEUKIN 10 RECEPTOR, BETA', 244264),
(347442, 'PTHR20859:SF53', NULL, NULL, NULL, NULL, 'INTERLEUKIN-10 RECEPTOR SUBUNIT ALPHA', 244264),
(347443, 'PTHR20859:SF86', NULL, NULL, NULL, NULL, 'INTERLEUKIN-20 RECEPTOR SUBUNIT ALPHA', 244264),
(347444, 'PTHR20859:SF20', NULL, NULL, NULL, NULL, 'INTERLEUKIN-22 RECEPTOR SUBUNIT ALPHA-1', 244264),
(347445, 'PTHR20859:SF50', NULL, NULL, NULL, NULL, 'INTERLEUKIN-10 RECEPTOR SUBUNIT BETA', 244264),
(347446, 'PTHR20859:SF84', NULL, NULL, NULL, NULL, 'INTERFERON ALPHA/BETA RECEPTOR 2', 244264),
(347447, 'PTHR20859:SF51', NULL, NULL, NULL, NULL, 'INTERLEUKIN-22 RECEPTOR SUBUNIT ALPHA-2', 244264),
(347448, 'PTHR20859:SF46', NULL, NULL, NULL, NULL, 'INTERFERON GAMMA RECEPTOR 2', 244264);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(347449, 'PTHR20859:SF54', NULL, NULL, NULL, NULL, 'INTERFERON ALPHA/BETA RECEPTOR 1', 244264),
(347450, 'PTHR20859:SF87', NULL, NULL, NULL, NULL, 'INTERFERON GAMMA RECEPTOR 1', 244264),
(347451, 'PTHR20859:SF22', NULL, NULL, NULL, NULL, 'TISSUE FACTOR', 244264),
(347452, 'PTHR20859:SF55', NULL, NULL, NULL, NULL, 'INTERFERON LAMBDA RECEPTOR 1', 244264),
(347453, 'PTHR20859:SF82', NULL, NULL, NULL, NULL, 'COAGULATION FACTOR III', 244264),
(347454, 'PTHR20859:SF5', NULL, NULL, NULL, NULL, 'INTERFERON GAMMA RECEPTOR 1', 244264),
(347455, 'PTHR20859:SF49', NULL, NULL, NULL, NULL, 'ACTIVATED CHLORINE CHANNEL, PUTATIVE-RELATED', 244264),
(347456, 'PTHR20859', NULL, NULL, NULL, NULL, 'INTERFERON/INTERLEUKIN RECEPTOR', 244264),
(347457, 'PTHR20859:SF48', NULL, NULL, NULL, NULL, 'INTERLEUKIN-20 RECEPTOR SUBUNIT BETA', 244264),
(347458, 'PTHR13378', NULL, NULL, NULL, NULL, 'REGULATOR COMPLEX PROTEIN LAMTOR3', 244265),
(347459, 'PTHR13378:SF1', NULL, NULL, NULL, NULL, 'RAGULATOR COMPLEX PROTEIN LAMTOR3', 244265),
(347460, 'PTHR13107', NULL, NULL, NULL, NULL, 'N6-ADENOSINE-METHYLTRANSFERASE NON-CATALYTIC SUBUNIT', 244266),
(347461, 'PTHR13107:SF3', NULL, NULL, NULL, NULL, 'MT-A70 FAMILY PROTEIN, EXPRESSED', 244266),
(347462, 'PTHR13107:SF0', NULL, NULL, NULL, NULL, 'N6-ADENOSINE-METHYLTRANSFERASE NON-CATALYTIC SUBUNIT', 244266),
(347463, 'PTHR31405', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PDR8-RELATED', 244267),
(347464, 'PTHR31405:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PDR8-RELATED', 244267),
(347465, 'PTHR35098:SF3', NULL, NULL, NULL, NULL, 'SARCOPLASMIC RETICULUM HISTIDINE-RICH CALCIUM-BINDING PROTEIN-LIKE', 244268),
(347466, 'PTHR35098:SF5', NULL, NULL, NULL, NULL, 'BNAC03G56520D PROTEIN', 244268),
(347467, 'PTHR35098:SF4', NULL, NULL, NULL, NULL, 'BNAA02G36940D PROTEIN', 244268),
(347468, 'PTHR35098', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244268),
(347469, 'PTHR35098:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244268),
(347470, 'PTHR35098:SF10', NULL, NULL, NULL, NULL, 'NODULIN-RELATED PROTEIN 1', 244268),
(347471, 'PTHR35098:SF6', NULL, NULL, NULL, NULL, '', 244268),
(347472, 'PTHR35098:SF8', NULL, NULL, NULL, NULL, 'NODULIN-RELATED PROTEIN 1', 244268),
(347473, 'PTHR13633:SF3', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL TRANSCRIPTION RESCUE FACTOR 1', 244269),
(347474, 'PTHR13633', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244269),
(347475, 'PTHR24211:SF17', NULL, NULL, NULL, NULL, 'ZM DOMAIN-CONTAINING PROTEIN', 244270),
(347476, 'PTHR24211:SF1', NULL, NULL, NULL, NULL, 'TESTIN', 244270),
(347477, 'PTHR24211:SF19', NULL, NULL, NULL, NULL, 'PRICKLE PLANAR CELL POLARITY PROTEIN 3', 244270),
(347478, 'PTHR24211:SF0', NULL, NULL, NULL, NULL, 'LIM AND CYSTEINE-RICH DOMAINS PROTEIN 1', 244270),
(347479, 'PTHR24211:SF18', NULL, NULL, NULL, NULL, 'PRICKLE-LIKE PROTEIN 2', 244270),
(347480, 'PTHR24211:SF35', NULL, NULL, NULL, NULL, '', 244270),
(347481, 'PTHR24211:SF15', NULL, NULL, NULL, NULL, 'PRICKLE-LIKE PROTEIN 1', 244270),
(347482, 'PTHR24211:SF37', NULL, NULL, NULL, NULL, 'PROTEIN ESPINAS-LIKE PROTEIN', 244270),
(347483, 'PTHR24211:SF20', NULL, NULL, NULL, NULL, 'PROTEIN ESPINAS-RELATED', 244270),
(347484, 'PTHR24211:SF22', NULL, NULL, NULL, NULL, 'TESTIN', 244270),
(347485, 'PTHR24211', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING PROTEIN', 244270),
(347486, 'PTHR16788:SF0', NULL, NULL, NULL, NULL, 'EPIDIDYMAL SECRETORY PROTEIN E3-BETA', 244271),
(347487, 'PTHR16788', NULL, NULL, NULL, NULL, 'EPIDIDYMAL SECRETORY PROTEIN E3 ALPHA', 244271),
(347488, 'PTHR16788:SF4', NULL, NULL, NULL, NULL, 'EPIDIDYMAL SECRETORY PROTEIN E3-ALPHA', 244271),
(347489, 'PTHR17008:SF1', NULL, NULL, NULL, NULL, 'MEIOSIS EXPRESSED GENE 1 PROTEIN HOMOLOG', 244272),
(347490, 'PTHR17008', NULL, NULL, NULL, NULL, 'MEIOSIS-EXPRESSED GENE 1 PROTEIN', 244272),
(347491, 'PTHR31324', NULL, NULL, NULL, NULL, 'MORF4 FAMILY-ASSOCIATED PROTEIN 1-RELATED', 244273),
(347492, 'PTHR31324:SF1', NULL, NULL, NULL, NULL, 'MORF4 FAMILY-ASSOCIATED PROTEIN 1', 244273),
(347493, 'PTHR31324:SF3', NULL, NULL, NULL, NULL, 'MORF4 FAMILY-ASSOCIATED PROTEIN 1-LIKE PROTEIN UPP-RELATED', 244273);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(347494, 'PTHR31324:SF2', NULL, NULL, NULL, NULL, 'MORF4 FAMILY-ASSOCIATED PROTEIN 1-LIKE 1', 244273),
(347495, 'PTHR15289:SF3', NULL, NULL, NULL, NULL, 'TASTIN', 244274),
(347496, 'PTHR15289', NULL, NULL, NULL, NULL, 'TASTIN', 244274),
(347497, 'PTHR16007:SF21', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 45A', 244275),
(347498, 'PTHR16007:SF15', NULL, NULL, NULL, NULL, 'PROTEIN 45B, PUTATIVE-RELATED', 244275),
(347499, 'PTHR16007:SF59', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 45B', 244275),
(347500, 'PTHR16007', NULL, NULL, NULL, NULL, 'EPIDIDYMAL MEMBRANE PROTEIN E9-RELATED', 244275),
(347501, 'PTHR16007:SF42', NULL, NULL, NULL, NULL, '2310005G13RIK PROTEIN', 244275),
(347502, 'PTHR36863:SF1', NULL, NULL, NULL, NULL, 'SHIELDIN COMPLEX SUBUNIT 1', 244276),
(347503, 'PTHR36863', NULL, NULL, NULL, NULL, 'SHIELDIN COMPLEX SUBUNIT 1', 244276),
(347504, 'PTHR35446:SF2', NULL, NULL, NULL, NULL, 'CMD DOMAIN-CONTAINING PROTEIN', 244277),
(347505, 'PTHR35446:SF3', NULL, NULL, NULL, NULL, 'CMD DOMAIN-CONTAINING PROTEIN', 244277),
(347506, 'PTHR35446', NULL, NULL, NULL, NULL, 'SI:CH211-175M2.5', 244277),
(347507, 'PTHR30345:SF2', NULL, NULL, NULL, NULL, 'SUGAR-PHOSPHATE ISOMERASE, RPIB/LACA/LACB FAMILY', 244278),
(347508, 'PTHR30345', NULL, NULL, NULL, NULL, 'RIBOSE-5-PHOSPHATE ISOMERASE B', 244278),
(347509, 'PTHR30345:SF0', NULL, NULL, NULL, NULL, 'DNA DAMAGE-REPAIR/TOLERATION PROTEIN DRT102', 244278),
(347510, 'PTHR30345:SF6', NULL, NULL, NULL, NULL, 'RIBOSE 5-PHOSPHATE ISOMERASE-RELATED', 244278),
(347511, 'PTHR30345:SF5', NULL, NULL, NULL, NULL, 'GALACTOSE-6-PHOSPHATE ISOMERASE SUBUNIT LACA', 244278),
(347512, 'PTHR40980', NULL, NULL, NULL, NULL, 'PLUG DOMAIN-CONTAINING PROTEIN', 244279),
(347513, 'PTHR40980:SF4', NULL, NULL, NULL, NULL, 'TONB_DEP_REC DOMAIN-CONTAINING PROTEIN', 244279),
(347514, 'PTHR40980:SF5', NULL, NULL, NULL, NULL, 'TONB-DEPENDENT RECEPTOR', 244279),
(347515, 'PTHR40980:SF3', NULL, NULL, NULL, NULL, 'PLUG DOMAIN-CONTAINING PROTEIN', 244279),
(347516, 'PTHR10623:SF6', NULL, NULL, NULL, NULL, 'EB1, ISOFORM F-RELATED', 244280),
(347517, 'PTHR10623:SF40', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN, RP/EB FAMILY, MEMBER 3B', 244280),
(347518, 'PTHR10623:SF7', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN RP/EB FAMILY MEMBER 2', 244280),
(347519, 'PTHR10623:SF29', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN RP/EB FAMILY MEMBER 1B', 244280),
(347520, 'PTHR10623', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN RP/EB FAMILY MEMBER', 244280),
(347521, 'PTHR10623:SF38', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN RP/EB-RELATED', 244280),
(347522, 'PTHR10623:SF39', NULL, NULL, NULL, NULL, 'MICROTUBULE END BINDING PROTEIN', 244280),
(347523, 'PTHR10623:SF36', NULL, NULL, NULL, NULL, 'EB1 C-TERMINAL DOMAIN-CONTAINING PROTEIN', 244280),
(347524, 'PTHR10623:SF35', NULL, NULL, NULL, NULL, 'BNAANNG27250D PROTEIN', 244280),
(347525, 'PTHR10623:SF32', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN RP/EB FAMILY MEMBER 1A', 244280),
(347526, 'PTHR10623:SF10', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN RP/EB FAMILY MEMBER 3', 244280),
(347527, 'PTHR10623:SF33', NULL, NULL, NULL, NULL, 'OS04G0642100 PROTEIN', 244280),
(347528, 'PTHR10623:SF20', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN RP/EB FAMILY MEMBER 1', 244280),
(347529, 'PTHR46198:SF2', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE TYROSINE-PROTEIN PHOSPHATASE R', 244281),
(347530, 'PTHR46198:SF1', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE NON-RECEPTOR TYPE 5', 244281),
(347531, 'PTHR46198:SF4', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE-PHOSPHATASE', 244281),
(347532, 'PTHR46198:SF3', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE-PHOSPHATASE', 244281),
(347533, 'PTHR46198', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE-PHOSPHATASE', 244281),
(347534, 'PTHR37958:SF1', NULL, NULL, NULL, NULL, 'SODIUM-POTASSIUM/PROTON ANTIPORTER CHAA', 244282),
(347535, 'PTHR37958', NULL, NULL, NULL, NULL, 'SODIUM-POTASSIUM/PROTON ANTIPORTER CHAA', 244282),
(347536, 'PTHR35851:SF1', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN FTSQ', 244283);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(347537, 'PTHR35851', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN FTSQ', 244283),
(347538, 'PTHR45570', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 244284),
(347539, 'PTHR45570:SF1', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 244284),
(347540, 'PTHR19932:SF10', NULL, NULL, NULL, NULL, 'WD REPEAT AND HMG-BOX DNA-BINDING PROTEIN 1', 244285),
(347541, 'PTHR19932', NULL, NULL, NULL, NULL, 'WD REPEAT AND HMG-BOX DNA BINDING PROTEIN', 244285),
(347542, 'PTHR35660', NULL, NULL, NULL, NULL, 'SERINE-RICH AND TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN 1', 244286),
(347543, 'PTHR35660:SF2', NULL, NULL, NULL, NULL, 'SERINE-RICH AND TRANSMEMBRANE DOMAIN-CONTAINING 2', 244286),
(347544, 'PTHR35660:SF1', NULL, NULL, NULL, NULL, 'SERINE-RICH AND TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN 1', 244286),
(347545, 'PTHR43808:SF28', NULL, NULL, NULL, NULL, '[LYSW]-LYSINE/[LYSW]-ORNITHINE HYDROLASE-RELATED', 244287),
(347546, 'PTHR43808:SF17', NULL, NULL, NULL, NULL, 'PEPTIDASE M20', 244287),
(347547, 'PTHR43808:SF30', NULL, NULL, NULL, NULL, 'ACETYLORNITHINE DEACETYLASE', 244287),
(347548, 'PTHR43808:SF9', NULL, NULL, NULL, NULL, 'BLL0789 PROTEIN', 244287),
(347549, 'PTHR43808:SF8', NULL, NULL, NULL, NULL, 'M20_DIMER DOMAIN-CONTAINING PROTEIN', 244287),
(347550, 'PTHR43808:SF3', NULL, NULL, NULL, NULL, 'ACETYLORNITHINE DEACETYLASE', 244287),
(347551, 'PTHR43808:SF27', NULL, NULL, NULL, NULL, 'PROTEIN ROCB', 244287),
(347552, 'PTHR43808:SF24', NULL, NULL, NULL, NULL, 'N-FORMYL-4-AMINO-5-AMINOMETHYL-2-METHYLPYRIMIDINE DEFORMYLASE', 244287),
(347553, 'PTHR43808:SF1', NULL, NULL, NULL, NULL, 'ACETYLORNITHINE DEACETYLASE', 244287),
(347554, 'PTHR43808:SF14', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 244287),
(347555, 'PTHR43808:SF25', NULL, NULL, NULL, NULL, 'M20_DIMER DOMAIN-CONTAINING PROTEIN', 244287),
(347556, 'PTHR43808', NULL, NULL, NULL, NULL, 'ACETYLORNITHINE DEACETYLASE', 244287),
(347557, 'PTHR43808:SF31', NULL, NULL, NULL, NULL, 'DIPEPTIDASE YTJP-RELATED', 244287),
(347558, 'PTHR43808:SF10', NULL, NULL, NULL, NULL, 'BLL3749 PROTEIN', 244287),
(347559, 'PTHR43808:SF21', NULL, NULL, NULL, NULL, 'M20_DIMER DOMAIN-CONTAINING PROTEIN', 244287),
(347560, 'PTHR14179:SF8', NULL, NULL, NULL, NULL, 'OPIORPHIN PREPROPEPTIDE', 244288),
(347561, 'PTHR14179:SF13', NULL, NULL, NULL, NULL, 'SUBMAXILLARY GLAND ANDROGEN-REGULATED PROTEIN 3B', 244288),
(347562, 'PTHR14179', NULL, NULL, NULL, NULL, 'SMR1-RELATED', 244288),
(347563, 'PTHR14179:SF11', NULL, NULL, NULL, NULL, 'SUBMAXILLARY GLAND ANDROGEN-REGULATED PROTEIN 3A', 244288),
(347564, 'PTHR14735:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 134', 244289),
(347565, 'PTHR14735', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244289),
(347566, 'PTHR12307:SF2', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 3A', 244290),
(347567, 'PTHR12307:SF4', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 3D', 244290),
(347568, 'PTHR12307:SF7', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 3G', 244290),
(347569, 'PTHR12307:SF23', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 3C', 244290),
(347570, 'PTHR12307:SF20', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 3E', 244290),
(347571, 'PTHR12307:SF15', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 3C', 244290),
(347572, 'PTHR12307:SF48', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT', 244290),
(347573, 'PTHR12307:SF49', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT', 244290),
(347574, 'PTHR12307:SF13', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 3B', 244290),
(347575, 'PTHR12307:SF36', NULL, NULL, NULL, NULL, 'GLYCOGEN-BINDING SUBUNIT 76A', 244290),
(347576, 'PTHR12307:SF51', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT GAC1-RELATED', 244290),
(347577, 'PTHR12307:SF40', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 3F', 244290),
(347578, 'PTHR12307:SF52', NULL, NULL, NULL, NULL, 'CBM21 DOMAIN-CONTAINING PROTEIN', 244290); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(347579, 'PTHR12307', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT', 244290),
(347580, 'PTHR40021', NULL, NULL, NULL, NULL, 'DEFECT AT LOW TEMPERATURE PROTEIN 1', 244291),
(347581, 'PTHR40021:SF1', NULL, NULL, NULL, NULL, 'DEFECT AT LOW TEMPERATURE PROTEIN 1', 244291),
(347582, 'PTHR13554', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 5-RELATED', 244292),
(347583, 'PTHR13554:SF10', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 5', 244292),
(347584, 'PTHR13035:SF0', NULL, NULL, NULL, NULL, 'PROTEIN N-TERMINAL GLUTAMINE AMIDOHYDROLASE', 244293),
(347585, 'PTHR13035', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244293),
(347586, 'PTHR12183', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL UBIQUITIN LIGASE ACTIVATOR OF NFKB 1', 244294),
(347587, 'PTHR12183:SF37', NULL, NULL, NULL, NULL, 'PROTEIN MDM4', 244294),
(347588, 'PTHR12183:SF36', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 244294),
(347589, 'PTHR12183:SF6', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 244294),
(347590, 'PTHR12183:SF4', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL UBIQUITIN LIGASE ACTIVATOR OF NFKB 1', 244294),
(347591, 'PTHR12183:SF32', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL E3 UBIQUITIN PROTEIN LIGASE 1', 244294),
(347592, 'PTHR13289:SF6', NULL, NULL, NULL, NULL, 'MACOILIN', 244295),
(347593, 'PTHR13289:SF3', NULL, NULL, NULL, NULL, 'BIFOCAL, ISOFORM F', 244295),
(347594, 'PTHR13289', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1-BINDING PROTEIN BIFOCAL', 244295),
(347595, 'PTHR31426', NULL, NULL, NULL, NULL, 'GROUP II INTRON SPLICING FACTOR CRS1-LIKE', 244296),
(347596, 'PTHR31426:SF4', NULL, NULL, NULL, NULL, 'CRM-DOMAIN CONTAINING FACTOR CFM9, MITOCHONDRIAL', 244296),
(347597, 'PTHR31426:SF3', NULL, NULL, NULL, NULL, 'OS06G0304500 PROTEIN', 244296),
(347598, 'PTHR31426:SF2', NULL, NULL, NULL, NULL, 'OS01G0958400 PROTEIN', 244296),
(347599, 'PTHR31426:SF8', NULL, NULL, NULL, NULL, 'CRM DOMAIN-CONTAINING PROTEIN', 244296),
(347600, 'PTHR31426:SF7', NULL, NULL, NULL, NULL, 'CRM DOMAIN-CONTAINING PROTEIN', 244296),
(347601, 'PTHR31426:SF5', NULL, NULL, NULL, NULL, 'OS04G0492900 PROTEIN', 244296),
(347602, 'PTHR23112:SF39', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 116', 244297),
(347603, 'PTHR23112', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR 157-RELATED', 244297),
(347604, 'PTHR23112:SF5', NULL, NULL, NULL, NULL, 'CYCLIC AMP RECEPTOR-LIKE PROTEIN D', 244297),
(347605, 'PTHR23112:SF41', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_2G12640)', 244297),
(347606, 'PTHR23112:SF9', NULL, NULL, NULL, NULL, 'CYCLIC AMP RECEPTOR-LIKE PROTEIN F', 244297),
(347607, 'PTHR23112:SF8', NULL, NULL, NULL, NULL, 'CYCLIC AMP RECEPTOR-LIKE PROTEIN A', 244297),
(347608, 'PTHR23112:SF46', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 116', 244297),
(347609, 'PTHR23112:SF13', NULL, NULL, NULL, NULL, 'CYCLIC AMP RECEPTOR-LIKE PROTEIN C', 244297),
(347610, 'PTHR23112:SF36', NULL, NULL, NULL, NULL, 'SI:DKEY-30C15.2', 244297),
(347611, 'PTHR23112:SF37', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR GPR1', 244297),
(347612, 'PTHR23112:SF16', NULL, NULL, NULL, NULL, 'CYCLIC AMP RECEPTOR-LIKE PROTEIN E', 244297),
(347613, 'PTHR23112:SF43', NULL, NULL, NULL, NULL, 'SI:DKEY-100N23.5', 244297),
(347614, 'PTHR23112:SF22', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR', 244297),
(347615, 'PTHR23112:SF44', NULL, NULL, NULL, NULL, 'CYCLIC AMP RECEPTOR-LIKE PROTEIN G', 244297),
(347616, 'PTHR23112:SF23', NULL, NULL, NULL, NULL, 'CYCLIC AMP RECEPTOR 1-RELATED', 244297),
(347617, 'PTHR23112:SF0', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 157', 244297),
(347618, 'PTHR24322:SF733', NULL, NULL, NULL, NULL, 'DEHYDROGENASES, SHORT CHAIN', 244298),
(347619, 'PTHR24322:SF744', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE-LIKE PROTEIN SRL4', 244298),
(347620, 'PTHR24322:SF743', NULL, NULL, NULL, NULL, 'AER111WP', 244298),
(347621, 'PTHR24322:SF746', NULL, NULL, NULL, NULL, '', 244298),
(347622, 'PTHR24322:SF745', NULL, NULL, NULL, NULL, 'RETINOL DEHYDROGENASE 10-A-RELATED', 244298);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(347623, 'PTHR24322:SF734', NULL, NULL, NULL, NULL, 'SI:DKEY-221H15.4', 244298),
(347624, 'PTHR24322:SF489', NULL, NULL, NULL, NULL, 'ESTRADIOL 17-BETA-DEHYDROGENASE 11', 244298),
(347625, 'PTHR24322:SF742', NULL, NULL, NULL, NULL, 'PROTEIN DHS-3', 244298),
(347626, 'PTHR24322:SF499', NULL, NULL, NULL, NULL, '17-BETA-HYDROXYSTEROID DEHYDROGENASE 13', 244298),
(347627, 'PTHR24322:SF483', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/REDUCTASE 3', 244298),
(347628, 'PTHR24322:SF691', NULL, NULL, NULL, NULL, 'RETINOL DEHYDROGENASE 20', 244298),
(347629, 'PTHR24322:SF341', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/REDUCTASE FAMILY 16C MEMBER 6', 244298),
(347630, 'PTHR24322', NULL, NULL, NULL, NULL, 'PKSB', 244298),
(347631, 'PTHR24322:SF729', NULL, NULL, NULL, NULL, 'MIP05442P', 244298),
(347632, 'PTHR24322:SF748', NULL, NULL, NULL, NULL, 'FI23927P1-RELATED', 244298),
(347633, 'PTHR24322:SF638', NULL, NULL, NULL, NULL, 'DEHYDROGENASES, SHORT CHAIN', 244298),
(347634, 'PTHR24322:SF736', NULL, NULL, NULL, NULL, 'RETINOL DEHYDROGENASE 10', 244298),
(347635, 'PTHR24322:SF747', NULL, NULL, NULL, NULL, 'SHORT CHAIN DEHYDROGENASE/REDUCTASE FAMILY 16C, MEMBER 5-RELATED', 244298),
(347636, 'PTHR24322:SF728', NULL, NULL, NULL, NULL, 'EPIDERMAL RETINOL DEHYDROGENASE 2', 244298),
(347637, 'PTHR22427', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244299),
(347638, 'PTHR22427:SF8', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 36', 244299),
(347639, 'PTHR22427:SF7', NULL, NULL, NULL, NULL, 'GH15728P', 244299),
(347640, 'PTHR22427:SF2', NULL, NULL, NULL, NULL, 'AP2-INTERACTING CLATHRIN-ENDOCYTOSIS PROTEIN', 244299),
(347641, 'PTHR20995', NULL, NULL, NULL, NULL, 'F-BOX/WD REPEAT-CONTAINING PROTEIN 5', 244300),
(347642, 'PTHR20995:SF17', NULL, NULL, NULL, NULL, 'F-BOX/WD REPEAT-CONTAINING PROTEIN 5', 244300),
(347643, 'PTHR48155', NULL, NULL, NULL, NULL, 'OS09G0497600 PROTEIN', 244301),
(347644, 'PTHR48155:SF1', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 244301),
(347645, 'PTHR10331:SF6', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN J', 244302),
(347646, 'PTHR10331', NULL, NULL, NULL, NULL, 'T COMPLEX PROTEIN 10', 244302),
(347647, 'PTHR10331:SF25', NULL, NULL, NULL, NULL, 'T-COMPLEX PROTEIN 10A-RELATED', 244302),
(347648, 'PTHR10331:SF23', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN J', 244302),
(347649, 'PTHR22918:SF5', NULL, NULL, NULL, NULL, 'BINDER OF SPERM PROTEIN HOMOLOG 2', 244303),
(347650, 'PTHR22918:SF3', NULL, NULL, NULL, NULL, 'SEMINAL PLASMA PROTEIN HSP-1', 244303),
(347651, 'PTHR22918:SF4', NULL, NULL, NULL, NULL, 'BINDER OF SPERM PROTEIN HOMOLOG 1', 244303),
(347652, 'PTHR22918:SF1', NULL, NULL, NULL, NULL, 'EG:8D8.1 PROTEIN-RELATED', 244303),
(347653, 'PTHR22918', NULL, NULL, NULL, NULL, 'SEMINAL PLASMA PROTEIN', 244303),
(347654, 'PTHR22918:SF2', NULL, NULL, NULL, NULL, 'EPIDIDYMAL SPERM-BINDING PROTEIN 1', 244303),
(347655, 'PTHR36572:SF3', NULL, NULL, NULL, NULL, 'VIRULENCE PROTEIN MSGA', 244304),
(347656, 'PTHR36572:SF2', NULL, NULL, NULL, NULL, 'DNA DAMAGE-INDUCIBLE PROTEIN I', 244304),
(347657, 'PTHR36572', NULL, NULL, NULL, NULL, 'DNA DAMAGE-INDUCIBLE PROTEIN I-RELATED', 244304),
(347658, 'PTHR12929:SF20', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 52, RIBOFLAVIN TRANSPORTER, MEMBER 1', 244305),
(347659, 'PTHR12929:SF21', NULL, NULL, NULL, NULL, '', 244305),
(347660, 'PTHR12929:SF10', NULL, NULL, NULL, NULL, 'RIBOFLAVIN TRANSPORTER', 244305),
(347661, 'PTHR12929:SF4', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 52, RIBOFLAVIN TRANSPORTER, MEMBER 3', 244305),
(347662, 'PTHR12929:SF6', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 52, RIBOFLAVIN TRANSPORTER, MEMBER 3-B', 244305),
(347663, 'PTHR12929:SF1', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 52, RIBOFLAVIN TRANSPORTER, MEMBER 2', 244305),
(347664, 'PTHR12929:SF3', NULL, NULL, NULL, NULL, 'RIBOFLAVIN TRANSPORTER RFT-1', 244305),
(347665, 'PTHR12929:SF19', NULL, NULL, NULL, NULL, 'SI:CH73-196L6.5', 244305),
(347666, 'PTHR12929', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 52', 244305),
(347667, 'PTHR30625:SF9', NULL, NULL, NULL, NULL, 'MOTA/TOLQ/EXBB PROTON CHANNEL FAMILY PROTEIN', 244306);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(347668, 'PTHR30625:SF11', NULL, NULL, NULL, NULL, 'TOLQ-TYPE TRANSPORT PROTEIN-RELATED', 244306),
(347669, 'PTHR30625', NULL, NULL, NULL, NULL, 'PROTEIN TOLQ', 244306),
(347670, 'PTHR30625:SF15', NULL, NULL, NULL, NULL, 'BIOPOLYMER TRANSPORT PROTEIN EXBB', 244306),
(347671, 'PTHR30625:SF14', NULL, NULL, NULL, NULL, 'BIOPOLYMER TRANSPORT PROTEIN EXBB', 244306),
(347672, 'PTHR30625:SF3', NULL, NULL, NULL, NULL, 'TOL-PAL SYSTEM PROTEIN TOLQ', 244306),
(347673, 'PTHR30625:SF16', NULL, NULL, NULL, NULL, 'BIOPOLYMER TRANSPORT PROTEIN EXBB', 244306),
(347674, 'PTHR12419:SF85', NULL, NULL, NULL, NULL, 'OS06G0669800 PROTEIN', 244307),
(347675, 'PTHR12419:SF21', NULL, NULL, NULL, NULL, 'DEUBIQUITINASE OTUD6B', 244307),
(347676, 'PTHR12419:SF80', NULL, NULL, NULL, NULL, 'OTU DOMAIN-CONTAINING PROTEIN', 244307),
(347677, 'PTHR12419:SF81', NULL, NULL, NULL, NULL, 'OTU DOMAIN-CONTAINING PROTEIN', 244307),
(347678, 'PTHR12419:SF61', NULL, NULL, NULL, NULL, 'OS08G0506000 PROTEIN', 244307),
(347679, 'PTHR12419:SF9', NULL, NULL, NULL, NULL, 'OTU DOMAIN-CONTAINING PROTEIN 4', 244307),
(347680, 'PTHR12419:SF8', NULL, NULL, NULL, NULL, 'OVARIAN TUMOR DOMAIN-CONTAINING DEUBIQUITINATING ENZYME 4', 244307),
(347681, 'PTHR12419:SF59', NULL, NULL, NULL, NULL, 'OTU DOMAIN-CONTAINING PROTEIN DDB_G0284757-LIKE', 244307),
(347682, 'PTHR12419:SF3', NULL, NULL, NULL, NULL, 'OVARIAN TUMOR DOMAIN-CONTAINING DEUBIQUITINATING ENZYME 12', 244307),
(347683, 'PTHR12419:SF11', NULL, NULL, NULL, NULL, 'OTU DOMAIN-CONTAINING PROTEIN DDB_G0284757', 244307),
(347684, 'PTHR12419:SF4', NULL, NULL, NULL, NULL, 'OTU DOMAIN-CONTAINING PROTEIN 5', 244307),
(347685, 'PTHR12419:SF13', NULL, NULL, NULL, NULL, 'OTU DOMAIN-CONTAINING PROTEIN 6A', 244307),
(347686, 'PTHR12419:SF7', NULL, NULL, NULL, NULL, 'OTU DOMAIN-CONTAINING PROTEIN 3', 244307),
(347687, 'PTHR12419:SF79', NULL, NULL, NULL, NULL, 'OS02G0168600 PROTEIN', 244307),
(347688, 'PTHR12419:SF58', NULL, NULL, NULL, NULL, 'ALG13 UDP-N-ACETYLGLUCOSAMINYLTRANSFERASE SUBUNIT', 244307),
(347689, 'PTHR12419:SF73', NULL, NULL, NULL, NULL, 'BNAA04G15810D PROTEIN', 244307),
(347690, 'PTHR12419:SF53', NULL, NULL, NULL, NULL, 'OTU DOMAIN-CONTAINING PROTEIN', 244307),
(347691, 'PTHR12419:SF10', NULL, NULL, NULL, NULL, 'FI09629P', 244307),
(347692, 'PTHR12419:SF70', NULL, NULL, NULL, NULL, 'OTU DOMAIN-CONTAINING PROTEIN', 244307),
(347693, 'PTHR12419:SF93', NULL, NULL, NULL, NULL, 'OTU DOMAIN-CONTAINING PROTEIN', 244307),
(347694, 'PTHR12419:SF90', NULL, NULL, NULL, NULL, 'OS02G0819500 PROTEIN', 244307),
(347695, 'PTHR12419', NULL, NULL, NULL, NULL, 'OTU DOMAIN CONTAINING PROTEIN', 244307),
(347696, 'PTHR12419:SF104', NULL, NULL, NULL, NULL, 'OS04G0402300 PROTEIN', 244307),
(347697, 'PTHR12419:SF103', NULL, NULL, NULL, NULL, 'OVARIAN TUMOR DOMAIN-CONTAINING DEUBIQUITINATING ENZYME 10-RELATED', 244307),
(347698, 'PTHR12419:SF106', NULL, NULL, NULL, NULL, 'OTU DOMAIN-CONTAINING PROTEIN DDB_G0284757-LIKE', 244307),
(347699, 'PTHR12419:SF105', NULL, NULL, NULL, NULL, 'DEUBIQUITINASE OTUD6B', 244307),
(347700, 'PTHR12419:SF100', NULL, NULL, NULL, NULL, 'OS01G0900900 PROTEIN', 244307),
(347701, 'PTHR12419:SF102', NULL, NULL, NULL, NULL, 'OTU-LIKE CYSTEINE PROTEASE FAMILY PROTEIN, EXPRESSED', 244307),
(347702, 'PTHR12419:SF101', NULL, NULL, NULL, NULL, 'OTU DOMAIN-CONTAINING PROTEIN 1', 244307),
(347703, 'PTHR12419:SF26', NULL, NULL, NULL, NULL, 'OTU DOMAIN-CONTAINING PROTEIN', 244307),
(347704, 'PTHR12419:SF49', NULL, NULL, NULL, NULL, 'OVARIAN TUMOR DOMAIN-CONTAINING DEUBIQUITINATING ENZYME 11', 244307),
(347705, 'PTHR12419:SF108', NULL, NULL, NULL, NULL, 'OTU DOMAIN-CONTAINING PROTEIN-RELATED', 244307),
(347706, 'PTHR12419:SF107', NULL, NULL, NULL, NULL, 'OTU DOMAIN-CONTAINING PROTEIN', 244307),
(347707, 'PTHR12419:SF109', NULL, NULL, NULL, NULL, 'OVARIAN TUMOR DOMAIN-CONTAINING DEUBIQUITINATING ENZYME 6', 244307),
(347708, 'PTHR13398:SF7', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 36', 244308),
(347709, 'PTHR13398:SF3', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 14', 244308),
(347710, 'PTHR13398:SF4', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 244308);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(347711, 'PTHR13398:SF0', NULL, NULL, NULL, NULL, 'GDP-FUCOSE PROTEIN O-FUCOSYLTRANSFERASE 2', 244308),
(347712, 'PTHR13398', NULL, NULL, NULL, NULL, 'GDP-FUCOSE PROTEIN O-FUCOSYLTRANSFERASE 2', 244308),
(347713, 'PTHR40596:SF1', NULL, NULL, NULL, NULL, 'CITRATE LYASE ALPHA CHAIN', 244309),
(347714, 'PTHR40596', NULL, NULL, NULL, NULL, 'CITRATE LYASE ALPHA CHAIN', 244309),
(347715, 'PTHR47223:SF1', NULL, NULL, NULL, NULL, 'SPERM ACROSOME MEMBRANE-ASSOCIATED PROTEIN 1', 244310),
(347716, 'PTHR47223', NULL, NULL, NULL, NULL, 'SPERM ACROSOME MEMBRANE-ASSOCIATED PROTEIN 1', 244310),
(347717, 'PTHR13937:SF5', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT C', 244311),
(347718, 'PTHR13937', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITATION FACTOR 3, SUBUNIT 8  EIF3S8 -RELATED', 244311),
(347719, 'PTHR13937:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG08598', 244311),
(347720, 'PTHR13937:SF10', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT C', 244311),
(347721, 'PTHR13937:SF0', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT C-RELATED', 244311),
(347722, 'PTHR13937:SF9', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT C', 244311),
(347723, 'PTHR13937:SF8', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT C', 244311),
(347724, 'PTHR45801:SF62', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 244312),
(347725, 'PTHR45801:SF61', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 244312),
(347726, 'PTHR45801:SF16', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 244312),
(347727, 'PTHR45801:SF18', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR SUPERMAN-LIKE', 244312),
(347728, 'PTHR45801:SF56', NULL, NULL, NULL, NULL, 'OS04G0168100 PROTEIN', 244312),
(347729, 'PTHR45801:SF97', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR TAC1-LIKE', 244312),
(347730, 'PTHR45801:SF96', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR SUPERMAN-LIKE', 244312),
(347731, 'PTHR45801:SF99', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR SUPERMAN', 244312),
(347732, 'PTHR45801:SF10', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 244312),
(347733, 'PTHR45801:SF98', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 244312),
(347734, 'PTHR45801:SF54', NULL, NULL, NULL, NULL, 'ZINC FINGER C2H2-TYPE/INTEGRASE DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 244312),
(347735, 'PTHR45801:SF100', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 244312),
(347736, 'PTHR45801:SF93', NULL, NULL, NULL, NULL, 'C2H2 TYPE ZINC FINGER TRANSCRIPTION FACTOR FAMILY PROTEIN', 244312),
(347737, 'PTHR45801:SF101', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 244312),
(347738, 'PTHR45801:SF92', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 244312),
(347739, 'PTHR45801:SF95', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 244312),
(347740, 'PTHR45801:SF51', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 244312),
(347741, 'PTHR45801', NULL, NULL, NULL, NULL, 'OS07G0101800 PROTEIN', 244312),
(347742, 'PTHR45801:SF94', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 10', 244312),
(347743, 'PTHR45801:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR SUPERMAN', 244312),
(347744, 'PTHR45801:SF91', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 244312),
(347745, 'PTHR45801:SF90', NULL, NULL, NULL, NULL, 'OS03G0148900 PROTEIN', 244312),
(347746, 'PTHR45801:SF49', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 244312),
(347747, 'PTHR45801:SF8', NULL, NULL, NULL, NULL, 'C2H2 AND C2HC ZINC FINGERS SUPERFAMILY PROTEIN', 244312),
(347748, 'PTHR45801:SF46', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 244312),
(347749, 'PTHR45801:SF48', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR SUPERMAN', 244312),
(347750, 'PTHR45801:SF106', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 244312);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(347751, 'PTHR45801:SF104', NULL, NULL, NULL, NULL, 'OS02G0100900 PROTEIN', 244312),
(347752, 'PTHR45801:SF105', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR SUPERMAN', 244312),
(347753, 'PTHR45801:SF102', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 244312),
(347754, 'PTHR45801:SF88', NULL, NULL, NULL, NULL, 'C2H2 AND C2HC ZINC FINGERS SUPERFAMILY PROTEIN', 244312),
(347755, 'PTHR45801:SF103', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C2H2 FAMILY-RELATED', 244312),
(347756, 'PTHR45801:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR RABBIT EARS-RELATED', 244312),
(347757, 'PTHR45801:SF87', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 244312),
(347758, 'PTHR45801:SF81', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR TAC1', 244312),
(347759, 'PTHR45801:SF84', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 244312),
(347760, 'PTHR45801:SF83', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 244312),
(347761, 'PTHR45801:SF79', NULL, NULL, NULL, NULL, 'ZINC FINGER, C2H2-RELATED', 244312),
(347762, 'PTHR45801:SF78', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR RABBIT EARS-RELATED', 244312),
(347763, 'PTHR45801:SF74', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR SUPERMAN-LIKE', 244312),
(347764, 'PTHR45801:SF77', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 244312),
(347765, 'PTHR45801:SF71', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR SUPERMAN-LIKE', 244312),
(347766, 'PTHR45801:SF70', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR TAC1-LIKE', 244312),
(347767, 'PTHR45801:SF73', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 11', 244312),
(347768, 'PTHR45801:SF72', NULL, NULL, NULL, NULL, 'ZINC FINGER C2H2-TYPE/INTEGRASE DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 244312),
(347769, 'PTHR45801:SF67', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 244312),
(347770, 'PTHR45801:SF69', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR SUPERMAN-LIKE', 244312),
(347771, 'PTHR45801:SF20', NULL, NULL, NULL, NULL, 'JAG', 244312),
(347772, 'PTHR45801:SF63', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 244312),
(347773, 'PTHR45801:SF65', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C2H2 FAMILY-RELATED', 244312),
(347774, 'PTHR12416:SF2', NULL, NULL, NULL, NULL, 'RRNA-PROCESSING PROTEIN FCF1 HOMOLOG', 244313),
(347775, 'PTHR12416', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244313),
(347776, 'PTHR12416:SF8', NULL, NULL, NULL, NULL, 'RRNA-PROCESSING PROTEIN FCF1 HOMOLOG', 244313),
(347777, 'PTHR12416:SF6', NULL, NULL, NULL, NULL, 'PINC DOMAIN-CONTAINING PROTEIN', 244313),
(347778, 'PTHR12416:SF3', NULL, NULL, NULL, NULL, 'RRNA-PROCESSING PROTEIN UTP23 HOMOLOG', 244313),
(347779, 'PTHR27005:SF239', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE-LIKE 11-RELATED', 244314),
(347780, 'PTHR27005:SF238', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE 3', 244314),
(347781, 'PTHR27005:SF359', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347782, 'PTHR27005:SF477', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347783, 'PTHR27005:SF355', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347784, 'PTHR27005:SF476', NULL, NULL, NULL, NULL, 'SERINE/THREONINE/DUAL SPECIFICITY PROTEIN KINASE, CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 244314),
(347785, 'PTHR27005:SF479', NULL, NULL, NULL, NULL, 'OS06G0705200 PROTEIN', 244314),
(347786, 'PTHR27005:SF357', NULL, NULL, NULL, NULL, '', 244314),
(347787, 'PTHR27005:SF478', NULL, NULL, NULL, NULL, '', 244314),
(347788, 'PTHR27005:SF231', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347789, 'PTHR27005:SF473', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347790, 'PTHR27005:SF472', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE-LIKE 8', 244314),
(347791, 'PTHR27005:SF475', NULL, NULL, NULL, NULL, 'SERINE/THREONINE/DUAL SPECIFICITY PROTEIN KINASE, CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 244314);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(347792, 'PTHR27005:SF233', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347793, 'PTHR27005:SF354', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347794, 'PTHR27005:SF353', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE-LIKE 11-RELATED', 244314),
(347795, 'PTHR27005:SF474', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347796, 'PTHR27005:SF471', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE-LIKE 1-RELATED', 244314),
(347797, 'PTHR27005:SF470', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347798, 'PTHR27005:SF11', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE-LIKE 20', 244314),
(347799, 'PTHR27005:SF10', NULL, NULL, NULL, NULL, 'OS08G0501500 PROTEIN', 244314),
(347800, 'PTHR27005:SF469', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347801, 'PTHR27005:SF466', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347802, 'PTHR27005:SF345', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347803, 'PTHR27005:SF344', NULL, NULL, NULL, NULL, 'BNAANNG18620D PROTEIN', 244314),
(347804, 'PTHR27005:SF465', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347805, 'PTHR27005:SF468', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347806, 'PTHR27005:SF346', NULL, NULL, NULL, NULL, 'BNACNNG45090D PROTEIN', 244314),
(347807, 'PTHR27005:SF467', NULL, NULL, NULL, NULL, 'NON-FUNCTIONAL PSEUDOKINASE ZED1-LIKE ISOFORM X1', 244314),
(347808, 'PTHR27005:SF220', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347809, 'PTHR27005:SF462', NULL, NULL, NULL, NULL, 'WALL ASSOCIATED KINASE-LIKE PROTEIN', 244314),
(347810, 'PTHR27005:SF461', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347811, 'PTHR27005:SF343', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347812, 'PTHR27005:SF464', NULL, NULL, NULL, NULL, 'BNAA06G15050D PROTEIN', 244314),
(347813, 'PTHR27005:SF463', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347814, 'PTHR27005:SF460', NULL, NULL, NULL, NULL, 'NON-FUNCTIONAL PSEUDOKINASE ZED1-LIKE', 244314),
(347815, 'PTHR27005:SF459', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE-LIKE 17', 244314),
(347816, 'PTHR27005:SF216', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347817, 'PTHR27005:SF458', NULL, NULL, NULL, NULL, '', 244314),
(347818, 'PTHR27005:SF218', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347819, 'PTHR27005:SF339', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347820, 'PTHR27005:SF213', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347821, 'PTHR27005:SF334', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347822, 'PTHR27005:SF455', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE 2-LIKE', 244314),
(347823, 'PTHR27005:SF212', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347824, 'PTHR27005:SF333', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347825, 'PTHR27005:SF454', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347826, 'PTHR27005:SF336', NULL, NULL, NULL, NULL, 'BNAANNG18600D PROTEIN', 244314),
(347827, 'PTHR27005:SF215', NULL, NULL, NULL, NULL, 'OS09G0562600 PROTEIN', 244314),
(347828, 'PTHR27005:SF457', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE-LIKE 14', 244314),
(347829, 'PTHR27005:SF456', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347830, 'PTHR27005:SF335', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347831, 'PTHR27005:SF214', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347832, 'PTHR27005:SF451', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(347833, 'PTHR27005:SF330', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347834, 'PTHR27005:SF332', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE 2-LIKE', 244314),
(347835, 'PTHR27005:SF453', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347836, 'PTHR27005:SF39', NULL, NULL, NULL, NULL, '(RICE GENOME ANNOTATION PROJECT) OSWAK10A - OSWAK RECEPTOR-LIKE CYTOPLASMIC KINASE', 244314),
(347837, 'PTHR27005', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE-LIKE 21', 244314),
(347838, 'PTHR27005:SF34', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE-LIKE 21', 244314),
(347839, 'PTHR27005:SF37', NULL, NULL, NULL, NULL, 'OS04G0367600 PROTEIN', 244314),
(347840, 'PTHR27005:SF327', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347841, 'PTHR27005:SF208', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347842, 'PTHR27005:SF329', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347843, 'PTHR27005:SF207', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347844, 'PTHR27005:SF328', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347845, 'PTHR27005:SF322', NULL, NULL, NULL, NULL, 'BNAA06G15010D PROTEIN', 244314),
(347846, 'PTHR27005:SF204', NULL, NULL, NULL, NULL, 'CALCIUM BINDING EGF DOMAIN CONTAINING PROTEIN, EXPRESSED', 244314),
(347847, 'PTHR27005:SF445', NULL, NULL, NULL, NULL, 'BNAANNG15620D PROTEIN', 244314),
(347848, 'PTHR27005:SF200', NULL, NULL, NULL, NULL, 'OS06G0142500 PROTEIN', 244314),
(347849, 'PTHR27005:SF321', NULL, NULL, NULL, NULL, 'OS10G0141300 PROTEIN', 244314),
(347850, 'PTHR27005:SF320', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE 2-LIKE ISOFORM X1', 244314),
(347851, 'PTHR27005:SF29', NULL, NULL, NULL, NULL, 'OS01G0310500 PROTEIN', 244314),
(347852, 'PTHR27005:SF209', NULL, NULL, NULL, NULL, 'OS09G0561500 PROTEIN', 244314),
(347853, 'PTHR27005:SF315', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347854, 'PTHR27005:SF436', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE-LIKE PROTEIN 9', 244314),
(347855, 'PTHR27005:SF433', NULL, NULL, NULL, NULL, 'NON-FUNCTIONAL PSEUDOKINASE ZED1-LIKE ISOFORM X1', 244314),
(347856, 'PTHR27005:SF432', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE-LIKE 11-RELATED', 244314),
(347857, 'PTHR27005:SF311', NULL, NULL, NULL, NULL, 'NON-FUNCTIONAL PSEUDOKINASE ZED1-LIKE', 244314),
(347858, 'PTHR27005:SF431', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR PROTEIN KINASE FAMILY PROTEIN-RELATED', 244314),
(347859, 'PTHR27005:SF310', NULL, NULL, NULL, NULL, 'BNAA06G15000D PROTEIN', 244314),
(347860, 'PTHR27005:SF305', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED KINASE 2-LIKE PROTEIN', 244314),
(347861, 'PTHR27005:SF426', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE-LIKE 10', 244314),
(347862, 'PTHR27005:SF427', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347863, 'PTHR27005:SF6', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE-LIKE 8', 244314),
(347864, 'PTHR27005:SF420', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE 2-LIKE', 244314),
(347865, 'PTHR27005:SF429', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347866, 'PTHR27005:SF308', NULL, NULL, NULL, NULL, 'NON-FUNCTIONAL PSEUDOKINASE ZRK2-RELATED', 244314),
(347867, 'PTHR27005:SF415', NULL, NULL, NULL, NULL, 'NON-FUNCTIONAL PSEUDOKINASE ZED1-LIKE', 244314),
(347868, 'PTHR27005:SF416', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347869, 'PTHR27005:SF412', NULL, NULL, NULL, NULL, 'OS04G0307900 PROTEIN', 244314),
(347870, 'PTHR27005:SF418', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347871, 'PTHR27005:SF404', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347872, 'PTHR27005:SF405', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(347873, 'PTHR27005:SF400', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347874, 'PTHR27005:SF402', NULL, NULL, NULL, NULL, 'BNAC08G19750D PROTEIN', 244314),
(347875, 'PTHR27005:SF407', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347876, 'PTHR27005:SF409', NULL, NULL, NULL, NULL, 'OS12G0595800 PROTEIN', 244314),
(347877, 'PTHR27005:SF199', NULL, NULL, NULL, NULL, '', 244314),
(347878, 'PTHR27005:SF193', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347879, 'PTHR27005:SF503', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347880, 'PTHR27005:SF502', NULL, NULL, NULL, NULL, 'WAK FAMILY RECEPTOR-LIKE PROTEIN KINASE-RELATED', 244314),
(347881, 'PTHR27005:SF501', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN (MAP) KINASE, ERK3/4-RELATED', 244314),
(347882, 'PTHR27005:SF500', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE ZRK1', 244314),
(347883, 'PTHR27005:SF187', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE-LIKE 15', 244314),
(347884, 'PTHR27005:SF186', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347885, 'PTHR27005:SF189', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347886, 'PTHR27005:SF188', NULL, NULL, NULL, NULL, 'INACTIVE SERINE/THREONINE-PROTEIN KINASE ZRK12-RELATED', 244314),
(347887, 'PTHR27005:SF190', NULL, NULL, NULL, NULL, 'OS05G0318100 PROTEIN', 244314),
(347888, 'PTHR27005:SF87', NULL, NULL, NULL, NULL, 'OS11G0556600 PROTEIN', 244314),
(347889, 'PTHR27005:SF297', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE-LIKE 18', 244314),
(347890, 'PTHR27005:SF175', NULL, NULL, NULL, NULL, 'NON-FUNCTIONAL PSEUDOKINASE ZRK6', 244314),
(347891, 'PTHR27005:SF296', NULL, NULL, NULL, NULL, 'CALCIUM BINDING EGF DOMAIN CONTAINING PROTEIN, EXPRESSED', 244314),
(347892, 'PTHR27005:SF177', NULL, NULL, NULL, NULL, 'WAK FAMILY RECEPTOR-LIKE PROTEIN KINASE-RELATED', 244314),
(347893, 'PTHR27005:SF293', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347894, 'PTHR27005:SF174', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR PROTEIN KINASE FAMILY PROTEIN-RELATED', 244314),
(347895, 'PTHR27005:SF173', NULL, NULL, NULL, NULL, 'OS06G0170100 PROTEIN', 244314),
(347896, 'PTHR27005:SF169', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347897, 'PTHR27005:SF168', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE 2', 244314),
(347898, 'PTHR27005:SF165', NULL, NULL, NULL, NULL, 'OS03G0642600 PROTEIN', 244314),
(347899, 'PTHR27005:SF286', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE 3', 244314),
(347900, 'PTHR27005:SF164', NULL, NULL, NULL, NULL, 'WAK RECEPTOR-LIKE PROTEIN KINASE FAMILY PROTEIN-RELATED', 244314),
(347901, 'PTHR27005:SF288', NULL, NULL, NULL, NULL, 'OS04G0275100 PROTEIN', 244314),
(347902, 'PTHR27005:SF287', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347903, 'PTHR27005:SF281', NULL, NULL, NULL, NULL, 'OS01G0364100 PROTEIN', 244314),
(347904, 'PTHR27005:SF283', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE 1-RELATED', 244314),
(347905, 'PTHR27005:SF162', NULL, NULL, NULL, NULL, 'OS11G0691500 PROTEIN', 244314),
(347906, 'PTHR27005:SF170', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347907, 'PTHR27005:SF279', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347908, 'PTHR27005:SF395', NULL, NULL, NULL, NULL, 'OS02G0633066 PROTEIN', 244314),
(347909, 'PTHR27005:SF276', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347910, 'PTHR27005:SF397', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 244314),
(347911, 'PTHR27005:SF392', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347912, 'PTHR27005:SF391', NULL, NULL, NULL, NULL, 'ATP BINDING PROTEIN', 244314),
(347913, 'PTHR27005:SF270', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(347914, 'PTHR27005:SF394', NULL, NULL, NULL, NULL, 'OS02G0807200 PROTEIN', 244314),
(347915, 'PTHR27005:SF273', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347916, 'PTHR27005:SF57', NULL, NULL, NULL, NULL, 'OS08G0365500 PROTEIN', 244314),
(347917, 'PTHR27005:SF56', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 1.1', 244314),
(347918, 'PTHR27005:SF59', NULL, NULL, NULL, NULL, 'OS12G0614851 PROTEIN', 244314),
(347919, 'PTHR27005:SF280', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE-LIKE 1', 244314),
(347920, 'PTHR27005:SF389', NULL, NULL, NULL, NULL, 'OS01G0364400 PROTEIN', 244314),
(347921, 'PTHR27005:SF388', NULL, NULL, NULL, NULL, 'VASCULAR ENDOTHELIAL GROWTH FACTOR RECEPTOR 2 (VEGFR2)-RELATED', 244314),
(347922, 'PTHR27005:SF385', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE-LIKE 22', 244314),
(347923, 'PTHR27005:SF264', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347924, 'PTHR27005:SF266', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE ZRK4', 244314),
(347925, 'PTHR27005:SF145', NULL, NULL, NULL, NULL, 'OS10G0142600 PROTEIN', 244314),
(347926, 'PTHR27005:SF381', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347927, 'PTHR27005:SF380', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 244314),
(347928, 'PTHR27005:SF383', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347929, 'PTHR27005:SF261', NULL, NULL, NULL, NULL, '', 244314),
(347930, 'PTHR27005:SF45', NULL, NULL, NULL, NULL, 'OS10G0351500 PROTEIN', 244314),
(347931, 'PTHR27005:SF390', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347932, 'PTHR27005:SF499', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347933, 'PTHR27005:SF257', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE-LIKE 9', 244314),
(347934, 'PTHR27005:SF498', NULL, NULL, NULL, NULL, 'NON-FUNCTIONAL PSEUDOKINASE ZED1-LIKE', 244314),
(347935, 'PTHR27005:SF256', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347936, 'PTHR27005:SF259', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347937, 'PTHR27005:SF253', NULL, NULL, NULL, NULL, '', 244314),
(347938, 'PTHR27005:SF495', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347939, 'PTHR27005:SF494', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE 1', 244314),
(347940, 'PTHR27005:SF497', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347941, 'PTHR27005:SF496', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE 3', 244314),
(347942, 'PTHR27005:SF254', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE-LIKE 2-RELATED', 244314),
(347943, 'PTHR27005:SF491', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347944, 'PTHR27005:SF490', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 244314),
(347945, 'PTHR27005:SF493', NULL, NULL, NULL, NULL, 'OS09G0482640 PROTEIN', 244314),
(347946, 'PTHR27005:SF372', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347947, 'PTHR27005:SF492', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE 2-LIKE', 244314),
(347948, 'PTHR27005:SF371', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347949, 'PTHR27005:SF78', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347950, 'PTHR27005:SF249', NULL, NULL, NULL, NULL, 'OS10G0116600 PROTEIN', 244314),
(347951, 'PTHR27005:SF488', NULL, NULL, NULL, NULL, 'NON-FUNCTIONAL PSEUDOKINASE ZED1', 244314),
(347952, 'PTHR27005:SF246', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347953, 'PTHR27005:SF487', NULL, NULL, NULL, NULL, 'ATP BINDING PROTEIN', 244314),
(347954, 'PTHR27005:SF366', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347955, 'PTHR27005:SF245', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 1.5', 244314);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(347956, 'PTHR27005:SF369', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN-RELATED', 244314),
(347957, 'PTHR27005:SF489', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347958, 'PTHR27005:SF247', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347959, 'PTHR27005:SF484', NULL, NULL, NULL, NULL, '', 244314),
(347960, 'PTHR27005:SF363', NULL, NULL, NULL, NULL, 'OS07G0494300 PROTEIN', 244314),
(347961, 'PTHR27005:SF483', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347962, 'PTHR27005:SF241', NULL, NULL, NULL, NULL, 'OS10G0174548 PROTEIN', 244314),
(347963, 'PTHR27005:SF362', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347964, 'PTHR27005:SF365', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347965, 'PTHR27005:SF244', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR PROTEIN KINASE FAMILY PROTEIN-RELATED', 244314),
(347966, 'PTHR27005:SF486', NULL, NULL, NULL, NULL, '', 244314),
(347967, 'PTHR27005:SF364', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347968, 'PTHR27005:SF485', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244314),
(347969, 'PTHR27005:SF480', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 244314),
(347970, 'PTHR27005:SF482', NULL, NULL, NULL, NULL, 'OS01G0580150 PROTEIN', 244314),
(347971, 'PTHR27005:SF481', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE-LIKE 16-RELATED', 244314),
(347972, 'PTHR30344', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONOLACTONASE-RELATED', 244315),
(347973, 'PTHR30344:SF7', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244315),
(347974, 'PTHR30344:SF9', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONOLACTONASE', 244315),
(347975, 'PTHR30344:SF1', NULL, NULL, NULL, NULL, 'CYCLOISOMERASE 2 FAMILY PROTEIN', 244315),
(347976, 'PTHR30344:SF4', NULL, NULL, NULL, NULL, 'CYCLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G11580)-RELATED', 244315),
(347977, 'PTHR42978:SF3', NULL, NULL, NULL, NULL, 'METALLO-HYDROLASE RV2300C-RELATED', 244316),
(347978, 'PTHR42978:SF4', NULL, NULL, NULL, NULL, 'LACTAMASE_B DOMAIN-CONTAINING PROTEIN', 244316),
(347979, 'PTHR42978:SF5', NULL, NULL, NULL, NULL, 'LACTAMASE_B DOMAIN-CONTAINING PROTEIN', 244316),
(347980, 'PTHR42978:SF6', NULL, NULL, NULL, NULL, 'QUORUM-QUENCHING LACTONASE YTNP-RELATED', 244316),
(347981, 'PTHR42978:SF1', NULL, NULL, NULL, NULL, 'BLL0351 PROTEIN', 244316),
(347982, 'PTHR42978:SF2', NULL, NULL, NULL, NULL, '102 KBASES UNSTABLE REGION: FROM 1 TO 119443', 244316),
(347983, 'PTHR42978', NULL, NULL, NULL, NULL, 'QUORUM-QUENCHING LACTONASE YTNP-RELATED-RELATED', 244316),
(347984, 'PTHR39479:SF2', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 244317),
(347985, 'PTHR39479', NULL, NULL, NULL, NULL, '', 244317),
(347986, 'PTHR15438:SF11', NULL, NULL, NULL, NULL, '', 244318),
(347987, 'PTHR15438:SF4', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX-INTERACTING PROTEIN FAMILY MEMBER B15-RELATED', 244318),
(347988, 'PTHR15438:SF12', NULL, NULL, NULL, NULL, '', 244318),
(347989, 'PTHR15438:SF5', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX-INTERACTING PROTEIN FAMILY MEMBER B11-RELATED', 244318),
(347990, 'PTHR15438:SF14', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX-INTERACTING PROTEIN FAMILY MEMBER A1-RELATED', 244318),
(347991, 'PTHR15438', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX INTERACTING PROTEIN', 244318),
(347992, 'PTHR36327:SF1', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I REACTION CENTER SUBUNIT N', 244319),
(347993, 'PTHR36327:SF2', NULL, NULL, NULL, NULL, '', 244319),
(347994, 'PTHR36327', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', 244319),
(347995, 'PTHR35753:SF2', NULL, NULL, NULL, NULL, 'PROTEIN MAINTENANCE OF PSII UNDER HIGH LIGHT 1', 244320),
(347996, 'PTHR35753', NULL, NULL, NULL, NULL, 'PROTEIN MAINTENANCE OF PSII UNDER HIGH LIGHT 1', 244320),
(347997, 'PTHR12338:SF10', NULL, NULL, NULL, NULL, 'ADHESION AND PENETRATION PROTEIN AUTOTRANSPORTER', 244321),
(347998, 'PTHR12338', NULL, NULL, NULL, NULL, 'AUTOTRANSPORTER', 244321);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(347999, 'PTHR12338:SF8', NULL, NULL, NULL, NULL, 'ANTIGEN 43', 244321),
(348000, 'PTHR12338:SF9', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN A1 PROTEASE AUTOTRANSPORTER', 244321),
(348001, 'PTHR12338:SF5', NULL, NULL, NULL, NULL, 'AUTOTRANSPORTER YFAL-RELATED', 244321),
(348002, 'PTHR34722', NULL, NULL, NULL, NULL, 'HOMOLOG OF ODR-2 (TWO)-RELATED', 244322),
(348003, 'PTHR34722:SF2', NULL, NULL, NULL, NULL, 'HOMOLOG OF ODR-2 (TWO)', 244322),
(348004, 'PTHR34722:SF1', NULL, NULL, NULL, NULL, 'HOMOLOG OF ODR-2 (TWO)', 244322),
(348005, 'PTHR34722:SF4', NULL, NULL, NULL, NULL, 'HOMOLOG OF ODR-2 (TWO)', 244322),
(348006, 'PTHR34722:SF3', NULL, NULL, NULL, NULL, 'HOMOLOG OF ODR-2 (TWO)-RELATED', 244322),
(348007, 'PTHR34722:SF6', NULL, NULL, NULL, NULL, 'HOMOLOG OF ODR-2 (TWO)', 244322),
(348008, 'PTHR34722:SF8', NULL, NULL, NULL, NULL, 'HOMOLOG OF ODR-2 (TWO)', 244322),
(348009, 'PTHR34722:SF9', NULL, NULL, NULL, NULL, 'HOMOLOG OF ODR-2 (TWO)', 244322),
(348010, 'PTHR13024:SF2', NULL, NULL, NULL, NULL, 'MICROSOMAL TRIGLYCERIDE TRANSFER PROTEIN LARGE SUBUNIT-LIKE PROTEIN', 244323),
(348011, 'PTHR13024:SF1', NULL, NULL, NULL, NULL, 'MICROSOMAL TRIGLYCERIDE TRANSFER PROTEIN LARGE SUBUNIT', 244323),
(348012, 'PTHR13024:SF0', NULL, NULL, NULL, NULL, 'MICROSOMAL TRIACYLGLYCEROL TRANSFER PROTEIN', 244323),
(348013, 'PTHR13024', NULL, NULL, NULL, NULL, 'MICROSOMAL TRIGLYCERIDE TRANSFER PROTEIN, LARGE SUBUNIT', 244323),
(348014, 'PTHR14628:SF1', NULL, NULL, NULL, NULL, 'BEN DOMAIN-CONTAINING PROTEIN 5', 244324),
(348015, 'PTHR14628', NULL, NULL, NULL, NULL, 'BEN DOMAIN-CONTAINING PROTEIN 5', 244324),
(348016, 'PTHR13232:SF10', NULL, NULL, NULL, NULL, 'NAD(P)H-HYDRATE EPIMERASE', 244325),
(348017, 'PTHR13232:SF11', NULL, NULL, NULL, NULL, 'NAD(P)H-HYDRATE EPIMERASE', 244325),
(348018, 'PTHR13232:SF12', NULL, NULL, NULL, NULL, 'YJEF N-TERMINAL DOMAIN-CONTAINING PROTEIN 3', 244325),
(348019, 'PTHR13232:SF13', NULL, NULL, NULL, NULL, 'NAD(P)H-HYDRATE EPIMERASE', 244325),
(348020, 'PTHR13232', NULL, NULL, NULL, NULL, 'NAD(P)H-HYDRATE EPIMERASE', 244325),
(348021, 'PTHR40381', NULL, NULL, NULL, NULL, 'PEROXISOMAL TESTIS-SPECIFIC PROTEIN 1', 244326),
(348022, 'PTHR40381:SF1', NULL, NULL, NULL, NULL, 'PEROXISOMAL TESTIS-SPECIFIC PROTEIN 1', 244326),
(348023, 'PTHR24205:SF7', NULL, NULL, NULL, NULL, 'FOUR AND A HALF LIM DOMAINS PROTEIN 5', 244327),
(348024, 'PTHR24205:SF4', NULL, NULL, NULL, NULL, 'LIM DOMAIN FAMILY', 244327),
(348025, 'PTHR24205:SF15', NULL, NULL, NULL, NULL, 'FOUR AND A HALF LIM DOMAINS 5', 244327),
(348026, 'PTHR24205:SF5', NULL, NULL, NULL, NULL, 'FOUR AND A HALF LIM DOMAINS PROTEIN 3', 244327),
(348027, 'PTHR24205:SF14', NULL, NULL, NULL, NULL, 'FOUR AND A HALF LIM DOMAINS 1', 244327),
(348028, 'PTHR24205:SF3', NULL, NULL, NULL, NULL, 'FOUR AND A HALF LIM DOMAINS PROTEIN 2', 244327),
(348029, 'PTHR24205', NULL, NULL, NULL, NULL, 'FOUR AND A HALF LIM DOMAINS PROTEIN', 244327),
(348030, 'PTHR38525:SF1', NULL, NULL, NULL, NULL, 'OS03G0824500 PROTEIN', 244328),
(348031, 'PTHR38525', NULL, NULL, NULL, NULL, 'OS03G0824500 PROTEIN', 244328),
(348032, 'PTHR23313', NULL, NULL, NULL, NULL, 'TSEC1-RELATED', 244329),
(348033, 'PTHR23313:SF0', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 9', 244329),
(348034, 'PTHR47244:SF3', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE-PHOSPHATASE IBR5-LIKE', 244330),
(348035, 'PTHR47244:SF2', NULL, NULL, NULL, NULL, 'OS02G0720300 PROTEIN', 244330),
(348036, 'PTHR47244:SF1', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE-PHOSPHATASE IBR5', 244330),
(348037, 'PTHR47244', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE-PHOSPHATASE IBR5', 244330),
(348038, 'PTHR47244:SF4', NULL, NULL, NULL, NULL, 'BNAA07G04540D PROTEIN', 244330),
(348039, 'PTHR10948:SF23', NULL, NULL, NULL, NULL, 'TRANSPOSASE INSI FOR INSERTION SEQUENCE ELEMENT IS30A-RELATED', 244331),
(348040, 'PTHR10948', NULL, NULL, NULL, NULL, 'TRANSPOSASE', 244331),
(348041, 'PTHR21437', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244332),
(348042, 'PTHR21437:SF1', NULL, NULL, NULL, NULL, 'WIDE AWAKE', 244332),
(348043, 'PTHR21437:SF3', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND FIBRONECTIN TYPE-III DOMAIN-CONTAINING PROTEIN 1', 244332);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(348044, 'PTHR21437:SF2', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND FIBRONECTIN TYPE-III DOMAIN-CONTAINING PROTEIN 1-LIKE', 244332),
(348045, 'PTHR12967', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244333),
(348046, 'PTHR12967:SF0', NULL, NULL, NULL, NULL, 'PROTEIN SHQ1 HOMOLOG', 244333),
(348047, 'PTHR47591:SF9', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 244334),
(348048, 'PTHR47591', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZAT2-RELATED', 244334),
(348049, 'PTHR47591:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZAT2-RELATED', 244334),
(348050, 'PTHR47591:SF10', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZAT3-LIKE', 244334),
(348051, 'PTHR47591:SF4', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REGULATORY PROTEIN SNF2-LIKE', 244334),
(348052, 'PTHR47591:SF11', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 244334),
(348053, 'PTHR47591:SF5', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 244334),
(348054, 'PTHR47591:SF6', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 244334),
(348055, 'PTHR47591:SF7', NULL, NULL, NULL, NULL, 'C2H2-LIKE ZINC FINGER PROTEIN-RELATED', 244334),
(348056, 'PTHR33622:SF16', NULL, NULL, NULL, NULL, '', 244335),
(348057, 'PTHR33622:SF17', NULL, NULL, NULL, NULL, 'BNAA07G24460D PROTEIN', 244335),
(348058, 'PTHR33622:SF8', NULL, NULL, NULL, NULL, '', 244335),
(348059, 'PTHR33622:SF14', NULL, NULL, NULL, NULL, '', 244335),
(348060, 'PTHR33622:SF7', NULL, NULL, NULL, NULL, 'BNAA09G43010D PROTEIN', 244335),
(348061, 'PTHR33622:SF15', NULL, NULL, NULL, NULL, '', 244335),
(348062, 'PTHR33622:SF9', NULL, NULL, NULL, NULL, '', 244335),
(348063, 'PTHR33622:SF19', NULL, NULL, NULL, NULL, '', 244335),
(348064, 'PTHR33622:SF20', NULL, NULL, NULL, NULL, '', 244335),
(348065, 'PTHR33622:SF23', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244335),
(348066, 'PTHR33622:SF21', NULL, NULL, NULL, NULL, '', 244335),
(348067, 'PTHR33622:SF10', NULL, NULL, NULL, NULL, 'MARKER FOR OXIDATIVE STRESS RESPONSE PROTEIN', 244335),
(348068, 'PTHR33622:SF22', NULL, NULL, NULL, NULL, '', 244335),
(348069, 'PTHR33622:SF11', NULL, NULL, NULL, NULL, 'BNAA05G31660D PROTEIN', 244335),
(348070, 'PTHR33622', NULL, NULL, NULL, NULL, 'OS03G0724500 PROTEIN', 244335),
(348071, 'PTHR33622:SF1', NULL, NULL, NULL, NULL, '', 244335),
(348072, 'PTHR39193:SF1', NULL, NULL, NULL, NULL, '5-DEOXY-GLUCURONATE ISOMERASE', 244336),
(348073, 'PTHR39193', NULL, NULL, NULL, NULL, '5-DEOXY-GLUCURONATE ISOMERASE', 244336),
(348074, 'PTHR36541', NULL, NULL, NULL, NULL, 'SUPEROXIDE REDUCTASE-RELATED', 244337),
(348075, 'PTHR36541:SF1', NULL, NULL, NULL, NULL, 'SUPEROXIDE REDUCTASE-RELATED', 244337),
(348076, 'PTHR43034:SF2', NULL, NULL, NULL, NULL, 'ION-TRANSLOCATING OXIDOREDUCTASE COMPLEX SUBUNIT C', 244338),
(348077, 'PTHR43034', NULL, NULL, NULL, NULL, 'ION-TRANSLOCATING OXIDOREDUCTASE COMPLEX SUBUNIT C', 244338),
(348078, 'PTHR22605:SF21', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF213-BETA', 244339),
(348079, 'PTHR22605:SF9', NULL, NULL, NULL, NULL, '', 244339),
(348080, 'PTHR22605', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244339),
(348081, 'PTHR22605:SF18', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF213-ALPHA', 244339),
(348082, 'PTHR22605:SF16', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF213', 244339),
(348083, 'PTHR22605:SF24', NULL, NULL, NULL, NULL, '', 244339),
(348084, 'PTHR22605:SF25', NULL, NULL, NULL, NULL, 'AAA+ ATPASE, CORE DOMAIN-CONTAINING PROTEIN', 244339),
(348085, 'PTHR22605:SF1', NULL, NULL, NULL, NULL, '', 244339),
(348086, 'PTHR47925:SF75', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348087, 'PTHR47925:SF85', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348088, 'PTHR47925:SF84', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348089, 'PTHR47925:SF83', NULL, NULL, NULL, NULL, 'VEGETATIVE STORAGE PROTEIN', 244340),
(348090, 'PTHR47925:SF81', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(348091, 'PTHR47925:SF80', NULL, NULL, NULL, NULL, 'BNAA02G25460D PROTEIN', 244340),
(348092, 'PTHR47925:SF9', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 244340),
(348093, 'PTHR47925:SF8', NULL, NULL, NULL, NULL, '', 244340),
(348094, 'PTHR47925:SF7', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348095, 'PTHR47925:SF89', NULL, NULL, NULL, NULL, 'BNAA05G31840D PROTEIN', 244340),
(348096, 'PTHR47925:SF88', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348097, 'PTHR47925:SF3', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348098, 'PTHR47925:SF87', NULL, NULL, NULL, NULL, '', 244340),
(348099, 'PTHR47925:SF86', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 244340),
(348100, 'PTHR47925:SF160', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 244340),
(348101, 'PTHR47925:SF161', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN DOT4, CHLOROPLASTIC-LIKE', 244340),
(348102, 'PTHR47925:SF162', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348103, 'PTHR47925:SF163', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348104, 'PTHR47925:SF164', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 244340),
(348105, 'PTHR47925:SF165', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN DOT4, CHLOROPLASTIC-LIKE', 244340),
(348106, 'PTHR47925:SF166', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348107, 'PTHR47925:SF167', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348108, 'PTHR47925:SF168', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348109, 'PTHR47925:SF169', NULL, NULL, NULL, NULL, 'HEAT SHOCK FACTOR', 244340),
(348110, 'PTHR47925:SF1', NULL, NULL, NULL, NULL, '', 244340),
(348111, 'PTHR47925:SF95', NULL, NULL, NULL, NULL, '', 244340),
(348112, 'PTHR47925:SF94', NULL, NULL, NULL, NULL, '', 244340),
(348113, 'PTHR47925:SF92', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN, MITOCHONDRIAL', 244340),
(348114, 'PTHR47925:SF91', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 244340),
(348115, 'PTHR47925:SF90', NULL, NULL, NULL, NULL, '', 244340),
(348116, 'PTHR47925:SF15', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 244340),
(348117, 'PTHR47925:SF14', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348118, 'PTHR47925:SF12', NULL, NULL, NULL, NULL, '', 244340),
(348119, 'PTHR47925:SF11', NULL, NULL, NULL, NULL, '', 244340),
(348120, 'PTHR47925:SF99', NULL, NULL, NULL, NULL, 'BNAC05G04200D PROTEIN', 244340),
(348121, 'PTHR47925:SF10', NULL, NULL, NULL, NULL, '', 244340),
(348122, 'PTHR47925:SF150', NULL, NULL, NULL, NULL, 'PPPPR_98 PROTEIN', 244340),
(348123, 'PTHR47925:SF151', NULL, NULL, NULL, NULL, 'OS01G0913400 PROTEIN', 244340),
(348124, 'PTHR47925:SF152', NULL, NULL, NULL, NULL, 'SELENIUM-BINDING PROTEIN', 244340),
(348125, 'PTHR47925:SF153', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN, CHLOROPLASTIC', 244340),
(348126, 'PTHR47925:SF19', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 244340),
(348127, 'PTHR47925:SF154', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348128, 'PTHR47925:SF17', NULL, NULL, NULL, NULL, 'BNAA09G35950D PROTEIN', 244340),
(348129, 'PTHR47925:SF155', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 244340),
(348130, 'PTHR47925:SF156', NULL, NULL, NULL, NULL, 'BNAC04G43080D PROTEIN', 244340),
(348131, 'PTHR47925:SF157', NULL, NULL, NULL, NULL, 'BNAC09G42500D PROTEIN', 244340),
(348132, 'PTHR47925:SF158', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348133, 'PTHR47925:SF159', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348134, 'PTHR47925', NULL, NULL, NULL, NULL, 'OS01G0913400 PROTEIN-RELATED', 244340);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(348135, 'PTHR47925:SF26', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348136, 'PTHR47925:SF25', NULL, NULL, NULL, NULL, '', 244340),
(348137, 'PTHR47925:SF24', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348138, 'PTHR47925:SF22', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348139, 'PTHR47925:SF20', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 244340),
(348140, 'PTHR47925:SF141', NULL, NULL, NULL, NULL, '', 244340),
(348141, 'PTHR47925:SF142', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348142, 'PTHR47925:SF143', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 244340),
(348143, 'PTHR47925:SF29', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348144, 'PTHR47925:SF144', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348145, 'PTHR47925:SF28', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348146, 'PTHR47925:SF145', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348147, 'PTHR47925:SF146', NULL, NULL, NULL, NULL, '', 244340),
(348148, 'PTHR47925:SF147', NULL, NULL, NULL, NULL, '', 244340),
(348149, 'PTHR47925:SF148', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 244340),
(348150, 'PTHR47925:SF149', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348151, 'PTHR47925:SF38', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348152, 'PTHR47925:SF37', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN, MITOCHONDRIAL', 244340),
(348153, 'PTHR47925:SF36', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348154, 'PTHR47925:SF35', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 244340),
(348155, 'PTHR47925:SF34', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 244340),
(348156, 'PTHR47925:SF33', NULL, NULL, NULL, NULL, '', 244340),
(348157, 'PTHR47925:SF32', NULL, NULL, NULL, NULL, '', 244340),
(348158, 'PTHR47925:SF31', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348159, 'PTHR47925:SF132', NULL, NULL, NULL, NULL, 'BNAA09G20490D PROTEIN', 244340),
(348160, 'PTHR47925:SF134', NULL, NULL, NULL, NULL, 'BNACNNG30980D PROTEIN', 244340),
(348161, 'PTHR47925:SF41', NULL, NULL, NULL, NULL, '', 244340),
(348162, 'PTHR47925:SF40', NULL, NULL, NULL, NULL, '', 244340),
(348163, 'PTHR47925:SF48', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 244340),
(348164, 'PTHR47925:SF46', NULL, NULL, NULL, NULL, '', 244340),
(348165, 'PTHR47925:SF45', NULL, NULL, NULL, NULL, 'BNAA08G11890D PROTEIN', 244340),
(348166, 'PTHR47925:SF44', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT', 244340),
(348167, 'PTHR47925:SF122', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348168, 'PTHR47925:SF123', NULL, NULL, NULL, NULL, 'BNAC09G43810D PROTEIN', 244340),
(348169, 'PTHR47925:SF125', NULL, NULL, NULL, NULL, '', 244340),
(348170, 'PTHR47925:SF126', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN DOT4, CHLOROPLASTIC-LIKE', 244340),
(348171, 'PTHR47925:SF128', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 244340),
(348172, 'PTHR47925:SF129', NULL, NULL, NULL, NULL, 'BNAC06G00550D PROTEIN', 244340),
(348173, 'PTHR47925:SF58', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348174, 'PTHR47925:SF57', NULL, NULL, NULL, NULL, '', 244340),
(348175, 'PTHR47925:SF56', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 244340),
(348176, 'PTHR47925:SF55', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN, MITOCHONDRIAL', 244340),
(348177, 'PTHR47925:SF53', NULL, NULL, NULL, NULL, '', 244340),
(348178, 'PTHR47925:SF110', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN, MITOCHONDRIAL', 244340);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(348179, 'PTHR47925:SF111', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348180, 'PTHR47925:SF114', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN, CHLOROPLASTIC', 244340),
(348181, 'PTHR47925:SF115', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348182, 'PTHR47925:SF116', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 244340),
(348183, 'PTHR47925:SF117', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 244340),
(348184, 'PTHR47925:SF61', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348185, 'PTHR47925:SF60', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348186, 'PTHR47925:SF69', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 244340),
(348187, 'PTHR47925:SF68', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 244340),
(348188, 'PTHR47925:SF67', NULL, NULL, NULL, NULL, '', 244340),
(348189, 'PTHR47925:SF66', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN FTSH', 244340),
(348190, 'PTHR47925:SF101', NULL, NULL, NULL, NULL, '', 244340),
(348191, 'PTHR47925:SF103', NULL, NULL, NULL, NULL, '', 244340),
(348192, 'PTHR47925:SF104', NULL, NULL, NULL, NULL, '', 244340),
(348193, 'PTHR47925:SF105', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN, CHLOROPLASTIC', 244340),
(348194, 'PTHR47925:SF107', NULL, NULL, NULL, NULL, '', 244340),
(348195, 'PTHR47925:SF108', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348196, 'PTHR47925:SF73', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 244340),
(348197, 'PTHR47925:SF72', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348198, 'PTHR47925:SF70', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 244340),
(348199, 'PTHR42741:SF3', NULL, NULL, NULL, NULL, 'NITROREDUCTASE FAMILY PROTEIN', 244341),
(348200, 'PTHR42741', NULL, NULL, NULL, NULL, 'NITROREDUCTASE FAMILY PROTEIN', 244341),
(348201, 'PTHR41386', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN-RELATED', 244342),
(348202, 'PTHR41386:SF1', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 244342),
(348203, 'PTHR13278:SF0', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 830', 244343),
(348204, 'PTHR13278', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244343),
(348205, 'PTHR31216', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS BETA-1-RELATED-RELATED', 244344),
(348206, 'PTHR31216:SF0', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS BETA-11', 244344),
(348207, 'PTHR31216:SF1', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS BETA-3', 244344),
(348208, 'PTHR31216:SF10', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS BETA-7', 244344),
(348209, 'PTHR31216:SF4', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS BETA-12', 244344),
(348210, 'PTHR31216:SF5', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS BETA-13', 244344),
(348211, 'PTHR31216:SF12', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS BETA-1-RELATED', 244344),
(348212, 'PTHR31216:SF3', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS BETA-15-RELATED', 244344),
(348213, 'PTHR31216:SF11', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS BETA-16-RELATED', 244344),
(348214, 'PTHR31216:SF7', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS BETA-5', 244344),
(348215, 'PTHR44468', NULL, NULL, NULL, NULL, 'COXSACKIEVIRUS AND ADENOVIRUS RECEPTOR-RELATED', 244345),
(348216, 'PTHR44468:SF3', NULL, NULL, NULL, NULL, 'COXSACKIEVIRUS AND ADENOVIRUS RECEPTOR', 244345),
(348217, 'PTHR44468:SF4', NULL, NULL, NULL, NULL, 'CAR-LIKE SOLUBLE PROTEIN', 244345),
(348218, 'PTHR44468:SF1', NULL, NULL, NULL, NULL, 'V-SET AND IMMUNOGLOBULIN DOMAIN-CONTAINING 8A', 244345),
(348219, 'PTHR44468:SF2', NULL, NULL, NULL, NULL, 'V-SET AND IMMUNOGLOBULIN DOMAIN-CONTAINING 8B', 244345),
(348220, 'PTHR36194', NULL, NULL, NULL, NULL, 'S-LAYER-LIKE PROTEIN', 244346),
(348221, 'PTHR36194:SF1', NULL, NULL, NULL, NULL, 'PEGA DOMAIN-CONTAINING PROTEIN', 244346);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(348222, 'PTHR16276', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT DOMAIN-CONTAINING PROTEIN 3', 244347),
(348223, 'PTHR16276:SF1', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT DOMAIN-CONTAINING PROTEIN 3, MITOCHONDRIAL', 244347),
(348224, 'PTHR15869:SF0', NULL, NULL, NULL, NULL, 'ENDOMUCIN', 244348),
(348225, 'PTHR15869', NULL, NULL, NULL, NULL, 'ENDOMUCIN-RELATED', 244348),
(348226, 'PTHR36807', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCOLATE PHOSPHATASE', 244349),
(348227, 'PTHR36807:SF3', NULL, NULL, NULL, NULL, '', 244349),
(348228, 'PTHR36807:SF2', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCOLATE PHOSPHATASE', 244349),
(348229, 'PTHR46503', NULL, NULL, NULL, NULL, 'INTER-ALPHA-TRYPSIN INHIBITOR HEAVY CHAIN-LIKE PROTEIN', 244350),
(348230, 'PTHR46503:SF12', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 244350),
(348231, 'PTHR46503:SF9', NULL, NULL, NULL, NULL, 'INTER ALPHA-TRYPSIN INHIBITOR, HEAVY CHAIN-LIKE PROTEIN', 244350),
(348232, 'PTHR46503:SF10', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR, TYPE A-RELATED', 244350),
(348233, 'PTHR46503:SF8', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR, TYPE A-RELATED', 244350),
(348234, 'PTHR46503:SF6', NULL, NULL, NULL, NULL, 'INTER-ALPHA-TRYPSIN INHIBITOR HEAVY CHAIN-RELATED', 244350),
(348235, 'PTHR46503:SF1', NULL, NULL, NULL, NULL, 'INTER-ALPHA-TRYPSIN INHIBITOR HEAVY CHAIN-LIKE PROTEIN', 244350),
(348236, 'PTHR46503:SF17', NULL, NULL, NULL, NULL, 'INTER-ALPHA-TRYPSIN INHIBITOR HEAVY CHAIN-LIKE PROTEIN', 244350),
(348237, 'PTHR46503:SF16', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 244350),
(348238, 'PTHR46503:SF15', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 244350),
(348239, 'PTHR35518', NULL, NULL, NULL, NULL, 'MAINTENANCE OF TELOMOERE CAPPING', 244351),
(348240, 'PTHR35518:SF2', NULL, NULL, NULL, NULL, 'MAINTENANCE OF TELOMERE CAPPING PROTEIN 6', 244351),
(348241, 'PTHR35491:SF9', NULL, NULL, NULL, NULL, 'OS12G0638500-LIKE PROTEIN', 244352),
(348242, 'PTHR35491:SF12', NULL, NULL, NULL, NULL, 'OS12G0638500-LIKE PROTEIN', 244352),
(348243, 'PTHR35491:SF10', NULL, NULL, NULL, NULL, 'BNAA04G27700D PROTEIN', 244352),
(348244, 'PTHR35491', NULL, NULL, NULL, NULL, 'OS12G0638500-LIKE PROTEIN', 244352),
(348245, 'PTHR35491:SF7', NULL, NULL, NULL, NULL, 'DENTIN SIALOPHOSPHOPROTEIN-LIKE PROTEIN', 244352),
(348246, 'PTHR12587:SF18', NULL, NULL, NULL, NULL, 'LIPRIN-BETA-2', 244353),
(348247, 'PTHR12587:SF16', NULL, NULL, NULL, NULL, 'LIPRIN-BETA-1', 244353),
(348248, 'PTHR12587:SF15', NULL, NULL, NULL, NULL, 'LIPRIN-ALPHA-1', 244353),
(348249, 'PTHR12587:SF14', NULL, NULL, NULL, NULL, 'AT31531P', 244353),
(348250, 'PTHR12587:SF21', NULL, NULL, NULL, NULL, 'PPFIA-BINDING PROTEIN 1A', 244353),
(348251, 'PTHR12587:SF5', NULL, NULL, NULL, NULL, 'LIPRIN-ALPHA-4', 244353),
(348252, 'PTHR12587', NULL, NULL, NULL, NULL, 'LAR INTERACTING PROTEIN  LIP -RELATED PROTEIN', 244353),
(348253, 'PTHR12587:SF20', NULL, NULL, NULL, NULL, 'LIPRIN-ALPHA, ISOFORM E', 244353),
(348254, 'PTHR12587:SF4', NULL, NULL, NULL, NULL, 'LIPRIN-ALPHA-3', 244353),
(348255, 'PTHR12587:SF6', NULL, NULL, NULL, NULL, 'LIPRIN-ALPHA-2', 244353),
(348256, 'PTHR36326:SF22', NULL, NULL, NULL, NULL, 'PROTEIN SULFUR DEFICIENCY-INDUCED 1-LIKE', 244354),
(348257, 'PTHR36326:SF2', NULL, NULL, NULL, NULL, 'PROTEIN SULFUR DEFICIENCY-INDUCED 2', 244354),
(348258, 'PTHR36326:SF11', NULL, NULL, NULL, NULL, 'MALE STERILITY MS5 FAMILY PROTEIN', 244354),
(348259, 'PTHR36326:SF10', NULL, NULL, NULL, NULL, 'PROTEIN POLLENLESS 3', 244354),
(348260, 'PTHR36326:SF21', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 244354),
(348261, 'PTHR36326:SF20', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 244354),
(348262, 'PTHR36326:SF4', NULL, NULL, NULL, NULL, 'PROTEIN POLLENLESS 3-LIKE 1', 244354),
(348263, 'PTHR36326:SF18', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 244354),
(348264, 'PTHR36326:SF7', NULL, NULL, NULL, NULL, 'PROTEIN POLLENLESS 3-LIKE 2', 244354),
(348265, 'PTHR36326:SF16', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 244354);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(348266, 'PTHR36326', NULL, NULL, NULL, NULL, 'PROTEIN POLLENLESS 3-LIKE 2', 244354),
(348267, 'PTHR36326:SF14', NULL, NULL, NULL, NULL, 'PROTEIN SULFUR DEFICIENCY-INDUCED 1', 244354),
(348268, 'PTHR41729', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA SYNTHETASE', 244355),
(348269, 'PTHR41729:SF1', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA SYNTHETASE', 244355),
(348270, 'PTHR14499:SF140', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 244356),
(348271, 'PTHR14499:SF122', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN KCTD7', 244356),
(348272, 'PTHR14499:SF123', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL TETRAMERIZATION DOMAIN-CONTAINING PROTEIN', 244356),
(348273, 'PTHR14499:SF125', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 244356),
(348274, 'PTHR14499:SF128', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL TETRAMERIZATION DOMAIN CONTAINING 21', 244356),
(348275, 'PTHR14499:SF30', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL TETRAMERISATION DOMAIN-CONTAINING 12B', 244356),
(348276, 'PTHR14499:SF74', NULL, NULL, NULL, NULL, 'PROTEIN CBG04376', 244356),
(348277, 'PTHR14499:SF57', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN KCTD21', 244356),
(348278, 'PTHR14499:SF77', NULL, NULL, NULL, NULL, 'OS02G0612700 PROTEIN', 244356),
(348279, 'PTHR14499:SF10', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN KCTD6', 244356),
(348280, 'PTHR14499:SF131', NULL, NULL, NULL, NULL, 'VOLTAGE-GATED CHANNEL, PUTATIVE-RELATED', 244356),
(348281, 'PTHR14499:SF28', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN KCTD16', 244356),
(348282, 'PTHR14499:SF29', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN KCTD12', 244356),
(348283, 'PTHR14499:SF135', NULL, NULL, NULL, NULL, 'BTB_2 DOMAIN-CONTAINING PROTEIN', 244356),
(348284, 'PTHR14499:SF112', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL TETRAMERISATION DOMAIN CONTAINING 15', 244356),
(348285, 'PTHR14499:SF137', NULL, NULL, NULL, NULL, 'GH08630P', 244356),
(348286, 'PTHR14499:SF136', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 244356),
(348287, 'PTHR14499:SF139', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 244356),
(348288, 'PTHR14499:SF138', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 244356),
(348289, 'PTHR14499:SF116', NULL, NULL, NULL, NULL, 'OSJNBA0029H02.24 PROTEIN', 244356),
(348290, 'PTHR14499:SF119', NULL, NULL, NULL, NULL, 'BTB_2 DOMAIN-CONTAINING PROTEIN', 244356),
(348291, 'PTHR14499:SF118', NULL, NULL, NULL, NULL, 'BTB_2 DOMAIN-CONTAINING PROTEIN', 244356),
(348292, 'PTHR14499:SF80', NULL, NULL, NULL, NULL, '', 244356),
(348293, 'PTHR14499:SF4', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN KCTD18', 244356),
(348294, 'PTHR14499:SF27', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN KCTD15', 244356),
(348295, 'PTHR14499:SF5', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL REGULATORY PROTEIN', 244356),
(348296, 'PTHR14499:SF68', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN KCTD8', 244356),
(348297, 'PTHR14499:SF3', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN KCTD14', 244356),
(348298, 'PTHR14499', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL TETRAMERIZATION DOMAIN-CONTAINING', 244356),
(348299, 'PTHR14499:SF9', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN KCTD4', 244356),
(348300, 'PTHR14499:SF67', NULL, NULL, NULL, NULL, 'MIP18912P', 244356),
(348301, 'PTHR14499:SF20', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN KCTD19', 244356),
(348302, 'PTHR14499:SF7', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN KCTD11', 244356),
(348303, 'PTHR14499:SF65', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN KCTD1', 244356),
(348304, 'PTHR42842:SF3', NULL, NULL, NULL, NULL, 'FAD/NAD(P)-BINDING OXIDOREDUCTASE FAMILY PROTEIN', 244357),
(348305, 'PTHR42842', NULL, NULL, NULL, NULL, 'FAD/NAD(P)-BINDING OXIDOREDUCTASE', 244357),
(348306, 'PTHR47411:SF3', NULL, NULL, NULL, NULL, 'B3GNT1, BETA-1,3-N-ACETYLGUCOSAMINYLTRANSFERASE 1, HOMOLOG', 244358),
(348307, 'PTHR47411:SF2', NULL, NULL, NULL, NULL, 'B3GNT1, BETA-1,3-N-ACETYLGUCOSAMINYLTRANSFERASE 1, HOMOLOG', 244358);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(348308, 'PTHR47411', NULL, NULL, NULL, NULL, 'B3GNT1, BETA-1,3-N-ACETYLGUCOSAMINYLTRANSFERASE 1, HOMOLOG', 244358),
(348309, 'PTHR47411:SF1', NULL, NULL, NULL, NULL, 'B3GNT1, BETA-1,3-N-ACETYLGUCOSAMINYLTRANSFERASE 1, HOMOLOG', 244358),
(348310, 'PTHR42832:SF4', NULL, NULL, NULL, NULL, 'BLR3474 PROTEIN', 244359),
(348311, 'PTHR42832:SF2', NULL, NULL, NULL, NULL, 'ASPARTATE TRANSAMINASE', 244359),
(348312, 'PTHR42832:SF3', NULL, NULL, NULL, NULL, 'L-GLUTAMINE--4-(METHYLSULFANYL)-2-OXOBUTANOATE AMINOTRANSFERASE', 244359),
(348313, 'PTHR42832:SF1', NULL, NULL, NULL, NULL, 'GLUTAMATE-PYRUVATE AMINOTRANSFERASE ALAC', 244359),
(348314, 'PTHR42832', NULL, NULL, NULL, NULL, 'AMINO ACID AMINOTRANSFERASE', 244359),
(348315, 'PTHR19851:SF12', NULL, NULL, NULL, NULL, '', 244360),
(348316, 'PTHR19851:SF7', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 244360),
(348317, 'PTHR19851', NULL, NULL, NULL, NULL, 'OS02G0203500 PROTEIN', 244360),
(348318, 'PTHR33700:SF22', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 244361),
(348319, 'PTHR33700:SF4', NULL, NULL, NULL, NULL, 'MYB-LIKE PROTEIN X', 244361),
(348320, 'PTHR33700:SF25', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 244361),
(348321, 'PTHR33700', NULL, NULL, NULL, NULL, 'MYB-LIKE PROTEIN X', 244361),
(348322, 'PTHR33700:SF30', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 244361),
(348323, 'PTHR33700:SF27', NULL, NULL, NULL, NULL, 'BNAA04G13260D PROTEIN', 244361),
(348324, 'PTHR33700:SF26', NULL, NULL, NULL, NULL, '', 244361),
(348325, 'PTHR33700:SF3', NULL, NULL, NULL, NULL, 'OS06G0554300 PROTEIN', 244361),
(348326, 'PTHR33700:SF29', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 244361),
(348327, 'PTHR33700:SF18', NULL, NULL, NULL, NULL, 'BNAA09G42300D PROTEIN', 244361),
(348328, 'PTHR12961:SF2', NULL, NULL, NULL, NULL, 'COMPONENT OF OLIGOMERIC GOLGI COMPLEX 2', 244362),
(348329, 'PTHR12961:SF1', NULL, NULL, NULL, NULL, 'COMPONENT OF OLIGOMERIC GOLGI COMPLEX 2', 244362),
(348330, 'PTHR12961:SF0', NULL, NULL, NULL, NULL, 'CONSERVED OLIGOMERIC GOLGI COMPLEX SUBUNIT 2', 244362),
(348331, 'PTHR12961', NULL, NULL, NULL, NULL, 'CONSERVED OLIGOMERIC GOLGI COMPLEX COMPONENT 2', 244362),
(348332, 'PTHR15682', NULL, NULL, NULL, NULL, 'UNHEALTHY RIBOSOME BIOGENESIS PROTEIN 2 HOMOLOG', 244363),
(348333, 'PTHR15682:SF2', NULL, NULL, NULL, NULL, 'UNHEALTHY RIBOSOME BIOGENESIS PROTEIN 2 HOMOLOG', 244363),
(348334, 'PTHR15459', NULL, NULL, NULL, NULL, 'POLYAMINE-MODULATED FACTOR 1', 244364),
(348335, 'PTHR15459:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 DOMAIN-CONTAINING PROTEIN', 244364),
(348336, 'PTHR15459:SF3', NULL, NULL, NULL, NULL, 'POLYAMINE-MODULATED FACTOR 1', 244364),
(348337, 'PTHR15459:SF4', NULL, NULL, NULL, NULL, 'POLYAMINE-MODULATED FACTOR 1', 244364),
(348338, 'PTHR15459:SF5', NULL, NULL, NULL, NULL, 'POLYAMINE MODULATED FACTOR 1', 244364),
(348339, 'PTHR12876:SF35', NULL, NULL, NULL, NULL, 'LD08718P-RELATED', 244365),
(348340, 'PTHR12876:SF44', NULL, NULL, NULL, NULL, 'RNASE_ZC3H12A DOMAIN-CONTAINING PROTEIN', 244365),
(348341, 'PTHR12876:SF11', NULL, NULL, NULL, NULL, 'RIBONUCLEASE ZC3H12D-RELATED', 244365),
(348342, 'PTHR12876:SF10', NULL, NULL, NULL, NULL, 'ENDORIBONUCLEASE ZC3H12A', 244365),
(348343, 'PTHR12876:SF43', NULL, NULL, NULL, NULL, 'KH AND NYN DOMAIN-CONTAINING', 244365),
(348344, 'PTHR12876:SF42', NULL, NULL, NULL, NULL, 'C3H1-TYPE DOMAIN-CONTAINING PROTEIN', 244365),
(348345, 'PTHR12876:SF41', NULL, NULL, NULL, NULL, 'C3H1-TYPE DOMAIN-CONTAINING PROTEIN', 244365),
(348346, 'PTHR12876:SF40', NULL, NULL, NULL, NULL, 'RNASE_ZC3H12A DOMAIN-CONTAINING PROTEIN', 244365),
(348347, 'PTHR12876:SF28', NULL, NULL, NULL, NULL, 'PROTEIN KHNYN', 244365),
(348348, 'PTHR12876:SF27', NULL, NULL, NULL, NULL, 'RIBONUCLEASE ZC3H12B-RELATED', 244365),
(348349, 'PTHR12876:SF38', NULL, NULL, NULL, NULL, 'MIRP K CHANNEL ACCESSORY SUBUNIT', 244365),
(348350, 'PTHR12876:SF26', NULL, NULL, NULL, NULL, 'NEDD4-BINDING PROTEIN 1', 244365),
(348351, 'PTHR12876:SF37', NULL, NULL, NULL, NULL, 'ENDORIBONUCLEASE REGE-1-RELATED', 244365);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(348352, 'PTHR12876:SF36', NULL, NULL, NULL, NULL, 'RIBONUCLEASE ZC3H12C-RELATED', 244365),
(348353, 'PTHR12876', NULL, NULL, NULL, NULL, 'N4BP1-RELATED', 244365),
(348354, 'PTHR12876:SF2', NULL, NULL, NULL, NULL, 'PROTEIN NYNRIN', 244365),
(348355, 'PTHR35507', NULL, NULL, NULL, NULL, 'OS09G0488600 PROTEIN', 244366),
(348356, 'PTHR35507:SF1', NULL, NULL, NULL, NULL, 'OS09G0488600 PROTEIN', 244366),
(348357, 'PTHR46030', NULL, NULL, NULL, NULL, 'ALPHA-KETOGLUTARATE-DEPENDENT DIOXYGENASE ALKB HOMOLOG 6', 244367),
(348358, 'PTHR46030:SF1', NULL, NULL, NULL, NULL, 'ALPHA-KETOGLUTARATE-DEPENDENT DIOXYGENASE ALKB HOMOLOG 6', 244367),
(348359, 'PTHR31504', NULL, NULL, NULL, NULL, 'ZW10 INTERACTOR ZWINT', 244368),
(348360, 'PTHR31504:SF1', NULL, NULL, NULL, NULL, 'ZW10 INTERACTOR', 244368),
(348361, 'PTHR11048:SF5', NULL, NULL, NULL, NULL, 'DECAPRENYL-PHOSPHATE PHOSPHORIBOSYLTRANSFERASE', 244369),
(348362, 'PTHR11048:SF40', NULL, NULL, NULL, NULL, '4-HYDROXYBENZOATE POLYPRENYLTRANSFERASE, MITOCHONDRIAL-LIKE ISOFORM X1', 244369),
(348363, 'PTHR11048:SF41', NULL, NULL, NULL, NULL, '4-HYDROXYBENZOATE POLYPRENYLTRANSFERASE, MITOCHONDRIAL', 244369),
(348364, 'PTHR11048:SF42', NULL, NULL, NULL, NULL, 'DNA (CYTOSINE-5)-METHYLTRANSFERASE', 244369),
(348365, 'PTHR11048', NULL, NULL, NULL, NULL, 'PRENYLTRANSFERASES', 244369),
(348366, 'PTHR11048:SF39', NULL, NULL, NULL, NULL, 'POLYPRENYL TRANSFERASE AUSN', 244369),
(348367, 'PTHR11048:SF28', NULL, NULL, NULL, NULL, '4-HYDROXYBENZOATE POLYPRENYLTRANSFERASE, MITOCHONDRIAL', 244369),
(348368, 'PTHR45666:SF24', NULL, NULL, NULL, NULL, 'OS09G0394600 PROTEIN', 244370),
(348369, 'PTHR45666:SF46', NULL, NULL, NULL, NULL, 'IPPC DOMAIN-CONTAINING PROTEIN', 244370),
(348370, 'PTHR45666:SF25', NULL, NULL, NULL, NULL, 'TYPE I INOSITOL POLYPHOSPHATE 5-PHOSPHATASE 2-LIKE ISOFORM X1', 244370),
(348371, 'PTHR45666:SF47', NULL, NULL, NULL, NULL, 'IPPC DOMAIN-CONTAINING PROTEIN', 244370),
(348372, 'PTHR45666:SF48', NULL, NULL, NULL, NULL, 'ENDONUCLEASE/EXONUCLEASE/PHOSPHATASE-RELATED', 244370),
(348373, 'PTHR45666:SF49', NULL, NULL, NULL, NULL, 'IPPC DOMAIN-CONTAINING PROTEIN', 244370),
(348374, 'PTHR45666:SF29', NULL, NULL, NULL, NULL, 'INOSITOL POLYPHOSPHATE PHOSPHATASE (SYNAPTOGENIN-LIKE) FAMILY PROTEIN-RELATED', 244370),
(348375, 'PTHR45666:SF60', NULL, NULL, NULL, NULL, 'ENDONUCLEASE/EXONUCLEASE/PHOSPHATASE-RELATED', 244370),
(348376, 'PTHR45666:SF40', NULL, NULL, NULL, NULL, 'DNASE I-LIKE SUPERFAMILY PROTEIN-RELATED', 244370),
(348377, 'PTHR45666:SF20', NULL, NULL, NULL, NULL, 'TYPE I INOSITOL POLYPHOSPHATE 5-PHOSPHATASE 10', 244370),
(348378, 'PTHR45666:SF42', NULL, NULL, NULL, NULL, 'IPPC DOMAIN-CONTAINING PROTEIN', 244370),
(348379, 'PTHR45666:SF21', NULL, NULL, NULL, NULL, 'TYPE I INOSITOL POLYPHOSPHATE 5-PHOSPHATASE 2', 244370),
(348380, 'PTHR45666:SF22', NULL, NULL, NULL, NULL, 'TYPE I INOSITOL POLYPHOSPHATE 5-PHOSPHATASE 4', 244370),
(348381, 'PTHR45666:SF23', NULL, NULL, NULL, NULL, 'PHOSPHORIC MONOESTER HYDROLASE-RELATED', 244370),
(348382, 'PTHR45666:SF57', NULL, NULL, NULL, NULL, 'INOSITOL POLYPHOSPHATE PHOSPHATASE (SYNAPTOGENIN-LIKE) FAMILY PROTEIN-RELATED', 244370),
(348383, 'PTHR45666:SF35', NULL, NULL, NULL, NULL, 'TYPE IV INOSITOL POLYPHOSPHATE 5-PHOSPHATASE 6', 244370),
(348384, 'PTHR45666:SF58', NULL, NULL, NULL, NULL, 'TYPE IV INOSITOL POLYPHOSPHATE 5-PHOSPHATASE 7-LIKE', 244370),
(348385, 'PTHR45666:SF14', NULL, NULL, NULL, NULL, 'OS01G0183300 PROTEIN', 244370),
(348386, 'PTHR45666:SF59', NULL, NULL, NULL, NULL, 'TYPE IV INOSITOL POLYPHOSPHATE 5-PHOSPHATASE 9-LIKE ISOFORM X1', 244370),
(348387, 'PTHR45666:SF15', NULL, NULL, NULL, NULL, 'TYPE I INOSITOL POLYPHOSPHATE 5-PHOSPHATASE 8', 244370),
(348388, 'PTHR45666:SF18', NULL, NULL, NULL, NULL, 'TYPE IV INOSITOL POLYPHOSPHATE 5-PHOSPHATASE 9', 244370),
(348389, 'PTHR45666:SF19', NULL, NULL, NULL, NULL, 'OS06G0222900 PROTEIN', 244370),
(348390, 'PTHR45666:SF2', NULL, NULL, NULL, NULL, 'OS10G0422500 PROTEIN', 244370),
(348391, 'PTHR45666:SF3', NULL, NULL, NULL, NULL, 'TYPE I INOSITOL POLYPHOSPHATE 5-PHOSPHATASE 5', 244370);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(348392, 'PTHR45666:SF50', NULL, NULL, NULL, NULL, 'IPPC DOMAIN-CONTAINING PROTEIN', 244370),
(348393, 'PTHR45666:SF51', NULL, NULL, NULL, NULL, 'IPPC DOMAIN-CONTAINING PROTEIN', 244370),
(348394, 'PTHR45666:SF5', NULL, NULL, NULL, NULL, 'TYPE IV INOSITOL POLYPHOSPHATE 5-PHOSPHATASE 3', 244370),
(348395, 'PTHR45666:SF30', NULL, NULL, NULL, NULL, 'TYPE I INOSITOL POLYPHOSPHATE 5-PHOSPHATASE 1', 244370),
(348396, 'PTHR45666:SF52', NULL, NULL, NULL, NULL, 'IPPC DOMAIN-CONTAINING PROTEIN', 244370),
(348397, 'PTHR45666:SF32', NULL, NULL, NULL, NULL, 'TYPE IV INOSITOL POLYPHOSPHATE 5-PHOSPHATASE 7-LIKE', 244370),
(348398, 'PTHR45666:SF10', NULL, NULL, NULL, NULL, 'OS05G0489000 PROTEIN', 244370),
(348399, 'PTHR45666:SF11', NULL, NULL, NULL, NULL, 'OS08G0425500 PROTEIN', 244370),
(348400, 'PTHR45666:SF33', NULL, NULL, NULL, NULL, 'TYPE I INOSITOL-1,4,5-TRISPHOSPHATE 5-PHOSPHATASE', 244370),
(348401, 'PTHR45666', NULL, NULL, NULL, NULL, 'TYPE IV INOSITOL POLYPHOSPHATE 5-PHOSPHATASE 9', 244370),
(348402, 'PTHR45666:SF56', NULL, NULL, NULL, NULL, 'OS03G0160600 PROTEIN', 244370),
(348403, 'PTHR45666:SF34', NULL, NULL, NULL, NULL, 'TYPE IV INOSITOL POLYPHOSPHATE 5-PHOSPHATASE 7', 244370),
(348404, 'PTHR45666:SF12', NULL, NULL, NULL, NULL, 'TYPE I INOSITOL-1,4,5-TRISPHOSPHATE 5-PHOSPHATASE', 244370),
(348405, 'PTHR45666:SF7', NULL, NULL, NULL, NULL, 'IPPC DOMAIN-CONTAINING PROTEIN', 244370),
(348406, 'PTHR45666:SF8', NULL, NULL, NULL, NULL, 'OS03G0793600 PROTEIN', 244370),
(348407, 'PTHR45666:SF9', NULL, NULL, NULL, NULL, 'INOSITOL POLYPHOSPHATE PHOSPHATASE (SYNAPTOGENIN-LIKE) FAMILY PROTEIN-RELATED', 244370),
(348408, 'PTHR31678', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 6-3', 244371),
(348409, 'PTHR31678:SF6', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 6-3', 244371),
(348410, 'PTHR31678:SF2', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 6-1', 244371),
(348411, 'PTHR31678:SF3', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 6-2', 244371),
(348412, 'PTHR30347', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL RELATED', 244372),
(348413, 'PTHR30347:SF1', NULL, NULL, NULL, NULL, 'MINICONDUCTANCE MECHANOSENSITIVE CHANNEL MSCM', 244372),
(348414, 'PTHR30347:SF8', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE CHANNEL MSCK', 244372),
(348415, 'PTHR43397:SF2', NULL, NULL, NULL, NULL, 'METHYLTRANSF_33 DOMAIN-CONTAINING PROTEIN', 244373),
(348416, 'PTHR43397:SF1', NULL, NULL, NULL, NULL, 'ERGOTHIONEINE BIOSYNTHESIS PROTEIN 1', 244373),
(348417, 'PTHR43397', NULL, NULL, NULL, NULL, 'ERGOTHIONEINE BIOSYNTHESIS PROTEIN 1', 244373),
(348418, 'PTHR22949:SF0', NULL, NULL, NULL, NULL, 'RE27538P', 244374),
(348419, 'PTHR22949', NULL, NULL, NULL, NULL, 'WHITE COLLAR 2 PROTEIN  WC2', 244374),
(348420, 'PTHR47552:SF1', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLFORMYLGLYCINAMIDINE SYNTHASE SUBUNIT PURQ', 244375),
(348421, 'PTHR47552', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLFORMYLGLYCINAMIDINE SYNTHASE SUBUNIT PURQ', 244375),
(348422, 'PTHR36011', NULL, NULL, NULL, NULL, 'BAT2 DOMAIN PROTEIN', 244376),
(348423, 'PTHR36011:SF2', NULL, NULL, NULL, NULL, '', 244376),
(348424, 'PTHR36011:SF1', NULL, NULL, NULL, NULL, 'BAT2 DOMAIN PROTEIN', 244376),
(348425, 'PTHR21053:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR, MITOCHONDRIAL', 244377),
(348426, 'PTHR21053', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244377),
(348427, 'PTHR45667:SF7', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL MAGNESIUM EXPORTER 1', 244378),
(348428, 'PTHR45667', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE MITOCHONDRIAL CARRIER PROTEIN', 244378),
(348429, 'PTHR45667:SF8', NULL, NULL, NULL, NULL, 'PROTEIN MITOFERRINLIKE 1, CHLOROPLASTIC', 244378),
(348430, 'PTHR45667:SF5', NULL, NULL, NULL, NULL, 'CARRIER PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G09980)-RELATED', 244378),
(348431, 'PTHR45667:SF6', NULL, NULL, NULL, NULL, 'OS07G0295000 PROTEIN', 244378),
(348432, 'PTHR45667:SF9', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE MITOCHONDRIAL CARRIER PROTEIN', 244378),
(348433, 'PTHR45667:SF19', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN', 244378);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(348434, 'PTHR45667:SF29', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN', 244378),
(348435, 'PTHR45667:SF18', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN', 244378),
(348436, 'PTHR45667:SF25', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 244378),
(348437, 'PTHR45667:SF28', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN', 244378),
(348438, 'PTHR45667:SF17', NULL, NULL, NULL, NULL, '', 244378),
(348439, 'PTHR45667:SF27', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CARRIER PROTEIN', 244378),
(348440, 'PTHR45667:SF11', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN', 244378),
(348441, 'PTHR45667:SF32', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE CARRIER 2, CHLOROPLASTIC-RELATED', 244378),
(348442, 'PTHR45667:SF20', NULL, NULL, NULL, NULL, 'BNAA04G20810D PROTEIN', 244378),
(348443, 'PTHR45667:SF31', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CARRIER PROTEIN', 244378),
(348444, 'PTHR45667:SF30', NULL, NULL, NULL, NULL, 'TRICARBOXYLATE TRANSPORTER', 244378),
(348445, 'PTHR12764:SF4', NULL, NULL, NULL, NULL, 'INTRAFLAGELLAR TRANSPORT PROTEIN 122 HOMOLOG', 244379),
(348446, 'PTHR12764:SF5', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 55 HOMOLOG', 244379),
(348447, 'PTHR12764', NULL, NULL, NULL, NULL, 'WD REPEAT DOMAIN-RELATED', 244379),
(348448, 'PTHR35901:SF1', NULL, NULL, NULL, NULL, 'EXONUCLEASE VAPC9', 244380),
(348449, 'PTHR35901', NULL, NULL, NULL, NULL, 'RIBONUCLEASE VAPC3', 244380),
(348450, 'PTHR35901:SF3', NULL, NULL, NULL, NULL, 'SLL1225 PROTEIN', 244380),
(348451, 'PTHR43063:SF1', NULL, NULL, NULL, NULL, '4FE-4S CLUSTER CONTAINING PARA FAMILY ATPASE PROTEIN', 244381),
(348452, 'PTHR43063', NULL, NULL, NULL, NULL, '4FE-4S CLUSTER CONTAINING PARA FAMILY ATPASE PROTEIN', 244381),
(348453, 'PTHR43201:SF28', NULL, NULL, NULL, NULL, 'ENZYME, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G01530)-RELATED', 244382),
(348454, 'PTHR43201:SF27', NULL, NULL, NULL, NULL, 'AMP DEPENDENT COA LIGASE', 244382),
(348455, 'PTHR43201:SF13', NULL, NULL, NULL, NULL, 'LONG-CHAIN-FATTY-ACID--COA LIGASE', 244382),
(348456, 'PTHR43201:SF24', NULL, NULL, NULL, NULL, 'FATTY ACID COA SYNTHETASE FAMILY', 244382),
(348457, 'PTHR43201:SF12', NULL, NULL, NULL, NULL, 'AMP-BINDING DOMAIN-CONTAINING PROTEIN', 244382),
(348458, 'PTHR43201:SF26', NULL, NULL, NULL, NULL, 'BNAC05G37220D PROTEIN', 244382),
(348459, 'PTHR43201:SF15', NULL, NULL, NULL, NULL, 'AMP BINDING ENZYME, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G11340)-RELATED', 244382),
(348460, 'PTHR43201:SF25', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE', 244382),
(348461, 'PTHR43201:SF20', NULL, NULL, NULL, NULL, 'MALONATE--COA LIGASE-LIKE', 244382),
(348462, 'PTHR43201:SF3', NULL, NULL, NULL, NULL, 'ENZYME, PUTATIVE (JCVI)-RELATED', 244382),
(348463, 'PTHR43201:SF11', NULL, NULL, NULL, NULL, 'ENZYME, PUTATIVE (JCVI)-RELATED', 244382),
(348464, 'PTHR43201:SF6', NULL, NULL, NULL, NULL, 'ACYL COA SYNTHETASE (EUROFUNG)', 244382),
(348465, 'PTHR43201:SF5', NULL, NULL, NULL, NULL, 'OXALATE--COA LIGASE', 244382),
(348466, 'PTHR43201:SF10', NULL, NULL, NULL, NULL, 'MANNOSE-1-PHOSPHATE GUANYLYLTRANSFERASE', 244382),
(348467, 'PTHR43201', NULL, NULL, NULL, NULL, 'ACYL-COA SYNTHETASE', 244382),
(348468, 'PTHR43201:SF8', NULL, NULL, NULL, NULL, 'FATTY ACID COA SYNTHETASE FAMILY', 244382),
(348469, 'PTHR43201:SF9', NULL, NULL, NULL, NULL, 'MEDIUM-CHAIN ACYL-COA LIGASE ACSF2, MITOCHONDRIAL', 244382),
(348470, 'PTHR36407', NULL, NULL, NULL, NULL, 'MEDIATOR-ASSOCIATED PROTEIN 2', 244383),
(348471, 'PTHR36407:SF2', NULL, NULL, NULL, NULL, '', 244383),
(348472, 'PTHR36407:SF1', NULL, NULL, NULL, NULL, 'MEDIATOR-ASSOCIATED PROTEIN 2', 244383),
(348473, 'PTHR43834:SF2', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN ENGA', 244384),
(348474, 'PTHR43834', NULL, NULL, NULL, NULL, 'GTPASE DER', 244384),
(348475, 'PTHR43834:SF6', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN ENGA', 244384),
(348476, 'PTHR43834:SF5', NULL, NULL, NULL, NULL, 'G DOMAIN-CONTAINING PROTEIN', 244384),
(348477, 'PTHR37563:SF2', NULL, NULL, NULL, NULL, 'PHYTANOYL-COA DIOXYGENASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_2G03330)', 244385);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(348478, 'PTHR37563:SF8', NULL, NULL, NULL, NULL, '', 244385),
(348479, 'PTHR37563', NULL, NULL, NULL, NULL, 'PHYTANOYL-COA DIOXYGENASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_2G03330)', 244385),
(348480, 'PTHR36335:SF2', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 244386),
(348481, 'PTHR36335:SF1', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', 244386),
(348482, 'PTHR36335:SF3', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 244386),
(348483, 'PTHR36335', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', 244386),
(348484, 'PTHR35537', NULL, NULL, NULL, NULL, 'DNA DAMAGE-INDUCIBLE APOPTOSIS SUPPRESSOR PROTEIN DDIAS', 244387),
(348485, 'PTHR35537:SF1', NULL, NULL, NULL, NULL, 'DNA DAMAGE-INDUCED APOPTOSIS SUPPRESSOR PROTEIN', 244387),
(348486, 'PTHR35674', NULL, NULL, NULL, NULL, 'CDNA SEQUENCE CK137956', 244388),
(348487, 'PTHR35674:SF1', NULL, NULL, NULL, NULL, 'CDNA SEQUENCE CK137956', 244388),
(348488, 'PTHR34130', NULL, NULL, NULL, NULL, 'OS08G0243800 PROTEIN', 244389),
(348489, 'PTHR34130:SF13', NULL, NULL, NULL, NULL, '', 244389),
(348490, 'PTHR34130:SF8', NULL, NULL, NULL, NULL, '', 244389),
(348491, 'PTHR34130:SF10', NULL, NULL, NULL, NULL, '', 244389),
(348492, 'PTHR34130:SF3', NULL, NULL, NULL, NULL, 'BNAA03G50030D PROTEIN', 244389),
(348493, 'PTHR34130:SF12', NULL, NULL, NULL, NULL, 'BNAA01G06790D PROTEIN', 244389),
(348494, 'PTHR34130:SF5', NULL, NULL, NULL, NULL, 'OS08G0243800 PROTEIN', 244389),
(348495, 'PTHR33618:SF1', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L53, MITOCHONDRIAL', 244390),
(348496, 'PTHR33618', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L53, MITOCHONDRIAL', 244390),
(348497, 'PTHR47392', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 82-RELATED', 244391),
(348498, 'PTHR47392:SF1', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 82-RELATED', 244391),
(348499, 'PTHR47030', NULL, NULL, NULL, NULL, 'LIPASE CLASS 3 FAMILY PROTEIN', 244392),
(348500, 'PTHR47030:SF3', NULL, NULL, NULL, NULL, 'OS04G0489100 PROTEIN', 244392),
(348501, 'PTHR47030:SF2', NULL, NULL, NULL, NULL, 'LIPASE CLASS 3 FAMILY PROTEIN', 244392),
(348502, 'PTHR43523:SF14', NULL, NULL, NULL, NULL, 'GLUCOSE-1-PHOSPHATE ADENYLYLTRANSFERASE LARGE SUBUNIT, CHLOROPLASTIC-RELATED', 244393),
(348503, 'PTHR43523:SF25', NULL, NULL, NULL, NULL, 'GLUCOSE-1-PHOSPHATE ADENYLYLTRANSFERASE', 244393),
(348504, 'PTHR43523:SF24', NULL, NULL, NULL, NULL, 'GLUCOSE-1-PHOSPHATE ADENYLYLTRANSFERASE', 244393),
(348505, 'PTHR43523', NULL, NULL, NULL, NULL, 'GLUCOSE-1-PHOSPHATE ADENYLYLTRANSFERASE-RELATED', 244393),
(348506, 'PTHR43523:SF12', NULL, NULL, NULL, NULL, 'GLUCOSE-1-PHOSPHATE ADENYLYLTRANSFERASE LARGE SUBUNIT 1, CHLOROPLASTIC-RELATED', 244393),
(348507, 'PTHR43523:SF22', NULL, NULL, NULL, NULL, 'GLUCOSE-1-PHOSPHATE ADENYLYLTRANSFERASE', 244393),
(348508, 'PTHR43523:SF21', NULL, NULL, NULL, NULL, 'GLUCOSE-1-PHOSPHATE ADENYLYLTRANSFERASE', 244393),
(348509, 'PTHR43523:SF19', NULL, NULL, NULL, NULL, 'GLUCOSE-1-PHOSPHATE ADENYLYLTRANSFERASE', 244393),
(348510, 'PTHR43523:SF6', NULL, NULL, NULL, NULL, 'GLYCOGEN BIOSYNTHESIS PROTEIN GLGD', 244393),
(348511, 'PTHR43523:SF7', NULL, NULL, NULL, NULL, 'GLUCOSE-1-PHOSPHATE ADENYLYLTRANSFERASE SMALL SUBUNIT 1, CHLOROPLASTIC/AMYLOPLASTIC', 244393),
(348512, 'PTHR43523:SF17', NULL, NULL, NULL, NULL, 'INACTIVE GLUCOSE-1-PHOSPHATE ADENYLYLTRANSFERASE SMALL SUBUNIT 2, CHLOROPLASTIC', 244393),
(348513, 'PTHR43523:SF4', NULL, NULL, NULL, NULL, 'GLUCOSE-1-PHOSPHATE ADENYLYLTRANSFERASE LARGE SUBUNIT 3, CHLOROPLASTIC', 244393),
(348514, 'PTHR43523:SF27', NULL, NULL, NULL, NULL, 'NTP_TRANSFERASE DOMAIN-CONTAINING PROTEIN', 244393),
(348515, 'PTHR43523:SF15', NULL, NULL, NULL, NULL, 'GLUCOSE-1-PHOSPHATE ADENYLYLTRANSFERASE LARGE SUBUNIT 4, CHLOROPLASTIC/AMYLOPLASTIC', 244393),
(348516, 'PTHR43523:SF2', NULL, NULL, NULL, NULL, 'GLUCOSE-1-PHOSPHATE ADENYLYLTRANSFERASE', 244393),
(348517, 'PTHR43523:SF1', NULL, NULL, NULL, NULL, 'GLUCOSE-1-PHOSPHATE ADENYLYLTRANSFERASE LARGE SUBUNIT 2, CYTOSOLIC', 244393),
(348518, 'PTHR34988', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 244394);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(348519, 'PTHR34988:SF1', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 244394),
(348520, 'PTHR35825', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT ALPHA PRIME-INTERACTING PROTEIN', 244395),
(348521, 'PTHR35825:SF2', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT ALPHA''-INTERACTING PROTEIN', 244395),
(348522, 'PTHR22897:SF6', NULL, NULL, NULL, NULL, 'SULFHYDRYL OXIDASE 1', 244396),
(348523, 'PTHR22897:SF20', NULL, NULL, NULL, NULL, 'SULFHYDRYL OXIDASE', 244396),
(348524, 'PTHR22897:SF8', NULL, NULL, NULL, NULL, 'SULFHYDRYL OXIDASE', 244396),
(348525, 'PTHR22897:SF7', NULL, NULL, NULL, NULL, 'SULFHYDRYL OXIDASE 2', 244396),
(348526, 'PTHR22897', NULL, NULL, NULL, NULL, 'QUIESCIN Q6-RELATED SULFHYDRYL OXIDASE', 244396),
(348527, 'PTHR22897:SF23', NULL, NULL, NULL, NULL, 'SULFHYDRYL OXIDASE', 244396),
(348528, 'PTHR22897:SF24', NULL, NULL, NULL, NULL, 'SULFHYDRYL OXIDASE', 244396),
(348529, 'PTHR22897:SF21', NULL, NULL, NULL, NULL, 'SULFHYDRYL OXIDASE 1', 244396),
(348530, 'PTHR22897:SF22', NULL, NULL, NULL, NULL, 'SULFHYDRYL OXIDASE', 244396),
(348531, 'PTHR22897:SF26', NULL, NULL, NULL, NULL, 'SULFHYDRYL OXIDASE', 244396),
(348532, 'PTHR39610:SF2', NULL, NULL, NULL, NULL, '', 244397),
(348533, 'PTHR39610:SF1', NULL, NULL, NULL, NULL, '', 244397),
(348534, 'PTHR39610', NULL, NULL, NULL, NULL, '', 244397),
(348535, 'PTHR34856', NULL, NULL, NULL, NULL, 'PROTEIN NRFD', 244398),
(348536, 'PTHR34856:SF2', NULL, NULL, NULL, NULL, 'PROTEIN NRFD', 244398),
(348537, 'PTHR14689:SF0', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 82', 244399),
(348538, 'PTHR14689:SF2', NULL, NULL, NULL, NULL, 'PHORBOL-ESTER/DAG-TYPE DOMAIN-CONTAINING PROTEIN', 244399),
(348539, 'PTHR14689', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244399),
(348540, 'PTHR44914:SF1', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ 13', 244400),
(348541, 'PTHR44914', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ 13', 244400),
(348542, 'PTHR19860:SF42', NULL, NULL, NULL, NULL, 'DUF4062 DOMAIN-CONTAINING PROTEIN', 244401),
(348543, 'PTHR19860:SF41', NULL, NULL, NULL, NULL, '', 244401),
(348544, 'PTHR19860:SF40', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 244401),
(348545, 'PTHR19860:SF24', NULL, NULL, NULL, NULL, 'TPR REPEAT-CONTAINING PROTEIN DDB_G0287407', 244401),
(348546, 'PTHR19860:SF35', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 12-LIKE PROTEIN 1', 244401),
(348547, 'PTHR19860:SF10', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 12', 244401),
(348548, 'PTHR19860:SF8', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 12-LIKE PROTEIN 2', 244401),
(348549, 'PTHR19860:SF39', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 12-LIKE PROTEIN 1', 244401),
(348550, 'PTHR19860:SF17', NULL, NULL, NULL, NULL, 'FBA DOMAIN-CONTAINING PROTEIN', 244401),
(348551, 'PTHR19860:SF16', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 12', 244401),
(348552, 'PTHR19860:SF14', NULL, NULL, NULL, NULL, 'PROTEIN CBG01633', 244401),
(348553, 'PTHR19860:SF18', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT DOMAIN 41', 244401),
(348554, 'PTHR19860', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 12-RELATED', 244401),
(348555, 'PTHR28034', NULL, NULL, NULL, NULL, 'SET1 COMPLEX COMPONENT SHG1', 244402),
(348556, 'PTHR28034:SF2', NULL, NULL, NULL, NULL, 'ARGININE RICH PROTEIN', 244402),
(348557, 'PTHR28034:SF1', NULL, NULL, NULL, NULL, 'NUCLEOMORPHIN', 244402),
(348558, 'PTHR12631:SF6', NULL, NULL, NULL, NULL, '', 244403),
(348559, 'PTHR12631:SF10', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_42 DOMAIN-CONTAINING PROTEIN', 244403),
(348560, 'PTHR12631', NULL, NULL, NULL, NULL, 'ALPHA-L-IDURONIDASE', 244403),
(348561, 'PTHR12631:SF11', NULL, NULL, NULL, NULL, 'CELLULASE DOMAIN-CONTAINING PROTEIN', 244403),
(348562, 'PTHR12631:SF8', NULL, NULL, NULL, NULL, 'ALPHA-L-IDURONIDASE', 244403),
(348563, 'PTHR28004:SF2', NULL, NULL, NULL, NULL, 'ZGC:162816', 244404),
(348564, 'PTHR28004:SF8', NULL, NULL, NULL, NULL, 'D-SERINE DEAMINASE', 244404),
(348565, 'PTHR28004', NULL, NULL, NULL, NULL, 'ZGC:162816-RELATED', 244404);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(348566, 'PTHR31138', NULL, NULL, NULL, NULL, 'CHROMOSOME 19, WHOLE GENOME SHOTGUN SEQUENCE', 244405),
(348567, 'PTHR31138:SF1', NULL, NULL, NULL, NULL, 'FUNGAL PROTEIN', 244405),
(348568, 'PTHR31138:SF4', NULL, NULL, NULL, NULL, '', 244405),
(348569, 'PTHR31138:SF11', NULL, NULL, NULL, NULL, '', 244405),
(348570, 'PTHR31138:SF9', NULL, NULL, NULL, NULL, 'BPI1 DOMAIN-CONTAINING PROTEIN', 244405),
(348571, 'PTHR15011', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN F', 244406),
(348572, 'PTHR15011:SF1', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN N', 244406),
(348573, 'PTHR15011:SF3', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN F', 244406),
(348574, 'PTHR13091', NULL, NULL, NULL, NULL, 'AMPLIFIED IN BREAST CANCER 2-RELATED', 244407),
(348575, 'PTHR13091:SF0', NULL, NULL, NULL, NULL, 'PROTEIN SMG8', 244407),
(348576, 'PTHR14087', NULL, NULL, NULL, NULL, 'THYMOCYTE NUCLEAR PROTEIN 1', 244408),
(348577, 'PTHR14087:SF7', NULL, NULL, NULL, NULL, 'THYMOCYTE NUCLEAR PROTEIN 1', 244408),
(348578, 'PTHR14087:SF8', NULL, NULL, NULL, NULL, 'OS03G0676100 PROTEIN', 244408),
(348579, 'PTHR37184:SF2', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 43', 244409),
(348580, 'PTHR37184', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 27', 244409),
(348581, 'PTHR37184:SF5', NULL, NULL, NULL, NULL, 'BNAA06G33250D PROTEIN', 244409),
(348582, 'PTHR37184:SF6', NULL, NULL, NULL, NULL, 'BNAA09G54550D PROTEIN', 244409),
(348583, 'PTHR37184:SF7', NULL, NULL, NULL, NULL, '', 244409),
(348584, 'PTHR37184:SF8', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 27', 244409),
(348585, 'PTHR37474', NULL, NULL, NULL, NULL, 'RNA LIGASE/CYCLIC NUCLEOTIDE PHOSPHODIESTERASE', 244410),
(348586, 'PTHR37474:SF1', NULL, NULL, NULL, NULL, 'RNA LIGASE/CYCLIC NUCLEOTIDE PHOSPHODIESTERASE', 244410),
(348587, 'PTHR12466:SF8', NULL, NULL, NULL, NULL, 'PARAFIBROMIN', 244411),
(348588, 'PTHR12466', NULL, NULL, NULL, NULL, 'CDC73 DOMAIN PROTEIN', 244411),
(348589, 'PTHR13248:SF5', NULL, NULL, NULL, NULL, 'ELONGIN-B', 244412),
(348590, 'PTHR13248:SF6', NULL, NULL, NULL, NULL, '', 244412),
(348591, 'PTHR13248:SF3', NULL, NULL, NULL, NULL, 'ELONGIN B-LIKE', 244412),
(348592, 'PTHR13248:SF4', NULL, NULL, NULL, NULL, 'ELONGIN B', 244412),
(348593, 'PTHR13248:SF2', NULL, NULL, NULL, NULL, 'ELONGIN-B', 244412),
(348594, 'PTHR13248', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR B POLYPEPTIDE 2', 244412),
(348595, 'PTHR33836:SF18', NULL, NULL, NULL, NULL, 'OS01G0144300 PROTEIN', 244413),
(348596, 'PTHR33836:SF8', NULL, NULL, NULL, NULL, '', 244413),
(348597, 'PTHR33836:SF11', NULL, NULL, NULL, NULL, 'BNAA02G10970D PROTEIN', 244413),
(348598, 'PTHR33836:SF13', NULL, NULL, NULL, NULL, 'LOW-TEMPERATURE-INDUCED 78 KDA PROTEIN-LIKE', 244413),
(348599, 'PTHR33836', NULL, NULL, NULL, NULL, 'LOW-TEMPERATURE-INDUCED 65 KDA PROTEIN-RELATED', 244413),
(348600, 'PTHR33836:SF21', NULL, NULL, NULL, NULL, '', 244413),
(348601, 'PTHR33836:SF1', NULL, NULL, NULL, NULL, 'LOW-TEMPERATURE-INDUCED 65 KDA PROTEIN-RELATED', 244413),
(348602, 'PTHR33836:SF10', NULL, NULL, NULL, NULL, 'BNAA03G12660D PROTEIN', 244413),
(348603, 'PTHR33836:SF20', NULL, NULL, NULL, NULL, '', 244413),
(348604, 'PTHR33836:SF7', NULL, NULL, NULL, NULL, 'LOW-TEMPERATURE-INDUCED PROTEIN', 244413),
(348605, 'PTHR33836:SF19', NULL, NULL, NULL, NULL, 'BNACNNG31850D PROTEIN', 244413),
(348606, 'PTHR33836:SF5', NULL, NULL, NULL, NULL, 'EUKARYOTIC RNA POLYMERASE II HEPTAPEPTIDE REPEAT', 244413),
(348607, 'PTHR13159:SF1', NULL, NULL, NULL, NULL, 'RADIAL SPOKE HEAD PROTEIN 6 HOMOLOG A', 244414),
(348608, 'PTHR13159:SF0', NULL, NULL, NULL, NULL, 'RADIAL SPOKE HEAD COMPONENT 4A', 244414),
(348609, 'PTHR13159:SF5', NULL, NULL, NULL, NULL, 'RADIAL SPOKE PROTEIN-LIKE, PUTATIVE-RELATED', 244414),
(348610, 'PTHR13159:SF4', NULL, NULL, NULL, NULL, 'RADIAL SPOKE HEAD PROTEIN 4 HOMOLOG A', 244414),
(348611, 'PTHR13159', NULL, NULL, NULL, NULL, 'RADIAL SPOKEHEAD-RELATED', 244414),
(348612, 'PTHR46928:SF1', NULL, NULL, NULL, NULL, 'MESENCHYME-SPECIFIC CELL SURFACE GLYCOPROTEIN', 244415);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(348613, 'PTHR46928', NULL, NULL, NULL, NULL, 'MESENCHYME-SPECIFIC CELL SURFACE GLYCOPROTEIN', 244415),
(348614, 'PTHR47162', NULL, NULL, NULL, NULL, 'OS02G0192300 PROTEIN', 244416),
(348615, 'PTHR47162:SF9', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN EHD3-LIKE', 244416),
(348616, 'PTHR47162:SF10', NULL, NULL, NULL, NULL, 'METHYL-CPG-BINDING DOMAIN-CONTAINING PROTEIN 9-LIKE', 244416),
(348617, 'PTHR47162:SF8', NULL, NULL, NULL, NULL, 'METHYL-CPG-BINDING DOMAIN-CONTAINING PROTEIN 9', 244416),
(348618, 'PTHR47162:SF5', NULL, NULL, NULL, NULL, 'BNAA05G33850D PROTEIN', 244416),
(348619, 'PTHR47162:SF4', NULL, NULL, NULL, NULL, 'BROMODOMAIN-CONTAINING PROTEIN-RELATED', 244416),
(348620, 'PTHR34355:SF1', NULL, NULL, NULL, NULL, 'JOSEPHIN-LIKE PROTEIN', 244417),
(348621, 'PTHR34355:SF4', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1-RELATED', 244417),
(348622, 'PTHR34355:SF10', NULL, NULL, NULL, NULL, 'BNAC05G05090D PROTEIN', 244417),
(348623, 'PTHR34355:SF6', NULL, NULL, NULL, NULL, 'BNAC01G39230D PROTEIN', 244417),
(348624, 'PTHR34355:SF11', NULL, NULL, NULL, NULL, 'BNAA04G28500D PROTEIN', 244417),
(348625, 'PTHR34355:SF8', NULL, NULL, NULL, NULL, '', 244417),
(348626, 'PTHR34355:SF12', NULL, NULL, NULL, NULL, 'BNAA05G29290D PROTEIN', 244417),
(348627, 'PTHR34355:SF7', NULL, NULL, NULL, NULL, 'JOSEPHIN PROTEIN-LIKE PROTEIN', 244417),
(348628, 'PTHR34355:SF9', NULL, NULL, NULL, NULL, 'JOSEPHIN-LIKE PROTEIN', 244417),
(348629, 'PTHR34355', NULL, NULL, NULL, NULL, 'JOSEPHIN-LIKE PROTEIN', 244417),
(348630, 'PTHR37807', NULL, NULL, NULL, NULL, 'OS07G0160300 PROTEIN', 244418),
(348631, 'PTHR37807:SF4', NULL, NULL, NULL, NULL, 'C1_2 DOMAIN-CONTAINING PROTEIN', 244418),
(348632, 'PTHR37807:SF3', NULL, NULL, NULL, NULL, 'OS07G0160300 PROTEIN', 244418),
(348633, 'PTHR35163:SF3', NULL, NULL, NULL, NULL, '', 244419),
(348634, 'PTHR35163', NULL, NULL, NULL, NULL, 'OS02G0467300 PROTEIN', 244419),
(348635, 'PTHR35163:SF9', NULL, NULL, NULL, NULL, 'GRF-TYPE DOMAIN-CONTAINING PROTEIN', 244419),
(348636, 'PTHR35163:SF8', NULL, NULL, NULL, NULL, 'OS05G0134500 PROTEIN', 244419),
(348637, 'PTHR13168:SF1', NULL, NULL, NULL, NULL, '', 244420),
(348638, 'PTHR13168:SF0', NULL, NULL, NULL, NULL, 'C-MYC-BINDING PROTEIN', 244420),
(348639, 'PTHR13168:SF2', NULL, NULL, NULL, NULL, 'C-MYC-BINDING PROTEIN', 244420),
(348640, 'PTHR13168', NULL, NULL, NULL, NULL, 'ASSOCIATE OF C-MYC  AMY-1', 244420),
(348641, 'PTHR16198:SF2', NULL, NULL, NULL, NULL, 'INO80 COMPLEX SUBUNIT D', 244421),
(348642, 'PTHR16198', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244421),
(348643, 'PTHR33620', NULL, NULL, NULL, NULL, 'UREASE ACCESSORY PROTEIN F', 244422),
(348644, 'PTHR33620:SF2', NULL, NULL, NULL, NULL, 'UREASE ACCESSORY PROTEIN UREE', 244422),
(348645, 'PTHR33620:SF1', NULL, NULL, NULL, NULL, 'UREASE ACCESSORY PROTEIN F', 244422),
(348646, 'PTHR12411:SF679', NULL, NULL, NULL, NULL, 'PEPT_C1 DOMAIN-CONTAINING PROTEIN', 244423),
(348647, 'PTHR12411:SF553', NULL, NULL, NULL, NULL, '', 244423),
(348648, 'PTHR12411:SF793', NULL, NULL, NULL, NULL, 'BNAANNG24210D PROTEIN', 244423),
(348649, 'PTHR12411:SF792', NULL, NULL, NULL, NULL, 'BNAA01G26140D PROTEIN', 244423),
(348650, 'PTHR12411:SF675', NULL, NULL, NULL, NULL, '', 244423),
(348651, 'PTHR12411:SF554', NULL, NULL, NULL, NULL, 'CATHEPSIN 12', 244423),
(348652, 'PTHR12411:SF433', NULL, NULL, NULL, NULL, 'PROTEIN CBR-TAG-329', 244423),
(348653, 'PTHR12411:SF308', NULL, NULL, NULL, NULL, 'CATHEPSIN J', 244423),
(348654, 'PTHR12411:SF789', NULL, NULL, NULL, NULL, 'BNAA09G28660D PROTEIN', 244423),
(348655, 'PTHR12411:SF547', NULL, NULL, NULL, NULL, 'CATHEPSIN B-LIKE CYSTEINE PROTEINASE 3', 244423),
(348656, 'PTHR12411:SF660', NULL, NULL, NULL, NULL, 'BNAA02G21730D PROTEIN', 244423),
(348657, 'PTHR12411:SF779', NULL, NULL, NULL, NULL, 'BNAA02G06390D PROTEIN', 244423),
(348658, 'PTHR12411:SF416', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE 4-RELATED', 244423),
(348659, 'PTHR12411:SF778', NULL, NULL, NULL, NULL, 'PEPT_C1 DOMAIN-CONTAINING PROTEIN', 244423),
(348660, 'PTHR12411:SF657', NULL, NULL, NULL, NULL, 'PEPT_C1 DOMAIN-CONTAINING PROTEIN', 244423);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(348661, 'PTHR12411:SF899', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE 1', 244423),
(348662, 'PTHR12411:SF652', NULL, NULL, NULL, NULL, 'PAPAIN FAMILY CYSTEINE PROTEASE', 244423),
(348663, 'PTHR12411:SF773', NULL, NULL, NULL, NULL, 'PREPROCYSTEINE PROTEINASE-RELATED', 244423),
(348664, 'PTHR12411:SF894', NULL, NULL, NULL, NULL, 'CATHEPSIN B-LIKE CYSTEINE PROTEINASE 6', 244423),
(348665, 'PTHR12411:SF893', NULL, NULL, NULL, NULL, 'PEPTIDASE C1A-RELATED', 244423),
(348666, 'PTHR12411:SF650', NULL, NULL, NULL, NULL, 'BNAA09G27050D PROTEIN', 244423),
(348667, 'PTHR12411:SF898', NULL, NULL, NULL, NULL, 'SENESCENCE-SPECIFIC CYSTEINE PROTEASE SAG12', 244423),
(348668, 'PTHR12411:SF414', NULL, NULL, NULL, NULL, 'OS05G0508300 PROTEIN', 244423),
(348669, 'PTHR12411:SF897', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASES SUPERFAMILY PROTEIN-RELATED', 244423),
(348670, 'PTHR12411:SF776', NULL, NULL, NULL, NULL, 'INHIBITOR_I29 DOMAIN-CONTAINING PROTEIN', 244423),
(348671, 'PTHR12411:SF775', NULL, NULL, NULL, NULL, '', 244423),
(348672, 'PTHR12411:SF533', NULL, NULL, NULL, NULL, 'CYSTEINE ENDOPEPTIDASE', 244423),
(348673, 'PTHR12411:SF654', NULL, NULL, NULL, NULL, 'PAPAIN FAMILY CYSTEINE PROTEASE', 244423),
(348674, 'PTHR12411:SF412', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE RD19D-RELATED', 244423),
(348675, 'PTHR12411:SF896', NULL, NULL, NULL, NULL, 'PROTEASE, PUTATIVE-RELATED', 244423),
(348676, 'PTHR12411:SF895', NULL, NULL, NULL, NULL, 'PEPT_C1 DOMAIN-CONTAINING PROTEIN', 244423),
(348677, 'PTHR12411:SF527', NULL, NULL, NULL, NULL, 'OS01G0330200 PROTEIN', 244423),
(348678, 'PTHR12411:SF406', NULL, NULL, NULL, NULL, 'CATHEPSIN X', 244423),
(348679, 'PTHR12411:SF768', NULL, NULL, NULL, NULL, 'SENESCENCE-SPECIFIC CYSTEINE PROTEASE SAG39-RELATED', 244423),
(348680, 'PTHR12411:SF647', NULL, NULL, NULL, NULL, 'SENESCENCE-SPECIFIC CYSTEINE PROTEASE SAG12', 244423),
(348681, 'PTHR12411:SF525', NULL, NULL, NULL, NULL, 'CATHEPSIN S', 244423),
(348682, 'PTHR12411:SF888', NULL, NULL, NULL, NULL, 'OS08G0556900 PROTEIN', 244423),
(348683, 'PTHR12411:SF16', NULL, NULL, NULL, NULL, 'CATHEPSIN B', 244423),
(348684, 'PTHR12411:SF883', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE-LIKE PROTEIN-RELATED', 244423),
(348685, 'PTHR12411:SF761', NULL, NULL, NULL, NULL, '', 244423),
(348686, 'PTHR12411:SF882', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE RD19C-RELATED', 244423),
(348687, 'PTHR12411:SF881', NULL, NULL, NULL, NULL, 'OS02G0715000 PROTEIN', 244423),
(348688, 'PTHR12411:SF760', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE', 244423),
(348689, 'PTHR12411:SF887', NULL, NULL, NULL, NULL, 'PAPAIN FAMILY CYSTEINE PROTEASE', 244423),
(348690, 'PTHR12411:SF765', NULL, NULL, NULL, NULL, 'BNAA08G02620D PROTEIN', 244423),
(348691, 'PTHR12411:SF886', NULL, NULL, NULL, NULL, 'SENESCENCE-ASSOCIATED GENE 12', 244423),
(348692, 'PTHR12411:SF763', NULL, NULL, NULL, NULL, 'OS09G0381400 PROTEIN', 244423),
(348693, 'PTHR12411:SF642', NULL, NULL, NULL, NULL, 'PRO-CATHEPSIN H', 244423),
(348694, 'PTHR12411:SF638', NULL, NULL, NULL, NULL, '', 244423),
(348695, 'PTHR12411:SF879', NULL, NULL, NULL, NULL, 'PROTEIN CBG12906', 244423),
(348696, 'PTHR12411:SF758', NULL, NULL, NULL, NULL, 'BNAA05G09670D PROTEIN', 244423),
(348697, 'PTHR12411:SF878', NULL, NULL, NULL, NULL, 'PROTEIN CBG15672', 244423),
(348698, 'PTHR12411:SF872', NULL, NULL, NULL, NULL, 'SENESCENCE-SPECIFIC CYSTEINE PROTEASE SAG39-LIKE', 244423),
(348699, 'PTHR12411:SF750', NULL, NULL, NULL, NULL, 'PEPT_C1 DOMAIN-CONTAINING PROTEIN', 244423),
(348700, 'PTHR12411:SF633', NULL, NULL, NULL, NULL, 'INSECT RESISTANCE2', 244423),
(348701, 'PTHR12411:SF874', NULL, NULL, NULL, NULL, 'PAPAIN FAMILY CYSTEINE PROTEASE', 244423),
(348702, 'PTHR12411:SF627', NULL, NULL, NULL, NULL, 'OS04G0107700 PROTEIN', 244423),
(348703, 'PTHR12411:SF748', NULL, NULL, NULL, NULL, 'OS01G0613800 PROTEIN', 244423),
(348704, 'PTHR12411:SF869', NULL, NULL, NULL, NULL, 'LOW-TEMPERATURE-INDUCED CYSTEINE PROTEINASE-LIKE ISOFORM X1', 244423),
(348705, 'PTHR12411:SF868', NULL, NULL, NULL, NULL, 'INSECT RESISTANCE1', 244423);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(348706, 'PTHR12411:SF744', NULL, NULL, NULL, NULL, 'PEPT_C1 DOMAIN-CONTAINING PROTEIN', 244423),
(348707, 'PTHR12411:SF622', NULL, NULL, NULL, NULL, 'KDEL-TAILED CYSTEINE ENDOPEPTIDASE CEP3', 244423),
(348708, 'PTHR12411:SF862', NULL, NULL, NULL, NULL, 'CATHEPSIN L-LIKE PROTEINASE', 244423),
(348709, 'PTHR12411:SF741', NULL, NULL, NULL, NULL, 'RE20049P', 244423),
(348710, 'PTHR12411:SF857', NULL, NULL, NULL, NULL, '', 244423),
(348711, 'PTHR12411:SF615', NULL, NULL, NULL, NULL, 'PEPT_C1 DOMAIN-CONTAINING PROTEIN', 244423),
(348712, 'PTHR12411:SF856', NULL, NULL, NULL, NULL, 'CATHEPSIN S, ORTHOLOG 1', 244423),
(348713, 'PTHR12411:SF855', NULL, NULL, NULL, NULL, 'ZINGIPAIN-2-LIKE', 244423),
(348714, 'PTHR12411:SF619', NULL, NULL, NULL, NULL, 'PAPAIN FAMILY CYSTEINE PROTEASE', 244423),
(348715, 'PTHR12411:SF859', NULL, NULL, NULL, NULL, 'PEPT_C1 DOMAIN-CONTAINING PROTEIN', 244423),
(348716, 'PTHR12411:SF854', NULL, NULL, NULL, NULL, 'ORYZAIN ALPHA CHAIN', 244423),
(348717, 'PTHR12411:SF853', NULL, NULL, NULL, NULL, 'BNAA01G26160D PROTEIN', 244423),
(348718, 'PTHR12411:SF726', NULL, NULL, NULL, NULL, 'BNAA08G04080D PROTEIN', 244423),
(348719, 'PTHR12411:SF844', NULL, NULL, NULL, NULL, '', 244423),
(348720, 'PTHR12411:SF849', NULL, NULL, NULL, NULL, 'BNAA09G43180D PROTEIN', 244423),
(348721, 'PTHR12411:SF281', NULL, NULL, NULL, NULL, 'PEPT_C1 DOMAIN-CONTAINING PROTEIN', 244423),
(348722, 'PTHR12411', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE FAMILY C1-RELATED', 244423),
(348723, 'PTHR12411:SF841', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE-4', 244423),
(348724, 'PTHR12411:SF957', NULL, NULL, NULL, NULL, '', 244423),
(348725, 'PTHR12411:SF956', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE', 244423),
(348726, 'PTHR12411:SF713', NULL, NULL, NULL, NULL, 'BNAC07G33540D PROTEIN', 244423),
(348727, 'PTHR12411:SF955', NULL, NULL, NULL, NULL, 'GAMETE AND MATING-TYPE SPECIFIC PROTEIN A', 244423),
(348728, 'PTHR12411:SF834', NULL, NULL, NULL, NULL, 'TUBULOINTERSTITIAL NEPHRITIS ANTIGEN-LIKE 1', 244423),
(348729, 'PTHR12411:SF712', NULL, NULL, NULL, NULL, 'BNAA06G40240D PROTEIN', 244423),
(348730, 'PTHR12411:SF954', NULL, NULL, NULL, NULL, 'BNAC06G00260D PROTEIN', 244423),
(348731, 'PTHR12411:SF839', NULL, NULL, NULL, NULL, 'VIGNAIN-LIKE', 244423),
(348732, 'PTHR12411:SF838', NULL, NULL, NULL, NULL, 'CATHEPSIN X', 244423),
(348733, 'PTHR12411:SF270', NULL, NULL, NULL, NULL, 'TUBULOINTERSTITIAL NEPHRITIS ANTIGEN-LIKE', 244423),
(348734, 'PTHR12411:SF274', NULL, NULL, NULL, NULL, 'TUBULOINTERSTITIAL NEPHRITIS ANTIGEN', 244423),
(348735, 'PTHR12411:SF276', NULL, NULL, NULL, NULL, '', 244423),
(348736, 'PTHR12411:SF953', NULL, NULL, NULL, NULL, 'ORYZAIN BETA CHAIN', 244423),
(348737, 'PTHR12411:SF832', NULL, NULL, NULL, NULL, 'SENESCENCE-SPECIFIC CYSTEINE PROTEASE SAG12-LIKE', 244423),
(348738, 'PTHR12411:SF831', NULL, NULL, NULL, NULL, 'BNAC05G04310D PROTEIN', 244423),
(348739, 'PTHR12411:SF952', NULL, NULL, NULL, NULL, 'PEPT_C1 DOMAIN-CONTAINING PROTEIN', 244423),
(348740, 'PTHR12411:SF951', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE RDL4-RELATED', 244423),
(348741, 'PTHR12411:SF950', NULL, NULL, NULL, NULL, 'KDEL-TAILED CYSTEINE ENDOPEPTIDASE CEP2-LIKE', 244423),
(348742, 'PTHR12411:SF946', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE', 244423),
(348743, 'PTHR12411:SF704', NULL, NULL, NULL, NULL, 'OS04G0207600 PROTEIN', 244423),
(348744, 'PTHR12411:SF824', NULL, NULL, NULL, NULL, 'PAPAIN FAMILY CYSTEINE PROTEASE', 244423),
(348745, 'PTHR12411:SF945', NULL, NULL, NULL, NULL, 'CATHEPSIN B-LIKE PROTEASE 3', 244423),
(348746, 'PTHR12411:SF823', NULL, NULL, NULL, NULL, 'PEPT_C1 DOMAIN-CONTAINING PROTEIN', 244423),
(348747, 'PTHR12411:SF944', NULL, NULL, NULL, NULL, 'OS04G0208200 PROTEIN', 244423),
(348748, 'PTHR12411:SF943', NULL, NULL, NULL, NULL, 'KDEL-TAILED CYSTEINE ENDOPEPTIDASE CEP2', 244423),
(348749, 'PTHR12411:SF707', NULL, NULL, NULL, NULL, 'CATHEPSIN B-LIKE CYSTEINE PROTEINASE 5', 244423),
(348750, 'PTHR12411:SF949', NULL, NULL, NULL, NULL, 'PROTEIN CBG17217', 244423),
(348751, 'PTHR12411:SF828', NULL, NULL, NULL, NULL, 'GERMINATION-SPECIFIC CYSTEINE PROTEASE 1', 244423);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(348752, 'PTHR12411:SF948', NULL, NULL, NULL, NULL, 'CATHEPSIN O', 244423),
(348753, 'PTHR12411:SF947', NULL, NULL, NULL, NULL, 'CATHEPSIN F', 244423),
(348754, 'PTHR12411:SF705', NULL, NULL, NULL, NULL, 'SENESCENCE-SPECIFIC CYSTEINE PROTEASE SAG12', 244423),
(348755, 'PTHR12411:SF142', NULL, NULL, NULL, NULL, 'CATHEPSIN-6', 244423),
(348756, 'PTHR12411:SF141', NULL, NULL, NULL, NULL, 'CATHEPSIN R', 244423),
(348757, 'PTHR12411:SF140', NULL, NULL, NULL, NULL, 'CATHEPSIN 8', 244423),
(348758, 'PTHR12411:SF143', NULL, NULL, NULL, NULL, 'CATHEPSIN Q', 244423),
(348759, 'PTHR12411:SF700', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE RDL2-RELATED', 244423),
(348760, 'PTHR12411:SF942', NULL, NULL, NULL, NULL, 'DIPEPTIDYL PEPTIDASE 1', 244423),
(348761, 'PTHR12411:SF941', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE', 244423),
(348762, 'PTHR12411:SF820', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE XCP1', 244423),
(348763, 'PTHR12411:SF940', NULL, NULL, NULL, NULL, 'PAPAIN FAMILY CYSTEINE PROTEASE-RELATED', 244423),
(348764, 'PTHR12411:SF814', NULL, NULL, NULL, NULL, 'PEPT_C1 DOMAIN-CONTAINING PROTEIN', 244423),
(348765, 'PTHR12411:SF935', NULL, NULL, NULL, NULL, 'PEPT_C1 DOMAIN-CONTAINING PROTEIN', 244423),
(348766, 'PTHR12411:SF934', NULL, NULL, NULL, NULL, '', 244423),
(348767, 'PTHR12411:SF813', NULL, NULL, NULL, NULL, 'VIGNAIN', 244423),
(348768, 'PTHR12411:SF933', NULL, NULL, NULL, NULL, 'SENESCENCE-SPECIFIC CYSTEINE PROTEASE SAG39-LIKE', 244423),
(348769, 'PTHR12411:SF812', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE 3', 244423),
(348770, 'PTHR12411:SF932', NULL, NULL, NULL, NULL, 'PEPT_C1 DOMAIN-CONTAINING PROTEIN', 244423),
(348771, 'PTHR12411:SF818', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE CP8', 244423),
(348772, 'PTHR12411:SF939', NULL, NULL, NULL, NULL, 'OS01G0971400 PROTEIN', 244423),
(348773, 'PTHR12411:SF938', NULL, NULL, NULL, NULL, 'PROTEASE, PUTATIVE-RELATED', 244423),
(348774, 'PTHR12411:SF937', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE RD21A-RELATED', 244423),
(348775, 'PTHR12411:SF936', NULL, NULL, NULL, NULL, 'VIGNAIN-LIKE', 244423),
(348776, 'PTHR12411:SF931', NULL, NULL, NULL, NULL, 'LOW-TEMPERATURE-INDUCED CYSTEINE PROTEINASE-LIKE', 244423),
(348777, 'PTHR12411:SF810', NULL, NULL, NULL, NULL, '', 244423),
(348778, 'PTHR12411:SF930', NULL, NULL, NULL, NULL, 'PAPAIN FAMILY CYSTEINE PROTEASE', 244423),
(348779, 'PTHR12411:SF803', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASES SUPERFAMILY PROTEIN', 244423),
(348780, 'PTHR12411:SF924', NULL, NULL, NULL, NULL, 'CATHEPSIN L', 244423),
(348781, 'PTHR12411:SF923', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE 1', 244423),
(348782, 'PTHR12411:SF922', NULL, NULL, NULL, NULL, 'TESTIN-2', 244423),
(348783, 'PTHR12411:SF921', NULL, NULL, NULL, NULL, 'PEPT_C1 DOMAIN-CONTAINING PROTEIN', 244423),
(348784, 'PTHR12411:SF928', NULL, NULL, NULL, NULL, 'PEPT_C1 DOMAIN-CONTAINING PROTEIN', 244423),
(348785, 'PTHR12411:SF806', NULL, NULL, NULL, NULL, 'PEPT_C1 DOMAIN-CONTAINING PROTEIN', 244423),
(348786, 'PTHR12411:SF927', NULL, NULL, NULL, NULL, 'BNAA04G12170D PROTEIN', 244423),
(348787, 'PTHR12411:SF926', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE COT44-LIKE', 244423),
(348788, 'PTHR12411:SF805', NULL, NULL, NULL, NULL, 'KDEL-TAILED CYSTEINE ENDOPEPTIDASE CEP1', 244423),
(348789, 'PTHR12411:SF925', NULL, NULL, NULL, NULL, 'KDEL-TAILED CYSTEINE ENDOPEPTIDASE CEP1-LIKE', 244423),
(348790, 'PTHR12411:SF804', NULL, NULL, NULL, NULL, 'OS09G0564600 PROTEIN', 244423),
(348791, 'PTHR12411:SF929', NULL, NULL, NULL, NULL, 'CATHEPSIN Z', 244423),
(348792, 'PTHR12411:SF360', NULL, NULL, NULL, NULL, 'OS06G0582600 PROTEIN', 244423),
(348793, 'PTHR12411:SF920', NULL, NULL, NULL, NULL, 'PROPEPTIDE_C1 DOMAIN-CONTAINING PROTEIN', 244423),
(348794, 'PTHR12411:SF369', NULL, NULL, NULL, NULL, 'CATHEPSIN B-LIKE CYSTEINE PROTEINASE 4', 244423),
(348795, 'PTHR12411:SF913', NULL, NULL, NULL, NULL, 'PROTEASE, PUTATIVE-RELATED', 244423),
(348796, 'PTHR12411:SF912', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASES SUPERFAMILY PROTEIN', 244423),
(348797, 'PTHR12411:SF911', NULL, NULL, NULL, NULL, 'PEPT_C1 DOMAIN-CONTAINING PROTEIN', 244423);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(348798, 'PTHR12411:SF910', NULL, NULL, NULL, NULL, '', 244423),
(348799, 'PTHR12411:SF917', NULL, NULL, NULL, NULL, 'CATHEPSIN L.1', 244423),
(348800, 'PTHR12411:SF916', NULL, NULL, NULL, NULL, 'CATHEPSIN O', 244423),
(348801, 'PTHR12411:SF915', NULL, NULL, NULL, NULL, 'THIOL PROTEASE ALEURAIN', 244423),
(348802, 'PTHR12411:SF914', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE RD19A-LIKE', 244423),
(348803, 'PTHR12411:SF919', NULL, NULL, NULL, NULL, 'XYLEM CYSTEINE PROTEINASE 1-LIKE', 244423),
(348804, 'PTHR12411:SF918', NULL, NULL, NULL, NULL, 'THIOL PROTEASE SEN102-LIKE', 244423),
(348805, 'PTHR12411:SF591', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE RDL3-RELATED', 244423),
(348806, 'PTHR12411:SF597', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE', 244423),
(348807, 'PTHR12411:SF596', NULL, NULL, NULL, NULL, 'PEPT_C1 DOMAIN-CONTAINING PROTEIN', 244423),
(348808, 'PTHR12411:SF595', NULL, NULL, NULL, NULL, 'PEPT_C1 DOMAIN-CONTAINING PROTEIN', 244423),
(348809, 'PTHR12411:SF357', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE XCP2', 244423),
(348810, 'PTHR12411:SF356', NULL, NULL, NULL, NULL, 'PEPT_C1 DOMAIN-CONTAINING PROTEIN', 244423),
(348811, 'PTHR12411:SF598', NULL, NULL, NULL, NULL, 'PEPT_C1 DOMAIN-CONTAINING PROTEIN', 244423),
(348812, 'PTHR12411:SF902', NULL, NULL, NULL, NULL, 'PROCATHEPSIN L', 244423),
(348813, 'PTHR12411:SF901', NULL, NULL, NULL, NULL, 'OS09G0497500 PROTEIN', 244423),
(348814, 'PTHR12411:SF900', NULL, NULL, NULL, NULL, 'SENESCENCE-SPECIFIC CYSTEINE PROTEASE SAG39-LIKE', 244423),
(348815, 'PTHR12411:SF906', NULL, NULL, NULL, NULL, 'LD36817P-RELATED', 244423),
(348816, 'PTHR12411:SF905', NULL, NULL, NULL, NULL, 'INHIBITOR_I29 DOMAIN-CONTAINING PROTEIN', 244423),
(348817, 'PTHR12411:SF904', NULL, NULL, NULL, NULL, 'SENESCENCE-SPECIFIC CYSTEINE PROTEASE SAG39-LIKE', 244423),
(348818, 'PTHR12411:SF903', NULL, NULL, NULL, NULL, 'SI:DKEY-228A15.1-RELATED', 244423),
(348819, 'PTHR12411:SF909', NULL, NULL, NULL, NULL, 'PAPAIN FAMILY CYSTEINE PROTEASE', 244423),
(348820, 'PTHR12411:SF908', NULL, NULL, NULL, NULL, 'CATHEPSIN B-LIKE', 244423),
(348821, 'PTHR12411:SF907', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE RDL6-RELATED', 244423),
(348822, 'PTHR12411:SF586', NULL, NULL, NULL, NULL, 'ZGC:110239', 244423),
(348823, 'PTHR12411:SF101', NULL, NULL, NULL, NULL, 'CATHEPSIN W', 244423),
(348824, 'PTHR12411:SF589', NULL, NULL, NULL, NULL, 'ERVATAMIN-B-LIKE', 244423),
(348825, 'PTHR12411:SF693', NULL, NULL, NULL, NULL, 'PEPT_C1 DOMAIN-CONTAINING PROTEIN', 244423),
(348826, 'PTHR12411:SF698', NULL, NULL, NULL, NULL, 'PEPT_C1 DOMAIN-CONTAINING PROTEIN', 244423),
(348827, 'PTHR12411:SF577', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE 3', 244423),
(348828, 'PTHR12411:SF329', NULL, NULL, NULL, NULL, 'PEPT_C1 DOMAIN-CONTAINING PROTEIN', 244423),
(348829, 'PTHR12411:SF569', NULL, NULL, NULL, NULL, 'PEPT_C1 DOMAIN-CONTAINING PROTEIN', 244423),
(348830, 'PTHR12411:SF327', NULL, NULL, NULL, NULL, 'CATHEPSIN L-LIKE 3-RELATED', 244423),
(348831, 'PTHR12411:SF681', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE RD21C-RELATED', 244423),
(348832, 'PTHR12411:SF684', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASES SUPERFAMILY PROTEIN-RELATED', 244423),
(348833, 'PTHR12411:SF562', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASES SUPERFAMILY PROTEIN', 244423),
(348834, 'PTHR12411:SF561', NULL, NULL, NULL, NULL, 'COUNTING FACTOR ASSOCIATED PROTEIN D', 244423),
(348835, 'PTHR12411:SF689', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASES SUPERFAMILY PROTEIN', 244423),
(348836, 'PTHR12411:SF56', NULL, NULL, NULL, NULL, 'CATHEPSIN 7', 244423),
(348837, 'PTHR12411:SF55', NULL, NULL, NULL, NULL, 'CATHEPSIN K', 244423),
(348838, 'PTHR12411:SF58', NULL, NULL, NULL, NULL, 'CATHEPSIN M-RELATED', 244423),
(348839, 'PTHR12411:SF57', NULL, NULL, NULL, NULL, 'CATHEPSIN L2', 244423),
(348840, 'PTHR12411:SF444', NULL, NULL, NULL, NULL, 'CATHEPSIN F', 244423),
(348841, 'PTHR35768', NULL, NULL, NULL, NULL, 'PROTEIN MULTIPOLAR SPINDLE 1', 244424),
(348842, 'PTHR35768:SF2', NULL, NULL, NULL, NULL, 'BNAA02G08030D PROTEIN', 244424),
(348843, 'PTHR35768:SF1', NULL, NULL, NULL, NULL, 'PROTEIN MULTIPOLAR SPINDLE 1', 244424);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(348844, 'PTHR33866', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE DECARBOXYLASE PROENZYME', 244425),
(348845, 'PTHR33866:SF1', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE DECARBOXYLASE PROENZYME', 244425),
(348846, 'PTHR33866:SF2', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE DECARBOXYLASE PROENZYME', 244425),
(348847, 'PTHR47603:SF3', NULL, NULL, NULL, NULL, 'BNAANNG12240D PROTEIN', 244426),
(348848, 'PTHR47603:SF2', NULL, NULL, NULL, NULL, '', 244426),
(348849, 'PTHR47603', NULL, NULL, NULL, NULL, 'PPR CONTAINING-LIKE PROTEIN', 244426),
(348850, 'PTHR47603:SF1', NULL, NULL, NULL, NULL, 'PPR CONTAINING-LIKE PROTEIN', 244426),
(348851, 'PTHR45788:SF5', NULL, NULL, NULL, NULL, 'AFR253WP', 244427),
(348852, 'PTHR45788:SF6', NULL, NULL, NULL, NULL, 'SI:DKEY-178E17.1-RELATED', 244427),
(348853, 'PTHR45788', NULL, NULL, NULL, NULL, 'SUCCINATE/FUMARATE MITOCHONDRIAL TRANSPORTER-RELATED', 244427),
(348854, 'PTHR45788:SF7', NULL, NULL, NULL, NULL, 'TRICARBOXYLATE TRANSPORT PROTEIN A, MITOCHONDRIAL', 244427),
(348855, 'PTHR45788:SF2', NULL, NULL, NULL, NULL, 'SUCCINATE/FUMARATE MITOCHONDRIAL TRANSPORTER', 244427),
(348856, 'PTHR45788:SF3', NULL, NULL, NULL, NULL, '', 244427),
(348857, 'PTHR45788:SF4', NULL, NULL, NULL, NULL, 'TRICARBOXYLATE TRANSPORT PROTEIN, MITOCHONDRIAL', 244427),
(348858, 'PTHR37170', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-RELATED', 244428),
(348859, 'PTHR37170:SF1', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-LIKE PROTEIN', 244428),
(348860, 'PTHR35310:SF1', NULL, NULL, NULL, NULL, 'CELL WALL INTEGRITY/STRESS RESPONSE COMPONENT-LIKE PROTEIN', 244429),
(348861, 'PTHR35310:SF2', NULL, NULL, NULL, NULL, '', 244429),
(348862, 'PTHR35310', NULL, NULL, NULL, NULL, 'CELL WALL INTEGRITY/STRESS RESPONSE COMPONENT-LIKE PROTEIN', 244429),
(348863, 'PTHR35310:SF5', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 244429),
(348864, 'PTHR35310:SF6', NULL, NULL, NULL, NULL, 'BNAA01G34680D PROTEIN', 244429),
(348865, 'PTHR28035', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL DISTRIBUTION AND MORPHOLOGY PROTEIN 10', 244430),
(348866, 'PTHR28035:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL DISTRIBUTION AND MORPHOLOGY PROTEIN 10', 244430),
(348867, 'PTHR22684:SF0', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR 25', 244431),
(348868, 'PTHR22684', NULL, NULL, NULL, NULL, 'NULP1-RELATED', 244431),
(348869, 'PTHR34849', NULL, NULL, NULL, NULL, 'SSL5025 PROTEIN', 244432),
(348870, 'PTHR34849:SF2', NULL, NULL, NULL, NULL, 'SSR2962 PROTEIN', 244432),
(348871, 'PTHR34849:SF1', NULL, NULL, NULL, NULL, 'SLR0770 PROTEIN', 244432),
(348872, 'PTHR34849:SF4', NULL, NULL, NULL, NULL, 'SLR1209 PROTEIN', 244432),
(348873, 'PTHR34849:SF3', NULL, NULL, NULL, NULL, 'SSL5025 PROTEIN', 244432),
(348874, 'PTHR23273:SF89', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 244433),
(348875, 'PTHR23273:SF129', NULL, NULL, NULL, NULL, 'REPLICATION PROTEIN A 70 KDA DNA-BINDING SUBUNIT A-LIKE ISOFORM X1', 244433),
(348876, 'PTHR23273:SF128', NULL, NULL, NULL, NULL, 'REPLICATION PROTEIN A SUBUNIT', 244433),
(348877, 'PTHR23273:SF86', NULL, NULL, NULL, NULL, 'BNAA09G24930D PROTEIN', 244433),
(348878, 'PTHR23273:SF127', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 244433),
(348879, 'PTHR23273:SF122', NULL, NULL, NULL, NULL, 'BNAC04G32120D PROTEIN', 244433),
(348880, 'PTHR23273:SF121', NULL, NULL, NULL, NULL, 'BNAC05G00220D PROTEIN', 244433),
(348881, 'PTHR23273:SF120', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 244433),
(348882, 'PTHR23273:SF126', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 244433),
(348883, 'PTHR23273:SF125', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 244433),
(348884, 'PTHR23273:SF124', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 244433),
(348885, 'PTHR23273:SF123', NULL, NULL, NULL, NULL, 'RPA1 DOMAIN PROTEIN, PUTATIVE-RELATED', 244433),
(348886, 'PTHR23273', NULL, NULL, NULL, NULL, 'REPLICATION FACTOR A 1, RFA1', 244433),
(348887, 'PTHR23273:SF47', NULL, NULL, NULL, NULL, 'REPLICATION PROTEIN A 70 KDA DNA-BINDING SUBUNIT A', 244433); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(348888, 'PTHR23273:SF119', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 244433),
(348889, 'PTHR23273:SF118', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 244433),
(348890, 'PTHR23273:SF98', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 244433),
(348891, 'PTHR23273:SF117', NULL, NULL, NULL, NULL, 'BNAC09G37970D PROTEIN', 244433),
(348892, 'PTHR23273:SF116', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 244433),
(348893, 'PTHR23273:SF111', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 244433),
(348894, 'PTHR23273:SF155', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 244433),
(348895, 'PTHR23273:SF92', NULL, NULL, NULL, NULL, 'NUCLEIC ACID-BINDING, OB-FOLD PROTEIN-RELATED', 244433),
(348896, 'PTHR23273:SF110', NULL, NULL, NULL, NULL, 'REPLICATION PROTEIN A SUBUNIT', 244433),
(348897, 'PTHR23273:SF154', NULL, NULL, NULL, NULL, 'BNAC04G13900D PROTEIN', 244433),
(348898, 'PTHR23273:SF153', NULL, NULL, NULL, NULL, 'REPLICATION FACTOR-A CARBOXY-TERMINAL DOMAIN PROTEIN', 244433),
(348899, 'PTHR23273:SF152', NULL, NULL, NULL, NULL, 'BNAUNNG00360D PROTEIN', 244433),
(348900, 'PTHR23273:SF115', NULL, NULL, NULL, NULL, 'REPLICATION PROTEIN A SUBUNIT', 244433),
(348901, 'PTHR23273:SF159', NULL, NULL, NULL, NULL, 'BNAC08G08520D PROTEIN', 244433),
(348902, 'PTHR23273:SF4', NULL, NULL, NULL, NULL, 'REPLICATION PROTEIN A 70 KDA DNA-BINDING SUBUNIT', 244433),
(348903, 'PTHR23273:SF158', NULL, NULL, NULL, NULL, 'BNAC05G49610D PROTEIN', 244433),
(348904, 'PTHR23273:SF114', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 244433),
(348905, 'PTHR23273:SF157', NULL, NULL, NULL, NULL, 'BNAA08G06240D PROTEIN', 244433),
(348906, 'PTHR23273:SF113', NULL, NULL, NULL, NULL, 'BNAA01G22550D PROTEIN', 244433),
(348907, 'PTHR23273:SF156', NULL, NULL, NULL, NULL, 'NUCLEIC ACID-BINDING, OB-FOLD PROTEIN-RELATED', 244433),
(348908, 'PTHR23273:SF112', NULL, NULL, NULL, NULL, 'BNAC04G02060D PROTEIN', 244433),
(348909, 'PTHR23273:SF160', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 244433),
(348910, 'PTHR23273:SF106', NULL, NULL, NULL, NULL, 'REPLICATION FACTOR A PROTEIN 1-LIKE ISOFORM X1', 244433),
(348911, 'PTHR23273:SF149', NULL, NULL, NULL, NULL, 'BNAA09G53830D PROTEIN', 244433),
(348912, 'PTHR23273:SF60', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 244433),
(348913, 'PTHR23273:SF144', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 244433),
(348914, 'PTHR23273:SF100', NULL, NULL, NULL, NULL, 'BNAA09G07920D PROTEIN', 244433),
(348915, 'PTHR23273:SF143', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 244433),
(348916, 'PTHR23273:SF142', NULL, NULL, NULL, NULL, 'REPLICATION PROTEIN A 70 KDA DNA-BINDING SUBUNIT B-LIKE ISOFORM X1', 244433),
(348917, 'PTHR23273:SF141', NULL, NULL, NULL, NULL, 'REPLICATION PROTEIN A SUBUNIT', 244433),
(348918, 'PTHR23273:SF148', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 244433),
(348919, 'PTHR23273:SF104', NULL, NULL, NULL, NULL, 'AMINO ACID BINDING PROTEIN', 244433),
(348920, 'PTHR23273:SF103', NULL, NULL, NULL, NULL, 'BNAA07G08240D PROTEIN', 244433),
(348921, 'PTHR23273:SF147', NULL, NULL, NULL, NULL, 'REPLICATION PROTEIN A 70 KDA DNA-BINDING SUBUNIT A-LIKE ISOFORM X1', 244433),
(348922, 'PTHR23273:SF146', NULL, NULL, NULL, NULL, '', 244433),
(348923, 'PTHR23273:SF145', NULL, NULL, NULL, NULL, 'BNAA04G05930D PROTEIN', 244433),
(348924, 'PTHR23273:SF151', NULL, NULL, NULL, NULL, 'BNAC05G19830D PROTEIN', 244433),
(348925, 'PTHR23273:SF150', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 244433),
(348926, 'PTHR23273:SF68', NULL, NULL, NULL, NULL, 'BNAC08G15530D PROTEIN', 244433),
(348927, 'PTHR23273:SF78', NULL, NULL, NULL, NULL, 'REPLICATION PROTEIN A SUBUNIT', 244433),
(348928, 'PTHR23273:SF139', NULL, NULL, NULL, NULL, 'REPLICATION PROTEIN A 70 KDA DNA-BINDING SUBUNIT E', 244433),
(348929, 'PTHR23273:SF32', NULL, NULL, NULL, NULL, 'REPA_OB_2 DOMAIN-CONTAINING PROTEIN', 244433);
INSERT INTO "PUBLIC"."MODEL" VALUES
(348930, 'PTHR23273:SF76', NULL, NULL, NULL, NULL, 'REPLICATION PROTEIN A 70 KDA DNA-BINDING SUBUNIT C', 244433),
(348931, 'PTHR23273:SF138', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 244433),
(348932, 'PTHR23273:SF74', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 244433),
(348933, 'PTHR23273:SF73', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 244433),
(348934, 'PTHR23273:SF72', NULL, NULL, NULL, NULL, 'NUCLEIC ACID-BINDING, OB-FOLD-LIKE PROTEIN', 244433),
(348935, 'PTHR23273:SF70', NULL, NULL, NULL, NULL, 'DUF223 DOMAIN-CONTAINING PROTEIN', 244433),
(348936, 'PTHR23273:SF133', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 244433),
(348937, 'PTHR23273:SF132', NULL, NULL, NULL, NULL, 'DUF223 DOMAIN-CONTAINING PROTEIN', 244433),
(348938, 'PTHR23273:SF131', NULL, NULL, NULL, NULL, 'REPLICATION FACTOR A PROTEIN 1', 244433),
(348939, 'PTHR23273:SF130', NULL, NULL, NULL, NULL, 'REP-A_N DOMAIN-CONTAINING PROTEIN', 244433),
(348940, 'PTHR23273:SF137', NULL, NULL, NULL, NULL, 'DUF223 DOMAIN-CONTAINING PROTEIN', 244433),
(348941, 'PTHR23273:SF136', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 244433),
(348942, 'PTHR23273:SF135', NULL, NULL, NULL, NULL, 'REPLICATION FACTOR-A CARBOXY-TERMINAL DOMAIN PROTEIN', 244433),
(348943, 'PTHR23273:SF134', NULL, NULL, NULL, NULL, 'NUCLEIC ACID-BINDING, OB-FOLD PROTEIN-RELATED', 244433),
(348944, 'PTHR23273:SF140', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 244433),
(348945, 'PTHR23273:SF38', NULL, NULL, NULL, NULL, 'REPLICATION PROTEIN A SUBUNIT', 244433),
(348946, 'PTHR35158:SF1', NULL, NULL, NULL, NULL, 'CDNA SEQUENCE CN725425', 244434),
(348947, 'PTHR35158', NULL, NULL, NULL, NULL, 'CDNA SEQUENCE CN725425', 244434),
(348948, 'PTHR35401:SF2', NULL, NULL, NULL, NULL, 'ABC-TYPE TRANSPORT SYSTEM-RELATED', 244435),
(348949, 'PTHR35401:SF1', NULL, NULL, NULL, NULL, 'COPG FAMILY HELIX-TURN-HELIX PROTEIN-RELATED', 244435),
(348950, 'PTHR35401', NULL, NULL, NULL, NULL, 'COPG FAMILY HELIX-TURN-HELIX PROTEIN-RELATED-RELATED', 244435),
(348951, 'PTHR28250:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME B PRE-MRNA-PROCESSING PROTEIN 6', 244436),
(348952, 'PTHR28250', NULL, NULL, NULL, NULL, 'CYTOCHROME B PRE-MRNA-PROCESSING PROTEIN 6', 244436),
(348953, 'PTHR48239:SF1', NULL, NULL, NULL, NULL, '', 244437),
(348954, 'PTHR48239:SF2', NULL, NULL, NULL, NULL, '', 244437),
(348955, 'PTHR48239', NULL, NULL, NULL, NULL, '', 244437),
(348956, 'PTHR35046:SF11', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE', 244438),
(348957, 'PTHR35046:SF10', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 244438),
(348958, 'PTHR35046:SF15', NULL, NULL, NULL, NULL, 'RETROTRANS_GAG DOMAIN-CONTAINING PROTEIN', 244438),
(348959, 'PTHR35046:SF14', NULL, NULL, NULL, NULL, 'RETROTRANS_GAG DOMAIN-CONTAINING PROTEIN', 244438),
(348960, 'PTHR35046:SF13', NULL, NULL, NULL, NULL, 'RETROTRANS_GAG DOMAIN-CONTAINING PROTEIN', 244438),
(348961, 'PTHR35046:SF12', NULL, NULL, NULL, NULL, 'ZINC KNUCKLE (CCHC-TYPE) FAMILY PROTEIN', 244438),
(348962, 'PTHR35046', NULL, NULL, NULL, NULL, 'ZINC KNUCKLE (CCHC-TYPE) FAMILY PROTEIN', 244438),
(348963, 'PTHR35046:SF18', NULL, NULL, NULL, NULL, 'POLYPROTEIN', 244438),
(348964, 'PTHR35046:SF17', NULL, NULL, NULL, NULL, 'POLYPROTEIN/RETROTRANSPOSON, PUTATIVE-RELATED', 244438),
(348965, 'PTHR35046:SF16', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 244438),
(348966, 'PTHR35046:SF7', NULL, NULL, NULL, NULL, 'OS08G0315200 PROTEIN', 244438),
(348967, 'PTHR35046:SF8', NULL, NULL, NULL, NULL, 'RETROTRANS_GAG DOMAIN-CONTAINING PROTEIN', 244438),
(348968, 'PTHR35046:SF9', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE', 244438),
(348969, 'PTHR37743:SF1', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 244439),
(348970, 'PTHR37743', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 244439),
(348971, 'PTHR30510', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244440),
(348972, 'PTHR30510:SF2', NULL, NULL, NULL, NULL, 'UPF0229 PROTEIN YEAH', 244440);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(348973, 'PTHR33653:SF1', NULL, NULL, NULL, NULL, 'RIBONUCLEASE VAPC2', 244441),
(348974, 'PTHR33653:SF2', NULL, NULL, NULL, NULL, 'SLR6049 PROTEIN', 244441),
(348975, 'PTHR33653', NULL, NULL, NULL, NULL, 'RIBONUCLEASE VAPC2', 244441),
(348976, 'PTHR35976', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN J', 244442),
(348977, 'PTHR35976:SF1', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN J', 244442),
(348978, 'PTHR35528', NULL, NULL, NULL, NULL, 'BLL1675 PROTEIN', 244443),
(348979, 'PTHR35528:SF3', NULL, NULL, NULL, NULL, 'BLL1675 PROTEIN', 244443),
(348980, 'PTHR12778:SF10', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY DOMAIN-CONTAINING PROTEIN 3', 244444),
(348981, 'PTHR12778', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 33  ACETYL-COA TRANSPORTER -RELATED', 244444),
(348982, 'PTHR12778:SF9', NULL, NULL, NULL, NULL, 'ACETYL-COENZYME A TRANSPORTER 1', 244444),
(348983, 'PTHR24284:SF10', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY', 244445),
(348984, 'PTHR24284', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY', 244445),
(348985, 'PTHR24284:SF8', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY', 244445),
(348986, 'PTHR24284:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY', 244445),
(348987, 'PTHR37048:SF2', NULL, NULL, NULL, NULL, '', 244446),
(348988, 'PTHR37048', NULL, NULL, NULL, NULL, '', 244446),
(348989, 'PTHR21633:SF10', NULL, NULL, NULL, NULL, 'IQ MOTIF-CONTAINING F4', 244447),
(348990, 'PTHR21633', NULL, NULL, NULL, NULL, 'IQ MOTIF CONTAINING F', 244447),
(348991, 'PTHR21633:SF24', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN F5', 244447),
(348992, 'PTHR21633:SF14', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN F1', 244447),
(348993, 'PTHR21633:SF15', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN F6', 244447),
(348994, 'PTHR21633:SF4', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN F2', 244447),
(348995, 'PTHR21633:SF5', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN F3', 244447),
(348996, 'PTHR11877:SF80', NULL, NULL, NULL, NULL, 'BISDEMETHOXYCURCUMIN SYNTHASE', 244448),
(348997, 'PTHR11877:SF81', NULL, NULL, NULL, NULL, 'BNAA02G30320D PROTEIN', 244448),
(348998, 'PTHR11877:SF60', NULL, NULL, NULL, NULL, 'TYPE III POLYKETIDE SYNTHASE B', 244448),
(348999, 'PTHR11877:SF62', NULL, NULL, NULL, NULL, 'CHALCONE SYNTHASE 7', 244448),
(349000, 'PTHR11877:SF14', NULL, NULL, NULL, NULL, 'CHALCONE SYNTHASE', 244448),
(349001, 'PTHR11877:SF10', NULL, NULL, NULL, NULL, 'TYPE III POLYKETIDE SYNTHASE B', 244448),
(349002, 'PTHR11877', NULL, NULL, NULL, NULL, 'HYDROXYMETHYLGLUTARYL-COA SYNTHASE', 244448),
(349003, 'PTHR11877:SF52', NULL, NULL, NULL, NULL, '', 244448),
(349004, 'PTHR11877:SF96', NULL, NULL, NULL, NULL, 'CHALCONE SYNTHASE', 244448),
(349005, 'PTHR11877:SF74', NULL, NULL, NULL, NULL, 'TYPE III POLYKETIDE SYNTHASE B', 244448),
(349006, 'PTHR11877:SF97', NULL, NULL, NULL, NULL, 'TYPE III POLYKETIDE SYNTHASE B', 244448),
(349007, 'PTHR11877:SF53', NULL, NULL, NULL, NULL, 'TYPE III POLYKETIDE SYNTHASE C', 244448),
(349008, 'PTHR11877:SF75', NULL, NULL, NULL, NULL, 'BNAA03G53070D PROTEIN', 244448),
(349009, 'PTHR11877:SF98', NULL, NULL, NULL, NULL, 'CHALCONE SYNTHASE', 244448),
(349010, 'PTHR11877:SF99', NULL, NULL, NULL, NULL, '1,3,6,8-TETRAHYDROXYNAPHTHALENE SYNTHASE', 244448),
(349011, 'PTHR11877:SF55', NULL, NULL, NULL, NULL, 'CHALCONE SYNTHASE 8', 244448),
(349012, 'PTHR11877:SF56', NULL, NULL, NULL, NULL, '', 244448),
(349013, 'PTHR11877:SF79', NULL, NULL, NULL, NULL, 'OS04G0304600 PROTEIN', 244448),
(349014, 'PTHR11877:SF57', NULL, NULL, NULL, NULL, 'CHALCONE SYNTHASE-LIKE', 244448),
(349015, 'PTHR11877:SF59', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 244448),
(349016, 'PTHR11877:SF91', NULL, NULL, NULL, NULL, '', 244448),
(349017, 'PTHR11877:SF70', NULL, NULL, NULL, NULL, '', 244448),
(349018, 'PTHR11877:SF94', NULL, NULL, NULL, NULL, 'CHALCONE SYNTHASE 2', 244448),
(349019, 'PTHR11877:SF95', NULL, NULL, NULL, NULL, 'CHAL_STI_SYNT_N DOMAIN-CONTAINING PROTEIN', 244448),
(349020, 'PTHR11877:SF73', NULL, NULL, NULL, NULL, '', 244448);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(349021, 'PTHR11877:SF51', NULL, NULL, NULL, NULL, 'CHALCONE SYNTHASE', 244448),
(349022, 'PTHR11877:SF48', NULL, NULL, NULL, NULL, '', 244448),
(349023, 'PTHR11877:SF47', NULL, NULL, NULL, NULL, 'OS11G0529900 PROTEIN', 244448),
(349024, 'PTHR11877:SF46', NULL, NULL, NULL, NULL, 'TYPE III POLYKETIDE SYNTHASE A', 244448),
(349025, 'PTHR11877:SF24', NULL, NULL, NULL, NULL, 'OS07G0526400 PROTEIN', 244448),
(349026, 'PTHR11877:SF23', NULL, NULL, NULL, NULL, 'OS10G0168500 PROTEIN', 244448),
(349027, 'PTHR11877:SF65', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 244448),
(349028, 'PTHR11877:SF89', NULL, NULL, NULL, NULL, 'BNAC03G65730D PROTEIN', 244448),
(349029, 'PTHR11877:SF68', NULL, NULL, NULL, NULL, 'OS07G0501100 PROTEIN', 244448),
(349030, 'PTHR11877:SF29', NULL, NULL, NULL, NULL, 'TYPE III POLYKETIDE SYNTHASE B', 244448),
(349031, 'PTHR11877:SF69', NULL, NULL, NULL, NULL, 'CHALCONE SYNTHASE 8', 244448),
(349032, 'PTHR11877:SF49', NULL, NULL, NULL, NULL, 'OS04G0103900 PROTEIN', 244448),
(349033, 'PTHR16518:SF6', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 162-RELATED', 244449),
(349034, 'PTHR16518', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 153, 162', 244449),
(349035, 'PTHR16518:SF4', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR 153', 244449),
(349036, 'PTHR16518:SF5', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 153-RELATED', 244449),
(349037, 'PTHR10638:SF18', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 244450),
(349038, 'PTHR10638:SF20', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 244450),
(349039, 'PTHR10638:SF86', NULL, NULL, NULL, NULL, 'COPPER AMINE OXIDASE 1-RELATED', 244450),
(349040, 'PTHR10638:SF41', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 244450),
(349041, 'PTHR10638:SF85', NULL, NULL, NULL, NULL, 'MEMBRANE PRIMARY AMINE OXIDASE', 244450),
(349042, 'PTHR10638:SF22', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 244450),
(349043, 'PTHR10638:SF88', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 244450),
(349044, 'PTHR10638:SF87', NULL, NULL, NULL, NULL, 'AMINE OXIDASE-RELATED', 244450),
(349045, 'PTHR10638:SF82', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 244450),
(349046, 'PTHR10638:SF60', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 244450),
(349047, 'PTHR10638:SF81', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 244450),
(349048, 'PTHR10638:SF40', NULL, NULL, NULL, NULL, 'PRIMARY AMINE OXIDASE 1', 244450),
(349049, 'PTHR10638:SF84', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 244450),
(349050, 'PTHR10638:SF80', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 244450),
(349051, 'PTHR10638:SF68', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 244450),
(349052, 'PTHR10638:SF89', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 244450),
(349053, 'PTHR10638:SF67', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 244450),
(349054, 'PTHR10638:SF23', NULL, NULL, NULL, NULL, 'MEMBRANE PRIMARY AMINE OXIDASE', 244450),
(349055, 'PTHR10638:SF26', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 244450),
(349056, 'PTHR10638:SF69', NULL, NULL, NULL, NULL, 'AMINE OXIDASE-RELATED', 244450),
(349057, 'PTHR10638:SF25', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 244450),
(349058, 'PTHR10638:SF75', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 244450),
(349059, 'PTHR10638', NULL, NULL, NULL, NULL, 'COPPER AMINE OXIDASE', 244450),
(349060, 'PTHR10638:SF33', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 244450),
(349061, 'PTHR10638:SF77', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 244450),
(349062, 'PTHR10638:SF93', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 244450),
(349063, 'PTHR10638:SF71', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 244450),
(349064, 'PTHR10638:SF92', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 244450),
(349065, 'PTHR10638:SF91', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 244450),
(349066, 'PTHR10638:SF3', NULL, NULL, NULL, NULL, 'AMILORIDE-SENSITIVE AMINE OXIDASE [COPPER-CONTAINING]', 244450),
(349067, 'PTHR10638:SF4', NULL, NULL, NULL, NULL, 'RETINA-SPECIFIC COPPER AMINE OXIDASE', 244450),
(349068, 'PTHR10638:SF90', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 244450),
(349069, 'PTHR11726:SF35', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L16 DOMAIN-CONTAINING PROTEIN', 244451);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(349070, 'PTHR11726', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L10', 244451),
(349071, 'PTHR11726:SF36', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L10', 244451),
(349072, 'PTHR11726:SF29', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L10-LIKE', 244451),
(349073, 'PTHR11726:SF37', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L16 DOMAIN-CONTAINING PROTEIN', 244451),
(349074, 'PTHR11726:SF38', NULL, NULL, NULL, NULL, 'BNAA07G24130D PROTEIN', 244451),
(349075, 'PTHR11726:SF42', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L10-LIKE', 244451),
(349076, 'PTHR11726:SF10', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L10', 244451),
(349077, 'PTHR11726:SF43', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L10-1-RELATED', 244451),
(349078, 'PTHR11726:SF30', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L10-1', 244451),
(349079, 'PTHR11726:SF41', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L16 DOMAIN-CONTAINING PROTEIN', 244451),
(349080, 'PTHR36078:SF2', NULL, NULL, NULL, NULL, 'BNACNNG21220D PROTEIN', 244452),
(349081, 'PTHR36078:SF3', NULL, NULL, NULL, NULL, 'OS08G0487000 PROTEIN', 244452),
(349082, 'PTHR36078', NULL, NULL, NULL, NULL, 'BNACNNG21220D PROTEIN', 244452),
(349083, 'PTHR30353:SF0', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 244453),
(349084, 'PTHR30353:SF10', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YGHB', 244453),
(349085, 'PTHR30353:SF11', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YQJA', 244453),
(349086, 'PTHR30353:SF15', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YABI', 244453),
(349087, 'PTHR30353', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN DEDA-RELATED', 244453),
(349088, 'PTHR11703:SF2', NULL, NULL, NULL, NULL, 'DEOXYHYPUSINE SYNTHASE-LIKE PROTEIN', 244454),
(349089, 'PTHR11703:SF1', NULL, NULL, NULL, NULL, 'DEOXYHYPUSINE SYNTHASE', 244454),
(349090, 'PTHR11703', NULL, NULL, NULL, NULL, 'DEOXYHYPUSINE SYNTHASE', 244454),
(349091, 'PTHR11703:SF3', NULL, NULL, NULL, NULL, 'DEOXYHYPUSINE SYNTHASE', 244454),
(349092, 'PTHR11703:SF0', NULL, NULL, NULL, NULL, 'DEOXYHYPUSINE SYNTHASE', 244454),
(349093, 'PTHR30445:SF8', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN YBJL-RELATED', 244455),
(349094, 'PTHR30445', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244455),
(349095, 'PTHR30445:SF3', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN YIDE-RELATED', 244455),
(349096, 'PTHR15914', NULL, NULL, NULL, NULL, 'ALPHA-HEMOGLOBIN-STABILIZING PROTEIN', 244456),
(349097, 'PTHR15914:SF0', NULL, NULL, NULL, NULL, 'ALPHA-HEMOGLOBIN-STABILIZING PROTEIN', 244456),
(349098, 'PTHR30244:SF39', NULL, NULL, NULL, NULL, 'BLR3650 PROTEIN', 244457),
(349099, 'PTHR30244:SF36', NULL, NULL, NULL, NULL, '3-OXO-GLUCOSE-6-PHOSPHATE:GLUTAMATE AMINOTRANSFERASE', 244457),
(349100, 'PTHR30244:SF9', NULL, NULL, NULL, NULL, 'PROTEIN RV3402C', 244457),
(349101, 'PTHR30244:SF34', NULL, NULL, NULL, NULL, 'DTDP-4-AMINO-4,6-DIDEOXYGALACTOSE TRANSAMINASE', 244457),
(349102, 'PTHR30244:SF42', NULL, NULL, NULL, NULL, 'UDP-2-ACETAMIDO-2-DEOXY-3-OXO-D-GLUCURONATE AMINOTRANSFERASE', 244457),
(349103, 'PTHR30244:SF41', NULL, NULL, NULL, NULL, 'UDP-4-AMINO-4-DEOXY-L-ARABINOSE--OXOGLUTARATE AMINOTRANSFERASE', 244457),
(349104, 'PTHR30244:SF30', NULL, NULL, NULL, NULL, 'BLR5990 PROTEIN', 244457),
(349105, 'PTHR30244', NULL, NULL, NULL, NULL, 'TRANSAMINASE', 244457),
(349106, 'PTHR11091:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG12370', 244458),
(349107, 'PTHR11091:SF3', NULL, NULL, NULL, NULL, '2,3-DIKETO-L-GULONATE REDUCTASE', 244458),
(349108, 'PTHR11091', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE-RELATED', 244458),
(349109, 'PTHR11091:SF0', NULL, NULL, NULL, NULL, 'HYDROXYCARBOXYLATE DEHYDROGENASE B-RELATED', 244458),
(349110, 'PTHR40518', NULL, NULL, NULL, NULL, '', 244459),
(349111, 'PTHR40518:SF1', NULL, NULL, NULL, NULL, '', 244459),
(349112, 'PTHR10993:SF17', NULL, NULL, NULL, NULL, 'BPL/LPL CATALYTIC DOMAIN-CONTAINING PROTEIN', 244460),
(349113, 'PTHR10993:SF19', NULL, NULL, NULL, NULL, 'OCTANOYLTRANSFERASE', 244460),
(349114, 'PTHR10993:SF18', NULL, NULL, NULL, NULL, 'LIPOYL(OCTANOYL) TRANSFERASE', 244460);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(349115, 'PTHR10993:SF12', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P', 244460),
(349116, 'PTHR10993:SF15', NULL, NULL, NULL, NULL, 'OCTANOYLTRANSFERASE LIP2, MITOCHONDRIAL', 244460),
(349117, 'PTHR10993:SF7', NULL, NULL, NULL, NULL, 'LIPOYLTRANSFERASE 2, MITOCHONDRIAL-RELATED', 244460),
(349118, 'PTHR10993', NULL, NULL, NULL, NULL, 'OCTANOYLTRANSFERASE', 244460),
(349119, 'PTHR45916', NULL, NULL, NULL, NULL, 'STRUCTURAL MAINTENANCE OF CHROMOSOMES PROTEIN 5', 244461),
(349120, 'PTHR45916:SF1', NULL, NULL, NULL, NULL, 'STRUCTURAL MAINTENANCE OF CHROMOSOMES PROTEIN 5', 244461),
(349121, 'PTHR14386:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM204A', 244462),
(349122, 'PTHR14386', NULL, NULL, NULL, NULL, 'PROTEIN FAM204A', 244462),
(349123, 'PTHR28540', NULL, NULL, NULL, NULL, 'BCL2-ASSOCIATED AGONIST OF CELL DEATH', 244463),
(349124, 'PTHR28540:SF1', NULL, NULL, NULL, NULL, 'BCL2-ASSOCIATED AGONIST OF CELL DEATH', 244463),
(349125, 'PTHR11049:SF3', NULL, NULL, NULL, NULL, 'ACETYL-COENZYME A THIOESTERASE', 244464),
(349126, 'PTHR11049:SF31', NULL, NULL, NULL, NULL, 'HOTDOG ACOT-TYPE DOMAIN-CONTAINING PROTEIN', 244464),
(349127, 'PTHR11049:SF5', NULL, NULL, NULL, NULL, 'ACYL-COA THIOESTER HYDROLASE YCIA', 244464),
(349128, 'PTHR11049:SF1', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A THIOESTERASE 11', 244464),
(349129, 'PTHR11049:SF29', NULL, NULL, NULL, NULL, 'CYTOSOLIC ACYL COENZYME A THIOESTER HYDROLASE-LIKE-RELATED', 244464),
(349130, 'PTHR11049', NULL, NULL, NULL, NULL, 'ACYL COENZYME A THIOESTER HYDROLASE', 244464),
(349131, 'PTHR11049:SF24', NULL, NULL, NULL, NULL, 'CYTOSOLIC ACYL COENZYME A THIOESTER HYDROLASE', 244464),
(349132, 'PTHR11049:SF27', NULL, NULL, NULL, NULL, 'CYTOSOLIC ACYL COENZYME A THIOESTER HYDROLASE', 244464),
(349133, 'PTHR11049:SF16', NULL, NULL, NULL, NULL, 'PROTEIN VDLD', 244464),
(349134, 'PTHR43686:SF1', NULL, NULL, NULL, NULL, 'TRNA-CYTIDINE(32) 2-SULFURTRANSFERASE', 244465),
(349135, 'PTHR43686', NULL, NULL, NULL, NULL, 'SULFURTRANSFERASE-RELATED', 244465),
(349136, 'PTHR40130', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244466),
(349137, 'PTHR40130:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244466),
(349138, 'PTHR46583', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING 22', 244467),
(349139, 'PTHR46583:SF1', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING 22', 244467),
(349140, 'PTHR38032', NULL, NULL, NULL, NULL, 'POLYMERASE-RELATED', 244468),
(349141, 'PTHR38032:SF1', NULL, NULL, NULL, NULL, 'JAG_N DOMAIN-CONTAINING PROTEIN', 244468),
(349142, 'PTHR48051', NULL, NULL, NULL, NULL, '', 244469),
(349143, 'PTHR48051:SF20', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE ROCO9-RELATED', 244469),
(349144, 'PTHR48051:SF21', NULL, NULL, NULL, NULL, 'CALPONIN-HOMOLOGY (CH) DOMAIN-CONTAINING PROTEIN', 244469),
(349145, 'PTHR48051:SF22', NULL, NULL, NULL, NULL, 'VOLUME-REGULATED ANION CHANNEL SUBUNIT LRRC8C-LIKE', 244469),
(349146, 'PTHR48051:SF23', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND DEATH DOMAIN-CONTAINING PROTEIN 1', 244469),
(349147, 'PTHR48051:SF24', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN SOG2', 244469),
(349148, 'PTHR48051:SF25', NULL, NULL, NULL, NULL, 'PLANT INTRACELLULAR RAS-GROUP-RELATED LRR PROTEIN 9', 244469),
(349149, 'PTHR48051:SF26', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 244469),
(349150, 'PTHR48051:SF27', NULL, NULL, NULL, NULL, 'CONSERVED LEUCINE-RICH REPEAT PROTEIN (AFU_ORTHOLOGUE AFUA_4G04440)', 244469),
(349151, 'PTHR48051:SF2', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT CONTAINING 39', 244469),
(349152, 'PTHR48051:SF28', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND IQ DOMAIN-CONTAINING PROTEIN 4', 244469),
(349153, 'PTHR48051:SF1', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE-RELATED', 244469),
(349154, 'PTHR48051:SF29', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 244469),
(349155, 'PTHR48051:SF8', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEATS AND CALPONIN HOMOLOGY DOMAIN CONTAINING 3', 244469),
(349156, 'PTHR48051:SF4', NULL, NULL, NULL, NULL, 'CALPONIN-HOMOLOGY (CH) DOMAIN-CONTAINING PROTEIN', 244469);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(349157, 'PTHR48051:SF3', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT CONTAINING 8 VRAC SUBUNIT A', 244469),
(349158, 'PTHR48051:SF30', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 244469),
(349159, 'PTHR48051:SF31', NULL, NULL, NULL, NULL, 'ZGC:77287', 244469),
(349160, 'PTHR48051:SF10', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 1', 244469),
(349161, 'PTHR48051:SF32', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT CONTAINING 58', 244469),
(349162, 'PTHR48051:SF33', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN SHOC-2', 244469),
(349163, 'PTHR48051:SF34', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT CONTAINING 10B', 244469),
(349164, 'PTHR48051:SF12', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 28', 244469),
(349165, 'PTHR48051:SF13', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT CONTAINING 30', 244469),
(349166, 'PTHR48051:SF14', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEATS AND CALPONIN HOMOLOGY DOMAIN CONTAINING 2', 244469),
(349167, 'PTHR48051:SF15', NULL, NULL, NULL, NULL, 'PANNEXIN_LIKE DOMAIN-CONTAINING PROTEIN', 244469),
(349168, 'PTHR48051:SF16', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT CONTAINING 2', 244469),
(349169, 'PTHR48051:SF17', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN', 244469),
(349170, 'PTHR48051:SF19', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT AND STERILE ALPHA MOTIF CONTAINING 1', 244469),
(349171, 'PTHR33240:SF13', NULL, NULL, NULL, NULL, '', 244470),
(349172, 'PTHR33240:SF14', NULL, NULL, NULL, NULL, 'GAG/POL POLYPROTEIN', 244470),
(349173, 'PTHR33240:SF15', NULL, NULL, NULL, NULL, 'GAG-PRO-LIKE PROTEIN', 244470),
(349174, 'PTHR33240', NULL, NULL, NULL, NULL, 'OS08G0508500 PROTEIN', 244470),
(349175, 'PTHR33240:SF8', NULL, NULL, NULL, NULL, 'H0502G05.11 PROTEIN', 244470),
(349176, 'PTHR24567:SF74', NULL, NULL, NULL, NULL, 'ANAEROBIC REGULATORY PROTEIN', 244471),
(349177, 'PTHR24567:SF75', NULL, NULL, NULL, NULL, 'FUMARATE AND NITRATE REDUCTION REGULATORY PROTEIN', 244471),
(349178, 'PTHR24567:SF76', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN PROTEIN', 244471),
(349179, 'PTHR24567:SF65', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN CYSR HOMOLOG', 244471),
(349180, 'PTHR24567:SF77', NULL, NULL, NULL, NULL, 'NUCLEOSIDE-RESPONSIVE TRANSCRIPTIONAL ACTIVATOR OF NUCLEOSIDE UTILIZATION DEOR', 244471),
(349181, 'PTHR24567:SF28', NULL, NULL, NULL, NULL, 'LISTERIOLYSIN REGULATORY PROTEIN', 244471),
(349182, 'PTHR24567', NULL, NULL, NULL, NULL, 'CRP FAMILY TRANSCRIPTIONAL REGULATORY PROTEIN', 244471),
(349183, 'PTHR24567:SF68', NULL, NULL, NULL, NULL, 'CAMP-ACTIVATED GLOBAL TRANSCRIPTIONAL REGULATOR CRP', 244471),
(349184, 'PTHR24567:SF58', NULL, NULL, NULL, NULL, 'CYCLIC AMP-BINDING REGULATORY PROTEIN', 244471),
(349185, 'PTHR24567:SF26', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN YEIL', 244471),
(349186, 'PTHR45824:SF17', NULL, NULL, NULL, NULL, 'CRAL/TRIO DOMAIN CONTAINING PROTEIN, EXPRESSED', 244472),
(349187, 'PTHR45824:SF18', NULL, NULL, NULL, NULL, 'OS01G0264700 PROTEIN', 244472),
(349188, 'PTHR45824', NULL, NULL, NULL, NULL, 'GH16843P', 244472),
(349189, 'PTHR45824:SF19', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 244472),
(349190, 'PTHR45824:SF21', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 244472),
(349191, 'PTHR45824:SF10', NULL, NULL, NULL, NULL, 'SEC14P-LIKE PHOSPHATIDYLINOSITOL TRANSFER FAMILY PROTEIN', 244472),
(349192, 'PTHR45824:SF11', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 244472),
(349193, 'PTHR45824:SF22', NULL, NULL, NULL, NULL, 'SEC14P-LIKE PHOSPHATIDYLINOSITOL TRANSFER FAMILY PROTEIN', 244472),
(349194, 'PTHR45824:SF23', NULL, NULL, NULL, NULL, 'CELLULAR RETINALDEHYDE BINDING/ALPHA-TOCOPHEROL TRANSPORT-RELATED', 244472),
(349195, 'PTHR45824:SF24', NULL, NULL, NULL, NULL, 'CRAL-TRIO LIPID BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 244472),
(349196, 'PTHR45824:SF25', NULL, NULL, NULL, NULL, 'RANDOM SLUG PROTEIN 5-LIKE', 244472),
(349197, 'PTHR45824:SF14', NULL, NULL, NULL, NULL, 'SEC14P-LIKE PHOSPHATIDYLINOSITOL TRANSFER FAMILY PROTEIN', 244472);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(349198, 'PTHR45824:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL TRANSFER PROTEIN 3', 244472),
(349199, 'PTHR45824:SF26', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 244472),
(349200, 'PTHR45824:SF15', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 244472),
(349201, 'PTHR45824:SF16', NULL, NULL, NULL, NULL, 'SEC14P-LIKE PHOSPHATIDYLINOSITOL TRANSFER FAMILY PROTEIN', 244472),
(349202, 'PTHR45824:SF27', NULL, NULL, NULL, NULL, 'SEC14P-LIKE PHOSPHATIDYLINOSITOL TRANSFER FAMILY PROTEIN', 244472),
(349203, 'PTHR45824:SF5', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL TRANSFER PROTEIN PDR17', 244472),
(349204, 'PTHR45824:SF7', NULL, NULL, NULL, NULL, 'OS05G0267800 PROTEIN', 244472),
(349205, 'PTHR45824:SF6', NULL, NULL, NULL, NULL, 'GH16843P', 244472),
(349206, 'PTHR45824:SF9', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 244472),
(349207, 'PTHR45824:SF8', NULL, NULL, NULL, NULL, 'CRAL-TRIO LIPID BINDING DOMAIN, CRAL/TRIO DOMAIN-CONTAINING PROTEIN-RELATED', 244472),
(349208, 'PTHR10430:SF40', NULL, NULL, NULL, NULL, 'REDOXIN DOMAIN-CONTAINING PROTEIN', 244473),
(349209, 'PTHR10430:SF30', NULL, NULL, NULL, NULL, 'PEROXIREDOXIN PRXA-RELATED', 244473),
(349210, 'PTHR10430:SF36', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-DEPENDENT PEROXIREDOXIN', 244473),
(349211, 'PTHR10430:SF37', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-DEPENDENT PEROXIREDOXIN', 244473),
(349212, 'PTHR10430:SF38', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-DEPENDENT PEROXIREDOXIN', 244473),
(349213, 'PTHR10430:SF16', NULL, NULL, NULL, NULL, 'PEROXIREDOXIN-5, MITOCHONDRIAL', 244473),
(349214, 'PTHR10430:SF39', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE ASSOCIATED PROTEIN 20', 244473),
(349215, 'PTHR10430:SF32', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-DEPENDENT PEROXIREDOXIN', 244473),
(349216, 'PTHR10430:SF33', NULL, NULL, NULL, NULL, 'PEROXIREDOXIN-2E-1, CHLOROPLASTIC', 244473),
(349217, 'PTHR10430:SF34', NULL, NULL, NULL, NULL, 'PEROXIREDOXIN-2F, MITOCHONDRIAL', 244473),
(349218, 'PTHR10430:SF35', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-DEPENDENT PEROXIREDOXIN', 244473),
(349219, 'PTHR10430', NULL, NULL, NULL, NULL, 'PEROXIREDOXIN', 244473),
(349220, 'PTHR10430:SF8', NULL, NULL, NULL, NULL, 'PEROXIREDOXIN-2A-RELATED', 244473),
(349221, 'PTHR37306:SF1', NULL, NULL, NULL, NULL, 'COLICIN V PRODUCTION PROTEIN', 244474),
(349222, 'PTHR37306', NULL, NULL, NULL, NULL, 'COLICIN V PRODUCTION PROTEIN', 244474),
(349223, 'PTHR23060', NULL, NULL, NULL, NULL, 'TESTIS EXPRESSED GENE 14', 244475),
(349224, 'PTHR23060:SF1', NULL, NULL, NULL, NULL, 'INACTIVE SERINE/THREONINE-PROTEIN KINASE TEX14', 244475),
(349225, 'PTHR23060:SF3', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244475),
(349226, 'PTHR23060:SF2', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 33, OPPOSITE STRAND', 244475),
(349227, 'PTHR11742:SF91', NULL, NULL, NULL, NULL, 'ALPHA-1,2-MANNOSIDASE', 244476),
(349228, 'PTHR11742:SF6', NULL, NULL, NULL, NULL, 'MANNOSYL-OLIGOSACCHARIDE ALPHA-1,2-MANNOSIDASE IA-RELATED', 244476),
(349229, 'PTHR11742:SF100', NULL, NULL, NULL, NULL, 'ALPHA-1,2-MANNOSIDASE', 244476),
(349230, 'PTHR11742:SF101', NULL, NULL, NULL, NULL, 'MANNOSYL-OLIGOSACCHARIDE ALPHA-1,2-MANNOSIDASE 1B', 244476),
(349231, 'PTHR11742:SF102', NULL, NULL, NULL, NULL, 'MANNOSYL-OLIGOSACCHARIDE 1,2-ALPHA-MANNOSIDASE MNS2', 244476),
(349232, 'PTHR11742:SF49', NULL, NULL, NULL, NULL, 'ALPHA-1,2-MANNOSIDASE', 244476),
(349233, 'PTHR11742:SF29', NULL, NULL, NULL, NULL, 'ALPHA-1,2-MANNOSIDASE', 244476),
(349234, 'PTHR11742:SF28', NULL, NULL, NULL, NULL, 'MANNOSYL-OLIGOSACCHARIDE 1,2-ALPHA-MANNOSIDASE IC', 244476),
(349235, 'PTHR11742:SF96', NULL, NULL, NULL, NULL, 'MANNOSYL-OLIGOSACCHARIDE 1,2-ALPHA-MANNOSIDASE C52E4.5', 244476),
(349236, 'PTHR11742:SF85', NULL, NULL, NULL, NULL, 'ALPHA-1,2-MANNOSIDASE', 244476),
(349237, 'PTHR11742:SF84', NULL, NULL, NULL, NULL, 'ALPHA-1,2-MANNOSIDASE', 244476),
(349238, 'PTHR11742:SF40', NULL, NULL, NULL, NULL, 'MANNOSYL-OLIGOSACCHARIDE 1,2-ALPHA-MANNOSIDASE IB', 244476);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(349239, 'PTHR11742:SF95', NULL, NULL, NULL, NULL, 'ALPHA-1,2-MANNOSIDASE', 244476),
(349240, 'PTHR11742:SF94', NULL, NULL, NULL, NULL, 'ALPHA-1,2-MANNOSIDASE', 244476),
(349241, 'PTHR11742', NULL, NULL, NULL, NULL, 'MANNOSYL-OLIGOSACCHARIDE ALPHA-1,2-MANNOSIDASE-RELATED', 244476),
(349242, 'PTHR11742:SF89', NULL, NULL, NULL, NULL, 'ALPHA-1,2-MANNOSIDASE', 244476),
(349243, 'PTHR11742:SF88', NULL, NULL, NULL, NULL, 'ALPHA-1,2-MANNOSIDASE', 244476),
(349244, 'PTHR11742:SF55', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM MANNOSYL-OLIGOSACCHARIDE 1,2-ALPHA-MANNOSIDASE', 244476),
(349245, 'PTHR11742:SF99', NULL, NULL, NULL, NULL, 'ALPHA-1,2-MANNOSIDASE', 244476),
(349246, 'PTHR11742:SF31', NULL, NULL, NULL, NULL, 'MANNOSYL-OLIGOSACCHARIDE 1,2-ALPHA-MANNOSIDASE IA', 244476),
(349247, 'PTHR47900', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 131A', 244477),
(349248, 'PTHR47900:SF2', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 131B', 244477),
(349249, 'PTHR47900:SF1', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 131A', 244477),
(349250, 'PTHR32094', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA GROUP E PROTEIN', 244478),
(349251, 'PTHR32094:SF5', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA GROUP E PROTEIN', 244478),
(349252, 'PTHR42155', NULL, NULL, NULL, NULL, 'CATION CHANNEL SPERM-ASSOCIATED PROTEIN SUBUNIT ZETA', 244479),
(349253, 'PTHR42155:SF1', NULL, NULL, NULL, NULL, 'CATION CHANNEL SPERM-ASSOCIATED PROTEIN SUBUNIT ZETA', 244479),
(349254, 'PTHR48257', NULL, NULL, NULL, NULL, '', 244480),
(349255, 'PTHR48257:SF1', NULL, NULL, NULL, NULL, '', 244480),
(349256, 'PTHR43210:SF5', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DETHIOBIOTIN SYNTHETASE BIOD 1', 244481),
(349257, 'PTHR43210:SF2', NULL, NULL, NULL, NULL, 'DETHIOBIOTIN SYNTHETASE', 244481),
(349258, 'PTHR43210:SF4', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DETHIOBIOTIN SYNTHETASE BIOD 2', 244481),
(349259, 'PTHR43210', NULL, NULL, NULL, NULL, 'DETHIOBIOTIN SYNTHETASE', 244481),
(349260, 'PTHR36433:SF2', NULL, NULL, NULL, NULL, 'HYPOTHETICAL CYTOSOLIC PROTEIN', 244482),
(349261, 'PTHR36433', NULL, NULL, NULL, NULL, 'HYPOTHETICAL CYTOSOLIC PROTEIN', 244482),
(349262, 'PTHR34462:SF5', NULL, NULL, NULL, NULL, 'OS02G0582200 PROTEIN', 244483),
(349263, 'PTHR34462:SF4', NULL, NULL, NULL, NULL, '', 244483),
(349264, 'PTHR34462', NULL, NULL, NULL, NULL, 'OS05G0587400 PROTEIN', 244483),
(349265, 'PTHR34462:SF1', NULL, NULL, NULL, NULL, 'OS05G0587400 PROTEIN', 244483),
(349266, 'PTHR34462:SF3', NULL, NULL, NULL, NULL, 'INTRACELLULAR PROTEIN TRANSPORTER', 244483),
(349267, 'PTHR46188:SF4', NULL, NULL, NULL, NULL, 'BOLA-LIKE PROTEIN 3', 244484),
(349268, 'PTHR46188', NULL, NULL, NULL, NULL, 'BOLA-LIKE PROTEIN 3', 244484),
(349269, 'PTHR46188:SF1', NULL, NULL, NULL, NULL, 'BOLA-LIKE PROTEIN 3', 244484),
(349270, 'PTHR46188:SF2', NULL, NULL, NULL, NULL, 'CHROMOSOME 10, WHOLE GENOME SHOTGUN SEQUENCE', 244484),
(349271, 'PTHR46188:SF3', NULL, NULL, NULL, NULL, 'BOLA FAMILY MEMBER 3', 244484),
(349272, 'PTHR34179:SF1', NULL, NULL, NULL, NULL, 'TUMOR PROTEIN P53-INDUCIBLE PROTEIN 13', 244485),
(349273, 'PTHR34179', NULL, NULL, NULL, NULL, 'TUMOR PROTEIN P53-INDUCIBLE PROTEIN 13', 244485),
(349274, 'PTHR42970', NULL, NULL, NULL, NULL, 'PECTATE LYASE C-RELATED', 244486),
(349275, 'PTHR42970:SF1', NULL, NULL, NULL, NULL, 'PECTATE LYASE C-RELATED', 244486),
(349276, 'PTHR17070', NULL, NULL, NULL, NULL, 'DEXAMETHASONE-INDUCED PROTEIN', 244487),
(349277, 'PTHR17070:SF0', NULL, NULL, NULL, NULL, 'DEXAMETHASONE-INDUCED PROTEIN', 244487),
(349278, 'PTHR12811', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING VPS16', 244488),
(349279, 'PTHR12811:SF0', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 16 HOMOLOG', 244488),
(349280, 'PTHR33976', NULL, NULL, NULL, NULL, 'OS07G0645000 PROTEIN', 244489),
(349281, 'PTHR33976:SF8', NULL, NULL, NULL, NULL, 'OS07G0645000 PROTEIN', 244489),
(349282, 'PTHR33976:SF7', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN MEMBRANE GPI-ANCHORED PROTEIN', 244489),
(349283, 'PTHR33976:SF10', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN MEMBRANE GPI-ANCHORED PROTEIN', 244489);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(349284, 'PTHR33976:SF11', NULL, NULL, NULL, NULL, '', 244489),
(349285, 'PTHR33976:SF9', NULL, NULL, NULL, NULL, 'BNAANNG08770D PROTEIN', 244489),
(349286, 'PTHR33976:SF12', NULL, NULL, NULL, NULL, 'BNAANNG03060D PROTEIN', 244489),
(349287, 'PTHR33976:SF13', NULL, NULL, NULL, NULL, 'BNAANNG08780D PROTEIN', 244489),
(349288, 'PTHR33976:SF14', NULL, NULL, NULL, NULL, 'BNAC03G34510D PROTEIN', 244489),
(349289, 'PTHR33976:SF15', NULL, NULL, NULL, NULL, '', 244489),
(349290, 'PTHR33976:SF2', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN MEMBRANE GPI-ANCHORED', 244489),
(349291, 'PTHR11820:SF108', NULL, NULL, NULL, NULL, 'ACYLPYRUVASE FAHD2, MITOCHONDRIAL-RELATED', 244490),
(349292, 'PTHR11820:SF109', NULL, NULL, NULL, NULL, 'FAA_HYDROLASE DOMAIN-CONTAINING PROTEIN', 244490),
(349293, 'PTHR11820:SF106', NULL, NULL, NULL, NULL, 'ACYLPYRUVASE FAHD1, MITOCHONDRIAL', 244490),
(349294, 'PTHR11820:SF7', NULL, NULL, NULL, NULL, 'ACYLPYRUVASE FAHD1, MITOCHONDRIAL', 244490),
(349295, 'PTHR11820:SF107', NULL, NULL, NULL, NULL, 'FAA_HYDROLASE DOMAIN-CONTAINING PROTEIN', 244490),
(349296, 'PTHR11820:SF8', NULL, NULL, NULL, NULL, 'BLL6360 PROTEIN', 244490),
(349297, 'PTHR11820:SF86', NULL, NULL, NULL, NULL, 'FUMARYLACETOACETATE HYDROLASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_7G07000)', 244490),
(349298, 'PTHR11820:SF105', NULL, NULL, NULL, NULL, 'FAA_HYDROLASE DOMAIN-CONTAINING PROTEIN', 244490),
(349299, 'PTHR11820', NULL, NULL, NULL, NULL, 'ACYLPYRUVASE', 244490),
(349300, 'PTHR11820:SF114', NULL, NULL, NULL, NULL, '4-HYDROXYPHENYLACETATE CATABOLISM PROTEIN', 244490),
(349301, 'PTHR11820:SF90', NULL, NULL, NULL, NULL, 'FLUTATHIONE S-TRANSFERASE-RELATED', 244490),
(349302, 'PTHR11820:SF111', NULL, NULL, NULL, NULL, 'FUMARYLACETOACETATE (FAA) HYDROLASE FAMILY', 244490),
(349303, 'PTHR11820:SF100', NULL, NULL, NULL, NULL, 'FUMARYLACETOACETATE HYDROLASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_4G01490)', 244490),
(349304, 'PTHR11820:SF112', NULL, NULL, NULL, NULL, 'FUMARYLACETOACETATE HYDROLASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_1G02370)-RELATED', 244490),
(349305, 'PTHR35279:SF3', NULL, NULL, NULL, NULL, '', 244491),
(349306, 'PTHR35279:SF4', NULL, NULL, NULL, NULL, '', 244491),
(349307, 'PTHR35279', NULL, NULL, NULL, NULL, '', 244491),
(349308, 'PTHR35279:SF1', NULL, NULL, NULL, NULL, 'ARABINANASE/LEVANSUCRASE/INVERTASE', 244491),
(349309, 'PTHR22941:SF7', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349310, 'PTHR22941:SF8', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349311, 'PTHR22941:SF6', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349312, 'PTHR22941:SF13', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349313, 'PTHR22941:SF34', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H-RELATED', 244492),
(349314, 'PTHR22941:SF33', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349315, 'PTHR22941:SF11', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349316, 'PTHR22941:SF32', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349317, 'PTHR22941:SF4', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349318, 'PTHR22941:SF51', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349319, 'PTHR22941:SF293', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349320, 'PTHR22941:SF2', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349321, 'PTHR22941:SF295', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS I', 244492),
(349322, 'PTHR22941:SF173', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349323, 'PTHR22941:SF19', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349324, 'PTHR22941:SF131', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349325, 'PTHR22941:SF18', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349326, 'PTHR22941:SF299', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349327, 'PTHR22941:SF134', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(349328, 'PTHR22941:SF16', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349329, 'PTHR22941:SF155', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349330, 'PTHR22941:SF133', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349331, 'PTHR22941:SF136', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349332, 'PTHR22941:SF36', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349333, 'PTHR22941:SF303', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349334, 'PTHR22941:SF302', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349335, 'PTHR22941:SF305', NULL, NULL, NULL, NULL, 'PROTEIN CBG09143', 244492),
(349336, 'PTHR22941', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR', 244492),
(349337, 'PTHR22941:SF304', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349338, 'PTHR22941:SF21', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349339, 'PTHR22941:SF20', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349340, 'PTHR22941:SF64', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349341, 'PTHR22941:SF161', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349342, 'PTHR22941:SF163', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349343, 'PTHR22941:SF28', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349344, 'PTHR22941:SF167', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349345, 'PTHR22941:SF27', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349346, 'PTHR22941:SF188', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349347, 'PTHR22941:SF301', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349348, 'PTHR22941:SF48', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H-RELATED', 244492),
(349349, 'PTHR22941:SF26', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349350, 'PTHR22941:SF300', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 244492),
(349351, 'PTHR23114:SF17', NULL, NULL, NULL, NULL, 'M7GPPPN-MRNA HYDROLASE', 244493),
(349352, 'PTHR23114:SF26', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 244493),
(349353, 'PTHR23114:SF25', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 244493),
(349354, 'PTHR23114:SF22', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 244493),
(349355, 'PTHR23114:SF20', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 244493),
(349356, 'PTHR23114', NULL, NULL, NULL, NULL, 'M7GPPPN-MRNA HYDROLASE', 244493),
(349357, 'PTHR14003:SF12', NULL, NULL, NULL, NULL, 'OS05G0106000 PROTEIN', 244494),
(349358, 'PTHR14003:SF8', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 42 HOMOLOG', 244494),
(349359, 'PTHR14003:SF20', NULL, NULL, NULL, NULL, 'FINGER DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G10380)-RELATED', 244494),
(349360, 'PTHR14003:SF10', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR PROTEIN YY1', 244494),
(349361, 'PTHR14003:SF11', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR YY2', 244494),
(349362, 'PTHR14003', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR PROTEIN YY', 244494),
(349363, 'PTHR14003:SF17', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR YY2', 244494),
(349364, 'PTHR14003:SF18', NULL, NULL, NULL, NULL, '', 244494),
(349365, 'PTHR14003:SF1', NULL, NULL, NULL, NULL, 'GENE 12845-RELATED', 244494),
(349366, 'PTHR14003:SF19', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR YY1-RELATED', 244494),
(349367, 'PTHR33470', NULL, NULL, NULL, NULL, 'OS01G0164075 PROTEIN', 244495),
(349368, 'PTHR33470:SF39', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 3-LIKE', 244495),
(349369, 'PTHR33470:SF17', NULL, NULL, NULL, NULL, 'PISTIL-SPECIFIC EXTENSIN-LIKE PROTEIN', 244495),
(349370, 'PTHR33470:SF36', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 1-LIKE', 244495),
(349371, 'PTHR33470:SF38', NULL, NULL, NULL, NULL, 'BNAA09G40040D PROTEIN', 244495);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(349372, 'PTHR33470:SF54', NULL, NULL, NULL, NULL, 'NON-CLASSICAL ARABINOGALACTAN PROTEIN 30-LIKE', 244495),
(349373, 'PTHR33470:SF53', NULL, NULL, NULL, NULL, 'POLLEN OLE E 1 ALLERGEN AND EXTENSIN FAMILY PROTEIN', 244495),
(349374, 'PTHR33470:SF31', NULL, NULL, NULL, NULL, 'NON-CLASSICAL ARABINOGALACTAN PROTEIN 31-LIKE', 244495),
(349375, 'PTHR33470:SF56', NULL, NULL, NULL, NULL, 'PROTEIN SEED AND ROOT HAIR PROTECTIVE PROTEIN', 244495),
(349376, 'PTHR33470:SF55', NULL, NULL, NULL, NULL, 'NON-CLASSICAL ARABINOGALACTAN PROTEIN 30', 244495),
(349377, 'PTHR33470:SF50', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 1-RELATED', 244495),
(349378, 'PTHR33470:SF52', NULL, NULL, NULL, NULL, '', 244495),
(349379, 'PTHR33470:SF30', NULL, NULL, NULL, NULL, 'PISTIL-SPECIFIC EXTENSIN-LIKE PROTEIN', 244495),
(349380, 'PTHR33470:SF4', NULL, NULL, NULL, NULL, 'OS01G0164025 PROTEIN', 244495),
(349381, 'PTHR33470:SF51', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN PROTEIN 30-RELATED', 244495),
(349382, 'PTHR33470:SF8', NULL, NULL, NULL, NULL, 'OS05G0531200 PROTEIN', 244495),
(349383, 'PTHR33470:SF29', NULL, NULL, NULL, NULL, 'POLLEN OLE E 1 ALLERGEN AND EXTENSIN FAMILY PROTEIN', 244495),
(349384, 'PTHR33470:SF47', NULL, NULL, NULL, NULL, '', 244495),
(349385, 'PTHR33470:SF46', NULL, NULL, NULL, NULL, '', 244495),
(349386, 'PTHR33470:SF27', NULL, NULL, NULL, NULL, 'OS01G0899700 PROTEIN', 244495),
(349387, 'PTHR33470:SF43', NULL, NULL, NULL, NULL, 'OS05G0531400 PROTEIN', 244495),
(349388, 'PTHR33470:SF21', NULL, NULL, NULL, NULL, 'NON-CLASSICAL ARABINOGALACTAN PROTEIN 31', 244495),
(349389, 'PTHR33470:SF42', NULL, NULL, NULL, NULL, '', 244495),
(349390, 'PTHR33470:SF20', NULL, NULL, NULL, NULL, 'POLLEN OLE E 1 ALLERGEN AND EXTENSIN FAMILY PROTEIN', 244495),
(349391, 'PTHR33470:SF23', NULL, NULL, NULL, NULL, 'POLLEN OLE E I FAMILY ALLERGEN', 244495),
(349392, 'PTHR33470:SF22', NULL, NULL, NULL, NULL, 'POLLEN OLE E 1 ALLERGEN AND EXTENSIN FAMILY PROTEIN', 244495),
(349393, 'PTHR33470:SF44', NULL, NULL, NULL, NULL, 'BNAANNG22480D PROTEIN', 244495),
(349394, 'PTHR33470:SF41', NULL, NULL, NULL, NULL, 'BNAA09G27390D PROTEIN', 244495),
(349395, 'PTHR33470:SF40', NULL, NULL, NULL, NULL, 'PISTIL-SPECIFIC EXTENSIN-LIKE PROTEIN', 244495),
(349396, 'PTHR11848:SF4', NULL, NULL, NULL, NULL, 'BMP-LIKE PROTEIN UNC-129', 244496),
(349397, 'PTHR11848:SF151', NULL, NULL, NULL, NULL, 'EMBRYONIC GROWTH/DIFFERENTIATION FACTOR 1', 244496),
(349398, 'PTHR11848:SF272', NULL, NULL, NULL, NULL, 'NODAL-RELATED 2', 244496),
(349399, 'PTHR11848:SF33', NULL, NULL, NULL, NULL, 'LATENCY-ASSOCIATED PEPTIDE', 244496),
(349400, 'PTHR11848:SF273', NULL, NULL, NULL, NULL, 'NODAL-RELATED 1', 244496),
(349401, 'PTHR11848:SF6', NULL, NULL, NULL, NULL, 'INHIBIN BETA E CHAIN', 244496),
(349402, 'PTHR11848:SF270', NULL, NULL, NULL, NULL, 'TGF_BETA_2 DOMAIN-CONTAINING PROTEIN', 244496),
(349403, 'PTHR11848:SF150', NULL, NULL, NULL, NULL, 'GROWTH/DIFFERENTIATION FACTOR 8', 244496),
(349404, 'PTHR11848:SF119', NULL, NULL, NULL, NULL, 'BONE MORPHOGENETIC PROTEIN 8A-RELATED', 244496),
(349405, 'PTHR11848:SF117', NULL, NULL, NULL, NULL, 'INHIBIN ALPHA CHAIN', 244496),
(349406, 'PTHR11848:SF232', NULL, NULL, NULL, NULL, 'LEFT-RIGHT DETERMINATION FACTOR 2', 244496),
(349407, 'PTHR11848:SF277', NULL, NULL, NULL, NULL, 'TGF_BETA_2 DOMAIN-CONTAINING PROTEIN', 244496),
(349408, 'PTHR11848:SF159', NULL, NULL, NULL, NULL, 'NODAL HOMOLOG', 244496),
(349409, 'PTHR11848:SF29', NULL, NULL, NULL, NULL, 'INHIBIN BETA B CHAIN', 244496),
(349410, 'PTHR11848:SF278', NULL, NULL, NULL, NULL, 'GROWTH/DIFFERENTIATION FACTOR 8', 244496),
(349411, 'PTHR11848:SF157', NULL, NULL, NULL, NULL, 'GROWTH/DIFFERENTIATION FACTOR 2', 244496),
(349412, 'PTHR11848:SF279', NULL, NULL, NULL, NULL, 'PROTEIN DBL-1', 244496),
(349413, 'PTHR11848:SF181', NULL, NULL, NULL, NULL, 'LEFT-RIGHT DETERMINATION FACTOR 1', 244496),
(349414, 'PTHR11848:SF43', NULL, NULL, NULL, NULL, 'GROWTH/DIFFERENTIATION FACTOR 6', 244496),
(349415, 'PTHR11848:SF141', NULL, NULL, NULL, NULL, 'TRANSFORMING GROWTH FACTOR BETA-2 PROPROTEIN', 244496);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(349416, 'PTHR11848:SF44', NULL, NULL, NULL, NULL, 'GROWTH/DIFFERENTIATION FACTOR 5', 244496),
(349417, 'PTHR11848:SF262', NULL, NULL, NULL, NULL, 'DAWDLE, ISOFORM A-RELATED', 244496),
(349418, 'PTHR11848:SF144', NULL, NULL, NULL, NULL, 'BONE MORPHOGENETIC PROTEIN 3', 244496),
(349419, 'PTHR11848:SF265', NULL, NULL, NULL, NULL, 'GROWTH DIFFERENTIATION FACTOR 10B', 244496),
(349420, 'PTHR11848:SF145', NULL, NULL, NULL, NULL, 'GROWTH/DIFFERENTIATION FACTOR 10', 244496),
(349421, 'PTHR11848:SF78', NULL, NULL, NULL, NULL, 'GROWTH/DIFFERENTIATION FACTOR 15', 244496),
(349422, 'PTHR11848:SF34', NULL, NULL, NULL, NULL, 'TRANSFORMING GROWTH FACTOR BETA-3 PROPROTEIN', 244496),
(349423, 'PTHR11848:SF263', NULL, NULL, NULL, NULL, 'PROTEIN DECAPENTAPLEGIC', 244496),
(349424, 'PTHR11848:SF143', NULL, NULL, NULL, NULL, 'BONE MORPHOGENETIC PROTEIN 2', 244496),
(349425, 'PTHR11848:SF226', NULL, NULL, NULL, NULL, 'LEFT-RIGHT DETERMINATION FACTOR', 244496),
(349426, 'PTHR11848:SF38', NULL, NULL, NULL, NULL, 'GROWTH/DIFFERENTIATION FACTOR 3', 244496),
(349427, 'PTHR11848:SF268', NULL, NULL, NULL, NULL, 'PROTEIN 60A-RELATED', 244496),
(349428, 'PTHR11848:SF39', NULL, NULL, NULL, NULL, 'BONE MORPHOGENETIC PROTEIN 10', 244496),
(349429, 'PTHR11848:SF290', NULL, NULL, NULL, NULL, 'INHIBIN SUBUNIT BETA AB', 244496),
(349430, 'PTHR11848:SF130', NULL, NULL, NULL, NULL, 'INHIBIN BETA C CHAIN', 244496),
(349431, 'PTHR11848:SF139', NULL, NULL, NULL, NULL, 'BONE MORPHOGENETIC PROTEIN 5', 244496),
(349432, 'PTHR11848:SF133', NULL, NULL, NULL, NULL, 'INHIBIN BETA A CHAIN', 244496),
(349433, 'PTHR11848:SF175', NULL, NULL, NULL, NULL, 'LEFT-RIGHT DETERMINATION FACTOR 2', 244496),
(349434, 'PTHR11848:SF132', NULL, NULL, NULL, NULL, 'BONE MORPHOGENETIC PROTEIN 8B', 244496),
(349435, 'PTHR11848:SF137', NULL, NULL, NULL, NULL, 'BONE MORPHOGENETIC PROTEIN 6', 244496),
(349436, 'PTHR11848:SF135', NULL, NULL, NULL, NULL, 'BONE MORPHOGENETIC PROTEIN 7', 244496),
(349437, 'PTHR11848:SF257', NULL, NULL, NULL, NULL, 'LEFT-RIGHT DETERMINATION FACTOR 1', 244496),
(349438, 'PTHR11848:SF280', NULL, NULL, NULL, NULL, 'TGF_BETA_2 DOMAIN-CONTAINING PROTEIN', 244496),
(349439, 'PTHR11848:SF283', NULL, NULL, NULL, NULL, 'TGF_BETA_2 DOMAIN-CONTAINING PROTEIN', 244496),
(349440, 'PTHR11848:SF284', NULL, NULL, NULL, NULL, 'TGF_BETA_2 DOMAIN-CONTAINING PROTEIN', 244496),
(349441, 'PTHR11848:SF22', NULL, NULL, NULL, NULL, 'BONE MORPHOGENETIC PROTEIN 15', 244496),
(349442, 'PTHR11848:SF281', NULL, NULL, NULL, NULL, 'INHIBIN BETA CHAIN', 244496),
(349443, 'PTHR11848:SF160', NULL, NULL, NULL, NULL, 'GROWTH/DIFFERENTIATION FACTOR 7', 244496),
(349444, 'PTHR11848:SF282', NULL, NULL, NULL, NULL, 'TGFB_PROPEPTIDE DOMAIN-CONTAINING PROTEIN', 244496),
(349445, 'PTHR11848:SF249', NULL, NULL, NULL, NULL, 'TRANSFORMING GROWTH FACTOR BETA', 244496),
(349446, 'PTHR11848', NULL, NULL, NULL, NULL, 'TGF-BETA FAMILY', 244496),
(349447, 'PTHR11848:SF166', NULL, NULL, NULL, NULL, 'GROWTH/DIFFERENTIATION FACTOR 11', 244496),
(349448, 'PTHR11848:SF243', NULL, NULL, NULL, NULL, 'TGF_BETA_2 DOMAIN-CONTAINING PROTEIN', 244496),
(349449, 'PTHR11848:SF287', NULL, NULL, NULL, NULL, 'LEFT-RIGHT DETERMINATION FACTOR', 244496),
(349450, 'PTHR11848:SF288', NULL, NULL, NULL, NULL, 'MAVERICK', 244496),
(349451, 'PTHR11848:SF241', NULL, NULL, NULL, NULL, 'ANTI-DORSALIZING MORPHOGENETIC PROTEIN', 244496),
(349452, 'PTHR11848:SF285', NULL, NULL, NULL, NULL, 'GROWTH/DIFFERENTIATION FACTOR 6-B', 244496),
(349453, 'PTHR11848:SF165', NULL, NULL, NULL, NULL, 'BONE MORPHOGENETIC PROTEIN 4', 244496),
(349454, 'PTHR11848:SF286', NULL, NULL, NULL, NULL, 'PROTEIN DVR-1 HOMOLOG', 244496),
(349455, 'PTHR11848:SF19', NULL, NULL, NULL, NULL, 'GROWTH/DIFFERENTIATION FACTOR 9', 244496),
(349456, 'PTHR11848:SF289', NULL, NULL, NULL, NULL, 'GONADAL SOMA DERIVED FACTOR', 244496),
(349457, 'PTHR11848:SF125', NULL, NULL, NULL, NULL, 'TRANSFORMING GROWTH FACTOR BETA-1 PROPROTEIN', 244496),
(349458, 'PTHR11848:SF246', NULL, NULL, NULL, NULL, 'BONE MORPHOGENETIC PROTEIN 16', 244496),
(349459, 'PTHR47184:SF2', NULL, NULL, NULL, NULL, 'SYMPLEKIN/PTA1-RELATED', 244497);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(349460, 'PTHR47184', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 3-AND 4-KINASE FAMILY PROTEIN-RELATED', 244497),
(349461, 'PTHR47184:SF3', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 3-AND 4-KINASE FAMILY PROTEIN-RELATED', 244497),
(349462, 'PTHR13651:SF0', NULL, NULL, NULL, NULL, 'PROTEIN ABITRAM', 244498),
(349463, 'PTHR13651', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244498),
(349464, 'PTHR43054', NULL, NULL, NULL, NULL, '', 244499),
(349465, 'PTHR43054:SF1', NULL, NULL, NULL, NULL, 'SCYLLO-INOSITOL 2-DEHYDROGENASE (NADP(+)) IOLU', 244499),
(349466, 'PTHR31704:SF45', NULL, NULL, NULL, NULL, 'L10-INTERACTING MYB DOMAIN-CONTAINING PROTEIN-LIKE', 244500),
(349467, 'PTHR31704:SF33', NULL, NULL, NULL, NULL, 'L10-INTERACTING MYB DOMAIN-CONTAINING PROTEIN', 244500),
(349468, 'PTHR31704:SF43', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN', 244500),
(349469, 'PTHR31704:SF53', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 244500),
(349470, 'PTHR31704:SF42', NULL, NULL, NULL, NULL, 'BNAA01G30910D PROTEIN', 244500),
(349471, 'PTHR31704:SF52', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DOMAIN, HARBINGER TRANSPOSASE-DERIVED NUCLEASE DOMAIN PROTEIN-RELATED', 244500),
(349472, 'PTHR31704:SF41', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DNA-BINDING DOMAIN PROTEIN', 244500),
(349473, 'PTHR31704:SF40', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DOMAIN, HARBINGER TRANSPOSASE-DERIVED NUCLEASE DOMAIN PROTEIN-RELATED', 244500),
(349474, 'PTHR31704:SF51', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DNA-BINDING DOMAIN PROTEIN', 244500),
(349475, 'PTHR31704:SF50', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 244500),
(349476, 'PTHR31704', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DNA-BINDING DOMAIN PROTEIN-RELATED', 244500),
(349477, 'PTHR31704:SF49', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DNA-BINDING DOMAIN PROTEIN', 244500),
(349478, 'PTHR31704:SF48', NULL, NULL, NULL, NULL, 'L10-INTERACTING MYB DOMAIN-CONTAINING PROTEIN-LIKE', 244500),
(349479, 'PTHR31704:SF37', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN', 244500),
(349480, 'PTHR47477:SF6', NULL, NULL, NULL, NULL, 'TRAF-LIKE SUPERFAMILY PROTEIN', 244501),
(349481, 'PTHR47477:SF12', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 244501),
(349482, 'PTHR47477:SF8', NULL, NULL, NULL, NULL, 'TNF RECEPTOR-ASSOCIATED FACTOR HOMOLOG 1A', 244501),
(349483, 'PTHR47477:SF15', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 244501),
(349484, 'PTHR47477:SF16', NULL, NULL, NULL, NULL, 'ZF-HD DIMERIZATION-TYPE DOMAIN-CONTAINING PROTEIN', 244501),
(349485, 'PTHR47477:SF5', NULL, NULL, NULL, NULL, 'TNF RECEPTOR-ASSOCIATED FACTOR HOMOLOG 1B', 244501),
(349486, 'PTHR47477:SF14', NULL, NULL, NULL, NULL, 'MEPRIN AND TRAF (MATH)-LIKE DOMAIN PROTEIN', 244501),
(349487, 'PTHR47477', NULL, NULL, NULL, NULL, 'TNF RECEPTOR-ASSOCIATED FACTOR HOMOLOG 1A', 244501),
(349488, 'PTHR47477:SF17', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 244501),
(349489, 'PTHR47477:SF18', NULL, NULL, NULL, NULL, 'TRAF-LIKE SUPERFAMILY PROTEIN', 244501),
(349490, 'PTHR36914', NULL, NULL, NULL, NULL, '', 244502),
(349491, 'PTHR36914:SF1', NULL, NULL, NULL, NULL, '', 244502),
(349492, 'PTHR36914:SF2', NULL, NULL, NULL, NULL, '', 244502),
(349493, 'PTHR45806:SF1', NULL, NULL, NULL, NULL, 'SYNAPTOBREVIN HOMOLOG YKT6', 244503),
(349494, 'PTHR45806:SF5', NULL, NULL, NULL, NULL, 'SYNAPTOBREVIN, LONGIN-LIKE DOMAIN PROTEIN-RELATED', 244503),
(349495, 'PTHR45806:SF13', NULL, NULL, NULL, NULL, 'OS01G0964000 PROTEIN', 244503),
(349496, 'PTHR45806', NULL, NULL, NULL, NULL, 'SYNAPTOBREVIN HOMOLOG YKT6', 244503),
(349497, 'PTHR45806:SF2', NULL, NULL, NULL, NULL, 'SYNAPTOBREVIN HOMOLOG YKT6-RELATED', 244503),
(349498, 'PTHR45806:SF10', NULL, NULL, NULL, NULL, 'BNAA10G29290D PROTEIN', 244503),
(349499, 'PTHR45806:SF7', NULL, NULL, NULL, NULL, 'SYNAPTOBREVIN-LIKE PROTEIN-RELATED', 244503),
(349500, 'PTHR45806:SF6', NULL, NULL, NULL, NULL, 'BNAA02G07810D PROTEIN', 244503),
(349501, 'PTHR31045:SF30', NULL, NULL, NULL, NULL, 'PLAC8 FAMILY PROTEIN', 244504);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(349502, 'PTHR31045:SF21', NULL, NULL, NULL, NULL, '', 244504),
(349503, 'PTHR31045:SF32', NULL, NULL, NULL, NULL, 'TERPENOID SYNTHASE 28-RELATED', 244504),
(349504, 'PTHR31045:SF27', NULL, NULL, NULL, NULL, 'PLAC8 FAMILY PROTEIN', 244504),
(349505, 'PTHR31045:SF16', NULL, NULL, NULL, NULL, 'OS12G0109633 PROTEIN', 244504),
(349506, 'PTHR31045:SF38', NULL, NULL, NULL, NULL, 'TERPENE_SYNTH DOMAIN-CONTAINING PROTEIN', 244504),
(349507, 'PTHR31045:SF29', NULL, NULL, NULL, NULL, 'ALPHA-BARBATENE SYNTHASE-RELATED', 244504),
(349508, 'PTHR31045:SF39', NULL, NULL, NULL, NULL, 'TERPENOID SYNTHASE 15-RELATED', 244504),
(349509, 'PTHR31045:SF28', NULL, NULL, NULL, NULL, 'PLAC8 MOTIF-CONTAINING PROTEIN-RELATED', 244504),
(349510, 'PTHR31045:SF34', NULL, NULL, NULL, NULL, '(Z)-GAMMA-BISABOLENE SYNTHASE 1-RELATED', 244504),
(349511, 'PTHR31045:SF23', NULL, NULL, NULL, NULL, 'OS01G0825900 PROTEIN', 244504),
(349512, 'PTHR31045:SF33', NULL, NULL, NULL, NULL, 'TERPENOID SYNTHASE 16-RELATED', 244504),
(349513, 'PTHR31045:SF8', NULL, NULL, NULL, NULL, 'OS05G0341900 PROTEIN', 244504),
(349514, 'PTHR31045:SF25', NULL, NULL, NULL, NULL, 'TERPENOID SYNTHASE 1-RELATED', 244504),
(349515, 'PTHR31045:SF24', NULL, NULL, NULL, NULL, 'PLAC8 FAMILY PROTEIN', 244504),
(349516, 'PTHR31045:SF4', NULL, NULL, NULL, NULL, 'TERPENOID SYNTHASE 17-RELATED', 244504),
(349517, 'PTHR31045:SF19', NULL, NULL, NULL, NULL, 'OS03G0299800 PROTEIN', 244504),
(349518, 'PTHR31045:SF3', NULL, NULL, NULL, NULL, 'OS11G0109700 PROTEIN', 244504),
(349519, 'PTHR31045', NULL, NULL, NULL, NULL, 'PLAC8 FAMILY PROTEIN-RELATED', 244504),
(349520, 'PTHR35740:SF1', NULL, NULL, NULL, NULL, 'OS12G0111700 PROTEIN', 244505),
(349521, 'PTHR35740', NULL, NULL, NULL, NULL, 'OS12G0111700 PROTEIN', 244505),
(349522, 'PTHR35740:SF4', NULL, NULL, NULL, NULL, 'BNAA09G35720D PROTEIN', 244505),
(349523, 'PTHR35740:SF2', NULL, NULL, NULL, NULL, '', 244505),
(349524, 'PTHR22839:SF0', NULL, NULL, NULL, NULL, 'THO COMPLEX SUBUNIT 3', 244506),
(349525, 'PTHR22839:SF1', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 244506),
(349526, 'PTHR22839', NULL, NULL, NULL, NULL, 'THO COMPLEX SUBUNIT 3  THO3', 244506),
(349527, 'PTHR37347:SF1', NULL, NULL, NULL, NULL, 'MEGAKARYOCYTE AND PLATELET INHIBITORY RECEPTOR G6B', 244507),
(349528, 'PTHR37347', NULL, NULL, NULL, NULL, 'MEGAKARYOCYTE AND PLATELET INHIBITORY RECEPTOR G6B', 244507),
(349529, 'PTHR45821', NULL, NULL, NULL, NULL, 'SNF2 DOMAIN-CONTAINING PROTEIN CLASSY 2-RELATED', 244508),
(349530, 'PTHR45821:SF25', NULL, NULL, NULL, NULL, 'SNF2-RELATED, N-TERMINAL DOMAIN-CONTAINING PROTEIN-RELATED', 244508),
(349531, 'PTHR45821:SF14', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT HELICASE', 244508),
(349532, 'PTHR45821:SF17', NULL, NULL, NULL, NULL, 'HELICASE ATP-BINDING DOMAIN-CONTAINING PROTEIN', 244508),
(349533, 'PTHR45821:SF9', NULL, NULL, NULL, NULL, 'CHROMATIN REMODELING 34', 244508),
(349534, 'PTHR45821:SF8', NULL, NULL, NULL, NULL, 'SNF2 DOMAIN-CONTAINING PROTEIN CLASSY 1', 244508),
(349535, 'PTHR45821:SF19', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT HELICASE', 244508),
(349536, 'PTHR45821:SF7', NULL, NULL, NULL, NULL, '', 244508),
(349537, 'PTHR45821:SF6', NULL, NULL, NULL, NULL, 'SNF2 DOMAIN-CONTAINING PROTEIN CLASSY 3', 244508),
(349538, 'PTHR45821:SF5', NULL, NULL, NULL, NULL, 'SNF2 DOMAIN-CONTAINING PROTEIN CLASSY 4', 244508),
(349539, 'PTHR45821:SF11', NULL, NULL, NULL, NULL, 'OS02G0650800 PROTEIN', 244508),
(349540, 'PTHR45821:SF22', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT HELICASE', 244508),
(349541, 'PTHR45821:SF24', NULL, NULL, NULL, NULL, 'SNF2_N DOMAIN-CONTAINING PROTEIN', 244508),
(349542, 'PTHR45821:SF12', NULL, NULL, NULL, NULL, 'OS03G0165266 PROTEIN', 244508),
(349543, 'PTHR45821:SF23', NULL, NULL, NULL, NULL, 'SNF2-RELATED, N-TERMINAL DOMAIN-CONTAINING PROTEIN-RELATED', 244508),
(349544, 'PTHR45821:SF2', NULL, NULL, NULL, NULL, 'SNF2 DOMAIN-CONTAINING PROTEIN CLASSY 2', 244508),
(349545, 'PTHR45821:SF1', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT HELICASE FAMILY PROTEIN-RELATED', 244508),
(349546, 'PTHR14392', NULL, NULL, NULL, NULL, 'NIBAN FAMILY MEMBER', 244509);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(349547, 'PTHR14392:SF3', NULL, NULL, NULL, NULL, 'PROTEIN NIBAN 1', 244509),
(349548, 'PTHR14392:SF2', NULL, NULL, NULL, NULL, 'PROTEIN NIBAN 2', 244509),
(349549, 'PTHR14392:SF4', NULL, NULL, NULL, NULL, 'PROTEIN NIBAN 3', 244509),
(349550, 'PTHR14392:SF8', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN DDB_G0267786', 244509),
(349551, 'PTHR21356:SF1', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING PROTEIN 2', 244510),
(349552, 'PTHR21356', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT CONTAINING 2', 244510),
(349553, 'PTHR32191:SF49', NULL, NULL, NULL, NULL, 'TETRASPANIN/PERIPHERIN-RELATED', 244511),
(349554, 'PTHR32191:SF47', NULL, NULL, NULL, NULL, 'TETRASPANIN-14-RELATED', 244511),
(349555, 'PTHR32191:SF48', NULL, NULL, NULL, NULL, 'TETRASPANIN-2-LIKE', 244511),
(349556, 'PTHR32191:SF89', NULL, NULL, NULL, NULL, 'TETRASPANIN/PERIPHERIN-RELATED', 244511),
(349557, 'PTHR32191:SF45', NULL, NULL, NULL, NULL, 'TETRASPANIN-8-LIKE', 244511),
(349558, 'PTHR32191:SF46', NULL, NULL, NULL, NULL, 'TETRASPANIN-3', 244511),
(349559, 'PTHR32191:SF43', NULL, NULL, NULL, NULL, 'TETRASPANIN-11', 244511),
(349560, 'PTHR32191:SF87', NULL, NULL, NULL, NULL, 'OS05G0126100 PROTEIN', 244511),
(349561, 'PTHR32191:SF44', NULL, NULL, NULL, NULL, 'OS08G0260600 PROTEIN', 244511),
(349562, 'PTHR32191:SF88', NULL, NULL, NULL, NULL, 'TETRASPANIN-8', 244511),
(349563, 'PTHR32191:SF2', NULL, NULL, NULL, NULL, 'TETRASPANIN-7', 244511),
(349564, 'PTHR32191:SF1', NULL, NULL, NULL, NULL, 'TETRASPANIN-6', 244511),
(349565, 'PTHR32191:SF85', NULL, NULL, NULL, NULL, '', 244511),
(349566, 'PTHR32191:SF42', NULL, NULL, NULL, NULL, 'TETRASPANIN-9', 244511),
(349567, 'PTHR32191:SF83', NULL, NULL, NULL, NULL, '', 244511),
(349568, 'PTHR32191:SF84', NULL, NULL, NULL, NULL, 'BNAC01G14980D PROTEIN', 244511),
(349569, 'PTHR32191:SF81', NULL, NULL, NULL, NULL, 'TETRASPANIN/PERIPHERIN-RELATED', 244511),
(349570, 'PTHR32191:SF82', NULL, NULL, NULL, NULL, 'BNAA10G11690D PROTEIN', 244511),
(349571, 'PTHR32191:SF80', NULL, NULL, NULL, NULL, 'BNAC05G14210D PROTEIN', 244511),
(349572, 'PTHR32191:SF16', NULL, NULL, NULL, NULL, 'OS02G0728800 PROTEIN', 244511),
(349573, 'PTHR32191:SF14', NULL, NULL, NULL, NULL, 'PROTEIN TORNADO 2', 244511),
(349574, 'PTHR32191:SF58', NULL, NULL, NULL, NULL, 'TETRASPANIN-8-LIKE', 244511),
(349575, 'PTHR32191:SF59', NULL, NULL, NULL, NULL, 'PROTEIN TORNADO 2-LIKE', 244511),
(349576, 'PTHR32191:SF56', NULL, NULL, NULL, NULL, 'TETRASPANIN-13', 244511),
(349577, 'PTHR32191:SF57', NULL, NULL, NULL, NULL, '', 244511),
(349578, 'PTHR32191', NULL, NULL, NULL, NULL, 'TETRASPANIN-8-RELATED', 244511),
(349579, 'PTHR32191:SF55', NULL, NULL, NULL, NULL, 'TETRASPANIN-11', 244511),
(349580, 'PTHR32191:SF18', NULL, NULL, NULL, NULL, 'OS08G0443800 PROTEIN', 244511),
(349581, 'PTHR32191:SF52', NULL, NULL, NULL, NULL, 'TETRASPANIN-4', 244511),
(349582, 'PTHR32191:SF50', NULL, NULL, NULL, NULL, 'TETRASPANIN-16-RELATED', 244511),
(349583, 'PTHR32191:SF51', NULL, NULL, NULL, NULL, 'TETRASPANIN-5', 244511),
(349584, 'PTHR32191:SF90', NULL, NULL, NULL, NULL, 'TETRASPANIN-12', 244511),
(349585, 'PTHR32191:SF91', NULL, NULL, NULL, NULL, 'TETRASPANIN-19-LIKE ISOFORM X1', 244511),
(349586, 'PTHR32191:SF69', NULL, NULL, NULL, NULL, 'SENESCENCE-ASSOCIATED PROTEIN', 244511),
(349587, 'PTHR32191:SF67', NULL, NULL, NULL, NULL, 'BNACNNG41940D PROTEIN', 244511),
(349588, 'PTHR32191:SF23', NULL, NULL, NULL, NULL, 'OS02G0219800 PROTEIN', 244511),
(349589, 'PTHR32191:SF68', NULL, NULL, NULL, NULL, 'BNAA09G44070D PROTEIN', 244511),
(349590, 'PTHR32191:SF65', NULL, NULL, NULL, NULL, 'TETRASPANIN-8-LIKE', 244511),
(349591, 'PTHR32191:SF22', NULL, NULL, NULL, NULL, 'TETRASPANIN-10', 244511),
(349592, 'PTHR32191:SF66', NULL, NULL, NULL, NULL, 'BNAA06G40190D PROTEIN', 244511),
(349593, 'PTHR32191:SF63', NULL, NULL, NULL, NULL, 'TETRASPANIN/PERIPHERIN-RELATED', 244511),
(349594, 'PTHR32191:SF64', NULL, NULL, NULL, NULL, 'BNAA09G44080D PROTEIN', 244511),
(349595, 'PTHR32191:SF61', NULL, NULL, NULL, NULL, 'TETRASPANIN-2-LIKE', 244511),
(349596, 'PTHR32191:SF78', NULL, NULL, NULL, NULL, 'BNAA03G48970D PROTEIN', 244511);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(349597, 'PTHR32191:SF76', NULL, NULL, NULL, NULL, 'BNAA09G09890D PROTEIN', 244511),
(349598, 'PTHR32191:SF77', NULL, NULL, NULL, NULL, 'TETRASPANIN-3-LIKE', 244511),
(349599, 'PTHR32191:SF0', NULL, NULL, NULL, NULL, 'TETRASPANIN-2', 244511),
(349600, 'PTHR32191:SF72', NULL, NULL, NULL, NULL, 'OS09G0425900 PROTEIN', 244511),
(349601, 'PTHR32191:SF73', NULL, NULL, NULL, NULL, 'BNAA09G41810D PROTEIN', 244511),
(349602, 'PTHR32191:SF70', NULL, NULL, NULL, NULL, 'BNAA02G36810D PROTEIN', 244511),
(349603, 'PTHR32191:SF71', NULL, NULL, NULL, NULL, 'TETRASPANIN6-RELATED', 244511),
(349604, 'PTHR33215', NULL, NULL, NULL, NULL, 'PROTEIN DISTAL ANTENNA', 244512),
(349605, 'PTHR33215:SF11', NULL, NULL, NULL, NULL, 'BLR1542 PROTEIN', 244512),
(349606, 'PTHR33215:SF10', NULL, NULL, NULL, NULL, 'BSR1972 PROTEIN', 244512),
(349607, 'PTHR33215:SF13', NULL, NULL, NULL, NULL, 'PROTEIN DISTAL ANTENNA', 244512),
(349608, 'PTHR33215:SF12', NULL, NULL, NULL, NULL, 'TRANSPOSASE INSN FOR INSERTION SEQUENCE ELEMENT IS911A-RELATED', 244512),
(349609, 'PTHR33215:SF6', NULL, NULL, NULL, NULL, 'TRANSPOSASE INSE FOR INSERTION SEQUENCE IS3A-RELATED', 244512),
(349610, 'PTHR47361', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 244513),
(349611, 'PTHR47361:SF5', NULL, NULL, NULL, NULL, 'RING FINGER', 244513),
(349612, 'PTHR47361:SF4', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 244513),
(349613, 'PTHR47361:SF6', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 244513),
(349614, 'PTHR10142:SF0', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN COMPLEMENTING XP-A CELLS', 244514),
(349615, 'PTHR10142', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN COMPLEMENTING XP-A CELLS', 244514),
(349616, 'PTHR47012:SF1', NULL, NULL, NULL, NULL, 'LAMIN TAIL DOMAIN-CONTAINING PROTEIN 1', 244515),
(349617, 'PTHR47012', NULL, NULL, NULL, NULL, 'LAMIN TAIL DOMAIN-CONTAINING PROTEIN 1', 244515),
(349618, 'PTHR34044:SF3', NULL, NULL, NULL, NULL, '', 244516),
(349619, 'PTHR34044:SF2', NULL, NULL, NULL, NULL, 'BNAA06G10780D PROTEIN', 244516),
(349620, 'PTHR34044:SF1', NULL, NULL, NULL, NULL, 'NUCLEAR PROTEIN', 244516),
(349621, 'PTHR34044', NULL, NULL, NULL, NULL, 'NUCLEAR PROTEIN', 244516),
(349622, 'PTHR36679:SF1', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE S', 244517),
(349623, 'PTHR36679', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE S', 244517),
(349624, 'PTHR14625', NULL, NULL, NULL, NULL, 'MICROCEPHALIN', 244518),
(349625, 'PTHR14625:SF3', NULL, NULL, NULL, NULL, 'MICROCEPHALIN', 244518),
(349626, 'PTHR46543:SF2', NULL, NULL, NULL, NULL, 'AGAP013096-PA', 244519),
(349627, 'PTHR46543:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER CCHC DOMAIN-CONTAINING PROTEIN 7', 244519),
(349628, 'PTHR46543', NULL, NULL, NULL, NULL, 'ZINC FINGER CCHC DOMAIN-CONTAINING PROTEIN 7', 244519),
(349629, 'PTHR48163', NULL, NULL, NULL, NULL, 'BNAC02G25670D PROTEIN', 244520),
(349630, 'PTHR48163:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244520),
(349631, 'PTHR36445:SF1', NULL, NULL, NULL, NULL, 'GTP CYCLOHYDROLASE FOLE2', 244521),
(349632, 'PTHR36445', NULL, NULL, NULL, NULL, 'GTP CYCLOHYDROLASE MPTA', 244521),
(349633, 'PTHR21094:SF2', NULL, NULL, NULL, NULL, 'GOLGI SNAP RECEPTOR COMPLEX MEMBER 1', 244522),
(349634, 'PTHR21094:SF0', NULL, NULL, NULL, NULL, 'GOLGI SNAP RECEPTOR COMPLEX MEMBER 1-1', 244522),
(349635, 'PTHR21094', NULL, NULL, NULL, NULL, 'GOS-28 SNARE- RELATED', 244522),
(349636, 'PTHR21094:SF5', NULL, NULL, NULL, NULL, 'GOLGI SNAP RECEPTOR COMPLEX MEMBER 1', 244522),
(349637, 'PTHR21094:SF4', NULL, NULL, NULL, NULL, 'GOLGI SNAP RECEPTOR COMPLEX MEMBER 1', 244522),
(349638, 'PTHR21094:SF3', NULL, NULL, NULL, NULL, 'GOLGI SNAP RECEPTOR COMPLEX MEMBER 1', 244522),
(349639, 'PTHR31803:SF26', NULL, NULL, NULL, NULL, 'UBIQUINOL OXIDASE', 244523),
(349640, 'PTHR31803:SF25', NULL, NULL, NULL, NULL, 'UBIQUINOL OXIDASE', 244523),
(349641, 'PTHR31803:SF35', NULL, NULL, NULL, NULL, 'UBIQUINOL OXIDASE', 244523),
(349642, 'PTHR31803:SF24', NULL, NULL, NULL, NULL, 'UBIQUINOL OXIDASE', 244523),
(349643, 'PTHR31803:SF19', NULL, NULL, NULL, NULL, 'UBIQUINOL OXIDASE', 244523);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(349644, 'PTHR31803:SF18', NULL, NULL, NULL, NULL, 'UBIQUINOL OXIDASE 1B, MITOCHONDRIAL-RELATED', 244523),
(349645, 'PTHR31803:SF28', NULL, NULL, NULL, NULL, 'UBIQUINOL OXIDASE', 244523),
(349646, 'PTHR31803:SF34', NULL, NULL, NULL, NULL, 'UBIQUINOL OXIDASE 1C, MITOCHONDRIAL', 244523),
(349647, 'PTHR31803:SF3', NULL, NULL, NULL, NULL, 'ALTERNATIVE OXIDASE', 244523),
(349648, 'PTHR31803:SF33', NULL, NULL, NULL, NULL, 'ALTERNATIVE OXIDASE', 244523),
(349649, 'PTHR31803:SF10', NULL, NULL, NULL, NULL, 'UBIQUINOL OXIDASE 4, CHLOROPLASTIC/CHROMOPLASTIC', 244523),
(349650, 'PTHR31803', NULL, NULL, NULL, NULL, 'ALTERNATIVE OXIDASE', 244523),
(349651, 'PTHR31803:SF20', NULL, NULL, NULL, NULL, 'ALTERNATIVE OXIDASE 3, MITOCHONDRIAL', 244523),
(349652, 'PTHR31803:SF6', NULL, NULL, NULL, NULL, 'UBIQUINOL OXIDASE 2, MITOCHONDRIAL', 244523),
(349653, 'PTHR31803:SF7', NULL, NULL, NULL, NULL, 'UBIQUINOL OXIDASE 3, MITOCHONDRIAL', 244523),
(349654, 'PTHR31803:SF8', NULL, NULL, NULL, NULL, 'UBIQUINOL OXIDASE 1B, MITOCHONDRIAL', 244523),
(349655, 'PTHR20883:SF19', NULL, NULL, NULL, NULL, 'MULTIFUNCTIONAL DIOXYGENASE AUSE', 244524),
(349656, 'PTHR20883:SF49', NULL, NULL, NULL, NULL, '', 244524),
(349657, 'PTHR20883:SF15', NULL, NULL, NULL, NULL, 'PHYTANOYL-COA DIOXYGENASE DOMAIN-CONTAINING PROTEIN 1', 244524),
(349658, 'PTHR20883:SF48', NULL, NULL, NULL, NULL, 'ECTOINE DIOXYGENASE', 244524),
(349659, 'PTHR20883:SF14', NULL, NULL, NULL, NULL, '', 244524),
(349660, 'PTHR20883:SF47', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 244524),
(349661, 'PTHR20883:SF46', NULL, NULL, NULL, NULL, 'PHYTANOYL-COA HYDROXYLASE', 244524),
(349662, 'PTHR20883:SF45', NULL, NULL, NULL, NULL, '', 244524),
(349663, 'PTHR20883:SF43', NULL, NULL, NULL, NULL, '', 244524),
(349664, 'PTHR20883:SF41', NULL, NULL, NULL, NULL, 'IRON/ALPHA-KETOGLUTARATE-DEPENDENT DIOXYGENASE ASQJ', 244524),
(349665, 'PTHR20883:SF40', NULL, NULL, NULL, NULL, 'BNAC09G20570D PROTEIN', 244524),
(349666, 'PTHR20883', NULL, NULL, NULL, NULL, 'PHYTANOYL-COA DIOXYGENASE DOMAIN CONTAINING 1', 244524),
(349667, 'PTHR20883:SF50', NULL, NULL, NULL, NULL, '', 244524),
(349668, 'PTHR40074', NULL, NULL, NULL, NULL, 'O-ACETYLTRANSFERASE WECH', 244525),
(349669, 'PTHR40074:SF3', NULL, NULL, NULL, NULL, 'MEMBRANE-BOUND ACYLTRANSFERASE YFIQ-RELATED', 244525),
(349670, 'PTHR40074:SF2', NULL, NULL, NULL, NULL, 'O-ACETYLTRANSFERASE WECH', 244525),
(349671, 'PTHR40074:SF4', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YCFT', 244525),
(349672, 'PTHR33173', NULL, NULL, NULL, NULL, '', 244526),
(349673, 'PTHR33173:SF2', NULL, NULL, NULL, NULL, 'MYND-TYPE DOMAIN-CONTAINING PROTEIN', 244526),
(349674, 'PTHR44252:SF1', NULL, NULL, NULL, NULL, 'CARBONYL REDUCTASE [NADPH] 2', 244527),
(349675, 'PTHR44252', NULL, NULL, NULL, NULL, 'D-ERYTHRULOSE REDUCTASE', 244527),
(349676, 'PTHR44252:SF3', NULL, NULL, NULL, NULL, 'D-ERYTHRULOSE REDUCTASE', 244527),
(349677, 'PTHR44252:SF2', NULL, NULL, NULL, NULL, 'L-XYLULOSE REDUCTASE', 244527),
(349678, 'PTHR33670:SF25', NULL, NULL, NULL, NULL, 'OS01G0384800 PROTEIN', 244528),
(349679, 'PTHR33670:SF14', NULL, NULL, NULL, NULL, 'T20H2.15 PROTEIN', 244528),
(349680, 'PTHR33670:SF23', NULL, NULL, NULL, NULL, 'BNAA08G31170D PROTEIN', 244528),
(349681, 'PTHR33670:SF11', NULL, NULL, NULL, NULL, '', 244528),
(349682, 'PTHR33670:SF1', NULL, NULL, NULL, NULL, 'OS09G0416300 PROTEIN', 244528),
(349683, 'PTHR33670', NULL, NULL, NULL, NULL, 'SPLICING FACTOR, PROLINE- AND GLUTAMINE-RICH-LIKE', 244528),
(349684, 'PTHR33670:SF18', NULL, NULL, NULL, NULL, 'BNAA09G41050D PROTEIN', 244528),
(349685, 'PTHR33670:SF17', NULL, NULL, NULL, NULL, 'BNAA03G51870D PROTEIN', 244528),
(349686, 'PTHR33670:SF27', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 244528),
(349687, 'PTHR33670:SF26', NULL, NULL, NULL, NULL, 'BNAA06G14220D PROTEIN', 244528),
(349688, 'PTHR33670:SF15', NULL, NULL, NULL, NULL, 'OS02G0797600 PROTEIN', 244528),
(349689, 'PTHR15126', NULL, NULL, NULL, NULL, 'SH3-BINDING', 244529),
(349690, 'PTHR15126:SF4', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-BINDING PROTEIN 2', 244529);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(349691, 'PTHR21359', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244530),
(349692, 'PTHR21359:SF1', NULL, NULL, NULL, NULL, 'LD36945P', 244530),
(349693, 'PTHR45909:SF1', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-RELATED PROTEIN 1', 244531),
(349694, 'PTHR45909', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-RELATED PROTEIN 1', 244531),
(349695, 'PTHR45909:SF2', NULL, NULL, NULL, NULL, 'OS07G0620400 PROTEIN', 244531),
(349696, 'PTHR45909:SF3', NULL, NULL, NULL, NULL, 'BNAA03G12710D PROTEIN', 244531),
(349697, 'PTHR15238:SF1', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN L39, MITOCHONDRIAL', 244532),
(349698, 'PTHR15238', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN L39, MITOCHONDRIAL', 244532),
(349699, 'PTHR47221:SF4', NULL, NULL, NULL, NULL, 'FIBRINOGEN GAMMA CHAIN', 244533),
(349700, 'PTHR47221:SF3', NULL, NULL, NULL, NULL, 'FIBRINOGEN ALPHA CHAIN', 244533),
(349701, 'PTHR47221:SF2', NULL, NULL, NULL, NULL, 'FIBRINOGEN BETA CHAIN', 244533),
(349702, 'PTHR47221', NULL, NULL, NULL, NULL, 'FIBRINOGEN ALPHA CHAIN', 244533),
(349703, 'PTHR37252', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN-INTERACTING PROTEIN 6', 244534),
(349704, 'PTHR37252:SF2', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN-INTERACTING PROTEIN 5', 244534),
(349705, 'PTHR37252:SF3', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN-INTERACTING PROTEIN 6', 244534),
(349706, 'PTHR42783', NULL, NULL, NULL, NULL, 'GLUTAMATE SYNTHASE [NADPH] SMALL CHAIN', 244535),
(349707, 'PTHR42783:SF3', NULL, NULL, NULL, NULL, 'GLUTAMATE SYNTHASE [NADPH] SMALL CHAIN', 244535),
(349708, 'PTHR42783:SF1', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE AEGA-RELATED', 244535),
(349709, 'PTHR31715', NULL, NULL, NULL, NULL, 'UREASE ACCESSORY PROTEIN G', 244536),
(349710, 'PTHR31715:SF0', NULL, NULL, NULL, NULL, 'UREASE ACCESSORY PROTEIN G', 244536),
(349711, 'PTHR36398', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE FUSION PROTEIN', 244537),
(349712, 'PTHR36398:SF1', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE FUSION PROTEIN', 244537),
(349713, 'PTHR30621', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE ADENYLYLTRANSFERASE', 244538),
(349714, 'PTHR30621:SF0', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL GLUTAMINE SYNTHETASE ADENYLYLTRANSFERASE/ADENYLYL-REMOVING ENZYME', 244538),
(349715, 'PTHR33280', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L31, CHLOROPLASTIC', 244539),
(349716, 'PTHR33280:SF1', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L31, CHLOROPLASTIC', 244539),
(349717, 'PTHR33280:SF6', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L31', 244539),
(349718, 'PTHR33280:SF5', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L31', 244539),
(349719, 'PTHR23410:SF25', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L18_C DOMAIN-CONTAINING PROTEIN', 244540),
(349720, 'PTHR23410:SF12', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L5', 244540),
(349721, 'PTHR23410:SF34', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L5-1 HOMOLOG B', 244540),
(349722, 'PTHR23410:SF23', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L18_C DOMAIN-CONTAINING PROTEIN', 244540),
(349723, 'PTHR23410:SF24', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L5', 244540),
(349724, 'PTHR23410:SF35', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L5-1-RELATED', 244540),
(349725, 'PTHR23410:SF33', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L5-LIKE', 244540),
(349726, 'PTHR23410:SF22', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L5-LIKE', 244540),
(349727, 'PTHR23410', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L5-RELATED', 244540),
(349728, 'PTHR23410:SF20', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L5-LIKE', 244540),
(349729, 'PTHR39228', NULL, NULL, NULL, NULL, 'LORICRIN', 244541),
(349730, 'PTHR39228:SF1', NULL, NULL, NULL, NULL, 'LORICRIN', 244541),
(349731, 'PTHR39228:SF2', NULL, NULL, NULL, NULL, '', 244541),
(349732, 'PTHR10806:SF21', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE I', 244542),
(349733, 'PTHR10806:SF31', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE I', 244542),
(349734, 'PTHR10806:SF30', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE I', 244542),
(349735, 'PTHR10806:SF36', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE COMPLEX CATALYTIC SUBUNIT SEC11A', 244542);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(349736, 'PTHR10806:SF25', NULL, NULL, NULL, NULL, 'PHOSPHOPROTEIN PHOSPHATASE INHIBITORS', 244542),
(349737, 'PTHR10806:SF35', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE I', 244542),
(349738, 'PTHR10806', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE COMPLEX CATALYTIC SUBUNIT SEC11', 244542),
(349739, 'PTHR10806:SF12', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE COMPLEX CATALYTIC SUBUNIT SEC11C', 244542),
(349740, 'PTHR10806:SF22', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE COMPLEX CATALYTIC SUBUNIT SEC11A-LIKE', 244542),
(349741, 'PTHR10806:SF33', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE I', 244542),
(349742, 'PTHR10806:SF39', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE I', 244542),
(349743, 'PTHR10806:SF28', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE COMPLEX CATALYTIC SUBUNIT SEC11B-RELATED', 244542),
(349744, 'PTHR10806:SF38', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE COMPLEX CATALYTIC SUBUNIT SEC11', 244542),
(349745, 'PTHR10806:SF27', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE I', 244542),
(349746, 'PTHR10806:SF37', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE COMPLEX CATALYTIC SUBUNIT SEC11', 244542),
(349747, 'PTHR10806:SF26', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE I', 244542),
(349748, 'PTHR10806:SF6', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE COMPLEX CATALYTIC SUBUNIT SEC11', 244542),
(349749, 'PTHR45953', NULL, NULL, NULL, NULL, 'IDURONATE 2-SULFATASE', 244543),
(349750, 'PTHR45953:SF1', NULL, NULL, NULL, NULL, 'IDURONATE 2-SULFATASE', 244543),
(349751, 'PTHR33120:SF39', NULL, NULL, NULL, NULL, 'OS01G0314000 PROTEIN', 244544),
(349752, 'PTHR33120:SF59', NULL, NULL, NULL, NULL, '', 244544),
(349753, 'PTHR33120:SF48', NULL, NULL, NULL, NULL, '', 244544),
(349754, 'PTHR33120:SF49', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 244544),
(349755, 'PTHR33120:SF16', NULL, NULL, NULL, NULL, '', 244544),
(349756, 'PTHR33120:SF53', NULL, NULL, NULL, NULL, '', 244544),
(349757, 'PTHR33120:SF42', NULL, NULL, NULL, NULL, 'OS12G0105000 PROTEIN', 244544),
(349758, 'PTHR33120:SF43', NULL, NULL, NULL, NULL, '', 244544),
(349759, 'PTHR33120:SF54', NULL, NULL, NULL, NULL, '', 244544),
(349760, 'PTHR33120:SF51', NULL, NULL, NULL, NULL, '', 244544),
(349761, 'PTHR33120:SF52', NULL, NULL, NULL, NULL, '', 244544),
(349762, 'PTHR33120:SF57', NULL, NULL, NULL, NULL, '', 244544),
(349763, 'PTHR33120:SF47', NULL, NULL, NULL, NULL, 'OS05G0571400 PROTEIN', 244544),
(349764, 'PTHR33120:SF44', NULL, NULL, NULL, NULL, '', 244544),
(349765, 'PTHR33120:SF55', NULL, NULL, NULL, NULL, '', 244544),
(349766, 'PTHR33120', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', 244544),
(349767, 'PTHR33120:SF60', NULL, NULL, NULL, NULL, '', 244544),
(349768, 'PTHR33120:SF61', NULL, NULL, NULL, NULL, 'OS03G0697833 PROTEIN', 244544),
(349769, 'PTHR33120:SF5', NULL, NULL, NULL, NULL, '', 244544),
(349770, 'PTHR40394', NULL, NULL, NULL, NULL, 'LIPOPROTEIN-RELATED', 244545),
(349771, 'PTHR40394:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME C DOMAIN-CONTAINING PROTEIN', 244545),
(349772, 'PTHR47618', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL OLIGORIBONUCLEASE AND PAP PHOSPHATASE NRNA', 244546),
(349773, 'PTHR47618:SF1', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL OLIGORIBONUCLEASE AND PAP PHOSPHATASE NRNA', 244546),
(349774, 'PTHR47618:SF2', NULL, NULL, NULL, NULL, 'CYCLIC-DI-AMP PHOSPHODIESTERASE GDPP', 244546),
(349775, 'PTHR40089', NULL, NULL, NULL, NULL, 'ETHANOLAMINE UTILIZATION PROTEIN EUTH', 244547),
(349776, 'PTHR40089:SF1', NULL, NULL, NULL, NULL, 'ETHANOLAMINE PERMEASE EUTH-RELATED', 244547),
(349777, 'PTHR34631:SF3', NULL, NULL, NULL, NULL, 'ISSOD12 TRANSPOSASE TNPA_ISSOD12', 244548),
(349778, 'PTHR34631', NULL, NULL, NULL, NULL, '', 244548),
(349779, 'PTHR23080:SF137', NULL, NULL, NULL, NULL, '', 244549),
(349780, 'PTHR23080:SF136', NULL, NULL, NULL, NULL, 'SI:DKEY-56D12.4-RELATED', 244549),
(349781, 'PTHR23080:SF139', NULL, NULL, NULL, NULL, 'DDE TNP4 DOMAIN-CONTAINING PROTEIN', 244549),
(349782, 'PTHR23080', NULL, NULL, NULL, NULL, 'THAP DOMAIN PROTEIN', 244549),
(349783, 'PTHR23080:SF138', NULL, NULL, NULL, NULL, '', 244549);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(349784, 'PTHR23080:SF63', NULL, NULL, NULL, NULL, 'THAP-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', 244549),
(349785, 'PTHR23080:SF140', NULL, NULL, NULL, NULL, 'CATHELICIDIN-LIKE ANTIMICROBIAL PROTEIN, ISOFORM A', 244549),
(349786, 'PTHR23080:SF141', NULL, NULL, NULL, NULL, 'HTH_TNP_4 DOMAIN-CONTAINING PROTEIN', 244549),
(349787, 'PTHR23080:SF133', NULL, NULL, NULL, NULL, 'SI:CH211-262I1.5-RELATED', 244549),
(349788, 'PTHR46724', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 9-RELATED', 244550),
(349789, 'PTHR46724:SF1', NULL, NULL, NULL, NULL, 'ADP RIBOSYLATION FACTOR LIKE GTPASE 10', 244550),
(349790, 'PTHR46724:SF2', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 9', 244550),
(349791, 'PTHR43874:SF209', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ARR12', 244551),
(349792, 'PTHR43874', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR', 244551),
(349793, 'PTHR43874:SF82', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ARR20-RELATED', 244551),
(349794, 'PTHR43874:SF207', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 244551),
(349795, 'PTHR43874:SF208', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ARR18', 244551),
(349796, 'PTHR43874:SF205', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ORR23', 244551),
(349797, 'PTHR43874:SF206', NULL, NULL, NULL, NULL, 'RESPONSE REGULATOR RECEIVER DOMAIN PROTEIN', 244551),
(349798, 'PTHR43874:SF203', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 244551),
(349799, 'PTHR43874:SF126', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 244551),
(349800, 'PTHR43874:SF204', NULL, NULL, NULL, NULL, '', 244551),
(349801, 'PTHR43874:SF161', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR', 244551),
(349802, 'PTHR43874:SF78', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 244551),
(349803, 'PTHR43874:SF201', NULL, NULL, NULL, NULL, 'CYTOKININ RESPOSNE REGULATOR 9', 244551),
(349804, 'PTHR43874:SF202', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ARR16', 244551),
(349805, 'PTHR43874:SF125', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR-LIKE APRR7', 244551),
(349806, 'PTHR43874:SF122', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ARR7', 244551),
(349807, 'PTHR43874:SF76', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 244551),
(349808, 'PTHR43874:SF200', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR', 244551),
(349809, 'PTHR43874:SF123', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ARR14', 244551),
(349810, 'PTHR43874:SF167', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ARR9', 244551),
(349811, 'PTHR43874:SF33', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ORR8', 244551),
(349812, 'PTHR43874:SF74', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ORR11', 244551),
(349813, 'PTHR43874:SF121', NULL, NULL, NULL, NULL, 'CHEY-LIKE SUPERFAMILY-RELATED', 244551),
(349814, 'PTHR43874:SF162', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR', 244551),
(349815, 'PTHR43874:SF72', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ORR5', 244551),
(349816, 'PTHR43874:SF92', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ORR28', 244551),
(349817, 'PTHR43874:SF119', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ARR1', 244551),
(349818, 'PTHR43874:SF117', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR-LIKE APRR3', 244551),
(349819, 'PTHR43874:SF118', NULL, NULL, NULL, NULL, 'CCT DOMAIN, CHEY-LIKE SUPERFAMILY-RELATED', 244551),
(349820, 'PTHR43874:SF159', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 244551),
(349821, 'PTHR43874:SF116', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 244551),
(349822, 'PTHR43874:SF1', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR-LIKE APRR1', 244551),
(349823, 'PTHR43874:SF193', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ARR3-LIKE PROTEIN', 244551);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(349824, 'PTHR43874:SF194', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR-LIKE APRR4-RELATED', 244551),
(349825, 'PTHR43874:SF191', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR', 244551),
(349826, 'PTHR43874:SF192', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR-LIKE APRR1', 244551),
(349827, 'PTHR43874:SF7', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ARR10', 244551),
(349828, 'PTHR43874:SF190', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR-LIKE PRR37 ISOFORM X1', 244551),
(349829, 'PTHR43874:SF87', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ARR11-LIKE', 244551),
(349830, 'PTHR43874:SF111', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 244551),
(349831, 'PTHR43874:SF199', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ARR15', 244551),
(349832, 'PTHR43874:SF88', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 244551),
(349833, 'PTHR43874:SF85', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ORR2', 244551),
(349834, 'PTHR43874:SF197', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR', 244551),
(349835, 'PTHR43874:SF86', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 244551),
(349836, 'PTHR43874:SF154', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 244551),
(349837, 'PTHR43874:SF198', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 244551),
(349838, 'PTHR43874:SF151', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR FAMILY PROTEIN-RELATED', 244551),
(349839, 'PTHR43874:SF195', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR-LIKE PRR37 ISOFORM X1', 244551),
(349840, 'PTHR43874:SF196', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR-LIKE APRR7 ISOFORM X1', 244551),
(349841, 'PTHR43874:SF152', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 244551),
(349842, 'PTHR43874:SF84', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ORR27', 244551),
(349843, 'PTHR43874:SF106', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ORR4', 244551),
(349844, 'PTHR43874:SF107', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ARR17', 244551),
(349845, 'PTHR43874:SF183', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 244551),
(349846, 'PTHR43874:SF18', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ORR7', 244551),
(349847, 'PTHR43874:SF19', NULL, NULL, NULL, NULL, 'RESPONSE REGULATOR 23-RELATED', 244551),
(349848, 'PTHR43874:SF58', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR-LIKE APRR8-RELATED', 244551),
(349849, 'PTHR43874:SF59', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR', 244551),
(349850, 'PTHR43874:SF146', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR-LIKE APRR9', 244551),
(349851, 'PTHR43874:SF147', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ORR6', 244551),
(349852, 'PTHR43874:SF144', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE, CHEY-LIKE SUPERFAMILY-RELATED', 244551),
(349853, 'PTHR43874:SF98', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ARR19-RELATED', 244551),
(349854, 'PTHR43874:SF188', NULL, NULL, NULL, NULL, 'B-TYPE RESPONSE REGULATOR-RELATED', 244551),
(349855, 'PTHR43874:SF145', NULL, NULL, NULL, NULL, 'BNAA09G04840D PROTEIN', 244551),
(349856, 'PTHR43874:SF99', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ARR16', 244551),
(349857, 'PTHR43874:SF189', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 244551),
(349858, 'PTHR43874:SF52', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ARR17-LIKE', 244551),
(349859, 'PTHR43874:SF96', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 244551),
(349860, 'PTHR43874:SF187', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ORR26-LIKE', 244551),
(349861, 'PTHR43874:SF143', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 244551),
(349862, 'PTHR43874:SF94', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ARR5', 244551);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(349863, 'PTHR43874:SF140', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 244551),
(349864, 'PTHR43874:SF50', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ARR3-RELATED', 244551),
(349865, 'PTHR43874:SF141', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 244551),
(349866, 'PTHR43874:SF185', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ARR9-LIKE', 244551),
(349867, 'PTHR43874:SF95', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR-LIKE APRR5', 244551),
(349868, 'PTHR43874:SF139', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ARR8', 244551),
(349869, 'PTHR43874:SF137', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ARR11', 244551),
(349870, 'PTHR43874:SF170', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR', 244551),
(349871, 'PTHR43874:SF28', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ORR1', 244551),
(349872, 'PTHR43874:SF69', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ORR3', 244551),
(349873, 'PTHR43874:SF67', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ARR2', 244551),
(349874, 'PTHR43874:SF135', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ORR22', 244551),
(349875, 'PTHR43874:SF136', NULL, NULL, NULL, NULL, 'MYB DOMAIN, PLANT-RELATED', 244551),
(349876, 'PTHR43874:SF210', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 244551),
(349877, 'PTHR43874:SF65', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ORR30', 244551),
(349878, 'PTHR43874:SF66', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ARR12-LIKE', 244551),
(349879, 'PTHR43874:SF211', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR-LIKE APRR1', 244551),
(349880, 'PTHR43874:SF134', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 244551),
(349881, 'PTHR43874:SF175', NULL, NULL, NULL, NULL, 'RESPONSE REGULATOR AND TRANSCRIPTION FACTOR RR-A-TYPE FAMILY-RELATED', 244551),
(349882, 'PTHR43874:SF63', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 244551),
(349883, 'PTHR43874:SF64', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR-LIKE PRR37', 244551),
(349884, 'PTHR43874:SF173', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 244551),
(349885, 'PTHR43874:SF130', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 244551),
(349886, 'PTHR43874:SF62', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ARR6', 244551),
(349887, 'PTHR11100:SF18', NULL, NULL, NULL, NULL, 'PRO-NEUREGULIN-3, MEMBRANE-BOUND ISOFORM', 244552),
(349888, 'PTHR11100:SF12', NULL, NULL, NULL, NULL, 'PROTEIN VEIN', 244552),
(349889, 'PTHR11100:SF20', NULL, NULL, NULL, NULL, 'PRO-NEUREGULIN-2, MEMBRANE-BOUND ISOFORM', 244552),
(349890, 'PTHR11100:SF7', NULL, NULL, NULL, NULL, 'PRO-NEUREGULIN-1, MEMBRANE-BOUND ISOFORM', 244552),
(349891, 'PTHR11100:SF27', NULL, NULL, NULL, NULL, 'PRO-NEUREGULIN-1, MEMBRANE-BOUND ISOFORM', 244552),
(349892, 'PTHR11100:SF24', NULL, NULL, NULL, NULL, 'NEUREGULIN 2A', 244552),
(349893, 'PTHR11100', NULL, NULL, NULL, NULL, 'HEREGULIN-NEUREGULIN FAMILY MEMBER', 244552),
(349894, 'PTHR11082', NULL, NULL, NULL, NULL, 'TRNA-DIHYDROURIDINE SYNTHASE', 244553),
(349895, 'PTHR11082:SF31', NULL, NULL, NULL, NULL, 'TRNA-DIHYDROURIDINE(20A/20B) SYNTHASE [NAD(P)+]-LIKE', 244553),
(349896, 'PTHR11082:SF25', NULL, NULL, NULL, NULL, 'DUS DOMAIN-CONTAINING PROTEIN', 244553),
(349897, 'PTHR11082:SF36', NULL, NULL, NULL, NULL, 'DUS DOMAIN-CONTAINING PROTEIN', 244553),
(349898, 'PTHR11082:SF26', NULL, NULL, NULL, NULL, 'TRNA-DIHYDROURIDINE(16) SYNTHASE', 244553),
(349899, 'PTHR11082:SF37', NULL, NULL, NULL, NULL, 'TRNA-DIHYDROURIDINE(16/17) SYNTHASE [NAD(P)(+)]-LIKE', 244553),
(349900, 'PTHR11082:SF5', NULL, NULL, NULL, NULL, 'TRNA-DIHYDROURIDINE(16/17) SYNTHASE [NAD(P)(+)]-LIKE', 244553),
(349901, 'PTHR11082:SF34', NULL, NULL, NULL, NULL, 'TRNA-DIHYDROURIDINE SYNTHASE', 244553),
(349902, 'PTHR11082:SF35', NULL, NULL, NULL, NULL, 'DUS DOMAIN-CONTAINING PROTEIN', 244553);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(349903, 'PTHR15431:SF23', NULL, NULL, NULL, NULL, 'PROTEIN TONNEAU 1A', 244554),
(349904, 'PTHR15431:SF22', NULL, NULL, NULL, NULL, 'LISH DOMAIN-CONTAINING PROTEIN', 244554),
(349905, 'PTHR15431:SF4', NULL, NULL, NULL, NULL, 'PROTEIN TONNEAU 1B', 244554),
(349906, 'PTHR15431:SF21', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN 20', 244554),
(349907, 'PTHR15431:SF20', NULL, NULL, NULL, NULL, '', 244554),
(349908, 'PTHR15431:SF9', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN 43', 244554),
(349909, 'PTHR15431:SF19', NULL, NULL, NULL, NULL, 'FGFR1OP N-TERMINAL LIKE', 244554),
(349910, 'PTHR15431:SF16', NULL, NULL, NULL, NULL, 'PROTEIN TONNEAU 1A-LIKE', 244554),
(349911, 'PTHR15431', NULL, NULL, NULL, NULL, 'FGFR1 ONCOGENE PARTNER/LISH DOMAIN-CONTAINING PROTEIN', 244554),
(349912, 'PTHR15431:SF14', NULL, NULL, NULL, NULL, 'ORAL-FACIAL-DIGITAL SYNDROME 1 PROTEIN', 244554),
(349913, 'PTHR41542:SF1', NULL, NULL, NULL, NULL, 'BLL5807 PROTEIN', 244555),
(349914, 'PTHR41542', NULL, NULL, NULL, NULL, 'BLL5807 PROTEIN', 244555),
(349915, 'PTHR16592', NULL, NULL, NULL, NULL, '', 244556),
(349916, 'PTHR16592:SF2', NULL, NULL, NULL, NULL, 'ASTROTACTIN-2', 244556),
(349917, 'PTHR16592:SF8', NULL, NULL, NULL, NULL, 'ASTROTACTIN-1', 244556),
(349918, 'PTHR16592:SF9', NULL, NULL, NULL, NULL, '', 244556),
(349919, 'PTHR11118', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244557),
(349920, 'PTHR11118:SF1', NULL, NULL, NULL, NULL, 'RNA-SPLICING LIGASE RTCB HOMOLOG', 244557),
(349921, 'PTHR33619:SF4', NULL, NULL, NULL, NULL, 'EXPORT PROTEIN, PUTATIVE-RELATED', 244558),
(349922, 'PTHR33619:SF3', NULL, NULL, NULL, NULL, 'POLYSACCHARIDE EXPORT PROTEIN GFCE-RELATED', 244558),
(349923, 'PTHR33619', NULL, NULL, NULL, NULL, 'POLYSACCHARIDE EXPORT PROTEIN GFCE-RELATED', 244558),
(349924, 'PTHR43539:SF26', NULL, NULL, NULL, NULL, 'MONOOXYGENASE, PUTATIVE-RELATED', 244559),
(349925, 'PTHR43539:SF67', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 244559),
(349926, 'PTHR43539:SF23', NULL, NULL, NULL, NULL, 'FAD-DEPENDENT OXIDOREDUCTASE DOMAIN-CONTAINING PROTEIN 2', 244559),
(349927, 'PTHR43539:SF68', NULL, NULL, NULL, NULL, 'FLAVIN-BINDING MONOOXYGENASE-LIKE PROTEIN (AFU_ORTHOLOGUE AFUA_4G09220)', 244559),
(349928, 'PTHR43539:SF24', NULL, NULL, NULL, NULL, 'MONOOXYGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G11650)-RELATED', 244559),
(349929, 'PTHR43539:SF29', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 244559),
(349930, 'PTHR43539:SF72', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 244559),
(349931, 'PTHR43539:SF70', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 244559),
(349932, 'PTHR43539:SF71', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 244559),
(349933, 'PTHR43539:SF33', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 244559),
(349934, 'PTHR43539:SF77', NULL, NULL, NULL, NULL, 'INDOLE-3-PYRUVATE MONOOXYGENASE YUCCA10-RELATED', 244559),
(349935, 'PTHR43539:SF74', NULL, NULL, NULL, NULL, 'INDOLE-3-PYRUVATE MONOOXYGENASE YUCCA5-RELATED', 244559),
(349936, 'PTHR43539:SF30', NULL, NULL, NULL, NULL, 'OS11G0207700 PROTEIN', 244559),
(349937, 'PTHR43539:SF59', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 244559),
(349938, 'PTHR43539:SF56', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244559),
(349939, 'PTHR43539:SF12', NULL, NULL, NULL, NULL, 'FAD_BINDING_3 DOMAIN-CONTAINING PROTEIN', 244559),
(349940, 'PTHR43539:SF62', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 244559),
(349941, 'PTHR43539:SF4', NULL, NULL, NULL, NULL, 'FAD-DEPENDENT PYRIDINE NUCLEOTIDE-DISULPHIDE OXIDOREDUCTASE', 244559),
(349942, 'PTHR43539:SF60', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 244559),
(349943, 'PTHR43539:SF65', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 244559),
(349944, 'PTHR43539:SF63', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 244559),
(349945, 'PTHR43539:SF20', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 244559),
(349946, 'PTHR43539:SF64', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 244559);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(349947, 'PTHR43539:SF9', NULL, NULL, NULL, NULL, 'INDOLE-3-PYRUVATE MONOOXYGENASE YUCCA11-RELATED', 244559),
(349948, 'PTHR43539', NULL, NULL, NULL, NULL, 'FLAVIN-BINDING MONOOXYGENASE-LIKE PROTEIN (AFU_ORTHOLOGUE AFUA_4G09220)', 244559),
(349949, 'PTHR43539:SF47', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 244559),
(349950, 'PTHR43539:SF48', NULL, NULL, NULL, NULL, 'INDOLE-3-PYRUVATE MONOOXYGENASE YUCCA2', 244559),
(349951, 'PTHR43539:SF89', NULL, NULL, NULL, NULL, 'MONOOXYGENASE-RELATED', 244559),
(349952, 'PTHR43539:SF46', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 244559),
(349953, 'PTHR43539:SF49', NULL, NULL, NULL, NULL, 'INDOLE-3-PYRUVATE MONOOXYGENASE YUCCA7-RELATED', 244559),
(349954, 'PTHR43539:SF50', NULL, NULL, NULL, NULL, 'INDOLE-3-PYRUVATE MONOOXYGENASE YUCCA11-RELATED', 244559),
(349955, 'PTHR43539:SF51', NULL, NULL, NULL, NULL, 'INDOLE-3-PYRUVATE MONOOXYGENASE YUCCA8', 244559),
(349956, 'PTHR43539:SF92', NULL, NULL, NULL, NULL, '', 244559),
(349957, 'PTHR43539:SF54', NULL, NULL, NULL, NULL, 'INDOLE-3-PYRUVATE MONOOXYGENASE YUCCA1-RELATED', 244559),
(349958, 'PTHR43539:SF55', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 244559),
(349959, 'PTHR43539:SF11', NULL, NULL, NULL, NULL, 'INDOLE-3-PYRUVATE MONOOXYGENASE YUCCA8-RELATED', 244559),
(349960, 'PTHR43539:SF52', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 244559),
(349961, 'PTHR43539:SF53', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 244559),
(349962, 'PTHR43539:SF90', NULL, NULL, NULL, NULL, 'FAD_BINDING_3 DOMAIN-CONTAINING PROTEIN', 244559),
(349963, 'PTHR43539:SF91', NULL, NULL, NULL, NULL, 'FAD-DEPENDENT URATE HYDROXYLASE', 244559),
(349964, 'PTHR43539:SF36', NULL, NULL, NULL, NULL, 'INDOLE-3-PYRUVATE MONOOXYGENASE YUCCA2', 244559),
(349965, 'PTHR43539:SF78', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 244559),
(349966, 'PTHR43539:SF38', NULL, NULL, NULL, NULL, 'INDOLE-3-PYRUVATE MONOOXYGENASE YUCCA6', 244559),
(349967, 'PTHR43539:SF83', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 244559),
(349968, 'PTHR43539:SF81', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 244559),
(349969, 'PTHR43539:SF82', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 244559),
(349970, 'PTHR43539:SF43', NULL, NULL, NULL, NULL, 'INDOLE-3-PYRUVATE MONOOXYGENASE YUCCA9-RELATED', 244559),
(349971, 'PTHR43539:SF87', NULL, NULL, NULL, NULL, 'DEPENDENT OXIDOREDUCTASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G01002)-RELATED', 244559),
(349972, 'PTHR43539:SF88', NULL, NULL, NULL, NULL, 'INDOLE-3-PYRUVATE MONOOXYGENASE YUCCA4', 244559),
(349973, 'PTHR43539:SF44', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244559),
(349974, 'PTHR43539:SF85', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 244559),
(349975, 'PTHR43539:SF42', NULL, NULL, NULL, NULL, 'OS01G0273800 PROTEIN', 244559),
(349976, 'PTHR43539:SF86', NULL, NULL, NULL, NULL, 'INDOLE-3-PYRUVATE MONOOXYGENASE YUCCA3-RELATED', 244559),
(349977, 'PTHR43539:SF80', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOOXYGENASE', 244559),
(349978, 'PTHR37292:SF2', NULL, NULL, NULL, NULL, 'DUF262 DOMAIN-CONTAINING PROTEIN', 244560),
(349979, 'PTHR37292', NULL, NULL, NULL, NULL, 'VNG6097C', 244560),
(349980, 'PTHR10502:SF120', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(349981, 'PTHR10502:SF122', NULL, NULL, NULL, NULL, 'ANNEXIN A9', 244561),
(349982, 'PTHR10502:SF209', NULL, NULL, NULL, NULL, 'ANNEXIN D4-LIKE', 244561),
(349983, 'PTHR10502', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(349984, 'PTHR10502:SF202', NULL, NULL, NULL, NULL, 'ANNEXIN D6', 244561),
(349985, 'PTHR10502:SF204', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(349986, 'PTHR10502:SF203', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(349987, 'PTHR10502:SF206', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(349988, 'PTHR10502:SF205', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(349989, 'PTHR10502:SF208', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(349990, 'PTHR10502:SF207', NULL, NULL, NULL, NULL, 'OS09G0368850 PROTEIN', 244561);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(349991, 'PTHR10502:SF8', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(349992, 'PTHR10502:SF194', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(349993, 'PTHR10502:SF193', NULL, NULL, NULL, NULL, 'ANNEXIN D8', 244561),
(349994, 'PTHR10502:SF196', NULL, NULL, NULL, NULL, 'ANNEXIN D4', 244561),
(349995, 'PTHR10502:SF195', NULL, NULL, NULL, NULL, 'ANNEXIN D7', 244561),
(349996, 'PTHR10502:SF198', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(349997, 'PTHR10502:SF197', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(349998, 'PTHR10502:SF233', NULL, NULL, NULL, NULL, 'ANNEXIN B9', 244561),
(349999, 'PTHR10502:SF232', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(350000, 'PTHR10502:SF199', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(350001, 'PTHR10502:SF190', NULL, NULL, NULL, NULL, 'OS09G0453300 PROTEIN', 244561),
(350002, 'PTHR10502:SF191', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(350003, 'PTHR10502:SF235', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(350004, 'PTHR10502:SF234', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(350005, 'PTHR10502:SF237', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(350006, 'PTHR10502:SF236', NULL, NULL, NULL, NULL, 'ANNEXIN B11', 244561),
(350007, 'PTHR10502:SF238', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(350008, 'PTHR10502:SF185', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(350009, 'PTHR10502:SF220', NULL, NULL, NULL, NULL, 'ANNEXIN D2', 244561),
(350010, 'PTHR10502:SF186', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(350011, 'PTHR10502:SF222', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(350012, 'PTHR10502:SF189', NULL, NULL, NULL, NULL, '', 244561),
(350013, 'PTHR10502:SF221', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(350014, 'PTHR10502:SF100', NULL, NULL, NULL, NULL, 'ANNEXIN A10', 244561),
(350015, 'PTHR10502:SF188', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(350016, 'PTHR10502:SF17', NULL, NULL, NULL, NULL, 'ANNEXIN A1', 244561),
(350017, 'PTHR10502:SF18', NULL, NULL, NULL, NULL, 'ANNEXIN A2-RELATED', 244561),
(350018, 'PTHR10502:SF19', NULL, NULL, NULL, NULL, 'ANNEXIN A6', 244561),
(350019, 'PTHR10502:SF224', NULL, NULL, NULL, NULL, 'BNAA04G22180D PROTEIN', 244561),
(350020, 'PTHR10502:SF102', NULL, NULL, NULL, NULL, 'ANNEXIN A7', 244561),
(350021, 'PTHR10502:SF223', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(350022, 'PTHR10502:SF225', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(350023, 'PTHR10502:SF104', NULL, NULL, NULL, NULL, 'ANNEXIN D1', 244561),
(350024, 'PTHR10502:SF107', NULL, NULL, NULL, NULL, 'ANNEXIN ANXC4 (AFU_ORTHOLOGUE AFUA_3G07020)', 244561),
(350025, 'PTHR10502:SF228', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(350026, 'PTHR10502:SF96', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(350027, 'PTHR10502:SF106', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(350028, 'PTHR10502:SF97', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(350029, 'PTHR10502:SF109', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(350030, 'PTHR10502:SF99', NULL, NULL, NULL, NULL, 'ANNEXIN D3', 244561),
(350031, 'PTHR10502:SF229', NULL, NULL, NULL, NULL, '', 244561),
(350032, 'PTHR10502:SF130', NULL, NULL, NULL, NULL, '', 244561),
(350033, 'PTHR10502:SF175', NULL, NULL, NULL, NULL, 'ANNEXIN A13', 244561),
(350034, 'PTHR10502:SF211', NULL, NULL, NULL, NULL, 'ANNEXIN D4-LIKE ISOFORM X1', 244561),
(350035, 'PTHR10502:SF178', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(350036, 'PTHR10502:SF177', NULL, NULL, NULL, NULL, 'ANNEXIN B10', 244561),
(350037, 'PTHR10502:SF133', NULL, NULL, NULL, NULL, 'ANNEXIN A8-RELATED', 244561),
(350038, 'PTHR10502:SF210', NULL, NULL, NULL, NULL, 'PRION PROTEIN B', 244561),
(350039, 'PTHR10502:SF28', NULL, NULL, NULL, NULL, 'ANNEXIN A4', 244561),
(350040, 'PTHR10502:SF29', NULL, NULL, NULL, NULL, 'ANNEXIN A11', 244561),
(350041, 'PTHR10502:SF135', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(350042, 'PTHR10502:SF179', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(350043, 'PTHR10502:SF25', NULL, NULL, NULL, NULL, 'ANNEXIN A3', 244561),
(350044, 'PTHR10502:SF215', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(350045, 'PTHR10502:SF26', NULL, NULL, NULL, NULL, 'ANNEXIN A5', 244561);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(350046, 'PTHR10502:SF139', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(350047, 'PTHR10502:SF216', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(350048, 'PTHR10502:SF219', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(350049, 'PTHR10502:SF218', NULL, NULL, NULL, NULL, 'ANNEXIN', 244561),
(350050, 'PTHR31954', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 157', 244562),
(350051, 'PTHR31954:SF1', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 157', 244562),
(350052, 'PTHR35967', NULL, NULL, NULL, NULL, 'UPF0450 PROTEIN C17ORF58', 244563),
(350053, 'PTHR35967:SF1', NULL, NULL, NULL, NULL, 'UPF0450 PROTEIN C17ORF58', 244563),
(350054, 'PTHR35967:SF2', NULL, NULL, NULL, NULL, 'NTR DOMAIN-CONTAINING PROTEIN', 244563),
(350055, 'PTHR21439:SF0', NULL, NULL, NULL, NULL, 'PROTEIN OSCP1', 244564),
(350056, 'PTHR21439', NULL, NULL, NULL, NULL, 'OXIDORED-NITRO DOMAIN-CONTAINING PROTEIN', 244564),
(350057, 'PTHR42796:SF6', NULL, NULL, NULL, NULL, 'FAA_HYDROLASE DOMAIN-CONTAINING PROTEIN', 244565),
(350058, 'PTHR42796:SF8', NULL, NULL, NULL, NULL, 'FAA_HYDROLASE DOMAIN-CONTAINING PROTEIN', 244565),
(350059, 'PTHR42796:SF7', NULL, NULL, NULL, NULL, '2-DEHYDRO-3-DEOXY-D-ARABINONATE DEHYDRATASE', 244565),
(350060, 'PTHR42796:SF4', NULL, NULL, NULL, NULL, 'FUMARYLACETOACETATE HYDROLASE DOMAIN-CONTAINING PROTEIN 2A', 244565),
(350061, 'PTHR42796:SF3', NULL, NULL, NULL, NULL, 'FUMARYLACETOACETATE HYDROLASE DOMAIN-CONTAINING PROTEIN 2A-RELATED', 244565),
(350062, 'PTHR42796', NULL, NULL, NULL, NULL, 'FUMARYLACETOACETATE HYDROLASE DOMAIN-CONTAINING PROTEIN 2A-RELATED', 244565),
(350063, 'PTHR43518', NULL, NULL, NULL, NULL, 'NITRATE REDUCTASE BETA SUBUNIT', 244566),
(350064, 'PTHR43518:SF3', NULL, NULL, NULL, NULL, 'RESPIRATORY NITRATE REDUCTASE 2 BETA CHAIN', 244566),
(350065, 'PTHR43518:SF1', NULL, NULL, NULL, NULL, 'RESPIRATORY NITRATE REDUCTASE 1 BETA CHAIN', 244566),
(350066, 'PTHR43385', NULL, NULL, NULL, NULL, 'RIBOFLAVIN TRANSPORTER RIBJ', 244567),
(350067, 'PTHR43385:SF1', NULL, NULL, NULL, NULL, 'RIBOFLAVIN TRANSPORTER RIBJ', 244567),
(350068, 'PTHR38653:SF1', NULL, NULL, NULL, NULL, 'SI:CH211-129O18.4', 244568),
(350069, 'PTHR38653', NULL, NULL, NULL, NULL, 'GENE 572-RELATED', 244568),
(350070, 'PTHR21443', NULL, NULL, NULL, NULL, 'CONSERVED OLIGOMERIC GOLGI COMPLEX COMPONENT 7', 244569),
(350071, 'PTHR21443:SF0', NULL, NULL, NULL, NULL, 'CONSERVED OLIGOMERIC GOLGI COMPLEX SUBUNIT 7', 244569),
(350072, 'PTHR11010:SF38', NULL, NULL, NULL, NULL, 'LYSOSOMAL PRO-X CARBOXYPEPTIDASE', 244570),
(350073, 'PTHR11010:SF37', NULL, NULL, NULL, NULL, '', 244570),
(350074, 'PTHR11010:SF90', NULL, NULL, NULL, NULL, 'SERINE PROTEASE EDA2-RELATED', 244570),
(350075, 'PTHR11010:SF101', NULL, NULL, NULL, NULL, 'SERINE PROTEASE F56F10.1-RELATED', 244570),
(350076, 'PTHR11010:SF104', NULL, NULL, NULL, NULL, 'SERINE PROTEASE PCP-1-RELATED', 244570),
(350077, 'PTHR11010:SF79', NULL, NULL, NULL, NULL, 'SERINE PEPTIDASE S28 FAMILY PROTEIN-RELATED', 244570),
(350078, 'PTHR11010:SF34', NULL, NULL, NULL, NULL, 'PROTEIN CBG01710', 244570),
(350079, 'PTHR11010:SF78', NULL, NULL, NULL, NULL, 'PRO-X CARBOXYPEPTIDASE, PUTATIVE-RELATED', 244570),
(350080, 'PTHR11010:SF11', NULL, NULL, NULL, NULL, 'THYMUS-SPECIFIC SERINE PROTEASE', 244570),
(350081, 'PTHR11010:SF105', NULL, NULL, NULL, NULL, 'PROLYL CARBOXY PEPTIDASE LIKE', 244570),
(350082, 'PTHR11010:SF33', NULL, NULL, NULL, NULL, '', 244570),
(350083, 'PTHR11010:SF97', NULL, NULL, NULL, NULL, 'OS01G0767100 PROTEIN', 244570),
(350084, 'PTHR11010:SF31', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 244570),
(350085, 'PTHR11010:SF107', NULL, NULL, NULL, NULL, 'DIPEPTIDYL PEPTIDASE 2', 244570),
(350086, 'PTHR11010', NULL, NULL, NULL, NULL, 'PROTEASE S28 PRO-X CARBOXYPEPTIDASE-RELATED', 244570),
(350087, 'PTHR11010:SF75', NULL, NULL, NULL, NULL, 'OS10G0511600 PROTEIN', 244570),
(350088, 'PTHR11010:SF96', NULL, NULL, NULL, NULL, 'SERINE PROTEASE 16', 244570),
(350089, 'PTHR11010:SF30', NULL, NULL, NULL, NULL, 'PROTEIN CBG14660', 244570);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(350090, 'PTHR11010:SF109', NULL, NULL, NULL, NULL, 'PEPTIDASE, FAMILY S28, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G03790)-RELATED', 244570),
(350091, 'PTHR11010:SF28', NULL, NULL, NULL, NULL, '', 244570),
(350092, 'PTHR11010:SF80', NULL, NULL, NULL, NULL, 'LYSOSOMAL PRO-X CARBOXYPEPTIDASE-LIKE PROTEIN', 244570),
(350093, 'PTHR11010:SF111', NULL, NULL, NULL, NULL, 'BNAANNG08440D PROTEIN', 244570),
(350094, 'PTHR11010:SF110', NULL, NULL, NULL, NULL, 'PROLYLCARBOXYPEPTIDASE-LIKE PROTEIN-RELATED', 244570),
(350095, 'PTHR11010:SF113', NULL, NULL, NULL, NULL, '', 244570),
(350096, 'PTHR11010:SF112', NULL, NULL, NULL, NULL, '', 244570),
(350097, 'PTHR11010:SF115', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE S28 FAMILY PROTEIN', 244570),
(350098, 'PTHR11010:SF5', NULL, NULL, NULL, NULL, 'RE36938P', 244570),
(350099, 'PTHR11010:SF114', NULL, NULL, NULL, NULL, '', 244570),
(350100, 'PTHR11010:SF23', NULL, NULL, NULL, NULL, 'SERINE PEPTIDASE', 244570),
(350101, 'PTHR11010:SF88', NULL, NULL, NULL, NULL, 'SERINE PEPTIDASE S28 FAMILY PROTEIN-RELATED', 244570),
(350102, 'PTHR13321', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION, SUBUNIT 18', 244571),
(350103, 'PTHR13321:SF2', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 18', 244571),
(350104, 'PTHR47691', NULL, NULL, NULL, NULL, 'REGULATOR-RELATED', 244572),
(350105, 'PTHR47691:SF3', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR RV0890C-RELATED', 244572),
(350106, 'PTHR13280:SF16', NULL, NULL, NULL, NULL, 'PHOSPHOFURIN ACIDIC CLUSTER SORTING PROTEIN 1', 244573),
(350107, 'PTHR13280', NULL, NULL, NULL, NULL, 'PHOSPHOFURIN ACIDIC CLUSTER SORTING PROTEIN', 244573),
(350108, 'PTHR13280:SF17', NULL, NULL, NULL, NULL, 'KRUEPPEL TARGET AT 95D, ISOFORM A', 244573),
(350109, 'PTHR13280:SF14', NULL, NULL, NULL, NULL, 'SI:CH211-126J24.1', 244573),
(350110, 'PTHR13280:SF15', NULL, NULL, NULL, NULL, 'PHOSPHOFURIN ACIDIC CLUSTER SORTING PROTEIN 2', 244573),
(350111, 'PTHR46160:SF3', NULL, NULL, NULL, NULL, 'ALPHA-TECTORIN', 244574),
(350112, 'PTHR46160', NULL, NULL, NULL, NULL, 'ALPHA-TECTORIN-RELATED', 244574),
(350113, 'PTHR46160:SF5', NULL, NULL, NULL, NULL, '', 244574),
(350114, 'PTHR46160:SF4', NULL, NULL, NULL, NULL, 'ZONADHESIN', 244574),
(350115, 'PTHR46160:SF6', NULL, NULL, NULL, NULL, 'UROMODULIN', 244574),
(350116, 'PTHR46160:SF1', NULL, NULL, NULL, NULL, 'NIDO DOMAIN-CONTAINING PROTEIN-RELATED', 244574),
(350117, 'PTHR31640:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN KIAA1109', 244575),
(350118, 'PTHR31640', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN KIAA1109', 244575),
(350119, 'PTHR12131:SF8', NULL, NULL, NULL, NULL, 'HELICASE SKI2W', 244576),
(350120, 'PTHR12131:SF7', NULL, NULL, NULL, NULL, 'EXOSOME RNA HELICASE MTR4', 244576),
(350121, 'PTHR12131:SF29', NULL, NULL, NULL, NULL, 'RNA HELICASE', 244576),
(350122, 'PTHR12131:SF1', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE SUPV3L1, MITOCHONDRIAL', 244576),
(350123, 'PTHR12131:SF27', NULL, NULL, NULL, NULL, 'HELICASE C-TERMINAL DOMAIN-CONTAINING PROTEIN', 244576),
(350124, 'PTHR12131:SF28', NULL, NULL, NULL, NULL, 'DEXH-BOX ATP-DEPENDENT RNA HELICASE DEXH18, MITOCHONDRIAL', 244576),
(350125, 'PTHR12131:SF25', NULL, NULL, NULL, NULL, 'DEXH-BOX ATP-DEPENDENT RNA HELICASE DEXH9', 244576),
(350126, 'PTHR12131:SF26', NULL, NULL, NULL, NULL, 'DEXH-BOX ATP-DEPENDENT RNA HELICASE DEXH14 ISOFORM X1', 244576),
(350127, 'PTHR12131:SF23', NULL, NULL, NULL, NULL, '', 244576),
(350128, 'PTHR12131:SF12', NULL, NULL, NULL, NULL, 'ACTIVATING SIGNAL COINTEGRATOR 1 COMPLEX SUBUNIT 3', 244576),
(350129, 'PTHR12131:SF24', NULL, NULL, NULL, NULL, 'DEXH-BOX ATP-DEPENDENT RNA HELICASE DEXH11', 244576),
(350130, 'PTHR12131:SF22', NULL, NULL, NULL, NULL, 'DEXH-BOX ATP-DEPENDENT RNA HELICASE DEXH10-LIKE', 244576),
(350131, 'PTHR12131:SF30', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DOB1', 244576),
(350132, 'PTHR12131', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA AND DNA HELICASE', 244576),
(350133, 'PTHR43568', NULL, NULL, NULL, NULL, 'P PROTEIN', 244577);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(350134, 'PTHR43568:SF1', NULL, NULL, NULL, NULL, 'P PROTEIN', 244577),
(350135, 'PTHR31170:SF13', NULL, NULL, NULL, NULL, 'BNAA09G04570D PROTEIN', 244578),
(350136, 'PTHR31170:SF15', NULL, NULL, NULL, NULL, 'BNAANNG34440D PROTEIN', 244578),
(350137, 'PTHR31170:SF16', NULL, NULL, NULL, NULL, '', 244578),
(350138, 'PTHR31170:SF7', NULL, NULL, NULL, NULL, '', 244578),
(350139, 'PTHR31170:SF8', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', 244578),
(350140, 'PTHR31170:SF17', NULL, NULL, NULL, NULL, 'DUF247 DOMAIN PROTEIN', 244578),
(350141, 'PTHR31170:SF9', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF247)-RELATED', 244578),
(350142, 'PTHR31170', NULL, NULL, NULL, NULL, 'BNAC04G53230D PROTEIN', 244578),
(350143, 'PTHR31170:SF10', NULL, NULL, NULL, NULL, 'BNAANNG36000D PROTEIN', 244578),
(350144, 'PTHR28222', NULL, NULL, NULL, NULL, 'DASH COMPLEX SUBUNIT DAD4', 244579),
(350145, 'PTHR28222:SF1', NULL, NULL, NULL, NULL, 'DASH COMPLEX SUBUNIT DAD4', 244579),
(350146, 'PTHR42763:SF1', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE--HEXOSE-1-PHOSPHATE URIDYLYLTRANSFERASE', 244580),
(350147, 'PTHR42763:SF2', NULL, NULL, NULL, NULL, 'ADP-GLUCOSE PHOSPHORYLASE', 244580),
(350148, 'PTHR42763', NULL, NULL, NULL, NULL, 'ADP-GLUCOSE PHOSPHORYLASE', 244580),
(350149, 'PTHR12129:SF17', NULL, NULL, NULL, NULL, 'HEPARAN SULFATE 2-O-SULFOTRANSFERASE 1', 244581),
(350150, 'PTHR12129', NULL, NULL, NULL, NULL, 'HEPARAN SULFATE 2-O-SULFOTRANSFERASE', 244581),
(350151, 'PTHR12129:SF15', NULL, NULL, NULL, NULL, 'URONYL 2-SULFOTRANSFERASE', 244581),
(350152, 'PTHR12129:SF13', NULL, NULL, NULL, NULL, 'HEPARAN SULFATE 2-O-SULFOTRANSFERASE 1B', 244581),
(350153, 'PTHR12129:SF14', NULL, NULL, NULL, NULL, 'HEPARAN SULFATE 2-O-SULFOTRANSFERASE 1', 244581),
(350154, 'PTHR12129:SF20', NULL, NULL, NULL, NULL, 'HEPARAN SULFATE 2-O-SULFOTRANSFERASE PIPE', 244581),
(350155, 'PTHR11511:SF5', NULL, NULL, NULL, NULL, 'FAT-BODY PROTEIN 1-RELATED', 244582),
(350156, 'PTHR11511:SF4', NULL, NULL, NULL, NULL, 'PHENOLOXIDASE 2-RELATED', 244582),
(350157, 'PTHR11511', NULL, NULL, NULL, NULL, 'LARVAL STORAGE PROTEIN/PHENOLOXIDASE', 244582),
(350158, 'PTHR11511:SF24', NULL, NULL, NULL, NULL, 'GH04080P', 244582),
(350159, 'PTHR11511:SF25', NULL, NULL, NULL, NULL, 'LARVAL SERUM PROTEIN 2', 244582),
(350160, 'PTHR33147:SF91', NULL, NULL, NULL, NULL, 'KNOT1 DOMAIN-CONTAINING PROTEIN', 244583),
(350161, 'PTHR33147:SF121', NULL, NULL, NULL, NULL, 'GAMMA-THIONINS FAMILY PROTEIN', 244583),
(350162, 'PTHR33147:SF120', NULL, NULL, NULL, NULL, 'LOW-MOLECULAR-WEIGHT CYSTEINE-RICH PROTEIN LCR70', 244583),
(350163, 'PTHR33147:SF123', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 10', 244583),
(350164, 'PTHR33147:SF125', NULL, NULL, NULL, NULL, '', 244583),
(350165, 'PTHR33147:SF124', NULL, NULL, NULL, NULL, 'DEFENSIN', 244583),
(350166, 'PTHR33147:SF127', NULL, NULL, NULL, NULL, '', 244583),
(350167, 'PTHR33147:SF126', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 244583),
(350168, 'PTHR33147:SF129', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 2-RELATED', 244583),
(350169, 'PTHR33147:SF89', NULL, NULL, NULL, NULL, 'KNOT1 DOMAIN-CONTAINING PROTEIN', 244583),
(350170, 'PTHR33147:SF128', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN', 244583),
(350171, 'PTHR33147:SF46', NULL, NULL, NULL, NULL, 'KNOT1 DOMAIN-CONTAINING PROTEIN', 244583),
(350172, 'PTHR33147:SF47', NULL, NULL, NULL, NULL, 'DEFENSIN', 244583),
(350173, 'PTHR33147:SF8', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN CAL1', 244583),
(350174, 'PTHR33147:SF81', NULL, NULL, NULL, NULL, 'KNOT1 DOMAIN-CONTAINING PROTEIN', 244583),
(350175, 'PTHR33147:SF83', NULL, NULL, NULL, NULL, '', 244583),
(350176, 'PTHR33147:SF84', NULL, NULL, NULL, NULL, '', 244583),
(350177, 'PTHR33147', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 1', 244583),
(350178, 'PTHR33147:SF85', NULL, NULL, NULL, NULL, 'KNOT1 DOMAIN-CONTAINING PROTEIN', 244583),
(350179, 'PTHR33147:SF130', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 1', 244583),
(350180, 'PTHR33147:SF132', NULL, NULL, NULL, NULL, 'DEFENSIN', 244583);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(350181, 'PTHR33147:SF131', NULL, NULL, NULL, NULL, '', 244583),
(350182, 'PTHR33147:SF134', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 19', 244583),
(350183, 'PTHR33147:SF133', NULL, NULL, NULL, NULL, 'DRO1 PROTEIN-RELATED', 244583),
(350184, 'PTHR33147:SF136', NULL, NULL, NULL, NULL, '', 244583),
(350185, 'PTHR33147:SF135', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN P322', 244583),
(350186, 'PTHR33147:SF138', NULL, NULL, NULL, NULL, 'KNOT1 DOMAIN-CONTAINING PROTEIN', 244583),
(350187, 'PTHR33147:SF137', NULL, NULL, NULL, NULL, 'DEFENSIN MTDEF4.7', 244583),
(350188, 'PTHR33147:SF56', NULL, NULL, NULL, NULL, 'DEFENSIN', 244583),
(350189, 'PTHR33147:SF139', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 19', 244583),
(350190, 'PTHR33147:SF57', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 1', 244583),
(350191, 'PTHR33147:SF58', NULL, NULL, NULL, NULL, 'DEFENSIN', 244583),
(350192, 'PTHR33147:SF15', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 1', 244583),
(350193, 'PTHR33147:SF94', NULL, NULL, NULL, NULL, 'KNOT1 DOMAIN-CONTAINING PROTEIN', 244583),
(350194, 'PTHR33147:SF51', NULL, NULL, NULL, NULL, '', 244583),
(350195, 'PTHR33147:SF96', NULL, NULL, NULL, NULL, 'FLOWER-SPECIFIC GAMMA-THIONIN-LIKE PROTEIN/ACIDIC PROTEIN', 244583),
(350196, 'PTHR33147:SF98', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 19', 244583),
(350197, 'PTHR33147:SF99', NULL, NULL, NULL, NULL, '', 244583),
(350198, 'PTHR33147:SF55', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 1', 244583),
(350199, 'PTHR33147:SF141', NULL, NULL, NULL, NULL, 'KNOT1 DOMAIN-CONTAINING PROTEIN', 244583),
(350200, 'PTHR33147:SF140', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 6', 244583),
(350201, 'PTHR33147:SF143', NULL, NULL, NULL, NULL, 'DEFENSIN', 244583),
(350202, 'PTHR33147:SF142', NULL, NULL, NULL, NULL, 'LCR', 244583),
(350203, 'PTHR33147:SF101', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 13', 244583),
(350204, 'PTHR33147:SF145', NULL, NULL, NULL, NULL, 'KNOT1 DOMAIN-CONTAINING PROTEIN', 244583),
(350205, 'PTHR33147:SF144', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 81-RELATED', 244583),
(350206, 'PTHR33147:SF100', NULL, NULL, NULL, NULL, 'KNOT1 DOMAIN-CONTAINING PROTEIN', 244583),
(350207, 'PTHR33147:SF147', NULL, NULL, NULL, NULL, 'KNOTTIN, SCORPION TOXIN-LIKE PROTEIN-RELATED', 244583),
(350208, 'PTHR33147:SF103', NULL, NULL, NULL, NULL, 'GAMMA-THIONINS FAMILY PROTEIN', 244583),
(350209, 'PTHR33147:SF146', NULL, NULL, NULL, NULL, '', 244583),
(350210, 'PTHR33147:SF102', NULL, NULL, NULL, NULL, '', 244583),
(350211, 'PTHR33147:SF149', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 2', 244583),
(350212, 'PTHR33147:SF105', NULL, NULL, NULL, NULL, '', 244583),
(350213, 'PTHR33147:SF148', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 98', 244583),
(350214, 'PTHR33147:SF107', NULL, NULL, NULL, NULL, 'KNOT1 DOMAIN-CONTAINING PROTEIN', 244583),
(350215, 'PTHR33147:SF67', NULL, NULL, NULL, NULL, 'GAMMA-THIONIN-RELATED', 244583),
(350216, 'PTHR33147:SF106', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 11', 244583),
(350217, 'PTHR33147:SF26', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 7-RELATED', 244583),
(350218, 'PTHR33147:SF27', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN', 244583),
(350219, 'PTHR33147:SF28', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 6', 244583),
(350220, 'PTHR33147:SF66', NULL, NULL, NULL, NULL, 'KNOT1 DOMAIN-CONTAINING PROTEIN', 244583),
(350221, 'PTHR33147:SF150', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 191-RELATED', 244583),
(350222, 'PTHR33147:SF111', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN', 244583),
(350223, 'PTHR33147:SF114', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN P322', 244583),
(350224, 'PTHR33147:SF116', NULL, NULL, NULL, NULL, 'BASAL ENDOSPERM TRANSFER LAYER10', 244583),
(350225, 'PTHR33147:SF118', NULL, NULL, NULL, NULL, 'KNOT1 DOMAIN-CONTAINING PROTEIN', 244583),
(350226, 'PTHR33147:SF79', NULL, NULL, NULL, NULL, '', 244583),
(350227, 'PTHR33147:SF37', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 14-RELATED', 244583),
(350228, 'PTHR33147:SF38', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 244583);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(350229, 'PTHR33147:SF39', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 8', 244583),
(350230, 'PTHR33147:SF70', NULL, NULL, NULL, NULL, 'KNOT1 DOMAIN-CONTAINING PROTEIN', 244583),
(350231, 'PTHR33147:SF72', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 1-RELATED', 244583),
(350232, 'PTHR33147:SF75', NULL, NULL, NULL, NULL, 'KNOTTIN, SCORPION TOXIN-LIKE PROTEIN-RELATED', 244583),
(350233, 'PTHR33147:SF31', NULL, NULL, NULL, NULL, 'DEFENSIN', 244583),
(350234, 'PTHR33147:SF76', NULL, NULL, NULL, NULL, 'DEFENSIN', 244583),
(350235, 'PTHR33147:SF77', NULL, NULL, NULL, NULL, 'KNOT1 DOMAIN-CONTAINING PROTEIN', 244583),
(350236, 'PTHR47294:SF3', NULL, NULL, NULL, NULL, 'OS08G0431150 PROTEIN', 244584),
(350237, 'PTHR47294:SF4', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 244584),
(350238, 'PTHR47294:SF5', NULL, NULL, NULL, NULL, 'OS09G0408550 PROTEIN', 244584),
(350239, 'PTHR47294:SF6', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 244584),
(350240, 'PTHR47294', NULL, NULL, NULL, NULL, 'OS08G0431150 PROTEIN', 244584),
(350241, 'PTHR45266:SF3', NULL, NULL, NULL, NULL, 'OXALOACETATE DECARBOXYLASE ALPHA CHAIN', 244585),
(350242, 'PTHR45266', NULL, NULL, NULL, NULL, 'OXALOACETATE DECARBOXYLASE ALPHA CHAIN', 244585),
(350243, 'PTHR33567', NULL, NULL, NULL, NULL, 'CHROMATE ION TRANSPORTER (EUROFUNG)', 244586),
(350244, 'PTHR33567:SF3', NULL, NULL, NULL, NULL, 'CHROMATE ION TRANSPORTER (EUROFUNG)', 244586),
(350245, 'PTHR30292:SF0', NULL, NULL, NULL, NULL, '5-OXOPROLINASE SUBUNIT A', 244587),
(350246, 'PTHR30292', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN YBGL-RELATED', 244587),
(350247, 'PTHR19364', NULL, NULL, NULL, NULL, 'IMMUNITY-RELATED GTPASE FAMILY Q PROTEIN', 244588),
(350248, 'PTHR19364:SF2', NULL, NULL, NULL, NULL, 'IMMUNITY-RELATED GTPASE FAMILY Q PROTEIN', 244588),
(350249, 'PTHR45851:SF5', NULL, NULL, NULL, NULL, 'PROTEIN L-MYC-RELATED', 244589),
(350250, 'PTHR45851:SF4', NULL, NULL, NULL, NULL, 'PROTEIN S-MYC', 244589),
(350251, 'PTHR45851:SF1', NULL, NULL, NULL, NULL, 'MYC PROTO-ONCOGENE PROTEIN', 244589),
(350252, 'PTHR45851', NULL, NULL, NULL, NULL, 'MYC PROTO-ONCOGENE', 244589),
(350253, 'PTHR45851:SF3', NULL, NULL, NULL, NULL, 'MYC PROTEIN', 244589),
(350254, 'PTHR45851:SF2', NULL, NULL, NULL, NULL, 'N-MYC PROTO-ONCOGENE PROTEIN', 244589),
(350255, 'PTHR23413:SF17', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L32-1', 244590),
(350256, 'PTHR23413:SF19', NULL, NULL, NULL, NULL, '', 244590),
(350257, 'PTHR23413:SF13', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L32-1-LIKE', 244590),
(350258, 'PTHR23413:SF14', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L32-1-LIKE', 244590),
(350259, 'PTHR23413:SF15', NULL, NULL, NULL, NULL, 'BNAC05G44590D PROTEIN', 244590),
(350260, 'PTHR23413:SF16', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L32-1', 244590),
(350261, 'PTHR23413:SF8', NULL, NULL, NULL, NULL, '', 244590),
(350262, 'PTHR23413:SF20', NULL, NULL, NULL, NULL, '', 244590),
(350263, 'PTHR23413:SF21', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L32-1-RELATED', 244590),
(350264, 'PTHR23413:SF10', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L32', 244590),
(350265, 'PTHR23413:SF6', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L32', 244590),
(350266, 'PTHR23413:SF12', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L32-1', 244590),
(350267, 'PTHR23413', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L32 AND DNA-DIRECTED RNA POLYMERASE II, SUBUNIT N', 244590),
(350268, 'PTHR23413:SF1', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L32', 244590),
(350269, 'PTHR23413:SF4', NULL, NULL, NULL, NULL, '', 244590),
(350270, 'PTHR23413:SF2', NULL, NULL, NULL, NULL, '', 244590),
(350271, 'PTHR38813:SF1', NULL, NULL, NULL, NULL, 'TOXIN RELE1-RELATED', 244591),
(350272, 'PTHR38813', NULL, NULL, NULL, NULL, '', 244591),
(350273, 'PTHR46207:SF1', NULL, NULL, NULL, NULL, 'PROTEIN RCC2', 244592),
(350274, 'PTHR46207', NULL, NULL, NULL, NULL, 'PROTEIN RCC2', 244592),
(350275, 'PTHR46009:SF1', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN VTA1 HOMOLOG', 244593);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(350276, 'PTHR46009', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN VTA1 HOMOLOG', 244593),
(350277, 'PTHR45762:SF18', NULL, NULL, NULL, NULL, 'ZINC FINGER RNA-BINDING PROTEIN 2', 244594),
(350278, 'PTHR45762:SF19', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244594),
(350279, 'PTHR45762', NULL, NULL, NULL, NULL, 'ZINC FINGER RNA-BINDING PROTEIN', 244594),
(350280, 'PTHR45762:SF20', NULL, NULL, NULL, NULL, '', 244594),
(350281, 'PTHR45762:SF16', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 244594),
(350282, 'PTHR45762:SF3', NULL, NULL, NULL, NULL, 'ZINC FINGER RNA-BINDING PROTEIN', 244594),
(350283, 'PTHR45762:SF4', NULL, NULL, NULL, NULL, 'INTERLEUKIN ENHANCER-BINDING FACTOR 3', 244594),
(350284, 'PTHR45762:SF17', NULL, NULL, NULL, NULL, 'ZINC FINGER RNA-BINDING PROTEIN', 244594),
(350285, 'PTHR45762:SF1', NULL, NULL, NULL, NULL, 'SPERMATID PERINUCLEAR RNA-BINDING PROTEIN', 244594),
(350286, 'PTHR45762:SF14', NULL, NULL, NULL, NULL, 'SI:CH211-197H24.6', 244594),
(350287, 'PTHR45762:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER RNA-BINDING PROTEIN 2', 244594),
(350288, 'PTHR45762:SF12', NULL, NULL, NULL, NULL, 'C2H2 TYPE ZINC-FINGER PROTEIN', 244594),
(350289, 'PTHR45762:SF13', NULL, NULL, NULL, NULL, '', 244594),
(350290, 'PTHR45762:SF10', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 244594),
(350291, 'PTHR47257:SF1', NULL, NULL, NULL, NULL, 'PH-RESPONSE TRANSCRIPTION FACTOR PACC/RIM101', 244595),
(350292, 'PTHR47257', NULL, NULL, NULL, NULL, 'PH-RESPONSE TRANSCRIPTION FACTOR PACC/RIM101', 244595),
(350293, 'PTHR48025:SF1', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN M-RELATED', 244596),
(350294, 'PTHR48025:SF3', NULL, NULL, NULL, NULL, '31 KDA RIBONUCLEOPROTEIN, CHLOROPLASTIC-RELATED', 244596),
(350295, 'PTHR48025:SF2', NULL, NULL, NULL, NULL, 'OS08G0557100 PROTEIN', 244596),
(350296, 'PTHR48025:SF5', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-BINDING ALPHA-BETA PLAIT DOMAIN-CONTAINING PROTEIN-RELATED', 244596),
(350297, 'PTHR48025:SF4', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN 2, CHLOROPLASTIC', 244596),
(350298, 'PTHR48025:SF7', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 244596),
(350299, 'PTHR48025:SF10', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN CP29B, CHLOROPLASTIC', 244596),
(350300, 'PTHR48025', NULL, NULL, NULL, NULL, 'OS02G0815200 PROTEIN', 244596),
(350301, 'PTHR48025:SF6', NULL, NULL, NULL, NULL, 'PLASTID-SPECIFIC 30S RIBOSOMAL PROTEIN 2', 244596),
(350302, 'PTHR48025:SF12', NULL, NULL, NULL, NULL, 'OS07G0631900 PROTEIN', 244596),
(350303, 'PTHR48025:SF9', NULL, NULL, NULL, NULL, 'OS02G0815200 PROTEIN', 244596),
(350304, 'PTHR48025:SF11', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN CP33, CHLOROPLASTIC', 244596),
(350305, 'PTHR48025:SF14', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-BINDING ALPHA-BETA PLAIT DOMAIN-CONTAINING PROTEIN-RELATED', 244596),
(350306, 'PTHR48025:SF13', NULL, NULL, NULL, NULL, 'OS05G0223500 PROTEIN', 244596),
(350307, 'PTHR48025:SF16', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 244596),
(350308, 'PTHR48025:SF15', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-BINDING ALPHA-BETA PLAIT DOMAIN-CONTAINING PROTEIN-RELATED', 244596),
(350309, 'PTHR48025:SF18', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN', 244596),
(350310, 'PTHR48025:SF17', NULL, NULL, NULL, NULL, '28 KDA RIBONUCLEOPROTEIN, CHLOROPLASTIC', 244596),
(350311, 'PTHR48025:SF19', NULL, NULL, NULL, NULL, '', 244596),
(350312, 'PTHR33737:SF2', NULL, NULL, NULL, NULL, 'OS05G0121800 PROTEIN', 244597),
(350313, 'PTHR33737:SF19', NULL, NULL, NULL, NULL, 'BNAA10G12980D PROTEIN', 244597),
(350314, 'PTHR33737:SF21', NULL, NULL, NULL, NULL, '', 244597),
(350315, 'PTHR33737:SF10', NULL, NULL, NULL, NULL, 'OS12G0102700 PROTEIN', 244597),
(350316, 'PTHR33737', NULL, NULL, NULL, NULL, 'OS05G0121800 PROTEIN', 244597),
(350317, 'PTHR33737:SF20', NULL, NULL, NULL, NULL, '', 244597),
(350318, 'PTHR33737:SF12', NULL, NULL, NULL, NULL, 'TRIO/F-ACTIN-BINDING PROTEIN', 244597),
(350319, 'PTHR33737:SF14', NULL, NULL, NULL, NULL, '', 244597);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(350320, 'PTHR33737:SF16', NULL, NULL, NULL, NULL, 'BNAA03G18210D PROTEIN', 244597),
(350321, 'PTHR14572', NULL, NULL, NULL, NULL, 'PANCREATIC PROGENITOR CELL DIFFERENTIATION AND PROLIFERATION FACTOR', 244598),
(350322, 'PTHR14572:SF0', NULL, NULL, NULL, NULL, 'PANCREATIC PROGENITOR CELL DIFFERENTIATION AND PROLIFERATION FACTOR', 244598),
(350323, 'PTHR14572:SF1', NULL, NULL, NULL, NULL, 'PANCREATIC PROGENITOR CELL DIFFERENTIATION AND PROLIFERATION FACTOR-LIKE PROTEIN', 244598),
(350324, 'PTHR30007', NULL, NULL, NULL, NULL, 'PHP DOMAIN PROTEIN', 244599),
(350325, 'PTHR30007:SF1', NULL, NULL, NULL, NULL, 'IS1648 TRANSPOSASE-RELATED', 244599),
(350326, 'PTHR30007:SF0', NULL, NULL, NULL, NULL, 'TRANSPOSASE', 244599),
(350327, 'PTHR31430:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG06031', 244600),
(350328, 'PTHR31430:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG12472', 244600),
(350329, 'PTHR31430:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG13848', 244600),
(350330, 'PTHR31430:SF0', NULL, NULL, NULL, NULL, 'PROTEIN CBG22332', 244600),
(350331, 'PTHR31430:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG24882', 244600),
(350332, 'PTHR31430', NULL, NULL, NULL, NULL, 'PROTEIN CBG22332-RELATED', 244600),
(350333, 'PTHR36307:SF2', NULL, NULL, NULL, NULL, 'FLAGELLA BASAL BODY P-RING FORMATION PROTEIN FLGA', 244601),
(350334, 'PTHR36307', NULL, NULL, NULL, NULL, 'FLAGELLA BASAL BODY P-RING FORMATION PROTEIN FLGA', 244601),
(350335, 'PTHR36307:SF1', NULL, NULL, NULL, NULL, 'FLAGELLA BASAL BODY P-RING FORMATION PROTEIN FLGA', 244601),
(350336, 'PTHR12968', NULL, NULL, NULL, NULL, 'B9 DOMAIN-CONTAINING', 244602),
(350337, 'PTHR12968:SF4', NULL, NULL, NULL, NULL, 'MECKEL SYNDROME TYPE 1 PROTEIN', 244602),
(350338, 'PTHR12968:SF1', NULL, NULL, NULL, NULL, 'B9 DOMAIN-CONTAINING PROTEIN 1', 244602),
(350339, 'PTHR12968:SF2', NULL, NULL, NULL, NULL, 'B9 DOMAIN-CONTAINING PROTEIN 2', 244602),
(350340, 'PTHR12968:SF5', NULL, NULL, NULL, NULL, '', 244602),
(350341, 'PTHR12968:SF6', NULL, NULL, NULL, NULL, 'B9 DOMAIN-CONTAINING PROTEIN', 244602),
(350342, 'PTHR45867:SF1', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 244603),
(350343, 'PTHR45867:SF2', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 244603),
(350344, 'PTHR45867', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 244603),
(350345, 'PTHR45867:SF9', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 244603),
(350346, 'PTHR45867:SF10', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 244603),
(350347, 'PTHR45867:SF6', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 244603),
(350348, 'PTHR45867:SF3', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE TYPE 7', 244603),
(350349, 'PTHR47613', NULL, NULL, NULL, NULL, 'SPERM ACROSOME MEMBRANE-ASSOCIATED PROTEIN 4', 244604),
(350350, 'PTHR47613:SF1', NULL, NULL, NULL, NULL, 'SPERM ACROSOME MEMBRANE-ASSOCIATED PROTEIN 4', 244604),
(350351, 'PTHR22409', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244605),
(350352, 'PTHR22409:SF2', NULL, NULL, NULL, NULL, 'DUF4614 DOMAIN-CONTAINING PROTEIN', 244605),
(350353, 'PTHR14320:SF2', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 181', 244606),
(350354, 'PTHR14320', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 181', 244606),
(350355, 'PTHR40707', NULL, NULL, NULL, NULL, 'POSSIBLE NUCLEASE OF RNASE H FOLD, RUVC/YQGF FAMILY', 244607),
(350356, 'PTHR40707:SF1', NULL, NULL, NULL, NULL, 'POSSIBLE NUCLEASE OF RNASE H FOLD, RUVC/YQGF FAMILY', 244607),
(350357, 'PTHR16040:SF8', NULL, NULL, NULL, NULL, 'BOREALIN', 244608),
(350358, 'PTHR16040:SF9', NULL, NULL, NULL, NULL, 'NBL1_BOREALIN_N DOMAIN-CONTAINING PROTEIN', 244608),
(350359, 'PTHR16040:SF10', NULL, NULL, NULL, NULL, 'BOREALIN-2', 244608),
(350360, 'PTHR16040:SF5', NULL, NULL, NULL, NULL, 'BOREALIN-2', 244608),
(350361, 'PTHR16040', NULL, NULL, NULL, NULL, 'AUSTRALIN, ISOFORM A-RELATED', 244608),
(350362, 'PTHR16040:SF6', NULL, NULL, NULL, NULL, 'BOREALIN', 244608),
(350363, 'PTHR16040:SF7', NULL, NULL, NULL, NULL, 'AUSTRALIN, ISOFORM A-RELATED', 244608),
(350364, 'PTHR39597', NULL, NULL, NULL, NULL, 'UBA DOMAIN-CONTAINING PROTEIN RUP1', 244609);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(350365, 'PTHR39597:SF1', NULL, NULL, NULL, NULL, 'UBA DOMAIN-CONTAINING PROTEIN RUP1', 244609),
(350366, 'PTHR21632:SF4', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DNA-BINDING DOMAIN-CONTAINING PROTEIN 3', 244610),
(350367, 'PTHR21632:SF3', NULL, NULL, NULL, NULL, 'TOMOREGULIN-1', 244610),
(350368, 'PTHR21632:SF2', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DNA-BINDING DOMAIN-CONTAINING PROTEIN 3', 244610),
(350369, 'PTHR21632', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244610),
(350370, 'PTHR35068:SF1', NULL, NULL, NULL, NULL, 'BEN DOMAIN-CONTAINING PROTEIN 7', 244611),
(350371, 'PTHR35068', NULL, NULL, NULL, NULL, 'BEN DOMAIN-CONTAINING PROTEIN 7', 244611),
(350372, 'PTHR46793:SF1', NULL, NULL, NULL, NULL, '1700018F24RIK PROTEIN-RELATED', 244612),
(350373, 'PTHR46793:SF2', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4930474N05 GENE', 244612),
(350374, 'PTHR46793', NULL, NULL, NULL, NULL, '1700018F24RIK PROTEIN-RELATED-RELATED', 244612),
(350375, 'PTHR28245', NULL, NULL, NULL, NULL, 'ARF3-INTERACTING PROTEIN 1', 244613),
(350376, 'PTHR28245:SF1', NULL, NULL, NULL, NULL, 'ARF3-INTERACTING PROTEIN 1', 244613),
(350377, 'PTHR46588', NULL, NULL, NULL, NULL, 'SERINE/THREONINE/TYROSINE-INTERACTING PROTEIN', 244614),
(350378, 'PTHR46588:SF1', NULL, NULL, NULL, NULL, 'SERINE/THREONINE/TYROSINE-INTERACTING PROTEIN', 244614),
(350379, 'PTHR43076:SF13', NULL, NULL, NULL, NULL, '5-AMINO-6-(D-RIBITYLAMINO)URACIL--L-TYROSINE 4-HYDROXYPHENYL TRANSFERASE', 244615),
(350380, 'PTHR43076:SF1', NULL, NULL, NULL, NULL, 'LIPOYL SYNTHASE 2', 244615),
(350381, 'PTHR43076', NULL, NULL, NULL, NULL, 'FO SYNTHASE (COFH)', 244615),
(350382, 'PTHR43076:SF8', NULL, NULL, NULL, NULL, 'CYCLIC DEHYPOXANTHINE FUTALOSINE SYNTHASE', 244615),
(350383, 'PTHR43076:SF7', NULL, NULL, NULL, NULL, 'AMINODEOXYFUTALOSINE SYNTHASE', 244615),
(350384, 'PTHR15453:SF8', NULL, NULL, NULL, NULL, 'TUMOR SUPPRESSOR CANDIDATE 2', 244616),
(350385, 'PTHR15453:SF9', NULL, NULL, NULL, NULL, 'TUMOR SUPPRESSOR 2, MITOCHONDRIAL CALCIUM REGULATOR A', 244616),
(350386, 'PTHR15453:SF10', NULL, NULL, NULL, NULL, 'TUMOR SUPPRESSOR 2, MITOCHONDRIAL CALCIUM REGULATOR B', 244616),
(350387, 'PTHR15453', NULL, NULL, NULL, NULL, 'TUMOR SUPPRESSOR CANDIDATE 2', 244616),
(350388, 'PTHR24082:SF505', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR SUBFAMILY 1, GROUP H, MEMBER 4-RELATED', 244617),
(350389, 'PTHR24082:SF504', NULL, NULL, NULL, NULL, 'VITAMIN D3 RECEPTOR B', 244617),
(350390, 'PTHR24082:SF503', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR UNC-55', 244617),
(350391, 'PTHR24082:SF502', NULL, NULL, NULL, NULL, 'STEROID HORMONE RECEPTOR FAMILY MEMBER CNR14', 244617),
(350392, 'PTHR24082:SF501', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR SUBFAMILY 1, GROUP D, MEMBER 4A', 244617),
(350393, 'PTHR24082:SF500', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-8', 244617),
(350394, 'PTHR24082:SF489', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR SUBFAMILY 1, GROUP D, MEMBER 4B', 244617),
(350395, 'PTHR24082:SF488', NULL, NULL, NULL, NULL, 'PEROXISOME PROLIFERATOR-ACTIVATED RECEPTOR GAMMA', 244617),
(350396, 'PTHR24082:SF506', NULL, NULL, NULL, NULL, 'NR LBD DOMAIN-CONTAINING PROTEIN', 244617),
(350397, 'PTHR24082:SF15', NULL, NULL, NULL, NULL, 'PEROXISOME PROLIFERATOR-ACTIVATED RECEPTOR DELTA', 244617),
(350398, 'PTHR24082', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR', 244617),
(350399, 'PTHR24082:SF497', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR', 244617),
(350400, 'PTHR24082:SF112', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR SUBFAMILY 1 GROUP D MEMBER 2', 244617),
(350401, 'PTHR24082:SF331', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR SUBFAMILY 1, GROUP H, MEMBER 3', 244617),
(350402, 'PTHR24082:SF210', NULL, NULL, NULL, NULL, 'THYROID HORMONE RECEPTOR BETA', 244617),
(350403, 'PTHR24082:SF155', NULL, NULL, NULL, NULL, 'BILE ACID RECEPTOR', 244617),
(350404, 'PTHR24082:SF39', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR SUBFAMILY 1 GROUP I MEMBER 2', 244617),
(350405, 'PTHR24082:SF231', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR SUBFAMILY 1 GROUP I MEMBER 3', 244617);
INSERT INTO "PUBLIC"."MODEL" VALUES
(350406, 'PTHR24082:SF473', NULL, NULL, NULL, NULL, 'ECDYSONE-INDUCED PROTEIN 75B, ISOFORM B', 244617),
(350407, 'PTHR24082:SF330', NULL, NULL, NULL, NULL, '', 244617),
(350408, 'PTHR24082:SF38', NULL, NULL, NULL, NULL, 'VITAMIN D3 RECEPTOR', 244617),
(350409, 'PTHR24082:SF197', NULL, NULL, NULL, NULL, 'PEROXISOME PROLIFERATOR-ACTIVATED RECEPTOR ALPHA', 244617),
(350410, 'PTHR24082:SF494', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER DAF-12', 244617),
(350411, 'PTHR24082:SF493', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-7', 244617),
(350412, 'PTHR24082:SF316', NULL, NULL, NULL, NULL, 'OXYSTEROLS RECEPTOR LXR-BETA', 244617),
(350413, 'PTHR24082:SF116', NULL, NULL, NULL, NULL, 'RETINOIC ACID RECEPTOR GAMMA', 244617),
(350414, 'PTHR24082:SF259', NULL, NULL, NULL, NULL, 'OXYSTEROLS RECEPTOR LXR-ALPHA', 244617),
(350415, 'PTHR24082:SF115', NULL, NULL, NULL, NULL, 'RETINOIC ACID RECEPTOR ALPHA', 244617),
(350416, 'PTHR24082:SF313', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR SUBFAMILY 1, GROUP H, MEMBER 5', 244617),
(350417, 'PTHR24082:SF334', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-85', 244617),
(350418, 'PTHR24082:SF113', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR SUBFAMILY 1 GROUP D MEMBER 1', 244617),
(350419, 'PTHR24082:SF42', NULL, NULL, NULL, NULL, 'THYROID HORMONE RECEPTOR ALPHA', 244617),
(350420, 'PTHR24082:SF464', NULL, NULL, NULL, NULL, 'RETINOIC ACID RECEPTOR', 244617),
(350421, 'PTHR24082:SF286', NULL, NULL, NULL, NULL, 'RETINOIC ACID RECEPTOR BETA', 244617),
(350422, 'PTHR24082:SF482', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR', 244617),
(350423, 'PTHR24082:SF283', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR HR96', 244617),
(350424, 'PTHR46045:SF4', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS U', 244618),
(350425, 'PTHR46045:SF5', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS U', 244618),
(350426, 'PTHR46045:SF6', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS U', 244618),
(350427, 'PTHR46045:SF7', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS U', 244618),
(350428, 'PTHR46045:SF8', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS U', 244618),
(350429, 'PTHR46045:SF11', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS U', 244618),
(350430, 'PTHR46045', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS U-RELATED', 244618),
(350431, 'PTHR46045:SF12', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS U', 244618),
(350432, 'PTHR46045:SF13', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS U', 244618),
(350433, 'PTHR46045:SF14', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS U', 244618),
(350434, 'PTHR46045:SF1', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS U', 244618),
(350435, 'PTHR46045:SF2', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS U', 244618),
(350436, 'PTHR46045:SF10', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS U', 244618),
(350437, 'PTHR46045:SF3', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS U', 244618),
(350438, 'PTHR46045:SF19', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS U', 244618),
(350439, 'PTHR46045:SF15', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS U', 244618),
(350440, 'PTHR46045:SF16', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS U-26', 244618),
(350441, 'PTHR46045:SF17', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS U', 244618),
(350442, 'PTHR46045:SF18', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS U', 244618),
(350443, 'PTHR31058:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER C4H2 DOMAIN-CONTAINING PROTEIN', 244619),
(350444, 'PTHR31058:SF10', NULL, NULL, NULL, NULL, 'C4H2-TYPE DOMAIN-CONTAINING PROTEIN', 244619),
(350445, 'PTHR31058', NULL, NULL, NULL, NULL, 'ZINC FINGER C4H2 DOMAIN-CONTAINING PROTEIN', 244619),
(350446, 'PTHR31793:SF32', NULL, NULL, NULL, NULL, 'ACYL-ACYL CARRIER PROTEIN THIOESTERASE ATL3 CHLOROPLASTIC', 244620),
(350447, 'PTHR31793:SF40', NULL, NULL, NULL, NULL, 'ACYL-COA THIOESTER HYDROLASE, YBGC/YBAW FAMILY', 244620),
(350448, 'PTHR31793:SF35', NULL, NULL, NULL, NULL, '4HBT DOMAIN-CONTAINING PROTEIN', 244620);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(350449, 'PTHR31793:SF24', NULL, NULL, NULL, NULL, 'LONG-CHAIN ACYL-COA THIOESTERASE FADM', 244620),
(350450, 'PTHR31793:SF25', NULL, NULL, NULL, NULL, 'OS04G0553100 PROTEIN', 244620),
(350451, 'PTHR31793:SF11', NULL, NULL, NULL, NULL, '', 244620),
(350452, 'PTHR31793:SF34', NULL, NULL, NULL, NULL, 'METHYLKETONE SYNTHASE II', 244620),
(350453, 'PTHR31793:SF28', NULL, NULL, NULL, NULL, '4HBT DOMAIN-CONTAINING PROTEIN', 244620),
(350454, 'PTHR31793:SF39', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 244620),
(350455, 'PTHR31793:SF37', NULL, NULL, NULL, NULL, 'ACYL-COA THIOESTER HYDROLASE YBGC', 244620),
(350456, 'PTHR31793:SF27', NULL, NULL, NULL, NULL, 'NOVEL THIOESTERASE SUPERFAMILY DOMAIN AND SAPOSIN A-TYPE DOMAIN CONTAINING PROTEIN (0610012H03RIK)', 244620),
(350457, 'PTHR31793:SF4', NULL, NULL, NULL, NULL, 'OS02G0659700 PROTEIN', 244620),
(350458, 'PTHR31793', NULL, NULL, NULL, NULL, '4-HYDROXYBENZOYL-COA THIOESTERASE FAMILY MEMBER', 244620),
(350459, 'PTHR31793:SF2', NULL, NULL, NULL, NULL, 'BLR1345 PROTEIN', 244620),
(350460, 'PTHR30329:SF21', NULL, NULL, NULL, NULL, 'LIPOPROTEIN YIAD-RELATED', 244621),
(350461, 'PTHR30329', NULL, NULL, NULL, NULL, 'STATOR ELEMENT OF FLAGELLAR MOTOR COMPLEX', 244621),
(350462, 'PTHR30329:SF20', NULL, NULL, NULL, NULL, 'EXPORTED PROTEIN-RELATED', 244621),
(350463, 'PTHR30329:SF16', NULL, NULL, NULL, NULL, 'CHEMOTAXIS MOTB PROTEIN', 244621),
(350464, 'PTHR30329:SF19', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN, OMPA FAMILY-RELATED', 244621),
(350465, 'PTHR30329:SF18', NULL, NULL, NULL, NULL, 'MOTILITY PROTEIN B', 244621),
(350466, 'PTHR30329:SF17', NULL, NULL, NULL, NULL, 'LIPOPROTEIN-RELATED', 244621),
(350467, 'PTHR13904', NULL, NULL, NULL, NULL, 'PRE-MRNA SPLICING FACTOR PRP31', 244622),
(350468, 'PTHR13904:SF4', NULL, NULL, NULL, NULL, 'NOP DOMAIN-CONTAINING PROTEIN', 244622),
(350469, 'PTHR13904:SF2', NULL, NULL, NULL, NULL, 'PRE-MRNA PROCESSING RIBONUCLEOPROTEIN, BINDING REGION_ NOSIC', 244622),
(350470, 'PTHR13904:SF3', NULL, NULL, NULL, NULL, 'NOP DOMAIN-CONTAINING PROTEIN', 244622),
(350471, 'PTHR13904:SF0', NULL, NULL, NULL, NULL, 'U4/U6 SMALL NUCLEAR RIBONUCLEOPROTEIN PRP31', 244622),
(350472, 'PTHR13904:SF1', NULL, NULL, NULL, NULL, 'FACTOR, PUTATIVE-RELATED', 244622),
(350473, 'PTHR31870:SF2', NULL, NULL, NULL, NULL, 'SI:DKEY-183I3.9-RELATED', 244623),
(350474, 'PTHR31870', NULL, NULL, NULL, NULL, 'SI:DKEY-183I3.9-RELATED', 244623),
(350475, 'PTHR31764', NULL, NULL, NULL, NULL, 'PROTEIN HAPLESS 2', 244624),
(350476, 'PTHR31764:SF0', NULL, NULL, NULL, NULL, 'HAP2-GCS1 DOMAIN-CONTAINING PROTEIN', 244624),
(350477, 'PTHR28200', NULL, NULL, NULL, NULL, 'DASH COMPLEX SUBUNIT ASK1', 244625),
(350478, 'PTHR28200:SF1', NULL, NULL, NULL, NULL, 'DASH COMPLEX SUBUNIT ASK1', 244625),
(350479, 'PTHR15420:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 10', 244626),
(350480, 'PTHR15420', NULL, NULL, NULL, NULL, 'UBIQUINOL-CYTOCHROME C REDUCTASE COMPLEX 6.4 KD PROTEIN', 244626),
(350481, 'PTHR47008:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CORDON-BLEU', 244627),
(350482, 'PTHR47008', NULL, NULL, NULL, NULL, 'PROTEIN CORDON-BLEU', 244627),
(350483, 'PTHR35727:SF2', NULL, NULL, NULL, NULL, '', 244628),
(350484, 'PTHR35727:SF5', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE DECARBOXYLASE LEADER PEPTIDE PROTEIN', 244628),
(350485, 'PTHR35727:SF6', NULL, NULL, NULL, NULL, '', 244628),
(350486, 'PTHR35727:SF7', NULL, NULL, NULL, NULL, '', 244628),
(350487, 'PTHR35727', NULL, NULL, NULL, NULL, 'BNAA05G33520D PROTEIN', 244628),
(350488, 'PTHR35727:SF9', NULL, NULL, NULL, NULL, '', 244628),
(350489, 'PTHR35727:SF10', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE DECARBOXYLASE PROENZYME', 244628),
(350490, 'PTHR35478:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER FYVE DOMAIN-CONTAINING PROTEIN 26', 244629),
(350491, 'PTHR35478', NULL, NULL, NULL, NULL, 'ZINC FINGER FYVE DOMAIN PROTEIN', 244629),
(350492, 'PTHR10554:SF12', NULL, NULL, NULL, NULL, 'IP02644P', 244630),
(350493, 'PTHR10554:SF1', NULL, NULL, NULL, NULL, 'FI16515P1', 244630);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(350494, 'PTHR10554:SF11', NULL, NULL, NULL, NULL, 'BETA-1-SYNTROPHIN', 244630),
(350495, 'PTHR10554:SF3', NULL, NULL, NULL, NULL, 'GAMMA-2-SYNTROPHIN', 244630),
(350496, 'PTHR10554:SF2', NULL, NULL, NULL, NULL, 'GAMMA-1-SYNTROPHIN', 244630),
(350497, 'PTHR10554:SF6', NULL, NULL, NULL, NULL, 'ALPHA-1-SYNTROPHIN', 244630),
(350498, 'PTHR10554:SF8', NULL, NULL, NULL, NULL, 'BETA-2-SYNTROPHIN', 244630),
(350499, 'PTHR10554', NULL, NULL, NULL, NULL, 'SYNTROPHIN', 244630),
(350500, 'PTHR15276:SF0', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 6', 244631),
(350501, 'PTHR15276', NULL, NULL, NULL, NULL, 'H4 D10S170  PROTEIN-RELATED', 244631),
(350502, 'PTHR31402', NULL, NULL, NULL, NULL, 'UPF0711 PROTEIN C18ORF21', 244632),
(350503, 'PTHR31402:SF2', NULL, NULL, NULL, NULL, 'UPF0711 PROTEIN C18ORF21', 244632),
(350504, 'PTHR35749:SF3', NULL, NULL, NULL, NULL, '', 244633),
(350505, 'PTHR35749:SF1', NULL, NULL, NULL, NULL, 'OSJNBA0084A10.10 PROTEIN', 244633),
(350506, 'PTHR35749', NULL, NULL, NULL, NULL, 'OSJNBA0084A10.10 PROTEIN', 244633),
(350507, 'PTHR34217', NULL, NULL, NULL, NULL, 'METAL-DEPENDENT CARBOXYPEPTIDASE', 244634),
(350508, 'PTHR34217:SF1', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE 1', 244634),
(350509, 'PTHR46678:SF2', NULL, NULL, NULL, NULL, 'LRAT DOMAIN-CONTAINING PROTEIN', 244635),
(350510, 'PTHR46678:SF1', NULL, NULL, NULL, NULL, 'LECITHIN RETINOL ACYLTRANSFERASE', 244635),
(350511, 'PTHR46678', NULL, NULL, NULL, NULL, 'LECITHIN RETINOL ACYLTRANSFERASE', 244635),
(350512, 'PTHR11748:SF116', NULL, NULL, NULL, NULL, 'D-LACTATE DEHYDROGENASE (CYTOCHROME) (AFU_ORTHOLOGUE AFUA_7G02560)', 244636),
(350513, 'PTHR11748', NULL, NULL, NULL, NULL, 'D-LACTATE DEHYDROGENASE', 244636),
(350514, 'PTHR11748:SF117', NULL, NULL, NULL, NULL, 'D-LACTATE DEHYDROGENASE', 244636),
(350515, 'PTHR11748:SF114', NULL, NULL, NULL, NULL, 'ARYL-ALCOHOL OXIDASE VANILLYL-ALCOHOL OXIDASE (AFU_ORTHOLOGUE AFUA_3G09500)-RELATED', 244636),
(350516, 'PTHR11748:SF103', NULL, NULL, NULL, NULL, 'GLYCOLATE OXIDASE SUBUNIT GLCE', 244636),
(350517, 'PTHR11748:SF83', NULL, NULL, NULL, NULL, 'DEHYDROGENASE (CYTOCHROME), PUTATIVE (AFU_ORTHOLOGUE AFUA_1G17520)-RELATED', 244636),
(350518, 'PTHR11748:SF111', NULL, NULL, NULL, NULL, 'D-LACTATE DEHYDROGENASE, MITOCHONDRIAL-RELATED', 244636),
(350519, 'PTHR11748:SF118', NULL, NULL, NULL, NULL, 'ALKYLDIHYDROXYACETONEPHOSPHATE SYNTHASE (PRECURSOR)', 244636),
(350520, 'PTHR11748:SF119', NULL, NULL, NULL, NULL, 'OXIDASE-RELATED', 244636),
(350521, 'PTHR15124:SF18', NULL, NULL, NULL, NULL, 'SELENOPROTEIN W', 244637),
(350522, 'PTHR15124:SF17', NULL, NULL, NULL, NULL, 'SELENOPROTEIN V', 244637),
(350523, 'PTHR15124:SF16', NULL, NULL, NULL, NULL, 'SELENOPROTEIN W', 244637),
(350524, 'PTHR15124:SF15', NULL, NULL, NULL, NULL, 'MIGRATION AND INVASION ENHANCER 1', 244637),
(350525, 'PTHR15124:SF26', NULL, NULL, NULL, NULL, '', 244637),
(350526, 'PTHR15124:SF20', NULL, NULL, NULL, NULL, '', 244637),
(350527, 'PTHR15124:SF25', NULL, NULL, NULL, NULL, 'MIGRATION AND INVASION ENHANCER 1-LIKE', 244637),
(350528, 'PTHR15124:SF23', NULL, NULL, NULL, NULL, 'PRKCSH_1 DOMAIN-CONTAINING PROTEIN', 244637),
(350529, 'PTHR15124', NULL, NULL, NULL, NULL, 'SELENOPROTEIN W', 244637),
(350530, 'PTHR10010:SF39', NULL, NULL, NULL, NULL, 'PHOU DOMAIN-CONTAINING PROTEIN', 244638),
(350531, 'PTHR10010:SF21', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT PHOSPHATE TRANSPORT PROTEIN 2A', 244638),
(350532, 'PTHR10010:SF47', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 34 MEMBER 2A', 244638),
(350533, 'PTHR10010:SF23', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT PHOSPHATE TRANSPORT PROTEIN 2B', 244638),
(350534, 'PTHR10010', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 34  SODIUM PHOSPHATE , MEMBER 2-RELATED', 244638),
(350535, 'PTHR10010:SF35', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT PHOSPHATE TRANSPORT PROTEIN 2C', 244638),
(350536, 'PTHR10010:SF46', NULL, NULL, NULL, NULL, 'SODIUM/PHOSPHATE COTRANSPORTER-RELATED', 244638),
(350537, 'PTHR38400:SF1', NULL, NULL, NULL, NULL, 'OS02G0317800 PROTEIN', 244639);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(350538, 'PTHR38400:SF2', NULL, NULL, NULL, NULL, '', 244639),
(350539, 'PTHR38400', NULL, NULL, NULL, NULL, 'OS02G0317800 PROTEIN', 244639),
(350540, 'PTHR30538:SF1', NULL, NULL, NULL, NULL, 'L-LYSINE 2,3-AMINOMUTASE', 244640),
(350541, 'PTHR30538:SF0', NULL, NULL, NULL, NULL, 'L-LYSINE 2,3-AMINOMUTASE AQ_1632-RELATED', 244640),
(350542, 'PTHR30538', NULL, NULL, NULL, NULL, 'LYSINE 2,3-AMINOMUTASE-RELATED', 244640),
(350543, 'PTHR40466:SF1', NULL, NULL, NULL, NULL, 'FUNGAL PROTEIN', 244641),
(350544, 'PTHR40466', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244641),
(350545, 'PTHR33399:SF9', NULL, NULL, NULL, NULL, 'OS02G0631100 PROTEIN', 244642),
(350546, 'PTHR33399:SF10', NULL, NULL, NULL, NULL, 'BNAA05G33860D PROTEIN', 244642),
(350547, 'PTHR33399:SF8', NULL, NULL, NULL, NULL, 'OS04G0522800 PROTEIN', 244642),
(350548, 'PTHR33399:SF3', NULL, NULL, NULL, NULL, 'OXYGEN-EVOLVING ENHANCER PROTEIN 3-1, CHLOROPLASTIC', 244642),
(350549, 'PTHR33399:SF2', NULL, NULL, NULL, NULL, 'PHOTOSYNTHETIC NDH SUBUNIT OF LUMENAL LOCATION 3, CHLOROPLASTIC', 244642),
(350550, 'PTHR33399:SF7', NULL, NULL, NULL, NULL, 'OXYGEN-EVOLVING ENHANCER PROTEIN 3-2, CHLOROPLASTIC', 244642),
(350551, 'PTHR33399:SF6', NULL, NULL, NULL, NULL, 'PSBQ-LIKE PROTEIN 3, CHLOROPLASTIC', 244642),
(350552, 'PTHR33399:SF5', NULL, NULL, NULL, NULL, 'PHOTOSYNTHETIC NDH SUBUNIT OF LUMENAL LOCATION 2, CHLOROPLASTIC', 244642),
(350553, 'PTHR33399:SF13', NULL, NULL, NULL, NULL, 'BNAA06G08980D PROTEIN', 244642),
(350554, 'PTHR33399', NULL, NULL, NULL, NULL, 'OXYGEN-EVOLVING ENHANCER PROTEIN 3-1, CHLOROPLASTIC', 244642),
(350555, 'PTHR33075:SF7', NULL, NULL, NULL, NULL, 'OS02G0513250 PROTEIN', 244643),
(350556, 'PTHR33075:SF8', NULL, NULL, NULL, NULL, 'OS02G0303350 PROTEIN', 244643),
(350557, 'PTHR33075:SF6', NULL, NULL, NULL, NULL, '', 244643),
(350558, 'PTHR33075', NULL, NULL, NULL, NULL, 'OS02G0499800 PROTEIN', 244643),
(350559, 'PTHR39661', NULL, NULL, NULL, NULL, 'UPF0310 PROTEIN MJECL36', 244644),
(350560, 'PTHR39661:SF1', NULL, NULL, NULL, NULL, 'UPF0310 PROTEIN MJECL36', 244644),
(350561, 'PTHR31451:SF36', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE 4', 244645),
(350562, 'PTHR31451:SF59', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE', 244645),
(350563, 'PTHR31451:SF39', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE 1', 244645),
(350564, 'PTHR31451:SF10', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE B', 244645),
(350565, 'PTHR31451:SF54', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE 6', 244645),
(350566, 'PTHR31451:SF55', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE 1', 244645),
(350567, 'PTHR31451:SF56', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE', 244645),
(350568, 'PTHR31451:SF57', NULL, NULL, NULL, NULL, 'BETA-1,4-ENDOGLUCANASE (EUROFUNG)-RELATED', 244645),
(350569, 'PTHR31451:SF50', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE', 244645),
(350570, 'PTHR31451:SF51', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE 6', 244645),
(350571, 'PTHR31451:SF52', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE', 244645),
(350572, 'PTHR31451:SF53', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE', 244645),
(350573, 'PTHR31451:SF48', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE 5', 244645),
(350574, 'PTHR31451:SF49', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE', 244645),
(350575, 'PTHR31451:SF65', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE', 244645),
(350576, 'PTHR31451:SF21', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE C', 244645),
(350577, 'PTHR31451:SF66', NULL, NULL, NULL, NULL, '', 244645),
(350578, 'PTHR31451:SF45', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE 2', 244645),
(350579, 'PTHR31451:SF46', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE 8', 244645),
(350580, 'PTHR31451:SF40', NULL, NULL, NULL, NULL, '', 244645),
(350581, 'PTHR31451:SF62', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE 2', 244645),
(350582, 'PTHR31451:SF64', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE 7', 244645);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(350583, 'PTHR31451:SF42', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE 3-RELATED', 244645),
(350584, 'PTHR31451', NULL, NULL, NULL, NULL, '', 244645),
(350585, 'PTHR31451:SF60', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE A-RELATED', 244645),
(350586, 'PTHR31852:SF267', NULL, NULL, NULL, NULL, 'OS04G0430600 PROTEIN', 244646),
(350587, 'PTHR31852:SF145', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY', 244646),
(350588, 'PTHR31852:SF266', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 244646),
(350589, 'PTHR31852:SF265', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 244646),
(350590, 'PTHR31852:SF144', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY', 244646),
(350591, 'PTHR31852:SF264', NULL, NULL, NULL, NULL, 'BNAC07G32890D PROTEIN', 244646),
(350592, 'PTHR31852:SF143', NULL, NULL, NULL, NULL, 'HARPIN-INDUCED 1', 244646),
(350593, 'PTHR31852:SF263', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 244646),
(350594, 'PTHR31852:SF142', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 244646),
(350595, 'PTHR31852:SF141', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN, GROUP 2', 244646),
(350596, 'PTHR31852:SF269', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 244646),
(350597, 'PTHR31852:SF268', NULL, NULL, NULL, NULL, '', 244646),
(350598, 'PTHR31852:SF134', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY', 244646),
(350599, 'PTHR31852:SF254', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 244646),
(350600, 'PTHR31852:SF132', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 244646),
(350601, 'PTHR31852:SF252', NULL, NULL, NULL, NULL, '', 244646),
(350602, 'PTHR31852:SF130', NULL, NULL, NULL, NULL, 'PROLINE-RICH RECEPTOR-LIKE KINASE', 244646),
(350603, 'PTHR31852:SF259', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 244646),
(350604, 'PTHR31852:SF138', NULL, NULL, NULL, NULL, 'F3F19.7', 244646),
(350605, 'PTHR31852:SF136', NULL, NULL, NULL, NULL, 'OS01G0228500 PROTEIN', 244646),
(350606, 'PTHR31852:SF245', NULL, NULL, NULL, NULL, 'OS05G0526700 PROTEIN', 244646),
(350607, 'PTHR31852:SF124', NULL, NULL, NULL, NULL, 'HARPIN-INDUCED PROTEIN 1 CONTAINING PROTEIN, EXPRESSED', 244646),
(350608, 'PTHR31852:SF243', NULL, NULL, NULL, NULL, 'WHY DOMAIN-CONTAINING PROTEIN', 244646),
(350609, 'PTHR31852:SF122', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY', 244646),
(350610, 'PTHR31852:SF241', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN FAMILY PROTEIN, PUTATIVE-RELATED', 244646),
(350611, 'PTHR31852:SF240', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 244646),
(350612, 'PTHR31852:SF50', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN', 244646),
(350613, 'PTHR31852:SF248', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY-RELATED', 244646),
(350614, 'PTHR31852:SF247', NULL, NULL, NULL, NULL, 'HARPIN-INDUCED PROTEIN 1 CONTAINING PROTEIN, EXPRESSED', 244646),
(350615, 'PTHR31852:SF246', NULL, NULL, NULL, NULL, '', 244646),
(350616, 'PTHR31852:SF232', NULL, NULL, NULL, NULL, 'PLANT CELL WALL PROTEIN SLTFR88', 244646),
(350617, 'PTHR31852:SF231', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 244646),
(350618, 'PTHR31852:SF198', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 244646),
(350619, 'PTHR31852:SF195', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY', 244646),
(350620, 'PTHR31852:SF194', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 244646),
(350621, 'PTHR31852:SF192', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 244646),
(350622, 'PTHR31852:SF55', NULL, NULL, NULL, NULL, 'OS06G0121300 PROTEIN', 244646),
(350623, 'PTHR31852:SF53', NULL, NULL, NULL, NULL, 'OS02G0667600 PROTEIN', 244646);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(350624, 'PTHR31852:SF52', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN', 244646),
(350625, 'PTHR31852:SF119', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 244646),
(350626, 'PTHR31852:SF239', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 244646),
(350627, 'PTHR31852:SF237', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 244646),
(350628, 'PTHR31852:SF236', NULL, NULL, NULL, NULL, 'HARPIN-INDUCED PROTEIN 1 CONTAINING PROTEIN, EXPRESSED', 244646),
(350629, 'PTHR31852:SF223', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN, GROUP 2', 244646),
(350630, 'PTHR31852:SF189', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 244646),
(350631, 'PTHR31852:SF188', NULL, NULL, NULL, NULL, 'EMB|CAB53482.1', 244646),
(350632, 'PTHR31852:SF221', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 244646),
(350633, 'PTHR31852:SF220', NULL, NULL, NULL, NULL, 'PROTEIN YLS9-LIKE', 244646),
(350634, 'PTHR31852:SF186', NULL, NULL, NULL, NULL, 'DELTA-LATROINSECTOTOXIN-LT1A PROTEIN', 244646),
(350635, 'PTHR31852:SF185', NULL, NULL, NULL, NULL, 'OS02G0507900 PROTEIN', 244646),
(350636, 'PTHR31852:SF183', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 244646),
(350637, 'PTHR31852:SF180', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 244646),
(350638, 'PTHR31852:SF25', NULL, NULL, NULL, NULL, 'OS06G0163300 PROTEIN', 244646),
(350639, 'PTHR31852:SF22', NULL, NULL, NULL, NULL, 'OS05G0238400 PROTEIN', 244646),
(350640, 'PTHR31852:SF21', NULL, NULL, NULL, NULL, 'OS07G0524200 PROTEIN', 244646),
(350641, 'PTHR31852:SF228', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 244646),
(350642, 'PTHR31852:SF227', NULL, NULL, NULL, NULL, '', 244646),
(350643, 'PTHR31852:SF226', NULL, NULL, NULL, NULL, '', 244646),
(350644, 'PTHR31852:SF212', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY', 244646),
(350645, 'PTHR31852:SF177', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 244646),
(350646, 'PTHR31852:SF176', NULL, NULL, NULL, NULL, 'OS09G0267400 PROTEIN', 244646),
(350647, 'PTHR31852:SF175', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 244646),
(350648, 'PTHR31852:SF172', NULL, NULL, NULL, NULL, 'PROTEIN YLS9-LIKE', 244646),
(350649, 'PTHR31852:SF170', NULL, NULL, NULL, NULL, 'HARPIN INDUCED PROTEIN 4', 244646),
(350650, 'PTHR31852', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY', 244646),
(350651, 'PTHR31852:SF33', NULL, NULL, NULL, NULL, 'OS05G0584300 PROTEIN', 244646),
(350652, 'PTHR31852:SF31', NULL, NULL, NULL, NULL, 'OS06G0521300 PROTEIN', 244646),
(350653, 'PTHR31852:SF30', NULL, NULL, NULL, NULL, 'OS08G0324200 PROTEIN', 244646),
(350654, 'PTHR31852:SF219', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 244646),
(350655, 'PTHR31852:SF215', NULL, NULL, NULL, NULL, 'HARPIN-INDUCED 1', 244646),
(350656, 'PTHR31852:SF201', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 244646),
(350657, 'PTHR31852:SF167', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 244646),
(350658, 'PTHR31852:SF285', NULL, NULL, NULL, NULL, 'OS09G0435400 PROTEIN', 244646),
(350659, 'PTHR31852:SF284', NULL, NULL, NULL, NULL, 'HARPIN-INDUCED PROTEIN', 244646),
(350660, 'PTHR31852:SF163', NULL, NULL, NULL, NULL, 'OS06G0121100 PROTEIN', 244646),
(350661, 'PTHR31852:SF283', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 244646),
(350662, 'PTHR31852:SF162', NULL, NULL, NULL, NULL, 'OS08G0163600 PROTEIN', 244646),
(350663, 'PTHR31852:SF282', NULL, NULL, NULL, NULL, '', 244646),
(350664, 'PTHR31852:SF281', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 244646),
(350665, 'PTHR31852:SF160', NULL, NULL, NULL, NULL, '', 244646),
(350666, 'PTHR31852:SF280', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 244646),
(350667, 'PTHR31852:SF7', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY', 244646);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(350668, 'PTHR31852:SF4', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 244646),
(350669, 'PTHR31852:SF5', NULL, NULL, NULL, NULL, 'GB|AAF18257.1', 244646),
(350670, 'PTHR31852:SF9', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN', 244646),
(350671, 'PTHR31852:SF2', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 244646),
(350672, 'PTHR31852:SF3', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY', 244646),
(350673, 'PTHR31852:SF0', NULL, NULL, NULL, NULL, 'NDR1/HIN1-LIKE PROTEIN 13', 244646),
(350674, 'PTHR31852:SF1', NULL, NULL, NULL, NULL, 'NDR1/HIN1-LIKE PROTEIN 6', 244646),
(350675, 'PTHR31852:SF209', NULL, NULL, NULL, NULL, 'NDR1/HIN1-LIKE 25', 244646),
(350676, 'PTHR31852:SF206', NULL, NULL, NULL, NULL, '', 244646),
(350677, 'PTHR31852:SF205', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 244646),
(350678, 'PTHR31852:SF204', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY-RELATED', 244646),
(350679, 'PTHR31852:SF203', NULL, NULL, NULL, NULL, 'HIN1', 244646),
(350680, 'PTHR31852:SF202', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 244646),
(350681, 'PTHR31852:SF157', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN', 244646),
(350682, 'PTHR31852:SF278', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN', 244646),
(350683, 'PTHR31852:SF277', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN, LEA-14-RELATED', 244646),
(350684, 'PTHR31852:SF155', NULL, NULL, NULL, NULL, 'HARPIN-INDUCED PROTEIN', 244646),
(350685, 'PTHR31852:SF276', NULL, NULL, NULL, NULL, '', 244646),
(350686, 'PTHR31852:SF154', NULL, NULL, NULL, NULL, 'NDR1/HIN1-LIKE PROTEIN 3-LIKE', 244646),
(350687, 'PTHR31852:SF275', NULL, NULL, NULL, NULL, 'BNACNNG52290D PROTEIN', 244646),
(350688, 'PTHR31852:SF153', NULL, NULL, NULL, NULL, 'OS05G0482501 PROTEIN', 244646),
(350689, 'PTHR31852:SF274', NULL, NULL, NULL, NULL, 'GRPE-LIKE PROTEIN', 244646),
(350690, 'PTHR31852:SF273', NULL, NULL, NULL, NULL, '', 244646),
(350691, 'PTHR31852:SF151', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 244646),
(350692, 'PTHR31852:SF272', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 244646),
(350693, 'PTHR31852:SF150', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN', 244646),
(350694, 'PTHR31852:SF271', NULL, NULL, NULL, NULL, 'BNAA08G04160D PROTEIN', 244646),
(350695, 'PTHR31852:SF270', NULL, NULL, NULL, NULL, '', 244646),
(350696, 'PTHR31852:SF279', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 244646),
(350697, 'PTHR36343', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244647),
(350698, 'PTHR36343:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244647),
(350699, 'PTHR16875', NULL, NULL, NULL, NULL, 'SELENOPROTEIN K', 244648),
(350700, 'PTHR16875:SF0', NULL, NULL, NULL, NULL, 'SELENOPROTEIN K', 244648),
(350701, 'PTHR14097', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE HTATIP2', 244649),
(350702, 'PTHR14097:SF9', NULL, NULL, NULL, NULL, 'EPIMERASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G07320)-RELATED', 244649),
(350703, 'PTHR14097:SF8', NULL, NULL, NULL, NULL, 'EPIMERASES, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G00670)-RELATED', 244649),
(350704, 'PTHR14097:SF7', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE HTATIP2', 244649),
(350705, 'PTHR36012', NULL, NULL, NULL, NULL, 'OS01G0654400 PROTEIN', 244650),
(350706, 'PTHR36012:SF4', NULL, NULL, NULL, NULL, 'OS08G0385000 PROTEIN', 244650),
(350707, 'PTHR36012:SF2', NULL, NULL, NULL, NULL, 'OS01G0654400 PROTEIN', 244650),
(350708, 'PTHR10494:SF16', NULL, NULL, NULL, NULL, 'NOGGIN', 244651),
(350709, 'PTHR10494:SF6', NULL, NULL, NULL, NULL, 'NOGGIN4', 244651),
(350710, 'PTHR10494:SF5', NULL, NULL, NULL, NULL, 'NOGGIN', 244651),
(350711, 'PTHR10494', NULL, NULL, NULL, NULL, 'BONE MORPHOGENETIC PROTEIN INHIBITOR, NOGGIN', 244651),
(350712, 'PTHR10494:SF4', NULL, NULL, NULL, NULL, 'NOGGIN', 244651),
(350713, 'PTHR22932:SF13', NULL, NULL, NULL, NULL, 'CS DOMAIN-CONTAINING PROTEIN', 244652);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(350714, 'PTHR22932:SF23', NULL, NULL, NULL, NULL, 'CS DOMAIN-CONTAINING PROTEIN', 244652),
(350715, 'PTHR22932', NULL, NULL, NULL, NULL, 'TELOMERASE-BINDING PROTEIN P23  HSP90 CO-CHAPERONE', 244652),
(350716, 'PTHR22932:SF4', NULL, NULL, NULL, NULL, 'PROTEIN PTGES3L-RELATED', 244652),
(350717, 'PTHR22932:SF3', NULL, NULL, NULL, NULL, 'PROSTAGLANDIN E SYNTHASE 3', 244652),
(350718, 'PTHR22932:SF14', NULL, NULL, NULL, NULL, 'CS DOMAIN-CONTAINING PROTEIN', 244652),
(350719, 'PTHR22932:SF20', NULL, NULL, NULL, NULL, 'CO-CHAPERONE PROTEIN P23-1', 244652),
(350720, 'PTHR22932:SF9', NULL, NULL, NULL, NULL, 'CS DOMAIN-CONTAINING PROTEIN', 244652),
(350721, 'PTHR22932:SF22', NULL, NULL, NULL, NULL, 'CS DOMAIN-CONTAINING PROTEIN', 244652),
(350722, 'PTHR22932:SF11', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244652),
(350723, 'PTHR22932:SF21', NULL, NULL, NULL, NULL, 'BNAA05G32740D PROTEIN', 244652),
(350724, 'PTHR22932:SF10', NULL, NULL, NULL, NULL, 'CS DOMAIN-CONTAINING PROTEIN', 244652),
(350725, 'PTHR22932:SF18', NULL, NULL, NULL, NULL, 'CS DOMAIN-CONTAINING PROTEIN', 244652),
(350726, 'PTHR22932:SF1', NULL, NULL, NULL, NULL, 'CO-CHAPERONE PROTEIN DAF-41', 244652),
(350727, 'PTHR47473', NULL, NULL, NULL, NULL, 'BTA1P', 244653),
(350728, 'PTHR47473:SF1', NULL, NULL, NULL, NULL, 'METHYLTRANSF_25 DOMAIN-CONTAINING PROTEIN', 244653),
(350729, 'PTHR21179:SF1', NULL, NULL, NULL, NULL, 'KAZ1-TYPE SERINE PROTEASE INHIBITOR-LIKE PROTEIN TYPE EPSILON-RELATED', 244654),
(350730, 'PTHR21179', NULL, NULL, NULL, NULL, 'SERINE-TYPE ENDOPEPTIDASE INHIBITOR', 244654),
(350731, 'PTHR21179:SF0', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR KAZAL-TYPE 4', 244654),
(350732, 'PTHR10501:SF25', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN WITH MULTIPLE SPLICING', 244655),
(350733, 'PTHR10501:SF69', NULL, NULL, NULL, NULL, 'RNP (RRM RNA BINDING DOMAIN) CONTAINING', 244655),
(350734, 'PTHR10501:SF13', NULL, NULL, NULL, NULL, 'U1 SMALL NUCLEAR RIBONUCLEOPROTEIN A', 244655),
(350735, 'PTHR10501:SF68', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 244655),
(350736, 'PTHR10501:SF79', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 2-LIKE ISOFORM X1', 244655),
(350737, 'PTHR10501:SF78', NULL, NULL, NULL, NULL, 'OS06G0127500 PROTEIN', 244655),
(350738, 'PTHR10501:SF43', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN-RELATED', 244655),
(350739, 'PTHR10501:SF65', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 244655),
(350740, 'PTHR10501:SF64', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN A, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G06490)-RELATED', 244655),
(350741, 'PTHR10501:SF53', NULL, NULL, NULL, NULL, 'NUCLEAR SPECKLE RNA-BINDING PROTEIN A', 244655),
(350742, 'PTHR10501:SF30', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN WITH MULTIPLE SPLICING 2', 244655),
(350743, 'PTHR10501:SF63', NULL, NULL, NULL, NULL, 'U1 SMALL NUCLEAR RIBONUCLEOPROTEIN A', 244655),
(350744, 'PTHR10501:SF41', NULL, NULL, NULL, NULL, 'PROTEIN COUCH POTATO', 244655),
(350745, 'PTHR10501:SF84', NULL, NULL, NULL, NULL, 'U2 SMALL NUCLEAR RIBONUCLEOPROTEIN B''''', 244655),
(350746, 'PTHR10501:SF73', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 244655),
(350747, 'PTHR10501:SF49', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 244655),
(350748, 'PTHR10501:SF48', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 244655),
(350749, 'PTHR10501', NULL, NULL, NULL, NULL, 'U1 SMALL NUCLEAR RIBONUCLEOPROTEIN A/U2 SMALL NUCLEAR RIBONUCLEOPROTEIN B', 244655),
(350750, 'PTHR10501:SF61', NULL, NULL, NULL, NULL, 'U2 SMALL NUCLEAR RIBONUCLEOPROTEIN B''''', 244655),
(350751, 'PTHR10501:SF83', NULL, NULL, NULL, NULL, 'OS09G0527500 PROTEIN', 244655),
(350752, 'PTHR10501:SF71', NULL, NULL, NULL, NULL, 'U2 SMALL NUCLEAR RIBONUCLEOPROTEIN B''''-RELATED', 244655),
(350753, 'PTHR10501:SF82', NULL, NULL, NULL, NULL, 'NUCLEAR SPECKLE RNA-BINDING PROTEIN B', 244655),
(350754, 'PTHR10501:SF81', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 1', 244655),
(350755, 'PTHR10501:SF80', NULL, NULL, NULL, NULL, 'PROTEIN MATERNALLY EXPRESSED GENE 5', 244655);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(350756, 'PTHR43015:SF1', NULL, NULL, NULL, NULL, 'D-RIBITOL-5-PHOSPHATE CYTIDYLYLTRANSFERASE', 244656),
(350757, 'PTHR43015', NULL, NULL, NULL, NULL, 'D-RIBITOL-5-PHOSPHATE CYTIDYLYLTRANSFERASE', 244656),
(350758, 'PTHR20948', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244657),
(350759, 'PTHR20948:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 164', 244657),
(350760, 'PTHR20948:SF3', NULL, NULL, NULL, NULL, '', 244657),
(350761, 'PTHR10091', NULL, NULL, NULL, NULL, 'ALDOSE-1-EPIMERASE', 244658),
(350762, 'PTHR10091:SF32', NULL, NULL, NULL, NULL, 'ALDOSE 1-EPIMERASE', 244658),
(350763, 'PTHR10091:SF31', NULL, NULL, NULL, NULL, 'ALDOSE 1-EPIMERASE', 244658),
(350764, 'PTHR10091:SF34', NULL, NULL, NULL, NULL, 'ALDOSE 1-EPIMERASE', 244658),
(350765, 'PTHR10091:SF33', NULL, NULL, NULL, NULL, 'ALDOSE 1-EPIMERASE', 244658),
(350766, 'PTHR10091:SF36', NULL, NULL, NULL, NULL, 'ALDOSE 1-EPIMERASE', 244658),
(350767, 'PTHR10091:SF13', NULL, NULL, NULL, NULL, 'ALDOSE 1-EPIMERASE', 244658),
(350768, 'PTHR10091:SF35', NULL, NULL, NULL, NULL, 'ALDOSE 1-EPIMERASE', 244658),
(350769, 'PTHR10091:SF0', NULL, NULL, NULL, NULL, 'GALACTOSE MUTAROTASE', 244658),
(350770, 'PTHR10091:SF29', NULL, NULL, NULL, NULL, 'ALDOSE 1-EPIMERASE', 244658),
(350771, 'PTHR10091:SF28', NULL, NULL, NULL, NULL, 'ALDOSE 1-EPIMERASE', 244658),
(350772, 'PTHR10091:SF3', NULL, NULL, NULL, NULL, 'ALDOSE 1-EPIMERASE', 244658),
(350773, 'PTHR10091:SF2', NULL, NULL, NULL, NULL, 'ALDOSE 1-EPIMERASE', 244658),
(350774, 'PTHR10091:SF8', NULL, NULL, NULL, NULL, 'GALACTOSE MUTAROTASE-LIKE SUPERFAMILY PROTEIN', 244658),
(350775, 'PTHR10091:SF6', NULL, NULL, NULL, NULL, '1-EPIMERASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G13240)-RELATED', 244658),
(350776, 'PTHR10091:SF21', NULL, NULL, NULL, NULL, 'ALDOSE 1-EPIMERASE', 244658),
(350777, 'PTHR10091:SF42', NULL, NULL, NULL, NULL, 'ALDOSE 1-EPIMERASE', 244658),
(350778, 'PTHR10091:SF20', NULL, NULL, NULL, NULL, 'ALDOSE 1-EPIMERASE', 244658),
(350779, 'PTHR10091:SF45', NULL, NULL, NULL, NULL, 'ALDOSE EPIMERASE FAMILY PROTEIN', 244658),
(350780, 'PTHR10091:SF23', NULL, NULL, NULL, NULL, 'ALDOSE 1-EPIMERASE', 244658),
(350781, 'PTHR10091:SF44', NULL, NULL, NULL, NULL, 'ALDOSE 1-EPIMERASE', 244658),
(350782, 'PTHR10091:SF47', NULL, NULL, NULL, NULL, 'ALDOSE 1-EPIMERASE', 244658),
(350783, 'PTHR10091:SF25', NULL, NULL, NULL, NULL, 'ALDOSE 1-EPIMERASE', 244658),
(350784, 'PTHR10091:SF24', NULL, NULL, NULL, NULL, 'GALACTOSE MUTAROTASE-LIKE SUPERFAMILY PROTEIN', 244658),
(350785, 'PTHR10091:SF46', NULL, NULL, NULL, NULL, 'ALDOSE 1-EPIMERASE FAMILY PROTEIN', 244658),
(350786, 'PTHR10091:SF26', NULL, NULL, NULL, NULL, 'ALDOSE 1-EPIMERASE', 244658),
(350787, 'PTHR14098', NULL, NULL, NULL, NULL, 'SH2 DOMAIN CONTAINING PROTEIN', 244659),
(350788, 'PTHR14098:SF17', NULL, NULL, NULL, NULL, 'SH2 DOMAIN-CONTAINING PROTEIN', 244659),
(350789, 'PTHR14098:SF2', NULL, NULL, NULL, NULL, 'CYTOKINE-DEPENDENT HEMATOPOIETIC CELL LINKER', 244659),
(350790, 'PTHR14098:SF16', NULL, NULL, NULL, NULL, 'SH2 DOMAIN-CONTAINING PROTEIN 6', 244659),
(350791, 'PTHR14098:SF1', NULL, NULL, NULL, NULL, 'LYMPHOCYTE CYTOSOLIC PROTEIN 2', 244659),
(350792, 'PTHR14098:SF14', NULL, NULL, NULL, NULL, 'RH14395P', 244659),
(350793, 'PTHR14098:SF3', NULL, NULL, NULL, NULL, 'B-CELL LINKER PROTEIN', 244659),
(350794, 'PTHR10980:SF55', NULL, NULL, NULL, NULL, 'BNAC04G19820D PROTEIN', 244660),
(350795, 'PTHR10980:SF44', NULL, NULL, NULL, NULL, 'RHO PROTEIN GDP-DISSOCIATION INHIBITOR-RELATED', 244660),
(350796, 'PTHR10980:SF54', NULL, NULL, NULL, NULL, 'BNAC08G15330D PROTEIN', 244660),
(350797, 'PTHR10980:SF35', NULL, NULL, NULL, NULL, '', 244660),
(350798, 'PTHR10980:SF46', NULL, NULL, NULL, NULL, 'BNAA06G38240D PROTEIN', 244660),
(350799, 'PTHR10980:SF57', NULL, NULL, NULL, NULL, 'RHO GDP-DISSOCIATION INHIBITOR 1-LIKE', 244660),
(350800, 'PTHR10980:SF45', NULL, NULL, NULL, NULL, 'RHO GDP-DISSOCIATION INHIBITOR 1-LIKE', 244660),
(350801, 'PTHR10980:SF15', NULL, NULL, NULL, NULL, 'RHO GDP-DISSOCIATION INHIBITOR 2', 244660),
(350802, 'PTHR10980:SF14', NULL, NULL, NULL, NULL, 'RHO GDP-DISSOCIATION INHIBITOR 2-RELATED', 244660);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(350803, 'PTHR10980:SF47', NULL, NULL, NULL, NULL, 'BNAC08G41570D PROTEIN', 244660),
(350804, 'PTHR10980:SF39', NULL, NULL, NULL, NULL, 'RHO GDP-DISSOCIATION INHIBITOR 1', 244660),
(350805, 'PTHR10980:SF49', NULL, NULL, NULL, NULL, 'RHO GDP-DISSOCIATION INHIBITOR 1-LIKE', 244660),
(350806, 'PTHR10980:SF38', NULL, NULL, NULL, NULL, '', 244660),
(350807, 'PTHR10980:SF9', NULL, NULL, NULL, NULL, 'RHO GDP-DISSOCIATION INHIBITOR 1', 244660),
(350808, 'PTHR10980:SF60', NULL, NULL, NULL, NULL, 'RHO GDP-DISSOCIATION INHIBITOR-RELATED', 244660),
(350809, 'PTHR10980:SF50', NULL, NULL, NULL, NULL, 'RHO GDP-DISSOCIATION INHIBITOR 1', 244660),
(350810, 'PTHR10980:SF61', NULL, NULL, NULL, NULL, 'OS01G0913600 PROTEIN', 244660),
(350811, 'PTHR10980:SF53', NULL, NULL, NULL, NULL, 'BNAA05G29800D PROTEIN', 244660),
(350812, 'PTHR10980:SF52', NULL, NULL, NULL, NULL, 'BNAC09G13520D PROTEIN', 244660),
(350813, 'PTHR10980:SF3', NULL, NULL, NULL, NULL, 'LD16419P', 244660),
(350814, 'PTHR10980:SF8', NULL, NULL, NULL, NULL, 'RHO GDP-DISSOCIATION INHIBITOR 3', 244660),
(350815, 'PTHR10980', NULL, NULL, NULL, NULL, 'RHO GDP-DISSOCIATION INHIBITOR', 244660),
(350816, 'PTHR11633:SF15', NULL, NULL, NULL, NULL, 'PDGF-2', 244661),
(350817, 'PTHR11633:SF2', NULL, NULL, NULL, NULL, 'PLATELET-DERIVED GROWTH FACTOR SUBUNIT B', 244661),
(350818, 'PTHR11633', NULL, NULL, NULL, NULL, 'PLATELET-DERIVED GROWTH FACTOR', 244661),
(350819, 'PTHR11633:SF1', NULL, NULL, NULL, NULL, 'LD28763P', 244661),
(350820, 'PTHR11633:SF4', NULL, NULL, NULL, NULL, 'PLATELET-DERIVED GROWTH FACTOR D', 244661),
(350821, 'PTHR11633:SF3', NULL, NULL, NULL, NULL, 'PLATELET-DERIVED GROWTH FACTOR SUBUNIT A', 244661),
(350822, 'PTHR11633:SF5', NULL, NULL, NULL, NULL, 'PLATELET-DERIVED GROWTH FACTOR C', 244661),
(350823, 'PTHR13359', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L40, MITOCHONDRIAL', 244662),
(350824, 'PTHR13359:SF3', NULL, NULL, NULL, NULL, 'COPPER ION-BINDING PROTEIN', 244662),
(350825, 'PTHR13359:SF2', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L40, MITOCHONDRIAL', 244662),
(350826, 'PTHR35928', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S3, MITOCHONDRIAL', 244663),
(350827, 'PTHR35928:SF2', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S3, MITOCHONDRIAL', 244663),
(350828, 'PTHR32052', NULL, NULL, NULL, NULL, '', 244664),
(350829, 'PTHR32052:SF10', NULL, NULL, NULL, NULL, '', 244664),
(350830, 'PTHR34349:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 32', 244665),
(350831, 'PTHR34349', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 32', 244665),
(350832, 'PTHR35902', NULL, NULL, NULL, NULL, 'S-LAYER DOMAIN-LIKE PROTEIN-RELATED', 244666),
(350833, 'PTHR35902:SF3', NULL, NULL, NULL, NULL, 'CONSERVED WITHIN P. AEROPHILUM', 244666),
(350834, 'PTHR35902:SF5', NULL, NULL, NULL, NULL, 'CARDB DOMAIN-CONTAINING PROTEIN', 244666),
(350835, 'PTHR31794:SF2', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX TRANSPORTER FAMILY PROTEIN (EUROFUNG)', 244667),
(350836, 'PTHR31794:SF4', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX TRANSPORTER FAMILY PROTEIN (EUROFUNG)', 244667),
(350837, 'PTHR31794', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX TRANSPORTER FAMILY PROTEIN (EUROFUNG)', 244667),
(350838, 'PTHR46831:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER MYND DOMAIN-CONTAINING PROTEIN 19', 244668),
(350839, 'PTHR46831', NULL, NULL, NULL, NULL, 'ZINC FINGER MYND DOMAIN-CONTAINING PROTEIN 19', 244668),
(350840, 'PTHR33033:SF110', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 244669),
(350841, 'PTHR33033:SF69', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 244669),
(350842, 'PTHR33033:SF89', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 244669),
(350843, 'PTHR33033:SF87', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 244669),
(350844, 'PTHR33033:SF66', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 244669),
(350845, 'PTHR33033:SF88', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 244669),
(350846, 'PTHR33033:SF86', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 244669);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(350847, 'PTHR33033:SF83', NULL, NULL, NULL, NULL, '14.7 KDA RIBONUCLEASE H-LIKE PROTEIN', 244669),
(350848, 'PTHR33033:SF101', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 244669),
(350849, 'PTHR33033:SF100', NULL, NULL, NULL, NULL, 'OS06G0629687 PROTEIN', 244669),
(350850, 'PTHR33033:SF105', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 244669),
(350851, 'PTHR33033:SF104', NULL, NULL, NULL, NULL, 'OS11G0510501 PROTEIN', 244669),
(350852, 'PTHR33033:SF103', NULL, NULL, NULL, NULL, '', 244669),
(350853, 'PTHR33033:SF102', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE-LIKE PROTEIN', 244669),
(350854, 'PTHR33033:SF109', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 244669),
(350855, 'PTHR33033:SF108', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 244669),
(350856, 'PTHR33033:SF107', NULL, NULL, NULL, NULL, 'ACID BINDING PROTEIN, PUTATIVE-RELATED', 244669),
(350857, 'PTHR33033:SF106', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDYL TRANSFERASE, RIBONUCLEASE H-LIKE SUPERFAMILY PROTEIN', 244669),
(350858, 'PTHR33033:SF98', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 244669),
(350859, 'PTHR33033:SF99', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 244669),
(350860, 'PTHR33033:SF96', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 244669),
(350861, 'PTHR33033:SF97', NULL, NULL, NULL, NULL, 'OS02G0587700 PROTEIN', 244669),
(350862, 'PTHR33033', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDYL TRANSFERASE, RIBONUCLEASE H-LIKE SUPERFAMILY PROTEIN-RELATED', 244669),
(350863, 'PTHR33033:SF94', NULL, NULL, NULL, NULL, '', 244669),
(350864, 'PTHR33033:SF95', NULL, NULL, NULL, NULL, 'OS02G0175302 PROTEIN', 244669),
(350865, 'PTHR33033:SF92', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 244669),
(350866, 'PTHR33033:SF93', NULL, NULL, NULL, NULL, '14.7 KDA RIBONUCLEASE H-LIKE PROTEIN', 244669),
(350867, 'PTHR33033:SF90', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 244669),
(350868, 'PTHR33033:SF91', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 244669),
(350869, 'PTHR12670:SF20', NULL, NULL, NULL, NULL, 'NEUTRAL CERAMIDASE', 244670),
(350870, 'PTHR12670:SF13', NULL, NULL, NULL, NULL, 'NEUTRAL CERAMIDASE', 244670),
(350871, 'PTHR12670:SF1', NULL, NULL, NULL, NULL, 'NEUTRAL CERAMIDASE', 244670),
(350872, 'PTHR12670:SF15', NULL, NULL, NULL, NULL, 'NEUTRAL CERAMIDASE', 244670),
(350873, 'PTHR12670:SF17', NULL, NULL, NULL, NULL, 'NEUTRAL CERAMIDASE 2', 244670),
(350874, 'PTHR12670', NULL, NULL, NULL, NULL, 'CERAMIDASE', 244670),
(350875, 'PTHR12670:SF19', NULL, NULL, NULL, NULL, 'NEUTRAL CERAMIDASE', 244670),
(350876, 'PTHR43437:SF9', NULL, NULL, NULL, NULL, 'MAOC-LIKE DOMAIN-CONTAINING PROTEIN', 244671),
(350877, 'PTHR43437', NULL, NULL, NULL, NULL, 'HYDROXYACYL-THIOESTER DEHYDRATASE TYPE 2, MITOCHONDRIAL-RELATED', 244671),
(350878, 'PTHR43437:SF3', NULL, NULL, NULL, NULL, 'HYDROXYACYL-THIOESTER DEHYDRATASE TYPE 2, MITOCHONDRIAL', 244671),
(350879, 'PTHR38498:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 191B-RELATED', 244672),
(350880, 'PTHR38498', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 191B-RELATED', 244672),
(350881, 'PTHR45623:SF51', NULL, NULL, NULL, NULL, 'DNA HELICASE CHROMATIN REGULATOR PHD FAMILY-RELATED', 244673),
(350882, 'PTHR45623:SF50', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 244673),
(350883, 'PTHR45623:SF53', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 244673),
(350884, 'PTHR45623:SF52', NULL, NULL, NULL, NULL, 'CHROMODOMAIN HELICASE HRP1', 244673),
(350885, 'PTHR45623:SF11', NULL, NULL, NULL, NULL, 'KISMET, ISOFORM C', 244673),
(350886, 'PTHR45623:SF33', NULL, NULL, NULL, NULL, 'OS01G0881000 PROTEIN', 244673),
(350887, 'PTHR45623:SF32', NULL, NULL, NULL, NULL, 'SANT/MYB DOMAIN, HOMEODOMAIN-LIKE PROTEIN-RELATED', 244673),
(350888, 'PTHR45623:SF13', NULL, NULL, NULL, NULL, 'HELICASE PROTEIN MOM1-LIKE ISOFORM X1', 244673),
(350889, 'PTHR45623:SF34', NULL, NULL, NULL, NULL, 'CHD3-TYPE CHROMATIN-REMODELING FACTOR PICKLE', 244673);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(350890, 'PTHR45623:SF36', NULL, NULL, NULL, NULL, 'CHROMO DOMAIN-CONTAINING PROTEIN', 244673),
(350891, 'PTHR45623:SF14', NULL, NULL, NULL, NULL, 'CHROMODOMAIN-HELICASE-DNA-BINDING PROTEIN 1', 244673),
(350892, 'PTHR45623:SF39', NULL, NULL, NULL, NULL, 'HOMEODOMAIN', 244673),
(350893, 'PTHR45623:SF17', NULL, NULL, NULL, NULL, 'CHROMODOMAIN-HELICASE-DNA-BINDING PROTEIN 3-RELATED', 244673),
(350894, 'PTHR45623:SF19', NULL, NULL, NULL, NULL, 'CHROMODOMAIN-HELICASE-DNA-BINDING PROTEIN 2', 244673),
(350895, 'PTHR45623', NULL, NULL, NULL, NULL, 'CHROMODOMAIN-HELICASE-DNA-BINDING PROTEIN 3-RELATED-RELATED', 244673),
(350896, 'PTHR45623:SF3', NULL, NULL, NULL, NULL, 'CHROMODOMAIN-HELICASE-DNA-BINDING PROTEIN 8', 244673),
(350897, 'PTHR45623:SF9', NULL, NULL, NULL, NULL, 'CHROMODOMAIN-HELICASE-DNA-BINDING PROTEIN 3', 244673),
(350898, 'PTHR45623:SF20', NULL, NULL, NULL, NULL, 'CHROMODOMAIN-HELICASE-DNA-BINDING PROTEIN 7', 244673),
(350899, 'PTHR45623:SF41', NULL, NULL, NULL, NULL, 'HELICASE C-TERMINAL DOMAIN-CONTAINING PROTEIN', 244673),
(350900, 'PTHR45623:SF44', NULL, NULL, NULL, NULL, 'HELICASE', 244673),
(350901, 'PTHR45623:SF7', NULL, NULL, NULL, NULL, 'CHROMODOMAIN-HELICASE-DNA-BINDING PROTEIN 1', 244673),
(350902, 'PTHR45623:SF22', NULL, NULL, NULL, NULL, 'CHROMODOMAIN-HELICASE-DNA-BINDING PROTEIN 4', 244673),
(350903, 'PTHR45623:SF8', NULL, NULL, NULL, NULL, 'CHROMODOMAIN-HELICASE-DNA-BINDING PROTEIN 6', 244673),
(350904, 'PTHR45623:SF43', NULL, NULL, NULL, NULL, 'OS02G0817000 PROTEIN', 244673),
(350905, 'PTHR45623:SF21', NULL, NULL, NULL, NULL, 'HELICASE CHR10-RELATED', 244673),
(350906, 'PTHR45623:SF5', NULL, NULL, NULL, NULL, 'CHD GENE FAMILY PROTEIN CONTAINING CHROMODOMAIN, HELICASE DOMAIN, AND DNA-BINDING DOMAIN', 244673),
(350907, 'PTHR45623:SF46', NULL, NULL, NULL, NULL, 'SNF2-RELATED DOMAIN, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 244673),
(350908, 'PTHR45623:SF45', NULL, NULL, NULL, NULL, 'BNAA03G51810D PROTEIN', 244673),
(350909, 'PTHR45623:SF6', NULL, NULL, NULL, NULL, 'CHROMODOMAIN-HELICASE-DNA-BINDING PROTEIN 5', 244673),
(350910, 'PTHR45623:SF48', NULL, NULL, NULL, NULL, '', 244673),
(350911, 'PTHR45623:SF47', NULL, NULL, NULL, NULL, 'MYB-LIKE DOMAIN-CONTAINING PROTEIN', 244673),
(350912, 'PTHR45623:SF28', NULL, NULL, NULL, NULL, 'PROTEIN CHROMATIN REMODELING 4', 244673),
(350913, 'PTHR45623:SF49', NULL, NULL, NULL, NULL, 'ISW-1', 244673),
(350914, 'PTHR45623:SF29', NULL, NULL, NULL, NULL, 'MYB-LIKE DOMAIN-CONTAINING PROTEIN', 244673),
(350915, 'PTHR13090:SF1', NULL, NULL, NULL, NULL, 'ARGININE-HYDROXYLASE NDUFAF5, MITOCHONDRIAL', 244674),
(350916, 'PTHR13090', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244674),
(350917, 'PTHR35178:SF1', NULL, NULL, NULL, NULL, 'FOLATE RECEPTOR HOMOLOG', 244675),
(350918, 'PTHR35178', NULL, NULL, NULL, NULL, 'FOLATE RECEPTOR HOMOLOG-RELATED', 244675),
(350919, 'PTHR35178:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG01935', 244675),
(350920, 'PTHR35867', NULL, NULL, NULL, NULL, 'PROTEIN RSEC', 244676),
(350921, 'PTHR35867:SF1', NULL, NULL, NULL, NULL, 'PROTEIN RSEC', 244676),
(350922, 'PTHR43116', NULL, NULL, NULL, NULL, 'PEPTIDE CHAIN RELEASE FACTOR 2', 244677),
(350923, 'PTHR43116:SF3', NULL, NULL, NULL, NULL, 'RF_PROK_I DOMAIN-CONTAINING PROTEIN', 244677),
(350924, 'PTHR43116:SF4', NULL, NULL, NULL, NULL, 'PEPTIDE CHAIN RELEASE FACTOR PRFB3, CHLOROPLASTIC', 244677),
(350925, 'PTHR42847:SF4', NULL, NULL, NULL, NULL, 'ALKANESULFONATE MONOOXYGENASE-RELATED', 244678),
(350926, 'PTHR42847', NULL, NULL, NULL, NULL, 'ALKANESULFONATE MONOOXYGENASE', 244678),
(350927, 'PTHR42847:SF9', NULL, NULL, NULL, NULL, 'BLL6451 PROTEIN', 244678),
(350928, 'PTHR42847:SF8', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', 244678),
(350929, 'PTHR16208:SF4', NULL, NULL, NULL, NULL, 'SYNTABULIN', 244679),
(350930, 'PTHR16208:SF1', NULL, NULL, NULL, NULL, 'SYNTAPHILIN', 244679),
(350931, 'PTHR16208', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN/SYNTAPHILIN', 244679),
(350932, 'PTHR38438', NULL, NULL, NULL, NULL, 'RIBOFLAVIN TRANSPORTER RIBU', 244680);
INSERT INTO "PUBLIC"."MODEL" VALUES
(350933, 'PTHR38438:SF1', NULL, NULL, NULL, NULL, 'RIBOFLAVIN TRANSPORTER RIBU', 244680),
(350934, 'PTHR45727:SF6', NULL, NULL, NULL, NULL, 'NPC INTRACELLULAR CHOLESTEROL TRANSPORTER 1 HOMOLOG 1B', 244681),
(350935, 'PTHR45727', NULL, NULL, NULL, NULL, 'NPC INTRACELLULAR CHOLESTEROL TRANSPORTER 1', 244681),
(350936, 'PTHR45727:SF1', NULL, NULL, NULL, NULL, 'NPC INTRACELLULAR CHOLESTEROL TRANSPORTER 1 HOMOLOG 1', 244681),
(350937, 'PTHR45727:SF3', NULL, NULL, NULL, NULL, 'NPC1-LIKE INTRACELLULAR CHOLESTEROL TRANSPORTER 1', 244681),
(350938, 'PTHR45727:SF2', NULL, NULL, NULL, NULL, 'NPC INTRACELLULAR CHOLESTEROL TRANSPORTER 1', 244681),
(350939, 'PTHR45727:SF10', NULL, NULL, NULL, NULL, 'NPC1 PROTEIN', 244681),
(350940, 'PTHR45727:SF9', NULL, NULL, NULL, NULL, 'SSD DOMAIN-CONTAINING PROTEIN', 244681),
(350941, 'PTHR45727:SF8', NULL, NULL, NULL, NULL, 'PATCHED FAMILY PROTEIN', 244681),
(350942, 'PTHR16146:SF46', NULL, NULL, NULL, NULL, 'INTELECTIN-1A-RELATED', 244682),
(350943, 'PTHR16146:SF21', NULL, NULL, NULL, NULL, 'INTELECTIN-2', 244682),
(350944, 'PTHR16146:SF42', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244682),
(350945, 'PTHR16146:SF38', NULL, NULL, NULL, NULL, 'INTELECTIN-1', 244682),
(350946, 'PTHR16146:SF47', NULL, NULL, NULL, NULL, 'FIBRINOGEN C-TERMINAL DOMAIN-CONTAINING PROTEIN', 244682),
(350947, 'PTHR16146:SF48', NULL, NULL, NULL, NULL, 'FIBRILLAR COLLAGEN NC1 DOMAIN-CONTAINING PROTEIN', 244682),
(350948, 'PTHR16146', NULL, NULL, NULL, NULL, 'INTELECTIN', 244682),
(350949, 'PTHR35523:SF1', NULL, NULL, NULL, NULL, 'CELL WALL PROTEIN SED1', 244683),
(350950, 'PTHR35523', NULL, NULL, NULL, NULL, 'CELL WALL PROTEIN SED1', 244683),
(350951, 'PTHR31093:SF7', NULL, NULL, NULL, NULL, '', 244684),
(350952, 'PTHR31093', NULL, NULL, NULL, NULL, 'CELL SURFACE GLYCOPROTEIN GP138-RELATED-RELATED', 244684),
(350953, 'PTHR31093:SF2', NULL, NULL, NULL, NULL, 'IPT/TIG DOMAIN-CONTAINING PROTEIN', 244684),
(350954, 'PTHR31093:SF5', NULL, NULL, NULL, NULL, '', 244684),
(350955, 'PTHR31093:SF6', NULL, NULL, NULL, NULL, '', 244684),
(350956, 'PTHR31093:SF4', NULL, NULL, NULL, NULL, 'CELL SURFACE GLYCOPROTEIN GP138-RELATED', 244684),
(350957, 'PTHR40039:SF1', NULL, NULL, NULL, NULL, 'PROTEIN DLTD', 244685),
(350958, 'PTHR40039', NULL, NULL, NULL, NULL, 'PROTEIN DLTD', 244685),
(350959, 'PTHR28249:SF1', NULL, NULL, NULL, NULL, 'SPORULATION-SPECIFIC PROTEIN SPO7', 244686),
(350960, 'PTHR28249', NULL, NULL, NULL, NULL, 'SPORULATION-SPECIFIC PROTEIN SPO7', 244686),
(350961, 'PTHR33730:SF32', NULL, NULL, NULL, NULL, '', 244687),
(350962, 'PTHR33730:SF31', NULL, NULL, NULL, NULL, '', 244687),
(350963, 'PTHR33730:SF30', NULL, NULL, NULL, NULL, 'BNAC02G23270D PROTEIN', 244687),
(350964, 'PTHR33730:SF19', NULL, NULL, NULL, NULL, '', 244687),
(350965, 'PTHR33730:SF29', NULL, NULL, NULL, NULL, '', 244687),
(350966, 'PTHR33730:SF28', NULL, NULL, NULL, NULL, '', 244687),
(350967, 'PTHR33730:SF16', NULL, NULL, NULL, NULL, 'OS01G0174100 PROTEIN', 244687),
(350968, 'PTHR33730:SF27', NULL, NULL, NULL, NULL, 'OS05G0542732 PROTEIN', 244687),
(350969, 'PTHR33730:SF15', NULL, NULL, NULL, NULL, '', 244687),
(350970, 'PTHR33730:SF25', NULL, NULL, NULL, NULL, 'PLANT/F18B13-26 PROTEIN', 244687),
(350971, 'PTHR33730:SF13', NULL, NULL, NULL, NULL, 'PLANT/PROTEIN', 244687),
(350972, 'PTHR33730:SF24', NULL, NULL, NULL, NULL, 'BNAA09G56820D PROTEIN', 244687),
(350973, 'PTHR33730:SF12', NULL, NULL, NULL, NULL, 'OS01G0704901 PROTEIN', 244687),
(350974, 'PTHR33730:SF23', NULL, NULL, NULL, NULL, '', 244687),
(350975, 'PTHR33730:SF1', NULL, NULL, NULL, NULL, '', 244687),
(350976, 'PTHR33730', NULL, NULL, NULL, NULL, 'OS05G0542732 PROTEIN-RELATED', 244687),
(350977, 'PTHR33730:SF4', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244687),
(350978, 'PTHR28645:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 119', 244688),
(350979, 'PTHR28645', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 119', 244688),
(350980, 'PTHR32274:SF1', NULL, NULL, NULL, NULL, 'NEDD4-BINDING PROTEIN 3', 244689),
(350981, 'PTHR32274', NULL, NULL, NULL, NULL, 'NEDD4-BINDING PROTEIN 3', 244689);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(350982, 'PTHR11001:SF2', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL FISSION PROCESS PROTEIN 1', 244690),
(350983, 'PTHR11001', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL FISSION PROCESS PROTEIN 1', 244690),
(350984, 'PTHR34599:SF1', NULL, NULL, NULL, NULL, 'TRAF-TYPE DOMAIN-CONTAINING PROTEIN', 244691),
(350985, 'PTHR34599', NULL, NULL, NULL, NULL, 'PEROXIDASE-RELATED', 244691),
(350986, 'PTHR14958:SF30', NULL, NULL, NULL, NULL, 'DUSP DOMAIN-CONTAINING PROTEIN', 244692),
(350987, 'PTHR14958', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL TETRAMERISATION DOMAIN CONTAINING PROTEIN', 244692),
(350988, 'PTHR14958:SF29', NULL, NULL, NULL, NULL, 'INSOMNIAC, ISOFORM B', 244692),
(350989, 'PTHR14958:SF24', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN KCTD17', 244692),
(350990, 'PTHR14958:SF22', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN KCTD2', 244692),
(350991, 'PTHR14958:SF12', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN KCTD5', 244692),
(350992, 'PTHR14958:SF31', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN-RELATED', 244692),
(350993, 'PTHR30319', NULL, NULL, NULL, NULL, 'PHENYLACETIC ACID REGULATOR-RELATED TRANSCRIPTIONAL REPRESSOR', 244693),
(350994, 'PTHR30319:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR PAAX', 244693),
(350995, 'PTHR30336', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN, PROBABLE PERMEASE', 244694),
(350996, 'PTHR30336:SF0', NULL, NULL, NULL, NULL, 'PROTEIN SANA', 244694),
(350997, 'PTHR30336:SF19', NULL, NULL, NULL, NULL, 'SECRETED PROTEIN-RELATED', 244694),
(350998, 'PTHR30336:SF4', NULL, NULL, NULL, NULL, 'DUF218 DOMAIN-CONTAINING PROTEIN', 244694),
(350999, 'PTHR30336:SF18', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 244694),
(351000, 'PTHR30336:SF6', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN-RELATED', 244694),
(351001, 'PTHR37876:SF1', NULL, NULL, NULL, NULL, 'PROTEIN GAR2-LIKE', 244695),
(351002, 'PTHR37876', NULL, NULL, NULL, NULL, 'PROTEIN GAR2-LIKE', 244695),
(351003, 'PTHR14017:SF9', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE 6A', 244696),
(351004, 'PTHR14017:SF26', NULL, NULL, NULL, NULL, 'LYSINE (K)-SPECIFIC DEMETHYLASE 6B, A', 244696),
(351005, 'PTHR14017', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE', 244696),
(351006, 'PTHR14017:SF5', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE 6B', 244696),
(351007, 'PTHR14017:SF25', NULL, NULL, NULL, NULL, 'HISTONE DEMETHYLASE UTY', 244696),
(351008, 'PTHR14017:SF14', NULL, NULL, NULL, NULL, 'JMJC DOMAIN-CONTAINING PROTEIN', 244696),
(351009, 'PTHR14017:SF1', NULL, NULL, NULL, NULL, 'LD02225P', 244696),
(351010, 'PTHR35455:SF1', NULL, NULL, NULL, NULL, 'AGAP005842-PA', 244697),
(351011, 'PTHR35455', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', 244697),
(351012, 'PTHR28660', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 73', 244698),
(351013, 'PTHR28660:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 73', 244698),
(351014, 'PTHR38699:SF1', NULL, NULL, NULL, NULL, 'MITOPHAGY RECEPTOR ATG43', 244699),
(351015, 'PTHR38699', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 244699),
(351016, 'PTHR31115', NULL, NULL, NULL, NULL, 'OS05G0107300 PROTEIN', 244700),
(351017, 'PTHR31115:SF8', NULL, NULL, NULL, NULL, '', 244700),
(351018, 'PTHR31115:SF14', NULL, NULL, NULL, NULL, 'BNACNNG47970D PROTEIN', 244700),
(351019, 'PTHR31115:SF5', NULL, NULL, NULL, NULL, 'OS01G0967100 PROTEIN', 244700),
(351020, 'PTHR31115:SF4', NULL, NULL, NULL, NULL, 'SPECTRIN BETA CHAIN, BRAIN', 244700),
(351021, 'PTHR31115:SF13', NULL, NULL, NULL, NULL, 'OS05G0350700 PROTEIN', 244700),
(351022, 'PTHR31115:SF7', NULL, NULL, NULL, NULL, 'PLANT/F27B13-30 PROTEIN', 244700),
(351023, 'PTHR31115:SF12', NULL, NULL, NULL, NULL, '', 244700),
(351024, 'PTHR31115:SF11', NULL, NULL, NULL, NULL, 'BNAA03G49750D PROTEIN', 244700),
(351025, 'PTHR31115:SF6', NULL, NULL, NULL, NULL, 'BNAA01G07190D PROTEIN', 244700),
(351026, 'PTHR31115:SF3', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244700),
(351027, 'PTHR31115:SF2', NULL, NULL, NULL, NULL, 'OS05G0107300 PROTEIN', 244700);
INSERT INTO "PUBLIC"."MODEL" VALUES
(351028, 'PTHR33667', NULL, NULL, NULL, NULL, 'SI:DKEY-57N24.6', 244701),
(351029, 'PTHR33667:SF7', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1810020O05 GENE', 244701),
(351030, 'PTHR21208', NULL, NULL, NULL, NULL, 'ADP-DEPENDENT GLUCOKINASE', 244702),
(351031, 'PTHR21208:SF1', NULL, NULL, NULL, NULL, 'ADP-DEPENDENT GLUCOKINASE 2', 244702),
(351032, 'PTHR21208:SF0', NULL, NULL, NULL, NULL, 'ADP-DEPENDENT GLUCOKINASE', 244702),
(351033, 'PTHR30287:SF1', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', 244703),
(351034, 'PTHR30287:SF2', NULL, NULL, NULL, NULL, 'BLL1001 PROTEIN', 244703),
(351035, 'PTHR30287', NULL, NULL, NULL, NULL, 'MEMBRANE COMPONENT OF PREDICTED ABC SUPERFAMILY METABOLITE UPTAKE TRANSPORTER', 244703),
(351036, 'PTHR21257:SF36', NULL, NULL, NULL, NULL, 'DUF1295 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_8G05810)', 244704),
(351037, 'PTHR21257:SF38', NULL, NULL, NULL, NULL, '7-DEHYDROCHOLESTEROL REDUCTASE', 244704),
(351038, 'PTHR21257:SF37', NULL, NULL, NULL, NULL, 'DELTA(14)-STEROL REDUCTASE', 244704),
(351039, 'PTHR21257:SF48', NULL, NULL, NULL, NULL, 'STEROL REDUCTASE (EUROFUNG)', 244704),
(351040, 'PTHR21257:SF54', NULL, NULL, NULL, NULL, 'DELTA(14)-STEROL REDUCTASE TM7SF2', 244704),
(351041, 'PTHR21257:SF31', NULL, NULL, NULL, NULL, 'DELTA(24(24(1)))-STEROL REDUCTASE', 244704),
(351042, 'PTHR21257:SF53', NULL, NULL, NULL, NULL, 'STEROL DELTA-7 REDUCTASE DWF5', 244704),
(351043, 'PTHR21257', NULL, NULL, NULL, NULL, 'DELTA(14)-STEROL REDUCTASE', 244704),
(351044, 'PTHR21257:SF52', NULL, NULL, NULL, NULL, 'DELTA(14)-STEROL REDUCTASE LBR', 244704),
(351045, 'PTHR21257:SF51', NULL, NULL, NULL, NULL, 'BNACNNG50210D PROTEIN', 244704),
(351046, 'PTHR15622:SF2', NULL, NULL, NULL, NULL, 'U4/U6 SMALL NUCLEAR RIBONUCLEOPROTEIN PRP4', 244705),
(351047, 'PTHR15622:SF1', NULL, NULL, NULL, NULL, 'WD REPEAT AND SOCS BOX-CONTAINING PROTEIN 2', 244705),
(351048, 'PTHR15622:SF12', NULL, NULL, NULL, NULL, 'WD REPEAT AND SOCS BOX-CONTAINING PROTEIN 1', 244705),
(351049, 'PTHR15622', NULL, NULL, NULL, NULL, 'WD40 REPEAT PROTEIN', 244705),
(351050, 'PTHR22382', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4921504E06 GENE', 244706),
(351051, 'PTHR22382:SF7', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4921504E06 GENE', 244706),
(351052, 'PTHR42872', NULL, NULL, NULL, NULL, 'PROTEIN-GLUTAMATE METHYLESTERASE/PROTEIN-GLUTAMINE GLUTAMINASE', 244707),
(351053, 'PTHR42872:SF3', NULL, NULL, NULL, NULL, 'PROTEIN-GLUTAMATE METHYLESTERASE/PROTEIN-GLUTAMINE GLUTAMINASE', 244707),
(351054, 'PTHR42872:SF6', NULL, NULL, NULL, NULL, 'PROTEIN-GLUTAMATE METHYLESTERASE/PROTEIN-GLUTAMINE GLUTAMINASE', 244707),
(351055, 'PTHR13650', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244708),
(351056, 'PTHR13650:SF1', NULL, NULL, NULL, NULL, '', 244708),
(351057, 'PTHR13650:SF0', NULL, NULL, NULL, NULL, 'SPATACSIN', 244708),
(351058, 'PTHR35072', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 91', 244709),
(351059, 'PTHR35072:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 91', 244709),
(351060, 'PTHR34645', NULL, NULL, NULL, NULL, 'SIMILAR TO HYPOTHETICAL PROTEIN', 244710),
(351061, 'PTHR34645:SF1', NULL, NULL, NULL, NULL, 'SIMILAR TO HYPOTHETICAL PROTEIN', 244710),
(351062, 'PTHR10630:SF3', NULL, NULL, NULL, NULL, 'MONOCYTE DIFFERENTIATION ANTIGEN CD14', 244711),
(351063, 'PTHR10630', NULL, NULL, NULL, NULL, 'MONOCYTE DIFFERENTIATION ANTIGEN CD14', 244711),
(351064, 'PTHR16231:SF11', NULL, NULL, NULL, NULL, 'COMM DOMAIN-CONTAINING PROTEIN 4', 244712),
(351065, 'PTHR16231', NULL, NULL, NULL, NULL, 'COMM DOMAIN-CONTAINING PROTEIN 4-8 FAMILY MEMBER', 244712),
(351066, 'PTHR16231:SF13', NULL, NULL, NULL, NULL, '', 244712),
(351067, 'PTHR16231:SF2', NULL, NULL, NULL, NULL, 'COMM DOMAIN-CONTAINING PROTEIN 7', 244712),
(351068, 'PTHR16231:SF0', NULL, NULL, NULL, NULL, 'COMM DOMAIN-CONTAINING PROTEIN 8', 244712),
(351069, 'PTHR16231:SF4', NULL, NULL, NULL, NULL, 'COMM DOMAIN-CONTAINING PROTEIN 4', 244712),
(351070, 'PTHR16231:SF5', NULL, NULL, NULL, NULL, 'COMM DOMAIN-CONTAINING PROTEIN 6', 244712),
(351071, 'PTHR28621:SF1', NULL, NULL, NULL, NULL, 'SELENOPROTEIN S', 244713);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(351072, 'PTHR28621', NULL, NULL, NULL, NULL, 'SELENOPROTEIN S', 244713),
(351073, 'PTHR34593:SF9', NULL, NULL, NULL, NULL, 'MATING RESPONSE PROTEIN POI2', 244714),
(351074, 'PTHR34593:SF11', NULL, NULL, NULL, NULL, '', 244714),
(351075, 'PTHR34593:SF10', NULL, NULL, NULL, NULL, '', 244714),
(351076, 'PTHR34593', NULL, NULL, NULL, NULL, 'MATING RESPONSE PROTEIN POI2', 244714),
(351077, 'PTHR33563:SF6', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244715),
(351078, 'PTHR33563:SF5', NULL, NULL, NULL, NULL, '', 244715),
(351079, 'PTHR33563:SF7', NULL, NULL, NULL, NULL, '', 244715),
(351080, 'PTHR33563:SF1', NULL, NULL, NULL, NULL, '3-DEHYDROQUINATE SYNTHASE', 244715),
(351081, 'PTHR33563:SF9', NULL, NULL, NULL, NULL, '', 244715),
(351082, 'PTHR33563:SF10', NULL, NULL, NULL, NULL, '', 244715),
(351083, 'PTHR33563', NULL, NULL, NULL, NULL, '', 244715),
(351084, 'PTHR42910:SF1', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 244716),
(351085, 'PTHR42910', NULL, NULL, NULL, NULL, 'TRANSPORTER SCO4007-RELATED', 244716),
(351086, 'PTHR36743:SF1', NULL, NULL, NULL, NULL, 'OS04G0495300 PROTEIN', 244717),
(351087, 'PTHR36743', NULL, NULL, NULL, NULL, 'OS04G0495300 PROTEIN', 244717),
(351088, 'PTHR47191', NULL, NULL, NULL, NULL, 'OS05G0170800 PROTEIN', 244718),
(351089, 'PTHR47191:SF2', NULL, NULL, NULL, NULL, 'OS05G0170800 PROTEIN', 244718),
(351090, 'PTHR10840:SF3', NULL, NULL, NULL, NULL, 'BNAA07G07610D PROTEIN', 244719),
(351091, 'PTHR10840:SF2', NULL, NULL, NULL, NULL, 'PROGRAMMED CELL DEATH 5', 244719),
(351092, 'PTHR10840:SF1', NULL, NULL, NULL, NULL, 'PROGRAMMED CELL DEATH PROTEIN 5', 244719),
(351093, 'PTHR10840:SF0', NULL, NULL, NULL, NULL, 'PROGRAMMED CELL DEATH PROTEIN 5', 244719),
(351094, 'PTHR10840', NULL, NULL, NULL, NULL, 'PROGRAMMED CELL DEATH PROTEIN 5', 244719),
(351095, 'PTHR42683:SF45', NULL, NULL, NULL, NULL, 'CINNAMYL ALCOHOL DEHYDROGENASE-LIKE PROTEIN', 244720),
(351096, 'PTHR42683:SF66', NULL, NULL, NULL, NULL, 'CINNAMYL ALCOHOL DEHYDROGENASE 6-RELATED', 244720),
(351097, 'PTHR42683:SF44', NULL, NULL, NULL, NULL, 'CINNAMYL ALCOHOL DEHYDROGENASE 2-RELATED', 244720),
(351098, 'PTHR42683:SF69', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 244720),
(351099, 'PTHR42683', NULL, NULL, NULL, NULL, 'ALDEHYDE REDUCTASE', 244720),
(351100, 'PTHR42683:SF24', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 244720),
(351101, 'PTHR42683:SF68', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 244720),
(351102, 'PTHR42683:SF49', NULL, NULL, NULL, NULL, 'CINNAMYL ALCOHOL DEHYDROGENASE 8C-RELATED', 244720),
(351103, 'PTHR42683:SF48', NULL, NULL, NULL, NULL, 'CINNAMYL ALCOHOL DEHYDROGENASE 6-RELATED', 244720),
(351104, 'PTHR42683:SF81', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 244720),
(351105, 'PTHR42683:SF83', NULL, NULL, NULL, NULL, '8-HYDROXYGERANIOL DEHYDROGENASE-LIKE', 244720),
(351106, 'PTHR42683:SF82', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G02430)-RELATED', 244720),
(351107, 'PTHR42683:SF60', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 244720),
(351108, 'PTHR42683:SF85', NULL, NULL, NULL, NULL, 'DEATH RESISTOR ADH DOMAIN CONTAINING TARGET, ISOFORM C', 244720),
(351109, 'PTHR42683:SF41', NULL, NULL, NULL, NULL, 'CINNAMYL ALCOHOL DEHYDROGENASE-LIKE PROTEIN', 244720),
(351110, 'PTHR42683:SF40', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 244720),
(351111, 'PTHR42683:SF84', NULL, NULL, NULL, NULL, 'ADH_ZINC_N DOMAIN-CONTAINING PROTEIN', 244720),
(351112, 'PTHR42683:SF65', NULL, NULL, NULL, NULL, 'CINNAMYL ALCOHOL DEHYDROGENASE 8', 244720),
(351113, 'PTHR42683:SF42', NULL, NULL, NULL, NULL, 'CINNAMYL ALCOHOL DEHYDROGENASE 4', 244720),
(351114, 'PTHR42683:SF64', NULL, NULL, NULL, NULL, 'MANNITOL DEHYDROGENASE-RELATED', 244720),
(351115, 'PTHR42683:SF78', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE, PROPANOL-PREFERRING', 244720),
(351116, 'PTHR42683:SF77', NULL, NULL, NULL, NULL, 'CINNAMYL ALCOHOL DEHYDROGENASE 7', 244720),
(351117, 'PTHR42683:SF55', NULL, NULL, NULL, NULL, 'ADH_ZINC_N DOMAIN-CONTAINING PROTEIN', 244720);
INSERT INTO "PUBLIC"."MODEL" VALUES
(351118, 'PTHR42683:SF36', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 244720),
(351119, 'PTHR42683:SF14', NULL, NULL, NULL, NULL, 'NADP-DEPENDENT ALCOHOL DEHYDROGENASE C', 244720),
(351120, 'PTHR42683:SF57', NULL, NULL, NULL, NULL, 'CINNAMYL ALCOHOL DEHYDROGENASE 7', 244720),
(351121, 'PTHR42683:SF38', NULL, NULL, NULL, NULL, 'ALDEHYDE REDUCTASE AHR', 244720),
(351122, 'PTHR42683:SF37', NULL, NULL, NULL, NULL, 'CINNAMYL ALCOHOL DEHYDROGENASE 6-RELATED', 244720),
(351123, 'PTHR42683:SF15', NULL, NULL, NULL, NULL, 'CINNAMYL ALCOHOL DEHYDROGENASE 8D-RELATED', 244720),
(351124, 'PTHR42683:SF18', NULL, NULL, NULL, NULL, 'NADP-DEPENDENT ALCOHOL DEHYDROGENASE (AFU_ORTHOLOGUE AFUA_6G00510)', 244720),
(351125, 'PTHR42683:SF39', NULL, NULL, NULL, NULL, 'NADP-DEPENDENT ALCOHOL DEHYDROGENASE 6-RELATED', 244720),
(351126, 'PTHR42683:SF17', NULL, NULL, NULL, NULL, 'CINNAMYL ALCOHOL DEHYDROGENASE 1-RELATED', 244720),
(351127, 'PTHR42683:SF1', NULL, NULL, NULL, NULL, 'CINNAMYL ALCOHOL DEHYDROGENASE 5', 244720),
(351128, 'PTHR42683:SF50', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE ADHA-RELATED', 244720),
(351129, 'PTHR42683:SF3', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G01980)-RELATED', 244720),
(351130, 'PTHR42683:SF71', NULL, NULL, NULL, NULL, 'MANNITOL DEHYDROGENASE-RELATED', 244720),
(351131, 'PTHR42683:SF74', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 244720),
(351132, 'PTHR42683:SF51', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 244720),
(351133, 'PTHR42683:SF76', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 244720),
(351134, 'PTHR42683:SF53', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 244720),
(351135, 'PTHR38344', NULL, NULL, NULL, NULL, 'UPF0753 PROTEIN AQ_863', 244721),
(351136, 'PTHR38344:SF1', NULL, NULL, NULL, NULL, 'UPF0753 PROTEIN YBCC', 244721),
(351137, 'PTHR30069:SF50', NULL, NULL, NULL, NULL, 'TONB-DEPENDENT RECEPTOR HI_1217-RELATED', 244722),
(351138, 'PTHR30069:SF51', NULL, NULL, NULL, NULL, 'FERRIENTEROBACTIN RECEPTOR', 244722),
(351139, 'PTHR30069:SF40', NULL, NULL, NULL, NULL, 'TONB-DEPENDENT RECEPTOR NMB0964-RELATED', 244722),
(351140, 'PTHR30069:SF41', NULL, NULL, NULL, NULL, 'HEME/HEMOPEXIN UTILIZATION PROTEIN C', 244722),
(351141, 'PTHR30069:SF52', NULL, NULL, NULL, NULL, 'TONB_DEP_REC DOMAIN-CONTAINING PROTEIN', 244722),
(351142, 'PTHR30069:SF42', NULL, NULL, NULL, NULL, 'FERRIC AEROBACTIN RECEPTOR', 244722),
(351143, 'PTHR30069:SF53', NULL, NULL, NULL, NULL, 'VITAMIN B12 TRANSPORTER BTUB', 244722),
(351144, 'PTHR30069:SF54', NULL, NULL, NULL, NULL, 'TRANSFERRIN-BINDING PROTEIN A', 244722),
(351145, 'PTHR30069:SF55', NULL, NULL, NULL, NULL, 'TONB DEPENDENT RECEPTOR', 244722),
(351146, 'PTHR30069:SF56', NULL, NULL, NULL, NULL, 'TONB-DEPENDENT HEME RECEPTOR A', 244722),
(351147, 'PTHR30069:SF46', NULL, NULL, NULL, NULL, 'COLICIN I RECEPTOR', 244722),
(351148, 'PTHR30069:SF36', NULL, NULL, NULL, NULL, 'BLL6948 PROTEIN', 244722),
(351149, 'PTHR30069:SF37', NULL, NULL, NULL, NULL, 'VIBRIOBACTIN RECEPTOR', 244722),
(351150, 'PTHR30069:SF49', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN C', 244722),
(351151, 'PTHR30069:SF27', NULL, NULL, NULL, NULL, 'BLL4766 PROTEIN', 244722),
(351152, 'PTHR30069:SF39', NULL, NULL, NULL, NULL, 'BLL6183 PROTEIN', 244722),
(351153, 'PTHR30069:SF28', NULL, NULL, NULL, NULL, 'TONB-DEPENDENT RECEPTOR YNCD-RELATED', 244722),
(351154, 'PTHR30069:SF29', NULL, NULL, NULL, NULL, 'HEMOGLOBIN AND HEMOGLOBIN-HAPTOGLOBIN-BINDING PROTEIN 1-RELATED', 244722),
(351155, 'PTHR30069:SF8', NULL, NULL, NULL, NULL, 'TONB-DEPENDENT SIDEROPHORE RECEPTOR PROTEIN', 244722),
(351156, 'PTHR30069', NULL, NULL, NULL, NULL, 'TONB-DEPENDENT OUTER MEMBRANE RECEPTOR', 244722),
(351157, 'PTHR31899:SF10', NULL, NULL, NULL, NULL, 'BETA-CAROTENE HYDROXYLASE 2, CHLOROPLASTIC', 244723),
(351158, 'PTHR31899:SF13', NULL, NULL, NULL, NULL, 'FATTY ACID HYDROXYLASE DOMAIN-CONTAINING PROTEIN', 244723),
(351159, 'PTHR31899', NULL, NULL, NULL, NULL, 'BETA-CAROTENE 3-HYDROXYLASE 1, CHLOROPLASTIC', 244723);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(351160, 'PTHR31899:SF17', NULL, NULL, NULL, NULL, 'BETA-CAROTENE HYDROXYLASE', 244723),
(351161, 'PTHR31899:SF16', NULL, NULL, NULL, NULL, 'BETA-CAROTENE 3-HYDROXYLASE 2, CHLOROPLASTIC', 244723),
(351162, 'PTHR31899:SF9', NULL, NULL, NULL, NULL, 'BETA-CAROTENE 3-HYDROXYLASE 1, CHLOROPLASTIC', 244723),
(351163, 'PTHR31899:SF18', NULL, NULL, NULL, NULL, 'ALDEHYDE OXYGENASE (DEFORMYLATING)', 244723),
(351164, 'PTHR38406:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR OPI1', 244724),
(351165, 'PTHR38406', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR OPI1', 244724),
(351166, 'PTHR43475:SF4', NULL, NULL, NULL, NULL, 'METHYLTHIORIBOSE-1-PHOSPHATE ISOMERASE', 244725),
(351167, 'PTHR43475:SF1', NULL, NULL, NULL, NULL, 'METHYLTHIORIBOSE-1-PHOSPHATE ISOMERASE', 244725),
(351168, 'PTHR43475:SF2', NULL, NULL, NULL, NULL, 'RIBOSE 1,5-BISPHOSPHATE ISOMERASE', 244725),
(351169, 'PTHR43475:SF3', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR EIF-2B SUBUNIT FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_2G14290)', 244725),
(351170, 'PTHR43475', NULL, NULL, NULL, NULL, 'METHYLTHIORIBOSE-1-PHOSPHATE ISOMERASE', 244725),
(351171, 'PTHR48153', NULL, NULL, NULL, NULL, 'UFM1-SPECIFIC PROTEASE 2', 244726),
(351172, 'PTHR48153:SF3', NULL, NULL, NULL, NULL, 'INACTIVE UFM1-SPECIFIC PROTEASE 1', 244726),
(351173, 'PTHR48153:SF2', NULL, NULL, NULL, NULL, 'UFM1-SPECIFIC PROTEASE 2', 244726),
(351174, 'PTHR48153:SF4', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE MUG105', 244726),
(351175, 'PTHR37611:SF3', NULL, NULL, NULL, NULL, 'VIRUS-SPECIFIC-SIGNALING-PATHWAY REGULATED PROTEIN', 244727),
(351176, 'PTHR37611:SF2', NULL, NULL, NULL, NULL, 'OS06G0538400 PROTEIN', 244727),
(351177, 'PTHR37611:SF1', NULL, NULL, NULL, NULL, '', 244727),
(351178, 'PTHR37611', NULL, NULL, NULL, NULL, 'VIRUS-SPECIFIC-SIGNALING-PATHWAY REGULATED PROTEIN-RELATED', 244727),
(351179, 'PTHR47523:SF1', NULL, NULL, NULL, NULL, 'F21O3.11 PROTEIN', 244728),
(351180, 'PTHR47523', NULL, NULL, NULL, NULL, 'F21O3.11 PROTEIN', 244728),
(351181, 'PTHR34260:SF1', NULL, NULL, NULL, NULL, 'UBIQUINOL-CYTOCHROME-C REDUCTASE COMPLEX ASSEMBLY FACTOR 2', 244729),
(351182, 'PTHR34260', NULL, NULL, NULL, NULL, 'UBIQUINOL-CYTOCHROME-C REDUCTASE COMPLEX ASSEMBLY FACTOR 2', 244729),
(351183, 'PTHR30036', NULL, NULL, NULL, NULL, 'D-XYLOSE-BINDING PERIPLASMIC PROTEIN', 244730),
(351184, 'PTHR30036:SF7', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERIPLASMIC-BINDING PROTEIN YPHF', 244730),
(351185, 'PTHR30036:SF6', NULL, NULL, NULL, NULL, 'L-ARABINOSE-BINDING PERIPLASMIC PROTEIN', 244730),
(351186, 'PTHR30036:SF1', NULL, NULL, NULL, NULL, 'D-XYLOSE-BINDING PERIPLASMIC PROTEIN', 244730),
(351187, 'PTHR30036:SF2', NULL, NULL, NULL, NULL, 'D-GALACTOSE-BINDING PERIPLASMIC PROTEIN', 244730),
(351188, 'PTHR39430', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED PROTEASE-RELATED', 244731),
(351189, 'PTHR39430:SF1', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED PROTEASE-RELATED', 244731),
(351190, 'PTHR46890:SF21', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 244732),
(351191, 'PTHR46890:SF43', NULL, NULL, NULL, NULL, 'NON-LTR RETROELEMENT REVERSE TRANSCRIPTASE', 244732),
(351192, 'PTHR46890:SF42', NULL, NULL, NULL, NULL, '', 244732),
(351193, 'PTHR46890:SF20', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 244732),
(351194, 'PTHR46890:SF23', NULL, NULL, NULL, NULL, 'RNA-DIRECTED DNA POLYMERASE, EUKARYOTA, REVERSE TRANSCRIPTASE ZINC-BINDING DOMAIN PROTEIN-RELATED', 244732),
(351195, 'PTHR46890:SF22', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN-RELATED', 244732),
(351196, 'PTHR46890:SF41', NULL, NULL, NULL, NULL, 'BNAC01G31370D PROTEIN', 244732),
(351197, 'PTHR46890:SF40', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 244732),
(351198, 'PTHR46890:SF29', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 244732),
(351199, 'PTHR46890:SF28', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 244732);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(351200, 'PTHR46890:SF25', NULL, NULL, NULL, NULL, 'NON-LTR RETROLELEMENT REVERSE TRANSCRIPTASE-LIKE PROTEIN', 244732),
(351201, 'PTHR46890:SF24', NULL, NULL, NULL, NULL, 'RNA BINDING / RNA-DIRECTED DNA POLYMERASE', 244732),
(351202, 'PTHR46890:SF27', NULL, NULL, NULL, NULL, 'OS03G0643433 PROTEIN', 244732),
(351203, 'PTHR46890', NULL, NULL, NULL, NULL, 'NON-LTR RETROLELEMENT REVERSE TRANSCRIPTASE-LIKE PROTEIN-RELATED', 244732),
(351204, 'PTHR46890:SF26', NULL, NULL, NULL, NULL, 'NON-LTR RETROELEMENT REVERSE TRANSCRIPTASE', 244732),
(351205, 'PTHR46890:SF1', NULL, NULL, NULL, NULL, 'FGR14P', 244732),
(351206, 'PTHR46890:SF32', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 244732),
(351207, 'PTHR46890:SF31', NULL, NULL, NULL, NULL, '', 244732),
(351208, 'PTHR46890:SF34', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 244732),
(351209, 'PTHR46890:SF33', NULL, NULL, NULL, NULL, '', 244732),
(351210, 'PTHR46890:SF30', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 244732),
(351211, 'PTHR46890:SF18', NULL, NULL, NULL, NULL, 'ENDONUCLEASE/EXONUCLEASE/PHOSPHATASE FAMILY PROTEIN', 244732),
(351212, 'PTHR46890:SF39', NULL, NULL, NULL, NULL, 'NON-LTR RETROELEMENT REVERSE TRANSCRIPTASE', 244732),
(351213, 'PTHR46890:SF19', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE-LIKE PROTEIN', 244732),
(351214, 'PTHR46890:SF36', NULL, NULL, NULL, NULL, 'OS06G0484800 PROTEIN', 244732),
(351215, 'PTHR46890:SF35', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 244732),
(351216, 'PTHR46890:SF38', NULL, NULL, NULL, NULL, '', 244732),
(351217, 'PTHR46890:SF37', NULL, NULL, NULL, NULL, '', 244732),
(351218, 'PTHR28006:SF1', NULL, NULL, NULL, NULL, 'MONOPOLIN COMPLEX SUBUNIT PCS1', 244733),
(351219, 'PTHR28006', NULL, NULL, NULL, NULL, 'MONOPOLIN COMPLEX SUBUNIT CSM1', 244733),
(351220, 'PTHR10865:SF22', NULL, NULL, NULL, NULL, 'MESODERM INDUCTION EARLY RESPONSE PROTEIN 3', 244734),
(351221, 'PTHR10865:SF24', NULL, NULL, NULL, NULL, 'MESODERM INDUCTION EARLY RESPONSE PROTEIN 1', 244734),
(351222, 'PTHR10865', NULL, NULL, NULL, NULL, 'METASTASIS-ASSOCIATED PROTEIN AND MESODERM INDUCTION EARLY RESPONSE PROTEIN', 244734),
(351223, 'PTHR10865:SF29', NULL, NULL, NULL, NULL, 'METASTASIS ASSOCIATED 1-LIKE, ISOFORM D', 244734),
(351224, 'PTHR10865:SF28', NULL, NULL, NULL, NULL, 'ELM2 DOMAIN-CONTAINING PROTEIN', 244734),
(351225, 'PTHR10865:SF27', NULL, NULL, NULL, NULL, 'MESODERM INDUCTION EARLY RESPONSE PROTEIN 2', 244734),
(351226, 'PTHR10865:SF6', NULL, NULL, NULL, NULL, 'METASTASIS-ASSOCIATED PROTEIN MTA3', 244734),
(351227, 'PTHR10865:SF5', NULL, NULL, NULL, NULL, 'METASTASIS-ASSOCIATED PROTEIN MTA1', 244734),
(351228, 'PTHR10865:SF4', NULL, NULL, NULL, NULL, 'METASTASIS-ASSOCIATED PROTEIN MTA2', 244734),
(351229, 'PTHR30508:SF1', NULL, NULL, NULL, NULL, 'UPF0051 PROTEIN ABCI8, CHLOROPLASTIC-RELATED', 244735),
(351230, 'PTHR30508:SF6', NULL, NULL, NULL, NULL, 'UPF0051 PROTEIN MJ0034', 244735),
(351231, 'PTHR30508', NULL, NULL, NULL, NULL, 'FES CLUSTER ASSEMBLY PROTEIN SUF', 244735),
(351232, 'PTHR30508:SF8', NULL, NULL, NULL, NULL, 'NON-INTRINSIC ABC PROTEIN', 244735),
(351233, 'PTHR38850:SF2', NULL, NULL, NULL, NULL, '', 244736),
(351234, 'PTHR38850', NULL, NULL, NULL, NULL, '', 244736),
(351235, 'PTHR11995:SF14', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] IRON-SULFUR PROTEIN 7, MITOCHONDRIAL', 244737),
(351236, 'PTHR11995:SF24', NULL, NULL, NULL, NULL, 'COMPLEX I-20KD', 244737),
(351237, 'PTHR11995:SF30', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] IRON-SULFUR PROTEIN 7 MITOCHONDRIAL', 244737),
(351238, 'PTHR11995', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE', 244737),
(351239, 'PTHR11995:SF33', NULL, NULL, NULL, NULL, 'NADH-QUINONE OXIDOREDUCTASE SUBUNIT B 2', 244737),
(351240, 'PTHR11995:SF22', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] IRON-SULFUR PROTEIN 7, MITOCHONDRIAL', 244737),
(351241, 'PTHR11995:SF32', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] IRON-SULFUR PROTEIN 7, MITOCHONDRIAL', 244737);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(351242, 'PTHR11995:SF31', NULL, NULL, NULL, NULL, 'OXIDORED_Q6 DOMAIN-CONTAINING PROTEIN', 244737),
(351243, 'PTHR34059:SF6', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 244738),
(351244, 'PTHR34059:SF5', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 244738),
(351245, 'PTHR34059:SF2', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 244738),
(351246, 'PTHR34059:SF11', NULL, NULL, NULL, NULL, 'COTTON FIBER PROTEIN', 244738),
(351247, 'PTHR34059:SF12', NULL, NULL, NULL, NULL, 'MICAL C-TERMINAL-LIKE PROTEIN', 244738),
(351248, 'PTHR34059:SF3', NULL, NULL, NULL, NULL, 'OS02G0656100 PROTEIN', 244738),
(351249, 'PTHR34059:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244738),
(351250, 'PTHR34059:SF8', NULL, NULL, NULL, NULL, 'BNAA04G27400D PROTEIN', 244738),
(351251, 'PTHR34059', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244738),
(351252, 'PTHR34059:SF9', NULL, NULL, NULL, NULL, 'BNAC08G10760D PROTEIN', 244738),
(351253, 'PTHR12406:SF41', NULL, NULL, NULL, NULL, 'BRUMMER, ISOFORM B-RELATED', 244739),
(351254, 'PTHR12406:SF38', NULL, NULL, NULL, NULL, 'PNPLA DOMAIN-CONTAINING PROTEIN', 244739),
(351255, 'PTHR12406:SF45', NULL, NULL, NULL, NULL, 'PATATIN', 244739),
(351256, 'PTHR12406:SF23', NULL, NULL, NULL, NULL, 'OMEGA-HYDROXYCERAMIDE TRANSACYLASE', 244739),
(351257, 'PTHR12406:SF22', NULL, NULL, NULL, NULL, '1-ACYLGLYCEROL-3-PHOSPHATE O-ACYLTRANSFERASE PNPLA3', 244739),
(351258, 'PTHR12406:SF44', NULL, NULL, NULL, NULL, 'PATATIN-LIKE PHOSPHOLIPASE DOMAIN-CONTAINING 3', 244739),
(351259, 'PTHR12406:SF43', NULL, NULL, NULL, NULL, 'PNPLA DOMAIN-CONTAINING PROTEIN', 244739),
(351260, 'PTHR12406', NULL, NULL, NULL, NULL, 'CALCIUM-INDEPENDENT PHOSPHOLIPASE A2  IPLA2 -RELATED', 244739),
(351261, 'PTHR12406:SF21', NULL, NULL, NULL, NULL, 'PNPLA DOMAIN-CONTAINING PROTEIN', 244739),
(351262, 'PTHR12406:SF42', NULL, NULL, NULL, NULL, 'PNPLA DOMAIN-CONTAINING PROTEIN', 244739),
(351263, 'PTHR12406:SF4', NULL, NULL, NULL, NULL, 'PATATIN-LIKE PHOSPHOLIPASE DOMAIN-CONTAINING PROTEIN 5', 244739),
(351264, 'PTHR12406:SF29', NULL, NULL, NULL, NULL, 'PATATIN-LIKE PHOSPHOLIPASE DOMAIN-CONTAINING PROTEIN 2', 244739),
(351265, 'PTHR12406:SF7', NULL, NULL, NULL, NULL, 'PATATIN-LIKE PHOSPHOLIPASE DOMAIN-CONTAINING PROTEIN 4', 244739),
(351266, 'PTHR13495:SF0', NULL, NULL, NULL, NULL, 'PSME3-INTERACTING PROTEIN', 244740),
(351267, 'PTHR13495', NULL, NULL, NULL, NULL, 'NEFA-INTERACTING NUCLEAR PROTEIN NIP30', 244740),
(351268, 'PTHR13495:SF2', NULL, NULL, NULL, NULL, 'FAM192A_FYV6_N DOMAIN-CONTAINING PROTEIN', 244740),
(351269, 'PTHR46601:SF1', NULL, NULL, NULL, NULL, '', 244741),
(351270, 'PTHR46601:SF2', NULL, NULL, NULL, NULL, '', 244741),
(351271, 'PTHR46601', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 244741),
(351272, 'PTHR46383:SF1', NULL, NULL, NULL, NULL, 'ASPARTATE AMINOTRANSFERASE', 244742),
(351273, 'PTHR46383:SF2', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE', 244742),
(351274, 'PTHR46383:SF3', NULL, NULL, NULL, NULL, 'ASPARTATE AMINOTRANSFERASE-RELATED', 244742),
(351275, 'PTHR46383', NULL, NULL, NULL, NULL, 'ASPARTATE AMINOTRANSFERASE', 244742),
(351276, 'PTHR46383:SF4', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE', 244742),
(351277, 'PTHR22844:SF369', NULL, NULL, NULL, NULL, 'COATOMER ALPHA SUBUNIT-RELATED', 244743),
(351278, 'PTHR22844:SF368', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 244743),
(351279, 'PTHR22844:SF346', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN KINASE B-LIKE', 244743),
(351280, 'PTHR22844:SF324', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 244743),
(351281, 'PTHR22844:SF367', NULL, NULL, NULL, NULL, 'APOPTOTIC PROTEASE-ACTIVATING FACTOR 1-RELATED', 244743),
(351282, 'PTHR22844:SF388', NULL, NULL, NULL, NULL, 'WD REPEAT PROTEIN DCAF11/LEC14B-RELATED', 244743),
(351283, 'PTHR22844:SF344', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN KINASE B-LIKE PROTEIN', 244743),
(351284, 'PTHR22844:SF366', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 244743);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(351285, 'PTHR22844:SF365', NULL, NULL, NULL, NULL, 'WD REPEAT PROTEIN DCAF11/LEC14B-RELATED', 244743),
(351286, 'PTHR22844:SF387', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 244743),
(351287, 'PTHR22844:SF386', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN-RELATED', 244743),
(351288, 'PTHR22844:SF342', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 244743),
(351289, 'PTHR22844:SF363', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 244743),
(351290, 'PTHR22844:SF385', NULL, NULL, NULL, NULL, '', 244743),
(351291, 'PTHR22844:SF340', NULL, NULL, NULL, NULL, 'OS01G0946100 PROTEIN', 244743),
(351292, 'PTHR22844:SF384', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 244743),
(351293, 'PTHR22844:SF383', NULL, NULL, NULL, NULL, 'OS06G0238700 PROTEIN', 244743),
(351294, 'PTHR22844:SF382', NULL, NULL, NULL, NULL, 'COATOMER ALPHA SUBUNIT-RELATED', 244743),
(351295, 'PTHR22844:SF381', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 244743),
(351296, 'PTHR22844:SF380', NULL, NULL, NULL, NULL, 'BNAANNG03630D PROTEIN', 244743),
(351297, 'PTHR22844', NULL, NULL, NULL, NULL, 'F-BOX AND WD40 DOMAIN PROTEIN', 244743),
(351298, 'PTHR22844:SF339', NULL, NULL, NULL, NULL, 'F13F21.11 PROTEIN', 244743),
(351299, 'PTHR22844:SF338', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 244743),
(351300, 'PTHR22844:SF359', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 244743),
(351301, 'PTHR22844:SF337', NULL, NULL, NULL, NULL, 'F16N3.9 PROTEIN', 244743),
(351302, 'PTHR22844:SF358', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN-RELATED', 244743),
(351303, 'PTHR22844:SF336', NULL, NULL, NULL, NULL, 'PROTEIN JINGUBANG', 244743),
(351304, 'PTHR22844:SF357', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 244743),
(351305, 'PTHR22844:SF379', NULL, NULL, NULL, NULL, 'EN/SPM-LIKE TRANSPOSON PROTEIN-LIKE', 244743),
(351306, 'PTHR22844:SF213', NULL, NULL, NULL, NULL, 'OS01G0232200 PROTEIN', 244743),
(351307, 'PTHR22844:SF356', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 244743),
(351308, 'PTHR22844:SF334', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 244743),
(351309, 'PTHR22844:SF355', NULL, NULL, NULL, NULL, 'OS03G0625300 PROTEIN', 244743),
(351310, 'PTHR22844:SF199', NULL, NULL, NULL, NULL, 'F21J9.19', 244743),
(351311, 'PTHR22844:SF331', NULL, NULL, NULL, NULL, 'SIMILARITY TO GTP-BINDING REGULATORY PROTEIN AND WD-REPEAT PROTEIN', 244743),
(351312, 'PTHR22844:SF352', NULL, NULL, NULL, NULL, 'WD40/YVTN REPEAT-LIKE-CONTAINING DOMAIN-CONTAINING PROTEIN-RELATED', 244743),
(351313, 'PTHR22844:SF374', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN KINASE B-LIKE', 244743),
(351314, 'PTHR22844:SF373', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 244743),
(351315, 'PTHR22844:SF350', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN, BETA SUBUNIT-RELATED', 244743),
(351316, 'PTHR22844:SF371', NULL, NULL, NULL, NULL, 'OS12G0594000 PROTEIN', 244743),
(351317, 'PTHR22844:SF370', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 244743),
(351318, 'PTHR47550:SF1', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE PPS1', 244744),
(351319, 'PTHR47550', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE PPS1', 244744),
(351320, 'PTHR43865', NULL, NULL, NULL, NULL, 'RUBRERYTHRIN-RELATED', 244745),
(351321, 'PTHR43865:SF1', NULL, NULL, NULL, NULL, 'RUBRERYTHRIN-RELATED', 244745),
(351322, 'PTHR31859:SF9', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 39B-LIKE PROTEIN', 244746),
(351323, 'PTHR31859:SF20', NULL, NULL, NULL, NULL, '', 244746),
(351324, 'PTHR31859:SF21', NULL, NULL, NULL, NULL, 'INCLUSION BODY CLEARANCE PROTEIN IML2', 244746),
(351325, 'PTHR31859:SF5', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT DOMAIN 39D', 244746),
(351326, 'PTHR31859:SF7', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 39A', 244746);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(351327, 'PTHR31859:SF2', NULL, NULL, NULL, NULL, '', 244746),
(351328, 'PTHR31859:SF1', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 39C', 244746),
(351329, 'PTHR31859', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 39 FAMILY MEMBER', 244746),
(351330, 'PTHR31859:SF4', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 39B', 244746),
(351331, 'PTHR31859:SF3', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 39A', 244746),
(351332, 'PTHR31859:SF19', NULL, NULL, NULL, NULL, '', 244746),
(351333, 'PTHR34825', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN, WITH A WEAK D-GALACTARATE DEHYDRATASE/ALTRONATE HYDROLASE DOMAIN', 244747),
(351334, 'PTHR34825:SF2', NULL, NULL, NULL, NULL, 'AAA-ATPASE_LIKE DOMAIN-CONTAINING PROTEIN', 244747),
(351335, 'PTHR34825:SF1', NULL, NULL, NULL, NULL, 'AAA-ATPASE_LIKE DOMAIN-CONTAINING PROTEIN', 244747),
(351336, 'PTHR42937:SF1', NULL, NULL, NULL, NULL, 'DIAMINOPROPIONATE AMMONIA-LYASE', 244748),
(351337, 'PTHR42937', NULL, NULL, NULL, NULL, '', 244748),
(351338, 'PTHR11225:SF4', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP93', 244749),
(351339, 'PTHR11225:SF5', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP93A', 244749),
(351340, 'PTHR11225:SF6', NULL, NULL, NULL, NULL, 'NUCLEOPORIN NPP106', 244749),
(351341, 'PTHR11225', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP93  NUCLEOPORIN NUP93   DEAD EYE PROTEIN', 244749),
(351342, 'PTHR14484', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 71', 244750),
(351343, 'PTHR14484:SF0', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 71', 244750),
(351344, 'PTHR14484:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 71L', 244750),
(351345, 'PTHR12550:SF18', NULL, NULL, NULL, NULL, 'HEPATOMA-DERIVED GROWTH FACTOR-RELATED PROTEIN 2', 244751),
(351346, 'PTHR12550:SF49', NULL, NULL, NULL, NULL, 'PROTEIN HUA2-LIKE 2-RELATED', 244751),
(351347, 'PTHR12550:SF42', NULL, NULL, NULL, NULL, 'PC4 AND SFRS1-INTERACTING PROTEIN', 244751),
(351348, 'PTHR12550:SF76', NULL, NULL, NULL, NULL, 'PWWP DOMAIN-CONTAINING PROTEIN', 244751),
(351349, 'PTHR12550:SF41', NULL, NULL, NULL, NULL, 'HEPATOMA-DERIVED GROWTH FACTOR', 244751),
(351350, 'PTHR12550:SF79', NULL, NULL, NULL, NULL, '', 244751),
(351351, 'PTHR12550:SF69', NULL, NULL, NULL, NULL, 'BNAC07G49730D PROTEIN', 244751),
(351352, 'PTHR12550:SF77', NULL, NULL, NULL, NULL, 'PROTEIN HUA2-LIKE 1', 244751),
(351353, 'PTHR12550:SF66', NULL, NULL, NULL, NULL, 'OS07G0655500 PROTEIN', 244751),
(351354, 'PTHR12550:SF78', NULL, NULL, NULL, NULL, 'HEPATOMA-DERIVED GROWTH FACTOR-RELATED PROTEIN 3', 244751),
(351355, 'PTHR12550', NULL, NULL, NULL, NULL, 'HEPATOMA-DERIVED GROWTH FACTOR-RELATED', 244751),
(351356, 'PTHR12550:SF72', NULL, NULL, NULL, NULL, 'PWWP DOMAIN-CONTAINING PROTEIN', 244751),
(351357, 'PTHR12550:SF80', NULL, NULL, NULL, NULL, 'TUDOR/PWWP/MBT SUPERFAMILY PROTEIN', 244751),
(351358, 'PTHR12550:SF70', NULL, NULL, NULL, NULL, 'JIL-1 ANCHORING AND STABILIZING PROTEIN, ISOFORM A', 244751),
(351359, 'PTHR12550:SF81', NULL, NULL, NULL, NULL, 'HEPATOMA-DERIVED GROWTH FACTOR-LIKE PROTEIN 1', 244751),
(351360, 'PTHR47040:SF3', NULL, NULL, NULL, NULL, 'BNAA08G28470D PROTEIN', 244752),
(351361, 'PTHR47040', NULL, NULL, NULL, NULL, 'OSJNBA0068L06.9 PROTEIN', 244752),
(351362, 'PTHR47040:SF2', NULL, NULL, NULL, NULL, 'PEPTIDASE S24/S26A/S26B/S26C FAMILY PROTEIN', 244752),
(351363, 'PTHR47040:SF1', NULL, NULL, NULL, NULL, 'OS04G0102600 PROTEIN', 244752),
(351364, 'PTHR43504:SF1', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NADP]', 244753),
(351365, 'PTHR43504', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NADP]', 244753),
(351366, 'PTHR15268:SF17', NULL, NULL, NULL, NULL, 'BCLAF1 AND THRAP3 FAMILY MEMBER 3', 244754),
(351367, 'PTHR15268:SF16', NULL, NULL, NULL, NULL, 'THYROID HORMONE RECEPTOR-ASSOCIATED PROTEIN 3', 244754),
(351368, 'PTHR15268:SF4', NULL, NULL, NULL, NULL, 'BCL-2-ASSOCIATED TRANSCRIPTION FACTOR 1', 244754),
(351369, 'PTHR15268:SF18', NULL, NULL, NULL, NULL, '', 244754);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(351370, 'PTHR15268', NULL, NULL, NULL, NULL, 'THRAP3/BCLAF1', 244754),
(351371, 'PTHR33911', NULL, NULL, NULL, NULL, 'RRNA-PROCESSING PROTEIN EFG1', 244755),
(351372, 'PTHR33911:SF2', NULL, NULL, NULL, NULL, 'RRNA-PROCESSING PROTEIN EFG1', 244755),
(351373, 'PTHR33911:SF1', NULL, NULL, NULL, NULL, 'RRNA-PROCESSING PROTEIN EFG1', 244755),
(351374, 'PTHR10272:SF14', NULL, NULL, NULL, NULL, '1-ALKYL-2-ACETYLGLYCEROPHOSPHOCHOLINE ESTERASE', 244756),
(351375, 'PTHR10272:SF0', NULL, NULL, NULL, NULL, 'PLATELET-ACTIVATING FACTOR ACETYLHYDROLASE', 244756),
(351376, 'PTHR10272:SF11', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE-RELATED', 244756),
(351377, 'PTHR10272:SF12', NULL, NULL, NULL, NULL, 'PLATELET-ACTIVATING FACTOR ACETYLHYDROLASE', 244756),
(351378, 'PTHR10272:SF13', NULL, NULL, NULL, NULL, 'SLR1506 PROTEIN', 244756),
(351379, 'PTHR10272', NULL, NULL, NULL, NULL, 'PLATELET-ACTIVATING FACTOR ACETYLHYDROLASE', 244756),
(351380, 'PTHR10272:SF6', NULL, NULL, NULL, NULL, 'PLATELET-ACTIVATING FACTOR ACETYLHYDROLASE 2, CYTOPLASMIC', 244756),
(351381, 'PTHR10272:SF7', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE-RELATED', 244756),
(351382, 'PTHR34306', NULL, NULL, NULL, NULL, 'RAD60-SLD DOMAIN-CONTAINING PROTEIN', 244757),
(351383, 'PTHR34306:SF6', NULL, NULL, NULL, NULL, '', 244757),
(351384, 'PTHR34306:SF5', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 244757),
(351385, 'PTHR34306:SF4', NULL, NULL, NULL, NULL, 'BROMODOMAIN-CONTAINING PROTEIN DDB_G0278469', 244757),
(351386, 'PTHR34306:SF3', NULL, NULL, NULL, NULL, 'RAD60-SLD DOMAIN-CONTAINING PROTEIN-RELATED', 244757),
(351387, 'PTHR43765', NULL, NULL, NULL, NULL, '2-DEHYDROPANTOATE 2-REDUCTASE-RELATED', 244758),
(351388, 'PTHR43765:SF2', NULL, NULL, NULL, NULL, '2-DEHYDROPANTOATE 2-REDUCTASE-RELATED', 244758),
(351389, 'PTHR43765:SF3', NULL, NULL, NULL, NULL, '2-DEHYDROPANTOATE 2-REDUCTASE', 244758),
(351390, 'PTHR21780:SF0', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 209', 244759),
(351391, 'PTHR21780', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244759),
(351392, 'PTHR41349', NULL, NULL, NULL, NULL, '', 244760),
(351393, 'PTHR41349:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG08683', 244760),
(351394, 'PTHR38456:SF1', NULL, NULL, NULL, NULL, 'CYCLIC DI-AMP RECEPTOR A', 244761),
(351395, 'PTHR38456', NULL, NULL, NULL, NULL, 'CYCLIC DI-AMP RECEPTOR A', 244761),
(351396, 'PTHR38137:SF2', NULL, NULL, NULL, NULL, 'PRC DOMAIN-CONTAINING PROTEIN', 244762),
(351397, 'PTHR38137:SF1', NULL, NULL, NULL, NULL, 'PRC DOMAIN-CONTAINING PROTEIN', 244762),
(351398, 'PTHR38137', NULL, NULL, NULL, NULL, 'PRC-BARREL DOMAIN PROTEIN', 244762),
(351399, 'PTHR37351:SF1', NULL, NULL, NULL, NULL, 'C-X-C MOTIF CHEMOKINE 17', 244763),
(351400, 'PTHR37351', NULL, NULL, NULL, NULL, 'C-X-C MOTIF CHEMOKINE 17', 244763),
(351401, 'PTHR46584', NULL, NULL, NULL, NULL, 'HMG DOMAIN-CONTAINING PROTEIN 4', 244764),
(351402, 'PTHR46584:SF1', NULL, NULL, NULL, NULL, 'HMG DOMAIN-CONTAINING PROTEIN 4', 244764),
(351403, 'PTHR31047:SF0', NULL, NULL, NULL, NULL, 'MEIOTICALLY UP-REGULATED GENE 157 PROTEIN', 244765),
(351404, 'PTHR31047:SF1', NULL, NULL, NULL, NULL, 'DUF1237 DOMAIN-CONTAINING PROTEIN', 244765),
(351405, 'PTHR31047:SF2', NULL, NULL, NULL, NULL, '', 244765),
(351406, 'PTHR31047', NULL, NULL, NULL, NULL, 'MEIOTICALLY UP-REGULATED GENE 157 PROTEIN', 244765),
(351407, 'PTHR43482:SF2', NULL, NULL, NULL, NULL, 'ZINC-BINDING DEHYDROGENASE FAMILY, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G15030)-RELATED', 244766),
(351408, 'PTHR43482:SF1', NULL, NULL, NULL, NULL, 'PROTEIN AST1-RELATED', 244766),
(351409, 'PTHR43482', NULL, NULL, NULL, NULL, 'PROTEIN AST1-RELATED', 244766),
(351410, 'PTHR43482:SF4', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G06260)-RELATED', 244766),
(351411, 'PTHR42979:SF1', NULL, NULL, NULL, NULL, '3-ISOPROPYLMALATE DEHYDROGENASE', 244767),
(351412, 'PTHR42979:SF4', NULL, NULL, NULL, NULL, '3-ISOPROPYLMALATE DEHYDROGENASE', 244767),
(351413, 'PTHR42979:SF5', NULL, NULL, NULL, NULL, '3-ISOPROPYLMALATE DEHYDROGENASE 1, CHLOROPLASTIC-RELATED', 244767);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(351414, 'PTHR42979', NULL, NULL, NULL, NULL, '3-ISOPROPYLMALATE DEHYDROGENASE', 244767),
(351415, 'PTHR42979:SF8', NULL, NULL, NULL, NULL, 'ISO_DH DOMAIN-CONTAINING PROTEIN', 244767),
(351416, 'PTHR42979:SF9', NULL, NULL, NULL, NULL, '3-ISOPROPYLMALATE DEHYDROGENASE', 244767),
(351417, 'PTHR42979:SF7', NULL, NULL, NULL, NULL, '3-ISOPROPYLMALATE DEHYDROGENASE', 244767),
(351418, 'PTHR40043', NULL, NULL, NULL, NULL, 'UPF0719 INNER MEMBRANE PROTEIN YJFL', 244768),
(351419, 'PTHR40043:SF1', NULL, NULL, NULL, NULL, 'UPF0719 INNER MEMBRANE PROTEIN YJFL', 244768),
(351420, 'PTHR46827', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN DDB_G0288861-RELATED', 244769),
(351421, 'PTHR46827:SF1', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN DDB_G0288861-RELATED', 244769),
(351422, 'PTHR35790:SF4', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR PCHR', 244770),
(351423, 'PTHR35790', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR PCHR', 244770),
(351424, 'PTHR35790:SF5', NULL, NULL, NULL, NULL, 'MARR-FAMILY TRANSCRIPTIONAL REGULATOR', 244770),
(351425, 'PTHR28491:SF1', NULL, NULL, NULL, NULL, 'UPF0688 PROTEIN C1ORF174', 244771),
(351426, 'PTHR28491', NULL, NULL, NULL, NULL, 'UPF0688 PROTEIN C1ORF174', 244771),
(351427, 'PTHR14950:SF53', NULL, NULL, NULL, NULL, 'RIBONUCLEASE 3-LIKE PROTEIN 3 ISOFORM X1', 244772),
(351428, 'PTHR14950:SF75', NULL, NULL, NULL, NULL, 'RNASE III DOMAIN-CONTAINING PROTEIN', 244772),
(351429, 'PTHR14950:SF31', NULL, NULL, NULL, NULL, 'ENDORIBONUCLEASE DICER HOMOLOG 3B', 244772),
(351430, 'PTHR14950:SF54', NULL, NULL, NULL, NULL, 'RNASE II-LIKE 1', 244772),
(351431, 'PTHR14950:SF76', NULL, NULL, NULL, NULL, '', 244772),
(351432, 'PTHR14950:SF77', NULL, NULL, NULL, NULL, 'ENDORIBONUCLEASE DICER-LIKE PROTEIN', 244772),
(351433, 'PTHR14950:SF66', NULL, NULL, NULL, NULL, 'RIBONUCLEASE 3-LIKE PROTEIN 2', 244772),
(351434, 'PTHR14950:SF46', NULL, NULL, NULL, NULL, 'ENDORIBONUCLEASE DICER HOMOLOG 3', 244772),
(351435, 'PTHR14950:SF69', NULL, NULL, NULL, NULL, 'RNASE III DOMAIN-CONTAINING PROTEIN', 244772),
(351436, 'PTHR14950:SF58', NULL, NULL, NULL, NULL, 'RNASE III DOMAIN-CONTAINING PROTEIN', 244772),
(351437, 'PTHR14950:SF36', NULL, NULL, NULL, NULL, 'DICER-2, ISOFORM A', 244772),
(351438, 'PTHR14950:SF15', NULL, NULL, NULL, NULL, 'DICER-LIKE PROTEIN 4', 244772),
(351439, 'PTHR14950:SF48', NULL, NULL, NULL, NULL, 'ENDORIBONUCLEASE DICER HOMOLOG 2', 244772),
(351440, 'PTHR14950:SF37', NULL, NULL, NULL, NULL, 'ENDORIBONUCLEASE DICER', 244772),
(351441, 'PTHR14950:SF49', NULL, NULL, NULL, NULL, 'RIBONUCLEASE 3-LIKE PROTEIN 2-RELATED', 244772),
(351442, 'PTHR14950:SF70', NULL, NULL, NULL, NULL, 'ENDORIBONUCLEASE DICER HOMOLOG 2', 244772),
(351443, 'PTHR14950:SF51', NULL, NULL, NULL, NULL, 'RIBONUCLEASE 3-LIKE PROTEIN 2', 244772),
(351444, 'PTHR14950:SF73', NULL, NULL, NULL, NULL, 'MINIMAL DICER', 244772),
(351445, 'PTHR14950:SF62', NULL, NULL, NULL, NULL, 'DICER-LIKE PROTEIN 1', 244772),
(351446, 'PTHR14950:SF74', NULL, NULL, NULL, NULL, '', 244772),
(351447, 'PTHR14950:SF63', NULL, NULL, NULL, NULL, 'RIBONUCLEASE III-RELATED', 244772),
(351448, 'PTHR14950', NULL, NULL, NULL, NULL, 'DICER-RELATED', 244772),
(351449, 'PTHR21529:SF4', NULL, NULL, NULL, NULL, 'TPR AND ANKYRIN REPEAT-CONTAINING PROTEIN 1', 244773),
(351450, 'PTHR21529', NULL, NULL, NULL, NULL, 'MAMMARY TURMOR VIRUS RECEPTOR HOMOLOG 1, 2  MTVR1, 2', 244773),
(351451, 'PTHR21529:SF10', NULL, NULL, NULL, NULL, '', 244773),
(351452, 'PTHR21529:SF11', NULL, NULL, NULL, NULL, '', 244773),
(351453, 'PTHR21529:SF9', NULL, NULL, NULL, NULL, 'UVRD-LIKE HELICASE ATP-BINDING DOMAIN-CONTAINING PROTEIN', 244773),
(351454, 'PTHR21529:SF7', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 244773),
(351455, 'PTHR15092:SF42', NULL, NULL, NULL, NULL, 'POLY(A)-SPECIFIC RIBONUCLEASE PARN-LIKE', 244774),
(351456, 'PTHR15092:SF44', NULL, NULL, NULL, NULL, 'POLY(A)-SPECIFIC RIBONUCLEASE PARN', 244774),
(351457, 'PTHR15092:SF22', NULL, NULL, NULL, NULL, 'POLY(A)-SPECIFIC RIBONUCLEASE PNLDC1', 244774),
(351458, 'PTHR15092:SF23', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 244774);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(351459, 'PTHR15092', NULL, NULL, NULL, NULL, 'POLY A -SPECIFIC RIBONUCLEASE/TARGET OF EGR1, MEMBER 1', 244774),
(351460, 'PTHR15092:SF46', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 244774),
(351461, 'PTHR15092:SF47', NULL, NULL, NULL, NULL, 'POLY(A)-SPECIFIC EXORIBONUCLEASE PARN', 244774),
(351462, 'PTHR15092:SF37', NULL, NULL, NULL, NULL, 'TARGET OF EGR1 PROTEIN 1', 244774),
(351463, 'PTHR42195', NULL, NULL, NULL, NULL, 'UCP015877 FAMILY PROTEIN', 244775),
(351464, 'PTHR42195:SF1', NULL, NULL, NULL, NULL, 'UCP015877 FAMILY PROTEIN', 244775),
(351465, 'PTHR12385:SF37', NULL, NULL, NULL, NULL, 'CHOLINE TRANSPORTER-LIKE PROTEIN 4', 244776),
(351466, 'PTHR12385:SF103', NULL, NULL, NULL, NULL, 'CHOLINE TRANSPORTER-LIKE PROTEIN-RELATED', 244776),
(351467, 'PTHR12385:SF102', NULL, NULL, NULL, NULL, 'PLASMA-MEMBRANE CHOLINE TRANSPORTER FAMILY PROTEIN', 244776),
(351468, 'PTHR12385:SF101', NULL, NULL, NULL, NULL, 'CHOLINE TRANSPORTER-LIKE PROTEIN 2', 244776),
(351469, 'PTHR12385:SF100', NULL, NULL, NULL, NULL, 'PLASMA-MEMBRANE CHOLINE TRANSPORTER FAMILY PROTEIN', 244776),
(351470, 'PTHR12385:SF94', NULL, NULL, NULL, NULL, 'PLASMA-MEMBRANE CHOLINE TRANSPORTER FAMILY PROTEIN', 244776),
(351471, 'PTHR12385:SF4', NULL, NULL, NULL, NULL, 'PROTEIN PNS1', 244776),
(351472, 'PTHR12385:SF93', NULL, NULL, NULL, NULL, 'PLASMA-MEMBRANE CHOLINE TRANSPORTER FAMILY PROTEIN', 244776),
(351473, 'PTHR12385:SF92', NULL, NULL, NULL, NULL, 'CHOLINE TRANSPORTER-LIKE PROTEIN-RELATED', 244776),
(351474, 'PTHR12385:SF98', NULL, NULL, NULL, NULL, 'PLASMA-MEMBRANE CHOLINE TRANSPORTER FAMILY PROTEIN', 244776),
(351475, 'PTHR12385:SF42', NULL, NULL, NULL, NULL, 'CHOLINE TRANSPORTER-LIKE PROTEIN 5', 244776),
(351476, 'PTHR12385:SF85', NULL, NULL, NULL, NULL, 'GB|AAF63775.1', 244776),
(351477, 'PTHR12385:SF96', NULL, NULL, NULL, NULL, 'CHOLINE TRANSPORTER-LIKE PROTEIN 1', 244776),
(351478, 'PTHR12385:SF84', NULL, NULL, NULL, NULL, 'F20H23.27 PROTEIN-RELATED', 244776),
(351479, 'PTHR12385', NULL, NULL, NULL, NULL, 'CHOLINE TRANSPORTER-LIKE (SLC FAMILY 44)', 244776),
(351480, 'PTHR12385:SF14', NULL, NULL, NULL, NULL, 'CHOLINE TRANSPORTER-LIKE 2', 244776),
(351481, 'PTHR12385:SF13', NULL, NULL, NULL, NULL, 'CHOLINE TRANSPORTER-LIKE PROTEIN 3', 244776),
(351482, 'PTHR12385:SF12', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 44 MEMBER 1A-RELATED', 244776),
(351483, 'PTHR12385:SF56', NULL, NULL, NULL, NULL, 'CHOLINE TRANSPORTER-LIKE PROTEIN 1', 244776),
(351484, 'PTHR12385:SF34', NULL, NULL, NULL, NULL, 'CHOLINE TRANSPORTER-LIKE PROTEIN 2', 244776),
(351485, 'PTHR12385:SF88', NULL, NULL, NULL, NULL, 'CHOLINE TRANSPORTER-LIKE PROTEIN CTL1', 244776),
(351486, 'PTHR12385:SF99', NULL, NULL, NULL, NULL, '', 244776),
(351487, 'PTHR14305:SF0', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE CCNB1IP1', 244777),
(351488, 'PTHR14305', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE CCNB1IP1', 244777),
(351489, 'PTHR10908:SF0', NULL, NULL, NULL, NULL, 'SEROTONIN N-ACETYLTRANSFERASE', 244778),
(351490, 'PTHR10908', NULL, NULL, NULL, NULL, 'SEROTONIN N-ACETYLTRANSFERASE', 244778),
(351491, 'PTHR10908:SF4', NULL, NULL, NULL, NULL, 'ARYLALKYLAMINE N-ACETYLTRANSFERASE', 244778),
(351492, 'PTHR10908:SF5', NULL, NULL, NULL, NULL, 'ARYLALKYLAMINE N-ACETYLTRANSFERASE', 244778),
(351493, 'PTHR36039:SF2', NULL, NULL, NULL, NULL, 'RNA LIGASE/CYCLIC NUCLEOTIDE PHOSPHODIESTERASE FAMILY PROTEIN', 244779),
(351494, 'PTHR36039', NULL, NULL, NULL, NULL, '', 244779),
(351495, 'PTHR37209', NULL, NULL, NULL, NULL, 'LYSINE-RICH ARABINOGALACTAN PROTEIN 17-RELATED', 244780),
(351496, 'PTHR37209:SF9', NULL, NULL, NULL, NULL, '', 244780),
(351497, 'PTHR37209:SF7', NULL, NULL, NULL, NULL, 'PROLINE-RICH CELL WALL PROTEIN', 244780),
(351498, 'PTHR37209:SF4', NULL, NULL, NULL, NULL, 'BNACNNG22370D PROTEIN', 244780),
(351499, 'PTHR37209:SF11', NULL, NULL, NULL, NULL, '', 244780),
(351500, 'PTHR37209:SF3', NULL, NULL, NULL, NULL, 'LYSINE-RICH ARABINOGALACTAN PROTEIN 17', 244780),
(351501, 'PTHR37209:SF12', NULL, NULL, NULL, NULL, 'CLASSICAL ARABINOGALACTAN PROTEIN 5-LIKE', 244780);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(351502, 'PTHR37209:SF13', NULL, NULL, NULL, NULL, 'LYSINE-RICH ARABINOGALACTAN PROTEIN 18', 244780),
(351503, 'PTHR37209:SF1', NULL, NULL, NULL, NULL, 'CLASSICAL ARABINOGALACTAN PROTEIN 9', 244780),
(351504, 'PTHR37209:SF10', NULL, NULL, NULL, NULL, '', 244780),
(351505, 'PTHR12097', NULL, NULL, NULL, NULL, 'SPLICING FACTOR 3B, SUBUNIT 1-RELATED', 244781),
(351506, 'PTHR12097:SF0', NULL, NULL, NULL, NULL, 'SPLICING FACTOR 3B SUBUNIT 1', 244781),
(351507, 'PTHR12097:SF1', NULL, NULL, NULL, NULL, 'SF3B1 DOMAIN-CONTAINING PROTEIN', 244781),
(351508, 'PTHR12904', NULL, NULL, NULL, NULL, '', 244782),
(351509, 'PTHR12904:SF23', NULL, NULL, NULL, NULL, 'PROTEIN ZER-1 HOMOLOG', 244782),
(351510, 'PTHR12904:SF28', NULL, NULL, NULL, NULL, 'GASTRULATION-DEFECTIVE PROTEIN 3', 244782),
(351511, 'PTHR12904:SF22', NULL, NULL, NULL, NULL, 'PROTEIN ZYG-11 HOMOLOG-RELATED', 244782),
(351512, 'PTHR12904:SF21', NULL, NULL, NULL, NULL, 'PROTEIN ZYG-11 HOMOLOG B', 244782),
(351513, 'PTHR12904:SF20', NULL, NULL, NULL, NULL, 'PROTEIN ZYG-11 HOMOLOG A', 244782),
(351514, 'PTHR12904:SF31', NULL, NULL, NULL, NULL, 'REPEAT PROTEIN (LRRP), PUTATIVE-RELATED', 244782),
(351515, 'PTHR12904:SF30', NULL, NULL, NULL, NULL, 'REGULATORY SUBUNIT', 244782),
(351516, 'PTHR15974:SF0', NULL, NULL, NULL, NULL, 'CYTOKINE-LIKE PROTEIN 1', 244783),
(351517, 'PTHR15974', NULL, NULL, NULL, NULL, 'CYTOKINE-LIKE PROTEIN 1', 244783),
(351518, 'PTHR13301:SF187', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 244784),
(351519, 'PTHR13301:SF220', NULL, NULL, NULL, NULL, 'BNAA04G18860D PROTEIN', 244784),
(351520, 'PTHR13301:SF141', NULL, NULL, NULL, NULL, 'MIXED-LINKED GLUCAN SYNTHASE 7-RELATED', 244784),
(351521, 'PTHR13301:SF185', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE-LIKE PROTEIN CSLE', 244784),
(351522, 'PTHR13301:SF91', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE A CATALYTIC SUBUNIT 4 [UDP-FORMING]', 244784),
(351523, 'PTHR13301:SF183', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE-LIKE PROTEIN D5', 244784),
(351524, 'PTHR13301:SF182', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE H1-LIKE PROTEIN', 244784),
(351525, 'PTHR13301:SF53', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE-LIKE PROTEIN B1-RELATED', 244784),
(351526, 'PTHR13301:SF181', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE', 244784),
(351527, 'PTHR13301:SF94', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE-LIKE PROTEIN D1', 244784),
(351528, 'PTHR13301:SF180', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE-LIKE PROTEIN', 244784),
(351529, 'PTHR13301:SF228', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE E1-LIKE PROTEIN', 244784),
(351530, 'PTHR13301:SF56', NULL, NULL, NULL, NULL, 'MIXED-LINKED GLUCAN SYNTHASE 4', 244784),
(351531, 'PTHR13301:SF149', NULL, NULL, NULL, NULL, '', 244784),
(351532, 'PTHR13301:SF226', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE-LIKE PROTEIN', 244784),
(351533, 'PTHR13301:SF148', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE H1-LIKE PROTEIN', 244784),
(351534, 'PTHR13301:SF224', NULL, NULL, NULL, NULL, 'BNAC03G70880D PROTEIN', 244784),
(351535, 'PTHR13301:SF147', NULL, NULL, NULL, NULL, '', 244784),
(351536, 'PTHR13301:SF222', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE A CATALYTIC SUBUNIT 6 [UDP-FORMING]-RELATED', 244784),
(351537, 'PTHR13301:SF145', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE-LIKE PROTEIN D1', 244784),
(351538, 'PTHR13301:SF189', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE-LIKE PROTEIN B5-RELATED', 244784),
(351539, 'PTHR13301:SF58', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE-LIKE PROTEIN D3', 244784),
(351540, 'PTHR13301:SF144', NULL, NULL, NULL, NULL, 'MIXED-LINKED GLUCAN SYNTHASE 9-RELATED', 244784),
(351541, 'PTHR13301:SF188', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE-LIKE PROTEIN E1', 244784),
(351542, 'PTHR13301:SF198', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE', 244784),
(351543, 'PTHR13301:SF153', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE A CATALYTIC SUBUNIT 5 [UDP-FORMING]', 244784),
(351544, 'PTHR13301:SF196', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE', 244784),
(351545, 'PTHR13301:SF152', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE A CATALYTIC SUBUNIT 3 [UDP-FORMING]-RELATED', 244784);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(351546, 'PTHR13301:SF41', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE-LIKE PROTEIN G3', 244784),
(351547, 'PTHR13301:SF194', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE-LIKE PROTEIN E1', 244784),
(351548, 'PTHR13301:SF193', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE', 244784),
(351549, 'PTHR13301:SF40', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE-LIKE PROTEIN D4', 244784),
(351550, 'PTHR13301:SF239', NULL, NULL, NULL, NULL, 'BNAA01G13600D PROTEIN', 244784),
(351551, 'PTHR13301:SF89', NULL, NULL, NULL, NULL, '', 244784),
(351552, 'PTHR13301:SF238', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE', 244784),
(351553, 'PTHR13301:SF237', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE-LIKE PROTEIN D3', 244784),
(351554, 'PTHR13301:SF236', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE', 244784),
(351555, 'PTHR13301:SF44', NULL, NULL, NULL, NULL, 'MIXED-LINKED GLUCAN SYNTHASE 3-RELATED', 244784),
(351556, 'PTHR13301:SF159', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE A CATALYTIC SUBUNIT 6 [UDP-FORMING]', 244784),
(351557, 'PTHR13301:SF156', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE-LIKE PROTEIN D6-RELATED', 244784),
(351558, 'PTHR13301:SF47', NULL, NULL, NULL, NULL, 'MIXED-LINKED GLUCAN SYNTHASE 8-RELATED', 244784),
(351559, 'PTHR13301:SF155', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE-LIKE PROTEIN D3', 244784),
(351560, 'PTHR13301:SF209', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE D', 244784),
(351561, 'PTHR13301:SF208', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE', 244784),
(351562, 'PTHR13301:SF207', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE, NUCLEOTIDE-DIPHOSPHO-SUGAR TRANSFERASE-RELATED', 244784),
(351563, 'PTHR13301:SF70', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE A CATALYTIC SUBUNIT 11 [UDP-FORMING]-RELATED', 244784),
(351564, 'PTHR13301:SF242', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE A CATALYTIC SUBUNIT 10 [UDP-FORMING]-RELATED', 244784),
(351565, 'PTHR13301:SF241', NULL, NULL, NULL, NULL, 'BNAA05G10500D PROTEIN', 244784),
(351566, 'PTHR13301:SF164', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE-LIKE PROTEIN G2', 244784),
(351567, 'PTHR13301:SF240', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE-LIKE PROTEIN E1', 244784),
(351568, 'PTHR13301:SF160', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE-LIKE PROTEIN G1-RELATED', 244784),
(351569, 'PTHR13301:SF75', NULL, NULL, NULL, NULL, 'MIXED-LINKED GLUCAN SYNTHASE 6-RELATED', 244784),
(351570, 'PTHR13301:SF31', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE A CATALYTIC SUBUNIT 8 [UDP-FORMING]', 244784),
(351571, 'PTHR13301:SF206', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE A CATALYTIC SUBUNIT 8 [UDP-FORMING]-RELATED', 244784),
(351572, 'PTHR13301:SF249', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE', 244784),
(351573, 'PTHR13301:SF204', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE, CAZY FAMILY GT2', 244784),
(351574, 'PTHR13301:SF248', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE A CATALYTIC SUBUNIT 2 [UDP-FORMING]-RELATED', 244784),
(351575, 'PTHR13301:SF203', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE', 244784),
(351576, 'PTHR13301:SF33', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE A CATALYTIC SUBUNIT 1 [UDP-FORMING]', 244784),
(351577, 'PTHR13301:SF247', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE-LIKE PROTEIN D3', 244784),
(351578, 'PTHR13301:SF169', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 244784),
(351579, 'PTHR13301:SF246', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE', 244784),
(351580, 'PTHR13301:SF202', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE, NUCLEOTIDE-DIPHOSPHO-SUGAR TRANSFERASE-RELATED', 244784),
(351581, 'PTHR13301:SF245', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE-LIKE D3-RELATED', 244784),
(351582, 'PTHR13301:SF167', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE A CATALYTIC SUBUNIT 9 [UDP-FORMING]-RELATED', 244784),
(351583, 'PTHR13301:SF244', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE CSLG', 244784),
(351584, 'PTHR13301:SF200', NULL, NULL, NULL, NULL, 'BNACNNG06180D PROTEIN', 244784),
(351585, 'PTHR13301:SF243', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE', 244784),
(351586, 'PTHR13301:SF219', NULL, NULL, NULL, NULL, 'BNAC09G40960D PROTEIN', 244784);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(351587, 'PTHR13301:SF175', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE H1-LIKE PROTEIN', 244784),
(351588, 'PTHR13301:SF173', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE-LIKE PROTEIN E1', 244784),
(351589, 'PTHR13301:SF172', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE-LIKE PROTEIN G2', 244784),
(351590, 'PTHR13301:SF171', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE A CATALYTIC SUBUNIT 3 [UDP-FORMING]', 244784),
(351591, 'PTHR13301:SF170', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE-LIKE PROTEIN', 244784),
(351592, 'PTHR13301', NULL, NULL, NULL, NULL, 'X-BOX TRANSCRIPTION FACTOR-RELATED', 244784),
(351593, 'PTHR13301:SF216', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE A CATALYTIC SUBUNIT 7 [UDP-FORMING]-LIKE', 244784),
(351594, 'PTHR13301:SF138', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE-LIKE PROTEIN E1', 244784),
(351595, 'PTHR13301:SF215', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE-LIKE PROTEIN D2', 244784),
(351596, 'PTHR13301:SF214', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE, NUCLEOTIDE-DIPHOSPHO-SUGAR TRANSFERASE-RELATED', 244784),
(351597, 'PTHR13301:SF213', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 244784),
(351598, 'PTHR13301:SF27', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE', 244784),
(351599, 'PTHR13301:SF135', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE-LIKE PROTEIN E2', 244784),
(351600, 'PTHR13301:SF212', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE CSLG', 244784),
(351601, 'PTHR13301:SF28', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE A CATALYTIC SUBUNIT 7 [UDP-FORMING]', 244784),
(351602, 'PTHR13301:SF178', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE-LIKE PROTEIN D3', 244784),
(351603, 'PTHR13301:SF211', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE A CATALYTIC SUBUNIT 2 [UDP-FORMING]', 244784),
(351604, 'PTHR13301:SF210', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE', 244784),
(351605, 'PTHR38659:SF1', NULL, NULL, NULL, NULL, 'METAL DEPENDENT PHOSPHOHYDROLASE-RELATED', 244785),
(351606, 'PTHR38659:SF2', NULL, NULL, NULL, NULL, 'METAL-DEPENDENT PHOSPHOHYDROLASE', 244785),
(351607, 'PTHR38659', NULL, NULL, NULL, NULL, 'METAL-DEPENDENT PHOSPHOHYDROLASE', 244785),
(351608, 'PTHR13393', NULL, NULL, NULL, NULL, 'SAM-DEPENDENT METHYLTRANSFERASE', 244786),
(351609, 'PTHR13393:SF0', NULL, NULL, NULL, NULL, 'RNA N6-ADENOSINE-METHYLTRANSFERASE METTL16', 244786),
(351610, 'PTHR43049', NULL, NULL, NULL, NULL, 'EARLY ENDOSOME ANTIGEN', 244787),
(351611, 'PTHR43049:SF1', NULL, NULL, NULL, NULL, 'EARLY ENDOSOME ANTIGEN', 244787),
(351612, 'PTHR43049:SF6', NULL, NULL, NULL, NULL, 'BNAANNG16240D PROTEIN', 244787),
(351613, 'PTHR43049:SF5', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN, EMBRYONIC SMOOTH PROTEIN', 244787),
(351614, 'PTHR47642', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 244788),
(351615, 'PTHR47642:SF2', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 244788),
(351616, 'PTHR47642:SF3', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 244788),
(351617, 'PTHR47642:SF4', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 244788),
(351618, 'PTHR47642:SF5', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 244788),
(351619, 'PTHR23429', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-DEHYDROGENASE  G6PD', 244789),
(351620, 'PTHR23429:SF0', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-DEHYDROGENASE', 244789),
(351621, 'PTHR23429:SF20', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-DEHYDROGENASE 3, CHLOROPLASTIC', 244789),
(351622, 'PTHR23429:SF4', NULL, NULL, NULL, NULL, 'INACTIVE GLUCOSE-6-PHOSPHATE 1-DEHYDROGENASE 4, CHLOROPLASTIC', 244789),
(351623, 'PTHR23429:SF21', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-DEHYDROGENASE C7.13C-RELATED', 244789),
(351624, 'PTHR23429:SF11', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-DEHYDROGENASE 2, CHLOROPLASTIC', 244789),
(351625, 'PTHR23429:SF22', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-DEHYDROGENASE', 244789),
(351626, 'PTHR23429:SF12', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-DEHYDROGENASE 5, CYTOPLASMIC', 244789),
(351627, 'PTHR23429:SF13', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-DEHYDROGENASE 1, CHLOROPLASTIC', 244789);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(351628, 'PTHR23429:SF14', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-DEHYDROGENASE', 244789),
(351629, 'PTHR23429:SF8', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-DEHYDROGENASE', 244789),
(351630, 'PTHR23429:SF15', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-DEHYDROGENASE', 244789),
(351631, 'PTHR23429:SF7', NULL, NULL, NULL, NULL, 'GDH/6PGL ENDOPLASMIC BIFUNCTIONAL PROTEIN', 244789),
(351632, 'PTHR23429:SF16', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-DEHYDROGENASE', 244789),
(351633, 'PTHR23429:SF19', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-DEHYDROGENASE GCD1', 244789),
(351634, 'PTHR23429:SF9', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-DEHYDROGENASE', 244789),
(351635, 'PTHR34008', NULL, NULL, NULL, NULL, 'REPETITIVE PROLINE-RICH CELL WALL PROTEIN 1', 244790),
(351636, 'PTHR34008:SF2', NULL, NULL, NULL, NULL, 'REPETITIVE PROLINE-RICH CELL WALL PROTEIN 1', 244790),
(351637, 'PTHR34673:SF2', NULL, NULL, NULL, NULL, 'BNAA10G17250D PROTEIN', 244791),
(351638, 'PTHR34673', NULL, NULL, NULL, NULL, 'COLD-REGULATED PROTEIN', 244791),
(351639, 'PTHR34673:SF1', NULL, NULL, NULL, NULL, 'COLD-REGULATED PROTEIN', 244791),
(351640, 'PTHR46638', NULL, NULL, NULL, NULL, 'CORRINOID ADENOSYLTRANSFERASE', 244792),
(351641, 'PTHR46638:SF1', NULL, NULL, NULL, NULL, 'CORRINOID ADENOSYLTRANSFERASE', 244792),
(351642, 'PTHR12176:SF59', NULL, NULL, NULL, NULL, 'METHYLTRANFER_DOM DOMAIN-CONTAINING PROTEIN', 244793),
(351643, 'PTHR12176:SF79', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 244793),
(351644, 'PTHR12176:SF78', NULL, NULL, NULL, NULL, 'EEF1A LYSINE AND N-TERMINAL METHYLTRANSFERASE', 244793),
(351645, 'PTHR12176:SF56', NULL, NULL, NULL, NULL, 'OS04G0510700 PROTEIN', 244793),
(351646, 'PTHR12176:SF77', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 244793),
(351647, 'PTHR12176:SF66', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 244793),
(351648, 'PTHR12176:SF76', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 244793),
(351649, 'PTHR12176:SF74', NULL, NULL, NULL, NULL, 'METHYLTRANFER_DOM DOMAIN-CONTAINING PROTEIN', 244793),
(351650, 'PTHR12176:SF84', NULL, NULL, NULL, NULL, '', 244793),
(351651, 'PTHR12176:SF83', NULL, NULL, NULL, NULL, 'CITRATE SYNTHASE-LYSINE N-METHYLTRANSFERASE CSKMT, MITOCHONDRIAL', 244793),
(351652, 'PTHR12176:SF72', NULL, NULL, NULL, NULL, '', 244793),
(351653, 'PTHR12176:SF82', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASE SUPERFAMILY PROTEIN', 244793),
(351654, 'PTHR12176:SF81', NULL, NULL, NULL, NULL, '', 244793),
(351655, 'PTHR12176:SF80', NULL, NULL, NULL, NULL, 'EEF1A LYSINE METHYLTRANSFERASE 4', 244793),
(351656, 'PTHR12176', NULL, NULL, NULL, NULL, 'SAM-DEPENDENT METHYLTRANSFERASE SUPERFAMILY PROTEIN', 244793),
(351657, 'PTHR13856:SF136', NULL, NULL, NULL, NULL, 'TARGET OF MYB1-LIKE 2 MEMBRANE-TRAFFICKING PROTEIN', 244794),
(351658, 'PTHR13856:SF137', NULL, NULL, NULL, NULL, 'GH05942P', 244794),
(351659, 'PTHR13856', NULL, NULL, NULL, NULL, 'VHS DOMAIN CONTAINING PROTEIN FAMILY', 244794),
(351660, 'PTHR13856:SF28', NULL, NULL, NULL, NULL, 'TOM1-LIKE PROTEIN 1', 244794),
(351661, 'PTHR13856:SF32', NULL, NULL, NULL, NULL, 'TARGET OF MYB PROTEIN 1', 244794),
(351662, 'PTHR13856:SF31', NULL, NULL, NULL, NULL, 'TOM1-LIKE PROTEIN 2', 244794),
(351663, 'PTHR47891', NULL, NULL, NULL, NULL, 'TRANSPORTER-RELATED', 244795),
(351664, 'PTHR47891:SF1', NULL, NULL, NULL, NULL, 'CORA-MAGNESIUM AND COBALT TRANSPORTER', 244795),
(351665, 'PTHR47891:SF2', NULL, NULL, NULL, NULL, 'MAGNESIUM AND COBALT TRANSPORTER', 244795),
(351666, 'PTHR36009', NULL, NULL, NULL, NULL, '', 244796),
(351667, 'PTHR36009:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 244796),
(351668, 'PTHR10799:SF992', NULL, NULL, NULL, NULL, 'HELICASE ATP-BINDING DOMAIN-CONTAINING PROTEIN', 244797),
(351669, 'PTHR10799:SF76', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ACTIVATOR BRG1', 244797); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(351670, 'PTHR10799:SF1001', NULL, NULL, NULL, NULL, 'BTAF (TBP-ASSOCIATED FACTOR) HOMOLOG', 244797),
(351671, 'PTHR10799:SF1000', NULL, NULL, NULL, NULL, 'CSB (COCKAYNE SYNDROME B) HOMOLOG', 244797),
(351672, 'PTHR10799:SF959', NULL, NULL, NULL, NULL, 'ATPASE (EUROFUNG)', 244797),
(351673, 'PTHR10799:SF1005', NULL, NULL, NULL, NULL, 'CHROMATIN COMPLEX SUBUNIT A 106', 244797),
(351674, 'PTHR10799:SF819', NULL, NULL, NULL, NULL, 'GLOBAL TRANSCRIPTION ACTIVATOR SNF2L1-RELATED', 244797),
(351675, 'PTHR10799:SF1004', NULL, NULL, NULL, NULL, '', 244797),
(351676, 'PTHR10799:SF1003', NULL, NULL, NULL, NULL, 'SWI/SNF-RELATED MATRIX-ASSOCIATED ACTIN-DEPENDENT REGULATOR OF CHROMATIN SUBFAMILY A CONTAINING DEAD/H BOX 1A', 244797),
(351677, 'PTHR10799:SF1002', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT HELICASE FFT2', 244797),
(351678, 'PTHR10799:SF994', NULL, NULL, NULL, NULL, 'BNAA04G26610D PROTEIN', 244797),
(351679, 'PTHR10799:SF1009', NULL, NULL, NULL, NULL, 'HELICASE ATP-BINDING DOMAIN-CONTAINING PROTEIN', 244797),
(351680, 'PTHR10799:SF971', NULL, NULL, NULL, NULL, 'HDA1 COMPLEX SUBUNIT 3', 244797),
(351681, 'PTHR10799:SF1008', NULL, NULL, NULL, NULL, 'HELICASE CHR10 ISOFORM X1-RELATED', 244797),
(351682, 'PTHR10799:SF993', NULL, NULL, NULL, NULL, 'PRION-LIKE-(Q/N-RICH)-DOMAIN-BEARING PROTEIN', 244797),
(351683, 'PTHR10799:SF973', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT HELICASE BRM', 244797),
(351684, 'PTHR10799:SF1007', NULL, NULL, NULL, NULL, 'SWI/SNF CHROMATIN-REMODELING COMPLEX SUBUNIT SNF22', 244797),
(351685, 'PTHR10799:SF1006', NULL, NULL, NULL, NULL, '', 244797),
(351686, 'PTHR10799:SF975', NULL, NULL, NULL, NULL, 'ISWI CHROMATIN-REMODELING COMPLEX ATPASE CHR17', 244797),
(351687, 'PTHR10799:SF854', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE CHR12-RELATED', 244797),
(351688, 'PTHR10799:SF997', NULL, NULL, NULL, NULL, 'SWI/SNF-RELATED MATRIX-ASSOCIATED ACTIN-DEPENDENT REGULATOR OF CHROMATIN SUBFAMILY A MEMBER 5', 244797),
(351689, 'PTHR10799:SF856', NULL, NULL, NULL, NULL, 'ISWI CHROMATIN-REMODELING COMPLEX ATPASE ISW1', 244797),
(351690, 'PTHR10799:SF978', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT HELICASE BRM', 244797),
(351691, 'PTHR10799:SF999', NULL, NULL, NULL, NULL, 'OS05G0150300 PROTEIN', 244797),
(351692, 'PTHR10799:SF879', NULL, NULL, NULL, NULL, 'SWI/SNF-RELATED, MATRIX-ASSOCIATED, ACTIN-DEPENDENT REGULATOR OF CHROMATIN, SUBFAMILY A, MEMBER 1-RELATED', 244797),
(351693, 'PTHR10799:SF541', NULL, NULL, NULL, NULL, 'GLOBAL TRANSCRIPTION ACTIVATOR SNF2L2-RELATED', 244797),
(351694, 'PTHR10799:SF1012', NULL, NULL, NULL, NULL, 'NUCLEAR PROTEIN STH1/NPS1', 244797),
(351695, 'PTHR10799:SF1011', NULL, NULL, NULL, NULL, 'ISWI CHROMATIN-REMODELING COMPLEX ATPASE CHR11-LIKE', 244797),
(351696, 'PTHR10799:SF1010', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT HELICASE FFT3', 244797),
(351697, 'PTHR10799:SF1015', NULL, NULL, NULL, NULL, 'BNAC07G16550D PROTEIN', 244797),
(351698, 'PTHR10799:SF1014', NULL, NULL, NULL, NULL, 'REMODELING FACTOR, PUTATIVE-RELATED', 244797),
(351699, 'PTHR10799', NULL, NULL, NULL, NULL, 'SNF2/RAD54 HELICASE FAMILY', 244797),
(351700, 'PTHR10799:SF1013', NULL, NULL, NULL, NULL, 'HELICASE OF THE SNF2/RAD54 FAMILY', 244797),
(351701, 'PTHR10799:SF982', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE DDM1-LIKE ISOFORM X1', 244797),
(351702, 'PTHR10799:SF963', NULL, NULL, NULL, NULL, 'SNF2-RELATED DOMAIN-CONTAINING PROTEIN', 244797),
(351703, 'PTHR10799:SF964', NULL, NULL, NULL, NULL, 'SWI/SNF-RELATED MATRIX-ASSOCIATED ACTIN-DEPENDENT REGULATOR OF CHROMATIN SUBFAMILY A CONTAINING DEAD/H BOX 1', 244797),
(351704, 'PTHR10799:SF989', NULL, NULL, NULL, NULL, 'BNAA05G30940D PROTEIN', 244797),
(351705, 'PTHR10799:SF988', NULL, NULL, NULL, NULL, 'BNAC09G39190D PROTEIN', 244797),
(351706, 'PTHR10799:SF923', NULL, NULL, NULL, NULL, 'HELICASE, LYMPHOID-SPECIFIC', 244797),
(351707, 'PTHR48304:SF1', NULL, NULL, NULL, NULL, 'QLQ DOMAIN-CONTAINING PROTEIN', 244798),
(351708, 'PTHR48304', NULL, NULL, NULL, NULL, 'QLQ DOMAIN-CONTAINING PROTEIN', 244798),
(351709, 'PTHR12850:SF27', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S25', 244799);
INSERT INTO "PUBLIC"."MODEL" VALUES
(351710, 'PTHR12850:SF28', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S25-1-RELATED', 244799),
(351711, 'PTHR12850:SF36', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S25', 244799),
(351712, 'PTHR12850:SF26', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S25', 244799),
(351713, 'PTHR12850:SF35', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S25', 244799),
(351714, 'PTHR12850:SF33', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S25', 244799),
(351715, 'PTHR12850:SF20', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S25', 244799),
(351716, 'PTHR12850', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S25', 244799),
(351717, 'PTHR12850:SF31', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S25', 244799),
(351718, 'PTHR12850:SF5', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S25', 244799),
(351719, 'PTHR12850:SF18', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S25', 244799),
(351720, 'PTHR12850:SF19', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S25', 244799),
(351721, 'PTHR40399:SF1', NULL, NULL, NULL, NULL, 'PTS SYSTEM GLUCITOL/SORBITOL-SPECIFIC EIIC COMPONENT', 244800),
(351722, 'PTHR40399', NULL, NULL, NULL, NULL, 'PTS SYSTEM GLUCITOL/SORBITOL-SPECIFIC EIIC COMPONENT', 244800),
(351723, 'PTHR37869', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 89', 244801),
(351724, 'PTHR37869:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 89', 244801),
(351725, 'PTHR10129:SF25', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MAFF', 244802),
(351726, 'PTHR10129:SF35', NULL, NULL, NULL, NULL, 'LEUCINE ZIPPER TRANSCRIPTION FACTOR', 244802),
(351727, 'PTHR10129:SF24', NULL, NULL, NULL, NULL, 'NEURAL RETINA-SPECIFIC LEUCINE ZIPPER PROTEIN', 244802),
(351728, 'PTHR10129:SF49', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MAFB', 244802),
(351729, 'PTHR10129:SF15', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MAFG', 244802),
(351730, 'PTHR10129:SF26', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MAFK', 244802),
(351731, 'PTHR10129:SF48', NULL, NULL, NULL, NULL, 'MAF-S, ISOFORM B', 244802),
(351732, 'PTHR10129:SF10', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MAFB', 244802),
(351733, 'PTHR10129', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MAF', 244802),
(351734, 'PTHR10129:SF44', NULL, NULL, NULL, NULL, 'TRAFFIC JAM, ISOFORM C', 244802),
(351735, 'PTHR10129:SF30', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MAFA', 244802),
(351736, 'PTHR10129:SF9', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MAF', 244802),
(351737, 'PTHR13259', NULL, NULL, NULL, NULL, 'BLADDER CANCER 10 KD PROTEIN HOMOLOG', 244803),
(351738, 'PTHR13259:SF1', NULL, NULL, NULL, NULL, 'BLADDER CANCER-ASSOCIATED PROTEIN', 244803),
(351739, 'PTHR36323:SF1', NULL, NULL, NULL, NULL, 'MYOTUBULARIN-LIKE PROTEIN', 244804),
(351740, 'PTHR36323', NULL, NULL, NULL, NULL, 'MYOTUBULARIN-LIKE PROTEIN', 244804),
(351741, 'PTHR23290', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244805),
(351742, 'PTHR23290:SF0', NULL, NULL, NULL, NULL, 'RRNA N6-ADENOSINE-METHYLTRANSFERASE METTL5', 244805),
(351743, 'PTHR23290:SF5', NULL, NULL, NULL, NULL, 'MTS DOMAIN-CONTAINING PROTEIN', 244805),
(351744, 'PTHR37746:SF2', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 244806),
(351745, 'PTHR37746:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 244806),
(351746, 'PTHR37746', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 244806),
(351747, 'PTHR15116:SF16', NULL, NULL, NULL, NULL, 'DEFECTIVE PROVENTRICULUS, ISOFORM A', 244807),
(351748, 'PTHR15116', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN SATB FAMILY MEMBER', 244807),
(351749, 'PTHR15116:SF15', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN SATB2', 244807),
(351750, 'PTHR15116:SF14', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN SATB1', 244807),
(351751, 'PTHR38390:SF2', NULL, NULL, NULL, NULL, 'OS01G0103900 PROTEIN', 244808),
(351752, 'PTHR38390', NULL, NULL, NULL, NULL, 'OS01G0103900 PROTEIN', 244808),
(351753, 'PTHR48245:SF1', NULL, NULL, NULL, NULL, '', 244809),
(351754, 'PTHR48245', NULL, NULL, NULL, NULL, '', 244809),
(351755, 'PTHR35069:SF1', NULL, NULL, NULL, NULL, 'PROTEIN C9ORF135', 244810);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(351756, 'PTHR35069', NULL, NULL, NULL, NULL, 'PROTEIN C9ORF135', 244810),
(351757, 'PTHR22900', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244811),
(351758, 'PTHR22900:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG24017', 244811),
(351759, 'PTHR22900:SF10', NULL, NULL, NULL, NULL, 'PROTEIN CBG20830', 244811),
(351760, 'PTHR22900:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG14245', 244811),
(351761, 'PTHR22900:SF23', NULL, NULL, NULL, NULL, 'PROTEIN CBG08041', 244811),
(351762, 'PTHR22900:SF11', NULL, NULL, NULL, NULL, 'PROTEIN CBG01579', 244811),
(351763, 'PTHR22900:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG14246', 244811),
(351764, 'PTHR22900:SF13', NULL, NULL, NULL, NULL, 'PROTEIN CBG22016', 244811),
(351765, 'PTHR22900:SF6', NULL, NULL, NULL, NULL, 'CARBOHYDRATE SULFOTRANSFERASE CHST-1', 244811),
(351766, 'PTHR22900:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG00813', 244811),
(351767, 'PTHR22900:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG16438', 244811),
(351768, 'PTHR12630:SF17', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244812),
(351769, 'PTHR12630:SF16', NULL, NULL, NULL, NULL, 'GLUCOSIDASE 2 SUBUNIT BETA', 244812),
(351770, 'PTHR12630:SF24', NULL, NULL, NULL, NULL, 'GLUCOSIDASE 2 SUBUNIT BETA', 244812),
(351771, 'PTHR12630:SF22', NULL, NULL, NULL, NULL, 'GLUCOSIDASE 2 SUBUNIT BETA', 244812),
(351772, 'PTHR12630:SF20', NULL, NULL, NULL, NULL, 'GLUCOSIDASE 2 SUBUNIT BETA', 244812),
(351773, 'PTHR12630:SF1', NULL, NULL, NULL, NULL, 'GLUCOSIDASE 2 SUBUNIT BETA', 244812),
(351774, 'PTHR12630', NULL, NULL, NULL, NULL, 'N-LINKED OLIGOSACCHARIDE PROCESSING', 244812),
(351775, 'PTHR12630:SF6', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINE-1-PHOSPHOTRANSFERASE SUBUNIT GAMMA', 244812),
(351776, 'PTHR12630:SF19', NULL, NULL, NULL, NULL, 'GLUCOSIDASE 2 SUBUNIT BETA-RELATED', 244812),
(351777, 'PTHR43138', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE, GNAT FAMILY', 244813),
(351778, 'PTHR43138:SF1', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE ACA1', 244813),
(351779, 'PTHR43138:SF2', NULL, NULL, NULL, NULL, 'PROTEIN SPT10', 244813),
(351780, 'PTHR44099:SF2', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 72', 244814),
(351781, 'PTHR44099', NULL, NULL, NULL, NULL, 'RABCONNECTIN-3B, ISOFORM A', 244814),
(351782, 'PTHR44099:SF3', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 7', 244814),
(351783, 'PTHR44099:SF4', NULL, NULL, NULL, NULL, 'RABCONNECTIN-3B, ISOFORM A', 244814),
(351784, 'PTHR15504', NULL, NULL, NULL, NULL, 'NASOPHARYNGEAL EPITHELIUM SPECIFIC PROTEIN 1', 244815),
(351785, 'PTHR15504:SF0', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 45', 244815),
(351786, 'PTHR37754:SF4', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 244816),
(351787, 'PTHR37754:SF2', NULL, NULL, NULL, NULL, 'ION-BINDING PROTEIN, PUTATIVE-RELATED', 244816),
(351788, 'PTHR37754', NULL, NULL, NULL, NULL, 'CALCIUM ION-BINDING PROTEIN', 244816),
(351789, 'PTHR37754:SF1', NULL, NULL, NULL, NULL, 'CALCIUM ION-BINDING PROTEIN', 244816),
(351790, 'PTHR13251', NULL, NULL, NULL, NULL, 'EPILEPSY HOLOPROSENCEPHALY CANDIDATE 1/TMEM1', 244817),
(351791, 'PTHR13251:SF3', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT 10', 244817),
(351792, 'PTHR13251:SF5', NULL, NULL, NULL, NULL, 'FOIE-GRAS_1 DOMAIN-CONTAINING PROTEIN', 244817),
(351793, 'PTHR13251:SF6', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN-CONTAINING PROTEIN-RELATED', 244817),
(351794, 'PTHR12067:SF5', NULL, NULL, NULL, NULL, 'PODOCALYXIN', 244818),
(351795, 'PTHR12067', NULL, NULL, NULL, NULL, 'PODOCALYXIN', 244818),
(351796, 'PTHR30372:SF5', NULL, NULL, NULL, NULL, 'LIPID-A-DISACCHARIDE SYNTHASE', 244819),
(351797, 'PTHR30372:SF4', NULL, NULL, NULL, NULL, 'LIPID-A-DISACCHARIDE SYNTHASE, MITOCHONDRIAL-RELATED', 244819),
(351798, 'PTHR30372', NULL, NULL, NULL, NULL, 'LIPID-A-DISACCHARIDE SYNTHASE', 244819),
(351799, 'PTHR30372:SF6', NULL, NULL, NULL, NULL, 'LIPID-A-DISACCHARIDE SYNTHASE', 244819),
(351800, 'PTHR34740:SF8', NULL, NULL, NULL, NULL, '', 244820),
(351801, 'PTHR34740:SF5', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244820);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(351802, 'PTHR34740', NULL, NULL, NULL, NULL, 'FINGER, C3HC4 TYPE, PUTATIVE-RELATED-RELATED', 244820),
(351803, 'PTHR12533:SF7', NULL, NULL, NULL, NULL, 'NFAT NUCLEAR FACTOR, ISOFORM B', 244821),
(351804, 'PTHR12533:SF4', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR OF ACTIVATED T-CELLS, CYTOPLASMIC 2', 244821),
(351805, 'PTHR12533:SF5', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR OF ACTIVATED T-CELLS, CYTOPLASMIC 1', 244821),
(351806, 'PTHR12533:SF10', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR OF ACTIVATED T-CELLS 5', 244821),
(351807, 'PTHR12533:SF11', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR OF ACTIVATED T-CELLS, CYTOPLASMIC 4', 244821),
(351808, 'PTHR12533:SF6', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR OF ACTIVATED T-CELLS, CYTOPLASMIC 3', 244821),
(351809, 'PTHR12533', NULL, NULL, NULL, NULL, 'NFAT', 244821),
(351810, 'PTHR13015:SF2', NULL, NULL, NULL, NULL, 'WASH COMPLEX SUBUNIT 3', 244822),
(351811, 'PTHR13015:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 53', 244822),
(351812, 'PTHR13015', NULL, NULL, NULL, NULL, 'PROTEIN AD-016-RELATED', 244822),
(351813, 'PTHR13015:SF0', NULL, NULL, NULL, NULL, 'WASH COMPLEX SUBUNIT 3', 244822),
(351814, 'PTHR12918', NULL, NULL, NULL, NULL, 'CYSTEINE DIOXYGENASE', 244823),
(351815, 'PTHR12918:SF1', NULL, NULL, NULL, NULL, 'CYSTEINE DIOXYGENASE TYPE 1', 244823),
(351816, 'PTHR12920:SF3', NULL, NULL, NULL, NULL, 'RING1 AND YY1-BINDING PROTEIN', 244824),
(351817, 'PTHR12920:SF4', NULL, NULL, NULL, NULL, 'GEO03726P1', 244824),
(351818, 'PTHR12920:SF2', NULL, NULL, NULL, NULL, 'YY1-ASSOCIATED FACTOR 2', 244824),
(351819, 'PTHR12920', NULL, NULL, NULL, NULL, 'RYBP AND YAF2-RELATED', 244824),
(351820, 'PTHR21436', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244825),
(351821, 'PTHR21436:SF2', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 142', 244825),
(351822, 'PTHR13448:SF0', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 214', 244826),
(351823, 'PTHR13448', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 214', 244826),
(351824, 'PTHR13448:SF7', NULL, NULL, NULL, NULL, 'F26K24.17 PROTEIN', 244826),
(351825, 'PTHR13448:SF12', NULL, NULL, NULL, NULL, 'BNAA09G30070D PROTEIN', 244826),
(351826, 'PTHR13448:SF13', NULL, NULL, NULL, NULL, 'BNAC09G46560D PROTEIN', 244826),
(351827, 'PTHR13448:SF8', NULL, NULL, NULL, NULL, 'BNAA09G51360D PROTEIN', 244826),
(351828, 'PTHR13448:SF10', NULL, NULL, NULL, NULL, 'BNAA09G51340D PROTEIN', 244826),
(351829, 'PTHR13448:SF6', NULL, NULL, NULL, NULL, '', 244826),
(351830, 'PTHR13448:SF11', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 214-LIKE ISOFORM X1', 244826),
(351831, 'PTHR13448:SF9', NULL, NULL, NULL, NULL, 'BNAA09G09250D PROTEIN', 244826),
(351832, 'PTHR14030:SF24', NULL, NULL, NULL, NULL, 'MITOTIC CHECKPOINT SERINE/THREONINE-PROTEIN KINASE BUB-1', 244827),
(351833, 'PTHR14030', NULL, NULL, NULL, NULL, 'MITOTIC CHECKPOINT SERINE/THREONINE-PROTEIN KINASE BUB1', 244827),
(351834, 'PTHR14030:SF23', NULL, NULL, NULL, NULL, 'BUB1 KINASE, ISOFORM A', 244827),
(351835, 'PTHR14030:SF26', NULL, NULL, NULL, NULL, 'MITOTIC CHECKPOINT SERINE/THREONINE-PROTEIN KINASE BUB1', 244827),
(351836, 'PTHR14030:SF25', NULL, NULL, NULL, NULL, 'MITOTIC CHECKPOINT SERINE/THREONINE-PROTEIN KINASE BUB1 BETA', 244827),
(351837, 'PTHR14030:SF27', NULL, NULL, NULL, NULL, '', 244827),
(351838, 'PTHR14030:SF19', NULL, NULL, NULL, NULL, 'MITOTIC SPINDLE CHECKPOINT PROTEIN BUBR1', 244827),
(351839, 'PTHR14030:SF2', NULL, NULL, NULL, NULL, 'OS11G0128700 PROTEIN', 244827),
(351840, 'PTHR14030:SF4', NULL, NULL, NULL, NULL, 'BUB1-RELATED KINASE', 244827),
(351841, 'PTHR13068:SF92', NULL, NULL, NULL, NULL, '', 244828),
(351842, 'PTHR13068:SF93', NULL, NULL, NULL, NULL, 'OS05G0403600 PROTEIN', 244828),
(351843, 'PTHR13068:SF91', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR FAMILY PROTEIN', 244828),
(351844, 'PTHR13068:SF98', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR MTERF2, CHLOROPLASTIC', 244828),
(351845, 'PTHR13068:SF97', NULL, NULL, NULL, NULL, '', 244828),
(351846, 'PTHR13068:SF127', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL TRANSCRIPTION TERMINATION FACTOR', 244828);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(351847, 'PTHR13068:SF120', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR MTERF2, CHLOROPLASTIC-LIKE ISOFORM X1', 244828),
(351848, 'PTHR13068:SF122', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL TRANSCRIPTION TERMINATION FACTOR-RELATED / MTERF-LIKE PROTEIN', 244828),
(351849, 'PTHR13068:SF83', NULL, NULL, NULL, NULL, 'OS06G0224500 PROTEIN', 244828),
(351850, 'PTHR13068:SF84', NULL, NULL, NULL, NULL, 'OS06G0225100 PROTEIN', 244828),
(351851, 'PTHR13068:SF89', NULL, NULL, NULL, NULL, '', 244828),
(351852, 'PTHR13068:SF139', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR MTEF1, CHLOROPLASTIC', 244828),
(351853, 'PTHR13068:SF135', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR MTERF8, CHLOROPLASTIC', 244828),
(351854, 'PTHR13068:SF136', NULL, NULL, NULL, NULL, 'OS06G0224400 PROTEIN', 244828),
(351855, 'PTHR13068:SF137', NULL, NULL, NULL, NULL, '', 244828),
(351856, 'PTHR13068:SF138', NULL, NULL, NULL, NULL, 'MITOCHODRIAL TRANSCRIPTION TERMINATION FACTOR-RELATED', 244828),
(351857, 'PTHR13068:SF132', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL TRANSCRIPTION TERMINATION FACTOR FAMILY PROTEIN', 244828),
(351858, 'PTHR13068:SF133', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL TRANSCRIPTION TERMINATION FACTOR FAMILY PROTEIN', 244828),
(351859, 'PTHR13068:SF130', NULL, NULL, NULL, NULL, 'OS05G0403400 PROTEIN', 244828),
(351860, 'PTHR13068:SF190', NULL, NULL, NULL, NULL, 'BNAC03G44350D PROTEIN', 244828),
(351861, 'PTHR13068:SF192', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL TRANSCRIPTION TERMINATION FACTOR FAMILY PROTEIN', 244828),
(351862, 'PTHR13068:SF78', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL TRANSCRIPTION TERMINATION FACTOR FAMILY PROTEIN', 244828),
(351863, 'PTHR13068:SF79', NULL, NULL, NULL, NULL, 'OS02G0749800 PROTEIN', 244828),
(351864, 'PTHR13068:SF109', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR MTERF4, CHLOROPLASTIC', 244828),
(351865, 'PTHR13068:SF223', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL TRANSCRIPTION TERMINATION FACTOR FAMILY PROTEIN', 244828),
(351866, 'PTHR13068:SF102', NULL, NULL, NULL, NULL, 'MTERF FAMILY PROTEIN', 244828),
(351867, 'PTHR13068:SF103', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL TRANSCRIPTION TERMINATION FACTOR FAMILY PROTEIN', 244828),
(351868, 'PTHR13068:SF224', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR FAMILY PROTEIN', 244828),
(351869, 'PTHR13068:SF225', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR FAMILY PROTEIN', 244828),
(351870, 'PTHR13068:SF226', NULL, NULL, NULL, NULL, '', 244828),
(351871, 'PTHR13068:SF186', NULL, NULL, NULL, NULL, 'BNAA05G31650D PROTEIN', 244828),
(351872, 'PTHR13068:SF187', NULL, NULL, NULL, NULL, '', 244828),
(351873, 'PTHR13068:SF220', NULL, NULL, NULL, NULL, 'F19K23.4 PROTEIN-RELATED', 244828),
(351874, 'PTHR13068:SF221', NULL, NULL, NULL, NULL, '', 244828),
(351875, 'PTHR13068:SF222', NULL, NULL, NULL, NULL, '', 244828),
(351876, 'PTHR13068:SF183', NULL, NULL, NULL, NULL, '', 244828),
(351877, 'PTHR13068:SF184', NULL, NULL, NULL, NULL, 'F8K4.20 PROTEIN', 244828),
(351878, 'PTHR13068:SF185', NULL, NULL, NULL, NULL, '', 244828),
(351879, 'PTHR13068:SF117', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR MTERF5, CHLOROPLASTIC-LIKE', 244828),
(351880, 'PTHR13068:SF118', NULL, NULL, NULL, NULL, '', 244828),
(351881, 'PTHR13068:SF113', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR MTEF18, MITOCHONDRIAL', 244828),
(351882, 'PTHR13068:SF116', NULL, NULL, NULL, NULL, '', 244828),
(351883, 'PTHR13068:SF198', NULL, NULL, NULL, NULL, '', 244828),
(351884, 'PTHR13068:SF111', NULL, NULL, NULL, NULL, '', 244828),
(351885, 'PTHR13068:SF112', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR 3, MITOCHONDRIAL', 244828),
(351886, 'PTHR13068:SF194', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR 3, MITOCHONDRIAL', 244828),
(351887, 'PTHR13068:SF196', NULL, NULL, NULL, NULL, 'OS11G0246100 PROTEIN', 244828),
(351888, 'PTHR13068:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR MTERF6, CHLOROPLASTIC/MITOCHONDRIAL', 244828),
(351889, 'PTHR13068:SF3', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL TRANSCRIPTION TERMINATION FACTOR FAMILY PROTEIN', 244828);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(351890, 'PTHR13068:SF170', NULL, NULL, NULL, NULL, 'BNAC09G13460D PROTEIN', 244828),
(351891, 'PTHR13068:SF9', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR MTERF5, CHLOROPLASTIC', 244828),
(351892, 'PTHR13068:SF208', NULL, NULL, NULL, NULL, 'MITOCHODRIAL TRANSCRIPTION TERMINATION FACTOR-RELATED', 244828),
(351893, 'PTHR13068:SF168', NULL, NULL, NULL, NULL, 'MITOCHODRIAL TRANSCRIPTION TERMINATION FACTOR-RELATED', 244828),
(351894, 'PTHR13068:SF202', NULL, NULL, NULL, NULL, 'OS05G0413000 PROTEIN', 244828),
(351895, 'PTHR13068:SF203', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR 4, MITOCHONDRIAL', 244828),
(351896, 'PTHR13068:SF204', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR FAMILY PROTEIN, PUTATIVE ISOFORM 1-RELATED', 244828),
(351897, 'PTHR13068:SF166', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REGULATOR MTERF FAMILY-RELATED', 244828),
(351898, 'PTHR13068:SF161', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL TRANSCRIPTION TERMINATION FACTOR FAMILY PROTEIN', 244828),
(351899, 'PTHR13068:SF180', NULL, NULL, NULL, NULL, '', 244828),
(351900, 'PTHR13068:SF181', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL TRANSCRIPTION TERMINATION FACTOR FAMILY PROTEIN-RELATED', 244828),
(351901, 'PTHR13068:SF46', NULL, NULL, NULL, NULL, 'OS03G0360600 PROTEIN', 244828),
(351902, 'PTHR13068:SF216', NULL, NULL, NULL, NULL, '', 244828),
(351903, 'PTHR13068:SF217', NULL, NULL, NULL, NULL, 'OS04G0637500 PROTEIN', 244828),
(351904, 'PTHR13068:SF218', NULL, NULL, NULL, NULL, '', 244828),
(351905, 'PTHR13068:SF219', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL TRANSCRIPTION TERMINATION FACTOR FAMILY PROTEIN', 244828),
(351906, 'PTHR13068:SF212', NULL, NULL, NULL, NULL, '', 244828),
(351907, 'PTHR13068:SF179', NULL, NULL, NULL, NULL, 'BNAA09G10490D PROTEIN', 244828),
(351908, 'PTHR13068:SF213', NULL, NULL, NULL, NULL, 'OS07G0423000 PROTEIN', 244828),
(351909, 'PTHR13068:SF214', NULL, NULL, NULL, NULL, '', 244828),
(351910, 'PTHR13068:SF215', NULL, NULL, NULL, NULL, '', 244828),
(351911, 'PTHR13068:SF175', NULL, NULL, NULL, NULL, '', 244828),
(351912, 'PTHR13068:SF177', NULL, NULL, NULL, NULL, 'OS06G0224900 PROTEIN', 244828),
(351913, 'PTHR13068:SF210', NULL, NULL, NULL, NULL, '', 244828),
(351914, 'PTHR13068:SF211', NULL, NULL, NULL, NULL, '', 244828),
(351915, 'PTHR13068:SF171', NULL, NULL, NULL, NULL, '', 244828),
(351916, 'PTHR13068:SF172', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR FAMILY PROTEIN', 244828),
(351917, 'PTHR13068:SF173', NULL, NULL, NULL, NULL, 'EMB|CAB62602.1', 244828),
(351918, 'PTHR13068:SF174', NULL, NULL, NULL, NULL, '', 244828),
(351919, 'PTHR13068:SF36', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR MTEF1, CHLOROPLASTIC', 244828),
(351920, 'PTHR13068:SF35', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL TRANSCRIPTION TERMINATION FACTOR FAMILY PROTEIN', 244828),
(351921, 'PTHR13068:SF31', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR MTERF15, MITOCHONDRIAL-LIKE', 244828),
(351922, 'PTHR13068:SF148', NULL, NULL, NULL, NULL, '', 244828),
(351923, 'PTHR13068:SF38', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR FAMILY PROTEIN', 244828),
(351924, 'PTHR13068:SF149', NULL, NULL, NULL, NULL, '', 244828),
(351925, 'PTHR13068:SF39', NULL, NULL, NULL, NULL, '', 244828),
(351926, 'PTHR13068:SF142', NULL, NULL, NULL, NULL, '', 244828),
(351927, 'PTHR13068:SF143', NULL, NULL, NULL, NULL, '', 244828),
(351928, 'PTHR13068:SF144', NULL, NULL, NULL, NULL, 'OS02G0749900 PROTEIN', 244828),
(351929, 'PTHR13068:SF140', NULL, NULL, NULL, NULL, '', 244828),
(351930, 'PTHR13068:SF141', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL TRANSCRIPTION TERMINATION FACTOR FAMILY PROTEIN', 244828),
(351931, 'PTHR13068:SF23', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR MTERF15, MITOCHONDRIAL', 244828),
(351932, 'PTHR13068:SF24', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244828),
(351933, 'PTHR13068:SF157', NULL, NULL, NULL, NULL, 'BNAA10G09910D PROTEIN', 244828),
(351934, 'PTHR13068:SF158', NULL, NULL, NULL, NULL, 'BNAA03G59750D PROTEIN', 244828),
(351935, 'PTHR13068:SF159', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL TRANSCRIPTION TERMINATION FACTOR FAMILY PROTEIN', 244828);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(351936, 'PTHR13068:SF153', NULL, NULL, NULL, NULL, '', 244828),
(351937, 'PTHR13068:SF155', NULL, NULL, NULL, NULL, 'BNAA01G22940D PROTEIN', 244828),
(351938, 'PTHR13068:SF150', NULL, NULL, NULL, NULL, 'BNAC01G30030D PROTEIN', 244828),
(351939, 'PTHR13068:SF151', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR MTERF9, CHLOROPLASTIC', 244828),
(351940, 'PTHR13068', NULL, NULL, NULL, NULL, 'CGI-12 PROTEIN-RELATED', 244828),
(351941, 'PTHR12537:SF129', NULL, NULL, NULL, NULL, 'PUMILIO HOMOLOG 8, CHLOROPLASTIC-RELATED', 244829),
(351942, 'PTHR12537:SF128', NULL, NULL, NULL, NULL, 'PUMILIO HOMOLOG 1-RELATED', 244829),
(351943, 'PTHR12537:SF127', NULL, NULL, NULL, NULL, 'PUMILIO HOMOLOG 3', 244829),
(351944, 'PTHR12537:SF126', NULL, NULL, NULL, NULL, 'PUM-HD DOMAIN-CONTAINING PROTEIN', 244829),
(351945, 'PTHR12537:SF169', NULL, NULL, NULL, NULL, 'PUMILIO HOMOLOG 8, CHLOROPLASTIC-RELATED', 244829),
(351946, 'PTHR12537:SF124', NULL, NULL, NULL, NULL, 'PUM-HD DOMAIN-CONTAINING PROTEIN', 244829),
(351947, 'PTHR12537:SF168', NULL, NULL, NULL, NULL, 'PUM-HD DOMAIN-CONTAINING PROTEIN', 244829),
(351948, 'PTHR12537:SF123', NULL, NULL, NULL, NULL, 'PUM-HD DOMAIN-CONTAINING PROTEIN', 244829),
(351949, 'PTHR12537:SF122', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN, PUTATIVE-RELATED', 244829),
(351950, 'PTHR12537:SF166', NULL, NULL, NULL, NULL, 'PUMILIO HOMOLOG 18-RELATED', 244829),
(351951, 'PTHR12537:SF121', NULL, NULL, NULL, NULL, 'PUMILIO HOMOLOG 5', 244829),
(351952, 'PTHR12537:SF165', NULL, NULL, NULL, NULL, 'PUM-HD DOMAIN-CONTAINING PROTEIN', 244829),
(351953, 'PTHR12537:SF164', NULL, NULL, NULL, NULL, 'PUM-HD DOMAIN-CONTAINING PROTEIN', 244829),
(351954, 'PTHR12537:SF163', NULL, NULL, NULL, NULL, 'OS03G0191700 PROTEIN', 244829),
(351955, 'PTHR12537:SF161', NULL, NULL, NULL, NULL, 'PUM-HD DOMAIN-CONTAINING PROTEIN', 244829),
(351956, 'PTHR12537:SF26', NULL, NULL, NULL, NULL, 'PUMILIO DOMAIN-CONTAINING PROTEIN 5-RELATED', 244829),
(351957, 'PTHR12537:SF63', NULL, NULL, NULL, NULL, 'PUMILIO HOMOLOG 15', 244829),
(351958, 'PTHR12537:SF80', NULL, NULL, NULL, NULL, 'SUPPRESSOR PROTEIN MPT5', 244829),
(351959, 'PTHR12537:SF138', NULL, NULL, NULL, NULL, 'PUMILIO HOMOLOG 7, CHLOROPLASTIC-RELATED', 244829),
(351960, 'PTHR12537:SF137', NULL, NULL, NULL, NULL, 'PUMILIO HOMOLOG 16-RELATED', 244829),
(351961, 'PTHR12537:SF136', NULL, NULL, NULL, NULL, 'PUMILIO HOMOLOG 9-RELATED', 244829),
(351962, 'PTHR12537:SF135', NULL, NULL, NULL, NULL, 'PUM-HD DOMAIN-CONTAINING PROTEIN', 244829),
(351963, 'PTHR12537:SF134', NULL, NULL, NULL, NULL, 'PUMILIO HOMOLOG 12', 244829),
(351964, 'PTHR12537:SF133', NULL, NULL, NULL, NULL, 'OS03G0193150 PROTEIN', 244829),
(351965, 'PTHR12537:SF176', NULL, NULL, NULL, NULL, 'PUM-HD DOMAIN-CONTAINING PROTEIN', 244829),
(351966, 'PTHR12537:SF131', NULL, NULL, NULL, NULL, 'PUMILIO HOMOLOG 11', 244829),
(351967, 'PTHR12537:SF174', NULL, NULL, NULL, NULL, 'ARMADILLO-LIKE HELICAL, NUCLEIC ACID BINDING NABP, ARMADILLO-TYPE FOLD PROTEIN-RELATED', 244829),
(351968, 'PTHR12537:SF173', NULL, NULL, NULL, NULL, 'PUMILIO HOMOLOG 26-RELATED', 244829),
(351969, 'PTHR12537:SF172', NULL, NULL, NULL, NULL, 'PUM-HD DOMAIN-CONTAINING PROTEIN', 244829),
(351970, 'PTHR12537:SF171', NULL, NULL, NULL, NULL, 'PUM-HD DOMAIN-CONTAINING PROTEIN', 244829),
(351971, 'PTHR12537:SF170', NULL, NULL, NULL, NULL, 'PUM-HD DOMAIN-CONTAINING PROTEIN', 244829),
(351972, 'PTHR12537:SF50', NULL, NULL, NULL, NULL, 'RNA BINDING PROTEIN, PUTATIVE-RELATED', 244829),
(351973, 'PTHR12537:SF149', NULL, NULL, NULL, NULL, 'PUM-HD DOMAIN-CONTAINING PROTEIN', 244829),
(351974, 'PTHR12537:SF148', NULL, NULL, NULL, NULL, 'ARMADILLO-TYPE FOLD PROTEIN-RELATED', 244829),
(351975, 'PTHR12537:SF147', NULL, NULL, NULL, NULL, 'PUMILIO HOMOLOG 12', 244829),
(351976, 'PTHR12537:SF146', NULL, NULL, NULL, NULL, 'PUM-HD DOMAIN-CONTAINING PROTEIN', 244829),
(351977, 'PTHR12537:SF145', NULL, NULL, NULL, NULL, 'PUM-HD DOMAIN-CONTAINING PROTEIN', 244829),
(351978, 'PTHR12537:SF189', NULL, NULL, NULL, NULL, 'MEIOTIC PUF FAMILY PROTEIN 1', 244829);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(351979, 'PTHR12537:SF188', NULL, NULL, NULL, NULL, 'PUMILIO DOMAIN-CONTAINING PROTEIN C4G8.03C', 244829),
(351980, 'PTHR12537:SF144', NULL, NULL, NULL, NULL, 'PUM-HD DOMAIN-CONTAINING PROTEIN', 244829),
(351981, 'PTHR12537:SF187', NULL, NULL, NULL, NULL, 'OS04G0276200 PROTEIN', 244829),
(351982, 'PTHR12537:SF186', NULL, NULL, NULL, NULL, 'PUMILIO HOMOLOG 14-RELATED', 244829),
(351983, 'PTHR12537:SF185', NULL, NULL, NULL, NULL, 'PUM-HD DOMAIN-CONTAINING PROTEIN', 244829),
(351984, 'PTHR12537:SF184', NULL, NULL, NULL, NULL, 'PUM-HD DOMAIN-CONTAINING PROTEIN', 244829),
(351985, 'PTHR12537:SF183', NULL, NULL, NULL, NULL, 'RNA BINDING PROTEIN, PUTATIVE-RELATED', 244829),
(351986, 'PTHR12537:SF48', NULL, NULL, NULL, NULL, 'MEIOTIC COILED-COIL PROTEIN 2', 244829),
(351987, 'PTHR12537:SF180', NULL, NULL, NULL, NULL, 'ARMADILLO-TYPE FOLD PROTEIN-RELATED', 244829),
(351988, 'PTHR12537:SF62', NULL, NULL, NULL, NULL, 'PUMILIO HOMOLOG 3', 244829),
(351989, 'PTHR12537:SF60', NULL, NULL, NULL, NULL, 'PUM-HD DOMAIN-CONTAINING PROTEIN', 244829),
(351990, 'PTHR12537:SF119', NULL, NULL, NULL, NULL, 'PUMILIO HOMOLOG 6, CHLOROPLASTIC', 244829),
(351991, 'PTHR12537:SF158', NULL, NULL, NULL, NULL, 'PUM-HD DOMAIN-CONTAINING PROTEIN', 244829),
(351992, 'PTHR12537:SF157', NULL, NULL, NULL, NULL, 'PUM-HD DOMAIN-CONTAINING PROTEIN', 244829),
(351993, 'PTHR12537:SF112', NULL, NULL, NULL, NULL, 'FEM-3 MRNA-BINDING FACTOR 1-RELATED', 244829),
(351994, 'PTHR12537:SF156', NULL, NULL, NULL, NULL, 'PUM-HD DOMAIN-CONTAINING PROTEIN', 244829),
(351995, 'PTHR12537:SF154', NULL, NULL, NULL, NULL, 'OS01G0971900 PROTEIN', 244829),
(351996, 'PTHR12537:SF1', NULL, NULL, NULL, NULL, 'PUMILIO HOMOLOG 1', 244829),
(351997, 'PTHR12537:SF152', NULL, NULL, NULL, NULL, 'PUM-HD DOMAIN-CONTAINING PROTEIN', 244829),
(351998, 'PTHR12537:SF150', NULL, NULL, NULL, NULL, 'PUM-HD DOMAIN-CONTAINING PROTEIN', 244829),
(351999, 'PTHR12537', NULL, NULL, NULL, NULL, 'RNA BINDING PROTEIN PUMILIO-RELATED', 244829),
(352000, 'PTHR12537:SF193', NULL, NULL, NULL, NULL, 'ARMADILLO-TYPE FOLD PROTEIN-RELATED', 244829),
(352001, 'PTHR12537:SF59', NULL, NULL, NULL, NULL, 'RNA BINDING PROTEIN 5, PUTATIVE-RELATED', 244829),
(352002, 'PTHR12537:SF192', NULL, NULL, NULL, NULL, 'OS12G0488900 PROTEIN', 244829),
(352003, 'PTHR12537:SF191', NULL, NULL, NULL, NULL, 'PUM-HD DOMAIN-CONTAINING PROTEIN', 244829),
(352004, 'PTHR12537:SF13', NULL, NULL, NULL, NULL, 'PUMILIO HOMOLOGY DOMAIN FAMILY MEMBER 4', 244829),
(352005, 'PTHR12537:SF190', NULL, NULL, NULL, NULL, 'RNA BINDING PROTEIN, PUTATIVE-RELATED', 244829),
(352006, 'PTHR12537:SF12', NULL, NULL, NULL, NULL, 'MATERNAL PROTEIN PUMILIO', 244829),
(352007, 'PTHR12537:SF52', NULL, NULL, NULL, NULL, 'PUMILIO HOMOLOG 2', 244829),
(352008, 'PTHR31345', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN Q', 244830),
(352009, 'PTHR31345:SF3', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN Q', 244830),
(352010, 'PTHR31838:SF1', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 55 KDA', 244831),
(352011, 'PTHR31838', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 55 KDA', 244831),
(352012, 'PTHR34957:SF9', NULL, NULL, NULL, NULL, 'SNOAL-LIKE DOMAIN-CONTAINING PROTEIN', 244832),
(352013, 'PTHR34957', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSPORT FACTOR 2 (NTF2) FAMILY PROTEIN', 244832),
(352014, 'PTHR34957:SF1', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSPORT FACTOR 2 (NTF2) FAMILY PROTEIN', 244832),
(352015, 'PTHR34957:SF10', NULL, NULL, NULL, NULL, '', 244832),
(352016, 'PTHR34957:SF7', NULL, NULL, NULL, NULL, '', 244832),
(352017, 'PTHR34957:SF6', NULL, NULL, NULL, NULL, 'DNA BINDING PROTEIN', 244832),
(352018, 'PTHR36956:SF2', NULL, NULL, NULL, NULL, 'UTERINE LUMIN EXPRESSED/LOCAILIZED', 244833),
(352019, 'PTHR36956', NULL, NULL, NULL, NULL, 'UTERINE LUMIN EXPRESSED/LOCAILIZED-RELATED', 244833),
(352020, 'PTHR36956:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG27982', 244833),
(352021, 'PTHR42081', NULL, NULL, NULL, NULL, '', 244834),
(352022, 'PTHR42081:SF1', NULL, NULL, NULL, NULL, '', 244834),
(352023, 'PTHR34106:SF5', NULL, NULL, NULL, NULL, 'GLYCOSIDASE', 244835);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(352024, 'PTHR34106', NULL, NULL, NULL, NULL, 'GLYCOSIDASE', 244835),
(352025, 'PTHR34106:SF6', NULL, NULL, NULL, NULL, '', 244835),
(352026, 'PTHR34106:SF4', NULL, NULL, NULL, NULL, 'BLL5143 PROTEIN', 244835),
(352027, 'PTHR34106:SF1', NULL, NULL, NULL, NULL, '1,4-BETA-MANNOSYL-N-ACETYLGLUCOSAMINE PHOSPHORYLASE', 244835),
(352028, 'PTHR13703:SF63', NULL, NULL, NULL, NULL, 'MOTHERS AGAINST DECAPENTAPLEGIC HOMOLOG 4', 244836),
(352029, 'PTHR13703:SF41', NULL, NULL, NULL, NULL, 'MOTHERS AGAINST DECAPENTAPLEGIC HOMOLOG 9', 244836),
(352030, 'PTHR13703:SF64', NULL, NULL, NULL, NULL, 'MOTHERS AGAINST DECAPENTAPLEGIC HOMOLOG', 244836),
(352031, 'PTHR13703:SF53', NULL, NULL, NULL, NULL, 'MOTHERS AGAINST DECAPENTAPLEGIC HOMOLOG 3', 244836),
(352032, 'PTHR13703:SF42', NULL, NULL, NULL, NULL, 'MOTHERS AGAINST DECAPENTAPLEGIC HOMOLOG 2', 244836),
(352033, 'PTHR13703:SF65', NULL, NULL, NULL, NULL, 'DWARFIN SMA-3', 244836),
(352034, 'PTHR13703:SF54', NULL, NULL, NULL, NULL, 'MOTHERS AGAINST DECAPENTAPLEGIC HOMOLOG', 244836),
(352035, 'PTHR13703:SF66', NULL, NULL, NULL, NULL, 'MOTHERS AGAINST DECAPENTAPLEGIC HOMOLOG', 244836),
(352036, 'PTHR13703:SF44', NULL, NULL, NULL, NULL, 'MOTHERS AGAINST DECAPENTAPLEGIC HOMOLOG 7', 244836),
(352037, 'PTHR13703:SF23', NULL, NULL, NULL, NULL, 'MOTHERS AGAINST DECAPENTAPLEGIC HOMOLOG 1', 244836),
(352038, 'PTHR13703:SF45', NULL, NULL, NULL, NULL, 'MOTHERS AGAINST DECAPENTAPLEGIC HOMOLOG', 244836),
(352039, 'PTHR13703:SF34', NULL, NULL, NULL, NULL, 'MOTHERS AGAINST DECAPENTAPLEGIC HOMOLOG', 244836),
(352040, 'PTHR13703:SF25', NULL, NULL, NULL, NULL, 'MOTHERS AGAINST DECAPENTAPLEGIC HOMOLOG', 244836),
(352041, 'PTHR13703:SF36', NULL, NULL, NULL, NULL, 'MOTHERS AGAINST DECAPENTAPLEGIC HOMOLOG 5', 244836),
(352042, 'PTHR13703:SF28', NULL, NULL, NULL, NULL, 'MOTHERS AGAINST DECAPENTAPLEGIC HOMOLOG 6', 244836),
(352043, 'PTHR13703', NULL, NULL, NULL, NULL, 'SMAD', 244836),
(352044, 'PTHR13703:SF61', NULL, NULL, NULL, NULL, 'PROTEIN MOTHERS AGAINST DPP', 244836),
(352045, 'PTHR13703:SF62', NULL, NULL, NULL, NULL, 'SMAD PROTEIN DAF-3', 244836),
(352046, 'PTHR45700', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE E3C', 244837),
(352047, 'PTHR45700:SF2', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE E3C', 244837),
(352048, 'PTHR45700:SF3', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE E3B', 244837),
(352049, 'PTHR45700:SF6', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE UPL6', 244837),
(352050, 'PTHR45700:SF8', NULL, NULL, NULL, NULL, 'LIGASE, PUTATIVE-RELATED', 244837),
(352051, 'PTHR45700:SF7', NULL, NULL, NULL, NULL, 'HECT-TYPE E3 UBIQUITIN TRANSFERASE', 244837),
(352052, 'PTHR48144:SF1', NULL, NULL, NULL, NULL, 'DNA-DIRECTED DNA POLYMERASE', 244838),
(352053, 'PTHR48144', NULL, NULL, NULL, NULL, 'DNA-DIRECTED DNA POLYMERASE', 244838),
(352054, 'PTHR23050:SF524', NULL, NULL, NULL, NULL, 'EF HAND FAMILY PROTEIN', 244839),
(352055, 'PTHR23050:SF525', NULL, NULL, NULL, NULL, 'EF-HAND SUPERFAMILY CA2+-MODULATED PROTEIN (AFU_ORTHOLOGUE AFUA_5G13630)', 244839),
(352056, 'PTHR23050:SF522', NULL, NULL, NULL, NULL, 'CALMODULIN', 244839),
(352057, 'PTHR23050:SF489', NULL, NULL, NULL, NULL, 'CALMODULIN-RELATED PROTEIN-RELATED', 244839),
(352058, 'PTHR23050:SF523', NULL, NULL, NULL, NULL, 'CALMODULIN', 244839),
(352059, 'PTHR23050:SF402', NULL, NULL, NULL, NULL, 'OS02G0198200 PROTEIN', 244839),
(352060, 'PTHR23050:SF487', NULL, NULL, NULL, NULL, 'CALMODULIN-LIKE PROTEIN 9', 244839),
(352061, 'PTHR23050:SF520', NULL, NULL, NULL, NULL, 'CALMODULIN-LIKE PROTEIN 8', 244839),
(352062, 'PTHR23050:SF400', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML18-RELATED', 244839),
(352063, 'PTHR23050:SF521', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN PAIR-RELATED', 244839),
(352064, 'PTHR23050:SF488', NULL, NULL, NULL, NULL, 'ION BINDING PROTEIN, PUTATIVE-RELATED', 244839),
(352065, 'PTHR23050:SF367', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 244839),
(352066, 'PTHR23050:SF485', NULL, NULL, NULL, NULL, 'CALMODULIN RELATED GENES', 244839),
(352067, 'PTHR23050:SF486', NULL, NULL, NULL, NULL, 'OS09G0458900 PROTEIN', 244839);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(352068, 'PTHR23050:SF244', NULL, NULL, NULL, NULL, 'TROPONIN C, ISOFORM 2-RELATED', 244839),
(352069, 'PTHR23050:SF373', NULL, NULL, NULL, NULL, 'CALMODULIN-LIKE PROTEIN 3', 244839),
(352070, 'PTHR23050:SF494', NULL, NULL, NULL, NULL, 'PROTEIN CBG14543', 244839),
(352071, 'PTHR23050:SF374', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML19-RELATED', 244839),
(352072, 'PTHR23050:SF495', NULL, NULL, NULL, NULL, 'CALMODULIN-1', 244839),
(352073, 'PTHR23050:SF492', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 244839),
(352074, 'PTHR23050:SF130', NULL, NULL, NULL, NULL, 'CALMODULIN RELATED GENES', 244839),
(352075, 'PTHR23050:SF493', NULL, NULL, NULL, NULL, 'EF-HAND PAIR PROTEIN', 244839),
(352076, 'PTHR23050:SF490', NULL, NULL, NULL, NULL, 'CALMODULIN-3', 244839),
(352077, 'PTHR23050:SF491', NULL, NULL, NULL, NULL, 'CALMODULIN-7', 244839),
(352078, 'PTHR23050:SF519', NULL, NULL, NULL, NULL, 'CENTRIN, EF-HAND PROTEIN, 2', 244839),
(352079, 'PTHR23050:SF517', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML19-RELATED', 244839),
(352080, 'PTHR23050:SF518', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN E63-1', 244839),
(352081, 'PTHR23050:SF515', NULL, NULL, NULL, NULL, 'EF HAND CALCIUM-BINDING FAMILY PROTEIN', 244839),
(352082, 'PTHR23050:SF516', NULL, NULL, NULL, NULL, 'POLCALCIN NIC T 1', 244839),
(352083, 'PTHR23050:SF513', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 244839),
(352084, 'PTHR23050:SF359', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 244839),
(352085, 'PTHR23050:SF514', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML13-RELATED', 244839),
(352086, 'PTHR23050:SF478', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML15-RELATED', 244839),
(352087, 'PTHR23050:SF511', NULL, NULL, NULL, NULL, 'EF HAND CALCIUM-BINDING FAMILY PROTEIN', 244839),
(352088, 'PTHR23050:SF512', NULL, NULL, NULL, NULL, 'CALMODULIN-7', 244839),
(352089, 'PTHR23050:SF479', NULL, NULL, NULL, NULL, 'CALMODULIN', 244839),
(352090, 'PTHR23050:SF476', NULL, NULL, NULL, NULL, 'CALMODULIN-LIKE PROTEIN', 244839),
(352091, 'PTHR23050:SF510', NULL, NULL, NULL, NULL, 'CALMODULIN-1', 244839),
(352092, 'PTHR23050:SF354', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING DOMAIN-CONTAINING PROTEIN 11', 244839),
(352093, 'PTHR23050:SF483', NULL, NULL, NULL, NULL, 'CALMODULIN-LIKE PROTEIN 12', 244839),
(352094, 'PTHR23050:SF363', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML11-RELATED', 244839),
(352095, 'PTHR23050:SF484', NULL, NULL, NULL, NULL, '', 244839),
(352096, 'PTHR23050:SF481', NULL, NULL, NULL, NULL, 'CALMODULIN-2-RELATED', 244839),
(352097, 'PTHR23050:SF482', NULL, NULL, NULL, NULL, 'CALMODULIN-RELATED', 244839),
(352098, 'PTHR23050:SF480', NULL, NULL, NULL, NULL, 'CALMODULIN-3', 244839),
(352099, 'PTHR23050:SF429', NULL, NULL, NULL, NULL, 'BNACNNG44220D PROTEIN', 244839),
(352100, 'PTHR23050:SF309', NULL, NULL, NULL, NULL, 'PROTEIN CBG00175', 244839),
(352101, 'PTHR23050:SF427', NULL, NULL, NULL, NULL, 'CALMODULIN-3', 244839),
(352102, 'PTHR23050:SF428', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML19-RELATED', 244839),
(352103, 'PTHR23050:SF425', NULL, NULL, NULL, NULL, '', 244839),
(352104, 'PTHR23050:SF305', NULL, NULL, NULL, NULL, 'CENTRIN-2', 244839),
(352105, 'PTHR23050:SF421', NULL, NULL, NULL, NULL, 'BNAA06G12660D PROTEIN', 244839),
(352106, 'PTHR23050:SF389', NULL, NULL, NULL, NULL, 'CALMODULIN-LIKE PROTEIN 3', 244839),
(352107, 'PTHR23050:SF386', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML19-RELATED', 244839),
(352108, 'PTHR23050:SF420', NULL, NULL, NULL, NULL, 'CALMODULIN', 244839),
(352109, 'PTHR23050:SF23', NULL, NULL, NULL, NULL, 'AT22559P', 244839),
(352110, 'PTHR23050:SF393', NULL, NULL, NULL, NULL, 'CALMODULIN', 244839),
(352111, 'PTHR23050:SF394', NULL, NULL, NULL, NULL, 'CALMODULIN-LIKE PROTEIN 11', 244839),
(352112, 'PTHR23050:SF391', NULL, NULL, NULL, NULL, '', 244839),
(352113, 'PTHR23050:SF392', NULL, NULL, NULL, NULL, 'CALMODULIN RELATED GENES', 244839),
(352114, 'PTHR23050', NULL, NULL, NULL, NULL, 'CALCIUM BINDING PROTEIN', 244839),
(352115, 'PTHR23050:SF390', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML41-RELATED', 244839);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(352116, 'PTHR23050:SF418', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 244839),
(352117, 'PTHR23050:SF417', NULL, NULL, NULL, NULL, 'CALMODULIN-LIKE PROTEIN 6', 244839),
(352118, 'PTHR23050:SF415', NULL, NULL, NULL, NULL, 'BNAA06G15720D PROTEIN', 244839),
(352119, 'PTHR23050:SF498', NULL, NULL, NULL, NULL, 'CALMODULIN-LIKE PROTEIN 10', 244839),
(352120, 'PTHR23050:SF378', NULL, NULL, NULL, NULL, 'CALMODULIN-LIKE PROTEIN 11', 244839),
(352121, 'PTHR23050:SF499', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF-HAND DOMAIN-CONTAINING PROTEIN', 244839),
(352122, 'PTHR23050:SF375', NULL, NULL, NULL, NULL, '', 244839),
(352123, 'PTHR23050:SF496', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 244839),
(352124, 'PTHR23050:SF497', NULL, NULL, NULL, NULL, 'EF HAND FAMILY PROTEIN', 244839),
(352125, 'PTHR23050:SF385', NULL, NULL, NULL, NULL, 'CALMODULIN-7', 244839),
(352126, 'PTHR23050:SF382', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML25-RELATED', 244839),
(352127, 'PTHR23050:SF383', NULL, NULL, NULL, NULL, 'CALMODULIN-2', 244839),
(352128, 'PTHR23050:SF449', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN PAIR-RELATED', 244839),
(352129, 'PTHR23050:SF329', NULL, NULL, NULL, NULL, '', 244839),
(352130, 'PTHR23050:SF447', NULL, NULL, NULL, NULL, 'BNAA06G33520D PROTEIN', 244839),
(352131, 'PTHR23050:SF446', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 244839),
(352132, 'PTHR23050:SF325', NULL, NULL, NULL, NULL, 'CENTRIN-3', 244839),
(352133, 'PTHR23050:SF443', NULL, NULL, NULL, NULL, 'CALMODULIN-LIKE PROTEIN 8', 244839),
(352134, 'PTHR23050:SF169', NULL, NULL, NULL, NULL, 'CALMODULIN-LIKE PROTEIN 4', 244839),
(352135, 'PTHR23050:SF442', NULL, NULL, NULL, NULL, 'CALMODULIN RELATED GENES', 244839),
(352136, 'PTHR23050:SF437', NULL, NULL, NULL, NULL, 'PROTEIN CBG12886', 244839),
(352137, 'PTHR23050:SF434', NULL, NULL, NULL, NULL, 'CALMODULIN-LIKE PROTEIN', 244839),
(352138, 'PTHR23050:SF399', NULL, NULL, NULL, NULL, 'EF HAND FAMILY PROTEIN, EXPRESSED', 244839),
(352139, 'PTHR23050:SF430', NULL, NULL, NULL, NULL, 'MYOSIN-ID LIGHT CHAIN', 244839),
(352140, 'PTHR23050:SF398', NULL, NULL, NULL, NULL, 'CALTRACTIN-LIKE', 244839),
(352141, 'PTHR23050:SF440', NULL, NULL, NULL, NULL, 'BNAA06G20230D PROTEIN', 244839),
(352142, 'PTHR23050:SF508', NULL, NULL, NULL, NULL, 'AT16150P-RELATED', 244839),
(352143, 'PTHR23050:SF509', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN', 244839),
(352144, 'PTHR23050:SF506', NULL, NULL, NULL, NULL, 'CALMODULIN', 244839),
(352145, 'PTHR23050:SF507', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML13-RELATED', 244839),
(352146, 'PTHR23050:SF504', NULL, NULL, NULL, NULL, '', 244839),
(352147, 'PTHR23050:SF505', NULL, NULL, NULL, NULL, 'CALMODULIN-2', 244839),
(352148, 'PTHR23050:SF227', NULL, NULL, NULL, NULL, 'PARALYSED ARREST AT TWO-FOLD', 244839),
(352149, 'PTHR23050:SF502', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML37', 244839),
(352150, 'PTHR23050:SF469', NULL, NULL, NULL, NULL, '', 244839),
(352151, 'PTHR23050:SF348', NULL, NULL, NULL, NULL, 'GEO07376P1', 244839),
(352152, 'PTHR23050:SF503', NULL, NULL, NULL, NULL, 'CALMODULIN 1', 244839),
(352153, 'PTHR23050:SF500', NULL, NULL, NULL, NULL, 'CENTRIN 4', 244839),
(352154, 'PTHR23050:SF468', NULL, NULL, NULL, NULL, '', 244839),
(352155, 'PTHR23050:SF501', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML16-RELATED', 244839),
(352156, 'PTHR23050:SF224', NULL, NULL, NULL, NULL, 'CALMODULIN-LIKE PROTEIN 5', 244839),
(352157, 'PTHR23050:SF221', NULL, NULL, NULL, NULL, 'FI07231P-RELATED', 244839),
(352158, 'PTHR23050:SF351', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML15-RELATED', 244839),
(352159, 'PTHR23050:SF472', NULL, NULL, NULL, NULL, 'RE52086P', 244839),
(352160, 'PTHR23050:SF471', NULL, NULL, NULL, NULL, '', 244839),
(352161, 'PTHR23050:SF350', NULL, NULL, NULL, NULL, 'CENTRIN-4', 244839),
(352162, 'PTHR23050:SF218', NULL, NULL, NULL, NULL, 'CENTRIN-1', 244839),
(352163, 'PTHR23050:SF337', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 244839),
(352164, 'PTHR23050:SF458', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 244839);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(352165, 'PTHR23050:SF214', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML7-RELATED', 244839),
(352166, 'PTHR23050:SF452', NULL, NULL, NULL, NULL, 'GEO07854P1', 244839),
(352167, 'PTHR23050:SF453', NULL, NULL, NULL, NULL, 'CALMODULIN-LIKE PROTEIN 8', 244839),
(352168, 'PTHR23050:SF211', NULL, NULL, NULL, NULL, 'CALMODULIN-LIKE', 244839),
(352169, 'PTHR23050:SF461', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML17-RELATED', 244839),
(352170, 'PTHR46488:SF1', NULL, NULL, NULL, NULL, 'AP-5 COMPLEX SUBUNIT ZETA-1', 244840),
(352171, 'PTHR46488', NULL, NULL, NULL, NULL, 'AP-5 COMPLEX SUBUNIT ZETA-1', 244840),
(352172, 'PTHR14705', NULL, NULL, NULL, NULL, 'CATION CHANNEL SPERM-ASSOCIATED PROTEIN SUBUNIT BETA', 244841),
(352173, 'PTHR14705:SF0', NULL, NULL, NULL, NULL, 'CATION CHANNEL SPERM-ASSOCIATED PROTEIN SUBUNIT BETA', 244841),
(352174, 'PTHR31120:SF6', NULL, NULL, NULL, NULL, 'METALLOPROTEASE TIKI HOMOLOG', 244842),
(352175, 'PTHR31120:SF7', NULL, NULL, NULL, NULL, 'METALLOPROTEASE TIKI1', 244842),
(352176, 'PTHR31120:SF8', NULL, NULL, NULL, NULL, 'METALLOPROTEASE TIKI2', 244842),
(352177, 'PTHR31120', NULL, NULL, NULL, NULL, 'METALLOPROTEASE TIKI', 244842),
(352178, 'PTHR17598', NULL, NULL, NULL, NULL, 'DNA POLYMERASE DELTA SUBUNIT 3', 244843),
(352179, 'PTHR17598:SF13', NULL, NULL, NULL, NULL, 'DNA POLYMERASE DELTA SUBUNIT 3', 244843),
(352180, 'PTHR14716', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 69', 244844),
(352181, 'PTHR14716:SF0', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 69', 244844),
(352182, 'PTHR26312:SF191', NULL, NULL, NULL, NULL, 'TTC5_OB DOMAIN-CONTAINING PROTEIN', 244845),
(352183, 'PTHR26312:SF190', NULL, NULL, NULL, NULL, 'OS05G0447700 PROTEIN', 244845),
(352184, 'PTHR26312:SF78', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244845),
(352185, 'PTHR26312:SF209', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 244845),
(352186, 'PTHR26312', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 5', 244845),
(352187, 'PTHR26312:SF208', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 244845),
(352188, 'PTHR26312:SF207', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 244845),
(352189, 'PTHR26312:SF206', NULL, NULL, NULL, NULL, 'OS02G0684000 PROTEIN', 244845),
(352190, 'PTHR26312:SF205', NULL, NULL, NULL, NULL, 'BNACNNG36200D PROTEIN', 244845),
(352191, 'PTHR26312:SF127', NULL, NULL, NULL, NULL, 'PROTEIN SLOW GREEN 1, CHLOROPLASTIC-LIKE', 244845),
(352192, 'PTHR26312:SF148', NULL, NULL, NULL, NULL, 'BNAC05G00170D PROTEIN', 244845),
(352193, 'PTHR26312:SF126', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 244845),
(352194, 'PTHR26312:SF168', NULL, NULL, NULL, NULL, 'F18B13.21 PROTEIN', 244845),
(352195, 'PTHR26312:SF123', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 244845),
(352196, 'PTHR26312:SF165', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 244845),
(352197, 'PTHR26312:SF186', NULL, NULL, NULL, NULL, 'BNAC05G11110D PROTEIN', 244845),
(352198, 'PTHR26312:SF142', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 244845),
(352199, 'PTHR26312:SF164', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 244845),
(352200, 'PTHR26312:SF182', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 244845),
(352201, 'PTHR26312:SF181', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 244845),
(352202, 'PTHR26312:SF180', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 244845),
(352203, 'PTHR26312:SF67', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 244845),
(352204, 'PTHR26312:SF87', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 5', 244845),
(352205, 'PTHR26312:SF219', NULL, NULL, NULL, NULL, '', 244845),
(352206, 'PTHR26312:SF218', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 244845),
(352207, 'PTHR26312:SF217', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINE TRANSFERASE, OGT PROTEIN, PUTATIVE-RELATED', 244845);
INSERT INTO "PUBLIC"."MODEL" VALUES
(352208, 'PTHR26312:SF216', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN-CONTAINING PROTEIN-RELATED', 244845),
(352209, 'PTHR26312:SF215', NULL, NULL, NULL, NULL, 'TPR REPEAT PROTEIN', 244845),
(352210, 'PTHR26312:SF138', NULL, NULL, NULL, NULL, 'PROTEIN SLOW GREEN 1, CHLOROPLASTIC', 244845),
(352211, 'PTHR26312:SF137', NULL, NULL, NULL, NULL, 'OS05G0182100 PROTEIN', 244845),
(352212, 'PTHR26312:SF214', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN-RELATED', 244845),
(352213, 'PTHR26312:SF213', NULL, NULL, NULL, NULL, 'OS02G0204000 PROTEIN', 244845),
(352214, 'PTHR26312:SF136', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 244845),
(352215, 'PTHR26312:SF212', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 244845),
(352216, 'PTHR26312:SF135', NULL, NULL, NULL, NULL, 'BNAC03G75140D PROTEIN', 244845),
(352217, 'PTHR26312:SF157', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 244845),
(352218, 'PTHR26312:SF211', NULL, NULL, NULL, NULL, '43KDA POSTSYNAPTIC PROTEIN-RELATED', 244845),
(352219, 'PTHR26312:SF210', NULL, NULL, NULL, NULL, 'OS04G0510600 PROTEIN', 244845),
(352220, 'PTHR26312:SF155', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 244845),
(352221, 'PTHR26312:SF177', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT DOMAIN-CONTAINING PROTEIN PYG7, CHLOROPLASTIC', 244845),
(352222, 'PTHR26312:SF176', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 244845),
(352223, 'PTHR26312:SF132', NULL, NULL, NULL, NULL, 'OS01G0855200 PROTEIN', 244845),
(352224, 'PTHR26312:SF153', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244845),
(352225, 'PTHR26312:SF174', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 244845),
(352226, 'PTHR26312:SF152', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 244845),
(352227, 'PTHR26312:SF194', NULL, NULL, NULL, NULL, 'OS01G0506200 PROTEIN', 244845),
(352228, 'PTHR26312:SF172', NULL, NULL, NULL, NULL, 'O-LINKED N-ACETYLGLUCOSAMINE TRANSFERASE, OGT', 244845),
(352229, 'PTHR26312:SF171', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 244845),
(352230, 'PTHR46182', NULL, NULL, NULL, NULL, 'FI19480P1', 244846),
(352231, 'PTHR46182:SF3', NULL, NULL, NULL, NULL, 'DYSLEXIA-ASSOCIATED PROTEIN KIAA0319-LIKE PROTEIN', 244846),
(352232, 'PTHR46182:SF2', NULL, NULL, NULL, NULL, 'FI19480P1', 244846),
(352233, 'PTHR46182:SF1', NULL, NULL, NULL, NULL, 'DYSLEXIA-ASSOCIATED PROTEIN KIAA0319', 244846),
(352234, 'PTHR21648', NULL, NULL, NULL, NULL, 'FLAGELLAR RADIAL SPOKE PROTEIN 3', 244847),
(352235, 'PTHR21648:SF0', NULL, NULL, NULL, NULL, 'RADIAL SPOKE HEAD PROTEIN 3 HOMOLOG', 244847),
(352236, 'PTHR14543:SF1', NULL, NULL, NULL, NULL, 'PROTRUDIN', 244848),
(352237, 'PTHR14543', NULL, NULL, NULL, NULL, 'PROTRUDIN', 244848),
(352238, 'PTHR38489:SF1', NULL, NULL, NULL, NULL, '', 244849),
(352239, 'PTHR38489', NULL, NULL, NULL, NULL, '', 244849),
(352240, 'PTHR30519:SF0', NULL, NULL, NULL, NULL, '5-METHYLTETRAHYDROPTEROYLTRIGLUTAMATE--HOMOCYSTEINE METHYLTRANSFERASE', 244850),
(352241, 'PTHR30519:SF28', NULL, NULL, NULL, NULL, '5-METHYLTETRAHYDROPTEROYLTRIGLUTAMATE--HOMOCYSTEINE S-METHYLTRANSFERASE', 244850),
(352242, 'PTHR30519:SF27', NULL, NULL, NULL, NULL, '5-METHYLTETRAHYDROPTEROYLTRIGLUTAMATE--HOMOCYSTEINE METHYLTRANSFERASE 2', 244850),
(352243, 'PTHR30519:SF26', NULL, NULL, NULL, NULL, '5-METHYLTETRAHYDROPTEROYLTRIGLUTAMATE--HOMOCYSTEINE S-METHYLTRANSFERASE', 244850),
(352244, 'PTHR30519:SF25', NULL, NULL, NULL, NULL, '5-METHYLTETRAHYDROPTEROYLTRIGLUTAMATE--HOMOCYSTEINE METHYLTRANSFERASE 3, CHLOROPLASTIC', 244850),
(352245, 'PTHR30519', NULL, NULL, NULL, NULL, '5-METHYLTETRAHYDROPTEROYLTRIGLUTAMATE--HOMOCYSTEINE METHYLTRANSFERASE', 244850),
(352246, 'PTHR30519:SF24', NULL, NULL, NULL, NULL, '5-METHYLTETRAHYDROPTEROYLTRIGLUTAMATE--HOMOCYSTEINE METHYLTRANSFERASE 1', 244850),
(352247, 'PTHR30519:SF22', NULL, NULL, NULL, NULL, '5-METHYLTETRAHYDROPTEROYLTRIGLUTAMATE--HOMOCYSTEINE METHYLTRANSFERASE 1', 244850);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(352248, 'PTHR47624:SF1', NULL, NULL, NULL, NULL, 'OS01G0204900 PROTEIN', 244851),
(352249, 'PTHR47624', NULL, NULL, NULL, NULL, 'OS01G0204900 PROTEIN', 244851),
(352250, 'PTHR10867', NULL, NULL, NULL, NULL, 'NNMT/PNMT/TEMT FAMILY MEMBER', 244852),
(352251, 'PTHR10867:SF40', NULL, NULL, NULL, NULL, 'NICOTINAMIDE N-METHYLTRANSFERASE-LIKE', 244852),
(352252, 'PTHR10867:SF18', NULL, NULL, NULL, NULL, 'PHENYLETHANOLAMINE N-METHYLTRANSFERASE', 244852),
(352253, 'PTHR10867:SF39', NULL, NULL, NULL, NULL, 'AMINE N-METHYLTRANSFERASE', 244852),
(352254, 'PTHR10867:SF17', NULL, NULL, NULL, NULL, 'NICOTINAMIDE N-METHYLTRANSFERASE', 244852),
(352255, 'PTHR10867:SF38', NULL, NULL, NULL, NULL, 'AMINE N-METHYLTRANSFERASE', 244852),
(352256, 'PTHR10867:SF33', NULL, NULL, NULL, NULL, 'INDOLETHYLAMINE N-METHYLTRANSFERASE', 244852),
(352257, 'PTHR10867:SF32', NULL, NULL, NULL, NULL, 'NICOTINAMIDE N-METHYLTRANSFERASE', 244852),
(352258, 'PTHR43654', NULL, NULL, NULL, NULL, 'GLUTAMATE 5-KINASE', 244853),
(352259, 'PTHR43654:SF1', NULL, NULL, NULL, NULL, 'ISOPENTENYL PHOSPHATE KINASE', 244853),
(352260, 'PTHR43654:SF3', NULL, NULL, NULL, NULL, 'GLUTAMATE 5-KINASE', 244853),
(352261, 'PTHR11772:SF16', NULL, NULL, NULL, NULL, 'ASPARAGINE SYNTHETASE [GLUTAMINE-HYDROLYZING] 1', 244854),
(352262, 'PTHR11772:SF38', NULL, NULL, NULL, NULL, 'ASPARAGINE SYNTHETASE [GLUTAMINE-HYDROLYZING] 3', 244854),
(352263, 'PTHR11772:SF39', NULL, NULL, NULL, NULL, 'GLUTAMINE AMIDOTRANSFERASE TYPE-2 DOMAIN-CONTAINING PROTEIN', 244854),
(352264, 'PTHR11772:SF17', NULL, NULL, NULL, NULL, 'ASPARAGINE SYNTHETASE (EUROFUNG)', 244854),
(352265, 'PTHR11772:SF36', NULL, NULL, NULL, NULL, 'ASPARAGINE SYNTHETASE [GLUTAMINE-HYDROLYZING]', 244854),
(352266, 'PTHR11772:SF47', NULL, NULL, NULL, NULL, 'ASPARAGINE SYNTHETASE [GLUTAMINE-HYDROLYZING]', 244854),
(352267, 'PTHR11772:SF37', NULL, NULL, NULL, NULL, 'ASPARAGINE SYNTHETASE [GLUTAMINE-HYDROLYZING]', 244854),
(352268, 'PTHR11772:SF48', NULL, NULL, NULL, NULL, 'ASPARAGINE SYNTHETASE [GLUTAMINE-HYDROLYZING] 1', 244854),
(352269, 'PTHR11772:SF45', NULL, NULL, NULL, NULL, 'ASPARAGINE SYNTHETASE [GLUTAMINE-HYDROLYZING]', 244854),
(352270, 'PTHR11772:SF23', NULL, NULL, NULL, NULL, 'ASPARAGINE SYNTHETASE [GLUTAMINE-HYDROLYZING]', 244854),
(352271, 'PTHR11772:SF35', NULL, NULL, NULL, NULL, 'ASPARAGINE SYNTHETASE [GLUTAMINE-HYDROLYZING]', 244854),
(352272, 'PTHR11772:SF46', NULL, NULL, NULL, NULL, 'ASPARAGINE SYNTHETASE DOMAIN-CONTAINING PROTEIN', 244854),
(352273, 'PTHR11772:SF42', NULL, NULL, NULL, NULL, 'ASPARAGINE SYNTHETASE [GLUTAMINE-HYDROLYZING]', 244854),
(352274, 'PTHR11772', NULL, NULL, NULL, NULL, 'ASPARAGINE SYNTHETASE', 244854),
(352275, 'PTHR11772:SF2', NULL, NULL, NULL, NULL, 'ASPARAGINE SYNTHETASE [GLUTAMINE-HYDROLYZING]', 244854),
(352276, 'PTHR35463:SF11', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 244855),
(352277, 'PTHR35463:SF12', NULL, NULL, NULL, NULL, 'BNAANNG13040D PROTEIN', 244855),
(352278, 'PTHR35463:SF8', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244855),
(352279, 'PTHR35463:SF10', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 244855),
(352280, 'PTHR35463', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 244855),
(352281, 'PTHR10742:SF408', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 244856),
(352282, 'PTHR10742:SF407', NULL, NULL, NULL, NULL, 'AMINO_OXIDASE DOMAIN-CONTAINING PROTEIN', 244856),
(352283, 'PTHR10742:SF406', NULL, NULL, NULL, NULL, 'BNAC04G48640D PROTEIN', 244856),
(352284, 'PTHR10742:SF405', NULL, NULL, NULL, NULL, 'PEROXISOMAL N(1)-ACETYL-SPERMINE/SPERMIDINE OXIDASE', 244856),
(352285, 'PTHR10742:SF228', NULL, NULL, NULL, NULL, 'POLYAMINE OXIDASE 4-RELATED', 244856),
(352286, 'PTHR10742:SF404', NULL, NULL, NULL, NULL, 'POLYAMINE OXIDASE FMS1', 244856),
(352287, 'PTHR10742:SF368', NULL, NULL, NULL, NULL, 'POLYAMINE OXIDASE 1', 244856),
(352288, 'PTHR10742:SF409', NULL, NULL, NULL, NULL, 'SWIRM DOMAIN-CONTAINING PROTEIN', 244856),
(352289, 'PTHR10742:SF260', NULL, NULL, NULL, NULL, 'PROTEIN FLOWERING LOCUS D', 244856),
(352290, 'PTHR10742:SF381', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC HISTONE DEMETHYLASE 1 HOMOLOG 1', 244856);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(352291, 'PTHR10742:SF380', NULL, NULL, NULL, NULL, 'AMINO_OXIDASE DOMAIN-CONTAINING PROTEIN', 244856),
(352292, 'PTHR10742:SF21', NULL, NULL, NULL, NULL, 'L-AMINO-ACID OXIDASE', 244856),
(352293, 'PTHR10742', NULL, NULL, NULL, NULL, 'FLAVIN MONOAMINE OXIDASE', 244856),
(352294, 'PTHR10742:SF389', NULL, NULL, NULL, NULL, 'SWIRM DOMAIN-CONTAINING PROTEIN', 244856),
(352295, 'PTHR10742:SF388', NULL, NULL, NULL, NULL, 'AMINO_OXIDASE DOMAIN-CONTAINING PROTEIN', 244856),
(352296, 'PTHR10742:SF364', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 244856),
(352297, 'PTHR10742:SF386', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC HISTONE DEMETHYLASE 1A', 244856),
(352298, 'PTHR10742:SF342', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 244856),
(352299, 'PTHR10742:SF264', NULL, NULL, NULL, NULL, 'POLYAMINE OXIDASE 4', 244856),
(352300, 'PTHR10742:SF385', NULL, NULL, NULL, NULL, 'POLYAMINE OXIDASE 3', 244856),
(352301, 'PTHR10742:SF383', NULL, NULL, NULL, NULL, 'POLYAMINE OXIDASE-LIKE PROTEIN', 244856),
(352302, 'PTHR10742:SF382', NULL, NULL, NULL, NULL, 'AMINO_OXIDASE DOMAIN-CONTAINING PROTEIN', 244856),
(352303, 'PTHR10742:SF218', NULL, NULL, NULL, NULL, 'AMINE OXIDASE-RELATED', 244856),
(352304, 'PTHR10742:SF416', NULL, NULL, NULL, NULL, 'SPERMINE OXIDASE', 244856),
(352305, 'PTHR10742:SF415', NULL, NULL, NULL, NULL, 'HISTONE DEMETHYLASE 1, PUTATIVE-RELATED', 244856),
(352306, 'PTHR10742:SF414', NULL, NULL, NULL, NULL, 'CONTAINING AMINE OXIDASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G12150)-RELATED', 244856),
(352307, 'PTHR10742:SF413', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC HISTONE DEMETHYLASE 1B', 244856),
(352308, 'PTHR10742:SF313', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 244856),
(352309, 'PTHR10742:SF412', NULL, NULL, NULL, NULL, 'AMINO_OXIDASE DOMAIN-CONTAINING PROTEIN', 244856),
(352310, 'PTHR10742:SF357', NULL, NULL, NULL, NULL, 'AMINO_OXIDASE DOMAIN-CONTAINING PROTEIN', 244856),
(352311, 'PTHR10742:SF379', NULL, NULL, NULL, NULL, 'AMINO_OXIDASE DOMAIN-CONTAINING PROTEIN', 244856),
(352312, 'PTHR10742:SF391', NULL, NULL, NULL, NULL, 'BNAC07G50830D PROTEIN', 244856),
(352313, 'PTHR10742:SF235', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 244856),
(352314, 'PTHR10742:SF411', NULL, NULL, NULL, NULL, 'AMINO_OXIDASE DOMAIN-CONTAINING PROTEIN', 244856),
(352315, 'PTHR10742:SF377', NULL, NULL, NULL, NULL, 'ZGC:66484', 244856),
(352316, 'PTHR10742:SF410', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC HISTONE DEMETHYLASE 1 HOMOLOG 3', 244856),
(352317, 'PTHR10742:SF355', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 244856),
(352318, 'PTHR10742:SF376', NULL, NULL, NULL, NULL, 'AMINO_OXIDASE DOMAIN-CONTAINING PROTEIN', 244856),
(352319, 'PTHR10742:SF398', NULL, NULL, NULL, NULL, 'AMINO_OXIDASE DOMAIN-CONTAINING PROTEIN-RELATED', 244856),
(352320, 'PTHR10742:SF374', NULL, NULL, NULL, NULL, 'AMINO_OXIDASE DOMAIN-CONTAINING PROTEIN', 244856),
(352321, 'PTHR10742:SF373', NULL, NULL, NULL, NULL, 'AMINO_OXIDASE DOMAIN-CONTAINING PROTEIN', 244856),
(352322, 'PTHR10742:SF395', NULL, NULL, NULL, NULL, 'BNAC03G23980D PROTEIN', 244856),
(352323, 'PTHR10742:SF351', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC HISTONE DEMETHYLASE 1-RELATED', 244856),
(352324, 'PTHR10742:SF393', NULL, NULL, NULL, NULL, 'SPERMINE OXIDASE', 244856),
(352325, 'PTHR15922:SF2', NULL, NULL, NULL, NULL, 'NEUROBLASTOMA-AMPLIFIED SEQUENCE', 244857),
(352326, 'PTHR15922', NULL, NULL, NULL, NULL, 'NEUROBLASTOMA-AMPLIFIED SEQUENCE', 244857),
(352327, 'PTHR48092:SF6', NULL, NULL, NULL, NULL, 'PROGESTERONE RECEPTOR', 244858),
(352328, 'PTHR48092:SF7', NULL, NULL, NULL, NULL, 'STEROID HORMONE RECEPTOR ERR2', 244858),
(352329, 'PTHR48092:SF8', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR SUBFAMILY 1 GROUP I MEMBER 2', 244858),
(352330, 'PTHR48092:SF9', NULL, NULL, NULL, NULL, 'KNIRPS-RELATED PROTEIN-RELATED', 244858),
(352331, 'PTHR48092:SF19', NULL, NULL, NULL, NULL, 'MINERALOCORTICOID RECEPTOR', 244858),
(352332, 'PTHR48092:SF28', NULL, NULL, NULL, NULL, 'ESR2A PROTEIN', 244858),
(352333, 'PTHR48092:SF18', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR SUBFAMILY 6 GROUP A MEMBER 1', 244858);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(352334, 'PTHR48092:SF29', NULL, NULL, NULL, NULL, '', 244858),
(352335, 'PTHR48092:SF26', NULL, NULL, NULL, NULL, 'NR LBD DOMAIN-CONTAINING PROTEIN', 244858),
(352336, 'PTHR48092:SF15', NULL, NULL, NULL, NULL, 'STEROID HORMONE RECEPTOR ERR1', 244858),
(352337, 'PTHR48092:SF2', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR SUBFAMILY 1 GROUP H MEMBER 2', 244858),
(352338, 'PTHR48092:SF16', NULL, NULL, NULL, NULL, 'ESTROGEN RECEPTOR', 244858),
(352339, 'PTHR48092:SF13', NULL, NULL, NULL, NULL, 'ANDROGEN RECEPTOR', 244858),
(352340, 'PTHR48092:SF4', NULL, NULL, NULL, NULL, '', 244858),
(352341, 'PTHR48092:SF5', NULL, NULL, NULL, NULL, 'GLUCOCORTICOID RECEPTOR', 244858),
(352342, 'PTHR48092:SF14', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR SUBFAMILY 1 GROUP H MEMBER 4', 244858),
(352343, 'PTHR48092:SF22', NULL, NULL, NULL, NULL, 'ESTROGEN-RELATED RECEPTOR SPLICE VARIANT', 244858),
(352344, 'PTHR48092:SF23', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR SUBFAMILY 1 GROUP I MEMBER 3', 244858),
(352345, 'PTHR48092:SF12', NULL, NULL, NULL, NULL, 'ESTROGEN RECEPTOR BETA', 244858),
(352346, 'PTHR48092:SF10', NULL, NULL, NULL, NULL, 'ESTROGEN-RELATED RECEPTOR GAMMA', 244858),
(352347, 'PTHR48092:SF21', NULL, NULL, NULL, NULL, 'NR LBD DOMAIN-CONTAINING PROTEIN', 244858),
(352348, 'PTHR48092', NULL, NULL, NULL, NULL, 'KNIRPS-RELATED PROTEIN-RELATED', 244858),
(352349, 'PTHR46152', NULL, NULL, NULL, NULL, 'NF-KAPPA-B INHIBITOR-INTERACTING RAS-LIKE PROTEIN', 244859),
(352350, 'PTHR46152:SF2', NULL, NULL, NULL, NULL, 'NF-KAPPA-B INHIBITOR-INTERACTING RAS-LIKE PROTEIN 2', 244859),
(352351, 'PTHR46152:SF1', NULL, NULL, NULL, NULL, 'NF-KAPPA-B INHIBITOR-INTERACTING RAS-LIKE PROTEIN 1', 244859),
(352352, 'PTHR46152:SF3', NULL, NULL, NULL, NULL, 'NF-KAPPA-B INHIBITOR-INTERACTING RAS-LIKE PROTEIN', 244859),
(352353, 'PTHR14740:SF3', NULL, NULL, NULL, NULL, 'CASPASE ACTIVITY AND APOPTOSIS INHIBITOR 1', 244860),
(352354, 'PTHR14740', NULL, NULL, NULL, NULL, 'CASPASE ACTIVITY AND APOPTOSIS INHIBITOR 1', 244860),
(352355, 'PTHR12884:SF30', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L29', 244861),
(352356, 'PTHR12884:SF32', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L29', 244861),
(352357, 'PTHR12884:SF0', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L29', 244861),
(352358, 'PTHR12884:SF37', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L29', 244861),
(352359, 'PTHR12884:SF16', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L29', 244861),
(352360, 'PTHR12884:SF27', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L29', 244861),
(352361, 'PTHR12884:SF38', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L29', 244861),
(352362, 'PTHR12884:SF29', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L29', 244861),
(352363, 'PTHR12884:SF18', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L29', 244861),
(352364, 'PTHR12884:SF33', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L29', 244861),
(352365, 'PTHR12884:SF23', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L29', 244861),
(352366, 'PTHR12884:SF34', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L29', 244861),
(352367, 'PTHR12884:SF35', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L29', 244861),
(352368, 'PTHR12884:SF25', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L29', 244861),
(352369, 'PTHR12884:SF36', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L29', 244861),
(352370, 'PTHR12884', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L29', 244861),
(352371, 'PTHR35586:SF1', NULL, NULL, NULL, NULL, 'SLL1691 PROTEIN', 244862),
(352372, 'PTHR35586', NULL, NULL, NULL, NULL, 'SLL1691 PROTEIN', 244862),
(352373, 'PTHR47423:SF2', NULL, NULL, NULL, NULL, 'PROTEIN SQS1', 244863),
(352374, 'PTHR47423:SF3', NULL, NULL, NULL, NULL, 'PROTEIN SQS1', 244863),
(352375, 'PTHR47423', NULL, NULL, NULL, NULL, 'G-PATCH DOMAIN CONTAINING PROTEIN', 244863),
(352376, 'PTHR23242:SF9', NULL, NULL, NULL, NULL, 'INTEIN_C_TER DOMAIN-CONTAINING PROTEIN', 244864),
(352377, 'PTHR23242', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244864),
(352378, 'PTHR24306', NULL, NULL, NULL, NULL, '', 244865),
(352379, 'PTHR24306:SF0', NULL, NULL, NULL, NULL, '7-ALPHA-HYDROXYCHOLEST-4-EN-3-ONE 12-ALPHA-HYDROXYLASE', 244865);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(352380, 'PTHR24306:SF7', NULL, NULL, NULL, NULL, 'AHBB', 244865),
(352381, 'PTHR24306:SF4', NULL, NULL, NULL, NULL, 'PROSTACYCLIN SYNTHASE', 244865),
(352382, 'PTHR24306:SF8', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 244865),
(352383, 'PTHR22727:SF13', NULL, NULL, NULL, NULL, 'ENDOSOME/LYSOSOME-ASSOCIATED APOPTOSIS AND AUTOPHAGY REGULATOR 1', 244866),
(352384, 'PTHR22727', NULL, NULL, NULL, NULL, 'PROTEIN CBG13728', 244866),
(352385, 'PTHR22727:SF15', NULL, NULL, NULL, NULL, 'PROTEIN CBG13728', 244866),
(352386, 'PTHR22727:SF3', NULL, NULL, NULL, NULL, 'ENDOSOME/LYSOSOME-ASSOCIATED APOPTOSIS AND AUTOPHAGY REGULATOR FAMILY MEMBER 2', 244866),
(352387, 'PTHR24081:SF0', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR SUBFAMILY 0 GROUP B MEMBER 2', 244867),
(352388, 'PTHR24081', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR SUBFAMILY 0 GROUP B', 244867),
(352389, 'PTHR24081:SF1', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR SUBFAMILY 0 GROUP B MEMBER 1', 244867),
(352390, 'PTHR24081:SF8', NULL, NULL, NULL, NULL, 'NR LBD DOMAIN-CONTAINING PROTEIN', 244867),
(352391, 'PTHR24081:SF9', NULL, NULL, NULL, NULL, 'NR LBD DOMAIN-CONTAINING PROTEIN', 244867),
(352392, 'PTHR43250', NULL, NULL, NULL, NULL, '', 244868),
(352393, 'PTHR43250:SF2', NULL, NULL, NULL, NULL, 'EXODEOXYRIBONUCLEASE III', 244868),
(352394, 'PTHR43250:SF1', NULL, NULL, NULL, NULL, 'EXODEOXYRIBONUCLEASE III', 244868),
(352395, 'PTHR35786:SF1', NULL, NULL, NULL, NULL, 'REDOX-SENSING TRANSCRIPTIONAL REPRESSOR REX 1', 244869),
(352396, 'PTHR35786', NULL, NULL, NULL, NULL, 'REDOX-SENSING TRANSCRIPTIONAL REPRESSOR REX', 244869),
(352397, 'PTHR14695:SF8', NULL, NULL, NULL, NULL, 'SHC SH2 DOMAIN-BINDING PROTEIN 1', 244870),
(352398, 'PTHR14695:SF7', NULL, NULL, NULL, NULL, 'TESTICULAR SPINDLE-ASSOCIATED PROTEIN SHCBP1L', 244870),
(352399, 'PTHR14695:SF4', NULL, NULL, NULL, NULL, 'PROTEIN NESSUN DORMA', 244870),
(352400, 'PTHR14695', NULL, NULL, NULL, NULL, 'SHC SH2-DOMAIN BINDING PROTEIN 1-RELATED', 244870),
(352401, 'PTHR43184', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY TRANSPORTER 16, ISOFORM B', 244871),
(352402, 'PTHR43184:SF29', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 244871),
(352403, 'PTHR43184:SF18', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE TRANSPORTER 5-RELATED', 244871),
(352404, 'PTHR43184:SF19', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE TRANSPORTER 3-RELATED', 244871),
(352405, 'PTHR43184:SF25', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE TRANSPORTER 1-RELATED', 244871),
(352406, 'PTHR43184:SF15', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE TRANSPORTER 1-RELATED', 244871),
(352407, 'PTHR43184:SF27', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 244871),
(352408, 'PTHR43184:SF16', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE TRANSPORTER 1 ISOFORM X1-RELATED', 244871),
(352409, 'PTHR43184:SF17', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE TRANSPORTER 2-RELATED', 244871),
(352410, 'PTHR43184:SF28', NULL, NULL, NULL, NULL, 'SUGAR PHOSPHATE EXCHANGER 3', 244871),
(352411, 'PTHR43184:SF10', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 244871),
(352412, 'PTHR43184:SF11', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE EXCHANGER SLC37A1', 244871),
(352413, 'PTHR43184:SF12', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY TRANSPORTER 16, ISOFORM B', 244871),
(352414, 'PTHR43184:SF23', NULL, NULL, NULL, NULL, 'BNAC07G34420D PROTEIN', 244871),
(352415, 'PTHR43184:SF24', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY DOMAIN PROTEIN-RELATED', 244871),
(352416, 'PTHR43184:SF2', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 244871),
(352417, 'PTHR43184:SF4', NULL, NULL, NULL, NULL, 'OS08G0156600 PROTEIN', 244871),
(352418, 'PTHR43184:SF20', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 244871),
(352419, 'PTHR43184:SF8', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 244871),
(352420, 'PTHR43184:SF9', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE EXCHANGER SLC37A2', 244871),
(352421, 'PTHR11902:SF38', NULL, NULL, NULL, NULL, '2-PHOSPHO-D-GLYCERATE HYDRO-LYASE', 244872);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(352422, 'PTHR11902:SF45', NULL, NULL, NULL, NULL, 'PHOSPHOPYRUVATE HYDRATASE', 244872),
(352423, 'PTHR11902:SF12', NULL, NULL, NULL, NULL, 'ALPHA-ENOLASE', 244872),
(352424, 'PTHR11902:SF47', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL ENOLASE 2/TRANSCRIPTIONAL ACTIVATOR', 244872),
(352425, 'PTHR11902:SF46', NULL, NULL, NULL, NULL, 'PHOSPHOPYRUVATE HYDRATASE', 244872),
(352426, 'PTHR11902', NULL, NULL, NULL, NULL, 'ENOLASE', 244872),
(352427, 'PTHR11902:SF41', NULL, NULL, NULL, NULL, 'PHOSPHOPYRUVATE HYDRATASE', 244872),
(352428, 'PTHR11902:SF30', NULL, NULL, NULL, NULL, 'ENOLASE 4', 244872),
(352429, 'PTHR11902:SF6', NULL, NULL, NULL, NULL, '2-PHOSPHOGLYCERATE DEHYDRATASE', 244872),
(352430, 'PTHR11902:SF5', NULL, NULL, NULL, NULL, 'BETA-ENOLASE', 244872),
(352431, 'PTHR11902:SF43', NULL, NULL, NULL, NULL, 'ENOLASE_N DOMAIN-CONTAINING PROTEIN', 244872),
(352432, 'PTHR11902:SF54', NULL, NULL, NULL, NULL, '2-PHOSPHO-D-GLYCERATE HYDRO-LYASE', 244872),
(352433, 'PTHR11902:SF10', NULL, NULL, NULL, NULL, 'GAMMA-ENOLASE', 244872),
(352434, 'PTHR11902:SF53', NULL, NULL, NULL, NULL, 'ENOLASE', 244872),
(352435, 'PTHR11902:SF42', NULL, NULL, NULL, NULL, 'ENOLASE 1, CHLOROPLASTIC', 244872),
(352436, 'PTHR11902:SF31', NULL, NULL, NULL, NULL, 'ENOLASE 1', 244872),
(352437, 'PTHR11902:SF50', NULL, NULL, NULL, NULL, 'ENOLASE', 244872),
(352438, 'PTHR11902:SF1', NULL, NULL, NULL, NULL, 'ENOLASE', 244872),
(352439, 'PTHR47873', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 244873),
(352440, 'PTHR47873:SF1', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 244873),
(352441, 'PTHR12447:SF33', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 244874),
(352442, 'PTHR12447:SF32', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 244874),
(352443, 'PTHR12447:SF24', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 244874),
(352444, 'PTHR12447:SF34', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 244874),
(352445, 'PTHR12447:SF4', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 13A', 244874),
(352446, 'PTHR12447:SF3', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 13B', 244874),
(352447, 'PTHR12447:SF2', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 13D', 244874),
(352448, 'PTHR12447:SF20', NULL, NULL, NULL, NULL, 'GPCR-CHAPERONE PROTEIN', 244874),
(352449, 'PTHR12447:SF31', NULL, NULL, NULL, NULL, 'LD31969P', 244874),
(352450, 'PTHR12447:SF30', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 244874),
(352451, 'PTHR12447:SF19', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 244874),
(352452, 'PTHR12447:SF18', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 244874),
(352453, 'PTHR12447:SF25', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 13C', 244874),
(352454, 'PTHR12447:SF28', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN-RELATED', 244874),
(352455, 'PTHR12447', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 13', 244874),
(352456, 'PTHR12447:SF7', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 244874),
(352457, 'PTHR15299:SF3', NULL, NULL, NULL, NULL, 'HERV-H LTR-ASSOCIATING PROTEIN 1', 244875),
(352458, 'PTHR15299', NULL, NULL, NULL, NULL, 'HERV-H LTR-ASSOCIATING PROTEIN 1', 244875),
(352459, 'PTHR34512:SF30', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN ASSEMBLY FACTOR BAMB', 244876),
(352460, 'PTHR34512', NULL, NULL, NULL, NULL, 'CELL SURFACE PROTEIN', 244876),
(352461, 'PTHR28042', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE COMPLEX SLX5-SLX8 SUBUNIT SLX5', 244877),
(352462, 'PTHR28042:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE COMPLEX SLX5-SLX8 SUBUNIT SLX5', 244877),
(352463, 'PTHR36154:SF1', NULL, NULL, NULL, NULL, 'DNA-BINDING TRANSCRIPTIONAL ACTIVATOR ALPA', 244878),
(352464, 'PTHR36154', NULL, NULL, NULL, NULL, 'DNA-BINDING TRANSCRIPTIONAL ACTIVATOR ALPA', 244878),
(352465, 'PTHR36154:SF3', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN-RELATED', 244878);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(352466, 'PTHR34344:SF1', NULL, NULL, NULL, NULL, 'BUBLIN COILED-COIL PROTEIN', 244879),
(352467, 'PTHR34344', NULL, NULL, NULL, NULL, 'UPF0184 PROTEIN C9ORF16', 244879),
(352468, 'PTHR14907:SF6', NULL, NULL, NULL, NULL, '', 244880),
(352469, 'PTHR14907', NULL, NULL, NULL, NULL, 'FI14130P', 244880),
(352470, 'PTHR14907:SF3', NULL, NULL, NULL, NULL, 'SUPPRESSOR APC DOMAIN-CONTAINING PROTEIN 2', 244880),
(352471, 'PTHR14907:SF2', NULL, NULL, NULL, NULL, 'FI14130P', 244880),
(352472, 'PTHR14907:SF5', NULL, NULL, NULL, NULL, '', 244880),
(352473, 'PTHR14907:SF4', NULL, NULL, NULL, NULL, 'SUPPRESSOR APC DOMAIN-CONTAINING PROTEIN 1', 244880),
(352474, 'PTHR15759:SF6', NULL, NULL, NULL, NULL, 'INNEXIN', 244881),
(352475, 'PTHR15759:SF7', NULL, NULL, NULL, NULL, 'PANNEXIN-2', 244881),
(352476, 'PTHR15759:SF5', NULL, NULL, NULL, NULL, 'PANNEXIN-1', 244881),
(352477, 'PTHR15759', NULL, NULL, NULL, NULL, 'PANNEXIN', 244881),
(352478, 'PTHR15759:SF3', NULL, NULL, NULL, NULL, 'PANNEXIN-3', 244881),
(352479, 'PTHR13505', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 208', 244882),
(352480, 'PTHR13505:SF7', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 208', 244882),
(352481, 'PTHR13505:SF10', NULL, NULL, NULL, NULL, 'BNAA01G06570D PROTEIN', 244882),
(352482, 'PTHR21000:SF5', NULL, NULL, NULL, NULL, 'DIHYDROXY-ACID DEHYDRATASE, MITOCHONDRIAL', 244883),
(352483, 'PTHR21000:SF13', NULL, NULL, NULL, NULL, 'HYPOTHETICAL DIHYDROXYACID DEHYDRATASE (EUROFUNG)', 244883),
(352484, 'PTHR21000:SF14', NULL, NULL, NULL, NULL, 'BNAA01G23200D PROTEIN', 244883),
(352485, 'PTHR21000', NULL, NULL, NULL, NULL, 'DIHYDROXY-ACID DEHYDRATASE  DAD', 244883),
(352486, 'PTHR43844', NULL, NULL, NULL, NULL, 'METHIONINE SYNTHASE', 244884),
(352487, 'PTHR43844:SF1', NULL, NULL, NULL, NULL, 'METHIONINE SYNTHASE', 244884),
(352488, 'PTHR43844:SF2', NULL, NULL, NULL, NULL, 'SYNTHASE, VITAMIN-B12 INDEPENDENT, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G12060)-RELATED', 244884),
(352489, 'PTHR34187:SF3', NULL, NULL, NULL, NULL, 'DUF DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_6G11150)', 244885),
(352490, 'PTHR34187:SF2', NULL, NULL, NULL, NULL, 'DUF202 DOMAIN-CONTAINING PROTEIN', 244885),
(352491, 'PTHR34187:SF1', NULL, NULL, NULL, NULL, 'DUF202 DOMAIN-CONTAINING PROTEIN', 244885),
(352492, 'PTHR34187', NULL, NULL, NULL, NULL, 'FGR18P', 244885),
(352493, 'PTHR24088:SF0', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S17, MITOCHONDRIAL', 244886),
(352494, 'PTHR24088', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S17, MITOCHONDRIAL', 244886),
(352495, 'PTHR24088:SF1', NULL, NULL, NULL, NULL, '', 244886),
(352496, 'PTHR24088:SF2', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S17, MITOCHONDRIAL', 244886),
(352497, 'PTHR35013:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG22618', 244887),
(352498, 'PTHR35013:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG09921', 244887),
(352499, 'PTHR35013:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG09906', 244887),
(352500, 'PTHR35013', NULL, NULL, NULL, NULL, 'PROTEIN CBG22618-RELATED', 244887),
(352501, 'PTHR35013:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG04660', 244887),
(352502, 'PTHR35013:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG18177', 244887),
(352503, 'PTHR34396:SF10', NULL, NULL, NULL, NULL, 'BED-TYPE DOMAIN-CONTAINING PROTEIN', 244888),
(352504, 'PTHR34396:SF21', NULL, NULL, NULL, NULL, 'OS02G0326900 PROTEIN', 244888),
(352505, 'PTHR34396:SF20', NULL, NULL, NULL, NULL, 'BED-TYPE DOMAIN-CONTAINING PROTEIN', 244888),
(352506, 'PTHR34396:SF23', NULL, NULL, NULL, NULL, 'OS09G0382120 PROTEIN', 244888),
(352507, 'PTHR34396:SF22', NULL, NULL, NULL, NULL, 'ZINC FINGER BED DOMAIN-CONTAINING PROTEIN DAYSLEEPER-LIKE', 244888),
(352508, 'PTHR34396:SF14', NULL, NULL, NULL, NULL, 'BED-TYPE DOMAIN-CONTAINING PROTEIN', 244888),
(352509, 'PTHR34396:SF24', NULL, NULL, NULL, NULL, 'ZINC FINGER BED DOMAIN-CONTAINING PROTEIN 6-LIKE', 244888),
(352510, 'PTHR34396:SF16', NULL, NULL, NULL, NULL, 'PROTEIN DUMPY-20', 244888),
(352511, 'PTHR34396:SF15', NULL, NULL, NULL, NULL, 'OS10G0378900 PROTEIN', 244888),
(352512, 'PTHR34396:SF18', NULL, NULL, NULL, NULL, '', 244888);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(352513, 'PTHR34396', NULL, NULL, NULL, NULL, 'OS03G0264950 PROTEIN-RELATED', 244888),
(352514, 'PTHR34396:SF17', NULL, NULL, NULL, NULL, 'BOUNDARY ELEMENT ASSOCIATED FACTOR', 244888),
(352515, 'PTHR34396:SF19', NULL, NULL, NULL, NULL, 'BED-TYPE DOMAIN-CONTAINING PROTEIN', 244888),
(352516, 'PTHR35668:SF1', NULL, NULL, NULL, NULL, 'PROTEIN SHORTAGE IN CHIASMATA 1 ORTHOLOG', 244889),
(352517, 'PTHR35668', NULL, NULL, NULL, NULL, 'PROTEIN SHORTAGE IN CHIASMATA 1 ORTHOLOG', 244889),
(352518, 'PTHR44523', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 13', 244890),
(352519, 'PTHR44523:SF1', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 13', 244890),
(352520, 'PTHR34272:SF1', NULL, NULL, NULL, NULL, 'F13F21.24 PROTEIN', 244891),
(352521, 'PTHR34272', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244891),
(352522, 'PTHR34272:SF10', NULL, NULL, NULL, NULL, '', 244891),
(352523, 'PTHR34272:SF3', NULL, NULL, NULL, NULL, 'OS01G0693100 PROTEIN', 244891),
(352524, 'PTHR34272:SF12', NULL, NULL, NULL, NULL, 'BNACNNG44240D PROTEIN', 244891),
(352525, 'PTHR34272:SF13', NULL, NULL, NULL, NULL, 'BNAC09G08860D PROTEIN', 244891),
(352526, 'PTHR34272:SF14', NULL, NULL, NULL, NULL, '', 244891),
(352527, 'PTHR34272:SF7', NULL, NULL, NULL, NULL, '', 244891),
(352528, 'PTHR34272:SF15', NULL, NULL, NULL, NULL, 'GLYCOFAMILY PROTEIN, PUTATIVE-RELATED', 244891),
(352529, 'PTHR34272:SF8', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 244891),
(352530, 'PTHR47802:SF1', NULL, NULL, NULL, NULL, 'GLYOXALASE FAMILY PROTEIN, EXPRESSED', 244892),
(352531, 'PTHR47802', NULL, NULL, NULL, NULL, 'GLYOXALASE FAMILY PROTEIN, EXPRESSED', 244892),
(352532, 'PTHR31059', NULL, NULL, NULL, NULL, 'HSSA/B-LIKE PROTEIN 1-RELATED-RELATED', 244893),
(352533, 'PTHR31059:SF4', NULL, NULL, NULL, NULL, 'HSSA/B-LIKE PROTEIN 31', 244893),
(352534, 'PTHR31059:SF3', NULL, NULL, NULL, NULL, 'HSSA/B-LIKE PROTEIN 10-RELATED', 244893),
(352535, 'PTHR31059:SF5', NULL, NULL, NULL, NULL, 'HSSA/B-LIKE PROTEIN 1-RELATED', 244893),
(352536, 'PTHR23093:SF18', NULL, NULL, NULL, NULL, 'AGAP003351-PA', 244894),
(352537, 'PTHR23093', NULL, NULL, NULL, NULL, 'SIMILAR TO CHROMOSOME 3 OPEN READING FRAME 20', 244894),
(352538, 'PTHR23093:SF17', NULL, NULL, NULL, NULL, 'GLUTAMATE-RICH PROTEIN 6B', 244894),
(352539, 'PTHR23093:SF20', NULL, NULL, NULL, NULL, 'SIMILAR TO CHROMOSOME 3 OPEN READING FRAME 20', 244894),
(352540, 'PTHR23093:SF11', NULL, NULL, NULL, NULL, 'GLUTAMATE-RICH PROTEIN 6', 244894),
(352541, 'PTHR23093:SF16', NULL, NULL, NULL, NULL, 'FAM194 DOMAIN-CONTAINING PROTEIN', 244894),
(352542, 'PTHR38644:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244895),
(352543, 'PTHR38644', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244895),
(352544, 'PTHR45940:SF40', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 244896),
(352545, 'PTHR45940:SF43', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 3', 244896),
(352546, 'PTHR45940:SF44', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 244896),
(352547, 'PTHR45940:SF22', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 244896),
(352548, 'PTHR45940:SF11', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 3-LIKE', 244896),
(352549, 'PTHR45940:SF41', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 5', 244896),
(352550, 'PTHR45940:SF42', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 3', 244896),
(352551, 'PTHR45940:SF25', NULL, NULL, NULL, NULL, 'WOX3B', 244896),
(352552, 'PTHR45940:SF14', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 1', 244896),
(352553, 'PTHR45940:SF37', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 244896),
(352554, 'PTHR45940:SF26', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 244896),
(352555, 'PTHR45940:SF34', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 244896),
(352556, 'PTHR45940:SF45', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 244896),
(352557, 'PTHR45940:SF46', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 2-RELATED', 244896);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(352558, 'PTHR45940:SF13', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 1', 244896),
(352559, 'PTHR45940:SF19', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 6', 244896),
(352560, 'PTHR45940:SF28', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 244896),
(352561, 'PTHR45940:SF39', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 5', 244896),
(352562, 'PTHR45940', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 1-RELATED', 244896),
(352563, 'PTHR45940:SF17', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 244896),
(352564, 'PTHR45940:SF2', NULL, NULL, NULL, NULL, 'PROTEIN WUSCHEL', 244896),
(352565, 'PTHR45940:SF3', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 7', 244896),
(352566, 'PTHR45940:SF6', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 2', 244896),
(352567, 'PTHR33778', NULL, NULL, NULL, NULL, 'PROTEIN MGTC', 244897),
(352568, 'PTHR33778:SF3', NULL, NULL, NULL, NULL, 'PROTEIN MGTC', 244897),
(352569, 'PTHR33778:SF4', NULL, NULL, NULL, NULL, 'PROTEIN SAPB', 244897),
(352570, 'PTHR33778:SF1', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER YHID-RELATED', 244897),
(352571, 'PTHR43139:SF46', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 244898),
(352572, 'PTHR43139:SF48', NULL, NULL, NULL, NULL, 'HYDROLASE, ALPHA/BETA FOLD FAMILY PROTEIN', 244898),
(352573, 'PTHR43139', NULL, NULL, NULL, NULL, 'SI:DKEY-122A22.2', 244898),
(352574, 'PTHR43139:SF26', NULL, NULL, NULL, NULL, '', 244898),
(352575, 'PTHR43139:SF25', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 244898),
(352576, 'PTHR43139:SF64', NULL, NULL, NULL, NULL, 'OS07G0622700 PROTEIN', 244898),
(352577, 'PTHR43139:SF42', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 244898),
(352578, 'PTHR43139:SF41', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 244898),
(352579, 'PTHR43139:SF63', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 244898),
(352580, 'PTHR43139:SF22', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 244898),
(352581, 'PTHR43139:SF43', NULL, NULL, NULL, NULL, 'MESODERM-SPECIFIC TRANSCRIPT HOMOLOG PROTEIN', 244898),
(352582, 'PTHR43139:SF28', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 244898),
(352583, 'PTHR43139:SF49', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 244898),
(352584, 'PTHR43139:SF29', NULL, NULL, NULL, NULL, 'CATALYTIC/ HYDROLASE', 244898),
(352585, 'PTHR43139:SF51', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 244898),
(352586, 'PTHR43139:SF7', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 244898),
(352587, 'PTHR43139:SF50', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 244898),
(352588, 'PTHR43139:SF5', NULL, NULL, NULL, NULL, 'MESODERM-SPECIFIC TRANSCRIPT PROTEIN', 244898),
(352589, 'PTHR43139:SF6', NULL, NULL, NULL, NULL, 'OS02G0706900 PROTEIN', 244898),
(352590, 'PTHR43139:SF4', NULL, NULL, NULL, NULL, 'HYDROLASE, ALPHA/BETA FOLD FAMILY PROTEIN, EXPRESSED', 244898),
(352591, 'PTHR43139:SF57', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN-RELATED', 244898),
(352592, 'PTHR43139:SF13', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 244898),
(352593, 'PTHR43139:SF35', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 244898),
(352594, 'PTHR43139:SF34', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 244898),
(352595, 'PTHR43139:SF37', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 244898),
(352596, 'PTHR43139:SF59', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 244898),
(352597, 'PTHR43139:SF36', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 244898),
(352598, 'PTHR43139:SF58', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL INTEGRAL MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_1G03090)', 244898),
(352599, 'PTHR43139:SF14', NULL, NULL, NULL, NULL, 'OS01G0168800 PROTEIN', 244898),
(352600, 'PTHR43139:SF53', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 244898);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(352601, 'PTHR43139:SF31', NULL, NULL, NULL, NULL, 'ALPHA/BETA FOLD FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 244898),
(352602, 'PTHR43139:SF52', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 244898),
(352603, 'PTHR43139:SF30', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 244898),
(352604, 'PTHR43139:SF33', NULL, NULL, NULL, NULL, 'ALPHA/BETA FOLD HYDROLASE', 244898),
(352605, 'PTHR43139:SF39', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 244898),
(352606, 'PTHR43139:SF38', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 244898),
(352607, 'PTHR43139:SF16', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 244898),
(352608, 'PTHR43139:SF60', NULL, NULL, NULL, NULL, 'SI:DKEY-122A22.2', 244898),
(352609, 'PTHR43139:SF62', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 244898),
(352610, 'PTHR43139:SF61', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 244898),
(352611, 'PTHR46531', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER 6', 244899),
(352612, 'PTHR46531:SF1', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER 6', 244899),
(352613, 'PTHR43420:SF43', NULL, NULL, NULL, NULL, 'SPERMINE/SPERMIDINE ACETYLTRANSFERASE', 244900),
(352614, 'PTHR43420:SF42', NULL, NULL, NULL, NULL, 'GLUCOSAMINE 6-PHOSPHATE N-ACETYLTRANSFERASE', 244900),
(352615, 'PTHR43420:SF31', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE-RELATED', 244900),
(352616, 'PTHR43420:SF41', NULL, NULL, NULL, NULL, 'IAA ACETYLTRANSFERASE', 244900),
(352617, 'PTHR43420:SF51', NULL, NULL, NULL, NULL, 'PEPTIDYL-LYSINE N-ACETYLTRANSFERASE YIAC', 244900),
(352618, 'PTHR43420:SF50', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 244900),
(352619, 'PTHR43420:SF3', NULL, NULL, NULL, NULL, 'BLR4025 PROTEIN', 244900),
(352620, 'PTHR43420:SF49', NULL, NULL, NULL, NULL, 'RIBOSOMAL-PROTEIN-ALANINE ACETYLTRANSFERASE', 244900),
(352621, 'PTHR43420:SF48', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE, GNAT FAMILY PROTEIN', 244900),
(352622, 'PTHR43420:SF47', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 244900),
(352623, 'PTHR43420', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE', 244900),
(352624, 'PTHR43420:SF46', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE-RELATED', 244900),
(352625, 'PTHR43420:SF45', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE-RELATED', 244900),
(352626, 'PTHR43420:SF12', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 244900),
(352627, 'PTHR43420:SF44', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE YPEA', 244900),
(352628, 'PTHR43420:SF9', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 244900),
(352629, 'PTHR11130:SF0', NULL, NULL, NULL, NULL, 'GLUTATHIONE SYNTHETASE', 244901),
(352630, 'PTHR11130:SF2', NULL, NULL, NULL, NULL, 'GLUTATHIONE SYNTHETASE', 244901),
(352631, 'PTHR11130:SF3', NULL, NULL, NULL, NULL, 'GLUTATHIONE SYNTHETASE', 244901),
(352632, 'PTHR11130:SF4', NULL, NULL, NULL, NULL, 'GLUTATHIONE SYNTHETASE', 244901),
(352633, 'PTHR11130', NULL, NULL, NULL, NULL, 'GLUTATHIONE SYNTHETASE', 244901),
(352634, 'PTHR31375:SF237', NULL, NULL, NULL, NULL, 'BNAC04G02210D PROTEIN', 244902),
(352635, 'PTHR31375:SF238', NULL, NULL, NULL, NULL, 'BNAC03G35600D PROTEIN', 244902),
(352636, 'PTHR31375:SF235', NULL, NULL, NULL, NULL, 'BNAA09G51170D PROTEIN', 244902),
(352637, 'PTHR31375:SF236', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE-LIKE', 244902),
(352638, 'PTHR31375:SF112', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE ADPG1', 244902),
(352639, 'PTHR31375:SF233', NULL, NULL, NULL, NULL, 'BNAC04G03170D PROTEIN', 244902),
(352640, 'PTHR31375:SF198', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE', 244902),
(352641, 'PTHR31375:SF111', NULL, NULL, NULL, NULL, 'OS01G0329300 PROTEIN', 244902),
(352642, 'PTHR31375:SF199', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN-RELATED', 244902),
(352643, 'PTHR31375:SF196', NULL, NULL, NULL, NULL, 'POLLEN ALLERGEN PLA O 2', 244902),
(352644, 'PTHR31375:SF230', NULL, NULL, NULL, NULL, 'PECTIN LYASE SUPERFAMILY PROTEIN', 244902);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(352645, 'PTHR31375:SF197', NULL, NULL, NULL, NULL, 'PECTIN LYASE SUPERFAMILY PROTEIN', 244902),
(352646, 'PTHR31375:SF194', NULL, NULL, NULL, NULL, 'BNAC08G49850D PROTEIN', 244902),
(352647, 'PTHR31375:SF195', NULL, NULL, NULL, NULL, 'BNAC03G35510D PROTEIN', 244902),
(352648, 'PTHR31375:SF193', NULL, NULL, NULL, NULL, 'BNAA07G09960D PROTEIN', 244902),
(352649, 'PTHR31375:SF190', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE', 244902),
(352650, 'PTHR31375:SF191', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE/GLYCOSIDE HYDROLASE FAMILY PROTEIN', 244902),
(352651, 'PTHR31375:SF29', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN', 244902),
(352652, 'PTHR31375:SF26', NULL, NULL, NULL, NULL, 'OS05G0279900 PROTEIN', 244902),
(352653, 'PTHR31375:SF239', NULL, NULL, NULL, NULL, '', 244902),
(352654, 'PTHR31375:SF118', NULL, NULL, NULL, NULL, '', 244902),
(352655, 'PTHR31375:SF249', NULL, NULL, NULL, NULL, 'BNAC04G43570D PROTEIN', 244902),
(352656, 'PTHR31375:SF128', NULL, NULL, NULL, NULL, '', 244902),
(352657, 'PTHR31375:SF246', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN', 244902),
(352658, 'PTHR31375:SF247', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE-LIKE', 244902),
(352659, 'PTHR31375:SF123', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE-LIKE', 244902),
(352660, 'PTHR31375:SF244', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN', 244902),
(352661, 'PTHR31375:SF245', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN', 244902),
(352662, 'PTHR31375:SF124', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE FAMILY 28 PROTEIN-RELATED', 244902),
(352663, 'PTHR31375:SF242', NULL, NULL, NULL, NULL, 'BNAANNG30380D PROTEIN', 244902),
(352664, 'PTHR31375:SF122', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE-LIKE', 244902),
(352665, 'PTHR31375:SF243', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE-RELATED', 244902),
(352666, 'PTHR31375:SF33', NULL, NULL, NULL, NULL, 'EXOPOLYGALACTURONASE-LIKE', 244902),
(352667, 'PTHR31375', NULL, NULL, NULL, NULL, '', 244902),
(352668, 'PTHR31375:SF31', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN', 244902),
(352669, 'PTHR31375:SF259', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_6G11980)-RELATED', 244902),
(352670, 'PTHR31375:SF138', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE', 244902),
(352671, 'PTHR31375:SF139', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE-RELATED', 244902),
(352672, 'PTHR31375:SF137', NULL, NULL, NULL, NULL, 'NTS1 PROTEIN', 244902),
(352673, 'PTHR31375:SF255', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE', 244902),
(352674, 'PTHR31375:SF135', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE-LIKE', 244902),
(352675, 'PTHR31375:SF254', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE', 244902),
(352676, 'PTHR31375:SF133', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN', 244902),
(352677, 'PTHR31375:SF251', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 244902),
(352678, 'PTHR31375:SF130', NULL, NULL, NULL, NULL, 'EXOPOLYGALACTURONASE-LIKE', 244902),
(352679, 'PTHR31375:SF301', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN', 244902),
(352680, 'PTHR31375:SF147', NULL, NULL, NULL, NULL, 'EXOPOLYGALACTURONASE-LIKE', 244902),
(352681, 'PTHR31375:SF300', NULL, NULL, NULL, NULL, 'OS06G0509600 PROTEIN', 244902),
(352682, 'PTHR31375:SF141', NULL, NULL, NULL, NULL, 'ENDO-POLYGALACTURONASE', 244902),
(352683, 'PTHR31375:SF263', NULL, NULL, NULL, NULL, 'BNAC07G49180D PROTEIN', 244902),
(352684, 'PTHR31375:SF261', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE', 244902),
(352685, 'PTHR31375:SF11', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN', 244902),
(352686, 'PTHR31375:SF18', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN', 244902),
(352687, 'PTHR31375:SF17', NULL, NULL, NULL, NULL, 'EXOPOLYGALACTURONASE', 244902),
(352688, 'PTHR31375:SF92', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN', 244902),
(352689, 'PTHR31375:SF91', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN', 244902);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(352690, 'PTHR31375:SF279', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE/GLYCOSIDE HYDROLASE FAMILY PROTEIN', 244902),
(352691, 'PTHR31375:SF158', NULL, NULL, NULL, NULL, 'EXOPOLYGALACTURONASE CLONE GBGE184', 244902),
(352692, 'PTHR31375:SF277', NULL, NULL, NULL, NULL, 'EXOPOLYGALACTURONASE-LIKE', 244902),
(352693, 'PTHR31375:SF278', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN', 244902),
(352694, 'PTHR31375:SF157', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE FAMILY 28 PROTEIN / POLYGALACTURONASE (PECTINASE) FAMILY PROTEIN', 244902),
(352695, 'PTHR31375:SF275', NULL, NULL, NULL, NULL, 'EXOPOLYGALACTURONASE CLONE GBGA483-RELATED', 244902),
(352696, 'PTHR31375:SF276', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 244902),
(352697, 'PTHR31375:SF152', NULL, NULL, NULL, NULL, 'OS03G0808000 PROTEIN', 244902),
(352698, 'PTHR31375:SF273', NULL, NULL, NULL, NULL, 'ENDO POLYGALACTURONASE', 244902),
(352699, 'PTHR31375:SF153', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN', 244902),
(352700, 'PTHR31375:SF274', NULL, NULL, NULL, NULL, 'OS11G0249400 PROTEIN', 244902),
(352701, 'PTHR31375:SF272', NULL, NULL, NULL, NULL, '', 244902),
(352702, 'PTHR31375:SF270', NULL, NULL, NULL, NULL, 'OS05G0542900 PROTEIN', 244902),
(352703, 'PTHR31375:SF205', NULL, NULL, NULL, NULL, 'BNAA08G20470D PROTEIN', 244902),
(352704, 'PTHR31375:SF202', NULL, NULL, NULL, NULL, 'BNAA05G29810D PROTEIN', 244902),
(352705, 'PTHR31375:SF169', NULL, NULL, NULL, NULL, 'F3F20.10 PROTEIN-RELATED', 244902),
(352706, 'PTHR31375:SF203', NULL, NULL, NULL, NULL, 'OS07G0208200 PROTEIN', 244902),
(352707, 'PTHR31375:SF167', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE QRT2', 244902),
(352708, 'PTHR31375:SF200', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE-RELATED', 244902),
(352709, 'PTHR31375:SF288', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE, FAMILY 28', 244902),
(352710, 'PTHR31375:SF289', NULL, NULL, NULL, NULL, 'LYSM DOMAIN-CONTAINING PROTEIN', 244902),
(352711, 'PTHR31375:SF168', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE-LIKE', 244902),
(352712, 'PTHR31375:SF201', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE, FAMILY 28, PECTIN LYASE FOLD/VIRULENCE FACTOR-RELATED', 244902),
(352713, 'PTHR31375:SF286', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 244902),
(352714, 'PTHR31375:SF166', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN', 244902),
(352715, 'PTHR31375:SF287', NULL, NULL, NULL, NULL, 'EXOPOLYGALACTURONASE-LIKE', 244902),
(352716, 'PTHR31375:SF284', NULL, NULL, NULL, NULL, 'BNAC06G27000D PROTEIN', 244902),
(352717, 'PTHR31375:SF285', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE-2', 244902),
(352718, 'PTHR31375:SF282', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN', 244902),
(352719, 'PTHR31375:SF283', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN', 244902),
(352720, 'PTHR31375:SF280', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE', 244902),
(352721, 'PTHR31375:SF281', NULL, NULL, NULL, NULL, '', 244902),
(352722, 'PTHR31375:SF209', NULL, NULL, NULL, NULL, 'BNAC04G03160D PROTEIN', 244902),
(352723, 'PTHR31375:SF206', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 244902),
(352724, 'PTHR31375:SF207', NULL, NULL, NULL, NULL, 'BNAC04G03130D PROTEIN', 244902),
(352725, 'PTHR31375:SF215', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE', 244902),
(352726, 'PTHR31375:SF216', NULL, NULL, NULL, NULL, 'BNAANNG19420D PROTEIN', 244902),
(352727, 'PTHR31375:SF213', NULL, NULL, NULL, NULL, 'ABSCISSION POLYGALACTURONASE', 244902),
(352728, 'PTHR31375:SF214', NULL, NULL, NULL, NULL, 'BNAA07G02370D PROTEIN', 244902),
(352729, 'PTHR31375:SF211', NULL, NULL, NULL, NULL, 'BNAA04G29280D PROTEIN', 244902),
(352730, 'PTHR31375:SF299', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN', 244902),
(352731, 'PTHR31375:SF212', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 244902),
(352732, 'PTHR31375:SF297', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE-LIKE ISOFORM X1', 244902),
(352733, 'PTHR31375:SF298', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE QRT2', 244902),
(352734, 'PTHR31375:SF177', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE QRT2', 244902);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(352735, 'PTHR31375:SF295', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE/GLYCOSIDE HYDROLASE FAMILY PROTEIN', 244902),
(352736, 'PTHR31375:SF296', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE ADPG1-LIKE', 244902),
(352737, 'PTHR31375:SF175', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE ADPG2', 244902),
(352738, 'PTHR31375:SF293', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE-LIKE', 244902),
(352739, 'PTHR31375:SF172', NULL, NULL, NULL, NULL, 'PUTATIVE, EXPRESSED-RELATED', 244902),
(352740, 'PTHR31375:SF294', NULL, NULL, NULL, NULL, 'F18B13.22 PROTEIN ISOFORM 1', 244902),
(352741, 'PTHR31375:SF291', NULL, NULL, NULL, NULL, 'OS01G0623600 PROTEIN', 244902),
(352742, 'PTHR31375:SF170', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE', 244902),
(352743, 'PTHR31375:SF292', NULL, NULL, NULL, NULL, '', 244902),
(352744, 'PTHR31375:SF171', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN', 244902),
(352745, 'PTHR31375:SF290', NULL, NULL, NULL, NULL, 'PECTIN LYASE SUPERFAMILY PROTEIN', 244902),
(352746, 'PTHR31375:SF219', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 244902),
(352747, 'PTHR31375:SF43', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN', 244902),
(352748, 'PTHR31375:SF217', NULL, NULL, NULL, NULL, 'PECTATE_LYASE_3 DOMAIN-CONTAINING PROTEIN', 244902),
(352749, 'PTHR31375:SF41', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN', 244902),
(352750, 'PTHR31375:SF218', NULL, NULL, NULL, NULL, 'BNAC05G01430D PROTEIN', 244902),
(352751, 'PTHR31375:SF226', NULL, NULL, NULL, NULL, 'BNAC09G33090D PROTEIN', 244902),
(352752, 'PTHR31375:SF227', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE', 244902),
(352753, 'PTHR31375:SF224', NULL, NULL, NULL, NULL, 'F5I14.10', 244902),
(352754, 'PTHR31375:SF103', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE QRT2', 244902),
(352755, 'PTHR31375:SF189', NULL, NULL, NULL, NULL, 'BNACNNG50710D PROTEIN', 244902),
(352756, 'PTHR31375:SF222', NULL, NULL, NULL, NULL, 'BNAA08G25630D PROTEIN', 244902),
(352757, 'PTHR31375:SF223', NULL, NULL, NULL, NULL, 'BNAC03G58660D PROTEIN', 244902),
(352758, 'PTHR31375:SF102', NULL, NULL, NULL, NULL, 'OS02G0196700 PROTEIN', 244902),
(352759, 'PTHR31375:SF187', NULL, NULL, NULL, NULL, 'BNAC04G49330D PROTEIN', 244902),
(352760, 'PTHR31375:SF220', NULL, NULL, NULL, NULL, 'BNAC05G03780D PROTEIN', 244902),
(352761, 'PTHR31375:SF188', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE, FAMILY 28, PECTIN LYASE FOLD/VIRULENCE FACTOR-RELATED', 244902),
(352762, 'PTHR31375:SF184', NULL, NULL, NULL, NULL, 'BNAC05G01250D PROTEIN', 244902),
(352763, 'PTHR31375:SF181', NULL, NULL, NULL, NULL, 'BNAC03G35490D PROTEIN', 244902),
(352764, 'PTHR31375:SF182', NULL, NULL, NULL, NULL, 'BNAA04G25430D PROTEIN', 244902),
(352765, 'PTHR31375:SF180', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE-LIKE', 244902),
(352766, 'PTHR31375:SF108', NULL, NULL, NULL, NULL, 'OS05G0542800 PROTEIN', 244902),
(352767, 'PTHR31375:SF229', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN', 244902),
(352768, 'PTHR45828:SF9', NULL, NULL, NULL, NULL, '', 244903),
(352769, 'PTHR45828:SF34', NULL, NULL, NULL, NULL, 'DEFENSE PROTEIN L(2)34FC-RELATED', 244903),
(352770, 'PTHR45828:SF33', NULL, NULL, NULL, NULL, 'REELIN DOMAIN-CONTAINING PROTEIN 1', 244903),
(352771, 'PTHR45828', NULL, NULL, NULL, NULL, 'CYTOCHROME B561/FERRIC REDUCTASE TRANSMEMBRANE', 244903),
(352772, 'PTHR45828:SF32', NULL, NULL, NULL, NULL, 'SI:DKEY-251I10.2', 244903),
(352773, 'PTHR45828:SF31', NULL, NULL, NULL, NULL, 'PROTEIN CBG02902', 244903),
(352774, 'PTHR45828:SF3', NULL, NULL, NULL, NULL, 'FERRIC-CHELATE REDUCTASE 1', 244903),
(352775, 'PTHR45828:SF38', NULL, NULL, NULL, NULL, 'FERRIC-CHELATE REDUCTASE 1 HOMOLOG-RELATED', 244903),
(352776, 'PTHR45828:SF27', NULL, NULL, NULL, NULL, 'SI:CH73-196I15.3-RELATED', 244903),
(352777, 'PTHR45828:SF37', NULL, NULL, NULL, NULL, 'REELIN DOMAIN-CONTAINING PROTEIN', 244903),
(352778, 'PTHR45828:SF36', NULL, NULL, NULL, NULL, 'REELIN DOMAIN-CONTAINING PROTEIN', 244903),
(352779, 'PTHR45828:SF14', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 DOMAIN-CONTAINING PROTEIN', 244903); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(352780, 'PTHR45828:SF35', NULL, NULL, NULL, NULL, 'REELIN DOMAIN-CONTAINING PROTEIN', 244903),
(352781, 'PTHR45828:SF39', NULL, NULL, NULL, NULL, 'REELIN DOMAIN-CONTAINING PROTEIN', 244903),
(352782, 'PTHR36324:SF5', NULL, NULL, NULL, NULL, '', 244904),
(352783, 'PTHR36324:SF6', NULL, NULL, NULL, NULL, '', 244904),
(352784, 'PTHR36324:SF4', NULL, NULL, NULL, NULL, '', 244904),
(352785, 'PTHR36324:SF1', NULL, NULL, NULL, NULL, 'OS09G0460100 PROTEIN', 244904),
(352786, 'PTHR36324', NULL, NULL, NULL, NULL, 'OS09G0460100 PROTEIN', 244904),
(352787, 'PTHR30307', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE:TRNA RIBOSYLTRANSFERASE-ISOMERASE', 244905),
(352788, 'PTHR30307:SF0', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE:TRNA RIBOSYLTRANSFERASE-ISOMERASE', 244905),
(352789, 'PTHR13848:SF79', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE', 244906),
(352790, 'PTHR13848:SF3', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE 2', 244906),
(352791, 'PTHR13848:SF78', NULL, NULL, NULL, NULL, 'YIPPEE DOMAIN-CONTAINING PROTEIN', 244906),
(352792, 'PTHR13848:SF56', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE MOH1', 244906),
(352793, 'PTHR13848:SF99', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE', 244906),
(352794, 'PTHR13848:SF2', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE', 244906),
(352795, 'PTHR13848:SF1', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE 1', 244906),
(352796, 'PTHR13848:SF98', NULL, NULL, NULL, NULL, 'YIPPEE DOMAIN-CONTAINING PROTEIN', 244906),
(352797, 'PTHR13848:SF54', NULL, NULL, NULL, NULL, 'YIPPEE DOMAIN-CONTAINING PROTEIN', 244906),
(352798, 'PTHR13848:SF17', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE 4', 244906),
(352799, 'PTHR13848:SF6', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE 3', 244906),
(352800, 'PTHR13848:SF15', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE', 244906),
(352801, 'PTHR13848:SF58', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE 5', 244906),
(352802, 'PTHR13848:SF81', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE', 244906),
(352803, 'PTHR13848:SF80', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE', 244906),
(352804, 'PTHR13848:SF86', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE', 244906),
(352805, 'PTHR13848:SF63', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE', 244906),
(352806, 'PTHR13848:SF83', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE', 244906),
(352807, 'PTHR13848:SF46', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE', 244906),
(352808, 'PTHR13848:SF68', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE', 244906),
(352809, 'PTHR13848:SF44', NULL, NULL, NULL, NULL, 'YIPPEE-LIKE PROTEIN OS10G0369500-RELATED', 244906),
(352810, 'PTHR13848:SF88', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE', 244906),
(352811, 'PTHR13848:SF66', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE', 244906),
(352812, 'PTHR13848:SF87', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE', 244906),
(352813, 'PTHR13848:SF69', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE', 244906),
(352814, 'PTHR13848:SF100', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE', 244906),
(352815, 'PTHR13848', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE CG15309-RELATED', 244906),
(352816, 'PTHR13848:SF93', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE', 244906),
(352817, 'PTHR13848:SF92', NULL, NULL, NULL, NULL, 'YIPPEE DOMAIN-CONTAINING PROTEIN', 244906),
(352818, 'PTHR13848:SF91', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE 5', 244906),
(352819, 'PTHR13848:SF90', NULL, NULL, NULL, NULL, 'BNAA02G29570D PROTEIN', 244906),
(352820, 'PTHR13848:SF97', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE', 244906),
(352821, 'PTHR13848:SF75', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE', 244906),
(352822, 'PTHR13848:SF74', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE', 244906),
(352823, 'PTHR13848:SF96', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE', 244906),
(352824, 'PTHR13848:SF95', NULL, NULL, NULL, NULL, 'YIPPEE DOMAIN-CONTAINING PROTEIN', 244906),
(352825, 'PTHR13848:SF73', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE', 244906),
(352826, 'PTHR13848:SF50', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE', 244906),
(352827, 'PTHR13848:SF94', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE', 244906); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(352828, 'PTHR31092', NULL, NULL, NULL, NULL, 'SORORIN', 244907),
(352829, 'PTHR31092:SF2', NULL, NULL, NULL, NULL, 'SORORIN', 244907),
(352830, 'PTHR34195:SF1', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I REACTION CENTER SUBUNIT V, CHLOROPLASTIC', 244908),
(352831, 'PTHR34195:SF2', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I REACTION CENTER SUBUNIT PSAK, CHLOROPLASTIC', 244908),
(352832, 'PTHR34195', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I REACTION CENTER SUBUNIT V, CHLOROPLASTIC-RELATED', 244908),
(352833, 'PTHR34195:SF3', NULL, NULL, NULL, NULL, 'PSI-G', 244908),
(352834, 'PTHR34195:SF4', NULL, NULL, NULL, NULL, 'PSI-G', 244908),
(352835, 'PTHR34195:SF5', NULL, NULL, NULL, NULL, 'PSI-K', 244908),
(352836, 'PTHR34195:SF6', NULL, NULL, NULL, NULL, 'PSI-G', 244908),
(352837, 'PTHR44176', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 25', 244909),
(352838, 'PTHR44176:SF1', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 25', 244909),
(352839, 'PTHR32099:SF57', NULL, NULL, NULL, NULL, 'OS07G0540600 PROTEIN', 244910),
(352840, 'PTHR32099:SF35', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH REPEAT SECRETORY PROTEIN 38-LIKE ISOFORM X1', 244910),
(352841, 'PTHR32099:SF9', NULL, NULL, NULL, NULL, 'OS07G0538300 PROTEIN', 244910),
(352842, 'PTHR32099:SF36', NULL, NULL, NULL, NULL, 'ATP BINDING PROTEIN', 244910),
(352843, 'PTHR32099:SF97', NULL, NULL, NULL, NULL, 'GNK2-HOMOLOGOUS DOMAIN-CONTAINING PROTEIN', 244910),
(352844, 'PTHR32099:SF31', NULL, NULL, NULL, NULL, 'GNK2-HOMOLOGOUS DOMAIN-CONTAINING PROTEIN', 244910),
(352845, 'PTHR32099:SF54', NULL, NULL, NULL, NULL, 'GNK2-HOMOLOGOUS DOMAIN-CONTAINING PROTEIN', 244910),
(352846, 'PTHR32099:SF98', NULL, NULL, NULL, NULL, 'GNK2-HOMOLOGOUS DOMAIN-CONTAINING PROTEIN', 244910),
(352847, 'PTHR32099:SF99', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE-RELATED FAMILY PROTEIN-RELATED', 244910),
(352848, 'PTHR32099:SF71', NULL, NULL, NULL, NULL, '', 244910),
(352849, 'PTHR32099:SF93', NULL, NULL, NULL, NULL, 'BNACNNG14620D PROTEIN', 244910),
(352850, 'PTHR32099:SF94', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 25', 244910),
(352851, 'PTHR32099:SF72', NULL, NULL, NULL, NULL, 'GNK2-HOMOLOGOUS DOMAIN-CONTAINING PROTEIN', 244910),
(352852, 'PTHR32099:SF50', NULL, NULL, NULL, NULL, 'SALT STRESS RESPONSE/ANTIFUNGAL DOMAIN PROTEIN', 244910),
(352853, 'PTHR32099', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH REPEAT SECRETORY PROTEIN', 244910),
(352854, 'PTHR32099:SF51', NULL, NULL, NULL, NULL, 'GNK2-HOMOLOGOUS DOMAIN-CONTAINING PROTEIN', 244910),
(352855, 'PTHR32099:SF95', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 244910),
(352856, 'PTHR32099:SF30', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH REPEAT SECRETORY PROTEIN 38-LIKE', 244910),
(352857, 'PTHR32099:SF96', NULL, NULL, NULL, NULL, 'GNK2-HOMOLOGOUS DOMAIN-CONTAINING PROTEIN', 244910),
(352858, 'PTHR32099:SF74', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 10', 244910),
(352859, 'PTHR32099:SF52', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 10', 244910),
(352860, 'PTHR32099:SF70', NULL, NULL, NULL, NULL, 'BNAC03G29880D PROTEIN', 244910),
(352861, 'PTHR32099:SF92', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 34-RELATED', 244910),
(352862, 'PTHR32099:SF100', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 9-RELATED', 244910),
(352863, 'PTHR32099:SF29', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH REPEAT SECRETORY PROTEIN 8', 244910),
(352864, 'PTHR32099:SF101', NULL, NULL, NULL, NULL, 'GNK2-HOMOLOGOUS DOMAIN-CONTAINING PROTEIN', 244910),
(352865, 'PTHR32099:SF102', NULL, NULL, NULL, NULL, 'OS12G0608700 PROTEIN', 244910),
(352866, 'PTHR32099:SF46', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH REPEAT SECRETORY PROTEIN 5-RELATED', 244910),
(352867, 'PTHR32099:SF69', NULL, NULL, NULL, NULL, 'OS01G0342200 PROTEIN', 244910),
(352868, 'PTHR32099:SF48', NULL, NULL, NULL, NULL, 'OS10G0329900 PROTEIN', 244910),
(352869, 'PTHR32099:SF20', NULL, NULL, NULL, NULL, 'OS07G0534500 PROTEIN', 244910),
(352870, 'PTHR32099:SF42', NULL, NULL, NULL, NULL, 'OS07G0668500 PROTEIN', 244910);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(352871, 'PTHR32099:SF86', NULL, NULL, NULL, NULL, '', 244910),
(352872, 'PTHR32099:SF43', NULL, NULL, NULL, NULL, 'GNK2-HOMOLOGOUS DOMAIN-CONTAINING PROTEIN', 244910),
(352873, 'PTHR32099:SF44', NULL, NULL, NULL, NULL, 'GNK2-HOMOLOGOUS DOMAIN-CONTAINING PROTEIN', 244910),
(352874, 'PTHR32099:SF66', NULL, NULL, NULL, NULL, 'GNK2-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 244910),
(352875, 'PTHR32099:SF67', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 25', 244910),
(352876, 'PTHR32099:SF82', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH REPEAT SECRETORY PROTEIN 1', 244910),
(352877, 'PTHR32099:SF61', NULL, NULL, NULL, NULL, 'OS04G0316200 PROTEIN', 244910),
(352878, 'PTHR32099:SF62', NULL, NULL, NULL, NULL, 'OS01G0774133 PROTEIN', 244910),
(352879, 'PTHR32099:SF41', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH REPEAT SECRETORY PROTEIN 4-RELATED', 244910),
(352880, 'PTHR32099:SF63', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH REPEAT SECRETORY PROTEIN 38-LIKE', 244910),
(352881, 'PTHR32099:SF85', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH REPEAT SECRETORY PROTEIN 57-RELATED', 244910),
(352882, 'PTHR32518', NULL, NULL, NULL, NULL, '', 244911),
(352883, 'PTHR32518:SF3', NULL, NULL, NULL, NULL, 'AMYLOMALTASE', 244911),
(352884, 'PTHR20872:SF1', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 244912),
(352885, 'PTHR20872', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244912),
(352886, 'PTHR39332', NULL, NULL, NULL, NULL, 'BLL4707 PROTEIN', 244913),
(352887, 'PTHR39332:SF7', NULL, NULL, NULL, NULL, 'BLL4707 PROTEIN', 244913),
(352888, 'PTHR47155:SF1', NULL, NULL, NULL, NULL, 'CUB_2 DOMAIN-CONTAINING PROTEIN', 244914),
(352889, 'PTHR47155:SF2', NULL, NULL, NULL, NULL, 'CUB_2 DOMAIN-CONTAINING PROTEIN', 244914),
(352890, 'PTHR47155:SF3', NULL, NULL, NULL, NULL, 'CUB_2 DOMAIN-CONTAINING PROTEIN', 244914),
(352891, 'PTHR47155', NULL, NULL, NULL, NULL, 'DOWNSTREAM OF DAF-16 (REGULATED BY DAF-16)-RELATED', 244914),
(352892, 'PTHR42939:SF5', NULL, NULL, NULL, NULL, 'ABC-TYPE TRANSPORTER ATP-BINDING PROTEIN ECSA', 244915),
(352893, 'PTHR42939', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN ALBC-RELATED', 244915),
(352894, 'PTHR42939:SF3', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN', 244915),
(352895, 'PTHR42939:SF2', NULL, NULL, NULL, NULL, 'ABC-TYPE TRANSPORTER ATP-BINDING PROTEIN ECSA', 244915),
(352896, 'PTHR42939:SF1', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN ALBC-RELATED', 244915),
(352897, 'PTHR35256:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 8 OPEN READING FRAME 48', 244916),
(352898, 'PTHR35256', NULL, NULL, NULL, NULL, 'CHROMOSOME 8 OPEN READING FRAME 48', 244916),
(352899, 'PTHR12434:SF6', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 22', 244917),
(352900, 'PTHR12434', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 22', 244917),
(352901, 'PTHR24180:SF39', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 39', 244918),
(352902, 'PTHR24180:SF29', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE XBAT34-RELATED', 244918),
(352903, 'PTHR24180:SF37', NULL, NULL, NULL, NULL, 'REPEAT PROTEIN, PUTATIVE-RELATED', 244918),
(352904, 'PTHR24180:SF48', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 66', 244918),
(352905, 'PTHR24180:SF26', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN 39', 244918),
(352906, 'PTHR24180:SF49', NULL, NULL, NULL, NULL, 'PROTEIN SPT23', 244918),
(352907, 'PTHR24180:SF27', NULL, NULL, NULL, NULL, '2 OF PUTATIVE E3 UBIQUITIN-PROTEIN LIGASE XBAT35-RELATED', 244918),
(352908, 'PTHR24180:SF38', NULL, NULL, NULL, NULL, 'LP22840P', 244918),
(352909, 'PTHR24180:SF42', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 49', 244918),
(352910, 'PTHR24180:SF31', NULL, NULL, NULL, NULL, 'POLY [ADP-RIBOSE] POLYMERASE TANKYRASE', 244918),
(352911, 'PTHR24180:SF20', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244918),
(352912, 'PTHR24180:SF43', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING PROTEIN YCR051W', 244918),
(352913, 'PTHR24180:SF40', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 244918); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(352914, 'PTHR24180:SF41', NULL, NULL, NULL, NULL, 'GENE 15319-RELATED', 244918),
(352915, 'PTHR24180:SF46', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 244918),
(352916, 'PTHR24180:SF35', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 244918),
(352917, 'PTHR24180:SF47', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 49', 244918),
(352918, 'PTHR24180:SF36', NULL, NULL, NULL, NULL, '26S PROTEASOME REGULATORY SUBUNIT P28-RELATED', 244918),
(352919, 'PTHR24180:SF14', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 45', 244918),
(352920, 'PTHR24180:SF44', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 244918),
(352921, 'PTHR24180:SF11', NULL, NULL, NULL, NULL, 'POLY [ADP-RIBOSE] POLYMERASE TANKYRASE-2', 244918),
(352922, 'PTHR24180:SF45', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 244918),
(352923, 'PTHR24180:SF3', NULL, NULL, NULL, NULL, 'POLY [ADP-RIBOSE] POLYMERASE TANKYRASE-1', 244918),
(352924, 'PTHR24180', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR 2C-RELATED', 244918),
(352925, 'PTHR34184', NULL, NULL, NULL, NULL, 'UPF0718 PROTEIN YCGR', 244919),
(352926, 'PTHR34184:SF4', NULL, NULL, NULL, NULL, 'UPF0718 PROTEIN YCGR', 244919),
(352927, 'PTHR35153:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 154', 244920),
(352928, 'PTHR35153', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 154', 244920),
(352929, 'PTHR36562:SF5', NULL, NULL, NULL, NULL, 'RHODANESE DOMAIN-CONTAINING PROTEIN', 244921),
(352930, 'PTHR36562', NULL, NULL, NULL, NULL, 'SERINE/ARGININE REPETITIVE MATRIX 2', 244921),
(352931, 'PTHR36562:SF6', NULL, NULL, NULL, NULL, 'EG:133E12.4 PROTEIN', 244921),
(352932, 'PTHR43782:SF2', NULL, NULL, NULL, NULL, 'ARGINASE-1', 244922),
(352933, 'PTHR43782:SF4', NULL, NULL, NULL, NULL, 'ARGINASE-2, MITOCHONDRIAL', 244922),
(352934, 'PTHR43782:SF3', NULL, NULL, NULL, NULL, 'ARGINASE', 244922),
(352935, 'PTHR43782', NULL, NULL, NULL, NULL, 'ARGINASE', 244922),
(352936, 'PTHR12496:SF0', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE-LIKE PROTEIN 25', 244923),
(352937, 'PTHR12496:SF2', NULL, NULL, NULL, NULL, 'PROTEIN RRNAD1', 244923),
(352938, 'PTHR12496:SF8', NULL, NULL, NULL, NULL, '', 244923),
(352939, 'PTHR12496:SF7', NULL, NULL, NULL, NULL, 'METHYLTRANFER_DOM DOMAIN-CONTAINING PROTEIN', 244923),
(352940, 'PTHR12496', NULL, NULL, NULL, NULL, 'CGI-41 METHYLTRANSFERASE', 244923),
(352941, 'PTHR10901', NULL, NULL, NULL, NULL, 'TROPOMODULIN', 244924),
(352942, 'PTHR10901:SF3', NULL, NULL, NULL, NULL, 'LEIOMODIN-3', 244924),
(352943, 'PTHR10901:SF5', NULL, NULL, NULL, NULL, 'LEIOMODIN-1', 244924),
(352944, 'PTHR10901:SF6', NULL, NULL, NULL, NULL, 'TROPOMODULIN, ISOFORM N', 244924),
(352945, 'PTHR10901:SF8', NULL, NULL, NULL, NULL, 'TROPOMODULIN-1', 244924),
(352946, 'PTHR10901:SF15', NULL, NULL, NULL, NULL, 'TROPOMODULIN-2', 244924),
(352947, 'PTHR10901:SF9', NULL, NULL, NULL, NULL, 'TROPOMODULIN-4', 244924),
(352948, 'PTHR10901:SF16', NULL, NULL, NULL, NULL, 'TROPOMODULIN', 244924),
(352949, 'PTHR10901:SF18', NULL, NULL, NULL, NULL, 'TROPOMODULIN-3', 244924),
(352950, 'PTHR10901:SF12', NULL, NULL, NULL, NULL, 'LEIOMODIN-2', 244924),
(352951, 'PTHR12236:SF76', NULL, NULL, NULL, NULL, 'ADULT-SPECIFIC CUTICULAR PROTEIN ACP-20-LIKE PROTEIN', 244925),
(352952, 'PTHR12236:SF75', NULL, NULL, NULL, NULL, 'CUTICULAR PROTEIN 62BB, ISOFORM A', 244925),
(352953, 'PTHR12236:SF97', NULL, NULL, NULL, NULL, 'CUTICULAR PROTEIN 50CB-RELATED', 244925),
(352954, 'PTHR12236:SF86', NULL, NULL, NULL, NULL, 'CCP84AC-RELATED', 244925),
(352955, 'PTHR12236:SF85', NULL, NULL, NULL, NULL, 'PRO-RESILIN', 244925),
(352956, 'PTHR12236:SF96', NULL, NULL, NULL, NULL, 'PUPAL CUTICLE PROTEIN EDG-84A-LIKE PROTEIN', 244925),
(352957, 'PTHR12236:SF95', NULL, NULL, NULL, NULL, 'CUTICULAR PROTEIN 76BD, ISOFORM C-RELATED', 244925),
(352958, 'PTHR12236:SF94', NULL, NULL, NULL, NULL, 'CCP84AA-RELATED', 244925),
(352959, 'PTHR12236:SF92', NULL, NULL, NULL, NULL, 'CUTICULAR PROTEIN 92F', 244925);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(352960, 'PTHR12236:SF81', NULL, NULL, NULL, NULL, 'AGAP006867-PA', 244925),
(352961, 'PTHR12236:SF18', NULL, NULL, NULL, NULL, 'CUTICULAR PROTEIN 66D', 244925),
(352962, 'PTHR12236:SF29', NULL, NULL, NULL, NULL, 'CUTICULAR PROTEIN 64AC', 244925),
(352963, 'PTHR12236:SF7', NULL, NULL, NULL, NULL, 'CUTICULAR PROTEIN 57A, ISOFORM A', 244925),
(352964, 'PTHR12236:SF14', NULL, NULL, NULL, NULL, 'CUTICULAR PROTEIN 66CB', 244925),
(352965, 'PTHR12236:SF79', NULL, NULL, NULL, NULL, 'CUTICULAR PROTEIN 56F', 244925),
(352966, 'PTHR12236:SF46', NULL, NULL, NULL, NULL, 'CUTICULAR PROTEIN 30B-RELATED', 244925),
(352967, 'PTHR12236:SF80', NULL, NULL, NULL, NULL, 'CUTICULAR PROTEIN 62BC, ISOFORM A', 244925),
(352968, 'PTHR12236', NULL, NULL, NULL, NULL, 'STRUCTURAL CONTITUENT OF CUTICLE', 244925),
(352969, 'PTHR38503', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 1', 244926),
(352970, 'PTHR38503:SF1', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 1', 244926),
(352971, 'PTHR20981:SF33', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L21', 244927),
(352972, 'PTHR20981:SF21', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L21', 244927),
(352973, 'PTHR20981:SF30', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L21-A-RELATED', 244927),
(352974, 'PTHR20981:SF6', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L21', 244927),
(352975, 'PTHR20981:SF29', NULL, NULL, NULL, NULL, 'BNACNNG19840D PROTEIN', 244927),
(352976, 'PTHR20981:SF28', NULL, NULL, NULL, NULL, 'BNAA08G26210D PROTEIN', 244927),
(352977, 'PTHR20981:SF27', NULL, NULL, NULL, NULL, 'TRANSLATION PROTEIN SH3-LIKE FAMILY PROTEIN-RELATED', 244927),
(352978, 'PTHR20981:SF38', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L21', 244927),
(352979, 'PTHR20981', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L21', 244927),
(352980, 'PTHR20981:SF37', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L21', 244927),
(352981, 'PTHR20981:SF36', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L21', 244927),
(352982, 'PTHR20981:SF25', NULL, NULL, NULL, NULL, 'BNACNNG19850D PROTEIN', 244927),
(352983, 'PTHR20981:SF35', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L21-1', 244927),
(352984, 'PTHR20981:SF24', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L21', 244927),
(352985, 'PTHR20981:SF34', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L21', 244927),
(352986, 'PTHR20981:SF8', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L21', 244927),
(352987, 'PTHR31453:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 236', 244928),
(352988, 'PTHR31453', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 236', 244928),
(352989, 'PTHR36514:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG00436', 244929),
(352990, 'PTHR36514:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG13589', 244929),
(352991, 'PTHR36514', NULL, NULL, NULL, NULL, 'PROTEIN CBG00436', 244929),
(352992, 'PTHR35710:SF2', NULL, NULL, NULL, NULL, 'OBP3-RESPONSIVE GENE 4', 244930),
(352993, 'PTHR35710:SF1', NULL, NULL, NULL, NULL, 'OBP3-RESPONSIVE PROTEIN 4 (ORG4)', 244930),
(352994, 'PTHR35710:SF3', NULL, NULL, NULL, NULL, '', 244930),
(352995, 'PTHR35710', NULL, NULL, NULL, NULL, 'OBP3-RESPONSIVE PROTEIN 4 (ORG4)', 244930),
(352996, 'PTHR46241', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING PROTEIN 4 ARMC4', 244931),
(352997, 'PTHR46241:SF1', NULL, NULL, NULL, NULL, 'OUTER DYNEIN ARM-DOCKING COMPLEX SUBUNIT 2', 244931),
(352998, 'PTHR11777:SF35', NULL, NULL, NULL, NULL, 'ALANINE--TRNA LIGASE', 244932),
(352999, 'PTHR11777:SF36', NULL, NULL, NULL, NULL, 'ALANINE--TRNA LIGASE, CYTOPLASMIC', 244932),
(353000, 'PTHR11777', NULL, NULL, NULL, NULL, 'ALANYL-TRNA SYNTHETASE', 244932),
(353001, 'PTHR11777:SF32', NULL, NULL, NULL, NULL, 'AA_TRNA_LIGASE_II_ALA DOMAIN-CONTAINING PROTEIN', 244932),
(353002, 'PTHR11777:SF10', NULL, NULL, NULL, NULL, 'ALANINE--TRNA LIGASE, MITOCHONDRIAL', 244932),
(353003, 'PTHR11777:SF39', NULL, NULL, NULL, NULL, 'ALANINE--TRNA LIGASE, MITOCHONDRIAL', 244932),
(353004, 'PTHR11777:SF9', NULL, NULL, NULL, NULL, 'ALANINE--TRNA LIGASE, CYTOPLASMIC', 244932),
(353005, 'PTHR11777:SF38', NULL, NULL, NULL, NULL, 'ALANINE--TRNA LIGASE, CYTOPLASMIC', 244932);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(353006, 'PTHR11777:SF8', NULL, NULL, NULL, NULL, 'ALANINE--TRNA LIGASE, MITOCHONDRIAL', 244932),
(353007, 'PTHR19237', NULL, NULL, NULL, NULL, 'NUCLEOBINDIN', 244933),
(353008, 'PTHR19237:SF20', NULL, NULL, NULL, NULL, 'NUCB1', 244933),
(353009, 'PTHR19237:SF23', NULL, NULL, NULL, NULL, 'NUCB2B PROTEIN', 244933),
(353010, 'PTHR19237:SF22', NULL, NULL, NULL, NULL, 'NUCLEOBINDIN-2', 244933),
(353011, 'PTHR19237:SF21', NULL, NULL, NULL, NULL, 'NUCLEOBINDIN-1', 244933),
(353012, 'PTHR16560', NULL, NULL, NULL, NULL, 'ALPHA-2-MACROGLOBULIN RECEPTOR-ASSOCIATED PROTEIN', 244934),
(353013, 'PTHR16560:SF2', NULL, NULL, NULL, NULL, 'ALPHA-2-MACROGLOBULIN RECEPTOR-ASSOCIATED PROTEIN', 244934),
(353014, 'PTHR12100:SF1', NULL, NULL, NULL, NULL, 'RECYCLIN-1', 244935),
(353015, 'PTHR12100:SF2', NULL, NULL, NULL, NULL, '', 244935),
(353016, 'PTHR12100:SF0', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT 5', 244935),
(353017, 'PTHR12100:SF5', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT SEC10-LIKE PROTEIN-RELATED', 244935),
(353018, 'PTHR12100:SF3', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT SEC10', 244935),
(353019, 'PTHR12100:SF4', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT 5', 244935),
(353020, 'PTHR12100', NULL, NULL, NULL, NULL, 'SEC10', 244935),
(353021, 'PTHR45184:SF1', NULL, NULL, NULL, NULL, 'DNAJ PROTEIN ERDJ3A', 244936),
(353022, 'PTHR45184:SF2', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 16', 244936),
(353023, 'PTHR45184', NULL, NULL, NULL, NULL, 'DNAJ PROTEIN ERDJ3A', 244936),
(353024, 'PTHR38791', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED-RELATED', 244937),
(353025, 'PTHR38791:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, PUTATIVE-RELATED', 244937),
(353026, 'PTHR38791:SF5', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 244937),
(353027, 'PTHR38791:SF11', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 244937),
(353028, 'PTHR38791:SF12', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR DBAG-RELATED', 244937),
(353029, 'PTHR38791:SF13', NULL, NULL, NULL, NULL, 'ZN(2)-C6 FUNGAL-TYPE DOMAIN-CONTAINING PROTEIN', 244937),
(353030, 'PTHR10173:SF59', NULL, NULL, NULL, NULL, 'PEPTIDE METHIONINE SULFOXIDE REDUCTASE MSRA/MSRB 1', 244938),
(353031, 'PTHR10173:SF37', NULL, NULL, NULL, NULL, 'METHIONINE-R-SULFOXIDE REDUCTASE B2, MITOCHONDRIAL', 244938),
(353032, 'PTHR10173:SF58', NULL, NULL, NULL, NULL, 'PEPTIDE METHIONINE SULFOXIDE REDUCTASE MSRA/MSRB', 244938),
(353033, 'PTHR10173:SF57', NULL, NULL, NULL, NULL, 'PEPTIDE-METHIONINE (R)-S-OXIDE REDUCTASE', 244938),
(353034, 'PTHR10173:SF56', NULL, NULL, NULL, NULL, 'METHIONINE-R-SULFOXIDE REDUCTASE B3', 244938),
(353035, 'PTHR10173', NULL, NULL, NULL, NULL, 'METHIONINE SULFOXIDE REDUCTASE', 244938),
(353036, 'PTHR10173:SF52', NULL, NULL, NULL, NULL, 'METHIONINE-R-SULFOXIDE REDUCTASE B1', 244938),
(353037, 'PTHR43031:SF14', NULL, NULL, NULL, NULL, 'RHODANESE DOMAIN-CONTAINING PROTEIN', 244939),
(353038, 'PTHR43031:SF1', NULL, NULL, NULL, NULL, 'PHAGE SHOCK PROTEIN E-RELATED PROTEIN', 244939),
(353039, 'PTHR43031:SF13', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE-RELATED', 244939),
(353040, 'PTHR43031:SF10', NULL, NULL, NULL, NULL, 'RHODANESE DOMAIN-CONTAINING PROTEIN', 244939),
(353041, 'PTHR43031', NULL, NULL, NULL, NULL, 'FAD-DEPENDENT OXIDOREDUCTASE', 244939),
(353042, 'PTHR43031:SF9', NULL, NULL, NULL, NULL, 'RHODANESE-LIKE PROTEIN-RELATED', 244939),
(353043, 'PTHR43031:SF7', NULL, NULL, NULL, NULL, 'NITRIC OXIDE REDUCTASE FLRD-NAD(+) REDUCTASE', 244939),
(353044, 'PTHR43031:SF15', NULL, NULL, NULL, NULL, 'RHODANESE DOMAIN-CONTAINING PROTEIN', 244939),
(353045, 'PTHR43031:SF6', NULL, NULL, NULL, NULL, 'THIOSULFATE SULFURTRANSFERASE GLPE', 244939),
(353046, 'PTHR45774:SF8', NULL, NULL, NULL, NULL, '', 244940),
(353047, 'PTHR45774:SF3', NULL, NULL, NULL, NULL, 'BTB (POZ) DOMAIN-CONTAINING 2A-RELATED', 244940),
(353048, 'PTHR45774:SF2', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN 3', 244940),
(353049, 'PTHR45774:SF1', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN 1', 244940);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(353050, 'PTHR45774:SF7', NULL, NULL, NULL, NULL, 'AXUNDEAD, ISOFORM F', 244940),
(353051, 'PTHR45774', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING', 244940),
(353052, 'PTHR45774:SF6', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN 2', 244940),
(353053, 'PTHR45774:SF5', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN 6', 244940),
(353054, 'PTHR45774:SF4', NULL, NULL, NULL, NULL, 'LUTE, ISOFORM D', 244940),
(353055, 'PTHR15932', NULL, NULL, NULL, NULL, 'UBIQUITIN INTERACTION MOTIF-CONTAINING PROTEIN 1', 244941),
(353056, 'PTHR15932:SF2', NULL, NULL, NULL, NULL, 'BRCA1-A COMPLEX SUBUNIT RAP80', 244941),
(353057, 'PTHR40396', NULL, NULL, NULL, NULL, 'ATPASE-LIKE PROTEIN', 244942),
(353058, 'PTHR40396:SF1', NULL, NULL, NULL, NULL, 'ATPASE_AAA_CORE DOMAIN-CONTAINING PROTEIN', 244942),
(353059, 'PTHR24123:SF138', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 244943),
(353060, 'PTHR24123:SF137', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND KH DOMAIN-CONTAINING PROTEIN MASK-1', 244943),
(353061, 'PTHR24123:SF136', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX PROTEIN 10', 244943),
(353062, 'PTHR24123:SF49', NULL, NULL, NULL, NULL, 'ANKYRIN 2A, NEURONAL', 244943),
(353063, 'PTHR24123:SF135', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX PROTEIN 4', 244943),
(353064, 'PTHR24123:SF130', NULL, NULL, NULL, NULL, 'TANKYRASE-LIKE PROTEIN', 244943),
(353065, 'PTHR24123:SF134', NULL, NULL, NULL, NULL, 'PFS DOMAIN-CONTAINING PROTEIN', 244943),
(353066, 'PTHR24123:SF133', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 244943),
(353067, 'PTHR24123:SF132', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 244943),
(353068, 'PTHR24123:SF131', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX CONTAINING 3', 244943),
(353069, 'PTHR24123:SF82', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 6 REGULATORY ANKYRIN REPEAT SUBUNIT B', 244943),
(353070, 'PTHR24123:SF60', NULL, NULL, NULL, NULL, 'NACHT AND ANKYRIN DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_6G07030)', 244943),
(353071, 'PTHR24123:SF65', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 50', 244943),
(353072, 'PTHR24123:SF85', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 55', 244943),
(353073, 'PTHR24123:SF105', NULL, NULL, NULL, NULL, 'CARD- AND ANK-DOMAIN CONTAINING INFLAMMASOME ADAPTER PROTEIN', 244943),
(353074, 'PTHR24123:SF126', NULL, NULL, NULL, NULL, 'PROTEIN VAPYRIN-LIKE', 244943),
(353075, 'PTHR24123:SF124', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL CATION CHANNEL SUBFAMILY A MEMBER 1', 244943),
(353076, 'PTHR24123:SF129', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 244943),
(353077, 'PTHR24123:SF128', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 244943),
(353078, 'PTHR24123:SF122', NULL, NULL, NULL, NULL, 'PHOSPHATE SYSTEM POSITIVE REGULATORY PROTEIN PHO81', 244943),
(353079, 'PTHR24123', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING', 244943),
(353080, 'PTHR24123:SF73', NULL, NULL, NULL, NULL, 'OS02G0457500 PROTEIN', 244943),
(353081, 'PTHR24123:SF95', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 244943),
(353082, 'PTHR24123:SF71', NULL, NULL, NULL, NULL, 'ANKYRIN 1, ERYTHROCYTIC A', 244943),
(353083, 'PTHR24123:SF92', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN 50-LIKE', 244943),
(353084, 'PTHR24123:SF70', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 6 REGULATORY ANKYRIN REPEAT SUBUNIT C', 244943),
(353085, 'PTHR24123:SF33', NULL, NULL, NULL, NULL, 'ANKYRIN 2, ISOFORM U', 244943),
(353086, 'PTHR24123:SF54', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 244943),
(353087, 'PTHR24123:SF75', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 6 REGULATORY ANKYRIN REPEAT SUBUNIT A', 244943),
(353088, 'PTHR24123:SF74', NULL, NULL, NULL, NULL, 'ANKYRIN 3', 244943),
(353089, 'PTHR47812', NULL, NULL, NULL, NULL, 'SMR (SMALL MUTS RELATED) DOMAIN-CONTAINING PROTEIN', 244944);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(353090, 'PTHR47812:SF2', NULL, NULL, NULL, NULL, 'SMR (SMALL MUTS RELATED) DOMAIN-CONTAINING PROTEIN', 244944),
(353091, 'PTHR31133:SF9', NULL, NULL, NULL, NULL, '', 244945),
(353092, 'PTHR31133:SF8', NULL, NULL, NULL, NULL, 'OS04G0483200 PROTEIN', 244945),
(353093, 'PTHR31133:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 244945),
(353094, 'PTHR31133:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244945),
(353095, 'PTHR31133:SF18', NULL, NULL, NULL, NULL, 'BNAC06G13090D PROTEIN', 244945),
(353096, 'PTHR31133:SF15', NULL, NULL, NULL, NULL, '', 244945),
(353097, 'PTHR31133:SF16', NULL, NULL, NULL, NULL, 'BNAA06G32130D PROTEIN', 244945),
(353098, 'PTHR31133:SF13', NULL, NULL, NULL, NULL, 'BNAA02G28890D PROTEIN', 244945),
(353099, 'PTHR31133', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN', 244945),
(353100, 'PTHR31133:SF11', NULL, NULL, NULL, NULL, 'STEROID NUCLEAR RECEPTOR, LIGAND-BINDING', 244945),
(353101, 'PTHR31133:SF12', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN', 244945),
(353102, 'PTHR47830:SF1', NULL, NULL, NULL, NULL, 'OS11G0534100 PROTEIN', 244946),
(353103, 'PTHR47830:SF2', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 244946),
(353104, 'PTHR47830', NULL, NULL, NULL, NULL, 'OS11G0534100 PROTEIN', 244946),
(353105, 'PTHR43176:SF30', NULL, NULL, NULL, NULL, 'BNAA05G12620D PROTEIN', 244947),
(353106, 'PTHR43176:SF10', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 244947),
(353107, 'PTHR43176:SF33', NULL, NULL, NULL, NULL, '3-HYDROXYISOBUTYRYL-COA HYDROLASE 1', 244947),
(353108, 'PTHR43176:SF12', NULL, NULL, NULL, NULL, 'ACYLSUGAR ENOYL-COA HYDRATASE 1', 244947),
(353109, 'PTHR43176:SF34', NULL, NULL, NULL, NULL, '3-HYDROXYISOBUTYRYL-COA HYDROLASE 1-LIKE', 244947),
(353110, 'PTHR43176', NULL, NULL, NULL, NULL, '3-HYDROXYISOBUTYRYL-COA HYDROLASE-RELATED', 244947),
(353111, 'PTHR43176:SF13', NULL, NULL, NULL, NULL, '3-HYDROXYISOBUTYRYL-COA HYDROLASE, MITOCHONDRIAL', 244947),
(353112, 'PTHR43176:SF35', NULL, NULL, NULL, NULL, 'CLPP/CROTONASE-LIKE DOMAIN, ENOYL-COA HYDRATASE/ISOMERASE, HIBYL-COA-H TYPE-RELATED', 244947),
(353113, 'PTHR43176:SF36', NULL, NULL, NULL, NULL, 'BNAA02G34880D PROTEIN', 244947),
(353114, 'PTHR43176:SF14', NULL, NULL, NULL, NULL, '3-HYDROXYISOBUTYRYL-COA HYDROLASE-LIKE PROTEIN 2, MITOCHONDRIAL', 244947),
(353115, 'PTHR43176:SF15', NULL, NULL, NULL, NULL, '3-HYDROXYISOBUTYRYL-COA HYDROLASE, MITOCHONDRIAL', 244947),
(353116, 'PTHR43176:SF16', NULL, NULL, NULL, NULL, '3-HYDROXYISOBUTYRYL-COA HYDROLASE-LIKE PROTEIN 3, MITOCHONDRIAL', 244947),
(353117, 'PTHR43176:SF18', NULL, NULL, NULL, NULL, 'BNAA05G12590D PROTEIN', 244947),
(353118, 'PTHR43176:SF19', NULL, NULL, NULL, NULL, 'ENOYL-COA-HYDRATASE', 244947),
(353119, 'PTHR43176:SF21', NULL, NULL, NULL, NULL, '3-HYDROXYISOBUTYRYL-COA HYDROLASE-LIKE PROTEIN 3, MITOCHONDRIAL ISOFORM X1', 244947),
(353120, 'PTHR43176:SF22', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CASEINOLYTIC (CLP) PROTEASE/CROTONASE FAMILY PROTEIN-RELATED', 244947),
(353121, 'PTHR43176:SF24', NULL, NULL, NULL, NULL, '3-HYDROXYISOBUTYRYL-COA HYDROLASE-LIKE PROTEIN 5 ISOFORM X1', 244947),
(353122, 'PTHR43176:SF26', NULL, NULL, NULL, NULL, '3-HYDROXYBUTYRYL-COA DEHYDRATASE', 244947),
(353123, 'PTHR43176:SF27', NULL, NULL, NULL, NULL, '3-HYDROXYISOBUTYRYL-COA HYDROLASE-LIKE PROTEIN 5', 244947),
(353124, 'PTHR43176:SF28', NULL, NULL, NULL, NULL, 'BNAA08G28670D PROTEIN', 244947),
(353125, 'PTHR43176:SF1', NULL, NULL, NULL, NULL, '3-HYDROXYISOBUTYRYL-COA HYDROLASE, MITOCHONDRIAL', 244947),
(353126, 'PTHR43176:SF29', NULL, NULL, NULL, NULL, 'BNAA04G17110D PROTEIN', 244947),
(353127, 'PTHR43176:SF9', NULL, NULL, NULL, NULL, '3-HYDROXYISOBUTYRYL-COA HYDROLASE, MITOCHONDRIAL', 244947),
(353128, 'PTHR43176:SF7', NULL, NULL, NULL, NULL, '3-HYDROXYISOBUTYRYL-COA HYDROLASE, MITOCHONDRIAL', 244947),
(353129, 'PTHR43176:SF6', NULL, NULL, NULL, NULL, '3-HYDROXYISOBUTYRYL-COA HYDROLASE 3-RELATED', 244947),
(353130, 'PTHR43176:SF5', NULL, NULL, NULL, NULL, '3-HYDROXYISOBUTYRYL-COA HYDROLASE-LIKE PROTEIN 4, MITOCHONDRIAL', 244947),
(353131, 'PTHR43176:SF4', NULL, NULL, NULL, NULL, '3-HYDROXYISOBUTYRYL-COA HYDROLASE-LIKE PROTEIN 1, MITOCHONDRIAL', 244947);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(353132, 'PTHR43176:SF3', NULL, NULL, NULL, NULL, '3-HYDROXYISOBUTYRYL-COA HYDROLASE, MITOCHONDRIAL', 244947),
(353133, 'PTHR43176:SF2', NULL, NULL, NULL, NULL, '3-HYDROXYISOBUTYRYL-COA HYDROLASE-LIKE PROTEIN 5', 244947),
(353134, 'PTHR10188:SF41', NULL, NULL, NULL, NULL, 'ISOASPARTYL PEPTIDASE/L-ASPARAGINASE', 244948),
(353135, 'PTHR10188:SF42', NULL, NULL, NULL, NULL, 'SI:CH211-256M1.8', 244948),
(353136, 'PTHR10188', NULL, NULL, NULL, NULL, 'L-ASPARAGINASE', 244948),
(353137, 'PTHR10188:SF8', NULL, NULL, NULL, NULL, 'THREONINE ASPARTASE 1', 244948),
(353138, 'PTHR10188:SF16', NULL, NULL, NULL, NULL, 'ZGC:153169', 244948),
(353139, 'PTHR10188:SF36', NULL, NULL, NULL, NULL, 'PEPTIDASE T2, ASPARAGINASE 2, NUCLEOPHILE AMINOHYDROLASE-RELATED', 244948),
(353140, 'PTHR10188:SF6', NULL, NULL, NULL, NULL, 'N(4)-(BETA-N-ACETYLGLUCOSAMINYL)-L-ASPARAGINASE', 244948),
(353141, 'PTHR10188:SF37', NULL, NULL, NULL, NULL, 'ISOASPARTYL PEPTIDASE/L-ASPARAGINASE CG7860-RELATED', 244948),
(353142, 'PTHR10188:SF34', NULL, NULL, NULL, NULL, 'BNAC01G35480D PROTEIN', 244948),
(353143, 'PTHR10188:SF35', NULL, NULL, NULL, NULL, 'ASPARAGINASE-LIKE PROTEIN 1', 244948),
(353144, 'PTHR10188:SF13', NULL, NULL, NULL, NULL, 'ISOASPARTYL PEPTIDASE/L-ASPARAGINASE 2-RELATED', 244948),
(353145, 'PTHR10188:SF33', NULL, NULL, NULL, NULL, 'ISOASPARTYL PEPTIDASE/L-ASPARAGINASE-LIKE', 244948),
(353146, 'PTHR11119:SF3', NULL, NULL, NULL, NULL, 'LD30822P', 244949),
(353147, 'PTHR11119:SF84', NULL, NULL, NULL, NULL, 'OS03G0823800 PROTEIN', 244949),
(353148, 'PTHR11119:SF41', NULL, NULL, NULL, NULL, 'OS08G0420600 PROTEIN', 244949),
(353149, 'PTHR11119:SF57', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 23 MEMBER 3', 244949),
(353150, 'PTHR11119:SF58', NULL, NULL, NULL, NULL, 'PROTEIN CBG08341', 244949),
(353151, 'PTHR11119:SF97', NULL, NULL, NULL, NULL, 'NUCLEOBASE-ASCORBATE TRANSPORTER 4-LIKE', 244949),
(353152, 'PTHR11119:SF53', NULL, NULL, NULL, NULL, 'OS09G0381100 PROTEIN', 244949),
(353153, 'PTHR11119:SF98', NULL, NULL, NULL, NULL, 'NUCLEOBASE-ASCORBATE TRANSPORTER-LIKE PROTEIN', 244949),
(353154, 'PTHR11119:SF54', NULL, NULL, NULL, NULL, 'NUCLEOBASE-ASCORBATE TRANSPORTER 11', 244949),
(353155, 'PTHR11119:SF33', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 23 MEMBER 2', 244949),
(353156, 'PTHR11119', NULL, NULL, NULL, NULL, 'XANTHINE-URACIL / VITAMIN C PERMEASE FAMILY MEMBER', 244949),
(353157, 'PTHR11119:SF118', NULL, NULL, NULL, NULL, '', 244949),
(353158, 'PTHR11119:SF119', NULL, NULL, NULL, NULL, 'NUCLEOBASE-ASCORBATE TRANSPORTER-LIKE PROTEIN', 244949),
(353159, 'PTHR11119:SF116', NULL, NULL, NULL, NULL, '', 244949),
(353160, 'PTHR11119:SF117', NULL, NULL, NULL, NULL, 'NUCLEOBASE-ASCORBATE TRANSPORTER 2', 244949),
(353161, 'PTHR11119:SF17', NULL, NULL, NULL, NULL, 'PROTEIN CBG08364', 244949),
(353162, 'PTHR11119:SF115', NULL, NULL, NULL, NULL, 'PROTEIN CBG09535', 244949),
(353163, 'PTHR11119:SF112', NULL, NULL, NULL, NULL, 'NUCLEOBASE-ASCORBATE TRANSPORTER 6', 244949),
(353164, 'PTHR11119:SF113', NULL, NULL, NULL, NULL, 'NUCLEOBASE-ASCORBATE TRANSPORTER 6-LIKE ISOFORM X1', 244949),
(353165, 'PTHR11119:SF121', NULL, NULL, NULL, NULL, 'BNAC09G38690D PROTEIN', 244949),
(353166, 'PTHR11119:SF100', NULL, NULL, NULL, NULL, 'NUCLEOBASE-ASCORBATE TRANSPORTER 5', 244949),
(353167, 'PTHR11119:SF120', NULL, NULL, NULL, NULL, 'NUCLEOBASE-ASCORBATE TRANSPORTER 12-LIKE', 244949),
(353168, 'PTHR11119:SF50', NULL, NULL, NULL, NULL, 'NUCLEOBASE-ASCORBATE TRANSPORTER 7-RELATED', 244949),
(353169, 'PTHR11119:SF94', NULL, NULL, NULL, NULL, 'NUCLEOBASE-ASCORBATE TRANSPORTER 10-RELATED', 244949),
(353170, 'PTHR11119:SF95', NULL, NULL, NULL, NULL, 'NUCLEOBASE-ASCORBATE TRANSPORTER 6-LIKE', 244949),
(353171, 'PTHR11119:SF96', NULL, NULL, NULL, NULL, 'NUCLEOBASE-ASCORBATE TRANSPORTER 4', 244949),
(353172, 'PTHR11119:SF47', NULL, NULL, NULL, NULL, 'NUCLEOBASE-ASCORBATE TRANSPORTER 2', 244949),
(353173, 'PTHR11119:SF26', NULL, NULL, NULL, NULL, 'PROTEIN CBG01749', 244949),
(353174, 'PTHR11119:SF86', NULL, NULL, NULL, NULL, 'SI:DKEY-106N21.1', 244949);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(353175, 'PTHR11119:SF21', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 23 MEMBER 1', 244949),
(353176, 'PTHR11119:SF22', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 23 MEMBER 4', 244949),
(353177, 'PTHR11119:SF89', NULL, NULL, NULL, NULL, 'NUCLEOBASE-ASCORBATE TRANSPORTER-LIKE PROTEIN', 244949),
(353178, 'PTHR11119:SF105', NULL, NULL, NULL, NULL, 'XANTHINE/URACIL/VITAMIN C PERMEASE-RELATED', 244949),
(353179, 'PTHR11119:SF106', NULL, NULL, NULL, NULL, 'NUCLEOBASE-ASCORBATE TRANSPORTER 2', 244949),
(353180, 'PTHR11119:SF28', NULL, NULL, NULL, NULL, 'NUCLEOBASE-ASCORBATE TRANSPORTER 12', 244949),
(353181, 'PTHR11119:SF29', NULL, NULL, NULL, NULL, 'NUCLEOBASE-ASCORBATE TRANSPORTER 3', 244949),
(353182, 'PTHR11119:SF104', NULL, NULL, NULL, NULL, 'XANTHINE/URACIL/VITAMIN C PERMEASE-RELATED', 244949),
(353183, 'PTHR36495:SF2', NULL, NULL, NULL, NULL, '', 244950),
(353184, 'PTHR36495', NULL, NULL, NULL, NULL, '', 244950),
(353185, 'PTHR21237:SF41', NULL, NULL, NULL, NULL, 'GRPE PROTEIN HOMOLOG 2, MITOCHONDRIAL', 244951),
(353186, 'PTHR21237:SF40', NULL, NULL, NULL, NULL, 'CELL CYCLE AND APOPTOSIS REGULATOR PROTEIN 2', 244951),
(353187, 'PTHR21237:SF10', NULL, NULL, NULL, NULL, 'GRPE PROTEIN HOMOLOG 2, MITOCHONDRIAL', 244951),
(353188, 'PTHR21237', NULL, NULL, NULL, NULL, 'GRPE PROTEIN', 244951),
(353189, 'PTHR21237:SF23', NULL, NULL, NULL, NULL, 'GRPE PROTEIN HOMOLOG, MITOCHONDRIAL', 244951),
(353190, 'PTHR21237:SF36', NULL, NULL, NULL, NULL, 'GRPE PROTEIN HOMOLOG', 244951),
(353191, 'PTHR21237:SF25', NULL, NULL, NULL, NULL, 'GRPE PROTEIN HOMOLOG 1, MITOCHONDRIAL', 244951),
(353192, 'PTHR21237:SF27', NULL, NULL, NULL, NULL, 'GRPE PROTEIN HOMOLOG', 244951),
(353193, 'PTHR21237:SF37', NULL, NULL, NULL, NULL, 'GRPE PROTEIN HOMOLOG', 244951),
(353194, 'PTHR21237:SF39', NULL, NULL, NULL, NULL, 'GRPE PROTEIN HOMOLOG', 244951),
(353195, 'PTHR21237:SF28', NULL, NULL, NULL, NULL, 'GRPE PROTEIN HOMOLOG', 244951),
(353196, 'PTHR32341:SF10', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCIBLE GTPASE 5', 244952),
(353197, 'PTHR32341:SF2', NULL, NULL, NULL, NULL, 'INTERFERON-GAMMA-INDUCIBLE GTPASE IFGGA2 PROTEIN-RELATED', 244952),
(353198, 'PTHR32341:SF4', NULL, NULL, NULL, NULL, 'INTERFERON-GAMMA-INDUCIBLE GTPASE IFGGA3 PROTEIN-RELATED', 244952),
(353199, 'PTHR32341:SF14', NULL, NULL, NULL, NULL, 'IRG-TYPE G DOMAIN-CONTAINING PROTEIN', 244952),
(353200, 'PTHR32341:SF13', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN', 244952),
(353201, 'PTHR32341:SF6', NULL, NULL, NULL, NULL, 'IMMUNITY-RELATED GTPASE FAMILY M MEMBER 2-RELATED', 244952),
(353202, 'PTHR32341:SF9', NULL, NULL, NULL, NULL, 'IMMUNITY-RELATED GTPASE FAMILY M PROTEIN', 244952),
(353203, 'PTHR32341:SF15', NULL, NULL, NULL, NULL, 'RIKEN CDNA 9930111J21 GENE 1-RELATED', 244952),
(353204, 'PTHR32341', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCIBLE GTPASE', 244952),
(353205, 'PTHR16305:SF32', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE TYPE 10', 244953),
(353206, 'PTHR16305:SF35', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR DOMAIN', 244953),
(353207, 'PTHR16305:SF33', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE TYPE 10-LIKE', 244953),
(353208, 'PTHR16305', NULL, NULL, NULL, NULL, 'TESTICULAR SOLUBLE ADENYLYL CYCLASE', 244953),
(353209, 'PTHR16305:SF28', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE 10', 244953),
(353210, 'PTHR32468:SF101', NULL, NULL, NULL, NULL, 'CATION/H+ EXCHANGER 2', 244954),
(353211, 'PTHR32468:SF145', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 28', 244954),
(353212, 'PTHR32468:SF102', NULL, NULL, NULL, NULL, 'OS08G0117800 PROTEIN', 244954),
(353213, 'PTHR32468:SF143', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 15-LIKE', 244954),
(353214, 'PTHR32468:SF144', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 17', 244954),
(353215, 'PTHR32468:SF100', NULL, NULL, NULL, NULL, 'OS12G0616500 PROTEIN', 244954),
(353216, 'PTHR32468:SF141', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 244954),
(353217, 'PTHR32468:SF142', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 244954),
(353218, 'PTHR32468:SF140', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 244954);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(353219, 'PTHR32468:SF18', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 1', 244954),
(353220, 'PTHR32468:SF17', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 4', 244954),
(353221, 'PTHR32468:SF19', NULL, NULL, NULL, NULL, 'OS09G0545000 PROTEIN', 244954),
(353222, 'PTHR32468:SF109', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 24-RELATED', 244954),
(353223, 'PTHR32468:SF96', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 26-RELATED', 244954),
(353224, 'PTHR32468:SF95', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 15-LIKE', 244954),
(353225, 'PTHR32468:SF98', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 244954),
(353226, 'PTHR32468:SF97', NULL, NULL, NULL, NULL, 'CATION/H+ EXCHANGER 3', 244954),
(353227, 'PTHR32468:SF108', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 244954),
(353228, 'PTHR32468:SF105', NULL, NULL, NULL, NULL, 'CATION/H+ EXCHANGER 3', 244954),
(353229, 'PTHR32468:SF149', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 244954),
(353230, 'PTHR32468:SF11', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 244954),
(353231, 'PTHR32468:SF99', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 18-LIKE', 244954),
(353232, 'PTHR32468:SF103', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 16', 244954),
(353233, 'PTHR32468:SF148', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 244954),
(353234, 'PTHR32468:SF104', NULL, NULL, NULL, NULL, 'CATION/H+ EXCHANGER 3', 244954),
(353235, 'PTHR32468:SF134', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 244954),
(353236, 'PTHR32468:SF90', NULL, NULL, NULL, NULL, 'OS05G0473401 PROTEIN', 244954),
(353237, 'PTHR32468:SF132', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 21-RELATED', 244954),
(353238, 'PTHR32468:SF133', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 244954),
(353239, 'PTHR32468:SF130', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-KINASE ALPHA 1', 244954),
(353240, 'PTHR32468:SF92', NULL, NULL, NULL, NULL, 'CATION/H+ EXCHANGER 3', 244954),
(353241, 'PTHR32468:SF94', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 244954),
(353242, 'PTHR32468:SF93', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 5-RELATED', 244954),
(353243, 'PTHR32468:SF170', NULL, NULL, NULL, NULL, 'CATION/H+ EXCHANGER 3', 244954),
(353244, 'PTHR32468:SF171', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 244954),
(353245, 'PTHR32468', NULL, NULL, NULL, NULL, 'CATION/H +  ANTIPORTER', 244954),
(353246, 'PTHR32468:SF84', NULL, NULL, NULL, NULL, 'OS05G0382200 PROTEIN', 244954),
(353247, 'PTHR32468:SF86', NULL, NULL, NULL, NULL, 'OS11G0123600 PROTEIN', 244954),
(353248, 'PTHR32468:SF139', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 244954),
(353249, 'PTHR32468:SF167', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 18-LIKE', 244954),
(353250, 'PTHR32468:SF123', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 244954),
(353251, 'PTHR32468:SF168', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 15-LIKE', 244954),
(353252, 'PTHR32468:SF124', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 244954),
(353253, 'PTHR32468:SF165', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 3-LIKE', 244954),
(353254, 'PTHR32468:SF166', NULL, NULL, NULL, NULL, 'CATION/H+ EXCHANGER 3', 244954),
(353255, 'PTHR32468:SF122', NULL, NULL, NULL, NULL, 'OS03G0828600 PROTEIN', 244954),
(353256, 'PTHR32468:SF81', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 19', 244954),
(353257, 'PTHR32468:SF163', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 15-LIKE', 244954),
(353258, 'PTHR32468:SF120', NULL, NULL, NULL, NULL, 'CATION/H+ EXCHANGER 3', 244954),
(353259, 'PTHR32468:SF164', NULL, NULL, NULL, NULL, 'OS05G0485000 PROTEIN', 244954),
(353260, 'PTHR32468:SF161', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 244954),
(353261, 'PTHR32468:SF82', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 15-LIKE', 244954),
(353262, 'PTHR32468:SF160', NULL, NULL, NULL, NULL, 'CATION/H+ EXCHANGER 3', 244954);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(353263, 'PTHR32468:SF30', NULL, NULL, NULL, NULL, 'OS12G0109150 PROTEIN', 244954),
(353264, 'PTHR32468:SF74', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 244954),
(353265, 'PTHR32468:SF73', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 6A-RELATED', 244954),
(353266, 'PTHR32468:SF31', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 1', 244954),
(353267, 'PTHR32468:SF34', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 18', 244954),
(353268, 'PTHR32468:SF77', NULL, NULL, NULL, NULL, 'CATION/H+ EXCHANGER 3', 244954),
(353269, 'PTHR32468:SF128', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 244954),
(353270, 'PTHR32468:SF169', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 10-RELATED', 244954),
(353271, 'PTHR32468:SF35', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 244954),
(353272, 'PTHR32468:SF156', NULL, NULL, NULL, NULL, 'CATION/H+ EXCHANGER 16-RELATED', 244954),
(353273, 'PTHR32468:SF0', NULL, NULL, NULL, NULL, 'K(+)/H(+) ANTIPORTER 1', 244954),
(353274, 'PTHR32468:SF154', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 18-LIKE', 244954),
(353275, 'PTHR32468:SF110', NULL, NULL, NULL, NULL, 'CATION/H+ EXCHANGER 3', 244954),
(353276, 'PTHR32468:SF152', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 12', 244954),
(353277, 'PTHR32468:SF150', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 244954),
(353278, 'PTHR32468:SF72', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 19', 244954),
(353279, 'PTHR32468:SF151', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 244954),
(353280, 'PTHR32468:SF71', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 2', 244954),
(353281, 'PTHR32468:SF26', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 15', 244954),
(353282, 'PTHR32468:SF63', NULL, NULL, NULL, NULL, 'OS01G0817400 PROTEIN', 244954),
(353283, 'PTHR32468:SF118', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 3', 244954),
(353284, 'PTHR32468:SF119', NULL, NULL, NULL, NULL, 'CATION/H(+) SYMPORTER 13', 244954),
(353285, 'PTHR32468:SF23', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 14', 244954),
(353286, 'PTHR32468:SF67', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 6B', 244954),
(353287, 'PTHR32468:SF117', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 18-LIKE', 244954),
(353288, 'PTHR32468:SF66', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 244954),
(353289, 'PTHR32468:SF22', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 3-LIKE ISOFORM X1', 244954),
(353290, 'PTHR32468:SF69', NULL, NULL, NULL, NULL, 'CATION/H(+) ANTIPORTER 9', 244954),
(353291, 'PTHR32468:SF114', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 244954),
(353292, 'PTHR32468:SF159', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 244954),
(353293, 'PTHR32468:SF68', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 244954),
(353294, 'PTHR32468:SF115', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 244954),
(353295, 'PTHR47805', NULL, NULL, NULL, NULL, 'SAGA-ASSOCIATED FACTOR 73', 244955),
(353296, 'PTHR47805:SF1', NULL, NULL, NULL, NULL, 'SAGA-ASSOCIATED FACTOR 73', 244955),
(353297, 'PTHR12805:SF4', NULL, NULL, NULL, NULL, 'KIN17_MID DOMAIN-CONTAINING PROTEIN', 244956),
(353298, 'PTHR12805', NULL, NULL, NULL, NULL, 'KIN17  KIN, ANTIGENIC DETERMINANT OF RECA PROTEIN HOMOLOG', 244956),
(353299, 'PTHR12805:SF0', NULL, NULL, NULL, NULL, 'DNA/RNA-BINDING PROTEIN KIN17', 244956),
(353300, 'PTHR12805:SF1', NULL, NULL, NULL, NULL, 'KIN17_MID DOMAIN-CONTAINING PROTEIN', 244956),
(353301, 'PTHR36736', NULL, NULL, NULL, NULL, 'OS03G0100030 PROTEIN', 244957),
(353302, 'PTHR36736:SF1', NULL, NULL, NULL, NULL, 'OS03G0100030 PROTEIN', 244957),
(353303, 'PTHR36736:SF2', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 244957),
(353304, 'PTHR36736:SF4', NULL, NULL, NULL, NULL, 'BNAA05G08710D PROTEIN', 244957),
(353305, 'PTHR14696:SF2', NULL, NULL, NULL, NULL, 'HERMANSKY-PUDLAK SYNDROME 6 PROTEIN', 244958),
(353306, 'PTHR14696', NULL, NULL, NULL, NULL, 'HERMANSKY-PUDLAK SYNDROME 6 PROTEIN', 244958);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(353307, 'PTHR47256:SF3', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 244959),
(353308, 'PTHR47256:SF4', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 244959),
(353309, 'PTHR47256:SF5', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 244959),
(353310, 'PTHR47256:SF6', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 244959),
(353311, 'PTHR47256:SF9', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 244959),
(353312, 'PTHR47256', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 244959),
(353313, 'PTHR47256:SF1', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 244959),
(353314, 'PTHR35569', NULL, NULL, NULL, NULL, '', 244960),
(353315, 'PTHR35569:SF7', NULL, NULL, NULL, NULL, 'HYDRO-LYASE/CYANAMIDE HYDRATASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G10870)-RELATED', 244960),
(353316, 'PTHR35569:SF1', NULL, NULL, NULL, NULL, 'CYANAMIDE HYDRATASE DDI2-RELATED', 244960),
(353317, 'PTHR16757', NULL, NULL, NULL, NULL, 'DENDRIN', 244961),
(353318, 'PTHR16757:SF1', NULL, NULL, NULL, NULL, 'DENDRIN', 244961),
(353319, 'PTHR47336:SF4', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 244962),
(353320, 'PTHR47336:SF3', NULL, NULL, NULL, NULL, 'SERINE-RICH PROTEIN TYE7', 244962),
(353321, 'PTHR47336', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR HMS1-RELATED', 244962),
(353322, 'PTHR47336:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR HMS1-RELATED', 244962),
(353323, 'PTHR13399:SF2', NULL, NULL, NULL, NULL, 'TRANSLOCON-ASSOCIATED PROTEIN SUBUNIT GAMMA', 244963),
(353324, 'PTHR13399', NULL, NULL, NULL, NULL, 'TRANSLOCON-ASSOCIATED PROTEIN  TRAP , GAMMA SUBUNIT', 244963),
(353325, 'PTHR22930:SF241', NULL, NULL, NULL, NULL, 'OS08G0106900 PROTEIN', 244964),
(353326, 'PTHR22930:SF242', NULL, NULL, NULL, NULL, 'LOW PROTEIN: NUCLEASE-LIKE PROTEIN', 244964),
(353327, 'PTHR22930:SF220', NULL, NULL, NULL, NULL, 'SIMILAR TO ENSANGP00000010363', 244964),
(353328, 'PTHR22930:SF240', NULL, NULL, NULL, NULL, 'HARBINGER TRANSPOSASE-DERIVED NUCLEASE', 244964),
(353329, 'PTHR22930', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244964),
(353330, 'PTHR22930:SF245', NULL, NULL, NULL, NULL, 'LD12639P', 244964),
(353331, 'PTHR22930:SF246', NULL, NULL, NULL, NULL, 'TRANSPOSASE-RELATED', 244964),
(353332, 'PTHR22930:SF169', NULL, NULL, NULL, NULL, 'DDE TNP4 DOMAIN-CONTAINING PROTEIN', 244964),
(353333, 'PTHR22930:SF243', NULL, NULL, NULL, NULL, 'OS01G0186900 PROTEIN', 244964),
(353334, 'PTHR22930:SF221', NULL, NULL, NULL, NULL, 'DDE TNP4 DOMAIN-CONTAINING PROTEIN', 244964),
(353335, 'PTHR22930:SF244', NULL, NULL, NULL, NULL, 'OS05G0593000 PROTEIN', 244964),
(353336, 'PTHR22930:SF205', NULL, NULL, NULL, NULL, 'PROTEIN ALP1-LIKE', 244964),
(353337, 'PTHR22930:SF227', NULL, NULL, NULL, NULL, 'NUCLEASE HARBI1-RELATED', 244964),
(353338, 'PTHR22930:SF249', NULL, NULL, NULL, NULL, '', 244964),
(353339, 'PTHR22930:SF228', NULL, NULL, NULL, NULL, 'OS11G0577650 PROTEIN', 244964),
(353340, 'PTHR22930:SF206', NULL, NULL, NULL, NULL, 'DDE TNP4 DOMAIN-CONTAINING PROTEIN-RELATED', 244964),
(353341, 'PTHR22930:SF247', NULL, NULL, NULL, NULL, 'PROTEIN ANTAGONIST OF LIKE HETEROCHROMATIN PROTEIN 1', 244964),
(353342, 'PTHR22930:SF226', NULL, NULL, NULL, NULL, 'NUCLEASE', 244964),
(353343, 'PTHR22930:SF248', NULL, NULL, NULL, NULL, '', 244964),
(353344, 'PTHR22930:SF252', NULL, NULL, NULL, NULL, 'HARBINGER TRANSPOSASE-DERIVED NUCLEASE', 244964),
(353345, 'PTHR22930:SF253', NULL, NULL, NULL, NULL, 'NUCLEASE HARBI1-RELATED', 244964),
(353346, 'PTHR22930:SF198', NULL, NULL, NULL, NULL, 'DDE TNP4 DOMAIN-CONTAINING PROTEIN', 244964),
(353347, 'PTHR22930:SF173', NULL, NULL, NULL, NULL, 'DDE TNP4 DOMAIN-CONTAINING PROTEIN', 244964),
(353348, 'PTHR22930:SF250', NULL, NULL, NULL, NULL, 'NUCLEASE HARBI1-LIKE PROTEIN-RELATED', 244964),
(353349, 'PTHR22930:SF251', NULL, NULL, NULL, NULL, 'NUCLEASE HARBI1-RELATED', 244964);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(353350, 'PTHR22930:SF174', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244964),
(353351, 'PTHR22930:SF256', NULL, NULL, NULL, NULL, 'NUCLEASE', 244964),
(353352, 'PTHR22930:SF257', NULL, NULL, NULL, NULL, 'HARBINGER TRANSPOSASE-DERIVED NUCLEASE', 244964),
(353353, 'PTHR22930:SF199', NULL, NULL, NULL, NULL, 'DDE TNP4 DOMAIN-CONTAINING PROTEIN', 244964),
(353354, 'PTHR22930:SF254', NULL, NULL, NULL, NULL, 'NUCLEASE HARBI1-RELATED', 244964),
(353355, 'PTHR22930:SF255', NULL, NULL, NULL, NULL, 'ELONGIN B', 244964),
(353356, 'PTHR22930:SF190', NULL, NULL, NULL, NULL, 'OS06G0164500 PROTEIN', 244964),
(353357, 'PTHR22930:SF193', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DOMAIN, HARBINGER TRANSPOSASE-DERIVED NUCLEASE DOMAIN PROTEIN-RELATED', 244964),
(353358, 'PTHR22930:SF191', NULL, NULL, NULL, NULL, 'ZMP:0000000634', 244964),
(353359, 'PTHR22930:SF192', NULL, NULL, NULL, NULL, 'DDE TNP4 DOMAIN-CONTAINING PROTEIN', 244964),
(353360, 'PTHR22930:SF238', NULL, NULL, NULL, NULL, 'OS01G0582600 PROTEIN', 244964),
(353361, 'PTHR22930:SF239', NULL, NULL, NULL, NULL, 'DDE TNP4 DOMAIN-CONTAINING PROTEIN', 244964),
(353362, 'PTHR22930:SF258', NULL, NULL, NULL, NULL, 'SI:DKEY-228L14.1', 244964),
(353363, 'PTHR22930:SF236', NULL, NULL, NULL, NULL, 'DDE TNP4 DOMAIN-CONTAINING PROTEIN', 244964),
(353364, 'PTHR22930:SF237', NULL, NULL, NULL, NULL, 'AGAP013326-PA', 244964),
(353365, 'PTHR22930:SF259', NULL, NULL, NULL, NULL, 'DDE TNP4 DOMAIN-CONTAINING PROTEIN', 244964),
(353366, 'PTHR22930:SF85', NULL, NULL, NULL, NULL, 'GH03217P-RELATED', 244964),
(353367, 'PTHR22930:SF64', NULL, NULL, NULL, NULL, 'OS05G0184901 PROTEIN', 244964),
(353368, 'PTHR36053', NULL, NULL, NULL, NULL, 'OSJNBB0017I01.18 PROTEIN', 244965),
(353369, 'PTHR36053:SF1', NULL, NULL, NULL, NULL, 'OS04G0680300 PROTEIN', 244965),
(353370, 'PTHR36053:SF2', NULL, NULL, NULL, NULL, '', 244965),
(353371, 'PTHR21500:SF3', NULL, NULL, NULL, NULL, 'TUBULIN-SPECIFIC CHAPERONE A', 244966),
(353372, 'PTHR21500:SF4', NULL, NULL, NULL, NULL, 'TUBULIN-SPECIFIC CHAPERONE A', 244966),
(353373, 'PTHR21500', NULL, NULL, NULL, NULL, 'TUBULIN-SPECIFIC CHAPERONE A', 244966),
(353374, 'PTHR21500:SF2', NULL, NULL, NULL, NULL, 'TUBULIN-SPECIFIC CHAPERONE A', 244966),
(353375, 'PTHR21500:SF0', NULL, NULL, NULL, NULL, 'TUBULIN-SPECIFIC CHAPERONE A', 244966),
(353376, 'PTHR23245:SF41', NULL, NULL, NULL, NULL, 'TRNA(PHE) (4-DEMETHYLWYOSINE(37)-C(7)) AMINOCARBOXYPROPYLTRANSFERASE', 244967),
(353377, 'PTHR23245:SF42', NULL, NULL, NULL, NULL, 'TRNA (GUANINE(37)-N1)-METHYLTRANSFERASE 1', 244967),
(353378, 'PTHR23245:SF31', NULL, NULL, NULL, NULL, 'TRNA WYBUTOSINE-SYNTHESIZING PROTEIN 3 HOMOLOG', 244967),
(353379, 'PTHR23245:SF40', NULL, NULL, NULL, NULL, 'TRNA(PHE) 7-((3-AMINO-3-CARBOXYPROPYL)-4-DEMETHYLWYOSINE(37)-N(4))-METHYLTRANSFERASE', 244967),
(353380, 'PTHR23245:SF25', NULL, NULL, NULL, NULL, 'TRNA WYBUTOSINE-SYNTHESIZING PROTEIN 2 HOMOLOG', 244967),
(353381, 'PTHR23245:SF36', NULL, NULL, NULL, NULL, 'TRNA (GUANINE(37)-N1)-METHYLTRANSFERASE', 244967),
(353382, 'PTHR23245', NULL, NULL, NULL, NULL, 'TRNA METHYLTRANSFERASE', 244967),
(353383, 'PTHR38612', NULL, NULL, NULL, NULL, 'PROTEIN DCT-5-RELATED', 244968),
(353384, 'PTHR38612:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG06620', 244968),
(353385, 'PTHR38612:SF2', NULL, NULL, NULL, NULL, 'PROTEIN DCT-5', 244968),
(353386, 'PTHR47471', NULL, NULL, NULL, NULL, 'GYF DOMAIN-CONTAINING PROTEIN', 244969),
(353387, 'PTHR47471:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ESSENTIAL FOR POTEXVIRUS ACCUMULATION 1', 244969),
(353388, 'PTHR47471:SF2', NULL, NULL, NULL, NULL, 'GYF DOMAIN-CONTAINING PROTEIN', 244969),
(353389, 'PTHR19278:SF41', NULL, NULL, NULL, NULL, 'PYRE-LIKE PROTEIN', 244970),
(353390, 'PTHR19278:SF40', NULL, NULL, NULL, NULL, 'URIDINE 5''-MONOPHOSPHATE SYNTHASE', 244970),
(353391, 'PTHR19278:SF43', NULL, NULL, NULL, NULL, 'OMPDECASE', 244970),
(353392, 'PTHR19278:SF42', NULL, NULL, NULL, NULL, 'OROTATE PHOSPHORIBOSYLTRANSFERASE', 244970),
(353393, 'PTHR19278:SF33', NULL, NULL, NULL, NULL, 'OROTATE PHOSPHORIBOSYLTRANSFERASE', 244970); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(353394, 'PTHR19278:SF9', NULL, NULL, NULL, NULL, 'URIDINE 5''-MONOPHOSPHATE SYNTHASE', 244970),
(353395, 'PTHR19278', NULL, NULL, NULL, NULL, 'OROTATE PHOSPHORIBOSYLTRANSFERASE', 244970),
(353396, 'PTHR31740', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN L', 244971),
(353397, 'PTHR31740:SF2', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN L', 244971),
(353398, 'PTHR46247:SF1', NULL, NULL, NULL, NULL, 'CRS2-ASSOCIATED FACTOR 1, CHLOROPLASTIC', 244972),
(353399, 'PTHR46247:SF3', NULL, NULL, NULL, NULL, 'CRS2-ASSOCIATED FACTOR 2, CHLOROPLASTIC', 244972),
(353400, 'PTHR46247:SF2', NULL, NULL, NULL, NULL, 'CRS2-ASSOCIATED FACTOR 1, MITOCHONDRIAL', 244972),
(353401, 'PTHR46247', NULL, NULL, NULL, NULL, 'CRS2-ASSOCIATED FACTOR 1, CHLOROPLASTIC', 244972),
(353402, 'PTHR46247:SF4', NULL, NULL, NULL, NULL, 'CRS2-ASSOCIATED FACTOR 2, MITOCHONDRIAL', 244972),
(353403, 'PTHR35450', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 244973),
(353404, 'PTHR35450:SF1', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 244973),
(353405, 'PTHR21520:SF2', NULL, NULL, NULL, NULL, 'GLUTAMATE-RICH PROTEIN 2', 244974),
(353406, 'PTHR21520', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244974),
(353407, 'PTHR39425:SF1', NULL, NULL, NULL, NULL, 'MULTIHEME_CYTC DOMAIN-CONTAINING PROTEIN', 244975),
(353408, 'PTHR39425', NULL, NULL, NULL, NULL, 'LIPOPROTEIN CYTOCHROME C', 244975),
(353409, 'PTHR14490:SF5', NULL, NULL, NULL, NULL, 'PROTEIN KRI1 HOMOLOG', 244976),
(353410, 'PTHR14490', NULL, NULL, NULL, NULL, 'ZINC FINGER, ZZ TYPE', 244976),
(353411, 'PTHR16011', NULL, NULL, NULL, NULL, 'IFT57/HIPPI', 244977),
(353412, 'PTHR16011:SF0', NULL, NULL, NULL, NULL, 'INTRAFLAGELLAR TRANSPORT PROTEIN 57 HOMOLOG', 244977),
(353413, 'PTHR31995', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR IIS FAMILY PROTEIN-RELATED', 244978),
(353414, 'PTHR31995:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR IIS FAMILY PROTEIN', 244978),
(353415, 'PTHR31995:SF9', NULL, NULL, NULL, NULL, 'TFIIS N-TERMINAL DOMAIN-CONTAINING PROTEIN', 244978),
(353416, 'PTHR31995:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR (TFIIS) FAMILY PROTEIN', 244978),
(353417, 'PTHR31995:SF10', NULL, NULL, NULL, NULL, 'BNAA05G35150D PROTEIN', 244978),
(353418, 'PTHR31988:SF29', NULL, NULL, NULL, NULL, 'SGNH HYDROLASE-TYPE ESTERASE DOMAIN-CONTAINING PROTEIN-RELATED', 244979),
(353419, 'PTHR31988:SF17', NULL, NULL, NULL, NULL, 'SASA DOMAIN-CONTAINING PROTEIN', 244979),
(353420, 'PTHR31988:SF28', NULL, NULL, NULL, NULL, 'SASA DOMAIN-CONTAINING PROTEIN', 244979),
(353421, 'PTHR31988:SF27', NULL, NULL, NULL, NULL, 'SASA DOMAIN-CONTAINING PROTEIN', 244979),
(353422, 'PTHR31988:SF26', NULL, NULL, NULL, NULL, 'SGNH HYDROLASE-TYPE ESTERASE DOMAIN-CONTAINING PROTEIN-RELATED', 244979),
(353423, 'PTHR31988:SF15', NULL, NULL, NULL, NULL, 'ESTERASE, PUTATIVE (DUF303)-RELATED', 244979),
(353424, 'PTHR31988:SF14', NULL, NULL, NULL, NULL, 'SASA DOMAIN-CONTAINING PROTEIN', 244979),
(353425, 'PTHR31988:SF13', NULL, NULL, NULL, NULL, 'SASA DOMAIN-CONTAINING PROTEIN', 244979),
(353426, 'PTHR31988:SF24', NULL, NULL, NULL, NULL, 'HYDROLASE', 244979),
(353427, 'PTHR31988:SF5', NULL, NULL, NULL, NULL, 'OS04G0110400 PROTEIN', 244979),
(353428, 'PTHR31988:SF23', NULL, NULL, NULL, NULL, 'CARBOHYDRATE ESTERASE-RELATED', 244979),
(353429, 'PTHR31988:SF22', NULL, NULL, NULL, NULL, 'SASA DOMAIN-CONTAINING PROTEIN', 244979),
(353430, 'PTHR31988:SF33', NULL, NULL, NULL, NULL, 'SGNH HYDROLASE-TYPE ESTERASE DOMAIN-CONTAINING PROTEIN-RELATED', 244979),
(353431, 'PTHR31988:SF11', NULL, NULL, NULL, NULL, 'SASA DOMAIN-CONTAINING PROTEIN', 244979),
(353432, 'PTHR31988:SF9', NULL, NULL, NULL, NULL, 'SASA DOMAIN-CONTAINING PROTEIN', 244979),
(353433, 'PTHR31988:SF8', NULL, NULL, NULL, NULL, 'CARBOHYDRATE ESTERASE', 244979),
(353434, 'PTHR31988:SF19', NULL, NULL, NULL, NULL, '9-O-ACETYL-N-ACETYLNEURAMINIC ACID DEACETYLASE-RELATED', 244979),
(353435, 'PTHR31988', NULL, NULL, NULL, NULL, 'ESTERASE, PUTATIVE (DUF303)-RELATED', 244979),
(353436, 'PTHR31988:SF21', NULL, NULL, NULL, NULL, 'SASA DOMAIN-CONTAINING PROTEIN', 244979);
INSERT INTO "PUBLIC"."MODEL" VALUES
(353437, 'PTHR31988:SF10', NULL, NULL, NULL, NULL, 'SASA DOMAIN-CONTAINING PROTEIN', 244979),
(353438, 'PTHR31988:SF32', NULL, NULL, NULL, NULL, 'CARBOHYDRATE ESTERASE-RELATED', 244979),
(353439, 'PTHR31988:SF20', NULL, NULL, NULL, NULL, 'SASA DOMAIN-CONTAINING PROTEIN', 244979),
(353440, 'PTHR36973:SF4', NULL, NULL, NULL, NULL, 'NODULATION PROTEIN', 244980),
(353441, 'PTHR36973', NULL, NULL, NULL, NULL, 'SLL1456 PROTEIN-RELATED', 244980),
(353442, 'PTHR40629:SF1', NULL, NULL, NULL, NULL, 'PRO41 PROTEIN', 244981),
(353443, 'PTHR40629', NULL, NULL, NULL, NULL, 'PRO41 PROTEIN', 244981),
(353444, 'PTHR35155:SF1', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 24', 244982),
(353445, 'PTHR35155', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 24', 244982),
(353446, 'PTHR20772:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FMP42', 244983),
(353447, 'PTHR20772:SF4', NULL, NULL, NULL, NULL, 'HYPOTHETICAL AMINO ACID TRANSPORTER (EUROFUNG)', 244983),
(353448, 'PTHR20772:SF5', NULL, NULL, NULL, NULL, '', 244983),
(353449, 'PTHR20772', NULL, NULL, NULL, NULL, 'PROTEIN FMP42', 244983),
(353450, 'PTHR28280:SF1', NULL, NULL, NULL, NULL, 'SHUTTLING PRE-60S FACTOR ECM1', 244984),
(353451, 'PTHR28280', NULL, NULL, NULL, NULL, 'SHUTTLING PRE-60S FACTOR ECM1', 244984),
(353452, 'PTHR22966', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 244985),
(353453, 'PTHR22966:SF29', NULL, NULL, NULL, NULL, 'PLANT CYSTEINE OXIDASE 3', 244985),
(353454, 'PTHR22966:SF1', NULL, NULL, NULL, NULL, 'PLANT CYSTEINE OXIDASE 1', 244985),
(353455, 'PTHR22966:SF67', NULL, NULL, NULL, NULL, 'CYSTEINE DIOXYGENASE', 244985),
(353456, 'PTHR22966:SF66', NULL, NULL, NULL, NULL, 'CYSTEINE DIOXYGENASE', 244985),
(353457, 'PTHR22966:SF54', NULL, NULL, NULL, NULL, 'CYSTEINE DIOXYGENASE', 244985),
(353458, 'PTHR22966:SF65', NULL, NULL, NULL, NULL, 'PLANT CYSTEINE OXIDASE 2', 244985),
(353459, 'PTHR22966:SF31', NULL, NULL, NULL, NULL, 'CYSTEINE DIOXYGENASE', 244985),
(353460, 'PTHR22966:SF64', NULL, NULL, NULL, NULL, 'CYSTEINE DIOXYGENASE', 244985),
(353461, 'PTHR22966:SF53', NULL, NULL, NULL, NULL, 'CYSTEINE DIOXYGENASE', 244985),
(353462, 'PTHR22966:SF37', NULL, NULL, NULL, NULL, 'PLANT CYSTEINE OXIDASE 5', 244985),
(353463, 'PTHR22966:SF59', NULL, NULL, NULL, NULL, 'CYSTEINE DIOXYGENASE', 244985),
(353464, 'PTHR22966:SF69', NULL, NULL, NULL, NULL, 'CYSTEINE DIOXYGENASE', 244985),
(353465, 'PTHR22966:SF58', NULL, NULL, NULL, NULL, 'CYSTEINE DIOXYGENASE', 244985),
(353466, 'PTHR22966:SF36', NULL, NULL, NULL, NULL, 'PLANT CYSTEINE OXIDASE 4', 244985),
(353467, 'PTHR22966:SF68', NULL, NULL, NULL, NULL, 'CYSTEINE DIOXYGENASE', 244985),
(353468, 'PTHR22966:SF46', NULL, NULL, NULL, NULL, 'CYSTEINE DIOXYGENASE', 244985),
(353469, 'PTHR22966:SF70', NULL, NULL, NULL, NULL, 'CYSTEINE DIOXYGENASE', 244985),
(353470, 'PTHR22966:SF63', NULL, NULL, NULL, NULL, 'CYSTEINE DIOXYGENASE', 244985),
(353471, 'PTHR22966:SF52', NULL, NULL, NULL, NULL, 'CYSTEINE DIOXYGENASE', 244985),
(353472, 'PTHR22966:SF61', NULL, NULL, NULL, NULL, '2-AMINOETHANETHIOL DIOXYGENASE', 244985),
(353473, 'PTHR22966:SF50', NULL, NULL, NULL, NULL, 'CYSTEINE DIOXYGENASE', 244985),
(353474, 'PTHR22966:SF71', NULL, NULL, NULL, NULL, 'CYSTEINE DIOXYGENASE', 244985),
(353475, 'PTHR31895:SF15', NULL, NULL, NULL, NULL, 'PROTEIN CBG14285', 244986),
(353476, 'PTHR31895:SF14', NULL, NULL, NULL, NULL, 'PROTEIN CBG03177', 244986),
(353477, 'PTHR31895:SF17', NULL, NULL, NULL, NULL, 'PROTEIN CBG14306', 244986),
(353478, 'PTHR31895:SF22', NULL, NULL, NULL, NULL, 'ACTIVATED IN BLOCKED UNFOLDED PROTEIN RESPONSE', 244986),
(353479, 'PTHR31895:SF11', NULL, NULL, NULL, NULL, 'PRION-LIKE-(Q/N-RICH)-DOMAIN-BEARING PROTEIN', 244986),
(353480, 'PTHR31895:SF44', NULL, NULL, NULL, NULL, 'ACTIVATED IN BLOCKED UNFOLDED PROTEIN RESPONSE', 244986),
(353481, 'PTHR31895:SF21', NULL, NULL, NULL, NULL, 'PRION-LIKE-(Q/N-RICH)-DOMAIN-BEARING PROTEIN', 244986),
(353482, 'PTHR31895:SF10', NULL, NULL, NULL, NULL, 'ACTIVATED IN BLOCKED UNFOLDED PROTEIN RESPONSE', 244986),
(353483, 'PTHR31895:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG02722', 244986);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(353484, 'PTHR31895:SF23', NULL, NULL, NULL, NULL, 'PROTEIN CBG02724', 244986),
(353485, 'PTHR31895:SF40', NULL, NULL, NULL, NULL, 'PRION-LIKE-(Q/N-RICH)-DOMAIN-BEARING PROTEIN', 244986),
(353486, 'PTHR31895:SF9', NULL, NULL, NULL, NULL, 'ACTIVATED IN BLOCKED UNFOLDED PROTEIN RESPONSE-RELATED', 244986),
(353487, 'PTHR31895:SF42', NULL, NULL, NULL, NULL, 'ACTIVATED IN BLOCKED UNFOLDED PROTEIN RESPONSE', 244986),
(353488, 'PTHR31895:SF41', NULL, NULL, NULL, NULL, 'PRION-LIKE-(Q/N-RICH)-DOMAIN-BEARING PROTEIN', 244986),
(353489, 'PTHR31895', NULL, NULL, NULL, NULL, 'PROTEIN CBG03177-RELATED', 244986),
(353490, 'PTHR33473:SF3', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE ADAPTER PROTEIN CLPS', 244987),
(353491, 'PTHR33473:SF13', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE ADAPTER PROTEIN CLPS2, CHLOROPLASTIC', 244987),
(353492, 'PTHR33473', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE ADAPTER PROTEIN CLPS1, CHLOROPLASTIC', 244987),
(353493, 'PTHR33473:SF19', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE ADAPTER PROTEIN CLPS', 244987),
(353494, 'PTHR33473:SF18', NULL, NULL, NULL, NULL, 'CLPS DOMAIN-CONTAINING PROTEIN', 244987),
(353495, 'PTHR33473:SF17', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE ADAPTER PROTEIN CLPS1, CHLOROPLASTIC', 244987),
(353496, 'PTHR33473:SF1', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE ADAPTER PROTEIN CLPS1, CHLOROPLASTIC', 244987),
(353497, 'PTHR40637', NULL, NULL, NULL, NULL, 'ESSS SUBUNIT OF NADH:UBIQUINONE OXIDOREDUCTASE (COMPLEX I) PROTEIN', 244988),
(353498, 'PTHR40637:SF3', NULL, NULL, NULL, NULL, 'BNAA03G19790D PROTEIN', 244988),
(353499, 'PTHR40637:SF1', NULL, NULL, NULL, NULL, 'ESSS SUBUNIT OF NADH:UBIQUINONE OXIDOREDUCTASE (COMPLEX I) PROTEIN', 244988),
(353500, 'PTHR40637:SF2', NULL, NULL, NULL, NULL, 'COMPLEX I SUBUNIT', 244988),
(353501, 'PTHR31650:SF35', NULL, NULL, NULL, NULL, 'WAX ESTER SYNTHASE/DIACYLGLYCEROL ACYLTRANSFERASE 11', 244989),
(353502, 'PTHR31650:SF57', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353503, 'PTHR31650:SF55', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353504, 'PTHR31650:SF33', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353505, 'PTHR31650:SF34', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353506, 'PTHR31650:SF39', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353507, 'PTHR31650:SF59', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353508, 'PTHR31650:SF37', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353509, 'PTHR31650:SF38', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353510, 'PTHR31650:SF71', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353511, 'PTHR31650:SF72', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353512, 'PTHR31650:SF50', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353513, 'PTHR31650:SF70', NULL, NULL, NULL, NULL, 'WAX ESTER SYNTHASE/DIACYLGLYCEROL ACYLTRANSFERASE 6', 244989),
(353514, 'PTHR31650:SF53', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353515, 'PTHR31650:SF31', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353516, 'PTHR31650:SF54', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353517, 'PTHR31650:SF32', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353518, 'PTHR31650:SF73', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353519, 'PTHR31650:SF51', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353520, 'PTHR31650:SF52', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353521, 'PTHR31650:SF30', NULL, NULL, NULL, NULL, 'WAX ESTER SYNTHASE/DIACYLGLYCEROL ACYLTRANSFERASE 1', 244989),
(353522, 'PTHR31650:SF24', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353523, 'PTHR31650:SF46', NULL, NULL, NULL, NULL, 'WAX ESTER SYNTHASE/DIACYLGLYCEROL ACYLTRANSFERASE 3', 244989);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(353524, 'PTHR31650:SF68', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353525, 'PTHR31650:SF25', NULL, NULL, NULL, NULL, 'WAX ESTER SYNTHASE/DIACYLGLYCEROL ACYLTRANSFERASE 2', 244989),
(353526, 'PTHR31650:SF69', NULL, NULL, NULL, NULL, 'WAX ESTER SYNTHASE/DIACYLGLYCEROL ACYLTRANSFERASE 4-RELATED', 244989),
(353527, 'PTHR31650:SF47', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353528, 'PTHR31650:SF44', NULL, NULL, NULL, NULL, 'WAX ESTER SYNTHASE/DIACYLGLYCEROL ACYLTRANSFERASE 10-RELATED', 244989),
(353529, 'PTHR31650:SF66', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353530, 'PTHR31650:SF67', NULL, NULL, NULL, NULL, 'WS_DGAT_C DOMAIN-CONTAINING PROTEIN', 244989),
(353531, 'PTHR31650:SF45', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353532, 'PTHR31650:SF23', NULL, NULL, NULL, NULL, 'GH11223P', 244989),
(353533, 'PTHR31650:SF28', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353534, 'PTHR31650:SF29', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353535, 'PTHR31650:SF48', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353536, 'PTHR31650:SF27', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353537, 'PTHR31650:SF61', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353538, 'PTHR31650:SF42', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353539, 'PTHR31650:SF64', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353540, 'PTHR31650:SF43', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353541, 'PTHR31650:SF62', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353542, 'PTHR31650:SF40', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353543, 'PTHR31650:SF41', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 244989),
(353544, 'PTHR31650:SF1', NULL, NULL, NULL, NULL, 'DIACYGLYCEROL O-ACYLTRANSFERASE TGS4-RELATED', 244989),
(353545, 'PTHR31650', NULL, NULL, NULL, NULL, 'O-ACYLTRANSFERASE (WSD1-LIKE) FAMILY PROTEIN', 244989),
(353546, 'PTHR34113:SF5', NULL, NULL, NULL, NULL, '', 244990),
(353547, 'PTHR34113:SF2', NULL, NULL, NULL, NULL, 'BNAA01G24310D PROTEIN', 244990),
(353548, 'PTHR34113:SF3', NULL, NULL, NULL, NULL, 'INACTIVE PURPLE ACID PHOSPHATASE-LIKE PROTEIN', 244990),
(353549, 'PTHR34113', NULL, NULL, NULL, NULL, 'INACTIVE PURPLE ACID PHOSPHATASE-LIKE PROTEIN', 244990),
(353550, 'PTHR46664:SF2', NULL, NULL, NULL, NULL, 'ATM INTERACTOR', 244991),
(353551, 'PTHR46664:SF1', NULL, NULL, NULL, NULL, 'ATM INTERACTOR', 244991),
(353552, 'PTHR46664:SF3', NULL, NULL, NULL, NULL, '', 244991),
(353553, 'PTHR46664', NULL, NULL, NULL, NULL, 'ATM INTERACTOR', 244991),
(353554, 'PTHR37946', NULL, NULL, NULL, NULL, 'SLL1969 PROTEIN', 244992),
(353555, 'PTHR37946:SF2', NULL, NULL, NULL, NULL, 'SLR0421 PROTEIN', 244992),
(353556, 'PTHR37946:SF1', NULL, NULL, NULL, NULL, 'SLL1969 PROTEIN', 244992),
(353557, 'PTHR33539:SF2', NULL, NULL, NULL, NULL, 'UPF0764 PROTEIN C16ORF89', 244993),
(353558, 'PTHR33539:SF1', NULL, NULL, NULL, NULL, 'UPF0764 PROTEIN C16ORF89-LIKE PROTEIN', 244993),
(353559, 'PTHR33539', NULL, NULL, NULL, NULL, 'UPF0764 PROTEIN C16ORF89', 244993),
(353560, 'PTHR46282', NULL, NULL, NULL, NULL, 'LEUCINE-RICH MELANOCYTE DIFFERENTIATION-ASSOCIATED PROTEIN', 244994),
(353561, 'PTHR46282:SF2', NULL, NULL, NULL, NULL, 'LEUCINE-RICH MELANOCYTE DIFFERENTIATION-ASSOCIATED PROTEIN', 244994),
(353562, 'PTHR46282:SF1', NULL, NULL, NULL, NULL, 'LD15753P', 244994),
(353563, 'PTHR46282:SF3', NULL, NULL, NULL, NULL, '', 244994),
(353564, 'PTHR38700:SF1', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 244995),
(353565, 'PTHR38700', NULL, NULL, NULL, NULL, 'YALI0E22418P', 244995),
(353566, 'PTHR30346:SF17', NULL, NULL, NULL, NULL, 'LYSR FAMILY TRANSCRIPTIONAL REGULATOR-RELATED', 244996),
(353567, 'PTHR30346:SF0', NULL, NULL, NULL, NULL, 'HCA OPERON TRANSCRIPTIONAL ACTIVATOR HCAR', 244996);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(353568, 'PTHR30346:SF28', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR CYNR', 244996),
(353569, 'PTHR30346:SF27', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR XAPR', 244996),
(353570, 'PTHR30346:SF16', NULL, NULL, NULL, NULL, 'SMALL NEUTRAL PROTEASE REGULATORY PROTEIN', 244996),
(353571, 'PTHR30346', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL DUAL REGULATOR HCAR-RELATED', 244996),
(353572, 'PTHR30346:SF8', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR GLTC', 244996),
(353573, 'PTHR30346:SF10', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR OF OXIDATIVE STRESS OXYR', 244996),
(353574, 'PTHR30346:SF9', NULL, NULL, NULL, NULL, 'LYSR FAMILY TRANSCRIPTIONAL REGULATOR-RELATED', 244996),
(353575, 'PTHR30346:SF26', NULL, NULL, NULL, NULL, 'HYDROGEN PEROXIDE-INDUCIBLE GENES ACTIVATOR', 244996),
(353576, 'PTHR43489', NULL, NULL, NULL, NULL, 'ISOMERASE', 244997),
(353577, 'PTHR43489:SF1', NULL, NULL, NULL, NULL, 'L-RIBULOSE-5-PHOSPHATE 3-EPIMERASE SGBU-RELATED', 244997),
(353578, 'PTHR43489:SF3', NULL, NULL, NULL, NULL, 'XYLOSE ISOMERASE DOMAIN PROTEIN TIM BARREL', 244997),
(353579, 'PTHR43489:SF6', NULL, NULL, NULL, NULL, 'HYDROXYPYRUVATE ISOMERASE-RELATED', 244997),
(353580, 'PTHR43489:SF8', NULL, NULL, NULL, NULL, 'L-RIBULOSE-5-PHOSPHATE 3-EPIMERASE ULAE', 244997),
(353581, 'PTHR43489:SF7', NULL, NULL, NULL, NULL, '3-DEHYDRO-D-GULOSIDE 4-EPIMERASE-RELATED', 244997),
(353582, 'PTHR43489:SF13', NULL, NULL, NULL, NULL, 'HYDROXYPYRUVATE ISOMERASE', 244997),
(353583, 'PTHR20910', NULL, NULL, NULL, NULL, 'AGAP001623-PA', 244998),
(353584, 'PTHR20910:SF1', NULL, NULL, NULL, NULL, 'SOD_CU DOMAIN-CONTAINING PROTEIN', 244998),
(353585, 'PTHR34592', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 244999),
(353586, 'PTHR34592:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CEP120, PUTATIVE-RELATED', 244999),
(353587, 'PTHR34592:SF3', NULL, NULL, NULL, NULL, '', 244999),
(353588, 'PTHR17178', NULL, NULL, NULL, NULL, 'SECRETORY GRANULE PROTEOGLYCAN CORE PROTEIN', 245000),
(353589, 'PTHR17178:SF0', NULL, NULL, NULL, NULL, 'SERGLYCIN', 245000),
(353590, 'PTHR32183:SF6', NULL, NULL, NULL, NULL, 'OS01G0338600 PROTEIN', 245001),
(353591, 'PTHR32183', NULL, NULL, NULL, NULL, '', 245001),
(353592, 'PTHR32183:SF12', NULL, NULL, NULL, NULL, 'OS03G0843800 PROTEIN', 245001),
(353593, 'PTHR32183:SF11', NULL, NULL, NULL, NULL, 'THIOL METHYLTRANSFERASE 2-RELATED', 245001),
(353594, 'PTHR32183:SF14', NULL, NULL, NULL, NULL, 'BNAC04G03210D PROTEIN', 245001),
(353595, 'PTHR32183:SF13', NULL, NULL, NULL, NULL, 'THIOCYANATE METHYLTRANSFERASE 1', 245001),
(353596, 'PTHR32183:SF15', NULL, NULL, NULL, NULL, 'THIOL METHYLTRANSFERASE 1-RELATED', 245001),
(353597, 'PTHR32183:SF17', NULL, NULL, NULL, NULL, 'BNAC04G49360D PROTEIN', 245001),
(353598, 'PTHR30481:SF2', NULL, NULL, NULL, NULL, 'SITE-SPECIFIC DNA-METHYLTRANSFERASE (ADENINE-SPECIFIC)', 245002),
(353599, 'PTHR30481:SF3', NULL, NULL, NULL, NULL, 'DNA ADENINE METHYLASE', 245002),
(353600, 'PTHR30481:SF4', NULL, NULL, NULL, NULL, 'SITE-SPECIFIC DNA-METHYLTRANSFERASE (ADENINE-SPECIFIC)', 245002),
(353601, 'PTHR30481', NULL, NULL, NULL, NULL, 'DNA ADENINE METHYLASE', 245002),
(353602, 'PTHR35543:SF1', NULL, NULL, NULL, NULL, 'INTRAFLAGELLAR TRANSPORT-ASSOCIATED PROTEIN', 245003),
(353603, 'PTHR35543', NULL, NULL, NULL, NULL, 'PROTEIN C11ORF74', 245003),
(353604, 'PTHR10876:SF5', NULL, NULL, NULL, NULL, 'ZPR1 ZINC-FINGER DOMAIN PROTEIN', 245004),
(353605, 'PTHR10876:SF3', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZPR1', 245004),
(353606, 'PTHR10876:SF4', NULL, NULL, NULL, NULL, 'BNAA08G07440D PROTEIN', 245004),
(353607, 'PTHR10876:SF7', NULL, NULL, NULL, NULL, '', 245004),
(353608, 'PTHR10876', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZPR1', 245004),
(353609, 'PTHR10876:SF2', NULL, NULL, NULL, NULL, '', 245004),
(353610, 'PTHR10876:SF0', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZPR1', 245004),
(353611, 'PTHR39650', NULL, NULL, NULL, NULL, 'CDP-ARCHAEOL SYNTHASE', 245005),
(353612, 'PTHR39650:SF1', NULL, NULL, NULL, NULL, 'CDP-ARCHAEOL SYNTHASE', 245005);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(353613, 'PTHR31029', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE-LIKE PROTEIN', 245006),
(353614, 'PTHR31029:SF15', NULL, NULL, NULL, NULL, '', 245006),
(353615, 'PTHR31029:SF8', NULL, NULL, NULL, NULL, 'OS09G0488800 PROTEIN', 245006),
(353616, 'PTHR31029:SF9', NULL, NULL, NULL, NULL, 'BNACNNG56180D PROTEIN', 245006),
(353617, 'PTHR31029:SF10', NULL, NULL, NULL, NULL, 'BNAA02G36310D PROTEIN', 245006),
(353618, 'PTHR31029:SF3', NULL, NULL, NULL, NULL, 'IRK-INTERACTING PROTEIN', 245006),
(353619, 'PTHR31029:SF4', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE-LIKE PROTEIN', 245006),
(353620, 'PTHR31029:SF11', NULL, NULL, NULL, NULL, 'BNAC08G15560D PROTEIN', 245006),
(353621, 'PTHR31029:SF12', NULL, NULL, NULL, NULL, 'IRK-INTERACTING PROTEIN-LIKE', 245006),
(353622, 'PTHR47774:SF1', NULL, NULL, NULL, NULL, 'GROWTH-DIFFERENTIATION TRANSITION PROTEIN 5-RELATED', 245007),
(353623, 'PTHR47774', NULL, NULL, NULL, NULL, 'GROWTH-DIFFERENTIATION TRANSITION PROTEIN 5-RELATED', 245007),
(353624, 'PTHR15999', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 245008),
(353625, 'PTHR15999:SF5', NULL, NULL, NULL, NULL, 'ZINC FINGER CW-TYPE PWWP DOMAIN PROTEIN 2', 245008),
(353626, 'PTHR15999:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER CW-TYPE PWWP DOMAIN PROTEIN 1', 245008),
(353627, 'PTHR39364', NULL, NULL, NULL, NULL, 'PROTEIN CBG04867', 245009),
(353628, 'PTHR39364:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG04867', 245009),
(353629, 'PTHR14873:SF1', NULL, NULL, NULL, NULL, 'OS06G0694100 PROTEIN', 245010),
(353630, 'PTHR14873', NULL, NULL, NULL, NULL, 'OS06G0694100 PROTEIN', 245010),
(353631, 'PTHR36089:SF1', NULL, NULL, NULL, NULL, 'CHITIN SYNTHASE 3 COMPLEX PROTEIN CSI2-RELATED', 245011),
(353632, 'PTHR36089', NULL, NULL, NULL, NULL, 'CHITIN SYNTHASE 3 COMPLEX PROTEIN CSI2-RELATED', 245011),
(353633, 'PTHR33766', NULL, NULL, NULL, NULL, 'PROTEIN FAM181B', 245012),
(353634, 'PTHR33766:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM181B', 245012),
(353635, 'PTHR33766:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAM181A', 245012),
(353636, 'PTHR16445:SF0', NULL, NULL, NULL, NULL, 'SIMILAR TO HYPOTHETICAL PROTEIN FLJ20010', 245013),
(353637, 'PTHR16445', NULL, NULL, NULL, NULL, 'SIMILAR TO HYPOTHETICAL PROTEIN FLJ20010', 245013),
(353638, 'PTHR11958:SF24', NULL, NULL, NULL, NULL, 'EXCITATORY AMINO ACID TRANSPORTER 1', 245014),
(353639, 'PTHR11958:SF46', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT EXCITATORY AMINO ACID TRANSPORTER GLT-3-RELATED', 245014),
(353640, 'PTHR11958:SF67', NULL, NULL, NULL, NULL, 'EXCITATORY AMINO ACID TRANSPORTER 4', 245014),
(353641, 'PTHR11958:SF100', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER', 245014),
(353642, 'PTHR11958:SF48', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER', 245014),
(353643, 'PTHR11958:SF101', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER', 245014),
(353644, 'PTHR11958:SF102', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER', 245014),
(353645, 'PTHR11958:SF17', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER', 245014),
(353646, 'PTHR11958:SF19', NULL, NULL, NULL, NULL, 'NEUTRAL AMINO ACID TRANSPORTER B(0)', 245014),
(353647, 'PTHR11958:SF105', NULL, NULL, NULL, NULL, 'GLUTAMATE TRANSPORTER FAMILY-RELATED', 245014),
(353648, 'PTHR11958:SF106', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER', 245014),
(353649, 'PTHR11958:SF107', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER', 245014),
(353650, 'PTHR11958:SF108', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER', 245014),
(353651, 'PTHR11958', NULL, NULL, NULL, NULL, 'SODIUM/DICARBOXYLATE SYMPORTER-RELATED', 245014),
(353652, 'PTHR11958:SF93', NULL, NULL, NULL, NULL, 'EXCITATORY AMINO ACID TRANSPORTER 2', 245014),
(353653, 'PTHR11958:SF20', NULL, NULL, NULL, NULL, 'NEUTRAL AMINO ACID TRANSPORTER A', 245014),
(353654, 'PTHR11958:SF63', NULL, NULL, NULL, NULL, 'EXCITATORY AMINO ACID TRANSPORTER 3', 245014),
(353655, 'PTHR11958:SF22', NULL, NULL, NULL, NULL, 'EXCITATORY AMINO ACID TRANSPORTER 5', 245014),
(353656, 'PTHR11958:SF99', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER', 245014),
(353657, 'PTHR11958:SF33', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT EXCITATORY AMINO ACID TRANSPORTER GLT-6-RELATED', 245014);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(353658, 'PTHR11958:SF55', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER', 245014),
(353659, 'PTHR37735:SF1', NULL, NULL, NULL, NULL, 'OS08G0567000 PROTEIN', 245015),
(353660, 'PTHR37735:SF3', NULL, NULL, NULL, NULL, '', 245015),
(353661, 'PTHR37735', NULL, NULL, NULL, NULL, 'OS08G0567000 PROTEIN', 245015),
(353662, 'PTHR35464:SF2', NULL, NULL, NULL, NULL, 'F18O14.9', 245016),
(353663, 'PTHR35464:SF1', NULL, NULL, NULL, NULL, 'OS06G0115200 PROTEIN', 245016),
(353664, 'PTHR35464', NULL, NULL, NULL, NULL, 'OS06G0115200 PROTEIN', 245016),
(353665, 'PTHR47177:SF7', NULL, NULL, NULL, NULL, 'OS06G0283200 PROTEIN', 245017),
(353666, 'PTHR47177:SF8', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 245017),
(353667, 'PTHR47177:SF5', NULL, NULL, NULL, NULL, '', 245017),
(353668, 'PTHR47177:SF6', NULL, NULL, NULL, NULL, 'PHD DOMAIN-CONTAINING PROTEIN', 245017),
(353669, 'PTHR47177', NULL, NULL, NULL, NULL, 'F18C1.6 PROTEIN', 245017),
(353670, 'PTHR47177:SF3', NULL, NULL, NULL, NULL, 'F18C1.6 PROTEIN', 245017),
(353671, 'PTHR47177:SF4', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 245017),
(353672, 'PTHR44743', NULL, NULL, NULL, NULL, 'PUTATIVE, EXPRESSED-RELATED', 245018),
(353673, 'PTHR44743:SF16', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', 245018),
(353674, 'PTHR44743:SF9', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', 245018),
(353675, 'PTHR44743:SF15', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 245018),
(353676, 'PTHR44743:SF5', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 245018),
(353677, 'PTHR44743:SF7', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', 245018),
(353678, 'PTHR44743:SF4', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', 245018),
(353679, 'PTHR44743:SF12', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 245018),
(353680, 'PTHR44743:SF13', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 245018),
(353681, 'PTHR44743:SF10', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 245018),
(353682, 'PTHR44743:SF11', NULL, NULL, NULL, NULL, 'PUTATIVE, EXPRESSED-RELATED', 245018),
(353683, 'PTHR12931:SF35', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1', 245019),
(353684, 'PTHR12931:SF24', NULL, NULL, NULL, NULL, 'OTU DOMAIN-CONTAINING PROTEIN', 245019),
(353685, 'PTHR12931:SF23', NULL, NULL, NULL, NULL, 'OTU DOMAIN-CONTAINING PROTEIN', 245019),
(353686, 'PTHR12931:SF33', NULL, NULL, NULL, NULL, 'UBIQUITIN THIOESTERASE', 245019),
(353687, 'PTHR12931:SF22', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1', 245019),
(353688, 'PTHR12931:SF32', NULL, NULL, NULL, NULL, 'UBIQUITIN THIOESTERASE', 245019),
(353689, 'PTHR12931:SF31', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1', 245019),
(353690, 'PTHR12931:SF30', NULL, NULL, NULL, NULL, 'UBIQUITIN THIOESTERASE', 245019),
(353691, 'PTHR12931:SF19', NULL, NULL, NULL, NULL, 'UBIQUITIN THIOESTERASE OTUB1', 245019),
(353692, 'PTHR12931:SF18', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1', 245019),
(353693, 'PTHR12931:SF17', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1', 245019),
(353694, 'PTHR12931:SF38', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1', 245019),
(353695, 'PTHR12931:SF15', NULL, NULL, NULL, NULL, 'UBIQUITIN THIOESTERASE OTUBAIN-LIKE', 245019),
(353696, 'PTHR12931:SF37', NULL, NULL, NULL, NULL, 'OS02G0517600 PROTEIN', 245019),
(353697, 'PTHR12931:SF25', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1', 245019),
(353698, 'PTHR12931:SF3', NULL, NULL, NULL, NULL, 'UBIQUITIN THIOESTERASE OTUB2', 245019),
(353699, 'PTHR12931:SF36', NULL, NULL, NULL, NULL, 'OTU DOMAIN-CONTAINING PROTEIN', 245019),
(353700, 'PTHR12931', NULL, NULL, NULL, NULL, 'UBIQUITIN THIOLESTERASE PROTEIN OTUB', 245019),
(353701, 'PTHR12788:SF4', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE SULFOTRANSFERASE 1', 245020),
(353702, 'PTHR12788:SF10', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE SULFOTRANSFERASE', 245020),
(353703, 'PTHR12788', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE SULFOTRANSFERASE 2', 245020);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(353704, 'PTHR12788:SF8', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE SULFOTRANSFERASE', 245020),
(353705, 'PTHR12788:SF7', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE SULFOTRANSFERASE-RELATED', 245020),
(353706, 'PTHR12788:SF6', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE SULFOTRANSFERASE 2', 245020),
(353707, 'PTHR33133:SF29', NULL, NULL, NULL, NULL, '', 245021),
(353708, 'PTHR33133:SF28', NULL, NULL, NULL, NULL, '', 245021),
(353709, 'PTHR33133:SF27', NULL, NULL, NULL, NULL, '', 245021),
(353710, 'PTHR33133:SF49', NULL, NULL, NULL, NULL, 'BNAA02G26780D PROTEIN', 245021),
(353711, 'PTHR33133:SF47', NULL, NULL, NULL, NULL, '', 245021),
(353712, 'PTHR33133:SF46', NULL, NULL, NULL, NULL, '', 245021),
(353713, 'PTHR33133:SF24', NULL, NULL, NULL, NULL, 'OS01G0800300 PROTEIN', 245021),
(353714, 'PTHR33133:SF22', NULL, NULL, NULL, NULL, '', 245021),
(353715, 'PTHR33133:SF44', NULL, NULL, NULL, NULL, '', 245021),
(353716, 'PTHR33133:SF21', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 245021),
(353717, 'PTHR33133:SF43', NULL, NULL, NULL, NULL, '', 245021),
(353718, 'PTHR33133:SF42', NULL, NULL, NULL, NULL, 'BNAC03G74610D PROTEIN', 245021),
(353719, 'PTHR33133:SF20', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 245021),
(353720, 'PTHR33133:SF41', NULL, NULL, NULL, NULL, 'GB|AAC79135.1', 245021),
(353721, 'PTHR33133:SF40', NULL, NULL, NULL, NULL, 'BNAA09G09710D PROTEIN', 245021),
(353722, 'PTHR33133:SF60', NULL, NULL, NULL, NULL, 'BNAC07G31180D PROTEIN', 245021),
(353723, 'PTHR33133:SF19', NULL, NULL, NULL, NULL, '', 245021),
(353724, 'PTHR33133:SF39', NULL, NULL, NULL, NULL, '', 245021),
(353725, 'PTHR33133:SF38', NULL, NULL, NULL, NULL, 'BNAANNG31730D PROTEIN', 245021),
(353726, 'PTHR33133:SF15', NULL, NULL, NULL, NULL, '', 245021),
(353727, 'PTHR33133:SF59', NULL, NULL, NULL, NULL, '', 245021),
(353728, 'PTHR33133:SF36', NULL, NULL, NULL, NULL, 'BNAC04G26430D PROTEIN', 245021),
(353729, 'PTHR33133:SF58', NULL, NULL, NULL, NULL, 'SON OF SEVENLESS PROTEIN', 245021),
(353730, 'PTHR33133:SF14', NULL, NULL, NULL, NULL, 'OS06G0653700 PROTEIN', 245021),
(353731, 'PTHR33133:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', 245021),
(353732, 'PTHR33133:SF57', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 245021),
(353733, 'PTHR33133:SF35', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 245021),
(353734, 'PTHR33133:SF34', NULL, NULL, NULL, NULL, 'BNAC08G09270D PROTEIN', 245021),
(353735, 'PTHR33133:SF11', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245021),
(353736, 'PTHR33133:SF32', NULL, NULL, NULL, NULL, '', 245021),
(353737, 'PTHR33133:SF31', NULL, NULL, NULL, NULL, 'F28K20.6 PROTEIN', 245021),
(353738, 'PTHR33133:SF53', NULL, NULL, NULL, NULL, '', 245021),
(353739, 'PTHR33133:SF7', NULL, NULL, NULL, NULL, 'F26K24.10 PROTEIN-RELATED', 245021),
(353740, 'PTHR33133:SF51', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 245021),
(353741, 'PTHR33133', NULL, NULL, NULL, NULL, 'OS08G0107100 PROTEIN-RELATED', 245021),
(353742, 'PTHR33133:SF9', NULL, NULL, NULL, NULL, '', 245021),
(353743, 'PTHR33133:SF50', NULL, NULL, NULL, NULL, '', 245021),
(353744, 'PTHR33133:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 245021),
(353745, 'PTHR33133:SF5', NULL, NULL, NULL, NULL, 'OS08G0107100 PROTEIN', 245021),
(353746, 'PTHR48100:SF54', NULL, NULL, NULL, NULL, 'PHOSPHATASE SPAC5H10.03-RELATED', 245022),
(353747, 'PTHR48100:SF32', NULL, NULL, NULL, NULL, 'ANCHORED PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G10590)-RELATED', 245022),
(353748, 'PTHR48100:SF10', NULL, NULL, NULL, NULL, '2-CARBOXY-D-ARABINITOL-1-PHOSPHATASE-RELATED', 245022),
(353749, 'PTHR48100:SF34', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE-LIKE PROTEIN 4', 245022),
(353750, 'PTHR48100:SF56', NULL, NULL, NULL, NULL, 'PHOSPHATASE SPAC513.02-RELATED', 245022),
(353751, 'PTHR48100:SF33', NULL, NULL, NULL, NULL, 'RHOMBOID DOMAIN-CONTAINING PROTEIN', 245022),
(353752, 'PTHR48100:SF55', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE FAMILY PROTEIN-RELATED', 245022),
(353753, 'PTHR48100:SF30', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE-LIKE PROTEIN 1', 245022);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(353754, 'PTHR48100:SF52', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE-LIKE PROTEIN 1', 245022),
(353755, 'PTHR48100:SF51', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE-RELATED', 245022),
(353756, 'PTHR48100:SF5', NULL, NULL, NULL, NULL, 'LMO1244 PROTEIN', 245022),
(353757, 'PTHR48100:SF4', NULL, NULL, NULL, NULL, 'HISTIDINE PHOSPHATASE FAMILY (BRANCH 1) PROTEIN', 245022),
(353758, 'PTHR48100:SF2', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', 245022),
(353759, 'PTHR48100:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE PMU1-RELATED', 245022),
(353760, 'PTHR48100:SF19', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE FAMILY PROTEIN', 245022),
(353761, 'PTHR48100:SF9', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE 2 PARALOG', 245022),
(353762, 'PTHR48100:SF58', NULL, NULL, NULL, NULL, 'PE-PGRS FAMILY PROTEIN PE_PGRS11', 245022),
(353763, 'PTHR48100:SF57', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE', 245022),
(353764, 'PTHR48100:SF13', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE-LIKE PROTEIN 1 ISOFORM X1', 245022),
(353765, 'PTHR48100:SF35', NULL, NULL, NULL, NULL, 'BNAC07G31810D PROTEIN', 245022),
(353766, 'PTHR48100:SF8', NULL, NULL, NULL, NULL, 'BNAC08G42490D PROTEIN', 245022),
(353767, 'PTHR48100:SF15', NULL, NULL, NULL, NULL, 'SEDOHEPTULOSE 1,7-BISPHOSPHATASE', 245022),
(353768, 'PTHR48100:SF59', NULL, NULL, NULL, NULL, 'ADENOSYLCOBALAMIN/ALPHA-RIBAZOLE PHOSPHATASE', 245022),
(353769, 'PTHR48100:SF37', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE FAMILY PROTEIN', 245022),
(353770, 'PTHR48100:SF6', NULL, NULL, NULL, NULL, '', 245022),
(353771, 'PTHR48100:SF64', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 245022),
(353772, 'PTHR48100:SF20', NULL, NULL, NULL, NULL, 'BNAC02G02760D PROTEIN', 245022),
(353773, 'PTHR48100:SF44', NULL, NULL, NULL, NULL, 'BROAD-SPECIFICITY PHOSPHATASE YOR283W', 245022),
(353774, 'PTHR48100:SF61', NULL, NULL, NULL, NULL, '', 245022),
(353775, 'PTHR48100:SF60', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE FAMILY PROTEIN', 245022),
(353776, 'PTHR48100:SF63', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE-LIKE PROTEIN', 245022),
(353777, 'PTHR48100:SF41', NULL, NULL, NULL, NULL, 'BNAA02G24710D PROTEIN', 245022),
(353778, 'PTHR48100:SF40', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE-LIKE PROTEIN', 245022),
(353779, 'PTHR48100:SF62', NULL, NULL, NULL, NULL, 'GLUCOSYL-3-PHOSPHOGLYCERATE PHOSPHATASE', 245022),
(353780, 'PTHR48100', NULL, NULL, NULL, NULL, 'BROAD-SPECIFICITY PHOSPHATASE YOR283W-RELATED', 245022),
(353781, 'PTHR48100:SF29', NULL, NULL, NULL, NULL, 'OS11G0138600 PROTEIN', 245022),
(353782, 'PTHR48100:SF28', NULL, NULL, NULL, NULL, 'OS11G0138400 PROTEIN', 245022),
(353783, 'PTHR48100:SF24', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE', 245022),
(353784, 'PTHR48100:SF27', NULL, NULL, NULL, NULL, 'OS01G0237100 PROTEIN', 245022),
(353785, 'PTHR16151:SF2', NULL, NULL, NULL, NULL, 'HAUS AUGMIN-LIKE COMPLEX SUBUNIT 6', 245023),
(353786, 'PTHR16151', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 245023),
(353787, 'PTHR16151:SF7', NULL, NULL, NULL, NULL, 'HAUS6_N DOMAIN-CONTAINING PROTEIN', 245023),
(353788, 'PTHR16151:SF4', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 245023),
(353789, 'PTHR16151:SF6', NULL, NULL, NULL, NULL, 'AUGMIN SUBUNIT 6-LIKE', 245023),
(353790, 'PTHR23504:SF119', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN', 245024),
(353791, 'PTHR23504:SF118', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245024),
(353792, 'PTHR23504:SF95', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN', 245024),
(353793, 'PTHR23504:SF117', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN', 245024),
(353794, 'PTHR23504:SF116', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN', 245024),
(353795, 'PTHR23504:SF115', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN 2', 245024),
(353796, 'PTHR23504:SF114', NULL, NULL, NULL, NULL, 'PROTEIN ZINC INDUCED FACILITATOR-LIKE 1', 245024),
(353797, 'PTHR23504:SF90', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY-RELATED', 245024);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(353798, 'PTHR23504', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY DOMAIN-CONTAINING PROTEIN 10', 245024),
(353799, 'PTHR23504:SF91', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY-RELATED', 245024),
(353800, 'PTHR23504:SF4', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245024),
(353801, 'PTHR23504:SF3', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245024),
(353802, 'PTHR23504:SF6', NULL, NULL, NULL, NULL, 'MULTIDRUG TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G08740)-RELATED', 245024),
(353803, 'PTHR23504:SF8', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G03730)-RELATED', 245024),
(353804, 'PTHR23504:SF28', NULL, NULL, NULL, NULL, 'OS12G0133000 PROTEIN', 245024),
(353805, 'PTHR23504:SF2', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G04150)-RELATED', 245024),
(353806, 'PTHR23504:SF1', NULL, NULL, NULL, NULL, 'GH21943P-RELATED', 245024),
(353807, 'PTHR23504:SF89', NULL, NULL, NULL, NULL, 'TETRACYCLINE RESISTANCE PROTEIN, CLASS A-LIKE', 245024),
(353808, 'PTHR23504:SF111', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245024),
(353809, 'PTHR23504:SF86', NULL, NULL, NULL, NULL, 'HIPPOCAMPUS ABUNDANT TRANSCRIPT-LIKE PROTEIN 1 ISOFORM X1', 245024),
(353810, 'PTHR23504:SF88', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY ANTIPORTER', 245024),
(353811, 'PTHR23504:SF81', NULL, NULL, NULL, NULL, 'PROTEIN ZINC INDUCED FACILITATOR-LIKE 1-LIKE ISOFORM X1', 245024),
(353812, 'PTHR23504:SF109', NULL, NULL, NULL, NULL, 'OS01G0268100 PROTEIN', 245024),
(353813, 'PTHR23504:SF82', NULL, NULL, NULL, NULL, 'PEPTIDE/NITRATE TRANSPORTER-RELATED', 245024),
(353814, 'PTHR23504:SF108', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245024),
(353815, 'PTHR23504:SF83', NULL, NULL, NULL, NULL, 'TRANSPORTER OF MUGINEIC ACID3', 245024),
(353816, 'PTHR23504:SF106', NULL, NULL, NULL, NULL, 'PROTEIN ZINC INDUCED FACILITATOR-LIKE 1', 245024),
(353817, 'PTHR23504:SF84', NULL, NULL, NULL, NULL, 'ZINC INDUCED FACILITATOR-LIKE PROTEIN', 245024),
(353818, 'PTHR23504:SF105', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245024),
(353819, 'PTHR23504:SF103', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245024),
(353820, 'PTHR23504:SF102', NULL, NULL, NULL, NULL, 'PROTEIN ZINC INDUCED FACILITATOR 1', 245024),
(353821, 'PTHR23504:SF16', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G13970)-RELATED', 245024),
(353822, 'PTHR23504:SF17', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245024),
(353823, 'PTHR23504:SF39', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G03860)-RELATED', 245024),
(353824, 'PTHR23504:SF19', NULL, NULL, NULL, NULL, 'FACILITATOR SUPERFAMILY ANTIPORTER, PUTATIVE, EXPRESSED-RELATED', 245024),
(353825, 'PTHR23504:SF34', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245024),
(353826, 'PTHR23504:SF101', NULL, NULL, NULL, NULL, 'PEPTIDE/NITRATE TRANSPORTER-RELATED', 245024),
(353827, 'PTHR23504:SF100', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245024),
(353828, 'PTHR23504:SF14', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY DOMAIN-CONTAINING PROTEIN 9', 245024),
(353829, 'PTHR23504:SF15', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245024),
(353830, 'PTHR23504:SF30', NULL, NULL, NULL, NULL, 'FACILITATOR SUPERFAMILY ANTIPORTER, PUTATIVE, EXPRESSED-RELATED', 245024),
(353831, 'PTHR23504:SF31', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY DOMAIN-CONTAINING PROTEIN 10', 245024),
(353832, 'PTHR23504:SF97', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245024),
(353833, 'PTHR23504:SF32', NULL, NULL, NULL, NULL, 'HIPPOCAMPUS ABUNDANT TRANSCRIPT-LIKE PROTEIN 1', 245024),
(353834, 'PTHR23504:SF99', NULL, NULL, NULL, NULL, 'HIPPOCAMPUS ABUNDANT TRANSCRIPT 1 PROTEIN-LIKE ISOFORM X1', 245024),
(353835, 'PTHR23504:SF77', NULL, NULL, NULL, NULL, 'HIPPOCAMPUS ABUNDANT TRANSCRIPT 1 PROTEIN', 245024),
(353836, 'PTHR44360', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY B MEMBER 9', 245025);
INSERT INTO "PUBLIC"."MODEL" VALUES
(353837, 'PTHR44360:SF1', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY B MEMBER 9', 245025),
(353838, 'PTHR44360:SF3', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 245025),
(353839, 'PTHR45941:SF6', NULL, NULL, NULL, NULL, '', 245026),
(353840, 'PTHR45941:SF7', NULL, NULL, NULL, NULL, '', 245026),
(353841, 'PTHR45941:SF4', NULL, NULL, NULL, NULL, 'ST6 (ALPHA-N-ACETYL-NEURAMINYL-2,3-BETA-GALACTOSYL-1,3)-N-ACETYLGALACTOSAMINIDE ALPHA-2,6-SIALYLTRANSFERASE', 245026),
(353842, 'PTHR45941:SF5', NULL, NULL, NULL, NULL, 'ALPHA-N-ACETYLGALACTOSAMINIDE ALPHA-2,6-SIALYLTRANSFERASE 2', 245026),
(353843, 'PTHR45941:SF2', NULL, NULL, NULL, NULL, '', 245026),
(353844, 'PTHR45941:SF1', NULL, NULL, NULL, NULL, 'ALPHA-N-ACETYLGALACTOSAMINIDE ALPHA-2,6-SIALYLTRANSFERASE 1', 245026),
(353845, 'PTHR45941', NULL, NULL, NULL, NULL, '', 245026),
(353846, 'PTHR23239:SF110', NULL, NULL, NULL, NULL, 'KERATIN, TYPE I CUTICULAR HA8', 245027),
(353847, 'PTHR23239:SF374', NULL, NULL, NULL, NULL, 'KERATIN 97-RELATED', 245027),
(353848, 'PTHR23239:SF375', NULL, NULL, NULL, NULL, 'KERATIN 18B', 245027),
(353849, 'PTHR23239:SF353', NULL, NULL, NULL, NULL, 'KERATIN, TYPE I CUTICULAR HA7', 245027),
(353850, 'PTHR23239:SF155', NULL, NULL, NULL, NULL, 'KERATIN, TYPE I CUTICULAR HA2', 245027),
(353851, 'PTHR23239:SF354', NULL, NULL, NULL, NULL, 'KERATIN, TYPE 1, GENE C5', 245027),
(353852, 'PTHR23239:SF355', NULL, NULL, NULL, NULL, 'IF ROD DOMAIN-CONTAINING PROTEIN', 245027),
(353853, 'PTHR23239:SF371', NULL, NULL, NULL, NULL, 'IF ROD DOMAIN-CONTAINING PROTEIN', 245027),
(353854, 'PTHR23239:SF372', NULL, NULL, NULL, NULL, 'IF ROD DOMAIN-CONTAINING PROTEIN', 245027),
(353855, 'PTHR23239:SF373', NULL, NULL, NULL, NULL, 'KERATIN, TYPE I CUTICULAR HA4', 245027),
(353856, 'PTHR23239:SF351', NULL, NULL, NULL, NULL, 'SI:CH211-243G18.2', 245027),
(353857, 'PTHR23239:SF193', NULL, NULL, NULL, NULL, 'KERATIN, TYPE I CUTICULAR HA5', 245027),
(353858, 'PTHR23239:SF99', NULL, NULL, NULL, NULL, 'KERATIN, TYPE I CUTICULAR HA3-II', 245027),
(353859, 'PTHR23239:SF14', NULL, NULL, NULL, NULL, 'KERATIN, TYPE I CYTOSKELETAL 19', 245027),
(353860, 'PTHR23239:SF96', NULL, NULL, NULL, NULL, 'KERATIN, TYPE I CYTOSKELETAL 9', 245027),
(353861, 'PTHR23239:SF97', NULL, NULL, NULL, NULL, 'KERATIN, TYPE I CUTICULAR HA1', 245027),
(353862, 'PTHR23239:SF32', NULL, NULL, NULL, NULL, 'PHAKININ', 245027),
(353863, 'PTHR23239:SF98', NULL, NULL, NULL, NULL, 'KERATIN, TYPE I CUTICULAR HA3-I', 245027),
(353864, 'PTHR23239:SF137', NULL, NULL, NULL, NULL, 'KERATIN, TYPE I CYTOSKELETAL 10', 245027),
(353865, 'PTHR23239:SF358', NULL, NULL, NULL, NULL, 'ZGC:92380', 245027),
(353866, 'PTHR23239:SF215', NULL, NULL, NULL, NULL, 'KERATIN, TYPE I CYTOSKELETAL 28', 245027),
(353867, 'PTHR23239:SF121', NULL, NULL, NULL, NULL, 'KERATIN, TYPE I CYTOSKELETAL 13', 245027),
(353868, 'PTHR23239:SF165', NULL, NULL, NULL, NULL, 'IF ROD DOMAIN-CONTAINING PROTEIN-RELATED', 245027),
(353869, 'PTHR23239:SF167', NULL, NULL, NULL, NULL, 'KERATIN, TYPE I CYTOSKELETAL 20', 245027),
(353870, 'PTHR23239', NULL, NULL, NULL, NULL, 'INTERMEDIATE FILAMENT', 245027),
(353871, 'PTHR23239:SF344', NULL, NULL, NULL, NULL, 'IF ROD DOMAIN-CONTAINING PROTEIN', 245027),
(353872, 'PTHR23239:SF366', NULL, NULL, NULL, NULL, 'WU:FK65C09', 245027),
(353873, 'PTHR23239:SF360', NULL, NULL, NULL, NULL, 'IF ROD DOMAIN-CONTAINING PROTEIN', 245027),
(353874, 'PTHR23239:SF162', NULL, NULL, NULL, NULL, 'KERATIN, TYPE I CYTOSKELETAL 26', 245027),
(353875, 'PTHR23239:SF184', NULL, NULL, NULL, NULL, 'KERATIN, TYPE I CYTOSKELETAL 42', 245027),
(353876, 'PTHR23239:SF361', NULL, NULL, NULL, NULL, 'IF ROD DOMAIN-CONTAINING PROTEIN', 245027),
(353877, 'PTHR23239:SF120', NULL, NULL, NULL, NULL, 'KERATIN, TYPE I CYTOSKELETAL 27', 245027),
(353878, 'PTHR23239:SF164', NULL, NULL, NULL, NULL, 'KERATIN, TYPE I CYTOSKELETAL 15', 245027),
(353879, 'PTHR23239:SF362', NULL, NULL, NULL, NULL, 'IF ROD DOMAIN-CONTAINING PROTEIN', 245027),
(353880, 'PTHR23239:SF180', NULL, NULL, NULL, NULL, 'KERATIN, TYPE I CYTOSKELETAL 17', 245027);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(353881, 'PTHR23239:SF160', NULL, NULL, NULL, NULL, 'KERATIN, TYPE I CYTOSKELETAL 25', 245027),
(353882, 'PTHR23239:SF90', NULL, NULL, NULL, NULL, 'KERATIN, TYPE I CYTOSKELETAL 40', 245027),
(353883, 'PTHR23239:SF44', NULL, NULL, NULL, NULL, 'KERATIN, TYPE I CYTOSKELETAL 23', 245027),
(353884, 'PTHR23239:SF349', NULL, NULL, NULL, NULL, 'KERATIN, TYPE I CYTOSKELETAL 18', 245027),
(353885, 'PTHR23239:SF207', NULL, NULL, NULL, NULL, 'KERATIN, TYPE I CYTOSKELETAL 24', 245027),
(353886, 'PTHR23239:SF367', NULL, NULL, NULL, NULL, 'KERATIN 17-RELATED', 245027),
(353887, 'PTHR23239:SF368', NULL, NULL, NULL, NULL, 'KERATIN, TYPE I CYTOSKELETAL 14', 245027),
(353888, 'PTHR23239:SF369', NULL, NULL, NULL, NULL, 'KERATIN, TYPE I CYTOSKELETAL 12', 245027),
(353889, 'PTHR23239:SF347', NULL, NULL, NULL, NULL, 'KERATIN 93-RELATED', 245027),
(353890, 'PTHR23239:SF204', NULL, NULL, NULL, NULL, 'KERATIN, TYPE I CUTICULAR HA6', 245027),
(353891, 'PTHR23239:SF105', NULL, NULL, NULL, NULL, 'KERATIN, TYPE I CYTOSKELETAL 16', 245027),
(353892, 'PTHR23239:SF106', NULL, NULL, NULL, NULL, 'KERATIN, TYPE I CYTOSKELETAL 39', 245027),
(353893, 'PTHR23239:SF348', NULL, NULL, NULL, NULL, 'IF ROD DOMAIN-CONTAINING PROTEIN', 245027),
(353894, 'PTHR38796:SF1', NULL, NULL, NULL, NULL, 'ANCHORED PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G09600)-RELATED', 245028),
(353895, 'PTHR38796', NULL, NULL, NULL, NULL, '', 245028),
(353896, 'PTHR15154', NULL, NULL, NULL, NULL, 'HAMARTIN', 245029),
(353897, 'PTHR15154:SF2', NULL, NULL, NULL, NULL, 'HAMARTIN', 245029),
(353898, 'PTHR40368:SF1', NULL, NULL, NULL, NULL, 'YALI0F14399P', 245030),
(353899, 'PTHR40368', NULL, NULL, NULL, NULL, 'YALI0F14399P', 245030),
(353900, 'PTHR36050', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 30', 245031),
(353901, 'PTHR36050:SF1', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 30', 245031),
(353902, 'PTHR33303', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 245032),
(353903, 'PTHR33303:SF2', NULL, NULL, NULL, NULL, 'COA_BINDING DOMAIN-CONTAINING PROTEIN', 245032),
(353904, 'PTHR15439:SF6', NULL, NULL, NULL, NULL, 'OS03G0659400 PROTEIN', 245033),
(353905, 'PTHR15439:SF22', NULL, NULL, NULL, NULL, 'ZF-4CXXC_R1 DOMAIN-CONTAINING PROTEIN', 245033),
(353906, 'PTHR15439:SF11', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RBBP6-LIKE ISOFORM X1', 245033),
(353907, 'PTHR15439:SF21', NULL, NULL, NULL, NULL, 'DNA LIGASE (NAD(+))', 245033),
(353908, 'PTHR15439:SF13', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE PQT3-LIKE', 245033),
(353909, 'PTHR15439:SF24', NULL, NULL, NULL, NULL, 'RETINOBLASTOMA-BINDING PROTEIN', 245033),
(353910, 'PTHR15439:SF23', NULL, NULL, NULL, NULL, 'MARVEL DOMAIN-CONTAINING PROTEIN 3', 245033),
(353911, 'PTHR15439:SF20', NULL, NULL, NULL, NULL, 'DWNN DOMAIN-CONTAINING PROTEIN', 245033),
(353912, 'PTHR15439', NULL, NULL, NULL, NULL, 'RETINOBLASTOMA-BINDING PROTEIN 6', 245033),
(353913, 'PTHR15439:SF26', NULL, NULL, NULL, NULL, 'VAD-4', 245033),
(353914, 'PTHR15439:SF25', NULL, NULL, NULL, NULL, '', 245033),
(353915, 'PTHR15439:SF0', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RBBP6', 245033),
(353916, 'PTHR15439:SF28', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE AND APOPTOSIS REGULATOR PROTEIN 1-RELATED', 245033),
(353917, 'PTHR15439:SF17', NULL, NULL, NULL, NULL, 'DWNN DOMAIN-CONTAINING PROTEIN', 245033),
(353918, 'PTHR15439:SF16', NULL, NULL, NULL, NULL, 'DWNN DOMAIN-CONTAINING PROTEIN', 245033),
(353919, 'PTHR15439:SF27', NULL, NULL, NULL, NULL, '', 245033),
(353920, 'PTHR28288', NULL, NULL, NULL, NULL, 'PROTEASE B INHIBITOR 2', 245034),
(353921, 'PTHR28288:SF1', NULL, NULL, NULL, NULL, 'YALI0A01452P', 245034),
(353922, 'PTHR28288:SF2', NULL, NULL, NULL, NULL, 'PROTEASE B INHIBITOR 2', 245034),
(353923, 'PTHR37936', NULL, NULL, NULL, NULL, 'TRANSPOSASE INSC FOR INSERTION ELEMENT IS2A-RELATED', 245035),
(353924, 'PTHR37936:SF3', NULL, NULL, NULL, NULL, 'TRANSPOSASE INSC FOR INSERTION ELEMENT IS2A-RELATED', 245035),
(353925, 'PTHR45618:SF8', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL UNCOUPLING PROTEIN 4', 245036),
(353926, 'PTHR45618:SF9', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL DICARBOXYLATE/TRICARBOXYLATE TRANSPORTER DTC', 245036);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(353927, 'PTHR45618', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL DICARBOXYLATE CARRIER-RELATED', 245036),
(353928, 'PTHR45618:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL UNCOUPLING PROTEIN 2', 245036),
(353929, 'PTHR45618:SF2', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL UNCOUPLING PROTEIN 3', 245036),
(353930, 'PTHR45618:SF22', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL UNCOUPLING PROTEIN 6', 245036),
(353931, 'PTHR45618:SF44', NULL, NULL, NULL, NULL, '', 245036),
(353932, 'PTHR45618:SF21', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL UNCOUPLING PROTEIN BMCP', 245036),
(353933, 'PTHR45618:SF42', NULL, NULL, NULL, NULL, '', 245036),
(353934, 'PTHR45618:SF20', NULL, NULL, NULL, NULL, 'BRAIN MITOCHONDRIAL CARRIER PROTEIN 1', 245036),
(353935, 'PTHR45618:SF41', NULL, NULL, NULL, NULL, 'BNAA02G07340D PROTEIN', 245036),
(353936, 'PTHR45618:SF37', NULL, NULL, NULL, NULL, 'BNAC04G26520D PROTEIN', 245036),
(353937, 'PTHR45618:SF36', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL UNCOUPLING PROTEIN 2', 245036),
(353938, 'PTHR45618:SF13', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL DICARBOXYLATE CARRIER', 245036),
(353939, 'PTHR45618:SF12', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL UNCOUPLING PROTEIN 1', 245036),
(353940, 'PTHR45618:SF34', NULL, NULL, NULL, NULL, '', 245036),
(353941, 'PTHR45618:SF19', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL BROWN FAT UNCOUPLING PROTEIN 1', 245036),
(353942, 'PTHR45618:SF18', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL OXALOACETATE TRANSPORT PROTEIN', 245036),
(353943, 'PTHR45618:SF39', NULL, NULL, NULL, NULL, 'PLANT UNCOUPLING PROTEIN-RELATED', 245036),
(353944, 'PTHR45618:SF38', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 2-OXOGLUTARATE/MALATE CARRIER PROTEIN', 245036),
(353945, 'PTHR45618:SF51', NULL, NULL, NULL, NULL, '', 245036),
(353946, 'PTHR45618:SF50', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL UNCOUPLING PROTEIN 4', 245036),
(353947, 'PTHR45618:SF11', NULL, NULL, NULL, NULL, 'KIDNEY MITOCHONDRIAL CARRIER PROTEIN 1', 245036),
(353948, 'PTHR45618:SF55', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL UNCOUPLING PROTEIN 5-LIKE', 245036),
(353949, 'PTHR45618:SF32', NULL, NULL, NULL, NULL, '', 245036),
(353950, 'PTHR45618:SF54', NULL, NULL, NULL, NULL, 'BNAC02G08990D PROTEIN', 245036),
(353951, 'PTHR45618:SF31', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL DICARBOXYLATE/TRICARBOXYLATE TRANSPORTER DTC', 245036),
(353952, 'PTHR45618:SF53', NULL, NULL, NULL, NULL, 'DICARBOXYLATE CARRIER PROTEIN', 245036),
(353953, 'PTHR45618:SF52', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN UCPB', 245036),
(353954, 'PTHR45618:SF47', NULL, NULL, NULL, NULL, 'UNCOUPLING PROTEIN 5-RELATED', 245036),
(353955, 'PTHR45618:SF46', NULL, NULL, NULL, NULL, 'BNAA09G42560D PROTEIN', 245036),
(353956, 'PTHR33982:SF1', NULL, NULL, NULL, NULL, 'OS07G0154300 PROTEIN', 245037),
(353957, 'PTHR33982:SF5', NULL, NULL, NULL, NULL, 'OUTER ENVELOPE MEMBRANE PROTEIN 7', 245037),
(353958, 'PTHR33982:SF4', NULL, NULL, NULL, NULL, 'OS05G0532800 PROTEIN', 245037),
(353959, 'PTHR33982', NULL, NULL, NULL, NULL, 'OUTER ENVELOPE MEMBRANE PROTEIN 7-RELATED', 245037),
(353960, 'PTHR33982:SF6', NULL, NULL, NULL, NULL, 'BNAA09G55760D PROTEIN', 245037),
(353961, 'PTHR42946:SF6', NULL, NULL, NULL, NULL, 'PHOSPHOGLUCOSAMINE MUTASE-RELATED', 245038),
(353962, 'PTHR42946', NULL, NULL, NULL, NULL, 'PHOSPHOHEXOSE MUTASE', 245038),
(353963, 'PTHR42946:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOGLUCOSAMINE MUTASE FAMILY PROTEIN', 245038),
(353964, 'PTHR42946:SF2', NULL, NULL, NULL, NULL, 'OS06G0476200 PROTEIN', 245038),
(353965, 'PTHR40636', NULL, NULL, NULL, NULL, '', 245039),
(353966, 'PTHR40636:SF1', NULL, NULL, NULL, NULL, '', 245039),
(353967, 'PTHR46681', NULL, NULL, NULL, NULL, 'KINETOCHORE PROTEIN NDC80 HOMOLOG', 245040),
(353968, 'PTHR46681:SF1', NULL, NULL, NULL, NULL, 'KINETOCHORE PROTEIN NDC80 HOMOLOG', 245040),
(353969, 'PTHR46681:SF5', NULL, NULL, NULL, NULL, '', 245040),
(353970, 'PTHR42743:SF20', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN-AMINO-ACID AMINOTRANSFERASE-LIKE PROTEIN 1', 245041),
(353971, 'PTHR42743:SF5', NULL, NULL, NULL, NULL, 'AMINODEOXYCHORISMATE LYASE', 245041);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(353972, 'PTHR42743:SF4', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN-AMINO-ACID AMINOTRANSFERASE-RELATED', 245041),
(353973, 'PTHR42743:SF11', NULL, NULL, NULL, NULL, 'AMINODEOXYCHORISMATE LYASE', 245041),
(353974, 'PTHR42743:SF10', NULL, NULL, NULL, NULL, 'D-ALANINE AMINOTRANSFERASE', 245041),
(353975, 'PTHR42743:SF21', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN-AMINO-ACID AMINOTRANSFERASE-LIKE PROTEIN 2', 245041),
(353976, 'PTHR42743:SF13', NULL, NULL, NULL, NULL, 'SULFOTRANSFER_1 DOMAIN-CONTAINING PROTEIN', 245041),
(353977, 'PTHR42743:SF12', NULL, NULL, NULL, NULL, 'OS05G0244700 PROTEIN', 245041),
(353978, 'PTHR42743:SF8', NULL, NULL, NULL, NULL, 'OS01G0238500 PROTEIN', 245041),
(353979, 'PTHR42743:SF17', NULL, NULL, NULL, NULL, 'BNAA09G03710D PROTEIN', 245041),
(353980, 'PTHR42743:SF2', NULL, NULL, NULL, NULL, 'AMINODEOXYCHORISMATE LYASE', 245041),
(353981, 'PTHR42743', NULL, NULL, NULL, NULL, 'AMINO-ACID AMINOTRANSFERASE', 245041),
(353982, 'PTHR12425', NULL, NULL, NULL, NULL, 'SYNEMBRYN', 245042),
(353983, 'PTHR12425:SF5', NULL, NULL, NULL, NULL, 'SYNEMBRYN', 245042),
(353984, 'PTHR12425:SF2', NULL, NULL, NULL, NULL, 'SYNEMBRYN-B', 245042),
(353985, 'PTHR12425:SF4', NULL, NULL, NULL, NULL, 'SYNEMBRYN-A', 245042),
(353986, 'PTHR12425:SF3', NULL, NULL, NULL, NULL, 'SI:CH211-195B15.7', 245042),
(353987, 'PTHR45048:SF1', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 88', 245043),
(353988, 'PTHR45048', NULL, NULL, NULL, NULL, '', 245043),
(353989, 'PTHR23248:SF32', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID SCRAMBLASE', 245044),
(353990, 'PTHR23248:SF65', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID SCRAMBLASE', 245044),
(353991, 'PTHR23248:SF64', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID SCRAMBLASE', 245044),
(353992, 'PTHR23248:SF9', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID SCRAMBLASE', 245044),
(353993, 'PTHR23248:SF31', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID SCRAMBLASE', 245044),
(353994, 'PTHR23248:SF63', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID SCRAMBLASE', 245044),
(353995, 'PTHR23248:SF62', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID SCRAMBLASE', 245044),
(353996, 'PTHR23248:SF40', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID SCRAMBLASE', 245044),
(353997, 'PTHR23248:SF29', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID SCRAMBLASE 2', 245044),
(353998, 'PTHR23248:SF28', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID SCRAMBLASE 4', 245044),
(353999, 'PTHR23248:SF58', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID SCRAMBLASE', 245044),
(354000, 'PTHR23248', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID SCRAMBLASE-RELATED', 245044),
(354001, 'PTHR23248:SF25', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID SCRAMBLASE FAMILY MEMBER 5', 245044),
(354002, 'PTHR23248:SF57', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID SCRAMBLASE', 245044),
(354003, 'PTHR23248:SF38', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID SCRAMBLASE 1', 245044),
(354004, 'PTHR23248:SF37', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID SCRAMBLASE 3', 245044),
(354005, 'PTHR23248:SF4', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID SCRAMBLASE', 245044),
(354006, 'PTHR48162:SF2', NULL, NULL, NULL, NULL, '', 245045),
(354007, 'PTHR48162', NULL, NULL, NULL, NULL, 'YALI0A06930P', 245045),
(354008, 'PTHR48162:SF3', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 245045),
(354009, 'PTHR48162:SF1', NULL, NULL, NULL, NULL, 'RIBOSOMAL L1 DOMAIN-CONTAINING PROTEIN CG13096', 245045),
(354010, 'PTHR12418', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A THIOESTERASE THEM4', 245046),
(354011, 'PTHR12418:SF19', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A THIOESTERASE THEM4', 245046),
(354012, 'PTHR23065:SF14', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C AND CASEIN KINASE SUBSTRATE IN NEURONS PROTEIN 2', 245047),
(354013, 'PTHR23065:SF25', NULL, NULL, NULL, NULL, 'MENTAL RETARDATION GTPASE ACTIVATING PROTEIN HOMOLOG 1', 245047),
(354014, 'PTHR23065:SF58', NULL, NULL, NULL, NULL, 'SH3 AND F-BAR DOMAIN-CONTAINING PROTEIN DDB_G0274695', 245047),
(354015, 'PTHR23065:SF15', NULL, NULL, NULL, NULL, 'AT02057P', 245047),
(354016, 'PTHR23065:SF59', NULL, NULL, NULL, NULL, 'ENDOPHILIN-3-INTERACTING PROTEIN', 245047),
(354017, 'PTHR23065:SF16', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C AND CASEIN KINASE SUBSTRATE IN NEURONS PROTEIN 1', 245047);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(354018, 'PTHR23065:SF17', NULL, NULL, NULL, NULL, 'RHO-GTPASE-ACTIVATING PROTEIN RGD2', 245047),
(354019, 'PTHR23065:SF18', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C AND CASEIN KINASE SUBSTRATE IN NEURONS PROTEIN 3', 245047),
(354020, 'PTHR23065:SF9', NULL, NULL, NULL, NULL, 'PROLINE-SERINE-THREONINE PHOSPHATASE-INTERACTING PROTEIN 2', 245047),
(354021, 'PTHR23065', NULL, NULL, NULL, NULL, 'PROLINE-SERINE-THREONINE PHOSPHATASE INTERACTING PROTEIN 1', 245047),
(354022, 'PTHR23065:SF6', NULL, NULL, NULL, NULL, 'F-BAR DOMAIN ONLY PROTEIN 1', 245047),
(354023, 'PTHR23065:SF8', NULL, NULL, NULL, NULL, 'F-BAR DOMAIN ONLY PROTEIN 2', 245047),
(354024, 'PTHR23065:SF7', NULL, NULL, NULL, NULL, 'NOSTRIN, ISOFORM H', 245047),
(354025, 'PTHR23065:SF60', NULL, NULL, NULL, NULL, 'CELL DIVISION CONTROL PROTEIN 15', 245047),
(354026, 'PTHR23065:SF61', NULL, NULL, NULL, NULL, 'F-BAR DOMAIN-CONTAINING PROTEIN', 245047),
(354027, 'PTHR23065:SF50', NULL, NULL, NULL, NULL, 'SH3GL-INTERACTING ENDOCYTIC ADAPTOR 1B-RELATED', 245047),
(354028, 'PTHR23065:SF51', NULL, NULL, NULL, NULL, 'PROLINE-SERINE-THREONINE PHOSPHATASE-INTERACTING PROTEIN 1', 245047),
(354029, 'PTHR23065:SF52', NULL, NULL, NULL, NULL, 'SH3 AND F-BAR DOMAIN-CONTAINING PROTEIN DDB_G0271676', 245047),
(354030, 'PTHR23065:SF54', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF YEAST PROFILIN DELETION', 245047),
(354031, 'PTHR23065:SF22', NULL, NULL, NULL, NULL, 'SI:CH211-51C14.1', 245047),
(354032, 'PTHR23065:SF11', NULL, NULL, NULL, NULL, 'SYNDAPIN, ISOFORM C', 245047),
(354033, 'PTHR23065:SF23', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C AND CASEIN KINASE SUBSTRATE IN NEURONS PROTEIN 1', 245047),
(354034, 'PTHR23065:SF57', NULL, NULL, NULL, NULL, 'GROWTH ARREST-SPECIFIC PROTEIN 7', 245047),
(354035, 'PTHR33162:SF11', NULL, NULL, NULL, NULL, 'SEC-INDEPENDENT PROTEIN TRANSLOCASE PROTEIN TATA/B/E-RELATED', 245048),
(354036, 'PTHR33162:SF3', NULL, NULL, NULL, NULL, 'SEC-INDEPENDENT PROTEIN TRANSLOCASE PROTEIN TATB, CHLOROPLASTIC', 245048),
(354037, 'PTHR33162', NULL, NULL, NULL, NULL, 'SEC-INDEPENDENT PROTEIN TRANSLOCASE PROTEIN TATA, CHLOROPLASTIC', 245048),
(354038, 'PTHR33162:SF1', NULL, NULL, NULL, NULL, 'SEC-INDEPENDENT PROTEIN TRANSLOCASE PROTEIN TATA, CHLOROPLASTIC', 245048),
(354039, 'PTHR33162:SF8', NULL, NULL, NULL, NULL, 'TWIN-ARGININE TRANSLOCATION PROTEIN', 245048),
(354040, 'PTHR33162:SF6', NULL, NULL, NULL, NULL, 'BNAC07G27450D PROTEIN', 245048),
(354041, 'PTHR33162:SF7', NULL, NULL, NULL, NULL, 'BNAA03G12600D PROTEIN', 245048),
(354042, 'PTHR43594:SF1', NULL, NULL, NULL, NULL, 'QUERCETIN 2,3-DIOXYGENASE PA2418-RELATED', 245049),
(354043, 'PTHR43594', NULL, NULL, NULL, NULL, 'QUERCETIN 2,3-DIOXYGENASE', 245049),
(354044, 'PTHR34718', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', 245050),
(354045, 'PTHR34718:SF2', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', 245050),
(354046, 'PTHR46937:SF7', NULL, NULL, NULL, NULL, 'FETHRED_A DOMAIN-CONTAINING PROTEIN', 245051),
(354047, 'PTHR46937:SF6', NULL, NULL, NULL, NULL, 'FERREDOXIN/THIOREDOXIN REDUCTASE SUBUNIT A (VARIABLE SUBUNIT) 2', 245051),
(354048, 'PTHR46937:SF4', NULL, NULL, NULL, NULL, 'FERREDOXIN-THIOREDOXIN REDUCTASE, VARIABLE CHAIN', 245051),
(354049, 'PTHR46937', NULL, NULL, NULL, NULL, 'FERREDOXIN-THIOREDOXIN REDUCTASE, VARIABLE CHAIN', 245051),
(354050, 'PTHR46937:SF3', NULL, NULL, NULL, NULL, 'FERREDOXIN/THIOREDOXIN REDUCTASE SUBUNIT A (VARIABLE SUBUNIT) 2', 245051),
(354051, 'PTHR46049:SF8', NULL, NULL, NULL, NULL, 'MYOSIN X,-LIKE 3', 245052),
(354052, 'PTHR46049:SF2', NULL, NULL, NULL, NULL, 'UNCONVENTIONAL MYOSIN-X', 245052),
(354053, 'PTHR46049:SF3', NULL, NULL, NULL, NULL, 'AGAP003327-PA', 245052),
(354054, 'PTHR46049', NULL, NULL, NULL, NULL, 'AGAP003327-PA', 245052),
(354055, 'PTHR46049:SF4', NULL, NULL, NULL, NULL, 'MYOSIN X,-LIKE 1', 245052),
(354056, 'PTHR46049:SF5', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY H MEMBER 3', 245052),
(354057, 'PTHR31992:SF205', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(354058, 'PTHR31992:SF326', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354059, 'PTHR31992:SF206', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354060, 'PTHR31992:SF327', NULL, NULL, NULL, NULL, 'OS04G0678400 PROTEIN', 245053),
(354061, 'PTHR31992:SF328', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354062, 'PTHR31992:SF207', NULL, NULL, NULL, NULL, 'OBF BINDING PROTEIN 2 DOF1.1-1', 245053),
(354063, 'PTHR31992:SF164', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354064, 'PTHR31992:SF285', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF4.6', 245053),
(354065, 'PTHR31992:SF286', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF3.2-LIKE', 245053),
(354066, 'PTHR31992:SF165', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354067, 'PTHR31992:SF320', NULL, NULL, NULL, NULL, 'DOF-TYPE ZINC FINGER DNA-BINDING FAMILY PROTEIN', 245053),
(354068, 'PTHR31992:SF287', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354069, 'PTHR31992:SF288', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF2.1', 245053),
(354070, 'PTHR31992:SF167', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF1.1', 245053),
(354071, 'PTHR31992:SF321', NULL, NULL, NULL, NULL, 'OS05G0440000 PROTEIN', 245053),
(354072, 'PTHR31992:SF289', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354073, 'PTHR31992:SF322', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF3.6', 245053),
(354074, 'PTHR31992:SF168', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354075, 'PTHR31992:SF323', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF1.4-LIKE', 245053),
(354076, 'PTHR31992:SF324', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354077, 'PTHR31992:SF203', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF3.4-LIKE', 245053),
(354078, 'PTHR31992:SF325', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354079, 'PTHR31992:SF204', NULL, NULL, NULL, NULL, 'OS08G0490100 PROTEIN', 245053),
(354080, 'PTHR31992:SF280', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF2.1', 245053),
(354081, 'PTHR31992:SF281', NULL, NULL, NULL, NULL, 'ZINC FINGER, DOF-TYPE-RELATED', 245053),
(354082, 'PTHR31992:SF160', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354083, 'PTHR31992:SF282', NULL, NULL, NULL, NULL, '', 245053),
(354084, 'PTHR31992:SF283', NULL, NULL, NULL, NULL, 'OS03G0821200 PROTEIN', 245053),
(354085, 'PTHR31992:SF162', NULL, NULL, NULL, NULL, 'ZINC FINGER, DOF-TYPE-RELATED', 245053),
(354086, 'PTHR31992:SF284', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF1.2', 245053),
(354087, 'PTHR31992:SF315', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354088, 'PTHR31992:SF316', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN 2', 245053),
(354089, 'PTHR31992:SF317', NULL, NULL, NULL, NULL, 'ZINC FINGER, DOF-TYPE-RELATED', 245053),
(354090, 'PTHR31992:SF318', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354091, 'PTHR31992:SF319', NULL, NULL, NULL, NULL, 'ZINC FINGER, DOF-TYPE-RELATED', 245053),
(354092, 'PTHR31992:SF155', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF5.8', 245053),
(354093, 'PTHR31992:SF310', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354094, 'PTHR31992:SF311', NULL, NULL, NULL, NULL, 'DOF DOMAIN ZINC FINGER PROTEIN', 245053),
(354095, 'PTHR31992:SF157', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354096, 'PTHR31992:SF312', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF1.6', 245053),
(354097, 'PTHR31992:SF42', NULL, NULL, NULL, NULL, 'OS05G0112200 PROTEIN', 245053),
(354098, 'PTHR31992:SF279', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354099, 'PTHR31992:SF159', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF5.3', 245053),
(354100, 'PTHR31992:SF313', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF5.7', 245053); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(354101, 'PTHR31992:SF314', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF5.4', 245053),
(354102, 'PTHR31992:SF152', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354103, 'PTHR31992:SF107', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF2.2', 245053),
(354104, 'PTHR31992:SF108', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354105, 'PTHR31992:SF229', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354106, 'PTHR31992:SF93', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF2.5-LIKE', 245053),
(354107, 'PTHR31992:SF220', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354108, 'PTHR31992:SF187', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354109, 'PTHR31992:SF188', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354110, 'PTHR31992:SF221', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354111, 'PTHR31992:SF102', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF4.1', 245053),
(354112, 'PTHR31992:SF224', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354113, 'PTHR31992:SF97', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354114, 'PTHR31992:SF12', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF3.4', 245053),
(354115, 'PTHR31992:SF181', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF4.3-RELATED', 245053),
(354116, 'PTHR31992:SF182', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354117, 'PTHR31992:SF183', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354118, 'PTHR31992:SF216', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354119, 'PTHR31992:SF218', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354120, 'PTHR31992:SF296', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN', 245053),
(354121, 'PTHR31992:SF297', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354122, 'PTHR31992:SF210', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354123, 'PTHR31992:SF298', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN 4', 245053),
(354124, 'PTHR31992:SF299', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354125, 'PTHR31992:SF212', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF3.1-LIKE', 245053),
(354126, 'PTHR31992:SF215', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF2.4', 245053),
(354127, 'PTHR31992:SF290', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF1.8', 245053),
(354128, 'PTHR31992:SF291', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354129, 'PTHR31992:SF170', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354130, 'PTHR31992:SF292', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN MNB1A', 245053),
(354131, 'PTHR31992:SF172', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354132, 'PTHR31992:SF293', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF2.4-LIKE', 245053),
(354133, 'PTHR31992:SF294', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF3.7', 245053),
(354134, 'PTHR31992:SF295', NULL, NULL, NULL, NULL, 'ZINC FINGER, DOF-TYPE-RELATED', 245053),
(354135, 'PTHR31992', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF1.4-RELATED', 245053),
(354136, 'PTHR31992:SF129', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF2.2-LIKE ISOFORM X1', 245053),
(354137, 'PTHR31992:SF241', NULL, NULL, NULL, NULL, 'DOF DOMAIN, ZINC FINGER FAMILY PROTEIN, EXPRESSED', 245053),
(354138, 'PTHR31992:SF242', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354139, 'PTHR31992:SF123', NULL, NULL, NULL, NULL, 'DOF30 TRANSCRIPTION FACTOR', 245053),
(354140, 'PTHR31992:SF245', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF2.1-LIKE', 245053),
(354141, 'PTHR31992:SF75', NULL, NULL, NULL, NULL, 'DOF DOMAIN, ZINC FINGER FAMILY PROTEIN, EXPRESSED', 245053),
(354142, 'PTHR31992:SF126', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF4.2-RELATED', 245053);
INSERT INTO "PUBLIC"."MODEL" VALUES
(354143, 'PTHR31992:SF238', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354144, 'PTHR31992:SF230', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354145, 'PTHR31992:SF111', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF3.5', 245053),
(354146, 'PTHR31992:SF232', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF1.7', 245053),
(354147, 'PTHR31992:SF191', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354148, 'PTHR31992:SF192', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354149, 'PTHR31992:SF193', NULL, NULL, NULL, NULL, 'DNA BINDING WITH ONE FINGER3', 245053),
(354150, 'PTHR31992:SF194', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354151, 'PTHR31992:SF304', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF3.2', 245053),
(354152, 'PTHR31992:SF305', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF3.1', 245053),
(354153, 'PTHR31992:SF306', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF5.6', 245053),
(354154, 'PTHR31992:SF307', NULL, NULL, NULL, NULL, 'PB1 DOMAIN, ZINC FINGER, DOF-TYPE, ALOG DOMAIN PROTEIN-RELATED', 245053),
(354155, 'PTHR31992:SF308', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF4.6-LIKE', 245053),
(354156, 'PTHR31992:SF309', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF5.4-LIKE', 245053),
(354157, 'PTHR31992:SF144', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245053),
(354158, 'PTHR31992:SF267', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF3.6', 245053),
(354159, 'PTHR31992:SF300', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF2.4-LIKE', 245053),
(354160, 'PTHR31992:SF301', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF2.5', 245053),
(354161, 'PTHR31992:SF302', NULL, NULL, NULL, NULL, 'ZINC FINGER, DOF-TYPE-RELATED', 245053),
(354162, 'PTHR31992:SF303', NULL, NULL, NULL, NULL, 'ZINC FINGER, DOF-TYPE-RELATED', 245053),
(354163, 'PTHR31992:SF149', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF4.7', 245053),
(354164, 'PTHR31992:SF141', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF1.4', 245053),
(354165, 'PTHR31992:SF252', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF5.1', 245053),
(354166, 'PTHR31992:SF255', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF2.4-LIKE', 245053),
(354167, 'PTHR31992:SF62', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF3.1', 245053),
(354168, 'PTHR31992:SF256', NULL, NULL, NULL, NULL, 'ZINC FINGER, DOF-TYPE-RELATED', 245053),
(354169, 'PTHR12482:SF58', NULL, NULL, NULL, NULL, 'SERINE ESTERASE FAMILY PROTEIN-RELATED', 245054),
(354170, 'PTHR12482:SF14', NULL, NULL, NULL, NULL, 'DUF676 DOMAIN-CONTAINING PROTEIN', 245054),
(354171, 'PTHR12482:SF57', NULL, NULL, NULL, NULL, 'OS08G0143700 PROTEIN', 245054),
(354172, 'PTHR12482:SF15', NULL, NULL, NULL, NULL, 'OS02G0787100 PROTEIN', 245054),
(354173, 'PTHR12482:SF54', NULL, NULL, NULL, NULL, 'ALPHA/BETA HYDROLASE FOLD PROTEIN-RELATED', 245054),
(354174, 'PTHR12482:SF11', NULL, NULL, NULL, NULL, 'HYDROLASE-LIKE PROTEIN FAMILY', 245054),
(354175, 'PTHR12482:SF55', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN-RELATED', 245054),
(354176, 'PTHR12482:SF50', NULL, NULL, NULL, NULL, 'ESTERASE FAMILY PROTEIN, PUTATIVE-RELATED', 245054),
(354177, 'PTHR12482:SF52', NULL, NULL, NULL, NULL, 'DUF676 DOMAIN-CONTAINING PROTEIN', 245054),
(354178, 'PTHR12482', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 245054),
(354179, 'PTHR12482:SF47', NULL, NULL, NULL, NULL, 'ESTERASE FAMILY PROTEIN, PUTATIVE-RELATED', 245054),
(354180, 'PTHR12482:SF24', NULL, NULL, NULL, NULL, 'LIPID DROPLET PHOSPHOLIPASE 1', 245054),
(354181, 'PTHR12482:SF46', NULL, NULL, NULL, NULL, 'OS11G0167500 PROTEIN', 245054),
(354182, 'PTHR12482:SF65', NULL, NULL, NULL, NULL, 'ESTERASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G12320)-RELATED', 245054),
(354183, 'PTHR12482:SF64', NULL, NULL, NULL, NULL, 'DUF676 DOMAIN-CONTAINING PROTEIN', 245054),
(354184, 'PTHR12482:SF20', NULL, NULL, NULL, NULL, 'LIPASE YDR444W-RELATED', 245054);
INSERT INTO "PUBLIC"."MODEL" VALUES
(354185, 'PTHR12482:SF45', NULL, NULL, NULL, NULL, 'LIPASE YOR059C-RELATED', 245054),
(354186, 'PTHR12482:SF67', NULL, NULL, NULL, NULL, 'DUF676 DOMAIN-CONTAINING PROTEIN', 245054),
(354187, 'PTHR12482:SF66', NULL, NULL, NULL, NULL, 'DUF676 DOMAIN-CONTAINING PROTEIN', 245054),
(354188, 'PTHR12482:SF3', NULL, NULL, NULL, NULL, 'PROTEIN FAM135B', 245054),
(354189, 'PTHR12482:SF63', NULL, NULL, NULL, NULL, 'DUF676 DOMAIN-CONTAINING PROTEIN', 245054),
(354190, 'PTHR12482:SF4', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 245054),
(354191, 'PTHR12482:SF41', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 245054),
(354192, 'PTHR12482:SF5', NULL, NULL, NULL, NULL, 'DUF676 DOMAIN-CONTAINING PROTEIN', 245054),
(354193, 'PTHR12482:SF40', NULL, NULL, NULL, NULL, 'PROTEIN FAM135A', 245054),
(354194, 'PTHR12482:SF62', NULL, NULL, NULL, NULL, 'LIPASE ROG1-RELATED', 245054),
(354195, 'PTHR10743:SF19', NULL, NULL, NULL, NULL, 'PROTEIN RER1', 245055),
(354196, 'PTHR10743:SF26', NULL, NULL, NULL, NULL, 'PROTEIN RER1D', 245055),
(354197, 'PTHR10743', NULL, NULL, NULL, NULL, 'PROTEIN RER1', 245055),
(354198, 'PTHR10743:SF17', NULL, NULL, NULL, NULL, 'PROTEIN RER1A', 245055),
(354199, 'PTHR10743:SF22', NULL, NULL, NULL, NULL, 'PROTEIN RER1', 245055),
(354200, 'PTHR10743:SF23', NULL, NULL, NULL, NULL, 'PROTEIN RER1', 245055),
(354201, 'PTHR10743:SF13', NULL, NULL, NULL, NULL, 'PROTEIN RER1B', 245055),
(354202, 'PTHR10743:SF24', NULL, NULL, NULL, NULL, 'PROTEIN RER1', 245055),
(354203, 'PTHR10743:SF25', NULL, NULL, NULL, NULL, 'PROTEIN RER1', 245055),
(354204, 'PTHR10743:SF20', NULL, NULL, NULL, NULL, 'PROTEIN RER1', 245055),
(354205, 'PTHR10743:SF21', NULL, NULL, NULL, NULL, 'PROTEIN RER1', 245055),
(354206, 'PTHR10743:SF0', NULL, NULL, NULL, NULL, 'PROTEIN RER1', 245055),
(354207, 'PTHR35039:SF3', NULL, NULL, NULL, NULL, '3-KETO-L-GULONATE-6-PHOSPHATE DECARBOXYLASE SGBH-RELATED', 245056),
(354208, 'PTHR35039', NULL, NULL, NULL, NULL, '3-KETO-L-GULONATE-6-PHOSPHATE DECARBOXYLASE SGBH-RELATED', 245056),
(354209, 'PTHR12062', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINYLTRANSFERASE VI', 245057),
(354210, 'PTHR12062:SF30', NULL, NULL, NULL, NULL, 'ALPHA-1,3-MANNOSYL-GLYCOPROTEIN 4-BETA-N-ACETYLGLUCOSAMINYLTRANSFERASE C', 245057),
(354211, 'PTHR12062:SF31', NULL, NULL, NULL, NULL, 'ALPHA-1,3-MANNOSYL-GLYCOPROTEIN 4-BETA-N-ACETYLGLUCOSAMINYLTRANSFERASE D', 245057),
(354212, 'PTHR12062:SF10', NULL, NULL, NULL, NULL, 'ALPHA-1,3-MANNOSYL-GLYCOPROTEIN 4-BETA-N-ACETYLGLUCOSAMINYLTRANSFERASE-LIKE PROTEIN MGAT4D', 245057),
(354213, 'PTHR12062:SF27', NULL, NULL, NULL, NULL, 'ZGC:154054', 245057),
(354214, 'PTHR12062:SF4', NULL, NULL, NULL, NULL, 'ALPHA-1,3-MANNOSYL-GLYCOPROTEIN 4-BETA-N-ACETYLGLUCOSAMINYLTRANSFERASE A', 245057),
(354215, 'PTHR12062:SF29', NULL, NULL, NULL, NULL, 'MGAT4 FAMILY MEMBER G', 245057),
(354216, 'PTHR12062:SF1', NULL, NULL, NULL, NULL, 'ALPHA-1,3-MANNOSYL-GLYCOPROTEIN 4-BETA-N-ACETYLGLUCOSAMINYLTRANSFERASE B', 245057),
(354217, 'PTHR12062:SF11', NULL, NULL, NULL, NULL, 'MGAT4 FAMILY, MEMBER F', 245057),
(354218, 'PTHR12062:SF0', NULL, NULL, NULL, NULL, '', 245057),
(354219, 'PTHR12062:SF3', NULL, NULL, NULL, NULL, 'ALPHA-1,3-MANNOSYL-GLYCOPROTEIN 4-BETA-N-ACETYLGLUCOSAMINYLTRANSFERASE-LIKE PROTEIN MGAT4E', 245057),
(354220, 'PTHR12062:SF14', NULL, NULL, NULL, NULL, 'ALPHA-1,3-MANNOSYL-GLYCOPROTEIN 4-BETA-N-ACETYLGLUCOSAMINYLTRANSFERASE C', 245057),
(354221, 'PTHR12062:SF9', NULL, NULL, NULL, NULL, 'FI02046P', 245057),
(354222, 'PTHR34418:SF3', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP214', 245058),
(354223, 'PTHR34418', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP214 ISOFORM X1', 245058),
(354224, 'PTHR28591', NULL, NULL, NULL, NULL, 'LATEXIN', 245059),
(354225, 'PTHR28591:SF1', NULL, NULL, NULL, NULL, 'LATEXIN', 245059),
(354226, 'PTHR28591:SF2', NULL, NULL, NULL, NULL, 'RETINOIC ACID RECEPTOR RESPONDER PROTEIN 1', 245059),
(354227, 'PTHR22435', NULL, NULL, NULL, NULL, 'CHROMOSOME 6 OPEN READING FRAME 222', 245060),
(354228, 'PTHR22435:SF0', NULL, NULL, NULL, NULL, 'PROTEIN BNIP5', 245060);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(354229, 'PTHR34456:SF14', NULL, NULL, NULL, NULL, 'MITOVIRUS RNA-DEPENDENT RNA POLYMERASE', 245061),
(354230, 'PTHR34456:SF15', NULL, NULL, NULL, NULL, '', 245061),
(354231, 'PTHR34456:SF13', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 245061),
(354232, 'PTHR34456', NULL, NULL, NULL, NULL, 'MITOVIRUS RNA-DEPENDENT RNA POLYMERASE', 245061),
(354233, 'PTHR34456:SF9', NULL, NULL, NULL, NULL, 'MITOVIRUS RNA-DEPENDENT RNA POLYMERASE', 245061),
(354234, 'PTHR33683:SF46', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE-III DOMAIN-CONTAINING PROTEIN', 245062),
(354235, 'PTHR33683', NULL, NULL, NULL, NULL, '1, PUTATIVE-RELATED', 245062),
(354236, 'PTHR45613', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 245063),
(354237, 'PTHR45613:SF4', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE (PPR) REPEAT PROTEIN', 245063),
(354238, 'PTHR45613:SF456', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT PROTEIN-RELATED', 245063),
(354239, 'PTHR45613:SF455', NULL, NULL, NULL, NULL, 'OS02G0110400 PROTEIN', 245063),
(354240, 'PTHR45613:SF9', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL GROUP I INTRON SPLICING FACTOR CCM1', 245063),
(354241, 'PTHR45613:SF217', NULL, NULL, NULL, NULL, '', 245063),
(354242, 'PTHR45613:SF415', NULL, NULL, NULL, NULL, '', 245063),
(354243, 'PTHR45613:SF459', NULL, NULL, NULL, NULL, 'OS10G0497300 PROTEIN', 245063),
(354244, 'PTHR45613:SF88', NULL, NULL, NULL, NULL, 'OS12G0152600 PROTEIN', 245063),
(354245, 'PTHR45613:SF50', NULL, NULL, NULL, NULL, 'OS03G0761300 PROTEIN', 245063),
(354246, 'PTHR45613:SF333', NULL, NULL, NULL, NULL, '', 245063),
(354247, 'PTHR45613:SF179', NULL, NULL, NULL, NULL, 'OS01G0505500 PROTEIN', 245063),
(354248, 'PTHR45613:SF452', NULL, NULL, NULL, NULL, 'OS02G0582300 PROTEIN', 245063),
(354249, 'PTHR45613:SF297', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 245063),
(354250, 'PTHR45613:SF2', NULL, NULL, NULL, NULL, 'OS04G0350000 PROTEIN', 245063),
(354251, 'PTHR45613:SF469', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 245063),
(354252, 'PTHR45613:SF149', NULL, NULL, NULL, NULL, 'OS07G0101200 PROTEIN', 245063),
(354253, 'PTHR45613:SF468', NULL, NULL, NULL, NULL, '', 245063),
(354254, 'PTHR45613:SF424', NULL, NULL, NULL, NULL, '', 245063),
(354255, 'PTHR45613:SF467', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE (PPR) REPEAT PROTEIN', 245063),
(354256, 'PTHR45613:SF346', NULL, NULL, NULL, NULL, '', 245063),
(354257, 'PTHR45613:SF466', NULL, NULL, NULL, NULL, '', 245063),
(354258, 'PTHR45613:SF308', NULL, NULL, NULL, NULL, '', 245063),
(354259, 'PTHR45613:SF57', NULL, NULL, NULL, NULL, 'OS01G0816000 PROTEIN', 245063),
(354260, 'PTHR45613:SF99', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 245063),
(354261, 'PTHR45613:SF340', NULL, NULL, NULL, NULL, '', 245063),
(354262, 'PTHR45613:SF465', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 245063),
(354263, 'PTHR45613:SF344', NULL, NULL, NULL, NULL, '(PPR) REPEAT PROTEIN, PUTATIVE-RELATED', 245063),
(354264, 'PTHR45613:SF464', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 245063),
(354265, 'PTHR45613:SF143', NULL, NULL, NULL, NULL, 'OS06G0694600 PROTEIN', 245063),
(354266, 'PTHR45613:SF386', NULL, NULL, NULL, NULL, 'OS01G0506100 PROTEIN', 245063),
(354267, 'PTHR45613:SF144', NULL, NULL, NULL, NULL, 'OS04G0612800 PROTEIN', 245063),
(354268, 'PTHR45613:SF358', NULL, NULL, NULL, NULL, 'OS06G0565000 PROTEIN', 245063),
(354269, 'PTHR45613:SF312', NULL, NULL, NULL, NULL, 'BNAA09G26230D PROTEIN', 245063),
(354270, 'PTHR45613:SF65', NULL, NULL, NULL, NULL, 'OS08G0369200 PROTEIN', 245063),
(354271, 'PTHR45613:SF62', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 245063),
(354272, 'PTHR45613:SF391', NULL, NULL, NULL, NULL, 'OS07G0621100 PROTEIN', 245063),
(354273, 'PTHR45613:SF70', NULL, NULL, NULL, NULL, 'OS07G0472100 PROTEIN', 245063),
(354274, 'PTHR45613:SF472', NULL, NULL, NULL, NULL, 'PPR1 PROTEIN', 245063),
(354275, 'PTHR45613:SF471', NULL, NULL, NULL, NULL, '', 245063),
(354276, 'PTHR45613:SF230', NULL, NULL, NULL, NULL, 'BNAC04G20030D PROTEIN', 245063);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(354277, 'PTHR45613:SF470', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 245063),
(354278, 'PTHR45613:SF195', NULL, NULL, NULL, NULL, 'OS01G0151900 PROTEIN', 245063),
(354279, 'PTHR45613:SF354', NULL, NULL, NULL, NULL, 'OS10G0368902 PROTEIN', 245063),
(354280, 'PTHR45613:SF277', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 245063),
(354281, 'PTHR45613:SF475', NULL, NULL, NULL, NULL, 'REPEAT-LIKE SUPERFAMILY PROTEIN, PUTATIVE-RELATED', 245063),
(354282, 'PTHR45613:SF431', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN MITOCHONDRIAL', 245063),
(354283, 'PTHR45613:SF474', NULL, NULL, NULL, NULL, '', 245063),
(354284, 'PTHR45613:SF473', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 245063),
(354285, 'PTHR45613:SF248', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN MITOCHONDRIAL', 245063),
(354286, 'PTHR45613:SF39', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 245063),
(354287, 'PTHR45613:SF128', NULL, NULL, NULL, NULL, 'OS09G0542800 PROTEIN', 245063),
(354288, 'PTHR45613:SF401', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 245063),
(354289, 'PTHR45613:SF125', NULL, NULL, NULL, NULL, 'DEFECTIVE KERNEL35', 245063),
(354290, 'PTHR45613:SF368', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 245063),
(354291, 'PTHR45613:SF400', NULL, NULL, NULL, NULL, 'OS02G0824000 PROTEIN', 245063),
(354292, 'PTHR45613:SF324', NULL, NULL, NULL, NULL, 'OS06G0690900 PROTEIN', 245063),
(354293, 'PTHR45613:SF247', NULL, NULL, NULL, NULL, 'OS03G0728200 PROTEIN', 245063),
(354294, 'PTHR45613:SF448', NULL, NULL, NULL, NULL, 'RESTORER OF FERTILITY-LIKE PROTEIN', 245063),
(354295, 'PTHR45613:SF207', NULL, NULL, NULL, NULL, 'OS08G0300700 PROTEIN', 245063),
(354296, 'PTHR45613:SF30', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN MITOCHONDRIAL', 245063),
(354297, 'PTHR45613:SF82', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 245063),
(354298, 'PTHR45613:SF240', NULL, NULL, NULL, NULL, 'OS08G0272200 PROTEIN', 245063),
(354299, 'PTHR45613:SF120', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 245063),
(354300, 'PTHR45613:SF441', NULL, NULL, NULL, NULL, 'OS02G0226900 PROTEIN', 245063),
(354301, 'PTHR45613:SF287', NULL, NULL, NULL, NULL, 'OS12G0456100 PROTEIN', 245063),
(354302, 'PTHR36057:SF1', NULL, NULL, NULL, NULL, 'LIPOPROTEIN LIPID ATTACHMENT SITE-LIKE PROTEIN, PUTATIVE (DUF1223)-RELATED', 245064),
(354303, 'PTHR36057', NULL, NULL, NULL, NULL, '', 245064),
(354304, 'PTHR36057:SF7', NULL, NULL, NULL, NULL, 'LIPOPROTEIN LIPID ATTACHMENT SITE-LIKE PROTEIN, PUTATIVE (DUF1223)-RELATED', 245064),
(354305, 'PTHR36057:SF6', NULL, NULL, NULL, NULL, 'BNAC09G30620D PROTEIN', 245064),
(354306, 'PTHR36155', NULL, NULL, NULL, NULL, 'BLL5354 PROTEIN', 245065),
(354307, 'PTHR36155:SF1', NULL, NULL, NULL, NULL, 'BLL5354 PROTEIN', 245065),
(354308, 'PTHR34000:SF21', NULL, NULL, NULL, NULL, 'PROTEIN CBG24243', 245066),
(354309, 'PTHR34000', NULL, NULL, NULL, NULL, 'LRRGT00142-RELATED', 245066),
(354310, 'PTHR34000:SF8', NULL, NULL, NULL, NULL, 'METALLO-BETA-LACTAMASE SUPERFAMILY PROTEIN', 245066),
(354311, 'PTHR34000:SF12', NULL, NULL, NULL, NULL, 'LRRGT00142', 245066),
(354312, 'PTHR34000:SF22', NULL, NULL, NULL, NULL, 'PROTEIN CBG27467', 245066),
(354313, 'PTHR44090', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 61', 245067),
(354314, 'PTHR44090:SF3', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 245067),
(354315, 'PTHR44090:SF1', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 61', 245067),
(354316, 'PTHR35534:SF2', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L32', 245068),
(354317, 'PTHR35534:SF1', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L32', 245068),
(354318, 'PTHR35534', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L32', 245068),
(354319, 'PTHR43464:SF61', NULL, NULL, NULL, NULL, 'SLL0564 PROTEIN', 245069),
(354320, 'PTHR43464:SF83', NULL, NULL, NULL, NULL, 'MALONYL-[ACYL-CARRIER PROTEIN] O-METHYLTRANSFERASE', 245069);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(354321, 'PTHR43464:SF82', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 245069),
(354322, 'PTHR43464:SF81', NULL, NULL, NULL, NULL, '2-HEPTYL-1-HYDROXYQUINOLIN-4(1H)-ONE METHYLTRANSFERASE', 245069),
(354323, 'PTHR43464:SF80', NULL, NULL, NULL, NULL, 'METHYLTRANFER_DOM DOMAIN-CONTAINING PROTEIN', 245069),
(354324, 'PTHR43464:SF65', NULL, NULL, NULL, NULL, 'METHYLTRANSF_25 DOMAIN-CONTAINING PROTEIN', 245069),
(354325, 'PTHR43464:SF87', NULL, NULL, NULL, NULL, 'MALONYL-[ACYL-CARRIER PROTEIN] O-METHYLTRANSFERASE', 245069),
(354326, 'PTHR43464:SF86', NULL, NULL, NULL, NULL, 'BLR5434 PROTEIN', 245069),
(354327, 'PTHR43464:SF85', NULL, NULL, NULL, NULL, 'TRNA 5-CARBOXYMETHOXYURIDINE METHYLTRANSFERASE', 245069),
(354328, 'PTHR43464:SF84', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE, PUTATIVE-RELATED', 245069),
(354329, 'PTHR43464:SF23', NULL, NULL, NULL, NULL, 'JUVENILE HORMONE ACID O-METHYLTRANSFERASE', 245069),
(354330, 'PTHR43464:SF49', NULL, NULL, NULL, NULL, 'TELLURITE METHYLTRANSFERASE', 245069),
(354331, 'PTHR43464:SF19', NULL, NULL, NULL, NULL, 'UBIQUINONE BIOSYNTHESIS O-METHYLTRANSFERASE, MITOCHONDRIAL', 245069),
(354332, 'PTHR43464', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 245069),
(354333, 'PTHR43464:SF72', NULL, NULL, NULL, NULL, 'GLL1483 PROTEIN', 245069),
(354334, 'PTHR43464:SF71', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE, PUTATIVE-RELATED', 245069),
(354335, 'PTHR43464:SF3', NULL, NULL, NULL, NULL, 'SAM-DEPENDENT METHYLTRANSFERASE-RELATED', 245069),
(354336, 'PTHR43464:SF70', NULL, NULL, NULL, NULL, 'METHYLTRANFER_DOM DOMAIN-CONTAINING PROTEIN-RELATED', 245069),
(354337, 'PTHR43464:SF76', NULL, NULL, NULL, NULL, 'MALONYL-[ACYL-CARRIER PROTEIN] O-METHYLTRANSFERASE', 245069),
(354338, 'PTHR43464:SF75', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE TYPE 11', 245069),
(354339, 'PTHR43464:SF74', NULL, NULL, NULL, NULL, 'DUF4214 DOMAIN-CONTAINING PROTEIN', 245069),
(354340, 'PTHR43464:SF52', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 245069),
(354341, 'PTHR43464:SF73', NULL, NULL, NULL, NULL, 'SAM-DEPENDENT METHYLTRANSFERASE-RELATED', 245069),
(354342, 'PTHR43464:SF58', NULL, NULL, NULL, NULL, 'BLL2745 PROTEIN', 245069),
(354343, 'PTHR43464:SF79', NULL, NULL, NULL, NULL, 'SAM-DEPENDENT METHYLTRANSFERASE', 245069),
(354344, 'PTHR43464:SF78', NULL, NULL, NULL, NULL, 'METHYLTRANFER_DOM DOMAIN-CONTAINING PROTEIN', 245069),
(354345, 'PTHR43464:SF77', NULL, NULL, NULL, NULL, 'BLL3586 PROTEIN', 245069),
(354346, 'PTHR36539', NULL, NULL, NULL, NULL, 'ETHANOLAMINE UTILIZATION PROTEIN EUTN', 245070),
(354347, 'PTHR36539:SF1', NULL, NULL, NULL, NULL, 'BACTERIAL MICROCOMPARTMENT VERTEX PROTEIN EUTN', 245070),
(354348, 'PTHR42739', NULL, NULL, NULL, NULL, 'MALATE SYNTHASE G', 245071),
(354349, 'PTHR42739:SF1', NULL, NULL, NULL, NULL, 'MALATE SYNTHASE G', 245071),
(354350, 'PTHR37871:SF1', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 22', 245072),
(354351, 'PTHR37871', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 22', 245072),
(354352, 'PTHR31433', NULL, NULL, NULL, NULL, 'PX DOMAIN-CONTAINING PROTEIN 1', 245073),
(354353, 'PTHR31433:SF0', NULL, NULL, NULL, NULL, 'PX DOMAIN-CONTAINING PROTEIN 1', 245073),
(354354, 'PTHR45839:SF7', NULL, NULL, NULL, NULL, 'SUCROSE SYNTHASE 1', 245074),
(354355, 'PTHR45839', NULL, NULL, NULL, NULL, '', 245074),
(354356, 'PTHR45839:SF9', NULL, NULL, NULL, NULL, 'SUCROSE SYNTHASE 2', 245074),
(354357, 'PTHR45839:SF11', NULL, NULL, NULL, NULL, 'SUCROSE SYNTHASE', 245074),
(354358, 'PTHR45839:SF22', NULL, NULL, NULL, NULL, 'SUCROSE SYNTHASE', 245074),
(354359, 'PTHR45839:SF23', NULL, NULL, NULL, NULL, 'SUCROSE SYNTHASE', 245074),
(354360, 'PTHR45839:SF31', NULL, NULL, NULL, NULL, 'SUCROSE SYNTHASE', 245074),
(354361, 'PTHR45839:SF4', NULL, NULL, NULL, NULL, 'SUCROSE SYNTHASE 5', 245074),
(354362, 'PTHR45839:SF10', NULL, NULL, NULL, NULL, 'SUCROSE SYNTHASE', 245074),
(354363, 'PTHR45839:SF5', NULL, NULL, NULL, NULL, 'SUCROSE SYNTHASE 3', 245074),
(354364, 'PTHR45839:SF21', NULL, NULL, NULL, NULL, 'SUCROSE SYNTHASE', 245074),
(354365, 'PTHR45839:SF30', NULL, NULL, NULL, NULL, 'SUCROSE SYNTHASE', 245074); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(354366, 'PTHR45839:SF19', NULL, NULL, NULL, NULL, 'SUCROSE SYNTHASE', 245074),
(354367, 'PTHR45839:SF29', NULL, NULL, NULL, NULL, 'SUCROSE SYNTHASE 1', 245074),
(354368, 'PTHR45839:SF18', NULL, NULL, NULL, NULL, 'SUCROSE SYNTHASE', 245074),
(354369, 'PTHR45839:SF26', NULL, NULL, NULL, NULL, 'SUCROSE SYNTHASE', 245074),
(354370, 'PTHR45839:SF27', NULL, NULL, NULL, NULL, 'SUCROSE SYNTHASE 4', 245074),
(354371, 'PTHR45839:SF16', NULL, NULL, NULL, NULL, 'SUCROSE SYNTHASE 6', 245074),
(354372, 'PTHR45839:SF13', NULL, NULL, NULL, NULL, 'SUCROSE SYNTHASE 3', 245074),
(354373, 'PTHR45839:SF24', NULL, NULL, NULL, NULL, 'SUCROSE SYNTHASE 6', 245074),
(354374, 'PTHR45839:SF25', NULL, NULL, NULL, NULL, 'SUCROSE SYNTHASE', 245074),
(354375, 'PTHR21531:SF1', NULL, NULL, NULL, NULL, 'LOW TEMPERATURE VIABILITY PROTEIN', 245075),
(354376, 'PTHR21531:SF0', NULL, NULL, NULL, NULL, 'PROTEIN LTV1 HOMOLOG', 245075),
(354377, 'PTHR21531', NULL, NULL, NULL, NULL, 'LOW-TEMPERATURE VIABILITY PROTEIN LTV1-RELATED', 245075),
(354378, 'PTHR47318', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP37, CHLOROPLASTIC', 245076),
(354379, 'PTHR47318:SF1', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP37, CHLOROPLASTIC', 245076),
(354380, 'PTHR34395:SF19', NULL, NULL, NULL, NULL, '', 245077),
(354381, 'PTHR34395:SF5', NULL, NULL, NULL, NULL, '', 245077),
(354382, 'PTHR34395:SF15', NULL, NULL, NULL, NULL, 'OS09G0292400 PROTEIN', 245077),
(354383, 'PTHR34395:SF16', NULL, NULL, NULL, NULL, '', 245077),
(354384, 'PTHR34395:SF11', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 245077),
(354385, 'PTHR34395:SF3', NULL, NULL, NULL, NULL, 'OS10G0460800 PROTEIN', 245077),
(354386, 'PTHR34395', NULL, NULL, NULL, NULL, 'OS11G0427500 PROTEIN', 245077),
(354387, 'PTHR34395:SF20', NULL, NULL, NULL, NULL, '', 245077),
(354388, 'PTHR45376:SF1', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN-RELATED', 245078),
(354389, 'PTHR45376:SF6', NULL, NULL, NULL, NULL, 'BNAC04G48090D PROTEIN', 245078),
(354390, 'PTHR45376', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN-RELATED', 245078),
(354391, 'PTHR45376:SF7', NULL, NULL, NULL, NULL, 'OS04G0687300 PROTEIN', 245078),
(354392, 'PTHR45376:SF5', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', 245078),
(354393, 'PTHR36003', NULL, NULL, NULL, NULL, 'TONB-DEPENDENT HEME RECEPTOR A', 245079),
(354394, 'PTHR36003:SF4', NULL, NULL, NULL, NULL, 'SLL1 PROTEIN', 245079),
(354395, 'PTHR36003:SF5', NULL, NULL, NULL, NULL, 'TONB-DEPENDENT HEME RECEPTOR A', 245079),
(354396, 'PTHR36003:SF6', NULL, NULL, NULL, NULL, 'SLL1 PROTEIN', 245079),
(354397, 'PTHR46150', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 100F', 245080),
(354398, 'PTHR46150:SF2', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN SYDE1', 245080),
(354399, 'PTHR46150:SF1', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN SYDE2', 245080),
(354400, 'PTHR46150:SF3', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 100F', 245080),
(354401, 'PTHR36114:SF8', NULL, NULL, NULL, NULL, 'CUPIN TYPE-1 DOMAIN-CONTAINING PROTEIN', 245081),
(354402, 'PTHR36114:SF4', NULL, NULL, NULL, NULL, 'CUPIN_2 DOMAIN-CONTAINING PROTEIN', 245081),
(354403, 'PTHR36114', NULL, NULL, NULL, NULL, '16.7 KDA PROTEIN IN WHIE LOCUS', 245081),
(354404, 'PTHR36114:SF1', NULL, NULL, NULL, NULL, '16.7 KDA PROTEIN IN WHIE LOCUS', 245081),
(354405, 'PTHR12312:SF16', NULL, NULL, NULL, NULL, 'TWISTED GASTRULATION PROTEIN HOMOLOG 1', 245082),
(354406, 'PTHR12312', NULL, NULL, NULL, NULL, 'TWISTED GASTRULATION PROTEIN HOMOLOG 1-A-RELATED', 245082),
(354407, 'PTHR32315:SF4', NULL, NULL, NULL, NULL, 'URACIL PHOSPHORIBOSYLTRANSFERASE, CHLOROPLASTIC', 245083),
(354408, 'PTHR32315:SF3', NULL, NULL, NULL, NULL, 'ADENINE PHOSPHORIBOSYLTRANSFERASE', 245083),
(354409, 'PTHR32315', NULL, NULL, NULL, NULL, 'ADENINE PHOSPHORIBOSYLTRANSFERASE', 245083),
(354410, 'PTHR22698:SF1', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN 9', 245084),
(354411, 'PTHR22698', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN 9', 245084);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(354412, 'PTHR12413:SF2', NULL, NULL, NULL, NULL, 'DOLICHYL PYROPHOSPHATE GLC1MAN9GLCNAC2 ALPHA-1,3-GLUCOSYLTRANSFERASE-RELATED', 245085),
(354413, 'PTHR12413', NULL, NULL, NULL, NULL, 'DOLICHYL GLYCOSYLTRANSFERASE', 245085),
(354414, 'PTHR12413:SF1', NULL, NULL, NULL, NULL, 'DOLICHYL PYROPHOSPHATE MAN9GLCNAC2 ALPHA-1,3-GLUCOSYLTRANSFERASE', 245085),
(354415, 'PTHR10340:SF31', NULL, NULL, NULL, NULL, 'SPHINGOMYELIN PHOSPHODIESTERASE ASM-3-RELATED', 245086),
(354416, 'PTHR10340:SF53', NULL, NULL, NULL, NULL, 'SPHINGOMYELINASE PHOSPHODIESTERASE D', 245086),
(354417, 'PTHR10340:SF55', NULL, NULL, NULL, NULL, 'ENDOPOLYPHOSPHATASE', 245086),
(354418, 'PTHR10340:SF54', NULL, NULL, NULL, NULL, 'SPHINGOMYELIN PHOSPHODIESTERASE 2', 245086),
(354419, 'PTHR10340:SF24', NULL, NULL, NULL, NULL, 'ACID SPHINGOMYELINASE-LIKE PHOSPHODIESTERASE 3A', 245086),
(354420, 'PTHR10340:SF57', NULL, NULL, NULL, NULL, 'METALLOPHOS DOMAIN-CONTAINING PROTEIN', 245086),
(354421, 'PTHR10340:SF56', NULL, NULL, NULL, NULL, 'SPHINGOMYELIN PHOSPHODIESTERASE B', 245086),
(354422, 'PTHR10340:SF34', NULL, NULL, NULL, NULL, 'SPHINGOMYELIN PHOSPHODIESTERASE', 245086),
(354423, 'PTHR10340:SF25', NULL, NULL, NULL, NULL, 'ACID SPHINGOMYELINASE-LIKE PHOSPHODIESTERASE 3B', 245086),
(354424, 'PTHR10340:SF27', NULL, NULL, NULL, NULL, 'ASM3P', 245086),
(354425, 'PTHR10340:SF29', NULL, NULL, NULL, NULL, 'SPHINGOMYELIN PHOSPHODIESTERASE', 245086),
(354426, 'PTHR10340', NULL, NULL, NULL, NULL, 'SPHINGOMYELIN PHOSPHODIESTERASE', 245086),
(354427, 'PTHR30194', NULL, NULL, NULL, NULL, 'CROSSOVER JUNCTION ENDODEOXYRIBONUCLEASE RUVC', 245087),
(354428, 'PTHR30194:SF3', NULL, NULL, NULL, NULL, 'CROSSOVER JUNCTION ENDODEOXYRIBONUCLEASE RUVC', 245087),
(354429, 'PTHR39757:SF8', NULL, NULL, NULL, NULL, 'BNAC09G53690D PROTEIN', 245088),
(354430, 'PTHR39757:SF9', NULL, NULL, NULL, NULL, 'CAPSANTHIN/CAPSORUBIN SYNTHASE, CHROMOPLAST PROTEIN', 245088),
(354431, 'PTHR39757:SF10', NULL, NULL, NULL, NULL, 'BNAA01G26530D PROTEIN', 245088),
(354432, 'PTHR39757', NULL, NULL, NULL, NULL, '', 245088),
(354433, 'PTHR39757:SF5', NULL, NULL, NULL, NULL, 'OS02G0190600 PROTEIN', 245088),
(354434, 'PTHR39757:SF3', NULL, NULL, NULL, NULL, 'LYCOPENE EPSILON CYCLASE, CHLOROPLASTIC', 245088),
(354435, 'PTHR12903', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOMAL PROTEIN L24', 245089),
(354436, 'PTHR12903:SF10', NULL, NULL, NULL, NULL, 'KOW DOMAIN-CONTAINING PROTEIN', 245089),
(354437, 'PTHR12903:SF9', NULL, NULL, NULL, NULL, 'KOW DOMAIN-CONTAINING PROTEIN', 245089),
(354438, 'PTHR12903:SF13', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L24, CHLOROPLASTIC', 245089),
(354439, 'PTHR12903:SF14', NULL, NULL, NULL, NULL, '', 245089),
(354440, 'PTHR12903:SF0', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L24, MITOCHONDRIAL', 245089),
(354441, 'PTHR12903:SF12', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L24, CHLOROPLASTIC-LIKE', 245089),
(354442, 'PTHR38451', NULL, NULL, NULL, NULL, 'TRNA (ADENINE(22)-N(1))-METHYLTRANSFERASE', 245090),
(354443, 'PTHR38451:SF1', NULL, NULL, NULL, NULL, 'TRNA (ADENINE(22)-N(1))-METHYLTRANSFERASE', 245090),
(354444, 'PTHR21549:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 148', 245091),
(354445, 'PTHR21549:SF0', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 112', 245091),
(354446, 'PTHR21549', NULL, NULL, NULL, NULL, 'MUTATED IN BLADDER CANCER 1', 245091),
(354447, 'PTHR46813:SF1', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 15', 245092),
(354448, 'PTHR46813:SF11', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 245092),
(354449, 'PTHR46813', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 18', 245092),
(354450, 'PTHR46813:SF13', NULL, NULL, NULL, NULL, 'BNAC01G40720D PROTEIN', 245092),
(354451, 'PTHR46813:SF12', NULL, NULL, NULL, NULL, 'BNAC07G16680D PROTEIN', 245092),
(354452, 'PTHR46813:SF15', NULL, NULL, NULL, NULL, 'OS01G0662800 PROTEIN', 245092),
(354453, 'PTHR46813:SF16', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 18', 245092),
(354454, 'PTHR46813:SF9', NULL, NULL, NULL, NULL, 'BNAA08G15310D PROTEIN', 245092);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(354455, 'PTHR46813:SF19', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 19', 245092),
(354456, 'PTHR46813:SF18', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 245092),
(354457, 'PTHR46813:SF6', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR', 245092),
(354458, 'PTHR46813:SF4', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 20', 245092),
(354459, 'PTHR32387:SF18', NULL, NULL, NULL, NULL, 'DUF3883 DOMAIN-CONTAINING PROTEIN', 245093),
(354460, 'PTHR32387:SF9', NULL, NULL, NULL, NULL, '', 245093),
(354461, 'PTHR32387:SF16', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE-LIKE ATPASE, C-TERMINAL DOMAIN-CONTAINING PROTEIN-RELATED', 245093),
(354462, 'PTHR32387:SF14', NULL, NULL, NULL, NULL, 'BNAANNG19870D PROTEIN', 245093),
(354463, 'PTHR32387:SF12', NULL, NULL, NULL, NULL, '', 245093),
(354464, 'PTHR32387:SF11', NULL, NULL, NULL, NULL, 'HMG BOX DOMAIN-CONTAINING PROTEIN', 245093),
(354465, 'PTHR32387:SF0', NULL, NULL, NULL, NULL, 'WU:FJ29H11', 245093),
(354466, 'PTHR32387:SF3', NULL, NULL, NULL, NULL, 'ATP/DNA BINDING PROTEIN', 245093),
(354467, 'PTHR32387', NULL, NULL, NULL, NULL, 'WU:FJ29H11', 245093),
(354468, 'PTHR34680:SF5', NULL, NULL, NULL, NULL, 'WRC DOMAIN-CONTAINING PROTEIN', 245094),
(354469, 'PTHR34680', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245094),
(354470, 'PTHR34680:SF3', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245094),
(354471, 'PTHR34680:SF8', NULL, NULL, NULL, NULL, 'WRC DOMAIN-CONTAINING PROTEIN', 245094),
(354472, 'PTHR34680:SF7', NULL, NULL, NULL, NULL, 'WRC DOMAIN-CONTAINING PROTEIN', 245094),
(354473, 'PTHR34680:SF6', NULL, NULL, NULL, NULL, 'HMG-I AND HMG-Y, DNA-BINDING', 245094),
(354474, 'PTHR14609', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 219', 245095),
(354475, 'PTHR14609:SF1', NULL, NULL, NULL, NULL, 'ORC UBIQUITIN LIGASE 1', 245095),
(354476, 'PTHR24298:SF45', NULL, NULL, NULL, NULL, 'FLAVONOID 3''-MONOOXYGENASE', 245096),
(354477, 'PTHR24298:SF47', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 77A4', 245096),
(354478, 'PTHR24298:SF751', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 712, SUBFAMILY A, POLYPEPTIDE 2', 245096),
(354479, 'PTHR24298:SF630', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 705A1-RELATED', 245096),
(354480, 'PTHR24298:SF475', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 705A5-RELATED', 245096),
(354481, 'PTHR24298:SF872', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A26', 245096),
(354482, 'PTHR24298:SF871', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 76 SUBFAMILY C POLYPEPTIDE 7', 245096),
(354483, 'PTHR24298:SF474', NULL, NULL, NULL, NULL, 'OS08G0507100 PROTEIN', 245096),
(354484, 'PTHR24298:SF879', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP736A12-LIKE', 245096),
(354485, 'PTHR24298:SF636', NULL, NULL, NULL, NULL, 'OS07G0451300 PROTEIN', 245096),
(354486, 'PTHR24298:SF515', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71B6', 245096),
(354487, 'PTHR24298:SF878', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 81E8-LIKE', 245096),
(354488, 'PTHR24298:SF877', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71B34', 245096),
(354489, 'PTHR24298:SF876', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP71C36', 245096),
(354490, 'PTHR24298:SF875', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71B10', 245096),
(354491, 'PTHR24298:SF477', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 245096),
(354492, 'PTHR24298:SF507', NULL, NULL, NULL, NULL, '3,9-DIHYDROXYPTEROCARPAN 6A-MONOOXYGENASE-LIKE', 245096),
(354493, 'PTHR24298:SF903', NULL, NULL, NULL, NULL, '', 245096),
(354494, 'PTHR24298:SF860', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 81F2', 245096),
(354495, 'PTHR24298:SF581', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 SUPERFAMILY PROTEIN-RELATED', 245096),
(354496, 'PTHR24298:SF461', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 81F3', 245096),
(354497, 'PTHR24298:SF183', NULL, NULL, NULL, NULL, '', 245096),
(354498, 'PTHR24298:SF184', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 93G2', 245096),
(354499, 'PTHR24298:SF869', NULL, NULL, NULL, NULL, 'CYTOCHROME P450-RELATED', 245096),
(354500, 'PTHR24298:SF902', NULL, NULL, NULL, NULL, 'OS08G0105800 PROTEIN', 245096); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(354501, 'PTHR24298:SF901', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 81, SUBFAMILY D, POLYPEPTIDE 2-RELATED', 245096),
(354502, 'PTHR24298:SF626', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 81, SUBFAMILY H, POLYPEPTIDE 1', 245096),
(354503, 'PTHR24298:SF900', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 89A9', 245096),
(354504, 'PTHR24298:SF866', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP736A12-LIKE', 245096),
(354505, 'PTHR24298:SF744', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 245096),
(354506, 'PTHR24298:SF864', NULL, NULL, NULL, NULL, 'ORYZALEXIN E SYNTHASE', 245096),
(354507, 'PTHR24298:SF743', NULL, NULL, NULL, NULL, '3,9-DIHYDROXYPTEROCARPAN 6A-MONOOXYGENASE-LIKE', 245096),
(354508, 'PTHR24298:SF224', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 245096),
(354509, 'PTHR24298:SF587', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 81F4', 245096),
(354510, 'PTHR24298:SF819', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 705, SUBFAMILY A, POLYPEPTIDE 15-RELATED', 245096),
(354511, 'PTHR24298:SF818', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 9', 245096),
(354512, 'PTHR24298:SF817', NULL, NULL, NULL, NULL, '', 245096),
(354513, 'PTHR24298:SF419', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71B26', 245096),
(354514, 'PTHR24298:SF894', NULL, NULL, NULL, NULL, 'TRYPTOPHAN N-MONOOXYGENASE 1', 245096),
(354515, 'PTHR24298:SF377', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 SUPERFAMILY PROTEIN-RELATED', 245096),
(354516, 'PTHR24298:SF893', NULL, NULL, NULL, NULL, 'P450, PUTATIVE-RELATED', 245096),
(354517, 'PTHR24298:SF650', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 245096),
(354518, 'PTHR24298:SF495', NULL, NULL, NULL, NULL, '', 245096),
(354519, 'PTHR24298:SF892', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 87 SUBFAMILY A POLYPEPTIDE 6', 245096),
(354520, 'PTHR24298:SF891', NULL, NULL, NULL, NULL, 'P450 FAMILY PROTEIN, PUTATIVE-RELATED', 245096),
(354521, 'PTHR24298:SF890', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 245096),
(354522, 'PTHR24298:SF491', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 93G1', 245096),
(354523, 'PTHR24298:SF492', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 87 SUBFAMILY A POLYPEPTIDE 6', 245096),
(354524, 'PTHR24298:SF811', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 245096),
(354525, 'PTHR24298:SF899', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 81E8-LIKE', 245096),
(354526, 'PTHR24298:SF898', NULL, NULL, NULL, NULL, 'OS09G0447500 PROTEIN', 245096),
(354527, 'PTHR24298:SF810', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 SUPERFAMILY PROTEIN-RELATED', 245096),
(354528, 'PTHR24298:SF897', NULL, NULL, NULL, NULL, 'OS09G0530300 PROTEIN', 245096),
(354529, 'PTHR24298:SF896', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 245096),
(354530, 'PTHR24298:SF378', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 245096),
(354531, 'PTHR24298:SF379', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 71 PROTEIN', 245096),
(354532, 'PTHR24298:SF774', NULL, NULL, NULL, NULL, 'ISOFLAVONE 3''-HYDROXYLASE-LIKE', 245096),
(354533, 'PTHR24298:SF895', NULL, NULL, NULL, NULL, 'OS06G0613600 PROTEIN', 245096),
(354534, 'PTHR24298:SF883', NULL, NULL, NULL, NULL, 'P450, PUTATIVE-RELATED', 245096),
(354535, 'PTHR24298:SF366', NULL, NULL, NULL, NULL, 'OS08G0152300 PROTEIN', 245096),
(354536, 'PTHR24298:SF882', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 705, SUBFAMILY A, POLYPEPTIDE 18-RELATED', 245096),
(354537, 'PTHR24298:SF881', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 89A2-LIKE', 245096),
(354538, 'PTHR24298:SF760', NULL, NULL, NULL, NULL, '3-HYDROXYINDOLIN-2-ONE MONOOXYGENASE', 245096),
(354539, 'PTHR24298:SF880', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71B35', 245096),
(354540, 'PTHR24298:SF889', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 98A3', 245096),
(354541, 'PTHR24298:SF800', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 89A2-RELATED', 245096),
(354542, 'PTHR24298:SF888', NULL, NULL, NULL, NULL, 'P450, PUTATIVE-RELATED', 245096),
(354543, 'PTHR24298:SF887', NULL, NULL, NULL, NULL, '', 245096),
(354544, 'PTHR24298:SF523', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 81, SUBFAMILY D, POLYPEPTIDE 6-RELATED', 245096);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(354545, 'PTHR24298:SF765', NULL, NULL, NULL, NULL, '', 245096),
(354546, 'PTHR24298:SF886', NULL, NULL, NULL, NULL, '', 245096),
(354547, 'PTHR24298:SF885', NULL, NULL, NULL, NULL, '', 245096),
(354548, 'PTHR24298:SF642', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A26', 245096),
(354549, 'PTHR24298:SF763', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A26', 245096),
(354550, 'PTHR24298:SF884', NULL, NULL, NULL, NULL, 'P450, PUTATIVE-RELATED', 245096),
(354551, 'PTHR24298:SF839', NULL, NULL, NULL, NULL, 'ISOFLAVONE 2''-HYDROXYLASE', 245096),
(354552, 'PTHR24298:SF80', NULL, NULL, NULL, NULL, 'OS02G0108800 PROTEIN', 245096),
(354553, 'PTHR24298:SF82', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 SUPERFAMILY PROTEIN-RELATED', 245096),
(354554, 'PTHR24298:SF399', NULL, NULL, NULL, NULL, 'P450, PUTATIVE-RELATED', 245096),
(354555, 'PTHR24298:SF152', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN, EXPRESSED', 245096),
(354556, 'PTHR24298:SF835', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 245096),
(354557, 'PTHR24298:SF833', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN, EXPRESSED', 245096),
(354558, 'PTHR24298:SF678', NULL, NULL, NULL, NULL, 'BETA-AMYRIN 24-HYDROXYLASE', 245096),
(354559, 'PTHR24298:SF831', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP76M15', 245096),
(354560, 'PTHR24298:SF830', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 245096),
(354561, 'PTHR24298:SF675', NULL, NULL, NULL, NULL, 'PHENYLALANINE N-MONOOXYGENASE-RELATED', 245096),
(354562, 'PTHR24298:SF554', NULL, NULL, NULL, NULL, 'INDOLIN-2-ONE MONOOXYGENASE', 245096),
(354563, 'PTHR24298:SF828', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 245096),
(354564, 'PTHR24298:SF827', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 705, SUBFAMILY A, POLYPEPTIDE 8-RELATED', 245096),
(354565, 'PTHR24298:SF826', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 SUPERFAMILY PROTEIN-RELATED', 245096),
(354566, 'PTHR24298:SF542', NULL, NULL, NULL, NULL, '', 245096),
(354567, 'PTHR24298:SF662', NULL, NULL, NULL, NULL, '2-HYDROXYISOFLAVANONE SYNTHASE', 245096),
(354568, 'PTHR24298:SF541', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 705A20-RELATED', 245096),
(354569, 'PTHR24298:SF388', NULL, NULL, NULL, NULL, '', 245096),
(354570, 'PTHR24298:SF143', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP79A33', 245096),
(354571, 'PTHR24298:SF428', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 93B16', 245096),
(354572, 'PTHR24298:SF825', NULL, NULL, NULL, NULL, 'OS01G0350200 PROTEIN', 245096),
(354573, 'PTHR24298:SF824', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 245096),
(354574, 'PTHR24298:SF669', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 81F1', 245096),
(354575, 'PTHR24298:SF823', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 SUPERFAMILY PROTEIN-RELATED', 245096),
(354576, 'PTHR24298:SF668', NULL, NULL, NULL, NULL, 'INDOLE-2-MONOOXYGENASE', 245096),
(354577, 'PTHR24298:SF547', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 79, SUBFAMILY C, POLYPEPTIDE 1', 245096),
(354578, 'PTHR24298:SF820', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 89A2-LIKE', 245096),
(354579, 'PTHR24298:SF389', NULL, NULL, NULL, NULL, 'OS04G0128400 PROTEIN', 245096),
(354580, 'PTHR24298:SF619', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71B36-RELATED', 245096),
(354581, 'PTHR24298', NULL, NULL, NULL, NULL, 'FLAVONOID 3''-MONOOXYGENASE-RELATED', 245096),
(354582, 'PTHR24298:SF453', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 705A22', 245096),
(354583, 'PTHR24298:SF573', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 87 SUBFAMILY A POLYPEPTIDE 6', 245096),
(354584, 'PTHR24298:SF692', NULL, NULL, NULL, NULL, 'OS10G0515200 PROTEIN', 245096),
(354585, 'PTHR24298:SF691', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71D7', 245096),
(354586, 'PTHR24298:SF219', NULL, NULL, NULL, NULL, 'OS06G0325900 PROTEIN', 245096),
(354587, 'PTHR24298:SF858', NULL, NULL, NULL, NULL, '', 245096),
(354588, 'PTHR24298:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 98A3', 245096),
(354589, 'PTHR24298:SF857', NULL, NULL, NULL, NULL, '', 245096),
(354590, 'PTHR24298:SF612', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 89A2-LIKE', 245096);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(354591, 'PTHR24298:SF577', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY MONOOXYGENASE', 245096),
(354592, 'PTHR24298:SF851', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 87 SUBFAMILY A POLYPEPTIDE 6', 245096),
(354593, 'PTHR24298:SF54', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 LIKE PROTEIN', 245096),
(354594, 'PTHR24298:SF442', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 93 SUBFAMILY D POLYPEPTIDE 1', 245096),
(354595, 'PTHR24298:SF563', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 76C3', 245096),
(354596, 'PTHR24298:SF684', NULL, NULL, NULL, NULL, 'DIHOMOMETHIONINE N-HYDROXYLASE-RELATED', 245096),
(354597, 'PTHR24298:SF441', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 81D1', 245096),
(354598, 'PTHR24298:SF847', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 87 SUBFAMILY A POLYPEPTIDE 6', 245096),
(354599, 'PTHR24298:SF59', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 705, SUBFAMILY A, POLYPEPTIDE 25-RELATED', 245096),
(354600, 'PTHR24298:SF846', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 MONOOXYGENASE-LIKE PROTEIN', 245096),
(354601, 'PTHR24298:SF603', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A26', 245096),
(354602, 'PTHR24298:SF845', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 71 PROTEIN', 245096),
(354603, 'PTHR24298:SF723', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71C3', 245096),
(354604, 'PTHR24298:SF204', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 712, SUBFAMILY A, POLYPEPTIDE 1', 245096),
(354605, 'PTHR24298:SF841', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 81D11', 245096),
(354606, 'PTHR24298:SF444', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 245096),
(354607, 'PTHR14553:SF1', NULL, NULL, NULL, NULL, 'SIMILAR TO CHROMOSOME 1 OPEN READING FRAME 50', 245097),
(354608, 'PTHR14553', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN C1ORF50', 245097),
(354609, 'PTHR46526', NULL, NULL, NULL, NULL, 'CHORDIN', 245098),
(354610, 'PTHR46526:SF1', NULL, NULL, NULL, NULL, 'CHORDIN', 245098),
(354611, 'PTHR20835:SF4', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE PPP1R11', 245099),
(354612, 'PTHR20835:SF3', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE PPP1R11', 245099),
(354613, 'PTHR20835:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG06971', 245099),
(354614, 'PTHR20835:SF5', NULL, NULL, NULL, NULL, 'BNAA05G11590D PROTEIN', 245099),
(354615, 'PTHR20835:SF0', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE PPP1R11', 245099),
(354616, 'PTHR20835', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE PPP1R11-RELATED', 245099),
(354617, 'PTHR20835:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG00975', 245099),
(354618, 'PTHR20835:SF8', NULL, NULL, NULL, NULL, 'BNAC04G42180D PROTEIN', 245099),
(354619, 'PTHR20835:SF9', NULL, NULL, NULL, NULL, '', 245099),
(354620, 'PTHR37485:SF1', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN FTSB', 245100),
(354621, 'PTHR37485', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN FTSB', 245100),
(354622, 'PTHR40277:SF1', NULL, NULL, NULL, NULL, 'BLL5419 PROTEIN', 245101),
(354623, 'PTHR40277', NULL, NULL, NULL, NULL, 'BLL5419 PROTEIN', 245101),
(354624, 'PTHR35346:SF1', NULL, NULL, NULL, NULL, 'BEN DOMAIN-CONTAINING PROTEIN 6', 245102),
(354625, 'PTHR35346', NULL, NULL, NULL, NULL, 'BEN DOMAIN-CONTAINING PROTEIN 6', 245102),
(354626, 'PTHR32325', NULL, NULL, NULL, NULL, 'BETA-ELIMINATING LYASE-LIKE PROTEIN-RELATED', 245103),
(354627, 'PTHR32325:SF4', NULL, NULL, NULL, NULL, 'TRYPTOPHANASE', 245103),
(354628, 'PTHR12050:SF5', NULL, NULL, NULL, NULL, 'LEPTIN RECEPTOR OVERLAPPING TRANSCRIPT LIKE 1', 245104),
(354629, 'PTHR12050', NULL, NULL, NULL, NULL, 'LEPTIN RECEPTOR-RELATED', 245104),
(354630, 'PTHR12050:SF1', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 55 HOMOLOG', 245104),
(354631, 'PTHR12050:SF3', NULL, NULL, NULL, NULL, 'LEPTIN RECEPTOR GENE-RELATED PROTEIN', 245104),
(354632, 'PTHR12050:SF4', NULL, NULL, NULL, NULL, 'LEPTIN RECEPTOR OVERLAPPING TRANSCRIPT-LIKE 1', 245104),
(354633, 'PTHR12050:SF0', NULL, NULL, NULL, NULL, 'RH04491P', 245104),
(354634, 'PTHR12021:SF18', NULL, NULL, NULL, NULL, 'THYMOSIN BETA-4, Y-CHROMOSOMAL', 245105);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(354635, 'PTHR12021:SF3', NULL, NULL, NULL, NULL, 'THYMOSIN BETA', 245105),
(354636, 'PTHR12021:SF17', NULL, NULL, NULL, NULL, 'THYMOSIN BETA', 245105),
(354637, 'PTHR12021:SF14', NULL, NULL, NULL, NULL, 'THYMOSIN BETA 15A', 245105),
(354638, 'PTHR12021:SF26', NULL, NULL, NULL, NULL, 'THYMOSIN BETA HOMOLOGUE', 245105),
(354639, 'PTHR12021:SF24', NULL, NULL, NULL, NULL, 'THYMOSIN BETA', 245105),
(354640, 'PTHR12021:SF10', NULL, NULL, NULL, NULL, 'THYMOSIN BETA-10', 245105),
(354641, 'PTHR12021:SF21', NULL, NULL, NULL, NULL, 'THYMOSIN BETA-15B', 245105),
(354642, 'PTHR12021:SF11', NULL, NULL, NULL, NULL, 'THYMOSIN BETA-15A-RELATED', 245105),
(354643, 'PTHR12021:SF5', NULL, NULL, NULL, NULL, 'THYMOSIN BETA', 245105),
(354644, 'PTHR12021:SF20', NULL, NULL, NULL, NULL, 'THYMOSIN BETA-4', 245105),
(354645, 'PTHR12021', NULL, NULL, NULL, NULL, 'THYMOSIN BETA', 245105),
(354646, 'PTHR46870:SF2', NULL, NULL, NULL, NULL, 'PROTEIN THYLAKOID ASSEMBLY 8-LIKE, CHLOROPLASTIC', 245106),
(354647, 'PTHR46870:SF1', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 245106),
(354648, 'PTHR46870', NULL, NULL, NULL, NULL, 'PROTEIN THYLAKOID ASSEMBLY 8-LIKE, CHLOROPLASTIC', 245106),
(354649, 'PTHR36715:SF4', NULL, NULL, NULL, NULL, 'BNAA02G13840D PROTEIN', 245107),
(354650, 'PTHR36715', NULL, NULL, NULL, NULL, 'BNAANNG41370D PROTEIN', 245107),
(354651, 'PTHR36715:SF3', NULL, NULL, NULL, NULL, 'BNAC06G30030D PROTEIN', 245107),
(354652, 'PTHR36715:SF2', NULL, NULL, NULL, NULL, '', 245107),
(354653, 'PTHR36715:SF1', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 245107),
(354654, 'PTHR44757:SF4', NULL, NULL, NULL, NULL, 'DIGUANYLATE CYCLASE DGCE-RELATED', 245108),
(354655, 'PTHR44757:SF2', NULL, NULL, NULL, NULL, 'CYCLIC DI-GMP PHOSPHODIESTERASE PDER', 245108),
(354656, 'PTHR44757', NULL, NULL, NULL, NULL, 'DIGUANYLATE CYCLASE DGCP', 245108),
(354657, 'PTHR44757:SF9', NULL, NULL, NULL, NULL, 'ANTI-FLHC(2)FLHD(4) FACTOR YDIV', 245108),
(354658, 'PTHR12608:SF15', NULL, NULL, NULL, NULL, 'GDT1 FAMILY PROTEIN', 245109),
(354659, 'PTHR12608:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 165', 245109),
(354660, 'PTHR12608', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN HTP-1 RELATED', 245109),
(354661, 'PTHR12608:SF5', NULL, NULL, NULL, NULL, 'GDT1-LIKE PROTEIN 3', 245109),
(354662, 'PTHR12608:SF17', NULL, NULL, NULL, NULL, 'GDT1 FAMILY PROTEIN', 245109),
(354663, 'PTHR12608:SF9', NULL, NULL, NULL, NULL, 'GDT1-LIKE PROTEIN 3', 245109),
(354664, 'PTHR12608:SF6', NULL, NULL, NULL, NULL, 'PROTEIN PAM71, CHLOROPLASTIC', 245109),
(354665, 'PTHR12608:SF7', NULL, NULL, NULL, NULL, 'PROTEIN PAM71-HOMOLOG, CHLOROPLASTIC', 245109),
(354666, 'PTHR12608:SF12', NULL, NULL, NULL, NULL, 'GDT1 FAMILY PROTEIN', 245109),
(354667, 'PTHR12608:SF11', NULL, NULL, NULL, NULL, 'GDT1 FAMILY PROTEIN', 245109),
(354668, 'PTHR47581:SF2', NULL, NULL, NULL, NULL, 'OS09G0431600 PROTEIN', 245110),
(354669, 'PTHR47581', NULL, NULL, NULL, NULL, 'OS09G0431600 PROTEIN', 245110),
(354670, 'PTHR38325:SF1', NULL, NULL, NULL, NULL, 'GENE, 17455-RELATED', 245111),
(354671, 'PTHR38325', NULL, NULL, NULL, NULL, 'MCG55969', 245111),
(354672, 'PTHR23360:SF32', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245112),
(354673, 'PTHR23360:SF10', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN-RELATED', 245112),
(354674, 'PTHR23360:SF11', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245112),
(354675, 'PTHR23360:SF71', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245112),
(354676, 'PTHR23360:SF72', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245112),
(354677, 'PTHR23360:SF73', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245112),
(354678, 'PTHR23360:SF6', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS SX', 245112),
(354679, 'PTHR23360:SF5', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245112),
(354680, 'PTHR23360:SF8', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245112);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(354681, 'PTHR23360:SF16', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245112),
(354682, 'PTHR23360:SF39', NULL, NULL, NULL, NULL, 'PROTEIN CBG13084', 245112),
(354683, 'PTHR23360:SF7', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245112),
(354684, 'PTHR23360:SF17', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245112),
(354685, 'PTHR23360:SF19', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245112),
(354686, 'PTHR23360:SF34', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245112),
(354687, 'PTHR23360:SF36', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245112),
(354688, 'PTHR23360:SF14', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS SX', 245112),
(354689, 'PTHR23360:SF15', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245112),
(354690, 'PTHR23360:SF37', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245112),
(354691, 'PTHR23360:SF41', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245112),
(354692, 'PTHR23360:SF64', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245112),
(354693, 'PTHR23360:SF21', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245112),
(354694, 'PTHR23360:SF66', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245112),
(354695, 'PTHR23360', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 245112),
(354696, 'PTHR23360:SF29', NULL, NULL, NULL, NULL, 'PROTEIN CBG02598', 245112),
(354697, 'PTHR23360:SF67', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245112),
(354698, 'PTHR23360:SF68', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245112),
(354699, 'PTHR23360:SF69', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245112),
(354700, 'PTHR23360:SF26', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245112),
(354701, 'PTHR46422:SF6', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE BSL1 HOMOLOG', 245113),
(354702, 'PTHR46422:SF7', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 245113),
(354703, 'PTHR46422:SF4', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE BSL3', 245113),
(354704, 'PTHR46422', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE BSL3', 245113),
(354705, 'PTHR46422:SF18', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 245113),
(354706, 'PTHR46422:SF19', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 245113),
(354707, 'PTHR46422:SF16', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 245113),
(354708, 'PTHR46422:SF17', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 245113),
(354709, 'PTHR46422:SF14', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE BSL2', 245113),
(354710, 'PTHR46422:SF15', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 245113),
(354711, 'PTHR46422:SF13', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 245113),
(354712, 'PTHR46422:SF21', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 245113),
(354713, 'PTHR46422:SF10', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 245113),
(354714, 'PTHR46422:SF11', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 245113),
(354715, 'PTHR46422:SF20', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE BSL1-RELATED', 245113),
(354716, 'PTHR46422:SF9', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 245113),
(354717, 'PTHR23280:SF27', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE NON-RECEPTOR TYPE', 245114),
(354718, 'PTHR23280:SF15', NULL, NULL, NULL, NULL, 'BAND 4.1-LIKE PROTEIN 5', 245114),
(354719, 'PTHR23280:SF25', NULL, NULL, NULL, NULL, 'MOESIN/EZRIN/RADIXIN HOMOLOG 1', 245114),
(354720, 'PTHR23280:SF24', NULL, NULL, NULL, NULL, 'BAND 4.1-LIKE PROTEIN 1', 245114);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(354721, 'PTHR23280:SF13', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MYLIP', 245114),
(354722, 'PTHR23280:SF12', NULL, NULL, NULL, NULL, 'PROTEIN 4.1', 245114),
(354723, 'PTHR23280:SF34', NULL, NULL, NULL, NULL, 'FERM DOMAIN CONTAINING 7', 245114),
(354724, 'PTHR23280:SF32', NULL, NULL, NULL, NULL, 'FI22325P1', 245114),
(354725, 'PTHR23280:SF21', NULL, NULL, NULL, NULL, 'PROTEIN 4.1 HOMOLOG', 245114),
(354726, 'PTHR23280:SF20', NULL, NULL, NULL, NULL, 'BAND 4.1-LIKE PROTEIN 3', 245114),
(354727, 'PTHR23280:SF18', NULL, NULL, NULL, NULL, 'BAND 4.1-LIKE PROTEIN 4B', 245114),
(354728, 'PTHR23280:SF17', NULL, NULL, NULL, NULL, 'BAND 4.1-LIKE PROTEIN 2', 245114),
(354729, 'PTHR23280', NULL, NULL, NULL, NULL, '4.1 G PROTEIN', 245114),
(354730, 'PTHR23280:SF8', NULL, NULL, NULL, NULL, 'FERM DOMAIN-CONTAINING PROTEIN 3', 245114),
(354731, 'PTHR23280:SF5', NULL, NULL, NULL, NULL, 'FERM DOMAIN-CONTAINING PROTEIN 5', 245114),
(354732, 'PTHR23280:SF4', NULL, NULL, NULL, NULL, 'BAND 4.1-LIKE PROTEIN 4A', 245114),
(354733, 'PTHR23280:SF40', NULL, NULL, NULL, NULL, '', 245114),
(354734, 'PTHR15249:SF0', NULL, NULL, NULL, NULL, 'TRAF FAMILY MEMBER-ASSOCIATED NF-KAPPA-B ACTIVATOR', 245115),
(354735, 'PTHR15249', NULL, NULL, NULL, NULL, 'TRAF FAMILY MEMBER-ASSOCIATED NF-KAPPA-B ACTIVATOR', 245115),
(354736, 'PTHR48208', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN I', 245116),
(354737, 'PTHR48208:SF2', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN I', 245116),
(354738, 'PTHR38468:SF1', NULL, NULL, NULL, NULL, 'SLL0939 PROTEIN', 245117),
(354739, 'PTHR38468', NULL, NULL, NULL, NULL, 'SLL0939 PROTEIN', 245117),
(354740, 'PTHR31817:SF7', NULL, NULL, NULL, NULL, '', 245118),
(354741, 'PTHR31817:SF3', NULL, NULL, NULL, NULL, 'SI:DKEY-222B8.4', 245118),
(354742, 'PTHR31817:SF5', NULL, NULL, NULL, NULL, '', 245118),
(354743, 'PTHR31817:SF0', NULL, NULL, NULL, NULL, 'HYPOTHETICAL MEMBRANE SPANNING PROTEIN', 245118),
(354744, 'PTHR31817:SF1', NULL, NULL, NULL, NULL, 'KIAA0895 LIKE', 245118),
(354745, 'PTHR31817', NULL, NULL, NULL, NULL, '', 245118),
(354746, 'PTHR33336:SF1', NULL, NULL, NULL, NULL, '(4S)-4-HYDROXY-5-PHOSPHONOOXYPENTANE-2,3-DIONE ISOMERASE', 245119),
(354747, 'PTHR33336', NULL, NULL, NULL, NULL, 'QUINOL MONOOXYGENASE YGIN-RELATED', 245119),
(354748, 'PTHR33336:SF3', NULL, NULL, NULL, NULL, 'ABM DOMAIN-CONTAINING PROTEIN', 245119),
(354749, 'PTHR33336:SF13', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', 245119),
(354750, 'PTHR33336:SF14', NULL, NULL, NULL, NULL, 'ANTIBIOTIC BIOSYNTHESIS MONOOXYGENASE', 245119),
(354751, 'PTHR24119:SF1', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 245120),
(354752, 'PTHR24119:SF0', NULL, NULL, NULL, NULL, 'ACYL-COA-BINDING DOMAIN-CONTAINING PROTEIN 6', 245120),
(354753, 'PTHR24119', NULL, NULL, NULL, NULL, 'ACYL-COA-BINDING DOMAIN-CONTAINING PROTEIN 6', 245120),
(354754, 'PTHR24119:SF10', NULL, NULL, NULL, NULL, 'SH2 DOMAIN-CONTAINING PROTEIN', 245120),
(354755, 'PTHR24119:SF4', NULL, NULL, NULL, NULL, 'ACYL-COA-BINDING DOMAIN-CONTAINING PROTEIN 2', 245120),
(354756, 'PTHR24119:SF7', NULL, NULL, NULL, NULL, '', 245120),
(354757, 'PTHR36565:SF5', NULL, NULL, NULL, NULL, 'TOXIN MJ0605-RELATED', 245121),
(354758, 'PTHR36565', NULL, NULL, NULL, NULL, 'UPF0332 PROTEIN TM_1000', 245121),
(354759, 'PTHR36565:SF1', NULL, NULL, NULL, NULL, 'UPF0332 PROTEIN TM_1000', 245121),
(354760, 'PTHR44969:SF1', NULL, NULL, NULL, NULL, 'CELL SURFACE A33 ANTIGEN', 245122),
(354761, 'PTHR44969', NULL, NULL, NULL, NULL, 'CELL SURFACE A33 ANTIGEN', 245122),
(354762, 'PTHR46788:SF1', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING DOMAIN-CONTAINING PROTEIN 5', 245123),
(354763, 'PTHR46788', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING DOMAIN-CONTAINING PROTEIN 5', 245123),
(354764, 'PTHR46653', NULL, NULL, NULL, NULL, 'SPECIFICITY PROTEIN PHOSPHATASE, PUTATIVE-RELATED', 245124),
(354765, 'PTHR46653:SF1', NULL, NULL, NULL, NULL, 'SPECIFICITY PROTEIN PHOSPHATASE, PUTATIVE-RELATED', 245124),
(354766, 'PTHR45782:SF5', NULL, NULL, NULL, NULL, 'DAR GTPASE 3, CHLOROPLASTIC', 245125);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(354767, 'PTHR45782:SF4', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOME-ASSOCIATED GTPASE 1', 245125),
(354768, 'PTHR45782:SF8', NULL, NULL, NULL, NULL, 'G DOMAIN-CONTAINING PROTEIN', 245125),
(354769, 'PTHR45782', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOME-ASSOCIATED GTPASE 1', 245125),
(354770, 'PTHR45782:SF1', NULL, NULL, NULL, NULL, 'DAR GTPASE 2, MITOCHONDRIAL', 245125),
(354771, 'PTHR33709:SF4', NULL, NULL, NULL, NULL, 'OS04G0606500 PROTEIN', 245126),
(354772, 'PTHR33709', NULL, NULL, NULL, NULL, 'OSJNBA0035M09.9 PROTEIN', 245126),
(354773, 'PTHR33709:SF20', NULL, NULL, NULL, NULL, 'OS04G0541900 PROTEIN', 245126),
(354774, 'PTHR33709:SF31', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 245126),
(354775, 'PTHR33709:SF32', NULL, NULL, NULL, NULL, 'UBIQUITIN-SPECIFIC PROTEASE FAMILY C19 PROTEIN', 245126),
(354776, 'PTHR33709:SF22', NULL, NULL, NULL, NULL, '', 245126),
(354777, 'PTHR33709:SF33', NULL, NULL, NULL, NULL, 'UBIQUITIN-SPECIFIC PROTEASE FAMILY C19-RELATED PROTEIN', 245126),
(354778, 'PTHR33709:SF34', NULL, NULL, NULL, NULL, '', 245126),
(354779, 'PTHR33709:SF12', NULL, NULL, NULL, NULL, 'UBIQUITIN THIOLESTERASE', 245126),
(354780, 'PTHR33709:SF23', NULL, NULL, NULL, NULL, 'BNAC04G08590D PROTEIN', 245126),
(354781, 'PTHR33709:SF24', NULL, NULL, NULL, NULL, 'BNAC05G12870D PROTEIN', 245126),
(354782, 'PTHR33709:SF13', NULL, NULL, NULL, NULL, 'F9K20.7 PROTEIN', 245126),
(354783, 'PTHR33709:SF35', NULL, NULL, NULL, NULL, '', 245126),
(354784, 'PTHR33709:SF25', NULL, NULL, NULL, NULL, 'UBIQUITIN-SPECIFIC PROTEASE FAMILY C19-RELATED PROTEIN-RELATED', 245126),
(354785, 'PTHR33709:SF14', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 245126),
(354786, 'PTHR33709:SF17', NULL, NULL, NULL, NULL, 'UBIQUITIN-SPECIFIC PROTEASE FAMILY C19-RELATED PROTEIN', 245126),
(354787, 'PTHR33709:SF28', NULL, NULL, NULL, NULL, 'CYSTEINE-TYPE ENDOPEPTIDASE/ UBIQUITIN THIOLESTERASE', 245126),
(354788, 'PTHR19308:SF2', NULL, NULL, NULL, NULL, 'START DOMAIN-CONTAINING PROTEIN', 245127),
(354789, 'PTHR19308', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLCHOLINE TRANSFER PROTEIN', 245127),
(354790, 'PTHR19308:SF7', NULL, NULL, NULL, NULL, 'START DOMAIN-CONTAINING PROTEIN 10', 245127),
(354791, 'PTHR19308:SF48', NULL, NULL, NULL, NULL, 'START DOMAIN-CONTAINING PROTEIN', 245127),
(354792, 'PTHR19308:SF46', NULL, NULL, NULL, NULL, 'START DOMAIN, START-LIKE DOMAIN PROTEIN-RELATED', 245127),
(354793, 'PTHR19308:SF47', NULL, NULL, NULL, NULL, 'START DOMAIN-CONTAINING PROTEIN', 245127),
(354794, 'PTHR19308:SF44', NULL, NULL, NULL, NULL, 'POLYKETIDE CYCLASE/DEHYDRASE AND LIPID TRANSPORT SUPERFAMILY PROTEIN', 245127),
(354795, 'PTHR19308:SF8', NULL, NULL, NULL, NULL, 'STAR-RELATED LIPID TRANSFER PROTEIN 7, MITOCHONDRIAL', 245127),
(354796, 'PTHR19308:SF42', NULL, NULL, NULL, NULL, 'START DOMAIN-CONTAINING PROTEIN', 245127),
(354797, 'PTHR19308:SF9', NULL, NULL, NULL, NULL, 'OS07G0185200 PROTEIN', 245127),
(354798, 'PTHR19308:SF40', NULL, NULL, NULL, NULL, 'START DOMAIN-CONTAINING PROTEIN', 245127),
(354799, 'PTHR19308:SF39', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLCHOLINE TRANSFER PROTEIN', 245127),
(354800, 'PTHR19308:SF37', NULL, NULL, NULL, NULL, 'POLYKETIDE CYCLASE/DEHYDRASE AND LIPID TRANSPORT SUPERFAMILY PROTEIN', 245127),
(354801, 'PTHR19308:SF13', NULL, NULL, NULL, NULL, 'OS02G0468400 PROTEIN', 245127),
(354802, 'PTHR19308:SF35', NULL, NULL, NULL, NULL, 'STAR-RELATED LIPID TRANSFER PROTEIN 7, MITOCHONDRIAL-LIKE ISOFORM X1', 245127),
(354803, 'PTHR19308:SF36', NULL, NULL, NULL, NULL, 'MEMBRANE RELATED PROTEIN-LIKE', 245127),
(354804, 'PTHR19308:SF14', NULL, NULL, NULL, NULL, 'START DOMAIN-CONTAINING PROTEIN', 245127),
(354805, 'PTHR19308:SF55', NULL, NULL, NULL, NULL, 'START DOMAIN-CONTAINING PROTEIN', 245127),
(354806, 'PTHR19308:SF11', NULL, NULL, NULL, NULL, 'POLYKETIDE CYCLASE/DEHYDRASE AND LIPID TRANSPORT SUPERFAMILY PROTEIN', 245127),
(354807, 'PTHR19308:SF33', NULL, NULL, NULL, NULL, 'START DOMAIN-CONTAINING PROTEIN', 245127),
(354808, 'PTHR19308:SF53', NULL, NULL, NULL, NULL, 'CERAMIDE TRANSFER PROTEIN', 245127);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(354809, 'PTHR19308:SF54', NULL, NULL, NULL, NULL, 'CHROMOSOME 19, WHOLE GENOME SHOTGUN SEQUENCE', 245127),
(354810, 'PTHR19308:SF51', NULL, NULL, NULL, NULL, 'START DOMAIN-CONTAINING PROTEIN', 245127),
(354811, 'PTHR19308:SF52', NULL, NULL, NULL, NULL, 'POLYKETIDE CYCLASE/DEHYDRASE AND LIPID TRANSPORT SUPERFAMILY PROTEIN', 245127),
(354812, 'PTHR19308:SF50', NULL, NULL, NULL, NULL, 'PROTEIN CP5, PUTATIVE-RELATED', 245127),
(354813, 'PTHR48157:SF1', NULL, NULL, NULL, NULL, '', 245128),
(354814, 'PTHR48157', NULL, NULL, NULL, NULL, '', 245128),
(354815, 'PTHR11475:SF112', NULL, NULL, NULL, NULL, '', 245129),
(354816, 'PTHR11475:SF134', NULL, NULL, NULL, NULL, 'LD42267P', 245129),
(354817, 'PTHR11475:SF22', NULL, NULL, NULL, NULL, 'PEROXIDASE SKPO-1', 245129),
(354818, 'PTHR11475:SF43', NULL, NULL, NULL, NULL, 'PROTEIN CBG06977', 245129),
(354819, 'PTHR11475:SF133', NULL, NULL, NULL, NULL, 'PROTEIN CBG02940', 245129),
(354820, 'PTHR11475:SF136', NULL, NULL, NULL, NULL, 'PEROXIDASIN HOMOLOG PXN-1', 245129),
(354821, 'PTHR11475:SF114', NULL, NULL, NULL, NULL, 'PEROXIDASE-LIKE PROTEIN', 245129),
(354822, 'PTHR11475:SF135', NULL, NULL, NULL, NULL, '', 245129),
(354823, 'PTHR11475:SF67', NULL, NULL, NULL, NULL, 'LACTOPEROXIDASE', 245129),
(354824, 'PTHR11475:SF138', NULL, NULL, NULL, NULL, 'CARDINAL', 245129),
(354825, 'PTHR11475:SF137', NULL, NULL, NULL, NULL, 'FTP DOMAIN-CONTAINING PROTEIN', 245129),
(354826, 'PTHR11475:SF115', NULL, NULL, NULL, NULL, 'CHORION PEROXIDASE', 245129),
(354827, 'PTHR11475:SF4', NULL, NULL, NULL, NULL, 'PEROXINECTIN A', 245129),
(354828, 'PTHR11475:SF139', NULL, NULL, NULL, NULL, 'EOSINOPHIL PEROXIDASE', 245129),
(354829, 'PTHR11475:SF60', NULL, NULL, NULL, NULL, 'THYROID PEROXIDASE', 245129),
(354830, 'PTHR11475:SF61', NULL, NULL, NULL, NULL, 'PEROXIDASE MLT-7', 245129),
(354831, 'PTHR11475:SF86', NULL, NULL, NULL, NULL, 'PEROXIDASE', 245129),
(354832, 'PTHR11475:SF63', NULL, NULL, NULL, NULL, 'EOSINOPHIL PEROXIDASE', 245129),
(354833, 'PTHR11475:SF85', NULL, NULL, NULL, NULL, 'SHKT DOMAIN-CONTAINING PROTEIN', 245129),
(354834, 'PTHR11475:SF131', NULL, NULL, NULL, NULL, 'PROTEIN CBG17660', 245129),
(354835, 'PTHR11475', NULL, NULL, NULL, NULL, 'OXIDASE/PEROXIDASE', 245129),
(354836, 'PTHR11475:SF54', NULL, NULL, NULL, NULL, 'PEROXIDASE', 245129),
(354837, 'PTHR11475:SF125', NULL, NULL, NULL, NULL, 'GH11385P', 245129),
(354838, 'PTHR11475:SF58', NULL, NULL, NULL, NULL, 'PEROXIDASIN', 245129),
(354839, 'PTHR11475:SF38', NULL, NULL, NULL, NULL, 'PEROXIDASIN-LIKE PROTEIN', 245129),
(354840, 'PTHR11475:SF106', NULL, NULL, NULL, NULL, 'CURLY SU', 245129),
(354841, 'PTHR11475:SF51', NULL, NULL, NULL, NULL, 'SHK DOMAIN AND PEROXIDASE DOMAIN CONTAINING PROTEIN', 245129),
(354842, 'PTHR11475:SF121', NULL, NULL, NULL, NULL, 'THYROID PEROXIDASE', 245129),
(354843, 'PTHR11475:SF75', NULL, NULL, NULL, NULL, 'PEROXIDASIN HOMOLOG', 245129),
(354844, 'PTHR11475:SF109', NULL, NULL, NULL, NULL, 'CHORION PEROXIDASE-LIKE PROTEIN', 245129),
(354845, 'PTHR11475:SF108', NULL, NULL, NULL, NULL, 'MYELOPEROXIDASE', 245129),
(354846, 'PTHR36296:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 2 OPEN READING FRAME 80', 245130),
(354847, 'PTHR36296', NULL, NULL, NULL, NULL, 'GAMMA-CRYSTALLIN A', 245130),
(354848, 'PTHR19327', NULL, NULL, NULL, NULL, 'GOLGIN', 245131),
(354849, 'PTHR19327:SF0', NULL, NULL, NULL, NULL, 'GOLGIN SUBFAMILY A MEMBER 4', 245131),
(354850, 'PTHR46772:SF3', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 245132),
(354851, 'PTHR46772:SF4', NULL, NULL, NULL, NULL, 'OS01G0518300 PROTEIN', 245132),
(354852, 'PTHR46772:SF6', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 245132),
(354853, 'PTHR46772:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH95', 245132),
(354854, 'PTHR46772:SF9', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 245132),
(354855, 'PTHR46772:SF10', NULL, NULL, NULL, NULL, 'BNAA05G16020D PROTEIN', 245132),
(354856, 'PTHR46772', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 245132),
(354857, 'PTHR46772:SF13', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 245132);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(354858, 'PTHR46772:SF12', NULL, NULL, NULL, NULL, 'OS02G0548100 PROTEIN', 245132),
(354859, 'PTHR46772:SF2', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 245132),
(354860, 'PTHR46772:SF14', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 245132),
(354861, 'PTHR22807:SF64', NULL, NULL, NULL, NULL, 'BNAA08G28690D PROTEIN', 245133),
(354862, 'PTHR22807:SF75', NULL, NULL, NULL, NULL, '25S RRNA (CYTOSINE-C(5))-METHYLTRANSFERASE NOP2A', 245133),
(354863, 'PTHR22807:SF53', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA SMALL SUBUNIT METHYLTRANSFERASE B-RELATED', 245133),
(354864, 'PTHR22807:SF54', NULL, NULL, NULL, NULL, 'SAM_MT_RSMB_NOP DOMAIN-CONTAINING PROTEIN', 245133),
(354865, 'PTHR22807:SF73', NULL, NULL, NULL, NULL, 'BNAA10G10010D PROTEIN', 245133),
(354866, 'PTHR22807:SF74', NULL, NULL, NULL, NULL, 'TRNA (CYTOSINE(48)-C(5))-METHYLTRANSFERASE', 245133),
(354867, 'PTHR22807:SF30', NULL, NULL, NULL, NULL, '28S RRNA (CYTOSINE(4447)-C(5))-METHYLTRANSFERASE-RELATED', 245133),
(354868, 'PTHR22807:SF68', NULL, NULL, NULL, NULL, '28S RRNA (CYTOSINE-C(5))-METHYLTRANSFERASE', 245133),
(354869, 'PTHR22807:SF66', NULL, NULL, NULL, NULL, 'BNAA09G04380D PROTEIN', 245133),
(354870, 'PTHR22807:SF67', NULL, NULL, NULL, NULL, 'NOL1/NOP2/SUN DOMAIN FAMILY MEMBER 5B-RELATED', 245133),
(354871, 'PTHR22807:SF34', NULL, NULL, NULL, NULL, 'TRNA (CYTOSINE(72)-C(5))-METHYLTRANSFERASE NSUN6', 245133),
(354872, 'PTHR22807:SF71', NULL, NULL, NULL, NULL, 'BNACNNG50050D PROTEIN', 245133),
(354873, 'PTHR22807:SF61', NULL, NULL, NULL, NULL, 'NOL1/NOP2/SUN FAMILY PROTEIN / ANTITERMINATION NUSB DOMAIN-CONTAINING PROTEIN', 245133),
(354874, 'PTHR22807:SF4', NULL, NULL, NULL, NULL, '28S RRNA (CYTOSINE-C(5))-METHYLTRANSFERASE', 245133),
(354875, 'PTHR22807:SF70', NULL, NULL, NULL, NULL, 'SUN (FMU) PROTEIN (SUN-2)', 245133),
(354876, 'PTHR22807', NULL, NULL, NULL, NULL, 'NOP2 YEAST -RELATED NOL1/NOP2/FMU SUN  DOMAIN-CONTAINING', 245133),
(354877, 'PTHR22807:SF16', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 245133),
(354878, 'PTHR43175:SF3', NULL, NULL, NULL, NULL, 'CARBON DISULFIDE HYDROLASE', 245134),
(354879, 'PTHR43175', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 245134),
(354880, 'PTHR43175:SF1', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE-LIKE PROTEIN YBCF-RELATED', 245134),
(354881, 'PTHR43005', NULL, NULL, NULL, NULL, 'BLR7065 PROTEIN', 245135),
(354882, 'PTHR43005:SF1', NULL, NULL, NULL, NULL, 'SPERMIDINE/PUTRESCINE TRANSPORT SYSTEM PERMEASE PROTEIN', 245135),
(354883, 'PTHR12861:SF2', NULL, NULL, NULL, NULL, 'TRANSLOCON-ASSOCIATED PROTEIN SUBUNIT BETA', 245136),
(354884, 'PTHR12861:SF3', NULL, NULL, NULL, NULL, 'TRANSLOCON-ASSOCIATED PROTEIN SUBUNIT BETA', 245136),
(354885, 'PTHR12861:SF6', NULL, NULL, NULL, NULL, 'TRANSLOCON-ASSOCIATED PROTEIN BETA (TRAPB) FAMILY PROTEIN', 245136),
(354886, 'PTHR12861:SF5', NULL, NULL, NULL, NULL, 'OS05G0103100 PROTEIN', 245136),
(354887, 'PTHR12861:SF8', NULL, NULL, NULL, NULL, 'BNAA02G28300D PROTEIN', 245136),
(354888, 'PTHR12861:SF7', NULL, NULL, NULL, NULL, 'TRANSLOCON-ASSOCIATED PROTEIN, BETA SUBUNIT', 245136),
(354889, 'PTHR12861', NULL, NULL, NULL, NULL, 'TRANSLOCON-ASSOCIATED PROTEIN, BETA SUBUNIT PRECURSOR  TRAP-BETA   SIGNAL SEQUENCE RECEPTOR BETA SUBUNIT', 245136),
(354890, 'PTHR12963:SF0', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245137),
(354891, 'PTHR12963:SF4', NULL, NULL, NULL, NULL, 'ACTIVATING SIGNAL COINTEGRATOR 1', 245137),
(354892, 'PTHR12963', NULL, NULL, NULL, NULL, 'THYROID RECEPTOR INTERACTING PROTEIN RELATED', 245137),
(354893, 'PTHR36082', NULL, NULL, NULL, NULL, '', 245138),
(354894, 'PTHR36082:SF2', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I REACTION CENTER SUBUNIT IX', 245138),
(354895, 'PTHR34862:SF1', NULL, NULL, NULL, NULL, '', 245139),
(354896, 'PTHR34862', NULL, NULL, NULL, NULL, '', 245139),
(354897, 'PTHR43666', NULL, NULL, NULL, NULL, 'TLDD PROTEIN', 245140),
(354898, 'PTHR43666:SF1', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', 245140),
(354899, 'PTHR37457:SF4', NULL, NULL, NULL, NULL, 'TRNA SELENOCYSTEINE 1-ASSOCIATED PROTEIN 1', 245141);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(354900, 'PTHR37457:SF3', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN-LIKE PROTEIN', 245141),
(354901, 'PTHR37457:SF2', NULL, NULL, NULL, NULL, 'TRNA SELENOCYSTEINE 1-ASSOCIATED PROTEIN 1', 245141),
(354902, 'PTHR37457:SF1', NULL, NULL, NULL, NULL, 'SIMILAR TO HUMAN CHROMOSOME 6 OPEN READING FRAME 52', 245141),
(354903, 'PTHR37457', NULL, NULL, NULL, NULL, 'TRNA SELENOCYSTEINE 1-ASSOCIATED PROTEIN 1-RELATED', 245141),
(354904, 'PTHR38595', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 245142),
(354905, 'PTHR38595:SF2', NULL, NULL, NULL, NULL, 'TYPE VI SECRETION SYSTEM NEEDLE HUB PROTEIN TSSE', 245142),
(354906, 'PTHR38595:SF1', NULL, NULL, NULL, NULL, 'TYPE VI SECRETION SYSTEM COMPONENT TSSE1', 245142),
(354907, 'PTHR48030', NULL, NULL, NULL, NULL, 'SPLICING FACTOR 3B SUBUNIT 4', 245143),
(354908, 'PTHR48030:SF5', NULL, NULL, NULL, NULL, 'BNAA09G52820D PROTEIN', 245143),
(354909, 'PTHR48030:SF4', NULL, NULL, NULL, NULL, 'SPLICING FACTOR 3B SUBUNIT 4', 245143),
(354910, 'PTHR48030:SF3', NULL, NULL, NULL, NULL, 'SPLICING FACTOR 3B SUBUNIT 4', 245143),
(354911, 'PTHR48030:SF2', NULL, NULL, NULL, NULL, '', 245143),
(354912, 'PTHR30011:SF16', NULL, NULL, NULL, NULL, 'C2H2 FINGER DOMAIN TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 245144),
(354913, 'PTHR30011:SF4', NULL, NULL, NULL, NULL, 'COENZYME F420-DEPENDENT OXIDOREDUCTASE RV3520C-RELATED', 245144),
(354914, 'PTHR30011', NULL, NULL, NULL, NULL, 'ALKANESULFONATE MONOOXYGENASE-RELATED', 245144),
(354915, 'PTHR30011:SF32', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', 245144),
(354916, 'PTHR30011:SF30', NULL, NULL, NULL, NULL, 'XENOBIOTIC COMPOUND MONOOXYGENASE, DSZA FAMILY (AFU_ORTHOLOGUE AFUA_6G01920)', 245144),
(354917, 'PTHR30011:SF41', NULL, NULL, NULL, NULL, 'XENOBIOTIC COMPOUND MONOOXYGENASE, DSZA FAMILY (AFU_ORTHOLOGUE AFUA_3G15040)', 245144),
(354918, 'PTHR21224:SF1', NULL, NULL, NULL, NULL, 'INTEGRATOR COMPLEX SUBUNIT 1', 245145),
(354919, 'PTHR21224', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 245145),
(354920, 'PTHR11728:SF39', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE DEHYDROGENASE [NAD(+)]', 245146),
(354921, 'PTHR11728:SF38', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE DEHYDROGENASE [NAD(+)] 2, CYTOSOLIC-RELATED', 245146),
(354922, 'PTHR11728:SF42', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE DEHYDROGENASE [NAD(+)]', 245146),
(354923, 'PTHR11728:SF31', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE DEHYDROGENASE [NAD(+)]', 245146),
(354924, 'PTHR11728:SF43', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE DEHYDROGENASE [NAD(+)] 1', 245146),
(354925, 'PTHR11728:SF32', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE DEHYDROGENASE [NAD(+)], CYTOPLASMIC', 245146),
(354926, 'PTHR11728:SF33', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE DEHYDROGENASE [NAD(+)]', 245146),
(354927, 'PTHR11728', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE DEHYDROGENASE', 245146),
(354928, 'PTHR11728:SF44', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE DEHYDROGENASE [NAD(+)] 3, CYTOSOLIC-RELATED', 245146),
(354929, 'PTHR11728:SF1', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE DEHYDROGENASE [NAD(+)] 2, CHLOROPLASTIC', 245146),
(354930, 'PTHR11728:SF45', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE DEHYDROGENASE [NAD(+)]', 245146),
(354931, 'PTHR11728:SF40', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE DEHYDROGENASE [NAD(+)]', 245146),
(354932, 'PTHR11728:SF30', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE DEHYDROGENASE [NAD(+)] GPDHC1, CYTOSOLIC', 245146),
(354933, 'PTHR11728:SF7', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE DEHYDROGENASE 1-LIKE PROTEIN', 245146),
(354934, 'PTHR11728:SF9', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE DEHYDROGENASE [NAD(+)]', 245146),
(354935, 'PTHR11728:SF8', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE DEHYDROGENASE [NAD(+)]-RELATED', 245146),
(354936, 'PTHR35095', NULL, NULL, NULL, NULL, 'OS05G0143300 PROTEIN', 245147),
(354937, 'PTHR35095:SF3', NULL, NULL, NULL, NULL, 'F15K9.6', 245147),
(354938, 'PTHR35095:SF2', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 245147),
(354939, 'PTHR35095:SF1', NULL, NULL, NULL, NULL, 'OS05G0143300 PROTEIN', 245147);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(354940, 'PTHR40699:SF1', NULL, NULL, NULL, NULL, 'UPF0179 PROTEIN TK0790', 245148),
(354941, 'PTHR40699', NULL, NULL, NULL, NULL, 'UPF0179 PROTEIN MJ1627', 245148),
(354942, 'PTHR43294:SF8', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM-TRANSPORTING ATPASE SUBUNIT ALPHA', 245149),
(354943, 'PTHR43294:SF7', NULL, NULL, NULL, NULL, 'CATION_ATPASE_N DOMAIN-CONTAINING PROTEIN', 245149),
(354944, 'PTHR43294:SF6', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM-TRANSPORTING ATPASE SUBUNIT ALPHA-2', 245149),
(354945, 'PTHR43294:SF5', NULL, NULL, NULL, NULL, 'CATION_ATPASE_N DOMAIN-CONTAINING PROTEIN', 245149),
(354946, 'PTHR43294:SF9', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM-TRANSPORTING ATPASE SUBUNIT ALPHA-1', 245149),
(354947, 'PTHR43294', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM-TRANSPORTING ATPASE SUBUNIT ALPHA', 245149),
(354948, 'PTHR43294:SF10', NULL, NULL, NULL, NULL, 'POTASSIUM-TRANSPORTING ATPASE ALPHA CHAIN 1', 245149),
(354949, 'PTHR43294:SF13', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM-TRANSPORTING ATPASE SUBUNIT ALPHA', 245149),
(354950, 'PTHR43294:SF4', NULL, NULL, NULL, NULL, 'CATION TRANSPORTING ATPASE', 245149),
(354951, 'PTHR43294:SF3', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM-TRANSPORTING ATPASE SUBUNIT ALPHA-4', 245149),
(354952, 'PTHR43294:SF1', NULL, NULL, NULL, NULL, 'POTASSIUM-TRANSPORTING ATPASE ALPHA CHAIN 2', 245149),
(354953, 'PTHR43294:SF20', NULL, NULL, NULL, NULL, 'P-TYPE ATPASE', 245149),
(354954, 'PTHR43294:SF18', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM-TRANSPORTING ATPASE SUBUNIT ALPHA', 245149),
(354955, 'PTHR43294:SF19', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM-TRANSPORTING ATPASE SUBUNIT ALPHA', 245149),
(354956, 'PTHR43294:SF15', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM-TRANSPORTING ATPASE SUBUNIT ALPHA-3', 245149),
(354957, 'PTHR40086', NULL, NULL, NULL, NULL, 'PHOSPHOTRANSFERASE YTMP-RELATED', 245150),
(354958, 'PTHR40086:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOTRANSFERASE YTMP-RELATED', 245150),
(354959, 'PTHR31314:SF74', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 245151),
(354960, 'PTHR31314:SF79', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR PHL13', 245151),
(354961, 'PTHR31314:SF103', NULL, NULL, NULL, NULL, 'PROTEIN PHR1-LIKE 1-LIKE', 245151),
(354962, 'PTHR31314:SF147', NULL, NULL, NULL, NULL, 'PROTEIN PHR1-LIKE 1-LIKE', 245151),
(354963, 'PTHR31314:SF102', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 245151),
(354964, 'PTHR31314:SF148', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 245151),
(354965, 'PTHR31314:SF104', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR KAN1-LIKE', 245151),
(354966, 'PTHR31314:SF107', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 245151),
(354967, 'PTHR31314:SF109', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 245151),
(354968, 'PTHR31314:SF84', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN-RELATED', 245151),
(354969, 'PTHR31314:SF83', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 245151),
(354970, 'PTHR31314:SF87', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 245151),
(354971, 'PTHR31314:SF89', NULL, NULL, NULL, NULL, 'MYB_CC_LHEQLE DOMAIN-CONTAINING PROTEIN', 245151),
(354972, 'PTHR31314:SF170', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 245151),
(354973, 'PTHR31314:SF48', NULL, NULL, NULL, NULL, 'MYB-LIKE DNA-BINDING DOMAIN, SHAQKYF CLASS PROTEIN', 245151),
(354974, 'PTHR31314:SF172', NULL, NULL, NULL, NULL, 'PROTEIN PHR1-LIKE 1-LIKE ISOFORM X1', 245151),
(354975, 'PTHR31314:SF171', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 245151),
(354976, 'PTHR31314:SF174', NULL, NULL, NULL, NULL, 'OS02G0241200 PROTEIN', 245151),
(354977, 'PTHR31314:SF1', NULL, NULL, NULL, NULL, 'OS05G0491500 PROTEIN', 245151),
(354978, 'PTHR31314:SF173', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 245151),
(354979, 'PTHR31314:SF134', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 245151),
(354980, 'PTHR31314:SF133', NULL, NULL, NULL, NULL, 'BNAA09G20380D PROTEIN', 245151);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(354981, 'PTHR31314:SF7', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR PHL5', 245151),
(354982, 'PTHR31314:SF8', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR PHL6', 245151),
(354983, 'PTHR31314:SF138', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 245151),
(354984, 'PTHR31314:SF4', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATE STARVATION RESPONSE 2', 245151),
(354985, 'PTHR31314:SF5', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR PHL7', 245151),
(354986, 'PTHR31314:SF92', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 245151),
(354987, 'PTHR31314:SF97', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 245151),
(354988, 'PTHR31314:SF53', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 245151),
(354989, 'PTHR31314:SF52', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 245151),
(354990, 'PTHR31314:SF161', NULL, NULL, NULL, NULL, 'MYB-LIKE DNA-BINDING DOMAIN, SHAQKYF CLASS PROTEIN', 245151),
(354991, 'PTHR31314:SF160', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR-RELATED', 245151),
(354992, 'PTHR31314:SF19', NULL, NULL, NULL, NULL, 'OS06G0609500 PROTEIN', 245151),
(354993, 'PTHR31314:SF163', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 245151),
(354994, 'PTHR31314:SF162', NULL, NULL, NULL, NULL, 'OS08G0346500 PROTEIN', 245151),
(354995, 'PTHR31314:SF165', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 245151),
(354996, 'PTHR31314:SF164', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 245151),
(354997, 'PTHR31314:SF120', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 245151),
(354998, 'PTHR31314:SF167', NULL, NULL, NULL, NULL, 'OS06G0543200 PROTEIN', 245151),
(354999, 'PTHR31314:SF166', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ARR13 ISOFORM X1-RELATED', 245151),
(355000, 'PTHR31314:SF122', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 245151),
(355001, 'PTHR31314:SF169', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 245151),
(355002, 'PTHR31314:SF124', NULL, NULL, NULL, NULL, 'PROTEIN PHR1-LIKE 1', 245151),
(355003, 'PTHR31314:SF168', NULL, NULL, NULL, NULL, 'MYB-LIKE HTH TRANSCRIPTIONAL REGULATOR FAMILY PROTEIN', 245151),
(355004, 'PTHR31314:SF128', NULL, NULL, NULL, NULL, 'OS11G0106100 PROTEIN', 245151),
(355005, 'PTHR31314:SF62', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 245151),
(355006, 'PTHR31314:SF64', NULL, NULL, NULL, NULL, 'OS02G0672300 PROTEIN', 245151),
(355007, 'PTHR31314:SF21', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR PHL4-RELATED', 245151),
(355008, 'PTHR31314:SF152', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 245151),
(355009, 'PTHR31314:SF151', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN-RELATED', 245151),
(355010, 'PTHR31314:SF154', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 245151),
(355011, 'PTHR31314:SF153', NULL, NULL, NULL, NULL, 'MYB DOMAIN, PLANT-RELATED', 245151),
(355012, 'PTHR31314:SF156', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR PHL6', 245151),
(355013, 'PTHR31314:SF111', NULL, NULL, NULL, NULL, 'MYB-LIKE TRANSCRIPTION FACTOR FAMILY PROTEIN', 245151),
(355014, 'PTHR31314:SF155', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 245151),
(355015, 'PTHR31314:SF158', NULL, NULL, NULL, NULL, 'BNAA01G08300D PROTEIN', 245151),
(355016, 'PTHR31314:SF113', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR MPH1', 245151),
(355017, 'PTHR31314:SF157', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR PHL5-LIKE', 245151),
(355018, 'PTHR31314', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR PHL7-LIKE', 245151),
(355019, 'PTHR31314:SF159', NULL, NULL, NULL, NULL, 'MYB-LIKE TRANSCRIPTION FACTOR FAMILY PROTEIN', 245151),
(355020, 'PTHR31314:SF119', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN', 245151),
(355021, 'PTHR31314:SF71', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 245151);
INSERT INTO "PUBLIC"."MODEL" VALUES
(355022, 'PTHR31314:SF73', NULL, NULL, NULL, NULL, 'MYB-LIKE TRANSCRIPTION FACTOR FAMILY PROTEIN', 245151),
(355023, 'PTHR23299:SF4', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN-1H', 245152),
(355024, 'PTHR23299', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN', 245152),
(355025, 'PTHR23299:SF18', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN-3', 245152),
(355026, 'PTHR23299:SF54', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN', 245152),
(355027, 'PTHR23299:SF42', NULL, NULL, NULL, NULL, '', 245152),
(355028, 'PTHR23299:SF53', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN-1G', 245152),
(355029, 'PTHR23299:SF12', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN-4', 245152),
(355030, 'PTHR23299:SF55', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN-1F', 245152),
(355031, 'PTHR23299:SF22', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN-2', 245152),
(355032, 'PTHR23299:SF44', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN', 245152),
(355033, 'PTHR23299:SF58', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN 1H-LIKE PROTEIN 1', 245152),
(355034, 'PTHR23299:SF47', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN', 245152),
(355035, 'PTHR23299:SF57', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN 1E', 245152),
(355036, 'PTHR23299:SF24', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN-1X', 245152),
(355037, 'PTHR23299:SF49', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN-1A', 245152),
(355038, 'PTHR23299:SF38', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN-2B', 245152),
(355039, 'PTHR23299:SF59', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN-1B', 245152),
(355040, 'PTHR23299:SF48', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN-1E-RELATED', 245152),
(355041, 'PTHR23299:SF52', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN', 245152),
(355042, 'PTHR23299:SF51', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN-1B', 245152),
(355043, 'PTHR33678:SF1', NULL, NULL, NULL, NULL, 'BLL1576 PROTEIN', 245153),
(355044, 'PTHR33678', NULL, NULL, NULL, NULL, 'BLL1576 PROTEIN', 245153),
(355045, 'PTHR23090:SF16', NULL, NULL, NULL, NULL, 'GLUTAMINE-DEPENDENT NAD(+) SYNTHETASE', 245154),
(355046, 'PTHR23090:SF15', NULL, NULL, NULL, NULL, 'GLUTAMINE-DEPENDENT NAD(+) SYNTHETASE', 245154),
(355047, 'PTHR23090', NULL, NULL, NULL, NULL, 'NH 3 /GLUTAMINE-DEPENDENT NAD +  SYNTHETASE', 245154),
(355048, 'PTHR23090:SF9', NULL, NULL, NULL, NULL, 'GLUTAMINE-DEPENDENT NAD(+) SYNTHETASE', 245154),
(355049, 'PTHR23090:SF7', NULL, NULL, NULL, NULL, 'NH(3)-DEPENDENT NAD(+) SYNTHETASE', 245154),
(355050, 'PTHR10027:SF39', NULL, NULL, NULL, NULL, '', 245155),
(355051, 'PTHR10027:SF28', NULL, NULL, NULL, NULL, 'CALCIUM-ACTIVATED POTASSIUM CHANNEL SUBUNIT ALPHA-1', 245155),
(355052, 'PTHR10027:SF38', NULL, NULL, NULL, NULL, '', 245155),
(355053, 'PTHR10027:SF37', NULL, NULL, NULL, NULL, 'CHANNEL (CAKC), PUTATIVE-RELATED', 245155),
(355054, 'PTHR10027:SF14', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL SUBFAMILY T MEMBER 1', 245155),
(355055, 'PTHR10027:SF40', NULL, NULL, NULL, NULL, 'CALCIUM-ACTIVATED POTASSIUM CHANNEL SUBUNIT ALPHA-1', 245155),
(355056, 'PTHR10027:SF35', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL, SODIUM ACTIVATED SUBFAMILY T, MEMBER 2 LIKE', 245155),
(355057, 'PTHR10027:SF23', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL SUBFAMILY U MEMBER 1', 245155),
(355058, 'PTHR10027:SF33', NULL, NULL, NULL, NULL, 'BK CHANNEL', 245155),
(355059, 'PTHR10027:SF22', NULL, NULL, NULL, NULL, '', 245155),
(355060, 'PTHR10027:SF10', NULL, NULL, NULL, NULL, 'SLOWPOKE 2, ISOFORM D', 245155),
(355061, 'PTHR10027:SF9', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL SUBFAMILY T MEMBER 2', 245155),
(355062, 'PTHR10027', NULL, NULL, NULL, NULL, 'CALCIUM-ACTIVATED POTASSIUM CHANNEL ALPHA CHAIN', 245155),
(355063, 'PTHR47807', NULL, NULL, NULL, NULL, 'PROTEIN TBF1', 245156),
(355064, 'PTHR47807:SF1', NULL, NULL, NULL, NULL, 'PROTEIN TBF1', 245156),
(355065, 'PTHR12820:SF0', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 53 HOMOLOG', 245157),
(355066, 'PTHR12820:SF1', NULL, NULL, NULL, NULL, 'MEMBRANE TRAFFICKING VPS53 FAMILY PROTEIN-RELATED', 245157),
(355067, 'PTHR12820', NULL, NULL, NULL, NULL, 'VACUOLAR SORTING PROTEIN 53', 245157),
(355068, 'PTHR36444:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR PROTEIN YOBU-RELATED', 245158);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(355069, 'PTHR36444:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR, PUTATIVE-RELATED', 245158),
(355070, 'PTHR36444', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR PROTEIN YOBU-RELATED', 245158),
(355071, 'PTHR28590', NULL, NULL, NULL, NULL, 'SPEXIN', 245159),
(355072, 'PTHR28590:SF1', NULL, NULL, NULL, NULL, 'SPEXIN', 245159),
(355073, 'PTHR46245:SF17', NULL, NULL, NULL, NULL, 'CW-TYPE DOMAIN-CONTAINING PROTEIN', 245160),
(355074, 'PTHR46245:SF16', NULL, NULL, NULL, NULL, 'BNAC03G16940D PROTEIN', 245160),
(355075, 'PTHR46245:SF6', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS07G0563300-LIKE', 245160),
(355076, 'PTHR46245:SF15', NULL, NULL, NULL, NULL, 'BNAA04G17550D PROTEIN', 245160),
(355077, 'PTHR46245', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS07G0563300', 245160),
(355078, 'PTHR46245:SF14', NULL, NULL, NULL, NULL, 'ZINC FINGER, CW-TYPE, DNA-BINDING PSEUDOBARREL DOMAIN PROTEIN-RELATED', 245160),
(355079, 'PTHR46245:SF2', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING TRANSCRIPTION REPRESSOR VAL2', 245160),
(355080, 'PTHR46245:SF3', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING TRANSCRIPTION REPRESSOR VAL1', 245160),
(355081, 'PTHR46245:SF10', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING TRANSCRIPTION FACTOR VAL3', 245160),
(355082, 'PTHR31263:SF44', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE', 245161),
(355083, 'PTHR31263:SF56', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE', 245161),
(355084, 'PTHR31263:SF45', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE', 245161),
(355085, 'PTHR31263:SF64', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE', 245161),
(355086, 'PTHR31263:SF42', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE', 245161),
(355087, 'PTHR31263:SF65', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE', 245161),
(355088, 'PTHR31263:SF59', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE', 245161),
(355089, 'PTHR31263:SF48', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE', 245161),
(355090, 'PTHR31263:SF57', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE', 245161),
(355091, 'PTHR31263:SF46', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE', 245161),
(355092, 'PTHR31263:SF58', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE', 245161),
(355093, 'PTHR31263:SF63', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE', 245161),
(355094, 'PTHR31263:SF52', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE', 245161),
(355095, 'PTHR31263:SF60', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE', 245161),
(355096, 'PTHR31263:SF50', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE', 245161),
(355097, 'PTHR31263', NULL, NULL, NULL, NULL, 'CELLULASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_5G14560)', 245161),
(355098, 'PTHR31263:SF0', NULL, NULL, NULL, NULL, 'CELLULASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_5G14560)', 245161),
(355099, 'PTHR23187:SF1', NULL, NULL, NULL, NULL, 'ELONGIN BC AND POLYCOMB REPRESSIVE COMPLEX 2-ASSOCIATED PROTEIN', 245162),
(355100, 'PTHR23187:SF3', NULL, NULL, NULL, NULL, 'SUMO-INTERACTING MOTIF-CONTAINING PROTEIN 1', 245162),
(355101, 'PTHR23187:SF2', NULL, NULL, NULL, NULL, 'SKI/DACH DOMAIN-CONTAINING PROTEIN 1', 245162),
(355102, 'PTHR23187:SF4', NULL, NULL, NULL, NULL, 'SKI_SNO DOMAIN-CONTAINING PROTEIN', 245162),
(355103, 'PTHR23187', NULL, NULL, NULL, NULL, 'FLJ44216 PROTEIN-RELATED', 245162),
(355104, 'PTHR47906', NULL, NULL, NULL, NULL, 'OSJNBB0050O03.9 PROTEIN-RELATED', 245163),
(355105, 'PTHR47906:SF7', NULL, NULL, NULL, NULL, 'OS09G0248900 PROTEIN', 245163),
(355106, 'PTHR47906:SF8', NULL, NULL, NULL, NULL, '', 245163),
(355107, 'PTHR47906:SF3', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245163),
(355108, 'PTHR47906:SF4', NULL, NULL, NULL, NULL, 'OS05G0182900 PROTEIN', 245163),
(355109, 'PTHR47906:SF5', NULL, NULL, NULL, NULL, 'OS05G0118600 PROTEIN', 245163),
(355110, 'PTHR35332:SF2', NULL, NULL, NULL, NULL, 'REGULATION OF ENOLASE PROTEIN 1', 245164),
(355111, 'PTHR35332', NULL, NULL, NULL, NULL, 'REGULATION OF ENOLASE PROTEIN 1', 245164);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(355112, 'PTHR35332:SF3', NULL, NULL, NULL, NULL, '', 245164),
(355113, 'PTHR39669:SF2', NULL, NULL, NULL, NULL, '', 245165),
(355114, 'PTHR39669', NULL, NULL, NULL, NULL, '', 245165),
(355115, 'PTHR16451', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL DYNAMICS PROTEINS 49/51 FAMILY MEMBER', 245166),
(355116, 'PTHR16451:SF7', NULL, NULL, NULL, NULL, 'MAB-21 DOMAIN-CONTAINING PROTEIN', 245166),
(355117, 'PTHR16451:SF14', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL DYNAMICS PROTEIN MID51', 245166),
(355118, 'PTHR16451:SF13', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ELONGATION FACTOR 2', 245166),
(355119, 'PTHR16451:SF12', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL DYNAMICS PROTEIN MID51', 245166),
(355120, 'PTHR16451:SF11', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL DYNAMICS PROTEIN MID49', 245166),
(355121, 'PTHR34676:SF8', NULL, NULL, NULL, NULL, 'MYOSIN-11-LIKE', 245167),
(355122, 'PTHR34676:SF21', NULL, NULL, NULL, NULL, 'GAG-POL POLYPROTEIN-LIKE PROTEIN', 245167),
(355123, 'PTHR34676:SF10', NULL, NULL, NULL, NULL, 'GAG-POL-RELATED RETROTRANSPOSON FAMILY PROTEIN', 245167),
(355124, 'PTHR34676:SF22', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 245167),
(355125, 'PTHR34676:SF23', NULL, NULL, NULL, NULL, 'GAG-POL-RELATED RETROTRANSPOSON FAMILY PROTEIN', 245167),
(355126, 'PTHR34676:SF13', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 245167),
(355127, 'PTHR34676:SF24', NULL, NULL, NULL, NULL, 'ZINC FINGER, CCHC-TYPE, RIBONUCLEASE H-LIKE DOMAIN, GAG-PRE-INTEGRASE DOMAIN PROTEIN-RELATED', 245167),
(355128, 'PTHR34676:SF25', NULL, NULL, NULL, NULL, '', 245167),
(355129, 'PTHR34676:SF26', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 245167),
(355130, 'PTHR34676:SF15', NULL, NULL, NULL, NULL, 'GAG_PRE-INTEGRS DOMAIN-CONTAINING PROTEIN', 245167),
(355131, 'PTHR34676:SF27', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 245167),
(355132, 'PTHR34676:SF17', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 245167),
(355133, 'PTHR34676:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER, CCHC-TYPE, TUBBY C-TERMINAL-LIKE DOMAIN PROTEIN-RELATED', 245167),
(355134, 'PTHR34676', NULL, NULL, NULL, NULL, 'DUF4219 DOMAIN-CONTAINING PROTEIN-RELATED', 245167),
(355135, 'PTHR11653:SF21', NULL, NULL, NULL, NULL, 'PARVALBUMIN-7', 245168),
(355136, 'PTHR11653:SF10', NULL, NULL, NULL, NULL, 'CALMODULIN', 245168),
(355137, 'PTHR11653:SF2', NULL, NULL, NULL, NULL, 'PARVALBUMIN ALPHA', 245168),
(355138, 'PTHR11653:SF16', NULL, NULL, NULL, NULL, 'ONCOMODULIN-1', 245168),
(355139, 'PTHR11653:SF19', NULL, NULL, NULL, NULL, 'PARVALBUMIN 9', 245168),
(355140, 'PTHR11653:SF18', NULL, NULL, NULL, NULL, 'PARVALBUMIN 4-RELATED', 245168),
(355141, 'PTHR11653', NULL, NULL, NULL, NULL, 'PARVALBUMIN ALPHA', 245168),
(355142, 'PTHR11653:SF12', NULL, NULL, NULL, NULL, 'PARVALBUMIN 1-RELATED', 245168),
(355143, 'PTHR11653:SF4', NULL, NULL, NULL, NULL, 'ONCOMODULIN-2-RELATED', 245168),
(355144, 'PTHR11653:SF3', NULL, NULL, NULL, NULL, 'PARVALBUMIN, THYMIC', 245168),
(355145, 'PTHR31192', NULL, NULL, NULL, NULL, 'SPERM-SPECIFIC FAMILY, CLASS Q', 245169),
(355146, 'PTHR31192:SF4', NULL, NULL, NULL, NULL, 'SPERM-SPECIFIC FAMILY, CLASS Q', 245169),
(355147, 'PTHR31192:SF7', NULL, NULL, NULL, NULL, 'SPERM-SPECIFIC FAMILY, CLASS Q', 245169),
(355148, 'PTHR37066', NULL, NULL, NULL, NULL, 'HELICASE-ASSOCIATED', 245170),
(355149, 'PTHR37066:SF1', NULL, NULL, NULL, NULL, 'LNS2 DOMAIN-CONTAINING PROTEIN', 245170),
(355150, 'PTHR31851:SF61', NULL, NULL, NULL, NULL, 'NODULIN', 245171),
(355151, 'PTHR31851:SF4', NULL, NULL, NULL, NULL, 'CCC1 FAMILY PROTEIN-RELATED', 245171),
(355152, 'PTHR31851:SF41', NULL, NULL, NULL, NULL, 'VACUOLAR IRON TRANSPORTER HOMOLOG 2.1-LIKE', 245171),
(355153, 'PTHR31851:SF63', NULL, NULL, NULL, NULL, 'CCC1 FAMILY-RELATED', 245171),
(355154, 'PTHR31851:SF44', NULL, NULL, NULL, NULL, 'CCC1 FAMILY PROTEIN-RELATED', 245171),
(355155, 'PTHR31851:SF65', NULL, NULL, NULL, NULL, 'VACUOLAR IRON TRANSPORTER HOMOLOG 4-LIKE', 245171),
(355156, 'PTHR31851:SF43', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN OF ER BODY 1', 245171);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(355157, 'PTHR31851:SF68', NULL, NULL, NULL, NULL, 'VACUOLAR IRON TRANSPORTER (VIT) FAMILY PROTEIN-RELATED', 245171),
(355158, 'PTHR31851:SF67', NULL, NULL, NULL, NULL, 'BNAA06G14970D PROTEIN', 245171),
(355159, 'PTHR31851:SF47', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN OF ER BODY-LIKE PROTEIN', 245171),
(355160, 'PTHR31851:SF49', NULL, NULL, NULL, NULL, 'FE2+/MN2+ TRANSPORTER, PUTATIVE (EUROFUNG)-RELATED', 245171),
(355161, 'PTHR31851:SF9', NULL, NULL, NULL, NULL, 'VACUOLAR IRON TRANSPORTER 1-LIKE', 245171),
(355162, 'PTHR31851:SF70', NULL, NULL, NULL, NULL, 'BNAA08G14000D PROTEIN', 245171),
(355163, 'PTHR31851:SF73', NULL, NULL, NULL, NULL, 'SANT/MYB DOMAIN-CONTAINING PROTEIN-RELATED', 245171),
(355164, 'PTHR31851:SF51', NULL, NULL, NULL, NULL, 'VACUOLAR IRON TRANSPORTER HOMOLOG 4-LIKE', 245171),
(355165, 'PTHR31851:SF53', NULL, NULL, NULL, NULL, 'VACUOLAR IRON TRANSPORTER HOMOLOG 4', 245171),
(355166, 'PTHR31851:SF75', NULL, NULL, NULL, NULL, 'CCC1 FAMILY-RELATED', 245171),
(355167, 'PTHR31851:SF52', NULL, NULL, NULL, NULL, 'PROTEIN CCC1', 245171),
(355168, 'PTHR31851:SF74', NULL, NULL, NULL, NULL, 'VACUOLAR IRON TRANSPORTER HOMOLOG 2', 245171),
(355169, 'PTHR31851:SF55', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN OF ER BODY 2', 245171),
(355170, 'PTHR31851:SF77', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN OF ER BODY-LIKE PROTEIN', 245171),
(355171, 'PTHR31851:SF54', NULL, NULL, NULL, NULL, 'VACUOLAR IRON TRANSPORTER HOMOLOG 1', 245171),
(355172, 'PTHR31851:SF10', NULL, NULL, NULL, NULL, '', 245171),
(355173, 'PTHR31851:SF79', NULL, NULL, NULL, NULL, 'NODULIN-21', 245171),
(355174, 'PTHR31851:SF57', NULL, NULL, NULL, NULL, 'BNAA03G48860D PROTEIN', 245171),
(355175, 'PTHR31851:SF78', NULL, NULL, NULL, NULL, 'VACUOLAR IRON TRANSPORTER-LIKE PROTEIN', 245171),
(355176, 'PTHR31851:SF56', NULL, NULL, NULL, NULL, 'BNAA07G03300D PROTEIN', 245171),
(355177, 'PTHR31851:SF59', NULL, NULL, NULL, NULL, 'NODULIN', 245171),
(355178, 'PTHR31851:SF58', NULL, NULL, NULL, NULL, 'VACUOLAR IRON TRANSPORTER HOMOLOG 2', 245171),
(355179, 'PTHR31851:SF39', NULL, NULL, NULL, NULL, 'VACUOLAR IRON TRANSPORTER HOMOLOG 1-LIKE', 245171),
(355180, 'PTHR31851', NULL, NULL, NULL, NULL, 'FE(2+)/MN(2+) TRANSPORTER PCL1', 245171),
(355181, 'PTHR31851:SF80', NULL, NULL, NULL, NULL, 'VACUOLAR IRON TRANSPORTER 1', 245171),
(355182, 'PTHR31851:SF60', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN FAMILY-RELATED', 245171),
(355183, 'PTHR38442', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', 245172),
(355184, 'PTHR38442:SF1', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', 245172),
(355185, 'PTHR34822:SF1', NULL, NULL, NULL, NULL, 'GRPB DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_1G01530)', 245173),
(355186, 'PTHR34822', NULL, NULL, NULL, NULL, 'GRPB DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_1G01530)', 245173),
(355187, 'PTHR24367:SF318', NULL, NULL, NULL, NULL, 'LRRCT DOMAIN-CONTAINING PROTEIN', 245174),
(355188, 'PTHR24367', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN', 245174),
(355189, 'PTHR24367:SF21', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT LGI FAMILY MEMBER 2', 245174),
(355190, 'PTHR24367:SF10', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT LGI FAMILY MEMBER 3', 245174),
(355191, 'PTHR24367:SF268', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT LGI FAMILY MEMBER 4', 245174),
(355192, 'PTHR24367:SF17', NULL, NULL, NULL, NULL, 'LEUCINE-RICH GLIOMA-INACTIVATED PROTEIN 1', 245174),
(355193, 'PTHR14083:SF2', NULL, NULL, NULL, NULL, 'PROTEIN YIF1A', 245175),
(355194, 'PTHR14083:SF1', NULL, NULL, NULL, NULL, 'PROTEIN YIF1B', 245175),
(355195, 'PTHR14083:SF0', NULL, NULL, NULL, NULL, 'YIP1D-INTERACTING FACTOR 1, ISOFORM C', 245175),
(355196, 'PTHR14083', NULL, NULL, NULL, NULL, 'YIP1 INTERACTING FACTOR HOMOLOG  YIF1 PROTEIN', 245175),
(355197, 'PTHR14083:SF14', NULL, NULL, NULL, NULL, 'PROTEIN YIF1B-LIKE', 245175),
(355198, 'PTHR14083:SF9', NULL, NULL, NULL, NULL, 'OS06G0620600 PROTEIN', 245175),
(355199, 'PTHR14083:SF12', NULL, NULL, NULL, NULL, '', 245175),
(355200, 'PTHR14083:SF13', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE HRF1 FAMILY PROTEIN', 245175); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(355201, 'PTHR14083:SF11', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE HRF1 FAMILY PROTEIN', 245175),
(355202, 'PTHR14083:SF3', NULL, NULL, NULL, NULL, 'PROTEIN YIF1B-LIKE', 245175),
(355203, 'PTHR12121:SF37', NULL, NULL, NULL, NULL, '2'',5''-PHOSPHODIESTERASE 12', 245176),
(355204, 'PTHR12121:SF50', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 245176),
(355205, 'PTHR12121:SF93', NULL, NULL, NULL, NULL, 'ENDONUCLEASE/EXONUCLEASE/PHOSPHATASE, MYND-LIKE ZINC FINGER, MRNA-BINDING PROTEIN-RELATED', 245176),
(355206, 'PTHR12121:SF92', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 245176),
(355207, 'PTHR12121:SF90', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 245176),
(355208, 'PTHR12121:SF36', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 245176),
(355209, 'PTHR12121:SF79', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 245176),
(355210, 'PTHR12121:SF35', NULL, NULL, NULL, NULL, 'CCR4-NOT TRANSCRIPTION COMPLEX SUBUNIT 6-LIKE', 245176),
(355211, 'PTHR12121:SF34', NULL, NULL, NULL, NULL, 'POLY(A)-SPECIFIC RIBONUCLEASE', 245176),
(355212, 'PTHR12121:SF78', NULL, NULL, NULL, NULL, 'CARBON CATABOLITE REPRESSOR PROTEIN 4 HOMOLOG 2', 245176),
(355213, 'PTHR12121:SF33', NULL, NULL, NULL, NULL, 'CCR4-NOT TRANSCRIPTION COMPLEX SUBUNIT 6', 245176),
(355214, 'PTHR12121:SF99', NULL, NULL, NULL, NULL, 'ENDONUCLEASE/EXONUCLEASE/PHOSPHATASE, EF-HAND DOMAIN PAIR-RELATED', 245176),
(355215, 'PTHR12121:SF11', NULL, NULL, NULL, NULL, 'RNA EXONUCLEASE NGL1', 245176),
(355216, 'PTHR12121', NULL, NULL, NULL, NULL, 'CARBON CATABOLITE REPRESSOR PROTEIN 4', 245176),
(355217, 'PTHR12121:SF98', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 245176),
(355218, 'PTHR12121:SF31', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 245176),
(355219, 'PTHR12121:SF97', NULL, NULL, NULL, NULL, 'ENDONUCLEASE/EXONUCLEASE/PHOSPHATASE FAMILY PROTEIN, EXPRESSED', 245176),
(355220, 'PTHR12121:SF96', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 245176),
(355221, 'PTHR12121:SF74', NULL, NULL, NULL, NULL, 'PROTEIN ANGEL', 245176),
(355222, 'PTHR12121:SF95', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 245176),
(355223, 'PTHR12121:SF28', NULL, NULL, NULL, NULL, 'PROTEIN ANGEL HOMOLOG 1', 245176),
(355224, 'PTHR12121:SF27', NULL, NULL, NULL, NULL, 'PROTEIN ANGEL HOMOLOG 2', 245176),
(355225, 'PTHR12121:SF83', NULL, NULL, NULL, NULL, 'CARBON CATABOLITE REPRESSOR PROTEIN 4 HOMOLOG 1-LIKE', 245176),
(355226, 'PTHR12121:SF82', NULL, NULL, NULL, NULL, 'CARBON CATABOLITE REPRESSOR PROTEIN 4 HOMOLOG 3', 245176),
(355227, 'PTHR12121:SF68', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 245176),
(355228, 'PTHR12121:SF45', NULL, NULL, NULL, NULL, 'NOCTURNIN', 245176),
(355229, 'PTHR12121:SF87', NULL, NULL, NULL, NULL, 'ENDONUCLEASE/EXONUCLEASE/PHOSPHATASE FAMILY PROTEIN', 245176),
(355230, 'PTHR12121:SF86', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 245176),
(355231, 'PTHR12121:SF85', NULL, NULL, NULL, NULL, 'CARBON CATABOLITE REPRESSOR PROTEIN 4 HOMOLOG 6', 245176),
(355232, 'PTHR37792', NULL, NULL, NULL, NULL, 'RIBONUCLEASE MRP PROTEIN SUBUNIT RMP1', 245177),
(355233, 'PTHR37792:SF1', NULL, NULL, NULL, NULL, 'RIBONUCLEASE MRP PROTEIN SUBUNIT RMP1', 245177),
(355234, 'PTHR34407:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245178),
(355235, 'PTHR34407', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245178),
(355236, 'PTHR30163', NULL, NULL, NULL, NULL, 'MEMBRANE-BOUND LYTIC MUREIN TRANSGLYCOSYLASE B', 245179),
(355237, 'PTHR30163:SF8', NULL, NULL, NULL, NULL, 'MEMBRANE-BOUND LYTIC MUREIN TRANSGLYCOSYLASE B', 245179),
(355238, 'PTHR46038:SF9', NULL, NULL, NULL, NULL, 'OS01G0920800 PROTEIN', 245180),
(355239, 'PTHR46038:SF19', NULL, NULL, NULL, NULL, 'NUCLEOTID_TRANS DOMAIN-CONTAINING PROTEIN', 245180),
(355240, 'PTHR46038:SF5', NULL, NULL, NULL, NULL, 'NUCLEOTID_TRANS DOMAIN-CONTAINING PROTEIN', 245180);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(355241, 'PTHR46038:SF38', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE-RELATED', 245180),
(355242, 'PTHR46038:SF16', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 245180),
(355243, 'PTHR46038:SF37', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 245180),
(355244, 'PTHR46038:SF59', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 245180),
(355245, 'PTHR46038:SF7', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-DIPHOSPHO-SUGAR TRANSFERASE FAMILY PROTEIN', 245180),
(355246, 'PTHR46038:SF56', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-DIPHOSPHO-SUGAR TRANSFERASE FAMILY PROTEIN', 245180),
(355247, 'PTHR46038:SF1', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 245180),
(355248, 'PTHR46038:SF12', NULL, NULL, NULL, NULL, 'OS03G0731800 PROTEIN', 245180),
(355249, 'PTHR46038:SF55', NULL, NULL, NULL, NULL, 'BNAA02G23630D PROTEIN', 245180),
(355250, 'PTHR46038:SF33', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 245180),
(355251, 'PTHR46038:SF58', NULL, NULL, NULL, NULL, 'NUCLEOTID_TRANS DOMAIN-CONTAINING PROTEIN', 245180),
(355252, 'PTHR46038:SF14', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-DIPHOSPHO-SUGAR TRANSFERASE FAMILY PROTEIN', 245180),
(355253, 'PTHR46038:SF36', NULL, NULL, NULL, NULL, 'NUCLEOTID_TRANS DOMAIN-CONTAINING PROTEIN', 245180),
(355254, 'PTHR46038:SF2', NULL, NULL, NULL, NULL, 'OS07G0294800 PROTEIN', 245180),
(355255, 'PTHR46038:SF35', NULL, NULL, NULL, NULL, 'NUCLEOTID_TRANS DOMAIN-CONTAINING PROTEIN', 245180),
(355256, 'PTHR46038:SF13', NULL, NULL, NULL, NULL, 'NUCLEOTID_TRANS DOMAIN-CONTAINING PROTEIN', 245180),
(355257, 'PTHR46038:SF30', NULL, NULL, NULL, NULL, 'OS01G0921100 PROTEIN', 245180),
(355258, 'PTHR46038:SF52', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 245180),
(355259, 'PTHR46038:SF10', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-DIPHOSPHO-SUGAR TRANSFERASE FAMILY PROTEIN', 245180),
(355260, 'PTHR46038:SF31', NULL, NULL, NULL, NULL, 'NUCLEOTID_TRANS DOMAIN-CONTAINING PROTEIN', 245180),
(355261, 'PTHR46038:SF50', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 245180),
(355262, 'PTHR46038', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', 245180),
(355263, 'PTHR46038:SF48', NULL, NULL, NULL, NULL, 'NUCLEOTID_TRANS DOMAIN-CONTAINING PROTEIN', 245180),
(355264, 'PTHR46038:SF29', NULL, NULL, NULL, NULL, 'NUCLEOTID_TRANS DOMAIN-CONTAINING PROTEIN', 245180),
(355265, 'PTHR46038:SF28', NULL, NULL, NULL, NULL, 'NUCLEOTID_TRANS DOMAIN-CONTAINING PROTEIN', 245180),
(355266, 'PTHR46038:SF23', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN', 245180),
(355267, 'PTHR46038:SF45', NULL, NULL, NULL, NULL, 'NUCLEOTID_TRANS DOMAIN-CONTAINING PROTEIN', 245180),
(355268, 'PTHR46038:SF22', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-DIPHOSPHO-SUGAR TRANSFERASE FAMILY PROTEIN', 245180),
(355269, 'PTHR46038:SF47', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-DIPHOSPHO-SUGAR TRANSFERASE-RELATED', 245180),
(355270, 'PTHR46038:SF46', NULL, NULL, NULL, NULL, 'NUCLEOTID_TRANS DOMAIN-CONTAINING PROTEIN', 245180),
(355271, 'PTHR46038:SF24', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-DIPHOSPHO-SUGAR TRANSFERASE FAMILY PROTEIN', 245180),
(355272, 'PTHR46038:SF63', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 245180),
(355273, 'PTHR46038:SF62', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-DIPHOSPHO-SUGAR TRANSFERASE-RELATED', 245180),
(355274, 'PTHR46038:SF43', NULL, NULL, NULL, NULL, 'NUCLEOTID_TRANS DOMAIN-CONTAINING PROTEIN', 245180),
(355275, 'PTHR46038:SF65', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-DIPHOSPHO-SUGAR TRANSFERASE FAMILY PROTEIN', 245180),
(355276, 'PTHR46038:SF64', NULL, NULL, NULL, NULL, 'NUCLEOTID_TRANS DOMAIN-CONTAINING PROTEIN', 245180),
(355277, 'PTHR46038:SF61', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', 245180),
(355278, 'PTHR46038:SF60', NULL, NULL, NULL, NULL, 'NUCLEOTID_TRANS DOMAIN-CONTAINING PROTEIN', 245180),
(355279, 'PTHR33295:SF20', NULL, NULL, NULL, NULL, 'ATPASE', 245181),
(355280, 'PTHR33295', NULL, NULL, NULL, NULL, 'ATPASE', 245181),
(355281, 'PTHR33295:SF19', NULL, NULL, NULL, NULL, 'ARCHAEAL ATPASE', 245181),
(355282, 'PTHR33295:SF18', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 245181);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(355283, 'PTHR33295:SF8', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 245181),
(355284, 'PTHR33295:SF7', NULL, NULL, NULL, NULL, 'ATPASE', 245181),
(355285, 'PTHR31528', NULL, NULL, NULL, NULL, '4-AMINO-5-HYDROXYMETHYL-2-METHYLPYRIMIDINE PHOSPHATE SYNTHASE THI11-RELATED', 245182),
(355286, 'PTHR31528:SF3', NULL, NULL, NULL, NULL, 'THIAMINE BIOSYNTHESIS PROTEIN HI_0357-RELATED', 245182),
(355287, 'PTHR31528:SF1', NULL, NULL, NULL, NULL, '4-AMINO-5-HYDROXYMETHYL-2-METHYLPYRIMIDINE PHOSPHATE SYNTHASE THI11-RELATED', 245182),
(355288, 'PTHR31528:SF15', NULL, NULL, NULL, NULL, 'RIBOFLAVIN-BINDING PROTEIN RIBY', 245182),
(355289, 'PTHR47742:SF1', NULL, NULL, NULL, NULL, 'GAMETOGENETIN', 245183),
(355290, 'PTHR47742', NULL, NULL, NULL, NULL, 'GAMETOGENETIN', 245183),
(355291, 'PTHR30154:SF0', NULL, NULL, NULL, NULL, 'LEUCINE-RESPONSIVE REGULATORY PROTEIN', 245184),
(355292, 'PTHR30154:SF50', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REGULATOR, LRP/ASNC FAMILY', 245184),
(355293, 'PTHR30154:SF54', NULL, NULL, NULL, NULL, 'POSSIBLE TRANSCRIPTIONAL REGULATORY PROTEIN (PROBABLY LRP/ASNC-FAMILY)', 245184),
(355294, 'PTHR30154:SF53', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR LRPB', 245184),
(355295, 'PTHR30154:SF20', NULL, NULL, NULL, NULL, 'LEUCINE-RESPONSIVE REGULATORY PROTEIN', 245184),
(355296, 'PTHR30154:SF52', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR LRPC', 245184),
(355297, 'PTHR30154:SF51', NULL, NULL, NULL, NULL, 'ASNC-FAMILY TRANSCRIPTIONAL REGULATORY PROTEIN', 245184),
(355298, 'PTHR30154:SF36', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, ASNC FAMILY-RELATED', 245184),
(355299, 'PTHR30154:SF46', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 245184),
(355300, 'PTHR30154:SF34', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR AZLB', 245184),
(355301, 'PTHR30154:SF45', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN (PROBABLY ASNC-FAMILY)-RELATED', 245184),
(355302, 'PTHR30154', NULL, NULL, NULL, NULL, 'LEUCINE-RESPONSIVE REGULATORY PROTEIN', 245184),
(355303, 'PTHR30154:SF17', NULL, NULL, NULL, NULL, 'DNA-BINDING TRANSCRIPTIONAL ACTIVATOR DECR', 245184),
(355304, 'PTHR46287:SF1', NULL, NULL, NULL, NULL, 'BTB/POZ AND TAZ DOMAIN-CONTAINING PROTEIN 3', 245185),
(355305, 'PTHR46287:SF20', NULL, NULL, NULL, NULL, 'OS04G0482300 PROTEIN', 245185),
(355306, 'PTHR46287:SF11', NULL, NULL, NULL, NULL, 'BTB/POZ AND TAZ DOMAIN-CONTAINING PROTEIN 4', 245185),
(355307, 'PTHR46287', NULL, NULL, NULL, NULL, 'BTB/POZ AND TAZ DOMAIN-CONTAINING PROTEIN 3-RELATED', 245185),
(355308, 'PTHR46287:SF8', NULL, NULL, NULL, NULL, 'BTB/POZ AND TAZ DOMAIN PROTEIN', 245185),
(355309, 'PTHR46287:SF9', NULL, NULL, NULL, NULL, 'BTB/POZ AND TAZ DOMAIN-CONTAINING PROTEIN 5', 245185),
(355310, 'PTHR46287:SF4', NULL, NULL, NULL, NULL, 'BTB/POZ AND TAZ DOMAIN-CONTAINING PROTEIN 2', 245185),
(355311, 'PTHR46287:SF5', NULL, NULL, NULL, NULL, 'OS02G0596700 PROTEIN', 245185),
(355312, 'PTHR46287:SF6', NULL, NULL, NULL, NULL, 'BTB/POZ AND TAZ DOMAIN-CONTAINING PROTEIN 1-LIKE ISOFORM X1', 245185),
(355313, 'PTHR46287:SF7', NULL, NULL, NULL, NULL, 'BTB/POZ AND TAZ DOMAIN-CONTAINING PROTEIN 1', 245185),
(355314, 'PTHR46287:SF16', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 245185),
(355315, 'PTHR46287:SF15', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN', 245185),
(355316, 'PTHR46287:SF18', NULL, NULL, NULL, NULL, 'BTB AND TAZ DOMAIN PROTEIN 3', 245185),
(355317, 'PTHR46287:SF17', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 245185),
(355318, 'PTHR46287:SF19', NULL, NULL, NULL, NULL, 'BTB AND TAZ DOMAIN PROTEIN 1-RELATED', 245185),
(355319, 'PTHR39223', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1700029H14 GENE', 245186),
(355320, 'PTHR39223:SF1', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1700029H14 GENE', 245186),
(355321, 'PTHR38431:SF1', NULL, NULL, NULL, NULL, 'BLL2305 PROTEIN', 245187),
(355322, 'PTHR38431', NULL, NULL, NULL, NULL, 'BLL2305 PROTEIN', 245187),
(355323, 'PTHR10138:SF2', NULL, NULL, NULL, NULL, 'TRYPTOPHAN 2,3-DIOXYGENASE A', 245188);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(355324, 'PTHR10138:SF0', NULL, NULL, NULL, NULL, 'TRYPTOPHAN 2,3-DIOXYGENASE', 245188),
(355325, 'PTHR10138', NULL, NULL, NULL, NULL, 'TRYPTOPHAN 2,3-DIOXYGENASE', 245188),
(355326, 'PTHR11776:SF31', NULL, NULL, NULL, NULL, 'UMP PYROPHOSPHORYLASE', 245189),
(355327, 'PTHR11776:SF22', NULL, NULL, NULL, NULL, 'ADENINE PHOSPHORIBOSYLTRANSFERASE 5', 245189),
(355328, 'PTHR11776:SF11', NULL, NULL, NULL, NULL, 'OS04G0504000 PROTEIN', 245189),
(355329, 'PTHR11776', NULL, NULL, NULL, NULL, 'ADENINE PHOSPHORIBOSYLTRANSFERASE', 245189),
(355330, 'PTHR11776:SF32', NULL, NULL, NULL, NULL, 'ADENINE PHOSPHORIBOSYLTRANSFERASE', 245189),
(355331, 'PTHR11776:SF0', NULL, NULL, NULL, NULL, 'ADENINE PHOSPHORIBOSYLTRANSFERASE 1, CHLOROPLASTIC', 245189),
(355332, 'PTHR11776:SF24', NULL, NULL, NULL, NULL, 'ADENINE PHOSPHORIBOSYLTRANSFERASE', 245189),
(355333, 'PTHR11776:SF23', NULL, NULL, NULL, NULL, 'ADENINE PHOSPHORIBOSYLTRANSFERASE 2', 245189),
(355334, 'PTHR11776:SF25', NULL, NULL, NULL, NULL, 'ADENINE PHOSPHORIBOSYLTRANSFERASE', 245189),
(355335, 'PTHR11776:SF27', NULL, NULL, NULL, NULL, 'ADENINE PHOSPHORIBOSYLTRANSFERASE', 245189),
(355336, 'PTHR11776:SF29', NULL, NULL, NULL, NULL, 'ADENINE PHOSPHORIBOSYLTRANSFERASE', 245189),
(355337, 'PTHR11776:SF7', NULL, NULL, NULL, NULL, 'PRIBOSYLTRAN DOMAIN-CONTAINING PROTEIN', 245189),
(355338, 'PTHR33166:SF6', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 245190),
(355339, 'PTHR33166:SF4', NULL, NULL, NULL, NULL, 'GAG_P30 DOMAIN-CONTAINING PROTEIN', 245190),
(355340, 'PTHR33166:SF5', NULL, NULL, NULL, NULL, 'GAG_P30 DOMAIN-CONTAINING PROTEIN', 245190),
(355341, 'PTHR33166:SF2', NULL, NULL, NULL, NULL, 'GAG_P30 DOMAIN-CONTAINING PROTEIN', 245190),
(355342, 'PTHR33166:SF3', NULL, NULL, NULL, NULL, 'PROTEIN ALEX-LIKE', 245190),
(355343, 'PTHR33166:SF1', NULL, NULL, NULL, NULL, 'GAG_P30 DOMAIN-CONTAINING PROTEIN', 245190),
(355344, 'PTHR33166', NULL, NULL, NULL, NULL, 'GAG_P30 DOMAIN-CONTAINING PROTEIN', 245190),
(355345, 'PTHR43664:SF1', NULL, NULL, NULL, NULL, 'BETA-METHYLMALYL-COA DEHYDRATASE', 245191),
(355346, 'PTHR43664', NULL, NULL, NULL, NULL, 'MONOAMINE OXIDASE-RELATED', 245191),
(355347, 'PTHR41800', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245192),
(355348, 'PTHR41800:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245192),
(355349, 'PTHR46176', NULL, NULL, NULL, NULL, 'LD21662P', 245193),
(355350, 'PTHR46176:SF3', NULL, NULL, NULL, NULL, 'PROTEIN FAM76B', 245193),
(355351, 'PTHR46176:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM76A', 245193),
(355352, 'PTHR46176:SF1', NULL, NULL, NULL, NULL, 'LD21662P', 245193),
(355353, 'PTHR14511:SF17', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR, CLASS C, GROUP 5, MEMBER BB', 245194),
(355354, 'PTHR14511:SF9', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR FAMILY C GROUP 5 MEMBER B', 245194),
(355355, 'PTHR14511:SF16', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR FAMILY C GROUP 5 MEMBER D', 245194),
(355356, 'PTHR14511:SF15', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR FAMILY C GROUP 5 MEMBER C', 245194),
(355357, 'PTHR14511:SF14', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F3_4 DOMAIN-CONTAINING PROTEIN', 245194),
(355358, 'PTHR14511', NULL, NULL, NULL, NULL, 'G PROTEIN COUPLED RECEPTOR, CLASS C, GROUP 5', 245194),
(355359, 'PTHR14511:SF7', NULL, NULL, NULL, NULL, 'RETINOIC ACID-INDUCED PROTEIN 3', 245194),
(355360, 'PTHR14511:SF18', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F3_4 DOMAIN-CONTAINING PROTEIN', 245194),
(355361, 'PTHR23087:SF27', NULL, NULL, NULL, NULL, 'DRESDEN PROSTATE CARCINOMA PROTEIN 2-RELATED', 245195),
(355362, 'PTHR23087:SF26', NULL, NULL, NULL, NULL, '', 245195),
(355363, 'PTHR23087:SF13', NULL, NULL, NULL, NULL, 'NON-HISTONE CHROMOSOMAL PROTEIN HMG-17', 245195),
(355364, 'PTHR23087:SF12', NULL, NULL, NULL, NULL, 'NON-HISTONE CHROMOSOMAL PROTEIN HMG-14', 245195),
(355365, 'PTHR23087:SF23', NULL, NULL, NULL, NULL, '', 245195),
(355366, 'PTHR23087:SF11', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP NUCLEOSOME-BINDING DOMAIN-CONTAINING PROTEIN 4', 245195);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(355367, 'PTHR23087:SF22', NULL, NULL, NULL, NULL, '', 245195),
(355368, 'PTHR23087', NULL, NULL, NULL, NULL, 'NONHISTONE CHROMOSOMAL PROTEIN HMG', 245195),
(355369, 'PTHR23087:SF10', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP NUCLEOSOMAL-BINDING DOMAIN 7-RELATED', 245195),
(355370, 'PTHR23087:SF30', NULL, NULL, NULL, NULL, 'NON-HISTONE CHROMOSOMAL PROTEIN HMG-14A', 245195),
(355371, 'PTHR23087:SF2', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP NUCLEOSOME-BINDING DOMAIN-CONTAINING PROTEIN 3', 245195),
(355372, 'PTHR28032', NULL, NULL, NULL, NULL, 'FI02826P', 245196),
(355373, 'PTHR28032:SF1', NULL, NULL, NULL, NULL, 'FI02826P', 245196),
(355374, 'PTHR46983:SF4', NULL, NULL, NULL, NULL, 'CYSTEINE AND HISTIDINE-RICH DOMAIN-CONTAINING PROTEIN 1', 245197),
(355375, 'PTHR46983:SF3', NULL, NULL, NULL, NULL, 'CHORD DOMAIN-CONTAINING PROTEIN', 245197),
(355376, 'PTHR46983', NULL, NULL, NULL, NULL, 'CYSTEINE AND HISTIDINE-RICH DOMAIN-CONTAINING PROTEIN 1', 245197),
(355377, 'PTHR46983:SF2', NULL, NULL, NULL, NULL, 'ZGC:92429', 245197),
(355378, 'PTHR11913:SF88', NULL, NULL, NULL, NULL, 'ACTIN DEPOLYMERIZING FACTOR 3-RELATED', 245198),
(355379, 'PTHR11913:SF89', NULL, NULL, NULL, NULL, 'ACTIN-DEPOLYMERIZING FACTOR 7', 245198),
(355380, 'PTHR11913', NULL, NULL, NULL, NULL, 'COFILIN-RELATED', 245198),
(355381, 'PTHR11913:SF90', NULL, NULL, NULL, NULL, 'ACTIN-DEPOLYMERIZING FACTOR 12', 245198),
(355382, 'PTHR11913:SF92', NULL, NULL, NULL, NULL, 'ADF-H DOMAIN-CONTAINING PROTEIN', 245198),
(355383, 'PTHR11913:SF93', NULL, NULL, NULL, NULL, 'COFILIN/ACTIN-DEPOLYMERIZING FACTOR-LIKE PROTEIN', 245198),
(355384, 'PTHR11913:SF94', NULL, NULL, NULL, NULL, 'ACTIN-DEPOLYMERIZING FACTOR 7', 245198),
(355385, 'PTHR11913:SF50', NULL, NULL, NULL, NULL, 'ACTIN-DEPOLYMERIZING FACTOR 4', 245198),
(355386, 'PTHR11913:SF95', NULL, NULL, NULL, NULL, 'ADF-H DOMAIN-CONTAINING PROTEIN', 245198),
(355387, 'PTHR11913:SF110', NULL, NULL, NULL, NULL, 'ADF-H DOMAIN-CONTAINING PROTEIN', 245198),
(355388, 'PTHR11913:SF111', NULL, NULL, NULL, NULL, 'ACTIN-DEPOLYMERIZING FACTOR 2-RELATED', 245198),
(355389, 'PTHR11913:SF96', NULL, NULL, NULL, NULL, 'COFILIN/ACTIN-DEPOLYMERIZING FACTOR-LIKE PROTEIN', 245198),
(355390, 'PTHR11913:SF112', NULL, NULL, NULL, NULL, 'ACTIN-DEPOLYMERIZING FACTOR 1-RELATED', 245198),
(355391, 'PTHR11913:SF97', NULL, NULL, NULL, NULL, 'ADF-H DOMAIN-CONTAINING PROTEIN', 245198),
(355392, 'PTHR11913:SF53', NULL, NULL, NULL, NULL, 'COFILIN 1-RELATED', 245198),
(355393, 'PTHR11913:SF54', NULL, NULL, NULL, NULL, 'CFL1 PROTEIN', 245198),
(355394, 'PTHR11913:SF113', NULL, NULL, NULL, NULL, 'ADF-H DOMAIN-CONTAINING PROTEIN', 245198),
(355395, 'PTHR11913:SF98', NULL, NULL, NULL, NULL, 'ACTIN DEPOLYMERIZING FACTOR 5-RELATED', 245198),
(355396, 'PTHR11913:SF99', NULL, NULL, NULL, NULL, 'ACTIN DEPOLYMERIZING FACTOR 10-RELATED', 245198),
(355397, 'PTHR11913:SF55', NULL, NULL, NULL, NULL, 'ACTIN-DEPOLYMERIZING FACTOR 10-LIKE', 245198),
(355398, 'PTHR11913:SF12', NULL, NULL, NULL, NULL, 'COFILIN/ACTIN-DEPOLYMERIZING FACTOR HOMOLOG-RELATED', 245198),
(355399, 'PTHR11913:SF57', NULL, NULL, NULL, NULL, 'ACTIN-DEPOLYMERIZING FACTOR 8', 245198),
(355400, 'PTHR11913:SF58', NULL, NULL, NULL, NULL, 'ACTIN-DEPOLYMERIZING FACTOR 10-LIKE', 245198),
(355401, 'PTHR11913:SF59', NULL, NULL, NULL, NULL, 'ADF-H DOMAIN-CONTAINING PROTEIN', 245198),
(355402, 'PTHR11913:SF15', NULL, NULL, NULL, NULL, 'COFILIN-2', 245198),
(355403, 'PTHR11913:SF16', NULL, NULL, NULL, NULL, 'ACTIN-DEPOLYMERIZING FACTOR 5', 245198),
(355404, 'PTHR11913:SF17', NULL, NULL, NULL, NULL, 'COFILIN-1', 245198),
(355405, 'PTHR11913:SF18', NULL, NULL, NULL, NULL, 'DESTRIN', 245198),
(355406, 'PTHR11913:SF62', NULL, NULL, NULL, NULL, 'ADF-H DOMAIN-CONTAINING PROTEIN', 245198),
(355407, 'PTHR11913:SF63', NULL, NULL, NULL, NULL, 'ADF-H DOMAIN-CONTAINING PROTEIN', 245198),
(355408, 'PTHR11913:SF23', NULL, NULL, NULL, NULL, 'ACTIN-DEPOLYMERIZING FACTOR 9', 245198),
(355409, 'PTHR11913:SF67', NULL, NULL, NULL, NULL, 'ADF-H DOMAIN-CONTAINING PROTEIN', 245198),
(355410, 'PTHR11913:SF68', NULL, NULL, NULL, NULL, 'ADF-H DOMAIN-CONTAINING PROTEIN', 245198);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(355411, 'PTHR11913:SF70', NULL, NULL, NULL, NULL, 'ADF-H DOMAIN-CONTAINING PROTEIN', 245198),
(355412, 'PTHR11913:SF72', NULL, NULL, NULL, NULL, 'ACTIN-DEPOLYMERIZING FACTOR 9', 245198),
(355413, 'PTHR11913:SF75', NULL, NULL, NULL, NULL, 'ACTIN-DEPOLYMERIZING FACTOR 10-LIKE', 245198),
(355414, 'PTHR11913:SF31', NULL, NULL, NULL, NULL, 'ACTIN-DEPOLYMERIZING FACTOR 6', 245198),
(355415, 'PTHR11913:SF76', NULL, NULL, NULL, NULL, 'ACTIN-DEPOLYMERIZING FACTOR 3', 245198),
(355416, 'PTHR11913:SF79', NULL, NULL, NULL, NULL, 'ADF-H DOMAIN-CONTAINING PROTEIN', 245198),
(355417, 'PTHR11913:SF107', NULL, NULL, NULL, NULL, 'COFILIN/ACTIN-DEPOLYMERIZING FACTOR-LIKE PROTEIN', 245198),
(355418, 'PTHR11913:SF108', NULL, NULL, NULL, NULL, 'ACTIN-DEPOLYMERIZING FACTOR 3', 245198),
(355419, 'PTHR11913:SF109', NULL, NULL, NULL, NULL, 'ADF/COFILIN/DESTRIN, ADF-H/GELSOLIN-LIKE DOMAIN PROTEIN-RELATED', 245198),
(355420, 'PTHR11913:SF80', NULL, NULL, NULL, NULL, 'ADF-H DOMAIN-CONTAINING PROTEIN', 245198),
(355421, 'PTHR11913:SF104', NULL, NULL, NULL, NULL, 'ACTIN-DEPOLYMERIZING FACTOR 2', 245198),
(355422, 'PTHR11913:SF82', NULL, NULL, NULL, NULL, 'ADF-H DOMAIN-CONTAINING PROTEIN', 245198),
(355423, 'PTHR11913:SF83', NULL, NULL, NULL, NULL, 'ACTIN-DEPOLYMERIZING FACTOR-LIKE', 245198),
(355424, 'PTHR11913:SF106', NULL, NULL, NULL, NULL, 'ACTIN-DEPOLYMERIZING FACTOR 10', 245198),
(355425, 'PTHR11913:SF100', NULL, NULL, NULL, NULL, 'ACTIN-DEPOLYMERIZING FACTOR 6', 245198),
(355426, 'PTHR11913:SF86', NULL, NULL, NULL, NULL, 'ACTIN-DEPOLYMERIZING FACTOR 2-LIKE', 245198),
(355427, 'PTHR11913:SF101', NULL, NULL, NULL, NULL, 'ACTIN-DEPOLYMERIZING FACTOR 7-LIKE', 245198),
(355428, 'PTHR11913:SF87', NULL, NULL, NULL, NULL, 'ADF-H DOMAIN-CONTAINING PROTEIN', 245198),
(355429, 'PTHR11913:SF102', NULL, NULL, NULL, NULL, 'ACTIN-DEPOLYMERIZING FACTOR 11', 245198),
(355430, 'PTHR31065:SF90', NULL, NULL, NULL, NULL, 'B BOX-TYPE DOMAIN-CONTAINING PROTEIN', 245199),
(355431, 'PTHR31065:SF92', NULL, NULL, NULL, NULL, 'PLATZ TRANSCRIPTION FACTOR 1', 245199),
(355432, 'PTHR31065:SF91', NULL, NULL, NULL, NULL, 'PLATZ TRANSCRIPTION FACTOR FAMILY PROTEIN-RELATED', 245199),
(355433, 'PTHR31065:SF50', NULL, NULL, NULL, NULL, 'ZINC ION BINDING PROTEIN', 245199),
(355434, 'PTHR31065:SF94', NULL, NULL, NULL, NULL, '', 245199),
(355435, 'PTHR31065:SF93', NULL, NULL, NULL, NULL, 'B BOX-TYPE DOMAIN-CONTAINING PROTEIN', 245199),
(355436, 'PTHR31065:SF96', NULL, NULL, NULL, NULL, 'DUF4216 DOMAIN-CONTAINING PROTEIN', 245199),
(355437, 'PTHR31065:SF52', NULL, NULL, NULL, NULL, 'B BOX-TYPE DOMAIN-CONTAINING PROTEIN', 245199),
(355438, 'PTHR31065:SF51', NULL, NULL, NULL, NULL, '', 245199),
(355439, 'PTHR31065:SF95', NULL, NULL, NULL, NULL, '', 245199),
(355440, 'PTHR31065:SF54', NULL, NULL, NULL, NULL, 'BNAC01G10450D PROTEIN', 245199),
(355441, 'PTHR31065:SF53', NULL, NULL, NULL, NULL, 'B BOX-TYPE DOMAIN-CONTAINING PROTEIN', 245199),
(355442, 'PTHR31065:SF97', NULL, NULL, NULL, NULL, 'PLATZ TRANSCRIPTION FACTOR FAMILY PROTEIN', 245199),
(355443, 'PTHR31065:SF56', NULL, NULL, NULL, NULL, 'OS02G0193400 PROTEIN', 245199),
(355444, 'PTHR31065:SF55', NULL, NULL, NULL, NULL, '', 245199),
(355445, 'PTHR31065:SF11', NULL, NULL, NULL, NULL, 'PROTEIN RGF1 INDUCIBLE TRANSCRIPTION FACTOR 1', 245199),
(355446, 'PTHR31065:SF58', NULL, NULL, NULL, NULL, 'BNAA02G36800D PROTEIN', 245199),
(355447, 'PTHR31065:SF57', NULL, NULL, NULL, NULL, 'PLATZ TRANSCRIPTION FACTOR FAMILY PROTEIN', 245199),
(355448, 'PTHR31065:SF59', NULL, NULL, NULL, NULL, 'OS02G0661400 PROTEIN', 245199),
(355449, 'PTHR31065:SF60', NULL, NULL, NULL, NULL, '', 245199),
(355450, 'PTHR31065:SF62', NULL, NULL, NULL, NULL, 'BNAA08G06760D PROTEIN', 245199),
(355451, 'PTHR31065:SF64', NULL, NULL, NULL, NULL, '', 245199),
(355452, 'PTHR31065:SF67', NULL, NULL, NULL, NULL, 'BNAA09G18140D PROTEIN', 245199),
(355453, 'PTHR31065:SF66', NULL, NULL, NULL, NULL, 'BNAC08G19610D PROTEIN', 245199),
(355454, 'PTHR31065:SF68', NULL, NULL, NULL, NULL, 'OS02G0172800 PROTEIN', 245199),
(355455, 'PTHR31065:SF39', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 245199);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(355456, 'PTHR31065:SF70', NULL, NULL, NULL, NULL, 'PLATZ TRANSCRIPTION FACTOR FAMILY PROTEIN-RELATED', 245199),
(355457, 'PTHR31065:SF72', NULL, NULL, NULL, NULL, 'BNAC08G11100D PROTEIN', 245199),
(355458, 'PTHR31065:SF78', NULL, NULL, NULL, NULL, '', 245199),
(355459, 'PTHR31065', NULL, NULL, NULL, NULL, 'PLATZ TRANSCRIPTION FACTOR FAMILY PROTEIN', 245199),
(355460, 'PTHR31065:SF77', NULL, NULL, NULL, NULL, 'BNACNNG65920D PROTEIN', 245199),
(355461, 'PTHR31065:SF36', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245199),
(355462, 'PTHR31065:SF35', NULL, NULL, NULL, NULL, 'PLATZ TRANSCRIPTION FACTOR FAMILY PROTEIN', 245199),
(355463, 'PTHR31065:SF38', NULL, NULL, NULL, NULL, '', 245199),
(355464, 'PTHR31065:SF1', NULL, NULL, NULL, NULL, 'OS09G0116050 PROTEIN', 245199),
(355465, 'PTHR31065:SF9', NULL, NULL, NULL, NULL, 'B BOX-TYPE DOMAIN-CONTAINING PROTEIN', 245199),
(355466, 'PTHR31065:SF7', NULL, NULL, NULL, NULL, 'OS01G0517800 PROTEIN', 245199),
(355467, 'PTHR31065:SF4', NULL, NULL, NULL, NULL, 'TRANSPOSON PROTEIN, CACTA, EN/SPM SUB-CLASS', 245199),
(355468, 'PTHR31065:SF80', NULL, NULL, NULL, NULL, 'OS04G0591100 PROTEIN', 245199),
(355469, 'PTHR31065:SF83', NULL, NULL, NULL, NULL, '', 245199),
(355470, 'PTHR31065:SF41', NULL, NULL, NULL, NULL, 'PLATZ TRANSCRIPTION FACTOR FAMILY PROTEIN', 245199),
(355471, 'PTHR31065:SF40', NULL, NULL, NULL, NULL, 'ZINC-BINDING PROTEIN', 245199),
(355472, 'PTHR31065:SF87', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR', 245199),
(355473, 'PTHR31065:SF86', NULL, NULL, NULL, NULL, 'BNAA09G38660D PROTEIN', 245199),
(355474, 'PTHR31065:SF42', NULL, NULL, NULL, NULL, 'PLATZ TRANSCRIPTION FACTOR FAMILY PROTEIN', 245199),
(355475, 'PTHR31065:SF89', NULL, NULL, NULL, NULL, 'PLATZ TRANSCRIPTION FACTOR FAMILY PROTEIN', 245199),
(355476, 'PTHR31065:SF88', NULL, NULL, NULL, NULL, 'PLATZ TRANSCRIPTION FACTOR FAMILY PROTEIN', 245199),
(355477, 'PTHR31065:SF46', NULL, NULL, NULL, NULL, 'PLATZ TRANSCRIPTION FACTOR FAMILY PROTEIN-RELATED', 245199),
(355478, 'PTHR31065:SF49', NULL, NULL, NULL, NULL, 'PLATZ TRANSCRIPTION FACTOR FAMILY PROTEIN', 245199),
(355479, 'PTHR31065:SF48', NULL, NULL, NULL, NULL, 'PLATZ TRANSCRIPTION FACTOR FAMILY PROTEIN', 245199),
(355480, 'PTHR13491', NULL, NULL, NULL, NULL, 'ZCCHC10 PROTEIN', 245200),
(355481, 'PTHR13491:SF3', NULL, NULL, NULL, NULL, '', 245200),
(355482, 'PTHR13491:SF0', NULL, NULL, NULL, NULL, 'ZINC FINGER CCHC DOMAIN-CONTAINING PROTEIN 10', 245200),
(355483, 'PTHR33321:SF22', NULL, NULL, NULL, NULL, 'NTPRP27', 245201),
(355484, 'PTHR33321:SF21', NULL, NULL, NULL, NULL, '', 245201),
(355485, 'PTHR33321:SF24', NULL, NULL, NULL, NULL, '', 245201),
(355486, 'PTHR33321:SF23', NULL, NULL, NULL, NULL, '', 245201),
(355487, 'PTHR33321:SF3', NULL, NULL, NULL, NULL, 'OS05G0582000 PROTEIN', 245201),
(355488, 'PTHR33321:SF12', NULL, NULL, NULL, NULL, 'PLANT BASIC SECRETORY PROTEIN (BSP) FAMILY PROTEIN', 245201),
(355489, 'PTHR33321:SF26', NULL, NULL, NULL, NULL, '', 245201),
(355490, 'PTHR33321:SF15', NULL, NULL, NULL, NULL, '', 245201),
(355491, 'PTHR33321:SF14', NULL, NULL, NULL, NULL, 'BASIC SECRETORY PROTEIN (BSP) FAMILY PROTEIN, PUTATIVE-RELATED', 245201),
(355492, 'PTHR33321', NULL, NULL, NULL, NULL, '', 245201),
(355493, 'PTHR33321:SF17', NULL, NULL, NULL, NULL, 'PR17D', 245201),
(355494, 'PTHR33321:SF16', NULL, NULL, NULL, NULL, 'PLANT BASIC SECRETORY PROTEIN (BSP) FAMILY PROTEIN', 245201),
(355495, 'PTHR43265:SF1', NULL, NULL, NULL, NULL, 'ESTERASE ESTD', 245202),
(355496, 'PTHR43265', NULL, NULL, NULL, NULL, 'ESTERASE ESTD', 245202),
(355497, 'PTHR46913:SF11', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 245203),
(355498, 'PTHR46913:SF9', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 245203),
(355499, 'PTHR46913', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL16', 245203),
(355500, 'PTHR46913:SF8', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 245203),
(355501, 'PTHR46913:SF10', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 245203),
(355502, 'PTHR46913:SF3', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL16-LIKE', 245203);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(355503, 'PTHR46913:SF16', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL1', 245203),
(355504, 'PTHR46913:SF13', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 245203),
(355505, 'PTHR46913:SF14', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 245203),
(355506, 'PTHR46913:SF17', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL16', 245203),
(355507, 'PTHR46913:SF1', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL16', 245203),
(355508, 'PTHR11422:SF0', NULL, NULL, NULL, NULL, 'T-CELL SURFACE GLYCOPROTEIN CD4', 245204),
(355509, 'PTHR11422:SF5', NULL, NULL, NULL, NULL, 'DIVERSE IMMUNOGLOBULIN DOMAIN-CONTAINING PROTEIN 1.1-RELATED', 245204),
(355510, 'PTHR11422:SF6', NULL, NULL, NULL, NULL, 'CD4-2 MOLECULE, TANDEM DUPLICATE 2-RELATED', 245204),
(355511, 'PTHR11422:SF3', NULL, NULL, NULL, NULL, 'G6F-LIKE', 245204),
(355512, 'PTHR11422:SF9', NULL, NULL, NULL, NULL, 'MICROFIBRIL-ASSOCIATED GLYCOPROTEIN 3', 245204),
(355513, 'PTHR11422:SF7', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ACTIVATION GENE 3 PROTEIN-LIKE', 245204),
(355514, 'PTHR11422', NULL, NULL, NULL, NULL, 'T-CELL SURFACE GLYCOPROTEIN CD4', 245204),
(355515, 'PTHR11422:SF8', NULL, NULL, NULL, NULL, 'CD4-1 MOLECULE', 245204),
(355516, 'PTHR11422:SF10', NULL, NULL, NULL, NULL, 'T-CELL SURFACE ANTIGEN T4/LEU-3', 245204),
(355517, 'PTHR34828', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 45', 245205),
(355518, 'PTHR34828:SF1', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 45', 245205),
(355519, 'PTHR23008', NULL, NULL, NULL, NULL, 'CHROMOSOME 28 C10ORF62 HOMOLOG', 245206),
(355520, 'PTHR23008:SF0', NULL, NULL, NULL, NULL, 'CHROMOSOME 28 C10ORF62 HOMOLOG', 245206),
(355521, 'PTHR45789:SF2', NULL, NULL, NULL, NULL, 'FI18025P1', 245207),
(355522, 'PTHR45789', NULL, NULL, NULL, NULL, 'FI18025P1', 245207),
(355523, 'PTHR45789:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SOX-5', 245207),
(355524, 'PTHR45789:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SOX-6', 245207),
(355525, 'PTHR45789:SF4', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SOX-13', 245207),
(355526, 'PTHR45789:SF5', NULL, NULL, NULL, NULL, 'HMG BOX DOMAIN-CONTAINING PROTEIN', 245207),
(355527, 'PTHR13634:SF0', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS PROTEIN BRX1 HOMOLOG', 245208),
(355528, 'PTHR13634:SF1', NULL, NULL, NULL, NULL, 'OS01G0148400 PROTEIN', 245208),
(355529, 'PTHR13634:SF2', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 245208),
(355530, 'PTHR13634:SF3', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS PROTEIN BRX1 HOMOLOG 2', 245208),
(355531, 'PTHR13634', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS PROTEIN BRIX', 245208),
(355532, 'PTHR35482', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT', 245209),
(355533, 'PTHR35482:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT', 245209),
(355534, 'PTHR15961:SF3', NULL, NULL, NULL, NULL, 'PROTEIN EURL HOMOLOG', 245210),
(355535, 'PTHR15961', NULL, NULL, NULL, NULL, 'PROTEIN EURL HOMOLOG', 245210),
(355536, 'PTHR31307:SF60', NULL, NULL, NULL, NULL, '', 245211),
(355537, 'PTHR31307:SF40', NULL, NULL, NULL, NULL, 'SEQUENCE-SPECIFIC DNA BINDING TRANSCRIPTION FACTOR', 245211),
(355538, 'PTHR31307:SF41', NULL, NULL, NULL, NULL, 'FRIGIDA INTERACTING PROTEIN 2', 245211),
(355539, 'PTHR31307:SF44', NULL, NULL, NULL, NULL, '', 245211),
(355540, 'PTHR31307:SF43', NULL, NULL, NULL, NULL, 'MYB-LIKE DOMAIN-CONTAINING PROTEIN', 245211),
(355541, 'PTHR31307', NULL, NULL, NULL, NULL, 'TRIHELIX TRANSCRIPTION FACTOR ASIL2', 245211),
(355542, 'PTHR31307:SF12', NULL, NULL, NULL, NULL, 'OS02G0565000 PROTEIN', 245211),
(355543, 'PTHR31307:SF59', NULL, NULL, NULL, NULL, '', 245211),
(355544, 'PTHR31307:SF37', NULL, NULL, NULL, NULL, '', 245211),
(355545, 'PTHR31307:SF58', NULL, NULL, NULL, NULL, 'TRIHELIX TRANSCRIPTION FACTOR ASIL2-LIKE', 245211),
(355546, 'PTHR31307:SF39', NULL, NULL, NULL, NULL, 'TRIHELIX TRANSCRIPTION FACTOR ASIL1', 245211),
(355547, 'PTHR31307:SF38', NULL, NULL, NULL, NULL, 'OS01G0674000 PROTEIN', 245211),
(355548, 'PTHR31307:SF16', NULL, NULL, NULL, NULL, 'OS05G0560600 PROTEIN', 245211); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(355549, 'PTHR31307:SF8', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE TRANSCRIPTION FACTOR MYB/SANT-LIKE FAMILY PROTEIN', 245211),
(355550, 'PTHR31307:SF7', NULL, NULL, NULL, NULL, 'SEQUENCE-SPECIFIC DNA BINDING TRANSCRIPTION FACTOR', 245211),
(355551, 'PTHR31307:SF50', NULL, NULL, NULL, NULL, 'SEQUENCE-SPECIFIC DNA BINDING TRANSCRIPTION FACTOR', 245211),
(355552, 'PTHR31307:SF53', NULL, NULL, NULL, NULL, 'BNAA05G14030D PROTEIN', 245211),
(355553, 'PTHR31307:SF55', NULL, NULL, NULL, NULL, 'MADF DOMAIN, MYB-LIKE DOMAIN PROTEIN-RELATED', 245211),
(355554, 'PTHR31307:SF54', NULL, NULL, NULL, NULL, 'BNAA01G29550D PROTEIN', 245211),
(355555, 'PTHR31307:SF4', NULL, NULL, NULL, NULL, 'TRIHELIX TRANSCRIPTION FACTOR ASIL2', 245211),
(355556, 'PTHR31307:SF3', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN', 245211),
(355557, 'PTHR31307:SF6', NULL, NULL, NULL, NULL, 'OS01G0718900 PROTEIN', 245211),
(355558, 'PTHR31307:SF46', NULL, NULL, NULL, NULL, '', 245211),
(355559, 'PTHR31307:SF45', NULL, NULL, NULL, NULL, 'OS09G0558200 PROTEIN', 245211),
(355560, 'PTHR31307:SF49', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE TRANSCRIPTION FACTOR MYB/SANT-LIKE FAMILY PROTEIN', 245211),
(355561, 'PTHR37193', NULL, NULL, NULL, NULL, 'ALPHA-1,6-MANNOSYL-GLYCOPROTEIN 2-BETA-N-ACETYLGLUCOSAMINYLTRANSFERASE', 245212),
(355562, 'PTHR37193:SF1', NULL, NULL, NULL, NULL, 'ALPHA-1,6-MANNOSYL-GLYCOPROTEIN 2-BETA-N-ACETYLGLUCOSAMINYLTRANSFERASE', 245212),
(355563, 'PTHR36686', NULL, NULL, NULL, NULL, 'SYNAPTONEMAL COMPLEX CENTRAL ELEMENT PROTEIN 3', 245213),
(355564, 'PTHR36686:SF1', NULL, NULL, NULL, NULL, 'SYNAPTONEMAL COMPLEX CENTRAL ELEMENT PROTEIN 3', 245213),
(355565, 'PTHR14882:SF3', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING 92B', 245214),
(355566, 'PTHR14882:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG07050', 245214),
(355567, 'PTHR14882:SF7', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 74A-RELATED', 245214),
(355568, 'PTHR14882:SF6', NULL, NULL, NULL, NULL, 'CCDC92 DOMAIN-CONTAINING PROTEIN', 245214),
(355569, 'PTHR14882:SF5', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING 74A', 245214),
(355570, 'PTHR14882:SF4', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 92', 245214),
(355571, 'PTHR14882', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING 74A', 245214),
(355572, 'PTHR39178', NULL, NULL, NULL, NULL, 'HYPOTHETICAL RIBOSOME-ASSOCIATED PROTEIN', 245215),
(355573, 'PTHR39178:SF1', NULL, NULL, NULL, NULL, 'HYPOTHETICAL RIBOSOME-ASSOCIATED PROTEIN', 245215),
(355574, 'PTHR11800:SF18', NULL, NULL, NULL, NULL, 'RPOLD DOMAIN-CONTAINING PROTEIN', 245216),
(355575, 'PTHR11800:SF2', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE II SUBUNIT RPB3', 245216),
(355576, 'PTHR11800:SF17', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE FAMILY PROTEIN', 245216),
(355577, 'PTHR11800', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE', 245216),
(355578, 'PTHR11800:SF15', NULL, NULL, NULL, NULL, 'RPOLD DOMAIN-CONTAINING PROTEIN', 245216),
(355579, 'PTHR11800:SF13', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASES I AND III SUBUNIT RPAC1', 245216),
(355580, 'PTHR28065:SF1', NULL, NULL, NULL, NULL, 'DUF4050 DOMAIN-CONTAINING PROTEIN', 245217),
(355581, 'PTHR28065', NULL, NULL, NULL, NULL, 'FREQUENIN', 245217),
(355582, 'PTHR33732:SF2', NULL, NULL, NULL, NULL, 'RUBBER ELONGATION FACTOR PROTEIN', 245218),
(355583, 'PTHR33732', NULL, NULL, NULL, NULL, 'REF/SRPP-LIKE PROTEIN OS05G0151300/LOC_OS05G05940', 245218),
(355584, 'PTHR33732:SF3', NULL, NULL, NULL, NULL, 'RUBBER ELONGATION FACTOR PROTEIN', 245218),
(355585, 'PTHR33732:SF11', NULL, NULL, NULL, NULL, 'BNAA07G25040D PROTEIN', 245218),
(355586, 'PTHR33732:SF10', NULL, NULL, NULL, NULL, 'RUBBER ELONGATION FACTOR-RELATED', 245218),
(355587, 'PTHR33732:SF9', NULL, NULL, NULL, NULL, 'REF/SRPP-LIKE PROTEIN OS05G0151300/LOC_OS05G05940', 245218),
(355588, 'PTHR33732:SF7', NULL, NULL, NULL, NULL, 'RUBBER ELONGATION FACTOR-RELATED', 245218),
(355589, 'PTHR10849:SF20', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] IRON-SULFUR PROTEIN 8, MITOCHONDRIAL', 245219); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(355590, 'PTHR10849:SF31', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] IRON-SULFUR PROTEIN 8, MITOCHONDRIAL', 245219),
(355591, 'PTHR10849:SF34', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] IRON-SULFUR PROTEIN 8-B, MITOCHONDRIAL', 245219),
(355592, 'PTHR10849:SF24', NULL, NULL, NULL, NULL, 'NADH-QUINONE OXIDOREDUCTASE SUBUNIT I 2', 245219),
(355593, 'PTHR10849:SF35', NULL, NULL, NULL, NULL, 'FORMATE HYDROGENLYASE SUBUNIT 6-RELATED', 245219),
(355594, 'PTHR10849:SF32', NULL, NULL, NULL, NULL, 'ALPHA-HELICAL FERREDOXIN-RELATED', 245219),
(355595, 'PTHR10849:SF33', NULL, NULL, NULL, NULL, 'BNAA07G38480D PROTEIN', 245219),
(355596, 'PTHR10849', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE  UBIQUINONE  IRON-SULFUR PROTEIN 8, MITOCHONDRIAL', 245219),
(355597, 'PTHR45181', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN DNAJ WITH TETRATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 245220),
(355598, 'PTHR45181:SF11', NULL, NULL, NULL, NULL, 'DNAJ DOMAIN, TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN PROTEIN-RELATED', 245220),
(355599, 'PTHR45181:SF12', NULL, NULL, NULL, NULL, 'DNAJ DOMAIN, TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN PROTEIN-RELATED', 245220),
(355600, 'PTHR45181:SF4', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN DNAJ WITH TETRATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 245220),
(355601, 'PTHR45181:SF8', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN DNAJ WITH TETRATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 245220),
(355602, 'PTHR22937:SF104', NULL, NULL, NULL, NULL, 'OS05G0564300 PROTEIN', 245221),
(355603, 'PTHR22937:SF147', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 245221),
(355604, 'PTHR22937', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF165', 245221),
(355605, 'PTHR22937:SF141', NULL, NULL, NULL, NULL, 'RING ZINC FINGER PROTEIN_ 69105-67310-RELATED', 245221),
(355606, 'PTHR22937:SF185', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MBR1-LIKE', 245221),
(355607, 'PTHR22937:SF106', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE BIG BROTHER-RELATED-LIKE', 245221),
(355608, 'PTHR22937:SF149', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 245221),
(355609, 'PTHR22937:SF46', NULL, NULL, NULL, NULL, 'OS04G0603200 PROTEIN', 245221),
(355610, 'PTHR22937:SF184', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HIP1-RELATED', 245221),
(355611, 'PTHR22937:SF140', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 245221),
(355612, 'PTHR22937:SF113', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MBR1-LIKE ISOFORM X1', 245221),
(355613, 'PTHR22937:SF156', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF13-LIKE', 245221),
(355614, 'PTHR22937:SF115', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MBR2-LIKE', 245221),
(355615, 'PTHR22937:SF159', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 245221),
(355616, 'PTHR22937:SF158', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 245221),
(355617, 'PTHR22937:SF114', NULL, NULL, NULL, NULL, 'F27F5.26', 245221),
(355618, 'PTHR22937:SF197', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 245221),
(355619, 'PTHR22937:SF196', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 245221),
(355620, 'PTHR22937:SF199', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MBR2-LIKE', 245221),
(355621, 'PTHR22937:SF198', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HIP1-RELATED', 245221),
(355622, 'PTHR22937:SF193', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 245221),
(355623, 'PTHR22937:SF192', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 245221),
(355624, 'PTHR22937:SF195', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 245221),
(355625, 'PTHR22937:SF150', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 245221),
(355626, 'PTHR22937:SF194', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 245221),
(355627, 'PTHR22937:SF191', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 165B', 245221),
(355628, 'PTHR22937:SF190', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C2H2 FAMILY-RELATED', 245221);
INSERT INTO "PUBLIC"."MODEL" VALUES
(355629, 'PTHR22937:SF201', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 245221),
(355630, 'PTHR22937:SF168', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RHG1A-RELATED', 245221),
(355631, 'PTHR22937:SF200', NULL, NULL, NULL, NULL, 'ZINC FINGER, C3HC4 TYPE (RING FINGER) PROTEIN', 245221),
(355632, 'PTHR22937:SF167', NULL, NULL, NULL, NULL, 'OS06G0695600 PROTEIN', 245221),
(355633, 'PTHR22937:SF203', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 165A', 245221),
(355634, 'PTHR22937:SF125', NULL, NULL, NULL, NULL, 'C3HC4-TYPE RING ZINC FINGER PROTEIN', 245221),
(355635, 'PTHR22937:SF202', NULL, NULL, NULL, NULL, 'ZINC FINGER, C3HC4 TYPE (RING FINGER) PROTEIN', 245221),
(355636, 'PTHR22937:SF163', NULL, NULL, NULL, NULL, 'F28K19.4', 245221),
(355637, 'PTHR22937:SF122', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 245221),
(355638, 'PTHR22937:SF166', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 245221),
(355639, 'PTHR22937:SF121', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 245221),
(355640, 'PTHR22937:SF209', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 245221),
(355641, 'PTHR22937:SF208', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MBR1-LIKE', 245221),
(355642, 'PTHR22937:SF205', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 245221),
(355643, 'PTHR22937:SF204', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 245221),
(355644, 'PTHR22937:SF207', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 245221),
(355645, 'PTHR22937:SF206', NULL, NULL, NULL, NULL, 'OS05G0163400 PROTEIN', 245221),
(355646, 'PTHR22937:SF162', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 245221),
(355647, 'PTHR22937:SF161', NULL, NULL, NULL, NULL, 'OS08G0241400 PROTEIN', 245221),
(355648, 'PTHR22937:SF178', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 245221),
(355649, 'PTHR22937:SF211', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HIP1 ISOFORM X1-RELATED', 245221),
(355650, 'PTHR22937:SF134', NULL, NULL, NULL, NULL, 'RING FINGER CONTAINING PROTEIN', 245221),
(355651, 'PTHR22937:SF136', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 245221),
(355652, 'PTHR22937:SF175', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 11-LIKE', 245221),
(355653, 'PTHR22937:SF174', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 245221),
(355654, 'PTHR22937:SF130', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 245221),
(355655, 'PTHR22937:SF210', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN-RELATED', 245221),
(355656, 'PTHR22937:SF176', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 245221),
(355657, 'PTHR22937:SF138', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 245221),
(355658, 'PTHR22937:SF67', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ZFP1-RELATED', 245221),
(355659, 'PTHR22937:SF65', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF165', 245221),
(355660, 'PTHR22937:SF170', NULL, NULL, NULL, NULL, 'TRANSPOSASE-ASSOCIATED DOMAIN-CONTAINING PROTEIN-RELATED', 245221),
(355661, 'PTHR32507:SF0', NULL, NULL, NULL, NULL, 'NA(+)/H(+) ANTIPORTER 1', 245222),
(355662, 'PTHR32507', NULL, NULL, NULL, NULL, 'NA(+)/H(+) ANTIPORTER 1', 245222),
(355663, 'PTHR32507:SF8', NULL, NULL, NULL, NULL, 'TRANSPORTER-RELATED', 245222),
(355664, 'PTHR32507:SF7', NULL, NULL, NULL, NULL, 'K(+)/H(+) ANTIPORTER NHAP2', 245222),
(355665, 'PTHR24287:SF5', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 245223),
(355666, 'PTHR24287:SF1', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 245223),
(355667, 'PTHR24287', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 245223),
(355668, 'PTHR24287:SF18', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 MONOOXYGENASE APDE-RELATED', 245223),
(355669, 'PTHR24287:SF17', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 245223),
(355670, 'PTHR46787:SF1', NULL, NULL, NULL, NULL, 'SYNDROMES PUTATIVE CHAPERONIN-RELATED', 245224);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(355671, 'PTHR46787', NULL, NULL, NULL, NULL, 'SYNDROMES PUTATIVE CHAPERONIN-RELATED', 245224),
(355672, 'PTHR39444:SF3', NULL, NULL, NULL, NULL, '', 245225),
(355673, 'PTHR39444', NULL, NULL, NULL, NULL, '', 245225),
(355674, 'PTHR43090', NULL, NULL, NULL, NULL, '1-(5-PHOSPHORIBOSYL)-5-[(5-PHOSPHORIBOSYLAMINO)METHYLIDENEAMINO] IMIDAZOLE-4-CARBOXAMIDE ISOMERASE', 245226),
(355675, 'PTHR43090:SF7', NULL, NULL, NULL, NULL, '1-(5-PHOSPHORIBOSYL)-5-[(5-PHOSPHORIBOSYLAMINO)METHYLIDENEAMINO] IMIDAZOLE-4-CARBOXAMIDE ISOMERASE', 245226),
(355676, 'PTHR43090:SF5', NULL, NULL, NULL, NULL, '1-(5-PHOSPHORIBOSYL)-5-[(5-PHOSPHORIBOSYLAMINO)METHYLIDENEAMINO] IMIDAZOLE-4-CARBOXAMIDE ISOMERASE, CHLOROPLASTIC', 245226),
(355677, 'PTHR43090:SF2', NULL, NULL, NULL, NULL, '1-(5-PHOSPHORIBOSYL)-5-[(5-PHOSPHORIBOSYLAMINO)METHYLIDENEAMINO] IMIDAZOLE-4-CARBOXAMIDE ISOMERASE', 245226),
(355678, 'PTHR16308:SF20', NULL, NULL, NULL, NULL, 'UBIQUITIN-ASSOCIATED PROTEIN 2B', 245227),
(355679, 'PTHR16308:SF13', NULL, NULL, NULL, NULL, 'PROTEIN LINGERER', 245227),
(355680, 'PTHR16308', NULL, NULL, NULL, NULL, 'UBIQUITIN ASSOCIATED PROTEIN 2-LIKE/LINGERER', 245227),
(355681, 'PTHR16308:SF19', NULL, NULL, NULL, NULL, 'UBIQUITIN-ASSOCIATED PROTEIN 2', 245227),
(355682, 'PTHR16308:SF18', NULL, NULL, NULL, NULL, 'UBIQUITIN-ASSOCIATED PROTEIN 2-LIKE', 245227),
(355683, 'PTHR30506:SF3', NULL, NULL, NULL, NULL, 'UPF0126 INNER MEMBRANE PROTEIN YADS', 245228),
(355684, 'PTHR30506:SF2', NULL, NULL, NULL, NULL, 'UPF0126 INNER MEMBRANE PROTEIN YICG', 245228),
(355685, 'PTHR30506', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN', 245228),
(355686, 'PTHR12588:SF11', NULL, NULL, NULL, NULL, 'INOSITOL OXYGENASE', 245229),
(355687, 'PTHR12588:SF10', NULL, NULL, NULL, NULL, 'INOSITOL OXYGENASE 2', 245229),
(355688, 'PTHR12588:SF14', NULL, NULL, NULL, NULL, 'INOSITOL OXYGENASE 5', 245229),
(355689, 'PTHR12588:SF0', NULL, NULL, NULL, NULL, 'INOSITOL OXYGENASE', 245229),
(355690, 'PTHR12588:SF13', NULL, NULL, NULL, NULL, 'INOSITOL OXYGENASE', 245229),
(355691, 'PTHR12588:SF12', NULL, NULL, NULL, NULL, 'INOSITOL OXYGENASE 1', 245229),
(355692, 'PTHR12588', NULL, NULL, NULL, NULL, 'MYOINOSITOL OXYGENASE', 245229),
(355693, 'PTHR12588:SF5', NULL, NULL, NULL, NULL, 'INOSITOL OXYGENASE', 245229),
(355694, 'PTHR12588:SF18', NULL, NULL, NULL, NULL, 'INOSITOL OXYGENASE', 245229),
(355695, 'PTHR12588:SF4', NULL, NULL, NULL, NULL, 'INOSITOL OXYGENASE 4', 245229),
(355696, 'PTHR12588:SF17', NULL, NULL, NULL, NULL, 'INOSITOL OXYGENASE', 245229),
(355697, 'PTHR45817:SF4', NULL, NULL, NULL, NULL, 'LYSYL OXIDASE-LIKE-RELATED', 245230),
(355698, 'PTHR45817:SF5', NULL, NULL, NULL, NULL, 'LYSYL OXIDASE HOMOLOG 4', 245230),
(355699, 'PTHR45817:SF2', NULL, NULL, NULL, NULL, 'LYSYL OXIDASE HOMOLOG 3', 245230),
(355700, 'PTHR45817:SF1', NULL, NULL, NULL, NULL, 'LYSYL OXIDASE HOMOLOG 2', 245230),
(355701, 'PTHR45817', NULL, NULL, NULL, NULL, 'LYSYL OXIDASE-LIKE-RELATED', 245230),
(355702, 'PTHR45817:SF8', NULL, NULL, NULL, NULL, 'LYSYL OXIDASE HOMOLOG 1', 245230),
(355703, 'PTHR45817:SF6', NULL, NULL, NULL, NULL, 'PROTEIN-LYSINE 6-OXIDASE', 245230),
(355704, 'PTHR45817:SF7', NULL, NULL, NULL, NULL, 'LYSYL OXIDASE HOMOLOG 2A', 245230),
(355705, 'PTHR43829:SF26', NULL, NULL, NULL, NULL, 'AQUAPORIN 9B', 245231),
(355706, 'PTHR43829:SF15', NULL, NULL, NULL, NULL, 'AQUAPORIN-7', 245231),
(355707, 'PTHR43829:SF8', NULL, NULL, NULL, NULL, 'AQUAPORIN OR AQUAGLYCEROPORIN RELATED', 245231),
(355708, 'PTHR43829:SF7', NULL, NULL, NULL, NULL, 'AQUAPORIN-3', 245231),
(355709, 'PTHR43829:SF14', NULL, NULL, NULL, NULL, '', 245231),
(355710, 'PTHR43829:SF25', NULL, NULL, NULL, NULL, 'AQUAPORIN-7-LIKE PROTEIN 3-RELATED', 245231),
(355711, 'PTHR43829:SF24', NULL, NULL, NULL, NULL, 'MIP AQUAPORIN (EUROFUNG)', 245231),
(355712, 'PTHR43829:SF13', NULL, NULL, NULL, NULL, 'AQUAPORIN-10', 245231),
(355713, 'PTHR43829', NULL, NULL, NULL, NULL, 'AQUAPORIN OR AQUAGLYCEROPORIN RELATED', 245231),
(355714, 'PTHR43829:SF12', NULL, NULL, NULL, NULL, 'AQUAPORIN-7-LIKE PROTEIN 3-RELATED', 245231);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(355715, 'PTHR43829:SF9', NULL, NULL, NULL, NULL, 'AQUAPORIN OR AQUAGLYCEROPORIN RELATED', 245231),
(355716, 'PTHR43829:SF4', NULL, NULL, NULL, NULL, 'AQUAPORIN OR AQUAGLYCEROPORIN RELATED', 245231),
(355717, 'PTHR43829:SF10', NULL, NULL, NULL, NULL, 'AQUAPORIN OR AQUAGLYCEROPORIN RELATED', 245231),
(355718, 'PTHR43829:SF6', NULL, NULL, NULL, NULL, 'AQUAPORIN-9', 245231),
(355719, 'PTHR43829:SF20', NULL, NULL, NULL, NULL, 'AQUAPORIN-10A', 245231),
(355720, 'PTHR43829:SF5', NULL, NULL, NULL, NULL, 'AQUAPORIN OR AQUAGLYCEROPORIN RELATED', 245231),
(355721, 'PTHR42919:SF39', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE', 245232),
(355722, 'PTHR42919:SF29', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE', 245232),
(355723, 'PTHR42919:SF26', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE', 245232),
(355724, 'PTHR42919:SF37', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE SAN ISOFORM X1-RELATED', 245232),
(355725, 'PTHR42919:SF38', NULL, NULL, NULL, NULL, 'N-ALPHA-ACETYLTRANSFERASE 50', 245232),
(355726, 'PTHR42919:SF35', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 245232),
(355727, 'PTHR42919:SF36', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 245232),
(355728, 'PTHR42919:SF33', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 245232),
(355729, 'PTHR42919:SF34', NULL, NULL, NULL, NULL, 'DTDP-FUCOSAMINE ACETYLTRANSFERASE', 245232),
(355730, 'PTHR42919:SF20', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASES (NAT) SUPERFAMILY PROTEIN', 245232),
(355731, 'PTHR42919:SF1', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 245232),
(355732, 'PTHR42919', NULL, NULL, NULL, NULL, 'N-ALPHA-ACETYLTRANSFERASE', 245232),
(355733, 'PTHR42919:SF8', NULL, NULL, NULL, NULL, 'N-ALPHA-ACETYLTRANSFERASE 50', 245232),
(355734, 'PTHR46640:SF1', NULL, NULL, NULL, NULL, 'TRIACYLGLYCEROL LIPASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G06510)-RELATED', 245233),
(355735, 'PTHR46640', NULL, NULL, NULL, NULL, 'TRIACYLGLYCEROL LIPASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G06510)-RELATED', 245233),
(355736, 'PTHR46640:SF3', NULL, NULL, NULL, NULL, 'LIPASE LIH1-RELATED', 245233),
(355737, 'PTHR34545:SF13', NULL, NULL, NULL, NULL, 'CLE FAMILY OSCLE404 PROTEIN', 245234),
(355738, 'PTHR34545:SF7', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 16', 245234),
(355739, 'PTHR34545:SF14', NULL, NULL, NULL, NULL, 'BNACNNG22250D PROTEIN', 245234),
(355740, 'PTHR34545:SF8', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 21', 245234),
(355741, 'PTHR34545:SF9', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 17', 245234),
(355742, 'PTHR34545:SF1', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 22', 245234),
(355743, 'PTHR34545', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 22', 245234),
(355744, 'PTHR34545:SF10', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE) GENE FAMILY MEMBER', 245234),
(355745, 'PTHR14166:SF15', NULL, NULL, NULL, NULL, 'SLIT-ROBO RHO GTPASE-ACTIVATING PROTEIN 1', 245235),
(355746, 'PTHR14166:SF17', NULL, NULL, NULL, NULL, 'RHO-GAP DOMAIN-CONTAINING PROTEIN', 245235),
(355747, 'PTHR14166:SF16', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 4', 245235),
(355748, 'PTHR14166:SF8', NULL, NULL, NULL, NULL, 'SLIT-ROBO RHO GTPASE-ACTIVATING PROTEIN 3', 245235),
(355749, 'PTHR14166', NULL, NULL, NULL, NULL, 'SLIT-ROBO RHO GTPASE ACTIVATING PROTEIN', 245235),
(355750, 'PTHR14166:SF6', NULL, NULL, NULL, NULL, 'SLIT-ROBO RHO GTPASE-ACTIVATING PROTEIN 2', 245235),
(355751, 'PTHR37852:SF1', NULL, NULL, NULL, NULL, 'YALI0B21208P', 245236),
(355752, 'PTHR37852', NULL, NULL, NULL, NULL, 'YALI0B21208P', 245236),
(355753, 'PTHR12323', NULL, NULL, NULL, NULL, 'SR-RELATED CTD ASSOCIATED FACTOR 6', 245237),
(355754, 'PTHR12323:SF0', NULL, NULL, NULL, NULL, 'CALCIUM HOMEOSTASIS ENDOPLASMIC RETICULUM PROTEIN', 245237),
(355755, 'PTHR32003:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAM199X', 245238),
(355756, 'PTHR32003', NULL, NULL, NULL, NULL, 'PROTEIN FAM199X', 245238),
(355757, 'PTHR13029:SF20', NULL, NULL, NULL, NULL, 'MYELIN GENE REGULATORY FACTOR-LIKE A', 245239);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(355758, 'PTHR13029:SF16', NULL, NULL, NULL, NULL, 'MYELIN REGULATORY FACTOR', 245239),
(355759, 'PTHR13029', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 245239),
(355760, 'PTHR13029:SF15', NULL, NULL, NULL, NULL, 'MYELIN REGULATORY FACTOR HOMOLOG 2', 245239),
(355761, 'PTHR13029:SF18', NULL, NULL, NULL, NULL, 'MYELIN REGULATORY FACTOR HOMOLOG 1', 245239),
(355762, 'PTHR13029:SF17', NULL, NULL, NULL, NULL, 'MYELIN REGULATORY FACTOR-LIKE PROTEIN', 245239),
(355763, 'PTHR13029:SF19', NULL, NULL, NULL, NULL, '', 245239),
(355764, 'PTHR38706:SF2', NULL, NULL, NULL, NULL, 'SI:CH211-198C19.1-RELATED', 245240),
(355765, 'PTHR38706', NULL, NULL, NULL, NULL, 'SI:CH211-198C19.1-RELATED', 245240),
(355766, 'PTHR47338:SF20', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 245241),
(355767, 'PTHR47338:SF7', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 245241),
(355768, 'PTHR47338:SF10', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 245241),
(355769, 'PTHR47338:SF6', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 245241),
(355770, 'PTHR47338:SF11', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 245241),
(355771, 'PTHR47338:SF9', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 245241),
(355772, 'PTHR47338:SF22', NULL, NULL, NULL, NULL, 'CHROMOSOME 12, WHOLE GENOME SHOTGUN SEQUENCE', 245241),
(355773, 'PTHR47338:SF23', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 245241),
(355774, 'PTHR47338:SF17', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 245241),
(355775, 'PTHR47338:SF19', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 245241),
(355776, 'PTHR47338:SF24', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR', 245241),
(355777, 'PTHR47338:SF25', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR', 245241),
(355778, 'PTHR47338', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 245241),
(355779, 'PTHR47338:SF26', NULL, NULL, NULL, NULL, 'C6 TRANSCRIPTION FACTOR', 245241),
(355780, 'PTHR47338:SF16', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G09360)-RELATED', 245241),
(355781, 'PTHR47338:SF27', NULL, NULL, NULL, NULL, 'FUNGAL_TRANS DOMAIN-CONTAINING PROTEIN-RELATED', 245241),
(355782, 'PTHR47338:SF3', NULL, NULL, NULL, NULL, 'C6 FINGER DOMAIN TRANSCRIPTION FACTOR DBAA-RELATED', 245241),
(355783, 'PTHR47338:SF5', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 245241),
(355784, 'PTHR47338:SF4', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 245241),
(355785, 'PTHR35173', NULL, NULL, NULL, NULL, '', 245242),
(355786, 'PTHR35173:SF1', NULL, NULL, NULL, NULL, '', 245242),
(355787, 'PTHR37362', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 38', 245243),
(355788, 'PTHR37362:SF1', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 38', 245243),
(355789, 'PTHR46682:SF1', NULL, NULL, NULL, NULL, 'ADHESION G-PROTEIN COUPLED RECEPTOR V1', 245244),
(355790, 'PTHR46682', NULL, NULL, NULL, NULL, 'ADHESION G-PROTEIN COUPLED RECEPTOR V1', 245244),
(355791, 'PTHR34040:SF8', NULL, NULL, NULL, NULL, 'FLAGELLAR BIOSYNTHETIC PROTEIN FLIQ', 245245),
(355792, 'PTHR34040', NULL, NULL, NULL, NULL, 'FLAGELLAR BIOSYNTHETIC PROTEIN FLIQ', 245245),
(355793, 'PTHR34040:SF2', NULL, NULL, NULL, NULL, 'FLAGELLAR BIOSYNTHETIC PROTEIN FLIQ', 245245),
(355794, 'PTHR34040:SF7', NULL, NULL, NULL, NULL, 'SURFACE PRESENTATION OF ANTIGENS PROTEIN SPAQ', 245245),
(355795, 'PTHR34040:SF4', NULL, NULL, NULL, NULL, 'SECRETION SYSTEM APPARATUS PROTEIN SSAS', 245245),
(355796, 'PTHR15704:SF8', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 245246),
(355797, 'PTHR15704', NULL, NULL, NULL, NULL, 'SUPERKILLER 3 PROTEIN-RELATED', 245246),
(355798, 'PTHR15704:SF7', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 37', 245246);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(355799, 'PTHR13220:SF11', NULL, NULL, NULL, NULL, 'TIMELESS-INTERACTING PROTEIN', 245247),
(355800, 'PTHR13220:SF12', NULL, NULL, NULL, NULL, 'CALMODULIN-REGULATED SPECTRIN-ASSOCIATED PROTEIN 3-RELATED', 245247),
(355801, 'PTHR13220:SF13', NULL, NULL, NULL, NULL, 'TIMELESS-INTERACTING PROTEIN', 245247),
(355802, 'PTHR13220:SF14', NULL, NULL, NULL, NULL, 'TIMELESS-INTERACTING PROTEIN', 245247),
(355803, 'PTHR13220:SF15', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 245247),
(355804, 'PTHR13220', NULL, NULL, NULL, NULL, 'TIMELESS INTERACTING-RELATED', 245247),
(355805, 'PTHR46180', NULL, NULL, NULL, NULL, 'VINCULIN', 245248),
(355806, 'PTHR46180:SF3', NULL, NULL, NULL, NULL, '', 245248),
(355807, 'PTHR46180:SF2', NULL, NULL, NULL, NULL, 'VINCULIN-RELATED', 245248),
(355808, 'PTHR46180:SF1', NULL, NULL, NULL, NULL, 'VINCULIN', 245248),
(355809, 'PTHR36290', NULL, NULL, NULL, NULL, 'RIKEN CDNA D630039A03 GENE', 245249),
(355810, 'PTHR36290:SF1', NULL, NULL, NULL, NULL, 'RIKEN CDNA D630039A03 GENE', 245249),
(355811, 'PTHR36059:SF3', NULL, NULL, NULL, NULL, 'BNAA03G49900D PROTEIN', 245250),
(355812, 'PTHR36059', NULL, NULL, NULL, NULL, 'OS02G0175800 PROTEIN', 245250),
(355813, 'PTHR36059:SF2', NULL, NULL, NULL, NULL, 'OS02G0175800 PROTEIN', 245250),
(355814, 'PTHR22789', NULL, NULL, NULL, NULL, 'FUCULOSE PHOSPHATE ALDOLASE', 245251),
(355815, 'PTHR22789:SF15', NULL, NULL, NULL, NULL, 'L-RIBULOSE-5-PHOSPHATE 4-EPIMERASE ARAD', 245251),
(355816, 'PTHR22789:SF9', NULL, NULL, NULL, NULL, 'L-RIBULOSE-5-PHOSPHATE 4-EPIMERASE ULAF', 245251),
(355817, 'PTHR22789:SF8', NULL, NULL, NULL, NULL, 'L-RIBULOSE-5-PHOSPHATE 4-EPIMERASE SGBE', 245251),
(355818, 'PTHR22789:SF0', NULL, NULL, NULL, NULL, '3-OXO-TETRONATE 4-PHOSPHATE DECARBOXYLASE-RELATED', 245251),
(355819, 'PTHR34717', NULL, NULL, NULL, NULL, 'EG:BACR7A4.20 PROTEIN', 245252),
(355820, 'PTHR34717:SF1', NULL, NULL, NULL, NULL, 'EG:BACR7A4.20 PROTEIN', 245252),
(355821, 'PTHR47059:SF1', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 32', 245253),
(355822, 'PTHR47059', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 32', 245253),
(355823, 'PTHR15110', NULL, NULL, NULL, NULL, 'REGULATORY FACTOR X-ASSOCIATED PROTEIN', 245254),
(355824, 'PTHR15110:SF2', NULL, NULL, NULL, NULL, 'REGULATORY FACTOR X-ASSOCIATED PROTEIN', 245254),
(355825, 'PTHR19441:SF95', NULL, NULL, NULL, NULL, 'WAP DOMAIN-CONTAINING PROTEIN', 245255),
(355826, 'PTHR19441:SF30', NULL, NULL, NULL, NULL, 'ELAFIN', 245255),
(355827, 'PTHR19441:SF96', NULL, NULL, NULL, NULL, 'WHEY ACIDIC PROTEIN', 245255),
(355828, 'PTHR19441:SF93', NULL, NULL, NULL, NULL, 'WAP DOMAIN-CONTAINING PROTEIN', 245255),
(355829, 'PTHR19441:SF71', NULL, NULL, NULL, NULL, 'WAP FOUR-DISULFIDE CORE DOMAIN 16', 245255),
(355830, 'PTHR19441:SF94', NULL, NULL, NULL, NULL, 'WAP FOUR-DISULFIDE CORE DOMAIN PROTEIN 15A', 245255),
(355831, 'PTHR19441:SF91', NULL, NULL, NULL, NULL, 'WAP DOMAIN-CONTAINING PROTEIN', 245255),
(355832, 'PTHR19441:SF92', NULL, NULL, NULL, NULL, 'WAP FOUR-DISULFIDE CORE DOMAIN PROTEIN 18', 245255),
(355833, 'PTHR19441:SF90', NULL, NULL, NULL, NULL, 'WAP FOUR-DISULFIDE CORE DOMAIN PROTEIN 13-LIKE', 245255),
(355834, 'PTHR19441:SF38', NULL, NULL, NULL, NULL, 'WAP FOUR-DISULFIDE CORE DOMAIN PROTEIN 10A', 245255),
(355835, 'PTHR19441:SF16', NULL, NULL, NULL, NULL, 'PROTEIN WFDC9', 245255),
(355836, 'PTHR19441:SF13', NULL, NULL, NULL, NULL, 'ANTILEUKOPROTEINASE-LIKE', 245255),
(355837, 'PTHR19441:SF33', NULL, NULL, NULL, NULL, 'PROTEIN WFDC21', 245255),
(355838, 'PTHR19441:SF12', NULL, NULL, NULL, NULL, 'PROTEIN WFDC11', 245255),
(355839, 'PTHR19441:SF34', NULL, NULL, NULL, NULL, 'WAP FOUR-DISULFIDE CORE DOMAIN PROTEIN 2', 245255),
(355840, 'PTHR19441:SF39', NULL, NULL, NULL, NULL, 'WAP FOUR-DISULFIDE CORE DOMAIN PROTEIN 5', 245255),
(355841, 'PTHR19441:SF17', NULL, NULL, NULL, NULL, 'PROTEIN WFDC10B', 245255),
(355842, 'PTHR19441:SF82', NULL, NULL, NULL, NULL, 'WAP FOUR-DISULFIDE CORE DOMAIN PROTEIN 3', 245255),
(355843, 'PTHR19441:SF81', NULL, NULL, NULL, NULL, 'WAP FOUR-DISULFIDE CORE DOMAIN 2', 245255); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(355844, 'PTHR19441:SF27', NULL, NULL, NULL, NULL, 'WHEY ACIDIC PROTEIN', 245255),
(355845, 'PTHR19441:SF88', NULL, NULL, NULL, NULL, 'WAP FOUR-DISULFIDE CORE DOMAIN PROTEIN 15B', 245255),
(355846, 'PTHR19441:SF44', NULL, NULL, NULL, NULL, 'ANTILEUKOPROTEINASE', 245255),
(355847, 'PTHR19441:SF22', NULL, NULL, NULL, NULL, 'WAP FOUR-DISULFIDE CORE DOMAIN PROTEIN 13', 245255),
(355848, 'PTHR19441:SF42', NULL, NULL, NULL, NULL, 'WAP FOUR-DISULFIDE CORE DOMAIN PROTEIN 12', 245255),
(355849, 'PTHR19441:SF87', NULL, NULL, NULL, NULL, 'ACTIVATED MACROPHAGE/MICROGLIA WAP DOMAIN PROTEIN', 245255),
(355850, 'PTHR19441', NULL, NULL, NULL, NULL, 'WHEY ACDIC PROTEIN  WAP', 245255),
(355851, 'PTHR23120:SF14', NULL, NULL, NULL, NULL, 'MAESTRO HEAT-LIKE REPEAT-CONTAINING PROTEIN FAMILY MEMBER 2A', 245256),
(355852, 'PTHR23120:SF39', NULL, NULL, NULL, NULL, '', 245256),
(355853, 'PTHR23120:SF17', NULL, NULL, NULL, NULL, 'MAESTRO HEAT-LIKE REPEAT-CONTAINING PROTEIN FAMILY MEMBER 7', 245256),
(355854, 'PTHR23120:SF18', NULL, NULL, NULL, NULL, 'MAESTRO HEAT-LIKE REPEAT FAMILY MEMBER 8', 245256),
(355855, 'PTHR23120', NULL, NULL, NULL, NULL, 'MAESTRO-RELATED HEAT DOMAIN-CONTAINING', 245256),
(355856, 'PTHR23120:SF0', NULL, NULL, NULL, NULL, 'MAESTRO HEAT-LIKE REPEAT FAMILY MEMBER 1', 245256),
(355857, 'PTHR23120:SF3', NULL, NULL, NULL, NULL, 'MAESTRO HEAT-LIKE REPEAT FAMILY MEMBER 4', 245256),
(355858, 'PTHR23120:SF40', NULL, NULL, NULL, NULL, 'MAESTRO HEAT-LIKE REPEAT-CONTAINING PROTEIN FAMILY MEMBER 6', 245256),
(355859, 'PTHR23120:SF42', NULL, NULL, NULL, NULL, 'MAESTRO HEAT-LIKE REPEAT FAMILY MEMBER 3', 245256),
(355860, 'PTHR23120:SF5', NULL, NULL, NULL, NULL, 'MAESTRO HEAT-LIKE REPEAT FAMILY MEMBER 9', 245256),
(355861, 'PTHR23120:SF6', NULL, NULL, NULL, NULL, 'MAESTRO HEAT-LIKE REPEAT FAMILY MEMBER 5', 245256),
(355862, 'PTHR23120:SF44', NULL, NULL, NULL, NULL, 'MAESTRO HEAT-LIKE REPEAT-CONTAINING PROTEIN FAMILY MEMBER 1', 245256),
(355863, 'PTHR23120:SF22', NULL, NULL, NULL, NULL, 'MAESTRO HEAT-LIKE REPEAT-CONTAINING PROTEIN FAMILY MEMBER 2B', 245256),
(355864, 'PTHR23120:SF46', NULL, NULL, NULL, NULL, '', 245256),
(355865, 'PTHR23120:SF45', NULL, NULL, NULL, NULL, 'MAESTRO HEAT-LIKE REPEAT-CONTAINING PROTEIN FAMILY MEMBER 1', 245256),
(355866, 'PTHR28077', NULL, NULL, NULL, NULL, 'INOSITOL PHOSPHORYLCERAMIDE SYNTHASE REGULATORY SUBUNIT KEI1', 245257),
(355867, 'PTHR28077:SF1', NULL, NULL, NULL, NULL, 'INOSITOL PHOSPHORYLCERAMIDE SYNTHASE REGULATORY SUBUNIT KEI1', 245257),
(355868, 'PTHR15267:SF1', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR LIGAND SUPERFAMILY MEMBER 18', 245258),
(355869, 'PTHR15267', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR LIGAND SUPERFAMILY MEMBER 18', 245258),
(355870, 'PTHR43939:SF120', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 245259),
(355871, 'PTHR43939:SF101', NULL, NULL, NULL, NULL, 'STRUCTURAL MAINTENANCE OF CHROMOSOMES PROTEIN 4', 245259),
(355872, 'PTHR43939:SF107', NULL, NULL, NULL, NULL, '', 245259),
(355873, 'PTHR43939:SF106', NULL, NULL, NULL, NULL, 'C2 NT-TYPE DOMAIN-CONTAINING PROTEIN', 245259),
(355874, 'PTHR43939:SF109', NULL, NULL, NULL, NULL, '', 245259),
(355875, 'PTHR43939:SF108', NULL, NULL, NULL, NULL, 'JAVELIN-LIKE, ISOFORM D', 245259),
(355876, 'PTHR43939:SF103', NULL, NULL, NULL, NULL, 'SPINDLE POLE PROTEIN-RELATED', 245259),
(355877, 'PTHR43939:SF102', NULL, NULL, NULL, NULL, 'UDS1 DOMAIN-CONTAINING PROTEIN', 245259),
(355878, 'PTHR43939:SF105', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 245259),
(355879, 'PTHR43939:SF104', NULL, NULL, NULL, NULL, 'SPINDLE APPARATUS PROTEIN LIN-5', 245259),
(355880, 'PTHR43939:SF57', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN-LIKE', 245259),
(355881, 'PTHR43939:SF96', NULL, NULL, NULL, NULL, '', 245259),
(355882, 'PTHR43939:SF50', NULL, NULL, NULL, NULL, 'NUCLEOPORIN', 245259),
(355883, 'PTHR43939', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 158', 245259),
(355884, 'PTHR43939:SF110', NULL, NULL, NULL, NULL, 'BNAA01G34800D PROTEIN', 245259),
(355885, 'PTHR43939:SF112', NULL, NULL, NULL, NULL, '', 245259);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(355886, 'PTHR43939:SF111', NULL, NULL, NULL, NULL, '', 245259),
(355887, 'PTHR43939:SF118', NULL, NULL, NULL, NULL, 'MAR-BINDING FILAMENT-LIKE PROTEIN 1', 245259),
(355888, 'PTHR43939:SF117', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245259),
(355889, 'PTHR43939:SF119', NULL, NULL, NULL, NULL, 'BACULOVIRAL IAP REPEAT CONTAINING 6', 245259),
(355890, 'PTHR43939:SF114', NULL, NULL, NULL, NULL, 'ASTERLESS', 245259),
(355891, 'PTHR43939:SF113', NULL, NULL, NULL, NULL, '', 245259),
(355892, 'PTHR43939:SF116', NULL, NULL, NULL, NULL, 'GAF DOMAIN-CONTAINING PROTEIN', 245259),
(355893, 'PTHR43939:SF115', NULL, NULL, NULL, NULL, 'OS01G0180300 PROTEIN', 245259),
(355894, 'PTHR43939:SF68', NULL, NULL, NULL, NULL, 'CENTROMERE-ASSOCIATED PROTEIN E-LIKE', 245259),
(355895, 'PTHR43939:SF44', NULL, NULL, NULL, NULL, 'PROTEIN CBG16903', 245259),
(355896, 'PTHR43939:SF83', NULL, NULL, NULL, NULL, 'MAR-BINDING FILAMENT-LIKE PROTEIN 1', 245259),
(355897, 'PTHR13407:SF1', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 121', 245260),
(355898, 'PTHR13407', NULL, NULL, NULL, NULL, 'RNF121 PROTEIN', 245260),
(355899, 'PTHR13407:SF0', NULL, NULL, NULL, NULL, 'FI05221P', 245260),
(355900, 'PTHR13407:SF2', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 175', 245260),
(355901, 'PTHR34453:SF5', NULL, NULL, NULL, NULL, 'BNAC02G01190D PROTEIN', 245261),
(355902, 'PTHR34453:SF4', NULL, NULL, NULL, NULL, '', 245261),
(355903, 'PTHR34453', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE (DEFL) FAMILY PROTEIN-RELATED', 245261),
(355904, 'PTHR34453:SF3', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE (DEFL) FAMILY PROTEIN-RELATED', 245261),
(355905, 'PTHR34453:SF8', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 24', 245261),
(355906, 'PTHR34453:SF7', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 22-RELATED', 245261),
(355907, 'PTHR34453:SF6', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 23-RELATED', 245261),
(355908, 'PTHR12446:SF60', NULL, NULL, NULL, NULL, 'PROTEIN TESMIN/TSO1-LIKE CXC 8', 245262),
(355909, 'PTHR12446:SF62', NULL, NULL, NULL, NULL, 'TESMIN/TSO1-LIKE CXC DOMAIN PROTEIN', 245262),
(355910, 'PTHR12446:SF63', NULL, NULL, NULL, NULL, 'CRC DOMAIN-CONTAINING PROTEIN', 245262),
(355911, 'PTHR12446:SF64', NULL, NULL, NULL, NULL, 'TESMIN/TSO1-LIKE CXC DOMAIN-CONTAINING PROTEIN', 245262),
(355912, 'PTHR12446:SF54', NULL, NULL, NULL, NULL, 'BNAA08G30730D PROTEIN', 245262),
(355913, 'PTHR12446:SF22', NULL, NULL, NULL, NULL, 'TESMIN', 245262),
(355914, 'PTHR12446:SF55', NULL, NULL, NULL, NULL, 'BNAA04G10170D PROTEIN', 245262),
(355915, 'PTHR12446:SF56', NULL, NULL, NULL, NULL, 'BNAA07G00040D PROTEIN', 245262),
(355916, 'PTHR12446:SF34', NULL, NULL, NULL, NULL, 'PROTEIN LIN-54 HOMOLOG', 245262),
(355917, 'PTHR12446:SF57', NULL, NULL, NULL, NULL, 'CRC DOMAIN-CONTAINING PROTEIN', 245262),
(355918, 'PTHR12446:SF46', NULL, NULL, NULL, NULL, 'PROTEIN TESMIN/TSO1-LIKE CXC 7', 245262),
(355919, 'PTHR12446:SF35', NULL, NULL, NULL, NULL, 'CPP TRANSCRIPTION FACTOR', 245262),
(355920, 'PTHR12446:SF58', NULL, NULL, NULL, NULL, 'OS06G0332700 PROTEIN', 245262),
(355921, 'PTHR12446:SF47', NULL, NULL, NULL, NULL, 'CRC DOMAIN-CONTAINING PROTEIN', 245262),
(355922, 'PTHR12446:SF36', NULL, NULL, NULL, NULL, 'PROTEIN LIN-54 HOMOLOG', 245262),
(355923, 'PTHR12446', NULL, NULL, NULL, NULL, 'TESMIN/TSO1-RELATED', 245262),
(355924, 'PTHR12446:SF49', NULL, NULL, NULL, NULL, 'CRC DOMAIN-CONTAINING PROTEIN', 245262),
(355925, 'PTHR41294', NULL, NULL, NULL, NULL, 'CADMIUM-INDUCED PROTEIN CADI', 245263),
(355926, 'PTHR41294:SF1', NULL, NULL, NULL, NULL, 'CADMIUM-INDUCED PROTEIN CADI', 245263),
(355927, 'PTHR28617', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 77', 245264),
(355928, 'PTHR28617:SF1', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 77', 245264),
(355929, 'PTHR43183:SF1', NULL, NULL, NULL, NULL, 'HYPOTHETICAL DIHYDROXY-ACID DEHYDRATASE (EUROFUNG)-RELATED', 245265),
(355930, 'PTHR43183:SF2', NULL, NULL, NULL, NULL, 'DIHYDROXY-ACID DEHYDRATASE', 245265),
(355931, 'PTHR43183', NULL, NULL, NULL, NULL, 'HYPOTHETICAL DIHYDROXYACID DEHYDRATASE (EUROFUNG)-RELATED', 245265);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(355932, 'PTHR14917', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 7', 245266),
(355933, 'PTHR14917:SF3', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 7 HOMOLOG', 245266),
(355934, 'PTHR14917:SF4', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED 7', 245266),
(355935, 'PTHR14917:SF2', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 7', 245266),
(355936, 'PTHR31673:SF3', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN 4', 245267),
(355937, 'PTHR31673:SF53', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN', 245267),
(355938, 'PTHR31673:SF30', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN 6', 245267),
(355939, 'PTHR31673:SF52', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN', 245267),
(355940, 'PTHR31673:SF55', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN 5', 245267),
(355941, 'PTHR31673:SF33', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN', 245267),
(355942, 'PTHR31673:SF32', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN', 245267),
(355943, 'PTHR31673:SF54', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN', 245267),
(355944, 'PTHR31673:SF50', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN', 245267),
(355945, 'PTHR31673:SF9', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN 6', 245267),
(355946, 'PTHR31673:SF39', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN 5', 245267),
(355947, 'PTHR31673:SF38', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN', 245267),
(355948, 'PTHR31673:SF57', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN', 245267),
(355949, 'PTHR31673:SF59', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN', 245267),
(355950, 'PTHR31673:SF36', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN', 245267),
(355951, 'PTHR31673:SF58', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN', 245267),
(355952, 'PTHR31673:SF42', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN', 245267),
(355953, 'PTHR31673:SF41', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN', 245267),
(355954, 'PTHR31673:SF43', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN 2', 245267),
(355955, 'PTHR31673:SF60', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN', 245267),
(355956, 'PTHR31673:SF62', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN 2', 245267),
(355957, 'PTHR31673:SF61', NULL, NULL, NULL, NULL, 'PROTEIN COBRA', 245267),
(355958, 'PTHR31673:SF28', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN 4', 245267),
(355959, 'PTHR31673:SF27', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN', 245267),
(355960, 'PTHR31673:SF23', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN 4', 245267),
(355961, 'PTHR31673:SF45', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN 1', 245267),
(355962, 'PTHR31673:SF48', NULL, NULL, NULL, NULL, 'COBRA, PLANT-RELATED', 245267),
(355963, 'PTHR31673:SF26', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN', 245267),
(355964, 'PTHR31673', NULL, NULL, NULL, NULL, 'PROTEIN COBRA', 245267),
(355965, 'PTHR31673:SF47', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN', 245267),
(355966, 'PTHR30047', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY CHOLINE TRANSPORT PROTEIN-RELATED', 245268),
(355967, 'PTHR30047:SF7', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY CHOLINE TRANSPORT PROTEIN', 245268),
(355968, 'PTHR30047:SF12', NULL, NULL, NULL, NULL, 'BCCT-FAMILY TRANSPORTER-RELATED', 245268),
(355969, 'PTHR30047:SF11', NULL, NULL, NULL, NULL, 'L-CARNITINE/GAMMA-BUTYROBETAINE ANTIPORTER', 245268),
(355970, 'PTHR31432:SF0', NULL, NULL, NULL, NULL, 'INTRAFLAGELLAR TRANSPORT PROTEIN 74 HOMOLOG', 245269),
(355971, 'PTHR31432', NULL, NULL, NULL, NULL, 'INTRAFLAGELLAR TRANSPORT PROTEIN 74 HOMOLOG', 245269),
(355972, 'PTHR32243:SF18', NULL, NULL, NULL, NULL, 'INNER MEMBRANE ABC TRANSPORTER PERMEASE PROTEIN YCJP', 245270),
(355973, 'PTHR32243:SF52', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN', 245270),
(355974, 'PTHR32243:SF3', NULL, NULL, NULL, NULL, 'BINDING-PROTEIN-DEPENDENT TRANSPORT SYSTEMS INNER MEMBRANE COMPONENT', 245270),
(355975, 'PTHR32243:SF50', NULL, NULL, NULL, NULL, 'MALTOSE/MALTODEXTRIN TRANSPORT SYSTEM PERMEASE PROTEIN MALG', 245270),
(355976, 'PTHR32243:SF34', NULL, NULL, NULL, NULL, 'GALACTOOLIGOSACCHARIDES TRANSPORT SYSTEM PERMEASE PROTEIN GANQ', 245270);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(355977, 'PTHR32243:SF24', NULL, NULL, NULL, NULL, 'DIACETYLCHITOBIOSE UPTAKE SYSTEM PERMEASE PROTEIN NGCG', 245270),
(355978, 'PTHR32243', NULL, NULL, NULL, NULL, 'MALTOSE TRANSPORT SYSTEM PERMEASE-RELATED', 245270),
(355979, 'PTHR22772:SF4', NULL, NULL, NULL, NULL, 'ZINC FINGER ZZ-TYPE AND EF-HAND DOMAIN-CONTAINING PROTEIN 1', 245271),
(355980, 'PTHR22772:SF5', NULL, NULL, NULL, NULL, 'HECT DOMAIN-CONTAINING PROTEIN', 245271),
(355981, 'PTHR22772', NULL, NULL, NULL, NULL, 'NOVEL ZZ TYPE ZINC FINGER DOMAIN CONTAINING PROTEIN', 245271),
(355982, 'PTHR35562:SF1', NULL, NULL, NULL, NULL, 'UPF0115 PROTEIN YFCN', 245272),
(355983, 'PTHR35562:SF2', NULL, NULL, NULL, NULL, 'DNA ENDONUCLEASE SMRA-RELATED', 245272),
(355984, 'PTHR35562', NULL, NULL, NULL, NULL, 'DNA ENDONUCLEASE SMRA-RELATED', 245272),
(355985, 'PTHR47217:SF1', NULL, NULL, NULL, NULL, 'GLOBIN-LIKE PROTEIN', 245273),
(355986, 'PTHR47217', NULL, NULL, NULL, NULL, 'GLOBIN-LIKE PROTEIN', 245273),
(355987, 'PTHR37029:SF1', NULL, NULL, NULL, NULL, 'SSR1768 PROTEIN', 245274),
(355988, 'PTHR37029', NULL, NULL, NULL, NULL, 'SSR1768 PROTEIN', 245274),
(355989, 'PTHR10351:SF70', NULL, NULL, NULL, NULL, 'NASCENT POLYPEPTIDE-ASSOCIATED COMPLEX SUBUNIT BETA', 245275),
(355990, 'PTHR10351:SF71', NULL, NULL, NULL, NULL, 'NASCENT POLYPEPTIDE-ASSOCIATED COMPLEX SUBUNIT BETA', 245275),
(355991, 'PTHR10351:SF61', NULL, NULL, NULL, NULL, 'NASCENT POLYPEPTIDE-ASSOCIATED COMPLEX SUBUNIT BETA', 245275),
(355992, 'PTHR10351:SF72', NULL, NULL, NULL, NULL, 'NASCENT POLYPEPTIDE-ASSOCIATED COMPLEX SUBUNIT BETA', 245275),
(355993, 'PTHR10351:SF73', NULL, NULL, NULL, NULL, 'NASCENT POLYPEPTIDE-ASSOCIATED COMPLEX SUBUNIT BETA', 245275),
(355994, 'PTHR10351:SF23', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BTF3', 245275),
(355995, 'PTHR10351:SF56', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BTF3', 245275),
(355996, 'PTHR10351:SF68', NULL, NULL, NULL, NULL, 'NASCENT POLYPEPTIDE-ASSOCIATED COMPLEX SUBUNIT BETA', 245275),
(355997, 'PTHR10351:SF57', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BTF3', 245275),
(355998, 'PTHR10351:SF59', NULL, NULL, NULL, NULL, 'NASCENT POLYPEPTIDE-ASSOCIATED COMPLEX SUBUNIT BETA', 245275),
(355999, 'PTHR10351:SF64', NULL, NULL, NULL, NULL, 'NASCENT POLYPEPTIDE-ASSOCIATED COMPLEX SUBUNIT BETA', 245275),
(356000, 'PTHR10351:SF54', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BTF3', 245275),
(356001, 'PTHR10351:SF65', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BTF3', 245275),
(356002, 'PTHR10351:SF55', NULL, NULL, NULL, NULL, 'NASCENT POLYPEPTIDE-ASSOCIATED COMPLEX SUBUNIT BETA', 245275),
(356003, 'PTHR10351:SF66', NULL, NULL, NULL, NULL, 'NASCENT POLYPEPTIDE-ASSOCIATED COMPLEX SUBUNIT BETA', 245275),
(356004, 'PTHR10351:SF28', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BTF3', 245275),
(356005, 'PTHR10351:SF29', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BTF3 HOMOLOG 4', 245275),
(356006, 'PTHR10351', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BTF3 FAMILY MEMBER', 245275),
(356007, 'PTHR24369:SF8', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 4C', 245276),
(356008, 'PTHR24369:SF9', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 4', 245276),
(356009, 'PTHR24369:SF209', NULL, NULL, NULL, NULL, 'LRRCT DOMAIN-CONTAINING PROTEIN', 245276),
(356010, 'PTHR24369:SF207', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 245276),
(356011, 'PTHR24369:SF208', NULL, NULL, NULL, NULL, 'PROTEIN SINGED WINGS 2', 245276),
(356012, 'PTHR24369:SF205', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 245276),
(356013, 'PTHR24369:SF206', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT CONTAINING 17', 245276),
(356014, 'PTHR24369:SF203', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 245276),
(356015, 'PTHR24369:SF204', NULL, NULL, NULL, NULL, 'LRRCT DOMAIN-CONTAINING PROTEIN', 245276),
(356016, 'PTHR24369:SF102', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 4B', 245276),
(356017, 'PTHR24369:SF201', NULL, NULL, NULL, NULL, 'INSULIN LIKE GROWTH FACTOR BINDING PROTEIN ACID LABILE SUBUNIT', 245276);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(356018, 'PTHR24369:SF163', NULL, NULL, NULL, NULL, 'MATRIX-REMODELLING-ASSOCIATED 5B', 245276),
(356019, 'PTHR24369:SF160', NULL, NULL, NULL, NULL, 'VASORIN', 245276),
(356020, 'PTHR24369:SF161', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 53', 245276),
(356021, 'PTHR24369', NULL, NULL, NULL, NULL, 'ANTIGEN BSP, PUTATIVE-RELATED', 245276),
(356022, 'PTHR24369:SF157', NULL, NULL, NULL, NULL, 'PLATELET GLYCOPROTEIN IB ALPHA CHAIN', 245276),
(356023, 'PTHR24369:SF210', NULL, NULL, NULL, NULL, 'CHAOPTIN-RELATED', 245276),
(356024, 'PTHR24369:SF155', NULL, NULL, NULL, NULL, 'PROTEIN WINDPIPE', 245276),
(356025, 'PTHR24369:SF156', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT AND IG DOMAIN CONTAINING 2', 245276),
(356026, 'PTHR24369:SF178', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT AND IG DOMAIN CONTAINING 1', 245276),
(356027, 'PTHR24369:SF175', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEATS AND TRANSMEMBRANE DOMAINS 2', 245276),
(356028, 'PTHR24369:SF154', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING 4.1', 245276),
(356029, 'PTHR24369:SF198', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND FIBRONECTIN TYPE-III DOMAIN-CONTAINING PROTEIN 2-LIKE', 245276),
(356030, 'PTHR24369:SF174', NULL, NULL, NULL, NULL, 'RETICULON-4 RECEPTOR', 245276),
(356031, 'PTHR24369:SF196', NULL, NULL, NULL, NULL, 'SLIT HOMOLOG 1B (DROSOPHILA)', 245276),
(356032, 'PTHR24369:SF193', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT CONTAINING 8 VRAC SUBUNIT C', 245276),
(356033, 'PTHR24369:SF172', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT AND FIBRONECTIN TYPE III DOMAIN CONTAINING 1', 245276),
(356034, 'PTHR24369:SF170', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 3', 245276),
(356035, 'PTHR24370', NULL, NULL, NULL, NULL, 'OPTICIN', 245277),
(356036, 'PTHR24370:SF10', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND WD REPEAT-CONTAINING PROTEIN 1', 245277),
(356037, 'PTHR30408:SF13', NULL, NULL, NULL, NULL, 'TYPE-1 RESTRICTION ENZYME HINDVIIP SPECIFICITY PROTEIN-RELATED', 245278),
(356038, 'PTHR30408:SF12', NULL, NULL, NULL, NULL, 'TYPE-1 RESTRICTION ENZYME MJAXIP SPECIFICITY PROTEIN', 245278),
(356039, 'PTHR30408', NULL, NULL, NULL, NULL, 'TYPE-1 RESTRICTION ENZYME ECOKI SPECIFICITY PROTEIN', 245278),
(356040, 'PTHR32163:SF1', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR LIGAND SUPERFAMILY MEMBER 8', 245279),
(356041, 'PTHR32163', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR LIGAND SUPERFAMILY MEMBER 8', 245279),
(356042, 'PTHR40613', NULL, NULL, NULL, NULL, '', 245280),
(356043, 'PTHR40613:SF1', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 245280),
(356044, 'PTHR37878:SF1', NULL, NULL, NULL, NULL, 'RCG33933', 245281),
(356045, 'PTHR37878', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC689039', 245281),
(356046, 'PTHR33279:SF2', NULL, NULL, NULL, NULL, 'SULFUR CARRIER PROTEIN TUSA', 245282),
(356047, 'PTHR33279:SF16', NULL, NULL, NULL, NULL, 'SIRA FAMILY PROTEIN', 245282),
(356048, 'PTHR33279:SF17', NULL, NULL, NULL, NULL, 'SULFUR CARRIER PROTEIN YEDF-RELATED', 245282),
(356049, 'PTHR33279', NULL, NULL, NULL, NULL, 'SULFUR CARRIER PROTEIN YEDF-RELATED', 245282),
(356050, 'PTHR33279:SF6', NULL, NULL, NULL, NULL, 'SULFUR CARRIER PROTEIN TM_0983-RELATED', 245282),
(356051, 'PTHR33279:SF15', NULL, NULL, NULL, NULL, 'SULFUR CARRIER PROTEIN YRKF-RELATED', 245282),
(356052, 'PTHR34094', NULL, NULL, NULL, NULL, '', 245283),
(356053, 'PTHR34094:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAM185A', 245283),
(356054, 'PTHR12448:SF1', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT EPSILON, MITOCHONDRIAL', 245284),
(356055, 'PTHR12448', NULL, NULL, NULL, NULL, 'ATP SYNTHASE EPSILON CHAIN, MITOCHONDRIAL', 245284),
(356056, 'PTHR12448:SF0', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT EPSILON, MITOCHONDRIAL', 245284),
(356057, 'PTHR12448:SF3', NULL, NULL, NULL, NULL, '', 245284),
(356058, 'PTHR12448:SF2', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT EPSILON-LIKE PROTEIN, MITOCHONDRIAL', 245284),
(356059, 'PTHR12448:SF7', NULL, NULL, NULL, NULL, 'BNAA08G01880D PROTEIN', 245284);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(356060, 'PTHR12448:SF6', NULL, NULL, NULL, NULL, 'BNAC01G32170D PROTEIN', 245284),
(356061, 'PTHR13360', NULL, NULL, NULL, NULL, 'ACTIVATING SIGNAL COINTEGRATOR 1 COMPLEX SUBUNIT 1', 245285),
(356062, 'PTHR13360:SF1', NULL, NULL, NULL, NULL, 'ACTIVATING SIGNAL COINTEGRATOR 1 COMPLEX SUBUNIT 1', 245285),
(356063, 'PTHR13360:SF3', NULL, NULL, NULL, NULL, 'AKAP7_NLS DOMAIN-CONTAINING PROTEIN', 245285),
(356064, 'PTHR13360:SF2', NULL, NULL, NULL, NULL, 'BNAA01G28130D PROTEIN', 245285),
(356065, 'PTHR42069', NULL, NULL, NULL, NULL, 'HYPHAL ANASTAMOSIS-8 PROTEIN', 245286),
(356066, 'PTHR42069:SF1', NULL, NULL, NULL, NULL, 'HYPHAL ANASTAMOSIS-8 PROTEIN', 245286),
(356067, 'PTHR46669:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG23538', 245287),
(356068, 'PTHR46669', NULL, NULL, NULL, NULL, 'LEUCINE-RICH PPR MOTIF-CONTAINING PROTEIN, MITOCHONDRIAL', 245287),
(356069, 'PTHR46669:SF2', NULL, NULL, NULL, NULL, 'EG:BACN32G11.3 PROTEIN', 245287),
(356070, 'PTHR46669:SF1', NULL, NULL, NULL, NULL, 'LEUCINE-RICH PPR MOTIF-CONTAINING PROTEIN, MITOCHONDRIAL', 245287),
(356071, 'PTHR35578:SF6', NULL, NULL, NULL, NULL, 'PROLINE-RICH TRANSMEMBRANE PROTEIN 4', 245288),
(356072, 'PTHR35578', NULL, NULL, NULL, NULL, 'PROLINE-RICH TRANSMEMBRANE PROTEIN 4-RELATED', 245288),
(356073, 'PTHR47705', NULL, NULL, NULL, NULL, 'AGAP000321-PA', 245289),
(356074, 'PTHR47705:SF1', NULL, NULL, NULL, NULL, 'METHYLTRANSF_FA DOMAIN-CONTAINING PROTEIN', 245289),
(356075, 'PTHR24223:SF339', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY C MEMBER 6', 245290),
(356076, 'PTHR24223:SF215', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER C FAMILY MEMBER 4', 245290),
(356077, 'PTHR24223:SF335', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER (EUROFUNG)', 245290),
(356078, 'PTHR24223:SF334', NULL, NULL, NULL, NULL, 'FI20190P1', 245290),
(356079, 'PTHR24223:SF333', NULL, NULL, NULL, NULL, 'PROTEIN CBR-MRP-8', 245290),
(356080, 'PTHR24223:SF453', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER', 245290),
(356081, 'PTHR24223:SF452', NULL, NULL, NULL, NULL, 'SULFONYLUREA RECEPTOR, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 245290),
(356082, 'PTHR24223:SF451', NULL, NULL, NULL, NULL, 'AFR432WP', 245290),
(356083, 'PTHR24223:SF330', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY C MEMBER 10', 245290),
(356084, 'PTHR24223:SF176', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY C MEMBER 2', 245290),
(356085, 'PTHR24223:SF450', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE-ASSOCIATED PROTEIN 2, 6 (MRP2, 6), ABC-TRANSOPRTER', 245290),
(356086, 'PTHR24223:SF173', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY C MEMBER 9', 245290),
(356087, 'PTHR24223:SF172', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER C FAMILY MEMBER 1-RELATED', 245290),
(356088, 'PTHR24223:SF108', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER C FAMILY MEMBER 8', 245290),
(356089, 'PTHR24223:SF348', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER C FAMILY PROTEIN', 245290),
(356090, 'PTHR24223:SF345', NULL, NULL, NULL, NULL, 'MULTIDRUG TRANSPORTER, PUTATIVE-RELATED', 245290),
(356091, 'PTHR24223:SF189', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER C FAMILY MEMBER 5', 245290),
(356092, 'PTHR24223:SF222', NULL, NULL, NULL, NULL, 'OS01G0902100 PROTEIN', 245290),
(356093, 'PTHR24223:SF343', NULL, NULL, NULL, NULL, 'CYSTIC FIBROSIS TRANSMEMBRANE CONDUCTANCE REGULATOR HOMOLOG', 245290),
(356094, 'PTHR24223:SF342', NULL, NULL, NULL, NULL, 'PROTEIN CBG08354', 245290),
(356095, 'PTHR24223:SF187', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY C MEMBER 8', 245290),
(356096, 'PTHR24223:SF181', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER C FAMILY MEMBER 3', 245290),
(356097, 'PTHR24223:SF358', NULL, NULL, NULL, NULL, 'PROTEIN CBR-MRP-3', 245290),
(356098, 'PTHR24223:SF357', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY C MEMBER 4', 245290),
(356099, 'PTHR24223:SF356', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE TRANSPORTER ABC4', 245290),
(356100, 'PTHR24223:SF355', NULL, NULL, NULL, NULL, 'SI:CH211-221F10.2', 245290),
(356101, 'PTHR24223:SF354', NULL, NULL, NULL, NULL, 'BILE ACID TRANSPORTER, PUTATIVE (EUROFUNG)-RELATED', 245290);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(356102, 'PTHR24223:SF353', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN/PERMEASE VMR1-RELATED', 245290),
(356103, 'PTHR24223:SF230', NULL, NULL, NULL, NULL, 'OS04G0209300 PROTEIN', 245290),
(356104, 'PTHR24223:SF196', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE-ASSOCIATED PROTEIN 5', 245290),
(356105, 'PTHR24223:SF405', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY C MEMBER 3', 245290),
(356106, 'PTHR24223:SF404', NULL, NULL, NULL, NULL, 'ABC MULTIDRUG TRANSPORTER (EUROFUNG)-RELATED', 245290),
(356107, 'PTHR24223:SF249', NULL, NULL, NULL, NULL, 'OS02G0288700 PROTEIN', 245290),
(356108, 'PTHR24223:SF403', NULL, NULL, NULL, NULL, 'BNAA05G17490D PROTEIN', 245290),
(356109, 'PTHR24223:SF369', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER C FAMILY MEMBER 10', 245290),
(356110, 'PTHR24223:SF368', NULL, NULL, NULL, NULL, 'BILE ACID TRANSPORTER, PUTATIVE (EUROFUNG)-RELATED', 245290),
(356111, 'PTHR24223:SF401', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE TRANSPORTER SUBFAMILY C', 245290),
(356112, 'PTHR24223:SF367', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER C FAMILY PROTEIN', 245290),
(356113, 'PTHR24223:SF400', NULL, NULL, NULL, NULL, 'BNAC05G23280D PROTEIN', 245290),
(356114, 'PTHR24223:SF366', NULL, NULL, NULL, NULL, '', 245290),
(356115, 'PTHR24223:SF364', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER C FAMILY MEMBER 6', 245290),
(356116, 'PTHR24223:SF363', NULL, NULL, NULL, NULL, '', 245290),
(356117, 'PTHR24223:SF241', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE-ASSOCIATED PROTEIN 1', 245290),
(356118, 'PTHR24223:SF362', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER C FAMILY MEMBER 4', 245290),
(356119, 'PTHR24223:SF409', NULL, NULL, NULL, NULL, 'BNAA01G30260D PROTEIN', 245290),
(356120, 'PTHR24223:SF407', NULL, NULL, NULL, NULL, 'BNAA01G30060D PROTEIN', 245290),
(356121, 'PTHR24223:SF416', NULL, NULL, NULL, NULL, 'BNAA09G10230D PROTEIN', 245290),
(356122, 'PTHR24223:SF415', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER C FAMILY', 245290),
(356123, 'PTHR24223:SF379', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER C FAMILY MEMBER 1', 245290),
(356124, 'PTHR24223:SF377', NULL, NULL, NULL, NULL, '', 245290),
(356125, 'PTHR24223:SF410', NULL, NULL, NULL, NULL, 'BNAA01G25250D PROTEIN', 245290),
(356126, 'PTHR24223:SF375', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER C FAMILY MEMBER 11-RELATED', 245290),
(356127, 'PTHR24223:SF374', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER C FAMILY MEMBER 3', 245290),
(356128, 'PTHR24223:SF371', NULL, NULL, NULL, NULL, 'ABC TRANSMEMBRANE TYPE-1 DOMAIN-CONTAINING PROTEIN', 245290),
(356129, 'PTHR24223:SF418', NULL, NULL, NULL, NULL, 'BNAC05G23300D PROTEIN', 245290),
(356130, 'PTHR24223:SF417', NULL, NULL, NULL, NULL, '', 245290),
(356131, 'PTHR24223:SF426', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER TAP-LIKE, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 245290),
(356132, 'PTHR24223:SF425', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE-ASSOCIATED PROTEIN 3-RELATED', 245290),
(356133, 'PTHR24223:SF269', NULL, NULL, NULL, NULL, 'ABC MULTIDRUG TRANSPORTER (EUROFUNG)', 245290),
(356134, 'PTHR24223:SF422', NULL, NULL, NULL, NULL, 'OS12G0562700 PROTEIN', 245290),
(356135, 'PTHR24223:SF421', NULL, NULL, NULL, NULL, '', 245290),
(356136, 'PTHR24223:SF388', NULL, NULL, NULL, NULL, 'OS05G0196100 PROTEIN', 245290),
(356137, 'PTHR24223:SF387', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER C FAMILY MEMBER 7', 245290),
(356138, 'PTHR24223:SF19', NULL, NULL, NULL, NULL, 'CYSTIC FIBROSIS TRANSMEMBRANE CONDUCTANCE REGULATOR', 245290),
(356139, 'PTHR24223:SF386', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER C FAMILY MEMBER 14-LIKE', 245290),
(356140, 'PTHR24223:SF263', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER C FAMILY MEMBER 10-LIKE', 245290),
(356141, 'PTHR24223:SF383', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER C FAMILY MEMBER 14', 245290),
(356142, 'PTHR24223:SF382', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN ABC TRANSPORTER FAMILY PROTEIN', 245290),
(356143, 'PTHR24223:SF380', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN ABC TRANSPORTER FAMILY PROTEIN', 245290);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(356144, 'PTHR24223:SF10', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY C MEMBER 12', 245290),
(356145, 'PTHR24223:SF428', NULL, NULL, NULL, NULL, 'ABC MULTIDRUG TRANSPORTER (EUROFUNG)', 245290),
(356146, 'PTHR24223:SF438', NULL, NULL, NULL, NULL, '', 245290),
(356147, 'PTHR24223:SF434', NULL, NULL, NULL, NULL, 'PROTEIN CBG23578', 245290),
(356148, 'PTHR24223:SF399', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATNG', 245290),
(356149, 'PTHR24223:SF398', NULL, NULL, NULL, NULL, 'PROTEIN CBR-MRP-2', 245290),
(356150, 'PTHR24223:SF431', NULL, NULL, NULL, NULL, '', 245290),
(356151, 'PTHR24223:SF430', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE-ASSOCIATED PROTEIN 6-RELATED', 245290),
(356152, 'PTHR24223:SF397', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE ASSOCIATED PROTEIN MRP2', 245290),
(356153, 'PTHR24223:SF273', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN A', 245290),
(356154, 'PTHR24223:SF392', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER C FAMILY MEMBER 10-LIKE', 245290),
(356155, 'PTHR24223:SF391', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN ABC TRANSPORTER FAMILY PROTEIN', 245290),
(356156, 'PTHR24223:SF449', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER C FAMILY MEMBER 9', 245290),
(356157, 'PTHR24223:SF448', NULL, NULL, NULL, NULL, 'FI20146P1-RELATED', 245290),
(356158, 'PTHR24223:SF447', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE-ASSOCIATED PROTEIN 5', 245290),
(356159, 'PTHR24223:SF446', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER C FAMILY MEMBER 10-LIKE', 245290),
(356160, 'PTHR24223:SF324', NULL, NULL, NULL, NULL, 'LD17001P', 245290),
(356161, 'PTHR24223:SF445', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE TRANSPORTER, SUBFAMILY C, MEMBER 4, SMABCC4', 245290),
(356162, 'PTHR24223:SF444', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE TRANSPORTER ABC1', 245290),
(356163, 'PTHR24223:SF443', NULL, NULL, NULL, NULL, 'MULTIDRUG-RESISTANCE LIKE PROTEIN 1, ISOFORM I', 245290),
(356164, 'PTHR24223:SF168', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY C MEMBER 11', 245290),
(356165, 'PTHR24223:SF442', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY C MEMBER SUR', 245290),
(356166, 'PTHR24223:SF166', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE, SUB-FAMILY C (CFTR/MRP), MEMBER 13', 245290),
(356167, 'PTHR24223:SF441', NULL, NULL, NULL, NULL, '', 245290),
(356168, 'PTHR24223:SF440', NULL, NULL, NULL, NULL, '', 245290),
(356169, 'PTHR24223:SF165', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER C FAMILY MEMBER 15-RELATED', 245290),
(356170, 'PTHR24223', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY C', 245290),
(356171, 'PTHR24223:SF329', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER C FAMILY MEMBER 10-RELATED', 245290),
(356172, 'PTHR23259:SF71', NULL, NULL, NULL, NULL, 'GH03322P1', 245291),
(356173, 'PTHR23259:SF60', NULL, NULL, NULL, NULL, 'TIL DOMAIN-CONTAINING PROTEIN', 245291),
(356174, 'PTHR23259:SF72', NULL, NULL, NULL, NULL, 'TIL DOMAIN-CONTAINING PROTEIN', 245291),
(356175, 'PTHR23259:SF61', NULL, NULL, NULL, NULL, 'PROTEIN CBG20701', 245291),
(356176, 'PTHR23259:SF73', NULL, NULL, NULL, NULL, 'TIL DOMAIN-CONTAINING PROTEIN', 245291),
(356177, 'PTHR23259:SF74', NULL, NULL, NULL, NULL, 'TIL DOMAIN-CONTAINING PROTEIN', 245291),
(356178, 'PTHR23259:SF75', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR SWM-1', 245291),
(356179, 'PTHR23259:SF76', NULL, NULL, NULL, NULL, 'TIL DOMAIN-CONTAINING PROTEIN', 245291),
(356180, 'PTHR23259:SF77', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR 1 PROTEIN-RELATED', 245291),
(356181, 'PTHR23259:SF67', NULL, NULL, NULL, NULL, 'THYROGLOBULIN TYPE-1 DOMAIN-CONTAINING PROTEIN', 245291),
(356182, 'PTHR23259:SF78', NULL, NULL, NULL, NULL, 'AGAP002448-PA', 245291),
(356183, 'PTHR23259:SF68', NULL, NULL, NULL, NULL, 'TIL DOMAIN-CONTAINING PROTEIN', 245291),
(356184, 'PTHR23259:SF79', NULL, NULL, NULL, NULL, 'TIL DOMAIN-CONTAINING PROTEIN', 245291),
(356185, 'PTHR23259:SF69', NULL, NULL, NULL, NULL, 'GEO11767P1-RELATED', 245291),
(356186, 'PTHR23259:SF59', NULL, NULL, NULL, NULL, 'PROTEIN CBG19171', 245291);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(356187, 'PTHR23259', NULL, NULL, NULL, NULL, 'RIDDLE', 245291),
(356188, 'PTHR23259:SF80', NULL, NULL, NULL, NULL, 'TIL DOMAIN-CONTAINING PROTEIN', 245291),
(356189, 'PTHR23259:SF70', NULL, NULL, NULL, NULL, 'ACCESSORY GLAND PROTEIN ACP62F-RELATED', 245291),
(356190, 'PTHR43100:SF1', NULL, NULL, NULL, NULL, 'GLUTAMATE SYNTHASE [NADPH] SMALL CHAIN', 245292),
(356191, 'PTHR43100', NULL, NULL, NULL, NULL, 'GLUTAMATE SYNTHASE [NADPH] SMALL CHAIN', 245292),
(356192, 'PTHR31280', NULL, NULL, NULL, NULL, 'PROTEIN UNC-13 HOMOLOG', 245293),
(356193, 'PTHR31280:SF23', NULL, NULL, NULL, NULL, 'RETINOL DEHYDROGENASE 13', 245293),
(356194, 'PTHR31280:SF24', NULL, NULL, NULL, NULL, 'MHD1 DOMAIN-CONTAINING PROTEIN', 245293),
(356195, 'PTHR31280:SF25', NULL, NULL, NULL, NULL, 'BNAC05G02570D PROTEIN', 245293),
(356196, 'PTHR31280:SF26', NULL, NULL, NULL, NULL, '', 245293),
(356197, 'PTHR31280:SF27', NULL, NULL, NULL, NULL, '', 245293),
(356198, 'PTHR31280:SF16', NULL, NULL, NULL, NULL, 'GLS PROTEIN (DUF810)', 245293),
(356199, 'PTHR31280:SF18', NULL, NULL, NULL, NULL, 'DUF810 FAMILY PROTEIN', 245293),
(356200, 'PTHR31280:SF19', NULL, NULL, NULL, NULL, '', 245293),
(356201, 'PTHR31280:SF5', NULL, NULL, NULL, NULL, '', 245293),
(356202, 'PTHR31280:SF4', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR TS (DUF810)', 245293),
(356203, 'PTHR31280:SF3', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE 4 SUBUNIT B (DUF810)', 245293),
(356204, 'PTHR31280:SF2', NULL, NULL, NULL, NULL, 'PROTEIN UNC-13 HOMOLOG', 245293),
(356205, 'PTHR31280:SF1', NULL, NULL, NULL, NULL, 'DUF810 FAMILY PROTEIN', 245293),
(356206, 'PTHR31280:SF20', NULL, NULL, NULL, NULL, 'F19P19.6 PROTEIN', 245293),
(356207, 'PTHR31280:SF21', NULL, NULL, NULL, NULL, '', 245293),
(356208, 'PTHR31280:SF22', NULL, NULL, NULL, NULL, 'DUF810 FAMILY PROTEIN', 245293),
(356209, 'PTHR11012:SF6', NULL, NULL, NULL, NULL, 'CHK DOMAIN OV1-RELATED', 245294),
(356210, 'PTHR11012:SF8', NULL, NULL, NULL, NULL, 'JUVENILE HORMONE-INDUCIBLE PROTEIN 26', 245294),
(356211, 'PTHR11012:SF4', NULL, NULL, NULL, NULL, 'LD42035P', 245294),
(356212, 'PTHR11012:SF30', NULL, NULL, NULL, NULL, 'PROTEIN KINASE-LIKE DOMAIN-CONTAINING', 245294),
(356213, 'PTHR11012:SF54', NULL, NULL, NULL, NULL, 'CHK DOMAIN-CONTAINING PROTEIN', 245294),
(356214, 'PTHR11012:SF55', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 245294),
(356215, 'PTHR11012:SF12', NULL, NULL, NULL, NULL, 'CHK DOMAIN-CONTAINING PROTEIN-RELATED', 245294),
(356216, 'PTHR11012:SF56', NULL, NULL, NULL, NULL, 'CHK DOMAIN-CONTAINING PROTEIN-RELATED', 245294),
(356217, 'PTHR11012:SF13', NULL, NULL, NULL, NULL, 'CHK DOMAIN-CONTAINING PROTEIN-RELATED', 245294),
(356218, 'PTHR11012:SF57', NULL, NULL, NULL, NULL, 'LD10016P', 245294),
(356219, 'PTHR11012:SF58', NULL, NULL, NULL, NULL, 'CHK DOMAIN-CONTAINING PROTEIN', 245294),
(356220, 'PTHR11012:SF47', NULL, NULL, NULL, NULL, 'GH22833P', 245294),
(356221, 'PTHR11012:SF48', NULL, NULL, NULL, NULL, 'CHK DOMAIN-CONTAINING PROTEIN-RELATED', 245294),
(356222, 'PTHR11012:SF59', NULL, NULL, NULL, NULL, 'CHK DOMAIN-CONTAINING PROTEIN-RELATED', 245294),
(356223, 'PTHR11012:SF19', NULL, NULL, NULL, NULL, 'CHK DOMAIN-CONTAINING PROTEIN', 245294),
(356224, 'PTHR11012', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 245294),
(356225, 'PTHR36348:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245295),
(356226, 'PTHR36348', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245295),
(356227, 'PTHR12391', NULL, NULL, NULL, NULL, 'ARP2/3 COMPLEX 21 KD SUBUNIT', 245296),
(356228, 'PTHR12391:SF11', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 2/3 COMPLEX SUBUNIT 3', 245296),
(356229, 'PTHR12391:SF10', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 2/3 COMPLEX SUBUNIT 3', 245296),
(356230, 'PTHR12391:SF0', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 2/3 COMPLEX SUBUNIT 3', 245296),
(356231, 'PTHR12391:SF3', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 2/3 COMPLEX SUBUNIT 3', 245296),
(356232, 'PTHR12391:SF5', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 2/3 COMPLEX SUBUNIT 3', 245296),
(356233, 'PTHR12391:SF6', NULL, NULL, NULL, NULL, '', 245296);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(356234, 'PTHR12391:SF7', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 2/3 COMPLEX SUBUNIT 3', 245296),
(356235, 'PTHR12391:SF8', NULL, NULL, NULL, NULL, 'ARP2/3 COMPLEX 21 KDA SUBUNIT', 245296),
(356236, 'PTHR10977', NULL, NULL, NULL, NULL, 'DIPHOSPHOMEVALONATE DECARBOXYLASE', 245297),
(356237, 'PTHR10977:SF7', NULL, NULL, NULL, NULL, 'DIPHOSPHOMEVALONATE DECARBOXYLASE', 245297),
(356238, 'PTHR10977:SF6', NULL, NULL, NULL, NULL, 'DIPHOSPHOMEVALONATE DECARBOXYLASE', 245297),
(356239, 'PTHR10977:SF3', NULL, NULL, NULL, NULL, 'DIPHOSPHOMEVALONATE DECARBOXYLASE', 245297),
(356240, 'PTHR38122', NULL, NULL, NULL, NULL, '', 245298),
(356241, 'PTHR38122:SF1', NULL, NULL, NULL, NULL, '', 245298),
(356242, 'PTHR11774:SF13', NULL, NULL, NULL, NULL, 'GERANYLGERANYL TRANSFERASE TYPE-2 SUBUNIT BETA', 245299),
(356243, 'PTHR11774:SF14', NULL, NULL, NULL, NULL, 'PROTEIN FARNESYLTRANSFERASE SUBUNIT BETA', 245299),
(356244, 'PTHR11774:SF15', NULL, NULL, NULL, NULL, 'GERANYLGERANYL TRANSFERASE TYPE-2 SUBUNIT BETA', 245299),
(356245, 'PTHR11774', NULL, NULL, NULL, NULL, 'GERANYLGERANYL TRANSFERASE TYPE BETA SUBUNIT', 245299),
(356246, 'PTHR11774:SF4', NULL, NULL, NULL, NULL, 'GERANYLGERANYL TRANSFERASE TYPE-1 SUBUNIT BETA', 245299),
(356247, 'PTHR11774:SF6', NULL, NULL, NULL, NULL, 'PROTEIN FARNESYLTRANSFERASE SUBUNIT BETA', 245299),
(356248, 'PTHR11774:SF11', NULL, NULL, NULL, NULL, 'GERANYLGERANYL TRANSFERASE TYPE-2 SUBUNIT BETA', 245299),
(356249, 'PTHR37724:SF1', NULL, NULL, NULL, NULL, 'OS02G0564300 PROTEIN', 245300),
(356250, 'PTHR37724:SF2', NULL, NULL, NULL, NULL, '', 245300),
(356251, 'PTHR37724', NULL, NULL, NULL, NULL, 'OS02G0564300 PROTEIN', 245300),
(356252, 'PTHR43524', NULL, NULL, NULL, NULL, 'RADICAL SAM SUPERFAMILY PROTEIN', 245301),
(356253, 'PTHR43524:SF1', NULL, NULL, NULL, NULL, 'RADICAL SAM SUPERFAMILY PROTEIN', 245301),
(356254, 'PTHR43227:SF6', NULL, NULL, NULL, NULL, 'DIACETYLCHITOBIOSE UPTAKE SYSTEM PERMEASE PROTEIN DASB', 245302),
(356255, 'PTHR43227', NULL, NULL, NULL, NULL, 'BLL4140 PROTEIN', 245302),
(356256, 'PTHR43227:SF3', NULL, NULL, NULL, NULL, 'BINDING-PROTEIN-DEPENDENT TRANSPORT SYSTEMS INNER MEMBRANE COMPONENT', 245302),
(356257, 'PTHR43227:SF10', NULL, NULL, NULL, NULL, 'TRANSPORT SYSTEM INTEGRAL MEMBRANE PROTEIN-RELATED', 245302),
(356258, 'PTHR43227:SF9', NULL, NULL, NULL, NULL, 'SN-GLYCEROL-3-PHOSPHATE TRANSPORT SYSTEM PERMEASE PROTEIN UGPA', 245302),
(356259, 'PTHR43227:SF8', NULL, NULL, NULL, NULL, 'BLL4140 PROTEIN', 245302),
(356260, 'PTHR43227:SF7', NULL, NULL, NULL, NULL, 'ARABINOOLIGOSACCHARIDES TRANSPORT SYSTEM PERMEASE PROTEIN ARAP', 245302),
(356261, 'PTHR12225:SF0', NULL, NULL, NULL, NULL, 'PROTEASOMAL UBIQUITIN RECEPTOR ADRM1', 245303),
(356262, 'PTHR12225:SF1', NULL, NULL, NULL, NULL, 'PROTEASOMAL UBIQUITIN RECEPTOR ADRM1 HOMOLOG RPN1302', 245303),
(356263, 'PTHR12225', NULL, NULL, NULL, NULL, 'ADHESION REGULATING MOLECULE 1  110 KDA CELL MEMBRANE GLYCOPROTEIN', 245303),
(356264, 'PTHR11548:SF15', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL DIHYDROFOLATE REDUCTASE-THYMIDYLATE SYNTHASE-RELATED', 245304),
(356265, 'PTHR11548:SF1', NULL, NULL, NULL, NULL, 'THYMIDYLATE SYNTHASE 1', 245304),
(356266, 'PTHR11548:SF14', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL DIHYDROFOLATE REDUCTASE-THYMIDYLATE SYNTHASE', 245304),
(356267, 'PTHR11548:SF11', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL DIHYDROFOLATE REDUCTASE-THYMIDYLATE SYNTHASE 2', 245304),
(356268, 'PTHR11548', NULL, NULL, NULL, NULL, 'THYMIDYLATE SYNTHASE 1', 245304),
(356269, 'PTHR11548:SF10', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL DIHYDROFOLATE REDUCTASE-THYMIDYLATE SYNTHASE', 245304),
(356270, 'PTHR11548:SF9', NULL, NULL, NULL, NULL, 'THYMIDYLATE SYNTHASE', 245304),
(356271, 'PTHR11548:SF2', NULL, NULL, NULL, NULL, 'THYMIDYLATE SYNTHASE', 245304),
(356272, 'PTHR46254:SF7', NULL, NULL, NULL, NULL, '', 245305),
(356273, 'PTHR46254:SF6', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP AT-HOOK 2', 245305),
(356274, 'PTHR46254:SF11', NULL, NULL, NULL, NULL, '', 245305),
(356275, 'PTHR46254:SF12', NULL, NULL, NULL, NULL, '', 245305);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(356276, 'PTHR46254:SF13', NULL, NULL, NULL, NULL, '', 245305),
(356277, 'PTHR46254', NULL, NULL, NULL, NULL, 'PROTEIN GVQW1-RELATED', 245305),
(356278, 'PTHR46254:SF3', NULL, NULL, NULL, NULL, 'PROTEIN GVQW1', 245305),
(356279, 'PTHR13271:SF150', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 245306),
(356280, 'PTHR13271:SF9', NULL, NULL, NULL, NULL, 'RUBISCO METHYLTRANSFERASE FAMILY PROTEIN', 245306),
(356281, 'PTHR13271:SF131', NULL, NULL, NULL, NULL, 'N-LYSINE METHYLTRANSFERASE SETD6', 245306),
(356282, 'PTHR13271:SF132', NULL, NULL, NULL, NULL, '', 245306),
(356283, 'PTHR13271:SF151', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN 4', 245306),
(356284, 'PTHR13271:SF38', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 245306),
(356285, 'PTHR13271:SF54', NULL, NULL, NULL, NULL, 'PROTEIN PLASTID TRANSCRIPTIONALLY ACTIVE 14', 245306),
(356286, 'PTHR13271:SF76', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN 8', 245306),
(356287, 'PTHR13271:SF55', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 245306),
(356288, 'PTHR13271:SF34', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 245306),
(356289, 'PTHR13271:SF91', NULL, NULL, NULL, NULL, 'PROTEIN SET DOMAIN GROUP 40', 245306),
(356290, 'PTHR13271:SF93', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 245306),
(356291, 'PTHR13271:SF146', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 245306),
(356292, 'PTHR13271:SF103', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 245306),
(356293, 'PTHR13271:SF147', NULL, NULL, NULL, NULL, 'PROTEIN-LYSINE N-METHYLTRANSFERASE EFM1-RELATED', 245306),
(356294, 'PTHR13271:SF144', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 245306),
(356295, 'PTHR13271:SF145', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 245306),
(356296, 'PTHR13271:SF123', NULL, NULL, NULL, NULL, 'RIBULOSE-1,5-BISPHOSPHATE CARBOXYLASE/OXYGENASE SMALL SUBUNIT N-METHYLTRANSFERASE I-RELATED', 245306),
(356297, 'PTHR13271:SF128', NULL, NULL, NULL, NULL, 'RIBOSOMAL LYSINE N-METHYLTRANSFERASE 3', 245306),
(356298, 'PTHR13271:SF148', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 245306),
(356299, 'PTHR13271:SF149', NULL, NULL, NULL, NULL, 'N-LYSINE METHYLTRANSFERASE', 245306),
(356300, 'PTHR13271', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PUTATIVE METHYLTRANSFERASE', 245306),
(356301, 'PTHR13271:SF142', NULL, NULL, NULL, NULL, 'RIBOSOMAL LYSINE N-METHYLTRANSFERASE 4', 245306),
(356302, 'PTHR13271:SF121', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 245306),
(356303, 'PTHR13271:SF143', NULL, NULL, NULL, NULL, '', 245306),
(356304, 'PTHR13271:SF140', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 245306),
(356305, 'PTHR13271:SF141', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 245306),
(356306, 'PTHR13271:SF47', NULL, NULL, NULL, NULL, 'ACTIN-HISTIDINE N-METHYLTRANSFERASE', 245306),
(356307, 'PTHR13271:SF113', NULL, NULL, NULL, NULL, '[FRUCTOSE-BISPHOSPHATE ALDOLASE]-LYSINE N-METHYLTRANSFERASE, CHLOROPLASTIC', 245306),
(356308, 'PTHR13271:SF135', NULL, NULL, NULL, NULL, 'SET DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_4G11040)', 245306),
(356309, 'PTHR13271:SF136', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 245306),
(356310, 'PTHR13271:SF133', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 245306),
(356311, 'PTHR13271:SF134', NULL, NULL, NULL, NULL, 'OS01G0976450 PROTEIN', 245306),
(356312, 'PTHR13271:SF117', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 245306),
(356313, 'PTHR13271:SF139', NULL, NULL, NULL, NULL, 'RUBIS-SUBS-BIND DOMAIN-CONTAINING PROTEIN', 245306),
(356314, 'PTHR13271:SF118', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 245306),
(356315, 'PTHR13271:SF137', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 245306),
(356316, 'PTHR13271:SF115', NULL, NULL, NULL, NULL, 'RUBIS-SUBS-BIND DOMAIN-CONTAINING PROTEIN', 245306),
(356317, 'PTHR13271:SF116', NULL, NULL, NULL, NULL, 'F21J9.27', 245306),
(356318, 'PTHR13271:SF138', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 245306);
INSERT INTO "PUBLIC"."MODEL" VALUES
(356319, 'PTHR47883', NULL, NULL, NULL, NULL, 'YIPPEE DOMAIN-CONTAINING PROTEIN', 245307),
(356320, 'PTHR47883:SF6', NULL, NULL, NULL, NULL, '', 245307),
(356321, 'PTHR47883:SF11', NULL, NULL, NULL, NULL, 'NACHT DOMAIN-CONTAINING PROTEIN', 245307),
(356322, 'PTHR47883:SF10', NULL, NULL, NULL, NULL, '', 245307),
(356323, 'PTHR47883:SF9', NULL, NULL, NULL, NULL, 'YIPPEE DOMAIN-CONTAINING PROTEIN', 245307),
(356324, 'PTHR47883:SF8', NULL, NULL, NULL, NULL, '', 245307),
(356325, 'PTHR24301:SF10', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 245308),
(356326, 'PTHR24301', NULL, NULL, NULL, NULL, 'THROMBOXANE-A SYNTHASE', 245308),
(356327, 'PTHR24301:SF11', NULL, NULL, NULL, NULL, '', 245308),
(356328, 'PTHR24301:SF8', NULL, NULL, NULL, NULL, 'OS02G0221900 PROTEIN', 245308),
(356329, 'PTHR24301:SF13', NULL, NULL, NULL, NULL, '', 245308),
(356330, 'PTHR24301:SF14', NULL, NULL, NULL, NULL, '', 245308),
(356331, 'PTHR24301:SF15', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY CYP711A MEMBER', 245308),
(356332, 'PTHR24301:SF2', NULL, NULL, NULL, NULL, 'THROMBOXANE-A SYNTHASE', 245308),
(356333, 'PTHR33781:SF2', NULL, NULL, NULL, NULL, 'OS05G0220500 PROTEIN', 245309),
(356334, 'PTHR33781:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PHYTOCHROME KINASE SUBSTRATE 4', 245309),
(356335, 'PTHR33781:SF19', NULL, NULL, NULL, NULL, '', 245309),
(356336, 'PTHR33781:SF18', NULL, NULL, NULL, NULL, '', 245309),
(356337, 'PTHR33781:SF17', NULL, NULL, NULL, NULL, 'KINASE SUBSTRATE PROTEIN, PUTATIVE-RELATED', 245309),
(356338, 'PTHR33781:SF7', NULL, NULL, NULL, NULL, 'PHYTOCHROME KINASE SUBSTRATE', 245309),
(356339, 'PTHR33781:SF16', NULL, NULL, NULL, NULL, 'BNAA09G53700D PROTEIN', 245309),
(356340, 'PTHR33781:SF4', NULL, NULL, NULL, NULL, 'PROTEIN PHYTOCHROME KINASE SUBSTRATE 2', 245309),
(356341, 'PTHR33781:SF3', NULL, NULL, NULL, NULL, 'PROTEIN PHYTOCHROME KINASE SUBSTRATE 3', 245309),
(356342, 'PTHR33781:SF11', NULL, NULL, NULL, NULL, 'BNAA02G26640D PROTEIN', 245309),
(356343, 'PTHR33781:SF15', NULL, NULL, NULL, NULL, '', 245309),
(356344, 'PTHR33781:SF13', NULL, NULL, NULL, NULL, 'PHYTOCHROME KINASE SUBSTRATE 2-RELATED', 245309),
(356345, 'PTHR33781:SF12', NULL, NULL, NULL, NULL, 'PROTEIN PHYTOCHROME KINASE SUBSTRATE 1', 245309),
(356346, 'PTHR33781', NULL, NULL, NULL, NULL, 'PROTEIN PHYTOCHROME KINASE SUBSTRATE 1-RELATED', 245309),
(356347, 'PTHR21100:SF11', NULL, NULL, NULL, NULL, 'PREFOLDIN SUBUNIT 4', 245310),
(356348, 'PTHR21100:SF9', NULL, NULL, NULL, NULL, 'PREFOLDIN SUBUNIT 4', 245310),
(356349, 'PTHR21100', NULL, NULL, NULL, NULL, 'PREFOLDIN SUBUNIT 4', 245310),
(356350, 'PTHR11845:SF19', NULL, NULL, NULL, NULL, '5''-DEOXYNUCLEOTIDASE', 245311),
(356351, 'PTHR11845:SF17', NULL, NULL, NULL, NULL, '5''-DEOXYNUCLEOTIDASE', 245311),
(356352, 'PTHR11845', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 245311),
(356353, 'PTHR11845:SF13', NULL, NULL, NULL, NULL, '5''-DEOXYNUCLEOTIDASE HDDC2', 245311),
(356354, 'PTHR31900:SF19', NULL, NULL, NULL, NULL, 'RNI-LIKE SUPERFAMILY PROTEIN', 245312),
(356355, 'PTHR31900:SF17', NULL, NULL, NULL, NULL, 'RNI-LIKE SUPERFAMILY PROTEIN', 245312),
(356356, 'PTHR31900:SF18', NULL, NULL, NULL, NULL, 'BNAC08G09670D PROTEIN', 245312),
(356357, 'PTHR31900:SF15', NULL, NULL, NULL, NULL, 'FBD-LIKE DOMAIN FAMILY PROTEIN-RELATED', 245312),
(356358, 'PTHR31900:SF26', NULL, NULL, NULL, NULL, 'BNAA09G41650D PROTEIN', 245312),
(356359, 'PTHR31900:SF16', NULL, NULL, NULL, NULL, 'BNAA05G16380D PROTEIN', 245312),
(356360, 'PTHR31900:SF24', NULL, NULL, NULL, NULL, 'BNAC04G04850D PROTEIN', 245312),
(356361, 'PTHR31900:SF25', NULL, NULL, NULL, NULL, 'PROTEIN WITH RNI-LIKE/FBD-LIKE DOMAIN', 245312),
(356362, 'PTHR31900:SF14', NULL, NULL, NULL, NULL, 'RNI-LIKE/FBD-LIKE DOMAINS', 245312),
(356363, 'PTHR31900:SF22', NULL, NULL, NULL, NULL, 'FBD-LIKE DOMAIN FAMILY PROTEIN', 245312),
(356364, 'PTHR31900:SF23', NULL, NULL, NULL, NULL, 'SYNTAXIN-RELATED FAMILY PROTEIN', 245312),
(356365, 'PTHR31900:SF20', NULL, NULL, NULL, NULL, 'EMB|CAB62440.1-RELATED', 245312),
(356366, 'PTHR31900:SF21', NULL, NULL, NULL, NULL, 'F-BOX/RNI SUPERFAMILY PROTEIN', 245312); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(356367, 'PTHR31900', NULL, NULL, NULL, NULL, 'F-BOX/RNI SUPERFAMILY PROTEIN-RELATED', 245312),
(356368, 'PTHR45444:SF3', NULL, NULL, NULL, NULL, 'XANTHINE DEHYDROGENASE', 245313),
(356369, 'PTHR45444', NULL, NULL, NULL, NULL, 'XANTHINE DEHYDROGENASE', 245313),
(356370, 'PTHR38808', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 95', 245314),
(356371, 'PTHR38808:SF1', NULL, NULL, NULL, NULL, 'SPERM-EGG FUSION PROTEIN TMEM95', 245314),
(356372, 'PTHR45721:SF6', NULL, NULL, NULL, NULL, 'INTERMEDIATE FILAMENT PROTEIN IFB-1', 245315),
(356373, 'PTHR45721:SF13', NULL, NULL, NULL, NULL, 'INTERMEDIATE FILAMENT PROTEIN IFD-2', 245315),
(356374, 'PTHR45721:SF7', NULL, NULL, NULL, NULL, 'INTERMEDIATE FILAMENT PROTEIN IFB-2', 245315),
(356375, 'PTHR45721:SF14', NULL, NULL, NULL, NULL, 'INTERMEDIATE FILAMENT PROTEIN IFD-1', 245315),
(356376, 'PTHR45721:SF8', NULL, NULL, NULL, NULL, 'INTERMEDIATE FILAMENT PROTEIN IFA-4', 245315),
(356377, 'PTHR45721:SF15', NULL, NULL, NULL, NULL, 'INTERMEDIATE FILAMENT PROTEIN IFP-1', 245315),
(356378, 'PTHR45721:SF16', NULL, NULL, NULL, NULL, 'LAMIN L3', 245315),
(356379, 'PTHR45721:SF9', NULL, NULL, NULL, NULL, 'INTERMEDIATE FILAMENT PROTEIN IFA-2-RELATED', 245315),
(356380, 'PTHR45721:SF10', NULL, NULL, NULL, NULL, 'INTERMEDIATE FILAMENT PROTEIN IFC-1', 245315),
(356381, 'PTHR45721', NULL, NULL, NULL, NULL, 'LAMIN DM0-RELATED', 245315),
(356382, 'PTHR45721:SF11', NULL, NULL, NULL, NULL, 'LAMIN DM0-RELATED', 245315),
(356383, 'PTHR45721:SF12', NULL, NULL, NULL, NULL, 'INTERMEDIATE FILAMENT PROTEIN IFA-1', 245315),
(356384, 'PTHR45721:SF1', NULL, NULL, NULL, NULL, 'INTERMEDIATE FILAMENT PROTEIN IFC-2', 245315),
(356385, 'PTHR45721:SF2', NULL, NULL, NULL, NULL, 'LAMIN-B2', 245315),
(356386, 'PTHR45721:SF3', NULL, NULL, NULL, NULL, 'LAMIN-B1', 245315),
(356387, 'PTHR45721:SF5', NULL, NULL, NULL, NULL, 'PRELAMIN-A/C', 245315),
(356388, 'PTHR10423', NULL, NULL, NULL, NULL, 'INSULIN-LIKE 3', 245316),
(356389, 'PTHR10423:SF6', NULL, NULL, NULL, NULL, 'INSULIN-LIKE 3', 245316),
(356390, 'PTHR10423:SF5', NULL, NULL, NULL, NULL, 'INSULIN LIKE 3', 245316),
(356391, 'PTHR10423:SF3', NULL, NULL, NULL, NULL, 'INSULIN-LIKE 3', 245316),
(356392, 'PTHR35115:SF1', NULL, NULL, NULL, NULL, 'PROTEIN IN CHLOROPLAST ATPASE BIOGENESIS, CHLOROPLASTIC', 245317),
(356393, 'PTHR35115:SF7', NULL, NULL, NULL, NULL, 'CYCLIN DELTA-3', 245317),
(356394, 'PTHR35115:SF5', NULL, NULL, NULL, NULL, '', 245317),
(356395, 'PTHR35115', NULL, NULL, NULL, NULL, 'CYCLIN DELTA-3', 245317),
(356396, 'PTHR35747', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', 245318),
(356397, 'PTHR35747:SF2', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN GPI-ANCHORED 25', 245318),
(356398, 'PTHR35747:SF3', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 245318),
(356399, 'PTHR10480:SF14', NULL, NULL, NULL, NULL, 'UNC-13 HOMOLOG BA (C. ELEGANS)', 245319),
(356400, 'PTHR10480', NULL, NULL, NULL, NULL, 'PROTEIN UNC-13 HOMOLOG', 245319),
(356401, 'PTHR10480:SF8', NULL, NULL, NULL, NULL, 'PROTEIN UNC-13 HOMOLOG B', 245319),
(356402, 'PTHR10480:SF1', NULL, NULL, NULL, NULL, 'PROTEIN UNC-13 HOMOLOG A', 245319),
(356403, 'PTHR10480:SF12', NULL, NULL, NULL, NULL, 'UNC-13, ISOFORM E', 245319),
(356404, 'PTHR10480:SF2', NULL, NULL, NULL, NULL, 'PROTEIN UNC-13 HOMOLOG C', 245319),
(356405, 'PTHR46621:SF1', NULL, NULL, NULL, NULL, 'SNRNA-ACTIVATING PROTEIN COMPLEX SUBUNIT 4', 245320),
(356406, 'PTHR46621', NULL, NULL, NULL, NULL, 'SNRNA-ACTIVATING PROTEIN COMPLEX SUBUNIT 4', 245320),
(356407, 'PTHR34737:SF2', NULL, NULL, NULL, NULL, '', 245321),
(356408, 'PTHR34737', NULL, NULL, NULL, NULL, '', 245321),
(356409, 'PTHR10202:SF24', NULL, NULL, NULL, NULL, 'PRESENILIN-2', 245322),
(356410, 'PTHR10202:SF13', NULL, NULL, NULL, NULL, 'PRESENILIN HOMOLOG', 245322),
(356411, 'PTHR10202:SF14', NULL, NULL, NULL, NULL, 'PRESENILIN HOP-1', 245322),
(356412, 'PTHR10202:SF25', NULL, NULL, NULL, NULL, 'PRESENILIN SPE-4', 245322),
(356413, 'PTHR10202:SF26', NULL, NULL, NULL, NULL, 'PRESENILIN', 245322);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(356414, 'PTHR10202:SF18', NULL, NULL, NULL, NULL, 'PRESENILIN-1', 245322),
(356415, 'PTHR10202', NULL, NULL, NULL, NULL, 'PRESENILIN', 245322),
(356416, 'PTHR10202:SF21', NULL, NULL, NULL, NULL, 'PRESENILIN-A', 245322),
(356417, 'PTHR37891:SF1', NULL, NULL, NULL, NULL, 'OS06G0113900 PROTEIN', 245323),
(356418, 'PTHR37891', NULL, NULL, NULL, NULL, 'OS06G0113900 PROTEIN', 245323),
(356419, 'PTHR46974:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL GTP/GDP CARRIER PROTEIN 1', 245324),
(356420, 'PTHR46974', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL GTP/GDP CARRIER PROTEIN 1', 245324),
(356421, 'PTHR48009:SF5', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE', 245325),
(356422, 'PTHR48009:SF13', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 245325),
(356423, 'PTHR48009:SF14', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN KINASE CLAVATA1-LIKE', 245325),
(356424, 'PTHR48009:SF4', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT (LRR) FAMILY PROTEIN', 245325),
(356425, 'PTHR48009:SF15', NULL, NULL, NULL, NULL, 'SERINE/THREONINE KINASE, PLANT-TYPE PROTEIN', 245325),
(356426, 'PTHR48009:SF3', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 245325),
(356427, 'PTHR48009:SF2', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT FAMILY PROTEIN', 245325),
(356428, 'PTHR48009:SF1', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT (LRR) FAMILY PROTEIN', 245325),
(356429, 'PTHR48009', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT (LRR) FAMILY PROTEIN', 245325),
(356430, 'PTHR48009:SF10', NULL, NULL, NULL, NULL, 'OS11G0644100 PROTEIN', 245325),
(356431, 'PTHR48009:SF12', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 245325),
(356432, 'PTHR48009:SF9', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE GSO1', 245325),
(356433, 'PTHR48009:SF8', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT (LRR) FAMILY PROTEIN-RELATED', 245325),
(356434, 'PTHR48009:SF7', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT (LRR) FAMILY PROTEIN', 245325),
(356435, 'PTHR10628:SF19', NULL, NULL, NULL, NULL, 'SIALIDASE', 245326),
(356436, 'PTHR10628:SF28', NULL, NULL, NULL, NULL, 'SIALIDASE DOMAIN-CONTAINING PROTEIN', 245326),
(356437, 'PTHR10628:SF6', NULL, NULL, NULL, NULL, 'SIALIDASE-2', 245326),
(356438, 'PTHR10628', NULL, NULL, NULL, NULL, 'SIALIDASE', 245326),
(356439, 'PTHR10628:SF26', NULL, NULL, NULL, NULL, 'SIALIDASE-RELATED', 245326),
(356440, 'PTHR10628:SF27', NULL, NULL, NULL, NULL, 'EXO-ALPHA-SIALIDASE', 245326),
(356441, 'PTHR10628:SF25', NULL, NULL, NULL, NULL, 'SIALIDASE-1', 245326),
(356442, 'PTHR10628:SF22', NULL, NULL, NULL, NULL, 'SIALIDASE-4', 245326),
(356443, 'PTHR10628:SF23', NULL, NULL, NULL, NULL, 'SIALIDASE-3', 245326),
(356444, 'PTHR41733', NULL, NULL, NULL, NULL, 'UBIQUITIN-ASSOCIATED/TRANSLATION ELONGATION FACTOR EF1B, N-TERMINAL, EUKARYOTE', 245327),
(356445, 'PTHR41733:SF1', NULL, NULL, NULL, NULL, 'UBA DOMAIN-CONTAINING PROTEIN', 245327),
(356446, 'PTHR17488:SF0', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSITION PROTEIN 2', 245328),
(356447, 'PTHR17488', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSITION PROTEIN 2', 245328),
(356448, 'PTHR14110', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM22', 245329),
(356449, 'PTHR14110:SF21', NULL, NULL, NULL, NULL, 'BNAA03G11350D PROTEIN', 245329),
(356450, 'PTHR14110:SF10', NULL, NULL, NULL, NULL, 'OS04G0376100 PROTEIN', 245329),
(356451, 'PTHR14110:SF23', NULL, NULL, NULL, NULL, 'SAM DOMAIN-CONTAINING PROTEIN', 245329),
(356452, 'PTHR14110:SF30', NULL, NULL, NULL, NULL, 'CHLOROPLASTIC IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT HP30-1', 245329),
(356453, 'PTHR14110:SF18', NULL, NULL, NULL, NULL, 'OUTER ENVELOPE PORE PROTEIN 16-3, CHLOROPLASTIC/MITOCHONDRIAL', 245329),
(356454, 'PTHR14110:SF29', NULL, NULL, NULL, NULL, 'CHLOROPLASTIC IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT HP30-2', 245329),
(356455, 'PTHR14110:SF28', NULL, NULL, NULL, NULL, 'OS02G0526500 PROTEIN', 245329),
(356456, 'PTHR14110:SF6', NULL, NULL, NULL, NULL, 'OS04G0405100 PROTEIN', 245329),
(356457, 'PTHR14110:SF17', NULL, NULL, NULL, NULL, 'OS09G0279300 PROTEIN', 245329);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(356458, 'PTHR14110:SF9', NULL, NULL, NULL, NULL, 'IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM17/TIM22/TIM23 FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 245329),
(356459, 'PTHR14110:SF19', NULL, NULL, NULL, NULL, 'BNACNNG41500D PROTEIN', 245329),
(356460, 'PTHR14110:SF25', NULL, NULL, NULL, NULL, 'BNAA10G09540D PROTEIN', 245329),
(356461, 'PTHR14110:SF24', NULL, NULL, NULL, NULL, '', 245329),
(356462, 'PTHR14110:SF16', NULL, NULL, NULL, NULL, 'PROTEIN TRANSLOCASE/ PROTEIN TRANSPORTER', 245329),
(356463, 'PTHR14110:SF1', NULL, NULL, NULL, NULL, 'CHLOROPLASTIC IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM22-2-RELATED', 245329),
(356464, 'PTHR14110:SF0', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM22', 245329),
(356465, 'PTHR14110:SF5', NULL, NULL, NULL, NULL, 'OUTER ENVELOPE PORE PROTEIN 16-4, CHLOROPLASTIC', 245329),
(356466, 'PTHR45988:SF22', NULL, NULL, NULL, NULL, 'C2H2 AND C2HC ZINC FINGERS SUPERFAMILY PROTEIN-RELATED', 245330),
(356467, 'PTHR45988:SF44', NULL, NULL, NULL, NULL, 'OS03G0437100 PROTEIN', 245330),
(356468, 'PTHR45988:SF41', NULL, NULL, NULL, NULL, 'ZINC FINGER, C2H2-LIKE PROTEIN-RELATED', 245330),
(356469, 'PTHR45988:SF85', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 245330),
(356470, 'PTHR45988:SF86', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 245330),
(356471, 'PTHR45988:SF42', NULL, NULL, NULL, NULL, 'BNAC03G48520D PROTEIN', 245330),
(356472, 'PTHR45988:SF69', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN AZF2', 245330),
(356473, 'PTHR45988:SF47', NULL, NULL, NULL, NULL, 'OSJNBA0089K21.8-LIKE PROTEIN', 245330),
(356474, 'PTHR45988:SF48', NULL, NULL, NULL, NULL, 'BNAANNG21010D PROTEIN', 245330),
(356475, 'PTHR45988:SF26', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZAT10-LIKE', 245330),
(356476, 'PTHR45988:SF67', NULL, NULL, NULL, NULL, 'C2H2 TYPE ZINC FINGER TRANSCRIPTION FACTOR FAMILY', 245330),
(356477, 'PTHR45988:SF45', NULL, NULL, NULL, NULL, 'BNAA09G27780D PROTEIN', 245330),
(356478, 'PTHR45988:SF46', NULL, NULL, NULL, NULL, 'BNAA05G20490D PROTEIN', 245330),
(356479, 'PTHR45988:SF24', NULL, NULL, NULL, NULL, 'BNAC07G16940D PROTEIN', 245330),
(356480, 'PTHR45988:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZAT6', 245330),
(356481, 'PTHR45988:SF72', NULL, NULL, NULL, NULL, '', 245330),
(356482, 'PTHR45988:SF73', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN-RELATED', 245330),
(356483, 'PTHR45988:SF70', NULL, NULL, NULL, NULL, 'C2H2 AND C2HC ZINC FINGER PROTEIN', 245330),
(356484, 'PTHR45988:SF71', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZAT1-LIKE', 245330),
(356485, 'PTHR45988:SF76', NULL, NULL, NULL, NULL, 'FINGER PROTEIN, PUTATIVE-RELATED', 245330),
(356486, 'PTHR45988:SF32', NULL, NULL, NULL, NULL, 'OS07G0588600 PROTEIN', 245330),
(356487, 'PTHR45988:SF77', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZAT4-LIKE', 245330),
(356488, 'PTHR45988:SF30', NULL, NULL, NULL, NULL, '', 245330),
(356489, 'PTHR45988:SF74', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN AZF2', 245330),
(356490, 'PTHR45988:SF75', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZAT10-LIKE', 245330),
(356491, 'PTHR45988', NULL, NULL, NULL, NULL, 'C2H2 TYPE ZINC FINGER TRANSCRIPTION FACTOR FAMILY-RELATED', 245330),
(356492, 'PTHR45988:SF37', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN AZF1', 245330),
(356493, 'PTHR45988:SF78', NULL, NULL, NULL, NULL, 'OS06G0727000 PROTEIN', 245330),
(356494, 'PTHR45988:SF56', NULL, NULL, NULL, NULL, 'BNAA01G26030D PROTEIN', 245330),
(356495, 'PTHR45988:SF79', NULL, NULL, NULL, NULL, 'PROTEIN VASP HOMOLOG', 245330),
(356496, 'PTHR45988:SF35', NULL, NULL, NULL, NULL, 'BNAA03G11040D PROTEIN', 245330),
(356497, 'PTHR45988:SF57', NULL, NULL, NULL, NULL, '', 245330),
(356498, 'PTHR45988:SF18', NULL, NULL, NULL, NULL, 'C2H2-TYPE ZINC FINGER FAMILY PROTEIN', 245330),
(356499, 'PTHR45988:SF19', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 245330),
(356500, 'PTHR45988:SF16', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 36', 245330),
(356501, 'PTHR45988:SF39', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 245330);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(356502, 'PTHR45988:SF17', NULL, NULL, NULL, NULL, 'BNAA09G07340D PROTEIN', 245330),
(356503, 'PTHR45988:SF80', NULL, NULL, NULL, NULL, 'OS06G0304200 PROTEIN', 245330),
(356504, 'PTHR45988:SF61', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN AZF3-RELATED', 245330),
(356505, 'PTHR45988:SF83', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZAT10-LIKE', 245330),
(356506, 'PTHR45988:SF84', NULL, NULL, NULL, NULL, 'C2H2-TYPE ZINC FINGER PROTEIN', 245330),
(356507, 'PTHR45988:SF62', NULL, NULL, NULL, NULL, 'C2H2 TYPE ZINC FINGER TRANSCRIPTION FACTOR ZFP31', 245330),
(356508, 'PTHR45988:SF81', NULL, NULL, NULL, NULL, 'C2H2-TYPE ZINC FINGER PROTEIN', 245330),
(356509, 'PTHR45988:SF82', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN AZF2', 245330),
(356510, 'PTHR13954:SF12', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE IRLC-RELATED', 245331),
(356511, 'PTHR13954:SF31', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE IRLA-RELATED', 245331),
(356512, 'PTHR13954:SF30', NULL, NULL, NULL, NULL, 'ENDORIBONUCLEASE', 245331),
(356513, 'PTHR13954', NULL, NULL, NULL, NULL, 'IRE1-RELATED', 245331),
(356514, 'PTHR13954:SF6', NULL, NULL, NULL, NULL, 'ENDORIBONUCLEASE', 245331),
(356515, 'PTHR13954:SF29', NULL, NULL, NULL, NULL, 'ENDORIBONUCLEASE', 245331),
(356516, 'PTHR13954:SF17', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE/ENDORIBONUCLEASE IRE1', 245331),
(356517, 'PTHR13954:SF28', NULL, NULL, NULL, NULL, 'ENDORIBONUCLEASE', 245331),
(356518, 'PTHR13954:SF27', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE/ENDORIBONUCLEASE IRE1B', 245331),
(356519, 'PTHR13954:SF26', NULL, NULL, NULL, NULL, 'SERINE/THREONINE KINASE DOMAIN PROTEIN', 245331),
(356520, 'PTHR13954:SF15', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE/ENDORIBONUCLEASE IRE2', 245331),
(356521, 'PTHR37734:SF1', NULL, NULL, NULL, NULL, 'LARGE RIBOSOMAL RNA SUBUNIT ACCUMULATION PROTEIN YCED HOMOLOG 2, CHLOROPLASTIC', 245332),
(356522, 'PTHR37734', NULL, NULL, NULL, NULL, 'LARGE RIBOSOMAL RNA SUBUNIT ACCUMULATION PROTEIN YCED HOMOLOG 2, CHLOROPLASTIC', 245332),
(356523, 'PTHR33294:SF5', NULL, NULL, NULL, NULL, 'AWPM-19-LIKE FAMILY PROTEIN', 245333),
(356524, 'PTHR33294:SF4', NULL, NULL, NULL, NULL, 'AWPM-19-LIKE FAMILY PROTEIN, EXPRESSED', 245333),
(356525, 'PTHR33294:SF3', NULL, NULL, NULL, NULL, 'AWPM-19-LIKE FAMILY PROTEIN', 245333),
(356526, 'PTHR33294', NULL, NULL, NULL, NULL, 'AWPM-19-LIKE FAMILY PROTEIN', 245333),
(356527, 'PTHR33294:SF15', NULL, NULL, NULL, NULL, 'BNAC03G59210D PROTEIN', 245333),
(356528, 'PTHR33294:SF16', NULL, NULL, NULL, NULL, 'BNAC05G02680D PROTEIN', 245333),
(356529, 'PTHR33294:SF13', NULL, NULL, NULL, NULL, 'AWPM-19-LIKE PROTEIN-RELATED', 245333),
(356530, 'PTHR33294:SF14', NULL, NULL, NULL, NULL, 'BNAA09G18040D PROTEIN', 245333),
(356531, 'PTHR33294:SF8', NULL, NULL, NULL, NULL, 'OS02G0731500 PROTEIN', 245333),
(356532, 'PTHR33294:SF17', NULL, NULL, NULL, NULL, 'BNAA09G26780D PROTEIN', 245333),
(356533, 'PTHR33294:SF7', NULL, NULL, NULL, NULL, 'AWPM-19-LIKE FAMILY PROTEIN', 245333),
(356534, 'PTHR33294:SF6', NULL, NULL, NULL, NULL, 'AWPM-19-LIKE FAMILY PROTEIN', 245333),
(356535, 'PTHR33294:SF11', NULL, NULL, NULL, NULL, 'ABA INDUCED PLASMA MEMBRANE PROTEIN', 245333),
(356536, 'PTHR33294:SF12', NULL, NULL, NULL, NULL, 'PGMPM3', 245333),
(356537, 'PTHR33294:SF10', NULL, NULL, NULL, NULL, 'OS01G0247900 PROTEIN', 245333),
(356538, 'PTHR35356:SF1', NULL, NULL, NULL, NULL, 'OS01G0157500 PROTEIN', 245334),
(356539, 'PTHR35356:SF3', NULL, NULL, NULL, NULL, 'OS01G0156300 PROTEIN', 245334),
(356540, 'PTHR35356:SF4', NULL, NULL, NULL, NULL, 'BTR1-A-LIKE PROTEIN', 245334),
(356541, 'PTHR35356:SF7', NULL, NULL, NULL, NULL, '', 245334),
(356542, 'PTHR35356:SF8', NULL, NULL, NULL, NULL, 'OS01G0157300 PROTEIN', 245334),
(356543, 'PTHR35356', NULL, NULL, NULL, NULL, 'OS01G0156300 PROTEIN-RELATED', 245334),
(356544, 'PTHR34122:SF1', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR', 245335),
(356545, 'PTHR34122', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', 245335),
(356546, 'PTHR34122:SF3', NULL, NULL, NULL, NULL, 'WRC DOMAIN-CONTAINING PROTEIN', 245335);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(356547, 'PTHR22916:SF65', NULL, NULL, NULL, NULL, 'SLR1065 PROTEIN', 245336),
(356548, 'PTHR22916:SF66', NULL, NULL, NULL, NULL, 'BETA-1,3-GALACTOSYLTRANSFERASE-RELATED', 245336),
(356549, 'PTHR22916:SF56', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE-RELATED', 245336),
(356550, 'PTHR22916:SF67', NULL, NULL, NULL, NULL, 'COLANIC ACID BIOSYNTHESIS GLYCOSYL TRANSFERASE WCAE-RELATED', 245336),
(356551, 'PTHR22916:SF3', NULL, NULL, NULL, NULL, 'UDP-GLCNAC:BETAGAL BETA-1,3-N-ACETYLGLUCOSAMINYLTRANSFERASE-LIKE PROTEIN 1', 245336),
(356552, 'PTHR22916:SF51', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE EPSH-RELATED', 245336),
(356553, 'PTHR22916:SF30', NULL, NULL, NULL, NULL, 'RANDOM SLUG CDNA19 PROTEIN', 245336),
(356554, 'PTHR22916:SF64', NULL, NULL, NULL, NULL, 'TRANSFERASE, PUTATIVE-RELATED', 245336),
(356555, 'PTHR22916:SF71', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE-RELATED', 245336),
(356556, 'PTHR22916', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 245336),
(356557, 'PTHR22916:SF69', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL GLYCOSYLTRANSFERASE PGTA', 245336),
(356558, 'PTHR35716', NULL, NULL, NULL, NULL, 'OS05G0574700 PROTEIN-RELATED', 245337),
(356559, 'PTHR35716:SF6', NULL, NULL, NULL, NULL, '', 245337),
(356560, 'PTHR35716:SF5', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 245337),
(356561, 'PTHR35716:SF1', NULL, NULL, NULL, NULL, 'OS05G0574700 PROTEIN', 245337),
(356562, 'PTHR35716:SF4', NULL, NULL, NULL, NULL, 'ARGININE DECARBOXYLASE', 245337),
(356563, 'PTHR30204:SF83', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN-RELATED', 245338),
(356564, 'PTHR30204:SF0', NULL, NULL, NULL, NULL, 'REDOX-SENSITIVE TRANSCRIPTIONAL ACTIVATOR SOXR', 245338),
(356565, 'PTHR30204:SF82', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, MERR FAMILY', 245338),
(356566, 'PTHR30204:SF74', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR ADHR', 245338),
(356567, 'PTHR30204:SF85', NULL, NULL, NULL, NULL, 'MULTIDRUG-EFFLUX TRANSPORTER 2 REGULATOR', 245338),
(356568, 'PTHR30204:SF84', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', 245338),
(356569, 'PTHR30204:SF73', NULL, NULL, NULL, NULL, 'HEAVY METAL-DEPENDENT TRANSCRIPTIONAL REGULATOR HI_0293-RELATED', 245338),
(356570, 'PTHR30204:SF90', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL ACTIVATOR MTA', 245338),
(356571, 'PTHR30204:SF91', NULL, NULL, NULL, NULL, 'MERR FAMILY REGULATORY PROTEIN', 245338),
(356572, 'PTHR30204:SF58', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR YFMP', 245338),
(356573, 'PTHR30204:SF69', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR ZNTR', 245338),
(356574, 'PTHR30204:SF68', NULL, NULL, NULL, NULL, 'REGULATOR, MERR FAMILY, PUTATIVE-RELATED', 245338),
(356575, 'PTHR30204:SF16', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR CUER', 245338),
(356576, 'PTHR30204', NULL, NULL, NULL, NULL, 'REDOX-CYCLING DRUG-SENSING TRANSCRIPTIONAL ACTIVATOR SOXR', 245338),
(356577, 'PTHR30204:SF15', NULL, NULL, NULL, NULL, 'CHROMOSOME-ANCHORING PROTEIN RACA', 245338),
(356578, 'PTHR30204:SF65', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR TNRA', 245338),
(356579, 'PTHR30204:SF87', NULL, NULL, NULL, NULL, 'MULTIDRUG-EFFLUX TRANSPORTER 1 REGULATOR', 245338),
(356580, 'PTHR30204:SF86', NULL, NULL, NULL, NULL, 'HTH MERR-TYPE DOMAIN-CONTAINING PROTEIN', 245338),
(356581, 'PTHR30204:SF89', NULL, NULL, NULL, NULL, '', 245338),
(356582, 'PTHR30204:SF67', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR MLRA-RELATED', 245338),
(356583, 'PTHR30204:SF3', NULL, NULL, NULL, NULL, 'HTH MERR-TYPE DOMAIN-CONTAINING PROTEIN', 245338),
(356584, 'PTHR30204:SF88', NULL, NULL, NULL, NULL, 'REGULATOR OF LIU GENES', 245338),
(356585, 'PTHR43713:SF6', NULL, NULL, NULL, NULL, 'GLUTAMATE-1-SEMIALDEHYDE 2,1-AMINOMUTASE', 245339),
(356586, 'PTHR43713', NULL, NULL, NULL, NULL, 'GLUTAMATE-1-SEMIALDEHYDE 2,1-AMINOMUTASE', 245339),
(356587, 'PTHR43713:SF1', NULL, NULL, NULL, NULL, 'GLUTAMATE-1-SEMIALDEHYDE 2,1-AMINOMUTASE 2', 245339),
(356588, 'PTHR43713:SF3', NULL, NULL, NULL, NULL, 'GLUTAMATE-1-SEMIALDEHYDE 2,1-AMINOMUTASE 1, CHLOROPLASTIC-RELATED', 245339);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(356589, 'PTHR39607', NULL, NULL, NULL, NULL, 'XANTHOCILLIN BIOSYNTHESIS CLUSTER TRANSCRIPTION FACTOR XANC-RELATED', 245340),
(356590, 'PTHR39607:SF1', NULL, NULL, NULL, NULL, 'B-ZIP TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 245340),
(356591, 'PTHR39607:SF2', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 245340),
(356592, 'PTHR13420:SF7', NULL, NULL, NULL, NULL, 'UPF0235 PROTEIN C15ORF40', 245341),
(356593, 'PTHR13420', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 245341),
(356594, 'PTHR11889:SF36', NULL, NULL, NULL, NULL, 'SONIC HEDGEHOG PROTEIN', 245342),
(356595, 'PTHR11889:SF56', NULL, NULL, NULL, NULL, 'DESERT HEDGEHOG PROTEIN', 245342),
(356596, 'PTHR11889', NULL, NULL, NULL, NULL, 'HEDGEHOG', 245342),
(356597, 'PTHR11889:SF31', NULL, NULL, NULL, NULL, 'PROTEIN HEDGEHOG', 245342),
(356598, 'PTHR11889:SF85', NULL, NULL, NULL, NULL, 'HEDGEHOG PROTEIN', 245342),
(356599, 'PTHR11889:SF84', NULL, NULL, NULL, NULL, 'HEDGEHOG PROTEIN', 245342),
(356600, 'PTHR11889:SF39', NULL, NULL, NULL, NULL, 'INDIAN HEDGEHOG PROTEIN', 245342),
(356601, 'PTHR43245:SF24', NULL, NULL, NULL, NULL, 'DEHYDROGENASE-RELATED', 245343),
(356602, 'PTHR43245:SF46', NULL, NULL, NULL, NULL, 'NUCLEOSIDE-DIPHOSPHATE-SUGAR EPIMERASE-RELATED', 245343),
(356603, 'PTHR43245:SF45', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 245343),
(356604, 'PTHR43245:SF23', NULL, NULL, NULL, NULL, 'NAD(P)-BD_DOM DOMAIN-CONTAINING PROTEIN', 245343),
(356605, 'PTHR43245:SF48', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING DOMAIN, RMLD-LIKE SUBSTRATE BINDING DOMAIN PROTEIN-RELATED', 245343),
(356606, 'PTHR43245:SF47', NULL, NULL, NULL, NULL, 'BLL5923 PROTEIN', 245343),
(356607, 'PTHR43245:SF49', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 4-EPIMERASE GALE3 (GALACTOWALDENASE) (UDP-GALACTOSE 4-EPIMERASE) (URIDINE DIPHOSPHATE GALACTOSE 4-EPIMERASE) (URIDINE DIPHOSPHO-GALACTOSE 4-EPIMERASE)-RELATED', 245343),
(356608, 'PTHR43245:SF29', NULL, NULL, NULL, NULL, 'UDP-D-APIOSE/UDP-D-XYLOSE SYNTHASE 2-LIKE', 245343),
(356609, 'PTHR43245:SF40', NULL, NULL, NULL, NULL, 'UDP-D-APIOSE/UDP-D-XYLOSE SYNTHASE 1-RELATED', 245343),
(356610, 'PTHR43245:SF2', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 245343),
(356611, 'PTHR43245:SF1', NULL, NULL, NULL, NULL, 'CDP-4-DEHYDRO-6-DEOXY-D-GULOSE 4-REDUCTASE-RELATED', 245343),
(356612, 'PTHR43245:SF44', NULL, NULL, NULL, NULL, 'RMLD_SUB_BIND DOMAIN-CONTAINING PROTEIN', 245343),
(356613, 'PTHR43245:SF21', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE DECARBOXYLASE-RELATED', 245343),
(356614, 'PTHR43245:SF43', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 245343),
(356615, 'PTHR43245', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL POLYMYXIN RESISTANCE PROTEIN ARNA', 245343),
(356616, 'PTHR43245:SF13', NULL, NULL, NULL, NULL, 'UDP-D-APIOSE/UDP-D-XYLOSE SYNTHASE 1-RELATED', 245343),
(356617, 'PTHR43245:SF34', NULL, NULL, NULL, NULL, 'UDP-D-APIOSE/UDP-D-XYLOSE SYNTHASE 2-LIKE', 245343),
(356618, 'PTHR43245:SF56', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL DTDP-4-DEHYDRORHAMNOSE 3,5-EPIMERASE/DTDP-4-DEHYDRORHAMNOSE REDUCTASE', 245343),
(356619, 'PTHR43245:SF14', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 4-EPIMERASE', 245343),
(356620, 'PTHR43245:SF17', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 4-EPIMERASE', 245343),
(356621, 'PTHR43245:SF51', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 245343),
(356622, 'PTHR43245:SF50', NULL, NULL, NULL, NULL, 'UDP-D-APIOSE/UDP-D-XYLOSE SYNTHASE 2', 245343),
(356623, 'PTHR43245:SF53', NULL, NULL, NULL, NULL, 'CDP-ABEQUOSE SYNTHASE', 245343),
(356624, 'PTHR43245:SF52', NULL, NULL, NULL, NULL, 'NAD-DEPENDENT EPIMERASE/DEHYDRATASE', 245343),
(356625, 'PTHR43245:SF55', NULL, NULL, NULL, NULL, 'NAD(P)-BD_DOM DOMAIN-CONTAINING PROTEIN', 245343),
(356626, 'PTHR43245:SF11', NULL, NULL, NULL, NULL, 'LD23561P', 245343),
(356627, 'PTHR43245:SF54', NULL, NULL, NULL, NULL, 'BLL0593 PROTEIN', 245343),
(356628, 'PTHR43245:SF10', NULL, NULL, NULL, NULL, 'SUGAR DEHYDRATASE/EPIMERASE YFNG-RELATED', 245343),
(356629, 'PTHR42915', NULL, NULL, NULL, NULL, 'HYPOTHETICAL 460 KDA PROTEIN IN FEUA-SIGW INTERGENIC REGION [PRECURSOR]', 245344);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(356630, 'PTHR42915:SF1', NULL, NULL, NULL, NULL, 'HYPOTHETICAL 460 KDA PROTEIN IN FEUA-SIGW INTERGENIC REGION [PRECURSOR]', 245344),
(356631, 'PTHR43295:SF4', NULL, NULL, NULL, NULL, 'ARGININE DECARBOXYLASE', 245345),
(356632, 'PTHR43295:SF7', NULL, NULL, NULL, NULL, 'ARGININE DECARBOXYLASE', 245345),
(356633, 'PTHR43295:SF9', NULL, NULL, NULL, NULL, 'BIOSYNTHETIC ARGININE DECARBOXYLASE', 245345),
(356634, 'PTHR43295:SF8', NULL, NULL, NULL, NULL, 'ARGININE DECARBOXYLASE', 245345),
(356635, 'PTHR43295', NULL, NULL, NULL, NULL, 'ARGININE DECARBOXYLASE', 245345),
(356636, 'PTHR43295:SF1', NULL, NULL, NULL, NULL, 'ARGININE DECARBOXYLASE 1-RELATED', 245345),
(356637, 'PTHR43295:SF2', NULL, NULL, NULL, NULL, 'ARGININE DECARBOXYLASE 2', 245345),
(356638, 'PTHR36693', NULL, NULL, NULL, NULL, 'GH02722P', 245346),
(356639, 'PTHR36693:SF1', NULL, NULL, NULL, NULL, 'GH02722P', 245346),
(356640, 'PTHR21561:SF12', NULL, NULL, NULL, NULL, 'INO80 COMPLEX SUBUNIT B', 245347),
(356641, 'PTHR21561:SF20', NULL, NULL, NULL, NULL, 'OS12G0561200 PROTEIN', 245347),
(356642, 'PTHR21561:SF26', NULL, NULL, NULL, NULL, 'PAPA-1 DOMAIN-CONTAINING PROTEIN', 245347),
(356643, 'PTHR21561:SF16', NULL, NULL, NULL, NULL, 'PAPA-1-LIKE FAMILY PROTEIN / ZINC FINGER (HIT TYPE) FAMILY PROTEIN', 245347),
(356644, 'PTHR21561:SF27', NULL, NULL, NULL, NULL, 'INO80 COMPLEX SUBUNIT B-LIKE CONSERVED REGION-RELATED', 245347),
(356645, 'PTHR21561:SF25', NULL, NULL, NULL, NULL, 'OS03G0811500 PROTEIN', 245347),
(356646, 'PTHR21561:SF14', NULL, NULL, NULL, NULL, 'HIT ZINC FINGER AND PAPA-1-LIKE DOMAIN-CONTAINING PROTEIN', 245347),
(356647, 'PTHR21561', NULL, NULL, NULL, NULL, 'INO80 COMPLEX SUBUNIT B', 245347),
(356648, 'PTHR16521', NULL, NULL, NULL, NULL, 'TYPE-1 ANGIOTENSIN II RECEPTOR-ASSOCIATED PROTEIN', 245348),
(356649, 'PTHR16521:SF3', NULL, NULL, NULL, NULL, 'TYPE-1 ANGIOTENSIN II RECEPTOR-ASSOCIATED PROTEIN', 245348),
(356650, 'PTHR45622:SF7', NULL, NULL, NULL, NULL, 'E3 ISG15--PROTEIN LIGASE HERC5', 245349),
(356651, 'PTHR45622:SF68', NULL, NULL, NULL, NULL, 'PROTEIN TIRA', 245349),
(356652, 'PTHR45622:SF48', NULL, NULL, NULL, NULL, '', 245349),
(356653, 'PTHR45622:SF5', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HERC4-RELATED', 245349),
(356654, 'PTHR45622:SF64', NULL, NULL, NULL, NULL, 'SECRETION-REGULATING GUANINE NUCLEOTIDE EXCHANGE FACTOR', 245349),
(356655, 'PTHR45622:SF65', NULL, NULL, NULL, NULL, 'PEPTIDASE_M11 DOMAIN-CONTAINING PROTEIN', 245349),
(356656, 'PTHR45622:SF44', NULL, NULL, NULL, NULL, 'REGULATOR OF CHROMOSOME CONDENSATION (RCC1) FAMILY PROTEIN', 245349),
(356657, 'PTHR45622:SF66', NULL, NULL, NULL, NULL, 'RCC1 DOMAIN-CONTAINING PROTEIN RUG3, MITOCHONDRIAL', 245349),
(356658, 'PTHR45622:SF67', NULL, NULL, NULL, NULL, 'HECT DOMAIN-CONTAINING PROTEIN', 245349),
(356659, 'PTHR45622:SF60', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE E3A', 245349),
(356660, 'PTHR45622:SF61', NULL, NULL, NULL, NULL, 'HECT DOMAIN-CONTAINING PROTEIN', 245349),
(356661, 'PTHR45622:SF62', NULL, NULL, NULL, NULL, 'X-LINKED RETINITIS PIGMENTOSA GTPASE REGULATOR HOMOLOG', 245349),
(356662, 'PTHR45622:SF63', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN GACGG', 245349),
(356663, 'PTHR45622', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE E3A-RELATED', 245349),
(356664, 'PTHR45622:SF39', NULL, NULL, NULL, NULL, 'HECT DOMAIN-CONTAINING PROTEIN', 245349),
(356665, 'PTHR45622:SF18', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HERC3-RELATED', 245349),
(356666, 'PTHR45622:SF57', NULL, NULL, NULL, NULL, 'OF CHROMOSOME CONDENSATION, PUTATIVE-RELATED', 245349),
(356667, 'PTHR45622:SF14', NULL, NULL, NULL, NULL, 'REGULATOR OF CHROMOSOME CONDENSATION (RCC1) FAMILY PROTEIN', 245349),
(356668, 'PTHR45622:SF36', NULL, NULL, NULL, NULL, '', 245349),
(356669, 'PTHR45622:SF58', NULL, NULL, NULL, NULL, 'X-LINKED RETINITIS PIGMENTOSA GTPASE REGULATOR', 245349),
(356670, 'PTHR45622:SF59', NULL, NULL, NULL, NULL, 'RCC1 DOMAIN-CONTAINING PROTEIN DDB_G0295713', 245349),
(356671, 'PTHR45622:SF54', NULL, NULL, NULL, NULL, 'REGULATOR OF CHROMOSOME CONDENSATION DOMAIN-CONTAINING PROTEIN', 245349);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(356672, 'PTHR45622:SF55', NULL, NULL, NULL, NULL, 'CYCLIN-E BINDING PROTEIN 1-LIKE PROTEIN', 245349),
(356673, 'PTHR45622:SF11', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HERC6-RELATED', 245349),
(356674, 'PTHR45622:SF56', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HECTD2-RELATED', 245349),
(356675, 'PTHR45622:SF51', NULL, NULL, NULL, NULL, 'HECT DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_2G04450)', 245349),
(356676, 'PTHR45622:SF52', NULL, NULL, NULL, NULL, 'CHROMOSOME CONDENSATION REGULATOR RCC1 REPEAT PROTEIN', 245349),
(356677, 'PTHR31009:SF134', NULL, NULL, NULL, NULL, '', 245350),
(356678, 'PTHR31009:SF97', NULL, NULL, NULL, NULL, 'BENZOATE CARBOXYL METHYLTRANSFERASE-RELATED', 245350),
(356679, 'PTHR31009:SF132', NULL, NULL, NULL, NULL, 'BENZOATE CARBOXYL METHYLTRANSFERASE', 245350),
(356680, 'PTHR31009:SF95', NULL, NULL, NULL, NULL, '', 245350),
(356681, 'PTHR31009:SF133', NULL, NULL, NULL, NULL, 'ANTHRANILATE O-METHYLTRANSFERASE 3', 245350),
(356682, 'PTHR31009:SF138', NULL, NULL, NULL, NULL, 'OS06G0315000 PROTEIN', 245350),
(356683, 'PTHR31009:SF93', NULL, NULL, NULL, NULL, '', 245350),
(356684, 'PTHR31009:SF136', NULL, NULL, NULL, NULL, 'BNAC06G27680D PROTEIN', 245350),
(356685, 'PTHR31009:SF92', NULL, NULL, NULL, NULL, '', 245350),
(356686, 'PTHR31009:SF91', NULL, NULL, NULL, NULL, 'JASMONATE O-METHYLTRANSFERASE', 245350),
(356687, 'PTHR31009:SF90', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETATE O-METHYLTRANSFERASE 1-LIKE', 245350),
(356688, 'PTHR31009', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE:CARBOXYL METHYLTRANSFERASE FAMILY PROTEIN', 245350),
(356689, 'PTHR31009:SF49', NULL, NULL, NULL, NULL, 'OS02G0719600 PROTEIN', 245350),
(356690, 'PTHR31009:SF130', NULL, NULL, NULL, NULL, 'BNAC03G76600D PROTEIN', 245350),
(356691, 'PTHR31009:SF47', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN-RELATED', 245350),
(356692, 'PTHR31009:SF46', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 245350),
(356693, 'PTHR31009:SF89', NULL, NULL, NULL, NULL, '(BREAD WHEAT) HYPOTHETICAL PROTEIN', 245350),
(356694, 'PTHR31009:SF87', NULL, NULL, NULL, NULL, 'BNAA02G12540D PROTEIN', 245350),
(356695, 'PTHR31009:SF42', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETATE O-METHYLTRANSFERASE 1', 245350),
(356696, 'PTHR31009:SF86', NULL, NULL, NULL, NULL, '7-METHYLXANTHINE METHYLTRANSFERASE 3-RELATED', 245350),
(356697, 'PTHR31009:SF85', NULL, NULL, NULL, NULL, 'OS06G0311800 PROTEIN', 245350),
(356698, 'PTHR31009:SF122', NULL, NULL, NULL, NULL, 'BNAA07G03510D PROTEIN', 245350),
(356699, 'PTHR31009:SF83', NULL, NULL, NULL, NULL, '', 245350),
(356700, 'PTHR31009:SF82', NULL, NULL, NULL, NULL, '', 245350),
(356701, 'PTHR31009:SF128', NULL, NULL, NULL, NULL, 'BNAC09G50490D PROTEIN', 245350),
(356702, 'PTHR31009:SF80', NULL, NULL, NULL, NULL, '', 245350),
(356703, 'PTHR31009:SF126', NULL, NULL, NULL, NULL, '', 245350),
(356704, 'PTHR31009:SF129', NULL, NULL, NULL, NULL, 'BNAA07G12630D PROTEIN', 245350),
(356705, 'PTHR31009:SF6', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE TCM_000336-RELATED', 245350),
(356706, 'PTHR31009:SF160', NULL, NULL, NULL, NULL, '7-METHYLXANTHOSINE SYNTHASE 1-LIKE ISOFORM X1', 245350),
(356707, 'PTHR31009:SF163', NULL, NULL, NULL, NULL, 'GIBBERELLIC ACID METHYLTRANSFERASE 2', 245350),
(356708, 'PTHR31009:SF164', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 245350),
(356709, 'PTHR31009:SF120', NULL, NULL, NULL, NULL, 'LOGANIC ACID O-METHYLTRANSFERASE-LIKE', 245350),
(356710, 'PTHR31009:SF78', NULL, NULL, NULL, NULL, 'SALICYLATE CARBOXYMETHYLTRANSFERASE-LIKE', 245350),
(356711, 'PTHR31009:SF161', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE TCM_000331-RELATED', 245350),
(356712, 'PTHR31009:SF162', NULL, NULL, NULL, NULL, 'INDOLE-3-ACETATE O-METHYLTRANSFERASE-LIKE PROTEIN', 245350),
(356713, 'PTHR31009:SF156', NULL, NULL, NULL, NULL, 'PARAXANTHINE METHYLTRANSFERASE 1-RELATED', 245350),
(356714, 'PTHR31009:SF112', NULL, NULL, NULL, NULL, 'BNAA08G13630D PROTEIN', 245350),
(356715, 'PTHR31009:SF76', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 245350);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(356716, 'PTHR31009:SF157', NULL, NULL, NULL, NULL, 'CARBOXYL METHYLTRANSFERASE, PUTATIVE-RELATED', 245350),
(356717, 'PTHR31009:SF75', NULL, NULL, NULL, NULL, 'CARBOXYL METHYLTRANSFERASE, PUTATIVE-RELATED', 245350),
(356718, 'PTHR31009:SF113', NULL, NULL, NULL, NULL, 'BNAC02G45360D PROTEIN', 245350),
(356719, 'PTHR31009:SF74', NULL, NULL, NULL, NULL, '', 245350),
(356720, 'PTHR31009:SF154', NULL, NULL, NULL, NULL, 'SALICYLATE CARBOXYMETHYLTRANSFERASE-LIKE', 245350),
(356721, 'PTHR31009:SF155', NULL, NULL, NULL, NULL, 'F9L1.6', 245350),
(356722, 'PTHR31009:SF116', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 245350),
(356723, 'PTHR31009:SF117', NULL, NULL, NULL, NULL, 'BNAA05G27560D PROTEIN', 245350),
(356724, 'PTHR31009:SF71', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 245350),
(356725, 'PTHR31009:SF114', NULL, NULL, NULL, NULL, 'BNAC03G76610D PROTEIN', 245350),
(356726, 'PTHR31009:SF158', NULL, NULL, NULL, NULL, 'LOGANIC ACID METHYLTRANSFERASE', 245350),
(356727, 'PTHR31009:SF70', NULL, NULL, NULL, NULL, '', 245350),
(356728, 'PTHR31009:SF115', NULL, NULL, NULL, NULL, 'BNAC07G15660D PROTEIN', 245350),
(356729, 'PTHR31009:SF159', NULL, NULL, NULL, NULL, 'LOGANIC ACID O-METHYLTRANSFERASE-LIKE', 245350),
(356730, 'PTHR31009:SF152', NULL, NULL, NULL, NULL, '', 245350),
(356731, 'PTHR31009:SF153', NULL, NULL, NULL, NULL, 'BNAA09G26920D PROTEIN', 245350),
(356732, 'PTHR31009:SF67', NULL, NULL, NULL, NULL, 'BENZOATE O-METHYLTRANSFERASE', 245350),
(356733, 'PTHR31009:SF66', NULL, NULL, NULL, NULL, '', 245350),
(356734, 'PTHR31009:SF65', NULL, NULL, NULL, NULL, 'GIBBERELLIC ACID METHYLTRANSFERASE 1', 245350),
(356735, 'PTHR31009:SF64', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE:SALICYLIC ACID CARBOXYL METHYLTRANSFERASE_ 41514-39166-RELATED', 245350),
(356736, 'PTHR31009:SF146', NULL, NULL, NULL, NULL, '7-METHYLXANTHOSINE SYNTHASE-RELATED', 245350),
(356737, 'PTHR31009:SF102', NULL, NULL, NULL, NULL, 'BNAC08G12180D PROTEIN', 245350),
(356738, 'PTHR31009:SF143', NULL, NULL, NULL, NULL, 'LOGANIC ACID O-METHYLTRANSFERASE-LIKE', 245350),
(356739, 'PTHR31009:SF63', NULL, NULL, NULL, NULL, 'BENZOATE CARBOXYL METHYLTRANSFERASE-LIKE', 245350),
(356740, 'PTHR31009:SF61', NULL, NULL, NULL, NULL, '', 245350),
(356741, 'PTHR31009:SF105', NULL, NULL, NULL, NULL, 'BNAA05G36360D PROTEIN', 245350),
(356742, 'PTHR31009:SF149', NULL, NULL, NULL, NULL, '', 245350),
(356743, 'PTHR31009:SF60', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 245350),
(356744, 'PTHR31009:SF106', NULL, NULL, NULL, NULL, 'LOGANIC ACID O-METHYLTRANSFERASE-LIKE', 245350),
(356745, 'PTHR31009:SF103', NULL, NULL, NULL, NULL, 'SALICYLATE CARBOXYMETHYLTRANSFERASE-LIKE', 245350),
(356746, 'PTHR31009:SF104', NULL, NULL, NULL, NULL, 'BNAC02G44900D PROTEIN', 245350),
(356747, 'PTHR31009:SF148', NULL, NULL, NULL, NULL, 'BNAC01G23720D PROTEIN', 245350),
(356748, 'PTHR31009:SF107', NULL, NULL, NULL, NULL, '', 245350),
(356749, 'PTHR31009:SF18', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE TCM_000168-RELATED', 245350),
(356750, 'PTHR31009:SF58', NULL, NULL, NULL, NULL, 'ATPP-LIKE PROTEIN-RELATED', 245350),
(356751, 'PTHR31009:SF142', NULL, NULL, NULL, NULL, 'BNAA09G04020D PROTEIN', 245350),
(356752, 'PTHR43596:SF1', NULL, NULL, NULL, NULL, 'ADP,ATP CARRIER PROTEIN', 245351),
(356753, 'PTHR43596', NULL, NULL, NULL, NULL, 'ADP,ATP CARRIER PROTEIN', 245351),
(356754, 'PTHR28646', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 201', 245352),
(356755, 'PTHR28646:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 201', 245352),
(356756, 'PTHR24342:SF12', NULL, NULL, NULL, NULL, 'DEATH-ASSOCIATED PROTEIN KINASE RELATED', 245353),
(356757, 'PTHR24342:SF14', NULL, NULL, NULL, NULL, 'DEATH-ASSOCIATED PROTEIN KINASE DAPK-1', 245353),
(356758, 'PTHR24342:SF19', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245353),
(356759, 'PTHR24342:SF5', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 17B', 245353),
(356760, 'PTHR24342:SF16', NULL, NULL, NULL, NULL, 'SERINE/THREONINE KINASE 17A-LIKE', 245353);
INSERT INTO "PUBLIC"."MODEL" VALUES
(356761, 'PTHR24342:SF15', NULL, NULL, NULL, NULL, 'DEATH-ASSOCIATED PROTEIN KINASE 2', 245353),
(356762, 'PTHR24342', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 17', 245353),
(356763, 'PTHR24342:SF18', NULL, NULL, NULL, NULL, 'DEATH-ASSOCIATED PROTEIN KINASE 3', 245353),
(356764, 'PTHR24342:SF17', NULL, NULL, NULL, NULL, 'DEATH-ASSOCIATED PROTEIN KINASE 1', 245353),
(356765, 'PTHR24342:SF6', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 17A', 245353),
(356766, 'PTHR33695:SF1', NULL, NULL, NULL, NULL, 'LIPOPROTEIN SIGNAL PEPTIDASE', 245354),
(356767, 'PTHR33695', NULL, NULL, NULL, NULL, 'LIPOPROTEIN SIGNAL PEPTIDASE', 245354),
(356768, 'PTHR30313', NULL, NULL, NULL, NULL, 'DNA PRIMASE', 245355),
(356769, 'PTHR30313:SF2', NULL, NULL, NULL, NULL, 'DNA PRIMASE', 245355),
(356770, 'PTHR13387:SF9', NULL, NULL, NULL, NULL, 'PROTEIN HGH1 HOMOLOG', 245356),
(356771, 'PTHR13387', NULL, NULL, NULL, NULL, 'PROTEIN HGH1 HOMOLOG', 245356),
(356772, 'PTHR31108', NULL, NULL, NULL, NULL, 'TUMOR PROTEIN P63-REGULATED GENE 1-LIKE PROTEIN', 245357),
(356773, 'PTHR31108:SF1', NULL, NULL, NULL, NULL, 'HSAC2 DOMAIN-CONTAINING PROTEIN', 245357),
(356774, 'PTHR31108:SF7', NULL, NULL, NULL, NULL, 'TUMOR PROTEIN P63-REGULATED GENE 1-LIKE PROTEIN', 245357),
(356775, 'PTHR31108:SF6', NULL, NULL, NULL, NULL, 'TUMOR PROTEIN P63-REGULATED GENE 1 PROTEIN', 245357),
(356776, 'PTHR30511', NULL, NULL, NULL, NULL, 'ALANINE RACEMASE', 245358),
(356777, 'PTHR30511:SF4', NULL, NULL, NULL, NULL, 'ALANINE RACEMASE, BIOSYNTHETIC', 245358),
(356778, 'PTHR30511:SF3', NULL, NULL, NULL, NULL, 'LYSINE RACEMASE', 245358),
(356779, 'PTHR30511:SF0', NULL, NULL, NULL, NULL, 'ALANINE RACEMASE, CATABOLIC-RELATED', 245358),
(356780, 'PTHR36780', NULL, NULL, NULL, NULL, 'OS05G0241400 PROTEIN', 245359),
(356781, 'PTHR36780:SF1', NULL, NULL, NULL, NULL, 'OS05G0241400 PROTEIN', 245359),
(356782, 'PTHR11815', NULL, NULL, NULL, NULL, 'SUCCINYL-COA SYNTHETASE BETA CHAIN', 245360),
(356783, 'PTHR11815:SF10', NULL, NULL, NULL, NULL, 'SUCCINATE--COA LIGASE [GDP-FORMING] SUBUNIT BETA, MITOCHONDRIAL', 245360),
(356784, 'PTHR11815:SF11', NULL, NULL, NULL, NULL, 'SUCCINATE--COA LIGASE [GDP-FORMING] SUBUNIT BETA, MITOCHONDRIAL', 245360),
(356785, 'PTHR11815:SF12', NULL, NULL, NULL, NULL, 'SUCCINATE--COA LIGASE [GDP-FORMING] SUBUNIT BETA, MITOCHONDRIAL', 245360),
(356786, 'PTHR11815:SF13', NULL, NULL, NULL, NULL, 'ATP-GRASP_2 DOMAIN-CONTAINING PROTEIN', 245360),
(356787, 'PTHR11815:SF1', NULL, NULL, NULL, NULL, 'SUCCINATE--COA LIGASE [ADP-FORMING] SUBUNIT BETA, MITOCHONDRIAL', 245360),
(356788, 'PTHR11815:SF14', NULL, NULL, NULL, NULL, 'SUCCINATE--COA LIGASE [ADP-FORMING] SUBUNIT BETA, MITOCHONDRIAL', 245360),
(356789, 'PTHR11815:SF16', NULL, NULL, NULL, NULL, 'SUCCINATE--COA LIGASE [ADP-FORMING] SUBUNIT BETA, MITOCHONDRIAL', 245360),
(356790, 'PTHR11815:SF19', NULL, NULL, NULL, NULL, 'LIGASE_COA DOMAIN-CONTAINING PROTEIN', 245360),
(356791, 'PTHR33360:SF2', NULL, NULL, NULL, NULL, 'TRANSPOSASE FOR INSERTION SEQUENCE ELEMENT IS200', 245361),
(356792, 'PTHR33360', NULL, NULL, NULL, NULL, 'TRANSPOSASE FOR INSERTION SEQUENCE ELEMENT IS200', 245361),
(356793, 'PTHR11596:SF69', NULL, NULL, NULL, NULL, 'ALKALINE PHOSPHATASE, PLACENTAL TYPE', 245362),
(356794, 'PTHR11596:SF37', NULL, NULL, NULL, NULL, 'ALKALINE PHOSPHATASE', 245362),
(356795, 'PTHR11596:SF76', NULL, NULL, NULL, NULL, 'ALKALINE PHOSPHATASE', 245362),
(356796, 'PTHR11596:SF43', NULL, NULL, NULL, NULL, 'INTESTINAL-TYPE ALKALINE PHOSPHATASE', 245362),
(356797, 'PTHR11596:SF55', NULL, NULL, NULL, NULL, 'ALKALINE PHOSPHATASE', 245362),
(356798, 'PTHR11596:SF89', NULL, NULL, NULL, NULL, 'ALKALINE PHOSPHATASE', 245362),
(356799, 'PTHR11596:SF5', NULL, NULL, NULL, NULL, 'ALKALINE PHOSPHATASE', 245362),
(356800, 'PTHR11596:SF83', NULL, NULL, NULL, NULL, 'ALKALINE PHOSPHATASE 4', 245362),
(356801, 'PTHR11596:SF72', NULL, NULL, NULL, NULL, 'ALKALINE PHOSPHATASE', 245362),
(356802, 'PTHR11596:SF30', NULL, NULL, NULL, NULL, 'INTESTINAL-TYPE ALKALINE PHOSPHATASE', 245362),
(356803, 'PTHR11596:SF85', NULL, NULL, NULL, NULL, 'ALKALINE PHOSPHATASE', 245362);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(356804, 'PTHR11596:SF74', NULL, NULL, NULL, NULL, 'ALKALINE PHOSPHATASE, TISSUE-NONSPECIFIC ISOZYME', 245362),
(356805, 'PTHR11596:SF42', NULL, NULL, NULL, NULL, 'ALKALINE PHOSPHATASE, GERM CELL TYPE', 245362),
(356806, 'PTHR11596:SF81', NULL, NULL, NULL, NULL, 'ALKALINE PHOSPHATASE, GERM CELL TYPE', 245362),
(356807, 'PTHR11596', NULL, NULL, NULL, NULL, 'ALKALINE PHOSPHATASE', 245362),
(356808, 'PTHR47331', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', 245363),
(356809, 'PTHR47331:SF1', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 245363),
(356810, 'PTHR36223:SF5', NULL, NULL, NULL, NULL, '', 245364),
(356811, 'PTHR36223', NULL, NULL, NULL, NULL, '', 245364),
(356812, 'PTHR36223:SF1', NULL, NULL, NULL, NULL, '', 245364),
(356813, 'PTHR11645:SF61', NULL, NULL, NULL, NULL, 'PYRROLINE-5-CARBOXYLATE REDUCTASE 2', 245365),
(356814, 'PTHR11645:SF6', NULL, NULL, NULL, NULL, 'PYRROLINE-5-CARBOXYLATE REDUCTASE 1, MITOCHONDRIAL', 245365),
(356815, 'PTHR11645:SF49', NULL, NULL, NULL, NULL, 'PYRROLINE-5-CARBOXYLATE REDUCTASE 1', 245365),
(356816, 'PTHR11645:SF27', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PYRROLINE-5-CARBOXYLATE REDUCTASE (EUROFUNG)', 245365),
(356817, 'PTHR11645', NULL, NULL, NULL, NULL, 'PYRROLINE-5-CARBOXYLATE REDUCTASE', 245365),
(356818, 'PTHR11645:SF0', NULL, NULL, NULL, NULL, 'PYRROLINE-5-CARBOXYLATE REDUCTASE 3', 245365),
(356819, 'PTHR11645:SF63', NULL, NULL, NULL, NULL, 'PYRROLINE-5-CARBOXYLATE REDUCTASE', 245365),
(356820, 'PTHR11645:SF62', NULL, NULL, NULL, NULL, 'PYRROLINE-5-CARBOXYLATE REDUCTASE', 245365),
(356821, 'PTHR11645:SF51', NULL, NULL, NULL, NULL, 'COME OPERON PROTEIN 4', 245365),
(356822, 'PTHR11645:SF65', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PYRROLINE-5-CARBOXYLATE REDUCTASE (EUROFUNG)', 245365),
(356823, 'PTHR11645:SF21', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PYRROLINE-5-CARBOXYLATE REDUCTASE (EUROFUNG)', 245365),
(356824, 'PTHR11645:SF64', NULL, NULL, NULL, NULL, 'PYRROLINE-5-CARBOXYLATE REDUCTASE-RELATED', 245365),
(356825, 'PTHR11645:SF53', NULL, NULL, NULL, NULL, 'PYRROLINE-5-CARBOXYLATE REDUCTASE 3', 245365),
(356826, 'PTHR11645:SF67', NULL, NULL, NULL, NULL, 'PYRROLINE-5-CARBOXYLATE REDUCTASE', 245365),
(356827, 'PTHR11645:SF66', NULL, NULL, NULL, NULL, 'PYRROLINE-5-CARBOXYLATE REDUCTASE', 245365),
(356828, 'PTHR11645:SF69', NULL, NULL, NULL, NULL, 'PYRROLINE-5-CARBOXYLATE REDUCTASE', 245365),
(356829, 'PTHR11645:SF58', NULL, NULL, NULL, NULL, 'NADP-DEPENDENT OXIDOREDUCTASE DOMAIN-CONTAINING PROTEIN 1', 245365),
(356830, 'PTHR11645:SF13', NULL, NULL, NULL, NULL, '', 245365),
(356831, 'PTHR11645:SF68', NULL, NULL, NULL, NULL, 'PYRROLINE-5-CARBOXYLATE REDUCTASE 1', 245365),
(356832, 'PTHR38150', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 245366),
(356833, 'PTHR38150:SF1', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 245366),
(356834, 'PTHR45720:SF9', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN', 245367),
(356835, 'PTHR45720:SF10', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN 2', 245367),
(356836, 'PTHR45720:SF15', NULL, NULL, NULL, NULL, 'CBS DOMAIN-CONTAINING PROTEIN', 245367),
(356837, 'PTHR45720:SF14', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN', 245367),
(356838, 'PTHR45720:SF2', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN CLC-KB', 245367),
(356839, 'PTHR45720:SF13', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN', 245367),
(356840, 'PTHR45720:SF5', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN', 245367),
(356841, 'PTHR45720:SF6', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN 2', 245367),
(356842, 'PTHR45720:SF3', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN CLC-KB', 245367),
(356843, 'PTHR45720:SF16', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN CLC-KA', 245367),
(356844, 'PTHR45720', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN 2', 245367),
(356845, 'PTHR45720:SF4', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN 1', 245367),
(356846, 'PTHR38337', NULL, NULL, NULL, NULL, 'AGAP010540-PA', 245368),
(356847, 'PTHR38337:SF1', NULL, NULL, NULL, NULL, '', 245368); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(356848, 'PTHR43104', NULL, NULL, NULL, NULL, 'L-2-HYDROXYGLUTARATE DEHYDROGENASE, MITOCHONDRIAL', 245369),
(356849, 'PTHR43104:SF2', NULL, NULL, NULL, NULL, 'L-2-HYDROXYGLUTARATE DEHYDROGENASE, MITOCHONDRIAL', 245369),
(356850, 'PTHR43104:SF4', NULL, NULL, NULL, NULL, 'L-2-HYDROXYGLUTARATE DEHYDROGENASE, MITOCHONDRIAL', 245369),
(356851, 'PTHR43104:SF3', NULL, NULL, NULL, NULL, 'DAO DOMAIN-CONTAINING PROTEIN', 245369),
(356852, 'PTHR13040:SF2', NULL, NULL, NULL, NULL, 'AUTOPHAGY PROTEIN 5', 245370),
(356853, 'PTHR13040', NULL, NULL, NULL, NULL, 'AUTOPHAGY PROTEIN 5', 245370),
(356854, 'PTHR31964:SF55', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 245371),
(356855, 'PTHR31964:SF140', NULL, NULL, NULL, NULL, 'UNIVERSAL STRESS PROTEIN FAMILY PROTEIN', 245371),
(356856, 'PTHR31964:SF142', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN-RELATED', 245371),
(356857, 'PTHR31964:SF131', NULL, NULL, NULL, NULL, 'UNIVERSAL STRESS PROTEIN A-RELATED', 245371),
(356858, 'PTHR31964:SF141', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 245371),
(356859, 'PTHR31964:SF133', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 245371),
(356860, 'PTHR31964:SF122', NULL, NULL, NULL, NULL, 'OS02G0760500 PROTEIN', 245371),
(356861, 'PTHR31964:SF124', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN', 245371),
(356862, 'PTHR31964:SF135', NULL, NULL, NULL, NULL, 'UNIVERSAL STRESS PROTEIN A-LIKE PROTEIN', 245371),
(356863, 'PTHR31964:SF113', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 245371),
(356864, 'PTHR31964:SF134', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN', 245371),
(356865, 'PTHR31964:SF126', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN', 245371),
(356866, 'PTHR31964', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN', 245371),
(356867, 'PTHR31964:SF125', NULL, NULL, NULL, NULL, 'OS05G0357525 PROTEIN', 245371),
(356868, 'PTHR31964:SF139', NULL, NULL, NULL, NULL, 'OS03G0305400 PROTEIN', 245371),
(356869, 'PTHR31964:SF128', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASE-LIKE SUPERFAMILY PROTEIN', 245371),
(356870, 'PTHR31964:SF138', NULL, NULL, NULL, NULL, 'UNIVERSAL STRESS PROTEIN A-LIKE PROTEIN', 245371),
(356871, 'PTHR37260', NULL, NULL, NULL, NULL, 'PHOSPHORELAY PROTEIN', 245372),
(356872, 'PTHR37260:SF2', NULL, NULL, NULL, NULL, 'PHOSPHORELAY PROTEIN', 245372),
(356873, 'PTHR43388', NULL, NULL, NULL, NULL, 'HYDROGENASE MATURATION FACTOR HOXX', 245373),
(356874, 'PTHR43388:SF1', NULL, NULL, NULL, NULL, 'HYDROGENASE MATURATION FACTOR HOXX', 245373),
(356875, 'PTHR10302:SF26', NULL, NULL, NULL, NULL, '', 245374),
(356876, 'PTHR10302:SF25', NULL, NULL, NULL, NULL, 'PRIMOSOMAL REPLICATION PROTEIN N', 245374),
(356877, 'PTHR10302:SF0', NULL, NULL, NULL, NULL, 'SINGLE-STRANDED DNA-BINDING PROTEIN, MITOCHONDRIAL', 245374),
(356878, 'PTHR10302:SF16', NULL, NULL, NULL, NULL, 'NUCLEIC ACID-BINDING, OB-FOLD-LIKE PROTEIN', 245374),
(356879, 'PTHR10302', NULL, NULL, NULL, NULL, 'SINGLE-STRANDED DNA-BINDING PROTEIN', 245374),
(356880, 'PTHR10302:SF18', NULL, NULL, NULL, NULL, 'PROTEIN OSB1, MITOCHONDRIAL', 245374),
(356881, 'PTHR10302:SF20', NULL, NULL, NULL, NULL, '', 245374),
(356882, 'PTHR10302:SF21', NULL, NULL, NULL, NULL, 'PROTEIN OSB2, CHLOROPLASTIC', 245374),
(356883, 'PTHR10302:SF13', NULL, NULL, NULL, NULL, 'SINGLE-STRANDED DNA-BINDING PROTEIN, MITOCHONDRIAL', 245374),
(356884, 'PTHR10302:SF12', NULL, NULL, NULL, NULL, 'PROTEIN OSB3, CHLOROPLASTIC/MITOCHONDRIAL', 245374),
(356885, 'PTHR10302:SF23', NULL, NULL, NULL, NULL, 'PROTEIN OSB4, CHLOROPLASTIC', 245374),
(356886, 'PTHR43432:SF3', NULL, NULL, NULL, NULL, 'SLR0285 PROTEIN', 245375),
(356887, 'PTHR43432:SF4', NULL, NULL, NULL, NULL, 'RADICAL SAM DOMAIN PROTEIN', 245375),
(356888, 'PTHR43432:SF2', NULL, NULL, NULL, NULL, 'ELP3 DOMAIN-CONTAINING PROTEIN', 245375),
(356889, 'PTHR43432', NULL, NULL, NULL, NULL, 'SLR0285 PROTEIN', 245375); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(356890, 'PTHR21580:SF28', NULL, NULL, NULL, NULL, 'OUTER DENSE FIBER PROTEIN 3-B', 245376),
(356891, 'PTHR21580:SF25', NULL, NULL, NULL, NULL, 'PROTEIN STPG3', 245376),
(356892, 'PTHR21580:SF3', NULL, NULL, NULL, NULL, 'OUTER DENSE FIBER PROTEIN 3-LIKE PROTEIN 1', 245376),
(356893, 'PTHR21580:SF59', NULL, NULL, NULL, NULL, '', 245376),
(356894, 'PTHR21580:SF60', NULL, NULL, NULL, NULL, 'SPERM-TAIL PG-RICH REPEAT-CONTAINING PROTEIN 2', 245376),
(356895, 'PTHR21580:SF19', NULL, NULL, NULL, NULL, 'OUTER DENSE FIBER PROTEIN 3B', 245376),
(356896, 'PTHR21580:SF61', NULL, NULL, NULL, NULL, 'AT18965P', 245376),
(356897, 'PTHR21580', NULL, NULL, NULL, NULL, 'SHIPPO-1-RELATED', 245376),
(356898, 'PTHR21580:SF23', NULL, NULL, NULL, NULL, 'OUTER DENSE FIBER PROTEIN 3', 245376),
(356899, 'PTHR21580:SF57', NULL, NULL, NULL, NULL, 'OUTER DENSE FIBER PROTEIN 3-LIKE PROTEIN 2', 245376),
(356900, 'PTHR21580:SF21', NULL, NULL, NULL, NULL, 'O(6)-METHYLGUANINE-INDUCED APOPTOSIS 2', 245376),
(356901, 'PTHR45526', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN DPIA', 245377),
(356902, 'PTHR45526:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN DPIA', 245377),
(356903, 'PTHR45526:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN DCUR', 245377),
(356904, 'PTHR30477', NULL, NULL, NULL, NULL, 'ABC-TRANSPORTER METAL-BINDING PROTEIN', 245378),
(356905, 'PTHR30477:SF21', NULL, NULL, NULL, NULL, 'ABC-3 PROTEIN', 245378),
(356906, 'PTHR30477:SF23', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY ZINC UPTAKE SYSTEM MEMBRANE PROTEIN ZNUB', 245378),
(356907, 'PTHR30477:SF8', NULL, NULL, NULL, NULL, 'METAL TRANSPORT SYSTEM MEMBRANE PROTEIN CT_070-RELATED', 245378),
(356908, 'PTHR30477:SF22', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY ZINC UPTAKE SYSTEM MEMBRANE PROTEIN ZNUB', 245378),
(356909, 'PTHR30477:SF13', NULL, NULL, NULL, NULL, 'IRON TRANSPORT SYSTEM MEMBRANE PROTEIN HI_0359-RELATED', 245378),
(356910, 'PTHR30477:SF18', NULL, NULL, NULL, NULL, 'METAL TRANSPORT SYSTEM MEMBRANE PROTEIN CT_417-RELATED', 245378),
(356911, 'PTHR30477:SF17', NULL, NULL, NULL, NULL, 'IRON TRANSPORT SYSTEM MEMBRANE PROTEIN HI_0360-RELATED', 245378),
(356912, 'PTHR30477:SF0', NULL, NULL, NULL, NULL, 'METAL TRANSPORT SYSTEM MEMBRANE PROTEIN TM_0125-RELATED', 245378),
(356913, 'PTHR30477:SF19', NULL, NULL, NULL, NULL, 'ABC-TYPE ZINC UPTAKE SYSTEM PERMEASE COMPONENT ZNUB', 245378),
(356914, 'PTHR30477:SF3', NULL, NULL, NULL, NULL, 'METAL TRANSPORT SYSTEM MEMBRANE PROTEIN CT_069-RELATED', 245378),
(356915, 'PTHR47241', NULL, NULL, NULL, NULL, 'FINGER PROTEIN, PUTATIVE-RELATED', 245379),
(356916, 'PTHR47241:SF4', NULL, NULL, NULL, NULL, 'BED-TYPE DOMAIN-CONTAINING PROTEIN', 245379),
(356917, 'PTHR47241:SF3', NULL, NULL, NULL, NULL, 'BED-TYPE DOMAIN-CONTAINING PROTEIN', 245379),
(356918, 'PTHR47241:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER BED DOMAIN-CONTAINING PROTEIN 6', 245379),
(356919, 'PTHR47241:SF1', NULL, NULL, NULL, NULL, 'FINGER PROTEIN, PUTATIVE-RELATED', 245379),
(356920, 'PTHR45649:SF41', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (EUROFUNG)-RELATED', 245380),
(356921, 'PTHR45649:SF20', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (EUROFUNG)-RELATED', 245380),
(356922, 'PTHR45649:SF42', NULL, NULL, NULL, NULL, '', 245380),
(356923, 'PTHR45649:SF18', NULL, NULL, NULL, NULL, 'OS01G0945600 PROTEIN', 245380),
(356924, 'PTHR45649:SF19', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (EUROFUNG)-RELATED', 245380),
(356925, 'PTHR45649:SF35', NULL, NULL, NULL, NULL, 'AMINO-ACID PERMEASE BAT1', 245380),
(356926, 'PTHR45649:SF13', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE', 245380),
(356927, 'PTHR45649:SF10', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER (EUROFUNG)', 245380),
(356928, 'PTHR45649:SF32', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE-RELATED', 245380),
(356929, 'PTHR45649:SF11', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (EUROFUNG)-RELATED', 245380),
(356930, 'PTHR45649:SF16', NULL, NULL, NULL, NULL, '7-KETO 8-AMINOPELARGONIC ACID TRANSPORTER', 245380),
(356931, 'PTHR45649:SF17', NULL, NULL, NULL, NULL, 'AMINO-ACID PERMEASE BAT1 HOMOLOG', 245380);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(356932, 'PTHR45649:SF39', NULL, NULL, NULL, NULL, '', 245380),
(356933, 'PTHR45649:SF36', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 245380),
(356934, 'PTHR45649:SF14', NULL, NULL, NULL, NULL, 'GABA PERMEASE', 245380),
(356935, 'PTHR45649:SF15', NULL, NULL, NULL, NULL, 'CHOLINE TRANSPORTER (EUROFUNG)', 245380),
(356936, 'PTHR45649:SF37', NULL, NULL, NULL, NULL, 'AMINO-ACID PERMEASE BAT1-LIKE PROTEIN', 245380),
(356937, 'PTHR45649:SF30', NULL, NULL, NULL, NULL, 'AMINO-ACID PERMEASE BAT1', 245380),
(356938, 'PTHR45649:SF52', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE', 245380),
(356939, 'PTHR45649:SF31', NULL, NULL, NULL, NULL, '', 245380),
(356940, 'PTHR45649', NULL, NULL, NULL, NULL, 'AMINO-ACID PERMEASE BAT1', 245380),
(356941, 'PTHR45649:SF50', NULL, NULL, NULL, NULL, '', 245380),
(356942, 'PTHR45649:SF51', NULL, NULL, NULL, NULL, 'THIAMINE TRANSPORTER THI9', 245380),
(356943, 'PTHR45649:SF5', NULL, NULL, NULL, NULL, 'GABA TRANSPORTER (EUROFUNG)-RELATED', 245380),
(356944, 'PTHR45649:SF6', NULL, NULL, NULL, NULL, 'GABA-SPECIFIC PERMEASE', 245380),
(356945, 'PTHR45649:SF29', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER (EUROFUNG)', 245380),
(356946, 'PTHR45649:SF7', NULL, NULL, NULL, NULL, 'CHOLINE TRANSPORT PROTEIN', 245380),
(356947, 'PTHR45649:SF8', NULL, NULL, NULL, NULL, 'PERMEASE, PUTATIVE-RELATED', 245380),
(356948, 'PTHR45649:SF1', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (EUROFUNG)-RELATED', 245380),
(356949, 'PTHR45649:SF2', NULL, NULL, NULL, NULL, 'ACID PERMEASE, PUTATIVE-RELATED', 245380),
(356950, 'PTHR45649:SF3', NULL, NULL, NULL, NULL, 'POLYAMINE TRANSPORTER TPO5', 245380),
(356951, 'PTHR45649:SF4', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (EUROFUNG)-RELATED', 245380),
(356952, 'PTHR45649:SF23', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (EUROFUNG)-RELATED', 245380),
(356953, 'PTHR45649:SF45', NULL, NULL, NULL, NULL, '', 245380),
(356954, 'PTHR45649:SF24', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G15150)-RELATED', 245380),
(356955, 'PTHR45649:SF46', NULL, NULL, NULL, NULL, 'BNAA02G27130D PROTEIN', 245380),
(356956, 'PTHR45649:SF21', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (EUROFUNG)-RELATED', 245380),
(356957, 'PTHR45649:SF43', NULL, NULL, NULL, NULL, 'AMINO-ACID PERMEASE BAT1 HOMOLOG ISOFORM X1', 245380),
(356958, 'PTHR45649:SF22', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (EUROFUNG)-RELATED', 245380),
(356959, 'PTHR45649:SF27', NULL, NULL, NULL, NULL, 'CHOLINE TRANSPORTER (EUROFUNG)', 245380),
(356960, 'PTHR45649:SF49', NULL, NULL, NULL, NULL, '', 245380),
(356961, 'PTHR45649:SF9', NULL, NULL, NULL, NULL, 'AMINO-ACID PERMEASE 2', 245380),
(356962, 'PTHR45649:SF28', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (EUROFUNG)-RELATED', 245380),
(356963, 'PTHR45649:SF47', NULL, NULL, NULL, NULL, 'BNAA06G34530D PROTEIN', 245380),
(356964, 'PTHR45649:SF25', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (EUROFUNG)-RELATED', 245380),
(356965, 'PTHR45649:SF48', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE', 245380),
(356966, 'PTHR45649:SF26', NULL, NULL, NULL, NULL, 'OS04G0435100 PROTEIN', 245380),
(356967, 'PTHR12239', NULL, NULL, NULL, NULL, 'PROTEIN CBG20215-RELATED', 245381),
(356968, 'PTHR12239:SF41', NULL, NULL, NULL, NULL, 'TOLA PROTEIN', 245381),
(356969, 'PTHR34652:SF2', NULL, NULL, NULL, NULL, 'AGAP002134-PA', 245382),
(356970, 'PTHR34652', NULL, NULL, NULL, NULL, 'AGAP002134-PA', 245382),
(356971, 'PTHR37243:SF2', NULL, NULL, NULL, NULL, 'NEGATIVE REGULATOR OF SYSTEMIC ACQUIRED RESISTANCE SNI1', 245383),
(356972, 'PTHR37243', NULL, NULL, NULL, NULL, 'NEGATIVE REGULATOR OF SYSTEMIC ACQUIRED RESISTANCE SNI1', 245383),
(356973, 'PTHR46790:SF1', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN N', 245384),
(356974, 'PTHR46790', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN N', 245384),
(356975, 'PTHR12211:SF2', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM RESIDENT PROTEIN 29', 245385),
(356976, 'PTHR12211:SF1', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM RESIDENT PROTEIN 29', 245385),
(356977, 'PTHR12211:SF0', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM RESIDENT PROTEIN 29', 245385);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(356978, 'PTHR12211', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM PROTEIN ERP29', 245385),
(356979, 'PTHR43543:SF1', NULL, NULL, NULL, NULL, 'MALONIC SEMIALDEHYDE REDUCTASE RUTE-RELATED', 245386),
(356980, 'PTHR43543', NULL, NULL, NULL, NULL, 'MALONIC SEMIALDEHYDE REDUCTASE RUTE-RELATED', 245386),
(356981, 'PTHR36157:SF3', NULL, NULL, NULL, NULL, 'DX DOMAIN-CONTAINING PROTEIN', 245387),
(356982, 'PTHR36157', NULL, NULL, NULL, NULL, 'PROTEIN CBG12671-RELATED', 245387),
(356983, 'PTHR36157:SF2', NULL, NULL, NULL, NULL, 'DX DOMAIN-CONTAINING PROTEIN', 245387),
(356984, 'PTHR36157:SF1', NULL, NULL, NULL, NULL, 'DX DOMAIN-CONTAINING PROTEIN', 245387),
(356985, 'PTHR10357:SF222', NULL, NULL, NULL, NULL, 'MALTASE MALT (AFU_ORTHOLOGUE AFUA_8G07070)', 245388),
(356986, 'PTHR10357:SF224', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE 3', 245388),
(356987, 'PTHR10357:SF223', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE MDE5', 245388),
(356988, 'PTHR10357:SF184', NULL, NULL, NULL, NULL, 'OLIGO-1,6-GLUCOSIDASE 1', 245388),
(356989, 'PTHR10357:SF220', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE', 245388),
(356990, 'PTHR10357:SF208', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE', 245388),
(356991, 'PTHR10357:SF229', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE', 245388),
(356992, 'PTHR10357:SF209', NULL, NULL, NULL, NULL, 'PERIPLASMIC ALPHA-AMYLASE', 245388),
(356993, 'PTHR10357:SF226', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE 4', 245388),
(356994, 'PTHR10357:SF203', NULL, NULL, NULL, NULL, 'ALPHA-1,4-GLUCAN:MALTOSE-1-PHOSPHATE MALTOSYLTRANSFERASE 2', 245388),
(356995, 'PTHR10357:SF225', NULL, NULL, NULL, NULL, 'MALTASE 1-LIKE PROTEIN', 245388),
(356996, 'PTHR10357:SF228', NULL, NULL, NULL, NULL, 'ALPHA AMYLASE, CATALYTIC DOMAIN CONTAINING PROTEIN', 245388),
(356997, 'PTHR10357:SF227', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE 2', 245388),
(356998, 'PTHR10357:SF205', NULL, NULL, NULL, NULL, 'O-GLYCOSYL HYDROLASE FAMILY 13', 245388),
(356999, 'PTHR10357:SF178', NULL, NULL, NULL, NULL, 'OLIGO-1,6-GLUCOSIDASE 3-RELATED', 245388),
(357000, 'PTHR10357:SF199', NULL, NULL, NULL, NULL, 'ALPHA AMYLASE CATALYTIC REGION', 245388),
(357001, 'PTHR10357:SF232', NULL, NULL, NULL, NULL, 'AAMY DOMAIN-CONTAINING PROTEIN', 245388),
(357002, 'PTHR10357:SF210', NULL, NULL, NULL, NULL, 'MALTODEXTRIN GLUCOSIDASE', 245388),
(357003, 'PTHR10357:SF213', NULL, NULL, NULL, NULL, 'ALPHA AMYLASE CATALYTIC REGION', 245388),
(357004, 'PTHR10357:SF179', NULL, NULL, NULL, NULL, 'NEUTRAL AND BASIC AMINO ACID TRANSPORT PROTEIN RBAT', 245388),
(357005, 'PTHR10357:SF212', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE', 245388),
(357006, 'PTHR10357:SF231', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE', 245388),
(357007, 'PTHR10357:SF230', NULL, NULL, NULL, NULL, 'AAMY DOMAIN-CONTAINING PROTEIN', 245388),
(357008, 'PTHR10357:SF219', NULL, NULL, NULL, NULL, 'MALTOSE ALPHA-D-GLUCOSYLTRANSFERASE', 245388),
(357009, 'PTHR10357:SF218', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE', 245388),
(357010, 'PTHR10357:SF215', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE 1', 245388),
(357011, 'PTHR10357', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE FAMILY MEMBER', 245388),
(357012, 'PTHR10357:SF214', NULL, NULL, NULL, NULL, 'GLUCOSYLGLYCERATE PHOSPHORYLASE', 245388),
(357013, 'PTHR10357:SF217', NULL, NULL, NULL, NULL, 'TREHALOSE-6-PHOSPHATE HYDROLASE', 245388),
(357014, 'PTHR10357:SF216', NULL, NULL, NULL, NULL, 'MALTOOLIGOSYL TREHALOSE SYNTHASE-RELATED', 245388),
(357015, 'PTHR43425', NULL, NULL, NULL, NULL, 'OXYGEN-INSENSITIVE NADPH NITROREDUCTASE', 245389),
(357016, 'PTHR43425:SF3', NULL, NULL, NULL, NULL, 'FMN REDUCTASE (NADPH)', 245389),
(357017, 'PTHR43425:SF2', NULL, NULL, NULL, NULL, 'OXYGEN-INSENSITIVE NADPH NITROREDUCTASE', 245389),
(357018, 'PTHR43068:SF1', NULL, NULL, NULL, NULL, 'SLR1854 PROTEIN', 245390),
(357019, 'PTHR43068', NULL, NULL, NULL, NULL, 'SLR1854 PROTEIN', 245390),
(357020, 'PTHR11921:SF40', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE [UBIQUINONE] IRON-SULFUR SUBUNIT 3, MITOCHONDRIAL', 245391),
(357021, 'PTHR11921:SF29', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE [UBIQUINONE] IRON-SULFUR SUBUNIT, MITOCHONDRIAL', 245391);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(357022, 'PTHR11921', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE IRON-SULFUR PROTEIN', 245391),
(357023, 'PTHR11921:SF45', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE-RELATED', 245391),
(357024, 'PTHR11921:SF35', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE [IRON-SULFUR SUBUNIT] (SUCCINIC DEHYDROGENASE)-RELATED', 245391),
(357025, 'PTHR11921:SF36', NULL, NULL, NULL, NULL, 'FUMARATE REDUCTASE IRON-SULFUR SUBUNIT', 245391),
(357026, 'PTHR11921:SF41', NULL, NULL, NULL, NULL, '4FE-4S FERREDOXIN IRON-SULFUR BINDING DOMAIN PROTEIN', 245391),
(357027, 'PTHR11921:SF42', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE [UBIQUINONE] IRON-SULFUR SUBUNIT, MITOCHONDRIAL', 245391),
(357028, 'PTHR11921:SF43', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE [UBIQUINONE] IRON-SULFUR SUBUNIT, MITOCHONDRIAL', 245391),
(357029, 'PTHR11921:SF44', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE [UBIQUINONE] IRON-SULFUR SUBUNIT, MITOCHONDRIAL', 245391),
(357030, 'PTHR14368:SF7', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED BASIC PROTEIN 1', 245392),
(357031, 'PTHR14368', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED BASIC PROTEIN 1', 245392),
(357032, 'PTHR41964:SF1', NULL, NULL, NULL, NULL, 'GLOBAL NITROGEN REGULATOR NRPR', 245393),
(357033, 'PTHR41964', NULL, NULL, NULL, NULL, 'GLOBAL NITROGEN REGULATOR NRPR', 245393),
(357034, 'PTHR31268:SF8', NULL, NULL, NULL, NULL, 'GALACTINOL--SUCROSE GALACTOSYLTRANSFERASE 4-RELATED', 245394),
(357035, 'PTHR31268:SF5', NULL, NULL, NULL, NULL, 'GALACTINOL--SUCROSE GALACTOSYLTRANSFERASE 6-RELATED', 245394),
(357036, 'PTHR31268:SF31', NULL, NULL, NULL, NULL, '', 245394),
(357037, 'PTHR31268', NULL, NULL, NULL, NULL, '', 245394),
(357038, 'PTHR31268:SF40', NULL, NULL, NULL, NULL, 'GALACTINOL--SUCROSE GALACTOSYLTRANSFERASE 2-RELATED', 245394),
(357039, 'PTHR31268:SF12', NULL, NULL, NULL, NULL, 'STACHYOSE SYNTHASE-LIKE', 245394),
(357040, 'PTHR31268:SF34', NULL, NULL, NULL, NULL, 'GALACTINOL--SUCROSE GALACTOSYLTRANSFERASE', 245394),
(357041, 'PTHR31268:SF35', NULL, NULL, NULL, NULL, 'GALACTINOL--SUCROSE GALACTOSYLTRANSFERASE', 245394),
(357042, 'PTHR31268:SF10', NULL, NULL, NULL, NULL, 'GALACTINOL--SUCROSE GALACTOSYLTRANSFERASE 2-RELATED', 245394),
(357043, 'PTHR31268:SF32', NULL, NULL, NULL, NULL, 'GALACTINOL--SUCROSE GALACTOSYLTRANSFERASE 2-RELATED', 245394),
(357044, 'PTHR31268:SF38', NULL, NULL, NULL, NULL, 'GALACTINOL--SUCROSE GALACTOSYLTRANSFERASE', 245394),
(357045, 'PTHR31268:SF39', NULL, NULL, NULL, NULL, 'GALACTINOL--SUCROSE GALACTOSYLTRANSFERASE-RELATED', 245394),
(357046, 'PTHR31268:SF14', NULL, NULL, NULL, NULL, 'GALACTINOL--SUCROSE GALACTOSYLTRANSFERASE 5-RELATED', 245394),
(357047, 'PTHR31268:SF36', NULL, NULL, NULL, NULL, 'SYNTHASE, PUTATIVE-RELATED', 245394),
(357048, 'PTHR31268:SF37', NULL, NULL, NULL, NULL, 'GALACTINOL--SUCROSE GALACTOSYLTRANSFERASE', 245394),
(357049, 'PTHR31268:SF26', NULL, NULL, NULL, NULL, 'GALACTINOL--SUCROSE GALACTOSYLTRANSFERASE 2-RELATED', 245394),
(357050, 'PTHR31268:SF29', NULL, NULL, NULL, NULL, 'GALACTINOL--SUCROSE GALACTOSYLTRANSFERASE 1-RELATED', 245394),
(357051, 'PTHR37096', NULL, NULL, NULL, NULL, 'YALI0E33429P', 245395),
(357052, 'PTHR37096:SF1', NULL, NULL, NULL, NULL, 'ATPASE_AAA_CORE DOMAIN-CONTAINING PROTEIN', 245395),
(357053, 'PTHR13083', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 245396),
(357054, 'PTHR13083:SF3', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 91', 245396),
(357055, 'PTHR44303', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 16', 245397),
(357056, 'PTHR44303:SF2', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 16', 245397),
(357057, 'PTHR44303:SF1', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 16', 245397),
(357058, 'PTHR44303:SF3', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 16', 245397),
(357059, 'PTHR35137:SF1', NULL, NULL, NULL, NULL, 'CHROMOPHORE LYASE CRL, CHLOROPLASTIC', 245398),
(357060, 'PTHR35137:SF4', NULL, NULL, NULL, NULL, 'BNAA01G14430D PROTEIN', 245398),
(357061, 'PTHR35137', NULL, NULL, NULL, NULL, 'CHROMOPHORE LYASE CRL, CHLOROPLASTIC', 245398);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(357062, 'PTHR31032:SF9', NULL, NULL, NULL, NULL, 'PGR5-LIKE PROTEIN 1A, CHLOROPLASTIC', 245399),
(357063, 'PTHR31032:SF7', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245399),
(357064, 'PTHR31032:SF2', NULL, NULL, NULL, NULL, 'PGR5-LIKE A PROTEIN', 245399),
(357065, 'PTHR31032:SF1', NULL, NULL, NULL, NULL, 'PGR5-LIKE PROTEIN 1B, CHLOROPLASTIC', 245399),
(357066, 'PTHR31032:SF10', NULL, NULL, NULL, NULL, 'PGR5-LIKE PROTEIN 1A', 245399),
(357067, 'PTHR31032', NULL, NULL, NULL, NULL, 'PGR5-LIKE PROTEIN 1B, CHLOROPLASTIC', 245399),
(357068, 'PTHR31032:SF12', NULL, NULL, NULL, NULL, 'BNAC01G14340D PROTEIN', 245399),
(357069, 'PTHR31032:SF13', NULL, NULL, NULL, NULL, 'PGR5-LIKE PROTEIN 1A, CHLOROPLASTIC', 245399),
(357070, 'PTHR14492', NULL, NULL, NULL, NULL, 'JBTS17', 245400),
(357071, 'PTHR14492:SF4', NULL, NULL, NULL, NULL, 'CILIOGENESIS AND PLANAR POLARITY EFFECTOR 1', 245400),
(357072, 'PTHR36333:SF1', NULL, NULL, NULL, NULL, 'DIMETHYLALLYL, ADENOSINE TRNA METHYLTHIOTRANSFERASE', 245401),
(357073, 'PTHR36333', NULL, NULL, NULL, NULL, 'DIMETHYLALLYL, ADENOSINE TRNA METHYLTHIOTRANSFERASE', 245401),
(357074, 'PTHR12863:SF21', NULL, NULL, NULL, NULL, 'FATTY ACID 2-HYDROXYLASE', 245402),
(357075, 'PTHR12863:SF11', NULL, NULL, NULL, NULL, 'DIHYDROCERAMIDE FATTY ACYL 2-HYDROXYLASE FAH2-LIKE', 245402),
(357076, 'PTHR12863:SF20', NULL, NULL, NULL, NULL, 'DIHYDROCERAMIDE FATTY ACYL 2-HYDROXYLASE FAH1-LIKE ISOFORM X1', 245402),
(357077, 'PTHR12863:SF15', NULL, NULL, NULL, NULL, 'FATTY ACID 2-HYDROXYLASE-LIKE PROTEIN', 245402),
(357078, 'PTHR12863:SF12', NULL, NULL, NULL, NULL, 'FATTY ACID HYDROXYLASE DOMAIN-CONTAINING PROTEIN', 245402),
(357079, 'PTHR12863:SF13', NULL, NULL, NULL, NULL, 'DIHYDROCERAMIDE FATTY ACYL 2-HYDROXYLASE FAH2', 245402),
(357080, 'PTHR12863', NULL, NULL, NULL, NULL, 'FATTY ACID HYDROXYLASE', 245402),
(357081, 'PTHR12863:SF19', NULL, NULL, NULL, NULL, 'ALDEHYDE OXYGENASE (DEFORMYLATING)', 245402),
(357082, 'PTHR12863:SF16', NULL, NULL, NULL, NULL, 'FATTY ACID HYDROXYLASE DOMAIN-CONTAINING PROTEIN', 245402),
(357083, 'PTHR12863:SF1', NULL, NULL, NULL, NULL, 'FATTY ACID 2-HYDROXYLASE', 245402),
(357084, 'PTHR11662:SF53', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245403),
(357085, 'PTHR11662:SF72', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245403),
(357086, 'PTHR11662:SF418', NULL, NULL, NULL, NULL, 'VESICULAR GLUTAMATE TRANSPORTER, ISOFORM A', 245403),
(357087, 'PTHR11662:SF79', NULL, NULL, NULL, NULL, 'NA[+]-DEPENDENT INORGANIC PHOSPHATE COTRANSPORTER, ISOFORM A', 245403),
(357088, 'PTHR11662:SF77', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY TRANSPORTER 17, ISOFORM F', 245403),
(357089, 'PTHR11662:SF415', NULL, NULL, NULL, NULL, 'AT30085P-RELATED', 245403),
(357090, 'PTHR11662:SF314', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245403),
(357091, 'PTHR11662:SF336', NULL, NULL, NULL, NULL, 'LP19554P', 245403),
(357092, 'PTHR11662:SF399', NULL, NULL, NULL, NULL, 'GH23975P', 245403),
(357093, 'PTHR11662:SF432', NULL, NULL, NULL, NULL, 'SIALIN', 245403),
(357094, 'PTHR11662:SF333', NULL, NULL, NULL, NULL, 'D-GALACTONATE TRANSPORTER', 245403),
(357095, 'PTHR11662:SF411', NULL, NULL, NULL, NULL, 'GH05102P', 245403),
(357096, 'PTHR11662:SF279', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 17 MEMBER 9', 245403),
(357097, 'PTHR11662:SF331', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245403),
(357098, 'PTHR11662:SF452', NULL, NULL, NULL, NULL, 'PROTEIN CBG10101', 245403),
(357099, 'PTHR11662:SF134', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT PHOSPHATE TRANSPORT PROTEIN 4', 245403),
(357100, 'PTHR11662:SF453', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245403),
(357101, 'PTHR11662:SF255', NULL, NULL, NULL, NULL, 'ASCORBATE TRANSPORTER, CHLOROPLASTIC', 245403),
(357102, 'PTHR11662:SF450', NULL, NULL, NULL, NULL, 'BLR1003 PROTEIN', 245403),
(357103, 'PTHR11662:SF451', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245403),
(357104, 'PTHR11662:SF193', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT PHOSPHATE TRANSPORT PROTEIN 3', 245403);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(357105, 'PTHR11662:SF40', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245403),
(357106, 'PTHR11662:SF60', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245403),
(357107, 'PTHR11662:SF26', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT PHOSPHATE TRANSPORT PROTEIN 1', 245403),
(357108, 'PTHR11662:SF207', NULL, NULL, NULL, NULL, 'VESICULAR GLUTAMATE TRANSPORTER 3', 245403),
(357109, 'PTHR11662:SF449', NULL, NULL, NULL, NULL, 'SI:CH1073-513E17.1', 245403),
(357110, 'PTHR11662:SF405', NULL, NULL, NULL, NULL, 'PROTEIN CBG12249', 245403),
(357111, 'PTHR11662:SF447', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER 4,6-RELATED', 245403),
(357112, 'PTHR11662:SF448', NULL, NULL, NULL, NULL, 'FI19708P1', 245403),
(357113, 'PTHR11662:SF206', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245403),
(357114, 'PTHR11662:SF445', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245403),
(357115, 'PTHR11662:SF247', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245403),
(357116, 'PTHR11662:SF446', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT PHOSPHATE TRANSPORT PROTEIN 1, CHLOROPLASTIC', 245403),
(357117, 'PTHR11662:SF424', NULL, NULL, NULL, NULL, 'ANION TRANSPORTER 4, CHLOROPLASTIC-RELATED', 245403),
(357118, 'PTHR11662:SF201', NULL, NULL, NULL, NULL, 'VESICULAR GLUTAMATE TRANSPORTER 2', 245403),
(357119, 'PTHR11662:SF444', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245403),
(357120, 'PTHR11662:SF243', NULL, NULL, NULL, NULL, 'ANION TRANSPORTER 6, CHLOROPLASTIC-RELATED', 245403),
(357121, 'PTHR11662:SF145', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245403),
(357122, 'PTHR11662:SF442', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245403),
(357123, 'PTHR11662:SF29', NULL, NULL, NULL, NULL, 'VESICULAR GLUTAMATE TRANSPORTER 1', 245403),
(357124, 'PTHR11662:SF285', NULL, NULL, NULL, NULL, 'HEXURONATE TRANSPORTER', 245403),
(357125, 'PTHR11662', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 17', 245403),
(357126, 'PTHR11662:SF284', NULL, NULL, NULL, NULL, 'SMALL INTESTINE URATE EXPORTER-RELATED', 245403),
(357127, 'PTHR11662:SF282', NULL, NULL, NULL, NULL, 'ANION TRANSPORTER 5-RELATED', 245403),
(357128, 'PTHR11662:SF280', NULL, NULL, NULL, NULL, 'FI21844P1-RELATED', 245403),
(357129, 'PTHR43472:SF1', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLAMINE--GLYCINE LIGASE, CHLOROPLASTIC', 245404),
(357130, 'PTHR43472:SF6', NULL, NULL, NULL, NULL, 'GLYCINAMIDE RIBONUCLEOTIDE SYNTHETASE', 245404),
(357131, 'PTHR43472', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLAMINE--GLYCINE LIGASE', 245404),
(357132, 'PTHR21661:SF35', NULL, NULL, NULL, NULL, 'EPOXIDE HYDROLASE', 245405),
(357133, 'PTHR21661:SF78', NULL, NULL, NULL, NULL, 'EPOXIDE HYDROLASE 1', 245405),
(357134, 'PTHR21661:SF39', NULL, NULL, NULL, NULL, 'HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G08960)-RELATED', 245405),
(357135, 'PTHR21661:SF16', NULL, NULL, NULL, NULL, 'EPOXIDE HYDROLASE', 245405),
(357136, 'PTHR21661:SF71', NULL, NULL, NULL, NULL, 'EHN DOMAIN-CONTAINING PROTEIN', 245405),
(357137, 'PTHR21661:SF70', NULL, NULL, NULL, NULL, 'EPOXIDE HYDROLASE', 245405),
(357138, 'PTHR21661', NULL, NULL, NULL, NULL, 'EPOXIDE HYDROLASE 1-RELATED', 245405),
(357139, 'PTHR15381', NULL, NULL, NULL, NULL, 'CHONDROITIN SULFATE PROTEOGLYCAN 5 -RELATED', 245406),
(357140, 'PTHR15381:SF1', NULL, NULL, NULL, NULL, 'CHONDROITIN SULFATE PROTEOGLYCAN 5', 245406),
(357141, 'PTHR34141', NULL, NULL, NULL, NULL, '', 245407),
(357142, 'PTHR34141:SF2', NULL, NULL, NULL, NULL, '', 245407),
(357143, 'PTHR34141:SF1', NULL, NULL, NULL, NULL, '', 245407),
(357144, 'PTHR35476:SF2', NULL, NULL, NULL, NULL, 'MUCIN-LIKE PROTEIN', 245408),
(357145, 'PTHR35476:SF3', NULL, NULL, NULL, NULL, 'PROTEIN GAMETE CELL DEFECTIVE 1, MITOCHONDRIAL', 245408),
(357146, 'PTHR35476:SF4', NULL, NULL, NULL, NULL, 'BNAA02G33330D PROTEIN', 245408),
(357147, 'PTHR35476', NULL, NULL, NULL, NULL, 'MUCIN-LIKE PROTEIN', 245408),
(357148, 'PTHR43836:SF9', NULL, NULL, NULL, NULL, 'O-METHYLTRANSFERASE', 245409),
(357149, 'PTHR43836:SF8', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_5G06990)-RELATED', 245409);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(357150, 'PTHR43836', NULL, NULL, NULL, NULL, 'CATECHOL O-METHYLTRANSFERASE 1-RELATED', 245409),
(357151, 'PTHR43836:SF6', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_2G00150)-RELATED', 245409),
(357152, 'PTHR43836:SF3', NULL, NULL, NULL, NULL, 'CATECHOL O-METHYLTRANSFERASE', 245409),
(357153, 'PTHR43836:SF2', NULL, NULL, NULL, NULL, 'CATECHOL O-METHYLTRANSFERASE 1-RELATED', 245409),
(357154, 'PTHR43836:SF1', NULL, NULL, NULL, NULL, 'CATECHOL O-METHYLTRANSFERASE 2-RELATED', 245409),
(357155, 'PTHR15959:SF1', NULL, NULL, NULL, NULL, 'SYNTAXIN-18', 245410),
(357156, 'PTHR15959:SF0', NULL, NULL, NULL, NULL, 'SYNTAXIN-18', 245410),
(357157, 'PTHR15959', NULL, NULL, NULL, NULL, 'SYNTAXIN-18', 245410),
(357158, 'PTHR15959:SF2', NULL, NULL, NULL, NULL, 'SYNTAXIN-18', 245410),
(357159, 'PTHR14636', NULL, NULL, NULL, NULL, 'TPA-INDUCED TRANSMEMBRANE PROTEIN', 245411),
(357160, 'PTHR14636:SF1', NULL, NULL, NULL, NULL, 'TPA-INDUCED TRANSMEMBRANE PROTEIN', 245411),
(357161, 'PTHR30450:SF5', NULL, NULL, NULL, NULL, 'HISTIDINE TRANSPORT SYSTEM PERMEASE PROTEIN HISM', 245412),
(357162, 'PTHR30450:SF8', NULL, NULL, NULL, NULL, 'D-METHIONINE TRANSPORT SYSTEM PERMEASE PROTEIN METI', 245412),
(357163, 'PTHR30450:SF1', NULL, NULL, NULL, NULL, 'D-METHIONINE TRANSPORT SYSTEM PERMEASE PROTEIN METI-RELATED', 245412),
(357164, 'PTHR30450', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE', 245412),
(357165, 'PTHR30450:SF2', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN', 245412),
(357166, 'PTHR30450:SF14', NULL, NULL, NULL, NULL, 'TRANSPORTER, PERMEASE PROTEIN, PUTATIVE-RELATED', 245412),
(357167, 'PTHR37333:SF1', NULL, NULL, NULL, NULL, 'LEUCINE-RICH SINGLE-PASS MEMBRANE PROTEIN 2', 245413),
(357168, 'PTHR37333', NULL, NULL, NULL, NULL, 'LEUCINE-RICH SINGLE-PASS MEMBRANE PROTEIN 2', 245413),
(357169, 'PTHR47240', NULL, NULL, NULL, NULL, 'CHROMO DOMAIN-CONTAINING PROTEIN LHP1', 245414),
(357170, 'PTHR47240:SF6', NULL, NULL, NULL, NULL, 'CHROMO DOMAIN PROTEIN LHP1', 245414),
(357171, 'PTHR47240:SF5', NULL, NULL, NULL, NULL, 'CHROMO DOMAIN PROTEIN LHP1-RELATED', 245414),
(357172, 'PTHR47240:SF4', NULL, NULL, NULL, NULL, 'CHROMO DOMAIN-CONTAINING PROTEIN', 245414),
(357173, 'PTHR47240:SF2', NULL, NULL, NULL, NULL, 'CHROMO DOMAIN-CONTAINING PROTEIN LHP1', 245414),
(357174, 'PTHR11722:SF0', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L13', 245415),
(357175, 'PTHR11722:SF19', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L13-1-LIKE', 245415),
(357176, 'PTHR11722:SF18', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L13', 245415),
(357177, 'PTHR11722:SF16', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L13', 245415),
(357178, 'PTHR11722:SF14', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L13', 245415),
(357179, 'PTHR11722:SF13', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L13', 245415),
(357180, 'PTHR11722:SF12', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L13-1-RELATED', 245415),
(357181, 'PTHR11722:SF21', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L13', 245415),
(357182, 'PTHR11722:SF20', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L13', 245415),
(357183, 'PTHR11722', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L13', 245415),
(357184, 'PTHR11722:SF9', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L13', 245415),
(357185, 'PTHR11722:SF4', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L13', 245415),
(357186, 'PTHR11722:SF5', NULL, NULL, NULL, NULL, '', 245415),
(357187, 'PTHR34438', NULL, NULL, NULL, NULL, 'SI:DKEY-97L20.6', 245416),
(357188, 'PTHR34438:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME A3 C2ORF81 HOMOLOG', 245416),
(357189, 'PTHR15919:SF12', NULL, NULL, NULL, NULL, 'DAPPER HOMOLOG 1', 245417),
(357190, 'PTHR15919', NULL, NULL, NULL, NULL, 'DAPPER-RELATED', 245417),
(357191, 'PTHR15919:SF1', NULL, NULL, NULL, NULL, 'DAPPER HOMOLOG 3', 245417),
(357192, 'PTHR15919:SF14', NULL, NULL, NULL, NULL, 'SI:CH211-168F7.5', 245417),
(357193, 'PTHR15919:SF13', NULL, NULL, NULL, NULL, 'DAPPER HOMOLOG 2', 245417),
(357194, 'PTHR13469:SF8', NULL, NULL, NULL, NULL, 'HEXIM P-TEFB COMPLEX SUBUNIT 1', 245418); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(357195, 'PTHR13469:SF9', NULL, NULL, NULL, NULL, '', 245418),
(357196, 'PTHR13469:SF7', NULL, NULL, NULL, NULL, 'PROTEIN HEXIM1', 245418),
(357197, 'PTHR13469', NULL, NULL, NULL, NULL, 'HEXAMETHYLENE BISACETAMIDE INDUCIBLE 1', 245418),
(357198, 'PTHR13469:SF3', NULL, NULL, NULL, NULL, 'PROTEIN HEXIM2', 245418),
(357199, 'PTHR46651:SF5', NULL, NULL, NULL, NULL, 'SMR DOMAIN-CONTAINING PROTEIN', 245419),
(357200, 'PTHR46651:SF3', NULL, NULL, NULL, NULL, 'SMR DOMAIN-CONTAINING PROTEIN-RELATED', 245419),
(357201, 'PTHR46651', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN-INTERACTING PROTEIN 7', 245419),
(357202, 'PTHR46651:SF1', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN-INTERACTING PROTEIN 7', 245419),
(357203, 'PTHR46651:SF2', NULL, NULL, NULL, NULL, 'ATAXIN-2 C-TERMINAL REGION FAMILY PROTEIN, EXPRESSED', 245419),
(357204, 'PTHR36574:SF1', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONATE LYASE-RELATED', 245420),
(357205, 'PTHR36574', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONATE LYASE-RELATED', 245420),
(357206, 'PTHR16062:SF13', NULL, NULL, NULL, NULL, 'CHROMATIN STRUCTURE-REMODELING COMPLEX SUBUNIT RSC4', 245421),
(357207, 'PTHR16062:SF22', NULL, NULL, NULL, NULL, 'BAH DOMAINCONTAINING PROTEIN', 245421),
(357208, 'PTHR16062:SF23', NULL, NULL, NULL, NULL, 'CHROMOSOME 8, WHOLE GENOME SHOTGUN SEQUENCE', 245421),
(357209, 'PTHR16062:SF20', NULL, NULL, NULL, NULL, 'CHROMATIN STRUCTURE-REMODELING COMPLEX SUBUNIT RSC4', 245421),
(357210, 'PTHR16062:SF21', NULL, NULL, NULL, NULL, 'CHROMATIN STRUCTURE-REMODELING COMPLEX SUBUNIT RSC1-RELATED', 245421),
(357211, 'PTHR16062', NULL, NULL, NULL, NULL, 'SWI/SNF-RELATED', 245421),
(357212, 'PTHR16062:SF19', NULL, NULL, NULL, NULL, 'PROTEIN POLYBROMO-1', 245421),
(357213, 'PTHR45653:SF10', NULL, NULL, NULL, NULL, 'SPONGE, ISOFORM E', 245422),
(357214, 'PTHR45653:SF8', NULL, NULL, NULL, NULL, 'DOCKER DOMAIN-CONTAINING PROTEIN', 245422),
(357215, 'PTHR45653:SF5', NULL, NULL, NULL, NULL, '', 245422),
(357216, 'PTHR45653:SF4', NULL, NULL, NULL, NULL, 'DEDICATOR OF CYTOKINESIS PROTEIN 3', 245422),
(357217, 'PTHR45653:SF7', NULL, NULL, NULL, NULL, 'DEDICATOR OF CYTOKINESIS PROTEIN 4', 245422),
(357218, 'PTHR45653:SF6', NULL, NULL, NULL, NULL, 'DEDICATOR OF CYTOKINESIS PROTEIN 2', 245422),
(357219, 'PTHR45653:SF11', NULL, NULL, NULL, NULL, 'MYOBLAST CITY, ISOFORM B', 245422),
(357220, 'PTHR45653:SF1', NULL, NULL, NULL, NULL, 'DEDICATOR OF CYTOKINESIS PROTEIN 1', 245422),
(357221, 'PTHR45653', NULL, NULL, NULL, NULL, 'DEDICATOR OF CYTOKINESIS', 245422),
(357222, 'PTHR45653:SF3', NULL, NULL, NULL, NULL, 'DEDICATOR OF CYTOKINESIS PROTEIN 5', 245422),
(357223, 'PTHR45653:SF2', NULL, NULL, NULL, NULL, '', 245422),
(357224, 'PTHR43033:SF1', NULL, NULL, NULL, NULL, 'TRNA(ILE)-LYSIDINE SYNTHASE-RELATED', 245423),
(357225, 'PTHR43033:SF4', NULL, NULL, NULL, NULL, 'TRNA(ILE)-LYSIDINE SYNTHASE', 245423),
(357226, 'PTHR43033:SF3', NULL, NULL, NULL, NULL, 'TRNA(ILE)-2-LYSYL-CYTIDINE SYNTHASE', 245423),
(357227, 'PTHR43033', NULL, NULL, NULL, NULL, 'TRNA(ILE)-LYSIDINE SYNTHASE-RELATED', 245423),
(357228, 'PTHR34118:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CONSERVED ONLY IN THE GREEN LINEAGE 160, CHLOROPLASTIC', 245424),
(357229, 'PTHR34118', NULL, NULL, NULL, NULL, 'NF-KAPPA-B INHIBITOR-LIKE PROTEIN-RELATED', 245424),
(357230, 'PTHR34118:SF4', NULL, NULL, NULL, NULL, '', 245424),
(357231, 'PTHR34118:SF1', NULL, NULL, NULL, NULL, 'NF-KAPPA-B INHIBITOR-LIKE PROTEIN', 245424),
(357232, 'PTHR39563', NULL, NULL, NULL, NULL, 'XANTHINE PHOSPHORIBOSYLTRANSFERASE', 245425),
(357233, 'PTHR39563:SF1', NULL, NULL, NULL, NULL, 'XANTHINE-GUANINE PHOSPHORIBOSYLTRANSFERASE', 245425),
(357234, 'PTHR47295:SF10', NULL, NULL, NULL, NULL, 'OS09G0472900 PROTEIN', 245426),
(357235, 'PTHR47295:SF8', NULL, NULL, NULL, NULL, 'DPBB_1 DOMAIN-CONTAINING PROTEIN', 245426),
(357236, 'PTHR47295', NULL, NULL, NULL, NULL, 'EG45-LIKE DOMAIN CONTAINING PROTEIN 1-RELATED', 245426),
(357237, 'PTHR47295:SF7', NULL, NULL, NULL, NULL, 'RLPA-LIKE DOUBLE-PSI BETA-BARREL DOMAIN-CONTAINING PROTEIN-RELATED', 245426);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(357238, 'PTHR47295:SF14', NULL, NULL, NULL, NULL, 'OS06G0688300 PROTEIN', 245426),
(357239, 'PTHR47295:SF11', NULL, NULL, NULL, NULL, 'RLPA-LIKE DOUBLE-PSI BETA-BARREL DOMAIN-CONTAINING PROTEIN-RELATED', 245426),
(357240, 'PTHR47295:SF4', NULL, NULL, NULL, NULL, 'EXPANSIN-LIKE EG45 DOMAIN-CONTAINING PROTEIN', 245426),
(357241, 'PTHR47295:SF5', NULL, NULL, NULL, NULL, 'EG45-LIKE DOMAIN CONTAINING PROTEIN 2', 245426),
(357242, 'PTHR47295:SF2', NULL, NULL, NULL, NULL, 'EG45-LIKE DOMAIN CONTAINING PROTEIN 1-RELATED', 245426),
(357243, 'PTHR40063', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 245427),
(357244, 'PTHR40063:SF1', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 245427),
(357245, 'PTHR46450:SF9', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SUVR2-LIKE PROTEIN', 245428),
(357246, 'PTHR46450:SF8', NULL, NULL, NULL, NULL, 'OS02G0621100 PROTEIN', 245428),
(357247, 'PTHR46450:SF23', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SUVR4', 245428),
(357248, 'PTHR46450:SF5', NULL, NULL, NULL, NULL, '', 245428),
(357249, 'PTHR46450:SF11', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SUVR4', 245428),
(357250, 'PTHR46450:SF22', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 245428),
(357251, 'PTHR46450:SF21', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 245428),
(357252, 'PTHR46450:SF20', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE-RELATED', 245428),
(357253, 'PTHR46450:SF1', NULL, NULL, NULL, NULL, 'INACTIVE HISTONE-LYSINE N-METHYLTRANSFERASE SUVR1-RELATED', 245428),
(357254, 'PTHR46450:SF17', NULL, NULL, NULL, NULL, 'BNAA05G33030D PROTEIN', 245428),
(357255, 'PTHR46450', NULL, NULL, NULL, NULL, 'INACTIVE HISTONE-LYSINE N-METHYLTRANSFERASE SUVR1-RELATED', 245428),
(357256, 'PTHR46450:SF24', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SUVR4', 245428),
(357257, 'PTHR46450:SF13', NULL, NULL, NULL, NULL, 'INACTIVE HISTONE-LYSINE N-METHYLTRANSFERASE SUVR2-RELATED', 245428),
(357258, 'PTHR10728:SF39', NULL, NULL, NULL, NULL, 'CYTOSOLIC PHOSPHOLIPASE A2 GAMMA', 245429),
(357259, 'PTHR10728', NULL, NULL, NULL, NULL, 'CYTOSOLIC PHOSPHOLIPASE A2', 245429),
(357260, 'PTHR10728:SF61', NULL, NULL, NULL, NULL, 'LYSOPHOSPHOLIPASE 1', 245429),
(357261, 'PTHR10728:SF40', NULL, NULL, NULL, NULL, 'WW DOMAIN-CONTAINING PROTEIN', 245429),
(357262, 'PTHR10728:SF62', NULL, NULL, NULL, NULL, 'LYSOPHOSPHOLIPASE', 245429),
(357263, 'PTHR10728:SF31', NULL, NULL, NULL, NULL, 'CYTOSOLIC PHOSPHOLIPASE A2 DELTA', 245429),
(357264, 'PTHR10728:SF32', NULL, NULL, NULL, NULL, 'CYTOSOLIC PHOSPHOLIPASE A2 BETA', 245429),
(357265, 'PTHR10728:SF54', NULL, NULL, NULL, NULL, 'PLA2C DOMAIN-CONTAINING PROTEIN-RELATED', 245429),
(357266, 'PTHR10728:SF22', NULL, NULL, NULL, NULL, 'CYTOSOLIC PHOSPHOLIPASE A2 ZETA', 245429),
(357267, 'PTHR10728:SF33', NULL, NULL, NULL, NULL, 'LYSOPHOSPHOLIPASE 1-RELATED', 245429),
(357268, 'PTHR10728:SF56', NULL, NULL, NULL, NULL, 'MEIOTIC PHOSPHOLIPASE SPO1-RELATED', 245429),
(357269, 'PTHR10728:SF13', NULL, NULL, NULL, NULL, 'CYTOSOLIC PHOSPHOLIPASE A2', 245429),
(357270, 'PTHR10728:SF24', NULL, NULL, NULL, NULL, 'CYTOSOLIC PHOSPHOLIPASE A2 EPSILON', 245429),
(357271, 'PTHR10728:SF35', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A2', 245429),
(357272, 'PTHR10728:SF60', NULL, NULL, NULL, NULL, 'LYSOPHOSPHOLIPASE C1786.02-RELATED', 245429),
(357273, 'PTHR31265:SF32', NULL, NULL, NULL, NULL, '', 245430),
(357274, 'PTHR31265:SF54', NULL, NULL, NULL, NULL, '', 245430),
(357275, 'PTHR31265:SF51', NULL, NULL, NULL, NULL, '', 245430),
(357276, 'PTHR31265:SF36', NULL, NULL, NULL, NULL, '', 245430),
(357277, 'PTHR31265:SF35', NULL, NULL, NULL, NULL, '', 245430),
(357278, 'PTHR31265:SF57', NULL, NULL, NULL, NULL, '', 245430),
(357279, 'PTHR31265:SF34', NULL, NULL, NULL, NULL, 'BNAA05G09330D PROTEIN', 245430),
(357280, 'PTHR31265:SF56', NULL, NULL, NULL, NULL, 'BNAA05G29710D PROTEIN', 245430),
(357281, 'PTHR31265:SF33', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 245430),
(357282, 'PTHR31265:SF55', NULL, NULL, NULL, NULL, '', 245430); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(357283, 'PTHR31265:SF11', NULL, NULL, NULL, NULL, 'OS04G0494600 PROTEIN', 245430),
(357284, 'PTHR31265', NULL, NULL, NULL, NULL, 'OS02G0527500 PROTEIN-RELATED', 245430),
(357285, 'PTHR31265:SF39', NULL, NULL, NULL, NULL, '', 245430),
(357286, 'PTHR31265:SF38', NULL, NULL, NULL, NULL, 'GALACTOSE-BINDING DOMAIN-LIKE PROTEIN-RELATED', 245430),
(357287, 'PTHR31265:SF37', NULL, NULL, NULL, NULL, '', 245430),
(357288, 'PTHR31265:SF8', NULL, NULL, NULL, NULL, 'OS04G0494950 PROTEIN', 245430),
(357289, 'PTHR31265:SF42', NULL, NULL, NULL, NULL, 'OS01G0611000 PROTEIN', 245430),
(357290, 'PTHR31265:SF41', NULL, NULL, NULL, NULL, 'BNAC06G40680D PROTEIN', 245430),
(357291, 'PTHR31265:SF40', NULL, NULL, NULL, NULL, 'BNAC02G48660D PROTEIN', 245430),
(357292, 'PTHR31265:SF24', NULL, NULL, NULL, NULL, '', 245430),
(357293, 'PTHR31265:SF46', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 245430),
(357294, 'PTHR31265:SF23', NULL, NULL, NULL, NULL, 'BNAC04G47820D PROTEIN', 245430),
(357295, 'PTHR31265:SF7', NULL, NULL, NULL, NULL, 'OS04G0494800 PROTEIN', 245430),
(357296, 'PTHR31265:SF22', NULL, NULL, NULL, NULL, 'F17A17.37 PROTEIN', 245430),
(357297, 'PTHR31265:SF29', NULL, NULL, NULL, NULL, 'BNAA09G04540D PROTEIN', 245430),
(357298, 'PTHR31265:SF28', NULL, NULL, NULL, NULL, 'EMB|CAB87702.1', 245430),
(357299, 'PTHR31265:SF1', NULL, NULL, NULL, NULL, 'OS01G0756600 PROTEIN', 245430),
(357300, 'PTHR31265:SF2', NULL, NULL, NULL, NULL, 'F17A17.37 PROTEIN', 245430),
(357301, 'PTHR31265:SF48', NULL, NULL, NULL, NULL, 'TFIIS CENTRAL DOMAIN-CONTAINING PROTEIN', 245430),
(357302, 'PTHR31265:SF3', NULL, NULL, NULL, NULL, 'PLANT/F18G18-200 PROTEIN', 245430),
(357303, 'PTHR43072:SF51', NULL, NULL, NULL, NULL, 'ABC SUPERFAMILY TRANSPORT PROTEIN-RELATED', 245431),
(357304, 'PTHR43072:SF60', NULL, NULL, NULL, NULL, 'L-2,4-DIAMINOBUTYRIC ACID ACETYLTRANSFERASE', 245431),
(357305, 'PTHR43072:SF44', NULL, NULL, NULL, NULL, 'OS02G0180400 PROTEIN', 245431),
(357306, 'PTHR43072:SF55', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE', 245431),
(357307, 'PTHR43072:SF54', NULL, NULL, NULL, NULL, 'GCN5-RELATED N-ACETYLTRANSFERASE', 245431),
(357308, 'PTHR43072:SF20', NULL, NULL, NULL, NULL, 'ACETYL TRANSFERASE', 245431),
(357309, 'PTHR43072:SF53', NULL, NULL, NULL, NULL, 'OS07G0116600 PROTEIN', 245431),
(357310, 'PTHR43072:SF52', NULL, NULL, NULL, NULL, 'GCN5-RELATED N-ACETYLTRANSFERASE', 245431),
(357311, 'PTHR43072:SF8', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE FABY-RELATED', 245431),
(357312, 'PTHR43072', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE', 245431),
(357313, 'PTHR43072:SF59', NULL, NULL, NULL, NULL, 'L-2,4-DIAMINOBUTYRIC ACID ACETYLTRANSFERASE', 245431),
(357314, 'PTHR43072:SF48', NULL, NULL, NULL, NULL, 'OS12G0561600 PROTEIN', 245431),
(357315, 'PTHR43072:SF36', NULL, NULL, NULL, NULL, 'RIBOSOMAL-PROTEIN-ALANINE ACETYLTRANSFERASE', 245431),
(357316, 'PTHR43072:SF58', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 245431),
(357317, 'PTHR43072:SF57', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE HLS1-LIKE-RELATED', 245431),
(357318, 'PTHR43072:SF23', NULL, NULL, NULL, NULL, 'UPF0039 PROTEIN C11D3.02C', 245431),
(357319, 'PTHR43072:SF56', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASES (NAT) SUPERFAMILY PROTEIN-RELATED', 245431),
(357320, 'PTHR14350', NULL, NULL, NULL, NULL, 'ARGININE VASOPRESSIN-INDUCED PROTEIN 1', 245432),
(357321, 'PTHR14350:SF2', NULL, NULL, NULL, NULL, 'ARGININE VASOPRESSIN-INDUCED PROTEIN 1', 245432),
(357322, 'PTHR47707', NULL, NULL, NULL, NULL, '8-OXO-DGTP DIPHOSPHATASE', 245433),
(357323, 'PTHR47707:SF2', NULL, NULL, NULL, NULL, 'CTP PYROPHOSPHOHYDROLASE', 245433),
(357324, 'PTHR47707:SF1', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 245433),
(357325, 'PTHR37806:SF1', NULL, NULL, NULL, NULL, 'PEPTIDASE_C39_2 DOMAIN-CONTAINING PROTEIN', 245434),
(357326, 'PTHR37806', NULL, NULL, NULL, NULL, 'LMO0724 PROTEIN', 245434),
(357327, 'PTHR11492', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR I', 245435),
(357328, 'PTHR11492:SF6', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR 1 A-TYPE', 245435);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(357329, 'PTHR11492:SF8', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR I, ISOFORM B', 245435),
(357330, 'PTHR11492:SF2', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR 1 C-TYPE', 245435),
(357331, 'PTHR11492:SF3', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR 1 X-TYPE', 245435),
(357332, 'PTHR11492:SF4', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR 1 B-TYPE', 245435),
(357333, 'PTHR11037:SF20', NULL, NULL, NULL, NULL, 'PROTEIN GRAINYHEAD', 245436),
(357334, 'PTHR11037:SF11', NULL, NULL, NULL, NULL, 'ALPHA-GLOBIN TRANSCRIPTION FACTOR CP2', 245436),
(357335, 'PTHR11037:SF6', NULL, NULL, NULL, NULL, 'GRAINYHEAD-LIKE PROTEIN 3 HOMOLOG', 245436),
(357336, 'PTHR11037:SF21', NULL, NULL, NULL, NULL, 'GEMINI, ISOFORM C', 245436),
(357337, 'PTHR11037:SF17', NULL, NULL, NULL, NULL, 'GRAINYHEAD-LIKE PROTEIN 2 HOMOLOG', 245436),
(357338, 'PTHR11037:SF16', NULL, NULL, NULL, NULL, 'GRAINYHEAD-LIKE PROTEIN 1 HOMOLOG', 245436),
(357339, 'PTHR11037', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR CP2', 245436),
(357340, 'PTHR11037:SF18', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR CP2-LIKE PROTEIN 1', 245436),
(357341, 'PTHR11037:SF13', NULL, NULL, NULL, NULL, 'UPSTREAM-BINDING PROTEIN 1', 245436),
(357342, 'PTHR11037:SF12', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR CP2-LIKE PROTEIN 1', 245436),
(357343, 'PTHR15975:SF0', NULL, NULL, NULL, NULL, 'CCR4-NOT TRANSCRIPTION COMPLEX SUBUNIT 11', 245437),
(357344, 'PTHR15975:SF2', NULL, NULL, NULL, NULL, 'CCR4-NOT TRANSCRIPTION COMPLEX SUBUNIT 11', 245437),
(357345, 'PTHR15975', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 245437),
(357346, 'PTHR15975:SF3', NULL, NULL, NULL, NULL, 'CCR4-NOT TRANSCRIPTION COMPLEX SUBUNIT 11', 245437),
(357347, 'PTHR38033', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 245438),
(357348, 'PTHR38033:SF1', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 245438),
(357349, 'PTHR14897:SF5', NULL, NULL, NULL, NULL, 'WD REPEAT AND COILED-COIL-CONTAINING PROTEIN', 245439),
(357350, 'PTHR14897:SF4', NULL, NULL, NULL, NULL, 'WD REPEAT AND COILED-COIL-CONTAINING PROTEIN', 245439),
(357351, 'PTHR14897:SF10', NULL, NULL, NULL, NULL, 'WD REPEAT AND COILED-COIL-CONTAINING PROTEIN', 245439),
(357352, 'PTHR14897', NULL, NULL, NULL, NULL, 'WD REPEAT AND COILED-COIL-CONTAINING PROTEIN', 245439),
(357353, 'PTHR36391', NULL, NULL, NULL, NULL, 'FURRY', 245440),
(357354, 'PTHR36391:SF1', NULL, NULL, NULL, NULL, 'FURRY', 245440),
(357355, 'PTHR36391:SF2', NULL, NULL, NULL, NULL, 'FBA_3 DOMAIN-CONTAINING PROTEIN', 245440),
(357356, 'PTHR12970:SF1', NULL, NULL, NULL, NULL, 'PROTEASOME ASSEMBLY CHAPERONE 2', 245441),
(357357, 'PTHR12970:SF2', NULL, NULL, NULL, NULL, 'PROTEASOME ASSEMBLY CHAPERONE 2', 245441),
(357358, 'PTHR12970', NULL, NULL, NULL, NULL, 'PROTEASOME ASSEMBLY CHAPERONE 2', 245441),
(357359, 'PTHR28682:SF1', NULL, NULL, NULL, NULL, 'INHIBITORY SYNAPTIC FACTOR 2A', 245442),
(357360, 'PTHR28682:SF2', NULL, NULL, NULL, NULL, 'PROTEIN INSYN2B', 245442),
(357361, 'PTHR28682', NULL, NULL, NULL, NULL, 'INHIBITORY SYNAPTIC FACTOR 2A-RELATED', 245442),
(357362, 'PTHR28682:SF4', NULL, NULL, NULL, NULL, '', 245442),
(357363, 'PTHR28682:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 4-LIKE', 245442),
(357364, 'PTHR47682', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-CONTAINING PROTEIN', 245443),
(357365, 'PTHR47682:SF1', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-CONTAINING PROTEIN', 245443),
(357366, 'PTHR44516:SF6', NULL, NULL, NULL, NULL, 'SAM_MPBQ_MSBQ_MT DOMAIN-CONTAINING PROTEIN', 245444),
(357367, 'PTHR44516:SF10', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE TYPE 11, S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASE-RELATED', 245444),
(357368, 'PTHR44516:SF8', NULL, NULL, NULL, NULL, '2-METHYL-6-PHYTYL-1,4-HYDROQUINONE METHYLTRANSFERASE 1, CHLOROPLASTIC', 245444),
(357369, 'PTHR44516', NULL, NULL, NULL, NULL, '2-METHYL-6-PHYTYL-1,4-HYDROQUINONE METHYLTRANSFERASE, CHLOROPLASTIC', 245444),
(357370, 'PTHR44516:SF4', NULL, NULL, NULL, NULL, '2-METHYL-6-PHYTYL-1,4-HYDROQUINONE METHYLTRANSFERASE, CHLOROPLASTIC', 245444);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(357371, 'PTHR44516:SF9', NULL, NULL, NULL, NULL, '2-METHYL-6-PHYTYLBENZOQUINONE METHYLTRANSFERASE', 245444),
(357372, 'PTHR33527:SF6', NULL, NULL, NULL, NULL, 'OS04G0373100 PROTEIN', 245445),
(357373, 'PTHR33527:SF40', NULL, NULL, NULL, NULL, 'BNAC09G43470D PROTEIN', 245445),
(357374, 'PTHR33527:SF42', NULL, NULL, NULL, NULL, '', 245445),
(357375, 'PTHR33527:SF33', NULL, NULL, NULL, NULL, 'BNAA07G02990D PROTEIN', 245445),
(357376, 'PTHR33527:SF44', NULL, NULL, NULL, NULL, 'OS07G0274300 PROTEIN', 245445),
(357377, 'PTHR33527:SF43', NULL, NULL, NULL, NULL, '', 245445),
(357378, 'PTHR33527:SF21', NULL, NULL, NULL, NULL, 'OS10G0182800 PROTEIN', 245445),
(357379, 'PTHR33527:SF32', NULL, NULL, NULL, NULL, 'BNACNNG31160D PROTEIN', 245445),
(357380, 'PTHR33527:SF46', NULL, NULL, NULL, NULL, 'BNAA07G00110D PROTEIN', 245445),
(357381, 'PTHR33527:SF45', NULL, NULL, NULL, NULL, 'BNAA04G25960D PROTEIN', 245445),
(357382, 'PTHR33527:SF23', NULL, NULL, NULL, NULL, '', 245445),
(357383, 'PTHR33527:SF34', NULL, NULL, NULL, NULL, 'BNAA06G20120D PROTEIN', 245445),
(357384, 'PTHR33527:SF37', NULL, NULL, NULL, NULL, '', 245445),
(357385, 'PTHR33527:SF47', NULL, NULL, NULL, NULL, 'GB|AAD43168.1', 245445),
(357386, 'PTHR33527:SF14', NULL, NULL, NULL, NULL, '', 245445),
(357387, 'PTHR33527:SF25', NULL, NULL, NULL, NULL, '', 245445),
(357388, 'PTHR33527:SF36', NULL, NULL, NULL, NULL, 'BNAA09G08110D PROTEIN', 245445),
(357389, 'PTHR33527:SF28', NULL, NULL, NULL, NULL, 'F13F21.27 PROTEIN', 245445),
(357390, 'PTHR33527', NULL, NULL, NULL, NULL, 'OS07G0274300 PROTEIN', 245445),
(357391, 'PTHR33527:SF27', NULL, NULL, NULL, NULL, 'BNAA05G12810D PROTEIN', 245445),
(357392, 'PTHR33527:SF16', NULL, NULL, NULL, NULL, '', 245445),
(357393, 'PTHR33527:SF18', NULL, NULL, NULL, NULL, 'F13O11.17 PROTEIN', 245445),
(357394, 'PTHR15344:SF8', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC691418', 245446),
(357395, 'PTHR15344:SF15', NULL, NULL, NULL, NULL, 'CDC42 EFFECTOR PROTEIN 5', 245446),
(357396, 'PTHR15344:SF7', NULL, NULL, NULL, NULL, 'CDC42 EFFECTOR PROTEIN 1', 245446),
(357397, 'PTHR15344:SF19', NULL, NULL, NULL, NULL, 'CDC42 EFFECTOR PROTEIN (RHO GTPASE-BINDING) 4A', 245446),
(357398, 'PTHR15344:SF4', NULL, NULL, NULL, NULL, 'CDC42 EFFECTOR PROTEIN 2', 245446),
(357399, 'PTHR15344:SF20', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN', 245446),
(357400, 'PTHR15344:SF2', NULL, NULL, NULL, NULL, 'ZGC:154093', 245446),
(357401, 'PTHR15344:SF3', NULL, NULL, NULL, NULL, 'CDC42 EFFECTOR PROTEIN 3', 245446),
(357402, 'PTHR15344:SF14', NULL, NULL, NULL, NULL, 'CDC42 EFFECTOR PROTEIN 4', 245446),
(357403, 'PTHR15344:SF22', NULL, NULL, NULL, NULL, 'CDC42 EFFECTOR PROTEIN (RHO GTPASE-BINDING) 1B', 245446),
(357404, 'PTHR15344:SF12', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN', 245446),
(357405, 'PTHR15344', NULL, NULL, NULL, NULL, 'CDC42 EFFECTOR PROTEIN  BORG', 245446),
(357406, 'PTHR46036:SF19', NULL, NULL, NULL, NULL, 'LACTOYLGLUTATHIONE LYASE', 245447),
(357407, 'PTHR46036:SF18', NULL, NULL, NULL, NULL, 'LACTOYLGLUTATHIONE LYASE', 245447),
(357408, 'PTHR46036:SF12', NULL, NULL, NULL, NULL, 'GLYOXALASE I', 245447),
(357409, 'PTHR46036:SF2', NULL, NULL, NULL, NULL, 'LACTOYLGLUTATHIONE LYASE GLX1', 245447),
(357410, 'PTHR46036', NULL, NULL, NULL, NULL, 'LACTOYLGLUTATHIONE LYASE', 245447),
(357411, 'PTHR46036:SF10', NULL, NULL, NULL, NULL, 'GLYOXALASE I', 245447),
(357412, 'PTHR46036:SF5', NULL, NULL, NULL, NULL, 'LACTOYLGLUTATHIONE LYASE', 245447),
(357413, 'PTHR46036:SF7', NULL, NULL, NULL, NULL, 'GLYOXALASE I', 245447),
(357414, 'PTHR46036:SF16', NULL, NULL, NULL, NULL, 'LACTOYLGLUTATHIONE LYASE', 245447),
(357415, 'PTHR46036:SF15', NULL, NULL, NULL, NULL, 'LACTOYLGLUTATHIONE LYASE', 245447),
(357416, 'PTHR46036:SF9', NULL, NULL, NULL, NULL, 'LACTOYLGLUTATHIONE LYASE CHLOROPLASTIC-RELATED', 245447),
(357417, 'PTHR46036:SF8', NULL, NULL, NULL, NULL, 'GLYOXALASE I', 245447),
(357418, 'PTHR37467:SF1', NULL, NULL, NULL, NULL, 'EXPORTED CALCIUM-BINDING GLYCOPROTEIN-RELATED', 245448),
(357419, 'PTHR37467', NULL, NULL, NULL, NULL, 'EXPORTED CALCIUM-BINDING GLYCOPROTEIN-RELATED', 245448);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(357420, 'PTHR14926', NULL, NULL, NULL, NULL, 'M-PHASE PHOSPHOPROTEIN 9', 245449),
(357421, 'PTHR14926:SF1', NULL, NULL, NULL, NULL, 'M-PHASE PHOSPHOPROTEIN 9', 245449),
(357422, 'PTHR46968', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF138', 245450),
(357423, 'PTHR46968:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF138', 245450),
(357424, 'PTHR46968:SF3', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 245450),
(357425, 'PTHR46968:SF1', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 245450),
(357426, 'PTHR22550:SF18', NULL, NULL, NULL, NULL, 'UPF0353 PROTEIN RV1481', 245451),
(357427, 'PTHR22550:SF5', NULL, NULL, NULL, NULL, 'LEUCINE ZIPPER PROTEIN 4', 245451),
(357428, 'PTHR22550:SF16', NULL, NULL, NULL, NULL, 'SPORE GERMINATION PROTEIN', 245451),
(357429, 'PTHR22550:SF9', NULL, NULL, NULL, NULL, 'STAGE V SPORULATION PROTEIN AF', 245451),
(357430, 'PTHR22550', NULL, NULL, NULL, NULL, 'SPORE GERMINATION PROTEIN', 245451),
(357431, 'PTHR22550:SF14', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 245451),
(357432, 'PTHR15960:SF3', NULL, NULL, NULL, NULL, 'UBIQUITIN-ASSOCIATED PROTEIN 1-LIKE', 245452),
(357433, 'PTHR15960:SF2', NULL, NULL, NULL, NULL, 'UBIQUITIN-ASSOCIATED PROTEIN 1', 245452),
(357434, 'PTHR15960:SF9', NULL, NULL, NULL, NULL, 'UBA DOMAIN-CONTAINING PROTEIN', 245452),
(357435, 'PTHR15960:SF5', NULL, NULL, NULL, NULL, 'LD44032P', 245452),
(357436, 'PTHR15960:SF7', NULL, NULL, NULL, NULL, 'PROLINE-RICH CELL WALL PROTEIN', 245452),
(357437, 'PTHR15960', NULL, NULL, NULL, NULL, 'LD44032P', 245452),
(357438, 'PTHR23427:SF14', NULL, NULL, NULL, NULL, 'SURFEIT LOCUS PROTEIN 4', 245453),
(357439, 'PTHR23427:SF13', NULL, NULL, NULL, NULL, 'SURFEIT LOCUS PROTEIN 4', 245453),
(357440, 'PTHR23427', NULL, NULL, NULL, NULL, 'SURFEIT LOCUS PROTEIN', 245453),
(357441, 'PTHR23427:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG04160', 245453),
(357442, 'PTHR23427:SF2', NULL, NULL, NULL, NULL, 'SURFEIT LOCUS PROTEIN 1', 245453),
(357443, 'PTHR23427:SF1', NULL, NULL, NULL, NULL, 'SURFEIT LOCUS PROTEIN 4', 245453),
(357444, 'PTHR11434:SF16', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE CHAIN 4L', 245454),
(357445, 'PTHR11434:SF0', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE CHAIN 4L', 245454),
(357446, 'PTHR11434:SF14', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE SUBUNIT 4L', 245454),
(357447, 'PTHR11434:SF19', NULL, NULL, NULL, NULL, '', 245454),
(357448, 'PTHR11434', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE SUBUNIT ND4L', 245454),
(357449, 'PTHR11434:SF21', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE SUBUNIT 4L-RELATED', 245454),
(357450, 'PTHR11434:SF20', NULL, NULL, NULL, NULL, '', 245454),
(357451, 'PTHR46118', NULL, NULL, NULL, NULL, 'PROTEIN ABHD11', 245455),
(357452, 'PTHR46118:SF3', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 245455),
(357453, 'PTHR46118:SF4', NULL, NULL, NULL, NULL, 'PROTEIN ABHD11', 245455),
(357454, 'PTHR46118:SF5', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 245455),
(357455, 'PTHR34221', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC691189', 245456),
(357456, 'PTHR34221:SF1', NULL, NULL, NULL, NULL, '', 245456),
(357457, 'PTHR34221:SF2', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC691189', 245456),
(357458, 'PTHR11932:SF160', NULL, NULL, NULL, NULL, 'CULLIN_2 DOMAIN-CONTAINING PROTEIN', 245457),
(357459, 'PTHR11932:SF161', NULL, NULL, NULL, NULL, 'CULLIN_2 DOMAIN-CONTAINING PROTEIN', 245457),
(357460, 'PTHR11932:SF141', NULL, NULL, NULL, NULL, 'CULLIN-1-LIKE ISOFORM X1', 245457),
(357461, 'PTHR11932:SF143', NULL, NULL, NULL, NULL, 'CULLIN-1', 245457),
(357462, 'PTHR11932:SF166', NULL, NULL, NULL, NULL, 'CULLIN-2', 245457),
(357463, 'PTHR11932:SF123', NULL, NULL, NULL, NULL, 'CULLIN 4, ISOFORM A', 245457),
(357464, 'PTHR11932', NULL, NULL, NULL, NULL, 'CULLIN', 245457),
(357465, 'PTHR11932:SF146', NULL, NULL, NULL, NULL, 'CULLIN-LIKE PROTEIN', 245457),
(357466, 'PTHR11932:SF168', NULL, NULL, NULL, NULL, 'CULLIN-3', 245457); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(357467, 'PTHR11932:SF74', NULL, NULL, NULL, NULL, 'OS04G0643000 PROTEIN', 245457),
(357468, 'PTHR11932:SF169', NULL, NULL, NULL, NULL, 'CULLIN-1', 245457),
(357469, 'PTHR11932:SF147', NULL, NULL, NULL, NULL, 'CULLIN_2 DOMAIN-CONTAINING PROTEIN', 245457),
(357470, 'PTHR11932:SF76', NULL, NULL, NULL, NULL, 'CULLIN-5', 245457),
(357471, 'PTHR11932:SF126', NULL, NULL, NULL, NULL, 'CULLIN-2', 245457),
(357472, 'PTHR11932:SF148', NULL, NULL, NULL, NULL, 'CULLIN_2 DOMAIN-CONTAINING PROTEIN', 245457),
(357473, 'PTHR11932:SF149', NULL, NULL, NULL, NULL, 'CULLIN_2 DOMAIN-CONTAINING PROTEIN', 245457),
(357474, 'PTHR11932:SF79', NULL, NULL, NULL, NULL, 'OS08G0170900 PROTEIN', 245457),
(357475, 'PTHR11932:SF171', NULL, NULL, NULL, NULL, 'CULLIN_2 DOMAIN-CONTAINING PROTEIN', 245457),
(357476, 'PTHR11932:SF150', NULL, NULL, NULL, NULL, 'OS02G0746000 PROTEIN', 245457),
(357477, 'PTHR11932:SF172', NULL, NULL, NULL, NULL, 'CULLIN_2 DOMAIN-CONTAINING PROTEIN', 245457),
(357478, 'PTHR11932:SF152', NULL, NULL, NULL, NULL, 'CULLIN-1-LIKE', 245457),
(357479, 'PTHR11932:SF153', NULL, NULL, NULL, NULL, 'CULLIN_2 DOMAIN-CONTAINING PROTEIN', 245457),
(357480, 'PTHR11932:SF154', NULL, NULL, NULL, NULL, 'CULLIN_2 DOMAIN-CONTAINING PROTEIN', 245457),
(357481, 'PTHR11932:SF134', NULL, NULL, NULL, NULL, 'CULLIN-1', 245457),
(357482, 'PTHR11932:SF95', NULL, NULL, NULL, NULL, 'CULLIN-3A-RELATED', 245457),
(357483, 'PTHR11932:SF170', NULL, NULL, NULL, NULL, 'CULLIN 3B', 245457),
(357484, 'PTHR11932:SF63', NULL, NULL, NULL, NULL, 'CULLIN-5', 245457),
(357485, 'PTHR11932:SF157', NULL, NULL, NULL, NULL, 'CULLIN DOMAIN-CONTAINING PROTEIN', 245457),
(357486, 'PTHR11932:SF158', NULL, NULL, NULL, NULL, 'CULLIN_2 DOMAIN-CONTAINING PROTEIN', 245457),
(357487, 'PTHR11932:SF136', NULL, NULL, NULL, NULL, 'CULLIN DOMAIN-CONTAINING PROTEIN', 245457),
(357488, 'PTHR11932:SF159', NULL, NULL, NULL, NULL, 'CULLIN_2 DOMAIN-CONTAINING PROTEIN', 245457),
(357489, 'PTHR11932:SF138', NULL, NULL, NULL, NULL, 'CULLIN-1-RELATED', 245457),
(357490, 'PTHR11932:SF66', NULL, NULL, NULL, NULL, 'CULLIN-4B', 245457),
(357491, 'PTHR11932:SF68', NULL, NULL, NULL, NULL, 'CULLIN-4A', 245457),
(357492, 'PTHR31016', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 245458),
(357493, 'PTHR31016:SF12', NULL, NULL, NULL, NULL, 'OS05G0315200 PROTEIN', 245458),
(357494, 'PTHR31016:SF23', NULL, NULL, NULL, NULL, '', 245458),
(357495, 'PTHR31016:SF11', NULL, NULL, NULL, NULL, 'BNAUNNG01860D PROTEIN', 245458),
(357496, 'PTHR31016:SF22', NULL, NULL, NULL, NULL, 'RRNA BIOGENESIS PROTEIN RRP36-LIKE', 245458),
(357497, 'PTHR31016:SF2', NULL, NULL, NULL, NULL, 'OS04G0228100 PROTEIN', 245458),
(357498, 'PTHR31016:SF20', NULL, NULL, NULL, NULL, 'HEAT-INDUCIBLE TRANSCRIPTION REPRESSOR-RELATED', 245458),
(357499, 'PTHR31016:SF5', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245458),
(357500, 'PTHR31016:SF17', NULL, NULL, NULL, NULL, '', 245458),
(357501, 'PTHR31016:SF16', NULL, NULL, NULL, NULL, 'BNACNNG42740D PROTEIN', 245458),
(357502, 'PTHR31016:SF15', NULL, NULL, NULL, NULL, '', 245458),
(357503, 'PTHR46797:SF19', NULL, NULL, NULL, NULL, 'BLR5530 PROTEIN', 245459),
(357504, 'PTHR46797:SF9', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR SUTR', 245459),
(357505, 'PTHR46797', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR', 245459),
(357506, 'PTHR46797:SF1', NULL, NULL, NULL, NULL, 'METHYLPHOSPHONATE SYNTHASE', 245459),
(357507, 'PTHR46797:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR', 245459),
(357508, 'PTHR46797:SF21', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR SLRR', 245459),
(357509, 'PTHR46797:SF10', NULL, NULL, NULL, NULL, 'BLR1115 PROTEIN', 245459),
(357510, 'PTHR46797:SF20', NULL, NULL, NULL, NULL, 'HTH CRO/C1-TYPE DOMAIN-CONTAINING PROTEIN', 245459),
(357511, 'PTHR46797:SF15', NULL, NULL, NULL, NULL, 'BLR6715 PROTEIN', 245459),
(357512, 'PTHR46797:SF18', NULL, NULL, NULL, NULL, 'BLL2454 PROTEIN', 245459),
(357513, 'PTHR46797:SF22', NULL, NULL, NULL, NULL, 'DNA BINDING PROTEIN', 245459),
(357514, 'PTHR46797:SF11', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR PUUR', 245459);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(357515, 'PTHR46797:SF13', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR SINR', 245459),
(357516, 'PTHR11061', NULL, NULL, NULL, NULL, 'RNA M5U METHYLTRANSFERASE', 245460),
(357517, 'PTHR11061:SF30', NULL, NULL, NULL, NULL, 'TRNA (URACIL(54)-C(5))-METHYLTRANSFERASE', 245460),
(357518, 'PTHR11061:SF45', NULL, NULL, NULL, NULL, '', 245460),
(357519, 'PTHR11061:SF48', NULL, NULL, NULL, NULL, '23S RRNA (URACIL(747)-C(5))-METHYLTRANSFERASE RLMC', 245460),
(357520, 'PTHR14894:SF0', NULL, NULL, NULL, NULL, 'CDK5 REGULATORY SUBUNIT-ASSOCIATED PROTEIN 3', 245461),
(357521, 'PTHR14894:SF1', NULL, NULL, NULL, NULL, '', 245461),
(357522, 'PTHR14894:SF2', NULL, NULL, NULL, NULL, 'CDK5 REGULATORY SUBUNIT-ASSOCIATED PROTEIN 3', 245461),
(357523, 'PTHR14894', NULL, NULL, NULL, NULL, 'CDK5 REGULATORY SUBUNIT-ASSOCIATED PROTEIN 3', 245461),
(357524, 'PTHR35273:SF2', NULL, NULL, NULL, NULL, 'ALPHA-GALACTOSIDASE', 245462),
(357525, 'PTHR35273', NULL, NULL, NULL, NULL, 'ALPHA-1,4 POLYGALACTOSAMINIDASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G07890)-RELATED', 245462),
(357526, 'PTHR13437:SF7', NULL, NULL, NULL, NULL, '', 245463),
(357527, 'PTHR13437', NULL, NULL, NULL, NULL, 'NUCLEOPORIN P58/P45  NUCLEOPORIN-LIKE PROTEIN 1', 245463),
(357528, 'PTHR13437:SF6', NULL, NULL, NULL, NULL, '', 245463),
(357529, 'PTHR13437:SF5', NULL, NULL, NULL, NULL, 'BNAA08G15500D PROTEIN', 245463),
(357530, 'PTHR13437:SF3', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP58', 245463),
(357531, 'PTHR13437:SF2', NULL, NULL, NULL, NULL, 'NUCLEOPORIN P58/P45', 245463),
(357532, 'PTHR47610:SF1', NULL, NULL, NULL, NULL, 'TSC22 DOMAIN FAMILY PROTEIN 4', 245464),
(357533, 'PTHR47610', NULL, NULL, NULL, NULL, 'TSC22 DOMAIN FAMILY PROTEIN 4', 245464),
(357534, 'PTHR24064:SF192', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER 23', 245465),
(357535, 'PTHR24064:SF590', NULL, NULL, NULL, NULL, 'H(+)/PI COTRANSPORTER', 245465),
(357536, 'PTHR24064:SF592', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER 9', 245465),
(357537, 'PTHR24064:SF471', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357538, 'PTHR24064:SF196', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER 31-RELATED', 245465),
(357539, 'PTHR24064:SF591', NULL, NULL, NULL, NULL, 'STEROID TRANSMEMBRANE TRANSPORTER SLC22A24', 245465),
(357540, 'PTHR24064:SF470', NULL, NULL, NULL, NULL, 'SI:DKEY-166K12.1', 245465),
(357541, 'PTHR24064:SF583', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357542, 'PTHR24064:SF187', NULL, NULL, NULL, NULL, 'ORGANIC CATION TRANSPORTER PROTEIN-LIKE PROTEIN', 245465),
(357543, 'PTHR24064:SF462', NULL, NULL, NULL, NULL, 'SI:DKEY-190L8.2', 245465),
(357544, 'PTHR24064:SF186', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER 16', 245465),
(357545, 'PTHR24064:SF461', NULL, NULL, NULL, NULL, 'ORGANIC CATION TRANSPORTER 2', 245465),
(357546, 'PTHR24064:SF582', NULL, NULL, NULL, NULL, 'YUP8H12R.2 PROTEIN', 245465),
(357547, 'PTHR24064:SF222', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER 4', 245465),
(357548, 'PTHR24064:SF464', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORT PROTEIN-RELATED', 245465),
(357549, 'PTHR24064:SF463', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357550, 'PTHR24064:SF622', NULL, NULL, NULL, NULL, 'INORGANIC PHOSPHATE TRANSPORTER 1-4', 245465),
(357551, 'PTHR24064:SF468', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER 13A', 245465),
(357552, 'PTHR24064:SF621', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER 22', 245465),
(357553, 'PTHR24064:SF467', NULL, NULL, NULL, NULL, 'FI01439P-RELATED', 245465),
(357554, 'PTHR24064:SF588', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357555, 'PTHR24064:SF624', NULL, NULL, NULL, NULL, 'HIGH AFFINITY INORGANIC PHOSPHATE TRANSPORTER', 245465),
(357556, 'PTHR24064:SF502', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357557, 'PTHR24064:SF626', NULL, NULL, NULL, NULL, 'GH09241P', 245465),
(357558, 'PTHR24064:SF625', NULL, NULL, NULL, NULL, 'H(+)/PI COTRANSPORTER', 245465);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(357559, 'PTHR24064:SF628', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357560, 'PTHR24064:SF627', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357561, 'PTHR24064:SF629', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 (ORGANIC CATION/ZWITTERION TRANSPORTER), MEMBER 4', 245465),
(357562, 'PTHR24064:SF581', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357563, 'PTHR24064:SF460', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357564, 'PTHR24064:SF580', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357565, 'PTHR24064:SF572', NULL, NULL, NULL, NULL, 'BNAANNG20110D PROTEIN', 245465),
(357566, 'PTHR24064:SF571', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357567, 'PTHR24064:SF453', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER 4', 245465),
(357568, 'PTHR24064:SF576', NULL, NULL, NULL, NULL, 'CARCININE TRANSPORTER', 245465),
(357569, 'PTHR24064:SF454', NULL, NULL, NULL, NULL, 'SI:DKEY-119M7.4', 245465),
(357570, 'PTHR24064:SF457', NULL, NULL, NULL, NULL, 'TRANSPORTER SVOPL-RELATED', 245465),
(357571, 'PTHR24064:SF611', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357572, 'PTHR24064:SF578', NULL, NULL, NULL, NULL, 'ORGANIC CATION/CARNITINE TRANSPORTER 5', 245465),
(357573, 'PTHR24064:SF335', NULL, NULL, NULL, NULL, 'FI24011P1-RELATED', 245465),
(357574, 'PTHR24064:SF610', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357575, 'PTHR24064:SF577', NULL, NULL, NULL, NULL, 'BETA-ALANINE TRANSPORTER', 245465),
(357576, 'PTHR24064:SF217', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER 25', 245465),
(357577, 'PTHR24064:SF338', NULL, NULL, NULL, NULL, 'ORGANIC CATION/CARNITINE TRANSPORTER', 245465),
(357578, 'PTHR24064:SF613', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357579, 'PTHR24064:SF216', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER 17', 245465),
(357580, 'PTHR24064:SF337', NULL, NULL, NULL, NULL, 'PHOSPHATE PERMEASE (AFU_ORTHOLOGUE AFUA_5G01320)', 245465),
(357581, 'PTHR24064:SF616', NULL, NULL, NULL, NULL, 'INORGANIC PHOSPHATE TRANSPORTER PHO84', 245465),
(357582, 'PTHR24064:SF618', NULL, NULL, NULL, NULL, 'ORGANIC CATION TRANSPORTER 1', 245465),
(357583, 'PTHR24064:SF609', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357584, 'PTHR24064:SF170', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER 15', 245465),
(357585, 'PTHR24064:SF291', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER 1', 245465),
(357586, 'PTHR24064:SF294', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER 6', 245465),
(357587, 'PTHR24064:SF440', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357588, 'PTHR24064:SF560', NULL, NULL, NULL, NULL, 'BNAA06G36740D PROTEIN', 245465),
(357589, 'PTHR24064:SF200', NULL, NULL, NULL, NULL, 'METABOLITE TRANSPORT PROTEIN C1271.09-RELATED', 245465),
(357590, 'PTHR24064:SF562', NULL, NULL, NULL, NULL, 'BNAC02G16980D PROTEIN', 245465),
(357591, 'PTHR24064:SF48', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER 14', 245465),
(357592, 'PTHR24064:SF565', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357593, 'PTHR24064:SF443', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER 27-RELATED', 245465),
(357594, 'PTHR24064:SF600', NULL, NULL, NULL, NULL, 'BNAA02G22230D PROTEIN', 245465),
(357595, 'PTHR24064:SF567', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245465),
(357596, 'PTHR24064:SF445', NULL, NULL, NULL, NULL, 'SYNAPTIC VESICLE 2-RELATED PROTEIN', 245465),
(357597, 'PTHR24064:SF602', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357598, 'PTHR24064:SF205', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER 12', 245465),
(357599, 'PTHR24064:SF568', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357600, 'PTHR24064:SF604', NULL, NULL, NULL, NULL, 'METABOLITE TRANSPORTER C2H8.02-RELATED', 245465),
(357601, 'PTHR24064:SF449', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245465);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(357602, 'PTHR24064:SF328', NULL, NULL, NULL, NULL, 'ORGANIC CATION/CARNITINE TRANSPORTER 3', 245465),
(357603, 'PTHR24064:SF605', NULL, NULL, NULL, NULL, 'INNER MEMBRANE METABOLITE TRANSPORT PROTEIN YDJE-RELATED', 245465),
(357604, 'PTHR24064:SF608', NULL, NULL, NULL, NULL, 'GH28654P', 245465),
(357605, 'PTHR24064:SF607', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER 5', 245465),
(357606, 'PTHR24064:SF284', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357607, 'PTHR24064:SF33', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER 7', 245465),
(357608, 'PTHR24064:SF283', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER 5', 245465),
(357609, 'PTHR24064:SF34', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER 20', 245465),
(357610, 'PTHR24064:SF552', NULL, NULL, NULL, NULL, 'BNAA02G22250D PROTEIN', 245465),
(357611, 'PTHR24064:SF554', NULL, NULL, NULL, NULL, 'BNAA09G15770D PROTEIN', 245465),
(357612, 'PTHR24064:SF432', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER 2', 245465),
(357613, 'PTHR24064:SF278', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER 10', 245465),
(357614, 'PTHR24064:SF556', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 245465),
(357615, 'PTHR24064:SF316', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357616, 'PTHR24064:SF558', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357617, 'PTHR24064:SF557', NULL, NULL, NULL, NULL, 'BNAA01G30100D PROTEIN', 245465),
(357618, 'PTHR24064:SF439', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER 8', 245465),
(357619, 'PTHR24064:SF559', NULL, NULL, NULL, NULL, 'BNAA03G18250D PROTEIN', 245465),
(357620, 'PTHR24064:SF540', NULL, NULL, NULL, NULL, 'BNAC09G17510D PROTEIN', 245465),
(357621, 'PTHR24064:SF424', NULL, NULL, NULL, NULL, 'FI05810P', 245465),
(357622, 'PTHR24064:SF303', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357623, 'PTHR24064:SF545', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357624, 'PTHR24064:SF547', NULL, NULL, NULL, NULL, 'IP17430P', 245465),
(357625, 'PTHR24064:SF546', NULL, NULL, NULL, NULL, 'BNAC05G12500D PROTEIN', 245465),
(357626, 'PTHR24064:SF549', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357627, 'PTHR24064:SF52', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER 3', 245465),
(357628, 'PTHR24064:SF261', NULL, NULL, NULL, NULL, 'INORGANIC PHOSPHATE TRANSPORTER 1-6', 245465),
(357629, 'PTHR24064:SF530', NULL, NULL, NULL, NULL, 'ORGANIC CATION/CARNITINE TRANSPORTER 4', 245465),
(357630, 'PTHR24064:SF497', NULL, NULL, NULL, NULL, 'MFS TRANSPORTER', 245465),
(357631, 'PTHR24064:SF496', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357632, 'PTHR24064:SF531', NULL, NULL, NULL, NULL, 'TRANSPORTER B0361.11-RELATED', 245465),
(357633, 'PTHR24064:SF533', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357634, 'PTHR24064:SF535', NULL, NULL, NULL, NULL, 'BNAA06G36760D PROTEIN', 245465),
(357635, 'PTHR24064:SF537', NULL, NULL, NULL, NULL, 'BNAC05G16120D PROTEIN', 245465),
(357636, 'PTHR24064:SF80', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357637, 'PTHR24064:SF83', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357638, 'PTHR24064:SF491', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357639, 'PTHR24064:SF85', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357640, 'PTHR24064:SF490', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357641, 'PTHR24064:SF87', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357642, 'PTHR24064:SF251', NULL, NULL, NULL, NULL, 'INORGANIC PHOSPHATE TRANSPORTER 1-11', 245465),
(357643, 'PTHR24064:SF493', NULL, NULL, NULL, NULL, 'OS09G0559800 PROTEIN', 245465),
(357644, 'PTHR24064:SF492', NULL, NULL, NULL, NULL, 'INORGANIC PHOSPHATE TRANSPORTER 1-9-RELATED', 245465),
(357645, 'PTHR24064:SF250', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465);
INSERT INTO "PUBLIC"."MODEL" VALUES
(357646, 'PTHR24064:SF241', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER 11', 245465),
(357647, 'PTHR24064:SF640', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER 16-LIKE PROTEIN', 245465),
(357648, 'PTHR24064', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER', 245465),
(357649, 'PTHR24064:SF486', NULL, NULL, NULL, NULL, 'HIGH AFFINITY INORGANIC PHOSPHATE TRANSPORTER', 245465),
(357650, 'PTHR24064:SF485', NULL, NULL, NULL, NULL, 'INORGANIC PHOSPHATE TRANSPORTER 1-4-RELATED', 245465),
(357651, 'PTHR24064:SF642', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357652, 'PTHR24064:SF488', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER PROTEIN4', 245465),
(357653, 'PTHR24064:SF641', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357654, 'PTHR24064:SF487', NULL, NULL, NULL, NULL, 'ORGANIC CATION/CARNITINE TRANSPORTER 2', 245465),
(357655, 'PTHR24064:SF520', NULL, NULL, NULL, NULL, 'H(+)/PI COTRANSPORTER', 245465),
(357656, 'PTHR24064:SF644', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357657, 'PTHR24064:SF247', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357658, 'PTHR24064:SF643', NULL, NULL, NULL, NULL, 'IP21853P-RELATED', 245465),
(357659, 'PTHR24064:SF646', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN-RELATED', 245465),
(357660, 'PTHR24064:SF525', NULL, NULL, NULL, NULL, 'INORGANIC PHOSPHATE TRANSPORTER 1-3-RELATED', 245465),
(357661, 'PTHR24064:SF645', NULL, NULL, NULL, NULL, 'INORGANIC PHOSPHATE TRANSPORTER 1-5-RELATED', 245465),
(357662, 'PTHR24064:SF648', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357663, 'PTHR24064:SF647', NULL, NULL, NULL, NULL, 'TRANSPORTER B0252.3-RELATED', 245465),
(357664, 'PTHR24064:SF529', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357665, 'PTHR24064:SF71', NULL, NULL, NULL, NULL, 'RH23644P', 245465),
(357666, 'PTHR24064:SF73', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357667, 'PTHR24064:SF75', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357668, 'PTHR24064:SF482', NULL, NULL, NULL, NULL, 'INORGANIC PHOSPHATE TRANSPORTER 1-8-RELATED', 245465),
(357669, 'PTHR24064:SF481', NULL, NULL, NULL, NULL, 'ORGANIC CATION/CARNITINE TRANSPORTER 3', 245465),
(357670, 'PTHR24064:SF77', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357671, 'PTHR24064:SF473', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN, EXPRESSED', 245465),
(357672, 'PTHR24064:SF198', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER 13', 245465),
(357673, 'PTHR24064:SF233', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 (ORGANIC ANION TRANSPORTER), MEMBER 8-LIKE, GENE 1', 245465),
(357674, 'PTHR24064:SF596', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357675, 'PTHR24064:SF232', NULL, NULL, NULL, NULL, 'INORGANIC PHOSPHATE TRANSPORTER 1-7-RELATED', 245465),
(357676, 'PTHR24064:SF474', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357677, 'PTHR24064:SF595', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHOINOSITOL TRANSPORTER 1', 245465),
(357678, 'PTHR24064:SF235', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G10690)-RELATED', 245465),
(357679, 'PTHR24064:SF477', NULL, NULL, NULL, NULL, 'PT5', 245465),
(357680, 'PTHR24064:SF631', NULL, NULL, NULL, NULL, 'INORGANIC PHOSPHATE TRANSPORTER 1-1-RELATED', 245465),
(357681, 'PTHR24064:SF597', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357682, 'PTHR24064:SF630', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER 21', 245465),
(357683, 'PTHR24064:SF633', NULL, NULL, NULL, NULL, '', 245465),
(357684, 'PTHR24064:SF237', NULL, NULL, NULL, NULL, 'INORGANIC PHOSPHATE TRANSPORTER 1-13-RELATED', 245465),
(357685, 'PTHR24064:SF512', NULL, NULL, NULL, NULL, 'OS07G0571700 PROTEIN', 245465),
(357686, 'PTHR24064:SF599', NULL, NULL, NULL, NULL, 'BNAA09G16490D PROTEIN', 245465),
(357687, 'PTHR24064:SF511', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(357688, 'PTHR24064:SF632', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357689, 'PTHR24064:SF478', NULL, NULL, NULL, NULL, 'INORGANIC PHOSPHATE TRANSPORTER 1-12-RELATED', 245465),
(357690, 'PTHR24064:SF635', NULL, NULL, NULL, NULL, 'HIGH AFFINITY INORGANIC PHOSPHATE TRANSPORTER', 245465),
(357691, 'PTHR24064:SF634', NULL, NULL, NULL, NULL, 'LOW AFFINITY INORGANIC PHOSPHATE TRANSPORTER 1-LIKE', 245465),
(357692, 'PTHR24064:SF516', NULL, NULL, NULL, NULL, 'ORGANIC CATION/CARNITINE TRANSPORTER 6', 245465),
(357693, 'PTHR24064:SF637', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357694, 'PTHR24064:SF636', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357695, 'PTHR24064:SF515', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357696, 'PTHR24064:SF639', NULL, NULL, NULL, NULL, 'INORGANIC PHOSPHATE TRANSPORTER C1683.01-RELATED', 245465),
(357697, 'PTHR24064:SF638', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245465),
(357698, 'PTHR15484', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE I SUBUNIT RPA34', 245466),
(357699, 'PTHR15484:SF8', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE I SUBUNIT RPA34', 245466),
(357700, 'PTHR28190:SF2', NULL, NULL, NULL, NULL, 'MIGRATION PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G07730)-RELATED', 245467),
(357701, 'PTHR28190:SF1', NULL, NULL, NULL, NULL, 'NUCLEAR MIGRATION PROTEIN NUM1', 245467),
(357702, 'PTHR28190', NULL, NULL, NULL, NULL, 'NUCLEAR MIGRATION PROTEIN NUM1', 245467),
(357703, 'PTHR34069:SF3', NULL, NULL, NULL, NULL, 'ACYL-COA:ACYL-COA ALKYLTRANSFERASE', 245468),
(357704, 'PTHR34069:SF2', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE 3', 245468),
(357705, 'PTHR34069', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE 3', 245468),
(357706, 'PTHR36695', NULL, NULL, NULL, NULL, 'AGAP008648-PA', 245469),
(357707, 'PTHR36695:SF12', NULL, NULL, NULL, NULL, 'AGAP008648-PA', 245469),
(357708, 'PTHR36695:SF13', NULL, NULL, NULL, NULL, '', 245469),
(357709, 'PTHR48295', NULL, NULL, NULL, NULL, 'CRANIOFACIAL DEVELOPMENT PROTEIN 1', 245470),
(357710, 'PTHR48295:SF1', NULL, NULL, NULL, NULL, 'CRANIOFACIAL DEVELOPMENT PROTEIN 1', 245470),
(357711, 'PTHR37823:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME C-553-LIKE', 245471),
(357712, 'PTHR37823', NULL, NULL, NULL, NULL, 'CYTOCHROME C-553-LIKE', 245471),
(357713, 'PTHR37823:SF3', NULL, NULL, NULL, NULL, 'CYTOCHROME C-551', 245471),
(357714, 'PTHR37823:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME C-550', 245471),
(357715, 'PTHR37823:SF4', NULL, NULL, NULL, NULL, 'MENAQUINOL-CYTOCHROME C REDUCTASE CYTOCHROME B/C SUBUNIT', 245471),
(357716, 'PTHR33289:SF2', NULL, NULL, NULL, NULL, 'ANCHORAGE SUBUNIT, PUTATIVE-RELATED', 245472),
(357717, 'PTHR33289', NULL, NULL, NULL, NULL, 'ANCHORAGE SUBUNIT, PUTATIVE-RELATED', 245472),
(357718, 'PTHR32385', NULL, NULL, NULL, NULL, 'MANNOSYL PHOSPHORYLINOSITOL CERAMIDE SYNTHASE', 245473),
(357719, 'PTHR32385:SF15', NULL, NULL, NULL, NULL, 'POLYSACCHARIDE BIOSYNTHESIS PROTEIN', 245473),
(357720, 'PTHR32385:SF21', NULL, NULL, NULL, NULL, 'INOSITOL PHOSPHOCERAMIDE MANNOSYLTRANSFERASE 1-RELATED', 245473),
(357721, 'PTHR32385:SF20', NULL, NULL, NULL, NULL, 'MANNOSYL PHOSPHORYLINOSITOL CERAMIDE SYNTHASE CSH1-RELATED', 245473),
(357722, 'PTHR28003', NULL, NULL, NULL, NULL, 'NUCLEOPORIN POM34', 245474),
(357723, 'PTHR28003:SF1', NULL, NULL, NULL, NULL, 'NUCLEOPORIN POM34', 245474),
(357724, 'PTHR17408:SF12', NULL, NULL, NULL, NULL, 'SLBP_RNA_BIND DOMAIN-CONTAINING PROTEIN', 245475),
(357725, 'PTHR17408:SF11', NULL, NULL, NULL, NULL, 'STEM-LOOP-BINDING PROTEIN-LIKE', 245475),
(357726, 'PTHR17408', NULL, NULL, NULL, NULL, 'HISTONE RNA HAIRPIN-BINDING PROTEIN', 245475),
(357727, 'PTHR17408:SF0', NULL, NULL, NULL, NULL, 'HISTONE RNA HAIRPIN-BINDING PROTEIN', 245475),
(357728, 'PTHR17408:SF9', NULL, NULL, NULL, NULL, 'SLBP_RNA_BIND DOMAIN-CONTAINING PROTEIN', 245475),
(357729, 'PTHR17408:SF7', NULL, NULL, NULL, NULL, 'HISTONE RNA HAIRPIN-BINDING PROTEIN', 245475);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(357730, 'PTHR30451:SF22', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE USHER PROTEIN HTRE', 245476),
(357731, 'PTHR30451:SF8', NULL, NULL, NULL, NULL, 'FIMBRIAL USHER PROTEIN-RELATED', 245476),
(357732, 'PTHR30451:SF9', NULL, NULL, NULL, NULL, 'F1 CAPSULE-ANCHORING PROTEIN', 245476),
(357733, 'PTHR30451:SF3', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE USHER PROTEIN YEHB', 245476),
(357734, 'PTHR30451:SF6', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE USHER PROTEIN SFMD', 245476),
(357735, 'PTHR30451', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE USHER PROTEIN', 245476),
(357736, 'PTHR30451:SF4', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE USHER PROTEIN YQIG-RELATED', 245476),
(357737, 'PTHR30451:SF20', NULL, NULL, NULL, NULL, 'FIMBRIAE USHER-RELATED', 245476),
(357738, 'PTHR30451:SF5', NULL, NULL, NULL, NULL, 'SLR0019 PROTEIN', 245476),
(357739, 'PTHR30451:SF10', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE USHER PROTEIN YFCU-RELATED', 245476),
(357740, 'PTHR30451:SF21', NULL, NULL, NULL, NULL, 'FIMBRIAL USHER DOMAIN-CONTAINING PROTEIN YDET-RELATED', 245476),
(357741, 'PTHR41709', NULL, NULL, NULL, NULL, 'KAIB-LIKE PROTEIN 1', 245477),
(357742, 'PTHR41709:SF2', NULL, NULL, NULL, NULL, 'KAIB-LIKE PROTEIN 1', 245477),
(357743, 'PTHR46087:SF11', NULL, NULL, NULL, NULL, 'PROTEIN SEMI-ROLLED LEAF 2', 245478),
(357744, 'PTHR46087:SF10', NULL, NULL, NULL, NULL, 'OS02G0780500 PROTEIN', 245478),
(357745, 'PTHR46087:SF19', NULL, NULL, NULL, NULL, 'CYCLIN-LIKE PROTEIN', 245478),
(357746, 'PTHR46087:SF4', NULL, NULL, NULL, NULL, 'OS07G0205900 PROTEIN', 245478),
(357747, 'PTHR46087:SF18', NULL, NULL, NULL, NULL, '', 245478),
(357748, 'PTHR46087:SF17', NULL, NULL, NULL, NULL, 'BNAC05G04080D PROTEIN', 245478),
(357749, 'PTHR46087:SF1', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 245478),
(357750, 'PTHR46087:SF16', NULL, NULL, NULL, NULL, 'BNAA08G31700D PROTEIN', 245478),
(357751, 'PTHR46087:SF15', NULL, NULL, NULL, NULL, 'BNAC04G02200D PROTEIN', 245478),
(357752, 'PTHR46087', NULL, NULL, NULL, NULL, 'PUTATIVE, EXPRESSED-RELATED', 245478),
(357753, 'PTHR46087:SF13', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN-RELATED', 245478),
(357754, 'PTHR46087:SF9', NULL, NULL, NULL, NULL, 'OS02G0143200 PROTEIN', 245478),
(357755, 'PTHR46087:SF7', NULL, NULL, NULL, NULL, 'CYCLIN-LIKE PROTEIN', 245478),
(357756, 'PTHR28668:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 234', 245479),
(357757, 'PTHR28668', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 234', 245479),
(357758, 'PTHR10603', NULL, NULL, NULL, NULL, 'FRAGILE X MENTAL RETARDATION SYNDROME-RELATED PROTEIN', 245480),
(357759, 'PTHR10603:SF4', NULL, NULL, NULL, NULL, 'SYNAPTIC FUNCTIONAL REGULATOR FMR1', 245480),
(357760, 'PTHR10603:SF3', NULL, NULL, NULL, NULL, 'FRAGILE X MENTAL RETARDATION SYNDROME-RELATED PROTEIN 2', 245480),
(357761, 'PTHR10603:SF6', NULL, NULL, NULL, NULL, 'FRAGILE X MENTAL RETARDATION SYNDROME-RELATED PROTEIN 1', 245480),
(357762, 'PTHR10603:SF7', NULL, NULL, NULL, NULL, 'SYNAPTIC FUNCTIONAL REGULATOR FMR1', 245480),
(357763, 'PTHR21063:SF4', NULL, NULL, NULL, NULL, 'ENVELOPE GLYCOPROTEIN E-RELATED', 245481),
(357764, 'PTHR21063', NULL, NULL, NULL, NULL, 'LFA-3', 245481),
(357765, 'PTHR23344:SF50', NULL, NULL, NULL, NULL, 'GP-PDE DOMAIN-CONTAINING PROTEIN', 245482),
(357766, 'PTHR23344', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHORYL DIESTER PHOSPHODIESTERASE', 245482),
(357767, 'PTHR23344:SF1', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHOINOSITOL INOSITOLPHOSPHODIESTERASE GDPD2', 245482),
(357768, 'PTHR23344:SF13', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE DOMAIN-CONTAINING PROTEIN 4', 245482),
(357769, 'PTHR23344:SF49', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE DOMAIN-CONTAINING 5A', 245482),
(357770, 'PTHR23344:SF6', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE DOMAIN-CONTAINING PROTEIN 5', 245482),
(357771, 'PTHR14715:SF7', NULL, NULL, NULL, NULL, '', 245483),
(357772, 'PTHR14715', NULL, NULL, NULL, NULL, '', 245483),
(357773, 'PTHR14715:SF4', NULL, NULL, NULL, NULL, 'PROTEIN FAM124A', 245483);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(357774, 'PTHR14715:SF6', NULL, NULL, NULL, NULL, '', 245483),
(357775, 'PTHR14715:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM124B', 245483),
(357776, 'PTHR34672:SF13', NULL, NULL, NULL, NULL, 'BNAC03G23540D PROTEIN', 245484),
(357777, 'PTHR34672:SF6', NULL, NULL, NULL, NULL, 'BNAC04G02280D PROTEIN', 245484),
(357778, 'PTHR34672:SF12', NULL, NULL, NULL, NULL, 'BNACNNG40600D PROTEIN', 245484),
(357779, 'PTHR34672:SF14', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN PROTEIN 40', 245484),
(357780, 'PTHR34672:SF9', NULL, NULL, NULL, NULL, 'POLLEN-SPECIFIC ARABINOGALACTA PROTEIN BAN102', 245484),
(357781, 'PTHR34672:SF7', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN PROTEIN 1', 245484),
(357782, 'PTHR34672:SF10', NULL, NULL, NULL, NULL, 'BNAANNG40690D PROTEIN', 245484),
(357783, 'PTHR34672', NULL, NULL, NULL, NULL, 'POLLEN-SPECIFIC ARABINOGALACTA PROTEIN BAN102', 245484),
(357784, 'PTHR34672:SF2', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN PROTEIN 23', 245484),
(357785, 'PTHR34672:SF16', NULL, NULL, NULL, NULL, 'OS02G0195900 PROTEIN', 245484),
(357786, 'PTHR14189:SF0', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE METHYLESTERASE 1', 245485),
(357787, 'PTHR14189', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE METHYLESTERASE-1 RELATED', 245485),
(357788, 'PTHR45166:SF1', NULL, NULL, NULL, NULL, 'V-SET AND IMMUNOGLOBULIN DOMAIN-CONTAINING PROTEIN 8', 245486),
(357789, 'PTHR45166', NULL, NULL, NULL, NULL, 'V-SET AND IMMUNOGLOBULIN DOMAIN-CONTAINING PROTEIN 8', 245486),
(357790, 'PTHR33239:SF4', NULL, NULL, NULL, NULL, 'CBM49 DOMAIN-CONTAINING PROTEIN-RELATED', 245487),
(357791, 'PTHR33239:SF5', NULL, NULL, NULL, NULL, 'CBM49 DOMAIN-CONTAINING PROTEIN-RELATED', 245487),
(357792, 'PTHR33239:SF6', NULL, NULL, NULL, NULL, 'CBM49 DOMAIN-CONTAINING PROTEIN', 245487),
(357793, 'PTHR33239:SF8', NULL, NULL, NULL, NULL, 'CBM49 DOMAIN-CONTAINING PROTEIN', 245487),
(357794, 'PTHR33239:SF9', NULL, NULL, NULL, NULL, 'CBM49 DOMAIN-CONTAINING PROTEIN-RELATED', 245487),
(357795, 'PTHR33239', NULL, NULL, NULL, NULL, 'CELLULOSE-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 245487),
(357796, 'PTHR33239:SF17', NULL, NULL, NULL, NULL, 'CBM49 DOMAIN-CONTAINING PROTEIN', 245487),
(357797, 'PTHR33239:SF19', NULL, NULL, NULL, NULL, 'CMP/DCMP-TYPE DEAMINASE DOMAIN-CONTAINING PROTEIN-RELATED', 245487),
(357798, 'PTHR33239:SF18', NULL, NULL, NULL, NULL, 'CELLULOSE-BINDING DOMAIN-CONTAINING PROTEIN', 245487),
(357799, 'PTHR33239:SF12', NULL, NULL, NULL, NULL, '', 245487),
(357800, 'PTHR33239:SF14', NULL, NULL, NULL, NULL, 'CBM49 DOMAIN-CONTAINING PROTEIN', 245487),
(357801, 'PTHR33239:SF1', NULL, NULL, NULL, NULL, 'CELLULOSE-BINDING DOMAIN-CONTAINING PROTEIN', 245487),
(357802, 'PTHR33239:SF11', NULL, NULL, NULL, NULL, 'CBM49 DOMAIN-CONTAINING PROTEIN-RELATED', 245487),
(357803, 'PTHR12109:SF3', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 141', 245488),
(357804, 'PTHR12109:SF5', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 245488),
(357805, 'PTHR12109:SF10', NULL, NULL, NULL, NULL, 'FI02064P', 245488),
(357806, 'PTHR12109', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 141-RELATED', 245488),
(357807, 'PTHR24336:SF12', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR LBX2', 245489),
(357808, 'PTHR24336:SF8', NULL, NULL, NULL, NULL, 'LADYBIRD EARLY-RELATED', 245489),
(357809, 'PTHR24336', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR LBX', 245489),
(357810, 'PTHR24336:SF9', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR LBX1', 245489),
(357811, 'PTHR24336:SF10', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR LBX2', 245489),
(357812, 'PTHR36470:SF1', NULL, NULL, NULL, NULL, 'IZUMO SPERM-EGG FUSION PROTEIN 3', 245490),
(357813, 'PTHR36470', NULL, NULL, NULL, NULL, 'IZUMO SPERM-EGG FUSION PROTEIN 3', 245490),
(357814, 'PTHR24280', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 20A1', 245491),
(357815, 'PTHR24280:SF4', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 20A1', 245491),
(357816, 'PTHR47539', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN OTP51, CHLOROPLASTIC', 245492),
(357817, 'PTHR47539:SF1', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN OTP51, CHLOROPLASTIC', 245492);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(357818, 'PTHR23145', NULL, NULL, NULL, NULL, 'NUCLEOSOMAL BINDING PROTEIN 1', 245493),
(357819, 'PTHR23145:SF6', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP NUCLEOSOME-BINDING DOMAIN-CONTAINING PROTEIN 5', 245493),
(357820, 'PTHR46550:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED SEQUENCE C85627-RELATED', 245494),
(357821, 'PTHR46550:SF1', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN 3', 245494),
(357822, 'PTHR46550:SF4', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SKIP31-LIKE ISOFORM X1', 245494),
(357823, 'PTHR46550', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 3', 245494),
(357824, 'PTHR46550:SF6', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 3', 245494),
(357825, 'PTHR46550:SF5', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 245494),
(357826, 'PTHR33405:SF7', NULL, NULL, NULL, NULL, 'PROTEIN FLX-LIKE 1', 245495),
(357827, 'PTHR33405:SF18', NULL, NULL, NULL, NULL, 'PROTEIN FLX-LIKE 4', 245495),
(357828, 'PTHR33405', NULL, NULL, NULL, NULL, 'PROTEIN FLX-LIKE 2', 245495),
(357829, 'PTHR33405:SF17', NULL, NULL, NULL, NULL, 'PROTEIN FLC EXPRESSOR', 245495),
(357830, 'PTHR33405:SF19', NULL, NULL, NULL, NULL, 'OS08G0430100 PROTEIN', 245495),
(357831, 'PTHR33405:SF4', NULL, NULL, NULL, NULL, 'PROTEIN FLX-LIKE 2', 245495),
(357832, 'PTHR33405:SF21', NULL, NULL, NULL, NULL, '', 245495),
(357833, 'PTHR33405:SF20', NULL, NULL, NULL, NULL, 'PROTEIN FLX-LIKE 3', 245495),
(357834, 'PTHR33405:SF23', NULL, NULL, NULL, NULL, 'BNAA05G13920D PROTEIN', 245495),
(357835, 'PTHR33405:SF25', NULL, NULL, NULL, NULL, '', 245495),
(357836, 'PTHR33405:SF16', NULL, NULL, NULL, NULL, '', 245495),
(357837, 'PTHR35202:SF2', NULL, NULL, NULL, NULL, '', 245496),
(357838, 'PTHR35202:SF1', NULL, NULL, NULL, NULL, '', 245496),
(357839, 'PTHR35202:SF4', NULL, NULL, NULL, NULL, '', 245496),
(357840, 'PTHR35202:SF3', NULL, NULL, NULL, NULL, '', 245496),
(357841, 'PTHR35202:SF5', NULL, NULL, NULL, NULL, '', 245496),
(357842, 'PTHR35202', NULL, NULL, NULL, NULL, '', 245496),
(357843, 'PTHR42742:SF3', NULL, NULL, NULL, NULL, 'MANNOSE-6-PHOSPHATE ISOMERASE GMUF-RELATED', 245497),
(357844, 'PTHR42742', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR MPRA', 245497),
(357845, 'PTHR36132', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 221', 245498),
(357846, 'PTHR36132:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 221', 245498),
(357847, 'PTHR47117:SF1', NULL, NULL, NULL, NULL, 'STAR-RELATED LIPID TRANSFER PROTEIN 9', 245499),
(357848, 'PTHR47117', NULL, NULL, NULL, NULL, 'STAR-RELATED LIPID TRANSFER PROTEIN 9', 245499),
(357849, 'PTHR42747', NULL, NULL, NULL, NULL, 'NITRONATE MONOOXYGENASE-RELATED', 245500),
(357850, 'PTHR42747:SF4', NULL, NULL, NULL, NULL, 'BLR1330 PROTEIN', 245500),
(357851, 'PTHR42747:SF3', NULL, NULL, NULL, NULL, 'NITRONATE MONOOXYGENASE-RELATED', 245500),
(357852, 'PTHR35852:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG08380', 245501),
(357853, 'PTHR35852:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG00231', 245501),
(357854, 'PTHR35852:SF4', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE-LIKE PEPTIDE 36', 245501),
(357855, 'PTHR35852:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG16246', 245501),
(357856, 'PTHR35852', NULL, NULL, NULL, NULL, 'PROTEIN CBG16246', 245501),
(357857, 'PTHR31330:SF1', NULL, NULL, NULL, NULL, 'NEMATODE SPECIFIC PEPTIDE FAMILY, GROUP C', 245502),
(357858, 'PTHR31330', NULL, NULL, NULL, NULL, 'NEMATODE SPECIFIC PEPTIDE FAMILY, GROUP C', 245502),
(357859, 'PTHR24346:SF72', NULL, NULL, NULL, NULL, 'CAMK PROTEIN KINASE', 245503),
(357860, 'PTHR24346:SF74', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245503),
(357861, 'PTHR24346:SF30', NULL, NULL, NULL, NULL, 'KP78A-RELATED', 245503),
(357862, 'PTHR24346:SF51', NULL, NULL, NULL, NULL, 'PAS DOMAIN-CONTAINING SERINE/THREONINE-PROTEIN KINASE', 245503),
(357863, 'PTHR24346:SF73', NULL, NULL, NULL, NULL, 'CHK1 CHECKPOINT HOMOLOG', 245503),
(357864, 'PTHR24346:SF76', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 245503),
(357865, 'PTHR24346:SF53', NULL, NULL, NULL, NULL, 'GEMINIVIRUS REP INTERACTING KINASE 1 ISOFORM 1', 245503);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(357866, 'PTHR24346:SF75', NULL, NULL, NULL, NULL, 'CATABOLITE DEREPRESSING PROTEIN KINASE, PUTATIVE-RELATED', 245503),
(357867, 'PTHR24346:SF56', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE MARK2', 245503),
(357868, 'PTHR24346:SF78', NULL, NULL, NULL, NULL, 'MAP/MICROTUBULE AFFINITY-REGULATING KINASE 4-RELATED', 245503),
(357869, 'PTHR24346:SF77', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-DEPENDENT PROTEIN KINASE KINASE 1', 245503),
(357870, 'PTHR24346:SF36', NULL, NULL, NULL, NULL, 'BR SERINE/THREONINE KINASE 1', 245503),
(357871, 'PTHR24346:SF79', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245503),
(357872, 'PTHR24346:SF35', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245503),
(357873, 'PTHR24346:SF38', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 245503),
(357874, 'PTHR24346:SF59', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245503),
(357875, 'PTHR24346:SF39', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE GRIK1-RELATED', 245503),
(357876, 'PTHR24346:SF81', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE FNKB-RELATED', 245503),
(357877, 'PTHR24346:SF80', NULL, NULL, NULL, NULL, 'HORMONALLY UP-REGULATED NEU TUMOR-ASSOCIATED KINASE', 245503),
(357878, 'PTHR24346:SF83', NULL, NULL, NULL, NULL, 'SI:CH211-197L9.5', 245503),
(357879, 'PTHR24346:SF82', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 245503),
(357880, 'PTHR24346:SF41', NULL, NULL, NULL, NULL, 'SNF RELATED KINASE', 245503),
(357881, 'PTHR24346:SF62', NULL, NULL, NULL, NULL, 'SERINE/THREONINE KINASE FAMILY PROTEIN', 245503),
(357882, 'PTHR24346:SF21', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE MARK1', 245503),
(357883, 'PTHR24346:SF42', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SIK3', 245503),
(357884, 'PTHR24346:SF45', NULL, NULL, NULL, NULL, 'SNF RELATED KINASE', 245503),
(357885, 'PTHR24346', NULL, NULL, NULL, NULL, 'MAP/MICROTUBULE AFFINITY-REGULATING KINASE', 245503),
(357886, 'PTHR24346:SF44', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245503),
(357887, 'PTHR24346:SF47', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE-RELATED', 245503),
(357888, 'PTHR24346:SF69', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245503),
(357889, 'PTHR24346:SF46', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 245503),
(357890, 'PTHR24346:SF27', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE MARK-C-RELATED', 245503),
(357891, 'PTHR24346:SF49', NULL, NULL, NULL, NULL, 'NIM1 SERINE/THREONINE PROTEIN KINASE', 245503),
(357892, 'PTHR24346:SF29', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245503),
(357893, 'PTHR24346:SF28', NULL, NULL, NULL, NULL, 'MAP/MICROTUBULE AFFINITY-REGULATING KINASE 4', 245503),
(357894, 'PTHR24346:SF1', NULL, NULL, NULL, NULL, 'MAP/MICROTUBULE AFFINITY-REGULATING KINASE 3', 245503),
(357895, 'PTHR24346:SF3', NULL, NULL, NULL, NULL, 'GENE 10662-RELATED', 245503),
(357896, 'PTHR48032:SF8', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 1-LIKE', 245504),
(357897, 'PTHR48032:SF10', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN MUSASHI HOMOLOG 2', 245504),
(357898, 'PTHR48032:SF3', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN MUSASHI HOMOLOG 1', 245504),
(357899, 'PTHR48032:SF2', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 245504),
(357900, 'PTHR48032:SF1', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 245504),
(357901, 'PTHR48032:SF7', NULL, NULL, NULL, NULL, '', 245504),
(357902, 'PTHR48032:SF6', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN MUSASHI HOMOLOG RBP6', 245504),
(357903, 'PTHR48032:SF5', NULL, NULL, NULL, NULL, 'OS07G0584500 PROTEIN', 245504),
(357904, 'PTHR48032:SF4', NULL, NULL, NULL, NULL, 'FI20028P1', 245504),
(357905, 'PTHR48032', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN MUSASHI HOMOLOG RBP6', 245504),
(357906, 'PTHR48032:SF12', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 1', 245504);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(357907, 'PTHR48032:SF13', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 245504),
(357908, 'PTHR48032:SF14', NULL, NULL, NULL, NULL, 'BNAC05G52200D PROTEIN', 245504),
(357909, 'PTHR48032:SF15', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN 1-LIKE', 245504),
(357910, 'PTHR43127:SF1', NULL, NULL, NULL, NULL, 'DEVELOPMENTALLY-REGULATED GTP-BINDING PROTEIN 1', 245505),
(357911, 'PTHR43127', NULL, NULL, NULL, NULL, 'DEVELOPMENTALLY-REGULATED GTP-BINDING PROTEIN 2', 245505),
(357912, 'PTHR43127:SF3', NULL, NULL, NULL, NULL, 'DEVELOPMENTALLY-REGULATED G-PROTEIN 1', 245505),
(357913, 'PTHR43127:SF2', NULL, NULL, NULL, NULL, 'DEVELOPMENTALLY-REGULATED GTP-BINDING PROTEIN 2', 245505),
(357914, 'PTHR43127:SF7', NULL, NULL, NULL, NULL, 'DEVELOPMENTALLY REGULATED GTP-BINDING PROTEIN', 245505),
(357915, 'PTHR43127:SF6', NULL, NULL, NULL, NULL, 'BNAA06G11750D PROTEIN', 245505),
(357916, 'PTHR46451:SF1', NULL, NULL, NULL, NULL, 'RAS-RESPONSIVE ELEMENT-BINDING PROTEIN 1', 245506),
(357917, 'PTHR46451', NULL, NULL, NULL, NULL, 'RAS-RESPONSIVE ELEMENT-BINDING PROTEIN 1', 245506),
(357918, 'PTHR35894:SF7', NULL, NULL, NULL, NULL, 'EHA PROTEIN', 245507),
(357919, 'PTHR35894:SF4', NULL, NULL, NULL, NULL, 'DAMX-RELATED PROTEIN', 245507),
(357920, 'PTHR35894:SF5', NULL, NULL, NULL, NULL, 'MU-LIKE PROPHAGE FLUMU DNA TRANSPOSITION PROTEIN B', 245507),
(357921, 'PTHR35894', NULL, NULL, NULL, NULL, 'GENERAL SECRETION PATHWAY PROTEIN A-RELATED', 245507),
(357922, 'PTHR35894:SF1', NULL, NULL, NULL, NULL, 'GENERAL SECRETION PATHWAY PROTEIN A-RELATED', 245507),
(357923, 'PTHR15564:SF2', NULL, NULL, NULL, NULL, 'BMP/RETINOIC ACID-INDUCIBLE NEURAL-SPECIFIC PROTEIN 3', 245508),
(357924, 'PTHR15564:SF3', NULL, NULL, NULL, NULL, 'MACPF DOMAIN-CONTAINING PROTEIN', 245508),
(357925, 'PTHR15564:SF8', NULL, NULL, NULL, NULL, 'BMP/RETINOIC ACID-INDUCIBLE NEURAL-SPECIFIC PROTEIN 2', 245508),
(357926, 'PTHR15564:SF10', NULL, NULL, NULL, NULL, 'BONE MORPHOGENETIC PROTEIN/RETINOIC ACID-INDUCIBLE NEURAL-SPECIFIC 3A, TANDEM DUPLICATE 1-RELATED', 245508),
(357927, 'PTHR15564:SF4', NULL, NULL, NULL, NULL, 'BONE MORPHOGENETIC PROTEIN/RETINOIC ACID-INDUCIBLE NEURAL-SPECIFIC 2', 245508),
(357928, 'PTHR15564:SF7', NULL, NULL, NULL, NULL, 'BMP/RETINOIC ACID-INDUCIBLE NEURAL-SPECIFIC PROTEIN 1', 245508),
(357929, 'PTHR15564', NULL, NULL, NULL, NULL, 'MACPF DOMAIN-CONTAINING PROTEIN', 245508),
(357930, 'PTHR46925:SF3', NULL, NULL, NULL, NULL, 'SUBSTANCE-K RECEPTOR', 245509),
(357931, 'PTHR46925', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR TKR-1-RELATED', 245509),
(357932, 'PTHR46925:SF4', NULL, NULL, NULL, NULL, 'SUBSTANCE-P RECEPTOR', 245509),
(357933, 'PTHR46925:SF1', NULL, NULL, NULL, NULL, 'NEUROMEDIN-K RECEPTOR', 245509),
(357934, 'PTHR46925:SF2', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR TKR-1-RELATED', 245509),
(357935, 'PTHR41164', NULL, NULL, NULL, NULL, 'CURLI PRODUCTION ASSEMBLY/TRANSPORT COMPONENT CSGG', 245510),
(357936, 'PTHR41164:SF1', NULL, NULL, NULL, NULL, 'CURLI PRODUCTION ASSEMBLY/TRANSPORT COMPONENT CSGG', 245510),
(357937, 'PTHR10933', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN-BINDING PROTEIN 1', 245511),
(357938, 'PTHR10933:SF9', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN (CD79A)-BINDING PROTEIN 1', 245511),
(357939, 'PTHR10933:SF11', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN-BINDING PROTEIN 1', 245511),
(357940, 'PTHR10933:SF12', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN-BINDING PROTEIN 1', 245511),
(357941, 'PTHR10933:SF13', NULL, NULL, NULL, NULL, '', 245511),
(357942, 'PTHR10933:SF14', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN-BINDING PROTEIN 1B', 245511),
(357943, 'PTHR10933:SF15', NULL, NULL, NULL, NULL, 'HCG1642624, ISOFORM CRA_A', 245511),
(357944, 'PTHR10933:SF16', NULL, NULL, NULL, NULL, 'PP2A REGULATORY SUBUNIT TAP46', 245511),
(357945, 'PTHR45614:SF51', NULL, NULL, NULL, NULL, 'MYB-LIKE DNA-BINDING PROTEIN BAS1', 245512),
(357946, 'PTHR45614:SF102', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR TAMYB1', 245512),
(357947, 'PTHR45614:SF228', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB3R-4', 245512);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(357948, 'PTHR45614:SF227', NULL, NULL, NULL, NULL, 'MYB-LIKE PROTEIN Q ISOFORM X1', 245512),
(357949, 'PTHR45614:SF109', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 245512),
(357950, 'PTHR45614:SF229', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR-LIKE PROTEIN-RELATED', 245512),
(357951, 'PTHR45614:SF182', NULL, NULL, NULL, NULL, 'MYB119', 245512),
(357952, 'PTHR45614:SF101', NULL, NULL, NULL, NULL, 'BNAC03G36160D PROTEIN', 245512),
(357953, 'PTHR45614:SF221', NULL, NULL, NULL, NULL, 'MYB DOMAIN PROTEIN 110', 245512),
(357954, 'PTHR45614:SF100', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 245512),
(357955, 'PTHR45614:SF218', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB119-RELATED', 245512),
(357956, 'PTHR45614:SF171', NULL, NULL, NULL, NULL, 'BNAC02G34810D PROTEIN', 245512),
(357957, 'PTHR45614:SF175', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB117', 245512),
(357958, 'PTHR45614:SF178', NULL, NULL, NULL, NULL, 'BNAA03G52540D PROTEIN', 245512),
(357959, 'PTHR45614:SF177', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN B-LIKE', 245512),
(357960, 'PTHR45614:SF210', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 245512),
(357961, 'PTHR45614:SF33', NULL, NULL, NULL, NULL, 'OS02G0271900 PROTEIN', 245512),
(357962, 'PTHR45614:SF30', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN B', 245512),
(357963, 'PTHR45614:SF73', NULL, NULL, NULL, NULL, 'OS06G0258200 PROTEIN', 245512),
(357964, 'PTHR45614:SF72', NULL, NULL, NULL, NULL, 'BNAC04G05500D PROTEIN', 245512),
(357965, 'PTHR45614:SF246', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB44-LIKE', 245512),
(357966, 'PTHR45614:SF245', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB44-LIKE', 245512),
(357967, 'PTHR45614:SF124', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB73', 245512),
(357968, 'PTHR45614:SF248', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN 3R-1-LIKE', 245512),
(357969, 'PTHR45614:SF126', NULL, NULL, NULL, NULL, 'BNAC07G31640D PROTEIN', 245512),
(357970, 'PTHR45614:SF247', NULL, NULL, NULL, NULL, 'MYB PROTO-ONCOGENE PROTEIN', 245512),
(357971, 'PTHR45614:SF128', NULL, NULL, NULL, NULL, 'BNAANNG13080D PROTEIN', 245512),
(357972, 'PTHR45614:SF249', NULL, NULL, NULL, NULL, 'OS03G0236300 PROTEIN', 245512),
(357973, 'PTHR45614:SF240', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 245512),
(357974, 'PTHR45614:SF242', NULL, NULL, NULL, NULL, 'OS07G0222501 PROTEIN', 245512),
(357975, 'PTHR45614:SF121', NULL, NULL, NULL, NULL, 'BNAA03G53870D PROTEIN', 245512),
(357976, 'PTHR45614:SF241', NULL, NULL, NULL, NULL, 'MYB-LIKE DNA-BINDING DOMAIN CONTAINING PROTEIN', 245512),
(357977, 'PTHR45614:SF120', NULL, NULL, NULL, NULL, 'BNAC03G61550D PROTEIN', 245512),
(357978, 'PTHR45614:SF123', NULL, NULL, NULL, NULL, 'MYB DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 245512),
(357979, 'PTHR45614:SF244', NULL, NULL, NULL, NULL, '', 245512),
(357980, 'PTHR45614:SF243', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB52', 245512),
(357981, 'PTHR45614:SF69', NULL, NULL, NULL, NULL, 'MYB-LIKE DNA-BINDING DOMAIN CONTAINING PROTEIN', 245512),
(357982, 'PTHR45614:SF61', NULL, NULL, NULL, NULL, 'OS05G0459000 PROTEIN', 245512),
(357983, 'PTHR45614:SF235', NULL, NULL, NULL, NULL, 'MYB DNA BINDING PROTEIN/ TRANSCRIPTION FACTOR-LIKE PROTEIN', 245512),
(357984, 'PTHR45614:SF234', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 245512),
(357985, 'PTHR45614:SF237', NULL, NULL, NULL, NULL, '', 245512),
(357986, 'PTHR45614:SF236', NULL, NULL, NULL, NULL, 'MYB-LIKE DNA-BINDING DOMAIN CONTAINING PROTEIN', 245512),
(357987, 'PTHR45614:SF239', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 245512),
(357988, 'PTHR45614:SF238', NULL, NULL, NULL, NULL, 'MYB-LIKE TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 245512),
(357989, 'PTHR45614:SF119', NULL, NULL, NULL, NULL, 'BNAA04G10300D PROTEIN', 245512),
(357990, 'PTHR45614:SF194', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB3R-3-RELATED', 245512),
(357991, 'PTHR45614:SF193', NULL, NULL, NULL, NULL, '', 245512),
(357992, 'PTHR45614:SF195', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB77', 245512);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(357993, 'PTHR45614:SF110', NULL, NULL, NULL, NULL, 'BNAANNG17310D PROTEIN', 245512),
(357994, 'PTHR45614:SF231', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB1', 245512),
(357995, 'PTHR45614:SF230', NULL, NULL, NULL, NULL, 'OS08G0435700 PROTEIN', 245512),
(357996, 'PTHR45614:SF233', NULL, NULL, NULL, NULL, '', 245512),
(357997, 'PTHR45614:SF199', NULL, NULL, NULL, NULL, 'MYB-LIKE TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 245512),
(357998, 'PTHR45614:SF232', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB3R-2', 245512),
(357999, 'PTHR45614:SF190', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB44', 245512),
(358000, 'PTHR45614:SF54', NULL, NULL, NULL, NULL, 'MYB-LIKE DNA-BINDING DOMAIN CONTAINING PROTEIN', 245512),
(358001, 'PTHR45614:SF53', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB44-LIKE', 245512),
(358002, 'PTHR45614:SF95', NULL, NULL, NULL, NULL, '', 245512),
(358003, 'PTHR45614:SF92', NULL, NULL, NULL, NULL, 'MYB-LIKE PROTEIN B', 245512),
(358004, 'PTHR45614', NULL, NULL, NULL, NULL, 'MYB PROTEIN-RELATED', 245512),
(358005, 'PTHR45614:SF268', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB98-LIKE', 245512),
(358006, 'PTHR45614:SF9', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN A', 245512),
(358007, 'PTHR45614:SF267', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 245512),
(358008, 'PTHR45614:SF8', NULL, NULL, NULL, NULL, '', 245512),
(358009, 'PTHR45614:SF269', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB44-LIKE', 245512),
(358010, 'PTHR45614:SF148', NULL, NULL, NULL, NULL, 'BNAC03G35980D PROTEIN', 245512),
(358011, 'PTHR45614:SF6', NULL, NULL, NULL, NULL, 'MYB DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 245512),
(358012, 'PTHR45614:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR MYB', 245512),
(358013, 'PTHR45614:SF3', NULL, NULL, NULL, NULL, 'OS06G0637500 PROTEIN', 245512),
(358014, 'PTHR45614:SF260', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB105', 245512),
(358015, 'PTHR45614:SF141', NULL, NULL, NULL, NULL, 'BNAC07G50190D PROTEIN', 245512),
(358016, 'PTHR45614:SF262', NULL, NULL, NULL, NULL, 'MYB DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 245512),
(358017, 'PTHR45614:SF140', NULL, NULL, NULL, NULL, 'BNAA10G27190D PROTEIN', 245512),
(358018, 'PTHR45614:SF261', NULL, NULL, NULL, NULL, 'MYB-LIKE DNA-BINDING DOMAIN CONTAINING PROTEIN', 245512),
(358019, 'PTHR45614:SF264', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-RELATED', 245512),
(358020, 'PTHR45614:SF263', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 245512),
(358021, 'PTHR45614:SF266', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB3R-1', 245512),
(358022, 'PTHR45614:SF265', NULL, NULL, NULL, NULL, 'MYB-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 245512),
(358023, 'PTHR45614:SF87', NULL, NULL, NULL, NULL, 'MYB-LIKE PROTEIN C', 245512),
(358024, 'PTHR45614:SF82', NULL, NULL, NULL, NULL, 'OS01G0977300 PROTEIN', 245512),
(358025, 'PTHR45614:SF80', NULL, NULL, NULL, NULL, '', 245512),
(358026, 'PTHR45614:SF136', NULL, NULL, NULL, NULL, 'BNAA02G29620D PROTEIN', 245512),
(358027, 'PTHR45614:SF257', NULL, NULL, NULL, NULL, '', 245512),
(358028, 'PTHR45614:SF135', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB88', 245512),
(358029, 'PTHR45614:SF256', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB54', 245512),
(358030, 'PTHR45614:SF259', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB56', 245512),
(358031, 'PTHR45614:SF258', NULL, NULL, NULL, NULL, '', 245512),
(358032, 'PTHR45614:SF137', NULL, NULL, NULL, NULL, '', 245512),
(358033, 'PTHR45614:SF139', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 245512),
(358034, 'PTHR45614:SF251', NULL, NULL, NULL, NULL, '', 245512),
(358035, 'PTHR45614:SF250', NULL, NULL, NULL, NULL, 'MYB DOMAIN PROTEIN 110', 245512),
(358036, 'PTHR45614:SF253', NULL, NULL, NULL, NULL, 'MYB24', 245512),
(358037, 'PTHR45614:SF132', NULL, NULL, NULL, NULL, 'BNAA02G36420D PROTEIN', 245512),
(358038, 'PTHR45614:SF252', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 245512),
(358039, 'PTHR45614:SF255', NULL, NULL, NULL, NULL, 'MYB DOMAIN PROTEIN 64-RELATED', 245512);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(358040, 'PTHR45614:SF254', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN TOD6', 245512),
(358041, 'PTHR45614:SF76', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB124', 245512),
(358042, 'PTHR45614:SF74', NULL, NULL, NULL, NULL, 'MYB DOMAIN PROTEIN 118', 245512),
(358043, 'PTHR45614:SF209', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 245512),
(358044, 'PTHR45614:SF169', NULL, NULL, NULL, NULL, 'BNAA10G16980D PROTEIN', 245512),
(358045, 'PTHR45614:SF168', NULL, NULL, NULL, NULL, 'MYB', 245512),
(358046, 'PTHR45614:SF206', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN MYBAS1-LIKE', 245512),
(358047, 'PTHR45614:SF205', NULL, NULL, NULL, NULL, 'MYB-LIKE PROTEIN A-RELATED', 245512),
(358048, 'PTHR45614:SF160', NULL, NULL, NULL, NULL, 'BNAC06G43380D PROTEIN', 245512),
(358049, 'PTHR45614:SF163', NULL, NULL, NULL, NULL, 'BNAA09G44780D PROTEIN', 245512),
(358050, 'PTHR45614:SF162', NULL, NULL, NULL, NULL, 'BNAC03G66940D PROTEIN', 245512),
(358051, 'PTHR45614:SF26', NULL, NULL, NULL, NULL, 'MYB-LIKE PROTEIN Q', 245512),
(358052, 'PTHR45614:SF25', NULL, NULL, NULL, NULL, 'MYB PROTEIN', 245512),
(358053, 'PTHR45614:SF158', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB98', 245512),
(358054, 'PTHR45614:SF271', NULL, NULL, NULL, NULL, 'ASPARAGINASE', 245512),
(358055, 'PTHR45614:SF150', NULL, NULL, NULL, NULL, 'OS10G0350400 PROTEIN', 245512),
(358056, 'PTHR45614:SF270', NULL, NULL, NULL, NULL, 'MYB DOMAIN PROTEIN 89', 245512),
(358057, 'PTHR45614:SF273', NULL, NULL, NULL, NULL, 'MYB DOMAIN PROTEIN 100-RELATED', 245512),
(358058, 'PTHR45614:SF272', NULL, NULL, NULL, NULL, 'MYB DOMAIN PROTEIN 56', 245512),
(358059, 'PTHR45614:SF153', NULL, NULL, NULL, NULL, 'BNAA04G13540D PROTEIN', 245512),
(358060, 'PTHR45614:SF156', NULL, NULL, NULL, NULL, 'BNAC04G32490D PROTEIN', 245512),
(358061, 'PTHR45614:SF16', NULL, NULL, NULL, NULL, 'MYB-LIKE DNA-BINDING DOMAIN CONTAINING PROTEIN, EXPRESSED', 245512),
(358062, 'PTHR45614:SF10', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 245512),
(358063, 'PTHR43702:SF3', NULL, NULL, NULL, NULL, 'MONOSACCHARIDE TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G06630)-RELATED', 245513),
(358064, 'PTHR43702:SF2', NULL, NULL, NULL, NULL, 'PROTEIN TSGA', 245513),
(358065, 'PTHR43702', NULL, NULL, NULL, NULL, 'L-FUCOSE-PROTON SYMPORTER', 245513),
(358066, 'PTHR43702:SF5', NULL, NULL, NULL, NULL, '', 245513),
(358067, 'PTHR43702:SF10', NULL, NULL, NULL, NULL, 'PERMEASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G06730)-RELATED', 245513),
(358068, 'PTHR43702:SF11', NULL, NULL, NULL, NULL, 'L-FUCOSE-PROTON SYMPORTER', 245513),
(358069, 'PTHR33231:SF3', NULL, NULL, NULL, NULL, 'RIBOSOME-ASSOCIATED INHIBITOR A', 245514),
(358070, 'PTHR33231', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN', 245514),
(358071, 'PTHR33231:SF1', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN', 245514),
(358072, 'PTHR13986:SF8', NULL, NULL, NULL, NULL, 'PROLYL 3-HYDROXYLASE 1-LIKE PROTEIN', 245515),
(358073, 'PTHR13986', NULL, NULL, NULL, NULL, 'PROTEIN LYSINE HYDROXYLATION COMPLEX COMPONENT', 245515),
(358074, 'PTHR13986:SF3', NULL, NULL, NULL, NULL, 'CARTILAGE-ASSOCIATED PROTEIN', 245515),
(358075, 'PTHR13986:SF4', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM PROTEIN SC65', 245515),
(358076, 'PTHR47926', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 245516),
(358077, 'PTHR47926:SF339', NULL, NULL, NULL, NULL, 'UMP-CMP KINASE', 245516),
(358078, 'PTHR32430:SF1', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE III DOMAIN-CONTAINING PROTEIN 8', 245517),
(358079, 'PTHR32430', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE III DOMAIN-CONTAINING PROTEIN 8', 245517),
(358080, 'PTHR31129:SF2', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN HORMONE ALPHA-2', 245518),
(358081, 'PTHR31129', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN HORMONE ALPHA-2', 245518),
(358082, 'PTHR14286', NULL, NULL, NULL, NULL, 'GENE, 49355-RELATED', 245519),
(358083, 'PTHR14286:SF2', NULL, NULL, NULL, NULL, 'RGD1306063 PROTEIN', 245519),
(358084, 'PTHR33879:SF9', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 245520);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(358085, 'PTHR33879', NULL, NULL, NULL, NULL, '17.6 KDA CLASS II HEAT SHOCK PROTEIN-RELATED', 245520),
(358086, 'PTHR33879:SF15', NULL, NULL, NULL, NULL, '', 245520),
(358087, 'PTHR33879:SF14', NULL, NULL, NULL, NULL, 'SHOCK 22 KDA PROTEIN, PUTATIVE-RELATED', 245520),
(358088, 'PTHR33879:SF17', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245520),
(358089, 'PTHR33879:SF3', NULL, NULL, NULL, NULL, '17.6 KDA CLASS II HEAT SHOCK PROTEIN-RELATED', 245520),
(358090, 'PTHR33879:SF16', NULL, NULL, NULL, NULL, '', 245520),
(358091, 'PTHR33879:SF11', NULL, NULL, NULL, NULL, '', 245520),
(358092, 'PTHR33879:SF10', NULL, NULL, NULL, NULL, 'BNAA01G24640D PROTEIN', 245520),
(358093, 'PTHR33879:SF12', NULL, NULL, NULL, NULL, '', 245520),
(358094, 'PTHR47374:SF6', NULL, NULL, NULL, NULL, 'OS01G0375100 PROTEIN', 245521),
(358095, 'PTHR47374', NULL, NULL, NULL, NULL, 'ENDOSOME ANTIGEN-LIKE PROTEIN, PUTATIVE (DUF3444)-RELATED', 245521),
(358096, 'PTHR47374:SF9', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 245521),
(358097, 'PTHR47374:SF2', NULL, NULL, NULL, NULL, 'OS01G0927400 PROTEIN', 245521),
(358098, 'PTHR47374:SF5', NULL, NULL, NULL, NULL, 'ENDOSOME ANTIGEN-LIKE PROTEIN, PUTATIVE (DUF3444)-RELATED', 245521),
(358099, 'PTHR32046:SF6', NULL, NULL, NULL, NULL, 'G DOMAIN-CONTAINING PROTEIN', 245522),
(358100, 'PTHR32046:SF13', NULL, NULL, NULL, NULL, 'G DOMAIN-CONTAINING PROTEIN', 245522),
(358101, 'PTHR32046:SF11', NULL, NULL, NULL, NULL, 'G DOMAIN-CONTAINING PROTEIN', 245522),
(358102, 'PTHR32046:SF12', NULL, NULL, NULL, NULL, 'AIG1-TYPE G DOMAIN-CONTAINING PROTEIN', 245522),
(358103, 'PTHR32046', NULL, NULL, NULL, NULL, 'G DOMAIN-CONTAINING PROTEIN', 245522),
(358104, 'PTHR22840:SF12', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 36', 245523),
(358105, 'PTHR22840', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 36', 245523),
(358106, 'PTHR46677:SF1', NULL, NULL, NULL, NULL, 'SMC5-SMC6 COMPLEX LOCALIZATION FACTOR PROTEIN 1', 245524),
(358107, 'PTHR46677', NULL, NULL, NULL, NULL, 'SMC5-SMC6 COMPLEX LOCALIZATION FACTOR PROTEIN 1', 245524),
(358108, 'PTHR10488:SF1', NULL, NULL, NULL, NULL, 'GLYCINE AMIDINOTRANSFERASE, MITOCHONDRIAL', 245525),
(358109, 'PTHR10488', NULL, NULL, NULL, NULL, 'GLYCINE AMIDINOTRANSFERASE, MITOCHONDRIAL', 245525),
(358110, 'PTHR11359:SF5', NULL, NULL, NULL, NULL, 'MONOPHOSPHATE DEAMINASE, PUTATIVE-RELATED', 245526),
(358111, 'PTHR11359:SF4', NULL, NULL, NULL, NULL, 'AMP DEAMINASE', 245526),
(358112, 'PTHR11359:SF7', NULL, NULL, NULL, NULL, 'INACTIVE DEAMINASE YBR284W-RELATED', 245526),
(358113, 'PTHR11359:SF15', NULL, NULL, NULL, NULL, 'AMP DEAMINASE', 245526),
(358114, 'PTHR11359:SF6', NULL, NULL, NULL, NULL, 'DEAMINASE, PUTATIVE-RELATED', 245526),
(358115, 'PTHR11359:SF14', NULL, NULL, NULL, NULL, 'AMP DEAMINASE', 245526),
(358116, 'PTHR11359:SF12', NULL, NULL, NULL, NULL, 'AMP DEAMINASE', 245526),
(358117, 'PTHR11359:SF10', NULL, NULL, NULL, NULL, 'AMP DEAMINASE-RELATED', 245526),
(358118, 'PTHR11359', NULL, NULL, NULL, NULL, 'AMP DEAMINASE', 245526),
(358119, 'PTHR11359:SF1', NULL, NULL, NULL, NULL, 'AMP DEAMINASE 1', 245526),
(358120, 'PTHR11359:SF0', NULL, NULL, NULL, NULL, 'AMP DEAMINASE', 245526),
(358121, 'PTHR11359:SF3', NULL, NULL, NULL, NULL, 'AMP DEAMINASE 2', 245526),
(358122, 'PTHR11359:SF2', NULL, NULL, NULL, NULL, 'AMP DEAMINASE 3', 245526),
(358123, 'PTHR12452:SF6', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN 17', 245527),
(358124, 'PTHR12452:SF0', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN 17', 245527),
(358125, 'PTHR12452', NULL, NULL, NULL, NULL, '42-9-9 PROTEIN-RELATED', 245527),
(358126, 'PTHR38618', NULL, NULL, NULL, NULL, 'PROTEIN CBG21701-RELATED', 245528),
(358127, 'PTHR38618:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG21701', 245528),
(358128, 'PTHR38618:SF1', NULL, NULL, NULL, NULL, 'MEIOSIS-TO-MITOSIS TRANSITION ASSOCIATED', 245528),
(358129, 'PTHR28643:SF1', NULL, NULL, NULL, NULL, 'SWI5-DEPENDENT RECOMBINATION DNA REPAIR PROTEIN 1 HOMOLOG', 245529),
(358130, 'PTHR28643', NULL, NULL, NULL, NULL, 'SWI5-DEPENDENT RECOMBINATION DNA REPAIR PROTEIN 1 HOMOLOG', 245529);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(358131, 'PTHR14218:SF19', NULL, NULL, NULL, NULL, 'SERINE PROTEASE AORO, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G10250)-RELATED', 245530),
(358132, 'PTHR14218:SF7', NULL, NULL, NULL, NULL, 'DIPEPTIDYL AMINOPEPTIDASE', 245530),
(358133, 'PTHR14218:SF15', NULL, NULL, NULL, NULL, 'TRIPEPTIDYL-PEPTIDASE 1', 245530),
(358134, 'PTHR14218:SF14', NULL, NULL, NULL, NULL, 'TRIPEPTIDYL-PEPTIDASE 1', 245530),
(358135, 'PTHR14218:SF39', NULL, NULL, NULL, NULL, 'PEPTIDASE S53 DOMAIN-CONTAINING PROTEIN', 245530),
(358136, 'PTHR14218:SF38', NULL, NULL, NULL, NULL, 'PEPTIDASE S53 DOMAIN-CONTAINING PROTEIN', 245530),
(358137, 'PTHR14218:SF10', NULL, NULL, NULL, NULL, 'PEPTIDASE S53 DOMAIN-CONTAINING PROTEIN', 245530),
(358138, 'PTHR14218:SF32', NULL, NULL, NULL, NULL, 'TRIPEPTIDYL PEPTIDASE SED3 (AFU_ORTHOLOGUE AFUA_3G08930)', 245530),
(358139, 'PTHR14218:SF35', NULL, NULL, NULL, NULL, 'PEPTIDASE S53 DOMAIN-CONTAINING PROTEIN', 245530),
(358140, 'PTHR14218:SF34', NULL, NULL, NULL, NULL, 'TRIPEPTIDYL-PEPTIDASE SED4', 245530),
(358141, 'PTHR14218:SF40', NULL, NULL, NULL, NULL, 'PEPTIDASE S53 DOMAIN-CONTAINING PROTEIN', 245530),
(358142, 'PTHR14218:SF31', NULL, NULL, NULL, NULL, 'PEPTIDASE S53 DOMAIN-CONTAINING PROTEIN', 245530),
(358143, 'PTHR14218', NULL, NULL, NULL, NULL, 'PROTEASE S8 TRIPEPTIDYL PEPTIDASE I  CLN2', 245530),
(358144, 'PTHR46498:SF1', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN 8', 245531),
(358145, 'PTHR46498', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN 8', 245531),
(358146, 'PTHR35334:SF3', NULL, NULL, NULL, NULL, 'INNER MEMBRANE TRANSPORT PROTEIN YQEG', 245532),
(358147, 'PTHR35334:SF4', NULL, NULL, NULL, NULL, 'SERINE TRANSPORTER-RELATED', 245532),
(358148, 'PTHR35334:SF1', NULL, NULL, NULL, NULL, 'THREONINE/SERINE TRANSPORTER TDCC', 245532),
(358149, 'PTHR35334:SF2', NULL, NULL, NULL, NULL, 'SERINE TRANSPORTER', 245532),
(358150, 'PTHR35334:SF5', NULL, NULL, NULL, NULL, 'INNER MEMBRANE TRANSPORT PROTEIN YHJV', 245532),
(358151, 'PTHR35334', NULL, NULL, NULL, NULL, 'SERINE TRANSPORTER', 245532),
(358152, 'PTHR21113:SF4', NULL, NULL, NULL, NULL, 'CHITIN-BINDING TYPE-4 DOMAIN-CONTAINING PROTEIN', 245533),
(358153, 'PTHR21113:SF6', NULL, NULL, NULL, NULL, 'CHITIN-BINDING TYPE-4 DOMAIN-CONTAINING PROTEIN', 245533),
(358154, 'PTHR21113:SF14', NULL, NULL, NULL, NULL, 'LP24064P', 245533),
(358155, 'PTHR21113', NULL, NULL, NULL, NULL, 'AGAP001705-PA', 245533),
(358156, 'PTHR47278:SF1', NULL, NULL, NULL, NULL, 'GLUTATHIONE HYDROLASE 6', 245534),
(358157, 'PTHR47278', NULL, NULL, NULL, NULL, 'GLUTATHIONE HYDROLASE 6', 245534),
(358158, 'PTHR38104:SF1', NULL, NULL, NULL, NULL, 'ANTI-SIGMA-E FACTOR RSEA', 245535),
(358159, 'PTHR38104', NULL, NULL, NULL, NULL, '', 245535),
(358160, 'PTHR47072', NULL, NULL, NULL, NULL, '', 245536),
(358161, 'PTHR47072:SF1', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 245536),
(358162, 'PTHR47072:SF4', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 245536),
(358163, 'PTHR47072:SF6', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 245536),
(358164, 'PTHR47072:SF5', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 245536),
(358165, 'PTHR45675:SF47', NULL, NULL, NULL, NULL, 'BNAA01G32800D PROTEIN', 245537),
(358166, 'PTHR45675:SF88', NULL, NULL, NULL, NULL, 'MYB-LIKE DNA-BINDING DOMAIN PROTEIN', 245537),
(358167, 'PTHR45675:SF44', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB24', 245537),
(358168, 'PTHR45675:SF45', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB108', 245537),
(358169, 'PTHR45675:SF49', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 245537),
(358170, 'PTHR45675:SF82', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 245537),
(358171, 'PTHR45675:SF80', NULL, NULL, NULL, NULL, 'ABA-INDUCED MYB TRANSCRIPTION FACTOR', 245537),
(358172, 'PTHR45675:SF86', NULL, NULL, NULL, NULL, 'MYB DOMAIN PROTEIN 62-RELATED', 245537),
(358173, 'PTHR45675:SF84', NULL, NULL, NULL, NULL, 'OS04G0508500 PROTEIN', 245537),
(358174, 'PTHR45675:SF116', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN', 245537);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(358175, 'PTHR45675:SF117', NULL, NULL, NULL, NULL, 'SANT DOMAIN-CONTAINING PROTEIN', 245537),
(358176, 'PTHR45675:SF114', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB48-LIKE', 245537),
(358177, 'PTHR45675:SF115', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE, MYB-LIKE DOMAIN PROTEIN-RELATED', 245537),
(358178, 'PTHR45675:SF112', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB21', 245537),
(358179, 'PTHR45675:SF113', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 245537),
(358180, 'PTHR45675:SF110', NULL, NULL, NULL, NULL, 'ABA-INDUCED MYB TRANSCRIPTION FACTOR', 245537),
(358181, 'PTHR45675:SF111', NULL, NULL, NULL, NULL, 'MYB DOMAIN PROTEIN 78-RELATED', 245537),
(358182, 'PTHR45675:SF56', NULL, NULL, NULL, NULL, 'BNAC02G46060D PROTEIN', 245537),
(358183, 'PTHR45675:SF12', NULL, NULL, NULL, NULL, 'MYB-LIKE DNA-BINDING DOMAIN CONTAINING PROTEIN', 245537),
(358184, 'PTHR45675:SF17', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 245537),
(358185, 'PTHR45675:SF118', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 245537),
(358186, 'PTHR45675:SF59', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB48-LIKE', 245537),
(358187, 'PTHR45675:SF119', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 245537),
(358188, 'PTHR45675:SF93', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB59', 245537),
(358189, 'PTHR45675:SF50', NULL, NULL, NULL, NULL, 'MYB DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 245537),
(358190, 'PTHR45675:SF92', NULL, NULL, NULL, NULL, 'MYB305 PROTEIN V1', 245537),
(358191, 'PTHR45675:SF97', NULL, NULL, NULL, NULL, 'MYB DOMAIN PROTEIN 79', 245537),
(358192, 'PTHR45675:SF98', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 245537),
(358193, 'PTHR45675:SF95', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 245537),
(358194, 'PTHR45675:SF96', NULL, NULL, NULL, NULL, 'MYB DOMAIN PROTEIN 116', 245537),
(358195, 'PTHR45675:SF105', NULL, NULL, NULL, NULL, '', 245537),
(358196, 'PTHR45675:SF106', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN MYBAS2', 245537),
(358197, 'PTHR45675:SF104', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 245537),
(358198, 'PTHR45675', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR-RELATED-RELATED', 245537),
(358199, 'PTHR45675:SF69', NULL, NULL, NULL, NULL, 'BNAA10G12770D PROTEIN', 245537),
(358200, 'PTHR45675:SF22', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB48-LIKE', 245537),
(358201, 'PTHR45675:SF67', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB57', 245537),
(358202, 'PTHR45675:SF23', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB108-LIKE', 245537),
(358203, 'PTHR45675:SF109', NULL, NULL, NULL, NULL, 'BNAA09G02730D PROTEIN', 245537),
(358204, 'PTHR45675:SF107', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB2', 245537),
(358205, 'PTHR45675:SF108', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB24-LIKE', 245537),
(358206, 'PTHR45675:SF27', NULL, NULL, NULL, NULL, '', 245537),
(358207, 'PTHR45675:SF61', NULL, NULL, NULL, NULL, 'BNAC07G24710D PROTEIN', 245537),
(358208, 'PTHR45675:SF3', NULL, NULL, NULL, NULL, 'OS02G0618400 PROTEIN', 245537),
(358209, 'PTHR45675:SF2', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN MYBAS1', 245537),
(358210, 'PTHR45675:SF1', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR-RELATED', 245537),
(358211, 'PTHR45675:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB48', 245537),
(358212, 'PTHR45675:SF6', NULL, NULL, NULL, NULL, 'OS01G0298400 PROTEIN', 245537),
(358213, 'PTHR45675:SF38', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR JAMYB', 245537),
(358214, 'PTHR45675:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB27', 245537),
(358215, 'PTHR45675:SF31', NULL, NULL, NULL, NULL, 'ATMYB2', 245537),
(358216, 'PTHR45675:SF73', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 245537),
(358217, 'PTHR45675:SF74', NULL, NULL, NULL, NULL, 'BNAANNG32620D PROTEIN', 245537),
(358218, 'PTHR45675:SF30', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB62', 245537),
(358219, 'PTHR33596:SF19', NULL, NULL, NULL, NULL, 'BNAA07G03740D PROTEIN', 245538);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(358220, 'PTHR33596:SF17', NULL, NULL, NULL, NULL, 'COLD-REGULATED 413 INNER MEMBRANE PROTEIN 1, CHLOROPLASTIC-RELATED', 245538),
(358221, 'PTHR33596:SF14', NULL, NULL, NULL, NULL, '', 245538),
(358222, 'PTHR33596:SF13', NULL, NULL, NULL, NULL, 'COLD-REGULATED 413 PLASMA MEMBRANE PROTEIN 4', 245538),
(358223, 'PTHR33596:SF23', NULL, NULL, NULL, NULL, 'COLD-REGULATED 413 PLASMA MEMBRANE PROTEIN 2', 245538),
(358224, 'PTHR33596:SF1', NULL, NULL, NULL, NULL, 'COLD-REGULATED 413 PLASMA MEMBRANE PROTEIN 1-RELATED', 245538),
(358225, 'PTHR33596:SF4', NULL, NULL, NULL, NULL, 'COLD-REGULATED 413 PLASMA MEMBRANE PROTEIN 4-LIKE', 245538),
(358226, 'PTHR33596', NULL, NULL, NULL, NULL, 'COLD-REGULATED 413 PLASMA MEMBRANE PROTEIN 2', 245538),
(358227, 'PTHR33596:SF21', NULL, NULL, NULL, NULL, '', 245538),
(358228, 'PTHR38849', NULL, NULL, NULL, NULL, '', 245539),
(358229, 'PTHR38849:SF1', NULL, NULL, NULL, NULL, '', 245539),
(358230, 'PTHR47685:SF1', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORT PROTEIN CORA', 245540),
(358231, 'PTHR47685', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORT PROTEIN CORA', 245540),
(358232, 'PTHR39338:SF7', NULL, NULL, NULL, NULL, 'BLL6692 PROTEIN', 245541),
(358233, 'PTHR39338:SF6', NULL, NULL, NULL, NULL, 'BLL5662 PROTEIN', 245541),
(358234, 'PTHR39338:SF5', NULL, NULL, NULL, NULL, 'BLR6139 PROTEIN', 245541),
(358235, 'PTHR39338', NULL, NULL, NULL, NULL, 'BLL5662 PROTEIN-RELATED', 245541),
(358236, 'PTHR14319:SF8', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 245542),
(358237, 'PTHR14319:SF7', NULL, NULL, NULL, NULL, 'POST-GPI ATTACHMENT TO PROTEINS FACTOR 6', 245542),
(358238, 'PTHR14319', NULL, NULL, NULL, NULL, 'FIVE-SPAN TRANSMEMBRANE PROTEIN M83', 245542),
(358239, 'PTHR14319:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN-LIKE PROTEIN', 245542),
(358240, 'PTHR14319:SF6', NULL, NULL, NULL, NULL, 'SI:DKEY-84J12.1', 245542),
(358241, 'PTHR46976:SF2', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 245543),
(358242, 'PTHR46976', NULL, NULL, NULL, NULL, 'PROTEIN ARABIDILLO 1', 245543),
(358243, 'PTHR46976:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ARABIDILLO 1-RELATED', 245543),
(358244, 'PTHR46976:SF4', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 245543),
(358245, 'PTHR46976:SF3', NULL, NULL, NULL, NULL, 'BNAC04G55090D PROTEIN', 245543),
(358246, 'PTHR46976:SF5', NULL, NULL, NULL, NULL, 'BNAA09G38440D PROTEIN', 245543),
(358247, 'PTHR37001:SF9', NULL, NULL, NULL, NULL, '', 245544),
(358248, 'PTHR37001:SF8', NULL, NULL, NULL, NULL, 'YALI0F10901P', 245544),
(358249, 'PTHR37001', NULL, NULL, NULL, NULL, 'PHOSPHORYN, PUTATIVE-RELATED-RELATED', 245544),
(358250, 'PTHR37001:SF11', NULL, NULL, NULL, NULL, 'PROTEIN CBG18509', 245544),
(358251, 'PTHR37001:SF5', NULL, NULL, NULL, NULL, 'PHOSPHORYN, PUTATIVE-RELATED', 245544),
(358252, 'PTHR37001:SF10', NULL, NULL, NULL, NULL, '', 245544),
(358253, 'PTHR43876:SF17', NULL, NULL, NULL, NULL, 'NEOXANTHIN SYNTHASE, CHLOROPLASTIC', 245545),
(358254, 'PTHR43876', NULL, NULL, NULL, NULL, 'UBIQUINONE BIOSYNTHESIS MONOOXYGENASE COQ6, MITOCHONDRIAL', 245545),
(358255, 'PTHR43876:SF18', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_3G09540)-RELATED', 245545),
(358256, 'PTHR43876:SF3', NULL, NULL, NULL, NULL, 'TRIHYDROXYTOLUENE OXYGENASE (AFU_ORTHOLOGUE AFUA_8G02470)', 245545),
(358257, 'PTHR43876:SF9', NULL, NULL, NULL, NULL, 'MONOOXYGENASE, PUTATIVE-RELATED', 245545),
(358258, 'PTHR43876:SF8', NULL, NULL, NULL, NULL, '2-OCTAPRENYL-6-METHOXYPHENOL HYDROXYLASE', 245545),
(358259, 'PTHR43876:SF7', NULL, NULL, NULL, NULL, 'UBIQUINONE BIOSYNTHESIS MONOOXYGENASE COQ6, MITOCHONDRIAL', 245545),
(358260, 'PTHR43876:SF10', NULL, NULL, NULL, NULL, '3-DEMETHOXYUBIQUINOL 3-HYDROXYLASE', 245545),
(358261, 'PTHR43876:SF11', NULL, NULL, NULL, NULL, 'GLYOXALASE', 245545),
(358262, 'PTHR43876:SF23', NULL, NULL, NULL, NULL, 'UBIQUINONE BIOSYNTHESIS MONOOXYGENASE COQ6, MITOCHONDRIAL', 245545),
(358263, 'PTHR43876:SF24', NULL, NULL, NULL, NULL, 'LYCOPENE BETA CYCLASE, CHLOROPLASTIC', 245545),
(358264, 'PTHR43876:SF15', NULL, NULL, NULL, NULL, 'LYCOPENE BETA CYCLASE, CHLOROPLASTIC', 245545);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(358265, 'PTHR10206:SF0', NULL, NULL, NULL, NULL, 'CATHELICIDIN-1-RELATED', 245546),
(358266, 'PTHR10206', NULL, NULL, NULL, NULL, 'CATHELICIDIN', 245546),
(358267, 'PTHR10206:SF4', NULL, NULL, NULL, NULL, 'NEUTROPHILIC GRANULE PROTEIN', 245546),
(358268, 'PTHR10206:SF2', NULL, NULL, NULL, NULL, 'CATHELICIDIN ANTIMICROBIAL PEPTIDE', 245546),
(358269, 'PTHR46070', NULL, NULL, NULL, NULL, 'PINSTRIPE, ISOFORM A', 245547),
(358270, 'PTHR46070:SF1', NULL, NULL, NULL, NULL, 'PINSTRIPE, ISOFORM A', 245547),
(358271, 'PTHR46070:SF2', NULL, NULL, NULL, NULL, 'DENN DOMAIN-CONTAINING PROTEIN 5A', 245547),
(358272, 'PTHR46070:SF3', NULL, NULL, NULL, NULL, 'DENN DOMAIN-CONTAINING PROTEIN 5B', 245547),
(358273, 'PTHR19248', NULL, NULL, NULL, NULL, 'ATP-BINDING TRANSPORT PROTEIN-RELATED', 245548),
(358274, 'PTHR19248:SF29', NULL, NULL, NULL, NULL, 'BNACNNG24480D PROTEIN', 245548),
(358275, 'PTHR19248:SF18', NULL, NULL, NULL, NULL, 'OS02G0282900 PROTEIN', 245548),
(358276, 'PTHR19248:SF16', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY E MEMBER 1', 245548),
(358277, 'PTHR19248:SF28', NULL, NULL, NULL, NULL, '', 245548),
(358278, 'PTHR19248:SF26', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 245548),
(358279, 'PTHR19248:SF23', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER E FAMILY MEMBER 1', 245548),
(358280, 'PTHR19248:SF24', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 245548),
(358281, 'PTHR19248:SF30', NULL, NULL, NULL, NULL, 'OS05G0157300 PROTEIN', 245548),
(358282, 'PTHR12964:SF0', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX SUBUNIT 6', 245549),
(358283, 'PTHR12964:SF3', NULL, NULL, NULL, NULL, 'BNAA05G26780D PROTEIN', 245549),
(358284, 'PTHR12964', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE B14 SUBUNIT', 245549),
(358285, 'PTHR12964:SF7', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX SUBUNIT 6', 245549),
(358286, 'PTHR12964:SF5', NULL, NULL, NULL, NULL, 'NADH UBIQUINONE OXIDOREDUCTASE B14 SUBUNIT', 245549),
(358287, 'PTHR12964:SF6', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX SUBUNIT 6', 245549),
(358288, 'PTHR46705', NULL, NULL, NULL, NULL, 'PROTEIN CBG09805', 245550),
(358289, 'PTHR46705:SF14', NULL, NULL, NULL, NULL, 'DB DOMAIN-CONTAINING PROTEIN', 245550),
(358290, 'PTHR46705:SF1', NULL, NULL, NULL, NULL, 'DB DOMAIN-CONTAINING PROTEIN', 245550),
(358291, 'PTHR46705:SF15', NULL, NULL, NULL, NULL, 'DB DOMAIN-CONTAINING PROTEIN', 245550),
(358292, 'PTHR46705:SF2', NULL, NULL, NULL, NULL, 'DB DOMAIN-CONTAINING PROTEIN', 245550),
(358293, 'PTHR46705:SF3', NULL, NULL, NULL, NULL, 'DB DOMAIN-CONTAINING PROTEIN', 245550),
(358294, 'PTHR46705:SF4', NULL, NULL, NULL, NULL, 'DB DOMAIN-CONTAINING PROTEIN', 245550),
(358295, 'PTHR46705:SF10', NULL, NULL, NULL, NULL, 'DB DOMAIN-CONTAINING PROTEIN', 245550),
(358296, 'PTHR46705:SF5', NULL, NULL, NULL, NULL, 'DB DOMAIN-CONTAINING PROTEIN', 245550),
(358297, 'PTHR46705:SF11', NULL, NULL, NULL, NULL, 'DB DOMAIN-CONTAINING PROTEIN', 245550),
(358298, 'PTHR46705:SF6', NULL, NULL, NULL, NULL, 'DB DOMAIN-CONTAINING PROTEIN', 245550),
(358299, 'PTHR46705:SF12', NULL, NULL, NULL, NULL, 'DB DOMAIN-CONTAINING PROTEIN', 245550),
(358300, 'PTHR46705:SF13', NULL, NULL, NULL, NULL, 'DB DOMAIN-CONTAINING PROTEIN', 245550),
(358301, 'PTHR46705:SF9', NULL, NULL, NULL, NULL, 'DB DOMAIN-CONTAINING PROTEIN', 245550),
(358302, 'PTHR23509', NULL, NULL, NULL, NULL, 'PA-PL1 PHOSPHOLIPASE FAMILY', 245551),
(358303, 'PTHR23509:SF46', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SAM DOMAIN-CONTAINING PROTEIN 6-LIKE ISOFORM X1', 245551),
(358304, 'PTHR23509:SF47', NULL, NULL, NULL, NULL, 'SAM DOMAIN-CONTAINING PROTEIN', 245551),
(358305, 'PTHR23509:SF4', NULL, NULL, NULL, NULL, 'SEC23-INTERACTING PROTEIN', 245551),
(358306, 'PTHR23509:SF6', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE C1020.13C-RELATED', 245551),
(358307, 'PTHR23509:SF32', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE DDHD1', 245551),
(358308, 'PTHR23509:SF10', NULL, NULL, NULL, NULL, 'INTRACELLULAR PHOSPHOLIPASE A1', 245551);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(358309, 'PTHR23509:SF7', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE DDHD2', 245551),
(358310, 'PTHR23509:SF8', NULL, NULL, NULL, NULL, 'DDHD DOMAIN-CONTAINING PROTEIN', 245551),
(358311, 'PTHR23509:SF22', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED PHOSPHATIDYLINOSITOL TRANSFER PROTEIN 3', 245551),
(358312, 'PTHR23509:SF34', NULL, NULL, NULL, NULL, 'DDHD DOMAIN-CONTAINING PROTEIN', 245551),
(358313, 'PTHR23509:SF45', NULL, NULL, NULL, NULL, 'LD21067P', 245551),
(358314, 'PTHR23509:SF40', NULL, NULL, NULL, NULL, 'SAM DOMAIN-CONTAINING PROTEIN', 245551),
(358315, 'PTHR10631:SF3', NULL, NULL, NULL, NULL, 'TRNA (GUANINE(26)-N(2))-DIMETHYLTRANSFERASE', 245552),
(358316, 'PTHR10631:SF5', NULL, NULL, NULL, NULL, 'TRNA (GUANINE(26)-N(2))-DIMETHYLTRANSFERASE', 245552),
(358317, 'PTHR10631:SF1', NULL, NULL, NULL, NULL, 'TRMT1-LIKE PROTEIN', 245552),
(358318, 'PTHR10631', NULL, NULL, NULL, NULL, 'N 2 ,N 2 -DIMETHYLGUANOSINE TRNA METHYLTRANSFERASE', 245552),
(358319, 'PTHR10631:SF12', NULL, NULL, NULL, NULL, 'TRNA (GUANINE(26)-N(2))-DIMETHYLTRANSFERASE 1-RELATED', 245552),
(358320, 'PTHR10631:SF9', NULL, NULL, NULL, NULL, 'TRNA (GUANINE(26)-N(2))-DIMETHYLTRANSFERASE', 245552),
(358321, 'PTHR37248:SF1', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR', 245553),
(358322, 'PTHR37248', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR', 245553),
(358323, 'PTHR47208', NULL, NULL, NULL, NULL, 'OS02G0174800 PROTEIN', 245554),
(358324, 'PTHR47208:SF1', NULL, NULL, NULL, NULL, 'OS02G0174800 PROTEIN', 245554),
(358325, 'PTHR47208:SF10', NULL, NULL, NULL, NULL, 'FLZ-TYPE DOMAIN-CONTAINING PROTEIN', 245554),
(358326, 'PTHR47208:SF3', NULL, NULL, NULL, NULL, 'FCS-LIKE ZINC FINGER 14', 245554),
(358327, 'PTHR47208:SF13', NULL, NULL, NULL, NULL, 'FLZ-TYPE DOMAIN-CONTAINING PROTEIN', 245554),
(358328, 'PTHR47208:SF16', NULL, NULL, NULL, NULL, 'FLZ-TYPE DOMAIN-CONTAINING PROTEIN', 245554),
(358329, 'PTHR47208:SF8', NULL, NULL, NULL, NULL, 'DUF581 FAMILY PROTEIN', 245554),
(358330, 'PTHR47208:SF15', NULL, NULL, NULL, NULL, 'FLZ-TYPE DOMAIN-CONTAINING PROTEIN', 245554),
(358331, 'PTHR47208:SF5', NULL, NULL, NULL, NULL, 'FCS-LIKE ZINC FINGER 12-RELATED', 245554),
(358332, 'PTHR11635:SF154', NULL, NULL, NULL, NULL, '', 245555),
(358333, 'PTHR11635:SF165', NULL, NULL, NULL, NULL, 'CAMP/CGMP-DEPENDENT 3'',5''-CAMP/CGMP PHOSPHODIESTERASE B', 245555),
(358334, 'PTHR11635:SF164', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-BINDING PROTEIN, PUTATIVE-RELATED', 245555),
(358335, 'PTHR11635:SF153', NULL, NULL, NULL, NULL, 'CAMP-DEPENDENT PROTEIN KINASE TYPE II-ALPHA REGULATORY SUBUNIT', 245555),
(358336, 'PTHR11635:SF156', NULL, NULL, NULL, NULL, 'CAMP-DEPENDENT PROTEIN KINASE TYPE II-BETA REGULATORY SUBUNIT', 245555),
(358337, 'PTHR11635:SF166', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 245555),
(358338, 'PTHR11635:SF152', NULL, NULL, NULL, NULL, 'CAMP-DEPENDENT PROTEIN KINASE TYPE I REGULATORY SUBUNIT-RELATED', 245555),
(358339, 'PTHR11635', NULL, NULL, NULL, NULL, 'CAMP-DEPENDENT PROTEIN KINASE REGULATORY CHAIN', 245555),
(358340, 'PTHR11635:SF129', NULL, NULL, NULL, NULL, 'CAMP-DEPENDENT PROTEIN KINASE TYPE I-ALPHA REGULATORY SUBUNIT', 245555),
(358341, 'PTHR11635:SF126', NULL, NULL, NULL, NULL, 'CAMP-DEPENDENT PROTEIN KINASE TYPE I-BETA REGULATORY SUBUNIT', 245555),
(358342, 'PTHR43710', NULL, NULL, NULL, NULL, '2-HYDROXYACYL-COA LYASE', 245556),
(358343, 'PTHR43710:SF2', NULL, NULL, NULL, NULL, '2-HYDROXYACYL-COA LYASE 1', 245556),
(358344, 'PTHR43710:SF1', NULL, NULL, NULL, NULL, '', 245556),
(358345, 'PTHR43710:SF7', NULL, NULL, NULL, NULL, 'INDOLEPYRUVATE OXIDOREDUCTASE SUBUNIT IORA', 245556),
(358346, 'PTHR43710:SF6', NULL, NULL, NULL, NULL, 'INDOLEPYRUVATE OXIDOREDUCTASE SUBUNIT IORA', 245556),
(358347, 'PTHR43710:SF5', NULL, NULL, NULL, NULL, 'INDOLEPYRUVATE FERREDOXIN OXIDOREDUCTASE ALPHA SUBUNIT', 245556),
(358348, 'PTHR22911:SF132', NULL, NULL, NULL, NULL, 'CYSTINE TRANSPORTER YIJE-RELATED', 245557),
(358349, 'PTHR22911:SF110', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 35 MEMBER G3-RELATED', 245557);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(358350, 'PTHR22911:SF79', NULL, NULL, NULL, NULL, 'EAMA DOMAIN-CONTAINING PROTEIN', 245557),
(358351, 'PTHR22911', NULL, NULL, NULL, NULL, 'ACYL-MALONYL CONDENSING ENZYME-RELATED', 245557),
(358352, 'PTHR22911:SF133', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 245557),
(358353, 'PTHR22911:SF37', NULL, NULL, NULL, NULL, 'THREONINE/HOMOSERINE EXPORTER RHTA', 245557),
(358354, 'PTHR22911:SF130', NULL, NULL, NULL, NULL, 'BIOTIN TRANSPORTER', 245557),
(358355, 'PTHR22911:SF76', NULL, NULL, NULL, NULL, 'EAMA DOMAIN-CONTAINING PROTEIN', 245557),
(358356, 'PTHR22911:SF32', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 35 MEMBER G5-RELATED', 245557),
(358357, 'PTHR22911:SF6', NULL, NULL, NULL, NULL, 'RH69884P', 245557),
(358358, 'PTHR22911:SF129', NULL, NULL, NULL, NULL, 'PERMEASE, DRUG/METABOLITE TRANSPORTER (DMT) SUPERFAMILY', 245557),
(358359, 'PTHR22911:SF127', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 35 MEMBER G1', 245557),
(358360, 'PTHR22911:SF52', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 35 MEMBER G2', 245557),
(358361, 'PTHR22911:SF106', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN', 245557),
(358362, 'PTHR22911:SF136', NULL, NULL, NULL, NULL, 'PERMEASE OF THE DRUG/METABOLITE TRANSPORTER (DMT) SUPERFAMILY', 245557),
(358363, 'PTHR22911:SF103', NULL, NULL, NULL, NULL, 'BLR2811 PROTEIN', 245557),
(358364, 'PTHR22911:SF137', NULL, NULL, NULL, NULL, 'PROTEIN RARD', 245557),
(358365, 'PTHR22911:SF134', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 245557),
(358366, 'PTHR22911:SF102', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 245557),
(358367, 'PTHR22911:SF135', NULL, NULL, NULL, NULL, 'BLR4310 PROTEIN', 245557),
(358368, 'PTHR48138', NULL, NULL, NULL, NULL, 'KERATINOCYTE PROLINE-RICH PROTEIN-RELATED', 245558),
(358369, 'PTHR48138:SF2', NULL, NULL, NULL, NULL, 'KERATINOCYTE PROLINE-RICH PROTEIN', 245558),
(358370, 'PTHR38755', NULL, NULL, NULL, NULL, '5,10-METHYLENETETRAHYDROFOLATE REDUCTASE', 245559),
(358371, 'PTHR38755:SF1', NULL, NULL, NULL, NULL, 'MTHFR_C DOMAIN-CONTAINING PROTEIN', 245559),
(358372, 'PTHR15189:SF7', NULL, NULL, NULL, NULL, 'BRISC AND BRCA1-A COMPLEX MEMBER 2', 245560),
(358373, 'PTHR15189', NULL, NULL, NULL, NULL, 'BRISC AND BRCA1-A COMPLEX MEMBER 2', 245560),
(358374, 'PTHR43277:SF4', NULL, NULL, NULL, NULL, 'ARGININE DECARBOXYLASE', 245561),
(358375, 'PTHR43277:SF5', NULL, NULL, NULL, NULL, 'ARGININE DECARBOXYLASE-LIKE ISOFORM X1', 245561),
(358376, 'PTHR43277:SF3', NULL, NULL, NULL, NULL, 'DECARBOXYLASE, PUTATIVE-RELATED', 245561),
(358377, 'PTHR43277', NULL, NULL, NULL, NULL, 'ARGININE DECARBOXYLASE', 245561),
(358378, 'PTHR46459', NULL, NULL, NULL, NULL, 'E1A-BINDING PROTEIN P400-RELATED', 245562),
(358379, 'PTHR46459:SF1', NULL, NULL, NULL, NULL, 'E1A-BINDING PROTEIN P400', 245562),
(358380, 'PTHR28185', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL DISTRIBUTION AND MORPHOLOGY PROTEIN 34', 245563),
(358381, 'PTHR28185:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL DISTRIBUTION AND MORPHOLOGY PROTEIN 34', 245563),
(358382, 'PTHR34554:SF2', NULL, NULL, NULL, NULL, 'RGS1-HXK1-INTERACTING PROTEIN 1', 245564),
(358383, 'PTHR34554:SF1', NULL, NULL, NULL, NULL, 'ALANINE-TRNA LIGASE', 245564),
(358384, 'PTHR34554', NULL, NULL, NULL, NULL, 'RGS1-HXK1-INTERACTING PROTEIN 1', 245564),
(358385, 'PTHR22880:SF225', NULL, NULL, NULL, NULL, 'BROMODOMAIN-CONTAINING PROTEIN 3', 245565),
(358386, 'PTHR22880:SF238', NULL, NULL, NULL, NULL, 'BROMODOMAIN TESTIS-SPECIFIC PROTEIN', 245565),
(358387, 'PTHR22880:SF240', NULL, NULL, NULL, NULL, 'BROMODOMAIN-CONTAINING PROTEIN 2', 245565),
(358388, 'PTHR22880', NULL, NULL, NULL, NULL, 'FALZ-RELATED BROMODOMAIN-CONTAINING PROTEINS', 245565),
(358389, 'PTHR22880:SF244', NULL, NULL, NULL, NULL, 'BROMODOMAIN-CONTAINING PROTEIN BET-1', 245565),
(358390, 'PTHR22880:SF243', NULL, NULL, NULL, NULL, 'BET (TWO BROMODOMAINS) FAMILY PROTEIN', 245565),
(358391, 'PTHR22880:SF143', NULL, NULL, NULL, NULL, 'BROMODOMAIN-CONTAINING PROTEIN 4', 245565),
(358392, 'PTHR22880:SF242', NULL, NULL, NULL, NULL, 'BROMODOMAIN-CONTAINING PROTEIN C631.02', 245565);
INSERT INTO "PUBLIC"."MODEL" VALUES
(358393, 'PTHR22880:SF241', NULL, NULL, NULL, NULL, 'BROMO DOMAIN-CONTAINING PROTEIN', 245565),
(358394, 'PTHR22880:SF175', NULL, NULL, NULL, NULL, 'BROMODOMAIN TESTIS-SPECIFIC PROTEIN', 245565),
(358395, 'PTHR43314', NULL, NULL, NULL, NULL, '', 245566),
(358396, 'PTHR43314:SF20', NULL, NULL, NULL, NULL, 'FERREDOXIN--NADP REDUCTASE, CHLOROPLASTIC', 245566),
(358397, 'PTHR43314:SF30', NULL, NULL, NULL, NULL, 'FERREDOXIN--NADP REDUCTASE, EMBRYO ISOZYME, CHLOROPLASTIC', 245566),
(358398, 'PTHR43314:SF25', NULL, NULL, NULL, NULL, 'FERREDOXIN--NADP REDUCTASE, LEAF ISOZYME 2, CHLOROPLASTIC', 245566),
(358399, 'PTHR43314:SF29', NULL, NULL, NULL, NULL, 'FERREDOXIN--NADP REDUCTASE, CHLOROPLASTIC', 245566),
(358400, 'PTHR43314:SF28', NULL, NULL, NULL, NULL, 'FERREDOXIN--NADP REDUCTASE, ROOT ISOZYME 2, CHLOROPLASTIC', 245566),
(358401, 'PTHR43314:SF27', NULL, NULL, NULL, NULL, 'FERREDOXIN--NADP REDUCTASE, LEAF ISOZYME 1, CHLOROPLASTIC', 245566),
(358402, 'PTHR43314:SF26', NULL, NULL, NULL, NULL, 'FERREDOXIN--NADP REDUCTASE, LEAF ISOZYME 2, CHLOROPLASTIC', 245566),
(358403, 'PTHR43314:SF15', NULL, NULL, NULL, NULL, 'FERREDOXIN--NADP REDUCTASE, ROOT ISOZYME 1, CHLOROPLASTIC', 245566),
(358404, 'PTHR43314:SF19', NULL, NULL, NULL, NULL, 'FERREDOXIN--NADP REDUCTASE', 245566),
(358405, 'PTHR34844', NULL, NULL, NULL, NULL, '', 245567),
(358406, 'PTHR34844:SF2', NULL, NULL, NULL, NULL, '', 245567),
(358407, 'PTHR39339:SF1', NULL, NULL, NULL, NULL, 'CHAD DOMAIN-CONTAINING PROTEIN', 245568),
(358408, 'PTHR39339', NULL, NULL, NULL, NULL, 'SLR1444 PROTEIN', 245568),
(358409, 'PTHR16121', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 245569),
(358410, 'PTHR16121:SF2', NULL, NULL, NULL, NULL, 'CAP-SPECIFIC MRNA (NUCLEOSIDE-2''-O-)-METHYLTRANSFERASE 2', 245569),
(358411, 'PTHR16121:SF0', NULL, NULL, NULL, NULL, 'CAP-SPECIFIC MRNA (NUCLEOSIDE-2''-O-)-METHYLTRANSFERASE 1', 245569),
(358412, 'PTHR28575', NULL, NULL, NULL, NULL, 'MEIOSIS-SPECIFIC PROTEIN MEI4', 245570),
(358413, 'PTHR28575:SF1', NULL, NULL, NULL, NULL, 'MEIOSIS-SPECIFIC PROTEIN MEI4', 245570),
(358414, 'PTHR43745:SF2', NULL, NULL, NULL, NULL, 'NITROREDUCTASE MJ1384-RELATED', 245571),
(358415, 'PTHR43745', NULL, NULL, NULL, NULL, 'NITROREDUCTASE MJ1384-RELATED', 245571),
(358416, 'PTHR46544:SF1', NULL, NULL, NULL, NULL, 'EXTRACELLULAR MATRIX PROTEIN 2', 245572),
(358417, 'PTHR46544:SF3', NULL, NULL, NULL, NULL, 'YALI0F12705P', 245572),
(358418, 'PTHR46544:SF2', NULL, NULL, NULL, NULL, 'SI:DKEY-32E6.6-RELATED', 245572),
(358419, 'PTHR46544', NULL, NULL, NULL, NULL, 'EXTRACELLULAR MATRIX PROTEIN 2-RELATED', 245572),
(358420, 'PTHR21838:SF2', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 137', 245573),
(358421, 'PTHR21838', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 245573),
(358422, 'PTHR21461:SF2', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 245574),
(358423, 'PTHR21461:SF1', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 245574),
(358424, 'PTHR21461:SF16', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN RCOM_0530710', 245574),
(358425, 'PTHR21461', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 245574),
(358426, 'PTHR21461:SF19', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 245574),
(358427, 'PTHR21461:SF9', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 245574),
(358428, 'PTHR21461:SF8', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 245574),
(358429, 'PTHR21461:SF7', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 245574),
(358430, 'PTHR21461:SF52', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 245574),
(358431, 'PTHR21461:SF55', NULL, NULL, NULL, NULL, 'ZINC FINGER (C3HC4-TYPE RING FINGER) FAMILY PROTEIN', 245574),
(358432, 'PTHR21461:SF54', NULL, NULL, NULL, NULL, 'GALACTAN BETA-1,4-GALACTOSYLTRANSFERASE GALS3', 245574),
(358433, 'PTHR21461:SF76', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 245574),
(358434, 'PTHR21461:SF78', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 245574);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(358435, 'PTHR21461:SF12', NULL, NULL, NULL, NULL, 'GALACTAN BETA-1,4-GALACTOSYLTRANSFERASE GALS2', 245574),
(358436, 'PTHR21461:SF56', NULL, NULL, NULL, NULL, 'GALACTAN BETA-1,4-GALACTOSYLTRANSFERASE GALS1', 245574),
(358437, 'PTHR21461:SF59', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 245574),
(358438, 'PTHR21461:SF72', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 245574),
(358439, 'PTHR21461:SF86', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 245574),
(358440, 'PTHR21461:SF64', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 245574),
(358441, 'PTHR21461:SF85', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 245574),
(358442, 'PTHR21461:SF66', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 245574),
(358443, 'PTHR21461:SF88', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 245574),
(358444, 'PTHR21461:SF87', NULL, NULL, NULL, NULL, 'GH12965P', 245574),
(358445, 'PTHR21461:SF65', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 245574),
(358446, 'PTHR21461:SF68', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 245574),
(358447, 'PTHR21461:SF89', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 245574),
(358448, 'PTHR21461:SF45', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 245574),
(358449, 'PTHR21461:SF69', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 245574),
(358450, 'PTHR21461:SF80', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 245574),
(358451, 'PTHR21461:SF82', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 245574),
(358452, 'PTHR21461:SF60', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 245574),
(358453, 'PTHR21461:SF81', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 245574),
(358454, 'PTHR21461:SF84', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 245574),
(358455, 'PTHR21461:SF40', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 245574),
(358456, 'PTHR21461:SF62', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 245574),
(358457, 'PTHR21461:SF61', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 245574),
(358458, 'PTHR21461:SF83', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 245574),
(358459, 'PTHR46658', NULL, NULL, NULL, NULL, 'CYS OR MET METABOLISM PYRIDOXAL-PHOSPHATE-DEPENDENT ENZYME', 245575),
(358460, 'PTHR46658:SF1', NULL, NULL, NULL, NULL, 'CYS OR MET METABOLISM PYRIDOXAL-PHOSPHATE-DEPENDENT ENZYME', 245575),
(358461, 'PTHR13327:SF1', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 BETA SUBCOMPLEX SUBUNIT 11, MITOCHONDRIAL', 245576),
(358462, 'PTHR13327:SF2', NULL, NULL, NULL, NULL, 'COMPLEX I-ESSS', 245576),
(358463, 'PTHR13327', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE ESSS SUBUNIT, MITOCHONDRIAL PRECURSOR', 245576),
(358464, 'PTHR13327:SF0', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 BETA SUBCOMPLEX SUBUNIT 11, MITOCHONDRIAL', 245576),
(358465, 'PTHR31142:SF41', NULL, NULL, NULL, NULL, 'DUF1084 DOMAIN-CONTAINING PROTEIN', 245577),
(358466, 'PTHR31142:SF40', NULL, NULL, NULL, NULL, 'TOBAMOVIRUS MULTIPLICATION PROTEIN 3-RELATED', 245577),
(358467, 'PTHR31142:SF37', NULL, NULL, NULL, NULL, 'DUF1084 DOMAIN-CONTAINING PROTEIN', 245577),
(358468, 'PTHR31142:SF26', NULL, NULL, NULL, NULL, 'DUF1084 DOMAIN-CONTAINING PROTEIN', 245577),
(358469, 'PTHR31142:SF36', NULL, NULL, NULL, NULL, 'BNACNNG61220D PROTEIN', 245577),
(358470, 'PTHR31142:SF35', NULL, NULL, NULL, NULL, '', 245577),
(358471, 'PTHR31142:SF34', NULL, NULL, NULL, NULL, 'OS03G0565600 PROTEIN', 245577),
(358472, 'PTHR31142:SF22', NULL, NULL, NULL, NULL, 'DUF1084 DOMAIN-CONTAINING PROTEIN', 245577),
(358473, 'PTHR31142:SF33', NULL, NULL, NULL, NULL, 'DUF1084 DOMAIN-CONTAINING PROTEIN', 245577),
(358474, 'PTHR31142:SF21', NULL, NULL, NULL, NULL, 'OS03G0120300 PROTEIN', 245577),
(358475, 'PTHR31142:SF43', NULL, NULL, NULL, NULL, 'DUF1084 DOMAIN-CONTAINING PROTEIN', 245577);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(358476, 'PTHR31142:SF42', NULL, NULL, NULL, NULL, 'PROTEIN TOM THREE HOMOLOG 1', 245577),
(358477, 'PTHR31142:SF4', NULL, NULL, NULL, NULL, 'OS01G0751300 PROTEIN', 245577),
(358478, 'PTHR31142:SF2', NULL, NULL, NULL, NULL, 'DUF1084 DOMAIN-CONTAINING PROTEIN', 245577),
(358479, 'PTHR31142:SF3', NULL, NULL, NULL, NULL, 'DUF1084 DOMAIN-CONTAINING PROTEIN', 245577),
(358480, 'PTHR31142:SF8', NULL, NULL, NULL, NULL, 'DUF1084 DOMAIN-CONTAINING PROTEIN', 245577),
(358481, 'PTHR31142:SF9', NULL, NULL, NULL, NULL, '', 245577),
(358482, 'PTHR31142:SF29', NULL, NULL, NULL, NULL, 'DUF1084 DOMAIN-CONTAINING PROTEIN', 245577),
(358483, 'PTHR31142:SF28', NULL, NULL, NULL, NULL, 'TOBAMOVIRUS MULTIPLICATION PROTEIN 3-LIKE ISOFORM X1', 245577),
(358484, 'PTHR31142:SF39', NULL, NULL, NULL, NULL, 'TOBAMOVIRUS MULTIPLICATION PROTEIN 1-LIKE', 245577),
(358485, 'PTHR31142:SF7', NULL, NULL, NULL, NULL, 'OS02G0683900 PROTEIN', 245577),
(358486, 'PTHR31142', NULL, NULL, NULL, NULL, 'TOBAMOVIRUS MULTIPLICATION PROTEIN 1-LIKE ISOFORM X1', 245577),
(358487, 'PTHR31142:SF1', NULL, NULL, NULL, NULL, 'TOBAMOVIRUS MULTIPLICATION PROTEIN 1', 245577),
(358488, 'PTHR47528', NULL, NULL, NULL, NULL, 'PARALEMMIN-3', 245578),
(358489, 'PTHR47528:SF1', NULL, NULL, NULL, NULL, 'PARALEMMIN-3', 245578),
(358490, 'PTHR48082:SF8', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT ALPHA-RELATED', 245579),
(358491, 'PTHR48082:SF6', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT ALPHA, CHLOROPLASTIC', 245579),
(358492, 'PTHR48082', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT ALPHA, MITOCHONDRIAL', 245579),
(358493, 'PTHR48082:SF9', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT ALPHA, CHLOROPLASTIC', 245579),
(358494, 'PTHR48082:SF3', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT ALPHA, MITOCHONDRIAL', 245579),
(358495, 'PTHR48082:SF2', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT ALPHA, MITOCHONDRIAL', 245579),
(358496, 'PTHR48082:SF1', NULL, NULL, NULL, NULL, 'ATP SYNTHASE F1 SUBUNIT ALPHA', 245579),
(358497, 'PTHR34598:SF3', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE AN1597', 245580),
(358498, 'PTHR34598:SF1', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_3G13140)-RELATED', 245580),
(358499, 'PTHR34598', NULL, NULL, NULL, NULL, 'BLL6449 PROTEIN', 245580),
(358500, 'PTHR34598:SF4', NULL, NULL, NULL, NULL, '', 245580),
(358501, 'PTHR24224:SF33', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245581),
(358502, 'PTHR24224:SF13', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245581),
(358503, 'PTHR24224:SF12', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN-RELATED', 245581),
(358504, 'PTHR24224:SF34', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245581),
(358505, 'PTHR24224:SF37', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245581),
(358506, 'PTHR24224:SF15', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245581),
(358507, 'PTHR24224:SF36', NULL, NULL, NULL, NULL, 'NEMATOCIN RECEPTOR 2', 245581),
(358508, 'PTHR24224:SF14', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245581),
(358509, 'PTHR24224:SF17', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245581),
(358510, 'PTHR24224:SF16', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245581),
(358511, 'PTHR24224', NULL, NULL, NULL, NULL, 'CARDIOACCELERATORY PEPTIDE RECEPTOR-RELATED', 245581),
(358512, 'PTHR24224:SF31', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245581),
(358513, 'PTHR24224:SF1', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245581),
(358514, 'PTHR24224:SF18', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245581),
(358515, 'PTHR24224:SF3', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245581),
(358516, 'PTHR24224:SF6', NULL, NULL, NULL, NULL, 'CARDIOACCELERATORY PEPTIDE RECEPTOR-RELATED', 245581),
(358517, 'PTHR42866:SF9', NULL, NULL, NULL, NULL, 'BNAA05G35640D PROTEIN', 245582);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(358518, 'PTHR42866:SF8', NULL, NULL, NULL, NULL, '3-DEOXY-MANNO-OCTULOSONATE CYTIDYLYLTRANSFERASE, MITOCHONDRIAL-LIKE', 245582),
(358519, 'PTHR42866', NULL, NULL, NULL, NULL, '3-DEOXY-MANNO-OCTULOSONATE CYTIDYLYLTRANSFERASE', 245582),
(358520, 'PTHR42866:SF2', NULL, NULL, NULL, NULL, '3-DEOXY-MANNO-OCTULOSONATE CYTIDYLYLTRANSFERASE, MITOCHONDRIAL', 245582),
(358521, 'PTHR42866:SF1', NULL, NULL, NULL, NULL, 'SPORE COAT POLYSACCHARIDE BIOSYNTHESIS PROTEIN SPSF', 245582),
(358522, 'PTHR42866:SF10', NULL, NULL, NULL, NULL, '3-DEOXY-MANNO-OCTULOSONATE CYTIDYLYLTRANSFERASE, MITOCHONDRIAL', 245582),
(358523, 'PTHR47198:SF1', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 245583),
(358524, 'PTHR47198', NULL, NULL, NULL, NULL, 'OS05G0299300 PROTEIN', 245583),
(358525, 'PTHR28623:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAM118B', 245584),
(358526, 'PTHR28623:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM118A', 245584),
(358527, 'PTHR28623', NULL, NULL, NULL, NULL, 'PROTEIN FAM118B', 245584),
(358528, 'PTHR45581:SF3', NULL, NULL, NULL, NULL, 'METHYLTRANFER_DOM DOMAIN-CONTAINING PROTEIN', 245585),
(358529, 'PTHR45581:SF2', NULL, NULL, NULL, NULL, 'METHYLTRANFER_DOM DOMAIN-CONTAINING PROTEIN', 245585),
(358530, 'PTHR45581', NULL, NULL, NULL, NULL, 'PROTEIN CBG10435', 245585),
(358531, 'PTHR37440:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG17853', 245586),
(358532, 'PTHR37440:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG08766', 245586),
(358533, 'PTHR37440:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG12938', 245586),
(358534, 'PTHR37440:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG17854', 245586),
(358535, 'PTHR37440', NULL, NULL, NULL, NULL, 'PROTEIN CBG17852-RELATED', 245586),
(358536, 'PTHR37440:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG17852', 245586),
(358537, 'PTHR12205:SF0', NULL, NULL, NULL, NULL, 'CENTROMERE/KINETOCHORE PROTEIN ZW10 HOMOLOG', 245587),
(358538, 'PTHR12205', NULL, NULL, NULL, NULL, 'CENTROMERE/KINETOCHORE PROTEIN ZW10', 245587),
(358539, 'PTHR39450:SF1', NULL, NULL, NULL, NULL, 'MOLYBDOPTERIN OXIDOREDUCTASE, 4FE-4S CLUSTER-BINDING SUBUNIT', 245588),
(358540, 'PTHR39450', NULL, NULL, NULL, NULL, 'MOLYBDOPTERIN OXIDOREDUCTASE, 4FE-4S CLUSTER-BINDING SUBUNIT', 245588),
(358541, 'PTHR15275', NULL, NULL, NULL, NULL, 'CG1 PROTEIN/F18', 245589),
(358542, 'PTHR15275:SF0', NULL, NULL, NULL, NULL, 'MASTERMIND-LIKE DOMAIN-CONTAINING PROTEIN 1', 245589),
(358543, 'PTHR15275:SF1', NULL, NULL, NULL, NULL, 'MASTERMIND-LIKE DOMAIN-CONTAINING PROTEIN 1', 245589),
(358544, 'PTHR34047:SF8', NULL, NULL, NULL, NULL, 'GROUP II INTRON-ASSOCIATED OPEN READING FRAME', 245590),
(358545, 'PTHR34047:SF7', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE-RELATED', 245590),
(358546, 'PTHR34047:SF2', NULL, NULL, NULL, NULL, 'NUCLEAR INTRON MATURASE 1, MITOCHONDRIAL', 245590),
(358547, 'PTHR34047:SF1', NULL, NULL, NULL, NULL, 'NUCLEAR INTRON MATURASE 2, MITOCHONDRIAL', 245590),
(358548, 'PTHR34047:SF3', NULL, NULL, NULL, NULL, 'BLR2052 PROTEIN', 245590),
(358549, 'PTHR34047:SF9', NULL, NULL, NULL, NULL, 'PROTEIN YKFC', 245590),
(358550, 'PTHR34047', NULL, NULL, NULL, NULL, 'NUCLEAR INTRON MATURASE 1, MITOCHONDRIAL-RELATED', 245590),
(358551, 'PTHR18460:SF3', NULL, NULL, NULL, NULL, 'TELO2-INTERACTING PROTEIN 1 HOMOLOG', 245591),
(358552, 'PTHR18460', NULL, NULL, NULL, NULL, 'TEL2 INTERACTING PROTEIN 1 TTI1 FAMILY MEMBER', 245591),
(358553, 'PTHR37253', NULL, NULL, NULL, NULL, 'PROTEIN GAMETE EXPRESSED 3', 245592),
(358554, 'PTHR37253:SF1', NULL, NULL, NULL, NULL, 'PROTEIN GAMETE EXPRESSED 3', 245592),
(358555, 'PTHR20900:SF2', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 BETA SUBCOMPLEX SUBUNIT 7', 245593),
(358556, 'PTHR20900:SF3', NULL, NULL, NULL, NULL, 'PWWP DOMAIN-CONTAINING PROTEIN', 245593),
(358557, 'PTHR20900:SF0', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 BETA SUBCOMPLEX SUBUNIT 7', 245593),
(358558, 'PTHR20900:SF1', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 BETA SUBCOMPLEX SUBUNIT 7', 245593),
(358559, 'PTHR20900', NULL, NULL, NULL, NULL, 'NADH:UBIQUINONE OXIDOREDUCTASE B18-LIKE SUBUNIT', 245593);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(358560, 'PTHR23175:SF20', NULL, NULL, NULL, NULL, '', 245594),
(358561, 'PTHR23175:SF23', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN', 245594),
(358562, 'PTHR23175:SF5', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 23', 245594),
(358563, 'PTHR23175:SF16', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 21', 245594),
(358564, 'PTHR23175', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN', 245594),
(358565, 'PTHR28028:SF1', NULL, NULL, NULL, NULL, '60S RIBOSOMAL SUBUNIT ASSEMBLY/EXPORT PROTEIN LOC1', 245595),
(358566, 'PTHR28028', NULL, NULL, NULL, NULL, '60S RIBOSOMAL SUBUNIT ASSEMBLY/EXPORT PROTEIN LOC1', 245595),
(358567, 'PTHR20908:SF4', NULL, NULL, NULL, NULL, 'SI:DKEY-5I3.5', 245596),
(358568, 'PTHR20908:SF3', NULL, NULL, NULL, NULL, '', 245596),
(358569, 'PTHR20908:SF1', NULL, NULL, NULL, NULL, 'LD15586P', 245596),
(358570, 'PTHR20908', NULL, NULL, NULL, NULL, 'LD15586P', 245596),
(358571, 'PTHR10519:SF76', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID TYPE B RECEPTOR SUBUNIT 1', 245597),
(358572, 'PTHR10519:SF66', NULL, NULL, NULL, NULL, 'METABOTROPIC GLUTAMATE RECEPTOR-LIKE PROTEIN P', 245597),
(358573, 'PTHR10519:SF68', NULL, NULL, NULL, NULL, 'METABOTROPIC GLUTAMATE RECEPTOR-LIKE PROTEIN Q', 245597),
(358574, 'PTHR10519:SF46', NULL, NULL, NULL, NULL, 'METABOTROPIC GABA-B RECEPTOR SUBTYPE 3, ISOFORM A', 245597),
(358575, 'PTHR10519', NULL, NULL, NULL, NULL, 'GABA-B RECEPTOR', 245597),
(358576, 'PTHR10519:SF63', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 156-RELATED', 245597),
(358577, 'PTHR10519:SF74', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID TYPE B RECEPTOR SUBUNIT 2', 245597),
(358578, 'PTHR10519:SF75', NULL, NULL, NULL, NULL, 'ANF_RECEPTOR DOMAIN-CONTAINING PROTEIN', 245597),
(358579, 'PTHR10519:SF20', NULL, NULL, NULL, NULL, 'METABOTROPIC GLUTAMATE RECEPTOR-LIKE PROTEIN E', 245597),
(358580, 'PTHR34548', NULL, NULL, NULL, NULL, 'PROTEIN TIC 21, CHLOROPLASTIC', 245598),
(358581, 'PTHR34548:SF2', NULL, NULL, NULL, NULL, 'PROTEIN TIC 21, CHLOROPLASTIC', 245598),
(358582, 'PTHR34548:SF6', NULL, NULL, NULL, NULL, 'OS06G0638100 PROTEIN', 245598),
(358583, 'PTHR34548:SF5', NULL, NULL, NULL, NULL, 'BNAA09G52720D PROTEIN', 245598),
(358584, 'PTHR38450', NULL, NULL, NULL, NULL, 'STAGE V SPORULATION PROTEIN AC-RELATED', 245599),
(358585, 'PTHR38450:SF2', NULL, NULL, NULL, NULL, 'STAGE V SPORULATION PROTEIN AEB', 245599),
(358586, 'PTHR38450:SF1', NULL, NULL, NULL, NULL, 'STAGE V SPORULATION PROTEIN AC', 245599),
(358587, 'PTHR43674:SF16', NULL, NULL, NULL, NULL, 'CARBON-NITROGEN FAMILY, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G02350)-RELATED', 245600),
(358588, 'PTHR43674:SF2', NULL, NULL, NULL, NULL, 'BETA-UREIDOPROPIONASE', 245600),
(358589, 'PTHR43674:SF12', NULL, NULL, NULL, NULL, 'NITRILASE C965.09-RELATED', 245600),
(358590, 'PTHR43674:SF13', NULL, NULL, NULL, NULL, 'CN HYDROLASE DOMAIN-CONTAINING PROTEIN', 245600),
(358591, 'PTHR43674:SF14', NULL, NULL, NULL, NULL, 'ALIPHATIC AMIDASE', 245600),
(358592, 'PTHR43674:SF15', NULL, NULL, NULL, NULL, 'FORMAMIDASE', 245600),
(358593, 'PTHR43674:SF11', NULL, NULL, NULL, NULL, 'CN HYDROLASE DOMAIN-CONTAINING PROTEIN', 245600),
(358594, 'PTHR43674', NULL, NULL, NULL, NULL, 'NITRILASE C965.09-RELATED', 245600),
(358595, 'PTHR16886:SF0', NULL, NULL, NULL, NULL, 'HYPOXIA-INDUCIBLE LIPID DROPLET-ASSOCIATED PROTEIN', 245601),
(358596, 'PTHR16886', NULL, NULL, NULL, NULL, 'HYPOXIA-INDUCIBLE PROTEIN 2', 245601),
(358597, 'PTHR35301:SF2', NULL, NULL, NULL, NULL, '', 245602),
(358598, 'PTHR35301:SF1', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 41-RELATED', 245602),
(358599, 'PTHR35301:SF3', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 42', 245602),
(358600, 'PTHR35301:SF5', NULL, NULL, NULL, NULL, 'BNAC03G44760D PROTEIN', 245602),
(358601, 'PTHR35301', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 41-RELATED', 245602),
(358602, 'PTHR34949', NULL, NULL, NULL, NULL, 'OS05G0443700 PROTEIN', 245603),
(358603, 'PTHR34949:SF2', NULL, NULL, NULL, NULL, 'OS05G0443700 PROTEIN', 245603);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(358604, 'PTHR34949:SF3', NULL, NULL, NULL, NULL, 'OS08G0244100 PROTEIN', 245603),
(358605, 'PTHR34949:SF8', NULL, NULL, NULL, NULL, 'SYNTAXIN-6_N DOMAIN-CONTAINING PROTEIN', 245603),
(358606, 'PTHR34949:SF9', NULL, NULL, NULL, NULL, 'SYNTAXIN-6_N DOMAIN-CONTAINING PROTEIN', 245603),
(358607, 'PTHR34949:SF6', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245603),
(358608, 'PTHR34949:SF7', NULL, NULL, NULL, NULL, 'SYNTAXIN-6_N DOMAIN-CONTAINING PROTEIN', 245603),
(358609, 'PTHR34949:SF10', NULL, NULL, NULL, NULL, 'T-SNARE-RELATED', 245603),
(358610, 'PTHR34949:SF11', NULL, NULL, NULL, NULL, 'SYNTAXIN-6_N DOMAIN-CONTAINING PROTEIN', 245603),
(358611, 'PTHR34949:SF12', NULL, NULL, NULL, NULL, 'SYNTAXIN 6, AMINO-TERMINAL PROTEIN', 245603),
(358612, 'PTHR37858', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC689589', 245604),
(358613, 'PTHR37858:SF1', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC689589', 245604),
(358614, 'PTHR46671:SF4', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 245605),
(358615, 'PTHR46671:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG24500', 245605),
(358616, 'PTHR46671:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG21363', 245605),
(358617, 'PTHR46671:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG00952', 245605),
(358618, 'PTHR46671:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG02521', 245605),
(358619, 'PTHR46671', NULL, NULL, NULL, NULL, 'PROTEIN CBG11221', 245605),
(358620, 'PTHR46671:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG23370', 245605),
(358621, 'PTHR46671:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG11221', 245605),
(358622, 'PTHR11532:SF80', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE N CATALYTIC CHAIN', 245606),
(358623, 'PTHR11532:SF91', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE D, B', 245606),
(358624, 'PTHR11532:SF90', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE D', 245606),
(358625, 'PTHR11532:SF73', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE D', 245606),
(358626, 'PTHR11532:SF62', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE E', 245606),
(358627, 'PTHR11532:SF84', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE M', 245606),
(358628, 'PTHR11532:SF92', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE E', 245606),
(358629, 'PTHR11532:SF43', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE X1-RELATED', 245606),
(358630, 'PTHR11532:SF63', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE Z', 245606),
(358631, 'PTHR11532:SF48', NULL, NULL, NULL, NULL, 'ADIPOCYTE ENHANCER-BINDING PROTEIN 1', 245606),
(358632, 'PTHR11532:SF57', NULL, NULL, NULL, NULL, 'PEPTIDASE_M14 DOMAIN-CONTAINING PROTEIN', 245606),
(358633, 'PTHR11532:SF45', NULL, NULL, NULL, NULL, 'INACTIVE CARBOXYPEPTIDASE-LIKE PROTEIN X2', 245606),
(358634, 'PTHR11532', NULL, NULL, NULL, NULL, 'PROTEASE M14 CARBOXYPEPTIDASE', 245606),
(358635, 'PTHR38604:SF1', NULL, NULL, NULL, NULL, 'PERIPLASMIC NITRATE REDUCTASE, ELECTRON TRANSFER SUBUNIT', 245607),
(358636, 'PTHR38604', NULL, NULL, NULL, NULL, 'PERIPLASMIC NITRATE REDUCTASE, ELECTRON TRANSFER SUBUNIT', 245607),
(358637, 'PTHR21181:SF13', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE (UBIQUINONE) COMPLEX I, ASSEMBLY FACTOR 6', 245608),
(358638, 'PTHR21181:SF14', NULL, NULL, NULL, NULL, 'MEMBRANE MAGNESIUM TRANSPORTER 2', 245608),
(358639, 'PTHR21181', NULL, NULL, NULL, NULL, '', 245608),
(358640, 'PTHR21181:SF15', NULL, NULL, NULL, NULL, 'ER MEMBRANE PROTEIN COMPLEX SUBUNIT 5', 245608),
(358641, 'PTHR21181:SF7', NULL, NULL, NULL, NULL, 'ER MEMBRANE PROTEIN COMPLEX SUBUNIT 5', 245608),
(358642, 'PTHR23527:SF1', NULL, NULL, NULL, NULL, 'BLL3282 PROTEIN', 245609),
(358643, 'PTHR23527', NULL, NULL, NULL, NULL, 'BLL3282 PROTEIN', 245609),
(358644, 'PTHR44188:SF3', NULL, NULL, NULL, NULL, 'GANGLIOSIDE-INDUCED DIFFERENTIATION-ASSOCIATED PROTEIN 1', 245610),
(358645, 'PTHR44188:SF2', NULL, NULL, NULL, NULL, 'GANGLIOSIDE-INDUCED DIFFERENTIATION-ASSOCIATED PROTEIN 1-LIKE 1', 245610),
(358646, 'PTHR44188', NULL, NULL, NULL, NULL, 'GDAP1, ISOFORM A', 245610),
(358647, 'PTHR44188:SF1', NULL, NULL, NULL, NULL, 'GDAP1, ISOFORM A', 245610),
(358648, 'PTHR36032', NULL, NULL, NULL, NULL, 'PHOSPHOPANTOTHENATE--CYSTEINE LIGASE 2', 245611);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(358649, 'PTHR36032:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOPANTOTHENATE--CYSTEINE LIGASE 2', 245611),
(358650, 'PTHR46473:SF16', NULL, NULL, NULL, NULL, 'LEUCINE-RICH HEV GLYCOPROTEIN', 245612),
(358651, 'PTHR46473:SF17', NULL, NULL, NULL, NULL, 'PROTEIN HALFWAY', 245612),
(358652, 'PTHR46473:SF14', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT CONTAINING 3B', 245612),
(358653, 'PTHR46473:SF15', NULL, NULL, NULL, NULL, 'CHONDROADHERIN', 245612),
(358654, 'PTHR46473:SF4', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 38', 245612),
(358655, 'PTHR46473:SF3', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING 3C', 245612),
(358656, 'PTHR46473:SF18', NULL, NULL, NULL, NULL, 'LRRCT DOMAIN-CONTAINING PROTEIN', 245612),
(358657, 'PTHR46473:SF2', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 26', 245612),
(358658, 'PTHR46473:SF19', NULL, NULL, NULL, NULL, 'GH08155P-RELATED', 245612),
(358659, 'PTHR46473', NULL, NULL, NULL, NULL, 'GH08155P', 245612),
(358660, 'PTHR46473:SF6', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 52', 245612),
(358661, 'PTHR46473:SF5', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 55', 245612),
(358662, 'PTHR46473:SF20', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 245612),
(358663, 'PTHR46473:SF12', NULL, NULL, NULL, NULL, 'ELRR (EXTRACELLULAR LEUCINE-RICH REPEAT) ONLY', 245612),
(358664, 'PTHR46473:SF13', NULL, NULL, NULL, NULL, 'WSC DOMAIN-CONTAINING PROTEIN', 245612),
(358665, 'PTHR46473:SF10', NULL, NULL, NULL, NULL, 'LRRNT DOMAIN-CONTAINING PROTEIN', 245612),
(358666, 'PTHR46473:SF11', NULL, NULL, NULL, NULL, 'ELRR (EXTRACELLULAR LEUCINE-RICH REPEAT) ONLY', 245612),
(358667, 'PTHR12145:SF40', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,6-ALPHA-MANNOSIDASE C1198.07C-RELATED', 245613),
(358668, 'PTHR12145:SF39', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,6-ALPHA-MANNOSIDASE C1198.06C-RELATED', 245613),
(358669, 'PTHR12145:SF38', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,6-ALPHA-MANNOSIDASE', 245613),
(358670, 'PTHR12145:SF37', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,6-ALPHA-MANNOSIDASE', 245613),
(358671, 'PTHR12145:SF36', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,6-ALPHA-MANNOSIDASE DCW1', 245613),
(358672, 'PTHR12145:SF35', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,6-ALPHA-MANNOSIDASE', 245613),
(358673, 'PTHR12145:SF21', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,6-ALPHA-MANNOSIDASE DFG5', 245613),
(358674, 'PTHR12145', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 245613),
(358675, 'PTHR15673:SF2', NULL, NULL, NULL, NULL, 'IQ CALMODULIN-BINDING MOTIF-CONTAINING PROTEIN 1', 245614),
(358676, 'PTHR15673', NULL, NULL, NULL, NULL, 'IQ CALMODULIN-BINDING MOTIF CONTAINING PROTEIN 1', 245614),
(358677, 'PTHR38487:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ZIP4 HOMOLOG', 245615),
(358678, 'PTHR38487', NULL, NULL, NULL, NULL, 'TESTIS EXPRESSED 11', 245615),
(358679, 'PTHR22838:SF25', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR INTERACTOR AND REGULATOR LISH FAMILY-RELATED', 245616),
(358680, 'PTHR22838:SF0', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 26', 245616),
(358681, 'PTHR22838:SF24', NULL, NULL, NULL, NULL, '', 245616),
(358682, 'PTHR22838:SF26', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 26-LIKE', 245616),
(358683, 'PTHR22838:SF4', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 13', 245616),
(358684, 'PTHR22838', NULL, NULL, NULL, NULL, 'WD REPEAT PROTEIN 26-RELATED', 245616),
(358685, 'PTHR22838:SF6', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 26 HOMOLOG', 245616),
(358686, 'PTHR22838:SF20', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 26-RELATED', 245616),
(358687, 'PTHR22838:SF23', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN WDS HOMOLOG', 245616),
(358688, 'PTHR22838:SF22', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 245616),
(358689, 'PTHR43698:SF1', NULL, NULL, NULL, NULL, 'CUPIN_2 DOMAIN-CONTAINING PROTEIN', 245617),
(358690, 'PTHR43698', NULL, NULL, NULL, NULL, 'RIBD C-TERMINAL DOMAIN CONTAINING PROTEIN', 245617);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(358691, 'PTHR36849', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 245618),
(358692, 'PTHR36849:SF1', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 245618),
(358693, 'PTHR35348:SF1', NULL, NULL, NULL, NULL, 'TESTIS, PROSTATE AND PLACENTA-EXPRESSED PROTEIN', 245619),
(358694, 'PTHR35348', NULL, NULL, NULL, NULL, 'TESTIS, PROSTATE AND PLACENTA-EXPRESSED PROTEIN', 245619),
(358695, 'PTHR10881:SF58', NULL, NULL, NULL, NULL, 'GOLGIN SUBFAMILY A MEMBER 2', 245620),
(358696, 'PTHR10881:SF44', NULL, NULL, NULL, NULL, 'GOLGIN SUBFAMILY A MEMBER 6A-RELATED', 245620),
(358697, 'PTHR10881:SF46', NULL, NULL, NULL, NULL, 'GOLGIN SUBFAMILY A MEMBER 2', 245620),
(358698, 'PTHR10881', NULL, NULL, NULL, NULL, 'GOLGIN SUBFAMILY A MEMBER-RELATED', 245620),
(358699, 'PTHR10881:SF62', NULL, NULL, NULL, NULL, 'GOLGIN SUBFAMILY A MEMBER 8H-RELATED', 245620),
(358700, 'PTHR10881:SF63', NULL, NULL, NULL, NULL, 'GOLGIN SUBFAMILY A MEMBER 8B', 245620),
(358701, 'PTHR10881:SF64', NULL, NULL, NULL, NULL, 'GOLGIN SUBFAMILY A MEMBER 8A', 245620),
(358702, 'PTHR10881:SF7', NULL, NULL, NULL, NULL, 'GOLGIN SUBFAMILY A MEMBER 8C-RELATED', 245620),
(358703, 'PTHR23502:SF132', NULL, NULL, NULL, NULL, 'BICYCLOMYCIN RESISTANCE PROTEIN', 245621),
(358704, 'PTHR23502:SF173', NULL, NULL, NULL, NULL, 'CHROMOSOME 19, WHOLE GENOME SHOTGUN SEQUENCE', 245621),
(358705, 'PTHR23502:SF130', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245621),
(358706, 'PTHR23502', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY', 245621),
(358707, 'PTHR23502:SF179', NULL, NULL, NULL, NULL, 'SPERMIDINE FAMILY TRANSPORTER', 245621),
(358708, 'PTHR23502:SF135', NULL, NULL, NULL, NULL, 'MULTIDRUG TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G16320)-RELATED', 245621),
(358709, 'PTHR23502:SF136', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245621),
(358710, 'PTHR23502:SF177', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245621),
(358711, 'PTHR23502:SF178', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G02040)-RELATED', 245621),
(358712, 'PTHR23502:SF134', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245621),
(358713, 'PTHR23502:SF171', NULL, NULL, NULL, NULL, 'CHROMOSOME 23, WHOLE GENOME SHOTGUN SEQUENCE', 245621),
(358714, 'PTHR23502:SF172', NULL, NULL, NULL, NULL, 'POLYAMINE TRANSPORTER 2-RELATED', 245621),
(358715, 'PTHR23502:SF74', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245621),
(358716, 'PTHR23502:SF30', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G04702)-RELATED', 245621),
(358717, 'PTHR23502:SF75', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN D', 245621),
(358718, 'PTHR23502:SF31', NULL, NULL, NULL, NULL, 'POLYAMINE TRANSPORTER 1', 245621),
(358719, 'PTHR23502:SF34', NULL, NULL, NULL, NULL, 'PROTEIN HOL1', 245621),
(358720, 'PTHR23502:SF35', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245621),
(358721, 'PTHR23502:SF32', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN D', 245621),
(358722, 'PTHR23502:SF76', NULL, NULL, NULL, NULL, '', 245621),
(358723, 'PTHR23502:SF33', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245621),
(358724, 'PTHR23502:SF38', NULL, NULL, NULL, NULL, 'POLYAMINE TRANSPORTER 4', 245621),
(358725, 'PTHR23502:SF139', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G13160)-RELATED', 245621),
(358726, 'PTHR23502:SF36', NULL, NULL, NULL, NULL, 'MEMBRANE TRANSPORTER', 245621),
(358727, 'PTHR23502:SF137', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY TRANSPORTER', 245621),
(358728, 'PTHR23502:SF138', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245621),
(358729, 'PTHR23502:SF164', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245621),
(358730, 'PTHR23502:SF162', NULL, NULL, NULL, NULL, 'INNER MEMBRANE TRANSPORT PROTEIN YDHC', 245621),
(358731, 'PTHR23502:SF163', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245621),
(358732, 'PTHR23502:SF167', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G08910)-RELATED', 245621);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(358733, 'PTHR23502:SF70', NULL, NULL, NULL, NULL, 'BCR/CFLA FAMILY EFFLUX TRANSPORTER', 245621),
(358734, 'PTHR23502:SF160', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245621),
(358735, 'PTHR23502:SF5', NULL, NULL, NULL, NULL, 'QUINIDINE RESISTANCE PROTEIN 3', 245621),
(358736, 'PTHR23502:SF8', NULL, NULL, NULL, NULL, '', 245621),
(358737, 'PTHR23502:SF7', NULL, NULL, NULL, NULL, 'DRUG/PROTON ANTIPORTER YHK8-RELATED', 245621),
(358738, 'PTHR23502:SF2', NULL, NULL, NULL, NULL, 'MULTIDRUG TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G13830)-RELATED', 245621),
(358739, 'PTHR23502:SF20', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G13880)-RELATED', 245621),
(358740, 'PTHR23502:SF64', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G11760)-RELATED', 245621),
(358741, 'PTHR23502:SF61', NULL, NULL, NULL, NULL, 'MULTIDRUG TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G02780)-RELATED', 245621),
(358742, 'PTHR23502:SF4', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245621),
(358743, 'PTHR23502:SF3', NULL, NULL, NULL, NULL, 'MULTIDRUG EFFLUX PUMP OF PLASMA MEMBRANE (EUROFUNG)', 245621),
(358744, 'PTHR23502:SF23', NULL, NULL, NULL, NULL, 'FLUCONAZOLE RESISTANCE PROTEIN 1', 245621),
(358745, 'PTHR23502:SF24', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245621),
(358746, 'PTHR23502:SF68', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245621),
(358747, 'PTHR23502:SF21', NULL, NULL, NULL, NULL, 'DITYROSINE TRANSPORTER 1', 245621),
(358748, 'PTHR23502:SF66', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G17680)-RELATED', 245621),
(358749, 'PTHR23502:SF22', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G17840)-RELATED', 245621),
(358750, 'PTHR23502:SF26', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245621),
(358751, 'PTHR23502:SF29', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G06680)-RELATED', 245621),
(358752, 'PTHR23502:SF153', NULL, NULL, NULL, NULL, 'MULTIDRUG TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G00230)-RELATED', 245621),
(358753, 'PTHR23502:SF151', NULL, NULL, NULL, NULL, 'MFS MULTIDRUG TRANSPORTER', 245621),
(358754, 'PTHR23502:SF152', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245621),
(358755, 'PTHR23502:SF157', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245621),
(358756, 'PTHR23502:SF158', NULL, NULL, NULL, NULL, 'MULTIDRUG TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G01890)-RELATED', 245621),
(358757, 'PTHR23502:SF156', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G00420)-RELATED', 245621),
(358758, 'PTHR23502:SF150', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245621),
(358759, 'PTHR23502:SF60', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245621),
(358760, 'PTHR23502:SF52', NULL, NULL, NULL, NULL, 'MULTIDRUG TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G17730)-RELATED', 245621),
(358761, 'PTHR23502:SF50', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G00430)-RELATED', 245621),
(358762, 'PTHR23502:SF51', NULL, NULL, NULL, NULL, 'QUINIDINE RESISTANCE PROTEIN 1-RELATED', 245621),
(358763, 'PTHR23502:SF12', NULL, NULL, NULL, NULL, 'MULTIDRUG TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G06440)-RELATED', 245621),
(358764, 'PTHR23502:SF57', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN MDTL', 245621),
(358765, 'PTHR23502:SF13', NULL, NULL, NULL, NULL, 'MULTIDRUG TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G12550)-RELATED', 245621),
(358766, 'PTHR23502:SF10', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN MDTM', 245621),
(358767, 'PTHR23502:SF159', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G14230)-RELATED', 245621),
(358768, 'PTHR23502:SF59', NULL, NULL, NULL, NULL, 'MULTIDRUG TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G10370)-RELATED', 245621),
(358769, 'PTHR23502:SF142', NULL, NULL, NULL, NULL, 'ORF', 245621),
(358770, 'PTHR23502:SF143', NULL, NULL, NULL, NULL, 'MULTIDRUG TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G04900)-RELATED', 245621);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(358771, 'PTHR23502:SF144', NULL, NULL, NULL, NULL, 'EFFLUX TRANSPORTER, PUTATIVE-RELATED', 245621),
(358772, 'PTHR23502:SF145', NULL, NULL, NULL, NULL, 'MULTIDRUG TRANSPORTER, PUTATIVE-RELATED', 245621),
(358773, 'PTHR23502:SF182', NULL, NULL, NULL, NULL, 'POLYAMINE TRANSPORTER, PUTATIVE-RELATED', 245621),
(358774, 'PTHR23502:SF183', NULL, NULL, NULL, NULL, '', 245621),
(358775, 'PTHR23502:SF180', NULL, NULL, NULL, NULL, 'VITAMIN B6 TRANSPORTER BSU1', 245621),
(358776, 'PTHR23502:SF181', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245621),
(358777, 'PTHR23502:SF45', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245621),
(358778, 'PTHR23502:SF43', NULL, NULL, NULL, NULL, 'MULTIDRUG TRANSPORTER MDFA', 245621),
(358779, 'PTHR23502:SF49', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245621),
(358780, 'PTHR23502:SF47', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245621),
(358781, 'PTHR23502:SF48', NULL, NULL, NULL, NULL, 'MULTIDRUG TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G02700)-RELATED', 245621),
(358782, 'PTHR23502:SF149', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE-RELATED', 245621),
(358783, 'PTHR37168:SF2', NULL, NULL, NULL, NULL, 'CRISPR-ASSOCIATED EXONUCLEASE CAS4', 245622),
(358784, 'PTHR37168:SF1', NULL, NULL, NULL, NULL, 'CRISPR-ASSOCIATED EXONUCLEASE CAS4', 245622),
(358785, 'PTHR37168', NULL, NULL, NULL, NULL, 'CRISPR-ASSOCIATED EXONUCLEASE CAS4', 245622),
(358786, 'PTHR48064:SF5', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE 2', 245623),
(358787, 'PTHR48064:SF4', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 245623),
(358788, 'PTHR48064:SF1', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 51-RELATED', 245623),
(358789, 'PTHR48064', NULL, NULL, NULL, NULL, 'OS01G0750400 PROTEIN', 245623),
(358790, 'PTHR48064:SF2', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 51', 245623),
(358791, 'PTHR34186', NULL, NULL, NULL, NULL, 'CYANATE HYDRATASE', 245624),
(358792, 'PTHR34186:SF2', NULL, NULL, NULL, NULL, 'CYANATE HYDRATASE', 245624),
(358793, 'PTHR48081:SF7', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 245625),
(358794, 'PTHR48081:SF11', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN-RELATED', 245625),
(358795, 'PTHR48081:SF6', NULL, NULL, NULL, NULL, 'PEPTIDASE_S9 DOMAIN-CONTAINING PROTEIN', 245625),
(358796, 'PTHR48081:SF21', NULL, NULL, NULL, NULL, 'LIPASE/THIOESTERASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_8G02590)', 245625),
(358797, 'PTHR48081:SF9', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE', 245625),
(358798, 'PTHR48081:SF8', NULL, NULL, NULL, NULL, 'KYNURENINE FORMAMIDASE', 245625),
(358799, 'PTHR48081:SF27', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 245625),
(358800, 'PTHR48081:SF26', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 245625),
(358801, 'PTHR48081:SF15', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 245625),
(358802, 'PTHR48081:SF25', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_3G11560)-RELATED', 245625),
(358803, 'PTHR48081:SF14', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 245625),
(358804, 'PTHR48081:SF13', NULL, NULL, NULL, NULL, 'ESTERASE LIPQ', 245625),
(358805, 'PTHR48081:SF19', NULL, NULL, NULL, NULL, 'LIPASE/ESTERASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_6G09520)', 245625),
(358806, 'PTHR48081:SF18', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 245625),
(358807, 'PTHR48081:SF17', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 245625),
(358808, 'PTHR48081:SF3', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 245625),
(358809, 'PTHR48081:SF2', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 245625),
(358810, 'PTHR48081:SF5', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 245625),
(358811, 'PTHR48081', NULL, NULL, NULL, NULL, 'AB HYDROLASE SUPERFAMILY PROTEIN C4A8.06C', 245625),
(358812, 'PTHR48081:SF1', NULL, NULL, NULL, NULL, 'ABHYDROLASE_3 DOMAIN-CONTAINING PROTEIN', 245625);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(358813, 'PTHR37814', NULL, NULL, NULL, NULL, 'CONSERVED MEMBRANE PROTEIN', 245626),
(358814, 'PTHR37814:SF1', NULL, NULL, NULL, NULL, 'CONSERVED MEMBRANE PROTEIN', 245626),
(358815, 'PTHR31832:SF87', NULL, NULL, NULL, NULL, 'B-BOX ZINC FINGER PROTEIN 21', 245627),
(358816, 'PTHR31832:SF64', NULL, NULL, NULL, NULL, 'BNAA04G18330D PROTEIN', 245627),
(358817, 'PTHR31832:SF86', NULL, NULL, NULL, NULL, 'OS09G0527900 PROTEIN', 245627),
(358818, 'PTHR31832:SF67', NULL, NULL, NULL, NULL, 'B-BOX ZINC FINGER PROTEIN 22', 245627),
(358819, 'PTHR31832:SF89', NULL, NULL, NULL, NULL, 'LIGHT-REGULATED ZINC FINGER PROTEIN 1-RELATED', 245627),
(358820, 'PTHR31832:SF88', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR INTERACTOR AND REGULATOR ZNF-B FAMILY-RELATED', 245627),
(358821, 'PTHR31832:SF69', NULL, NULL, NULL, NULL, 'B-BOX-TYPE ZINC FINGER-RELATED', 245627),
(358822, 'PTHR31832:SF47', NULL, NULL, NULL, NULL, 'B-BOX ZINC FINGER PROTEIN 25', 245627),
(358823, 'PTHR31832:SF68', NULL, NULL, NULL, NULL, 'B-BOX ZINC FINGER PROTEIN 22', 245627),
(358824, 'PTHR31832:SF90', NULL, NULL, NULL, NULL, 'B-BOX ZINC FINGER PROTEIN 22-LIKE', 245627),
(358825, 'PTHR31832:SF91', NULL, NULL, NULL, NULL, 'BNAA02G18950D PROTEIN', 245627),
(358826, 'PTHR31832:SF72', NULL, NULL, NULL, NULL, 'B-BOX-TYPE ZINC FINGER-RELATED', 245627),
(358827, 'PTHR31832:SF52', NULL, NULL, NULL, NULL, 'B-BOX ZINC FINGER PROTEIN 20', 245627),
(358828, 'PTHR31832:SF73', NULL, NULL, NULL, NULL, 'BNAA06G37240D PROTEIN', 245627),
(358829, 'PTHR31832:SF5', NULL, NULL, NULL, NULL, 'B-BOX ZINC FINGER PROTEIN 19', 245627),
(358830, 'PTHR31832:SF9', NULL, NULL, NULL, NULL, 'OS05G0204600 PROTEIN', 245627),
(358831, 'PTHR31832:SF53', NULL, NULL, NULL, NULL, 'BNAC02G23750D PROTEIN', 245627),
(358832, 'PTHR31832:SF75', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN-RELATED', 245627),
(358833, 'PTHR31832:SF56', NULL, NULL, NULL, NULL, 'BNAANNG09120D PROTEIN', 245627),
(358834, 'PTHR31832:SF77', NULL, NULL, NULL, NULL, 'B-BOX ZINC FINGER PROTEIN 21-LIKE', 245627),
(358835, 'PTHR31832:SF36', NULL, NULL, NULL, NULL, 'B-BOX ZINC FINGER PROTEIN 18', 245627),
(358836, 'PTHR31832:SF79', NULL, NULL, NULL, NULL, 'BNAA10G03990D PROTEIN', 245627),
(358837, 'PTHR31832:SF59', NULL, NULL, NULL, NULL, 'BNAC08G44590D PROTEIN', 245627),
(358838, 'PTHR31832', NULL, NULL, NULL, NULL, 'B-BOX ZINC FINGER PROTEIN 22', 245627),
(358839, 'PTHR31832:SF80', NULL, NULL, NULL, NULL, 'AP2-EREBP TRANSCRIPTION FACTOR', 245627),
(358840, 'PTHR31832:SF83', NULL, NULL, NULL, NULL, 'OS06G0713000 PROTEIN', 245627),
(358841, 'PTHR31832:SF60', NULL, NULL, NULL, NULL, 'BNAC01G00140D PROTEIN', 245627),
(358842, 'PTHR31832:SF82', NULL, NULL, NULL, NULL, 'B-BOX ZINC FINGER PROTEIN 22-LIKE', 245627),
(358843, 'PTHR31832:SF63', NULL, NULL, NULL, NULL, 'B-BOX ZINC FINGER PROTEIN 23', 245627),
(358844, 'PTHR31832:SF85', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR INTERACTOR AND REGULATOR ZNF-B FAMILY-RELATED', 245627),
(358845, 'PTHR31832:SF41', NULL, NULL, NULL, NULL, 'B-BOX ZINC FINGER PROTEIN 24', 245627),
(358846, 'PTHR31832:SF62', NULL, NULL, NULL, NULL, 'BNAANNG29690D PROTEIN', 245627),
(358847, 'PTHR31832:SF84', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR INTERACTOR AND REGULATOR ZNF-B FAMILY-RELATED', 245627),
(358848, 'PTHR43119:SF1', NULL, NULL, NULL, NULL, 'BLR8070 PROTEIN', 245628),
(358849, 'PTHR43119', NULL, NULL, NULL, NULL, 'ABC TRANSPORT PROTEIN ATP-BINDING COMPONENT-RELATED', 245628),
(358850, 'PTHR43217:SF1', NULL, NULL, NULL, NULL, 'SUCCINATE SEMIALDEHYDE DEHYDROGENASE [NAD(P)+] SAD', 245629),
(358851, 'PTHR43217', NULL, NULL, NULL, NULL, 'SUCCINATE SEMIALDEHYDE DEHYDROGENASE [NAD(P)+] SAD', 245629),
(358852, 'PTHR43217:SF2', NULL, NULL, NULL, NULL, 'SUCCINATE-SEMIALDEHYDE DEHYDROGENASE [NADP(+)]', 245629),
(358853, 'PTHR32329:SF2', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL PROTEIN [INCLUDES 2-HYDROXYACYL-COA DEHYDRATASE (N-TER) AND ITS ACTIVATOR DOMAIN (C_TERM)-RELATED', 245630),
(358854, 'PTHR32329', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL PROTEIN [INCLUDES 2-HYDROXYACYL-COA DEHYDRATASE (N-TER) AND ITS ACTIVATOR DOMAIN (C_TERM)-RELATED', 245630);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(358855, 'PTHR32329:SF4', NULL, NULL, NULL, NULL, 'ACTIVATOR OF 2-HYDROXYACYL-COA DEHYDRATASE-RELATED', 245630),
(358856, 'PTHR32329:SF5', NULL, NULL, NULL, NULL, 'ACTIVATOR OF 2-HYDROXYACYL-COA DEHYDRATASE-RELATED', 245630),
(358857, 'PTHR32329:SF7', NULL, NULL, NULL, NULL, 'ACTIVATOR OF 2-HYDROXYACYL-COA-HYDRATASE-RELATED', 245630),
(358858, 'PTHR32329:SF8', NULL, NULL, NULL, NULL, 'DUF2229 DOMAIN-CONTAINING PROTEIN', 245630),
(358859, 'PTHR21319:SF54', NULL, NULL, NULL, NULL, 'CHY AND CTCHY AND RING-TYPE ZINC FINGER PROTEIN', 245631),
(358860, 'PTHR21319:SF65', NULL, NULL, NULL, NULL, 'CHY AND CTCHY AND RING-TYPE ZINC FINGER PROTEIN', 245631),
(358861, 'PTHR21319:SF31', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN-RELATED', 245631),
(358862, 'PTHR21319:SF20', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MIEL1', 245631),
(358863, 'PTHR21319:SF53', NULL, NULL, NULL, NULL, 'RING FINGER AND CHY ZINC FINGER DOMAIN-CONTAINING PROTEIN 1', 245631),
(358864, 'PTHR21319:SF64', NULL, NULL, NULL, NULL, 'CHY ZINC FINGER FAMILY PROTEIN, EXPRESSED', 245631),
(358865, 'PTHR21319:SF52', NULL, NULL, NULL, NULL, 'BNAC09G39170D PROTEIN', 245631),
(358866, 'PTHR21319:SF63', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MIEL1-LIKE ISOFORM X1', 245631),
(358867, 'PTHR21319:SF62', NULL, NULL, NULL, NULL, '', 245631),
(358868, 'PTHR21319:SF40', NULL, NULL, NULL, NULL, '', 245631),
(358869, 'PTHR21319:SF61', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN BRUTUS', 245631),
(358870, 'PTHR21319', NULL, NULL, NULL, NULL, 'RING FINGER AND CHY ZINC FINGER DOMAIN-CONTAINING PROTEIN 1', 245631),
(358871, 'PTHR21319:SF0', NULL, NULL, NULL, NULL, 'AND RING FINGER DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G08900)-RELATED', 245631),
(358872, 'PTHR21319:SF39', NULL, NULL, NULL, NULL, 'AMINOACYLTRANSFERASE, E1 UBIQUITIN-ACTIVATING ENZYME-RELATED', 245631),
(358873, 'PTHR21319:SF49', NULL, NULL, NULL, NULL, 'BNAC09G36140D PROTEIN', 245631),
(358874, 'PTHR21319:SF48', NULL, NULL, NULL, NULL, 'BNAA01G26820D PROTEIN', 245631),
(358875, 'PTHR21319:SF58', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RZFP34', 245631),
(358876, 'PTHR21319:SF47', NULL, NULL, NULL, NULL, 'BNAA09G44410D PROTEIN', 245631),
(358877, 'PTHR21319:SF35', NULL, NULL, NULL, NULL, 'CHY ZINC FINGER PROTEIN', 245631),
(358878, 'PTHR21319:SF46', NULL, NULL, NULL, NULL, 'BNAA06G13100D PROTEIN', 245631),
(358879, 'PTHR21319:SF13', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SRFP1', 245631),
(358880, 'PTHR21319:SF12', NULL, NULL, NULL, NULL, 'ZINC FINGER (C3HC4-TYPE RING FINGER) FAMILY PROTEIN', 245631),
(358881, 'PTHR21319:SF56', NULL, NULL, NULL, NULL, '', 245631),
(358882, 'PTHR13608', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 245632),
(358883, 'PTHR13608:SF3', NULL, NULL, NULL, NULL, 'ARMADILLO-LIKE HELICAL DOMAIN-CONTAINING PROTEIN 3', 245632),
(358884, 'PTHR11439', NULL, NULL, NULL, NULL, 'GAG-POL-RELATED RETROTRANSPOSON', 245633),
(358885, 'PTHR11439:SF438', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 245633),
(358886, 'PTHR11439:SF436', NULL, NULL, NULL, NULL, 'RETROTRANSPOSON PROTEIN-RELATED', 245633),
(358887, 'PTHR11439:SF437', NULL, NULL, NULL, NULL, '', 245633),
(358888, 'PTHR37358:SF1', NULL, NULL, NULL, NULL, 'MUCIN-20', 245634),
(358889, 'PTHR37358', NULL, NULL, NULL, NULL, 'MUCIN-20', 245634),
(358890, 'PTHR11070:SF17', NULL, NULL, NULL, NULL, 'DNA HELICASE IV', 245635),
(358891, 'PTHR11070', NULL, NULL, NULL, NULL, 'UVRD / RECB / PCRA DNA HELICASE FAMILY MEMBER', 245635),
(358892, 'PTHR11070:SF46', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE HMI1, MITOCHONDRIAL', 245635),
(358893, 'PTHR11070:SF68', NULL, NULL, NULL, NULL, 'DNA HELICASE', 245635),
(358894, 'PTHR11070:SF48', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT HELICASE/NUCLEASE SUBUNIT A', 245635),
(358895, 'PTHR11070:SF59', NULL, NULL, NULL, NULL, 'DNA HELICASE', 245635),
(358896, 'PTHR11070:SF49', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT HELICASE/DEOXYRIBONUCLEASE SUBUNIT B', 245635),
(358897, 'PTHR11070:SF3', NULL, NULL, NULL, NULL, 'DNA HELICASE', 245635);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(358898, 'PTHR11070:SF64', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE REP', 245635),
(358899, 'PTHR11070:SF2', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE SRS2', 245635),
(358900, 'PTHR11070:SF65', NULL, NULL, NULL, NULL, 'DNA HELICASE', 245635),
(358901, 'PTHR11070:SF66', NULL, NULL, NULL, NULL, 'DNA HELICASE', 245635),
(358902, 'PTHR11070:SF55', NULL, NULL, NULL, NULL, 'DNA HELICASE', 245635),
(358903, 'PTHR11070:SF67', NULL, NULL, NULL, NULL, 'DNA HELICASE', 245635),
(358904, 'PTHR11070:SF45', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE UVRD2', 245635),
(358905, 'PTHR11070:SF23', NULL, NULL, NULL, NULL, 'RECBCD ENZYME SUBUNIT RECB', 245635),
(358906, 'PTHR11070:SF61', NULL, NULL, NULL, NULL, 'DNA HELICASE', 245635),
(358907, 'PTHR11070:SF50', NULL, NULL, NULL, NULL, 'DNA HELICASE', 245635),
(358908, 'PTHR11070:SF30', NULL, NULL, NULL, NULL, 'F-BOX DNA HELICASE 1', 245635),
(358909, 'PTHR11070:SF63', NULL, NULL, NULL, NULL, 'DNA HELICASE IV', 245635),
(358910, 'PTHR22175:SF2', NULL, NULL, NULL, NULL, 'SMALL ACIDIC PROTEIN', 245636),
(358911, 'PTHR22175:SF1', NULL, NULL, NULL, NULL, 'SMALL ACIDIC PROTEIN', 245636),
(358912, 'PTHR22175', NULL, NULL, NULL, NULL, 'SMALL ACIDIC PROTEIN-RELATED', 245636),
(358913, 'PTHR22175:SF0', NULL, NULL, NULL, NULL, 'SMALL ACIDIC PROTEIN', 245636),
(358914, 'PTHR46641:SF17', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245637),
(358915, 'PTHR46641:SF18', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245637),
(358916, 'PTHR46641', NULL, NULL, NULL, NULL, 'FMRFAMIDE RECEPTOR-RELATED', 245637),
(358917, 'PTHR46641:SF20', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245637),
(358918, 'PTHR46641:SF10', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245637),
(358919, 'PTHR46641:SF1', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245637),
(358920, 'PTHR46641:SF22', NULL, NULL, NULL, NULL, 'PROCTOLIN RECEPTOR, ISOFORM A', 245637),
(358921, 'PTHR46641:SF11', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR DAF-37', 245637),
(358922, 'PTHR46641:SF23', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245637),
(358923, 'PTHR46641:SF13', NULL, NULL, NULL, NULL, 'GLOBIN RELATED', 245637),
(358924, 'PTHR46641:SF14', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245637),
(358925, 'PTHR46641:SF15', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245637),
(358926, 'PTHR46641:SF16', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245637),
(358927, 'PTHR46641:SF7', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245637),
(358928, 'PTHR46641:SF6', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245637),
(358929, 'PTHR46641:SF9', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245637),
(358930, 'PTHR46641:SF8', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245637),
(358931, 'PTHR46641:SF2', NULL, NULL, NULL, NULL, 'CNMAMIDE RECEPTOR-RELATED', 245637),
(358932, 'PTHR46641:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG01619', 245637),
(358933, 'PTHR31042:SF138', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING BETA-1,6-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN-RELATED', 245638),
(358934, 'PTHR31042:SF94', NULL, NULL, NULL, NULL, 'BNAC08G41640D PROTEIN', 245638),
(358935, 'PTHR31042:SF137', NULL, NULL, NULL, NULL, '', 245638),
(358936, 'PTHR31042:SF136', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING ENZYME', 245638),
(358937, 'PTHR31042:SF135', NULL, NULL, NULL, NULL, 'BETA-1,6-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN, PUTATIVE-RELATED', 245638),
(358938, 'PTHR31042:SF91', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING BETA-1,6-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 245638),
(358939, 'PTHR31042:SF139', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE, FAMILY 14-RELATED', 245638),
(358940, 'PTHR31042:SF14', NULL, NULL, NULL, NULL, 'OS07G0158800 PROTEIN', 245638);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(358941, 'PTHR31042:SF13', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING BETA-16-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 245638),
(358942, 'PTHR31042:SF134', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING BETA-1,6-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 245638),
(358943, 'PTHR31042:SF98', NULL, NULL, NULL, NULL, '', 245638),
(358944, 'PTHR31042:SF96', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING BETA-1,6-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN-RELATED', 245638),
(358945, 'PTHR31042:SF131', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING BETA-1,6-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 245638),
(358946, 'PTHR31042:SF2', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE BC10', 245638),
(358947, 'PTHR31042:SF19', NULL, NULL, NULL, NULL, 'OS02G0175500 PROTEIN', 245638),
(358948, 'PTHR31042:SF1', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING BETA-16-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 245638),
(358949, 'PTHR31042:SF3', NULL, NULL, NULL, NULL, 'OS08G0110400 PROTEIN', 245638),
(358950, 'PTHR31042', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING BETA-1,6-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN-RELATED', 245638),
(358951, 'PTHR31042:SF8', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING BETA-1,6-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 245638),
(358952, 'PTHR31042:SF84', NULL, NULL, NULL, NULL, '', 245638),
(358953, 'PTHR31042:SF126', NULL, NULL, NULL, NULL, 'BNAA08G25860D PROTEIN', 245638),
(358954, 'PTHR31042:SF125', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING ENZYME', 245638),
(358955, 'PTHR31042:SF81', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING BETA-1,6-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 245638),
(358956, 'PTHR31042:SF82', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING BETA-16-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 245638),
(358957, 'PTHR31042:SF128', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245638),
(358958, 'PTHR31042:SF87', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245638),
(358959, 'PTHR31042:SF123', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE, FAMILY 14-RELATED', 245638),
(358960, 'PTHR31042:SF122', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING ENZYME', 245638),
(358961, 'PTHR31042:SF121', NULL, NULL, NULL, NULL, 'BNAA02G13780D PROTEIN', 245638),
(358962, 'PTHR31042:SF86', NULL, NULL, NULL, NULL, '', 245638),
(358963, 'PTHR31042:SF120', NULL, NULL, NULL, NULL, 'BNAA08G25540D PROTEIN', 245638),
(358964, 'PTHR31042:SF116', NULL, NULL, NULL, NULL, 'OS06G0700500 PROTEIN', 245638),
(358965, 'PTHR31042:SF73', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING BETA-16-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 245638),
(358966, 'PTHR31042:SF70', NULL, NULL, NULL, NULL, 'OS01G0695200 PROTEIN', 245638),
(358967, 'PTHR31042:SF114', NULL, NULL, NULL, NULL, 'BNAC07G42290D PROTEIN', 245638),
(358968, 'PTHR31042:SF71', NULL, NULL, NULL, NULL, '', 245638),
(358969, 'PTHR31042:SF119', NULL, NULL, NULL, NULL, 'BNAC06G41260D PROTEIN', 245638),
(358970, 'PTHR31042:SF118', NULL, NULL, NULL, NULL, '', 245638),
(358971, 'PTHR31042:SF117', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE, FAMILY 14-RELATED', 245638),
(358972, 'PTHR31042:SF76', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING BETA-16-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 245638),
(358973, 'PTHR31042:SF111', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING BETA-1,6-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 245638),
(358974, 'PTHR31042:SF77', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING BETA-1,6-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 245638),
(358975, 'PTHR31042:SF74', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE TY1/COPIA-TYPE DOMAIN-CONTAINING PROTEIN', 245638),
(358976, 'PTHR31042:SF110', NULL, NULL, NULL, NULL, 'BNAA06G38890D PROTEIN', 245638),
(358977, 'PTHR31042:SF75', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING BETA-1,6-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 245638),
(358978, 'PTHR31042:SF61', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING BETA-16-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 245638),
(358979, 'PTHR31042:SF105', NULL, NULL, NULL, NULL, '', 245638);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(358980, 'PTHR31042:SF104', NULL, NULL, NULL, NULL, 'BNAC07G15830D PROTEIN', 245638),
(358981, 'PTHR31042:SF62', NULL, NULL, NULL, NULL, '', 245638),
(358982, 'PTHR31042:SF60', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING ENZYME', 245638),
(358983, 'PTHR31042:SF102', NULL, NULL, NULL, NULL, 'BNAA08G30840D PROTEIN', 245638),
(358984, 'PTHR31042:SF146', NULL, NULL, NULL, NULL, 'TUBULIN DOMAIN-CONTAINING PROTEIN', 245638),
(358985, 'PTHR31042:SF109', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING BETA-1,6-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN-RELATED', 245638),
(358986, 'PTHR31042:SF108', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING ENZYME', 245638),
(358987, 'PTHR31042:SF106', NULL, NULL, NULL, NULL, 'BNAA07G36120D PROTEIN', 245638),
(358988, 'PTHR31042:SF141', NULL, NULL, NULL, NULL, '', 245638),
(358989, 'PTHR31042:SF69', NULL, NULL, NULL, NULL, 'BNAC09G32940D PROTEIN', 245638),
(358990, 'PTHR31042:SF25', NULL, NULL, NULL, NULL, 'OS04G0272400 PROTEIN', 245638),
(358991, 'PTHR31042:SF140', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING BETA-1,6-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 245638),
(358992, 'PTHR31042:SF145', NULL, NULL, NULL, NULL, '', 245638),
(358993, 'PTHR31042:SF101', NULL, NULL, NULL, NULL, 'BNAA10G11330D PROTEIN', 245638),
(358994, 'PTHR31042:SF21', NULL, NULL, NULL, NULL, 'OS01G0875800 PROTEIN', 245638),
(358995, 'PTHR31042:SF144', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE, FAMILY 14-RELATED', 245638),
(358996, 'PTHR31042:SF63', NULL, NULL, NULL, NULL, '', 245638),
(358997, 'PTHR31042:SF143', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING BETA-1,6-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 245638),
(358998, 'PTHR31042:SF142', NULL, NULL, NULL, NULL, 'BNAA09G52890D PROTEIN', 245638),
(358999, 'PTHR31042:SF64', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING BETA-16-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 245638),
(359000, 'PTHR31042:SF20', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING BETA-1,6-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 245638),
(359001, 'PTHR37352:SF1', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC GENE 13 PROTEIN', 245639),
(359002, 'PTHR37352', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC GENE 13 PROTEIN', 245639),
(359003, 'PTHR23118:SF52', NULL, NULL, NULL, NULL, 'ATP CITRATE SYNTHASE', 245640),
(359004, 'PTHR23118:SF51', NULL, NULL, NULL, NULL, 'ATP-CITRATE SYNTHASE', 245640),
(359005, 'PTHR23118', NULL, NULL, NULL, NULL, 'ATP-CITRATE SYNTHASE', 245640),
(359006, 'PTHR23118:SF54', NULL, NULL, NULL, NULL, 'ATP CITRATE SYNTHASE', 245640),
(359007, 'PTHR23118:SF53', NULL, NULL, NULL, NULL, 'ATP CITRATE SYNTHASE', 245640),
(359008, 'PTHR23118:SF42', NULL, NULL, NULL, NULL, 'ATP-CITRATE SYNTHASE', 245640),
(359009, 'PTHR23118:SF56', NULL, NULL, NULL, NULL, 'ATP-CITRATE SYNTHASE BETA CHAIN PROTEIN 1-RELATED', 245640),
(359010, 'PTHR23118:SF55', NULL, NULL, NULL, NULL, 'ATP CITRATE SYNTHASE', 245640),
(359011, 'PTHR23118:SF50', NULL, NULL, NULL, NULL, 'ATP-CITRATE SYNTHASE BETA CHAIN PROTEIN 1', 245640),
(359012, 'PTHR35252', NULL, NULL, NULL, NULL, 'RETINITIS PIGMENTOSA 9 PROTEIN', 245641),
(359013, 'PTHR35252:SF1', NULL, NULL, NULL, NULL, 'RETINITIS PIGMENTOSA 9 PROTEIN', 245641),
(359014, 'PTHR43699', NULL, NULL, NULL, NULL, '3-DEHYDROQUINATE DEHYDRATASE', 245642),
(359015, 'PTHR43699:SF1', NULL, NULL, NULL, NULL, '3-DEHYDROQUINATE DEHYDRATASE', 245642),
(359016, 'PTHR43791:SF43', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245643),
(359017, 'PTHR43791:SF87', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G02730)-RELATED', 245643),
(359018, 'PTHR43791:SF86', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245643),
(359019, 'PTHR43791:SF85', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G00710)-RELATED', 245643),
(359020, 'PTHR43791:SF41', NULL, NULL, NULL, NULL, '', 245643),
(359021, 'PTHR43791:SF48', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G01000)-RELATED', 245643),
(359022, 'PTHR43791:SF47', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245643);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(359023, 'PTHR43791:SF46', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G06290)-RELATED', 245643),
(359024, 'PTHR43791', NULL, NULL, NULL, NULL, 'PERMEASE-RELATED', 245643),
(359025, 'PTHR43791:SF40', NULL, NULL, NULL, NULL, 'THIAMINE PATHWAY TRANSPORTER THI73', 245643),
(359026, 'PTHR43791:SF84', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G09170)-RELATED', 245643),
(359027, 'PTHR43791:SF81', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G01190)-RELATED', 245643),
(359028, 'PTHR43791:SF49', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G04250)-RELATED', 245643),
(359029, 'PTHR43791:SF33', NULL, NULL, NULL, NULL, 'VITAMIN H TRANSPORTER 1', 245643),
(359030, 'PTHR43791:SF32', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245643),
(359031, 'PTHR43791:SF31', NULL, NULL, NULL, NULL, 'VITAMIN H TRANSPORTER', 245643),
(359032, 'PTHR43791:SF75', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G00110)-RELATED', 245643),
(359033, 'PTHR43791:SF30', NULL, NULL, NULL, NULL, 'INNER MEMBRANE TRANSPORT PROTEIN RHMT', 245643),
(359034, 'PTHR43791:SF74', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G17530)-RELATED', 245643),
(359035, 'PTHR43791:SF37', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245643),
(359036, 'PTHR43791:SF36', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G08340)-RELATED', 245643),
(359037, 'PTHR43791:SF79', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE-RELATED', 245643),
(359038, 'PTHR43791:SF35', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245643),
(359039, 'PTHR43791:SF78', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G01370)-RELATED', 245643),
(359040, 'PTHR43791:SF73', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE-RELATED', 245643),
(359041, 'PTHR43791:SF70', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245643),
(359042, 'PTHR43791:SF39', NULL, NULL, NULL, NULL, 'TRANSPORTER LIZ1/SEO1, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G00980)-RELATED', 245643),
(359043, 'PTHR43791:SF38', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245643),
(359044, 'PTHR43791:SF66', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YIHN', 245643),
(359045, 'PTHR43791:SF22', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G11320)-RELATED', 245643),
(359046, 'PTHR43791:SF65', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245643),
(359047, 'PTHR43791:SF21', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245643),
(359048, 'PTHR43791:SF20', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G14670)-RELATED', 245643),
(359049, 'PTHR43791:SF64', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245643),
(359050, 'PTHR43791:SF63', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G02870)-RELATED', 245643),
(359051, 'PTHR43791:SF26', NULL, NULL, NULL, NULL, 'ALLANTOATE TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G09470)-RELATED', 245643),
(359052, 'PTHR43791:SF24', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY NICOTINIC ACID TRANSPORTER', 245643),
(359053, 'PTHR43791:SF1', NULL, NULL, NULL, NULL, 'ALLANTOATE PERMEASE', 245643),
(359054, 'PTHR43791:SF2', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G00120)-RELATED', 245643),
(359055, 'PTHR43791:SF67', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G04010)-RELATED', 245643),
(359056, 'PTHR43791:SF23', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245643),
(359057, 'PTHR43791:SF3', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245643),
(359058, 'PTHR43791:SF4', NULL, NULL, NULL, NULL, 'PANTOTHENATE TRANSPORTER FEN2', 245643),
(359059, 'PTHR43791:SF5', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245643),
(359060, 'PTHR43791:SF6', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G16690)-RELATED', 245643),
(359061, 'PTHR43791:SF7', NULL, NULL, NULL, NULL, '', 245643);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(359062, 'PTHR43791:SF62', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245643),
(359063, 'PTHR43791:SF60', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G17160)-RELATED', 245643),
(359064, 'PTHR43791:SF9', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR-TYPE TRANSPORTER HXNP', 245643),
(359065, 'PTHR43791:SF29', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245643),
(359066, 'PTHR43791:SF28', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE-RELATED', 245643),
(359067, 'PTHR43791:SF27', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G15730)-RELATED', 245643),
(359068, 'PTHR43791:SF99', NULL, NULL, NULL, NULL, 'PERMEASE-RELATED', 245643),
(359069, 'PTHR43791:SF55', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G01820)-RELATED', 245643),
(359070, 'PTHR43791:SF98', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245643),
(359071, 'PTHR43791:SF10', NULL, NULL, NULL, NULL, '', 245643),
(359072, 'PTHR43791:SF54', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245643),
(359073, 'PTHR43791:SF53', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245643),
(359074, 'PTHR43791:SF97', NULL, NULL, NULL, NULL, 'ALLANTOATE TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G14700)-RELATED', 245643),
(359075, 'PTHR43791:SF96', NULL, NULL, NULL, NULL, 'MEMBRANE TRANSPORTER', 245643),
(359076, 'PTHR43791:SF52', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G11820)-RELATED', 245643),
(359077, 'PTHR43791:SF59', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G06550)-RELATED', 245643),
(359078, 'PTHR43791:SF15', NULL, NULL, NULL, NULL, 'TRANSPORTER SEO1-RELATED', 245643),
(359079, 'PTHR43791:SF14', NULL, NULL, NULL, NULL, '', 245643),
(359080, 'PTHR43791:SF58', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G04470)-RELATED', 245643),
(359081, 'PTHR43791:SF57', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245643),
(359082, 'PTHR43791:SF13', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245643),
(359083, 'PTHR43791:SF12', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245643),
(359084, 'PTHR43791:SF91', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245643),
(359085, 'PTHR43791:SF95', NULL, NULL, NULL, NULL, 'ALLANTOATE TRANSPORTER, PUTATIVE-RELATED', 245643),
(359086, 'PTHR43791:SF51', NULL, NULL, NULL, NULL, '', 245643),
(359087, 'PTHR43791:SF50', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G00840)-RELATED', 245643),
(359088, 'PTHR43791:SF93', NULL, NULL, NULL, NULL, 'HIGH AFFINITY CYSTEINE TRANSPORTER', 245643),
(359089, 'PTHR43791:SF92', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245643),
(359090, 'PTHR43791:SF19', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G01812)-RELATED', 245643),
(359091, 'PTHR43791:SF18', NULL, NULL, NULL, NULL, 'NICOTINIC ACID TRANSPORTER TNA1, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G03820)-RELATED', 245643),
(359092, 'PTHR43791:SF16', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G01840)-RELATED', 245643),
(359093, 'PTHR37345:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 107', 245644),
(359094, 'PTHR37345', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 107', 245644),
(359095, 'PTHR34190', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245645),
(359096, 'PTHR34190:SF3', NULL, NULL, NULL, NULL, 'MICROSPORE-SPECIFIC PROMOTER 2', 245645),
(359097, 'PTHR34190:SF10', NULL, NULL, NULL, NULL, '', 245645),
(359098, 'PTHR34190:SF4', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245645),
(359099, 'PTHR34190:SF9', NULL, NULL, NULL, NULL, '', 245645),
(359100, 'PTHR34190:SF12', NULL, NULL, NULL, NULL, 'BNAA02G24680D PROTEIN', 245645),
(359101, 'PTHR45866:SF4', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE 4 SUBUNIT B', 245646),
(359102, 'PTHR45866', NULL, NULL, NULL, NULL, 'DNA GYRASE/TOPOISOMERASE SUBUNIT B', 245646),
(359103, 'PTHR45866:SF7', NULL, NULL, NULL, NULL, 'DNA GYRASE SUBUNIT B, CHLOROPLASTIC', 245646);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(359104, 'PTHR45866:SF1', NULL, NULL, NULL, NULL, 'DNA GYRASE SUBUNIT B, MITOCHONDRIAL', 245646),
(359105, 'PTHR45866:SF11', NULL, NULL, NULL, NULL, 'DNA GYRASE SUBUNIT B', 245646),
(359106, 'PTHR45866:SF2', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE (ATP-HYDROLYZING)', 245646),
(359107, 'PTHR45866:SF12', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE 4 SUBUNIT B', 245646),
(359108, 'PTHR36803', NULL, NULL, NULL, NULL, 'PROTEIN CHLORORESPIRATORY REDUCTION 7, CHLOROPLASTIC', 245647),
(359109, 'PTHR36803:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CHLORORESPIRATORY REDUCTION 7, CHLOROPLASTIC', 245647),
(359110, 'PTHR35479', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', 245648),
(359111, 'PTHR35479:SF6', NULL, NULL, NULL, NULL, 'BNAA05G11280D PROTEIN', 245648),
(359112, 'PTHR35479:SF4', NULL, NULL, NULL, NULL, 'OS01G0750800 PROTEIN', 245648),
(359113, 'PTHR43627', NULL, NULL, NULL, NULL, '', 245649),
(359114, 'PTHR43627:SF1', NULL, NULL, NULL, NULL, 'COBALT TRANSPORT PROTEIN CBIM', 245649),
(359115, 'PTHR10155:SF18', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF CYTOKINE-SIGNALING 9', 245650),
(359116, 'PTHR10155:SF31', NULL, NULL, NULL, NULL, 'SH2 DOMAIN-CONTAINING PROTEIN', 245650),
(359117, 'PTHR10155:SF30', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF CYTOKINE SIGNALLING 1-LIKE PROTEIN', 245650),
(359118, 'PTHR10155:SF15', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF CYTOKINE SIGNALING 5', 245650),
(359119, 'PTHR10155:SF16', NULL, NULL, NULL, NULL, 'SH2 DOMAIN-CONTAINING PROTEIN', 245650),
(359120, 'PTHR10155:SF33', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF CYTOKINE SIGNALING 5-RELATED', 245650),
(359121, 'PTHR10155:SF11', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF CYTOKINE SIGNALING 3', 245650),
(359122, 'PTHR10155:SF10', NULL, NULL, NULL, NULL, 'PI3K21B, ISOFORM B', 245650),
(359123, 'PTHR10155:SF32', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF CYTOKINE SIGNALING AT 16D, ISOFORM B', 245650),
(359124, 'PTHR10155:SF35', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF CYTOKINE SIGNALING 4', 245650),
(359125, 'PTHR10155:SF34', NULL, NULL, NULL, NULL, 'LP02169P', 245650),
(359126, 'PTHR10155:SF7', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF CYTOKINE SIGNALING 2', 245650),
(359127, 'PTHR10155:SF6', NULL, NULL, NULL, NULL, 'SRC-LIKE-ADAPTER 2', 245650),
(359128, 'PTHR10155:SF5', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF CYTOKINE SIGNALING 7', 245650),
(359129, 'PTHR10155:SF4', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF CYTOKINE SIGNALING 1', 245650),
(359130, 'PTHR10155:SF3', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 3-KINASE REGULATORY SUBUNIT ALPHA', 245650),
(359131, 'PTHR10155:SF29', NULL, NULL, NULL, NULL, 'CYTOKINE-INDUCIBLE SH2-CONTAINING PROTEIN', 245650),
(359132, 'PTHR10155:SF2', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 3-KINASE REGULATORY SUBUNIT GAMMA', 245650),
(359133, 'PTHR10155:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 3-KINASE REGULATORY SUBUNIT BETA', 245650),
(359134, 'PTHR10155:SF0', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF CYTOKINE SIGNALING AT 36E, ISOFORM D', 245650),
(359135, 'PTHR10155', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 3-KINASE REGULATORY SUBUNIT', 245650),
(359136, 'PTHR10155:SF28', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF CYTOKINE SIGNALING 6', 245650),
(359137, 'PTHR10155:SF27', NULL, NULL, NULL, NULL, 'PIK3R3 UPSTREAM OPEN READING FRAME PROTEIN', 245650),
(359138, 'PTHR10155:SF21', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF CYTOKINE SIGNALING 4', 245650),
(359139, 'PTHR10155:SF9', NULL, NULL, NULL, NULL, 'CYTOKINE-INDUCIBLE SH2-CONTAINING PROTEIN', 245650),
(359140, 'PTHR42087:SF1', NULL, NULL, NULL, NULL, '', 245651),
(359141, 'PTHR42087', NULL, NULL, NULL, NULL, '', 245651),
(359142, 'PTHR42087:SF2', NULL, NULL, NULL, NULL, '', 245651),
(359143, 'PTHR26374:SF360', NULL, NULL, NULL, NULL, 'C2H2 TYPE ZINC FINGER TRANSCRIPTION FACTOR FAMILY PROTEIN', 245652),
(359144, 'PTHR26374:SF431', NULL, NULL, NULL, NULL, 'ZINC FINGER C2H2-TYPE/INTEGRASE DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 245652),
(359145, 'PTHR26374:SF430', NULL, NULL, NULL, NULL, 'OS09G0122000 PROTEIN', 245652),
(359146, 'PTHR26374:SF352', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZAT12-LIKE', 245652);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(359147, 'PTHR26374:SF396', NULL, NULL, NULL, NULL, 'BNAC09G50520D PROTEIN', 245652),
(359148, 'PTHR26374:SF395', NULL, NULL, NULL, NULL, 'BNAA03G17210D PROTEIN', 245652),
(359149, 'PTHR26374:SF435', NULL, NULL, NULL, NULL, 'ZINC FINGER, C2H2-LIKE PROTEIN-RELATED', 245652),
(359150, 'PTHR26374:SF432', NULL, NULL, NULL, NULL, 'OS01G0838600 PROTEIN', 245652),
(359151, 'PTHR26374:SF399', NULL, NULL, NULL, NULL, 'OS03G0698300 PROTEIN', 245652),
(359152, 'PTHR26374:SF439', NULL, NULL, NULL, NULL, 'BNAC02G03060D PROTEIN', 245652),
(359153, 'PTHR26374:SF438', NULL, NULL, NULL, NULL, 'C2H2-TYPE ZINC FINGER PROTEIN', 245652),
(359154, 'PTHR26374:SF437', NULL, NULL, NULL, NULL, 'C2H2-TYPE ZINC FINGER PROTEIN', 245652),
(359155, 'PTHR26374:SF436', NULL, NULL, NULL, NULL, 'C2H2-TYPE ZINC FINGER FAMILY PROTEIN', 245652),
(359156, 'PTHR26374:SF359', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZAT5-LIKE', 245652),
(359157, 'PTHR26374:SF394', NULL, NULL, NULL, NULL, 'BNAC07G49780D PROTEIN', 245652),
(359158, 'PTHR26374:SF393', NULL, NULL, NULL, NULL, 'BNAANNG17660D PROTEIN', 245652),
(359159, 'PTHR26374:SF420', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZAT12-LIKE', 245652),
(359160, 'PTHR26374:SF342', NULL, NULL, NULL, NULL, 'OS05G0461200 PROTEIN', 245652),
(359161, 'PTHR26374:SF385', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZAT11', 245652),
(359162, 'PTHR26374:SF341', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 245652),
(359163, 'PTHR26374:SF384', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZAT12', 245652),
(359164, 'PTHR26374:SF424', NULL, NULL, NULL, NULL, 'BNAA02G06790D PROTEIN', 245652),
(359165, 'PTHR26374:SF423', NULL, NULL, NULL, NULL, 'GATA ZINC FINGER DOMAIN-CONTAINING PROTEIN 15-LIKE', 245652),
(359166, 'PTHR26374:SF345', NULL, NULL, NULL, NULL, 'C2H2-TYPE ZINC FINGER FAMILY PROTEIN', 245652),
(359167, 'PTHR26374:SF421', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZAT5', 245652),
(359168, 'PTHR26374:SF388', NULL, NULL, NULL, NULL, 'C2H2-TYPE ZINC FINGER FAMILY PROTEIN-RELATED', 245652),
(359169, 'PTHR26374:SF427', NULL, NULL, NULL, NULL, 'BNAC04G27120D PROTEIN', 245652),
(359170, 'PTHR26374:SF426', NULL, NULL, NULL, NULL, 'C2H2-TYPE ZINC FINGER PROTEIN', 245652),
(359171, 'PTHR26374:SF425', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN, PUTATIVE-RELATED', 245652),
(359172, 'PTHR26374:SF429', NULL, NULL, NULL, NULL, '', 245652),
(359173, 'PTHR26374:SF383', NULL, NULL, NULL, NULL, 'C2H2-TYPE ZINC FINGER FAMILY PROTEIN', 245652),
(359174, 'PTHR26374:SF380', NULL, NULL, NULL, NULL, 'C2H2-TYPE ZINC FINGER FAMILY PROTEIN-RELATED', 245652),
(359175, 'PTHR26374:SF376', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZAT11-LIKE', 245652),
(359176, 'PTHR26374:SF375', NULL, NULL, NULL, NULL, 'ZPT2-13', 245652),
(359177, 'PTHR26374:SF331', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 245652),
(359178, 'PTHR26374:SF374', NULL, NULL, NULL, NULL, '', 245652),
(359179, 'PTHR26374:SF450', NULL, NULL, NULL, NULL, 'C2H2 TRANSCRIPTION FACTOR', 245652),
(359180, 'PTHR26374:SF413', NULL, NULL, NULL, NULL, 'ZINC FINGER C2H2-TYPE/INTEGRASE DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 245652),
(359181, 'PTHR26374:SF379', NULL, NULL, NULL, NULL, 'OS05G0114400 PROTEIN', 245652),
(359182, 'PTHR26374:SF378', NULL, NULL, NULL, NULL, 'C2H2-TYPE ZINC FINGER FAMILY PROTEIN', 245652),
(359183, 'PTHR26374:SF410', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZAT5-LIKE', 245652),
(359184, 'PTHR26374:SF339', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZAT8-LIKE', 245652),
(359185, 'PTHR26374:SF416', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 245652),
(359186, 'PTHR26374:SF338', NULL, NULL, NULL, NULL, 'BNAA05G28380D PROTEIN', 245652),
(359187, 'PTHR26374:SF414', NULL, NULL, NULL, NULL, 'C2H2-TYPE ZINC FINGER PROTEIN', 245652),
(359188, 'PTHR26374:SF418', NULL, NULL, NULL, NULL, 'C2H2 TRANSCRIPTION FACTOR', 245652),
(359189, 'PTHR26374:SF171', NULL, NULL, NULL, NULL, 'OS11G0702400 PROTEIN', 245652),
(359190, 'PTHR26374:SF442', NULL, NULL, NULL, NULL, 'C2H2-TYPE ZINC FINGER FAMILY PROTEIN-RELATED', 245652);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(359191, 'PTHR26374:SF441', NULL, NULL, NULL, NULL, 'OS11G0702300 PROTEIN', 245652),
(359192, 'PTHR26374:SF440', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZAT11', 245652),
(359193, 'PTHR26374', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZAT5', 245652),
(359194, 'PTHR26374:SF362', NULL, NULL, NULL, NULL, 'C2H2 ZINC FINGER PROTEIN', 245652),
(359195, 'PTHR26374:SF402', NULL, NULL, NULL, NULL, 'ZPT2-12', 245652),
(359196, 'PTHR26374:SF446', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 245652),
(359197, 'PTHR26374:SF445', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZAT18', 245652),
(359198, 'PTHR26374:SF444', NULL, NULL, NULL, NULL, 'BNAA04G16610D PROTEIN', 245652),
(359199, 'PTHR26374:SF400', NULL, NULL, NULL, NULL, 'BNAA03G00910D PROTEIN', 245652),
(359200, 'PTHR26374:SF443', NULL, NULL, NULL, NULL, 'OS01G0839100 PROTEIN', 245652),
(359201, 'PTHR26374:SF366', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 245652),
(359202, 'PTHR26374:SF449', NULL, NULL, NULL, NULL, 'CYS2-HIS2 ZINC FINGER TRANSCRIPTION FACTOR', 245652),
(359203, 'PTHR26374:SF448', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZAT5-LIKE', 245652),
(359204, 'PTHR26374:SF403', NULL, NULL, NULL, NULL, 'C2H2 AND C2HC ZINC FINGERS SUPERFAMILY PROTEIN-RELATED', 245652),
(359205, 'PTHR26374:SF447', NULL, NULL, NULL, NULL, 'OS02G0823900 PROTEIN', 245652),
(359206, 'PTHR26374:SF409', NULL, NULL, NULL, NULL, '', 245652),
(359207, 'PTHR26374:SF408', NULL, NULL, NULL, NULL, 'ZINC FINGER, C2H2-LIKE PROTEIN-RELATED', 245652),
(359208, 'PTHR26374:SF407', NULL, NULL, NULL, NULL, 'ZINC FINGER, C2H2-LIKE PROTEIN-RELATED', 245652),
(359209, 'PTHR21708:SF42', NULL, NULL, NULL, NULL, '2-DEHYDROPANTOATE 2-REDUCTASE', 245653),
(359210, 'PTHR21708:SF30', NULL, NULL, NULL, NULL, '2-REDUCTASE FAMILY PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G00740)-RELATED', 245653),
(359211, 'PTHR21708:SF44', NULL, NULL, NULL, NULL, 'MEIOTICALLY UP-REGULATED GENE 72 PROTEIN', 245653),
(359212, 'PTHR21708:SF43', NULL, NULL, NULL, NULL, 'APBA_C DOMAIN-CONTAINING PROTEIN', 245653),
(359213, 'PTHR21708:SF34', NULL, NULL, NULL, NULL, 'OUTER SPORE WALL PROTEIN 2', 245653),
(359214, 'PTHR21708:SF26', NULL, NULL, NULL, NULL, '2-DEHYDROPANTOATE 2-REDUCTASE', 245653),
(359215, 'PTHR21708:SF25', NULL, NULL, NULL, NULL, 'PROTEIN PAM1-RELATED', 245653),
(359216, 'PTHR21708', NULL, NULL, NULL, NULL, 'PROBABLE 2-DEHYDROPANTOATE 2-REDUCTASE', 245653),
(359217, 'PTHR21708:SF40', NULL, NULL, NULL, NULL, 'REDUCTASE FAMILY PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G14497)-RELATED', 245653),
(359218, 'PTHR43448', NULL, NULL, NULL, NULL, 'PROTOHEME IX FARNESYLTRANSFERASE, MITOCHONDRIAL', 245654),
(359219, 'PTHR43448:SF2', NULL, NULL, NULL, NULL, 'PROTOHEME IX FARNESYLTRANSFERASE, MITOCHONDRIAL', 245654),
(359220, 'PTHR43448:SF7', NULL, NULL, NULL, NULL, '4-HYDROXYBENZOATE SOLANESYLTRANSFERASE', 245654),
(359221, 'PTHR43448:SF8', NULL, NULL, NULL, NULL, 'HEME O SYNTHASE', 245654),
(359222, 'PTHR47918', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN FIS', 245655),
(359223, 'PTHR47918:SF1', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN FIS', 245655),
(359224, 'PTHR16008', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 4', 245656),
(359225, 'PTHR16008:SF4', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 4', 245656),
(359226, 'PTHR16008:SF6', NULL, NULL, NULL, NULL, 'SI:DKEY-12E7.1', 245656),
(359227, 'PTHR38937', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN OF ER BODY-LIKE PROTEIN', 245657),
(359228, 'PTHR38937:SF2', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN OF ER BODY-LIKE PROTEIN ISOFORM X1', 245657),
(359229, 'PTHR33136:SF90', NULL, NULL, NULL, NULL, 'OS10G0328900 PROTEIN', 245658),
(359230, 'PTHR33136:SF108', NULL, NULL, NULL, NULL, 'RALF-LIKE 4-RELATED', 245658),
(359231, 'PTHR33136:SF109', NULL, NULL, NULL, NULL, 'PROTEIN RALF-LIKE 1', 245658),
(359232, 'PTHR33136:SF106', NULL, NULL, NULL, NULL, 'RALF-LIKE 22-RELATED', 245658),
(359233, 'PTHR33136:SF107', NULL, NULL, NULL, NULL, 'RAPID ALKALINIZATION FACTOR', 245658),
(359234, 'PTHR33136:SF6', NULL, NULL, NULL, NULL, 'PROTEIN RALF-LIKE 34', 245658);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(359235, 'PTHR33136:SF100', NULL, NULL, NULL, NULL, 'PROTEIN RALF-LIKE 33', 245658),
(359236, 'PTHR33136:SF101', NULL, NULL, NULL, NULL, 'PROTEIN RALF-LIKE 33', 245658),
(359237, 'PTHR33136:SF4', NULL, NULL, NULL, NULL, 'PROTEIN RALF-LIKE 32', 245658),
(359238, 'PTHR33136:SF46', NULL, NULL, NULL, NULL, 'BNAA08G07510D PROTEIN', 245658),
(359239, 'PTHR33136:SF104', NULL, NULL, NULL, NULL, 'RAPID ALKALINIZATION FACTOR-RELATED', 245658),
(359240, 'PTHR33136:SF89', NULL, NULL, NULL, NULL, 'PROTEIN RALF-LIKE 19', 245658),
(359241, 'PTHR33136:SF105', NULL, NULL, NULL, NULL, '', 245658),
(359242, 'PTHR33136:SF48', NULL, NULL, NULL, NULL, 'PROTEIN RALF-LIKE 14-RELATED', 245658),
(359243, 'PTHR33136:SF102', NULL, NULL, NULL, NULL, 'RAPID ALKALINIZATION FACTOR-RELATED', 245658),
(359244, 'PTHR33136:SF103', NULL, NULL, NULL, NULL, 'OS07G0238000 PROTEIN', 245658),
(359245, 'PTHR33136:SF64', NULL, NULL, NULL, NULL, 'BNAANNG39730D PROTEIN', 245658),
(359246, 'PTHR33136:SF86', NULL, NULL, NULL, NULL, 'BNAC05G01530D PROTEIN', 245658),
(359247, 'PTHR33136:SF42', NULL, NULL, NULL, NULL, 'RALF', 245658),
(359248, 'PTHR33136:SF66', NULL, NULL, NULL, NULL, 'PROTEIN RALF-LIKE 22', 245658),
(359249, 'PTHR33136:SF44', NULL, NULL, NULL, NULL, 'PROTEIN RALF-LIKE 33', 245658),
(359250, 'PTHR33136:SF88', NULL, NULL, NULL, NULL, 'BNAA03G57580D PROTEIN', 245658),
(359251, 'PTHR33136:SF43', NULL, NULL, NULL, NULL, 'PROTEIN RALF-LIKE 24', 245658),
(359252, 'PTHR33136:SF65', NULL, NULL, NULL, NULL, 'RALFL33', 245658),
(359253, 'PTHR33136:SF82', NULL, NULL, NULL, NULL, 'RALF', 245658),
(359254, 'PTHR33136:SF60', NULL, NULL, NULL, NULL, '', 245658),
(359255, 'PTHR33136:SF81', NULL, NULL, NULL, NULL, '', 245658),
(359256, 'PTHR33136:SF40', NULL, NULL, NULL, NULL, 'BNAA09G27400D PROTEIN', 245658),
(359257, 'PTHR33136:SF80', NULL, NULL, NULL, NULL, 'BNACNNG23920D PROTEIN', 245658),
(359258, 'PTHR33136:SF111', NULL, NULL, NULL, NULL, 'PROTEIN RALF-LIKE 22', 245658),
(359259, 'PTHR33136:SF39', NULL, NULL, NULL, NULL, 'BNAA05G31730D PROTEIN', 245658),
(359260, 'PTHR33136:SF110', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 245658),
(359261, 'PTHR33136:SF79', NULL, NULL, NULL, NULL, 'PROTEIN RALF-LIKE 4', 245658),
(359262, 'PTHR33136:SF13', NULL, NULL, NULL, NULL, 'OS01G0357900 PROTEIN', 245658),
(359263, 'PTHR33136:SF34', NULL, NULL, NULL, NULL, 'OS12G0541700 PROTEIN', 245658),
(359264, 'PTHR33136:SF58', NULL, NULL, NULL, NULL, 'OS03G0345000 PROTEIN', 245658),
(359265, 'PTHR33136:SF36', NULL, NULL, NULL, NULL, 'PROTEIN RALF-LIKE 31', 245658),
(359266, 'PTHR33136:SF52', NULL, NULL, NULL, NULL, 'BNAC05G36680D PROTEIN', 245658),
(359267, 'PTHR33136:SF74', NULL, NULL, NULL, NULL, 'BNAC03G58480D PROTEIN', 245658),
(359268, 'PTHR33136:SF32', NULL, NULL, NULL, NULL, 'PROTEIN RALF-LIKE 33', 245658),
(359269, 'PTHR33136:SF76', NULL, NULL, NULL, NULL, 'PROTEIN RALF-LIKE 34', 245658),
(359270, 'PTHR33136:SF93', NULL, NULL, NULL, NULL, 'RAPID ALKALINIZATION FACTOR-RELATED', 245658),
(359271, 'PTHR33136', NULL, NULL, NULL, NULL, 'RAPID ALKALINIZATION FACTOR-LIKE', 245658),
(359272, 'PTHR33136:SF70', NULL, NULL, NULL, NULL, 'RAPID ALKALINIZATION FACTOR-RELATED', 245658),
(359273, 'PTHR33136:SF95', NULL, NULL, NULL, NULL, 'PROTEIN RALF-LIKE 33-RELATED', 245658),
(359274, 'PTHR33136:SF72', NULL, NULL, NULL, NULL, 'BNAA09G03850D PROTEIN', 245658),
(359275, 'PTHR47955', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 71 PROTEIN', 245659),
(359276, 'PTHR47955:SF7', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A1-LIKE', 245659),
(359277, 'PTHR47955:SF5', NULL, NULL, NULL, NULL, 'PREMNASPIRODIENE OXYGENASE-LIKE', 245659),
(359278, 'PTHR47955:SF6', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A2-LIKE ISOFORM X1', 245659),
(359279, 'PTHR47955:SF4', NULL, NULL, NULL, NULL, 'OS01G0543600 PROTEIN', 245659),
(359280, 'PTHR47955:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 71 PROTEIN', 245659),
(359281, 'PTHR47753:SF2', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 245660),
(359282, 'PTHR47753:SF1', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN-RELATED', 245660);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(359283, 'PTHR47753:SF4', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 245660),
(359284, 'PTHR47753:SF3', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN', 245660),
(359285, 'PTHR47753', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN-RELATED', 245660),
(359286, 'PTHR13980:SF19', NULL, NULL, NULL, NULL, 'FACT COMPLEX SUBUNIT', 245661),
(359287, 'PTHR13980:SF17', NULL, NULL, NULL, NULL, 'FACT COMPLEX SUBUNIT SPT16', 245661),
(359288, 'PTHR13980:SF18', NULL, NULL, NULL, NULL, 'FACT COMPLEX SUBUNIT SPT16', 245661),
(359289, 'PTHR13980:SF15', NULL, NULL, NULL, NULL, 'FACT COMPLEX SUBUNIT SPT16', 245661),
(359290, 'PTHR13980:SF16', NULL, NULL, NULL, NULL, 'FACT COMPLEX SUBUNIT', 245661),
(359291, 'PTHR13980:SF22', NULL, NULL, NULL, NULL, 'FACT COMPLEX SUBUNIT', 245661),
(359292, 'PTHR13980:SF23', NULL, NULL, NULL, NULL, 'FACT COMPLEX SUBUNIT', 245661),
(359293, 'PTHR13980:SF21', NULL, NULL, NULL, NULL, 'FACT COMPLEX SUBUNIT', 245661),
(359294, 'PTHR13980', NULL, NULL, NULL, NULL, 'CDC68 RELATED', 245661),
(359295, 'PTHR11461:SF306', NULL, NULL, NULL, NULL, 'SERPIN-Z1', 245662),
(359296, 'PTHR11461:SF304', NULL, NULL, NULL, NULL, 'SERPIN-Z10-RELATED', 245662),
(359297, 'PTHR11461:SF84', NULL, NULL, NULL, NULL, 'PIGMENT EPITHELIUM-DERIVED FACTOR', 245662),
(359298, 'PTHR11461:SF301', NULL, NULL, NULL, NULL, 'SERPIN DOMAIN-CONTAINING PROTEIN', 245662),
(359299, 'PTHR11461:SF146', NULL, NULL, NULL, NULL, 'SERPIN DOMAIN-CONTAINING PROTEIN', 245662),
(359300, 'PTHR11461:SF300', NULL, NULL, NULL, NULL, 'SERPIN DOMAIN-CONTAINING PROTEIN', 245662),
(359301, 'PTHR11461:SF145', NULL, NULL, NULL, NULL, 'ALPHA-1-ANTICHYMOTRYPSIN', 245662),
(359302, 'PTHR11461:SF317', NULL, NULL, NULL, NULL, 'SERPIN-Z1C', 245662),
(359303, 'PTHR11461:SF316', NULL, NULL, NULL, NULL, 'SERPIN DOMAIN-CONTAINING PROTEIN', 245662),
(359304, 'PTHR11461:SF315', NULL, NULL, NULL, NULL, 'SERPIN-ZXA-LIKE', 245662),
(359305, 'PTHR11461:SF314', NULL, NULL, NULL, NULL, 'SERPIN-ZX-LIKE', 245662),
(359306, 'PTHR11461:SF159', NULL, NULL, NULL, NULL, 'PLASMA PROTEASE C1 INHIBITOR', 245662),
(359307, 'PTHR11461:SF313', NULL, NULL, NULL, NULL, 'SERPIN DOMAIN-CONTAINING PROTEIN', 245662),
(359308, 'PTHR11461:SF312', NULL, NULL, NULL, NULL, 'SERPIN-Z1', 245662),
(359309, 'PTHR11461:SF157', NULL, NULL, NULL, NULL, 'SERPIN A12', 245662),
(359310, 'PTHR11461:SF311', NULL, NULL, NULL, NULL, 'SERPIN-Z8-RELATED', 245662),
(359311, 'PTHR11461:SF278', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR 88EA', 245662),
(359312, 'PTHR11461:SF310', NULL, NULL, NULL, NULL, 'SERPIN DOMAIN-CONTAINING PROTEIN', 245662),
(359313, 'PTHR11461:SF154', NULL, NULL, NULL, NULL, 'SERPIN A11', 245662),
(359314, 'PTHR11461:SF274', NULL, NULL, NULL, NULL, 'PLASMA SERINE PROTEASE INHIBITOR', 245662),
(359315, 'PTHR11461:SF160', NULL, NULL, NULL, NULL, 'SERINE (OR CYSTEINE) PEPTIDASE INHIBITOR, CLADE A (ALPHA-1 ANTIPROTEINASE, ANTITRYPSIN), MEMBER 16', 245662),
(359316, 'PTHR11461', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR, SERPIN', 245662),
(359317, 'PTHR11461:SF209', NULL, NULL, NULL, NULL, 'SERPIN-Z2A', 245662),
(359318, 'PTHR11461:SF329', NULL, NULL, NULL, NULL, 'SERPIN DOMAIN-CONTAINING PROTEIN', 245662),
(359319, 'PTHR11461:SF328', NULL, NULL, NULL, NULL, 'SERPIN DOMAIN-CONTAINING PROTEIN', 245662),
(359320, 'PTHR11461:SF327', NULL, NULL, NULL, NULL, 'SERPIN-ZX-LIKE', 245662),
(359321, 'PTHR11461:SF326', NULL, NULL, NULL, NULL, 'SERPIN-ZX-LIKE', 245662),
(359322, 'PTHR11461:SF325', NULL, NULL, NULL, NULL, 'SERPIN DOMAIN-CONTAINING PROTEIN', 245662),
(359323, 'PTHR11461:SF204', NULL, NULL, NULL, NULL, 'SERPIN B6', 245662),
(359324, 'PTHR11461:SF203', NULL, NULL, NULL, NULL, 'SERPIN-Z12-RELATED', 245662),
(359325, 'PTHR11461:SF324', NULL, NULL, NULL, NULL, 'SERPIN DOMAIN-CONTAINING PROTEIN', 245662),
(359326, 'PTHR11461:SF323', NULL, NULL, NULL, NULL, 'SERPIN DOMAIN-CONTAINING PROTEIN', 245662),
(359327, 'PTHR11461:SF61', NULL, NULL, NULL, NULL, 'PLASMINOGEN ACTIVATOR INHIBITOR 2', 245662),
(359328, 'PTHR11461:SF322', NULL, NULL, NULL, NULL, 'SERPIN DOMAIN-CONTAINING PROTEIN', 245662);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(359329, 'PTHR11461:SF289', NULL, NULL, NULL, NULL, 'ALPHA-1-ANTITRYPSIN-RELATED PROTEIN-RELATED', 245662),
(359330, 'PTHR11461:SF321', NULL, NULL, NULL, NULL, 'SERPIN-Z1', 245662),
(359331, 'PTHR11461:SF166', NULL, NULL, NULL, NULL, 'SERPIN B8', 245662),
(359332, 'PTHR11461:SF320', NULL, NULL, NULL, NULL, 'SERPIN B3', 245662),
(359333, 'PTHR11461:SF286', NULL, NULL, NULL, NULL, 'NON-INHIBITORY SERPIN-Z11-RELATED', 245662),
(359334, 'PTHR11461:SF165', NULL, NULL, NULL, NULL, 'ALPHA-1-ANTITRYPSIN', 245662),
(359335, 'PTHR11461:SF164', NULL, NULL, NULL, NULL, 'UTEROFERRIN-ASSOCIATED PROTEIN', 245662),
(359336, 'PTHR11461:SF161', NULL, NULL, NULL, NULL, 'SERPIN B13', 245662),
(359337, 'PTHR11461:SF292', NULL, NULL, NULL, NULL, 'SERPIN 100A', 245662),
(359338, 'PTHR11461:SF290', NULL, NULL, NULL, NULL, 'SERINE (OR CYSTEINE) PEPTIDASE INHIBITOR, CLADE H, MEMBER 2', 245662),
(359339, 'PTHR11461:SF56', NULL, NULL, NULL, NULL, 'SERPIN B7', 245662),
(359340, 'PTHR11461:SF339', NULL, NULL, NULL, NULL, 'SERPIN DOMAIN-CONTAINING PROTEIN', 245662),
(359341, 'PTHR11461:SF338', NULL, NULL, NULL, NULL, 'SERPIN DOMAIN-CONTAINING PROTEIN', 245662),
(359342, 'PTHR11461:SF55', NULL, NULL, NULL, NULL, 'SERPIN B5', 245662),
(359343, 'PTHR11461:SF53', NULL, NULL, NULL, NULL, 'ANTITHROMBIN-III', 245662),
(359344, 'PTHR11461:SF336', NULL, NULL, NULL, NULL, 'SERPIN-Z5-RELATED', 245662),
(359345, 'PTHR11461:SF334', NULL, NULL, NULL, NULL, 'SERPIN DOMAIN-CONTAINING PROTEIN', 245662),
(359346, 'PTHR11461:SF51', NULL, NULL, NULL, NULL, 'SERPIN I2', 245662),
(359347, 'PTHR11461:SF50', NULL, NULL, NULL, NULL, 'NEUROSERPIN', 245662),
(359348, 'PTHR11461:SF211', NULL, NULL, NULL, NULL, 'ACCESSORY GLAND PROTEIN ACP76A-RELATED', 245662),
(359349, 'PTHR11461:SF299', NULL, NULL, NULL, NULL, 'SERPIN DOMAIN-CONTAINING PROTEIN', 245662),
(359350, 'PTHR11461:SF332', NULL, NULL, NULL, NULL, 'SERPIN DOMAIN-CONTAINING PROTEIN', 245662),
(359351, 'PTHR11461:SF330', NULL, NULL, NULL, NULL, 'OS05G0511800 PROTEIN', 245662),
(359352, 'PTHR11461:SF296', NULL, NULL, NULL, NULL, 'SERPIN-RELATED', 245662),
(359353, 'PTHR11461:SF175', NULL, NULL, NULL, NULL, 'SERPIN B10', 245662),
(359354, 'PTHR11461:SF180', NULL, NULL, NULL, NULL, 'LEUKOCYTE ELASTASE INHIBITOR', 245662),
(359355, 'PTHR11461:SF347', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR (SERPIN) FAMILY PROTEIN-RELATED', 245662),
(359356, 'PTHR11461:SF346', NULL, NULL, NULL, NULL, 'SERPIN DOMAIN-CONTAINING PROTEIN', 245662),
(359357, 'PTHR11461:SF40', NULL, NULL, NULL, NULL, 'SERPIN A9', 245662),
(359358, 'PTHR11461:SF189', NULL, NULL, NULL, NULL, 'NON-INHIBITORY SERPIN-Z9-RELATED', 245662),
(359359, 'PTHR11461:SF342', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR 28DC', 245662),
(359360, 'PTHR11461:SF340', NULL, NULL, NULL, NULL, 'SERPIN DOMAIN-CONTAINING PROTEIN', 245662),
(359361, 'PTHR11461:SF186', NULL, NULL, NULL, NULL, 'SERPIN B4', 245662),
(359362, 'PTHR11461:SF191', NULL, NULL, NULL, NULL, 'PROTEIN Z-DEPENDENT PROTEASE INHIBITOR', 245662),
(359363, 'PTHR11461:SF49', NULL, NULL, NULL, NULL, 'PLASMINOGEN ACTIVATOR INHIBITOR 1', 245662),
(359364, 'PTHR11461:SF48', NULL, NULL, NULL, NULL, 'GLIA-DERIVED NEXIN', 245662),
(359365, 'PTHR11461:SF34', NULL, NULL, NULL, NULL, 'CORTICOSTEROID-BINDING GLOBULIN', 245662),
(359366, 'PTHR11461:SF32', NULL, NULL, NULL, NULL, 'ALPHA-1-ANTITRYPSIN 1-6', 245662),
(359367, 'PTHR11461:SF30', NULL, NULL, NULL, NULL, 'HEPARIN COFACTOR 2', 245662),
(359368, 'PTHR11461:SF357', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR 27A', 245662),
(359369, 'PTHR11461:SF199', NULL, NULL, NULL, NULL, 'SERPIN B11', 245662),
(359370, 'PTHR11461:SF352', NULL, NULL, NULL, NULL, 'SERPIN DOMAIN-CONTAINING PROTEIN', 245662),
(359371, 'PTHR11461:SF350', NULL, NULL, NULL, NULL, 'SERPIN B9', 245662),
(359372, 'PTHR11461:SF195', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR A3A-RELATED', 245662),
(359373, 'PTHR11461:SF194', NULL, NULL, NULL, NULL, 'KALLISTATIN', 245662),
(359374, 'PTHR11461:SF129', NULL, NULL, NULL, NULL, 'SERPIN E3', 245662),
(359375, 'PTHR11461:SF128', NULL, NULL, NULL, NULL, 'NK13-RELATED', 245662);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(359376, 'PTHR11461:SF20', NULL, NULL, NULL, NULL, 'ALPHA-2-ANTIPLASMIN', 245662),
(359377, 'PTHR11461:SF369', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR (SERPIN) FAMILY PROTEIN', 245662),
(359378, 'PTHR11461:SF368', NULL, NULL, NULL, NULL, 'SERPIN DOMAIN-CONTAINING PROTEIN', 245662),
(359379, 'PTHR11461:SF367', NULL, NULL, NULL, NULL, 'GH21475P-RELATED', 245662),
(359380, 'PTHR11461:SF125', NULL, NULL, NULL, NULL, 'SERPIN B12', 245662),
(359381, 'PTHR11461:SF366', NULL, NULL, NULL, NULL, 'SERPIN DOMAIN-CONTAINING PROTEIN', 245662),
(359382, 'PTHR11461:SF122', NULL, NULL, NULL, NULL, 'SERINE (OR CYSTEINE) PEPTIDASE INHIBITOR, CLADE A (ALPHA-1 ANTIPROTEINASE, ANTITRYPSIN), MEMBER 3J-RELATED', 245662),
(359383, 'PTHR11461:SF363', NULL, NULL, NULL, NULL, 'SERINE (OR CYSTEINE) PROTEINASE INHIBITOR, CLADE A (ALPHA-1 ANTIPROTEINASE, ANTITRYPSIN), MEMBER 1-RELATED', 245662),
(359384, 'PTHR11461:SF27', NULL, NULL, NULL, NULL, 'SERPIN H1', 245662),
(359385, 'PTHR11461:SF13', NULL, NULL, NULL, NULL, 'ANGIOTENSINOGEN', 245662),
(359386, 'PTHR11461:SF377', NULL, NULL, NULL, NULL, 'SERPIN A13-RELATED', 245662),
(359387, 'PTHR11461:SF376', NULL, NULL, NULL, NULL, 'SERPIN-ZX-LIKE', 245662),
(359388, 'PTHR11461:SF375', NULL, NULL, NULL, NULL, 'THYROXINE-BINDING GLOBULIN', 245662),
(359389, 'PTHR11461:SF133', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR A3N', 245662),
(359390, 'PTHR11461:SF374', NULL, NULL, NULL, NULL, 'HETEROCHROMATIN-ASSOCIATED PROTEIN MENT-RELATED', 245662),
(359391, 'PTHR11461:SF131', NULL, NULL, NULL, NULL, 'NK21B-RELATED', 245662),
(359392, 'PTHR11461:SF373', NULL, NULL, NULL, NULL, 'SERPIN DOMAIN-CONTAINING PROTEIN', 245662),
(359393, 'PTHR11461:SF372', NULL, NULL, NULL, NULL, 'SERPIN DOMAIN-CONTAINING PROTEIN', 245662),
(359394, 'PTHR11461:SF130', NULL, NULL, NULL, NULL, 'SERPIN 85F', 245662),
(359395, 'PTHR11461:SF371', NULL, NULL, NULL, NULL, 'SERPIN DOMAIN-CONTAINING PROTEIN', 245662),
(359396, 'PTHR11461:SF370', NULL, NULL, NULL, NULL, 'SERPIN DOMAIN-CONTAINING PROTEIN', 245662),
(359397, 'PTHR45791:SF3', NULL, NULL, NULL, NULL, 'CALCIUM AND INTEGRIN-BINDING PROTEIN 1', 245663),
(359398, 'PTHR45791:SF4', NULL, NULL, NULL, NULL, 'CALCIUM AND INTEGRIN-BINDING FAMILY MEMBER 4', 245663),
(359399, 'PTHR45791:SF1', NULL, NULL, NULL, NULL, 'CALCIUM AND INTEGRIN-BINDING 1 (CALMYRIN)', 245663),
(359400, 'PTHR45791:SF7', NULL, NULL, NULL, NULL, 'CALCIUM AND INTEGRIN-BINDING FAMILY MEMBER 3', 245663),
(359401, 'PTHR45791:SF8', NULL, NULL, NULL, NULL, 'CALCINEURIN SUBUNIT B TYPE 2-LIKE PROTEIN', 245663),
(359402, 'PTHR45791', NULL, NULL, NULL, NULL, 'CALCIUM AND INTEGRIN BINDING FAMILY MEMBER 2', 245663),
(359403, 'PTHR45791:SF5', NULL, NULL, NULL, NULL, 'CALCIUM AND INTEGRIN-BINDING FAMILY MEMBER 2', 245663),
(359404, 'PTHR45791:SF6', NULL, NULL, NULL, NULL, 'CALCIUM AND INTEGRIN BINDING FAMILY MEMBER 2', 245663),
(359405, 'PTHR23529', NULL, NULL, NULL, NULL, 'GH19118P-RELATED', 245664),
(359406, 'PTHR23529:SF2', NULL, NULL, NULL, NULL, 'GH19118P-RELATED', 245664),
(359407, 'PTHR43028:SF9', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE-3', 245665),
(359408, 'PTHR43028', NULL, NULL, NULL, NULL, '3''(2''),5''-BISPHOSPHATE NUCLEOTIDASE 1', 245665),
(359409, 'PTHR43028:SF5', NULL, NULL, NULL, NULL, '3''(2''),5''-BISPHOSPHATE NUCLEOTIDASE 1', 245665),
(359410, 'PTHR43028:SF4', NULL, NULL, NULL, NULL, 'INOSITOL MONOPHOSPHATASE 3', 245665),
(359411, 'PTHR43028:SF7', NULL, NULL, NULL, NULL, '3''(2''),5''-BISPHOSPHATE NUCLEOTIDASE CYSQ', 245665),
(359412, 'PTHR43028:SF6', NULL, NULL, NULL, NULL, 'GOLGI-RESIDENT ADENOSINE 3'',5''-BISPHOSPHATE 3''-PHOSPHATASE', 245665),
(359413, 'PTHR43028:SF1', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORT PROTEIN', 245665),
(359414, 'PTHR43028:SF3', NULL, NULL, NULL, NULL, 'INOSITOL POLYPHOSPHATE 1-PHOSPHATASE', 245665),
(359415, 'PTHR43028:SF2', NULL, NULL, NULL, NULL, '', 245665),
(359416, 'PTHR22775:SF48', NULL, NULL, NULL, NULL, 'FI21262P1', 245666),
(359417, 'PTHR22775:SF47', NULL, NULL, NULL, NULL, 'MEIOTICALLY UP-REGULATED GENE 122 PROTEIN', 245666);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(359418, 'PTHR22775:SF29', NULL, NULL, NULL, NULL, 'SORTING NEXIN-25', 245666),
(359419, 'PTHR22775:SF3', NULL, NULL, NULL, NULL, 'SORTING NEXIN-13', 245666),
(359420, 'PTHR22775', NULL, NULL, NULL, NULL, 'SORTING NEXIN', 245666),
(359421, 'PTHR22775:SF33', NULL, NULL, NULL, NULL, '', 245666),
(359422, 'PTHR22775:SF44', NULL, NULL, NULL, NULL, 'SORTING NEXIN-14', 245666),
(359423, 'PTHR22775:SF31', NULL, NULL, NULL, NULL, 'SORTING NEXIN-19', 245666),
(359424, 'PTHR37935', NULL, NULL, NULL, NULL, '', 245667),
(359425, 'PTHR37935:SF1', NULL, NULL, NULL, NULL, '', 245667),
(359426, 'PTHR33445:SF1', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT B', 245668),
(359427, 'PTHR33445:SF2', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT B''', 245668),
(359428, 'PTHR33445', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT B'', CHLOROPLASTIC', 245668),
(359429, 'PTHR40275', NULL, NULL, NULL, NULL, 'SSL7038 PROTEIN', 245669),
(359430, 'PTHR40275:SF1', NULL, NULL, NULL, NULL, 'SSL7038 PROTEIN', 245669),
(359431, 'PTHR14181', NULL, NULL, NULL, NULL, 'DUFFY ANTIGEN/CHEMOKINE RECEPTOR', 245670),
(359432, 'PTHR14181:SF1', NULL, NULL, NULL, NULL, 'ATYPICAL CHEMOKINE RECEPTOR 1', 245670),
(359433, 'PTHR15629:SF42', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD-TYPE ZINC FINGER FAMILY PROTEIN ISOFORM 1', 245671),
(359434, 'PTHR15629', NULL, NULL, NULL, NULL, 'SH3YL1 PROTEIN', 245671),
(359435, 'PTHR15629:SF35', NULL, NULL, NULL, NULL, 'OS06G0552400 PROTEIN', 245671),
(359436, 'PTHR15629:SF38', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD-TYPE ZINC FINGER FAMILY PROTEIN', 245671),
(359437, 'PTHR15629:SF37', NULL, NULL, NULL, NULL, 'OS07G0616900 PROTEIN', 245671),
(359438, 'PTHR15629:SF7', NULL, NULL, NULL, NULL, 'YSC84 DOMAIN-CONTAINING PROTEIN', 245671),
(359439, 'PTHR15629:SF8', NULL, NULL, NULL, NULL, 'DUF500 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_5G07310)', 245671),
(359440, 'PTHR15629:SF2', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-CONTAINING YSC84-LIKE PROTEIN 1', 245671),
(359441, 'PTHR15629:SF41', NULL, NULL, NULL, NULL, 'FYVE-TYPE DOMAIN-CONTAINING PROTEIN', 245671),
(359442, 'PTHR15629:SF40', NULL, NULL, NULL, NULL, 'YSC84 DOMAIN-CONTAINING PROTEIN', 245671),
(359443, 'PTHR13356:SF5', NULL, NULL, NULL, NULL, 'SOSS COMPLEX SUBUNIT B2', 245672),
(359444, 'PTHR13356:SF8', NULL, NULL, NULL, NULL, '', 245672),
(359445, 'PTHR13356:SF7', NULL, NULL, NULL, NULL, 'BNAA02G33870D PROTEIN', 245672),
(359446, 'PTHR13356:SF3', NULL, NULL, NULL, NULL, 'SOSS COMPLEX SUBUNIT B1', 245672),
(359447, 'PTHR13356', NULL, NULL, NULL, NULL, 'OB FOLD NUCLEIC ACID BINDING PROTEIN-RELATED', 245672),
(359448, 'PTHR13356:SF0', NULL, NULL, NULL, NULL, 'SOSS COMPLEX SUBUNIT B HOMOLOG', 245672),
(359449, 'PTHR13356:SF9', NULL, NULL, NULL, NULL, '', 245672),
(359450, 'PTHR35298:SF5', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN S1FA3', 245673),
(359451, 'PTHR35298:SF4', NULL, NULL, NULL, NULL, 'BNAA01G32090D PROTEIN', 245673),
(359452, 'PTHR35298:SF7', NULL, NULL, NULL, NULL, 'BNACNNG30990D PROTEIN', 245673),
(359453, 'PTHR35298:SF11', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN S1FA1-RELATED', 245673),
(359454, 'PTHR35298:SF12', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN S1FA-LIKE', 245673),
(359455, 'PTHR35298', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN S1FA2', 245673),
(359456, 'PTHR35298:SF8', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN S1FA-LIKE', 245673),
(359457, 'PTHR47853:SF4', NULL, NULL, NULL, NULL, 'TFIIS N-TERMINAL DOMAIN-CONTAINING PROTEIN', 245674),
(359458, 'PTHR47853:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245674),
(359459, 'PTHR47853:SF3', NULL, NULL, NULL, NULL, 'TFIIS N-TERMINAL DOMAIN-CONTAINING PROTEIN', 245674),
(359460, 'PTHR47853', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245674),
(359461, 'PTHR33983:SF22', NULL, NULL, NULL, NULL, 'OS03G0799400 PROTEIN', 245675),
(359462, 'PTHR33983:SF21', NULL, NULL, NULL, NULL, '', 245675),
(359463, 'PTHR33983:SF20', NULL, NULL, NULL, NULL, '', 245675),
(359464, 'PTHR33983:SF4', NULL, NULL, NULL, NULL, '', 245675),
(359465, 'PTHR33983:SF1', NULL, NULL, NULL, NULL, 'OS07G0185900 PROTEIN', 245675);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(359466, 'PTHR33983:SF19', NULL, NULL, NULL, NULL, '', 245675),
(359467, 'PTHR33983:SF18', NULL, NULL, NULL, NULL, 'BNACNNG76190D PROTEIN', 245675),
(359468, 'PTHR33983:SF17', NULL, NULL, NULL, NULL, '', 245675),
(359469, 'PTHR33983:SF16', NULL, NULL, NULL, NULL, '', 245675),
(359470, 'PTHR33983:SF15', NULL, NULL, NULL, NULL, '', 245675),
(359471, 'PTHR33983:SF12', NULL, NULL, NULL, NULL, 'BNAANNG30110D PROTEIN', 245675),
(359472, 'PTHR33983', NULL, NULL, NULL, NULL, 'OS07G0185900 PROTEIN', 245675),
(359473, 'PTHR33983:SF9', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245675),
(359474, 'PTHR34928', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 217', 245676),
(359475, 'PTHR34928:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 217', 245676),
(359476, 'PTHR34928:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 217', 245676),
(359477, 'PTHR12155:SF26', NULL, NULL, NULL, NULL, 'SCHLAFEN FAMILY MEMBER 5', 245677),
(359478, 'PTHR12155:SF45', NULL, NULL, NULL, NULL, 'SCHLAFEN FAMILY MEMBER 11', 245677),
(359479, 'PTHR12155:SF46', NULL, NULL, NULL, NULL, 'SCHLAFEN FAMILY MEMBER 12-LIKE', 245677),
(359480, 'PTHR12155:SF43', NULL, NULL, NULL, NULL, 'SCHLAFEN FAMILY MEMBER 13', 245677),
(359481, 'PTHR12155:SF2', NULL, NULL, NULL, NULL, 'SCHLAFEN FAMILY MEMBER 12', 245677),
(359482, 'PTHR12155:SF41', NULL, NULL, NULL, NULL, 'ALBA_2 DOMAIN-CONTAINING PROTEIN', 245677),
(359483, 'PTHR12155:SF30', NULL, NULL, NULL, NULL, 'PROTEIN SLFN14', 245677),
(359484, 'PTHR12155:SF40', NULL, NULL, NULL, NULL, 'SCHLAFEN 3-RELATED', 245677),
(359485, 'PTHR12155:SF29', NULL, NULL, NULL, NULL, 'SCHLAFEN-LIKE PROTEIN 1', 245677),
(359486, 'PTHR12155', NULL, NULL, NULL, NULL, 'SCHLAFEN', 245677),
(359487, 'PTHR21573:SF0', NULL, NULL, NULL, NULL, 'ER MEMBRANE PROTEIN COMPLEX SUBUNIT 1', 245678),
(359488, 'PTHR21573', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 245678),
(359489, 'PTHR13345:SF4', NULL, NULL, NULL, NULL, 'PREFOLDIN CHAPERONE SUBUNIT FAMILY PROTEIN', 245679),
(359490, 'PTHR13345:SF12', NULL, NULL, NULL, NULL, 'PROTEIN UXT', 245679),
(359491, 'PTHR13345:SF8', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 10', 245679),
(359492, 'PTHR13345:SF10', NULL, NULL, NULL, NULL, '', 245679),
(359493, 'PTHR13345:SF11', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 10', 245679),
(359494, 'PTHR13345', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 10', 245679),
(359495, 'PTHR13345:SF9', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 10', 245679),
(359496, 'PTHR46353', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 5', 245680),
(359497, 'PTHR46353:SF22', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 245680),
(359498, 'PTHR46353:SF11', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 245680),
(359499, 'PTHR46353:SF13', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 6', 245680),
(359500, 'PTHR46353:SF14', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 6-LIKE', 245680),
(359501, 'PTHR46353:SF20', NULL, NULL, NULL, NULL, 'ZINC FINGER C2H2-TYPE/INTEGRASE DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 245680),
(359502, 'PTHR46353:SF21', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 245680),
(359503, 'PTHR46353:SF19', NULL, NULL, NULL, NULL, 'ZINC FINGER C2H2-TYPE/INTEGRASE DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 245680),
(359504, 'PTHR46353:SF15', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 245680),
(359505, 'PTHR46353:SF16', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 245680),
(359506, 'PTHR46353:SF7', NULL, NULL, NULL, NULL, 'OS01G0512700 PROTEIN', 245680),
(359507, 'PTHR46353:SF5', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 5', 245680),
(359508, 'PTHR46353:SF9', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN GIS3', 245680),
(359509, 'PTHR46353:SF8', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN JAGGED-LIKE', 245680),
(359510, 'PTHR43547:SF2', NULL, NULL, NULL, NULL, 'HYBRID SIGNAL TRANSDUCTION HISTIDINE KINASE C', 245681);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(359511, 'PTHR43547:SF3', NULL, NULL, NULL, NULL, 'SENSOR PROTEIN CITS', 245681),
(359512, 'PTHR43547', NULL, NULL, NULL, NULL, 'TWO-COMPONENT HISTIDINE KINASE', 245681),
(359513, 'PTHR43547:SF5', NULL, NULL, NULL, NULL, 'HYBRID SIGNAL TRANSDUCTION HISTIDINE KINASE D', 245681),
(359514, 'PTHR43547:SF11', NULL, NULL, NULL, NULL, 'TWO-COMPONENT SENSOR-RELATED', 245681),
(359515, 'PTHR43547:SF10', NULL, NULL, NULL, NULL, 'SENSOR HISTIDINE KINASE DCUS', 245681),
(359516, 'PTHR47015:SF3', NULL, NULL, NULL, NULL, 'BPIFA4P PROTEIN-RELATED', 245682),
(359517, 'PTHR47015:SF2', NULL, NULL, NULL, NULL, 'BPI FOLD-CONTAINING FAMILY A MEMBER 5', 245682),
(359518, 'PTHR47015', NULL, NULL, NULL, NULL, 'BPI FOLD-CONTAINING FAMILY A MEMBER 1', 245682),
(359519, 'PTHR47015:SF1', NULL, NULL, NULL, NULL, 'BPI FOLD-CONTAINING FAMILY A MEMBER 1', 245682),
(359520, 'PTHR35827:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER BED DOMAIN-CONTAINING PROTEIN 3', 245683),
(359521, 'PTHR35827:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER BED DOMAIN-CONTAINING PROTEIN 2', 245683),
(359522, 'PTHR35827', NULL, NULL, NULL, NULL, 'ZINC FINGER BED DOMAIN-CONTAINING PROTEIN 3', 245683),
(359523, 'PTHR11757:SF19', NULL, NULL, NULL, NULL, 'PROLYL ENDOPEPTIDASE-LIKE', 245684),
(359524, 'PTHR11757:SF18', NULL, NULL, NULL, NULL, 'PROLYL ENDOPEPTIDASE', 245684),
(359525, 'PTHR11757', NULL, NULL, NULL, NULL, 'PROTEASE FAMILY S9A OLIGOPEPTIDASE', 245684),
(359526, 'PTHR11757:SF12', NULL, NULL, NULL, NULL, 'PROLYL ENDOPEPTIDASE', 245684),
(359527, 'PTHR11757:SF20', NULL, NULL, NULL, NULL, 'B PROTEIN, PUTATIVE-RELATED', 245684),
(359528, 'PTHR11757:SF21', NULL, NULL, NULL, NULL, 'PROLYL ENDOPEPTIDASE', 245684),
(359529, 'PTHR11757:SF14', NULL, NULL, NULL, NULL, 'PROLYL ENDOPEPTIDASE', 245684),
(359530, 'PTHR46986:SF1', NULL, NULL, NULL, NULL, 'ENDORIBONUCLEASE YBEY, CHLOROPLASTIC', 245685),
(359531, 'PTHR46986:SF2', NULL, NULL, NULL, NULL, 'OS02G0227000 PROTEIN', 245685),
(359532, 'PTHR46986', NULL, NULL, NULL, NULL, 'ENDORIBONUCLEASE YBEY, CHLOROPLASTIC', 245685),
(359533, 'PTHR15495', NULL, NULL, NULL, NULL, 'NEGATIVE REGULATOR OF VESICLE FORMATION-RELATED', 245686),
(359534, 'PTHR15495:SF7', NULL, NULL, NULL, NULL, 'GPI INOSITOL-DEACYLASE', 245686),
(359535, 'PTHR43395:SF10', NULL, NULL, NULL, NULL, 'CHEMOTAXIS PROTEIN CHEA', 245687),
(359536, 'PTHR43395:SF8', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE', 245687),
(359537, 'PTHR43395:SF1', NULL, NULL, NULL, NULL, 'CHEMOTAXIS PROTEIN CHEA', 245687),
(359538, 'PTHR43395', NULL, NULL, NULL, NULL, 'SENSOR HISTIDINE KINASE CHEA', 245687),
(359539, 'PTHR13215:SF7', NULL, NULL, NULL, NULL, 'MEDIATOR-ASSOCIATED PROTEIN 3', 245688),
(359540, 'PTHR13215:SF9', NULL, NULL, NULL, NULL, 'PC4 DOMAIN-CONTAINING PROTEIN', 245688),
(359541, 'PTHR13215:SF6', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II TRANSCRIPTIONAL COACTIVATOR-RELATED', 245688),
(359542, 'PTHR13215', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II TRANSCRIPTIONAL COACTIVATOR', 245688),
(359543, 'PTHR13215:SF0', NULL, NULL, NULL, NULL, 'ACTIVATED RNA POLYMERASE II TRANSCRIPTIONAL COACTIVATOR P15', 245688),
(359544, 'PTHR13215:SF10', NULL, NULL, NULL, NULL, 'ACTIVATED RNA POLYMERASE II TRANSCRIPTIONAL COACTIVATOR P15', 245688),
(359545, 'PTHR31429:SF80', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 245689),
(359546, 'PTHR31429:SF81', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR WRKY FAMILY-RELATED', 245689),
(359547, 'PTHR31429:SF82', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 31-RELATED', 245689),
(359548, 'PTHR31429:SF84', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR WRKY62', 245689),
(359549, 'PTHR31429:SF41', NULL, NULL, NULL, NULL, 'OS01G0289600 PROTEIN', 245689),
(359550, 'PTHR31429:SF64', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR WRKY FAMILY-RELATED', 245689),
(359551, 'PTHR31429:SF86', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 61-RELATED', 245689),
(359552, 'PTHR31429:SF65', NULL, NULL, NULL, NULL, 'OS01G0185900 PROTEIN', 245689),
(359553, 'PTHR31429:SF87', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN-RELATED', 245689);
INSERT INTO "PUBLIC"."MODEL" VALUES
(359554, 'PTHR31429:SF88', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN-RELATED', 245689),
(359555, 'PTHR31429:SF103', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 245689),
(359556, 'PTHR31429:SF79', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 245689),
(359557, 'PTHR31429:SF104', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR WRKY FAMILY-RELATED', 245689),
(359558, 'PTHR31429:SF59', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 47-RELATED', 245689),
(359559, 'PTHR31429:SF38', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 40-RELATED', 245689),
(359560, 'PTHR31429', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 36-RELATED', 245689),
(359561, 'PTHR31429:SF109', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR WRKY FAMILY-RELATED', 245689),
(359562, 'PTHR31429:SF107', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 245689),
(359563, 'PTHR31429:SF108', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR WRKY76', 245689),
(359564, 'PTHR31429:SF105', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN-RELATED', 245689),
(359565, 'PTHR31429:SF106', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 245689),
(359566, 'PTHR31429:SF90', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 245689),
(359567, 'PTHR31429:SF91', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 245689),
(359568, 'PTHR31429:SF50', NULL, NULL, NULL, NULL, 'OS05G0567200 PROTEIN', 245689),
(359569, 'PTHR31429:SF74', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 245689),
(359570, 'PTHR31429:SF96', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 245689),
(359571, 'PTHR31429:SF97', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 36-RELATED', 245689),
(359572, 'PTHR31429:SF76', NULL, NULL, NULL, NULL, 'WRKY FAMILY TRANSCRIPTION FACTOR', 245689),
(359573, 'PTHR31429:SF98', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR WRKY FAMILY-RELATED', 245689),
(359574, 'PTHR31429:SF54', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 9-RELATED', 245689),
(359575, 'PTHR31429:SF33', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR WRKY28', 245689),
(359576, 'PTHR31429:SF77', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 6', 245689),
(359577, 'PTHR31429:SF78', NULL, NULL, NULL, NULL, 'WIZZ', 245689),
(359578, 'PTHR31429:SF3', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 40-RELATED', 245689),
(359579, 'PTHR31429:SF24', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 72-RELATED', 245689),
(359580, 'PTHR31429:SF68', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 42', 245689),
(359581, 'PTHR31429:SF48', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 72B', 245689),
(359582, 'PTHR31429:SF112', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 18-RELATED', 245689),
(359583, 'PTHR31429:SF110', NULL, NULL, NULL, NULL, 'WRKY DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 245689),
(359584, 'PTHR31429:SF111', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN-RELATED', 245689),
(359585, 'PTHR23011:SF12', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 245690),
(359586, 'PTHR23011:SF31', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 245690),
(359587, 'PTHR23011:SF32', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN 1', 245690),
(359588, 'PTHR23011:SF40', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 245690),
(359589, 'PTHR23011', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 245690),
(359590, 'PTHR23011:SF39', NULL, NULL, NULL, NULL, 'RAP GUANINE NUCLEOTIDE EXCHANGE FACTOR (GEF) 4', 245690),
(359591, 'PTHR23011:SF28', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN 2', 245690),
(359592, 'PTHR23011:SF38', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 245690),
(359593, 'PTHR35342:SF5', NULL, NULL, NULL, NULL, 'TRICARBOXYLIC TRANSPORT PROTEIN', 245691),
(359594, 'PTHR35342', NULL, NULL, NULL, NULL, 'TRICARBOXYLIC TRANSPORT PROTEIN', 245691);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(359595, 'PTHR35342:SF1', NULL, NULL, NULL, NULL, 'BLR4373 PROTEIN', 245691),
(359596, 'PTHR47010:SF1', NULL, NULL, NULL, NULL, 'CYSTATIN-8', 245692),
(359597, 'PTHR47010:SF2', NULL, NULL, NULL, NULL, 'CYSTATIN-13', 245692),
(359598, 'PTHR47010', NULL, NULL, NULL, NULL, 'CYSTATIN-8-RELATED', 245692),
(359599, 'PTHR36349:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CLAVATA 3', 245693),
(359600, 'PTHR36349:SF1', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE) GENE FAMILY MEMBER', 245693),
(359601, 'PTHR36349', NULL, NULL, NULL, NULL, 'PROTEIN CLAVATA 3', 245693),
(359602, 'PTHR45673:SF8', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 245694),
(359603, 'PTHR45673:SF6', NULL, NULL, NULL, NULL, 'SER_THR_PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 245694),
(359604, 'PTHR45673:SF7', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2B CATALYTIC SUBUNIT BETA ISOFORM', 245694),
(359605, 'PTHR45673:SF4', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 245694),
(359606, 'PTHR45673:SF5', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2B CATALYTIC SUBUNIT ALPHA ISOFORM', 245694),
(359607, 'PTHR45673:SF2', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2B CATALYTIC SUBUNIT GAMMA ISOFORM', 245694),
(359608, 'PTHR45673:SF3', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 245694),
(359609, 'PTHR45673:SF1', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2B CATALYTIC SUBUNIT 1-RELATED', 245694),
(359610, 'PTHR45673', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2B CATALYTIC SUBUNIT 1-RELATED', 245694),
(359611, 'PTHR34268:SF17', NULL, NULL, NULL, NULL, '', 245695),
(359612, 'PTHR34268:SF8', NULL, NULL, NULL, NULL, 'OS01G0321850 PROTEIN', 245695),
(359613, 'PTHR34268:SF16', NULL, NULL, NULL, NULL, 'OS02G0774200 PROTEIN', 245695),
(359614, 'PTHR34268:SF14', NULL, NULL, NULL, NULL, '', 245695),
(359615, 'PTHR34268:SF11', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 245695),
(359616, 'PTHR34268:SF10', NULL, NULL, NULL, NULL, '', 245695),
(359617, 'PTHR34268:SF7', NULL, NULL, NULL, NULL, 'OS06G0207200 PROTEIN', 245695),
(359618, 'PTHR34268', NULL, NULL, NULL, NULL, 'OS01G0321850 PROTEIN', 245695),
(359619, 'PTHR34268:SF19', NULL, NULL, NULL, NULL, '', 245695),
(359620, 'PTHR11724:SF1', NULL, NULL, NULL, NULL, 'LEPTIN', 245696),
(359621, 'PTHR11724', NULL, NULL, NULL, NULL, 'LEPTIN', 245696),
(359622, 'PTHR35798:SF1', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN SEPF', 245697),
(359623, 'PTHR35798', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN SEPF', 245697),
(359624, 'PTHR22604:SF115', NULL, NULL, NULL, NULL, 'DIHYDRODIOL DEHYDROGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G07520)-RELATED', 245698),
(359625, 'PTHR22604', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASES', 245698),
(359626, 'PTHR22604:SF105', NULL, NULL, NULL, NULL, 'TRANS-1,2-DIHYDROBENZENE-1,2-DIOL DEHYDROGENASE', 245698),
(359627, 'PTHR46662', NULL, NULL, NULL, NULL, 'DI-GLUCOSE BINDING PROTEIN WITH LEUCINE-RICH REPEAT DOMAIN-CONTAINING PROTEIN', 245699),
(359628, 'PTHR46662:SF31', NULL, NULL, NULL, NULL, 'SERINE-THREONINE PROTEIN KINASE, PLANT-TYPE', 245699),
(359629, 'PTHR46662:SF77', NULL, NULL, NULL, NULL, '', 245699),
(359630, 'PTHR46662:SF57', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 245699),
(359631, 'PTHR46662:SF79', NULL, NULL, NULL, NULL, 'GPI-ANCHORED ADHESIN-LIKE PROTEIN PGA55-RELATED', 245699),
(359632, 'PTHR46662:SF35', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 245699),
(359633, 'PTHR46662:SF78', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE', 245699),
(359634, 'PTHR46662:SF91', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE INHIBITOR 1-LIKE', 245699),
(359635, 'PTHR46662:SF90', NULL, NULL, NULL, NULL, 'PERU 2', 245699),
(359636, 'PTHR46662:SF93', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE PEPR1', 245699),
(359637, 'PTHR46662:SF92', NULL, NULL, NULL, NULL, 'DI-GLUCOSE BINDING PROTEIN WITH LEUCINE-RICH REPEAT DOMAIN ISOFORM 1', 245699),
(359638, 'PTHR46662:SF94', NULL, NULL, NULL, NULL, 'RECEPTOR LIKE PROTEIN 4 ISOFORM 1', 245699);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(359639, 'PTHR46662:SF3', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT (LRR) FAMILY PROTEIN', 245699),
(359640, 'PTHR46662:SF5', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT (LRR) FAMILY PROTEIN ISOFORM 1', 245699),
(359641, 'PTHR46662:SF28', NULL, NULL, NULL, NULL, '', 245699),
(359642, 'PTHR46662:SF49', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE', 245699),
(359643, 'PTHR46662:SF27', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR PROTEIN KINASE EMS1-LIKE', 245699),
(359644, 'PTHR46662:SF86', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR PROTEIN KINASE EXS', 245699),
(359645, 'PTHR46662:SF41', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR PROTEIN KINASE EXS', 245699),
(359646, 'PTHR46662:SF85', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 245699),
(359647, 'PTHR46662:SF88', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 245699),
(359648, 'PTHR46662:SF44', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 245699),
(359649, 'PTHR46662:SF66', NULL, NULL, NULL, NULL, 'PIRIFORMOSPORA INDICA-INSENSITIVE PROTEIN 2-LIKE', 245699),
(359650, 'PTHR46662:SF87', NULL, NULL, NULL, NULL, '', 245699),
(359651, 'PTHR46662:SF68', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 245699),
(359652, 'PTHR46662:SF89', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 245699),
(359653, 'PTHR46662:SF80', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN, PLANT-TYPE-RELATED', 245699),
(359654, 'PTHR46662:SF82', NULL, NULL, NULL, NULL, 'OS11G0570000 PROTEIN', 245699),
(359655, 'PTHR46662:SF60', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 245699),
(359656, 'PTHR46662:SF81', NULL, NULL, NULL, NULL, '', 245699),
(359657, 'PTHR46662:SF84', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE IRK-RELATED', 245699),
(359658, 'PTHR46662:SF40', NULL, NULL, NULL, NULL, 'PROTEIN TOO MANY MOUTHS', 245699),
(359659, 'PTHR46662:SF83', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 245699),
(359660, 'PTHR30053:SF14', NULL, NULL, NULL, NULL, 'EFP_N DOMAIN-CONTAINING PROTEIN', 245700),
(359661, 'PTHR30053:SF15', NULL, NULL, NULL, NULL, 'BNACNNG40680D PROTEIN', 245700),
(359662, 'PTHR30053:SF12', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR P (EF-P) FAMILY PROTEIN', 245700),
(359663, 'PTHR30053', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR P', 245700),
(359664, 'PTHR39586', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 245701),
(359665, 'PTHR39586:SF1', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 245701),
(359666, 'PTHR11984:SF50', NULL, NULL, NULL, NULL, 'LOC100038306 PROTEIN', 245702),
(359667, 'PTHR11984:SF9', NULL, NULL, NULL, NULL, 'GAP JUNCTION ALPHA-10 PROTEIN', 245702),
(359668, 'PTHR11984:SF6', NULL, NULL, NULL, NULL, 'GAP JUNCTION GAMMA-1 PROTEIN', 245702),
(359669, 'PTHR11984:SF52', NULL, NULL, NULL, NULL, 'GAP JUNCTION GAMMA-2 PROTEIN', 245702),
(359670, 'PTHR11984:SF30', NULL, NULL, NULL, NULL, 'GAP JUNCTION BETA-4 PROTEIN', 245702),
(359671, 'PTHR11984:SF53', NULL, NULL, NULL, NULL, 'GAP JUNCTION PROTEIN', 245702),
(359672, 'PTHR11984:SF54', NULL, NULL, NULL, NULL, 'GAP JUNCTION ALPHA-4 PROTEIN', 245702),
(359673, 'PTHR11984:SF32', NULL, NULL, NULL, NULL, 'GAP JUNCTION DELTA-2 PROTEIN', 245702),
(359674, 'PTHR11984:SF33', NULL, NULL, NULL, NULL, 'GAP JUNCTION ALPHA-1 PROTEIN', 245702),
(359675, 'PTHR11984:SF12', NULL, NULL, NULL, NULL, 'GAP JUNCTION ALPHA-3 PROTEIN', 245702),
(359676, 'PTHR11984:SF56', NULL, NULL, NULL, NULL, 'GAP JUNCTION GAMMA-3 PROTEIN', 245702),
(359677, 'PTHR11984:SF13', NULL, NULL, NULL, NULL, 'GAP JUNCTION ALPHA-5 PROTEIN', 245702),
(359678, 'PTHR11984:SF107', NULL, NULL, NULL, NULL, 'GAP JUNCTION PROTEIN', 245702),
(359679, 'PTHR11984:SF105', NULL, NULL, NULL, NULL, 'GAP JUNCTION PROTEIN', 245702),
(359680, 'PTHR11984:SF106', NULL, NULL, NULL, NULL, 'GAP JUNCTION PROTEIN', 245702),
(359681, 'PTHR11984:SF39', NULL, NULL, NULL, NULL, 'GAP JUNCTION PROTEIN', 245702),
(359682, 'PTHR11984:SF109', NULL, NULL, NULL, NULL, 'CONNEXIN 28.1-RELATED', 245702); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(359683, 'PTHR11984:SF19', NULL, NULL, NULL, NULL, 'GAP JUNCTION ALPHA-8 PROTEIN', 245702),
(359684, 'PTHR11984:SF104', NULL, NULL, NULL, NULL, 'GAP JUNCTION PROTEIN', 245702),
(359685, 'PTHR11984:SF1', NULL, NULL, NULL, NULL, 'GAP JUNCTION EPSILON-1 PROTEIN-RELATED', 245702),
(359686, 'PTHR11984:SF5', NULL, NULL, NULL, NULL, 'GAP JUNCTION DELTA-3 PROTEIN', 245702),
(359687, 'PTHR11984:SF3', NULL, NULL, NULL, NULL, 'GAP JUNCTION DELTA-4 PROTEIN', 245702),
(359688, 'PTHR11984:SF60', NULL, NULL, NULL, NULL, 'GAP JUNCTION ALPHA-9 PROTEIN', 245702),
(359689, 'PTHR11984:SF61', NULL, NULL, NULL, NULL, 'GAP JUNCTION PROTEIN', 245702),
(359690, 'PTHR11984:SF42', NULL, NULL, NULL, NULL, 'GAP JUNCTION ALPHA-6 PROTEIN', 245702),
(359691, 'PTHR11984:SF20', NULL, NULL, NULL, NULL, 'GAP JUNCTION BETA-1 PROTEIN', 245702),
(359692, 'PTHR11984:SF65', NULL, NULL, NULL, NULL, 'GAP JUNCTION BETA-3 PROTEIN', 245702),
(359693, 'PTHR11984:SF23', NULL, NULL, NULL, NULL, 'GAP JUNCTION BETA-6 PROTEIN', 245702),
(359694, 'PTHR11984:SF46', NULL, NULL, NULL, NULL, 'GAP JUNCTION BETA-2 PROTEIN', 245702),
(359695, 'PTHR11984:SF116', NULL, NULL, NULL, NULL, 'SI:RP71-1C10.10', 245702),
(359696, 'PTHR11984:SF26', NULL, NULL, NULL, NULL, 'GAP JUNCTION BETA-7 PROTEIN', 245702),
(359697, 'PTHR11984:SF49', NULL, NULL, NULL, NULL, 'GAP JUNCTION PROTEIN', 245702),
(359698, 'PTHR11984:SF117', NULL, NULL, NULL, NULL, 'GAP JUNCTION PROTEIN', 245702),
(359699, 'PTHR11984:SF29', NULL, NULL, NULL, NULL, 'GAP JUNCTION BETA-5 PROTEIN', 245702),
(359700, 'PTHR11984:SF115', NULL, NULL, NULL, NULL, 'GAP JUNCTION PROTEIN', 245702),
(359701, 'PTHR11984:SF113', NULL, NULL, NULL, NULL, 'GAP JUNCTION PROTEIN', 245702),
(359702, 'PTHR11984', NULL, NULL, NULL, NULL, 'CONNEXIN', 245702),
(359703, 'PTHR44067:SF5', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245703),
(359704, 'PTHR44067:SF17', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 245703),
(359705, 'PTHR44067:SF3', NULL, NULL, NULL, NULL, 'OS06G0138600 PROTEIN', 245703),
(359706, 'PTHR44067:SF2', NULL, NULL, NULL, NULL, 'OS08G0113400 PROTEIN', 245703),
(359707, 'PTHR44067:SF9', NULL, NULL, NULL, NULL, 'F22F7.17 PROTEIN', 245703),
(359708, 'PTHR44067:SF7', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 245703),
(359709, 'PTHR44067:SF6', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASE SUPERFAMILY PROTEIN', 245703),
(359710, 'PTHR44067', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASE SUPERFAMILY PROTEIN-RELATED', 245703),
(359711, 'PTHR44067:SF1', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 245703),
(359712, 'PTHR44067:SF10', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASE SUPERFAMILY PROTEIN', 245703),
(359713, 'PTHR44067:SF12', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 245703),
(359714, 'PTHR44067:SF11', NULL, NULL, NULL, NULL, 'ATRAD3', 245703),
(359715, 'PTHR44067:SF14', NULL, NULL, NULL, NULL, 'BNAC03G76030D PROTEIN', 245703),
(359716, 'PTHR44067:SF13', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASE SUPERFAMILY PROTEIN', 245703),
(359717, 'PTHR44067:SF16', NULL, NULL, NULL, NULL, 'ATRAD3-LIKE PROTEIN', 245703),
(359718, 'PTHR44067:SF15', NULL, NULL, NULL, NULL, '', 245703),
(359719, 'PTHR46865:SF7', NULL, NULL, NULL, NULL, 'MONOOXYGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G07040)-RELATED', 245704),
(359720, 'PTHR46865:SF6', NULL, NULL, NULL, NULL, 'FAD_BINDING_3 DOMAIN-CONTAINING PROTEIN', 245704),
(359721, 'PTHR46865', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE-RELATED', 245704),
(359722, 'PTHR46865:SF2', NULL, NULL, NULL, NULL, 'POSSIBLE OXIDOREDUCTASE', 245704),
(359723, 'PTHR21148:SF27', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 245705),
(359724, 'PTHR21148:SF26', NULL, NULL, NULL, NULL, 'PHOSDUCIN DOMAIN-CONTAINING PROTEIN', 245705),
(359725, 'PTHR21148', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN 9', 245705);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(359726, 'PTHR21148:SF25', NULL, NULL, NULL, NULL, 'PHOSDUCIN-LIKE PROTEIN 1', 245705),
(359727, 'PTHR21148:SF11', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN 9', 245705),
(359728, 'PTHR34262', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 220', 245706),
(359729, 'PTHR34262:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 220', 245706),
(359730, 'PTHR21227', NULL, NULL, NULL, NULL, 'TRNA-SPLICING ENDONUCLEASE SUBUNIT SEN2', 245707),
(359731, 'PTHR21227:SF0', NULL, NULL, NULL, NULL, 'TRNA-SPLICING ENDONUCLEASE SUBUNIT SEN2', 245707),
(359732, 'PTHR21227:SF3', NULL, NULL, NULL, NULL, 'TRNA-INTRON LYASE', 245707),
(359733, 'PTHR21227:SF4', NULL, NULL, NULL, NULL, 'TRNA-INTRON LYASE', 245707),
(359734, 'PTHR33595:SF19', NULL, NULL, NULL, NULL, '', 245708),
(359735, 'PTHR33595:SF28', NULL, NULL, NULL, NULL, '', 245708),
(359736, 'PTHR33595:SF17', NULL, NULL, NULL, NULL, 'BNAA02G33690D PROTEIN', 245708),
(359737, 'PTHR33595:SF7', NULL, NULL, NULL, NULL, 'OS12G0242500 PROTEIN', 245708),
(359738, 'PTHR33595:SF4', NULL, NULL, NULL, NULL, 'EMB|CAB62340.1', 245708),
(359739, 'PTHR33595:SF3', NULL, NULL, NULL, NULL, 'OS07G0585700 PROTEIN', 245708),
(359740, 'PTHR33595:SF11', NULL, NULL, NULL, NULL, 'EMB|CAB62340.1', 245708),
(359741, 'PTHR33595:SF22', NULL, NULL, NULL, NULL, 'BNAA02G28730D PROTEIN', 245708),
(359742, 'PTHR33595', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR A DOMAIN PROTEIN', 245708),
(359743, 'PTHR33595:SF20', NULL, NULL, NULL, NULL, 'BNAANNG12320D PROTEIN', 245708),
(359744, 'PTHR33595:SF21', NULL, NULL, NULL, NULL, '', 245708),
(359745, 'PTHR33595:SF10', NULL, NULL, NULL, NULL, '', 245708),
(359746, 'PTHR33595:SF26', NULL, NULL, NULL, NULL, 'BNAA06G32290D PROTEIN', 245708),
(359747, 'PTHR33595:SF16', NULL, NULL, NULL, NULL, 'BNAC02G42480D PROTEIN', 245708),
(359748, 'PTHR33595:SF27', NULL, NULL, NULL, NULL, '', 245708),
(359749, 'PTHR33595:SF13', NULL, NULL, NULL, NULL, 'BNAC03G75280D PROTEIN', 245708),
(359750, 'PTHR33595:SF25', NULL, NULL, NULL, NULL, '', 245708),
(359751, 'PTHR33643:SF1', NULL, NULL, NULL, NULL, 'UREASE ACCESSORY PROTEIN D', 245709),
(359752, 'PTHR33643', NULL, NULL, NULL, NULL, 'UREASE ACCESSORY PROTEIN D', 245709),
(359753, 'PTHR14208:SF0', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER AND W2 DOMAIN-CONTAINING PROTEIN 1', 245710),
(359754, 'PTHR14208:SF2', NULL, NULL, NULL, NULL, 'PROTEIN KRASAVIETZ', 245710),
(359755, 'PTHR14208', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER AND W2 DOMAIN-CONTAINING PROTEIN', 245710),
(359756, 'PTHR14208:SF8', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 245710),
(359757, 'PTHR14208:SF7', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER AND W2 DOMAIN-CONTAINING PROTEIN 2', 245710),
(359758, 'PTHR12117:SF0', NULL, NULL, NULL, NULL, 'PROLYL 3-HYDROXYLASE OGFOD1', 245711),
(359759, 'PTHR12117', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE COMPLEX', 245711),
(359760, 'PTHR35399', NULL, NULL, NULL, NULL, 'SLR8030 PROTEIN', 245712),
(359761, 'PTHR35399:SF4', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 245712),
(359762, 'PTHR35399:SF2', NULL, NULL, NULL, NULL, 'SLR8030 PROTEIN', 245712),
(359763, 'PTHR34045:SF18', NULL, NULL, NULL, NULL, 'OS03G0406300 PROTEIN', 245713),
(359764, 'PTHR34045:SF19', NULL, NULL, NULL, NULL, 'PROTEIN LAZY 4', 245713),
(359765, 'PTHR34045:SF16', NULL, NULL, NULL, NULL, 'BNAC02G46380D PROTEIN', 245713),
(359766, 'PTHR34045:SF17', NULL, NULL, NULL, NULL, '', 245713),
(359767, 'PTHR34045:SF1', NULL, NULL, NULL, NULL, '', 245713),
(359768, 'PTHR34045:SF10', NULL, NULL, NULL, NULL, 'PROTEIN DEEPER ROOTING 1', 245713),
(359769, 'PTHR34045', NULL, NULL, NULL, NULL, 'OS03G0406300 PROTEIN', 245713),
(359770, 'PTHR34045:SF3', NULL, NULL, NULL, NULL, 'PROTEIN LAZY 2', 245713),
(359771, 'PTHR34045:SF11', NULL, NULL, NULL, NULL, '', 245713),
(359772, 'PTHR34045:SF12', NULL, NULL, NULL, NULL, '', 245713),
(359773, 'PTHR34045:SF13', NULL, NULL, NULL, NULL, 'PROTEIN LAZY 3', 245713),
(359774, 'PTHR43252:SF4', NULL, NULL, NULL, NULL, 'NEGATIVE TRANSCRIPTION REGULATOR PADR', 245714);
INSERT INTO "PUBLIC"."MODEL" VALUES
(359775, 'PTHR43252', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR YQJI', 245714),
(359776, 'PTHR43252:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR YQJI', 245714),
(359777, 'PTHR34863:SF1', NULL, NULL, NULL, NULL, 'OTU DOMAIN-CONTAINING PROTEIN', 245715),
(359778, 'PTHR34863', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245715),
(359779, 'PTHR38001', NULL, NULL, NULL, NULL, 'PROTEIN CEBPZOS', 245716),
(359780, 'PTHR38001:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CEBPZOS', 245716),
(359781, 'PTHR43531:SF11', NULL, NULL, NULL, NULL, 'METHYL-ACCEPTING CHEMOTAXIS PROTEIN 3', 245717),
(359782, 'PTHR43531:SF7', NULL, NULL, NULL, NULL, 'AEROTAXIS RECEPTOR', 245717),
(359783, 'PTHR43531:SF15', NULL, NULL, NULL, NULL, 'METHYL-ACCEPTING CHEMOTAXIS PROTEIN I', 245717),
(359784, 'PTHR43531:SF5', NULL, NULL, NULL, NULL, 'METHYL-ACCEPTING CHEMOTAXIS PROTEIN III', 245717),
(359785, 'PTHR43531:SF14', NULL, NULL, NULL, NULL, 'METHYL-ACCEPTING CHEMOTAXIS PROTEIN II-RELATED', 245717),
(359786, 'PTHR43531', NULL, NULL, NULL, NULL, 'PROTEIN ICFG', 245717),
(359787, 'PTHR11447:SF21', NULL, NULL, NULL, NULL, 'TUMOR PROTEIN P73', 245718),
(359788, 'PTHR11447', NULL, NULL, NULL, NULL, 'CELLULAR TUMOR ANTIGEN P53', 245718),
(359789, 'PTHR11447:SF6', NULL, NULL, NULL, NULL, 'CELLULAR TUMOR ANTIGEN P53', 245718),
(359790, 'PTHR11447:SF16', NULL, NULL, NULL, NULL, 'P53 PROTEIN LONG FORM VARIANT 1', 245718),
(359791, 'PTHR11447:SF8', NULL, NULL, NULL, NULL, 'TUMOR PROTEIN 63', 245718),
(359792, 'PTHR39153', NULL, NULL, NULL, NULL, 'AGR244WP', 245719),
(359793, 'PTHR39153:SF1', NULL, NULL, NULL, NULL, 'AGR244WP', 245719),
(359794, 'PTHR31209', NULL, NULL, NULL, NULL, 'COFACTOR-INDEPENDENT PHOSPHOGLYCERATE MUTASE', 245720),
(359795, 'PTHR31209:SF5', NULL, NULL, NULL, NULL, 'METALLOENZYME DOMAIN-CONTAINING PROTEIN', 245720),
(359796, 'PTHR31209:SF4', NULL, NULL, NULL, NULL, '2,3-BISPHOSPHOGLYCERATE-INDEPENDENT PHOSPHOGLYCERATE MUTASE', 245720),
(359797, 'PTHR31209:SF0', NULL, NULL, NULL, NULL, 'METALLOENZYME DOMAIN-CONTAINING PROTEIN', 245720),
(359798, 'PTHR47238:SF2', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245721),
(359799, 'PTHR47238:SF4', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE 5', 245721),
(359800, 'PTHR47238', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE 5', 245721),
(359801, 'PTHR42825', NULL, NULL, NULL, NULL, 'AMINO ACID AMINOTRANSFERASE', 245722),
(359802, 'PTHR42825:SF29', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN-AMINO-ACID AMINOTRANSFERASE 1, MITOCHONDRIAL', 245722),
(359803, 'PTHR42825:SF28', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN-AMINO-ACID AMINOTRANSFERASE 7-RELATED', 245722),
(359804, 'PTHR42825:SF27', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN-AMINO-ACID AMINOTRANSFERASE', 245722),
(359805, 'PTHR42825:SF15', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN-AMINO-ACID AMINOTRANSFERASE', 245722),
(359806, 'PTHR42825:SF25', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN-AMINO-ACID AMINOTRANSFERASE', 245722),
(359807, 'PTHR42825:SF24', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN-AMINO-ACID AMINOTRANSFERASE', 245722),
(359808, 'PTHR42825:SF9', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN-AMINO-ACID AMINOTRANSFERASE 2, CHLOROPLASTIC', 245722),
(359809, 'PTHR42825:SF23', NULL, NULL, NULL, NULL, 'BNACNNG51620D PROTEIN', 245722),
(359810, 'PTHR42825:SF12', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN-AMINO-ACID AMINOTRANSFERASE', 245722),
(359811, 'PTHR42825:SF8', NULL, NULL, NULL, NULL, 'METHIONINE AMINOTRANSFERASE BCAT4', 245722),
(359812, 'PTHR42825:SF11', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN-AMINO-ACID AMINOTRANSFERASE 6', 245722),
(359813, 'PTHR42825:SF22', NULL, NULL, NULL, NULL, 'BNAC03G41100D PROTEIN', 245722),
(359814, 'PTHR42825:SF33', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN-AMINO-ACID AMINOTRANSFERASE', 245722),
(359815, 'PTHR42825:SF10', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN-AMINO-ACID AMINOTRANSFERASE', 245722),
(359816, 'PTHR42825:SF21', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN-AMINO-ACID AMINOTRANSFERASE', 245722),
(359817, 'PTHR42825:SF32', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN-AMINO-ACID AMINOTRANSFERASE', 245722);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(359818, 'PTHR42825:SF7', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN-AMINO-ACID AMINOTRANSFERASE', 245722),
(359819, 'PTHR42825:SF20', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN-AMINO-ACID AMINOTRANSFERASE', 245722),
(359820, 'PTHR42825:SF1', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN-AMINO-ACID AMINOTRANSFERASE', 245722),
(359821, 'PTHR42825:SF2', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN-AMINO-ACID AMINOTRANSFERASE 3, CHLOROPLASTIC-RELATED', 245722),
(359822, 'PTHR43260', NULL, NULL, NULL, NULL, '3-KETOSTEROID-DELTA-1-DEHYDROGENASE', 245723),
(359823, 'PTHR43260:SF1', NULL, NULL, NULL, NULL, 'KSDD-LIKE STEROID DEHYDROGENASE RV0785', 245723),
(359824, 'PTHR13128:SF12', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN-SORTING-ASSOCIATED PROTEIN 36', 245724),
(359825, 'PTHR13128', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN-SORTING-ASSOCIATED PROTEIN 36', 245724),
(359826, 'PTHR16003:SF3', NULL, NULL, NULL, NULL, 'CHROMOSOME 9 C9ORF40 HOMOLOG', 245725),
(359827, 'PTHR16003', NULL, NULL, NULL, NULL, 'C9ORF40 ISOFORM 1', 245725),
(359828, 'PTHR37531:SF1', NULL, NULL, NULL, NULL, 'HEME EXPORTER PROTEIN D', 245726),
(359829, 'PTHR37531', NULL, NULL, NULL, NULL, 'HEME EXPORTER PROTEIN D', 245726),
(359830, 'PTHR34459', NULL, NULL, NULL, NULL, 'OS01G0264500 PROTEIN', 245727),
(359831, 'PTHR34459:SF5', NULL, NULL, NULL, NULL, 'BNAA03G06990D PROTEIN', 245727),
(359832, 'PTHR34459:SF3', NULL, NULL, NULL, NULL, 'OS01G0264500 PROTEIN', 245727),
(359833, 'PTHR34459:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 245727),
(359834, 'PTHR22762:SF160', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASES FAMILY 31 PROTEIN ISOFORM 3', 245728),
(359835, 'PTHR22762:SF63', NULL, NULL, NULL, NULL, 'MALTASE-GLUCOAMYLASE, INTESTINAL', 245728),
(359836, 'PTHR22762:SF60', NULL, NULL, NULL, NULL, 'NEUTRAL ALPHA-GLUCOSIDASE C', 245728),
(359837, 'PTHR22762:SF162', NULL, NULL, NULL, NULL, 'NEUTRAL ALPHA-GLUCOSIDASE AB', 245728),
(359838, 'PTHR22762:SF161', NULL, NULL, NULL, NULL, 'OS07G0421300 PROTEIN', 245728),
(359839, 'PTHR22762:SF120', NULL, NULL, NULL, NULL, 'HETEROGLYCAN GLUCOSIDASE 1', 245728),
(359840, 'PTHR22762:SF164', NULL, NULL, NULL, NULL, 'ALPHA-GLUCOSIDASE', 245728),
(359841, 'PTHR22762:SF163', NULL, NULL, NULL, NULL, 'P-TYPE DOMAIN-CONTAINING PROTEIN', 245728),
(359842, 'PTHR22762:SF141', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 245728),
(359843, 'PTHR22762:SF166', NULL, NULL, NULL, NULL, 'ALPHA-GLUCOSIDASE', 245728),
(359844, 'PTHR22762:SF144', NULL, NULL, NULL, NULL, 'ALPHA-XYLOSIDASE', 245728),
(359845, 'PTHR22762:SF122', NULL, NULL, NULL, NULL, 'MALTASE-GLUCOAMYLASE 2-RELATED', 245728),
(359846, 'PTHR22762:SF165', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_1G06560)-RELATED', 245728),
(359847, 'PTHR22762:SF146', NULL, NULL, NULL, NULL, 'BNAA07G24570D PROTEIN', 245728),
(359848, 'PTHR22762:SF145', NULL, NULL, NULL, NULL, 'GAL_MUTAROTAS_2 DOMAIN-CONTAINING PROTEIN', 245728),
(359849, 'PTHR22762:SF167', NULL, NULL, NULL, NULL, 'LYSOSOMAL ALPHA-GLUCOSIDASE-LIKE PROTEIN', 245728),
(359850, 'PTHR22762:SF104', NULL, NULL, NULL, NULL, 'P-TYPE DOMAIN-CONTAINING PROTEIN', 245728),
(359851, 'PTHR22762:SF148', NULL, NULL, NULL, NULL, 'ALPHA-XYLOSIDASE 1-LIKE', 245728),
(359852, 'PTHR22762:SF147', NULL, NULL, NULL, NULL, 'BNAA02G13970D PROTEIN', 245728),
(359853, 'PTHR22762:SF66', NULL, NULL, NULL, NULL, 'SUCRASE-ISOMALTASE, INTESTINAL', 245728),
(359854, 'PTHR22762:SF89', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASES FAMILY 31 PROTEIN', 245728),
(359855, 'PTHR22762:SF127', NULL, NULL, NULL, NULL, 'ALPHA-XYLOSIDASE 1-RELATED', 245728),
(359856, 'PTHR22762:SF149', NULL, NULL, NULL, NULL, 'BNAA01G23630D PROTEIN', 245728),
(359857, 'PTHR22762:SF67', NULL, NULL, NULL, NULL, 'ALPHA/BETA-GLUCOSIDASE AGDC-RELATED', 245728),
(359858, 'PTHR22762', NULL, NULL, NULL, NULL, 'ALPHA-GLUCOSIDASE', 245728),
(359859, 'PTHR22762:SF54', NULL, NULL, NULL, NULL, 'BCDNA.GH04962', 245728),
(359860, 'PTHR22762:SF95', NULL, NULL, NULL, NULL, 'ALPHA/BETA-GLUCOSIDASE AGDC-RELATED', 245728),
(359861, 'PTHR22762:SF151', NULL, NULL, NULL, NULL, 'ALPHA-XYLOSIDASE 1-RELATED', 245728);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(359862, 'PTHR22762:SF150', NULL, NULL, NULL, NULL, 'ALPHA-GLUCOSIDASE-LIKE', 245728),
(359863, 'PTHR22762:SF94', NULL, NULL, NULL, NULL, 'P-TYPE DOMAIN-CONTAINING PROTEIN', 245728),
(359864, 'PTHR22762:SF131', NULL, NULL, NULL, NULL, 'P-TYPE DOMAIN-CONTAINING PROTEIN', 245728),
(359865, 'PTHR22762:SF153', NULL, NULL, NULL, NULL, 'GAL_MUTAROTAS_2 DOMAIN-CONTAINING PROTEIN', 245728),
(359866, 'PTHR22762:SF92', NULL, NULL, NULL, NULL, 'LYSOSOMAL ALPHA-GLUCOSIDASE', 245728),
(359867, 'PTHR22762:SF152', NULL, NULL, NULL, NULL, 'GAL_MUTAROTAS_2 DOMAIN-CONTAINING PROTEIN', 245728),
(359868, 'PTHR22762:SF155', NULL, NULL, NULL, NULL, 'P-TYPE DOMAIN-CONTAINING PROTEIN', 245728),
(359869, 'PTHR22762:SF133', NULL, NULL, NULL, NULL, 'P-TYPE DOMAIN-CONTAINING PROTEIN', 245728),
(359870, 'PTHR22762:SF135', NULL, NULL, NULL, NULL, '', 245728),
(359871, 'PTHR22762:SF137', NULL, NULL, NULL, NULL, 'GAL_MUTAROTAS_2 DOMAIN-CONTAINING PROTEIN', 245728),
(359872, 'PTHR22882', NULL, NULL, NULL, NULL, 'SYNPHILIN-1', 245729),
(359873, 'PTHR22882:SF3', NULL, NULL, NULL, NULL, 'SYNPHILIN-1', 245729),
(359874, 'PTHR33672:SF21', NULL, NULL, NULL, NULL, 'BNAA05G08980D PROTEIN', 245730),
(359875, 'PTHR33672:SF23', NULL, NULL, NULL, NULL, '', 245730),
(359876, 'PTHR33672:SF12', NULL, NULL, NULL, NULL, '', 245730),
(359877, 'PTHR33672:SF11', NULL, NULL, NULL, NULL, 'ROOT HAIR SPECIFIC 4', 245730),
(359878, 'PTHR33672:SF14', NULL, NULL, NULL, NULL, 'BNAC03G63750D PROTEIN', 245730),
(359879, 'PTHR33672:SF25', NULL, NULL, NULL, NULL, 'BNACNNG18720D PROTEIN', 245730),
(359880, 'PTHR33672:SF13', NULL, NULL, NULL, NULL, 'BNAANNG30880D PROTEIN', 245730),
(359881, 'PTHR33672:SF24', NULL, NULL, NULL, NULL, 'BNAANNG10210D PROTEIN', 245730),
(359882, 'PTHR33672:SF16', NULL, NULL, NULL, NULL, 'OS01G0798750 PROTEIN', 245730),
(359883, 'PTHR33672:SF15', NULL, NULL, NULL, NULL, 'BNACNNG61680D PROTEIN', 245730),
(359884, 'PTHR33672:SF2', NULL, NULL, NULL, NULL, '', 245730),
(359885, 'PTHR33672:SF3', NULL, NULL, NULL, NULL, 'YCF3-INTERACTING PROTEIN 1, CHLOROPLASTIC', 245730),
(359886, 'PTHR33672:SF8', NULL, NULL, NULL, NULL, 'OS01G0798600 PROTEIN', 245730),
(359887, 'PTHR33672:SF9', NULL, NULL, NULL, NULL, '', 245730),
(359888, 'PTHR33672:SF6', NULL, NULL, NULL, NULL, 'OS06G0574000 PROTEIN', 245730),
(359889, 'PTHR33672', NULL, NULL, NULL, NULL, 'YCF3-INTERACTING PROTEIN 1, CHLOROPLASTIC', 245730),
(359890, 'PTHR33672:SF19', NULL, NULL, NULL, NULL, 'BNAA08G30090D PROTEIN', 245730),
(359891, 'PTHR36384', NULL, NULL, NULL, NULL, 'SAWADEE PROTEIN', 245731),
(359892, 'PTHR36384:SF2', NULL, NULL, NULL, NULL, 'SAWADEE DOMAIN-CONTAINING PROTEIN', 245731),
(359893, 'PTHR36384:SF1', NULL, NULL, NULL, NULL, 'SAWADEE PROTEIN', 245731),
(359894, 'PTHR12613:SF10', NULL, NULL, NULL, NULL, '', 245732),
(359895, 'PTHR12613:SF6', NULL, NULL, NULL, NULL, 'ERO1-LIKE PROTEIN BETA-RELATED', 245732),
(359896, 'PTHR12613', NULL, NULL, NULL, NULL, 'ERO1-RELATED', 245732),
(359897, 'PTHR12613:SF11', NULL, NULL, NULL, NULL, 'ERO1-LIKE PROTEIN 1', 245732),
(359898, 'PTHR12613:SF8', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM OXIDOREDUCTIN-1', 245732),
(359899, 'PTHR12613:SF1', NULL, NULL, NULL, NULL, 'ERO1-LIKE PROTEIN ALPHA', 245732),
(359900, 'PTHR12613:SF0', NULL, NULL, NULL, NULL, 'ERO1-LIKE PROTEIN', 245732),
(359901, 'PTHR12613:SF2', NULL, NULL, NULL, NULL, 'ERO1-LIKE PROTEIN BETA', 245732),
(359902, 'PTHR46675:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF182', 245733),
(359903, 'PTHR46675:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF182', 245733),
(359904, 'PTHR46675:SF3', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF182', 245733),
(359905, 'PTHR46675:SF4', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF182', 245733),
(359906, 'PTHR46675', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF182', 245733),
(359907, 'PTHR30092', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN CRED', 245734),
(359908, 'PTHR30092:SF0', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN CRED', 245734),
(359909, 'PTHR31097:SF2', NULL, NULL, NULL, NULL, 'CHROMOSOME 7 OPEN READING FRAME 57', 245735);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(359910, 'PTHR31097:SF3', NULL, NULL, NULL, NULL, 'SI:DKEY-276J7.1', 245735),
(359911, 'PTHR31097', NULL, NULL, NULL, NULL, 'SI:DKEY-276J7.1', 245735),
(359912, 'PTHR31857:SF2', NULL, NULL, NULL, NULL, 'HSSA/B-LIKE PROTEIN 17-RELATED', 245736),
(359913, 'PTHR31857', NULL, NULL, NULL, NULL, 'HSSA/B-LIKE PROTEIN 17-RELATED', 245736),
(359914, 'PTHR40708', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1700113H08 GENE', 245737),
(359915, 'PTHR40708:SF1', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1700113H08 GENE', 245737),
(359916, 'PTHR43841', NULL, NULL, NULL, NULL, '3-HYDROXYACYL-THIOESTER DEHYDRATASE HTDX-RELATED', 245738),
(359917, 'PTHR43841:SF3', NULL, NULL, NULL, NULL, '(3R)-HYDROXYACYL-ACP DEHYDRATASE SUBUNIT HADB', 245738),
(359918, 'PTHR43841:SF1', NULL, NULL, NULL, NULL, '3-HYDROXYACYL-THIOESTER DEHYDRATASE X', 245738),
(359919, 'PTHR12451', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR CASTOR  PROTEIN MING -RELATED', 245739),
(359920, 'PTHR12451:SF0', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CASTOR HOMOLOG 1', 245739),
(359921, 'PTHR12231:SF239', NULL, NULL, NULL, NULL, 'NEURAL CELL ADHESION MOLECULE 1', 245740),
(359922, 'PTHR12231:SF218', NULL, NULL, NULL, NULL, 'CONTACTIN 1B', 245740),
(359923, 'PTHR12231:SF219', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AND IMMUNOGLOBULIN DOMAIN-CONTAINING PROTEIN 1', 245740),
(359924, 'PTHR12231:SF257', NULL, NULL, NULL, NULL, 'NEURAL CELL ADHESION MOLECULE L1-LIKE PROTEIN', 245740),
(359925, 'PTHR12231:SF236', NULL, NULL, NULL, NULL, 'ROUNDABOUT HOMOLOG 3', 245740),
(359926, 'PTHR12231:SF237', NULL, NULL, NULL, NULL, 'CONTACTIN-6', 245740),
(359927, 'PTHR12231:SF259', NULL, NULL, NULL, NULL, 'FACTOR OF INTERPULSE INTERVAL', 245740),
(359928, 'PTHR12231:SF253', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN DOMAIN-CONTAINING PROTEIN Y54G2A.25', 245740),
(359929, 'PTHR12231:SF231', NULL, NULL, NULL, NULL, 'MICROFIBRILLAR-ASSOCIATED PROTEIN 3-LIKE-RELATED', 245740),
(359930, 'PTHR12231:SF255', NULL, NULL, NULL, NULL, 'DPR-INTERACTING PROTEIN ALPHA, ISOFORM A', 245740),
(359931, 'PTHR12231:SF157', NULL, NULL, NULL, NULL, 'DPR-INTERACTING PROTEIN EPSILON-RELATED', 245740),
(359932, 'PTHR12231:SF256', NULL, NULL, NULL, NULL, 'NEUROGLIAN', 245740),
(359933, 'PTHR12231:SF234', NULL, NULL, NULL, NULL, 'DPR-INTERACTING PROTEIN ETA, ISOFORM B-RELATED', 245740),
(359934, 'PTHR12231:SF87', NULL, NULL, NULL, NULL, 'DPR-INTERACTING PROTEIN BETA, ISOFORM C', 245740),
(359935, 'PTHR12231:SF229', NULL, NULL, NULL, NULL, 'CONTACTIN-4', 245740),
(359936, 'PTHR12231:SF268', NULL, NULL, NULL, NULL, 'CONTACTIN-3-LIKE PROTEIN', 245740),
(359937, 'PTHR12231:SF224', NULL, NULL, NULL, NULL, 'CONTACTIN-3', 245740),
(359938, 'PTHR12231:SF246', NULL, NULL, NULL, NULL, 'ROUNDABOUT 1, ISOFORM A-RELATED', 245740),
(359939, 'PTHR12231:SF247', NULL, NULL, NULL, NULL, 'DPR-INTERACTING PROTEIN DELTA, ISOFORM D', 245740),
(359940, 'PTHR12231:SF269', NULL, NULL, NULL, NULL, 'NEURAL CELL ADHESION MOLECULE', 245740),
(359941, 'PTHR12231:SF105', NULL, NULL, NULL, NULL, 'DPR-INTERACTING PROTEIN GAMMA', 245740),
(359942, 'PTHR12231:SF242', NULL, NULL, NULL, NULL, 'ROUNDABOUT HOMOLOG 2', 245740),
(359943, 'PTHR12231:SF220', NULL, NULL, NULL, NULL, 'LACHESIN', 245740),
(359944, 'PTHR12231:SF264', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 245740),
(359945, 'PTHR12231:SF243', NULL, NULL, NULL, NULL, 'ROUNDABOUT HOMOLOG 1', 245740),
(359946, 'PTHR12231:SF265', NULL, NULL, NULL, NULL, 'DPR-INTERACTING PROTEIN LAMBDA', 245740),
(359947, 'PTHR12231:SF266', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AND IMMUNOGLOBULIN DOMAIN-CONTAINING PROTEIN 2', 245740),
(359948, 'PTHR12231:SF244', NULL, NULL, NULL, NULL, 'PROTEIN TURTLE HOMOLOG A', 245740),
(359949, 'PTHR12231:SF222', NULL, NULL, NULL, NULL, 'V-SET AND IMMUNOGLOBULIN DOMAIN-CONTAINING PROTEIN 10', 245740),
(359950, 'PTHR12231:SF267', NULL, NULL, NULL, NULL, 'BASEMENT MEMBRANE-SPECIFIC HEPARAN SULFATE PROTEOGLYCAN CORE PROTEIN', 245740),
(359951, 'PTHR12231:SF261', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN SUPERFAMILY MEMBER 10', 245740),
(359952, 'PTHR12231:SF240', NULL, NULL, NULL, NULL, 'PROTEIN TURTLE HOMOLOG B', 245740);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(359953, 'PTHR12231:SF262', NULL, NULL, NULL, NULL, 'DPR-INTERACTING PROTEIN KAPPA, ISOFORM A', 245740),
(359954, 'PTHR12231:SF263', NULL, NULL, NULL, NULL, '', 245740),
(359955, 'PTHR12231:SF241', NULL, NULL, NULL, NULL, 'L1 CELL ADHESION MOLECULE', 245740),
(359956, 'PTHR12231:SF270', NULL, NULL, NULL, NULL, 'TITIN HOMOLOG', 245740),
(359957, 'PTHR12231', NULL, NULL, NULL, NULL, 'CTX-RELATED TYPE I TRANSMEMBRANE PROTEIN', 245740),
(359958, 'PTHR35738:SF4', NULL, NULL, NULL, NULL, '', 245741),
(359959, 'PTHR35738:SF3', NULL, NULL, NULL, NULL, 'OS05G0577800 PROTEIN', 245741),
(359960, 'PTHR35738:SF5', NULL, NULL, NULL, NULL, 'BNAA02G29100D PROTEIN', 245741),
(359961, 'PTHR35738', NULL, NULL, NULL, NULL, 'OS05G0577800 PROTEIN', 245741),
(359962, 'PTHR45930:SF2', NULL, NULL, NULL, NULL, 'ADHESION G PROTEIN-COUPLED RECEPTOR A3', 245742),
(359963, 'PTHR45930:SF3', NULL, NULL, NULL, NULL, 'ADHESION G PROTEIN-COUPLED RECEPTOR A1', 245742),
(359964, 'PTHR45930:SF4', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 124-LIKE PROTEIN', 245742),
(359965, 'PTHR45930', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 124-LIKE PROTEIN', 245742),
(359966, 'PTHR45930:SF1', NULL, NULL, NULL, NULL, 'ADHESION G PROTEIN-COUPLED RECEPTOR A2', 245742),
(359967, 'PTHR12449:SF18', NULL, NULL, NULL, NULL, 'DEATH DOMAIN-CONTAINING PROTEIN', 245743),
(359968, 'PTHR12449:SF19', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 4-LIKE', 245743),
(359969, 'PTHR12449:SF17', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 4', 245743),
(359970, 'PTHR12449', NULL, NULL, NULL, NULL, 'DEATH DOMAIN-CONTAINING PROTEIN', 245743),
(359971, 'PTHR12449:SF22', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 4-LIKE PROTEIN', 245743),
(359972, 'PTHR46033:SF29', NULL, NULL, NULL, NULL, 'OS06G0232700 PROTEIN', 245744),
(359973, 'PTHR46033:SF69', NULL, NULL, NULL, NULL, 'OS07G0507600 PROTEIN', 245744),
(359974, 'PTHR46033:SF47', NULL, NULL, NULL, NULL, 'PMD DOMAIN-CONTAINING PROTEIN', 245744),
(359975, 'PTHR46033:SF1', NULL, NULL, NULL, NULL, 'PMD DOMAIN-CONTAINING PROTEIN', 245744),
(359976, 'PTHR46033:SF60', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 7 LONG FORM HOMOLOG', 245744),
(359977, 'PTHR46033:SF65', NULL, NULL, NULL, NULL, 'PMD DOMAIN-CONTAINING PROTEIN', 245744),
(359978, 'PTHR46033:SF66', NULL, NULL, NULL, NULL, 'PROTEIN MAIN-LIKE 2-LIKE ISOFORM X1', 245744),
(359979, 'PTHR46033:SF22', NULL, NULL, NULL, NULL, 'PROTEIN MAINTENANCE OF MERISTEMS', 245744),
(359980, 'PTHR46033:SF44', NULL, NULL, NULL, NULL, 'PMD DOMAIN-CONTAINING PROTEIN', 245744),
(359981, 'PTHR46033:SF67', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE-LIKE, PLANT MOBILE DOMAIN FAMILY PROTEIN', 245744),
(359982, 'PTHR46033:SF68', NULL, NULL, NULL, NULL, 'PROTEIN MAIN-LIKE 2', 245744),
(359983, 'PTHR46033:SF8', NULL, NULL, NULL, NULL, 'LOW QUALITY PROTEIN: SERINE/THREONINE-PROTEIN PHOSPHATASE 7 LONG FORM HOMOLOG', 245744),
(359984, 'PTHR46033:SF40', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245744),
(359985, 'PTHR46033:SF62', NULL, NULL, NULL, NULL, 'PMD DOMAIN-CONTAINING PROTEIN', 245744),
(359986, 'PTHR46033:SF58', NULL, NULL, NULL, NULL, 'PMD DOMAIN-CONTAINING PROTEIN', 245744),
(359987, 'PTHR46033:SF59', NULL, NULL, NULL, NULL, 'OS07G0507500 PROTEIN', 245744),
(359988, 'PTHR46033:SF16', NULL, NULL, NULL, NULL, 'PMD DOMAIN-CONTAINING PROTEIN', 245744),
(359989, 'PTHR46033:SF17', NULL, NULL, NULL, NULL, 'PMD DOMAIN-CONTAINING PROTEIN', 245744),
(359990, 'PTHR46033', NULL, NULL, NULL, NULL, 'PROTEIN MAIN-LIKE 2', 245744),
(359991, 'PTHR46033:SF70', NULL, NULL, NULL, NULL, 'PMD DOMAIN-CONTAINING PROTEIN', 245744),
(359992, 'PTHR46033:SF71', NULL, NULL, NULL, NULL, 'OS07G0238800 PROTEIN', 245744),
(359993, 'PTHR46033:SF32', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245744),
(359994, 'PTHR46033:SF76', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 7 LONG FORM-LIKE PROTEIN', 245744),
(359995, 'PTHR46033:SF33', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE-LIKE, PLANT MOBILE DOMAIN FAMILY PROTEIN', 245744),
(359996, 'PTHR46033:SF56', NULL, NULL, NULL, NULL, 'PMD DOMAIN-CONTAINING PROTEIN', 245744);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(359997, 'PTHR46033:SF35', NULL, NULL, NULL, NULL, 'PROTEIN MAIN-LIKE 1', 245744),
(359998, 'PTHR46033:SF72', NULL, NULL, NULL, NULL, 'PLANT MOBILE DOMAIN PROTEIN FAMILY', 245744),
(359999, 'PTHR46033:SF73', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE-LIKE, MOBILE DOMAIN PROTEIN-RELATED', 245744),
(360000, 'PTHR46033:SF74', NULL, NULL, NULL, NULL, 'PMD DOMAIN-CONTAINING PROTEIN', 245744),
(360001, 'PTHR46033:SF52', NULL, NULL, NULL, NULL, 'GLOBULAR STAGE, PUTATIVE-RELATED', 245744),
(360002, 'PTHR46033:SF75', NULL, NULL, NULL, NULL, '', 245744),
(360003, 'PTHR46033:SF53', NULL, NULL, NULL, NULL, 'OS12G0256800 PROTEIN', 245744),
(360004, 'PTHR21844', NULL, NULL, NULL, NULL, 'AKT1 SUBSTRATE 1 PROTEIN', 245745),
(360005, 'PTHR21844:SF2', NULL, NULL, NULL, NULL, 'PROLINE-RICH AKT1 SUBSTRATE 1', 245745),
(360006, 'PTHR36167:SF2', NULL, NULL, NULL, NULL, 'C2H2 FINGER DOMAIN TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 245746),
(360007, 'PTHR36167:SF3', NULL, NULL, NULL, NULL, 'WOR4P', 245746),
(360008, 'PTHR36167', NULL, NULL, NULL, NULL, 'C2H2 FINGER DOMAIN TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 245746),
(360009, 'PTHR33940:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG13625', 245747),
(360010, 'PTHR33940', NULL, NULL, NULL, NULL, 'PROTEIN CBG13625', 245747),
(360011, 'PTHR30118:SF10', NULL, NULL, NULL, NULL, 'LYSR FAMILY TRANSCRIPTIONAL REGULATOR-RELATED', 245748),
(360012, 'PTHR30118', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR LEUO-RELATED', 245748),
(360013, 'PTHR30118:SF6', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR LEUO', 245748),
(360014, 'PTHR30118:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR LYSR FAMILY', 245748),
(360015, 'PTHR30118:SF15', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 245748),
(360016, 'PTHR30118:SF12', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR LYSR FAMILY', 245748),
(360017, 'PTHR30118:SF11', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR YIDZ', 245748),
(360018, 'PTHR30118:SF14', NULL, NULL, NULL, NULL, 'LYSR FAMILY TRANSCRIPTIONAL REGULATOR-RELATED', 245748),
(360019, 'PTHR15390:SF0', NULL, NULL, NULL, NULL, 'NEUROMEDIN-U', 245749),
(360020, 'PTHR15390', NULL, NULL, NULL, NULL, 'NEUROMEDIN-U', 245749),
(360021, 'PTHR38603:SF1', NULL, NULL, NULL, NULL, 'CHAPERONE NAPD', 245750),
(360022, 'PTHR38603', NULL, NULL, NULL, NULL, 'CHAPERONE NAPD', 245750),
(360023, 'PTHR42700:SF3', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL SAT/APS KINASE-RELATED', 245751),
(360024, 'PTHR42700:SF1', NULL, NULL, NULL, NULL, 'SULFATE ADENYLYLTRANSFERASE', 245751),
(360025, 'PTHR42700', NULL, NULL, NULL, NULL, 'SULFATE ADENYLYLTRANSFERASE', 245751),
(360026, 'PTHR12399:SF2', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT D', 245752),
(360027, 'PTHR12399:SF1', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT D', 245752),
(360028, 'PTHR12399:SF3', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT D', 245752),
(360029, 'PTHR12399', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT 7', 245752),
(360030, 'PTHR12399:SF0', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT D', 245752),
(360031, 'PTHR36152:SF5', NULL, NULL, NULL, NULL, 'PROTEIN HCP1', 245753),
(360032, 'PTHR36152:SF1', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 245753),
(360033, 'PTHR36152', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 245753),
(360034, 'PTHR28297', NULL, NULL, NULL, NULL, 'FUNGAL PROTEIN', 245754),
(360035, 'PTHR28297:SF1', NULL, NULL, NULL, NULL, 'FUNGAL PROTEIN', 245754),
(360036, 'PTHR27000:SF736', NULL, NULL, NULL, NULL, 'OS01G0239700 PROTEIN', 245755),
(360037, 'PTHR27000:SF616', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE FLS2', 245755),
(360038, 'PTHR27000:SF735', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 245755),
(360039, 'PTHR27000:SF579', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE GSO2', 245755),
(360040, 'PTHR27000:SF733', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245755);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(360041, 'PTHR27000:SF697', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR PROTEIN KINASE FAMILY PROTEIN-RELATED', 245755),
(360042, 'PTHR27000:SF698', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE PEPR2', 245755),
(360043, 'PTHR27000:SF215', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE HSL1', 245755),
(360044, 'PTHR27000:SF580', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE RPK2', 245755),
(360045, 'PTHR27000:SF608', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE PEPR1', 245755),
(360046, 'PTHR27000:SF723', NULL, NULL, NULL, NULL, 'LEUCINE-RICH RECEPTOR-LIKE KINASE FAMILY PROTEIN', 245755),
(360047, 'PTHR27000:SF569', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE RPK2', 245755),
(360048, 'PTHR27000:SF603', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE FAMILY PROTEIN', 245755),
(360049, 'PTHR27000:SF721', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE GSO1', 245755),
(360050, 'PTHR27000:SF722', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245755),
(360051, 'PTHR27000:SF568', NULL, NULL, NULL, NULL, 'OS05G0522600 PROTEIN', 245755),
(360052, 'PTHR27000:SF686', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE PXC2', 245755),
(360053, 'PTHR27000:SF444', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE GSO1', 245755),
(360054, 'PTHR27000:SF720', NULL, NULL, NULL, NULL, 'REPEAT PROTEIN KINASE FAMILY PROTEIN, PUTATIVE-RELATED', 245755),
(360055, 'PTHR27000:SF571', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE FAMILY PROTEIN-RELATED', 245755),
(360056, 'PTHR27000:SF290', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE RGI2', 245755),
(360057, 'PTHR27000:SF54', NULL, NULL, NULL, NULL, 'OS07G0597200 PROTEIN', 245755),
(360058, 'PTHR27000:SF716', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE FLS2', 245755),
(360059, 'PTHR27000:SF439', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE 7', 245755),
(360060, 'PTHR27000:SF679', NULL, NULL, NULL, NULL, 'OS01G0170300 PROTEIN', 245755),
(360061, 'PTHR27000:SF558', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE IRK-RELATED', 245755),
(360062, 'PTHR27000:SF559', NULL, NULL, NULL, NULL, 'OS09G0326100 PROTEIN', 245755),
(360063, 'PTHR27000:SF798', NULL, NULL, NULL, NULL, 'PROTEIN KINASE FAMILY PROTEIN WITH LEUCINE-RICH REPEAT DOMAIN', 245755),
(360064, 'PTHR27000:SF711', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINE RECEPTOR 1', 245755),
(360065, 'PTHR27000:SF796', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245755),
(360066, 'PTHR27000:SF797', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245755),
(360067, 'PTHR27000:SF676', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE RGI3', 245755),
(360068, 'PTHR27000:SF794', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245755),
(360069, 'PTHR27000:SF795', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE FAMILY PROTEIN-RELATED', 245755),
(360070, 'PTHR27000:SF792', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT FAMILY PROTEIN, EXPRESSED', 245755),
(360071, 'PTHR27000:SF793', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE', 245755),
(360072, 'PTHR27000:SF162', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE IRK-RELATED', 245755),
(360073, 'PTHR27000:SF680', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE', 245755),
(360074, 'PTHR27000:SF282', NULL, NULL, NULL, NULL, 'OS06G0557100 PROTEIN', 245755),
(360075, 'PTHR27000:SF681', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE', 245755),
(360076, 'PTHR27000:SF708', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 245755),
(360077, 'PTHR27000:SF789', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT FAMILY PROTEIN, EXPRESSED', 245755),
(360078, 'PTHR27000:SF787', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 39', 245755);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(360079, 'PTHR27000:SF788', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 245755),
(360080, 'PTHR27000:SF785', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245755),
(360081, 'PTHR27000:SF544', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 245755),
(360082, 'PTHR27000:SF786', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE', 245755),
(360083, 'PTHR27000:SF783', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 245755),
(360084, 'PTHR27000:SF662', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT (LRR) FAMILY PROTEIN', 245755),
(360085, 'PTHR27000:SF784', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE RCH1', 245755),
(360086, 'PTHR27000:SF781', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245755),
(360087, 'PTHR27000:SF146', NULL, NULL, NULL, NULL, 'OS04G0472500 PROTEIN', 245755),
(360088, 'PTHR27000:SF782', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245755),
(360089, 'PTHR27000:SF790', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE FAMILY PROTEIN / LRR FAMILY PROTEIN ISOFORM 1', 245755),
(360090, 'PTHR27000:SF791', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE FAMILY PROTEIN', 245755),
(360091, 'PTHR27000:SF709', NULL, NULL, NULL, NULL, 'OS01G0742400 PROTEIN', 245755),
(360092, 'PTHR27000:SF778', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245755),
(360093, 'PTHR27000:SF779', NULL, NULL, NULL, NULL, 'OS11G0197000 PROTEIN', 245755),
(360094, 'PTHR27000:SF776', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245755),
(360095, 'PTHR27000:SF656', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE RGI4', 245755),
(360096, 'PTHR27000:SF777', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245755),
(360097, 'PTHR27000:SF774', NULL, NULL, NULL, NULL, 'BNAA06G33460D PROTEIN', 245755),
(360098, 'PTHR27000:SF775', NULL, NULL, NULL, NULL, 'MDIS1-INTERACTING RECEPTOR LIKE KINASE 2-LIKE', 245755),
(360099, 'PTHR27000:SF772', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE HSL2', 245755),
(360100, 'PTHR27000:SF773', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 45', 245755),
(360101, 'PTHR27000:SF770', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 245755),
(360102, 'PTHR27000:SF771', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE FLS2', 245755),
(360103, 'PTHR27000:SF780', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245755),
(360104, 'PTHR27000:SF529', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE 5', 245755),
(360105, 'PTHR27000:SF769', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE FAMILY PROTEIN', 245755),
(360106, 'PTHR27000:SF14', NULL, NULL, NULL, NULL, 'F12K21.25', 245755),
(360107, 'PTHR27000:SF767', NULL, NULL, NULL, NULL, 'TYROSINE-SULFATED GLYCOPEPTIDE RECEPTOR 1', 245755),
(360108, 'PTHR27000:SF768', NULL, NULL, NULL, NULL, 'RECEPTOR LIKE PROTEIN 29', 245755),
(360109, 'PTHR27000:SF765', NULL, NULL, NULL, NULL, 'OS03G0400800 PROTEIN', 245755),
(360110, 'PTHR27000:SF642', NULL, NULL, NULL, NULL, 'INACTIVE LEUCINE-RICH REPEAT RECEPTOR KINASE XIAO-RELATED', 245755),
(360111, 'PTHR27000:SF641', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE RPK2', 245755),
(360112, 'PTHR27000', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE FAMILY PROTEIN-RELATED', 245755),
(360113, 'PTHR27000:SF492', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT RECEPTOR LIKE PROTEIN CLAVATA2', 245755),
(360114, 'PTHR27000:SF97', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN-TYROSINE KINASE CEPR2', 245755),
(360115, 'PTHR27000:SF758', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE RGI1', 245755),
(360116, 'PTHR27000:SF756', NULL, NULL, NULL, NULL, 'TYROSINE-SULFATED GLYCOPEPTIDE RECEPTOR 1', 245755),
(360117, 'PTHR27000:SF636', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR PROTEIN KINASE FAMILY PROTEIN-RELATED', 245755);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(360118, 'PTHR27000:SF757', NULL, NULL, NULL, NULL, 'RECEPTOR LIKE PROTEIN 21-LIKE', 245755),
(360119, 'PTHR27000:SF479', NULL, NULL, NULL, NULL, 'INACTIVE LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE-RELATED', 245755),
(360120, 'PTHR27000:SF755', NULL, NULL, NULL, NULL, 'OS02G0154975 PROTEIN', 245755),
(360121, 'PTHR27000:SF752', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 245755),
(360122, 'PTHR27000:SF631', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE HAIKU2', 245755),
(360123, 'PTHR27000:SF753', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 245755),
(360124, 'PTHR27000:SF750', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 245755),
(360125, 'PTHR27000:SF594', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE FAMILY PROTEIN-RELATED', 245755),
(360126, 'PTHR27000:SF38', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE TYROSINE-PROTEIN KINASE PXC3', 245755),
(360127, 'PTHR27000:SF749', NULL, NULL, NULL, NULL, 'OS02G0228300 PROTEIN', 245755),
(360128, 'PTHR27000:SF747', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT FAMILY PROTEIN, EXPRESSED', 245755),
(360129, 'PTHR27000:SF746', NULL, NULL, NULL, NULL, 'INACTIVE LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE-RELATED', 245755),
(360130, 'PTHR27000:SF743', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245755),
(360131, 'PTHR27000:SF744', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 245755),
(360132, 'PTHR27000:SF224', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN-TYROSINE KINASE CEPR1', 245755),
(360133, 'PTHR27000:SF742', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245755),
(360134, 'PTHR27000:SF588', NULL, NULL, NULL, NULL, 'OS07G0152200 PROTEIN', 245755),
(360135, 'PTHR27000:SF585', NULL, NULL, NULL, NULL, 'HIGHLY SIMILAR TO RECEPTOR-LIKE PROTEIN KINASE', 245755),
(360136, 'PTHR27000:SF221', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN KINASE', 245755),
(360137, 'PTHR27000:SF584', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE RPK2', 245755),
(360138, 'PTHR27000:SF470', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245755),
(360139, 'PTHR27000:SF191', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE FLS2', 245755),
(360140, 'PTHR36871', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 190', 245756),
(360141, 'PTHR36871:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 190', 245756),
(360142, 'PTHR22746', NULL, NULL, NULL, NULL, 'RAB6A-GEF COMPLEX PARTNER PROTEIN 1', 245757),
(360143, 'PTHR22746:SF10', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE EXCHANGE FACTOR SUBUNIT RIC1', 245757),
(360144, 'PTHR11949:SF50', NULL, NULL, NULL, NULL, 'INTERFERON REGULATORY FACTOR', 245758),
(360145, 'PTHR11949:SF52', NULL, NULL, NULL, NULL, 'IRF-3 DOMAIN-CONTAINING PROTEIN', 245758),
(360146, 'PTHR11949:SF53', NULL, NULL, NULL, NULL, 'IRF TRYPTOPHAN PENTAD REPEAT DOMAIN-CONTAINING PROTEIN', 245758),
(360147, 'PTHR11949:SF20', NULL, NULL, NULL, NULL, 'INTERFERON REGULATORY FACTOR 4B', 245758),
(360148, 'PTHR11949:SF10', NULL, NULL, NULL, NULL, 'INTERFERON REGULATORY FACTOR 5', 245758),
(360149, 'PTHR11949:SF22', NULL, NULL, NULL, NULL, 'INTERFERON REGULATORY FACTOR 2', 245758),
(360150, 'PTHR11949', NULL, NULL, NULL, NULL, 'INTERFERON REGULATORY FACTOR', 245758),
(360151, 'PTHR11949:SF24', NULL, NULL, NULL, NULL, 'IRF TRYPTOPHAN PENTAD REPEAT DOMAIN-CONTAINING PROTEIN', 245758),
(360152, 'PTHR11949:SF2', NULL, NULL, NULL, NULL, 'INTERFERON REGULATORY FACTOR 7', 245758),
(360153, 'PTHR11949:SF1', NULL, NULL, NULL, NULL, 'INTERFERON REGULATORY FACTOR 3', 245758),
(360154, 'PTHR11949:SF26', NULL, NULL, NULL, NULL, 'INTERFERON REGULATORY FACTOR 9', 245758),
(360155, 'PTHR11949:SF3', NULL, NULL, NULL, NULL, 'INTERFERON REGULATORY FACTOR 1', 245758),
(360156, 'PTHR11949:SF17', NULL, NULL, NULL, NULL, 'IRF TRYPTOPHAN PENTAD REPEAT DOMAIN-CONTAINING PROTEIN', 245758),
(360157, 'PTHR11949:SF9', NULL, NULL, NULL, NULL, 'INTERFERON REGULATORY FACTOR 6', 245758);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(360158, 'PTHR11949:SF6', NULL, NULL, NULL, NULL, 'INTERFERON REGULATORY FACTOR 4', 245758),
(360159, 'PTHR11949:SF7', NULL, NULL, NULL, NULL, 'INTERFERON REGULATORY FACTOR 8', 245758),
(360160, 'PTHR21221:SF1', NULL, NULL, NULL, NULL, 'UREIDOGLYCOLATE LYASE', 245759),
(360161, 'PTHR21221', NULL, NULL, NULL, NULL, 'UREIDOGLYCOLATE HYDROLASE', 245759),
(360162, 'PTHR31081:SF20', NULL, NULL, NULL, NULL, 'BNAA06G39890D PROTEIN', 245760),
(360163, 'PTHR31081', NULL, NULL, NULL, NULL, 'UREIDE PERMEASE 1-RELATED-RELATED', 245760),
(360164, 'PTHR31081:SF21', NULL, NULL, NULL, NULL, '', 245760),
(360165, 'PTHR31081:SF8', NULL, NULL, NULL, NULL, 'OS12G0503300 PROTEIN', 245760),
(360166, 'PTHR31081:SF19', NULL, NULL, NULL, NULL, 'BNAC09G21970D PROTEIN', 245760),
(360167, 'PTHR31081:SF13', NULL, NULL, NULL, NULL, 'UREIDE PERMEASE 4', 245760),
(360168, 'PTHR31081:SF14', NULL, NULL, NULL, NULL, 'UREIDE PERMEASE 1-LIKE ISOFORM X1', 245760),
(360169, 'PTHR31081:SF3', NULL, NULL, NULL, NULL, 'OS12G0503000 PROTEIN', 245760),
(360170, 'PTHR31081:SF11', NULL, NULL, NULL, NULL, 'UREIDE PERMEASE 1-LIKE', 245760),
(360171, 'PTHR31081:SF23', NULL, NULL, NULL, NULL, 'UREIDE PERMEASE-RELATED', 245760),
(360172, 'PTHR31081:SF5', NULL, NULL, NULL, NULL, 'UREIDE PERMEASE 1-RELATED', 245760),
(360173, 'PTHR31081:SF17', NULL, NULL, NULL, NULL, '', 245760),
(360174, 'PTHR31081:SF18', NULL, NULL, NULL, NULL, 'UREIDE PERMEASE 1-LIKE', 245760),
(360175, 'PTHR31081:SF15', NULL, NULL, NULL, NULL, 'UREIDE PERMEASE 1-LIKE', 245760),
(360176, 'PTHR31081:SF16', NULL, NULL, NULL, NULL, 'UREIDE PERMEASE 5', 245760),
(360177, 'PTHR42080:SF1', NULL, NULL, NULL, NULL, 'SRR1 DOMAIN-CONTAINING PROTEIN', 245761),
(360178, 'PTHR42080:SF3', NULL, NULL, NULL, NULL, 'SRR1 DOMAIN-CONTAINING PROTEIN', 245761),
(360179, 'PTHR42080', NULL, NULL, NULL, NULL, 'SRR1 DOMAIN-CONTAINING PROTEIN', 245761),
(360180, 'PTHR36510:SF3', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', 245762),
(360181, 'PTHR36510', NULL, NULL, NULL, NULL, 'GLUTAMATE--CYSTEINE LIGASE 2-RELATED', 245762),
(360182, 'PTHR36510:SF1', NULL, NULL, NULL, NULL, 'GLUTAMATE--CYSTEINE LIGASE 2-RELATED', 245762),
(360183, 'PTHR23213:SF381', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 245763),
(360184, 'PTHR23213:SF360', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 245763),
(360185, 'PTHR23213:SF340', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 245763),
(360186, 'PTHR23213:SF384', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN 8', 245763),
(360187, 'PTHR23213:SF389', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 245763),
(360188, 'PTHR23213:SF345', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN 7', 245763),
(360189, 'PTHR23213:SF368', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN 2', 245763),
(360190, 'PTHR23213:SF269', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN 5', 245763),
(360191, 'PTHR23213:SF347', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN 14', 245763),
(360192, 'PTHR23213:SF348', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 245763),
(360193, 'PTHR23213:SF385', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN 3', 245763),
(360194, 'PTHR23213:SF341', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 245763),
(360195, 'PTHR23213:SF363', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 245763),
(360196, 'PTHR23213:SF386', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN 18', 245763),
(360197, 'PTHR23213:SF364', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN 8', 245763),
(360198, 'PTHR23213:SF365', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 245763),
(360199, 'PTHR23213:SF387', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 245763),
(360200, 'PTHR23213:SF388', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 245763),
(360201, 'PTHR23213:SF366', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 245763),
(360202, 'PTHR23213:SF349', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 245763),
(360203, 'PTHR23213:SF273', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 245763),
(360204, 'PTHR23213:SF372', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 245763),
(360205, 'PTHR23213:SF373', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 245763);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(360206, 'PTHR23213:SF351', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 245763),
(360207, 'PTHR23213:SF257', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN 13', 245763),
(360208, 'PTHR23213:SF378', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 245763),
(360209, 'PTHR23213:SF235', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN 10', 245763),
(360210, 'PTHR23213:SF379', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 245763),
(360211, 'PTHR23213:SF358', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN 2', 245763),
(360212, 'PTHR23213:SF336', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN 15', 245763),
(360213, 'PTHR23213:SF359', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 245763),
(360214, 'PTHR23213:SF374', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 245763),
(360215, 'PTHR23213:SF352', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN 9', 245763),
(360216, 'PTHR23213:SF276', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN 1', 245763),
(360217, 'PTHR23213:SF177', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN 11', 245763),
(360218, 'PTHR23213:SF375', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 245763),
(360219, 'PTHR23213:SF353', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN 10', 245763),
(360220, 'PTHR23213:SF354', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN 4', 245763),
(360221, 'PTHR23213', NULL, NULL, NULL, NULL, 'FORMIN-RELATED', 245763),
(360222, 'PTHR23213:SF376', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 245763),
(360223, 'PTHR23213:SF377', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 245763),
(360224, 'PTHR23213:SF338', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN 6', 245763),
(360225, 'PTHR23213:SF339', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN 4', 245763),
(360226, 'PTHR43828:SF3', NULL, NULL, NULL, NULL, 'C.ELEGANS CHROMODOMAIN PROTEIN', 245764),
(360227, 'PTHR43828:SF15', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MBP1', 245764),
(360228, 'PTHR43828:SF16', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE-RELATED PROTEIN RES1/SCT1', 245764),
(360229, 'PTHR43828', NULL, NULL, NULL, NULL, 'ASPARAGINASE', 245764),
(360230, 'PTHR43828:SF10', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING PROTEIN YAR1', 245764),
(360231, 'PTHR43828:SF13', NULL, NULL, NULL, NULL, 'L-ASPARAGINASE 1-RELATED', 245764),
(360232, 'PTHR43828:SF7', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN SWI4', 245764),
(360233, 'PTHR43828:SF14', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR XBP1', 245764),
(360234, 'PTHR43828:SF5', NULL, NULL, NULL, NULL, 'HTH APSES-TYPE DOMAIN-CONTAINING PROTEIN', 245764),
(360235, 'PTHR43828:SF11', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR XBP1 (EUROFUNG)-RELATED', 245764),
(360236, 'PTHR31165:SF8', NULL, NULL, NULL, NULL, 'PROTEIN LIGHT-DEPENDENT SHORT HYPOCOTYLS 9', 245765),
(360237, 'PTHR31165:SF18', NULL, NULL, NULL, NULL, 'PROTEIN G1-LIKE8', 245765),
(360238, 'PTHR31165:SF110', NULL, NULL, NULL, NULL, 'ALOG DOMAIN-CONTAINING PROTEIN', 245765),
(360239, 'PTHR31165:SF2', NULL, NULL, NULL, NULL, 'PROTEIN G1-LIKE1', 245765),
(360240, 'PTHR31165:SF115', NULL, NULL, NULL, NULL, 'PROTEIN LIGHT-DEPENDENT SHORT HYPOCOTYLS 4', 245765),
(360241, 'PTHR31165:SF116', NULL, NULL, NULL, NULL, 'ALOG DOMAIN-CONTAINING PROTEIN', 245765),
(360242, 'PTHR31165:SF117', NULL, NULL, NULL, NULL, 'ALOG DOMAIN-CONTAINING PROTEIN', 245765),
(360243, 'PTHR31165:SF118', NULL, NULL, NULL, NULL, 'G1-LIKE PROTEIN', 245765),
(360244, 'PTHR31165:SF111', NULL, NULL, NULL, NULL, 'PROTEIN LIGHT-DEPENDENT SHORT HYPOCOTYLS 10-LIKE', 245765),
(360245, 'PTHR31165:SF112', NULL, NULL, NULL, NULL, 'PROTEIN LIGHT-DEPENDENT SHORT HYPOCOTYLS 5', 245765),
(360246, 'PTHR31165:SF113', NULL, NULL, NULL, NULL, 'PROTEIN G1-LIKE9', 245765),
(360247, 'PTHR31165:SF114', NULL, NULL, NULL, NULL, 'PROTEIN LIGHT-DEPENDENT SHORT HYPOCOTYLS 1-LIKE', 245765),
(360248, 'PTHR31165:SF92', NULL, NULL, NULL, NULL, 'ALOG DOMAIN-CONTAINING PROTEIN', 245765),
(360249, 'PTHR31165:SF70', NULL, NULL, NULL, NULL, 'PROTEIN LIGHT-DEPENDENT SHORT HYPOCOTYLS 1', 245765),
(360250, 'PTHR31165:SF71', NULL, NULL, NULL, NULL, 'PROTEIN G1', 245765);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(360251, 'PTHR31165:SF90', NULL, NULL, NULL, NULL, 'ALOG DOMAIN-CONTAINING PROTEIN-RELATED', 245765),
(360252, 'PTHR31165:SF91', NULL, NULL, NULL, NULL, 'ALOG DOMAIN-CONTAINING PROTEIN', 245765),
(360253, 'PTHR31165:SF119', NULL, NULL, NULL, NULL, 'PROTEIN LIGHT-DEPENDENT SHORT HYPOCOTYLS 4-LIKE', 245765),
(360254, 'PTHR31165:SF74', NULL, NULL, NULL, NULL, 'PROTEIN LIGHT-DEPENDENT SHORT HYPOCOTYLS 10-LIKE', 245765),
(360255, 'PTHR31165:SF75', NULL, NULL, NULL, NULL, 'PROTEIN LIGHT-DEPENDENT SHORT HYPOCOTYLS 10-LIKE', 245765),
(360256, 'PTHR31165:SF94', NULL, NULL, NULL, NULL, 'ALOG DOMAIN-CONTAINING PROTEIN', 245765),
(360257, 'PTHR31165:SF95', NULL, NULL, NULL, NULL, 'PROTEIN LIGHT-DEPENDENT SHORT HYPOCOTYLS 3', 245765),
(360258, 'PTHR31165:SF51', NULL, NULL, NULL, NULL, 'PROTEIN LIGHT-DEPENDENT SHORT HYPOCOTYLS 10-LIKE', 245765),
(360259, 'PTHR31165:SF78', NULL, NULL, NULL, NULL, 'PROTEIN G1-LIKE7', 245765),
(360260, 'PTHR31165:SF76', NULL, NULL, NULL, NULL, 'ALOG DOMAIN-CONTAINING PROTEIN-RELATED', 245765),
(360261, 'PTHR31165:SF10', NULL, NULL, NULL, NULL, 'PROTEIN LIGHT-DEPENDENT SHORT HYPOCOTYLS 10', 245765),
(360262, 'PTHR31165', NULL, NULL, NULL, NULL, 'PROTEIN G1-LIKE2', 245765),
(360263, 'PTHR31165:SF9', NULL, NULL, NULL, NULL, 'PROTEIN LIGHT-DEPENDENT SHORT HYPOCOTYLS 7-RELATED', 245765),
(360264, 'PTHR31165:SF59', NULL, NULL, NULL, NULL, 'PROTEIN LIGHT-DEPENDENT SHORT HYPOCOTYLS 6', 245765),
(360265, 'PTHR31165:SF120', NULL, NULL, NULL, NULL, 'PROTEIN G1-LIKE2', 245765),
(360266, 'PTHR31165:SF107', NULL, NULL, NULL, NULL, 'PROTEIN LIGHT-DEPENDENT SHORT HYPOCOTYLS 4-LIKE', 245765),
(360267, 'PTHR31165:SF100', NULL, NULL, NULL, NULL, 'ALOG DOMAIN-CONTAINING PROTEIN', 245765),
(360268, 'PTHR31165:SF103', NULL, NULL, NULL, NULL, 'ALOG DOMAIN-CONTAINING PROTEIN', 245765),
(360269, 'PTHR31165:SF81', NULL, NULL, NULL, NULL, 'ALOG DOMAIN-CONTAINING PROTEIN', 245765),
(360270, 'PTHR31165:SF80', NULL, NULL, NULL, NULL, 'G1-LIKE PROTEIN', 245765),
(360271, 'PTHR31165:SF85', NULL, NULL, NULL, NULL, 'ALOG DOMAIN-CONTAINING PROTEIN', 245765),
(360272, 'PTHR31165:SF108', NULL, NULL, NULL, NULL, 'ALOG DOMAIN-CONTAINING PROTEIN', 245765),
(360273, 'PTHR31165:SF109', NULL, NULL, NULL, NULL, 'DUF640 FAMILY PROTEIN', 245765),
(360274, 'PTHR31165:SF64', NULL, NULL, NULL, NULL, 'PROTEIN LIGHT-DEPENDENT SHORT HYPOCOTYLS 5', 245765),
(360275, 'PTHR31165:SF40', NULL, NULL, NULL, NULL, 'PROTEIN G1-LIKE4', 245765),
(360276, 'PTHR31165:SF84', NULL, NULL, NULL, NULL, 'ALOG DOMAIN-CONTAINING PROTEIN', 245765),
(360277, 'PTHR31165:SF68', NULL, NULL, NULL, NULL, 'ALOG DOMAIN-CONTAINING PROTEIN', 245765),
(360278, 'PTHR31165:SF87', NULL, NULL, NULL, NULL, 'ALOG DOMAIN-CONTAINING PROTEIN', 245765),
(360279, 'PTHR31165:SF43', NULL, NULL, NULL, NULL, 'PROTEIN G1-LIKE3', 245765),
(360280, 'PTHR31165:SF49', NULL, NULL, NULL, NULL, 'PROTEIN LIGHT-DEPENDENT SHORT HYPOCOTYLS 2', 245765),
(360281, 'PTHR31165:SF69', NULL, NULL, NULL, NULL, 'ALOG DOMAIN-CONTAINING PROTEIN', 245765),
(360282, 'PTHR40743:SF1', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-DIPHOSPHO-SUGAR TRANSFERASE CONTAINING PROTEIN', 245766),
(360283, 'PTHR40743', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-DIPHOSPHO-SUGAR TRANSFERASE CONTAINING PROTEIN', 245766),
(360284, 'PTHR34391:SF1', NULL, NULL, NULL, NULL, 'UPF0658 GOLGI APPARATUS MEMBRANE PROTEIN C1952.10C-RELATED', 245767),
(360285, 'PTHR34391:SF2', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 245767),
(360286, 'PTHR34391', NULL, NULL, NULL, NULL, 'UPF0658 GOLGI APPARATUS MEMBRANE PROTEIN C1952.10C-RELATED', 245767),
(360287, 'PTHR23341:SF2', NULL, NULL, NULL, NULL, 'HMG', 245768),
(360288, 'PTHR23341:SF1', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP PROTEIN HMG-I/HMG-Y', 245768),
(360289, 'PTHR23341:SF9', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP PROTEIN HMG-I/HMG-Y', 245768),
(360290, 'PTHR23341:SF6', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP AT-HOOK PROTEIN 1', 245768),
(360291, 'PTHR23341', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP PROTEINS HMG-A AND C', 245768),
(360292, 'PTHR23341:SF7', NULL, NULL, NULL, NULL, '', 245768);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(360293, 'PTHR23341:SF4', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP PROTEIN HMGI-C', 245768),
(360294, 'PTHR23341:SF5', NULL, NULL, NULL, NULL, '', 245768),
(360295, 'PTHR48022:SF72', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G06720)-RELATED', 245769),
(360296, 'PTHR48022:SF73', NULL, NULL, NULL, NULL, 'METABOLITE TRANSPORT PROTEIN YDL199C-RELATED', 245769),
(360297, 'PTHR48022:SF70', NULL, NULL, NULL, NULL, 'MONOSACCHARIDE TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G14540)-RELATED', 245769),
(360298, 'PTHR48022:SF71', NULL, NULL, NULL, NULL, 'ALPHA-GLUCOSIDE TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G02650)-RELATED', 245769),
(360299, 'PTHR48022:SF76', NULL, NULL, NULL, NULL, 'MALTOSE PERMEASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G07240)-RELATED', 245769),
(360300, 'PTHR48022:SF33', NULL, NULL, NULL, NULL, 'SUGAR PERMEASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G12040)-RELATED', 245769),
(360301, 'PTHR48022:SF77', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245769),
(360302, 'PTHR48022:SF30', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245769),
(360303, 'PTHR48022:SF74', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G02010)-RELATED', 245769),
(360304, 'PTHR48022:SF75', NULL, NULL, NULL, NULL, 'GALACTOSE TRANSPORTER-RELATED', 245769),
(360305, 'PTHR48022:SF31', NULL, NULL, NULL, NULL, 'HEXOSE TRANSPORTER', 245769),
(360306, 'PTHR48022:SF36', NULL, NULL, NULL, NULL, 'LACTOSE PERMEASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G17310)-RELATED', 245769),
(360307, 'PTHR48022:SF37', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245769),
(360308, 'PTHR48022:SF34', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245769),
(360309, 'PTHR48022:SF78', NULL, NULL, NULL, NULL, 'MONOSACCHARIDE TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G02110)-RELATED', 245769),
(360310, 'PTHR48022:SF79', NULL, NULL, NULL, NULL, 'LACTOSE PERMEASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G01860)-RELATED', 245769),
(360311, 'PTHR48022:SF35', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245769),
(360312, 'PTHR48022:SF38', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245769),
(360313, 'PTHR48022:SF39', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245769),
(360314, 'PTHR48022:SF80', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G12170)-RELATED', 245769),
(360315, 'PTHR48022:SF83', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245769),
(360316, 'PTHR48022:SF40', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245769),
(360317, 'PTHR48022:SF84', NULL, NULL, NULL, NULL, 'MONOSACCHARIDE SUGAR TRANSPORTER-RELATED', 245769),
(360318, 'PTHR48022:SF81', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 245769),
(360319, 'PTHR48022:SF87', NULL, NULL, NULL, NULL, 'PLASTIDIC GLC TRANSLOCATOR-RELATED', 245769),
(360320, 'PTHR48022:SF43', NULL, NULL, NULL, NULL, 'QUINATE TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G16230)-RELATED', 245769),
(360321, 'PTHR48022:SF44', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G14610)-RELATED', 245769),
(360322, 'PTHR48022:SF88', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245769),
(360323, 'PTHR48022:SF85', NULL, NULL, NULL, NULL, 'OS09G0394500 PROTEIN', 245769),
(360324, 'PTHR48022:SF41', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245769),
(360325, 'PTHR48022:SF42', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245769),
(360326, 'PTHR48022:SF86', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY HEXOSE TRANSPORTER GHT7-RELATED', 245769),
(360327, 'PTHR48022:SF47', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245769),
(360328, 'PTHR48022:SF48', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G06730)-RELATED', 245769),
(360329, 'PTHR48022:SF89', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY GLUCOSE TRANSPORTER GHT2', 245769),
(360330, 'PTHR48022:SF45', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245769);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(360331, 'PTHR48022:SF46', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G11830)-RELATED', 245769),
(360332, 'PTHR48022:SF49', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G01340)-RELATED', 245769),
(360333, 'PTHR48022:SF90', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY GLUCONATE TRANSPORTER GHT3-RELATED', 245769),
(360334, 'PTHR48022:SF50', NULL, NULL, NULL, NULL, 'HEXOSE TRANSPORTER HXT14', 245769),
(360335, 'PTHR48022:SF51', NULL, NULL, NULL, NULL, 'ALPHA-GLUCOSIDE TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G11920)-RELATED', 245769),
(360336, 'PTHR48022:SF54', NULL, NULL, NULL, NULL, 'GLUCOSE TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G00890)-RELATED', 245769),
(360337, 'PTHR48022:SF10', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245769),
(360338, 'PTHR48022:SF55', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER STL1', 245769),
(360339, 'PTHR48022:SF11', NULL, NULL, NULL, NULL, 'MONOSACCHARIDE TRANSPORTER (HXT8), PUTATIVE (AFU_ORTHOLOGUE AFUA_2G08120)-RELATED', 245769),
(360340, 'PTHR48022:SF52', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER, PUTATIVE-RELATED', 245769),
(360341, 'PTHR48022:SF53', NULL, NULL, NULL, NULL, 'ALPHA-GLUCOSIDE TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G01700)-RELATED', 245769),
(360342, 'PTHR48022:SF14', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245769),
(360343, 'PTHR48022:SF59', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245769),
(360344, 'PTHR48022:SF15', NULL, NULL, NULL, NULL, 'ALPHA-GLUCOSIDE TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G00500)-RELATED', 245769),
(360345, 'PTHR48022:SF12', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245769),
(360346, 'PTHR48022:SF56', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245769),
(360347, 'PTHR48022:SF57', NULL, NULL, NULL, NULL, 'MALTOSE TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G00150)-RELATED', 245769),
(360348, 'PTHR48022:SF13', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245769),
(360349, 'PTHR48022:SF18', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR, SUGAR TRANSPORTER, MAJOR FACILITATOR SUPERFAMILY-RELATED', 245769),
(360350, 'PTHR48022:SF19', NULL, NULL, NULL, NULL, 'HIGH AFFINITY GLUCOSE TRANSPORTER GHT1', 245769),
(360351, 'PTHR48022:SF16', NULL, NULL, NULL, NULL, 'HIGH GLUCOSE SENSOR RGT2-RELATED', 245769),
(360352, 'PTHR48022:SF17', NULL, NULL, NULL, NULL, 'HEXOSE TRANSPORTER-RELATED', 245769),
(360353, 'PTHR48022:SF61', NULL, NULL, NULL, NULL, 'HIGH AFFINITY GLUCOSE TRANSPORTER RGT2', 245769),
(360354, 'PTHR48022:SF62', NULL, NULL, NULL, NULL, 'HEXOSE CARRIER PROTEIN', 245769),
(360355, 'PTHR48022:SF60', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245769),
(360356, 'PTHR48022:SF21', NULL, NULL, NULL, NULL, 'QUINATE TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G06960)-RELATED', 245769),
(360357, 'PTHR48022:SF66', NULL, NULL, NULL, NULL, 'MFS HEXOSE TRANSPORTER', 245769),
(360358, 'PTHR48022:SF22', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245769),
(360359, 'PTHR48022:SF63', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE-RELATED', 245769),
(360360, 'PTHR48022:SF64', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245769),
(360361, 'PTHR48022:SF20', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245769),
(360362, 'PTHR48022:SF25', NULL, NULL, NULL, NULL, 'QUINATE TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G12950)-RELATED', 245769),
(360363, 'PTHR48022:SF5', NULL, NULL, NULL, NULL, 'ALPHA-GLUCOSIDES PERMEASE MPH2-RELATED', 245769),
(360364, 'PTHR48022:SF69', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245769),
(360365, 'PTHR48022:SF26', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245769),
(360366, 'PTHR48022:SF6', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245769),
(360367, 'PTHR48022:SF67', NULL, NULL, NULL, NULL, 'QUINATE TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G14670)-RELATED', 245769),
(360368, 'PTHR48022:SF23', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245769);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(360369, 'PTHR48022:SF3', NULL, NULL, NULL, NULL, 'HEXOSE TRANSPORTER PROTEIN (AFU_ORTHOLOGUE AFUA_8G04480)-RELATED', 245769),
(360370, 'PTHR48022:SF4', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245769),
(360371, 'PTHR48022:SF68', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245769),
(360372, 'PTHR48022:SF24', NULL, NULL, NULL, NULL, 'HEXOSE TRANSPORTER PROTEIN (AFU_ORTHOLOGUE AFUA_8G04480)', 245769),
(360373, 'PTHR48022:SF1', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G06720)-RELATED', 245769),
(360374, 'PTHR48022', NULL, NULL, NULL, NULL, 'PLASTIDIC GLUCOSE TRANSPORTER 4', 245769),
(360375, 'PTHR48022:SF29', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G14500)-RELATED', 245769),
(360376, 'PTHR48022:SF2', NULL, NULL, NULL, NULL, 'PLASTIDIC GLUCOSE TRANSPORTER 4', 245769),
(360377, 'PTHR48022:SF27', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245769),
(360378, 'PTHR48022:SF28', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G02890)-RELATED', 245769),
(360379, 'PTHR48022:SF9', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245769),
(360380, 'PTHR48022:SF7', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245769),
(360381, 'PTHR48022:SF8', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 245769),
(360382, 'PTHR40590:SF1', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 245770),
(360383, 'PTHR40590', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 245770),
(360384, 'PTHR43382:SF2', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL GLUTAMATE/PROLINE--TRNA LIGASE', 245771),
(360385, 'PTHR43382:SF3', NULL, NULL, NULL, NULL, 'PROLINE--TRNA LIGASE, CHLOROPLASTIC/MITOCHONDRIAL', 245771),
(360386, 'PTHR43382:SF4', NULL, NULL, NULL, NULL, 'PROLYL-TRNA SYNTHETASE', 245771),
(360387, 'PTHR43382', NULL, NULL, NULL, NULL, 'PROLYL-TRNA SYNTHETASE', 245771),
(360388, 'PTHR43382:SF10', NULL, NULL, NULL, NULL, 'PROLYL-TRNA SYNTHETASE', 245771),
(360389, 'PTHR43382:SF7', NULL, NULL, NULL, NULL, 'AA_TRNA_LIGASE_II DOMAIN-CONTAINING PROTEIN', 245771),
(360390, 'PTHR43382:SF8', NULL, NULL, NULL, NULL, 'PROLYL-TRNA SYNTHETASE', 245771),
(360391, 'PTHR43382:SF12', NULL, NULL, NULL, NULL, 'PROLYL-TRNA SYNTHETASE', 245771),
(360392, 'PTHR41404:SF1', NULL, NULL, NULL, NULL, 'SHIELDIN COMPLEX SUBUNIT 3', 245772),
(360393, 'PTHR41404', NULL, NULL, NULL, NULL, 'SHIELDIN COMPLEX SUBUNIT 3', 245772),
(360394, 'PTHR12280', NULL, NULL, NULL, NULL, 'PANTOTHENATE KINASE', 245773),
(360395, 'PTHR12280:SF30', NULL, NULL, NULL, NULL, 'FUMBLE', 245773),
(360396, 'PTHR12280:SF40', NULL, NULL, NULL, NULL, 'PANTOTHENATE KINASE', 245773),
(360397, 'PTHR12280:SF39', NULL, NULL, NULL, NULL, 'PANTOTHENATE KINASE 2', 245773),
(360398, 'PTHR12280:SF21', NULL, NULL, NULL, NULL, 'PANTOTHENATE KINASE 3', 245773),
(360399, 'PTHR12280:SF20', NULL, NULL, NULL, NULL, '4''-PHOSPHOPANTETHEINE PHOSPHATASE', 245773),
(360400, 'PTHR12280:SF34', NULL, NULL, NULL, NULL, 'PANTOTHENATE KINASE 1', 245773),
(360401, 'PTHR12280:SF23', NULL, NULL, NULL, NULL, 'PANTOTHENATE KINASE 1', 245773),
(360402, 'PTHR12280:SF25', NULL, NULL, NULL, NULL, 'PANTOTHENATE KINASE 2, MITOCHONDRIAL', 245773),
(360403, 'PTHR12280:SF36', NULL, NULL, NULL, NULL, 'PANTOTHENATE KINASE 1', 245773),
(360404, 'PTHR12280:SF35', NULL, NULL, NULL, NULL, '4''-PHOSPHOPANTETHEINE PHOSPHATASE', 245773),
(360405, 'PTHR12280:SF38', NULL, NULL, NULL, NULL, 'DUF89 DOMAIN-CONTAINING PROTEIN', 245773),
(360406, 'PTHR12280:SF37', NULL, NULL, NULL, NULL, '', 245773),
(360407, 'PTHR21110', NULL, NULL, NULL, NULL, 'PHOSPHOPENTOMUTASE', 245774),
(360408, 'PTHR21110:SF0', NULL, NULL, NULL, NULL, 'PHOSPHOPENTOMUTASE', 245774),
(360409, 'PTHR42792', NULL, NULL, NULL, NULL, 'FLAGELLIN', 245775),
(360410, 'PTHR42792:SF2', NULL, NULL, NULL, NULL, 'FLAGELLIN', 245775),
(360411, 'PTHR42792:SF1', NULL, NULL, NULL, NULL, 'FLAGELLAR HOOK-ASSOCIATED PROTEIN 3', 245775),
(360412, 'PTHR31875:SF31', NULL, NULL, NULL, NULL, 'PROTEIN DEHYDRATION-INDUCED 19 HOMOLOG 4', 245776);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(360413, 'PTHR31875:SF42', NULL, NULL, NULL, NULL, '', 245776),
(360414, 'PTHR31875:SF30', NULL, NULL, NULL, NULL, 'PROTEIN DEHYDRATION-INDUCED 19 HOMOLOG 4-LIKE', 245776),
(360415, 'PTHR31875:SF33', NULL, NULL, NULL, NULL, 'ZF-DI19 DOMAIN-CONTAINING PROTEIN', 245776),
(360416, 'PTHR31875:SF35', NULL, NULL, NULL, NULL, 'BNAA01G32630D PROTEIN', 245776),
(360417, 'PTHR31875:SF24', NULL, NULL, NULL, NULL, 'PROTEIN DEHYDRATION-INDUCED 19 HOMOLOG 5', 245776),
(360418, 'PTHR31875:SF34', NULL, NULL, NULL, NULL, 'PROTEIN DEHYDRATION-INDUCED 19 HOMOLOG 2', 245776),
(360419, 'PTHR31875:SF23', NULL, NULL, NULL, NULL, 'PROTEIN DEHYDRATION-INDUCED 19 HOMOLOG 4', 245776),
(360420, 'PTHR31875:SF37', NULL, NULL, NULL, NULL, 'PROTEIN DEHYDRATION-INDUCED 19 HOMOLOG 3-LIKE ISOFORM X1', 245776),
(360421, 'PTHR31875:SF26', NULL, NULL, NULL, NULL, 'PROTEIN DEHYDRATION-INDUCED 19-RELATED', 245776),
(360422, 'PTHR31875:SF25', NULL, NULL, NULL, NULL, 'PROTEIN DEHYDRATION-INDUCED 19 HOMOLOG 5', 245776),
(360423, 'PTHR31875:SF36', NULL, NULL, NULL, NULL, 'PROTEIN DEHYDRATION-INDUCED 19 HOMOLOG 4-LIKE', 245776),
(360424, 'PTHR31875:SF28', NULL, NULL, NULL, NULL, 'PROTEIN DEHYDRATION-INDUCED 19 HOMOLOG 5-LIKE ISOFORM X1', 245776),
(360425, 'PTHR31875:SF27', NULL, NULL, NULL, NULL, 'PROTEIN DEHYDRATION-INDUCED 19 HOMOLOG 7', 245776),
(360426, 'PTHR31875', NULL, NULL, NULL, NULL, 'PROTEIN DEHYDRATION-INDUCED 19', 245776),
(360427, 'PTHR31875:SF9', NULL, NULL, NULL, NULL, 'PROTEIN DEHYDRATION-INDUCED 19 HOMOLOG 6', 245776),
(360428, 'PTHR31875:SF6', NULL, NULL, NULL, NULL, 'PROTEIN DEHYDRATION-INDUCED 19', 245776),
(360429, 'PTHR31875:SF4', NULL, NULL, NULL, NULL, 'PROTEIN DEHYDRATION-INDUCED 19 HOMOLOG 3', 245776),
(360430, 'PTHR22883:SF356', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360431, 'PTHR22883:SF357', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360432, 'PTHR22883:SF113', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360433, 'PTHR22883:SF352', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360434, 'PTHR22883:SF71', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE ZDHHC9', 245777),
(360435, 'PTHR22883:SF406', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360436, 'PTHR22883:SF405', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE', 245777),
(360437, 'PTHR22883:SF127', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360438, 'PTHR22883:SF246', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE ZDHHC3', 245777),
(360439, 'PTHR22883:SF338', NULL, NULL, NULL, NULL, 'PROTEIN S-ACYLTRANSFERASE 20-RELATED', 245777),
(360440, 'PTHR22883:SF459', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360441, 'PTHR22883:SF339', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360442, 'PTHR22883:SF457', NULL, NULL, NULL, NULL, 'PROTEIN S-ACYLTRANSFERASE 13-RELATED', 245777),
(360443, 'PTHR22883:SF11', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE ZDHHC21', 245777),
(360444, 'PTHR22883:SF458', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE', 245777),
(360445, 'PTHR22883:SF455', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE ZDHHC23-A', 245777),
(360446, 'PTHR22883:SF213', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE ZDHHC22', 245777),
(360447, 'PTHR22883:SF456', NULL, NULL, NULL, NULL, 'PROTEIN S-ACYLTRANSFERASE 2-RELATED', 245777),
(360448, 'PTHR22883:SF453', NULL, NULL, NULL, NULL, 'ZDHHC-TYPE PALMITOYLTRANSFERASE 3-RELATED', 245777),
(360449, 'PTHR22883:SF299', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360450, 'PTHR22883:SF454', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360451, 'PTHR22883:SF451', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE', 245777),
(360452, 'PTHR22883:SF297', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360453, 'PTHR22883:SF452', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE', 245777),
(360454, 'PTHR22883:SF331', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360455, 'PTHR22883:SF296', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360456, 'PTHR22883:SF450', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(360457, 'PTHR22883:SF98', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE ZDHHC20-A', 245777),
(360458, 'PTHR22883:SF349', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360459, 'PTHR22883', NULL, NULL, NULL, NULL, 'ZINC FINGER DHHC DOMAIN CONTAINING PROTEIN', 245777),
(360460, 'PTHR22883:SF105', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360461, 'PTHR22883:SF347', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360462, 'PTHR22883:SF348', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE ZDHHC18-B', 245777),
(360463, 'PTHR22883:SF346', NULL, NULL, NULL, NULL, 'PROTEIN S-ACYLTRANSFERASE 12-RELATED', 245777),
(360464, 'PTHR22883:SF464', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360465, 'PTHR22883:SF462', NULL, NULL, NULL, NULL, 'PROTEIN S-ACYLTRANSFERASE 16-RELATED', 245777),
(360466, 'PTHR22883:SF463', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360467, 'PTHR22883:SF460', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360468, 'PTHR22883:SF461', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE ZDHHC23-B', 245777),
(360469, 'PTHR22883:SF318', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE-RELATED', 245777),
(360470, 'PTHR22883:SF439', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360471, 'PTHR22883:SF437', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE', 245777),
(360472, 'PTHR22883:SF316', NULL, NULL, NULL, NULL, 'PROTEIN S-ACYLTRANSFERASE 21', 245777),
(360473, 'PTHR22883:SF438', NULL, NULL, NULL, NULL, 'PROTEIN S-ACYLTRANSFERASE 7-RELATED', 245777),
(360474, 'PTHR22883:SF317', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360475, 'PTHR22883:SF435', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE ZDHHC12', 245777),
(360476, 'PTHR22883:SF436', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360477, 'PTHR22883:SF312', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360478, 'PTHR22883:SF433', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE', 245777),
(360479, 'PTHR22883:SF434', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360480, 'PTHR22883:SF431', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE PFA5', 245777),
(360481, 'PTHR22883:SF398', NULL, NULL, NULL, NULL, 'PROTEIN S-ACYLTRANSFERASE 15-RELATED', 245777),
(360482, 'PTHR22883:SF432', NULL, NULL, NULL, NULL, 'PROTEIN S-ACYLTRANSFERASE 5-RELATED', 245777),
(360483, 'PTHR22883:SF278', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360484, 'PTHR22883:SF396', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE PFA5', 245777),
(360485, 'PTHR22883:SF397', NULL, NULL, NULL, NULL, 'PROTEIN S-ACYLTRANSFERASE 6-RELATED', 245777),
(360486, 'PTHR22883:SF430', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE', 245777),
(360487, 'PTHR22883:SF394', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360488, 'PTHR22883:SF393', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360489, 'PTHR22883:SF390', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360490, 'PTHR22883:SF270', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE ZDHHC15', 245777),
(360491, 'PTHR22883:SF391', NULL, NULL, NULL, NULL, 'PROTEIN S-ACYLTRANSFERASE 4-RELATED', 245777),
(360492, 'PTHR22883:SF448', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE', 245777),
(360493, 'PTHR22883:SF207', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE ZDHHC2', 245777),
(360494, 'PTHR22883:SF449', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE', 245777),
(360495, 'PTHR22883:SF22', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE ZDHHC11-RELATED', 245777),
(360496, 'PTHR22883:SF446', NULL, NULL, NULL, NULL, 'ZDHHC-TYPE PALMITOYLTRANSFERASE 2-RELATED', 245777),
(360497, 'PTHR22883:SF326', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE ZDHHC19', 245777),
(360498, 'PTHR22883:SF23', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE ZDHHC6', 245777),
(360499, 'PTHR22883:SF447', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360500, 'PTHR22883:SF444', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360501, 'PTHR22883:SF203', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE', 245777),
(360502, 'PTHR22883:SF324', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777);
INSERT INTO "PUBLIC"."MODEL" VALUES
(360503, 'PTHR22883:SF445', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE', 245777),
(360504, 'PTHR22883:SF8', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE ZDHHC1', 245777),
(360505, 'PTHR22883:SF442', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE', 245777),
(360506, 'PTHR22883:SF288', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE SWF1', 245777),
(360507, 'PTHR22883:SF443', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360508, 'PTHR22883:SF286', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE ZDHHC4', 245777),
(360509, 'PTHR22883:SF28', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE ZDHHC14', 245777),
(360510, 'PTHR22883:SF440', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360511, 'PTHR22883:SF320', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360512, 'PTHR22883:SF441', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360513, 'PTHR22883:SF284', NULL, NULL, NULL, NULL, 'PROTEIN S-ACYLTRANSFERASE 1-RELATED', 245777),
(360514, 'PTHR22883:SF285', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360515, 'PTHR22883:SF419', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360516, 'PTHR22883:SF417', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE ZDHHC20', 245777),
(360517, 'PTHR22883:SF418', NULL, NULL, NULL, NULL, 'ZDHHC-TYPE PALMITOYLTRANSFERASE 1-RELATED', 245777),
(360518, 'PTHR22883:SF416', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE', 245777),
(360519, 'PTHR22883:SF413', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360520, 'PTHR22883:SF414', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE ZDHHC24-RELATED', 245777),
(360521, 'PTHR22883:SF411', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360522, 'PTHR22883:SF57', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360523, 'PTHR22883:SF257', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE ZDHHC18', 245777),
(360524, 'PTHR22883:SF410', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE', 245777),
(360525, 'PTHR22883:SF130', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360526, 'PTHR22883:SF370', NULL, NULL, NULL, NULL, 'ZDHHC-TYPE PALMITOYLTRANSFERASE 8-RELATED', 245777),
(360527, 'PTHR22883:SF428', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360528, 'PTHR22883:SF429', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360529, 'PTHR22883:SF306', NULL, NULL, NULL, NULL, 'PROTEIN S-ACYLTRANSFERASE 18', 245777),
(360530, 'PTHR22883:SF427', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE', 245777),
(360531, 'PTHR22883:SF424', NULL, NULL, NULL, NULL, 'PROTEIN S-ACYLTRANSFERASE 8', 245777),
(360532, 'PTHR22883:SF425', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE', 245777),
(360533, 'PTHR22883:SF422', NULL, NULL, NULL, NULL, 'PROTEIN S-ACYLTRANSFERASE 3-RELATED', 245777),
(360534, 'PTHR22883:SF147', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE', 245777),
(360535, 'PTHR22883:SF301', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE ZDHHC23', 245777),
(360536, 'PTHR22883:SF423', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360537, 'PTHR22883:SF267', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360538, 'PTHR22883:SF49', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE ZDHHC7', 245777),
(360539, 'PTHR22883:SF421', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360540, 'PTHR22883:SF385', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 245777),
(360541, 'PTHR22883:SF386', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE', 245777),
(360542, 'PTHR22883:SF265', NULL, NULL, NULL, NULL, 'PROTEIN S-ACYLTRANSFERASE 22-RELATED', 245777),
(360543, 'PTHR22883:SF381', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE', 245777),
(360544, 'PTHR22883:SF40', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE', 245777),
(360545, 'PTHR22883:SF43', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE APP', 245777),
(360546, 'PTHR15160:SF15', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL NUCLEASE 1-LIKE ISOFORM X1', 245778),
(360547, 'PTHR15160:SF9', NULL, NULL, NULL, NULL, 'ZGC:194223 PROTEIN', 245778),
(360548, 'PTHR15160', NULL, NULL, NULL, NULL, 'VON HIPPEL-LINDAU PROTEIN', 245778),
(360549, 'PTHR15160:SF10', NULL, NULL, NULL, NULL, 'VON HIPPEL-LINDAU TUMOR SUPPRESSOR', 245778);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(360550, 'PTHR15160:SF3', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL NUCLEASE 1', 245778),
(360551, 'PTHR15160:SF12', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL NUCLEASE 2', 245778),
(360552, 'PTHR15160:SF1', NULL, NULL, NULL, NULL, 'VON HIPPEL-LINDAU DISEASE TUMOR SUPPRESSOR', 245778),
(360553, 'PTHR15160:SF13', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL NUCLEASE 1', 245778),
(360554, 'PTHR46746', NULL, NULL, NULL, NULL, 'KILLER CELL LECTIN-LIKE RECEPTOR SUBFAMILY F MEMBER 2', 245779),
(360555, 'PTHR46746:SF6', NULL, NULL, NULL, NULL, 'KILLER CELL LECTIN-LIKE RECEPTOR SUBFAMILY F MEMBER 2', 245779),
(360556, 'PTHR46746:SF4', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN LIKE 1', 245779),
(360557, 'PTHR46746:SF5', NULL, NULL, NULL, NULL, 'KILLER CELL LECTIN-LIKE RECEPTOR SUBFAMILY F MEMBER 1', 245779),
(360558, 'PTHR46746:SF3', NULL, NULL, NULL, NULL, 'KILLER CELL LECTIN-LIKE RECEPTOR SUBFAMILY F MEMBER 1', 245779),
(360559, 'PTHR33273:SF4', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 245780),
(360560, 'PTHR33273', NULL, NULL, NULL, NULL, 'DOMAIN-CONTAINING PROTEIN, PUTATIVE-RELATED', 245780),
(360561, 'PTHR33273:SF2', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 245780),
(360562, 'PTHR43157:SF56', NULL, NULL, NULL, NULL, '', 245781),
(360563, 'PTHR43157:SF35', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE FAMILY PROTEIN, PUTATIVE-RELATED', 245781),
(360564, 'PTHR43157:SF57', NULL, NULL, NULL, NULL, '', 245781),
(360565, 'PTHR43157:SF26', NULL, NULL, NULL, NULL, 'SI:CH211-107O10.3', 245781),
(360566, 'PTHR43157:SF59', NULL, NULL, NULL, NULL, 'RETINOL DEHYDROGENASE 13', 245781),
(360567, 'PTHR43157:SF27', NULL, NULL, NULL, NULL, 'RETINOL DEHYDROGENASE 12,-LIKE-RELATED', 245781),
(360568, 'PTHR43157:SF60', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL GLYCAN ANCHOR BIOSYNTHESIS CLASS F', 245781),
(360569, 'PTHR43157:SF50', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE (SDR FAMILY) MEMBER 13A, DUPLICATE 3', 245781),
(360570, 'PTHR43157:SF61', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE FAMILY PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G01250)-RELATED', 245781),
(360571, 'PTHR43157:SF62', NULL, NULL, NULL, NULL, '', 245781),
(360572, 'PTHR43157:SF51', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE (SDR FAMILY) MEMBER 13-LIKE 1-RELATED', 245781),
(360573, 'PTHR43157:SF30', NULL, NULL, NULL, NULL, 'RETINOL DEHYDROGENASE 12-LIKE', 245781),
(360574, 'PTHR43157:SF52', NULL, NULL, NULL, NULL, 'SHORT CHAIN DEHYDROGENASE ATND-RELATED', 245781),
(360575, 'PTHR43157:SF63', NULL, NULL, NULL, NULL, 'WW DOMAIN-CONTAINING OXIDOREDUCTASE-LIKE PROTEIN', 245781),
(360576, 'PTHR43157:SF64', NULL, NULL, NULL, NULL, 'SI:DKEY-174N20.1', 245781),
(360577, 'PTHR43157:SF53', NULL, NULL, NULL, NULL, '', 245781),
(360578, 'PTHR43157:SF31', NULL, NULL, NULL, NULL, 'DEHYDROGENASES, SHORT CHAIN', 245781),
(360579, 'PTHR43157:SF65', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-GLYCAN BIOSYNTHESIS CLASS F PROTEIN', 245781),
(360580, 'PTHR43157:SF32', NULL, NULL, NULL, NULL, 'RETINOL DEHYDROGENASE 12', 245781),
(360581, 'PTHR43157', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-GLYCAN BIOSYNTHESIS CLASS F PROTEIN-RELATED', 245781),
(360582, 'PTHR43157:SF54', NULL, NULL, NULL, NULL, 'SI:DKEY-23O4.6-RELATED', 245781),
(360583, 'PTHR43157:SF22', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/REDUCTASE PHMF', 245781),
(360584, 'PTHR43157:SF44', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE SDR FAMILY MEMBER 13', 245781),
(360585, 'PTHR37363', NULL, NULL, NULL, NULL, 'EKC/KEOPS COMPLEX SUBUNIT GON7', 245782),
(360586, 'PTHR37363:SF1', NULL, NULL, NULL, NULL, 'EKC/KEOPS COMPLEX SUBUNIT GON7', 245782),
(360587, 'PTHR37078', NULL, NULL, NULL, NULL, '', 245783),
(360588, 'PTHR37078:SF6', NULL, NULL, NULL, NULL, '', 245783),
(360589, 'PTHR37078:SF5', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 245783),
(360590, 'PTHR37078:SF4', NULL, NULL, NULL, NULL, '', 245783),
(360591, 'PTHR47135', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE III DOMAIN-CONTAINING PROTEIN 7', 245784);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(360592, 'PTHR47135:SF1', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE III DOMAIN-CONTAINING PROTEIN 7', 245784),
(360593, 'PTHR47135:SF2', NULL, NULL, NULL, NULL, '', 245784),
(360594, 'PTHR47637', NULL, NULL, NULL, NULL, 'CHAPERONE SURA', 245785),
(360595, 'PTHR47637:SF1', NULL, NULL, NULL, NULL, 'CHAPERONE SURA', 245785),
(360596, 'PTHR12259', NULL, NULL, NULL, NULL, 'RGS-GAIP INTERACTING PROTEIN GIPC', 245786),
(360597, 'PTHR12259:SF1', NULL, NULL, NULL, NULL, 'GH21964P', 245786),
(360598, 'PTHR12259:SF2', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN GIPC3', 245786),
(360599, 'PTHR12259:SF3', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN GIPC2', 245786),
(360600, 'PTHR12259:SF4', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN GIPC1', 245786),
(360601, 'PTHR48183', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 245787),
(360602, 'PTHR48183:SF1', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 245787),
(360603, 'PTHR38696:SF1', NULL, NULL, NULL, NULL, '', 245788),
(360604, 'PTHR38696', NULL, NULL, NULL, NULL, '', 245788),
(360605, 'PTHR40351', NULL, NULL, NULL, NULL, 'PROTEIN CBG19323', 245789),
(360606, 'PTHR40351:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG19321', 245789),
(360607, 'PTHR40351:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG19323', 245789),
(360608, 'PTHR40351:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG19320', 245789),
(360609, 'PTHR40351:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG19325', 245789),
(360610, 'PTHR47821:SF2', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE FAMILY PROTEIN', 245790),
(360611, 'PTHR47821', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE FAMILY PROTEIN', 245790),
(360612, 'PTHR43560:SF1', NULL, NULL, NULL, NULL, 'ION-TRANSLOCATING OXIDOREDUCTASE COMPLEX SUBUNIT B', 245791),
(360613, 'PTHR43560', NULL, NULL, NULL, NULL, 'ION-TRANSLOCATING OXIDOREDUCTASE COMPLEX SUBUNIT B', 245791),
(360614, 'PTHR43081', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE, TERMINAL-DIFFERENTIATION SPECIFIC-RELATED', 245792),
(360615, 'PTHR43081:SF18', NULL, NULL, NULL, NULL, 'BLL7624 PROTEIN', 245792),
(360616, 'PTHR43081:SF16', NULL, NULL, NULL, NULL, 'BLL2853 PROTEIN', 245792),
(360617, 'PTHR43081:SF17', NULL, NULL, NULL, NULL, 'PH-SENSITIVE ADENYLATE CYCLASE RV1264', 245792),
(360618, 'PTHR43081:SF11', NULL, NULL, NULL, NULL, 'BLR2264 PROTEIN', 245792),
(360619, 'PTHR43081:SF1', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE, TERMINAL-DIFFERENTIATION SPECIFIC', 245792),
(360620, 'PTHR22042:SF2', NULL, NULL, NULL, NULL, '182 KDA TANKYRASE-1-BINDING PROTEIN', 245793),
(360621, 'PTHR22042:SF3', NULL, NULL, NULL, NULL, 'SIMILAR TO HYPOTHETICAL PROTEIN A530094D01', 245793),
(360622, 'PTHR22042', NULL, NULL, NULL, NULL, 'TANKYRASE 1 BINDING PROTEIN', 245793),
(360623, 'PTHR15263:SF1', NULL, NULL, NULL, NULL, 'NF-KAPPA-B INHIBITOR-LIKE PROTEIN 1', 245794),
(360624, 'PTHR15263', NULL, NULL, NULL, NULL, 'I-KAPPA-B-LIKE PROTEIN  IKBL', 245794),
(360625, 'PTHR35833', NULL, NULL, NULL, NULL, 'GALACTOSE-BINDING DOMAIN-LIKE, ARMADILLO-TYPE FOLD PROTEIN-RELATED', 245795),
(360626, 'PTHR35833:SF1', NULL, NULL, NULL, NULL, 'GALACTOSE-BINDING DOMAIN-LIKE, ARMADILLO-TYPE FOLD PROTEIN-RELATED', 245795),
(360627, 'PTHR33047:SF32', NULL, NULL, NULL, NULL, '', 245796),
(360628, 'PTHR33047:SF40', NULL, NULL, NULL, NULL, 'SENESCENCE-ASSOCIATED PROTEIN', 245796),
(360629, 'PTHR33047:SF39', NULL, NULL, NULL, NULL, '', 245796),
(360630, 'PTHR33047:SF8', NULL, NULL, NULL, NULL, 'LRRG00136', 245796),
(360631, 'PTHR33047', NULL, NULL, NULL, NULL, 'PROTEIN TAR1', 245796),
(360632, 'PTHR28125:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REGULATOR RUA1', 245797),
(360633, 'PTHR28125', NULL, NULL, NULL, NULL, 'MEIOTIC EXPRESSION UP-REGULATED PROTEIN 26', 245797),
(360634, 'PTHR23520:SF2', NULL, NULL, NULL, NULL, 'ABR173CP', 245798),
(360635, 'PTHR23520:SF5', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G04000)-RELATED', 245798),
(360636, 'PTHR23520', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G04000)-RELATED', 245798),
(360637, 'PTHR47188:SF5', NULL, NULL, NULL, NULL, '', 245799);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(360638, 'PTHR47188:SF1', NULL, NULL, NULL, NULL, 'PROTEIN TAR1', 245799),
(360639, 'PTHR47188', NULL, NULL, NULL, NULL, 'PROTEIN TAR1', 245799),
(360640, 'PTHR47188:SF4', NULL, NULL, NULL, NULL, '', 245799),
(360641, 'PTHR24260:SF145', NULL, NULL, NULL, NULL, 'FI17609P1-RELATED', 245800),
(360642, 'PTHR24260:SF134', NULL, NULL, NULL, NULL, 'AT07769P-RELATED', 245800),
(360643, 'PTHR24260:SF111', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 245800),
(360644, 'PTHR24260:SF144', NULL, NULL, NULL, NULL, 'IP19864P-RELATED', 245800),
(360645, 'PTHR24260:SF136', NULL, NULL, NULL, NULL, 'GH08193P-RELATED', 245800),
(360646, 'PTHR24260:SF147', NULL, NULL, NULL, NULL, 'EG:BACR7A4.3 PROTEIN-RELATED', 245800),
(360647, 'PTHR24260:SF146', NULL, NULL, NULL, NULL, 'MODULAR SERINE PROTEASE', 245800),
(360648, 'PTHR24260:SF135', NULL, NULL, NULL, NULL, 'CLIP DOMAIN-CONTAINING SERINE PROTEASE-RELATED', 245800),
(360649, 'PTHR24260:SF138', NULL, NULL, NULL, NULL, 'IP10340P-RELATED', 245800),
(360650, 'PTHR24260:SF139', NULL, NULL, NULL, NULL, 'CLIP DOMAIN-CONTAINING SERINE PROTEASE', 245800),
(360651, 'PTHR24260:SF106', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 245800),
(360652, 'PTHR24260', NULL, NULL, NULL, NULL, '', 245800),
(360653, 'PTHR24260:SF28', NULL, NULL, NULL, NULL, 'RH69521P', 245800),
(360654, 'PTHR24260:SF141', NULL, NULL, NULL, NULL, 'TRYPSIN-LIKE PROTEASE TRY-5', 245800),
(360655, 'PTHR24260:SF140', NULL, NULL, NULL, NULL, 'SERINE PROTEASE GRASS', 245800),
(360656, 'PTHR24260:SF143', NULL, NULL, NULL, NULL, 'SERINE PROTEASE GD-LIKE PROTEIN', 245800),
(360657, 'PTHR24260:SF132', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 245800),
(360658, 'PTHR24260:SF142', NULL, NULL, NULL, NULL, 'IP09309P-RELATED', 245800),
(360659, 'PTHR24260:SF131', NULL, NULL, NULL, NULL, 'CLIP DOMAIN-CONTAINING SERINE PROTEASE', 245800),
(360660, 'PTHR24260:SF87', NULL, NULL, NULL, NULL, 'RE16127P', 245800),
(360661, 'PTHR38527:SF6', NULL, NULL, NULL, NULL, 'BNAANNG31500D PROTEIN', 245801),
(360662, 'PTHR38527:SF5', NULL, NULL, NULL, NULL, 'BNAC03G71280D PROTEIN', 245801),
(360663, 'PTHR38527:SF4', NULL, NULL, NULL, NULL, 'OS01G0838200 PROTEIN', 245801),
(360664, 'PTHR38527:SF3', NULL, NULL, NULL, NULL, '', 245801),
(360665, 'PTHR38527', NULL, NULL, NULL, NULL, 'OS01G0838200 PROTEIN', 245801),
(360666, 'PTHR10044:SF163', NULL, NULL, NULL, NULL, 'BACULOVIRAL IAP REPEAT-CONTAINING PROTEIN 7', 245802),
(360667, 'PTHR10044:SF174', NULL, NULL, NULL, NULL, 'DEATH-ASSOCIATED INHIBITOR OF APOPTOSIS 1', 245802),
(360668, 'PTHR10044:SF177', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 245802),
(360669, 'PTHR10044:SF79', NULL, NULL, NULL, NULL, 'BACULOVIRAL IAP REPEAT-CONTAINING PROTEIN 2', 245802),
(360670, 'PTHR10044:SF139', NULL, NULL, NULL, NULL, 'DEATH-ASSOCIATED INHIBITOR OF APOPTOSIS 2', 245802),
(360671, 'PTHR10044:SF167', NULL, NULL, NULL, NULL, 'BACULOVIRAL IAP REPEAT-CONTAINING PROTEIN 8', 245802),
(360672, 'PTHR10044:SF178', NULL, NULL, NULL, NULL, 'BACULOVIRAL IAP REPEAT-CONTAINING PROTEIN 3', 245802),
(360673, 'PTHR10044:SF179', NULL, NULL, NULL, NULL, 'BACULOVIRAL IAP REPEAT-CONTAINING PROTEIN 5', 245802),
(360674, 'PTHR10044:SF115', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE XIAP', 245802),
(360675, 'PTHR10044', NULL, NULL, NULL, NULL, 'INHIBITOR OF APOPTOSIS', 245802),
(360676, 'PTHR16955:SF6', NULL, NULL, NULL, NULL, 'METASTASIS-SUPPRESSOR KISS-1', 245803),
(360677, 'PTHR16955', NULL, NULL, NULL, NULL, 'METASTASIS-SUPPRESSOR KISS-1', 245803),
(360678, 'PTHR21575:SF12', NULL, NULL, NULL, NULL, 'PROTEIN HID1', 245804),
(360679, 'PTHR21575', NULL, NULL, NULL, NULL, 'PROTEIN HID1', 245804),
(360680, 'PTHR21575:SF13', NULL, NULL, NULL, NULL, 'UBP5-INTERACTING PROTEIN FTP105', 245804),
(360681, 'PTHR21575:SF14', NULL, NULL, NULL, NULL, 'HID-1 FAMILY PROTEIN P19A11.07C', 245804),
(360682, 'PTHR38666:SF2', NULL, NULL, NULL, NULL, 'FLAGELLAR ASSOCIATED PROTEIN', 245805),
(360683, 'PTHR38666', NULL, NULL, NULL, NULL, '', 245805);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(360684, 'PTHR38323:SF1', NULL, NULL, NULL, NULL, 'PROTEIN HEATR9', 245806),
(360685, 'PTHR38323', NULL, NULL, NULL, NULL, 'PROTEIN HEATR9', 245806),
(360686, 'PTHR46311:SF1', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN 7', 245807),
(360687, 'PTHR46311', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN 8-RELATED', 245807),
(360688, 'PTHR46311:SF2', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN 7B', 245807),
(360689, 'PTHR46311:SF3', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN 8', 245807),
(360690, 'PTHR46311:SF4', NULL, NULL, NULL, NULL, 'CALNEURON 2', 245807),
(360691, 'PTHR10059', NULL, NULL, NULL, NULL, 'GRANULOCYTE-MACROPHAGE COLONY-STIMULATING FACTOR  GM-CSF', 245808),
(360692, 'PTHR10059:SF0', NULL, NULL, NULL, NULL, 'GRANULOCYTE-MACROPHAGE COLONY-STIMULATING FACTOR', 245808),
(360693, 'PTHR47866', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 245809),
(360694, 'PTHR47866:SF3', NULL, NULL, NULL, NULL, 'BNAANNG27950D PROTEIN', 245809),
(360695, 'PTHR47866:SF2', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 245809),
(360696, 'PTHR22705:SF2', NULL, NULL, NULL, NULL, 'MYB-LIKE PROTEIN Y', 245810),
(360697, 'PTHR22705:SF0', NULL, NULL, NULL, NULL, 'ZZ-TYPE ZINC FINGER-CONTAINING PROTEIN 3', 245810),
(360698, 'PTHR22705', NULL, NULL, NULL, NULL, 'ZINC FINGER, ZZ DOMAIN CONTAINING 3', 245810),
(360699, 'PTHR47475:SF2', NULL, NULL, NULL, NULL, 'CHROMOSOME TRANSMISSION FIDELITY PROTEIN 8', 245811),
(360700, 'PTHR47475', NULL, NULL, NULL, NULL, 'CHROMOSOME TRANSMISSION FIDELITY PROTEIN 8', 245811),
(360701, 'PTHR28243', NULL, NULL, NULL, NULL, 'AGL049CP', 245812),
(360702, 'PTHR28243:SF1', NULL, NULL, NULL, NULL, 'PYRIDOX_OXASE_2 DOMAIN-CONTAINING PROTEIN', 245812),
(360703, 'PTHR10920:SF21', NULL, NULL, NULL, NULL, 'RRNA METHYLTRANSFERASE-RELATED', 245813),
(360704, 'PTHR10920:SF26', NULL, NULL, NULL, NULL, '', 245813),
(360705, 'PTHR10920:SF25', NULL, NULL, NULL, NULL, 'TRNA (CYTIDINE(32)/GUANOSINE(34)-2''-O)-METHYLTRANSFERASE-RELATED', 245813),
(360706, 'PTHR10920', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA METHYLTRANSFERASE', 245813),
(360707, 'PTHR10920:SF13', NULL, NULL, NULL, NULL, 'PRE-RRNA 2''-O-RIBOSE RNA METHYLTRANSFERASE FTSJ3', 245813),
(360708, 'PTHR10920:SF23', NULL, NULL, NULL, NULL, 'BNAA08G30800D PROTEIN', 245813),
(360709, 'PTHR10920:SF12', NULL, NULL, NULL, NULL, 'TRNA (CYTIDINE(32)/GUANOSINE(34)-2''-O)-METHYLTRANSFERASE-RELATED', 245813),
(360710, 'PTHR10920:SF19', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE, PUTATIVE-RELATED', 245813),
(360711, 'PTHR10920:SF29', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA METHYLTRANSFERASE PB17E12.10C-RELATED', 245813),
(360712, 'PTHR10920:SF18', NULL, NULL, NULL, NULL, 'RRNA METHYLTRANSFERASE 2, MITOCHONDRIAL', 245813),
(360713, 'PTHR34365:SF6', NULL, NULL, NULL, NULL, 'GLYCINE-RICH DOMAIN-CONTAINING PROTEIN 2', 245814),
(360714, 'PTHR34365:SF7', NULL, NULL, NULL, NULL, 'GLYCINE-RICH DOMAIN-CONTAINING PROTEIN 1', 245814),
(360715, 'PTHR34365:SF4', NULL, NULL, NULL, NULL, 'GLYCINE-RICH DOMAIN-CONTAINING PROTEIN 1-LIKE', 245814),
(360716, 'PTHR34365:SF2', NULL, NULL, NULL, NULL, 'ENOLASE (DUF1399)', 245814),
(360717, 'PTHR34365:SF11', NULL, NULL, NULL, NULL, 'BNAC06G01870D PROTEIN', 245814),
(360718, 'PTHR34365:SF12', NULL, NULL, NULL, NULL, 'BNAC03G61190D PROTEIN', 245814),
(360719, 'PTHR34365', NULL, NULL, NULL, NULL, 'ENOLASE (DUF1399)', 245814),
(360720, 'PTHR34365:SF10', NULL, NULL, NULL, NULL, 'GLYCINE-RICH DOMAIN-CONTAINING PROTEIN-LIKE PROTEIN-RELATED', 245814),
(360721, 'PTHR34365:SF15', NULL, NULL, NULL, NULL, 'GLYCINE-RICH DOMAIN-CONTAINING PROTEIN 2-LIKE', 245814),
(360722, 'PTHR34365:SF13', NULL, NULL, NULL, NULL, '', 245814),
(360723, 'PTHR21679', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 245815),
(360724, 'PTHR21679:SF6', NULL, NULL, NULL, NULL, 'DB DOMAIN-CONTAINING PROTEIN', 245815),
(360725, 'PTHR21679:SF2', NULL, NULL, NULL, NULL, 'DB DOMAIN-CONTAINING PROTEIN', 245815),
(360726, 'PTHR21679:SF5', NULL, NULL, NULL, NULL, 'DB DOMAIN-CONTAINING PROTEIN', 245815);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(360727, 'PTHR21679:SF4', NULL, NULL, NULL, NULL, 'DB DOMAIN-CONTAINING PROTEIN', 245815),
(360728, 'PTHR21679:SF1', NULL, NULL, NULL, NULL, 'DB DOMAIN-CONTAINING PROTEIN', 245815),
(360729, 'PTHR10786', NULL, NULL, NULL, NULL, 'CHOLECYSTOKININ', 245816),
(360730, 'PTHR10786:SF0', NULL, NULL, NULL, NULL, 'CHOLECYSTOKININ', 245816),
(360731, 'PTHR33305:SF50', NULL, NULL, NULL, NULL, 'BNAA02G16550D PROTEIN', 245817),
(360732, 'PTHR33305:SF51', NULL, NULL, NULL, NULL, 'ETHYLENE INSENSITIVE 3-LIKE 2 PROTEIN', 245817),
(360733, 'PTHR33305:SF7', NULL, NULL, NULL, NULL, 'ETHYLENE INSENSITIVE 3-LIKE 5 PROTEIN', 245817),
(360734, 'PTHR33305:SF27', NULL, NULL, NULL, NULL, 'EIL4', 245817),
(360735, 'PTHR33305', NULL, NULL, NULL, NULL, 'ETHYLENE INSENSITIVE 3-LIKE 2 PROTEIN', 245817),
(360736, 'PTHR33305:SF29', NULL, NULL, NULL, NULL, 'ETHYLENE INSENSITIVE 3-LIKE 5 PROTEIN', 245817),
(360737, 'PTHR33305:SF41', NULL, NULL, NULL, NULL, 'BNAA05G20140D PROTEIN', 245817),
(360738, 'PTHR33305:SF30', NULL, NULL, NULL, NULL, 'ETHYLENE INSENSITIVE 3-LIKE 3 PROTEIN', 245817),
(360739, 'PTHR33305:SF53', NULL, NULL, NULL, NULL, 'PROTEIN ETHYLENE INSENSITIVE 3-LIKE', 245817),
(360740, 'PTHR33305:SF42', NULL, NULL, NULL, NULL, 'ETHYLENE INSENSITIVE 3-LIKE 4 PROTEIN-RELATED', 245817),
(360741, 'PTHR33305:SF54', NULL, NULL, NULL, NULL, '', 245817),
(360742, 'PTHR33305:SF32', NULL, NULL, NULL, NULL, 'PROTEIN ETHYLENE-INSENSITIVE 3-LIKE 2', 245817),
(360743, 'PTHR33305:SF55', NULL, NULL, NULL, NULL, 'OS07G0272500 PROTEIN', 245817),
(360744, 'PTHR33305:SF11', NULL, NULL, NULL, NULL, 'PROTEIN ETHYLENE INSENSITIVE 3', 245817),
(360745, 'PTHR33305:SF23', NULL, NULL, NULL, NULL, 'ETHYLENE INSENSITIVE 3-LIKE 3 PROTEIN', 245817),
(360746, 'PTHR33305:SF56', NULL, NULL, NULL, NULL, 'ETHYLENE INSENSITIVE 3-LIKE 1 PROTEIN', 245817),
(360747, 'PTHR33305:SF45', NULL, NULL, NULL, NULL, 'BNAA02G05250D PROTEIN', 245817),
(360748, 'PTHR33305:SF57', NULL, NULL, NULL, NULL, 'BNAA07G39030D PROTEIN', 245817),
(360749, 'PTHR33305:SF58', NULL, NULL, NULL, NULL, 'ETHYLENE INSENSITIVE 3-LIKE 1 PROTEIN', 245817),
(360750, 'PTHR33305:SF47', NULL, NULL, NULL, NULL, 'BNAC03G41740D PROTEIN', 245817),
(360751, 'PTHR33305:SF37', NULL, NULL, NULL, NULL, 'ETHYLENE INSENSITIVE 3-LIKE 4 PROTEIN-RELATED', 245817),
(360752, 'PTHR33305:SF48', NULL, NULL, NULL, NULL, 'OS08G0508700 PROTEIN', 245817),
(360753, 'PTHR33305:SF59', NULL, NULL, NULL, NULL, 'BNACNNG68230D PROTEIN', 245817),
(360754, 'PTHR45976', NULL, NULL, NULL, NULL, 'ARMADILLO SEGMENT POLARITY PROTEIN', 245818),
(360755, 'PTHR45976:SF3', NULL, NULL, NULL, NULL, 'JUNCTION PLAKOGLOBIN', 245818),
(360756, 'PTHR45976:SF1', NULL, NULL, NULL, NULL, 'ARMADILLO SEGMENT POLARITY PROTEIN', 245818),
(360757, 'PTHR45976:SF6', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING PROTEIN WRM-1', 245818),
(360758, 'PTHR45976:SF5', NULL, NULL, NULL, NULL, 'BETA-CATENIN/ARMADILLO-RELATED PROTEIN 1', 245818),
(360759, 'PTHR45976:SF4', NULL, NULL, NULL, NULL, 'CATENIN BETA-1', 245818),
(360760, 'PTHR48218:SF4', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 245819),
(360761, 'PTHR48218', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN', 245819),
(360762, 'PTHR48218:SF3', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 245819),
(360763, 'PTHR21485:SF5', NULL, NULL, NULL, NULL, '3-DEOXY-D-MANNO-OCTULOSONATE 8-PHOSPHATE PHOSPHATASE KDSC', 245820),
(360764, 'PTHR21485:SF3', NULL, NULL, NULL, NULL, 'N-ACYLNEURAMINATE CYTIDYLYLTRANSFERASE', 245820),
(360765, 'PTHR21485', NULL, NULL, NULL, NULL, 'HAD SUPERFAMILY MEMBERS CMAS AND KDSC', 245820),
(360766, 'PTHR16220', NULL, NULL, NULL, NULL, 'WD REPEAT PROTEIN 8-RELATED', 245821),
(360767, 'PTHR16220:SF0', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN WRAP73', 245821),
(360768, 'PTHR43585:SF2', NULL, NULL, NULL, NULL, 'ATP-GRASP ENZYME FSQD', 245822),
(360769, 'PTHR43585', NULL, NULL, NULL, NULL, 'FUMIPYRROLE BIOSYNTHESIS PROTEIN C', 245822),
(360770, 'PTHR19357:SF0', NULL, NULL, NULL, NULL, 'TRIGGERING RECEPTOR EXPRESSED ON MYELOID CELLS 1', 245823);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(360771, 'PTHR19357:SF2', NULL, NULL, NULL, NULL, 'TRIGGERING RECEPTOR EXPRESSED ON MYELOID CELLS 3', 245823),
(360772, 'PTHR19357', NULL, NULL, NULL, NULL, 'TRIGGERING RECEPTOR EXPRESSED ON MYELOID CELLS 1', 245823),
(360773, 'PTHR46729:SF1', NULL, NULL, NULL, NULL, 'LEUKOCYTE RECEPTOR CLUSTER MEMBER 9', 245824),
(360774, 'PTHR46729', NULL, NULL, NULL, NULL, 'LEUKOCYTE RECEPTOR CLUSTER MEMBER 9', 245824),
(360775, 'PTHR45669:SF26', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 245825),
(360776, 'PTHR45669:SF48', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 245825),
(360777, 'PTHR45669:SF25', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN (GRX) FAMILY PROTEIN', 245825),
(360778, 'PTHR45669:SF47', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 245825),
(360779, 'PTHR45669:SF45', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE FOLD PROTEIN-RELATED', 245825),
(360780, 'PTHR45669:SF23', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN FAMILY PROTEIN', 245825),
(360781, 'PTHR45669:SF22', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING CYSTEINE-RICH PROTEIN CG12206-RELATED', 245825),
(360782, 'PTHR45669:SF44', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 245825),
(360783, 'PTHR45669:SF65', NULL, NULL, NULL, NULL, 'OS02G0748800 PROTEIN', 245825),
(360784, 'PTHR45669:SF21', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 245825),
(360785, 'PTHR45669:SF43', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 245825),
(360786, 'PTHR45669:SF64', NULL, NULL, NULL, NULL, 'OS07G0159900 PROTEIN', 245825),
(360787, 'PTHR45669:SF42', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 245825),
(360788, 'PTHR45669:SF63', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN FAMILY PROTEIN', 245825),
(360789, 'PTHR45669:SF41', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE FOLD PROTEIN-RELATED', 245825),
(360790, 'PTHR45669:SF29', NULL, NULL, NULL, NULL, 'OS06G0226100 PROTEIN', 245825),
(360791, 'PTHR45669:SF28', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 245825),
(360792, 'PTHR45669:SF27', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 245825),
(360793, 'PTHR45669:SF51', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 245825),
(360794, 'PTHR45669:SF50', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 245825),
(360795, 'PTHR45669:SF7', NULL, NULL, NULL, NULL, 'F1N19.7', 245825),
(360796, 'PTHR45669:SF8', NULL, NULL, NULL, NULL, 'OS01G0829400 PROTEIN', 245825),
(360797, 'PTHR45669:SF6', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN FAMILY PROTEIN', 245825),
(360798, 'PTHR45669:SF59', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE FOLD PROTEIN-RELATED', 245825),
(360799, 'PTHR45669:SF15', NULL, NULL, NULL, NULL, 'OS05G0353600 PROTEIN', 245825),
(360800, 'PTHR45669:SF36', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 245825),
(360801, 'PTHR45669:SF58', NULL, NULL, NULL, NULL, 'OS07G0659900 PROTEIN', 245825),
(360802, 'PTHR45669:SF14', NULL, NULL, NULL, NULL, 'EMB|CAB81925.1-RELATED', 245825),
(360803, 'PTHR45669:SF35', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN (GRX) FAMILY PROTEIN', 245825),
(360804, 'PTHR45669:SF57', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 245825),
(360805, 'PTHR45669:SF34', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 245825),
(360806, 'PTHR45669:SF12', NULL, NULL, NULL, NULL, 'EMB|CAB85507.1', 245825),
(360807, 'PTHR45669', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING CYSTEINE-RICH PROTEIN CG12206-RELATED', 245825),
(360808, 'PTHR45669:SF31', NULL, NULL, NULL, NULL, 'F3H7.9 PROTEIN', 245825),
(360809, 'PTHR45669:SF53', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN FAMILY PROTEIN', 245825),
(360810, 'PTHR45669:SF52', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE FOLD PROTEIN-RELATED', 245825),
(360811, 'PTHR45669:SF30', NULL, NULL, NULL, NULL, 'OS04G0641300 PROTEIN', 245825),
(360812, 'PTHR45669:SF19', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 245825),
(360813, 'PTHR45669:SF18', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN FAMILY PROTEIN', 245825);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(360814, 'PTHR45669:SF17', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 245825),
(360815, 'PTHR45669:SF39', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 245825),
(360816, 'PTHR45669:SF38', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 245825),
(360817, 'PTHR45669:SF16', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN FAMILY PROTEIN', 245825),
(360818, 'PTHR45669:SF62', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN (GRX) FAMILY PROTEIN', 245825),
(360819, 'PTHR45669:SF40', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN FAMILY PROTEIN-RELATED', 245825),
(360820, 'PTHR45669:SF61', NULL, NULL, NULL, NULL, 'OS05G0471350 PROTEIN', 245825),
(360821, 'PTHR45669:SF60', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN FAMILY PROTEIN, EXPRESSED', 245825),
(360822, 'PTHR48151', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-CONTAINING PROTEIN', 245826),
(360823, 'PTHR48151:SF3', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-CONTAINING PROTEIN', 245826),
(360824, 'PTHR48151:SF2', NULL, NULL, NULL, NULL, 'BNAA03G13040D PROTEIN', 245826),
(360825, 'PTHR36151:SF3', NULL, NULL, NULL, NULL, 'DUF2236 DOMAIN-CONTAINING PROTEIN', 245827),
(360826, 'PTHR36151', NULL, NULL, NULL, NULL, 'BLR2777 PROTEIN', 245827),
(360827, 'PTHR37530', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN SLP', 245828),
(360828, 'PTHR37530:SF1', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN SLP', 245828),
(360829, 'PTHR47984:SF19', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE PLANT', 245829),
(360830, 'PTHR47984:SF18', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245829),
(360831, 'PTHR47984:SF31', NULL, NULL, NULL, NULL, 'OS03G0227900 PROTEIN', 245829),
(360832, 'PTHR47984:SF30', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245829),
(360833, 'PTHR47984:SF39', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245829),
(360834, 'PTHR47984:SF17', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245829),
(360835, 'PTHR47984:SF38', NULL, NULL, NULL, NULL, 'OS10G0497600 PROTEIN', 245829),
(360836, 'PTHR47984:SF16', NULL, NULL, NULL, NULL, 'BRASSINOSTEROID INSENSITIVE 1-ASSOCIATED RECEPTOR KINASE', 245829),
(360837, 'PTHR47984:SF37', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245829),
(360838, 'PTHR47984:SF15', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245829),
(360839, 'PTHR47984:SF14', NULL, NULL, NULL, NULL, 'OS01G0323000 PROTEIN', 245829),
(360840, 'PTHR47984:SF36', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245829),
(360841, 'PTHR47984:SF13', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245829),
(360842, 'PTHR47984:SF34', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 245829),
(360843, 'PTHR47984:SF11', NULL, NULL, NULL, NULL, 'TELOKIN/MYOSIN LIGHT CHAIN KINASE-RELATED', 245829),
(360844, 'PTHR47984:SF10', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 245829),
(360845, 'PTHR47984:SF29', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245829),
(360846, 'PTHR47984:SF8', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE', 245829),
(360847, 'PTHR47984:SF5', NULL, NULL, NULL, NULL, 'OS12G0108100 PROTEIN', 245829),
(360848, 'PTHR47984:SF6', NULL, NULL, NULL, NULL, 'BNAANNG25880D PROTEIN', 245829),
(360849, 'PTHR47984:SF3', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 245829),
(360850, 'PTHR47984:SF4', NULL, NULL, NULL, NULL, 'OS01G0631700 PROTEIN', 245829),
(360851, 'PTHR47984', NULL, NULL, NULL, NULL, 'OS01G0323000 PROTEIN', 245829),
(360852, 'PTHR47984:SF1', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245829),
(360853, 'PTHR47984:SF9', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 245829),
(360854, 'PTHR47984:SF28', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 245829),
(360855, 'PTHR47984:SF27', NULL, NULL, NULL, NULL, 'OS05G0436100 PROTEIN', 245829),
(360856, 'PTHR47984:SF26', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245829);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(360857, 'PTHR47984:SF25', NULL, NULL, NULL, NULL, 'OS02G0549200 PROTEIN', 245829),
(360858, 'PTHR47984:SF24', NULL, NULL, NULL, NULL, 'OS10G0533150 PROTEIN', 245829),
(360859, 'PTHR47984:SF23', NULL, NULL, NULL, NULL, 'OS01G0664200 PROTEIN', 245829),
(360860, 'PTHR47984:SF22', NULL, NULL, NULL, NULL, 'OS03G0125600 PROTEIN', 245829),
(360861, 'PTHR47984:SF21', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245829),
(360862, 'PTHR33827:SF2', NULL, NULL, NULL, NULL, 'PROTEIN SAWADEE HOMEODOMAIN HOMOLOG 1', 245830),
(360863, 'PTHR33827:SF3', NULL, NULL, NULL, NULL, 'OS09G0346900 PROTEIN', 245830),
(360864, 'PTHR33827:SF13', NULL, NULL, NULL, NULL, 'SAWADEE DOMAIN-CONTAINING PROTEIN', 245830),
(360865, 'PTHR33827', NULL, NULL, NULL, NULL, 'PROTEIN SAWADEE HOMEODOMAIN HOMOLOG 2', 245830),
(360866, 'PTHR33827:SF11', NULL, NULL, NULL, NULL, 'SAWADEE DOMAIN-CONTAINING PROTEIN', 245830),
(360867, 'PTHR33827:SF6', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE TRANSCRIPTION FACTOR SUPERFAMILY PROTEIN-RELATED', 245830),
(360868, 'PTHR33827:SF7', NULL, NULL, NULL, NULL, 'PROTEIN SAWADEE HOMEODOMAIN HOMOLOG 2', 245830),
(360869, 'PTHR33827:SF8', NULL, NULL, NULL, NULL, 'PROTEIN SAWADEE HOMEODOMAIN HOMOLOG 1-LIKE', 245830),
(360870, 'PTHR33827:SF9', NULL, NULL, NULL, NULL, 'SAWADEE DOMAIN-CONTAINING PROTEIN', 245830),
(360871, 'PTHR35770:SF1', NULL, NULL, NULL, NULL, 'U2 SMALL NUCLEAR RIBONUCLEOPROTEIN AUXILIARY FACTOR-LIKE PROTEIN', 245831),
(360872, 'PTHR35770', NULL, NULL, NULL, NULL, 'U2 SMALL NUCLEAR RIBONUCLEOPROTEIN AUXILIARY FACTOR-LIKE PROTEIN', 245831),
(360873, 'PTHR10183:SF379', NULL, NULL, NULL, NULL, 'CALPAIN-A-RELATED', 245832),
(360874, 'PTHR10183:SF333', NULL, NULL, NULL, NULL, 'CALPAIN-13', 245832),
(360875, 'PTHR10183:SF397', NULL, NULL, NULL, NULL, 'CALPAIN CATALYTIC DOMAIN-CONTAINING PROTEIN', 245832),
(360876, 'PTHR10183:SF374', NULL, NULL, NULL, NULL, 'CALPAIN-8', 245832),
(360877, 'PTHR10183:SF395', NULL, NULL, NULL, NULL, 'CALPAIN 2, (M/II) LARGE SUBUNIT A-RELATED', 245832),
(360878, 'PTHR10183:SF394', NULL, NULL, NULL, NULL, 'CALPAIN-C', 245832),
(360879, 'PTHR10183:SF419', NULL, NULL, NULL, NULL, 'CALPAIN CLP-1', 245832),
(360880, 'PTHR10183:SF416', NULL, NULL, NULL, NULL, 'CALPAIN-5', 245832),
(360881, 'PTHR10183:SF30', NULL, NULL, NULL, NULL, 'CALPAIN-10', 245832),
(360882, 'PTHR10183:SF382', NULL, NULL, NULL, NULL, 'CALPAIN-15', 245832),
(360883, 'PTHR10183:SF381', NULL, NULL, NULL, NULL, 'CALPAIN-6', 245832),
(360884, 'PTHR10183:SF280', NULL, NULL, NULL, NULL, 'CALPAIN-12', 245832),
(360885, 'PTHR10183:SF302', NULL, NULL, NULL, NULL, 'CALPAIN-14', 245832),
(360886, 'PTHR10183:SF423', NULL, NULL, NULL, NULL, 'CYSTEINE PEPTIDASE, PUTATIVE-RELATED', 245832),
(360887, 'PTHR10183:SF422', NULL, NULL, NULL, NULL, 'CLAN CA, FAMILY C2, CALPAIN-LIKE CYSTEINE PEPTIDASE', 245832),
(360888, 'PTHR10183:SF268', NULL, NULL, NULL, NULL, 'CALPAIN-2 CATALYTIC SUBUNIT', 245832),
(360889, 'PTHR10183:SF421', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 245832),
(360890, 'PTHR10183:SF322', NULL, NULL, NULL, NULL, 'CALPAIN-11', 245832),
(360891, 'PTHR10183:SF420', NULL, NULL, NULL, NULL, 'CALPAIN CATALYTIC DOMAIN-CONTAINING PROTEIN', 245832),
(360892, 'PTHR10183', NULL, NULL, NULL, NULL, 'CALPAIN', 245832),
(360893, 'PTHR10183:SF385', NULL, NULL, NULL, NULL, 'CALPAIN-9', 245832),
(360894, 'PTHR10183:SF262', NULL, NULL, NULL, NULL, 'CALPAIN CATALYTIC DOMAIN-CONTAINING PROTEIN', 245832),
(360895, 'PTHR10183:SF284', NULL, NULL, NULL, NULL, 'CALPAIN-1 CATALYTIC SUBUNIT', 245832),
(360896, 'PTHR10183:SF409', NULL, NULL, NULL, NULL, 'CALPAIN 8', 245832),
(360897, 'PTHR10183:SF329', NULL, NULL, NULL, NULL, 'CALPAIN-3', 245832),
(360898, 'PTHR10183:SF405', NULL, NULL, NULL, NULL, 'SI:DKEY-19B23.13', 245832),
(360899, 'PTHR10183:SF426', NULL, NULL, NULL, NULL, 'CALPAIN CATALYTIC DOMAIN-CONTAINING PROTEIN', 245832),
(360900, 'PTHR10183:SF425', NULL, NULL, NULL, NULL, 'CALPAIN-5', 245832),
(360901, 'PTHR10183:SF424', NULL, NULL, NULL, NULL, 'CALPAIN-B-LIKE PROTEIN', 245832),
(360902, 'PTHR10183:SF402', NULL, NULL, NULL, NULL, 'CALPAIN-5', 245832);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(360903, 'PTHR10183:SF393', NULL, NULL, NULL, NULL, 'CALPAIN 12', 245832),
(360904, 'PTHR46121:SF1', NULL, NULL, NULL, NULL, 'STARD3 N-TERMINAL-LIKE PROTEIN', 245833),
(360905, 'PTHR46121:SF2', NULL, NULL, NULL, NULL, 'STAR-RELATED LIPID TRANSFER PROTEIN 3', 245833),
(360906, 'PTHR46121', NULL, NULL, NULL, NULL, 'STEROIDOGENIC ACUTE REGULATORY PROTEIN-LIKE', 245833),
(360907, 'PTHR46121:SF3', NULL, NULL, NULL, NULL, 'STEROIDOGENIC ACUTE REGULATORY-LIKE PROTEIN 1', 245833),
(360908, 'PTHR46121:SF4', NULL, NULL, NULL, NULL, 'STEROIDOGENIC ACUTE REGULATORY PROTEIN-LIKE', 245833),
(360909, 'PTHR12210:SF186', NULL, NULL, NULL, NULL, 'FCP1 HOMOLOGY DOMAIN-CONTAINING PROTEIN', 245834),
(360910, 'PTHR12210:SF187', NULL, NULL, NULL, NULL, 'CARBOXY-TERMINAL DOMAIN RNA POLYMERASE II POLYPEPTIDE A SMALL PHOSPHATASE 2', 245834),
(360911, 'PTHR12210:SF188', NULL, NULL, NULL, NULL, 'FCP1 HOMOLOGY DOMAIN-CONTAINING PROTEIN', 245834),
(360912, 'PTHR12210:SF189', NULL, NULL, NULL, NULL, 'INTERACTING FACTOR, PUTATIVE, EXPRESSED-RELATED', 245834),
(360913, 'PTHR12210:SF182', NULL, NULL, NULL, NULL, 'FCP1 HOMOLOGY DOMAIN-CONTAINING PROTEIN', 245834),
(360914, 'PTHR12210:SF183', NULL, NULL, NULL, NULL, 'CTD SMALL PHOSPHATASE-LIKE PROTEIN 2-A', 245834),
(360915, 'PTHR12210:SF140', NULL, NULL, NULL, NULL, 'CTD NUCLEAR ENVELOPE PHOSPHATASE 1', 245834),
(360916, 'PTHR12210:SF184', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 245834),
(360917, 'PTHR12210:SF185', NULL, NULL, NULL, NULL, 'HALOACID DEHALOGENASE-LIKE HYDROLASE (HAD) SUPERFAMILY PROTEIN', 245834),
(360918, 'PTHR12210:SF141', NULL, NULL, NULL, NULL, 'HALOACID DEHALOGENASE-LIKE HYDROLASE (HAD) SUPERFAMILY PROTEIN', 245834),
(360919, 'PTHR12210:SF109', NULL, NULL, NULL, NULL, 'FCP1 HOMOLOGY DOMAIN-CONTAINING PROTEIN', 245834),
(360920, 'PTHR12210:SF146', NULL, NULL, NULL, NULL, 'SCP1-LIKE SMALL PHOSPHATASE 4-RELATED', 245834),
(360921, 'PTHR12210:SF104', NULL, NULL, NULL, NULL, 'FCP1 HOMOLOGY DOMAIN-CONTAINING PROTEIN', 245834),
(360922, 'PTHR12210:SF148', NULL, NULL, NULL, NULL, 'C-TERMINAL DOMAIN SMALL PHOSPHATASE-RELATED', 245834),
(360923, 'PTHR12210:SF149', NULL, NULL, NULL, NULL, '', 245834),
(360924, 'PTHR12210:SF190', NULL, NULL, NULL, NULL, '', 245834),
(360925, 'PTHR12210:SF70', NULL, NULL, NULL, NULL, 'CTD NUCLEAR ENVELOPE PHOSPHATASE 1', 245834),
(360926, 'PTHR12210:SF154', NULL, NULL, NULL, NULL, 'FCP1 HOMOLOGY DOMAIN-CONTAINING PROTEIN', 245834),
(360927, 'PTHR12210:SF110', NULL, NULL, NULL, NULL, 'FCP1 HOMOLOGY DOMAIN-CONTAINING PROTEIN', 245834),
(360928, 'PTHR12210:SF155', NULL, NULL, NULL, NULL, 'SCP1-LIKE SMALL PHOSPHATASE 4-RELATED', 245834),
(360929, 'PTHR12210:SF111', NULL, NULL, NULL, NULL, 'OS05G0513200 PROTEIN', 245834),
(360930, 'PTHR12210:SF112', NULL, NULL, NULL, NULL, 'CTD (CARBOXY-TERMINAL DOMAIN, RNA POLYMERASE II, POLYPEPTIDE A) SMALL PHOSPHATASE-LIKE 3-RELATED', 245834),
(360931, 'PTHR12210:SF150', NULL, NULL, NULL, NULL, 'FCP1 HOMOLOGY DOMAIN-CONTAINING PROTEIN', 245834),
(360932, 'PTHR12210:SF29', NULL, NULL, NULL, NULL, 'OS05G0205100 PROTEIN', 245834),
(360933, 'PTHR12210:SF157', NULL, NULL, NULL, NULL, 'FCP1 HOMOLOGY DOMAIN-CONTAINING PROTEIN', 245834),
(360934, 'PTHR12210:SF158', NULL, NULL, NULL, NULL, 'FCP1 HOMOLOGY DOMAIN-CONTAINING PROTEIN', 245834),
(360935, 'PTHR12210:SF115', NULL, NULL, NULL, NULL, 'FCP1 HOMOLOGY DOMAIN-CONTAINING PROTEIN', 245834),
(360936, 'PTHR12210:SF65', NULL, NULL, NULL, NULL, 'OS01G0665300 PROTEIN', 245834),
(360937, 'PTHR12210:SF64', NULL, NULL, NULL, NULL, 'HALOACID DEHALOGENASE-LIKE HYDROLASE (HAD) SUPERFAMILY PROTEIN', 245834),
(360938, 'PTHR12210:SF164', NULL, NULL, NULL, NULL, 'FCP1 HOMOLOGY DOMAIN-CONTAINING PROTEIN', 245834),
(360939, 'PTHR12210:SF121', NULL, NULL, NULL, NULL, 'HALOACID DEHALOGENASE-LIKE HYDROLASE (HAD) SUPERFAMILY PROTEIN', 245834),
(360940, 'PTHR12210:SF166', NULL, NULL, NULL, NULL, 'BNAA06G00110D PROTEIN', 245834),
(360941, 'PTHR12210:SF167', NULL, NULL, NULL, NULL, 'FCP1 HOMOLOGY DOMAIN-CONTAINING PROTEIN', 245834),
(360942, 'PTHR12210:SF162', NULL, NULL, NULL, NULL, 'FCP1-LIKE DOMAIN, HAD-LIKE DOMAIN PROTEIN-RELATED', 245834);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(360943, 'PTHR12210:SF163', NULL, NULL, NULL, NULL, 'FCP1 HOMOLOGY DOMAIN-CONTAINING PROTEIN', 245834),
(360944, 'PTHR12210:SF128', NULL, NULL, NULL, NULL, 'FCP1 HOMOLOGY DOMAIN-CONTAINING PROTEIN', 245834),
(360945, 'PTHR12210:SF124', NULL, NULL, NULL, NULL, 'OS05G0466800 PROTEIN', 245834),
(360946, 'PTHR12210:SF169', NULL, NULL, NULL, NULL, 'FCP1 HOMOLOGY DOMAIN-CONTAINING PROTEIN', 245834),
(360947, 'PTHR12210:SF127', NULL, NULL, NULL, NULL, 'OS03G0755600 PROTEIN', 245834),
(360948, 'PTHR12210:SF59', NULL, NULL, NULL, NULL, 'FCP1 HOMOLOGY DOMAIN-CONTAINING PROTEIN', 245834),
(360949, 'PTHR12210:SF13', NULL, NULL, NULL, NULL, 'CTD SMALL PHOSPHATASE-LIKE PROTEIN 3', 245834),
(360950, 'PTHR12210:SF53', NULL, NULL, NULL, NULL, 'FCP1 HOMOLOGY DOMAIN-CONTAINING PROTEIN', 245834),
(360951, 'PTHR12210:SF131', NULL, NULL, NULL, NULL, 'FCP1 HOMOLOGY DOMAIN-CONTAINING PROTEIN', 245834),
(360952, 'PTHR12210:SF133', NULL, NULL, NULL, NULL, 'NLI INTERACTING FACTOR-LIKE PHOSPHATASE', 245834),
(360953, 'PTHR12210:SF178', NULL, NULL, NULL, NULL, 'FCP1-LIKE DOMAIN, HAD-LIKE DOMAIN PROTEIN-RELATED', 245834),
(360954, 'PTHR12210:SF171', NULL, NULL, NULL, NULL, 'PHOSPHATASE HERZOG', 245834),
(360955, 'PTHR12210:SF172', NULL, NULL, NULL, NULL, 'HALOACID DEHALOGENASE-LIKE HYDROLASE (HAD) SUPERFAMILY PROTEIN', 245834),
(360956, 'PTHR12210:SF173', NULL, NULL, NULL, NULL, 'CTD SMALL PHOSPHATASE-LIKE PROTEIN 2', 245834),
(360957, 'PTHR12210:SF139', NULL, NULL, NULL, NULL, 'CARBOXY-TERMINAL DOMAIN RNA POLYMERASE II POLYPEPTIDE A SMALL PHOSPHATASE 1', 245834),
(360958, 'PTHR12210:SF135', NULL, NULL, NULL, NULL, 'CTD SMALL PHOSPHATASE-LIKE PROTEIN', 245834),
(360959, 'PTHR12210:SF179', NULL, NULL, NULL, NULL, 'NLI INTERACTING FACTOR-LIKE PHOSPHATASE FAMILY PROTEIN', 245834),
(360960, 'PTHR12210:SF136', NULL, NULL, NULL, NULL, 'HALOACID DEHALOGENASE-LIKE HYDROLASE (HAD) SUPERFAMILY PROTEIN', 245834),
(360961, 'PTHR12210:SF43', NULL, NULL, NULL, NULL, 'CTD SMALL PHOSPHATASE-LIKE PROTEIN', 245834),
(360962, 'PTHR12210:SF44', NULL, NULL, NULL, NULL, 'FCP1 HOMOLOGY DOMAIN-CONTAINING PROTEIN', 245834),
(360963, 'PTHR12210:SF3', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM50', 245834),
(360964, 'PTHR12210:SF180', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM50-LIKE', 245834),
(360965, 'PTHR12210:SF181', NULL, NULL, NULL, NULL, 'NIF DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_6G04580)', 245834),
(360966, 'PTHR12210', NULL, NULL, NULL, NULL, 'DULLARD PROTEIN PHOSPHATASE', 245834),
(360967, 'PTHR10503:SF23', NULL, NULL, NULL, NULL, 'PROTEIN CBG11107', 245835),
(360968, 'PTHR10503:SF22', NULL, NULL, NULL, NULL, 'CHROMO DOMAIN-CONTAINING PROTEIN', 245835),
(360969, 'PTHR10503:SF24', NULL, NULL, NULL, NULL, 'CHROMO DOMAIN-CONTAINING PROTEIN CEC-4', 245835),
(360970, 'PTHR10503:SF7', NULL, NULL, NULL, NULL, 'CHROMO DOMAIN-CONTAINING PROTEIN', 245835),
(360971, 'PTHR10503', NULL, NULL, NULL, NULL, 'HP1 LIKE (HETEROCHROMATIN PROTEIN)-RELATED', 245835),
(360972, 'PTHR28048:SF1', NULL, NULL, NULL, NULL, 'DUF4536 DOMAIN-CONTAINING PROTEIN', 245836),
(360973, 'PTHR28048', NULL, NULL, NULL, NULL, 'ACR195WP', 245836),
(360974, 'PTHR15460', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN 4', 245837),
(360975, 'PTHR15460:SF3', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN 4', 245837),
(360976, 'PTHR15607:SF18', NULL, NULL, NULL, NULL, 'SYCP2_SLD DOMAIN-CONTAINING PROTEIN', 245838),
(360977, 'PTHR15607', NULL, NULL, NULL, NULL, 'SYNAPTONEMAL COMPLEX PROTEIN-RELATED', 245838),
(360978, 'PTHR15607:SF12', NULL, NULL, NULL, NULL, 'SYNAPTONEMAL COMPLEX PROTEIN 2', 245838),
(360979, 'PTHR15607:SF14', NULL, NULL, NULL, NULL, 'SYNAPTONEMAL COMPLEX PROTEIN 2-LIKE', 245838),
(360980, 'PTHR42769:SF2', NULL, NULL, NULL, NULL, 'SUPEROXIDE DISMUTASE', 245839),
(360981, 'PTHR42769:SF1', NULL, NULL, NULL, NULL, 'SOD_FE_C DOMAIN-CONTAINING PROTEIN', 245839),
(360982, 'PTHR42769:SF4', NULL, NULL, NULL, NULL, 'DISMUTASE, PUTATIVE-RELATED', 245839),
(360983, 'PTHR42769:SF10', NULL, NULL, NULL, NULL, 'SUPEROXIDE DISMUTASE [FE] 3, CHLOROPLASTIC', 245839);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(360984, 'PTHR42769:SF3', NULL, NULL, NULL, NULL, 'SUPEROXIDE DISMUTASE [FE] 2, CHLOROPLASTIC', 245839),
(360985, 'PTHR42769:SF8', NULL, NULL, NULL, NULL, 'SUPEROXIDE DISMUTASE [FE] 1, CHLOROPLASTIC', 245839),
(360986, 'PTHR42769', NULL, NULL, NULL, NULL, 'SUPEROXIDE DISMUTASE', 245839),
(360987, 'PTHR42769:SF13', NULL, NULL, NULL, NULL, 'SUPEROXIDE DISMUTASE', 245839),
(360988, 'PTHR42769:SF12', NULL, NULL, NULL, NULL, 'SUPEROXIDE DISMUTASE', 245839),
(360989, 'PTHR35079', NULL, NULL, NULL, NULL, 'LUNG ADENOMA SUSCEPTIBILITY PROTEIN 2', 245840),
(360990, 'PTHR35079:SF1', NULL, NULL, NULL, NULL, 'LUNG ADENOMA SUSCEPTIBILITY PROTEIN 2', 245840),
(360991, 'PTHR10039:SF15', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 245841),
(360992, 'PTHR10039:SF9', NULL, NULL, NULL, NULL, 'NACHT DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_2G01760)', 245841),
(360993, 'PTHR10039:SF16', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 245841),
(360994, 'PTHR10039', NULL, NULL, NULL, NULL, 'AMELOGENIN', 245841),
(360995, 'PTHR10039:SF5', NULL, NULL, NULL, NULL, 'NACHT DOMAIN-CONTAINING PROTEIN', 245841),
(360996, 'PTHR10039:SF10', NULL, NULL, NULL, NULL, 'NACHT DOMAIN PROTEIN', 245841),
(360997, 'PTHR10039:SF14', NULL, NULL, NULL, NULL, 'NACHT AND TPR DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_7G06670)', 245841),
(360998, 'PTHR10039:SF11', NULL, NULL, NULL, NULL, 'NACHT DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_1G01490)', 245841),
(360999, 'PTHR47559', NULL, NULL, NULL, NULL, 'OS03G0844900 PROTEIN', 245842),
(361000, 'PTHR47559:SF1', NULL, NULL, NULL, NULL, 'OS03G0844900 PROTEIN', 245842),
(361001, 'PTHR24125:SF1', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND DEATH DOMAIN-CONTAINING PROTEIN 1B', 245843),
(361002, 'PTHR24125:SF6', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 245843),
(361003, 'PTHR24125:SF5', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 245843),
(361004, 'PTHR24125:SF7', NULL, NULL, NULL, NULL, 'REPEAT PROTEIN, PUTATIVE-RELATED', 245843),
(361005, 'PTHR24125', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND DEATH DOMAIN-CONTAINING PROTEIN', 245843),
(361006, 'PTHR24125:SF0', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND DEATH DOMAIN-CONTAINING PROTEIN 1A', 245843),
(361007, 'PTHR12887:SF12', NULL, NULL, NULL, NULL, 'NANOS HOMOLOG 3', 245844),
(361008, 'PTHR12887', NULL, NULL, NULL, NULL, 'NANOS PROTEIN', 245844),
(361009, 'PTHR12887:SF13', NULL, NULL, NULL, NULL, 'NANOS HOMOLOG 1', 245844),
(361010, 'PTHR12887:SF10', NULL, NULL, NULL, NULL, 'NANOS-TYPE DOMAIN-CONTAINING PROTEIN', 245844),
(361011, 'PTHR12887:SF6', NULL, NULL, NULL, NULL, 'NANOS HOMOLOG 1', 245844),
(361012, 'PTHR12887:SF11', NULL, NULL, NULL, NULL, 'PROTEIN NANOS', 245844),
(361013, 'PTHR12887:SF4', NULL, NULL, NULL, NULL, 'NANOS-TYPE DOMAIN-CONTAINING PROTEIN', 245844),
(361014, 'PTHR12887:SF14', NULL, NULL, NULL, NULL, 'NANOS HOMOLOG 2', 245844),
(361015, 'PTHR48187:SF2', NULL, NULL, NULL, NULL, 'LD21810P', 245845),
(361016, 'PTHR48187', NULL, NULL, NULL, NULL, 'LD21810P', 245845),
(361017, 'PTHR34309:SF9', NULL, NULL, NULL, NULL, 'PROTEIN GLCG', 245846),
(361018, 'PTHR34309', NULL, NULL, NULL, NULL, 'SLR1406 PROTEIN', 245846),
(361019, 'PTHR34309:SF1', NULL, NULL, NULL, NULL, 'SLR1406 PROTEIN', 245846),
(361020, 'PTHR34309:SF2', NULL, NULL, NULL, NULL, 'BLL3419 PROTEIN', 245846),
(361021, 'PTHR36022:SF1', NULL, NULL, NULL, NULL, 'GPI-ANCHORED ADHESIN-LIKE PROTEIN', 245847),
(361022, 'PTHR36022', NULL, NULL, NULL, NULL, 'GPI-ANCHORED ADHESIN-LIKE PROTEIN', 245847),
(361023, 'PTHR37953', NULL, NULL, NULL, NULL, 'UPF0127 PROTEIN MJ1496', 245848),
(361024, 'PTHR37953:SF1', NULL, NULL, NULL, NULL, 'UPF0127 PROTEIN MJ1496', 245848),
(361025, 'PTHR16065', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN CONTAINING 198', 245849),
(361026, 'PTHR16065:SF2', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN CONTAINING 198', 245849),
(361027, 'PTHR31701', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM MEMBRANE-ASSOCIATED RNA DEGRADATION PROTEIN', 245850),
(361028, 'PTHR31701:SF2', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM MEMBRANE-ASSOCIATED RNA DEGRADATION PROTEIN', 245850);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(361029, 'PTHR41299', NULL, NULL, NULL, NULL, 'THIAMINE PYROPHOSPHOKINASE', 245851),
(361030, 'PTHR41299:SF1', NULL, NULL, NULL, NULL, 'THIAMINE PYROPHOSPHOKINASE', 245851),
(361031, 'PTHR37424:SF1', NULL, NULL, NULL, NULL, 'BACTERIOFERRITIN-ASSOCIATED FERREDOXIN', 245852),
(361032, 'PTHR37424', NULL, NULL, NULL, NULL, 'BACTERIOFERRITIN-ASSOCIATED FERREDOXIN', 245852),
(361033, 'PTHR43298:SF4', NULL, NULL, NULL, NULL, 'NA+ DRIVEN MULTIDRUG EFFLUX PUMP-RELATED', 245853),
(361034, 'PTHR43298:SF2', NULL, NULL, NULL, NULL, 'FMN/FAD EXPORTER YEEO-RELATED', 245853),
(361035, 'PTHR43298', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN NORM-RELATED', 245853),
(361036, 'PTHR45706:SF8', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE NON-RECEPTOR TYPE 20', 245854),
(361037, 'PTHR45706:SF7', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE NON-RECEPTOR TYPE 4', 245854),
(361038, 'PTHR45706', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE', 245854),
(361039, 'PTHR45706:SF4', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE', 245854),
(361040, 'PTHR45706:SF3', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE NON-RECEPTOR TYPE 21', 245854),
(361041, 'PTHR45706:SF6', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE NON-RECEPTOR TYPE 14', 245854),
(361042, 'PTHR45706:SF5', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE NON-RECEPTOR TYPE 3', 245854),
(361043, 'PTHR45706:SF1', NULL, NULL, NULL, NULL, 'PEZ, ISOFORM A', 245854),
(361044, 'PTHR40429', NULL, NULL, NULL, NULL, 'FLAGELLAR ASSOCIATED PROTEIN', 245855),
(361045, 'PTHR40429:SF1', NULL, NULL, NULL, NULL, 'FLAGELLAR ASSOCIATED PROTEIN', 245855),
(361046, 'PTHR43174', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE 2-EPIMERASE', 245856),
(361047, 'PTHR43174:SF3', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE 2-EPIMERASE', 245856),
(361048, 'PTHR43174:SF2', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE 2-EPIMERASE', 245856),
(361049, 'PTHR43174:SF1', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE 2-EPIMERASE', 245856),
(361050, 'PTHR22674:SF4', NULL, NULL, NULL, NULL, 'NTPASE KAP FAMILY P-LOOP DOMAIN-CONTAINING PROTEIN 1', 245857),
(361051, 'PTHR22674:SF6', NULL, NULL, NULL, NULL, 'NTPASE, KAP FAMILY P-LOOP DOMAIN-CONTAINING 1', 245857),
(361052, 'PTHR22674', NULL, NULL, NULL, NULL, 'NTPASE, KAP FAMILY P-LOOP DOMAIN-CONTAINING 1', 245857),
(361053, 'PTHR22674:SF7', NULL, NULL, NULL, NULL, 'KAP NTPASE DOMAIN-CONTAINING PROTEIN', 245857),
(361054, 'PTHR31099:SF19', NULL, NULL, NULL, NULL, '', 245858),
(361055, 'PTHR31099:SF18', NULL, NULL, NULL, NULL, 'OS02G0307900 PROTEIN', 245858),
(361056, 'PTHR31099:SF42', NULL, NULL, NULL, NULL, 'F5J5.12', 245858),
(361057, 'PTHR31099:SF41', NULL, NULL, NULL, NULL, 'TRANSPOSASE (PUTATIVE), GYPSY TYPE-RELATED', 245858),
(361058, 'PTHR31099:SF30', NULL, NULL, NULL, NULL, 'BNAA05G36310D PROTEIN', 245858),
(361059, 'PTHR31099:SF40', NULL, NULL, NULL, NULL, 'BNAANNG04490D PROTEIN', 245858),
(361060, 'PTHR31099:SF39', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 245858),
(361061, 'PTHR31099:SF28', NULL, NULL, NULL, NULL, 'OS06G0165300 PROTEIN', 245858),
(361062, 'PTHR31099:SF16', NULL, NULL, NULL, NULL, 'BNAC08G08730D PROTEIN', 245858),
(361063, 'PTHR31099:SF38', NULL, NULL, NULL, NULL, 'PARAMYOSIN-LIKE', 245858),
(361064, 'PTHR31099:SF37', NULL, NULL, NULL, NULL, 'MEIOSIS-SPECIFIC PROTEIN ASY2', 245858),
(361065, 'PTHR31099:SF36', NULL, NULL, NULL, NULL, '', 245858),
(361066, 'PTHR31099:SF46', NULL, NULL, NULL, NULL, 'BNAC03G53980D PROTEIN', 245858),
(361067, 'PTHR31099:SF35', NULL, NULL, NULL, NULL, 'TRANSPOSASE (PUTATIVE), GYPSY TYPE-RELATED', 245858),
(361068, 'PTHR31099:SF24', NULL, NULL, NULL, NULL, 'BNAA06G20380D PROTEIN', 245858),
(361069, 'PTHR31099:SF45', NULL, NULL, NULL, NULL, 'DUF1204 DOMAIN-CONTAINING PROTEIN-RELATED', 245858),
(361070, 'PTHR31099', NULL, NULL, NULL, NULL, 'OS06G0165300 PROTEIN', 245858),
(361071, 'PTHR31099:SF44', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 245858),
(361072, 'PTHR31099:SF32', NULL, NULL, NULL, NULL, 'BNAANNG15870D PROTEIN', 245858);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(361073, 'PTHR31099:SF43', NULL, NULL, NULL, NULL, 'DYNACTIN SUBUNIT 1-LIKE', 245858),
(361074, 'PTHR46590', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL TRANSFER PROTEIN CSR1-RELATED', 245859),
(361075, 'PTHR46590:SF2', NULL, NULL, NULL, NULL, 'CRAL/TRIO DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_4G13930)-RELATED', 245859),
(361076, 'PTHR46590:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL TRANSFER PROTEIN CSR1', 245859),
(361077, 'PTHR46590:SF4', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 245859),
(361078, 'PTHR46590:SF6', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN C365.01', 245859),
(361079, 'PTHR46590:SF5', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN C589.09, MITOCHONDRIAL', 245859),
(361080, 'PTHR35820', NULL, NULL, NULL, NULL, 'SPERM MITOCHONDRIAL-ASSOCIATED CYSTEINE-RICH PROTEIN', 245860),
(361081, 'PTHR35820:SF1', NULL, NULL, NULL, NULL, 'SPERM MITOCHONDRIAL-ASSOCIATED CYSTEINE-RICH PROTEIN', 245860),
(361082, 'PTHR23528', NULL, NULL, NULL, NULL, '', 245861),
(361083, 'PTHR23528:SF2', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245861),
(361084, 'PTHR23528:SF1', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245861),
(361085, 'PTHR38092:SF4', NULL, NULL, NULL, NULL, '', 245862),
(361086, 'PTHR38092:SF5', NULL, NULL, NULL, NULL, 'DEVELOPMENTAL GENE 1062 PROTEIN', 245862),
(361087, 'PTHR38092', NULL, NULL, NULL, NULL, 'REGULATOR CUDA, PUTATIVE-RELATED', 245862),
(361088, 'PTHR38092:SF6', NULL, NULL, NULL, NULL, '', 245862),
(361089, 'PTHR38092:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR CUDA-RELATED', 245862),
(361090, 'PTHR38092:SF2', NULL, NULL, NULL, NULL, '', 245862),
(361091, 'PTHR35706', NULL, NULL, NULL, NULL, 'F14O23.11 PROTEIN', 245863),
(361092, 'PTHR35706:SF1', NULL, NULL, NULL, NULL, 'EMBRYOGENESIS-LIKE PROTEIN', 245863),
(361093, 'PTHR10210:SF94', NULL, NULL, NULL, NULL, 'RIBOSE-PHOSPHATE PYROPHOSPHOKINASE 2, CHLOROPLASTIC', 245864),
(361094, 'PTHR10210:SF53', NULL, NULL, NULL, NULL, 'GH23275P', 245864),
(361095, 'PTHR10210:SF96', NULL, NULL, NULL, NULL, 'RIBOSE-PHOSPHATE DIPHOSPHOKINASE', 245864),
(361096, 'PTHR10210:SF110', NULL, NULL, NULL, NULL, 'RIBOSE-PHOSPHATE PYROPHOSPHOKINASE 2', 245864),
(361097, 'PTHR10210:SF93', NULL, NULL, NULL, NULL, 'RIBOSE-PHOSPHATE PYROPHOSPHOKINASE 4-LIKE ISOFORM X1', 245864),
(361098, 'PTHR10210:SF112', NULL, NULL, NULL, NULL, 'RIBOSE-PHOSPHATE PYROPHOSPHOKINASE 3', 245864),
(361099, 'PTHR10210:SF111', NULL, NULL, NULL, NULL, 'PYROPHOSPHOKINASE, PUTATIVE-RELATED', 245864),
(361100, 'PTHR10210:SF36', NULL, NULL, NULL, NULL, 'RIBOSE-PHOSPHATE DIPHOSPHOKINASE', 245864),
(361101, 'PTHR10210:SF39', NULL, NULL, NULL, NULL, 'SYNTHETASE, PUTATIVE-RELATED', 245864),
(361102, 'PTHR10210:SF114', NULL, NULL, NULL, NULL, 'RIBOSE-PHOSPHATE DIPHOSPHOKINASE-RELATED', 245864),
(361103, 'PTHR10210:SF113', NULL, NULL, NULL, NULL, 'SYNTHETASE, PUTATIVE-RELATED', 245864),
(361104, 'PTHR10210:SF116', NULL, NULL, NULL, NULL, 'RIBOSE-PHOSPHATE PYROPHOSPHOKINASE 2, CHLOROPLASTIC', 245864),
(361105, 'PTHR10210:SF115', NULL, NULL, NULL, NULL, 'RIBOSE-PHOSPHATE PYROPHOSPHOKINASE A', 245864),
(361106, 'PTHR10210:SF32', NULL, NULL, NULL, NULL, 'RIBOSE-PHOSPHATE DIPHOSPHOKINASE', 245864),
(361107, 'PTHR10210:SF57', NULL, NULL, NULL, NULL, 'RIBOSE-PHOSPHATE PYROPHOSPHOKINASE 1', 245864),
(361108, 'PTHR10210:SF35', NULL, NULL, NULL, NULL, 'RIBOSE-PHOSPHATE DIPHOSPHOKINASE', 245864),
(361109, 'PTHR10210:SF34', NULL, NULL, NULL, NULL, 'RIBOSE-PHOSPHATE PYROPHOSPHOKINASE 4', 245864),
(361110, 'PTHR10210:SF108', NULL, NULL, NULL, NULL, 'RIBOSE-PHOSPHATE PYROPHOSPHOKINASE 2-LIKE', 245864),
(361111, 'PTHR10210:SF29', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYL PYROPHOSPHATE SYNTHASE-ASSOCIATED PROTEIN 2', 245864),
(361112, 'PTHR10210:SF41', NULL, NULL, NULL, NULL, 'RIBOSE-PHOSPHATE PYROPHOSPHOKINASE 5, CHLOROPLASTIC', 245864),
(361113, 'PTHR10210:SF85', NULL, NULL, NULL, NULL, 'OS03G0100040 PROTEIN', 245864),
(361114, 'PTHR10210:SF60', NULL, NULL, NULL, NULL, 'RIBOSE-PHOSPHATE PYROPHOSPHOKINASE 1', 245864);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(361115, 'PTHR10210:SF48', NULL, NULL, NULL, NULL, 'RIBOSE-PHOSPHATE PYROPHOSPHOKINASE 3', 245864),
(361116, 'PTHR10210', NULL, NULL, NULL, NULL, 'RIBOSE-PHOSPHATE DIPHOSPHOKINASE FAMILY MEMBER', 245864),
(361117, 'PTHR10210:SF100', NULL, NULL, NULL, NULL, 'RIBOSE-PHOSPHATE PYROPHOSPHOKINASE 1, CHLOROPLASTIC', 245864),
(361118, 'PTHR10210:SF28', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYL PYROPHOSPHATE SYNTHASE-ASSOCIATED PROTEIN 1', 245864),
(361119, 'PTHR10210:SF103', NULL, NULL, NULL, NULL, 'PRIBOSYLTRAN DOMAIN-CONTAINING PROTEIN', 245864),
(361120, 'PTHR10210:SF104', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLTRANSFERASE-LIKE PROTEIN-RELATED', 245864),
(361121, 'PTHR10210:SF46', NULL, NULL, NULL, NULL, 'RIBOSE-PHOSPHATE DIPHOSPHOKINASE', 245864),
(361122, 'PTHR10210:SF45', NULL, NULL, NULL, NULL, 'RIBOSE-PHOSPHATE PYROPHOSPHOKINASE 3, CHLOROPLASTIC', 245864),
(361123, 'PTHR10210:SF89', NULL, NULL, NULL, NULL, 'RIBOSE-PHOSPHATE PYROPHOSPHOKINASE C', 245864),
(361124, 'PTHR30417:SF1', NULL, NULL, NULL, NULL, 'N-ACETYLMURAMOYL-L-ALANINE AMIDASE BLYA', 245865),
(361125, 'PTHR30417:SF10', NULL, NULL, NULL, NULL, 'N-ACETYLMURAMOYL-L-ALANINE AMIDASE AMID', 245865),
(361126, 'PTHR30417:SF11', NULL, NULL, NULL, NULL, 'N-ACETYLMURAMOYL-L-ALANINE AMIDASE XLYA', 245865),
(361127, 'PTHR30417:SF4', NULL, NULL, NULL, NULL, '1,6-ANHYDRO-N-ACETYLMURAMYL-L-ALANINE AMIDASE AMPD', 245865),
(361128, 'PTHR30417', NULL, NULL, NULL, NULL, 'N-ACETYLMURAMOYL-L-ALANINE AMIDASE AMID', 245865),
(361129, 'PTHR47254:SF1', NULL, NULL, NULL, NULL, 'CELL WALL MANNOPROTEIN CIS3-RELATED', 245866),
(361130, 'PTHR47254:SF2', NULL, NULL, NULL, NULL, '', 245866),
(361131, 'PTHR47254', NULL, NULL, NULL, NULL, 'CELL WALL MANNOPROTEIN CIS3-RELATED', 245866),
(361132, 'PTHR15508', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S6 KINASE', 245867),
(361133, 'PTHR15508:SF9', NULL, NULL, NULL, NULL, 'SORTING NEXIN-15', 245867),
(361134, 'PTHR15508:SF8', NULL, NULL, NULL, NULL, 'LD24550P', 245867),
(361135, 'PTHR15508:SF4', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S6 KINASE-LIKE 1', 245867),
(361136, 'PTHR15508:SF2', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S6 KINASE DELTA-1', 245867),
(361137, 'PTHR10336:SF207', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868),
(361138, 'PTHR10336:SF206', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868),
(361139, 'PTHR10336:SF208', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C 1', 245868),
(361140, 'PTHR10336:SF203', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868),
(361141, 'PTHR10336:SF202', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868),
(361142, 'PTHR10336:SF169', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868),
(361143, 'PTHR10336:SF6', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4,5-BISPHOSPHATE PHOSPHODIESTERASE EPSILON-1', 245868),
(361144, 'PTHR10336:SF205', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868),
(361145, 'PTHR10336:SF204', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C 4-RELATED', 245868),
(361146, 'PTHR10336:SF166', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4,5-BISPHOSPHATE PHOSPHODIESTERASE ETA-2', 245868),
(361147, 'PTHR10336:SF201', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868),
(361148, 'PTHR10336:SF200', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868),
(361149, 'PTHR10336:SF162', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C 5', 245868),
(361150, 'PTHR10336:SF161', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868),
(361151, 'PTHR10336:SF12', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4,5-BISPHOSPHATE PHOSPHODIESTERASE BETA-1', 245868),
(361152, 'PTHR10336:SF160', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868),
(361153, 'PTHR10336:SF11', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4,5-BISPHOSPHATE PHOSPHODIESTERASE BETA-3', 245868),
(361154, 'PTHR10336:SF10', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4,5-BISPHOSPHATE PHOSPHODIESTERASE BETA-2', 245868);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(361155, 'PTHR10336:SF51', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4,5-BISPHOSPHATE PHOSPHODIESTERASE ETA-1', 245868),
(361156, 'PTHR10336:SF177', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868),
(361157, 'PTHR10336:SF178', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868),
(361158, 'PTHR10336:SF173', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4,5-BISPHOSPHATE PHOSPHODIESTERASE GAMMA-1', 245868),
(361159, 'PTHR10336:SF29', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4,5-BISPHOSPHATE PHOSPHODIESTERASE ZETA-1', 245868),
(361160, 'PTHR10336:SF172', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868),
(361161, 'PTHR10336', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE-SPECIFIC PHOSPHOLIPASE C FAMILY PROTEIN', 245868),
(361162, 'PTHR10336:SF25', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4,5-BISPHOSPHATE PHOSPHODIESTERASE GAMMA-2', 245868),
(361163, 'PTHR10336:SF171', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868),
(361164, 'PTHR10336:SF82', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868),
(361165, 'PTHR10336:SF80', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4,5-BISPHOSPHATE PHOSPHODIESTERASE DELTA-1', 245868),
(361166, 'PTHR10336:SF105', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C 3', 245868),
(361167, 'PTHR10336:SF149', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4,5-BISPHOSPHATE PHOSPHODIESTERASE CLASSES I AND II', 245868),
(361168, 'PTHR10336:SF188', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN', 245868),
(361169, 'PTHR10336:SF187', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868),
(361170, 'PTHR10336:SF146', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868),
(361171, 'PTHR10336:SF102', NULL, NULL, NULL, NULL, 'INACTIVE PHOSPHOLIPASE C-LIKE PROTEIN 1', 245868),
(361172, 'PTHR10336:SF101', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C 6', 245868),
(361173, 'PTHR10336:SF189', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868),
(361174, 'PTHR10336:SF184', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868),
(361175, 'PTHR10336:SF183', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868),
(361176, 'PTHR10336:SF36', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4,5-BISPHOSPHATE PHOSPHODIESTERASE BETA-4', 245868),
(361177, 'PTHR10336:SF79', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4,5-BISPHOSPHATE PHOSPHODIESTERASE GAMMA', 245868),
(361178, 'PTHR10336:SF182', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868),
(361179, 'PTHR10336:SF33', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4,5-BISPHOSPHATE PHOSPHODIESTERASE DELTA-3', 245868),
(361180, 'PTHR10336:SF181', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868),
(361181, 'PTHR10336:SF31', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4,5-BISPHOSPHATE PHOSPHODIESTERASE DELTA-4', 245868),
(361182, 'PTHR10336:SF159', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 4,5-BISPHOSPHATE PHOSPHODIESTERASE GAMMA', 245868),
(361183, 'PTHR10336:SF158', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868),
(361184, 'PTHR10336:SF199', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868),
(361185, 'PTHR10336:SF154', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C 2', 245868),
(361186, 'PTHR10336:SF157', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868),
(361187, 'PTHR10336:SF156', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C 7', 245868),
(361188, 'PTHR10336:SF194', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868),
(361189, 'PTHR10336:SF153', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868),
(361190, 'PTHR10336:SF196', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868),
(361191, 'PTHR10336:SF190', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868),
(361192, 'PTHR10336:SF193', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(361193, 'PTHR10336:SF89', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868),
(361194, 'PTHR10336:SF85', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHOLIPASE C', 245868),
(361195, 'PTHR10336:SF84', NULL, NULL, NULL, NULL, 'INACTIVE PHOSPHOLIPASE C-LIKE PROTEIN 2', 245868),
(361196, 'PTHR46799', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN UNC-4 HOMOLOG', 245869),
(361197, 'PTHR46799:SF1', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN UNC-4 HOMOLOG', 245869),
(361198, 'PTHR15193:SF1', NULL, NULL, NULL, NULL, 'CD83 ANTIGEN', 245870),
(361199, 'PTHR15193:SF2', NULL, NULL, NULL, NULL, 'SI:DKEY-109A10.2', 245870),
(361200, 'PTHR15193', NULL, NULL, NULL, NULL, 'CD83 ANTIGEN', 245870),
(361201, 'PTHR12978', NULL, NULL, NULL, NULL, 'HISTIDINE TRIAD  HIT  PROTEIN MEMBER', 245871),
(361202, 'PTHR12978:SF0', NULL, NULL, NULL, NULL, 'M7GPPPX DIPHOSPHATASE', 245871),
(361203, 'PTHR14049:SF9', NULL, NULL, NULL, NULL, 'PROCOLLAGEN-PROLINE 3-DIOXYGENASE', 245872),
(361204, 'PTHR14049:SF1', NULL, NULL, NULL, NULL, 'PROLYL 3-HYDROXYLASE 2', 245872),
(361205, 'PTHR14049', NULL, NULL, NULL, NULL, 'LEPRECAN 1', 245872),
(361206, 'PTHR14049:SF5', NULL, NULL, NULL, NULL, 'PROLYL 3-HYDROXYLASE 1', 245872),
(361207, 'PTHR14049:SF14', NULL, NULL, NULL, NULL, 'PROLYL 3-HYDROXYLASE 3', 245872),
(361208, 'PTHR14049:SF15', NULL, NULL, NULL, NULL, 'PROCOLLAGEN-PROLINE 3-DIOXYGENASE', 245872),
(361209, 'PTHR32215', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 57', 245873),
(361210, 'PTHR32215:SF0', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 57', 245873),
(361211, 'PTHR32215:SF15', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 245873),
(361212, 'PTHR32215:SF14', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT BETA-LIKE PROTEIN', 245873),
(361213, 'PTHR43506', NULL, NULL, NULL, NULL, 'BIOTIN/LIPOATE A/B PROTEIN LIGASE FAMILY', 245874),
(361214, 'PTHR43506:SF3', NULL, NULL, NULL, NULL, 'BPL/LPL CATALYTIC DOMAIN-CONTAINING PROTEIN', 245874),
(361215, 'PTHR43506:SF1', NULL, NULL, NULL, NULL, 'BPL/LPL CATALYTIC DOMAIN-CONTAINING PROTEIN', 245874),
(361216, 'PTHR21109', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 28S RIBOSOMAL PROTEIN S21', 245875),
(361217, 'PTHR21109:SF21', NULL, NULL, NULL, NULL, 'STRUCTURAL CONSTITUENT OF RIBOSOME', 245875),
(361218, 'PTHR21109:SF10', NULL, NULL, NULL, NULL, '', 245875),
(361219, 'PTHR21109:SF18', NULL, NULL, NULL, NULL, 'BNAC02G42450D PROTEIN', 245875),
(361220, 'PTHR21109:SF4', NULL, NULL, NULL, NULL, 'OS08G0121800 PROTEIN', 245875),
(361221, 'PTHR21109:SF17', NULL, NULL, NULL, NULL, 'RIBOSOME', 245875),
(361222, 'PTHR21109:SF0', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S21, MITOCHONDRIAL', 245875),
(361223, 'PTHR21109:SF25', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S21-RELATED', 245875),
(361224, 'PTHR21109:SF24', NULL, NULL, NULL, NULL, 'BNAA02G28660D PROTEIN', 245875),
(361225, 'PTHR21109:SF13', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S21, MITOCHONDRIAL', 245875),
(361226, 'PTHR21109:SF12', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S21-RELATED', 245875),
(361227, 'PTHR21109:SF23', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S21, CHLOROPLASTIC-LIKE ISOFORM X1', 245875),
(361228, 'PTHR21109:SF22', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S21', 245875),
(361229, 'PTHR21354:SF0', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 511', 245876),
(361230, 'PTHR21354', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 245876),
(361231, 'PTHR37294', NULL, NULL, NULL, NULL, '3''-5'' EXORIBONUCLEASE YHAM', 245877),
(361232, 'PTHR37294:SF1', NULL, NULL, NULL, NULL, '3''-5'' EXORIBONUCLEASE YHAM', 245877),
(361233, 'PTHR39374', NULL, NULL, NULL, NULL, 'PROTEIN CBG12861', 245878),
(361234, 'PTHR39374:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG12861', 245878),
(361235, 'PTHR47426:SF4', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 245879),
(361236, 'PTHR47426:SF3', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASES (NAT) SUPERFAMILY PROTEIN', 245879),
(361237, 'PTHR47426', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASES (NAT) SUPERFAMILY PROTEIN', 245879);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(361238, 'PTHR23012:SF209', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 245880),
(361239, 'PTHR23012:SF170', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 245880),
(361240, 'PTHR23012:SF192', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 245880),
(361241, 'PTHR23012:SF187', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 245880),
(361242, 'PTHR23012:SF164', NULL, NULL, NULL, NULL, 'OS05G0552400 PROTEIN', 245880),
(361243, 'PTHR23012:SF200', NULL, NULL, NULL, NULL, 'OS02G0577100 PROTEIN', 245880),
(361244, 'PTHR23012:SF189', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING-CH-TYPE, ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 245880),
(361245, 'PTHR23012:SF183', NULL, NULL, NULL, NULL, 'OS08G0436200 PROTEIN', 245880),
(361246, 'PTHR23012:SF185', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER SUPERFAMILY PROTEIN', 245880),
(361247, 'PTHR23012:SF163', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER SUPERFAMILY PROTEIN', 245880),
(361248, 'PTHR23012:SF206', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER PROTEIN', 245880),
(361249, 'PTHR23012:SF205', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 245880),
(361250, 'PTHR23012:SF208', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 245880),
(361251, 'PTHR23012:SF207', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER SUPERFAMILY PROTEIN-RELATED', 245880),
(361252, 'PTHR23012:SF169', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 245880),
(361253, 'PTHR23012:SF204', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER SUPERFAMILY PROTEIN', 245880),
(361254, 'PTHR23012', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER DOMAIN-CONTAINING', 245880),
(361255, 'PTHR23012:SF180', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER SUPERFAMILY PROTEIN', 245880),
(361256, 'PTHR23012:SF176', NULL, NULL, NULL, NULL, 'OS01G0894600 PROTEIN', 245880),
(361257, 'PTHR23012:SF175', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER SUPERFAMILY PROTEIN', 245880),
(361258, 'PTHR23012:SF211', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 245880),
(361259, 'PTHR23012:SF177', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MARCH11-LIKE', 245880),
(361260, 'PTHR23012:SF210', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 245880),
(361261, 'PTHR23012:SF194', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 245880),
(361262, 'PTHR23012:SF193', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 245880),
(361263, 'PTHR23012:SF196', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER SUPERFAMILY PROTEIN-RELATED', 245880),
(361264, 'PTHR23012:SF93', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER SUPERFAMILY PROTEIN', 245880),
(361265, 'PTHR23012:SF174', NULL, NULL, NULL, NULL, 'OS01G0121200 PROTEIN', 245880),
(361266, 'PTHR23012:SF213', NULL, NULL, NULL, NULL, 'AMINOACYLTRANSFERASE, E1 UBIQUITIN-ACTIVATING ENZYME-RELATED', 245880),
(361267, 'PTHR23012:SF212', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER SUPERFAMILY PROTEIN-RELATED', 245880),
(361268, 'PTHR23012:SF159', NULL, NULL, NULL, NULL, 'OS05G0355300 PROTEIN', 245880),
(361269, 'PTHR48060:SF2', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT (LRR) FAMILY PROTEIN-RELATED', 245881),
(361270, 'PTHR48060:SF1', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT (LRR) FAMILY PROTEIN', 245881),
(361271, 'PTHR48060:SF4', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 245881),
(361272, 'PTHR48060', NULL, NULL, NULL, NULL, 'DNA DAMAGE-REPAIR/TOLERATION PROTEIN DRT100', 245881),
(361273, 'PTHR48060:SF3', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT (LRR) FAMILY PROTEIN', 245881),
(361274, 'PTHR48060:SF11', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 245881),
(361275, 'PTHR48060:SF15', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 245881),
(361276, 'PTHR48060:SF9', NULL, NULL, NULL, NULL, 'INACTIVE LEUCINE-RICH REPEAT RECEPTOR KINASE XIAO-RELATED', 245881),
(361277, 'PTHR48060:SF14', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN, PLANT-TYPE-RELATED', 245881);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(361278, 'PTHR48060:SF6', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 245881),
(361279, 'PTHR48060:SF7', NULL, NULL, NULL, NULL, 'DNA DAMAGE-REPAIR/TOLERATION PROTEIN DRT100', 245881),
(361280, 'PTHR46421:SF2', NULL, NULL, NULL, NULL, 'PDCD2_C DOMAIN-CONTAINING PROTEIN', 245882),
(361281, 'PTHR46421:SF1', NULL, NULL, NULL, NULL, 'PROGRAMMED CELL DEATH PROTEIN 2-LIKE', 245882),
(361282, 'PTHR46421', NULL, NULL, NULL, NULL, 'PROGRAMMED CELL DEATH PROTEIN 2-LIKE', 245882),
(361283, 'PTHR14971:SF2', NULL, NULL, NULL, NULL, 'VESICULAR, OVEREXPRESSED IN CANCER, PROSURVIVAL PROTEIN 1', 245883),
(361284, 'PTHR14971', NULL, NULL, NULL, NULL, 'VESICULAR, OVEREXPRESSED IN CANCER, PROSURVIVAL PROTEIN 1', 245883),
(361285, 'PTHR22895:SF8', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 245884),
(361286, 'PTHR22895:SF6', NULL, NULL, NULL, NULL, '', 245884),
(361287, 'PTHR22895', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 245884),
(361288, 'PTHR22895:SF0', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING PROTEIN 6', 245884),
(361289, 'PTHR46110:SF5', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 245885),
(361290, 'PTHR46110', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HMX', 245885),
(361291, 'PTHR46110:SF2', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HMX3', 245885),
(361292, 'PTHR46110:SF1', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HMX1', 245885),
(361293, 'PTHR46110:SF4', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HMX2', 245885),
(361294, 'PTHR46110:SF3', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HMX', 245885),
(361295, 'PTHR30004', NULL, NULL, NULL, NULL, '4-HYDROXYTHREONINE-4-PHOSPHATE DEHYDROGENASE', 245886),
(361296, 'PTHR30004:SF3', NULL, NULL, NULL, NULL, '4-HYDROXYTHREONINE-4-PHOSPHATE DEHYDROGENASE 2-RELATED', 245886),
(361297, 'PTHR30004:SF6', NULL, NULL, NULL, NULL, 'D-THREONATE 4-PHOSPHATE DEHYDROGENASE', 245886),
(361298, 'PTHR30004:SF5', NULL, NULL, NULL, NULL, '4-HYDROXYTHREONINE-4-PHOSPHATE DEHYDROGENASE', 245886),
(361299, 'PTHR10546:SF4', NULL, NULL, NULL, NULL, 'SI:CH211-225P5.8', 245887),
(361300, 'PTHR10546:SF5', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 245887),
(361301, 'PTHR10546', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL SUBUNIT BETA-1 AND 3', 245887),
(361302, 'PTHR10546:SF9', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL SUBUNIT BETA-1', 245887),
(361303, 'PTHR10546:SF2', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL SUBUNIT BETA-1', 245887),
(361304, 'PTHR10546:SF1', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL SUBUNIT BETA-3', 245887),
(361305, 'PTHR36206:SF14', NULL, NULL, NULL, NULL, 'ZN(2)-C6 FUNGAL-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', 245888),
(361306, 'PTHR36206:SF13', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN MOC3', 245888),
(361307, 'PTHR36206:SF16', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 245888),
(361308, 'PTHR36206:SF17', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR', 245888),
(361309, 'PTHR36206:SF4', NULL, NULL, NULL, NULL, 'HYPOTHETICAL CONSERVED PROTEIN (EUROFUNG)', 245888),
(361310, 'PTHR36206', NULL, NULL, NULL, NULL, 'ASPERCRYPTIN BIOSYNTHESIS CLUSTER-SPECIFIC TRANSCRIPTION REGULATOR ATNN-RELATED', 245888),
(361311, 'PTHR36206:SF10', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 245888),
(361312, 'PTHR36206:SF12', NULL, NULL, NULL, NULL, 'ASPERCRYPTIN BIOSYNTHESIS CLUSTER-SPECIFIC TRANSCRIPTION REGULATOR ATNN-RELATED', 245888),
(361313, 'PTHR15327:SF1', NULL, NULL, NULL, NULL, 'MFAP1 DOMAIN-CONTAINING PROTEIN', 245889),
(361314, 'PTHR15327:SF0', NULL, NULL, NULL, NULL, 'MICROFIBRILLAR-ASSOCIATED PROTEIN 1', 245889),
(361315, 'PTHR15327', NULL, NULL, NULL, NULL, 'MICROFIBRIL-ASSOCIATED PROTEIN', 245889),
(361316, 'PTHR35806', NULL, NULL, NULL, NULL, 'OXALOACETATE DECARBOXYLASE BETA CHAIN 2', 245890),
(361317, 'PTHR35806:SF1', NULL, NULL, NULL, NULL, 'OXALOACETATE DECARBOXYLASE BETA CHAIN 2', 245890),
(361318, 'PTHR35374:SF1', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 11A-LIKE', 245891),
(361319, 'PTHR35374', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 11A-LIKE', 245891);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(361320, 'PTHR16840:SF3', NULL, NULL, NULL, NULL, 'GROWTH ARREST-SPECIFIC PROTEIN 1', 245892),
(361321, 'PTHR16840:SF8', NULL, NULL, NULL, NULL, '', 245892),
(361322, 'PTHR16840:SF9', NULL, NULL, NULL, NULL, 'GROWTH ARREST-SPECIFIC 1A', 245892),
(361323, 'PTHR16840:SF7', NULL, NULL, NULL, NULL, 'GROWTH ARREST-SPECIFIC 1B', 245892),
(361324, 'PTHR16840', NULL, NULL, NULL, NULL, 'GROWTH ARREST-SPECIFIC PROTEIN 1', 245892),
(361325, 'PTHR34219', NULL, NULL, NULL, NULL, 'IRON-REGULATED INNER MEMBRANE PROTEIN-RELATED', 245893),
(361326, 'PTHR34219:SF7', NULL, NULL, NULL, NULL, 'IRON-REGULATED INNER MEMBRANE PROTEIN', 245893),
(361327, 'PTHR34219:SF6', NULL, NULL, NULL, NULL, 'BLR3280 PROTEIN', 245893),
(361328, 'PTHR34219:SF5', NULL, NULL, NULL, NULL, 'BLR4505 PROTEIN', 245893),
(361329, 'PTHR34219:SF4', NULL, NULL, NULL, NULL, 'SIDEROPHORE TRANSPORTER COMPONENT 2-RELATED', 245893),
(361330, 'PTHR34219:SF3', NULL, NULL, NULL, NULL, 'BLL7967 PROTEIN', 245893),
(361331, 'PTHR34219:SF1', NULL, NULL, NULL, NULL, 'PEPSY DOMAIN-CONTAINING PROTEIN', 245893),
(361332, 'PTHR46523:SF1', NULL, NULL, NULL, NULL, 'DCTP PYROPHOSPHATASE 1', 245894),
(361333, 'PTHR46523', NULL, NULL, NULL, NULL, 'DCTP PYROPHOSPHATASE 1', 245894),
(361334, 'PTHR46801', NULL, NULL, NULL, NULL, 'OS06G0309200 PROTEIN', 245895),
(361335, 'PTHR46801:SF2', NULL, NULL, NULL, NULL, 'BPI2 DOMAIN-CONTAINING PROTEIN', 245895),
(361336, 'PTHR46801:SF8', NULL, NULL, NULL, NULL, 'LBP/BPI/CETP FAMILY, CARBOXY-TERMINAL DOMAIN PROTEIN', 245895),
(361337, 'PTHR46801:SF6', NULL, NULL, NULL, NULL, 'LBP/BPI/CETP FAMILY, CARBOXY-TERMINAL DOMAIN PROTEIN', 245895),
(361338, 'PTHR46801:SF7', NULL, NULL, NULL, NULL, 'LIPID-BINDING SERUM GLYCOPROTEIN FAMILY PROTEIN-RELATED', 245895),
(361339, 'PTHR46801:SF5', NULL, NULL, NULL, NULL, 'OS09G0482720 PROTEIN', 245895),
(361340, 'PTHR31607:SF22', NULL, NULL, NULL, NULL, 'DUF1216 DOMAIN-CONTAINING PROTEIN', 245896),
(361341, 'PTHR31607:SF23', NULL, NULL, NULL, NULL, 'BNAA02G34240D PROTEIN', 245896),
(361342, 'PTHR31607', NULL, NULL, NULL, NULL, 'DUF1216 DOMAIN-CONTAINING PROTEIN-RELATED', 245896),
(361343, 'PTHR31607:SF28', NULL, NULL, NULL, NULL, 'DUF1216 DOMAIN-CONTAINING PROTEIN-RELATED', 245896),
(361344, 'PTHR13140', NULL, NULL, NULL, NULL, 'MYOSIN', 245897),
(361345, 'PTHR13140:SF812', NULL, NULL, NULL, NULL, 'BNAA05G15910D PROTEIN', 245897),
(361346, 'PTHR13140:SF735', NULL, NULL, NULL, NULL, 'MYOSIN-5', 245897),
(361347, 'PTHR13140:SF736', NULL, NULL, NULL, NULL, 'MYOSIN FAMILY PROTEIN WITH DIL DOMAIN', 245897),
(361348, 'PTHR13140:SF417', NULL, NULL, NULL, NULL, 'UNCONVENTIONAL MYOSIN-ID', 245897),
(361349, 'PTHR13140:SF737', NULL, NULL, NULL, NULL, 'MYOSIN FAMILY PROTEIN WITH DIL DOMAIN', 245897),
(361350, 'PTHR13140:SF697', NULL, NULL, NULL, NULL, 'OS03G0860700 PROTEIN', 245897),
(361351, 'PTHR13140:SF851', NULL, NULL, NULL, NULL, 'MYOSIN-14', 245897),
(361352, 'PTHR13140:SF655', NULL, NULL, NULL, NULL, 'MYOSIN IA HEAVY CHAIN', 245897),
(361353, 'PTHR13140:SF255', NULL, NULL, NULL, NULL, 'UNCONVENTIONAL MYOSIN-IC', 245897),
(361354, 'PTHR13140:SF772', NULL, NULL, NULL, NULL, 'MYOSIN-17', 245897),
(361355, 'PTHR13140:SF498', NULL, NULL, NULL, NULL, 'DACHS, ISOFORM E', 245897),
(361356, 'PTHR13140:SF850', NULL, NULL, NULL, NULL, 'MYOSIN-6', 245897),
(361357, 'PTHR13140:SF381', NULL, NULL, NULL, NULL, 'UNCONVENTIONAL MYOSIN-IG', 245897),
(361358, 'PTHR13140:SF780', NULL, NULL, NULL, NULL, 'MYOSIN-1', 245897),
(361359, 'PTHR13140:SF819', NULL, NULL, NULL, NULL, 'BNAA06G36470D PROTEIN', 245897),
(361360, 'PTHR13140:SF848', NULL, NULL, NULL, NULL, 'MYOSIN-7', 245897),
(361361, 'PTHR13140:SF805', NULL, NULL, NULL, NULL, 'MYOSIN-1-LIKE', 245897),
(361362, 'PTHR13140:SF849', NULL, NULL, NULL, NULL, 'MYOSIN-3', 245897),
(361363, 'PTHR13140:SF729', NULL, NULL, NULL, NULL, 'HEAVY CHAIN, UNCONVENTIONAL MYOSIN', 245897),
(361364, 'PTHR13140:SF806', NULL, NULL, NULL, NULL, 'IQ MOTIF, EF-HAND BINDING SITE-RELATED', 245897),
(361365, 'PTHR13140:SF807', NULL, NULL, NULL, NULL, 'MYOSIN-9-LIKE ISOFORM X1', 245897),
(361366, 'PTHR13140:SF767', NULL, NULL, NULL, NULL, 'MYOSIN-11', 245897);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(361367, 'PTHR13140:SF844', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN-RELATED', 245897),
(361368, 'PTHR13140:SF800', NULL, NULL, NULL, NULL, 'BNAA02G04890D PROTEIN', 245897),
(361369, 'PTHR13140:SF845', NULL, NULL, NULL, NULL, 'MYOSIN MOTOR DOMAIN-CONTAINING PROTEIN', 245897),
(361370, 'PTHR13140:SF769', NULL, NULL, NULL, NULL, 'MYOSIN-2-LIKE ISOFORM X1', 245897),
(361371, 'PTHR13140:SF802', NULL, NULL, NULL, NULL, 'MYOSIN IB', 245897),
(361372, 'PTHR13140:SF846', NULL, NULL, NULL, NULL, '', 245897),
(361373, 'PTHR13140:SF847', NULL, NULL, NULL, NULL, '', 245897),
(361374, 'PTHR13140:SF840', NULL, NULL, NULL, NULL, 'MYOSIN VIIAA-RELATED', 245897),
(361375, 'PTHR13140:SF763', NULL, NULL, NULL, NULL, 'MYOSIN-4', 245897),
(361376, 'PTHR13140:SF841', NULL, NULL, NULL, NULL, 'MYOSIN-52', 245897),
(361377, 'PTHR13140:SF369', NULL, NULL, NULL, NULL, 'UNCONVENTIONAL MYOSIN-VIIA', 245897),
(361378, 'PTHR13140:SF842', NULL, NULL, NULL, NULL, 'MYOSIN VIIAB', 245897),
(361379, 'PTHR13140:SF766', NULL, NULL, NULL, NULL, 'MYOSIN MOTOR DOMAIN PROTEIN AND DIL DOMAIN PROTEIN', 245897),
(361380, 'PTHR13140:SF843', NULL, NULL, NULL, NULL, 'IQ MOTIF, EF-HAND BINDING SITE-RELATED', 245897),
(361381, 'PTHR13140:SF561', NULL, NULL, NULL, NULL, 'MIP31562P1', 245897),
(361382, 'PTHR13140:SF761', NULL, NULL, NULL, NULL, 'MYOSIN-8-LIKE ISOFORM X1', 245897),
(361383, 'PTHR13140:SF762', NULL, NULL, NULL, NULL, 'MYOSIN-13', 245897),
(361384, 'PTHR13140:SF289', NULL, NULL, NULL, NULL, 'UNCONVENTIONAL MYOSIN-XIX', 245897),
(361385, 'PTHR13140:SF291', NULL, NULL, NULL, NULL, 'UNCONVENTIONAL MYOSIN-IA', 245897),
(361386, 'PTHR13140:SF837', NULL, NULL, NULL, NULL, 'MYOSIN-3-RELATED', 245897),
(361387, 'PTHR13140:SF519', NULL, NULL, NULL, NULL, 'MYOSIN IF HEAVY CHAIN', 245897),
(361388, 'PTHR13140:SF838', NULL, NULL, NULL, NULL, 'MYOSIN-16', 245897),
(361389, 'PTHR13140:SF839', NULL, NULL, NULL, NULL, 'MYOSIN-G HEAVY CHAIN', 245897),
(361390, 'PTHR13140:SF719', NULL, NULL, NULL, NULL, 'MYOSIN MOTOR DOMAIN-CONTAINING PROTEIN', 245897),
(361391, 'PTHR13140:SF679', NULL, NULL, NULL, NULL, 'UNCONVENTIONAL MYOSIN IC', 245897),
(361392, 'PTHR13140:SF713', NULL, NULL, NULL, NULL, 'UNCONVENTIONAL MYOSIN ID', 245897),
(361393, 'PTHR13140:SF834', NULL, NULL, NULL, NULL, 'XI, PUTATIVE-RELATED', 245897),
(361394, 'PTHR13140:SF757', NULL, NULL, NULL, NULL, 'MYOSIN-8', 245897),
(361395, 'PTHR13140:SF835', NULL, NULL, NULL, NULL, 'MYOSIN-6-LIKE ISOFORM X1', 245897),
(361396, 'PTHR13140:SF836', NULL, NULL, NULL, NULL, 'DILUTE CLASS UNCONVENTIONAL MYOSIN, ISOFORM C', 245897),
(361397, 'PTHR13140:SF356', NULL, NULL, NULL, NULL, 'UNCONVENTIONAL MYOSIN-VB', 245897),
(361398, 'PTHR13140:SF752', NULL, NULL, NULL, NULL, 'MYOSIN-M HEAVY CHAIN', 245897),
(361399, 'PTHR13140:SF797', NULL, NULL, NULL, NULL, 'MYOSIN-10', 245897),
(361400, 'PTHR13140:SF753', NULL, NULL, NULL, NULL, 'MYOSIN-9-LIKE', 245897),
(361401, 'PTHR13140:SF313', NULL, NULL, NULL, NULL, 'UNCONVENTIONAL MYOSIN-VC', 245897),
(361402, 'PTHR13140:SF798', NULL, NULL, NULL, NULL, 'BNAA10G07360D PROTEIN', 245897),
(361403, 'PTHR13140:SF755', NULL, NULL, NULL, NULL, '', 245897),
(361404, 'PTHR13140:SF513', NULL, NULL, NULL, NULL, 'MYOSIN ID HEAVY CHAIN', 245897),
(361405, 'PTHR13140:SF792', NULL, NULL, NULL, NULL, 'MYOSIN-I HEAVY CHAIN', 245897),
(361406, 'PTHR13140:SF550', NULL, NULL, NULL, NULL, 'MYOSIN MOTOR DOMAIN-CONTAINING PROTEIN', 245897),
(361407, 'PTHR13140:SF353', NULL, NULL, NULL, NULL, 'UNCONVENTIONAL MYOSIN-IH', 245897),
(361408, 'PTHR13140:SF277', NULL, NULL, NULL, NULL, 'UNCONVENTIONAL MYOSIN-IB', 245897),
(361409, 'PTHR13140:SF795', NULL, NULL, NULL, NULL, 'OS01G0584200 PROTEIN', 245897),
(361410, 'PTHR13140:SF751', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN', 245897),
(361411, 'PTHR13140:SF706', NULL, NULL, NULL, NULL, 'MYOSIN-2', 245897),
(361412, 'PTHR13140:SF745', NULL, NULL, NULL, NULL, 'UNCONVENTIONAL MYOSIN-VI', 245897),
(361413, 'PTHR13140:SF747', NULL, NULL, NULL, NULL, 'MYOSIN IEB', 245897),
(361414, 'PTHR13140:SF505', NULL, NULL, NULL, NULL, 'UNCONVENTIONAL MYOSIN-VIIB', 245897);
INSERT INTO "PUBLIC"."MODEL" VALUES
(361415, 'PTHR13140:SF824', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN', 245897),
(361416, 'PTHR13140:SF703', NULL, NULL, NULL, NULL, 'MYOSIN 28B1, ISOFORM B-RELATED', 245897),
(361417, 'PTHR13140:SF825', NULL, NULL, NULL, NULL, 'IQ MOTIF, EF-HAND BINDING SITE, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 245897),
(361418, 'PTHR13140:SF748', NULL, NULL, NULL, NULL, 'P-LOOP NUCLEOSIDE TRIPHOSPHATE HYDROLASE SUPERFAMILY PROTEIN', 245897),
(361419, 'PTHR13140:SF785', NULL, NULL, NULL, NULL, 'BNAC03G41300D PROTEIN', 245897),
(361420, 'PTHR13140:SF743', NULL, NULL, NULL, NULL, 'MYOSIN-K HEAVY CHAIN', 245897),
(361421, 'PTHR13140:SF781', NULL, NULL, NULL, NULL, 'MYOSIN-15', 245897),
(361422, 'PTHR13140:SF341', NULL, NULL, NULL, NULL, 'UNCONVENTIONAL MYOSIN-IE', 245897),
(361423, 'PTHR13140:SF782', NULL, NULL, NULL, NULL, 'BNAA09G10180D PROTEIN', 245897),
(361424, 'PTHR13140:SF663', NULL, NULL, NULL, NULL, 'UNCONVENTIONAL MYOSIN-IF', 245897),
(361425, 'PTHR13140:SF273', NULL, NULL, NULL, NULL, 'UNCONVENTIONAL MYOSIN-VA', 245897),
(361426, 'PTHR13140:SF270', NULL, NULL, NULL, NULL, 'MYOSIN-12', 245897),
(361427, 'PTHR13140:SF709', NULL, NULL, NULL, NULL, 'UNCONVENTIONAL MYOSIN-XV', 245897),
(361428, 'PTHR28613:SF5', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 238', 245898),
(361429, 'PTHR28613:SF6', NULL, NULL, NULL, NULL, 'RIKEN CDNA A930007A09 GENE', 245898),
(361430, 'PTHR28613:SF7', NULL, NULL, NULL, NULL, '', 245898),
(361431, 'PTHR28613:SF8', NULL, NULL, NULL, NULL, 'LCCL DOMAIN-CONTAINING PROTEIN', 245898),
(361432, 'PTHR28613:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 238-LIKE', 245898),
(361433, 'PTHR28613', NULL, NULL, NULL, NULL, 'SI:CH211-232M10.4-RELATED', 245898),
(361434, 'PTHR28613:SF9', NULL, NULL, NULL, NULL, 'SI:DKEY-16I5.8-RELATED', 245898),
(361435, 'PTHR12773:SF0', NULL, NULL, NULL, NULL, 'MULTIFUNCTIONAL METHYLTRANSFERASE SUBUNIT TRM112-LIKE PROTEIN', 245899),
(361436, 'PTHR12773:SF5', NULL, NULL, NULL, NULL, 'BNAA09G30730D PROTEIN', 245899),
(361437, 'PTHR12773', NULL, NULL, NULL, NULL, 'UPF0315 PROTEIN-RELATED', 245899),
(361438, 'PTHR12773:SF3', NULL, NULL, NULL, NULL, 'MULTIFUNCTIONAL METHYLTRANSFERASE SUBUNIT TRM112 HOMOLOG B', 245899),
(361439, 'PTHR46343:SF3', NULL, NULL, NULL, NULL, 'SUSHI REPEAT-CONTAINING PROTEIN SRPX2', 245900),
(361440, 'PTHR46343:SF1', NULL, NULL, NULL, NULL, 'SUSHI REPEAT-CONTAINING PROTEIN SRPX', 245900),
(361441, 'PTHR46343:SF2', NULL, NULL, NULL, NULL, 'HYR DOMAIN-CONTAINING PROTEIN', 245900),
(361442, 'PTHR46343', NULL, NULL, NULL, NULL, 'HYR DOMAIN-CONTAINING PROTEIN', 245900),
(361443, 'PTHR36010', NULL, NULL, NULL, NULL, 'CYTOCHROME C BIOGENESIS CCMF C-TERMINAL-LIKE MITOCHONDRIAL PROTEIN-RELATED', 245901),
(361444, 'PTHR36010:SF5', NULL, NULL, NULL, NULL, '', 245901),
(361445, 'PTHR36010:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME C BIOGENESIS CCMF C-TERMINAL-LIKE MITOCHONDRIAL PROTEIN-RELATED', 245901),
(361446, 'PTHR36010:SF2', NULL, NULL, NULL, NULL, 'LOW PROTEIN: CYTOCHROME C BIOGENESIS CCMF-LIKE PROTEIN', 245901),
(361447, 'PTHR28113', NULL, NULL, NULL, NULL, 'DASH COMPLEX SUBUNIT DAM1', 245902),
(361448, 'PTHR28113:SF1', NULL, NULL, NULL, NULL, 'DASH COMPLEX SUBUNIT DAM1', 245902),
(361449, 'PTHR37514', NULL, NULL, NULL, NULL, 'N-TERMINAL DELTA ENDOTOXIN DOMAIN-CONTAINING PROTEIN-RELATED', 245903),
(361450, 'PTHR37514:SF1', NULL, NULL, NULL, NULL, 'ENDOTOXIN_N DOMAIN-CONTAINING PROTEIN-RELATED', 245903),
(361451, 'PTHR47104:SF3', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 245904),
(361452, 'PTHR47104:SF4', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 245904),
(361453, 'PTHR47104:SF1', NULL, NULL, NULL, NULL, 'SEC14P-LIKE PHOSPHATIDYLINOSITOL TRANSFER FAMILY PROTEIN', 245904),
(361454, 'PTHR47104:SF2', NULL, NULL, NULL, NULL, 'SEC14P-LIKE PHOSPHATIDYLINOSITOL TRANSFER FAMILY PROTEIN', 245904),
(361455, 'PTHR47104', NULL, NULL, NULL, NULL, 'SEC14P-LIKE PHOSPHATIDYLINOSITOL TRANSFER FAMILY PROTEIN', 245904),
(361456, 'PTHR31089:SF1', NULL, NULL, NULL, NULL, 'CYCLIC DOF FACTOR 2', 245905);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(361457, 'PTHR31089:SF6', NULL, NULL, NULL, NULL, 'AOBP-LIKE PROTEIN', 245905),
(361458, 'PTHR31089:SF61', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN 5', 245905),
(361459, 'PTHR31089:SF63', NULL, NULL, NULL, NULL, 'CYCLIC DOF FACTOR 2', 245905),
(361460, 'PTHR31089:SF62', NULL, NULL, NULL, NULL, 'ZINC FINGER, DOF-TYPE, CUPREDOXIN-RELATED', 245905),
(361461, 'PTHR31089:SF65', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245905),
(361462, 'PTHR31089:SF64', NULL, NULL, NULL, NULL, 'ZINC FINGER, DOF-TYPE-RELATED', 245905),
(361463, 'PTHR31089:SF67', NULL, NULL, NULL, NULL, 'CYCLIC DOF FACTOR 1', 245905),
(361464, 'PTHR31089:SF66', NULL, NULL, NULL, NULL, 'DOF-TYPE ZINC FINGER DNA-BINDING FAMILY PROTEIN', 245905),
(361465, 'PTHR31089:SF22', NULL, NULL, NULL, NULL, 'CYCLIC DOF FACTOR 4', 245905),
(361466, 'PTHR31089:SF47', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245905),
(361467, 'PTHR31089:SF69', NULL, NULL, NULL, NULL, 'DOF-TYPE ZINC FINGER DNA-BINDING FAMILY PROTEIN', 245905),
(361468, 'PTHR31089:SF68', NULL, NULL, NULL, NULL, 'CYCLIC DOF FACTOR 5', 245905),
(361469, 'PTHR31089', NULL, NULL, NULL, NULL, 'CYCLIC DOF FACTOR 2', 245905),
(361470, 'PTHR31089:SF48', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245905),
(361471, 'PTHR31089:SF29', NULL, NULL, NULL, NULL, 'CYCLIC DOF FACTOR 3', 245905),
(361472, 'PTHR31089:SF70', NULL, NULL, NULL, NULL, 'CYCLIC DOF FACTOR 1-LIKE', 245905),
(361473, 'PTHR31089:SF50', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245905),
(361474, 'PTHR31089:SF72', NULL, NULL, NULL, NULL, 'OS01G0673700 PROTEIN', 245905),
(361475, 'PTHR31089:SF71', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF1.3', 245905),
(361476, 'PTHR31089:SF52', NULL, NULL, NULL, NULL, 'CYCLIC DOF FACTOR 1-LIKE', 245905),
(361477, 'PTHR31089:SF30', NULL, NULL, NULL, NULL, 'CYCLIC DOF FACTOR 1-LIKE', 245905),
(361478, 'PTHR31089:SF51', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245905),
(361479, 'PTHR31089:SF54', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245905),
(361480, 'PTHR31089:SF36', NULL, NULL, NULL, NULL, 'CYCLIC DOF FACTOR 3-LIKE', 245905),
(361481, 'PTHR31089:SF58', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245905),
(361482, 'PTHR31089:SF38', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245905),
(361483, 'PTHR31089:SF59', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF1.5', 245905),
(361484, 'PTHR31089:SF37', NULL, NULL, NULL, NULL, 'DOF DOMAIN, ZINC FINGER FAMILY PROTEIN, EXPRESSED', 245905),
(361485, 'PTHR31089:SF39', NULL, NULL, NULL, NULL, 'DOF-TYPE DOMAIN-CONTAINING PROTEIN', 245905),
(361486, 'PTHR38778:SF1', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 245906),
(361487, 'PTHR38778', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 245906),
(361488, 'PTHR47966:SF6', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 245907),
(361489, 'PTHR47966:SF5', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEASE 10', 245907),
(361490, 'PTHR47966:SF8', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEASE 1-RELATED', 245907),
(361491, 'PTHR47966:SF9', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE', 245907),
(361492, 'PTHR47966:SF44', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 245907),
(361493, 'PTHR47966:SF45', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 245907),
(361494, 'PTHR47966:SF40', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEASE 3', 245907),
(361495, 'PTHR47966:SF2', NULL, NULL, NULL, NULL, 'ASPERGILLOPEPSIN-1-RELATED', 245907),
(361496, 'PTHR47966:SF1', NULL, NULL, NULL, NULL, 'ASPARTYL PROTEINASE', 245907),
(361497, 'PTHR47966:SF4', NULL, NULL, NULL, NULL, 'OS01G0663400 PROTEIN', 245907),
(361498, 'PTHR47966:SF42', NULL, NULL, NULL, NULL, 'CATHEPSIN D', 245907),
(361499, 'PTHR47966:SF3', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 245907),
(361500, 'PTHR47966:SF41', NULL, NULL, NULL, NULL, 'BNAC03G29860D PROTEIN', 245907),
(361501, 'PTHR47966:SF48', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 245907);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(361502, 'PTHR47966:SF47', NULL, NULL, NULL, NULL, 'ENDOPEPTIDASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G01220)-RELATED', 245907),
(361503, 'PTHR47966:SF49', NULL, NULL, NULL, NULL, 'PEPSIN A-5', 245907),
(361504, 'PTHR47966:SF60', NULL, NULL, NULL, NULL, 'CYPROSIN-LIKE ISOFORM X1', 245907),
(361505, 'PTHR47966:SF54', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE A1-LIKE', 245907),
(361506, 'PTHR47966:SF57', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 245907),
(361507, 'PTHR47966:SF13', NULL, NULL, NULL, NULL, 'CHYMOSIN', 245907),
(361508, 'PTHR47966:SF56', NULL, NULL, NULL, NULL, 'NAPSIN-A', 245907),
(361509, 'PTHR47966:SF51', NULL, NULL, NULL, NULL, 'NAPSIN-A', 245907),
(361510, 'PTHR47966:SF50', NULL, NULL, NULL, NULL, 'OS01G0631900 PROTEIN', 245907),
(361511, 'PTHR47966:SF15', NULL, NULL, NULL, NULL, 'FUNGAL PROTEINASE A, ASPARTIC PROTEINASE SUPERFAMILY PROTEIN', 245907),
(361512, 'PTHR47966:SF14', NULL, NULL, NULL, NULL, 'BNAC08G15160D PROTEIN', 245907),
(361513, 'PTHR47966:SF58', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE-LIKE', 245907),
(361514, 'PTHR47966:SF16', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEASE 6', 245907),
(361515, 'PTHR47966:SF71', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 245907),
(361516, 'PTHR47966:SF70', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 245907),
(361517, 'PTHR47966:SF22', NULL, NULL, NULL, NULL, 'PEPSIN A-3-RELATED', 245907),
(361518, 'PTHR47966:SF66', NULL, NULL, NULL, NULL, 'PEPSINOGEN C', 245907),
(361519, 'PTHR47966:SF65', NULL, NULL, NULL, NULL, 'ASPARTIC-TYPE ENDOPEPTIDASE', 245907),
(361520, 'PTHR47966:SF68', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 245907),
(361521, 'PTHR47966:SF24', NULL, NULL, NULL, NULL, 'RENIN', 245907),
(361522, 'PTHR47966:SF67', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 245907),
(361523, 'PTHR47966:SF23', NULL, NULL, NULL, NULL, 'ASPARTIC ENDOPEPTIDASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G15950)-RELATED', 245907),
(361524, 'PTHR47966:SF20', NULL, NULL, NULL, NULL, 'FUNGAL PROTEINASE A, ASPARTIC PROTEINASE SUPERFAMILY PROTEIN', 245907),
(361525, 'PTHR47966:SF26', NULL, NULL, NULL, NULL, 'CATHEPSIN E', 245907),
(361526, 'PTHR47966:SF69', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 245907),
(361527, 'PTHR47966:SF25', NULL, NULL, NULL, NULL, 'ASPARTIC PEPTIDASE A1 FAMILY, ASPARTIC PEPTIDASE DOMAIN PROTEIN-RELATED', 245907),
(361528, 'PTHR47966:SF28', NULL, NULL, NULL, NULL, 'OS01G0290000 PROTEIN', 245907),
(361529, 'PTHR47966:SF27', NULL, NULL, NULL, NULL, '', 245907),
(361530, 'PTHR47966', NULL, NULL, NULL, NULL, 'BETA-SITE APP-CLEAVING ENZYME, ISOFORM A-RELATED', 245907),
(361531, 'PTHR47966:SF80', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE-LIKE', 245907),
(361532, 'PTHR47966:SF77', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 245907),
(361533, 'PTHR47966:SF32', NULL, NULL, NULL, NULL, 'FUNGAL PROTEINASE A, ASPARTIC PROTEINASE SUPERFAMILY PROTEIN', 245907),
(361534, 'PTHR47966:SF76', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE A1', 245907),
(361535, 'PTHR47966:SF35', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE A2', 245907),
(361536, 'PTHR47966:SF79', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE SXA1', 245907),
(361537, 'PTHR47966:SF78', NULL, NULL, NULL, NULL, 'FUNGAL PROTEINASE A, ASPARTIC PROTEINASE SUPERFAMILY PROTEIN', 245907),
(361538, 'PTHR47966:SF73', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 245907),
(361539, 'PTHR47966:SF72', NULL, NULL, NULL, NULL, 'GASTRICSIN', 245907),
(361540, 'PTHR47966:SF75', NULL, NULL, NULL, NULL, 'ENDOPEPTIDASE (CTSD), PUTATIVE (AFU_ORTHOLOGUE AFUA_4G07040)-RELATED', 245907),
(361541, 'PTHR47966:SF74', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 245907),
(361542, 'PTHR47966:SF30', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 245907),
(361543, 'PTHR47966:SF37', NULL, NULL, NULL, NULL, 'CATHEPSINE-A-LIKE PROTEIN-RELATED', 245907),
(361544, 'PTHR47966:SF39', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 245907);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(361545, 'PTHR47966:SF38', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE A3', 245907),
(361546, 'PTHR13026:SF4', NULL, NULL, NULL, NULL, '', 245908),
(361547, 'PTHR13026:SF2', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA PROCESSING PROTEIN 1 HOMOLOG B', 245908),
(361548, 'PTHR13026:SF1', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA PROCESSING PROTEIN 1 HOMOLOG A', 245908),
(361549, 'PTHR13026', NULL, NULL, NULL, NULL, 'NNP-1 PROTEIN  NOVEL NUCLEAR PROTEIN 1   NOP52', 245908),
(361550, 'PTHR13026:SF0', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA-PROCESSING 1', 245908),
(361551, 'PTHR30270:SF0', NULL, NULL, NULL, NULL, 'THIAMINE-MONOPHOSPHATE KINASE', 245909),
(361552, 'PTHR30270:SF2', NULL, NULL, NULL, NULL, '', 245909),
(361553, 'PTHR30270:SF3', NULL, NULL, NULL, NULL, 'THIAMINE-MONOPHOSPHATE KINASE', 245909),
(361554, 'PTHR30270', NULL, NULL, NULL, NULL, 'THIAMINE-MONOPHOSPHATE KINASE', 245909),
(361555, 'PTHR35255:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 71', 245910),
(361556, 'PTHR35255', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 71', 245910),
(361557, 'PTHR33834', NULL, NULL, NULL, NULL, 'SIGNALING PEPTIDE TAXIMIN 2', 245911),
(361558, 'PTHR33834:SF9', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 245911),
(361559, 'PTHR33834:SF14', NULL, NULL, NULL, NULL, '', 245911),
(361560, 'PTHR33834:SF15', NULL, NULL, NULL, NULL, 'BNAA09G43700D PROTEIN', 245911),
(361561, 'PTHR33834:SF16', NULL, NULL, NULL, NULL, 'OS05G0209500 PROTEIN', 245911),
(361562, 'PTHR33834:SF4', NULL, NULL, NULL, NULL, 'SIGNALING PEPTIDE TAXIMIN 2', 245911),
(361563, 'PTHR33834:SF10', NULL, NULL, NULL, NULL, 'SIGNALING PEPTIDE TAXIMIN 2-LIKE', 245911),
(361564, 'PTHR33834:SF12', NULL, NULL, NULL, NULL, '', 245911),
(361565, 'PTHR33834:SF2', NULL, NULL, NULL, NULL, 'SIGNALING PEPTIDE TAXIMIN 1', 245911),
(361566, 'PTHR28106:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ATPASE COMPLEX SUBUNIT ATP10', 245912),
(361567, 'PTHR28106:SF3', NULL, NULL, NULL, NULL, 'BNAC08G02480D PROTEIN', 245912),
(361568, 'PTHR28106', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ATPASE COMPLEX SUBUNIT ATP10', 245912),
(361569, 'PTHR10632', NULL, NULL, NULL, NULL, 'SULFIDE:QUINONE OXIDOREDUCTASE', 245913),
(361570, 'PTHR10632:SF2', NULL, NULL, NULL, NULL, 'SULFIDE:QUINONE OXIDOREDUCTASE, MITOCHONDRIAL', 245913),
(361571, 'PTHR30605', NULL, NULL, NULL, NULL, 'ANHYDRO-N-ACETYLMURAMIC ACID KINASE', 245914),
(361572, 'PTHR30605:SF2', NULL, NULL, NULL, NULL, 'UPF0075 DOMAIN-CONTAINING PROTEIN', 245914),
(361573, 'PTHR30605:SF0', NULL, NULL, NULL, NULL, 'ANHYDRO-N-ACETYLMURAMIC ACID KINASE', 245914),
(361574, 'PTHR46356:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 2-OXODICARBOXYLATE CARRIER', 245915),
(361575, 'PTHR46356', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 2-OXODICARBOXYLATE CARRIER', 245915),
(361576, 'PTHR32502:SF3', NULL, NULL, NULL, NULL, 'D-GALACTOSAMINE-6-PHOSPHATE DEAMINASE AGAS-RELATED', 245916),
(361577, 'PTHR32502:SF26', NULL, NULL, NULL, NULL, 'PHOSPHOTRANSFERASE SYSTEM SUGAR-SPECIFIC EIID COMPONENT', 245916),
(361578, 'PTHR32502:SF25', NULL, NULL, NULL, NULL, 'PHOSPHOTRANSFERASE SYSTEM, MANNOSE-SPECIFIC EIIC', 245916),
(361579, 'PTHR32502:SF4', NULL, NULL, NULL, NULL, 'PTS SYSTEM MANNOSE-SPECIFIC EIIC COMPONENT', 245916),
(361580, 'PTHR32502:SF5', NULL, NULL, NULL, NULL, 'PTS SYSTEM MANNOSE-SPECIFIC EIID COMPONENT', 245916),
(361581, 'PTHR32502:SF23', NULL, NULL, NULL, NULL, 'N-ACETYLGALACTOSAMINE PERMEASE IID COMPONENT', 245916),
(361582, 'PTHR32502', NULL, NULL, NULL, NULL, 'N-ACETYLGALACTOSAMINE PERMEASE II COMPONENT-RELATED', 245916),
(361583, 'PTHR32502:SF12', NULL, NULL, NULL, NULL, 'D-TAGATOSE-1,6-BISPHOSPHATE ALDOLASE SUBUNIT GATZ', 245916),
(361584, 'PTHR32502:SF8', NULL, NULL, NULL, NULL, 'N-ACETYLGALACTOSAMINE PERMEASE IIC COMPONENT 1', 245916),
(361585, 'PTHR32502:SF28', NULL, NULL, NULL, NULL, 'PHOSPHOTRANSFERASE SYSTEM SUGAR-SPECIFIC EIIC COMPONENT', 245916),
(361586, 'PTHR32502:SF2', NULL, NULL, NULL, NULL, 'D-TAGATOSE-1,6-BISPHOSPHATE ALDOLASE SUBUNIT KBAZ', 245916),
(361587, 'PTHR32502:SF27', NULL, NULL, NULL, NULL, 'PTS SYSTEM, MANNOSE-SPECIFIC IID COMPONENT', 245916);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(361588, 'PTHR35700:SF3', NULL, NULL, NULL, NULL, 'PEPTIDASE S59 DOMAIN-CONTAINING PROTEIN', 245917),
(361589, 'PTHR35700', NULL, NULL, NULL, NULL, 'OS07G0181800 PROTEIN', 245917),
(361590, 'PTHR35700:SF1', NULL, NULL, NULL, NULL, 'OS07G0181800 PROTEIN', 245917),
(361591, 'PTHR33070', NULL, NULL, NULL, NULL, 'OS06G0725500 PROTEIN', 245918),
(361592, 'PTHR33070:SF75', NULL, NULL, NULL, NULL, 'SELECTION/UPKEEP OF INTRAEPITHELIAL T-CELLS PROTEIN', 245918),
(361593, 'PTHR33070:SF76', NULL, NULL, NULL, NULL, '', 245918),
(361594, 'PTHR33070:SF70', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (DUF241)-RELATED', 245918),
(361595, 'PTHR33070:SF72', NULL, NULL, NULL, NULL, 'OS08G0551300 PROTEIN', 245918),
(361596, 'PTHR33070:SF74', NULL, NULL, NULL, NULL, 'BNAC01G23450D PROTEIN', 245918),
(361597, 'PTHR33070:SF64', NULL, NULL, NULL, NULL, 'DUF241 DOMAIN PROTEIN', 245918),
(361598, 'PTHR33070:SF111', NULL, NULL, NULL, NULL, '', 245918),
(361599, 'PTHR33070:SF68', NULL, NULL, NULL, NULL, '', 245918),
(361600, 'PTHR33070:SF106', NULL, NULL, NULL, NULL, 'OS08G0551366 PROTEIN', 245918),
(361601, 'PTHR33070:SF105', NULL, NULL, NULL, NULL, '', 245918),
(361602, 'PTHR33070:SF108', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (DUF241)-RELATED', 245918),
(361603, 'PTHR33070:SF107', NULL, NULL, NULL, NULL, '', 245918),
(361604, 'PTHR33070:SF60', NULL, NULL, NULL, NULL, 'OS06G0725700 PROTEIN', 245918),
(361605, 'PTHR33070:SF101', NULL, NULL, NULL, NULL, 'BNAANNG08220D PROTEIN', 245918),
(361606, 'PTHR33070:SF62', NULL, NULL, NULL, NULL, 'BNAA09G54690D PROTEIN', 245918),
(361607, 'PTHR33070:SF104', NULL, NULL, NULL, NULL, 'BNAC07G32230D PROTEIN', 245918),
(361608, 'PTHR33070:SF109', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (DUF241)-RELATED', 245918),
(361609, 'PTHR33070:SF53', NULL, NULL, NULL, NULL, '', 245918),
(361610, 'PTHR33070:SF54', NULL, NULL, NULL, NULL, '', 245918),
(361611, 'PTHR33070:SF98', NULL, NULL, NULL, NULL, '', 245918),
(361612, 'PTHR33070:SF55', NULL, NULL, NULL, NULL, 'OS06G0725800 PROTEIN', 245918),
(361613, 'PTHR33070:SF57', NULL, NULL, NULL, NULL, '', 245918),
(361614, 'PTHR33070:SF58', NULL, NULL, NULL, NULL, '', 245918),
(361615, 'PTHR33070:SF59', NULL, NULL, NULL, NULL, 'DUF241 DOMAIN PROTEIN', 245918),
(361616, 'PTHR33070:SF15', NULL, NULL, NULL, NULL, 'OS08G0552400 PROTEIN', 245918),
(361617, 'PTHR33070:SF117', NULL, NULL, NULL, NULL, 'OS08G0553750 PROTEIN', 245918),
(361618, 'PTHR33070:SF116', NULL, NULL, NULL, NULL, '', 245918),
(361619, 'PTHR33070:SF119', NULL, NULL, NULL, NULL, '', 245918),
(361620, 'PTHR33070:SF91', NULL, NULL, NULL, NULL, 'OS08G0551500 PROTEIN', 245918),
(361621, 'PTHR33070:SF92', NULL, NULL, NULL, NULL, '', 245918),
(361622, 'PTHR33070:SF118', NULL, NULL, NULL, NULL, '', 245918),
(361623, 'PTHR33070:SF113', NULL, NULL, NULL, NULL, '', 245918),
(361624, 'PTHR33070:SF50', NULL, NULL, NULL, NULL, 'OS08G0553500 PROTEIN', 245918),
(361625, 'PTHR33070:SF94', NULL, NULL, NULL, NULL, '', 245918),
(361626, 'PTHR33070:SF51', NULL, NULL, NULL, NULL, '', 245918),
(361627, 'PTHR33070:SF115', NULL, NULL, NULL, NULL, 'T23E18.15', 245918),
(361628, 'PTHR33070:SF95', NULL, NULL, NULL, NULL, '', 245918),
(361629, 'PTHR33070:SF114', NULL, NULL, NULL, NULL, '', 245918),
(361630, 'PTHR33070:SF96', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245918),
(361631, 'PTHR33070:SF86', NULL, NULL, NULL, NULL, '', 245918),
(361632, 'PTHR33070:SF42', NULL, NULL, NULL, NULL, 'OS08G0551250 PROTEIN', 245918),
(361633, 'PTHR33070:SF87', NULL, NULL, NULL, NULL, 'BNAA09G54670D PROTEIN', 245918),
(361634, 'PTHR33070:SF89', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245918),
(361635, 'PTHR33070:SF46', NULL, NULL, NULL, NULL, 'DUF241 DOMAIN PROTEIN', 245918),
(361636, 'PTHR33070:SF49', NULL, NULL, NULL, NULL, 'OS06G0725500 PROTEIN', 245918),
(361637, 'PTHR33070:SF80', NULL, NULL, NULL, NULL, '', 245918),
(361638, 'PTHR33070:SF83', NULL, NULL, NULL, NULL, '', 245918),
(361639, 'PTHR33070:SF84', NULL, NULL, NULL, NULL, '', 245918),
(361640, 'PTHR33070:SF85', NULL, NULL, NULL, NULL, 'BNAC07G32250D PROTEIN', 245918);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(361641, 'PTHR33070:SF5', NULL, NULL, NULL, NULL, 'OS10G0510100 PROTEIN', 245918),
(361642, 'PTHR33070:SF7', NULL, NULL, NULL, NULL, '', 245918),
(361643, 'PTHR33070:SF8', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245918),
(361644, 'PTHR34058:SF9', NULL, NULL, NULL, NULL, 'OXYGEN-EVOLVING ENHANCER PROTEIN 1, CHLOROPLASTIC', 245919),
(361645, 'PTHR34058:SF2', NULL, NULL, NULL, NULL, 'OXYGEN-EVOLVING ENHANCER PROTEIN 1-1, CHLOROPLASTIC', 245919),
(361646, 'PTHR34058:SF14', NULL, NULL, NULL, NULL, 'OXYGEN-EVOLVING ENHANCER PROTEIN 1-2, CHLOROPLASTIC', 245919),
(361647, 'PTHR34058:SF13', NULL, NULL, NULL, NULL, 'BNAA03G53620D PROTEIN', 245919),
(361648, 'PTHR34058:SF11', NULL, NULL, NULL, NULL, 'OXYGEN-EVOLVING ENHANCER PROTEIN 1, CHLOROPLASTIC', 245919),
(361649, 'PTHR34058', NULL, NULL, NULL, NULL, 'OXYGEN-EVOLVING ENHANCER PROTEIN 1-2, CHLOROPLASTIC', 245919),
(361650, 'PTHR34058:SF8', NULL, NULL, NULL, NULL, 'BNAA02G34760D PROTEIN', 245919),
(361651, 'PTHR34058:SF10', NULL, NULL, NULL, NULL, 'BNAC02G48890D PROTEIN', 245919),
(361652, 'PTHR31140:SF131', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 245920),
(361653, 'PTHR31140:SF130', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 245920),
(361654, 'PTHR31140:SF135', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 245920),
(361655, 'PTHR31140:SF134', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING TRANSCRIPTION FACTOR NGA3', 245920),
(361656, 'PTHR31140:SF133', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 245920),
(361657, 'PTHR31140:SF139', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS03G0120900', 245920),
(361658, 'PTHR31140:SF138', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING TRANSCRIPTION FACTOR NGA1-LIKE ISOFORM X1', 245920),
(361659, 'PTHR31140:SF137', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 245920),
(361660, 'PTHR31140:SF136', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN', 245920),
(361661, 'PTHR31140:SF8', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS10G0537100-RELATED', 245920),
(361662, 'PTHR31140:SF78', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS06G0107800', 245920),
(361663, 'PTHR31140:SF76', NULL, NULL, NULL, NULL, 'AP2/ERF AND B3 DOMAIN-CONTAINING TRANSCRIPTION FACTOR RAV1', 245920),
(361664, 'PTHR31140:SF73', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING TRANSCRIPTION FACTOR FUS3', 245920),
(361665, 'PTHR31140:SF74', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING TRANSCRIPTION FACTOR LEC2', 245920),
(361666, 'PTHR31140:SF1', NULL, NULL, NULL, NULL, 'AP2/ERF AND B3 DOMAIN-CONTAINING TRANSCRIPTION REPRESSOR RAV2', 245920),
(361667, 'PTHR31140:SF72', NULL, NULL, NULL, NULL, 'AP2/ERF AND B3 DOMAIN-CONTAINING TRANSCRIPTION FACTOR ARF14', 245920),
(361668, 'PTHR31140:SF70', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS02G0455900-RELATED', 245920),
(361669, 'PTHR31140:SF2', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS04G0581400', 245920),
(361670, 'PTHR31140:SF120', NULL, NULL, NULL, NULL, 'BNAA09G28670D PROTEIN', 245920),
(361671, 'PTHR31140:SF124', NULL, NULL, NULL, NULL, 'AP2/ERF AND B3 DOMAIN-CONTAINING TRANSCRIPTION FACTOR RAV1-LIKE', 245920),
(361672, 'PTHR31140:SF123', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING TRANSCRIPTION FACTOR NGA1', 245920),
(361673, 'PTHR31140:SF128', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING TRANSCRIPTION FACTOR NGA2', 245920),
(361674, 'PTHR31140:SF126', NULL, NULL, NULL, NULL, 'AP2/ERF AND B3 DOMAIN-CONTAINING PROTEIN OS05G0549800', 245920),
(361675, 'PTHR31140:SF129', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS02G0683500', 245920),
(361676, 'PTHR31140:SF46', NULL, NULL, NULL, NULL, 'AP2/ERF AND B3 DOMAIN-CONTAINING TRANSCRIPTION FACTOR', 245920),
(361677, 'PTHR31140:SF45', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 245920),
(361678, 'PTHR31140:SF89', NULL, NULL, NULL, NULL, 'BNAA05G15710D PROTEIN', 245920),
(361679, 'PTHR31140:SF87', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 245920),
(361680, 'PTHR31140:SF80', NULL, NULL, NULL, NULL, 'AP2/ERF AND B3 DOMAIN TRANSCRIPTION FACTOR', 245920);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(361681, 'PTHR31140:SF81', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING TRANSCRIPTION FACTOR ABI3', 245920),
(361682, 'PTHR31140:SF150', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 245920),
(361683, 'PTHR31140:SF113', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 245920),
(361684, 'PTHR31140:SF112', NULL, NULL, NULL, NULL, 'ETHYLENE RESPONSE DNA BINDING FACTOR 3-RELATED', 245920),
(361685, 'PTHR31140:SF110', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 245920),
(361686, 'PTHR31140:SF117', NULL, NULL, NULL, NULL, 'BNAC06G03910D PROTEIN', 245920),
(361687, 'PTHR31140:SF116', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 245920),
(361688, 'PTHR31140:SF114', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 245920),
(361689, 'PTHR31140:SF119', NULL, NULL, NULL, NULL, 'BNAA06G02760D PROTEIN', 245920),
(361690, 'PTHR31140:SF118', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 245920),
(361691, 'PTHR31140:SF14', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS08G0157700-RELATED', 245920),
(361692, 'PTHR31140:SF58', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN RAV1', 245920),
(361693, 'PTHR31140:SF99', NULL, NULL, NULL, NULL, 'BNAC06G03900D PROTEIN', 245920),
(361694, 'PTHR31140:SF56', NULL, NULL, NULL, NULL, 'AP2/ERF AND B3 DOMAIN-CONTAINING PROTEIN OS01G0141000', 245920),
(361695, 'PTHR31140:SF12', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS04G0676650-RELATED', 245920),
(361696, 'PTHR31140:SF97', NULL, NULL, NULL, NULL, 'BNAA06G02510D PROTEIN', 245920),
(361697, 'PTHR31140', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING TRANSCRIPTION FACTOR ABI3', 245920),
(361698, 'PTHR31140:SF93', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 245920),
(361699, 'PTHR31140:SF94', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 245920),
(361700, 'PTHR31140:SF90', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING TRANSCRIPTION FACTOR LEC2', 245920),
(361701, 'PTHR31140:SF142', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 245920),
(361702, 'PTHR31140:SF141', NULL, NULL, NULL, NULL, '', 245920),
(361703, 'PTHR31140:SF140', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 245920),
(361704, 'PTHR31140:SF146', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 245920),
(361705, 'PTHR31140:SF102', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 245920),
(361706, 'PTHR31140:SF145', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 245920),
(361707, 'PTHR31140:SF101', NULL, NULL, NULL, NULL, '', 245920),
(361708, 'PTHR31140:SF144', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 245920),
(361709, 'PTHR31140:SF143', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 245920),
(361710, 'PTHR31140:SF149', NULL, NULL, NULL, NULL, 'BNAA05G15500D PROTEIN', 245920),
(361711, 'PTHR31140:SF148', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR', 245920),
(361712, 'PTHR31140:SF103', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 245920),
(361713, 'PTHR31140:SF147', NULL, NULL, NULL, NULL, 'BNAANNG40580D PROTEIN', 245920),
(361714, 'PTHR31140:SF109', NULL, NULL, NULL, NULL, 'AP2/ERF AND B3 DOMAIN-CONTAINING TRANSCRIPTION REPRESSOR TEM1', 245920),
(361715, 'PTHR31140:SF67', NULL, NULL, NULL, NULL, 'AP2/ERF AND B3 DOMAIN TRANSCRIPTION FACTOR', 245920),
(361716, 'PTHR31140:SF64', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING TRANSCRIPTION FACTOR NGA4', 245920),
(361717, 'PTHR31140:SF65', NULL, NULL, NULL, NULL, 'AP2/ERF AND B3 DOMAIN-CONTAINING TRANSCRIPTION REPRESSOR RAV2-LIKE', 245920),
(361718, 'PTHR31140:SF60', NULL, NULL, NULL, NULL, 'PROTEIN RAV1, PUTATIVE-RELATED', 245920),
(361719, 'PTHR39219:SF1', NULL, NULL, NULL, NULL, '', 245921),
(361720, 'PTHR39219', NULL, NULL, NULL, NULL, '', 245921),
(361721, 'PTHR11385:SF14', NULL, NULL, NULL, NULL, 'AFAMIN', 245922),
(361722, 'PTHR11385:SF15', NULL, NULL, NULL, NULL, 'ALBUMIN', 245922),
(361723, 'PTHR11385:SF12', NULL, NULL, NULL, NULL, 'ALBUMIN SUPERFAMILY MEMBER 1', 245922),
(361724, 'PTHR11385:SF11', NULL, NULL, NULL, NULL, 'VITAMIN D-BINDING PROTEIN', 245922);
INSERT INTO "PUBLIC"."MODEL" VALUES
(361725, 'PTHR11385:SF7', NULL, NULL, NULL, NULL, 'ALPHA-FETOPROTEIN', 245922),
(361726, 'PTHR11385', NULL, NULL, NULL, NULL, 'SERUM ALBUMIN-RELATED', 245922),
(361727, 'PTHR46972:SF1', NULL, NULL, NULL, NULL, 'FAD_BINDING_3 DOMAIN-CONTAINING PROTEIN', 245923),
(361728, 'PTHR46972:SF2', NULL, NULL, NULL, NULL, 'FAD_BINDING_3 DOMAIN-CONTAINING PROTEIN', 245923),
(361729, 'PTHR46972', NULL, NULL, NULL, NULL, 'MONOOXYGENASE ASQM-RELATED', 245923),
(361730, 'PTHR33647', NULL, NULL, NULL, NULL, 'OS01G0793900 PROTEIN', 245924),
(361731, 'PTHR33647:SF5', NULL, NULL, NULL, NULL, 'OS07G0516400 PROTEIN', 245924),
(361732, 'PTHR33647:SF17', NULL, NULL, NULL, NULL, 'BNAC03G41560D PROTEIN', 245924),
(361733, 'PTHR33647:SF16', NULL, NULL, NULL, NULL, '', 245924),
(361734, 'PTHR33647:SF13', NULL, NULL, NULL, NULL, '', 245924),
(361735, 'PTHR33647:SF22', NULL, NULL, NULL, NULL, '', 245924),
(361736, 'PTHR33647:SF1', NULL, NULL, NULL, NULL, 'OS01G0793800 PROTEIN', 245924),
(361737, 'PTHR33647:SF23', NULL, NULL, NULL, NULL, '', 245924),
(361738, 'PTHR33647:SF12', NULL, NULL, NULL, NULL, 'OS05G0498666 PROTEIN', 245924),
(361739, 'PTHR33647:SF20', NULL, NULL, NULL, NULL, 'OS01G0793900 PROTEIN', 245924),
(361740, 'PTHR33647:SF21', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE-RELATED', 245924),
(361741, 'PTHR33647:SF10', NULL, NULL, NULL, NULL, '', 245924),
(361742, 'PTHR36738', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245925),
(361743, 'PTHR36738:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245925),
(361744, 'PTHR31560:SF0', NULL, NULL, NULL, NULL, 'UPF0652 PROTEIN C22H10.08', 245926),
(361745, 'PTHR31560:SF1', NULL, NULL, NULL, NULL, '', 245926),
(361746, 'PTHR31560:SF2', NULL, NULL, NULL, NULL, '', 245926),
(361747, 'PTHR31560:SF3', NULL, NULL, NULL, NULL, 'UPF0652 PROTEIN C16A11.03C', 245926),
(361748, 'PTHR31560', NULL, NULL, NULL, NULL, 'UPF0652 PROTEIN C16A11.03C-RELATED', 245926),
(361749, 'PTHR12680:SF6', NULL, NULL, NULL, NULL, 'PROTEIN PHTF', 245927),
(361750, 'PTHR12680', NULL, NULL, NULL, NULL, 'PUTATIVE HOMEODOMAIN TRANSCRIPTION FACTOR  PHTF', 245927),
(361751, 'PTHR12680:SF8', NULL, NULL, NULL, NULL, 'PROTEIN PHTF1', 245927),
(361752, 'PTHR12680:SF2', NULL, NULL, NULL, NULL, 'PROTEIN PHTF2', 245927),
(361753, 'PTHR24304:SF4', NULL, NULL, NULL, NULL, '', 245928),
(361754, 'PTHR24304:SF2', NULL, NULL, NULL, NULL, '24-HYDROXYCHOLESTEROL 7-ALPHA-HYDROXYLASE', 245928),
(361755, 'PTHR24304:SF3', NULL, NULL, NULL, NULL, 'CHOLESTEROL 7-ALPHA-MONOOXYGENASE-LIKE', 245928),
(361756, 'PTHR24304:SF0', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 7B1', 245928),
(361757, 'PTHR24304:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 7A1', 245928),
(361758, 'PTHR24304', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 7', 245928),
(361759, 'PTHR37316:SF3', NULL, NULL, NULL, NULL, 'TEICHOIC ACID GLYCEROL-PHOSPHATE TRANSFERASE', 245929),
(361760, 'PTHR37316:SF2', NULL, NULL, NULL, NULL, 'TEICHOIC ACID RIBITOL-PHOSPHATE POLYMERASE TARK', 245929),
(361761, 'PTHR37316', NULL, NULL, NULL, NULL, 'TEICHOIC ACID GLYCEROL-PHOSPHATE PRIMASE', 245929),
(361762, 'PTHR37316:SF1', NULL, NULL, NULL, NULL, 'TEICHOIC ACID GLYCEROL-PHOSPHATE PRIMASE', 245929),
(361763, 'PTHR34815:SF2', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 245930),
(361764, 'PTHR34815', NULL, NULL, NULL, NULL, 'LYSINE ACETYLTRANSFERASE', 245930),
(361765, 'PTHR34815:SF3', NULL, NULL, NULL, NULL, '', 245930),
(361766, 'PTHR30427', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR PROTEIN LYSR', 245931),
(361767, 'PTHR30427:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR PROTEIN LYSR', 245931),
(361768, 'PTHR38630:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG12780', 245932),
(361769, 'PTHR38630', NULL, NULL, NULL, NULL, 'PROTEIN CBG12780', 245932),
(361770, 'PTHR30627:SF1', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN D,D-TRANSPEPTIDASE FTSI', 245933),
(361771, 'PTHR30627:SF19', NULL, NULL, NULL, NULL, 'STAGE V SPORULATION PROTEIN D', 245933),
(361772, 'PTHR30627:SF2', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN D,D-TRANSPEPTIDASE MRDA', 245933);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(361773, 'PTHR30627:SF25', NULL, NULL, NULL, NULL, 'PENICILLIN-BINDING PROTEIN 3', 245933),
(361774, 'PTHR30627', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN D,D-TRANSPEPTIDASE', 245933),
(361775, 'PTHR30627:SF24', NULL, NULL, NULL, NULL, 'PENICILLIN-BINDING PROTEIN 4B', 245933),
(361776, 'PTHR30627:SF6', NULL, NULL, NULL, NULL, 'BETA-LACTAMASE YBXI-RELATED', 245933),
(361777, 'PTHR36819', NULL, NULL, NULL, NULL, 'REGULATOR OF PHOSPHOLIPASE D SRF1', 245934),
(361778, 'PTHR36819:SF1', NULL, NULL, NULL, NULL, 'REGULATOR OF PHOSPHOLIPASE D SRF1', 245934),
(361779, 'PTHR47687:SF5', NULL, NULL, NULL, NULL, 'G8 DOMAIN-CONTAINING PROTEIN DDB_G0288475-RELATED', 245935),
(361780, 'PTHR47687:SF4', NULL, NULL, NULL, NULL, 'COMMUNICATION MUTANT PROTEIN F-RELATED', 245935),
(361781, 'PTHR47687:SF2', NULL, NULL, NULL, NULL, 'G8 DOMAIN-CONTAINING PROTEIN DDB_G0278975', 245935),
(361782, 'PTHR47687', NULL, NULL, NULL, NULL, 'G8 DOMAIN-CONTAINING PROTEIN DDB_G0288475-RELATED', 245935),
(361783, 'PTHR42981', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE [UBIQUINONE]', 245936),
(361784, 'PTHR42981:SF2', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE [UBIQUINONE]', 245936),
(361785, 'PTHR40710:SF1', NULL, NULL, NULL, NULL, 'RIKEN CDNA E230025N22 GENE', 245937),
(361786, 'PTHR40710', NULL, NULL, NULL, NULL, 'RIKEN CDNA E230025N22 GENE', 245937),
(361787, 'PTHR12743:SF8', NULL, NULL, NULL, NULL, 'HOLOCYTOCHROME C-TYPE SYNTHASE', 245938),
(361788, 'PTHR12743:SF3', NULL, NULL, NULL, NULL, 'HOLOCYTOCHROME-C SYNTHASE', 245938),
(361789, 'PTHR12743', NULL, NULL, NULL, NULL, 'CYTOCHROME C1 HEME LYASE', 245938),
(361790, 'PTHR12743:SF0', NULL, NULL, NULL, NULL, 'HOLOCYTOCHROME C-TYPE SYNTHASE', 245938),
(361791, 'PTHR24273', NULL, NULL, NULL, NULL, 'FI04643P-RELATED', 245939),
(361792, 'PTHR24273:SF32', NULL, NULL, NULL, NULL, 'HYALIN', 245939),
(361793, 'PTHR47674:SF3', NULL, NULL, NULL, NULL, 'SAGA-ASSOCIATED FACTOR 11', 245940),
(361794, 'PTHR47674', NULL, NULL, NULL, NULL, 'SAGA-ASSOCIATED FACTOR 11', 245940),
(361795, 'PTHR11353:SF208', NULL, NULL, NULL, NULL, 'CCT-ALPHA', 245941),
(361796, 'PTHR11353:SF191', NULL, NULL, NULL, NULL, '', 245941),
(361797, 'PTHR11353:SF220', NULL, NULL, NULL, NULL, 'BNAANNG09450D PROTEIN', 245941),
(361798, 'PTHR11353:SF187', NULL, NULL, NULL, NULL, 'CCT-EPSILON', 245941),
(361799, 'PTHR11353:SF100', NULL, NULL, NULL, NULL, 'T-COMPLEX PROTEIN 1 SUBUNIT THETA-LIKE 1-RELATED', 245941),
(361800, 'PTHR11353:SF188', NULL, NULL, NULL, NULL, '', 245941),
(361801, 'PTHR11353:SF221', NULL, NULL, NULL, NULL, 'CCT-BETA', 245941),
(361802, 'PTHR11353:SF185', NULL, NULL, NULL, NULL, 'CCT-EPSILON', 245941),
(361803, 'PTHR11353:SF186', NULL, NULL, NULL, NULL, 'T-COMPLEX PROTEIN 1 SUBUNIT EPSILON', 245941),
(361804, 'PTHR11353:SF120', NULL, NULL, NULL, NULL, '', 245941),
(361805, 'PTHR11353:SF84', NULL, NULL, NULL, NULL, 'T-COMPLEX PROTEIN 1 SUBUNIT ALPHA', 245941),
(361806, 'PTHR11353:SF61', NULL, NULL, NULL, NULL, '', 245941),
(361807, 'PTHR11353:SF22', NULL, NULL, NULL, NULL, 'T-COMPLEX PROTEIN 1 SUBUNIT ETA', 245941),
(361808, 'PTHR11353:SF206', NULL, NULL, NULL, NULL, 'CCT-BETA', 245941),
(361809, 'PTHR11353:SF66', NULL, NULL, NULL, NULL, '', 245941),
(361810, 'PTHR11353:SF23', NULL, NULL, NULL, NULL, 'T-COMPLEX PROTEIN 1 SUBUNIT BETA', 245941),
(361811, 'PTHR11353:SF65', NULL, NULL, NULL, NULL, '', 245941),
(361812, 'PTHR11353:SF21', NULL, NULL, NULL, NULL, 'T-COMPLEX PROTEIN 1 SUBUNIT ZETA', 245941),
(361813, 'PTHR11353:SF202', NULL, NULL, NULL, NULL, 'CCT-THETA', 245941),
(361814, 'PTHR11353:SF26', NULL, NULL, NULL, NULL, 'T-COMPLEX PROTEIN 1 SUBUNIT DELTA', 245941),
(361815, 'PTHR11353:SF203', NULL, NULL, NULL, NULL, 'CCT-ALPHA', 245941),
(361816, 'PTHR11353:SF24', NULL, NULL, NULL, NULL, 'T-COMPLEX PROTEIN 1 SUBUNIT GAMMA', 245941),
(361817, 'PTHR11353:SF222', NULL, NULL, NULL, NULL, 'T-COMPLEX PROTEIN 1 SUBUNIT ZETA-RELATED', 245941),
(361818, 'PTHR11353', NULL, NULL, NULL, NULL, 'CHAPERONIN', 245941),
(361819, 'PTHR11353:SF189', NULL, NULL, NULL, NULL, '', 245941),
(361820, 'PTHR11353:SF201', NULL, NULL, NULL, NULL, 'TCP DOMAIN CLASS TRANSCRIPTION FACTOR', 245941);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(361821, 'PTHR11353:SF69', NULL, NULL, NULL, NULL, '', 245941),
(361822, 'PTHR11353:SF223', NULL, NULL, NULL, NULL, 'CCT-BETA', 245941),
(361823, 'PTHR11353:SF19', NULL, NULL, NULL, NULL, 'CCT-THETA', 245941),
(361824, 'PTHR11353:SF219', NULL, NULL, NULL, NULL, 'THERMOSOME SUBUNIT ALPHA', 245941),
(361825, 'PTHR11353:SF198', NULL, NULL, NULL, NULL, 'CCT-EPSILON', 245941),
(361826, 'PTHR11353:SF199', NULL, NULL, NULL, NULL, 'T-COMPLEX PROTEIN 1 SUBUNIT GAMMA', 245941),
(361827, 'PTHR11353:SF196', NULL, NULL, NULL, NULL, 'T-COMPLEX PROTEIN 1 SUBUNIT ZETA 2', 245941),
(361828, 'PTHR11353:SF194', NULL, NULL, NULL, NULL, '', 245941),
(361829, 'PTHR11353:SF195', NULL, NULL, NULL, NULL, '', 245941),
(361830, 'PTHR11353:SF192', NULL, NULL, NULL, NULL, 'T-COMPLEX PROTEIN 1 SUBUNIT ALPHA', 245941),
(361831, 'PTHR11353:SF94', NULL, NULL, NULL, NULL, 'T-COMPLEX PROTEIN 1 SUBUNIT EPSILON', 245941),
(361832, 'PTHR11353:SF78', NULL, NULL, NULL, NULL, 'T-COMPLEX PROTEIN 1 SUBUNIT THETA', 245941),
(361833, 'PTHR11353:SF56', NULL, NULL, NULL, NULL, '', 245941),
(361834, 'PTHR11353:SF54', NULL, NULL, NULL, NULL, 'T-COMPLEX PROTEIN 1 SUBUNIT ZETA', 245941),
(361835, 'PTHR11353:SF213', NULL, NULL, NULL, NULL, 'CCT-ALPHA', 245941),
(361836, 'PTHR11353:SF214', NULL, NULL, NULL, NULL, 'T-COMPLEX PROTEIN 1 SUBUNIT DELTA', 245941),
(361837, 'PTHR11353:SF58', NULL, NULL, NULL, NULL, 'T-COMPLEX PROTEIN 1 SUBUNIT ZETA-2', 245941),
(361838, 'PTHR47988:SF47', NULL, NULL, NULL, NULL, 'LRR RECEPTOR KINASE SERK2', 245942),
(361839, 'PTHR47988:SF42', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 245942),
(361840, 'PTHR47988:SF40', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245942),
(361841, 'PTHR47988:SF83', NULL, NULL, NULL, NULL, 'OS02G0236100 PROTEIN', 245942),
(361842, 'PTHR47988:SF43', NULL, NULL, NULL, NULL, 'OS11G0514700 PROTEIN', 245942),
(361843, 'PTHR47988:SF17', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245942),
(361844, 'PTHR47988', NULL, NULL, NULL, NULL, 'SOMATIC EMBRYOGENESIS RECEPTOR KINASE 1', 245942),
(361845, 'PTHR47988:SF59', NULL, NULL, NULL, NULL, 'PROTEIN NSP-INTERACTING KINASE 2', 245942),
(361846, 'PTHR47988:SF58', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 245942),
(361847, 'PTHR47988:SF18', NULL, NULL, NULL, NULL, 'PROTEIN NSP-INTERACTING KINASE 3-LIKE', 245942),
(361848, 'PTHR47988:SF13', NULL, NULL, NULL, NULL, 'SOMATIC EMBRYOGENESIS RECEPTOR KINASE 1-LIKE', 245942),
(361849, 'PTHR47988:SF11', NULL, NULL, NULL, NULL, 'BRASSINOSTEROID INSENSITIVE 1-ASSOCIATED RECEPTOR KINASE 1-RELATED', 245942),
(361850, 'PTHR47988:SF10', NULL, NULL, NULL, NULL, 'OS05G0170700 PROTEIN', 245942),
(361851, 'PTHR47988:SF54', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245942),
(361852, 'PTHR47988:SF60', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245942),
(361853, 'PTHR47988:SF26', NULL, NULL, NULL, NULL, 'SOMATIC EMBRYOGENESIS RECEPTOR-LIKE KINASE3', 245942),
(361854, 'PTHR47988:SF69', NULL, NULL, NULL, NULL, 'PROTEIN NSP-INTERACTING KINASE 1', 245942),
(361855, 'PTHR47988:SF29', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE', 245942),
(361856, 'PTHR47988:SF64', NULL, NULL, NULL, NULL, 'PROTEIN NSP-INTERACTING KINASE 1', 245942),
(361857, 'PTHR47988:SF63', NULL, NULL, NULL, NULL, 'BRASSINOSTEROID INSENSITIVE 1-ASSOCIATED RECEPTOR KINASE 1-LIKE', 245942),
(361858, 'PTHR47988:SF62', NULL, NULL, NULL, NULL, 'BRASSINOSTEROID INSENSITIVE 1-ASSOCIATED RECEPTOR KINASE 1', 245942),
(361859, 'PTHR47988:SF61', NULL, NULL, NULL, NULL, 'PROTEIN KINASE, PLANT-TYPE, PUTATIVE-RELATED', 245942),
(361860, 'PTHR47988:SF68', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245942),
(361861, 'PTHR47988:SF8', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245942),
(361862, 'PTHR47988:SF67', NULL, NULL, NULL, NULL, 'NSP-INTERACTING KINASE-LIKE PROTEIN', 245942),
(361863, 'PTHR47988:SF66', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 245942),
(361864, 'PTHR47988:SF5', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245942);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(361865, 'PTHR47988:SF65', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245942),
(361866, 'PTHR47988:SF21', NULL, NULL, NULL, NULL, 'INSENSITIVE 1-ASSOCIATED RECEPTOR KINASE 1, PUTATIVE, EXPRESSED-RELATED', 245942),
(361867, 'PTHR47988:SF4', NULL, NULL, NULL, NULL, 'LRR RECEPTOR KINASE SERK2', 245942),
(361868, 'PTHR47988:SF3', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245942),
(361869, 'PTHR47988:SF2', NULL, NULL, NULL, NULL, 'PROTEIN NSP-INTERACTING KINASE 3', 245942),
(361870, 'PTHR47988:SF1', NULL, NULL, NULL, NULL, 'OS04G0227000 PROTEIN', 245942),
(361871, 'PTHR47988:SF71', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245942),
(361872, 'PTHR47988:SF70', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 245942),
(361873, 'PTHR47988:SF39', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 245942),
(361874, 'PTHR47988:SF36', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 245942),
(361875, 'PTHR47988:SF31', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245942),
(361876, 'PTHR47988:SF75', NULL, NULL, NULL, NULL, 'BRASSINOSTEROID INSENSITIVE 1-ASSOCIATED RECEPTOR KINASE 1-LIKE', 245942),
(361877, 'PTHR47988:SF74', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245942),
(361878, 'PTHR47988:SF73', NULL, NULL, NULL, NULL, 'OS08G0442700 PROTEIN', 245942),
(361879, 'PTHR47988:SF72', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 245942),
(361880, 'PTHR47988:SF79', NULL, NULL, NULL, NULL, 'PROTEIN NSP-INTERACTING KINASE 1', 245942),
(361881, 'PTHR47988:SF34', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN, PLANT-TYPE-RELATED', 245942),
(361882, 'PTHR47988:SF78', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245942),
(361883, 'PTHR47988:SF77', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 245942),
(361884, 'PTHR47988:SF76', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 245942),
(361885, 'PTHR47988:SF32', NULL, NULL, NULL, NULL, 'SOMATIC EMBRYOGENESIS RECEPTOR KINASE 2', 245942),
(361886, 'PTHR47988:SF82', NULL, NULL, NULL, NULL, 'SOMATIC EMBRYOGENESIS RECEPTOR KINASE 1', 245942),
(361887, 'PTHR47988:SF81', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 245942),
(361888, 'PTHR47988:SF80', NULL, NULL, NULL, NULL, 'PROTEIN NSP-INTERACTING KINASE 2-LIKE', 245942),
(361889, 'PTHR12703:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 33', 245943),
(361890, 'PTHR12703:SF3', NULL, NULL, NULL, NULL, 'ABR032WP', 245943),
(361891, 'PTHR12703:SF8', NULL, NULL, NULL, NULL, 'OS01G0641700 PROTEIN', 245943),
(361892, 'PTHR12703', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 33', 245943),
(361893, 'PTHR12703:SF6', NULL, NULL, NULL, NULL, 'PORE MEMBRANE PROTEIN OF 33 KDA', 245943),
(361894, 'PTHR12703:SF7', NULL, NULL, NULL, NULL, 'OS05G0589000 PROTEIN', 245943),
(361895, 'PTHR35509:SF5', NULL, NULL, NULL, NULL, 'SAP DOMAIN-CONTAINING PROTEIN', 245944),
(361896, 'PTHR35509:SF6', NULL, NULL, NULL, NULL, 'ADENYLATE KINASE', 245944),
(361897, 'PTHR35509:SF4', NULL, NULL, NULL, NULL, 'DUF1995 DOMAIN-CONTAINING PROTEIN', 245944),
(361898, 'PTHR35509:SF1', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (DUF1995)-RELATED', 245944),
(361899, 'PTHR35509', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (DUF1995)-RELATED', 245944),
(361900, 'PTHR37262:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PEP-RELATED DEVELOPMENT ARRESTED 1, CHLOROPLASTIC', 245945),
(361901, 'PTHR37262', NULL, NULL, NULL, NULL, 'PROTEIN PEP-RELATED DEVELOPMENT ARRESTED 1, CHLOROPLASTIC', 245945),
(361902, 'PTHR43362:SF1', NULL, NULL, NULL, NULL, 'MANNITOL DEHYDROGENASE 2-RELATED', 245946),
(361903, 'PTHR43362:SF7', NULL, NULL, NULL, NULL, 'D-MANNONATE OXIDOREDUCTASE', 245946),
(361904, 'PTHR43362', NULL, NULL, NULL, NULL, 'MANNITOL DEHYDROGENASE DSF1-RELATED', 245946),
(361905, 'PTHR43362:SF4', NULL, NULL, NULL, NULL, 'MANNITOL DEHYDROGENASE-RELATED', 245946),
(361906, 'PTHR13131:SF13', NULL, NULL, NULL, NULL, '', 245947);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(361907, 'PTHR13131', NULL, NULL, NULL, NULL, 'CYSTINOSIN', 245947),
(361908, 'PTHR13131:SF5', NULL, NULL, NULL, NULL, 'CYSTINOSIN', 245947),
(361909, 'PTHR13131:SF7', NULL, NULL, NULL, NULL, 'PQ LOOP REPEAT FAMILY PROTEIN', 245947),
(361910, 'PTHR13131:SF8', NULL, NULL, NULL, NULL, 'CYSTINOSIN HOMOLOG', 245947),
(361911, 'PTHR13131:SF9', NULL, NULL, NULL, NULL, 'CYSTINOSIN-LIKE PROTEIN', 245947),
(361912, 'PTHR13131:SF11', NULL, NULL, NULL, NULL, 'LYSOSOMAL CYSTINE TRANSPORTER FAMILY PROTEIN', 245947),
(361913, 'PTHR13131:SF12', NULL, NULL, NULL, NULL, 'LYSOSOMAL CYSTINE TRANSPORTER FAMILY PROTEIN', 245947),
(361914, 'PTHR36848', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN (PUTATIVE SECRETED PROTEIN)-RELATED', 245948),
(361915, 'PTHR36848:SF2', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN (PUTATIVE SECRETED PROTEIN)-RELATED', 245948),
(361916, 'PTHR35679:SF1', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4933402J07 GENE', 245949),
(361917, 'PTHR35679', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4933402J07 GENE', 245949),
(361918, 'PTHR46052:SF2', NULL, NULL, NULL, NULL, 'PHOSDUCIN B', 245950),
(361919, 'PTHR46052:SF3', NULL, NULL, NULL, NULL, 'PHOSDUCIN', 245950),
(361920, 'PTHR46052:SF1', NULL, NULL, NULL, NULL, 'PHOSDUCIN-LIKE PROTEIN', 245950),
(361921, 'PTHR46052', NULL, NULL, NULL, NULL, 'PHOSDUCIN-LIKE PROTEIN', 245950),
(361922, 'PTHR46052:SF4', NULL, NULL, NULL, NULL, 'PHOSDUCIN-LIKE PROTEIN', 245950),
(361923, 'PTHR13394', NULL, NULL, NULL, NULL, 'ORIGIN RECOGNITION COMPLEX SUBUNIT 6', 245951),
(361924, 'PTHR13394:SF0', NULL, NULL, NULL, NULL, 'ORIGIN RECOGNITION COMPLEX SUBUNIT 6', 245951),
(361925, 'PTHR13394:SF1', NULL, NULL, NULL, NULL, 'BNAA09G23030D PROTEIN', 245951),
(361926, 'PTHR38690:SF1', NULL, NULL, NULL, NULL, 'PROTEASE-RELATED', 245952),
(361927, 'PTHR38690', NULL, NULL, NULL, NULL, 'PROTEASE-RELATED', 245952),
(361928, 'PTHR35397', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN-RELATED', 245953),
(361929, 'PTHR35397:SF1', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 245953),
(361930, 'PTHR35397:SF2', NULL, NULL, NULL, NULL, '', 245953),
(361931, 'PTHR46113:SF1', NULL, NULL, NULL, NULL, 'SNAC DOMAIN-CONTAINING PROTEIN', 245954),
(361932, 'PTHR46113', NULL, NULL, NULL, NULL, 'SNAC DOMAIN-CONTAINING PROTEIN', 245954),
(361933, 'PTHR10231:SF39', NULL, NULL, NULL, NULL, 'F44C8.7-LIKE PROTEIN-RELATED', 245955),
(361934, 'PTHR10231:SF84', NULL, NULL, NULL, NULL, 'BNACNNG31630D PROTEIN', 245955),
(361935, 'PTHR10231:SF96', NULL, NULL, NULL, NULL, 'UDP-SUGAR TRANSPORTER PROTEIN SLC35A4-RELATED', 245955),
(361936, 'PTHR10231:SF41', NULL, NULL, NULL, NULL, 'NUCLEOTIDE SUGAR TRANSPORTER FAMILY', 245955),
(361937, 'PTHR10231:SF71', NULL, NULL, NULL, NULL, 'CMP-SIALIC ACID TRANSPORTER 4', 245955),
(361938, 'PTHR10231:SF82', NULL, NULL, NULL, NULL, 'CMP-SIALIC ACID TRANSPORTER 5-LIKE ISOFORM X1', 245955),
(361939, 'PTHR10231:SF50', NULL, NULL, NULL, NULL, 'UDP-GALACTOSE TRANSPORTER SENJU', 245955),
(361940, 'PTHR10231:SF83', NULL, NULL, NULL, NULL, 'NUCLEOTIDE SUGAR TRANSPORTER FAMILY', 245955),
(361941, 'PTHR10231:SF90', NULL, NULL, NULL, NULL, 'UDP-SUGAR TRANSPORTER PROTEIN SLC35A5-RELATED', 245955),
(361942, 'PTHR10231:SF3', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE TRANSPORTER ROCK1', 245955),
(361943, 'PTHR10231:SF79', NULL, NULL, NULL, NULL, 'CMP-SIALIC ACID TRANSPORTER 4', 245955),
(361944, 'PTHR10231:SF36', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE TRANSPORTER', 245955),
(361945, 'PTHR10231:SF99', NULL, NULL, NULL, NULL, 'CMP-SIALIC ACID TRANSPORTER 3', 245955),
(361946, 'PTHR10231:SF66', NULL, NULL, NULL, NULL, 'CMP-SIALIC ACID TRANSPORTER', 245955),
(361947, 'PTHR10231:SF89', NULL, NULL, NULL, NULL, 'BNAC03G49310D PROTEIN', 245955),
(361948, 'PTHR10231:SF75', NULL, NULL, NULL, NULL, 'CMP-SIALIC ACID TRANSPORTER 5', 245955),
(361949, 'PTHR10231:SF86', NULL, NULL, NULL, NULL, 'CMP-SIALIC ACID TRANSPORTER 3', 245955),
(361950, 'PTHR10231:SF100', NULL, NULL, NULL, NULL, 'CMP-SIALIC ACID TRANSPORTER 4', 245955),
(361951, 'PTHR10231:SF97', NULL, NULL, NULL, NULL, 'BNAC03G62270D PROTEIN', 245955);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(361952, 'PTHR10231:SF98', NULL, NULL, NULL, NULL, 'CMP-SIALIC ACID TRANSPORTER 2', 245955),
(361953, 'PTHR10231:SF43', NULL, NULL, NULL, NULL, 'UDP-GALACTOSE TRANSLOCATOR', 245955),
(361954, 'PTHR10231', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-SUGAR TRANSMEMBRANE TRANSPORTER', 245955),
(361955, 'PTHR10231:SF87', NULL, NULL, NULL, NULL, '', 245955),
(361956, 'PTHR31833', NULL, NULL, NULL, NULL, 'UPF0690 PROTEIN C1ORF52', 245956),
(361957, 'PTHR31833:SF2', NULL, NULL, NULL, NULL, 'UPF0690 PROTEIN C1ORF52', 245956),
(361958, 'PTHR46424:SF1', NULL, NULL, NULL, NULL, 'UBX DOMAIN-CONTAINING PROTEIN 4', 245957),
(361959, 'PTHR46424', NULL, NULL, NULL, NULL, 'UBX DOMAIN-CONTAINING PROTEIN 4', 245957),
(361960, 'PTHR31938:SF4', NULL, NULL, NULL, NULL, 'NUCLEAR SPECKLE SPLICING REGULATORY PROTEIN 1', 245958),
(361961, 'PTHR31938', NULL, NULL, NULL, NULL, 'NUCLEAR SPECKLE SPLICING REGULATORY PROTEIN 1', 245958),
(361962, 'PTHR33881:SF7', NULL, NULL, NULL, NULL, 'NEUROGENIC LOCUS NOTCH-LIKE PROTEIN', 245959),
(361963, 'PTHR33881:SF14', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 245959),
(361964, 'PTHR33881:SF6', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 245959),
(361965, 'PTHR33881:SF10', NULL, NULL, NULL, NULL, 'MTN26', 245959),
(361966, 'PTHR33881', NULL, NULL, NULL, NULL, 'NEUROGENIC LOCUS NOTCH-LIKE PROTEIN', 245959),
(361967, 'PTHR33881:SF17', NULL, NULL, NULL, NULL, 'OS10G0419700 PROTEIN', 245959),
(361968, 'PTHR47916:SF1', NULL, NULL, NULL, NULL, '3-HYDROXY-5-PHOSPHONOOXYPENTANE-2,4-DIONE THIOLASE-RELATED', 245960),
(361969, 'PTHR47916:SF3', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE/6-DEOXY-5-KETOFRUCTOSE 1-PHOSPHATE SYNTHASE', 245960),
(361970, 'PTHR47916', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE CLASS 1', 245960),
(361971, 'PTHR36478:SF18', NULL, NULL, NULL, NULL, 'OS04G0616900 PROTEIN', 245961),
(361972, 'PTHR36478:SF10', NULL, NULL, NULL, NULL, 'OS07G0199000 PROTEIN', 245961),
(361973, 'PTHR36478:SF13', NULL, NULL, NULL, NULL, '', 245961),
(361974, 'PTHR36478:SF14', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 245961),
(361975, 'PTHR36478:SF17', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 245961),
(361976, 'PTHR36478:SF16', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 245961),
(361977, 'PTHR36478', NULL, NULL, NULL, NULL, 'OS04G0614237 PROTEIN-RELATED', 245961),
(361978, 'PTHR13532', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 245962),
(361979, 'PTHR13532:SF3', NULL, NULL, NULL, NULL, 'INTEGRATOR COMPLEX SUBUNIT 14', 245962),
(361980, 'PTHR48001:SF104', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(361981, 'PTHR48001:SF103', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 8S1', 245963),
(361982, 'PTHR48001:SF102', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245963),
(361983, 'PTHR48001:SF101', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(361984, 'PTHR48001:SF188', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(361985, 'PTHR48001:SF100', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 3A4-RELATED', 245963),
(361986, 'PTHR48001:SF187', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1E1', 245963),
(361987, 'PTHR48001:SF186', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1G1', 245963),
(361988, 'PTHR48001:SF185', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(361989, 'PTHR48001:SF41', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(361990, 'PTHR48001:SF40', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 3A1', 245963),
(361991, 'PTHR48001:SF43', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1N1', 245963),
(361992, 'PTHR48001:SF108', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR FAMILY 7 SUBFAMILY A MEMBER 67', 245963),
(361993, 'PTHR48001:SF42', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1P1', 245963),
(361994, 'PTHR48001:SF107', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 7D2', 245963),
(361995, 'PTHR48001:SF45', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(361996, 'PTHR48001:SF106', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1L6', 245963);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(361997, 'PTHR48001:SF105', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(361998, 'PTHR48001:SF44', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1D2', 245963),
(361999, 'PTHR48001:SF47', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 7E24', 245963),
(362000, 'PTHR48001:SF46', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362001, 'PTHR48001:SF49', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1L3', 245963),
(362002, 'PTHR48001:SF48', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362003, 'PTHR48001:SF179', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1L6-LIKE', 245963),
(362004, 'PTHR48001:SF178', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362005, 'PTHR48001:SF177', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 7A5', 245963),
(362006, 'PTHR48001:SF176', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 2AT4', 245963),
(362007, 'PTHR48001:SF174', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362008, 'PTHR48001:SF50', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1A1-RELATED', 245963),
(362009, 'PTHR48001:SF52', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362010, 'PTHR48001:SF51', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1L1', 245963),
(362011, 'PTHR48001:SF53', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1I1', 245963),
(362012, 'PTHR48001:SF56', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1Q1', 245963),
(362013, 'PTHR48001:SF55', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362014, 'PTHR48001:SF58', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245963),
(362015, 'PTHR48001:SF57', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362016, 'PTHR48001:SF59', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362017, 'PTHR48001:SF9', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1J2', 245963),
(362018, 'PTHR48001', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362019, 'PTHR48001:SF7', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362020, 'PTHR48001:SF6', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362021, 'PTHR48001:SF184', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 365', 245963),
(362022, 'PTHR48001:SF183', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362023, 'PTHR48001:SF4', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362024, 'PTHR48001:SF182', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362025, 'PTHR48001:SF3', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362026, 'PTHR48001:SF2', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362027, 'PTHR48001:SF1', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 867', 245963),
(362028, 'PTHR48001:SF180', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362029, 'PTHR48001:SF169', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362030, 'PTHR48001:SF167', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR-RELATED', 245963),
(362031, 'PTHR48001:SF166', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362032, 'PTHR48001:SF165', NULL, NULL, NULL, NULL, 'SIMILAR TO OLFACTORY RECEPTOR OLR1374', 245963),
(362033, 'PTHR48001:SF164', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR FAMILY 7 SUBFAMILY A MEMBER 17', 245963),
(362034, 'PTHR48001:SF163', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1E2', 245963),
(362035, 'PTHR48001:SF21', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362036, 'PTHR48001:SF20', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362037, 'PTHR48001:SF23', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362038, 'PTHR48001:SF22', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245963),
(362039, 'PTHR48001:SF25', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362040, 'PTHR48001:SF24', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362041, 'PTHR48001:SF27', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362042, 'PTHR48001:SF26', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362043, 'PTHR48001:SF28', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362044, 'PTHR48001:SF173', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(362045, 'PTHR48001:SF172', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362046, 'PTHR48001:SF171', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245963),
(362047, 'PTHR48001:SF170', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362048, 'PTHR48001:SF159', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362049, 'PTHR48001:SF158', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362050, 'PTHR48001:SF157', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362051, 'PTHR48001:SF155', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 7A2-RELATED', 245963),
(362052, 'PTHR48001:SF154', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362053, 'PTHR48001:SF153', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR-RELATED', 245963),
(362054, 'PTHR48001:SF152', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362055, 'PTHR48001:SF30', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362056, 'PTHR48001:SF32', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362057, 'PTHR48001:SF31', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR FAMILY 1 SUBFAMILY A MEMBER 1C', 245963),
(362058, 'PTHR48001:SF34', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362059, 'PTHR48001:SF33', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362060, 'PTHR48001:SF35', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362061, 'PTHR48001:SF37', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362062, 'PTHR48001:SF39', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362063, 'PTHR48001:SF162', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1351', 245963),
(362064, 'PTHR48001:SF161', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362065, 'PTHR48001:SF148', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1J1', 245963),
(362066, 'PTHR48001:SF147', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 3A3', 245963),
(362067, 'PTHR48001:SF146', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362068, 'PTHR48001:SF145', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362069, 'PTHR48001:SF144', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362070, 'PTHR48001:SF143', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362071, 'PTHR48001:SF81', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 356', 245963),
(362072, 'PTHR48001:SF142', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 7A17', 245963),
(362073, 'PTHR48001:SF141', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362074, 'PTHR48001:SF80', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362075, 'PTHR48001:SF83', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1L8', 245963),
(362076, 'PTHR48001:SF82', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362077, 'PTHR48001:SF85', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362078, 'PTHR48001:SF84', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1L4', 245963),
(362079, 'PTHR48001:SF87', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362080, 'PTHR48001:SF86', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 866', 245963),
(362081, 'PTHR48001:SF89', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362082, 'PTHR48001:SF149', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245963),
(362083, 'PTHR48001:SF151', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245963),
(362084, 'PTHR48001:SF150', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362085, 'PTHR48001:SF136', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362086, 'PTHR48001:SF135', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1N2', 245963),
(362087, 'PTHR48001:SF134', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362088, 'PTHR48001:SF90', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362089, 'PTHR48001:SF133', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362090, 'PTHR48001:SF131', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362091, 'PTHR48001:SF92', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362092, 'PTHR48001:SF91', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(362093, 'PTHR48001:SF130', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1E3', 245963),
(362094, 'PTHR48001:SF94', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362095, 'PTHR48001:SF93', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362096, 'PTHR48001:SF96', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 7G2', 245963),
(362097, 'PTHR48001:SF95', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362098, 'PTHR48001:SF98', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1F1-RELATED', 245963),
(362099, 'PTHR48001:SF10', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1J4', 245963),
(362100, 'PTHR48001:SF97', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1', 245963),
(362101, 'PTHR48001:SF12', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362102, 'PTHR48001:SF139', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 3A2', 245963),
(362103, 'PTHR48001:SF99', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245963),
(362104, 'PTHR48001:SF138', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 7D4', 245963),
(362105, 'PTHR48001:SF14', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362106, 'PTHR48001:SF13', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245963),
(362107, 'PTHR48001:SF16', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362108, 'PTHR48001:SF15', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362109, 'PTHR48001:SF18', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362110, 'PTHR48001:SF17', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362111, 'PTHR48001:SF140', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362112, 'PTHR48001:SF126', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362113, 'PTHR48001:SF125', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1B1', 245963),
(362114, 'PTHR48001:SF124', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1M1', 245963),
(362115, 'PTHR48001:SF123', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 7G3', 245963),
(362116, 'PTHR48001:SF122', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245963),
(362117, 'PTHR48001:SF121', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362118, 'PTHR48001:SF120', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362119, 'PTHR48001:SF61', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362120, 'PTHR48001:SF60', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362121, 'PTHR48001:SF63', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362122, 'PTHR48001:SF62', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 139', 245963),
(362123, 'PTHR48001:SF64', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362124, 'PTHR48001:SF129', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362125, 'PTHR48001:SF67', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 7G1', 245963),
(362126, 'PTHR48001:SF128', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362127, 'PTHR48001:SF66', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362128, 'PTHR48001:SF127', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362129, 'PTHR48001:SF69', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1F12', 245963),
(362130, 'PTHR48001:SF68', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362131, 'PTHR48001:SF115', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1S1-RELATED', 245963),
(362132, 'PTHR48001:SF114', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1C1', 245963),
(362133, 'PTHR48001:SF113', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362134, 'PTHR48001:SF112', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 7A10', 245963),
(362135, 'PTHR48001:SF111', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362136, 'PTHR48001:SF110', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 50', 245963),
(362137, 'PTHR48001:SF70', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1D4-RELATED', 245963),
(362138, 'PTHR48001:SF72', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362139, 'PTHR48001:SF71', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362140, 'PTHR48001:SF73', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(362141, 'PTHR48001:SF76', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362142, 'PTHR48001:SF118', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 7C1', 245963),
(362143, 'PTHR48001:SF78', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 245963),
(362144, 'PTHR48001:SF77', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 245963),
(362145, 'PTHR48001:SF79', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 7C2', 245963),
(362146, 'PTHR47892', NULL, NULL, NULL, NULL, 'UNIVERSAL STRESS PROTEIN E', 245964),
(362147, 'PTHR47892:SF1', NULL, NULL, NULL, NULL, 'UNIVERSAL STRESS PROTEIN E', 245964),
(362148, 'PTHR37831:SF1', NULL, NULL, NULL, NULL, 'D-RIBOSE PYRANASE', 245965),
(362149, 'PTHR37831', NULL, NULL, NULL, NULL, 'D-RIBOSE PYRANASE', 245965),
(362150, 'PTHR16322:SF0', NULL, NULL, NULL, NULL, 'PHOSPHOPROTEIN ASSOCIATED WITH GLYCOSPHINGOLIPID-ENRICHED MICRODOMAINS 1', 245966),
(362151, 'PTHR16322:SF1', NULL, NULL, NULL, NULL, 'SI:DKEY-70P6.1', 245966),
(362152, 'PTHR16322', NULL, NULL, NULL, NULL, 'PHOSPHOPROTEIN ASSOCIATED WITH GLYCOSPHINGOLIPID-ENRICHED MICRODOMAINS 1', 245966),
(362153, 'PTHR47116:SF26', NULL, NULL, NULL, NULL, 'CYSTATIN DOMAIN-CONTAINING PROTEIN', 245967),
(362154, 'PTHR47116:SF15', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR', 245967),
(362155, 'PTHR47116:SF16', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR', 245967),
(362156, 'PTHR47116:SF17', NULL, NULL, NULL, NULL, 'OS03G0172400 PROTEIN', 245967),
(362157, 'PTHR47116:SF18', NULL, NULL, NULL, NULL, 'OS10G0400400 PROTEIN', 245967),
(362158, 'PTHR47116:SF22', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR', 245967),
(362159, 'PTHR47116:SF13', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR', 245967),
(362160, 'PTHR47116:SF14', NULL, NULL, NULL, NULL, 'OS02G0278600 PROTEIN', 245967),
(362161, 'PTHR47116:SF25', NULL, NULL, NULL, NULL, 'CYSTATIN DOMAIN-CONTAINING PROTEIN', 245967),
(362162, 'PTHR47116:SF20', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR', 245967),
(362163, 'PTHR47116:SF10', NULL, NULL, NULL, NULL, 'CYSTATIN DOMAIN-CONTAINING PROTEIN', 245967),
(362164, 'PTHR47116:SF21', NULL, NULL, NULL, NULL, 'OS03G0173100 PROTEIN', 245967),
(362165, 'PTHR47116', NULL, NULL, NULL, NULL, 'PHLOEM FILAMENT PROTEIN', 245967),
(362166, 'PTHR47116:SF9', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR 5', 245967),
(362167, 'PTHR47116:SF7', NULL, NULL, NULL, NULL, 'CYSTATIN', 245967),
(362168, 'PTHR47116:SF6', NULL, NULL, NULL, NULL, 'CYSTATIN, EXPRESSED', 245967),
(362169, 'PTHR47116:SF4', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 245967),
(362170, 'PTHR47116:SF3', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR 8', 245967),
(362171, 'PTHR12098:SF5', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE PELLINO HOMOLOG 2', 245968),
(362172, 'PTHR12098:SF7', NULL, NULL, NULL, NULL, '', 245968),
(362173, 'PTHR12098:SF9', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE PELLINO HOMOLOG 3', 245968),
(362174, 'PTHR12098', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE PELLINO-RELATED', 245968),
(362175, 'PTHR12098:SF2', NULL, NULL, NULL, NULL, 'PROTEIN PELLINO', 245968),
(362176, 'PTHR12098:SF4', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE PELLINO HOMOLOG 1', 245968),
(362177, 'PTHR32123:SF10', NULL, NULL, NULL, NULL, 'BICAUDAL-D-RELATED PROTEIN 2-LIKE-RELATED', 245969),
(362178, 'PTHR32123', NULL, NULL, NULL, NULL, 'BICD FAMILY-LIKE CARGO ADAPTER', 245969),
(362179, 'PTHR32123:SF11', NULL, NULL, NULL, NULL, 'BICD FAMILY-LIKE CARGO ADAPTER 2-RELATED', 245969),
(362180, 'PTHR32123:SF12', NULL, NULL, NULL, NULL, 'BICD FAMILY-LIKE CARGO ADAPTER 1', 245969),
(362181, 'PTHR32123:SF13', NULL, NULL, NULL, NULL, 'BICAUDAL D-RELATED PROTEIN HOMOLOG', 245969),
(362182, 'PTHR32123:SF9', NULL, NULL, NULL, NULL, 'PROTEIN SPINDLY', 245969),
(362183, 'PTHR43323:SF20', NULL, NULL, NULL, NULL, '3-HYDROXY-3-METHYLGLUTARYL COENZYME A SYNTHASE', 245970),
(362184, 'PTHR43323:SF21', NULL, NULL, NULL, NULL, '3-HYDROXY-3-METHYLGLUTARYL COENZYME A SYNTHASE', 245970); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(362185, 'PTHR43323:SF6', NULL, NULL, NULL, NULL, '3-HYDROXY-3-METHYLGLUTARYL COENZYME A SYNTHASE', 245970),
(362186, 'PTHR43323:SF9', NULL, NULL, NULL, NULL, '3-HYDROXY-3-METHYLGLUTARYL COENZYME A SYNTHASE', 245970),
(362187, 'PTHR43323:SF19', NULL, NULL, NULL, NULL, '3-HYDROXY-3-METHYLGLUTARYL COENZYME A SYNTHASE', 245970),
(362188, 'PTHR43323:SF1', NULL, NULL, NULL, NULL, 'HYDROXYMETHYLGLUTARYL-COA SYNTHASE, MITOCHONDRIAL', 245970),
(362189, 'PTHR43323:SF13', NULL, NULL, NULL, NULL, '3-HYDROXY-3-METHYLGLUTARYL COENZYME A SYNTHASE', 245970),
(362190, 'PTHR43323:SF14', NULL, NULL, NULL, NULL, 'HYDROXYMETHYLGLUTARYL-COA SYNTHASE A', 245970),
(362191, 'PTHR43323:SF2', NULL, NULL, NULL, NULL, '3-HYDROXY-3-METHYLGLUTARYL COENZYME A SYNTHASE', 245970),
(362192, 'PTHR43323:SF15', NULL, NULL, NULL, NULL, '3-HYDROXY-3-METHYLGLUTARYL COENZYME A SYNTHASE', 245970),
(362193, 'PTHR43323', NULL, NULL, NULL, NULL, '3-HYDROXY-3-METHYLGLUTARYL COENZYME A SYNTHASE', 245970),
(362194, 'PTHR43323:SF4', NULL, NULL, NULL, NULL, 'HYDROXYMETHYLGLUTARYL-COA SYNTHASE, CYTOPLASMIC', 245970),
(362195, 'PTHR33202:SF6', NULL, NULL, NULL, NULL, 'ZINC UPTAKE REGULATION PROTEIN', 245971),
(362196, 'PTHR33202:SF2', NULL, NULL, NULL, NULL, 'FERRIC UPTAKE REGULATION PROTEIN', 245971),
(362197, 'PTHR33202:SF1', NULL, NULL, NULL, NULL, 'ZINC-SPECIFIC METALLO-REGULATORY PROTEIN', 245971),
(362198, 'PTHR33202:SF17', NULL, NULL, NULL, NULL, 'EXPORTED PROTEIN-RELATED', 245971),
(362199, 'PTHR33202:SF18', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR FURA', 245971),
(362200, 'PTHR33202:SF19', NULL, NULL, NULL, NULL, 'FERRIC UPTAKE REGULATION PROTEIN', 245971),
(362201, 'PTHR33202', NULL, NULL, NULL, NULL, 'ZINC UPTAKE REGULATION PROTEIN', 245971),
(362202, 'PTHR33202:SF8', NULL, NULL, NULL, NULL, 'PEROXIDE OPERON REGULATOR', 245971),
(362203, 'PTHR33202:SF21', NULL, NULL, NULL, NULL, 'FERRIC UPTAKE REGULATION PROTEIN', 245971),
(362204, 'PTHR33202:SF7', NULL, NULL, NULL, NULL, 'FERRIC UPTAKE REGULATION PROTEIN', 245971),
(362205, 'PTHR47417', NULL, NULL, NULL, NULL, 'SMR DOMAIN-CONTAINING PROTEIN YPL199C', 245972),
(362206, 'PTHR47417:SF1', NULL, NULL, NULL, NULL, 'SMR DOMAIN-CONTAINING PROTEIN YPL199C', 245972),
(362207, 'PTHR47417:SF2', NULL, NULL, NULL, NULL, 'SMR DOMAIN-CONTAINING PROTEIN', 245972),
(362208, 'PTHR46513:SF39', NULL, NULL, NULL, NULL, 'PROTEIN CUEBALL-LIKE PROTEIN', 245973),
(362209, 'PTHR46513:SF5', NULL, NULL, NULL, NULL, 'PRO-EPIDERMAL GROWTH FACTOR', 245973),
(362210, 'PTHR46513:SF15', NULL, NULL, NULL, NULL, 'NIDOGEN 2', 245973),
(362211, 'PTHR46513:SF37', NULL, NULL, NULL, NULL, 'LOW-DENSITY LIPOPROTEIN RECEPTOR-RELATED PROTEIN 1', 245973),
(362212, 'PTHR46513:SF38', NULL, NULL, NULL, NULL, 'NIDOGEN 1B', 245973),
(362213, 'PTHR46513:SF16', NULL, NULL, NULL, NULL, 'LOW-DENSITY LIPOPROTEIN RECEPTOR-RELATED PROTEIN 5', 245973),
(362214, 'PTHR46513:SF35', NULL, NULL, NULL, NULL, 'RECEPTOR MEDIATED ENDOCYTOSIS', 245973),
(362215, 'PTHR46513:SF13', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 245973),
(362216, 'PTHR46513:SF36', NULL, NULL, NULL, NULL, 'LOW-DENSITY LIPOPROTEIN RECEPTOR-RELATED PROTEIN', 245973),
(362217, 'PTHR46513:SF33', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 245973),
(362218, 'PTHR46513:SF34', NULL, NULL, NULL, NULL, 'SUSHI DOMAIN-CONTAINING PROTEIN', 245973),
(362219, 'PTHR46513:SF31', NULL, NULL, NULL, NULL, '', 245973),
(362220, 'PTHR46513:SF21', NULL, NULL, NULL, NULL, 'LOW-DENSITY LIPOPROTEIN RECEPTOR-RELATED PROTEIN 2', 245973),
(362221, 'PTHR46513:SF32', NULL, NULL, NULL, NULL, 'PROTEIN CBG19478', 245973),
(362222, 'PTHR46513:SF40', NULL, NULL, NULL, NULL, 'LOW-DENSITY LIPOPROTEIN RECEPTOR-RELATED PROTEIN 6', 245973),
(362223, 'PTHR46513', NULL, NULL, NULL, NULL, 'VITELLOGENIN RECEPTOR-LIKE PROTEIN-RELATED-RELATED', 245973),
(362224, 'PTHR46513:SF6', NULL, NULL, NULL, NULL, 'NIDOGEN-1', 245973),
(362225, 'PTHR46513:SF7', NULL, NULL, NULL, NULL, 'LDL RECEPTOR RELATED PROTEIN 1B', 245973),
(362226, 'PTHR35723', NULL, NULL, NULL, NULL, 'POLYPHOSPHATIDYLINOSITOL PHOSPHATASE', 245974);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(362227, 'PTHR35723:SF1', NULL, NULL, NULL, NULL, 'POLYPHOSPHATIDYLINOSITOL PHOSPHATASE', 245974),
(362228, 'PTHR37384', NULL, NULL, NULL, NULL, 'OS01G0835600 PROTEIN', 245975),
(362229, 'PTHR37384:SF4', NULL, NULL, NULL, NULL, 'LBR_TUDOR DOMAIN-CONTAINING PROTEIN', 245975),
(362230, 'PTHR37384:SF1', NULL, NULL, NULL, NULL, 'OS01G0835600 PROTEIN', 245975),
(362231, 'PTHR37384:SF3', NULL, NULL, NULL, NULL, 'LBR_TUDOR DOMAIN-CONTAINING PROTEIN', 245975),
(362232, 'PTHR37384:SF2', NULL, NULL, NULL, NULL, '', 245975),
(362233, 'PTHR19959:SF118', NULL, NULL, NULL, NULL, 'CHAT DOMAIN-CONTAINING PROTEIN', 245976),
(362234, 'PTHR19959', NULL, NULL, NULL, NULL, 'KINESIN LIGHT CHAIN', 245976),
(362235, 'PTHR36487:SF3', NULL, NULL, NULL, NULL, 'OS09G0296500 PROTEIN', 245977),
(362236, 'PTHR36487', NULL, NULL, NULL, NULL, 'OS09G0296500 PROTEIN-RELATED', 245977),
(362237, 'PTHR36487:SF1', NULL, NULL, NULL, NULL, '', 245977),
(362238, 'PTHR36487:SF2', NULL, NULL, NULL, NULL, 'B1159F04.1 PROTEIN', 245977),
(362239, 'PTHR43321:SF19', NULL, NULL, NULL, NULL, 'GLUTAMATE DECARBOXYLASE 2', 245978),
(362240, 'PTHR43321', NULL, NULL, NULL, NULL, 'GLUTAMATE DECARBOXYLASE', 245978),
(362241, 'PTHR43321:SF36', NULL, NULL, NULL, NULL, 'GLUTAMATE DECARBOXYLASE', 245978),
(362242, 'PTHR43321:SF25', NULL, NULL, NULL, NULL, 'GLUTAMATE DECARBOXYLASE', 245978),
(362243, 'PTHR43321:SF35', NULL, NULL, NULL, NULL, 'GLUTAMATE DECARBOXYLASE', 245978),
(362244, 'PTHR43321:SF13', NULL, NULL, NULL, NULL, 'GLUTAMATE DECARBOXYLASE', 245978),
(362245, 'PTHR43321:SF34', NULL, NULL, NULL, NULL, 'GLUTAMATE DECARBOXYLASE 1', 245978),
(362246, 'PTHR43321:SF22', NULL, NULL, NULL, NULL, 'GLUTAMATE DECARBOXYLASE 5', 245978),
(362247, 'PTHR43321:SF29', NULL, NULL, NULL, NULL, 'GLUTAMATE DECARBOXYLASE', 245978),
(362248, 'PTHR43321:SF39', NULL, NULL, NULL, NULL, 'GLUTAMATE DECARBOXYLASE', 245978),
(362249, 'PTHR43321:SF38', NULL, NULL, NULL, NULL, 'GLUTAMATE DECARBOXYLASE 3-RELATED', 245978),
(362250, 'PTHR43321:SF27', NULL, NULL, NULL, NULL, 'GLUTAMATE DECARBOXYLASE', 245978),
(362251, 'PTHR43321:SF16', NULL, NULL, NULL, NULL, 'GLUTAMATE DECARBOXYLASE', 245978),
(362252, 'PTHR43321:SF37', NULL, NULL, NULL, NULL, 'GLUTAMATE DECARBOXYLASE', 245978),
(362253, 'PTHR43321:SF6', NULL, NULL, NULL, NULL, 'GLUTAMATE DECARBOXYLASE', 245978),
(362254, 'PTHR43321:SF32', NULL, NULL, NULL, NULL, 'GLUTAMATE DECARBOXYLASE', 245978),
(362255, 'PTHR43321:SF1', NULL, NULL, NULL, NULL, 'GLUTAMATE DECARBOXYLASE', 245978),
(362256, 'PTHR43321:SF20', NULL, NULL, NULL, NULL, 'GLUTAMATE DECARBOXYLASE', 245978),
(362257, 'PTHR43321:SF3', NULL, NULL, NULL, NULL, 'GLUTAMATE DECARBOXYLASE', 245978),
(362258, 'PTHR35392:SF4', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 245979),
(362259, 'PTHR35392:SF3', NULL, NULL, NULL, NULL, '', 245979),
(362260, 'PTHR35392:SF2', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 245979),
(362261, 'PTHR35392:SF1', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 245979),
(362262, 'PTHR35392', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED-RELATED', 245979),
(362263, 'PTHR35392:SF5', NULL, NULL, NULL, NULL, '', 245979),
(362264, 'PTHR33597:SF17', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR Y SUBUNIT C-4, PUTATIVE-RELATED', 245980),
(362265, 'PTHR33597:SF18', NULL, NULL, NULL, NULL, 'BNAA09G14940D PROTEIN', 245980),
(362266, 'PTHR33597:SF22', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 245980),
(362267, 'PTHR33597:SF11', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 245980),
(362268, 'PTHR33597:SF12', NULL, NULL, NULL, NULL, '', 245980),
(362269, 'PTHR33597:SF13', NULL, NULL, NULL, NULL, '', 245980),
(362270, 'PTHR33597:SF20', NULL, NULL, NULL, NULL, 'OS02G0760400 PROTEIN', 245980),
(362271, 'PTHR33597:SF21', NULL, NULL, NULL, NULL, '', 245980),
(362272, 'PTHR33597:SF19', NULL, NULL, NULL, NULL, 'OS07G0620600 PROTEIN', 245980),
(362273, 'PTHR33597', NULL, NULL, NULL, NULL, 'OS02G0760400 PROTEIN', 245980);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(362274, 'PTHR11141:SF0', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC23', 245981),
(362275, 'PTHR11141:SF2', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC23', 245981),
(362276, 'PTHR11141:SF7', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC23A', 245981),
(362277, 'PTHR11141:SF6', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC23', 245981),
(362278, 'PTHR11141:SF30', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC23', 245981),
(362279, 'PTHR11141:SF31', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC23-1', 245981),
(362280, 'PTHR11141:SF18', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC23', 245981),
(362281, 'PTHR11141:SF32', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC23', 245981),
(362282, 'PTHR11141:SF22', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC23', 245981),
(362283, 'PTHR11141:SF23', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC23', 245981),
(362284, 'PTHR11141:SF24', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC23', 245981),
(362285, 'PTHR11141:SF10', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC23B', 245981),
(362286, 'PTHR11141:SF29', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC23', 245981),
(362287, 'PTHR11141', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC23', 245981),
(362288, 'PTHR23524', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G04850)-RELATED', 245982),
(362289, 'PTHR23524:SF3', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 245982),
(362290, 'PTHR23524:SF1', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G04850)-RELATED', 245982),
(362291, 'PTHR12544:SF33', NULL, NULL, NULL, NULL, 'GLUTAMINASE LIVER ISOFORM, MITOCHONDRIAL', 245983),
(362292, 'PTHR12544:SF32', NULL, NULL, NULL, NULL, 'GLUTAMINASE 1', 245983),
(362293, 'PTHR12544:SF51', NULL, NULL, NULL, NULL, 'GLUTAMINASE 3-RELATED', 245983),
(362294, 'PTHR12544:SF7', NULL, NULL, NULL, NULL, 'GLUTAMINASE 2-RELATED', 245983),
(362295, 'PTHR12544:SF29', NULL, NULL, NULL, NULL, 'GLUTAMINASE', 245983),
(362296, 'PTHR12544', NULL, NULL, NULL, NULL, 'GLUTAMINASE', 245983),
(362297, 'PTHR12544:SF49', NULL, NULL, NULL, NULL, 'GLUTAMINASE KIDNEY ISOFORM, MITOCHONDRIAL', 245983),
(362298, 'PTHR12544:SF26', NULL, NULL, NULL, NULL, 'GLUTAMINASE', 245983),
(362299, 'PTHR12544:SF48', NULL, NULL, NULL, NULL, 'GLUTAMINASE 1', 245983),
(362300, 'PTHR37353:SF1', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4921517D22 GENE', 245984),
(362301, 'PTHR37353', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4921517D22 GENE', 245984),
(362302, 'PTHR47285', NULL, NULL, NULL, NULL, 'PROTEIN TIC 62, CHLOROPLASTIC', 245985),
(362303, 'PTHR47285:SF1', NULL, NULL, NULL, NULL, 'PROTEIN TIC 62, CHLOROPLASTIC', 245985),
(362304, 'PTHR39117:SF4', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 28-LIKE', 245986),
(362305, 'PTHR39117:SF3', NULL, NULL, NULL, NULL, 'BNAC06G14140D PROTEIN', 245986),
(362306, 'PTHR39117:SF1', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 28', 245986),
(362307, 'PTHR39117', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 28', 245986),
(362308, 'PTHR13754:SF18', NULL, NULL, NULL, NULL, '7,8-DIHYDROPTERIN-6-METHYL-4-(BETA-D-RIBOFURANOSYL)-AMINOBENZENE-5''-PHOSPHATE SYNTHASE', 245987),
(362309, 'PTHR13754', NULL, NULL, NULL, NULL, 'METALLO-BETA-LACTAMASE SUPERFAMILY PROTEIN', 245987),
(362310, 'PTHR13754:SF13', NULL, NULL, NULL, NULL, 'METALLO-BETA-LACTAMASE SUPERFAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_3G07630)', 245987),
(362311, 'PTHR11038:SF16', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM10', 245988),
(362312, 'PTHR11038:SF19', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM9', 245988),
(362313, 'PTHR11038:SF18', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM12', 245988),
(362314, 'PTHR11038', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM10', 245988);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(362315, 'PTHR11038:SF22', NULL, NULL, NULL, NULL, 'ZF-TIM10_DDP DOMAIN-CONTAINING PROTEIN', 245988),
(362316, 'PTHR11038:SF23', NULL, NULL, NULL, NULL, 'ZF-TIM10_DDP DOMAIN-CONTAINING PROTEIN', 245988),
(362317, 'PTHR11038:SF21', NULL, NULL, NULL, NULL, 'OS07G0243100 PROTEIN', 245988),
(362318, 'PTHR35043', NULL, NULL, NULL, NULL, '', 245989),
(362319, 'PTHR35043:SF6', NULL, NULL, NULL, NULL, '', 245989),
(362320, 'PTHR35043:SF7', NULL, NULL, NULL, NULL, '', 245989),
(362321, 'PTHR44825', NULL, NULL, NULL, NULL, '', 245990),
(362322, 'PTHR44825:SF1', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 4', 245990),
(362323, 'PTHR32235:SF1', NULL, NULL, NULL, NULL, 'NON-HOMOLOGOUS END-JOINING FACTOR 1', 245991),
(362324, 'PTHR32235', NULL, NULL, NULL, NULL, 'NON-HOMOLOGOUS END-JOINING FACTOR 1', 245991),
(362325, 'PTHR38402:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL OUTER MEMBRANE PROTEIN OM14', 245992),
(362326, 'PTHR38402', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL OUTER MEMBRANE PROTEIN OM14', 245992),
(362327, 'PTHR46786:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER MATRIN-TYPE PROTEIN 3', 245993),
(362328, 'PTHR46786', NULL, NULL, NULL, NULL, 'ZINC FINGER MATRIN-TYPE PROTEIN 3', 245993),
(362329, 'PTHR47605', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ELONGATION REGULATOR MINIYO', 245994),
(362330, 'PTHR47605:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ELONGATION REGULATOR MINIYO', 245994),
(362331, 'PTHR10697:SF5', NULL, NULL, NULL, NULL, 'EPENDYMIN-RELATED', 245995),
(362332, 'PTHR10697:SF1', NULL, NULL, NULL, NULL, 'MAMMALIAN EPENDYMIN-RELATED PROTEIN 1', 245995),
(362333, 'PTHR10697:SF12', NULL, NULL, NULL, NULL, 'FZ DOMAIN-CONTAINING PROTEIN', 245995),
(362334, 'PTHR10697', NULL, NULL, NULL, NULL, 'MAMMALIAN EPENDYMIN-RELATED PROTEIN 1', 245995),
(362335, 'PTHR10697:SF11', NULL, NULL, NULL, NULL, '', 245995),
(362336, 'PTHR48075:SF10', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G10070)-RELATED', 245996),
(362337, 'PTHR48075:SF9', NULL, NULL, NULL, NULL, '3-HYDROXYBUTYRYL-COA DEHYDROGENASE', 245996),
(362338, 'PTHR48075', NULL, NULL, NULL, NULL, '3-HYDROXYACYL-COA DEHYDROGENASE FAMILY PROTEIN', 245996),
(362339, 'PTHR48075:SF1', NULL, NULL, NULL, NULL, 'LAMBDA-CRYSTALLIN HOMOLOG', 245996),
(362340, 'PTHR48075:SF3', NULL, NULL, NULL, NULL, '3-HYDROXYACYL-COA DEHYDROGENASE', 245996),
(362341, 'PTHR48075:SF5', NULL, NULL, NULL, NULL, '3-HYDROXYACYL-COA DEHYDROGENASE FAMILY PROTEIN', 245996),
(362342, 'PTHR48075:SF7', NULL, NULL, NULL, NULL, '3-HYDROXYACYL-COA DEHYDROGENASE-RELATED', 245996),
(362343, 'PTHR36353', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 245997),
(362344, 'PTHR36353:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 245997),
(362345, 'PTHR15678:SF15', NULL, NULL, NULL, NULL, 'PROTEIN FMP27, MITOCHONDRIAL', 245998),
(362346, 'PTHR15678:SF11', NULL, NULL, NULL, NULL, 'FMP27, GFWDK DOMAIN-CONTAINING PROTEIN-RELATED', 245998),
(362347, 'PTHR15678:SF6', NULL, NULL, NULL, NULL, 'PROTEIN KIAA0100', 245998),
(362348, 'PTHR15678:SF13', NULL, NULL, NULL, NULL, 'FMP27_GFWDK DOMAIN-CONTAINING PROTEIN', 245998),
(362349, 'PTHR15678:SF14', NULL, NULL, NULL, NULL, 'FMP27_GFWDK DOMAIN-CONTAINING PROTEIN', 245998),
(362350, 'PTHR15678:SF8', NULL, NULL, NULL, NULL, 'PROTEIN KINKY POLLEN', 245998),
(362351, 'PTHR15678:SF10', NULL, NULL, NULL, NULL, 'LOCALIZATION AND RNA POL II PROMOTER FMP27 DOMAIN PROTEIN', 245998),
(362352, 'PTHR15678', NULL, NULL, NULL, NULL, 'ANTIGEN MLAA-22-RELATED', 245998),
(362353, 'PTHR36331', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN', 245999),
(362354, 'PTHR36331:SF2', NULL, NULL, NULL, NULL, '', 245999),
(362355, 'PTHR36331:SF1', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN', 245999),
(362356, 'PTHR16489:SF11', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 15B', 246000),
(362357, 'PTHR16489:SF12', NULL, NULL, NULL, NULL, 'GH11727P', 246000),
(362358, 'PTHR16489:SF14', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 15A', 246000),
(362359, 'PTHR16489', NULL, NULL, NULL, NULL, 'GH11727P', 246000);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(362360, 'PTHR43280:SF20', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR ADIY-RELATED', 246001),
(362361, 'PTHR43280:SF10', NULL, NULL, NULL, NULL, 'ARAC/XYLS FAMILY REGULATOR-RELATED', 246001),
(362362, 'PTHR43280:SF19', NULL, NULL, NULL, NULL, '4-HYDROXYPHENYLACETATE CATABOLISM PROTEIN', 246001),
(362363, 'PTHR43280', NULL, NULL, NULL, NULL, 'ARAC-FAMILY TRANSCRIPTIONAL REGULATOR', 246001),
(362364, 'PTHR43280:SF9', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR EXSA', 246001),
(362365, 'PTHR43280:SF13', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL ACTIVATOR RHAR', 246001),
(362366, 'PTHR43280:SF6', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL ACTIVATOR RHAS', 246001),
(362367, 'PTHR43280:SF25', NULL, NULL, NULL, NULL, 'ARABINOSE OPERON REGULATORY PROTEIN', 246001),
(362368, 'PTHR43280:SF14', NULL, NULL, NULL, NULL, 'MELIBIOSE OPERON REGULATORY PROTEIN', 246001),
(362369, 'PTHR43280:SF11', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 246001),
(362370, 'PTHR43280:SF12', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR CHBR', 246001),
(362371, 'PTHR43280:SF17', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REGULATOR, ARAC FAMILY-RELATED', 246001),
(362372, 'PTHR43280:SF2', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL TRANSCRIPTIONAL ACTIVATOR/DNA REPAIR ENZYME ADAA', 246001),
(362373, 'PTHR43280:SF26', NULL, NULL, NULL, NULL, 'ARAC-FAMILY TRANSCRIPTIONAL REGULATOR', 246001),
(362374, 'PTHR43280:SF15', NULL, NULL, NULL, NULL, 'RCS-SPECIFIC HTH-TYPE TRANSCRIPTIONAL ACTIVATOR RCLR', 246001),
(362375, 'PTHR43280:SF1', NULL, NULL, NULL, NULL, 'ARAC-FAMILY TRANSCRIPTIONAL REGULATOR', 246001),
(362376, 'PTHR43211:SF1', NULL, NULL, NULL, NULL, 'BLL6422 PROTEIN', 246002),
(362377, 'PTHR43211', NULL, NULL, NULL, NULL, 'FUMARYLACETOACETATE HYDROLASE', 246002),
(362378, 'PTHR43671', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NEK', 246003),
(362379, 'PTHR43671:SF103', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 246003),
(362380, 'PTHR43671:SF35', NULL, NULL, NULL, NULL, 'KINASE A, PUTATIVE-RELATED', 246003),
(362381, 'PTHR43671:SF104', NULL, NULL, NULL, NULL, 'NIMA-RELATED KINASE 1-RELATED', 246003),
(362382, 'PTHR43671:SF13', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NEK2', 246003),
(362383, 'PTHR43671:SF101', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 246003),
(362384, 'PTHR43671:SF102', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 246003),
(362385, 'PTHR43671:SF98', NULL, NULL, NULL, NULL, 'NIMA-LIKE KINASE', 246003),
(362386, 'PTHR43671:SF76', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NEK7', 246003),
(362387, 'PTHR43671:SF97', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NEK4', 246003),
(362388, 'PTHR43671:SF75', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246003),
(362389, 'PTHR43671:SF55', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NEK2', 246003),
(362390, 'PTHR43671:SF99', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246003),
(362391, 'PTHR43671:SF94', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NEK6', 246003),
(362392, 'PTHR43671:SF93', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NEK4', 246003),
(362393, 'PTHR43671:SF71', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NEK3', 246003),
(362394, 'PTHR43671:SF74', NULL, NULL, NULL, NULL, 'KINASE NEK1, PUTATIVE-RELATED', 246003),
(362395, 'PTHR43671:SF96', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246003),
(362396, 'PTHR43671:SF73', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NEK2', 246003),
(362397, 'PTHR43671:SF95', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246003),
(362398, 'PTHR43671:SF90', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246003),
(362399, 'PTHR43671:SF100', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246003),
(362400, 'PTHR43671:SF92', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NEK10', 246003); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(362401, 'PTHR43671:SF91', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246003),
(362402, 'PTHR43671:SF68', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246003),
(362403, 'PTHR43671:SF24', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NEK11', 246003),
(362404, 'PTHR43671:SF87', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NEK1', 246003),
(362405, 'PTHR43671:SF86', NULL, NULL, NULL, NULL, 'KINASE', 246003),
(362406, 'PTHR43671:SF89', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 246003),
(362407, 'PTHR43671:SF45', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NEK1-RELATED', 246003),
(362408, 'PTHR43671:SF66', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NEK2', 246003),
(362409, 'PTHR43671:SF88', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-KINASE NEK7-LIKE PROTEIN', 246003),
(362410, 'PTHR43671:SF61', NULL, NULL, NULL, NULL, 'BNAANNG10650D PROTEIN', 246003),
(362411, 'PTHR43671:SF82', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246003),
(362412, 'PTHR43671:SF85', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 246003),
(362413, 'PTHR43671:SF63', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NEK6', 246003),
(362414, 'PTHR43671:SF41', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 246003),
(362415, 'PTHR43671:SF84', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NEK11', 246003),
(362416, 'PTHR43671:SF81', NULL, NULL, NULL, NULL, 'PROTEIN KINASE, PUTATIVE-RELATED', 246003),
(362417, 'PTHR46660:SF2', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE 1 DOMAIN-CONTAINING PROTEIN 1', 246004),
(362418, 'PTHR46660', NULL, NULL, NULL, NULL, '', 246004),
(362419, 'PTHR46763:SF1', NULL, NULL, NULL, NULL, 'DYNEIN REGULATORY COMPLEX PROTEIN 8', 246005),
(362420, 'PTHR46763', NULL, NULL, NULL, NULL, 'DYNEIN REGULATORY COMPLEX PROTEIN 8', 246005),
(362421, 'PTHR47724:SF1', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP26-2, CHLOROPLASTIC', 246006),
(362422, 'PTHR47724', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP26-2, CHLOROPLASTIC', 246006),
(362423, 'PTHR10024:SF180', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN-9', 246007),
(362424, 'PTHR10024:SF362', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN BETA, ISOFORM D', 246007),
(362425, 'PTHR10024:SF282', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN-5', 246007),
(362426, 'PTHR10024:SF360', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN', 246007),
(362427, 'PTHR10024:SF366', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN-7', 246007),
(362428, 'PTHR10024:SF344', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN 7, ISOFORM A', 246007),
(362429, 'PTHR10024:SF124', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN VB', 246007),
(362430, 'PTHR10024:SF223', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN-2', 246007),
(362431, 'PTHR10024:SF363', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN VIIA', 246007),
(362432, 'PTHR10024:SF221', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN', 246007),
(362433, 'PTHR10024:SF364', NULL, NULL, NULL, NULL, 'PROTEIN CBG19188', 246007),
(362434, 'PTHR10024:SF369', NULL, NULL, NULL, NULL, 'FI18813P1', 246007),
(362435, 'PTHR10024:SF249', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN-8', 246007),
(362436, 'PTHR10024:SF227', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN 1', 246007),
(362437, 'PTHR10024:SF348', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN-17', 246007),
(362438, 'PTHR10024:SF203', NULL, NULL, NULL, NULL, '', 246007),
(362439, 'PTHR10024:SF368', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 246007),
(362440, 'PTHR10024', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN', 246007),
(362441, 'PTHR10024:SF372', NULL, NULL, NULL, NULL, '', 246007),
(362442, 'PTHR10024:SF45', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN-6', 246007),
(362443, 'PTHR10024:SF252', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN-12', 246007),
(362444, 'PTHR10024:SF373', NULL, NULL, NULL, NULL, 'MIP05618P', 246007),
(362445, 'PTHR10024:SF175', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 246007),
(362446, 'PTHR10024:SF351', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 246007);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(362447, 'PTHR10024:SF370', NULL, NULL, NULL, NULL, 'PROTEIN CLARINET', 246007),
(362448, 'PTHR10024:SF46', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN-10', 246007),
(362449, 'PTHR10024:SF371', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN IXB', 246007),
(362450, 'PTHR10024:SF250', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN-13', 246007),
(362451, 'PTHR10024:SF234', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN-15', 246007),
(362452, 'PTHR10024:SF374', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN 1-LIKE PROTEIN', 246007),
(362453, 'PTHR10024:SF176', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN-3', 246007),
(362454, 'PTHR10024:SF352', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN 2', 246007),
(362455, 'PTHR10024:SF114', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN-4', 246007),
(362456, 'PTHR10024:SF115', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN-11', 246007),
(362457, 'PTHR10024:SF217', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN VA', 246007),
(362458, 'PTHR10024:SF239', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN-1', 246007),
(362459, 'PTHR34589:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER TRANSLOCATION-ASSOCIATED PROTEIN', 246008),
(362460, 'PTHR34589:SF1', NULL, NULL, NULL, NULL, 'SPINDLIN INTERACTOR AND REPRESSOR OF CHROMATIN-BINDING PROTEIN', 246008),
(362461, 'PTHR34589', NULL, NULL, NULL, NULL, 'SIMILAR TO RIKEN CDNA 2700081O15', 246008),
(362462, 'PTHR22534', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 246009),
(362463, 'PTHR22534:SF5', NULL, NULL, NULL, NULL, '', 246009),
(362464, 'PTHR10891:SF937', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML47-RELATED', 246010),
(362465, 'PTHR10891:SF815', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML35-RELATED', 246010),
(362466, 'PTHR10891:SF936', NULL, NULL, NULL, NULL, '', 246010),
(362467, 'PTHR10891:SF814', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML27-RELATED', 246010),
(362468, 'PTHR10891:SF819', NULL, NULL, NULL, NULL, '', 246010),
(362469, 'PTHR10891:SF939', NULL, NULL, NULL, NULL, 'EF HAND CALCIUM-BINDING FAMILY PROTEIN', 246010),
(362470, 'PTHR10891:SF938', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML30-RELATED', 246010),
(362471, 'PTHR10891:SF817', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML23-RELATED', 246010),
(362472, 'PTHR10891:SF893', NULL, NULL, NULL, NULL, 'CALMODULIN-LIKE PROTEIN 3', 246010),
(362473, 'PTHR10891:SF530', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML44-RELATED', 246010),
(362474, 'PTHR10891:SF933', NULL, NULL, NULL, NULL, 'BNACNNG15180D PROTEIN', 246010),
(362475, 'PTHR10891:SF931', NULL, NULL, NULL, NULL, 'CALMODULIN-LIKE PROTEIN 5', 246010),
(362476, 'PTHR10891:SF898', NULL, NULL, NULL, NULL, 'BNAA04G11660D PROTEIN', 246010),
(362477, 'PTHR10891:SF897', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 246010),
(362478, 'PTHR10891:SF930', NULL, NULL, NULL, NULL, 'EF HAND CALCIUM-BINDING FAMILY PROTEIN', 246010),
(362479, 'PTHR10891:SF892', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML29-RELATED', 246010),
(362480, 'PTHR10891:SF891', NULL, NULL, NULL, NULL, 'BNAA09G02460D PROTEIN', 246010),
(362481, 'PTHR10891:SF890', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN PAIR-RELATED', 246010),
(362482, 'PTHR10891:SF926', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML23-RELATED', 246010),
(362483, 'PTHR10891:SF805', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML45-RELATED', 246010),
(362484, 'PTHR10891:SF804', NULL, NULL, NULL, NULL, 'OS03G0813500 PROTEIN', 246010),
(362485, 'PTHR10891:SF924', NULL, NULL, NULL, NULL, 'BNAC03G35300D PROTEIN', 246010),
(362486, 'PTHR10891:SF802', NULL, NULL, NULL, NULL, 'CALMODULIN-LIKE PROTEIN 3', 246010),
(362487, 'PTHR10891:SF809', NULL, NULL, NULL, NULL, 'CALMODULIN-LIKE PROTEIN 4', 246010),
(362488, 'PTHR10891:SF806', NULL, NULL, NULL, NULL, 'BNAC02G24190D PROTEIN', 246010),
(362489, 'PTHR10891:SF927', NULL, NULL, NULL, NULL, 'BNAC03G30220D PROTEIN', 246010),
(362490, 'PTHR10891:SF885', NULL, NULL, NULL, NULL, 'CALCIUM BINDING PROTEIN 2-RELATED', 246010),
(362491, 'PTHR10891:SF884', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF-HAND FAMILY PROTEIN', 246010),
(362492, 'PTHR10891:SF883', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF-HAND FAMILY PROTEIN-RELATED', 246010);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(362493, 'PTHR10891:SF922', NULL, NULL, NULL, NULL, 'EF HAND CALCIUM-BINDING FAMILY PROTEIN', 246010),
(362494, 'PTHR10891:SF801', NULL, NULL, NULL, NULL, 'CALMODULIN-LIKE PROTEIN 30', 246010),
(362495, 'PTHR10891:SF920', NULL, NULL, NULL, NULL, 'EF HAND CALCIUM-BINDING FAMILY PROTEIN', 246010),
(362496, 'PTHR10891:SF880', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN PAIR-RELATED', 246010),
(362497, 'PTHR10891', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING DOMAIN CONTAINING PROTEIN', 246010),
(362498, 'PTHR10891:SF915', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN PAIR-RELATED', 246010),
(362499, 'PTHR10891:SF913', NULL, NULL, NULL, NULL, 'CALMODULIN-LIKE PROTEIN 3', 246010),
(362500, 'PTHR10891:SF879', NULL, NULL, NULL, NULL, 'BNAC04G31730D PROTEIN', 246010),
(362501, 'PTHR10891:SF918', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN 2', 246010),
(362502, 'PTHR10891:SF917', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING ALLERGEN OLE E 8-LIKE', 246010),
(362503, 'PTHR10891:SF916', NULL, NULL, NULL, NULL, 'CALMODULIN', 246010),
(362504, 'PTHR10891:SF994', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML10-RELATED', 246010),
(362505, 'PTHR10891:SF993', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML26-RELATED', 246010),
(362506, 'PTHR10891:SF871', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN PAIR-RELATED', 246010),
(362507, 'PTHR10891:SF992', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN PAIR-RELATED', 246010),
(362508, 'PTHR10891:SF635', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML15-RELATED', 246010),
(362509, 'PTHR10891:SF756', NULL, NULL, NULL, NULL, 'EF HAND FAMILY PROTEIN, EXPRESSED', 246010),
(362510, 'PTHR10891:SF876', NULL, NULL, NULL, NULL, 'BNAA02G17640D PROTEIN', 246010),
(362511, 'PTHR10891:SF991', NULL, NULL, NULL, NULL, 'BNAA01G34390D PROTEIN', 246010),
(362512, 'PTHR10891:SF990', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML28-RELATED', 246010),
(362513, 'PTHR10891:SF909', NULL, NULL, NULL, NULL, 'BNAC04G01850D PROTEIN', 246010),
(362514, 'PTHR10891:SF903', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML43-RELATED', 246010),
(362515, 'PTHR10891:SF869', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING ALLERGEN OLE E', 246010),
(362516, 'PTHR10891:SF989', NULL, NULL, NULL, NULL, '', 246010),
(362517, 'PTHR10891:SF747', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML38', 246010),
(362518, 'PTHR10891:SF908', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML25/26-RELATED', 246010),
(362519, 'PTHR10891:SF906', NULL, NULL, NULL, NULL, '', 246010),
(362520, 'PTHR10891:SF905', NULL, NULL, NULL, NULL, 'CALMODULIN-LIKE PROTEIN 3', 246010),
(362521, 'PTHR10891:SF984', NULL, NULL, NULL, NULL, 'CALMODULIN', 246010),
(362522, 'PTHR10891:SF983', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN PAIR-RELATED', 246010),
(362523, 'PTHR10891:SF982', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN PAIR-RELATED', 246010),
(362524, 'PTHR10891:SF981', NULL, NULL, NULL, NULL, '', 246010),
(362525, 'PTHR10891:SF746', NULL, NULL, NULL, NULL, 'OS05G0147300 PROTEIN', 246010),
(362526, 'PTHR10891:SF988', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 246010),
(362527, 'PTHR10891:SF745', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML46-RELATED', 246010),
(362528, 'PTHR10891:SF987', NULL, NULL, NULL, NULL, 'FLAGELLAR CALCIUM-BINDING PROTEIN', 246010),
(362529, 'PTHR10891:SF866', NULL, NULL, NULL, NULL, 'CALMODULIN-LIKE PROTEIN 6-RELATED', 246010),
(362530, 'PTHR10891:SF986', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING ALLERGEN BET V 3-RELATED', 246010),
(362531, 'PTHR10891:SF985', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML25-RELATED', 246010),
(362532, 'PTHR10891:SF743', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML42', 246010),
(362533, 'PTHR10891:SF980', NULL, NULL, NULL, NULL, 'BNAANNG10070D PROTEIN', 246010),
(362534, 'PTHR10891:SF979', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML39', 246010),
(362535, 'PTHR10891:SF978', NULL, NULL, NULL, NULL, 'OS12G0138050 PROTEIN', 246010),
(362536, 'PTHR10891:SF973', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML22-RELATED', 246010);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(362537, 'PTHR10891:SF972', NULL, NULL, NULL, NULL, 'OS09G0458800 PROTEIN', 246010),
(362538, 'PTHR10891:SF851', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML45-RELATED', 246010),
(362539, 'PTHR10891:SF971', NULL, NULL, NULL, NULL, 'POLCALCIN JUN O', 246010),
(362540, 'PTHR10891:SF970', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 246010),
(362541, 'PTHR10891:SF856', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN PAIR-RELATED', 246010),
(362542, 'PTHR10891:SF977', NULL, NULL, NULL, NULL, 'SLR0366 PROTEIN', 246010),
(362543, 'PTHR10891:SF976', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML31-RELATED', 246010),
(362544, 'PTHR10891:SF975', NULL, NULL, NULL, NULL, 'ZF_RING DOMAIN-CONTAINING PROTEIN', 246010),
(362545, 'PTHR10891:SF854', NULL, NULL, NULL, NULL, 'BNAANNG17220D PROTEIN', 246010),
(362546, 'PTHR10891:SF974', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF-HAND FAMILY PROTEIN-RELATED', 246010),
(362547, 'PTHR10891:SF849', NULL, NULL, NULL, NULL, '', 246010),
(362548, 'PTHR10891:SF969', NULL, NULL, NULL, NULL, 'ION BINDING PROTEIN, PUTATIVE-RELATED', 246010),
(362549, 'PTHR10891:SF847', NULL, NULL, NULL, NULL, 'BNAA04G25000D PROTEIN', 246010),
(362550, 'PTHR10891:SF968', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML33-RELATED', 246010),
(362551, 'PTHR10891:SF967', NULL, NULL, NULL, NULL, 'CENTRIN-1-LIKE', 246010),
(362552, 'PTHR10891:SF846', NULL, NULL, NULL, NULL, 'CALMODULIN-LIKE PROTEIN 2', 246010),
(362553, 'PTHR10891:SF962', NULL, NULL, NULL, NULL, 'EF HAND CALCIUM-BINDING FAMILY PROTEIN', 246010),
(362554, 'PTHR10891:SF840', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML29-RELATED', 246010),
(362555, 'PTHR10891:SF961', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF-HAND PROTEIN', 246010),
(362556, 'PTHR10891:SF685', NULL, NULL, NULL, NULL, 'EF-HAND PAIR PROTEIN', 246010),
(362557, 'PTHR10891:SF960', NULL, NULL, NULL, NULL, 'POLCALCIN NIC T 1', 246010),
(362558, 'PTHR10891:SF845', NULL, NULL, NULL, NULL, 'BNAC03G63910D PROTEIN', 246010),
(362559, 'PTHR10891:SF966', NULL, NULL, NULL, NULL, 'EF HAND FAMILY PROTEIN', 246010),
(362560, 'PTHR10891:SF965', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN PAIR-RELATED', 246010),
(362561, 'PTHR10891:SF964', NULL, NULL, NULL, NULL, '', 246010),
(362562, 'PTHR10891:SF963', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML27-RELATED', 246010),
(362563, 'PTHR10891:SF959', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML44-RELATED', 246010),
(362564, 'PTHR10891:SF958', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN PAIR-RELATED', 246010),
(362565, 'PTHR10891:SF957', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML47-RELATED', 246010),
(362566, 'PTHR10891:SF835', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML38', 246010),
(362567, 'PTHR10891:SF956', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML35-RELATED', 246010),
(362568, 'PTHR10891:SF951', NULL, NULL, NULL, NULL, 'OS07G0631700 PROTEIN', 246010),
(362569, 'PTHR10891:SF796', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML30-RELATED', 246010),
(362570, 'PTHR10891:SF795', NULL, NULL, NULL, NULL, 'EF HAND CALCIUM-BINDING FAMILY PROTEIN', 246010),
(362571, 'PTHR10891:SF794', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML23-RELATED', 246010),
(362572, 'PTHR10891:SF834', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML30-RELATED', 246010),
(362573, 'PTHR10891:SF833', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML31-RELATED', 246010),
(362574, 'PTHR10891:SF798', NULL, NULL, NULL, NULL, 'EF HAND CALCIUM-BINDING FAMILY PROTEIN', 246010),
(362575, 'PTHR10891:SF947', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML25-RELATED', 246010),
(362576, 'PTHR10891:SF826', NULL, NULL, NULL, NULL, '', 246010),
(362577, 'PTHR10891:SF945', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML26-RELATED', 246010),
(362578, 'PTHR10891:SF828', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML21-RELATED', 246010),
(362579, 'PTHR10891:SF785', NULL, NULL, NULL, NULL, 'EF HAND FAMILY PROTEIN', 246010),
(362580, 'PTHR10891:SF944', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML12-RELATED', 246010);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(362581, 'PTHR10891:SF943', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML36-RELATED', 246010),
(362582, 'PTHR10891:SF781', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML20-RELATED', 246010),
(362583, 'PTHR10891:SF780', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML24', 246010),
(362584, 'PTHR43180:SF60', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE REDUCTASE 3A-LIKE', 246011),
(362585, 'PTHR43180:SF61', NULL, NULL, NULL, NULL, 'SHORT CHAIN ALCOHOL DEHYDROGENASE', 246011),
(362586, 'PTHR43180:SF63', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE FAMILY PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G03520)-RELATED', 246011),
(362587, 'PTHR43180:SF66', NULL, NULL, NULL, NULL, '3-OXOACYL-(ACYL-CARRIER-PROTEIN) REDUCTASE (AFU_ORTHOLOGUE AFUA_6G11210)', 246011),
(362588, 'PTHR43180:SF67', NULL, NULL, NULL, NULL, 'SECOISOLARICIRESINOL DEHYDROGENASE-LIKE', 246011),
(362589, 'PTHR43180:SF69', NULL, NULL, NULL, NULL, 'SHORT CHAIN ALCOHOL DEHYDROGENASE', 246011),
(362590, 'PTHR43180:SF28', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 246011),
(362591, 'PTHR43180:SF70', NULL, NULL, NULL, NULL, 'GLUCOSE/RIBITOL DEHYDROGENASE-RELATED', 246011),
(362592, 'PTHR43180:SF31', NULL, NULL, NULL, NULL, 'CHAIN DEHYDROGENASE/REDUCTASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G16570)-RELATED', 246011),
(362593, 'PTHR43180:SF75', NULL, NULL, NULL, NULL, 'CHAIN ALCOHOL DEHYDROGENASE, PUTATIVE-RELATED', 246011),
(362594, 'PTHR43180:SF30', NULL, NULL, NULL, NULL, 'MOMILACTONE A SYNTHASE', 246011),
(362595, 'PTHR43180:SF74', NULL, NULL, NULL, NULL, 'SHORT CHAIN ALCOHOL DEHYDROGENASE', 246011),
(362596, 'PTHR43180:SF9', NULL, NULL, NULL, NULL, 'TETRAHYDROXYNAPHTHALENE REDUCTASE', 246011),
(362597, 'PTHR43180:SF33', NULL, NULL, NULL, NULL, 'CHAIN DEHYDROGENASE/REDUCTASE, PUTATIVE-RELATED', 246011),
(362598, 'PTHR43180:SF77', NULL, NULL, NULL, NULL, 'CHAIN ALCOHOL DEHYDROGENASE, PUTATIVE-RELATED', 246011),
(362599, 'PTHR43180:SF76', NULL, NULL, NULL, NULL, 'BNAA06G32670D PROTEIN', 246011),
(362600, 'PTHR43180:SF35', NULL, NULL, NULL, NULL, 'OS07G0663600 PROTEIN', 246011),
(362601, 'PTHR43180:SF3', NULL, NULL, NULL, NULL, 'SHORT CHAIN DEHYDROGENASE MDPC-RELATED', 246011),
(362602, 'PTHR43180:SF78', NULL, NULL, NULL, NULL, 'SHORT CHAIN ALCOHOL DEHYDROGENASE', 246011),
(362603, 'PTHR43180:SF34', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 246011),
(362604, 'PTHR43180:SF37', NULL, NULL, NULL, NULL, 'SECOISOLARICIRESINOL DEHYDROGENASE-LIKE', 246011),
(362605, 'PTHR43180:SF38', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 246011),
(362606, 'PTHR43180:SF80', NULL, NULL, NULL, NULL, '', 246011),
(362607, 'PTHR43180:SF81', NULL, NULL, NULL, NULL, 'MOMILACTONE A SYNTHASE-LIKE', 246011),
(362608, 'PTHR43180:SF40', NULL, NULL, NULL, NULL, '', 246011),
(362609, 'PTHR43180:SF42', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE REDUCTASE ATA1', 246011),
(362610, 'PTHR43180:SF86', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G00290)-RELATED', 246011),
(362611, 'PTHR43180:SF41', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE REDUCTASE 2A', 246011),
(362612, 'PTHR43180', NULL, NULL, NULL, NULL, '3-OXOACYL-(ACYL-CARRIER-PROTEIN) REDUCTASE (AFU_ORTHOLOGUE AFUA_6G11210)', 246011),
(362613, 'PTHR43180:SF44', NULL, NULL, NULL, NULL, 'SEX DETERMINATION PROTEIN TASSELSEED-2', 246011),
(362614, 'PTHR43180:SF87', NULL, NULL, NULL, NULL, 'SHORT CHAIN ALCOHOL DEHYDROGENASE', 246011),
(362615, 'PTHR43180:SF46', NULL, NULL, NULL, NULL, '', 246011),
(362616, 'PTHR43180:SF45', NULL, NULL, NULL, NULL, 'SECOISOLARICIRESINOL DEHYDROGENASE-LIKE', 246011),
(362617, 'PTHR43180:SF89', NULL, NULL, NULL, NULL, 'SHORT CHAIN ALCOHOL DEHYDROGENASE', 246011),
(362618, 'PTHR43180:SF48', NULL, NULL, NULL, NULL, 'CHAIN ALCOHOL DEHYDROGENASE, PUTATIVE-RELATED', 246011),
(362619, 'PTHR43180:SF47', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 246011),
(362620, 'PTHR43180:SF49', NULL, NULL, NULL, NULL, 'SECOISOLARICIRESINOL DEHYDROGENASE-LIKE', 246011);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(362621, 'PTHR43180:SF100', NULL, NULL, NULL, NULL, 'GLUCOSE/RIBITOL DEHYDROGENASE-RELATED', 246011),
(362622, 'PTHR43180:SF91', NULL, NULL, NULL, NULL, '', 246011),
(362623, 'PTHR43180:SF90', NULL, NULL, NULL, NULL, 'TROPINONE REDUCTASE-LIKE 1', 246011),
(362624, 'PTHR43180:SF93', NULL, NULL, NULL, NULL, 'SHORT CHAIN ALCOHOL DEHYDROGENASE', 246011),
(362625, 'PTHR43180:SF92', NULL, NULL, NULL, NULL, 'SECOISOLARICIRESINOL DEHYDROGENASE-LIKE', 246011),
(362626, 'PTHR43180:SF95', NULL, NULL, NULL, NULL, 'OS07G0691600 PROTEIN', 246011),
(362627, 'PTHR43180:SF50', NULL, NULL, NULL, NULL, 'SHORT CHAIN DEHYDROGENASE', 246011),
(362628, 'PTHR43180:SF94', NULL, NULL, NULL, NULL, 'OS07G0665000 PROTEIN', 246011),
(362629, 'PTHR43180:SF53', NULL, NULL, NULL, NULL, 'XANTHOXIN DEHYDROGENASE', 246011),
(362630, 'PTHR43180:SF97', NULL, NULL, NULL, NULL, 'SECOISOLARICIRESINOL DEHYDROGENASE-LIKE', 246011),
(362631, 'PTHR43180:SF96', NULL, NULL, NULL, NULL, '', 246011),
(362632, 'PTHR43180:SF52', NULL, NULL, NULL, NULL, 'OS07G0664400 PROTEIN', 246011),
(362633, 'PTHR43180:SF55', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE-LIKE PROTEIN', 246011),
(362634, 'PTHR43180:SF11', NULL, NULL, NULL, NULL, '', 246011),
(362635, 'PTHR43180:SF99', NULL, NULL, NULL, NULL, 'SECOISOLARICIRESINOL DEHYDROGENASE-LIKE', 246011),
(362636, 'PTHR43180:SF54', NULL, NULL, NULL, NULL, '', 246011),
(362637, 'PTHR43180:SF98', NULL, NULL, NULL, NULL, 'SECOISOLARICIRESINOL DEHYDROGENASE-LIKE', 246011),
(362638, 'PTHR43180:SF10', NULL, NULL, NULL, NULL, '', 246011),
(362639, 'PTHR43180:SF57', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE-LIKE PROTEIN', 246011),
(362640, 'PTHR43180:SF16', NULL, NULL, NULL, NULL, 'BACILYSIN BIOSYNTHESIS OXIDOREDUCTASE BACC', 246011),
(362641, 'PTHR20933', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 33', 246012),
(362642, 'PTHR20933:SF4', NULL, NULL, NULL, NULL, 'F-BOX INVOLVED IN POLYQ PATHOGENESIS, ISOFORM A', 246012),
(362643, 'PTHR20933:SF3', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 33', 246012),
(362644, 'PTHR39456:SF1', NULL, NULL, NULL, NULL, '', 246013),
(362645, 'PTHR39456', NULL, NULL, NULL, NULL, '', 246013),
(362646, 'PTHR46243:SF4', NULL, NULL, NULL, NULL, 'BIS(5''-ADENOSYL)-TRIPHOSPHATASE', 246014),
(362647, 'PTHR46243:SF5', NULL, NULL, NULL, NULL, 'BIS(5''-ADENOSYL)-TRIPHOSPHATASE', 246014),
(362648, 'PTHR46243', NULL, NULL, NULL, NULL, 'BIS(5''-ADENOSYL)-TRIPHOSPHATASE', 246014),
(362649, 'PTHR46243:SF1', NULL, NULL, NULL, NULL, 'BIS(5''-ADENOSYL)-TRIPHOSPHATASE', 246014),
(362650, 'PTHR10170', NULL, NULL, NULL, NULL, 'HUNTINGTON DISEASE PROTEIN', 246015),
(362651, 'PTHR10170:SF10', NULL, NULL, NULL, NULL, 'HUNTINGTIN', 246015),
(362652, 'PTHR28681', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 196', 246016),
(362653, 'PTHR28681:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 196', 246016),
(362654, 'PTHR24192:SF3', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 246017),
(362655, 'PTHR24192', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN 40', 246017),
(362656, 'PTHR24192:SF2', NULL, NULL, NULL, NULL, 'ANKRD40 C-TERMINAL-LIKE PROTEIN-RELATED', 246017),
(362657, 'PTHR24192:SF1', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 40', 246017),
(362658, 'PTHR10328', NULL, NULL, NULL, NULL, 'PROTEIN MAX  MYC-ASSOCIATED FACTOR X', 246018),
(362659, 'PTHR10328:SF13', NULL, NULL, NULL, NULL, 'MAX-LIKE PROTEIN X', 246018),
(362660, 'PTHR10328:SF12', NULL, NULL, NULL, NULL, 'CARBOHYDRATE-RESPONSIVE ELEMENT-BINDING PROTEIN', 246018),
(362661, 'PTHR10328:SF11', NULL, NULL, NULL, NULL, 'MAX-LIKE PROTEIN X', 246018),
(362662, 'PTHR10328:SF10', NULL, NULL, NULL, NULL, 'MAX-LIKE PROTEIN 1', 246018),
(362663, 'PTHR10328:SF3', NULL, NULL, NULL, NULL, 'PROTEIN MAX', 246018),
(362664, 'PTHR10328:SF15', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 246018),
(362665, 'PTHR10328:SF14', NULL, NULL, NULL, NULL, 'MLX-INTERACTING PROTEIN', 246018),
(362666, 'PTHR31312:SF13', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB-HB-LIKE FAMILY-RELATED', 246019);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(362667, 'PTHR31312', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ACTIVATOR GLK1', 246019),
(362668, 'PTHR31312:SF9', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ACTIVATOR GLK2', 246019),
(362669, 'PTHR31312:SF10', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ACTIVATOR GLK1-LIKE ISOFORM X1', 246019),
(362670, 'PTHR31312:SF7', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 246019),
(362671, 'PTHR31312:SF6', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR-APRR2-LIKE PROTEIN', 246019),
(362672, 'PTHR31312:SF4', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR-LIKE APRR2', 246019),
(362673, 'PTHR31312:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GLK1-RELATED', 246019),
(362674, 'PTHR31312:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ACTIVATOR GLK1', 246019),
(362675, 'PTHR31312:SF14', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR-LIKE APRR2 ISOFORM X1', 246019),
(362676, 'PTHR15029:SF0', NULL, NULL, NULL, NULL, 'CAMPATH-1 ANTIGEN', 246020),
(362677, 'PTHR15029', NULL, NULL, NULL, NULL, 'CAMPATH-1 ANTIGEN', 246020),
(362678, 'PTHR45711', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN', 246021),
(362679, 'PTHR45711:SF3', NULL, NULL, NULL, NULL, 'CLC CHANNEL', 246021),
(362680, 'PTHR45711:SF10', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN', 246021),
(362681, 'PTHR45711:SF2', NULL, NULL, NULL, NULL, 'H(+)/CL(-) EXCHANGE TRANSPORTER 4', 246021),
(362682, 'PTHR45711:SF8', NULL, NULL, NULL, NULL, 'H(+)/CL(-) EXCHANGE TRANSPORTER 3', 246021),
(362683, 'PTHR45711:SF7', NULL, NULL, NULL, NULL, 'H(+)/CL(-) EXCHANGE TRANSPORTER 5', 246021),
(362684, 'PTHR45711:SF6', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN', 246021),
(362685, 'PTHR45711:SF9', NULL, NULL, NULL, NULL, 'ANION/PROTON EXCHANGE TRANSPORTER GEF1', 246021),
(362686, 'PTHR20838', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 86', 246022),
(362687, 'PTHR20838:SF0', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 86', 246022),
(362688, 'PTHR11610:SF178', NULL, NULL, NULL, NULL, 'LD47264P', 246023),
(362689, 'PTHR11610:SF179', NULL, NULL, NULL, NULL, 'AGAP001825-PA', 246023),
(362690, 'PTHR11610:SF159', NULL, NULL, NULL, NULL, 'TRIACYLGLYCEROL LIPASE', 246023),
(362691, 'PTHR11610:SF174', NULL, NULL, NULL, NULL, 'MIP30168P', 246023),
(362692, 'PTHR11610:SF175', NULL, NULL, NULL, NULL, 'LIPASE MEMBER H-A-LIKE PROTEIN', 246023),
(362693, 'PTHR11610:SF176', NULL, NULL, NULL, NULL, '', 246023),
(362694, 'PTHR11610:SF111', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1 MEMBER A', 246023),
(362695, 'PTHR11610:SF177', NULL, NULL, NULL, NULL, 'IP13478P-RELATED', 246023),
(362696, 'PTHR11610:SF171', NULL, NULL, NULL, NULL, 'LIPASE DOMAIN-CONTAINING PROTEIN-RELATED', 246023),
(362697, 'PTHR11610:SF172', NULL, NULL, NULL, NULL, 'LIPASE MEMBER H-A-LIKE PROTEIN', 246023),
(362698, 'PTHR11610:SF150', NULL, NULL, NULL, NULL, 'FI01825P-RELATED', 246023),
(362699, 'PTHR11610:SF151', NULL, NULL, NULL, NULL, 'LIPASE DOMAIN-CONTAINING PROTEIN', 246023),
(362700, 'PTHR11610:SF173', NULL, NULL, NULL, NULL, 'LIPASE DOMAIN-CONTAINING PROTEIN-RELATED', 246023),
(362701, 'PTHR11610:SF37', NULL, NULL, NULL, NULL, 'GH01208P', 246023),
(362702, 'PTHR11610:SF13', NULL, NULL, NULL, NULL, 'ENDOTHELIAL LIPASE', 246023),
(362703, 'PTHR11610:SF36', NULL, NULL, NULL, NULL, 'LIPASE DOMAIN-CONTAINING PROTEIN', 246023),
(362704, 'PTHR11610:SF3', NULL, NULL, NULL, NULL, 'LIPOPROTEIN LIPASE', 246023),
(362705, 'PTHR11610:SF12', NULL, NULL, NULL, NULL, 'LIPASE MEMBER H', 246023),
(362706, 'PTHR11610:SF2', NULL, NULL, NULL, NULL, 'HEPATIC TRIACYLGLYCEROL LIPASE', 246023),
(362707, 'PTHR11610', NULL, NULL, NULL, NULL, 'LIPASE', 246023),
(362708, 'PTHR11610:SF146', NULL, NULL, NULL, NULL, 'PLAT DOMAIN-CONTAINING PROTEIN', 246023),
(362709, 'PTHR11610:SF102', NULL, NULL, NULL, NULL, 'FI22312P1', 246023),
(362710, 'PTHR11610:SF103', NULL, NULL, NULL, NULL, 'LIPASE MEMBER I', 246023),
(362711, 'PTHR11610:SF169', NULL, NULL, NULL, NULL, 'GH15759P-RELATED', 246023),
(362712, 'PTHR11610:SF147', NULL, NULL, NULL, NULL, 'PANCREATIC TRIACYLGLYCEROL LIPASE', 246023); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(362713, 'PTHR11610:SF104', NULL, NULL, NULL, NULL, 'AGAP010328-PA', 246023),
(362714, 'PTHR11610:SF165', NULL, NULL, NULL, NULL, 'PANCREATIC LIPASE-RELATED PROTEIN 2', 246023),
(362715, 'PTHR11610:SF100', NULL, NULL, NULL, NULL, 'PANCREATIC LIPASE-RELATED PROTEIN 3', 246023),
(362716, 'PTHR11610:SF180', NULL, NULL, NULL, NULL, 'LIPASE DOMAIN-CONTAINING PROTEIN', 246023),
(362717, 'PTHR11610:SF149', NULL, NULL, NULL, NULL, 'FI01450P-RELATED', 246023),
(362718, 'PTHR11610:SF108', NULL, NULL, NULL, NULL, 'INACTIVE PANCREATIC LIPASE-RELATED PROTEIN 1', 246023),
(362719, 'PTHR46878', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN M1', 246024),
(362720, 'PTHR46878:SF1', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN M1', 246024),
(362721, 'PTHR11609:SF5', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLAMINOIMIDAZOLE CARBOXYLASE', 246025),
(362722, 'PTHR11609', NULL, NULL, NULL, NULL, 'PURINE BIOSYNTHESIS PROTEIN 6/7, PUR6/7', 246025),
(362723, 'PTHR11609:SF13', NULL, NULL, NULL, NULL, 'AIR CARBOXYLASE', 246025),
(362724, 'PTHR15995:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ZWILCH HOMOLOG', 246026),
(362725, 'PTHR15995', NULL, NULL, NULL, NULL, 'PROTEIN ZWILCH HOMOLOG', 246026),
(362726, 'PTHR47183', NULL, NULL, NULL, NULL, 'GLUCOSE-1-PHOSPHATE CYTIDYLYLTRANSFERASE-RELATED', 246027),
(362727, 'PTHR47183:SF3', NULL, NULL, NULL, NULL, 'TRANSFERASE-RELATED', 246027),
(362728, 'PTHR47183:SF2', NULL, NULL, NULL, NULL, 'GLUCOSE-1-PHOSPHATE CYTIDYLYLTRANSFERASE-RELATED', 246027),
(362729, 'PTHR47183:SF1', NULL, NULL, NULL, NULL, 'GLUCOSE-1-PHOSPHATE CYTIDYLYLTRANSFERASE', 246027),
(362730, 'PTHR12930:SF8', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 246028),
(362731, 'PTHR12930:SF10', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246028),
(362732, 'PTHR12930:SF1', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 113B', 246028),
(362733, 'PTHR12930:SF0', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 113A1-RELATED', 246028),
(362734, 'PTHR12930', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 183', 246028),
(362735, 'PTHR12930:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF113A', 246028),
(362736, 'PTHR47472', NULL, NULL, NULL, NULL, 'PROPIONYL-COA CARBOXYLASE', 246029),
(362737, 'PTHR47472:SF1', NULL, NULL, NULL, NULL, 'PROPIONYL-COA CARBOXYLASE', 246029),
(362738, 'PTHR47420:SF2', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE', 246030),
(362739, 'PTHR47420:SF3', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE ASHR2', 246030),
(362740, 'PTHR47420', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE ASHR2', 246030),
(362741, 'PTHR45757', NULL, NULL, NULL, NULL, 'PROTEIN CBG23364-RELATED', 246031),
(362742, 'PTHR45757:SF2', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246031),
(362743, 'PTHR45757:SF1', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246031),
(362744, 'PTHR45757:SF16', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246031),
(362745, 'PTHR45757:SF6', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246031),
(362746, 'PTHR45757:SF5', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246031),
(362747, 'PTHR45757:SF17', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246031),
(362748, 'PTHR45757:SF18', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246031),
(362749, 'PTHR45757:SF4', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246031),
(362750, 'PTHR45757:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG25180', 246031),
(362751, 'PTHR45757:SF19', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246031),
(362752, 'PTHR45757:SF9', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246031),
(362753, 'PTHR45757:SF8', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246031),
(362754, 'PTHR45757:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG03300', 246031),
(362755, 'PTHR45757:SF30', NULL, NULL, NULL, NULL, 'PROTEIN CBG21726', 246031),
(362756, 'PTHR45757:SF31', NULL, NULL, NULL, NULL, 'PROTEIN CBG04430', 246031),
(362757, 'PTHR45757:SF32', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246031);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(362758, 'PTHR45757:SF10', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246031),
(362759, 'PTHR45757:SF11', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246031),
(362760, 'PTHR45757:SF33', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246031),
(362761, 'PTHR45757:SF12', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246031),
(362762, 'PTHR45757:SF14', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246031),
(362763, 'PTHR45757:SF15', NULL, NULL, NULL, NULL, 'PROTEIN CBG20085', 246031),
(362764, 'PTHR45757:SF27', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246031),
(362765, 'PTHR45757:SF28', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246031),
(362766, 'PTHR45757:SF29', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246031),
(362767, 'PTHR45757:SF20', NULL, NULL, NULL, NULL, 'PROTEIN CBG01833', 246031),
(362768, 'PTHR45757:SF21', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246031),
(362769, 'PTHR45757:SF22', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246031),
(362770, 'PTHR45757:SF23', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246031),
(362771, 'PTHR45757:SF24', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246031),
(362772, 'PTHR45757:SF25', NULL, NULL, NULL, NULL, 'PROTEIN CBG20625', 246031),
(362773, 'PTHR45757:SF26', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246031),
(362774, 'PTHR28562:SF1', NULL, NULL, NULL, NULL, 'COP9 SIGNALOSOME COMPLEX SUBUNIT 9', 246032),
(362775, 'PTHR28562:SF2', NULL, NULL, NULL, NULL, 'COP9 SIGNALOSOME COMPLEX SUBUNIT 9', 246032),
(362776, 'PTHR28562', NULL, NULL, NULL, NULL, 'COP9 SIGNALOSOME COMPLEX SUBUNIT 9', 246032),
(362777, 'PTHR28562:SF3', NULL, NULL, NULL, NULL, 'COP9 SIGNALOSOME COMPLEX SUBUNIT 9', 246032),
(362778, 'PTHR39342', NULL, NULL, NULL, NULL, 'UPF0283 MEMBRANE PROTEIN YCJF', 246033),
(362779, 'PTHR39342:SF1', NULL, NULL, NULL, NULL, 'UPF0283 MEMBRANE PROTEIN YCJF', 246033),
(362780, 'PTHR46204:SF9', NULL, NULL, NULL, NULL, 'CHITIN ELICITOR RECEPTOR KINASE 1-LIKE ISOFORM X1', 246034),
(362781, 'PTHR46204:SF8', NULL, NULL, NULL, NULL, 'LYSM-DOMAIN PROTEIN KINASE FAMILY PROTEIN-RELATED', 246034),
(362782, 'PTHR46204', NULL, NULL, NULL, NULL, 'CHITIN ELICITOR RECEPTOR KINASE 1-RELATED', 246034),
(362783, 'PTHR46204:SF12', NULL, NULL, NULL, NULL, 'LYSM RECEPTOR KINASE K1B', 246034),
(362784, 'PTHR46204:SF15', NULL, NULL, NULL, NULL, 'LYSM DOMAIN RECEPTOR-LIKE KINASE 3', 246034),
(362785, 'PTHR46204:SF28', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246034),
(362786, 'PTHR46204:SF16', NULL, NULL, NULL, NULL, 'CHITIN ELICITOR RECEPTOR KINASE 1-LIKE', 246034),
(362787, 'PTHR46204:SF27', NULL, NULL, NULL, NULL, 'SERINE-THREONINE/TYROSINE-PROTEIN KINASE CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 246034),
(362788, 'PTHR46204:SF29', NULL, NULL, NULL, NULL, 'CONCANAVALIN A-LIKE LECTIN/GLUCANASE DOMAIN-CONTAINING PROTEIN-RELATED', 246034),
(362789, 'PTHR46204:SF2', NULL, NULL, NULL, NULL, 'CHITIN ELICITOR RECEPTOR KINASE 1', 246034),
(362790, 'PTHR46204:SF5', NULL, NULL, NULL, NULL, 'KINASE FAMILY PROTEIN / PEPTIDOGLYCAN-BINDING LYSM DOMAIN-CONTAINING PROTEIN', 246034),
(362791, 'PTHR46204:SF22', NULL, NULL, NULL, NULL, 'BNAA06G02020D PROTEIN', 246034),
(362792, 'PTHR46204:SF4', NULL, NULL, NULL, NULL, 'LYSM DOMAIN RECEPTOR-LIKE KINASE 10', 246034),
(362793, 'PTHR46204:SF11', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN / PEPTIDOGLYCAN-BINDING LYSM DOMAIN-CONTAINING PROTEIN, PUTATIVE-RELATED', 246034),
(362794, 'PTHR46204:SF10', NULL, NULL, NULL, NULL, 'LYSM DOMAIN RECEPTOR-LIKE KINASE 3', 246034),
(362795, 'PTHR10602:SF0', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 2 SUBUNIT 1', 246035),
(362796, 'PTHR10602', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 2 SUBUNIT 1', 246035),
(362797, 'PTHR10602:SF4', NULL, NULL, NULL, NULL, 'S1 MOTIF DOMAIN-CONTAINING PROTEIN', 246035),
(362798, 'PTHR10602:SF3', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 2 SUBUNIT ALPHA-RELATED', 246035);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(362799, 'PTHR10602:SF6', NULL, NULL, NULL, NULL, 'S1 MOTIF DOMAIN-CONTAINING PROTEIN', 246035),
(362800, 'PTHR34145:SF39', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 246036),
(362801, 'PTHR34145:SF52', NULL, NULL, NULL, NULL, 'OS02G0105800 PROTEIN', 246036),
(362802, 'PTHR34145:SF51', NULL, NULL, NULL, NULL, 'F-BOX FAMILY PROTEIN', 246036),
(362803, 'PTHR34145:SF50', NULL, NULL, NULL, NULL, '', 246036),
(362804, 'PTHR34145:SF56', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 246036),
(362805, 'PTHR34145:SF12', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246036),
(362806, 'PTHR34145:SF34', NULL, NULL, NULL, NULL, 'OS05G0571700 PROTEIN', 246036),
(362807, 'PTHR34145:SF33', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 246036),
(362808, 'PTHR34145:SF55', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246036),
(362809, 'PTHR34145:SF32', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246036),
(362810, 'PTHR34145:SF54', NULL, NULL, NULL, NULL, 'FBD-ASSOCIATED F-BOX PLANT PROTEIN', 246036),
(362811, 'PTHR34145:SF53', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 246036),
(362812, 'PTHR34145:SF16', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246036),
(362813, 'PTHR34145:SF38', NULL, NULL, NULL, NULL, 'OS09G0502900 PROTEIN', 246036),
(362814, 'PTHR34145:SF37', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246036),
(362815, 'PTHR34145:SF59', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 246036),
(362816, 'PTHR34145:SF36', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246036),
(362817, 'PTHR34145:SF14', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246036),
(362818, 'PTHR34145:SF58', NULL, NULL, NULL, NULL, 'OS10G0384600 PROTEIN', 246036),
(362819, 'PTHR34145:SF57', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246036),
(362820, 'PTHR34145:SF35', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246036),
(362821, 'PTHR34145:SF29', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246036),
(362822, 'PTHR34145:SF28', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', 246036),
(362823, 'PTHR34145:SF9', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 246036),
(362824, 'PTHR34145:SF8', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246036),
(362825, 'PTHR34145:SF7', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246036),
(362826, 'PTHR34145:SF6', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 246036),
(362827, 'PTHR34145:SF5', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246036),
(362828, 'PTHR34145:SF63', NULL, NULL, NULL, NULL, 'OS09G0506700 PROTEIN', 246036),
(362829, 'PTHR34145:SF41', NULL, NULL, NULL, NULL, 'OS02G0729251 PROTEIN', 246036),
(362830, 'PTHR34145:SF62', NULL, NULL, NULL, NULL, '', 246036),
(362831, 'PTHR34145:SF40', NULL, NULL, NULL, NULL, '', 246036),
(362832, 'PTHR34145:SF61', NULL, NULL, NULL, NULL, 'OS07G0161500 PROTEIN', 246036),
(362833, 'PTHR34145:SF60', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246036),
(362834, 'PTHR34145:SF23', NULL, NULL, NULL, NULL, 'OS04G0479800 PROTEIN', 246036),
(362835, 'PTHR34145', NULL, NULL, NULL, NULL, 'OS02G0105600 PROTEIN', 246036),
(362836, 'PTHR34145:SF44', NULL, NULL, NULL, NULL, '', 246036),
(362837, 'PTHR34145:SF43', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN PROTEIN', 246036),
(362838, 'PTHR34145:SF42', NULL, NULL, NULL, NULL, '', 246036),
(362839, 'PTHR34145:SF20', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 246036),
(362840, 'PTHR34145:SF49', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 246036),
(362841, 'PTHR34145:SF26', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 246036),
(362842, 'PTHR34145:SF48', NULL, NULL, NULL, NULL, 'OS01G0553400 PROTEIN', 246036),
(362843, 'PTHR34145:SF47', NULL, NULL, NULL, NULL, 'OS06G0684900 PROTEIN', 246036),
(362844, 'PTHR34145:SF24', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246036),
(362845, 'PTHR34145:SF46', NULL, NULL, NULL, NULL, 'OS06G0716467 PROTEIN', 246036);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(362846, 'PTHR43122', NULL, NULL, NULL, NULL, 'FERREDOXIN SUBUNIT OF PYRUVATE:FLAVODOXIN OXIDOREDUCTASE-RELATED', 246037),
(362847, 'PTHR43122:SF1', NULL, NULL, NULL, NULL, 'IRON-SULFUR-BINDING PROTEIN-RELATED', 246037),
(362848, 'PTHR45011:SF1', NULL, NULL, NULL, NULL, 'DAP3-BINDING CELL DEATH ENHANCER 1', 246038),
(362849, 'PTHR45011', NULL, NULL, NULL, NULL, 'DAP3-BINDING CELL DEATH ENHANCER 1', 246038),
(362850, 'PTHR21777', NULL, NULL, NULL, NULL, 'RCG55159-LIKE', 246039),
(362851, 'PTHR21777:SF0', NULL, NULL, NULL, NULL, 'RCG55159-LIKE', 246039),
(362852, 'PTHR47631:SF1', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS E (EPSILON)', 246040),
(362853, 'PTHR47631:SF3', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS EPSILON-45', 246040),
(362854, 'PTHR47631:SF2', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS E (EPSILON)', 246040),
(362855, 'PTHR47631', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS E (EPSILON)-RELATED', 246040),
(362856, 'PTHR47631:SF4', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS E (EPSILON)', 246040),
(362857, 'PTHR40430', NULL, NULL, NULL, NULL, '', 246041),
(362858, 'PTHR40430:SF1', NULL, NULL, NULL, NULL, '', 246041),
(362859, 'PTHR21290:SF25', NULL, NULL, NULL, NULL, 'SPHINGOMYELIN SYNTHASE-RELATED PROTEIN 1', 246042),
(362860, 'PTHR21290:SF59', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL:CERAMIDE INOSITOLPHOSPHOTRANSFERASE 1-LIKE ISOFORM X1', 246042),
(362861, 'PTHR21290:SF48', NULL, NULL, NULL, NULL, 'OS02G0543100 PROTEIN', 246042),
(362862, 'PTHR21290:SF49', NULL, NULL, NULL, NULL, 'OS05G0452900 PROTEIN', 246042),
(362863, 'PTHR21290:SF27', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLCHOLINE:CERAMIDE CHOLINEPHOSPHOTRANSFERASE 1', 246042),
(362864, 'PTHR21290:SF28', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLCHOLINE:CERAMIDE CHOLINEPHOSPHOTRANSFERASE 1', 246042),
(362865, 'PTHR21290:SF54', NULL, NULL, NULL, NULL, 'PLANT INOSITOL PHOSPHORYLCERAMIDE SYNTHASE', 246042),
(362866, 'PTHR21290:SF4', NULL, NULL, NULL, NULL, 'SPHINGOMYELIN SYNTHASE-RELATED 2', 246042),
(362867, 'PTHR21290:SF23', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLCHOLINE:CERAMIDE CHOLINEPHOSPHOTRANSFERASE 2', 246042),
(362868, 'PTHR21290:SF34', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLCHOLINE:CERAMIDE CHOLINEPHOSPHOTRANSFERASE 3-RELATED', 246042),
(362869, 'PTHR21290:SF56', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL:CERAMIDE INOSITOLPHOSPHOTRANSFERASE 1-LIKE ISOFORM X1', 246042),
(362870, 'PTHR21290:SF24', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLCHOLINE:CERAMIDE CHOLINEPHOSPHOTRANSFERASE 2', 246042),
(362871, 'PTHR21290', NULL, NULL, NULL, NULL, 'SPHINGOMYELIN SYNTHETASE', 246042),
(362872, 'PTHR21290:SF61', NULL, NULL, NULL, NULL, 'PAP2_C DOMAIN-CONTAINING PROTEIN', 246042),
(362873, 'PTHR21290:SF50', NULL, NULL, NULL, NULL, 'PAP2_C DOMAIN-CONTAINING PROTEIN', 246042),
(362874, 'PTHR21290:SF62', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL:CERAMIDE INOSITOLPHOSPHOTRANSFERASE 1-RELATED', 246042),
(362875, 'PTHR21290:SF63', NULL, NULL, NULL, NULL, 'PAP2_C DOMAIN-CONTAINING PROTEIN', 246042),
(362876, 'PTHR21290:SF64', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL:CERAMIDE INOSITOLPHOSPHOTRANSFERASE', 246042),
(362877, 'PTHR21290:SF53', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL:CERAMIDE INOSITOLPHOSPHOTRANSFERASE 2', 246042),
(362878, 'PTHR14381', NULL, NULL, NULL, NULL, 'DACTYLIN', 246043),
(362879, 'PTHR14381:SF1', NULL, NULL, NULL, NULL, 'F-BOX/WD REPEAT-CONTAINING PROTEIN 4', 246043),
(362880, 'PTHR24255:SF28', NULL, NULL, NULL, NULL, 'ST14 TRANSMEMBRANE SERINE PROTEASE MATRIPTASE B', 246044),
(362881, 'PTHR24255:SF27', NULL, NULL, NULL, NULL, 'HAPTOGLOBIN-RELATED PROTEIN', 246044),
(362882, 'PTHR24255:SF18', NULL, NULL, NULL, NULL, 'COMPLEMENT C1S SUBCOMPONENT', 246044),
(362883, 'PTHR24255:SF29', NULL, NULL, NULL, NULL, 'WU:FD46C06', 246044),
(362884, 'PTHR24255', NULL, NULL, NULL, NULL, 'COMPLEMENT COMPONENT 1, S SUBCOMPONENT-RELATED', 246044),
(362885, 'PTHR24255:SF31', NULL, NULL, NULL, NULL, 'CUB DOMAIN-CONTAINING PROTEIN', 246044),
(362886, 'PTHR24255:SF30', NULL, NULL, NULL, NULL, 'HAPTOGLOBIN', 246044);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(362887, 'PTHR24255:SF33', NULL, NULL, NULL, NULL, 'CUBILIN', 246044),
(362888, 'PTHR24255:SF10', NULL, NULL, NULL, NULL, 'MANNAN-BINDING LECTIN SERINE PROTEASE 2', 246044),
(362889, 'PTHR24255:SF32', NULL, NULL, NULL, NULL, 'CUB DOMAINCONTAINING PROTEIN', 246044),
(362890, 'PTHR24255:SF13', NULL, NULL, NULL, NULL, 'MANNAN-BINDING LECTIN SERINE PROTEASE 1', 246044),
(362891, 'PTHR24255:SF26', NULL, NULL, NULL, NULL, 'COMPLEMENT C1R SUBCOMPONENT-LIKE PROTEIN', 246044),
(362892, 'PTHR24255:SF25', NULL, NULL, NULL, NULL, 'COMPLEMENT C1R SUBCOMPONENT', 246044),
(362893, 'PTHR48161', NULL, NULL, NULL, NULL, 'BNACNNG12870D PROTEIN', 246045),
(362894, 'PTHR48161:SF1', NULL, NULL, NULL, NULL, 'BNACNNG12870D PROTEIN', 246045),
(362895, 'PTHR48161:SF2', NULL, NULL, NULL, NULL, 'ORF122B PROTEIN', 246045),
(362896, 'PTHR43505:SF1', NULL, NULL, NULL, NULL, 'REVERSE GYRASE', 246046),
(362897, 'PTHR43505', NULL, NULL, NULL, NULL, 'REVERSE GYRASE', 246046),
(362898, 'PTHR14952:SF19', NULL, NULL, NULL, NULL, 'RIIA DOMAIN-CONTAINING PROTEIN', 246047),
(362899, 'PTHR14952:SF20', NULL, NULL, NULL, NULL, 'ROPN1L-LIKE PROTEIN-RELATED', 246047),
(362900, 'PTHR14952:SF12', NULL, NULL, NULL, NULL, 'ROPPORIN-1B', 246047),
(362901, 'PTHR14952:SF14', NULL, NULL, NULL, NULL, 'ROPPORIN-1-LIKE PROTEIN', 246047),
(362902, 'PTHR14952:SF9', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN E', 246047),
(362903, 'PTHR14952', NULL, NULL, NULL, NULL, 'ROPPORIN-1-LIKE PROTEIN', 246047),
(362904, 'PTHR14952:SF18', NULL, NULL, NULL, NULL, 'ROPPORIN-1A', 246047),
(362905, 'PTHR46704:SF4', NULL, NULL, NULL, NULL, '', 246048),
(362906, 'PTHR46704', NULL, NULL, NULL, NULL, 'CXC DOMAIN-CONTAINING PROTEIN-RELATED', 246048),
(362907, 'PTHR46704:SF8', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 246048),
(362908, 'PTHR46704:SF1', NULL, NULL, NULL, NULL, 'CXC DOMAIN-CONTAINING PROTEIN', 246048),
(362909, 'PTHR31529:SF60', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN CRL1', 246049),
(362910, 'PTHR31529:SF40', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 14', 246049),
(362911, 'PTHR31529:SF62', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 246049),
(362912, 'PTHR31529:SF61', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 18', 246049),
(362913, 'PTHR31529', NULL, NULL, NULL, NULL, 'LOB DOMAIN CONTAINING PROTEIN', 246049),
(362914, 'PTHR31529:SF64', NULL, NULL, NULL, NULL, 'OS02G0820500 PROTEIN', 246049),
(362915, 'PTHR31529:SF42', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 246049),
(362916, 'PTHR31529:SF63', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 33', 246049),
(362917, 'PTHR31529:SF41', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 246049),
(362918, 'PTHR31529:SF65', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 17', 246049),
(362919, 'PTHR31529:SF46', NULL, NULL, NULL, NULL, 'BNAC03G23720D PROTEIN', 246049),
(362920, 'PTHR31529:SF23', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 16', 246049),
(362921, 'PTHR31529:SF45', NULL, NULL, NULL, NULL, 'BNAC04G56960D PROTEIN', 246049),
(362922, 'PTHR31529:SF37', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 246049),
(362923, 'PTHR31529:SF58', NULL, NULL, NULL, NULL, 'LOB DOMAIN PROTEIN', 246049),
(362924, 'PTHR31529:SF39', NULL, NULL, NULL, NULL, 'BNAC04G56950D PROTEIN', 246049),
(362925, 'PTHR31529:SF4', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 30', 246049),
(362926, 'PTHR31529:SF51', NULL, NULL, NULL, NULL, 'BNAANNG32930D PROTEIN', 246049),
(362927, 'PTHR31529:SF50', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 246049),
(362928, 'PTHR31529:SF32', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 31', 246049),
(362929, 'PTHR31529:SF54', NULL, NULL, NULL, NULL, 'OS01G0772100 PROTEIN', 246049),
(362930, 'PTHR31529:SF57', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 29', 246049),
(362931, 'PTHR31529:SF56', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246049),
(362932, 'PTHR31529:SF34', NULL, NULL, NULL, NULL, 'BNAC04G13650D PROTEIN', 246049);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(362933, 'PTHR31529:SF12', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 20', 246049),
(362934, 'PTHR31529:SF48', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 246049),
(362935, 'PTHR31529:SF26', NULL, NULL, NULL, NULL, 'OS08G0563400 PROTEIN', 246049),
(362936, 'PTHR31529:SF47', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 31', 246049),
(362937, 'PTHR31529:SF28', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 19', 246049),
(362938, 'PTHR12818:SF0', NULL, NULL, NULL, NULL, 'TRNA (ADENINE(37)-N6)-METHYLTRANSFERASE', 246050),
(362939, 'PTHR12818:SF5', NULL, NULL, NULL, NULL, 'TSAA-LIKE DOMAIN-CONTAINING PROTEIN', 246050),
(362940, 'PTHR12818', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 246050),
(362941, 'PTHR46006:SF8', NULL, NULL, NULL, NULL, 'DH DOMAIN-CONTAINING PROTEIN', 246051),
(362942, 'PTHR46006:SF7', NULL, NULL, NULL, NULL, 'DH DOMAIN-CONTAINING PROTEIN', 246051),
(362943, 'PTHR46006:SF2', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 3', 246051),
(362944, 'PTHR46006:SF6', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE EXCHANGE FACTOR, PUTATIVE-RELATED', 246051),
(362945, 'PTHR46006:SF5', NULL, NULL, NULL, NULL, 'DH DOMAIN-CONTAINING PROTEIN', 246051),
(362946, 'PTHR46006:SF4', NULL, NULL, NULL, NULL, 'NEUROEPITHELIAL CELL-TRANSFORMING GENE 1 PROTEIN', 246051),
(362947, 'PTHR46006', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR AT 64C, ISOFORM A', 246051),
(362948, 'PTHR46006:SF3', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 3', 246051),
(362949, 'PTHR36153:SF1', NULL, NULL, NULL, NULL, 'TYPE VI SECRETION SYSTEM COMPONENT TSSM1', 246052),
(362950, 'PTHR36153:SF5', NULL, NULL, NULL, NULL, 'EXPORTED PROTEIN-RELATED', 246052),
(362951, 'PTHR36153', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', 246052),
(362952, 'PTHR15428', NULL, NULL, NULL, NULL, 'ENDOTHELIAL CELL-SPECIFIC MOLECULE 1  ESM-1', 246053),
(362953, 'PTHR15428:SF0', NULL, NULL, NULL, NULL, 'ENDOTHELIAL CELL-SPECIFIC MOLECULE 1', 246053),
(362954, 'PTHR39267', NULL, NULL, NULL, NULL, 'SURVIVAL MOTOR NEURON-LIKE PROTEIN 1', 246054),
(362955, 'PTHR39267:SF1', NULL, NULL, NULL, NULL, 'SURVIVAL MOTOR NEURON PROTEIN', 246054),
(362956, 'PTHR30523:SF6', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYLASE', 246055),
(362957, 'PTHR30523:SF5', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYLASE 1', 246055),
(362958, 'PTHR30523:SF42', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYLASE', 246055),
(362959, 'PTHR30523:SF31', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYLASE', 246055),
(362960, 'PTHR30523:SF43', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYLASE', 246055),
(362961, 'PTHR30523:SF32', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYLASE', 246055),
(362962, 'PTHR30523:SF44', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYLASE', 246055),
(362963, 'PTHR30523:SF33', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYLASE 3', 246055),
(362964, 'PTHR30523:SF22', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYLASE 2', 246055),
(362965, 'PTHR30523', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYLASE', 246055),
(362966, 'PTHR30523:SF45', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYLASE', 246055),
(362967, 'PTHR30523:SF35', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYLASE', 246055),
(362968, 'PTHR30523:SF46', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYLASE', 246055),
(362969, 'PTHR30523:SF47', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYLASE 2', 246055),
(362970, 'PTHR30523:SF25', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYLASE', 246055),
(362971, 'PTHR30523:SF36', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYLASE', 246055),
(362972, 'PTHR30523:SF37', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYLASE', 246055),
(362973, 'PTHR30523:SF38', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYLASE 1', 246055),
(362974, 'PTHR32086:SF0', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA GROUP D2 PROTEIN', 246056),
(362975, 'PTHR32086', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA GROUP D2 PROTEIN', 246056); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(362976, 'PTHR24228:SF59', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE RECEPTOR 15', 246057),
(362977, 'PTHR24228:SF33', NULL, NULL, NULL, NULL, 'BRADYKININ RECEPTOR B1', 246057),
(362978, 'PTHR24228:SF55', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 75-RELATED', 246057),
(362979, 'PTHR24228:SF11', NULL, NULL, NULL, NULL, 'TYPE-1 ANGIOTENSIN II RECEPTOR', 246057),
(362980, 'PTHR24228:SF8', NULL, NULL, NULL, NULL, 'TYPE-2 ANGIOTENSIN II RECEPTOR', 246057),
(362981, 'PTHR24228:SF54', NULL, NULL, NULL, NULL, 'MELATONIN RECEPTOR TYPE 1B', 246057),
(362982, 'PTHR24228:SF10', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 15', 246057),
(362983, 'PTHR24228:SF32', NULL, NULL, NULL, NULL, 'TYPE-1B ANGIOTENSIN II RECEPTOR', 246057),
(362984, 'PTHR24228:SF13', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR NPR-29-RELATED', 246057),
(362985, 'PTHR24228:SF56', NULL, NULL, NULL, NULL, 'MELATONIN-RELATED RECEPTOR', 246057),
(362986, 'PTHR24228:SF73', NULL, NULL, NULL, NULL, 'PROTEIN-COUPLED RECEPTOR, PUTATIVE-RELATED', 246057),
(362987, 'PTHR24228:SF72', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 246057),
(362988, 'PTHR24228:SF9', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 25-RELATED', 246057),
(362989, 'PTHR24228:SF53', NULL, NULL, NULL, NULL, 'MELATONIN RECEPTOR TYPE 1A', 246057),
(362990, 'PTHR24228:SF31', NULL, NULL, NULL, NULL, 'APELIN RECEPTOR', 246057),
(362991, 'PTHR24228:SF52', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 246057),
(362992, 'PTHR24228:SF74', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 246057),
(362993, 'PTHR24228:SF71', NULL, NULL, NULL, NULL, 'PROTEIN TRAPPED IN ENDODERM-1', 246057),
(362994, 'PTHR24228', NULL, NULL, NULL, NULL, 'B2 BRADYKININ RECEPTOR/ANGIOTENSIN II RECEPTOR', 246057),
(362995, 'PTHR24228:SF26', NULL, NULL, NULL, NULL, 'APELIN RECEPTOR B', 246057),
(362996, 'PTHR24228:SF25', NULL, NULL, NULL, NULL, 'B2 BRADYKININ RECEPTOR', 246057),
(362997, 'PTHR24228:SF69', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 246057),
(362998, 'PTHR24228:SF28', NULL, NULL, NULL, NULL, 'B1 BRADYKININ RECEPTOR', 246057),
(362999, 'PTHR24228:SF49', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 246057),
(363000, 'PTHR24228:SF21', NULL, NULL, NULL, NULL, 'APELIN RECEPTOR 2', 246057),
(363001, 'PTHR24228:SF65', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 246057),
(363002, 'PTHR24228:SF68', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 246057),
(363003, 'PTHR24228:SF67', NULL, NULL, NULL, NULL, 'APELIN RECEPTOR 2', 246057),
(363004, 'PTHR24228:SF61', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 246057),
(363005, 'PTHR24228:SF63', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR MOODY', 246057),
(363006, 'PTHR34924:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAM166C', 246058),
(363007, 'PTHR34924', NULL, NULL, NULL, NULL, 'UPF0573 PROTEIN C2ORF70', 246058),
(363008, 'PTHR34066', NULL, NULL, NULL, NULL, 'GROWTH FACTOR 2', 246059),
(363009, 'PTHR34066:SF1', NULL, NULL, NULL, NULL, 'GROWTH FACTOR 2', 246059),
(363010, 'PTHR13497:SF3', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE COMPLEX SUBUNIT SAP130', 246060),
(363011, 'PTHR13497', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE COMPLEX SUBUNIT SAP130', 246060),
(363012, 'PTHR24637:SF309', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363013, 'PTHR24637:SF308', NULL, NULL, NULL, NULL, 'COLLAGEN', 246061),
(363014, 'PTHR24637:SF303', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363015, 'PTHR24637:SF269', NULL, NULL, NULL, NULL, 'COLLAGEN STRUCTURAL-RELATED', 246061),
(363016, 'PTHR24637:SF302', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN-RELATED', 246061),
(363017, 'PTHR24637:SF268', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363018, 'PTHR24637:SF389', NULL, NULL, NULL, NULL, 'COLLAGEN STRUCTURAL', 246061);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(363019, 'PTHR24637:SF301', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363020, 'PTHR24637:SF267', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN-RELATED', 246061),
(363021, 'PTHR24637:SF388', NULL, NULL, NULL, NULL, 'SCAVENGER RECEPTOR CLASS A MEMBER 3', 246061),
(363022, 'PTHR24637:SF306', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363023, 'PTHR24637:SF305', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN-RELATED', 246061),
(363024, 'PTHR24637:SF383', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363025, 'PTHR24637:SF262', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN-RELATED', 246061),
(363026, 'PTHR24637:SF261', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363027, 'PTHR24637:SF382', NULL, NULL, NULL, NULL, 'COLLAGEN-RELATED', 246061),
(363028, 'PTHR24637:SF260', NULL, NULL, NULL, NULL, 'CUTICLE COLLAGEN 80-RELATED', 246061),
(363029, 'PTHR24637:SF380', NULL, NULL, NULL, NULL, 'COLLAGEN', 246061),
(363030, 'PTHR24637:SF387', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363031, 'PTHR24637:SF266', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363032, 'PTHR24637:SF265', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363033, 'PTHR24637:SF386', NULL, NULL, NULL, NULL, 'PROTEIN CBR-COL-77', 246061),
(363034, 'PTHR24637:SF385', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363035, 'PTHR24637:SF263', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363036, 'PTHR24637:SF384', NULL, NULL, NULL, NULL, 'CUTICLE COLLAGEN 90-RELATED', 246061),
(363037, 'PTHR24637:SF319', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363038, 'PTHR24637:SF314', NULL, NULL, NULL, NULL, 'COLLAGEN', 246061),
(363039, 'PTHR24637:SF313', NULL, NULL, NULL, NULL, 'COLLAGEN-RELATED', 246061),
(363040, 'PTHR24637:SF312', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363041, 'PTHR24637:SF311', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363042, 'PTHR24637:SF399', NULL, NULL, NULL, NULL, 'COLLAGEN', 246061),
(363043, 'PTHR24637:SF278', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363044, 'PTHR24637:SF318', NULL, NULL, NULL, NULL, 'CUTICLE COLLAGEN 91-RELATED', 246061),
(363045, 'PTHR24637:SF317', NULL, NULL, NULL, NULL, 'CUTICLE COLLAGEN DPY-13', 246061),
(363046, 'PTHR24637:SF316', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363047, 'PTHR24637:SF315', NULL, NULL, NULL, NULL, 'CUTICLE COLLAGEN 40', 246061),
(363048, 'PTHR24637:SF394', NULL, NULL, NULL, NULL, 'CUTICLE COLLAGEN 39', 246061),
(363049, 'PTHR24637:SF393', NULL, NULL, NULL, NULL, 'CUTICLE COLLAGEN ROL-6', 246061),
(363050, 'PTHR24637:SF271', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363051, 'PTHR24637:SF392', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363052, 'PTHR24637:SF270', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363053, 'PTHR24637:SF391', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-1(IX) CHAIN', 246061),
(363054, 'PTHR24637:SF310', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363055, 'PTHR24637:SF398', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363056, 'PTHR24637:SF277', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363057, 'PTHR24637:SF276', NULL, NULL, NULL, NULL, 'CUTICLE COLLAGEN LON-3', 246061),
(363058, 'PTHR24637:SF397', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363059, 'PTHR24637:SF396', NULL, NULL, NULL, NULL, 'COLLAGEN TRIPLE HELIX PROTEIN', 246061),
(363060, 'PTHR24637:SF275', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(363061, 'PTHR24637:SF395', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363062, 'PTHR24637:SF274', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363063, 'PTHR24637:SF390', NULL, NULL, NULL, NULL, 'CUTICLE COLLAGEN 14', 246061),
(363064, 'PTHR24637:SF209', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363065, 'PTHR24637:SF325', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363066, 'PTHR24637:SF324', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363067, 'PTHR24637:SF289', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363068, 'PTHR24637:SF328', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363069, 'PTHR24637:SF327', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363070, 'PTHR24637:SF326', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363071, 'PTHR24637:SF284', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363072, 'PTHR24637:SF283', NULL, NULL, NULL, NULL, 'COLLAGEN', 246061),
(363073, 'PTHR24637:SF282', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN-RELATED', 246061),
(363074, 'PTHR24637:SF321', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363075, 'PTHR24637:SF288', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363076, 'PTHR24637:SF320', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363077, 'PTHR24637:SF287', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363078, 'PTHR24637:SF286', NULL, NULL, NULL, NULL, 'CUTICLE COLLAGEN 6', 246061),
(363079, 'PTHR24637:SF336', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363080, 'PTHR24637:SF334', NULL, NULL, NULL, NULL, 'COLLAGEN', 246061),
(363081, 'PTHR24637:SF295', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363082, 'PTHR24637:SF294', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363083, 'PTHR24637:SF293', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363084, 'PTHR24637:SF332', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363085, 'PTHR24637:SF299', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363086, 'PTHR24637:SF298', NULL, NULL, NULL, NULL, 'CUTICLE COLLAGEN 75-RELATED', 246061),
(363087, 'PTHR24637:SF297', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363088, 'PTHR24637:SF330', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN-RELATED', 246061),
(363089, 'PTHR24637:SF296', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363090, 'PTHR24637', NULL, NULL, NULL, NULL, 'COLLAGEN', 246061),
(363091, 'PTHR24637:SF344', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363092, 'PTHR24637:SF348', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363093, 'PTHR24637:SF358', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363094, 'PTHR24637:SF237', NULL, NULL, NULL, NULL, 'CUTICLE COLLAGEN 1', 246061),
(363095, 'PTHR24637:SF236', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363096, 'PTHR24637:SF357', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363097, 'PTHR24637:SF235', NULL, NULL, NULL, NULL, 'CUTICLE COLLAGEN 2', 246061),
(363098, 'PTHR24637:SF356', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363099, 'PTHR24637:SF234', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363100, 'PTHR24637:SF355', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363101, 'PTHR24637:SF239', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(363102, 'PTHR24637:SF238', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363103, 'PTHR24637:SF359', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363104, 'PTHR24637:SF350', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363105, 'PTHR24637:SF194', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN-RELATED', 246061),
(363106, 'PTHR24637:SF354', NULL, NULL, NULL, NULL, 'COLLAGEN', 246061),
(363107, 'PTHR24637:SF233', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363108, 'PTHR24637:SF231', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363109, 'PTHR24637:SF351', NULL, NULL, NULL, NULL, 'CUTICLE COLLAGEN DPY-10', 246061),
(363110, 'PTHR24637:SF230', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363111, 'PTHR24637:SF409', NULL, NULL, NULL, NULL, 'PROTEIN CBR-COL-83', 246061),
(363112, 'PTHR24637:SF408', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363113, 'PTHR24637:SF407', NULL, NULL, NULL, NULL, 'CUTICLE COLLAGEN 19', 246061),
(363114, 'PTHR24637:SF248', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363115, 'PTHR24637:SF402', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363116, 'PTHR24637:SF368', NULL, NULL, NULL, NULL, 'CUTICLE COLLAGEN 36', 246061),
(363117, 'PTHR24637:SF401', NULL, NULL, NULL, NULL, 'CUTICLE COLLAGEN DPY-2', 246061),
(363118, 'PTHR24637:SF400', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363119, 'PTHR24637:SF246', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363120, 'PTHR24637:SF366', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363121, 'PTHR24637:SF406', NULL, NULL, NULL, NULL, 'GENE, 37797-RELATED', 246061),
(363122, 'PTHR24637:SF405', NULL, NULL, NULL, NULL, 'SRTX-1', 246061),
(363123, 'PTHR24637:SF404', NULL, NULL, NULL, NULL, 'SI:CH211-160J14.3-RELATED', 246061),
(363124, 'PTHR24637:SF249', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363125, 'PTHR24637:SF403', NULL, NULL, NULL, NULL, 'COLLAGEN-RELATED', 246061),
(363126, 'PTHR24637:SF240', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363127, 'PTHR24637:SF360', NULL, NULL, NULL, NULL, 'COLLAGEN-RELATED', 246061),
(363128, 'PTHR24637:SF365', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363129, 'PTHR24637:SF243', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363130, 'PTHR24637:SF364', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363131, 'PTHR24637:SF242', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363132, 'PTHR24637:SF362', NULL, NULL, NULL, NULL, 'COLLAGEN', 246061),
(363133, 'PTHR24637:SF241', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363134, 'PTHR24637:SF259', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363135, 'PTHR24637:SF412', NULL, NULL, NULL, NULL, 'COLLAGEN', 246061),
(363136, 'PTHR24637:SF411', NULL, NULL, NULL, NULL, '', 246061),
(363137, 'PTHR24637:SF257', NULL, NULL, NULL, NULL, 'CUTICLE COLLAGEN DPY-5', 246061),
(363138, 'PTHR24637:SF410', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363139, 'PTHR24637:SF256', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363140, 'PTHR24637:SF377', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363141, 'PTHR24637:SF372', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363142, 'PTHR24637:SF251', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363143, 'PTHR24637:SF250', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363144, 'PTHR24637:SF371', NULL, NULL, NULL, NULL, 'COLLAGEN', 246061);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(363145, 'PTHR24637:SF370', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363146, 'PTHR24637:SF255', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363147, 'PTHR24637:SF376', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363148, 'PTHR24637:SF375', NULL, NULL, NULL, NULL, 'CUTICLE COLLAGEN BLI-1-RELATED', 246061),
(363149, 'PTHR24637:SF374', NULL, NULL, NULL, NULL, 'CUTICLE COLLAGEN DPY-7', 246061),
(363150, 'PTHR24637:SF253', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363151, 'PTHR24637:SF252', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363152, 'PTHR24637:SF373', NULL, NULL, NULL, NULL, 'COL_CUTICLE_N DOMAIN-CONTAINING PROTEIN', 246061),
(363153, 'PTHR41752:SF1', NULL, NULL, NULL, NULL, '', 246062),
(363154, 'PTHR41752', NULL, NULL, NULL, NULL, '', 246062),
(363155, 'PTHR14330', NULL, NULL, NULL, NULL, 'A-KINASE-INTERACTING PROTEIN 1', 246063),
(363156, 'PTHR14330:SF2', NULL, NULL, NULL, NULL, 'A-KINASE-INTERACTING PROTEIN 1', 246063),
(363157, 'PTHR14237:SF74', NULL, NULL, NULL, NULL, 'MOSC DOMAIN-CONTAINING PROTEIN', 246064),
(363158, 'PTHR14237:SF73', NULL, NULL, NULL, NULL, 'PYRIDOXAL PHOSPHATE-DEPENDENT TRANSFERASE-RELATED', 246064),
(363159, 'PTHR14237:SF54', NULL, NULL, NULL, NULL, 'MOLYBDENUM COFACTOR SULFURASE FAMILY PROTEIN', 246064),
(363160, 'PTHR14237:SF76', NULL, NULL, NULL, NULL, 'OS03G0765800 PROTEIN', 246064),
(363161, 'PTHR14237:SF72', NULL, NULL, NULL, NULL, 'MOSC DOMAIN-CONTAINING PROTEIN', 246064),
(363162, 'PTHR14237:SF50', NULL, NULL, NULL, NULL, 'OS11G0487100 PROTEIN', 246064),
(363163, 'PTHR14237:SF59', NULL, NULL, NULL, NULL, 'MOSC DOMAIN-CONTAINING PROTEIN', 246064),
(363164, 'PTHR14237:SF34', NULL, NULL, NULL, NULL, 'MOSC DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_2G07820)', 246064),
(363165, 'PTHR14237:SF78', NULL, NULL, NULL, NULL, 'PYRIDOXAL PHOSPHATE (PLP)-DEPENDENT TRANSFERASES SUPERFAMILY PROTEIN', 246064),
(363166, 'PTHR14237:SF77', NULL, NULL, NULL, NULL, 'MOLYBDENUM COFACTOR SULFURASE, PYRUVATE KINASE-LIKE, INSERT DOMAIN PROTEIN-RELATED', 246064),
(363167, 'PTHR14237:SF14', NULL, NULL, NULL, NULL, 'EMB|CAB16785.1', 246064),
(363168, 'PTHR14237:SF19', NULL, NULL, NULL, NULL, 'MOSC DOMAIN-CONTAINING PROTEIN', 246064),
(363169, 'PTHR14237:SF85', NULL, NULL, NULL, NULL, 'PYRIDOXAL PHOSPHATE (PLP)-DEPENDENT TRANSFERASES SUPERFAMILY PROTEIN', 246064),
(363170, 'PTHR14237:SF62', NULL, NULL, NULL, NULL, 'AMINOTRAN_5 DOMAIN-CONTAINING PROTEIN', 246064),
(363171, 'PTHR14237:SF84', NULL, NULL, NULL, NULL, 'BNAA01G12790D PROTEIN', 246064),
(363172, 'PTHR14237:SF87', NULL, NULL, NULL, NULL, '', 246064),
(363173, 'PTHR14237:SF64', NULL, NULL, NULL, NULL, 'MOLYBDENUM COFACTOR SULFURASE-LIKE PROTEIN', 246064),
(363174, 'PTHR14237:SF20', NULL, NULL, NULL, NULL, 'MOSC DOMAIN-CONTAINING PROTEIN', 246064),
(363175, 'PTHR14237:SF86', NULL, NULL, NULL, NULL, '', 246064),
(363176, 'PTHR14237:SF80', NULL, NULL, NULL, NULL, 'MOLYBDENUM COFACTOR SULFURASE', 246064),
(363177, 'PTHR14237:SF61', NULL, NULL, NULL, NULL, 'MOLYBDENUM COFACTOR SULFURASE FAMILY PROTEIN', 246064),
(363178, 'PTHR14237:SF60', NULL, NULL, NULL, NULL, 'MOLYBDENUM COFACTOR SULFURASE-LIKE', 246064),
(363179, 'PTHR14237:SF82', NULL, NULL, NULL, NULL, 'PYRIDOXAL PHOSPHATE-DEPENDENT TRANSFERASE-RELATED', 246064),
(363180, 'PTHR14237:SF27', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL AMIDOXIME REDUCING COMPONENT 2', 246064),
(363181, 'PTHR14237:SF23', NULL, NULL, NULL, NULL, 'MOSC DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_7G05900)', 246064),
(363182, 'PTHR14237:SF89', NULL, NULL, NULL, NULL, 'MOLYBDENUM COFACTOR SULFURASE', 246064),
(363183, 'PTHR14237:SF88', NULL, NULL, NULL, NULL, 'PYRIDOXAL PHOSPHATE (PLP)-DEPENDENT TRANSFERASES SUPERFAMILY PROTEIN', 246064),
(363184, 'PTHR14237:SF69', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL AMIDOXIME REDUCING COMPONENT 2-LIKE', 246064),
(363185, 'PTHR14237:SF25', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL AMIDOXIME-REDUCING COMPONENT 1', 246064);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(363186, 'PTHR14237:SF24', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246064),
(363187, 'PTHR14237:SF90', NULL, NULL, NULL, NULL, 'MOLYBDENUM COFACTOR SULFURASE', 246064),
(363188, 'PTHR14237', NULL, NULL, NULL, NULL, 'MOLYBDOPTERIN COFACTOR SULFURASE  MOSC', 246064),
(363189, 'PTHR47551:SF1', NULL, NULL, NULL, NULL, 'TUBULIN--TYROSINE LIGASE PBY1-RELATED', 246065),
(363190, 'PTHR47551', NULL, NULL, NULL, NULL, 'TUBULIN--TYROSINE LIGASE PBY1-RELATED', 246065),
(363191, 'PTHR46143:SF1', NULL, NULL, NULL, NULL, 'CALPAIN-7', 246066),
(363192, 'PTHR46143', NULL, NULL, NULL, NULL, 'CALPAIN-7', 246066),
(363193, 'PTHR35313:SF1', NULL, NULL, NULL, NULL, 'NO EXINE FORMATION 1', 246067),
(363194, 'PTHR35313', NULL, NULL, NULL, NULL, 'NO EXINE FORMATION 1', 246067),
(363195, 'PTHR24032:SF70', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 246068),
(363196, 'PTHR24032:SF20', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 246068),
(363197, 'PTHR24032:SF72', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN COMC', 246068),
(363198, 'PTHR24032:SF62', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 246068),
(363199, 'PTHR24032:SF74', NULL, NULL, NULL, NULL, '', 246068),
(363200, 'PTHR24032:SF39', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 246068),
(363201, 'PTHR24032:SF17', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 246068),
(363202, 'PTHR24032:SF18', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 246068),
(363203, 'PTHR24032:SF19', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 246068),
(363204, 'PTHR24032', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN-RELATED-RELATED', 246068),
(363205, 'PTHR24032:SF13', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 246068),
(363206, 'PTHR24032:SF8', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 246068),
(363207, 'PTHR24032:SF24', NULL, NULL, NULL, NULL, 'IPT/TIG DOMAIN-CONTAINING PROTEIN', 246068),
(363208, 'PTHR24032:SF69', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 246068),
(363209, 'PTHR24032:SF9', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 246068),
(363210, 'PTHR24032:SF14', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 246068),
(363211, 'PTHR24032:SF16', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 246068),
(363212, 'PTHR46022:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PATCHED', 246069),
(363213, 'PTHR46022:SF3', NULL, NULL, NULL, NULL, 'PROTEIN PATCHED HOMOLOG 2', 246069),
(363214, 'PTHR46022', NULL, NULL, NULL, NULL, 'PROTEIN PATCHED', 246069),
(363215, 'PTHR46022:SF5', NULL, NULL, NULL, NULL, 'PROTEIN PATCHED HOMOLOG 1', 246069),
(363216, 'PTHR46022:SF6', NULL, NULL, NULL, NULL, 'PROTEIN PATCHED HOMOLOG 3', 246069),
(363217, 'PTHR22881:SF27', NULL, NULL, NULL, NULL, 'LD22651P', 246070),
(363218, 'PTHR22881:SF15', NULL, NULL, NULL, NULL, 'DNA-BINDING BROMODOMAIN-CONTAINING PROTEIN', 246070),
(363219, 'PTHR22881:SF26', NULL, NULL, NULL, NULL, 'BROMODOMAIN CONTAINING PROTEIN, EXPRESSED', 246070),
(363220, 'PTHR22881:SF24', NULL, NULL, NULL, NULL, 'BROMODOMAIN-CONTAINING PROTEIN 9-LIKE', 246070),
(363221, 'PTHR22881:SF34', NULL, NULL, NULL, NULL, 'BROMO DOMAIN-CONTAINING PROTEIN', 246070),
(363222, 'PTHR22881:SF12', NULL, NULL, NULL, NULL, 'BROMODOMAIN-CONTAINING PROTEIN 7', 246070),
(363223, 'PTHR22881:SF11', NULL, NULL, NULL, NULL, 'BROMO DOMAIN-CONTAINING PROTEIN', 246070),
(363224, 'PTHR22881:SF31', NULL, NULL, NULL, NULL, 'BROMODOMAIN-CONTAINING PROTEIN-RELATED', 246070),
(363225, 'PTHR22881:SF42', NULL, NULL, NULL, NULL, 'DNA-BINDING BROMODOMAIN-CONTAINING PROTEIN', 246070),
(363226, 'PTHR22881:SF41', NULL, NULL, NULL, NULL, 'BROMO DOMAIN-CONTAINING PROTEIN', 246070),
(363227, 'PTHR22881', NULL, NULL, NULL, NULL, 'BROMODOMAIN CONTAINING PROTEIN', 246070),
(363228, 'PTHR22881:SF4', NULL, NULL, NULL, NULL, 'BROMODOMAIN-CONTAINING PROTEIN 9', 246070),
(363229, 'PTHR22881:SF29', NULL, NULL, NULL, NULL, 'BROMO DOMAIN-CONTAINING PROTEIN', 246070);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(363230, 'PTHR23200:SF51', NULL, NULL, NULL, NULL, 'LACTAMASE_B DOMAIN-CONTAINING PROTEIN', 246071),
(363231, 'PTHR23200:SF39', NULL, NULL, NULL, NULL, 'PROTEIN CBG14679', 246071),
(363232, 'PTHR23200', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 246071),
(363233, 'PTHR23200:SF35', NULL, NULL, NULL, NULL, 'LACTAMASE_B DOMAIN-CONTAINING PROTEIN', 246071),
(363234, 'PTHR23200:SF49', NULL, NULL, NULL, NULL, 'LACTAMASE_B DOMAIN-CONTAINING PROTEIN', 246071),
(363235, 'PTHR23200:SF48', NULL, NULL, NULL, NULL, 'METALLO-BETA-LACTAMASE DOMAIN-CONTAINING PROTEIN 1', 246071),
(363236, 'PTHR23071', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL GLYCAN', 246072),
(363237, 'PTHR23071:SF1', NULL, NULL, NULL, NULL, 'GPI ETHANOLAMINE PHOSPHATE TRANSFERASE 3', 246072),
(363238, 'PTHR10061', NULL, NULL, NULL, NULL, 'S-FORMYLGLUTATHIONE HYDROLASE', 246073),
(363239, 'PTHR10061:SF0', NULL, NULL, NULL, NULL, 'S-FORMYLGLUTATHIONE HYDROLASE', 246073),
(363240, 'PTHR10061:SF2', NULL, NULL, NULL, NULL, 'S-FORMYLGLUTATHIONE HYDROLASE', 246073),
(363241, 'PTHR10061:SF1', NULL, NULL, NULL, NULL, 'S-FORMYLGLUTATHIONE HYDROLASE YEIG', 246073),
(363242, 'PTHR34413:SF2', NULL, NULL, NULL, NULL, 'PROPHAGE TAIL FIBER ASSEMBLY PROTEIN HOMOLOG TFAE-RELATED', 246074),
(363243, 'PTHR34413:SF1', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 246074),
(363244, 'PTHR34413', NULL, NULL, NULL, NULL, 'PROPHAGE TAIL FIBER ASSEMBLY PROTEIN HOMOLOG TFAE-RELATED-RELATED', 246074),
(363245, 'PTHR10751:SF56', NULL, NULL, NULL, NULL, 'GUANYLATE-BINDING PROTEIN 4', 246075),
(363246, 'PTHR10751:SF119', NULL, NULL, NULL, NULL, 'GUANYLATE-BINDING PROTEIN 6', 246075),
(363247, 'PTHR10751:SF117', NULL, NULL, NULL, NULL, 'GUANYLATE-BINDING PROTEIN 7', 246075),
(363248, 'PTHR10751:SF15', NULL, NULL, NULL, NULL, 'ATLASTIN-1', 246075),
(363249, 'PTHR10751:SF118', NULL, NULL, NULL, NULL, 'GUANYLATE-BINDING FAMILY PROTEIN', 246075),
(363250, 'PTHR10751:SF17', NULL, NULL, NULL, NULL, 'GUANYLATE-BINDING PROTEIN 4', 246075),
(363251, 'PTHR10751:SF92', NULL, NULL, NULL, NULL, 'GBP4 PROTEIN', 246075),
(363252, 'PTHR10751:SF94', NULL, NULL, NULL, NULL, 'OS02G0307000 PROTEIN', 246075),
(363253, 'PTHR10751:SF95', NULL, NULL, NULL, NULL, 'GUANYLATE-BINDING PROTEIN 4-LIKE', 246075),
(363254, 'PTHR10751:SF96', NULL, NULL, NULL, NULL, 'GUANYLATE-BINDING PROTEIN 3', 246075),
(363255, 'PTHR10751:SF97', NULL, NULL, NULL, NULL, 'GUANYLATE-BINDING PROTEIN 1-LIKE', 246075),
(363256, 'PTHR10751:SF32', NULL, NULL, NULL, NULL, 'ATLASTIN-3', 246075),
(363257, 'PTHR10751:SF1', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 112', 246075),
(363258, 'PTHR10751:SF2', NULL, NULL, NULL, NULL, 'GB1/RHD3-TYPE G DOMAIN-CONTAINING PROTEIN', 246075),
(363259, 'PTHR10751:SF112', NULL, NULL, NULL, NULL, 'GUANYLATE-BINDING PROTEIN 2', 246075),
(363260, 'PTHR10751:SF110', NULL, NULL, NULL, NULL, 'OS07G0181700 PROTEIN', 246075),
(363261, 'PTHR10751:SF113', NULL, NULL, NULL, NULL, 'GUANYLATE-BINDING PROTEIN 1', 246075),
(363262, 'PTHR10751:SF114', NULL, NULL, NULL, NULL, 'GUANYLATE BINDING PROTEIN 11-RELATED', 246075),
(363263, 'PTHR10751:SF109', NULL, NULL, NULL, NULL, 'GB1/RHD3-TYPE G DOMAIN-CONTAINING PROTEIN', 246075),
(363264, 'PTHR10751:SF107', NULL, NULL, NULL, NULL, 'GUANYLATE-BINDING FAMILY PROTEIN-RELATED', 246075),
(363265, 'PTHR10751:SF29', NULL, NULL, NULL, NULL, 'ATLASTIN', 246075),
(363266, 'PTHR10751:SF81', NULL, NULL, NULL, NULL, 'GUANYLATE-BINDING FAMILY PROTEIN', 246075),
(363267, 'PTHR10751:SF40', NULL, NULL, NULL, NULL, 'GUANYLATE-BINDING PROTEIN 5', 246075),
(363268, 'PTHR10751:SF41', NULL, NULL, NULL, NULL, 'GB1/RHD3-TYPE G DOMAIN-CONTAINING PROTEIN', 246075),
(363269, 'PTHR10751:SF42', NULL, NULL, NULL, NULL, 'ATLASTIN-2', 246075),
(363270, 'PTHR10751:SF100', NULL, NULL, NULL, NULL, 'GUANYLATE-BINDING PROTEIN 1-RELATED', 246075),
(363271, 'PTHR10751:SF122', NULL, NULL, NULL, NULL, 'GB1/RHD3-TYPE G DOMAIN-CONTAINING PROTEIN', 246075),
(363272, 'PTHR10751:SF123', NULL, NULL, NULL, NULL, 'GB1/RHD3-TYPE G DOMAIN-CONTAINING PROTEIN', 246075),
(363273, 'PTHR10751:SF120', NULL, NULL, NULL, NULL, 'GUANYLATE-BINDING FAMILY PROTEIN', 246075);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(363274, 'PTHR10751', NULL, NULL, NULL, NULL, 'GUANYLATE BINDING PROTEIN', 246075),
(363275, 'PTHR10751:SF121', NULL, NULL, NULL, NULL, 'GUANYLATE-BINDING PROTEIN, PUTATIVE-RELATED', 246075),
(363276, 'PTHR10751:SF105', NULL, NULL, NULL, NULL, 'GUANYLATE-BINDING PROTEIN 2-RELATED', 246075),
(363277, 'PTHR10751:SF102', NULL, NULL, NULL, NULL, 'GB1/RHD3-TYPE G DOMAIN-CONTAINING PROTEIN', 246075),
(363278, 'PTHR12890:SF0', NULL, NULL, NULL, NULL, 'PROTEIN-L-HISTIDINE N-PROS-METHYLTRANSFERASE', 246076),
(363279, 'PTHR12890', NULL, NULL, NULL, NULL, 'DREV PROTEIN', 246076),
(363280, 'PTHR13078:SF56', NULL, NULL, NULL, NULL, 'PEROXISOMAL MULTIFUNCTIONAL ENZYME TYPE 2', 246077),
(363281, 'PTHR13078:SF57', NULL, NULL, NULL, NULL, 'DEHYDRATASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G00640)-RELATED', 246077),
(363282, 'PTHR13078', NULL, NULL, NULL, NULL, 'PEROXISOMAL MULTIFUNCTIONAL ENZYME TYPE 2-RELATED', 246077),
(363283, 'PTHR36930:SF1', NULL, NULL, NULL, NULL, 'MOSC DOMAIN-CONTAINING PROTEIN', 246078),
(363284, 'PTHR36930', NULL, NULL, NULL, NULL, 'METAL-SULFUR CLUSTER BIOSYNTHESIS PROTEINS YUAD-RELATED', 246078),
(363285, 'PTHR40642:SF1', NULL, NULL, NULL, NULL, 'YALI0F31295P', 246079),
(363286, 'PTHR40642', NULL, NULL, NULL, NULL, 'YALI0F31295P', 246079),
(363287, 'PTHR22799', NULL, NULL, NULL, NULL, 'TETRANECTIN-RELATED', 246080),
(363288, 'PTHR22799:SF5', NULL, NULL, NULL, NULL, 'DUF5050 DOMAIN-CONTAINING PROTEIN', 246080),
(363289, 'PTHR22799:SF3', NULL, NULL, NULL, NULL, 'TETRANECTIN', 246080),
(363290, 'PTHR22799:SF2', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 3 MEMBER A', 246080),
(363291, 'PTHR22799:SF1', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 11 MEMBER A', 246080),
(363292, 'PTHR35841:SF1', NULL, NULL, NULL, NULL, 'PHOSPHONATES-BINDING PERIPLASMIC PROTEIN', 246081),
(363293, 'PTHR35841', NULL, NULL, NULL, NULL, 'PHOSPHONATES-BINDING PERIPLASMIC PROTEIN', 246081),
(363294, 'PTHR48021:SF62', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246082),
(363295, 'PTHR48021:SF65', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246082),
(363296, 'PTHR48021:SF21', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER ERD6-LIKE 8', 246082),
(363297, 'PTHR48021:SF64', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246082),
(363298, 'PTHR48021:SF20', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER ERD6-LIKE 6', 246082),
(363299, 'PTHR48021:SF61', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER ERD6-LIKE 17-RELATED', 246082),
(363300, 'PTHR48021:SF60', NULL, NULL, NULL, NULL, 'RETROVIRUS-RELATED POL POLYPROTEIN LINE-1', 246082),
(363301, 'PTHR48021:SF29', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246082),
(363302, 'PTHR48021:SF28', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246082),
(363303, 'PTHR48021:SF67', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER ERD6-LIKE 4', 246082),
(363304, 'PTHR48021:SF23', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER ERD6-LIKE 6', 246082),
(363305, 'PTHR48021:SF66', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR, SUGAR TRANSPORTER, MAJOR FACILITATOR SUPERFAMILY-RELATED', 246082),
(363306, 'PTHR48021:SF22', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN-RELATED', 246082),
(363307, 'PTHR48021:SF25', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER ERD6-LIKE 5', 246082),
(363308, 'PTHR48021:SF69', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER ERD6-LIKE 16', 246082),
(363309, 'PTHR48021:SF24', NULL, NULL, NULL, NULL, 'FACILITATED TREHALOSE TRANSPORTER TRET1-2 HOMOLOG-LIKE PROTEIN', 246082),
(363310, 'PTHR48021:SF68', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER ERD6-LIKE 6', 246082),
(363311, 'PTHR48021:SF30', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246082),
(363312, 'PTHR48021:SF73', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246082),
(363313, 'PTHR48021:SF32', NULL, NULL, NULL, NULL, 'FACILITATED TREHALOSE TRANSPORTER TRET1-2 HOMOLOG-LIKE PROTEIN', 246082),
(363314, 'PTHR48021:SF76', NULL, NULL, NULL, NULL, 'MONOSACCHARIDE-SENSING PROTEIN 2-LIKE ISOFORM X1', 246082),
(363315, 'PTHR48021:SF75', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246082);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(363316, 'PTHR48021:SF31', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER ERD6-LIKE 5 ISOFORM X1', 246082),
(363317, 'PTHR48021:SF70', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER ERD6-LIKE 15', 246082),
(363318, 'PTHR48021:SF72', NULL, NULL, NULL, NULL, 'MONOSACCHARIDE-SENSING PROTEIN 1', 246082),
(363319, 'PTHR48021:SF71', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER ERD6-LIKE 14', 246082),
(363320, 'PTHR48021:SF37', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER ERD6-LIKE 16', 246082),
(363321, 'PTHR48021:SF39', NULL, NULL, NULL, NULL, 'AGAP001236-PA', 246082),
(363322, 'PTHR48021:SF34', NULL, NULL, NULL, NULL, 'FACILITATED TREHALOSE TRANSPORTER TRET1-2 HOMOLOG-LIKE PROTEIN', 246082),
(363323, 'PTHR48021:SF78', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246082),
(363324, 'PTHR48021:SF33', NULL, NULL, NULL, NULL, 'AT22075P-RELATED', 246082),
(363325, 'PTHR48021:SF79', NULL, NULL, NULL, NULL, 'OS11G0643800 PROTEIN', 246082),
(363326, 'PTHR48021:SF35', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER ERD6-LIKE 9', 246082),
(363327, 'PTHR48021:SF85', NULL, NULL, NULL, NULL, 'MONOSACCHARIDE-SENSING PROTEIN 2', 246082),
(363328, 'PTHR48021:SF40', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER ERD6', 246082),
(363329, 'PTHR48021:SF87', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR, SUGAR TRANSPORTER, MAJOR FACILITATOR SUPERFAMILY-RELATED', 246082),
(363330, 'PTHR48021:SF43', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER ESL1', 246082),
(363331, 'PTHR48021:SF86', NULL, NULL, NULL, NULL, 'AGAP003492-PA', 246082),
(363332, 'PTHR48021:SF42', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR, SUGAR TRANSPORTER-LIKE, MAJOR FACILITATOR SUPERFAMILY DOMAIN PROTEIN-RELATED', 246082),
(363333, 'PTHR48021:SF83', NULL, NULL, NULL, NULL, 'TONOPLAST MONOSACCHARIDE TRANSPORTER 2', 246082),
(363334, 'PTHR48021:SF82', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER ERD6-LIKE 13-RELATED', 246082),
(363335, 'PTHR48021:SF48', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246082),
(363336, 'PTHR48021:SF89', NULL, NULL, NULL, NULL, 'FI02132P-RELATED', 246082),
(363337, 'PTHR48021:SF45', NULL, NULL, NULL, NULL, 'OS03G0363500 PROTEIN', 246082),
(363338, 'PTHR48021:SF88', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR, SUGAR TRANSPORTER-LIKE, MAJOR FACILITATOR SUPERFAMILY DOMAIN PROTEIN-RELATED', 246082),
(363339, 'PTHR48021:SF47', NULL, NULL, NULL, NULL, 'GH17672P', 246082),
(363340, 'PTHR48021:SF46', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246082),
(363341, 'PTHR48021:SF8', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246082),
(363342, 'PTHR48021:SF51', NULL, NULL, NULL, NULL, 'MONOSACCHARIDE-SENSING PROTEIN 3', 246082),
(363343, 'PTHR48021:SF54', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER ERD6-LIKE 6', 246082),
(363344, 'PTHR48021:SF10', NULL, NULL, NULL, NULL, 'OS11G0620400 PROTEIN', 246082),
(363345, 'PTHR48021:SF92', NULL, NULL, NULL, NULL, 'OS05G0579000 PROTEIN', 246082),
(363346, 'PTHR48021:SF91', NULL, NULL, NULL, NULL, 'GH07001P-RELATED', 246082),
(363347, 'PTHR48021:SF50', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER ERD6-LIKE 10-RELATED', 246082),
(363348, 'PTHR48021:SF93', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER ERD6-LIKE 1-RELATED', 246082),
(363349, 'PTHR48021:SF1', NULL, NULL, NULL, NULL, 'FACILITATED TREHALOSE TRANSPORTER TRET1-1-RELATED', 246082),
(363350, 'PTHR48021:SF90', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER ERD6-LIKE 5 ISOFORM X1', 246082),
(363351, 'PTHR48021:SF2', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE, EXPRESSED-RELATED', 246082),
(363352, 'PTHR48021:SF3', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246082),
(363353, 'PTHR48021:SF4', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER ERD6-LIKE 4', 246082),
(363354, 'PTHR48021:SF5', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246082),
(363355, 'PTHR48021:SF6', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246082),
(363356, 'PTHR48021:SF7', NULL, NULL, NULL, NULL, 'RH09188P', 246082),
(363357, 'PTHR48021:SF19', NULL, NULL, NULL, NULL, 'GENERAL SUBSTRATE TRANSPORTER', 246082),
(363358, 'PTHR48021', NULL, NULL, NULL, NULL, '', 246082);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(363359, 'PTHR48021:SF16', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246082),
(363360, 'PTHR48021:SF59', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 2, FACILITATED GLUCOSE TRANSPORTER MEMBER 6', 246082),
(363361, 'PTHR48021:SF15', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER ERD6-LIKE 15 ISOFORM X1', 246082),
(363362, 'PTHR48021:SF18', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 2, FACILITATED GLUCOSE TRANSPORTER MEMBER 8', 246082),
(363363, 'PTHR48021:SF17', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER ERD6-LIKE 3', 246082),
(363364, 'PTHR48021:SF56', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER ERD6-LIKE 14', 246082),
(363365, 'PTHR48021:SF12', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER ERD6-LIKE 5 ISOFORM X1', 246082),
(363366, 'PTHR48021:SF55', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246082),
(363367, 'PTHR48021:SF11', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER ERD6-LIKE 12', 246082),
(363368, 'PTHR48021:SF58', NULL, NULL, NULL, NULL, 'SUGAR PORTER (SP) FAMILY MFS TRANSPORTER', 246082),
(363369, 'PTHR48021:SF14', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246082),
(363370, 'PTHR48021:SF13', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER ERD6-LIKE 7', 246082),
(363371, 'PTHR13924', NULL, NULL, NULL, NULL, 'TRANSFORMING ACIDIC COILED-COIL CONTAINING PROTEIN 1/2', 246083),
(363372, 'PTHR13924:SF10', NULL, NULL, NULL, NULL, 'TRANSFORMING ACIDIC COILED-COIL PROTEIN, ISOFORM K', 246083),
(363373, 'PTHR13924:SF4', NULL, NULL, NULL, NULL, 'TRANSFORMING ACIDIC COILED-COIL-CONTAINING PROTEIN 3', 246083),
(363374, 'PTHR13924:SF11', NULL, NULL, NULL, NULL, 'TRANSFORMING ACIDIC COILED-COIL-CONTAINING PROTEIN 2', 246083),
(363375, 'PTHR13924:SF12', NULL, NULL, NULL, NULL, 'TRANSFORMING ACIDIC COILED-COIL-CONTAINING PROTEIN 1', 246083),
(363376, 'PTHR32141:SF26', NULL, NULL, NULL, NULL, 'OS12G0595200 PROTEIN', 246084),
(363377, 'PTHR32141:SF152', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246084),
(363378, 'PTHR32141:SF61', NULL, NULL, NULL, NULL, 'OS01G0598400 PROTEIN', 246084),
(363379, 'PTHR32141:SF153', NULL, NULL, NULL, NULL, 'OS06G0685200 PROTEIN', 246084),
(363380, 'PTHR32141:SF150', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 246084),
(363381, 'PTHR32141:SF151', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246084),
(363382, 'PTHR32141:SF156', NULL, NULL, NULL, NULL, '', 246084),
(363383, 'PTHR32141:SF112', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 246084),
(363384, 'PTHR32141:SF157', NULL, NULL, NULL, NULL, 'OS07G0286300 PROTEIN', 246084),
(363385, 'PTHR32141:SF113', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246084),
(363386, 'PTHR32141:SF154', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 246084),
(363387, 'PTHR32141:SF111', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 246084),
(363388, 'PTHR32141:SF155', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN', 246084),
(363389, 'PTHR32141:SF116', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246084),
(363390, 'PTHR32141:SF117', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246084),
(363391, 'PTHR32141:SF114', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246084),
(363392, 'PTHR32141:SF65', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 246084),
(363393, 'PTHR32141:SF63', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246084),
(363394, 'PTHR32141:SF119', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246084),
(363395, 'PTHR32141:SF39', NULL, NULL, NULL, NULL, 'OS01G0715100 PROTEIN', 246084),
(363396, 'PTHR32141:SF37', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 246084),
(363397, 'PTHR32141:SF70', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246084),
(363398, 'PTHR32141:SF123', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 246084),
(363399, 'PTHR32141', NULL, NULL, NULL, NULL, '', 246084),
(363400, 'PTHR32141:SF78', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246084),
(363401, 'PTHR32141:SF34', NULL, NULL, NULL, NULL, 'OS12G0558366 PROTEIN', 246084); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(363402, 'PTHR32141:SF126', NULL, NULL, NULL, NULL, 'OS07G0285200 PROTEIN', 246084),
(363403, 'PTHR32141:SF77', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246084),
(363404, 'PTHR32141:SF74', NULL, NULL, NULL, NULL, 'OS04G0409100 PROTEIN', 246084),
(363405, 'PTHR32141:SF130', NULL, NULL, NULL, NULL, 'F-BOX/FBD/LRR PROTEIN', 246084),
(363406, 'PTHR32141:SF83', NULL, NULL, NULL, NULL, 'OS01G0596700 PROTEIN', 246084),
(363407, 'PTHR32141:SF82', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 246084),
(363408, 'PTHR32141:SF131', NULL, NULL, NULL, NULL, '', 246084),
(363409, 'PTHR32141:SF80', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246084),
(363410, 'PTHR32141:SF134', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246084),
(363411, 'PTHR32141:SF135', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246084),
(363412, 'PTHR32141:SF132', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246084),
(363413, 'PTHR32141:SF133', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246084),
(363414, 'PTHR32141:SF47', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 246084),
(363415, 'PTHR32141:SF138', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246084),
(363416, 'PTHR32141:SF139', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 246084),
(363417, 'PTHR32141:SF46', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 246084),
(363418, 'PTHR32141:SF136', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 246084),
(363419, 'PTHR32141:SF45', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 246084),
(363420, 'PTHR32141:SF89', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 246084),
(363421, 'PTHR32141:SF137', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 246084),
(363422, 'PTHR32141:SF87', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246084),
(363423, 'PTHR32141:SF42', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 246084),
(363424, 'PTHR32141:SF41', NULL, NULL, NULL, NULL, 'OS04G0208500 PROTEIN', 246084),
(363425, 'PTHR32141:SF40', NULL, NULL, NULL, NULL, 'OS06G0492900 PROTEIN', 246084),
(363426, 'PTHR32141:SF84', NULL, NULL, NULL, NULL, 'OS04G0208600 PROTEIN', 246084),
(363427, 'PTHR32141:SF59', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246084),
(363428, 'PTHR32141:SF141', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 246084),
(363429, 'PTHR32141:SF50', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246084),
(363430, 'PTHR32141:SF94', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246084),
(363431, 'PTHR32141:SF142', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246084),
(363432, 'PTHR32141:SF91', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246084),
(363433, 'PTHR32141:SF140', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246084),
(363434, 'PTHR32141:SF145', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246084),
(363435, 'PTHR32141:SF146', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246084),
(363436, 'PTHR32141:SF143', NULL, NULL, NULL, NULL, 'FBD PROTEIN', 246084),
(363437, 'PTHR32141:SF144', NULL, NULL, NULL, NULL, 'OS07G0277500 PROTEIN', 246084),
(363438, 'PTHR32141:SF149', NULL, NULL, NULL, NULL, 'OS01G0596100 PROTEIN', 246084),
(363439, 'PTHR32141:SF105', NULL, NULL, NULL, NULL, 'OS01G0706266 PROTEIN', 246084),
(363440, 'PTHR32141:SF58', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246084),
(363441, 'PTHR32141:SF106', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 246084),
(363442, 'PTHR32141:SF147', NULL, NULL, NULL, NULL, 'CYCLIN-LIKE F-BOX', 246084),
(363443, 'PTHR32141:SF148', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246084),
(363444, 'PTHR32141:SF98', NULL, NULL, NULL, NULL, '', 246084),
(363445, 'PTHR32141:SF97', NULL, NULL, NULL, NULL, 'OS04G0231400 PROTEIN', 246084),
(363446, 'PTHR32141:SF53', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 246084),
(363447, 'PTHR32141:SF96', NULL, NULL, NULL, NULL, 'OS01G0730100 PROTEIN', 246084);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(363448, 'PTHR32141:SF52', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246084),
(363449, 'PTHR32141:SF107', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 246084),
(363450, 'PTHR46820:SF1', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SETD7', 246085),
(363451, 'PTHR46820', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SETD7', 246085),
(363452, 'PTHR13621:SF2', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN PRCC', 246086),
(363453, 'PTHR13621', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN PRCC', 246086),
(363454, 'PTHR44591:SF3', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 246087),
(363455, 'PTHR44591:SF21', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 246087),
(363456, 'PTHR44591:SF20', NULL, NULL, NULL, NULL, 'PROTEIN PILH', 246087),
(363457, 'PTHR44591:SF23', NULL, NULL, NULL, NULL, 'CHEY SUBFAMILY', 246087),
(363458, 'PTHR44591:SF22', NULL, NULL, NULL, NULL, 'CHEY SUBFAMILY', 246087),
(363459, 'PTHR44591', NULL, NULL, NULL, NULL, 'STRESS RESPONSE REGULATOR PROTEIN 1', 246087),
(363460, 'PTHR44591:SF18', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN-RELATED', 246087),
(363461, 'PTHR44591:SF17', NULL, NULL, NULL, NULL, 'TWO-COMPONENT SYSTEM REGULATORY PROTEIN', 246087),
(363462, 'PTHR44591:SF19', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR-RELATED', 246087),
(363463, 'PTHR44591:SF7', NULL, NULL, NULL, NULL, 'PROTEIN PILG', 246087),
(363464, 'PTHR44591:SF14', NULL, NULL, NULL, NULL, 'PROTEIN-GLUTAMATE METHYLESTERASE/PROTEIN-GLUTAMINE GLUTAMINASE 1', 246087),
(363465, 'PTHR35005:SF1', NULL, NULL, NULL, NULL, '3-DEHYDRO-SCYLLO-INOSOSE HYDROLASE', 246088),
(363466, 'PTHR35005', NULL, NULL, NULL, NULL, '3-DEHYDRO-SCYLLO-INOSOSE HYDROLASE', 246088),
(363467, 'PTHR43366:SF1', NULL, NULL, NULL, NULL, 'PYRUVATE SYNTHASE SUBUNIT PORC', 246089),
(363468, 'PTHR43366', NULL, NULL, NULL, NULL, 'PYRUVATE SYNTHASE SUBUNIT PORC', 246089),
(363469, 'PTHR45046:SF1', NULL, NULL, NULL, NULL, 'V-SET AND IMMUNOGLOBULIN DOMAIN-CONTAINING PROTEIN 2', 246090),
(363470, 'PTHR45046', NULL, NULL, NULL, NULL, 'V-SET AND IMMUNOGLOBULIN DOMAIN-CONTAINING PROTEIN 2', 246090),
(363471, 'PTHR28588:SF1', NULL, NULL, NULL, NULL, 'HAUS AUGMIN-LIKE COMPLEX SUBUNIT 5', 246091),
(363472, 'PTHR28588', NULL, NULL, NULL, NULL, 'HAUS AUGMIN-LIKE COMPLEX SUBUNIT 5', 246091),
(363473, 'PTHR24179:SF18', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 12B', 246092),
(363474, 'PTHR24179:SF29', NULL, NULL, NULL, NULL, 'LD46604P', 246092),
(363475, 'PTHR24179:SF30', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 16A', 246092),
(363476, 'PTHR24179:SF20', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 12A', 246092),
(363477, 'PTHR24179:SF31', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY INHIBITOR SUBUNIT 16B', 246092),
(363478, 'PTHR24179:SF21', NULL, NULL, NULL, NULL, 'MYOSIN BINDING SUBUNIT, ISOFORM O', 246092),
(363479, 'PTHR24179:SF27', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 12C', 246092),
(363480, 'PTHR24179', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 12', 246092),
(363481, 'PTHR19353:SF13', NULL, NULL, NULL, NULL, 'FATTY ACID DESATURASE 6', 246093),
(363482, 'PTHR19353:SF57', NULL, NULL, NULL, NULL, 'ACYL-COA (8-3)-DESATURASE', 246093),
(363483, 'PTHR19353:SF37', NULL, NULL, NULL, NULL, 'DELTA(5) FATTY ACID DESATURASE A', 246093),
(363484, 'PTHR19353:SF15', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 HEME-BINDING DOMAIN-CONTAINING PROTEIN', 246093),
(363485, 'PTHR19353:SF76', NULL, NULL, NULL, NULL, 'DELTA 8-(E)-SPHINGOLIPID DESATURASE', 246093),
(363486, 'PTHR19353:SF75', NULL, NULL, NULL, NULL, 'FATTY ACID DESATURASE, PUTATIVE-RELATED', 246093),
(363487, 'PTHR19353:SF12', NULL, NULL, NULL, NULL, 'ACYL-COA 6-DESATURASE', 246093),
(363488, 'PTHR19353:SF11', NULL, NULL, NULL, NULL, 'FATTY ACID DESATURASE 3', 246093),
(363489, 'PTHR19353:SF17', NULL, NULL, NULL, NULL, 'FA_DESATURASE DOMAIN-CONTAINING PROTEIN', 246093);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(363490, 'PTHR19353:SF19', NULL, NULL, NULL, NULL, 'DELTA(5) FATTY ACID DESATURASE FAT-4', 246093),
(363491, 'PTHR19353:SF71', NULL, NULL, NULL, NULL, 'DELTA(8)-FATTY-ACID DESATURASE-LIKE', 246093),
(363492, 'PTHR19353:SF74', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 HEME-BINDING DOMAIN-CONTAINING PROTEIN', 246093),
(363493, 'PTHR19353:SF30', NULL, NULL, NULL, NULL, 'DELTA 8-(E)-SPHINGOLIPID DESATURASE', 246093),
(363494, 'PTHR19353', NULL, NULL, NULL, NULL, 'FATTY ACID DESATURASE 2', 246093),
(363495, 'PTHR19353:SF73', NULL, NULL, NULL, NULL, 'FATTY ACID DESATURASE', 246093),
(363496, 'PTHR19353:SF69', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 HEME-BINDING DOMAIN-CONTAINING PROTEIN', 246093),
(363497, 'PTHR19353:SF67', NULL, NULL, NULL, NULL, 'DELTA(8)-FATTY-ACID DESATURASE 2', 246093),
(363498, 'PTHR19353:SF22', NULL, NULL, NULL, NULL, 'FATTY ACID DESATURASE 2-LIKE PROTEIN FADS2B-RELATED', 246093),
(363499, 'PTHR19353:SF28', NULL, NULL, NULL, NULL, 'DELTA(8)-FATTY-ACID DESATURASE 2', 246093),
(363500, 'PTHR19353:SF83', NULL, NULL, NULL, NULL, 'DELTA(6)-FATTY-ACID DESATURASE FAT-3', 246093),
(363501, 'PTHR19353:SF82', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 HEME-BINDING DOMAIN-CONTAINING PROTEIN', 246093),
(363502, 'PTHR19353:SF85', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 HEME-BINDING DOMAIN-CONTAINING PROTEIN', 246093),
(363503, 'PTHR19353:SF63', NULL, NULL, NULL, NULL, 'DELTA(8)-FATTY-ACID DESATURASE 1', 246093),
(363504, 'PTHR19353:SF84', NULL, NULL, NULL, NULL, 'ACYL-COA DELTA-9-DESATURASE, DESB', 246093),
(363505, 'PTHR19353:SF81', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 HEME-BINDING DOMAIN-CONTAINING PROTEIN', 246093),
(363506, 'PTHR19353:SF80', NULL, NULL, NULL, NULL, 'ACYL-LIPID (8-3)-DESATURASE B', 246093),
(363507, 'PTHR45849:SF2', NULL, NULL, NULL, NULL, 'FACT COMPLEX SUBUNIT SSRP1-B', 246094),
(363508, 'PTHR45849:SF1', NULL, NULL, NULL, NULL, 'FACT COMPLEX SUBUNIT SSRP1', 246094),
(363509, 'PTHR45849:SF3', NULL, NULL, NULL, NULL, 'HISTONE CHAPERONE RTT106', 246094),
(363510, 'PTHR45849:SF6', NULL, NULL, NULL, NULL, 'FACT COMPLEX SUBUNIT SSRP1', 246094),
(363511, 'PTHR45849', NULL, NULL, NULL, NULL, 'FACT COMPLEX SUBUNIT SSRP1', 246094),
(363512, 'PTHR37849:SF1', NULL, NULL, NULL, NULL, 'YALI0E11605P', 246095),
(363513, 'PTHR37849', NULL, NULL, NULL, NULL, 'YALI0E11605P', 246095),
(363514, 'PTHR43787', NULL, NULL, NULL, NULL, 'FEMO COFACTOR BIOSYNTHESIS PROTEIN NIFB-RELATED', 246096),
(363515, 'PTHR43787:SF10', NULL, NULL, NULL, NULL, 'COFACTOR MODIFYING PROTEIN-RELATED', 246096),
(363516, 'PTHR43787:SF8', NULL, NULL, NULL, NULL, 'PYRUVATE FORMATE-LYASE ACTIVATING ENZYME HOMOLOG', 246096),
(363517, 'PTHR43787:SF11', NULL, NULL, NULL, NULL, 'UPF0026 PROTEIN SLR1464', 246096),
(363518, 'PTHR43787:SF12', NULL, NULL, NULL, NULL, 'ELP3 DOMAIN-CONTAINING PROTEIN', 246096),
(363519, 'PTHR43787:SF3', NULL, NULL, NULL, NULL, 'FEMO COFACTOR BIOSYNTHESIS PROTEIN NIFB', 246096),
(363520, 'PTHR28259:SF18', NULL, NULL, NULL, NULL, 'FLUORIDE ION TRANSPORTER CRCB-RELATED', 246097),
(363521, 'PTHR28259:SF16', NULL, NULL, NULL, NULL, 'FLUORIDE ION TRANSPORTER CRCB 2-RELATED', 246097),
(363522, 'PTHR28259:SF15', NULL, NULL, NULL, NULL, 'BNAC04G02030D PROTEIN', 246097),
(363523, 'PTHR28259', NULL, NULL, NULL, NULL, 'FLUORIDE EXPORT PROTEIN 1-RELATED', 246097),
(363524, 'PTHR28259:SF1', NULL, NULL, NULL, NULL, 'FLUORIDE EXPORT PROTEIN 1-RELATED', 246097),
(363525, 'PTHR12042', NULL, NULL, NULL, NULL, 'LACTOSYLCERAMIDE 4-ALPHA-GALACTOSYLTRANSFERASE  ALPHA- 1,4-GALACTOSYLTRANSFERASE', 246098),
(363526, 'PTHR12042:SF21', NULL, NULL, NULL, NULL, 'ALPHA-1,4-N-ACETYLGLUCOSAMINYLTRANSFERASE', 246098),
(363527, 'PTHR12042:SF16', NULL, NULL, NULL, NULL, 'ALPHA-1,4-N-ACETYLGLUCOSAMINYLTRANSFERASE', 246098),
(363528, 'PTHR12042:SF17', NULL, NULL, NULL, NULL, 'LACTOSYLCERAMIDE 4-ALPHA-GALACTOSYLTRANSFERASE', 246098),
(363529, 'PTHR15222:SF3', NULL, NULL, NULL, NULL, 'COMPLEX I-MNLL', 246099),
(363530, 'PTHR15222:SF4', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 BETA SUBCOMPLEX SUBUNIT 1', 246099),
(363531, 'PTHR15222:SF2', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 BETA SUBCOMPLEX SUBUNIT 1', 246099);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(363532, 'PTHR15222:SF5', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 BETA SUBCOMPLEX SUBUNIT 1', 246099),
(363533, 'PTHR15222', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 BETA SUBCOMPLEX SUBUNIT 1', 246099),
(363534, 'PTHR15336:SF0', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 6, MITOCHONDRIAL', 246100),
(363535, 'PTHR15336:SF18', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 6-1, MITOCHONDRIAL', 246100),
(363536, 'PTHR15336:SF19', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 6-2, MITOCHONDRIAL', 246100),
(363537, 'PTHR15336:SF6', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 6-LIKE, MITOCHONDRIAL', 246100),
(363538, 'PTHR15336', NULL, NULL, NULL, NULL, 'UBIQUINOL-CYTOCHROME C REDUCTASE COMPLEX 7.8 KDA PROTEIN', 246100),
(363539, 'PTHR15336:SF8', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 6', 246100),
(363540, 'PTHR15336:SF12', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 6', 246100),
(363541, 'PTHR15336:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 6', 246100),
(363542, 'PTHR15336:SF13', NULL, NULL, NULL, NULL, 'UCR_HINGE DOMAIN-CONTAINING PROTEIN', 246100),
(363543, 'PTHR15336:SF10', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 6', 246100),
(363544, 'PTHR15336:SF3', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 6, MITOCHONDRIAL', 246100),
(363545, 'PTHR35278:SF3', NULL, NULL, NULL, NULL, 'HAP2-GCS1 DOMAIN-CONTAINING PROTEIN', 246101),
(363546, 'PTHR35278:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 246101),
(363547, 'PTHR35278', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN-RELATED', 246101),
(363548, 'PTHR35278:SF1', NULL, NULL, NULL, NULL, 'F8K7.16', 246101),
(363549, 'PTHR38095:SF2', NULL, NULL, NULL, NULL, 'ANAEROBIC DIMETHYL SULFOXIDE REDUCTASE CHAIN C', 246102),
(363550, 'PTHR38095:SF3', NULL, NULL, NULL, NULL, 'ANAEROBIC DIMETHYL SULFOXIDE REDUCTASE, SUBUNIT C-RELATED', 246102),
(363551, 'PTHR38095:SF1', NULL, NULL, NULL, NULL, 'ANAEROBIC DIMETHYL SULFOXIDE REDUCTASE CHAIN YNFH', 246102),
(363552, 'PTHR38095', NULL, NULL, NULL, NULL, 'ANAEROBIC DIMETHYL SULFOXIDE REDUCTASE CHAIN YNFH', 246102),
(363553, 'PTHR13276:SF0', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE EXCHANGE FACTOR MSS4', 246103),
(363554, 'PTHR13276:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG02782', 246103),
(363555, 'PTHR13276', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE EXCHANGE FACTOR MSS4', 246103),
(363556, 'PTHR37341', NULL, NULL, NULL, NULL, 'PROTEIN INCA1', 246104),
(363557, 'PTHR37341:SF1', NULL, NULL, NULL, NULL, 'PROTEIN INCA1', 246104),
(363558, 'PTHR36471:SF1', NULL, NULL, NULL, NULL, 'SMALL MEMBRANE A-KINASE ANCHOR PROTEIN', 246105),
(363559, 'PTHR36471', NULL, NULL, NULL, NULL, 'SMALL MEMBRANE A-KINASE ANCHOR PROTEIN', 246105),
(363560, 'PTHR46600:SF9', NULL, NULL, NULL, NULL, 'ZGC:153292', 246106),
(363561, 'PTHR46600:SF7', NULL, NULL, NULL, NULL, 'THAP DOMAIN-CONTAINING PROTEIN 1-RELATED', 246106),
(363562, 'PTHR46600:SF2', NULL, NULL, NULL, NULL, 'SI:CH73-382F3.1', 246106),
(363563, 'PTHR46600:SF1', NULL, NULL, NULL, NULL, 'THAP-TYPE DOMAIN-CONTAINING PROTEIN', 246106),
(363564, 'PTHR46600:SF10', NULL, NULL, NULL, NULL, 'THAP DOMAIN-CONTAINING PROTEIN 10', 246106),
(363565, 'PTHR46600:SF5', NULL, NULL, NULL, NULL, 'THAP DOMAIN-CONTAINING PROTEIN 1', 246106),
(363566, 'PTHR46600:SF3', NULL, NULL, NULL, NULL, 'SI:DKEY-228B2.6-RELATED', 246106),
(363567, 'PTHR46600', NULL, NULL, NULL, NULL, 'THAP DOMAIN-CONTAINING', 246106),
(363568, 'PTHR10780:SF18', NULL, NULL, NULL, NULL, 'LD43650P', 246107),
(363569, 'PTHR10780:SF3', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CARRIER HOMOLOG 1', 246107),
(363570, 'PTHR10780', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CARRIER HOMOLOG', 246107),
(363571, 'PTHR10780:SF20', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CARRIER HOMOLOG 2', 246107),
(363572, 'PTHR36924', NULL, NULL, NULL, NULL, 'ANTITOXIN HIGA-1', 246108),
(363573, 'PTHR36924:SF1', NULL, NULL, NULL, NULL, 'ANTITOXIN HIGA-1', 246108),
(363574, 'PTHR48316:SF1', NULL, NULL, NULL, NULL, '', 246109);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(363575, 'PTHR48316', NULL, NULL, NULL, NULL, '', 246109),
(363576, 'PTHR36382', NULL, NULL, NULL, NULL, 'OSJNBA0043L09.26 PROTEIN', 246110),
(363577, 'PTHR36382:SF2', NULL, NULL, NULL, NULL, 'OS04G0635700 PROTEIN', 246110),
(363578, 'PTHR19370:SF183', NULL, NULL, NULL, NULL, 'NADH-CYTOCHROME B5 REDUCTASE', 246111),
(363579, 'PTHR19370:SF185', NULL, NULL, NULL, NULL, 'NADH-CYTOCHROME B5 REDUCTASE', 246111),
(363580, 'PTHR19370:SF184', NULL, NULL, NULL, NULL, 'NADH-CYTOCHROME B5 REDUCTASE-LIKE', 246111),
(363581, 'PTHR19370:SF121', NULL, NULL, NULL, NULL, 'NADH-CYTOCHROME B5 REDUCTASE 3', 246111),
(363582, 'PTHR19370:SF143', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE-ASSOCIATED COENZYME Q6 REDUCTASE PGA3', 246111),
(363583, 'PTHR19370:SF200', NULL, NULL, NULL, NULL, 'NADH-CYTOCHROME B5 REDUCTASE', 246111),
(363584, 'PTHR19370:SF189', NULL, NULL, NULL, NULL, 'CYTOCHROME C MITOCHONDRIAL IMPORT FACTOR CYC2', 246111),
(363585, 'PTHR19370:SF101', NULL, NULL, NULL, NULL, 'NADH-CYTOCHROME B5 REDUCTASE', 246111),
(363586, 'PTHR19370:SF100', NULL, NULL, NULL, NULL, 'NITRATE REDUCTASE', 246111),
(363587, 'PTHR19370:SF188', NULL, NULL, NULL, NULL, 'NITRATE REDUCTASE [NADH] 3', 246111),
(363588, 'PTHR19370:SF201', NULL, NULL, NULL, NULL, 'NADH-CYTOCHROME B5 REDUCTASE', 246111),
(363589, 'PTHR19370:SF204', NULL, NULL, NULL, NULL, 'NADH-CYTOCHROME B5 REDUCTASE', 246111),
(363590, 'PTHR19370:SF203', NULL, NULL, NULL, NULL, 'NADH-CYTOCHROME B5 REDUCTASE', 246111),
(363591, 'PTHR19370', NULL, NULL, NULL, NULL, 'NADH-CYTOCHROME B5 REDUCTASE', 246111),
(363592, 'PTHR19370:SF190', NULL, NULL, NULL, NULL, 'NADH-CYTOCHROME B5 REDUCTASE-LIKE PROTEIN', 246111),
(363593, 'PTHR19370:SF171', NULL, NULL, NULL, NULL, 'NADH-CYTOCHROME B5 REDUCTASE 2', 246111),
(363594, 'PTHR19370:SF131', NULL, NULL, NULL, NULL, 'B5 REDUCTASE, PUTATIVE-RELATED', 246111),
(363595, 'PTHR19370:SF211', NULL, NULL, NULL, NULL, 'NITRATE REDUCTASE [NADPH]', 246111),
(363596, 'PTHR19370:SF178', NULL, NULL, NULL, NULL, 'B5 REDUCTASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G10060)-RELATED', 246111),
(363597, 'PTHR19370:SF210', NULL, NULL, NULL, NULL, 'NITRATE REDUCTASE [NADH] 2', 246111),
(363598, 'PTHR19370:SF179', NULL, NULL, NULL, NULL, 'B5 REDUCTASE, PUTATIVE-RELATED', 246111),
(363599, 'PTHR19370:SF205', NULL, NULL, NULL, NULL, 'FAD-BINDING FR-TYPE DOMAIN-CONTAINING PROTEIN', 246111),
(363600, 'PTHR19370:SF108', NULL, NULL, NULL, NULL, 'NADH-CYTOCHROME B5 REDUCTASE 2', 246111),
(363601, 'PTHR19370:SF207', NULL, NULL, NULL, NULL, '', 246111),
(363602, 'PTHR19370:SF74', NULL, NULL, NULL, NULL, 'NADH-CYTOCHROME B5 REDUCTASE 1', 246111),
(363603, 'PTHR19370:SF79', NULL, NULL, NULL, NULL, 'NADH-CYTOCHROME B5 REDUCTASE', 246111),
(363604, 'PTHR47791:SF4', NULL, NULL, NULL, NULL, 'HYDROLASE (PUTATIVE SECRETED PROTEIN)-RELATED', 246112),
(363605, 'PTHR47791:SF3', NULL, NULL, NULL, NULL, 'MEIOTICALLY UP-REGULATED GENE 191 PROTEIN', 246112),
(363606, 'PTHR47791', NULL, NULL, NULL, NULL, 'MEIOTICALLY UP-REGULATED GENE 191 PROTEIN', 246112),
(363607, 'PTHR47791:SF2', NULL, NULL, NULL, NULL, 'ENDO MANNANASE, GH76 FAMILY (EUROFUNG)-RELATED', 246112),
(363608, 'PTHR47791:SF1', NULL, NULL, NULL, NULL, 'ENDO MANNANASE, GH76 FAMILY (EUROFUNG)-RELATED', 246112),
(363609, 'PTHR40260', NULL, NULL, NULL, NULL, 'BLR8190 PROTEIN', 246113),
(363610, 'PTHR40260:SF2', NULL, NULL, NULL, NULL, 'BLR8190 PROTEIN', 246113),
(363611, 'PTHR10057:SF16', NULL, NULL, NULL, NULL, 'PERIPHERAL-TYPE BENZODIAZEPINE RECEPTOR-RELATED', 246114),
(363612, 'PTHR10057:SF18', NULL, NULL, NULL, NULL, 'BNAC04G00110D PROTEIN', 246114),
(363613, 'PTHR10057:SF17', NULL, NULL, NULL, NULL, 'TSPO/MBR-RELATED PROTEIN-RELATED', 246114),
(363614, 'PTHR10057:SF5', NULL, NULL, NULL, NULL, 'TRANSLOCATOR PROTEIN', 246114),
(363615, 'PTHR10057:SF4', NULL, NULL, NULL, NULL, 'TRANSLOCATOR PROTEIN 2', 246114),
(363616, 'PTHR10057', NULL, NULL, NULL, NULL, 'PERIPHERAL-TYPE BENZODIAZEPINE RECEPTOR', 246114),
(363617, 'PTHR10057:SF20', NULL, NULL, NULL, NULL, '', 246114),
(363618, 'PTHR10057:SF6', NULL, NULL, NULL, NULL, 'TSPO/MBR FAMILY PROTEIN', 246114);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(363619, 'PTHR10057:SF0', NULL, NULL, NULL, NULL, 'TRANSLOCATOR PROTEIN', 246114),
(363620, 'PTHR10057:SF19', NULL, NULL, NULL, NULL, '', 246114),
(363621, 'PTHR28675:SF2', NULL, NULL, NULL, NULL, 'MELANOCORTIN-2 RECEPTOR ACCESSORY PROTEIN', 246115),
(363622, 'PTHR28675:SF1', NULL, NULL, NULL, NULL, 'MELANOCORTIN-2 RECEPTOR ACCESSORY PROTEIN 2', 246115),
(363623, 'PTHR28675', NULL, NULL, NULL, NULL, 'MELANOCORTIN-2 RECEPTOR ACCESSORY PROTEIN 2', 246115),
(363624, 'PTHR13759:SF8', NULL, NULL, NULL, NULL, 'TWINFILIN-1', 246116),
(363625, 'PTHR13759', NULL, NULL, NULL, NULL, 'TWINFILIN', 246116),
(363626, 'PTHR13759:SF9', NULL, NULL, NULL, NULL, 'TWINFILIN-2', 246116),
(363627, 'PTHR13759:SF1', NULL, NULL, NULL, NULL, 'TWINFILIN', 246116),
(363628, 'PTHR46296:SF8', NULL, NULL, NULL, NULL, 'C2 CALCIUM/LIPID-BINDING AND GRAM DOMAIN CONTAINING PROTEIN', 246117),
(363629, 'PTHR46296:SF7', NULL, NULL, NULL, NULL, 'C2 AND GRAM DOMAIN-CONTAINING PROTEIN', 246117),
(363630, 'PTHR46296:SF6', NULL, NULL, NULL, NULL, 'C2 AND GRAM DOMAIN PLANT-LIKE PROTEIN', 246117),
(363631, 'PTHR46296', NULL, NULL, NULL, NULL, 'BNAA05G37250D PROTEIN', 246117),
(363632, 'PTHR46296:SF1', NULL, NULL, NULL, NULL, 'C2 AND GRAM DOMAIN-CONTAINING PROTEIN', 246117),
(363633, 'PTHR46296:SF4', NULL, NULL, NULL, NULL, 'OS02G0199800 PROTEIN', 246117),
(363634, 'PTHR46296:SF2', NULL, NULL, NULL, NULL, 'C2 AND GRAM DOMAIN-CONTAINING PROTEIN', 246117),
(363635, 'PTHR11647:SF55', NULL, NULL, NULL, NULL, 'DIHYDROPYRIMIDINASE-RELATED PROTEIN 4', 246118),
(363636, 'PTHR11647:SF56', NULL, NULL, NULL, NULL, 'DIHYDROPYRIMIDINASE-RELATED PROTEIN 2', 246118),
(363637, 'PTHR11647:SF65', NULL, NULL, NULL, NULL, 'DIHYDROPYRIMIDINASE 1', 246118),
(363638, 'PTHR11647:SF54', NULL, NULL, NULL, NULL, 'DIHYDROPYRIMIDINASE-RELATED PROTEIN 1', 246118),
(363639, 'PTHR11647:SF57', NULL, NULL, NULL, NULL, 'DIHYDROPYRIMIDINASE-RELATED PROTEIN 3', 246118),
(363640, 'PTHR11647', NULL, NULL, NULL, NULL, 'HYDRANTOINASE/DIHYDROPYRIMIDINASE FAMILY MEMBER', 246118),
(363641, 'PTHR11647:SF58', NULL, NULL, NULL, NULL, 'DIHYDROPYRIMIDINASE-RELATED PROTEIN 5', 246118),
(363642, 'PTHR11647:SF1', NULL, NULL, NULL, NULL, 'COLLAPSIN RESPONSE MEDIATOR PROTEIN', 246118),
(363643, 'PTHR11647:SF74', NULL, NULL, NULL, NULL, 'PROTEIN UNC-33', 246118),
(363644, 'PTHR11647:SF96', NULL, NULL, NULL, NULL, 'AMIDOHYDRO-REL DOMAIN-CONTAINING PROTEIN', 246118),
(363645, 'PTHR11647:SF94', NULL, NULL, NULL, NULL, 'DIHYDROPYRIMIDINASE-RELATED PROTEIN 2', 246118),
(363646, 'PTHR11647:SF50', NULL, NULL, NULL, NULL, 'DIHYDROPYRIMIDINASE', 246118),
(363647, 'PTHR30458', NULL, NULL, NULL, NULL, 'PHENYLACETIC ACID DEGRADATION PROTEIN PAA', 246119),
(363648, 'PTHR30458:SF2', NULL, NULL, NULL, NULL, '1,2-PHENYLACETYL-COA EPOXIDASE, SUBUNIT A', 246119),
(363649, 'PTHR30458:SF0', NULL, NULL, NULL, NULL, '1,2-PHENYLACETYL-COA EPOXIDASE, SUBUNIT C', 246119),
(363650, 'PTHR21351', NULL, NULL, NULL, NULL, 'BARDET-BIEDL SYNDROME PROTEIN 5', 246120),
(363651, 'PTHR21351:SF0', NULL, NULL, NULL, NULL, 'BARDET-BIEDL SYNDROME 5 PROTEIN', 246120),
(363652, 'PTHR46097', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR KINASE INTERACTING ARFGAP', 246121),
(363653, 'PTHR46097:SF3', NULL, NULL, NULL, NULL, 'ARF GTPASE-ACTIVATING PROTEIN GIT', 246121),
(363654, 'PTHR46097:SF4', NULL, NULL, NULL, NULL, 'ARF GTPASE-ACTIVATING PROTEIN GIT2', 246121),
(363655, 'PTHR46097:SF1', NULL, NULL, NULL, NULL, 'ARF GTPASE-ACTIVATING PROTEIN GIT1', 246121),
(363656, 'PTHR46097:SF2', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR KINASE-INTERACTING ARFGAP 2B', 246121),
(363657, 'PTHR35096:SF8', NULL, NULL, NULL, NULL, 'BNAC08G44720D PROTEIN', 246122),
(363658, 'PTHR35096:SF10', NULL, NULL, NULL, NULL, 'OS03G0308700 PROTEIN', 246122),
(363659, 'PTHR35096', NULL, NULL, NULL, NULL, 'BNAA08G28570D PROTEIN', 246122),
(363660, 'PTHR35096:SF13', NULL, NULL, NULL, NULL, 'BNAA08G28570D PROTEIN', 246122),
(363661, 'PTHR35096:SF12', NULL, NULL, NULL, NULL, '', 246122),
(363662, 'PTHR33351:SF1', NULL, NULL, NULL, NULL, 'HISACTOPHILIN-1-RELATED', 246123);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(363663, 'PTHR33351', NULL, NULL, NULL, NULL, 'HISACTOPHILIN-1-RELATED', 246123),
(363664, 'PTHR21284:SF6', NULL, NULL, NULL, NULL, 'SINUOUS', 246124),
(363665, 'PTHR21284', NULL, NULL, NULL, NULL, 'EG:80H7.2 PROTEIN', 246124),
(363666, 'PTHR21284:SF11', NULL, NULL, NULL, NULL, 'KUNE-KUNE', 246124),
(363667, 'PTHR21284:SF12', NULL, NULL, NULL, NULL, 'EG:80H7.2 PROTEIN', 246124),
(363668, 'PTHR32226', NULL, NULL, NULL, NULL, 'TELO2-INTERACTING PROTEIN 2', 246125),
(363669, 'PTHR32226:SF2', NULL, NULL, NULL, NULL, 'TELO2-INTERACTING PROTEIN 2', 246125),
(363670, 'PTHR36365:SF1', NULL, NULL, NULL, NULL, 'OS05G0500400 PROTEIN', 246126),
(363671, 'PTHR36365', NULL, NULL, NULL, NULL, 'OS05G0500400 PROTEIN', 246126),
(363672, 'PTHR36332:SF1', NULL, NULL, NULL, NULL, 'STRESS RESPONSE PROTEIN', 246127),
(363673, 'PTHR36332', NULL, NULL, NULL, NULL, 'STRESS RESPONSE PROTEIN', 246127),
(363674, 'PTHR40738:SF1', NULL, NULL, NULL, NULL, '', 246128),
(363675, 'PTHR40738', NULL, NULL, NULL, NULL, '', 246128),
(363676, 'PTHR18875:SF8', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 18', 246129),
(363677, 'PTHR18875', NULL, NULL, NULL, NULL, 'SARCOMA ANTIGEN NY-SAR-24/CYTOSKELETAL PROTEIN SOJO', 246129),
(363678, 'PTHR18875:SF5', NULL, NULL, NULL, NULL, 'DEUTEROSOME ASSEMBLY PROTEIN 1', 246129),
(363679, 'PTHR18875:SF7', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 63 KDA', 246129),
(363680, 'PTHR18875:SF3', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 63 KDA', 246129),
(363681, 'PTHR41251', NULL, NULL, NULL, NULL, 'NON-HOMOLOGOUS END JOINING PROTEIN KU', 246130),
(363682, 'PTHR41251:SF1', NULL, NULL, NULL, NULL, 'NON-HOMOLOGOUS END JOINING PROTEIN KU', 246130),
(363683, 'PTHR33743:SF29', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 246131),
(363684, 'PTHR33743:SF4', NULL, NULL, NULL, NULL, 'OS06G0179600 PROTEIN', 246131),
(363685, 'PTHR33743:SF19', NULL, NULL, NULL, NULL, 'PROTEIN GOLVEN 6', 246131),
(363686, 'PTHR33743:SF25', NULL, NULL, NULL, NULL, '', 246131),
(363687, 'PTHR33743:SF27', NULL, NULL, NULL, NULL, 'ROOT MERISTEM GROWTH FACTOR 8-RELATED', 246131),
(363688, 'PTHR33743:SF16', NULL, NULL, NULL, NULL, 'PROTEIN GOLVEN 2', 246131),
(363689, 'PTHR33743:SF28', NULL, NULL, NULL, NULL, '', 246131),
(363690, 'PTHR33743:SF21', NULL, NULL, NULL, NULL, 'BNAC02G43300D PROTEIN', 246131),
(363691, 'PTHR33743:SF22', NULL, NULL, NULL, NULL, 'OS02G0799200 PROTEIN', 246131),
(363692, 'PTHR33743:SF13', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 246131),
(363693, 'PTHR33743:SF30', NULL, NULL, NULL, NULL, '', 246131),
(363694, 'PTHR33743:SF31', NULL, NULL, NULL, NULL, 'OS04G0643800 PROTEIN', 246131),
(363695, 'PTHR33743', NULL, NULL, NULL, NULL, 'PROTEIN GOLVEN 6-RELATED', 246131),
(363696, 'PTHR46123:SF3', NULL, NULL, NULL, NULL, 'DOUBLE HOMEOBOX PROTEIN 1-RELATED', 246132),
(363697, 'PTHR46123:SF4', NULL, NULL, NULL, NULL, 'MIX-TYPE HOMEOBOX GENE 1-RELATED', 246132),
(363698, 'PTHR46123:SF5', NULL, NULL, NULL, NULL, 'DOUBLE HOMEOBOX PROTEIN B', 246132),
(363699, 'PTHR46123', NULL, NULL, NULL, NULL, 'MIX-TYPE HOMEOBOX GENE 1-RELATED', 246132),
(363700, 'PTHR46123:SF1', NULL, NULL, NULL, NULL, 'DOUBLE HOMEOBOX PROTEIN A', 246132),
(363701, 'PTHR13287:SF2', NULL, NULL, NULL, NULL, 'UPF0687 PROTEIN C20ORF27 HOMOLOG', 246133),
(363702, 'PTHR13287:SF7', NULL, NULL, NULL, NULL, 'SI:CH211-74F19.2', 246133),
(363703, 'PTHR13287:SF6', NULL, NULL, NULL, NULL, 'UPF0687 PROTEIN C20ORF27', 246133),
(363704, 'PTHR13287:SF5', NULL, NULL, NULL, NULL, '', 246133),
(363705, 'PTHR13287', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 246133),
(363706, 'PTHR13287:SF8', NULL, NULL, NULL, NULL, 'SI:CH211-151P13.8', 246133),
(363707, 'PTHR34715', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 246134),
(363708, 'PTHR34715:SF3', NULL, NULL, NULL, NULL, '', 246134),
(363709, 'PTHR34715:SF1', NULL, NULL, NULL, NULL, 'POX_D5 DOMAIN-CONTAINING PROTEIN', 246134),
(363710, 'PTHR11177:SF332', NULL, NULL, NULL, NULL, 'CHITINASE', 246135),
(363711, 'PTHR11177:SF398', NULL, NULL, NULL, NULL, 'CHITINASE 2-RELATED', 246135);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(363712, 'PTHR11177:SF333', NULL, NULL, NULL, NULL, 'CHITINASE', 246135),
(363713, 'PTHR11177:SF378', NULL, NULL, NULL, NULL, 'CHITINASE', 246135),
(363714, 'PTHR11177:SF235', NULL, NULL, NULL, NULL, 'CHITINASE-LIKE PROTEIN IDGF1-RELATED', 246135),
(363715, 'PTHR11177:SF379', NULL, NULL, NULL, NULL, 'CHITINASE', 246135),
(363716, 'PTHR11177:SF337', NULL, NULL, NULL, NULL, 'CHITINASE', 246135),
(363717, 'PTHR11177:SF359', NULL, NULL, NULL, NULL, 'CHITINASE 10-RELATED', 246135),
(363718, 'PTHR11177:SF317', NULL, NULL, NULL, NULL, 'CHITINASE 6, ISOFORM C', 246135),
(363719, 'PTHR11177:SF390', NULL, NULL, NULL, NULL, 'CHITINASE 11', 246135),
(363720, 'PTHR11177:SF391', NULL, NULL, NULL, NULL, 'CHITINASE 7', 246135),
(363721, 'PTHR11177:SF392', NULL, NULL, NULL, NULL, 'HAP41P', 246135),
(363722, 'PTHR11177:SF393', NULL, NULL, NULL, NULL, 'CHITINASE-LIKE PROTEIN-RELATED', 246135),
(363723, 'PTHR11177:SF394', NULL, NULL, NULL, NULL, 'GLYCO_18 DOMAIN-CONTAINING PROTEIN', 246135),
(363724, 'PTHR11177:SF395', NULL, NULL, NULL, NULL, 'GLYCO_18 DOMAIN-CONTAINING PROTEIN', 246135),
(363725, 'PTHR11177:SF373', NULL, NULL, NULL, NULL, 'CHITINASE', 246135),
(363726, 'PTHR11177:SF396', NULL, NULL, NULL, NULL, 'GLYCO_18 DOMAIN-CONTAINING PROTEIN', 246135),
(363727, 'PTHR11177:SF397', NULL, NULL, NULL, NULL, 'CHITINASE', 246135),
(363728, 'PTHR11177:SF375', NULL, NULL, NULL, NULL, 'NOD FACTOR HYDROLASE PROTEIN 1', 246135),
(363729, 'PTHR11177:SF180', NULL, NULL, NULL, NULL, 'OS04G0376400 PROTEIN', 246135),
(363730, 'PTHR11177', NULL, NULL, NULL, NULL, 'CHITINASE', 246135),
(363731, 'PTHR11177:SF365', NULL, NULL, NULL, NULL, 'ENDOCHITINASE B', 246135),
(363732, 'PTHR11177:SF387', NULL, NULL, NULL, NULL, '', 246135),
(363733, 'PTHR11177:SF388', NULL, NULL, NULL, NULL, 'CHITINASE', 246135),
(363734, 'PTHR11177:SF202', NULL, NULL, NULL, NULL, 'CHITINASE-3-LIKE PROTEIN 1', 246135),
(363735, 'PTHR11177:SF389', NULL, NULL, NULL, NULL, 'CHITINASE', 246135),
(363736, 'PTHR11177:SF147', NULL, NULL, NULL, NULL, 'CHITINASE-LIKE 6', 246135),
(363737, 'PTHR11177:SF368', NULL, NULL, NULL, NULL, 'GLYCO_18 DOMAIN-CONTAINING PROTEIN', 246135),
(363738, 'PTHR11177:SF369', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246135),
(363739, 'PTHR11177:SF347', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASES FAMILY 18 PROTEIN, EXPRESSED', 246135),
(363740, 'PTHR11177:SF248', NULL, NULL, NULL, NULL, 'CHITOTRIOSIDASE-1', 246135),
(363741, 'PTHR11177:SF348', NULL, NULL, NULL, NULL, 'CLASS V CHITINASE CHIT5A', 246135),
(363742, 'PTHR11177:SF228', NULL, NULL, NULL, NULL, 'CHITINASE', 246135),
(363743, 'PTHR11177:SF380', NULL, NULL, NULL, NULL, 'GLYCO_18 DOMAIN-CONTAINING PROTEIN', 246135),
(363744, 'PTHR11177:SF360', NULL, NULL, NULL, NULL, 'CHITINASE 12-RELATED', 246135),
(363745, 'PTHR11177:SF82', NULL, NULL, NULL, NULL, 'CHITINASE-3-LIKE PROTEIN 2', 246135),
(363746, 'PTHR11177:SF140', NULL, NULL, NULL, NULL, 'CHITINASE-LIKE PROTEIN 3-RELATED', 246135),
(363747, 'PTHR11177:SF383', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE FAMILY PROTEIN WITH CHITINASE INSERTION DOMAIN-CONTAINING PROTEIN', 246135),
(363748, 'PTHR11177:SF361', NULL, NULL, NULL, NULL, 'CHITINASE-3-LIKE PROTEIN 2', 246135),
(363749, 'PTHR11177:SF384', NULL, NULL, NULL, NULL, 'CHITINASE', 246135),
(363750, 'PTHR11177:SF362', NULL, NULL, NULL, NULL, 'CLASS V CHITINASE-LIKE', 246135),
(363751, 'PTHR11177:SF385', NULL, NULL, NULL, NULL, 'OVIDUCT-SPECIFIC GLYCOPROTEIN', 246135),
(363752, 'PTHR11177:SF363', NULL, NULL, NULL, NULL, 'GLYCO_18 DOMAIN-CONTAINING PROTEIN', 246135),
(363753, 'PTHR11177:SF188', NULL, NULL, NULL, NULL, 'ACIDIC MAMMALIAN CHITINASE', 246135),
(363754, 'PTHR11177:SF144', NULL, NULL, NULL, NULL, 'CHITINASE-RELATED', 246135),
(363755, 'PTHR11177:SF308', NULL, NULL, NULL, NULL, 'CHITINASE A', 246135),
(363756, 'PTHR37574:SF1', NULL, NULL, NULL, NULL, 'LIPASE B', 246136),
(363757, 'PTHR37574', NULL, NULL, NULL, NULL, 'LIPASE B', 246136),
(363758, 'PTHR10358:SF25', NULL, NULL, NULL, NULL, '', 246137),
(363759, 'PTHR10358:SF33', NULL, NULL, NULL, NULL, 'BNAA09G06720D PROTEIN', 246137);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(363760, 'PTHR10358:SF44', NULL, NULL, NULL, NULL, '', 246137),
(363761, 'PTHR10358:SF45', NULL, NULL, NULL, NULL, 'OS01G0249300 PROTEIN', 246137),
(363762, 'PTHR10358:SF42', NULL, NULL, NULL, NULL, 'ENDOSULPHINE-RELATED', 246137),
(363763, 'PTHR10358:SF21', NULL, NULL, NULL, NULL, 'ALPHA-ENDOSULFINE', 246137),
(363764, 'PTHR10358:SF4', NULL, NULL, NULL, NULL, 'CAMP-REGULATED PHOSPHOPROTEIN 19', 246137),
(363765, 'PTHR10358:SF43', NULL, NULL, NULL, NULL, 'ENDOSULPHINE-RELATED', 246137),
(363766, 'PTHR10358', NULL, NULL, NULL, NULL, 'ENDOSULFINE', 246137),
(363767, 'PTHR10358:SF40', NULL, NULL, NULL, NULL, 'ALPHA-ENDOSULFINE', 246137),
(363768, 'PTHR10358:SF6', NULL, NULL, NULL, NULL, 'ENDOSULFINE, ISOFORM A', 246137),
(363769, 'PTHR10358:SF30', NULL, NULL, NULL, NULL, 'BNAC02G42940D PROTEIN', 246137),
(363770, 'PTHR10358:SF28', NULL, NULL, NULL, NULL, 'ENDOSULPHINE-RELATED', 246137),
(363771, 'PTHR37226:SF3', NULL, NULL, NULL, NULL, '', 246138),
(363772, 'PTHR37226:SF4', NULL, NULL, NULL, NULL, 'GOLGIN FAMILY A PROTEIN', 246138),
(363773, 'PTHR37226:SF2', NULL, NULL, NULL, NULL, 'TROPONIN T, SKELETAL PROTEIN', 246138),
(363774, 'PTHR37226', NULL, NULL, NULL, NULL, 'GOLGIN FAMILY A PROTEIN', 246138),
(363775, 'PTHR45023:SF11', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE T3-LIKE PROTEIN', 246139),
(363776, 'PTHR45023:SF12', NULL, NULL, NULL, NULL, 'MYB-LIKE DOMAIN-CONTAINING PROTEIN', 246139),
(363777, 'PTHR45023:SF4', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN', 246139),
(363778, 'PTHR45023', NULL, NULL, NULL, NULL, '', 246139),
(363779, 'PTHR38045', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 246140),
(363780, 'PTHR38045:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 246140),
(363781, 'PTHR47540:SF3', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 246141),
(363782, 'PTHR47540:SF4', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 246141),
(363783, 'PTHR47540:SF1', NULL, NULL, NULL, NULL, 'ACTIVATOR OF STRESS GENES 1-RELATED', 246141),
(363784, 'PTHR47540:SF2', NULL, NULL, NULL, NULL, 'THIAMINE REPRESSIBLE GENES REGULATORY PROTEIN THI5', 246141),
(363785, 'PTHR47540:SF5', NULL, NULL, NULL, NULL, 'ZN(2)-C6 FUNGAL-TYPE DOMAIN-CONTAINING PROTEIN', 246141),
(363786, 'PTHR47540', NULL, NULL, NULL, NULL, 'THIAMINE REPRESSIBLE GENES REGULATORY PROTEIN THI5', 246141),
(363787, 'PTHR47122:SF13', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 246142),
(363788, 'PTHR47122:SF8', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 246142),
(363789, 'PTHR47122:SF7', NULL, NULL, NULL, NULL, 'SANT DOMAIN-CONTAINING PROTEIN', 246142),
(363790, 'PTHR47122:SF11', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 246142),
(363791, 'PTHR47122:SF10', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 246142),
(363792, 'PTHR47122:SF5', NULL, NULL, NULL, NULL, 'TRF-LIKE 8', 246142),
(363793, 'PTHR47122:SF9', NULL, NULL, NULL, NULL, 'MYB-LIKE DOMAIN-CONTAINING PROTEIN', 246142),
(363794, 'PTHR47122', NULL, NULL, NULL, NULL, 'MYB-LIKE DNA-BINDING DOMAIN CONTAINING PROTEIN, EXPRESSED', 246142),
(363795, 'PTHR47122:SF4', NULL, NULL, NULL, NULL, 'TRF-LIKE 3', 246142),
(363796, 'PTHR47122:SF3', NULL, NULL, NULL, NULL, 'TRF-LIKE 6', 246142),
(363797, 'PTHR47122:SF14', NULL, NULL, NULL, NULL, 'MYB-LIKE DNA-BINDING DOMAIN CONTAINING PROTEIN, EXPRESSED', 246142),
(363798, 'PTHR45799', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 246143),
(363799, 'PTHR45799:SF5', NULL, NULL, NULL, NULL, 'RETICULON-1', 246143),
(363800, 'PTHR45799:SF4', NULL, NULL, NULL, NULL, 'RETICULON-3', 246143),
(363801, 'PTHR45799:SF3', NULL, NULL, NULL, NULL, 'RETICULON-2', 246143),
(363802, 'PTHR45799:SF2', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 246143),
(363803, 'PTHR45799:SF1', NULL, NULL, NULL, NULL, 'RETICULON-4', 246143),
(363804, 'PTHR42831:SF1', NULL, NULL, NULL, NULL, 'FE-S PROTEIN MATURATION AUXILIARY FACTOR YITW', 246144),
(363805, 'PTHR42831:SF3', NULL, NULL, NULL, NULL, '1,2-PHENYLACETYL-COA EPOXIDASE, SUBUNIT D-RELATED', 246144);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(363806, 'PTHR42831', NULL, NULL, NULL, NULL, 'FE-S PROTEIN MATURATION AUXILIARY FACTOR YITW', 246144),
(363807, 'PTHR47670', NULL, NULL, NULL, NULL, 'ADENYLYLSULFATASE HINT3', 246145),
(363808, 'PTHR47670:SF1', NULL, NULL, NULL, NULL, 'ADENYLYLSULFATASE HINT3', 246145),
(363809, 'PTHR16027:SF8', NULL, NULL, NULL, NULL, '', 246146),
(363810, 'PTHR16027:SF9', NULL, NULL, NULL, NULL, '', 246146),
(363811, 'PTHR16027:SF4', NULL, NULL, NULL, NULL, 'RAS-INTERACTING PROTEIN 1', 246146),
(363812, 'PTHR16027:SF3', NULL, NULL, NULL, NULL, 'RAS-ASSOCIATING AND DILUTE DOMAIN-CONTAINING PROTEIN', 246146),
(363813, 'PTHR16027:SF6', NULL, NULL, NULL, NULL, 'DILUTE DOMAIN-CONTAINING PROTEIN YPR089W', 246146),
(363814, 'PTHR16027', NULL, NULL, NULL, NULL, 'DILUTE DOMAIN-CONTAINING PROTEIN YPR089W', 246146),
(363815, 'PTHR16027:SF10', NULL, NULL, NULL, NULL, 'SI:CH211-176G6.2-RELATED', 246146),
(363816, 'PTHR24014:SF18', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 246147),
(363817, 'PTHR24014:SF17', NULL, NULL, NULL, NULL, 'OXOGLUTARATE/IRON-DEPENDENT DIOXYGENASE-RELATED', 246147),
(363818, 'PTHR24014:SF19', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 246147),
(363819, 'PTHR24014:SF20', NULL, NULL, NULL, NULL, '2OG-FE(II) OXYGENASE FAMILY OXIDOREDUCTASE', 246147),
(363820, 'PTHR24014:SF12', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 246147),
(363821, 'PTHR24014:SF4', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE AND IRON-DEPENDENT OXYGENASE DOMAIN-CONTAINING PROTEIN 2', 246147),
(363822, 'PTHR24014:SF6', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN 1, MITOCHONDRIAL', 246147),
(363823, 'PTHR24014:SF16', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN ISOFORM 2', 246147),
(363824, 'PTHR24014:SF8', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE AND IRON-DEPENDENT OXYGENASE DOMAIN-CONTAINING PROTEIN ICU11', 246147),
(363825, 'PTHR24014:SF15', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 246147),
(363826, 'PTHR24014:SF9', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 246147),
(363827, 'PTHR24014', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE AND IRON-DEPENDENT OXYGENASE DOMAIN-CONTAINING PROTEIN 2', 246147),
(363828, 'PTHR34701', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR MRAZ', 246148),
(363829, 'PTHR34701:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR MRAZ', 246148),
(363830, 'PTHR24034:SF107', NULL, NULL, NULL, NULL, 'FIBULIN-5', 246149),
(363831, 'PTHR24034:SF149', NULL, NULL, NULL, NULL, 'FIBRILLIN 2A', 246149),
(363832, 'PTHR24034:SF105', NULL, NULL, NULL, NULL, 'MATRILIN 3', 246149),
(363833, 'PTHR24034:SF148', NULL, NULL, NULL, NULL, 'RE58433P', 246149),
(363834, 'PTHR24034:SF189', NULL, NULL, NULL, NULL, 'COMPLEMENT COMPONENT C1Q RECEPTOR', 246149),
(363835, 'PTHR24034:SF146', NULL, NULL, NULL, NULL, 'SI:DKEY-234I14.3', 246149),
(363836, 'PTHR24034:SF102', NULL, NULL, NULL, NULL, 'EGF-CONTAINING FIBULIN-LIKE EXTRACELLULAR MATRIX PROTEIN 1', 246149),
(363837, 'PTHR24034:SF143', NULL, NULL, NULL, NULL, 'ZGC:66455', 246149),
(363838, 'PTHR24034:SF187', NULL, NULL, NULL, NULL, 'RE64043P', 246149),
(363839, 'PTHR24034:SF188', NULL, NULL, NULL, NULL, 'EGF_CA DOMAIN-CONTAINING PROTEIN', 246149),
(363840, 'PTHR24034:SF185', NULL, NULL, NULL, NULL, 'VACUOLAR SORTING RECEPTOR 2-RELATED', 246149),
(363841, 'PTHR24034', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 246149),
(363842, 'PTHR24034:SF186', NULL, NULL, NULL, NULL, 'OS07G0680000 PROTEIN', 246149),
(363843, 'PTHR24034:SF183', NULL, NULL, NULL, NULL, 'NEUROGENIC LOCUS NOTCH PROTEIN-LIKE PROTEIN', 246149),
(363844, 'PTHR24034:SF140', NULL, NULL, NULL, NULL, 'LATENT-TRANSFORMING GROWTH FACTOR BETA-BINDING PROTEIN 1', 246149),
(363845, 'PTHR24034:SF184', NULL, NULL, NULL, NULL, 'COLLAGEN AND CALCIUM-BINDING EGF DOMAIN-CONTAINING PROTEIN 1', 246149),
(363846, 'PTHR24034:SF192', NULL, NULL, NULL, NULL, '', 246149),
(363847, 'PTHR24034:SF193', NULL, NULL, NULL, NULL, 'THROMBOMODULIN', 246149);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(363848, 'PTHR24034:SF190', NULL, NULL, NULL, NULL, 'VACUOLAR-SORTING RECEPTOR 1 ISOFORM X1', 246149),
(363849, 'PTHR24034:SF191', NULL, NULL, NULL, NULL, 'OS03G0335300 PROTEIN', 246149),
(363850, 'PTHR24034:SF96', NULL, NULL, NULL, NULL, 'EGF-CONTAINING FIBULIN-LIKE EXTRACELLULAR MATRIX PROTEIN 2', 246149),
(363851, 'PTHR24034:SF158', NULL, NULL, NULL, NULL, 'FIBULIN 2', 246149),
(363852, 'PTHR24034:SF114', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE ISOMERASE CRELD1', 246149),
(363853, 'PTHR24034:SF97', NULL, NULL, NULL, NULL, 'FIBULIN-1', 246149),
(363854, 'PTHR24034:SF110', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE ISOMERASE CRELD2', 246149),
(363855, 'PTHR24034:SF94', NULL, NULL, NULL, NULL, 'FIBULIN-7', 246149),
(363856, 'PTHR24034:SF155', NULL, NULL, NULL, NULL, 'MATRILIN 2', 246149),
(363857, 'PTHR24034:SF111', NULL, NULL, NULL, NULL, '', 246149),
(363858, 'PTHR24034:SF89', NULL, NULL, NULL, NULL, 'VACUOLAR-SORTING RECEPTOR 3-RELATED', 246149),
(363859, 'PTHR24034:SF46', NULL, NULL, NULL, NULL, 'LATENT-TRANSFORMING GROWTH FACTOR BETA-BINDING PROTEIN 3', 246149),
(363860, 'PTHR24034:SF43', NULL, NULL, NULL, NULL, 'LATENT-TRANSFORMING GROWTH FACTOR BETA-BINDING PROTEIN 4', 246149),
(363861, 'PTHR24034:SF169', NULL, NULL, NULL, NULL, 'OS04G0611400 PROTEIN', 246149),
(363862, 'PTHR24034:SF87', NULL, NULL, NULL, NULL, 'FIBULIN-7-LIKE', 246149),
(363863, 'PTHR24034:SF167', NULL, NULL, NULL, NULL, 'FIBULIN 7', 246149),
(363864, 'PTHR24034:SF168', NULL, NULL, NULL, NULL, 'UROMODULIN LIKE 1', 246149),
(363865, 'PTHR24034:SF165', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 246149),
(363866, 'PTHR24034:SF166', NULL, NULL, NULL, NULL, 'VACUOLAR-SORTING RECEPTOR 1-RELATED', 246149),
(363867, 'PTHR24034:SF163', NULL, NULL, NULL, NULL, '', 246149),
(363868, 'PTHR24034:SF164', NULL, NULL, NULL, NULL, '', 246149),
(363869, 'PTHR24034:SF170', NULL, NULL, NULL, NULL, '', 246149),
(363870, 'PTHR24034:SF171', NULL, NULL, NULL, NULL, 'VACUOLAR-SORTING RECEPTOR 3-LIKE', 246149),
(363871, 'PTHR24034:SF49', NULL, NULL, NULL, NULL, 'LATENT-TRANSFORMING GROWTH FACTOR BETA-BINDING PROTEIN 2', 246149),
(363872, 'PTHR24034:SF76', NULL, NULL, NULL, NULL, 'COLLAGEN AND CALCIUM-BINDING EGF DOMAIN-CONTAINING PROTEIN 1', 246149),
(363873, 'PTHR24034:SF137', NULL, NULL, NULL, NULL, 'SI:DKEY-163F14.6', 246149),
(363874, 'PTHR24034:SF178', NULL, NULL, NULL, NULL, '', 246149),
(363875, 'PTHR24034:SF179', NULL, NULL, NULL, NULL, 'FI18763P1-RELATED', 246149),
(363876, 'PTHR24034:SF176', NULL, NULL, NULL, NULL, '', 246149),
(363877, 'PTHR24034:SF177', NULL, NULL, NULL, NULL, '', 246149),
(363878, 'PTHR24034:SF174', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 246149),
(363879, 'PTHR24034:SF175', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 246149),
(363880, 'PTHR24034:SF172', NULL, NULL, NULL, NULL, 'EGF-LIKE AND EMI DOMAIN-CONTAINING PROTEIN 1', 246149),
(363881, 'PTHR24034:SF173', NULL, NULL, NULL, NULL, '', 246149),
(363882, 'PTHR24034:SF181', NULL, NULL, NULL, NULL, 'VACUOLAR-SORTING RECEPTOR 6', 246149),
(363883, 'PTHR24034:SF182', NULL, NULL, NULL, NULL, 'VACUOLAR-SORTING RECEPTOR 7', 246149),
(363884, 'PTHR24034:SF180', NULL, NULL, NULL, NULL, 'VACUOLAR-SORTING RECEPTOR 5', 246149),
(363885, 'PTHR35091:SF5', NULL, NULL, NULL, NULL, 'FLAGELLAR PROTEIN FLIL', 246150),
(363886, 'PTHR35091', NULL, NULL, NULL, NULL, 'FLAGELLAR PROTEIN FLIL', 246150),
(363887, 'PTHR35091:SF2', NULL, NULL, NULL, NULL, 'FLAGELLAR PROTEIN FLIL', 246150),
(363888, 'PTHR11265:SF3', NULL, NULL, NULL, NULL, '', 246151),
(363889, 'PTHR11265:SF1', NULL, NULL, NULL, NULL, '12S RRNA N4-METHYLCYTIDINE (M4C) METHYLTRANSFERASE-RELATED', 246151),
(363890, 'PTHR11265:SF0', NULL, NULL, NULL, NULL, '12S RRNA N4-METHYLCYTIDINE METHYLTRANSFERASE', 246151),
(363891, 'PTHR11265', NULL, NULL, NULL, NULL, 'S-ADENOSYL-METHYLTRANSFERASE MRAW', 246151),
(363892, 'PTHR20437', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUBFAMILY MEMBER 13/17', 246152),
(363893, 'PTHR20437:SF0', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 17', 246152);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(363894, 'PTHR20437:SF2', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 13C', 246152),
(363895, 'PTHR20437:SF3', NULL, NULL, NULL, NULL, 'BCMA-TALL_BIND DOMAIN-CONTAINING PROTEIN', 246152),
(363896, 'PTHR20437:SF5', NULL, NULL, NULL, NULL, '', 246152),
(363897, 'PTHR38662', NULL, NULL, NULL, NULL, '', 246153),
(363898, 'PTHR38662:SF1', NULL, NULL, NULL, NULL, 'COBALT TRANSPORT PROTEIN CBIN', 246153),
(363899, 'PTHR21310:SF51', NULL, NULL, NULL, NULL, 'APH DOMAIN-CONTAINING PROTEIN', 246154),
(363900, 'PTHR21310:SF40', NULL, NULL, NULL, NULL, 'APH DOMAIN-CONTAINING PROTEIN-RELATED', 246154),
(363901, 'PTHR21310:SF41', NULL, NULL, NULL, NULL, '3-HYDROXYASPARAGINE PHOSPHOTRANSFERASE', 246154),
(363902, 'PTHR21310:SF52', NULL, NULL, NULL, NULL, 'APH DOMAIN-CONTAINING PROTEIN', 246154),
(363903, 'PTHR21310:SF42', NULL, NULL, NULL, NULL, '2''''-AMINOGLYCOSIDE PHOSPHOTRANSFERASE', 246154),
(363904, 'PTHR21310:SF53', NULL, NULL, NULL, NULL, 'APH DOMAIN-CONTAINING PROTEIN', 246154),
(363905, 'PTHR21310:SF43', NULL, NULL, NULL, NULL, 'PHOSPHOTRANSFERASE ENZYME FAMILY PROTEIN', 246154),
(363906, 'PTHR21310:SF15', NULL, NULL, NULL, NULL, 'APH DOMAIN-CONTAINING PROTEIN', 246154),
(363907, 'PTHR21310:SF48', NULL, NULL, NULL, NULL, 'APH DOMAIN-CONTAINING PROTEIN', 246154),
(363908, 'PTHR21310:SF37', NULL, NULL, NULL, NULL, 'APH DOMAIN-CONTAINING PROTEIN', 246154),
(363909, 'PTHR21310:SF39', NULL, NULL, NULL, NULL, 'APH DOMAIN-CONTAINING PROTEIN', 246154),
(363910, 'PTHR21310:SF13', NULL, NULL, NULL, NULL, 'APH DOMAIN-CONTAINING PROTEIN', 246154),
(363911, 'PTHR21310:SF46', NULL, NULL, NULL, NULL, 'APH DOMAIN-CONTAINING PROTEIN', 246154),
(363912, 'PTHR21310', NULL, NULL, NULL, NULL, 'AMINOGLYCOSIDE PHOSPHOTRANSFERASE-RELATED-RELATED', 246154),
(363913, 'PTHR43339', NULL, NULL, NULL, NULL, 'RUBRERYTHRIN-RELATED', 246155),
(363914, 'PTHR43339:SF1', NULL, NULL, NULL, NULL, 'RUBRERYTHRIN-RELATED', 246155),
(363915, 'PTHR45899', NULL, NULL, NULL, NULL, 'RHO GTPASE ACTIVATING PROTEIN AT 15B, ISOFORM C', 246156),
(363916, 'PTHR45899:SF1', NULL, NULL, NULL, NULL, 'ARF-GAP WITH RHO-GAP DOMAIN, ANK REPEAT AND PH DOMAIN-CONTAINING PROTEIN 2', 246156),
(363917, 'PTHR45899:SF3', NULL, NULL, NULL, NULL, 'ARF-GAP WITH RHO-GAP DOMAIN, ANK REPEAT AND PH DOMAIN-CONTAINING PROTEIN 1', 246156),
(363918, 'PTHR45899:SF2', NULL, NULL, NULL, NULL, 'RHO GTPASE ACTIVATING PROTEIN AT 15B, ISOFORM C', 246156),
(363919, 'PTHR45899:SF5', NULL, NULL, NULL, NULL, '', 246156),
(363920, 'PTHR45899:SF4', NULL, NULL, NULL, NULL, 'ARF-GAP WITH RHO-GAP DOMAIN, ANK REPEAT AND PH DOMAIN-CONTAINING PROTEIN 3', 246156),
(363921, 'PTHR33566:SF12', NULL, NULL, NULL, NULL, '', 246157),
(363922, 'PTHR33566:SF9', NULL, NULL, NULL, NULL, 'DEFECTIVE IN MERISTEM SILENCING PROTEIN', 246157),
(363923, 'PTHR33566:SF7', NULL, NULL, NULL, NULL, 'DEFECTIVE IN MERISTEM SILENCING 3-RELATED', 246157),
(363924, 'PTHR33566:SF6', NULL, NULL, NULL, NULL, 'PROTEIN DEFECTIVE IN MERISTEM SILENCING 3', 246157),
(363925, 'PTHR33566:SF5', NULL, NULL, NULL, NULL, 'PROTEIN DEFECTIVE IN MERISTEM SILENCING 3-LIKE ISOFORM X1', 246157),
(363926, 'PTHR33566:SF1', NULL, NULL, NULL, NULL, 'STRUCTURAL MAINTENANCE OF CHROMOSOMES FLEXIBLE HINGE DOMAIN-CONTAINING PROTEIN GMI1', 246157),
(363927, 'PTHR33566', NULL, NULL, NULL, NULL, 'EN/SPM-LIKE TRANSPOSON-RELATED', 246157),
(363928, 'PTHR43626', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASE', 246158),
(363929, 'PTHR43626:SF4', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE NSI', 246158),
(363930, 'PTHR43626:SF1', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASES (NAT) SUPERFAMILY PROTEIN', 246158),
(363931, 'PTHR43637:SF1', NULL, NULL, NULL, NULL, 'UPF0273 PROTEIN TM_0370', 246159),
(363932, 'PTHR43637:SF3', NULL, NULL, NULL, NULL, 'FLAGELLA-RELATED PROTEIN H-RELATED', 246159),
(363933, 'PTHR43637:SF2', NULL, NULL, NULL, NULL, 'PROTEIN GVPD 1', 246159),
(363934, 'PTHR43637', NULL, NULL, NULL, NULL, 'UPF0273 PROTEIN TM_0370', 246159),
(363935, 'PTHR46441:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EPIDIDYMAL PROTEIN 1A', 246160);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(363936, 'PTHR46441:SF5', NULL, NULL, NULL, NULL, '', 246160),
(363937, 'PTHR46441:SF6', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EPIDIDYMAL PROTEIN 1', 246160),
(363938, 'PTHR46441', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EPIDIDYMAL FAMILY MEMBER 3', 246160),
(363939, 'PTHR46441:SF1', NULL, NULL, NULL, NULL, 'EPIDIDYMAL PROTEIN ME9', 246160),
(363940, 'PTHR46441:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EPIDIDYMAL PROTEIN 1', 246160),
(363941, 'PTHR46441:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EPIDIDYMAL FAMILY MEMBER 3', 246160),
(363942, 'PTHR35756', NULL, NULL, NULL, NULL, 'OS05G0337400 PROTEIN', 246161),
(363943, 'PTHR35756:SF1', NULL, NULL, NULL, NULL, 'OS05G0337400 PROTEIN', 246161),
(363944, 'PTHR43342:SF2', NULL, NULL, NULL, NULL, 'POTENTIAL NAD-REDUCING HYDROGENASE SUBUNIT', 246162),
(363945, 'PTHR43342:SF1', NULL, NULL, NULL, NULL, 'NADH:UBIQUINONE OXIDOREDUCTASE, SUBUNIT E', 246162),
(363946, 'PTHR43342', NULL, NULL, NULL, NULL, 'NADH-QUINONE OXIDOREDUCTASE, E SUBUNIT', 246162),
(363947, 'PTHR24038:SF8', NULL, NULL, NULL, NULL, 'STABILIN-1', 246163),
(363948, 'PTHR24038', NULL, NULL, NULL, NULL, 'STABILIN', 246163),
(363949, 'PTHR24038:SF11', NULL, NULL, NULL, NULL, 'INTEGRIN BETA-LIKE PROTEIN E', 246163),
(363950, 'PTHR24038:SF0', NULL, NULL, NULL, NULL, 'STABILIN-2', 246163),
(363951, 'PTHR15819', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN FAM155', 246164),
(363952, 'PTHR15819:SF11', NULL, NULL, NULL, NULL, 'MID1, ISOFORM A', 246164),
(363953, 'PTHR15819:SF8', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN FAM155B', 246164),
(363954, 'PTHR15819:SF9', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN FAM155A', 246164),
(363955, 'PTHR45864:SF7', NULL, NULL, NULL, NULL, 'SLINGSHOT PROTEIN PHOSPHATASE 1B', 246165),
(363956, 'PTHR45864:SF2', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE SLINGSHOT', 246165),
(363957, 'PTHR45864:SF3', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE SLINGSHOT HOMOLOG 2', 246165),
(363958, 'PTHR45864:SF4', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE SLINGSHOT HOMOLOG 3', 246165),
(363959, 'PTHR45864:SF5', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE SLINGSHOT HOMOLOG 1', 246165),
(363960, 'PTHR45864', NULL, NULL, NULL, NULL, 'SLINGSHOT PROTEIN PHOSPHATASE HOMOLOG', 246165),
(363961, 'PTHR23233:SF51', NULL, NULL, NULL, NULL, 'SAL-LIKE PROTEIN 1', 246166),
(363962, 'PTHR23233:SF84', NULL, NULL, NULL, NULL, 'FI23031P1', 246166),
(363963, 'PTHR23233:SF85', NULL, NULL, NULL, NULL, 'SI:CH211-212K18.5', 246166),
(363964, 'PTHR23233:SF19', NULL, NULL, NULL, NULL, 'SAL-LIKE PROTEIN 4', 246166),
(363965, 'PTHR23233:SF15', NULL, NULL, NULL, NULL, 'SAL-LIKE PROTEIN 2', 246166),
(363966, 'PTHR23233', NULL, NULL, NULL, NULL, 'SAL-LIKE PROTEIN', 246166),
(363967, 'PTHR23233:SF46', NULL, NULL, NULL, NULL, 'SAL-LIKE PROTEIN 3', 246166),
(363968, 'PTHR23233:SF86', NULL, NULL, NULL, NULL, 'SPALT-LIKE TRANSCRIPTION FACTOR 2', 246166),
(363969, 'PTHR23233:SF87', NULL, NULL, NULL, NULL, 'HOMEOTIC PROTEIN SPALT-MAJOR', 246166),
(363970, 'PTHR21107', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY PROTEIN COX19', 246167),
(363971, 'PTHR21107:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY PROTEIN COX19', 246167),
(363972, 'PTHR44899', NULL, NULL, NULL, NULL, 'CAMK FAMILY PROTEIN KINASE', 246168),
(363973, 'PTHR44899:SF1', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NEK5', 246168),
(363974, 'PTHR44899:SF3', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE', 246168),
(363975, 'PTHR44899:SF4', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NEK1', 246168),
(363976, 'PTHR44899:SF5', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246168),
(363977, 'PTHR44899:SF6', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE', 246168),
(363978, 'PTHR46706', NULL, NULL, NULL, NULL, 'PROTEIN QUA-1-RELATED', 246169),
(363979, 'PTHR46706:SF12', NULL, NULL, NULL, NULL, 'PROTEIN QUA-1-RELATED', 246169),
(363980, 'PTHR46706:SF7', NULL, NULL, NULL, NULL, 'GROUNDHOG (HEDGEHOG-LIKE FAMILY)-RELATED', 246169),
(363981, 'PTHR15672:SF12', NULL, NULL, NULL, NULL, 'R3H DOMAIN-CONTAINING PROTEIN 1', 246170);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(363982, 'PTHR15672', NULL, NULL, NULL, NULL, 'CAMP-REGULATED PHOSPHOPROTEIN 21 RELATED R3H DOMAIN CONTAINING PROTEIN', 246170),
(363983, 'PTHR15672:SF8', NULL, NULL, NULL, NULL, 'PROTEIN ENCORE', 246170),
(363984, 'PTHR15672:SF29', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246170),
(363985, 'PTHR15672:SF28', NULL, NULL, NULL, NULL, 'SINGLE-STRANDED NUCLEIC ACID BINDING R3H PROTEIN', 246170),
(363986, 'PTHR15672:SF27', NULL, NULL, NULL, NULL, 'BNAA01G31440D PROTEIN', 246170),
(363987, 'PTHR15672:SF15', NULL, NULL, NULL, NULL, 'SINGLE-STRANDED NUCLEIC ACID BINDING R3H PROTEIN', 246170),
(363988, 'PTHR15672:SF25', NULL, NULL, NULL, NULL, 'OS01G0100600 PROTEIN', 246170),
(363989, 'PTHR15672:SF14', NULL, NULL, NULL, NULL, 'CAMP-REGULATED PHOSPHOPROTEIN 21', 246170),
(363990, 'PTHR15672:SF13', NULL, NULL, NULL, NULL, 'R3H DOMAIN-CONTAINING PROTEIN 2', 246170),
(363991, 'PTHR10837', NULL, NULL, NULL, NULL, 'PEPTIDYLARGININE DEIMINASE', 246171),
(363992, 'PTHR10837:SF11', NULL, NULL, NULL, NULL, 'PROTEIN-ARGININE DEIMINASE TYPE-1', 246171),
(363993, 'PTHR10837:SF12', NULL, NULL, NULL, NULL, 'PROTEIN-ARGININE DEIMINASE TYPE-2', 246171),
(363994, 'PTHR10837:SF21', NULL, NULL, NULL, NULL, 'PROTEIN-ARGININE DEIMINASE TYPE-3', 246171),
(363995, 'PTHR10837:SF8', NULL, NULL, NULL, NULL, 'PROTEIN-ARGININE DEIMINASE', 246171),
(363996, 'PTHR10837:SF3', NULL, NULL, NULL, NULL, 'PROTEIN-ARGININE DEIMINASE TYPE-4', 246171),
(363997, 'PTHR10837:SF4', NULL, NULL, NULL, NULL, 'PROTEIN-ARGININE DEIMINASE TYPE-6', 246171),
(363998, 'PTHR15048:SF0', NULL, NULL, NULL, NULL, 'STARCH-BINDING DOMAIN-CONTAINING PROTEIN 1', 246172),
(363999, 'PTHR15048:SF1', NULL, NULL, NULL, NULL, 'CBM20 DOMAIN-CONTAINING PROTEIN', 246172),
(364000, 'PTHR15048', NULL, NULL, NULL, NULL, 'STARCH-BINDING DOMAIN-CONTAINING PROTEIN 1', 246172),
(364001, 'PTHR34783:SF1', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 144-RELATED', 246173),
(364002, 'PTHR34783:SF6', NULL, NULL, NULL, NULL, 'OS02G0727600 PROTEIN', 246173),
(364003, 'PTHR34783', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 144-RELATED', 246173),
(364004, 'PTHR34783:SF4', NULL, NULL, NULL, NULL, 'BNAA08G03860D PROTEIN', 246173),
(364005, 'PTHR34783:SF5', NULL, NULL, NULL, NULL, '', 246173),
(364006, 'PTHR42681:SF1', NULL, NULL, NULL, NULL, 'MALONYL-COA-ACYL CARRIER PROTEIN TRANSACYLASE, MITOCHONDRIAL', 246174),
(364007, 'PTHR42681', NULL, NULL, NULL, NULL, 'MALONYL-COA-ACYL CARRIER PROTEIN TRANSACYLASE, MITOCHONDRIAL', 246174),
(364008, 'PTHR42681:SF6', NULL, NULL, NULL, NULL, 'BLL0263 PROTEIN', 246174),
(364009, 'PTHR38758:SF1', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 246175),
(364010, 'PTHR38758', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 246175),
(364011, 'PTHR34761:SF1', NULL, NULL, NULL, NULL, 'NUCLEOLUS AND NEURAL PROGENITOR PROTEIN', 246176),
(364012, 'PTHR34761', NULL, NULL, NULL, NULL, 'NUCLEOLUS AND NEURAL PROGENITOR PROTEIN', 246176),
(364013, 'PTHR34049:SF11', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246177),
(364014, 'PTHR34049:SF2', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', 246177),
(364015, 'PTHR34049:SF10', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246177),
(364016, 'PTHR34049:SF1', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SKIP27', 246177),
(364017, 'PTHR34049:SF3', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246177),
(364018, 'PTHR34049:SF6', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246177),
(364019, 'PTHR34049:SF5', NULL, NULL, NULL, NULL, 'F-BOX FAMILY PROTEIN', 246177),
(364020, 'PTHR34049:SF8', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246177),
(364021, 'PTHR34049:SF7', NULL, NULL, NULL, NULL, 'BNACNNG04130D PROTEIN', 246177),
(364022, 'PTHR34049:SF9', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN', 246177),
(364023, 'PTHR34049', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SKIP27', 246177),
(364024, 'PTHR34049:SF12', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN-RELATED', 246177),
(364025, 'PTHR43243:SF73', NULL, NULL, NULL, NULL, 'AA_PERMEASE_C DOMAIN-CONTAINING PROTEIN', 246178);
INSERT INTO "PUBLIC"."MODEL" VALUES
(364026, 'PTHR43243:SF30', NULL, NULL, NULL, NULL, 'CATIONIC AMINO ACID TRANSPORTER 1-LIKE', 246178),
(364027, 'PTHR43243:SF75', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE FAMILY PROTEIN, EXPRESSED', 246178),
(364028, 'PTHR43243:SF76', NULL, NULL, NULL, NULL, 'AA_PERMEASE_C DOMAIN-CONTAINING PROTEIN', 246178),
(364029, 'PTHR43243:SF77', NULL, NULL, NULL, NULL, 'CATIONIC AMINO ACID TRANSPORTER', 246178),
(364030, 'PTHR43243:SF33', NULL, NULL, NULL, NULL, 'AA_PERMEASE DOMAIN-CONTAINING PROTEIN', 246178),
(364031, 'PTHR43243:SF78', NULL, NULL, NULL, NULL, 'AA_PERMEASE_C DOMAIN-CONTAINING PROTEIN', 246178),
(364032, 'PTHR43243:SF35', NULL, NULL, NULL, NULL, 'CATIONIC AMINO ACID TRANSPORTER 2', 246178),
(364033, 'PTHR43243:SF79', NULL, NULL, NULL, NULL, 'AA_PERMEASE_C DOMAIN-CONTAINING PROTEIN', 246178),
(364034, 'PTHR43243:SF36', NULL, NULL, NULL, NULL, 'AA_PERMEASE_C DOMAIN-CONTAINING PROTEIN', 246178),
(364035, 'PTHR43243:SF29', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 7 MEMBER 14B', 246178),
(364036, 'PTHR43243:SF61', NULL, NULL, NULL, NULL, 'CATIONIC AMINO ACID TRANSPORTER 6 CHLOROPLASTIC', 246178),
(364037, 'PTHR43243:SF62', NULL, NULL, NULL, NULL, 'CATIONIC AMINO ACID TRANSPORTER 8, VACUOLAR', 246178),
(364038, 'PTHR43243:SF63', NULL, NULL, NULL, NULL, 'CATIONIC AMINO ACID TRANSPORTER 3, MITOCHONDRIAL', 246178),
(364039, 'PTHR43243:SF20', NULL, NULL, NULL, NULL, 'CATIONIC AMINO ACID TRANSPORTER 3', 246178),
(364040, 'PTHR43243:SF6', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE FAMILY PROTEIN, EXPRESSED', 246178),
(364041, 'PTHR43243:SF22', NULL, NULL, NULL, NULL, 'CATIONIC AMINO ACID TRANSPORTER 5', 246178),
(364042, 'PTHR43243:SF66', NULL, NULL, NULL, NULL, 'CATIONIC AMINO ACID TRANSPORTER 1-LIKE', 246178),
(364043, 'PTHR43243:SF67', NULL, NULL, NULL, NULL, 'AA_PERMEASE_C DOMAIN-CONTAINING PROTEIN', 246178),
(364044, 'PTHR43243:SF24', NULL, NULL, NULL, NULL, 'CATIONIC AMINO ACID TRANSPORT INTEGRAL MEMBRANE PROTEIN ROCE-RELATED', 246178),
(364045, 'PTHR43243:SF69', NULL, NULL, NULL, NULL, 'CATIONIC AMINO ACID TRANSPORTER 6, CHLOROPLASTIC', 246178),
(364046, 'PTHR43243:SF25', NULL, NULL, NULL, NULL, 'CATIONIC AMINO ACID TRANSPORTER-RELATED', 246178),
(364047, 'PTHR43243:SF1', NULL, NULL, NULL, NULL, 'CATIONIC AMINO ACID TRANSPORTER 1', 246178),
(364048, 'PTHR43243:SF4', NULL, NULL, NULL, NULL, 'AA_PERMEASE DOMAIN-CONTAINING PROTEIN', 246178),
(364049, 'PTHR43243:SF27', NULL, NULL, NULL, NULL, 'AA_PERMEASE_C DOMAIN-CONTAINING PROTEIN', 246178),
(364050, 'PTHR43243:SF3', NULL, NULL, NULL, NULL, 'AA_PERMEASE_C DOMAIN-CONTAINING PROTEIN', 246178),
(364051, 'PTHR43243:SF28', NULL, NULL, NULL, NULL, 'HIGH AFFINITY CATIONIC AMINO ACID TRANSPORTER 1', 246178),
(364052, 'PTHR43243:SF18', NULL, NULL, NULL, NULL, 'AA_PERMEASE_C DOMAIN-CONTAINING PROTEIN', 246178),
(364053, 'PTHR43243:SF19', NULL, NULL, NULL, NULL, 'ZGC:175280', 246178),
(364054, 'PTHR43243:SF90', NULL, NULL, NULL, NULL, 'EXPRESSED SEQUENCE AU018091', 246178),
(364055, 'PTHR43243:SF92', NULL, NULL, NULL, NULL, 'AA_PERMEASE_C DOMAIN-CONTAINING PROTEIN', 246178),
(364056, 'PTHR43243:SF93', NULL, NULL, NULL, NULL, 'AMINO ACID/POLYAMINE TRANSPORTER I, CATIONIC AMINO ACID TRANSPORTER-RELATED', 246178),
(364057, 'PTHR43243:SF94', NULL, NULL, NULL, NULL, 'CATIONIC AMINO ACID TRANSPORTER 2', 246178),
(364058, 'PTHR43243:SF95', NULL, NULL, NULL, NULL, 'LD37241P', 246178),
(364059, 'PTHR43243:SF96', NULL, NULL, NULL, NULL, 'CATIONIC AMINO ACID TRANSPORTER 1', 246178),
(364060, 'PTHR43243:SF97', NULL, NULL, NULL, NULL, '', 246178),
(364061, 'PTHR43243:SF53', NULL, NULL, NULL, NULL, 'AA_PERMEASE_C DOMAIN-CONTAINING PROTEIN', 246178),
(364062, 'PTHR43243:SF10', NULL, NULL, NULL, NULL, 'AA_PERMEASE_C DOMAIN-CONTAINING PROTEIN', 246178),
(364063, 'PTHR43243:SF98', NULL, NULL, NULL, NULL, 'TORN AND DIMINISHED RHABDOMERES, ISOFORM D', 246178),
(364064, 'PTHR43243:SF11', NULL, NULL, NULL, NULL, 'ION_TRANS_2 DOMAIN-CONTAINING PROTEIN', 246178),
(364065, 'PTHR43243:SF99', NULL, NULL, NULL, NULL, 'CATIONIC AMINO ACID TRANSPORTER 2, VACUOLAR PROTEIN', 246178);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(364066, 'PTHR43243:SF12', NULL, NULL, NULL, NULL, 'AA_PERMEASE_C DOMAIN-CONTAINING PROTEIN', 246178),
(364067, 'PTHR43243:SF13', NULL, NULL, NULL, NULL, 'AA_PERMEASE_C DOMAIN-CONTAINING PROTEIN', 246178),
(364068, 'PTHR43243:SF15', NULL, NULL, NULL, NULL, 'CATIONIC AMINO ACID TRANSPORTER 4, VACUOLAR', 246178),
(364069, 'PTHR43243:SF17', NULL, NULL, NULL, NULL, 'CATIONIC AMINO ACID TRANSPORTER-RELATED', 246178),
(364070, 'PTHR43243', NULL, NULL, NULL, NULL, 'INNER MEMBRANE TRANSPORTER YGJI-RELATED', 246178),
(364071, 'PTHR43243:SF80', NULL, NULL, NULL, NULL, 'AMINO ACID/POLYAMINE TRANSPORTER I, CATIONIC AMINO ACID TRANSPORTER-RELATED', 246178),
(364072, 'PTHR43243:SF82', NULL, NULL, NULL, NULL, 'AA_PERMEASE_C DOMAIN-CONTAINING PROTEIN', 246178),
(364073, 'PTHR43243:SF83', NULL, NULL, NULL, NULL, 'HIGH AFFINITY CATIONIC AMINO ACID TRANSPORTER 1-LIKE PROTEIN', 246178),
(364074, 'PTHR43243:SF41', NULL, NULL, NULL, NULL, 'CATIONIC AMINO ACID TRANSPORTER 7, CHLOROPLASTIC', 246178),
(364075, 'PTHR43243:SF86', NULL, NULL, NULL, NULL, '', 246178),
(364076, 'PTHR43243:SF87', NULL, NULL, NULL, NULL, 'AA_PERMEASE_C DOMAIN-CONTAINING PROTEIN', 246178),
(364077, 'PTHR43243:SF88', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 7 MEMBER 1A', 246178),
(364078, 'PTHR43243:SF89', NULL, NULL, NULL, NULL, 'CATIONIC AMINO ACID TRANSPORTER 4', 246178),
(364079, 'PTHR43243:SF45', NULL, NULL, NULL, NULL, 'CATIONIC AMINO ACID TRANSPORTER 9, CHLOROPLASTIC', 246178),
(364080, 'PTHR43243:SF48', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN-RELATED', 246178),
(364081, 'PTHR41302:SF2', NULL, NULL, NULL, NULL, 'PRESPORE SPECIFIC TRANSCRIPTIONAL ACTIVATOR RSFA', 246179),
(364082, 'PTHR41302:SF1', NULL, NULL, NULL, NULL, 'PRESPORE-SPECIFIC TRANSCRIPTIONAL REGULATOR RSFA', 246179),
(364083, 'PTHR41302', NULL, NULL, NULL, NULL, 'PRESPORE-SPECIFIC TRANSCRIPTIONAL REGULATOR RSFA-RELATED', 246179),
(364084, 'PTHR22975:SF5', NULL, NULL, NULL, NULL, 'INACTIVE UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 54', 246180),
(364085, 'PTHR22975', NULL, NULL, NULL, NULL, 'UBIQUITIN SPECIFIC PROTEINASE', 246180),
(364086, 'PTHR22975:SF6', NULL, NULL, NULL, NULL, 'INACTIVE UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 53', 246180),
(364087, 'PTHR22975:SF9', NULL, NULL, NULL, NULL, 'ECHINUS SPLICE FORM 3', 246180),
(364088, 'PTHR22975:SF19', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246180),
(364089, 'PTHR22975:SF37', NULL, NULL, NULL, NULL, '', 246180),
(364090, 'PTHR22975:SF29', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 246180),
(364091, 'PTHR22975:SF28', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 246180),
(364092, 'PTHR22975:SF23', NULL, NULL, NULL, NULL, 'F6D8.33-RELATED', 246180),
(364093, 'PTHR22975:SF34', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 246180),
(364094, 'PTHR22975:SF36', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 246180),
(364095, 'PTHR22975:SF24', NULL, NULL, NULL, NULL, 'CARBOXYL-TERMINAL HYDROLASE-LIKE PROTEIN, PUTATIVE (DUF627 AND DUF629)-RELATED', 246180),
(364096, 'PTHR22975:SF35', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 246180),
(364097, 'PTHR22975:SF32', NULL, NULL, NULL, NULL, 'BNAA02G33070D PROTEIN', 246180),
(364098, 'PTHR22975:SF20', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE-RELATED PROTEIN-RELATED', 246180),
(364099, 'PTHR33110:SF81', NULL, NULL, NULL, NULL, 'OS11G0154100 PROTEIN', 246181),
(364100, 'PTHR33110:SF82', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246181),
(364101, 'PTHR33110:SF83', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 246181),
(364102, 'PTHR33110:SF84', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246181),
(364103, 'PTHR33110:SF111', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 246181),
(364104, 'PTHR33110:SF110', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 246181),
(364105, 'PTHR33110:SF89', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246181),
(364106, 'PTHR33110:SF115', NULL, NULL, NULL, NULL, 'OS02G0129200 PROTEIN', 246181);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(364107, 'PTHR33110:SF114', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246181),
(364108, 'PTHR33110:SF119', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246181),
(364109, 'PTHR33110:SF86', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246181),
(364110, 'PTHR33110:SF42', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246181),
(364111, 'PTHR33110:SF43', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 246181),
(364112, 'PTHR33110:SF44', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 246181),
(364113, 'PTHR33110:SF38', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 246181),
(364114, 'PTHR33110:SF39', NULL, NULL, NULL, NULL, 'OS04G0514700 PROTEIN', 246181),
(364115, 'PTHR33110:SF70', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 246181),
(364116, 'PTHR33110:SF71', NULL, NULL, NULL, NULL, 'F-BOX/KELCH-REPEAT PROTEIN', 246181),
(364117, 'PTHR33110:SF73', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246181),
(364118, 'PTHR33110:SF122', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 246181),
(364119, 'PTHR33110:SF123', NULL, NULL, NULL, NULL, 'OSJNBA0004L19.23-LIKE PROTEIN', 246181),
(364120, 'PTHR33110:SF120', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 246181),
(364121, 'PTHR33110:SF121', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 246181),
(364122, 'PTHR33110', NULL, NULL, NULL, NULL, 'F-BOX/KELCH-REPEAT PROTEIN-RELATED', 246181),
(364123, 'PTHR33110:SF126', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 246181),
(364124, 'PTHR33110:SF78', NULL, NULL, NULL, NULL, 'OS06G0148900 PROTEIN', 246181),
(364125, 'PTHR33110:SF35', NULL, NULL, NULL, NULL, 'OS02G0714801 PROTEIN', 246181),
(364126, 'PTHR33110:SF127', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 246181),
(364127, 'PTHR33110:SF79', NULL, NULL, NULL, NULL, 'OS12G0155900 PROTEIN', 246181),
(364128, 'PTHR33110:SF36', NULL, NULL, NULL, NULL, 'OS06G0148600 PROTEIN', 246181),
(364129, 'PTHR33110:SF124', NULL, NULL, NULL, NULL, '', 246181),
(364130, 'PTHR33110:SF125', NULL, NULL, NULL, NULL, 'OS05G0539300 PROTEIN', 246181),
(364131, 'PTHR33110:SF74', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 246181),
(364132, 'PTHR33110:SF76', NULL, NULL, NULL, NULL, 'OS07G0500250 PROTEIN', 246181),
(364133, 'PTHR33110:SF128', NULL, NULL, NULL, NULL, 'RETROVIRUS-RELATED POL POLYPROTEIN FROM TRANSPOSON TNT 1-94', 246181),
(364134, 'PTHR33110:SF33', NULL, NULL, NULL, NULL, '', 246181),
(364135, 'PTHR33110:SF129', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 246181),
(364136, 'PTHR33110:SF130', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246181),
(364137, 'PTHR33110:SF61', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246181),
(364138, 'PTHR33110:SF62', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 246181),
(364139, 'PTHR33110:SF133', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 246181),
(364140, 'PTHR33110:SF131', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN', 246181),
(364141, 'PTHR33110:SF132', NULL, NULL, NULL, NULL, 'OS01G0520260 PROTEIN', 246181),
(364142, 'PTHR33110:SF23', NULL, NULL, NULL, NULL, 'OS04G0316800 PROTEIN', 246181),
(364143, 'PTHR33110:SF24', NULL, NULL, NULL, NULL, '', 246181),
(364144, 'PTHR33110:SF69', NULL, NULL, NULL, NULL, 'OS02G0318200 PROTEIN', 246181),
(364145, 'PTHR33110:SF26', NULL, NULL, NULL, NULL, 'OS10G0550400 PROTEIN', 246181),
(364146, 'PTHR33110:SF64', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 246181),
(364147, 'PTHR33110:SF65', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 246181),
(364148, 'PTHR33110:SF100', NULL, NULL, NULL, NULL, '', 246181),
(364149, 'PTHR33110:SF101', NULL, NULL, NULL, NULL, 'OS02G0159800 PROTEIN', 246181),
(364150, 'PTHR33110:SF90', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246181),
(364151, 'PTHR33110:SF91', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 246181),
(364152, 'PTHR33110:SF56', NULL, NULL, NULL, NULL, 'OS09G0565350 PROTEIN', 246181); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(364153, 'PTHR33110:SF104', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 246181),
(364154, 'PTHR33110:SF57', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 246181),
(364155, 'PTHR33110:SF15', NULL, NULL, NULL, NULL, 'OS11G0594500 PROTEIN', 246181),
(364156, 'PTHR33110:SF103', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246181),
(364157, 'PTHR33110:SF108', NULL, NULL, NULL, NULL, 'OS11G0154200 PROTEIN', 246181),
(364158, 'PTHR33110:SF97', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 246181),
(364159, 'PTHR33110:SF109', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 246181),
(364160, 'PTHR33110:SF99', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 246181),
(364161, 'PTHR35565:SF3', NULL, NULL, NULL, NULL, 'TYPE VI SECRETION SYSTEM SHEATH PROTEIN TSSC1', 246182),
(364162, 'PTHR35565:SF1', NULL, NULL, NULL, NULL, 'TYPE VI SECRETION SYSTEM NEEDLE SHEATH PROTEIN TSSC', 246182),
(364163, 'PTHR35565', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 246182),
(364164, 'PTHR10276:SF3', NULL, NULL, NULL, NULL, 'CORE-BINDING FACTOR SUBUNIT BETA', 246183),
(364165, 'PTHR10276', NULL, NULL, NULL, NULL, 'CORE-BINDING FACTOR, BETA SUBUNIT', 246183),
(364166, 'PTHR43326', NULL, NULL, NULL, NULL, 'METHIONYL-TRNA SYNTHETASE', 246184),
(364167, 'PTHR43326:SF2', NULL, NULL, NULL, NULL, 'METHIONYL-TRNA SYNTHETASE', 246184),
(364168, 'PTHR43326:SF1', NULL, NULL, NULL, NULL, 'METHIONINE--TRNA LIGASE, MITOCHONDRIAL', 246184),
(364169, 'PTHR43326:SF6', NULL, NULL, NULL, NULL, 'METHIONINE--TRNA LIGASE', 246184),
(364170, 'PTHR12504:SF3', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM22 HOMOLOG', 246185),
(364171, 'PTHR12504', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM22', 246185),
(364172, 'PTHR12504:SF0', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM22 HOMOLOG', 246185),
(364173, 'PTHR12504:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM22 HOMOLOG', 246185),
(364174, 'PTHR12504:SF2', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM22 HOMOLOG', 246185),
(364175, 'PTHR11046:SF0', NULL, NULL, NULL, NULL, 'OLIGORIBONUCLEASE, MITOCHONDRIAL', 246186),
(364176, 'PTHR11046', NULL, NULL, NULL, NULL, 'OLIGORIBONUCLEASE, MITOCHONDRIAL', 246186),
(364177, 'PTHR11046:SF15', NULL, NULL, NULL, NULL, 'ZGC:109744', 246186),
(364178, 'PTHR11046:SF26', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 246186),
(364179, 'PTHR11046:SF14', NULL, NULL, NULL, NULL, 'EXONUCLEASE DOMAIN-CONTAINING PROTEIN', 246186),
(364180, 'PTHR11046:SF25', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE TRANSCRIPTION FACTOR', 246186),
(364181, 'PTHR11046:SF24', NULL, NULL, NULL, NULL, 'PROTEIN CBG26503', 246186),
(364182, 'PTHR11046:SF11', NULL, NULL, NULL, NULL, 'EXODEOXYRIBONUCLEASE I', 246186),
(364183, 'PTHR11046:SF22', NULL, NULL, NULL, NULL, 'OLIGORIBONUCLEASE-LIKE', 246186),
(364184, 'PTHR13568:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 60', 246187),
(364185, 'PTHR13568:SF5', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 185B', 246187),
(364186, 'PTHR13568:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 185A', 246187),
(364187, 'PTHR13568:SF9', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 203', 246187),
(364188, 'PTHR13568', NULL, NULL, NULL, NULL, 'FAM11A, B PROTEIN', 246187),
(364189, 'PTHR13568:SF6', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 185-LIKE', 246187),
(364190, 'PTHR13568:SF10', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 185-LIKE', 246187),
(364191, 'PTHR22896:SF1', NULL, NULL, NULL, NULL, 'CDK5 AND ABL1 ENZYME SUBSTRATE 1', 246188),
(364192, 'PTHR22896:SF0', NULL, NULL, NULL, NULL, 'CYCLIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 246188),
(364193, 'PTHR22896', NULL, NULL, NULL, NULL, 'CDK5 AND ABL1 ENZYME SUBSTRATE 1', 246188),
(364194, 'PTHR22896:SF3', NULL, NULL, NULL, NULL, 'CDK5 AND ABL1 ENZYME SUBSTRATE 2', 246188),
(364195, 'PTHR47764:SF10', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE-SPECIFIC PROTEASE 2A-RELATED', 246189);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(364196, 'PTHR47764:SF11', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE-SPECIFIC PROTEASE 2A-RELATED', 246189),
(364197, 'PTHR47764:SF12', NULL, NULL, NULL, NULL, 'ULP1 PROTEASE FAMILY, CARBOXY-TERMINAL DOMAIN PROTEIN', 246189),
(364198, 'PTHR47764:SF13', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 246189),
(364199, 'PTHR47764:SF2', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 246189),
(364200, 'PTHR47764:SF4', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE-SPECIFIC PROTEASE 2B ISOFORM X1-RELATED', 246189),
(364201, 'PTHR47764', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE-SPECIFIC PROTEASE 2B-RELATED', 246189),
(364202, 'PTHR47764:SF7', NULL, NULL, NULL, NULL, 'ULP1 PROTEASE FAMILY, C-TERMINAL CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 246189),
(364203, 'PTHR47764:SF8', NULL, NULL, NULL, NULL, 'ULP1 PROTEASE FAMILY, C-TERMINAL CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 246189),
(364204, 'PTHR31814:SF5', NULL, NULL, NULL, NULL, 'PHOSPHOMEVALONATE KINASE', 246190),
(364205, 'PTHR31814', NULL, NULL, NULL, NULL, '', 246190),
(364206, 'PTHR31814:SF2', NULL, NULL, NULL, NULL, 'PHOSPHOMEVALONATE KINASE', 246190),
(364207, 'PTHR31814:SF6', NULL, NULL, NULL, NULL, 'PHOSPHOMEVALONATE KINASE', 246190),
(364208, 'PTHR47715', NULL, NULL, NULL, NULL, 'TRYPTOPHAN/TYROSINE PERMEASE', 246191),
(364209, 'PTHR47715:SF1', NULL, NULL, NULL, NULL, 'TRYPTOPHAN/TYROSINE PERMEASE', 246191),
(364210, 'PTHR23099:SF0', NULL, NULL, NULL, NULL, 'ACIDIC REPEAT-CONTAINING PROTEIN', 246192),
(364211, 'PTHR23099', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR', 246192),
(364212, 'PTHR30199:SF0', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YDCO', 246193),
(364213, 'PTHR30199', NULL, NULL, NULL, NULL, 'MFS FAMILY TRANSPORTER, PREDICTED SUBSTRATE BENZOATE', 246193),
(364214, 'PTHR13802:SF60', NULL, NULL, NULL, NULL, 'PROTEIN CBG06057', 246194),
(364215, 'PTHR13802:SF62', NULL, NULL, NULL, NULL, 'PROTEIN CBG09941', 246194),
(364216, 'PTHR13802:SF61', NULL, NULL, NULL, NULL, 'PROTEIN CBG04396', 246194),
(364217, 'PTHR13802', NULL, NULL, NULL, NULL, 'MUCIN 4-RELATED', 246194),
(364218, 'PTHR13802:SF56', NULL, NULL, NULL, NULL, 'PROTEIN MESH', 246194),
(364219, 'PTHR13802:SF59', NULL, NULL, NULL, NULL, 'NIDO DOMAIN-CONTAINING PROTEIN', 246194),
(364220, 'PTHR13802:SF63', NULL, NULL, NULL, NULL, 'SUSHI DOMAIN-CONTAINING PROTEIN 2', 246194),
(364221, 'PTHR13802:SF52', NULL, NULL, NULL, NULL, 'MUCIN-4', 246194),
(364222, 'PTHR36031', NULL, NULL, NULL, NULL, 'F21O3.15 PROTEIN', 246195),
(364223, 'PTHR36031:SF1', NULL, NULL, NULL, NULL, 'F21O3.15 PROTEIN', 246195),
(364224, 'PTHR38223:SF5', NULL, NULL, NULL, NULL, '', 246196),
(364225, 'PTHR38223:SF1', NULL, NULL, NULL, NULL, '', 246196),
(364226, 'PTHR38223:SF4', NULL, NULL, NULL, NULL, '', 246196),
(364227, 'PTHR38223', NULL, NULL, NULL, NULL, '', 246196),
(364228, 'PTHR46064:SF1', NULL, NULL, NULL, NULL, 'QUEUINE TRNA-RIBOSYLTRANSFERASE ACCESSORY SUBUNIT 2', 246197),
(364229, 'PTHR46064', NULL, NULL, NULL, NULL, 'QUEUINE TRNA-RIBOSYLTRANSFERASE ACCESSORY SUBUNIT 2', 246197),
(364230, 'PTHR28592:SF2', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING PROTEIN 1', 246198),
(364231, 'PTHR28592:SF1', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING PROTEIN 1', 246198),
(364232, 'PTHR28592', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING PROTEIN 1', 246198),
(364233, 'PTHR28592:SF4', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING PROTEIN 1', 246198),
(364234, 'PTHR28592:SF3', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING PROTEIN 1', 246198),
(364235, 'PTHR12265:SF9', NULL, NULL, NULL, NULL, 'DUF829 DOMAIN PROTEIN', 246199),
(364236, 'PTHR12265:SF40', NULL, NULL, NULL, NULL, '', 246199),
(364237, 'PTHR12265:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG03928', 246199),
(364238, 'PTHR12265:SF35', NULL, NULL, NULL, NULL, 'BNAA07G04120D PROTEIN', 246199),
(364239, 'PTHR12265:SF13', NULL, NULL, NULL, NULL, 'OS06G0213400 PROTEIN', 246199),
(364240, 'PTHR12265:SF0', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246199),
(364241, 'PTHR12265:SF36', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 246199);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(364242, 'PTHR12265:SF14', NULL, NULL, NULL, NULL, 'PAXU PROTEIN', 246199),
(364243, 'PTHR12265:SF30', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 53', 246199),
(364244, 'PTHR12265:SF41', NULL, NULL, NULL, NULL, 'PROTEIN CBG03266', 246199),
(364245, 'PTHR12265:SF11', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 246199),
(364246, 'PTHR12265:SF39', NULL, NULL, NULL, NULL, '', 246199),
(364247, 'PTHR12265:SF16', NULL, NULL, NULL, NULL, '', 246199),
(364248, 'PTHR12265:SF38', NULL, NULL, NULL, NULL, 'PROTEIN CBG12665', 246199),
(364249, 'PTHR12265', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 246199),
(364250, 'PTHR46104:SF6', NULL, NULL, NULL, NULL, '', 246200),
(364251, 'PTHR46104:SF1', NULL, NULL, NULL, NULL, 'GENE 9195-RELATED', 246200),
(364252, 'PTHR46104', NULL, NULL, NULL, NULL, 'GENE 9195-RELATED-RELATED', 246200),
(364253, 'PTHR43346', NULL, NULL, NULL, NULL, 'LIGAND BINDING DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G14370)-RELATED', 246201),
(364254, 'PTHR43346:SF2', NULL, NULL, NULL, NULL, '', 246201),
(364255, 'PTHR43346:SF1', NULL, NULL, NULL, NULL, 'LIGAND BINDING DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G14370)-RELATED', 246201),
(364256, 'PTHR43004:SF13', NULL, NULL, NULL, NULL, 'FAD_BINDING_3 DOMAIN-CONTAINING PROTEIN-RELATED', 246202),
(364257, 'PTHR43004:SF16', NULL, NULL, NULL, NULL, 'PHENOL 2-MONOOXYGENASE FSQG', 246202),
(364258, 'PTHR43004:SF15', NULL, NULL, NULL, NULL, 'MONOOXYGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G03030)-RELATED', 246202),
(364259, 'PTHR43004:SF17', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 246202),
(364260, 'PTHR43004:SF19', NULL, NULL, NULL, NULL, 'BINDING MONOOXYGENASE, PUTATIVE (JCVI)-RELATED', 246202),
(364261, 'PTHR43004:SF5', NULL, NULL, NULL, NULL, 'FAD_BINDING_3 DOMAIN-CONTAINING PROTEIN', 246202),
(364262, 'PTHR43004:SF10', NULL, NULL, NULL, NULL, '2-MONOOXYGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G11480)-RELATED', 246202),
(364263, 'PTHR43004:SF21', NULL, NULL, NULL, NULL, 'FAD-DEPENDENT MONOOXYGENASE APDD-RELATED', 246202),
(364264, 'PTHR43004:SF4', NULL, NULL, NULL, NULL, 'PHENOL 2-MONOOXYGENASE', 246202),
(364265, 'PTHR43004:SF20', NULL, NULL, NULL, NULL, '2-MONOOXYGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G13660)-RELATED', 246202),
(364266, 'PTHR43004:SF3', NULL, NULL, NULL, NULL, 'P-HYDROXYBENZOATE HYDROXYLASE', 246202),
(364267, 'PTHR43004', NULL, NULL, NULL, NULL, 'TRK SYSTEM POTASSIUM UPTAKE PROTEIN', 246202),
(364268, 'PTHR43004:SF8', NULL, NULL, NULL, NULL, 'FAD_BINDING_3 DOMAIN-CONTAINING PROTEIN-RELATED', 246202),
(364269, 'PTHR43004:SF7', NULL, NULL, NULL, NULL, 'FAD_BINDING_3 DOMAIN-CONTAINING PROTEIN-RELATED', 246202),
(364270, 'PTHR43004:SF6', NULL, NULL, NULL, NULL, 'FAD/NAD(P)-BINDING OXIDOREDUCTASE FAMILY PROTEIN', 246202),
(364271, 'PTHR36496:SF2', NULL, NULL, NULL, NULL, 'CADHERIN DOMAIN-CONTAINING PROTEIN', 246203),
(364272, 'PTHR36496', NULL, NULL, NULL, NULL, 'CADHERIN DOMAIN-CONTAINING PROTEIN', 246203),
(364273, 'PTHR39183', NULL, NULL, NULL, NULL, 'SPORE COAT PROTEIN F-LIKE PROTEIN YHCQ', 246204),
(364274, 'PTHR39183:SF1', NULL, NULL, NULL, NULL, 'SPORE COAT PROTEIN F-LIKE PROTEIN YHCQ', 246204),
(364275, 'PTHR37181', NULL, NULL, NULL, NULL, 'F6A14.6 PROTEIN', 246205),
(364276, 'PTHR37181:SF1', NULL, NULL, NULL, NULL, 'F6A14.6 PROTEIN', 246205),
(364277, 'PTHR21050', NULL, NULL, NULL, NULL, 'MIDKINE AND PLEIOTROPHIN 1, ISOFORM A-RELATED', 246206),
(364278, 'PTHR21050:SF1', NULL, NULL, NULL, NULL, 'MIDKINE AND PLEIOTROPHIN 1, ISOFORM A-RELATED', 246206),
(364279, 'PTHR28595', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L54, MITOCHONDRIAL', 246207),
(364280, 'PTHR28595:SF1', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L54, MITOCHONDRIAL', 246207),
(364281, 'PTHR47503:SF1', NULL, NULL, NULL, NULL, 'PURKINJE CELL PROTEIN 2 HOMOLOG', 246208),
(364282, 'PTHR47503', NULL, NULL, NULL, NULL, 'PURKINJE CELL PROTEIN 2', 246208),
(364283, 'PTHR45992:SF12', NULL, NULL, NULL, NULL, 'ALPHA-TYPE PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246209),
(364284, 'PTHR45992:SF11', NULL, NULL, NULL, NULL, 'ALPHA-TYPE PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246209);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(364285, 'PTHR45992:SF9', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN KINASE B', 246209),
(364286, 'PTHR45992:SF10', NULL, NULL, NULL, NULL, 'ALPHA-PROTEIN KINASE 1', 246209),
(364287, 'PTHR45992:SF8', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN KINASE A', 246209),
(364288, 'PTHR45992:SF2', NULL, NULL, NULL, NULL, 'EUKARYOTIC ELONGATION FACTOR 2 KINASE', 246209),
(364289, 'PTHR45992:SF1', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN KINASE C', 246209),
(364290, 'PTHR45992', NULL, NULL, NULL, NULL, 'EUKARYOTIC ELONGATION FACTOR 2 KINASE-RELATED', 246209),
(364291, 'PTHR12311', NULL, NULL, NULL, NULL, 'ACTIVATOR OF BASAL TRANSCRIPTION 1', 246210),
(364292, 'PTHR12311:SF7', NULL, NULL, NULL, NULL, 'ACTIVATOR OF BASAL TRANSCRIPTION 1', 246210),
(364293, 'PTHR46246:SF1', NULL, NULL, NULL, NULL, 'GUANOSINE-3'',5''-BIS(DIPHOSPHATE) 3''-PYROPHOSPHOHYDROLASE MESH1', 246211),
(364294, 'PTHR46246', NULL, NULL, NULL, NULL, 'GUANOSINE-3'',5''-BIS(DIPHOSPHATE) 3''-PYROPHOSPHOHYDROLASE MESH1', 246211),
(364295, 'PTHR19871:SF41', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 246212),
(364296, 'PTHR19871:SF40', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 41-RELATED', 246212),
(364297, 'PTHR19871:SF29', NULL, NULL, NULL, NULL, 'NACHT DOMAIN-CONTAINING PROTEIN', 246212),
(364298, 'PTHR19871:SF38', NULL, NULL, NULL, NULL, 'PROTEIN QUI-1', 246212),
(364299, 'PTHR19871:SF28', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 246212),
(364300, 'PTHR19871:SF39', NULL, NULL, NULL, NULL, 'NACHT AND WD REPEAT DOMAIN-CONTAINING PROTEIN 2', 246212),
(364301, 'PTHR19871:SF36', NULL, NULL, NULL, NULL, 'SI:CH211-212K18.6', 246212),
(364302, 'PTHR19871:SF14', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 246212),
(364303, 'PTHR19871:SF37', NULL, NULL, NULL, NULL, 'GH25853P', 246212),
(364304, 'PTHR19871', NULL, NULL, NULL, NULL, 'BETA TRANSDUCIN-RELATED PROTEIN', 246212),
(364305, 'PTHR48186:SF1', NULL, NULL, NULL, NULL, 'TOSPOVIRUS RESISTANCE PROTEIN C', 246213),
(364306, 'PTHR48186', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 246213),
(364307, 'PTHR40047:SF1', NULL, NULL, NULL, NULL, 'UPF0703 PROTEIN YCGQ', 246214),
(364308, 'PTHR40047', NULL, NULL, NULL, NULL, 'UPF0703 PROTEIN YCGQ', 246214),
(364309, 'PTHR10985:SF104', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR HES-5', 246215),
(364310, 'PTHR10985:SF8', NULL, NULL, NULL, NULL, 'HAIRY AND ENHANCER OF SPLIT-RELATED PROTEIN HELT', 246215),
(364311, 'PTHR10985:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR HES-3', 246215),
(364312, 'PTHR10985:SF3', NULL, NULL, NULL, NULL, 'CLASS E BASIC HELIX-LOOP-HELIX PROTEIN 40', 246215),
(364313, 'PTHR10985:SF76', NULL, NULL, NULL, NULL, 'CLASS E BASIC HELIX-LOOP-HELIX PROTEIN 41', 246215),
(364314, 'PTHR10985:SF12', NULL, NULL, NULL, NULL, 'ENHANCER OF SPLIT M3 PROTEIN-RELATED', 246215),
(364315, 'PTHR10985:SF78', NULL, NULL, NULL, NULL, 'HAIRY/ENHANCER-OF-SPLIT RELATED WITH YRPW MOTIF PROTEIN 1', 246215),
(364316, 'PTHR10985', NULL, NULL, NULL, NULL, 'BASIC HELIX-LOOP-HELIX TRANSCRIPTION FACTOR, HES-RELATED', 246215),
(364317, 'PTHR10985:SF77', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR HES-1', 246215),
(364318, 'PTHR10985:SF11', NULL, NULL, NULL, NULL, 'TRANSCRIPTION COFACTOR HES-6', 246215),
(364319, 'PTHR10985:SF79', NULL, NULL, NULL, NULL, 'HAIRY/ENHANCER-OF-SPLIT RELATED WITH YRPW MOTIF-LIKE PROTEIN', 246215),
(364320, 'PTHR10985:SF13', NULL, NULL, NULL, NULL, 'HER-4 PROTEIN-RELATED', 246215),
(364321, 'PTHR10985:SF145', NULL, NULL, NULL, NULL, 'HES-RELATED', 246215),
(364322, 'PTHR10985:SF15', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR HES-2', 246215),
(364323, 'PTHR10985:SF144', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTION FACTOR-RELATED', 246215),
(364324, 'PTHR10985:SF143', NULL, NULL, NULL, NULL, 'REF-1', 246215),
(364325, 'PTHR10985:SF141', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR CWO', 246215),
(364326, 'PTHR10985:SF140', NULL, NULL, NULL, NULL, 'HAIRY/ENHANCER-OF-SPLIT RELATED WITH YRPW MOTIF-LIKE PROTEIN', 246215);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(364327, 'PTHR10985:SF139', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 246215),
(364328, 'PTHR10985:SF138', NULL, NULL, NULL, NULL, 'HAIRY/ENHANCER-OF-SPLIT RELATED WITH YRPW MOTIF PROTEIN', 246215),
(364329, 'PTHR10985:SF137', NULL, NULL, NULL, NULL, 'PROTEIN DEADPAN-RELATED', 246215),
(364330, 'PTHR10985:SF136', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR HES-4', 246215),
(364331, 'PTHR10985:SF84', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR HES-7', 246215),
(364332, 'PTHR10985:SF88', NULL, NULL, NULL, NULL, 'HAIRY/ENHANCER-OF-SPLIT RELATED WITH YRPW MOTIF PROTEIN 2', 246215),
(364333, 'PTHR10985:SF27', NULL, NULL, NULL, NULL, 'HAIRY AND ENHANCER OF SPLIT 6, GENE 2', 246215),
(364334, 'PTHR10985:SF135', NULL, NULL, NULL, NULL, 'HAIRY AND ENHANCER OF SPLIT-RELATED-7', 246215),
(364335, 'PTHR10985:SF130', NULL, NULL, NULL, NULL, 'HAIRY-RELATED 8A', 246215),
(364336, 'PTHR40644:SF1', NULL, NULL, NULL, NULL, 'UPF0653 PROTEIN C607.02C', 246216),
(364337, 'PTHR40644', NULL, NULL, NULL, NULL, 'UPF0653 PROTEIN C607.02C', 246216),
(364338, 'PTHR31208:SF11', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE', 246217),
(364339, 'PTHR31208:SF2', NULL, NULL, NULL, NULL, 'DOMAIN-CONTAINING PROTEIN, PUTATIVE, EXPRESSED-RELATED', 246217),
(364340, 'PTHR31208:SF10', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 246217),
(364341, 'PTHR31208:SF4', NULL, NULL, NULL, NULL, 'OS07G0585000 PROTEIN', 246217),
(364342, 'PTHR31208:SF3', NULL, NULL, NULL, NULL, 'OS01G0953500 PROTEIN', 246217),
(364343, 'PTHR31208', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246217),
(364344, 'PTHR31208:SF17', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT LIPID-BINDING (CALB DOMAIN) FAMILY PROTEIN', 246217),
(364345, 'PTHR31208:SF18', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 246217),
(364346, 'PTHR31208:SF12', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 246217),
(364347, 'PTHR22801:SF61', NULL, NULL, NULL, NULL, 'SI:DKEYP-75B4.10', 246218),
(364348, 'PTHR22801', NULL, NULL, NULL, NULL, 'LITHOSTATHINE', 246218),
(364349, 'PTHR22801:SF60', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 246218),
(364350, 'PTHR22801:SF62', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 246218),
(364351, 'PTHR22801:SF53', NULL, NULL, NULL, NULL, '27 KDA PRIMARY MESENCHYME-SPECIFIC SPICULE PROTEIN', 246218),
(364352, 'PTHR39951:SF1', NULL, NULL, NULL, NULL, 'FI22632P1', 246219),
(364353, 'PTHR39951:SF2', NULL, NULL, NULL, NULL, 'IP05660P', 246219),
(364354, 'PTHR39951', NULL, NULL, NULL, NULL, 'FI22632P1', 246219),
(364355, 'PTHR13445:SF9', NULL, NULL, NULL, NULL, 'PROTEIN TSSC4', 246220),
(364356, 'PTHR13445', NULL, NULL, NULL, NULL, 'TUMOR SUPPRESSING SUBTRANSFERABLE CANDIDATE 4 TSSC4', 246220),
(364357, 'PTHR13445:SF3', NULL, NULL, NULL, NULL, 'PROTEIN TSSC4', 246220),
(364358, 'PTHR13445:SF5', NULL, NULL, NULL, NULL, 'PROTEIN TSSC4', 246220),
(364359, 'PTHR34792:SF4', NULL, NULL, NULL, NULL, 'BNAANNG08980D PROTEIN', 246221),
(364360, 'PTHR34792', NULL, NULL, NULL, NULL, 'OS02G0121500 PROTEIN', 246221),
(364361, 'PTHR34792:SF3', NULL, NULL, NULL, NULL, '', 246221),
(364362, 'PTHR34792:SF1', NULL, NULL, NULL, NULL, 'OS02G0121500 PROTEIN', 246221),
(364363, 'PTHR39377:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG12456', 246222),
(364364, 'PTHR39377:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG18428', 246222),
(364365, 'PTHR39377', NULL, NULL, NULL, NULL, 'PROTEIN CBG18423-RELATED', 246222),
(364366, 'PTHR39377:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG18423', 246222),
(364367, 'PTHR36102:SF4', NULL, NULL, NULL, NULL, '', 246223),
(364368, 'PTHR36102', NULL, NULL, NULL, NULL, 'CHROMOSOME 10, WHOLE GENOME SHOTGUN SEQUENCE', 246223),
(364369, 'PTHR36102:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 10, WHOLE GENOME SHOTGUN SEQUENCE', 246223),
(364370, 'PTHR36102:SF2', NULL, NULL, NULL, NULL, '', 246223),
(364371, 'PTHR47114', NULL, NULL, NULL, NULL, '', 246224),
(364372, 'PTHR47114:SF2', NULL, NULL, NULL, NULL, 'OLIGODENDROCYTE-MYELIN GLYCOPROTEIN', 246224);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(364373, 'PTHR30046:SF0', NULL, NULL, NULL, NULL, 'FLAGELLAR M-RING PROTEIN', 246225),
(364374, 'PTHR30046:SF3', NULL, NULL, NULL, NULL, 'SECRETION SYSTEM APPARATUS LIPOPROTEIN SSAJ', 246225),
(364375, 'PTHR30046:SF2', NULL, NULL, NULL, NULL, 'YOP PROTEINS TRANSLOCATION LIPOPROTEIN J', 246225),
(364376, 'PTHR30046', NULL, NULL, NULL, NULL, 'FLAGELLAR M-RING PROTEIN', 246225),
(364377, 'PTHR16212:SF4', NULL, NULL, NULL, NULL, 'FOCADHESIN', 246226),
(364378, 'PTHR16212', NULL, NULL, NULL, NULL, 'FOCADHESIN FAMILY MEMBER', 246226),
(364379, 'PTHR33272:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG04677', 246227),
(364380, 'PTHR33272:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG04649', 246227),
(364381, 'PTHR33272:SF2', NULL, NULL, NULL, NULL, 'DAF-16/FOXO CONTROLLED, GERMLINE TUMOR AFFECTING', 246227),
(364382, 'PTHR33272', NULL, NULL, NULL, NULL, 'PROTEIN CBG22877-RELATED', 246227),
(364383, 'PTHR33272:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG04676', 246227),
(364384, 'PTHR33272:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG22877', 246227),
(364385, 'PTHR33272:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG11525', 246227),
(364386, 'PTHR33272:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG19065', 246227),
(364387, 'PTHR33272:SF10', NULL, NULL, NULL, NULL, 'PROTEIN CBG04801', 246227),
(364388, 'PTHR33272:SF11', NULL, NULL, NULL, NULL, 'PROTEIN CBG19069', 246227),
(364389, 'PTHR33272:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG26497', 246227),
(364390, 'PTHR33272:SF12', NULL, NULL, NULL, NULL, 'PROTEIN CBG27161', 246227),
(364391, 'PTHR33272:SF13', NULL, NULL, NULL, NULL, 'PROTEIN CBG04683', 246227),
(364392, 'PTHR33272:SF14', NULL, NULL, NULL, NULL, 'TRANSCELLULAR CHAPERONE SIGNALING (X)CROSS TISSUE', 246227),
(364393, 'PTHR36943:SF1', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 246228),
(364394, 'PTHR36943', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 246228),
(364395, 'PTHR12577:SF7', NULL, NULL, NULL, NULL, 'DACHSHUND HOMOLOG 2', 246229),
(364396, 'PTHR12577:SF14', NULL, NULL, NULL, NULL, 'DACHSHUND HOMOLOG 1', 246229),
(364397, 'PTHR12577', NULL, NULL, NULL, NULL, 'DACHSHUND', 246229),
(364398, 'PTHR12577:SF6', NULL, NULL, NULL, NULL, 'DACHSHUND, ISOFORM B', 246229),
(364399, 'PTHR21432:SF13', NULL, NULL, NULL, NULL, 'ACETYL-COA DEACYLASE', 246230),
(364400, 'PTHR21432', NULL, NULL, NULL, NULL, 'ACETYL-COA HYDROLASE-RELATED', 246230),
(364401, 'PTHR21432:SF20', NULL, NULL, NULL, NULL, 'ACETYL-COA DEACYLASE', 246230),
(364402, 'PTHR40392', NULL, NULL, NULL, NULL, '2-PHOSPHO-L-LACTATE GUANYLYLTRANSFERASE', 246231),
(364403, 'PTHR40392:SF1', NULL, NULL, NULL, NULL, '2-PHOSPHO-L-LACTATE GUANYLYLTRANSFERASE', 246231),
(364404, 'PTHR47579:SF4', NULL, NULL, NULL, NULL, 'BNAA01G27230D PROTEIN', 246232),
(364405, 'PTHR47579:SF3', NULL, NULL, NULL, NULL, 'COMPLEX 1 PROTEIN, LYR FAMILY PROTEIN', 246232),
(364406, 'PTHR47579', NULL, NULL, NULL, NULL, 'COMPLEX 1 LYR PROTEIN', 246232),
(364407, 'PTHR24244:SF2', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE S RECEPTOR', 246233),
(364408, 'PTHR24244:SF1', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 246233),
(364409, 'PTHR24244', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE S RECEPTOR', 246233),
(364410, 'PTHR24244:SF0', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 246233),
(364411, 'PTHR47704', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER KIMA', 246234),
(364412, 'PTHR47704:SF1', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER KIMA', 246234),
(364413, 'PTHR35737', NULL, NULL, NULL, NULL, 'CRYPTIC LOCI REGULATOR', 246235),
(364414, 'PTHR35737:SF2', NULL, NULL, NULL, NULL, 'BNAA09G02070D PROTEIN', 246235),
(364415, 'PTHR35737:SF1', NULL, NULL, NULL, NULL, 'CRYPTIC LOCI REGULATOR', 246235),
(364416, 'PTHR21058:SF0', NULL, NULL, NULL, NULL, '6,7-DIMETHYL-8-RIBITYLLUMAZINE SYNTHASE', 246236),
(364417, 'PTHR21058:SF1', NULL, NULL, NULL, NULL, '6,7-DIMETHYL-8-RIBITYLLUMAZINE SYNTHASE', 246236),
(364418, 'PTHR21058', NULL, NULL, NULL, NULL, '6,7-DIMETHYL-8-RIBITYLLUMAZINE SYNTHASE  DMRL SYNTHASE   LUMAZINE SYNTHASE', 246236);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(364419, 'PTHR46067:SF9', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE (GNAT) DOMAIN PROTEIN', 246237),
(364420, 'PTHR46067:SF7', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 246237),
(364421, 'PTHR46067:SF28', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE (GNAT) DOMAIN PROTEIN', 246237),
(364422, 'PTHR46067:SF17', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASES (NAT) SUPERFAMILY PROTEIN', 246237),
(364423, 'PTHR46067', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASES (NAT) SUPERFAMILY PROTEIN', 246237),
(364424, 'PTHR46067:SF2', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE, GNAT FAMILY PROTEIN, EXPRESSED', 246237),
(364425, 'PTHR46067:SF18', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASES (NAT) SUPERFAMILY PROTEIN', 246237),
(364426, 'PTHR46067:SF3', NULL, NULL, NULL, NULL, 'OS03G0665000 PROTEIN', 246237),
(364427, 'PTHR46067:SF26', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 246237),
(364428, 'PTHR46067:SF15', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE (GNAT) DOMAIN PROTEIN', 246237),
(364429, 'PTHR46067:SF16', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 246237),
(364430, 'PTHR46067:SF27', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASES (NAT) SUPERFAMILY PROTEIN', 246237),
(364431, 'PTHR46067:SF20', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 246237),
(364432, 'PTHR46067:SF30', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASE (NAT) SUPERFAMILY PROTEIN', 246237),
(364433, 'PTHR46067:SF13', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 246237),
(364434, 'PTHR46067:SF24', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASES (NAT) SUPERFAMILY PROTEIN', 246237),
(364435, 'PTHR46067:SF25', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 246237),
(364436, 'PTHR46067:SF14', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 246237),
(364437, 'PTHR46067:SF11', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 246237),
(364438, 'PTHR46067:SF22', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 246237),
(364439, 'PTHR46822', NULL, NULL, NULL, NULL, 'COILED-COIL ALPHA-HELICAL ROD PROTEIN 1', 246238),
(364440, 'PTHR46822:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL ALPHA-HELICAL ROD PROTEIN 1', 246238),
(364441, 'PTHR31257:SF7', NULL, NULL, NULL, NULL, 'RICIN B-LIKE LECTIN R40G2', 246239),
(364442, 'PTHR31257:SF5', NULL, NULL, NULL, NULL, 'OS12G0184300 PROTEIN', 246239),
(364443, 'PTHR31257:SF13', NULL, NULL, NULL, NULL, 'OS03G0325900 PROTEIN', 246239),
(364444, 'PTHR31257', NULL, NULL, NULL, NULL, 'RICIN B-LIKE LECTIN EULS3', 246239),
(364445, 'PTHR31257:SF23', NULL, NULL, NULL, NULL, 'RICIN B, LECTIN DOMAIN-CONTAINING PROTEIN-RELATED', 246239),
(364446, 'PTHR31257:SF11', NULL, NULL, NULL, NULL, 'RICIN B-LIKE LECTIN R40G3', 246239),
(364447, 'PTHR31257:SF22', NULL, NULL, NULL, NULL, 'RICIN B-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 246239),
(364448, 'PTHR31257:SF21', NULL, NULL, NULL, NULL, 'OS07G0683600 PROTEIN', 246239),
(364449, 'PTHR31257:SF20', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 246239),
(364450, 'PTHR31257:SF3', NULL, NULL, NULL, NULL, 'RICIN B-LIKE LECTIN R40C1', 246239),
(364451, 'PTHR31257:SF2', NULL, NULL, NULL, NULL, 'RICIN B-LIKE LECTIN EULS3', 246239),
(364452, 'PTHR31257:SF18', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 246239),
(364453, 'PTHR31257:SF17', NULL, NULL, NULL, NULL, '', 246239),
(364454, 'PTHR35795:SF1', NULL, NULL, NULL, NULL, 'SLR1885 PROTEIN', 246240),
(364455, 'PTHR35795', NULL, NULL, NULL, NULL, 'SLR1885 PROTEIN', 246240),
(364456, 'PTHR15201:SF1', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 26', 246241),
(364457, 'PTHR15201', NULL, NULL, NULL, NULL, 'CRSP70', 246241),
(364458, 'PTHR31475:SF3', NULL, NULL, NULL, NULL, 'UPF0462 PROTEIN C4ORF33', 246242),
(364459, 'PTHR31475:SF6', NULL, NULL, NULL, NULL, '', 246242),
(364460, 'PTHR31475:SF5', NULL, NULL, NULL, NULL, 'UPF0462 PROTEIN C4ORF33 HOMOLOG', 246242);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(364461, 'PTHR31475', NULL, NULL, NULL, NULL, 'UPF0462 PROTEIN', 246242),
(364462, 'PTHR36986:SF1', NULL, NULL, NULL, NULL, 'UPF0643 PROTEIN PB2B2.08', 246243),
(364463, 'PTHR36986', NULL, NULL, NULL, NULL, 'UPF0643 PROTEIN PB2B2.08', 246243),
(364464, 'PTHR30168', NULL, NULL, NULL, NULL, 'PUTATIVE MEMBRANE PROTEIN YPFJ', 246244),
(364465, 'PTHR30168:SF0', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', 246244),
(364466, 'PTHR21483', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II-ASSOCIATED PROTEIN 1', 246245),
(364467, 'PTHR21483:SF18', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II-ASSOCIATED PROTEIN 1', 246245),
(364468, 'PTHR21595:SF0', NULL, NULL, NULL, NULL, 'PATRONIN', 246246),
(364469, 'PTHR21595:SF2', NULL, NULL, NULL, NULL, 'CALMODULIN-REGULATED SPECTRIN-ASSOCIATED PROTEIN 3', 246246),
(364470, 'PTHR21595:SF1', NULL, NULL, NULL, NULL, 'CALMODULIN-REGULATED SPECTRIN-ASSOCIATED PROTEIN 2', 246246),
(364471, 'PTHR21595:SF3', NULL, NULL, NULL, NULL, 'CALMODULIN-REGULATED SPECTRIN-ASSOCIATED PROTEIN 1', 246246),
(364472, 'PTHR21595', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 246246),
(364473, 'PTHR21503:SF51', NULL, NULL, NULL, NULL, '', 246247),
(364474, 'PTHR21503', NULL, NULL, NULL, NULL, 'F-BOX-CONTAINING HYPOTHETICAL PROTEIN  C.ELEGANS', 246247),
(364475, 'PTHR21503:SF40', NULL, NULL, NULL, NULL, 'PROTEIN CBG03708', 246247),
(364476, 'PTHR21503:SF50', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246247),
(364477, 'PTHR21503:SF17', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246247),
(364478, 'PTHR21503:SF15', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246247),
(364479, 'PTHR21503:SF48', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN-RELATED', 246247),
(364480, 'PTHR21503:SF49', NULL, NULL, NULL, NULL, 'PROTEIN CBG20260', 246247),
(364481, 'PTHR21503:SF36', NULL, NULL, NULL, NULL, 'FBA_2 DOMAIN-CONTAINING PROTEIN', 246247),
(364482, 'PTHR21503:SF11', NULL, NULL, NULL, NULL, 'PROTEIN CBG27691', 246247),
(364483, 'PTHR21503:SF12', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN-RELATED', 246247),
(364484, 'PTHR21503:SF6', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN-RELATED', 246247),
(364485, 'PTHR21503:SF31', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246247),
(364486, 'PTHR21503:SF20', NULL, NULL, NULL, NULL, 'FBA_2 DOMAIN-CONTAINING PROTEIN', 246247),
(364487, 'PTHR21503:SF8', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN-RELATED', 246247),
(364488, 'PTHR11213:SF5', NULL, NULL, NULL, NULL, 'VIP PEPTIDES', 246248),
(364489, 'PTHR11213:SF6', NULL, NULL, NULL, NULL, 'SOMATOLIBERIN', 246248),
(364490, 'PTHR11213', NULL, NULL, NULL, NULL, 'GLUCAGON-FAMILY NEUROPEPTIDE', 246248),
(364491, 'PTHR11213:SF1', NULL, NULL, NULL, NULL, 'PITUITARY ADENYLATE CYCLASE-ACTIVATING POLYPEPTIDE', 246248),
(364492, 'PTHR11213:SF10', NULL, NULL, NULL, NULL, 'ADCYAP1B PROTEIN', 246248),
(364493, 'PTHR31102:SF18', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 246249),
(364494, 'PTHR31102:SF14', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER 9B2', 246249),
(364495, 'PTHR31102:SF5', NULL, NULL, NULL, NULL, 'SLC9B1-LIKE PROTEIN SLC9B1P1-RELATED', 246249),
(364496, 'PTHR31102:SF21', NULL, NULL, NULL, NULL, 'NA[+]/H[+] HYDROGEN ANTIPORTER 2, ISOFORM B', 246249),
(364497, 'PTHR31102:SF1', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 246249),
(364498, 'PTHR31102', NULL, NULL, NULL, NULL, '', 246249),
(364499, 'PTHR45086', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN PCN', 246250),
(364500, 'PTHR45086:SF1', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN PCN', 246250),
(364501, 'PTHR45086:SF2', NULL, NULL, NULL, NULL, 'TRANSDUCIN FAMILY PROTEIN / WD-40 REPEAT FAMILY PROTEIN', 246250),
(364502, 'PTHR45086:SF4', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 246250),
(364503, 'PTHR45086:SF5', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RNA-ASSOCIATED PROTEIN 4 HOMOLOG', 246250),
(364504, 'PTHR24093:SF458', NULL, NULL, NULL, NULL, 'CATION_ATPASE_C DOMAIN-CONTAINING PROTEIN', 246251);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(364505, 'PTHR24093:SF377', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE CALCIUM-TRANSPORTING ATPASE 2', 246251),
(364506, 'PTHR24093:SF454', NULL, NULL, NULL, NULL, 'CATION_ATPASE_C DOMAIN-CONTAINING PROTEIN', 246251),
(364507, 'PTHR24093:SF455', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE 12, PLASMA MEMBRANE-TYPE', 246251),
(364508, 'PTHR24093:SF463', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364509, 'PTHR24093:SF420', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE 3, PLASMA MEMBRANE-TYPE', 246251),
(364510, 'PTHR24093:SF462', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE 11, PLASMA MEMBRANE-TYPE-RELATED', 246251),
(364511, 'PTHR24093:SF524', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364512, 'PTHR24093:SF128', NULL, NULL, NULL, NULL, 'MAGNESIUM-TRANSPORTING ATPASE, P-TYPE 1', 246251),
(364513, 'PTHR24093:SF448', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364514, 'PTHR24093:SF489', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364515, 'PTHR24093:SF522', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364516, 'PTHR24093:SF369', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364517, 'PTHR24093:SF523', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364518, 'PTHR24093:SF520', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE 9, PLASMA MEMBRANE-TYPE', 246251),
(364519, 'PTHR24093:SF245', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE CALCIUM-TRANSPORTING ATPASE 1', 246251),
(364520, 'PTHR24093:SF444', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE 7, PLASMA MEMBRANE-TYPE-RELATED', 246251),
(364521, 'PTHR24093:SF521', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364522, 'PTHR24093:SF496', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364523, 'PTHR24093:SF453', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364524, 'PTHR24093:SF450', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364525, 'PTHR24093:SF253', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364526, 'PTHR24093:SF451', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364527, 'PTHR24093:SF493', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364528, 'PTHR24093', NULL, NULL, NULL, NULL, 'CATION TRANSPORTING ATPASE', 246251),
(364529, 'PTHR24093:SF491', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE 7, PLASMA MEMBRANE-TYPE', 246251),
(364530, 'PTHR24093:SF519', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364531, 'PTHR24093:SF517', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364532, 'PTHR24093:SF518', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364533, 'PTHR24093:SF438', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE 4, PLASMA MEMBRANE-TYPE', 246251),
(364534, 'PTHR24093:SF515', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364535, 'PTHR24093:SF516', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364536, 'PTHR24093:SF439', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE 8, PLASMA MEMBRANE-TYPE', 246251),
(364537, 'PTHR24093:SF436', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364538, 'PTHR24093:SF513', NULL, NULL, NULL, NULL, 'CATION-TRANSPORTING ATPASE I-RELATED', 246251),
(364539, 'PTHR24093:SF514', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364540, 'PTHR24093:SF511', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE 12, PLASMA MEMBRANE-TYPE-LIKE', 246251),
(364541, 'PTHR24093:SF434', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE 13, PLASMA MEMBRANE-TYPE-RELATED', 246251),
(364542, 'PTHR24093:SF512', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE 6, PLASMA MEMBRANE-TYPE-RELATED', 246251),
(364543, 'PTHR24093:SF479', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364544, 'PTHR24093:SF435', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE CALCIUM-TRANSPORTING ATPASE 4', 246251);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(364545, 'PTHR24093:SF432', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE 12, PLASMA MEMBRANE-TYPE-LIKE', 246251),
(364546, 'PTHR24093:SF477', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364547, 'PTHR24093:SF510', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364548, 'PTHR24093:SF485', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364549, 'PTHR24093:SF486', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364550, 'PTHR24093:SF481', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364551, 'PTHR24093:SF284', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE CALCIUM-TRANSPORTING ATPASE 3', 246251),
(364552, 'PTHR24093:SF480', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364553, 'PTHR24093:SF508', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE CTPE', 246251),
(364554, 'PTHR24093:SF509', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364555, 'PTHR24093:SF506', NULL, NULL, NULL, NULL, 'CATION-TRANSPORTING ATPASE PMA1', 246251),
(364556, 'PTHR24093:SF504', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364557, 'PTHR24093:SF425', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364558, 'PTHR24093:SF502', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE 1, PLASMA MEMBRANE-TYPE', 246251),
(364559, 'PTHR24093:SF346', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364560, 'PTHR24093:SF423', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364561, 'PTHR24093:SF467', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE 1', 246251),
(364562, 'PTHR24093:SF424', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364563, 'PTHR24093:SF501', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364564, 'PTHR24093:SF465', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364565, 'PTHR24093:SF474', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE 2, PLASMA MEMBRANE-TYPE', 246251),
(364566, 'PTHR24093:SF431', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364567, 'PTHR24093:SF473', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', 246251),
(364568, 'PTHR24093:SF470', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE 12, PLASMA MEMBRANE-TYPE-LIKE', 246251),
(364569, 'PTHR33339', NULL, NULL, NULL, NULL, '', 246252),
(364570, 'PTHR33339:SF1', NULL, NULL, NULL, NULL, '', 246252),
(364571, 'PTHR23530:SF1', NULL, NULL, NULL, NULL, 'PERMEASE, MAJOR FACILITATOR SUPERFAMILY-RELATED', 246253),
(364572, 'PTHR23530', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN-RELATED', 246253),
(364573, 'PTHR35038:SF5', NULL, NULL, NULL, NULL, 'OCTAHEME TETRATHIONATE REDUCTASE OTR', 246254),
(364574, 'PTHR35038:SF6', NULL, NULL, NULL, NULL, 'C-TYPE POLYHEME CYTOCHROME OMCC', 246254),
(364575, 'PTHR35038:SF8', NULL, NULL, NULL, NULL, 'CYTOCHROME C-TYPE PROTEIN NRFB', 246254),
(364576, 'PTHR35038:SF9', NULL, NULL, NULL, NULL, 'BLL2660 PROTEIN', 246254),
(364577, 'PTHR35038', NULL, NULL, NULL, NULL, 'DISSIMILATORY SULFITE REDUCTASE SIRA', 246254),
(364578, 'PTHR46494', NULL, NULL, NULL, NULL, 'CORA FAMILY METAL ION TRANSPORTER (EUROFUNG)', 246255),
(364579, 'PTHR46494:SF1', NULL, NULL, NULL, NULL, 'CORA FAMILY METAL ION TRANSPORTER (EUROFUNG)', 246255),
(364580, 'PTHR46494:SF3', NULL, NULL, NULL, NULL, 'ZINC TRANSPORT PROTEIN ZNTB', 246255),
(364581, 'PTHR46494:SF2', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORT PROTEIN CORA', 246255),
(364582, 'PTHR43022:SF1', NULL, NULL, NULL, NULL, 'PROTEIN SMF', 246256),
(364583, 'PTHR43022', NULL, NULL, NULL, NULL, 'PROTEIN SMF', 246256),
(364584, 'PTHR13456', NULL, NULL, NULL, NULL, 'UPF0729 PROTEIN C18ORF32', 246257),
(364585, 'PTHR13456:SF0', NULL, NULL, NULL, NULL, 'UPF0729 PROTEIN C18ORF32', 246257),
(364586, 'PTHR46577:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 246258),
(364587, 'PTHR46577:SF1', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATORY PROTEIN GABR', 246258),
(364588, 'PTHR46577', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATORY PROTEIN GABR', 246258);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(364589, 'PTHR46988:SF2', NULL, NULL, NULL, NULL, 'TWO PORE CALCIUM CHANNEL PROTEIN 1', 246259),
(364590, 'PTHR46988', NULL, NULL, NULL, NULL, 'TWO PORE CALCIUM CHANNEL PROTEIN 1', 246259),
(364591, 'PTHR46988:SF3', NULL, NULL, NULL, NULL, 'BNACNNG16060D PROTEIN', 246259),
(364592, 'PTHR46988:SF4', NULL, NULL, NULL, NULL, 'ION_TRANS DOMAIN-CONTAINING PROTEIN', 246259),
(364593, 'PTHR42023', NULL, NULL, NULL, NULL, '', 246260),
(364594, 'PTHR42023:SF1', NULL, NULL, NULL, NULL, '', 246260),
(364595, 'PTHR34149:SF6', NULL, NULL, NULL, NULL, '', 246261),
(364596, 'PTHR34149:SF11', NULL, NULL, NULL, NULL, 'PROTEIN CBG26518', 246261),
(364597, 'PTHR34149:SF12', NULL, NULL, NULL, NULL, '', 246261),
(364598, 'PTHR34149:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG02644', 246261),
(364599, 'PTHR34149:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG09996', 246261),
(364600, 'PTHR34149:SF10', NULL, NULL, NULL, NULL, 'PROTEIN CBG11905', 246261),
(364601, 'PTHR34149:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG18148', 246261),
(364602, 'PTHR34149:SF2', NULL, NULL, NULL, NULL, 'PROTEIN SUP-1', 246261),
(364603, 'PTHR34149', NULL, NULL, NULL, NULL, 'PROTEIN CBG11905-RELATED', 246261),
(364604, 'PTHR34149:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG25828', 246261),
(364605, 'PTHR34149:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG13228', 246261),
(364606, 'PTHR34149:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG00994', 246261),
(364607, 'PTHR43313', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/REDUCTASE FAMILY 9C', 246262),
(364608, 'PTHR43313:SF5', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/REDUCTASE FAMILY 9C MEMBER 7', 246262),
(364609, 'PTHR43313:SF7', NULL, NULL, NULL, NULL, 'DEHYDROGENASES, SHORT CHAIN', 246262),
(364610, 'PTHR43313:SF1', NULL, NULL, NULL, NULL, 'GH26015P', 246262),
(364611, 'PTHR43313:SF2', NULL, NULL, NULL, NULL, 'CORTICOSTEROID 11-BETA-DEHYDROGENASE ISOZYME 2', 246262),
(364612, 'PTHR43313:SF3', NULL, NULL, NULL, NULL, '17-BETA-HYDROXYSTEROID DEHYDROGENASE TYPE 2', 246262),
(364613, 'PTHR43313:SF18', NULL, NULL, NULL, NULL, 'DIETARY RESTRICTION DOWN REGULATED', 246262),
(364614, 'PTHR43313:SF4', NULL, NULL, NULL, NULL, '17-BETA-HYDROXYSTEROID DEHYDROGENASE TYPE 6', 246262),
(364615, 'PTHR43313:SF25', NULL, NULL, NULL, NULL, 'D-BETA-HYDROXYBUTYRATE DEHYDROGENASE, MITOCHONDRIAL', 246262),
(364616, 'PTHR43313:SF14', NULL, NULL, NULL, NULL, 'CIS-RETINOL/3ALPHA HYDROXYSTEROL SHORT-CHAIN DEHYDROGENASE-LIKE PROTEIN-RELATED', 246262),
(364617, 'PTHR43313:SF36', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/REDUCTASE', 246262),
(364618, 'PTHR43313:SF15', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE SDR FAMILY MEMBER 9', 246262),
(364619, 'PTHR43313:SF34', NULL, NULL, NULL, NULL, 'DEHYDROGENASES, SHORT CHAIN', 246262),
(364620, 'PTHR43313:SF12', NULL, NULL, NULL, NULL, 'RETINOL DEHYDROGENASE 5', 246262),
(364621, 'PTHR43313:SF32', NULL, NULL, NULL, NULL, '', 246262),
(364622, 'PTHR43313:SF43', NULL, NULL, NULL, NULL, 'ZGC:113142', 246262),
(364623, 'PTHR43313:SF11', NULL, NULL, NULL, NULL, 'RETINOL DEHYDROGENASE 16', 246262),
(364624, 'PTHR43313:SF41', NULL, NULL, NULL, NULL, 'RETINOL DEHYDROGENASE 1', 246262),
(364625, 'PTHR43313:SF42', NULL, NULL, NULL, NULL, '', 246262),
(364626, 'PTHR33877', NULL, NULL, NULL, NULL, 'SLL1193 PROTEIN', 246263),
(364627, 'PTHR33877:SF2', NULL, NULL, NULL, NULL, 'HNHC DOMAIN-CONTAINING PROTEIN', 246263),
(364628, 'PTHR33877:SF1', NULL, NULL, NULL, NULL, '5-METHYLCYTOSINE-SPECIFIC RESTRICTION ENZYME A', 246263),
(364629, 'PTHR46792:SF2', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 80', 246264),
(364630, 'PTHR46792:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING 80-LIKE 2', 246264),
(364631, 'PTHR46792', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 80', 246264),
(364632, 'PTHR10252:SF140', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT C-6', 246265),
(364633, 'PTHR10252:SF141', NULL, NULL, NULL, NULL, 'CBFD_NFYB_HMF DOMAIN-CONTAINING PROTEIN', 246265),
(364634, 'PTHR10252:SF39', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT C-6', 246265);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(364635, 'PTHR10252:SF142', NULL, NULL, NULL, NULL, 'HISTONE DOMAIN-CONTAINING PROTEIN', 246265),
(364636, 'PTHR10252:SF127', NULL, NULL, NULL, NULL, 'CBFD_NFYB_HMF DOMAIN-CONTAINING PROTEIN', 246265),
(364637, 'PTHR10252:SF124', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT C-10', 246265),
(364638, 'PTHR10252:SF103', NULL, NULL, NULL, NULL, 'CBFD_NFYB_HMF DOMAIN-CONTAINING PROTEIN', 246265),
(364639, 'PTHR10252:SF109', NULL, NULL, NULL, NULL, 'CBFD_NFYB_HMF DOMAIN-CONTAINING PROTEIN', 246265),
(364640, 'PTHR10252:SF106', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT C-3-RELATED', 246265),
(364641, 'PTHR10252:SF93', NULL, NULL, NULL, NULL, 'HISTONE-LIKE TRANSCRIPTION FACTOR AND ARCHAEAL HISTONE FAMILY PROTEIN, EXPRESSED', 246265),
(364642, 'PTHR10252:SF91', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT GAMMA', 246265),
(364643, 'PTHR10252:SF79', NULL, NULL, NULL, NULL, 'DNA POLYMERASE EPSILON SUBUNIT 4', 246265),
(364644, 'PTHR10252:SF98', NULL, NULL, NULL, NULL, 'OS05G0494100 PROTEIN', 246265),
(364645, 'PTHR10252:SF54', NULL, NULL, NULL, NULL, 'CHROMATIN ACCESSIBILITY COMPLEX PROTEIN 1', 246265),
(364646, 'PTHR10252:SF96', NULL, NULL, NULL, NULL, 'CBFD_NFYB_HMF DOMAIN-CONTAINING PROTEIN', 246265),
(364647, 'PTHR10252:SF130', NULL, NULL, NULL, NULL, 'DR1-ASSOCIATED COREPRESSOR HOMOLOG', 246265),
(364648, 'PTHR10252:SF5', NULL, NULL, NULL, NULL, 'DR1-ASSOCIATED COREPRESSOR', 246265),
(364649, 'PTHR10252:SF133', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT C-1-RELATED', 246265),
(364650, 'PTHR10252:SF134', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT C-4', 246265),
(364651, 'PTHR10252:SF8', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT GAMMA', 246265),
(364652, 'PTHR10252:SF131', NULL, NULL, NULL, NULL, 'HISTONE SUPERFAMILY PROTEIN', 246265),
(364653, 'PTHR10252:SF132', NULL, NULL, NULL, NULL, 'CBFD_NFYB_HMF DOMAIN-CONTAINING PROTEIN', 246265),
(364654, 'PTHR10252:SF115', NULL, NULL, NULL, NULL, 'CBFD_NFYB_HMF DOMAIN-CONTAINING PROTEIN', 246265),
(364655, 'PTHR10252:SF137', NULL, NULL, NULL, NULL, 'HISTONE DOMAIN-CONTAINING PROTEIN', 246265),
(364656, 'PTHR10252:SF138', NULL, NULL, NULL, NULL, 'CBFD_NFYB_HMF DOMAIN-CONTAINING PROTEIN', 246265),
(364657, 'PTHR10252:SF135', NULL, NULL, NULL, NULL, 'CBFD_NFYB_HMF DOMAIN-CONTAINING PROTEIN', 246265),
(364658, 'PTHR10252:SF113', NULL, NULL, NULL, NULL, 'DR1-ASSOCIATED PROTEIN 1 (NEGATIVE COFACTOR 2 ALPHA)', 246265),
(364659, 'PTHR10252:SF136', NULL, NULL, NULL, NULL, 'CBFD_NFYB_HMF DOMAIN-CONTAINING PROTEIN', 246265),
(364660, 'PTHR10252:SF139', NULL, NULL, NULL, NULL, 'HAP5 SUBUNIT OF HAP COMPLEX', 246265),
(364661, 'PTHR10252:SF117', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y PROTEIN', 246265),
(364662, 'PTHR10252', NULL, NULL, NULL, NULL, 'HISTONE-LIKE TRANSCRIPTION FACTOR CCAAT-RELATED', 246265),
(364663, 'PTHR10252:SF41', NULL, NULL, NULL, NULL, 'HAP5 SUBUNIT OF HAP COMPLEX', 246265),
(364664, 'PTHR17613:SF9', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AND COILED-COIL DOMAINS PROTEIN 2', 246266),
(364665, 'PTHR17613:SF8', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AND COILED-COIL DOMAIN PROTEIN 3', 246266),
(364666, 'PTHR17613:SF14', NULL, NULL, NULL, NULL, 'DEMENTIN, ISOFORM H', 246266),
(364667, 'PTHR17613', NULL, NULL, NULL, NULL, 'CEREBRAL PROTEIN-11-RELATED', 246266),
(364668, 'PTHR17613:SF11', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AND COILED-COIL DOMAINS PROTEIN 1', 246266),
(364669, 'PTHR17613:SF22', NULL, NULL, NULL, NULL, '', 246266),
(364670, 'PTHR17613:SF10', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC PROTEIN TEX28', 246266),
(364671, 'PTHR35836', NULL, NULL, NULL, NULL, '', 246267),
(364672, 'PTHR35836:SF1', NULL, NULL, NULL, NULL, '', 246267),
(364673, 'PTHR46335', NULL, NULL, NULL, NULL, 'CUBILIN', 246268),
(364674, 'PTHR46335:SF3', NULL, NULL, NULL, NULL, 'CUBILIN', 246268),
(364675, 'PTHR46335:SF1', NULL, NULL, NULL, NULL, 'CUBILIN HOMOLOG', 246268),
(364676, 'PTHR10130:SF8', NULL, NULL, NULL, NULL, 'TRNA (ADENINE(58)-N(1))-METHYLTRANSFERASE', 246269);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(364677, 'PTHR10130:SF4', NULL, NULL, NULL, NULL, 'MICROBODY (PEROXISOME) BIOGENESIS PROTEIN PEROXIN 20 (EUROFUNG)', 246269),
(364678, 'PTHR10130:SF5', NULL, NULL, NULL, NULL, 'PEROXIN-5', 246269),
(364679, 'PTHR10130:SF2', NULL, NULL, NULL, NULL, 'PEROXISOMAL TARGETING SIGNAL 1 RECEPTOR', 246269),
(364680, 'PTHR10130:SF0', NULL, NULL, NULL, NULL, 'GH08708P', 246269),
(364681, 'PTHR10130:SF1', NULL, NULL, NULL, NULL, 'PEX5-RELATED PROTEIN', 246269),
(364682, 'PTHR10130', NULL, NULL, NULL, NULL, 'PEROXISOMAL TARGETING SIGNAL 1 RECEPTOR  PEX5', 246269),
(364683, 'PTHR46051:SF8', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 3,4,5-TRISPHOSPHATE 5-PHOSPHATASE 2B', 246270),
(364684, 'PTHR46051:SF1', NULL, NULL, NULL, NULL, 'IPPC DOMAIN-CONTAINING PROTEIN', 246270),
(364685, 'PTHR46051:SF2', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 3,4,5-TRISPHOSPHATE 5-PHOSPHATASE 2', 246270),
(364686, 'PTHR46051', NULL, NULL, NULL, NULL, 'SH2 DOMAIN-CONTAINING PROTEIN', 246270),
(364687, 'PTHR46051:SF3', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 3,4,5-TRISPHOSPHATE 5-PHOSPHATASE 1', 246270),
(364688, 'PTHR15371', NULL, NULL, NULL, NULL, 'TIM23', 246271),
(364689, 'PTHR15371:SF30', NULL, NULL, NULL, NULL, 'BNAC07G33510D PROTEIN', 246271),
(364690, 'PTHR15371:SF0', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM23', 246271),
(364691, 'PTHR15371:SF1', NULL, NULL, NULL, NULL, 'OUTER ENVELOPE PORE PROTEIN 16-2, CHLOROPLASTIC', 246271),
(364692, 'PTHR15371:SF26', NULL, NULL, NULL, NULL, 'BNAA06G11810D PROTEIN', 246271),
(364693, 'PTHR15371:SF5', NULL, NULL, NULL, NULL, 'OS01G0303300 PROTEIN', 246271),
(364694, 'PTHR15371:SF24', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM23-3', 246271),
(364695, 'PTHR15371:SF2', NULL, NULL, NULL, NULL, 'OUTER ENVELOPE PORE PROTEIN 16-1, CHLOROPLASTIC', 246271),
(364696, 'PTHR15371:SF35', NULL, NULL, NULL, NULL, '', 246271),
(364697, 'PTHR15371:SF25', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM23-2-LIKE', 246271),
(364698, 'PTHR15371:SF33', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM23', 246271),
(364699, 'PTHR15371:SF22', NULL, NULL, NULL, NULL, 'OUTER ENVELOPE PORE PROTEIN 16-1 CHLOROPLASTIC', 246271),
(364700, 'PTHR15371:SF34', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM23B', 246271),
(364701, 'PTHR15371:SF20', NULL, NULL, NULL, NULL, '', 246271),
(364702, 'PTHR15371:SF21', NULL, NULL, NULL, NULL, '', 246271),
(364703, 'PTHR15371:SF32', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM17 FAMILY PROTEIN, EXPRESSED', 246271),
(364704, 'PTHR15371:SF19', NULL, NULL, NULL, NULL, 'OS04G0566700 PROTEIN', 246271),
(364705, 'PTHR15371:SF28', NULL, NULL, NULL, NULL, 'BNAC01G21960D PROTEIN', 246271),
(364706, 'PTHR15371:SF29', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM23', 246271),
(364707, 'PTHR23040:SF1', NULL, NULL, NULL, NULL, 'OUTER DYNEIN ARM-DOCKING COMPLEX SUBUNIT 4', 246272),
(364708, 'PTHR23040', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 246272),
(364709, 'PTHR23040:SF2', NULL, NULL, NULL, NULL, 'TPR DOMAIN CONTAINING PROTEIN', 246272),
(364710, 'PTHR37853:SF1', NULL, NULL, NULL, NULL, '', 246273),
(364711, 'PTHR37853', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 246273),
(364712, 'PTHR11558:SF51', NULL, NULL, NULL, NULL, 'SPERMIDINE SYNTHASE', 246274),
(364713, 'PTHR11558:SF28', NULL, NULL, NULL, NULL, 'PABS DOMAIN-CONTAINING PROTEIN', 246274),
(364714, 'PTHR11558:SF29', NULL, NULL, NULL, NULL, 'AMINOPROPYL TRANSFERASE', 246274),
(364715, 'PTHR11558', NULL, NULL, NULL, NULL, 'SPERMIDINE/SPERMINE SYNTHASE', 246274),
(364716, 'PTHR11558:SF45', NULL, NULL, NULL, NULL, 'PUTRESCINE N-METHYLTRANSFERASE', 246274),
(364717, 'PTHR11558:SF46', NULL, NULL, NULL, NULL, 'PABS DOMAIN-CONTAINING PROTEIN', 246274),
(364718, 'PTHR11558:SF47', NULL, NULL, NULL, NULL, 'SPERMIDINE SYNTHASE', 246274);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(364719, 'PTHR11558:SF25', NULL, NULL, NULL, NULL, 'SPERMINE SYNTHASE', 246274),
(364720, 'PTHR11558:SF48', NULL, NULL, NULL, NULL, 'PABS DOMAIN-CONTAINING PROTEIN', 246274),
(364721, 'PTHR11558:SF53', NULL, NULL, NULL, NULL, 'PUTRESCINE N-METHYLTRANSFERASE 1', 246274),
(364722, 'PTHR11558:SF43', NULL, NULL, NULL, NULL, 'SPERMIDINE SYNTHASE', 246274),
(364723, 'PTHR11558:SF54', NULL, NULL, NULL, NULL, 'PABS DOMAIN-CONTAINING PROTEIN', 246274),
(364724, 'PTHR11558:SF44', NULL, NULL, NULL, NULL, 'PABS DOMAIN-CONTAINING PROTEIN', 246274),
(364725, 'PTHR11558:SF11', NULL, NULL, NULL, NULL, 'SPERMIDINE SYNTHASE', 246274),
(364726, 'PTHR13994:SF39', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 246275),
(364727, 'PTHR13994:SF49', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE SUPERFAMILY PROTEIN', 246275),
(364728, 'PTHR13994:SF38', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 246275),
(364729, 'PTHR13994:SF37', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 246275),
(364730, 'PTHR13994:SF26', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 5-RELATED', 246275),
(364731, 'PTHR13994:SF13', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 8', 246275),
(364732, 'PTHR13994:SF35', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 2-LIKE', 246275),
(364733, 'PTHR13994:SF46', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE-LINKED MOIETY X MOTIF 6', 246275),
(364734, 'PTHR13994:SF45', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 2-LIKE', 246275),
(364735, 'PTHR13994:SF44', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 6-LIKE PROTEIN-RELATED', 246275),
(364736, 'PTHR13994:SF33', NULL, NULL, NULL, NULL, 'NUDIX FAMILY HYDROLASE', 246275),
(364737, 'PTHR13994:SF32', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 10-LIKE', 246275),
(364738, 'PTHR13994:SF7', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE FAMILY PROTEIN-RELATED', 246275),
(364739, 'PTHR13994:SF42', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 6-LIKE PROTEIN-RELATED', 246275),
(364740, 'PTHR13994:SF30', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 246275),
(364741, 'PTHR13994:SF52', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 8-LIKE', 246275),
(364742, 'PTHR13994:SF51', NULL, NULL, NULL, NULL, 'FI03680P', 246275),
(364743, 'PTHR13994:SF40', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 10', 246275),
(364744, 'PTHR13994:SF50', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 7', 246275),
(364745, 'PTHR13994', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE RELATED', 246275),
(364746, 'PTHR13994:SF29', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 2', 246275),
(364747, 'PTHR11028', NULL, NULL, NULL, NULL, 'VACUOLAR ATP SYNTHASE SUBUNIT AC39', 246276),
(364748, 'PTHR11028:SF2', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT D 2', 246276),
(364749, 'PTHR11028:SF4', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT', 246276),
(364750, 'PTHR11028:SF3', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT D 1', 246276),
(364751, 'PTHR11028:SF0', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT D 1', 246276),
(364752, 'PTHR47733', NULL, NULL, NULL, NULL, 'ATAXIN-7 LIKE PROTEIN 3B, ATXN7L3B', 246277),
(364753, 'PTHR47733:SF1', NULL, NULL, NULL, NULL, 'ATAXIN-7-LIKE PROTEIN 3B', 246277),
(364754, 'PTHR30561:SF7', NULL, NULL, NULL, NULL, 'GUANIDINIUM EFFLUX SYSTEM SUBUNIT GDNC-RELATED', 246278),
(364755, 'PTHR30561:SF6', NULL, NULL, NULL, NULL, 'SPERMIDINE EXPORT PROTEIN MDTI', 246278),
(364756, 'PTHR30561:SF1', NULL, NULL, NULL, NULL, 'MULTIDRUG TRANSPORTER EMRE', 246278),
(364757, 'PTHR30561:SF0', NULL, NULL, NULL, NULL, 'GUANIDINIUM EXPORTER', 246278),
(364758, 'PTHR30561:SF23', NULL, NULL, NULL, NULL, '4-AMINO-4-DEOXY-L-ARABINOSE-PHOSPHOUNDECAPRENOL FLIPPASE SUBUNIT ARNE-RELATED', 246278),
(364759, 'PTHR30561:SF2', NULL, NULL, NULL, NULL, 'SPERMIDINE EXPORT PROTEIN MDTJ', 246278),
(364760, 'PTHR30561:SF21', NULL, NULL, NULL, NULL, 'MOLECULAR CHAPERONE-RELATED', 246278),
(364761, 'PTHR30561:SF9', NULL, NULL, NULL, NULL, '4-AMINO-4-DEOXY-L-ARABINOSE-PHOSPHOUNDECAPRENOL FLIPPASE SUBUNIT ARNF-RELATED', 246278),
(364762, 'PTHR30561', NULL, NULL, NULL, NULL, 'SMR FAMILY PROTON-DEPENDENT DRUG EFFLUX TRANSPORTER SUGE', 246278);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(364763, 'PTHR13681', NULL, NULL, NULL, NULL, 'SURVIVAL OF MOTOR NEURON-RELATED-SPLICING FACTOR 30-RELATED', 246279),
(364764, 'PTHR13681:SF27', NULL, NULL, NULL, NULL, 'SURVIVAL MOTOR NEURON PROTEIN', 246279),
(364765, 'PTHR13681:SF26', NULL, NULL, NULL, NULL, 'SURVIVAL OF MOTOR NEURON-RELATED-SPLICING FACTOR 30', 246279),
(364766, 'PTHR13681:SF24', NULL, NULL, NULL, NULL, 'TUDOR DOMAIN-CONTAINING PROTEIN 3', 246279),
(364767, 'PTHR13681:SF32', NULL, NULL, NULL, NULL, 'TUDOR DOMAIN-CONTAINING PROTEIN', 246279),
(364768, 'PTHR33605:SF2', NULL, NULL, NULL, NULL, 'EARLY NODULIN-93', 246280),
(364769, 'PTHR33605:SF3', NULL, NULL, NULL, NULL, 'EARLY NODULIN-LIKE PROTEIN', 246280),
(364770, 'PTHR33605:SF10', NULL, NULL, NULL, NULL, '', 246280),
(364771, 'PTHR33605:SF6', NULL, NULL, NULL, NULL, '', 246280),
(364772, 'PTHR33605:SF4', NULL, NULL, NULL, NULL, 'EARLY NODULIN-RELATED', 246280),
(364773, 'PTHR33605', NULL, NULL, NULL, NULL, 'EARLY NODULIN-93', 246280),
(364774, 'PTHR33605:SF5', NULL, NULL, NULL, NULL, '', 246280),
(364775, 'PTHR33605:SF15', NULL, NULL, NULL, NULL, '', 246280),
(364776, 'PTHR33605:SF16', NULL, NULL, NULL, NULL, '', 246280),
(364777, 'PTHR33605:SF11', NULL, NULL, NULL, NULL, 'EARLY NODULIN', 246280),
(364778, 'PTHR33605:SF13', NULL, NULL, NULL, NULL, '', 246280),
(364779, 'PTHR33605:SF14', NULL, NULL, NULL, NULL, '', 246280),
(364780, 'PTHR45962:SF1', NULL, NULL, NULL, NULL, 'N-FATTY-ACYL-AMINO ACID SYNTHASE/HYDROLASE PM20D1', 246281),
(364781, 'PTHR45962:SF2', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE S-LIKE 2-RELATED', 246281),
(364782, 'PTHR45962', NULL, NULL, NULL, NULL, 'N-FATTY-ACYL-AMINO ACID SYNTHASE/HYDROLASE PM20D1', 246281),
(364783, 'PTHR24184', NULL, NULL, NULL, NULL, 'SI:CH211-189E2.2', 246282),
(364784, 'PTHR24184:SF26', NULL, NULL, NULL, NULL, 'ANKYRIN-1-LIKE', 246282),
(364785, 'PTHR24184:SF24', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND PROTEIN KINASE DOMAIN-CONTAINING PROTEIN 1-LIKE', 246282),
(364786, 'PTHR24184:SF25', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT PROTEIN YAHD-RELATED', 246282),
(364787, 'PTHR24184:SF11', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN-RELATED', 246282),
(364788, 'PTHR24184:SF6', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SAM DOMAIN-CONTAINING PROTEIN 3', 246282),
(364789, 'PTHR24174:SF1', NULL, NULL, NULL, NULL, 'IP14385P', 246283),
(364790, 'PTHR24174:SF18', NULL, NULL, NULL, NULL, 'CASKIN-2', 246283),
(364791, 'PTHR24174', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND STERILE ALPHA MOTIF DOMAIN-CONTAINING PROTEIN 1', 246283),
(364792, 'PTHR24174:SF17', NULL, NULL, NULL, NULL, 'PID DOMAIN-CONTAINING PROTEIN', 246283),
(364793, 'PTHR24174:SF16', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 246283),
(364794, 'PTHR24174:SF5', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND STERILE ALPHA MOTIF DOMAIN-CONTAINING 1AB', 246283),
(364795, 'PTHR24174:SF4', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SAM DOMAIN-CONTAINING PROTEIN 1A', 246283),
(364796, 'PTHR24174:SF3', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND STERILE ALPHA MOTIF DOMAIN-CONTAINING PROTEIN 1B', 246283),
(364797, 'PTHR24174:SF11', NULL, NULL, NULL, NULL, 'CASKIN-1', 246283),
(364798, 'PTHR11603:SF155', NULL, NULL, NULL, NULL, 'AAA+ ATPASE MOXR MRP FAMILY', 246284),
(364799, 'PTHR11603:SF166', NULL, NULL, NULL, NULL, 'MORR PROTEIN', 246284),
(364800, 'PTHR11603:SF132', NULL, NULL, NULL, NULL, 'MAGNESIUM CHELATASE', 246284),
(364801, 'PTHR11603', NULL, NULL, NULL, NULL, 'AAA FAMILY ATPASE', 246284),
(364802, 'PTHR11603:SF157', NULL, NULL, NULL, NULL, 'PILT PROTEIN DOMAIN PROTEIN', 246284),
(364803, 'PTHR11603:SF148', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN MOXR1-RELATED', 246284),
(364804, 'PTHR11603:SF147', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 246284),
(364805, 'PTHR31827', NULL, NULL, NULL, NULL, 'EMB|CAB89363.1', 246285),
(364806, 'PTHR31827:SF38', NULL, NULL, NULL, NULL, 'OS04G0640900 PROTEIN', 246285),
(364807, 'PTHR31827:SF59', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR', 246285),
(364808, 'PTHR31827:SF43', NULL, NULL, NULL, NULL, '', 246285); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(364809, 'PTHR31827:SF32', NULL, NULL, NULL, NULL, 'OS02G0259100 PROTEIN', 246285),
(364810, 'PTHR31827:SF42', NULL, NULL, NULL, NULL, 'LORICRIN-RELATED', 246285),
(364811, 'PTHR31827:SF40', NULL, NULL, NULL, NULL, 'F22C12.10', 246285),
(364812, 'PTHR31827:SF47', NULL, NULL, NULL, NULL, 'BNAA09G06880D PROTEIN', 246285),
(364813, 'PTHR31827:SF58', NULL, NULL, NULL, NULL, '', 246285),
(364814, 'PTHR31827:SF57', NULL, NULL, NULL, NULL, 'OS02G0575700 PROTEIN', 246285),
(364815, 'PTHR31827:SF35', NULL, NULL, NULL, NULL, 'LORICRIN-RELATED', 246285),
(364816, 'PTHR31827:SF45', NULL, NULL, NULL, NULL, '', 246285),
(364817, 'PTHR31827:SF56', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR', 246285),
(364818, 'PTHR31827:SF55', NULL, NULL, NULL, NULL, 'BNACNNG45290D PROTEIN', 246285),
(364819, 'PTHR31827:SF1', NULL, NULL, NULL, NULL, 'EMB|CAB89363.1', 246285),
(364820, 'PTHR31827:SF50', NULL, NULL, NULL, NULL, 'BNAC02G43180D PROTEIN', 246285),
(364821, 'PTHR31827:SF60', NULL, NULL, NULL, NULL, '', 246285),
(364822, 'PTHR24094:SF15', NULL, NULL, NULL, NULL, 'CIA30 DOMAIN-CONTAINING PROTEIN-RELATED', 246286),
(364823, 'PTHR24094', NULL, NULL, NULL, NULL, 'SECRETED PROTEIN', 246286),
(364824, 'PTHR37435:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG04414', 246287),
(364825, 'PTHR37435:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG14643', 246287),
(364826, 'PTHR37435:SF3', NULL, NULL, NULL, NULL, 'DUMPY: SHORTER THAN WILD-TYPE', 246287),
(364827, 'PTHR37435:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG05945', 246287),
(364828, 'PTHR37435:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG14344', 246287),
(364829, 'PTHR37435', NULL, NULL, NULL, NULL, 'PROTEIN CBG14344', 246287),
(364830, 'PTHR42802:SF1', NULL, NULL, NULL, NULL, 'L-ORNITHINE N(5)-MONOOXYGENASE', 246288),
(364831, 'PTHR42802', NULL, NULL, NULL, NULL, 'MONOOXYGENASE', 246288),
(364832, 'PTHR31594:SF15', NULL, NULL, NULL, NULL, 'SI:CH211-281L24.3-RELATED', 246289),
(364833, 'PTHR31594:SF14', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE-III DOMAIN-CONTAINING PROTEIN', 246289),
(364834, 'PTHR31594:SF11', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE-III DOMAIN-CONTAINING PROTEIN-RELATED', 246289),
(364835, 'PTHR31594', NULL, NULL, NULL, NULL, 'AIG1-TYPE G DOMAIN-CONTAINING PROTEIN', 246289),
(364836, 'PTHR14431:SF1', NULL, NULL, NULL, NULL, 'HCLS1-BINDING PROTEIN 3', 246290),
(364837, 'PTHR14431', NULL, NULL, NULL, NULL, 'HCLS1-BINDING PROTEIN 3', 246290),
(364838, 'PTHR33548:SF11', NULL, NULL, NULL, NULL, '', 246291),
(364839, 'PTHR33548', NULL, NULL, NULL, NULL, 'GLYCINE-RICH CELL WALL STRUCTURAL PROTEIN 2', 246291),
(364840, 'PTHR33548:SF20', NULL, NULL, NULL, NULL, 'OS06G0199000 PROTEIN', 246291),
(364841, 'PTHR33548:SF10', NULL, NULL, NULL, NULL, 'GLYCINE-RICH CELL WALL STRUCTURAL PROTEIN 2', 246291),
(364842, 'PTHR33548:SF15', NULL, NULL, NULL, NULL, '', 246291),
(364843, 'PTHR33548:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246291),
(364844, 'PTHR33548:SF14', NULL, NULL, NULL, NULL, 'GLYCINE RICH PROTEIN4', 246291),
(364845, 'PTHR33548:SF3', NULL, NULL, NULL, NULL, 'GLYCINE-RICH CELL WALL STRUCTURAL PROTEIN 2', 246291),
(364846, 'PTHR33548:SF2', NULL, NULL, NULL, NULL, 'OS10G0452500 PROTEIN', 246291),
(364847, 'PTHR33548:SF17', NULL, NULL, NULL, NULL, '', 246291),
(364848, 'PTHR33548:SF4', NULL, NULL, NULL, NULL, '', 246291),
(364849, 'PTHR33548:SF6', NULL, NULL, NULL, NULL, '', 246291),
(364850, 'PTHR23506', NULL, NULL, NULL, NULL, '', 246292),
(364851, 'PTHR23506:SF28', NULL, NULL, NULL, NULL, 'MFS-TYPE TRANSPORTER SLC18B1-LIKE PROTEIN', 246292),
(364852, 'PTHR23506:SF26', NULL, NULL, NULL, NULL, 'MFS-TYPE TRANSPORTER SLC18B1', 246292),
(364853, 'PTHR23506:SF37', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 246292),
(364854, 'PTHR23506:SF23', NULL, NULL, NULL, NULL, 'GH10249P', 246292),
(364855, 'PTHR23506:SF35', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 246292),
(364856, 'PTHR23506:SF13', NULL, NULL, NULL, NULL, 'VESICULAR ACETYLCHOLINE TRANSPORTER', 246292),
(364857, 'PTHR23506:SF4', NULL, NULL, NULL, NULL, 'PORTABELLA', 246292); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(364858, 'PTHR23506:SF30', NULL, NULL, NULL, NULL, 'SYNAPTIC VESICULAR AMINE TRANSPORTER', 246292),
(364859, 'PTHR23506:SF31', NULL, NULL, NULL, NULL, 'CHROMAFFIN GRANULE AMINE TRANSPORTER', 246292),
(364860, 'PTHR23506:SF29', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G10530)-RELATED', 246292),
(364861, 'PTHR28019:SF3', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_6G07470)', 246293),
(364862, 'PTHR28019:SF2', NULL, NULL, NULL, NULL, 'CELL MEMBRANE PROTEIN YLR413W-RELATED', 246293),
(364863, 'PTHR28019:SF6', NULL, NULL, NULL, NULL, 'PROTEIN ECM7', 246293),
(364864, 'PTHR28019:SF5', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN', 246293),
(364865, 'PTHR28019', NULL, NULL, NULL, NULL, 'CELL MEMBRANE PROTEIN YLR413W-RELATED', 246293),
(364866, 'PTHR24046:SF6', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 246294),
(364867, 'PTHR24046:SF5', NULL, NULL, NULL, NULL, 'CYSTEINE REPEAT MODULAR PROTEIN 3', 246294),
(364868, 'PTHR24046:SF4', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDE, CUB AND EGF-LIKE DOMAIN-CONTAINING PROTEIN 1', 246294),
(364869, 'PTHR24046:SF3', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDE, CUB AND EGF-LIKE DOMAIN-CONTAINING PROTEIN 2', 246294),
(364870, 'PTHR24046:SF2', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDE, CUB AND EGF-LIKE DOMAIN-CONTAINING PROTEIN 3', 246294),
(364871, 'PTHR24046', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDE, CUB AND EGF-LIKE DOMAIN-CONTAINING', 246294),
(364872, 'PTHR47597:SF4', NULL, NULL, NULL, NULL, 'LIPOYL-BINDING DOMAIN-CONTAINING PROTEIN', 246295),
(364873, 'PTHR47597', NULL, NULL, NULL, NULL, 'IS A MEMBER OF THE PF|00364 BIOTIN-REQUIRING ENZYMES FAMILY-RELATED', 246295),
(364874, 'PTHR47597:SF2', NULL, NULL, NULL, NULL, 'LIPOYL-BINDING DOMAIN-CONTAINING PROTEIN', 246295),
(364875, 'PTHR47597:SF1', NULL, NULL, NULL, NULL, 'IS A MEMBER OF THE PF|00364 BIOTIN-REQUIRING ENZYMES FAMILY-RELATED', 246295),
(364876, 'PTHR37992', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246296),
(364877, 'PTHR37992:SF1', NULL, NULL, NULL, NULL, 'FUNGAL PROTEIN', 246296),
(364878, 'PTHR16188:SF13', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 14D', 246297),
(364879, 'PTHR16188', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 INHIBITOR POTENTIATED BY PROTEIN KINASE C', 246297),
(364880, 'PTHR16188:SF15', NULL, NULL, NULL, NULL, '4933415F23RIK PROTEIN', 246297),
(364881, 'PTHR16188:SF14', NULL, NULL, NULL, NULL, 'GEO07393P1', 246297),
(364882, 'PTHR16188:SF18', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY INHIBITOR SUBUNIT 14B', 246297),
(364883, 'PTHR16188:SF6', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 14C', 246297),
(364884, 'PTHR16188:SF5', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 14B', 246297),
(364885, 'PTHR16188:SF4', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 14A', 246297),
(364886, 'PTHR12396:SF46', NULL, NULL, NULL, NULL, 'METHYL-CPG-BINDING DOMAIN PROTEIN 1', 246298),
(364887, 'PTHR12396:SF55', NULL, NULL, NULL, NULL, 'MBD DOMAIN-CONTAINING PROTEIN', 246298),
(364888, 'PTHR12396:SF45', NULL, NULL, NULL, NULL, 'OS06G0702100 PROTEIN', 246298),
(364889, 'PTHR12396:SF12', NULL, NULL, NULL, NULL, 'METHYL-CPG-BINDING DOMAIN PROTEIN 3', 246298),
(364890, 'PTHR12396:SF56', NULL, NULL, NULL, NULL, 'MBDA DOMAIN-CONTAINING PROTEIN', 246298),
(364891, 'PTHR12396:SF53', NULL, NULL, NULL, NULL, 'MBD DOMAIN-CONTAINING PROTEIN', 246298),
(364892, 'PTHR12396:SF42', NULL, NULL, NULL, NULL, 'MBD DOMAIN-CONTAINING PROTEIN', 246298),
(364893, 'PTHR12396:SF54', NULL, NULL, NULL, NULL, 'METHYL-CPG-BINDING DOMAIN PROTEIN 1A', 246298),
(364894, 'PTHR12396:SF10', NULL, NULL, NULL, NULL, 'METHYL-CPG-BINDING DOMAIN-CONTAINING PROTEIN 1-RELATED', 246298),
(364895, 'PTHR12396:SF51', NULL, NULL, NULL, NULL, 'BNAANNG29130D PROTEIN', 246298),
(364896, 'PTHR12396:SF30', NULL, NULL, NULL, NULL, '', 246298),
(364897, 'PTHR12396:SF52', NULL, NULL, NULL, NULL, '', 246298),
(364898, 'PTHR12396:SF50', NULL, NULL, NULL, NULL, 'ZINC FINGER, CW-TYPE, DNA-BINDING DOMAIN PROTEIN-RELATED', 246298);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(364899, 'PTHR12396:SF6', NULL, NULL, NULL, NULL, 'METHYL-CPG-BINDING DOMAIN PROTEIN 3-LIKE 2-RELATED', 246298),
(364900, 'PTHR12396:SF5', NULL, NULL, NULL, NULL, 'METHYL-CPG-BINDING DOMAIN PROTEIN 2', 246298),
(364901, 'PTHR12396:SF1', NULL, NULL, NULL, NULL, 'METHYL-CPG-BINDING DOMAIN PROTEIN 3-LIKE 1', 246298),
(364902, 'PTHR12396:SF0', NULL, NULL, NULL, NULL, 'METHYL-CPG BINDING DOMAIN PROTEIN-LIKE, ISOFORM C', 246298),
(364903, 'PTHR12396', NULL, NULL, NULL, NULL, 'METHYL-CPG BINDING PROTEIN, MBD', 246298),
(364904, 'PTHR12396:SF39', NULL, NULL, NULL, NULL, 'MBD DOMAIN-CONTAINING PROTEIN', 246298),
(364905, 'PTHR12396:SF29', NULL, NULL, NULL, NULL, 'MBD DOMAIN-CONTAINING PROTEIN', 246298),
(364906, 'PTHR12396:SF48', NULL, NULL, NULL, NULL, 'METHYL-CPG-BINDING DOMAIN PROTEIN 1B', 246298),
(364907, 'PTHR12396:SF38', NULL, NULL, NULL, NULL, 'METHYL-CPG-BINDING DOMAIN-CONTAINING PROTEIN 7', 246298),
(364908, 'PTHR12396:SF49', NULL, NULL, NULL, NULL, 'METHYL-CPG-BINDING DOMAIN-CONTAINING PROTEIN 6', 246298),
(364909, 'PTHR10063:SF0', NULL, NULL, NULL, NULL, 'TUBERIN', 246299),
(364910, 'PTHR10063:SF2', NULL, NULL, NULL, NULL, 'RAL GTPASE-ACTIVATING PROTEIN SUBUNIT ALPHA-2', 246299),
(364911, 'PTHR10063:SF3', NULL, NULL, NULL, NULL, 'RAL GTPASE-ACTIVATING PROTEIN SUBUNIT ALPHA-1', 246299),
(364912, 'PTHR10063', NULL, NULL, NULL, NULL, 'TUBERIN', 246299),
(364913, 'PTHR10063:SF11', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN CG5521-RELATED', 246299),
(364914, 'PTHR23274:SF43', NULL, NULL, NULL, NULL, '', 246300),
(364915, 'PTHR23274:SF44', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 246300),
(364916, 'PTHR23274:SF33', NULL, NULL, NULL, NULL, 'ANIMAL RPA1 DOMAIN PROTEIN', 246300),
(364917, 'PTHR23274:SF11', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE PIF1', 246300),
(364918, 'PTHR23274:SF45', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 246300),
(364919, 'PTHR23274:SF46', NULL, NULL, NULL, NULL, 'HELICASE-LIKE PROTEIN, PUTATIVE-RELATED', 246300),
(364920, 'PTHR23274', NULL, NULL, NULL, NULL, 'DNA HELICASE-RELATED', 246300),
(364921, 'PTHR23274:SF40', NULL, NULL, NULL, NULL, '', 246300),
(364922, 'PTHR23274:SF41', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 246300),
(364923, 'PTHR23274:SF42', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 246300),
(364924, 'PTHR23274:SF18', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE PIF2', 246300),
(364925, 'PTHR23274:SF19', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE PIF1', 246300),
(364926, 'PTHR23274:SF7', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE PIF3', 246300),
(364927, 'PTHR23274:SF47', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE PIF6', 246300),
(364928, 'PTHR23274:SF48', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 246300),
(364929, 'PTHR23274:SF37', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 246300),
(364930, 'PTHR23274:SF39', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 246300),
(364931, 'PTHR13902:SF129', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246301),
(364932, 'PTHR13902:SF127', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246301),
(364933, 'PTHR13902:SF169', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 246301),
(364934, 'PTHR13902:SF147', NULL, NULL, NULL, NULL, 'BNAA02G08990D PROTEIN', 246301),
(364935, 'PTHR13902:SF168', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE WNK2', 246301),
(364936, 'PTHR13902:SF167', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246301),
(364937, 'PTHR13902:SF145', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246301),
(364938, 'PTHR13902:SF48', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR-BINDING PROTEIN', 246301),
(364939, 'PTHR13902:SF46', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE WNK1', 246301),
(364940, 'PTHR13902:SF68', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246301),
(364941, 'PTHR13902:SF47', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE WNK3', 246301);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(364942, 'PTHR13902:SF44', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE WNK5-RELATED', 246301),
(364943, 'PTHR13902:SF67', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR-BINDING PROTEIN HOMOLOG', 246301),
(364944, 'PTHR13902:SF166', NULL, NULL, NULL, NULL, 'BNAA10G11970D PROTEIN', 246301),
(364945, 'PTHR13902:SF144', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE WNK1', 246301),
(364946, 'PTHR13902:SF165', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 246301),
(364947, 'PTHR13902:SF143', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246301),
(364948, 'PTHR13902:SF121', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE WNK9-RELATED', 246301),
(364949, 'PTHR13902:SF120', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE WNK8-RELATED', 246301),
(364950, 'PTHR13902:SF164', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 246301),
(364951, 'PTHR13902:SF163', NULL, NULL, NULL, NULL, 'WNK LYSINE DEFICIENT PROTEIN KINASE 4', 246301),
(364952, 'PTHR13902:SF162', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-KINASE WNK11-LIKE PROTEIN', 246301),
(364953, 'PTHR13902:SF140', NULL, NULL, NULL, NULL, 'BNAA02G07690D PROTEIN', 246301),
(364954, 'PTHR13902:SF160', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE WNK11-RELATED', 246301),
(364955, 'PTHR13902:SF118', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE WNK6-RELATED', 246301),
(364956, 'PTHR13902:SF117', NULL, NULL, NULL, NULL, 'WNK KINASE', 246301),
(364957, 'PTHR13902:SF138', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246301),
(364958, 'PTHR13902:SF116', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE WNK9-RELATED', 246301),
(364959, 'PTHR13902:SF159', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE WNK1-RELATED', 246301),
(364960, 'PTHR13902:SF115', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE WNK3-RELATED', 246301),
(364961, 'PTHR13902:SF136', NULL, NULL, NULL, NULL, 'BNAANNG10720D PROTEIN', 246301),
(364962, 'PTHR13902:SF114', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE WNK4', 246301),
(364963, 'PTHR13902:SF157', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 246301),
(364964, 'PTHR13902:SF135', NULL, NULL, NULL, NULL, 'BNAA10G09670D PROTEIN', 246301),
(364965, 'PTHR13902:SF156', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE WNK5-RELATED', 246301),
(364966, 'PTHR13902:SF134', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246301),
(364967, 'PTHR13902:SF12', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 246301),
(364968, 'PTHR13902:SF53', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR-BINDING PROTEIN 2', 246301),
(364969, 'PTHR13902:SF10', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE WNK2', 246301),
(364970, 'PTHR13902', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE WNK  WITH NO LYSINE -RELATED', 246301),
(364971, 'PTHR13902:SF132', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE WNK4-RELATED', 246301),
(364972, 'PTHR13902:SF131', NULL, NULL, NULL, NULL, 'WNK KINASE', 246301),
(364973, 'PTHR13902:SF151', NULL, NULL, NULL, NULL, 'BNAA05G17210D PROTEIN', 246301),
(364974, 'PTHR35541', NULL, NULL, NULL, NULL, 'RAD9, HUS1, RAD1-INTERACTING NUCLEAR ORPHAN PROTEIN 1', 246302),
(364975, 'PTHR35541:SF1', NULL, NULL, NULL, NULL, 'RAD9, HUS1, RAD1-INTERACTING NUCLEAR ORPHAN PROTEIN 1', 246302),
(364976, 'PTHR15407:SF38', NULL, NULL, NULL, NULL, 'PROTEIN CBG15246', 246303),
(364977, 'PTHR15407:SF28', NULL, NULL, NULL, NULL, 'FUKUTIN', 246303),
(364978, 'PTHR15407', NULL, NULL, NULL, NULL, 'FUKUTIN-RELATED', 246303),
(364979, 'PTHR15407:SF41', NULL, NULL, NULL, NULL, 'PROTEIN CBG15245', 246303),
(364980, 'PTHR15407:SF40', NULL, NULL, NULL, NULL, 'PROTEIN CBG11699', 246303),
(364981, 'PTHR15407:SF32', NULL, NULL, NULL, NULL, 'PROTEIN (MNN4), PUTATIVE (AFU_ORTHOLOGUE AFUA_1G03790)-RELATED', 246303),
(364982, 'PTHR21409:SF1', NULL, NULL, NULL, NULL, 'HEMATOPOIETIC CELL SIGNAL TRANSDUCER', 246304);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(364983, 'PTHR21409', NULL, NULL, NULL, NULL, 'HEMATOPOIETIC CELL SIGNAL TRANSDUCER', 246304),
(364984, 'PTHR46373:SF27', NULL, NULL, NULL, NULL, 'PROTEIN RKD4', 246305),
(364985, 'PTHR46373:SF26', NULL, NULL, NULL, NULL, 'RWP-RK DOMAIN-CONTAINING PROTEIN', 246305),
(364986, 'PTHR46373:SF29', NULL, NULL, NULL, NULL, 'PROTEIN RKD3', 246305),
(364987, 'PTHR46373:SF28', NULL, NULL, NULL, NULL, 'OS06G0228950 PROTEIN', 246305),
(364988, 'PTHR46373:SF7', NULL, NULL, NULL, NULL, 'PROTEIN RKD2', 246305),
(364989, 'PTHR46373:SF9', NULL, NULL, NULL, NULL, 'RWP-RK DOMAIN-CONTAINING PROTEIN', 246305),
(364990, 'PTHR46373', NULL, NULL, NULL, NULL, 'PROTEIN RKD4', 246305),
(364991, 'PTHR46373:SF3', NULL, NULL, NULL, NULL, 'RWP-RK DOMAIN-CONTAINING PROTEIN', 246305),
(364992, 'PTHR46373:SF2', NULL, NULL, NULL, NULL, 'RWP-RK DOMAIN-CONTAINING PROTEIN', 246305),
(364993, 'PTHR46373:SF30', NULL, NULL, NULL, NULL, 'OS01G0246500 PROTEIN', 246305),
(364994, 'PTHR46373:SF5', NULL, NULL, NULL, NULL, 'RWP-RK DOMAIN PROTEIN', 246305),
(364995, 'PTHR46373:SF21', NULL, NULL, NULL, NULL, 'RWP-RK DOMAIN-CONTAINING PROTEIN', 246305),
(364996, 'PTHR46373:SF32', NULL, NULL, NULL, NULL, 'PROTEIN RKD3', 246305),
(364997, 'PTHR46373:SF20', NULL, NULL, NULL, NULL, 'PROTEIN RKD1', 246305),
(364998, 'PTHR46373:SF31', NULL, NULL, NULL, NULL, 'RWP-RK DOMAIN-CONTAINING PROTEIN', 246305),
(364999, 'PTHR46373:SF12', NULL, NULL, NULL, NULL, 'PROTEIN RKD5', 246305),
(365000, 'PTHR46373:SF34', NULL, NULL, NULL, NULL, 'RWP-RK DOMAIN-CONTAINING PROTEIN', 246305),
(365001, 'PTHR46373:SF22', NULL, NULL, NULL, NULL, 'RWP-RK DOMAIN-CONTAINING PROTEIN', 246305),
(365002, 'PTHR46373:SF33', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR NIN-LIKE FAMILY-RELATED', 246305),
(365003, 'PTHR15414', NULL, NULL, NULL, NULL, 'OS-9-RELATED', 246306),
(365004, 'PTHR15414:SF5', NULL, NULL, NULL, NULL, 'PROTEIN OS-9', 246306),
(365005, 'PTHR15414:SF0', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM LECTIN 1', 246306),
(365006, 'PTHR18950:SF1', NULL, NULL, NULL, NULL, 'PROGESTERONE-INDUCED-BLOCKING FACTOR 1', 246307),
(365007, 'PTHR18950:SF0', NULL, NULL, NULL, NULL, 'PROGESTERONE IMMUNOMODULATORY-BINDING FACTOR 1', 246307),
(365008, 'PTHR18950:SF2', NULL, NULL, NULL, NULL, '', 246307),
(365009, 'PTHR18950', NULL, NULL, NULL, NULL, 'PROGESTERONE-INDUCED BLOCKING FACTOR 1', 246307),
(365010, 'PTHR12883:SF2', NULL, NULL, NULL, NULL, '', 246308),
(365011, 'PTHR12883:SF1', NULL, NULL, NULL, NULL, 'BNAA03G46700D PROTEIN', 246308),
(365012, 'PTHR12883:SF0', NULL, NULL, NULL, NULL, 'PAT COMPLEX SUBUNIT CCDC47', 246308),
(365013, 'PTHR12883', NULL, NULL, NULL, NULL, 'ADIPOCYTE-SPECIFIC PROTEIN 4-RELATED', 246308),
(365014, 'PTHR35988', NULL, NULL, NULL, NULL, '15-CIS-ZETA-CAROTENE ISOMERASE, CHLOROPLASTIC', 246309),
(365015, 'PTHR35988:SF2', NULL, NULL, NULL, NULL, '15-CIS-ZETA-CAROTENE ISOMERASE, CHLOROPLASTIC', 246309),
(365016, 'PTHR31297:SF8', NULL, NULL, NULL, NULL, 'CELLULASE DOMAIN-CONTAINING PROTEIN', 246310),
(365017, 'PTHR31297:SF40', NULL, NULL, NULL, NULL, 'CELLULASE DOMAIN-CONTAINING PROTEIN', 246310),
(365018, 'PTHR31297:SF41', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G01830)-RELATED', 246310),
(365019, 'PTHR31297:SF1', NULL, NULL, NULL, NULL, 'GLUCAN 1,3-BETA-GLUCOSIDASE I/II-RELATED', 246310),
(365020, 'PTHR31297:SF22', NULL, NULL, NULL, NULL, 'GLUCAN 1,3-BETA-GLUCOSIDASE 2', 246310),
(365021, 'PTHR31297:SF34', NULL, NULL, NULL, NULL, 'GLUCAN 1,3-BETA-GLUCOSIDASE 3', 246310),
(365022, 'PTHR31297:SF13', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 246310),
(365023, 'PTHR31297', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,6-BETA-GLUCOSIDASE B', 246310),
(365024, 'PTHR31297:SF38', NULL, NULL, NULL, NULL, 'X8 DOMAIN-CONTAINING PROTEIN', 246310),
(365025, 'PTHR31297:SF9', NULL, NULL, NULL, NULL, 'GLUCAN 1,3-BETA-GLUCOSIDASE 2', 246310),
(365026, 'PTHR31297:SF17', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 246310),
(365027, 'PTHR31297:SF39', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,6-BETA-GLUCOSIDASE B', 246310),
(365028, 'PTHR35991', NULL, NULL, NULL, NULL, 'CA-RESPONSIVE PROTEIN', 246311);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(365029, 'PTHR35991:SF1', NULL, NULL, NULL, NULL, 'CA-RESPONSIVE PROTEIN', 246311),
(365030, 'PTHR33430:SF8', NULL, NULL, NULL, NULL, 'OS04G0110200 PROTEIN', 246312),
(365031, 'PTHR33430:SF9', NULL, NULL, NULL, NULL, 'MATERNAL EFFECT EMBRYO ARREST PROTEIN', 246312),
(365032, 'PTHR33430:SF6', NULL, NULL, NULL, NULL, 'MATERNAL EFFECT EMBRYO ARREST PROTEIN', 246312),
(365033, 'PTHR33430:SF7', NULL, NULL, NULL, NULL, 'OS07G0240400 PROTEIN', 246312),
(365034, 'PTHR33430:SF13', NULL, NULL, NULL, NULL, '', 246312),
(365035, 'PTHR33430', NULL, NULL, NULL, NULL, 'MATERNAL EFFECT EMBRYO ARREST PROTEIN', 246312),
(365036, 'PTHR33430:SF1', NULL, NULL, NULL, NULL, '', 246312),
(365037, 'PTHR33430:SF14', NULL, NULL, NULL, NULL, '', 246312),
(365038, 'PTHR33430:SF11', NULL, NULL, NULL, NULL, '', 246312),
(365039, 'PTHR33430:SF12', NULL, NULL, NULL, NULL, '', 246312),
(365040, 'PTHR10496:SF0', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S24', 246313),
(365041, 'PTHR10496:SF18', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S24', 246313),
(365042, 'PTHR10496:SF19', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S24', 246313),
(365043, 'PTHR10496', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S24', 246313),
(365044, 'PTHR10496:SF16', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S24', 246313),
(365045, 'PTHR10496:SF14', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S24', 246313),
(365046, 'PTHR10496:SF25', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S24', 246313),
(365047, 'PTHR10496:SF26', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S24', 246313),
(365048, 'PTHR10496:SF13', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S24', 246313),
(365049, 'PTHR10496:SF24', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S24', 246313),
(365050, 'PTHR10496:SF7', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S24', 246313),
(365051, 'PTHR10496:SF21', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S24', 246313),
(365052, 'PTHR46372:SF6', NULL, NULL, NULL, NULL, 'PROTEIN WVD2-LIKE 1', 246314),
(365053, 'PTHR46372:SF5', NULL, NULL, NULL, NULL, 'TPX2 (TARGETING PROTEIN FOR XKLP2) FAMILY PROTEIN', 246314),
(365054, 'PTHR46372:SF18', NULL, NULL, NULL, NULL, 'TPX2 DOMAIN-CONTAINING PROTEIN', 246314),
(365055, 'PTHR46372:SF4', NULL, NULL, NULL, NULL, 'OS11G0592600 PROTEIN', 246314),
(365056, 'PTHR46372:SF19', NULL, NULL, NULL, NULL, 'TPX2 DOMAIN-CONTAINING PROTEIN', 246314),
(365057, 'PTHR46372:SF2', NULL, NULL, NULL, NULL, 'PROTEIN WVD2-LIKE 3', 246314),
(365058, 'PTHR46372:SF23', NULL, NULL, NULL, NULL, 'PROTEIN WVD2-LIKE 2', 246314),
(365059, 'PTHR46372:SF24', NULL, NULL, NULL, NULL, 'OS03G0799100 PROTEIN', 246314),
(365060, 'PTHR46372:SF14', NULL, NULL, NULL, NULL, 'TPX2 DOMAIN-CONTAINING PROTEIN', 246314),
(365061, 'PTHR46372:SF25', NULL, NULL, NULL, NULL, 'PROTEIN WAVE-DAMPENED 2', 246314),
(365062, 'PTHR46372:SF21', NULL, NULL, NULL, NULL, 'PROTEIN WVD2-LIKE 3', 246314),
(365063, 'PTHR46372:SF10', NULL, NULL, NULL, NULL, 'PROTEIN WVD2-LIKE 2', 246314),
(365064, 'PTHR46372', NULL, NULL, NULL, NULL, 'PROTEIN WVD2-LIKE 3', 246314),
(365065, 'PTHR31145:SF7', NULL, NULL, NULL, NULL, 'TRP-LIKE ION CHANNEL', 246315),
(365066, 'PTHR31145:SF8', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_2G17475)', 246315),
(365067, 'PTHR31145:SF4', NULL, NULL, NULL, NULL, 'FLAVIN CARRIER PROTEIN 1-RELATED', 246315),
(365068, 'PTHR31145:SF5', NULL, NULL, NULL, NULL, 'DUF907 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_2G06100)', 246315),
(365069, 'PTHR31145:SF6', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_7G01610)', 246315),
(365070, 'PTHR31145', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_7G01610)', 246315),
(365071, 'PTHR31145:SF2', NULL, NULL, NULL, NULL, 'FLAVIN CARRIER PROTEIN 2', 246315),
(365072, 'PTHR43995', NULL, NULL, NULL, NULL, 'PRE-MRNA-PROCESSING FACTOR 19', 246316),
(365073, 'PTHR43995:SF5', NULL, NULL, NULL, NULL, 'PRE-MRNA-PROCESSING FACTOR 19', 246316),
(365074, 'PTHR43995:SF8', NULL, NULL, NULL, NULL, 'PRE-MRNA-PROCESSING FACTOR 19', 246316);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(365075, 'PTHR43995:SF2', NULL, NULL, NULL, NULL, 'PRE-MRNA-PROCESSING FACTOR 19', 246316),
(365076, 'PTHR43995:SF1', NULL, NULL, NULL, NULL, 'PRE-MRNA-PROCESSING FACTOR 19', 246316),
(365077, 'PTHR43995:SF4', NULL, NULL, NULL, NULL, 'PRE-MRNA-PROCESSING FACTOR 19', 246316),
(365078, 'PTHR43995:SF3', NULL, NULL, NULL, NULL, 'PRE-MRNA-PROCESSING FACTOR 19 HOMOLOG 2', 246316),
(365079, 'PTHR24037:SF10', NULL, NULL, NULL, NULL, 'MUCIN-13', 246317),
(365080, 'PTHR24037:SF11', NULL, NULL, NULL, NULL, '', 246317),
(365081, 'PTHR24037', NULL, NULL, NULL, NULL, 'HEART DEVELOPMENT PROTEIN WITH EGF-LIKE DOMAINS 1', 246317),
(365082, 'PTHR24037:SF7', NULL, NULL, NULL, NULL, 'MUCIN 13B, CELL SURFACE-ASSOCIATED-RELATED', 246317),
(365083, 'PTHR24037:SF3', NULL, NULL, NULL, NULL, 'PROTEIN HEG HOMOLOG 1', 246317),
(365084, 'PTHR17005', NULL, NULL, NULL, NULL, 'MALE-ENHANCED ANTIGEN-1', 246318),
(365085, 'PTHR17005:SF3', NULL, NULL, NULL, NULL, 'MALE-ENHANCED ANTIGEN 1', 246318),
(365086, 'PTHR44830:SF1', NULL, NULL, NULL, NULL, 'TR-TYPE G DOMAIN-CONTAINING PROTEIN', 246319),
(365087, 'PTHR44830', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1 ALPHA', 246319),
(365088, 'PTHR35719', NULL, NULL, NULL, NULL, 'OS01G0680600 PROTEIN', 246320),
(365089, 'PTHR35719:SF2', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 246320),
(365090, 'PTHR35719:SF5', NULL, NULL, NULL, NULL, 'T6K12.7 PROTEIN', 246320),
(365091, 'PTHR36927', NULL, NULL, NULL, NULL, 'BLR4337 PROTEIN', 246321),
(365092, 'PTHR36927:SF3', NULL, NULL, NULL, NULL, 'BLR4337 PROTEIN', 246321),
(365093, 'PTHR36927:SF1', NULL, NULL, NULL, NULL, 'GLUCANS BIOSYNTHESIS PROTEIN C', 246321),
(365094, 'PTHR11075:SF54', NULL, NULL, NULL, NULL, 'PEPTIDYL-TRNA HYDROLASE ICT1, MITOCHONDRIAL', 246322),
(365095, 'PTHR11075', NULL, NULL, NULL, NULL, 'PEPTIDE CHAIN RELEASE FACTOR', 246322),
(365096, 'PTHR38764:SF1', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN PHOSPHODIESTERASE', 246323),
(365097, 'PTHR38764', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN PHOSPHODIESTERASE', 246323),
(365098, 'PTHR35897:SF2', NULL, NULL, NULL, NULL, 'METHYLTRANSF_25 DOMAIN-CONTAINING PROTEIN', 246324),
(365099, 'PTHR35897:SF1', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE AUSD', 246324),
(365100, 'PTHR35897', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE AUSD', 246324),
(365101, 'PTHR44666', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 53', 246325),
(365102, 'PTHR44666:SF1', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 53', 246325),
(365103, 'PTHR28554:SF1', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L45, MITOCHONDRIAL', 246326),
(365104, 'PTHR28554', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L45, MITOCHONDRIAL', 246326),
(365105, 'PTHR11851:SF190', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL-PROCESSING PEPTIDASE SUBUNIT ALPHA', 246327),
(365106, 'PTHR11851:SF192', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL-PROCESSING PEPTIDASE SUBUNIT ALPHA', 246327),
(365107, 'PTHR11851:SF194', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL-PROCESSING PEPTIDASE SUBUNIT ALPHA-2, CHLOROPLASTIC/MITOCHONDRIAL-RELATED', 246327),
(365108, 'PTHR11851:SF196', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL-PROCESSING PEPTIDASE SUBUNIT BETA MITOCHONDRIAL-RELATED', 246327),
(365109, 'PTHR11851:SF199', NULL, NULL, NULL, NULL, 'OS01G0191500 PROTEIN', 246327),
(365110, 'PTHR11851:SF134', NULL, NULL, NULL, NULL, 'ZINC PROTEASE', 246327),
(365111, 'PTHR11851:SF156', NULL, NULL, NULL, NULL, 'PROCESSING PEPTIDASE, BETA SUBUNIT, PUTATIVE-RELATED', 246327),
(365112, 'PTHR11851:SF212', NULL, NULL, NULL, NULL, 'BNAC03G78020D PROTEIN', 246327),
(365113, 'PTHR11851:SF214', NULL, NULL, NULL, NULL, 'METALLOENZYME, LUXS/M16 PEPTIDASE-LIKE PROTEIN-RELATED', 246327),
(365114, 'PTHR11851:SF116', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 1, MITOCHONDRIAL', 246327),
(365115, 'PTHR11851:SF219', NULL, NULL, NULL, NULL, 'HYPOTHETICAL ZINC PROTEASE', 246327),
(365116, 'PTHR11851', NULL, NULL, NULL, NULL, 'METALLOPROTEASE', 246327),
(365117, 'PTHR11851:SF49', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL-PROCESSING PEPTIDASE SUBUNIT ALPHA', 246327);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(365118, 'PTHR11851:SF186', NULL, NULL, NULL, NULL, 'INACTIVE METALLOPROTEASE YMFF-RELATED', 246327),
(365119, 'PTHR11851:SF143', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 1, MITOCHONDRIAL', 246327),
(365120, 'PTHR11851:SF220', NULL, NULL, NULL, NULL, 'PEPTIDASE M16 DOMAIN PROTEIN', 246327),
(365121, 'PTHR11851:SF221', NULL, NULL, NULL, NULL, 'BNAA01G33220D PROTEIN', 246327),
(365122, 'PTHR11851:SF222', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL-PROCESSING PEPTIDASE SUBUNIT ALPHA-1', 246327),
(365123, 'PTHR11851:SF200', NULL, NULL, NULL, NULL, '', 246327),
(365124, 'PTHR11851:SF223', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL-PROCESSING PEPTIDASE SUBUNIT ALPHA-2 CHLOROPLASTIC/MITOCHONDRIAL-RELATED', 246327),
(365125, 'PTHR11851:SF224', NULL, NULL, NULL, NULL, 'PROCESSING PROTEASE', 246327),
(365126, 'PTHR11851:SF103', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL-PROCESSING PEPTIDASE SUBUNIT BETA', 246327),
(365127, 'PTHR11851:SF126', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 1, MITOCHONDRIAL', 246327),
(365128, 'PTHR11851:SF225', NULL, NULL, NULL, NULL, 'PEPTIDASE M16 DOMAIN PROTEIN', 246327),
(365129, 'PTHR11851:SF203', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL-PROCESSING PEPTIDASE SUBUNIT ALPHA-1, MITOCHONDRIAL-RELATED', 246327),
(365130, 'PTHR11851:SF204', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL-PROCESSING PEPTIDASE SUBUNIT BETA, MITOCHONDRIAL-RELATED', 246327),
(365131, 'PTHR11851:SF226', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 2, MITOCHONDRIAL', 246327),
(365132, 'PTHR11851:SF149', NULL, NULL, NULL, NULL, 'GH01077P', 246327),
(365133, 'PTHR11851:SF227', NULL, NULL, NULL, NULL, 'PROCESSING PEPTIDASE ALPHA SUBUNIT, PUTATIVE-RELATED', 246327),
(365134, 'PTHR11851:SF208', NULL, NULL, NULL, NULL, 'BNAA05G15080D PROTEIN', 246327),
(365135, 'PTHR11851:SF209', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 2, MITOCHONDRIAL', 246327),
(365136, 'PTHR43286:SF1', NULL, NULL, NULL, NULL, 'ENDONUCLEASE III-LIKE PROTEIN 1', 246328),
(365137, 'PTHR43286:SF5', NULL, NULL, NULL, NULL, 'ENDONUCLEASE III HOMOLOG 1, CHLOROPLASTIC', 246328),
(365138, 'PTHR43286:SF2', NULL, NULL, NULL, NULL, 'ENDONUCLEASE III HOMOLOG', 246328),
(365139, 'PTHR43286', NULL, NULL, NULL, NULL, 'ENDONUCLEASE III-LIKE PROTEIN 1', 246328),
(365140, 'PTHR43286:SF6', NULL, NULL, NULL, NULL, 'ENDONUCLEASE III HOMOLOG', 246328),
(365141, 'PTHR37323:SF1', NULL, NULL, NULL, NULL, 'L-ORNITHINE N(ALPHA)-ACYLTRANSFERASE', 246329),
(365142, 'PTHR37323', NULL, NULL, NULL, NULL, 'GCN5-RELATED N-ACETYLTRANSFERASE', 246329),
(365143, 'PTHR11699:SF288', NULL, NULL, NULL, NULL, 'ALDEDH DOMAIN-CONTAINING PROTEIN', 246330),
(365144, 'PTHR11699:SF221', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE, CYTOSOLIC 1', 246330),
(365145, 'PTHR11699:SF301', NULL, NULL, NULL, NULL, 'CYTOSOLIC ALDEHYDE DEHYDROGENASE RF2C', 246330),
(365146, 'PTHR11699:SF202', NULL, NULL, NULL, NULL, 'SUCCINATE-SEMIALDEHYDE DEHYDROGENASE [NADP(+)] 2-RELATED', 246330),
(365147, 'PTHR11699:SF268', NULL, NULL, NULL, NULL, 'MAGNESIUM-ACTIVATED ALDEHYDE DEHYDROGENASE, CYTOSOLIC-RELATED', 246330),
(365148, 'PTHR11699:SF289', NULL, NULL, NULL, NULL, 'ALDEDH DOMAIN-CONTAINING PROTEIN', 246330),
(365149, 'PTHR11699:SF300', NULL, NULL, NULL, NULL, 'ALDEDH DOMAIN-CONTAINING PROTEIN', 246330),
(365150, 'PTHR11699:SF102', NULL, NULL, NULL, NULL, 'RETINAL DEHYDROGENASE 2', 246330),
(365151, 'PTHR11699:SF223', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE', 246330),
(365152, 'PTHR11699:SF284', NULL, NULL, NULL, NULL, 'NAD-DEPENDENT ALDEHYDE DEHYDROGENASE FAMILY PROTEIN', 246330),
(365153, 'PTHR11699:SF140', NULL, NULL, NULL, NULL, 'RETINAL DEHYDROGENASE 1', 246330),
(365154, 'PTHR11699:SF286', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE FAMILY 2 MEMBER B4, MITOCHONDRIAL-LIKE', 246330),
(365155, 'PTHR11699:SF120', NULL, NULL, NULL, NULL, 'CYTOSOLIC 10-FORMYLTETRAHYDROFOLATE DEHYDROGENASE', 246330),
(365156, 'PTHR11699:SF263', NULL, NULL, NULL, NULL, 'ALDEDH DOMAIN-CONTAINING PROTEIN-RELATED', 246330),
(365157, 'PTHR11699:SF285', NULL, NULL, NULL, NULL, 'OS01G0591300 PROTEIN', 246330);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(365158, 'PTHR11699:SF182', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE FAMILY 2 MEMBER C4', 246330),
(365159, 'PTHR11699:SF281', NULL, NULL, NULL, NULL, 'CYTOSOLIC ALDEHYDE DEHYDROGENASE', 246330),
(365160, 'PTHR11699', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE-RELATED', 246330),
(365161, 'PTHR11699:SF207', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE X, MITOCHONDRIAL', 246330),
(365162, 'PTHR11699:SF209', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE FAMILY 1 MEMBER A3', 246330),
(365163, 'PTHR11699:SF204', NULL, NULL, NULL, NULL, 'ALDEDH DOMAIN-CONTAINING PROTEIN', 246330),
(365164, 'PTHR11699:SF302', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE', 246330),
(365165, 'PTHR11699:SF269', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE, MITOCHONDRIAL-LIKE PROTEIN', 246330),
(365166, 'PTHR11699:SF225', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE FAMILY 2 MEMBER B4, MITOCHONDRIAL', 246330),
(365167, 'PTHR11699:SF228', NULL, NULL, NULL, NULL, '4-TRIMETHYLAMINOBUTYRALDEHYDE DEHYDROGENASE', 246330),
(365168, 'PTHR11699:SF206', NULL, NULL, NULL, NULL, 'ALDEDH DOMAIN-CONTAINING PROTEIN', 246330),
(365169, 'PTHR11699:SF211', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE FAMILY 16 MEMBER A1', 246330),
(365170, 'PTHR11699:SF299', NULL, NULL, NULL, NULL, 'N-SUCCINYLGLUTAMATE 5-SEMIALDEHYDE DEHYDROGENASE', 246330),
(365171, 'PTHR11699:SF233', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE, MITOCHONDRIAL', 246330),
(365172, 'PTHR11699:SF232', NULL, NULL, NULL, NULL, '4-TRIMETHYLAMINOBUTYRALDEHYDE DEHYDROGENASE A-RELATED', 246330),
(365173, 'PTHR11699:SF298', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE', 246330),
(365174, 'PTHR11699:SF276', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ALDEHYDE DEHYDROGENASE ALDH2A', 246330),
(365175, 'PTHR11699:SF157', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE FAMILY 2 MEMBER C4', 246330),
(365176, 'PTHR11699:SF25', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE-LIKE PROTEIN YHR039C-RELATED', 246330),
(365177, 'PTHR11699:SF272', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE-RELATED', 246330),
(365178, 'PTHR11699:SF132', NULL, NULL, NULL, NULL, '4-TRIMETHYLAMINOBUTYRALDEHYDE DEHYDROGENASE B', 246330),
(365179, 'PTHR11699:SF275', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE (NAD) FAMILY PROTEIN (EUROFUNG)', 246330),
(365180, 'PTHR11699:SF297', NULL, NULL, NULL, NULL, 'ALDEHYDE/HISTIDINOL DEHYDROGENASE-RELATED', 246330),
(365181, 'PTHR11699:SF198', NULL, NULL, NULL, NULL, 'DEHYDROGENASE FAMILY PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G03250)-RELATED', 246330),
(365182, 'PTHR11699:SF131', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 10-FORMYLTETRAHYDROFOLATE DEHYDROGENASE', 246330),
(365183, 'PTHR11699:SF291', NULL, NULL, NULL, NULL, 'NADP/NAD-DEPENDENT ALDEHYDE DEHYDROGENASE PUUC', 246330),
(365184, 'PTHR11699:SF293', NULL, NULL, NULL, NULL, 'RETINAL DEHYDROGENASE 1-RELATED', 246330),
(365185, 'PTHR11699:SF292', NULL, NULL, NULL, NULL, 'ALDEDH DOMAIN-CONTAINING PROTEIN', 246330),
(365186, 'PTHR11699:SF68', NULL, NULL, NULL, NULL, 'ACETALDEHYDE DEHYDROGENASE (ACETYLATING) EUTE', 246330),
(365187, 'PTHR11699:SF190', NULL, NULL, NULL, NULL, '10-FORMYLTETRAHYDROFOLATE DEHYDROGENASE', 246330),
(365188, 'PTHR11699:SF65', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE', 246330),
(365189, 'PTHR11699:SF219', NULL, NULL, NULL, NULL, 'ALDEDH DOMAIN-CONTAINING PROTEIN', 246330),
(365190, 'PTHR11188:SF76', NULL, NULL, NULL, NULL, 'PROTEIN LDB19', 246331),
(365191, 'PTHR11188:SF16', NULL, NULL, NULL, NULL, 'ARRESTIN DOMAIN-CONTAINING PROTEIN 4', 246331),
(365192, 'PTHR11188:SF14', NULL, NULL, NULL, NULL, 'THIOREDOXIN-INTERACTING PROTEIN', 246331),
(365193, 'PTHR11188:SF51', NULL, NULL, NULL, NULL, 'ARRESTIN DOMAIN-CONTAINING PROTEIN 15', 246331),
(365194, 'PTHR11188:SF3', NULL, NULL, NULL, NULL, 'ARRESTIN_C DOMAIN-CONTAINING PROTEIN', 246331),
(365195, 'PTHR11188:SF160', NULL, NULL, NULL, NULL, 'ARRESTIN_C DOMAIN-CONTAINING PROTEIN', 246331),
(365196, 'PTHR11188:SF161', NULL, NULL, NULL, NULL, 'PH-RESPONSE REGULATOR PROTEIN PALF/RIM8', 246331),
(365197, 'PTHR11188:SF162', NULL, NULL, NULL, NULL, 'ARRESTIN DOMAIN-CONTAINING PROTEIN B', 246331);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(365198, 'PTHR11188:SF7', NULL, NULL, NULL, NULL, 'ARRESTIN_C DOMAIN-CONTAINING PROTEIN-RELATED', 246331),
(365199, 'PTHR11188:SF163', NULL, NULL, NULL, NULL, 'ARRESTIN DOMAIN-CONTAINING PROTEIN 1', 246331),
(365200, 'PTHR11188:SF165', NULL, NULL, NULL, NULL, 'ARRESTIN (OR S-ANTIGEN), N-TERMINAL DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_6G13380)', 246331),
(365201, 'PTHR11188:SF144', NULL, NULL, NULL, NULL, 'ARRESTIN DOMAIN PROTEIN-RELATED', 246331),
(365202, 'PTHR11188:SF166', NULL, NULL, NULL, NULL, 'ARRESTIN (OR S-ANTIGEN), N-TERMINAL DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_7G02050)', 246331),
(365203, 'PTHR11188:SF167', NULL, NULL, NULL, NULL, 'ARRESTIN_C DOMAIN-CONTAINING PROTEIN-RELATED', 246331),
(365204, 'PTHR11188:SF168', NULL, NULL, NULL, NULL, 'PROTEIN ECM21-RELATED', 246331),
(365205, 'PTHR11188:SF17', NULL, NULL, NULL, NULL, 'LD44267P', 246331),
(365206, 'PTHR11188:SF169', NULL, NULL, NULL, NULL, 'ARRESTIN DOMAIN-CONTAINING PROTEIN A', 246331),
(365207, 'PTHR11188:SF129', NULL, NULL, NULL, NULL, 'ARRESTIN DOMAIN-CONTAINING PROTEIN F', 246331),
(365208, 'PTHR11188:SF66', NULL, NULL, NULL, NULL, 'ARRESTIN_C DOMAIN-CONTAINING PROTEIN', 246331),
(365209, 'PTHR11188:SF67', NULL, NULL, NULL, NULL, 'ARRESTIN_C DOMAIN-CONTAINING PROTEIN', 246331),
(365210, 'PTHR11188:SF45', NULL, NULL, NULL, NULL, 'ARRESTIN_C DOMAIN-CONTAINING PROTEIN', 246331),
(365211, 'PTHR11188:SF48', NULL, NULL, NULL, NULL, 'ARRESTIN DOMAIN-CONTAINING PROTEIN 2', 246331),
(365212, 'PTHR11188:SF49', NULL, NULL, NULL, NULL, 'ARRESTIN DOMAIN-CONTAINING PROTEIN 3', 246331),
(365213, 'PTHR11188:SF81', NULL, NULL, NULL, NULL, 'ARRESTIN_C DOMAIN-CONTAINING PROTEIN', 246331),
(365214, 'PTHR11188:SF62', NULL, NULL, NULL, NULL, 'ARRESTIN-RELATED TRAFFICKING ADAPTER 5', 246331),
(365215, 'PTHR11188:SF83', NULL, NULL, NULL, NULL, 'ARRESTIN_C DOMAIN-CONTAINING PROTEIN', 246331),
(365216, 'PTHR11188:SF170', NULL, NULL, NULL, NULL, 'ARRESTIN DOMAIN-CONTAINING PROTEIN C31A2.12', 246331),
(365217, 'PTHR11188:SF171', NULL, NULL, NULL, NULL, 'ARRESTIN_N DOMAIN-CONTAINING PROTEIN', 246331),
(365218, 'PTHR11188:SF172', NULL, NULL, NULL, NULL, 'ARRESTIN DOMAIN-CONTAINING PROTEIN 5', 246331),
(365219, 'PTHR11188:SF151', NULL, NULL, NULL, NULL, 'ARRESTIN_C DOMAIN-CONTAINING PROTEIN', 246331),
(365220, 'PTHR11188:SF173', NULL, NULL, NULL, NULL, 'PROTEIN TTM-2', 246331),
(365221, 'PTHR11188:SF174', NULL, NULL, NULL, NULL, 'ARRESTIN-RELATED TRAFFICKING ADAPTER 10-RELATED', 246331),
(365222, 'PTHR11188:SF130', NULL, NULL, NULL, NULL, 'ARRESTIN_C DOMAIN-CONTAINING PROTEIN', 246331),
(365223, 'PTHR11188:SF155', NULL, NULL, NULL, NULL, 'ARRESTIN_C DOMAIN-CONTAINING PROTEIN', 246331),
(365224, 'PTHR11188:SF135', NULL, NULL, NULL, NULL, 'SI:CH211-130M23.2-RELATED', 246331),
(365225, 'PTHR11188:SF157', NULL, NULL, NULL, NULL, 'FI21816P1', 246331),
(365226, 'PTHR11188:SF159', NULL, NULL, NULL, NULL, 'ARRESTIN_C DOMAIN-CONTAINING PROTEIN', 246331),
(365227, 'PTHR11188', NULL, NULL, NULL, NULL, 'ARRESTIN DOMAIN CONTAINING PROTEIN', 246331),
(365228, 'PTHR32093:SF121', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT EXTENSIN-LIKE PROTEIN 6', 246332),
(365229, 'PTHR32093:SF122', NULL, NULL, NULL, NULL, '', 246332),
(365230, 'PTHR32093:SF123', NULL, NULL, NULL, NULL, 'POLLEN-SPECIFIC LEUCINE-RICH REPEAT EXTENSIN-LIKE PROTEIN 2', 246332),
(365231, 'PTHR32093:SF124', NULL, NULL, NULL, NULL, 'POLLEN-SPECIFIC LEUCINE-RICH REPEAT EXTENSIN-LIKE PROTEIN 1', 246332),
(365232, 'PTHR32093:SF125', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT EXTENSIN-LIKE PROTEIN 4', 246332),
(365233, 'PTHR32093:SF126', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT (LRR) FAMILY PROTEIN', 246332),
(365234, 'PTHR32093:SF128', NULL, NULL, NULL, NULL, 'SERINE-THREONINE PROTEIN KINASE, PLANT-TYPE', 246332),
(365235, 'PTHR32093:SF129', NULL, NULL, NULL, NULL, 'LRR/EXTENSIN', 246332),
(365236, 'PTHR32093:SF50', NULL, NULL, NULL, NULL, 'EXTENSIN-LIKE PROTEIN', 246332),
(365237, 'PTHR32093:SF91', NULL, NULL, NULL, NULL, 'SERINE-THREONINE PROTEIN KINASE, PLANT-TYPE', 246332),
(365238, 'PTHR32093:SF130', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT (LRR) FAMILY PROTEIN', 246332);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(365239, 'PTHR32093:SF131', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT FAMILY PROTEIN', 246332),
(365240, 'PTHR32093:SF133', NULL, NULL, NULL, NULL, 'BNAA07G36350D PROTEIN', 246332),
(365241, 'PTHR32093:SF134', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 246332),
(365242, 'PTHR32093:SF135', NULL, NULL, NULL, NULL, 'BNAA01G26320D PROTEIN', 246332),
(365243, 'PTHR32093:SF136', NULL, NULL, NULL, NULL, 'BNAC08G02750D PROTEIN', 246332),
(365244, 'PTHR32093:SF137', NULL, NULL, NULL, NULL, 'BNAC08G41590D PROTEIN', 246332),
(365245, 'PTHR32093:SF139', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 246332),
(365246, 'PTHR32093:SF140', NULL, NULL, NULL, NULL, 'BNAA05G16890D PROTEIN', 246332),
(365247, 'PTHR32093:SF142', NULL, NULL, NULL, NULL, 'BNAC05G49420D PROTEIN', 246332),
(365248, 'PTHR32093:SF101', NULL, NULL, NULL, NULL, 'OS07G0176500 PROTEIN', 246332),
(365249, 'PTHR32093:SF146', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 246332),
(365250, 'PTHR32093:SF147', NULL, NULL, NULL, NULL, 'BNAC03G77110D PROTEIN', 246332),
(365251, 'PTHR32093:SF148', NULL, NULL, NULL, NULL, 'OSJNBA0014K14.21 PROTEIN', 246332),
(365252, 'PTHR32093:SF104', NULL, NULL, NULL, NULL, 'OS11G0657400 PROTEIN', 246332),
(365253, 'PTHR32093:SF106', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 246332),
(365254, 'PTHR32093:SF107', NULL, NULL, NULL, NULL, 'OS01G0594300 PROTEIN', 246332),
(365255, 'PTHR32093:SF108', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT (LRR) FAMILY PROTEIN', 246332),
(365256, 'PTHR32093:SF109', NULL, NULL, NULL, NULL, '', 246332),
(365257, 'PTHR32093:SF150', NULL, NULL, NULL, NULL, 'BNAA09G55960D PROTEIN', 246332),
(365258, 'PTHR32093:SF152', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT FAMILY PROTEIN, EXPRESSED', 246332),
(365259, 'PTHR32093:SF153', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 246332),
(365260, 'PTHR32093:SF111', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT EXTENSIN-LIKE PROTEIN 5', 246332),
(365261, 'PTHR32093:SF155', NULL, NULL, NULL, NULL, 'LRR EXTENSIN-LIKE PROTEIN', 246332),
(365262, 'PTHR32093:SF112', NULL, NULL, NULL, NULL, 'POLLEN-SPECIFIC LEUCINE-RICH REPEAT EXTENSIN-LIKE PROTEIN 4', 246332),
(365263, 'PTHR32093:SF157', NULL, NULL, NULL, NULL, 'POLLEN-SPECIFIC LEUCINE-RICH REPEAT EXTENSIN-LIKE PROTEIN 3', 246332),
(365264, 'PTHR32093', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT EXTENSIN-LIKE PROTEIN 3-RELATED', 246332),
(365265, 'PTHR32093:SF158', NULL, NULL, NULL, NULL, 'LRR EXTENSIN-LIKE PROTEIN, PUTATIVE-RELATED', 246332),
(365266, 'PTHR32093:SF159', NULL, NULL, NULL, NULL, 'OS02G0616100 PROTEIN', 246332),
(365267, 'PTHR32093:SF115', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT EXTENSIN-LIKE PROTEIN 2', 246332),
(365268, 'PTHR32093:SF116', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT EXTENSIN-LIKE PROTEIN 1', 246332),
(365269, 'PTHR32093:SF117', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT EXTENSIN-LIKE PROTEIN 7', 246332),
(365270, 'PTHR32093:SF118', NULL, NULL, NULL, NULL, 'LRR-FAMILY PROTEIN', 246332),
(365271, 'PTHR32093:SF119', NULL, NULL, NULL, NULL, '', 246332),
(365272, 'PTHR32093:SF86', NULL, NULL, NULL, NULL, 'EXTENSIN-LIKE PROTEIN', 246332),
(365273, 'PTHR32093:SF160', NULL, NULL, NULL, NULL, 'OS01G0180000 PROTEIN', 246332),
(365274, 'PTHR32093:SF161', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT (LRR) FAMILY PROTEIN', 246332),
(365275, 'PTHR32093:SF162', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 246332),
(365276, 'PTHR32093:SF163', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT EXTENSIN 3', 246332),
(365277, 'PTHR32093:SF120', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT EXTENSIN-LIKE PROTEIN 3-RELATED', 246332),
(365278, 'PTHR32093:SF164', NULL, NULL, NULL, NULL, 'BNAA08G11700D PROTEIN', 246332),
(365279, 'PTHR46888', NULL, NULL, NULL, NULL, 'ZINC KNUCKLE DOMAINCONTAINING PROTEIN-RELATED', 246333),
(365280, 'PTHR46888:SF8', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 246333),
(365281, 'PTHR46888:SF7', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 246333);
INSERT INTO "PUBLIC"."MODEL" VALUES
(365282, 'PTHR46888:SF1', NULL, NULL, NULL, NULL, 'SCAN BOX DOMAIN-CONTAINING PROTEIN', 246333),
(365283, 'PTHR42770', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER-RELATED', 246334),
(365284, 'PTHR42770:SF8', NULL, NULL, NULL, NULL, 'PUTRESCINE IMPORTER PUUP', 246334),
(365285, 'PTHR42770:SF15', NULL, NULL, NULL, NULL, 'GLUTAMATE/GAMMA-AMINOBUTYRATE ANTIPORTER-RELATED', 246334),
(365286, 'PTHR42770:SF7', NULL, NULL, NULL, NULL, 'ARGININE/AGMATINE ANTIPORTER', 246334),
(365287, 'PTHR42770:SF14', NULL, NULL, NULL, NULL, 'ARGININE/ORNITHINE ANTIPORTER-RELATED', 246334),
(365288, 'PTHR42770:SF6', NULL, NULL, NULL, NULL, 'PUTRESCINE TRANSPORTER POTE', 246334),
(365289, 'PTHR42770:SF17', NULL, NULL, NULL, NULL, 'ARGININE PERMEASE', 246334),
(365290, 'PTHR42770:SF5', NULL, NULL, NULL, NULL, 'CADAVERINE/LYSINE ANTIPORTER-RELATED', 246334),
(365291, 'PTHR42770:SF16', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE-RELATED', 246334),
(365292, 'PTHR42770:SF4', NULL, NULL, NULL, NULL, 'ARGININE/ORNITHINE ANTIPORTER-RELATED', 246334),
(365293, 'PTHR42770:SF11', NULL, NULL, NULL, NULL, 'INNER MEMBRANE TRANSPORT PROTEIN YBAT', 246334),
(365294, 'PTHR42770:SF13', NULL, NULL, NULL, NULL, 'L-METHIONINE/BRANCHED-CHAIN AMINO ACID EXPORTER YJEH', 246334),
(365295, 'PTHR42770:SF1', NULL, NULL, NULL, NULL, 'LOW-AFFINITY PUTRESCINE IMPORTER PLAP', 246334),
(365296, 'PTHR42770:SF12', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER-RELATED', 246334),
(365297, 'PTHR45701', NULL, NULL, NULL, NULL, 'SYNAPTOBREVIN FAMILY MEMBER', 246335),
(365298, 'PTHR45701:SF3', NULL, NULL, NULL, NULL, 'SYNAPTOBREVIN', 246335),
(365299, 'PTHR45701:SF1', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE PROTEIN 1', 246335),
(365300, 'PTHR45701:SF19', NULL, NULL, NULL, NULL, 'V-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 246335),
(365301, 'PTHR45701:SF9', NULL, NULL, NULL, NULL, 'V-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 246335),
(365302, 'PTHR45701:SF8', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE PROTEIN 5', 246335),
(365303, 'PTHR45701:SF7', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE PROTEIN 8', 246335),
(365304, 'PTHR45701:SF6', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE PROTEIN 3', 246335),
(365305, 'PTHR45701:SF5', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE PROTEIN 2', 246335),
(365306, 'PTHR45701:SF4', NULL, NULL, NULL, NULL, 'V-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 246335),
(365307, 'PTHR45701:SF18', NULL, NULL, NULL, NULL, 'SYNAPTOBREVIN-A', 246335),
(365308, 'PTHR45701:SF12', NULL, NULL, NULL, NULL, 'SI:CH73-234B20.5', 246335),
(365309, 'PTHR45701:SF13', NULL, NULL, NULL, NULL, 'V-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 246335),
(365310, 'PTHR45701:SF14', NULL, NULL, NULL, NULL, 'SYNAPTOBREVIN-LIKE PROTEIN 5-RELATED', 246335),
(365311, 'PTHR45701:SF21', NULL, NULL, NULL, NULL, 'NEURONAL SYNAPTOBREVIN, ISOFORM J', 246335),
(365312, 'PTHR20516', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 114/235 FAMILY MEMBER', 246336),
(365313, 'PTHR20516:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 114', 246336),
(365314, 'PTHR20516:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 235', 246336),
(365315, 'PTHR38460', NULL, NULL, NULL, NULL, 'TAUTOMERASE YOLI-RELATED', 246337),
(365316, 'PTHR38460:SF1', NULL, NULL, NULL, NULL, 'TAUTOMERASE YOLI-RELATED', 246337),
(365317, 'PTHR45716:SF2', NULL, NULL, NULL, NULL, 'BITESIZE, ISOFORM I', 246338),
(365318, 'PTHR45716:SF3', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN-LIKE PROTEIN 1', 246338),
(365319, 'PTHR45716:SF1', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN-LIKE PROTEIN 3', 246338),
(365320, 'PTHR45716', NULL, NULL, NULL, NULL, 'BITESIZE, ISOFORM I', 246338),
(365321, 'PTHR45716:SF6', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN-LIKE PROTEIN 5', 246338),
(365322, 'PTHR45716:SF4', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN-LIKE PROTEIN 4', 246338),
(365323, 'PTHR45716:SF5', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN-LIKE PROTEIN 2', 246338),
(365324, 'PTHR45716:SF8', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN-LIKE PROTEIN 2', 246338); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(365325, 'PTHR46903:SF1', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 246339),
(365326, 'PTHR46903', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 246339),
(365327, 'PTHR34777:SF3', NULL, NULL, NULL, NULL, 'OS06G0530600 PROTEIN', 246340),
(365328, 'PTHR34777:SF1', NULL, NULL, NULL, NULL, 'VQ MOTIF-CONTAINING PROTEIN 10', 246340),
(365329, 'PTHR34777:SF24', NULL, NULL, NULL, NULL, 'OS01G0653300 PROTEIN', 246340),
(365330, 'PTHR34777:SF12', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 246340),
(365331, 'PTHR34777:SF23', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 246340),
(365332, 'PTHR34777:SF22', NULL, NULL, NULL, NULL, 'OS05G0211700 PROTEIN', 246340),
(365333, 'PTHR34777', NULL, NULL, NULL, NULL, 'VQ MOTIF-CONTAINING PROTEIN 10', 246340),
(365334, 'PTHR34777:SF20', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 246340),
(365335, 'PTHR34777:SF7', NULL, NULL, NULL, NULL, 'VQ MOTIF-CONTAINING PROTEIN 1', 246340),
(365336, 'PTHR34777:SF18', NULL, NULL, NULL, NULL, 'OS02G0251800 PROTEIN', 246340),
(365337, 'PTHR34777:SF17', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 246340),
(365338, 'PTHR34777:SF15', NULL, NULL, NULL, NULL, 'VQ MOTIF PROTEIN', 246340),
(365339, 'PTHR34777:SF25', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 246340),
(365340, 'PTHR34777:SF14', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 246340),
(365341, 'PTHR34274:SF9', NULL, NULL, NULL, NULL, 'BNAA05G14730D PROTEIN', 246341),
(365342, 'PTHR34274:SF7', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 246341),
(365343, 'PTHR34274:SF5', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 246341),
(365344, 'PTHR34274', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 246341),
(365345, 'PTHR34274:SF12', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 246341),
(365346, 'PTHR34274:SF10', NULL, NULL, NULL, NULL, 'BNAA01G28830D PROTEIN', 246341),
(365347, 'PTHR34274:SF11', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 246341),
(365348, 'PTHR37254', NULL, NULL, NULL, NULL, 'OS01G0100500 PROTEIN', 246342),
(365349, 'PTHR37254:SF1', NULL, NULL, NULL, NULL, 'OS01G0100500 PROTEIN', 246342),
(365350, 'PTHR37254:SF2', NULL, NULL, NULL, NULL, 'MONOCOPPER OXIDASE-LIKE PROTEIN SKU5', 246342),
(365351, 'PTHR37254:SF4', NULL, NULL, NULL, NULL, '', 246342),
(365352, 'PTHR14093', NULL, NULL, NULL, NULL, 'HLA CLASS II GAMMA CHAIN', 246343),
(365353, 'PTHR14093:SF21', NULL, NULL, NULL, NULL, 'METHYLTRANSF_21 DOMAIN-CONTAINING PROTEIN', 246343),
(365354, 'PTHR14093:SF19', NULL, NULL, NULL, NULL, 'THYROGLOBULIN', 246343),
(365355, 'PTHR14093:SF17', NULL, NULL, NULL, NULL, 'HLA CLASS II HISTOCOMPATIBILITY ANTIGEN GAMMA CHAIN', 246343),
(365356, 'PTHR46131:SF1', NULL, NULL, NULL, NULL, 'SD08549P', 246344),
(365357, 'PTHR46131:SF2', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL NICOTINAMIDE ADENINE DINUCLEOTIDE TRANSPORTER SLC25A51-RELATED', 246344),
(365358, 'PTHR46131:SF5', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 25 MEMBER 53', 246344),
(365359, 'PTHR46131', NULL, NULL, NULL, NULL, 'SD08549P', 246344),
(365360, 'PTHR46131:SF7', NULL, NULL, NULL, NULL, '', 246344),
(365361, 'PTHR46131:SF6', NULL, NULL, NULL, NULL, '', 246344),
(365362, 'PTHR46093:SF11', NULL, NULL, NULL, NULL, 'ACB DOMAIN-CONTAINING PROTEIN', 246345),
(365363, 'PTHR46093:SF2', NULL, NULL, NULL, NULL, 'KELCH MOTIF FAMILY PROTEIN, EXPRESSED', 246345),
(365364, 'PTHR46093:SF14', NULL, NULL, NULL, NULL, 'ACYL-COA-BINDING DOMAIN PROTEIN', 246345),
(365365, 'PTHR46093:SF15', NULL, NULL, NULL, NULL, 'GALACTOSE OXIDASE/KELCH REPEAT SUPERFAMILY PROTEIN-RELATED', 246345),
(365366, 'PTHR46093:SF12', NULL, NULL, NULL, NULL, 'ACYL-COA-BINDING DOMAIN-CONTAINING PROTEIN 5', 246345),
(365367, 'PTHR46093:SF13', NULL, NULL, NULL, NULL, '', 246345),
(365368, 'PTHR46093:SF7', NULL, NULL, NULL, NULL, 'ACB DOMAIN-CONTAINING PROTEIN', 246345),
(365369, 'PTHR46093:SF8', NULL, NULL, NULL, NULL, 'KELCH MOTIF FAMILY PROTEIN, EXPRESSED', 246345),
(365370, 'PTHR46093:SF9', NULL, NULL, NULL, NULL, 'KELCH REPEAT F-BOX PROTEIN, PUTATIVE-RELATED', 246345);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(365371, 'PTHR46093', NULL, NULL, NULL, NULL, 'ACYL-COA-BINDING DOMAIN-CONTAINING PROTEIN 5', 246345),
(365372, 'PTHR46093:SF3', NULL, NULL, NULL, NULL, 'MULTIPLE EGF-LIKE-DOMAINS 8', 246345),
(365373, 'PTHR46093:SF4', NULL, NULL, NULL, NULL, 'GALACTOSE OXIDASE/KELCH REPEAT SUPERFAMILY PROTEIN', 246345),
(365374, 'PTHR46093:SF5', NULL, NULL, NULL, NULL, 'OS02G0822800 PROTEIN', 246345),
(365375, 'PTHR40730:SF4', NULL, NULL, NULL, NULL, '', 246346),
(365376, 'PTHR40730:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REGULATOR THIR', 246346),
(365377, 'PTHR40730:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR PROTEIN-LIKE PROTEIN', 246346),
(365378, 'PTHR40730', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR PROTEIN-LIKE PROTEIN', 246346),
(365379, 'PTHR13124:SF12', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L46, MITOCHONDRIAL', 246347),
(365380, 'PTHR13124:SF16', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L46, MITOCHONDRIAL-LIKE', 246347),
(365381, 'PTHR13124:SF13', NULL, NULL, NULL, NULL, 'BNAC04G00860D PROTEIN', 246347),
(365382, 'PTHR13124', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L46, MITOCHONDRIAL PRECURSOR-RELATED', 246347),
(365383, 'PTHR35011:SF5', NULL, NULL, NULL, NULL, 'SIALIC ACID TRAP TRANSPORTER SMALL PERMEASE PROTEIN SIAQ', 246348),
(365384, 'PTHR35011', NULL, NULL, NULL, NULL, '2,3-DIKETO-L-GULONATE TRAP TRANSPORTER SMALL PERMEASE PROTEIN YIAM', 246348),
(365385, 'PTHR35011:SF10', NULL, NULL, NULL, NULL, 'BLL7177 PROTEIN', 246348),
(365386, 'PTHR35011:SF4', NULL, NULL, NULL, NULL, 'BLL3751 PROTEIN', 246348),
(365387, 'PTHR35011:SF11', NULL, NULL, NULL, NULL, 'BLL6833 PROTEIN', 246348),
(365388, 'PTHR35011:SF2', NULL, NULL, NULL, NULL, '2,3-DIKETO-L-GULONATE TRAP TRANSPORTER SMALL PERMEASE PROTEIN YIAM', 246348),
(365389, 'PTHR31022:SF4', NULL, NULL, NULL, NULL, 'CENTRIOLE, CILIA AND SPINDLE-ASSOCIATED PROTEIN', 246349),
(365390, 'PTHR31022:SF5', NULL, NULL, NULL, NULL, 'CENTRIOLE, CILIA AND SPINDLE-ASSOCIATED PROTEIN', 246349),
(365391, 'PTHR31022:SF6', NULL, NULL, NULL, NULL, 'CENTRIOLE, CILIA AND SPINDLE-ASSOCIATED PROTEIN A', 246349),
(365392, 'PTHR31022', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 246349),
(365393, 'PTHR15856:SF26', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN 20-LIKE PROTEIN 1', 246350),
(365394, 'PTHR15856:SF27', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN 20', 246350),
(365395, 'PTHR15856', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN 20-RELATED', 246350),
(365396, 'PTHR15856:SF51', NULL, NULL, NULL, NULL, 'MBD-R2', 246350),
(365397, 'PTHR35596', NULL, NULL, NULL, NULL, 'DUF2263 DOMAIN-CONTAINING PROTEIN', 246351),
(365398, 'PTHR35596:SF1', NULL, NULL, NULL, NULL, 'DUF2263 DOMAIN-CONTAINING PROTEIN', 246351),
(365399, 'PTHR35596:SF2', NULL, NULL, NULL, NULL, 'DUF2263 DOMAIN-CONTAINING PROTEIN', 246351),
(365400, 'PTHR45814', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SETD1', 246352),
(365401, 'PTHR45814:SF1', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SETD1B', 246352),
(365402, 'PTHR45814:SF2', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SETD1', 246352),
(365403, 'PTHR45814:SF3', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SETD1A', 246352),
(365404, 'PTHR47901', NULL, NULL, NULL, NULL, 'CASPASE RECRUITMENT DOMAIN-CONTAINING PROTEIN 18', 246353),
(365405, 'PTHR47901:SF5', NULL, NULL, NULL, NULL, 'CASPASE 1', 246353),
(365406, 'PTHR47901:SF4', NULL, NULL, NULL, NULL, '', 246353),
(365407, 'PTHR47901:SF6', NULL, NULL, NULL, NULL, 'CASPASE-12', 246353),
(365408, 'PTHR47901:SF3', NULL, NULL, NULL, NULL, 'CASPASE-1', 246353),
(365409, 'PTHR47901:SF2', NULL, NULL, NULL, NULL, 'CASPASE RECRUITMENT DOMAIN-CONTAINING PROTEIN 16', 246353),
(365410, 'PTHR46310:SF9', NULL, NULL, NULL, NULL, 'AMIDASE 1-LIKE', 246354),
(365411, 'PTHR46310:SF7', NULL, NULL, NULL, NULL, 'AMIDASE 1', 246354),
(365412, 'PTHR46310', NULL, NULL, NULL, NULL, 'AMIDASE 1', 246354),
(365413, 'PTHR46310:SF8', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 246354),
(365414, 'PTHR46310:SF5', NULL, NULL, NULL, NULL, 'OUTER ENVELOPE PROTEIN 64, CHLOROPLASTIC', 246354);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(365415, 'PTHR46310:SF4', NULL, NULL, NULL, NULL, 'OUTER ENVELOPE PROTEIN 64, MITOCHONDRIAL', 246354),
(365416, 'PTHR35705:SF12', NULL, NULL, NULL, NULL, '', 246355),
(365417, 'PTHR35705:SF10', NULL, NULL, NULL, NULL, '', 246355),
(365418, 'PTHR35705:SF11', NULL, NULL, NULL, NULL, 'BNAA02G14150D PROTEIN', 246355),
(365419, 'PTHR35705', NULL, NULL, NULL, NULL, 'WPP DOMAIN-INTERACTING TAIL-ANCHORED PROTEIN 1', 246355),
(365420, 'PTHR35705:SF2', NULL, NULL, NULL, NULL, 'WPP DOMAIN-INTERACTING TAIL-ANCHORED PROTEIN 2', 246355),
(365421, 'PTHR35705:SF1', NULL, NULL, NULL, NULL, 'WPP DOMAIN-INTERACTING TAIL-ANCHORED PROTEIN 1', 246355),
(365422, 'PTHR35705:SF7', NULL, NULL, NULL, NULL, 'OS01G0235350 PROTEIN', 246355),
(365423, 'PTHR34235:SF1', NULL, NULL, NULL, NULL, 'SLR0416 PROTEIN', 246356),
(365424, 'PTHR34235:SF3', NULL, NULL, NULL, NULL, 'SLR1203 PROTEIN', 246356),
(365425, 'PTHR34235', NULL, NULL, NULL, NULL, 'SLR1203 PROTEIN-RELATED', 246356),
(365426, 'PTHR46429:SF2', NULL, NULL, NULL, NULL, 'TRNA/RRNA METHYLTRANSFERASE-RELATED', 246357),
(365427, 'PTHR46429', NULL, NULL, NULL, NULL, '23S RRNA (GUANOSINE-2''-O-)-METHYLTRANSFERASE RLMB', 246357),
(365428, 'PTHR46429:SF1', NULL, NULL, NULL, NULL, '23S RRNA (GUANOSINE-2''-O-)-METHYLTRANSFERASE RLMB', 246357),
(365429, 'PTHR33671:SF7', NULL, NULL, NULL, NULL, 'BNAA05G09610D PROTEIN', 246358),
(365430, 'PTHR33671:SF8', NULL, NULL, NULL, NULL, 'OS05G0514400 PROTEIN', 246358),
(365431, 'PTHR33671:SF9', NULL, NULL, NULL, NULL, 'DUF688 FAMILY PROTEIN', 246358),
(365432, 'PTHR33671:SF3', NULL, NULL, NULL, NULL, 'F28N24.8 PROTEIN', 246358),
(365433, 'PTHR33671:SF16', NULL, NULL, NULL, NULL, '', 246358),
(365434, 'PTHR33671:SF6', NULL, NULL, NULL, NULL, '', 246358),
(365435, 'PTHR33671:SF1', NULL, NULL, NULL, NULL, 'DUF688 FAMILY PROTEIN', 246358),
(365436, 'PTHR33671:SF2', NULL, NULL, NULL, NULL, 'N-METHYLTRANSFERASE, PUTATIVE (DUF688)-RELATED', 246358),
(365437, 'PTHR33671:SF12', NULL, NULL, NULL, NULL, '', 246358),
(365438, 'PTHR33671', NULL, NULL, NULL, NULL, 'N-METHYLTRANSFERASE, PUTATIVE (DUF688)-RELATED', 246358),
(365439, 'PTHR33671:SF13', NULL, NULL, NULL, NULL, 'BNAA05G11690D PROTEIN', 246358),
(365440, 'PTHR33671:SF14', NULL, NULL, NULL, NULL, 'BNAA07G08110D PROTEIN', 246358),
(365441, 'PTHR33671:SF15', NULL, NULL, NULL, NULL, '', 246358),
(365442, 'PTHR33671:SF10', NULL, NULL, NULL, NULL, '', 246358),
(365443, 'PTHR33671:SF11', NULL, NULL, NULL, NULL, 'DUF688 FAMILY PROTEIN', 246358),
(365444, 'PTHR46312:SF1', NULL, NULL, NULL, NULL, 'NACHT DOMAIN-CONTAINING PROTEIN', 246359),
(365445, 'PTHR46312', NULL, NULL, NULL, NULL, 'NACHT DOMAIN-CONTAINING PROTEIN', 246359),
(365446, 'PTHR21068:SF43', NULL, NULL, NULL, NULL, 'SPARTIN', 246360),
(365447, 'PTHR21068:SF32', NULL, NULL, NULL, NULL, 'SENESCENCE/SPARTIN-ASSOCIATED-RELATED', 246360),
(365448, 'PTHR21068:SF40', NULL, NULL, NULL, NULL, 'SENESCENCE/DEHYDRATION-ASSOCIATED PROTEIN-LIKE PROTEIN', 246360),
(365449, 'PTHR21068:SF41', NULL, NULL, NULL, NULL, 'SENESCENCE/DEHYDRATION-ASSOCIATED PROTEIN-RELATED PROTEIN-RELATED', 246360),
(365450, 'PTHR21068:SF29', NULL, NULL, NULL, NULL, 'SENESCENCE DOMAIN-CONTAINING PROTEIN', 246360),
(365451, 'PTHR21068:SF37', NULL, NULL, NULL, NULL, 'SENESCENCE DOMAIN-CONTAINING PROTEIN', 246360),
(365452, 'PTHR21068:SF48', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 246360),
(365453, 'PTHR21068:SF49', NULL, NULL, NULL, NULL, 'SENESCENCE DOMAIN-CONTAINING PROTEIN', 246360),
(365454, 'PTHR21068:SF38', NULL, NULL, NULL, NULL, 'SENESCENCE DOMAIN-CONTAINING PROTEIN', 246360),
(365455, 'PTHR21068:SF47', NULL, NULL, NULL, NULL, 'SENESCENCE/SPARTIN-ASSOCIATED-RELATED', 246360),
(365456, 'PTHR21068:SF36', NULL, NULL, NULL, NULL, 'SENESCENCE/DEHYDRATION-ASSOCIATED PROTEIN-LIKE PROTEIN', 246360),
(365457, 'PTHR21068', NULL, NULL, NULL, NULL, 'SPARTIN', 246360),
(365458, 'PTHR21068:SF33', NULL, NULL, NULL, NULL, 'OS03G0241900 PROTEIN', 246360),
(365459, 'PTHR21068:SF44', NULL, NULL, NULL, NULL, 'SENESCENCE DOMAIN-CONTAINING PROTEIN', 246360),
(365460, 'PTHR21068:SF45', NULL, NULL, NULL, NULL, 'PROTEIN EARLY-RESPONSIVE TO DEHYDRATION 7, CHLOROPLASTIC', 246360);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(365461, 'PTHR21068:SF34', NULL, NULL, NULL, NULL, 'SENESCENCE DOMAIN-CONTAINING PROTEIN', 246360),
(365462, 'PTHR30352:SF14', NULL, NULL, NULL, NULL, 'PYRUVATE FORMATE-LYASE 3-ACTIVATING ENZYME-RELATED', 246361),
(365463, 'PTHR30352:SF2', NULL, NULL, NULL, NULL, 'ANAEROBIC RIBONUCLEOSIDE-TRIPHOSPHATE REDUCTASE-ACTIVATING PROTEIN', 246361),
(365464, 'PTHR30352:SF13', NULL, NULL, NULL, NULL, 'GLYCYL-RADICAL ENZYME ACTIVATING ENZYME YJJW-RELATED', 246361),
(365465, 'PTHR30352:SF22', NULL, NULL, NULL, NULL, 'PYRUVATE FORMATE-LYASE ACTIVATING ENZYME HOMOLOG', 246361),
(365466, 'PTHR30352:SF4', NULL, NULL, NULL, NULL, 'PYRUVATE FORMATE-LYASE 2-ACTIVATING ENZYME', 246361),
(365467, 'PTHR30352:SF5', NULL, NULL, NULL, NULL, 'PYRUVATE FORMATE-LYASE 1-ACTIVATING ENZYME', 246361),
(365468, 'PTHR30352', NULL, NULL, NULL, NULL, 'PYRUVATE FORMATE-LYASE-ACTIVATING ENZYME', 246361),
(365469, 'PTHR30352:SF20', NULL, NULL, NULL, NULL, '7-CARBOXY-7-DEAZAGUANINE SYNTHASE', 246361),
(365470, 'PTHR47075:SF9', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH47', 246362),
(365471, 'PTHR47075', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH47', 246362),
(365472, 'PTHR47075:SF2', NULL, NULL, NULL, NULL, 'HELIX-LOOP-HELIX DNA-BINDING DOMAIN CONTAINING PROTEIN, EXPRESSED', 246362),
(365473, 'PTHR47075:SF3', NULL, NULL, NULL, NULL, 'PROTEIN IRON-RELATED TRANSCRIPTION FACTOR 3', 246362),
(365474, 'PTHR47075:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH062', 246362),
(365475, 'PTHR47075:SF7', NULL, NULL, NULL, NULL, 'BNAC01G42730D PROTEIN', 246362),
(365476, 'PTHR47694', NULL, NULL, NULL, NULL, 'PLANT UBX DOMAIN-CONTAINING PROTEIN 2', 246363),
(365477, 'PTHR47694:SF1', NULL, NULL, NULL, NULL, 'PLANT UBX DOMAIN-CONTAINING PROTEIN 2', 246363),
(365478, 'PTHR30534', NULL, NULL, NULL, NULL, 'FLAGELLAR MOTOR SWITCH PROTEIN FLIG', 246364),
(365479, 'PTHR30534:SF0', NULL, NULL, NULL, NULL, 'FLAGELLAR MOTOR SWITCH PROTEIN FLIG', 246364),
(365480, 'PTHR35903', NULL, NULL, NULL, NULL, 'FLAGELLIN B1', 246365),
(365481, 'PTHR35903:SF1', NULL, NULL, NULL, NULL, 'FLAGELLIN B1', 246365),
(365482, 'PTHR14790', NULL, NULL, NULL, NULL, 'RECQ-MEDIATED GENOME INSTABILITY PROTEIN 1 RMI1', 246366),
(365483, 'PTHR14790:SF18', NULL, NULL, NULL, NULL, 'DUF1767 DOMAIN-CONTAINING PROTEIN', 246366),
(365484, 'PTHR14790:SF15', NULL, NULL, NULL, NULL, 'RECQ-MEDIATED GENOME INSTABILITY PROTEIN 1', 246366),
(365485, 'PTHR48216:SF1', NULL, NULL, NULL, NULL, '', 246367),
(365486, 'PTHR48216', NULL, NULL, NULL, NULL, '', 246367),
(365487, 'PTHR46210', NULL, NULL, NULL, NULL, 'FHA DOMAIN-CONTAINING PROTEIN', 246368),
(365488, 'PTHR46210:SF1', NULL, NULL, NULL, NULL, 'FHA DOMAIN-CONTAINING PROTEIN', 246368),
(365489, 'PTHR12474:SF4', NULL, NULL, NULL, NULL, 'SESTRIN-3', 246369),
(365490, 'PTHR12474:SF3', NULL, NULL, NULL, NULL, 'SESTRIN-1', 246369),
(365491, 'PTHR12474:SF2', NULL, NULL, NULL, NULL, 'SESTRIN-2', 246369),
(365492, 'PTHR12474:SF1', NULL, NULL, NULL, NULL, 'SI:ZFOS-80G12.1', 246369),
(365493, 'PTHR12474:SF0', NULL, NULL, NULL, NULL, 'SESTRIN HOMOLOG', 246369),
(365494, 'PTHR12474', NULL, NULL, NULL, NULL, 'P53 REGULATED PA26 NUCLEAR PROTEIN SESTRIN', 246369),
(365495, 'PTHR31684:SF2', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 43', 246370),
(365496, 'PTHR31684', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 43', 246370),
(365497, 'PTHR38695:SF1', NULL, NULL, NULL, NULL, '', 246371),
(365498, 'PTHR38695', NULL, NULL, NULL, NULL, '', 246371),
(365499, 'PTHR14549:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 223-LIKE', 246372),
(365500, 'PTHR14549', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 246372),
(365501, 'PTHR14549:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 223', 246372),
(365502, 'PTHR14549:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 223', 246372),
(365503, 'PTHR43484:SF1', NULL, NULL, NULL, NULL, 'FLAGELLAR MOTOR SWITCH PROTEIN FLIN', 246373),
(365504, 'PTHR43484', NULL, NULL, NULL, NULL, '', 246373),
(365505, 'PTHR46821:SF2', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246374); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(365506, 'PTHR46821:SF4', NULL, NULL, NULL, NULL, 'OS08G0275200 PROTEIN', 246374),
(365507, 'PTHR46821:SF5', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246374),
(365508, 'PTHR46821:SF7', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 246374),
(365509, 'PTHR46821:SF8', NULL, NULL, NULL, NULL, 'OS03G0251700 PROTEIN', 246374),
(365510, 'PTHR46821:SF9', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-KINASE PLANT', 246374),
(365511, 'PTHR46821', NULL, NULL, NULL, NULL, 'OS07G0586332 PROTEIN', 246374),
(365512, 'PTHR37450', NULL, NULL, NULL, NULL, 'CIPC PROTEIN', 246375),
(365513, 'PTHR37450:SF1', NULL, NULL, NULL, NULL, 'CIPC PROTEIN', 246375),
(365514, 'PTHR46056:SF7', NULL, NULL, NULL, NULL, 'LONG-CHAIN-ALCOHOL OXIDASE', 246376),
(365515, 'PTHR46056:SF5', NULL, NULL, NULL, NULL, 'LONG-CHAIN-ALCOHOL OXIDASE FAO1', 246376),
(365516, 'PTHR46056:SF4', NULL, NULL, NULL, NULL, 'LONG-CHAIN-ALCOHOL OXIDASE FAO4A', 246376),
(365517, 'PTHR46056:SF8', NULL, NULL, NULL, NULL, 'LONG-CHAIN-ALCOHOL OXIDASE', 246376),
(365518, 'PTHR46056', NULL, NULL, NULL, NULL, 'LONG-CHAIN-ALCOHOL OXIDASE', 246376),
(365519, 'PTHR46056:SF19', NULL, NULL, NULL, NULL, 'LONG-CHAIN-ALCOHOL OXIDASE', 246376),
(365520, 'PTHR46056:SF18', NULL, NULL, NULL, NULL, 'LONG-CHAIN-ALCOHOL OXIDASE', 246376),
(365521, 'PTHR46056:SF2', NULL, NULL, NULL, NULL, 'OS10G0475100 PROTEIN', 246376),
(365522, 'PTHR46056:SF14', NULL, NULL, NULL, NULL, 'LONG-CHAIN-ALCOHOL OXIDASE', 246376),
(365523, 'PTHR46056:SF12', NULL, NULL, NULL, NULL, 'LONG-CHAIN-ALCOHOL OXIDASE', 246376),
(365524, 'PTHR46056:SF11', NULL, NULL, NULL, NULL, 'LONG-CHAIN-ALCOHOL OXIDASE', 246376),
(365525, 'PTHR46056:SF21', NULL, NULL, NULL, NULL, 'LONG-CHAIN-ALCOHOL OXIDASE', 246376),
(365526, 'PTHR46056:SF10', NULL, NULL, NULL, NULL, 'LONG-CHAIN-ALCOHOL OXIDASE FAO3', 246376),
(365527, 'PTHR46056:SF20', NULL, NULL, NULL, NULL, 'LONG-CHAIN-ALCOHOL OXIDASE', 246376),
(365528, 'PTHR36901:SF4', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 246377),
(365529, 'PTHR36901:SF5', NULL, NULL, NULL, NULL, 'OS10G0520200 PROTEIN', 246377),
(365530, 'PTHR36901', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED-RELATED', 246377),
(365531, 'PTHR36901:SF6', NULL, NULL, NULL, NULL, 'OS05G0150100 PROTEIN', 246377),
(365532, 'PTHR36901:SF1', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', 246377),
(365533, 'PTHR36901:SF2', NULL, NULL, NULL, NULL, 'OS10G0520400 PROTEIN', 246377),
(365534, 'PTHR12197:SF290', NULL, NULL, NULL, NULL, 'N-LYSINE METHYLTRANSFERASE SMYD2-B', 246378),
(365535, 'PTHR12197:SF291', NULL, NULL, NULL, NULL, 'SET AND MYND DOMAIN-CONTAINING PROTEIN DDB_G0277331-RELATED', 246378),
(365536, 'PTHR12197:SF292', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 246378),
(365537, 'PTHR12197:SF193', NULL, NULL, NULL, NULL, 'N-LYSINE METHYLTRANSFERASE SMYD2', 246378),
(365538, 'PTHR12197:SF282', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 246378),
(365539, 'PTHR12197:SF293', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN 14', 246378),
(365540, 'PTHR12197:SF44', NULL, NULL, NULL, NULL, '', 246378),
(365541, 'PTHR12197:SF288', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SMYD3', 246378),
(365542, 'PTHR12197:SF211', NULL, NULL, NULL, NULL, 'SET AND MYND DOMAIN-CONTAINING PROTEIN DDB_G0292140', 246378),
(365543, 'PTHR12197:SF289', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 246378),
(365544, 'PTHR12197:SF39', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 246378),
(365545, 'PTHR12197:SF279', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 246378),
(365546, 'PTHR12197:SF268', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 246378),
(365547, 'PTHR12197:SF294', NULL, NULL, NULL, NULL, 'POTENTIAL PROTEIN LYSINE METHYLTRANSFERASE SET6', 246378),
(365548, 'PTHR12197:SF283', NULL, NULL, NULL, NULL, 'MYND-TYPE DOMAIN-CONTAINING PROTEIN', 246378),
(365549, 'PTHR12197:SF184', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SMYD1', 246378);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(365550, 'PTHR12197:SF273', NULL, NULL, NULL, NULL, 'MYND-TYPE ZINC FINGER PROTEIN SAMB', 246378),
(365551, 'PTHR12197:SF295', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 246378),
(365552, 'PTHR12197:SF251', NULL, NULL, NULL, NULL, 'EG:BACR7C10.4 PROTEIN', 246378),
(365553, 'PTHR12197:SF296', NULL, NULL, NULL, NULL, 'SET AND MYND DOMAIN-CONTAINING PROTEIN DDB_G0288495', 246378),
(365554, 'PTHR12197:SF285', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE ASHR1', 246378),
(365555, 'PTHR12197:SF241', NULL, NULL, NULL, NULL, 'MYND-TYPE DOMAIN-CONTAINING PROTEIN', 246378),
(365556, 'PTHR12197:SF275', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 246378),
(365557, 'PTHR12197', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SMYD', 246378),
(365558, 'PTHR35566:SF1', NULL, NULL, NULL, NULL, 'TYPE VI SECRETION SYSTEM BASEPLATE COMPONENT TSSK1', 246379),
(365559, 'PTHR35566:SF6', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 246379),
(365560, 'PTHR35566', NULL, NULL, NULL, NULL, 'BLR3599 PROTEIN', 246379),
(365561, 'PTHR16254', NULL, NULL, NULL, NULL, 'POTASSIUM/PROTON ANTIPORTER-RELATED', 246380),
(365562, 'PTHR16254:SF20', NULL, NULL, NULL, NULL, 'K(+) EFFLUX ANTIPORTER 5', 246380),
(365563, 'PTHR16254:SF21', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 246380),
(365564, 'PTHR16254:SF22', NULL, NULL, NULL, NULL, 'CATION/H+ EXCHANGER-RELATED', 246380),
(365565, 'PTHR16254:SF27', NULL, NULL, NULL, NULL, 'K+/H+-ANTIPORTER-RELATED', 246380),
(365566, 'PTHR16254:SF28', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 246380),
(365567, 'PTHR16254:SF29', NULL, NULL, NULL, NULL, 'K(+) EFFLUX ANTIPORTER 6', 246380),
(365568, 'PTHR16254:SF18', NULL, NULL, NULL, NULL, 'K(+) EFFLUX ANTIPORTER 4-LIKE', 246380),
(365569, 'PTHR16254:SF19', NULL, NULL, NULL, NULL, 'K(+) EFFLUX ANTIPORTER 4-LIKE', 246380),
(365570, 'PTHR16254:SF14', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AND COILED-COIL DOMAIN-CONTAINING PROTEIN 3', 246380),
(365571, 'PTHR14297', NULL, NULL, NULL, NULL, 'MEMBRANE TRANSPORT PROTEIN XK FAMILY MEMBER', 246381),
(365572, 'PTHR14297:SF9', NULL, NULL, NULL, NULL, 'XK-RELATED PROTEIN 3', 246381),
(365573, 'PTHR14297:SF8', NULL, NULL, NULL, NULL, 'MEMBRANE TRANSPORT PROTEIN XK', 246381),
(365574, 'PTHR14297:SF4', NULL, NULL, NULL, NULL, 'XK-RELATED PROTEIN 2', 246381),
(365575, 'PTHR47717:SF1', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP19, CHLOROPLASTIC', 246382),
(365576, 'PTHR47717', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP19, CHLOROPLASTIC', 246382),
(365577, 'PTHR36953:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG07386', 246383),
(365578, 'PTHR36953', NULL, NULL, NULL, NULL, 'PROTEIN CBG07386-RELATED', 246383),
(365579, 'PTHR36953:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG17380', 246383),
(365580, 'PTHR36953:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG16638', 246383),
(365581, 'PTHR36762:SF5', NULL, NULL, NULL, NULL, 'LIGHT-REGULATED PROTEIN 1, CHLOROPLASTIC', 246384),
(365582, 'PTHR36762:SF2', NULL, NULL, NULL, NULL, 'LIGHT-REGULATED PROTEIN, CHLOROPLASTIC', 246384),
(365583, 'PTHR36762', NULL, NULL, NULL, NULL, 'LIGHT-REGULATED PROTEIN 1, CHLOROPLASTIC', 246384),
(365584, 'PTHR47231', NULL, NULL, NULL, NULL, 'UPF0722 PROTEIN C11ORF88', 246385),
(365585, 'PTHR47231:SF1', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN HOATZ', 246385),
(365586, 'PTHR24293', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 46 SUBFAMILY A', 246386),
(365587, 'PTHR24293:SF1', NULL, NULL, NULL, NULL, 'CHOLESTEROL 24-HYDROXYLASE', 246386),
(365588, 'PTHR24293:SF0', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 46, SUBFAMILY A, POLYPEPTIDE 1, TANDEM DUPLICATE 2-RELATED', 246386),
(365589, 'PTHR30191:SF0', NULL, NULL, NULL, NULL, 'FORMATE ACETYLTRANSFERASE 1', 246387),
(365590, 'PTHR30191', NULL, NULL, NULL, NULL, 'FORMATE ACETYLTRANSFERASE', 246387),
(365591, 'PTHR30191:SF8', NULL, NULL, NULL, NULL, 'FORMATE ACETYLTRANSFERASE', 246387),
(365592, 'PTHR30191:SF7', NULL, NULL, NULL, NULL, 'PFL-LIKE ENZYME TDCE', 246387);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(365593, 'PTHR45564:SF10', NULL, NULL, NULL, NULL, '', 246388),
(365594, 'PTHR45564:SF1', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT 2', 246388),
(365595, 'PTHR45564', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT 2 B, CHLOROPLASTIC', 246388),
(365596, 'PTHR10048:SF28', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 3-KINASE C2 DOMAIN-CONTAINING SUBUNIT ALPHA', 246389),
(365597, 'PTHR10048:SF29', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 3-KINASE C2 DOMAIN-CONTAINING SUBUNIT GAMMA', 246389),
(365598, 'PTHR10048:SF46', NULL, NULL, NULL, NULL, '', 246389),
(365599, 'PTHR10048:SF48', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 3-KINASE 3', 246389),
(365600, 'PTHR10048:SF22', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-KINASE BETA', 246389),
(365601, 'PTHR10048:SF66', NULL, NULL, NULL, NULL, '', 246389),
(365602, 'PTHR10048:SF106', NULL, NULL, NULL, NULL, 'BNAA02G34040D PROTEIN', 246389),
(365603, 'PTHR10048:SF105', NULL, NULL, NULL, NULL, 'BNAC06G04220D PROTEIN', 246389),
(365604, 'PTHR10048:SF7', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 3-KINASE CATALYTIC SUBUNIT TYPE 3', 246389),
(365605, 'PTHR10048:SF107', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4,5-BISPHOSPHATE 3-KINASE CATALYTIC SUBUNIT ALPHA ISOFORM', 246389),
(365606, 'PTHR10048', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL KINASE', 246389),
(365607, 'PTHR10048:SF35', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4,5-BISPHOSPHATE 3-KINASE CATALYTIC SUBUNIT DELTA ISOFORM', 246389),
(365608, 'PTHR10048:SF14', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-4-PHOSPHATE 3-KINASE', 246389),
(365609, 'PTHR10048:SF15', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-KINASE ALPHA', 246389),
(365610, 'PTHR10048:SF55', NULL, NULL, NULL, NULL, '', 246389),
(365611, 'PTHR10048:SF33', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4,5-BISPHOSPHATE 3-KINASE CATALYTIC SUBUNIT BETA ISOFORM', 246389),
(365612, 'PTHR10048:SF99', NULL, NULL, NULL, NULL, 'SI:RP71-17I16.5', 246389),
(365613, 'PTHR10048:SF34', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4,5-BISPHOSPHATE 3-KINASE CATALYTIC SUBUNIT GAMMA ISOFORM', 246389),
(365614, 'PTHR10048:SF117', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 3-KINASE 2', 246389),
(365615, 'PTHR10048:SF116', NULL, NULL, NULL, NULL, 'PI3K/PI4K DOMAIN-CONTAINING PROTEIN', 246389),
(365616, 'PTHR10048:SF95', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-4,5-BISPHOSPHATE 3-KINASE', 246389),
(365617, 'PTHR10048:SF30', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 3-KINASE C2 DOMAIN-CONTAINING SUBUNIT BETA', 246389),
(365618, 'PTHR10048:SF118', NULL, NULL, NULL, NULL, 'PI-3 KINASE', 246389),
(365619, 'PTHR10048:SF52', NULL, NULL, NULL, NULL, '', 246389),
(365620, 'PTHR10048:SF114', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 3-KINASE', 246389),
(365621, 'PTHR10048:SF111', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 3-KINASE AGE-1', 246389),
(365622, 'PTHR10048:SF110', NULL, NULL, NULL, NULL, 'BNAA06G03180D PROTEIN', 246389),
(365623, 'PTHR13551:SF1', NULL, NULL, NULL, NULL, 'BRAIN PROTEIN I3', 246390),
(365624, 'PTHR13551', NULL, NULL, NULL, NULL, 'BRAIN PROTEIN I3', 246390),
(365625, 'PTHR45852:SF2', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 246391),
(365626, 'PTHR45852:SF1', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE RIO2', 246391),
(365627, 'PTHR45852', NULL, NULL, NULL, NULL, 'SER/THR-PROTEIN KINASE RIO2', 246391),
(365628, 'PTHR47273:SF15', NULL, NULL, NULL, NULL, '', 246392),
(365629, 'PTHR47273:SF8', NULL, NULL, NULL, NULL, 'BNAC04G56700D PROTEIN', 246392),
(365630, 'PTHR47273:SF16', NULL, NULL, NULL, NULL, 'POLLEN OLE E 1 ALLERGEN AND EXTENSIN FAMILY PROTEIN-RELATED', 246392),
(365631, 'PTHR47273:SF9', NULL, NULL, NULL, NULL, 'BNAC09G20310D PROTEIN', 246392),
(365632, 'PTHR47273:SF11', NULL, NULL, NULL, NULL, 'POLLEN OLE E 1 ALLERGEN AND EXTENSIN FAMILY PROTEIN', 246392),
(365633, 'PTHR47273', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246392),
(365634, 'PTHR47273:SF12', NULL, NULL, NULL, NULL, '', 246392);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(365635, 'PTHR47273:SF14', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 12-LIKE', 246392),
(365636, 'PTHR47273:SF2', NULL, NULL, NULL, NULL, 'PROLINE-RICH EXTENSIN-LIKE PROTEIN EPR1', 246392),
(365637, 'PTHR47273:SF10', NULL, NULL, NULL, NULL, 'BNAA06G35370D PROTEIN', 246392),
(365638, 'PTHR47273:SF4', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246392),
(365639, 'PTHR47273:SF6', NULL, NULL, NULL, NULL, 'POLLEN OLE E 1 ALLERGEN AND EXTENSIN FAMILY PROTEIN', 246392),
(365640, 'PTHR14619:SF6', NULL, NULL, NULL, NULL, 'PROTEIN NDNF', 246393),
(365641, 'PTHR14619:SF5', NULL, NULL, NULL, NULL, 'COLLAGEN IV NC1 DOMAIN-CONTAINING PROTEIN', 246393),
(365642, 'PTHR14619:SF4', NULL, NULL, NULL, NULL, 'PROTEIN NDNF', 246393),
(365643, 'PTHR14619', NULL, NULL, NULL, NULL, 'NEURON-DERIVED NEUROTROPHIC FACTOR', 246393),
(365644, 'PTHR14619:SF3', NULL, NULL, NULL, NULL, 'FI20196P1', 246393),
(365645, 'PTHR14619:SF2', NULL, NULL, NULL, NULL, 'PROTEIN NDNF', 246393),
(365646, 'PTHR14619:SF1', NULL, NULL, NULL, NULL, 'PROTEIN NDNF', 246393),
(365647, 'PTHR33129', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN-RELATED', 246394),
(365648, 'PTHR33129:SF3', NULL, NULL, NULL, NULL, 'HOT SPOT (RHS) PROTEIN, PUTATIVE-RELATED', 246394),
(365649, 'PTHR33129:SF1', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246394),
(365650, 'PTHR46634:SF1', NULL, NULL, NULL, NULL, 'OS02G0816400 PROTEIN', 246395),
(365651, 'PTHR46634:SF5', NULL, NULL, NULL, NULL, 'M REDUCTASE II SUBUNIT GAMMA, PUTATIVE (DUF3741)-RELATED', 246395),
(365652, 'PTHR46634:SF12', NULL, NULL, NULL, NULL, '', 246395),
(365653, 'PTHR46634:SF3', NULL, NULL, NULL, NULL, 'M REDUCTASE II SUBUNIT GAMMA, PUTATIVE (DUF3741)-RELATED', 246395),
(365654, 'PTHR46634:SF8', NULL, NULL, NULL, NULL, 'DUF3741 FAMILY PROTEIN', 246395),
(365655, 'PTHR46634:SF13', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246395),
(365656, 'PTHR46634:SF9', NULL, NULL, NULL, NULL, 'ADHESIN-LIKE PROTEIN, PUTATIVE (DUF3741)-RELATED', 246395),
(365657, 'PTHR46634:SF15', NULL, NULL, NULL, NULL, '', 246395),
(365658, 'PTHR46634:SF7', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL N-ACETYGLUCOSAMINLYTRANSFERASE SUBUNIT P-RELATED', 246395),
(365659, 'PTHR46634', NULL, NULL, NULL, NULL, 'M REDUCTASE II SUBUNIT GAMMA, PUTATIVE (DUF3741)-RELATED', 246395),
(365660, 'PTHR36933', NULL, NULL, NULL, NULL, 'SLL0788 PROTEIN', 246396),
(365661, 'PTHR36933:SF1', NULL, NULL, NULL, NULL, 'SLL0788 PROTEIN', 246396),
(365662, 'PTHR12064:SF66', NULL, NULL, NULL, NULL, 'CNNM TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN', 246397),
(365663, 'PTHR12064:SF88', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIE SUBUNIT ALPHA', 246397),
(365664, 'PTHR12064:SF22', NULL, NULL, NULL, NULL, 'METAL TRANSPORTER CNNM2', 246397),
(365665, 'PTHR12064:SF23', NULL, NULL, NULL, NULL, 'METAL TRANSPORTER CNNM-2', 246397),
(365666, 'PTHR12064:SF87', NULL, NULL, NULL, NULL, 'MRNA, CLONE: RAFL25-31-I24', 246397),
(365667, 'PTHR12064:SF82', NULL, NULL, NULL, NULL, 'CNNM TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN', 246397),
(365668, 'PTHR12064:SF80', NULL, NULL, NULL, NULL, '', 246397),
(365669, 'PTHR12064:SF81', NULL, NULL, NULL, NULL, '', 246397),
(365670, 'PTHR12064:SF4', NULL, NULL, NULL, NULL, 'METAL TRANSPORTER CNNM-4', 246397),
(365671, 'PTHR12064:SF28', NULL, NULL, NULL, NULL, 'METAL TRANSPORTER CNNM1', 246397),
(365672, 'PTHR12064:SF26', NULL, NULL, NULL, NULL, 'METAL TRANSPORTER CNNM4', 246397),
(365673, 'PTHR12064:SF27', NULL, NULL, NULL, NULL, 'METAL TRANSPORTER CNNM3', 246397),
(365674, 'PTHR12064:SF99', NULL, NULL, NULL, NULL, 'DUF21 DOMAIN PLANT PROTEIN', 246397),
(365675, 'PTHR12064:SF97', NULL, NULL, NULL, NULL, 'METAL TRANSPORTER CNNM-5', 246397),
(365676, 'PTHR12064:SF75', NULL, NULL, NULL, NULL, 'BNAC03G76080D PROTEIN', 246397),
(365677, 'PTHR12064', NULL, NULL, NULL, NULL, 'METAL TRANSPORTER CNNM', 246397),
(365678, 'PTHR12064:SF76', NULL, NULL, NULL, NULL, 'CNNM TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN', 246397),
(365679, 'PTHR12064:SF98', NULL, NULL, NULL, NULL, '', 246397);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(365680, 'PTHR12064:SF73', NULL, NULL, NULL, NULL, '', 246397),
(365681, 'PTHR12064:SF95', NULL, NULL, NULL, NULL, 'CNNM TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN', 246397),
(365682, 'PTHR12064:SF74', NULL, NULL, NULL, NULL, 'CBS DOMAIN-CONTAINING PROTEIN', 246397),
(365683, 'PTHR12064:SF96', NULL, NULL, NULL, NULL, 'DUF21 DOMAIN PLANT PROTEIN', 246397),
(365684, 'PTHR12064:SF93', NULL, NULL, NULL, NULL, '', 246397),
(365685, 'PTHR12064:SF71', NULL, NULL, NULL, NULL, '', 246397),
(365686, 'PTHR12064:SF72', NULL, NULL, NULL, NULL, 'CBS DOMAIN PROTEIN', 246397),
(365687, 'PTHR12064:SF94', NULL, NULL, NULL, NULL, 'UNEXTENDED PROTEIN', 246397),
(365688, 'PTHR12064:SF70', NULL, NULL, NULL, NULL, '', 246397),
(365689, 'PTHR12064:SF92', NULL, NULL, NULL, NULL, 'MRNA, CLONE: RAFL25-31-I24', 246397),
(365690, 'PTHR12064:SF90', NULL, NULL, NULL, NULL, 'CNNM TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN', 246397),
(365691, 'PTHR12064:SF59', NULL, NULL, NULL, NULL, 'CNNM TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN', 246397),
(365692, 'PTHR12064:SF79', NULL, NULL, NULL, NULL, 'AND COBALT EFFLUX PROTEIN CORC, PUTATIVE-RELATED', 246397),
(365693, 'PTHR12064:SF57', NULL, NULL, NULL, NULL, 'AND COBALT EFFLUX PROTEIN CORC, PUTATIVE-RELATED', 246397),
(365694, 'PTHR12064:SF36', NULL, NULL, NULL, NULL, 'DOMAIN-CONTAINING PROTEIN, PUTATIVE, EXPRESSED-RELATED', 246397),
(365695, 'PTHR47395', NULL, NULL, NULL, NULL, 'BPI FOLD-CONTAINING FAMILY B MEMBER 1', 246398),
(365696, 'PTHR47395:SF1', NULL, NULL, NULL, NULL, 'BPI FOLD-CONTAINING FAMILY B MEMBER 1', 246398),
(365697, 'PTHR28141:SF2', NULL, NULL, NULL, NULL, 'RNA LIGASE/CYCLIC NUCLEOTIDE PHOSPHODIESTERASE FAMILY PROTEIN', 246399),
(365698, 'PTHR28141:SF1', NULL, NULL, NULL, NULL, '2'',3''-CYCLIC-NUCLEOTIDE 3''-PHOSPHODIESTERASE', 246399),
(365699, 'PTHR28141', NULL, NULL, NULL, NULL, '2'',3''-CYCLIC-NUCLEOTIDE 3''-PHOSPHODIESTERASE', 246399),
(365700, 'PTHR28141:SF4', NULL, NULL, NULL, NULL, 'CYCLIC PHOSPHODIESTERASE-LIKE', 246399),
(365701, 'PTHR28141:SF3', NULL, NULL, NULL, NULL, '', 246399),
(365702, 'PTHR42203', NULL, NULL, NULL, NULL, 'UPF0058 PROTEIN MJ1205', 246400),
(365703, 'PTHR42203:SF2', NULL, NULL, NULL, NULL, 'UPF0058 PROTEIN MJ1205', 246400),
(365704, 'PTHR24237:SF7', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 183', 246401),
(365705, 'PTHR24237:SF38', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 246401),
(365706, 'PTHR24237:SF36', NULL, NULL, NULL, NULL, 'SI:DKEY-6N21.13', 246401),
(365707, 'PTHR24237:SF14', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 246401),
(365708, 'PTHR24237:SF37', NULL, NULL, NULL, NULL, 'COAGULATION FACTOR II (THROMBIN) RECEPTOR-LIKE 2', 246401),
(365709, 'PTHR24237:SF35', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 141-RELATED', 246401),
(365710, 'PTHR24237', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR', 246401),
(365711, 'PTHR24237:SF40', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR 141B', 246401),
(365712, 'PTHR12029', NULL, NULL, NULL, NULL, 'RNA METHYLTRANSFERASE', 246402),
(365713, 'PTHR12029:SF49', NULL, NULL, NULL, NULL, 'TRNA/RRNA METHYLTRANSFERASE SPOU FAMILY PROTEIN', 246402),
(365714, 'PTHR12029:SF11', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE TARBP1-RELATED', 246402),
(365715, 'PTHR31300:SF23', NULL, NULL, NULL, NULL, 'OS03G0606100 PROTEIN', 246403),
(365716, 'PTHR31300:SF45', NULL, NULL, NULL, NULL, '', 246403),
(365717, 'PTHR31300:SF34', NULL, NULL, NULL, NULL, 'PLANT/T8K14-16 PROTEIN', 246403),
(365718, 'PTHR31300:SF33', NULL, NULL, NULL, NULL, 'LIPASE', 246403),
(365719, 'PTHR31300:SF44', NULL, NULL, NULL, NULL, 'BNACNNG55970D PROTEIN', 246403),
(365720, 'PTHR31300:SF43', NULL, NULL, NULL, NULL, '', 246403),
(365721, 'PTHR31300:SF32', NULL, NULL, NULL, NULL, 'FACTOR C SUBUNIT, PUTATIVE (DUF620)-RELATED', 246403),
(365722, 'PTHR31300:SF31', NULL, NULL, NULL, NULL, 'PUTATIVE (DUF620)-RELATED', 246403),
(365723, 'PTHR31300:SF42', NULL, NULL, NULL, NULL, '', 246403),
(365724, 'PTHR31300:SF30', NULL, NULL, NULL, NULL, 'EMB|CAB81597.1', 246403);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(365725, 'PTHR31300:SF41', NULL, NULL, NULL, NULL, 'BNACNNG60070D PROTEIN', 246403),
(365726, 'PTHR31300:SF9', NULL, NULL, NULL, NULL, 'SPINDLE ASSEMBLY ABNORMAL PROTEIN (DUF620)', 246403),
(365727, 'PTHR31300:SF6', NULL, NULL, NULL, NULL, 'OS05G0252100 PROTEIN', 246403),
(365728, 'PTHR31300:SF29', NULL, NULL, NULL, NULL, 'LIPASE-LIKE PROTEIN', 246403),
(365729, 'PTHR31300:SF28', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA (GLN) AMIDOTRANSFERASE SUBUNIT A (DUF620)', 246403),
(365730, 'PTHR31300:SF38', NULL, NULL, NULL, NULL, 'BNAC02G43970D PROTEIN', 246403),
(365731, 'PTHR31300:SF27', NULL, NULL, NULL, NULL, '', 246403),
(365732, 'PTHR31300:SF26', NULL, NULL, NULL, NULL, 'DUF620 FAMILY PROTEIN', 246403),
(365733, 'PTHR31300:SF25', NULL, NULL, NULL, NULL, 'DUF620 FAMILY PROTEIN (DUF620)', 246403),
(365734, 'PTHR31300:SF24', NULL, NULL, NULL, NULL, '', 246403),
(365735, 'PTHR31300:SF5', NULL, NULL, NULL, NULL, 'OS07G0591100 PROTEIN', 246403),
(365736, 'PTHR31300:SF2', NULL, NULL, NULL, NULL, 'LIPASE', 246403),
(365737, 'PTHR31300:SF3', NULL, NULL, NULL, NULL, 'GB|AAD30234.1', 246403),
(365738, 'PTHR31300', NULL, NULL, NULL, NULL, 'LIPASE', 246403),
(365739, 'PTHR38563:SF1', NULL, NULL, NULL, NULL, 'FL(2)D-ASSOCIATED COMPLEX COMPONENT', 246404),
(365740, 'PTHR38563', NULL, NULL, NULL, NULL, 'FL(2)D-ASSOCIATED COMPLEX COMPONENT', 246404),
(365741, 'PTHR34667:SF1', NULL, NULL, NULL, NULL, 'D-AMINOACYL-TRNA DEACYLASE', 246405),
(365742, 'PTHR34667', NULL, NULL, NULL, NULL, 'D-AMINOACYL-TRNA DEACYLASE', 246405),
(365743, 'PTHR34667:SF3', NULL, NULL, NULL, NULL, 'D-AMINOACYL-TRNA DEACYLASE-LIKE ISOFORM X1', 246405),
(365744, 'PTHR34667:SF4', NULL, NULL, NULL, NULL, 'BNAA02G27310D PROTEIN', 246405),
(365745, 'PTHR34667:SF5', NULL, NULL, NULL, NULL, 'D-AMINOACYL-TRNA DEACYLASE-LIKE ISOFORM X1', 246405),
(365746, 'PTHR34667:SF6', NULL, NULL, NULL, NULL, 'OS08G0339200 PROTEIN', 246405),
(365747, 'PTHR16206:SF10', NULL, NULL, NULL, NULL, 'DEP DOMAIN-CONTAINING PROTEIN 4', 246406),
(365748, 'PTHR16206:SF9', NULL, NULL, NULL, NULL, 'DEP DOMAIN-CONTAINING PROTEIN 7', 246406),
(365749, 'PTHR16206:SF19', NULL, NULL, NULL, NULL, 'DEP DOMAIN-CONTAINING PROTEIN', 246406),
(365750, 'PTHR16206:SF18', NULL, NULL, NULL, NULL, 'TARGET OF ERK KINASE MPK-1', 246406),
(365751, 'PTHR16206', NULL, NULL, NULL, NULL, 'DEP DOMAIN-CONTAINING', 246406),
(365752, 'PTHR16206:SF13', NULL, NULL, NULL, NULL, 'DEP DOMAIN-CONTAINING PROTEIN', 246406),
(365753, 'PTHR16206:SF4', NULL, NULL, NULL, NULL, 'PROTEIN LET-99', 246406),
(365754, 'PTHR16206:SF11', NULL, NULL, NULL, NULL, 'DEP DOMAIN-CONTAINING PROTEIN 1B', 246406),
(365755, 'PTHR16206:SF12', NULL, NULL, NULL, NULL, 'DEP DOMAIN-CONTAINING PROTEIN 1A', 246406),
(365756, 'PTHR37076:SF3', NULL, NULL, NULL, NULL, 'EF-HAND 1, CALCIUM-BINDING PROTEIN-RELATED', 246407),
(365757, 'PTHR37076:SF4', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE, H3 LYSINE-79 SPECIFIC-LIKE', 246407),
(365758, 'PTHR37076', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE, H3 LYSINE-79 SPECIFIC-LIKE-RELATED', 246407),
(365759, 'PTHR35699:SF1', NULL, NULL, NULL, NULL, 'F2J10.10 PROTEIN', 246408),
(365760, 'PTHR35699:SF2', NULL, NULL, NULL, NULL, 'BNAC06G03050D PROTEIN', 246408),
(365761, 'PTHR35699', NULL, NULL, NULL, NULL, 'F2J10.10 PROTEIN', 246408),
(365762, 'PTHR20766', NULL, NULL, NULL, NULL, '', 246409),
(365763, 'PTHR20766:SF1', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 43 MEMBER 2B', 246409),
(365764, 'PTHR20766:SF0', NULL, NULL, NULL, NULL, 'LARGE NEUTRAL AMINO ACIDS TRANSPORTER SMALL SUBUNIT 3', 246409),
(365765, 'PTHR20766:SF3', NULL, NULL, NULL, NULL, '', 246409),
(365766, 'PTHR20766:SF2', NULL, NULL, NULL, NULL, 'LARGE NEUTRAL AMINO ACIDS TRANSPORTER SMALL SUBUNIT 4', 246409),
(365767, 'PTHR20766:SF7', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 43 MEMBER 1A', 246409),
(365768, 'PTHR42735:SF15', NULL, NULL, NULL, NULL, 'SPHINGOSINE PHOSPHATE LYASE', 246410),
(365769, 'PTHR42735:SF9', NULL, NULL, NULL, NULL, '', 246410),
(365770, 'PTHR42735:SF12', NULL, NULL, NULL, NULL, '', 246410);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(365771, 'PTHR42735:SF14', NULL, NULL, NULL, NULL, '', 246410),
(365772, 'PTHR42735', NULL, NULL, NULL, NULL, '', 246410),
(365773, 'PTHR42735:SF10', NULL, NULL, NULL, NULL, 'PYRIDOXAL-DEPENDENT DECARBOXYLASE DOMAIN-CONTAINING PROTEIN 1-RELATED', 246410),
(365774, 'PTHR42735:SF1', NULL, NULL, NULL, NULL, 'PYRIDOXAL-DEPENDENT DECARBOXYLASE DOMAIN-CONTAINING PROTEIN 1', 246410),
(365775, 'PTHR42735:SF6', NULL, NULL, NULL, NULL, 'SPHINGOSINE-1-PHOSPHATE LYASE 1', 246410),
(365776, 'PTHR42735:SF4', NULL, NULL, NULL, NULL, '', 246410),
(365777, 'PTHR37693:SF1', NULL, NULL, NULL, NULL, '', 246411),
(365778, 'PTHR37693', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLGLYCEROL LYSYLTRANSFERASE', 246411),
(365779, 'PTHR47502:SF1', NULL, NULL, NULL, NULL, 'THAP DOMAIN-CONTAINING PROTEIN 7', 246412),
(365780, 'PTHR47502', NULL, NULL, NULL, NULL, 'THAP DOMAIN-CONTAINING PROTEIN 7', 246412),
(365781, 'PTHR31539:SF1', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 19 KDA', 246413),
(365782, 'PTHR31539', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 19K CEP19', 246413),
(365783, 'PTHR24372:SF5', NULL, NULL, NULL, NULL, 'FOLLICLE-STIMULATING HORMONE RECEPTOR', 246414),
(365784, 'PTHR24372:SF0', NULL, NULL, NULL, NULL, 'THYROTROPIN RECEPTOR', 246414),
(365785, 'PTHR24372:SF1', NULL, NULL, NULL, NULL, 'LUTROPIN-CHORIOGONADOTROPIC HORMONE RECEPTOR', 246414),
(365786, 'PTHR24372:SF80', NULL, NULL, NULL, NULL, 'FI21465P1-RELATED', 246414),
(365787, 'PTHR24372:SF70', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 246414),
(365788, 'PTHR24372:SF71', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING G-PROTEIN COUPLED RECEPTOR 5', 246414),
(365789, 'PTHR24372:SF82', NULL, NULL, NULL, NULL, 'RICKETS', 246414),
(365790, 'PTHR24372:SF72', NULL, NULL, NULL, NULL, 'RELAXIN RECEPTOR 2', 246414),
(365791, 'PTHR24372:SF73', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING G-PROTEIN COUPLED RECEPTOR 6', 246414),
(365792, 'PTHR24372:SF74', NULL, NULL, NULL, NULL, 'LP13728P', 246414),
(365793, 'PTHR24372:SF77', NULL, NULL, NULL, NULL, 'GPR INSULIN LIKE RECEPTOR 1', 246414),
(365794, 'PTHR24372:SF67', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING G-PROTEIN COUPLED RECEPTOR 4', 246414),
(365795, 'PTHR24372:SF68', NULL, NULL, NULL, NULL, 'RELAXIN RECEPTOR 1', 246414),
(365796, 'PTHR24372', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN HORMONE RECEPTOR', 246414),
(365797, 'PTHR33244:SF6', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 246415),
(365798, 'PTHR33244:SF3', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 246415),
(365799, 'PTHR33244', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 246415),
(365800, 'PTHR36141:SF3', NULL, NULL, NULL, NULL, '', 246416),
(365801, 'PTHR36141:SF2', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 246416),
(365802, 'PTHR36141:SF5', NULL, NULL, NULL, NULL, '', 246416),
(365803, 'PTHR36141:SF4', NULL, NULL, NULL, NULL, 'OS08G0148566 PROTEIN', 246416),
(365804, 'PTHR36141', NULL, NULL, NULL, NULL, 'OS08G0148500 PROTEIN', 246416),
(365805, 'PTHR36141:SF6', NULL, NULL, NULL, NULL, '', 246416),
(365806, 'PTHR35680', NULL, NULL, NULL, NULL, 'NFAT ACTIVATION MOLECULE 1', 246417),
(365807, 'PTHR35680:SF1', NULL, NULL, NULL, NULL, 'NFAT ACTIVATION MOLECULE 1', 246417),
(365808, 'PTHR19965:SF89', NULL, NULL, NULL, NULL, 'OS08G0427900 PROTEIN', 246418),
(365809, 'PTHR19965:SF68', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 246418),
(365810, 'PTHR19965:SF25', NULL, NULL, NULL, NULL, 'FOP_DUPLICATION DOMAIN-CONTAINING PROTEIN', 246418),
(365811, 'PTHR19965:SF69', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-BINDING ALPHA-BETA PLAIT DOMAIN-CONTAINING PROTEIN-RELATED', 246418),
(365812, 'PTHR19965', NULL, NULL, NULL, NULL, 'RNA AND EXPORT FACTOR BINDING PROTEIN', 246418),
(365813, 'PTHR19965:SF26', NULL, NULL, NULL, NULL, 'THO COMPLEX SUBUNIT 4B', 246418),
(365814, 'PTHR19965:SF86', NULL, NULL, NULL, NULL, 'THO COMPLEX SUBUNIT 4C', 246418),
(365815, 'PTHR19965:SF21', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 246418);
INSERT INTO "PUBLIC"."MODEL" VALUES
(365816, 'PTHR19965:SF65', NULL, NULL, NULL, NULL, 'THO COMPLEX SUBUNIT 4A-LIKE', 246418),
(365817, 'PTHR19965:SF22', NULL, NULL, NULL, NULL, 'CHROMATIN TARGET OF PRMT1 PROTEIN', 246418),
(365818, 'PTHR19965:SF82', NULL, NULL, NULL, NULL, 'THO COMPLEX SUBUNIT 4', 246418),
(365819, 'PTHR19965:SF60', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 246418),
(365820, 'PTHR19965:SF83', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 246418),
(365821, 'PTHR19965:SF100', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 246418),
(365822, 'PTHR19965:SF35', NULL, NULL, NULL, NULL, 'RNA ANNEALING PROTEIN YRA1', 246418),
(365823, 'PTHR19965:SF96', NULL, NULL, NULL, NULL, 'POLYMERASE DELTA-INTERACTING PROTEIN 3', 246418),
(365824, 'PTHR19965:SF97', NULL, NULL, NULL, NULL, '', 246418),
(365825, 'PTHR19965:SF98', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN-RELATED', 246418),
(365826, 'PTHR19965:SF76', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 246418),
(365827, 'PTHR19965:SF33', NULL, NULL, NULL, NULL, 'THO COMPLEX SUBUNIT 4D', 246418),
(365828, 'PTHR19965:SF99', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN-RELATED', 246418),
(365829, 'PTHR19965:SF93', NULL, NULL, NULL, NULL, 'RNA RECOGNITION MOTIF', 246418),
(365830, 'PTHR19965:SF94', NULL, NULL, NULL, NULL, 'FI13061P-RELATED', 246418),
(365831, 'PTHR19965:SF72', NULL, NULL, NULL, NULL, 'THO COMPLEX SUBUNIT 4A', 246418),
(365832, 'PTHR19965:SF95', NULL, NULL, NULL, NULL, 'OS12G0100100 PROTEIN', 246418),
(365833, 'PTHR19965:SF91', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 246418),
(365834, 'PTHR47649', NULL, NULL, NULL, NULL, 'RIBONUCLEASE D', 246419),
(365835, 'PTHR47649:SF1', NULL, NULL, NULL, NULL, 'RIBONUCLEASE D', 246419),
(365836, 'PTHR16717:SF7', NULL, NULL, NULL, NULL, 'SI:DKEY-85N7.8', 246420),
(365837, 'PTHR16717:SF8', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 8A', 246420),
(365838, 'PTHR16717', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE POLYPEPTIDE VIII', 246420),
(365839, 'PTHR16717:SF4', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 8B, MITOCHONDRIAL', 246420),
(365840, 'PTHR16717:SF5', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 8, ISOFORM A', 246420),
(365841, 'PTHR16717:SF6', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 8B', 246420),
(365842, 'PTHR16717:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 8A, MITOCHONDRIAL', 246420),
(365843, 'PTHR16717:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 8C, MITOCHONDRIAL', 246420),
(365844, 'PTHR35872:SF2', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_5G07110)', 246421),
(365845, 'PTHR35872', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_5G07110)', 246421),
(365846, 'PTHR35872:SF1', NULL, NULL, NULL, NULL, '', 246421),
(365847, 'PTHR28289', NULL, NULL, NULL, NULL, 'DASH COMPLEX SUBUNIT HSK3', 246422),
(365848, 'PTHR28289:SF1', NULL, NULL, NULL, NULL, 'DASH COMPLEX SUBUNIT HSK3', 246422),
(365849, 'PTHR46208', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM70', 246423),
(365850, 'PTHR46208:SF2', NULL, NULL, NULL, NULL, 'ASSEMBLY CHAPERONE OF RPL4', 246423),
(365851, 'PTHR46208:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM70', 246423),
(365852, 'PTHR43581:SF2', NULL, NULL, NULL, NULL, 'ATP/GTP PHOSPHATASE', 246424),
(365853, 'PTHR43581', NULL, NULL, NULL, NULL, 'ATP/GTP PHOSPHATASE', 246424),
(365854, 'PTHR43581:SF1', NULL, NULL, NULL, NULL, 'AAA_15 DOMAIN-CONTAINING PROTEIN', 246424),
(365855, 'PTHR44411:SF1', NULL, NULL, NULL, NULL, 'THO COMPLEX SUBUNIT 6 HOMOLOG', 246425),
(365856, 'PTHR44411', NULL, NULL, NULL, NULL, 'THO COMPLEX SUBUNIT 6 HOMOLOG', 246425),
(365857, 'PTHR35669', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 9', 246426),
(365858, 'PTHR35669:SF1', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 9', 246426),
(365859, 'PTHR11195:SF13', NULL, NULL, NULL, NULL, 'INVERTEBRATE-TYPE LYSOZYME 2-RELATED', 246427);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(365860, 'PTHR11195', NULL, NULL, NULL, NULL, 'DESTABILASE-RELATED', 246427),
(365861, 'PTHR11195:SF17', NULL, NULL, NULL, NULL, 'LYSOZYME', 246427),
(365862, 'PTHR11195:SF22', NULL, NULL, NULL, NULL, 'LYSOZYME', 246427),
(365863, 'PTHR11195:SF20', NULL, NULL, NULL, NULL, 'LYSOZYME', 246427),
(365864, 'PTHR10541:SF2', NULL, NULL, NULL, NULL, 'PARATHYROID HORMONE', 246428),
(365865, 'PTHR10541', NULL, NULL, NULL, NULL, 'PARATHYROID HORMONE', 246428),
(365866, 'PTHR32063:SF21', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN MDTB', 246429),
(365867, 'PTHR32063:SF9', NULL, NULL, NULL, NULL, 'SIMILAR TO MULTIDRUG RESISTANCE PROTEIN MEXB', 246429),
(365868, 'PTHR32063:SF23', NULL, NULL, NULL, NULL, 'HAE1 FAMILY EFFLLUX PUMP PERMEASE COMPONENT', 246429),
(365869, 'PTHR32063:SF68', NULL, NULL, NULL, NULL, 'PROBALE CATION EFFLUX SYSTEM PROTEIN', 246429),
(365870, 'PTHR32063:SF24', NULL, NULL, NULL, NULL, 'CATION EFFLUX SYSTEM (ACRB/ACRD/ACRF FAMILY)', 246429),
(365871, 'PTHR32063:SF8', NULL, NULL, NULL, NULL, 'CATION EFFLUX PROTEIN', 246429),
(365872, 'PTHR32063:SF64', NULL, NULL, NULL, NULL, 'ACRB/ACRD/ACRF FAMILY PROTEIN', 246429),
(365873, 'PTHR32063:SF4', NULL, NULL, NULL, NULL, 'SLR6043 PROTEIN', 246429),
(365874, 'PTHR32063:SF0', NULL, NULL, NULL, NULL, 'SWARMING MOTILITY PROTEIN SWRC', 246429),
(365875, 'PTHR32063:SF29', NULL, NULL, NULL, NULL, 'HAE1 FAMILY EFFLUX PUMP PERMEASE COMPONENT', 246429),
(365876, 'PTHR32063:SF26', NULL, NULL, NULL, NULL, 'EFFLUX PUMP MEMBRANE TRANSPORTER', 246429),
(365877, 'PTHR32063:SF28', NULL, NULL, NULL, NULL, 'BLR2861 PROTEIN', 246429),
(365878, 'PTHR32063:SF10', NULL, NULL, NULL, NULL, 'EFFLUX PUMP MEMBRANE TRANSPORTER', 246429),
(365879, 'PTHR32063:SF32', NULL, NULL, NULL, NULL, 'AMINOGLYCOSIDE EFFLUX PUMP-RELATED', 246429),
(365880, 'PTHR32063:SF76', NULL, NULL, NULL, NULL, 'EFFLUX PUMP MEMBRANE TRANSPORTER', 246429),
(365881, 'PTHR32063:SF11', NULL, NULL, NULL, NULL, 'EFFLUX PUMP MEMBRANE TRANSPORTER', 246429),
(365882, 'PTHR32063:SF33', NULL, NULL, NULL, NULL, 'RND SUPERFAMILY EFFLUX PUMP PERMEASE COMPONENT', 246429),
(365883, 'PTHR32063:SF34', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN MDTC', 246429),
(365884, 'PTHR32063:SF12', NULL, NULL, NULL, NULL, 'CATION EFFLUX SYSTEM PROTEIN', 246429),
(365885, 'PTHR32063:SF13', NULL, NULL, NULL, NULL, 'MULTIDRUG EFFLUX PUMP SUBUNIT ACRB-RELATED', 246429),
(365886, 'PTHR32063:SF72', NULL, NULL, NULL, NULL, 'MULTIDRUG EXPORT PROTEIN ACRF', 246429),
(365887, 'PTHR32063:SF73', NULL, NULL, NULL, NULL, 'RND SUPERFAMILY EFFLUX PUMP PERMEASE COMPONENT 1', 246429),
(365888, 'PTHR32063:SF74', NULL, NULL, NULL, NULL, 'CATION OR DRUG EFFLUX SYSTEM PROTEIN', 246429),
(365889, 'PTHR32063:SF30', NULL, NULL, NULL, NULL, 'ACRB/ACRD/ACRF FAMILY PROTEIN', 246429),
(365890, 'PTHR32063:SF18', NULL, NULL, NULL, NULL, 'CATION EFFLUX SYSTEM PROTEIN', 246429),
(365891, 'PTHR32063', NULL, NULL, NULL, NULL, '', 246429),
(365892, 'PTHR32063:SF19', NULL, NULL, NULL, NULL, 'CATION EFFLUX SYSTEM PROTEIN CUSA', 246429),
(365893, 'PTHR32063:SF14', NULL, NULL, NULL, NULL, 'CATION EFFLUX (ACRB/ACRD/ACRF FAMILY)', 246429),
(365894, 'PTHR32063:SF16', NULL, NULL, NULL, NULL, 'CATION EFFLUX SYSTEM (ACRB/ACRD/ACRF FAMILY)', 246429),
(365895, 'PTHR32063:SF17', NULL, NULL, NULL, NULL, 'CATION EFFLUX SYSTEM PROTEIN', 246429),
(365896, 'PTHR23054:SF26', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246430),
(365897, 'PTHR23054:SF80', NULL, NULL, NULL, NULL, 'ELECTRON TRANSPORTER', 246430),
(365898, 'PTHR23054:SF60', NULL, NULL, NULL, NULL, '', 246430),
(365899, 'PTHR23054:SF82', NULL, NULL, NULL, NULL, 'DUF547 DOMAIN-CONTAINING PROTEIN', 246430),
(365900, 'PTHR23054:SF81', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 246430),
(365901, 'PTHR23054:SF66', NULL, NULL, NULL, NULL, 'BNAA04G13840D PROTEIN', 246430),
(365902, 'PTHR23054:SF23', NULL, NULL, NULL, NULL, 'OS09G0493400 PROTEIN', 246430),
(365903, 'PTHR23054:SF84', NULL, NULL, NULL, NULL, 'TERNARY COMPLEX FACTOR MIP1-LIKE', 246430),
(365904, 'PTHR23054:SF62', NULL, NULL, NULL, NULL, 'DUF547 DOMAIN-CONTAINING PROTEIN', 246430);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(365905, 'PTHR23054:SF83', NULL, NULL, NULL, NULL, 'TERNARY COMPLEX FACTOR MIP1, LEUCINE-ZIPPER-RELATED', 246430),
(365906, 'PTHR23054:SF61', NULL, NULL, NULL, NULL, 'OS02G0153000 PROTEIN', 246430),
(365907, 'PTHR23054:SF64', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE-RELATED', 246430),
(365908, 'PTHR23054:SF20', NULL, NULL, NULL, NULL, 'TERNARY COMPLEX FACTOR MIP1 LEUCINE-ZIPPER PROTEIN', 246430),
(365909, 'PTHR23054:SF85', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN', 246430),
(365910, 'PTHR23054:SF18', NULL, NULL, NULL, NULL, 'ELECTRON TRANSPORTER', 246430),
(365911, 'PTHR23054:SF15', NULL, NULL, NULL, NULL, 'OS08G0515700 PROTEIN', 246430),
(365912, 'PTHR23054:SF59', NULL, NULL, NULL, NULL, 'DUF547 DOMAIN-CONTAINING PROTEIN', 246430),
(365913, 'PTHR23054:SF58', NULL, NULL, NULL, NULL, 'OS03G0233800 PROTEIN', 246430),
(365914, 'PTHR23054', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 246430),
(365915, 'PTHR23054:SF70', NULL, NULL, NULL, NULL, 'OS06G0692800 PROTEIN', 246430),
(365916, 'PTHR23054:SF55', NULL, NULL, NULL, NULL, 'ELECTRON TRANSPORTER', 246430),
(365917, 'PTHR23054:SF77', NULL, NULL, NULL, NULL, 'BNAA07G12450D PROTEIN', 246430),
(365918, 'PTHR23054:SF57', NULL, NULL, NULL, NULL, 'TERNARY COMPLEX FACTOR MIP1 LEUCINE-ZIPPER PROTEIN', 246430),
(365919, 'PTHR23054:SF73', NULL, NULL, NULL, NULL, 'BNAC05G40340D PROTEIN', 246430),
(365920, 'PTHR23054:SF72', NULL, NULL, NULL, NULL, 'TERNARY COMPLEX FACTOR MIP1, LEUCINE-ZIPPER-RELATED', 246430),
(365921, 'PTHR23054:SF53', NULL, NULL, NULL, NULL, 'OS06G0704100 PROTEIN', 246430),
(365922, 'PTHR23054:SF75', NULL, NULL, NULL, NULL, 'DUF547 DOMAIN-CONTAINING PROTEIN', 246430),
(365923, 'PTHR38447:SF1', NULL, NULL, NULL, NULL, 'RNA POLYMERASE-BINDING TRANSCRIPTION FACTOR CARD', 246431),
(365924, 'PTHR38447', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR YDEB-RELATED', 246431),
(365925, 'PTHR43247', NULL, NULL, NULL, NULL, 'PHOSPHOSERINE AMINOTRANSFERASE', 246432),
(365926, 'PTHR43247:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOSERINE AMINOTRANSFERASE', 246432),
(365927, 'PTHR43247:SF4', NULL, NULL, NULL, NULL, 'PHOSPHOHYDROXYTHREONINE AMINOTRANSFERASE', 246432),
(365928, 'PTHR43247:SF3', NULL, NULL, NULL, NULL, 'PHOSPHOSERINE AMINOTRANSFERASE 1, CHLOROPLASTIC', 246432),
(365929, 'PTHR43247:SF6', NULL, NULL, NULL, NULL, 'PHOSPHOHYDROXYTHREONINE AMINOTRANSFERASE', 246432),
(365930, 'PTHR43247:SF5', NULL, NULL, NULL, NULL, 'PHOSPHOSERINE AMINOTRANSFERASE', 246432),
(365931, 'PTHR43917:SF5', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 246433),
(365932, 'PTHR43917:SF10', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 246433),
(365933, 'PTHR43917:SF4', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE THETA-2-RELATED', 246433),
(365934, 'PTHR43917:SF12', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE THETA-3', 246433),
(365935, 'PTHR43917:SF9', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE THETA-1', 246433),
(365936, 'PTHR43917:SF13', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE THETA-4-RELATED', 246433),
(365937, 'PTHR43917:SF8', NULL, NULL, NULL, NULL, 'GH16740P-RELATED', 246433),
(365938, 'PTHR43917', NULL, NULL, NULL, NULL, '', 246433),
(365939, 'PTHR15498:SF72', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 7', 246434),
(365940, 'PTHR15498:SF73', NULL, NULL, NULL, NULL, 'HEPATITIS A VIRUS CELLULAR RECEPTOR 2', 246434),
(365941, 'PTHR15498', NULL, NULL, NULL, NULL, 'T-CELL IMMUNOGLOBULIN AND MUCIN DOMAIN CONTAINING  TIM', 246434),
(365942, 'PTHR15498:SF74', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 7', 246434),
(365943, 'PTHR11685:SF319', NULL, NULL, NULL, NULL, 'RING ZN FINGER-CONTAINING PROTEIN', 246435),
(365944, 'PTHR11685:SF439', NULL, NULL, NULL, NULL, '', 246435),
(365945, 'PTHR11685:SF438', NULL, NULL, NULL, NULL, 'ZINC FINGER, C3HC4 TYPE (RING FINGER) PROTEIN', 246435),
(365946, 'PTHR11685:SF317', NULL, NULL, NULL, NULL, 'BNAA05G11180D PROTEIN', 246435),
(365947, 'PTHR11685:SF316', NULL, NULL, NULL, NULL, 'BNAA10G03930D PROTEIN', 246435);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(365948, 'PTHR11685:SF437', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND IBR DOMAIN-CONTAINING PROTEIN 1', 246435),
(365949, 'PTHR11685:SF395', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ARI2 ISOFORM X1-RELATED', 246435),
(365950, 'PTHR11685:SF273', NULL, NULL, NULL, NULL, 'IBR DOMAIN CONTAINING PROTEIN, EXPRESSED', 246435),
(365951, 'PTHR11685:SF272', NULL, NULL, NULL, NULL, 'OS11G0599700 PROTEIN', 246435),
(365952, 'PTHR11685:SF393', NULL, NULL, NULL, NULL, 'OS09G0559000 PROTEIN', 246435),
(365953, 'PTHR11685:SF432', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 246435),
(365954, 'PTHR11685:SF311', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246435),
(365955, 'PTHR11685:SF431', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN-RELATED', 246435),
(365956, 'PTHR11685:SF310', NULL, NULL, NULL, NULL, 'RBR-TYPE E3 UBIQUITIN TRANSFERASE', 246435),
(365957, 'PTHR11685:SF430', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN-RELATED', 246435),
(365958, 'PTHR11685:SF397', NULL, NULL, NULL, NULL, '', 246435),
(365959, 'PTHR11685:SF396', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF144B-LIKE', 246435),
(365960, 'PTHR11685:SF436', NULL, NULL, NULL, NULL, 'RBR-TYPE E3 UBIQUITIN TRANSFERASE', 246435),
(365961, 'PTHR11685:SF315', NULL, NULL, NULL, NULL, 'BNAA02G08240D PROTEIN', 246435),
(365962, 'PTHR11685:SF314', NULL, NULL, NULL, NULL, 'SI:CH211-212K18.15', 246435),
(365963, 'PTHR11685:SF435', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF19B', 246435),
(365964, 'PTHR11685:SF434', NULL, NULL, NULL, NULL, 'PROTEIN ARIADNE-1-LIKE', 246435),
(365965, 'PTHR11685:SF313', NULL, NULL, NULL, NULL, 'RING ZINC FINGER DOMAIN SUPERFAMILY PROTEIN-RELATED', 246435),
(365966, 'PTHR11685:SF433', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246435),
(365967, 'PTHR11685:SF429', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF217-RELATED', 246435),
(365968, 'PTHR11685:SF428', NULL, NULL, NULL, NULL, 'RING ZN FINGER-CONTAINING PROTEIN', 246435),
(365969, 'PTHR11685:SF427', NULL, NULL, NULL, NULL, 'RBR-TYPE E3 UBIQUITIN TRANSFERASE', 246435),
(365970, 'PTHR11685:SF426', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ARI2-RELATED', 246435),
(365971, 'PTHR11685:SF382', NULL, NULL, NULL, NULL, 'RBR-TYPE E3 UBIQUITIN TRANSFERASE', 246435),
(365972, 'PTHR11685:SF146', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF217 ISOFORM X1-RELATED', 246435),
(365973, 'PTHR11685:SF421', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246435),
(365974, 'PTHR11685:SF267', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ARI10-RELATED', 246435),
(365975, 'PTHR11685:SF266', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ARI12-RELATED', 246435),
(365976, 'PTHR11685:SF420', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246435),
(365977, 'PTHR11685:SF387', NULL, NULL, NULL, NULL, '', 246435),
(365978, 'PTHR11685:SF265', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 246435),
(365979, 'PTHR11685:SF425', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246435),
(365980, 'PTHR11685:SF424', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ARI7-RELATED', 246435),
(365981, 'PTHR11685:SF423', NULL, NULL, NULL, NULL, 'IBR DOMAIN CONTAINING PROTEIN-RELATED', 246435),
(365982, 'PTHR11685:SF422', NULL, NULL, NULL, NULL, '', 246435),
(365983, 'PTHR11685:SF389', NULL, NULL, NULL, NULL, 'RBR-TYPE E3 UBIQUITIN TRANSFERASE', 246435),
(365984, 'PTHR11685:SF301', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF217-RELATED', 246435),
(365985, 'PTHR11685:SF418', NULL, NULL, NULL, NULL, 'IBR FINGER DOMAIN PROTEIN', 246435),
(365986, 'PTHR11685:SF417', NULL, NULL, NULL, NULL, 'EMB|CAB75487.1', 246435),
(365987, 'PTHR11685:SF416', NULL, NULL, NULL, NULL, 'ZINC FINGER FAMILY PROTEIN', 246435),
(365988, 'PTHR11685:SF415', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ARI11-RELATED', 246435),
(365989, 'PTHR11685:SF419', NULL, NULL, NULL, NULL, 'RBR-TYPE E3 UBIQUITIN TRANSFERASE', 246435);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(365990, 'PTHR11685:SF252', NULL, NULL, NULL, NULL, 'FINGER FAMILY PROTEIN, PUTATIVE-RELATED', 246435),
(365991, 'PTHR11685:SF372', NULL, NULL, NULL, NULL, 'PROTEIN ARIADNE-2-LIKE', 246435),
(365992, 'PTHR11685:SF371', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF14', 246435),
(365993, 'PTHR11685:SF250', NULL, NULL, NULL, NULL, 'RING ZINC FINGER DOMAIN SUPERFAMILY PROTEIN-RELATED', 246435),
(365994, 'PTHR11685:SF370', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ARI13-RELATED', 246435),
(365995, 'PTHR11685:SF377', NULL, NULL, NULL, NULL, 'ARIADNE-1, PUTATIVE-RELATED', 246435),
(365996, 'PTHR11685:SF410', NULL, NULL, NULL, NULL, 'RBR-TYPE E3 UBIQUITIN TRANSFERASE', 246435),
(365997, 'PTHR11685:SF376', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ARI3-RELATED', 246435),
(365998, 'PTHR11685:SF414', NULL, NULL, NULL, NULL, 'RANBP-TYPE AND C3HC4-TYPE ZINC FINGER-CONTAINING PROTEIN 1', 246435),
(365999, 'PTHR11685:SF413', NULL, NULL, NULL, NULL, '', 246435),
(366000, 'PTHR11685:SF412', NULL, NULL, NULL, NULL, 'RBR-TYPE E3 UBIQUITIN TRANSFERASE', 246435),
(366001, 'PTHR11685:SF257', NULL, NULL, NULL, NULL, '', 246435),
(366002, 'PTHR11685:SF407', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 246435),
(366003, 'PTHR11685:SF406', NULL, NULL, NULL, NULL, 'OS09G0435250 PROTEIN', 246435),
(366004, 'PTHR11685:SF404', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246435),
(366005, 'PTHR11685:SF362', NULL, NULL, NULL, NULL, 'BNAA04G18230D PROTEIN', 246435),
(366006, 'PTHR11685:SF241', NULL, NULL, NULL, NULL, 'BNAA02G29030D PROTEIN', 246435),
(366007, 'PTHR11685:SF245', NULL, NULL, NULL, NULL, 'RBR-TYPE E3 UBIQUITIN TRANSFERASE', 246435),
(366008, 'PTHR11685:SF243', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 246435),
(366009, 'PTHR11685:SF403', NULL, NULL, NULL, NULL, 'BNAA08G31720D PROTEIN', 246435),
(366010, 'PTHR11685:SF402', NULL, NULL, NULL, NULL, 'BNAA10G13050D PROTEIN', 246435),
(366011, 'PTHR11685:SF369', NULL, NULL, NULL, NULL, 'RING/U-BOX PROTEIN WITH C6HC-TYPE ZINC FINGER', 246435),
(366012, 'PTHR11685:SF368', NULL, NULL, NULL, NULL, 'RBR-TYPE E3 UBIQUITIN TRANSFERASE', 246435),
(366013, 'PTHR11685:SF400', NULL, NULL, NULL, NULL, 'RBR-TYPE E3 UBIQUITIN TRANSFERASE', 246435),
(366014, 'PTHR11685:SF367', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246435),
(366015, 'PTHR11685:SF355', NULL, NULL, NULL, NULL, 'RBR-TYPE E3 UBIQUITIN TRANSFERASE', 246435),
(366016, 'PTHR11685:SF234', NULL, NULL, NULL, NULL, 'RBR-TYPE E3 UBIQUITIN TRANSFERASE', 246435),
(366017, 'PTHR11685:SF233', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE', 246435),
(366018, 'PTHR11685:SF111', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF19A', 246435),
(366019, 'PTHR11685:SF99', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF144A', 246435),
(366020, 'PTHR11685:SF359', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246435),
(366021, 'PTHR11685:SF237', NULL, NULL, NULL, NULL, 'F5D14.10 PROTEIN', 246435),
(366022, 'PTHR11685:SF356', NULL, NULL, NULL, NULL, 'IBR DOMAIN, ZINC FINGER, RING/FYVE/PHD-TYPE, E3 UBIQUITIN LIGASE RBR FAMILY-RELATED', 246435),
(366023, 'PTHR11685:SF109', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF19B', 246435),
(366024, 'PTHR11685:SF229', NULL, NULL, NULL, NULL, 'RBR-TYPE E3 UBIQUITIN TRANSFERASE', 246435),
(366025, 'PTHR11685:SF349', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF217-RELATED', 246435),
(366026, 'PTHR11685:SF340', NULL, NULL, NULL, NULL, 'HELICASE, IBR AND ZINC FINGER PROTEIN', 246435),
(366027, 'PTHR11685:SF343', NULL, NULL, NULL, NULL, 'RBR-TYPE E3 UBIQUITIN TRANSFERASE', 246435),
(366028, 'PTHR11685:SF342', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ARI7-RELATED', 246435),
(366029, 'PTHR11685:SF347', NULL, NULL, NULL, NULL, 'BNACNNG75090D PROTEIN', 246435),
(366030, 'PTHR11685:SF226', NULL, NULL, NULL, NULL, '', 246435),
(366031, 'PTHR11685:SF225', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF217-RELATED', 246435),
(366032, 'PTHR11685:SF104', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF144B', 246435);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(366033, 'PTHR11685:SF339', NULL, NULL, NULL, NULL, 'RBR-TYPE E3 UBIQUITIN TRANSFERASE', 246435),
(366034, 'PTHR11685:SF290', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF14', 246435),
(366035, 'PTHR11685:SF296', NULL, NULL, NULL, NULL, 'RBR-TYPE E3 UBIQUITIN TRANSFERASE', 246435),
(366036, 'PTHR11685:SF295', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ARI16-RELATED', 246435),
(366037, 'PTHR11685:SF294', NULL, NULL, NULL, NULL, 'RBR-TYPE E3 UBIQUITIN TRANSFERASE', 246435),
(366038, 'PTHR11685:SF212', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ARIH1', 246435),
(366039, 'PTHR11685:SF333', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ARI2-RELATED', 246435),
(366040, 'PTHR11685:SF299', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246435),
(366041, 'PTHR11685:SF331', NULL, NULL, NULL, NULL, 'BNAC02G11650D PROTEIN', 246435),
(366042, 'PTHR11685:SF210', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ARIH2', 246435),
(366043, 'PTHR11685:SF297', NULL, NULL, NULL, NULL, 'RBR-TYPE E3 UBIQUITIN TRANSFERASE', 246435),
(366044, 'PTHR11685:SF330', NULL, NULL, NULL, NULL, 'BNAC03G47060D PROTEIN', 246435),
(366045, 'PTHR11685:SF334', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 246435),
(366046, 'PTHR11685:SF208', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246435),
(366047, 'PTHR11685:SF281', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 246435),
(366048, 'PTHR11685:SF284', NULL, NULL, NULL, NULL, 'IBR DOMAIN CONTAINING PROTEIN-RELATED', 246435),
(366049, 'PTHR11685:SF322', NULL, NULL, NULL, NULL, 'OS03G0625933 PROTEIN', 246435),
(366050, 'PTHR11685:SF289', NULL, NULL, NULL, NULL, 'RBR-TYPE E3 UBIQUITIN TRANSFERASE', 246435),
(366051, 'PTHR11685', NULL, NULL, NULL, NULL, 'RBR FAMILY  RING FINGER AND IBR DOMAIN-CONTAINING', 246435),
(366052, 'PTHR11685:SF441', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE PARKIN', 246435),
(366053, 'PTHR11685:SF440', NULL, NULL, NULL, NULL, 'OS09G0420000 PROTEIN', 246435),
(366054, 'PTHR11685:SF286', NULL, NULL, NULL, NULL, 'RBR-TYPE E3 UBIQUITIN TRANSFERASE', 246435),
(366055, 'PTHR11685:SF326', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ARI5-RELATED', 246435),
(366056, 'PTHR11685:SF323', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 246435),
(366057, 'PTHR34494:SF1', NULL, NULL, NULL, NULL, 'C. ELEGANS HOMEOBOX', 246436),
(366058, 'PTHR34494:SF2', NULL, NULL, NULL, NULL, '', 246436),
(366059, 'PTHR34494', NULL, NULL, NULL, NULL, '', 246436),
(366060, 'PTHR33600', NULL, NULL, NULL, NULL, 'PLASTID DIVISION PROTEIN PDV2', 246437),
(366061, 'PTHR33600:SF4', NULL, NULL, NULL, NULL, 'PLASTID DIVISION PROTEIN PDV1', 246437),
(366062, 'PTHR33600:SF13', NULL, NULL, NULL, NULL, 'OS01G0224200 PROTEIN', 246437),
(366063, 'PTHR33600:SF3', NULL, NULL, NULL, NULL, 'PLASTID DIVISION PROTEIN PDV2', 246437),
(366064, 'PTHR33600:SF1', NULL, NULL, NULL, NULL, 'OS06G0506000 PROTEIN', 246437),
(366065, 'PTHR33600:SF16', NULL, NULL, NULL, NULL, 'BNAA03G12350D PROTEIN', 246437),
(366066, 'PTHR33600:SF5', NULL, NULL, NULL, NULL, '', 246437),
(366067, 'PTHR33600:SF14', NULL, NULL, NULL, NULL, 'BNAA09G08610D PROTEIN', 246437),
(366068, 'PTHR13999:SF4', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED TRANSMEMBRANE PROTEIN 3', 246438),
(366069, 'PTHR13999:SF6', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED TRANSMEMBRANE PROTEIN 1', 246438),
(366070, 'PTHR13999:SF7', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED TRANSMEMBRANE PROTEIN 2', 246438),
(366071, 'PTHR13999:SF8', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED TRANSMEMBRANE PROTEIN 2', 246438),
(366072, 'PTHR13999:SF9', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED TRANSMEMBRANE PROTEIN 10', 246438),
(366073, 'PTHR13999:SF26', NULL, NULL, NULL, NULL, '', 246438),
(366074, 'PTHR13999:SF29', NULL, NULL, NULL, NULL, '', 246438),
(366075, 'PTHR13999', NULL, NULL, NULL, NULL, 'INTERFERON INDUCIBLE TRANSMEMBRANE PROTEIN', 246438),
(366076, 'PTHR13999:SF30', NULL, NULL, NULL, NULL, '', 246438),
(366077, 'PTHR13999:SF31', NULL, NULL, NULL, NULL, 'INTERFERON INDUCED TRANSMEMBRANE PROTEIN 3', 246438);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(366078, 'PTHR13999:SF10', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED TRANSMEMBRANE PROTEIN 5', 246438),
(366079, 'PTHR13999:SF32', NULL, NULL, NULL, NULL, '', 246438),
(366080, 'PTHR13999:SF22', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED TRANSMEMBRANE PROTEIN 6', 246438),
(366081, 'PTHR13999:SF23', NULL, NULL, NULL, NULL, 'DISPANIN SUBFAMILY A MEMBER 2D-RELATED', 246438),
(366082, 'PTHR13999:SF13', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED TRANSMEMBRANE PROTEIN 1-RELATED', 246438),
(366083, 'PTHR13999:SF25', NULL, NULL, NULL, NULL, '', 246438),
(366084, 'PTHR13914:SF30', NULL, NULL, NULL, NULL, 'PROLINE DEHYDROGENASE', 246439),
(366085, 'PTHR13914:SF20', NULL, NULL, NULL, NULL, 'PROLINE DEHYDROGENASE', 246439),
(366086, 'PTHR13914:SF31', NULL, NULL, NULL, NULL, 'PROLINE DEHYDROGENASE 2, MITOCHONDRIAL', 246439),
(366087, 'PTHR13914', NULL, NULL, NULL, NULL, 'PROLINE OXIDASE', 246439),
(366088, 'PTHR13914:SF29', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE DEHYDROGENASE', 246439),
(366089, 'PTHR13914:SF28', NULL, NULL, NULL, NULL, 'PROLINE DEHYDROGENASE', 246439),
(366090, 'PTHR13914:SF26', NULL, NULL, NULL, NULL, 'PROLINE DEHYDROGENASE', 246439),
(366091, 'PTHR13914:SF0', NULL, NULL, NULL, NULL, 'PROLINE DEHYDROGENASE 1, MITOCHONDRIAL', 246439),
(366092, 'PTHR13914:SF34', NULL, NULL, NULL, NULL, 'PROLINE DEHYDROGENASE', 246439),
(366093, 'PTHR13914:SF24', NULL, NULL, NULL, NULL, 'PROLINE DEHYDROGENASE', 246439),
(366094, 'PTHR13914:SF32', NULL, NULL, NULL, NULL, 'PROLINE DEHYDROGENASE', 246439),
(366095, 'PTHR13914:SF33', NULL, NULL, NULL, NULL, 'PROLINE DEHYDROGENASE', 246439),
(366096, 'PTHR45921:SF1', NULL, NULL, NULL, NULL, 'T-CELL LEUKEMIA HOMEOBOX PROTEIN 3', 246440),
(366097, 'PTHR45921', NULL, NULL, NULL, NULL, 'IP01054P', 246440),
(366098, 'PTHR45921:SF3', NULL, NULL, NULL, NULL, 'T-CELL LEUKEMIA HOMEOBOX PROTEIN 2', 246440),
(366099, 'PTHR45921:SF2', NULL, NULL, NULL, NULL, 'T-CELL LEUKEMIA HOMEOBOX PROTEIN 1', 246440),
(366100, 'PTHR45921:SF5', NULL, NULL, NULL, NULL, 'T CELL LEUKEMIA HOMEOBOX 2', 246440),
(366101, 'PTHR45921:SF4', NULL, NULL, NULL, NULL, 'IP01054P', 246440),
(366102, 'PTHR45921:SF6', NULL, NULL, NULL, NULL, 'C15', 246440),
(366103, 'PTHR14081', NULL, NULL, NULL, NULL, 'SPERM-ASSOCIATED ANTIGEN 11A-RELATED-RELATED', 246441),
(366104, 'PTHR14081:SF3', NULL, NULL, NULL, NULL, 'SPERM-ASSOCIATED ANTIGEN 11', 246441),
(366105, 'PTHR14081:SF1', NULL, NULL, NULL, NULL, 'SPERM-ASSOCIATED ANTIGEN 11A-RELATED', 246441),
(366106, 'PTHR36178:SF1', NULL, NULL, NULL, NULL, 'SODIUM/GLUTAMATE SYMPORTER', 246442),
(366107, 'PTHR36178', NULL, NULL, NULL, NULL, 'SLR0625 PROTEIN', 246442),
(366108, 'PTHR16023:SF4', NULL, NULL, NULL, NULL, 'VAC14_FIG4_BD DOMAIN-CONTAINING PROTEIN', 246443),
(366109, 'PTHR16023', NULL, NULL, NULL, NULL, 'TAX1 BINDING PROTEIN-RELATED', 246443),
(366110, 'PTHR16023:SF3', NULL, NULL, NULL, NULL, 'VAC14_FIG4_BD DOMAIN-CONTAINING PROTEIN', 246443),
(366111, 'PTHR16023:SF0', NULL, NULL, NULL, NULL, 'PROTEIN VAC14 HOMOLOG', 246443),
(366112, 'PTHR16023:SF1', NULL, NULL, NULL, NULL, 'PROTEIN VAC14 HOMOLOG', 246443),
(366113, 'PTHR47819', NULL, NULL, NULL, NULL, 'DENTIN SIALOPHOSPHOPROTEIN', 246444),
(366114, 'PTHR47819:SF1', NULL, NULL, NULL, NULL, 'DENTIN SIALOPHOSPHOPROTEIN', 246444),
(366115, 'PTHR33052:SF160', NULL, NULL, NULL, NULL, '', 246445),
(366116, 'PTHR33052:SF24', NULL, NULL, NULL, NULL, 'OS06G0568400 PROTEIN', 246445),
(366117, 'PTHR33052:SF68', NULL, NULL, NULL, NULL, 'OS03G0356526 PROTEIN', 246445),
(366118, 'PTHR33052:SF26', NULL, NULL, NULL, NULL, '6,7-DIMETHYL-8-RIBITYLLUMAZINE SYNTHASE', 246445),
(366119, 'PTHR33052:SF118', NULL, NULL, NULL, NULL, '', 246445),
(366120, 'PTHR33052:SF117', NULL, NULL, NULL, NULL, 'BNAA02G34750D PROTEIN', 246445),
(366121, 'PTHR33052:SF159', NULL, NULL, NULL, NULL, 'DUF4228 DOMAIN PROTEIN', 246445),
(366122, 'PTHR33052:SF158', NULL, NULL, NULL, NULL, '', 246445),
(366123, 'PTHR33052:SF157', NULL, NULL, NULL, NULL, 'BNAC08G19630D PROTEIN', 246445),
(366124, 'PTHR33052:SF113', NULL, NULL, NULL, NULL, 'DUF4228 DOMAIN PROTEIN', 246445);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(366125, 'PTHR33052:SF156', NULL, NULL, NULL, NULL, 'BNAA08G28790D PROTEIN', 246445),
(366126, 'PTHR33052:SF155', NULL, NULL, NULL, NULL, 'OS03G0768900 PROTEIN', 246445),
(366127, 'PTHR33052:SF198', NULL, NULL, NULL, NULL, '', 246445),
(366128, 'PTHR33052:SF197', NULL, NULL, NULL, NULL, '', 246445),
(366129, 'PTHR33052:SF196', NULL, NULL, NULL, NULL, '', 246445),
(366130, 'PTHR33052:SF152', NULL, NULL, NULL, NULL, '', 246445),
(366131, 'PTHR33052:SF173', NULL, NULL, NULL, NULL, '', 246445),
(366132, 'PTHR33052:SF172', NULL, NULL, NULL, NULL, '', 246445),
(366133, 'PTHR33052:SF170', NULL, NULL, NULL, NULL, '', 246445),
(366134, 'PTHR33052:SF126', NULL, NULL, NULL, NULL, '', 246445),
(366135, 'PTHR33052:SF77', NULL, NULL, NULL, NULL, '', 246445),
(366136, 'PTHR33052:SF123', NULL, NULL, NULL, NULL, '', 246445),
(366137, 'PTHR33052:SF166', NULL, NULL, NULL, NULL, 'BNAA09G07830D PROTEIN', 246445),
(366138, 'PTHR33052:SF72', NULL, NULL, NULL, NULL, '', 246445),
(366139, 'PTHR33052:SF122', NULL, NULL, NULL, NULL, '', 246445),
(366140, 'PTHR33052:SF165', NULL, NULL, NULL, NULL, '', 246445),
(366141, 'PTHR33052:SF71', NULL, NULL, NULL, NULL, '', 246445),
(366142, 'PTHR33052:SF164', NULL, NULL, NULL, NULL, 'OS07G0123100 PROTEIN', 246445),
(366143, 'PTHR33052:SF120', NULL, NULL, NULL, NULL, '', 246445),
(366144, 'PTHR33052:SF30', NULL, NULL, NULL, NULL, 'OS01G0165600 PROTEIN', 246445),
(366145, 'PTHR33052:SF140', NULL, NULL, NULL, NULL, 'BNAA09G41900D PROTEIN', 246445),
(366146, 'PTHR33052:SF184', NULL, NULL, NULL, NULL, 'BNAA05G32510D PROTEIN', 246445),
(366147, 'PTHR33052:SF183', NULL, NULL, NULL, NULL, '', 246445),
(366148, 'PTHR33052:SF182', NULL, NULL, NULL, NULL, '', 246445),
(366149, 'PTHR33052:SF181', NULL, NULL, NULL, NULL, '', 246445),
(366150, 'PTHR33052:SF180', NULL, NULL, NULL, NULL, 'OS06G0259800 PROTEIN', 246445),
(366151, 'PTHR33052', NULL, NULL, NULL, NULL, 'DUF4228 DOMAIN PROTEIN-RELATED', 246445),
(366152, 'PTHR33052:SF80', NULL, NULL, NULL, NULL, 'BNAC07G31880D PROTEIN', 246445),
(366153, 'PTHR33052:SF138', NULL, NULL, NULL, NULL, 'BNAC08G45070D PROTEIN', 246445),
(366154, 'PTHR33052:SF87', NULL, NULL, NULL, NULL, 'POLY POLYMERASE', 246445),
(366155, 'PTHR33052:SF137', NULL, NULL, NULL, NULL, '', 246445),
(366156, 'PTHR33052:SF135', NULL, NULL, NULL, NULL, 'BNAC03G58960D PROTEIN', 246445),
(366157, 'PTHR33052:SF134', NULL, NULL, NULL, NULL, 'BNAC03G16710D PROTEIN', 246445),
(366158, 'PTHR33052:SF178', NULL, NULL, NULL, NULL, 'BNAA01G22980D PROTEIN', 246445),
(366159, 'PTHR33052:SF177', NULL, NULL, NULL, NULL, 'OS05G0474700 PROTEIN', 246445),
(366160, 'PTHR33052:SF83', NULL, NULL, NULL, NULL, 'OS01G0304400 PROTEIN', 246445),
(366161, 'PTHR33052:SF133', NULL, NULL, NULL, NULL, 'BNAC03G58330D PROTEIN', 246445),
(366162, 'PTHR33052:SF84', NULL, NULL, NULL, NULL, 'DUF4228 DOMAIN PROTEIN', 246445),
(366163, 'PTHR33052:SF195', NULL, NULL, NULL, NULL, 'BNAA06G14850D PROTEIN', 246445),
(366164, 'PTHR33052:SF151', NULL, NULL, NULL, NULL, 'DUF4228 DOMAIN PROTEIN', 246445),
(366165, 'PTHR33052:SF150', NULL, NULL, NULL, NULL, 'OS02G0193100 PROTEIN', 246445),
(366166, 'PTHR33052:SF194', NULL, NULL, NULL, NULL, 'BNAC05G14040D PROTEIN', 246445),
(366167, 'PTHR33052:SF7', NULL, NULL, NULL, NULL, 'OS03G0298100 PROTEIN', 246445),
(366168, 'PTHR33052:SF193', NULL, NULL, NULL, NULL, 'BNAA08G15460D PROTEIN', 246445),
(366169, 'PTHR33052:SF192', NULL, NULL, NULL, NULL, 'OS01G0952900 PROTEIN', 246445),
(366170, 'PTHR33052:SF19', NULL, NULL, NULL, NULL, 'DUF4228 DOMAIN PROTEIN', 246445),
(366171, 'PTHR33052:SF191', NULL, NULL, NULL, NULL, '', 246445),
(366172, 'PTHR33052:SF14', NULL, NULL, NULL, NULL, 'OS01G0826800 PROTEIN', 246445),
(366173, 'PTHR33052:SF190', NULL, NULL, NULL, NULL, '', 246445),
(366174, 'PTHR33052:SF15', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR', 246445),
(366175, 'PTHR33052:SF4', NULL, NULL, NULL, NULL, 'DUF4228 DOMAIN PROTEIN', 246445),
(366176, 'PTHR33052:SF3', NULL, NULL, NULL, NULL, 'OS01G0758500 PROTEIN', 246445),
(366177, 'PTHR33052:SF2', NULL, NULL, NULL, NULL, 'OS06G0700300 PROTEIN', 246445);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(366178, 'PTHR33052:SF92', NULL, NULL, NULL, NULL, '', 246445),
(366179, 'PTHR33052:SF91', NULL, NULL, NULL, NULL, 'F3H9.15 PROTEIN', 246445),
(366180, 'PTHR33052:SF106', NULL, NULL, NULL, NULL, 'OS03G0844850 PROTEIN', 246445),
(366181, 'PTHR33052:SF149', NULL, NULL, NULL, NULL, 'BNAA03G55990D PROTEIN', 246445),
(366182, 'PTHR33052:SF147', NULL, NULL, NULL, NULL, 'BNAA03G53610D PROTEIN', 246445),
(366183, 'PTHR33052:SF146', NULL, NULL, NULL, NULL, 'BNAA07G12470D PROTEIN', 246445),
(366184, 'PTHR33052:SF102', NULL, NULL, NULL, NULL, 'TMV RESPONSE-RELATED PROTEIN', 246445),
(366185, 'PTHR33052:SF145', NULL, NULL, NULL, NULL, 'BNAANNG38710D PROTEIN', 246445),
(366186, 'PTHR33052:SF189', NULL, NULL, NULL, NULL, 'DUF4228 DOMAIN PROTEIN', 246445),
(366187, 'PTHR33052:SF101', NULL, NULL, NULL, NULL, 'AGAA.5', 246445),
(366188, 'PTHR33052:SF188', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR', 246445),
(366189, 'PTHR33052:SF100', NULL, NULL, NULL, NULL, '6,7-DIMETHYL-8-RIBITYLLUMAZINE SYNTHASE', 246445),
(366190, 'PTHR33052:SF93', NULL, NULL, NULL, NULL, '', 246445),
(366191, 'PTHR33052:SF143', NULL, NULL, NULL, NULL, 'BNAA02G18180D PROTEIN', 246445),
(366192, 'PTHR33052:SF187', NULL, NULL, NULL, NULL, '', 246445),
(366193, 'PTHR33052:SF96', NULL, NULL, NULL, NULL, 'OS05G0385400 PROTEIN', 246445),
(366194, 'PTHR33052:SF186', NULL, NULL, NULL, NULL, '', 246445),
(366195, 'PTHR33052:SF141', NULL, NULL, NULL, NULL, 'BNAA06G12440D PROTEIN', 246445),
(366196, 'PTHR33052:SF185', NULL, NULL, NULL, NULL, 'OS05G0552800 PROTEIN', 246445),
(366197, 'PTHR33052:SF95', NULL, NULL, NULL, NULL, 'OS01G0686000 PROTEIN', 246445),
(366198, 'PTHR23359:SF22', NULL, NULL, NULL, NULL, 'ADENYLATE KINASE', 246446),
(366199, 'PTHR23359:SF68', NULL, NULL, NULL, NULL, 'GTP:AMP PHOSPHOTRANSFERASE AK3, MITOCHONDRIAL', 246446),
(366200, 'PTHR23359:SF171', NULL, NULL, NULL, NULL, 'ADENYLATE KINASE-RELATED', 246446),
(366201, 'PTHR23359:SF252', NULL, NULL, NULL, NULL, '', 246446),
(366202, 'PTHR23359:SF251', NULL, NULL, NULL, NULL, 'ADENYLATE KINASE 6, CHLOROPLASTIC-RELATED', 246446),
(366203, 'PTHR23359:SF174', NULL, NULL, NULL, NULL, 'ADENYLATE KINASE', 246446),
(366204, 'PTHR23359:SF250', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 246446),
(366205, 'PTHR23359:SF173', NULL, NULL, NULL, NULL, 'ATP:AMP PHOSPHOTRANSFERASE', 246446),
(366206, 'PTHR23359:SF213', NULL, NULL, NULL, NULL, 'ADENYLATE KINASE', 246446),
(366207, 'PTHR23359:SF70', NULL, NULL, NULL, NULL, 'ADENYLATE KINASE 1, ISOFORM B', 246446),
(366208, 'PTHR23359:SF228', NULL, NULL, NULL, NULL, 'UMP-CMP KINASE 1', 246446),
(366209, 'PTHR23359:SF227', NULL, NULL, NULL, NULL, 'ADENYLATE KINASE 2, MITOCHONDRIAL', 246446),
(366210, 'PTHR23359:SF105', NULL, NULL, NULL, NULL, 'ADENYLATE KINASE 7', 246446),
(366211, 'PTHR23359:SF226', NULL, NULL, NULL, NULL, 'ATP:AMP PHOSPHOTRANSFERASE', 246446),
(366212, 'PTHR23359:SF225', NULL, NULL, NULL, NULL, 'NUCLEOSIDE-DIPHOSPHATE KINASE', 246446),
(366213, 'PTHR23359:SF148', NULL, NULL, NULL, NULL, 'ADENYLATE KINASE 9', 246446),
(366214, 'PTHR23359', NULL, NULL, NULL, NULL, 'NUCLEOTIDE KINASE', 246446),
(366215, 'PTHR23359:SF57', NULL, NULL, NULL, NULL, 'NUCLEOSIDE-DIPHOSPHATE KINASE', 246446),
(366216, 'PTHR23359:SF229', NULL, NULL, NULL, NULL, 'ADENYLATE KINASE', 246446),
(366217, 'PTHR23359:SF59', NULL, NULL, NULL, NULL, 'ADENYLATE KINASE ISOENZYME 1', 246446),
(366218, 'PTHR23359:SF58', NULL, NULL, NULL, NULL, 'ADENYLATE KINASE 4, MITOCHONDRIAL', 246446),
(366219, 'PTHR23359:SF182', NULL, NULL, NULL, NULL, 'ADENYLATE KINASE', 246446),
(366220, 'PTHR23359:SF181', NULL, NULL, NULL, NULL, 'ADENYLATE KINASE', 246446),
(366221, 'PTHR23359:SF187', NULL, NULL, NULL, NULL, 'ADENYLATE KINASE', 246446),
(366222, 'PTHR23359:SF220', NULL, NULL, NULL, NULL, 'ADENYLATE KINASE 1, CHLOROPLASTIC-RELATED', 246446),
(366223, 'PTHR23359:SF184', NULL, NULL, NULL, NULL, 'NUCLEOSIDE-DIPHOSPHATE KINASE', 246446),
(366224, 'PTHR23359:SF103', NULL, NULL, NULL, NULL, 'UMP-CMP KINASE 1', 246446),
(366225, 'PTHR23359:SF146', NULL, NULL, NULL, NULL, 'ADENYLATE KINASE', 246446);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(366226, 'PTHR23359:SF239', NULL, NULL, NULL, NULL, '', 246446),
(366227, 'PTHR23359:SF238', NULL, NULL, NULL, NULL, 'ATP:AMP PHOSPHOTRANSFERASE', 246446),
(366228, 'PTHR23359:SF237', NULL, NULL, NULL, NULL, 'UMP-CMP KINASE 3', 246446),
(366229, 'PTHR23359:SF86', NULL, NULL, NULL, NULL, 'ADENYLATE KINASE 7, MITOCHONDRIAL-RELATED', 246446),
(366230, 'PTHR23359:SF236', NULL, NULL, NULL, NULL, 'NUCLEOSIDE-DIPHOSPHATE KINASE', 246446),
(366231, 'PTHR23359:SF88', NULL, NULL, NULL, NULL, '', 246446),
(366232, 'PTHR23359:SF190', NULL, NULL, NULL, NULL, 'ATP:AMP PHOSPHOTRANSFERASE', 246446),
(366233, 'PTHR23359:SF150', NULL, NULL, NULL, NULL, 'UMP-CMP KINASE', 246446),
(366234, 'PTHR23359:SF194', NULL, NULL, NULL, NULL, 'ADENYLATE KINASE ISOENZYME 5-LIKE PROTEIN', 246446),
(366235, 'PTHR23359:SF191', NULL, NULL, NULL, NULL, 'ADENYLATE KINASE 4', 246446),
(366236, 'PTHR23359:SF198', NULL, NULL, NULL, NULL, 'ATP:AMP PHOSPHOTRANSFERASE', 246446),
(366237, 'PTHR23359:SF196', NULL, NULL, NULL, NULL, 'ATP:AMP PHOSPHOTRANSFERASE', 246446),
(366238, 'PTHR23359:SF234', NULL, NULL, NULL, NULL, 'ADENYLATE KINASE 2, MITOCHONDRIAL', 246446),
(366239, 'PTHR23359:SF111', NULL, NULL, NULL, NULL, 'PROTEIN CBG04516', 246446),
(366240, 'PTHR23359:SF206', NULL, NULL, NULL, NULL, 'UMP-CMP KINASE', 246446),
(366241, 'PTHR23359:SF205', NULL, NULL, NULL, NULL, 'ADENYLATE KINASE 1, CHLOROPLASTIC', 246446),
(366242, 'PTHR23359:SF249', NULL, NULL, NULL, NULL, 'NUCLEOSIDE-DIPHOSPHATE KINASE', 246446),
(366243, 'PTHR23359:SF248', NULL, NULL, NULL, NULL, 'NUCLEOSIDE-DIPHOSPHATE KINASE', 246446),
(366244, 'PTHR23359:SF247', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 206', 246446),
(366245, 'PTHR23359:SF203', NULL, NULL, NULL, NULL, 'ADENYLATE KINASE 6, CHLOROPLASTIC-RELATED', 246446),
(366246, 'PTHR23359:SF79', NULL, NULL, NULL, NULL, 'ADENYLATE KINASE ISOENZYME 5', 246446),
(366247, 'PTHR23359:SF208', NULL, NULL, NULL, NULL, 'UMP-CMP KINASE', 246446),
(366248, 'PTHR23359:SF160', NULL, NULL, NULL, NULL, '', 246446),
(366249, 'PTHR23359:SF165', NULL, NULL, NULL, NULL, 'GTP:AMP PHOSPHOTRANSFERASE AK3, MITOCHONDRIAL', 246446),
(366250, 'PTHR23359:SF242', NULL, NULL, NULL, NULL, 'GTP:AMP PHOSPHOTRANSFERASE, MITOCHONDRIAL', 246446),
(366251, 'PTHR23359:SF164', NULL, NULL, NULL, NULL, 'ADENYLATE KINASE 3', 246446),
(366252, 'PTHR23359:SF241', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 246446),
(366253, 'PTHR23359:SF240', NULL, NULL, NULL, NULL, 'UMP-CMP KINASE', 246446),
(366254, 'PTHR23359:SF246', NULL, NULL, NULL, NULL, 'UMP-CMP KINASE 2-RELATED', 246446),
(366255, 'PTHR23359:SF202', NULL, NULL, NULL, NULL, 'UMP-CMP KINASE', 246446),
(366256, 'PTHR23359:SF245', NULL, NULL, NULL, NULL, 'ATP:AMP PHOSPHOTRANSFERASE', 246446),
(366257, 'PTHR23359:SF244', NULL, NULL, NULL, NULL, 'ATP:AMP PHOSPHOTRANSFERASE', 246446),
(366258, 'PTHR23359:SF167', NULL, NULL, NULL, NULL, 'ADENYLATE KINASE 5, CHLOROPLASTIC', 246446),
(366259, 'PTHR23359:SF200', NULL, NULL, NULL, NULL, 'ATP:AMP PHOSPHOTRANSFERASE', 246446),
(366260, 'PTHR23359:SF166', NULL, NULL, NULL, NULL, 'UMP-CMP KINASE', 246446),
(366261, 'PTHR23359:SF81', NULL, NULL, NULL, NULL, 'ADENYLATE KINASE 8', 246446),
(366262, 'PTHR23359:SF243', NULL, NULL, NULL, NULL, '', 246446),
(366263, 'PTHR28037:SF2', NULL, NULL, NULL, NULL, 'ACR018CP', 246447),
(366264, 'PTHR28037:SF1', NULL, NULL, NULL, NULL, 'ALCOHOL O-ACETYLTRANSFERASE 1-RELATED', 246447),
(366265, 'PTHR28037', NULL, NULL, NULL, NULL, 'ALCOHOL O-ACETYLTRANSFERASE 1-RELATED', 246447),
(366266, 'PTHR25466:SF9', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 246448),
(366267, 'PTHR25466:SF4', NULL, NULL, NULL, NULL, 'T-LYMPHOCYTE ACTIVATION ANTIGEN CD80', 246448),
(366268, 'PTHR25466:SF3', NULL, NULL, NULL, NULL, 'PROGRAMMED CELL DEATH 1 LIGAND 1', 246448),
(366269, 'PTHR25466:SF2', NULL, NULL, NULL, NULL, 'T-LYMPHOCYTE ACTIVATION ANTIGEN CD86', 246448),
(366270, 'PTHR25466:SF1', NULL, NULL, NULL, NULL, 'PROGRAMMED CELL DEATH 1 LIGAND 2', 246448),
(366271, 'PTHR25466:SF12', NULL, NULL, NULL, NULL, '', 246448);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(366272, 'PTHR25466:SF11', NULL, NULL, NULL, NULL, 'GALECTIN 17-RELATED', 246448),
(366273, 'PTHR25466:SF15', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 246448),
(366274, 'PTHR25466:SF14', NULL, NULL, NULL, NULL, 'HERV-H LTR-ASSOCIATING 2A, TANDEM DUPLICATE 1-RELATED', 246448),
(366275, 'PTHR25466:SF13', NULL, NULL, NULL, NULL, 'SI:DKEYP-77H1.4', 246448),
(366276, 'PTHR25466', NULL, NULL, NULL, NULL, 'T-LYMPHOCYTE ACTIVATION ANTIGEN', 246448),
(366277, 'PTHR21382:SF1', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX SUBUNIT 11', 246449),
(366278, 'PTHR21382', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE SUBUNIT', 246449),
(366279, 'PTHR22934', NULL, NULL, NULL, NULL, 'PROTEIN ESC1/WETA-RELATED', 246450),
(366280, 'PTHR22934:SF13', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 246450),
(366281, 'PTHR22934:SF24', NULL, NULL, NULL, NULL, '', 246450),
(366282, 'PTHR22934:SF23', NULL, NULL, NULL, NULL, 'DEVELOPMENTAL REGULATORY PROTEIN WETA', 246450),
(366283, 'PTHR46358:SF1', NULL, NULL, NULL, NULL, 'TONSOKU-LIKE PROTEIN', 246451),
(366284, 'PTHR46358', NULL, NULL, NULL, NULL, 'TONSOKU-LIKE PROTEIN', 246451),
(366285, 'PTHR15099', NULL, NULL, NULL, NULL, 'PROTEIN PM1', 246452),
(366286, 'PTHR15099:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 11, MITOCHONDRIAL', 246452),
(366287, 'PTHR11117', NULL, NULL, NULL, NULL, 'SUCCINYL-COA LIGASE SUBUNIT ALPHA', 246453),
(366288, 'PTHR11117:SF3', NULL, NULL, NULL, NULL, 'SUCCINATE--COA LIGASE [ADP/GDP-FORMING] SUBUNIT ALPHA, MITOCHONDRIAL', 246453),
(366289, 'PTHR11117:SF19', NULL, NULL, NULL, NULL, 'SUCCINATE--COA LIGASE [ADP-FORMING] SUBUNIT ALPHA-1, MITOCHONDRIAL', 246453),
(366290, 'PTHR11117:SF2', NULL, NULL, NULL, NULL, 'SUCCINATE--COA LIGASE [ADP/GDP-FORMING] SUBUNIT ALPHA, MITOCHONDRIAL', 246453),
(366291, 'PTHR11117:SF20', NULL, NULL, NULL, NULL, 'SUCCINATE--COA LIGASE [ADP-FORMING] SUBUNIT ALPHA, MITOCHONDRIAL', 246453),
(366292, 'PTHR11117:SF6', NULL, NULL, NULL, NULL, 'SYNTHETASE SUBUNIT ALPHA, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G10830)-RELATED', 246453),
(366293, 'PTHR11117:SF24', NULL, NULL, NULL, NULL, 'PROTEIN FDRA', 246453),
(366294, 'PTHR11117:SF23', NULL, NULL, NULL, NULL, 'SUCCINATE--COA LIGASE [ADP-FORMING] SUBUNIT ALPHA-2, MITOCHONDRIAL', 246453),
(366295, 'PTHR35775:SF2', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I REACTION CENTER SUBUNIT VIII', 246454),
(366296, 'PTHR35775', NULL, NULL, NULL, NULL, '', 246454),
(366297, 'PTHR13930', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT TRNA 4-DEMETHYLWYOSINE SYNTHASE', 246455),
(366298, 'PTHR13930:SF0', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT TRNA 4-DEMETHYLWYOSINE SYNTHASE TYW1-RELATED', 246455),
(366299, 'PTHR13930:SF1', NULL, NULL, NULL, NULL, 'SAM DOMAIN PROTEIN, PUTATIVE-RELATED', 246455),
(366300, 'PTHR15666', NULL, NULL, NULL, NULL, 'COMM DOMAIN CONTAINING PROTEIN 5', 246456),
(366301, 'PTHR15666:SF3', NULL, NULL, NULL, NULL, 'COMM DOMAIN-CONTAINING PROTEIN 5', 246456),
(366302, 'PTHR15666:SF2', NULL, NULL, NULL, NULL, 'COMM DOMAIN-CONTAINING PROTEIN 5', 246456),
(366303, 'PTHR15666:SF1', NULL, NULL, NULL, NULL, 'COMM DOMAIN-CONTAINING PROTEIN 5', 246456),
(366304, 'PTHR13257:SF0', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP88', 246457),
(366305, 'PTHR13257', NULL, NULL, NULL, NULL, 'NUCLEOPORIN NUP84-RELATED', 246457),
(366306, 'PTHR31036:SF0', NULL, NULL, NULL, NULL, 'FANCD2 OPPOSITE STRAND PROTEIN', 246458),
(366307, 'PTHR31036', NULL, NULL, NULL, NULL, 'FANCD2 OPPOSITE STRAND PROTEIN', 246458),
(366308, 'PTHR46041:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL INNER MEMBRANE PROTEASE SUBUNIT 2', 246459),
(366309, 'PTHR46041:SF2', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL INNER MEMBRANE PROTEASE SUBUNIT 2', 246459),
(366310, 'PTHR46041:SF3', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL INNER MEMBRANE PROTEASE SUBUNIT 2', 246459),
(366311, 'PTHR46041:SF4', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL INNER MEMBRANE PROTEASE SUBUNIT 2', 246459),
(366312, 'PTHR46041', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL INNER MEMBRANE PROTEASE SUBUNIT 2', 246459);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(366313, 'PTHR45689', NULL, NULL, NULL, NULL, 'I[[H]] CHANNEL, ISOFORM E', 246460),
(366314, 'PTHR45689:SF13', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 246460),
(366315, 'PTHR45689:SF12', NULL, NULL, NULL, NULL, 'HYPERPOLARIZATION-ACTIVATED CYCLIC NUCLEOTIDE-GATED POTASSIUM CHANNEL 3', 246460),
(366316, 'PTHR45689:SF3', NULL, NULL, NULL, NULL, 'POTASSIUM/SODIUM HYPERPOLARIZATION-ACTIVATED CYCLIC NUCLEOTIDE-GATED CHANNEL 1', 246460),
(366317, 'PTHR45689:SF11', NULL, NULL, NULL, NULL, 'POTASSIUM/SODIUM HYPERPOLARIZATION-ACTIVATED CYCLIC NUCLEOTIDE-GATED CHANNEL 2', 246460),
(366318, 'PTHR45689:SF4', NULL, NULL, NULL, NULL, 'POTASSIUM/SODIUM HYPERPOLARIZATION-ACTIVATED CYCLIC NUCLEOTIDE-GATED CHANNEL 4', 246460),
(366319, 'PTHR45689:SF5', NULL, NULL, NULL, NULL, 'I[[H]] CHANNEL, ISOFORM E', 246460),
(366320, 'PTHR45689:SF7', NULL, NULL, NULL, NULL, 'POTASSIUM/SODIUM HYPERPOLARIZATION-ACTIVATED CYCLIC NUCLEOTIDE-GATED CHANNEL 3', 246460),
(366321, 'PTHR45689:SF14', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED CATION CHANNEL SUBUNIT A-LIKE PROTEIN', 246460),
(366322, 'PTHR45689:SF8', NULL, NULL, NULL, NULL, 'HYPERPOLARIZATION-ACTIVATED CYCLIC NUCLEOTIDE-GATED POTASSIUM CHANNEL 5', 246460),
(366323, 'PTHR15723:SF0', NULL, NULL, NULL, NULL, 'CARBOHYDRATE SULFOTRANSFERASE 15', 246461),
(366324, 'PTHR15723', NULL, NULL, NULL, NULL, 'CARBOHYDRATE SULFOTRANSFERASE 15', 246461),
(366325, 'PTHR47038:SF5', NULL, NULL, NULL, NULL, 'ABC-2 TYPE TRANSPORTER-RELATED', 246462),
(366326, 'PTHR47038:SF4', NULL, NULL, NULL, NULL, 'BAG-ASSOCIATED GRAM PROTEIN 1-LIKE', 246462),
(366327, 'PTHR47038:SF3', NULL, NULL, NULL, NULL, '', 246462),
(366328, 'PTHR47038:SF2', NULL, NULL, NULL, NULL, 'BAG-ASSOCIATED GRAM PROTEIN 1', 246462),
(366329, 'PTHR47038:SF1', NULL, NULL, NULL, NULL, 'BAG-ASSOCIATED GRAM PROTEIN 1', 246462),
(366330, 'PTHR47038', NULL, NULL, NULL, NULL, 'BAG-ASSOCIATED GRAM PROTEIN 1', 246462),
(366331, 'PTHR43322:SF9', NULL, NULL, NULL, NULL, '1-DEOXY-D-XYLULOSE-5-PHOSPHATE SYNTHASE', 246463),
(366332, 'PTHR43322:SF8', NULL, NULL, NULL, NULL, '1-DEOXY-D-XYLULOSE-5-PHOSPHATE SYNTHASE', 246463),
(366333, 'PTHR43322:SF7', NULL, NULL, NULL, NULL, '1-DEOXY-D-XYLULOSE-5-PHOSPHATE SYNTHASE', 246463),
(366334, 'PTHR43322:SF1', NULL, NULL, NULL, NULL, '1-DEOXY-D-XYLULOSE-5-PHOSPHATE SYNTHASE', 246463),
(366335, 'PTHR43322:SF6', NULL, NULL, NULL, NULL, '1-DEOXY-D-XYLULOSE-5-PHOSPHATE SYNTHASE', 246463),
(366336, 'PTHR43322:SF5', NULL, NULL, NULL, NULL, '1-DEOXY-D-XYLULOSE-5-PHOSPHATE SYNTHASE, CHLOROPLASTIC', 246463),
(366337, 'PTHR43322', NULL, NULL, NULL, NULL, '1-D-DEOXYXYLULOSE 5-PHOSPHATE SYNTHASE-RELATED', 246463),
(366338, 'PTHR43322:SF4', NULL, NULL, NULL, NULL, '1-DEOXY-D-XYLULOSE-5-PHOSPHATE SYNTHASE 2, CHLOROPLASTIC-RELATED', 246463),
(366339, 'PTHR43322:SF3', NULL, NULL, NULL, NULL, '1-DEOXY-D-XYLULOSE-5-PHOSPHATE SYNTHASE', 246463),
(366340, 'PTHR15350:SF15', NULL, NULL, NULL, NULL, 'COMPLEX SUBUNIT 7A, PUTATIVE-RELATED', 246464),
(366341, 'PTHR15350:SF14', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT M', 246464),
(366342, 'PTHR15350', NULL, NULL, NULL, NULL, 'COP9 SIGNALOSOME COMPLEX SUBUNIT 7/DENDRITIC CELL PROTEIN GA17', 246464),
(366343, 'PTHR15350:SF10', NULL, NULL, NULL, NULL, 'COP9 CONSTITUTIVE PHOTOMORPHOGENIC HOMOLOG SUBUNIT 7A', 246464),
(366344, 'PTHR15350:SF2', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT M', 246464),
(366345, 'PTHR15350:SF8', NULL, NULL, NULL, NULL, 'COP9 SIGNALOSOME COMPLEX SUBUNIT 7B', 246464),
(366346, 'PTHR15350:SF7', NULL, NULL, NULL, NULL, 'COP9 SIGNALOSOME COMPLEX SUBUNIT 7A', 246464),
(366347, 'PTHR15350:SF5', NULL, NULL, NULL, NULL, 'COP9 SIGNALOSOME COMPLEX SUBUNIT 7', 246464),
(366348, 'PTHR35454', NULL, NULL, NULL, NULL, 'AGAP005206-PA', 246465),
(366349, 'PTHR35454:SF2', NULL, NULL, NULL, NULL, 'AGAP005206-PA', 246465),
(366350, 'PTHR36317', NULL, NULL, NULL, NULL, 'PROTEIN MULTIPLE CHLOROPLAST DIVISION SITE 1', 246466),
(366351, 'PTHR36317:SF1', NULL, NULL, NULL, NULL, 'PROTEIN MULTIPLE CHLOROPLAST DIVISION SITE 1', 246466);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(366352, 'PTHR42037:SF1', NULL, NULL, NULL, NULL, '', 246467),
(366353, 'PTHR42037', NULL, NULL, NULL, NULL, '', 246467),
(366354, 'PTHR47668:SF1', NULL, NULL, NULL, NULL, 'DLH DOMAIN-CONTAINING PROTEIN-RELATED', 246468),
(366355, 'PTHR47668', NULL, NULL, NULL, NULL, 'DIENELACTONE HYDROLASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_6G01940)', 246468),
(366356, 'PTHR11142:SF26', NULL, NULL, NULL, NULL, 'SYNTHASE I, PUTATIVE-RELATED', 246469),
(366357, 'PTHR11142:SF27', NULL, NULL, NULL, NULL, 'PSEUDOU_SYNTH_1 DOMAIN-CONTAINING PROTEIN', 246469),
(366358, 'PTHR11142:SF28', NULL, NULL, NULL, NULL, 'TRNA PSEUDOURIDINE SYNTHASE 2', 246469),
(366359, 'PTHR11142:SF29', NULL, NULL, NULL, NULL, 'OS06G0663100 PROTEIN', 246469),
(366360, 'PTHR11142:SF0', NULL, NULL, NULL, NULL, 'TRNA PSEUDOURIDINE SYNTHASE-LIKE 1', 246469),
(366361, 'PTHR11142:SF22', NULL, NULL, NULL, NULL, 'TRNA PSEUDOURIDINE SYNTHASE A 2', 246469),
(366362, 'PTHR11142:SF5', NULL, NULL, NULL, NULL, 'TRNA PSEUDOURIDINE(38/39) SYNTHASE', 246469),
(366363, 'PTHR11142:SF4', NULL, NULL, NULL, NULL, 'TRNA PSEUDOURIDINE SYNTHASE A', 246469),
(366364, 'PTHR11142:SF25', NULL, NULL, NULL, NULL, 'PSEUDOU_SYNTH_1 DOMAIN-CONTAINING PROTEIN', 246469),
(366365, 'PTHR11142:SF9', NULL, NULL, NULL, NULL, 'TRNA PSEUDOURIDINE SYNTHASE-RELATED', 246469),
(366366, 'PTHR11142', NULL, NULL, NULL, NULL, 'PSEUDOURIDYLATE SYNTHASE', 246469),
(366367, 'PTHR11142:SF21', NULL, NULL, NULL, NULL, 'TRNA PSEUDOURIDINE SYNTHASE', 246469),
(366368, 'PTHR11142:SF10', NULL, NULL, NULL, NULL, 'TRNA PSEUDOURIDINE SYNTHASE', 246469),
(366369, 'PTHR44227', NULL, NULL, NULL, NULL, '', 246470),
(366370, 'PTHR44227:SF3', NULL, NULL, NULL, NULL, 'PROTEIN O-MANNOSYL-TRANSFERASE TMTC4', 246470),
(366371, 'PTHR21145:SF15', NULL, NULL, NULL, NULL, 'CHORISMATE MUTASE 3, CHLOROPLASTIC', 246471),
(366372, 'PTHR21145:SF16', NULL, NULL, NULL, NULL, 'CHORISMATE MUTASE', 246471),
(366373, 'PTHR21145:SF12', NULL, NULL, NULL, NULL, 'CHORISMATE MUTASE', 246471),
(366374, 'PTHR21145:SF0', NULL, NULL, NULL, NULL, 'CHORISMATE MUTASE 1, CHLOROPLASTIC', 246471),
(366375, 'PTHR21145:SF10', NULL, NULL, NULL, NULL, 'CHORISMATE MUTASE', 246471),
(366376, 'PTHR21145:SF9', NULL, NULL, NULL, NULL, 'CHORISMATE MUTASE', 246471),
(366377, 'PTHR21145', NULL, NULL, NULL, NULL, 'CHORISMATE MUTASE', 246471),
(366378, 'PTHR21145:SF8', NULL, NULL, NULL, NULL, 'CHORISMATE MUTASE', 246471),
(366379, 'PTHR34090', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L52, MITOCHONDRIAL', 246472),
(366380, 'PTHR34090:SF1', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L52, MITOCHONDRIAL', 246472),
(366381, 'PTHR11377:SF21', NULL, NULL, NULL, NULL, 'GLYCYLPEPTIDE N-TETRADECANOYLTRANSFERASE', 246473),
(366382, 'PTHR11377', NULL, NULL, NULL, NULL, 'N-MYRISTOYL TRANSFERASE', 246473),
(366383, 'PTHR11377:SF14', NULL, NULL, NULL, NULL, 'GLYCYLPEPTIDE N-TETRADECANOYLTRANSFERASE 2', 246473),
(366384, 'PTHR11377:SF22', NULL, NULL, NULL, NULL, 'GLYCYLPEPTIDE N-TETRADECANOYLTRANSFERASE', 246473),
(366385, 'PTHR11377:SF23', NULL, NULL, NULL, NULL, 'GLYCYLPEPTIDE N-TETRADECANOYLTRANSFERASE', 246473),
(366386, 'PTHR11377:SF17', NULL, NULL, NULL, NULL, 'GLYCYLPEPTIDE N-TETRADECANOYLTRANSFERASE 1-RELATED', 246473),
(366387, 'PTHR11377:SF7', NULL, NULL, NULL, NULL, 'GLYCYLPEPTIDE N-TETRADECANOYLTRANSFERASE 1', 246473),
(366388, 'PTHR11377:SF5', NULL, NULL, NULL, NULL, 'GLYCYLPEPTIDE N-TETRADECANOYLTRANSFERASE', 246473),
(366389, 'PTHR28290:SF1', NULL, NULL, NULL, NULL, 'ENHANCER OF TRANSLATION TERMINATION 1', 246474),
(366390, 'PTHR28290', NULL, NULL, NULL, NULL, 'ENHANCER OF TRANSLATION TERMINATION 1', 246474),
(366391, 'PTHR12619:SF33', NULL, NULL, NULL, NULL, 'RFX, ISOFORM H', 246475),
(366392, 'PTHR12619:SF23', NULL, NULL, NULL, NULL, 'MHC CLASS II REGULATORY FACTOR RFX1', 246475),
(366393, 'PTHR12619:SF2', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN RFX7', 246475),
(366394, 'PTHR12619:SF31', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR RFX4', 246475),
(366395, 'PTHR12619:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR RFX4', 246475);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(366396, 'PTHR12619:SF20', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR RFX3', 246475),
(366397, 'PTHR12619:SF21', NULL, NULL, NULL, NULL, 'RFX-TYPE WINGED-HELIX DOMAIN-CONTAINING PROTEIN', 246475),
(366398, 'PTHR12619:SF32', NULL, NULL, NULL, NULL, 'RFX-TYPE WINGED-HELIX DOMAIN-CONTAINING PROTEIN', 246475),
(366399, 'PTHR12619', NULL, NULL, NULL, NULL, 'RFX TRANSCRIPTION FACTOR FAMILY', 246475),
(366400, 'PTHR12619:SF28', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN RFX6', 246475),
(366401, 'PTHR12619:SF17', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN RFX2', 246475),
(366402, 'PTHR12619:SF18', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN RFX5', 246475),
(366403, 'PTHR12619:SF24', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN RFX8', 246475),
(366404, 'PTHR24321:SF12', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/REDUCTASE FAMILY, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G14340)-RELATED', 246476),
(366405, 'PTHR24321:SF8', NULL, NULL, NULL, NULL, 'DEHYDROGENASES, SHORT CHAIN', 246476),
(366406, 'PTHR24321:SF13', NULL, NULL, NULL, NULL, '2,3-DIHYDRO-2,3-DIHYDROXYBENZOATE DEHYDROGENASE', 246476),
(366407, 'PTHR24321:SF14', NULL, NULL, NULL, NULL, 'SHORT-CHAIN TYPE DEHYDROGENASE/REDUCTASE BLR2146-RELATED', 246476),
(366408, 'PTHR24321:SF15', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE UCPA', 246476),
(366409, 'PTHR24321:SF9', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER PROTEIN] REDUCTASE', 246476),
(366410, 'PTHR24321:SF11', NULL, NULL, NULL, NULL, 'BLR0893 PROTEIN', 246476),
(366411, 'PTHR24321', NULL, NULL, NULL, NULL, 'DEHYDROGENASES, SHORT CHAIN', 246476),
(366412, 'PTHR23416', NULL, NULL, NULL, NULL, 'SIALIC ACID SYNTHASE-RELATED', 246477),
(366413, 'PTHR23416:SF77', NULL, NULL, NULL, NULL, 'MANNOSE-1-PHOSPHATE GUANYLYLTRANSFERASE', 246477),
(366414, 'PTHR23416:SF54', NULL, NULL, NULL, NULL, 'MAC DOMAIN-CONTAINING PROTEIN-RELATED', 246477),
(366415, 'PTHR23416:SF76', NULL, NULL, NULL, NULL, 'MANNOSE-1-PHOSPHATE GUANYLYLTRANSFERASE', 246477),
(366416, 'PTHR23416:SF23', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE C18B11.09C-RELATED', 246477),
(366417, 'PTHR42047', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G03560)-RELATED', 246478),
(366418, 'PTHR42047:SF1', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G03560)-RELATED', 246478),
(366419, 'PTHR13645:SF0', NULL, NULL, NULL, NULL, 'DEFENSIN', 246479),
(366420, 'PTHR13645', NULL, NULL, NULL, NULL, 'DEFENSIN', 246479),
(366421, 'PTHR46647', NULL, NULL, NULL, NULL, 'RAB9 EFFECTOR PROTEIN WITH KELCH MOTIFS', 246480),
(366422, 'PTHR46647:SF1', NULL, NULL, NULL, NULL, 'RAB9 EFFECTOR PROTEIN WITH KELCH MOTIFS', 246480),
(366423, 'PTHR45884:SF5', NULL, NULL, NULL, NULL, 'BNAA08G12500D PROTEIN', 246481),
(366424, 'PTHR45884:SF2', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE ECO', 246481),
(366425, 'PTHR45884:SF3', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE ESCO2', 246481),
(366426, 'PTHR45884:SF1', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE ESCO1', 246481),
(366427, 'PTHR45884', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE ECO', 246481),
(366428, 'PTHR31187:SF13', NULL, NULL, NULL, NULL, 'ADP,ATP CARRIER PROTEIN 1, CHLOROPLASTIC', 246482),
(366429, 'PTHR31187:SF9', NULL, NULL, NULL, NULL, 'ADP,ATP CARRIER PROTEIN', 246482),
(366430, 'PTHR31187:SF14', NULL, NULL, NULL, NULL, 'ADP,ATP CARRIER PROTEIN 2, CHLOROPLASTIC', 246482),
(366431, 'PTHR31187:SF3', NULL, NULL, NULL, NULL, 'ADP,ATP CARRIER PROTEIN', 246482),
(366432, 'PTHR31187:SF1', NULL, NULL, NULL, NULL, 'ADP,ATP CARRIER PROTEIN 1', 246482),
(366433, 'PTHR31187', NULL, NULL, NULL, NULL, '', 246482),
(366434, 'PTHR31187:SF7', NULL, NULL, NULL, NULL, 'ADP,ATP CARRIER PROTEIN', 246482),
(366435, 'PTHR37348:SF1', NULL, NULL, NULL, NULL, 'SPERM-EGG FUSION PROTEIN LLCFC1', 246483),
(366436, 'PTHR37348', NULL, NULL, NULL, NULL, 'LLLL AND CFNLAS MOTIF-CONTAINING PROTEIN 1', 246483),
(366437, 'PTHR34467:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 246484),
(366438, 'PTHR34467:SF2', NULL, NULL, NULL, NULL, 'OS01G0705400 PROTEIN', 246484),
(366439, 'PTHR34467', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 246484);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(366440, 'PTHR34467:SF3', NULL, NULL, NULL, NULL, '', 246484),
(366441, 'PTHR34467:SF4', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 246484),
(366442, 'PTHR34467:SF6', NULL, NULL, NULL, NULL, '', 246484),
(366443, 'PTHR31495:SF32', NULL, NULL, NULL, NULL, 'BNAC06G31770D PROTEIN', 246485),
(366444, 'PTHR31495:SF33', NULL, NULL, NULL, NULL, 'CALCIUM ION BINDING PROTEIN', 246485),
(366445, 'PTHR31495:SF34', NULL, NULL, NULL, NULL, 'OS03G0222600 PROTEIN', 246485),
(366446, 'PTHR31495:SF35', NULL, NULL, NULL, NULL, 'BNAA04G19410D PROTEIN', 246485),
(366447, 'PTHR31495:SF14', NULL, NULL, NULL, NULL, 'CALEOSIN', 246485),
(366448, 'PTHR31495:SF15', NULL, NULL, NULL, NULL, 'CALEOSIN', 246485),
(366449, 'PTHR31495:SF37', NULL, NULL, NULL, NULL, 'CALEOSIN-RELATED PROTEIN-RELATED', 246485),
(366450, 'PTHR31495:SF38', NULL, NULL, NULL, NULL, 'BNAC07G13170D PROTEIN', 246485),
(366451, 'PTHR31495:SF17', NULL, NULL, NULL, NULL, 'CALEOSIN', 246485),
(366452, 'PTHR31495:SF30', NULL, NULL, NULL, NULL, 'PEROXYGENASE 2', 246485),
(366453, 'PTHR31495:SF19', NULL, NULL, NULL, NULL, 'ABA-INDUCED PROTEIN', 246485),
(366454, 'PTHR31495:SF21', NULL, NULL, NULL, NULL, 'CALEOSIN', 246485),
(366455, 'PTHR31495:SF43', NULL, NULL, NULL, NULL, 'BNAC02G20100D PROTEIN', 246485),
(366456, 'PTHR31495:SF44', NULL, NULL, NULL, NULL, 'ABA-INDUCED PROTEIN', 246485),
(366457, 'PTHR31495:SF45', NULL, NULL, NULL, NULL, 'PEROXYGENASE 5 ISOFORM X1-RELATED', 246485),
(366458, 'PTHR31495:SF23', NULL, NULL, NULL, NULL, 'PEROXYGENASE 3-RELATED', 246485),
(366459, 'PTHR31495:SF24', NULL, NULL, NULL, NULL, 'PEROXYGENASE 5-RELATED', 246485),
(366460, 'PTHR31495:SF46', NULL, NULL, NULL, NULL, '', 246485),
(366461, 'PTHR31495:SF25', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 246485),
(366462, 'PTHR31495:SF47', NULL, NULL, NULL, NULL, 'PEROXYGENASE 1', 246485),
(366463, 'PTHR31495:SF26', NULL, NULL, NULL, NULL, 'PEROXYGENASE 4-RELATED', 246485),
(366464, 'PTHR31495:SF27', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING PROTEIN', 246485),
(366465, 'PTHR31495:SF20', NULL, NULL, NULL, NULL, 'CALEOSIN-RELATED FAMILY PROTEIN', 246485),
(366466, 'PTHR31495:SF4', NULL, NULL, NULL, NULL, 'OS06G0254600 PROTEIN', 246485),
(366467, 'PTHR31495:SF2', NULL, NULL, NULL, NULL, 'OS02G0734600 PROTEIN', 246485),
(366468, 'PTHR31495:SF1', NULL, NULL, NULL, NULL, 'INACTIVE PEROXYGENASE-LIKE PROTEIN-RELATED', 246485),
(366469, 'PTHR31495:SF0', NULL, NULL, NULL, NULL, 'PEROXYGENASE 3-RELATED', 246485),
(366470, 'PTHR31495', NULL, NULL, NULL, NULL, 'PEROXYGENASE 3-RELATED', 246485),
(366471, 'PTHR24407', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246486),
(366472, 'PTHR24407:SF14', NULL, NULL, NULL, NULL, 'SIR2_2 DOMAIN-CONTAINING PROTEIN', 246486),
(366473, 'PTHR39670:SF2', NULL, NULL, NULL, NULL, '', 246487),
(366474, 'PTHR39670:SF4', NULL, NULL, NULL, NULL, '', 246487),
(366475, 'PTHR39670', NULL, NULL, NULL, NULL, '', 246487),
(366476, 'PTHR14470', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE III DOMAIN-CONTAINING PROTEIN', 246488),
(366477, 'PTHR14470:SF2', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE III DOMAIN-CONTAINING PROTEIN 4', 246488),
(366478, 'PTHR14470:SF1', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE III DOMAIN-CONTAINING PROTEIN 5', 246488),
(366479, 'PTHR14470:SF3', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE-III DOMAIN-CONTAINING PROTEIN', 246488),
(366480, 'PTHR31457', NULL, NULL, NULL, NULL, 'METHYLMALONIC ACIDURIA AND HOMOCYSTINURIA TYPE C PROTEIN', 246489),
(366481, 'PTHR31457:SF2', NULL, NULL, NULL, NULL, 'CYANOCOBALAMIN REDUCTASE / ALKYLCOBALAMIN DEALKYLASE', 246489),
(366482, 'PTHR38224:SF3', NULL, NULL, NULL, NULL, '', 246490),
(366483, 'PTHR38224', NULL, NULL, NULL, NULL, 'PHLOEM SPECIFIC PROTEIN', 246490),
(366484, 'PTHR38224:SF2', NULL, NULL, NULL, NULL, '', 246490),
(366485, 'PTHR38224:SF1', NULL, NULL, NULL, NULL, 'PHLOEM SPECIFIC PROTEIN', 246490),
(366486, 'PTHR40407:SF1', NULL, NULL, NULL, NULL, 'DUF1624 DOMAIN-CONTAINING PROTEIN', 246491),
(366487, 'PTHR40407', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-LIKE PROTEIN', 246491);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(366488, 'PTHR43514', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER I FAMILY MEMBER 10', 246492),
(366489, 'PTHR43514:SF10', NULL, NULL, NULL, NULL, 'MOLYBDENUM IMPORT ATP-BINDING PROTEIN MODC 2', 246492),
(366490, 'PTHR43514:SF4', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER I FAMILY MEMBER 10', 246492),
(366491, 'PTHR43514:SF3', NULL, NULL, NULL, NULL, 'SULFATE/THIOSULFATE IMPORT ATP-BINDING PROTEIN CYSA', 246492),
(366492, 'PTHR43514:SF11', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER RELATED', 246492),
(366493, 'PTHR43514:SF1', NULL, NULL, NULL, NULL, 'SULFATE/THIOSULFATE IMPORT ATP-BINDING PROTEIN CYSA', 246492),
(366494, 'PTHR24334:SF2', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN GBX-1', 246493),
(366495, 'PTHR24334:SF3', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN GBX-2', 246493),
(366496, 'PTHR24334', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN GBX', 246493),
(366497, 'PTHR24334:SF0', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN UNPLUGGED', 246493),
(366498, 'PTHR35330', NULL, NULL, NULL, NULL, 'SIROHEME BIOSYNTHESIS PROTEIN MET8', 246494),
(366499, 'PTHR35330:SF1', NULL, NULL, NULL, NULL, 'SIROHEME BIOSYNTHESIS PROTEIN MET8', 246494),
(366500, 'PTHR33349:SF24', NULL, NULL, NULL, NULL, 'CAM_BINDING DOMAIN-CONTAINING PROTEIN', 246495),
(366501, 'PTHR33349:SF25', NULL, NULL, NULL, NULL, 'CAM_BINDING DOMAIN-CONTAINING PROTEIN', 246495),
(366502, 'PTHR33349:SF26', NULL, NULL, NULL, NULL, 'CAM_BINDING DOMAIN-CONTAINING PROTEIN', 246495),
(366503, 'PTHR33349:SF20', NULL, NULL, NULL, NULL, 'CHROMO DOMAIN CEC-LIKE PROTEIN', 246495),
(366504, 'PTHR33349:SF21', NULL, NULL, NULL, NULL, 'OS02G0462200 PROTEIN', 246495),
(366505, 'PTHR33349:SF27', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING DOMAIN, PLANT-RELATED', 246495),
(366506, 'PTHR33349:SF29', NULL, NULL, NULL, NULL, 'CAM_BINDING DOMAIN-CONTAINING PROTEIN', 246495),
(366507, 'PTHR33349', NULL, NULL, NULL, NULL, 'EMB|CAB62594.1', 246495),
(366508, 'PTHR33349:SF34', NULL, NULL, NULL, NULL, 'CAM_BINDING DOMAIN-CONTAINING PROTEIN', 246495),
(366509, 'PTHR33349:SF12', NULL, NULL, NULL, NULL, 'INNER CENTROMERE PROTEIN A-LIKE', 246495),
(366510, 'PTHR33349:SF35', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN FUTSCH-LIKE', 246495),
(366511, 'PTHR33349:SF13', NULL, NULL, NULL, NULL, 'OS04G0284900 PROTEIN', 246495),
(366512, 'PTHR33349:SF36', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING DOMAIN, PLANT-RELATED', 246495),
(366513, 'PTHR33349:SF14', NULL, NULL, NULL, NULL, 'PLANT CALMODULIN-BINDING-LIKE PROTEIN', 246495),
(366514, 'PTHR33349:SF37', NULL, NULL, NULL, NULL, 'PLANT CALMODULIN-BINDING PROTEIN-RELATED', 246495),
(366515, 'PTHR33349:SF30', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN-LIKE PROTEIN', 246495),
(366516, 'PTHR33349:SF2', NULL, NULL, NULL, NULL, 'EMB|CAB62594.1', 246495),
(366517, 'PTHR33349:SF1', NULL, NULL, NULL, NULL, 'EMB|CAB62594.1', 246495),
(366518, 'PTHR33349:SF32', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING DOMAIN, PLANT-RELATED', 246495),
(366519, 'PTHR33349:SF33', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246495),
(366520, 'PTHR33349:SF11', NULL, NULL, NULL, NULL, 'PLANT CALMODULIN-BINDING PROTEIN-LIKE PROTEIN', 246495),
(366521, 'PTHR33349:SF38', NULL, NULL, NULL, NULL, 'CAM_BINDING DOMAIN-CONTAINING PROTEIN', 246495),
(366522, 'PTHR33349:SF39', NULL, NULL, NULL, NULL, 'CAM_BINDING DOMAIN-CONTAINING PROTEIN', 246495),
(366523, 'PTHR33349:SF6', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246495),
(366524, 'PTHR33349:SF40', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING DOMAIN, PLANT-RELATED', 246495),
(366525, 'PTHR33349:SF9', NULL, NULL, NULL, NULL, 'CAM_BINDING DOMAIN-CONTAINING PROTEIN', 246495),
(366526, 'PTHR33349:SF7', NULL, NULL, NULL, NULL, 'PLANT CALMODULIN-BINDING-LIKE PROTEIN', 246495),
(366527, 'PTHR43619:SF2', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 246496),
(366528, 'PTHR43619:SF8', NULL, NULL, NULL, NULL, 'LEUCINE CARBOXYL METHYLTRANSFERASE', 246496),
(366529, 'PTHR43619', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASE YKTD-RELATED', 246496);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(366530, 'PTHR22977', NULL, NULL, NULL, NULL, 'COX ASSEMBLY MITOCHONDRIAL PROTEIN', 246497),
(366531, 'PTHR22977:SF1', NULL, NULL, NULL, NULL, 'COX ASSEMBLY MITOCHONDRIAL PROTEIN 2 HOMOLOG', 246497),
(366532, 'PTHR22977:SF12', NULL, NULL, NULL, NULL, 'COX ASSEMBLY MITOCHONDRIAL PROTEIN', 246497),
(366533, 'PTHR22977:SF11', NULL, NULL, NULL, NULL, 'COX ASSEMBLY MITOCHONDRIAL PROTEIN', 246497),
(366534, 'PTHR22977:SF7', NULL, NULL, NULL, NULL, 'COX ASSEMBLY MITOCHONDRIAL PROTEIN', 246497),
(366535, 'PTHR22977:SF6', NULL, NULL, NULL, NULL, 'COX ASSEMBLY MITOCHONDRIAL PROTEIN', 246497),
(366536, 'PTHR22977:SF5', NULL, NULL, NULL, NULL, 'COX ASSEMBLY MITOCHONDRIAL PROTEIN HOMOLOG', 246497),
(366537, 'PTHR47098', NULL, NULL, NULL, NULL, 'PROTEIN MAK32', 246498),
(366538, 'PTHR47098:SF1', NULL, NULL, NULL, NULL, 'PFKB FAMILY CARBOHYDRATE KINASE SUPERFAMILY (AFU_ORTHOLOGUE AFUA_4G09500)', 246498),
(366539, 'PTHR47098:SF2', NULL, NULL, NULL, NULL, 'PROTEIN MAK32', 246498),
(366540, 'PTHR37741', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 246499),
(366541, 'PTHR37741:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 246499),
(366542, 'PTHR23271', NULL, NULL, NULL, NULL, 'HEPATOCELLULAR CARCINOMA-ASSOCIATED ANTIGEN 66', 246500),
(366543, 'PTHR23271:SF2', NULL, NULL, NULL, NULL, '', 246500),
(366544, 'PTHR23271:SF3', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RNA-ASSOCIATED PROTEIN 6 HOMOLOG', 246500),
(366545, 'PTHR23271:SF1', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RNA-ASSOCIATED PROTEIN 6 HOMOLOG', 246500),
(366546, 'PTHR12767:SF12', NULL, NULL, NULL, NULL, '', 246501),
(366547, 'PTHR12767:SF11', NULL, NULL, NULL, NULL, 'B-CELL CLL/LYMPHOMA 7 PROTEIN FAMILY MEMBER A', 246501),
(366548, 'PTHR12767:SF9', NULL, NULL, NULL, NULL, 'BCL7-LIKE', 246501),
(366549, 'PTHR12767', NULL, NULL, NULL, NULL, 'BCL7 RELATED', 246501),
(366550, 'PTHR12767:SF5', NULL, NULL, NULL, NULL, 'B-CELL CLL/LYMPHOMA 7 PROTEIN FAMILY MEMBER B', 246501),
(366551, 'PTHR12767:SF10', NULL, NULL, NULL, NULL, 'B-CELL CLL/LYMPHOMA 7 PROTEIN FAMILY MEMBER C', 246501),
(366552, 'PTHR47543:SF2', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II TRANSCRIPTION FACTOR SIII SUBUNIT A', 246502),
(366553, 'PTHR47543', NULL, NULL, NULL, NULL, 'OS08G0169600 PROTEIN', 246502),
(366554, 'PTHR47697:SF1', NULL, NULL, NULL, NULL, 'OS03G0340700 PROTEIN', 246503),
(366555, 'PTHR47697', NULL, NULL, NULL, NULL, 'OS03G0340700 PROTEIN', 246503),
(366556, 'PTHR22118', NULL, NULL, NULL, NULL, 'DYNEIN ASSEMBLY FACTOR 3, AXONEMAL', 246504),
(366557, 'PTHR22118:SF14', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL ASSEMBLY FACTOR 3', 246504),
(366558, 'PTHR22573:SF37', NULL, NULL, NULL, NULL, 'PHOSPHOGLUCOMUTASE-1', 246505),
(366559, 'PTHR22573:SF59', NULL, NULL, NULL, NULL, 'PHOSPHOGLUCOMUTASE, CHLOROPLASTIC', 246505),
(366560, 'PTHR22573:SF27', NULL, NULL, NULL, NULL, 'PHOSPHOGLUCOMUTASE-LIKE PROTEIN 5', 246505),
(366561, 'PTHR22573:SF57', NULL, NULL, NULL, NULL, 'PHOSPHOGLUCOMUTASE', 246505),
(366562, 'PTHR22573:SF58', NULL, NULL, NULL, NULL, 'PHOSPHOGLUCOMUTASE (ALPHA-D-GLUCOSE-1,6-BISPHOSPHATE-DEPENDENT)', 246505),
(366563, 'PTHR22573:SF2', NULL, NULL, NULL, NULL, 'PHOSPHOGLUCOMUTASE', 246505),
(366564, 'PTHR22573', NULL, NULL, NULL, NULL, 'PHOSPHOHEXOMUTASE FAMILY MEMBER', 246505),
(366565, 'PTHR22573:SF60', NULL, NULL, NULL, NULL, 'PHOSPHOGLUCOMUTASE 1', 246505),
(366566, 'PTHR41390:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 7, WHOLE GENOME SHOTGUN SEQUENCE', 246506),
(366567, 'PTHR41390', NULL, NULL, NULL, NULL, 'CHROMOSOME 7, WHOLE GENOME SHOTGUN SEQUENCE', 246506),
(366568, 'PTHR47400', NULL, NULL, NULL, NULL, 'PROLINE-RICH TRANSMEMBRANE PROTEIN 3', 246507),
(366569, 'PTHR47400:SF1', NULL, NULL, NULL, NULL, 'PROLINE-RICH TRANSMEMBRANE PROTEIN 3', 246507),
(366570, 'PTHR42956', NULL, NULL, NULL, NULL, 'NITROGENASE IRON-MOLYBDENUM COFACTOR BIOSYNTHESIS PROTEIN NIFE', 246508),
(366571, 'PTHR42956:SF1', NULL, NULL, NULL, NULL, 'NITROGENASE IRON-MOLYBDENUM COFACTOR BIOSYNTHESIS PROTEIN NIFE', 246508),
(366572, 'PTHR14905:SF11', NULL, NULL, NULL, NULL, 'TINC (EUROFUNG)', 246509);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(366573, 'PTHR14905', NULL, NULL, NULL, NULL, 'NG37', 246509),
(366574, 'PTHR14905:SF18', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR A DOMAIN-CONTAINING 10, TANDEM DUPLICATE 1-RELATED', 246509),
(366575, 'PTHR14905:SF7', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR A DOMAIN-CONTAINING PROTEIN 7', 246509),
(366576, 'PTHR14905:SF21', NULL, NULL, NULL, NULL, 'CHITINASE', 246509),
(366577, 'PTHR11006:SF119', NULL, NULL, NULL, NULL, 'COILIN', 246510),
(366578, 'PTHR11006:SF49', NULL, NULL, NULL, NULL, 'COACTIVATOR-ASSOCIATED ARGININE METHYLTRANSFERASE 1', 246510),
(366579, 'PTHR11006:SF118', NULL, NULL, NULL, NULL, 'N-METHYLTRANSFERASE, PUTATIVE-RELATED', 246510),
(366580, 'PTHR11006:SF47', NULL, NULL, NULL, NULL, 'PROTEIN ARGININE N-METHYLTRANSFERASE 8', 246510),
(366581, 'PTHR11006:SF116', NULL, NULL, NULL, NULL, 'PROTEIN METHYLTRANSFERASE', 246510),
(366582, 'PTHR11006:SF89', NULL, NULL, NULL, NULL, 'PROTEIN ARGININE N-METHYLTRANSFERASE 3-RELATED', 246510),
(366583, 'PTHR11006:SF68', NULL, NULL, NULL, NULL, 'PROTEIN ARGININE N-METHYLTRANSFERASE PRMT10', 246510),
(366584, 'PTHR11006:SF70', NULL, NULL, NULL, NULL, 'PROTEIN ARGININE N-METHYLTRANSFERASE 6.1-RELATED', 246510),
(366585, 'PTHR11006:SF92', NULL, NULL, NULL, NULL, 'PROTEIN ARGININE N-METHYLTRANSFERASE 2', 246510),
(366586, 'PTHR11006:SF114', NULL, NULL, NULL, NULL, 'PROTEIN ARGININE N-METHYLTRANSFERASE 3', 246510),
(366587, 'PTHR11006:SF111', NULL, NULL, NULL, NULL, 'BNAC03G41340D PROTEIN', 246510),
(366588, 'PTHR11006:SF4', NULL, NULL, NULL, NULL, 'PROTEIN ARGININE N-METHYLTRANSFERASE 7', 246510),
(366589, 'PTHR11006:SF107', NULL, NULL, NULL, NULL, 'BNAA08G13390D PROTEIN', 246510),
(366590, 'PTHR11006:SF10', NULL, NULL, NULL, NULL, 'HISTONE-ARGININE METHYLTRANSFERASE CARMER-RELATED', 246510),
(366591, 'PTHR11006:SF54', NULL, NULL, NULL, NULL, 'PROTEIN ARGININE N-METHYLTRANSFERASE 1', 246510),
(366592, 'PTHR11006:SF99', NULL, NULL, NULL, NULL, '', 246510),
(366593, 'PTHR11006:SF53', NULL, NULL, NULL, NULL, 'ARGININE METHYLTRANSFERASE 1-RELATED', 246510),
(366594, 'PTHR11006:SF51', NULL, NULL, NULL, NULL, 'HISTONE-ARGININE METHYLTRANSFERASE CARM1', 246510),
(366595, 'PTHR11006:SF73', NULL, NULL, NULL, NULL, 'PROTEIN ARGININE N-METHYLTRANSFERASE 6', 246510),
(366596, 'PTHR11006:SF60', NULL, NULL, NULL, NULL, 'PROTEIN ARGININE N-METHYLTRANSFERASE 9', 246510),
(366597, 'PTHR11006', NULL, NULL, NULL, NULL, 'PROTEIN ARGININE N-METHYLTRANSFERASE', 246510),
(366598, 'PTHR11006:SF102', NULL, NULL, NULL, NULL, 'N-METHYLTRANSFERASE, PUTATIVE-RELATED', 246510),
(366599, 'PTHR11006:SF103', NULL, NULL, NULL, NULL, 'PROTEIN ARGININE N-METHYLTRANSFERASE 1.2-RELATED', 246510),
(366600, 'PTHR11006:SF122', NULL, NULL, NULL, NULL, 'ARGININE METHYLTRANSFERASE 8', 246510),
(366601, 'PTHR11006:SF100', NULL, NULL, NULL, NULL, 'HISTONE-ARGININE METHYLTRANSFERASE 1.3-RELATED', 246510),
(366602, 'PTHR11006:SF123', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN ARGININE N-METHYLTRANSFERASE RMT3', 246510),
(366603, 'PTHR11006:SF101', NULL, NULL, NULL, NULL, 'HISTONE-ARGININE METHYLTRANSFERASE 1.4-RELATED', 246510),
(366604, 'PTHR11006:SF120', NULL, NULL, NULL, NULL, 'N-METHYLTRANSFERASE, PUTATIVE-RELATED', 246510),
(366605, 'PTHR11006:SF121', NULL, NULL, NULL, NULL, 'PROTEIN ARGININE N-METHYLTRANSFERASE 1-RELATED', 246510),
(366606, 'PTHR11216:SF160', NULL, NULL, NULL, NULL, 'BNAC08G19880D PROTEIN', 246511),
(366607, 'PTHR11216:SF161', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF HAND FAMILY PROTEIN', 246511),
(366608, 'PTHR11216:SF140', NULL, NULL, NULL, NULL, 'EH DOMAIN-CONTAINING PROTEIN 1-LIKE ISOFORM X1', 246511),
(366609, 'PTHR11216:SF162', NULL, NULL, NULL, NULL, 'UBA DOMAIN-CONTAINING PROTEIN 8', 246511),
(366610, 'PTHR11216:SF163', NULL, NULL, NULL, NULL, 'EH DOMAIN-CONTAINING PROTEIN 1-LIKE ISOFORM X1', 246511),
(366611, 'PTHR11216:SF141', NULL, NULL, NULL, NULL, 'ACTIN CYTOSKELETON-REGULATORY COMPLEX PROTEIN PAN1-LIKE', 246511),
(366612, 'PTHR11216:SF120', NULL, NULL, NULL, NULL, 'SI:CH211-11K18.4', 246511),
(366613, 'PTHR11216:SF142', NULL, NULL, NULL, NULL, 'BNAC07G15190D PROTEIN', 246511);
INSERT INTO "PUBLIC"."MODEL" VALUES
(366614, 'PTHR11216:SF164', NULL, NULL, NULL, NULL, 'INCREASED RDNA SILENCING PROTEIN 4', 246511),
(366615, 'PTHR11216:SF165', NULL, NULL, NULL, NULL, 'EPS15-LIKE PROTEIN-RELATED', 246511),
(366616, 'PTHR11216:SF121', NULL, NULL, NULL, NULL, 'OS02G0158100 PROTEIN', 246511),
(366617, 'PTHR11216:SF143', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN PAIR-RELATED', 246511),
(366618, 'PTHR11216:SF144', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF HAND PROTEIN', 246511),
(366619, 'PTHR11216:SF166', NULL, NULL, NULL, NULL, 'G DOMAIN-CONTAINING PROTEIN', 246511),
(366620, 'PTHR11216:SF145', NULL, NULL, NULL, NULL, 'OS04G0669300 PROTEIN', 246511),
(366621, 'PTHR11216:SF123', NULL, NULL, NULL, NULL, 'SI:DKEY-98F17.5', 246511),
(366622, 'PTHR11216:SF167', NULL, NULL, NULL, NULL, 'EH DOMAIN-CONTAINING PROTEIN 1-LIKE', 246511),
(366623, 'PTHR11216:SF168', NULL, NULL, NULL, NULL, 'GH06923P', 246511),
(366624, 'PTHR11216:SF169', NULL, NULL, NULL, NULL, 'EF HAND FAMILY PROTEIN, EXPRESSED', 246511),
(366625, 'PTHR11216:SF57', NULL, NULL, NULL, NULL, 'EH DOMAIN-CONTAINING PROTEIN 4', 246511),
(366626, 'PTHR11216:SF127', NULL, NULL, NULL, NULL, 'EH DOMAIN-CONTAINING PROTEIN 1', 246511),
(366627, 'PTHR11216:SF31', NULL, NULL, NULL, NULL, 'AT21416P', 246511),
(366628, 'PTHR11216:SF76', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF HAND PROTEIN', 246511),
(366629, 'PTHR11216:SF54', NULL, NULL, NULL, NULL, 'EPIDERMAL GROWTH FACTOR RECEPTOR SUBSTRATE 15', 246511),
(366630, 'PTHR11216', NULL, NULL, NULL, NULL, 'EH DOMAIN', 246511),
(366631, 'PTHR11216:SF74', NULL, NULL, NULL, NULL, 'ACTIN CYTOSKELETON-REGULATORY COMPLEX PROTEIN END3', 246511),
(366632, 'PTHR11216:SF1', NULL, NULL, NULL, NULL, 'DYNAMIN-TYPE G DOMAIN-CONTAINING PROTEIN-RELATED', 246511),
(366633, 'PTHR11216:SF170', NULL, NULL, NULL, NULL, 'DYNAMIN ASSOCIATED PROTEIN 160, ISOFORM D', 246511),
(366634, 'PTHR11216:SF171', NULL, NULL, NULL, NULL, 'BNAC08G19440D PROTEIN', 246511),
(366635, 'PTHR11216:SF151', NULL, NULL, NULL, NULL, 'BNAC05G31740D PROTEIN', 246511),
(366636, 'PTHR11216:SF154', NULL, NULL, NULL, NULL, 'DYNAMIN-TYPE G DOMAIN-CONTAINING PROTEIN', 246511),
(366637, 'PTHR11216:SF68', NULL, NULL, NULL, NULL, 'INTERSECTIN-1', 246511),
(366638, 'PTHR11216:SF69', NULL, NULL, NULL, NULL, 'EPIDERMAL GROWTH FACTOR RECEPTOR SUBSTRATE 15-LIKE 1', 246511),
(366639, 'PTHR11216:SF159', NULL, NULL, NULL, NULL, 'EPIDERMAL GROWTH FACTOR RECEPTOR PATHWAY SUBSTRATE CLONE 15, ISOFORM A', 246511),
(366640, 'PTHR11216:SF137', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF HAND FAMILY PROTEIN', 246511),
(366641, 'PTHR11216:SF138', NULL, NULL, NULL, NULL, 'EH DOMAIN-CONTAINING PROTEIN 2', 246511),
(366642, 'PTHR11216:SF139', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF HAND FAMILY PROTEIN', 246511),
(366643, 'PTHR11216:SF67', NULL, NULL, NULL, NULL, 'EH DOMAIN-CONTAINING PROTEIN 3', 246511),
(366644, 'PTHR11216:SF64', NULL, NULL, NULL, NULL, 'RALBP1-ASSOCIATED EPS DOMAIN-CONTAINING PROTEIN 2', 246511),
(366645, 'PTHR11216:SF62', NULL, NULL, NULL, NULL, 'EH DOMAIN-CONTAINING PROTEIN 2', 246511),
(366646, 'PTHR11216:SF63', NULL, NULL, NULL, NULL, 'RALBP1-ASSOCIATED EPS DOMAIN-CONTAINING PROTEIN 1', 246511),
(366647, 'PTHR11216:SF29', NULL, NULL, NULL, NULL, 'INTERSECTIN-2', 246511),
(366648, 'PTHR21562:SF69', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE 9', 246512),
(366649, 'PTHR21562:SF67', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366650, 'PTHR21562:SF65', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366651, 'PTHR21562:SF61', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE 10', 246512),
(366652, 'PTHR21562:SF60', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE 5', 246512),
(366653, 'PTHR21562:SF109', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366654, 'PTHR21562', NULL, NULL, NULL, NULL, 'NOTUM-RELATED', 246512),
(366655, 'PTHR21562:SF105', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366656, 'PTHR21562:SF103', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366657, 'PTHR21562:SF102', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(366658, 'PTHR21562:SF100', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366659, 'PTHR21562:SF78', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366660, 'PTHR21562:SF77', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366661, 'PTHR21562:SF75', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE 2', 246512),
(366662, 'PTHR21562:SF74', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366663, 'PTHR21562:SF73', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366664, 'PTHR21562:SF72', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366665, 'PTHR21562:SF71', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366666, 'PTHR21562:SF117', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366667, 'PTHR21562:SF116', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366668, 'PTHR21562:SF115', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366669, 'PTHR21562:SF5', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE 12', 246512),
(366670, 'PTHR21562:SF114', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE 11', 246512),
(366671, 'PTHR21562:SF113', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366672, 'PTHR21562:SF7', NULL, NULL, NULL, NULL, 'PALMITOLEOYL-PROTEIN CARBOXYLESTERASE NOTUM', 246512),
(366673, 'PTHR21562:SF112', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366674, 'PTHR21562:SF111', NULL, NULL, NULL, NULL, '', 246512),
(366675, 'PTHR21562:SF110', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366676, 'PTHR21562:SF49', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366677, 'PTHR21562:SF47', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366678, 'PTHR21562:SF44', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366679, 'PTHR21562:SF88', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366680, 'PTHR21562:SF87', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366681, 'PTHR21562:SF86', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366682, 'PTHR21562:SF85', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366683, 'PTHR21562:SF83', NULL, NULL, NULL, NULL, 'PALMITOLEOYL-PROTEIN CARBOXYLESTERASE NOTUM', 246512),
(366684, 'PTHR21562:SF82', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366685, 'PTHR21562:SF81', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366686, 'PTHR21562:SF80', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366687, 'PTHR21562:SF59', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366688, 'PTHR21562:SF57', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366689, 'PTHR21562:SF56', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366690, 'PTHR21562:SF99', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366691, 'PTHR21562:SF98', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE 3', 246512),
(366692, 'PTHR21562:SF54', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE 1', 246512),
(366693, 'PTHR21562:SF10', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE NOTUM2', 246512),
(366694, 'PTHR21562:SF53', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366695, 'PTHR21562:SF96', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366696, 'PTHR21562:SF95', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366697, 'PTHR21562:SF51', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE 7', 246512),
(366698, 'PTHR21562:SF94', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366699, 'PTHR21562:SF50', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE 6', 246512),
(366700, 'PTHR21562:SF93', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE 8', 246512),
(366701, 'PTHR21562:SF92', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366702, 'PTHR21562:SF90', NULL, NULL, NULL, NULL, 'PECTIN ACETYLESTERASE', 246512),
(366703, 'PTHR45688:SF1', NULL, NULL, NULL, NULL, 'ETHANOLAMINE-PHOSPHATE PHOSPHO-LYASE', 246513),
(366704, 'PTHR45688:SF15', NULL, NULL, NULL, NULL, 'BNAC04G56620D PROTEIN', 246513),
(366705, 'PTHR45688:SF4', NULL, NULL, NULL, NULL, 'ALANINE--GLYOXYLATE AMINOTRANSFERASE1', 246513);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(366706, 'PTHR45688:SF16', NULL, NULL, NULL, NULL, 'ALANINE-GLYOXYLATE AMINOTRANSFERASE-LIKE PROTEIN', 246513),
(366707, 'PTHR45688:SF13', NULL, NULL, NULL, NULL, 'ALANINE--GLYOXYLATE AMINOTRANSFERASE 2-LIKE', 246513),
(366708, 'PTHR45688:SF14', NULL, NULL, NULL, NULL, 'BNAC01G00550D PROTEIN', 246513),
(366709, 'PTHR45688:SF3', NULL, NULL, NULL, NULL, 'ALANINE--GLYOXYLATE AMINOTRANSFERASE 2, MITOCHONDRIAL', 246513),
(366710, 'PTHR45688:SF8', NULL, NULL, NULL, NULL, 'ALANINE--GLYOXYLATE AMINOTRANSFERASE 2 HOMOLOG 3, MITOCHONDRIAL-LIKE ISOFORM X1', 246513),
(366711, 'PTHR45688:SF11', NULL, NULL, NULL, NULL, 'ALANINE--GLYOXYLATE AMINOTRANSFERASE 2 HOMOLOG 3, MITOCHONDRIAL', 246513),
(366712, 'PTHR45688:SF12', NULL, NULL, NULL, NULL, 'BNAANNG13240D PROTEIN', 246513),
(366713, 'PTHR45688:SF6', NULL, NULL, NULL, NULL, '5-PHOSPHOHYDROXY-L-LYSINE PHOSPHO-LYASE', 246513),
(366714, 'PTHR45688', NULL, NULL, NULL, NULL, '', 246513),
(366715, 'PTHR34723:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG17025', 246514),
(366716, 'PTHR34723', NULL, NULL, NULL, NULL, 'PROTEIN CBG17025', 246514),
(366717, 'PTHR34723:SF8', NULL, NULL, NULL, NULL, '', 246514),
(366718, 'PTHR34723:SF7', NULL, NULL, NULL, NULL, '', 246514),
(366719, 'PTHR34723:SF6', NULL, NULL, NULL, NULL, '', 246514),
(366720, 'PTHR34723:SF10', NULL, NULL, NULL, NULL, '', 246514),
(366721, 'PTHR34798:SF4', NULL, NULL, NULL, NULL, 'BNAA05G17250D PROTEIN', 246515),
(366722, 'PTHR34798:SF3', NULL, NULL, NULL, NULL, 'BNAC03G42780D PROTEIN', 246515),
(366723, 'PTHR34798:SF2', NULL, NULL, NULL, NULL, 'PROTEIN TIME FOR COFFEE', 246515),
(366724, 'PTHR34798:SF1', NULL, NULL, NULL, NULL, 'TIC-LIKE PROTEIN', 246515),
(366725, 'PTHR34798', NULL, NULL, NULL, NULL, 'PROTEIN TIME FOR COFFEE', 246515),
(366726, 'PTHR31254:SF1', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC690617', 246516),
(366727, 'PTHR31254', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC690617', 246516),
(366728, 'PTHR20854', NULL, NULL, NULL, NULL, 'INOSITOL MONOPHOSPHATASE', 246517),
(366729, 'PTHR20854:SF4', NULL, NULL, NULL, NULL, 'INOSITOL-1-MONOPHOSPHATASE-RELATED', 246517),
(366730, 'PTHR20854:SF41', NULL, NULL, NULL, NULL, 'INOSITOL-1-MONOPHOSPHATASE', 246517),
(366731, 'PTHR20854:SF44', NULL, NULL, NULL, NULL, 'INOSITOL-1-MONOPHOSPHATASE', 246517),
(366732, 'PTHR20854:SF22', NULL, NULL, NULL, NULL, 'INOSITOL-1-MONOPHOSPHATASE', 246517),
(366733, 'PTHR20854:SF26', NULL, NULL, NULL, NULL, 'INOSITOL MONOPHOSPHATASE 1', 246517),
(366734, 'PTHR20854:SF48', NULL, NULL, NULL, NULL, 'INOSITOL MONOPHOSPHATASE 3', 246517),
(366735, 'PTHR20854:SF49', NULL, NULL, NULL, NULL, 'INOSITOL-1-MONOPHOSPHATASE', 246517),
(366736, 'PTHR20854:SF46', NULL, NULL, NULL, NULL, 'INOSITOL MONOPHOSPHATASE 2', 246517),
(366737, 'PTHR20854:SF25', NULL, NULL, NULL, NULL, 'INOSITOL-1-MONOPHOSPHATASE', 246517),
(366738, 'PTHR20854:SF39', NULL, NULL, NULL, NULL, 'PROTEIN QUTG', 246517),
(366739, 'PTHR20854:SF17', NULL, NULL, NULL, NULL, 'PHOSPHATASE IMPL1, CHLOROPLASTIC', 246517),
(366740, 'PTHR20854:SF29', NULL, NULL, NULL, NULL, 'INOSITOL MONOPHOSPHATASE 2', 246517),
(366741, 'PTHR24282:SF31', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 734A2', 246518),
(366742, 'PTHR24282:SF250', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP72A219-LIKE', 246518),
(366743, 'PTHR24282:SF130', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 246518),
(366744, 'PTHR24282:SF251', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP72A219-LIKE', 246518),
(366745, 'PTHR24282:SF252', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 ISOFORM 1', 246518),
(366746, 'PTHR24282:SF253', NULL, NULL, NULL, NULL, '11-OXO-BETA-AMYRIN 30-OXIDASE', 246518),
(366747, 'PTHR24282', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY MEMBER', 246518),
(366748, 'PTHR24282:SF36', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 714A1-RELATED', 246518),
(366749, 'PTHR24282:SF124', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 SUPERFAMILY PROTEIN-RELATED', 246518),
(366750, 'PTHR24282:SF245', NULL, NULL, NULL, NULL, 'CYP72A56', 246518),
(366751, 'PTHR24282:SF39', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 714D1', 246518);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(366752, 'PTHR24282:SF125', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 709B3', 246518),
(366753, 'PTHR24282:SF247', NULL, NULL, NULL, NULL, '11-OXO-BETA-AMYRIN 30-OXIDASE-LIKE', 246518),
(366754, 'PTHR24282:SF248', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP13A1-RELATED', 246518),
(366755, 'PTHR24282:SF127', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 72 SUBFAMILY A POLYPEPTIDE 8', 246518),
(366756, 'PTHR24282:SF249', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 72A11-RELATED', 246518),
(366757, 'PTHR24282:SF41', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 734A5', 246518),
(366758, 'PTHR24282:SF240', NULL, NULL, NULL, NULL, 'P450, PUTATIVE-RELATED', 246518),
(366759, 'PTHR24282:SF121', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 714C2-LIKE', 246518),
(366760, 'PTHR24282:SF199', NULL, NULL, NULL, NULL, 'BNAA02G10890D PROTEIN', 246518),
(366761, 'PTHR24282:SF233', NULL, NULL, NULL, NULL, 'P450, PUTATIVE-RELATED', 246518),
(366762, 'PTHR24282:SF112', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 709 PROTEIN', 246518),
(366763, 'PTHR24282:SF113', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 246518),
(366764, 'PTHR24282:SF234', NULL, NULL, NULL, NULL, 'CYTOCHROME P450-RELATED', 246518),
(366765, 'PTHR24282:SF49', NULL, NULL, NULL, NULL, 'OS01G0628700 PROTEIN', 246518),
(366766, 'PTHR24282:SF236', NULL, NULL, NULL, NULL, 'P450, PUTATIVE-RELATED', 246518),
(366767, 'PTHR24282:SF115', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 SUPERFAMILY PROTEIN-RELATED', 246518),
(366768, 'PTHR24282:SF43', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 734A4', 246518),
(366769, 'PTHR24282:SF117', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP13A2-RELATED', 246518),
(366770, 'PTHR24282:SF6', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP13A8-RELATED', 246518),
(366771, 'PTHR24282:SF118', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY MONOOXYGENASE', 246518),
(366772, 'PTHR24282:SF191', NULL, NULL, NULL, NULL, 'CYP72A58', 246518),
(366773, 'PTHR24282:SF94', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 72C1', 246518),
(366774, 'PTHR24282:SF192', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP749A22-LIKE', 246518),
(366775, 'PTHR24282:SF97', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP13A10-RELATED', 246518),
(366776, 'PTHR24282:SF193', NULL, NULL, NULL, NULL, 'P450, PUTATIVE-RELATED', 246518),
(366777, 'PTHR24282:SF194', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP72A219-LIKE', 246518),
(366778, 'PTHR24282:SF195', NULL, NULL, NULL, NULL, 'CYTOKININ HYDROXYLASE', 246518),
(366779, 'PTHR24282:SF196', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 714C2', 246518),
(366780, 'PTHR24282:SF230', NULL, NULL, NULL, NULL, '', 246518),
(366781, 'PTHR24282:SF197', NULL, NULL, NULL, NULL, 'ECERIFERUM-U', 246518),
(366782, 'PTHR24282:SF110', NULL, NULL, NULL, NULL, 'OS01G0349800 PROTEIN', 246518),
(366783, 'PTHR24282:SF198', NULL, NULL, NULL, NULL, 'CYP72A56', 246518),
(366784, 'PTHR24282:SF100', NULL, NULL, NULL, NULL, 'OS06G0191700 PROTEIN', 246518),
(366785, 'PTHR24282:SF188', NULL, NULL, NULL, NULL, 'BNAA06G32050D PROTEIN', 246518),
(366786, 'PTHR24282:SF15', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 715, SUBFAMILY A, POLYPEPTIDE 1', 246518),
(366787, 'PTHR24282:SF221', NULL, NULL, NULL, NULL, '', 246518),
(366788, 'PTHR24282:SF222', NULL, NULL, NULL, NULL, 'CASTASTERONE 26-HYDROXYLASE', 246518),
(366789, 'PTHR24282:SF223', NULL, NULL, NULL, NULL, 'BNACNNG69060D PROTEIN', 246518),
(366790, 'PTHR24282:SF17', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY', 246518),
(366791, 'PTHR24282:SF224', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 734A1', 246518),
(366792, 'PTHR24282:SF103', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 MONOOXYGENASE', 246518),
(366793, 'PTHR24282:SF99', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 714A1', 246518),
(366794, 'PTHR24282:SF225', NULL, NULL, NULL, NULL, 'CYP72A57', 246518),
(366795, 'PTHR24282:SF10', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP13A6-RELATED', 246518),
(366796, 'PTHR24282:SF226', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP749A22-LIKE ISOFORM X1', 246518),
(366797, 'PTHR24282:SF106', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 72 SUBFAMILY A POLYPEPTIDE 8', 246518);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(366798, 'PTHR24282:SF227', NULL, NULL, NULL, NULL, '', 246518),
(366799, 'PTHR24282:SF228', NULL, NULL, NULL, NULL, 'CYTOKININ HYDROXYLASE', 246518),
(366800, 'PTHR24282:SF109', NULL, NULL, NULL, NULL, 'OS01G0627800 PROTEIN', 246518),
(366801, 'PTHR24282:SF180', NULL, NULL, NULL, NULL, 'CYTOCHROME', 246518),
(366802, 'PTHR24282:SF181', NULL, NULL, NULL, NULL, '', 246518),
(366803, 'PTHR24282:SF20', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 246518),
(366804, 'PTHR24282:SF183', NULL, NULL, NULL, NULL, 'BNAA02G10910D PROTEIN', 246518),
(366805, 'PTHR24282:SF184', NULL, NULL, NULL, NULL, 'P450, PUTATIVE-RELATED', 246518),
(366806, 'PTHR24282:SF185', NULL, NULL, NULL, NULL, 'BNAA06G03010D PROTEIN', 246518),
(366807, 'PTHR24282:SF220', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP72A219-LIKE', 246518),
(366808, 'PTHR24282:SF26', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 246518),
(366809, 'PTHR24282:SF210', NULL, NULL, NULL, NULL, 'CYTOCHROME P450-RELATED', 246518),
(366810, 'PTHR24282:SF178', NULL, NULL, NULL, NULL, 'BNAA01G29240D PROTEIN', 246518),
(366811, 'PTHR24282:SF211', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY-RELATED', 246518),
(366812, 'PTHR24282:SF212', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 PROTEIN-RELATED', 246518),
(366813, 'PTHR24282:SF28', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 714C2-LIKE', 246518),
(366814, 'PTHR24282:SF213', NULL, NULL, NULL, NULL, '', 246518),
(366815, 'PTHR24282:SF27', NULL, NULL, NULL, NULL, 'CYTOKININ HYDROXYLASE', 246518),
(366816, 'PTHR24282:SF216', NULL, NULL, NULL, NULL, 'CYP72A54', 246518),
(366817, 'PTHR24282:SF217', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP72A219-LIKE', 246518),
(366818, 'PTHR24282:SF171', NULL, NULL, NULL, NULL, 'OS01G0628900 PROTEIN', 246518),
(366819, 'PTHR24282:SF175', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP72A219-LIKE', 246518),
(366820, 'PTHR24282:SF176', NULL, NULL, NULL, NULL, 'CYTOCHROME P450-RELATED', 246518),
(366821, 'PTHR24282:SF167', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP72A219-LIKE ISOFORM X2', 246518),
(366822, 'PTHR24282:SF201', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 246518),
(366823, 'PTHR24282:SF204', NULL, NULL, NULL, NULL, 'CYTOCHROME P450-RELATED', 246518),
(366824, 'PTHR24282:SF205', NULL, NULL, NULL, NULL, 'BNACNNG42960D PROTEIN', 246518),
(366825, 'PTHR24282:SF207', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP72A219-LIKE', 246518),
(366826, 'PTHR24282:SF208', NULL, NULL, NULL, NULL, 'P450, PUTATIVE-RELATED', 246518),
(366827, 'PTHR24282:SF209', NULL, NULL, NULL, NULL, '11-OXO-BETA-AMYRIN 30-OXIDASE-RELATED', 246518),
(366828, 'PTHR24282:SF160', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY MONOOXYGENASE', 246518),
(366829, 'PTHR24282:SF162', NULL, NULL, NULL, NULL, '', 246518),
(366830, 'PTHR24282:SF155', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 734A1-LIKE', 246518),
(366831, 'PTHR24282:SF158', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP72A123', 246518),
(366832, 'PTHR24282:SF159', NULL, NULL, NULL, NULL, '', 246518),
(366833, 'PTHR24282:SF270', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP749A22-LIKE', 246518),
(366834, 'PTHR24282:SF52', NULL, NULL, NULL, NULL, 'OS07G0635200 PROTEIN', 246518),
(366835, 'PTHR24282:SF150', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 709B2', 246518),
(366836, 'PTHR24282:SF151', NULL, NULL, NULL, NULL, 'OS07G0635700 PROTEIN', 246518),
(366837, 'PTHR24282:SF152', NULL, NULL, NULL, NULL, '', 246518),
(366838, 'PTHR24282:SF154', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP749A22-LIKE', 246518),
(366839, 'PTHR24282:SF265', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP749A22-LIKE', 246518),
(366840, 'PTHR24282:SF145', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP709H1', 246518),
(366841, 'PTHR24282:SF266', NULL, NULL, NULL, NULL, '11-OXO-BETA-AMYRIN 30-OXIDASE-RELATED', 246518),
(366842, 'PTHR24282:SF267', NULL, NULL, NULL, NULL, '', 246518),
(366843, 'PTHR24282:SF146', NULL, NULL, NULL, NULL, '', 246518),
(366844, 'PTHR24282:SF268', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 72 SUBFAMILY A POLYPEPTIDE 8', 246518),
(366845, 'PTHR24282:SF148', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 72A15-LIKE', 246518);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(366846, 'PTHR24282:SF269', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, REVERSE TRANSCRIPTASE, RNA-DEPENDENT DNA POLYMERASE-RELATED', 246518),
(366847, 'PTHR24282:SF55', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP13A3-RELATED', 246518),
(366848, 'PTHR24282:SF149', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 72 PROTEIN', 246518),
(366849, 'PTHR24282:SF260', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 714C2-LIKE', 246518),
(366850, 'PTHR24282:SF63', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 734A1-LIKE', 246518),
(366851, 'PTHR24282:SF261', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 714B2', 246518),
(366852, 'PTHR24282:SF262', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP72A219-LIKE ISOFORM X1', 246518),
(366853, 'PTHR24282:SF141', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 714C3', 246518),
(366854, 'PTHR24282:SF263', NULL, NULL, NULL, NULL, '', 246518),
(366855, 'PTHR24282:SF142', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 709B1', 246518),
(366856, 'PTHR24282:SF143', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 72 SUBFAMILY A POLYPEPTIDE 8', 246518),
(366857, 'PTHR24282:SF264', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 709B2', 246518),
(366858, 'PTHR24282:SF254', NULL, NULL, NULL, NULL, 'CYTOCHROME P450-RELATED', 246518),
(366859, 'PTHR24282:SF255', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 72, SUBFAMILY A, POLYPEPTIDE 9', 246518),
(366860, 'PTHR24282:SF134', NULL, NULL, NULL, NULL, '', 246518),
(366861, 'PTHR24282:SF135', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 709B2', 246518),
(366862, 'PTHR24282:SF256', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 246518),
(366863, 'PTHR24282:SF257', NULL, NULL, NULL, NULL, '', 246518),
(366864, 'PTHR24282:SF136', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP749A22-LIKE', 246518),
(366865, 'PTHR24282:SF137', NULL, NULL, NULL, NULL, '', 246518),
(366866, 'PTHR24282:SF258', NULL, NULL, NULL, NULL, '', 246518),
(366867, 'PTHR24282:SF259', NULL, NULL, NULL, NULL, 'OS05G0372300 PROTEIN', 246518),
(366868, 'PTHR24282:SF139', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 714A1-LIKE ISOFORM X1', 246518),
(366869, 'PTHR43214', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR', 246519),
(366870, 'PTHR43214:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN COMA', 246519),
(366871, 'PTHR43214:SF3', NULL, NULL, NULL, NULL, 'RESPONSE REGULATOR UVRY', 246519),
(366872, 'PTHR43214:SF41', NULL, NULL, NULL, NULL, 'NITRATE/NITRITE RESPONSE REGULATOR PROTEIN NARP', 246519),
(366873, 'PTHR43214:SF30', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR YJJQ-RELATED', 246519),
(366874, 'PTHR43214:SF42', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN DESR', 246519),
(366875, 'PTHR43214:SF31', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR PROTEIN BGLJ', 246519),
(366876, 'PTHR43214:SF40', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN LNRK', 246519),
(366877, 'PTHR43214:SF24', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN NARL-RELATED', 246519),
(366878, 'PTHR43214:SF43', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR', 246519),
(366879, 'PTHR43214:SF22', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN UHPA', 246519),
(366880, 'PTHR43214:SF44', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR', 246519),
(366881, 'PTHR43214:SF38', NULL, NULL, NULL, NULL, 'NITRATE/NITRITE RESPONSE REGULATOR PROTEIN NARL', 246519),
(366882, 'PTHR43214:SF39', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN DEGU', 246519),
(366883, 'PTHR43214:SF17', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN RCSB', 246519),
(366884, 'PTHR43214:SF36', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 246519),
(366885, 'PTHR43214:SF37', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN YDFI', 246519),
(366886, 'PTHR45674:SF7', NULL, NULL, NULL, NULL, 'DNA LIGASE', 246520),
(366887, 'PTHR45674:SF4', NULL, NULL, NULL, NULL, 'DNA LIGASE 1', 246520),
(366888, 'PTHR45674:SF3', NULL, NULL, NULL, NULL, 'PARP-TYPE DOMAIN-CONTAINING PROTEIN', 246520),
(366889, 'PTHR45674:SF9', NULL, NULL, NULL, NULL, 'DNA LIGASE 3', 246520);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(366890, 'PTHR45674', NULL, NULL, NULL, NULL, 'DNA LIGASE 1/3 FAMILY MEMBER', 246520),
(366891, 'PTHR45674:SF13', NULL, NULL, NULL, NULL, 'DNA LIGASE-RELATED', 246520),
(366892, 'PTHR45674:SF12', NULL, NULL, NULL, NULL, 'ATP DEPENDENT DNA LIGASE DOMAIN-CONTAINING PROTEIN', 246520),
(366893, 'PTHR36042', NULL, NULL, NULL, NULL, 'OS05G0490900 PROTEIN', 246521),
(366894, 'PTHR36042:SF1', NULL, NULL, NULL, NULL, 'OS05G0490900 PROTEIN', 246521),
(366895, 'PTHR12392', NULL, NULL, NULL, NULL, 'LADININ 1', 246522),
(366896, 'PTHR12392:SF0', NULL, NULL, NULL, NULL, 'LADININ-1', 246522),
(366897, 'PTHR14445:SF51', NULL, NULL, NULL, NULL, '', 246523),
(366898, 'PTHR14445:SF36', NULL, NULL, NULL, NULL, 'FI03272P-RELATED', 246523),
(366899, 'PTHR14445:SF37', NULL, NULL, NULL, NULL, 'GRB10-INTERACTING GYF PROTEIN 1', 246523),
(366900, 'PTHR14445:SF38', NULL, NULL, NULL, NULL, 'GRB10-INTERACTING GYF PROTEIN 2', 246523),
(366901, 'PTHR14445', NULL, NULL, NULL, NULL, 'GRB10 INTERACTING GYF PROTEIN', 246523),
(366902, 'PTHR14445:SF46', NULL, NULL, NULL, NULL, '', 246523),
(366903, 'PTHR35487', NULL, NULL, NULL, NULL, 'DUF3824 DOMAIN-CONTAINING PROTEIN', 246524),
(366904, 'PTHR35487:SF1', NULL, NULL, NULL, NULL, 'DUF3824 DOMAIN-CONTAINING PROTEIN', 246524),
(366905, 'PTHR43725:SF32', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 246525),
(366906, 'PTHR43725:SF31', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 4-EPIMERASE', 246525),
(366907, 'PTHR43725:SF30', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 4-EPIMERASE', 246525),
(366908, 'PTHR43725:SF25', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 4-EPIMERASE', 246525),
(366909, 'PTHR43725:SF47', NULL, NULL, NULL, NULL, 'CARNITINE ACETYL TRANSFERASE (AFU_ORTHOLOGUE AFUA_2G12530)-RELATED', 246525),
(366910, 'PTHR43725:SF24', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL UDP-GLUCOSE 4-EPIMERASE AND UDP-XYLOSE 4-EPIMERASE 3', 246525),
(366911, 'PTHR43725:SF46', NULL, NULL, NULL, NULL, 'UDP-ARABINOSE 4-EPIMERASE 3-RELATED', 246525),
(366912, 'PTHR43725:SF23', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 4-EPIMERASE', 246525),
(366913, 'PTHR43725:SF45', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 4-EPIMERASE', 246525),
(366914, 'PTHR43725:SF44', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 4-EPIMERASE 2', 246525),
(366915, 'PTHR43725:SF22', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 4-EPIMERASE 5', 246525),
(366916, 'PTHR43725:SF28', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 4-EPIMERASE', 246525),
(366917, 'PTHR43725:SF27', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 4-EPIMERASE', 246525),
(366918, 'PTHR43725:SF26', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 4-EPIMERASE', 246525),
(366919, 'PTHR43725:SF48', NULL, NULL, NULL, NULL, 'NAD(P)-BD_DOM DOMAIN-CONTAINING PROTEIN', 246525),
(366920, 'PTHR43725', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 4-EPIMERASE', 246525),
(366921, 'PTHR43725:SF43', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 4-EPIMERASE 2', 246525),
(366922, 'PTHR43725:SF42', NULL, NULL, NULL, NULL, 'UDP-ARABINOSE 4-EPIMERASE 1-LIKE', 246525),
(366923, 'PTHR43725:SF41', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 4-EPIMERASE GALE-RELATED', 246525),
(366924, 'PTHR43725:SF40', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN-RELATED', 246525),
(366925, 'PTHR43725:SF6', NULL, NULL, NULL, NULL, 'CHLOROPLAST STEM-LOOP BINDING PROTEIN OF 41 KDA A, CHLOROPLASTIC', 246525),
(366926, 'PTHR43725:SF36', NULL, NULL, NULL, NULL, 'UDP-ARABINOSE 4-EPIMERASE 4-RELATED', 246525),
(366927, 'PTHR43725:SF35', NULL, NULL, NULL, NULL, 'UDP-ARABINOSE 4-EPIMERASE-RELATED', 246525),
(366928, 'PTHR43725:SF12', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 4-EPIMERASE 4', 246525),
(366929, 'PTHR43725:SF34', NULL, NULL, NULL, NULL, 'UDP-ARABINOSE 4-EPIMERASE 2-RELATED', 246525),
(366930, 'PTHR43725:SF33', NULL, NULL, NULL, NULL, 'UDP-ARABINOSE 4-EPIMERASE 2-RELATED', 246525),
(366931, 'PTHR43725:SF3', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 4-EPIMERASE (EUROFUNG)', 246525),
(366932, 'PTHR43725:SF39', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 4-EPIMERASE UGE1', 246525),
(366933, 'PTHR43725:SF38', NULL, NULL, NULL, NULL, 'UDP-ARABINOSE 4-EPIMERASE 3-RELATED', 246525);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(366934, 'PTHR43725:SF15', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL UDP-GLUCOSE 4-EPIMERASE AND UDP-XYLOSE 4-EPIMERASE 1', 246525),
(366935, 'PTHR43725:SF1', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 4-EPIMERASE 4', 246525),
(366936, 'PTHR43725:SF37', NULL, NULL, NULL, NULL, 'UDP-ARABINOSE 4-EPIMERASE 1', 246525),
(366937, 'PTHR43725:SF8', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 4-EPIMERASE', 246525),
(366938, 'PTHR38493:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 1 OPEN READING FRAME 167', 246526),
(366939, 'PTHR38493', NULL, NULL, NULL, NULL, 'CHROMOSOME 1 OPEN READING FRAME 167', 246526),
(366940, 'PTHR21660:SF52', NULL, NULL, NULL, NULL, 'SUPERFAMILY PROTEIN, PUTATIVE-RELATED', 246527),
(366941, 'PTHR21660:SF50', NULL, NULL, NULL, NULL, '4HBT DOMAIN-CONTAINING PROTEIN', 246527),
(366942, 'PTHR21660:SF1', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A THIOESTERASE 13', 246527),
(366943, 'PTHR21660', NULL, NULL, NULL, NULL, 'THIOESTERASE SUPERFAMILY MEMBER-RELATED', 246527),
(366944, 'PTHR21660:SF37', NULL, NULL, NULL, NULL, 'OS04G0436100 PROTEIN', 246527),
(366945, 'PTHR21660:SF38', NULL, NULL, NULL, NULL, '4HBT DOMAIN-CONTAINING PROTEIN', 246527),
(366946, 'PTHR21660:SF35', NULL, NULL, NULL, NULL, '4HBT DOMAIN-CONTAINING PROTEIN', 246527),
(366947, 'PTHR21660:SF57', NULL, NULL, NULL, NULL, 'PAAI THIOESTERASE', 246527),
(366948, 'PTHR21660:SF55', NULL, NULL, NULL, NULL, 'ESTERASE F42H10.6-RELATED', 246527),
(366949, 'PTHR21660:SF11', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G04355)-RELATED', 246527),
(366950, 'PTHR21660:SF8', NULL, NULL, NULL, NULL, 'OS02G0521700 PROTEIN', 246527),
(366951, 'PTHR21660:SF9', NULL, NULL, NULL, NULL, '4HBT DOMAIN-CONTAINING PROTEIN', 246527),
(366952, 'PTHR21660:SF12', NULL, NULL, NULL, NULL, 'OS07G0462700 PROTEIN', 246527),
(366953, 'PTHR21660:SF56', NULL, NULL, NULL, NULL, '4HBT DOMAIN-CONTAINING PROTEIN', 246527),
(366954, 'PTHR21660:SF53', NULL, NULL, NULL, NULL, '4HBT DOMAIN-CONTAINING PROTEIN', 246527),
(366955, 'PTHR21660:SF10', NULL, NULL, NULL, NULL, '4HBT DOMAIN-CONTAINING PROTEIN', 246527),
(366956, 'PTHR21660:SF32', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A THIOESTERASE 13-LIKE ISOFORM X1', 246527),
(366957, 'PTHR21660:SF40', NULL, NULL, NULL, NULL, 'OS01G0229600 PROTEIN', 246527),
(366958, 'PTHR21660:SF48', NULL, NULL, NULL, NULL, '4HBT DOMAIN-CONTAINING PROTEIN', 246527),
(366959, 'PTHR21660:SF46', NULL, NULL, NULL, NULL, 'SUPERFAMILY PROTEIN, PUTATIVE-RELATED', 246527),
(366960, 'PTHR21660:SF47', NULL, NULL, NULL, NULL, 'F19P19.27 PROTEIN', 246527),
(366961, 'PTHR21660:SF44', NULL, NULL, NULL, NULL, '4HBT DOMAIN-CONTAINING PROTEIN', 246527),
(366962, 'PTHR21660:SF45', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A THIOESTERASE 13-LIKE', 246527),
(366963, 'PTHR21660:SF42', NULL, NULL, NULL, NULL, '', 246527),
(366964, 'PTHR21660:SF43', NULL, NULL, NULL, NULL, '4HBT DOMAIN-CONTAINING PROTEIN', 246527),
(366965, 'PTHR21349', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L21', 246528),
(366966, 'PTHR21349:SF6', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L21, MITOCHONDRIAL', 246528),
(366967, 'PTHR21349:SF7', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L21, CHLOROPLASTIC', 246528),
(366968, 'PTHR21349:SF4', NULL, NULL, NULL, NULL, 'BNAA01G06210D PROTEIN', 246528),
(366969, 'PTHR21349:SF0', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L21, MITOCHONDRIAL', 246528),
(366970, 'PTHR10196:SF90', NULL, NULL, NULL, NULL, 'GLYCEROL KINASE', 246529),
(366971, 'PTHR10196:SF60', NULL, NULL, NULL, NULL, 'L-FUCULOKINASE', 246529),
(366972, 'PTHR10196:SF93', NULL, NULL, NULL, NULL, 'L-RHAMNULOKINASE', 246529),
(366973, 'PTHR10196:SF82', NULL, NULL, NULL, NULL, 'GLYCEROL KINASE', 246529),
(366974, 'PTHR10196:SF80', NULL, NULL, NULL, NULL, 'D-RIBULOSE KINASE', 246529),
(366975, 'PTHR10196:SF64', NULL, NULL, NULL, NULL, 'GLYCEROL KINASE', 246529),
(366976, 'PTHR10196:SF53', NULL, NULL, NULL, NULL, 'GLYCEROL KINASE 2', 246529),
(366977, 'PTHR10196:SF75', NULL, NULL, NULL, NULL, 'GLYCEROL KINASE', 246529),
(366978, 'PTHR10196:SF40', NULL, NULL, NULL, NULL, 'GLYCEROL KINASE', 246529);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(366979, 'PTHR10196:SF95', NULL, NULL, NULL, NULL, 'GLYCEROL KINASE 3', 246529),
(366980, 'PTHR10196:SF85', NULL, NULL, NULL, NULL, 'XYLULOSE KINASE', 246529),
(366981, 'PTHR10196:SF46', NULL, NULL, NULL, NULL, 'GLYCEROL KINASE 2', 246529),
(366982, 'PTHR10196:SF57', NULL, NULL, NULL, NULL, 'XYLULOSE KINASE', 246529),
(366983, 'PTHR10196:SF68', NULL, NULL, NULL, NULL, 'GLYCEROL KINASE 5-RELATED', 246529),
(366984, 'PTHR10196:SF69', NULL, NULL, NULL, NULL, 'GLYCEROL KINASE', 246529),
(366985, 'PTHR10196:SF88', NULL, NULL, NULL, NULL, 'XYLULOSE KINASE', 246529),
(366986, 'PTHR10196:SF56', NULL, NULL, NULL, NULL, 'GLYCEROL KINASE', 246529),
(366987, 'PTHR10196:SF67', NULL, NULL, NULL, NULL, 'SEDOHEPTULOKINASE', 246529),
(366988, 'PTHR10196:SF78', NULL, NULL, NULL, NULL, 'GLYCEROL KINASE', 246529),
(366989, 'PTHR10196', NULL, NULL, NULL, NULL, 'SUGAR KINASE', 246529),
(366990, 'PTHR47941:SF10', NULL, NULL, NULL, NULL, 'OS02G0759500 PROTEIN', 246530),
(366991, 'PTHR47941:SF11', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 246530),
(366992, 'PTHR47941:SF12', NULL, NULL, NULL, NULL, 'OS03G0363700 PROTEIN', 246530),
(366993, 'PTHR47941:SF13', NULL, NULL, NULL, NULL, 'OS01G0783100 PROTEIN', 246530),
(366994, 'PTHR47941:SF15', NULL, NULL, NULL, NULL, '', 246530),
(366995, 'PTHR47941:SF16', NULL, NULL, NULL, NULL, '', 246530),
(366996, 'PTHR47941:SF17', NULL, NULL, NULL, NULL, '', 246530),
(366997, 'PTHR47941:SF18', NULL, NULL, NULL, NULL, 'BNAA09G46900D PROTEIN', 246530),
(366998, 'PTHR47941:SF19', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED SALT-INDUCIBLE PROTEIN', 246530),
(366999, 'PTHR47941:SF1', NULL, NULL, NULL, NULL, 'OS04G0446100 PROTEIN', 246530),
(367000, 'PTHR47941:SF3', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 246530),
(367001, 'PTHR47941:SF2', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN-CONTAINING PROTEIN-RELATED', 246530),
(367002, 'PTHR47941:SF20', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 246530),
(367003, 'PTHR47941:SF7', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 246530),
(367004, 'PTHR47941:SF21', NULL, NULL, NULL, NULL, '', 246530),
(367005, 'PTHR47941:SF6', NULL, NULL, NULL, NULL, 'OS01G0546700 PROTEIN', 246530),
(367006, 'PTHR47941:SF22', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN 3, MITOCHONDRIAL', 246530),
(367007, 'PTHR47941:SF23', NULL, NULL, NULL, NULL, '', 246530),
(367008, 'PTHR47941:SF24', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 246530),
(367009, 'PTHR47941:SF25', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 246530),
(367010, 'PTHR47941:SF26', NULL, NULL, NULL, NULL, 'OS12G0407900 PROTEIN', 246530),
(367011, 'PTHR47941:SF27', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 246530),
(367012, 'PTHR47941', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN 3, MITOCHONDRIAL', 246530),
(367013, 'PTHR47941:SF9', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 246530),
(367014, 'PTHR47941:SF8', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 246530),
(367015, 'PTHR46037:SF6', NULL, NULL, NULL, NULL, 'SRC-LIKE-ADAPTOR 2', 246531),
(367016, 'PTHR46037:SF5', NULL, NULL, NULL, NULL, 'SRC-LIKE-ADAPTER', 246531),
(367017, 'PTHR46037:SF4', NULL, NULL, NULL, NULL, 'GROWTH FACTOR RECEPTOR-BOUND PROTEIN 2', 246531),
(367018, 'PTHR46037:SF3', NULL, NULL, NULL, NULL, 'GRB2-RELATED ADAPTER PROTEIN 2', 246531),
(367019, 'PTHR46037:SF2', NULL, NULL, NULL, NULL, 'GRB2-RELATED ADAPTER PROTEIN', 246531),
(367020, 'PTHR46037:SF1', NULL, NULL, NULL, NULL, 'GROWTH FACTOR RECEPTOR-BOUND PROTEIN 2', 246531),
(367021, 'PTHR46037', NULL, NULL, NULL, NULL, 'PROTEIN ENHANCER OF SEVENLESS 2B', 246531),
(367022, 'PTHR31541:SF44', NULL, NULL, NULL, NULL, 'BNAA05G11120D PROTEIN', 246532),
(367023, 'PTHR31541:SF42', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246532),
(367024, 'PTHR31541:SF41', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246532); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(367025, 'PTHR31541:SF40', NULL, NULL, NULL, NULL, 'BNAA04G18270D PROTEIN', 246532),
(367026, 'PTHR31541:SF28', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246532),
(367027, 'PTHR31541:SF27', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246532),
(367028, 'PTHR31541:SF49', NULL, NULL, NULL, NULL, '', 246532),
(367029, 'PTHR31541:SF48', NULL, NULL, NULL, NULL, 'DNA BINDING PROTEIN', 246532),
(367030, 'PTHR31541:SF47', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246532),
(367031, 'PTHR31541:SF25', NULL, NULL, NULL, NULL, 'B3 DOMAIN PLANT PROTEIN', 246532),
(367032, 'PTHR31541:SF46', NULL, NULL, NULL, NULL, 'BNAANNG20380D PROTEIN', 246532),
(367033, 'PTHR31541', NULL, NULL, NULL, NULL, 'B3 DOMAIN PLANT PROTEIN-RELATED', 246532),
(367034, 'PTHR31541:SF45', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246532),
(367035, 'PTHR31541:SF33', NULL, NULL, NULL, NULL, 'DUF313 DOMAIN PROTEIN', 246532),
(367036, 'PTHR31541:SF55', NULL, NULL, NULL, NULL, 'BNAC04G54200D PROTEIN', 246532),
(367037, 'PTHR31541:SF54', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246532),
(367038, 'PTHR31541:SF52', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246532),
(367039, 'PTHR31541:SF30', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246532),
(367040, 'PTHR31541:SF51', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246532),
(367041, 'PTHR31541:SF39', NULL, NULL, NULL, NULL, '', 246532),
(367042, 'PTHR31541:SF59', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246532),
(367043, 'PTHR31541:SF37', NULL, NULL, NULL, NULL, 'BNAC04G05680D PROTEIN', 246532),
(367044, 'PTHR31541:SF58', NULL, NULL, NULL, NULL, 'BNAC05G03740D PROTEIN', 246532),
(367045, 'PTHR31541:SF36', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246532),
(367046, 'PTHR31541:SF57', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246532),
(367047, 'PTHR31541:SF34', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246532),
(367048, 'PTHR31541:SF56', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (DUF313)-RELATED', 246532),
(367049, 'PTHR39365:SF2', NULL, NULL, NULL, NULL, 'MX REGION OF TRA-2 RELATED-RELATED', 246533),
(367050, 'PTHR39365', NULL, NULL, NULL, NULL, 'MX REGION OF TRA-2 RELATED-RELATED', 246533),
(367051, 'PTHR34131', NULL, NULL, NULL, NULL, '(RAP ANNOTATION RELEASE2) GALACTOSE-BINDING LIKE DOMAIN CONTAINING PROTEIN', 246534),
(367052, 'PTHR34131:SF3', NULL, NULL, NULL, NULL, '(RAP ANNOTATION RELEASE2) GALACTOSE-BINDING LIKE DOMAIN CONTAINING PROTEIN', 246534),
(367053, 'PTHR34131:SF2', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE (DUF1997)-RELATED', 246534),
(367054, 'PTHR13771:SF17', NULL, NULL, NULL, NULL, 'INTERCELLULAR ADHESION MOLECULE 3', 246535),
(367055, 'PTHR13771:SF18', NULL, NULL, NULL, NULL, 'INTERCELLULAR ADHESION MOLECULE 1', 246535),
(367056, 'PTHR13771:SF4', NULL, NULL, NULL, NULL, 'CELL ADHESION MOLECULE TCAM-1', 246535),
(367057, 'PTHR13771:SF9', NULL, NULL, NULL, NULL, 'INTERCELLULAR ADHESION MOLECULE 5', 246535),
(367058, 'PTHR13771:SF8', NULL, NULL, NULL, NULL, 'INTERCELLULAR ADHESION MOLECULE 4', 246535),
(367059, 'PTHR13771:SF19', NULL, NULL, NULL, NULL, 'INTERCELLULAR ADHESION MOLECULE 3-RELATED', 246535),
(367060, 'PTHR13771', NULL, NULL, NULL, NULL, 'INTERCELLULAR ADHESION MOLECULE', 246535),
(367061, 'PTHR13771:SF14', NULL, NULL, NULL, NULL, 'VASCULAR CELL ADHESION PROTEIN 1', 246535),
(367062, 'PTHR13771:SF3', NULL, NULL, NULL, NULL, 'INTERCELLULAR ADHESION MOLECULE 2', 246535),
(367063, 'PTHR23308', NULL, NULL, NULL, NULL, 'NUCLEAR INHIBITOR OF PROTEIN PHOSPHATASE-1', 246536),
(367064, 'PTHR23308:SF58', NULL, NULL, NULL, NULL, 'FHA DOMAIN-CONTAINING PROTEIN', 246536),
(367065, 'PTHR23308:SF69', NULL, NULL, NULL, NULL, 'FHA DOMAIN-CONTAINING PROTEIN DDL-LIKE ISOFORM X1', 246536),
(367066, 'PTHR23308:SF36', NULL, NULL, NULL, NULL, 'SMAD NUCLEAR-INTERACTING PROTEIN 1', 246536),
(367067, 'PTHR23308:SF28', NULL, NULL, NULL, NULL, 'NUCLEAR INHIBITOR OF PROTEIN PHOSPHATASE 1', 246536);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(367068, 'PTHR23308:SF66', NULL, NULL, NULL, NULL, 'KANADAPTIN', 246536),
(367069, 'PTHR23308:SF65', NULL, NULL, NULL, NULL, 'FHA DOMAIN-CONTAINING PROTEIN', 246536),
(367070, 'PTHR23308:SF68', NULL, NULL, NULL, NULL, 'FHA DOMAIN-CONTAINING PROTEIN', 246536),
(367071, 'PTHR23308:SF67', NULL, NULL, NULL, NULL, 'FHA DOMAIN-CONTAINING PROTEIN', 246536),
(367072, 'PTHR23308:SF61', NULL, NULL, NULL, NULL, 'FHA DOMAIN-CONTAINING PROTEIN', 246536),
(367073, 'PTHR23308:SF53', NULL, NULL, NULL, NULL, 'FHA DOMAIN-CONTAINING PROTEIN', 246536),
(367074, 'PTHR23308:SF71', NULL, NULL, NULL, NULL, 'FHA DOMAIN-CONTAINING PROTEIN FHAA', 246536),
(367075, 'PTHR23308:SF70', NULL, NULL, NULL, NULL, 'FHA DOMAIN CONTAINING PROTEIN, EXPRESSED', 246536),
(367076, 'PTHR46465:SF2', NULL, NULL, NULL, NULL, 'LATERAL SIGNALING TARGET PROTEIN 2 HOMOLOG', 246537),
(367077, 'PTHR46465', NULL, NULL, NULL, NULL, 'LATERAL SIGNALING TARGET PROTEIN 2 HOMOLOG', 246537),
(367078, 'PTHR46848:SF1', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING 3', 246538),
(367079, 'PTHR46848', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING 3', 246538),
(367080, 'PTHR23075:SF8', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN', 246539),
(367081, 'PTHR23075:SF6', NULL, NULL, NULL, NULL, 'AAA-TYPE ATPASE FAMILY PROTEIN', 246539),
(367082, 'PTHR23075:SF7', NULL, NULL, NULL, NULL, 'AAA-TYPE ATPASE FAMILY PROTEIN', 246539),
(367083, 'PTHR23075', NULL, NULL, NULL, NULL, 'PUTATIVE ATP-ASE', 246539),
(367084, 'PTHR23075:SF0', NULL, NULL, NULL, NULL, 'ATPASE FAMILY AAA DOMAIN-CONTAINING PROTEIN 3', 246539),
(367085, 'PTHR23075:SF11', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 246539),
(367086, 'PTHR23075:SF4', NULL, NULL, NULL, NULL, 'ATPASE FAMILY AAA DOMAIN-CONTAINING PROTEIN 3C', 246539),
(367087, 'PTHR23075:SF5', NULL, NULL, NULL, NULL, 'ATPASE FAMILY AAA DOMAIN-CONTAINING PROTEIN 3A', 246539),
(367088, 'PTHR23075:SF2', NULL, NULL, NULL, NULL, 'ATPASE FAMILY AAA DOMAIN-CONTAINING PROTEIN 3B', 246539),
(367089, 'PTHR15921:SF16', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II-BINDING DOMAIN PROTEIN', 246540),
(367090, 'PTHR15921:SF3', NULL, NULL, NULL, NULL, 'PRE-MRNA CLEAVAGE COMPLEX 2 PROTEIN PCF11', 246540),
(367091, 'PTHR15921:SF12', NULL, NULL, NULL, NULL, 'POLYADENYLATION AND CLEAVAGE FACTOR HOMOLOG 4', 246540),
(367092, 'PTHR15921:SF13', NULL, NULL, NULL, NULL, '', 246540),
(367093, 'PTHR15921:SF10', NULL, NULL, NULL, NULL, 'ZINC FINGER, C2H2, ENTH/VHS-RELATED', 246540),
(367094, 'PTHR15921', NULL, NULL, NULL, NULL, 'PRE-MRNA CLEAVAGE COMPLEX II', 246540),
(367095, 'PTHR15921:SF11', NULL, NULL, NULL, NULL, 'POLYADENYLATION AND CLEAVAGE FACTOR HOMOLOG 1-RELATED', 246540),
(367096, 'PTHR15921:SF7', NULL, NULL, NULL, NULL, 'SR-RELATED AND CTD-ASSOCIATED FACTOR 8', 246540),
(367097, 'PTHR14241', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED PROTEIN 44', 246541),
(367098, 'PTHR14241:SF21', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246541),
(367099, 'PTHR14241:SF32', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN-RELATED', 246541),
(367100, 'PTHR14241:SF33', NULL, NULL, NULL, NULL, '', 246541),
(367101, 'PTHR14241:SF31', NULL, NULL, NULL, NULL, '', 246541),
(367102, 'PTHR14241:SF3', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED PROTEIN 44', 246541),
(367103, 'PTHR14241:SF19', NULL, NULL, NULL, NULL, 'SI:CH211-197G15.10-RELATED', 246541),
(367104, 'PTHR14241:SF28', NULL, NULL, NULL, NULL, '', 246541),
(367105, 'PTHR14241:SF34', NULL, NULL, NULL, NULL, 'TLDC DOMAIN-CONTAINING PROTEIN', 246541),
(367106, 'PTHR14241:SF1', NULL, NULL, NULL, NULL, 'G DOMAIN-CONTAINING PROTEIN-RELATED', 246541),
(367107, 'PTHR14241:SF24', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE-RELATED', 246541),
(367108, 'PTHR14241:SF2', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED PROTEIN 44-LIKE', 246541),
(367109, 'PTHR31599', NULL, NULL, NULL, NULL, 'CALCIUM UP-REGULATED PROTEIN A-RELATED', 246542),
(367110, 'PTHR31599:SF2', NULL, NULL, NULL, NULL, 'CALCIUM UP-REGULATED PROTEIN A-RELATED', 246542); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(367111, 'PTHR39075', NULL, NULL, NULL, NULL, 'FI19908P1', 246543),
(367112, 'PTHR39075:SF1', NULL, NULL, NULL, NULL, 'FI19908P1', 246543),
(367113, 'PTHR46949', NULL, NULL, NULL, NULL, 'LEUCINE REPEAT ADAPTER PROTEIN 25', 246544),
(367114, 'PTHR46949:SF1', NULL, NULL, NULL, NULL, 'FAMILY WITH SEQUENCE SIMILARITY 89 MEMBER A-RELATED', 246544),
(367115, 'PTHR46949:SF2', NULL, NULL, NULL, NULL, 'LEUCINE REPEAT ADAPTER PROTEIN 25', 246544),
(367116, 'PTHR46949:SF3', NULL, NULL, NULL, NULL, 'PROTEIN FAM89A', 246544),
(367117, 'PTHR12522:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 703', 246545),
(367118, 'PTHR12522', NULL, NULL, NULL, NULL, 'ZINC-FINGER PROTEIN NOLZ1-RELATED', 246545),
(367119, 'PTHR12522:SF4', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ELBOW', 246545),
(367120, 'PTHR12522:SF3', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 503', 246545),
(367121, 'PTHR12522:SF5', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN NOC', 246545),
(367122, 'PTHR39297', NULL, NULL, NULL, NULL, '', 246546),
(367123, 'PTHR39297:SF1', NULL, NULL, NULL, NULL, '', 246546),
(367124, 'PTHR33199:SF1', NULL, NULL, NULL, NULL, 'OS01G0958700 PROTEIN', 246547),
(367125, 'PTHR33199:SF21', NULL, NULL, NULL, NULL, 'MACPF DOMAIN-CONTAINING PROTEIN', 246547),
(367126, 'PTHR33199:SF10', NULL, NULL, NULL, NULL, 'MACPF DOMAIN-CONTAINING PROTEIN CAD1-LIKE', 246547),
(367127, 'PTHR33199:SF20', NULL, NULL, NULL, NULL, 'MACPF DOMAIN-CONTAINING PROTEIN', 246547),
(367128, 'PTHR33199:SF8', NULL, NULL, NULL, NULL, 'MACPF DOMAIN-CONTAINING PROTEIN NSL1', 246547),
(367129, 'PTHR33199:SF7', NULL, NULL, NULL, NULL, 'OS06G0251100 PROTEIN', 246547),
(367130, 'PTHR33199:SF12', NULL, NULL, NULL, NULL, 'MACPF DOMAIN-CONTAINING PROTEIN', 246547),
(367131, 'PTHR33199:SF6', NULL, NULL, NULL, NULL, 'MACPF DOMAIN PROTEIN', 246547),
(367132, 'PTHR33199:SF14', NULL, NULL, NULL, NULL, 'MAC/PERFORIN DOMAIN PROTEIN', 246547),
(367133, 'PTHR33199:SF13', NULL, NULL, NULL, NULL, 'MAC/PERFORIN DOMAIN-CONTAINING PROTEIN', 246547),
(367134, 'PTHR33199:SF4', NULL, NULL, NULL, NULL, 'OS02G0736300 PROTEIN', 246547),
(367135, 'PTHR33199:SF3', NULL, NULL, NULL, NULL, 'MACPF DOMAIN-CONTAINING PROTEIN CAD1', 246547),
(367136, 'PTHR33199:SF15', NULL, NULL, NULL, NULL, 'MACPF DOMAIN-CONTAINING PROTEIN', 246547),
(367137, 'PTHR33199:SF2', NULL, NULL, NULL, NULL, 'OS02G0475300 PROTEIN', 246547),
(367138, 'PTHR33199:SF18', NULL, NULL, NULL, NULL, 'MACPF DOMAIN-CONTAINING PROTEIN', 246547),
(367139, 'PTHR33199:SF17', NULL, NULL, NULL, NULL, 'MACPF DOMAIN-CONTAINING PROTEIN', 246547),
(367140, 'PTHR33199:SF19', NULL, NULL, NULL, NULL, 'MEMBRANE ATTACK COMPLEX COMPONENT/PERFORIN (MACPF) DOMAIN-CONTAINING PROTEIN-RELATED', 246547),
(367141, 'PTHR33199', NULL, NULL, NULL, NULL, 'MACPF DOMAIN-CONTAINING PROTEIN CAD1', 246547),
(367142, 'PTHR36919:SF2', NULL, NULL, NULL, NULL, 'BLR1215 PROTEIN', 246548),
(367143, 'PTHR36919', NULL, NULL, NULL, NULL, 'BLR1215 PROTEIN', 246548),
(367144, 'PTHR34591:SF30', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246549),
(367145, 'PTHR34591:SF10', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246549),
(367146, 'PTHR34591:SF32', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246549),
(367147, 'PTHR34591:SF33', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246549),
(367148, 'PTHR34591:SF11', NULL, NULL, NULL, NULL, 'OS03G0653100 PROTEIN', 246549),
(367149, 'PTHR34591:SF50', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246549),
(367150, 'PTHR34591:SF38', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246549),
(367151, 'PTHR34591:SF39', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246549),
(367152, 'PTHR34591:SF17', NULL, NULL, NULL, NULL, 'OS01G0824700 PROTEIN', 246549),
(367153, 'PTHR34591:SF12', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246549),
(367154, 'PTHR34591:SF35', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246549),
(367155, 'PTHR34591:SF13', NULL, NULL, NULL, NULL, 'OS03G0669900 PROTEIN', 246549),
(367156, 'PTHR34591:SF36', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246549);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(367157, 'PTHR34591:SF37', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246549),
(367158, 'PTHR34591', NULL, NULL, NULL, NULL, 'OS03G0653100 PROTEIN-RELATED', 246549),
(367159, 'PTHR34591:SF41', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246549),
(367160, 'PTHR34591:SF43', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246549),
(367161, 'PTHR34591:SF21', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', 246549),
(367162, 'PTHR34591:SF22', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246549),
(367163, 'PTHR34591:SF40', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246549),
(367164, 'PTHR34591:SF49', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246549),
(367165, 'PTHR34591:SF28', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246549),
(367166, 'PTHR34591:SF29', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', 246549),
(367167, 'PTHR34591:SF23', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246549),
(367168, 'PTHR34591:SF47', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246549),
(367169, 'PTHR34591:SF48', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246549),
(367170, 'PTHR11122:SF44', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-EPIMERASE', 246550),
(367171, 'PTHR11122:SF45', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-EPIMERASE', 246550),
(367172, 'PTHR11122:SF46', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-EPIMERASE', 246550),
(367173, 'PTHR11122:SF48', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-EPIMERASE', 246550),
(367174, 'PTHR11122:SF49', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-EPIMERASE', 246550),
(367175, 'PTHR11122:SF40', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-EPIMERASE', 246550),
(367176, 'PTHR11122:SF41', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-EPIMERASE', 246550),
(367177, 'PTHR11122:SF31', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-EPIMERASE', 246550),
(367178, 'PTHR11122:SF53', NULL, NULL, NULL, NULL, 'ALDOSE 1-/GLUCOSE-6-PHOSPHATE 1-EPIMERASE, GALACTOSE MUTAROTASE-LIKE DOMAIN PROTEIN-RELATED', 246550),
(367179, 'PTHR11122:SF54', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-EPIMERASE', 246550),
(367180, 'PTHR11122:SF10', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-EPIMERASE', 246550),
(367181, 'PTHR11122:SF33', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-EPIMERASE', 246550),
(367182, 'PTHR11122:SF34', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-EPIMERASE', 246550),
(367183, 'PTHR11122:SF35', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-EPIMERASE', 246550),
(367184, 'PTHR11122:SF13', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-EPIMERASE', 246550),
(367185, 'PTHR11122:SF57', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-EPIMERASE', 246550),
(367186, 'PTHR11122:SF58', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-EPIMERASE', 246550),
(367187, 'PTHR11122:SF36', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-EPIMERASE', 246550),
(367188, 'PTHR11122:SF15', NULL, NULL, NULL, NULL, 'PROTEIN NDH-DEPENDENT CYCLIC ELECTRON FLOW 5', 246550),
(367189, 'PTHR11122:SF51', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-EPIMERASE', 246550),
(367190, 'PTHR11122:SF52', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-EPIMERASE', 246550),
(367191, 'PTHR11122:SF39', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-EPIMERASE', 246550),
(367192, 'PTHR11122:SF18', NULL, NULL, NULL, NULL, 'PHOTOSYNTHETIC NDH SUBUNIT OF SUBCOMPLEX B 2, CHLOROPLASTIC', 246550),
(367193, 'PTHR11122:SF19', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-EPIMERASE', 246550),
(367194, 'PTHR11122', NULL, NULL, NULL, NULL, 'APOSPORY-ASSOCIATED PROTEIN C-RELATED', 246550),
(367195, 'PTHR34198:SF16', NULL, NULL, NULL, NULL, '', 246551),
(367196, 'PTHR34198:SF8', NULL, NULL, NULL, NULL, '', 246551),
(367197, 'PTHR34198:SF21', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 246551),
(367198, 'PTHR34198', NULL, NULL, NULL, NULL, 'OS01G0175100 PROTEIN', 246551),
(367199, 'PTHR34198:SF20', NULL, NULL, NULL, NULL, 'BNAA05G35680D PROTEIN', 246551);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(367200, 'PTHR34198:SF23', NULL, NULL, NULL, NULL, 'OS05G0189200 PROTEIN', 246551),
(367201, 'PTHR34198:SF11', NULL, NULL, NULL, NULL, '', 246551),
(367202, 'PTHR34198:SF1', NULL, NULL, NULL, NULL, 'OS01G0104300 PROTEIN', 246551),
(367203, 'PTHR13136:SF13', NULL, NULL, NULL, NULL, 'KAT8 REGULATORY NSL COMPLEX SUBUNIT 3/TESTIS-EXPRESSED SEQUENCE 30 PROTEIN-RELATED', 246552),
(367204, 'PTHR13136:SF11', NULL, NULL, NULL, NULL, 'KAT8 REGULATORY NSL COMPLEX SUBUNIT 3', 246552),
(367205, 'PTHR13136:SF15', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 30', 246552),
(367206, 'PTHR13136', NULL, NULL, NULL, NULL, 'TESTIS DEVELOPMENT PROTEIN PRTD', 246552),
(367207, 'PTHR47542', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASES (NAT) SUPERFAMILY PROTEIN', 246553),
(367208, 'PTHR47542:SF2', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASES (NAT) SUPERFAMILY PROTEIN', 246553),
(367209, 'PTHR35205:SF1', NULL, NULL, NULL, NULL, 'AAA_16 DOMAIN-CONTAINING PROTEIN', 246554),
(367210, 'PTHR35205', NULL, NULL, NULL, NULL, 'NB-ARC AND TPR DOMAIN PROTEIN', 246554),
(367211, 'PTHR21337:SF32', NULL, NULL, NULL, NULL, 'PHOSPHO-2-DEHYDRO-3-DEOXYHEPTONATE ALDOLASE 1, CHLOROPLASTIC', 246555),
(367212, 'PTHR21337', NULL, NULL, NULL, NULL, 'PHOSPHO-2-DEHYDRO-3-DEOXYHEPTONATE ALDOLASE 1, 2', 246555),
(367213, 'PTHR21337:SF4', NULL, NULL, NULL, NULL, 'PHOSPHO-2-DEHYDRO-3-DEOXYHEPTONATE ALDOLASE', 246555),
(367214, 'PTHR21337:SF25', NULL, NULL, NULL, NULL, 'PHOSPHO-2-DEHYDRO-3-DEOXYHEPTONATE ALDOLASE', 246555),
(367215, 'PTHR21337:SF23', NULL, NULL, NULL, NULL, 'PHOSPHO-2-DEHYDRO-3-DEOXYHEPTONATE ALDOLASE', 246555),
(367216, 'PTHR21337:SF24', NULL, NULL, NULL, NULL, 'PHOSPHO-2-DEHYDRO-3-DEOXYHEPTONATE ALDOLASE 1, CHLOROPLASTIC', 246555),
(367217, 'PTHR21337:SF29', NULL, NULL, NULL, NULL, 'PHOSPHO-2-DEHYDRO-3-DEOXYHEPTONATE ALDOLASE', 246555),
(367218, 'PTHR21337:SF19', NULL, NULL, NULL, NULL, 'PHOSPHO-2-DEHYDRO-3-DEOXYHEPTONATE ALDOLASE 2, CHLOROPLASTIC', 246555),
(367219, 'PTHR21337:SF27', NULL, NULL, NULL, NULL, 'PHOSPHO-2-DEHYDRO-3-DEOXYHEPTONATE ALDOLASE', 246555),
(367220, 'PTHR21337:SF28', NULL, NULL, NULL, NULL, 'PHOSPHO-2-DEHYDRO-3-DEOXYHEPTONATE ALDOLASE 2, CHLOROPLASTIC', 246555),
(367221, 'PTHR21337:SF0', NULL, NULL, NULL, NULL, 'PHOSPHO-2-DEHYDRO-3-DEOXYHEPTONATE ALDOLASE', 246555),
(367222, 'PTHR31642:SF181', NULL, NULL, NULL, NULL, '', 246556),
(367223, 'PTHR31642:SF180', NULL, NULL, NULL, NULL, 'HXXXD-TYPE ACYL-TRANSFERASE FAMILY PROTEIN', 246556),
(367224, 'PTHR31642:SF16', NULL, NULL, NULL, NULL, 'OS08G0543400 PROTEIN', 246556),
(367225, 'PTHR31642:SF189', NULL, NULL, NULL, NULL, 'HXXXD-TYPE ACYL-TRANSFERASE FAMILY PROTEIN', 246556),
(367226, 'PTHR31642:SF11', NULL, NULL, NULL, NULL, 'SHIKIMATE O-HYDROXYCINNAMOYLTRANSFERASE', 246556),
(367227, 'PTHR31642:SF221', NULL, NULL, NULL, NULL, 'ACYL-TRANSFERASE FAMILY PROTEIN, PUTATIVE-RELATED', 246556),
(367228, 'PTHR31642:SF188', NULL, NULL, NULL, NULL, 'SHIKIMATE O-HYDROXYCINNAMOYLTRANSFERASE-LIKE ISOFORM X1', 246556),
(367229, 'PTHR31642:SF13', NULL, NULL, NULL, NULL, 'AGMATINE HYDROXYCINNAMOYLTRANSFERASE 1', 246556),
(367230, 'PTHR31642:SF224', NULL, NULL, NULL, NULL, 'N-BENZOYLTRANSFERASE, PUTATIVE-RELATED', 246556),
(367231, 'PTHR31642:SF185', NULL, NULL, NULL, NULL, '(Z)-3-HEXEN-1-OL ACETYLTRANSFERASE', 246556),
(367232, 'PTHR31642:SF184', NULL, NULL, NULL, NULL, 'SPERMIDINE HYDROXYCINNAMOYL TRANSFERASE', 246556),
(367233, 'PTHR31642:SF220', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE 2', 246556),
(367234, 'PTHR31642:SF186', NULL, NULL, NULL, NULL, 'BRASSINOSTEROID-RELATED ACYLTRANSFERASE 1-LIKE', 246556),
(367235, 'PTHR31642', NULL, NULL, NULL, NULL, 'TRICHOTHECENE 3-O-ACETYLTRANSFERASE', 246556),
(367236, 'PTHR31642:SF225', NULL, NULL, NULL, NULL, 'BNAANNG21320D PROTEIN', 246556),
(367237, 'PTHR31642:SF228', NULL, NULL, NULL, NULL, 'TRANSFERASE, CHLORAMPHENICOL ACETYLTRANSFERASE-LIKE DOMAIN PROTEIN-RELATED', 246556),
(367238, 'PTHR31642:SF192', NULL, NULL, NULL, NULL, '', 246556),
(367239, 'PTHR31642:SF191', NULL, NULL, NULL, NULL, 'BENZYL ALCOHOL O-BENZOYLTRANSFERASE-LIKE', 246556);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(367240, 'PTHR31642:SF194', NULL, NULL, NULL, NULL, 'SHIKIMATE O-HYDROXYCINNAMOYLTRANSFERASE-LIKE', 246556),
(367241, 'PTHR31642:SF193', NULL, NULL, NULL, NULL, 'OS04G0609300 PROTEIN', 246556),
(367242, 'PTHR31642:SF232', NULL, NULL, NULL, NULL, 'BNAC01G22120D PROTEIN', 246556),
(367243, 'PTHR31642:SF114', NULL, NULL, NULL, NULL, 'OS07G0244600 PROTEIN', 246556),
(367244, 'PTHR31642:SF113', NULL, NULL, NULL, NULL, 'OS01G0924933 PROTEIN', 246556),
(367245, 'PTHR31642:SF196', NULL, NULL, NULL, NULL, 'SHIKIMATE O-HYDROXYCINNAMOYLTRANSFERASE-LIKE ISOFORM X1', 246556),
(367246, 'PTHR31642:SF198', NULL, NULL, NULL, NULL, '', 246556),
(367247, 'PTHR31642:SF231', NULL, NULL, NULL, NULL, 'OMEGA-HYDROXYPALMITATE O-FERULOYL TRANSFERASE-LIKE', 246556),
(367248, 'PTHR31642:SF230', NULL, NULL, NULL, NULL, '', 246556),
(367249, 'PTHR31642:SF237', NULL, NULL, NULL, NULL, 'OS06G0151100 PROTEIN', 246556),
(367250, 'PTHR31642:SF115', NULL, NULL, NULL, NULL, 'PROTEIN ECERIFERUM 26', 246556),
(367251, 'PTHR31642:SF239', NULL, NULL, NULL, NULL, '', 246556),
(367252, 'PTHR31642:SF38', NULL, NULL, NULL, NULL, 'TRYPTAMINE BENZOYLTRANSFERASE 2', 246556),
(367253, 'PTHR31642:SF244', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE 2', 246556),
(367254, 'PTHR31642:SF33', NULL, NULL, NULL, NULL, 'OS09G0422000 PROTEIN', 246556),
(367255, 'PTHR31642:SF243', NULL, NULL, NULL, NULL, 'HXXXD-TYPE ACYL-TRANSFERASE FAMILY PROTEIN-RELATED', 246556),
(367256, 'PTHR31642:SF32', NULL, NULL, NULL, NULL, 'OS04G0507400 PROTEIN', 246556),
(367257, 'PTHR31642:SF240', NULL, NULL, NULL, NULL, '', 246556),
(367258, 'PTHR31642:SF241', NULL, NULL, NULL, NULL, 'OS07G0550600 PROTEIN', 246556),
(367259, 'PTHR31642:SF248', NULL, NULL, NULL, NULL, 'HXXXD-TYPE ACYL-TRANSFERASE FAMILY PROTEIN', 246556),
(367260, 'PTHR31642:SF127', NULL, NULL, NULL, NULL, 'OS05G0141300 PROTEIN', 246556),
(367261, 'PTHR31642:SF26', NULL, NULL, NULL, NULL, 'HXXXD-TYPE ACYL-TRANSFERASE FAMILY PROTEIN', 246556),
(367262, 'PTHR31642:SF25', NULL, NULL, NULL, NULL, 'SPERMIDINE HYDROXYCINNAMOYL TRANSFERASE', 246556),
(367263, 'PTHR31642:SF28', NULL, NULL, NULL, NULL, 'OS06G0150600 PROTEIN', 246556),
(367264, 'PTHR31642:SF254', NULL, NULL, NULL, NULL, 'TRANSFERASE, CHLORAMPHENICOL ACETYLTRANSFERASE-LIKE DOMAIN PROTEIN-RELATED', 246556),
(367265, 'PTHR31642:SF5', NULL, NULL, NULL, NULL, 'OS01G0104900 PROTEIN', 246556),
(367266, 'PTHR31642:SF21', NULL, NULL, NULL, NULL, 'OS07G0421600 PROTEIN', 246556),
(367267, 'PTHR31642:SF257', NULL, NULL, NULL, NULL, 'SPERMIDINE HYDROXYCINNAMOYL TRANSFERASE-RELATED', 246556),
(367268, 'PTHR31642:SF23', NULL, NULL, NULL, NULL, 'SPERMIDINE HYDROXYCINNAMOYL TRANSFERASE', 246556),
(367269, 'PTHR31642:SF256', NULL, NULL, NULL, NULL, 'BNACNNG59260D PROTEIN', 246556),
(367270, 'PTHR31642:SF9', NULL, NULL, NULL, NULL, 'BENZYL ALCOHOL O-BENZOYLTRANSFERASE', 246556),
(367271, 'PTHR31642:SF253', NULL, NULL, NULL, NULL, 'HXXXD-TYPE ACYL-TRANSFERASE FAMILY PROTEIN-RELATED', 246556),
(367272, 'PTHR31642:SF252', NULL, NULL, NULL, NULL, 'BNACNNG03180D PROTEIN', 246556),
(367273, 'PTHR31642:SF138', NULL, NULL, NULL, NULL, 'PUTRESCINE HYDROXYCINNAMOYLTRANSFERASE 1', 246556),
(367274, 'PTHR31642:SF259', NULL, NULL, NULL, NULL, 'PROTEIN ECERIFERUM 2', 246556),
(367275, 'PTHR31642:SF137', NULL, NULL, NULL, NULL, '', 246556),
(367276, 'PTHR31642:SF139', NULL, NULL, NULL, NULL, 'SPERMIDINE HYDROXYCINNAMOYL TRANSFERASE', 246556),
(367277, 'PTHR31642:SF260', NULL, NULL, NULL, NULL, 'SHIKIMATE O-HYDROXYCINNAMOYLTRANSFERASE-LIKE', 246556),
(367278, 'PTHR31642:SF266', NULL, NULL, NULL, NULL, 'HXXXD-TYPE ACYL-TRANSFERASE FAMILY PROTEIN', 246556),
(367279, 'PTHR31642:SF145', NULL, NULL, NULL, NULL, 'BRASSINOSTEROID-RELATED ACYLTRANSFERASE 1', 246556),
(367280, 'PTHR31642:SF144', NULL, NULL, NULL, NULL, 'SPERMIDINE HYDROXYCINNAMOYL TRANSFERASE', 246556),
(367281, 'PTHR31642:SF265', NULL, NULL, NULL, NULL, 'BNAA03G00700D PROTEIN', 246556),
(367282, 'PTHR31642:SF301', NULL, NULL, NULL, NULL, '', 246556),
(367283, 'PTHR31642:SF268', NULL, NULL, NULL, NULL, 'BNACNNG39330D PROTEIN', 246556);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(367284, 'PTHR31642:SF147', NULL, NULL, NULL, NULL, 'ANTHRANILATE N-BENZOYLTRANSFERASE PROTEIN 1', 246556),
(367285, 'PTHR31642:SF146', NULL, NULL, NULL, NULL, 'TRANSFERASE', 246556),
(367286, 'PTHR31642:SF56', NULL, NULL, NULL, NULL, 'PUTRESCINE HYDROXYCINNAMOYLTRANSFERASE 2', 246556),
(367287, 'PTHR31642:SF267', NULL, NULL, NULL, NULL, 'BNAC05G47750D PROTEIN', 246556),
(367288, 'PTHR31642:SF300', NULL, NULL, NULL, NULL, 'OSJNBA0079A21.8 PROTEIN', 246556),
(367289, 'PTHR31642:SF262', NULL, NULL, NULL, NULL, '', 246556),
(367290, 'PTHR31642:SF50', NULL, NULL, NULL, NULL, 'F21B7.2', 246556),
(367291, 'PTHR31642:SF140', NULL, NULL, NULL, NULL, 'PUTRESCINE HYDROXYCINNAMOYLTRANSFERASE', 246556),
(367292, 'PTHR31642:SF142', NULL, NULL, NULL, NULL, 'ALCOHOL ACYLTRANSFERASE', 246556),
(367293, 'PTHR31642:SF52', NULL, NULL, NULL, NULL, 'ACYL TRANSFERASE 1', 246556),
(367294, 'PTHR31642:SF307', NULL, NULL, NULL, NULL, 'SHIKIMATE/QUINATE HYDROXYCINNAMOYLTRANSFERASE', 246556),
(367295, 'PTHR31642:SF306', NULL, NULL, NULL, NULL, '', 246556),
(367296, 'PTHR31642:SF309', NULL, NULL, NULL, NULL, '', 246556),
(367297, 'PTHR31642:SF308', NULL, NULL, NULL, NULL, 'OMEGA-HYDROXYPALMITATE O-FERULOYL TRANSFERASE', 246556),
(367298, 'PTHR31642:SF303', NULL, NULL, NULL, NULL, 'SPERMIDINE HYDROXYCINNAMOYL TRANSFERASE', 246556),
(367299, 'PTHR31642:SF302', NULL, NULL, NULL, NULL, 'METHANOL O-ANTHRANILOYLTRANSFERASE-LIKE', 246556),
(367300, 'PTHR31642:SF269', NULL, NULL, NULL, NULL, 'BENZYL ALCOHOL O-BENZOYLTRANSFERASE-LIKE', 246556),
(367301, 'PTHR31642:SF305', NULL, NULL, NULL, NULL, 'BENZYL ALCOHOL O-BENZOYLTRANSFERASE', 246556),
(367302, 'PTHR31642:SF304', NULL, NULL, NULL, NULL, '', 246556),
(367303, 'PTHR31642:SF270', NULL, NULL, NULL, NULL, 'O-ACETYLTRANSFERASE PYR7', 246556),
(367304, 'PTHR31642:SF49', NULL, NULL, NULL, NULL, 'OS06G0710700 PROTEIN', 246556),
(367305, 'PTHR31642:SF310', NULL, NULL, NULL, NULL, 'FATTY ALCOHOL:CAFFEOYL-COA ACYLTRANSFERASE', 246556),
(367306, 'PTHR31642:SF44', NULL, NULL, NULL, NULL, '', 246556),
(367307, 'PTHR31642:SF276', NULL, NULL, NULL, NULL, 'ANTHRANILATE N-BENZOYLTRANSFERASE PROTEIN', 246556),
(367308, 'PTHR31642:SF155', NULL, NULL, NULL, NULL, 'HXXXD-TYPE ACYL-TRANSFERASE FAMILY PROTEIN', 246556),
(367309, 'PTHR31642:SF158', NULL, NULL, NULL, NULL, 'N-BENZOYLTRANSFERASE PROTEIN, PUTATIVE-RELATED', 246556),
(367310, 'PTHR31642:SF312', NULL, NULL, NULL, NULL, '', 246556),
(367311, 'PTHR31642:SF45', NULL, NULL, NULL, NULL, 'PUTRESCINE HYDROXYCINNAMOYLTRANSFERASE 3', 246556),
(367312, 'PTHR31642:SF157', NULL, NULL, NULL, NULL, 'OMEGA-HYDROXYPALMITATE O-FERULOYL TRANSFERASE', 246556),
(367313, 'PTHR31642:SF278', NULL, NULL, NULL, NULL, 'TRYPTAMINE HYDROXYCINNAMOYLTRANSFERASE 1', 246556),
(367314, 'PTHR31642:SF311', NULL, NULL, NULL, NULL, 'BENZYL ALCOHOL O-BENZOYLTRANSFERASE-LIKE', 246556),
(367315, 'PTHR31642:SF151', NULL, NULL, NULL, NULL, 'OS12G0134700 PROTEIN', 246556),
(367316, 'PTHR31642:SF272', NULL, NULL, NULL, NULL, 'TRANSFERASE, CHLORAMPHENICOL ACETYLTRANSFERASE-LIKE DOMAIN PROTEIN-RELATED', 246556),
(367317, 'PTHR31642:SF154', NULL, NULL, NULL, NULL, 'SPERMIDINE HYDROXYCINNAMOYL TRANSFERASE', 246556),
(367318, 'PTHR31642:SF153', NULL, NULL, NULL, NULL, '', 246556),
(367319, 'PTHR31642:SF274', NULL, NULL, NULL, NULL, 'TRANSFERASE, CHLORAMPHENICOL ACETYLTRANSFERASE-LIKE DOMAIN PROTEIN-RELATED', 246556),
(367320, 'PTHR31642:SF318', NULL, NULL, NULL, NULL, 'OMEGA-HYDROXYPALMITATE O-FERULOYL TRANSFERASE', 246556),
(367321, 'PTHR31642:SF317', NULL, NULL, NULL, NULL, 'PROTEIN ECERIFERUM 26-LIKE', 246556),
(367322, 'PTHR31642:SF319', NULL, NULL, NULL, NULL, 'SHIKIMATE O-HYDROXYCINNAMOYLTRANSFERASE-LIKE', 246556),
(367323, 'PTHR31642:SF314', NULL, NULL, NULL, NULL, 'SPERMIDINE HYDROXYCINNAMOYLTRANSFERASE 2', 246556),
(367324, 'PTHR31642:SF159', NULL, NULL, NULL, NULL, '', 246556),
(367325, 'PTHR31642:SF313', NULL, NULL, NULL, NULL, '', 246556),
(367326, 'PTHR31642:SF316', NULL, NULL, NULL, NULL, 'SHIKIMATE O-HYDROXYCINNAMOYLTRANSFERASE', 246556),
(367327, 'PTHR31642:SF315', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE EASC', 246556);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(367328, 'PTHR31642:SF280', NULL, NULL, NULL, NULL, 'HYDROXYCINNAMOYLTRANSFERASE2', 246556),
(367329, 'PTHR31642:SF161', NULL, NULL, NULL, NULL, 'SHIKIMATE O-HYDROXYCINNAMOYLTRANSFERASE-LIKE', 246556),
(367330, 'PTHR31642:SF160', NULL, NULL, NULL, NULL, 'HXXXD-TYPE ACYL-TRANSFERASE FAMILY PROTEIN', 246556),
(367331, 'PTHR31642:SF321', NULL, NULL, NULL, NULL, '', 246556),
(367332, 'PTHR31642:SF200', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 246556),
(367333, 'PTHR31642:SF320', NULL, NULL, NULL, NULL, '', 246556),
(367334, 'PTHR31642:SF166', NULL, NULL, NULL, NULL, 'HYDROXYCINNAMOYLTRANSFERASE 2', 246556),
(367335, 'PTHR31642:SF323', NULL, NULL, NULL, NULL, 'OMEGA-HYDROXYPALMITATE O-FERULOYL TRANSFERASE', 246556),
(367336, 'PTHR31642:SF169', NULL, NULL, NULL, NULL, '(Z)-3-HEXEN-1-OL ACETYLTRANSFERASE', 246556),
(367337, 'PTHR31642:SF322', NULL, NULL, NULL, NULL, 'SHIKIMATE/QUINATE HYDROXYCINNAMOYLTRANSFERASE', 246556),
(367338, 'PTHR31642:SF289', NULL, NULL, NULL, NULL, 'SHIKIMATE O-HYDROXYCINNAMOYLTRANSFERASE-RELATED', 246556),
(367339, 'PTHR31642:SF168', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 246556),
(367340, 'PTHR31642:SF328', NULL, NULL, NULL, NULL, 'BAHD FAMILY ACYLTRANSFERASE', 246556),
(367341, 'PTHR31642:SF325', NULL, NULL, NULL, NULL, '', 246556),
(367342, 'PTHR31642:SF204', NULL, NULL, NULL, NULL, 'AGMATINE COUMAROYLTRANSFERASE-2-LIKE', 246556),
(367343, 'PTHR31642:SF203', NULL, NULL, NULL, NULL, 'OS07G0244200 PROTEIN', 246556),
(367344, 'PTHR31642:SF324', NULL, NULL, NULL, NULL, 'SPERMIDINE HYDROXYCINNAMOYL TRANSFERASE', 246556),
(367345, 'PTHR31642:SF327', NULL, NULL, NULL, NULL, 'BNAA09G27830D PROTEIN', 246556),
(367346, 'PTHR31642:SF326', NULL, NULL, NULL, NULL, 'HXXXD-TYPE ACYL-TRANSFERASE FAMILY PROTEIN', 246556),
(367347, 'PTHR31642:SF170', NULL, NULL, NULL, NULL, 'OS01G0350000 PROTEIN', 246556),
(367348, 'PTHR31642:SF299', NULL, NULL, NULL, NULL, 'OS02G0653400 PROTEIN', 246556),
(367349, 'PTHR31642:SF178', NULL, NULL, NULL, NULL, '', 246556),
(367350, 'PTHR31642:SF210', NULL, NULL, NULL, NULL, 'HXXXD-TYPE ACYL-TRANSFERASE FAMILY PROTEIN', 246556),
(367351, 'PTHR31642:SF298', NULL, NULL, NULL, NULL, 'TRANSFERASE, CHLORAMPHENICOL ACETYLTRANSFERASE-LIKE DOMAIN PROTEIN-RELATED', 246556),
(367352, 'PTHR31642:SF179', NULL, NULL, NULL, NULL, '', 246556),
(367353, 'PTHR31642:SF212', NULL, NULL, NULL, NULL, '', 246556),
(367354, 'PTHR31642:SF174', NULL, NULL, NULL, NULL, 'BENZYL ALCOHOL O-BENZOYLTRANSFERASE-LIKE', 246556),
(367355, 'PTHR31642:SF295', NULL, NULL, NULL, NULL, 'HSR201 PROTEIN', 246556),
(367356, 'PTHR31642:SF173', NULL, NULL, NULL, NULL, 'SPERMIDINE HYDROXYCINNAMOYL TRANSFERASE', 246556),
(367357, 'PTHR31642:SF294', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE MATC1', 246556),
(367358, 'PTHR31642:SF176', NULL, NULL, NULL, NULL, 'ROSMARINATE SYNTHASE-LIKE', 246556),
(367359, 'PTHR31642:SF297', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_2G18020)-RELATED', 246556),
(367360, 'PTHR31642:SF296', NULL, NULL, NULL, NULL, 'SHIKIMATE O-HYDROXYCINNAMOYLTRANSFERASE-LIKE', 246556),
(367361, 'PTHR31642:SF175', NULL, NULL, NULL, NULL, 'SPERMIDINE HYDROXYCINNAMOYL TRANSFERASE', 246556),
(367362, 'PTHR31642:SF218', NULL, NULL, NULL, NULL, '(Z)-3-HEXEN-1-OL ACETYLTRANSFERASE', 246556),
(367363, 'PTHR31642:SF214', NULL, NULL, NULL, NULL, '', 246556),
(367364, 'PTHR31642:SF217', NULL, NULL, NULL, NULL, 'OMEGA-HYDROXYPALMITATE O-FERULOYL TRANSFERASE-LIKE ISOFORM X1', 246556),
(367365, 'PTHR31642:SF216', NULL, NULL, NULL, NULL, 'HXXXD-TYPE ACYL-TRANSFERASE FAMILY PROTEIN', 246556),
(367366, 'PTHR21454', NULL, NULL, NULL, NULL, 'DPH3 HOMOLOG-RELATED', 246557),
(367367, 'PTHR21454:SF31', NULL, NULL, NULL, NULL, 'DPH3 HOMOLOG', 246557),
(367368, 'PTHR21454:SF41', NULL, NULL, NULL, NULL, 'EXPP1 PROTEIN', 246557),
(367369, 'PTHR21454:SF44', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN, PUTATIVE-RELATED', 246557),
(367370, 'PTHR21454:SF46', NULL, NULL, NULL, NULL, 'DIPHTHAMIDE BIOSYNTHESIS PROTEIN 4', 246557),
(367371, 'PTHR21454:SF24', NULL, NULL, NULL, NULL, 'DPH3 HOMOLOG', 246557);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(367372, 'PTHR21454:SF23', NULL, NULL, NULL, NULL, 'DPH3 HOMOLOG B-RELATED', 246557),
(367373, 'PTHR21454:SF12', NULL, NULL, NULL, NULL, '', 246557),
(367374, 'PTHR21454:SF34', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246557),
(367375, 'PTHR21454:SF48', NULL, NULL, NULL, NULL, 'EXPP1 PROTEIN', 246557),
(367376, 'PTHR21454:SF47', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK N-TERMINAL DOMAIN-CONTAINING PROTEIN', 246557),
(367377, 'PTHR21454:SF36', NULL, NULL, NULL, NULL, 'OS08G0474600 PROTEIN', 246557),
(367378, 'PTHR21454:SF49', NULL, NULL, NULL, NULL, 'RE24848P', 246557),
(367379, 'PTHR43158:SF1', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, ATP-BINDING PROTEIN', 246558),
(367380, 'PTHR43158:SF5', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, ATP-BINDING PROTEIN', 246558),
(367381, 'PTHR43158:SF2', NULL, NULL, NULL, NULL, 'SKFA PEPTIDE EXPORT ATP-BINDING PROTEIN SKFE', 246558),
(367382, 'PTHR43158:SF8', NULL, NULL, NULL, NULL, 'LANTIBIOTIC ABC TRANSPORTER,ATP-BINDING PROTEIN-RELATED', 246558),
(367383, 'PTHR43158:SF10', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN YTRB', 246558),
(367384, 'PTHR43158:SF9', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, ATP-BINDING PROTEIN', 246558),
(367385, 'PTHR43158:SF7', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, ATP-BINDING PROTEIN-RELATED', 246558),
(367386, 'PTHR43158:SF11', NULL, NULL, NULL, NULL, 'CCR4-NOT COMPLEX SUBUNIT CAF16', 246558),
(367387, 'PTHR43158', NULL, NULL, NULL, NULL, 'SKFA PEPTIDE EXPORT ATP-BINDING PROTEIN SKFE', 246558),
(367388, 'PTHR26379:SF418', NULL, NULL, NULL, NULL, '', 246559),
(367389, 'PTHR26379:SF370', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367390, 'PTHR26379:SF253', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367391, 'PTHR26379:SF374', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367392, 'PTHR26379:SF373', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367393, 'PTHR26379:SF378', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367394, 'PTHR26379:SF411', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367395, 'PTHR26379:SF410', NULL, NULL, NULL, NULL, 'OS08G0228200 PROTEIN', 246559),
(367396, 'PTHR26379:SF415', NULL, NULL, NULL, NULL, 'TRAF-LIKE, SKP1/BTB/POZ DOMAIN PROTEIN-RELATED', 246559),
(367397, 'PTHR26379:SF409', NULL, NULL, NULL, NULL, 'SPECKLE-TYPE POZ PROTEIN-LIKE PROTEIN', 246559),
(367398, 'PTHR26379:SF406', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367399, 'PTHR26379:SF242', NULL, NULL, NULL, NULL, '', 246559),
(367400, 'PTHR26379:SF364', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367401, 'PTHR26379:SF246', NULL, NULL, NULL, NULL, '', 246559),
(367402, 'PTHR26379:SF401', NULL, NULL, NULL, NULL, '', 246559),
(367403, 'PTHR26379:SF244', NULL, NULL, NULL, NULL, '', 246559),
(367404, 'PTHR26379:SF404', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN CONTAINING PROTEIN, EXPRESSED', 246559),
(367405, 'PTHR26379:SF369', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367406, 'PTHR26379:SF249', NULL, NULL, NULL, NULL, 'TRAF TRANSCRIPTION FACTOR', 246559),
(367407, 'PTHR26379:SF403', NULL, NULL, NULL, NULL, 'SPECKLE-TYPE POZ PROTEIN', 246559),
(367408, 'PTHR26379:SF439', NULL, NULL, NULL, NULL, '', 246559),
(367409, 'PTHR26379:SF392', NULL, NULL, NULL, NULL, 'BNAA02G05190D PROTEIN', 246559),
(367410, 'PTHR26379:SF270', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367411, 'PTHR26379:SF396', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN CONTAINING PROTEIN', 246559),
(367412, 'PTHR26379:SF430', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367413, 'PTHR26379:SF274', NULL, NULL, NULL, NULL, 'SPECKLE-TYPE POZ PROTEIN', 246559),
(367414, 'PTHR26379:SF433', NULL, NULL, NULL, NULL, 'OS08G0226800 PROTEIN', 246559),
(367415, 'PTHR26379:SF313', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 246559),
(367416, 'PTHR26379:SF434', NULL, NULL, NULL, NULL, 'BTB/POZ AND MATH DOMAIN-CONTAINING PROTEIN 2', 246559);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(367417, 'PTHR26379:SF431', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367418, 'PTHR26379:SF399', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367419, 'PTHR26379:SF432', NULL, NULL, NULL, NULL, '', 246559),
(367420, 'PTHR26379:SF316', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 246559),
(367421, 'PTHR26379:SF437', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367422, 'PTHR26379:SF438', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367423, 'PTHR26379:SF314', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367424, 'PTHR26379:SF435', NULL, NULL, NULL, NULL, 'OS06G0251200 PROTEIN', 246559),
(367425, 'PTHR26379:SF436', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367426, 'PTHR26379:SF428', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367427, 'PTHR26379:SF307', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367428, 'PTHR26379:SF429', NULL, NULL, NULL, NULL, 'OS10G0429300 PROTEIN', 246559),
(367429, 'PTHR26379:SF381', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367430, 'PTHR26379:SF382', NULL, NULL, NULL, NULL, 'OS10G0434999 PROTEIN', 246559),
(367431, 'PTHR26379:SF261', NULL, NULL, NULL, NULL, 'BTB/POZ AND MATH DOMAIN-CONTAINING PROTEIN 2', 246559),
(367432, 'PTHR26379:SF380', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367433, 'PTHR26379:SF385', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367434, 'PTHR26379:SF265', NULL, NULL, NULL, NULL, '', 246559),
(367435, 'PTHR26379:SF383', NULL, NULL, NULL, NULL, 'BNAA05G31070D PROTEIN', 246559),
(367436, 'PTHR26379:SF384', NULL, NULL, NULL, NULL, 'BNAC09G38850D PROTEIN', 246559),
(367437, 'PTHR26379:SF268', NULL, NULL, NULL, NULL, 'OS08G0406500 PROTEIN', 246559),
(367438, 'PTHR26379:SF422', NULL, NULL, NULL, NULL, '', 246559),
(367439, 'PTHR26379:SF420', NULL, NULL, NULL, NULL, 'BTB/POZ AND MATH DOMAIN-CONTAINING PROTEIN 4-LIKE', 246559),
(367440, 'PTHR26379:SF266', NULL, NULL, NULL, NULL, 'OS08G0227100 PROTEIN', 246559),
(367441, 'PTHR26379:SF388', NULL, NULL, NULL, NULL, 'OS04G0625700 PROTEIN', 246559),
(367442, 'PTHR26379:SF300', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367443, 'PTHR26379:SF427', NULL, NULL, NULL, NULL, 'BNAANNG03090D PROTEIN', 246559),
(367444, 'PTHR26379:SF303', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367445, 'PTHR26379:SF304', NULL, NULL, NULL, NULL, 'BTB/POZ AND MATH DOMAIN-CONTAINING PROTEIN 2', 246559),
(367446, 'PTHR26379:SF180', NULL, NULL, NULL, NULL, 'OS06G0668400 PROTEIN', 246559),
(367447, 'PTHR26379', NULL, NULL, NULL, NULL, 'BTB/POZ AND MATH DOMAIN-CONTAINING PROTEIN 1', 246559),
(367448, 'PTHR26379:SF293', NULL, NULL, NULL, NULL, 'BTB/POZ AND MATH DOMAIN-CONTAINING PROTEIN 3', 246559),
(367449, 'PTHR26379:SF291', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN CONTAINING PROTEIN, EXPRESSED', 246559),
(367450, 'PTHR26379:SF292', NULL, NULL, NULL, NULL, '(BREAD WHEAT) HYPOTHETICAL PROTEIN', 246559),
(367451, 'PTHR26379:SF451', NULL, NULL, NULL, NULL, 'OS08G0226000 PROTEIN', 246559),
(367452, 'PTHR26379:SF452', NULL, NULL, NULL, NULL, '', 246559),
(367453, 'PTHR26379:SF295', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246559),
(367454, 'PTHR26379:SF296', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367455, 'PTHR26379:SF450', NULL, NULL, NULL, NULL, 'OS10G0428900 PROTEIN', 246559),
(367456, 'PTHR26379:SF455', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 246559),
(367457, 'PTHR26379:SF456', NULL, NULL, NULL, NULL, '', 246559),
(367458, 'PTHR26379:SF332', NULL, NULL, NULL, NULL, 'OS08G0128900 PROTEIN', 246559),
(367459, 'PTHR26379:SF453', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 246559),
(367460, 'PTHR26379:SF454', NULL, NULL, NULL, NULL, 'BTB/POZ AND MATH DOMAIN-CONTAINING PROTEIN 2-LIKE', 246559),
(367461, 'PTHR26379:SF333', NULL, NULL, NULL, NULL, '', 246559),
(367462, 'PTHR26379:SF459', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(367463, 'PTHR26379:SF339', NULL, NULL, NULL, NULL, '', 246559),
(367464, 'PTHR26379:SF457', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367465, 'PTHR26379:SF215', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN CONTAINING PROTEIN, EXPRESSED', 246559),
(367466, 'PTHR26379:SF458', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 246559),
(367467, 'PTHR26379:SF282', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 246559),
(367468, 'PTHR26379:SF440', NULL, NULL, NULL, NULL, 'OS04G0433000 PROTEIN', 246559),
(367469, 'PTHR26379:SF441', NULL, NULL, NULL, NULL, '', 246559),
(367470, 'PTHR26379:SF287', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367471, 'PTHR26379:SF284', NULL, NULL, NULL, NULL, '', 246559),
(367472, 'PTHR26379:SF444', NULL, NULL, NULL, NULL, 'TD AND POZ DOMAIN-CONTAINING PROTEIN 3', 246559),
(367473, 'PTHR26379:SF324', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367474, 'PTHR26379:SF445', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367475, 'PTHR26379:SF321', NULL, NULL, NULL, NULL, 'OS04G0625400 PROTEIN', 246559),
(367476, 'PTHR26379:SF442', NULL, NULL, NULL, NULL, '', 246559),
(367477, 'PTHR26379:SF443', NULL, NULL, NULL, NULL, 'MATH DOMAIN CONTAINING PROTEIN', 246559),
(367478, 'PTHR26379:SF289', NULL, NULL, NULL, NULL, '', 246559),
(367479, 'PTHR26379:SF448', NULL, NULL, NULL, NULL, 'OS10G0423400 PROTEIN', 246559),
(367480, 'PTHR26379:SF449', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 246559),
(367481, 'PTHR26379:SF446', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367482, 'PTHR26379:SF447', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367483, 'PTHR26379:SF470', NULL, NULL, NULL, NULL, 'BTB/POZ AND MATH DOMAIN-CONTAINING PROTEIN 2-LIKE', 246559),
(367484, 'PTHR26379:SF232', NULL, NULL, NULL, NULL, 'OS02G0311150 PROTEIN', 246559),
(367485, 'PTHR26379:SF351', NULL, NULL, NULL, NULL, 'OS08G0128700 PROTEIN', 246559),
(367486, 'PTHR26379:SF355', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 246559),
(367487, 'PTHR26379:SF238', NULL, NULL, NULL, NULL, 'OS08G0523100 PROTEIN', 246559),
(367488, 'PTHR26379:SF191', NULL, NULL, NULL, NULL, 'BTB/POZ AND MATH DOMAIN-CONTAINING PROTEIN 2', 246559),
(367489, 'PTHR26379:SF462', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367490, 'PTHR26379:SF187', NULL, NULL, NULL, NULL, 'OS07G0655300 PROTEIN', 246559),
(367491, 'PTHR26379:SF341', NULL, NULL, NULL, NULL, '', 246559),
(367492, 'PTHR26379:SF463', NULL, NULL, NULL, NULL, '', 246559),
(367493, 'PTHR26379:SF460', NULL, NULL, NULL, NULL, '', 246559),
(367494, 'PTHR26379:SF461', NULL, NULL, NULL, NULL, '', 246559),
(367495, 'PTHR26379:SF340', NULL, NULL, NULL, NULL, 'OS09G0338200 PROTEIN', 246559),
(367496, 'PTHR26379:SF466', NULL, NULL, NULL, NULL, 'BTB/POZ AND MATH DOMAIN-CONTAINING PROTEIN 4', 246559),
(367497, 'PTHR26379:SF346', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367498, 'PTHR26379:SF467', NULL, NULL, NULL, NULL, 'SPECKLE-TYPE POZ PROTEIN-LIKE PROTEIN', 246559),
(367499, 'PTHR26379:SF343', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367500, 'PTHR26379:SF464', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367501, 'PTHR26379:SF465', NULL, NULL, NULL, NULL, 'BTB/POZ AND MATH DOMAIN-CONTAINING PROTEIN 1', 246559),
(367502, 'PTHR26379:SF344', NULL, NULL, NULL, NULL, 'OS04G0625500 PROTEIN', 246559),
(367503, 'PTHR26379:SF229', NULL, NULL, NULL, NULL, 'BTB/POZ AND MATH DOMAIN-CONTAINING PROTEIN 5-RELATED', 246559),
(367504, 'PTHR26379:SF468', NULL, NULL, NULL, NULL, 'MATH DOMAIN CONTAINING PROTEIN', 246559),
(367505, 'PTHR26379:SF348', NULL, NULL, NULL, NULL, 'BTB/POZ AND MATH DOMAIN-CONTAINING PROTEIN 1', 246559),
(367506, 'PTHR26379:SF469', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246559),
(367507, 'PTHR33171', NULL, NULL, NULL, NULL, 'LAR_N DOMAIN-CONTAINING PROTEIN', 246560),
(367508, 'PTHR33171:SF17', NULL, NULL, NULL, NULL, 'LAR_N DOMAIN-CONTAINING PROTEIN', 246560);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(367509, 'PTHR45949:SF4', NULL, NULL, NULL, NULL, 'SORTING NEXIN-4', 246561),
(367510, 'PTHR45949:SF3', NULL, NULL, NULL, NULL, 'SORTING NEXIN-7', 246561),
(367511, 'PTHR45949:SF2', NULL, NULL, NULL, NULL, 'SORTING NEXIN-4', 246561),
(367512, 'PTHR45949:SF1', NULL, NULL, NULL, NULL, 'SORTING NEXIN-30', 246561),
(367513, 'PTHR45949', NULL, NULL, NULL, NULL, 'SORTING NEXIN-4', 246561),
(367514, 'PTHR31494:SF3', NULL, NULL, NULL, NULL, '', 246562),
(367515, 'PTHR31494:SF2', NULL, NULL, NULL, NULL, '', 246562),
(367516, 'PTHR31494', NULL, NULL, NULL, NULL, '', 246562),
(367517, 'PTHR31494:SF5', NULL, NULL, NULL, NULL, '', 246562),
(367518, 'PTHR31494:SF4', NULL, NULL, NULL, NULL, '', 246562),
(367519, 'PTHR31172:SF6', NULL, NULL, NULL, NULL, 'OS07G0642800 PROTEIN', 246563),
(367520, 'PTHR31172:SF7', NULL, NULL, NULL, NULL, 'STOMATAL CLOSURE-RELATED ACTIN-BINDING PROTEIN 3', 246563),
(367521, 'PTHR31172:SF9', NULL, NULL, NULL, NULL, 'BNAA09G35910D PROTEIN', 246563),
(367522, 'PTHR31172:SF13', NULL, NULL, NULL, NULL, 'STOMATAL CLOSURE-RELATED ACTIN-BINDING PROTEIN 2', 246563),
(367523, 'PTHR31172:SF10', NULL, NULL, NULL, NULL, 'PLECTIN-RELATED PROTEIN-RELATED', 246563),
(367524, 'PTHR31172:SF11', NULL, NULL, NULL, NULL, 'BNAC04G47430D PROTEIN', 246563),
(367525, 'PTHR31172', NULL, NULL, NULL, NULL, 'STOMATAL CLOSURE-RELATED ACTIN-BINDING PROTEIN 1', 246563),
(367526, 'PTHR31172:SF14', NULL, NULL, NULL, NULL, 'CYCLIN 4', 246563),
(367527, 'PTHR31172:SF3', NULL, NULL, NULL, NULL, 'STOMATAL CLOSURE-RELATED ACTIN-BINDING PROTEIN 1', 246563),
(367528, 'PTHR31172:SF4', NULL, NULL, NULL, NULL, 'STOMATAL CLOSURE-RELATED ACTIN-BINDING PROTEIN 1', 246563),
(367529, 'PTHR13163', NULL, NULL, NULL, NULL, 'SPINAL CORD EXPRESSION PROTEIN 4', 246564),
(367530, 'PTHR13163:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 35B', 246564),
(367531, 'PTHR13163:SF0', NULL, NULL, NULL, NULL, 'NOVEL ACETYLCHOLINE RECEPTOR CHAPERONE', 246564),
(367532, 'PTHR14564:SF2', NULL, NULL, NULL, NULL, 'MICOS COMPLEX SUBUNIT MIC26', 246565),
(367533, 'PTHR14564:SF5', NULL, NULL, NULL, NULL, 'MICOS COMPLEX SUBUNIT', 246565),
(367534, 'PTHR14564:SF4', NULL, NULL, NULL, NULL, 'MICOS COMPLEX SUBUNIT', 246565),
(367535, 'PTHR14564:SF3', NULL, NULL, NULL, NULL, 'MICOS COMPLEX SUBUNIT MIC27', 246565),
(367536, 'PTHR14564', NULL, NULL, NULL, NULL, 'MICOS COMPLEX SUBUNIT MIC26 / MIC27 FAMILY MEMBER', 246565),
(367537, 'PTHR47745', NULL, NULL, NULL, NULL, 'IZUMO SPERM-EGG FUSION PROTEIN 2', 246566),
(367538, 'PTHR47745:SF1', NULL, NULL, NULL, NULL, 'IZUMO SPERM-EGG FUSION PROTEIN 2', 246566),
(367539, 'PTHR31359', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 92', 246567),
(367540, 'PTHR31359:SF31', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 92', 246567),
(367541, 'PTHR12873:SF2', NULL, NULL, NULL, NULL, 'TOPRIM DOMAIN, TWINKLE-LIKE PROTEIN-RELATED', 246568),
(367542, 'PTHR12873:SF0', NULL, NULL, NULL, NULL, 'TWINKLE PROTEIN, MITOCHONDRIAL', 246568),
(367543, 'PTHR12873:SF6', NULL, NULL, NULL, NULL, 'TOPRIM DOMAIN-CONTAINING PROTEIN', 246568),
(367544, 'PTHR12873', NULL, NULL, NULL, NULL, 'T7-LIKE MITOCHONDRIAL DNA HELICASE', 246568),
(367545, 'PTHR36946', NULL, NULL, NULL, NULL, 'PROTEIN CBG13897-RELATED', 246569),
(367546, 'PTHR36946:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG03444', 246569),
(367547, 'PTHR36946:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG13897', 246569),
(367548, 'PTHR23231:SF20', NULL, NULL, NULL, NULL, 'GERM CELL-LESS PROTEIN-LIKE 1', 246570),
(367549, 'PTHR23231:SF19', NULL, NULL, NULL, NULL, 'GERM CELL-LESS PROTEIN-LIKE 1', 246570),
(367550, 'PTHR23231', NULL, NULL, NULL, NULL, 'GERM CELL-LESS PROTEIN', 246570),
(367551, 'PTHR23231:SF3', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING 35, FAMILY MEMBER 10-RELATED', 246570),
(367552, 'PTHR23231:SF18', NULL, NULL, NULL, NULL, 'GERM CELL-LESS PROTEIN-LIKE 2', 246570),
(367553, 'PTHR23231:SF17', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246570),
(367554, 'PTHR37879:SF1', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH TAIL PROTEIN 1', 246571),
(367555, 'PTHR37879', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH TAIL PROTEIN 1', 246571);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(367556, 'PTHR36615', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 246572),
(367557, 'PTHR36615:SF6', NULL, NULL, NULL, NULL, '', 246572),
(367558, 'PTHR36615:SF7', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 246572),
(367559, 'PTHR16112', NULL, NULL, NULL, NULL, 'METHYL-CPG BINDING PROTEIN, DROSOPHILA', 246573),
(367560, 'PTHR16112:SF22', NULL, NULL, NULL, NULL, 'PWWP DOMAIN-CONTAINING 2B', 246573),
(367561, 'PTHR16112:SF16', NULL, NULL, NULL, NULL, 'SIX-BANDED, ISOFORM H', 246573),
(367562, 'PTHR16112:SF17', NULL, NULL, NULL, NULL, 'METHYL-CPG-BINDING DOMAIN PROTEIN 6', 246573),
(367563, 'PTHR16112:SF18', NULL, NULL, NULL, NULL, 'METHYL-CPG-BINDING DOMAIN PROTEIN 5', 246573),
(367564, 'PTHR21397:SF2', NULL, NULL, NULL, NULL, 'CHROMATIN COMPLEXES SUBUNIT BAP18', 246574),
(367565, 'PTHR21397:SF4', NULL, NULL, NULL, NULL, 'ER MEMBRANE PROTEIN COMPLEX SUBUNIT 10', 246574),
(367566, 'PTHR21397:SF5', NULL, NULL, NULL, NULL, 'BNAC04G29940D PROTEIN', 246574),
(367567, 'PTHR21397', NULL, NULL, NULL, NULL, 'CHROMATIN COMPLEXES SUBUNIT BAP18-RELATED', 246574),
(367568, 'PTHR47304:SF1', NULL, NULL, NULL, NULL, 'COMPLEMENT COMPONENT C8 GAMMA CHAIN', 246575),
(367569, 'PTHR47304', NULL, NULL, NULL, NULL, 'COMPLEMENT COMPONENT C8 GAMMA CHAIN', 246575),
(367570, 'PTHR45229:SF3', NULL, NULL, NULL, NULL, 'BIODEGRADATIVE ARGININE DECARBOXYLASE', 246576),
(367571, 'PTHR45229:SF4', NULL, NULL, NULL, NULL, 'CONSTITUTIVE ORNITHINE DECARBOXYLASE', 246576),
(367572, 'PTHR45229', NULL, NULL, NULL, NULL, 'CONSTITUTIVE ORNITHINE DECARBOXYLASE', 246576),
(367573, 'PTHR45229:SF1', NULL, NULL, NULL, NULL, 'INDUCIBLE ORNITHINE DECARBOXYLASE', 246576),
(367574, 'PTHR12982:SF0', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL N-ACETYLGLUCOSAMINYLTRANSFERASE SUBUNIT C', 246577),
(367575, 'PTHR12982', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL GLYCAN, CLASS C', 246577),
(367576, 'PTHR12982:SF2', NULL, NULL, NULL, NULL, '', 246577),
(367577, 'PTHR12982:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL N-ACETYLGLUCOSAMINYLTRANSFERASE SUBUNIT C', 246577),
(367578, 'PTHR36578:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 15, WHOLE GENOME SHOTGUN SEQUENCE', 246578),
(367579, 'PTHR36578', NULL, NULL, NULL, NULL, 'CHROMOSOME 15, WHOLE GENOME SHOTGUN SEQUENCE', 246578),
(367580, 'PTHR46542:SF3', NULL, NULL, NULL, NULL, 'X-BOX-BINDING PROTEIN 1', 246579),
(367581, 'PTHR46542:SF2', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 246579),
(367582, 'PTHR46542', NULL, NULL, NULL, NULL, 'X-BOX BINDING PROTEIN 1', 246579),
(367583, 'PTHR46542:SF1', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 246579),
(367584, 'PTHR46126:SF3', NULL, NULL, NULL, NULL, '', 246580),
(367585, 'PTHR46126:SF2', NULL, NULL, NULL, NULL, 'DYNACTIN SUBUNIT 5', 246580),
(367586, 'PTHR46126:SF1', NULL, NULL, NULL, NULL, 'DYNACTIN SUBUNIT 5', 246580),
(367587, 'PTHR46126', NULL, NULL, NULL, NULL, 'DYNACTIN SUBUNIT 5', 246580),
(367588, 'PTHR33565:SF2', NULL, NULL, NULL, NULL, 'DORMANCY-ASSOCIATED PROTEIN 1', 246581),
(367589, 'PTHR33565:SF1', NULL, NULL, NULL, NULL, 'DORMANCY-ASSOCIATED PROTEIN HOMOLOG 3', 246581),
(367590, 'PTHR33565:SF30', NULL, NULL, NULL, NULL, 'AUXIN-REPRESSED 12.5 KDA PROTEIN-LIKE', 246581),
(367591, 'PTHR33565:SF20', NULL, NULL, NULL, NULL, 'DORMANCY-ASSOCIATED PROTEIN HOMOLOG 4', 246581),
(367592, 'PTHR33565:SF31', NULL, NULL, NULL, NULL, 'DORMANCY-ASSOCIATED PROTEIN-LIKE 1-RELATED', 246581),
(367593, 'PTHR33565:SF32', NULL, NULL, NULL, NULL, 'BNAC05G52140D PROTEIN', 246581),
(367594, 'PTHR33565:SF10', NULL, NULL, NULL, NULL, 'DORMANCY-ASSOCIATED PROTEIN HOMOLOG 2', 246581),
(367595, 'PTHR33565:SF21', NULL, NULL, NULL, NULL, 'BNAC06G10490D PROTEIN', 246581),
(367596, 'PTHR33565:SF11', NULL, NULL, NULL, NULL, 'DORMANCY-ASSOCIATED PROTEIN HOMOLOG 1', 246581),
(367597, 'PTHR33565:SF22', NULL, NULL, NULL, NULL, 'BNAC09G00190D PROTEIN', 246581),
(367598, 'PTHR33565:SF23', NULL, NULL, NULL, NULL, 'DORMANCYAUXIN ASSOCIATED-RELATED', 246581),
(367599, 'PTHR33565:SF14', NULL, NULL, NULL, NULL, 'DORMANCY ASSOCIATED1', 246581);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(367600, 'PTHR33565:SF25', NULL, NULL, NULL, NULL, 'BNAA05G09830D PROTEIN', 246581),
(367601, 'PTHR33565:SF28', NULL, NULL, NULL, NULL, 'BNAA01G29540D PROTEIN', 246581),
(367602, 'PTHR33565:SF18', NULL, NULL, NULL, NULL, 'OS09G0437500 PROTEIN', 246581),
(367603, 'PTHR33565', NULL, NULL, NULL, NULL, 'DORMANCY-ASSOCIATED PROTEIN 1', 246581),
(367604, 'PTHR14947:SF22', NULL, NULL, NULL, NULL, 'SP4 TRANSCRIPTION FACTOR', 246582),
(367605, 'PTHR14947:SF21', NULL, NULL, NULL, NULL, '', 246582),
(367606, 'PTHR14947:SF20', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 818-RELATED', 246582),
(367607, 'PTHR14947', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 246582),
(367608, 'PTHR14947:SF19', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 781', 246582),
(367609, 'PTHR46710:SF4', NULL, NULL, NULL, NULL, 'ARM REPEAT PROTEIN INTERACTING WITH ABF2 PROTEIN', 246583),
(367610, 'PTHR46710:SF10', NULL, NULL, NULL, NULL, 'ARMADILLO BTB ARABIDOPSIS PROTEIN 1', 246583),
(367611, 'PTHR46710:SF2', NULL, NULL, NULL, NULL, 'ARM REPEAT PROTEIN INTERACTING WITH ABF2-LIKE', 246583),
(367612, 'PTHR46710:SF1', NULL, NULL, NULL, NULL, 'ARM REPEAT PROTEIN INTERACTING WITH ABF2', 246583),
(367613, 'PTHR46710:SF9', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246583),
(367614, 'PTHR46710:SF8', NULL, NULL, NULL, NULL, 'ARM REPEAT PROTEIN INTERACTING WITH ABF2 PROTEIN', 246583),
(367615, 'PTHR46710:SF7', NULL, NULL, NULL, NULL, 'ARM REPEAT PROTEIN INTERACTING WITH ABF2-LIKE', 246583),
(367616, 'PTHR46710', NULL, NULL, NULL, NULL, 'ARM REPEAT PROTEIN INTERACTING WITH ABF2', 246583),
(367617, 'PTHR40280', NULL, NULL, NULL, NULL, 'BLR6907 PROTEIN', 246584),
(367618, 'PTHR40280:SF1', NULL, NULL, NULL, NULL, 'VOC DOMAIN-CONTAINING PROTEIN', 246584),
(367619, 'PTHR20870:SF0', NULL, NULL, NULL, NULL, 'BARDET-BIEDL SYNDROME 1 PROTEIN', 246585),
(367620, 'PTHR20870', NULL, NULL, NULL, NULL, 'BARDET-BIEDL SYNDROME 1 PROTEIN', 246585),
(367621, 'PTHR37311:SF1', NULL, NULL, NULL, NULL, '2-PHOSPHOSULFOLACTATE PHOSPHATASE-RELATED', 246586),
(367622, 'PTHR37311', NULL, NULL, NULL, NULL, '2-PHOSPHOSULFOLACTATE PHOSPHATASE-RELATED', 246586),
(367623, 'PTHR35859:SF1', NULL, NULL, NULL, NULL, 'NONSELECTIVE CATION CHANNEL PROTEIN', 246587),
(367624, 'PTHR35859:SF4', NULL, NULL, NULL, NULL, 'MEMBRANE CHANNEL PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G11300)-RELATED', 246587),
(367625, 'PTHR35859:SF5', NULL, NULL, NULL, NULL, 'ION_TRANS DOMAIN-CONTAINING PROTEIN', 246587),
(367626, 'PTHR35859', NULL, NULL, NULL, NULL, 'NONSELECTIVE CATION CHANNEL PROTEIN', 246587),
(367627, 'PTHR22848:SF3', NULL, NULL, NULL, NULL, '', 246588),
(367628, 'PTHR22848:SF1', NULL, NULL, NULL, NULL, 'REPEAT PROTEIN, PUTATIVE-RELATED', 246588),
(367629, 'PTHR22848', NULL, NULL, NULL, NULL, 'WD40 REPEAT PROTEIN', 246588),
(367630, 'PTHR22848:SF2', NULL, NULL, NULL, NULL, 'WD40 REPEAT-CONTAINING PROTEIN SMU1', 246588),
(367631, 'PTHR22848:SF0', NULL, NULL, NULL, NULL, 'WD40 REPEAT-CONTAINING PROTEIN SMU1', 246588),
(367632, 'PTHR34960:SF1', NULL, NULL, NULL, NULL, 'EMB|CAB68146.1-RELATED', 246589),
(367633, 'PTHR34960:SF3', NULL, NULL, NULL, NULL, '', 246589),
(367634, 'PTHR34960:SF4', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 24-RELATED', 246589),
(367635, 'PTHR34960', NULL, NULL, NULL, NULL, 'EMB|CAB68146.1-RELATED', 246589),
(367636, 'PTHR21029:SF21', NULL, NULL, NULL, NULL, 'R-SEVEN BINDING PROTEIN (R7BP) HOMOLOG', 246590),
(367637, 'PTHR21029', NULL, NULL, NULL, NULL, 'R-SEVEN BINDING PROTEIN (R7BP) HOMOLOG', 246590),
(367638, 'PTHR21029:SF1', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING 9-BINDING PROTEIN', 246590),
(367639, 'PTHR21029:SF12', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING 7-BINDING PROTEIN', 246590),
(367640, 'PTHR21029:SF18', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN-SIGNALING 9-BINDING PROTEIN', 246590),
(367641, 'PTHR21029:SF5', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING 9-BINDING PROTEIN', 246590),
(367642, 'PTHR46995:SF4', NULL, NULL, NULL, NULL, 'POLLEN OLE E 1 ALLERGEN AND EXTENSIN FAMILY PROTEIN-RELATED', 246591);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(367643, 'PTHR46995:SF5', NULL, NULL, NULL, NULL, 'POLLEN OLE E 1 ALLERGEN AND EXTENSIN FAMILY PROTEIN', 246591),
(367644, 'PTHR46995:SF6', NULL, NULL, NULL, NULL, 'POLLEN OLE E 1 ALLERGEN AND EXTENSIN FAMILY PROTEIN', 246591),
(367645, 'PTHR46995:SF12', NULL, NULL, NULL, NULL, 'OS12G0472800 PROTEIN', 246591),
(367646, 'PTHR46995:SF8', NULL, NULL, NULL, NULL, '', 246591),
(367647, 'PTHR46995:SF10', NULL, NULL, NULL, NULL, 'BNAC06G13410D PROTEIN', 246591),
(367648, 'PTHR46995:SF9', NULL, NULL, NULL, NULL, 'BNAA09G01840D PROTEIN', 246591),
(367649, 'PTHR46995', NULL, NULL, NULL, NULL, 'OS09G0508200 PROTEIN', 246591),
(367650, 'PTHR30373:SF2', NULL, NULL, NULL, NULL, 'UPF0603 PROTEIN YGCG', 246592),
(367651, 'PTHR30373', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 246592),
(367652, 'PTHR30373:SF8', NULL, NULL, NULL, NULL, 'TPM_PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 246592),
(367653, 'PTHR43098:SF2', NULL, NULL, NULL, NULL, 'FAD-BINDING MONOOXYGENASE AUSB-RELATED', 246593),
(367654, 'PTHR43098', NULL, NULL, NULL, NULL, 'L-ORNITHINE N(5)-MONOOXYGENASE-RELATED', 246593),
(367655, 'PTHR43098:SF5', NULL, NULL, NULL, NULL, 'DUAL-FUNCTIONAL MONOOXYGENASE/METHYLTRANSFERASE PSOF', 246593),
(367656, 'PTHR43098:SF4', NULL, NULL, NULL, NULL, 'BLR3857 PROTEIN', 246593),
(367657, 'PTHR43098:SF3', NULL, NULL, NULL, NULL, 'L-ORNITHINE N(5)-MONOOXYGENASE-RELATED', 246593),
(367658, 'PTHR11727:SF29', NULL, NULL, NULL, NULL, 'RRNA ADENINE N(6)-METHYLTRANSFERASE', 246594),
(367659, 'PTHR11727:SF18', NULL, NULL, NULL, NULL, 'RRNA ADENINE N(6)-METHYLTRANSFERASE', 246594),
(367660, 'PTHR11727:SF17', NULL, NULL, NULL, NULL, 'DIMETHYLADENOSINE TRANSFERASE 1, MITOCHONDRIAL', 246594),
(367661, 'PTHR11727:SF27', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA SMALL SUBUNIT METHYLTRANSFERASE, CHLOROPLASTIC', 246594),
(367662, 'PTHR11727', NULL, NULL, NULL, NULL, 'DIMETHYLADENOSINE TRANSFERASE', 246594),
(367663, 'PTHR11727:SF26', NULL, NULL, NULL, NULL, 'RRNA ADENINE N(6)-METHYLTRANSFERASE', 246594),
(367664, 'PTHR11727:SF14', NULL, NULL, NULL, NULL, 'BLL8166 PROTEIN', 246594),
(367665, 'PTHR11727:SF13', NULL, NULL, NULL, NULL, 'DIMETHYLADENOSINE TRANSFERASE 2, MITOCHONDRIAL', 246594),
(367666, 'PTHR11727:SF12', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA SMALL SUBUNIT METHYLTRANSFERASE, MITOCHONDRIAL', 246594),
(367667, 'PTHR11727:SF7', NULL, NULL, NULL, NULL, 'DIMETHYLADENOSINE TRANSFERASE-RELATED', 246594),
(367668, 'PTHR15566:SF4', NULL, NULL, NULL, NULL, 'POM121-LIKE PROTEIN 1-LIKE-RELATED', 246595),
(367669, 'PTHR15566:SF6', NULL, NULL, NULL, NULL, 'POM121-LIKE PROTEIN 1-RELATED', 246595),
(367670, 'PTHR15566', NULL, NULL, NULL, NULL, 'POM121-LIKE', 246595),
(367671, 'PTHR15566:SF7', NULL, NULL, NULL, NULL, 'UPF0607 PROTEIN ENSP00000332738-RELATED', 246595),
(367672, 'PTHR38100:SF1', NULL, NULL, NULL, NULL, 'HIGH FREQUENCY LYSOGENIZATION PROTEIN HFLD', 246596),
(367673, 'PTHR38100', NULL, NULL, NULL, NULL, 'HIGH FREQUENCY LYSOGENIZATION PROTEIN HFLD', 246596),
(367674, 'PTHR28498', NULL, NULL, NULL, NULL, 'ZINC FINGER SWIM DOMAIN-CONTAINING PROTEIN 7', 246597),
(367675, 'PTHR28498:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER SWIM DOMAIN-CONTAINING PROTEIN 7', 246597),
(367676, 'PTHR16943:SF11', NULL, NULL, NULL, NULL, 'CIS-ACONITATE DECARBOXYLASE', 246598),
(367677, 'PTHR16943:SF14', NULL, NULL, NULL, NULL, 'IMMUNORESPONSIVE GENE 1,-LIKE', 246598),
(367678, 'PTHR16943:SF8', NULL, NULL, NULL, NULL, '2-METHYLCITRATE DEHYDRATASE-RELATED', 246598),
(367679, 'PTHR16943', NULL, NULL, NULL, NULL, '2-METHYLCITRATE DEHYDRATASE-RELATED', 246598),
(367680, 'PTHR40658:SF3', NULL, NULL, NULL, NULL, 'HYPOTHETICAL CYTOSOLIC PROTEIN', 246599),
(367681, 'PTHR40658:SF4', NULL, NULL, NULL, NULL, 'HYPOTHETICAL CYTOSOLIC PROTEIN', 246599),
(367682, 'PTHR40658', NULL, NULL, NULL, NULL, '', 246599),
(367683, 'PTHR15028:SF6', NULL, NULL, NULL, NULL, 'B-CELL DIFFERENTIATION ANTIGEN CD72', 246600),
(367684, 'PTHR15028', NULL, NULL, NULL, NULL, 'CD72-RELATED', 246600),
(367685, 'PTHR42722:SF1', NULL, NULL, NULL, NULL, 'VALINE DEHYDROGENASE', 246601),
(367686, 'PTHR42722', NULL, NULL, NULL, NULL, 'LEUCINE DEHYDROGENASE', 246601);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(367687, 'PTHR42991:SF11', NULL, NULL, NULL, NULL, 'NADP-DEPENDENT GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE', 246602),
(367688, 'PTHR42991', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE', 246602),
(367689, 'PTHR42991:SF1', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE', 246602),
(367690, 'PTHR42991:SF7', NULL, NULL, NULL, NULL, 'ALDEDH DOMAIN-CONTAINING PROTEIN', 246602),
(367691, 'PTHR35702:SF4', NULL, NULL, NULL, NULL, '', 246603),
(367692, 'PTHR35702', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246603),
(367693, 'PTHR35702:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246603),
(367694, 'PTHR35702:SF2', NULL, NULL, NULL, NULL, '', 246603),
(367695, 'PTHR11741:SF0', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR TS, MITOCHONDRIAL', 246604),
(367696, 'PTHR11741:SF10', NULL, NULL, NULL, NULL, 'POLYPROTEIN OF EF-TS, CHLOROPLASTIC', 246604),
(367697, 'PTHR11741:SF7', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR TS, MITOCHONDRIAL', 246604),
(367698, 'PTHR11741', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR TS', 246604),
(367699, 'PTHR46834:SF10', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH138-RELATED', 246605),
(367700, 'PTHR46834', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH91', 246605),
(367701, 'PTHR46834:SF9', NULL, NULL, NULL, NULL, 'BASIC HELIX-LOOP-HELIX (BHLH) DNA-BINDING SUPERFAMILY PROTEIN-RELATED', 246605),
(367702, 'PTHR46834:SF8', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 246605),
(367703, 'PTHR46834:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH91-LIKE', 246605),
(367704, 'PTHR46834:SF12', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH89', 246605),
(367705, 'PTHR46834:SF4', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR EAT1', 246605),
(367706, 'PTHR46834:SF11', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 246605),
(367707, 'PTHR46834:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TIP2', 246605),
(367708, 'PTHR46834:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH10', 246605),
(367709, 'PTHR39206:SF1', NULL, NULL, NULL, NULL, 'SLL8004 PROTEIN', 246606),
(367710, 'PTHR39206', NULL, NULL, NULL, NULL, 'SLL8004 PROTEIN', 246606),
(367711, 'PTHR23055:SF75', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING DOMAIN-CONTAINING PROTEIN 1', 246607),
(367712, 'PTHR23055:SF74', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN L', 246607),
(367713, 'PTHR23055:SF30', NULL, NULL, NULL, NULL, 'KV CHANNEL-INTERACTING PROTEIN 4', 246607),
(367714, 'PTHR23055:SF96', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN J-RELATED', 246607),
(367715, 'PTHR23055:SF79', NULL, NULL, NULL, NULL, 'HIPPOCALCIN-LIKE PROTEIN 1', 246607),
(367716, 'PTHR23055:SF57', NULL, NULL, NULL, NULL, 'NEURON-SPECIFIC CALCIUM-BINDING PROTEIN HIPPOCALCIN', 246607),
(367717, 'PTHR23055:SF13', NULL, NULL, NULL, NULL, 'GUANYLYL CYCLASE-ACTIVATING PROTEIN 1', 246607),
(367718, 'PTHR23055:SF11', NULL, NULL, NULL, NULL, 'GUANYLYL CYCLASE-ACTIVATING PROTEIN 2', 246607),
(367719, 'PTHR23055:SF56', NULL, NULL, NULL, NULL, 'NEURONAL CALCIUM SENSOR FAMILY', 246607),
(367720, 'PTHR23055:SF166', NULL, NULL, NULL, NULL, 'VISININ', 246607),
(367721, 'PTHR23055:SF188', NULL, NULL, NULL, NULL, '', 246607),
(367722, 'PTHR23055:SF165', NULL, NULL, NULL, NULL, 'CALSENILIN', 246607),
(367723, 'PTHR23055:SF187', NULL, NULL, NULL, NULL, 'EF HAND DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_6G07310)', 246607),
(367724, 'PTHR23055:SF168', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE ACTIVATOR 1G', 246607),
(367725, 'PTHR23055:SF102', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE ACTIVATING PROTEIN 4', 246607),
(367726, 'PTHR23055:SF101', NULL, NULL, NULL, NULL, 'VISININ-LIKE PROTEIN 1', 246607),
(367727, 'PTHR23055:SF189', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN NCSA-RELATED', 246607),
(367728, 'PTHR23055:SF167', NULL, NULL, NULL, NULL, 'NEURONAL CALCIUM SENSOR FAMILY', 246607),
(367729, 'PTHR23055:SF184', NULL, NULL, NULL, NULL, '', 246607),
(367730, 'PTHR23055:SF183', NULL, NULL, NULL, NULL, 'RECOVERIN FAMILY PROTEIN DDB_G0274781', 246607),
(367731, 'PTHR23055:SF164', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE ACTIVATOR 1A', 246607);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(367732, 'PTHR23055:SF186', NULL, NULL, NULL, NULL, 'NEUROCALCIN HOMOLOG-LIKE PROTEIN', 246607),
(367733, 'PTHR23055:SF91', NULL, NULL, NULL, NULL, 'NEUROCALCIN HOMOLOG', 246607),
(367734, 'PTHR23055:SF185', NULL, NULL, NULL, NULL, 'NEUROCALCIN HOMOLOG-LIKE PROTEIN', 246607),
(367735, 'PTHR23055:SF70', NULL, NULL, NULL, NULL, '', 246607),
(367736, 'PTHR23055:SF191', NULL, NULL, NULL, NULL, 'CALMODULIN', 246607),
(367737, 'PTHR23055:SF190', NULL, NULL, NULL, NULL, 'AT17667P-RELATED', 246607),
(367738, 'PTHR23055:SF171', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 246607),
(367739, 'PTHR23055:SF192', NULL, NULL, NULL, NULL, '', 246607),
(367740, 'PTHR23055:SF64', NULL, NULL, NULL, NULL, 'NEUROCALCIN-DELTA B', 246607),
(367741, 'PTHR23055:SF20', NULL, NULL, NULL, NULL, 'RECOVERIN', 246607),
(367742, 'PTHR23055:SF65', NULL, NULL, NULL, NULL, 'KV CHANNEL-INTERACTING PROTEIN 2', 246607),
(367743, 'PTHR23055:SF87', NULL, NULL, NULL, NULL, 'NEUROCALCIN-DELTA', 246607),
(367744, 'PTHR23055:SF84', NULL, NULL, NULL, NULL, 'HIPPOCALCIN-LIKE PROTEIN 4', 246607),
(367745, 'PTHR23055:SF85', NULL, NULL, NULL, NULL, 'SI:CH211-245J22.3', 246607),
(367746, 'PTHR23055:SF69', NULL, NULL, NULL, NULL, 'NEURONAL CALCIUM SENSOR 2', 246607),
(367747, 'PTHR23055:SF67', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1700109H08 GENE', 246607),
(367748, 'PTHR23055:SF89', NULL, NULL, NULL, NULL, 'KV CHANNEL-INTERACTING PROTEIN 1 B', 246607),
(367749, 'PTHR23055:SF111', NULL, NULL, NULL, NULL, 'NEURONAL CALCIUM SENSOR FAMILY', 246607),
(367750, 'PTHR23055:SF176', NULL, NULL, NULL, NULL, 'VISININ-LIKE PROTEIN 1', 246607),
(367751, 'PTHR23055', NULL, NULL, NULL, NULL, 'CALCIUM BINDING PROTEINS', 246607),
(367752, 'PTHR23055:SF178', NULL, NULL, NULL, NULL, 'NEURONAL CALCIUM SENSOR 1', 246607),
(367753, 'PTHR23055:SF82', NULL, NULL, NULL, NULL, 'KV CHANNEL-INTERACTING PROTEIN 1', 246607),
(367754, 'PTHR23055:SF60', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING DOMAIN 1', 246607),
(367755, 'PTHR23055:SF172', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN 24', 246607),
(367756, 'PTHR23055:SF80', NULL, NULL, NULL, NULL, 'GUANYLYL CYCLASE-ACTIVATING PROTEIN 3', 246607),
(367757, 'PTHR23055:SF174', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE ACTIVATOR 1C', 246607),
(367758, 'PTHR33890', NULL, NULL, NULL, NULL, 'OS10G0571000 PROTEIN', 246608),
(367759, 'PTHR33890:SF5', NULL, NULL, NULL, NULL, 'OS10G0571000 PROTEIN', 246608),
(367760, 'PTHR12296:SF21', NULL, NULL, NULL, NULL, 'DENN DOMAIN-CONTAINING PROTEIN 3', 246609),
(367761, 'PTHR12296:SF30', NULL, NULL, NULL, NULL, 'DENN DOMAIN-CONTAINING PROTEIN CRAG', 246609),
(367762, 'PTHR12296:SF31', NULL, NULL, NULL, NULL, 'DENN (AEX-3) DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_6G11200)', 246609),
(367763, 'PTHR12296:SF18', NULL, NULL, NULL, NULL, 'DENN DOMAIN-CONTAINING PROTEIN 4B', 246609),
(367764, 'PTHR12296', NULL, NULL, NULL, NULL, 'DENN DOMAIN-CONTAINING PROTEIN 4', 246609),
(367765, 'PTHR12296:SF16', NULL, NULL, NULL, NULL, 'C-MYC PROMOTER-BINDING PROTEIN', 246609),
(367766, 'PTHR12296:SF17', NULL, NULL, NULL, NULL, 'DENN DOMAIN-CONTAINING PROTEIN 4C', 246609),
(367767, 'PTHR10126:SF57', NULL, NULL, NULL, NULL, 'TATA BOX-BINDING PROTEIN-LIKE 1', 246610),
(367768, 'PTHR10126:SF68', NULL, NULL, NULL, NULL, 'TATA-BOX-BINDING PROTEIN 2', 246610),
(367769, 'PTHR10126:SF67', NULL, NULL, NULL, NULL, 'BNAC03G70590D PROTEIN', 246610),
(367770, 'PTHR10126:SF66', NULL, NULL, NULL, NULL, 'TATA-BOX-BINDING PROTEIN', 246610),
(367771, 'PTHR10126:SF54', NULL, NULL, NULL, NULL, 'TATA-BINDING PROTEIN 2', 246610),
(367772, 'PTHR10126:SF43', NULL, NULL, NULL, NULL, '', 246610),
(367773, 'PTHR10126:SF65', NULL, NULL, NULL, NULL, 'TATA-BOX-BINDING PROTEIN 2', 246610),
(367774, 'PTHR10126:SF53', NULL, NULL, NULL, NULL, 'BNAC08G45230D PROTEIN', 246610),
(367775, 'PTHR10126:SF20', NULL, NULL, NULL, NULL, 'TATA-BOX-BINDING PROTEIN', 246610),
(367776, 'PTHR10126', NULL, NULL, NULL, NULL, 'TATA-BOX BINDING PROTEIN', 246610),
(367777, 'PTHR10126:SF64', NULL, NULL, NULL, NULL, 'TATA-BOX-BINDING PROTEIN', 246610);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(367778, 'PTHR10126:SF42', NULL, NULL, NULL, NULL, 'RT01008P-RELATED', 246610),
(367779, 'PTHR10126:SF41', NULL, NULL, NULL, NULL, 'TBP-RELATED FACTOR', 246610),
(367780, 'PTHR10126:SF63', NULL, NULL, NULL, NULL, 'TATA-BOX-BINDING PROTEIN', 246610),
(367781, 'PTHR10126:SF61', NULL, NULL, NULL, NULL, 'TATA BOX-BINDING PROTEIN-LIKE 1', 246610),
(367782, 'PTHR10126:SF49', NULL, NULL, NULL, NULL, 'BNAA03G55430D PROTEIN', 246610),
(367783, 'PTHR10126:SF48', NULL, NULL, NULL, NULL, 'TATA-BOX-BINDING PROTEIN 1', 246610),
(367784, 'PTHR10126:SF37', NULL, NULL, NULL, NULL, 'TATA BOX-BINDING PROTEIN-LIKE 2', 246610),
(367785, 'PTHR10126:SF58', NULL, NULL, NULL, NULL, 'TATA-BOX-BINDING PROTEIN 1', 246610),
(367786, 'PTHR10126:SF47', NULL, NULL, NULL, NULL, 'BNAC02G01920D PROTEIN', 246610),
(367787, 'PTHR10126:SF69', NULL, NULL, NULL, NULL, 'TATA BOX-BINDING PROTEIN-LIKE 1', 246610),
(367788, 'PTHR21277:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ADAPTER 1', 246611),
(367789, 'PTHR21277', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ADAPTER 1', 246611),
(367790, 'PTHR21277:SF35', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL COACTIVATOR HFI1/TRANSCRIPTIONAL ADAPTER 1-RELATED', 246611),
(367791, 'PTHR21277:SF46', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246611),
(367792, 'PTHR21277:SF25', NULL, NULL, NULL, NULL, 'BNAA01G05800D PROTEIN', 246611),
(367793, 'PTHR21277:SF36', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL COACTIVATOR HFI1/TRANSCRIPTIONAL ADAPTER 1-RELATED', 246611),
(367794, 'PTHR21277:SF33', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL COACTIVATOR HFI1/TRANSCRIPTIONAL ADAPTER 1-RELATED', 246611),
(367795, 'PTHR21277:SF44', NULL, NULL, NULL, NULL, 'BNAA03G50700D PROTEIN', 246611),
(367796, 'PTHR21277:SF22', NULL, NULL, NULL, NULL, '', 246611),
(367797, 'PTHR21277:SF45', NULL, NULL, NULL, NULL, '', 246611),
(367798, 'PTHR21277:SF23', NULL, NULL, NULL, NULL, '', 246611),
(367799, 'PTHR21277:SF34', NULL, NULL, NULL, NULL, 'BNAA03G51500D PROTEIN', 246611),
(367800, 'PTHR21277:SF29', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR OF RNA POLII, SAGA, SUBUNIT', 246611),
(367801, 'PTHR21277:SF26', NULL, NULL, NULL, NULL, '', 246611),
(367802, 'PTHR21277:SF37', NULL, NULL, NULL, NULL, '', 246611),
(367803, 'PTHR21277:SF31', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR OF RNA POLII, SAGA, SUBUNIT', 246611),
(367804, 'PTHR21277:SF42', NULL, NULL, NULL, NULL, 'BNAANNG14490D PROTEIN', 246611),
(367805, 'PTHR21277:SF43', NULL, NULL, NULL, NULL, '', 246611),
(367806, 'PTHR21277:SF40', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR OF RNA POLII, SAGA, SUBUNIT', 246611),
(367807, 'PTHR21277:SF30', NULL, NULL, NULL, NULL, '', 246611),
(367808, 'PTHR31114', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA', 246612),
(367809, 'PTHR31114:SF6', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA', 246612),
(367810, 'PTHR31114:SF5', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA', 246612),
(367811, 'PTHR31114:SF4', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA-RELATED', 246612),
(367812, 'PTHR31114:SF3', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA-RELATED', 246612),
(367813, 'PTHR14663', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 246613),
(367814, 'PTHR14663:SF2', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE NSUN7-RELATED', 246613),
(367815, 'PTHR48026:SF9', NULL, NULL, NULL, NULL, '', 246614),
(367816, 'PTHR48026:SF8', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 44', 246614),
(367817, 'PTHR48026:SF17', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 246614),
(367818, 'PTHR48026:SF6', NULL, NULL, NULL, NULL, '', 246614),
(367819, 'PTHR48026:SF16', NULL, NULL, NULL, NULL, 'HOMOLOGOUS TO DROSOPHILA SQD (SQUID) PROTEIN', 246614),
(367820, 'PTHR48026:SF5', NULL, NULL, NULL, NULL, '', 246614),
(367821, 'PTHR48026:SF19', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN A1-LIKE 2', 246614),
(367822, 'PTHR48026:SF3', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 246614),
(367823, 'PTHR48026:SF2', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN A1-RELATED', 246614);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(367824, 'PTHR48026', NULL, NULL, NULL, NULL, 'HOMOLOGOUS TO DROSOPHILA SQD (SQUID) PROTEIN', 246614),
(367825, 'PTHR48026:SF24', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 246614),
(367826, 'PTHR48026:SF13', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEINS A2/B1', 246614),
(367827, 'PTHR48026:SF12', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN A3', 246614),
(367828, 'PTHR48026:SF23', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN A0,-LIKE', 246614),
(367829, 'PTHR48026:SF15', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 246614),
(367830, 'PTHR48026:SF14', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN A1', 246614),
(367831, 'PTHR48026:SF20', NULL, NULL, NULL, NULL, 'HELIX-DESTABILIZING PROTEIN', 246614),
(367832, 'PTHR48026:SF22', NULL, NULL, NULL, NULL, 'HELIX-DESTABILIZING PROTEIN', 246614),
(367833, 'PTHR48026:SF21', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN R05D3.8-RELATED', 246614),
(367834, 'PTHR48026:SF10', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 246614),
(367835, 'PTHR38608:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG07207', 246615),
(367836, 'PTHR38608:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG20616', 246615),
(367837, 'PTHR38608:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG03806', 246615),
(367838, 'PTHR38608', NULL, NULL, NULL, NULL, 'PROTEIN CBG07207', 246615),
(367839, 'PTHR38608:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG00664', 246615),
(367840, 'PTHR39576:SF2', NULL, NULL, NULL, NULL, 'ATTACHING AND EFFACING PROTEIN HOMOLOG-RELATED', 246616),
(367841, 'PTHR39576:SF1', NULL, NULL, NULL, NULL, 'INVASIN-RELATED', 246616),
(367842, 'PTHR39576', NULL, NULL, NULL, NULL, 'ATTACHING AND EFFACING PROTEIN HOMOLOG-RELATED-RELATED', 246616),
(367843, 'PTHR38928', NULL, NULL, NULL, NULL, 'ARGOS7', 246617),
(367844, 'PTHR38928:SF7', NULL, NULL, NULL, NULL, 'ARGOS7', 246617),
(367845, 'PTHR38928:SF8', NULL, NULL, NULL, NULL, '', 246617),
(367846, 'PTHR38928:SF5', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 246617),
(367847, 'PTHR40069:SF1', NULL, NULL, NULL, NULL, 'YWBE PROTEIN', 246618),
(367848, 'PTHR40069', NULL, NULL, NULL, NULL, 'YWBE PROTEIN', 246618),
(367849, 'PTHR33888', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4932415D10 GENE', 246619),
(367850, 'PTHR33888:SF1', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4932415D10 GENE', 246619),
(367851, 'PTHR23081:SF2', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II C-TERMINAL DOMAIN PHOSPHATASE-LIKE 3', 246620),
(367852, 'PTHR23081:SF0', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II SUBUNIT A C-TERMINAL DOMAIN PHOSPHATASE', 246620),
(367853, 'PTHR23081:SF19', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II C-TERMINAL DOMAIN PHOSPHATASE-LIKE', 246620),
(367854, 'PTHR23081', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II CTD PHOSPHATASE', 246620),
(367855, 'PTHR23081:SF38', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 246620),
(367856, 'PTHR23081:SF28', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II C-TERMINAL DOMAIN PHOSPHATASE-LIKE', 246620),
(367857, 'PTHR23081:SF4', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 246620),
(367858, 'PTHR23081:SF21', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II C-TERMINAL DOMAIN PHOSPHATASE-LIKE-RELATED', 246620),
(367859, 'PTHR23081:SF22', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II C-TERMINAL DOMAIN PHOSPHATASE-LIKE', 246620),
(367860, 'PTHR23081:SF30', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II C-TERMINAL DOMAIN PHOSPHATASE-LIKE', 246620),
(367861, 'PTHR23081:SF31', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II C-TERMINAL DOMAIN PHOSPHATASE-LIKE', 246620),
(367862, 'PTHR23081:SF36', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II C-TERMINAL DOMAIN PHOSPHATASE-LIKE 4', 246620),
(367863, 'PTHR23081:SF37', NULL, NULL, NULL, NULL, 'PROTEIN CBG13622', 246620),
(367864, 'PTHR23081:SF26', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II C-TERMINAL DOMAIN PHOSPHATASE-LIKE', 246620),
(367865, 'PTHR23081:SF23', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II C-TERMINAL DOMAIN PHOSPHATASE-LIKE', 246620),
(367866, 'PTHR23081:SF34', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 246620); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(367867, 'PTHR23081:SF24', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II C-TERMINAL DOMAIN PHOSPHATASE-LIKE 2', 246620),
(367868, 'PTHR23081:SF35', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II C-TERMINAL DOMAIN PHOSPHATASE-LIKE', 246620),
(367869, 'PTHR47800:SF6', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 246621),
(367870, 'PTHR47800', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 246621),
(367871, 'PTHR47800:SF5', NULL, NULL, NULL, NULL, 'FER-1-LIKE PROTEIN 6', 246621),
(367872, 'PTHR47800:SF4', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 246621),
(367873, 'PTHR34281:SF9', NULL, NULL, NULL, NULL, 'FLOWERING PROTEIN, PUTATIVE-RELATED', 246622),
(367874, 'PTHR34281:SF20', NULL, NULL, NULL, NULL, 'PROTEIN EARLY FLOWERING 3', 246622),
(367875, 'PTHR34281', NULL, NULL, NULL, NULL, 'PROTEIN EARLY FLOWERING 3', 246622),
(367876, 'PTHR34281:SF2', NULL, NULL, NULL, NULL, 'PROTEIN EARLY FLOWERING 3', 246622),
(367877, 'PTHR34281:SF12', NULL, NULL, NULL, NULL, 'EARLY FLOWERING 3', 246622),
(367878, 'PTHR34281:SF11', NULL, NULL, NULL, NULL, 'BNAA09G40710D PROTEIN', 246622),
(367879, 'PTHR34281:SF16', NULL, NULL, NULL, NULL, 'BNAC03G42060D PROTEIN', 246622),
(367880, 'PTHR34281:SF8', NULL, NULL, NULL, NULL, 'PROTEIN EARLY FLOWERING 3-LIKE', 246622),
(367881, 'PTHR34281:SF14', NULL, NULL, NULL, NULL, 'BNAA05G36670D PROTEIN', 246622),
(367882, 'PTHR34281:SF15', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN-RELATED', 246622),
(367883, 'PTHR34281:SF7', NULL, NULL, NULL, NULL, 'EARLY FLOWERING PROTEIN', 246622),
(367884, 'PTHR21528', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 246623),
(367885, 'PTHR21528:SF0', NULL, NULL, NULL, NULL, 'DEHYDRODOLICHYL DIPHOSPHATE SYNTHASE COMPLEX SUBUNIT NUS1', 246623),
(367886, 'PTHR21528:SF2', NULL, NULL, NULL, NULL, 'DITRANS,POLYCIS-POLYPRENYL DIPHOSPHATE SYNTHASE ((2E,6E)-FARNESYLDIPHOSPHATE SPECIFIC)', 246623),
(367887, 'PTHR21528:SF3', NULL, NULL, NULL, NULL, 'DEHYDRODOLICHYL DIPHOSPHATE SYNTHASE COMPLEX SUBUNIT NUS1', 246623),
(367888, 'PTHR21528:SF5', NULL, NULL, NULL, NULL, 'DITRANS,POLYCIS-POLYPRENYL DIPHOSPHATE SYNTHASE ((2E,6E)-FARNESYLDIPHOSPHATE SPECIFIC)', 246623),
(367889, 'PTHR39945:SF1', NULL, NULL, NULL, NULL, 'FI14129P', 246624),
(367890, 'PTHR39945', NULL, NULL, NULL, NULL, 'FI14129P', 246624),
(367891, 'PTHR28674', NULL, NULL, NULL, NULL, 'SIMILAR TO DNA SEGMENT, CHR 10, WAYNE STATE UNIVERSITY 102,-EXPRESSED', 246625),
(367892, 'PTHR28674:SF1', NULL, NULL, NULL, NULL, 'NOP PROTEIN CHAPERONE 1', 246625),
(367893, 'PTHR46234:SF12', NULL, NULL, NULL, NULL, 'ALPHA/BETA HYDROLASE FOLD PROTEIN-RELATED', 246626),
(367894, 'PTHR46234:SF21', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 246626),
(367895, 'PTHR46234:SF10', NULL, NULL, NULL, NULL, 'ACYL-PROTEIN THIOESTERASE 1-LIKE', 246626),
(367896, 'PTHR46234:SF20', NULL, NULL, NULL, NULL, 'ACYL THIOESTERASE-LIKE PROTEIN', 246626),
(367897, 'PTHR46234:SF16', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 246626),
(367898, 'PTHR46234:SF14', NULL, NULL, NULL, NULL, 'ABHYDROLASE_2 DOMAIN-CONTAINING PROTEIN', 246626),
(367899, 'PTHR46234:SF13', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 246626),
(367900, 'PTHR46234', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 246626),
(367901, 'PTHR46234:SF3', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 246626),
(367902, 'PTHR46234:SF2', NULL, NULL, NULL, NULL, 'OS01G0612500 PROTEIN', 246626),
(367903, 'PTHR46234:SF19', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN-RELATED', 246626),
(367904, 'PTHR46234:SF18', NULL, NULL, NULL, NULL, 'ABHYDROLASE_2 DOMAIN-CONTAINING PROTEIN', 246626),
(367905, 'PTHR46234:SF17', NULL, NULL, NULL, NULL, 'ABHYDROLASE_2 DOMAIN-CONTAINING PROTEIN', 246626),
(367906, 'PTHR46234:SF7', NULL, NULL, NULL, NULL, 'OS04G0174900 PROTEIN', 246626),
(367907, 'PTHR46234:SF9', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 246626),
(367908, 'PTHR36512:SF3', NULL, NULL, NULL, NULL, 'BLR5678 PROTEIN', 246627);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(367909, 'PTHR36512', NULL, NULL, NULL, NULL, 'D-AMINOPEPTIDASE', 246627),
(367910, 'PTHR46214:SF4', NULL, NULL, NULL, NULL, 'OS05G0452800 PROTEIN', 246628),
(367911, 'PTHR46214', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING-CH-TYPE', 246628),
(367912, 'PTHR46214:SF29', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 246628),
(367913, 'PTHR46214:SF18', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 246628),
(367914, 'PTHR46214:SF28', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 246628),
(367915, 'PTHR46214:SF17', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MARCH-RELATED', 246628),
(367916, 'PTHR46214:SF38', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER SUPERFAMILY PROTEIN', 246628),
(367917, 'PTHR46214:SF16', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 246628),
(367918, 'PTHR46214:SF27', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 246628),
(367919, 'PTHR46214:SF26', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 246628),
(367920, 'PTHR46214:SF36', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 246628),
(367921, 'PTHR46214:SF14', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 246628),
(367922, 'PTHR46214:SF25', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 246628),
(367923, 'PTHR46214:SF24', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 246628),
(367924, 'PTHR46214:SF12', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER SUPERFAMILY PROTEIN', 246628),
(367925, 'PTHR46214:SF11', NULL, NULL, NULL, NULL, 'OS05G0207400 PROTEIN', 246628),
(367926, 'PTHR46214:SF22', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 246628),
(367927, 'PTHR46214:SF21', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 246628),
(367928, 'PTHR46214:SF8', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER SUPERFAMILY PROTEIN', 246628),
(367929, 'PTHR46214:SF30', NULL, NULL, NULL, NULL, 'OS01G0850200 PROTEIN', 246628),
(367930, 'PTHR46214:SF40', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MARCH8-LIKE', 246628),
(367931, 'PTHR42927', NULL, NULL, NULL, NULL, 'HELICASE SUPERFAMILY 1 AND 2 DOMAIN-CONTAINING PROTEIN', 246629),
(367932, 'PTHR42927:SF1', NULL, NULL, NULL, NULL, 'HELICASE SUPERFAMILY 1 AND 2 DOMAIN-CONTAINING PROTEIN', 246629),
(367933, 'PTHR42927:SF2', NULL, NULL, NULL, NULL, '', 246629),
(367934, 'PTHR14005:SF0', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT A', 246630),
(367935, 'PTHR14005:SF5', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT A', 246630),
(367936, 'PTHR14005', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3, THETA SUBUNIT', 246630),
(367937, 'PTHR14005:SF2', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT A', 246630),
(367938, 'PTHR14005:SF1', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT A', 246630),
(367939, 'PTHR14005:SF4', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT A', 246630),
(367940, 'PTHR31644', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR ARO80-RELATED', 246631),
(367941, 'PTHR31644:SF4', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 246631),
(367942, 'PTHR31644:SF3', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 246631),
(367943, 'PTHR31644:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR ARO80', 246631),
(367944, 'PTHR31644:SF1', NULL, NULL, NULL, NULL, 'WEAK ACID RESISTANCE PROTEIN 1', 246631),
(367945, 'PTHR42803:SF3', NULL, NULL, NULL, NULL, 'ACYL-COA DEHYDROGENASE-RELATED', 246632),
(367946, 'PTHR42803:SF1', NULL, NULL, NULL, NULL, 'BROAD-SPECIFICITY LINEAR ACYL-COA DEHYDROGENASE FADE5', 246632),
(367947, 'PTHR42803', NULL, NULL, NULL, NULL, 'ACYL-COA DEHYDROGENASE', 246632),
(367948, 'PTHR38435:SF2', NULL, NULL, NULL, NULL, 'DUF871_N DOMAIN-CONTAINING PROTEIN', 246633),
(367949, 'PTHR38435:SF1', NULL, NULL, NULL, NULL, 'OUTER SURFACE PROTEIN', 246633);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(367950, 'PTHR38435', NULL, NULL, NULL, NULL, '', 246633),
(367951, 'PTHR44942:SF6', NULL, NULL, NULL, NULL, 'NOVEL PROTEIN', 246634),
(367952, 'PTHR44942', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 246634),
(367953, 'PTHR44942:SF4', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 246634),
(367954, 'PTHR44942:SF10', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 246634),
(367955, 'PTHR44942:SF9', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN-RELATED', 246634),
(367956, 'PTHR36193', NULL, NULL, NULL, NULL, 'PHISTB DOMAIN-CONTAINING RESA-LIKE PROTEIN 1', 246635),
(367957, 'PTHR36193:SF23', NULL, NULL, NULL, NULL, 'PHISTB DOMAIN-CONTAINING RESA-LIKE PROTEIN 1', 246635),
(367958, 'PTHR23309:SF35', NULL, NULL, NULL, NULL, '3-HYDROXYACYL-COA DEHYDROGENASE', 246636),
(367959, 'PTHR23309:SF47', NULL, NULL, NULL, NULL, '3-HYDROXYACYL-COA DEHYDROGENASE', 246636),
(367960, 'PTHR23309', NULL, NULL, NULL, NULL, '3-HYDROXYACYL-COA DEHYROGENASE', 246636),
(367961, 'PTHR23309:SF33', NULL, NULL, NULL, NULL, '3-HYDROXYACYL-COA DEHYDROGENASE', 246636),
(367962, 'PTHR23309:SF45', NULL, NULL, NULL, NULL, '3-HYDROXYACYL-COA DEHYDROGENASE', 246636),
(367963, 'PTHR23309:SF34', NULL, NULL, NULL, NULL, '3-HYDROXYACYL-COA DEHYDROGENASE', 246636),
(367964, 'PTHR23309:SF39', NULL, NULL, NULL, NULL, '3-HYDROXYACYL-COA DEHYDROGENASE', 246636),
(367965, 'PTHR23309:SF37', NULL, NULL, NULL, NULL, '3-HYDROXYACYL-COA DEHYDROGENASE', 246636),
(367966, 'PTHR23309:SF49', NULL, NULL, NULL, NULL, 'PEROXISOMAL BIFUNCTIONAL ENZYME', 246636),
(367967, 'PTHR23309:SF16', NULL, NULL, NULL, NULL, 'ENOYL-COA HYDRATASE', 246636),
(367968, 'PTHR23309:SF9', NULL, NULL, NULL, NULL, 'PEROXISOMAL FATTY ACID BETA-OXIDATION MULTIFUNCTIONAL PROTEIN MFP2', 246636),
(367969, 'PTHR23309:SF50', NULL, NULL, NULL, NULL, '3-HYDROXYACYL-COA DEHYDROGENASE', 246636),
(367970, 'PTHR23309:SF31', NULL, NULL, NULL, NULL, '3-HYDROXYACYL-COA DEHYDROGENASE', 246636),
(367971, 'PTHR23309:SF43', NULL, NULL, NULL, NULL, '3-HYDROXYACYL-COA DEHYDROGENASE', 246636),
(367972, 'PTHR23309:SF51', NULL, NULL, NULL, NULL, '3-HYDROXYACYL-COA DEHYDROGENASE-RELATED', 246636),
(367973, 'PTHR23309:SF40', NULL, NULL, NULL, NULL, '3-HYDROXYACYL-COA DEHYDROGENASE-RELATED', 246636),
(367974, 'PTHR23309:SF41', NULL, NULL, NULL, NULL, '3-HYDROXYACYL-COA DEHYDROGENASE', 246636),
(367975, 'PTHR23309:SF52', NULL, NULL, NULL, NULL, '3-HYDROXYACYL-COA DEHYDROGENASE', 246636),
(367976, 'PTHR34116:SF10', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 246637),
(367977, 'PTHR34116:SF12', NULL, NULL, NULL, NULL, 'BNAA09G15030D PROTEIN', 246637),
(367978, 'PTHR34116:SF9', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 246637),
(367979, 'PTHR34116:SF2', NULL, NULL, NULL, NULL, 'PLASMINOGEN ACTIVATOR INHIBITOR', 246637),
(367980, 'PTHR34116:SF14', NULL, NULL, NULL, NULL, '', 246637),
(367981, 'PTHR34116', NULL, NULL, NULL, NULL, 'PLASMINOGEN ACTIVATOR INHIBITOR', 246637),
(367982, 'PTHR34116:SF13', NULL, NULL, NULL, NULL, '', 246637),
(367983, 'PTHR34116:SF15', NULL, NULL, NULL, NULL, 'OS08G0346600 PROTEIN', 246637),
(367984, 'PTHR42773', NULL, NULL, NULL, NULL, 'METALLO-BETA-LACTAMASE-RELATED', 246638),
(367985, 'PTHR42773:SF1', NULL, NULL, NULL, NULL, 'METALLO-BETA-LACTAMASE FAMILY PROTEIN', 246638),
(367986, 'PTHR42773:SF3', NULL, NULL, NULL, NULL, 'SLR0630 PROTEIN', 246638),
(367987, 'PTHR42773:SF2', NULL, NULL, NULL, NULL, 'LACTAMASE_B DOMAIN-CONTAINING PROTEIN', 246638),
(367988, 'PTHR35512:SF1', NULL, NULL, NULL, NULL, 'OS11G0550900 PROTEIN', 246639),
(367989, 'PTHR35512', NULL, NULL, NULL, NULL, 'OS11G0550900 PROTEIN', 246639),
(367990, 'PTHR46889', NULL, NULL, NULL, NULL, 'TRANSPOSASE INSF FOR INSERTION SEQUENCE IS3B-RELATED', 246640),
(367991, 'PTHR46889:SF4', NULL, NULL, NULL, NULL, 'TRANSPOSASE INSF FOR INSERTION SEQUENCE IS3B', 246640),
(367992, 'PTHR46889:SF1', NULL, NULL, NULL, NULL, 'TRANSPOSASE FOR INSERTION SEQUENCE ELEMENT IS904-RELATED', 246640),
(367993, 'PTHR15082', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE B12 SUBUNIT', 246641);
INSERT INTO "PUBLIC"."MODEL" VALUES
(367994, 'PTHR15082:SF4', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 BETA SUBCOMPLEX SUBUNIT 3-B', 246641),
(367995, 'PTHR15082:SF2', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 BETA SUBCOMPLEX SUBUNIT 3', 246641),
(367996, 'PTHR48204:SF1', NULL, NULL, NULL, NULL, 'OS07G0265100 PROTEIN', 246642),
(367997, 'PTHR48204', NULL, NULL, NULL, NULL, 'OS07G0265100 PROTEIN', 246642),
(367998, 'PTHR10688:SF15', NULL, NULL, NULL, NULL, 'TUDOR/PWWP/MBT SUPERFAMILY PROTEIN-RELATED', 246643),
(367999, 'PTHR10688:SF16', NULL, NULL, NULL, NULL, 'TUDOR/PWWP/MBT SUPERFAMILY PROTEIN', 246643),
(368000, 'PTHR10688:SF6', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-KINASE ATM', 246643),
(368001, 'PTHR10688', NULL, NULL, NULL, NULL, 'PWWP DOMAIN-CONTAINING PROTEIN', 246643),
(368002, 'PTHR10688:SF17', NULL, NULL, NULL, NULL, 'PWWP DOMAIN-CONTAINING PROTEIN', 246643),
(368003, 'PTHR10688:SF5', NULL, NULL, NULL, NULL, 'F22F7.12 PROTEIN-RELATED', 246643),
(368004, 'PTHR10688:SF3', NULL, NULL, NULL, NULL, 'TUDOR/PWWP/MBT SUPERFAMILY PROTEIN', 246643),
(368005, 'PTHR10688:SF2', NULL, NULL, NULL, NULL, '', 246643),
(368006, 'PTHR10688:SF14', NULL, NULL, NULL, NULL, 'PWWP DOMAIN-CONTAINING PROTEIN', 246643),
(368007, 'PTHR31630:SF6', NULL, NULL, NULL, NULL, 'PHYTANOYL-COA DIOXYGENASE-RELATED', 246644),
(368008, 'PTHR31630:SF10', NULL, NULL, NULL, NULL, '', 246644),
(368009, 'PTHR31630:SF7', NULL, NULL, NULL, NULL, '', 246644),
(368010, 'PTHR31630:SF8', NULL, NULL, NULL, NULL, '', 246644),
(368011, 'PTHR31630:SF9', NULL, NULL, NULL, NULL, '', 246644),
(368012, 'PTHR31630', NULL, NULL, NULL, NULL, 'PHYTANOYL-COA DIOXYGENASE-RELATED-RELATED', 246644),
(368013, 'PTHR10824:SF10', NULL, NULL, NULL, NULL, 'PROTEIN CBG04103', 246645),
(368014, 'PTHR10824:SF16', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A THIOESTERASE 1-RELATED', 246645),
(368015, 'PTHR10824', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A THIOESTERASE-RELATED', 246645),
(368016, 'PTHR10824:SF18', NULL, NULL, NULL, NULL, 'BILE ACID-COA:AMINO ACID N-ACYLTRANSFERASE', 246645),
(368017, 'PTHR10824:SF17', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A THIOESTERASE 6-RELATED', 246645),
(368018, 'PTHR10824:SF12', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A THIOESTERASE 1-RELATED', 246645),
(368019, 'PTHR10824:SF11', NULL, NULL, NULL, NULL, 'PROTEIN CBG12426', 246645),
(368020, 'PTHR10824:SF36', NULL, NULL, NULL, NULL, 'ACYL-COA THIOESTERASE 14-RELATED', 246645),
(368021, 'PTHR10824:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG12559', 246645),
(368022, 'PTHR10824:SF6', NULL, NULL, NULL, NULL, 'PEROXISOMAL SUCCINYL-COENZYME A THIOESTERASE', 246645),
(368023, 'PTHR10824:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG14567', 246645),
(368024, 'PTHR10824:SF3', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A THIOESTERASE 5', 246645),
(368025, 'PTHR10824:SF1', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A AMINO ACID N-ACYLTRANSFERASE 1-RELATED', 246645),
(368026, 'PTHR38886:SF1', NULL, NULL, NULL, NULL, 'SESA DOMAIN-CONTAINING PROTEIN', 246646),
(368027, 'PTHR38886', NULL, NULL, NULL, NULL, 'SESA DOMAIN-CONTAINING PROTEIN', 246646),
(368028, 'PTHR33639', NULL, NULL, NULL, NULL, 'THIOL-DISULFIDE OXIDOREDUCTASE DCC', 246647),
(368029, 'PTHR33639:SF2', NULL, NULL, NULL, NULL, 'THIOL-DISULFIDE OXIDOREDUCTASE DCC', 246647),
(368030, 'PTHR33639:SF1', NULL, NULL, NULL, NULL, 'THIOL-DISULFIDE OXIDOREDUCTASE DCC-RELATED', 246647),
(368031, 'PTHR15962:SF0', NULL, NULL, NULL, NULL, 'ACTIVITY-REGULATED CYTOSKELETON-ASSOCIATED PROTEIN', 246648),
(368032, 'PTHR15962', NULL, NULL, NULL, NULL, 'ACTIVITY-REGULATED CYTOSKELETON-ASSOCIATED PROTEIN', 246648),
(368033, 'PTHR24147:SF29', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 62', 246649),
(368034, 'PTHR24147', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN 36-RELATED', 246649),
(368035, 'PTHR24147:SF71', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 36C', 246649),
(368036, 'PTHR24147:SF60', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 26', 246649),
(368037, 'PTHR24147:SF70', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 246649);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(368038, 'PTHR24147:SF53', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 246649),
(368039, 'PTHR24147:SF64', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 19-RELATED', 246649),
(368040, 'PTHR24147:SF63', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 30A', 246649),
(368041, 'PTHR24147:SF52', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 30B', 246649),
(368042, 'PTHR24147:SF62', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 7-RELATED', 246649),
(368043, 'PTHR24147:SF1', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 20A1-RELATED', 246649),
(368044, 'PTHR24147:SF50', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 36A-RELATED', 246649),
(368045, 'PTHR24147:SF68', NULL, NULL, NULL, NULL, 'POTE ANKYRIN DOMAIN FAMILY MEMBER A', 246649),
(368046, 'PTHR24147:SF67', NULL, NULL, NULL, NULL, 'ANKRD26-LIKE FAMILY C, MEMBER 3', 246649),
(368047, 'PTHR24147:SF22', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 18A', 246649),
(368048, 'PTHR24147:SF66', NULL, NULL, NULL, NULL, 'POTE ANKYRIN DOMAIN FAMILY MEMBER D', 246649),
(368049, 'PTHR24147:SF65', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 26-LIKE PROTEIN-RELATED', 246649),
(368050, 'PTHR24147:SF59', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 18B', 246649),
(368051, 'PTHR24147:SF69', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN 36', 246649),
(368052, 'PTHR11880:SF56', NULL, NULL, NULL, NULL, '', 246650),
(368053, 'PTHR11880:SF57', NULL, NULL, NULL, NULL, '', 246650),
(368054, 'PTHR11880:SF35', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S19, CHLOROPLASTIC', 246650),
(368055, 'PTHR11880:SF58', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S15-6', 246650),
(368056, 'PTHR11880:SF48', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S19-RELATED', 246650),
(368057, 'PTHR11880:SF59', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S15-4', 246650),
(368058, 'PTHR11880:SF37', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S15-LIKE', 246650),
(368059, 'PTHR11880:SF52', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S19, CHLOROPLASTIC', 246650),
(368060, 'PTHR11880:SF41', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S15-3', 246650),
(368061, 'PTHR11880:SF53', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S15-1-RELATED', 246650),
(368062, 'PTHR11880:SF42', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S19, CHLOROPLASTIC', 246650),
(368063, 'PTHR11880:SF60', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S15-LIKE', 246650),
(368064, 'PTHR11880:SF61', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S15-LIKE', 246650),
(368065, 'PTHR11880:SF51', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S19, CHLOROPLASTIC', 246650),
(368066, 'PTHR11880:SF2', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S15', 246650),
(368067, 'PTHR11880:SF8', NULL, NULL, NULL, NULL, '37S RIBOSOMAL PROTEIN S19, MITOCHONDRIAL', 246650),
(368068, 'PTHR11880:SF49', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S15-2', 246650),
(368069, 'PTHR11880:SF27', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S15', 246650),
(368070, 'PTHR11880:SF28', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S15', 246650),
(368071, 'PTHR11880:SF39', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S19, CHLOROPLASTIC', 246650),
(368072, 'PTHR11880', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S19P FAMILY MEMBER', 246650),
(368073, 'PTHR36842:SF2', NULL, NULL, NULL, NULL, 'SLR0195 PROTEIN', 246651),
(368074, 'PTHR36842:SF1', NULL, NULL, NULL, NULL, 'TOL-PAL SYSTEM PROTEIN TOLB', 246651),
(368075, 'PTHR36842', NULL, NULL, NULL, NULL, 'PROTEIN TOLB HOMOLOG', 246651),
(368076, 'PTHR12755:SF7', NULL, NULL, NULL, NULL, '', 246652),
(368077, 'PTHR12755', NULL, NULL, NULL, NULL, 'CLEAVAGE/POLYADENYLATION FACTOR IA SUBUNIT CLP1P', 246652),
(368078, 'PTHR12755:SF6', NULL, NULL, NULL, NULL, 'POLYRIBONUCLEOTIDE 5''-HYDROXYL-KINASE CLP1', 246652),
(368079, 'PTHR12755:SF19', NULL, NULL, NULL, NULL, 'PROTEIN CLP1 HOMOLOG 5', 246652);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(368080, 'PTHR12755:SF3', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDE 5''-HYDROXYL-KINASE NOL9', 246652),
(368081, 'PTHR12755:SF18', NULL, NULL, NULL, NULL, 'OS01G0354700 PROTEIN', 246652),
(368082, 'PTHR12755:SF4', NULL, NULL, NULL, NULL, '', 246652),
(368083, 'PTHR12755:SF17', NULL, NULL, NULL, NULL, 'CLP1_P DOMAIN-CONTAINING PROTEIN', 246652),
(368084, 'PTHR46292', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 102A', 246653),
(368085, 'PTHR46292:SF2', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 102B', 246653),
(368086, 'PTHR46292:SF3', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 102A', 246653),
(368087, 'PTHR46292:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 102A', 246653),
(368088, 'PTHR11306:SF50', NULL, NULL, NULL, NULL, 'ML DOMAIN-CONTAINING PROTEIN', 246654),
(368089, 'PTHR11306:SF51', NULL, NULL, NULL, NULL, 'ML DOMAIN-CONTAINING PROTEIN', 246654),
(368090, 'PTHR11306:SF65', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLGLYCEROL/PHOSPHATIDYLINOSITOL TRANSFER PROTEIN DDB_G0282179-RELATED', 246654),
(368091, 'PTHR11306:SF43', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN E-SET-RELATED', 246654),
(368092, 'PTHR11306:SF64', NULL, NULL, NULL, NULL, 'LEGUMINOSIN GROUP578 SECRETED PEPTIDE', 246654),
(368093, 'PTHR11306:SF45', NULL, NULL, NULL, NULL, 'ML DOMAIN-CONTAINING PROTEIN', 246654),
(368094, 'PTHR11306:SF67', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLGLYCEROL/PHOSPHATIDYLINOSITOL TRANSFER PROTEIN DDB_G0278295-RELATED', 246654),
(368095, 'PTHR11306:SF44', NULL, NULL, NULL, NULL, 'MD-LIKE LIPID RECOGNITION DOMAIN PROTEIN/ML DOMAIN PROTEIN', 246654),
(368096, 'PTHR11306:SF66', NULL, NULL, NULL, NULL, 'ML DOMAIN-CONTAINING PROTEIN', 246654),
(368097, 'PTHR11306:SF46', NULL, NULL, NULL, NULL, 'MD-2-RELATED LIPID-RECOGNITION PROTEIN ROSY1', 246654),
(368098, 'PTHR11306:SF49', NULL, NULL, NULL, NULL, 'ML DOMAIN-CONTAINING PROTEIN', 246654),
(368099, 'PTHR11306:SF48', NULL, NULL, NULL, NULL, 'ML DOMAIN-CONTAINING PROTEIN', 246654),
(368100, 'PTHR11306:SF0', NULL, NULL, NULL, NULL, 'NPC INTRACELLULAR CHOLESTEROL TRANSPORTER 2', 246654),
(368101, 'PTHR11306:SF60', NULL, NULL, NULL, NULL, 'COUNTIN-3-RELATED', 246654),
(368102, 'PTHR11306:SF63', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLGLYCEROL/PHOSPHATIDYLINOSITOL TRANSFER PROTEIN DDB_G0282179-RELATED', 246654),
(368103, 'PTHR11306:SF41', NULL, NULL, NULL, NULL, 'BNAA09G12830D PROTEIN', 246654),
(368104, 'PTHR11306:SF62', NULL, NULL, NULL, NULL, 'OS07G0159800 PROTEIN', 246654),
(368105, 'PTHR11306:SF40', NULL, NULL, NULL, NULL, 'ML DOMAIN-CONTAINING PROTEIN', 246654),
(368106, 'PTHR11306:SF54', NULL, NULL, NULL, NULL, 'MD-2-RELATED LIPID RECOGNITION DOMAIN-CONTAINING PROTEIN-RELATED', 246654),
(368107, 'PTHR11306:SF56', NULL, NULL, NULL, NULL, 'LP08842P-RELATED', 246654),
(368108, 'PTHR11306:SF55', NULL, NULL, NULL, NULL, 'GEO08227P1-RELATED', 246654),
(368109, 'PTHR11306:SF36', NULL, NULL, NULL, NULL, 'NIEMANN-PICK TYPE C-2C-RELATED', 246654),
(368110, 'PTHR11306:SF57', NULL, NULL, NULL, NULL, 'ML DOMAIN-CONTAINING PROTEIN', 246654),
(368111, 'PTHR11306:SF35', NULL, NULL, NULL, NULL, 'ML DOMAIN-CONTAINING PROTEIN', 246654),
(368112, 'PTHR11306', NULL, NULL, NULL, NULL, 'NIEMANN PICK TYPE C2 PROTEIN NPC2-RELATED', 246654),
(368113, 'PTHR11306:SF7', NULL, NULL, NULL, NULL, 'AGAP002848-PA', 246654),
(368114, 'PTHR11306:SF39', NULL, NULL, NULL, NULL, 'MD-2-RELATED LIPID RECOGNITION DOMAIN-CONTAINING PROTEIN / ML DOMAIN-CONTAINING PROTEIN', 246654),
(368115, 'PTHR30633', NULL, NULL, NULL, NULL, 'CYTOCHROME C-552 RESPIRATORY NITRITE REDUCTASE', 246655),
(368116, 'PTHR30633:SF0', NULL, NULL, NULL, NULL, 'CYTOCHROME C-552', 246655),
(368117, 'PTHR34819:SF3', NULL, NULL, NULL, NULL, 'CELL SURFACE PROTEIN-RELATED', 246656),
(368118, 'PTHR34819', NULL, NULL, NULL, NULL, 'LARGE CYSTEINE-RICH PERIPLASMIC PROTEIN OMCB', 246656),
(368119, 'PTHR39162:SF1', NULL, NULL, NULL, NULL, 'GLL3345 PROTEIN', 246657),
(368120, 'PTHR39162', NULL, NULL, NULL, NULL, 'GLL3345 PROTEIN', 246657),
(368121, 'PTHR24412:SF162', NULL, NULL, NULL, NULL, 'KELCH-LIKE ECH-ASSOCIATED PROTEIN 1', 246658);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(368122, 'PTHR24412:SF481', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246658),
(368123, 'PTHR24412:SF22', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 40', 246658),
(368124, 'PTHR24412:SF23', NULL, NULL, NULL, NULL, 'KELCH REPEAT AND BTB DOMAIN-CONTAINING PROTEIN 7', 246658),
(368125, 'PTHR24412:SF480', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 8', 246658),
(368126, 'PTHR24412:SF483', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246658),
(368127, 'PTHR24412:SF482', NULL, NULL, NULL, NULL, 'KELCH REPEAT AND BTB DOMAIN-CONTAINING PROTEIN F47D12.7-RELATED', 246658),
(368128, 'PTHR24412:SF163', NULL, NULL, NULL, NULL, 'CALICIN', 246658),
(368129, 'PTHR24412:SF485', NULL, NULL, NULL, NULL, 'BACK DOMAIN-CONTAINING PROTEIN', 246658),
(368130, 'PTHR24412:SF441', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 28', 246658),
(368131, 'PTHR24412:SF484', NULL, NULL, NULL, NULL, 'B BOX-TYPE DOMAIN-CONTAINING PROTEIN', 246658),
(368132, 'PTHR24412:SF486', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246658),
(368133, 'PTHR24412:SF401', NULL, NULL, NULL, NULL, 'FI11917P', 246658),
(368134, 'PTHR24412:SF459', NULL, NULL, NULL, NULL, 'KELCH REPEAT AND BTB DOMAIN-CONTAINING PROTEIN 12', 246658),
(368135, 'PTHR24412:SF418', NULL, NULL, NULL, NULL, 'KELCH REPEAT AND BTB DOMAIN-CONTAINING PROTEIN 3', 246658),
(368136, 'PTHR24412:SF419', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246658),
(368137, 'PTHR24412:SF250', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 12', 246658),
(368138, 'PTHR24412:SF172', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 10', 246658),
(368139, 'PTHR24412:SF450', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246658),
(368140, 'PTHR24412:SF174', NULL, NULL, NULL, NULL, 'KELCH-LIKE ECH-ASSOCIATED PROTEIN 1A', 246658),
(368141, 'PTHR24412:SF452', NULL, NULL, NULL, NULL, 'SPERMATOCYTE PROTEIN SPE-26', 246658),
(368142, 'PTHR24412:SF451', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 20', 246658),
(368143, 'PTHR24412:SF135', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 5', 246658),
(368144, 'PTHR24412:SF179', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 3', 246658),
(368145, 'PTHR24412:SF10', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 29', 246658),
(368146, 'PTHR24412:SF255', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 21', 246658),
(368147, 'PTHR24412:SF455', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 12', 246658),
(368148, 'PTHR24412:SF458', NULL, NULL, NULL, NULL, 'KELCH REPEAT AND BTB (POZ) DOMAIN-CONTAINING 6', 246658),
(368149, 'PTHR24412:SF215', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 24', 246658),
(368150, 'PTHR24412:SF457', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246658),
(368151, 'PTHR24412:SF428', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 6', 246658),
(368152, 'PTHR24412', NULL, NULL, NULL, NULL, 'KELCH PROTEIN', 246658),
(368153, 'PTHR24412:SF463', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246658),
(368154, 'PTHR24412:SF187', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 35', 246658),
(368155, 'PTHR24412:SF385', NULL, NULL, NULL, NULL, 'KELCH REPEAT AND BTB DOMAIN-CONTAINING PROTEIN 6', 246658),
(368156, 'PTHR24412:SF462', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 38', 246658),
(368157, 'PTHR24412:SF146', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 41', 246658),
(368158, 'PTHR24412:SF420', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 11', 246658),
(368159, 'PTHR24412:SF466', NULL, NULL, NULL, NULL, 'RING CANAL KELCH PROTEIN', 246658),
(368160, 'PTHR24412:SF304', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 23', 246658),
(368161, 'PTHR24412:SF469', NULL, NULL, NULL, NULL, 'SI:DKEY-260J18.2', 246658),
(368162, 'PTHR24412:SF437', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246658),
(368163, 'PTHR24412:SF192', NULL, NULL, NULL, NULL, 'KELCH REPEAT AND BTB DOMAIN-CONTAINING PROTEIN 2', 246658),
(368164, 'PTHR24412:SF272', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246658),
(368165, 'PTHR24412:SF35', NULL, NULL, NULL, NULL, 'ACTIN-BINDING PROTEIN IPP', 246658);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(368166, 'PTHR24412:SF232', NULL, NULL, NULL, NULL, 'GIGAXONIN', 246658),
(368167, 'PTHR24412:SF155', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 2', 246658),
(368168, 'PTHR24412:SF430', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246658),
(368169, 'PTHR24412:SF74', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 4', 246658),
(368170, 'PTHR24412:SF396', NULL, NULL, NULL, NULL, 'INFLUENZA VIRUS NS1A-BINDING PROTEIN', 246658),
(368171, 'PTHR24412:SF476', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246658),
(368172, 'PTHR24412:SF75', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 1', 246658),
(368173, 'PTHR24412:SF398', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 30', 246658),
(368174, 'PTHR24412:SF475', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 17', 246658),
(368175, 'PTHR24412:SF478', NULL, NULL, NULL, NULL, 'SI:CH211-256E16.3', 246658),
(368176, 'PTHR24412:SF433', NULL, NULL, NULL, NULL, 'KELCH REPEAT AND BTB DOMAIN-CONTAINING PROTEIN 8', 246658),
(368177, 'PTHR24412:SF477', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 246658),
(368178, 'PTHR24412:SF435', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 7', 246658),
(368179, 'PTHR24412:SF479', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 18', 246658),
(368180, 'PTHR46978', NULL, NULL, NULL, NULL, 'ZINC KNUCKLE (CCHC-TYPE) FAMILY PROTEIN', 246659),
(368181, 'PTHR46978:SF2', NULL, NULL, NULL, NULL, 'ZINC KNUCKLE (CCHC-TYPE) FAMILY PROTEIN ISOFORM 1', 246659),
(368182, 'PTHR46978:SF1', NULL, NULL, NULL, NULL, 'ZINC KNUCKLE (CCHC-TYPE) FAMILY PROTEIN', 246659),
(368183, 'PTHR46978:SF4', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 246659),
(368184, 'PTHR46978:SF3', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE GLH-1-LIKE ISOFORM X1', 246659),
(368185, 'PTHR46978:SF5', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 246659),
(368186, 'PTHR46978:SF8', NULL, NULL, NULL, NULL, 'ZINC FINGER CCHC DOMAIN-CONTAINING PROTEIN 7-LIKE', 246659),
(368187, 'PTHR46978:SF9', NULL, NULL, NULL, NULL, 'ZINC FINGER, CCHC-TYPE-RELATED', 246659),
(368188, 'PTHR36159', NULL, NULL, NULL, NULL, 'PROTEIN CBG23766', 246660),
(368189, 'PTHR36159:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG23766', 246660),
(368190, 'PTHR32234:SF0', NULL, NULL, NULL, NULL, 'THIOL:DISULFIDE INTERCHANGE PROTEIN DSBD', 246661),
(368191, 'PTHR32234:SF3', NULL, NULL, NULL, NULL, 'SUPPRESSION OF COPPER SENSITIVITY PROTEIN', 246661),
(368192, 'PTHR32234', NULL, NULL, NULL, NULL, 'THIOL:DISULFIDE INTERCHANGE PROTEIN DSBD', 246661),
(368193, 'PTHR33977', NULL, NULL, NULL, NULL, 'ZINC ION BINDING PROTEIN', 246662),
(368194, 'PTHR33977:SF4', NULL, NULL, NULL, NULL, 'SWIM-TYPE DOMAIN-CONTAINING PROTEIN', 246662),
(368195, 'PTHR33977:SF2', NULL, NULL, NULL, NULL, 'OS09G0309100 PROTEIN', 246662),
(368196, 'PTHR33977:SF1', NULL, NULL, NULL, NULL, 'ZINC ION BINDING PROTEIN', 246662),
(368197, 'PTHR45879:SF1', NULL, NULL, NULL, NULL, 'CYCLIC AMP-RESPONSIVE ELEMENT-BINDING PROTEIN 1', 246663),
(368198, 'PTHR45879', NULL, NULL, NULL, NULL, 'CYCLIC AMP RESPONSE ELEMENT-BINDING PROTEIN B', 246663),
(368199, 'PTHR45879:SF4', NULL, NULL, NULL, NULL, 'CAMP-RESPONSIVE ELEMENT MODULATOR', 246663),
(368200, 'PTHR45879:SF3', NULL, NULL, NULL, NULL, 'CYCLIC AMP RESPONSE ELEMENT-BINDING PROTEIN B', 246663),
(368201, 'PTHR45879:SF2', NULL, NULL, NULL, NULL, 'CYCLIC AMP-DEPENDENT TRANSCRIPTION FACTOR ATF-1', 246663),
(368202, 'PTHR36352:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246664),
(368203, 'PTHR36352', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246664),
(368204, 'PTHR28450', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA GROUP B PROTEIN', 246665),
(368205, 'PTHR28450:SF1', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA GROUP B PROTEIN', 246665),
(368206, 'PTHR11249:SF2', NULL, NULL, NULL, NULL, 'GEO09696P1', 246666),
(368207, 'PTHR11249:SF3', NULL, NULL, NULL, NULL, 'GLIA MATURATION FACTOR BETA', 246666),
(368208, 'PTHR11249', NULL, NULL, NULL, NULL, 'GLIAL FACTOR NATURATION FACTOR', 246666),
(368209, 'PTHR11249:SF4', NULL, NULL, NULL, NULL, 'GLIA MATURATION FACTOR GAMMA', 246666);
INSERT INTO "PUBLIC"."MODEL" VALUES
(368210, 'PTHR28577:SF1', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN P', 246667),
(368211, 'PTHR28577', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN P', 246667),
(368212, 'PTHR45646', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DOA-RELATED', 246668),
(368213, 'PTHR45646:SF6', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN KINASE CLK2', 246668),
(368214, 'PTHR45646:SF7', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE AFC2', 246668),
(368215, 'PTHR45646:SF4', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN KINASE CLK1', 246668),
(368216, 'PTHR45646:SF8', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246668),
(368217, 'PTHR45646:SF19', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE AFC2-LIKE ISOFORM X1', 246668),
(368218, 'PTHR45646:SF2', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246668),
(368219, 'PTHR45646:SF16', NULL, NULL, NULL, NULL, 'KINASE AFC1', 246668),
(368220, 'PTHR45646:SF17', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246668),
(368221, 'PTHR45646:SF1', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN KINASE CLK4', 246668),
(368222, 'PTHR45646:SF11', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DOA', 246668),
(368223, 'PTHR45646:SF12', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE AFC1', 246668),
(368224, 'PTHR45646:SF14', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246668),
(368225, 'PTHR45646:SF10', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN KINASE CLK3', 246668),
(368226, 'PTHR45637:SF19', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE D6PKL3', 246669),
(368227, 'PTHR45637:SF18', NULL, NULL, NULL, NULL, 'OS05G0237400 PROTEIN', 246669),
(368228, 'PTHR45637:SF12', NULL, NULL, NULL, NULL, 'PROTEIN KINASE PINOID 2', 246669),
(368229, 'PTHR45637:SF56', NULL, NULL, NULL, NULL, 'PROTEIN KINASE', 246669),
(368230, 'PTHR45637:SF54', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE KIPK-LIKE', 246669),
(368231, 'PTHR45637:SF10', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 246669),
(368232, 'PTHR45637:SF59', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE D6PK-LIKE', 246669),
(368233, 'PTHR45637:SF57', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE WAG2', 246669),
(368234, 'PTHR45637:SF14', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246669),
(368235, 'PTHR45637:SF62', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246669),
(368236, 'PTHR45637:SF60', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE D6PKL1', 246669),
(368237, 'PTHR45637:SF61', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246669),
(368238, 'PTHR45637:SF5', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 246669),
(368239, 'PTHR45637:SF4', NULL, NULL, NULL, NULL, 'OS03G0642300 PROTEIN', 246669),
(368240, 'PTHR45637:SF3', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE UCNL', 246669),
(368241, 'PTHR45637:SF2', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE WAG1', 246669),
(368242, 'PTHR45637:SF9', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE AGC1-5', 246669),
(368243, 'PTHR45637:SF8', NULL, NULL, NULL, NULL, 'AGC (CAMP-DEPENDENT, CGMP-DEPENDENT AND PROTEIN KINASE C) KINASE FAMILY PROTEIN-RELATED', 246669),
(368244, 'PTHR45637:SF6', NULL, NULL, NULL, NULL, 'PROTEIN KINASE PINOID', 246669),
(368245, 'PTHR45637:SF44', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE RHS3', 246669),
(368246, 'PTHR45637:SF88', NULL, NULL, NULL, NULL, 'OS02G0654300 PROTEIN', 246669),
(368247, 'PTHR45637:SF89', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE D6PK-LIKE ISOFORM X1', 246669),
(368248, 'PTHR45637:SF86', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE KIPK', 246669),
(368249, 'PTHR45637:SF42', NULL, NULL, NULL, NULL, 'OS11G0150700 PROTEIN', 246669),
(368250, 'PTHR45637:SF87', NULL, NULL, NULL, NULL, 'SERINE/THREONINE KINASE FAMILY PROTEIN', 246669),
(368251, 'PTHR45637:SF43', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE AGC1-7', 246669);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(368252, 'PTHR45637:SF48', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE KIPK2', 246669),
(368253, 'PTHR45637:SF91', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PPK22', 246669),
(368254, 'PTHR45637:SF92', NULL, NULL, NULL, NULL, 'OS09G0258500 PROTEIN', 246669),
(368255, 'PTHR45637:SF90', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246669),
(368256, 'PTHR45637:SF51', NULL, NULL, NULL, NULL, 'OS08G0504800 PROTEIN', 246669),
(368257, 'PTHR45637:SF52', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE D6PKL1-LIKE', 246669),
(368258, 'PTHR45637', NULL, NULL, NULL, NULL, 'FLIPPASE KINASE 1-RELATED', 246669),
(368259, 'PTHR45637:SF33', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-KINASE OXI1-LIKE PROTEIN', 246669),
(368260, 'PTHR45637:SF77', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246669),
(368261, 'PTHR45637:SF78', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246669),
(368262, 'PTHR45637:SF34', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE KIPK-LIKE', 246669),
(368263, 'PTHR45637:SF31', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE UCN', 246669),
(368264, 'PTHR45637:SF76', NULL, NULL, NULL, NULL, 'RHO-ASSOCIATED PROTEIN KINASE 1/2-RELATED', 246669),
(368265, 'PTHR45637:SF32', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE D6PK', 246669),
(368266, 'PTHR45637:SF38', NULL, NULL, NULL, NULL, 'PROTEIN KINASE G11A', 246669),
(368267, 'PTHR45637:SF79', NULL, NULL, NULL, NULL, 'OS09G0478500 PROTEIN', 246669),
(368268, 'PTHR45637:SF81', NULL, NULL, NULL, NULL, 'NONPHOTOTROPIC HYPOCOTYL PROTEIN', 246669),
(368269, 'PTHR45637:SF40', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE KIPK1', 246669),
(368270, 'PTHR45637:SF66', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246669),
(368271, 'PTHR45637:SF22', NULL, NULL, NULL, NULL, 'FLIPPASE KINASE 1-RELATED', 246669),
(368272, 'PTHR45637:SF20', NULL, NULL, NULL, NULL, 'PHOTOTROPIN-1', 246669),
(368273, 'PTHR45637:SF21', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246669),
(368274, 'PTHR45637:SF65', NULL, NULL, NULL, NULL, 'TELOKIN/MYOSIN LIGHT CHAIN KINASE-RELATED', 246669),
(368275, 'PTHR45637:SF24', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE AGC1-5', 246669),
(368276, 'PTHR45637:SF68', NULL, NULL, NULL, NULL, 'PHOTOTROPIN 2B', 246669),
(368277, 'PTHR45637:SF25', NULL, NULL, NULL, NULL, 'OS08G0491200 PROTEIN', 246669),
(368278, 'PTHR45637:SF70', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE D6PKL2', 246669),
(368279, 'PTHR45637:SF73', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246669),
(368280, 'PTHR45637:SF30', NULL, NULL, NULL, NULL, 'OS02G0603000 PROTEIN', 246669),
(368281, 'PTHR45637:SF71', NULL, NULL, NULL, NULL, 'PHOTOTROPIN 2C', 246669),
(368282, 'PTHR45637:SF72', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246669),
(368283, 'PTHR22993:SF10', NULL, NULL, NULL, NULL, 'ENDONUCLEASE 8-LIKE 3', 246670),
(368284, 'PTHR22993:SF27', NULL, NULL, NULL, NULL, 'ENDONUCLEASE 8-LIKE 1', 246670),
(368285, 'PTHR22993', NULL, NULL, NULL, NULL, 'FORMAMIDOPYRIMIDINE-DNA GLYCOSYLASE', 246670),
(368286, 'PTHR22993:SF28', NULL, NULL, NULL, NULL, 'OS08G0304900 PROTEIN', 246670),
(368287, 'PTHR22993:SF29', NULL, NULL, NULL, NULL, 'ENDONUCLEASE 8-LIKE 2', 246670),
(368288, 'PTHR22993:SF9', NULL, NULL, NULL, NULL, 'FORMAMIDOPYRIMIDINE-DNA GLYCOSYLASE', 246670),
(368289, 'PTHR42916', NULL, NULL, NULL, NULL, '2-SUCCINYL-5-ENOLPYRUVYL-6-HYDROXY-3-CYCLOHEXENE-1-CARBOXYLATE SYNTHASE', 246671),
(368290, 'PTHR42916:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PHYLLO, CHLOROPLASTIC', 246671),
(368291, 'PTHR11817:SF70', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368292, 'PTHR11817:SF93', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368293, 'PTHR11817:SF91', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368294, 'PTHR11817:SF31', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE PKLR', 246672),
(368295, 'PTHR11817:SF72', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(368296, 'PTHR11817:SF95', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368297, 'PTHR11817:SF34', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368298, 'PTHR11817:SF78', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368299, 'PTHR11817', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368300, 'PTHR11817:SF76', NULL, NULL, NULL, NULL, 'PLASTIDIAL PYRUVATE KINASE 4, CHLOROPLASTIC', 246672),
(368301, 'PTHR11817:SF98', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368302, 'PTHR11817:SF99', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368303, 'PTHR11817:SF2', NULL, NULL, NULL, NULL, 'PLASTIDIAL PYRUVATE KINASE 2', 246672),
(368304, 'PTHR11817:SF3', NULL, NULL, NULL, NULL, 'AT14039P-RELATED', 246672),
(368305, 'PTHR11817:SF120', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368306, 'PTHR11817:SF121', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368307, 'PTHR11817:SF4', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368308, 'PTHR11817:SF122', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368309, 'PTHR11817:SF101', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE PKM', 246672),
(368310, 'PTHR11817:SF123', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368311, 'PTHR11817:SF124', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368312, 'PTHR11817:SF102', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368313, 'PTHR11817:SF125', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE II', 246672),
(368314, 'PTHR11817:SF104', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368315, 'PTHR11817:SF126', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368316, 'PTHR11817:SF105', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368317, 'PTHR11817:SF107', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368318, 'PTHR11817:SF5', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE-RELATED', 246672),
(368319, 'PTHR11817:SF82', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368320, 'PTHR11817:SF80', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368321, 'PTHR11817:SF85', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368322, 'PTHR11817:SF63', NULL, NULL, NULL, NULL, 'PLASTIDIAL PYRUVATE KINASE 3, CHLOROPLASTIC', 246672),
(368323, 'PTHR11817:SF40', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE 1', 246672),
(368324, 'PTHR11817:SF84', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368325, 'PTHR11817:SF89', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368326, 'PTHR11817:SF67', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368327, 'PTHR11817:SF21', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368328, 'PTHR11817:SF88', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368329, 'PTHR11817:SF14', NULL, NULL, NULL, NULL, 'PLASTIDIAL PYRUVATE KINASE 1, CHLOROPLASTIC', 246672),
(368330, 'PTHR11817:SF15', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE PKM', 246672),
(368331, 'PTHR11817:SF111', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368332, 'PTHR11817:SF112', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368333, 'PTHR11817:SF113', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368334, 'PTHR11817:SF114', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368335, 'PTHR11817:SF115', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368336, 'PTHR11817:SF116', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368337, 'PTHR11817:SF118', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368338, 'PTHR11817:SF119', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', 246672),
(368339, 'PTHR41391:SF1', NULL, NULL, NULL, NULL, 'RESTRICTION OF TELOMERE CAPPING PROTEIN 4', 246673),
(368340, 'PTHR41391', NULL, NULL, NULL, NULL, 'RESTRICTION OF TELOMERE CAPPING PROTEIN 4', 246673),
(368341, 'PTHR14728', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 246674),
(368342, 'PTHR14728:SF2', NULL, NULL, NULL, NULL, 'PROTEIN AURORA BOREALIS', 246674),
(368343, 'PTHR28359:SF1', NULL, NULL, NULL, NULL, 'ASHWIN', 246675),
(368344, 'PTHR28359', NULL, NULL, NULL, NULL, 'ASHWIN', 246675),
(368345, 'PTHR14534', NULL, NULL, NULL, NULL, 'VACUOLAR IMPORT AND DEGRADATION PROTEIN 24', 246676);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(368346, 'PTHR14534:SF3', NULL, NULL, NULL, NULL, 'VACUOLAR IMPORT AND DEGRADATION PROTEIN 24', 246676),
(368347, 'PTHR46032:SF7', NULL, NULL, NULL, NULL, 'RIKEN CDNA 6430550D23 GENE', 246677),
(368348, 'PTHR46032:SF6', NULL, NULL, NULL, NULL, 'CMP-N-ACETYLNEURAMINATE-BETA-GALACTOSAMIDE-ALPHA-2,3-SIALYLTRANSFERASE 1', 246677),
(368349, 'PTHR46032', NULL, NULL, NULL, NULL, 'ALPHA-2,3-SIALYLTRANSFERASE ST3GAL I ISOFORM X1', 246677),
(368350, 'PTHR46032:SF1', NULL, NULL, NULL, NULL, '', 246677),
(368351, 'PTHR46032:SF2', NULL, NULL, NULL, NULL, 'GAL BETA 1,3-GALNAC ALPHA-2,3-SIALYL TRANSFERASE-RELATED', 246677),
(368352, 'PTHR46032:SF5', NULL, NULL, NULL, NULL, 'ST3 BETA-GALACTOSIDE ALPHA-2,3-SIALYLTRANSFERASE 8', 246677),
(368353, 'PTHR46032:SF4', NULL, NULL, NULL, NULL, 'CMP-N-ACETYLNEURAMINATE-BETA-GALACTOSAMIDE-ALPHA-2,3-SIALYLTRANSFERASE 2', 246677),
(368354, 'PTHR36955', NULL, NULL, NULL, NULL, 'SECRETED NEMATODE CLADE V PROTEIN GENE FAMILY', 246678),
(368355, 'PTHR36955:SF1', NULL, NULL, NULL, NULL, 'SECRETED NEMATODE CLADE V PROTEIN GENE FAMILY', 246678),
(368356, 'PTHR43279:SF1', NULL, NULL, NULL, NULL, 'CATECHOL-2,3-DIOXYGENASE', 246679),
(368357, 'PTHR43279', NULL, NULL, NULL, NULL, 'CATECHOL-2,3-DIOXYGENASE', 246679),
(368358, 'PTHR38035:SF1', NULL, NULL, NULL, NULL, 'ANCILLARY SECYEG TRANSLOCON SUBUNIT', 246680),
(368359, 'PTHR38035', NULL, NULL, NULL, NULL, 'UPF0070 PROTEIN YFGM', 246680),
(368360, 'PTHR39953', NULL, NULL, NULL, NULL, 'RE54151P', 246681),
(368361, 'PTHR39953:SF1', NULL, NULL, NULL, NULL, 'RE54151P', 246681),
(368362, 'PTHR12934:SF13', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L18E/L15P DOMAIN-CONTAINING PROTEIN', 246682),
(368363, 'PTHR12934:SF14', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L18E/L15P DOMAIN-CONTAINING PROTEIN', 246682),
(368364, 'PTHR12934:SF11', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L15, MITOCHONDRIAL', 246682),
(368365, 'PTHR12934', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L15', 246682),
(368366, 'PTHR33386:SF19', NULL, NULL, NULL, NULL, '', 246683),
(368367, 'PTHR33386:SF29', NULL, NULL, NULL, NULL, 'F21J9.7', 246683),
(368368, 'PTHR33386:SF28', NULL, NULL, NULL, NULL, 'BNAA06G20790D PROTEIN', 246683),
(368369, 'PTHR33386:SF27', NULL, NULL, NULL, NULL, '', 246683),
(368370, 'PTHR33386:SF26', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT PROTEIN', 246683),
(368371, 'PTHR33386:SF13', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246683),
(368372, 'PTHR33386:SF1', NULL, NULL, NULL, NULL, 'F12A21.18', 246683),
(368373, 'PTHR33386:SF24', NULL, NULL, NULL, NULL, '', 246683),
(368374, 'PTHR33386:SF12', NULL, NULL, NULL, NULL, '', 246683),
(368375, 'PTHR33386:SF23', NULL, NULL, NULL, NULL, '', 246683),
(368376, 'PTHR33386:SF22', NULL, NULL, NULL, NULL, '', 246683),
(368377, 'PTHR33386:SF11', NULL, NULL, NULL, NULL, 'BNAA09G44360D PROTEIN', 246683),
(368378, 'PTHR33386:SF32', NULL, NULL, NULL, NULL, '', 246683),
(368379, 'PTHR33386:SF20', NULL, NULL, NULL, NULL, 'CDP-DIACYLGLYCEROL-GLYCEROL-3-PHOSPHATE 3-PHOSPHATIDYLTRANSFERASE', 246683),
(368380, 'PTHR33386:SF31', NULL, NULL, NULL, NULL, '', 246683),
(368381, 'PTHR33386:SF30', NULL, NULL, NULL, NULL, '', 246683),
(368382, 'PTHR33386', NULL, NULL, NULL, NULL, 'OS02G0740600 PROTEIN', 246683),
(368383, 'PTHR33386:SF5', NULL, NULL, NULL, NULL, 'OS02G0740600 PROTEIN', 246683),
(368384, 'PTHR20882:SF14', NULL, NULL, NULL, NULL, 'CYTOPLASMIC TRNA 2-THIOLATION PROTEIN 2', 246684),
(368385, 'PTHR20882', NULL, NULL, NULL, NULL, 'CYTOPLASMIC TRNA 2-THIOLATION PROTEIN 2', 246684),
(368386, 'PTHR40606', NULL, NULL, NULL, NULL, '', 246685),
(368387, 'PTHR40606:SF1', NULL, NULL, NULL, NULL, 'UPF0339 PROTEIN YEGP', 246685),
(368388, 'PTHR23031', NULL, NULL, NULL, NULL, 'RHOPHILIN', 246686),
(368389, 'PTHR23031:SF6', NULL, NULL, NULL, NULL, 'RHOPHILIN-1', 246686),
(368390, 'PTHR23031:SF15', NULL, NULL, NULL, NULL, 'LD12055P', 246686),
(368391, 'PTHR23031:SF5', NULL, NULL, NULL, NULL, 'RHOPHILIN-2-RELATED', 246686),
(368392, 'PTHR28309:SF1', NULL, NULL, NULL, NULL, 'REQUIRED FOR EXCISION 1-B DOMAIN-CONTAINING PROTEIN', 246687);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(368393, 'PTHR28309', NULL, NULL, NULL, NULL, 'REQUIRED FOR EXCISION 1-B DOMAIN-CONTAINING PROTEIN', 246687),
(368394, 'PTHR46060', NULL, NULL, NULL, NULL, 'MARINER MOS1 TRANSPOSASE-LIKE PROTEIN', 246688),
(368395, 'PTHR46060:SF2', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SETMAR', 246688),
(368396, 'PTHR46060:SF1', NULL, NULL, NULL, NULL, 'PROTEIN GVQW3', 246688),
(368397, 'PTHR27008:SF509', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368398, 'PTHR27008:SF508', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368399, 'PTHR27008:SF507', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 246689),
(368400, 'PTHR27008:SF505', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368401, 'PTHR27008:SF502', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368402, 'PTHR27008:SF501', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 246689),
(368403, 'PTHR27008:SF468', NULL, NULL, NULL, NULL, 'OS02G0615500 PROTEIN', 246689),
(368404, 'PTHR27008:SF467', NULL, NULL, NULL, NULL, 'OS02G0615800 PROTEIN', 246689),
(368405, 'PTHR27008:SF586', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368406, 'PTHR27008:SF465', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT FAMILY PROTEIN, EXPRESSED', 246689),
(368407, 'PTHR27008:SF585', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368408, 'PTHR27008:SF222', NULL, NULL, NULL, NULL, 'OS08G0248100 PROTEIN', 246689),
(368409, 'PTHR27008:SF584', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE', 246689),
(368410, 'PTHR27008:SF221', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368411, 'PTHR27008:SF583', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 246689),
(368412, 'PTHR27008:SF582', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE EFR', 246689),
(368413, 'PTHR27008:SF581', NULL, NULL, NULL, NULL, 'OS06G0585950 PROTEIN', 246689),
(368414, 'PTHR27008:SF580', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368415, 'PTHR27008:SF518', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368416, 'PTHR27008:SF514', NULL, NULL, NULL, NULL, 'OS02G0231700 PROTEIN', 246689),
(368417, 'PTHR27008:SF513', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368418, 'PTHR27008:SF357', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368419, 'PTHR27008:SF478', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368420, 'PTHR27008:SF510', NULL, NULL, NULL, NULL, 'OS09G0423200 PROTEIN', 246689),
(368421, 'PTHR27008:SF477', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368422, 'PTHR27008:SF476', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368423, 'PTHR27008:SF474', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368424, 'PTHR27008:SF198', NULL, NULL, NULL, NULL, 'OS04G0226800 PROTEIN', 246689),
(368425, 'PTHR27008:SF472', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368426, 'PTHR27008:SF196', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368427, 'PTHR27008:SF350', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368428, 'PTHR27008:SF470', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368429, 'PTHR27008:SF42', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 246689),
(368430, 'PTHR27008', NULL, NULL, NULL, NULL, 'OS04G0122200 PROTEIN', 246689),
(368431, 'PTHR27008:SF528', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368432, 'PTHR27008:SF527', NULL, NULL, NULL, NULL, 'OS11G0173432 PROTEIN', 246689),
(368433, 'PTHR27008:SF526', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(368434, 'PTHR27008:SF524', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368435, 'PTHR27008:SF403', NULL, NULL, NULL, NULL, 'OS09G0110100 PROTEIN', 246689),
(368436, 'PTHR27008:SF523', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE FAMILY PROTEIN', 246689),
(368437, 'PTHR27008:SF402', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368438, 'PTHR27008:SF400', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368439, 'PTHR27008:SF521', NULL, NULL, NULL, NULL, 'OS11G0490200 PROTEIN', 246689),
(368440, 'PTHR27008:SF11', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 246689),
(368441, 'PTHR27008:SF487', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368442, 'PTHR27008:SF486', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE RCH1', 246689),
(368443, 'PTHR27008:SF485', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368444, 'PTHR27008:SF481', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368445, 'PTHR27008:SF480', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368446, 'PTHR27008:SF538', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368447, 'PTHR27008:SF417', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368448, 'PTHR27008:SF537', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368449, 'PTHR27008:SF413', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368450, 'PTHR27008:SF379', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 246689),
(368451, 'PTHR27008:SF533', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE-RELATED', 246689),
(368452, 'PTHR27008:SF499', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368453, 'PTHR27008:SF530', NULL, NULL, NULL, NULL, 'REPEAT PROTEIN KINASE FAMILY PROTEIN, PUTATIVE-RELATED', 246689),
(368454, 'PTHR27008:SF497', NULL, NULL, NULL, NULL, 'RECEPTOR KINASE-LIKE PROTEIN XA21', 246689),
(368455, 'PTHR27008:SF376', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368456, 'PTHR27008:SF254', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368457, 'PTHR27008:SF496', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368458, 'PTHR27008:SF495', NULL, NULL, NULL, NULL, 'OS01G0153000 PROTEIN', 246689),
(368459, 'PTHR27008:SF373', NULL, NULL, NULL, NULL, 'OS06G0586400 PROTEIN', 246689),
(368460, 'PTHR27008:SF252', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN KINASE-LIKE PROTEIN ZAR1', 246689),
(368461, 'PTHR27008:SF494', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368462, 'PTHR27008:SF493', NULL, NULL, NULL, NULL, 'OS06G0667000 PROTEIN', 246689),
(368463, 'PTHR27008:SF490', NULL, NULL, NULL, NULL, 'OS11G0569300 PROTEIN', 246689),
(368464, 'PTHR27008:SF308', NULL, NULL, NULL, NULL, 'OS06G0581500 PROTEIN', 246689),
(368465, 'PTHR27008:SF549', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368466, 'PTHR27008:SF548', NULL, NULL, NULL, NULL, 'OS02G0211800 PROTEIN', 246689),
(368467, 'PTHR27008:SF426', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368468, 'PTHR27008:SF305', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368469, 'PTHR27008:SF547', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368470, 'PTHR27008:SF425', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368471, 'PTHR27008:SF546', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368472, 'PTHR27008:SF545', NULL, NULL, NULL, NULL, 'PROTEIN KINASE, PLANT-TYPE, PUTATIVE-RELATED', 246689),
(368473, 'PTHR27008:SF544', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE FAMILY PROTEIN-RELATED', 246689);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(368474, 'PTHR27008:SF543', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368475, 'PTHR27008:SF542', NULL, NULL, NULL, NULL, 'OS02G0635600 PROTEIN', 246689),
(368476, 'PTHR27008:SF541', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT FAMILY PROTEIN, EXPRESSED', 246689),
(368477, 'PTHR27008:SF540', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368478, 'PTHR27008:SF264', NULL, NULL, NULL, NULL, 'OS10G0375000 PROTEIN', 246689),
(368479, 'PTHR27008:SF384', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368480, 'PTHR27008:SF439', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368481, 'PTHR27008:SF438', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE EFR', 246689),
(368482, 'PTHR27008:SF559', NULL, NULL, NULL, NULL, 'OS04G0122200 PROTEIN', 246689),
(368483, 'PTHR27008:SF558', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368484, 'PTHR27008:SF557', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368485, 'PTHR27008:SF556', NULL, NULL, NULL, NULL, 'OS10G0336300 PROTEIN', 246689),
(368486, 'PTHR27008:SF435', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368487, 'PTHR27008:SF555', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368488, 'PTHR27008:SF554', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368489, 'PTHR27008:SF553', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368490, 'PTHR27008:SF432', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368491, 'PTHR27008:SF398', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368492, 'PTHR27008:SF431', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368493, 'PTHR27008:SF552', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368494, 'PTHR27008:SF551', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368495, 'PTHR27008:SF397', NULL, NULL, NULL, NULL, 'OS01G0523100 PROTEIN', 246689),
(368496, 'PTHR27008:SF550', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINE RECEPTOR 1-LIKE', 246689),
(368497, 'PTHR27008:SF396', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368498, 'PTHR27008:SF393', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT FAMILY PROTEIN', 246689),
(368499, 'PTHR27008:SF449', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368500, 'PTHR27008:SF569', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368501, 'PTHR27008:SF568', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368502, 'PTHR27008:SF567', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE FAMILY PROTEIN', 246689),
(368503, 'PTHR27008:SF446', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368504, 'PTHR27008:SF445', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368505, 'PTHR27008:SF566', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE EFR', 246689),
(368506, 'PTHR27008:SF169', NULL, NULL, NULL, NULL, 'OS01G0152000 PROTEIN', 246689),
(368507, 'PTHR27008:SF565', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE FAMILY PROTEIN-RELATED', 246689),
(368508, 'PTHR27008:SF564', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368509, 'PTHR27008:SF201', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368510, 'PTHR27008:SF443', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368511, 'PTHR27008:SF563', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368512, 'PTHR27008:SF562', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368513, 'PTHR27008:SF561', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE, STRIATED MUSCLE-SPECIFIC-RELATED', 246689);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(368514, 'PTHR27008:SF440', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368515, 'PTHR27008:SF560', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368516, 'PTHR27008:SF285', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368517, 'PTHR27008:SF284', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368518, 'PTHR27008:SF161', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368519, 'PTHR27008:SF281', NULL, NULL, NULL, NULL, 'OS06G0186100 PROTEIN', 246689),
(368520, 'PTHR27008:SF459', NULL, NULL, NULL, NULL, 'RECEPTOR-KINASE', 246689),
(368521, 'PTHR27008:SF458', NULL, NULL, NULL, NULL, 'OS04G0227200 PROTEIN', 246689),
(368522, 'PTHR27008:SF216', NULL, NULL, NULL, NULL, 'OS07G0121200 PROTEIN', 246689),
(368523, 'PTHR27008:SF337', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368524, 'PTHR27008:SF579', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE FAMILY PROTEIN', 246689),
(368525, 'PTHR27008:SF578', NULL, NULL, NULL, NULL, 'SERINE-THREONINE PROTEIN KINASE PLANT-TYPE', 246689),
(368526, 'PTHR27008:SF577', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368527, 'PTHR27008:SF456', NULL, NULL, NULL, NULL, 'OS10G0337400 PROTEIN', 246689),
(368528, 'PTHR27008:SF576', NULL, NULL, NULL, NULL, 'BNAC06G43210D PROTEIN', 246689),
(368529, 'PTHR27008:SF575', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE EFR', 246689),
(368530, 'PTHR27008:SF332', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368531, 'PTHR27008:SF574', NULL, NULL, NULL, NULL, 'RHO-ASSOCIATED PROTEIN KINASE 1/2-RELATED', 246689),
(368532, 'PTHR27008:SF573', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368533, 'PTHR27008:SF572', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368534, 'PTHR27008:SF451', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE EFR ISOFORM X1', 246689),
(368535, 'PTHR27008:SF571', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368536, 'PTHR27008:SF570', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246689),
(368537, 'PTHR10429', NULL, NULL, NULL, NULL, 'DNA-3-METHYLADENINE GLYCOSYLASE', 246690),
(368538, 'PTHR10429:SF0', NULL, NULL, NULL, NULL, 'DNA-3-METHYLADENINE GLYCOSYLASE', 246690),
(368539, 'PTHR19858', NULL, NULL, NULL, NULL, 'WD40 REPEAT PROTEIN', 246691),
(368540, 'PTHR19858:SF0', NULL, NULL, NULL, NULL, 'PERIODIC TRYPTOPHAN PROTEIN 2 HOMOLOG', 246691),
(368541, 'PTHR12198:SF9', NULL, NULL, NULL, NULL, 'PROSPERO HOMEOBOX 2', 246692),
(368542, 'PTHR12198:SF6', NULL, NULL, NULL, NULL, 'PROSPERO HOMEOBOX PROTEIN 1', 246692),
(368543, 'PTHR12198:SF5', NULL, NULL, NULL, NULL, 'PROSPERO HOMEOBOX PROTEIN 2', 246692),
(368544, 'PTHR12198:SF11', NULL, NULL, NULL, NULL, 'PROSPERO HOMEOBOX 3', 246692),
(368545, 'PTHR12198:SF0', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN PROSPERO', 246692),
(368546, 'PTHR12198', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN PROSPERO/PROX-1/CEH-26', 246692),
(368547, 'PTHR12198:SF10', NULL, NULL, NULL, NULL, 'PROSPERO HOMEOBOX 1A', 246692),
(368548, 'PTHR32494:SF20', NULL, NULL, NULL, NULL, 'SYNTHASE, PUTATIVE-RELATED', 246693),
(368549, 'PTHR32494:SF5', NULL, NULL, NULL, NULL, 'ALLANTOATE AMIDOHYDROLASE', 246693),
(368550, 'PTHR32494', NULL, NULL, NULL, NULL, 'ALLANTOATE DEIMINASE-RELATED', 246693),
(368551, 'PTHR32494:SF19', NULL, NULL, NULL, NULL, 'ALLANTOATE DEIMINASE-RELATED', 246693),
(368552, 'PTHR10551:SF30', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE', 246694),
(368553, 'PTHR10551:SF31', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE', 246694),
(368554, 'PTHR10551:SF1', NULL, NULL, NULL, NULL, 'FASCIN-3', 246694),
(368555, 'PTHR10551:SF28', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE', 246694),
(368556, 'PTHR10551:SF36', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE', 246694);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(368557, 'PTHR10551:SF14', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE', 246694),
(368558, 'PTHR10551:SF37', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE', 246694),
(368559, 'PTHR10551:SF23', NULL, NULL, NULL, NULL, 'FASCIN', 246694),
(368560, 'PTHR10551:SF13', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE', 246694),
(368561, 'PTHR10551:SF24', NULL, NULL, NULL, NULL, 'FASCIN-2', 246694),
(368562, 'PTHR10551:SF29', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE', 246694),
(368563, 'PTHR10551', NULL, NULL, NULL, NULL, 'FASCIN', 246694),
(368564, 'PTHR10551:SF9', NULL, NULL, NULL, NULL, 'PROTEIN SINGED', 246694),
(368565, 'PTHR31155:SF26', NULL, NULL, NULL, NULL, 'ACYL-[ACYL-CARRIER-PROTEIN] DESATURASE', 246695),
(368566, 'PTHR31155:SF27', NULL, NULL, NULL, NULL, 'STEAROYL-[ACYL-CARRIER-PROTEIN] 9-DESATURASE 5, CHLOROPLASTIC', 246695),
(368567, 'PTHR31155:SF28', NULL, NULL, NULL, NULL, 'ACYL-[ACYL-CARRIER-PROTEIN] DESATURASE', 246695),
(368568, 'PTHR31155:SF29', NULL, NULL, NULL, NULL, 'STEAROYL-[ACYL-CARRIER-PROTEIN] 9-DESATURASE 7 CHLOROPLASTIC', 246695),
(368569, 'PTHR31155:SF22', NULL, NULL, NULL, NULL, 'ACYL-[ACYL-CARRIER-PROTEIN] DESATURASE 4, CHLOROPLASTIC', 246695),
(368570, 'PTHR31155:SF23', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 246695),
(368571, 'PTHR31155:SF24', NULL, NULL, NULL, NULL, 'ACYL-[ACYL-CARRIER-PROTEIN] DESATURASE', 246695),
(368572, 'PTHR31155:SF25', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 246695),
(368573, 'PTHR31155:SF40', NULL, NULL, NULL, NULL, 'ACYL-[ACYL-CARRIER-PROTEIN] DESATURASE 7, CHLOROPLASTIC', 246695),
(368574, 'PTHR31155:SF41', NULL, NULL, NULL, NULL, 'CHLOROPLAST,PUTATIVE,EXPRESSED-RELATED', 246695),
(368575, 'PTHR31155:SF20', NULL, NULL, NULL, NULL, 'STEAROYL-[ACYL-CARRIER-PROTEIN] 9-DESATURASE 1, CHLOROPLASTIC', 246695),
(368576, 'PTHR31155:SF42', NULL, NULL, NULL, NULL, 'STEAROYL-ACYL-CARRIER-PROTEIN DESATURASE8', 246695),
(368577, 'PTHR31155:SF37', NULL, NULL, NULL, NULL, 'ACYL-[ACYL-CARRIER-PROTEIN] DESATURASE', 246695),
(368578, 'PTHR31155:SF15', NULL, NULL, NULL, NULL, 'ACYL-[ACYL-CARRIER-PROTEIN] DESATURASE 6, CHLOROPLASTIC', 246695),
(368579, 'PTHR31155:SF18', NULL, NULL, NULL, NULL, 'STEAROYL-[ACYL-CARRIER-PROTEIN] 9-DESATURASE 3, CHLOROPLASTIC', 246695),
(368580, 'PTHR31155:SF11', NULL, NULL, NULL, NULL, 'STEAROYL-[ACYL-CARRIER-PROTEIN] 9-DESATURASE 5, CHLOROPLASTIC', 246695),
(368581, 'PTHR31155:SF34', NULL, NULL, NULL, NULL, 'ACYL-[ACYL-CARRIER-PROTEIN] DESATURASE', 246695),
(368582, 'PTHR31155:SF35', NULL, NULL, NULL, NULL, 'ACYL-[ACYL-CARRIER-PROTEIN] DESATURASE', 246695),
(368583, 'PTHR31155:SF36', NULL, NULL, NULL, NULL, '', 246695),
(368584, 'PTHR31155:SF14', NULL, NULL, NULL, NULL, 'STEAROYL-ACYL-CARRIER-PROTEIN DESATURASE7', 246695),
(368585, 'PTHR31155:SF9', NULL, NULL, NULL, NULL, 'STEAROYL-[ACYL-CARRIER-PROTEIN] 9-DESATURASE 7, CHLOROPLASTIC', 246695),
(368586, 'PTHR31155:SF8', NULL, NULL, NULL, NULL, 'ACYL-[ACYL-CARRIER-PROTEIN] DESATURASE 3, CHLOROPLASTIC', 246695),
(368587, 'PTHR31155:SF30', NULL, NULL, NULL, NULL, 'STEAROYL-[ACYL-CARRIER-PROTEIN] 9-DESATURASE 2, CHLOROPLASTIC-RELATED', 246695),
(368588, 'PTHR31155:SF31', NULL, NULL, NULL, NULL, 'STEAROYL-[ACYL-CARRIER-PROTEIN] 9-DESATURASE 6, CHLOROPLASTIC', 246695),
(368589, 'PTHR31155', NULL, NULL, NULL, NULL, 'ACYL- ACYL-CARRIER-PROTEIN  DESATURASE-RELATED', 246695),
(368590, 'PTHR31155:SF19', NULL, NULL, NULL, NULL, 'STEAROYL-[ACYL-CARRIER-PROTEIN] 9-DESATURASE, CHLOROPLASTIC', 246695),
(368591, 'PTHR34185', NULL, NULL, NULL, NULL, 'DIADENYLATE CYCLASE', 246696),
(368592, 'PTHR34185:SF1', NULL, NULL, NULL, NULL, 'CYCLIC DI-AMP SYNTHASE CDAA', 246696),
(368593, 'PTHR34185:SF3', NULL, NULL, NULL, NULL, 'DNA INTEGRITY SCANNING PROTEIN DISA', 246696),
(368594, 'PTHR34185:SF2', NULL, NULL, NULL, NULL, 'CYCLIC DI-AMP SYNTHASE CDAS', 246696),
(368595, 'PTHR15054:SF3', NULL, NULL, NULL, NULL, 'SARCOPLASMIC RETICULUM HISTIDINE-RICH CALCIUM-BINDING PROTEIN', 246697),
(368596, 'PTHR15054', NULL, NULL, NULL, NULL, 'HISTIDINE-RICH CALCIUM-BINDING PROTEIN-RELATED', 246697);
INSERT INTO "PUBLIC"."MODEL" VALUES
(368597, 'PTHR10640:SF8', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL METHYLTHIORIBULOSE-1-PHOSPHATE DEHYDRATASE/ENOLASE-PHOSPHATASE E1-RELATED', 246698),
(368598, 'PTHR10640:SF9', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL METHYLTHIORIBULOSE-1-PHOSPHATE DEHYDRATASE/ENOLASE-PHOSPHATASE E1 2-RELATED', 246698),
(368599, 'PTHR10640', NULL, NULL, NULL, NULL, 'METHYLTHIORIBULOSE-1-PHOSPHATE DEHYDRATASE', 246698),
(368600, 'PTHR10640:SF10', NULL, NULL, NULL, NULL, 'METHYLTHIORIBULOSE-1-PHOSPHATE DEHYDRATASE-LIKE PROTEIN', 246698),
(368601, 'PTHR10640:SF7', NULL, NULL, NULL, NULL, 'METHYLTHIORIBULOSE-1-PHOSPHATE DEHYDRATASE', 246698),
(368602, 'PTHR45696:SF19', NULL, NULL, NULL, NULL, 'BNAANNG17900D PROTEIN', 246699),
(368603, 'PTHR45696', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P1', 246699),
(368604, 'PTHR45696:SF6', NULL, NULL, NULL, NULL, 'ACIDIC RIBOSOMAL PROTEIN P2, PUTATIVE-RELATED', 246699),
(368605, 'PTHR45696:SF35', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P1-LIKE', 246699),
(368606, 'PTHR45696:SF23', NULL, NULL, NULL, NULL, 'BNAA09G51520D PROTEIN', 246699),
(368607, 'PTHR45696:SF34', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN FAMILY', 246699),
(368608, 'PTHR45696:SF9', NULL, NULL, NULL, NULL, '', 246699),
(368609, 'PTHR45696:SF33', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P1-BETA', 246699),
(368610, 'PTHR45696:SF11', NULL, NULL, NULL, NULL, '', 246699),
(368611, 'PTHR45696:SF32', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P1', 246699),
(368612, 'PTHR45696:SF10', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P1', 246699),
(368613, 'PTHR45696:SF39', NULL, NULL, NULL, NULL, 'BNAC05G00800D PROTEIN', 246699),
(368614, 'PTHR45696:SF28', NULL, NULL, NULL, NULL, '', 246699),
(368615, 'PTHR45696:SF38', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P1', 246699),
(368616, 'PTHR45696:SF37', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P1-LIKE', 246699),
(368617, 'PTHR45696:SF36', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P1-LIKE', 246699),
(368618, 'PTHR45696:SF25', NULL, NULL, NULL, NULL, 'ACIDIC RIBOSOMAL PROTEIN P1A', 246699),
(368619, 'PTHR45696:SF42', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P1-1-RELATED', 246699),
(368620, 'PTHR45696:SF41', NULL, NULL, NULL, NULL, '', 246699),
(368621, 'PTHR45696:SF40', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN', 246699),
(368622, 'PTHR36474:SF1', NULL, NULL, NULL, NULL, 'PROTEIN LIAT1', 246700),
(368623, 'PTHR36474', NULL, NULL, NULL, NULL, 'PROTEIN LIAT1', 246700),
(368624, 'PTHR39201', NULL, NULL, NULL, NULL, 'EXPORTED PROTEIN-RELATED', 246701),
(368625, 'PTHR39201:SF1', NULL, NULL, NULL, NULL, 'FLAVODOXIN-LIKE DOMAIN-CONTAINING PROTEIN', 246701),
(368626, 'PTHR21472:SF16', NULL, NULL, NULL, NULL, 'SI:DKEY-85K7.11', 246702),
(368627, 'PTHR21472:SF17', NULL, NULL, NULL, NULL, '', 246702),
(368628, 'PTHR21472:SF18', NULL, NULL, NULL, NULL, 'ENDONUCLEASE_NS DOMAIN-CONTAINING PROTEIN', 246702),
(368629, 'PTHR21472:SF19', NULL, NULL, NULL, NULL, 'ZGC:172339', 246702),
(368630, 'PTHR21472', NULL, NULL, NULL, NULL, 'ENDONUCLEASE DOMAIN-CONTAINING 1 PROTEIN ENDOD1', 246702),
(368631, 'PTHR21472:SF7', NULL, NULL, NULL, NULL, 'ENDONUCLEASE_NS DOMAIN-CONTAINING PROTEIN', 246702),
(368632, 'PTHR21472:SF8', NULL, NULL, NULL, NULL, 'ENDONUCLEASE DOMAIN-CONTAINING 1 PROTEIN', 246702),
(368633, 'PTHR21472:SF23', NULL, NULL, NULL, NULL, 'INO80 COMPLEX SUBUNIT E', 246702),
(368634, 'PTHR21472:SF24', NULL, NULL, NULL, NULL, 'SI:DKEY-243K1.3', 246702),
(368635, 'PTHR21472:SF15', NULL, NULL, NULL, NULL, 'SI:CH211-133N4.4-RELATED', 246702),
(368636, 'PTHR21472:SF20', NULL, NULL, NULL, NULL, 'SI:DKEY-85K7.10', 246702),
(368637, 'PTHR21472:SF10', NULL, NULL, NULL, NULL, 'K123 PROTEIN', 246702),
(368638, 'PTHR21472:SF21', NULL, NULL, NULL, NULL, 'NOVEL PROTEIN SIMILAR TO VERTEBRATE ENDONUCLEASE DOMAIN CONTAINING 1 (ENDOD1)', 246702),
(368639, 'PTHR43415', NULL, NULL, NULL, NULL, 'SPERMIDINE N(1)-ACETYLTRANSFERASE', 246703),
(368640, 'PTHR43415:SF5', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE-RELATED', 246703);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(368641, 'PTHR43415:SF4', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 246703),
(368642, 'PTHR43415:SF3', NULL, NULL, NULL, NULL, 'SPERMIDINE N(1)-ACETYLTRANSFERASE', 246703),
(368643, 'PTHR24233:SF3', NULL, NULL, NULL, NULL, 'P2Y PURINOCEPTOR 14', 246704),
(368644, 'PTHR24233:SF11', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN-RELATED', 246704),
(368645, 'PTHR24233:SF4', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 171-RELATED', 246704),
(368646, 'PTHR24233:SF10', NULL, NULL, NULL, NULL, 'P2Y PURINOCEPTOR 13', 246704),
(368647, 'PTHR24233:SF6', NULL, NULL, NULL, NULL, 'PLATELET-ACTIVATING FACTOR RECEPTOR', 246704),
(368648, 'PTHR24233:SF8', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 87', 246704),
(368649, 'PTHR24233:SF9', NULL, NULL, NULL, NULL, '', 246704),
(368650, 'PTHR24233:SF0', NULL, NULL, NULL, NULL, 'P2Y PURINOCEPTOR 12', 246704),
(368651, 'PTHR24233:SF1', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 34-RELATED', 246704),
(368652, 'PTHR24233', NULL, NULL, NULL, NULL, 'P2Y PURINOCEPTOR-RELATED G-PROTEIN COUPLED RECEPTOR', 246704),
(368653, 'PTHR37526:SF1', NULL, NULL, NULL, NULL, 'PROTEIN TUSB', 246705),
(368654, 'PTHR37526', NULL, NULL, NULL, NULL, 'PROTEIN TUSB', 246705),
(368655, 'PTHR32114:SF2', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ABCH.3', 246706),
(368656, 'PTHR32114', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ABCH.3', 246706),
(368657, 'PTHR37176', NULL, NULL, NULL, NULL, 'F10K1.23', 246707),
(368658, 'PTHR37176:SF1', NULL, NULL, NULL, NULL, 'PROTEIN DOUBLE-STRAND BREAK FORMATION', 246707),
(368659, 'PTHR38225:SF4', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 246708),
(368660, 'PTHR38225:SF3', NULL, NULL, NULL, NULL, '', 246708),
(368661, 'PTHR38225', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 246708),
(368662, 'PTHR46885:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ANKUB1', 246709),
(368663, 'PTHR46885', NULL, NULL, NULL, NULL, 'PROTEIN ANKUB1', 246709),
(368664, 'PTHR36776:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246710),
(368665, 'PTHR36776', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246710),
(368666, 'PTHR22168:SF6', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 26-LIKE PROTEIN', 246711),
(368667, 'PTHR22168', NULL, NULL, NULL, NULL, 'TMEM26 PROTEIN', 246711),
(368668, 'PTHR22168:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 26', 246711),
(368669, 'PTHR13322:SF2', NULL, NULL, NULL, NULL, 'INTEGRATOR COMPLEX SUBUNIT 7', 246712),
(368670, 'PTHR13322', NULL, NULL, NULL, NULL, 'C1ORF73 PROTEIN', 246712),
(368671, 'PTHR47758', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS M-RELATED', 246713),
(368672, 'PTHR47758:SF4', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS M', 246713),
(368673, 'PTHR47758:SF1', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS M', 246713),
(368674, 'PTHR47758:SF2', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS M', 246713),
(368675, 'PTHR47758:SF3', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS M', 246713),
(368676, 'PTHR32059:SF0', NULL, NULL, NULL, NULL, 'RAB11-BINDING PROTEIN RELCH', 246714),
(368677, 'PTHR32059:SF1', NULL, NULL, NULL, NULL, 'LISH DOMAIN AND HEAT REPEAT KIAA1468-LIKE PROTEIN', 246714),
(368678, 'PTHR32059', NULL, NULL, NULL, NULL, 'RAB11-BINDING PROTEIN RELCH', 246714),
(368679, 'PTHR15012:SF37', NULL, NULL, NULL, NULL, 'PROTEIN SHROOM1', 246715),
(368680, 'PTHR15012', NULL, NULL, NULL, NULL, 'APICAL PROTEIN/SHROOM-RELATED', 246715),
(368681, 'PTHR15012:SF35', NULL, NULL, NULL, NULL, 'PROTEIN SHROOM4', 246715),
(368682, 'PTHR15012:SF8', NULL, NULL, NULL, NULL, 'PROTEIN SHROOM2', 246715),
(368683, 'PTHR15012:SF33', NULL, NULL, NULL, NULL, 'PROTEIN SHROOM3', 246715),
(368684, 'PTHR15012:SF32', NULL, NULL, NULL, NULL, 'PROTEIN SHROOM', 246715),
(368685, 'PTHR22953', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE RELATED', 246716),
(368686, 'PTHR22953:SF86', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE 10', 246716),
(368687, 'PTHR22953:SF119', NULL, NULL, NULL, NULL, 'PUR_AC_PHOSPH_N DOMAIN-CONTAINING PROTEIN', 246716);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(368688, 'PTHR22953:SF118', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 246716),
(368689, 'PTHR22953:SF138', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 246716),
(368690, 'PTHR22953:SF136', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 246716),
(368691, 'PTHR22953:SF114', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE 25-RELATED', 246716),
(368692, 'PTHR22953:SF113', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 246716),
(368693, 'PTHR22953:SF134', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 246716),
(368694, 'PTHR22953:SF133', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 246716),
(368695, 'PTHR22953:SF111', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 246716),
(368696, 'PTHR22953:SF132', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 246716),
(368697, 'PTHR22953:SF153', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 246716),
(368698, 'PTHR22953:SF131', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 246716),
(368699, 'PTHR22953:SF152', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 246716),
(368700, 'PTHR22953:SF130', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 246716),
(368701, 'PTHR22953:SF151', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 246716),
(368702, 'PTHR22953:SF150', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 246716),
(368703, 'PTHR22953:SF7', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE 22', 246716),
(368704, 'PTHR22953:SF35', NULL, NULL, NULL, NULL, 'FE(3+)-ZN(2+) PURPLE ACID PHOSPHATASE 12', 246716),
(368705, 'PTHR22953:SF13', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 246716),
(368706, 'PTHR22953:SF55', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL PURPLE ACID PHOSPHATASE 26', 246716),
(368707, 'PTHR22953:SF96', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE 15', 246716),
(368708, 'PTHR22953:SF109', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 246716),
(368709, 'PTHR22953:SF108', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 246716),
(368710, 'PTHR22953:SF106', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 246716),
(368711, 'PTHR22953:SF128', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 246716),
(368712, 'PTHR22953:SF127', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE 20-RELATED', 246716),
(368713, 'PTHR22953:SF105', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE 21', 246716),
(368714, 'PTHR22953:SF149', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 246716),
(368715, 'PTHR22953:SF148', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 246716),
(368716, 'PTHR22953:SF104', NULL, NULL, NULL, NULL, 'METALLOPHOS DOMAIN-CONTAINING PROTEIN', 246716),
(368717, 'PTHR22953:SF125', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 246716),
(368718, 'PTHR22953:SF15', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE 13', 246716),
(368719, 'PTHR22953:SF102', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 246716),
(368720, 'PTHR22953:SF146', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 246716),
(368721, 'PTHR22953:SF145', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 246716),
(368722, 'PTHR22953:SF123', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 246716),
(368723, 'PTHR22953:SF144', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 246716),
(368724, 'PTHR22953:SF143', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 246716),
(368725, 'PTHR22953:SF121', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 246716),
(368726, 'PTHR22953:SF120', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE 11-RELATED', 246716),
(368727, 'PTHR22953:SF140', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 246716),
(368728, 'PTHR33352:SF3', NULL, NULL, NULL, NULL, 'SLR1612 PROTEIN', 246717),
(368729, 'PTHR33352', NULL, NULL, NULL, NULL, 'SLR1095 PROTEIN', 246717),
(368730, 'PTHR33352:SF2', NULL, NULL, NULL, NULL, 'SLL0995 PROTEIN', 246717),
(368731, 'PTHR43784:SF3', NULL, NULL, NULL, NULL, 'GDSL FAMILY LIPASE', 246718),
(368732, 'PTHR43784', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G00820)-RELATED', 246718),
(368733, 'PTHR43784:SF2', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G00820)-RELATED', 246718);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(368734, 'PTHR43784:SF1', NULL, NULL, NULL, NULL, 'GDSL LIPASE RV0518', 246718),
(368735, 'PTHR33453:SF28', NULL, NULL, NULL, NULL, 'RRNA N-GLYCOSIDASE', 246719),
(368736, 'PTHR33453:SF27', NULL, NULL, NULL, NULL, 'RRNA N-GLYCOSIDASE', 246719),
(368737, 'PTHR33453:SF38', NULL, NULL, NULL, NULL, 'RRNA N-GLYCOSIDASE', 246719),
(368738, 'PTHR33453:SF37', NULL, NULL, NULL, NULL, 'RRNA N-GLYCOSIDASE', 246719),
(368739, 'PTHR33453:SF9', NULL, NULL, NULL, NULL, 'ALBUMIN B-32', 246719),
(368740, 'PTHR33453:SF25', NULL, NULL, NULL, NULL, 'RRNA N-GLYCOSIDASE', 246719),
(368741, 'PTHR33453:SF13', NULL, NULL, NULL, NULL, 'RRNA N-GLYCOSIDASE', 246719),
(368742, 'PTHR33453:SF34', NULL, NULL, NULL, NULL, 'RRNA N-GLYCOSIDASE', 246719),
(368743, 'PTHR33453:SF11', NULL, NULL, NULL, NULL, 'RRNA N-GLYCOSIDASE', 246719),
(368744, 'PTHR33453:SF21', NULL, NULL, NULL, NULL, 'RRNA N-GLYCOSIDASE', 246719),
(368745, 'PTHR33453:SF10', NULL, NULL, NULL, NULL, 'RRNA N-GLYCOSIDASE', 246719),
(368746, 'PTHR33453:SF43', NULL, NULL, NULL, NULL, 'RRNA N-GLYCOSIDASE', 246719),
(368747, 'PTHR33453:SF42', NULL, NULL, NULL, NULL, 'RRNA N-GLYCOSIDASE', 246719),
(368748, 'PTHR33453:SF31', NULL, NULL, NULL, NULL, 'RRNA N-GLYCOSIDASE', 246719),
(368749, 'PTHR33453:SF41', NULL, NULL, NULL, NULL, 'RRNA N-GLYCOSIDASE', 246719),
(368750, 'PTHR33453:SF40', NULL, NULL, NULL, NULL, 'RRNA N-GLYCOSIDASE', 246719),
(368751, 'PTHR33453:SF3', NULL, NULL, NULL, NULL, 'RRNA N-GLYCOSIDASE', 246719),
(368752, 'PTHR33453:SF8', NULL, NULL, NULL, NULL, 'RRNA N-GLYCOSIDASE', 246719),
(368753, 'PTHR33453', NULL, NULL, NULL, NULL, '', 246719),
(368754, 'PTHR35259:SF1', NULL, NULL, NULL, NULL, 'BOMBESIN RECEPTOR-ACTIVATED PROTEIN C6ORF89', 246720),
(368755, 'PTHR35259:SF2', NULL, NULL, NULL, NULL, '', 246720),
(368756, 'PTHR35259', NULL, NULL, NULL, NULL, 'BOMBESIN RECEPTOR-ACTIVATED PROTEIN C6ORF89', 246720),
(368757, 'PTHR31397', NULL, NULL, NULL, NULL, 'BLOC-1-RELATED COMPLEX SUBUNIT 7 BORSC7', 246721),
(368758, 'PTHR31397:SF1', NULL, NULL, NULL, NULL, 'BLOC-1-RELATED COMPLEX SUBUNIT 7', 246721),
(368759, 'PTHR31397:SF3', NULL, NULL, NULL, NULL, 'BLOC-1-RELATED COMPLEX SUBUNIT 7', 246721),
(368760, 'PTHR31397:SF2', NULL, NULL, NULL, NULL, 'BLOC-1-RELATED COMPLEX SUBUNIT 7', 246721),
(368761, 'PTHR47133', NULL, NULL, NULL, NULL, 'TALIN ROD DOMAIN-CONTAINING PROTEIN 1', 246722),
(368762, 'PTHR47133:SF1', NULL, NULL, NULL, NULL, 'TALIN ROD DOMAIN-CONTAINING PROTEIN 1', 246722),
(368763, 'PTHR47262', NULL, NULL, NULL, NULL, 'OS02G0132600 PROTEIN', 246723),
(368764, 'PTHR47262:SF1', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN MITOCHONDRIAL', 246723),
(368765, 'PTHR47262:SF2', NULL, NULL, NULL, NULL, 'BNAA09G20240D PROTEIN', 246723),
(368766, 'PTHR15347:SF1', NULL, NULL, NULL, NULL, 'SPERM-ASSOCIATED ANTIGEN 5', 246724),
(368767, 'PTHR15347', NULL, NULL, NULL, NULL, 'SPERM-ASSOCIATED ANTIGEN 5', 246724),
(368768, 'PTHR10997:SF53', NULL, NULL, NULL, NULL, 'IMPORTIN BETA-LIKE SAD2 HOMOLOG', 246725),
(368769, 'PTHR10997:SF52', NULL, NULL, NULL, NULL, 'YALI0B18480P', 246725),
(368770, 'PTHR10997:SF63', NULL, NULL, NULL, NULL, 'IMPORTIN-7-LIKE PROTEIN-RELATED', 246725),
(368771, 'PTHR10997:SF7', NULL, NULL, NULL, NULL, 'IMPORTIN-11', 246725),
(368772, 'PTHR10997:SF8', NULL, NULL, NULL, NULL, 'EXPORTIN-2', 246725),
(368773, 'PTHR10997:SF67', NULL, NULL, NULL, NULL, 'IMPORTIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 246725),
(368774, 'PTHR10997:SF26', NULL, NULL, NULL, NULL, 'IMPORTIN-8', 246725),
(368775, 'PTHR10997:SF59', NULL, NULL, NULL, NULL, 'IMPORTIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 246725),
(368776, 'PTHR10997:SF9', NULL, NULL, NULL, NULL, 'IMPORTIN-9', 246725),
(368777, 'PTHR10997:SF69', NULL, NULL, NULL, NULL, 'IMPORTIN-LIKE PROTEIN', 246725),
(368778, 'PTHR10997:SF28', NULL, NULL, NULL, NULL, 'IMPORTIN BETA SMX1', 246725),
(368779, 'PTHR10997:SF27', NULL, NULL, NULL, NULL, 'IMPORTIN-7', 246725),
(368780, 'PTHR10997:SF18', NULL, NULL, NULL, NULL, 'D-IMPORTIN 7/RANBP7', 246725),
(368781, 'PTHR10997:SF29', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 246725);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(368782, 'PTHR10997', NULL, NULL, NULL, NULL, 'IMPORTIN-7, 8, 11', 246725),
(368783, 'PTHR10997:SF60', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 246725),
(368784, 'PTHR10997:SF70', NULL, NULL, NULL, NULL, 'IMPORTIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 246725),
(368785, 'PTHR10997:SF61', NULL, NULL, NULL, NULL, 'OS04G0337201 PROTEIN', 246725),
(368786, 'PTHR42090:SF1', NULL, NULL, NULL, NULL, '', 246726),
(368787, 'PTHR42090', NULL, NULL, NULL, NULL, '', 246726),
(368788, 'PTHR11922', NULL, NULL, NULL, NULL, 'GMP SYNTHASE-RELATED', 246727),
(368789, 'PTHR11922:SF1', NULL, NULL, NULL, NULL, 'ANTHRANILATE PHOSPHORIBOSYLTRANSFERASE', 246727),
(368790, 'PTHR11922:SF2', NULL, NULL, NULL, NULL, 'GMP SYNTHASE [GLUTAMINE-HYDROLYZING]', 246727),
(368791, 'PTHR11922:SF4', NULL, NULL, NULL, NULL, 'GLUTAMINE AMIDOTRANSFERASE', 246727),
(368792, 'PTHR46751:SF1', NULL, NULL, NULL, NULL, 'WAP FOUR-DISULFIDE CORE DOMAIN PROTEIN 6A', 246728),
(368793, 'PTHR46751:SF2', NULL, NULL, NULL, NULL, 'EPPIN', 246728),
(368794, 'PTHR46751:SF3', NULL, NULL, NULL, NULL, 'WAP FOUR-DISULFIDE CORE DOMAIN PROTEIN 6B', 246728),
(368795, 'PTHR46751', NULL, NULL, NULL, NULL, 'EPPIN', 246728),
(368796, 'PTHR24153', NULL, NULL, NULL, NULL, 'ESPIN', 246729),
(368797, 'PTHR24153:SF8', NULL, NULL, NULL, NULL, 'FORKED, ISOFORM F', 246729),
(368798, 'PTHR24153:SF14', NULL, NULL, NULL, NULL, 'ESPIN', 246729),
(368799, 'PTHR24153:SF23', NULL, NULL, NULL, NULL, 'INTRACELLULAR PHOSPHOLIPASE A2', 246729),
(368800, 'PTHR24153:SF0', NULL, NULL, NULL, NULL, 'ESPIN-LIKE PROTEIN', 246729),
(368801, 'PTHR33909:SF1', NULL, NULL, NULL, NULL, 'SEC TRANSLOCON ACCESSORY COMPLEX SUBUNIT YAJC', 246730),
(368802, 'PTHR33909', NULL, NULL, NULL, NULL, 'SEC TRANSLOCON ACCESSORY COMPLEX SUBUNIT YAJC', 246730),
(368803, 'PTHR34360', NULL, NULL, NULL, NULL, 'OS08G0519400 PROTEIN', 246731),
(368804, 'PTHR34360:SF14', NULL, NULL, NULL, NULL, 'BNAA09G41410D PROTEIN', 246731),
(368805, 'PTHR34360:SF15', NULL, NULL, NULL, NULL, 'BNAA04G14370D PROTEIN', 246731),
(368806, 'PTHR34360:SF12', NULL, NULL, NULL, NULL, 'BNAA03G51420D PROTEIN', 246731),
(368807, 'PTHR34360:SF13', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN-RELATED PROTEIN-RELATED', 246731),
(368808, 'PTHR34360:SF16', NULL, NULL, NULL, NULL, '', 246731),
(368809, 'PTHR34360:SF6', NULL, NULL, NULL, NULL, 'OS02G0306550 PROTEIN', 246731),
(368810, 'PTHR34360:SF4', NULL, NULL, NULL, NULL, 'OS09G0497700 PROTEIN', 246731),
(368811, 'PTHR34360:SF2', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN-LIKE PROTEIN', 246731),
(368812, 'PTHR34360:SF10', NULL, NULL, NULL, NULL, 'GOLGIN FAMILY A PROTEIN', 246731),
(368813, 'PTHR34360:SF1', NULL, NULL, NULL, NULL, 'OS08G0519400 PROTEIN', 246731),
(368814, 'PTHR34360:SF11', NULL, NULL, NULL, NULL, 'OS04G0607150 PROTEIN', 246731),
(368815, 'PTHR34360:SF8', NULL, NULL, NULL, NULL, 'TROPOMYOSIN-LIKE', 246731),
(368816, 'PTHR34360:SF7', NULL, NULL, NULL, NULL, '', 246731),
(368817, 'PTHR45694:SF28', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN 1', 246732),
(368818, 'PTHR45694:SF17', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 246732),
(368819, 'PTHR45694:SF27', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-2', 246732),
(368820, 'PTHR45694:SF16', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 246732),
(368821, 'PTHR45694:SF29', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 246732),
(368822, 'PTHR45694:SF18', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-1-RELATED', 246732),
(368823, 'PTHR45694', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN 2', 246732),
(368824, 'PTHR45694:SF5', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN 2', 246732),
(368825, 'PTHR45694:SF3', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 246732),
(368826, 'PTHR45694:SF4', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-C3', 246732),
(368827, 'PTHR45694:SF20', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 246732),
(368828, 'PTHR45694:SF11', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-C6', 246732),
(368829, 'PTHR45694:SF22', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 246732);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(368830, 'PTHR45694:SF13', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-C1', 246732),
(368831, 'PTHR45694:SF12', NULL, NULL, NULL, NULL, 'MONOTHIOL GLUTAREDOXIN-S12, CHLOROPLASTIC', 246732),
(368832, 'PTHR45694:SF26', NULL, NULL, NULL, NULL, 'GRX1P', 246732),
(368833, 'PTHR45694:SF14', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-C2', 246732),
(368834, 'PTHR34454:SF2', NULL, NULL, NULL, NULL, 'TUNICAMYCIN INDUCED PROTEIN', 246733),
(368835, 'PTHR34454:SF3', NULL, NULL, NULL, NULL, 'PEPTIDASE I, PUTATIVE-RELATED', 246733),
(368836, 'PTHR34454', NULL, NULL, NULL, NULL, 'TUNICAMYCIN INDUCED PROTEIN', 246733),
(368837, 'PTHR12669:SF16', NULL, NULL, NULL, NULL, '', 246734),
(368838, 'PTHR12669', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4E-BINDING PROTEIN', 246734),
(368839, 'PTHR12669:SF12', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4E-BINDING PROTEIN', 246734),
(368840, 'PTHR12669:SF15', NULL, NULL, NULL, NULL, 'GRANULITO', 246734),
(368841, 'PTHR12669:SF14', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4E-BINDING PROTEIN 1', 246734),
(368842, 'PTHR12669:SF4', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4E-BINDING PROTEIN 2', 246734),
(368843, 'PTHR12669:SF5', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4E-BINDING PROTEIN 3', 246734),
(368844, 'PTHR31543', NULL, NULL, NULL, NULL, 'DYNEIN REGULATORY COMPLEX SUBUNIT 4', 246735),
(368845, 'PTHR31543:SF0', NULL, NULL, NULL, NULL, 'DYNEIN REGULATORY COMPLEX SUBUNIT 4', 246735),
(368846, 'PTHR31543:SF2', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 246735),
(368847, 'PTHR31543:SF1', NULL, NULL, NULL, NULL, 'GAS DOMAIN-CONTAINING PROTEIN', 246735),
(368848, 'PTHR21338', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOMAL PROTEIN L41', 246736),
(368849, 'PTHR21338:SF0', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L41, MITOCHONDRIAL', 246736),
(368850, 'PTHR45698:SF1', NULL, NULL, NULL, NULL, 'TRACE AMINE-ASSOCIATED RECEPTOR 19N', 246737),
(368851, 'PTHR45698', NULL, NULL, NULL, NULL, 'TRACE AMINE-ASSOCIATED RECEPTOR 19N-RELATED', 246737),
(368852, 'PTHR42801:SF22', NULL, NULL, NULL, NULL, 'PEROXIREDOXIN SLL0755-RELATED', 246738),
(368853, 'PTHR42801:SF23', NULL, NULL, NULL, NULL, 'PEROXIREDOXIN DOT5', 246738),
(368854, 'PTHR42801:SF8', NULL, NULL, NULL, NULL, 'PEROXIREDOXIN RV1608C-RELATED', 246738),
(368855, 'PTHR42801', NULL, NULL, NULL, NULL, 'THIOREDOXIN-DEPENDENT PEROXIDE REDUCTASE', 246738),
(368856, 'PTHR42801:SF5', NULL, NULL, NULL, NULL, 'GROUP 1 TRUNCATED HEMOGLOBIN GLBN', 246738),
(368857, 'PTHR42801:SF4', NULL, NULL, NULL, NULL, 'AHPC/TSA FAMILY PROTEIN-RELATED', 246738),
(368858, 'PTHR42801:SF20', NULL, NULL, NULL, NULL, 'ALKYL HYDROPEROXIDE REDUCTASE E', 246738),
(368859, 'PTHR42801:SF7', NULL, NULL, NULL, NULL, 'SLL1159 PROTEIN', 246738),
(368860, 'PTHR42801:SF21', NULL, NULL, NULL, NULL, 'BCPB PROTEIN', 246738),
(368861, 'PTHR30055:SF119', NULL, NULL, NULL, NULL, 'NALC', 246739),
(368862, 'PTHR30055:SF239', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 246739),
(368863, 'PTHR30055:SF151', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 246739),
(368864, 'PTHR30055:SF195', NULL, NULL, NULL, NULL, 'FATTY ACID METABOLISM REGULATOR PROTEIN', 246739),
(368865, 'PTHR30055:SF153', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REPRESSOR RV3405C', 246739),
(368866, 'PTHR30055:SF230', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN (PROBABLY TETR-FAMILY)-RELATED', 246739),
(368867, 'PTHR30055:SF196', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR RUTR', 246739),
(368868, 'PTHR30055:SF236', NULL, NULL, NULL, NULL, 'SLL1286 PROTEIN', 246739),
(368869, 'PTHR30055:SF158', NULL, NULL, NULL, NULL, 'POSSIBLE TRANSCRIPTIONAL REGULATORY PROTEIN (PROBABLY TETR-FAMILY)', 246739),
(368870, 'PTHR30055:SF235', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 246739),
(368871, 'PTHR30055:SF238', NULL, NULL, NULL, NULL, 'MYCOFACTOCIN BIOSYNTHESIS TRANSCRIPTIONAL REGULATOR MFTR-RELATED', 246739);
INSERT INTO "PUBLIC"."MODEL" VALUES
(368872, 'PTHR30055:SF237', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR MCE3R', 246739),
(368873, 'PTHR30055:SF199', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR YTTP-RELATED', 246739),
(368874, 'PTHR30055:SF232', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, TETR FAMILY', 246739),
(368875, 'PTHR30055:SF231', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN (PROBABLY DEOR-FAMILY)-RELATED', 246739),
(368876, 'PTHR30055:SF234', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR BETI', 246739),
(368877, 'PTHR30055:SF233', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN TETR', 246739),
(368878, 'PTHR30055:SF229', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REPRESSOR RV1474C', 246739),
(368879, 'PTHR30055:SF228', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', 246739),
(368880, 'PTHR30055:SF184', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR ETHR', 246739),
(368881, 'PTHR30055:SF183', NULL, NULL, NULL, NULL, 'NUCLEOID OCCLUSION FACTOR SLMA', 246739),
(368882, 'PTHR30055:SF181', NULL, NULL, NULL, NULL, 'BLR6905 PROTEIN', 246739),
(368883, 'PTHR30055:SF225', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN-RELATED', 246739),
(368884, 'PTHR30055:SF148', NULL, NULL, NULL, NULL, 'TETR-FAMILY TRANSCRIPTIONAL REGULATOR', 246739),
(368885, 'PTHR30055:SF224', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR TETR FAMILY', 246739),
(368886, 'PTHR30055:SF227', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN (PROBABLY TETR-FAMILY)-RELATED', 246739),
(368887, 'PTHR30055:SF226', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR PKSA', 246739),
(368888, 'PTHR30055:SF149', NULL, NULL, NULL, NULL, 'TETR-FAMILY TRANSCRIPTIONAL REGULATOR-RELATED', 246739),
(368889, 'PTHR30055:SF221', NULL, NULL, NULL, NULL, 'MERR FAMILY BACTERIAL REGULATORY PROTEIN-RELATED', 246739),
(368890, 'PTHR30055:SF220', NULL, NULL, NULL, NULL, 'TETR-FAMILY REGULATORY PROTEIN', 246739),
(368891, 'PTHR30055:SF187', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 246739),
(368892, 'PTHR30055:SF146', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL DUAL REGULATOR CECR', 246739),
(368893, 'PTHR30055:SF223', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR UIDR', 246739),
(368894, 'PTHR30055:SF222', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN-RELATED', 246739),
(368895, 'PTHR30055:SF219', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 246739),
(368896, 'PTHR30055:SF175', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REPRESSOR KSTR2', 246739),
(368897, 'PTHR30055:SF174', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN (PROBABLY TETR-FAMILY)-RELATED', 246739),
(368898, 'PTHR30055:SF214', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REPRESSOR COMR', 246739),
(368899, 'PTHR30055', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR RUTR', 246739),
(368900, 'PTHR30055:SF212', NULL, NULL, NULL, NULL, 'TETR-FAMILY FAMILY TRANSCRIPTIONAL REGULATOR', 246739),
(368901, 'PTHR30055:SF211', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, TETR FAMILY-RELATED', 246739),
(368902, 'PTHR30055:SF178', NULL, NULL, NULL, NULL, 'POSSIBLE TRANSCRIPTIONAL REGULATORY PROTEIN', 246739),
(368903, 'PTHR30055:SF207', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REPRESSOR FATR', 246739),
(368904, 'PTHR30055:SF209', NULL, NULL, NULL, NULL, 'POSSIBLE TRANSCRIPTIONAL REGULATORY PROTEIN (PROBABLY TETR-FAMILY)', 246739),
(368905, 'PTHR30055:SF164', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 246739),
(368906, 'PTHR30055:SF241', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 246739),
(368907, 'PTHR30055:SF240', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR ACRR', 246739),
(368908, 'PTHR30055:SF160', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN (PROBABLY ASNC-FAMILY)-RELATED', 246739),
(368909, 'PTHR30055:SF243', NULL, NULL, NULL, NULL, 'TETR-FAMILY TRANSCRIPTIONAL REGULATOR-RELATED', 246739),
(368910, 'PTHR30055:SF242', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REPRESSOR KSTR', 246739);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(368911, 'PTHR30055:SF201', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 246739),
(368912, 'PTHR30055:SF200', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REPRESSOR BDCR', 246739),
(368913, 'PTHR39468:SF1', NULL, NULL, NULL, NULL, 'MTF2 DOMAIN-CONTAINING PROTEIN', 246740),
(368914, 'PTHR39468', NULL, NULL, NULL, NULL, 'CHROMOSOME 7, WHOLE GENOME SHOTGUN SEQUENCE', 246740),
(368915, 'PTHR12673:SF106', NULL, NULL, NULL, NULL, '', 246741),
(368916, 'PTHR12673:SF50', NULL, NULL, NULL, NULL, '', 246741),
(368917, 'PTHR12673:SF248', NULL, NULL, NULL, NULL, '', 246741),
(368918, 'PTHR12673:SF269', NULL, NULL, NULL, NULL, 'RHOGEF DOMAIN-CONTAINING PROTEIN', 246741),
(368919, 'PTHR12673:SF148', NULL, NULL, NULL, NULL, '', 246741),
(368920, 'PTHR12673:SF268', NULL, NULL, NULL, NULL, '', 246741),
(368921, 'PTHR12673:SF92', NULL, NULL, NULL, NULL, 'DH DOMAIN-CONTAINING PROTEIN', 246741),
(368922, 'PTHR12673:SF124', NULL, NULL, NULL, NULL, '', 246741),
(368923, 'PTHR12673:SF245', NULL, NULL, NULL, NULL, 'GUANINE EXCHANGE FACTOR FOR RAC 30', 246741),
(368924, 'PTHR12673:SF267', NULL, NULL, NULL, NULL, 'PROTEIN CBG10230', 246741),
(368925, 'PTHR12673:SF264', NULL, NULL, NULL, NULL, 'DH DOMAIN-CONTAINING PROTEIN', 246741),
(368926, 'PTHR12673:SF263', NULL, NULL, NULL, NULL, 'GRFA PROTEIN, PUTATIVE-RELATED', 246741),
(368927, 'PTHR12673:SF241', NULL, NULL, NULL, NULL, 'PROTEIN CBR-EXC-5', 246741),
(368928, 'PTHR12673:SF13', NULL, NULL, NULL, NULL, 'FYVE, RHOGEF AND PH DOMAIN-CONTAINING PROTEIN 5', 246741),
(368929, 'PTHR12673:SF79', NULL, NULL, NULL, NULL, 'FYVE, RHOGEF AND PH DOMAIN-CONTAINING PROTEIN 1', 246741),
(368930, 'PTHR12673:SF262', NULL, NULL, NULL, NULL, 'DH DOMAIN-CONTAINING PROTEIN', 246741),
(368931, 'PTHR12673:SF14', NULL, NULL, NULL, NULL, 'FYVE, RHOGEF AND PH DOMAIN-CONTAINING PROTEIN 3', 246741),
(368932, 'PTHR12673:SF240', NULL, NULL, NULL, NULL, '', 246741),
(368933, 'PTHR12673:SF55', NULL, NULL, NULL, NULL, 'DH DOMAIN-CONTAINING PROTEIN', 246741),
(368934, 'PTHR12673:SF261', NULL, NULL, NULL, NULL, 'BUD3', 246741),
(368935, 'PTHR12673:SF78', NULL, NULL, NULL, NULL, '', 246741),
(368936, 'PTHR12673:SF12', NULL, NULL, NULL, NULL, 'FYVE, RHOGEF AND PH DOMAIN-CONTAINING PROTEIN 6', 246741),
(368937, 'PTHR12673:SF98', NULL, NULL, NULL, NULL, 'FYVE, RHOGEF AND PH DOMAIN-CONTAINING PROTEIN 4', 246741),
(368938, 'PTHR12673:SF62', NULL, NULL, NULL, NULL, '', 246741),
(368939, 'PTHR12673:SF82', NULL, NULL, NULL, NULL, 'FYVE, RHOGEF AND PH DOMAIN-CONTAINING PROTEIN 2', 246741),
(368940, 'PTHR12673:SF159', NULL, NULL, NULL, NULL, 'LD03170P', 246741),
(368941, 'PTHR12673:SF80', NULL, NULL, NULL, NULL, 'RAC GUANYL-NUCLEOTIDE EXCHANGE FACTOR', 246741),
(368942, 'PTHR12673:SF158', NULL, NULL, NULL, NULL, 'DH DOMAIN-CONTAINING PROTEIN', 246741),
(368943, 'PTHR12673:SF114', NULL, NULL, NULL, NULL, 'DH DOMAIN-CONTAINING PROTEIN', 246741),
(368944, 'PTHR12673:SF255', NULL, NULL, NULL, NULL, '', 246741),
(368945, 'PTHR12673:SF254', NULL, NULL, NULL, NULL, 'RHOGEF DOMAIN-CONTAINING PROTEIN GXCH', 246741),
(368946, 'PTHR12673:SF252', NULL, NULL, NULL, NULL, 'RAC GUANINE NUCLEOTIDE EXCHANGE FACTOR JJ', 246741),
(368947, 'PTHR12673:SF251', NULL, NULL, NULL, NULL, '', 246741),
(368948, 'PTHR12673:SF152', NULL, NULL, NULL, NULL, '', 246741),
(368949, 'PTHR12673:SF150', NULL, NULL, NULL, NULL, '', 246741),
(368950, 'PTHR12673:SF271', NULL, NULL, NULL, NULL, 'PROTEIN CBR-TAG-77', 246741),
(368951, 'PTHR12673:SF270', NULL, NULL, NULL, NULL, 'DH DOMAIN-CONTAINING PROTEIN', 246741),
(368952, 'PTHR12673:SF87', NULL, NULL, NULL, NULL, 'DH DOMAIN-CONTAINING PROTEIN', 246741),
(368953, 'PTHR12673', NULL, NULL, NULL, NULL, 'FACIOGENITAL DYSPLASIA PROTEIN', 246741),
(368954, 'PTHR19868:SF12', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT BETA-LIKE PROTEIN', 246742),
(368955, 'PTHR19868:SF13', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 246742),
(368956, 'PTHR19868:SF0', NULL, NULL, NULL, NULL, 'RECEPTOR OF ACTIVATED PROTEIN C KINASE 1', 246742),
(368957, 'PTHR19868', NULL, NULL, NULL, NULL, 'RECEPTOR FOR ACTIVATED PROTEIN KINASE C  RACK1', 246742);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(368958, 'PTHR19868:SF9', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 246742),
(368959, 'PTHR19868:SF14', NULL, NULL, NULL, NULL, 'RECEPTOR FOR ACTIVATED C KINASE 1B', 246742),
(368960, 'PTHR19868:SF6', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT BETA-LIKE PROTEIN A', 246742),
(368961, 'PTHR19868:SF7', NULL, NULL, NULL, NULL, 'RECEPTOR FOR ACTIVATED C KINASE 1C', 246742),
(368962, 'PTHR19868:SF8', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 246742),
(368963, 'PTHR31437', NULL, NULL, NULL, NULL, 'SREK1IP1 FAMILY MEMBER', 246743),
(368964, 'PTHR31437:SF1', NULL, NULL, NULL, NULL, 'PROTEIN SREK1IP1', 246743),
(368965, 'PTHR30093:SF7', NULL, NULL, NULL, NULL, 'MSHA MAJOR PILIN SUBUNIT MSHA', 246744),
(368966, 'PTHR30093:SF35', NULL, NULL, NULL, NULL, 'MSHA MINOR PILIN PROTEIN MSHC', 246744),
(368967, 'PTHR30093:SF36', NULL, NULL, NULL, NULL, 'TYPE II SECRETION SYSTEM CORE PROTEIN G', 246744),
(368968, 'PTHR30093', NULL, NULL, NULL, NULL, 'GENERAL SECRETION PATHWAY PROTEIN G', 246744),
(368969, 'PTHR30093:SF34', NULL, NULL, NULL, NULL, 'PREPILIN PEPTIDASE-DEPENDENT PROTEIN D', 246744),
(368970, 'PTHR30093:SF42', NULL, NULL, NULL, NULL, 'TYPE II SECRETION SYSTEM PROTEIN H', 246744),
(368971, 'PTHR30093:SF43', NULL, NULL, NULL, NULL, 'SLR2015 PROTEIN', 246744),
(368972, 'PTHR30093:SF2', NULL, NULL, NULL, NULL, 'COMG OPERON PROTEIN 3', 246744),
(368973, 'PTHR30093:SF40', NULL, NULL, NULL, NULL, 'TYPE IV PILUS NON-CORE MINOR PILIN PILE', 246744),
(368974, 'PTHR30093:SF41', NULL, NULL, NULL, NULL, 'PILIN', 246744),
(368975, 'PTHR31321:SF67', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(368976, 'PTHR31321:SF105', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(368977, 'PTHR31321:SF68', NULL, NULL, NULL, NULL, 'PECTINESTERASE 50-RELATED', 246745),
(368978, 'PTHR31321:SF103', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(368979, 'PTHR31321:SF69', NULL, NULL, NULL, NULL, 'PECTINESTERASE PPME1-RELATED', 246745),
(368980, 'PTHR31321:SF102', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(368981, 'PTHR31321:SF101', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(368982, 'PTHR31321:SF100', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(368983, 'PTHR31321:SF109', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(368984, 'PTHR31321', NULL, NULL, NULL, NULL, 'ACYL-COA THIOESTER HYDROLASE YBHC-RELATED', 246745),
(368985, 'PTHR31321:SF106', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(368986, 'PTHR31321:SF78', NULL, NULL, NULL, NULL, 'PECTINESTERASE 49-RELATED', 246745),
(368987, 'PTHR31321:SF116', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(368988, 'PTHR31321:SF112', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(368989, 'PTHR31321:SF111', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(368990, 'PTHR31321:SF70', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(368991, 'PTHR31321:SF71', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(368992, 'PTHR31321:SF72', NULL, NULL, NULL, NULL, 'PECTINESTERASE 11-RELATED', 246745),
(368993, 'PTHR31321:SF73', NULL, NULL, NULL, NULL, 'PECTINESTERASE 14-RELATED', 246745),
(368994, 'PTHR31321:SF74', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(368995, 'PTHR31321:SF31', NULL, NULL, NULL, NULL, 'PECTINESTERASE QRT1', 246745),
(368996, 'PTHR31321:SF76', NULL, NULL, NULL, NULL, 'PECTINESTERASE 29-RELATED', 246745),
(368997, 'PTHR31321:SF33', NULL, NULL, NULL, NULL, 'PECTINESTERASE 8-RELATED', 246745),
(368998, 'PTHR31321:SF77', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(368999, 'PTHR31321:SF80', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(369000, 'PTHR31321:SF118', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(369001, 'PTHR31321:SF127', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(369002, 'PTHR31321:SF126', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(369003, 'PTHR31321:SF125', NULL, NULL, NULL, NULL, 'ACYL-COA THIOESTER HYDROLASE YBHC-RELATED', 246745),
(369004, 'PTHR31321:SF124', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(369005, 'PTHR31321:SF123', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(369006, 'PTHR31321:SF122', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(369007, 'PTHR31321:SF120', NULL, NULL, NULL, NULL, 'PECTINESTERASE 52-RELATED', 246745),
(369008, 'PTHR31321:SF81', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(369009, 'PTHR31321:SF82', NULL, NULL, NULL, NULL, 'PECTINESTERASE 10-RELATED', 246745),
(369010, 'PTHR31321:SF85', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(369011, 'PTHR31321:SF86', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(369012, 'PTHR31321:SF87', NULL, NULL, NULL, NULL, 'PECTINESTERASE 63-RELATED', 246745),
(369013, 'PTHR31321:SF88', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(369014, 'PTHR31321:SF91', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(369015, 'PTHR31321:SF129', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(369016, 'PTHR31321:SF128', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(369017, 'PTHR31321:SF12', NULL, NULL, NULL, NULL, 'PECTINESTERASE 31', 246745),
(369018, 'PTHR31321:SF57', NULL, NULL, NULL, NULL, 'PECTINESTERASE 53-RELATED', 246745),
(369019, 'PTHR31321:SF58', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(369020, 'PTHR31321:SF19', NULL, NULL, NULL, NULL, 'PECTINESTERASE 68-RELATED', 246745),
(369021, 'PTHR31321:SF92', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(369022, 'PTHR31321:SF93', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(369023, 'PTHR31321:SF94', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(369024, 'PTHR31321:SF95', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(369025, 'PTHR31321:SF97', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(369026, 'PTHR31321:SF98', NULL, NULL, NULL, NULL, 'PECTINESTERASE 67-RELATED', 246745),
(369027, 'PTHR31321:SF99', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 246745),
(369028, 'PTHR35609', NULL, NULL, NULL, NULL, '', 246746),
(369029, 'PTHR35609:SF1', NULL, NULL, NULL, NULL, '', 246746),
(369030, 'PTHR10882:SF7', NULL, NULL, NULL, NULL, 'BIOSYNTHESIS PRECORRIN-6B METHYLASE, PUTATIVE (CBIE)-RELATED', 246747),
(369031, 'PTHR10882:SF0', NULL, NULL, NULL, NULL, 'DIPHTHINE METHYL ESTER SYNTHASE', 246747),
(369032, 'PTHR10882', NULL, NULL, NULL, NULL, 'DIPHTHINE SYNTHASE', 246747),
(369033, 'PTHR21499', NULL, NULL, NULL, NULL, 'ASPARTATE KINASE', 246748),
(369034, 'PTHR21499:SF62', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 246748),
(369035, 'PTHR21499:SF40', NULL, NULL, NULL, NULL, 'ASPARTATE KINASE', 246748),
(369036, 'PTHR21499:SF60', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 246748),
(369037, 'PTHR21499:SF66', NULL, NULL, NULL, NULL, 'ASPARTOKINASE', 246748),
(369038, 'PTHR21499:SF55', NULL, NULL, NULL, NULL, 'ASPARTOKINASE', 246748),
(369039, 'PTHR21499:SF67', NULL, NULL, NULL, NULL, 'ASPARTOKINASE 3', 246748),
(369040, 'PTHR21499:SF64', NULL, NULL, NULL, NULL, 'ASPARTOKINASE', 246748),
(369041, 'PTHR21499:SF54', NULL, NULL, NULL, NULL, 'ASPARTOKINASE 2, CHLOROPLASTIC', 246748),
(369042, 'PTHR21499:SF59', NULL, NULL, NULL, NULL, 'ASPARTOKINASE', 246748),
(369043, 'PTHR21499:SF68', NULL, NULL, NULL, NULL, 'ASPARTOKINASE 2', 246748),
(369044, 'PTHR21499:SF58', NULL, NULL, NULL, NULL, 'ASPARTOKINASE 1, CHLOROPLASTIC', 246748),
(369045, 'PTHR21499:SF69', NULL, NULL, NULL, NULL, 'ASPARTOKINASE', 246748),
(369046, 'PTHR21499:SF3', NULL, NULL, NULL, NULL, 'ASPARTOKINASE 1', 246748),
(369047, 'PTHR21499:SF29', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL ASPARTOKINASE/HOMOSERINE DEHYDROGENASE 2', 246748),
(369048, 'PTHR35672:SF1', NULL, NULL, NULL, NULL, 'C-U-EDITING ENZYME APOBEC-4-RELATED', 246749),
(369049, 'PTHR35672', NULL, NULL, NULL, NULL, 'C-U-EDITING ENZYME APOBEC-4-RELATED', 246749),
(369050, 'PTHR39668', NULL, NULL, NULL, NULL, 'HYPOTHETICAL TRANSMEMBRANE PROTEIN L6586.03-RELATED', 246750),
(369051, 'PTHR39668:SF1', NULL, NULL, NULL, NULL, 'HYPOTHETICAL TRANSMEMBRANE PROTEIN L6586.03', 246750),
(369052, 'PTHR39668:SF2', NULL, NULL, NULL, NULL, '', 246750),
(369053, 'PTHR31920:SF60', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246751);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(369054, 'PTHR31920:SF61', NULL, NULL, NULL, NULL, 'BNAA03G53170D PROTEIN', 246751),
(369055, 'PTHR31920:SF106', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246751),
(369056, 'PTHR31920:SF107', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246751),
(369057, 'PTHR31920', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING', 246751),
(369058, 'PTHR31920:SF108', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING TRANSCRIPTION FACTOR VRN1-LIKE ISOFORM X1', 246751),
(369059, 'PTHR31920:SF101', NULL, NULL, NULL, NULL, 'DNA-BINDING PSEUDOBARREL DOMAIN-CONTAINING PROTEIN-RELATED', 246751),
(369060, 'PTHR31920:SF102', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING TRANSCRIPTION FACTOR VRN1-LIKE', 246751),
(369061, 'PTHR31920:SF104', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS03G0621600-RELATED', 246751),
(369062, 'PTHR31920:SF55', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246751),
(369063, 'PTHR31920:SF56', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246751),
(369064, 'PTHR31920:SF98', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS12G0592300', 246751),
(369065, 'PTHR31920:SF54', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN REM21', 246751),
(369066, 'PTHR31920:SF70', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN', 246751),
(369067, 'PTHR31920:SF74', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246751),
(369068, 'PTHR31920:SF72', NULL, NULL, NULL, NULL, 'BNAA01G27140D PROTEIN', 246751),
(369069, 'PTHR31920:SF111', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN LOC_OS12G40080', 246751),
(369070, 'PTHR31920:SF116', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246751),
(369071, 'PTHR31920:SF117', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL FACTOR FAMILY PROTEIN, PUTATIVE-RELATED', 246751),
(369072, 'PTHR31920:SF118', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246751),
(369073, 'PTHR31920:SF119', NULL, NULL, NULL, NULL, '', 246751),
(369074, 'PTHR31920:SF112', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS02G0598200', 246751),
(369075, 'PTHR31920:SF113', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246751),
(369076, 'PTHR31920:SF114', NULL, NULL, NULL, NULL, 'DNA BINDING PROTEIN', 246751),
(369077, 'PTHR31920:SF115', NULL, NULL, NULL, NULL, 'BNAA08G25640D PROTEIN', 246751),
(369078, 'PTHR31920:SF67', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246751),
(369079, 'PTHR31920:SF64', NULL, NULL, NULL, NULL, '', 246751),
(369080, 'PTHR31920:SF69', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246751),
(369081, 'PTHR31920:SF80', NULL, NULL, NULL, NULL, 'BNAC04G49490D PROTEIN', 246751),
(369082, 'PTHR31920:SF81', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246751),
(369083, 'PTHR31920:SF82', NULL, NULL, NULL, NULL, 'BNAA09G07640D PROTEIN', 246751),
(369084, 'PTHR31920:SF120', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246751),
(369085, 'PTHR31920:SF121', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN REM13-LIKE', 246751),
(369086, 'PTHR31920:SF122', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN REM23', 246751),
(369087, 'PTHR31920:SF127', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246751),
(369088, 'PTHR31920:SF128', NULL, NULL, NULL, NULL, 'B3 DOMAIN TRANSCRIPTION FACTOR VRN1-LIKE PROTEIN', 246751),
(369089, 'PTHR31920:SF129', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS03G0620400-LIKE', 246751),
(369090, 'PTHR31920:SF123', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246751),
(369091, 'PTHR31920:SF124', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246751),
(369092, 'PTHR31920:SF125', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246751),
(369093, 'PTHR31920:SF126', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN REM20', 246751),
(369094, 'PTHR31920:SF33', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS11G0197600-LIKE', 246751),
(369095, 'PTHR31920:SF75', NULL, NULL, NULL, NULL, 'BNAANNG11010D PROTEIN', 246751);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(369096, 'PTHR31920:SF32', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN REM22', 246751),
(369097, 'PTHR31920:SF37', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING TRANSCRIPTION FACTOR VRN1', 246751),
(369098, 'PTHR31920:SF51', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE-RELATED', 246751),
(369099, 'PTHR31920:SF94', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS01G0723500-LIKE ISOFORM X1', 246751),
(369100, 'PTHR31920:SF50', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246751),
(369101, 'PTHR31920:SF130', NULL, NULL, NULL, NULL, 'BNAA02G35360D PROTEIN', 246751),
(369102, 'PTHR31920:SF131', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING TRANSCRIPTION FACTOR VRN1-LIKE', 246751),
(369103, 'PTHR31920:SF132', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246751),
(369104, 'PTHR31920:SF133', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246751),
(369105, 'PTHR31920:SF134', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246751),
(369106, 'PTHR31920:SF135', NULL, NULL, NULL, NULL, 'B3 DNA-BINDING DOMAIN PROTEIN', 246751),
(369107, 'PTHR31920:SF136', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 246751),
(369108, 'PTHR31920:SF137', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246751),
(369109, 'PTHR31920:SF44', NULL, NULL, NULL, NULL, 'BNAA04G20470D PROTEIN', 246751),
(369110, 'PTHR31920:SF47', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 246751),
(369111, 'PTHR46754:SF1', NULL, NULL, NULL, NULL, 'MKI67 FHA DOMAIN-INTERACTING NUCLEOLAR PHOSPHOPROTEIN', 246752),
(369112, 'PTHR46754:SF12', NULL, NULL, NULL, NULL, 'MKI67 FHA DOMAIN-INTERACTING NUCLEOLAR PHOSPHOPROTEIN', 246752),
(369113, 'PTHR46754:SF13', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 246752),
(369114, 'PTHR46754:SF10', NULL, NULL, NULL, NULL, 'RNA BINDING PROTEIN', 246752),
(369115, 'PTHR46754:SF11', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 246752),
(369116, 'PTHR46754:SF7', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 246752),
(369117, 'PTHR46754', NULL, NULL, NULL, NULL, 'MKI67 FHA DOMAIN-INTERACTING NUCLEOLAR PHOSPHOPROTEIN', 246752),
(369118, 'PTHR38768', NULL, NULL, NULL, NULL, 'UPF0502 PROTEIN YCEH', 246753),
(369119, 'PTHR38768:SF1', NULL, NULL, NULL, NULL, 'UPF0502 PROTEIN YCEH', 246753),
(369120, 'PTHR48313:SF1', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 246754),
(369121, 'PTHR48313', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 246754),
(369122, 'PTHR15380:SF1', NULL, NULL, NULL, NULL, 'CLN5-LIKE PROTEIN 1-RELATED', 246755),
(369123, 'PTHR15380:SF2', NULL, NULL, NULL, NULL, 'CEROID-LIPOFUSCINOSIS NEURONAL PROTEIN 5', 246755),
(369124, 'PTHR15380', NULL, NULL, NULL, NULL, 'CEROID-LIPOFUSCINOSIS, NEURONAL 5', 246755),
(369125, 'PTHR22979', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN-RELATED', 246756),
(369126, 'PTHR22979:SF3', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 512B', 246756),
(369127, 'PTHR22979:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 512', 246756),
(369128, 'PTHR21680', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 246757),
(369129, 'PTHR21680:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246757),
(369130, 'PTHR21680:SF0', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 124', 246757),
(369131, 'PTHR39665:SF2', NULL, NULL, NULL, NULL, '', 246758),
(369132, 'PTHR39665:SF1', NULL, NULL, NULL, NULL, '', 246758),
(369133, 'PTHR39665', NULL, NULL, NULL, NULL, '', 246758),
(369134, 'PTHR33385:SF21', NULL, NULL, NULL, NULL, 'BNAA06G09450D PROTEIN', 246759),
(369135, 'PTHR33385:SF20', NULL, NULL, NULL, NULL, 'BNAA09G56950D PROTEIN', 246759),
(369136, 'PTHR33385:SF25', NULL, NULL, NULL, NULL, '', 246759),
(369137, 'PTHR33385:SF14', NULL, NULL, NULL, NULL, '', 246759),
(369138, 'PTHR33385:SF26', NULL, NULL, NULL, NULL, 'OS01G0918100 PROTEIN', 246759),
(369139, 'PTHR33385:SF13', NULL, NULL, NULL, NULL, '', 246759),
(369140, 'PTHR33385', NULL, NULL, NULL, NULL, 'PROTEIN XRI1', 246759),
(369141, 'PTHR33385:SF18', NULL, NULL, NULL, NULL, 'XRI1-LIKE PROTEIN', 246759);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(369142, 'PTHR33385:SF19', NULL, NULL, NULL, NULL, 'BNAA02G30390D PROTEIN', 246759),
(369143, 'PTHR33385:SF16', NULL, NULL, NULL, NULL, 'PROTEIN XRI1-LIKE ISOFORM X1', 246759),
(369144, 'PTHR33385:SF17', NULL, NULL, NULL, NULL, 'OS08G0466800 PROTEIN', 246759),
(369145, 'PTHR33385:SF4', NULL, NULL, NULL, NULL, 'PROTEIN XRI1', 246759),
(369146, 'PTHR31253:SF0', NULL, NULL, NULL, NULL, 'BRI3-BINDING PROTEIN', 246760),
(369147, 'PTHR31253', NULL, NULL, NULL, NULL, 'BRI3-BINDING PROTEIN', 246760),
(369148, 'PTHR14145:SF6', NULL, NULL, NULL, NULL, 'PCI DOMAIN-CONTAINING PROTEIN', 246761),
(369149, 'PTHR14145:SF4', NULL, NULL, NULL, NULL, 'PCI DOMAIN-CONTAINING PROTEIN', 246761),
(369150, 'PTHR14145:SF5', NULL, NULL, NULL, NULL, 'PCI DOMAIN-CONTAINING PROTEIN', 246761),
(369151, 'PTHR14145:SF2', NULL, NULL, NULL, NULL, 'COP9 SIGNALOSOME COMPLEX SUBUNIT 1', 246761),
(369152, 'PTHR14145:SF3', NULL, NULL, NULL, NULL, 'OS02G0600100 PROTEIN', 246761),
(369153, 'PTHR14145:SF1', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 6', 246761),
(369154, 'PTHR14145', NULL, NULL, NULL, NULL, '26S PROTESOME SUBUNIT 6', 246761),
(369155, 'PTHR31258', NULL, NULL, NULL, NULL, 'KERATINOCYTE-ASSOCIATED PROTEIN 3', 246762),
(369156, 'PTHR31258:SF1', NULL, NULL, NULL, NULL, 'KERATINOCYTE-ASSOCIATED PROTEIN 3', 246762),
(369157, 'PTHR31258:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 54', 246762),
(369158, 'PTHR31258:SF5', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 54A-RELATED', 246762),
(369159, 'PTHR40618:SF1', NULL, NULL, NULL, NULL, 'B-ZIP TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 246763),
(369160, 'PTHR40618', NULL, NULL, NULL, NULL, 'B-ZIP TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 246763),
(369161, 'PTHR12047', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA GROUP A PROTEIN', 246764),
(369162, 'PTHR12047:SF2', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA GROUP A PROTEIN', 246764),
(369163, 'PTHR16431', NULL, NULL, NULL, NULL, 'NEUROGENIC PROTEIN MASTERMIND', 246765),
(369164, 'PTHR16431:SF2', NULL, NULL, NULL, NULL, 'PROTEIN MIS18-ALPHA', 246765),
(369165, 'PTHR16431:SF3', NULL, NULL, NULL, NULL, 'PROTEIN MIS18-BETA', 246765),
(369166, 'PTHR16431:SF1', NULL, NULL, NULL, NULL, 'NEUROGENIC PROTEIN MASTERMIND', 246765),
(369167, 'PTHR43471:SF10', NULL, NULL, NULL, NULL, 'SLL1107 PROTEIN', 246766),
(369168, 'PTHR43471:SF3', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN NATB', 246766),
(369169, 'PTHR43471:SF13', NULL, NULL, NULL, NULL, 'HYPOTHETICAL MEMBRANE PROTEIN, CONSERVED', 246766),
(369170, 'PTHR43471:SF12', NULL, NULL, NULL, NULL, 'HYPOTHETICAL MEMBRANE PROTEIN, CONSERVED', 246766),
(369171, 'PTHR43471:SF1', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN NOSY-RELATED', 246766),
(369172, 'PTHR43471', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE', 246766),
(369173, 'PTHR21128', NULL, NULL, NULL, NULL, 'FETAL AND ADULT TESTIS-EXPRESSED TRANSCRIPT PROTEIN', 246767),
(369174, 'PTHR21128:SF0', NULL, NULL, NULL, NULL, 'FETAL AND ADULT TESTIS-EXPRESSED TRANSCRIPT PROTEIN', 246767),
(369175, 'PTHR46713', NULL, NULL, NULL, NULL, 'F13M7.16 PROTEIN', 246768),
(369176, 'PTHR46713:SF1', NULL, NULL, NULL, NULL, 'F13M7.16 PROTEIN', 246768),
(369177, 'PTHR46713:SF11', NULL, NULL, NULL, NULL, 'UBX DOMAIN-CONTAINING PROTEIN 1-LIKE ISOFORM X1', 246768),
(369178, 'PTHR46713:SF12', NULL, NULL, NULL, NULL, 'PUB DOMAIN-CONTAINING PROTEIN', 246768),
(369179, 'PTHR46713:SF5', NULL, NULL, NULL, NULL, 'UBA DOMAIN-CONTAINING PROTEIN', 246768),
(369180, 'PTHR46713:SF4', NULL, NULL, NULL, NULL, 'UBIQUITIN-ASSOCIATED (UBA)/TS-N DOMAIN PROTEIN', 246768),
(369181, 'PTHR46713:SF7', NULL, NULL, NULL, NULL, 'UBA DOMAIN-CONTAINING PROTEIN', 246768),
(369182, 'PTHR46447:SF1', NULL, NULL, NULL, NULL, 'INTERLEUKIN ENHANCER-BINDING FACTOR 2', 246769),
(369183, 'PTHR46447', NULL, NULL, NULL, NULL, 'INTERLEUKIN ENHANCER-BINDING FACTOR', 246769),
(369184, 'PTHR24249:SF409', NULL, NULL, NULL, NULL, 'PROTEIN CBR-TAG-89', 246770),
(369185, 'PTHR24249:SF406', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 246770);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(369186, 'PTHR24249:SF307', NULL, NULL, NULL, NULL, 'TRACE AMINE-ASSOCIATED RECEPTOR 5', 246770),
(369187, 'PTHR24249:SF405', NULL, NULL, NULL, NULL, 'TRACE AMINE-ASSOCIATED RECEPTOR 8A-RELATED', 246770),
(369188, 'PTHR24249:SF381', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN-RELATED', 246770),
(369189, 'PTHR24249:SF387', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 246770),
(369190, 'PTHR24249:SF220', NULL, NULL, NULL, NULL, 'TRACE AMINE-ASSOCIATED RECEPTOR 4', 246770),
(369191, 'PTHR24249:SF82', NULL, NULL, NULL, NULL, 'TRACE AMINE-ASSOCIATED RECEPTOR 3-RELATED', 246770),
(369192, 'PTHR24249:SF384', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 21-RELATED', 246770),
(369193, 'PTHR24249:SF419', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 246770),
(369194, 'PTHR24249:SF418', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 246770),
(369195, 'PTHR24249:SF417', NULL, NULL, NULL, NULL, 'TRACE AMINE-ASSOCIATED RECEPTOR 11', 246770),
(369196, 'PTHR24249:SF416', NULL, NULL, NULL, NULL, 'TRACE AMINE-ASSOCIATED RECEPTOR 8', 246770),
(369197, 'PTHR24249:SF415', NULL, NULL, NULL, NULL, 'TRACE AMINE-ASSOCIATED RECEPTOR 1', 246770),
(369198, 'PTHR24249:SF414', NULL, NULL, NULL, NULL, 'LP14436P', 246770),
(369199, 'PTHR24249:SF413', NULL, NULL, NULL, NULL, 'TRACE AMINE-ASSOCIATED RECEPTOR 2', 246770),
(369200, 'PTHR24249', NULL, NULL, NULL, NULL, 'HISTAMINE RECEPTOR-RELATED G-PROTEIN COUPLED RECEPTOR', 246770),
(369201, 'PTHR24249:SF271', NULL, NULL, NULL, NULL, 'TRACE AMINE-ASSOCIATED RECEPTOR 6', 246770),
(369202, 'PTHR24249:SF392', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR 52', 246770),
(369203, 'PTHR24249:SF79', NULL, NULL, NULL, NULL, 'TRACE AMINE-ASSOCIATED RECEPTOR 9', 246770),
(369204, 'PTHR24249:SF412', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 246770),
(369205, 'PTHR24249:SF411', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 246770),
(369206, 'PTHR24249:SF78', NULL, NULL, NULL, NULL, 'TRACE AMINE-ASSOCIATED RECEPTOR 7A-RELATED', 246770),
(369207, 'PTHR24249:SF376', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 246770),
(369208, 'PTHR24249:SF374', NULL, NULL, NULL, NULL, 'TRACE AMINE ASSOCIATED RECEPTOR 8', 246770),
(369209, 'PTHR24249:SF372', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 246770),
(369210, 'PTHR12958', NULL, NULL, NULL, NULL, 'FRIEND OF GATA2-RELATED', 246771),
(369211, 'PTHR12958:SF5', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZFPM2', 246771),
(369212, 'PTHR12958:SF4', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZFPM1', 246771),
(369213, 'PTHR12958:SF3', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN USH', 246771),
(369214, 'PTHR36974:SF1', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 246772),
(369215, 'PTHR36974', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 246772),
(369216, 'PTHR40659', NULL, NULL, NULL, NULL, 'NICKEL/COBALT EFFLUX SYSTEM RCNA', 246773),
(369217, 'PTHR40659:SF1', NULL, NULL, NULL, NULL, 'NICKEL/COBALT EFFLUX SYSTEM RCNA', 246773),
(369218, 'PTHR43873:SF1', NULL, NULL, NULL, NULL, 'COBYRINATE A,C-DIAMIDE SYNTHASE', 246774),
(369219, 'PTHR43873:SF2', NULL, NULL, NULL, NULL, 'COBYRIC ACID SYNTHASE', 246774),
(369220, 'PTHR43873', NULL, NULL, NULL, NULL, 'COBYRINATE A,C-DIAMIDE SYNTHASE', 246774),
(369221, 'PTHR28265', NULL, NULL, NULL, NULL, 'MAINTENANCE OF TELOMERE CAPPING PROTEIN 1', 246775),
(369222, 'PTHR28265:SF1', NULL, NULL, NULL, NULL, 'MAINTENANCE OF TELOMERE CAPPING PROTEIN 1', 246775),
(369223, 'PTHR31154:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG11920', 246776),
(369224, 'PTHR31154:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG11935', 246776),
(369225, 'PTHR31154:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG17976', 246776),
(369226, 'PTHR31154:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG17977', 246776),
(369227, 'PTHR31154', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 246776),
(369228, 'PTHR43586:SF15', NULL, NULL, NULL, NULL, 'BLR3095 PROTEIN', 246777);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(369229, 'PTHR43586:SF25', NULL, NULL, NULL, NULL, 'CYSTEINE DESULFURASE', 246777),
(369230, 'PTHR43586:SF24', NULL, NULL, NULL, NULL, 'BLR4730 PROTEIN', 246777),
(369231, 'PTHR43586:SF23', NULL, NULL, NULL, NULL, 'AMINOTRAN_5 DOMAIN-CONTAINING PROTEIN', 246777),
(369232, 'PTHR43586:SF8', NULL, NULL, NULL, NULL, 'CYSTEINE DESULFURASE 1, CHLOROPLASTIC', 246777),
(369233, 'PTHR43586:SF19', NULL, NULL, NULL, NULL, 'OS01G0729600 PROTEIN', 246777),
(369234, 'PTHR43586:SF17', NULL, NULL, NULL, NULL, 'OS11G0209900 PROTEIN', 246777),
(369235, 'PTHR43586:SF4', NULL, NULL, NULL, NULL, 'ISOPENICILLIN N EPIMERASE', 246777),
(369236, 'PTHR43586:SF3', NULL, NULL, NULL, NULL, 'O-PHOSPHO-L-SERYL-TRNA:CYS-TRNA SYNTHASE', 246777),
(369237, 'PTHR43586:SF22', NULL, NULL, NULL, NULL, 'AMINOTRAN_5 DOMAIN-CONTAINING PROTEIN', 246777),
(369238, 'PTHR43586:SF21', NULL, NULL, NULL, NULL, 'PYRIDOXAL PHOSPHATE (PLP)-DEPENDENT ASPARTATE AMINOTRANSFERASE SUPERFAMILY', 246777),
(369239, 'PTHR43586', NULL, NULL, NULL, NULL, 'CYSTEINE DESULFURASE', 246777),
(369240, 'PTHR35076', NULL, NULL, NULL, NULL, 'TUBULIN EPSILON AND DELTA COMPLEX PROTEIN 1', 246778),
(369241, 'PTHR35076:SF1', NULL, NULL, NULL, NULL, 'TUBULIN EPSILON AND DELTA COMPLEX PROTEIN 1', 246778),
(369242, 'PTHR17103:SF13', NULL, NULL, NULL, NULL, 'NEUREXOPHILIN-1', 246779),
(369243, 'PTHR17103:SF11', NULL, NULL, NULL, NULL, 'NEUREXOPHILIN-2', 246779),
(369244, 'PTHR17103:SF10', NULL, NULL, NULL, NULL, 'NEUREXOPHILIN-4', 246779),
(369245, 'PTHR17103:SF15', NULL, NULL, NULL, NULL, 'NEUREXOPHILIN', 246779),
(369246, 'PTHR17103:SF14', NULL, NULL, NULL, NULL, 'NEUREXOPHILIN-3', 246779),
(369247, 'PTHR17103', NULL, NULL, NULL, NULL, 'NEUREXOPHILIN', 246779),
(369248, 'PTHR23327:SF5', NULL, NULL, NULL, NULL, 'LON PEPTIDASE N-TERMINAL DOMAIN AND RING FINGER PROTEIN 2', 246780),
(369249, 'PTHR23327:SF45', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246780),
(369250, 'PTHR23327:SF4', NULL, NULL, NULL, NULL, 'LON PEPTIDASE N-TERMINAL DOMAIN AND RING FINGER PROTEIN 1', 246780),
(369251, 'PTHR23327:SF6', NULL, NULL, NULL, NULL, 'LON PEPTIDASE N-TERMINAL DOMAIN AND RING FINGER 1', 246780),
(369252, 'PTHR23327:SF46', NULL, NULL, NULL, NULL, '43KDA POSTSYNAPTIC PROTEIN-RELATED', 246780),
(369253, 'PTHR23327:SF41', NULL, NULL, NULL, NULL, 'LON PEPTIDASE N-TERMINAL DOMAIN AND RING FINGER PROTEIN 3', 246780),
(369254, 'PTHR23327', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 127', 246780),
(369255, 'PTHR23327:SF42', NULL, NULL, NULL, NULL, 'LON PEPTIDASE N-TERMINAL DOMAIN AND RING FINGER PROTEIN C14F5.10C', 246780),
(369256, 'PTHR23327:SF49', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246780),
(369257, 'PTHR23327:SF48', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR OF YEAST FORM ADHERENCE 3', 246780),
(369258, 'PTHR34962:SF1', NULL, NULL, NULL, NULL, 'EMBRYO DEFECTIVE 1703-RELATED', 246781),
(369259, 'PTHR34962:SF3', NULL, NULL, NULL, NULL, 'ABC SUBFAMILY C PROTEIN', 246781),
(369260, 'PTHR34962', NULL, NULL, NULL, NULL, 'EMBRYO DEFECTIVE 1703-RELATED', 246781),
(369261, 'PTHR34682:SF16', NULL, NULL, NULL, NULL, 'AT HOOK MOTIF-CONTAINING PROTEIN', 246782),
(369262, 'PTHR34682:SF15', NULL, NULL, NULL, NULL, 'BNAC03G71820D PROTEIN', 246782),
(369263, 'PTHR34682:SF1', NULL, NULL, NULL, NULL, 'AT HOOK MOTIF-CONTAINING PROTEIN', 246782),
(369264, 'PTHR34682:SF3', NULL, NULL, NULL, NULL, 'HOOK MOTIF-CONTAINING PROTEIN, PUTATIVE ISOFORM 1-RELATED', 246782),
(369265, 'PTHR34682:SF10', NULL, NULL, NULL, NULL, '', 246782),
(369266, 'PTHR34682:SF5', NULL, NULL, NULL, NULL, 'AT HOOK MOTIF-CONTAINING PROTEIN', 246782),
(369267, 'PTHR34682:SF7', NULL, NULL, NULL, NULL, '', 246782),
(369268, 'PTHR34682', NULL, NULL, NULL, NULL, 'AT HOOK MOTIF-CONTAINING PROTEIN', 246782),
(369269, 'PTHR34682:SF8', NULL, NULL, NULL, NULL, 'AT HOOK MOTIF-CONTAINING PROTEIN', 246782),
(369270, 'PTHR34682:SF14', NULL, NULL, NULL, NULL, 'DNA BINDING PROTEIN', 246782),
(369271, 'PTHR34682:SF9', NULL, NULL, NULL, NULL, 'BNAA10G27870D PROTEIN', 246782),
(369272, 'PTHR34682:SF13', NULL, NULL, NULL, NULL, 'BNACNNG37080D PROTEIN', 246782);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(369273, 'PTHR34682:SF12', NULL, NULL, NULL, NULL, '', 246782),
(369274, 'PTHR34682:SF11', NULL, NULL, NULL, NULL, '', 246782),
(369275, 'PTHR47344', NULL, NULL, NULL, NULL, 'RING ZINC FINGER PROTEIN-RELATED', 246783),
(369276, 'PTHR47344:SF1', NULL, NULL, NULL, NULL, 'RING ZINC FINGER PROTEIN-RELATED', 246783),
(369277, 'PTHR47344:SF2', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 40-LIKE ISOFORM X1', 246783),
(369278, 'PTHR37557:SF5', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 246784),
(369279, 'PTHR37557:SF4', NULL, NULL, NULL, NULL, 'BED-TYPE DOMAIN-CONTAINING PROTEIN', 246784),
(369280, 'PTHR37557', NULL, NULL, NULL, NULL, '115 KDA PROTEIN IN TYPE-1 RETROTRANSPOSABLE ELEMENT R1DM-LIKE PROTEIN-RELATED-RELATED', 246784),
(369281, 'PTHR34410:SF2', NULL, NULL, NULL, NULL, 'INTRON-ENCODED HOMING ENDONUCLEASE, PUTATIVE-RELATED', 246785),
(369282, 'PTHR34410', NULL, NULL, NULL, NULL, 'INTRON-ENCODED HOMING ENDONUCLEASE, PUTATIVE-RELATED', 246785),
(369283, 'PTHR34410:SF3', NULL, NULL, NULL, NULL, '', 246785),
(369284, 'PTHR12306:SF15', NULL, NULL, NULL, NULL, 'DNAATION FACTOR-RELATED PROTEIN 1, ISOFORM B-RELATED', 246786),
(369285, 'PTHR12306:SF10', NULL, NULL, NULL, NULL, 'CELL DEATH ACTIVATOR CIDE-B', 246786),
(369286, 'PTHR12306:SF22', NULL, NULL, NULL, NULL, 'DNAATION FACTOR-RELATED PROTEIN 2, ISOFORM B', 246786),
(369287, 'PTHR12306:SF9', NULL, NULL, NULL, NULL, 'CELL DEATH ACTIVATOR CIDE-3', 246786),
(369288, 'PTHR12306:SF8', NULL, NULL, NULL, NULL, 'CELL DEATH ACTIVATOR CIDE-A', 246786),
(369289, 'PTHR12306', NULL, NULL, NULL, NULL, 'CELL DEATH ACTIVATOR CIDE', 246786),
(369290, 'PTHR12306:SF16', NULL, NULL, NULL, NULL, 'CIDE-N DOMAIN-CONTAINING PROTEIN', 246786),
(369291, 'PTHR41930:SF1', NULL, NULL, NULL, NULL, 'UPF0200 PROTEIN TK1334', 246787),
(369292, 'PTHR41930', NULL, NULL, NULL, NULL, 'UPF0200 PROTEIN MJ1399', 246787),
(369293, 'PTHR32012:SF0', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 182', 246788),
(369294, 'PTHR32012', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 182-RELATED', 246788),
(369295, 'PTHR32012:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 182', 246788),
(369296, 'PTHR45619', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP2A-RELATED', 246789),
(369297, 'PTHR45619:SF46', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 246789),
(369298, 'PTHR45619:SF25', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 246789),
(369299, 'PTHR45619:SF27', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP2A-3 CATALYTIC SUBUNIT', 246789),
(369300, 'PTHR45619:SF28', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 246789),
(369301, 'PTHR45619:SF29', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP-X ISOZYME 1', 246789),
(369302, 'PTHR45619:SF50', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 246789),
(369303, 'PTHR45619:SF53', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 246789),
(369304, 'PTHR45619:SF10', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 6 CATALYTIC SUBUNIT', 246789),
(369305, 'PTHR45619:SF11', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP2A-2 CATALYTIC SUBUNIT', 246789),
(369306, 'PTHR45619:SF34', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP2A-4 CATALYTIC SUBUNIT', 246789),
(369307, 'PTHR45619:SF12', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP2A', 246789),
(369308, 'PTHR45619:SF13', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 246789),
(369309, 'PTHR45619:SF57', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 246789),
(369310, 'PTHR45619:SF35', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 246789),
(369311, 'PTHR45619:SF36', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 246789),
(369312, 'PTHR45619:SF58', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 246789),
(369313, 'PTHR45619:SF15', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 246789); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(369314, 'PTHR45619:SF59', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP2A-5 CATALYTIC SUBUNIT', 246789),
(369315, 'PTHR45619:SF16', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP2A-1 CATALYTIC SUBUNIT', 246789),
(369316, 'PTHR45619:SF38', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 246789),
(369317, 'PTHR45619:SF17', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP2A-5 CATALYTIC SUBUNIT', 246789),
(369318, 'PTHR45619:SF39', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 246789),
(369319, 'PTHR45619:SF19', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 246789),
(369320, 'PTHR45619:SF60', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 246789),
(369321, 'PTHR45619:SF61', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 246789),
(369322, 'PTHR45619:SF62', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP2A-2 CATALYTIC SUBUNIT', 246789),
(369323, 'PTHR45619:SF2', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP2A-4 CATALYTIC SUBUNIT', 246789),
(369324, 'PTHR45619:SF40', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 246789),
(369325, 'PTHR45619:SF41', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 246789),
(369326, 'PTHR45619:SF63', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 246789),
(369327, 'PTHR45619:SF42', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A CATALYTIC SUBUNIT ALPHA ISOFORM', 246789),
(369328, 'PTHR45619:SF64', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 246789),
(369329, 'PTHR45619:SF65', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 246789),
(369330, 'PTHR45619:SF21', NULL, NULL, NULL, NULL, 'PHYTOCHROME-ASSOCIATED SERINE/THREONINE-PROTEIN PHOSPHATASE 1-RELATED', 246789),
(369331, 'PTHR45619:SF66', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP2A CATALYTIC SUBUNIT', 246789),
(369332, 'PTHR45619:SF44', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A CATALYTIC SUBUNIT BETA ISOFORM', 246789),
(369333, 'PTHR45619:SF23', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 246789),
(369334, 'PTHR45619:SF8', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 4 CATALYTIC SUBUNIT', 246789),
(369335, 'PTHR45619:SF6', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP2A-LIKE PPG1', 246789),
(369336, 'PTHR42244', NULL, NULL, NULL, NULL, 'ANTITOXIN VAPB3-RELATED', 246790),
(369337, 'PTHR42244:SF2', NULL, NULL, NULL, NULL, 'ANTITOXIN VAPB3-RELATED', 246790),
(369338, 'PTHR40663:SF2', NULL, NULL, NULL, NULL, 'HTH DOMAIN PROTEIN', 246791),
(369339, 'PTHR40663', NULL, NULL, NULL, NULL, '', 246791),
(369340, 'PTHR31199', NULL, NULL, NULL, NULL, 'ARPIN', 246792),
(369341, 'PTHR31199:SF1', NULL, NULL, NULL, NULL, 'ARPIN', 246792),
(369342, 'PTHR43811', NULL, NULL, NULL, NULL, 'FKBP-TYPE PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKPA', 246793),
(369343, 'PTHR43811:SF40', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 246793),
(369344, 'PTHR43811:SF19', NULL, NULL, NULL, NULL, '39 KDA FK506-BINDING NUCLEAR PROTEIN', 246793),
(369345, 'PTHR43811:SF17', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP16-3, CHLOROPLASTIC', 246793),
(369346, 'PTHR43811:SF55', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN ISOFORM 1', 246793),
(369347, 'PTHR43811:SF23', NULL, NULL, NULL, NULL, 'FKBP-TYPE 22 KDA PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246793),
(369348, 'PTHR43811:SF56', NULL, NULL, NULL, NULL, 'FK506-BINDING PROTEIN', 246793),
(369349, 'PTHR43811:SF54', NULL, NULL, NULL, NULL, 'FKBP-TYPE PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKPA', 246793),
(369350, 'PTHR43811:SF32', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP16-4, CHLOROPLASTIC', 246793),
(369351, 'PTHR43811:SF26', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP16-1, CHLOROPLASTIC', 246793),
(369352, 'PTHR43811:SF48', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP43', 246793);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(369353, 'PTHR43811:SF37', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 246793),
(369354, 'PTHR43811:SF46', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 246793),
(369355, 'PTHR35145:SF3', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 246794),
(369356, 'PTHR35145', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 246794),
(369357, 'PTHR35145:SF1', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 246794),
(369358, 'PTHR45374', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE TCHQD', 246795),
(369359, 'PTHR45374:SF2', NULL, NULL, NULL, NULL, 'TCHQD CLASS GLUTATHIONE S-TRANSFERASE', 246795),
(369360, 'PTHR45374:SF1', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE TCHQD', 246795),
(369361, 'PTHR45684:SF34', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN SAR1A', 246796),
(369362, 'PTHR45684:SF12', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN SAR1A-LIKE', 246796),
(369363, 'PTHR45684:SF33', NULL, NULL, NULL, NULL, 'BNAA09G15410D PROTEIN', 246796),
(369364, 'PTHR45684:SF22', NULL, NULL, NULL, NULL, '', 246796),
(369365, 'PTHR45684:SF32', NULL, NULL, NULL, NULL, 'PROTEIN SAR1A, PUTATIVE, EXPRESSED-RELATED', 246796),
(369366, 'PTHR45684:SF10', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN SAR1B', 246796),
(369367, 'PTHR45684:SF20', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN SAR1B', 246796),
(369368, 'PTHR45684:SF31', NULL, NULL, NULL, NULL, 'OS06G0225000 PROTEIN', 246796),
(369369, 'PTHR45684:SF38', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN SAR2', 246796),
(369370, 'PTHR45684:SF27', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN SAR1A-LIKE PROTEIN', 246796),
(369371, 'PTHR45684:SF26', NULL, NULL, NULL, NULL, 'BNACNNG06680D PROTEIN', 246796),
(369372, 'PTHR45684:SF37', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN SAR1A-LIKE', 246796),
(369373, 'PTHR45684:SF25', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN SAR1', 246796),
(369374, 'PTHR45684:SF36', NULL, NULL, NULL, NULL, '', 246796),
(369375, 'PTHR45684:SF24', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN SAR1B-RELATED', 246796),
(369376, 'PTHR45684:SF13', NULL, NULL, NULL, NULL, 'PROTEIN SAR1, PUTATIVE-RELATED', 246796),
(369377, 'PTHR45684', NULL, NULL, NULL, NULL, 'RE74312P', 246796),
(369378, 'PTHR45684:SF30', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN SAR1A', 246796),
(369379, 'PTHR45684:SF2', NULL, NULL, NULL, NULL, 'RE74312P', 246796),
(369380, 'PTHR45684:SF17', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN', 246796),
(369381, 'PTHR45684:SF6', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN SAR1A', 246796),
(369382, 'PTHR31561:SF190', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE 16', 246797),
(369383, 'PTHR31561:SF109', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE 2', 246797),
(369384, 'PTHR31561:SF105', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369385, 'PTHR31561:SF107', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE 3', 246797),
(369386, 'PTHR31561:SF106', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE 19', 246797),
(369387, 'PTHR31561:SF101', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369388, 'PTHR31561:SF189', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369389, 'PTHR31561:SF188', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369390, 'PTHR31561:SF100', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369391, 'PTHR31561:SF103', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE 11', 246797),
(369392, 'PTHR31561:SF185', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369393, 'PTHR31561:SF184', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE 17', 246797),
(369394, 'PTHR31561:SF187', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN 3-OXOACYL-COA SYNTHASE', 246797),
(369395, 'PTHR31561:SF186', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369396, 'PTHR31561:SF182', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369397, 'PTHR31561:SF27', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN 3-OXOACYL-COA SYNTHASE', 246797),
(369398, 'PTHR31561:SF23', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE 9', 246797);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(369399, 'PTHR31561:SF24', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE 12', 246797),
(369400, 'PTHR31561:SF116', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369401, 'PTHR31561:SF115', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369402, 'PTHR31561:SF118', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE 20', 246797),
(369403, 'PTHR31561:SF29', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN 3-OXOACYL-COA SYNTHASE', 246797),
(369404, 'PTHR31561:SF112', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369405, 'PTHR31561:SF111', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369406, 'PTHR31561:SF199', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369407, 'PTHR31561:SF113', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE 19-LIKE', 246797),
(369408, 'PTHR31561:SF196', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369409, 'PTHR31561:SF195', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369410, 'PTHR31561:SF198', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369411, 'PTHR31561:SF110', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN 3-OXOACYL-COA SYNTHASE', 246797),
(369412, 'PTHR31561:SF197', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369413, 'PTHR31561:SF192', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369414, 'PTHR31561:SF191', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369415, 'PTHR31561:SF194', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369416, 'PTHR31561:SF193', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369417, 'PTHR31561:SF97', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE 7', 246797),
(369418, 'PTHR31561:SF90', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE 15', 246797),
(369419, 'PTHR31561:SF91', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369420, 'PTHR31561:SF16', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE 20-RELATED', 246797),
(369421, 'PTHR31561:SF98', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369422, 'PTHR31561:SF10', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE 2-LIKE', 246797),
(369423, 'PTHR31561:SF99', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE 4', 246797),
(369424, 'PTHR31561:SF12', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369425, 'PTHR31561:SF127', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369426, 'PTHR31561:SF126', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN 3-OXOACYL-COA SYNTHASE', 246797),
(369427, 'PTHR31561:SF128', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369428, 'PTHR31561:SF125', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369429, 'PTHR31561:SF124', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369430, 'PTHR31561:SF121', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369431, 'PTHR31561:SF7', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369432, 'PTHR31561:SF83', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369433, 'PTHR31561:SF8', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE 15', 246797),
(369434, 'PTHR31561:SF84', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369435, 'PTHR31561:SF5', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE 5-RELATED', 246797),
(369436, 'PTHR31561:SF6', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE 21-RELATED', 246797),
(369437, 'PTHR31561:SF80', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369438, 'PTHR31561:SF81', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369439, 'PTHR31561:SF2', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE 10', 246797),
(369440, 'PTHR31561:SF88', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE 18', 246797),
(369441, 'PTHR31561:SF89', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369442, 'PTHR31561:SF138', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369443, 'PTHR31561:SF137', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369444, 'PTHR31561:SF139', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(369445, 'PTHR31561:SF134', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369446, 'PTHR31561:SF133', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369447, 'PTHR31561:SF136', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369448, 'PTHR31561:SF132', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369449, 'PTHR31561:SF9', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369450, 'PTHR31561:SF72', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369451, 'PTHR31561:SF73', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE 1', 246797),
(369452, 'PTHR31561:SF74', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369453, 'PTHR31561:SF70', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369454, 'PTHR31561:SF76', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE 13-RELATED', 246797),
(369455, 'PTHR31561:SF78', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE 8', 246797),
(369456, 'PTHR31561:SF79', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369457, 'PTHR31561:SF149', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369458, 'PTHR31561:SF148', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369459, 'PTHR31561:SF144', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369460, 'PTHR31561:SF146', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369461, 'PTHR31561:SF141', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369462, 'PTHR31561:SF140', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369463, 'PTHR31561:SF143', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369464, 'PTHR31561:SF142', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369465, 'PTHR31561', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369466, 'PTHR31561:SF65', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369467, 'PTHR31561:SF156', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369468, 'PTHR31561:SF155', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369469, 'PTHR31561:SF158', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369470, 'PTHR31561:SF157', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN 3-OXOACYL-COA SYNTHASE', 246797),
(369471, 'PTHR31561:SF151', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369472, 'PTHR31561:SF153', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369473, 'PTHR31561:SF167', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369474, 'PTHR31561:SF200', NULL, NULL, NULL, NULL, 'FAE DOMAIN-CONTAINING PROTEIN', 246797),
(369475, 'PTHR31561:SF166', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369476, 'PTHR31561:SF169', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369477, 'PTHR31561:SF168', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369478, 'PTHR31561:SF201', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369479, 'PTHR31561:SF162', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN 3-OXOACYL-COA SYNTHASE', 246797),
(369480, 'PTHR31561:SF165', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369481, 'PTHR31561:SF177', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369482, 'PTHR31561:SF174', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369483, 'PTHR31561:SF173', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369484, 'PTHR31561:SF176', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369485, 'PTHR31561:SF170', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369486, 'PTHR31561:SF172', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369487, 'PTHR31561:SF171', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', 246797),
(369488, 'PTHR35471:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 246798),
(369489, 'PTHR35471:SF1', NULL, NULL, NULL, NULL, 'OS07G0223700 PROTEIN', 246798),
(369490, 'PTHR35471', NULL, NULL, NULL, NULL, 'OS07G0223700 PROTEIN', 246798);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(369491, 'PTHR35863:SF1', NULL, NULL, NULL, NULL, 'COBALT-PRECORRIN-5B C(1)-METHYLTRANSFERASE', 246799),
(369492, 'PTHR35863', NULL, NULL, NULL, NULL, 'COBALT-PRECORRIN-5B C(1)-METHYLTRANSFERASE', 246799),
(369493, 'PTHR46697:SF1', NULL, NULL, NULL, NULL, 'FORMIN-BINDING PROTEIN 4', 246800),
(369494, 'PTHR46697', NULL, NULL, NULL, NULL, 'FORMIN-BINDING PROTEIN 4', 246800),
(369495, 'PTHR38601:SF1', NULL, NULL, NULL, NULL, 'HYDROGENASE-4 COMPONENT E', 246801),
(369496, 'PTHR38601', NULL, NULL, NULL, NULL, 'HYDROGENASE-4 COMPONENT E', 246801),
(369497, 'PTHR21091', NULL, NULL, NULL, NULL, 'METHYLTETRAHYDROFOLATE:HOMOCYSTEINE METHYLTRANSFERASE RELATED', 246802),
(369498, 'PTHR21091:SF169', NULL, NULL, NULL, NULL, 'UROPORPHYRINOGEN DECARBOXYLASE', 246802),
(369499, 'PTHR21091:SF167', NULL, NULL, NULL, NULL, 'UROPORPHYRINOGEN DECARBOXYLASE 1, CHLOROPLASTIC', 246802),
(369500, 'PTHR21091:SF174', NULL, NULL, NULL, NULL, 'UROPORPHYRINOGEN DECARBOXYLASE', 246802),
(369501, 'PTHR21091:SF173', NULL, NULL, NULL, NULL, 'UROPORPHYRINOGEN_DECOASE DOMAIN-CONTAINING PROTEIN', 246802),
(369502, 'PTHR42696', NULL, NULL, NULL, NULL, 'ASPARTATE AMMONIA-LYASE', 246803),
(369503, 'PTHR42696:SF2', NULL, NULL, NULL, NULL, 'ASPARTATE AMMONIA-LYASE', 246803),
(369504, 'PTHR16950:SF16', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER ZIP13', 246804),
(369505, 'PTHR16950:SF17', NULL, NULL, NULL, NULL, 'ZRT (ZRT), IRT-(IRT-) LIKE PROTEIN TRANSPORTER', 246804),
(369506, 'PTHR16950:SF18', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER ZIPT-7.1', 246804),
(369507, 'PTHR16950', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER SLC39A7  HISTIDINE-RICH MEMBRANE PROTEIN KE4', 246804),
(369508, 'PTHR16950:SF25', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER SLC39A7', 246804),
(369509, 'PTHR46818:SF1', NULL, NULL, NULL, NULL, 'CRAL_TRIO_N DOMAIN-CONTAINING PROTEIN', 246805),
(369510, 'PTHR46818', NULL, NULL, NULL, NULL, 'DOMAIN-CONTAINING PROTEIN, PUTATIVE-RELATED', 246805),
(369511, 'PTHR43685:SF11', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE TAGX-RELATED', 246806),
(369512, 'PTHR43685:SF10', NULL, NULL, NULL, NULL, 'LACTO-N-NEOTETRAOSE BIOSYNTHESIS GLYCOSYL TRANSFERASE LGTA', 246806),
(369513, 'PTHR43685:SF3', NULL, NULL, NULL, NULL, 'SLR2126 PROTEIN', 246806),
(369514, 'PTHR43685:SF5', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE EPSE-RELATED', 246806),
(369515, 'PTHR43685:SF2', NULL, NULL, NULL, NULL, 'GLYCO_TRANS_2-LIKE DOMAIN-CONTAINING PROTEIN', 246806),
(369516, 'PTHR43685:SF14', NULL, NULL, NULL, NULL, 'GLYCO_TRANS_2-LIKE DOMAIN-CONTAINING PROTEIN', 246806),
(369517, 'PTHR43685:SF13', NULL, NULL, NULL, NULL, 'O ANTIGEN BIOSYNTHESIS RHAMNOSYLTRANSFERASE RFBN', 246806),
(369518, 'PTHR43685', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 246806),
(369519, 'PTHR43685:SF12', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE FAMILY 2', 246806),
(369520, 'PTHR10104:SF20', NULL, NULL, NULL, NULL, 'STATHMIN DOMAIN-CONTAINING PROTEIN 1', 246807),
(369521, 'PTHR10104', NULL, NULL, NULL, NULL, 'STATHMIN', 246807),
(369522, 'PTHR10104:SF1', NULL, NULL, NULL, NULL, 'STATHMIN, ISOFORM D', 246807),
(369523, 'PTHR10104:SF5', NULL, NULL, NULL, NULL, 'STATHMIN', 246807),
(369524, 'PTHR10104:SF6', NULL, NULL, NULL, NULL, 'STATHMIN-4', 246807),
(369525, 'PTHR10104:SF17', NULL, NULL, NULL, NULL, 'STATHMIN-3', 246807),
(369526, 'PTHR10104:SF18', NULL, NULL, NULL, NULL, 'STATHMIN-2', 246807),
(369527, 'PTHR23240:SF33', NULL, NULL, NULL, NULL, '', 246808),
(369528, 'PTHR23240:SF34', NULL, NULL, NULL, NULL, 'STERILE ALPHA MOTIF (SAM) DOMAIN-CONTAINING PROTEIN', 246808),
(369529, 'PTHR23240:SF31', NULL, NULL, NULL, NULL, 'DNA REPAIR METALLO-BETA-LACTAMASE FAMILY PROTEIN', 246808),
(369530, 'PTHR23240:SF32', NULL, NULL, NULL, NULL, 'BNAA10G17350D PROTEIN', 246808),
(369531, 'PTHR23240', NULL, NULL, NULL, NULL, 'DNA CROSS-LINK REPAIR PROTEIN PSO2/SNM1-RELATED', 246808),
(369532, 'PTHR23240:SF8', NULL, NULL, NULL, NULL, 'PROTEIN ARTEMIS', 246808),
(369533, 'PTHR23240:SF6', NULL, NULL, NULL, NULL, 'DNA CROSS-LINK REPAIR 1A PROTEIN', 246808),
(369534, 'PTHR23240:SF29', NULL, NULL, NULL, NULL, 'OS08G0107600 PROTEIN', 246808);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(369535, 'PTHR23240:SF26', NULL, NULL, NULL, NULL, '5'' EXONUCLEASE APOLLO', 246808),
(369536, 'PTHR23240:SF35', NULL, NULL, NULL, NULL, 'DNA LIGASE 6-LIKE', 246808),
(369537, 'PTHR47443', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASES (NAT) SUPERFAMILY PROTEIN', 246809),
(369538, 'PTHR47443:SF3', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASES (NAT) SUPERFAMILY PROTEIN', 246809),
(369539, 'PTHR35008', NULL, NULL, NULL, NULL, 'BLL4482 PROTEIN-RELATED', 246810),
(369540, 'PTHR35008:SF4', NULL, NULL, NULL, NULL, 'SOXD PROTEIN', 246810),
(369541, 'PTHR35008:SF8', NULL, NULL, NULL, NULL, 'BLL4482 PROTEIN', 246810),
(369542, 'PTHR47101:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE CYTIDYLYLTRANSFERASE 4, CHLOROPLASTIC', 246811),
(369543, 'PTHR47101', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE CYTIDYLYLTRANSFERASE 5, CHLOROPLASTIC', 246811),
(369544, 'PTHR47101:SF5', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE CYTIDYLYLTRANSFERASE 5, CHLOROPLASTIC', 246811),
(369545, 'PTHR33356:SF16', NULL, NULL, NULL, NULL, 'G PATCH DOMAIN PROTEIN', 246812),
(369546, 'PTHR33356:SF27', NULL, NULL, NULL, NULL, 'BNACNNG53800D PROTEIN', 246812),
(369547, 'PTHR33356:SF17', NULL, NULL, NULL, NULL, 'H/ACA RIBONUCLEOPROTEIN COMPLEX NON-CORE SUBUNIT NAF1-LIKE', 246812),
(369548, 'PTHR33356:SF29', NULL, NULL, NULL, NULL, '', 246812),
(369549, 'PTHR33356:SF19', NULL, NULL, NULL, NULL, 'BNAC03G30580D PROTEIN', 246812),
(369550, 'PTHR33356:SF12', NULL, NULL, NULL, NULL, '', 246812),
(369551, 'PTHR33356:SF34', NULL, NULL, NULL, NULL, '', 246812),
(369552, 'PTHR33356:SF23', NULL, NULL, NULL, NULL, 'BNAC06G15000D PROTEIN', 246812),
(369553, 'PTHR33356:SF13', NULL, NULL, NULL, NULL, '', 246812),
(369554, 'PTHR33356:SF15', NULL, NULL, NULL, NULL, 'BNAC04G05510D PROTEIN', 246812),
(369555, 'PTHR33356:SF30', NULL, NULL, NULL, NULL, '', 246812),
(369556, 'PTHR33356:SF31', NULL, NULL, NULL, NULL, 'BNAA10G12250D PROTEIN', 246812),
(369557, 'PTHR33356:SF21', NULL, NULL, NULL, NULL, 'BNAC09G00250D PROTEIN', 246812),
(369558, 'PTHR33356:SF32', NULL, NULL, NULL, NULL, '', 246812),
(369559, 'PTHR33356:SF33', NULL, NULL, NULL, NULL, '', 246812),
(369560, 'PTHR33356:SF5', NULL, NULL, NULL, NULL, 'TIP41-LIKE PROTEIN', 246812),
(369561, 'PTHR33356', NULL, NULL, NULL, NULL, 'TIP41-LIKE PROTEIN', 246812),
(369562, 'PTHR17068', NULL, NULL, NULL, NULL, 'MYELOID-ASSOCIATED DIFFERENTIATION MARKER MYADM FAMILY MEMBER', 246813),
(369563, 'PTHR17068:SF2', NULL, NULL, NULL, NULL, 'ZGC:77748', 246813),
(369564, 'PTHR17068:SF16', NULL, NULL, NULL, NULL, '', 246813),
(369565, 'PTHR17068:SF3', NULL, NULL, NULL, NULL, 'MYELOID-ASSOCIATED DIFFERENTIATION MARKER', 246813),
(369566, 'PTHR17068:SF15', NULL, NULL, NULL, NULL, '', 246813),
(369567, 'PTHR17068:SF5', NULL, NULL, NULL, NULL, 'MYELOID-ASSOCIATED DIFFERENTIATION MARKER-LIKE PROTEIN 2', 246813),
(369568, 'PTHR17068:SF12', NULL, NULL, NULL, NULL, 'MARVEL DOMAIN-CONTAINING PROTEIN', 246813),
(369569, 'PTHR17068:SF11', NULL, NULL, NULL, NULL, '', 246813),
(369570, 'PTHR45625:SF6', NULL, NULL, NULL, NULL, 'SPLICEOSOME-ASSOCIATED PROTEIN CWC27 HOMOLOG', 246814),
(369571, 'PTHR45625:SF16', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246814),
(369572, 'PTHR45625:SF3', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE B-RELATED', 246814),
(369573, 'PTHR45625', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE-RELATED', 246814),
(369574, 'PTHR45625:SF17', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246814),
(369575, 'PTHR45625:SF4', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE DOMAIN AND WD REPEAT-CONTAINING PROTEIN 1', 246814),
(369576, 'PTHR45625:SF7', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE-LIKE 1', 246814),
(369577, 'PTHR45625:SF8', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246814),
(369578, 'PTHR45625:SF1', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN-PROTEIN LIGASE PPIL2', 246814),
(369579, 'PTHR45625:SF2', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE-LIKE 3', 246814),
(369580, 'PTHR45625:SF12', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246814);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(369581, 'PTHR43305', NULL, NULL, NULL, NULL, 'FAMILY N-ACETYLTRANSFERASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G01380)-RELATED', 246815),
(369582, 'PTHR43305:SF1', NULL, NULL, NULL, NULL, 'FAMILY N-ACETYLTRANSFERASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G01380)-RELATED', 246815),
(369583, 'PTHR43075:SF1', NULL, NULL, NULL, NULL, 'FORMATE LYASE ACTIVATING ENZYME, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G15630)-RELATED', 246816),
(369584, 'PTHR43075', NULL, NULL, NULL, NULL, 'FORMATE LYASE ACTIVATING ENZYME, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G15630)-RELATED', 246816),
(369585, 'PTHR11403:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME BO(3) UBIQUINOL OXIDASE SUBUNIT 3', 246817),
(369586, 'PTHR11403', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT III', 246817),
(369587, 'PTHR11403:SF10', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE', 246817),
(369588, 'PTHR11403:SF9', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 3', 246817),
(369589, 'PTHR11403:SF6', NULL, NULL, NULL, NULL, 'NITRIC OXIDE REDUCTASE SUBUNIT E', 246817),
(369590, 'PTHR11403:SF7', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 3', 246817),
(369591, 'PTHR36047:SF1', NULL, NULL, NULL, NULL, 'OS01G0191000 PROTEIN', 246818),
(369592, 'PTHR36047', NULL, NULL, NULL, NULL, 'OS01G0191000 PROTEIN', 246818),
(369593, 'PTHR34780:SF7', NULL, NULL, NULL, NULL, 'BNAC02G17680D PROTEIN', 246819),
(369594, 'PTHR34780:SF8', NULL, NULL, NULL, NULL, '', 246819),
(369595, 'PTHR34780:SF5', NULL, NULL, NULL, NULL, 'OS02G0733900 PROTEIN', 246819),
(369596, 'PTHR34780:SF6', NULL, NULL, NULL, NULL, 'BNAANNG06500D PROTEIN', 246819),
(369597, 'PTHR34780:SF10', NULL, NULL, NULL, NULL, 'OS08G0427800 PROTEIN', 246819),
(369598, 'PTHR34780', NULL, NULL, NULL, NULL, 'OS08G0427800 PROTEIN', 246819),
(369599, 'PTHR34780:SF4', NULL, NULL, NULL, NULL, 'BNAA08G19180D PROTEIN', 246819),
(369600, 'PTHR34780:SF2', NULL, NULL, NULL, NULL, 'BNAA07G38580D PROTEIN', 246819),
(369601, 'PTHR32470:SF2', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX ASSEMBLY FACTOR 2', 246820),
(369602, 'PTHR32470', NULL, NULL, NULL, NULL, 'ADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX ASSEMBLY FACTOR 2', 246820),
(369603, 'PTHR45829:SF4', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CARRIER PROTEIN RIM2', 246821),
(369604, 'PTHR45829:SF3', NULL, NULL, NULL, NULL, '', 246821),
(369605, 'PTHR45829:SF2', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 25 MEMBER 36', 246821),
(369606, 'PTHR45829:SF1', NULL, NULL, NULL, NULL, 'CARRIER PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G06780)-RELATED', 246821),
(369607, 'PTHR45829', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CARRIER PROTEIN RIM2', 246821),
(369608, 'PTHR45829:SF5', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 25 MEMBER 33', 246821),
(369609, 'PTHR40257:SF1', NULL, NULL, NULL, NULL, 'BLR0911 PROTEIN', 246822),
(369610, 'PTHR40257', NULL, NULL, NULL, NULL, '', 246822),
(369611, 'PTHR30175:SF1', NULL, NULL, NULL, NULL, 'PTS SYSTEM ARBUTIN-, CELLOBIOSE-, AND SALICIN-SPECIFIC EIIBC COMPONENT-RELATED', 246823),
(369612, 'PTHR30175:SF4', NULL, NULL, NULL, NULL, 'PTS SYSTEM TREHALOSE-SPECIFIC EIIBC COMPONENT', 246823),
(369613, 'PTHR30175:SF3', NULL, NULL, NULL, NULL, 'PTS SYSTEM N-ACETYLMURAMIC ACID-SPECIFIC EIIBC COMPONENT', 246823),
(369614, 'PTHR30175', NULL, NULL, NULL, NULL, 'PHOSPHOTRANSFERASE SYSTEM TRANSPORT PROTEIN', 246823),
(369615, 'PTHR30175:SF7', NULL, NULL, NULL, NULL, 'NEGATIVE REGULATOR OF SACY ACTIVITY', 246823),
(369616, 'PTHR44083:SF54', NULL, NULL, NULL, NULL, 'LISSENCEPHALY TYPE-1-LIKE HOMOLOGY MOTIF_ CTLH, C-TERMINAL TO LISH MOTIF_ NITROUS OXIDE REDUCTASE, N-TERMINAL_ WD40-LIKE_ QUINONPROTEIN ALCOHOL DEHYDROGENASE-LIKE', 246824),
(369617, 'PTHR44083:SF43', NULL, NULL, NULL, NULL, 'TRANSDUCIN FAMILY PROTEIN/WD-40 REPEAT PROTEIN', 246824),
(369618, 'PTHR44083:SF53', NULL, NULL, NULL, NULL, '', 246824),
(369619, 'PTHR44083:SF52', NULL, NULL, NULL, NULL, 'TOPLESS-LIKE PROTEIN', 246824),
(369620, 'PTHR44083:SF30', NULL, NULL, NULL, NULL, 'TOPLESS-LIKE PROTEIN', 246824),
(369621, 'PTHR44083:SF19', NULL, NULL, NULL, NULL, 'LIS1 HOMOLOGY MOTIF PROTEIN-RELATED', 246824);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(369622, 'PTHR44083:SF9', NULL, NULL, NULL, NULL, 'BNAA06G10370D PROTEIN', 246824),
(369623, 'PTHR44083', NULL, NULL, NULL, NULL, 'TOPLESS-RELATED PROTEIN 1-RELATED', 246824),
(369624, 'PTHR44083:SF5', NULL, NULL, NULL, NULL, 'PROTEIN TOPLESS-RELATED PROTEIN 2', 246824),
(369625, 'PTHR44083:SF14', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 246824),
(369626, 'PTHR44083:SF36', NULL, NULL, NULL, NULL, 'LIS1 HOMOLOGY MOTIF PROTEIN-RELATED', 246824),
(369627, 'PTHR44083:SF35', NULL, NULL, NULL, NULL, 'TOPLESS-RELATED PROTEIN 1-LIKE ISOFORM X1', 246824),
(369628, 'PTHR44083:SF24', NULL, NULL, NULL, NULL, 'TOPLESS-RELATED PROTEIN 2', 246824),
(369629, 'PTHR44083:SF46', NULL, NULL, NULL, NULL, 'TOPLESS-RELATED PROTEIN 1-LIKE ISOFORM X1', 246824),
(369630, 'PTHR44083:SF45', NULL, NULL, NULL, NULL, 'TOPLESS-RELATED PROTEIN 1', 246824),
(369631, 'PTHR44083:SF55', NULL, NULL, NULL, NULL, 'BNAA01G28410D PROTEIN', 246824),
(369632, 'PTHR44083:SF22', NULL, NULL, NULL, NULL, 'PROTEIN TPR3-LIKE', 246824),
(369633, 'PTHR44083:SF17', NULL, NULL, NULL, NULL, 'TRANSDUCIN FAMILY PROTEIN / WD-40 REPEAT FAMILY PROTEIN', 246824),
(369634, 'PTHR44083:SF49', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 246824),
(369635, 'PTHR44083:SF16', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 246824),
(369636, 'PTHR44083:SF27', NULL, NULL, NULL, NULL, 'PROTEIN TOPLESS', 246824),
(369637, 'PTHR44083:SF2', NULL, NULL, NULL, NULL, 'TOPLESS-RELATED PROTEIN 3', 246824),
(369638, 'PTHR44083:SF48', NULL, NULL, NULL, NULL, 'TOPLESS-RELATED PROTEIN 4', 246824),
(369639, 'PTHR34566:SF2', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN', 246825),
(369640, 'PTHR34566:SF5', NULL, NULL, NULL, NULL, '', 246825),
(369641, 'PTHR34566:SF6', NULL, NULL, NULL, NULL, 'OS09G0530700 PROTEIN', 246825),
(369642, 'PTHR34566', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN', 246825),
(369643, 'PTHR30008:SF0', NULL, NULL, NULL, NULL, 'EXODEOXYRIBONUCLEASE 7 LARGE SUBUNIT', 246826),
(369644, 'PTHR30008', NULL, NULL, NULL, NULL, 'EXODEOXYRIBONUCLEASE 7 LARGE SUBUNIT', 246826),
(369645, 'PTHR37244:SF1', NULL, NULL, NULL, NULL, 'NADP-SPECIFIC GLUTAMATE DEHYDROGENASE', 246827),
(369646, 'PTHR37244', NULL, NULL, NULL, NULL, 'NADP-SPECIFIC GLUTAMATE DEHYDROGENASE', 246827),
(369647, 'PTHR45745', NULL, NULL, NULL, NULL, 'PHOSPHOMANNOMUTASE 45A', 246828),
(369648, 'PTHR45745:SF2', NULL, NULL, NULL, NULL, 'GLUCOSE 1,6-BISPHOSPHATE SYNTHASE', 246828),
(369649, 'PTHR45745:SF3', NULL, NULL, NULL, NULL, 'PHOSPHOGLUCOMUTASE-2', 246828),
(369650, 'PTHR45745:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOGLUCOMUTASE 2A-RELATED', 246828),
(369651, 'PTHR37036:SF2', NULL, NULL, NULL, NULL, 'LMO0863 PROTEIN', 246829),
(369652, 'PTHR37036', NULL, NULL, NULL, NULL, '', 246829),
(369653, 'PTHR45995:SF5', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246830),
(369654, 'PTHR45995:SF3', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 246830),
(369655, 'PTHR45995:SF2', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE NIMA-INTERACTING 4', 246830),
(369656, 'PTHR45995:SF1', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE NIMA-INTERACTING 4', 246830),
(369657, 'PTHR45995', NULL, NULL, NULL, NULL, '', 246830),
(369658, 'PTHR44133:SF2', NULL, NULL, NULL, NULL, 'CLEAVAGE STIMULATION FACTOR SUBUNIT 1', 246831),
(369659, 'PTHR44133', NULL, NULL, NULL, NULL, 'CLEAVAGE STIMULATION FACTOR SUBUNIT 1', 246831),
(369660, 'PTHR31339:SF4', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN', 246832),
(369661, 'PTHR31339:SF5', NULL, NULL, NULL, NULL, 'HYDROLASE FAMILY 28 PROTEIN, PUTATIVE, EXPRESSED-RELATED', 246832),
(369662, 'PTHR31339:SF0', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN', 246832),
(369663, 'PTHR31339:SF3', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN', 246832),
(369664, 'PTHR31339:SF73', NULL, NULL, NULL, NULL, 'BNAA01G13460D PROTEIN', 246832),
(369665, 'PTHR31339:SF51', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE/GLYCOSIDE HYDROLASE FAMILY PROTEIN', 246832);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(369666, 'PTHR31339:SF54', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN', 246832),
(369667, 'PTHR31339:SF76', NULL, NULL, NULL, NULL, 'BNAA09G39690D PROTEIN', 246832),
(369668, 'PTHR31339:SF75', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 246832),
(369669, 'PTHR31339:SF70', NULL, NULL, NULL, NULL, 'PLASMIN AND FIBRONECTIN-BINDING PROTEIN A', 246832),
(369670, 'PTHR31339:SF9', NULL, NULL, NULL, NULL, 'HYDROLASE FAMILY 28 PROTEIN, PUTATIVE, EXPRESSED-RELATED', 246832),
(369671, 'PTHR31339:SF50', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN', 246832),
(369672, 'PTHR31339:SF72', NULL, NULL, NULL, NULL, 'BNAA02G30650D PROTEIN', 246832),
(369673, 'PTHR31339:SF71', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN', 246832),
(369674, 'PTHR31339:SF49', NULL, NULL, NULL, NULL, 'BNAC06G13740D PROTEIN', 246832),
(369675, 'PTHR31339:SF48', NULL, NULL, NULL, NULL, 'PECTIN LYASE SUPERFAMILY PROTEIN', 246832),
(369676, 'PTHR31339:SF44', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN', 246832),
(369677, 'PTHR31339:SF66', NULL, NULL, NULL, NULL, 'OS06G0106800 PROTEIN', 246832),
(369678, 'PTHR31339:SF69', NULL, NULL, NULL, NULL, 'BNAA09G39410D PROTEIN', 246832),
(369679, 'PTHR31339:SF68', NULL, NULL, NULL, NULL, 'OS09G0439400 PROTEIN', 246832),
(369680, 'PTHR31339:SF46', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE-RELATED', 246832),
(369681, 'PTHR31339:SF85', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE-RELATED', 246832),
(369682, 'PTHR31339:SF62', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE-RELATED', 246832),
(369683, 'PTHR31339:SF84', NULL, NULL, NULL, NULL, 'BNAA05G32060D PROTEIN', 246832),
(369684, 'PTHR31339:SF65', NULL, NULL, NULL, NULL, '', 246832),
(369685, 'PTHR31339:SF20', NULL, NULL, NULL, NULL, 'OS07G0245200 PROTEIN', 246832),
(369686, 'PTHR31339:SF81', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE-RELATED', 246832),
(369687, 'PTHR31339:SF80', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE', 246832),
(369688, 'PTHR31339:SF61', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE/GLYCOSIDE HYDROLASE FAMILY PROTEIN', 246832),
(369689, 'PTHR31339:SF83', NULL, NULL, NULL, NULL, 'OS03G0124900 PROTEIN', 246832),
(369690, 'PTHR31339:SF60', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE/GLYCOSIDE HYDROLASE FAMILY PROTEIN', 246832),
(369691, 'PTHR31339:SF82', NULL, NULL, NULL, NULL, '', 246832),
(369692, 'PTHR31339:SF16', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN', 246832),
(369693, 'PTHR31339:SF15', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN', 246832),
(369694, 'PTHR31339:SF59', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE-RELATED', 246832),
(369695, 'PTHR31339:SF78', NULL, NULL, NULL, NULL, 'BNAA06G16130D PROTEIN', 246832),
(369696, 'PTHR31339:SF12', NULL, NULL, NULL, NULL, 'ENDO-POLYGALACTURONASE-LIKE PROTEIN', 246832),
(369697, 'PTHR31339', NULL, NULL, NULL, NULL, 'PECTIN LYASE-RELATED', 246832),
(369698, 'PTHR31339:SF56', NULL, NULL, NULL, NULL, 'PECTIN LYASE-LIKE SUPERFAMILY PROTEIN', 246832),
(369699, 'PTHR31339:SF55', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE FAMILY 28 PROTEIN/POLYGALACTURONASE FAMILY PROTEIN', 246832),
(369700, 'PTHR31339:SF77', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE, FAMILY 28, PECTIN LYASE FOLD/VIRULENCE FACTOR-RELATED', 246832),
(369701, 'PTHR31339:SF58', NULL, NULL, NULL, NULL, 'OS05G0587000 PROTEIN', 246832),
(369702, 'PTHR31339:SF79', NULL, NULL, NULL, NULL, 'SMALL RNA 2''-O-METHYLTRANSFERASE', 246832),
(369703, 'PTHR48007', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE PXC1', 246833),
(369704, 'PTHR48007:SF39', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246833),
(369705, 'PTHR48007:SF37', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 246833),
(369706, 'PTHR48007:SF38', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 246833),
(369707, 'PTHR48007:SF35', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246833),
(369708, 'PTHR48007:SF36', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN KINASE-LIKE PROTEIN ZAR1', 246833);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(369709, 'PTHR48007:SF33', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246833),
(369710, 'PTHR48007:SF34', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246833),
(369711, 'PTHR48007:SF31', NULL, NULL, NULL, NULL, 'STRUBBELIG FAMILY RECEPTOR PROTEIN KINASE-RELATED', 246833),
(369712, 'PTHR48007:SF32', NULL, NULL, NULL, NULL, 'KINASE-LIKE PROTEIN TMKL1-RELATED', 246833),
(369713, 'PTHR48007:SF73', NULL, NULL, NULL, NULL, 'OS07G0251900 PROTEIN', 246833),
(369714, 'PTHR48007:SF30', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246833),
(369715, 'PTHR48007:SF71', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE', 246833),
(369716, 'PTHR48007:SF72', NULL, NULL, NULL, NULL, 'POLLEN RECEPTOR-LIKE KINASE 2', 246833),
(369717, 'PTHR48007:SF70', NULL, NULL, NULL, NULL, 'PROTEIN STRUBBELIG-RECEPTOR FAMILY 1', 246833),
(369718, 'PTHR48007:SF28', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246833),
(369719, 'PTHR48007:SF29', NULL, NULL, NULL, NULL, 'POLLEN RECEPTOR-LIKE KINASE 3', 246833),
(369720, 'PTHR48007:SF68', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246833),
(369721, 'PTHR48007:SF24', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246833),
(369722, 'PTHR48007:SF25', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 246833),
(369723, 'PTHR48007:SF69', NULL, NULL, NULL, NULL, 'POLLEN RECEPTOR-LIKE KINASE 4', 246833),
(369724, 'PTHR48007:SF66', NULL, NULL, NULL, NULL, 'BNAA01G05970D PROTEIN', 246833),
(369725, 'PTHR48007:SF22', NULL, NULL, NULL, NULL, 'PROTEIN STRUBBELIG-RECEPTOR FAMILY 3 ISOFORM X1', 246833),
(369726, 'PTHR48007:SF23', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246833),
(369727, 'PTHR48007:SF67', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE', 246833),
(369728, 'PTHR48007:SF64', NULL, NULL, NULL, NULL, 'POLLEN RECEPTOR-LIKE KINASE 1', 246833),
(369729, 'PTHR48007:SF20', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE', 246833),
(369730, 'PTHR48007:SF65', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE FLS2', 246833),
(369731, 'PTHR48007:SF63', NULL, NULL, NULL, NULL, 'POLLEN RECEPTOR-LIKE KINASE 6', 246833),
(369732, 'PTHR48007:SF60', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246833),
(369733, 'PTHR48007:SF9', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246833),
(369734, 'PTHR48007:SF8', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246833),
(369735, 'PTHR48007:SF19', NULL, NULL, NULL, NULL, 'POLLEN RECEPTOR-LIKE KINASE 5', 246833),
(369736, 'PTHR48007:SF17', NULL, NULL, NULL, NULL, 'POLLEN RECEPTOR-LIKE KINASE 3', 246833),
(369737, 'PTHR48007:SF15', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN-RELATED', 246833),
(369738, 'PTHR48007:SF16', NULL, NULL, NULL, NULL, 'POLLEN RECEPTOR-LIKE KINASE 1 ISOFORM X1', 246833),
(369739, 'PTHR48007:SF57', NULL, NULL, NULL, NULL, 'OS03G0145102 PROTEIN', 246833),
(369740, 'PTHR48007:SF13', NULL, NULL, NULL, NULL, 'PROTEIN STRUBBELIG-RECEPTOR FAMILY 4', 246833),
(369741, 'PTHR48007:SF58', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE', 246833),
(369742, 'PTHR48007:SF14', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246833),
(369743, 'PTHR48007:SF55', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246833),
(369744, 'PTHR48007:SF11', NULL, NULL, NULL, NULL, 'OS11G0620500 PROTEIN', 246833),
(369745, 'PTHR48007:SF56', NULL, NULL, NULL, NULL, 'PROTEIN STRUBBELIG-RECEPTOR FAMILY 2 ISOFORM X1', 246833),
(369746, 'PTHR48007:SF3', NULL, NULL, NULL, NULL, 'PROTEIN STRUBBELIG-RECEPTOR FAMILY 1', 246833),
(369747, 'PTHR48007:SF53', NULL, NULL, NULL, NULL, 'OS01G0711200 PROTEIN', 246833),
(369748, 'PTHR48007:SF10', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246833),
(369749, 'PTHR48007:SF54', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 246833);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(369750, 'PTHR48007:SF1', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE', 246833),
(369751, 'PTHR48007:SF50', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246833),
(369752, 'PTHR48007:SF6', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE', 246833),
(369753, 'PTHR48007:SF4', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE PXC1', 246833),
(369754, 'PTHR48007:SF49', NULL, NULL, NULL, NULL, 'OS08G0521200 PROTEIN', 246833),
(369755, 'PTHR48007:SF47', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 246833),
(369756, 'PTHR48007:SF43', NULL, NULL, NULL, NULL, 'POLLEN RECEPTOR-LIKE KINASE 4', 246833),
(369757, 'PTHR48007:SF40', NULL, NULL, NULL, NULL, 'POLLEN RECEPTOR-LIKE KINASE 4', 246833),
(369758, 'PTHR48200:SF1', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 246834),
(369759, 'PTHR48200', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 246834),
(369760, 'PTHR11627:SF64', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE 2, CHLOROPLASTIC', 246835),
(369761, 'PTHR11627:SF20', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE 5, CYTOSOLIC-RELATED', 246835),
(369762, 'PTHR11627:SF42', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE 8, CYTOSOLIC', 246835),
(369763, 'PTHR11627:SF65', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE', 246835),
(369764, 'PTHR11627:SF63', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE', 246835),
(369765, 'PTHR11627:SF60', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE', 246835),
(369766, 'PTHR11627:SF80', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE', 246835),
(369767, 'PTHR11627:SF59', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE', 246835),
(369768, 'PTHR11627:SF16', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE, CHLOROPLASTIC', 246835),
(369769, 'PTHR11627:SF79', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE 6, CYTOSOLIC', 246835),
(369770, 'PTHR11627:SF9', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE 2', 246835),
(369771, 'PTHR11627:SF58', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE', 246835),
(369772, 'PTHR11627:SF77', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE', 246835),
(369773, 'PTHR11627:SF56', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE 4, CYTOSOLIC', 246835),
(369774, 'PTHR11627:SF78', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE', 246835),
(369775, 'PTHR11627:SF1', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE A', 246835),
(369776, 'PTHR11627:SF3', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE C', 246835),
(369777, 'PTHR11627:SF2', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE B', 246835),
(369778, 'PTHR11627:SF53', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE', 246835),
(369779, 'PTHR11627:SF75', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE 3, CHLOROPLASTIC', 246835),
(369780, 'PTHR11627:SF76', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE', 246835),
(369781, 'PTHR11627:SF51', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE', 246835),
(369782, 'PTHR11627:SF74', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE', 246835),
(369783, 'PTHR11627:SF52', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE', 246835),
(369784, 'PTHR11627:SF71', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE', 246835),
(369785, 'PTHR11627:SF72', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE', 246835),
(369786, 'PTHR11627:SF70', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE', 246835),
(369787, 'PTHR11627', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE', 246835),
(369788, 'PTHR11627:SF49', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE', 246835),
(369789, 'PTHR11627:SF68', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE 1, CHLOROPLASTIC', 246835),
(369790, 'PTHR11627:SF69', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE', 246835),
(369791, 'PTHR15188', NULL, NULL, NULL, NULL, 'C-X-C MOTIF CHEMOKINE 14', 246836),
(369792, 'PTHR15188:SF0', NULL, NULL, NULL, NULL, 'C-X-C MOTIF CHEMOKINE 14', 246836);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(369793, 'PTHR23519:SF4', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN', 246837),
(369794, 'PTHR23519:SF3', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 22-2', 246837),
(369795, 'PTHR23519', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 22', 246837),
(369796, 'PTHR23519:SF5', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN', 246837),
(369797, 'PTHR23519:SF2', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 22', 246837),
(369798, 'PTHR23519:SF1', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 22', 246837),
(369799, 'PTHR12290', NULL, NULL, NULL, NULL, 'CORNICHON-RELATED', 246838),
(369800, 'PTHR12290:SF19', NULL, NULL, NULL, NULL, 'PROTEIN CORNICHON HOMOLOG 4', 246838),
(369801, 'PTHR12290:SF18', NULL, NULL, NULL, NULL, 'PROTEIN CORNICHON HOMOLOG 4', 246838),
(369802, 'PTHR12290:SF39', NULL, NULL, NULL, NULL, 'PROTEIN CORNICHON HOMOLOG 4-LIKE', 246838),
(369803, 'PTHR12290:SF37', NULL, NULL, NULL, NULL, 'BNAA10G27390D PROTEIN', 246838),
(369804, 'PTHR12290:SF36', NULL, NULL, NULL, NULL, 'BNAA03G54690D PROTEIN', 246838),
(369805, 'PTHR12290:SF13', NULL, NULL, NULL, NULL, 'PROTEIN CORNICHON HOMOLOG 2', 246838),
(369806, 'PTHR12290:SF35', NULL, NULL, NULL, NULL, 'BNAC05G09440D PROTEIN', 246838),
(369807, 'PTHR12290:SF2', NULL, NULL, NULL, NULL, 'PHOSPHOPANTOTHENATE--CYSTEINE LIGASE', 246838),
(369808, 'PTHR12290:SF12', NULL, NULL, NULL, NULL, 'PROTEIN CORNICHON HOMOLOG 3', 246838),
(369809, 'PTHR12290:SF11', NULL, NULL, NULL, NULL, 'PROTEIN CORNICHON', 246838),
(369810, 'PTHR12290:SF32', NULL, NULL, NULL, NULL, 'CORNICHON-RELATED', 246838),
(369811, 'PTHR12290:SF10', NULL, NULL, NULL, NULL, 'PROTEIN CORNICHON HOMOLOG 1', 246838),
(369812, 'PTHR12290:SF40', NULL, NULL, NULL, NULL, 'PROTEIN CORNICHON HOMOLOG 4-LIKE', 246838),
(369813, 'PTHR12290:SF29', NULL, NULL, NULL, NULL, 'PROTEIN CORNICHON HOMOLOG 5', 246838),
(369814, 'PTHR12290:SF27', NULL, NULL, NULL, NULL, 'CORNICHON FAMILY PROTEIN', 246838),
(369815, 'PTHR12290:SF26', NULL, NULL, NULL, NULL, 'PROTEIN CORNICHON HOMOLOG 4-LIKE', 246838),
(369816, 'PTHR12290:SF25', NULL, NULL, NULL, NULL, 'PROTEIN CORNICHON HOMOLOG 4-LIKE', 246838),
(369817, 'PTHR12290:SF46', NULL, NULL, NULL, NULL, 'PHOSPHOPANTOTHENATE--CYSTEINE LIGASE 1', 246838),
(369818, 'PTHR12290:SF24', NULL, NULL, NULL, NULL, 'PROTEIN CORNICHON HOMOLOG 3', 246838),
(369819, 'PTHR12290:SF45', NULL, NULL, NULL, NULL, 'PROTEIN CORNICHON HOMOLOG 2-RELATED', 246838),
(369820, 'PTHR12290:SF44', NULL, NULL, NULL, NULL, 'CORNICHON FAMILY PROTEIN-RELATED', 246838),
(369821, 'PTHR12290:SF22', NULL, NULL, NULL, NULL, 'CORNICHON FAMILY PROTEIN', 246838),
(369822, 'PTHR12290:SF43', NULL, NULL, NULL, NULL, '', 246838),
(369823, 'PTHR12290:SF20', NULL, NULL, NULL, NULL, 'PHOSPHOPANTOTHENATE--CYSTEINE LIGASE 2-LIKE ISOFORM X1', 246838),
(369824, 'PTHR46001:SF4', NULL, NULL, NULL, NULL, 'TIAM RAC1-ASSOCIATED GEF 1B', 246839),
(369825, 'PTHR46001:SF5', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR TIAM2', 246839),
(369826, 'PTHR46001', NULL, NULL, NULL, NULL, 'TIAM (MAMMALIAN TUMOR INVASION AND METASTASIS FACTOR) HOMOLOG', 246839),
(369827, 'PTHR46001:SF1', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR TIAM1', 246839),
(369828, 'PTHR46001:SF2', NULL, NULL, NULL, NULL, 'DH DOMAIN-CONTAINING PROTEIN', 246839),
(369829, 'PTHR46001:SF3', NULL, NULL, NULL, NULL, 'PROTEIN STILL LIFE, ISOFORM SIF TYPE 1', 246839),
(369830, 'PTHR13292:SF2', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 101', 246840),
(369831, 'PTHR13292', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 246840),
(369832, 'PTHR13292:SF0', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 101', 246840),
(369833, 'PTHR13292:SF1', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 101', 246840),
(369834, 'PTHR10812:SF15', NULL, NULL, NULL, NULL, 'TF_AP-2 DOMAIN-CONTAINING PROTEIN', 246841),
(369835, 'PTHR10812', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR AP-2', 246841),
(369836, 'PTHR10812:SF14', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR AP-2-BETA', 246841),
(369837, 'PTHR10812:SF17', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR AP-2, ISOFORM D', 246841);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(369838, 'PTHR10812:SF16', NULL, NULL, NULL, NULL, 'TF_AP-2 DOMAIN-CONTAINING PROTEIN', 246841),
(369839, 'PTHR10812:SF9', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR AP-2 GAMMA', 246841),
(369840, 'PTHR10812:SF13', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR AP-2-EPSILON', 246841),
(369841, 'PTHR10812:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR AP-2-DELTA', 246841),
(369842, 'PTHR10812:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR AP-2-ALPHA', 246841),
(369843, 'PTHR10812:SF18', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR AP-2 BETA', 246841),
(369844, 'PTHR19384:SF17', NULL, NULL, NULL, NULL, 'NADPH--CYTOCHROME P450 REDUCTASE', 246842),
(369845, 'PTHR19384:SF128', NULL, NULL, NULL, NULL, 'NADPH OXIDOREDUCTASE A', 246842),
(369846, 'PTHR19384:SF117', NULL, NULL, NULL, NULL, 'NADPH--CYTOCHROME P450 REDUCTASE', 246842),
(369847, 'PTHR19384:SF56', NULL, NULL, NULL, NULL, 'NITRIC OXIDE SYNTHASE, INDUCIBLE', 246842),
(369848, 'PTHR19384:SF66', NULL, NULL, NULL, NULL, 'NITRIC OXIDE SYNTHASE, ENDOTHELIAL', 246842),
(369849, 'PTHR19384:SF127', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL CYTOCHROME P450/NADPH--P450 REDUCTASE', 246842),
(369850, 'PTHR19384:SF115', NULL, NULL, NULL, NULL, 'NADPH--CYTOCHROME P450 REDUCTASE', 246842),
(369851, 'PTHR19384:SF126', NULL, NULL, NULL, NULL, 'NADPH--CYTOCHROME P450 REDUCTASE 2', 246842),
(369852, 'PTHR19384:SF114', NULL, NULL, NULL, NULL, 'NADPH--CYTOCHROME P450 REDUCTASE', 246842),
(369853, 'PTHR19384:SF125', NULL, NULL, NULL, NULL, 'P450 REDUCTASE, PUTATIVE-RELATED', 246842),
(369854, 'PTHR19384:SF63', NULL, NULL, NULL, NULL, 'NITRIC OXIDE SYNTHASE, BRAIN', 246842),
(369855, 'PTHR19384:SF109', NULL, NULL, NULL, NULL, 'SULFITE REDUCTASE [NADPH] FLAVOPROTEIN COMPONENT', 246842),
(369856, 'PTHR19384:SF84', NULL, NULL, NULL, NULL, 'METHIONINE SYNTHASE REDUCTASE', 246842),
(369857, 'PTHR19384:SF108', NULL, NULL, NULL, NULL, 'NADPH--CYTOCHROME P450 REDUCTASE', 246842),
(369858, 'PTHR19384:SF76', NULL, NULL, NULL, NULL, 'NITRIC OXIDE SYNTHASE', 246842),
(369859, 'PTHR19384:SF10', NULL, NULL, NULL, NULL, 'NADPH-DEPENDENT DIFLAVIN OXIDOREDUCTASE 1', 246842),
(369860, 'PTHR19384:SF107', NULL, NULL, NULL, NULL, 'NADPH--CYTOCHROME P450 REDUCTASE 1', 246842),
(369861, 'PTHR19384:SF124', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 246842),
(369862, 'PTHR19384:SF113', NULL, NULL, NULL, NULL, 'FAD-BINDING FR-TYPE DOMAIN-CONTAINING PROTEIN', 246842),
(369863, 'PTHR19384:SF123', NULL, NULL, NULL, NULL, 'NADPH--CYTOCHROME P450 REDUCTASE', 246842),
(369864, 'PTHR19384:SF111', NULL, NULL, NULL, NULL, 'NADPH--CYTOCHROME P450 REDUCTASE 1', 246842),
(369865, 'PTHR19384', NULL, NULL, NULL, NULL, 'NITRIC OXIDE SYNTHASE-RELATED', 246842),
(369866, 'PTHR12143:SF25', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G10790)-RELATED', 246843),
(369867, 'PTHR12143:SF44', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_92 DOMAIN-CONTAINING PROTEIN', 246843),
(369868, 'PTHR12143:SF23', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 246843),
(369869, 'PTHR12143:SF42', NULL, NULL, NULL, NULL, 'PUTATIVE SUBFAMILY (AFU_ORTHOLOGUE AFUA_6G13760)-RELATED', 246843),
(369870, 'PTHR12143:SF43', NULL, NULL, NULL, NULL, 'SECRETED ATP/GTP BINDING PROTEIN-RELATED', 246843),
(369871, 'PTHR12143:SF19', NULL, NULL, NULL, NULL, 'PEPTIDE-N(4)-(N-ACETYL-BETA-GLUCOSAMINYL)ASPARAGINE AMIDASE', 246843),
(369872, 'PTHR12143', NULL, NULL, NULL, NULL, 'PEPTIDE N-GLYCANASE  PNGASE -RELATED', 246843),
(369873, 'PTHR12143:SF39', NULL, NULL, NULL, NULL, 'SECRETED PROTEIN-RELATED', 246843),
(369874, 'PTHR12143:SF38', NULL, NULL, NULL, NULL, 'ALPHA-1,2-MANNOSIDASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_5G10520)', 246843),
(369875, 'PTHR12143:SF27', NULL, NULL, NULL, NULL, 'ALPHA-1,2-MANNOSIDASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_5G10520)', 246843),
(369876, 'PTHR36021:SF1', NULL, NULL, NULL, NULL, 'COREPRESSOR', 246844),
(369877, 'PTHR36021:SF3', NULL, NULL, NULL, NULL, 'BNAC04G03090D PROTEIN', 246844),
(369878, 'PTHR36021', NULL, NULL, NULL, NULL, 'COREPRESSOR', 246844),
(369879, 'PTHR12840:SF1', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 BETA SUBCOMPLEX SUBUNIT 8, MITOCHONDRIAL', 246845);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(369880, 'PTHR12840', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE ASHI SUBUNIT', 246845),
(369881, 'PTHR12840:SF3', NULL, NULL, NULL, NULL, '', 246845),
(369882, 'PTHR12840:SF2', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 BETA SUBCOMPLEX SUBUNIT 8, MITOCHONDRIAL', 246845),
(369883, 'PTHR31071:SF2', NULL, NULL, NULL, NULL, 'ACTIN CYTOSKELETON-REGULATORY COMPLEX PAN-LIKE PROTEIN', 246846),
(369884, 'PTHR31071', NULL, NULL, NULL, NULL, 'GB|AAF24581.1', 246846),
(369885, 'PTHR31071:SF42', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 30-LIKE', 246846),
(369886, 'PTHR31071:SF7', NULL, NULL, NULL, NULL, 'PLANT/F24K9-26 PROTEIN', 246846),
(369887, 'PTHR31071:SF60', NULL, NULL, NULL, NULL, 'BNAC04G01010D PROTEIN', 246846),
(369888, 'PTHR31071:SF8', NULL, NULL, NULL, NULL, 'INTRACELLULAR PROTEIN TRANSPORT PROTEIN USO1-RELATED', 246846),
(369889, 'PTHR31071:SF9', NULL, NULL, NULL, NULL, 'INTRACELLULAR PROTEIN TRANSPORT PROTEIN USO1-RELATED', 246846),
(369890, 'PTHR31071:SF61', NULL, NULL, NULL, NULL, 'BNACNNG57260D PROTEIN', 246846),
(369891, 'PTHR31071:SF49', NULL, NULL, NULL, NULL, '', 246846),
(369892, 'PTHR31071:SF45', NULL, NULL, NULL, NULL, 'BRANCHLESS TRICHOME-LIKE PROTEIN', 246846),
(369893, 'PTHR31071:SF47', NULL, NULL, NULL, NULL, 'PARAMYOSIN-LIKE', 246846),
(369894, 'PTHR31071:SF48', NULL, NULL, NULL, NULL, 'OS04G0625000 PROTEIN', 246846),
(369895, 'PTHR31071:SF53', NULL, NULL, NULL, NULL, 'BNAA08G31660D PROTEIN', 246846),
(369896, 'PTHR31071:SF32', NULL, NULL, NULL, NULL, 'OS07G0102200 PROTEIN', 246846),
(369897, 'PTHR31071:SF54', NULL, NULL, NULL, NULL, '', 246846),
(369898, 'PTHR31071:SF55', NULL, NULL, NULL, NULL, '', 246846),
(369899, 'PTHR31071:SF51', NULL, NULL, NULL, NULL, 'F11F12.2-LIKE PROTEIN', 246846),
(369900, 'PTHR31071:SF16', NULL, NULL, NULL, NULL, 'OS02G0506100 PROTEIN', 246846),
(369901, 'PTHR31071:SF38', NULL, NULL, NULL, NULL, 'INTRACELLULAR PROTEIN TRANSPORT PROTEIN USO1-LIKE PROTEIN', 246846),
(369902, 'PTHR31071:SF39', NULL, NULL, NULL, NULL, 'PROTEIN BRANCHLESS TRICHOME', 246846),
(369903, 'PTHR31071:SF34', NULL, NULL, NULL, NULL, 'ACTIN CYTOSKELETON-REGULATORY COMPLEX PAN-LIKE PROTEIN', 246846),
(369904, 'PTHR31071:SF12', NULL, NULL, NULL, NULL, 'OS08G0190700 PROTEIN', 246846),
(369905, 'PTHR31071:SF36', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN-RELATED', 246846),
(369906, 'PTHR31071:SF14', NULL, NULL, NULL, NULL, '', 246846),
(369907, 'PTHR31071:SF58', NULL, NULL, NULL, NULL, 'OS04G0382800 PROTEIN', 246846),
(369908, 'PTHR31071:SF59', NULL, NULL, NULL, NULL, 'INTRACELLULAR PROTEIN TRANSPORTER USO1-LIKE PROTEIN', 246846),
(369909, 'PTHR13683:SF839', NULL, NULL, NULL, NULL, 'ASPARTYL PROTEASE AED3-LIKE', 246847),
(369910, 'PTHR13683:SF716', NULL, NULL, NULL, NULL, 'OS06G0119600 PROTEIN', 246847),
(369911, 'PTHR13683:SF838', NULL, NULL, NULL, NULL, 'PROTEIN ASPARTIC PROTEASE IN GUARD CELL 2-LIKE', 246847),
(369912, 'PTHR13683:SF710', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(369913, 'PTHR13683:SF677', NULL, NULL, NULL, NULL, 'PROTEIN ASPARTIC PROTEASE IN GUARD CELL 1-LIKE', 246847),
(369914, 'PTHR13683:SF798', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(369915, 'PTHR13683:SF799', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(369916, 'PTHR13683:SF796', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 246847),
(369917, 'PTHR13683:SF797', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE NEPENTHESIN-2-LIKE', 246847),
(369918, 'PTHR13683:SF830', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(369919, 'PTHR13683:SF835', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE NEPENTHESIN-2', 246847),
(369920, 'PTHR13683:SF836', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE-LIKE PROTEIN 2', 246847),
(369921, 'PTHR13683:SF316', NULL, NULL, NULL, NULL, 'ASPARTYL PROTEASE APCB1', 246847),
(369922, 'PTHR13683:SF712', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(369923, 'PTHR13683:SF679', NULL, NULL, NULL, NULL, 'ASPARTYL PROTEASE FAMILY PROTEIN 2', 246847);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(369924, 'PTHR13683:SF834', NULL, NULL, NULL, NULL, 'ASPARTIC PEPTIDASE A1 FAMILY-RELATED', 246847),
(369925, 'PTHR13683:SF790', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(369926, 'PTHR13683:SF274', NULL, NULL, NULL, NULL, 'PROTEIN ASPARTIC PROTEASE IN GUARD CELL 1', 246847),
(369927, 'PTHR13683:SF794', NULL, NULL, NULL, NULL, 'ASPARTIC PEPTIDASE A1 FAMILY-RELATED', 246847),
(369928, 'PTHR13683:SF398', NULL, NULL, NULL, NULL, 'ASPARTYL PROTEASE AED1-LIKE', 246847),
(369929, 'PTHR13683:SF795', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(369930, 'PTHR13683:SF276', NULL, NULL, NULL, NULL, 'OS04G0535200 PROTEIN', 246847),
(369931, 'PTHR13683:SF793', NULL, NULL, NULL, NULL, 'OS06G0268700 PROTEIN', 246847),
(369932, 'PTHR13683:SF828', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(369933, 'PTHR13683:SF829', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 246847),
(369934, 'PTHR13683:SF826', NULL, NULL, NULL, NULL, 'ASPARTYL PROTEASE FAMILY PROTEIN 1', 246847),
(369935, 'PTHR13683:SF827', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(369936, 'PTHR13683:SF820', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(369937, 'PTHR13683:SF667', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 246847),
(369938, 'PTHR13683:SF664', NULL, NULL, NULL, NULL, 'OS05G0203912 PROTEIN', 246847),
(369939, 'PTHR13683:SF703', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(369940, 'PTHR13683:SF824', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(369941, 'PTHR13683:SF704', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 246847),
(369942, 'PTHR13683:SF825', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(369943, 'PTHR13683:SF822', NULL, NULL, NULL, NULL, 'ASPARTIC PEPTIDASE A1 FAMILY, ASPARTIC PEPTIDASE DOMAIN PROTEIN-RELATED', 246847),
(369944, 'PTHR13683:SF669', NULL, NULL, NULL, NULL, 'ASPARTYL PROTEASE AED1', 246847),
(369945, 'PTHR13683:SF823', NULL, NULL, NULL, NULL, 'ASPARTIC PEPTIDASE A1 FAMILY-RELATED', 246847),
(369946, 'PTHR13683:SF783', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 246847),
(369947, 'PTHR13683:SF661', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE 36', 246847),
(369948, 'PTHR13683:SF265', NULL, NULL, NULL, NULL, 'PROTEIN ASPARTIC PROTEASE IN GUARD CELL 2', 246847),
(369949, 'PTHR13683:SF618', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE-LIKE PROTEIN 2', 246847),
(369950, 'PTHR13683:SF336', NULL, NULL, NULL, NULL, 'OS06G0121800 PROTEIN', 246847),
(369951, 'PTHR13683:SF852', NULL, NULL, NULL, NULL, 'OS09G0482200 PROTEIN', 246847),
(369952, 'PTHR13683:SF858', NULL, NULL, NULL, NULL, 'OS02G0473200 PROTEIN', 246847),
(369953, 'PTHR13683:SF338', NULL, NULL, NULL, NULL, 'OS01G0720000 PROTEIN', 246847),
(369954, 'PTHR13683:SF855', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(369955, 'PTHR13683:SF856', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 246847),
(369956, 'PTHR13683:SF339', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(369957, 'PTHR13683:SF850', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(369958, 'PTHR13683:SF330', NULL, NULL, NULL, NULL, 'OS06G0118700 PROTEIN', 246847),
(369959, 'PTHR13683:SF331', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE ASP1', 246847),
(369960, 'PTHR13683:SF609', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(369961, 'PTHR13683:SF848', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(369962, 'PTHR13683:SF607', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(369963, 'PTHR13683:SF840', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(369964, 'PTHR13683:SF846', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(369965, 'PTHR13683:SF605', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 246847),
(369966, 'PTHR13683:SF844', NULL, NULL, NULL, NULL, 'ASPARTYL PROTEASE AED1', 246847),
(369967, 'PTHR13683:SF724', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(369968, 'PTHR13683:SF845', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(369969, 'PTHR13683:SF680', NULL, NULL, NULL, NULL, 'PROTEASE FAMILY PROTEIN, PUTATIVE-RELATED', 246847),
(369970, 'PTHR13683:SF685', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 246847),
(369971, 'PTHR13683:SF875', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 246847),
(369972, 'PTHR13683:SF634', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE 39', 246847),
(369973, 'PTHR13683:SF876', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(369974, 'PTHR13683:SF873', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(369975, 'PTHR13683:SF874', NULL, NULL, NULL, NULL, 'ASPARTYL PROTEASE FAMILY PROTEIN 2-LIKE', 246847),
(369976, 'PTHR13683:SF632', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE NEPENTHESIN-2', 246847),
(369977, 'PTHR13683:SF879', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 246847),
(369978, 'PTHR13683:SF638', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE NEPENTHESIN-2', 246847),
(369979, 'PTHR13683:SF877', NULL, NULL, NULL, NULL, 'PROTEIN ASPARTIC PROTEASE IN GUARD CELL 1-LIKE', 246847),
(369980, 'PTHR13683:SF878', NULL, NULL, NULL, NULL, 'ASPARTYL PROTEASE FAMILY PROTEIN 2-LIKE', 246847),
(369981, 'PTHR13683:SF750', NULL, NULL, NULL, NULL, 'ASPARTYL PROTEASE AED1', 246847),
(369982, 'PTHR13683:SF871', NULL, NULL, NULL, NULL, 'OS06G0717900 PROTEIN', 246847),
(369983, 'PTHR13683:SF596', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 246847),
(369984, 'PTHR13683:SF872', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE ASP1-LIKE ISOFORM X1', 246847),
(369985, 'PTHR13683:SF751', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 246847),
(369986, 'PTHR13683:SF630', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE NEPENTHESIN-2-LIKE', 246847),
(369987, 'PTHR13683:SF870', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(369988, 'PTHR13683:SF232', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(369989, 'PTHR13683:SF749', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 246847),
(369990, 'PTHR13683:SF622', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE NEPENTHESIN-2', 246847),
(369991, 'PTHR13683:SF743', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE-LIKE PROTEIN 1', 246847),
(369992, 'PTHR13683:SF227', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 246847),
(369993, 'PTHR13683:SF869', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(369994, 'PTHR13683:SF748', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(369995, 'PTHR13683:SF746', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(369996, 'PTHR13683', NULL, NULL, NULL, NULL, 'ASPARTYL PROTEASES', 246847),
(369997, 'PTHR13683:SF817', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 246847),
(369998, 'PTHR13683:SF818', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(369999, 'PTHR13683:SF815', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(370000, 'PTHR13683:SF816', NULL, NULL, NULL, NULL, 'ASPARTYL PROTEASE FAMILY PROTEIN 1-LIKE', 246847),
(370001, 'PTHR13683:SF810', NULL, NULL, NULL, NULL, 'ASPARTIC PEPTIDASE A1 FAMILY-RELATED', 246847),
(370002, 'PTHR13683:SF774', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 246847),
(370003, 'PTHR13683:SF775', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 246847),
(370004, 'PTHR13683:SF813', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(370005, 'PTHR13683:SF814', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE ASP1-LIKE', 246847),
(370006, 'PTHR13683:SF811', NULL, NULL, NULL, NULL, 'OS02G0314600 PROTEIN', 246847),
(370007, 'PTHR13683:SF812', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(370008, 'PTHR13683:SF890', NULL, NULL, NULL, NULL, 'ASPARTYL PROTEASE FAMILY PROTEIN, PUTATIVE-RELATED', 246847),
(370009, 'PTHR13683:SF893', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 246847),
(370010, 'PTHR13683:SF891', NULL, NULL, NULL, NULL, 'PROTEIN ASPARTIC PROTEASE IN GUARD CELL 2-LIKE', 246847),
(370011, 'PTHR13683:SF375', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(370012, 'PTHR13683:SF892', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(370013, 'PTHR13683:SF806', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 246847),
(370014, 'PTHR13683:SF808', NULL, NULL, NULL, NULL, 'ASPARTYL PROTEASE AED1', 246847),
(370015, 'PTHR13683:SF809', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(370016, 'PTHR13683:SF886', NULL, NULL, NULL, NULL, 'OS01G0598600 PROTEIN', 246847),
(370017, 'PTHR13683:SF887', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE-LIKE PROTEIN 2', 246847),
(370018, 'PTHR13683:SF884', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 246847),
(370019, 'PTHR13683:SF764', NULL, NULL, NULL, NULL, 'ASPARTYL PROTEASE AED1', 246847),
(370020, 'PTHR13683:SF885', NULL, NULL, NULL, NULL, 'ASPARTYL PROTEASE AED1', 246847),
(370021, 'PTHR13683:SF802', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(370022, 'PTHR13683:SF888', NULL, NULL, NULL, NULL, 'TAXI_N DOMAIN-CONTAINING PROTEIN', 246847),
(370023, 'PTHR13683:SF800', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 246847),
(370024, 'PTHR13683:SF889', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEASE IN GUARD CELL-LIKE PROTEIN', 246847),
(370025, 'PTHR13683:SF768', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 246847),
(370026, 'PTHR13683:SF801', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(370027, 'PTHR13683:SF882', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE-LIKE PROTEIN 2', 246847),
(370028, 'PTHR13683:SF883', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE-LIKE PROTEIN 2', 246847),
(370029, 'PTHR13683:SF762', NULL, NULL, NULL, NULL, 'OS02G0720600 PROTEIN', 246847),
(370030, 'PTHR13683:SF880', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 246847),
(370031, 'PTHR13683:SF881', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 246847),
(370032, 'PTHR47831:SF1', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR II-I REPEAT DOMAIN-CONTAINING PROTEIN 2A-RELATED', 246848),
(370033, 'PTHR47831', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR II-I REPEAT DOMAIN-CONTAINING PROTEIN 2', 246848),
(370034, 'PTHR12722:SF3', NULL, NULL, NULL, NULL, 'BNAA04G11980D PROTEIN', 246849),
(370035, 'PTHR12722:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAM50B', 246849),
(370036, 'PTHR12722:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM50A', 246849),
(370037, 'PTHR12722:SF0', NULL, NULL, NULL, NULL, 'PROTEIN FAM50A', 246849),
(370038, 'PTHR12722', NULL, NULL, NULL, NULL, 'XAP-5 PROTEIN-RELATED', 246849),
(370039, 'PTHR42954:SF1', NULL, NULL, NULL, NULL, 'FEOA DOMAIN-CONTAINING PROTEIN', 246850),
(370040, 'PTHR42954:SF2', NULL, NULL, NULL, NULL, 'FE(2+) TRANSPORT PROTEIN A', 246850),
(370041, 'PTHR42954', NULL, NULL, NULL, NULL, 'FE(2+) TRANSPORT PROTEIN A', 246850),
(370042, 'PTHR20986', NULL, NULL, NULL, NULL, 'FMRFAMIDE-RELATED PEPTIDES', 246851),
(370043, 'PTHR20986:SF19', NULL, NULL, NULL, NULL, 'FMRFAMIDE-LIKE NEUROPEPTIDES 3', 246851),
(370044, 'PTHR20986:SF18', NULL, NULL, NULL, NULL, 'FMRF-LIKE PEPTIDE', 246851),
(370045, 'PTHR20986:SF17', NULL, NULL, NULL, NULL, 'FMRFAMIDE-LIKE NEUROPEPTIDE 18', 246851),
(370046, 'PTHR20986:SF16', NULL, NULL, NULL, NULL, 'FMRFAMIDE-LIKE NEUROPEPTIDES 7', 246851);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(370047, 'PTHR20986:SF15', NULL, NULL, NULL, NULL, 'FMRFAMIDE-LIKE NEUROPEPTIDES 13', 246851),
(370048, 'PTHR20986:SF14', NULL, NULL, NULL, NULL, 'FMRFAMIDE-LIKE NEUROPEPTIDES 6', 246851),
(370049, 'PTHR20986:SF13', NULL, NULL, NULL, NULL, 'FMRF-LIKE PEPTIDE', 246851),
(370050, 'PTHR20986:SF24', NULL, NULL, NULL, NULL, 'FMRFAMIDE-LIKE NEUROPEPTIDES 1', 246851),
(370051, 'PTHR20986:SF22', NULL, NULL, NULL, NULL, 'FMRFAMIDE-RELATED PEPTIDES', 246851),
(370052, 'PTHR20986:SF21', NULL, NULL, NULL, NULL, 'FMRFAMIDE-LIKE NEUROPEPTIDES 14', 246851),
(370053, 'PTHR14465', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN H', 246852),
(370054, 'PTHR14465:SF0', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN H', 246852),
(370055, 'PTHR37409:SF5', NULL, NULL, NULL, NULL, 'SI:CH73-160P18.3', 246853),
(370056, 'PTHR37409', NULL, NULL, NULL, NULL, 'RIKEN CDNA D130052B06 GENE', 246853),
(370057, 'PTHR37409:SF8', NULL, NULL, NULL, NULL, '', 246853),
(370058, 'PTHR37409:SF7', NULL, NULL, NULL, NULL, '', 246853),
(370059, 'PTHR37409:SF6', NULL, NULL, NULL, NULL, '', 246853),
(370060, 'PTHR43317:SF6', NULL, NULL, NULL, NULL, 'THERMOSPERMINE SYNTHASE ACAULIS5-LIKE', 246854),
(370061, 'PTHR43317:SF11', NULL, NULL, NULL, NULL, 'POLYAMINE AMINOPROPYLTRANSFERASE 2', 246854),
(370062, 'PTHR43317:SF10', NULL, NULL, NULL, NULL, 'PABS DOMAIN-CONTAINING PROTEIN', 246854),
(370063, 'PTHR43317:SF8', NULL, NULL, NULL, NULL, 'PABS DOMAIN-CONTAINING PROTEIN', 246854),
(370064, 'PTHR43317', NULL, NULL, NULL, NULL, 'THERMOSPERMINE SYNTHASE ACAULIS5', 246854),
(370065, 'PTHR43317:SF1', NULL, NULL, NULL, NULL, 'THERMOSPERMINE SYNTHASE ACAULIS5', 246854),
(370066, 'PTHR43317:SF3', NULL, NULL, NULL, NULL, 'BLR2883 PROTEIN', 246854),
(370067, 'PTHR43317:SF9', NULL, NULL, NULL, NULL, 'SPERMINE SYNTHASE', 246854),
(370068, 'PTHR33626', NULL, NULL, NULL, NULL, 'ZGC:158463', 246855),
(370069, 'PTHR33626:SF2', NULL, NULL, NULL, NULL, 'ZGC:158463', 246855),
(370070, 'PTHR31171', NULL, NULL, NULL, NULL, 'LY6/PLAUR DOMAIN-CONTAINING PROTEIN 6', 246856),
(370071, 'PTHR31171:SF0', NULL, NULL, NULL, NULL, 'LY6/PLAUR DOMAIN-CONTAINING PROTEIN 6', 246856),
(370072, 'PTHR31171:SF2', NULL, NULL, NULL, NULL, '', 246856),
(370073, 'PTHR31171:SF3', NULL, NULL, NULL, NULL, 'LY6/PLAUR DOMAIN-CONTAINING PROTEIN 6B', 246856),
(370074, 'PTHR38436:SF1', NULL, NULL, NULL, NULL, 'RHODANESE DOMAIN-CONTAINING PROTEIN', 246857),
(370075, 'PTHR38436:SF2', NULL, NULL, NULL, NULL, 'SNOAL-LIKE DOMAIN-CONTAINING PROTEIN', 246857),
(370076, 'PTHR38436:SF3', NULL, NULL, NULL, NULL, 'DIENELACTONE HYDROLASE (AFU_ORTHOLOGUE AFUA_2G05810)', 246857),
(370077, 'PTHR38436', NULL, NULL, NULL, NULL, 'POLYKETIDE CYCLASE SNOAL-LIKE DOMAIN', 246857),
(370078, 'PTHR12625', NULL, NULL, NULL, NULL, 'LIPOCALIN-1 INTERACTING MEMBRANE RECEPTOR  LIMR', 246858),
(370079, 'PTHR12625:SF1', NULL, NULL, NULL, NULL, 'LIMB REGION 1 PROTEIN HOMOLOG', 246858),
(370080, 'PTHR12625:SF2', NULL, NULL, NULL, NULL, 'PROTEIN LMBR1L', 246858),
(370081, 'PTHR12625:SF0', NULL, NULL, NULL, NULL, 'PROTEIN LILIPOD', 246858),
(370082, 'PTHR47583', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN', 246859),
(370083, 'PTHR47583:SF1', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN', 246859),
(370084, 'PTHR40380:SF1', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE-III DOMAIN-CONTAINING PROTEIN', 246860),
(370085, 'PTHR40380:SF2', NULL, NULL, NULL, NULL, '', 246860),
(370086, 'PTHR40380', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE-III DOMAIN-CONTAINING PROTEIN-RELATED', 246860),
(370087, 'PTHR12692:SF6', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE SUBUNIT 3B-RELATED', 246861),
(370088, 'PTHR12692:SF5', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE SUBUNIT 3B-RELATED', 246861),
(370089, 'PTHR12692:SF8', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE SUBUNIT 3-RELATED', 246861),
(370090, 'PTHR12692:SF7', NULL, NULL, NULL, NULL, 'BNAA08G25260D PROTEIN', 246861);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(370091, 'PTHR12692:SF0', NULL, NULL, NULL, NULL, 'GH11935P', 246861),
(370092, 'PTHR12692:SF2', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER PROTEIN 1', 246861),
(370093, 'PTHR12692', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE-RELATED', 246861),
(370094, 'PTHR12692:SF1', NULL, NULL, NULL, NULL, 'TUMOR SUPPRESSOR CANDIDATE 3', 246861),
(370095, 'PTHR12692:SF4', NULL, NULL, NULL, NULL, '', 246861),
(370096, 'PTHR12692:SF3', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE SUBUNIT OST6', 246861),
(370097, 'PTHR31288:SF5', NULL, NULL, NULL, NULL, 'PROTEIN MANNAN SYNTHESIS-RELATED 1', 246862),
(370098, 'PTHR31288:SF29', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 246862),
(370099, 'PTHR31288:SF27', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 4', 246862),
(370100, 'PTHR31288:SF28', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 246862),
(370101, 'PTHR31288:SF25', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 246862),
(370102, 'PTHR31288:SF36', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 246862),
(370103, 'PTHR31288:SF26', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 246862),
(370104, 'PTHR31288:SF23', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 246862),
(370105, 'PTHR31288:SF34', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 246862),
(370106, 'PTHR31288:SF24', NULL, NULL, NULL, NULL, 'PROTEIN MANNAN SYNTHESIS-RELATED 2', 246862),
(370107, 'PTHR31288:SF32', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 246862),
(370108, 'PTHR31288:SF10', NULL, NULL, NULL, NULL, 'PROTEIN ESMERALDA 1', 246862),
(370109, 'PTHR31288:SF22', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 9', 246862),
(370110, 'PTHR31288:SF8', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 10-RELATED', 246862),
(370111, 'PTHR31288:SF30', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 246862),
(370112, 'PTHR31288:SF20', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 246862),
(370113, 'PTHR31288:SF31', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 246862),
(370114, 'PTHR31288', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 246862),
(370115, 'PTHR10966', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIA SUBUNIT 2', 246863),
(370116, 'PTHR10966:SF4', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIA SUBUNIT 2', 246863),
(370117, 'PTHR10966:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIA GAMMA CHAIN', 246863),
(370118, 'PTHR10966:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIA SMALL CHAIN HOMOLOG', 246863),
(370119, 'PTHR10966:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIA SUBUNIT 2', 246863),
(370120, 'PTHR10966:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIA SUBUNIT 2', 246863),
(370121, 'PTHR10966:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIA SUBUNIT 2', 246863),
(370122, 'PTHR10966:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIA SUBUNIT 2', 246863),
(370123, 'PTHR10966:SF9', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIA, GAMMA SUBUNIT-RELATED', 246863),
(370124, 'PTHR10966:SF0', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIA SUBUNIT 2', 246863),
(370125, 'PTHR24363:SF6', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-BINDING KINASE FAMILY, MEMBER 3', 246864),
(370126, 'PTHR24363:SF5', NULL, NULL, NULL, NULL, 'SERINE/THREONINE KINASE-LIKE DOMAIN-CONTAINING PROTEIN STKLD1', 246864),
(370127, 'PTHR24363', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE', 246864),
(370128, 'PTHR24363:SF0', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0277989-RELATED', 246864),
(370129, 'PTHR33592:SF18', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 246865),
(370130, 'PTHR33592:SF9', NULL, NULL, NULL, NULL, 'BNAC04G42470D PROTEIN', 246865),
(370131, 'PTHR33592:SF6', NULL, NULL, NULL, NULL, '', 246865);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(370132, 'PTHR33592:SF14', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 246865),
(370133, 'PTHR33592:SF5', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 246865),
(370134, 'PTHR33592:SF16', NULL, NULL, NULL, NULL, '', 246865),
(370135, 'PTHR33592:SF8', NULL, NULL, NULL, NULL, 'BNAA10G04070D PROTEIN', 246865),
(370136, 'PTHR33592:SF17', NULL, NULL, NULL, NULL, '', 246865),
(370137, 'PTHR33592:SF7', NULL, NULL, NULL, NULL, 'MUCIN', 246865),
(370138, 'PTHR33592:SF10', NULL, NULL, NULL, NULL, '', 246865),
(370139, 'PTHR33592', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 246865),
(370140, 'PTHR33592:SF3', NULL, NULL, NULL, NULL, '', 246865),
(370141, 'PTHR14781', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 246866),
(370142, 'PTHR14781:SF0', NULL, NULL, NULL, NULL, 'INTRAFLAGELLAR TRANSPORT PROTEIN 56', 246866),
(370143, 'PTHR11935', NULL, NULL, NULL, NULL, 'BETA LACTAMASE DOMAIN', 246867),
(370144, 'PTHR11935:SF142', NULL, NULL, NULL, NULL, 'HYDROXYACYLGLUTATHIONE HYDROLASE 2, MITOCHONDRIAL', 246867),
(370145, 'PTHR11935:SF141', NULL, NULL, NULL, NULL, 'LACTAMASE_B DOMAIN-CONTAINING PROTEIN', 246867),
(370146, 'PTHR11935:SF77', NULL, NULL, NULL, NULL, 'HYDROXYACYLGLUTATHIONE HYDROLASE-LIKE PROTEIN', 246867),
(370147, 'PTHR11935:SF146', NULL, NULL, NULL, NULL, 'HYDROXYACYLGLUTATHIONE HYDROLASE', 246867),
(370148, 'PTHR11935:SF145', NULL, NULL, NULL, NULL, 'LACTAMASE_B DOMAIN-CONTAINING PROTEIN', 246867),
(370149, 'PTHR11935:SF144', NULL, NULL, NULL, NULL, 'HYDROXYACYLGLUTATHIONE HYDROLASE 1, MITOCHONDRIAL', 246867),
(370150, 'PTHR11935:SF139', NULL, NULL, NULL, NULL, 'HYDROLASE, PUTATIVE-RELATED', 246867),
(370151, 'PTHR11935:SF94', NULL, NULL, NULL, NULL, 'TENZING NORGAY, ISOFORM C', 246867),
(370152, 'PTHR11935:SF116', NULL, NULL, NULL, NULL, 'HYDROLASE PNKD-RELATED', 246867),
(370153, 'PTHR11935:SF80', NULL, NULL, NULL, NULL, 'HYDROXYACYLGLUTATHIONE HYDROLASE, MITOCHONDRIAL', 246867),
(370154, 'PTHR11935:SF7', NULL, NULL, NULL, NULL, 'HYDROXYACYLGLUTATHIONE HYDROLASE 2, CHLOROPLASTIC-RELATED', 246867),
(370155, 'PTHR21099:SF2', NULL, NULL, NULL, NULL, 'C3H1-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', 246868),
(370156, 'PTHR21099', NULL, NULL, NULL, NULL, 'RAD201', 246868),
(370157, 'PTHR12127:SF5', NULL, NULL, NULL, NULL, 'MUCOLIPIN-3', 246869),
(370158, 'PTHR12127:SF20', NULL, NULL, NULL, NULL, 'MUCOLIPIN 1.2', 246869),
(370159, 'PTHR12127:SF4', NULL, NULL, NULL, NULL, 'MUCOLIPIN-2', 246869),
(370160, 'PTHR12127:SF22', NULL, NULL, NULL, NULL, 'PKD_CHANNEL DOMAIN-CONTAINING PROTEIN', 246869),
(370161, 'PTHR12127', NULL, NULL, NULL, NULL, 'MUCOLIPIN', 246869),
(370162, 'PTHR12127:SF7', NULL, NULL, NULL, NULL, 'SD02261P', 246869),
(370163, 'PTHR12127:SF6', NULL, NULL, NULL, NULL, 'MUCOLIPIN-1', 246869),
(370164, 'PTHR16240:SF2', NULL, NULL, NULL, NULL, 'PROTEIN MENT', 246870),
(370165, 'PTHR16240', NULL, NULL, NULL, NULL, 'PROTEIN MENT', 246870),
(370166, 'PTHR12365:SF8', NULL, NULL, NULL, NULL, 'PROTEIN SPROUTY HOMOLOG 2', 246871),
(370167, 'PTHR12365:SF9', NULL, NULL, NULL, NULL, 'PROTEIN SPROUTY HOMOLOG 3', 246871),
(370168, 'PTHR12365', NULL, NULL, NULL, NULL, 'SPROUTY', 246871),
(370169, 'PTHR12365:SF6', NULL, NULL, NULL, NULL, 'PROTEIN SPROUTY HOMOLOG 4', 246871),
(370170, 'PTHR12365:SF7', NULL, NULL, NULL, NULL, 'PROTEIN SPROUTY', 246871),
(370171, 'PTHR12365:SF10', NULL, NULL, NULL, NULL, 'PROTEIN SPROUTY HOMOLOG 1', 246871),
(370172, 'PTHR36504', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE EXPORT SYSTEM PROTEIN LPTA', 246872),
(370173, 'PTHR36504:SF1', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE EXPORT SYSTEM PROTEIN LPTA', 246872),
(370174, 'PTHR46293:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN PROTEIN LIGASE DRIP1', 246873),
(370175, 'PTHR46293:SF2', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246873),
(370176, 'PTHR46293:SF3', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN PROTEIN LIGASE DRIPH-RELATED', 246873),
(370177, 'PTHR46293:SF4', NULL, NULL, NULL, NULL, 'OS03G0798200 PROTEIN', 246873),
(370178, 'PTHR46293:SF5', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN PROTEIN LIGASE DRIP2', 246873);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(370179, 'PTHR46293:SF7', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN PROTEIN LIGASE DRIP2', 246873),
(370180, 'PTHR46293:SF8', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN PROTEIN LIGASE DRIP2', 246873),
(370181, 'PTHR46293:SF14', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246873),
(370182, 'PTHR46293:SF9', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN PROTEIN LIGASE DRIP1-LIKE', 246873),
(370183, 'PTHR46293:SF10', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246873),
(370184, 'PTHR46293:SF11', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN', 246873),
(370185, 'PTHR46293:SF12', NULL, NULL, NULL, NULL, 'BNAA04G17680D PROTEIN', 246873),
(370186, 'PTHR46293:SF13', NULL, NULL, NULL, NULL, '', 246873),
(370187, 'PTHR46293', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN PROTEIN LIGASE DRIP1', 246873),
(370188, 'PTHR28665:SF1', NULL, NULL, NULL, NULL, 'BEN DOMAIN-CONTAINING PROTEIN 3', 246874),
(370189, 'PTHR28665', NULL, NULL, NULL, NULL, 'BEN DOMAIN-CONTAINING PROTEIN 3', 246874),
(370190, 'PTHR28547:SF1', NULL, NULL, NULL, NULL, 'PROTEIN MMS22-LIKE', 246875),
(370191, 'PTHR28547', NULL, NULL, NULL, NULL, 'PROTEIN MMS22-LIKE', 246875),
(370192, 'PTHR37540:SF10', NULL, NULL, NULL, NULL, 'SIGMA-70 REGION 2 FAMILY PROTEIN', 246876),
(370193, 'PTHR37540:SF11', NULL, NULL, NULL, NULL, 'ZN(2)-C6 FUNGAL-TYPE DOMAIN-CONTAINING PROTEIN', 246876),
(370194, 'PTHR37540', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR (ACR-2), PUTATIVE-RELATED-RELATED', 246876),
(370195, 'PTHR37540:SF9', NULL, NULL, NULL, NULL, '', 246876),
(370196, 'PTHR37540:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR (ACR-2), PUTATIVE-RELATED', 246876),
(370197, 'PTHR15874:SF1', NULL, NULL, NULL, NULL, 'NUCLEOLAR AND SPINDLE-ASSOCIATED PROTEIN 1', 246877),
(370198, 'PTHR15874', NULL, NULL, NULL, NULL, 'NUCLEOLAR AND SPINDLE-ASSOCIATED PROTEIN 1', 246877),
(370199, 'PTHR38452', NULL, NULL, NULL, NULL, 'UPF0756 MEMBRANE PROTEIN YEAL', 246878),
(370200, 'PTHR38452:SF1', NULL, NULL, NULL, NULL, 'UPF0756 MEMBRANE PROTEIN YEAL', 246878),
(370201, 'PTHR20937:SF3', NULL, NULL, NULL, NULL, 'IP14615P', 246879),
(370202, 'PTHR20937:SF18', NULL, NULL, NULL, NULL, 'MESODERM POSTERIOR B-RELATED', 246879),
(370203, 'PTHR20937:SF17', NULL, NULL, NULL, NULL, 'MESODERM POSTERIOR PROTEIN 2', 246879),
(370204, 'PTHR20937', NULL, NULL, NULL, NULL, 'IP14615P', 246879),
(370205, 'PTHR20937:SF6', NULL, NULL, NULL, NULL, 'MESODERM POSTERIOR PROTEIN 1', 246879),
(370206, 'PTHR20937:SF4', NULL, NULL, NULL, NULL, 'MESOGENIN-1', 246879),
(370207, 'PTHR31439:SF7', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246880),
(370208, 'PTHR31439', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246880),
(370209, 'PTHR31439:SF5', NULL, NULL, NULL, NULL, 'NEURONAL PAS DOMAIN PROTEIN', 246880),
(370210, 'PTHR31439:SF6', NULL, NULL, NULL, NULL, '', 246880),
(370211, 'PTHR31439:SF3', NULL, NULL, NULL, NULL, 'OS07G0231800 PROTEIN', 246880),
(370212, 'PTHR31439:SF4', NULL, NULL, NULL, NULL, 'NEURONAL PAS DOMAIN PROTEIN', 246880),
(370213, 'PTHR31922:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 215', 246881),
(370214, 'PTHR31922', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 215', 246881),
(370215, 'PTHR12138:SF129', NULL, NULL, NULL, NULL, 'LMO7 DOWNSTREAM NEIGHBOR PROTEIN', 246882),
(370216, 'PTHR12138:SF139', NULL, NULL, NULL, NULL, '', 246882),
(370217, 'PTHR12138:SF138', NULL, NULL, NULL, NULL, '', 246882),
(370218, 'PTHR12138:SF74', NULL, NULL, NULL, NULL, 'DOWN SYNDROME CRITICAL REGION PROTEIN 8', 246882),
(370219, 'PTHR12138:SF75', NULL, NULL, NULL, NULL, 'DUF4549 DOMAIN-CONTAINING PROTEIN', 246882),
(370220, 'PTHR12138:SF140', NULL, NULL, NULL, NULL, '', 246882),
(370221, 'PTHR12138:SF100', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN CONTAINING 122', 246882),
(370222, 'PTHR12138:SF133', NULL, NULL, NULL, NULL, '', 246882),
(370223, 'PTHR12138:SF144', NULL, NULL, NULL, NULL, 'CHROMOSOME 9 OPEN READING FRAME 37', 246882),
(370224, 'PTHR12138:SF143', NULL, NULL, NULL, NULL, 'PROTEIN PPP5D1', 246882),
(370225, 'PTHR12138:SF132', NULL, NULL, NULL, NULL, '', 246882);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(370226, 'PTHR12138', NULL, NULL, NULL, NULL, 'PRIMATE-EXPANDED PROTEIN FAMILY', 246882),
(370227, 'PTHR12138:SF131', NULL, NULL, NULL, NULL, '', 246882),
(370228, 'PTHR12138:SF142', NULL, NULL, NULL, NULL, '', 246882),
(370229, 'PTHR12138:SF141', NULL, NULL, NULL, NULL, '', 246882),
(370230, 'PTHR12138:SF130', NULL, NULL, NULL, NULL, '', 246882),
(370231, 'PTHR12138:SF137', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN CONTAINING 122', 246882),
(370232, 'PTHR12138:SF147', NULL, NULL, NULL, NULL, '', 246882),
(370233, 'PTHR12138:SF136', NULL, NULL, NULL, NULL, '', 246882),
(370234, 'PTHR12138:SF146', NULL, NULL, NULL, NULL, '', 246882),
(370235, 'PTHR12138:SF135', NULL, NULL, NULL, NULL, 'CHROMOSOME 14 OPEN READING FRAME 132', 246882),
(370236, 'PTHR12138:SF112', NULL, NULL, NULL, NULL, 'CHROMOSOME 14 OPEN READING FRAME 178', 246882),
(370237, 'PTHR12138:SF134', NULL, NULL, NULL, NULL, '', 246882),
(370238, 'PTHR12138:SF145', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ENSP00000375192', 246882),
(370239, 'PTHR47065:SF1', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING DOMAIN-CONTAINING PROTEIN 9', 246883),
(370240, 'PTHR47065', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING DOMAIN-CONTAINING PROTEIN 9', 246883),
(370241, 'PTHR23064:SF29', NULL, NULL, NULL, NULL, 'PARVALBUMIN-LIKE EF-HAND-CONTAINING PROTEIN', 246884),
(370242, 'PTHR23064:SF68', NULL, NULL, NULL, NULL, '', 246884),
(370243, 'PTHR23064:SF47', NULL, NULL, NULL, NULL, 'TROPONIN C, SLOW SKELETAL AND CARDIAC MUSCLES', 246884),
(370244, 'PTHR23064:SF69', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML1-RELATED', 246884),
(370245, 'PTHR23064:SF58', NULL, NULL, NULL, NULL, 'FAST SKELETAL MUSCLE TROPONIN C', 246884),
(370246, 'PTHR23064:SF75', NULL, NULL, NULL, NULL, 'EF HAND FAMILY PROTEIN', 246884),
(370247, 'PTHR23064:SF53', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML22-RELATED', 246884),
(370248, 'PTHR23064:SF31', NULL, NULL, NULL, NULL, 'CALMODULIN LIKE 6', 246884),
(370249, 'PTHR23064:SF76', NULL, NULL, NULL, NULL, 'CALCIUM BINDING PROTEIN HOMOLOG', 246884),
(370250, 'PTHR23064:SF32', NULL, NULL, NULL, NULL, 'CALTRACTIN ICL1F', 246884),
(370251, 'PTHR23064:SF21', NULL, NULL, NULL, NULL, 'TROPONIN C, SKELETAL MUSCLE', 246884),
(370252, 'PTHR23064:SF77', NULL, NULL, NULL, NULL, 'CALCIUM ION BINDING PROTEIN', 246884),
(370253, 'PTHR23064', NULL, NULL, NULL, NULL, 'TROPONIN', 246884),
(370254, 'PTHR23064:SF71', NULL, NULL, NULL, NULL, 'PROTEIN CBG15199', 246884),
(370255, 'PTHR23064:SF72', NULL, NULL, NULL, NULL, 'SARCOPLASMIC CALCIUM-BINDING PROTEIN, ISOFORM C', 246884),
(370256, 'PTHR23064:SF73', NULL, NULL, NULL, NULL, 'EF HAND FAMILY PROTEIN', 246884),
(370257, 'PTHR23064:SF62', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN PAIR-RELATED', 246884),
(370258, 'PTHR23064:SF74', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN PAIR-RELATED', 246884),
(370259, 'PTHR23064:SF70', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF-HAND FAMILY PROTEIN', 246884),
(370260, 'PTHR39198:SF1', NULL, NULL, NULL, NULL, 'NPCBM_ASSOC DOMAIN-CONTAINING PROTEIN', 246885),
(370261, 'PTHR39198', NULL, NULL, NULL, NULL, 'HYPOTHETICAL MEMBRANE PROTEIN, CONSERVED', 246885),
(370262, 'PTHR12450:SF22', NULL, NULL, NULL, NULL, 'EXTRACELLULAR SERINE/THREONINE PROTEIN CG31145', 246886),
(370263, 'PTHR12450:SF11', NULL, NULL, NULL, NULL, 'EXTRACELLULAR SERINE/THREONINE PROTEIN KINASE FAM20C', 246886),
(370264, 'PTHR12450:SF12', NULL, NULL, NULL, NULL, 'PSEUDOKINASE FAM20A', 246886),
(370265, 'PTHR12450:SF14', NULL, NULL, NULL, NULL, 'GLYCOSAMINOGLYCAN XYLOSYLKINASE', 246886),
(370266, 'PTHR12450:SF25', NULL, NULL, NULL, NULL, 'FAMILY WITH SEQUENCE SIMILARITY 20 MEMBER C,-LIKE', 246886),
(370267, 'PTHR12450', NULL, NULL, NULL, NULL, 'DENTIN MATRIX PROTEIN 4  PROTEIN FAM20', 246886),
(370268, 'PTHR23324:SF87', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN C34C12.6', 246887),
(370269, 'PTHR23324:SF66', NULL, NULL, NULL, NULL, 'PROTEIN REAL-TIME', 246887),
(370270, 'PTHR23324:SF88', NULL, NULL, NULL, NULL, 'CRAL/TRIO AND GOLD DOMAIN CONTAINING', 246887);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(370271, 'PTHR23324:SF41', NULL, NULL, NULL, NULL, 'SEC14-LIKE PROTEIN 6-RELATED', 246887),
(370272, 'PTHR23324:SF86', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 246887),
(370273, 'PTHR23324:SF42', NULL, NULL, NULL, NULL, 'SEC14-LIKE PROTEIN 4', 246887),
(370274, 'PTHR23324:SF83', NULL, NULL, NULL, NULL, 'RE68566P', 246887),
(370275, 'PTHR23324:SF62', NULL, NULL, NULL, NULL, 'SEC14-LIKE PROTEIN 3', 246887),
(370276, 'PTHR23324:SF84', NULL, NULL, NULL, NULL, '', 246887),
(370277, 'PTHR23324:SF51', NULL, NULL, NULL, NULL, 'SEC14-LIKE PROTEIN 1', 246887),
(370278, 'PTHR23324:SF7', NULL, NULL, NULL, NULL, 'CRAL/TRIO AND GOLD DOMAIN SUPPRESSOR OF ACTIVATED RAS', 246887),
(370279, 'PTHR23324', NULL, NULL, NULL, NULL, 'SEC14 RELATED PROTEIN', 246887),
(370280, 'PTHR23324:SF39', NULL, NULL, NULL, NULL, 'SEC14-LIKE PROTEIN 5', 246887),
(370281, 'PTHR23324:SF89', NULL, NULL, NULL, NULL, 'SEC14-LIKE PROTEIN 2', 246887),
(370282, 'PTHR10829:SF25', NULL, NULL, NULL, NULL, 'DREBRIN-LIKE PROTEIN', 246888),
(370283, 'PTHR10829:SF15', NULL, NULL, NULL, NULL, 'SRC SUBSTRATE CORTACTIN', 246888),
(370284, 'PTHR10829:SF12', NULL, NULL, NULL, NULL, 'DREBRIN-LIKE PROTEIN', 246888),
(370285, 'PTHR10829:SF23', NULL, NULL, NULL, NULL, 'CORTACTIN, ISOFORM A', 246888),
(370286, 'PTHR10829:SF1', NULL, NULL, NULL, NULL, 'DREBRIN', 246888),
(370287, 'PTHR10829:SF54', NULL, NULL, NULL, NULL, 'ADF-H DOMAIN-CONTAINING PROTEIN', 246888),
(370288, 'PTHR10829:SF55', NULL, NULL, NULL, NULL, '', 246888),
(370289, 'PTHR10829:SF52', NULL, NULL, NULL, NULL, 'ADF-H DOMAIN-CONTAINING PROTEIN', 246888),
(370290, 'PTHR10829:SF42', NULL, NULL, NULL, NULL, 'HIGH OSMOLARITY SIGNALING PROTEIN SHO1', 246888),
(370291, 'PTHR10829:SF20', NULL, NULL, NULL, NULL, 'ADF-H DOMAIN-CONTAINING PROTEIN', 246888),
(370292, 'PTHR10829:SF53', NULL, NULL, NULL, NULL, 'DREBRIN-LIKE PROTEIN', 246888),
(370293, 'PTHR10829:SF50', NULL, NULL, NULL, NULL, '', 246888),
(370294, 'PTHR10829:SF9', NULL, NULL, NULL, NULL, 'SI:DKEY-40C11.2', 246888),
(370295, 'PTHR10829', NULL, NULL, NULL, NULL, 'CORTACTIN AND DREBRIN', 246888),
(370296, 'PTHR10829:SF5', NULL, NULL, NULL, NULL, 'HEMATOPOIETIC LINEAGE CELL-SPECIFIC PROTEIN', 246888),
(370297, 'PTHR10829:SF29', NULL, NULL, NULL, NULL, 'COACTOSIN-LIKE PROTEIN', 246888),
(370298, 'PTHR13017', NULL, NULL, NULL, NULL, '5-FORMYLTETRAHYDROFOLATE CYCLO-LIGASE-RELATED', 246889),
(370299, 'PTHR13017:SF0', NULL, NULL, NULL, NULL, 'METHENYLTETRAHYDROFOLATE SYNTHASE DOMAIN-CONTAINING PROTEIN', 246889),
(370300, 'PTHR45748:SF26', NULL, NULL, NULL, NULL, 'OS03G0399532 PROTEIN', 246890),
(370301, 'PTHR45748:SF15', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL-3-PHOSPHATE 5-KINASE', 246890),
(370302, 'PTHR45748:SF14', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL-3-PHOSPHATE 5-KINASE FAB1C-RELATED', 246890),
(370303, 'PTHR45748:SF25', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL-3-PHOSPHATE 5-KINASE', 246890),
(370304, 'PTHR45748:SF24', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL-3-PHOSPHATE 5-KINASE', 246890),
(370305, 'PTHR45748:SF13', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL-3-PHOSPHATE 5-KINASE FAB1C-RELATED', 246890),
(370306, 'PTHR45748:SF9', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL-3-PHOSPHATE 5-KINASE', 246890),
(370307, 'PTHR45748', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 3-PHOSPHATE 5-KINASE-RELATED', 246890),
(370308, 'PTHR45748:SF22', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL-3-PHOSPHATE 5-KINASE', 246890),
(370309, 'PTHR45748:SF21', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL-3-PHOSPHATE 5-KINASE FAB1A', 246890),
(370310, 'PTHR45748:SF5', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL-3-PHOSPHATE 5-KINASE', 246890),
(370311, 'PTHR45748:SF8', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL-3-PHOSPHATE 5-KINASE', 246890),
(370312, 'PTHR45748:SF7', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 3-PHOSPHATE 5-KINASE-RELATED', 246890),
(370313, 'PTHR45748:SF1', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL-3-PHOSPHATE 5-KINASE', 246890),
(370314, 'PTHR45748:SF4', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL-3-PHOSPHATE 5-KINASE FAB1D-RELATED', 246890);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(370315, 'PTHR45748:SF3', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL-3-PHOSPHATE 5-KINASE', 246890),
(370316, 'PTHR37303:SF2', NULL, NULL, NULL, NULL, 'EXPORTED PROTEIN-RELATED', 246891),
(370317, 'PTHR37303', NULL, NULL, NULL, NULL, 'EXPORTED PROTEIN-RELATED', 246891),
(370318, 'PTHR32098', NULL, NULL, NULL, NULL, 'LYCOPENE BETA/EPSILON CYCLASE PROTEIN', 246892),
(370319, 'PTHR32098:SF5', NULL, NULL, NULL, NULL, 'LYCOPENE BETA/EPSILON CYCLASE PROTEIN', 246892),
(370320, 'PTHR21236:SF18', NULL, NULL, NULL, NULL, 'PROTEIN YIP', 246893),
(370321, 'PTHR21236:SF2', NULL, NULL, NULL, NULL, 'PROTEIN YIPF', 246893),
(370322, 'PTHR21236:SF1', NULL, NULL, NULL, NULL, 'PROTEIN YIPF6', 246893),
(370323, 'PTHR21236', NULL, NULL, NULL, NULL, 'GOLGI MEMBRANE PROTEIN YIP1', 246893),
(370324, 'PTHR21236:SF25', NULL, NULL, NULL, NULL, 'PROTEIN YIP', 246893),
(370325, 'PTHR21236:SF26', NULL, NULL, NULL, NULL, 'PROTEIN YIP', 246893),
(370326, 'PTHR21236:SF27', NULL, NULL, NULL, NULL, 'PROTEIN YIP', 246893),
(370327, 'PTHR21236:SF7', NULL, NULL, NULL, NULL, 'PROTEIN YIPF4', 246893),
(370328, 'PTHR21236:SF6', NULL, NULL, NULL, NULL, 'PROTEIN YIPF5', 246893),
(370329, 'PTHR21236:SF20', NULL, NULL, NULL, NULL, 'PROTEIN YIP', 246893),
(370330, 'PTHR21236:SF5', NULL, NULL, NULL, NULL, 'PROTEIN YIPF7', 246893),
(370331, 'PTHR43220:SF18', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 41B', 246894),
(370332, 'PTHR43220:SF19', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING DOMAIN, SNARE ASSOCIATED GOLGI PROTEIN-RELATED', 246894),
(370333, 'PTHR43220:SF3', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE, EXPRESSED-RELATED', 246894),
(370334, 'PTHR43220:SF16', NULL, NULL, NULL, NULL, '', 246894),
(370335, 'PTHR43220', NULL, NULL, NULL, NULL, '', 246894),
(370336, 'PTHR43220:SF21', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 41A', 246894),
(370337, 'PTHR43220:SF7', NULL, NULL, NULL, NULL, 'SNARE ASSOCIATED GOLGI PROTEIN FAMILY', 246894),
(370338, 'PTHR43220:SF20', NULL, NULL, NULL, NULL, 'PROTEIN CBR-BUS-19', 246894),
(370339, 'PTHR43220:SF6', NULL, NULL, NULL, NULL, 'OS04G0592600 PROTEIN', 246894),
(370340, 'PTHR43220:SF9', NULL, NULL, NULL, NULL, 'SNARE ASSOCIATED GOLGI PROTEIN FAMILY', 246894),
(370341, 'PTHR43220:SF11', NULL, NULL, NULL, NULL, 'SNARE ASSOCIATED GOLGI PROTEIN FAMILY-RELATED', 246894),
(370342, 'PTHR36376:SF1', NULL, NULL, NULL, NULL, 'OS09G0514700 PROTEIN', 246895),
(370343, 'PTHR36376', NULL, NULL, NULL, NULL, 'OS09G0514700 PROTEIN', 246895),
(370344, 'PTHR33217', NULL, NULL, NULL, NULL, 'TRANSPOSASE FOR INSERTION SEQUENCE ELEMENT IS1081', 246896),
(370345, 'PTHR33217:SF5', NULL, NULL, NULL, NULL, 'MUTATOR FAMILY TRANSPOSASE', 246896),
(370346, 'PTHR33217:SF7', NULL, NULL, NULL, NULL, 'TRANSPOSASE FOR INSERTION SEQUENCE ELEMENT IS1081', 246896),
(370347, 'PTHR33217:SF8', NULL, NULL, NULL, NULL, 'MUTATOR FAMILY TRANSPOSASE', 246896),
(370348, 'PTHR46736:SF73', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 246897),
(370349, 'PTHR46736:SF72', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', 246897),
(370350, 'PTHR46736:SF71', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', 246897),
(370351, 'PTHR46736:SF70', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN, REVERSE TRANSCRIPTASE ZINC-BINDING DOMAIN PROTEIN-RELATED', 246897),
(370352, 'PTHR46736:SF66', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', 246897),
(370353, 'PTHR46736:SF65', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', 246897),
(370354, 'PTHR46736:SF64', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', 246897),
(370355, 'PTHR46736:SF63', NULL, NULL, NULL, NULL, 'ACID BINDING PROTEIN, PUTATIVE-RELATED', 246897),
(370356, 'PTHR46736:SF69', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 246897),
(370357, 'PTHR46736:SF68', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', 246897),
(370358, 'PTHR46736:SF67', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', 246897),
(370359, 'PTHR46736:SF80', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', 246897);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(370360, 'PTHR46736', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', 246897),
(370361, 'PTHR46736:SF84', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDYL TRANSFERASE, RIBONUCLEASE H-LIKE SUPERFAMILY PROTEIN', 246897),
(370362, 'PTHR46736:SF83', NULL, NULL, NULL, NULL, 'OS01G0698850 PROTEIN', 246897),
(370363, 'PTHR46736:SF82', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE-RELATED', 246897),
(370364, 'PTHR46736:SF81', NULL, NULL, NULL, NULL, 'ORF258 PROTEIN', 246897),
(370365, 'PTHR46736:SF38', NULL, NULL, NULL, NULL, 'BNAC03G55090D PROTEIN', 246897),
(370366, 'PTHR46736:SF77', NULL, NULL, NULL, NULL, '', 246897),
(370367, 'PTHR46736:SF76', NULL, NULL, NULL, NULL, 'SI:CH211-167J9.4', 246897),
(370368, 'PTHR46736:SF75', NULL, NULL, NULL, NULL, 'OS12G0428401 PROTEIN', 246897),
(370369, 'PTHR46736:SF74', NULL, NULL, NULL, NULL, 'OS05G0331700 PROTEIN', 246897),
(370370, 'PTHR46736:SF79', NULL, NULL, NULL, NULL, '', 246897),
(370371, 'PTHR46736:SF78', NULL, NULL, NULL, NULL, 'RNA-DIRECTED DNA POLYMERASE (REVERSE TRANSCRIPTASE)-RELATED FAMILY PROTEIN', 246897),
(370372, 'PTHR46736:SF34', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 246897),
(370373, 'PTHR46736:SF51', NULL, NULL, NULL, NULL, '', 246897),
(370374, 'PTHR46736:SF50', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 246897),
(370375, 'PTHR46736:SF49', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', 246897),
(370376, 'PTHR46736:SF88', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 246897),
(370377, 'PTHR46736:SF44', NULL, NULL, NULL, NULL, '', 246897),
(370378, 'PTHR46736:SF87', NULL, NULL, NULL, NULL, 'BNAUNNG02060D PROTEIN', 246897),
(370379, 'PTHR46736:SF43', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H PROTEIN', 246897),
(370380, 'PTHR46736:SF42', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 246897),
(370381, 'PTHR46736:SF86', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 246897),
(370382, 'PTHR46736:SF85', NULL, NULL, NULL, NULL, '', 246897),
(370383, 'PTHR46736:SF41', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', 246897),
(370384, 'PTHR46736:SF48', NULL, NULL, NULL, NULL, 'NON-LTR RETROELEMENT REVERSE TRANSCRIPTASE-RELATED', 246897),
(370385, 'PTHR46736:SF47', NULL, NULL, NULL, NULL, '', 246897),
(370386, 'PTHR46736:SF46', NULL, NULL, NULL, NULL, '', 246897),
(370387, 'PTHR46736:SF45', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', 246897),
(370388, 'PTHR46736:SF62', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 246897),
(370389, 'PTHR46736:SF61', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', 246897),
(370390, 'PTHR46736:SF60', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 246897),
(370391, 'PTHR46736:SF55', NULL, NULL, NULL, NULL, 'NON-LTR RETROELEMENT REVERSE TRANSCRIPTASE', 246897),
(370392, 'PTHR46736:SF54', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', 246897),
(370393, 'PTHR46736:SF53', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 246897),
(370394, 'PTHR46736:SF52', NULL, NULL, NULL, NULL, 'NON-LTR REVERSE TRANSCRIPTASE-RELATED', 246897),
(370395, 'PTHR46736:SF59', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', 246897),
(370396, 'PTHR46736:SF58', NULL, NULL, NULL, NULL, 'RNA-DIRECTED DNA POLYMERASE (REVERSE TRANSCRIPTASE)-RELATED FAMILY PROTEIN', 246897),
(370397, 'PTHR46736:SF57', NULL, NULL, NULL, NULL, '', 246897),
(370398, 'PTHR46736:SF56', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 246897),
(370399, 'PTHR22955', NULL, NULL, NULL, NULL, 'RETROTRANSPOSON', 246898),
(370400, 'PTHR22955:SF65', NULL, NULL, NULL, NULL, 'DUF1758 DOMAIN-CONTAINING PROTEIN', 246898),
(370401, 'PTHR22955:SF66', NULL, NULL, NULL, NULL, 'DUF5641 DOMAIN-CONTAINING PROTEIN', 246898),
(370402, 'PTHR22955:SF67', NULL, NULL, NULL, NULL, 'PROTEIN CBG26128', 246898),
(370403, 'PTHR22955:SF68', NULL, NULL, NULL, NULL, 'PROTEIN CBG25357', 246898),
(370404, 'PTHR22955:SF69', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 246898),
(370405, 'PTHR22955:SF70', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 246898);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(370406, 'PTHR39591', NULL, NULL, NULL, NULL, 'UPF0265 PROTEIN YEEX', 246899),
(370407, 'PTHR39591:SF1', NULL, NULL, NULL, NULL, 'UPF0265 PROTEIN YEEX', 246899),
(370408, 'PTHR48097:SF12', NULL, NULL, NULL, NULL, 'LOW-SPECIFICITY L-THREONINE ALDOLASE 1-RELATED', 246900),
(370409, 'PTHR48097:SF13', NULL, NULL, NULL, NULL, 'LOW-SPECIFICITY L-THREONINE ALDOLASE 1-RELATED', 246900),
(370410, 'PTHR48097:SF10', NULL, NULL, NULL, NULL, 'BETA_ELIM_LYASE DOMAIN-CONTAINING PROTEIN', 246900),
(370411, 'PTHR48097', NULL, NULL, NULL, NULL, 'L-THREONINE ALDOLASE-RELATED', 246900),
(370412, 'PTHR48097:SF11', NULL, NULL, NULL, NULL, 'BETA_ELIM_LYASE DOMAIN-CONTAINING PROTEIN', 246900),
(370413, 'PTHR48097:SF9', NULL, NULL, NULL, NULL, 'L-THREONINE ALDOLASE', 246900),
(370414, 'PTHR48097:SF8', NULL, NULL, NULL, NULL, 'BETA_ELIM_LYASE DOMAIN-CONTAINING PROTEIN', 246900),
(370415, 'PTHR48097:SF6', NULL, NULL, NULL, NULL, 'LOW-SPECIFICITY L-THREONINE ALDOLASE 1-RELATED', 246900),
(370416, 'PTHR48097:SF5', NULL, NULL, NULL, NULL, 'LOW SPECIFICITY L-THREONINE ALDOLASE', 246900),
(370417, 'PTHR48097:SF3', NULL, NULL, NULL, NULL, 'L-ALLO-THREONINE ALDOLASE', 246900),
(370418, 'PTHR48097:SF1', NULL, NULL, NULL, NULL, 'BETA_ELIM_LYASE DOMAIN-CONTAINING PROTEIN', 246900),
(370419, 'PTHR33625', NULL, NULL, NULL, NULL, 'OS08G0179900 PROTEIN', 246901),
(370420, 'PTHR33625:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246901),
(370421, 'PTHR33625:SF7', NULL, NULL, NULL, NULL, 'OS02G0657700 PROTEIN', 246901),
(370422, 'PTHR33625:SF8', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 246901),
(370423, 'PTHR33625:SF11', NULL, NULL, NULL, NULL, '', 246901),
(370424, 'PTHR33625:SF12', NULL, NULL, NULL, NULL, 'BNACNNG45510D PROTEIN', 246901),
(370425, 'PTHR33625:SF13', NULL, NULL, NULL, NULL, '', 246901),
(370426, 'PTHR33625:SF2', NULL, NULL, NULL, NULL, '', 246901),
(370427, 'PTHR33625:SF3', NULL, NULL, NULL, NULL, 'OS04G0550700 PROTEIN', 246901),
(370428, 'PTHR33625:SF14', NULL, NULL, NULL, NULL, 'BNAC08G11980D PROTEIN', 246901),
(370429, 'PTHR33625:SF4', NULL, NULL, NULL, NULL, 'OS08G0179900 PROTEIN', 246901),
(370430, 'PTHR38422', NULL, NULL, NULL, NULL, 'SOMETHING ABOUT SILENCING PROTEIN 4', 246902),
(370431, 'PTHR38422:SF1', NULL, NULL, NULL, NULL, 'SOMETHING ABOUT SILENCING PROTEIN 4', 246902),
(370432, 'PTHR21222:SF1', NULL, NULL, NULL, NULL, 'MIT DOMAIN-CONTAINING PROTEIN 1', 246903),
(370433, 'PTHR21222', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 246903),
(370434, 'PTHR35483:SF1', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN-RELATED', 246904),
(370435, 'PTHR35483', NULL, NULL, NULL, NULL, 'NUCLEUSENVELOPE PROTEIN', 246904),
(370436, 'PTHR35483:SF8', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN', 246904),
(370437, 'PTHR35483:SF9', NULL, NULL, NULL, NULL, 'BNAA09G55430D PROTEIN', 246904),
(370438, 'PTHR45937:SF1', NULL, NULL, NULL, NULL, 'ASPARAGINE SYNTHETASE DOMAIN-CONTAINING PROTEIN 1', 246905),
(370439, 'PTHR45937', NULL, NULL, NULL, NULL, 'ASPARAGINE SYNTHETASE DOMAIN-CONTAINING PROTEIN 1', 246905),
(370440, 'PTHR43418:SF8', NULL, NULL, NULL, NULL, 'SYNTHASE COMPONENT II, PUTATIVE-RELATED', 246906),
(370441, 'PTHR43418:SF7', NULL, NULL, NULL, NULL, 'CARBAMOYL-PHOSPHATE SYNTHASE SMALL CHAIN', 246906),
(370442, 'PTHR43418:SF14', NULL, NULL, NULL, NULL, 'ANTHRANILATE SYNTHASE BETA SUBUNIT 2, CHLOROPLASTIC', 246906),
(370443, 'PTHR43418', NULL, NULL, NULL, NULL, 'MULTIFUNCTIONAL TRYPTOPHAN BIOSYNTHESIS PROTEIN-RELATED', 246906),
(370444, 'PTHR43418:SF12', NULL, NULL, NULL, NULL, 'GLUTAMINE AMIDOTRANSFERASE TYPE-1 DOMAIN-CONTAINING PROTEIN', 246906),
(370445, 'PTHR43418:SF2', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL PROTEIN TRPGD', 246906),
(370446, 'PTHR43418:SF4', NULL, NULL, NULL, NULL, 'MULTIFUNCTIONAL TRYPTOPHAN BIOSYNTHESIS PROTEIN', 246906),
(370447, 'PTHR35693:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246907),
(370448, 'PTHR35693:SF2', NULL, NULL, NULL, NULL, 'BNAA09G29210D PROTEIN', 246907),
(370449, 'PTHR35693', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246907),
(370450, 'PTHR31763', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC689766', 246908);
INSERT INTO "PUBLIC"."MODEL" VALUES
(370451, 'PTHR31763:SF2', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC689766', 246908),
(370452, 'PTHR43872:SF1', NULL, NULL, NULL, NULL, 'MONOOXYGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G02570)-RELATED', 246909),
(370453, 'PTHR43872', NULL, NULL, NULL, NULL, 'MONOOXYGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G02570)-RELATED', 246909),
(370454, 'PTHR22765:SF365', NULL, NULL, NULL, NULL, 'RING ZINC FINGER DOMAIN SUPERFAMILY PROTEIN-RELATED', 246910),
(370455, 'PTHR22765:SF400', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246910),
(370456, 'PTHR22765:SF360', NULL, NULL, NULL, NULL, 'OS12G0580700 PROTEIN', 246910),
(370457, 'PTHR22765:SF361', NULL, NULL, NULL, NULL, 'OS06G0537500 PROTEIN', 246910),
(370458, 'PTHR22765:SF362', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246910),
(370459, 'PTHR22765:SF405', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 128', 246910),
(370460, 'PTHR22765:SF406', NULL, NULL, NULL, NULL, 'PA AND RING FINGER DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_2G02470)', 246910),
(370461, 'PTHR22765:SF407', NULL, NULL, NULL, NULL, 'VACUOLAR-SORTING RECEPTOR 3-LIKE', 246910),
(370462, 'PTHR22765:SF408', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246910),
(370463, 'PTHR22765:SF401', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 246910),
(370464, 'PTHR22765:SF402', NULL, NULL, NULL, NULL, 'RING ZINC FINGER DOMAIN SUPERFAMILY PROTEIN-RELATED', 246910),
(370465, 'PTHR22765:SF369', NULL, NULL, NULL, NULL, 'RING ZINC FINGER DOMAIN SUPERFAMILY PROTEIN-RELATED', 246910),
(370466, 'PTHR22765:SF403', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246910),
(370467, 'PTHR22765:SF404', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 246910),
(370468, 'PTHR22765:SF409', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RHA4A-RELATED', 246910),
(370469, 'PTHR22765:SF190', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ATL41', 246910),
(370470, 'PTHR22765:SF232', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 246910),
(370471, 'PTHR22765:SF354', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246910),
(370472, 'PTHR22765:SF350', NULL, NULL, NULL, NULL, 'GB|AAD18119.1-RELATED', 246910),
(370473, 'PTHR22765:SF238', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 246910),
(370474, 'PTHR22765:SF53', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 148', 246910),
(370475, 'PTHR22765:SF265', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 246910),
(370476, 'PTHR22765:SF420', NULL, NULL, NULL, NULL, 'GB|AAD18119.1-RELATED', 246910),
(370477, 'PTHR22765:SF267', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246910),
(370478, 'PTHR22765:SF421', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246910),
(370479, 'PTHR22765:SF422', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 115', 246910),
(370480, 'PTHR22765:SF262', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SIRP1', 246910),
(370481, 'PTHR22765:SF141', NULL, NULL, NULL, NULL, 'OS06G0540050 PROTEIN', 246910),
(370482, 'PTHR22765:SF383', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL81-LIKE ISOFORM X1', 246910),
(370483, 'PTHR22765:SF384', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE AIP2', 246910),
(370484, 'PTHR22765:SF385', NULL, NULL, NULL, NULL, 'OS09G0243200 PROTEIN', 246910),
(370485, 'PTHR22765:SF427', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 246910),
(370486, 'PTHR22765:SF307', NULL, NULL, NULL, NULL, 'OS06G0687200 PROTEIN', 246910),
(370487, 'PTHR22765:SF428', NULL, NULL, NULL, NULL, 'VACUOLAR-SORTING RECEPTOR 4', 246910),
(370488, 'PTHR22765:SF429', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246910),
(370489, 'PTHR22765:SF423', NULL, NULL, NULL, NULL, 'RECEPTOR HOMOLOGY REGION, TRANSMEMBRANE DOMAIN- AND RING DOMAIN-CONTAINING PROTEIN 2-LIKE', 246910),
(370490, 'PTHR22765:SF303', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246910),
(370491, 'PTHR22765:SF424', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 246910);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(370492, 'PTHR22765:SF40', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF130', 246910),
(370493, 'PTHR22765:SF425', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246910),
(370494, 'PTHR22765:SF42', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 150', 246910),
(370495, 'PTHR22765:SF426', NULL, NULL, NULL, NULL, 'OS06G0534800 PROTEIN', 246910),
(370496, 'PTHR22765:SF47', NULL, NULL, NULL, NULL, 'VACUOLAR-SORTING RECEPTOR 1', 246910),
(370497, 'PTHR22765', NULL, NULL, NULL, NULL, 'RING FINGER AND PROTEASE ASSOCIATED DOMAIN-CONTAINING', 246910),
(370498, 'PTHR22765:SF254', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246910),
(370499, 'PTHR22765:SF375', NULL, NULL, NULL, NULL, 'OS10G0438800 PROTEIN', 246910),
(370500, 'PTHR22765:SF135', NULL, NULL, NULL, NULL, 'OS04G0450300 PROTEIN', 246910),
(370501, 'PTHR22765:SF410', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE EL5', 246910),
(370502, 'PTHR22765:SF411', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 246910),
(370503, 'PTHR22765:SF257', NULL, NULL, NULL, NULL, 'OS09G0242800 PROTEIN', 246910),
(370504, 'PTHR22765:SF371', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246910),
(370505, 'PTHR22765:SF374', NULL, NULL, NULL, NULL, 'PROTEIN GOLIATH-LIKE PROTEIN', 246910),
(370506, 'PTHR22765:SF416', NULL, NULL, NULL, NULL, 'FI17865P1', 246910),
(370507, 'PTHR22765:SF417', NULL, NULL, NULL, NULL, 'RECEPTOR HOMOLOGY REGION, TRANSMEMBRANE DOMAIN- AND RING DOMAIN-CONTAINING PROTEIN 4-RELATED', 246910),
(370508, 'PTHR22765:SF34', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF13', 246910),
(370509, 'PTHR22765:SF418', NULL, NULL, NULL, NULL, 'OS08G0487500 PROTEIN', 246910),
(370510, 'PTHR22765:SF419', NULL, NULL, NULL, NULL, 'RECEPTOR HOMOLOGY REGION, TRANSMEMBRANE DOMAIN- AND RING DOMAIN-CONTAINING PROTEIN 1', 246910),
(370511, 'PTHR22765:SF35', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF167', 246910),
(370512, 'PTHR22765:SF412', NULL, NULL, NULL, NULL, 'OS02G0248440 PROTEIN', 246910),
(370513, 'PTHR22765:SF413', NULL, NULL, NULL, NULL, 'FINGER DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G04600)-RELATED', 246910),
(370514, 'PTHR22765:SF414', NULL, NULL, NULL, NULL, 'OS12G0140700 PROTEIN', 246910),
(370515, 'PTHR22765:SF30', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF128', 246910),
(370516, 'PTHR22765:SF415', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 246910),
(370517, 'PTHR22765:SF38', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF133', 246910),
(370518, 'PTHR22765:SF39', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF149', 246910),
(370519, 'PTHR22765:SF281', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246910),
(370520, 'PTHR22765:SF441', NULL, NULL, NULL, NULL, 'OS11G0119200 PROTEIN', 246910),
(370521, 'PTHR22765:SF200', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246910),
(370522, 'PTHR22765:SF442', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246910),
(370523, 'PTHR22765:SF443', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN (AFU_ORTHOLOGUE AFUA_2G10860)', 246910),
(370524, 'PTHR22765:SF444', NULL, NULL, NULL, NULL, 'ZINC FINGER, C3HC4 TYPE (RING FINGER) PROTEIN', 246910),
(370525, 'PTHR22765:SF163', NULL, NULL, NULL, NULL, 'OS06G0257700 PROTEIN', 246910),
(370526, 'PTHR22765:SF284', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 246910),
(370527, 'PTHR22765:SF440', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246910),
(370528, 'PTHR22765:SF445', NULL, NULL, NULL, NULL, 'VACUOLAR SORTING RECEPTOR 7', 246910),
(370529, 'PTHR22765:SF446', NULL, NULL, NULL, NULL, 'RING ZINC FINGER DOMAIN SUPERFAMILY PROTEIN-RELATED', 246910),
(370530, 'PTHR22765:SF447', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 246910),
(370531, 'PTHR22765:SF206', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RHY1A-RELATED', 246910),
(370532, 'PTHR22765:SF271', NULL, NULL, NULL, NULL, 'OS02G0727700 PROTEIN', 246910);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(370533, 'PTHR22765:SF430', NULL, NULL, NULL, NULL, 'RECEPTOR HOMOLOGY REGION, TRANSMEMBRANE DOMAIN- AND RING DOMAIN-CONTAINING PROTEIN 2-RELATED', 246910),
(370534, 'PTHR22765:SF431', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 246910),
(370535, 'PTHR22765:SF310', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246910),
(370536, 'PTHR22765:SF432', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246910),
(370537, 'PTHR22765:SF157', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE CIP8', 246910),
(370538, 'PTHR22765:SF399', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL3', 246910),
(370539, 'PTHR22765:SF311', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 246910),
(370540, 'PTHR22765:SF433', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246910),
(370541, 'PTHR22765:SF272', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246910),
(370542, 'PTHR22765:SF393', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ATL59-RELATED', 246910),
(370543, 'PTHR22765:SF152', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL3', 246910),
(370544, 'PTHR22765:SF396', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 246910),
(370545, 'PTHR22765:SF438', NULL, NULL, NULL, NULL, 'RING ZINC FINGER DOMAIN SUPERFAMILY PROTEIN-RELATED', 246910),
(370546, 'PTHR22765:SF439', NULL, NULL, NULL, NULL, 'OS11G0142600 PROTEIN', 246910),
(370547, 'PTHR22765:SF434', NULL, NULL, NULL, NULL, 'GB|AAD18119.1-RELATED', 246910),
(370548, 'PTHR22765:SF313', NULL, NULL, NULL, NULL, 'OS02G0798200 PROTEIN', 246910),
(370549, 'PTHR22765:SF435', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 246910),
(370550, 'PTHR22765:SF436', NULL, NULL, NULL, NULL, 'OS12G0620100 PROTEIN', 246910),
(370551, 'PTHR22765:SF437', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 246910),
(370552, 'PTHR22765:SF180', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 246910),
(370553, 'PTHR22765:SF183', NULL, NULL, NULL, NULL, 'FINGER DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G03900)-RELATED', 246910),
(370554, 'PTHR22765:SF343', NULL, NULL, NULL, NULL, 'OS05G0408800 PROTEIN', 246910),
(370555, 'PTHR22765:SF345', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 215', 246910),
(370556, 'PTHR22765:SF340', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246910),
(370557, 'PTHR22765:SF108', NULL, NULL, NULL, NULL, 'OS03G0391100 PROTEIN', 246910),
(370558, 'PTHR22765:SF229', NULL, NULL, NULL, NULL, 'RING ZINC FINGER DOMAIN SUPERFAMILY PROTEIN-RELATED', 246910),
(370559, 'PTHR22765:SF347', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ZNRF4', 246910),
(370560, 'PTHR22765:SF106', NULL, NULL, NULL, NULL, 'OS02G0248200 PROTEIN', 246910),
(370561, 'PTHR22765:SF348', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 246910),
(370562, 'PTHR22765:SF293', NULL, NULL, NULL, NULL, 'RING ZINC FINGER DOMAIN SUPERFAMILY PROTEIN-RELATED', 246910),
(370563, 'PTHR22765:SF331', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 246910),
(370564, 'PTHR22765:SF334', NULL, NULL, NULL, NULL, 'RECEPTOR HOMOLOGY REGION, TRANSMEMBRANE DOMAIN- AND RING DOMAIN-CONTAINING PROTEIN 1', 246910),
(370565, 'PTHR22765:SF335', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 246910),
(370566, 'PTHR22765:SF338', NULL, NULL, NULL, NULL, 'RECEPTOR HOMOLOGY REGION, TRANSMEMBRANE DOMAIN- AND RING DOMAIN-CONTAINING PROTEIN 2', 246910),
(370567, 'PTHR22718:SF25', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 246911),
(370568, 'PTHR22718:SF10', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN-RELATED', 246911),
(370569, 'PTHR22718:SF22', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN-RELATED', 246911),
(370570, 'PTHR22718:SF33', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN', 246911),
(370571, 'PTHR22718:SF11', NULL, NULL, NULL, NULL, 'PROTEIN CBG15452', 246911),
(370572, 'PTHR22718:SF34', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 246911);
INSERT INTO "PUBLIC"."MODEL" VALUES
(370573, 'PTHR22718:SF35', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN', 246911),
(370574, 'PTHR22718', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS X', 246911),
(370575, 'PTHR22718:SF9', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN', 246911),
(370576, 'PTHR11822:SF5', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NADP], CHLOROPLASTIC/MITOCHONDRIAL', 246912),
(370577, 'PTHR11822:SF40', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE (NADP(+))', 246912),
(370578, 'PTHR11822:SF30', NULL, NULL, NULL, NULL, 'PEROXISOMAL ISOCITRATE DEHYDROGENASE [NADP]', 246912),
(370579, 'PTHR11822:SF41', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NADP]-RELATED', 246912),
(370580, 'PTHR11822:SF31', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NADP]', 246912),
(370581, 'PTHR11822:SF42', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NADP], MITOCHONDRIAL', 246912),
(370582, 'PTHR11822:SF21', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NADP] CYTOPLASMIC', 246912),
(370583, 'PTHR11822:SF22', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NADP]', 246912),
(370584, 'PTHR11822:SF34', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NADP]', 246912),
(370585, 'PTHR11822:SF35', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NADP]', 246912),
(370586, 'PTHR11822:SF36', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NADP]', 246912),
(370587, 'PTHR11822', NULL, NULL, NULL, NULL, 'NADP-SPECIFIC ISOCITRATE DEHYDROGENASE', 246912),
(370588, 'PTHR11822:SF15', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NADP] CYTOPLASMIC', 246912),
(370589, 'PTHR11822:SF26', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NADP]', 246912),
(370590, 'PTHR11822:SF27', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NADP]', 246912),
(370591, 'PTHR11822:SF39', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NADP]', 246912),
(370592, 'PTHR11822:SF28', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NADP] CYTOPLASMIC', 246912),
(370593, 'PTHR30543:SF19', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE)', 246913),
(370594, 'PTHR30543', NULL, NULL, NULL, NULL, 'CHROMATE REDUCTASE', 246913),
(370595, 'PTHR30543:SF26', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE)', 246913),
(370596, 'PTHR30543:SF16', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE)', 246913),
(370597, 'PTHR30543:SF28', NULL, NULL, NULL, NULL, 'FMN_RED DOMAIN-CONTAINING PROTEIN', 246913),
(370598, 'PTHR30543:SF17', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE)', 246913),
(370599, 'PTHR30543:SF29', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE)', 246913),
(370600, 'PTHR30543:SF22', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE)', 246913),
(370601, 'PTHR30543:SF23', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE)', 246913),
(370602, 'PTHR30543:SF24', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE)', 246913),
(370603, 'PTHR30543:SF14', NULL, NULL, NULL, NULL, 'NADPH:QUINONE OXIDOREDUCTASE 2-RELATED', 246913),
(370604, 'PTHR30543:SF30', NULL, NULL, NULL, NULL, 'FMN-DEPENDENT NADPH-AZOREDUCTASE', 246913),
(370605, 'PTHR30543:SF21', NULL, NULL, NULL, NULL, 'NAD(P)H-DEPENDENT FMN REDUCTASE LOT6', 246913),
(370606, 'PTHR21510', NULL, NULL, NULL, NULL, '', 246914),
(370607, 'PTHR21510:SF15', NULL, NULL, NULL, NULL, 'MICROTUBULE ORGANIZATION PROTEIN AKNA', 246914),
(370608, 'PTHR21510:SF16', NULL, NULL, NULL, NULL, 'PROTEIN AKNAD1', 246914),
(370609, 'PTHR21510:SF13', NULL, NULL, NULL, NULL, '', 246914),
(370610, 'PTHR32328', NULL, NULL, NULL, NULL, 'L-SERYL-TRNA(SEC) SELENIUM TRANSFERASE', 246915),
(370611, 'PTHR32328:SF0', NULL, NULL, NULL, NULL, 'L-SERYL-TRNA(SEC) SELENIUM TRANSFERASE', 246915),
(370612, 'PTHR33435', NULL, NULL, NULL, NULL, 'PROTEIN CBG21870-RELATED', 246916),
(370613, 'PTHR33435:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG21870', 246916),
(370614, 'PTHR33893:SF14', NULL, NULL, NULL, NULL, 'INSULIN RELATED', 246917),
(370615, 'PTHR33893:SF5', NULL, NULL, NULL, NULL, 'INSULIN-LIKE PEPTIDE BETA-TYPE 3-RELATED', 246917);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(370616, 'PTHR33893:SF11', NULL, NULL, NULL, NULL, 'INSULIN RELATED-RELATED', 246917),
(370617, 'PTHR33893:SF9', NULL, NULL, NULL, NULL, 'INSULIN RELATED-RELATED', 246917),
(370618, 'PTHR33893', NULL, NULL, NULL, NULL, 'INSULIN RELATED-RELATED-RELATED', 246917),
(370619, 'PTHR13500:SF0', NULL, NULL, NULL, NULL, 'NUCLEOLAR PRE-RIBOSOMAL-ASSOCIATED PROTEIN 1', 246918),
(370620, 'PTHR13500', NULL, NULL, NULL, NULL, 'NUCLEOLAR PRERIBOSOMAL-ASSOCIATED PROTEIN 1', 246918),
(370621, 'PTHR23013:SF20', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN', 246919),
(370622, 'PTHR23013:SF32', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN', 246919),
(370623, 'PTHR23013:SF21', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN', 246919),
(370624, 'PTHR23013:SF13', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN-RELATED', 246919),
(370625, 'PTHR23013:SF35', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 246919),
(370626, 'PTHR23013:SF14', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN', 246919),
(370627, 'PTHR23013:SF26', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 246919),
(370628, 'PTHR23013:SF27', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 246919),
(370629, 'PTHR23013', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR', 246919),
(370630, 'PTHR23013:SF19', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN', 246919),
(370631, 'PTHR12937:SF4', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 28 HOMOLOG', 246920),
(370632, 'PTHR12937:SF3', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 28 HOMOLOG 1', 246920),
(370633, 'PTHR12937', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING 28, ISOFORM 2  VPS28', 246920),
(370634, 'PTHR12937:SF0', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 28 HOMOLOG', 246920),
(370635, 'PTHR12937:SF2', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 28 HOMOLOG', 246920),
(370636, 'PTHR37408', NULL, NULL, NULL, NULL, '', 246921),
(370637, 'PTHR37408:SF1', NULL, NULL, NULL, NULL, '', 246921),
(370638, 'PTHR11054:SF10', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONOLACTONASE-RELATED', 246922),
(370639, 'PTHR11054:SF21', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONOLACTONASE-RELATED', 246922),
(370640, 'PTHR11054:SF20', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONOLACTONASE-RELATED', 246922),
(370641, 'PTHR11054:SF14', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONOLACTONASE 2-RELATED', 246922),
(370642, 'PTHR11054:SF13', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONOLACTONASE-RELATED', 246922),
(370643, 'PTHR11054:SF23', NULL, NULL, NULL, NULL, 'GLUCOSAMINE_ISO DOMAIN-CONTAINING PROTEIN', 246922),
(370644, 'PTHR11054:SF22', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONOLACTONASE 3, CHLOROPLASTIC', 246922),
(370645, 'PTHR11054:SF11', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONOLACTONASE 4-RELATED', 246922),
(370646, 'PTHR11054:SF18', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONOLACTONASE-RELATED', 246922),
(370647, 'PTHR11054:SF17', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONOLACTONASE 1-RELATED', 246922),
(370648, 'PTHR11054:SF16', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONOLACTONASE 5-RELATED', 246922),
(370649, 'PTHR11054:SF15', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONOLACTONASE-RELATED', 246922),
(370650, 'PTHR11054:SF9', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONOLACTONASE-RELATED', 246922),
(370651, 'PTHR11054:SF8', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONOLACTONASE 2-RELATED', 246922),
(370652, 'PTHR11054:SF19', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONOLACTONASE-RELATED', 246922),
(370653, 'PTHR11054:SF3', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONOLACTONASE 3, CHLOROPLASTIC-RELATED', 246922),
(370654, 'PTHR11054', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONOLACTONASE', 246922),
(370655, 'PTHR11054:SF1', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONOLACTONASE-LIKE PROTEIN 1-RELATED', 246922),
(370656, 'PTHR11054:SF0', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONOLACTONASE', 246922);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(370657, 'PTHR45790:SF3', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT UROPORPHYRINOGEN III METHYLTRANSFERASE, CHLOROPLASTIC', 246923),
(370658, 'PTHR45790:SF4', NULL, NULL, NULL, NULL, 'COBALT-PRECORRIN-4 C(11)-METHYLTRANSFERASE', 246923),
(370659, 'PTHR45790', NULL, NULL, NULL, NULL, 'SIROHEME SYNTHASE-RELATED', 246923),
(370660, 'PTHR45790:SF1', NULL, NULL, NULL, NULL, 'SIROHEME SYNTHASE', 246923),
(370661, 'PTHR45790:SF6', NULL, NULL, NULL, NULL, 'UROPORPHYRINOGEN-III C-METHYLTRANSFERASE', 246923),
(370662, 'PTHR37615:SF1', NULL, NULL, NULL, NULL, 'NUCLEOPORIN NUP159-LIKE', 246924),
(370663, 'PTHR37615', NULL, NULL, NULL, NULL, 'NUCLEOPORIN NUP159-LIKE', 246924),
(370664, 'PTHR33170', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN-RELATED', 246925),
(370665, 'PTHR33170:SF22', NULL, NULL, NULL, NULL, 'OS10G0417100 PROTEIN', 246925),
(370666, 'PTHR33170:SF44', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 246925),
(370667, 'PTHR33170:SF24', NULL, NULL, NULL, NULL, '', 246925),
(370668, 'PTHR33170:SF46', NULL, NULL, NULL, NULL, '', 246925),
(370669, 'PTHR33170:SF34', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 246925),
(370670, 'PTHR33170:SF45', NULL, NULL, NULL, NULL, 'OS01G0148700 PROTEIN', 246925),
(370671, 'PTHR33170:SF23', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 246925),
(370672, 'PTHR33170:SF37', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 246925),
(370673, 'PTHR33170:SF47', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 246925),
(370674, 'PTHR33170:SF38', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 246925),
(370675, 'PTHR33170:SF40', NULL, NULL, NULL, NULL, 'OS04G0557100 PROTEIN', 246925),
(370676, 'PTHR33170:SF41', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 246925),
(370677, 'PTHR33170:SF30', NULL, NULL, NULL, NULL, 'OS05G0102200 PROTEIN', 246925),
(370678, 'PTHR33170:SF8', NULL, NULL, NULL, NULL, 'OS07G0485366 PROTEIN', 246925),
(370679, 'PTHR33170:SF2', NULL, NULL, NULL, NULL, 'OS12G0531500 PROTEIN', 246925),
(370680, 'PTHR11606:SF31', NULL, NULL, NULL, NULL, 'GLUTAMATE DEHYDROGENASE', 246926),
(370681, 'PTHR11606:SF30', NULL, NULL, NULL, NULL, 'GLUTAMATE DEHYDROGENASE 1', 246926),
(370682, 'PTHR11606:SF33', NULL, NULL, NULL, NULL, 'GLUTAMATE DEHYDROGENASE (NAD(P)(+))', 246926),
(370683, 'PTHR11606:SF7', NULL, NULL, NULL, NULL, 'GLUTAMATE DEHYDROGENASE', 246926),
(370684, 'PTHR11606:SF40', NULL, NULL, NULL, NULL, 'GLUTAMATE DEHYDROGENASE', 246926),
(370685, 'PTHR11606:SF39', NULL, NULL, NULL, NULL, 'ELFV_DEHYDROG DOMAIN-CONTAINING PROTEIN', 246926),
(370686, 'PTHR11606:SF28', NULL, NULL, NULL, NULL, 'GLUTAMATE DEHYDROGENASE', 246926),
(370687, 'PTHR11606', NULL, NULL, NULL, NULL, 'GLUTAMATE DEHYDROGENASE', 246926),
(370688, 'PTHR11606:SF29', NULL, NULL, NULL, NULL, 'GLUTAMATE DEHYDROGENASE 3-RELATED', 246926),
(370689, 'PTHR11606:SF13', NULL, NULL, NULL, NULL, 'GLUTAMATE DEHYDROGENASE 1, MITOCHONDRIAL', 246926),
(370690, 'PTHR11606:SF24', NULL, NULL, NULL, NULL, 'NAD-SPECIFIC GLUTAMATE DEHYDROGENASE', 246926),
(370691, 'PTHR11606:SF34', NULL, NULL, NULL, NULL, 'ELFV_DEHYDROG DOMAIN-CONTAINING PROTEIN', 246926),
(370692, 'PTHR11606:SF15', NULL, NULL, NULL, NULL, 'GLUTAMATE DEHYDROGENASE 2, MITOCHONDRIAL', 246926),
(370693, 'PTHR11606:SF25', NULL, NULL, NULL, NULL, 'GLUTAMATE DEHYDROGENASE 1, MITOCHONDRIAL', 246926),
(370694, 'PTHR11606:SF36', NULL, NULL, NULL, NULL, 'GLUTAMATE DEHYDROGENASE', 246926),
(370695, 'PTHR21694:SF36', NULL, NULL, NULL, NULL, 'OUTER DYNEIN ARM DOCKING COMPLEX-RELATED', 246927),
(370696, 'PTHR21694:SF35', NULL, NULL, NULL, NULL, 'OUTER DYNEIN ARM-DOCKING COMPLEX SUBUNIT 1', 246927),
(370697, 'PTHR21694:SF18', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 63', 246927),
(370698, 'PTHR21694', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 246927),
(370699, 'PTHR45718', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR CUBITUS INTERRUPTUS', 246928),
(370700, 'PTHR45718:SF6', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN GLI2', 246928);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(370701, 'PTHR45718:SF7', NULL, NULL, NULL, NULL, '', 246928),
(370702, 'PTHR45718:SF4', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR CUBITUS INTERRUPTUS', 246928),
(370703, 'PTHR45718:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR GLI3', 246928),
(370704, 'PTHR45718:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN GLI1', 246928),
(370705, 'PTHR45718:SF3', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN GLIS1', 246928),
(370706, 'PTHR45718:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN GLIS3', 246928),
(370707, 'PTHR11071:SF11', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE C', 246929),
(370708, 'PTHR11071:SF385', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370709, 'PTHR11071:SF461', NULL, NULL, NULL, NULL, 'OS02G0761100 PROTEIN', 246929),
(370710, 'PTHR11071:SF538', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP19-1', 246929),
(370711, 'PTHR11071:SF537', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370712, 'PTHR11071:SF533', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP18-4', 246929),
(370713, 'PTHR11071:SF532', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370714, 'PTHR11071:SF257', NULL, NULL, NULL, NULL, 'NK-TUMOR RECOGNITION PROTEIN', 246929),
(370715, 'PTHR11071:SF499', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370716, 'PTHR11071:SF454', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370717, 'PTHR11071:SF498', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370718, 'PTHR11071:SF453', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370719, 'PTHR11071:SF497', NULL, NULL, NULL, NULL, 'GH06403P', 246929),
(370720, 'PTHR11071:SF496', NULL, NULL, NULL, NULL, 'PPIASE CYCLOPHILIN-TYPE DOMAIN-CONTAINING PROTEIN', 246929),
(370721, 'PTHR11071:SF550', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP20-1', 246929),
(370722, 'PTHR11071', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370723, 'PTHR11071:SF472', NULL, NULL, NULL, NULL, 'PPIASE CYCLOPHILIN-TYPE DOMAIN-CONTAINING PROTEIN', 246929),
(370724, 'PTHR11071:SF509', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370725, 'PTHR11071:SF506', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370726, 'PTHR11071:SF549', NULL, NULL, NULL, NULL, 'TYPE PEPTIDYL-PROLYL CIS-TRANS ISOMERASE, PUTATIVE-RELATED', 246929),
(370727, 'PTHR11071:SF504', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370728, 'PTHR11071:SF427', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE 8', 246929),
(370729, 'PTHR11071:SF548', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370730, 'PTHR11071:SF547', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370731, 'PTHR11071:SF546', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP19-3', 246929),
(370732, 'PTHR11071:SF469', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370733, 'PTHR11071:SF545', NULL, NULL, NULL, NULL, 'PPIASE CYCLOPHILIN-TYPE DOMAIN-CONTAINING PROTEIN', 246929),
(370734, 'PTHR11071:SF467', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP21-2', 246929),
(370735, 'PTHR11071:SF466', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE A-LIKE 4C-RELATED', 246929),
(370736, 'PTHR11071:SF389', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE, PUTATIVE-RELATED', 246929),
(370737, 'PTHR11071:SF420', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP20-3, CHLOROPLASTIC', 246929),
(370738, 'PTHR11071:SF222', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE 2', 246929),
(370739, 'PTHR11071:SF541', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP40-LIKE', 246929),
(370740, 'PTHR11071:SF561', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE D-RELATED', 246929),
(370741, 'PTHR11071:SF484', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(370742, 'PTHR11071:SF560', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370743, 'PTHR11071:SF480', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370744, 'PTHR11071:SF519', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE E', 246929),
(370745, 'PTHR11071:SF515', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370746, 'PTHR11071:SF559', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370747, 'PTHR11071:SF437', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370748, 'PTHR11071:SF514', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP95', 246929),
(370749, 'PTHR11071:SF558', NULL, NULL, NULL, NULL, 'YCF3-RELATED', 246929),
(370750, 'PTHR11071:SF436', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 246929),
(370751, 'PTHR11071:SF513', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370752, 'PTHR11071:SF557', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370753, 'PTHR11071:SF556', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 246929),
(370754, 'PTHR11071:SF555', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP40-LIKE', 246929),
(370755, 'PTHR11071:SF511', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370756, 'PTHR11071:SF478', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE, RHODOPSIN-SPECIFIC ISOZYME', 246929),
(370757, 'PTHR11071:SF477', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE B', 246929),
(370758, 'PTHR11071:SF433', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370759, 'PTHR11071:SF554', NULL, NULL, NULL, NULL, 'PPIASE CYCLOPHILIN-TYPE DOMAIN-CONTAINING PROTEIN', 246929),
(370760, 'PTHR11071:SF476', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370761, 'PTHR11071:SF553', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370762, 'PTHR11071:SF552', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP26-1', 246929),
(370763, 'PTHR11071:SF431', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370764, 'PTHR11071:SF551', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370765, 'PTHR11071:SF450', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE A-LIKE 4A', 246929),
(370766, 'PTHR11071:SF293', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE 6', 246929),
(370767, 'PTHR11071:SF490', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE A', 246929),
(370768, 'PTHR11071:SF292', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE G', 246929),
(370769, 'PTHR11071:SF408', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE F, MITOCHONDRIAL', 246929),
(370770, 'PTHR11071:SF528', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370771, 'PTHR11071:SF527', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370772, 'PTHR11071:SF449', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP21-1', 246929),
(370773, 'PTHR11071:SF525', NULL, NULL, NULL, NULL, 'CYCLOPHILIN-TYPE PEPTIDYL-PROLYL CIS-TRANS ISOMERASE DOMAIN-CONTAINING PROTEIN-RELATED', 246929),
(370774, 'PTHR11071:SF327', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE C, MITOCHONDRIAL', 246929),
(370775, 'PTHR11071:SF447', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP63', 246929),
(370776, 'PTHR11071:SF568', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CPR4-RELATED', 246929),
(370777, 'PTHR11071:SF567', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370778, 'PTHR11071:SF566', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE 1', 246929),
(370779, 'PTHR11071:SF565', NULL, NULL, NULL, NULL, 'MOCA-CYP, ISOFORM A', 246929),
(370780, 'PTHR11071:SF488', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370781, 'PTHR11071:SF564', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP95', 246929); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(370782, 'PTHR11071:SF443', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE H', 246929),
(370783, 'PTHR11071:SF563', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370784, 'PTHR11071:SF562', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP19-4', 246929),
(370785, 'PTHR11071:SF441', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 246929),
(370786, 'PTHR31796', NULL, NULL, NULL, NULL, 'SUZ DOMAIN-CONTAINING PROTEIN 1', 246930),
(370787, 'PTHR31796:SF2', NULL, NULL, NULL, NULL, 'SUZ DOMAIN-CONTAINING PROTEIN 1', 246930),
(370788, 'PTHR31796:SF3', NULL, NULL, NULL, NULL, 'SUZ-C DOMAIN-CONTAINING PROTEIN', 246930),
(370789, 'PTHR31796:SF4', NULL, NULL, NULL, NULL, 'SUZ DOMAIN-CONTAINING PROTEIN 1', 246930),
(370790, 'PTHR24128:SF80', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 246931),
(370791, 'PTHR24128:SF81', NULL, NULL, NULL, NULL, 'REPEAT FAMILY PROTEIN, PUTATIVE-RELATED', 246931),
(370792, 'PTHR24128:SF39', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN-RELATED', 246931),
(370793, 'PTHR24128:SF35', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE XBAT33', 246931),
(370794, 'PTHR24128:SF38', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 246931),
(370795, 'PTHR24128:SF76', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 246931),
(370796, 'PTHR24128:SF71', NULL, NULL, NULL, NULL, 'BNAA04G16730D PROTEIN', 246931),
(370797, 'PTHR24128:SF72', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 246931),
(370798, 'PTHR24128:SF100', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 246931),
(370799, 'PTHR24128:SF70', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT PROTEIN', 246931),
(370800, 'PTHR24128:SF103', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING DOMAIN, PGG DOMAIN PROTEIN-RELATED', 246931),
(370801, 'PTHR24128:SF104', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING PROTEIN ITN1-LIKE', 246931),
(370802, 'PTHR24128:SF101', NULL, NULL, NULL, NULL, 'OS06G0292400 PROTEIN', 246931),
(370803, 'PTHR24128:SF102', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 246931),
(370804, 'PTHR24128', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN WARIAI', 246931),
(370805, 'PTHR24128:SF24', NULL, NULL, NULL, NULL, 'PGG DOMAIN-CONTAINING PROTEIN', 246931),
(370806, 'PTHR24128:SF68', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE XBOS35-RELATED', 246931),
(370807, 'PTHR24128:SF65', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE XBOS31-RELATED', 246931),
(370808, 'PTHR24128:SF66', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 246931),
(370809, 'PTHR24128:SF60', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN WARIAI-LIKE', 246931),
(370810, 'PTHR24128:SF61', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 246931),
(370811, 'PTHR24128:SF18', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE XBOS36-RELATED', 246931),
(370812, 'PTHR24128:SF14', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE XBAT31-RELATED', 246931),
(370813, 'PTHR24128:SF97', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE XBAT31-RELATED', 246931),
(370814, 'PTHR24128:SF98', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING PROTEIN ITN1-LIKE', 246931),
(370815, 'PTHR24128:SF55', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 246931),
(370816, 'PTHR24128:SF99', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 246931),
(370817, 'PTHR24128:SF12', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE XBAT32', 246931),
(370818, 'PTHR24128:SF93', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING PROTEIN BDA1-LIKE ISOFORM X1', 246931),
(370819, 'PTHR24128:SF94', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE XB3', 246931),
(370820, 'PTHR24128:SF95', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 246931),
(370821, 'PTHR24128:SF52', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE XBAT31-RELATED', 246931),
(370822, 'PTHR24128:SF96', NULL, NULL, NULL, NULL, 'ANKYRIN', 246931);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(370823, 'PTHR24128:SF90', NULL, NULL, NULL, NULL, 'PGG DOMAIN-CONTAINING PROTEIN', 246931),
(370824, 'PTHR24128:SF91', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 246931),
(370825, 'PTHR24128:SF92', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 246931),
(370826, 'PTHR24128:SF46', NULL, NULL, NULL, NULL, 'ALPHA-LATROTOXIN-LHE1A-LIKE ISOFORM X1', 246931),
(370827, 'PTHR24128:SF48', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE XBAT31-RELATED', 246931),
(370828, 'PTHR24128:SF86', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 246931),
(370829, 'PTHR24128:SF87', NULL, NULL, NULL, NULL, 'REPEAT PROTEIN, PUTATIVE-RELATED', 246931),
(370830, 'PTHR24128:SF43', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE 43 KDA PROTEIN, CHLOROPLASTIC', 246931),
(370831, 'PTHR24128:SF88', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING DOMAIN, PGG DOMAIN PROTEIN-RELATED', 246931),
(370832, 'PTHR24128:SF89', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE XBAT31-RELATED', 246931),
(370833, 'PTHR24128:SF82', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE XBAT31-LIKE PROTEIN', 246931),
(370834, 'PTHR24128:SF83', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 246931),
(370835, 'PTHR24128:SF40', NULL, NULL, NULL, NULL, 'ALPHA-LATROINSECTOTOXIN-LT1A-LIKE', 246931),
(370836, 'PTHR24128:SF84', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING PROTEIN BDA1-LIKE', 246931),
(370837, 'PTHR24128:SF41', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE XBOS35-RELATED', 246931),
(370838, 'PTHR24128:SF85', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 246931),
(370839, 'PTHR33776', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 246932),
(370840, 'PTHR33776:SF3', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 246932),
(370841, 'PTHR33776:SF4', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 246932),
(370842, 'PTHR31371:SF25', NULL, NULL, NULL, NULL, 'PLANT/T32M21-140 PROTEIN', 246933),
(370843, 'PTHR31371:SF14', NULL, NULL, NULL, NULL, 'SIMILARITY TO UNKNOWN PROTEIN', 246933),
(370844, 'PTHR31371:SF13', NULL, NULL, NULL, NULL, 'OS05G0457600 PROTEIN', 246933),
(370845, 'PTHR31371:SF24', NULL, NULL, NULL, NULL, '', 246933),
(370846, 'PTHR31371:SF12', NULL, NULL, NULL, NULL, 'AVR9/CF-9 RAPIDLY ELICITED PROTEIN', 246933),
(370847, 'PTHR31371:SF22', NULL, NULL, NULL, NULL, 'PLANT/T32M21-140 PROTEIN', 246933),
(370848, 'PTHR31371:SF11', NULL, NULL, NULL, NULL, 'DUF3475 DOMAIN PROTEIN', 246933),
(370849, 'PTHR31371:SF10', NULL, NULL, NULL, NULL, 'DUF3475 DOMAIN PROTEIN', 246933),
(370850, 'PTHR31371:SF20', NULL, NULL, NULL, NULL, 'DUF668 DOMAIN-CONTAINING PROTEIN', 246933),
(370851, 'PTHR31371:SF2', NULL, NULL, NULL, NULL, 'PLANT/PROTEIN (DUF668)', 246933),
(370852, 'PTHR31371:SF19', NULL, NULL, NULL, NULL, 'DUF668 DOMAIN-CONTAINING PROTEIN', 246933),
(370853, 'PTHR31371:SF18', NULL, NULL, NULL, NULL, '', 246933),
(370854, 'PTHR31371:SF17', NULL, NULL, NULL, NULL, 'BNAC02G02650D PROTEIN', 246933),
(370855, 'PTHR31371', NULL, NULL, NULL, NULL, 'BNAC09G50660D PROTEIN', 246933),
(370856, 'PTHR31371:SF4', NULL, NULL, NULL, NULL, 'PLANT/T32M21-140 PROTEIN', 246933),
(370857, 'PTHR12345:SF3', NULL, NULL, NULL, NULL, 'SYNTENIN-1-LIKE PROTEIN', 246934),
(370858, 'PTHR12345:SF13', NULL, NULL, NULL, NULL, 'SYNTENIN-2', 246934),
(370859, 'PTHR12345:SF14', NULL, NULL, NULL, NULL, 'AMYLOID-BETA A4 PRECURSOR PROTEIN-BINDING FAMILY A MEMBER 1', 246934),
(370860, 'PTHR12345:SF22', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN', 246934),
(370861, 'PTHR12345:SF11', NULL, NULL, NULL, NULL, 'FI13065P', 246934),
(370862, 'PTHR12345:SF23', NULL, NULL, NULL, NULL, '', 246934),
(370863, 'PTHR12345:SF12', NULL, NULL, NULL, NULL, 'AMYLOID-BETA A4 PRECURSOR PROTEIN-BINDING FAMILY A MEMBER 2', 246934),
(370864, 'PTHR12345:SF17', NULL, NULL, NULL, NULL, 'SDCBP PROTEIN', 246934),
(370865, 'PTHR12345:SF18', NULL, NULL, NULL, NULL, 'SYNDECAN-BINDING PROTEIN (SYNTENIN)', 246934);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(370866, 'PTHR12345:SF16', NULL, NULL, NULL, NULL, 'X11L, ISOFORM F-RELATED', 246934),
(370867, 'PTHR12345:SF9', NULL, NULL, NULL, NULL, 'AMYLOID-BETA A4 PRECURSOR PROTEIN-BINDING FAMILY A MEMBER 3', 246934),
(370868, 'PTHR12345', NULL, NULL, NULL, NULL, 'SYNTENIN RELATED', 246934),
(370869, 'PTHR12345:SF10', NULL, NULL, NULL, NULL, 'SYNTENIN-1', 246934),
(370870, 'PTHR31683:SF119', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370871, 'PTHR31683:SF190', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370872, 'PTHR31683:SF69', NULL, NULL, NULL, NULL, 'PECTATE LYASE 7-RELATED', 246935),
(370873, 'PTHR31683:SF191', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370874, 'PTHR31683:SF67', NULL, NULL, NULL, NULL, 'PECTIN LYASE F-RELATED', 246935),
(370875, 'PTHR31683:SF192', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370876, 'PTHR31683:SF193', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370877, 'PTHR31683:SF29', NULL, NULL, NULL, NULL, 'PECTATE LYASE 11-RELATED', 246935),
(370878, 'PTHR31683:SF150', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370879, 'PTHR31683:SF194', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370880, 'PTHR31683:SF195', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370881, 'PTHR31683:SF152', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370882, 'PTHR31683:SF196', NULL, NULL, NULL, NULL, 'PECTATE LYASE 15-RELATED', 246935),
(370883, 'PTHR31683:SF197', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370884, 'PTHR31683:SF153', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370885, 'PTHR31683:SF198', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370886, 'PTHR31683:SF199', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370887, 'PTHR31683:SF112', NULL, NULL, NULL, NULL, 'PECTATE LYASE 10-RELATED', 246935),
(370888, 'PTHR31683:SF113', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370889, 'PTHR31683:SF157', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370890, 'PTHR31683', NULL, NULL, NULL, NULL, 'PECTATE LYASE 18-RELATED', 246935),
(370891, 'PTHR31683:SF21', NULL, NULL, NULL, NULL, 'PECTATE LYASE 12-RELATED', 246935),
(370892, 'PTHR31683:SF159', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370893, 'PTHR31683:SF116', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370894, 'PTHR31683:SF181', NULL, NULL, NULL, NULL, 'PECTATE LYASE 3-RELATED', 246935),
(370895, 'PTHR31683:SF182', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370896, 'PTHR31683:SF11', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370897, 'PTHR31683:SF18', NULL, NULL, NULL, NULL, 'PECTATE LYASE A-RELATED', 246935),
(370898, 'PTHR31683:SF183', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370899, 'PTHR31683:SF140', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370900, 'PTHR31683:SF184', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370901, 'PTHR31683:SF16', NULL, NULL, NULL, NULL, 'PECTIN LYASE A-RELATED', 246935),
(370902, 'PTHR31683:SF186', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370903, 'PTHR31683:SF143', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370904, 'PTHR31683:SF187', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370905, 'PTHR31683:SF144', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370906, 'PTHR31683:SF188', NULL, NULL, NULL, NULL, 'PECTATE LYASE 18-RELATED', 246935),
(370907, 'PTHR31683:SF189', NULL, NULL, NULL, NULL, 'PECTATE LYASE 8-RELATED', 246935),
(370908, 'PTHR31683:SF101', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370909, 'PTHR31683:SF145', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370910, 'PTHR31683:SF147', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370911, 'PTHR31683:SF104', NULL, NULL, NULL, NULL, 'PECTATE LYASE 22-RELATED', 246935),
(370912, 'PTHR31683:SF96', NULL, NULL, NULL, NULL, 'PECTATE LYASE 14-RELATED', 246935),
(370913, 'PTHR31683:SF105', NULL, NULL, NULL, NULL, 'PECTATE LYASE 2-RELATED', 246935),
(370914, 'PTHR31683:SF106', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370915, 'PTHR31683:SF170', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(370916, 'PTHR31683:SF88', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370917, 'PTHR31683:SF171', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370918, 'PTHR31683:SF172', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370919, 'PTHR31683:SF173', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370920, 'PTHR31683:SF130', NULL, NULL, NULL, NULL, 'PECTATE LYASE 1-RELATED', 246935),
(370921, 'PTHR31683:SF131', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370922, 'PTHR31683:SF133', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370923, 'PTHR31683:SF82', NULL, NULL, NULL, NULL, 'PECTATE LYASE P56-RELATED', 246935),
(370924, 'PTHR31683:SF134', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370925, 'PTHR31683:SF80', NULL, NULL, NULL, NULL, 'PECTATE LYASE 16-RELATED', 246935),
(370926, 'PTHR31683:SF136', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370927, 'PTHR31683:SF86', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370928, 'PTHR31683:SF138', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370929, 'PTHR31683:SF85', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370930, 'PTHR31683:SF139', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370931, 'PTHR31683:SF129', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370932, 'PTHR31683:SF33', NULL, NULL, NULL, NULL, 'PECTATE LYASE 21-RELATED', 246935),
(370933, 'PTHR31683:SF77', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370934, 'PTHR31683:SF160', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370935, 'PTHR31683:SF161', NULL, NULL, NULL, NULL, 'PECTATE LYASE 19-RELATED', 246935),
(370936, 'PTHR31683:SF162', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370937, 'PTHR31683:SF163', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370938, 'PTHR31683:SF120', NULL, NULL, NULL, NULL, 'PECTATE LYASE 20-RELATED', 246935),
(370939, 'PTHR31683:SF164', NULL, NULL, NULL, NULL, 'PECTATE LYASE 5-RELATED', 246935),
(370940, 'PTHR31683:SF121', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370941, 'PTHR31683:SF165', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370942, 'PTHR31683:SF166', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370943, 'PTHR31683:SF70', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370944, 'PTHR31683:SF200', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370945, 'PTHR31683:SF123', NULL, NULL, NULL, NULL, 'PECTATE LYASE 6-RELATED', 246935),
(370946, 'PTHR31683:SF201', NULL, NULL, NULL, NULL, 'PECTATE LYASE 13-RELATED', 246935),
(370947, 'PTHR31683:SF124', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370948, 'PTHR31683:SF125', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370949, 'PTHR31683:SF169', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370950, 'PTHR31683:SF76', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370951, 'PTHR31683:SF74', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370952, 'PTHR31683:SF127', NULL, NULL, NULL, NULL, 'PECTATE LYASE', 246935),
(370953, 'PTHR33083:SF119', NULL, NULL, NULL, NULL, 'SENESCENCE REGULATOR S40-RELATED', 246936),
(370954, 'PTHR33083:SF118', NULL, NULL, NULL, NULL, '', 246936),
(370955, 'PTHR33083:SF49', NULL, NULL, NULL, NULL, 'OS01G0748300 PROTEIN', 246936),
(370956, 'PTHR33083:SF111', NULL, NULL, NULL, NULL, 'OJ000126_13.10 PROTEIN', 246936),
(370957, 'PTHR33083:SF110', NULL, NULL, NULL, NULL, 'BNAA05G09520D PROTEIN', 246936),
(370958, 'PTHR33083:SF113', NULL, NULL, NULL, NULL, 'OJ000126_13.10 PROTEIN', 246936),
(370959, 'PTHR33083:SF112', NULL, NULL, NULL, NULL, 'BNAC03G62980D PROTEIN', 246936),
(370960, 'PTHR33083:SF89', NULL, NULL, NULL, NULL, 'BNAANNG41640D PROTEIN', 246936),
(370961, 'PTHR33083:SF115', NULL, NULL, NULL, NULL, 'OS01G0862600 PROTEIN', 246936),
(370962, 'PTHR33083:SF88', NULL, NULL, NULL, NULL, 'SENESCENCE REGULATOR S40-RELATED', 246936),
(370963, 'PTHR33083:SF114', NULL, NULL, NULL, NULL, 'OS10G0481000 PROTEIN', 246936),
(370964, 'PTHR33083:SF117', NULL, NULL, NULL, NULL, '', 246936),
(370965, 'PTHR33083:SF69', NULL, NULL, NULL, NULL, '', 246936),
(370966, 'PTHR33083:SF68', NULL, NULL, NULL, NULL, '', 246936);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(370967, 'PTHR33083:SF116', NULL, NULL, NULL, NULL, 'OS04G0413900 PROTEIN', 246936),
(370968, 'PTHR33083:SF63', NULL, NULL, NULL, NULL, 'BNAA03G48340D PROTEIN', 246936),
(370969, 'PTHR33083:SF87', NULL, NULL, NULL, NULL, 'OS01G0727500 PROTEIN', 246936),
(370970, 'PTHR33083:SF64', NULL, NULL, NULL, NULL, 'OS01G0727700 PROTEIN', 246936),
(370971, 'PTHR33083:SF81', NULL, NULL, NULL, NULL, 'OS05G0518800 PROTEIN', 246936),
(370972, 'PTHR33083:SF80', NULL, NULL, NULL, NULL, 'BNAC01G36420D PROTEIN', 246936),
(370973, 'PTHR33083:SF83', NULL, NULL, NULL, NULL, 'BNAA07G36440D PROTEIN', 246936),
(370974, 'PTHR33083:SF120', NULL, NULL, NULL, NULL, 'ATS40-3', 246936),
(370975, 'PTHR33083:SF82', NULL, NULL, NULL, NULL, 'SENESCENCE REGULATOR S40-RELATED', 246936),
(370976, 'PTHR33083:SF109', NULL, NULL, NULL, NULL, 'BNAC09G13940D PROTEIN', 246936),
(370977, 'PTHR33083:SF19', NULL, NULL, NULL, NULL, 'OS05G0531100 PROTEIN', 246936),
(370978, 'PTHR33083', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246936),
(370979, 'PTHR33083:SF102', NULL, NULL, NULL, NULL, '', 246936),
(370980, 'PTHR33083:SF55', NULL, NULL, NULL, NULL, 'OS07G0512250 PROTEIN', 246936),
(370981, 'PTHR33083:SF103', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246936),
(370982, 'PTHR33083:SF106', NULL, NULL, NULL, NULL, '', 246936),
(370983, 'PTHR33083:SF58', NULL, NULL, NULL, NULL, 'BNACNNG18100D PROTEIN', 246936),
(370984, 'PTHR33083:SF79', NULL, NULL, NULL, NULL, 'SENESCENCE REGULATOR S40-RELATED', 246936),
(370985, 'PTHR33083:SF74', NULL, NULL, NULL, NULL, '', 246936),
(370986, 'PTHR33083:SF96', NULL, NULL, NULL, NULL, '', 246936),
(370987, 'PTHR33083:SF97', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246936),
(370988, 'PTHR33083:SF72', NULL, NULL, NULL, NULL, 'BNAA09G26720D PROTEIN', 246936),
(370989, 'PTHR33083:SF94', NULL, NULL, NULL, NULL, 'BNAC03G59240D PROTEIN', 246936),
(370990, 'PTHR33083:SF50', NULL, NULL, NULL, NULL, 'BNACNNG59690D PROTEIN', 246936),
(370991, 'PTHR33083:SF93', NULL, NULL, NULL, NULL, 'OS07G0516300 PROTEIN', 246936),
(370992, 'PTHR33083:SF71', NULL, NULL, NULL, NULL, 'OS05G0531000 PROTEIN', 246936),
(370993, 'PTHR31621:SF49', NULL, NULL, NULL, NULL, 'BNAA01G08420D PROTEIN', 246937),
(370994, 'PTHR31621:SF27', NULL, NULL, NULL, NULL, 'OS01G0368500 PROTEIN', 246937),
(370995, 'PTHR31621:SF28', NULL, NULL, NULL, NULL, 'DUF679 DOMAIN MEMBRANE PROTEIN 7', 246937),
(370996, 'PTHR31621:SF29', NULL, NULL, NULL, NULL, 'OS07G0645300 PROTEIN', 246937),
(370997, 'PTHR31621:SF66', NULL, NULL, NULL, NULL, 'PROTEIN DMP2', 246937),
(370998, 'PTHR31621:SF67', NULL, NULL, NULL, NULL, 'OS01G0389200 PROTEIN', 246937),
(370999, 'PTHR31621:SF46', NULL, NULL, NULL, NULL, '', 246937),
(371000, 'PTHR31621:SF69', NULL, NULL, NULL, NULL, 'POLLEN-SPECIFIC LEUCINE-RICH REPEAT EXTENSIN-LIKE PROTEIN 1', 246937),
(371001, 'PTHR31621:SF40', NULL, NULL, NULL, NULL, '', 246937),
(371002, 'PTHR31621:SF62', NULL, NULL, NULL, NULL, 'BNAA05G19650D PROTEIN', 246937),
(371003, 'PTHR31621:SF1', NULL, NULL, NULL, NULL, 'PROTEIN DMP5', 246937),
(371004, 'PTHR31621:SF0', NULL, NULL, NULL, NULL, 'PROTEIN DMP6', 246937),
(371005, 'PTHR31621:SF63', NULL, NULL, NULL, NULL, 'BNAA03G55920D PROTEIN', 246937),
(371006, 'PTHR31621:SF42', NULL, NULL, NULL, NULL, 'DUF679 DOMAIN MEMBRANE PROTEIN 7', 246937),
(371007, 'PTHR31621:SF3', NULL, NULL, NULL, NULL, 'OS06G0352200 PROTEIN', 246937),
(371008, 'PTHR31621:SF43', NULL, NULL, NULL, NULL, '', 246937),
(371009, 'PTHR31621:SF65', NULL, NULL, NULL, NULL, 'BNAC03G76810D PROTEIN', 246937),
(371010, 'PTHR31621:SF5', NULL, NULL, NULL, NULL, 'PROTEIN DMP10', 246937),
(371011, 'PTHR31621', NULL, NULL, NULL, NULL, 'PROTEIN DMP3', 246937),
(371012, 'PTHR31621:SF7', NULL, NULL, NULL, NULL, 'OS07G0407900 PROTEIN', 246937),
(371013, 'PTHR31621:SF71', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 246937),
(371014, 'PTHR31621:SF72', NULL, NULL, NULL, NULL, 'DUF679 DOMAIN MEMBRANE PROTEIN 7', 246937),
(371015, 'PTHR31621:SF6', NULL, NULL, NULL, NULL, 'PROTEIN DMP7', 246937),
(371016, 'PTHR31621:SF50', NULL, NULL, NULL, NULL, 'BNAA01G25000D PROTEIN', 246937); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(371017, 'PTHR31621:SF9', NULL, NULL, NULL, NULL, 'OS12G0411500 PROTEIN', 246937),
(371018, 'PTHR31621:SF37', NULL, NULL, NULL, NULL, 'DUF679 DOMAIN MEMBRANE PROTEIN 2', 246937),
(371019, 'PTHR31621:SF59', NULL, NULL, NULL, NULL, '', 246937),
(371020, 'PTHR31621:SF38', NULL, NULL, NULL, NULL, 'PROTEIN DMP4', 246937),
(371021, 'PTHR31621:SF55', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 246937),
(371022, 'PTHR31621:SF11', NULL, NULL, NULL, NULL, 'PROTEIN DMP8-RELATED', 246937),
(371023, 'PTHR31621:SF34', NULL, NULL, NULL, NULL, 'DOMAIN MEMBRANE PROTEIN 2, PUTATIVE-RELATED', 246937),
(371024, 'PTHR31621:SF56', NULL, NULL, NULL, NULL, '', 246937),
(371025, 'PTHR31621:SF57', NULL, NULL, NULL, NULL, 'BNAA06G36210D PROTEIN', 246937),
(371026, 'PTHR31621:SF73', NULL, NULL, NULL, NULL, '', 246937),
(371027, 'PTHR31621:SF52', NULL, NULL, NULL, NULL, 'BNAA08G14730D PROTEIN', 246937),
(371028, 'PTHR31621:SF74', NULL, NULL, NULL, NULL, 'DUF679 DOMAIN MEMBRANE PROTEIN 7', 246937),
(371029, 'PTHR31621:SF31', NULL, NULL, NULL, NULL, '', 246937),
(371030, 'PTHR31621:SF53', NULL, NULL, NULL, NULL, '', 246937),
(371031, 'PTHR31621:SF75', NULL, NULL, NULL, NULL, 'PROTEIN DMP3', 246937),
(371032, 'PTHR31621:SF32', NULL, NULL, NULL, NULL, 'PROTEIN DMP1', 246937),
(371033, 'PTHR31621:SF61', NULL, NULL, NULL, NULL, '', 246937),
(371034, 'PTHR31634:SF2', NULL, NULL, NULL, NULL, 'BLOC-1-RELATED COMPLEX SUBUNIT 5', 246938),
(371035, 'PTHR31634', NULL, NULL, NULL, NULL, 'BLOC-1-RELATED COMPLEX SUBUNIT 5', 246938),
(371036, 'PTHR47005:SF9', NULL, NULL, NULL, NULL, 'CIRCUMSPOROZOITE PROTEIN', 246939),
(371037, 'PTHR47005:SF10', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED DOMAIN, HMA-RELATED', 246939),
(371038, 'PTHR47005:SF11', NULL, NULL, NULL, NULL, 'OS04G0401100 PROTEIN', 246939),
(371039, 'PTHR47005:SF12', NULL, NULL, NULL, NULL, 'OS04G0400700 PROTEIN', 246939),
(371040, 'PTHR47005:SF5', NULL, NULL, NULL, NULL, 'POLLEN-SPECIFIC LEUCINE-RICH REPEAT EXTENSIN-LIKE PROTEIN 1', 246939),
(371041, 'PTHR47005:SF13', NULL, NULL, NULL, NULL, 'IGA FC RECEPTOR', 246939),
(371042, 'PTHR47005:SF6', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 246939),
(371043, 'PTHR47005:SF14', NULL, NULL, NULL, NULL, '', 246939),
(371044, 'PTHR47005', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORT/DETOXIFICATION SUPERFAMILY PROTEIN', 246939),
(371045, 'PTHR47005:SF16', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORT/DETOXIFICATION SUPERFAMILY PROTEIN', 246939),
(371046, 'PTHR47005:SF17', NULL, NULL, NULL, NULL, 'OS11G0629100 PROTEIN', 246939),
(371047, 'PTHR47005:SF2', NULL, NULL, NULL, NULL, 'NEUROFILAMENT HEAVY POLYPEPTIDE-LIKE', 246939),
(371048, 'PTHR40376:SF1', NULL, NULL, NULL, NULL, 'ODONTOGENESIS ASSOCIATED PHOSPHOPROTEIN', 246940),
(371049, 'PTHR40376', NULL, NULL, NULL, NULL, 'ODONTOGENESIS ASSOCIATED PHOSPHOPROTEIN', 246940),
(371050, 'PTHR22706:SF1', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 17', 246941),
(371051, 'PTHR22706', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 246941),
(371052, 'PTHR22706:SF2', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 246941),
(371053, 'PTHR47044', NULL, NULL, NULL, NULL, 'OS02G0276400 PROTEIN', 246942),
(371054, 'PTHR47044:SF4', NULL, NULL, NULL, NULL, 'OS02G0276400 PROTEIN', 246942),
(371055, 'PTHR47044:SF2', NULL, NULL, NULL, NULL, 'OS02G0276200 PROTEIN', 246942),
(371056, 'PTHR35277:SF8', NULL, NULL, NULL, NULL, 'BNAA06G11780D PROTEIN', 246943),
(371057, 'PTHR35277:SF17', NULL, NULL, NULL, NULL, 'BNAA10G29050D PROTEIN', 246943),
(371058, 'PTHR35277:SF7', NULL, NULL, NULL, NULL, 'BNAC03G13190D PROTEIN', 246943),
(371059, 'PTHR35277:SF16', NULL, NULL, NULL, NULL, '', 246943),
(371060, 'PTHR35277:SF9', NULL, NULL, NULL, NULL, '', 246943),
(371061, 'PTHR35277:SF18', NULL, NULL, NULL, NULL, '', 246943),
(371062, 'PTHR35277', NULL, NULL, NULL, NULL, 'OS09G0363700 PROTEIN', 246943),
(371063, 'PTHR35277:SF12', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 246943),
(371064, 'PTHR35277:SF15', NULL, NULL, NULL, NULL, 'BNAC02G11930D PROTEIN', 246943);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(371065, 'PTHR35277:SF14', NULL, NULL, NULL, NULL, 'BNAC06G24070D PROTEIN', 246943),
(371066, 'PTHR35277:SF10', NULL, NULL, NULL, NULL, 'OS09G0363700 PROTEIN', 246943),
(371067, 'PTHR15679:SF8', NULL, NULL, NULL, NULL, 'PCNA-ASSOCIATED FACTOR', 246944),
(371068, 'PTHR15679', NULL, NULL, NULL, NULL, 'PCNA-ASSOCIATED FACTOR', 246944),
(371069, 'PTHR42106:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 10, WHOLE GENOME SHOTGUN SEQUENCE', 246945),
(371070, 'PTHR42106', NULL, NULL, NULL, NULL, 'CHROMOSOME 10, WHOLE GENOME SHOTGUN SEQUENCE', 246945),
(371071, 'PTHR47128:SF2', NULL, NULL, NULL, NULL, 'PROTEIN HIGH CHLOROPHYLL FLUORESCENCE PHENOTYPE 244, CHLOROPLASTIC', 246946),
(371072, 'PTHR47128', NULL, NULL, NULL, NULL, '', 246946),
(371073, 'PTHR36484:SF1', NULL, NULL, NULL, NULL, 'OS05G0542001 PROTEIN', 246947),
(371074, 'PTHR36484', NULL, NULL, NULL, NULL, 'OS01G0558700 PROTEIN', 246947),
(371075, 'PTHR36484:SF2', NULL, NULL, NULL, NULL, 'OS01G0558700 PROTEIN', 246947),
(371076, 'PTHR11566:SF229', NULL, NULL, NULL, NULL, 'BNAA08G12650D PROTEIN', 246948),
(371077, 'PTHR11566:SF228', NULL, NULL, NULL, NULL, 'DYNAMIN CENTRAL REGION PROTEIN', 246948),
(371078, 'PTHR11566:SF227', NULL, NULL, NULL, NULL, 'DYNAMIN 1E-LIKE PROTEIN', 246948),
(371079, 'PTHR11566:SF226', NULL, NULL, NULL, NULL, '', 246948),
(371080, 'PTHR11566:SF149', NULL, NULL, NULL, NULL, 'GTPASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G11890)-RELATED', 246948),
(371081, 'PTHR11566:SF80', NULL, NULL, NULL, NULL, 'PHRAGMOPLASTIN DRP1C', 246948),
(371082, 'PTHR11566:SF39', NULL, NULL, NULL, NULL, 'DYNAMIN-1-LIKE PROTEIN', 246948),
(371083, 'PTHR11566:SF182', NULL, NULL, NULL, NULL, 'BNAA09G45430D PROTEIN', 246948),
(371084, 'PTHR11566:SF221', NULL, NULL, NULL, NULL, 'DYNAMIN-RELATED PROTEIN 3B-LIKE ISOFORM X1', 246948),
(371085, 'PTHR11566:SF188', NULL, NULL, NULL, NULL, 'DYNAMIN CENTRAL DOMAIN-CONTAINING PROTEIN-RELATED', 246948),
(371086, 'PTHR11566:SF220', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 1', 246948),
(371087, 'PTHR11566:SF186', NULL, NULL, NULL, NULL, 'DYNAMIN RELATED PROTEIN 4C-RELATED', 246948),
(371088, 'PTHR11566:SF185', NULL, NULL, NULL, NULL, 'BNAA08G11490D PROTEIN', 246948),
(371089, 'PTHR11566:SF225', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED GTP-BINDING PROTEIN MXA-RELATED', 246948),
(371090, 'PTHR11566:SF32', NULL, NULL, NULL, NULL, 'DYNAMIN-1', 246948),
(371091, 'PTHR11566:SF147', NULL, NULL, NULL, NULL, 'DYNAMIN GTPASE', 246948),
(371092, 'PTHR11566:SF224', NULL, NULL, NULL, NULL, 'DYNAMIN-LIKE PROTEIN 1E', 246948),
(371093, 'PTHR11566:SF146', NULL, NULL, NULL, NULL, 'FAMILY GTPASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G14300)-RELATED', 246948),
(371094, 'PTHR11566:SF78', NULL, NULL, NULL, NULL, 'DYNAMIN-LIKE PROTEIN ARC5', 246948),
(371095, 'PTHR11566:SF223', NULL, NULL, NULL, NULL, 'PROTEIN 1C, PUTATIVE, EXPRESSED-RELATED', 246948),
(371096, 'PTHR11566:SF222', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED GTP-BINDING PROTEIN MX', 246948),
(371097, 'PTHR11566:SF191', NULL, NULL, NULL, NULL, 'DYNAMIN GTPASE', 246948),
(371098, 'PTHR11566:SF46', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED GTP-BINDING PROTEIN MX2', 246948),
(371099, 'PTHR11566:SF190', NULL, NULL, NULL, NULL, 'DYNAMIN_M DOMAIN-CONTAINING PROTEIN', 246948),
(371100, 'PTHR11566:SF151', NULL, NULL, NULL, NULL, 'PHRAGMOPLASTIN DRP1E', 246948),
(371101, 'PTHR11566:SF194', NULL, NULL, NULL, NULL, 'DYNAMIN GTPASE', 246948),
(371102, 'PTHR11566:SF150', NULL, NULL, NULL, NULL, 'GTPASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G08580)-RELATED', 246948),
(371103, 'PTHR11566:SF193', NULL, NULL, NULL, NULL, 'DYNAMIN-RELATED PROTEIN 4C-LIKE', 246948),
(371104, 'PTHR11566:SF155', NULL, NULL, NULL, NULL, 'DYNAMIN-TYPE G DOMAIN-CONTAINING PROTEIN', 246948),
(371105, 'PTHR11566:SF199', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED GTP-BINDING PROTEIN MXC-RELATED', 246948),
(371106, 'PTHR11566:SF198', NULL, NULL, NULL, NULL, 'DYNAMIN-RELATED PROTEIN 5A-LIKE', 246948),
(371107, 'PTHR11566:SF230', NULL, NULL, NULL, NULL, 'DYNAMIN GTPASE', 246948),
(371108, 'PTHR11566:SF197', NULL, NULL, NULL, NULL, 'DYNAMIN CENTRAL DOMAIN-CONTAINING PROTEIN-RELATED', 246948);
INSERT INTO "PUBLIC"."MODEL" VALUES
(371109, 'PTHR11566:SF40', NULL, NULL, NULL, NULL, 'DYNAMIN-LIKE PROTEIN A', 246948),
(371110, 'PTHR11566:SF84', NULL, NULL, NULL, NULL, 'DYNAMIN-RELATED PROTEIN 3A-LIKE ISOFORM X1', 246948),
(371111, 'PTHR11566:SF152', NULL, NULL, NULL, NULL, 'PHRAGMOPLASTIN DRP1D', 246948),
(371112, 'PTHR11566:SF159', NULL, NULL, NULL, NULL, 'PHRAGMOPLASTIN DRP1A', 246948),
(371113, 'PTHR11566:SF207', NULL, NULL, NULL, NULL, 'DYNAMIN-RELATED PROTEIN 12A', 246948),
(371114, 'PTHR11566:SF206', NULL, NULL, NULL, NULL, 'DYNAMIN-2A', 246948),
(371115, 'PTHR11566:SF205', NULL, NULL, NULL, NULL, 'DYNAMIN CENTRAL DOMAIN-CONTAINING PROTEIN-RELATED', 246948),
(371116, 'PTHR11566:SF204', NULL, NULL, NULL, NULL, 'DYNAMIN-LIKE PROTEIN B', 246948),
(371117, 'PTHR11566:SF57', NULL, NULL, NULL, NULL, 'DYNAMIN-2B', 246948),
(371118, 'PTHR11566:SF161', NULL, NULL, NULL, NULL, 'DYNAMIN-RELATED PROTEIN 1E-LIKE', 246948),
(371119, 'PTHR11566:SF160', NULL, NULL, NULL, NULL, 'DYNAMIN-RELATED PROTEIN 3A', 246948),
(371120, 'PTHR11566:SF50', NULL, NULL, NULL, NULL, 'SI:DKEY-32E23.4', 246948),
(371121, 'PTHR11566:SF164', NULL, NULL, NULL, NULL, 'DYNAMIN-RELATED PROTEIN 4A-RELATED', 246948),
(371122, 'PTHR11566:SF163', NULL, NULL, NULL, NULL, 'DYNAMIN FAMILY PROTEIN', 246948),
(371123, 'PTHR11566:SF54', NULL, NULL, NULL, NULL, 'DYNAMIN-3', 246948),
(371124, 'PTHR11566:SF203', NULL, NULL, NULL, NULL, 'DYNAMIN CENTRAL DOMAIN-CONTAINING PROTEIN-RELATED', 246948),
(371125, 'PTHR11566:SF169', NULL, NULL, NULL, NULL, 'DYNAMIN-LIKE PROTEIN C', 246948),
(371126, 'PTHR11566:SF202', NULL, NULL, NULL, NULL, 'BNAC01G28600D PROTEIN', 246948),
(371127, 'PTHR11566:SF56', NULL, NULL, NULL, NULL, 'DYNAMIN-B', 246948),
(371128, 'PTHR11566:SF200', NULL, NULL, NULL, NULL, 'BNAC06G10080D PROTEIN', 246948),
(371129, 'PTHR11566:SF167', NULL, NULL, NULL, NULL, 'DYNAMIN GTPASE', 246948),
(371130, 'PTHR11566:SF218', NULL, NULL, NULL, NULL, 'BNAC06G13620D PROTEIN', 246948),
(371131, 'PTHR11566:SF217', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED GTP-BINDING PROTEIN MX1', 246948),
(371132, 'PTHR11566:SF215', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED GTP-BINDING PROTEIN MX2', 246948),
(371133, 'PTHR11566:SF219', NULL, NULL, NULL, NULL, 'OS08G0425100 PROTEIN', 246948),
(371134, 'PTHR11566:SF173', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED GTP-BINDING PROTEIN MX', 246948),
(371135, 'PTHR11566:SF170', NULL, NULL, NULL, NULL, 'DYNAMIN 3A-LIKE PROTEIN', 246948),
(371136, 'PTHR11566:SF60', NULL, NULL, NULL, NULL, 'PHRAGMOPLASTIN DRP1B', 246948),
(371137, 'PTHR11566:SF131', NULL, NULL, NULL, NULL, 'GTPASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G07630)-RELATED', 246948),
(371138, 'PTHR11566', NULL, NULL, NULL, NULL, 'DYNAMIN', 246948),
(371139, 'PTHR11566:SF214', NULL, NULL, NULL, NULL, 'DYNAMIN-TYPE G DOMAIN-CONTAINING PROTEIN', 246948),
(371140, 'PTHR11566:SF21', NULL, NULL, NULL, NULL, 'DYNAMIN-1-LIKE PROTEIN', 246948),
(371141, 'PTHR11566:SF213', NULL, NULL, NULL, NULL, 'DYNAMIN CENTRAL DOMAIN-CONTAINING PROTEIN-RELATED', 246948),
(371142, 'PTHR11566:SF23', NULL, NULL, NULL, NULL, 'DYNAMIN-2', 246948),
(371143, 'PTHR11566:SF67', NULL, NULL, NULL, NULL, 'DYNAMIN-LIKE 120 KDA PROTEIN, MITOCHONDRIAL', 246948),
(371144, 'PTHR11566:SF179', NULL, NULL, NULL, NULL, 'BNAC06G13930D PROTEIN', 246948),
(371145, 'PTHR11566:SF212', NULL, NULL, NULL, NULL, 'DYNAMIN', 246948),
(371146, 'PTHR11566:SF66', NULL, NULL, NULL, NULL, '', 246948),
(371147, 'PTHR11566:SF178', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED GTP-BINDING PROTEIN MX', 246948),
(371148, 'PTHR11566:SF211', NULL, NULL, NULL, NULL, 'DYNAMIN-RELATED PROTEIN 4C-LIKE', 246948),
(371149, 'PTHR36783:SF2', NULL, NULL, NULL, NULL, 'THYLAKOID LUMENAL 17.9 KDA PROTEIN, CHLOROPLASTIC', 246949),
(371150, 'PTHR36783', NULL, NULL, NULL, NULL, 'THYLAKOID LUMENAL 17.9 KDA PROTEIN, CHLOROPLASTIC', 246949),
(371151, 'PTHR12626:SF2', NULL, NULL, NULL, NULL, 'MA3 DOMAIN-CONTAINING TRANSLATION REGULATORY FACTOR 2', 246950),
(371152, 'PTHR12626:SF3', NULL, NULL, NULL, NULL, 'PROGRAMMED CELL DEATH PROTEIN 4', 246950),
(371153, 'PTHR12626:SF4', NULL, NULL, NULL, NULL, 'PROGRAMMED CELL DEATH PROTEIN 4', 246950);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(371154, 'PTHR12626:SF6', NULL, NULL, NULL, NULL, 'OS04G0482800 PROTEIN', 246950),
(371155, 'PTHR12626:SF11', NULL, NULL, NULL, NULL, 'MI DOMAIN-CONTAINING PROTEIN', 246950),
(371156, 'PTHR12626:SF7', NULL, NULL, NULL, NULL, 'MA3 DOMAIN-CONTAINING TRANSLATION REGULATORY FACTOR 1', 246950),
(371157, 'PTHR12626:SF12', NULL, NULL, NULL, NULL, 'MA3 DOMAIN-CONTAINING TRANSLATION REGULATORY FACTOR 4', 246950),
(371158, 'PTHR12626:SF8', NULL, NULL, NULL, NULL, '', 246950),
(371159, 'PTHR12626', NULL, NULL, NULL, NULL, 'PROGRAMMED CELL DEATH 4', 246950),
(371160, 'PTHR12626:SF10', NULL, NULL, NULL, NULL, 'BNAC05G03970D PROTEIN', 246950),
(371161, 'PTHR12626:SF0', NULL, NULL, NULL, NULL, 'PROGRAMMED CELL DEATH PROTEIN 4', 246950),
(371162, 'PTHR38007:SF1', NULL, NULL, NULL, NULL, 'CRISPR SYSTEM CMS PROTEIN CSM5', 246951),
(371163, 'PTHR38007', NULL, NULL, NULL, NULL, 'CRISPR SYSTEM CMS PROTEIN CSM5', 246951),
(371164, 'PTHR34834:SF3', NULL, NULL, NULL, NULL, 'GENE, 39566-RELATED', 246952),
(371165, 'PTHR34834', NULL, NULL, NULL, NULL, 'SPERMATID MATURATION PROTEIN 1', 246952),
(371166, 'PTHR34834:SF4', NULL, NULL, NULL, NULL, '', 246952),
(371167, 'PTHR34834:SF1', NULL, NULL, NULL, NULL, 'SPERMATID MATURATION PROTEIN 1', 246952),
(371168, 'PTHR34834:SF2', NULL, NULL, NULL, NULL, 'SPEM FAMILY MEMBER 2', 246952),
(371169, 'PTHR32358', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL AND IMMUNE RESPONSE REGULATOR', 246953),
(371170, 'PTHR32358:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL AND IMMUNE RESPONSE REGULATOR', 246953),
(371171, 'PTHR47596:SF9', NULL, NULL, NULL, NULL, 'SMALL POLYPEPTIDE DEVIL 18', 246954),
(371172, 'PTHR47596:SF8', NULL, NULL, NULL, NULL, '', 246954),
(371173, 'PTHR47596:SF7', NULL, NULL, NULL, NULL, 'SMALL POLYPEPTIDE DEVIL 15', 246954),
(371174, 'PTHR47596:SF6', NULL, NULL, NULL, NULL, 'DVL-RELATED', 246954),
(371175, 'PTHR47596:SF10', NULL, NULL, NULL, NULL, 'ROTUNDIFOLIA-LIKE PROTEIN', 246954),
(371176, 'PTHR47596:SF3', NULL, NULL, NULL, NULL, 'SMALL POLYPEPTIDE DEVIL 9', 246954),
(371177, 'PTHR47596:SF2', NULL, NULL, NULL, NULL, 'SMALL POLYPEPTIDE DEVIL 13', 246954),
(371178, 'PTHR47596', NULL, NULL, NULL, NULL, 'DVL13', 246954),
(371179, 'PTHR31511', NULL, NULL, NULL, NULL, 'PROTEIN CBG23764', 246955),
(371180, 'PTHR31511:SF12', NULL, NULL, NULL, NULL, 'DNA-DIRECTED DNA POLYMERASE', 246955),
(371181, 'PTHR11078:SF4', NULL, NULL, NULL, NULL, 'NUSB DOMAIN-CONTAINING PROTEIN', 246956),
(371182, 'PTHR11078:SF3', NULL, NULL, NULL, NULL, 'ANTITERMINATION NUSB DOMAIN-CONTAINING PROTEIN', 246956),
(371183, 'PTHR11078', NULL, NULL, NULL, NULL, 'N UTILIZATION SUBSTANCE PROTEIN B-RELATED', 246956),
(371184, 'PTHR37945:SF1', NULL, NULL, NULL, NULL, 'EXTRACELLULAR TUNGSTATE BINDING PROTEIN', 246957),
(371185, 'PTHR37945', NULL, NULL, NULL, NULL, 'EXTRACELLULAR TUNGSTATE BINDING PROTEIN', 246957),
(371186, 'PTHR15231', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL N-ACETYLGLUCOSAMINYLTRANSFERASE SUBUNIT H', 246958),
(371187, 'PTHR15231:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL N-ACETYLGLUCOSAMINYLTRANSFERASE SUBUNIT H', 246958),
(371188, 'PTHR15231:SF4', NULL, NULL, NULL, NULL, 'OS01G0166400 PROTEIN', 246958),
(371189, 'PTHR30582:SF29', NULL, NULL, NULL, NULL, 'L,D-TRANSPEPTIDASE YNHG-RELATED', 246959),
(371190, 'PTHR30582:SF30', NULL, NULL, NULL, NULL, 'BLR4375 PROTEIN', 246959),
(371191, 'PTHR30582:SF31', NULL, NULL, NULL, NULL, 'L,D-TRANSPEPTIDASE YBIS-RELATED', 246959),
(371192, 'PTHR30582:SF32', NULL, NULL, NULL, NULL, 'L,D-TRANSPEPTIDASE ERFK/SRFK-RELATED', 246959),
(371193, 'PTHR30582:SF33', NULL, NULL, NULL, NULL, 'EXPORTED PROTEIN-RELATED', 246959),
(371194, 'PTHR30582:SF24', NULL, NULL, NULL, NULL, 'L,D-TRANSPEPTIDASE YKUD-RELATED', 246959),
(371195, 'PTHR30582:SF2', NULL, NULL, NULL, NULL, 'L,D-TRANSPEPTIDASE YCIB-RELATED', 246959),
(371196, 'PTHR30582', NULL, NULL, NULL, NULL, 'L,D-TRANSPEPTIDASE', 246959),
(371197, 'PTHR30582:SF27', NULL, NULL, NULL, NULL, 'L,D-TRANSPEPTIDASE YCFS-RELATED', 246959),
(371198, 'PTHR30582:SF4', NULL, NULL, NULL, NULL, 'L,D-TRANSPEPTIDASE YQJB-RELATED', 246959);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(371199, 'PTHR11003:SF28', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL SUBFAMILY K MEMBER 6', 246960),
(371200, 'PTHR11003:SF241', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL SUBFAMILY K MEMBER 5', 246960),
(371201, 'PTHR11003:SF285', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN PAIR, POTASSIUM CHANNEL DOMAIN PROTEIN-RELATED', 246960),
(371202, 'PTHR11003:SF69', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS', 246960),
(371203, 'PTHR11003:SF240', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS', 246960),
(371204, 'PTHR11003:SF283', NULL, NULL, NULL, NULL, 'TWO PORE DOMAIN POTASSIUM CHANNEL, EF-HAND DOMAIN PAIR-RELATED', 246960),
(371205, 'PTHR11003:SF282', NULL, NULL, NULL, NULL, 'TWO-PORE POTASSIUM CHANNEL 3', 246960),
(371206, 'PTHR11003:SF66', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS', 246960),
(371207, 'PTHR11003:SF289', NULL, NULL, NULL, NULL, 'BNAC09G32260D PROTEIN', 246960),
(371208, 'PTHR11003:SF21', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL SUBFAMILY K MEMBER 2', 246960),
(371209, 'PTHR11003:SF322', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL SUBUNIT N2P17M2-2-RELATED', 246960),
(371210, 'PTHR11003:SF288', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS', 246960),
(371211, 'PTHR11003:SF320', NULL, NULL, NULL, NULL, 'IP11374P', 246960),
(371212, 'PTHR11003:SF286', NULL, NULL, NULL, NULL, 'TWO-PORE POTASSIUM CHANNEL 3-LIKE', 246960),
(371213, 'PTHR11003:SF61', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS', 246960),
(371214, 'PTHR11003:SF249', NULL, NULL, NULL, NULL, 'TWO PORE POTASSIUM CHANNEL PROTEIN SUP-9', 246960),
(371215, 'PTHR11003:SF326', NULL, NULL, NULL, NULL, 'ACID-SENSITIVE TWO PORE DOMAIN K+ CHANNEL DTASK-6', 246960),
(371216, 'PTHR11003:SF325', NULL, NULL, NULL, NULL, '', 246960),
(371217, 'PTHR11003:SF324', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS', 246960),
(371218, 'PTHR11003:SF323', NULL, NULL, NULL, NULL, '', 246960),
(371219, 'PTHR11003:SF329', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL, SUBFAMILY K, MEMBER 17', 246960),
(371220, 'PTHR11003:SF328', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS', 246960),
(371221, 'PTHR11003:SF327', NULL, NULL, NULL, NULL, 'FI03418P', 246960),
(371222, 'PTHR11003:SF18', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL SUBFAMILY K MEMBER 15', 246960),
(371223, 'PTHR11003:SF291', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS PROTEIN 18', 246960),
(371224, 'PTHR11003:SF59', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL SUBFAMILY K MEMBER 1', 246960),
(371225, 'PTHR11003:SF296', NULL, NULL, NULL, NULL, 'ION_TRANS_2 DOMAIN-CONTAINING PROTEIN', 246960),
(371226, 'PTHR11003:SF57', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL SUBFAMILY K MEMBER 13', 246960),
(371227, 'PTHR11003:SF295', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL, SUBFAMILY K, MEMBER 5B', 246960),
(371228, 'PTHR11003:SF294', NULL, NULL, NULL, NULL, 'BNAA01G21820D PROTEIN', 246960),
(371229, 'PTHR11003:SF250', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS', 246960),
(371230, 'PTHR11003:SF172', NULL, NULL, NULL, NULL, 'TWO PORE POTASSIUM CHANNEL PROTEIN SUP-9', 246960),
(371231, 'PTHR11003:SF11', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL SUBFAMILY K MEMBER 12', 246960),
(371232, 'PTHR11003:SF98', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS', 246960),
(371233, 'PTHR11003:SF333', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS PROTEIN 7', 246960),
(371234, 'PTHR11003:SF10', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS', 246960),
(371235, 'PTHR11003:SF332', NULL, NULL, NULL, NULL, 'TWO PORE POTASSIUM CHANNEL A', 246960),
(371236, 'PTHR11003:SF299', NULL, NULL, NULL, NULL, 'TWO PORE DOMAIN POTASSIUM CHANNEL-RELATED', 246960),
(371237, 'PTHR11003:SF97', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS', 246960),
(371238, 'PTHR11003:SF331', NULL, NULL, NULL, NULL, 'OPEN RECTIFIER POTASSIUM CHANNEL PROTEIN 1', 246960),
(371239, 'PTHR11003:SF330', NULL, NULL, NULL, NULL, 'ION_TRANS_2 DOMAIN-CONTAINING PROTEIN', 246960),
(371240, 'PTHR11003:SF337', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS', 246960);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(371241, 'PTHR11003:SF336', NULL, NULL, NULL, NULL, 'TWO-PORE POTASSIUM CHANNEL 1-LIKE', 246960),
(371242, 'PTHR11003:SF138', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL SUBFAMILY K MEMBER 3', 246960),
(371243, 'PTHR11003:SF93', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL SUBUNIT N2P16', 246960),
(371244, 'PTHR11003:SF137', NULL, NULL, NULL, NULL, 'TWO PORE POTASSIUM CHANNEL B', 246960),
(371245, 'PTHR11003:SF335', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS', 246960),
(371246, 'PTHR11003:SF257', NULL, NULL, NULL, NULL, 'AGAP003031-PA', 246960),
(371247, 'PTHR11003:SF334', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL SUBFAMILY K MEMBER 18', 246960),
(371248, 'PTHR11003:SF339', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL SUBFAMILY K MEMBER 16-LIKE', 246960),
(371249, 'PTHR11003:SF338', NULL, NULL, NULL, NULL, 'PROTEIN CBG03693', 246960),
(371250, 'PTHR11003:SF340', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL SUBFAMILY K MEMBER 17', 246960),
(371251, 'PTHR11003:SF142', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS PROTEIN 7-LIKE PROTEIN', 246960),
(371252, 'PTHR11003:SF261', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS', 246960),
(371253, 'PTHR11003:SF87', NULL, NULL, NULL, NULL, 'ION_TRANS_2 DOMAIN-CONTAINING PROTEIN', 246960),
(371254, 'PTHR11003:SF86', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS', 246960),
(371255, 'PTHR11003:SF342', NULL, NULL, NULL, NULL, 'OUTWARD-RECTIFIER POTASSIUM CHANNEL TOK1', 246960),
(371256, 'PTHR11003:SF264', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL, SUBFAMILY K, MEMBER 12-LIKE-RELATED', 246960),
(371257, 'PTHR11003:SF341', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS', 246960),
(371258, 'PTHR11003:SF106', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS', 246960),
(371259, 'PTHR11003:SF303', NULL, NULL, NULL, NULL, 'OS01G0696100 PROTEIN', 246960),
(371260, 'PTHR11003:SF269', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS', 246960),
(371261, 'PTHR11003:SF104', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL SUBFAMILY K MEMBER 16', 246960),
(371262, 'PTHR11003:SF147', NULL, NULL, NULL, NULL, 'ION_TRANS_2 DOMAIN-CONTAINING PROTEIN', 246960),
(371263, 'PTHR11003:SF268', NULL, NULL, NULL, NULL, 'TWO-PORE POTASSIUM CHANNEL 4-RELATED', 246960),
(371264, 'PTHR11003:SF301', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL PROTEIN', 246960),
(371265, 'PTHR11003:SF90', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS', 246960),
(371266, 'PTHR11003:SF109', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS', 246960),
(371267, 'PTHR11003:SF307', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS', 246960),
(371268, 'PTHR11003:SF305', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS', 246960),
(371269, 'PTHR11003:SF107', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS', 246960),
(371270, 'PTHR11003:SF309', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS', 246960),
(371271, 'PTHR11003:SF270', NULL, NULL, NULL, NULL, 'TWO-PORE POTASSIUM CHANNEL 1-LIKE', 246960),
(371272, 'PTHR11003:SF274', NULL, NULL, NULL, NULL, 'POTASSIUM INWARD RECTIFIER (KIR)-LIKE CHANNEL 3-RELATED', 246960),
(371273, 'PTHR11003:SF273', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS PROTEIN 9', 246960),
(371274, 'PTHR11003:SF152', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS PROTEIN 12', 246960),
(371275, 'PTHR11003:SF271', NULL, NULL, NULL, NULL, 'TWO-PORE POTASSIUM CHANNEL 1-LIKE', 246960),
(371276, 'PTHR11003:SF150', NULL, NULL, NULL, NULL, 'PROTEIN CBG08159', 246960),
(371277, 'PTHR11003:SF113', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS', 246960),
(371278, 'PTHR11003:SF32', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL SUBFAMILY K MEMBER 10', 246960),
(371279, 'PTHR11003:SF310', NULL, NULL, NULL, NULL, 'UNCOORDINATED PROTEIN 58', 246960),
(371280, 'PTHR11003:SF277', NULL, NULL, NULL, NULL, 'TWO-PORE POTASSIUM CHANNEL 1-LIKE', 246960),
(371281, 'PTHR11003:SF75', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL SUBFAMILY K MEMBER 9', 246960);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(371282, 'PTHR11003:SF156', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS', 246960),
(371283, 'PTHR11003:SF31', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL SUBFAMILY K MEMBER 7', 246960),
(371284, 'PTHR11003:SF111', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS', 246960),
(371285, 'PTHR11003:SF30', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL SUBFAMILY K MEMBER 4', 246960),
(371286, 'PTHR11003:SF73', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS', 246960),
(371287, 'PTHR11003:SF110', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS', 246960),
(371288, 'PTHR11003:SF315', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL SUBFAMILY K MEMBER 16', 246960),
(371289, 'PTHR11003:SF314', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL, SUBFAMILY K, MEMBER 13', 246960),
(371290, 'PTHR11003:SF312', NULL, NULL, NULL, NULL, 'TWIK FAMILY OF POTASSIUM CHANNELS', 246960),
(371291, 'PTHR11003:SF318', NULL, NULL, NULL, NULL, '', 246960),
(371292, 'PTHR11003:SF317', NULL, NULL, NULL, NULL, 'PROTEIN CBR-EGL-23', 246960),
(371293, 'PTHR11003', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL, SUBFAMILY K', 246960),
(371294, 'PTHR40698:SF1', NULL, NULL, NULL, NULL, 'FLAGELLA-RELATED PROTEIN E-RELATED', 246961),
(371295, 'PTHR40698:SF2', NULL, NULL, NULL, NULL, 'FLAGELLA-RELATED PROTEIN C-RELATED', 246961),
(371296, 'PTHR40698', NULL, NULL, NULL, NULL, 'FLAGELLA-RELATED PROTEIN E-RELATED-RELATED', 246961),
(371297, 'PTHR18879', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 290 KDA', 246962),
(371298, 'PTHR18879:SF20', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 290 KDA', 246962),
(371299, 'PTHR47384:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE CCNB1IP1 HOMOLOG', 246963),
(371300, 'PTHR47384', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE CCNB1IP1 HOMOLOG', 246963),
(371301, 'PTHR34475', NULL, NULL, NULL, NULL, '', 246964),
(371302, 'PTHR34475:SF1', NULL, NULL, NULL, NULL, 'CYTOSKELETON PROTEIN RODZ', 246964),
(371303, 'PTHR43609:SF1', NULL, NULL, NULL, NULL, 'ACETYL-COA HYDROLASE', 246965),
(371304, 'PTHR43609', NULL, NULL, NULL, NULL, 'ACETYL-COA HYDROLASE', 246965),
(371305, 'PTHR30400:SF0', NULL, NULL, NULL, NULL, 'BIOSYNTHETIC PEPTIDOGLYCAN TRANSGLYCOSYLASE', 246966),
(371306, 'PTHR30400', NULL, NULL, NULL, NULL, 'MONOFUNCTIONAL BIOSYNTHETIC PEPTIDOGLYCAN TRANSGLYCOSYLASE', 246966),
(371307, 'PTHR35714:SF4', NULL, NULL, NULL, NULL, '', 246967),
(371308, 'PTHR35714', NULL, NULL, NULL, NULL, 'OS02G0715300 PROTEIN', 246967),
(371309, 'PTHR35714:SF3', NULL, NULL, NULL, NULL, 'BNACNNG22830D PROTEIN', 246967),
(371310, 'PTHR35714:SF2', NULL, NULL, NULL, NULL, 'OS08G0511400 PROTEIN', 246967),
(371311, 'PTHR35714:SF1', NULL, NULL, NULL, NULL, 'OS02G0715300 PROTEIN', 246967),
(371312, 'PTHR12962:SF4', NULL, NULL, NULL, NULL, 'COLD SHOCK DOMAIN-CONTAINING PROTEIN C2', 246968),
(371313, 'PTHR12962:SF3', NULL, NULL, NULL, NULL, 'CALCIUM-REGULATED HEAT-STABLE PROTEIN 1', 246968),
(371314, 'PTHR12962:SF5', NULL, NULL, NULL, NULL, 'CSD DOMAIN-CONTAINING PROTEIN', 246968),
(371315, 'PTHR12962:SF1', NULL, NULL, NULL, NULL, 'COLD SHOCK DOMAIN-CONTAINING PROTEIN CG9705', 246968),
(371316, 'PTHR12962', NULL, NULL, NULL, NULL, 'CALCIUM-REGULATED HEAT STABLE PROTEIN CRHSP-24-RELATED', 246968),
(371317, 'PTHR40457', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1', 246969),
(371318, 'PTHR40457:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1', 246969),
(371319, 'PTHR42071', NULL, NULL, NULL, NULL, 'PROTOGLOBIN DOMAIN-CONTAINING PROTEIN', 246970),
(371320, 'PTHR42071:SF1', NULL, NULL, NULL, NULL, 'PROTOGLOBIN DOMAIN-CONTAINING PROTEIN', 246970),
(371321, 'PTHR42885:SF1', NULL, NULL, NULL, NULL, 'THREONINE-PHOSPHATE DECARBOXYLASE', 246971),
(371322, 'PTHR42885:SF2', NULL, NULL, NULL, NULL, 'HISTIDINOL-PHOSPHATE AMINOTRANSFERASE', 246971),
(371323, 'PTHR42885', NULL, NULL, NULL, NULL, 'HISTIDINOL-PHOSPHATE AMINOTRANSFERASE-RELATED', 246971),
(371324, 'PTHR31348', NULL, NULL, NULL, NULL, 'EID1-LIKE F-BOX PROTEIN 2-RELATED', 246972),
(371325, 'PTHR31348:SF13', NULL, NULL, NULL, NULL, 'EID1-LIKE F-BOX PROTEIN 1', 246972);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(371326, 'PTHR31348:SF12', NULL, NULL, NULL, NULL, 'OS05G0494600 PROTEIN', 246972),
(371327, 'PTHR31348:SF11', NULL, NULL, NULL, NULL, 'CIRCADIAN CLOCK COUPLING FACTOR ZGT', 246972),
(371328, 'PTHR31348:SF4', NULL, NULL, NULL, NULL, 'PHYTOCHROME A-ASSOCIATED F-BOX PROTEIN', 246972),
(371329, 'PTHR31348:SF3', NULL, NULL, NULL, NULL, 'EID1-LIKE F-BOX PROTEIN 3', 246972),
(371330, 'PTHR31348:SF2', NULL, NULL, NULL, NULL, 'EID1-LIKE F-BOX PROTEIN 2', 246972),
(371331, 'PTHR31348:SF9', NULL, NULL, NULL, NULL, 'OS07G0598200 PROTEIN', 246972),
(371332, 'PTHR45113:SF1', NULL, NULL, NULL, NULL, 'JUNCTIONAL ADHESION MOLECULE A', 246973),
(371333, 'PTHR45113', NULL, NULL, NULL, NULL, 'JUNCTIONAL ADHESION MOLECULE A', 246973),
(371334, 'PTHR19324:SF33', NULL, NULL, NULL, NULL, 'APEC DOMAIN-CONTAINING PROTEIN', 246974),
(371335, 'PTHR19324', NULL, NULL, NULL, NULL, 'PERFORIN-LIKE PROTEIN 1', 246974),
(371336, 'PTHR38769', NULL, NULL, NULL, NULL, 'UPF0381 PROTEIN YFCZ-RELATED', 246975),
(371337, 'PTHR38769:SF1', NULL, NULL, NULL, NULL, 'UPF0381 PROTEIN YFCZ-RELATED', 246975),
(371338, 'PTHR46464:SF1', NULL, NULL, NULL, NULL, 'ANKYRIN AND ARMADILLO REPEAT-CONTAINING PROTEIN', 246976),
(371339, 'PTHR46464', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 246976),
(371340, 'PTHR46464:SF2', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 246976),
(371341, 'PTHR12896:SF1', NULL, NULL, NULL, NULL, 'ELONGATOR COMPLEX PROTEIN 4', 246977),
(371342, 'PTHR12896', NULL, NULL, NULL, NULL, 'PAX6 NEIGHBOR PROTEIN  PAXNEB', 246977),
(371343, 'PTHR10835:SF0', NULL, NULL, NULL, NULL, 'SQUALENE MONOOXYGENASE', 246978),
(371344, 'PTHR10835:SF6', NULL, NULL, NULL, NULL, 'SQUALENE MONOOXYGENASE', 246978),
(371345, 'PTHR10835:SF9', NULL, NULL, NULL, NULL, 'SQUALENE EPOXIDASE 3', 246978),
(371346, 'PTHR10835:SF8', NULL, NULL, NULL, NULL, 'SQUALENE MONOOXYGENASE', 246978),
(371347, 'PTHR10835:SF30', NULL, NULL, NULL, NULL, 'SQUALENE MONOOXYGENASE', 246978),
(371348, 'PTHR10835:SF20', NULL, NULL, NULL, NULL, 'SQUALENE EPOXIDASE 4', 246978),
(371349, 'PTHR10835:SF31', NULL, NULL, NULL, NULL, 'SQUALENE MONOOXYGENASE', 246978),
(371350, 'PTHR10835:SF10', NULL, NULL, NULL, NULL, 'SQUALENE MONOOXYGENASE', 246978),
(371351, 'PTHR10835:SF32', NULL, NULL, NULL, NULL, 'SQUALENE MONOOXYGENASE', 246978),
(371352, 'PTHR10835:SF11', NULL, NULL, NULL, NULL, 'SQUALENE MONOOXYGENASE', 246978),
(371353, 'PTHR10835:SF33', NULL, NULL, NULL, NULL, 'SQUALENE MONOOXYGENASE', 246978),
(371354, 'PTHR10835:SF22', NULL, NULL, NULL, NULL, 'SQUALENE EPOXIDASE 5-RELATED', 246978),
(371355, 'PTHR10835:SF12', NULL, NULL, NULL, NULL, 'SQUALENE MONOOXYGENASE', 246978),
(371356, 'PTHR10835', NULL, NULL, NULL, NULL, 'SQUALENE MONOOXYGENASE', 246978),
(371357, 'PTHR10835:SF26', NULL, NULL, NULL, NULL, 'SQUALENE MONOOXYGENASE', 246978),
(371358, 'PTHR10835:SF15', NULL, NULL, NULL, NULL, 'SQUALENE EPOXIDASE 2, MITOCHONDRIAL', 246978),
(371359, 'PTHR10835:SF27', NULL, NULL, NULL, NULL, 'SQUALENE MONOOXYGENASE', 246978),
(371360, 'PTHR10835:SF16', NULL, NULL, NULL, NULL, 'SQUALENE MONOOXYGENASE', 246978),
(371361, 'PTHR10835:SF28', NULL, NULL, NULL, NULL, 'SQUALENE MONOOXYGENASE', 246978),
(371362, 'PTHR10835:SF18', NULL, NULL, NULL, NULL, 'SQUALENE MONOOXYGENASE', 246978),
(371363, 'PTHR10835:SF29', NULL, NULL, NULL, NULL, 'SQUALENE MONOOXYGENASE', 246978),
(371364, 'PTHR10835:SF19', NULL, NULL, NULL, NULL, 'SQUALENE MONOOXYGENASE', 246978),
(371365, 'PTHR39957:SF1', NULL, NULL, NULL, NULL, 'AT09846P1-RELATED', 246979),
(371366, 'PTHR39957', NULL, NULL, NULL, NULL, 'AT09846P1-RELATED', 246979),
(371367, 'PTHR14788', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 156', 246980),
(371368, 'PTHR14788:SF5', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 156', 246980),
(371369, 'PTHR45734', NULL, NULL, NULL, NULL, 'TENSIN', 246981),
(371370, 'PTHR45734:SF3', NULL, NULL, NULL, NULL, 'TENSIN-1', 246981),
(371371, 'PTHR45734:SF1', NULL, NULL, NULL, NULL, 'TENSIN-2', 246981),
(371372, 'PTHR45734:SF11', NULL, NULL, NULL, NULL, '', 246981);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(371373, 'PTHR45734:SF9', NULL, NULL, NULL, NULL, 'SH2 DOMAIN-CONTAINING PROTEIN', 246981),
(371374, 'PTHR45734:SF7', NULL, NULL, NULL, NULL, 'PVR ADAPTOR PROTEIN-RELATED', 246981),
(371375, 'PTHR45734:SF6', NULL, NULL, NULL, NULL, 'TENSIN-4', 246981),
(371376, 'PTHR45734:SF10', NULL, NULL, NULL, NULL, 'BLISTERY, ISOFORM A', 246981),
(371377, 'PTHR45734:SF5', NULL, NULL, NULL, NULL, 'TENSIN-3', 246981),
(371378, 'PTHR33736:SF26', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246982),
(371379, 'PTHR33736:SF15', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE-RELATED', 246982),
(371380, 'PTHR33736:SF28', NULL, NULL, NULL, NULL, 'F-BOX PLANT-LIKE PROTEIN', 246982),
(371381, 'PTHR33736:SF22', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN-RELATED', 246982),
(371382, 'PTHR33736:SF12', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 246982),
(371383, 'PTHR33736:SF23', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN-RELATED', 246982),
(371384, 'PTHR33736:SF13', NULL, NULL, NULL, NULL, 'OS12G0156500 PROTEIN', 246982),
(371385, 'PTHR33736:SF29', NULL, NULL, NULL, NULL, 'DUF1279 DOMAIN-CONTAINING PROTEIN', 246982),
(371386, 'PTHR33736:SF18', NULL, NULL, NULL, NULL, 'F-BOX PLANT-LIKE PROTEIN', 246982),
(371387, 'PTHR33736:SF6', NULL, NULL, NULL, NULL, 'OS02G0535901 PROTEIN', 246982),
(371388, 'PTHR33736', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN-RELATED', 246982),
(371389, 'PTHR33736:SF4', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN-RELATED', 246982),
(371390, 'PTHR33736:SF30', NULL, NULL, NULL, NULL, 'F-BOX PLANT-LIKE PROTEIN', 246982),
(371391, 'PTHR33736:SF31', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN-RELATED', 246982),
(371392, 'PTHR36505', NULL, NULL, NULL, NULL, 'BLR1072 PROTEIN', 246983),
(371393, 'PTHR36505:SF1', NULL, NULL, NULL, NULL, 'BLR1072 PROTEIN', 246983),
(371394, 'PTHR45831:SF1', NULL, NULL, NULL, NULL, 'SMALL GLUTAMINE-RICH TETRATRICOPEPTIDE REPEAT-CONTAINING PROTEIN BETA', 246984),
(371395, 'PTHR45831:SF4', NULL, NULL, NULL, NULL, '', 246984),
(371396, 'PTHR45831:SF3', NULL, NULL, NULL, NULL, 'SMALL GLUTAMINE-RICH TETRATRICOPEPTIDE REPEAT-CONTAINING PROTEIN ALPHA', 246984),
(371397, 'PTHR45831:SF2', NULL, NULL, NULL, NULL, 'LD24721P', 246984),
(371398, 'PTHR45831', NULL, NULL, NULL, NULL, 'LD24721P', 246984),
(371399, 'PTHR47833:SF1', NULL, NULL, NULL, NULL, 'PHOTOSYNTHETIC NDH SUBUNIT OF LUMENAL LOCATION 4, CHLOROPLASTIC', 246985),
(371400, 'PTHR47833:SF2', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 246985),
(371401, 'PTHR47833', NULL, NULL, NULL, NULL, 'PHOTOSYNTHETIC NDH SUBUNIT OF LUMENAL LOCATION 4, CHLOROPLASTIC', 246985),
(371402, 'PTHR43555', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLFORMYLGLYCINAMIDINE SYNTHASE SUBUNIT PURL', 246986),
(371403, 'PTHR43555:SF1', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLFORMYLGLYCINAMIDINE SYNTHASE SUBUNIT PURL', 246986),
(371404, 'PTHR40866:SF1', NULL, NULL, NULL, NULL, '', 246987),
(371405, 'PTHR40866', NULL, NULL, NULL, NULL, '', 246987),
(371406, 'PTHR14913', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR TYPE 1-ASSOCIATED DEATH DOMAIN PROTEIN', 246988),
(371407, 'PTHR14913:SF0', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR TYPE 1-ASSOCIATED DEATH DOMAIN PROTEIN', 246988),
(371408, 'PTHR46733:SF9', NULL, NULL, NULL, NULL, 'OS09G0345500 PROTEIN', 246989),
(371409, 'PTHR46733:SF8', NULL, NULL, NULL, NULL, 'HSP20/ALPHA CRYSTALLIN FAMILY PROTEIN', 246989),
(371410, 'PTHR46733:SF7', NULL, NULL, NULL, NULL, 'HSP20/ALPHA CRYSTALLIN FAMILY PROTEIN, EXPRESSED', 246989),
(371411, 'PTHR46733:SF6', NULL, NULL, NULL, NULL, 'LOCALIZED SMALL HEAT SHOCK PROTEIN', 246989),
(371412, 'PTHR46733:SF10', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 246989),
(371413, 'PTHR46733:SF5', NULL, NULL, NULL, NULL, 'HSP20/ALPHA CRYSTALLIN FAMILY PROTEIN, EXPRESSED', 246989),
(371414, 'PTHR46733:SF4', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 21, CHLOROPLASTIC', 246989),
(371415, 'PTHR46733', NULL, NULL, NULL, NULL, '26.5 KDA HEAT SHOCK PROTEIN, MITOCHONDRIAL', 246989),
(371416, 'PTHR46733:SF3', NULL, NULL, NULL, NULL, '26.5 KDA HEAT SHOCK PROTEIN, MITOCHONDRIAL', 246989);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(371417, 'PTHR46733:SF2', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 246989),
(371418, 'PTHR12993:SF30', NULL, NULL, NULL, NULL, 'N-ACETYL-ALPHA-D-GLUCOSAMINYL L-MALATE DEACETYLASE 1', 246990),
(371419, 'PTHR12993:SF29', NULL, NULL, NULL, NULL, 'BLR3841 PROTEIN', 246990),
(371420, 'PTHR12993:SF27', NULL, NULL, NULL, NULL, 'N-ACETYL-ALPHA-D-GLUCOSAMINYL L-MALATE DEACETYLASE 2-RELATED', 246990),
(371421, 'PTHR12993', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINYL-PHOSPHATIDYLINOSITOL DE-N-ACETYLASE-RELATED', 246990),
(371422, 'PTHR12993:SF28', NULL, NULL, NULL, NULL, 'LMBE FAMILY PROTEIN', 246990),
(371423, 'PTHR12993:SF26', NULL, NULL, NULL, NULL, '1D-MYO-INOSITOL 2-ACETAMIDO-2-DEOXY-ALPHA-D-GLUCOPYRANOSIDE DEACETYLASE', 246990),
(371424, 'PTHR12993:SF23', NULL, NULL, NULL, NULL, '', 246990),
(371425, 'PTHR12993:SF11', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINYL-PHOSPHATIDYLINOSITOL DE-N-ACETYLASE', 246990),
(371426, 'PTHR34034:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAM180B', 246991),
(371427, 'PTHR34034', NULL, NULL, NULL, NULL, 'PROTEIN FAM180A-RELATED', 246991),
(371428, 'PTHR34034:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM180A', 246991),
(371429, 'PTHR45709:SF3', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN-LIKE 1', 246992),
(371430, 'PTHR45709:SF2', NULL, NULL, NULL, NULL, 'LARGE SUBUNIT GTPASE 1 HOMOLOG', 246992),
(371431, 'PTHR45709', NULL, NULL, NULL, NULL, 'LARGE SUBUNIT GTPASE 1 HOMOLOG-RELATED', 246992),
(371432, 'PTHR45709:SF5', NULL, NULL, NULL, NULL, 'CP-TYPE G DOMAIN-CONTAINING PROTEIN', 246992),
(371433, 'PTHR45709:SF4', NULL, NULL, NULL, NULL, 'GTPASE LSG1-1', 246992),
(371434, 'PTHR34666:SF2', NULL, NULL, NULL, NULL, 'OS02G0554800 PROTEIN', 246993),
(371435, 'PTHR34666:SF3', NULL, NULL, NULL, NULL, 'OS04G0436000 PROTEIN', 246993),
(371436, 'PTHR34666:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246993),
(371437, 'PTHR34666:SF8', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246993),
(371438, 'PTHR34666', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 246993),
(371439, 'PTHR34666:SF6', NULL, NULL, NULL, NULL, '', 246993),
(371440, 'PTHR34666:SF7', NULL, NULL, NULL, NULL, '', 246993),
(371441, 'PTHR33403:SF40', NULL, NULL, NULL, NULL, 'PROTEIN SPIRAL1-LIKE 3', 246994),
(371442, 'PTHR33403:SF41', NULL, NULL, NULL, NULL, 'PROTEIN SPIRAL1-LIKE 1', 246994),
(371443, 'PTHR33403:SF30', NULL, NULL, NULL, NULL, 'BNAA01G13110D PROTEIN', 246994),
(371444, 'PTHR33403:SF42', NULL, NULL, NULL, NULL, 'PROTEIN SPIRAL1-LIKE 4', 246994),
(371445, 'PTHR33403:SF31', NULL, NULL, NULL, NULL, 'PROTEIN SPIRAL1-LIKE 1', 246994),
(371446, 'PTHR33403:SF43', NULL, NULL, NULL, NULL, 'PROTEIN SPIRAL1-LIKE 2', 246994),
(371447, 'PTHR33403:SF32', NULL, NULL, NULL, NULL, 'BNAA06G39830D PROTEIN', 246994),
(371448, 'PTHR33403', NULL, NULL, NULL, NULL, 'SPR1', 246994),
(371449, 'PTHR33403:SF33', NULL, NULL, NULL, NULL, 'BNAC02G35090D PROTEIN', 246994),
(371450, 'PTHR33403:SF22', NULL, NULL, NULL, NULL, 'DEHYDROGENASE LARGE SUBUNIT, PUTATIVE-RELATED', 246994),
(371451, 'PTHR33403:SF35', NULL, NULL, NULL, NULL, '', 246994),
(371452, 'PTHR33403:SF25', NULL, NULL, NULL, NULL, 'PROTEIN SPIRAL1-LIKE 1', 246994),
(371453, 'PTHR33403:SF36', NULL, NULL, NULL, NULL, '', 246994),
(371454, 'PTHR33403:SF26', NULL, NULL, NULL, NULL, 'PROTEIN SPIRAL1-LIKE 3', 246994),
(371455, 'PTHR33403:SF27', NULL, NULL, NULL, NULL, 'PROTEIN SPIRAL1-LIKE 3', 246994),
(371456, 'PTHR33403:SF38', NULL, NULL, NULL, NULL, 'PROTEIN SPIRAL1-LIKE 3', 246994),
(371457, 'PTHR33403:SF17', NULL, NULL, NULL, NULL, 'PROTEIN SPIRAL1-LIKE 4', 246994),
(371458, 'PTHR33403:SF28', NULL, NULL, NULL, NULL, 'PROTEIN SPIRAL1-LIKE 1-RELATED', 246994),
(371459, 'PTHR33403:SF39', NULL, NULL, NULL, NULL, 'PROTEIN SPIRAL1', 246994),
(371460, 'PTHR33403:SF19', NULL, NULL, NULL, NULL, 'PROTEIN SPIRAL1-LIKE 5', 246994),
(371461, 'PTHR31898:SF4', NULL, NULL, NULL, NULL, 'TLC DOMAIN-CONTAINING 5A', 246995),
(371462, 'PTHR31898:SF5', NULL, NULL, NULL, NULL, 'TLC DOMAIN-CONTAINING PROTEIN', 246995),
(371463, 'PTHR31898', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 136', 246995);
INSERT INTO "PUBLIC"."MODEL" VALUES
(371464, 'PTHR31898:SF2', NULL, NULL, NULL, NULL, 'TRAM, LAG1 AND CLN8 (TLC) LIPID-SENSING DOMAIN CONTAINING PROTEIN', 246995),
(371465, 'PTHR31898:SF3', NULL, NULL, NULL, NULL, 'TLC DOMAIN-CONTAINING PROTEIN', 246995),
(371466, 'PTHR31898:SF6', NULL, NULL, NULL, NULL, 'TLC DOMAIN-CONTAINING PROTEIN', 246995),
(371467, 'PTHR31898:SF7', NULL, NULL, NULL, NULL, 'TLC DOMAIN-CONTAINING PROTEIN 5', 246995),
(371468, 'PTHR31898:SF1', NULL, NULL, NULL, NULL, 'TLC DOMAIN-CONTAINING PROTEIN 5', 246995),
(371469, 'PTHR47801', NULL, NULL, NULL, NULL, 'OS05G0145600 PROTEIN', 246996),
(371470, 'PTHR47801:SF1', NULL, NULL, NULL, NULL, 'OS05G0145600 PROTEIN', 246996),
(371471, 'PTHR30137', NULL, NULL, NULL, NULL, 'LUCIFERASE-LIKE MONOOXYGENASE', 246997),
(371472, 'PTHR30137:SF15', NULL, NULL, NULL, NULL, 'BLL6902 PROTEIN', 246997),
(371473, 'PTHR30137:SF6', NULL, NULL, NULL, NULL, 'LUCIFERASE-LIKE MONOOXYGENASE', 246997),
(371474, 'PTHR30137:SF17', NULL, NULL, NULL, NULL, 'BAC_LUCIFERASE DOMAIN-CONTAINING PROTEIN', 246997),
(371475, 'PTHR30137:SF16', NULL, NULL, NULL, NULL, 'BLL0895 PROTEIN', 246997),
(371476, 'PTHR30137:SF8', NULL, NULL, NULL, NULL, 'BLR5498 PROTEIN', 246997),
(371477, 'PTHR30137:SF18', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', 246997),
(371478, 'PTHR23292:SF7', NULL, NULL, NULL, NULL, 'CELL DEATH-INDUCING P53-TARGET PROTEIN 1', 246998),
(371479, 'PTHR23292:SF5', NULL, NULL, NULL, NULL, 'LITAF DOMAIN-CONTAINING PROTEIN', 246998),
(371480, 'PTHR23292:SF6', NULL, NULL, NULL, NULL, 'FI16602P1-RELATED', 246998),
(371481, 'PTHR23292:SF4', NULL, NULL, NULL, NULL, 'LITAF DOMAIN-CONTAINING PROTEIN', 246998),
(371482, 'PTHR23292:SF1', NULL, NULL, NULL, NULL, 'LITAF DOMAIN-CONTAINING PROTEIN', 246998),
(371483, 'PTHR23292:SF2', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE-INDUCED TUMOR NECROSIS FACTOR-ALPHA FACTOR', 246998),
(371484, 'PTHR23292:SF42', NULL, NULL, NULL, NULL, 'LITAF DOMAIN-CONTAINING PROTEIN', 246998),
(371485, 'PTHR23292:SF41', NULL, NULL, NULL, NULL, 'LITAF DOMAIN-CONTAINING PROTEIN', 246998),
(371486, 'PTHR23292:SF28', NULL, NULL, NULL, NULL, 'SI:CH211-157C3.4', 246998),
(371487, 'PTHR23292:SF27', NULL, NULL, NULL, NULL, 'LITAF DOMAIN-CONTAINING PROTEIN', 246998),
(371488, 'PTHR23292:SF14', NULL, NULL, NULL, NULL, 'FI16615P1-RELATED', 246998),
(371489, 'PTHR23292:SF35', NULL, NULL, NULL, NULL, 'LITAF DOMAIN-CONTAINING PROTEIN', 246998),
(371490, 'PTHR23292:SF46', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE-INDUCED TUMOR NECROSIS FACTOR-ALPHA FACTOR HOMOLOG', 246998),
(371491, 'PTHR23292:SF45', NULL, NULL, NULL, NULL, 'LITAF DOMAIN-CONTAINING PROTEIN-RELATED', 246998),
(371492, 'PTHR23292:SF44', NULL, NULL, NULL, NULL, 'LITAF DOMAIN-CONTAINING PROTEIN', 246998),
(371493, 'PTHR23292:SF10', NULL, NULL, NULL, NULL, 'LITAF DOMAIN-CONTAINING PROTEIN', 246998),
(371494, 'PTHR23292', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE-INDUCED TUMOR NECROSIS FACTOR-ALPHA FACTOR', 246998),
(371495, 'PTHR23292:SF43', NULL, NULL, NULL, NULL, 'LITAF DOMAIN-CONTAINING PROTEIN', 246998),
(371496, 'PTHR39960:SF1', NULL, NULL, NULL, NULL, 'LD34147P', 246999),
(371497, 'PTHR39960', NULL, NULL, NULL, NULL, 'LD34147P', 246999),
(371498, 'PTHR47368:SF2', NULL, NULL, NULL, NULL, 'PID DOMAIN-CONTAINING PROTEIN', 247000),
(371499, 'PTHR47368:SF4', NULL, NULL, NULL, NULL, 'NUMB-LIKE PROTEIN', 247000),
(371500, 'PTHR47368:SF5', NULL, NULL, NULL, NULL, 'PROTEIN NUMB HOMOLOG', 247000),
(371501, 'PTHR47368', NULL, NULL, NULL, NULL, 'NUMB', 247000),
(371502, 'PTHR46297', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH-TYPE WITH G PATCH DOMAIN-CONTAINING PROTEIN', 247001),
(371503, 'PTHR46297:SF2', NULL, NULL, NULL, NULL, 'SMN (SURVIVAL OF MOTOR NEURON PROTEIN) RELATED', 247001),
(371504, 'PTHR46297:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH-TYPE WITH G PATCH DOMAIN-CONTAINING PROTEIN', 247001),
(371505, 'PTHR43065:SF51', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE', 247002),
(371506, 'PTHR43065:SF50', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE', 247002),
(371507, 'PTHR43065:SF22', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE', 247002);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(371508, 'PTHR43065:SF10', NULL, NULL, NULL, NULL, 'PEROXIDE STRESS-ACTIVATED HISTIDINE KINASE MAK3', 247002),
(371509, 'PTHR43065:SF54', NULL, NULL, NULL, NULL, 'SENSOR PROTEIN ZRAS', 247002),
(371510, 'PTHR43065:SF53', NULL, NULL, NULL, NULL, 'SPORULATION KINASE B', 247002),
(371511, 'PTHR43065', NULL, NULL, NULL, NULL, 'SENSOR HISTIDINE KINASE', 247002),
(371512, 'PTHR43065:SF42', NULL, NULL, NULL, NULL, 'TWO-COMPONENT SENSOR PPRA', 247002),
(371513, 'PTHR43065:SF52', NULL, NULL, NULL, NULL, 'SENSOR PROTEIN KINASE PILS', 247002),
(371514, 'PTHR43065:SF48', NULL, NULL, NULL, NULL, 'TWO-COMPONENT SENSOR HISTIDINE KINASE-RELATED', 247002),
(371515, 'PTHR43065:SF47', NULL, NULL, NULL, NULL, 'COMPONENT HISTIDINE KINASE, PUTATIVE-RELATED', 247002),
(371516, 'PTHR43065:SF46', NULL, NULL, NULL, NULL, 'C4-DICARBOXYLATE TRANSPORT SENSOR PROTEIN DCTB', 247002),
(371517, 'PTHR43065:SF23', NULL, NULL, NULL, NULL, 'SENSOR HISTIDINE KINASE PDTAS-RELATED', 247002),
(371518, 'PTHR43065:SF34', NULL, NULL, NULL, NULL, 'SPORULATION KINASE A', 247002),
(371519, 'PTHR43065:SF29', NULL, NULL, NULL, NULL, 'SENSOR PROTEIN KINASE FLES', 247002),
(371520, 'PTHR43065:SF16', NULL, NULL, NULL, NULL, 'SENSORY HISTIDINE KINASE/PHOSPHATASE NTRB', 247002),
(371521, 'PTHR43065:SF49', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE', 247002),
(371522, 'PTHR43424', NULL, NULL, NULL, NULL, 'LOCUS PUTATIVE PROTEIN 1-RELATED', 247003),
(371523, 'PTHR43424:SF1', NULL, NULL, NULL, NULL, 'LOCUS PUTATIVE PROTEIN 1-RELATED', 247003),
(371524, 'PTHR47127:SF10', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 247004),
(371525, 'PTHR47127:SF8', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 247004),
(371526, 'PTHR47127:SF9', NULL, NULL, NULL, NULL, 'CAULI_VI DOMAIN-CONTAINING PROTEIN', 247004),
(371527, 'PTHR47127:SF2', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 247004),
(371528, 'PTHR47127:SF1', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 247004),
(371529, 'PTHR47127:SF6', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 247004),
(371530, 'PTHR47127', NULL, NULL, NULL, NULL, '10A19I.15', 247004),
(371531, 'PTHR47127:SF4', NULL, NULL, NULL, NULL, '10A19I.15', 247004),
(371532, 'PTHR18937:SF173', NULL, NULL, NULL, NULL, 'STRUCTURAL MAINTENANCE OF CHROMOSOMES PROTEIN 4', 247005),
(371533, 'PTHR18937:SF147', NULL, NULL, NULL, NULL, 'STRUCTURAL MAINTENANCE OF CHROMOSOMES PROTEIN 1B', 247005),
(371534, 'PTHR18937', NULL, NULL, NULL, NULL, 'STRUCTURAL MAINTENANCE OF CHROMOSOMES SMC FAMILY MEMBER', 247005),
(371535, 'PTHR18937:SF12', NULL, NULL, NULL, NULL, 'STRUCTURAL MAINTENANCE OF CHROMOSOMES PROTEIN', 247005),
(371536, 'PTHR18937:SF170', NULL, NULL, NULL, NULL, 'STRUCTURAL MAINTENANCE OF CHROMOSOMES PROTEIN 1A', 247005),
(371537, 'PTHR18937:SF172', NULL, NULL, NULL, NULL, 'STRUCTURAL MAINTENANCE OF CHROMOSOMES PROTEIN', 247005),
(371538, 'PTHR18937:SF171', NULL, NULL, NULL, NULL, 'SPORULATION PROTEIN SPO15', 247005),
(371539, 'PTHR38794', NULL, NULL, NULL, NULL, '', 247006),
(371540, 'PTHR38794:SF2', NULL, NULL, NULL, NULL, '', 247006),
(371541, 'PTHR38794:SF3', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN', 247006),
(371542, 'PTHR38794:SF1', NULL, NULL, NULL, NULL, '', 247006),
(371543, 'PTHR28089', NULL, NULL, NULL, NULL, 'PROTEIN ZDS1-RELATED', 247007),
(371544, 'PTHR28089:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ZDS1-RELATED', 247007),
(371545, 'PTHR31207:SF30', NULL, NULL, NULL, NULL, 'PROLAMIN_LIKE DOMAIN-CONTAINING PROTEIN', 247008),
(371546, 'PTHR31207:SF31', NULL, NULL, NULL, NULL, 'PROLAMIN_LIKE DOMAIN-CONTAINING PROTEIN', 247008),
(371547, 'PTHR31207:SF19', NULL, NULL, NULL, NULL, 'PROLAMIN-LIKE PROTEIN', 247008),
(371548, 'PTHR31207', NULL, NULL, NULL, NULL, 'ECA1 GAMETOGENESIS FAMILY PROTEIN (DUF784)-RELATED-RELATED', 247008),
(371549, 'PTHR31207:SF33', NULL, NULL, NULL, NULL, 'PROLAMIN_LIKE DOMAIN-CONTAINING PROTEIN', 247008),
(371550, 'PTHR31207:SF34', NULL, NULL, NULL, NULL, 'PROLAMIN_LIKE DOMAIN-CONTAINING PROTEIN', 247008); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(371551, 'PTHR31207:SF23', NULL, NULL, NULL, NULL, 'DOWNREGULATED IN DIF1 18-RELATED', 247008),
(371552, 'PTHR31207:SF35', NULL, NULL, NULL, NULL, 'ECA1 GAMETOGENESIS FAMILY PROTEIN (DUF784)-RELATED', 247008),
(371553, 'PTHR31207:SF36', NULL, NULL, NULL, NULL, 'PROLAMIN_LIKE DOMAIN-CONTAINING PROTEIN', 247008),
(371554, 'PTHR31207:SF25', NULL, NULL, NULL, NULL, 'PROLAMIN_LIKE DOMAIN-CONTAINING PROTEIN', 247008),
(371555, 'PTHR31207:SF37', NULL, NULL, NULL, NULL, 'PROLAMIN_LIKE DOMAIN-CONTAINING PROTEIN', 247008),
(371556, 'PTHR31207:SF26', NULL, NULL, NULL, NULL, 'PROLAMIN_LIKE DOMAIN-CONTAINING PROTEIN', 247008),
(371557, 'PTHR31207:SF27', NULL, NULL, NULL, NULL, 'PROLAMIN_LIKE DOMAIN-CONTAINING PROTEIN', 247008),
(371558, 'PTHR31207:SF28', NULL, NULL, NULL, NULL, 'PROLAMIN_LIKE DOMAIN-CONTAINING PROTEIN', 247008),
(371559, 'PTHR31207:SF29', NULL, NULL, NULL, NULL, 'PROLAMIN_LIKE DOMAIN-CONTAINING PROTEIN', 247008),
(371560, 'PTHR34978', NULL, NULL, NULL, NULL, 'POSSIBLE SENSOR-TRANSDUCER PROTEIN BLAR', 247009),
(371561, 'PTHR34978:SF3', NULL, NULL, NULL, NULL, 'SLR0241 PROTEIN', 247009),
(371562, 'PTHR24421:SF58', NULL, NULL, NULL, NULL, 'SIGNAL TRANSDUCTION HISTIDINE-PROTEIN KINASE/PHOSPHATASE UHPB', 247010),
(371563, 'PTHR24421:SF57', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE DIMERISATION AND PHOSPHOACCEPTOR REGION', 247010),
(371564, 'PTHR24421:SF37', NULL, NULL, NULL, NULL, 'SENSOR HISTIDINE KINASE NARS', 247010),
(371565, 'PTHR24421:SF59', NULL, NULL, NULL, NULL, 'NITROGEN REGULATION PROTEIN B', 247010),
(371566, 'PTHR24421:SF10', NULL, NULL, NULL, NULL, 'NITRATE/NITRITE SENSOR PROTEIN NARQ', 247010),
(371567, 'PTHR24421:SF56', NULL, NULL, NULL, NULL, 'OXYGEN SENSOR HISTIDINE KINASE RESPONSE REGULATOR DEVS/DOSS', 247010),
(371568, 'PTHR24421:SF55', NULL, NULL, NULL, NULL, 'SIGNAL TRANSDUCTION HISTIDINE-PROTEIN KINASE/PHOSPHATASE DEGS', 247010),
(371569, 'PTHR24421:SF61', NULL, NULL, NULL, NULL, 'NITROGEN REGULATION PROTEIN B', 247010),
(371570, 'PTHR24421:SF60', NULL, NULL, NULL, NULL, 'SENSOR HISTIDINE KINASE COMP', 247010),
(371571, 'PTHR24421:SF63', NULL, NULL, NULL, NULL, 'SENSOR HISTIDINE KINASE DESK', 247010),
(371572, 'PTHR24421:SF40', NULL, NULL, NULL, NULL, 'SENSOR HISTIDINE KINASE YHCY', 247010),
(371573, 'PTHR24421:SF62', NULL, NULL, NULL, NULL, 'HISTIDINE AUTOKINASE-RELATED', 247010),
(371574, 'PTHR24421:SF51', NULL, NULL, NULL, NULL, 'NITRATE/NITRITE SENSOR PROTEIN NARX', 247010),
(371575, 'PTHR24421', NULL, NULL, NULL, NULL, 'NITRATE/NITRITE SENSOR PROTEIN NARX-RELATED', 247010),
(371576, 'PTHR35686:SF1', NULL, NULL, NULL, NULL, 'KINETOCHORE PROTEIN', 247011),
(371577, 'PTHR35686', NULL, NULL, NULL, NULL, 'KINETOCHORE PROTEIN', 247011),
(371578, 'PTHR47048:SF1', NULL, NULL, NULL, NULL, 'PROTEIN SCAF11', 247012),
(371579, 'PTHR47048', NULL, NULL, NULL, NULL, 'PROTEIN SCAF11', 247012),
(371580, 'PTHR38592:SF3', NULL, NULL, NULL, NULL, 'BLL4819 PROTEIN', 247013),
(371581, 'PTHR38592', NULL, NULL, NULL, NULL, 'BLL4819 PROTEIN', 247013),
(371582, 'PTHR47087', NULL, NULL, NULL, NULL, 'METHIONINE S-METHYLTRANSFERASE', 247014),
(371583, 'PTHR47087:SF2', NULL, NULL, NULL, NULL, 'METHIONINE S-METHYLTRANSFERASE', 247014),
(371584, 'PTHR47087:SF1', NULL, NULL, NULL, NULL, 'METHIONINE S-METHYLTRANSFERASE', 247014),
(371585, 'PTHR47087:SF3', NULL, NULL, NULL, NULL, 'METHIONINE S-METHYLTRANSFERASE', 247014),
(371586, 'PTHR15396:SF1', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P PROTEIN SUBUNIT P40', 247015),
(371587, 'PTHR15396', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P PROTEIN SUBUNIT P40', 247015),
(371588, 'PTHR36122:SF2', NULL, NULL, NULL, NULL, 'NICOTINAMIDE RIBOSIDE TRANSPORTER PNUC', 247016),
(371589, 'PTHR36122', NULL, NULL, NULL, NULL, 'NICOTINAMIDE RIBOSIDE TRANSPORTER PNUC', 247016),
(371590, 'PTHR43150:SF7', NULL, NULL, NULL, NULL, 'VOLTAGE-GATED POTASSIUM CHANNEL SUBUNIT BETA-1', 247017),
(371591, 'PTHR43150:SF6', NULL, NULL, NULL, NULL, 'VIC POTASSIUM ION CHANNEL, BETA SUBUNIT (EUROFUNG)', 247017),
(371592, 'PTHR43150:SF9', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 247017);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(371593, 'PTHR43150', NULL, NULL, NULL, NULL, 'HYPERKINETIC, ISOFORM M', 247017),
(371594, 'PTHR43150:SF1', NULL, NULL, NULL, NULL, 'VOLTAGE-GATED POTASSIUM CHANNEL SUBUNIT BETA-2', 247017),
(371595, 'PTHR43150:SF3', NULL, NULL, NULL, NULL, 'VOLTAGE-GATED POTASSIUM CHANNEL SUBUNIT BETA-3', 247017),
(371596, 'PTHR43150:SF2', NULL, NULL, NULL, NULL, 'HYPERKINETIC, ISOFORM M', 247017),
(371597, 'PTHR43150:SF4', NULL, NULL, NULL, NULL, 'L-GLYCERALDEHYDE 3-PHOSPHATE REDUCTASE', 247017),
(371598, 'PTHR31101:SF2', NULL, NULL, NULL, NULL, 'UPF0547 DOMAIN-CONTAINING PROTEIN', 247018),
(371599, 'PTHR31101:SF3', NULL, NULL, NULL, NULL, 'UPF0547 PROTEIN C16ORF87', 247018),
(371600, 'PTHR31101:SF4', NULL, NULL, NULL, NULL, 'CHROMOSOME 16 OPEN READING FRAME 87', 247018),
(371601, 'PTHR31101', NULL, NULL, NULL, NULL, 'UPF0547 PROTEIN C16ORF87', 247018),
(371602, 'PTHR46127:SF1', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 65', 247019),
(371603, 'PTHR46127', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 65', 247019),
(371604, 'PTHR30536:SF5', NULL, NULL, NULL, NULL, 'ALTRONATE DEHYDRATASE', 247020),
(371605, 'PTHR30536:SF1', NULL, NULL, NULL, NULL, 'GALACTARATE DEHYDRATASE (L-THREO-FORMING)', 247020),
(371606, 'PTHR30536', NULL, NULL, NULL, NULL, 'ALTRONATE/GALACTARATE DEHYDRATASE', 247020),
(371607, 'PTHR12598:SF0', NULL, NULL, NULL, NULL, 'COPPER HOMEOSTASIS PROTEIN CUTC HOMOLOG', 247021),
(371608, 'PTHR12598', NULL, NULL, NULL, NULL, 'COPPER HOMEOSTASIS PROTEIN CUTC', 247021),
(371609, 'PTHR33154:SF32', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 247022),
(371610, 'PTHR33154:SF33', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR RV2034', 247022),
(371611, 'PTHR33154:SF12', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 247022),
(371612, 'PTHR33154:SF35', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, ARSR FAMILY', 247022),
(371613, 'PTHR33154:SF24', NULL, NULL, NULL, NULL, 'HTH5 FAMILY PROTEIN', 247022),
(371614, 'PTHR33154:SF25', NULL, NULL, NULL, NULL, 'LMO0101 PROTEIN', 247022),
(371615, 'PTHR33154:SF36', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR', 247022),
(371616, 'PTHR33154:SF37', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN (POSSIBLY ARSR-FAMILY)-RELATED', 247022),
(371617, 'PTHR33154:SF15', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN ARSR', 247022),
(371618, 'PTHR33154:SF28', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR YGAV-RELATED', 247022),
(371619, 'PTHR33154:SF18', NULL, NULL, NULL, NULL, 'ARSENICAL RESISTANCE OPERON REPRESSOR', 247022),
(371620, 'PTHR33154:SF29', NULL, NULL, NULL, NULL, 'THIOSULFATE SULFURTRANSFERASE', 247022),
(371621, 'PTHR33154', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, ARSR FAMILY', 247022),
(371622, 'PTHR46716:SF1', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 7', 247023),
(371623, 'PTHR46716', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 7', 247023),
(371624, 'PTHR34485', NULL, NULL, NULL, NULL, 'PROLINE-RICH, LACRIMAL 1', 247024),
(371625, 'PTHR34485:SF1', NULL, NULL, NULL, NULL, 'PROLINE-RICH, LACRIMAL 1', 247024),
(371626, 'PTHR46474:SF1', NULL, NULL, NULL, NULL, 'TWO PORE CALCIUM CHANNEL PROTEIN 1', 247025),
(371627, 'PTHR46474', NULL, NULL, NULL, NULL, 'TWO PORE CALCIUM CHANNEL PROTEIN 1', 247025),
(371628, 'PTHR42737:SF4', NULL, NULL, NULL, NULL, 'GLUTATHIONE REDUCTASE', 247026),
(371629, 'PTHR42737:SF5', NULL, NULL, NULL, NULL, 'GLUTATHIONE REDUCTASE, MITOCHONDRIAL', 247026),
(371630, 'PTHR42737:SF2', NULL, NULL, NULL, NULL, 'GLUTATHIONE REDUCTASE', 247026),
(371631, 'PTHR42737:SF3', NULL, NULL, NULL, NULL, 'THIOREDOXIN-DISULFIDE REDUCTASE', 247026),
(371632, 'PTHR42737:SF1', NULL, NULL, NULL, NULL, 'GLUTATHIONE REDUCTASE', 247026),
(371633, 'PTHR42737', NULL, NULL, NULL, NULL, 'GLUTATHIONE REDUCTASE', 247026),
(371634, 'PTHR46382', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE CYTIDYLYLTRANSFERASE', 247027),
(371635, 'PTHR46382:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE CYTIDYLYLTRANSFERASE', 247027);
INSERT INTO "PUBLIC"."MODEL" VALUES
(371636, 'PTHR40076', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 247028),
(371637, 'PTHR40076:SF1', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 247028),
(371638, 'PTHR24129', NULL, NULL, NULL, NULL, 'ANKYCORBIN', 247029),
(371639, 'PTHR24129:SF0', NULL, NULL, NULL, NULL, 'ANKYCORBIN', 247029),
(371640, 'PTHR45749:SF19', NULL, NULL, NULL, NULL, 'DUF4371 DOMAIN-CONTAINING PROTEIN', 247030),
(371641, 'PTHR45749', NULL, NULL, NULL, NULL, '', 247030),
(371642, 'PTHR45749:SF20', NULL, NULL, NULL, NULL, 'DUF4371 DOMAIN-CONTAINING PROTEIN', 247030),
(371643, 'PTHR45749:SF14', NULL, NULL, NULL, NULL, 'TTF-TYPE DOMAIN-CONTAINING PROTEIN', 247030),
(371644, 'PTHR45749:SF13', NULL, NULL, NULL, NULL, 'AC-LIKE TRANSPOSASE-RELATED', 247030),
(371645, 'PTHR45749:SF18', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR 2-RELATED ZINC FINGER PROTEIN', 247030),
(371646, 'PTHR45749:SF17', NULL, NULL, NULL, NULL, 'DIMER_TNP_HAT DOMAIN-CONTAINING PROTEIN', 247030),
(371647, 'PTHR45749:SF16', NULL, NULL, NULL, NULL, 'DUF4371 DOMAIN-CONTAINING PROTEIN', 247030),
(371648, 'PTHR45749:SF15', NULL, NULL, NULL, NULL, 'TTF-TYPE DOMAIN-CONTAINING PROTEIN', 247030),
(371649, 'PTHR23255:SF69', NULL, NULL, NULL, NULL, 'ACTIVIN RECEPTOR TYPE-1', 247031),
(371650, 'PTHR23255:SF58', NULL, NULL, NULL, NULL, 'ACTIVIN RECEPTOR TYPE-1C', 247031),
(371651, 'PTHR23255:SF68', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN SERINE/THREONINE KINASE', 247031),
(371652, 'PTHR23255:SF49', NULL, NULL, NULL, NULL, 'ANTI-MUELLERIAN HORMONE TYPE-2 RECEPTOR', 247031),
(371653, 'PTHR23255:SF98', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE RECEPTOR', 247031),
(371654, 'PTHR23255:SF64', NULL, NULL, NULL, NULL, 'ACTIVIN RECEPTOR TYPE-2A', 247031),
(371655, 'PTHR23255:SF66', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE RECEPTOR R3', 247031),
(371656, 'PTHR23255:SF55', NULL, NULL, NULL, NULL, 'TGF-BETA RECEPTOR TYPE-2', 247031),
(371657, 'PTHR23255:SF22', NULL, NULL, NULL, NULL, 'ACTIVIN RECEPTOR TYPE-1B', 247031),
(371658, 'PTHR23255:SF50', NULL, NULL, NULL, NULL, 'BONE MORPHOGENETIC PROTEIN RECEPTOR TYPE-1A', 247031),
(371659, 'PTHR23255:SF61', NULL, NULL, NULL, NULL, 'TGF-BETA RECEPTOR TYPE-1', 247031),
(371660, 'PTHR23255', NULL, NULL, NULL, NULL, 'TRANSFORMING GROWTH FACTOR-BETA RECEPTOR TYPE I AND II', 247031),
(371661, 'PTHR23255:SF72', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN SERINE/THREONINE KINASE', 247031),
(371662, 'PTHR23255:SF60', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE RECEPTOR', 247031),
(371663, 'PTHR23255:SF71', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN SERINE/THREONINE KINASE', 247031),
(371664, 'PTHR23255:SF63', NULL, NULL, NULL, NULL, 'BONE MORPHOGENETIC PROTEIN RECEPTOR TYPE-2', 247031),
(371665, 'PTHR23255:SF96', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN SERINE/THREONINE KINASE', 247031),
(371666, 'PTHR23255:SF51', NULL, NULL, NULL, NULL, 'TGF-BETA RECEPTOR TYPE-2', 247031),
(371667, 'PTHR23255:SF62', NULL, NULL, NULL, NULL, 'BONE MORPHOGENETIC PROTEIN RECEPTOR TYPE-1B', 247031),
(371668, 'PTHR23255:SF70', NULL, NULL, NULL, NULL, 'ACTIVIN RECEPTOR TYPE-2B', 247031),
(371669, 'PTHR23255:SF100', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN SERINE/THREONINE KINASE', 247031),
(371670, 'PTHR23255:SF103', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN SERINE/THREONINE KINASE', 247031),
(371671, 'PTHR23255:SF102', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN SERINE/THREONINE KINASE', 247031),
(371672, 'PTHR31110:SF8', NULL, NULL, NULL, NULL, 'MAMMALIAN UNCOORDINATED HOMOLOGY 13, DOMAIN 2-RELATED', 247032),
(371673, 'PTHR31110:SF7', NULL, NULL, NULL, NULL, '', 247032),
(371674, 'PTHR31110:SF5', NULL, NULL, NULL, NULL, '', 247032),
(371675, 'PTHR31110:SF10', NULL, NULL, NULL, NULL, '', 247032),
(371676, 'PTHR31110:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 247032),
(371677, 'PTHR31110:SF3', NULL, NULL, NULL, NULL, 'PORTAL PROTEIN', 247032),
(371678, 'PTHR31110:SF2', NULL, NULL, NULL, NULL, 'PESTICIDAL CRYSTAL CRY8BA PROTEIN', 247032),
(371679, 'PTHR31110', NULL, NULL, NULL, NULL, 'PESTICIDAL CRYSTAL CRY8BA PROTEIN', 247032);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(371680, 'PTHR31110:SF9', NULL, NULL, NULL, NULL, '', 247032),
(371681, 'PTHR37721:SF1', NULL, NULL, NULL, NULL, 'OS05G0464200 PROTEIN', 247033),
(371682, 'PTHR37721', NULL, NULL, NULL, NULL, 'OS05G0464200 PROTEIN', 247033),
(371683, 'PTHR43826:SF9', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 247034),
(371684, 'PTHR43826:SF8', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 247034),
(371685, 'PTHR43826:SF7', NULL, NULL, NULL, NULL, 'PROTEIN UHPC, PUTATIVE-RELATED', 247034),
(371686, 'PTHR43826:SF6', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE TRANSPORTER', 247034),
(371687, 'PTHR43826:SF10', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 37 MEMBER 4B', 247034),
(371688, 'PTHR43826', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE EXCHANGER SLC37A4', 247034),
(371689, 'PTHR43826:SF11', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 37 MEMBER 4A', 247034),
(371690, 'PTHR43826:SF4', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 247034),
(371691, 'PTHR43826:SF3', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE EXCHANGER SLC37A4', 247034),
(371692, 'PTHR43826:SF2', NULL, NULL, NULL, NULL, 'HEXOSE-6-PHOSPHATE:PHOSPHATE ANTIPORTER', 247034),
(371693, 'PTHR37783:SF1', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G04315)-RELATED', 247035),
(371694, 'PTHR37783', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G04315)-RELATED', 247035),
(371695, 'PTHR13162', NULL, NULL, NULL, NULL, 'CCR4-NOT TRANSCRIPTION COMPLEX', 247036),
(371696, 'PTHR13162:SF8', NULL, NULL, NULL, NULL, 'CCR4-NOT TRANSCRIPTION COMPLEX SUBUNIT 1', 247036),
(371697, 'PTHR13162:SF13', NULL, NULL, NULL, NULL, 'BNACNNG58980D PROTEIN', 247036),
(371698, 'PTHR13162:SF11', NULL, NULL, NULL, NULL, '', 247036),
(371699, 'PTHR13162:SF17', NULL, NULL, NULL, NULL, 'BNACNNG09060D PROTEIN', 247036),
(371700, 'PTHR13162:SF15', NULL, NULL, NULL, NULL, 'BNAANNG20460D PROTEIN', 247036),
(371701, 'PTHR12052:SF10', NULL, NULL, NULL, NULL, '', 247037),
(371702, 'PTHR12052', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE PROTEN 4A, 4B', 247037),
(371703, 'PTHR12052:SF4', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE PROTEIN 4B', 247037),
(371704, 'PTHR12052:SF5', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE PROTEIN 4A', 247037),
(371705, 'PTHR12052:SF7', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE PROTEIN YLS8', 247037),
(371706, 'PTHR12052:SF9', NULL, NULL, NULL, NULL, '', 247037),
(371707, 'PTHR12052:SF14', NULL, NULL, NULL, NULL, '', 247037),
(371708, 'PTHR12052:SF12', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE PROTEIN YLS8', 247037),
(371709, 'PTHR12052:SF13', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE PROTEIN YLS8', 247037),
(371710, 'PTHR15096:SF5', NULL, NULL, NULL, NULL, 'PROLACTIN-INDUCIBLE PROTEIN', 247038),
(371711, 'PTHR15096', NULL, NULL, NULL, NULL, 'PROLACTIN-INDUCIBLE PROTEIN/SEMINAL VESICLE ANTIGEN', 247038),
(371712, 'PTHR15096:SF8', NULL, NULL, NULL, NULL, 'PROLACTIN-INDUCED PROTEIN', 247038),
(371713, 'PTHR15096:SF9', NULL, NULL, NULL, NULL, 'PROLACTIN-INDUCED PROTEIN', 247038),
(371714, 'PTHR36707', NULL, NULL, NULL, NULL, 'T20M3.17 PROTEIN', 247039),
(371715, 'PTHR36707:SF1', NULL, NULL, NULL, NULL, 'T20M3.17 PROTEIN', 247039),
(371716, 'PTHR36707:SF2', NULL, NULL, NULL, NULL, 'BNAC04G42350D PROTEIN', 247039),
(371717, 'PTHR36707:SF3', NULL, NULL, NULL, NULL, 'BNAA05G11300D PROTEIN', 247039),
(371718, 'PTHR36707:SF4', NULL, NULL, NULL, NULL, 'BNAC04G13120D PROTEIN', 247039),
(371719, 'PTHR11214:SF339', NULL, NULL, NULL, NULL, 'BETA-1,3-GALACTOSYLTRANSFERASE 4-RELATED', 247040),
(371720, 'PTHR11214:SF217', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371721, 'PTHR11214:SF338', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371722, 'PTHR11214:SF219', NULL, NULL, NULL, NULL, 'UDP-GALNAC:BETA-1,3-N-ACETYLGALACTOSAMINYLTRANSFERASE 2', 247040),
(371723, 'PTHR11214:SF87', NULL, NULL, NULL, NULL, 'UDP-GLCNAC:BETAGAL BETA-1,3-N-ACETYLGLUCOSAMINYLTRANSFERASE 8', 247040),
(371724, 'PTHR11214:SF85', NULL, NULL, NULL, NULL, 'BETA-1,3-GALACTOSYLTRANSFERASE 12-RELATED', 247040);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(371725, 'PTHR11214:SF290', NULL, NULL, NULL, NULL, 'BETA-1,3-GALACTOSYLTRANSFERASE 13-RELATED', 247040),
(371726, 'PTHR11214:SF91', NULL, NULL, NULL, NULL, 'UDP-GLCNAC:BETAGAL BETA-1,3-N-ACETYLGLUCOSAMINYLTRANSFERASE 9', 247040),
(371727, 'PTHR11214:SF294', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371728, 'PTHR11214:SF291', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371729, 'PTHR11214:SF330', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371730, 'PTHR11214:SF297', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371731, 'PTHR11214:SF335', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371732, 'PTHR11214:SF334', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371733, 'PTHR11214:SF212', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE O-GALACTOSYLTRANSFERASE GALT2', 247040),
(371734, 'PTHR11214:SF333', NULL, NULL, NULL, NULL, '', 247040),
(371735, 'PTHR11214:SF229', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371736, 'PTHR11214:SF349', NULL, NULL, NULL, NULL, 'BETA-1,3-GALACTOSYLTRANSFERASE BRN', 247040),
(371737, 'PTHR11214:SF348', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371738, 'PTHR11214:SF226', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371739, 'PTHR11214:SF347', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371740, 'PTHR11214:SF19', NULL, NULL, NULL, NULL, 'BETA-1,3-GALACTOSYLTRANSFERASE 2', 247040),
(371741, 'PTHR11214:SF105', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371742, 'PTHR11214:SF93', NULL, NULL, NULL, NULL, 'UDP-GLCNAC:BETAGAL BETA-1,3-N-ACETYLGLUCOSAMINYLTRANSFERASE 7', 247040),
(371743, 'PTHR11214:SF342', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371744, 'PTHR11214:SF340', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371745, 'PTHR11214:SF346', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371746, 'PTHR11214:SF343', NULL, NULL, NULL, NULL, 'BETA-1,3-GALACTOSYLTRANSFERASE 1-RELATED', 247040),
(371747, 'PTHR11214:SF314', NULL, NULL, NULL, NULL, 'BETA-1,3-GALACTOSYLTRANSFERASE 4', 247040),
(371748, 'PTHR11214:SF319', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371749, 'PTHR11214:SF151', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371750, 'PTHR11214:SF270', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371751, 'PTHR11214:SF275', NULL, NULL, NULL, NULL, 'BETA-1,3-GALACTOSYLTRANSFERASE 8-RELATED', 247040),
(371752, 'PTHR11214:SF153', NULL, NULL, NULL, NULL, 'UDP-GALNAC:BETA-1,3-N-ACETYLGALACTOSAMINYLTRANSFERASE 1', 247040),
(371753, 'PTHR11214:SF273', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371754, 'PTHR11214:SF311', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371755, 'PTHR11214:SF74', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE O-GALACTOSYLTRANSFERASE HPGT1', 247040),
(371756, 'PTHR11214:SF283', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371757, 'PTHR11214:SF3', NULL, NULL, NULL, NULL, 'BETA-1,3-GALACTOSYLTRANSFERASE 6', 247040),
(371758, 'PTHR11214:SF320', NULL, NULL, NULL, NULL, 'BETA-1,3-GALACTOSYLTRANSFERASE-LIKE PROTEIN', 247040),
(371759, 'PTHR11214:SF286', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE O-GALACTOSYLTRANSFERASE GALT4', 247040),
(371760, 'PTHR11214:SF285', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371761, 'PTHR11214:SF5', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371762, 'PTHR11214:SF324', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371763, 'PTHR11214:SF289', NULL, NULL, NULL, NULL, 'GALECTIN DOMAIN-CONTAINING PROTEIN', 247040),
(371764, 'PTHR11214:SF322', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371765, 'PTHR11214:SF371', NULL, NULL, NULL, NULL, 'BETA-1,3-GALACTOSYLTRANSFERASE 7', 247040),
(371766, 'PTHR11214:SF370', NULL, NULL, NULL, NULL, 'N-ACETYLLACTOSAMINIDE BETA-1,3-N-ACETYLGLUCOSAMINYLTRANSFERASE 3', 247040),
(371767, 'PTHR11214:SF133', NULL, NULL, NULL, NULL, 'OS02G0577300 PROTEIN', 247040),
(371768, 'PTHR11214:SF372', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371769, 'PTHR11214:SF136', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE O-GALACTOSYLTRANSFERASE GALT4', 247040);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(371770, 'PTHR11214:SF135', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371771, 'PTHR11214:SF256', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE O-GALACTOSYLTRANSFERASE HPGT2', 247040),
(371772, 'PTHR11214:SF305', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371773, 'PTHR11214:SF308', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371774, 'PTHR11214:SF307', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371775, 'PTHR11214:SF265', NULL, NULL, NULL, NULL, 'BETA-1,3-GALACTOSYLTRANSFERASE 5', 247040),
(371776, 'PTHR11214:SF263', NULL, NULL, NULL, NULL, 'BETA-1,3-GALACTOSYLTRANSFERASE GALT1-LIKE', 247040),
(371777, 'PTHR11214:SF269', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371778, 'PTHR11214:SF268', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE O-GALACTOSYLTRANSFERASE GALT6-LIKE', 247040),
(371779, 'PTHR11214:SF267', NULL, NULL, NULL, NULL, 'BETA-1,3-GALACTOSYLTRANSFERASE 3-RELATED', 247040),
(371780, 'PTHR11214:SF29', NULL, NULL, NULL, NULL, 'BETA-1,3-GALACTOSYLTRANSFERASE 9', 247040),
(371781, 'PTHR11214:SF359', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE O-GALACTOSYLTRANSFERASE GALT5', 247040),
(371782, 'PTHR11214:SF358', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371783, 'PTHR11214:SF25', NULL, NULL, NULL, NULL, 'N-ACETYLLACTOSAMINIDE BETA-1,3-N-ACETYLGLUCOSAMINYLTRANSFERASE 2', 247040),
(371784, 'PTHR11214:SF21', NULL, NULL, NULL, NULL, 'LACTOSYLCERAMIDE 1,3-N-ACETYL-BETA-D-GLUCOSAMINYLTRANSFERASE', 247040),
(371785, 'PTHR11214:SF20', NULL, NULL, NULL, NULL, 'BETA-1,3-GALACTOSYLTRANSFERASE 1', 247040),
(371786, 'PTHR11214:SF23', NULL, NULL, NULL, NULL, 'ACETYLGALACTOSAMINYL-O-GLYCOSYL-GLYCOPROTEIN BETA-1,3-N-ACETYLGLUCOSAMINYLTRANSFERASE', 247040),
(371787, 'PTHR11214:SF353', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371788, 'PTHR11214:SF352', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE O-GALACTOSYLTRANSFERASE GALT6', 247040),
(371789, 'PTHR11214:SF351', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371790, 'PTHR11214:SF350', NULL, NULL, NULL, NULL, 'BETA-1,3-GALACTOSYLTRANSFERASE BRE-5', 247040),
(371791, 'PTHR11214', NULL, NULL, NULL, NULL, 'BETA-1,3-N-ACETYLGLUCOSAMINYLTRANSFERASE', 247040),
(371792, 'PTHR11214:SF357', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371793, 'PTHR11214:SF115', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371794, 'PTHR11214:SF356', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371795, 'PTHR11214:SF235', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371796, 'PTHR11214:SF234', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371797, 'PTHR11214:SF355', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371798, 'PTHR11214:SF354', NULL, NULL, NULL, NULL, 'GALECTIN DOMAIN-CONTAINING PROTEIN', 247040),
(371799, 'PTHR11214:SF129', NULL, NULL, NULL, NULL, 'BETA-1,3-GALACTOSYLTRANSFERASE GALT1', 247040),
(371800, 'PTHR11214:SF369', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE O-GALACTOSYLTRANSFERASE GALT6-LIKE', 247040),
(371801, 'PTHR11214:SF360', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371802, 'PTHR11214:SF364', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371803, 'PTHR11214:SF122', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371804, 'PTHR11214:SF363', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371805, 'PTHR11214:SF242', NULL, NULL, NULL, NULL, 'BETA-1,3-GALACTOSYLTRANSFERASE 5-RELATED', 247040),
(371806, 'PTHR11214:SF121', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371807, 'PTHR11214:SF362', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371808, 'PTHR11214:SF241', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE O-GALACTOSYLTRANSFERASE GALT4', 247040),
(371809, 'PTHR11214:SF361', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371810, 'PTHR11214:SF368', NULL, NULL, NULL, NULL, 'N-ACETYLLACTOSAMINIDE BETA-1,3-N-ACETYLGLUCOSAMINYLTRANSFERASE 4', 247040),
(371811, 'PTHR11214:SF367', NULL, NULL, NULL, NULL, 'BETA-1,3-GALACTOSYLTRANSFERASE 2-RELATED', 247040),
(371812, 'PTHR11214:SF366', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(371813, 'PTHR11214:SF124', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE O-GALACTOSYLTRANSFERASE HPGT3', 247040),
(371814, 'PTHR11214:SF245', NULL, NULL, NULL, NULL, 'OS07G0194800 PROTEIN', 247040),
(371815, 'PTHR11214:SF244', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371816, 'PTHR11214:SF123', NULL, NULL, NULL, NULL, 'BETA-1,6-GALACTOSYLTRANSFERASE GALT31A', 247040),
(371817, 'PTHR11214:SF365', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247040),
(371818, 'PTHR40588:SF1', NULL, NULL, NULL, NULL, 'MRNA INTERFERASE TOXIN YAFQ', 247041),
(371819, 'PTHR40588', NULL, NULL, NULL, NULL, 'MRNA INTERFERASE TOXIN YAFQ', 247041),
(371820, 'PTHR46010:SF1', NULL, NULL, NULL, NULL, 'PROTEIN IWS1 HOMOLOG', 247042),
(371821, 'PTHR46010', NULL, NULL, NULL, NULL, 'PROTEIN IWS1 HOMOLOG', 247042),
(371822, 'PTHR47293:SF60', NULL, NULL, NULL, NULL, 'INACTIVE PROTEIN RESTRICTED TEV MOVEMENT 1-LIKE', 247043),
(371823, 'PTHR47293:SF62', NULL, NULL, NULL, NULL, 'INACTIVE PROTEIN RESTRICTED TEV MOVEMENT 1-LIKE', 247043),
(371824, 'PTHR47293:SF64', NULL, NULL, NULL, NULL, 'JACALIN-RELATED LECTIN 35', 247043),
(371825, 'PTHR47293:SF20', NULL, NULL, NULL, NULL, 'BNAC01G35320D PROTEIN', 247043),
(371826, 'PTHR47293:SF21', NULL, NULL, NULL, NULL, 'JACALIN-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 247043),
(371827, 'PTHR47293:SF66', NULL, NULL, NULL, NULL, 'JACALIN-RELATED LECTIN 11-RELATED', 247043),
(371828, 'PTHR47293:SF67', NULL, NULL, NULL, NULL, 'MANNOSE/GLUCOSE-SPECIFIC LECTIN-RELATED', 247043),
(371829, 'PTHR47293:SF68', NULL, NULL, NULL, NULL, 'JACALIN-RELATED LECTIN 3', 247043),
(371830, 'PTHR47293:SF26', NULL, NULL, NULL, NULL, 'MANNOSE-BINDING LECTIN SUPERFAMILY PROTEIN', 247043),
(371831, 'PTHR47293:SF27', NULL, NULL, NULL, NULL, 'JACALIN-RELATED LECTIN 22-RELATED', 247043),
(371832, 'PTHR47293:SF28', NULL, NULL, NULL, NULL, 'JACALIN-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 247043),
(371833, 'PTHR47293:SF70', NULL, NULL, NULL, NULL, 'JACALIN-RELATED LECTIN 24-RELATED', 247043),
(371834, 'PTHR47293:SF71', NULL, NULL, NULL, NULL, 'PYK10-BINDING PROTEIN 1-RELATED', 247043),
(371835, 'PTHR47293:SF72', NULL, NULL, NULL, NULL, 'INACTIVE PROTEIN RESTRICTED TEV MOVEMENT 1-LIKE', 247043),
(371836, 'PTHR47293:SF73', NULL, NULL, NULL, NULL, 'JACALIN-RELATED LECTIN 46-RELATED', 247043),
(371837, 'PTHR47293:SF30', NULL, NULL, NULL, NULL, 'BNAA06G01980D PROTEIN', 247043),
(371838, 'PTHR47293:SF74', NULL, NULL, NULL, NULL, '', 247043),
(371839, 'PTHR47293:SF75', NULL, NULL, NULL, NULL, 'MYROSINASE-BINDING PROTEIN 2', 247043),
(371840, 'PTHR47293:SF31', NULL, NULL, NULL, NULL, 'BNAC03G78030D PROTEIN', 247043),
(371841, 'PTHR47293:SF32', NULL, NULL, NULL, NULL, 'BNAC05G11200D PROTEIN', 247043),
(371842, 'PTHR47293:SF76', NULL, NULL, NULL, NULL, 'JACALIN-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 247043),
(371843, 'PTHR47293:SF33', NULL, NULL, NULL, NULL, 'JACALIN-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 247043),
(371844, 'PTHR47293:SF77', NULL, NULL, NULL, NULL, 'MANNOSE/GLUCOSE-SPECIFIC LECTIN-LIKE', 247043),
(371845, 'PTHR47293:SF78', NULL, NULL, NULL, NULL, 'BNAA06G13880D PROTEIN', 247043),
(371846, 'PTHR47293:SF34', NULL, NULL, NULL, NULL, 'BNAA08G29580D PROTEIN', 247043),
(371847, 'PTHR47293:SF79', NULL, NULL, NULL, NULL, 'JACALIN-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 247043),
(371848, 'PTHR47293:SF36', NULL, NULL, NULL, NULL, '', 247043),
(371849, 'PTHR47293:SF37', NULL, NULL, NULL, NULL, 'BNACNNG15490D PROTEIN', 247043),
(371850, 'PTHR47293:SF38', NULL, NULL, NULL, NULL, 'INACTIVE PROTEIN RESTRICTED TEV MOVEMENT 1-LIKE', 247043),
(371851, 'PTHR47293:SF80', NULL, NULL, NULL, NULL, 'JACALIN-RELATED LECTIN 2-RELATED', 247043),
(371852, 'PTHR47293:SF43', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN DWY1, CHLOROPLASTIC', 247043),
(371853, 'PTHR47293:SF44', NULL, NULL, NULL, NULL, 'BNAA01G28070D PROTEIN', 247043),
(371854, 'PTHR47293:SF45', NULL, NULL, NULL, NULL, 'JACALIN-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 247043),
(371855, 'PTHR47293:SF46', NULL, NULL, NULL, NULL, 'JACALIN-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 247043);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(371856, 'PTHR47293:SF47', NULL, NULL, NULL, NULL, 'JACALIN-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 247043),
(371857, 'PTHR47293:SF48', NULL, NULL, NULL, NULL, 'JACALIN-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 247043),
(371858, 'PTHR47293:SF9', NULL, NULL, NULL, NULL, 'JACALIN-RELATED LECTIN 36', 247043),
(371859, 'PTHR47293:SF7', NULL, NULL, NULL, NULL, 'JACALIN-RELATED LECTIN 34-RELATED', 247043),
(371860, 'PTHR47293:SF51', NULL, NULL, NULL, NULL, 'JACALIN-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 247043),
(371861, 'PTHR47293:SF52', NULL, NULL, NULL, NULL, 'JACALIN-RELATED LECTIN 10-RELATED', 247043),
(371862, 'PTHR47293:SF54', NULL, NULL, NULL, NULL, 'JACALIN-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 247043),
(371863, 'PTHR47293:SF10', NULL, NULL, NULL, NULL, 'BNAA06G01990D PROTEIN', 247043),
(371864, 'PTHR47293', NULL, NULL, NULL, NULL, 'JACALIN-RELATED LECTIN 3', 247043),
(371865, 'PTHR47293:SF11', NULL, NULL, NULL, NULL, 'JACALIN-RELATED LECTIN 12-RELATED', 247043),
(371866, 'PTHR47293:SF12', NULL, NULL, NULL, NULL, 'JACALIN-RELATED LECTIN 32-RELATED', 247043),
(371867, 'PTHR47293:SF57', NULL, NULL, NULL, NULL, 'JACALIN-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 247043),
(371868, 'PTHR47293:SF13', NULL, NULL, NULL, NULL, 'JACALIN-RELATED LECTIN 45', 247043),
(371869, 'PTHR47293:SF58', NULL, NULL, NULL, NULL, 'BNAC03G22030D PROTEIN', 247043),
(371870, 'PTHR47293:SF59', NULL, NULL, NULL, NULL, 'JACALIN-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 247043),
(371871, 'PTHR47293:SF15', NULL, NULL, NULL, NULL, 'JACALIN-RELATED LECTIN 19', 247043),
(371872, 'PTHR23407', NULL, NULL, NULL, NULL, 'ATPASE INHIBITOR/5-FORMYLTETRAHYDROFOLATE CYCLO-LIGASE', 247044),
(371873, 'PTHR23407:SF11', NULL, NULL, NULL, NULL, 'CYCLO-LIGASE, PUTATIVE-RELATED', 247044),
(371874, 'PTHR23407:SF6', NULL, NULL, NULL, NULL, 'ATPASE INHIBITOR, MITOCHONDRIAL', 247044),
(371875, 'PTHR23407:SF10', NULL, NULL, NULL, NULL, '5-FORMYLTETRAHYDROFOLATE CYCLO-LIGASE, MITOCHONDRIAL-LIKE ISOFORM X1', 247044),
(371876, 'PTHR23407:SF1', NULL, NULL, NULL, NULL, '5-FORMYLTETRAHYDROFOLATE CYCLO-LIGASE', 247044),
(371877, 'PTHR43345:SF9', NULL, NULL, NULL, NULL, '3-ISOPROPYLMALATE DEHYDRATASE SMALL SUBUNIT', 247045),
(371878, 'PTHR43345:SF8', NULL, NULL, NULL, NULL, 'ACONITASE_C DOMAIN-CONTAINING PROTEIN', 247045),
(371879, 'PTHR43345:SF7', NULL, NULL, NULL, NULL, '3-ISOPROPYLMALATE DEHYDRATASE SMALL SUBUNIT 2', 247045),
(371880, 'PTHR43345:SF5', NULL, NULL, NULL, NULL, '3-ISOPROPYLMALATE DEHYDRATASE SMALL SUBUNIT', 247045),
(371881, 'PTHR43345:SF2', NULL, NULL, NULL, NULL, '3-ISOPROPYLMALATE DEHYDRATASE SMALL SUBUNIT 1-RELATED', 247045),
(371882, 'PTHR43345', NULL, NULL, NULL, NULL, '3-ISOPROPYLMALATE DEHYDRATASE SMALL SUBUNIT 2-RELATED-RELATED', 247045),
(371883, 'PTHR43345:SF10', NULL, NULL, NULL, NULL, '3-ISOPROPYLMALATE DEHYDRATASE SMALL SUBUNIT 1', 247045),
(371884, 'PTHR46205:SF1', NULL, NULL, NULL, NULL, 'RISC-LOADING COMPLEX SUBUNIT TARBP2', 247046),
(371885, 'PTHR46205:SF3', NULL, NULL, NULL, NULL, 'LOQUACIOUS, ISOFORM B', 247046),
(371886, 'PTHR46205:SF2', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCIBLE DOUBLE-STRANDED RNA-DEPENDENT PROTEIN KINASE ACTIVATOR A', 247046),
(371887, 'PTHR46205', NULL, NULL, NULL, NULL, 'LOQUACIOUS, ISOFORM B', 247046),
(371888, 'PTHR46205:SF5', NULL, NULL, NULL, NULL, 'BLANKS-RELATED', 247046),
(371889, 'PTHR46205:SF4', NULL, NULL, NULL, NULL, 'LD06392P', 247046),
(371890, 'PTHR21740:SF3', NULL, NULL, NULL, NULL, 'NCK-ASSOCIATED PROTEIN 5-LIKE', 247047),
(371891, 'PTHR21740:SF0', NULL, NULL, NULL, NULL, 'NCK-ASSOCIATED PROTEIN 5', 247047),
(371892, 'PTHR21740', NULL, NULL, NULL, NULL, 'NCK-ASSOCIATED PROTEIN 5', 247047),
(371893, 'PTHR21740:SF8', NULL, NULL, NULL, NULL, '', 247047),
(371894, 'PTHR47666', NULL, NULL, NULL, NULL, 'PROTEIN VASCULAR ASSOCIATED DEATH 1, CHLOROPLASTIC', 247048),
(371895, 'PTHR47666:SF1', NULL, NULL, NULL, NULL, 'PROTEIN VASCULAR ASSOCIATED DEATH 1, CHLOROPLASTIC', 247048),
(371896, 'PTHR43199:SF1', NULL, NULL, NULL, NULL, 'GLUTATHIONE HYDROLASE PROENZYME', 247049),
(371897, 'PTHR43199:SF6', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYLTRANSPEPTIDASE-RELATED', 247049);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(371898, 'PTHR43199', NULL, NULL, NULL, NULL, 'GLUTATHIONE HYDROLASE', 247049),
(371899, 'PTHR12566:SF17', NULL, NULL, NULL, NULL, 'CYTOPLASMIC POLYADENYLATION ELEMENT-BINDING PROTEIN 1', 247050),
(371900, 'PTHR12566:SF6', NULL, NULL, NULL, NULL, 'FOG-1 PROTEIN', 247050),
(371901, 'PTHR12566:SF12', NULL, NULL, NULL, NULL, 'TRANSLATIONAL REGULATOR ORB2', 247050),
(371902, 'PTHR12566:SF2', NULL, NULL, NULL, NULL, 'CYTOPLASMIC POLYADENYLATION ELEMENT-BINDING PROTEIN 4', 247050),
(371903, 'PTHR12566', NULL, NULL, NULL, NULL, 'CYTOPLASMIC POLYADENYLATION ELEMENT BINDING PROTEIN  CPEB', 247050),
(371904, 'PTHR12566:SF8', NULL, NULL, NULL, NULL, 'CYTOPLASMIC POLYADENYLATION ELEMENT-BINDING PROTEIN 2', 247050),
(371905, 'PTHR12566:SF7', NULL, NULL, NULL, NULL, 'CYTOPLASMIC POLYADENYLATION ELEMENT-BINDING PROTEIN 3', 247050),
(371906, 'PTHR12566:SF9', NULL, NULL, NULL, NULL, 'CYTOPLASMIC POLYADENYLATION ELEMENT-BINDING PROTEIN 1', 247050),
(371907, 'PTHR13468:SF14', NULL, NULL, NULL, NULL, 'DEK_C DOMAIN-CONTAINING PROTEIN', 247051),
(371908, 'PTHR13468:SF12', NULL, NULL, NULL, NULL, 'DEK_C DOMAIN-CONTAINING PROTEIN', 247051),
(371909, 'PTHR13468:SF13', NULL, NULL, NULL, NULL, 'OS01G0924900 PROTEIN', 247051),
(371910, 'PTHR13468:SF18', NULL, NULL, NULL, NULL, 'DEK CARBOXY-TERMINAL DOMAIN PROTEIN-RELATED', 247051),
(371911, 'PTHR13468:SF16', NULL, NULL, NULL, NULL, 'BNAANNG31030D PROTEIN', 247051),
(371912, 'PTHR13468:SF17', NULL, NULL, NULL, NULL, 'DEK_C DOMAIN-CONTAINING PROTEIN', 247051),
(371913, 'PTHR13468:SF10', NULL, NULL, NULL, NULL, 'DEK DOMAIN-CONTAINING CHROMATIN ASSOCIATED PROTEIN', 247051),
(371914, 'PTHR13468:SF21', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER F FAMILY MEMBER 4-LIKE ISOFORM X1', 247051),
(371915, 'PTHR13468:SF11', NULL, NULL, NULL, NULL, 'DNA LIGASE 1-LIKE ISOFORM X1', 247051),
(371916, 'PTHR13468:SF1', NULL, NULL, NULL, NULL, 'PROTEIN DEK', 247051),
(371917, 'PTHR13468:SF20', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE, DEK-RELATED', 247051),
(371918, 'PTHR13468:SF7', NULL, NULL, NULL, NULL, 'OS03G0412900 PROTEIN', 247051),
(371919, 'PTHR13468', NULL, NULL, NULL, NULL, 'DEK PROTEIN', 247051),
(371920, 'PTHR47068:SF5', NULL, NULL, NULL, NULL, 'CYS2/HIS2 ZINC-FINGER TRANSCRIPTION FACTOR', 247052),
(371921, 'PTHR47068:SF4', NULL, NULL, NULL, NULL, 'ZINC FINGER, C2H2-LIKE PROTEIN-RELATED', 247052),
(371922, 'PTHR47068:SF6', NULL, NULL, NULL, NULL, 'BNACNNG09030D PROTEIN', 247052),
(371923, 'PTHR47068', NULL, NULL, NULL, NULL, 'OS02G0659100 PROTEIN', 247052),
(371924, 'PTHR47068:SF1', NULL, NULL, NULL, NULL, 'OS02G0659100 PROTEIN', 247052),
(371925, 'PTHR47068:SF3', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZAT1-LIKE', 247052),
(371926, 'PTHR47068:SF2', NULL, NULL, NULL, NULL, 'OS04G0552400 PROTEIN', 247052),
(371927, 'PTHR48035:SF2', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN 1', 247053),
(371928, 'PTHR48035:SF4', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN 1-LIKE', 247053),
(371929, 'PTHR48035:SF3', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN-RELATED', 247053),
(371930, 'PTHR48035', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN 1', 247053),
(371931, 'PTHR48035:SF6', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN 27C', 247053),
(371932, 'PTHR48035:SF5', NULL, NULL, NULL, NULL, 'BNACNNG54370D PROTEIN', 247053),
(371933, 'PTHR32422', NULL, NULL, NULL, NULL, 'ADHERENS JUNCTION-ASSOCIATED PROTEIN 1', 247054),
(371934, 'PTHR32422:SF0', NULL, NULL, NULL, NULL, 'ADHERENS JUNCTION-ASSOCIATED PROTEIN 1', 247054),
(371935, 'PTHR34669', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE FOLD DOMAIN-CONTAINING PROTEIN MRL7L, CHLOROPLASTIC', 247055),
(371936, 'PTHR34669:SF2', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE FOLD DOMAIN-CONTAINING PROTEIN MRL7, CHLOROPLASTIC', 247055),
(371937, 'PTHR34669:SF1', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE FOLD DOMAIN-CONTAINING PROTEIN MRL7L, CHLOROPLASTIC', 247055),
(371938, 'PTHR48179:SF1', NULL, NULL, NULL, NULL, 'OS08G0232201 PROTEIN', 247056),
(371939, 'PTHR48179', NULL, NULL, NULL, NULL, 'OS08G0232201 PROTEIN', 247056);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(371940, 'PTHR11849:SF286', NULL, NULL, NULL, NULL, 'ETS DOMAIN-CONTAINING PROTEIN', 247057),
(371941, 'PTHR11849:SF165', NULL, NULL, NULL, NULL, 'ETS DOMAIN-CONTAINING TRANSCRIPTION FACTOR ERF-LIKE', 247057),
(371942, 'PTHR11849:SF287', NULL, NULL, NULL, NULL, 'ETS DOMAIN-CONTAINING PROTEIN', 247057),
(371943, 'PTHR11849:SF288', NULL, NULL, NULL, NULL, 'ETS DOMAIN-CONTAINING PROTEIN', 247057),
(371944, 'PTHR11849:SF201', NULL, NULL, NULL, NULL, 'ETS DNA-BINDING PROTEIN POKKURI', 247057),
(371945, 'PTHR11849:SF289', NULL, NULL, NULL, NULL, 'ETS-LIKE PROTEIN POINTED', 247057),
(371946, 'PTHR11849:SF203', NULL, NULL, NULL, NULL, 'PROTEIN FEV', 247057),
(371947, 'PTHR11849:SF206', NULL, NULL, NULL, NULL, 'ETS TRANSLOCATION VARIANT 2', 247057),
(371948, 'PTHR11849:SF209', NULL, NULL, NULL, NULL, 'PROTEIN C-ETS-1', 247057),
(371949, 'PTHR11849:SF281', NULL, NULL, NULL, NULL, 'ETS DOMAIN-CONTAINING PROTEIN', 247057),
(371950, 'PTHR11849:SF160', NULL, NULL, NULL, NULL, 'ETS TRANSLOCATION VARIANT 5', 247057),
(371951, 'PTHR11849:SF282', NULL, NULL, NULL, NULL, 'ETV5-RELATED PROTEIN ETS96B', 247057),
(371952, 'PTHR11849:SF161', NULL, NULL, NULL, NULL, 'FRIEND LEUKEMIA INTEGRATION 1 TRANSCRIPTION FACTOR', 247057),
(371953, 'PTHR11849:SF174', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SPI-B', 247057),
(371954, 'PTHR11849:SF133', NULL, NULL, NULL, NULL, 'ETS DOMAIN-CONTAINING PROTEIN', 247057),
(371955, 'PTHR11849:SF299', NULL, NULL, NULL, NULL, 'SI:CH211-265G22.4', 247057),
(371956, 'PTHR11849:SF178', NULL, NULL, NULL, NULL, 'ETS DOMAIN-CONTAINING PROTEIN ELK-1', 247057),
(371957, 'PTHR11849:SF216', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR ERG', 247057),
(371958, 'PTHR11849:SF10', NULL, NULL, NULL, NULL, 'ETS-RELATED TRANSCRIPTION FACTOR ELF-2', 247057),
(371959, 'PTHR11849:SF290', NULL, NULL, NULL, NULL, 'PNT DOMAIN-CONTAINING PROTEIN', 247057),
(371960, 'PTHR11849:SF291', NULL, NULL, NULL, NULL, 'ETS DOMAIN-CONTAINING PROTEIN', 247057),
(371961, 'PTHR11849:SF170', NULL, NULL, NULL, NULL, 'ETS-RELATED TRANSCRIPTION FACTOR ELF-4', 247057),
(371962, 'PTHR11849:SF171', NULL, NULL, NULL, NULL, 'ETS HOMOLOGOUS FACTOR', 247057),
(371963, 'PTHR11849:SF172', NULL, NULL, NULL, NULL, 'ETS DOMAIN-CONTAINING PROTEIN ELK-3', 247057),
(371964, 'PTHR11849:SF187', NULL, NULL, NULL, NULL, 'ETS-DOMAIN LACKING', 247057),
(371965, 'PTHR11849:SF188', NULL, NULL, NULL, NULL, 'PROTEIN C-ETS-2', 247057),
(371966, 'PTHR11849:SF301', NULL, NULL, NULL, NULL, '', 247057),
(371967, 'PTHR11849:SF302', NULL, NULL, NULL, NULL, 'ETS DOMAIN-CONTAINING PROTEIN', 247057),
(371968, 'PTHR11849:SF303', NULL, NULL, NULL, NULL, 'PNT DOMAIN-CONTAINING PROTEIN', 247057),
(371969, 'PTHR11849:SF19', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR ETV6', 247057),
(371970, 'PTHR11849:SF304', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN D-ETS-3', 247057),
(371971, 'PTHR11849:SF305', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN D-ETS-6', 247057),
(371972, 'PTHR11849:SF17', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SPI-C', 247057),
(371973, 'PTHR11849:SF306', NULL, NULL, NULL, NULL, 'ETS TRANSLOCATION VARIANT 3-LIKE PROTEIN', 247057),
(371974, 'PTHR11849:SF307', NULL, NULL, NULL, NULL, 'ETS DOMAIN-CONTAINING PROTEIN', 247057),
(371975, 'PTHR11849:SF59', NULL, NULL, NULL, NULL, 'ETS DOMAIN-CONTAINING PROTEIN', 247057),
(371976, 'PTHR11849:SF15', NULL, NULL, NULL, NULL, 'ETS-RELATED TRANSCRIPTION FACTOR ELF-5', 247057),
(371977, 'PTHR11849:SF16', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PU.1', 247057),
(371978, 'PTHR11849:SF13', NULL, NULL, NULL, NULL, 'ETS-RELATED TRANSCRIPTION FACTOR ELF-3', 247057),
(371979, 'PTHR11849:SF21', NULL, NULL, NULL, NULL, 'ETS DOMAIN-CONTAINING PROTEIN ELK-4', 247057),
(371980, 'PTHR11849:SF181', NULL, NULL, NULL, NULL, 'ETS TRANSLOCATION VARIANT 4', 247057),
(371981, 'PTHR11849:SF182', NULL, NULL, NULL, NULL, 'SAM POINTED DOMAIN-CONTAINING ETS TRANSCRIPTION FACTOR', 247057),
(371982, 'PTHR11849:SF184', NULL, NULL, NULL, NULL, 'ETS DOMAIN-CONTAINING PROTEIN', 247057),
(371983, 'PTHR11849:SF196', NULL, NULL, NULL, NULL, 'ETS TRANSLOCATION VARIANT 1', 247057);
INSERT INTO "PUBLIC"."MODEL" VALUES
(371984, 'PTHR11849:SF275', NULL, NULL, NULL, NULL, 'FLI-1 PROTO-ONCOGENE, ETS TRANSCRIPTION FACTOR B', 247057),
(371985, 'PTHR11849:SF276', NULL, NULL, NULL, NULL, 'SPI-2 PROTO-ONCOGENE', 247057),
(371986, 'PTHR11849:SF156', NULL, NULL, NULL, NULL, 'ETS-RELATED TRANSCRIPTION FACTOR ELF-1', 247057),
(371987, 'PTHR11849:SF279', NULL, NULL, NULL, NULL, 'ETS DOMAIN-CONTAINING PROTEIN', 247057),
(371988, 'PTHR11849:SF77', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR ETV7', 247057),
(371989, 'PTHR11849', NULL, NULL, NULL, NULL, 'ETS', 247057),
(371990, 'PTHR11849:SF31', NULL, NULL, NULL, NULL, 'ETS DOMAIN-CONTAINING TRANSCRIPTION FACTOR ERF', 247057),
(371991, 'PTHR11849:SF30', NULL, NULL, NULL, NULL, 'ETS TRANSLOCATION VARIANT 3', 247057),
(371992, 'PTHR11849:SF190', NULL, NULL, NULL, NULL, 'ETS DOMAIN-CONTAINING PROTEIN', 247057),
(371993, 'PTHR11849:SF191', NULL, NULL, NULL, NULL, 'ECDYSONE-INDUCED PROTEIN 74EF ISOFORM B', 247057),
(371994, 'PTHR11849:SF195', NULL, NULL, NULL, NULL, 'GA-BINDING PROTEIN ALPHA CHAIN', 247057),
(371995, 'PTHR21164', NULL, NULL, NULL, NULL, 'CHORISMATE MUTASE', 247058),
(371996, 'PTHR21164:SF0', NULL, NULL, NULL, NULL, 'CHORISMATE MUTASE AROH', 247058),
(371997, 'PTHR11671:SF1', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT D', 247059),
(371998, 'PTHR11671:SF2', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT D', 247059),
(371999, 'PTHR11671:SF3', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT D-RELATED', 247059),
(372000, 'PTHR11671', NULL, NULL, NULL, NULL, 'V-TYPE ATP SYNTHASE SUBUNIT D', 247059),
(372001, 'PTHR46124', NULL, NULL, NULL, NULL, 'D-AMINOACYL-TRNA DEACYLASE', 247060),
(372002, 'PTHR46124:SF4', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 247060),
(372003, 'PTHR46124:SF2', NULL, NULL, NULL, NULL, 'D-AMINOACYL-TRNA DEACYLASE', 247060),
(372004, 'PTHR46124:SF3', NULL, NULL, NULL, NULL, 'HYDROLASE-RELATED', 247060),
(372005, 'PTHR24189:SF50', NULL, NULL, NULL, NULL, 'MYOTROPHIN', 247061),
(372006, 'PTHR24189:SF67', NULL, NULL, NULL, NULL, 'M-PHASE PHOSPHOPROTEIN 8', 247061),
(372007, 'PTHR24189:SF57', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 247061),
(372008, 'PTHR24189:SF68', NULL, NULL, NULL, NULL, 'LETHAL (2) 35BE', 247061),
(372009, 'PTHR24189:SF65', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 247061),
(372010, 'PTHR24189:SF66', NULL, NULL, NULL, NULL, 'SI:CH211-203B8.6', 247061),
(372011, 'PTHR24189:SF63', NULL, NULL, NULL, NULL, '', 247061),
(372012, 'PTHR24189:SF52', NULL, NULL, NULL, NULL, 'MYOTROPHIN', 247061),
(372013, 'PTHR24189', NULL, NULL, NULL, NULL, 'MYOTROPHIN', 247061),
(372014, 'PTHR24189:SF64', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-RICH MEMBRANE SPANNING PROTEIN', 247061),
(372015, 'PTHR33433:SF2', NULL, NULL, NULL, NULL, 'FLOWERING-PROMOTING FACTOR 1-LIKE PROTEIN 5', 247062),
(372016, 'PTHR33433:SF32', NULL, NULL, NULL, NULL, 'FLOWERING-PROMOTING FACTOR 1-LIKE PROTEIN 3', 247062),
(372017, 'PTHR33433:SF21', NULL, NULL, NULL, NULL, '', 247062),
(372018, 'PTHR33433:SF4', NULL, NULL, NULL, NULL, 'FLOWERING-PROMOTING FACTOR 1-LIKE PROTEIN 4', 247062),
(372019, 'PTHR33433:SF22', NULL, NULL, NULL, NULL, 'FLOWERING-PROMOTING FACTOR 1-LIKE PROTEIN 1', 247062),
(372020, 'PTHR33433:SF11', NULL, NULL, NULL, NULL, 'FLOWERING-PROMOTING FACTOR 1-LIKE', 247062),
(372021, 'PTHR33433:SF30', NULL, NULL, NULL, NULL, '', 247062),
(372022, 'PTHR33433:SF6', NULL, NULL, NULL, NULL, 'FLOWERING-PROMOTING FACTOR 1-LIKE PROTEIN 2', 247062),
(372023, 'PTHR33433:SF31', NULL, NULL, NULL, NULL, 'FLOWERING-PROMOTING FACTOR 1-LIKE PROTEIN 1', 247062),
(372024, 'PTHR33433:SF14', NULL, NULL, NULL, NULL, 'FLOWERING-PROMOTING FACTOR 1', 247062),
(372025, 'PTHR33433:SF25', NULL, NULL, NULL, NULL, 'FLOWERING-PROMOTING FACTOR 1-RELATED', 247062),
(372026, 'PTHR33433:SF26', NULL, NULL, NULL, NULL, 'FLOWERING PROMOTING FACTOR-LIKE 1', 247062),
(372027, 'PTHR33433:SF15', NULL, NULL, NULL, NULL, 'FLOWERING-PROMOTING FACTOR 1-LIKE PROTEIN 2', 247062),
(372028, 'PTHR33433:SF12', NULL, NULL, NULL, NULL, 'FLOWERING-PROMOTING FACTOR 1-LIKE PROTEIN 3', 247062);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(372029, 'PTHR33433:SF23', NULL, NULL, NULL, NULL, 'FLOWERING PROMOTING FACTOR-LIKE 1', 247062),
(372030, 'PTHR33433:SF13', NULL, NULL, NULL, NULL, '', 247062),
(372031, 'PTHR33433:SF29', NULL, NULL, NULL, NULL, 'BNAA03G51440D PROTEIN', 247062),
(372032, 'PTHR33433:SF19', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 247062),
(372033, 'PTHR33433:SF27', NULL, NULL, NULL, NULL, 'BNAA08G12520D PROTEIN', 247062),
(372034, 'PTHR33433:SF8', NULL, NULL, NULL, NULL, 'FLOWERING-PROMOTING FACTOR 1-LIKE PROTEIN 1', 247062),
(372035, 'PTHR33433', NULL, NULL, NULL, NULL, 'FLOWERING-PROMOTING FACTOR 1-LIKE PROTEIN 1', 247062),
(372036, 'PTHR24203:SF55', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 247063),
(372037, 'PTHR24203:SF77', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 247063),
(372038, 'PTHR24203:SF78', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 2A', 247063),
(372039, 'PTHR24203:SF45', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 247063),
(372040, 'PTHR24203:SF68', NULL, NULL, NULL, NULL, 'REPEAT DOMAIN PROTEIN 2, PUTATIVE, EXPRESSED-RELATED', 247063),
(372041, 'PTHR24203:SF79', NULL, NULL, NULL, NULL, '', 247063),
(372042, 'PTHR24203:SF14', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 10', 247063),
(372043, 'PTHR24203:SF69', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 247063),
(372044, 'PTHR24203:SF39', NULL, NULL, NULL, NULL, 'OS12G0587100 PROTEIN', 247063),
(372045, 'PTHR24203:SF80', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 6', 247063),
(372046, 'PTHR24203:SF81', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX PROTEIN 15-RELATED', 247063),
(372047, 'PTHR24203:SF70', NULL, NULL, NULL, NULL, '', 247063),
(372048, 'PTHR24203', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 247063),
(372049, 'PTHR24203:SF82', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING 2B-RELATED', 247063),
(372050, 'PTHR24203:SF71', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 247063),
(372051, 'PTHR24203:SF72', NULL, NULL, NULL, NULL, 'PROTEASOME NON-ATPASE REGULATORY SUBUNIT 10, PUTATIVE, EXPRESSED-RELATED', 247063),
(372052, 'PTHR24203:SF61', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 2A-RELATED', 247063),
(372053, 'PTHR24203:SF73', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT PROTEIN', 247063),
(372054, 'PTHR24203:SF52', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 247063),
(372055, 'PTHR24203:SF74', NULL, NULL, NULL, NULL, 'OS05G0298200 PROTEIN', 247063),
(372056, 'PTHR24203:SF53', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN, CHLOROPLASTIC', 247063),
(372057, 'PTHR24203:SF75', NULL, NULL, NULL, NULL, 'NOTCH-REGULATED ANKYRIN REPEAT-CONTAINING PROTEIN', 247063),
(372058, 'PTHR24203:SF76', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 247063),
(372059, 'PTHR24203:SF65', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT PROTEIN RF_0381-RELATED', 247063),
(372060, 'PTHR41910:SF1', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE HYDROPHOBIC MEMBRANE ANCHOR SUBUNIT', 247064),
(372061, 'PTHR41910', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE 2 MEMBRANE SUBUNIT SDHC', 247064),
(372062, 'PTHR14375:SF2', NULL, NULL, NULL, NULL, 'SIMILAR TO RIKEN CDNA 4931414P19', 247065),
(372063, 'PTHR14375', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247065),
(372064, 'PTHR31400:SF2', NULL, NULL, NULL, NULL, 'GUANYLYL CYCLASE-RELATED', 247066),
(372065, 'PTHR31400', NULL, NULL, NULL, NULL, 'GUANYLYL CYCLASE DOMAIN CONTAINING PROTEIN 1 GUCD1', 247066),
(372066, 'PTHR31400:SF1', NULL, NULL, NULL, NULL, 'PROTEIN GUCD1', 247066),
(372067, 'PTHR36179:SF2', NULL, NULL, NULL, NULL, 'LUD_DOM DOMAIN-CONTAINING PROTEIN', 247067),
(372068, 'PTHR36179:SF1', NULL, NULL, NULL, NULL, 'PRESPORE-SPECIFIC PROTEIN', 247067),
(372069, 'PTHR36179', NULL, NULL, NULL, NULL, 'LUD_DOM DOMAIN-CONTAINING PROTEIN', 247067),
(372070, 'PTHR14338:SF7', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 247068);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(372071, 'PTHR14338:SF8', NULL, NULL, NULL, NULL, 'ACTIN FILAMENT-ASSOCIATED PROTEIN 1', 247068),
(372072, 'PTHR14338:SF9', NULL, NULL, NULL, NULL, '', 247068),
(372073, 'PTHR14338', NULL, NULL, NULL, NULL, 'ACTIN FILAMENT-ASSOCIATED PROTEIN 1 FAMILY MEMBER', 247068),
(372074, 'PTHR14338:SF1', NULL, NULL, NULL, NULL, 'ACTIN FILAMENT-ASSOCIATED PROTEIN 1-LIKE 1', 247068),
(372075, 'PTHR14338:SF4', NULL, NULL, NULL, NULL, 'ACTIN FILAMENT-ASSOCIATED PROTEIN 1-LIKE 2', 247068),
(372076, 'PTHR14194:SF101', NULL, NULL, NULL, NULL, 'NAD(P)-BD_DOM DOMAIN-CONTAINING PROTEIN', 247069),
(372077, 'PTHR14194', NULL, NULL, NULL, NULL, 'NITROGEN METABOLIC REGULATION PROTEIN NMR-RELATED', 247069),
(372078, 'PTHR14194:SF104', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247069),
(372079, 'PTHR14194:SF86', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 247069),
(372080, 'PTHR34197:SF10', NULL, NULL, NULL, NULL, 'BNAA02G27530D PROTEIN', 247070),
(372081, 'PTHR34197:SF11', NULL, NULL, NULL, NULL, 'BNACNNG49610D PROTEIN', 247070),
(372082, 'PTHR34197:SF5', NULL, NULL, NULL, NULL, '', 247070),
(372083, 'PTHR34197:SF6', NULL, NULL, NULL, NULL, 'DUF740 FAMILY PROTEIN', 247070),
(372084, 'PTHR34197:SF7', NULL, NULL, NULL, NULL, '', 247070),
(372085, 'PTHR34197:SF8', NULL, NULL, NULL, NULL, '', 247070),
(372086, 'PTHR34197:SF1', NULL, NULL, NULL, NULL, 'OS02G0693000 PROTEIN', 247070),
(372087, 'PTHR34197:SF2', NULL, NULL, NULL, NULL, 'OS04G0591300 PROTEIN', 247070),
(372088, 'PTHR34197:SF3', NULL, NULL, NULL, NULL, 'BNAA06G33530D PROTEIN', 247070),
(372089, 'PTHR34197', NULL, NULL, NULL, NULL, 'OS04G0591300 PROTEIN', 247070),
(372090, 'PTHR34197:SF4', NULL, NULL, NULL, NULL, '', 247070),
(372091, 'PTHR35353', NULL, NULL, NULL, NULL, 'OSTEOCRIN', 247071),
(372092, 'PTHR35353:SF1', NULL, NULL, NULL, NULL, 'OSTEOCRIN', 247071),
(372093, 'PTHR23102:SF25', NULL, NULL, NULL, NULL, '', 247072),
(372094, 'PTHR23102:SF24', NULL, NULL, NULL, NULL, 'CLEAVAGE AND POLYADENYLATION SPECIFICITY FACTOR SUBUNIT 4', 247072),
(372095, 'PTHR23102:SF18', NULL, NULL, NULL, NULL, 'CLEAVAGE AND POLYADENYLATION SPECIFICITY FACTOR SUBUNIT 4', 247072),
(372096, 'PTHR23102:SF19', NULL, NULL, NULL, NULL, 'CLEAVAGE AND POLYADENYLATION SPECIFICITY FACTOR SUBUNIT 4-LIKE PROTEIN-RELATED', 247072),
(372097, 'PTHR23102', NULL, NULL, NULL, NULL, 'CLEAVAGE AND POLYADENYLATION SPECIFICITY FACTOR SUBUNIT 4-RELATED', 247072),
(372098, 'PTHR35604', NULL, NULL, NULL, NULL, 'TRANSPOSASE INSH FOR INSERTION SEQUENCE ELEMENT IS5A-RELATED', 247073),
(372099, 'PTHR35604:SF2', NULL, NULL, NULL, NULL, 'TRANSPOSASE INSH FOR INSERTION SEQUENCE ELEMENT IS5A-RELATED', 247073),
(372100, 'PTHR19241:SF328', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 2', 247074),
(372101, 'PTHR19241:SF495', NULL, NULL, NULL, NULL, 'ABC MULTIDRUG TRANSPORTER (EUROFUNG)', 247074),
(372102, 'PTHR19241:SF650', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 247074),
(372103, 'PTHR19241:SF651', NULL, NULL, NULL, NULL, 'DRUG RESISTANCE TRANSPORTER-LIKE ABC DOMAIN PROTEIN', 247074),
(372104, 'PTHR19241:SF574', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 30-RELATED', 247074),
(372105, 'PTHR19241:SF530', NULL, NULL, NULL, NULL, 'DRUG RESISTANCE TRANSPORTER-LIKE ABC DOMAIN PROTEIN', 247074),
(372106, 'PTHR19241:SF531', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 32', 247074),
(372107, 'PTHR19241:SF652', NULL, NULL, NULL, NULL, 'PLEIOTROPIC DRUG RESISTANCE PROTEIN 1', 247074),
(372108, 'PTHR19241:SF498', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PROTEIN', 247074),
(372109, 'PTHR19241:SF179', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT PERMEASE PDR10-RELATED', 247074),
(372110, 'PTHR19241:SF566', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 40', 247074),
(372111, 'PTHR19241:SF644', NULL, NULL, NULL, NULL, 'ABC-2 AND PLANT PDR ABC-TYPE TRANSPORTER FAMILY PROTEIN', 247074),
(372112, 'PTHR19241:SF567', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 42-RELATED', 247074),
(372113, 'PTHR19241:SF298', NULL, NULL, NULL, NULL, 'ABC MULTIDRUG TRANSPORTER (EUROFUNG)', 247074);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(372114, 'PTHR19241:SF253', NULL, NULL, NULL, NULL, 'ABC MULTIDRUG TRANSPORTER (EUROFUNG)', 247074),
(372115, 'PTHR19241:SF645', NULL, NULL, NULL, NULL, 'PLEIOTROPIC DRUG RESISTANCE PROTEIN 3-LIKE', 247074),
(372116, 'PTHR19241:SF524', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 36', 247074),
(372117, 'PTHR19241:SF601', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 50', 247074),
(372118, 'PTHR19241:SF646', NULL, NULL, NULL, NULL, 'ABC-2 AND PLANT PDR ABC-TYPE TRANSPORTER FAMILY PROTEIN', 247074),
(372119, 'PTHR19241:SF569', NULL, NULL, NULL, NULL, 'PLEIOTROPIC DRUG RESISTANCE PROTEIN 3-LIKE', 247074),
(372120, 'PTHR19241:SF647', NULL, NULL, NULL, NULL, 'DRUG RESISTANCE TRANSPORTER-LIKE ABC DOMAIN PROTEIN', 247074),
(372121, 'PTHR19241:SF649', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 16', 247074),
(372122, 'PTHR19241:SF580', NULL, NULL, NULL, NULL, 'DRUG RESISTANCE TRANSPORTER-LIKE ABC DOMAIN PROTEIN', 247074),
(372123, 'PTHR19241:SF660', NULL, NULL, NULL, NULL, '', 247074),
(372124, 'PTHR19241:SF584', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 247074),
(372125, 'PTHR19241:SF662', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 39', 247074),
(372126, 'PTHR19241:SF663', NULL, NULL, NULL, NULL, '', 247074),
(372127, 'PTHR19241:SF654', NULL, NULL, NULL, NULL, 'PDR-TYPE ABC TRANSPORTER', 247074),
(372128, 'PTHR19241:SF611', NULL, NULL, NULL, NULL, '', 247074),
(372129, 'PTHR19241:SF457', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 10-RELATED', 247074),
(372130, 'PTHR19241:SF655', NULL, NULL, NULL, NULL, '', 247074),
(372131, 'PTHR19241:SF579', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 35', 247074),
(372132, 'PTHR19241:SF536', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 17', 247074),
(372133, 'PTHR19241:SF538', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 34', 247074),
(372134, 'PTHR19241:SF617', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 7', 247074),
(372135, 'PTHR19241:SF619', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 37', 247074),
(372136, 'PTHR19241:SF306', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 46', 247074),
(372137, 'PTHR19241:SF670', NULL, NULL, NULL, NULL, 'CASSETTE TRANSPORTER, PUTATIVE-RELATED', 247074),
(372138, 'PTHR19241:SF671', NULL, NULL, NULL, NULL, 'PLEIOTROPIC DRUG RESISTANCE PROTEIN 2-LIKE', 247074),
(372139, 'PTHR19241:SF672', NULL, NULL, NULL, NULL, 'CASSETTE TRANSPORTER, PUTATIVE-RELATED', 247074),
(372140, 'PTHR19241:SF551', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 247074),
(372141, 'PTHR19241:SF673', NULL, NULL, NULL, NULL, 'PLEIOTROPIC DRUG RESISTANCE PROTEIN 3-LIKE', 247074),
(372142, 'PTHR19241:SF630', NULL, NULL, NULL, NULL, 'PLEIOTROPIC DRUG RESISTANCE PROTEIN', 247074),
(372143, 'PTHR19241:SF674', NULL, NULL, NULL, NULL, '', 247074),
(372144, 'PTHR19241:SF664', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 11-RELATED', 247074),
(372145, 'PTHR19241:SF620', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN/PERMEASE PDR18-RELATED', 247074),
(372146, 'PTHR19241:SF157', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 3', 247074),
(372147, 'PTHR19241:SF665', NULL, NULL, NULL, NULL, 'DRUG RESISTANCE TRANSPORTER-LIKE ABC DOMAIN PROTEIN', 247074),
(372148, 'PTHR19241:SF621', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 37', 247074),
(372149, 'PTHR19241:SF666', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 34', 247074),
(372150, 'PTHR19241:SF353', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 38', 247074),
(372151, 'PTHR19241:SF622', NULL, NULL, NULL, NULL, 'PLEIOTROPIC DRUG RESISTANCE PROTEIN 3-LIKE', 247074),
(372152, 'PTHR19241:SF545', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 29', 247074),
(372153, 'PTHR19241:SF667', NULL, NULL, NULL, NULL, 'ABC MULTIDRUG TRANSPORTER A-1', 247074),
(372154, 'PTHR19241:SF668', NULL, NULL, NULL, NULL, 'ABC MULTIDRUG TRANSPORTER (EUROFUNG)', 247074),
(372155, 'PTHR19241:SF669', NULL, NULL, NULL, NULL, 'PLEIOTROPIC DRUG RESISTANCE PROTEIN 2-LIKE', 247074);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(372156, 'PTHR19241:SF625', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 18', 247074),
(372157, 'PTHR19241:SF628', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 33', 247074),
(372158, 'PTHR19241:SF629', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 34', 247074),
(372159, 'PTHR19241:SF561', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 31', 247074),
(372160, 'PTHR19241:SF640', NULL, NULL, NULL, NULL, 'PLANT PDR ABC TRANSPORTER ASSOCIATED-RELATED', 247074),
(372161, 'PTHR19241:SF313', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 44', 247074),
(372162, 'PTHR19241:SF641', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 29-LIKE', 247074),
(372163, 'PTHR19241:SF510', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 39-LIKE', 247074),
(372164, 'PTHR19241:SF289', NULL, NULL, NULL, NULL, 'DRUG RESISTANCE TRANSPORTER-LIKE ABC DOMAIN PROTEIN', 247074),
(372165, 'PTHR19241:SF675', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 31', 247074),
(372166, 'PTHR19241:SF598', NULL, NULL, NULL, NULL, 'PLEIOTROPIC DRUG RESISTANCE PROTEIN 1-LIKE', 247074),
(372167, 'PTHR19241:SF554', NULL, NULL, NULL, NULL, 'ABC MULTIDRUG TRANSPORTER ATRA', 247074),
(372168, 'PTHR19241:SF631', NULL, NULL, NULL, NULL, 'PLEIOTROPIC DRUG RESISTANCE PROTEIN 3-LIKE ISOFORM X1', 247074),
(372169, 'PTHR19241:SF676', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 45', 247074),
(372170, 'PTHR19241:SF167', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 5-RELATED', 247074),
(372171, 'PTHR19241:SF633', NULL, NULL, NULL, NULL, 'DRUG RESISTANCE TRANSPORTER-LIKE ABC DOMAIN PROTEIN', 247074),
(372172, 'PTHR19241:SF677', NULL, NULL, NULL, NULL, 'PLEIOTROPIC DRUG RESISTANCE PROTEIN 2', 247074),
(372173, 'PTHR19241:SF678', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 15', 247074),
(372174, 'PTHR19241:SF636', NULL, NULL, NULL, NULL, 'DRUG RESISTANCE TRANSPORTER-LIKE ABC DOMAIN PROTEIN', 247074),
(372175, 'PTHR19241:SF517', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 38', 247074),
(372176, 'PTHR19241:SF638', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 34-RELATED', 247074),
(372177, 'PTHR19241:SF639', NULL, NULL, NULL, NULL, 'ABC MULTIDRUG TRANSPORTER (EUROFUNG)-RELATED', 247074),
(372178, 'PTHR19241', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE TRANSPORTER', 247074),
(372179, 'PTHR19241:SF280', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 32', 247074),
(372180, 'PTHR21584:SF1', NULL, NULL, NULL, NULL, 'PROLINE/SERINE-RICH COILED-COIL PROTEIN 1', 247075),
(372181, 'PTHR21584:SF10', NULL, NULL, NULL, NULL, 'G2 AND S PHASE-EXPRESSED PROTEIN 1', 247075),
(372182, 'PTHR21584:SF9', NULL, NULL, NULL, NULL, 'GTSE1_N DOMAIN-CONTAINING PROTEIN', 247075),
(372183, 'PTHR21584', NULL, NULL, NULL, NULL, 'DIFFERENTIAL DISPLAY AND ACTIVATED BY P53  DDA3 /G2 S PHASE EXPRESSED 1', 247075),
(372184, 'PTHR34651:SF1', NULL, NULL, NULL, NULL, 'SIMILAR TO ENSANGP00000021391', 247076),
(372185, 'PTHR34651', NULL, NULL, NULL, NULL, 'SIMILAR TO ENSANGP00000021391', 247076),
(372186, 'PTHR10309:SF9', NULL, NULL, NULL, NULL, 'MANNOSE-6-PHOSPHATE ISOMERASE 1', 247077),
(372187, 'PTHR10309:SF8', NULL, NULL, NULL, NULL, 'MANNOSE-6-PHOSPHATE ISOMERASE', 247077),
(372188, 'PTHR10309:SF7', NULL, NULL, NULL, NULL, 'MANNOSE-6-PHOSPHATE ISOMERASE', 247077),
(372189, 'PTHR10309:SF6', NULL, NULL, NULL, NULL, 'MANNOSE-6-PHOSPHATE ISOMERASE', 247077),
(372190, 'PTHR10309', NULL, NULL, NULL, NULL, 'MANNOSE-6-PHOSPHATE ISOMERASE', 247077),
(372191, 'PTHR10309:SF12', NULL, NULL, NULL, NULL, 'MANNOSE-6-PHOSPHATE ISOMERASE', 247077),
(372192, 'PTHR10309:SF11', NULL, NULL, NULL, NULL, 'MANNOSE-6-PHOSPHATE ISOMERASE', 247077),
(372193, 'PTHR10309:SF10', NULL, NULL, NULL, NULL, 'MANNOSE-6-PHOSPHATE ISOMERASE', 247077),
(372194, 'PTHR10309:SF0', NULL, NULL, NULL, NULL, 'MANNOSE-6-PHOSPHATE ISOMERASE', 247077),
(372195, 'PTHR10309:SF4', NULL, NULL, NULL, NULL, 'MANNOSE-6-PHOSPHATE ISOMERASE', 247077),
(372196, 'PTHR10309:SF2', NULL, NULL, NULL, NULL, 'MANNOSE-6-PHOSPHATE ISOMERASE', 247077);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(372197, 'PTHR43500', NULL, NULL, NULL, NULL, 'CYSTATHIONINE BETA-LYASE-RELATED', 247078),
(372198, 'PTHR43500:SF1', NULL, NULL, NULL, NULL, 'CYSTATHIONINE BETA-LYASE-RELATED', 247078),
(372199, 'PTHR39200', NULL, NULL, NULL, NULL, 'HYPOTHETICAL EXPORTED PROTEIN', 247079),
(372200, 'PTHR39200:SF1', NULL, NULL, NULL, NULL, 'DUF2807 DOMAIN-CONTAINING PROTEIN', 247079),
(372201, 'PTHR43020:SF2', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL TRNA METHYLTHIOTRANSFERASE CDK5RAP1', 247080),
(372202, 'PTHR43020', NULL, NULL, NULL, NULL, 'CDK5 REGULATORY SUBUNIT-ASSOCIATED PROTEIN 1', 247080),
(372203, 'PTHR19423:SF1', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-BINDING PROTEIN 5', 247081),
(372204, 'PTHR19423:SF2', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE EXCHANGE FACTOR REI-1', 247081),
(372205, 'PTHR19423:SF4', NULL, NULL, NULL, NULL, 'SH3-DOMAIN-BINDING PROTEIN 5A (BTK-ASSOCIATED)', 247081),
(372206, 'PTHR19423:SF11', NULL, NULL, NULL, NULL, 'SH3-DOMAIN-BINDING PROTEIN 5B (BTK-ASSOCIATED)', 247081),
(372207, 'PTHR19423:SF8', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-BINDING PROTEIN 5-LIKE', 247081),
(372208, 'PTHR19423:SF12', NULL, NULL, NULL, NULL, 'LD13933P1', 247081),
(372209, 'PTHR19423', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-BINDING PROTEIN 5', 247081),
(372210, 'PTHR13313:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE POLYPEPTIDE VIIC', 247082),
(372211, 'PTHR13313:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 7C, MITOCHONDRIAL', 247082),
(372212, 'PTHR13313:SF0', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 7C, MITOCHONDRIAL', 247082),
(372213, 'PTHR13313', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT VIIC', 247082),
(372214, 'PTHR46962:SF1', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE KIST', 247083),
(372215, 'PTHR46962', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE KIST', 247083),
(372216, 'PTHR30485:SF0', NULL, NULL, NULL, NULL, 'NI/FE-HYDROGENASE 1 B-TYPE CYTOCHROME SUBUNIT-RELATED', 247084),
(372217, 'PTHR30485:SF2', NULL, NULL, NULL, NULL, 'BLL0597 PROTEIN', 247084),
(372218, 'PTHR30485:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME YDHU-RELATED', 247084),
(372219, 'PTHR30485:SF3', NULL, NULL, NULL, NULL, 'CYTOCHROME B561', 247084),
(372220, 'PTHR30485', NULL, NULL, NULL, NULL, 'NI/FE-HYDROGENASE 1 B-TYPE CYTOCHROME SUBUNIT', 247084),
(372221, 'PTHR43146:SF2', NULL, NULL, NULL, NULL, 'NUCLEOSIDE-TRIPHOSPHATASE THEP1', 247085),
(372222, 'PTHR43146:SF1', NULL, NULL, NULL, NULL, 'CANCER-RELATED NUCLEOSIDE-TRIPHOSPHATASE', 247085),
(372223, 'PTHR43146', NULL, NULL, NULL, NULL, 'CANCER-RELATED NUCLEOSIDE-TRIPHOSPHATASE', 247085),
(372224, 'PTHR47793:SF1', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE COMPLEX SUBUNIT CTI6', 247086),
(372225, 'PTHR47793', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE COMPLEX SUBUNIT CTI6', 247086),
(372226, 'PTHR44375:SF19', NULL, NULL, NULL, NULL, 'GLUCOSE/RIBITOL DEHYDROGENASE-RELATED', 247087),
(372227, 'PTHR44375:SF17', NULL, NULL, NULL, NULL, '2,4-DIENOYL-COA REDUCTASE', 247087),
(372228, 'PTHR44375:SF18', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', 247087),
(372229, 'PTHR44375', NULL, NULL, NULL, NULL, 'BETA-KETOACYL-ACP REDUCTASE-LIKE PROTEIN-RELATED', 247087),
(372230, 'PTHR44375:SF22', NULL, NULL, NULL, NULL, '11-BETA-HYDROXYSTEROID DEHYDROGENASE-LIKE 4A', 247087),
(372231, 'PTHR44375:SF11', NULL, NULL, NULL, NULL, 'GLUCOSE/RIBITOL DEHYDROGENASE-RELATED', 247087),
(372232, 'PTHR44375:SF9', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', 247087),
(372233, 'PTHR44375:SF23', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD PROTEIN', 247087),
(372234, 'PTHR44375:SF12', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', 247087),
(372235, 'PTHR44375:SF8', NULL, NULL, NULL, NULL, '', 247087),
(372236, 'PTHR44375:SF20', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', 247087),
(372237, 'PTHR44375:SF21', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', 247087),
(372238, 'PTHR44375:SF10', NULL, NULL, NULL, NULL, '2-(R)-HYDROXYPROPYL-COM DEHYDROGENASE-LIKE', 247087);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(372239, 'PTHR44375:SF6', NULL, NULL, NULL, NULL, 'F28J7.36 PROTEIN', 247087),
(372240, 'PTHR44375:SF5', NULL, NULL, NULL, NULL, 'ESTRADIOL 17-BETA-DEHYDROGENASE 8-LIKE', 247087),
(372241, 'PTHR44375:SF15', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN-RELATED', 247087),
(372242, 'PTHR44375:SF16', NULL, NULL, NULL, NULL, '2,4-DIENOYL-COA REDUCTASE', 247087),
(372243, 'PTHR44375:SF4', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN-RELATED', 247087),
(372244, 'PTHR44375:SF13', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE FABG-LIKE', 247087),
(372245, 'PTHR44375:SF14', NULL, NULL, NULL, NULL, '2,4-DIENOYL-COA REDUCTASE', 247087),
(372246, 'PTHR44375:SF2', NULL, NULL, NULL, NULL, 'BETA-KETOACYL-ACP REDUCTASE-LIKE PROTEIN-RELATED', 247087),
(372247, 'PTHR28127:SF1', NULL, NULL, NULL, NULL, 'RIBOSOME ASSEMBLY PROTEIN 3', 247088),
(372248, 'PTHR28127', NULL, NULL, NULL, NULL, 'RIBOSOME ASSEMBLY PROTEIN 3', 247088),
(372249, 'PTHR46730:SF1', NULL, NULL, NULL, NULL, 'REJ DOMAIN-CONTAINING PROTEIN', 247089),
(372250, 'PTHR46730:SF2', NULL, NULL, NULL, NULL, 'POLYCYSTIC KIDNEY DISEASE 1B', 247089),
(372251, 'PTHR46730:SF3', NULL, NULL, NULL, NULL, 'POLYCYSTIN-1', 247089),
(372252, 'PTHR46730', NULL, NULL, NULL, NULL, 'POLYCYSTIN-1', 247089),
(372253, 'PTHR34985:SF1', NULL, NULL, NULL, NULL, 'SLR0554 PROTEIN', 247090),
(372254, 'PTHR34985', NULL, NULL, NULL, NULL, 'SLR0554 PROTEIN', 247090),
(372255, 'PTHR26452:SF754', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5H6', 247091),
(372256, 'PTHR26452:SF117', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 490', 247091),
(372257, 'PTHR26452:SF239', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372258, 'PTHR26452:SF119', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5C1', 247091),
(372259, 'PTHR26452:SF4', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372260, 'PTHR26452:SF2', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372261, 'PTHR26452:SF196', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1440', 247091),
(372262, 'PTHR26452:SF198', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR-RELATED', 247091),
(372263, 'PTHR26452:SF111', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372264, 'PTHR26452:SF354', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5A1', 247091),
(372265, 'PTHR26452:SF236', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372266, 'PTHR26452:SF115', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372267, 'PTHR26452:SF75', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 481', 247091),
(372268, 'PTHR26452:SF105', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372269, 'PTHR26452:SF227', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR-RELATED', 247091),
(372270, 'PTHR26452:SF228', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372271, 'PTHR26452:SF747', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5H1', 247091),
(372272, 'PTHR26452:SF748', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372273, 'PTHR26452:SF186', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5AU1', 247091),
(372274, 'PTHR26452:SF220', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372275, 'PTHR26452:SF187', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372276, 'PTHR26452:SF189', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 491', 247091),
(372277, 'PTHR26452:SF222', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 6B2-RELATED', 247091),
(372278, 'PTHR26452:SF223', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372279, 'PTHR26452:SF740', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372280, 'PTHR26452:SF345', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372281, 'PTHR26452:SF191', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 495-RELATED', 247091),
(372282, 'PTHR26452:SF192', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 299', 247091),
(372283, 'PTHR26452:SF193', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372284, 'PTHR26452:SF85', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372285, 'PTHR26452:SF83', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(372286, 'PTHR26452:SF217', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372287, 'PTHR26452:SF734', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372288, 'PTHR26452:SF219', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372289, 'PTHR26452:SF692', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372290, 'PTHR26452:SF175', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372291, 'PTHR26452:SF176', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5A2', 247091),
(372292, 'PTHR26452:SF695', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5W2', 247091),
(372293, 'PTHR26452:SF212', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR-RELATED', 247091),
(372294, 'PTHR26452:SF179', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 478', 247091),
(372295, 'PTHR26452:SF334', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372296, 'PTHR26452:SF213', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372297, 'PTHR26452:SF58', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372298, 'PTHR26452:SF55', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372299, 'PTHR26452:SF180', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 14C36', 247091),
(372300, 'PTHR26452:SF51', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 14A2', 247091),
(372301, 'PTHR26452:SF52', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372302, 'PTHR26452:SF204', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372303, 'PTHR26452:SF842', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372304, 'PTHR26452:SF843', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372305, 'PTHR26452:SF206', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372306, 'PTHR26452:SF727', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372307, 'PTHR26452:SF284', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 183', 247091),
(372308, 'PTHR26452:SF285', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1009', 247091),
(372309, 'PTHR26452:SF165', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10W1', 247091),
(372310, 'PTHR26452:SF840', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372311, 'PTHR26452:SF841', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5P3', 247091),
(372312, 'PTHR26452', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372313, 'PTHR26452:SF65', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372314, 'PTHR26452:SF292', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5G3', 247091),
(372315, 'PTHR26452:SF729', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372316, 'PTHR26452:SF831', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372317, 'PTHR26452:SF799', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372318, 'PTHR26452:SF315', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5AR1', 247091),
(372319, 'PTHR26452:SF833', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372320, 'PTHR26452:SF834', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372321, 'PTHR26452:SF713', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR-RELATED', 247091),
(372322, 'PTHR26452:SF318', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 9K2', 247091),
(372323, 'PTHR26452:SF836', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5H2', 247091),
(372324, 'PTHR26452:SF837', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372325, 'PTHR26452:SF838', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372326, 'PTHR26452:SF394', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372327, 'PTHR26452:SF396', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 494', 247091),
(372328, 'PTHR26452:SF39', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372329, 'PTHR26452:SF430', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR-LIKE PROTEIN OLF2', 247091),
(372330, 'PTHR26452:SF310', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372331, 'PTHR26452:SF38', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5K2', 247091),
(372332, 'PTHR26452:SF795', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5K4', 247091),
(372333, 'PTHR26452:SF159', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 293-RELATED', 247091);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(372334, 'PTHR26452:SF830', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1086', 247091),
(372335, 'PTHR26452:SF36', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 492-RELATED', 247091),
(372336, 'PTHR26452:SF160', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372337, 'PTHR26452:SF282', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR-RELATED', 247091),
(372338, 'PTHR26452:SF839', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372339, 'PTHR26452:SF718', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372340, 'PTHR26452:SF719', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372341, 'PTHR26452:SF820', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 247091),
(372342, 'PTHR26452:SF789', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372343, 'PTHR26452:SF701', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 11L1', 247091),
(372344, 'PTHR26452:SF823', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR-RELATED', 247091),
(372345, 'PTHR26452:SF704', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5AS1', 247091),
(372346, 'PTHR26452:SF825', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 14I1', 247091),
(372347, 'PTHR26452:SF826', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372348, 'PTHR26452:SF827', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372349, 'PTHR26452:SF262', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5AN1', 247091),
(372350, 'PTHR26452:SF383', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372351, 'PTHR26452:SF142', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1358', 247091),
(372352, 'PTHR26452:SF263', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10V1', 247091),
(372353, 'PTHR26452:SF385', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 483', 247091),
(372354, 'PTHR26452:SF264', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372355, 'PTHR26452:SF143', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1002-RELATED', 247091),
(372356, 'PTHR26452:SF144', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372357, 'PTHR26452:SF48', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 482-RELATED', 247091),
(372358, 'PTHR26452:SF783', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372359, 'PTHR26452:SF388', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 14K1', 247091),
(372360, 'PTHR26452:SF147', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372361, 'PTHR26452:SF785', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372362, 'PTHR26452:SF423', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 510', 247091),
(372363, 'PTHR26452:SF42', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 14J1', 247091),
(372364, 'PTHR26452:SF270', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372365, 'PTHR26452:SF707', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372366, 'PTHR26452:SF828', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372367, 'PTHR26452:SF829', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5K1', 247091),
(372368, 'PTHR26452:SF413', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372369, 'PTHR26452:SF810', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372370, 'PTHR26452:SF778', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372371, 'PTHR26452:SF415', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372372, 'PTHR26452:SF812', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372373, 'PTHR26452:SF417', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 507', 247091),
(372374, 'PTHR26452:SF418', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5J2', 247091),
(372375, 'PTHR26452:SF814', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372376, 'PTHR26452:SF816', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372377, 'PTHR26452:SF19', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372378, 'PTHR26452:SF131', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 310', 247091),
(372379, 'PTHR26452:SF770', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372380, 'PTHR26452:SF253', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10Q1', 247091),
(372381, 'PTHR26452:SF254', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(372382, 'PTHR26452:SF771', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372383, 'PTHR26452:SF773', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 476-RELATED', 247091),
(372384, 'PTHR26452:SF256', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 247091),
(372385, 'PTHR26452:SF135', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5H15', 247091),
(372386, 'PTHR26452:SF16', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1141', 247091),
(372387, 'PTHR26452:SF257', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372388, 'PTHR26452:SF136', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 469-RELATED', 247091),
(372389, 'PTHR26452:SF775', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5H8', 247091),
(372390, 'PTHR26452:SF99', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372391, 'PTHR26452:SF96', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5H14', 247091),
(372392, 'PTHR26452:SF140', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372393, 'PTHR26452:SF91', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372394, 'PTHR26452:SF817', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372395, 'PTHR26452:SF818', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5AC2', 247091),
(372396, 'PTHR26452:SF819', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372397, 'PTHR26452:SF90', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5P2', 247091),
(372398, 'PTHR26452:SF248', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 12', 247091),
(372399, 'PTHR26452:SF403', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372400, 'PTHR26452:SF129', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372401, 'PTHR26452:SF768', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372402, 'PTHR26452:SF801', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372403, 'PTHR26452:SF769', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5F1', 247091),
(372404, 'PTHR26452:SF802', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372405, 'PTHR26452:SF803', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372406, 'PTHR26452:SF407', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5AC1', 247091),
(372407, 'PTHR26452:SF804', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 186', 247091),
(372408, 'PTHR26452:SF805', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372409, 'PTHR26452:SF409', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372410, 'PTHR26452:SF361', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372411, 'PTHR26452:SF28', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372412, 'PTHR26452:SF29', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372413, 'PTHR26452:SF246', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372414, 'PTHR26452:SF367', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372415, 'PTHR26452:SF125', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 13A1', 247091),
(372416, 'PTHR26452:SF247', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5K3', 247091),
(372417, 'PTHR26452:SF22', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372418, 'PTHR26452:SF806', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 14A16-RELATED', 247091),
(372419, 'PTHR26452:SF807', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372420, 'PTHR26452:SF809', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247091),
(372421, 'PTHR22654:SF2', NULL, NULL, NULL, NULL, 'G PROTEIN PATHWAY SUPPRESSOR 2', 247092),
(372422, 'PTHR22654', NULL, NULL, NULL, NULL, 'G PROTEIN PATHWAY SUPPRESSOR 2', 247092),
(372423, 'PTHR14611:SF5', NULL, NULL, NULL, NULL, 'DUF1619 DOMAIN-CONTAINING PROTEIN', 247093),
(372424, 'PTHR14611', NULL, NULL, NULL, NULL, 'TECTONIC FAMILY MEMBER', 247093),
(372425, 'PTHR14611:SF4', NULL, NULL, NULL, NULL, 'TECTONIC-3', 247093),
(372426, 'PTHR14611:SF2', NULL, NULL, NULL, NULL, 'TECTONIC-2', 247093),
(372427, 'PTHR14611:SF1', NULL, NULL, NULL, NULL, 'TECTONIC-1', 247093),
(372428, 'PTHR28638:SF2', NULL, NULL, NULL, NULL, 'CELL CYCLE PROGRESSION PROTEIN 1', 247094),
(372429, 'PTHR28638:SF3', NULL, NULL, NULL, NULL, 'PRE-B-CELL LEUKEMIA HOMEOBOX-INTERACTING PROTEIN 1B', 247094);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(372430, 'PTHR28638:SF1', NULL, NULL, NULL, NULL, 'PRE-B-CELL LEUKEMIA TRANSCRIPTION FACTOR-INTERACTING PROTEIN 1', 247094),
(372431, 'PTHR28638', NULL, NULL, NULL, NULL, 'CELL CYCLE PROGRESSION PROTEIN 1', 247094),
(372432, 'PTHR36884:SF5', NULL, NULL, NULL, NULL, 'FIP1 DOMAIN-CONTAINING PROTEIN', 247095),
(372433, 'PTHR36884:SF4', NULL, NULL, NULL, NULL, 'FIP1[III]-LIKE PROTEIN', 247095),
(372434, 'PTHR36884:SF6', NULL, NULL, NULL, NULL, 'FIP1[III]-LIKE PROTEIN', 247095),
(372435, 'PTHR36884', NULL, NULL, NULL, NULL, 'FIP1[III]-LIKE PROTEIN', 247095),
(372436, 'PTHR36884:SF1', NULL, NULL, NULL, NULL, 'FIP1[V]-LIKE PROTEIN', 247095),
(372437, 'PTHR34436', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN M', 247096),
(372438, 'PTHR34436:SF1', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN M', 247096),
(372439, 'PTHR11993:SF10', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] IRON-SULFUR PROTEIN 2, MITOCHONDRIAL', 247097),
(372440, 'PTHR11993:SF46', NULL, NULL, NULL, NULL, 'COMPLEX1_49KDA DOMAIN-CONTAINING PROTEIN', 247097),
(372441, 'PTHR11993', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE 49 KDA SUBUNIT', 247097),
(372442, 'PTHR11993:SF47', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE SUBUNIT H', 247097),
(372443, 'PTHR11993:SF44', NULL, NULL, NULL, NULL, 'COMPLEX I-49KD', 247097),
(372444, 'PTHR11993:SF45', NULL, NULL, NULL, NULL, 'NADH-QUINONE OXIDOREDUCTASE SUBUNIT C/D', 247097),
(372445, 'PTHR48160', NULL, NULL, NULL, NULL, '', 247098),
(372446, 'PTHR48160:SF1', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L37A', 247098),
(372447, 'PTHR38139', NULL, NULL, NULL, NULL, 'GATE DOMAIN-CONTAINING PROTEIN', 247099),
(372448, 'PTHR38139:SF1', NULL, NULL, NULL, NULL, 'GATE DOMAIN-CONTAINING PROTEIN', 247099),
(372449, 'PTHR12601:SF6', NULL, NULL, NULL, NULL, 'CLUSTERED MITOCHONDRIA PROTEIN HOMOLOG', 247100),
(372450, 'PTHR12601:SF8', NULL, NULL, NULL, NULL, 'CLU DOMAIN-CONTAINING PROTEIN', 247100),
(372451, 'PTHR12601:SF20', NULL, NULL, NULL, NULL, '', 247100),
(372452, 'PTHR12601:SF41', NULL, NULL, NULL, NULL, 'SI:CH211-166A6.5', 247100),
(372453, 'PTHR12601:SF11', NULL, NULL, NULL, NULL, 'CLU DOMAIN-CONTAINING PROTEIN', 247100),
(372454, 'PTHR12601:SF22', NULL, NULL, NULL, NULL, '', 247100),
(372455, 'PTHR12601:SF21', NULL, NULL, NULL, NULL, 'CLU DOMAIN-CONTAINING PROTEIN', 247100),
(372456, 'PTHR12601', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT  EIF-3', 247100),
(372457, 'PTHR12601:SF10', NULL, NULL, NULL, NULL, 'CLUSTERED MITOCHONDRIA (CLUA/CLU1) HOMOLOG B-RELATED', 247100),
(372458, 'PTHR12601:SF46', NULL, NULL, NULL, NULL, 'BNAA08G13880D PROTEIN', 247100),
(372459, 'PTHR12601:SF24', NULL, NULL, NULL, NULL, 'CLU DOMAIN-CONTAINING PROTEIN', 247100),
(372460, 'PTHR12601:SF13', NULL, NULL, NULL, NULL, '', 247100),
(372461, 'PTHR12601:SF45', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 247100),
(372462, 'PTHR12601:SF15', NULL, NULL, NULL, NULL, '', 247100),
(372463, 'PTHR12601:SF39', NULL, NULL, NULL, NULL, 'PROTEIN TSS', 247100),
(372464, 'PTHR12601:SF17', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 247100),
(372465, 'PTHR12601:SF49', NULL, NULL, NULL, NULL, 'CLU DOMAIN-CONTAINING PROTEIN', 247100),
(372466, 'PTHR12601:SF16', NULL, NULL, NULL, NULL, '', 247100),
(372467, 'PTHR12601:SF27', NULL, NULL, NULL, NULL, 'CLU DOMAIN-CONTAINING PROTEIN', 247100),
(372468, 'PTHR12601:SF19', NULL, NULL, NULL, NULL, 'CLU DOMAIN-CONTAINING PROTEIN', 247100),
(372469, 'PTHR43445', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLMURAMATE--L-ALANINE LIGASE-RELATED', 247101),
(372470, 'PTHR43445:SF1', NULL, NULL, NULL, NULL, 'PGA SYNTHASE CAPB', 247101),
(372471, 'PTHR43445:SF3', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLMURAMATE--L-ALANINE LIGASE', 247101),
(372472, 'PTHR43445:SF5', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLMURAMATE--L-ALANYL-GAMMA-D-GLUTAMYL-MESO-2,6-DIAMINOHEPTANDIOATE LIGASE', 247101),
(372473, 'PTHR16247:SF0', NULL, NULL, NULL, NULL, 'RIKEN CDNA 9430015G10 GENE', 247102),
(372474, 'PTHR16247', NULL, NULL, NULL, NULL, 'RIKEN CDNA 9430015G10 GENE', 247102);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(372475, 'PTHR35494:SF3', NULL, NULL, NULL, NULL, 'BNAA01G13510D PROTEIN', 247103),
(372476, 'PTHR35494:SF4', NULL, NULL, NULL, NULL, 'PLANT/T32A16-60 PROTEIN', 247103),
(372477, 'PTHR35494', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT S, CHLOROPLASTIC', 247103),
(372478, 'PTHR35494:SF1', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT S, CHLOROPLASTIC', 247103),
(372479, 'PTHR31501:SF3', NULL, NULL, NULL, NULL, 'CALCIUM RELEASE-ACTIVATED CALCIUM CHANNEL PROTEIN 1', 247104),
(372480, 'PTHR31501:SF6', NULL, NULL, NULL, NULL, 'PROTEIN ORAI-3', 247104),
(372481, 'PTHR31501:SF5', NULL, NULL, NULL, NULL, 'PROTEIN ORAI-2', 247104),
(372482, 'PTHR31501', NULL, NULL, NULL, NULL, 'CALCIUM RELEASE-ACTIVATED CALCIUM CHANNEL PROTEIN 1', 247104),
(372483, 'PTHR31501:SF7', NULL, NULL, NULL, NULL, 'CALCIUM RELEASE-ACTIVATED CALCIUM CHANNEL PROTEIN 1', 247104),
(372484, 'PTHR24041:SF26', NULL, NULL, NULL, NULL, 'DEATH DOMAIN-CONTAINING PROTEIN', 247105),
(372485, 'PTHR24041', NULL, NULL, NULL, NULL, 'MUCIN', 247105),
(372486, 'PTHR24041:SF33', NULL, NULL, NULL, NULL, 'MUCIN-12', 247105),
(372487, 'PTHR24041:SF22', NULL, NULL, NULL, NULL, 'MUCIN-3A-RELATED', 247105),
(372488, 'PTHR24041:SF30', NULL, NULL, NULL, NULL, 'SI:CH211-196F2.3', 247105),
(372489, 'PTHR24041:SF32', NULL, NULL, NULL, NULL, '', 247105),
(372490, 'PTHR32344:SF1', NULL, NULL, NULL, NULL, 'U1-TYPE DOMAIN-CONTAINING PROTEIN', 247106),
(372491, 'PTHR32344', NULL, NULL, NULL, NULL, 'U1-TYPE DOMAIN-CONTAINING PROTEIN', 247106),
(372492, 'PTHR34683:SF8', NULL, NULL, NULL, NULL, '', 247107),
(372493, 'PTHR34683:SF5', NULL, NULL, NULL, NULL, 'BNAA08G13800D PROTEIN', 247107),
(372494, 'PTHR34683:SF3', NULL, NULL, NULL, NULL, 'BNAUNNG00100D PROTEIN', 247107),
(372495, 'PTHR34683', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', 247107),
(372496, 'PTHR34683:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247107),
(372497, 'PTHR34148:SF1', NULL, NULL, NULL, NULL, 'ADENOSYLCOBINAMIDE-GDP RIBAZOLETRANSFERASE', 247108),
(372498, 'PTHR34148', NULL, NULL, NULL, NULL, 'ADENOSYLCOBINAMIDE-GDP RIBAZOLETRANSFERASE', 247108),
(372499, 'PTHR39180:SF2', NULL, NULL, NULL, NULL, '', 247109),
(372500, 'PTHR39180', NULL, NULL, NULL, NULL, '', 247109),
(372501, 'PTHR45779', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 247110),
(372502, 'PTHR45779:SF2', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP11', 247110),
(372503, 'PTHR45779:SF14', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 247110),
(372504, 'PTHR45779:SF3', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP2', 247110),
(372505, 'PTHR45779:SF15', NULL, NULL, NULL, NULL, 'FK506-BINDING PROTEIN 3', 247110),
(372506, 'PTHR45779:SF6', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP15-1', 247110),
(372507, 'PTHR45779:SF5', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 247110),
(372508, 'PTHR45779:SF10', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP15-2', 247110),
(372509, 'PTHR45779:SF11', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 247110),
(372510, 'PTHR45779:SF7', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 247110),
(372511, 'PTHR47025', NULL, NULL, NULL, NULL, 'AUTOIMMUNE REGULATOR', 247111),
(372512, 'PTHR47025:SF17', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASE WITH RING/FYVE/PHD-TYPE ZINC FINGER DOMAIN', 247111),
(372513, 'PTHR47025:SF23', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE CHROMATIN REGULATOR PHD FAMILY-RELATED', 247111),
(372514, 'PTHR47025:SF9', NULL, NULL, NULL, NULL, 'TDBD DOMAIN-CONTAINING PROTEIN', 247111),
(372515, 'PTHR47025:SF24', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', 247111),
(372516, 'PTHR47025:SF25', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASE WITH RING/FYVE/PHD-TYPE ZINC FINGER DOMAIN', 247111),
(372517, 'PTHR47025:SF7', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASE WITH RING/FYVE/PHD-TYPE ZINC FINGER DOMAIN-CONTAINING PROTEIN', 247111),
(372518, 'PTHR47025:SF15', NULL, NULL, NULL, NULL, 'INCREASED DNA METHYLATION 1', 247111);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(372519, 'PTHR47025:SF26', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', 247111),
(372520, 'PTHR47025:SF6', NULL, NULL, NULL, NULL, 'N-LYSINE METHYLTRANSFERASE', 247111),
(372521, 'PTHR47025:SF10', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN', 247111),
(372522, 'PTHR47025:SF21', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASE WITH RING/FYVE/PHD-TYPE ZINC FINGER PROTEIN', 247111),
(372523, 'PTHR47025:SF22', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASE WITH RING/FYVE/PHD-TYPE ZINC FINGER DOMAIN-CONTAINING PROTEIN', 247111),
(372524, 'PTHR47025:SF11', NULL, NULL, NULL, NULL, 'OS06G0101000 PROTEIN', 247111),
(372525, 'PTHR47025:SF2', NULL, NULL, NULL, NULL, 'AUTOIMMUNE REGULATOR', 247111),
(372526, 'PTHR33474:SF3', NULL, NULL, NULL, NULL, 'OS01G0276900 PROTEIN', 247112),
(372527, 'PTHR33474:SF28', NULL, NULL, NULL, NULL, 'OS01G0264400 PROTEIN', 247112),
(372528, 'PTHR33474:SF2', NULL, NULL, NULL, NULL, 'OS07G0631300 PROTEIN', 247112),
(372529, 'PTHR33474:SF18', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 247112),
(372530, 'PTHR33474:SF1', NULL, NULL, NULL, NULL, 'OS09G0412700 PROTEIN', 247112),
(372531, 'PTHR33474:SF30', NULL, NULL, NULL, NULL, '', 247112),
(372532, 'PTHR33474:SF31', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 247112),
(372533, 'PTHR33474', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 247112),
(372534, 'PTHR33474:SF33', NULL, NULL, NULL, NULL, '', 247112),
(372535, 'PTHR33474:SF22', NULL, NULL, NULL, NULL, '', 247112),
(372536, 'PTHR33474:SF34', NULL, NULL, NULL, NULL, '', 247112),
(372537, 'PTHR33474:SF35', NULL, NULL, NULL, NULL, '', 247112),
(372538, 'PTHR33474:SF36', NULL, NULL, NULL, NULL, 'OS12G0490050 PROTEIN', 247112),
(372539, 'PTHR33474:SF37', NULL, NULL, NULL, NULL, '', 247112),
(372540, 'PTHR33474:SF27', NULL, NULL, NULL, NULL, '', 247112),
(372541, 'PTHR33474:SF38', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 247112),
(372542, 'PTHR33474:SF16', NULL, NULL, NULL, NULL, 'OS11G0600600 PROTEIN', 247112),
(372543, 'PTHR11866:SF7', NULL, NULL, NULL, NULL, 'PROSTACYCLIN RECEPTOR', 247113),
(372544, 'PTHR11866:SF8', NULL, NULL, NULL, NULL, 'PROSTAGLANDIN E2 RECEPTOR EP2 SUBTYPE', 247113),
(372545, 'PTHR11866:SF5', NULL, NULL, NULL, NULL, 'THROMBOXANE A2 RECEPTOR', 247113),
(372546, 'PTHR11866:SF6', NULL, NULL, NULL, NULL, 'PROSTAGLANDIN E2 RECEPTOR EP4 SUBTYPE', 247113),
(372547, 'PTHR11866:SF3', NULL, NULL, NULL, NULL, 'PROSTAGLANDIN E2 RECEPTOR EP1 SUBTYPE', 247113),
(372548, 'PTHR11866:SF4', NULL, NULL, NULL, NULL, 'PROSTAGLANDIN F2-ALPHA RECEPTOR', 247113),
(372549, 'PTHR11866:SF16', NULL, NULL, NULL, NULL, 'PROSTAGLANDIN E2 RECEPTOR EP4 SUBTYPE-LIKE PROTEIN', 247113),
(372550, 'PTHR11866:SF38', NULL, NULL, NULL, NULL, 'PROSTAGLANDIN E2 RECEPTOR EP4 SUBTYPE', 247113),
(372551, 'PTHR11866', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR FAMILY 1 MEMBER', 247113),
(372552, 'PTHR11866:SF34', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 247113),
(372553, 'PTHR11866:SF14', NULL, NULL, NULL, NULL, 'PROSTAGLANDIN D2 RECEPTOR', 247113),
(372554, 'PTHR11866:SF41', NULL, NULL, NULL, NULL, 'PROSTAGLANDIN E2 RECEPTOR EP3 SUBTYPE', 247113),
(372555, 'PTHR11866:SF31', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 247113),
(372556, 'PTHR11866:SF42', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 247113),
(372557, 'PTHR11866:SF10', NULL, NULL, NULL, NULL, 'PROSTAGLANDIN E2 RECEPTOR EP3 SUBTYPE', 247113),
(372558, 'PTHR11866:SF32', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 247113),
(372559, 'PTHR11866:SF33', NULL, NULL, NULL, NULL, 'PROSTANOID TP RECEPTOR', 247113),
(372560, 'PTHR12465:SF1', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 20', 247114),
(372561, 'PTHR12465:SF4', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 20', 247114),
(372562, 'PTHR12465', NULL, NULL, NULL, NULL, 'UBIQUITIN SPECIFIC PROTEASE HOMOLOG 49', 247114),
(372563, 'PTHR12465:SF0', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 20', 247114);
INSERT INTO "PUBLIC"."MODEL" VALUES
(372564, 'PTHR12595:SF20', NULL, NULL, NULL, NULL, 'ADENYLATE KINASE ISOENZYME 6 HOMOLOG', 247115),
(372565, 'PTHR12595:SF0', NULL, NULL, NULL, NULL, 'ADENYLATE KINASE ISOENZYME 6', 247115),
(372566, 'PTHR12595:SF19', NULL, NULL, NULL, NULL, 'ADENYLATE KINASE ISOENZYME 6', 247115),
(372567, 'PTHR12595:SF18', NULL, NULL, NULL, NULL, '', 247115),
(372568, 'PTHR12595', NULL, NULL, NULL, NULL, 'POS9-ACTIVATING FACTOR FAP7-RELATED', 247115),
(372569, 'PTHR12681:SF15', NULL, NULL, NULL, NULL, 'BNAA09G43820D PROTEIN', 247116),
(372570, 'PTHR12681:SF14', NULL, NULL, NULL, NULL, 'ZINC FINGER, CCCH-TYPE, ZC3H15/TMA46 FAMILY-RELATED', 247116),
(372571, 'PTHR12681:SF0', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 15', 247116),
(372572, 'PTHR12681:SF13', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C3H FAMILY-RELATED', 247116),
(372573, 'PTHR12681', NULL, NULL, NULL, NULL, 'ZINC FINGER-CONTAINING PROTEIN P48ZNF', 247116),
(372574, 'PTHR12681:SF12', NULL, NULL, NULL, NULL, 'BNAA09G10160D PROTEIN', 247116),
(372575, 'PTHR12507', NULL, NULL, NULL, NULL, 'REDUCED GROWTH PHENOTYPE 1  RGP1, YEAST -RELATED', 247117),
(372576, 'PTHR12507:SF4', NULL, NULL, NULL, NULL, 'BNAANNG31920D PROTEIN', 247117),
(372577, 'PTHR12507:SF5', NULL, NULL, NULL, NULL, '', 247117),
(372578, 'PTHR12507:SF3', NULL, NULL, NULL, NULL, 'RAB6A-GEF COMPLEX PARTNER PROTEIN 2', 247117),
(372579, 'PTHR22749', NULL, NULL, NULL, NULL, 'RIBOFLAVIN KINASE/FMN ADENYLYLTRANSFERASE', 247118),
(372580, 'PTHR22749:SF8', NULL, NULL, NULL, NULL, 'RIBOFLAVIN KINASE', 247118),
(372581, 'PTHR22749:SF14', NULL, NULL, NULL, NULL, '', 247118),
(372582, 'PTHR22749:SF6', NULL, NULL, NULL, NULL, 'RIBOFLAVIN KINASE', 247118),
(372583, 'PTHR22749:SF13', NULL, NULL, NULL, NULL, 'RIBOFLAVIN KINASE', 247118),
(372584, 'PTHR22749:SF12', NULL, NULL, NULL, NULL, 'RIBOFLAVIN KINASE', 247118),
(372585, 'PTHR23183', NULL, NULL, NULL, NULL, 'NOP14', 247119),
(372586, 'PTHR23183:SF0', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 14', 247119),
(372587, 'PTHR15929', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247120),
(372588, 'PTHR15929:SF0', NULL, NULL, NULL, NULL, 'STORE-OPERATED CALCIUM ENTRY-ASSOCIATED REGULATORY FACTOR', 247120),
(372589, 'PTHR43360', NULL, NULL, NULL, NULL, 'CARBON DIOXIDE CONCENTRATING MECHANISM PROTEIN CCMM', 247121),
(372590, 'PTHR43360:SF1', NULL, NULL, NULL, NULL, 'CARBOXYSOME ASSEMBLY PROTEIN CCMM', 247121),
(372591, 'PTHR15315:SF105', NULL, NULL, NULL, NULL, 'OS01G0905700 PROTEIN', 247122),
(372592, 'PTHR15315:SF106', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 41,-LIKE', 247122),
(372593, 'PTHR15315:SF102', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 247122),
(372594, 'PTHR15315:SF74', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE NRDP1', 247122),
(372595, 'PTHR15315:SF31', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE AIRP2', 247122),
(372596, 'PTHR15315:SF75', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 247122),
(372597, 'PTHR15315:SF91', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 247122),
(372598, 'PTHR15315:SF107', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C2H2 FAMILY-RELATED', 247122),
(372599, 'PTHR15315:SF108', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C2H2 FAMILY-RELATED', 247122),
(372600, 'PTHR15315:SF71', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 247122),
(372601, 'PTHR15315:SF109', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 247122),
(372602, 'PTHR15315', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 41, 151', 247122),
(372603, 'PTHR15315:SF99', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 247122),
(372604, 'PTHR15315:SF79', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF8-LIKE', 247122),
(372605, 'PTHR15315:SF35', NULL, NULL, NULL, NULL, 'F21J9.10', 247122),
(372606, 'PTHR15315:SF36', NULL, NULL, NULL, NULL, 'OS10G0445400 PROTEIN', 247122),
(372607, 'PTHR15315:SF90', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 247122),
(372608, 'PTHR15315:SF110', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 247122);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(372609, 'PTHR15315:SF111', NULL, NULL, NULL, NULL, 'OS10G0500300 PROTEIN', 247122),
(372610, 'PTHR15315:SF84', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 247122),
(372611, 'PTHR15315:SF64', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 151', 247122),
(372612, 'PTHR15315:SF86', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 247122),
(372613, 'PTHR15315:SF87', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 247122),
(372614, 'PTHR15315:SF26', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 247122),
(372615, 'PTHR15315:SF88', NULL, NULL, NULL, NULL, 'OS07G0661600 PROTEIN', 247122),
(372616, 'PTHR15315:SF22', NULL, NULL, NULL, NULL, 'OS07G0275300 PROTEIN', 247122),
(372617, 'PTHR15315:SF89', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 247122),
(372618, 'PTHR15315:SF68', NULL, NULL, NULL, NULL, 'ZINC FINGER, C3HC4 TYPE (RING FINGER) PROTEIN', 247122),
(372619, 'PTHR35662:SF1', NULL, NULL, NULL, NULL, 'INTERACTOR OF HORMAD1 PROTEIN 1', 247123),
(372620, 'PTHR35662', NULL, NULL, NULL, NULL, 'INTERACTOR OF HORMAD1 PROTEIN 1', 247123),
(372621, 'PTHR43079:SF3', NULL, NULL, NULL, NULL, 'BNAA09G42040D PROTEIN', 247124),
(372622, 'PTHR43079:SF1', NULL, NULL, NULL, NULL, 'CADMIUM/ZINC-TRANSPORTING ATPASE HMA1, CHLOROPLASTIC-RELATED', 247124),
(372623, 'PTHR43079', NULL, NULL, NULL, NULL, 'PROBABLE CADMIUM/ZINC-TRANSPORTING ATPASE HMA1', 247124),
(372624, 'PTHR15715:SF26', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 136', 247125),
(372625, 'PTHR15715:SF48', NULL, NULL, NULL, NULL, 'FHA DOMAIN-CONTAINING PROTEIN', 247125),
(372626, 'PTHR15715:SF37', NULL, NULL, NULL, NULL, 'LD47843P', 247125),
(372627, 'PTHR15715:SF18', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 170 KDA PROTEIN B', 247125),
(372628, 'PTHR15715:SF17', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 170 KDA', 247125),
(372629, 'PTHR15715', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 170 KDA', 247125),
(372630, 'PTHR15715:SF21', NULL, NULL, NULL, NULL, 'TRAF3-INTERACTING JNK-ACTIVATING MODULATOR', 247125),
(372631, 'PTHR15715:SF22', NULL, NULL, NULL, NULL, 'SARCOLEMMAL MEMBRANE-ASSOCIATED PROTEIN', 247125),
(372632, 'PTHR15715:SF47', NULL, NULL, NULL, NULL, 'FHA DOMAINCONTAINING PROTEIN', 247125),
(372633, 'PTHR15715:SF46', NULL, NULL, NULL, NULL, 'TO VACUOLE TARGETING VPS64, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G02420)-RELATED', 247125),
(372634, 'PTHR43094', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE', 247126),
(372635, 'PTHR43094:SF2', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE, CLASS III (AFU_ORTHOLOGUE AFUA_1G16810)', 247126),
(372636, 'PTHR43094:SF1', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE CLASS-III', 247126),
(372637, 'PTHR16510:SF4', NULL, NULL, NULL, NULL, 'MATRIX EXTRACELLULAR PHOSPHOGLYCOPROTEIN', 247127),
(372638, 'PTHR16510', NULL, NULL, NULL, NULL, 'EXTRACELLULAR MATRIX PHOSPHOGLYCOPROTEIN WITH ASARM MOTIF', 247127),
(372639, 'PTHR46489:SF1', NULL, NULL, NULL, NULL, 'STEROIDOGENIC ACUTE REGULATORY PROTEIN, MITOCHONDRIAL', 247128),
(372640, 'PTHR46489:SF3', NULL, NULL, NULL, NULL, 'STEROIDOGENIC ACUTE REGULATORY PROTEIN, MITOCHONDRIAL', 247128),
(372641, 'PTHR46489:SF2', NULL, NULL, NULL, NULL, 'START DOMAIN-CONTAINING PROTEIN 1', 247128),
(372642, 'PTHR46489', NULL, NULL, NULL, NULL, 'STEROIDOGENIC ACUTE REGULATORY PROTEIN, MITOCHONDRIAL', 247128),
(372643, 'PTHR45642:SF129', NULL, NULL, NULL, NULL, 'OS06G0636700 PROTEIN', 247129),
(372644, 'PTHR45642:SF33', NULL, NULL, NULL, NULL, '', 247129),
(372645, 'PTHR45642:SF77', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 247129),
(372646, 'PTHR45642:SF34', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 247129),
(372647, 'PTHR45642:SF78', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE', 247129),
(372648, 'PTHR45642:SF79', NULL, NULL, NULL, NULL, 'BNAANNG14670D PROTEIN', 247129),
(372649, 'PTHR45642:SF35', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE APG', 247129),
(372650, 'PTHR45642:SF36', NULL, NULL, NULL, NULL, 'BNAA02G33660D PROTEIN', 247129),
(372651, 'PTHR45642:SF38', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE EXL3-LIKE', 247129);
INSERT INTO "PUBLIC"."MODEL" VALUES
(372652, 'PTHR45642:SF71', NULL, NULL, NULL, NULL, '', 247129),
(372653, 'PTHR45642:SF73', NULL, NULL, NULL, NULL, '', 247129),
(372654, 'PTHR45642:SF30', NULL, NULL, NULL, NULL, 'LIPASE/ACYLHYDROLASE FAMILY PROTEIN, PUTATIVE-RELATED', 247129),
(372655, 'PTHR45642:SF75', NULL, NULL, NULL, NULL, 'OS09G0540400 PROTEIN', 247129),
(372656, 'PTHR45642:SF32', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 247129),
(372657, 'PTHR45642:SF120', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 247129),
(372658, 'PTHR45642:SF125', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 247129),
(372659, 'PTHR45642:SF128', NULL, NULL, NULL, NULL, 'OS06G0351500 PROTEIN', 247129),
(372660, 'PTHR45642:SF44', NULL, NULL, NULL, NULL, 'CF-2.2', 247129),
(372661, 'PTHR45642:SF88', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE FAMILY PROTEIN-RELATED', 247129),
(372662, 'PTHR45642:SF45', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 247129),
(372663, 'PTHR45642:SF89', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE FAMILY PROTEIN', 247129),
(372664, 'PTHR45642:SF46', NULL, NULL, NULL, NULL, 'OS09G0132200 PROTEIN', 247129),
(372665, 'PTHR45642:SF47', NULL, NULL, NULL, NULL, '', 247129),
(372666, 'PTHR45642:SF48', NULL, NULL, NULL, NULL, 'OS02G0189300 PROTEIN', 247129),
(372667, 'PTHR45642:SF49', NULL, NULL, NULL, NULL, 'ANTHER-SPECIFIC PROLINE-RICH PROTEIN APG', 247129),
(372668, 'PTHR45642:SF80', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE FAMILY PROTEIN, EXPRESSED', 247129),
(372669, 'PTHR45642:SF81', NULL, NULL, NULL, NULL, 'BNAC03G17570D PROTEIN', 247129),
(372670, 'PTHR45642:SF82', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE SUPERFAMILY PROTEIN-RELATED', 247129),
(372671, 'PTHR45642:SF83', NULL, NULL, NULL, NULL, 'BNAA09G15550D PROTEIN', 247129),
(372672, 'PTHR45642:SF84', NULL, NULL, NULL, NULL, 'BNAC03G75690D PROTEIN', 247129),
(372673, 'PTHR45642', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE EXL3', 247129),
(372674, 'PTHR45642:SF40', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 247129),
(372675, 'PTHR45642:SF85', NULL, NULL, NULL, NULL, 'BNAA09G14610D PROTEIN', 247129),
(372676, 'PTHR45642:SF86', NULL, NULL, NULL, NULL, 'BNAC05G04810D PROTEIN', 247129),
(372677, 'PTHR45642:SF42', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE EXL3-LIKE ISOFORM X1', 247129),
(372678, 'PTHR45642:SF87', NULL, NULL, NULL, NULL, 'BNAANNG30030D PROTEIN', 247129),
(372679, 'PTHR45642:SF130', NULL, NULL, NULL, NULL, '', 247129),
(372680, 'PTHR45642:SF131', NULL, NULL, NULL, NULL, 'BNAANNG20620D PROTEIN', 247129),
(372681, 'PTHR45642:SF90', NULL, NULL, NULL, NULL, 'SGNH HYDROLASE-TYPE ESTERASE DOMAIN-CONTAINING PROTEIN-RELATED', 247129),
(372682, 'PTHR45642:SF132', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 247129),
(372683, 'PTHR45642:SF133', NULL, NULL, NULL, NULL, 'BNAA04G18220D PROTEIN', 247129),
(372684, 'PTHR45642:SF134', NULL, NULL, NULL, NULL, 'BNAC02G29810D PROTEIN', 247129),
(372685, 'PTHR45642:SF135', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE EXL2', 247129),
(372686, 'PTHR45642:SF136', NULL, NULL, NULL, NULL, '', 247129),
(372687, 'PTHR45642:SF137', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 247129),
(372688, 'PTHR45642:SF138', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE EXL1-LIKE', 247129),
(372689, 'PTHR45642:SF139', NULL, NULL, NULL, NULL, 'ESTERASE ESTA', 247129),
(372690, 'PTHR45642:SF107', NULL, NULL, NULL, NULL, 'SGNH HYDROLASE-TYPE ESTERASE SUPERFAMILY PROTEIN-RELATED', 247129),
(372691, 'PTHR45642:SF99', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE EXL6', 247129),
(372692, 'PTHR45642:SF55', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE EXL4-RELATED', 247129),
(372693, 'PTHR45642:SF108', NULL, NULL, NULL, NULL, 'BNAC05G04820D PROTEIN', 247129),
(372694, 'PTHR45642:SF56', NULL, NULL, NULL, NULL, '', 247129),
(372695, 'PTHR45642:SF12', NULL, NULL, NULL, NULL, 'OS02G0189200 PROTEIN', 247129),
(372696, 'PTHR45642:SF109', NULL, NULL, NULL, NULL, 'OS09G0132900 PROTEIN', 247129),
(372697, 'PTHR45642:SF58', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE EXL3-LIKE ISOFORM X1', 247129);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(372698, 'PTHR45642:SF59', NULL, NULL, NULL, NULL, '', 247129),
(372699, 'PTHR45642:SF16', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE APG', 247129),
(372700, 'PTHR45642:SF17', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE FAMILY PROTEIN, EXPRESSED', 247129),
(372701, 'PTHR45642:SF18', NULL, NULL, NULL, NULL, 'OS01G0832100 PROTEIN', 247129),
(372702, 'PTHR45642:SF3', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 247129),
(372703, 'PTHR45642:SF92', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE', 247129),
(372704, 'PTHR45642:SF93', NULL, NULL, NULL, NULL, 'SGNH HYDROLASE-TYPE ESTERASE DOMAIN-CONTAINING PROTEIN-RELATED', 247129),
(372705, 'PTHR45642:SF95', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE EXL3', 247129),
(372706, 'PTHR45642:SF51', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 247129),
(372707, 'PTHR45642:SF7', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE', 247129),
(372708, 'PTHR45642:SF52', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 247129),
(372709, 'PTHR45642:SF96', NULL, NULL, NULL, NULL, 'FINGER PROTEIN, PUTATIVE-RELATED', 247129),
(372710, 'PTHR45642:SF97', NULL, NULL, NULL, NULL, 'BNAC04G13080D PROTEIN', 247129),
(372711, 'PTHR45642:SF53', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE SUPERFAMILY PROTEIN', 247129),
(372712, 'PTHR45642:SF54', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 247129),
(372713, 'PTHR45642:SF140', NULL, NULL, NULL, NULL, '', 247129),
(372714, 'PTHR45642:SF141', NULL, NULL, NULL, NULL, 'SECRETED EFFECTOR PROTEIN SSEJ', 247129),
(372715, 'PTHR45642:SF142', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE', 247129),
(372716, 'PTHR45642:SF143', NULL, NULL, NULL, NULL, 'SGNH HYDROLASE-TYPE ESTERASE DOMAIN-CONTAINING PROTEIN-RELATED', 247129),
(372717, 'PTHR45642:SF19', NULL, NULL, NULL, NULL, 'OS02G0110000 PROTEIN', 247129),
(372718, 'PTHR45642:SF100', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 247129),
(372719, 'PTHR45642:SF144', NULL, NULL, NULL, NULL, 'BNAANNG34060D PROTEIN', 247129),
(372720, 'PTHR45642:SF101', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE SUPERFAMILY PROTEIN-RELATED', 247129),
(372721, 'PTHR45642:SF145', NULL, NULL, NULL, NULL, 'OS05G0468500 PROTEIN', 247129),
(372722, 'PTHR45642:SF102', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE', 247129),
(372723, 'PTHR45642:SF103', NULL, NULL, NULL, NULL, 'FINGER PROTEIN, PUTATIVE-RELATED', 247129),
(372724, 'PTHR45642:SF106', NULL, NULL, NULL, NULL, 'BNAA01G29160D PROTEIN', 247129),
(372725, 'PTHR45642:SF67', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE FAMILY PROTEIN, EXPRESSED', 247129),
(372726, 'PTHR45642:SF24', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 247129),
(372727, 'PTHR45642:SF68', NULL, NULL, NULL, NULL, '', 247129),
(372728, 'PTHR45642:SF69', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE EXL1', 247129),
(372729, 'PTHR45642:SF26', NULL, NULL, NULL, NULL, 'OS09G0247600 PROTEIN', 247129),
(372730, 'PTHR45642:SF60', NULL, NULL, NULL, NULL, '', 247129),
(372731, 'PTHR45642:SF62', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE', 247129),
(372732, 'PTHR45642:SF63', NULL, NULL, NULL, NULL, '', 247129),
(372733, 'PTHR45642:SF65', NULL, NULL, NULL, NULL, 'BNAA02G25900D PROTEIN', 247129),
(372734, 'PTHR45642:SF110', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE EXL3', 247129),
(372735, 'PTHR45642:SF111', NULL, NULL, NULL, NULL, 'BNAA09G15560D PROTEIN', 247129),
(372736, 'PTHR45642:SF113', NULL, NULL, NULL, NULL, 'BNAA07G09940D PROTEIN', 247129),
(372737, 'PTHR45642:SF114', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 247129),
(372738, 'PTHR45642:SF116', NULL, NULL, NULL, NULL, 'BNAA03G01070D PROTEIN', 247129),
(372739, 'PTHR15239:SF6', NULL, NULL, NULL, NULL, 'NUCLEAR EXPORT MEDIATOR FACTOR NEMF', 247130),
(372740, 'PTHR15239', NULL, NULL, NULL, NULL, 'NUCLEAR EXPORT MEDIATOR FACTOR NEMF', 247130),
(372741, 'PTHR47653:SF1', NULL, NULL, NULL, NULL, 'PROTEIN BARK BEETLE', 247131),
(372742, 'PTHR47653', NULL, NULL, NULL, NULL, 'PROTEIN BARK BEETLE', 247131),
(372743, 'PTHR38036:SF1', NULL, NULL, NULL, NULL, 'UPF0250 PROTEIN YBED', 247132);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(372744, 'PTHR38036', NULL, NULL, NULL, NULL, 'UPF0250 PROTEIN YBED', 247132),
(372745, 'PTHR23045:SF9', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING 37A-RELATED', 247133),
(372746, 'PTHR23045:SF19', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 37A-RELATED', 247133),
(372747, 'PTHR23045', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 37A', 247133),
(372748, 'PTHR23045:SF20', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 37A-LIKE', 247133),
(372749, 'PTHR23045:SF11', NULL, NULL, NULL, NULL, 'LRRC37AB_C DOMAIN-CONTAINING PROTEIN', 247133),
(372750, 'PTHR11161:SF65', NULL, NULL, NULL, NULL, 'NOSE RESISTANT TO FLUOXETINE PROTEIN 6', 247134),
(372751, 'PTHR11161', NULL, NULL, NULL, NULL, 'O-ACYLTRANSFERASE', 247134),
(372752, 'PTHR11161:SF22', NULL, NULL, NULL, NULL, 'ACYL_TRANSF_3 DOMAIN-CONTAINING PROTEIN-RELATED', 247134),
(372753, 'PTHR11161:SF55', NULL, NULL, NULL, NULL, 'NRF DOMAIN-CONTAINING PROTEIN', 247134),
(372754, 'PTHR11161:SF33', NULL, NULL, NULL, NULL, 'NRF DOMAIN-CONTAINING PROTEIN', 247134),
(372755, 'PTHR11161:SF70', NULL, NULL, NULL, NULL, 'ACYL_TRANSF_3 DOMAIN-CONTAINING PROTEIN', 247134),
(372756, 'PTHR11161:SF7', NULL, NULL, NULL, NULL, 'NRF DOMAIN-CONTAINING PROTEIN', 247134),
(372757, 'PTHR11161:SF71', NULL, NULL, NULL, NULL, 'NRF DOMAIN-CONTAINING PROTEIN', 247134),
(372758, 'PTHR11161:SF60', NULL, NULL, NULL, NULL, 'NRF DOMAIN-CONTAINING PROTEIN', 247134),
(372759, 'PTHR11161:SF8', NULL, NULL, NULL, NULL, 'NRF DOMAIN-CONTAINING PROTEIN', 247134),
(372760, 'PTHR11161:SF61', NULL, NULL, NULL, NULL, 'NRF DOMAIN-CONTAINING PROTEIN', 247134),
(372761, 'PTHR11161:SF4', NULL, NULL, NULL, NULL, 'DROP DEAD', 247134),
(372762, 'PTHR11161:SF0', NULL, NULL, NULL, NULL, 'O-ACYLTRANSFERASE LIKE PROTEIN', 247134),
(372763, 'PTHR11161:SF16', NULL, NULL, NULL, NULL, 'NRF DOMAIN-CONTAINING PROTEIN', 247134),
(372764, 'PTHR11161:SF12', NULL, NULL, NULL, NULL, 'ACYL_TRANSF_3 DOMAIN-CONTAINING PROTEIN-RELATED', 247134),
(372765, 'PTHR11161:SF67', NULL, NULL, NULL, NULL, 'NRF DOMAIN-CONTAINING PROTEIN', 247134),
(372766, 'PTHR11161:SF68', NULL, NULL, NULL, NULL, 'NRF DOMAIN-CONTAINING PROTEIN', 247134),
(372767, 'PTHR11161:SF69', NULL, NULL, NULL, NULL, 'NOSE RESISTANT TO FLUOXETINE PROTEIN 6-LIKE PROTEIN', 247134),
(372768, 'PTHR11161:SF14', NULL, NULL, NULL, NULL, 'NRF DOMAIN-CONTAINING PROTEIN', 247134),
(372769, 'PTHR11161:SF59', NULL, NULL, NULL, NULL, 'FI22618P1-RELATED', 247134),
(372770, 'PTHR11161:SF15', NULL, NULL, NULL, NULL, 'GH19286P-RELATED', 247134),
(372771, 'PTHR33451', NULL, NULL, NULL, NULL, 'MALATE-2H(+)/NA(+)-LACTATE ANTIPORTER', 247135),
(372772, 'PTHR33451:SF4', NULL, NULL, NULL, NULL, 'NA+/H+ ANTIPORTER-RELATED', 247135),
(372773, 'PTHR33451:SF3', NULL, NULL, NULL, NULL, 'MALATE-2H(+)/NA(+)-LACTATE ANTIPORTER', 247135),
(372774, 'PTHR33451:SF6', NULL, NULL, NULL, NULL, 'NA(+)/H(+) ANTIPORTER NHAC', 247135),
(372775, 'PTHR33451:SF5', NULL, NULL, NULL, NULL, 'NA+/H+ ANTIPORTER-RELATED', 247135),
(372776, 'PTHR24018:SF5', NULL, NULL, NULL, NULL, 'ELASTIN', 247136),
(372777, 'PTHR24018', NULL, NULL, NULL, NULL, 'ELASTIN', 247136),
(372778, 'PTHR12736', NULL, NULL, NULL, NULL, 'LANC-LIKE PROTEIN', 247137),
(372779, 'PTHR12736:SF25', NULL, NULL, NULL, NULL, 'LANC-LIKE PROTEIN GCL1', 247137),
(372780, 'PTHR12736:SF5', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE LANCL1', 247137),
(372781, 'PTHR12736:SF21', NULL, NULL, NULL, NULL, 'LANC-LIKE PROTEIN 3 HOMOLOG', 247137),
(372782, 'PTHR12736:SF7', NULL, NULL, NULL, NULL, 'LANC-LIKE PROTEIN 3', 247137),
(372783, 'PTHR12736:SF23', NULL, NULL, NULL, NULL, 'LANC-LIKE PROTEIN GCR2', 247137),
(372784, 'PTHR12736:SF22', NULL, NULL, NULL, NULL, 'LANC-LIKE PROTEIN GCL2', 247137),
(372785, 'PTHR12736:SF11', NULL, NULL, NULL, NULL, 'LANC-LIKE PROTEIN 2', 247137),
(372786, 'PTHR32322:SF2', NULL, NULL, NULL, NULL, 'EAMA DOMAIN-CONTAINING PROTEIN', 247138),
(372787, 'PTHR32322:SF14', NULL, NULL, NULL, NULL, 'PROTEIN PAGO', 247138),
(372788, 'PTHR32322:SF18', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE/S-ADENOSYLHOMOCYSTEINE TRANSPORTER', 247138);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(372789, 'PTHR32322:SF9', NULL, NULL, NULL, NULL, 'AMINO-ACID METABOLITE EFFLUX PUMP-RELATED', 247138),
(372790, 'PTHR32322', NULL, NULL, NULL, NULL, 'INNER MEMBRANE TRANSPORTER', 247138),
(372791, 'PTHR16296', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED HYPOTHALAMUS PROTEIN HT007', 247139),
(372792, 'PTHR16296:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 126A', 247139),
(372793, 'PTHR16296:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 126A', 247139),
(372794, 'PTHR16296:SF3', NULL, NULL, NULL, NULL, 'COMPLEX I ASSEMBLY FACTOR TMEM126B, MITOCHONDRIAL', 247139),
(372795, 'PTHR31147:SF29', NULL, NULL, NULL, NULL, 'BNAC03G77600D PROTEIN', 247140),
(372796, 'PTHR31147:SF26', NULL, NULL, NULL, NULL, 'OS06G0699100 PROTEIN', 247140),
(372797, 'PTHR31147:SF48', NULL, NULL, NULL, NULL, 'SPERMIDINE COUMAROYL-COA ACYLTRANSFERASE', 247140),
(372798, 'PTHR31147:SF25', NULL, NULL, NULL, NULL, 'HXXXD-TYPE ACYL-TRANSFERASE FAMILY PROTEIN', 247140),
(372799, 'PTHR31147:SF46', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 247140),
(372800, 'PTHR31147:SF44', NULL, NULL, NULL, NULL, '', 247140),
(372801, 'PTHR31147:SF1', NULL, NULL, NULL, NULL, 'ACYL TRANSFERASE 4', 247140),
(372802, 'PTHR31147:SF64', NULL, NULL, NULL, NULL, 'OS05G0315700 PROTEIN', 247140),
(372803, 'PTHR31147:SF63', NULL, NULL, NULL, NULL, 'HXXXD-TYPE ACYL-TRANSFERASE FAMILY PROTEIN', 247140),
(372804, 'PTHR31147:SF2', NULL, NULL, NULL, NULL, 'OS01G0615300 PROTEIN', 247140),
(372805, 'PTHR31147:SF41', NULL, NULL, NULL, NULL, 'OS01G0179000 PROTEIN', 247140),
(372806, 'PTHR31147:SF3', NULL, NULL, NULL, NULL, 'ACYL TRANSFERASE 7', 247140),
(372807, 'PTHR31147:SF62', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 247140),
(372808, 'PTHR31147:SF61', NULL, NULL, NULL, NULL, 'ACYL TRANSFERASE 15', 247140),
(372809, 'PTHR31147', NULL, NULL, NULL, NULL, 'ACYL TRANSFERASE 4', 247140),
(372810, 'PTHR31147:SF8', NULL, NULL, NULL, NULL, 'OS04G0194466 PROTEIN', 247140),
(372811, 'PTHR31147:SF36', NULL, NULL, NULL, NULL, 'OS01G0615200 PROTEIN', 247140),
(372812, 'PTHR31147:SF35', NULL, NULL, NULL, NULL, 'BNAA08G07970D PROTEIN', 247140),
(372813, 'PTHR31147:SF57', NULL, NULL, NULL, NULL, 'BNAC07G42100D PROTEIN', 247140),
(372814, 'PTHR31147:SF12', NULL, NULL, NULL, NULL, 'ACYL TRANSFERASE 8', 247140),
(372815, 'PTHR31147:SF34', NULL, NULL, NULL, NULL, 'ACYL TRANSFERASE 9', 247140),
(372816, 'PTHR31147:SF56', NULL, NULL, NULL, NULL, '', 247140),
(372817, 'PTHR31147:SF33', NULL, NULL, NULL, NULL, 'N-HYDROXYCINNAMOYL/BENZOYLTRANSFERASE, PUTATIVE-RELATED', 247140),
(372818, 'PTHR31147:SF55', NULL, NULL, NULL, NULL, 'HXXXD-TYPE ACYL-TRANSFERASE FAMILY PROTEIN', 247140),
(372819, 'PTHR31147:SF11', NULL, NULL, NULL, NULL, 'ACYL TRANSFERASE 10', 247140),
(372820, 'PTHR31147:SF54', NULL, NULL, NULL, NULL, 'OS10G0105900 PROTEIN', 247140),
(372821, 'PTHR31147:SF31', NULL, NULL, NULL, NULL, 'ACYL TRANSFERASE 5', 247140),
(372822, 'PTHR31147:SF53', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 247140),
(372823, 'PTHR31147:SF30', NULL, NULL, NULL, NULL, '10-DEACETYLBACCATIN III 10-O-ACETYLTRANSFERASE', 247140),
(372824, 'PTHR31147:SF52', NULL, NULL, NULL, NULL, 'SPERMIDINE SINAPOYL-COA ACYLTRANSFERASE', 247140),
(372825, 'PTHR31147:SF51', NULL, NULL, NULL, NULL, 'PF02458-FAMILY ACYL TRANSFERASE 2-RELATED', 247140),
(372826, 'PTHR31147:SF50', NULL, NULL, NULL, NULL, 'BNAA08G13330D PROTEIN', 247140),
(372827, 'PTHR47913', NULL, NULL, NULL, NULL, 'OS01G0167750 PROTEIN', 247141),
(372828, 'PTHR47913:SF1', NULL, NULL, NULL, NULL, 'OS01G0167750 PROTEIN', 247141),
(372829, 'PTHR46250:SF3', NULL, NULL, NULL, NULL, 'OS04G0590366 PROTEIN', 247142),
(372830, 'PTHR46250:SF1', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 247142),
(372831, 'PTHR46250', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DNA-BINDING DOMAIN PROTEIN-RELATED', 247142),
(372832, 'PTHR46250:SF12', NULL, NULL, NULL, NULL, '', 247142),
(372833, 'PTHR46250:SF11', NULL, NULL, NULL, NULL, 'RNASE H FAMILY PROTEIN', 247142),
(372834, 'PTHR46250:SF14', NULL, NULL, NULL, NULL, 'RNASE H FAMILY PROTEIN', 247142);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(372835, 'PTHR46250:SF4', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 247142),
(372836, 'PTHR46250:SF13', NULL, NULL, NULL, NULL, 'RNASE H FAMILY PROTEIN', 247142),
(372837, 'PTHR46250:SF10', NULL, NULL, NULL, NULL, '', 247142),
(372838, 'PTHR46250:SF9', NULL, NULL, NULL, NULL, 'RNASE H FAMILY PROTEIN', 247142),
(372839, 'PTHR15528', NULL, NULL, NULL, NULL, 'PEROXISOME PROLIFERATOR ACTIVATED RECEPTOR GAMMA COACTIVATOR 1  PGC-1 -RELATED', 247143),
(372840, 'PTHR15528:SF10', NULL, NULL, NULL, NULL, 'PEROXISOME PROLIFERATOR-ACTIVATED RECEPTOR GAMMA COACTIVATOR 1-ALPHA', 247143),
(372841, 'PTHR15528:SF5', NULL, NULL, NULL, NULL, 'PEROXISOME PROLIFERATOR-ACTIVATED RECEPTOR GAMMA COACTIVATOR-RELATED PROTEIN 1', 247143),
(372842, 'PTHR15528:SF12', NULL, NULL, NULL, NULL, 'PEROXISOME PROLIFERATOR-ACTIVATED RECEPTOR GAMMA COACTIVATOR 1-BETA', 247143),
(372843, 'PTHR15528:SF11', NULL, NULL, NULL, NULL, 'FI18188P1', 247143),
(372844, 'PTHR14540:SF2', NULL, NULL, NULL, NULL, 'SIMILAR TO PROTEIN C7ORF26 HOMOLOG', 247144),
(372845, 'PTHR14540', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247144),
(372846, 'PTHR43496', NULL, NULL, NULL, NULL, 'PROTEIN LPLB', 247145),
(372847, 'PTHR43496:SF1', NULL, NULL, NULL, NULL, 'PROTEIN LPLB', 247145),
(372848, 'PTHR43381:SF20', NULL, NULL, NULL, NULL, 'OS09G0515500 PROTEIN', 247146),
(372849, 'PTHR43381:SF10', NULL, NULL, NULL, NULL, 'TR-TYPE G DOMAIN-CONTAINING PROTEIN', 247146),
(372850, 'PTHR43381:SF21', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR IF-2', 247146),
(372851, 'PTHR43381:SF12', NULL, NULL, NULL, NULL, '', 247146),
(372852, 'PTHR43381:SF14', NULL, NULL, NULL, NULL, 'C3H1-TYPE DOMAIN-CONTAINING PROTEIN', 247146),
(372853, 'PTHR43381:SF15', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 5B', 247146),
(372854, 'PTHR43381:SF16', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 5B', 247146),
(372855, 'PTHR43381:SF4', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 5B', 247146),
(372856, 'PTHR43381:SF17', NULL, NULL, NULL, NULL, 'IF-2 DOMAIN-CONTAINING PROTEIN', 247146),
(372857, 'PTHR43381:SF18', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 5B', 247146),
(372858, 'PTHR43381:SF5', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR IF-2, MITOCHONDRIAL', 247146),
(372859, 'PTHR43381', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR IF-2-RELATED', 247146),
(372860, 'PTHR43381:SF6', NULL, NULL, NULL, NULL, 'INITIATION FACTOR IF-2, PUTATIVE-RELATED', 247146),
(372861, 'PTHR24025:SF17', NULL, NULL, NULL, NULL, 'FAT ATYPICAL CADHERIN 4', 247147),
(372862, 'PTHR24025:SF28', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 247147),
(372863, 'PTHR24025:SF18', NULL, NULL, NULL, NULL, 'CADHERIN-23', 247147),
(372864, 'PTHR24025', NULL, NULL, NULL, NULL, 'DESMOGLEIN FAMILY MEMBER', 247147),
(372865, 'PTHR24025:SF25', NULL, NULL, NULL, NULL, 'FAT ATYPICAL CADHERIN 1', 247147),
(372866, 'PTHR24025:SF16', NULL, NULL, NULL, NULL, 'FAT ATYPICAL CADHERIN 2', 247147),
(372867, 'PTHR24025:SF27', NULL, NULL, NULL, NULL, 'SI:CH211-186J3.6-RELATED', 247147),
(372868, 'PTHR24025:SF20', NULL, NULL, NULL, NULL, 'DACHSOUS CADHERIN-RELATED 2', 247147),
(372869, 'PTHR24025:SF1', NULL, NULL, NULL, NULL, 'DESMOGLEIN-2', 247147),
(372870, 'PTHR24025:SF21', NULL, NULL, NULL, NULL, 'FAT ATYPICAL CADHERIN 3', 247147),
(372871, 'PTHR24025:SF10', NULL, NULL, NULL, NULL, 'DESMOGLEIN-4', 247147),
(372872, 'PTHR24025:SF0', NULL, NULL, NULL, NULL, 'DESMOCOLLIN-2', 247147),
(372873, 'PTHR24025:SF22', NULL, NULL, NULL, NULL, 'DACHSOUS CADHERIN-RELATED 1', 247147),
(372874, 'PTHR24025:SF12', NULL, NULL, NULL, NULL, 'DESMOCOLLIN-3', 247147),
(372875, 'PTHR24025:SF23', NULL, NULL, NULL, NULL, 'CADHERIN-4', 247147),
(372876, 'PTHR24025:SF3', NULL, NULL, NULL, NULL, 'DESMOGLEIN-3', 247147),
(372877, 'PTHR24025:SF9', NULL, NULL, NULL, NULL, 'DESMOGLEIN-1', 247147),
(372878, 'PTHR24025:SF8', NULL, NULL, NULL, NULL, 'DESMOCOLLIN-1', 247147),
(372879, 'PTHR38790:SF4', NULL, NULL, NULL, NULL, '', 247148);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(372880, 'PTHR38790:SF8', NULL, NULL, NULL, NULL, '', 247148),
(372881, 'PTHR38790:SF7', NULL, NULL, NULL, NULL, '', 247148),
(372882, 'PTHR38790', NULL, NULL, NULL, NULL, '', 247148),
(372883, 'PTHR31200:SF1', NULL, NULL, NULL, NULL, 'INO80 COMPLEX SUBUNIT C', 247149),
(372884, 'PTHR31200', NULL, NULL, NULL, NULL, 'INO80 COMPLEX SUBUNIT C', 247149),
(372885, 'PTHR12093:SF9', NULL, NULL, NULL, NULL, 'NCK-ASSOCIATED PROTEIN 1-LIKE', 247150),
(372886, 'PTHR12093', NULL, NULL, NULL, NULL, 'NCK-ASSOCIATED PROTEIN 1', 247150),
(372887, 'PTHR12093:SF10', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED PROTEIN HEM', 247150),
(372888, 'PTHR12093:SF11', NULL, NULL, NULL, NULL, 'NCK-ASSOCIATED PROTEIN 1', 247150),
(372889, 'PTHR21364:SF2', NULL, NULL, NULL, NULL, 'GENERAL ODORANT-BINDING PROTEIN 19A', 247151),
(372890, 'PTHR21364', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247151),
(372891, 'PTHR21364:SF1', NULL, NULL, NULL, NULL, 'GENERAL ODORANT-BINDING PROTEIN LUSH', 247151),
(372892, 'PTHR36699:SF1', NULL, NULL, NULL, NULL, 'L,D-TRANSPEPTIDASE YAFK-RELATED', 247152),
(372893, 'PTHR36699', NULL, NULL, NULL, NULL, 'LD-TRANSPEPTIDASE', 247152),
(372894, 'PTHR15283', NULL, NULL, NULL, NULL, 'GREMLIN 1', 247153),
(372895, 'PTHR15283:SF7', NULL, NULL, NULL, NULL, 'BURSICON', 247153),
(372896, 'PTHR15283:SF6', NULL, NULL, NULL, NULL, 'GREMLIN', 247153),
(372897, 'PTHR15283:SF3', NULL, NULL, NULL, NULL, 'GREMLIN-1', 247153),
(372898, 'PTHR15283:SF2', NULL, NULL, NULL, NULL, 'GREMLIN-2', 247153),
(372899, 'PTHR15283:SF5', NULL, NULL, NULL, NULL, 'NEUROBLASTOMA SUPPRESSOR OF TUMORIGENICITY 1', 247153),
(372900, 'PTHR15283:SF4', NULL, NULL, NULL, NULL, 'BURSICON', 247153),
(372901, 'PTHR23399:SF2', NULL, NULL, NULL, NULL, 'DEOXYNUCLEOTIDYLTRANSFERASE TERMINAL-INTERACTING PROTEIN 1', 247154),
(372902, 'PTHR23399', NULL, NULL, NULL, NULL, 'DEOXYNUCLEOTIDYLTRANSFERASE TERMINAL-INTERACTING PROTEIN 1', 247154),
(372903, 'PTHR39952:SF1', NULL, NULL, NULL, NULL, '', 247155),
(372904, 'PTHR39952', NULL, NULL, NULL, NULL, 'FI02073P', 247155),
(372905, 'PTHR32196:SF19', NULL, NULL, NULL, NULL, 'GALACTOFURANOSE TRANSPORTER PERMEASE PROTEIN YTFT', 247156),
(372906, 'PTHR32196:SF18', NULL, NULL, NULL, NULL, 'GALACTOSIDE TRANSPORT SYSTEM PERMEASE PROTEIN MGLC', 247156),
(372907, 'PTHR32196:SF29', NULL, NULL, NULL, NULL, 'AUTOINDUCER 2 IMPORT SYSTEM PERMEASE PROTEIN LSRC', 247156),
(372908, 'PTHR32196:SF15', NULL, NULL, NULL, NULL, 'SUGAR ABC TRANSPORTER PERMEASE PROTEIN', 247156),
(372909, 'PTHR32196:SF37', NULL, NULL, NULL, NULL, 'L-ARABINOSE TRANSPORT SYSTEM PERMEASE PROTEIN ARAH', 247156),
(372910, 'PTHR32196:SF69', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, PERMEASE PROTEIN-RELATED', 247156),
(372911, 'PTHR32196:SF32', NULL, NULL, NULL, NULL, 'XYLOSE TRANSPORT SYSTEM PERMEASE PROTEIN XYLH', 247156),
(372912, 'PTHR32196:SF21', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN YPHD-RELATED', 247156),
(372913, 'PTHR32196:SF63', NULL, NULL, NULL, NULL, 'INNER MEMBRANE ABC TRANSPORTER PERMEASE PROTEIN YJFF', 247156),
(372914, 'PTHR32196:SF71', NULL, NULL, NULL, NULL, 'MONOSACCHARIDE-TRANSPORTING ATPASE', 247156),
(372915, 'PTHR32196', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN YPHD-RELATED-RELATED', 247156),
(372916, 'PTHR32196:SF72', NULL, NULL, NULL, NULL, 'RIBOSE IMPORT PERMEASE PROTEIN RBSC', 247156),
(372917, 'PTHR32196:SF70', NULL, NULL, NULL, NULL, 'AUTOINDUCER 2 IMPORT SYSTEM PERMEASE PROTEIN LSRD', 247156),
(372918, 'PTHR11451:SF42', NULL, NULL, NULL, NULL, 'THREONYL-TRNA SYNTHETASE', 247157),
(372919, 'PTHR11451:SF53', NULL, NULL, NULL, NULL, 'THREONYL-TRNA SYNTHETASE', 247157),
(372920, 'PTHR11451:SF44', NULL, NULL, NULL, NULL, 'THREONINE--TRNA LIGASE, CHLOROPLASTIC/MITOCHONDRIAL 2', 247157),
(372921, 'PTHR11451:SF55', NULL, NULL, NULL, NULL, 'THREONYL-TRNA SYNTHETASE', 247157),
(372922, 'PTHR11451:SF54', NULL, NULL, NULL, NULL, 'THREONYL-TRNA SYNTHETASE', 247157),
(372923, 'PTHR11451:SF46', NULL, NULL, NULL, NULL, 'THREONYL-TRNA SYNTHETASE', 247157),
(372924, 'PTHR11451:SF56', NULL, NULL, NULL, NULL, 'THREONINE--TRNA LIGASE 1', 247157);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(372925, 'PTHR11451:SF36', NULL, NULL, NULL, NULL, 'THREONINE--TRNA LIGASE 1, CYTOPLASMIC', 247157),
(372926, 'PTHR11451:SF51', NULL, NULL, NULL, NULL, 'THREONYL-TRNA SYNTHETASE', 247157),
(372927, 'PTHR11451:SF50', NULL, NULL, NULL, NULL, 'THREONINE--TRNA LIGASE, MITOCHONDRIAL', 247157),
(372928, 'PTHR11451:SF27', NULL, NULL, NULL, NULL, 'THREONINE--TRNA LIGASE, MITOCHONDRIAL', 247157),
(372929, 'PTHR11451:SF38', NULL, NULL, NULL, NULL, 'THREONINE--TRNA LIGASE 2, CYTOPLASMIC', 247157),
(372930, 'PTHR11451:SF16', NULL, NULL, NULL, NULL, 'THREONINE--TRNA LIGASE 2, CYTOPLASMIC-RELATED', 247157),
(372931, 'PTHR11451', NULL, NULL, NULL, NULL, 'THREONINE-TRNA LIGASE', 247157),
(372932, 'PTHR12770:SF30', NULL, NULL, NULL, NULL, '', 247158),
(372933, 'PTHR12770:SF21', NULL, NULL, NULL, NULL, 'RUS FAMILY MEMBER 1', 247158),
(372934, 'PTHR12770:SF5', NULL, NULL, NULL, NULL, 'PROTEIN ROOT UVB SENSITIVE 2, CHLOROPLASTIC', 247158),
(372935, 'PTHR12770:SF20', NULL, NULL, NULL, NULL, 'PROTEIN ROOT UVB SENSITIVE 6', 247158),
(372936, 'PTHR12770:SF31', NULL, NULL, NULL, NULL, 'RUS FAMILY MEMBER 1', 247158),
(372937, 'PTHR12770:SF22', NULL, NULL, NULL, NULL, 'PROTEIN ROOT UVB SENSITIVE 1, CHLOROPLASTIC', 247158),
(372938, 'PTHR12770:SF27', NULL, NULL, NULL, NULL, 'PROTEIN ROOT UVB SENSITIVE 5', 247158),
(372939, 'PTHR12770:SF26', NULL, NULL, NULL, NULL, 'OS01G0886900 PROTEIN', 247158),
(372940, 'PTHR12770:SF29', NULL, NULL, NULL, NULL, 'PROTEIN ROOT UVB SENSITIVE 4', 247158),
(372941, 'PTHR12770', NULL, NULL, NULL, NULL, 'RUS1 FAMILY PROTEIN C16ORF58', 247158),
(372942, 'PTHR11686:SF65', NULL, NULL, NULL, NULL, 'BNAA06G40450D PROTEIN', 247159),
(372943, 'PTHR11686:SF54', NULL, NULL, NULL, NULL, 'GLUTATHIONE HYDROLASE 7', 247159),
(372944, 'PTHR11686:SF53', NULL, NULL, NULL, NULL, '', 247159),
(372945, 'PTHR11686:SF63', NULL, NULL, NULL, NULL, 'BNAA09G02940D PROTEIN', 247159),
(372946, 'PTHR11686:SF62', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYLTRANSPEPTIDASE (EUROFUNG)', 247159),
(372947, 'PTHR11686:SF61', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYLTRANSPEPTIDASE 1-RELATED', 247159),
(372948, 'PTHR11686:SF60', NULL, NULL, NULL, NULL, 'BNAA06G40460D PROTEIN', 247159),
(372949, 'PTHR11686:SF71', NULL, NULL, NULL, NULL, 'RE13973P', 247159),
(372950, 'PTHR11686:SF70', NULL, NULL, NULL, NULL, 'GLUTATHIONE HYDROLASE PROENZYME 1', 247159),
(372951, 'PTHR11686:SF19', NULL, NULL, NULL, NULL, 'GLUTATHIONE HYDROLASE 5 PROENZYME', 247159),
(372952, 'PTHR11686:SF17', NULL, NULL, NULL, NULL, 'PROTEIN CBG05566', 247159),
(372953, 'PTHR11686:SF59', NULL, NULL, NULL, NULL, 'BNAC07G41830D PROTEIN', 247159),
(372954, 'PTHR11686:SF69', NULL, NULL, NULL, NULL, 'PROTEIN CBG22061', 247159),
(372955, 'PTHR11686:SF58', NULL, NULL, NULL, NULL, 'BNAA01G07620D PROTEIN', 247159),
(372956, 'PTHR11686:SF46', NULL, NULL, NULL, NULL, 'PROTEIN CBG13651', 247159),
(372957, 'PTHR11686:SF9', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYL TRANSPEPTIDASE, ISOFORM A', 247159),
(372958, 'PTHR11686:SF56', NULL, NULL, NULL, NULL, 'GLUTATHIONE HYDROLASE 1 PROENZYME-RELATED', 247159),
(372959, 'PTHR11686:SF67', NULL, NULL, NULL, NULL, 'PROTEIN CBG19133', 247159),
(372960, 'PTHR11686:SF34', NULL, NULL, NULL, NULL, 'GLUTATHIONE HYDROLASE 1-RELATED', 247159),
(372961, 'PTHR11686', NULL, NULL, NULL, NULL, 'GAMMA GLUTAMYL TRANSPEPTIDASE', 247159),
(372962, 'PTHR21538:SF19', NULL, NULL, NULL, NULL, 'RHOTEKIN', 247160),
(372963, 'PTHR21538', NULL, NULL, NULL, NULL, 'ANILLIN/RHOTEKIN  RTKN', 247160),
(372964, 'PTHR21538:SF21', NULL, NULL, NULL, NULL, 'RHOTEKIN-2', 247160),
(372965, 'PTHR21538:SF23', NULL, NULL, NULL, NULL, 'ANILLIN', 247160),
(372966, 'PTHR21538:SF11', NULL, NULL, NULL, NULL, 'ANILLIN-LIKE PROTEIN 1', 247160),
(372967, 'PTHR21538:SF25', NULL, NULL, NULL, NULL, 'ANILLIN, ACTIN-BINDING PROTEIN', 247160),
(372968, 'PTHR21538:SF24', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 247160),
(372969, 'PTHR21538:SF26', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN-RELATED', 247160),
(372970, 'PTHR22804:SF40', NULL, NULL, NULL, NULL, 'HYALURONAN AND PROTEOGLYCAN LINK PROTEIN 3', 247161);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(372971, 'PTHR22804:SF11', NULL, NULL, NULL, NULL, 'HYALURONAN AND PROTEOGLYCAN LINK PROTEIN 4', 247161),
(372972, 'PTHR22804:SF54', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 247161),
(372973, 'PTHR22804', NULL, NULL, NULL, NULL, 'AGGRECAN/VERSICAN PROTEOGLYCAN', 247161),
(372974, 'PTHR22804:SF10', NULL, NULL, NULL, NULL, 'HYALURONAN AND PROTEOGLYCAN LINK PROTEIN 1', 247161),
(372975, 'PTHR22804:SF42', NULL, NULL, NULL, NULL, 'AGGRECAN CORE PROTEIN', 247161),
(372976, 'PTHR22804:SF41', NULL, NULL, NULL, NULL, 'BREVICAN CORE PROTEIN', 247161),
(372977, 'PTHR22804:SF8', NULL, NULL, NULL, NULL, 'HYALURONAN AND PROTEOGLYCAN LINK PROTEIN 2', 247161),
(372978, 'PTHR22804:SF59', NULL, NULL, NULL, NULL, 'UROMODULIN', 247161),
(372979, 'PTHR22804:SF47', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 247161),
(372980, 'PTHR22804:SF58', NULL, NULL, NULL, NULL, 'HYALURONAN AND PROTEOGLYCAN LINK PROTEIN 1A', 247161),
(372981, 'PTHR22804:SF57', NULL, NULL, NULL, NULL, 'NEUROGENIC LOCUS NOTCH HOMOLOG PROTEIN 2', 247161),
(372982, 'PTHR22804:SF24', NULL, NULL, NULL, NULL, 'NEUROCAN CORE PROTEIN', 247161),
(372983, 'PTHR22804:SF56', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 247161),
(372984, 'PTHR22804:SF6', NULL, NULL, NULL, NULL, 'VERSICAN CORE PROTEIN', 247161),
(372985, 'PTHR45989', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR EIF-2B SUBUNIT GAMMA', 247162),
(372986, 'PTHR45989:SF1', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR EIF-2B SUBUNIT GAMMA', 247162),
(372987, 'PTHR45989:SF2', NULL, NULL, NULL, NULL, 'NTP_TRANSF_3 DOMAIN-CONTAINING PROTEIN', 247162),
(372988, 'PTHR10165:SF180', NULL, NULL, NULL, NULL, 'LIPID PHOSPHATE PHOSPHATASE 1', 247163),
(372989, 'PTHR10165:SF193', NULL, NULL, NULL, NULL, 'LIPID PHOSPHATE PHOSPHATASE 2-LIKE', 247163),
(372990, 'PTHR10165:SF192', NULL, NULL, NULL, NULL, 'ACIDPPC DOMAIN-CONTAINING PROTEIN', 247163),
(372991, 'PTHR10165:SF87', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID PHOSPHATASE 5', 247163),
(372992, 'PTHR10165:SF195', NULL, NULL, NULL, NULL, 'ACIDPPC DOMAIN-CONTAINING PROTEIN', 247163),
(372993, 'PTHR10165:SF194', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID PHOSPHATASE HOMOLOG 1.2 HOMOLOG', 247163),
(372994, 'PTHR10165:SF197', NULL, NULL, NULL, NULL, 'FI04477P-RELATED', 247163),
(372995, 'PTHR10165:SF196', NULL, NULL, NULL, NULL, 'ACIDPPC DOMAIN-CONTAINING PROTEIN', 247163),
(372996, 'PTHR10165:SF174', NULL, NULL, NULL, NULL, 'ACIDPPC DOMAIN-CONTAINING PROTEIN', 247163),
(372997, 'PTHR10165:SF26', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID PHOSPHATASE 1', 247163),
(372998, 'PTHR10165:SF25', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID PHOSPHATASE 2', 247163),
(372999, 'PTHR10165:SF155', NULL, NULL, NULL, NULL, 'LIPID PHOSPHATE PHOSPHATASE 1', 247163),
(373000, 'PTHR10165:SF199', NULL, NULL, NULL, NULL, 'OS09G0308900 PROTEIN', 247163),
(373001, 'PTHR10165:SF177', NULL, NULL, NULL, NULL, 'ACIDPPC DOMAIN-CONTAINING PROTEIN', 247163),
(373002, 'PTHR10165:SF198', NULL, NULL, NULL, NULL, 'PAP2 SUPERFAMILY PROTEIN', 247163),
(373003, 'PTHR10165:SF154', NULL, NULL, NULL, NULL, 'PAP2 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_1G09730)', 247163),
(373004, 'PTHR10165:SF178', NULL, NULL, NULL, NULL, 'ACIDPPC DOMAIN-CONTAINING PROTEIN', 247163),
(373005, 'PTHR10165:SF158', NULL, NULL, NULL, NULL, 'PAP2 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_4G08970)', 247163),
(373006, 'PTHR10165:SF114', NULL, NULL, NULL, NULL, 'ACIDPPC DOMAIN-CONTAINING PROTEIN', 247163),
(373007, 'PTHR10165:SF41', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID PHOSPHATASE-RELATED PROTEIN TYPE 1', 247163),
(373008, 'PTHR10165:SF84', NULL, NULL, NULL, NULL, 'PHOSPHATIDIC ACID PHOSPHATASE BETA', 247163),
(373009, 'PTHR10165', NULL, NULL, NULL, NULL, 'LIPID PHOSPHATE PHOSPHATASE', 247163),
(373010, 'PTHR10165:SF17', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID PHOSPHATASE-RELATED PROTEIN TYPE 5', 247163),
(373011, 'PTHR10165:SF191', NULL, NULL, NULL, NULL, 'ACIDPPC DOMAIN-CONTAINING PROTEIN', 247163),
(373012, 'PTHR10165:SF160', NULL, NULL, NULL, NULL, 'ACIDPPC DOMAIN-CONTAINING PROTEIN', 247163);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(373013, 'PTHR10165:SF99', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE ACP2', 247163),
(373014, 'PTHR10165:SF183', NULL, NULL, NULL, NULL, 'LIPID PHOSPHATE PHOSPHATASE 2', 247163),
(373015, 'PTHR10165:SF15', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID PHOSPHATASE-RELATED PROTEIN TYPE 2', 247163),
(373016, 'PTHR10165:SF185', NULL, NULL, NULL, NULL, 'ACIDPPC DOMAIN-CONTAINING PROTEIN', 247163),
(373017, 'PTHR10165:SF163', NULL, NULL, NULL, NULL, 'OS05G0549900 PROTEIN', 247163),
(373018, 'PTHR10165:SF14', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID PHOSPHATASE-RELATED PROTEIN TYPE 3', 247163),
(373019, 'PTHR10165:SF35', NULL, NULL, NULL, NULL, 'RE23632P', 247163),
(373020, 'PTHR10165:SF13', NULL, NULL, NULL, NULL, '2-LYSOPHOSPHATIDATE PHOSPHATASE PLPPR4', 247163),
(373021, 'PTHR10165:SF187', NULL, NULL, NULL, NULL, 'LIPID PHOSPHATE PHOSPHATASE 2-LIKE', 247163),
(373022, 'PTHR10165:SF79', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID PHOSPHATASE 3', 247163),
(373023, 'PTHR10165:SF102', NULL, NULL, NULL, NULL, 'ACIDPPC DOMAIN-CONTAINING PROTEIN', 247163),
(373024, 'PTHR10165:SF167', NULL, NULL, NULL, NULL, 'ACIDPPC DOMAIN-CONTAINING PROTEIN', 247163),
(373025, 'PTHR10165:SF145', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID PHOSPHATASE-RELATED 2A', 247163),
(373026, 'PTHR10165:SF189', NULL, NULL, NULL, NULL, 'PHOSPHATIDIC ACID PHOSPHATASE TYPE 2/HALOPEROXIDASE, LIPID PHOSPHATE PHOSPHATASE, PLANT-RELATED', 247163),
(373027, 'PTHR10165:SF91', NULL, NULL, NULL, NULL, 'LIPID PHOSPHATE PHOSPHATASE 4-RELATED', 247163),
(373028, 'PTHR10165:SF200', NULL, NULL, NULL, NULL, 'LIPID PHOSPHATE PHOSPHATASE-LIKE PROTEIN', 247163),
(373029, 'PTHR10165:SF90', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID PHOSPHATASE 4', 247163),
(373030, 'PTHR10165:SF103', NULL, NULL, NULL, NULL, 'ACIDPPC DOMAIN-CONTAINING PROTEIN', 247163),
(373031, 'PTHR10165:SF149', NULL, NULL, NULL, NULL, 'OS01G0666000 PROTEIN', 247163),
(373032, 'PTHR10165:SF108', NULL, NULL, NULL, NULL, 'PA-PHOSPHATASE RELATED-FAMILY PROTEIN DDB_G0271516-RELATED', 247163),
(373033, 'PTHR10165:SF94', NULL, NULL, NULL, NULL, 'PHOSPHATIDIC ACID PHOSPHATASE TYPE 2D', 247163),
(373034, 'PTHR33714', NULL, NULL, NULL, NULL, 'COUNTING FACTOR-ASSOCIATED PROTEIN A-RELATED', 247164),
(373035, 'PTHR33714:SF5', NULL, NULL, NULL, NULL, 'COUNTING FACTOR-ASSOCIATED PROTEIN C', 247164),
(373036, 'PTHR33714:SF3', NULL, NULL, NULL, NULL, 'COUNTING FACTOR-ASSOCIATED PROTEIN A-RELATED', 247164),
(373037, 'PTHR33714:SF2', NULL, NULL, NULL, NULL, '', 247164),
(373038, 'PTHR33714:SF1', NULL, NULL, NULL, NULL, '', 247164),
(373039, 'PTHR12774', NULL, NULL, NULL, NULL, 'PEROXISOMAL BIOGENESIS FACTOR 19', 247165),
(373040, 'PTHR12774:SF2', NULL, NULL, NULL, NULL, 'PEROXISOMAL BIOGENESIS FACTOR 19', 247165),
(373041, 'PTHR12774:SF3', NULL, NULL, NULL, NULL, '', 247165),
(373042, 'PTHR12774:SF7', NULL, NULL, NULL, NULL, 'PEROXISOME BIOGENESIS PROTEIN 19-1', 247165),
(373043, 'PTHR12774:SF5', NULL, NULL, NULL, NULL, 'PEROXISOME BIOGENESIS PROTEIN 19-1-LIKE', 247165),
(373044, 'PTHR11276:SF24', NULL, NULL, NULL, NULL, 'DNA-DIRECTED DNA/RNA POLYMERASE MU', 247166),
(373045, 'PTHR11276:SF14', NULL, NULL, NULL, NULL, 'DNA POLYMERASE', 247166),
(373046, 'PTHR11276:SF42', NULL, NULL, NULL, NULL, 'DNA POLYMERASE BETA', 247166),
(373047, 'PTHR11276:SF21', NULL, NULL, NULL, NULL, 'DNA NUCLEOTIDYLEXOTRANSFERASE', 247166),
(373048, 'PTHR11276:SF40', NULL, NULL, NULL, NULL, 'BRCT DOMAIN-CONTAINING PROTEIN', 247166),
(373049, 'PTHR11276:SF41', NULL, NULL, NULL, NULL, 'DNA POLYMERASE LAMBDA', 247166),
(373050, 'PTHR11276:SF28', NULL, NULL, NULL, NULL, 'DNA POLYMERASE LAMBDA', 247166),
(373051, 'PTHR11276:SF29', NULL, NULL, NULL, NULL, 'DNA POLYMERASE TYPE-X FAMILY PROTEIN POL4', 247166),
(373052, 'PTHR11276', NULL, NULL, NULL, NULL, 'DNA POLYMERASE TYPE-X FAMILY MEMBER', 247166),
(373053, 'PTHR44115:SF3', NULL, NULL, NULL, NULL, 'DEHYDROGENASES, SHORT CHAIN', 247167),
(373054, 'PTHR44115:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG06196', 247167),
(373055, 'PTHR44115:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG05820', 247167),
(373056, 'PTHR44115:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG09690', 247167);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(373057, 'PTHR44115:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG06354', 247167),
(373058, 'PTHR44115:SF11', NULL, NULL, NULL, NULL, 'DEHYDROGENASES, SHORT CHAIN', 247167),
(373059, 'PTHR44115:SF6', NULL, NULL, NULL, NULL, 'DEHYDROGENASES, SHORT CHAIN', 247167),
(373060, 'PTHR44115:SF12', NULL, NULL, NULL, NULL, 'PROTEIN CBG09704', 247167),
(373061, 'PTHR44115:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG24212', 247167),
(373062, 'PTHR44115:SF10', NULL, NULL, NULL, NULL, 'PROTEIN CBG22606', 247167),
(373063, 'PTHR44115', NULL, NULL, NULL, NULL, 'PROTEIN CBG09704', 247167),
(373064, 'PTHR15131:SF3', NULL, NULL, NULL, NULL, 'SNRNA-ACTIVATING PROTEIN COMPLEX SUBUNIT 1', 247168),
(373065, 'PTHR15131', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RNA ACTIVATING COMPLEX, POLYPEPTIDE 1', 247168),
(373066, 'PTHR15131:SF7', NULL, NULL, NULL, NULL, 'SNAPC (SMALL NUCLEAR RNA ACTIVATING COMPLEX) HOMOLOG', 247168),
(373067, 'PTHR15204:SF0', NULL, NULL, NULL, NULL, 'LARGE PROLINE-RICH PROTEIN BAG6', 247169),
(373068, 'PTHR15204:SF9', NULL, NULL, NULL, NULL, 'UBIQUITIN-RELATED', 247169),
(373069, 'PTHR15204:SF5', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 247169),
(373070, 'PTHR15204', NULL, NULL, NULL, NULL, 'LARGE PROLINE-RICH PROTEIN BAG6', 247169),
(373071, 'PTHR15204:SF7', NULL, NULL, NULL, NULL, 'UBIQUITIN DOMAIN-CONTAINING PROTEIN DSK2-LIKE ISOFORM X1', 247169),
(373072, 'PTHR15204:SF8', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 12-LIKE', 247169),
(373073, 'PTHR39461', NULL, NULL, NULL, NULL, 'LEA DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_8G04920)', 247170),
(373074, 'PTHR39461:SF1', NULL, NULL, NULL, NULL, 'LEA DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_8G04920)', 247170),
(373075, 'PTHR18863', NULL, NULL, NULL, NULL, 'TSEC-2-RELATED', 247171),
(373076, 'PTHR18863:SF5', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED GENE 21', 247171),
(373077, 'PTHR18863:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG02343', 247171),
(373078, 'PTHR18863:SF4', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 170', 247171),
(373079, 'PTHR13043', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT SEC5', 247172),
(373080, 'PTHR13043:SF1', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT 2', 247172),
(373081, 'PTHR13043:SF3', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT SEC5', 247172),
(373082, 'PTHR13043:SF2', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT SEC5', 247172),
(373083, 'PTHR36169', NULL, NULL, NULL, NULL, 'ETHANOLAMINE UTILIZATION PROTEIN EUTQ', 247173),
(373084, 'PTHR36169:SF1', NULL, NULL, NULL, NULL, 'ACETATE KINASE EUTQ', 247173),
(373085, 'PTHR30295:SF1', NULL, NULL, NULL, NULL, 'DNA PROTECTION DURING STARVATION PROTEIN', 247174),
(373086, 'PTHR30295:SF0', NULL, NULL, NULL, NULL, 'BACTERIOFERRITIN', 247174),
(373087, 'PTHR30295', NULL, NULL, NULL, NULL, 'BACTERIOFERRITIN', 247174),
(373088, 'PTHR30295:SF9', NULL, NULL, NULL, NULL, 'BACTERIOFERRITIN', 247174),
(373089, 'PTHR14795:SF5', NULL, NULL, NULL, NULL, 'OS07G0274100 PROTEIN', 247175),
(373090, 'PTHR14795:SF6', NULL, NULL, NULL, NULL, 'METALLOPHOSPHOESTERASE-RELATED', 247175),
(373091, 'PTHR14795:SF0', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 62', 247175),
(373092, 'PTHR14795', NULL, NULL, NULL, NULL, 'HELICASE RELATED', 247175),
(373093, 'PTHR18821:SF8', NULL, NULL, NULL, NULL, 'PROKINETICIN-2', 247176),
(373094, 'PTHR18821:SF7', NULL, NULL, NULL, NULL, 'PROKINETICIN-1', 247176),
(373095, 'PTHR18821', NULL, NULL, NULL, NULL, 'PROKINETICIN', 247176),
(373096, 'PTHR18821:SF9', NULL, NULL, NULL, NULL, 'PROKINETICIN', 247176),
(373097, 'PTHR18821:SF2', NULL, NULL, NULL, NULL, 'PROKINETICIN DOMAIN-CONTAINING PROTEIN', 247176),
(373098, 'PTHR34183:SF9', NULL, NULL, NULL, NULL, 'SPOR DOMAIN-CONTAINING PROTEIN', 247177),
(373099, 'PTHR34183:SF8', NULL, NULL, NULL, NULL, 'ENDOLYTIC PEPTIDOGLYCAN TRANSGLYCOSYLASE RLPA', 247177),
(373100, 'PTHR34183', NULL, NULL, NULL, NULL, '', 247177),
(373101, 'PTHR34183:SF1', NULL, NULL, NULL, NULL, 'ENDOLYTIC PEPTIDOGLYCAN TRANSGLYCOSYLASE RLPA', 247177),
(373102, 'PTHR36887:SF3', NULL, NULL, NULL, NULL, '', 247178);
INSERT INTO "PUBLIC"."MODEL" VALUES
(373103, 'PTHR36887', NULL, NULL, NULL, NULL, 'OS01G0532300 PROTEIN', 247178),
(373104, 'PTHR36887:SF2', NULL, NULL, NULL, NULL, '', 247178),
(373105, 'PTHR36887:SF1', NULL, NULL, NULL, NULL, 'OS01G0532300 PROTEIN', 247178),
(373106, 'PTHR21599:SF0', NULL, NULL, NULL, NULL, 'GLYCERATE 3-KINASE', 247179),
(373107, 'PTHR21599', NULL, NULL, NULL, NULL, 'GLYCERATE KINASE', 247179),
(373108, 'PTHR21599:SF7', NULL, NULL, NULL, NULL, 'GLYCERATE 2-KINASE', 247179),
(373109, 'PTHR13383:SF11', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H2 SUBUNIT B', 247180),
(373110, 'PTHR13383', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H2 SUBUNIT B', 247180),
(373111, 'PTHR37812:SF1', NULL, NULL, NULL, NULL, 'MU-LIKE PROPHAGE FLUMU PROTEIN C', 247181),
(373112, 'PTHR37812', NULL, NULL, NULL, NULL, 'MU-LIKE PROPHAGE FLUMU PROTEIN C', 247181),
(373113, 'PTHR35111:SF1', NULL, NULL, NULL, NULL, 'OS04G0115900 PROTEIN', 247182),
(373114, 'PTHR35111', NULL, NULL, NULL, NULL, 'F10A5.9-RELATED', 247182),
(373115, 'PTHR35111:SF5', NULL, NULL, NULL, NULL, 'F10A5.9', 247182),
(373116, 'PTHR35111:SF8', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247182),
(373117, 'PTHR21101:SF11', NULL, NULL, NULL, NULL, 'RESISTIN', 247183),
(373118, 'PTHR21101:SF5', NULL, NULL, NULL, NULL, 'RESISTIN-LIKE ALPHA', 247183),
(373119, 'PTHR21101:SF12', NULL, NULL, NULL, NULL, 'RESISTIN-LIKE BETA', 247183),
(373120, 'PTHR21101:SF13', NULL, NULL, NULL, NULL, 'RESISTIN-LIKE BETA', 247183),
(373121, 'PTHR21101:SF14', NULL, NULL, NULL, NULL, 'RESISTIN-LIKE GAMMA', 247183),
(373122, 'PTHR21101', NULL, NULL, NULL, NULL, 'RESISTIN', 247183),
(373123, 'PTHR43238', NULL, NULL, NULL, NULL, 'GDP-L-FUCOSE SYNTHASE', 247184),
(373124, 'PTHR43238:SF8', NULL, NULL, NULL, NULL, 'GDP-L-FUCOSE SYNTHASE 2-RELATED', 247184),
(373125, 'PTHR43238:SF6', NULL, NULL, NULL, NULL, 'GDP-L-FUCOSE SYNTHASE 2-RELATED', 247184),
(373126, 'PTHR43238:SF1', NULL, NULL, NULL, NULL, 'GDP-L-FUCOSE SYNTHASE', 247184),
(373127, 'PTHR13734:SF5', NULL, NULL, NULL, NULL, 'CCA TRNA NUCLEOTIDYLTRANSFERASE, MITOCHONDRIAL', 247185),
(373128, 'PTHR13734:SF6', NULL, NULL, NULL, NULL, 'BNAA08G02170D PROTEIN', 247185),
(373129, 'PTHR13734:SF7', NULL, NULL, NULL, NULL, 'POLYA_POL DOMAIN-CONTAINING PROTEIN', 247185),
(373130, 'PTHR13734:SF8', NULL, NULL, NULL, NULL, 'POLYA_POL DOMAIN-CONTAINING PROTEIN', 247185),
(373131, 'PTHR13734', NULL, NULL, NULL, NULL, 'TRNA-NUCLEOTIDYLTRANSFERASE', 247185),
(373132, 'PTHR19256:SF57', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR GAMMA VARIABLE 2-RELATED', 247186),
(373133, 'PTHR19256:SF56', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 247186),
(373134, 'PTHR19256:SF45', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR GAMMA VARIABLE 3-RELATED', 247186),
(373135, 'PTHR19256:SF44', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR GAMMA VARIABLE 9', 247186),
(373136, 'PTHR19256:SF48', NULL, NULL, NULL, NULL, 'NON-FUNCTIONAL T CELL RECEPTOR GAMMA VARIABLE-RELATED', 247186),
(373137, 'PTHR19256:SF59', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR GAMMA CONSTANT 1-RELATED', 247186),
(373138, 'PTHR19256:SF60', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR GAMMA, CONSTANT 3-RELATED', 247186),
(373139, 'PTHR19256:SF54', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR GAMMA VARIABLE 8', 247186),
(373140, 'PTHR19256', NULL, NULL, NULL, NULL, 'T-CELL RECEPTOR GAMMA CHAIN', 247186),
(373141, 'PTHR19256:SF40', NULL, NULL, NULL, NULL, 'NON-FUNCTIONAL T CELL RECEPTOR GAMMA VARIABLE 10-RELATED', 247186),
(373142, 'PTHR12674:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG01589', 247187),
(373143, 'PTHR12674:SF6', NULL, NULL, NULL, NULL, 'PREFOLDIN SUBUNIT 5', 247187),
(373144, 'PTHR12674:SF7', NULL, NULL, NULL, NULL, '', 247187),
(373145, 'PTHR12674:SF8', NULL, NULL, NULL, NULL, 'BNAA09G05390D PROTEIN', 247187),
(373146, 'PTHR12674:SF2', NULL, NULL, NULL, NULL, 'PREFOLDIN SUBUNIT 5', 247187),
(373147, 'PTHR12674:SF4', NULL, NULL, NULL, NULL, 'PREFOLDIN SUBUNIT ALPHA 2', 247187),
(373148, 'PTHR12674', NULL, NULL, NULL, NULL, 'PREFOLDIN SUBUNIT 5', 247187),
(373149, 'PTHR37541', NULL, NULL, NULL, NULL, 'SRP40_C DOMAIN-CONTAINING PROTEIN', 247188);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(373150, 'PTHR37541:SF1', NULL, NULL, NULL, NULL, 'SRP40_C DOMAIN-CONTAINING PROTEIN', 247188),
(373151, 'PTHR36840', NULL, NULL, NULL, NULL, 'BLL5714 PROTEIN', 247189),
(373152, 'PTHR36840:SF1', NULL, NULL, NULL, NULL, 'BLL5714 PROTEIN', 247189),
(373153, 'PTHR36001', NULL, NULL, NULL, NULL, 'CTAGE FAMILY PROTEIN-RELATED', 247190),
(373154, 'PTHR36001:SF2', NULL, NULL, NULL, NULL, 'CTAGE FAMILY PROTEIN-RELATED', 247190),
(373155, 'PTHR34387:SF1', NULL, NULL, NULL, NULL, 'PERIPLASMIC IMMUNOGENIC PROTEIN-RELATED', 247191),
(373156, 'PTHR34387', NULL, NULL, NULL, NULL, 'SLR1258 PROTEIN', 247191),
(373157, 'PTHR34387:SF2', NULL, NULL, NULL, NULL, 'SLR1258 PROTEIN', 247191),
(373158, 'PTHR47876:SF2', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 247192),
(373159, 'PTHR47876:SF3', NULL, NULL, NULL, NULL, 'PHYTOCHROME 1', 247192),
(373160, 'PTHR47876', NULL, NULL, NULL, NULL, 'OS08G0260000 PROTEIN', 247192),
(373161, 'PTHR10176:SF1', NULL, NULL, NULL, NULL, 'GLYCOGEN [STARCH] SYNTHASE, LIVER', 247193),
(373162, 'PTHR10176:SF2', NULL, NULL, NULL, NULL, 'GLYCOGEN [STARCH] SYNTHASE, MUSCLE', 247193),
(373163, 'PTHR10176', NULL, NULL, NULL, NULL, 'GLYCOGEN SYNTHASE', 247193),
(373164, 'PTHR10176:SF3', NULL, NULL, NULL, NULL, 'GLYCOGEN [STARCH] SYNTHASE', 247193),
(373165, 'PTHR22939:SF101', NULL, NULL, NULL, NULL, 'PERIPLASMIC PH-DEPENDENT SERINE ENDOPROTEASE DEGQ', 247194),
(373166, 'PTHR22939:SF14', NULL, NULL, NULL, NULL, 'SERINE PROTEASE HTRA3', 247194),
(373167, 'PTHR22939:SF127', NULL, NULL, NULL, NULL, 'SERINE PROTEASE HTRA2, MITOCHONDRIAL', 247194),
(373168, 'PTHR22939:SF105', NULL, NULL, NULL, NULL, 'SERINE PROTEASE HTRA4', 247194),
(373169, 'PTHR22939:SF13', NULL, NULL, NULL, NULL, 'SERINE PROTEASE HTRA1', 247194),
(373170, 'PTHR22939:SF128', NULL, NULL, NULL, NULL, 'SERINE PROTEASE HTRA1A', 247194),
(373171, 'PTHR22939:SF125', NULL, NULL, NULL, NULL, 'PROTEASE DO-LIKE 14-RELATED', 247194),
(373172, 'PTHR22939', NULL, NULL, NULL, NULL, 'SERINE PROTEASE FAMILY S1C HTRA-RELATED', 247194),
(373173, 'PTHR22939:SF129', NULL, NULL, NULL, NULL, 'SERINE PROTEASE HTRA2, MITOCHONDRIAL', 247194),
(373174, 'PTHR37174', NULL, NULL, NULL, NULL, 'FORKHEAD-ASSOCIATED DOMAIN PROTEIN', 247195),
(373175, 'PTHR37174:SF2', NULL, NULL, NULL, NULL, 'FORKHEAD-ASSOCIATED DOMAIN PROTEIN', 247195),
(373176, 'PTHR36720:SF3', NULL, NULL, NULL, NULL, 'BNAA06G01070D PROTEIN', 247196),
(373177, 'PTHR36720:SF1', NULL, NULL, NULL, NULL, 'TAF RNA POLYMERASE I SUBUNIT A', 247196),
(373178, 'PTHR36720', NULL, NULL, NULL, NULL, 'TAF RNA POLYMERASE I SUBUNIT A', 247196),
(373179, 'PTHR31896:SF42', NULL, NULL, NULL, NULL, 'ANTHRANILATE N-HYDROXYCINNAMOYL/BENZOYLTRANSFERASE-LIKE PROTEIN', 247197),
(373180, 'PTHR31896:SF64', NULL, NULL, NULL, NULL, 'TRICHOTHECENE 3-O-ACETYLTRANSFERASE', 247197),
(373181, 'PTHR31896:SF43', NULL, NULL, NULL, NULL, 'PROTEIN ENHANCED PSEUDOMONAS SUSCEPTIBILITY 1', 247197),
(373182, 'PTHR31896:SF65', NULL, NULL, NULL, NULL, '', 247197),
(373183, 'PTHR31896:SF40', NULL, NULL, NULL, NULL, 'ANTHRANILATE N-HYDROXYCINNAMOYL/BENZOYLTRANSFERASE-LIKE PROTEIN-RELATED', 247197),
(373184, 'PTHR31896:SF62', NULL, NULL, NULL, NULL, 'HXXXD-TYPE ACYL-TRANSFERASE FAMILY PROTEIN-RELATED', 247197),
(373185, 'PTHR31896:SF41', NULL, NULL, NULL, NULL, 'OS05G0449200 PROTEIN', 247197),
(373186, 'PTHR31896:SF68', NULL, NULL, NULL, NULL, 'MYB-LIKE DOMAIN-CONTAINING PROTEIN', 247197),
(373187, 'PTHR31896:SF46', NULL, NULL, NULL, NULL, 'HXXXD-TYPE ACYL-TRANSFERASE FAMILY PROTEIN', 247197),
(373188, 'PTHR31896:SF47', NULL, NULL, NULL, NULL, 'ACYL-TRANSFERASE FAMILY PROTEIN, PUTATIVE-RELATED', 247197),
(373189, 'PTHR31896:SF69', NULL, NULL, NULL, NULL, 'FAMILY REGULATORY PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G14730)-RELATED', 247197),
(373190, 'PTHR31896:SF66', NULL, NULL, NULL, NULL, 'ANTHRANILATE N-HYDROXYCINNAMOYL/BENZOYLTRANSFERASE-LIKE PROTEIN', 247197),
(373191, 'PTHR31896:SF67', NULL, NULL, NULL, NULL, 'AMINO_OXIDASE DOMAIN-CONTAINING PROTEIN', 247197),
(373192, 'PTHR31896:SF29', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 247197);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(373193, 'PTHR31896:SF48', NULL, NULL, NULL, NULL, 'BNAA09G06710D PROTEIN', 247197),
(373194, 'PTHR31896:SF27', NULL, NULL, NULL, NULL, '', 247197),
(373195, 'PTHR31896:SF50', NULL, NULL, NULL, NULL, 'ANTHOCYANIN 5-AROMATIC ACYLTRANSFERASE', 247197),
(373196, 'PTHR31896:SF53', NULL, NULL, NULL, NULL, 'BNAA09G07570D PROTEIN', 247197),
(373197, 'PTHR31896:SF31', NULL, NULL, NULL, NULL, 'HXXXD-TYPE ACYL-TRANSFERASE FAMILY PROTEIN', 247197),
(373198, 'PTHR31896:SF32', NULL, NULL, NULL, NULL, 'ANTHRANILATE N-BENZOYLTRANSFERASE PROTEIN', 247197),
(373199, 'PTHR31896:SF54', NULL, NULL, NULL, NULL, 'BNAC09G31030D PROTEIN', 247197),
(373200, 'PTHR31896:SF51', NULL, NULL, NULL, NULL, 'BNAC02G01430D PROTEIN', 247197),
(373201, 'PTHR31896:SF52', NULL, NULL, NULL, NULL, 'ANTHRANILATE N-BENZOYLTRANSFERASE PROTEIN', 247197),
(373202, 'PTHR31896:SF57', NULL, NULL, NULL, NULL, 'BNAA10G27540D PROTEIN', 247197),
(373203, 'PTHR31896:SF35', NULL, NULL, NULL, NULL, 'HXXXD-TYPE ACYL-TRANSFERASE FAMILY PROTEIN', 247197),
(373204, 'PTHR31896:SF13', NULL, NULL, NULL, NULL, '', 247197),
(373205, 'PTHR31896:SF36', NULL, NULL, NULL, NULL, 'HXXXD-TYPE ACYL-TRANSFERASE FAMILY PROTEIN-RELATED', 247197),
(373206, 'PTHR31896:SF55', NULL, NULL, NULL, NULL, 'TRANSFERASE FAMILY PROTEIN', 247197),
(373207, 'PTHR31896:SF33', NULL, NULL, NULL, NULL, '', 247197),
(373208, 'PTHR31896:SF56', NULL, NULL, NULL, NULL, 'BNAC06G15240D PROTEIN', 247197),
(373209, 'PTHR31896:SF12', NULL, NULL, NULL, NULL, 'HXXXD-TYPE ACYL-TRANSFERASE FAMILY PROTEIN', 247197),
(373210, 'PTHR31896:SF39', NULL, NULL, NULL, NULL, 'PROTEIN ENHANCED PSEUDOMONAS SUSCEPTIBILITY 1-LIKE', 247197),
(373211, 'PTHR31896:SF59', NULL, NULL, NULL, NULL, '', 247197),
(373212, 'PTHR31896:SF37', NULL, NULL, NULL, NULL, 'OS07G0142700 PROTEIN', 247197),
(373213, 'PTHR31896', NULL, NULL, NULL, NULL, 'FAMILY REGULATORY PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G14730)-RELATED', 247197),
(373214, 'PTHR31896:SF9', NULL, NULL, NULL, NULL, 'OS08G0111500 PROTEIN', 247197),
(373215, 'PTHR31896:SF5', NULL, NULL, NULL, NULL, 'OS01G0854000 PROTEIN', 247197),
(373216, 'PTHR31896:SF60', NULL, NULL, NULL, NULL, 'BNAA02G29330D PROTEIN', 247197),
(373217, 'PTHR31896:SF61', NULL, NULL, NULL, NULL, 'ANTHRANILATE N-HYDROXYCINNAMOYL/BENZOYLTRANSFERASE', 247197),
(373218, 'PTHR46261:SF3', NULL, NULL, NULL, NULL, 'HMG PROTEIN', 247198),
(373219, 'PTHR46261:SF1', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP B PROTEIN 1', 247198),
(373220, 'PTHR46261:SF30', NULL, NULL, NULL, NULL, 'HMG1/2-LIKE PROTEIN', 247198),
(373221, 'PTHR46261:SF31', NULL, NULL, NULL, NULL, 'HMG TYPE NUCLEOSOME/CHROMATIN ASSEMBLY FACTOR', 247198),
(373222, 'PTHR46261:SF32', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP B PROTEIN 3-LIKE', 247198),
(373223, 'PTHR46261:SF22', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP B PROTEIN 2-RELATED', 247198),
(373224, 'PTHR46261:SF12', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP B PROTEIN 14', 247198),
(373225, 'PTHR46261:SF24', NULL, NULL, NULL, NULL, 'HMG BOX DOMAIN-CONTAINING PROTEIN', 247198),
(373226, 'PTHR46261:SF14', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP B PROTEIN 1-LIKE ISOFORM X1', 247198),
(373227, 'PTHR46261:SF15', NULL, NULL, NULL, NULL, 'OS02G0670400 PROTEIN', 247198),
(373228, 'PTHR46261', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP B PROTEIN 4-RELATED', 247198),
(373229, 'PTHR46261:SF28', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN', 247198),
(373230, 'PTHR46261:SF29', NULL, NULL, NULL, NULL, 'HMG BOX DOMAIN-CONTAINING PROTEIN', 247198),
(373231, 'PTHR46261:SF18', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP B PROTEIN 4-RELATED', 247198),
(373232, 'PTHR46261:SF19', NULL, NULL, NULL, NULL, 'HMG BOX DOMAIN-CONTAINING PROTEIN', 247198),
(373233, 'PTHR39476', NULL, NULL, NULL, NULL, 'NADH:UBIQUINONE OXIDOREDUCTASE 6.6KD SUBUNIT', 247199),
(373234, 'PTHR39476:SF1', NULL, NULL, NULL, NULL, 'COMPLEX I-B15', 247199),
(373235, 'PTHR25465:SF5', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF135', 247200),
(373236, 'PTHR25465:SF7', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 29', 247200);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(373237, 'PTHR25465:SF29', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 65', 247200),
(373238, 'PTHR25465:SF19', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM8', 247200),
(373239, 'PTHR25465', NULL, NULL, NULL, NULL, 'B-BOX DOMAIN CONTAINING', 247200),
(373240, 'PTHR25465:SF14', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN/ISG15 LIGASE TRIM25', 247200),
(373241, 'PTHR25465:SF26', NULL, NULL, NULL, NULL, 'FINTRIM FAMILY, MEMBER 99', 247200),
(373242, 'PTHR25465:SF34', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING 80', 247200),
(373243, 'PTHR25465:SF12', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING 25,-LIKE', 247200),
(373244, 'PTHR25465:SF35', NULL, NULL, NULL, NULL, 'FINTRIM FAMILY, MEMBER 83', 247200),
(373245, 'PTHR25465:SF13', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 42', 247200),
(373246, 'PTHR25465:SF32', NULL, NULL, NULL, NULL, 'BLOODTHIRSTY-RELATED GENE FAMILY, MEMBER 1-RELATED', 247200),
(373247, 'PTHR25465:SF21', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM47', 247200),
(373248, 'PTHR25465:SF10', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 16-RELATED', 247200),
(373249, 'PTHR25465:SF11', NULL, NULL, NULL, NULL, 'B BOX-TYPE DOMAIN-CONTAINING PROTEIN', 247200),
(373250, 'PTHR25465:SF33', NULL, NULL, NULL, NULL, '', 247200),
(373251, 'PTHR25465:SF30', NULL, NULL, NULL, NULL, 'FINTRIM FAMILY, MEMBER 82', 247200),
(373252, 'PTHR25465:SF31', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 247200),
(373253, 'PTHR46266:SF8', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247201),
(373254, 'PTHR46266:SF9', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247201),
(373255, 'PTHR46266:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR EGL1', 247201),
(373256, 'PTHR46266:SF4', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TT8', 247201),
(373257, 'PTHR46266:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GLABRA 3', 247201),
(373258, 'PTHR46266:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYC1', 247201),
(373259, 'PTHR46266', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TT8', 247201),
(373260, 'PTHR11413:SF108', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR', 247202),
(373261, 'PTHR11413:SF118', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR 7', 247202),
(373262, 'PTHR11413:SF107', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR 3', 247202),
(373263, 'PTHR11413:SF104', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR 2', 247202),
(373264, 'PTHR11413:SF116', NULL, NULL, NULL, NULL, 'MULTICYSTATIN', 247202),
(373265, 'PTHR11413', NULL, NULL, NULL, NULL, 'CYSTATIN FAMILY MEMBER', 247202),
(373266, 'PTHR11413:SF113', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR', 247202),
(373267, 'PTHR11413:SF124', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR 3', 247202),
(373268, 'PTHR11413:SF125', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR', 247202),
(373269, 'PTHR11413:SF114', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR', 247202),
(373270, 'PTHR11413:SF103', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR 12', 247202),
(373271, 'PTHR11413:SF111', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR', 247202),
(373272, 'PTHR11413:SF122', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR 1', 247202),
(373273, 'PTHR11413:SF123', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR', 247202),
(373274, 'PTHR11413:SF112', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR', 247202),
(373275, 'PTHR11413:SF120', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR', 247202),
(373276, 'PTHR11413:SF121', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR', 247202),
(373277, 'PTHR11413:SF110', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR 6', 247202),
(373278, 'PTHR44742:SF7', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 247203),
(373279, 'PTHR44742:SF6', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 247203),
(373280, 'PTHR44742:SF5', NULL, NULL, NULL, NULL, '24-METHYLENESTEROL C-METHYLTRANSFERASE 3', 247203);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(373281, 'PTHR44742:SF4', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 247203),
(373282, 'PTHR44742:SF2', NULL, NULL, NULL, NULL, '24-METHYLENESTEROL C-METHYLTRANSFERASE 2', 247203),
(373283, 'PTHR44742', NULL, NULL, NULL, NULL, '', 247203),
(373284, 'PTHR33306:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247204),
(373285, 'PTHR33306:SF29', NULL, NULL, NULL, NULL, '', 247204),
(373286, 'PTHR33306:SF18', NULL, NULL, NULL, NULL, 'OS02G0775300 PROTEIN', 247204),
(373287, 'PTHR33306:SF39', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247204),
(373288, 'PTHR33306:SF24', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 247204),
(373289, 'PTHR33306:SF38', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247204),
(373290, 'PTHR33306:SF27', NULL, NULL, NULL, NULL, 'OS06G0206900 PROTEIN', 247204),
(373291, 'PTHR33306:SF21', NULL, NULL, NULL, NULL, '', 247204),
(373292, 'PTHR33306:SF43', NULL, NULL, NULL, NULL, '', 247204),
(373293, 'PTHR33306:SF42', NULL, NULL, NULL, NULL, '', 247204),
(373294, 'PTHR33306:SF23', NULL, NULL, NULL, NULL, '', 247204),
(373295, 'PTHR33306:SF34', NULL, NULL, NULL, NULL, '', 247204),
(373296, 'PTHR33306:SF22', NULL, NULL, NULL, NULL, 'PERIPHERAL-TYPE BENZODIAZEPINE RECEPTOR-ASSOCIATED PROTEIN 1', 247204),
(373297, 'PTHR33306', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED-RELATED', 247204),
(373298, 'PTHR33306:SF41', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 247204),
(373299, 'PTHR33306:SF40', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247204),
(373300, 'PTHR33306:SF7', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247204),
(373301, 'PTHR33306:SF5', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE/TRANSITION METAL ION-BINDING PROTEIN', 247204),
(373302, 'PTHR43318:SF2', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE 4,6-DEHYDRATASE (INVERTING)', 247205),
(373303, 'PTHR43318:SF1', NULL, NULL, NULL, NULL, 'POLYSACCHARIDE BIOSYNTHESIS PROTEIN EPSC-RELATED', 247205),
(373304, 'PTHR43318', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE 4,6-DEHYDRATASE', 247205),
(373305, 'PTHR28584', NULL, NULL, NULL, NULL, 'FAMILY WITH SEQUENCE SIMILARITY 228 MEMBER A', 247206),
(373306, 'PTHR28584:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM228A', 247206),
(373307, 'PTHR28584:SF3', NULL, NULL, NULL, NULL, 'PROTEIN FAM228B', 247206),
(373308, 'PTHR28584:SF1', NULL, NULL, NULL, NULL, 'FAMILY WITH SEQUENCE SIMILARITY 228 MEMBER A', 247206),
(373309, 'PTHR35810:SF1', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 247207),
(373310, 'PTHR35810', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 247207),
(373311, 'PTHR22442:SF4', NULL, NULL, NULL, NULL, 'PROTEIN FAM169B', 247208),
(373312, 'PTHR22442:SF3', NULL, NULL, NULL, NULL, 'SOLUBLE LAMIN-ASSOCIATED PROTEIN OF 75 KDA', 247208),
(373313, 'PTHR22442:SF10', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE, GNAT FAMILY-RELATED', 247208),
(373314, 'PTHR22442', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247208),
(373315, 'PTHR43519', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE HRPB', 247209),
(373316, 'PTHR43519:SF1', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE HRPB', 247209),
(373317, 'PTHR46278:SF7', NULL, NULL, NULL, NULL, 'ASPARTATE-SEMIALDEHYDE DEHYDROGENASE', 247210),
(373318, 'PTHR46278:SF2', NULL, NULL, NULL, NULL, 'ASPARTATE-SEMIALDEHYDE DEHYDROGENASE', 247210),
(373319, 'PTHR46278:SF4', NULL, NULL, NULL, NULL, 'ASPARTATE-SEMIALDEHYDE DEHYDROGENASE', 247210),
(373320, 'PTHR46278', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE-RELATED', 247210),
(373321, 'PTHR33471:SF7', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT ZINC METALLOPROTEASE-RELATED', 247211),
(373322, 'PTHR33471:SF4', NULL, NULL, NULL, NULL, 'T22H22.11 PROTEIN', 247211),
(373323, 'PTHR33471', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT ZINC METALLOPROTEASE-RELATED', 247211),
(373324, 'PTHR33471:SF1', NULL, NULL, NULL, NULL, 'OS01G0382700 PROTEIN', 247211),
(373325, 'PTHR11104:SF0', NULL, NULL, NULL, NULL, 'SPBETA PROPHAGE-DERIVED AMINOGLYCOSIDE N(3'')-ACETYLTRANSFERASE-LIKE PROTEIN YOKD', 247212),
(373326, 'PTHR11104', NULL, NULL, NULL, NULL, 'AMINOGLYCOSIDE N3-ACETYLTRANSFERASE', 247212);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(373327, 'PTHR24197:SF48', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 61', 247213),
(373328, 'PTHR24197', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 61', 247213),
(373329, 'PTHR24197:SF44', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 54', 247213),
(373330, 'PTHR10211:SF0', NULL, NULL, NULL, NULL, 'DNA PHOTOLYASE', 247214),
(373331, 'PTHR10211', NULL, NULL, NULL, NULL, 'DEOXYRIBODIPYRIMIDINE PHOTOLYASE', 247214),
(373332, 'PTHR47635:SF1', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 247215),
(373333, 'PTHR47635', NULL, NULL, NULL, NULL, 'CUB DOMAIN-CONTAINING PROTEIN', 247215),
(373334, 'PTHR12091', NULL, NULL, NULL, NULL, 'MELANIN-CONCENTRATING HORMONE', 247216),
(373335, 'PTHR12091:SF0', NULL, NULL, NULL, NULL, 'PRO-MCH', 247216),
(373336, 'PTHR12091:SF1', NULL, NULL, NULL, NULL, 'PRO-MCH-LIKE PROTEIN 1-RELATED', 247216),
(373337, 'PTHR12454:SF11', NULL, NULL, NULL, NULL, 'GH25683P', 247217),
(373338, 'PTHR12454', NULL, NULL, NULL, NULL, 'TRIMERIC INTRACELLULAR CATION CHANNEL', 247217),
(373339, 'PTHR12454:SF5', NULL, NULL, NULL, NULL, 'TRIMERIC INTRACELLULAR CATION CHANNEL TYPE B', 247217),
(373340, 'PTHR12454:SF3', NULL, NULL, NULL, NULL, 'TRIMERIC INTRACELLULAR CATION CHANNEL TYPE A', 247217),
(373341, 'PTHR12454:SF18', NULL, NULL, NULL, NULL, 'TRIMERIC INTRACELLULAR CATION CHANNEL TYPE 1B.2', 247217),
(373342, 'PTHR47281:SF4', NULL, NULL, NULL, NULL, 'DOMON DOMAIN, CYTOCHROME B561/FERRIC REDUCTASE TRANSMEMBRANE, DM13 DOMAIN PROTEIN-RELATED', 247218),
(373343, 'PTHR47281:SF3', NULL, NULL, NULL, NULL, 'OS06G0649700 PROTEIN', 247218),
(373344, 'PTHR47281', NULL, NULL, NULL, NULL, 'OS09G0557700 PROTEIN', 247218),
(373345, 'PTHR47281:SF1', NULL, NULL, NULL, NULL, 'OS09G0557700 PROTEIN', 247218),
(373346, 'PTHR37971:SF1', NULL, NULL, NULL, NULL, 'ANTIBACTERIAL FACTOR-RELATED PEPTIDE 1-RELATED', 247219),
(373347, 'PTHR37971', NULL, NULL, NULL, NULL, 'ANTIBACTERIAL FACTOR-RELATED PEPTIDE 1-RELATED', 247219),
(373348, 'PTHR44858:SF19', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 247220),
(373349, 'PTHR44858', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 6', 247220),
(373350, 'PTHR44858:SF1', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE--PEPTIDE N-ACETYLGLUCOSAMINYLTRANSFERASE SPINDLY-RELATED', 247220),
(373351, 'PTHR44858:SF14', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I ASSEMBLY PROTEIN YCF3', 247220),
(373352, 'PTHR44858:SF17', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 247220),
(373353, 'PTHR44858:SF18', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 247220),
(373354, 'PTHR44858:SF15', NULL, NULL, NULL, NULL, 'STRESS-INDUCED-PHOSPHOPROTEIN 1', 247220),
(373355, 'PTHR44858:SF16', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 247220),
(373356, 'PTHR47498:SF1', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 2 MEMBER L', 247221),
(373357, 'PTHR47498', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 2 MEMBER L', 247221),
(373358, 'PTHR36035', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE SCO2', 247222),
(373359, 'PTHR36035:SF1', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE SCO2', 247222),
(373360, 'PTHR46027:SF3', NULL, NULL, NULL, NULL, 'PEROXIN-7', 247223),
(373361, 'PTHR46027:SF1', NULL, NULL, NULL, NULL, 'PEROXISOMAL TARGETING SIGNAL 2 RECEPTOR', 247223),
(373362, 'PTHR46027', NULL, NULL, NULL, NULL, 'PEROXISOMAL TARGETING SIGNAL 2 RECEPTOR', 247223),
(373363, 'PTHR30592:SF4', NULL, NULL, NULL, NULL, 'SULFUR CARRIER PROTEIN FDHD', 247224),
(373364, 'PTHR30592', NULL, NULL, NULL, NULL, 'FORMATE DEHYDROGENASE', 247224),
(373365, 'PTHR30592:SF1', NULL, NULL, NULL, NULL, 'SULFUR CARRIER PROTEIN FDHD', 247224),
(373366, 'PTHR13341:SF2', NULL, NULL, NULL, NULL, 'PROTEIN SEELE', 247225),
(373367, 'PTHR13341:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CANOPY-1', 247225),
(373368, 'PTHR13341:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CANOPY HOMOLOG 2', 247225),
(373369, 'PTHR13341:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG09064', 247225);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(373370, 'PTHR13341:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG15841', 247225),
(373371, 'PTHR13341', NULL, NULL, NULL, NULL, 'MIR-INTERACTING SAPOSIN-LIKE PROTEIN', 247225),
(373372, 'PTHR30575', NULL, NULL, NULL, NULL, 'PEPTIDASE M20', 247226),
(373373, 'PTHR30575:SF0', NULL, NULL, NULL, NULL, 'PEPTIDASE M20 DOMAIN-CONTAINING PROTEIN 2', 247226),
(373374, 'PTHR30575:SF3', NULL, NULL, NULL, NULL, 'M20_DIMER DOMAIN-CONTAINING PROTEIN', 247226),
(373375, 'PTHR30575:SF4', NULL, NULL, NULL, NULL, 'PEPTIDASE M20 DOMAIN-CONTAINING PROTEIN 2', 247226),
(373376, 'PTHR30575:SF8', NULL, NULL, NULL, NULL, 'PEPTIDASE M20 DOMAIN-CONTAINING PROTEIN 2', 247226),
(373377, 'PTHR30575:SF9', NULL, NULL, NULL, NULL, 'PEPTIDASE M20 DOMAIN-CONTAINING PROTEIN 2', 247226),
(373378, 'PTHR46374', NULL, NULL, NULL, NULL, 'PROTEIN CBG07384', 247227),
(373379, 'PTHR46374:SF3', NULL, NULL, NULL, NULL, 'STAR-RELATED LIPID TRANSFER PROTEIN 5', 247227),
(373380, 'PTHR46374:SF2', NULL, NULL, NULL, NULL, 'STAR-RELATED LIPID TRANSFER PROTEIN 6', 247227),
(373381, 'PTHR46374:SF1', NULL, NULL, NULL, NULL, 'START DOMAIN-CONTAINING PROTEIN', 247227),
(373382, 'PTHR36377:SF2', NULL, NULL, NULL, NULL, 'OS11G0107450 PROTEIN', 247228),
(373383, 'PTHR36377:SF1', NULL, NULL, NULL, NULL, 'DNA MISMATCH REPAIR PROTEIN', 247228),
(373384, 'PTHR36377', NULL, NULL, NULL, NULL, 'DNA MISMATCH REPAIR PROTEIN', 247228),
(373385, 'PTHR33986:SF12', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 247229),
(373386, 'PTHR33986', NULL, NULL, NULL, NULL, 'OS02G0535700 PROTEIN', 247229),
(373387, 'PTHR33986:SF2', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL FISSION PROTEIN ELM1', 247229),
(373388, 'PTHR33986:SF17', NULL, NULL, NULL, NULL, 'FISSION PROTEIN ELM1-LIKE PROTEIN-RELATED', 247229),
(373389, 'PTHR33986:SF18', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL FISSION PROTEIN ELM1', 247229),
(373390, 'PTHR33986:SF15', NULL, NULL, NULL, NULL, 'ELONGATED MITOCHONDRIA 1', 247229),
(373391, 'PTHR33986:SF16', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL FISSION PROTEIN ELM1-LIKE ISOFORM X1', 247229),
(373392, 'PTHR33993:SF13', NULL, NULL, NULL, NULL, 'GLYOXALASE/BLEOMYCIN RESISTANCE PROTEIN/DIOXYGENASE', 247230),
(373393, 'PTHR33993:SF14', NULL, NULL, NULL, NULL, 'GB|AAF24581.1', 247230),
(373394, 'PTHR33993:SF11', NULL, NULL, NULL, NULL, 'BNAC09G11920D PROTEIN', 247230),
(373395, 'PTHR33993:SF12', NULL, NULL, NULL, NULL, 'BNAC09G12330D PROTEIN', 247230),
(373396, 'PTHR33993:SF5', NULL, NULL, NULL, NULL, 'GLYOXALASE_6 DOMAIN-CONTAINING PROTEIN', 247230),
(373397, 'PTHR33993:SF10', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', 247230),
(373398, 'PTHR33993:SF1', NULL, NULL, NULL, NULL, 'GLYOXALASE FAMILY PROTEIN', 247230),
(373399, 'PTHR33993:SF2', NULL, NULL, NULL, NULL, 'VOC DOMAIN-CONTAINING PROTEIN', 247230),
(373400, 'PTHR33993', NULL, NULL, NULL, NULL, 'GLYOXALASE-RELATED', 247230),
(373401, 'PTHR38652:SF1', NULL, NULL, NULL, NULL, 'INTERLEUKIN-31', 247231),
(373402, 'PTHR38652', NULL, NULL, NULL, NULL, 'INTERLEUKIN-31', 247231),
(373403, 'PTHR11927:SF9', NULL, NULL, NULL, NULL, 'L-FUCOSYLTRANSFERASE', 247232),
(373404, 'PTHR11927:SF8', NULL, NULL, NULL, NULL, 'GALACTOSIDE 2-ALPHA-L-FUCOSYLTRANSFERASE SEC1', 247232),
(373405, 'PTHR11927:SF5', NULL, NULL, NULL, NULL, 'GALACTOSIDE 2-ALPHA-L-FUCOSYLTRANSFERASE SEC1', 247232),
(373406, 'PTHR11927:SF4', NULL, NULL, NULL, NULL, 'GALACTOSIDE ALPHA-(1,2)-FUCOSYLTRANSFERASE 1', 247232),
(373407, 'PTHR11927:SF2', NULL, NULL, NULL, NULL, 'GALACTOSIDE ALPHA-(1,2)-FUCOSYLTRANSFERASE 2', 247232),
(373408, 'PTHR11927', NULL, NULL, NULL, NULL, 'GALACTOSIDE 2-L-FUCOSYLTRANSFERASE', 247232),
(373409, 'PTHR35869', NULL, NULL, NULL, NULL, 'OUTER-MEMBRANE LIPOPROTEIN CARRIER PROTEIN', 247233),
(373410, 'PTHR35869:SF1', NULL, NULL, NULL, NULL, 'OUTER-MEMBRANE LIPOPROTEIN CARRIER PROTEIN', 247233),
(373411, 'PTHR43160', NULL, NULL, NULL, NULL, 'ACONITATE HYDRATASE B', 247234),
(373412, 'PTHR43160:SF3', NULL, NULL, NULL, NULL, 'ACONITATE HYDRATASE, MITOCHONDRIAL', 247234),
(373413, 'PTHR43160:SF4', NULL, NULL, NULL, NULL, 'ACONITATE HYDRATASE B', 247234);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(373414, 'PTHR43160:SF2', NULL, NULL, NULL, NULL, 'HOMOCITRATE DEHYDRATASE, MITOCHONDRIAL', 247234),
(373415, 'PTHR35538', NULL, NULL, NULL, NULL, 'LIG_CHAN-GLU_BD DOMAIN-CONTAINING PROTEIN', 247235),
(373416, 'PTHR35538:SF5', NULL, NULL, NULL, NULL, '', 247235),
(373417, 'PTHR35538:SF4', NULL, NULL, NULL, NULL, '', 247235),
(373418, 'PTHR35538:SF3', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 247235),
(373419, 'PTHR34538:SF20', NULL, NULL, NULL, NULL, '', 247236),
(373420, 'PTHR34538:SF10', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE DOMAIN-CONTAINING PROTEIN 2, PUTATIVE-RELATED', 247236),
(373421, 'PTHR34538', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247236),
(373422, 'PTHR34538:SF21', NULL, NULL, NULL, NULL, '', 247236),
(373423, 'PTHR34538:SF11', NULL, NULL, NULL, NULL, '', 247236),
(373424, 'PTHR34538:SF4', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247236),
(373425, 'PTHR34538:SF13', NULL, NULL, NULL, NULL, 'OS02G0637200 PROTEIN', 247236),
(373426, 'PTHR34538:SF18', NULL, NULL, NULL, NULL, 'OS07G0573000 PROTEIN', 247236),
(373427, 'PTHR34538:SF19', NULL, NULL, NULL, NULL, '', 247236),
(373428, 'PTHR15623:SF10', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED SERINE-RICH PROTEIN 2', 247237),
(373429, 'PTHR15623:SF8', NULL, NULL, NULL, NULL, 'SPATS2-LIKE PROTEIN', 247237),
(373430, 'PTHR15623', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED SERINE-RICH PROTEIN 2-RELATED', 247237),
(373431, 'PTHR15623:SF11', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS ASSOCIATED, SERINE RICH 2', 247237),
(373432, 'PTHR15107:SF0', NULL, NULL, NULL, NULL, 'COMPLETION OF MEIOTIC RECOMBINATION (BUDDING YEAST COM) RELATED', 247238),
(373433, 'PTHR15107:SF3', NULL, NULL, NULL, NULL, 'RBBP8 N-TERMINAL-LIKE PROTEIN', 247238),
(373434, 'PTHR15107:SF4', NULL, NULL, NULL, NULL, 'DNA ENDONUCLEASE RBBP8', 247238),
(373435, 'PTHR15107', NULL, NULL, NULL, NULL, 'RETINOBLASTOMA BINDING PROTEIN 8', 247238),
(373436, 'PTHR37950:SF1', NULL, NULL, NULL, NULL, '4-HYDROXYPHENYLACETATE CATABOLISM PROTEIN', 247239),
(373437, 'PTHR37950', NULL, NULL, NULL, NULL, '4-HYDROXYPHENYLACETATE CATABOLISM PROTEIN', 247239),
(373438, 'PTHR15141:SF7', NULL, NULL, NULL, NULL, 'ELONGIN-A2', 247240),
(373439, 'PTHR15141:SF76', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR B POLYPEPTIDE 3', 247240),
(373440, 'PTHR15141', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR B POLYPEPTIDE 3', 247240),
(373441, 'PTHR15141:SF49', NULL, NULL, NULL, NULL, 'ELONGIN A,-LIKE', 247240),
(373442, 'PTHR15141:SF75', NULL, NULL, NULL, NULL, 'ELONGIN-A', 247240),
(373443, 'PTHR15141:SF74', NULL, NULL, NULL, NULL, 'ELONGIN-A3-RELATED', 247240),
(373444, 'PTHR23129', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247241),
(373445, 'PTHR23129:SF0', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A DIPHOSPHATASE FITM2', 247241),
(373446, 'PTHR23129:SF1', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A DIPHOSPHATASE FITM2', 247241),
(373447, 'PTHR23129:SF3', NULL, NULL, NULL, NULL, 'FAT STORAGE-INDUCING TRANSMEMBRANE PROTEIN 1', 247241),
(373448, 'PTHR33357:SF3', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN-LIKE PROTEIN 3', 247242),
(373449, 'PTHR33357', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN-LIKE PROTEIN 3', 247242),
(373450, 'PTHR30590', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247243),
(373451, 'PTHR30590:SF3', NULL, NULL, NULL, NULL, 'HYPOTHETICAL MEMBRANE SPANNING PROTEIN', 247243),
(373452, 'PTHR30590:SF2', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', 247243),
(373453, 'PTHR46058:SF32', NULL, NULL, NULL, NULL, 'PROTEIN BREVIS RADIX-LIKE 4', 247244),
(373454, 'PTHR46058:SF21', NULL, NULL, NULL, NULL, 'BNAA08G07050D PROTEIN', 247244),
(373455, 'PTHR46058:SF31', NULL, NULL, NULL, NULL, 'PROTEIN BREVIS RADIX-LIKE 4', 247244),
(373456, 'PTHR46058:SF20', NULL, NULL, NULL, NULL, 'BNAA03G56110D PROTEIN', 247244),
(373457, 'PTHR46058:SF23', NULL, NULL, NULL, NULL, 'BNAA04G20570D PROTEIN', 247244),
(373458, 'PTHR46058:SF34', NULL, NULL, NULL, NULL, 'BREVIS RADIX (BRX) DOMAIN-CONTAINING PROTEIN-RELATED', 247244),
(373459, 'PTHR46058:SF22', NULL, NULL, NULL, NULL, 'BREVIS RADIX (BRX) DOMAIN-CONTAINING PROTEIN-RELATED', 247244);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(373460, 'PTHR46058:SF33', NULL, NULL, NULL, NULL, 'PROTEIN BREVIS RADIX-LIKE 1', 247244),
(373461, 'PTHR46058:SF11', NULL, NULL, NULL, NULL, 'PROTEIN BREVIS RADIX', 247244),
(373462, 'PTHR46058:SF36', NULL, NULL, NULL, NULL, 'PROTEIN BREVIS RADIX-LIKE', 247244),
(373463, 'PTHR46058:SF14', NULL, NULL, NULL, NULL, 'PROTEIN BREVIS RADIX-LIKE', 247244),
(373464, 'PTHR46058:SF25', NULL, NULL, NULL, NULL, 'BRX DOMAIN-CONTAINING PROTEIN', 247244),
(373465, 'PTHR46058:SF24', NULL, NULL, NULL, NULL, 'BNACNNG46630D PROTEIN', 247244),
(373466, 'PTHR46058:SF35', NULL, NULL, NULL, NULL, 'PROTEIN BREVIS RADIX-LIKE 2', 247244),
(373467, 'PTHR46058:SF16', NULL, NULL, NULL, NULL, 'PROTEIN BREVIS RADIX-LIKE 5-RELATED', 247244),
(373468, 'PTHR46058:SF26', NULL, NULL, NULL, NULL, 'BREVIS RADIX-LIKE PROTEIN-RELATED', 247244),
(373469, 'PTHR46058:SF15', NULL, NULL, NULL, NULL, 'PROTEIN BREVIS RADIX-LIKE 4', 247244),
(373470, 'PTHR46058', NULL, NULL, NULL, NULL, 'PROTEIN BREVIS RADIX-LIKE 1', 247244),
(373471, 'PTHR46058:SF4', NULL, NULL, NULL, NULL, 'OS04G0475250 PROTEIN', 247244),
(373472, 'PTHR46058:SF3', NULL, NULL, NULL, NULL, 'PROTEIN BREVIS RADIX-LIKE 4', 247244),
(373473, 'PTHR46058:SF2', NULL, NULL, NULL, NULL, 'PROTEIN BREVIS RADIX-LIKE 3', 247244),
(373474, 'PTHR46058:SF17', NULL, NULL, NULL, NULL, 'BNAA05G16600D PROTEIN', 247244),
(373475, 'PTHR46058:SF19', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BREVIS RADIX (BRX) DOMAIN-CONTAINING PROTEIN-RELATED', 247244),
(373476, 'PTHR13312:SF0', NULL, NULL, NULL, NULL, 'UBIQUITIN THIOESTERASE OTU1', 247245),
(373477, 'PTHR13312', NULL, NULL, NULL, NULL, 'HIV-INDUCED PROTEIN-7-LIKE PROTEASE', 247245),
(373478, 'PTHR13312:SF4', NULL, NULL, NULL, NULL, 'OTU DOMAIN-CONTAINING PROTEIN', 247245),
(373479, 'PTHR13312:SF3', NULL, NULL, NULL, NULL, 'OVARIAN TUMOR DOMAIN-CONTAINING DEUBIQUITINATING ENZYME 3', 247245),
(373480, 'PTHR20955:SF1', NULL, NULL, NULL, NULL, 'PROTEIN JAGUNAL HOMOLOG 1', 247246),
(373481, 'PTHR20955:SF3', NULL, NULL, NULL, NULL, 'PROTEIN JAGUNAL HOMOLOG 1-A', 247246),
(373482, 'PTHR20955:SF2', NULL, NULL, NULL, NULL, 'PROTEIN JAGUNAL HOMOLOG 1-B', 247246),
(373483, 'PTHR20955', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247246),
(373484, 'PTHR47686:SF1', NULL, NULL, NULL, NULL, 'CALCYCLIN-BINDING PROTEIN', 247247),
(373485, 'PTHR47686', NULL, NULL, NULL, NULL, 'SGS DOMAIN-CONTAINING PROTEIN', 247247),
(373486, 'PTHR36530:SF1', NULL, NULL, NULL, NULL, 'INHIBITOR OF CYSTEINE PEPTIDASE', 247248),
(373487, 'PTHR36530', NULL, NULL, NULL, NULL, 'INHIBITOR OF CYSTEINE PEPTIDASE', 247248),
(373488, 'PTHR31805:SF16', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN (DUF1421)', 247249),
(373489, 'PTHR31805:SF4', NULL, NULL, NULL, NULL, 'OS05G0561600 PROTEIN', 247249),
(373490, 'PTHR31805:SF27', NULL, NULL, NULL, NULL, 'WAS/WASL-INTERACTING PROTEIN FAMILY MEMBER 3-LIKE', 247249),
(373491, 'PTHR31805:SF26', NULL, NULL, NULL, NULL, 'OS01G0169900 PROTEIN', 247249),
(373492, 'PTHR31805:SF5', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 247249),
(373493, 'PTHR31805:SF15', NULL, NULL, NULL, NULL, 'DUF1421 DOMAIN-CONTAINING PROTEIN', 247249),
(373494, 'PTHR31805:SF29', NULL, NULL, NULL, NULL, 'DUF1421 DOMAIN-CONTAINING PROTEIN', 247249),
(373495, 'PTHR31805:SF28', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 27-LIKE', 247249),
(373496, 'PTHR31805', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE, PUTATIVE (DUF1421)-RELATED', 247249),
(373497, 'PTHR31805:SF14', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE, PUTATIVE (DUF1421)-RELATED', 247249),
(373498, 'PTHR31805:SF21', NULL, NULL, NULL, NULL, 'DUF1421 DOMAIN-CONTAINING PROTEIN', 247249),
(373499, 'PTHR31805:SF20', NULL, NULL, NULL, NULL, 'DUF1421 DOMAIN-CONTAINING PROTEIN', 247249),
(373500, 'PTHR44080:SF6', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 247250),
(373501, 'PTHR44080', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE COP1', 247250),
(373502, 'PTHR44080:SF7', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE COP1', 247250);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(373503, 'PTHR44080:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE COP1', 247250),
(373504, 'PTHR34550:SF4', NULL, NULL, NULL, NULL, 'BNAA09G43250D PROTEIN', 247251),
(373505, 'PTHR34550:SF3', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S31, MITOCHONDRIAL', 247251),
(373506, 'PTHR34550:SF2', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S31, CHLOROPLASTIC', 247251),
(373507, 'PTHR34550', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S31, CHLOROPLASTIC', 247251),
(373508, 'PTHR21456', NULL, NULL, NULL, NULL, 'FAMILY WITH SEQUENCE SIMILARITY 102', 247252),
(373509, 'PTHR21456:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM102A', 247252),
(373510, 'PTHR21456:SF1', NULL, NULL, NULL, NULL, 'C2 NT-TYPE DOMAIN-CONTAINING PROTEIN', 247252),
(373511, 'PTHR21456:SF3', NULL, NULL, NULL, NULL, 'PROTEIN FAM102B', 247252),
(373512, 'PTHR32254:SF14', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247253),
(373513, 'PTHR32254:SF17', NULL, NULL, NULL, NULL, '', 247253),
(373514, 'PTHR32254:SF22', NULL, NULL, NULL, NULL, 'BNAA08G12740D PROTEIN', 247253),
(373515, 'PTHR32254:SF21', NULL, NULL, NULL, NULL, '', 247253),
(373516, 'PTHR32254:SF13', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF1068)-RELATED', 247253),
(373517, 'PTHR32254:SF12', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247253),
(373518, 'PTHR32254:SF23', NULL, NULL, NULL, NULL, 'PLANT/T7A14-6 PROTEIN', 247253),
(373519, 'PTHR32254:SF3', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', 247253),
(373520, 'PTHR32254', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247253),
(373521, 'PTHR32254:SF5', NULL, NULL, NULL, NULL, 'CALCINEURIN-LIKE METALLO-PHOSPHOESTERASE SUPERFAMILY PROTEIN', 247253),
(373522, 'PTHR32254:SF6', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 247253),
(373523, 'PTHR35758', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 247254),
(373524, 'PTHR35758:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 247254),
(373525, 'PTHR35758:SF1', NULL, NULL, NULL, NULL, 'SERINE RICH PROTEIN', 247254),
(373526, 'PTHR35758:SF3', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 247254),
(373527, 'PTHR28202:SF1', NULL, NULL, NULL, NULL, 'ASSEMBLY FACTOR CBP4', 247255),
(373528, 'PTHR28202', NULL, NULL, NULL, NULL, 'ASSEMBLY FACTOR CBP4', 247255),
(373529, 'PTHR14021', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER CO-CHAPERONE PROTEIN HSCB', 247256),
(373530, 'PTHR14021:SF18', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 247256),
(373531, 'PTHR14021:SF15', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER CO-CHAPERONE PROTEIN HSCB', 247256),
(373532, 'PTHR11380', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID/SUPT3-RELATED', 247257),
(373533, 'PTHR11380:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 13', 247257),
(373534, 'PTHR11380:SF16', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION PROTEIN SPT3 HOMOLOG', 247257),
(373535, 'PTHR36131', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 8-1', 247258),
(373536, 'PTHR36131:SF1', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 8-1', 247258),
(373537, 'PTHR36131:SF2', NULL, NULL, NULL, NULL, '', 247258),
(373538, 'PTHR45085:SF7', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 247259),
(373539, 'PTHR45085:SF8', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 247259),
(373540, 'PTHR45085', NULL, NULL, NULL, NULL, 'F21J9.14', 247259),
(373541, 'PTHR45085:SF2', NULL, NULL, NULL, NULL, 'F21J9.14', 247259),
(373542, 'PTHR45085:SF5', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 247259),
(373543, 'PTHR45085:SF6', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 247259),
(373544, 'PTHR45085:SF3', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 247259),
(373545, 'PTHR45085:SF4', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASE SUPERFAMILY PROTEIN', 247259),
(373546, 'PTHR46469:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 8', 247260); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(373547, 'PTHR46469', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 8', 247260),
(373548, 'PTHR23518', NULL, NULL, NULL, NULL, 'C-METHYLTRANSFERASE', 247261),
(373549, 'PTHR23518:SF2', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY TRANSPORTER', 247261),
(373550, 'PTHR43763:SF4', NULL, NULL, NULL, NULL, 'XAA-PRO AMINOPEPTIDASE 2', 247262),
(373551, 'PTHR43763:SF12', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE P1', 247262),
(373552, 'PTHR43763:SF20', NULL, NULL, NULL, NULL, 'XAA-PRO AMINOPEPTIDASE APEPP', 247262),
(373553, 'PTHR43763:SF13', NULL, NULL, NULL, NULL, 'PROTEIN PID-5', 247262),
(373554, 'PTHR43763:SF19', NULL, NULL, NULL, NULL, 'BNAA08G15420D PROTEIN', 247262),
(373555, 'PTHR43763:SF9', NULL, NULL, NULL, NULL, 'XAA-PRO AMINOPEPTIDASE P ISOFORM X4-RELATED', 247262),
(373556, 'PTHR43763:SF17', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE P, CYTOPLASMIC-RELATED', 247262),
(373557, 'PTHR43763:SF6', NULL, NULL, NULL, NULL, 'XAA-PRO AMINOPEPTIDASE 1', 247262),
(373558, 'PTHR43763:SF18', NULL, NULL, NULL, NULL, '', 247262),
(373559, 'PTHR43763', NULL, NULL, NULL, NULL, 'XAA-PRO AMINOPEPTIDASE 1', 247262),
(373560, 'PTHR35451', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE-LIKE PROTEIN C4ORF48', 247263),
(373561, 'PTHR35451:SF1', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE-LIKE PROTEIN C4ORF48', 247263),
(373562, 'PTHR35451:SF2', NULL, NULL, NULL, NULL, 'CHROMOSOME 4 OPEN READING FRAME 48', 247263),
(373563, 'PTHR13234:SF70', NULL, NULL, NULL, NULL, 'GILT-LIKE PROTEIN C02D5.2', 247264),
(373564, 'PTHR13234:SF73', NULL, NULL, NULL, NULL, 'GILT-LIKE PROTEIN 2-RELATED', 247264),
(373565, 'PTHR13234:SF74', NULL, NULL, NULL, NULL, 'BNAC08G45100D PROTEIN', 247264),
(373566, 'PTHR13234:SF71', NULL, NULL, NULL, NULL, 'GAMMA-INTERFERON-INDUCIBLE LYSOSOMAL THIOL REDUCTASE-LIKE PROTEIN', 247264),
(373567, 'PTHR13234:SF60', NULL, NULL, NULL, NULL, 'BNAC05G04890D PROTEIN', 247264),
(373568, 'PTHR13234:SF72', NULL, NULL, NULL, NULL, 'GAMMA INTERFERON RESPONSIVE LYSOSOMAL THIOL (GILT) REDUCTASE FAMILY PROTEIN', 247264),
(373569, 'PTHR13234:SF11', NULL, NULL, NULL, NULL, 'PRION-LIKE-(Q/N-RICH)-DOMAIN-BEARING PROTEIN', 247264),
(373570, 'PTHR13234:SF55', NULL, NULL, NULL, NULL, 'BNAA04G07200D PROTEIN', 247264),
(373571, 'PTHR13234:SF45', NULL, NULL, NULL, NULL, 'SI:DKEY-197I20.6', 247264),
(373572, 'PTHR13234:SF64', NULL, NULL, NULL, NULL, 'GAMMA-INTERFERON-INDUCIBLE LYSOSOMAL THIOL REDUCTASE-LIKE', 247264),
(373573, 'PTHR13234:SF53', NULL, NULL, NULL, NULL, 'GAMMA INTERFERON RESPONSIVE LYSOSOMAL THIOL (GILT) REDUCTASE FAMILY PROTEIN-RELATED', 247264),
(373574, 'PTHR13234:SF65', NULL, NULL, NULL, NULL, '', 247264),
(373575, 'PTHR13234:SF43', NULL, NULL, NULL, NULL, 'GAMMA-INTERFERON-INDUCIBLE LYSOSOMAL THIOL REDUCTASE', 247264),
(373576, 'PTHR13234:SF54', NULL, NULL, NULL, NULL, 'OS01G0828200 PROTEIN', 247264),
(373577, 'PTHR13234:SF48', NULL, NULL, NULL, NULL, 'GAMMA INTERFERON RESPONSIVE LYSOSOMAL THIOL (GILT) REDUCTASE FAMILY PROTEIN', 247264),
(373578, 'PTHR13234:SF16', NULL, NULL, NULL, NULL, 'PROTEIN CBG03285', 247264),
(373579, 'PTHR13234:SF27', NULL, NULL, NULL, NULL, 'GAMMA INTERFERON INDUCIBLE LYSOSOMAL THIOL REDUCTASE', 247264),
(373580, 'PTHR13234:SF68', NULL, NULL, NULL, NULL, 'GH19763P', 247264),
(373581, 'PTHR13234:SF24', NULL, NULL, NULL, NULL, 'GILT-LIKE PROTEIN ZK669.3', 247264),
(373582, 'PTHR13234:SF25', NULL, NULL, NULL, NULL, 'PROTEIN CBG07974', 247264),
(373583, 'PTHR13234:SF14', NULL, NULL, NULL, NULL, 'PROTEIN CBG18077', 247264),
(373584, 'PTHR13234:SF69', NULL, NULL, NULL, NULL, 'GILT-LIKE PROTEIN 1', 247264),
(373585, 'PTHR13234:SF8', NULL, NULL, NULL, NULL, 'GAMMA-INTERFERON-INDUCIBLE LYSOSOMAL THIOL REDUCTASE', 247264),
(373586, 'PTHR13234', NULL, NULL, NULL, NULL, 'GAMMA-INTERFERON INDUCIBLE LYSOSOMAL THIOL REDUCTASE  GILT', 247264),
(373587, 'PTHR28090:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ROT1', 247265),
(373588, 'PTHR28090:SF2', NULL, NULL, NULL, NULL, 'PROTEIN ROT1', 247265),
(373589, 'PTHR28090', NULL, NULL, NULL, NULL, 'PROTEIN ROT1', 247265),
(373590, 'PTHR21737:SF19', NULL, NULL, NULL, NULL, 'BNAC05G02180D PROTEIN', 247266);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(373591, 'PTHR21737:SF18', NULL, NULL, NULL, NULL, 'OS04G0558200 PROTEIN', 247266),
(373592, 'PTHR21737', NULL, NULL, NULL, NULL, 'POLYGLUTAMINE BINDING PROTEIN 1/MARVEL  MEMBRANE-ASSOCIATING  DOMAIN CONTAINING 3', 247266),
(373593, 'PTHR21737:SF22', NULL, NULL, NULL, NULL, 'CACTUS-BINDING CARBOXY-TERMINAL, CACTIN PROTEIN', 247266),
(373594, 'PTHR21737:SF3', NULL, NULL, NULL, NULL, 'POLYGLUTAMINE-BINDING PROTEIN 1', 247266),
(373595, 'PTHR21737:SF4', NULL, NULL, NULL, NULL, 'CACTIN', 247266),
(373596, 'PTHR21737:SF21', NULL, NULL, NULL, NULL, 'MARVEL DOMAIN-CONTAINING 3', 247266),
(373597, 'PTHR21737:SF6', NULL, NULL, NULL, NULL, 'CACTIN', 247266),
(373598, 'PTHR46749', NULL, NULL, NULL, NULL, 'COMPLEX III ASSEMBLY FACTOR LYRM7', 247267),
(373599, 'PTHR46749:SF1', NULL, NULL, NULL, NULL, 'COMPLEX III ASSEMBLY FACTOR LYRM7', 247267),
(373600, 'PTHR46749:SF2', NULL, NULL, NULL, NULL, 'BNAA09G40160D PROTEIN', 247267),
(373601, 'PTHR42757:SF34', NULL, NULL, NULL, NULL, 'MAM DOMAIN CONTAINING GLYCOSYLPHOSPHATIDYLINOSITOL ANCHOR 2', 247268),
(373602, 'PTHR42757:SF12', NULL, NULL, NULL, NULL, 'IGLON FAMILY MEMBER 5', 247268),
(373603, 'PTHR42757', NULL, NULL, NULL, NULL, 'IGLON FAMILY OF IMMUNOGLOBULIN SUPERFAMILY-RELATED', 247268),
(373604, 'PTHR42757:SF22', NULL, NULL, NULL, NULL, 'LIMBIC SYSTEM-ASSOCIATED MEMBRANE PROTEIN', 247268),
(373605, 'PTHR42757:SF44', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 141', 247268),
(373606, 'PTHR42757:SF17', NULL, NULL, NULL, NULL, 'OPIOID-BINDING PROTEIN/CELL ADHESION MOLECULE', 247268),
(373607, 'PTHR42757:SF43', NULL, NULL, NULL, NULL, 'OBSCURIN, CYTOSKELETAL CALMODULIN AND TITIN-INTERACTING RHOGEF', 247268),
(373608, 'PTHR42757:SF32', NULL, NULL, NULL, NULL, 'PROTEIN AMALGAM', 247268),
(373609, 'PTHR42757:SF42', NULL, NULL, NULL, NULL, '', 247268),
(373610, 'PTHR42757:SF30', NULL, NULL, NULL, NULL, 'MAM DOMAIN-CONTAINING GLYCOSYLPHOSPHATIDYLINOSITOL ANCHOR PROTEIN 1', 247268),
(373611, 'PTHR42757:SF6', NULL, NULL, NULL, NULL, 'NEURONAL GROWTH REGULATOR 1', 247268),
(373612, 'PTHR42757:SF41', NULL, NULL, NULL, NULL, 'NEUROTRIMIN', 247268),
(373613, 'PTHR42757:SF40', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 247268),
(373614, 'PTHR42757:SF9', NULL, NULL, NULL, NULL, 'NEUROTRIMIN', 247268),
(373615, 'PTHR12301:SF5', NULL, NULL, NULL, NULL, 'SAM AND SH3 DOMAIN-CONTAINING PROTEIN 3', 247269),
(373616, 'PTHR12301:SF4', NULL, NULL, NULL, NULL, 'SAM DOMAIN-CONTAINING PROTEIN SAMSN-1', 247269),
(373617, 'PTHR12301:SF3', NULL, NULL, NULL, NULL, 'SAM AND SH3 DOMAIN-CONTAINING PROTEIN 1', 247269),
(373618, 'PTHR12301', NULL, NULL, NULL, NULL, 'SAM-DOMAIN, SH3 AND NUCLEAR LOCALIZATION SIGNALS PROTEIN RELATED', 247269),
(373619, 'PTHR12301:SF10', NULL, NULL, NULL, NULL, '', 247269),
(373620, 'PTHR12301:SF8', NULL, NULL, NULL, NULL, 'STERILE ALPHA MOTIF DOMAIN-CONTAINING PROTEIN 5', 247269),
(373621, 'PTHR47923', NULL, NULL, NULL, NULL, 'INSERTION ELEMENT IS1 1 PROTEIN INSA-RELATED', 247270),
(373622, 'PTHR47923:SF1', NULL, NULL, NULL, NULL, 'INSERTION ELEMENT IS1 1 PROTEIN INSA-RELATED', 247270),
(373623, 'PTHR11632:SF86', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE1', 247271),
(373624, 'PTHR11632:SF53', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE FLAVOPROTEIN SUBUNIT', 247271),
(373625, 'PTHR11632:SF87', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE [UBIQUINONE] FLAVOPROTEIN SUBUNIT, MITOCHONDRIAL', 247271),
(373626, 'PTHR11632:SF82', NULL, NULL, NULL, NULL, 'FUMARATE REDUCTASE FLAVOPROTEIN SUBUNIT', 247271),
(373627, 'PTHR11632:SF71', NULL, NULL, NULL, NULL, 'FUMARATE REDUCTASE FLAVOPROTEIN SUBUNIT', 247271),
(373628, 'PTHR11632:SF72', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE [UBIQUINONE] FLAVOPROTEIN SUBUNIT 2, MITOCHONDRIAL', 247271),
(373629, 'PTHR11632:SF84', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE [UBIQUINONE] FLAVOPROTEIN SUBUNIT, MITOCHONDRIAL', 247271),
(373630, 'PTHR11632:SF73', NULL, NULL, NULL, NULL, 'BLR3196 PROTEIN', 247271),
(373631, 'PTHR11632:SF51', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE [UBIQUINONE] FLAVOPROTEIN SUBUNIT, MITOCHONDRIAL', 247271); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(373632, 'PTHR11632', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE 2 FLAVOPROTEIN SUBUNIT', 247271),
(373633, 'PTHR11632:SF37', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE [UBIQUINONE] FLAVOPROTEIN SUBUNIT, MITOCHONDRIAL', 247271),
(373634, 'PTHR15635:SF10', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 9B', 247272),
(373635, 'PTHR15635:SF11', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 9', 247272),
(373636, 'PTHR15635', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN CONTAINING PROTEIN 9', 247272),
(373637, 'PTHR15635:SF12', NULL, NULL, NULL, NULL, 'PROTEIN CBG06763', 247272),
(373638, 'PTHR13612', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247273),
(373639, 'PTHR13612:SF0', NULL, NULL, NULL, NULL, 'ENHANCER OF MRNA-DECAPPING PROTEIN 3', 247273),
(373640, 'PTHR37417', NULL, NULL, NULL, NULL, '67 KDA MYOSIN-CROSS-REACTIVE ANTIGEN FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_5G09970)', 247274),
(373641, 'PTHR37417:SF4', NULL, NULL, NULL, NULL, '67 KDA MYOSIN-CROSS-REACTIVE ANTIGEN FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_3G03570)', 247274),
(373642, 'PTHR37417:SF3', NULL, NULL, NULL, NULL, 'MYOSIN-CROSSREACTIVE PROTEIN-RELATED', 247274),
(373643, 'PTHR37417:SF2', NULL, NULL, NULL, NULL, '67 KDA MYOSIN-CROSS-REACTIVE ANTIGEN FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_5G09970)', 247274),
(373644, 'PTHR37166:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FLAG', 247275),
(373645, 'PTHR37166', NULL, NULL, NULL, NULL, 'PROTEIN FLAG', 247275),
(373646, 'PTHR12874:SF28', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247276),
(373647, 'PTHR12874:SF16', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247276),
(373648, 'PTHR12874:SF27', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN-RELATED', 247276),
(373649, 'PTHR12874:SF18', NULL, NULL, NULL, NULL, 'BNAA09G41530D PROTEIN', 247276),
(373650, 'PTHR12874:SF24', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 48', 247276),
(373651, 'PTHR12874:SF23', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN GID2', 247276),
(373652, 'PTHR12874:SF26', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247276),
(373653, 'PTHR12874:SF20', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247276),
(373654, 'PTHR12874:SF9', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 9', 247276),
(373655, 'PTHR12874', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 48-RELATED', 247276),
(373656, 'PTHR31431:SF1', NULL, NULL, NULL, NULL, 'NUCLEOPORIN NUP188', 247277),
(373657, 'PTHR31431', NULL, NULL, NULL, NULL, 'NUCLEOPORIN NUP188 HOMOLOG', 247277),
(373658, 'PTHR43021:SF2', NULL, NULL, NULL, NULL, 'NA_H_EXCHANGER DOMAIN-CONTAINING PROTEIN', 247278),
(373659, 'PTHR43021', NULL, NULL, NULL, NULL, 'NA(+)/H(+) ANTIPORTER-RELATED', 247278),
(373660, 'PTHR45283', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT T, CHLOROPLASTIC', 247279),
(373661, 'PTHR45283:SF1', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT T, CHLOROPLASTIC', 247279),
(373662, 'PTHR11581:SF8', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S4, Y ISOFORM 1', 247280),
(373663, 'PTHR11581:SF7', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S4, Y ISOFORM 2', 247280),
(373664, 'PTHR11581:SF19', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S4', 247280),
(373665, 'PTHR11581:SF18', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S4', 247280),
(373666, 'PTHR11581:SF29', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S4', 247280),
(373667, 'PTHR11581:SF15', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S4', 247280),
(373668, 'PTHR11581:SF0', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S4-RELATED', 247280),
(373669, 'PTHR11581:SF37', NULL, NULL, NULL, NULL, '', 247280),
(373670, 'PTHR11581:SF36', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S4', 247280),
(373671, 'PTHR11581:SF39', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S4', 247280),
(373672, 'PTHR11581:SF16', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S4', 247280),
(373673, 'PTHR11581:SF27', NULL, NULL, NULL, NULL, 'S4 RNA-BINDING DOMAIN-CONTAINING PROTEIN', 247280),
(373674, 'PTHR11581:SF35', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S4, X ISOFORM', 247280);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(373675, 'PTHR11581:SF23', NULL, NULL, NULL, NULL, 'S4 RNA-BINDING DOMAIN-CONTAINING PROTEIN', 247280),
(373676, 'PTHR11581:SF40', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S4', 247280),
(373677, 'PTHR11581:SF31', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S4', 247280),
(373678, 'PTHR11581:SF41', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S4', 247280),
(373679, 'PTHR11581', NULL, NULL, NULL, NULL, '30S/40S RIBOSOMAL PROTEIN S4', 247280),
(373680, 'PTHR42973:SF13', NULL, NULL, NULL, NULL, 'DEPENDENT OXIDOREDUCTASE, PUTATIVE-RELATED', 247281),
(373681, 'PTHR42973:SF46', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 247281),
(373682, 'PTHR42973:SF47', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 247281),
(373683, 'PTHR42973:SF25', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 247281),
(373684, 'PTHR42973:SF14', NULL, NULL, NULL, NULL, 'FAD-LINKED OXIDOREDUCTASE DDB_G0289697', 247281),
(373685, 'PTHR42973:SF22', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', 247281),
(373686, 'PTHR42973:SF44', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 247281),
(373687, 'PTHR42973:SF34', NULL, NULL, NULL, NULL, 'FAD BINDING DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_3G02770)', 247281),
(373688, 'PTHR42973:SF32', NULL, NULL, NULL, NULL, 'FAD-LINKED OXIDOREDUCTASE AFOF', 247281),
(373689, 'PTHR42973:SF51', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 247281),
(373690, 'PTHR42973:SF52', NULL, NULL, NULL, NULL, 'FAD BINDING DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_2G00730)-RELATED', 247281),
(373691, 'PTHR42973:SF8', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 247281),
(373692, 'PTHR42973:SF9', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', 247281),
(373693, 'PTHR42973:SF17', NULL, NULL, NULL, NULL, 'OXIDASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G14340)-RELATED', 247281),
(373694, 'PTHR42973:SF39', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 247281),
(373695, 'PTHR42973:SF28', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 247281),
(373696, 'PTHR42973:SF7', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 247281),
(373697, 'PTHR42973', NULL, NULL, NULL, NULL, 'BINDING OXIDOREDUCTASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G17690)-RELATED', 247281),
(373698, 'PTHR42973:SF15', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 247281),
(373699, 'PTHR42973:SF4', NULL, NULL, NULL, NULL, 'FAD BINDING DOMAIN PROTEIN', 247281),
(373700, 'PTHR42973:SF48', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 247281),
(373701, 'PTHR42973:SF27', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', 247281),
(373702, 'PTHR42973:SF49', NULL, NULL, NULL, NULL, 'BINDING OXIDOREDUCTASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G17690)-RELATED', 247281),
(373703, 'PTHR42973:SF50', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 247281),
(373704, 'PTHR31310:SF16', NULL, NULL, NULL, NULL, '', 247282),
(373705, 'PTHR31310:SF8', NULL, NULL, NULL, NULL, 'INOSITOLPHOSPHOTRANSFERASE 1', 247282),
(373706, 'PTHR31310:SF11', NULL, NULL, NULL, NULL, 'INOSITOL PHOSPHORYLCERAMIDE SYNTHASE CATALYTIC SUBUNIT AUR1', 247282),
(373707, 'PTHR31310:SF10', NULL, NULL, NULL, NULL, '', 247282),
(373708, 'PTHR31310:SF7', NULL, NULL, NULL, NULL, 'PA-PHOSPHATASE RELATED-FAMILY PROTEIN DDB_G0268928', 247282),
(373709, 'PTHR31310', NULL, NULL, NULL, NULL, '', 247282),
(373710, 'PTHR10664:SF35', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS BC (CLASS B-LIKE)', 247283),
(373711, 'PTHR10664:SF36', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS BC (CLASS B-LIKE)', 247283),
(373712, 'PTHR10664:SF31', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS BC (CLASS B-LIKE)', 247283),
(373713, 'PTHR10664:SF20', NULL, NULL, NULL, NULL, 'PROTEIN CBG01292', 247283);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(373714, 'PTHR10664:SF42', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS BC (CLASS B-LIKE)', 247283),
(373715, 'PTHR10664:SF2', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS BC (CLASS B-LIKE)', 247283),
(373716, 'PTHR10664:SF22', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS BC (CLASS B-LIKE)', 247283),
(373717, 'PTHR10664', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR-C.ELEGANS', 247283),
(373718, 'PTHR22591', NULL, NULL, NULL, NULL, 'XIN', 247284),
(373719, 'PTHR22591:SF1', NULL, NULL, NULL, NULL, 'XIN ACTIN-BINDING REPEAT-CONTAINING PROTEIN 2', 247284),
(373720, 'PTHR22591:SF3', NULL, NULL, NULL, NULL, 'XIN ACTIN-BINDING REPEAT-CONTAINING 2B', 247284),
(373721, 'PTHR22591:SF2', NULL, NULL, NULL, NULL, 'XIN ACTIN-BINDING REPEAT-CONTAINING PROTEIN 1', 247284),
(373722, 'PTHR42909', NULL, NULL, NULL, NULL, 'ZGC:136858', 247285),
(373723, 'PTHR42909:SF1', NULL, NULL, NULL, NULL, 'PFKB DOMAIN-CONTAINING PROTEIN', 247285),
(373724, 'PTHR42909:SF3', NULL, NULL, NULL, NULL, 'BNAA06G02750D PROTEIN', 247285),
(373725, 'PTHR42909:SF4', NULL, NULL, NULL, NULL, 'CARBOHYDRATE KINASE, PFKB FAMILY', 247285),
(373726, 'PTHR35864:SF1', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEASE YWHC-RELATED', 247286),
(373727, 'PTHR35864', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEASE MJ0611-RELATED', 247286),
(373728, 'PTHR30405:SF20', NULL, NULL, NULL, NULL, 'FIRST ORF IN TRANSPOSON ISC1316', 247287),
(373729, 'PTHR30405:SF21', NULL, NULL, NULL, NULL, 'ORFB_ZN_RIBBON DOMAIN-CONTAINING PROTEIN', 247287),
(373730, 'PTHR30405:SF11', NULL, NULL, NULL, NULL, 'TRANSPOSASE INSQ FOR INSERTION SEQUENCE ELEMENT IS609-RELATED', 247287),
(373731, 'PTHR30405:SF22', NULL, NULL, NULL, NULL, 'TRANSPOSASE MJ0751-RELATED', 247287),
(373732, 'PTHR30405', NULL, NULL, NULL, NULL, 'TRANSPOSASE', 247287),
(373733, 'PTHR30405:SF23', NULL, NULL, NULL, NULL, 'ORF IN PARTIAL TRANSPOSON ISC1913', 247287),
(373734, 'PTHR30405:SF24', NULL, NULL, NULL, NULL, 'TRANSPOSASE MJ1635-RELATED', 247287),
(373735, 'PTHR22546', NULL, NULL, NULL, NULL, 'PREMATURE OVARIAN FAILURE, 1B', 247288),
(373736, 'PTHR22546:SF0', NULL, NULL, NULL, NULL, 'PROTEIN POF1B', 247288),
(373737, 'PTHR15018', NULL, NULL, NULL, NULL, 'BCL-2-INTERACTING KILLER', 247289),
(373738, 'PTHR15018:SF1', NULL, NULL, NULL, NULL, 'BCL-2-INTERACTING KILLER', 247289),
(373739, 'PTHR24200:SF11', NULL, NULL, NULL, NULL, 'TOUCAN, ISOFORM A', 247290),
(373740, 'PTHR24200:SF7', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED TUMOR SUPPRESSOR 1', 247290),
(373741, 'PTHR24200:SF6', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 69', 247290),
(373742, 'PTHR24200:SF14', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED TUMOR SUPPRESSOR CANDIDATE 2', 247290),
(373743, 'PTHR24200', NULL, NULL, NULL, NULL, 'TOUCAN, ISOFORM A', 247290),
(373744, 'PTHR13213:SF2', NULL, NULL, NULL, NULL, 'MYB-BINDING PROTEIN 1A', 247291),
(373745, 'PTHR13213', NULL, NULL, NULL, NULL, 'MYB-BINDING PROTEIN 1A FAMILY MEMBER', 247291),
(373746, 'PTHR14015:SF2', NULL, NULL, NULL, NULL, 'OGFR_N DOMAIN-CONTAINING PROTEIN', 247292),
(373747, 'PTHR14015:SF0', NULL, NULL, NULL, NULL, 'OPIOID GROWTH FACTOR RECEPTOR-LIKE PROTEIN 1', 247292),
(373748, 'PTHR14015', NULL, NULL, NULL, NULL, 'OPIOID GROWTH FACTOR RECEPTOR  OGFR   ZETA-TYPE OPIOID RECEPTOR', 247292),
(373749, 'PTHR14015:SF1', NULL, NULL, NULL, NULL, 'OPIOID GROWTH FACTOR RECEPTOR', 247292),
(373750, 'PTHR46761:SF2', NULL, NULL, NULL, NULL, 'RAN GTPASE-ACTIVATING PROTEIN 1', 247293),
(373751, 'PTHR46761:SF7', NULL, NULL, NULL, NULL, 'WPP DOMAIN, LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 247293),
(373752, 'PTHR46761', NULL, NULL, NULL, NULL, 'RAN GTPASE-ACTIVATING PROTEIN 1', 247293),
(373753, 'PTHR46761:SF4', NULL, NULL, NULL, NULL, 'WPP DOMAIN-CONTAINING PROTEIN', 247293),
(373754, 'PTHR46761:SF3', NULL, NULL, NULL, NULL, 'BNAA05G31290D PROTEIN', 247293),
(373755, 'PTHR46761:SF5', NULL, NULL, NULL, NULL, 'RAN GTPASE-ACTIVATING PROTEIN 2', 247293),
(373756, 'PTHR13048:SF0', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT', 247294);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(373757, 'PTHR13048:SF2', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT 3', 247294),
(373758, 'PTHR13048', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT 3', 247294),
(373759, 'PTHR13048:SF1', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT 3-LIKE PROTEIN', 247294),
(373760, 'PTHR13048:SF5', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT', 247294),
(373761, 'PTHR10350', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP155', 247295),
(373762, 'PTHR10350:SF7', NULL, NULL, NULL, NULL, 'BNAC05G49530D PROTEIN', 247295),
(373763, 'PTHR10350:SF6', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP155', 247295),
(373764, 'PTHR12573:SF4', NULL, NULL, NULL, NULL, 'AT09986P-RELATED', 247296),
(373765, 'PTHR12573', NULL, NULL, NULL, NULL, 'AT09986P-RELATED', 247296),
(373766, 'PTHR11588:SF370', NULL, NULL, NULL, NULL, 'PEROXIDASE', 247297),
(373767, 'PTHR11588:SF79', NULL, NULL, NULL, NULL, 'TUBULIN GAMMA-2 CHAIN', 247297),
(373768, 'PTHR11588:SF253', NULL, NULL, NULL, NULL, 'TUBULIN BETA-4A CHAIN', 247297),
(373769, 'PTHR11588:SF78', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373770, 'PTHR11588:SF133', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA-1A CHAIN', 247297),
(373771, 'PTHR11588:SF251', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA-1B CHAIN', 247297),
(373772, 'PTHR11588:SF75', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373773, 'PTHR11588:SF410', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA-2 CHAIN', 247297),
(373774, 'PTHR11588:SF416', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373775, 'PTHR11588:SF413', NULL, NULL, NULL, NULL, 'TUBULIN BETA CHAIN', 247297),
(373776, 'PTHR11588:SF414', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373777, 'PTHR11588:SF417', NULL, NULL, NULL, NULL, 'AT04270P-RELATED', 247297),
(373778, 'PTHR11588:SF480', NULL, NULL, NULL, NULL, 'TUBULIN BETA-2 CHAIN', 247297),
(373779, 'PTHR11588:SF481', NULL, NULL, NULL, NULL, 'TUBULIN BETA CHAIN', 247297),
(373780, 'PTHR11588:SF89', NULL, NULL, NULL, NULL, 'TUBULIN BETA CHAIN', 247297),
(373781, 'PTHR11588:SF363', NULL, NULL, NULL, NULL, 'TUBULIN BETA CHAIN', 247297),
(373782, 'PTHR11588:SF88', NULL, NULL, NULL, NULL, 'TUBULIN BETA-6 CHAIN', 247297),
(373783, 'PTHR11588:SF362', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373784, 'PTHR11588:SF368', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373785, 'PTHR11588:SF247', NULL, NULL, NULL, NULL, 'TUBULIN BETA-4B CHAIN', 247297),
(373786, 'PTHR11588:SF124', NULL, NULL, NULL, NULL, 'TUBULIN BETA-7 CHAIN', 247297),
(373787, 'PTHR11588:SF82', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373788, 'PTHR11588:SF369', NULL, NULL, NULL, NULL, 'TUBULIN BETA CHAIN', 247297),
(373789, 'PTHR11588:SF402', NULL, NULL, NULL, NULL, 'TUBULIN BETA CHAIN', 247297),
(373790, 'PTHR11588:SF403', NULL, NULL, NULL, NULL, 'TUBULIN BETA-4 CHAIN', 247297),
(373791, 'PTHR11588:SF407', NULL, NULL, NULL, NULL, 'TUBULIN BETA-6 CHAIN', 247297),
(373792, 'PTHR11588', NULL, NULL, NULL, NULL, 'TUBULIN', 247297),
(373793, 'PTHR11588:SF470', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA-2 CHAIN', 247297),
(373794, 'PTHR11588:SF13', NULL, NULL, NULL, NULL, 'TUBULIN EPSILON CHAIN', 247297),
(373795, 'PTHR11588:SF473', NULL, NULL, NULL, NULL, 'TUBULIN BETA CHAIN', 247297),
(373796, 'PTHR11588:SF352', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373797, 'PTHR11588:SF474', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373798, 'PTHR11588:SF350', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373799, 'PTHR11588:SF471', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373800, 'PTHR11588:SF472', NULL, NULL, NULL, NULL, 'TUBULIN BETA CHAIN', 247297),
(373801, 'PTHR11588:SF477', NULL, NULL, NULL, NULL, 'TUBULIN BETA-1 CHAIN', 247297),
(373802, 'PTHR11588:SF357', NULL, NULL, NULL, NULL, 'TUBULIN BETA CHAIN-RELATED', 247297),
(373803, 'PTHR11588:SF478', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373804, 'PTHR11588:SF354', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA-8 CHAIN', 247297);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(373805, 'PTHR11588:SF475', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373806, 'PTHR11588:SF112', NULL, NULL, NULL, NULL, 'TUBULIN BETA-1 CHAIN', 247297),
(373807, 'PTHR11588:SF113', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA-3D CHAIN', 247297),
(373808, 'PTHR11588:SF476', NULL, NULL, NULL, NULL, 'TUBULIN_C DOMAIN-CONTAINING PROTEIN', 247297),
(373809, 'PTHR11588:SF239', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA-4 CHAIN', 247297),
(373810, 'PTHR11588:SF479', NULL, NULL, NULL, NULL, 'TUBULIN BETA CHAIN', 247297),
(373811, 'PTHR11588:SF116', NULL, NULL, NULL, NULL, 'TUBULIN BETA-1 CHAIN-RELATED', 247297),
(373812, 'PTHR11588:SF359', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373813, 'PTHR11588:SF6', NULL, NULL, NULL, NULL, 'RICIN B-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 247297),
(373814, 'PTHR11588:SF7', NULL, NULL, NULL, NULL, 'TUBULIN GAMMA CHAIN', 247297),
(373815, 'PTHR11588:SF182', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373816, 'PTHR11588:SF462', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373817, 'PTHR11588:SF100', NULL, NULL, NULL, NULL, 'TUBULIN BETA-2A CHAIN', 247297),
(373818, 'PTHR11588:SF463', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373819, 'PTHR11588:SF460', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA-3 CHAIN', 247297),
(373820, 'PTHR11588:SF461', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373821, 'PTHR11588:SF466', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373822, 'PTHR11588:SF467', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373823, 'PTHR11588:SF346', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373824, 'PTHR11588:SF464', NULL, NULL, NULL, NULL, 'TUBULIN BETA CHAIN', 247297),
(373825, 'PTHR11588:SF465', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373826, 'PTHR11588:SF349', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373827, 'PTHR11588:SF468', NULL, NULL, NULL, NULL, 'TUBULIN BETA CHAIN', 247297),
(373828, 'PTHR11588:SF469', NULL, NULL, NULL, NULL, 'TUBULIN BETA CHAIN', 247297),
(373829, 'PTHR11588:SF106', NULL, NULL, NULL, NULL, 'TUBULIN BETA CHAIN', 247297),
(373830, 'PTHR11588:SF4', NULL, NULL, NULL, NULL, 'TUBULIN DELTA CHAIN', 247297),
(373831, 'PTHR11588:SF291', NULL, NULL, NULL, NULL, 'TUBULIN BETA-2 CHAIN', 247297),
(373832, 'PTHR11588:SF292', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373833, 'PTHR11588:SF451', NULL, NULL, NULL, NULL, 'TUBULIN BETA CHAIN', 247297),
(373834, 'PTHR11588:SF330', NULL, NULL, NULL, NULL, 'TUBULIN BETA-2B CHAIN', 247297),
(373835, 'PTHR11588:SF452', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA-2 CHAIN', 247297),
(373836, 'PTHR11588:SF298', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA-1C CHAIN', 247297),
(373837, 'PTHR11588:SF450', NULL, NULL, NULL, NULL, 'TUBULIN BETA CHAIN', 247297),
(373838, 'PTHR11588:SF334', NULL, NULL, NULL, NULL, 'TUBULIN BETA-8 CHAIN', 247297),
(373839, 'PTHR11588:SF455', NULL, NULL, NULL, NULL, 'TUBULIN BETA CHAIN', 247297),
(373840, 'PTHR11588:SF456', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373841, 'PTHR11588:SF453', NULL, NULL, NULL, NULL, 'TUBULIN BETA-2 CHAIN', 247297),
(373842, 'PTHR11588:SF454', NULL, NULL, NULL, NULL, 'TUBULIN BETA CHAIN', 247297),
(373843, 'PTHR11588:SF459', NULL, NULL, NULL, NULL, 'DELTA-TUBULIN', 247297),
(373844, 'PTHR11588:SF457', NULL, NULL, NULL, NULL, 'TUBULIN BETA CHAIN', 247297),
(373845, 'PTHR11588:SF336', NULL, NULL, NULL, NULL, 'TUBULIN BETA CHAIN', 247297),
(373846, 'PTHR11588:SF458', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373847, 'PTHR11588:SF48', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA-5 CHAIN', 247297),
(373848, 'PTHR11588:SF280', NULL, NULL, NULL, NULL, 'TUBULIN BETA-6 CHAIN', 247297),
(373849, 'PTHR11588:SF440', NULL, NULL, NULL, NULL, 'TUBULIN BETA CHAIN', 247297),
(373850, 'PTHR11588:SF43', NULL, NULL, NULL, NULL, 'TUBULIN BETA-3 CHAIN', 247297),
(373851, 'PTHR11588:SF444', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA-1 CHAIN', 247297),
(373852, 'PTHR11588:SF443', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA-6 CHAIN', 247297);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(373853, 'PTHR11588:SF322', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA-3C CHAIN-RELATED', 247297),
(373854, 'PTHR11588:SF448', NULL, NULL, NULL, NULL, 'TUBULIN BETA-1 CHAIN', 247297),
(373855, 'PTHR11588:SF449', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA-2 CHAIN', 247297),
(373856, 'PTHR11588:SF328', NULL, NULL, NULL, NULL, 'TUBULIN DOMAIN-CONTAINING PROTEIN', 247297),
(373857, 'PTHR11588:SF326', NULL, NULL, NULL, NULL, 'TUBULIN BETA CHAIN', 247297),
(373858, 'PTHR11588:SF390', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373859, 'PTHR11588:SF396', NULL, NULL, NULL, NULL, 'TUBULIN BETA CHAIN', 247297),
(373860, 'PTHR11588:SF430', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373861, 'PTHR11588:SF55', NULL, NULL, NULL, NULL, 'TUBULIN BETA 8B-RELATED', 247297),
(373862, 'PTHR11588:SF273', NULL, NULL, NULL, NULL, 'TUBULIN BETA-3 CHAIN-RELATED', 247297),
(373863, 'PTHR11588:SF53', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA-4A CHAIN', 247297),
(373864, 'PTHR11588:SF312', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA-2 CHAIN', 247297),
(373865, 'PTHR11588:SF310', NULL, NULL, NULL, NULL, 'TUBULIN BETA CHAIN', 247297),
(373866, 'PTHR11588:SF431', NULL, NULL, NULL, NULL, 'TUBULIN BETA-1 CHAIN', 247297),
(373867, 'PTHR11588:SF278', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN-LIKE 3', 247297),
(373868, 'PTHR11588:SF438', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373869, 'PTHR11588:SF317', NULL, NULL, NULL, NULL, 'TUBULIN EPSILON CHAIN', 247297),
(373870, 'PTHR11588:SF435', NULL, NULL, NULL, NULL, 'TUBULIN BETA CHAIN', 247297),
(373871, 'PTHR11588:SF381', NULL, NULL, NULL, NULL, 'TUBULIN GAMMA CHAIN', 247297),
(373872, 'PTHR11588:SF140', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA-8 CHAIN-RELATED', 247297),
(373873, 'PTHR11588:SF380', NULL, NULL, NULL, NULL, 'TUBULIN BETA CHAIN', 247297),
(373874, 'PTHR11588:SF386', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373875, 'PTHR11588:SF384', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373876, 'PTHR11588:SF301', NULL, NULL, NULL, NULL, 'TUBULIN BETA-7 CHAIN', 247297),
(373877, 'PTHR11588:SF62', NULL, NULL, NULL, NULL, 'TUBULIN GAMMA-1 CHAIN', 247297),
(373878, 'PTHR11588:SF61', NULL, NULL, NULL, NULL, 'TUBULIN BETA CHAIN', 247297),
(373879, 'PTHR11588:SF306', NULL, NULL, NULL, NULL, 'TUBULIN BETA-8 CHAIN', 247297),
(373880, 'PTHR11588:SF424', NULL, NULL, NULL, NULL, 'TUBULIN BETA-9 CHAIN', 247297),
(373881, 'PTHR11588:SF425', NULL, NULL, NULL, NULL, 'TUBULIN ALPHA CHAIN', 247297),
(373882, 'PTHR11588:SF309', NULL, NULL, NULL, NULL, 'TUBULIN BETA CHAIN', 247297),
(373883, 'PTHR11588:SF428', NULL, NULL, NULL, NULL, 'TUBULIN BETA-7 CHAIN', 247297),
(373884, 'PTHR11588:SF429', NULL, NULL, NULL, NULL, 'TUBULIN BETA-1 CHAIN-RELATED', 247297),
(373885, 'PTHR38589:SF1', NULL, NULL, NULL, NULL, 'YKUD DOMAIN-CONTAINING PROTEIN', 247298),
(373886, 'PTHR38589', NULL, NULL, NULL, NULL, 'BLR0621 PROTEIN', 247298),
(373887, 'PTHR19265:SF0', NULL, NULL, NULL, NULL, 'MEIOSIS-SPECIFIC NUCLEAR STRUCTURAL PROTEIN 1', 247299),
(373888, 'PTHR19265', NULL, NULL, NULL, NULL, 'MEIOSIS-SPECIFIC NUCLEAR STRUCTURAL PROTEIN 1', 247299),
(373889, 'PTHR46179:SF23', NULL, NULL, NULL, NULL, 'SI:DKEY-208K4.2', 247300),
(373890, 'PTHR46179:SF22', NULL, NULL, NULL, NULL, 'FINGER DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G05010)-RELATED', 247300),
(373891, 'PTHR46179:SF11', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ZFP91', 247300),
(373892, 'PTHR46179:SF21', NULL, NULL, NULL, NULL, 'ZINC FINGER X-LINKED PROTEIN ZXDB', 247300),
(373893, 'PTHR46179:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR IIIA', 247300),
(373894, 'PTHR46179:SF20', NULL, NULL, NULL, NULL, 'FINGER PUTATIVE TRANSCRIPTION FACTOR FAMILY-RELATED', 247300),
(373895, 'PTHR46179:SF15', NULL, NULL, NULL, NULL, '', 247300),
(373896, 'PTHR46179:SF25', NULL, NULL, NULL, NULL, 'METAL RESPONSE ELEMENT-BINDING TRANSCRIPTION FACTOR-1, ISOFORM C', 247300),
(373897, 'PTHR46179:SF13', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 423 HOMOLOG', 247300),
(373898, 'PTHR46179:SF24', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 247300);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(373899, 'PTHR46179:SF6', NULL, NULL, NULL, NULL, 'ZINC FINGER X-LINKED PROTEIN ZXDA', 247300),
(373900, 'PTHR46179:SF9', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 653', 247300),
(373901, 'PTHR46179', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 247300),
(373902, 'PTHR46179:SF3', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 410', 247300),
(373903, 'PTHR46179:SF5', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZXDC', 247300),
(373904, 'PTHR46179:SF19', NULL, NULL, NULL, NULL, 'C2H2 TRANSCRIPTION FACTOR', 247300),
(373905, 'PTHR43359', NULL, NULL, NULL, NULL, 'FORMATE HYDROGENLYASE SUBUNIT 4', 247301),
(373906, 'PTHR43359:SF1', NULL, NULL, NULL, NULL, 'FORMATE HYDROGENLYASE SUBUNIT 4-RELATED', 247301),
(373907, 'PTHR47845', NULL, NULL, NULL, NULL, 'NUCLEAR SPECKLE SPLICING REGULATORY PROTEIN 1 HOMOLOG', 247302),
(373908, 'PTHR47845:SF1', NULL, NULL, NULL, NULL, 'NUCLEAR SPECKLE SPLICING REGULATORY PROTEIN 1 HOMOLOG', 247302),
(373909, 'PTHR33541:SF30', NULL, NULL, NULL, NULL, '', 247303),
(373910, 'PTHR33541:SF20', NULL, NULL, NULL, NULL, 'PROTEIN BIG GRAIN 1-LIKE B', 247303),
(373911, 'PTHR33541:SF31', NULL, NULL, NULL, NULL, 'PROTEIN BIG GRAIN 1-LIKE A', 247303),
(373912, 'PTHR33541:SF8', NULL, NULL, NULL, NULL, 'OS02G0776600 PROTEIN', 247303),
(373913, 'PTHR33541:SF32', NULL, NULL, NULL, NULL, 'BNACNNG28490D PROTEIN', 247303),
(373914, 'PTHR33541:SF22', NULL, NULL, NULL, NULL, 'PROTEIN BIG GRAIN 1-LIKE A', 247303),
(373915, 'PTHR33541:SF11', NULL, NULL, NULL, NULL, 'PROTEIN BIG GRAIN 1-LIKE E', 247303),
(373916, 'PTHR33541:SF12', NULL, NULL, NULL, NULL, 'PROTEIN BIG GRAIN 1-LIKE B', 247303),
(373917, 'PTHR33541:SF23', NULL, NULL, NULL, NULL, '', 247303),
(373918, 'PTHR33541:SF24', NULL, NULL, NULL, NULL, 'BNAC05G10000D PROTEIN', 247303),
(373919, 'PTHR33541:SF13', NULL, NULL, NULL, NULL, 'PROTEIN BIG GRAIN 1-LIKE B-RELATED', 247303),
(373920, 'PTHR33541:SF25', NULL, NULL, NULL, NULL, '', 247303),
(373921, 'PTHR33541:SF15', NULL, NULL, NULL, NULL, 'PROTEIN BIG GRAIN 1-LIKE D', 247303),
(373922, 'PTHR33541:SF2', NULL, NULL, NULL, NULL, 'PROTEIN BIG GRAIN 1', 247303),
(373923, 'PTHR33541:SF16', NULL, NULL, NULL, NULL, 'BNAA02G14570D PROTEIN', 247303),
(373924, 'PTHR33541:SF28', NULL, NULL, NULL, NULL, 'PROTEIN BIG GRAIN 1-LIKE A', 247303),
(373925, 'PTHR33541:SF18', NULL, NULL, NULL, NULL, '', 247303),
(373926, 'PTHR33541:SF19', NULL, NULL, NULL, NULL, 'BNAA06G00600D PROTEIN', 247303),
(373927, 'PTHR33541:SF9', NULL, NULL, NULL, NULL, 'PROTEIN BIG GRAIN 1-LIKE', 247303),
(373928, 'PTHR33541', NULL, NULL, NULL, NULL, 'PROTEIN BIG GRAIN 1-LIKE A-RELATED', 247303),
(373929, 'PTHR46984', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 71', 247304),
(373930, 'PTHR46984:SF1', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 71', 247304),
(373931, 'PTHR35568', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR DAUR', 247305),
(373932, 'PTHR35568:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR DAUR', 247305),
(373933, 'PTHR46868', NULL, NULL, NULL, NULL, 'FCS-LIKE ZINC FINGER 11', 247306),
(373934, 'PTHR46868:SF7', NULL, NULL, NULL, NULL, 'DUF581 FAMILY PROTEIN', 247306),
(373935, 'PTHR46868:SF8', NULL, NULL, NULL, NULL, 'FLZ-TYPE DOMAIN-CONTAINING PROTEIN', 247306),
(373936, 'PTHR46868:SF10', NULL, NULL, NULL, NULL, 'OS05G0180500 PROTEIN', 247306),
(373937, 'PTHR46868:SF5', NULL, NULL, NULL, NULL, 'FCS-LIKE ZINC FINGER 10', 247306),
(373938, 'PTHR46868:SF3', NULL, NULL, NULL, NULL, 'FCS-LIKE ZINC FINGER 11', 247306),
(373939, 'PTHR46868:SF4', NULL, NULL, NULL, NULL, 'FLZ-TYPE DOMAIN-CONTAINING PROTEIN', 247306),
(373940, 'PTHR28639:SF1', NULL, NULL, NULL, NULL, 'BCL-2-BINDING COMPONENT 3, ISOFORMS 3/4', 247307),
(373941, 'PTHR28639', NULL, NULL, NULL, NULL, 'BCL-2-BINDING COMPONENT 3', 247307),
(373942, 'PTHR24135:SF29', NULL, NULL, NULL, NULL, 'SH3 AND MULTIPLE ANKYRIN REPEAT DOMAINS 3B', 247308),
(373943, 'PTHR24135:SF28', NULL, NULL, NULL, NULL, 'LD13733P', 247308),
(373944, 'PTHR24135:SF17', NULL, NULL, NULL, NULL, 'SH3 AND MULTIPLE ANKYRIN REPEAT DOMAINS PROTEIN 2', 247308);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(373945, 'PTHR24135:SF4', NULL, NULL, NULL, NULL, 'SH3 AND MULTIPLE ANKYRIN REPEAT DOMAINS PROTEIN 3', 247308),
(373946, 'PTHR24135:SF3', NULL, NULL, NULL, NULL, 'SH3 AND MULTIPLE ANKYRIN REPEAT DOMAINS PROTEIN 1', 247308),
(373947, 'PTHR24135', NULL, NULL, NULL, NULL, 'SH3 AND MULTIPLE ANKYRIN REPEAT DOMAINS PROTEIN', 247308),
(373948, 'PTHR37862:SF1', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA CORE COMPLEX-ASSOCIATED PROTEIN 20', 247309),
(373949, 'PTHR37862', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA CORE COMPLEX-ASSOCIATED PROTEIN 20', 247309),
(373950, 'PTHR30560:SF6', NULL, NULL, NULL, NULL, 'TRIGGER_N DOMAIN-CONTAINING PROTEIN', 247310),
(373951, 'PTHR30560:SF5', NULL, NULL, NULL, NULL, 'OS09G0515400 PROTEIN', 247310),
(373952, 'PTHR30560:SF4', NULL, NULL, NULL, NULL, 'OS01G0894700 PROTEIN', 247310),
(373953, 'PTHR30560:SF3', NULL, NULL, NULL, NULL, 'TRIGGER FACTOR-LIKE PROTEIN TIG, CHLOROPLASTIC', 247310),
(373954, 'PTHR30560', NULL, NULL, NULL, NULL, 'TRIGGER FACTOR CHAPERONE AND PEPTIDYL-PROLYL CIS/TRANS ISOMERASE', 247310),
(373955, 'PTHR48031', NULL, NULL, NULL, NULL, 'SRA STEM-LOOP-INTERACTING RNA-BINDING PROTEIN, MITOCHONDRIAL', 247311),
(373956, 'PTHR48031:SF6', NULL, NULL, NULL, NULL, 'GLYCINE-RICH RNA-BINDING PROTEIN RZ1C-LIKE ISOFORM X1', 247311),
(373957, 'PTHR48031:SF5', NULL, NULL, NULL, NULL, 'GLYCINE-RICH RNA-BINDING PROTEIN 7', 247311),
(373958, 'PTHR48031:SF2', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 4', 247311),
(373959, 'PTHR48031:SF4', NULL, NULL, NULL, NULL, 'MEMBRANE COMPLEX PROTEIN 1E, PUTATIVE-RELATED', 247311),
(373960, 'PTHR10872:SF1', NULL, NULL, NULL, NULL, 'SH2B ADAPTER PROTEIN 3', 247312),
(373961, 'PTHR10872:SF2', NULL, NULL, NULL, NULL, 'LNK, ISOFORM D', 247312),
(373962, 'PTHR10872:SF3', NULL, NULL, NULL, NULL, 'SH2B ADAPTER PROTEIN 1', 247312),
(373963, 'PTHR10872:SF4', NULL, NULL, NULL, NULL, 'SH2B ADAPTER PROTEIN 2', 247312),
(373964, 'PTHR10872', NULL, NULL, NULL, NULL, 'SH2B ADAPTER PROTEIN', 247312),
(373965, 'PTHR46284:SF9', NULL, NULL, NULL, NULL, 'OS02G0109800 PROTEIN', 247313),
(373966, 'PTHR46284:SF8', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN-CONTAINING PROTEIN-RELATED', 247313),
(373967, 'PTHR46284:SF11', NULL, NULL, NULL, NULL, '43KDA POSTSYNAPTIC PROTEIN-RELATED', 247313),
(373968, 'PTHR46284:SF10', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 247313),
(373969, 'PTHR46284', NULL, NULL, NULL, NULL, 'PROTEIN KINESIN LIGHT CHAIN-RELATED 3', 247313),
(373970, 'PTHR46284:SF1', NULL, NULL, NULL, NULL, 'PROTEIN KINESIN LIGHT CHAIN-RELATED 2', 247313),
(373971, 'PTHR46284:SF2', NULL, NULL, NULL, NULL, 'PROTEIN KINESIN LIGHT CHAIN-RELATED 1', 247313),
(373972, 'PTHR46284:SF5', NULL, NULL, NULL, NULL, 'PROTEIN KINESIN LIGHT CHAIN-RELATED 3', 247313),
(373973, 'PTHR46284:SF6', NULL, NULL, NULL, NULL, 'KINESIN LIGHT CHAIN', 247313),
(373974, 'PTHR38464', NULL, NULL, NULL, NULL, 'L-ARABINOSE ISOMERASE', 247314),
(373975, 'PTHR38464:SF1', NULL, NULL, NULL, NULL, 'L-ARABINOSE ISOMERASE', 247314),
(373976, 'PTHR31752:SF71', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER COMPONENT', 247315),
(373977, 'PTHR31752:SF70', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER COMPONENT', 247315),
(373978, 'PTHR31752:SF44', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER COMPONENT', 247315),
(373979, 'PTHR31752:SF66', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER COMPONENT 1B-RELATED', 247315),
(373980, 'PTHR31752:SF43', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER COMPONENT', 247315),
(373981, 'PTHR31752:SF65', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER COMPONENT', 247315),
(373982, 'PTHR31752:SF68', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 247315),
(373983, 'PTHR31752:SF67', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER COMPONENT 7', 247315),
(373984, 'PTHR31752:SF45', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER COMPONENT 9-RELATED', 247315),
(373985, 'PTHR31752:SF62', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER COMPONENT', 247315),
(373986, 'PTHR31752:SF40', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER COMPONENT 8', 247315);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(373987, 'PTHR31752:SF61', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER-RELATED', 247315),
(373988, 'PTHR31752:SF64', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER COMPONENT', 247315),
(373989, 'PTHR31752:SF63', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER COMPONENT', 247315),
(373990, 'PTHR31752:SF48', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER COMPONENT 1A', 247315),
(373991, 'PTHR31752:SF69', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER COMPONENT', 247315),
(373992, 'PTHR31752:SF49', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER COMPONENT', 247315),
(373993, 'PTHR31752:SF60', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER COMPONENT 3', 247315),
(373994, 'PTHR31752:SF11', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER COMPONENT 5C-RELATED', 247315),
(373995, 'PTHR31752:SF54', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER COMPONENT 4', 247315),
(373996, 'PTHR31752', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER COMPONENT 1B-RELATED', 247315),
(373997, 'PTHR31752:SF56', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER COMPONENT 6', 247315),
(373998, 'PTHR31752:SF51', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER COMPONENT', 247315),
(373999, 'PTHR31752:SF52', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER COMPONENT 8-RELATED', 247315),
(374000, 'PTHR31752:SF2', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER COMPONENT 5', 247315),
(374001, 'PTHR31752:SF18', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER COMPONENT 3A', 247315),
(374002, 'PTHR31752:SF4', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER COMPONENT 2', 247315),
(374003, 'PTHR31752:SF15', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER COMPONENT 5B-RELATED', 247315),
(374004, 'PTHR31752:SF59', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER COMPONENT 1', 247315),
(374005, 'PTHR31752:SF58', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER COMPONENT', 247315),
(374006, 'PTHR31752:SF16', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER COMPONENT 3B-RELATED', 247315),
(374007, 'PTHR24289:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 17, SUBFAMILY A, POLYPEPTIDE 2', 247316),
(374008, 'PTHR24289:SF13', NULL, NULL, NULL, NULL, 'STEROID 17-ALPHA-HYDROXYLASE/17,20 LYASE', 247316),
(374009, 'PTHR24289:SF12', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 247316),
(374010, 'PTHR24289', NULL, NULL, NULL, NULL, 'STEROID 17-ALPHA-HYDROXYLASE/17,20 LYASE', 247316),
(374011, 'PTHR12409', NULL, NULL, NULL, NULL, 'PREFOLDIN SUBUNIT 3', 247317),
(374012, 'PTHR12409:SF0', NULL, NULL, NULL, NULL, 'PREFOLDIN SUBUNIT 3', 247317),
(374013, 'PTHR39452', NULL, NULL, NULL, NULL, 'CHEY-P PHOSPHATASE CHEX', 247318),
(374014, 'PTHR39452:SF1', NULL, NULL, NULL, NULL, 'CHEY-P PHOSPHATASE CHEX', 247318),
(374015, 'PTHR10562:SF91', NULL, NULL, NULL, NULL, 'OS07G0574600 PROTEIN', 247319),
(374016, 'PTHR10562:SF108', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 247319),
(374017, 'PTHR10562:SF93', NULL, NULL, NULL, NULL, 'SMALL UBIQUITIN-RELATED MODIFIER', 247319),
(374018, 'PTHR10562:SF95', NULL, NULL, NULL, NULL, 'SMALL UBIQUITIN-RELATED MODIFIER', 247319),
(374019, 'PTHR10562:SF94', NULL, NULL, NULL, NULL, 'SMALL UBIQUITIN-RELATED MODIFIER', 247319),
(374020, 'PTHR10562:SF75', NULL, NULL, NULL, NULL, 'RAD60-SLD DOMAIN-CONTAINING PROTEIN', 247319),
(374021, 'PTHR10562:SF74', NULL, NULL, NULL, NULL, 'SMALL UBIQUITIN-RELATED MODIFIER 3-RELATED', 247319),
(374022, 'PTHR10562:SF98', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 247319),
(374023, 'PTHR10562:SF56', NULL, NULL, NULL, NULL, 'SMALL UBIQUITIN-RELATED MODIFIER', 247319),
(374024, 'PTHR10562:SF78', NULL, NULL, NULL, NULL, 'RAD60-SLD DOMAIN-CONTAINING PROTEIN', 247319),
(374025, 'PTHR10562:SF59', NULL, NULL, NULL, NULL, 'OS07G0574500 PROTEIN', 247319),
(374026, 'PTHR10562:SF14', NULL, NULL, NULL, NULL, 'SMALL UBIQUITIN-RELATED MODIFIER 1', 247319),
(374027, 'PTHR10562:SF120', NULL, NULL, NULL, NULL, 'SMALL UBIQUITIN-RELATED MODIFIER 1', 247319),
(374028, 'PTHR10562:SF121', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE RAD60 SUMO-LIKE PROTEIN', 247319),
(374029, 'PTHR10562', NULL, NULL, NULL, NULL, 'SMALL UBIQUITIN-RELATED MODIFIER', 247319);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(374030, 'PTHR10562:SF122', NULL, NULL, NULL, NULL, 'SMALL UBIQUITIN-RELATED MODIFIER 7-RELATED', 247319),
(374031, 'PTHR10562:SF123', NULL, NULL, NULL, NULL, 'SMALL UBIQUITIN-RELATED MODIFIER 2-RELATED', 247319),
(374032, 'PTHR10562:SF124', NULL, NULL, NULL, NULL, 'SMALL UBIQUITIN-RELATED MODIFIER 5', 247319),
(374033, 'PTHR10562:SF102', NULL, NULL, NULL, NULL, 'SMALL UBIQUITIN-RELATED MODIFIER', 247319),
(374034, 'PTHR10562:SF125', NULL, NULL, NULL, NULL, 'SMALL UBIQUITIN-RELATED MODIFIER 2', 247319),
(374035, 'PTHR10562:SF103', NULL, NULL, NULL, NULL, 'SMALL UBIQUITIN-RELATED MODIFIER 5', 247319),
(374036, 'PTHR10562:SF126', NULL, NULL, NULL, NULL, 'SMALL UBIQUITIN-RELATED MODIFIER-RELATED', 247319),
(374037, 'PTHR10562:SF127', NULL, NULL, NULL, NULL, 'SMALL UBIQUITIN LIKE MODIFIER 2', 247319),
(374038, 'PTHR10562:SF128', NULL, NULL, NULL, NULL, 'SMALL UBIQUITIN-RELATED MODIFIER', 247319),
(374039, 'PTHR10562:SF119', NULL, NULL, NULL, NULL, 'RAD60-SLD DOMAIN-CONTAINING PROTEIN', 247319),
(374040, 'PTHR10562:SF62', NULL, NULL, NULL, NULL, 'OS01G0852300 PROTEIN', 247319),
(374041, 'PTHR10562:SF65', NULL, NULL, NULL, NULL, 'SMALL UBIQUITIN-RELATED MODIFIER', 247319),
(374042, 'PTHR10562:SF110', NULL, NULL, NULL, NULL, 'SMALL UBIQUITIN-RELATED MODIFIER', 247319),
(374043, 'PTHR10562:SF111', NULL, NULL, NULL, NULL, 'SMALL UBIQUITIN-RELATED MODIFIER', 247319),
(374044, 'PTHR10562:SF113', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 247319),
(374045, 'PTHR10562:SF117', NULL, NULL, NULL, NULL, 'SMALL UBIQUITIN-RELATED MODIFIER 1', 247319),
(374046, 'PTHR10562:SF118', NULL, NULL, NULL, NULL, 'RAD60-SLD DOMAIN-CONTAINING PROTEIN', 247319),
(374047, 'PTHR12991:SF10', NULL, NULL, NULL, NULL, 'GATOR COMPLEX PROTEIN NPRL2', 247320),
(374048, 'PTHR12991', NULL, NULL, NULL, NULL, 'NITROGEN PERMEASE REGULATOR 2/TUMOR SUPPRESSOR CANDIDATE 4', 247320),
(374049, 'PTHR10658:SF82', NULL, NULL, NULL, NULL, 'VIBRATOR, ISOFORM B', 247321),
(374050, 'PTHR10658:SF81', NULL, NULL, NULL, NULL, 'PROTEIN RETINAL DEGENERATION B', 247321),
(374051, 'PTHR10658:SF84', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL TRANSFER PROTEIN MEMBRANE ASSOCIATED 2', 247321),
(374052, 'PTHR10658:SF40', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED PHOSPHATIDYLINOSITOL TRANSFER PROTEIN 1', 247321),
(374053, 'PTHR10658:SF83', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL TRANSFER PROTEIN CYTOPLASMIC 1B', 247321),
(374054, 'PTHR10658:SF86', NULL, NULL, NULL, NULL, 'LNS2 DOMAIN-CONTAINING PROTEIN', 247321),
(374055, 'PTHR10658:SF41', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED PHOSPHATIDYLINOSITOL TRANSFER PROTEIN 2', 247321),
(374056, 'PTHR10658:SF85', NULL, NULL, NULL, NULL, '', 247321),
(374057, 'PTHR10658', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL TRANSFER PROTEIN', 247321),
(374058, 'PTHR10658:SF55', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PHOSPHATIDYLINOSITOL TRANSFER PROTEIN 1', 247321),
(374059, 'PTHR10658:SF11', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL TRANSFER PROTEIN', 247321),
(374060, 'PTHR10658:SF54', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PHOSPHATIDYLINOSITOL TRANSFER PROTEIN 1', 247321),
(374061, 'PTHR10658:SF35', NULL, NULL, NULL, NULL, 'PROTEIN CBG22145', 247321),
(374062, 'PTHR10658:SF78', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PHOSPHATIDYLINOSITOL TRANSFER PROTEIN 1-LIKE', 247321),
(374063, 'PTHR10658:SF28', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL TRANSFER PROTEIN ALPHA ISOFORM', 247321),
(374064, 'PTHR10658:SF27', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL TRANSFER PROTEIN BETA ISOFORM', 247321),
(374065, 'PTHR10658:SF38', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL TRANSFER PROTEIN 4', 247321),
(374066, 'PTHR43509', NULL, NULL, NULL, NULL, 'PTHR43509', 247322),
(374067, 'PTHR43509:SF1', NULL, NULL, NULL, NULL, 'SULFATE ADENYLYLTRANSFERASE-RELATED', 247322),
(374068, 'PTHR10543:SF58', NULL, NULL, NULL, NULL, 'CAROTENOID CLEAVAGE DIOXYGENASE 4, CHLOROPLASTIC-RELATED', 247323),
(374069, 'PTHR10543:SF57', NULL, NULL, NULL, NULL, 'RETINOID ISOMEROHYDROLASE', 247323),
(374070, 'PTHR10543:SF37', NULL, NULL, NULL, NULL, 'CAROTENOID CLEAVAGE DIOXYGENASE 7, CHLOROPLASTIC', 247323);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(374071, 'PTHR10543:SF138', NULL, NULL, NULL, NULL, '', 247323),
(374072, 'PTHR10543:SF116', NULL, NULL, NULL, NULL, 'CAROTENOID CLEAVAGE DIOXYGENASE 4', 247323),
(374073, 'PTHR10543:SF139', NULL, NULL, NULL, NULL, 'DIOXYGENASE', 247323),
(374074, 'PTHR10543:SF117', NULL, NULL, NULL, NULL, 'BNAA09G41150D PROTEIN', 247323),
(374075, 'PTHR10543:SF118', NULL, NULL, NULL, NULL, 'CAROTENOID CLEAVAGE DIOXYGENASE-RELATED', 247323),
(374076, 'PTHR10543:SF94', NULL, NULL, NULL, NULL, 'CAROTENOID CLEAVAGE DIOXYGENASE 8 HOMOLOG A, CHLOROPLASTIC', 247323),
(374077, 'PTHR10543:SF93', NULL, NULL, NULL, NULL, '9-CIS-EPOXYCAROTENOID DIOXYGENASE NCED2, CHLOROPLASTIC', 247323),
(374078, 'PTHR10543:SF30', NULL, NULL, NULL, NULL, 'OS09G0321200 PROTEIN', 247323),
(374079, 'PTHR10543:SF95', NULL, NULL, NULL, NULL, '9-CIS-EPOXYCAROTENOID DIOXYGENASE NCED9, CHLOROPLASTIC', 247323),
(374080, 'PTHR10543:SF97', NULL, NULL, NULL, NULL, '9-CIS-EPOXYCAROTENOID DIOXYGENASE NCED4, CHLOROPLASTIC', 247323),
(374081, 'PTHR10543:SF134', NULL, NULL, NULL, NULL, '9-CIS-EPOXYCAROTENOID DIOXYGENASE NCED3, CHLOROPLASTIC', 247323),
(374082, 'PTHR10543:SF112', NULL, NULL, NULL, NULL, 'CAROTENOID OXYGENASE-RELATED', 247323),
(374083, 'PTHR10543:SF135', NULL, NULL, NULL, NULL, 'CAROTENOID 9,10(9'',10'')-CLEAVAGE DIOXYGENASE 1-LIKE', 247323),
(374084, 'PTHR10543:SF114', NULL, NULL, NULL, NULL, '', 247323),
(374085, 'PTHR10543:SF136', NULL, NULL, NULL, NULL, 'CAROTENOID 9,10(9'',10'')-CLEAVAGE DIOXYGENASE 1-LIKE ISOFORM X1', 247323),
(374086, 'PTHR10543:SF137', NULL, NULL, NULL, NULL, '', 247323),
(374087, 'PTHR10543', NULL, NULL, NULL, NULL, 'BETA-CAROTENE DIOXYGENASE', 247323),
(374088, 'PTHR10543:SF132', NULL, NULL, NULL, NULL, 'BETA,BETA-CAROTENE 15,15''-DIOXYGENASE', 247323),
(374089, 'PTHR10543:SF110', NULL, NULL, NULL, NULL, 'BETA-CAROTENE OXYGENASE 1', 247323),
(374090, 'PTHR10543:SF111', NULL, NULL, NULL, NULL, '', 247323),
(374091, 'PTHR10543:SF109', NULL, NULL, NULL, NULL, 'CAROTENOID CLEAVAGE DIOXYGENASE 1-1', 247323),
(374092, 'PTHR10543:SF46', NULL, NULL, NULL, NULL, 'CAROTENOID CLEAVAGE DIOXYGENASE 4, CHLOROPLASTIC-RELATED', 247323),
(374093, 'PTHR10543:SF24', NULL, NULL, NULL, NULL, 'CAROTENOID ISOMEROOXYGENASE', 247323),
(374094, 'PTHR10543:SF26', NULL, NULL, NULL, NULL, '9-CIS-EPOXYCAROTENOID DIOXYGENASE NCED3, CHLOROPLASTIC', 247323),
(374095, 'PTHR10543:SF106', NULL, NULL, NULL, NULL, '', 247323),
(374096, 'PTHR10543:SF129', NULL, NULL, NULL, NULL, 'PROTEIN CBG14773', 247323),
(374097, 'PTHR10543:SF107', NULL, NULL, NULL, NULL, 'BETA-CAROTENE 15, 15-DIOXYGENASE 2,-LIKE', 247323),
(374098, 'PTHR10543:SF83', NULL, NULL, NULL, NULL, '', 247323),
(374099, 'PTHR10543:SF43', NULL, NULL, NULL, NULL, 'ALL-TRANS-RETINYL ESTER 13-CIS ISOMEROHYDROLASE-RELATED', 247323),
(374100, 'PTHR10543:SF86', NULL, NULL, NULL, NULL, 'BETA-CAROTENE OXYGENASE 1,-LIKE', 247323),
(374101, 'PTHR10543:SF89', NULL, NULL, NULL, NULL, 'CAROTENOID 9,10(9'',10'')-CLEAVAGE DIOXYGENASE 1', 247323),
(374102, 'PTHR10543:SF140', NULL, NULL, NULL, NULL, 'BETA-CAROTENE 15,15''-MONOOXYGENASE', 247323),
(374103, 'PTHR10543:SF101', NULL, NULL, NULL, NULL, '9-CIS-EPOXYCAROTENOID DIOXYGENASE NCED6, CHLOROPLASTIC', 247323),
(374104, 'PTHR10543:SF123', NULL, NULL, NULL, NULL, '9-CIS-EPOXYCAROTENOID DIOXYGENASE NCED5, CHLOROPLASTIC-RELATED', 247323),
(374105, 'PTHR10543:SF102', NULL, NULL, NULL, NULL, '', 247323),
(374106, 'PTHR10543:SF125', NULL, NULL, NULL, NULL, 'CAROTENOID OXYGENASE-RELATED', 247323),
(374107, 'PTHR10543:SF141', NULL, NULL, NULL, NULL, 'OS06G0162550 PROTEIN', 247323),
(374108, 'PTHR10543:SF122', NULL, NULL, NULL, NULL, 'BETA,BETA-CAROTENE 9'',10''-OXYGENASE', 247323),
(374109, 'PTHR37866:SF1', NULL, NULL, NULL, NULL, 'PRE T-CELL ANTIGEN RECEPTOR ALPHA', 247324),
(374110, 'PTHR37866', NULL, NULL, NULL, NULL, 'PRE T-CELL ANTIGEN RECEPTOR ALPHA', 247324),
(374111, 'PTHR13509', NULL, NULL, NULL, NULL, 'SEC61 SUBUNIT BETA', 247325),
(374112, 'PTHR13509:SF22', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC61 SUBUNIT BETA', 247325),
(374113, 'PTHR13509:SF21', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC61 SUBUNIT BETA', 247325);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(374114, 'PTHR13509:SF20', NULL, NULL, NULL, NULL, '', 247325),
(374115, 'PTHR13509:SF15', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC61 SUBUNIT BETA', 247325),
(374116, 'PTHR13509:SF2', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC61 SUBUNIT BETA', 247325),
(374117, 'PTHR13509:SF14', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC61 SUBUNIT BETA', 247325),
(374118, 'PTHR13509:SF24', NULL, NULL, NULL, NULL, 'OS11G0104050 PROTEIN', 247325),
(374119, 'PTHR13509:SF12', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC61 SUBUNIT BETA', 247325),
(374120, 'PTHR13509:SF23', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC61 SUBUNIT BETA', 247325),
(374121, 'PTHR13509:SF3', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC61 SUBUNIT BETA', 247325),
(374122, 'PTHR28585', NULL, NULL, NULL, NULL, 'TUBEROINFUNDIBULAR PEPTIDE OF 39 RESIDUES', 247326),
(374123, 'PTHR28585:SF1', NULL, NULL, NULL, NULL, 'TUBEROINFUNDIBULAR PEPTIDE OF 39 RESIDUES', 247326),
(374124, 'PTHR15434:SF2', NULL, NULL, NULL, NULL, 'HEAT SHOCK FACTOR 2-BINDING PROTEIN', 247327),
(374125, 'PTHR15434', NULL, NULL, NULL, NULL, 'HEAT SHOCK FACTOR 2-BINDING PROTEIN', 247327),
(374126, 'PTHR22588:SF14', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 247328),
(374127, 'PTHR22588:SF13', NULL, NULL, NULL, NULL, 'INTEGRIN, ALPHA E, TANDEM DUPLICATE 1', 247328),
(374128, 'PTHR22588:SF8', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 247328),
(374129, 'PTHR22588:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG04137', 247328),
(374130, 'PTHR22588:SF6', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-4(VI) CHAIN', 247328),
(374131, 'PTHR22588:SF10', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 247328),
(374132, 'PTHR22588:SF5', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-6(VI) CHAIN', 247328),
(374133, 'PTHR22588:SF4', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA-5(VI) CHAIN', 247328),
(374134, 'PTHR22588:SF3', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 247328),
(374135, 'PTHR22588:SF12', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 247328),
(374136, 'PTHR22588:SF11', NULL, NULL, NULL, NULL, 'VWA DOMAIN-CONTAINING PROTEIN', 247328),
(374137, 'PTHR22588', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247328),
(374138, 'PTHR35692:SF5', NULL, NULL, NULL, NULL, 'BNAA03G19430D PROTEIN', 247329),
(374139, 'PTHR35692', NULL, NULL, NULL, NULL, 'F26F24.11', 247329),
(374140, 'PTHR35692:SF1', NULL, NULL, NULL, NULL, 'F26F24.11', 247329),
(374141, 'PTHR35692:SF6', NULL, NULL, NULL, NULL, 'BNAA09G29980D PROTEIN', 247329),
(374142, 'PTHR46967', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR BINDING PROTEIN,N-TERMINAL', 247330),
(374143, 'PTHR46967:SF1', NULL, NULL, NULL, NULL, 'SI:DKEY-21A6.5', 247330),
(374144, 'PTHR46967:SF2', NULL, NULL, NULL, NULL, 'MACPF DOMAIN-CONTAINING PROTEIN', 247330),
(374145, 'PTHR17102', NULL, NULL, NULL, NULL, 'NEURONAL REGENERATION-RELATED PROTEIN', 247331),
(374146, 'PTHR17102:SF4', NULL, NULL, NULL, NULL, 'NEURONAL REGENERATION-RELATED PROTEIN', 247331),
(374147, 'PTHR22017:SF0', NULL, NULL, NULL, NULL, 'PHOTORECEPTOR CILIUM ACTIN REGULATOR', 247332),
(374148, 'PTHR22017', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247332),
(374149, 'PTHR22017:SF3', NULL, NULL, NULL, NULL, 'PHOTORECEPTOR CILIUM ACTIN REGULATOR 2', 247332),
(374150, 'PTHR20856:SF21', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE D SUBUNIT 2B-RELATED', 247333),
(374151, 'PTHR20856:SF31', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT BETA', 247333),
(374152, 'PTHR20856:SF20', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT BETA', 247333),
(374153, 'PTHR20856:SF30', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE', 247333),
(374154, 'PTHR20856', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE I SUBUNIT 2', 247333),
(374155, 'PTHR20856:SF8', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE III SUBUNIT RPC2', 247333),
(374156, 'PTHR20856:SF5', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE I SUBUNIT RPA2', 247333),
(374157, 'PTHR20856:SF23', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT BETA', 247333);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(374158, 'PTHR20856:SF7', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE II SUBUNIT RPB2', 247333),
(374159, 'PTHR20856:SF22', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT BETA', 247333),
(374160, 'PTHR20856:SF29', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT BETA', 247333),
(374161, 'PTHR20856:SF28', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT BETA', 247333),
(374162, 'PTHR20856:SF26', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT BETA', 247333),
(374163, 'PTHR21274:SF0', NULL, NULL, NULL, NULL, 'MECKELIN', 247334),
(374164, 'PTHR21274', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247334),
(374165, 'PTHR30151:SF7', NULL, NULL, NULL, NULL, 'NITRATE IMPORT PERMEASE PROTEIN NRTB', 247335),
(374166, 'PTHR30151:SF40', NULL, NULL, NULL, NULL, 'TRANSPORT SYSTEM INTEGRAL MEMBRANE PROTEIN-RELATED', 247335),
(374167, 'PTHR30151:SF16', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN', 247335),
(374168, 'PTHR30151:SF38', NULL, NULL, NULL, NULL, 'ALIPHATIC SULFONATES TRANSPORT PERMEASE PROTEIN SSUC-RELATED', 247335),
(374169, 'PTHR30151:SF39', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN', 247335),
(374170, 'PTHR30151:SF19', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE-RELATED', 247335),
(374171, 'PTHR30151:SF23', NULL, NULL, NULL, NULL, 'GLYCINE BETAINE/CARNITINE/CHOLINE TRANSPORT SYSTEM PERMEASE PROTEIN OPUCD', 247335),
(374172, 'PTHR30151', NULL, NULL, NULL, NULL, 'ALKANE SULFONATE ABC TRANSPORTER-RELATED, MEMBRANE SUBUNIT', 247335),
(374173, 'PTHR30151:SF25', NULL, NULL, NULL, NULL, 'TAURINE TRANSPORT SYSTEM PERMEASE PROTEIN TAUC', 247335),
(374174, 'PTHR30151:SF0', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN MJ0413-RELATED', 247335),
(374175, 'PTHR30151:SF20', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN HI_0355-RELATED', 247335),
(374176, 'PTHR23201:SF132', NULL, NULL, NULL, NULL, 'GIBBERELLIN-REGULATED PROTEIN 1-LIKE', 247336),
(374177, 'PTHR23201:SF67', NULL, NULL, NULL, NULL, 'GIBBERELLIN-REGULATED PROTEIN 1-LIKE', 247336),
(374178, 'PTHR23201:SF68', NULL, NULL, NULL, NULL, 'SNAKIN-2-LIKE', 247336),
(374179, 'PTHR23201:SF131', NULL, NULL, NULL, NULL, 'GIBBERELLIN-REGULATED PROTEIN 7', 247336),
(374180, 'PTHR23201:SF139', NULL, NULL, NULL, NULL, 'GASA/GAST/SNAKIN', 247336),
(374181, 'PTHR23201:SF60', NULL, NULL, NULL, NULL, 'GIBBERELLIN-REGULATED PROTEIN 5', 247336),
(374182, 'PTHR23201:SF138', NULL, NULL, NULL, NULL, 'GIBBERELLIN-REGULATED PROTEIN 6-LIKE', 247336),
(374183, 'PTHR23201:SF137', NULL, NULL, NULL, NULL, 'GIBBERELLIN-REGULATED FAMILY PROTEIN', 247336),
(374184, 'PTHR23201:SF136', NULL, NULL, NULL, NULL, 'GIBBERELLIN-REGULATED FAMILY PROTEIN', 247336),
(374185, 'PTHR23201:SF20', NULL, NULL, NULL, NULL, 'GIBBERELLIN-REGULATED PROTEIN 9-LIKE', 247336),
(374186, 'PTHR23201:SF135', NULL, NULL, NULL, NULL, '', 247336),
(374187, 'PTHR23201:SF134', NULL, NULL, NULL, NULL, 'GIBBERELLIN-REGULATED FAMILY PROTEIN', 247336),
(374188, 'PTHR23201:SF133', NULL, NULL, NULL, NULL, '', 247336),
(374189, 'PTHR23201:SF79', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 4', 247336),
(374190, 'PTHR23201:SF77', NULL, NULL, NULL, NULL, 'PROTEIN GAST1', 247336),
(374191, 'PTHR23201:SF2', NULL, NULL, NULL, NULL, 'GIBBERELLIN-REGULATED PROTEIN 1-RELATED', 247336),
(374192, 'PTHR23201:SF70', NULL, NULL, NULL, NULL, 'GIBBERELLIN-STIMULATED PROTEIN', 247336),
(374193, 'PTHR23201:SF71', NULL, NULL, NULL, NULL, 'GIBBERELLIN REGULATED PROTEIN', 247336),
(374194, 'PTHR23201:SF124', NULL, NULL, NULL, NULL, 'GIBBERELLIN-REGULATED PROTEIN 4', 247336),
(374195, 'PTHR23201:SF75', NULL, NULL, NULL, NULL, 'SNAKIN-2-LIKE', 247336),
(374196, 'PTHR23201:SF122', NULL, NULL, NULL, NULL, 'GIP1-LIKE PROTEIN', 247336),
(374197, 'PTHR23201', NULL, NULL, NULL, NULL, 'EXTENSIN, PROLINE-RICH PROTEIN', 247336),
(374198, 'PTHR23201:SF154', NULL, NULL, NULL, NULL, 'GIBBERELLIN-REGULATED PROTEIN 9', 247336),
(374199, 'PTHR23201:SF45', NULL, NULL, NULL, NULL, 'SNAKIN-2-LIKE', 247336),
(374200, 'PTHR23201:SF153', NULL, NULL, NULL, NULL, 'PEAMACLEIN-LIKE', 247336);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(374201, 'PTHR23201:SF152', NULL, NULL, NULL, NULL, '', 247336),
(374202, 'PTHR23201:SF43', NULL, NULL, NULL, NULL, 'GIBBERELLIN-REGULATED PROTEIN 6-LIKE', 247336),
(374203, 'PTHR23201:SF87', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 4-LIKE', 247336),
(374204, 'PTHR23201:SF151', NULL, NULL, NULL, NULL, 'GIBBERELLIN-REGULATED PROTEIN 1-LIKE', 247336),
(374205, 'PTHR23201:SF150', NULL, NULL, NULL, NULL, 'GAST', 247336),
(374206, 'PTHR23201:SF49', NULL, NULL, NULL, NULL, 'PROTEIN GAST1-LIKE', 247336),
(374207, 'PTHR23201:SF118', NULL, NULL, NULL, NULL, 'GIBBERELLIN STIMULATED TRANSCRIPT RELATED PROTEIN 1', 247336),
(374208, 'PTHR23201:SF117', NULL, NULL, NULL, NULL, 'GIBBERELLIN REGULATED PROTEIN', 247336),
(374209, 'PTHR23201:SF116', NULL, NULL, NULL, NULL, 'BNAA09G09740D PROTEIN', 247336),
(374210, 'PTHR23201:SF115', NULL, NULL, NULL, NULL, 'GAST1 PROTEIN', 247336),
(374211, 'PTHR23201:SF80', NULL, NULL, NULL, NULL, 'OS06G0729400 PROTEIN', 247336),
(374212, 'PTHR23201:SF114', NULL, NULL, NULL, NULL, 'GIBBERELLIN REGULATED PROTEIN-RELATED', 247336),
(374213, 'PTHR23201:SF113', NULL, NULL, NULL, NULL, 'BNAA02G06740D PROTEIN', 247336),
(374214, 'PTHR23201:SF84', NULL, NULL, NULL, NULL, 'GIBBERELLIN REGULATED PROTEIN', 247336),
(374215, 'PTHR23201:SF108', NULL, NULL, NULL, NULL, 'GIBBERELLIN-REGULATED PROTEIN 6', 247336),
(374216, 'PTHR23201:SF18', NULL, NULL, NULL, NULL, 'GIBBERELLIN-REGULATED PROTEIN 2-RELATED', 247336),
(374217, 'PTHR23201:SF56', NULL, NULL, NULL, NULL, 'GIBBERELLIN-REGULATED FAMILY PROTEIN-RELATED', 247336),
(374218, 'PTHR23201:SF12', NULL, NULL, NULL, NULL, 'OS05G0432200 PROTEIN', 247336),
(374219, 'PTHR23201:SF143', NULL, NULL, NULL, NULL, 'SNAKIN-1', 247336),
(374220, 'PTHR23201:SF142', NULL, NULL, NULL, NULL, 'PROTEIN GAST1-LIKE', 247336),
(374221, 'PTHR23201:SF98', NULL, NULL, NULL, NULL, 'GIBBERELLIN-REGULATED PROTEIN 11-LIKE', 247336),
(374222, 'PTHR23201:SF141', NULL, NULL, NULL, NULL, 'GIBBERELLIN-REGULATED PROTEIN 10', 247336),
(374223, 'PTHR23201:SF99', NULL, NULL, NULL, NULL, 'OS07G0592000 PROTEIN', 247336),
(374224, 'PTHR23201:SF140', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 2', 247336),
(374225, 'PTHR23201:SF92', NULL, NULL, NULL, NULL, 'GIBBERELLIN-REGULATED PROTEIN 12', 247336),
(374226, 'PTHR23201:SF93', NULL, NULL, NULL, NULL, 'GIBBERELLIN-REGULATED FAMILY PROTEIN-RELATED', 247336),
(374227, 'PTHR23201:SF106', NULL, NULL, NULL, NULL, '', 247336),
(374228, 'PTHR23201:SF149', NULL, NULL, NULL, NULL, 'GIBBERELLIN STIMULATED TRANSCRIPT RELATED PROTEIN 2', 247336),
(374229, 'PTHR23201:SF105', NULL, NULL, NULL, NULL, 'BNAUNNG01070D PROTEIN', 247336),
(374230, 'PTHR23201:SF148', NULL, NULL, NULL, NULL, 'GAST1 PROTEIN', 247336),
(374231, 'PTHR23201:SF104', NULL, NULL, NULL, NULL, 'GIBBERELLIN-REGULATED PROTEIN 1', 247336),
(374232, 'PTHR23201:SF96', NULL, NULL, NULL, NULL, 'BNAA10G12810D PROTEIN', 247336),
(374233, 'PTHR23201:SF52', NULL, NULL, NULL, NULL, 'GIBBERELLIN-REGULATED PROTEIN 13', 247336),
(374234, 'PTHR23201:SF147', NULL, NULL, NULL, NULL, 'GIBBERELLIN-REGULATED PROTEIN 6-LIKE', 247336),
(374235, 'PTHR23201:SF103', NULL, NULL, NULL, NULL, 'GIBBERELLIN-REGULATED FAMILY PROTEIN-RELATED', 247336),
(374236, 'PTHR23201:SF53', NULL, NULL, NULL, NULL, 'GIBBERELLIN-REGULATED PROTEIN 14', 247336),
(374237, 'PTHR23201:SF146', NULL, NULL, NULL, NULL, '', 247336),
(374238, 'PTHR23201:SF102', NULL, NULL, NULL, NULL, 'BNAC02G23510D PROTEIN', 247336),
(374239, 'PTHR23201:SF101', NULL, NULL, NULL, NULL, 'GIBBERELLIN REGULATED PROTEIN-RELATED', 247336),
(374240, 'PTHR23201:SF50', NULL, NULL, NULL, NULL, '', 247336),
(374241, 'PTHR23201:SF145', NULL, NULL, NULL, NULL, 'GAST1 PROTEIN', 247336),
(374242, 'PTHR23201:SF100', NULL, NULL, NULL, NULL, 'GIBBERELLIN REGULATED PROTEIN-RELATED', 247336),
(374243, 'PTHR23201:SF51', NULL, NULL, NULL, NULL, '', 247336),
(374244, 'PTHR23201:SF144', NULL, NULL, NULL, NULL, '', 247336),
(374245, 'PTHR47107:SF1', NULL, NULL, NULL, NULL, 'SVF1-LIKE PROTEIN YDR222W-RELATED', 247337),
(374246, 'PTHR47107:SF2', NULL, NULL, NULL, NULL, 'SURVIVAL FACTOR 2', 247337);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(374247, 'PTHR47107', NULL, NULL, NULL, NULL, 'SVF1-LIKE PROTEIN YDR222W-RELATED', 247337),
(374248, 'PTHR46561', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS AB (CLASS A-LIKE)-RELATED', 247338),
(374249, 'PTHR46561:SF11', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS ALPHA/BETA-14', 247338),
(374250, 'PTHR46561:SF10', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS AB (CLASS A-LIKE)', 247338),
(374251, 'PTHR46561:SF5', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS AB (CLASS A-LIKE)', 247338),
(374252, 'PTHR46561:SF17', NULL, NULL, NULL, NULL, 'PROTEIN CBG13582', 247338),
(374253, 'PTHR46561:SF16', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS AB (CLASS A-LIKE)', 247338),
(374254, 'PTHR46561:SF6', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS AB (CLASS A-LIKE)', 247338),
(374255, 'PTHR46561:SF7', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS AB (CLASS A-LIKE)', 247338),
(374256, 'PTHR46561:SF15', NULL, NULL, NULL, NULL, 'PROTEIN CBG16352', 247338),
(374257, 'PTHR46561:SF14', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS AB (CLASS A-LIKE)', 247338),
(374258, 'PTHR46561:SF9', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS AB (CLASS A-LIKE)', 247338),
(374259, 'PTHR46561:SF1', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS AB (CLASS A-LIKE)', 247338),
(374260, 'PTHR46561:SF2', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS AB (CLASS A-LIKE)', 247338),
(374261, 'PTHR46561:SF3', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS AB (CLASS A-LIKE)', 247338),
(374262, 'PTHR46561:SF4', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS AB (CLASS A-LIKE)', 247338),
(374263, 'PTHR30528', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247339),
(374264, 'PTHR30528:SF0', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 247339),
(374265, 'PTHR13935:SF41', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR ORG2-RELATED', 247340),
(374266, 'PTHR13935:SF122', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247340),
(374267, 'PTHR13935:SF82', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR', 247340),
(374268, 'PTHR13935', NULL, NULL, NULL, NULL, 'ACHAETE-SCUTE TRANSCRIPTION FACTOR-RELATED', 247340),
(374269, 'PTHR13935:SF129', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247340),
(374270, 'PTHR13935:SF125', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247340),
(374271, 'PTHR13935:SF126', NULL, NULL, NULL, NULL, 'ACHAETE-SCUTE HOMOLOG 1A', 247340),
(374272, 'PTHR13935:SF123', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247340),
(374273, 'PTHR13935:SF124', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH118-LIKE', 247340),
(374274, 'PTHR13935:SF154', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247340),
(374275, 'PTHR13935:SF110', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH55', 247340),
(374276, 'PTHR13935:SF155', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247340),
(374277, 'PTHR13935:SF111', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH125', 247340),
(374278, 'PTHR13935:SF152', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH FAMILY-RELATED', 247340),
(374279, 'PTHR13935:SF153', NULL, NULL, NULL, NULL, 'ACHAETE-SCUTE FAMILY BHLH TRANSCRIPTION FACTOR 2-RELATED', 247340),
(374280, 'PTHR13935:SF118', NULL, NULL, NULL, NULL, 'BASIC HELIX-LOOP-HELIX DNA-BINDING SUPERFAMILY PROTEIN', 247340),
(374281, 'PTHR13935:SF68', NULL, NULL, NULL, NULL, 'ACHAETE-SCUTE HOMOLOG 3', 247340),
(374282, 'PTHR13935:SF114', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247340),
(374283, 'PTHR13935:SF158', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247340),
(374284, 'PTHR13935:SF159', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH167-RELATED', 247340),
(374285, 'PTHR13935:SF66', NULL, NULL, NULL, NULL, 'ACHAETE-SCUTE HOMOLOG 1', 247340),
(374286, 'PTHR13935:SF112', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH118', 247340),
(374287, 'PTHR13935:SF156', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247340),
(374288, 'PTHR13935:SF157', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247340);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(374289, 'PTHR13935:SF113', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247340),
(374290, 'PTHR13935:SF63', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247340),
(374291, 'PTHR13935:SF62', NULL, NULL, NULL, NULL, 'ACHAETE-SCUTE HOMOLOG 2', 247340),
(374292, 'PTHR13935:SF100', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH100', 247340),
(374293, 'PTHR13935:SF142', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247340),
(374294, 'PTHR13935:SF108', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH118-LIKE', 247340),
(374295, 'PTHR13935:SF106', NULL, NULL, NULL, NULL, 'ACHAETE-SCUTE COMPLEX PROTEIN T4-RELATED', 247340),
(374296, 'PTHR13935:SF55', NULL, NULL, NULL, NULL, 'ACHAETE-SCUTE HOMOLOG 5', 247340),
(374297, 'PTHR13935:SF104', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH160', 247340),
(374298, 'PTHR13935:SF148', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR ORG2-LIKE', 247340),
(374299, 'PTHR13935:SF145', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH FAMILY-RELATED', 247340),
(374300, 'PTHR13935:SF98', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH126-LIKE', 247340),
(374301, 'PTHR13935:SF146', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247340),
(374302, 'PTHR13935:SF52', NULL, NULL, NULL, NULL, 'OS01G0108400 PROTEIN', 247340),
(374303, 'PTHR13935:SF96', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247340),
(374304, 'PTHR13935:SF51', NULL, NULL, NULL, NULL, 'ACHAETE-SCUTE HOMOLOG 4', 247340),
(374305, 'PTHR13935:SF133', NULL, NULL, NULL, NULL, 'ACHAETE-SCUTE HOMOLOG 1B', 247340),
(374306, 'PTHR13935:SF130', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH36', 247340),
(374307, 'PTHR13935:SF131', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247340),
(374308, 'PTHR13935:SF90', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH162', 247340),
(374309, 'PTHR13935:SF46', NULL, NULL, NULL, NULL, 'OS01G0108600 PROTEIN', 247340),
(374310, 'PTHR13935:SF89', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR ORG2-LIKE', 247340),
(374311, 'PTHR13935:SF137', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247340),
(374312, 'PTHR13935:SF88', NULL, NULL, NULL, NULL, '', 247340),
(374313, 'PTHR13935:SF134', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247340),
(374314, 'PTHR13935:SF135', NULL, NULL, NULL, NULL, 'HELIX-LOOP-HELIX PROTEIN 4', 247340),
(374315, 'PTHR28180:SF4', NULL, NULL, NULL, NULL, 'CONSERVED MITOCHONDRIAL PROTEIN', 247341),
(374316, 'PTHR28180', NULL, NULL, NULL, NULL, 'CONSERVED MITOCHONDRIAL PROTEIN-RELATED', 247341),
(374317, 'PTHR28180:SF2', NULL, NULL, NULL, NULL, 'PEROXISOMAL PROTEIN 2', 247341),
(374318, 'PTHR45896:SF1', NULL, NULL, NULL, NULL, 'N-ALPHA-ACETYLTRANSFERASE 30', 247342),
(374319, 'PTHR45896', NULL, NULL, NULL, NULL, 'N-ALPHA-ACETYLTRANSFERASE 30', 247342),
(374320, 'PTHR14196:SF5', NULL, NULL, NULL, NULL, 'PROTEIN ODD-SKIPPED-RELATED 1', 247343),
(374321, 'PTHR14196:SF4', NULL, NULL, NULL, NULL, 'PROTEIN ODD-SKIPPED-RELATED 2', 247343),
(374322, 'PTHR14196', NULL, NULL, NULL, NULL, 'ODD-SKIPPED - RELATED', 247343),
(374323, 'PTHR14196:SF0', NULL, NULL, NULL, NULL, 'PROTEIN BOWEL-RELATED', 247343),
(374324, 'PTHR14196:SF10', NULL, NULL, NULL, NULL, 'AGAP002993-PA', 247343),
(374325, 'PTHR37716', NULL, NULL, NULL, NULL, 'OS07G0568900 PROTEIN', 247344),
(374326, 'PTHR37716:SF1', NULL, NULL, NULL, NULL, 'OS07G0568900 PROTEIN', 247344),
(374327, 'PTHR47983:SF33', NULL, NULL, NULL, NULL, 'OS01G0899000 PROTEIN', 247345),
(374328, 'PTHR47983:SF11', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247345),
(374329, 'PTHR47983:SF12', NULL, NULL, NULL, NULL, 'PTI1-LIKE TYROSINE-PROTEIN KINASE 2-RELATED', 247345),
(374330, 'PTHR47983:SF34', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247345),
(374331, 'PTHR47983:SF31', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247345),
(374332, 'PTHR47983:SF32', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247345),
(374333, 'PTHR47983:SF10', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247345);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(374334, 'PTHR47983:SF37', NULL, NULL, NULL, NULL, 'OS03G0226300 PROTEIN', 247345),
(374335, 'PTHR47983:SF15', NULL, NULL, NULL, NULL, 'PTI1-LIKE TYROSINE-PROTEIN KINASE 3', 247345),
(374336, 'PTHR47983:SF16', NULL, NULL, NULL, NULL, 'OS02G0565500 PROTEIN', 247345),
(374337, 'PTHR47983:SF13', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247345),
(374338, 'PTHR47983:SF36', NULL, NULL, NULL, NULL, 'PTI1-LIKE TYROSINE-PROTEIN KINASE 1', 247345),
(374339, 'PTHR47983:SF14', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247345),
(374340, 'PTHR47983:SF19', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247345),
(374341, 'PTHR47983:SF2', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247345),
(374342, 'PTHR47983:SF3', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE CYTOPLASMIC KINASE 1', 247345),
(374343, 'PTHR47983:SF17', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247345),
(374344, 'PTHR47983:SF4', NULL, NULL, NULL, NULL, 'PTI1-LIKE TYROSINE-PROTEIN KINASE 3', 247345),
(374345, 'PTHR47983:SF6', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247345),
(374346, 'PTHR47983:SF7', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 247345),
(374347, 'PTHR47983:SF1', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247345),
(374348, 'PTHR47983:SF40', NULL, NULL, NULL, NULL, 'OS01G0323100 PROTEIN', 247345),
(374349, 'PTHR47983:SF41', NULL, NULL, NULL, NULL, 'PTI1-LIKE TYROSINE-PROTEIN KINASE 3', 247345),
(374350, 'PTHR47983:SF44', NULL, NULL, NULL, NULL, 'PTI1-LIKE TYROSINE-PROTEIN KINASE 3 ISOFORM X2', 247345),
(374351, 'PTHR47983:SF22', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE ALE2', 247345),
(374352, 'PTHR47983', NULL, NULL, NULL, NULL, 'PTO-INTERACTING PROTEIN 1-LIKE', 247345),
(374353, 'PTHR47983:SF23', NULL, NULL, NULL, NULL, 'PROLINE-RICH RECEPTOR-LIKE PROTEIN KINASE PERK13', 247345),
(374354, 'PTHR47983:SF45', NULL, NULL, NULL, NULL, 'PTO-INTERACTING PROTEIN 1', 247345),
(374355, 'PTHR47983:SF42', NULL, NULL, NULL, NULL, 'TYROSINE KINASE FAMILY PROTEIN', 247345),
(374356, 'PTHR47983:SF20', NULL, NULL, NULL, NULL, 'OS03G0844100 PROTEIN', 247345),
(374357, 'PTHR47983:SF21', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247345),
(374358, 'PTHR47983:SF43', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247345),
(374359, 'PTHR47983:SF26', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE-LIKE 8 ISOFORM X1', 247345),
(374360, 'PTHR47983:SF27', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247345),
(374361, 'PTHR47983:SF46', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247345),
(374362, 'PTHR47983:SF24', NULL, NULL, NULL, NULL, 'F11A17.22 PROTEIN-RELATED', 247345),
(374363, 'PTHR47983:SF28', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247345),
(374364, 'PTHR11405:SF51', NULL, NULL, NULL, NULL, 'CARBAMOYL-PHOSPHATE SYNTHASE ARGININE-SPECIFIC LARGE CHAIN', 247346),
(374365, 'PTHR11405', NULL, NULL, NULL, NULL, 'CARBAMOYLTRANSFERASE FAMILY MEMBER', 247346),
(374366, 'PTHR11405:SF4', NULL, NULL, NULL, NULL, 'CARBAMOYL-PHOSPHATE SYNTHASE ARGININE-SPECIFIC SMALL CHAIN', 247346),
(374367, 'PTHR11405:SF5', NULL, NULL, NULL, NULL, 'CAD PROTEIN', 247346),
(374368, 'PTHR11405:SF16', NULL, NULL, NULL, NULL, 'ASPARTATE CARBAMOYLTRANSFERASE, CHLOROPLASTIC', 247346),
(374369, 'PTHR11405:SF54', NULL, NULL, NULL, NULL, 'ASPARTATE CARBAMOYLTRANSFERASE', 247346),
(374370, 'PTHR11405:SF53', NULL, NULL, NULL, NULL, 'CARBAMOYL-PHOSPHATE SYNTHASE [AMMONIA], MITOCHONDRIAL', 247346),
(374371, 'PTHR11405:SF55', NULL, NULL, NULL, NULL, 'ASPARTATE CARBAMOYLTRANSFERASE', 247346),
(374372, 'PTHR20931:SF4', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 30A2', 247347),
(374373, 'PTHR20931', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247347),
(374374, 'PTHR20931:SF3', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 30A', 247347);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(374375, 'PTHR20931:SF6', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 30B', 247347),
(374376, 'PTHR20931:SF0', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 30', 247347),
(374377, 'PTHR12879:SF22', NULL, NULL, NULL, NULL, 'FA_DESATURASE DOMAIN-CONTAINING PROTEIN', 247348),
(374378, 'PTHR12879', NULL, NULL, NULL, NULL, 'SPHINGOLIPID DELTA 4 DESATURASE/C-4 HYDROXYLASE PROTEIN DES2', 247348),
(374379, 'PTHR12879:SF20', NULL, NULL, NULL, NULL, 'SPHINGOLIPID DELTA(4)-DESATURASE/C4-MONOOXYGENASE-RELATED', 247348),
(374380, 'PTHR12879:SF21', NULL, NULL, NULL, NULL, 'SPHINGOLIPID DELTA(4)-DESATURASE/C4-MONOOXYGENASE DES2', 247348),
(374381, 'PTHR12879:SF8', NULL, NULL, NULL, NULL, 'DEGENERATIVE SPERMATOCYTE HOMOLOG 1', 247348),
(374382, 'PTHR12879:SF6', NULL, NULL, NULL, NULL, 'SPHINGOLIPID 4-DESATURASE', 247348),
(374383, 'PTHR12879:SF2', NULL, NULL, NULL, NULL, 'SPHINGOLIPID DELTA(4)-DESATURASE DES1', 247348),
(374384, 'PTHR35169:SF2', NULL, NULL, NULL, NULL, '', 247349),
(374385, 'PTHR35169:SF1', NULL, NULL, NULL, NULL, '2OG-FEII_OXY_4 DOMAIN-CONTAINING PROTEIN', 247349),
(374386, 'PTHR35169', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 247349),
(374387, 'PTHR31126:SF39', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE DSP2-RELATED', 247350),
(374388, 'PTHR31126:SF1', NULL, NULL, NULL, NULL, 'PTP/DSP-LIKE', 247350),
(374389, 'PTHR31126:SF18', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 247350),
(374390, 'PTHR31126:SF57', NULL, NULL, NULL, NULL, '', 247350),
(374391, 'PTHR31126:SF14', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE OCA6-RELATED', 247350),
(374392, 'PTHR31126:SF58', NULL, NULL, NULL, NULL, '', 247350),
(374393, 'PTHR31126:SF56', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE DSP4-RELATED', 247350),
(374394, 'PTHR31126:SF75', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE DSP1-LIKE ISOFORM X1', 247350),
(374395, 'PTHR31126:SF53', NULL, NULL, NULL, NULL, 'PHOSPHOTYROSINE PROTEIN PHOSPHATASES SUPERFAMILY PROTEIN ISOFORM 1', 247350),
(374396, 'PTHR31126:SF54', NULL, NULL, NULL, NULL, 'BNAA05G10690D PROTEIN', 247350),
(374397, 'PTHR31126:SF10', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G06650)-RELATED', 247350),
(374398, 'PTHR31126:SF51', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE DSP4-RELATED', 247350),
(374399, 'PTHR31126:SF73', NULL, NULL, NULL, NULL, 'TYR_PHOSPHATASE_2 DOMAIN-CONTAINING PROTEIN', 247350),
(374400, 'PTHR31126:SF74', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE-LIKE PROTEIN OCA2', 247350),
(374401, 'PTHR31126:SF60', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE SIW14', 247350),
(374402, 'PTHR31126', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE', 247350),
(374403, 'PTHR31126:SF61', NULL, NULL, NULL, NULL, 'BNAC02G06640D PROTEIN', 247350),
(374404, 'PTHR31126:SF8', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE OCA1-RELATED', 247350),
(374405, 'PTHR31126:SF48', NULL, NULL, NULL, NULL, 'INOSITOL PHOSPHATASE SIW14', 247350),
(374406, 'PTHR31126:SF46', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE DSP5', 247350),
(374407, 'PTHR31126:SF68', NULL, NULL, NULL, NULL, '', 247350),
(374408, 'PTHR31126:SF69', NULL, NULL, NULL, NULL, 'OS09G0135700 PROTEIN', 247350),
(374409, 'PTHR31126:SF43', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE DSP3', 247350),
(374410, 'PTHR31126:SF62', NULL, NULL, NULL, NULL, 'TYR_PHOSPHATASE_2 DOMAIN-CONTAINING PROTEIN', 247350),
(374411, 'PTHR31126:SF63', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE DSP2', 247350),
(374412, 'PTHR31126:SF71', NULL, NULL, NULL, NULL, '', 247350),
(374413, 'PTHR31126:SF72', NULL, NULL, NULL, NULL, 'PROTEIN TYROSINE PHOSPHATASE TPBA', 247350),
(374414, 'PTHR31126:SF70', NULL, NULL, NULL, NULL, 'PROTEIN OCA4', 247350),
(374415, 'PTHR20974', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247351),
(374416, 'PTHR20974:SF0', NULL, NULL, NULL, NULL, 'UPF0585 PROTEIN CG18661', 247351),
(374417, 'PTHR20974:SF2', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE-LIKE 26', 247351);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(374418, 'PTHR20974:SF1', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE-LIKE 26 B', 247351),
(374419, 'PTHR15923:SF1', NULL, NULL, NULL, NULL, 'LIPOLYSIS-STIMULATED LIPOPROTEIN RECEPTOR', 247352),
(374420, 'PTHR15923:SF3', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN-LIKE DOMAIN-CONTAINING RECEPTOR 1', 247352),
(374421, 'PTHR15923', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AND IMMUNOGLOBULIN DOMAIN-CONTAINING PROTEIN', 247352),
(374422, 'PTHR15923:SF0', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN-LIKE DOMAIN-CONTAINING RECEPTOR 2', 247352),
(374423, 'PTHR15923:SF6', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN-LIKE DOMAIN-CONTAINING RECEPTOR 1B', 247352),
(374424, 'PTHR12320:SF50', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE', 247353),
(374425, 'PTHR12320:SF79', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE', 247353),
(374426, 'PTHR12320:SF78', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247353),
(374427, 'PTHR12320:SF56', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE', 247353),
(374428, 'PTHR12320:SF37', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE', 247353),
(374429, 'PTHR12320:SF59', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE', 247353),
(374430, 'PTHR12320:SF14', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE', 247353),
(374431, 'PTHR12320:SF58', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE', 247353),
(374432, 'PTHR12320:SF75', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE', 247353),
(374433, 'PTHR12320:SF74', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE', 247353),
(374434, 'PTHR12320:SF52', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C BIPP2C1-RELATED', 247353),
(374435, 'PTHR12320:SF77', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE', 247353),
(374436, 'PTHR12320:SF76', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE', 247353),
(374437, 'PTHR12320:SF39', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE', 247353),
(374438, 'PTHR12320', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C', 247353),
(374439, 'PTHR12320:SF60', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 26-RELATED', 247353),
(374440, 'PTHR12320:SF82', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE', 247353),
(374441, 'PTHR12320:SF81', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE PTC7 HOMOLOG', 247353),
(374442, 'PTHR12320:SF40', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE PTC7 HOMOLOG', 247353),
(374443, 'PTHR12320:SF83', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 55-RELATED', 247353),
(374444, 'PTHR12320:SF80', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN-CONTAINING PROTEIN-RELATED', 247353),
(374445, 'PTHR12320:SF24', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE', 247353),
(374446, 'PTHR12320:SF67', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE', 247353),
(374447, 'PTHR12320:SF69', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE', 247353),
(374448, 'PTHR12320:SF47', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE', 247353),
(374449, 'PTHR12320:SF65', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE', 247353),
(374450, 'PTHR12320:SF49', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 80-RELATED', 247353),
(374451, 'PTHR12320:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C HOMOLOG 7, MITOCHONDRIAL', 247353),
(374452, 'PTHR35698:SF2', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN RHL1', 247354),
(374453, 'PTHR35698', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN RHL1', 247354),
(374454, 'PTHR46804', NULL, NULL, NULL, NULL, 'ADP RIBOSYLATION FACTOR LIKE GTPASE 14 EFFECTOR PROTEIN LIKE', 247355),
(374455, 'PTHR46804:SF4', NULL, NULL, NULL, NULL, 'ARL14 EFFECTOR PROTEIN-LIKE', 247355),
(374456, 'PTHR22235:SF2', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 30', 247356),
(374457, 'PTHR22235', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 30', 247356),
(374458, 'PTHR30546:SF42', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE)', 247357),
(374459, 'PTHR30546:SF41', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE)', 247357),
(374460, 'PTHR30546:SF40', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE)', 247357),
(374461, 'PTHR30546:SF57', NULL, NULL, NULL, NULL, 'FLAVODOXIN FAMILY PROTEIN', 247357),
(374462, 'PTHR30546:SF35', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE)', 247357);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(374463, 'PTHR30546:SF3', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE) FQR1-LIKE 2-RELATED', 247357),
(374464, 'PTHR30546:SF56', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE)', 247357),
(374465, 'PTHR30546:SF32', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE)', 247357),
(374466, 'PTHR30546:SF39', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE)', 247357),
(374467, 'PTHR30546:SF7', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE)', 247357),
(374468, 'PTHR30546:SF38', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE)', 247357),
(374469, 'PTHR30546:SF59', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE)', 247357),
(374470, 'PTHR30546:SF58', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE)', 247357),
(374471, 'PTHR30546:SF31', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE)', 247357),
(374472, 'PTHR30546:SF53', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE)', 247357),
(374473, 'PTHR30546:SF51', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE)', 247357),
(374474, 'PTHR30546:SF50', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE)', 247357),
(374475, 'PTHR30546', NULL, NULL, NULL, NULL, 'FLAVODOXIN-RELATED PROTEIN WRBA-RELATED', 247357),
(374476, 'PTHR30546:SF46', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE) FQR1-LIKE 1-RELATED', 247357),
(374477, 'PTHR30546:SF24', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE)', 247357),
(374478, 'PTHR30546:SF23', NULL, NULL, NULL, NULL, 'FLAVOPROTEIN-LIKE PROTEIN YCP4-RELATED', 247357),
(374479, 'PTHR30546:SF22', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE)', 247357),
(374480, 'PTHR30546:SF44', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE)', 247357),
(374481, 'PTHR30546:SF43', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE)', 247357),
(374482, 'PTHR30546:SF49', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE)', 247357),
(374483, 'PTHR30546:SF25', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE) FQR1-LIKE 3-RELATED', 247357),
(374484, 'PTHR30546:SF47', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE (QUINONE)', 247357),
(374485, 'PTHR34290', NULL, NULL, NULL, NULL, 'SI:CH73-390P7.2', 247358),
(374486, 'PTHR34290:SF2', NULL, NULL, NULL, NULL, 'SI:CH73-390P7.2', 247358),
(374487, 'PTHR12072', NULL, NULL, NULL, NULL, 'CWF19, CELL CYCLE CONTROL PROTEIN', 247359),
(374488, 'PTHR12072:SF4', NULL, NULL, NULL, NULL, 'CWF19-LIKE PROTEIN 1', 247359),
(374489, 'PTHR12072:SF5', NULL, NULL, NULL, NULL, 'CWF19-LIKE PROTEIN 2', 247359),
(374490, 'PTHR13803:SF10', NULL, NULL, NULL, NULL, 'OS04G0412900 PROTEIN', 247360),
(374491, 'PTHR13803:SF43', NULL, NULL, NULL, NULL, 'SI:DKEY-9K7.3', 247360),
(374492, 'PTHR13803:SF42', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC24B', 247360),
(374493, 'PTHR13803:SF45', NULL, NULL, NULL, NULL, 'BNAA05G30470D PROTEIN', 247360),
(374494, 'PTHR13803:SF34', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC24-LIKE CEF', 247360),
(374495, 'PTHR13803:SF33', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC24-LIKE CEF', 247360),
(374496, 'PTHR13803:SF36', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 247360),
(374497, 'PTHR13803:SF46', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 247360),
(374498, 'PTHR13803:SF37', NULL, NULL, NULL, NULL, 'SEC23/SEC24 PROTEIN TRANSPORT FAMILY PROTEIN-RELATED', 247360),
(374499, 'PTHR13803:SF29', NULL, NULL, NULL, NULL, '', 247360),
(374500, 'PTHR13803:SF17', NULL, NULL, NULL, NULL, 'OS05G0443300 PROTEIN', 247360),
(374501, 'PTHR13803:SF39', NULL, NULL, NULL, NULL, 'SECRETORY 24AB, ISOFORM A', 247360),
(374502, 'PTHR13803:SF5', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC24C', 247360),
(374503, 'PTHR13803:SF4', NULL, NULL, NULL, NULL, 'SECRETORY 24CD, ISOFORM C', 247360),
(374504, 'PTHR13803:SF6', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC24D', 247360),
(374505, 'PTHR13803', NULL, NULL, NULL, NULL, 'SEC24-RELATED PROTEIN', 247360),
(374506, 'PTHR13803:SF1', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC24A', 247360);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(374507, 'PTHR13803:SF41', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR, TYPE A-RELATED', 247360),
(374508, 'PTHR13803:SF30', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC24-LIKE CEF', 247360),
(374509, 'PTHR13803:SF40', NULL, NULL, NULL, NULL, 'BNAA01G32450D PROTEIN', 247360),
(374510, 'PTHR13603:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 186', 247361),
(374511, 'PTHR13603', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247361),
(374512, 'PTHR10539:SF5', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 13 HOMOLOG B', 247362),
(374513, 'PTHR10539', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 13', 247362),
(374514, 'PTHR10539:SF3', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 13 HOMOLOG A', 247362),
(374515, 'PTHR10539:SF0', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 13', 247362),
(374516, 'PTHR10539:SF7', NULL, NULL, NULL, NULL, 'PROTEASOME COMPONENT (PCI) DOMAIN PROTEIN-RELATED', 247362),
(374517, 'PTHR10539:SF8', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 13 HOMOLOG B', 247362),
(374518, 'PTHR10678:SF14', NULL, NULL, NULL, NULL, 'PCI DOMAIN-CONTAINING PROTEIN', 247363),
(374519, 'PTHR10678:SF6', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 11A', 247363),
(374520, 'PTHR10678:SF3', NULL, NULL, NULL, NULL, 'COP9 SIGNALOSOME COMPLEX SUBUNIT 2', 247363),
(374521, 'PTHR10678:SF4', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 11B', 247363),
(374522, 'PTHR10678:SF13', NULL, NULL, NULL, NULL, 'COP9 SIGNALOSOME COMPLEX SUBUNIT', 247363),
(374523, 'PTHR10678:SF10', NULL, NULL, NULL, NULL, 'COP9 SIGNALOSOME COMPLEX SUBUNIT 2', 247363),
(374524, 'PTHR10678:SF9', NULL, NULL, NULL, NULL, 'PCI DOMAIN-CONTAINING PROTEIN', 247363),
(374525, 'PTHR10678:SF11', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 11-LIKE PROTEIN', 247363),
(374526, 'PTHR10678', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 11/COP9 SIGNALOSOME COMPLEX SUBUNIT 2', 247363),
(374527, 'PTHR10678:SF7', NULL, NULL, NULL, NULL, '26S PROTEASOME REGULATORY SUBUNIT RPN-6.2-RELATED', 247363),
(374528, 'PTHR10678:SF2', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 11', 247363),
(374529, 'PTHR10678:SF16', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 247363),
(374530, 'PTHR30438', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247364),
(374531, 'PTHR30438:SF2', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 247364),
(374532, 'PTHR30438:SF1', NULL, NULL, NULL, NULL, '36 KDA ANTIGEN', 247364),
(374533, 'PTHR24225:SF17', NULL, NULL, NULL, NULL, 'FORMYL PEPTIDE RECEPTOR-RELATED SEQUENCE 6-RELATED', 247365),
(374534, 'PTHR24225:SF18', NULL, NULL, NULL, NULL, 'FORMYL PEPTIDE RECEPTOR-RELATED SEQUENCE 3', 247365),
(374535, 'PTHR24225:SF5', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 33-RELATED', 247365),
(374536, 'PTHR24225:SF15', NULL, NULL, NULL, NULL, 'FMET-LEU-PHE RECEPTOR', 247365),
(374537, 'PTHR24225:SF59', NULL, NULL, NULL, NULL, 'C3A ANAPHYLATOXIN CHEMOTACTIC RECEPTOR-LIKE', 247365),
(374538, 'PTHR24225:SF16', NULL, NULL, NULL, NULL, 'N-FORMYL PEPTIDE RECEPTOR 3', 247365),
(374539, 'PTHR24225:SF57', NULL, NULL, NULL, NULL, 'CHEMOKINE-LIKE RECEPTOR 1', 247365),
(374540, 'PTHR24225:SF58', NULL, NULL, NULL, NULL, '', 247365),
(374541, 'PTHR24225:SF55', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 247365),
(374542, 'PTHR24225:SF1', NULL, NULL, NULL, NULL, 'C5A ANAPHYLATOXIN CHEMOTACTIC RECEPTOR 2', 247365),
(374543, 'PTHR24225:SF56', NULL, NULL, NULL, NULL, 'C5A ANAPHYLATOXIN CHEMOTACTIC RECEPTOR 1', 247365),
(374544, 'PTHR24225:SF0', NULL, NULL, NULL, NULL, 'N-FORMYL PEPTIDE RECEPTOR 2', 247365),
(374545, 'PTHR24225:SF51', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 247365),
(374546, 'PTHR24225:SF52', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 247365),
(374547, 'PTHR24225:SF50', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 247365);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(374548, 'PTHR24225', NULL, NULL, NULL, NULL, 'CHEMOTACTIC RECEPTOR', 247365),
(374549, 'PTHR24225:SF28', NULL, NULL, NULL, NULL, 'C3A ANAPHYLATOXIN CHEMOTACTIC RECEPTOR', 247365),
(374550, 'PTHR24225:SF29', NULL, NULL, NULL, NULL, 'C5A ANAPHYLATOXIN CHEMOTACTIC RECEPTOR 1', 247365),
(374551, 'PTHR24225:SF48', NULL, NULL, NULL, NULL, 'SI:CH73-160I9.3-RELATED', 247365),
(374552, 'PTHR24225:SF26', NULL, NULL, NULL, NULL, 'FORMYL PEPTIDE RECEPTOR-RELATED SEQUENCE 4', 247365),
(374553, 'PTHR24225:SF49', NULL, NULL, NULL, NULL, 'CHEMOKINE-LIKE RECEPTOR 1', 247365),
(374554, 'PTHR24225:SF27', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 32-RELATED', 247365),
(374555, 'PTHR24225:SF24', NULL, NULL, NULL, NULL, '', 247365),
(374556, 'PTHR24225:SF60', NULL, NULL, NULL, NULL, 'FMET-LEU-PHE RECEPTOR', 247365),
(374557, 'PTHR24225:SF61', NULL, NULL, NULL, NULL, 'LEUKOTRIENE B4 RECEPTOR 1', 247365),
(374558, 'PTHR11758:SF42', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S15A-2', 247366),
(374559, 'PTHR11758:SF41', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S15A', 247366),
(374560, 'PTHR11758:SF4', NULL, NULL, NULL, NULL, '37S RIBOSOMAL PROTEIN S8, MITOCHONDRIAL', 247366),
(374561, 'PTHR11758', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S15A', 247366),
(374562, 'PTHR11758:SF28', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S15A-2', 247366),
(374563, 'PTHR11758:SF16', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S15A', 247366),
(374564, 'PTHR11758:SF37', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S15A', 247366),
(374565, 'PTHR11758:SF36', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 247366),
(374566, 'PTHR11758:SF35', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S15A-1-RELATED', 247366),
(374567, 'PTHR11758:SF13', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S15A', 247366),
(374568, 'PTHR11758:SF34', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S15A', 247366),
(374569, 'PTHR11758:SF11', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S15A-5', 247366),
(374570, 'PTHR11758:SF43', NULL, NULL, NULL, NULL, 'OS01G0153200 PROTEIN', 247366),
(374571, 'PTHR47089:SF1', NULL, NULL, NULL, NULL, 'GUANOSINE ABC TRANSPORTER PERMEASE PROTEIN NUPP', 247367),
(374572, 'PTHR47089', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, PERMEASE PROTEIN', 247367),
(374573, 'PTHR34394', NULL, NULL, NULL, NULL, 'SIMILAR TO RIKEN CDNA 2310022B05', 247368),
(374574, 'PTHR34394:SF1', NULL, NULL, NULL, NULL, 'SIMILAR TO RIKEN CDNA 2310022B05', 247368),
(374575, 'PTHR46687:SF1', NULL, NULL, NULL, NULL, 'PROTEIN DISPATCHED HOMOLOG 3', 247369),
(374576, 'PTHR46687', NULL, NULL, NULL, NULL, 'PROTEIN DISPATCHED HOMOLOG 3', 247369),
(374577, 'PTHR30060:SF0', NULL, NULL, NULL, NULL, 'COILED-COIL PROTEIN (DUF2040)-RELATED', 247370),
(374578, 'PTHR30060', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN', 247370),
(374579, 'PTHR33413:SF6', NULL, NULL, NULL, NULL, 'OS06G0236300 PROTEIN', 247371),
(374580, 'PTHR33413:SF23', NULL, NULL, NULL, NULL, '', 247371),
(374581, 'PTHR33413:SF34', NULL, NULL, NULL, NULL, '', 247371),
(374582, 'PTHR33413:SF4', NULL, NULL, NULL, NULL, 'D-RIBOSE-BINDING PERIPLASMIC PROTEIN', 247371),
(374583, 'PTHR33413:SF35', NULL, NULL, NULL, NULL, 'OS09G0381600 PROTEIN', 247371),
(374584, 'PTHR33413:SF32', NULL, NULL, NULL, NULL, 'BNAANNG05050D PROTEIN', 247371),
(374585, 'PTHR33413', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247371),
(374586, 'PTHR33413:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247371),
(374587, 'PTHR33413:SF33', NULL, NULL, NULL, NULL, 'DUF4228 DOMAIN PROTEIN', 247371),
(374588, 'PTHR33413:SF22', NULL, NULL, NULL, NULL, 'OS08G0420700 PROTEIN', 247371),
(374589, 'PTHR33413:SF30', NULL, NULL, NULL, NULL, '', 247371),
(374590, 'PTHR33413:SF20', NULL, NULL, NULL, NULL, 'BASIC-LEUCINE ZIPPER TRANSCRIPTION FACTOR K', 247371),
(374591, 'PTHR33413:SF31', NULL, NULL, NULL, NULL, 'BNAC09G14830D PROTEIN', 247371),
(374592, 'PTHR33413:SF38', NULL, NULL, NULL, NULL, 'BNAA09G07270D PROTEIN', 247371),
(374593, 'PTHR33413:SF27', NULL, NULL, NULL, NULL, 'BNAC03G48170D PROTEIN', 247371);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(374594, 'PTHR33413:SF39', NULL, NULL, NULL, NULL, 'OS02G0741700 PROTEIN', 247371),
(374595, 'PTHR33413:SF37', NULL, NULL, NULL, NULL, '', 247371),
(374596, 'PTHR43593:SF1', NULL, NULL, NULL, NULL, 'INOSITOL 2-DEHYDROGENASE', 247372),
(374597, 'PTHR43593:SF2', NULL, NULL, NULL, NULL, 'OS08G0148267 PROTEIN', 247372),
(374598, 'PTHR43593', NULL, NULL, NULL, NULL, '', 247372),
(374599, 'PTHR38365:SF1', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN-RELATED', 247373),
(374600, 'PTHR38365', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN-RELATED', 247373),
(374601, 'PTHR38365:SF4', NULL, NULL, NULL, NULL, '', 247373),
(374602, 'PTHR38365:SF2', NULL, NULL, NULL, NULL, '', 247373),
(374603, 'PTHR38365:SF3', NULL, NULL, NULL, NULL, 'BNAC07G18580D PROTEIN', 247373),
(374604, 'PTHR24144:SF5', NULL, NULL, NULL, NULL, 'MYND-TYPE DOMAIN-CONTAINING PROTEIN', 247374),
(374605, 'PTHR24144', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 49', 247374),
(374606, 'PTHR21585:SF0', NULL, NULL, NULL, NULL, 'ARMADILLO-LIKE HELICAL DOMAIN-CONTAINING PROTEIN 4', 247375),
(374607, 'PTHR21585', NULL, NULL, NULL, NULL, 'FULL-LENGTH CDNA CLONE CS0DC025YL05 OF NEUROBLASTOMA', 247375),
(374608, 'PTHR22943:SF76', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374609, 'PTHR22943:SF77', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374610, 'PTHR22943:SF78', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374611, 'PTHR22943:SF35', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374612, 'PTHR22943:SF38', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN-RELATED', 247376),
(374613, 'PTHR22943:SF39', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374614, 'PTHR22943:SF137', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374615, 'PTHR22943:SF254', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374616, 'PTHR22943:SF253', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374617, 'PTHR22943:SF250', NULL, NULL, NULL, NULL, 'PROTEIN CBG05658', 247376),
(374618, 'PTHR22943:SF251', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374619, 'PTHR22943:SF81', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374620, 'PTHR22943:SF82', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374621, 'PTHR22943:SF84', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374622, 'PTHR22943:SF40', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374623, 'PTHR22943:SF41', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374624, 'PTHR22943', NULL, NULL, NULL, NULL, '7-TRANSMEMBRANE DOMAIN RECEPTOR  C.ELEGANS', 247376),
(374625, 'PTHR22943:SF86', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374626, 'PTHR22943:SF87', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374627, 'PTHR22943:SF45', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374628, 'PTHR22943:SF89', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374629, 'PTHR22943:SF46', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374630, 'PTHR22943:SF47', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374631, 'PTHR22943:SF48', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374632, 'PTHR22943:SF49', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374633, 'PTHR22943:SF109', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374634, 'PTHR22943:SF106', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374635, 'PTHR22943:SF103', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374636, 'PTHR22943:SF100', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374637, 'PTHR22943:SF90', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374638, 'PTHR22943:SF94', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374639, 'PTHR22943:SF50', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374640, 'PTHR22943:SF95', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR STR-217', 247376),
(374641, 'PTHR22943:SF52', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374642, 'PTHR22943:SF97', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(374643, 'PTHR22943:SF12', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374644, 'PTHR22943:SF59', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 247376),
(374645, 'PTHR22943:SF17', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374646, 'PTHR22943:SF18', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374647, 'PTHR22943:SF116', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS R-10', 247376),
(374648, 'PTHR22943:SF113', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374649, 'PTHR22943:SF111', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374650, 'PTHR22943:SF112', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374651, 'PTHR22943:SF60', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374652, 'PTHR22943:SF61', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374653, 'PTHR22943:SF62', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374654, 'PTHR22943:SF64', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374655, 'PTHR22943:SF20', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374656, 'PTHR22943:SF65', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374657, 'PTHR22943:SF23', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374658, 'PTHR22943:SF67', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374659, 'PTHR22943:SF68', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374660, 'PTHR22943:SF6', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374661, 'PTHR22943:SF24', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374662, 'PTHR22943:SF25', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374663, 'PTHR22943:SF26', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374664, 'PTHR22943:SF28', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374665, 'PTHR22943:SF29', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374666, 'PTHR22943:SF249', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374667, 'PTHR22943:SF129', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374668, 'PTHR22943:SF126', NULL, NULL, NULL, NULL, 'PROTEIN CBG00350', 247376),
(374669, 'PTHR22943:SF248', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374670, 'PTHR22943:SF245', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374671, 'PTHR22943:SF246', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374672, 'PTHR22943:SF242', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374673, 'PTHR22943:SF121', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374674, 'PTHR22943:SF70', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374675, 'PTHR22943:SF71', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374676, 'PTHR22943:SF73', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', 247376),
(374677, 'PTHR47708', NULL, NULL, NULL, NULL, '', 247377),
(374678, 'PTHR47708:SF2', NULL, NULL, NULL, NULL, 'SI:CH73-132F6.5', 247377),
(374679, 'PTHR33165:SF33', NULL, NULL, NULL, NULL, '', 247378),
(374680, 'PTHR33165:SF11', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 247378),
(374681, 'PTHR33165:SF76', NULL, NULL, NULL, NULL, 'OS01G0526550 PROTEIN', 247378),
(374682, 'PTHR33165:SF54', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 247378),
(374683, 'PTHR33165:SF75', NULL, NULL, NULL, NULL, 'OS04G0583000 PROTEIN', 247378),
(374684, 'PTHR33165:SF53', NULL, NULL, NULL, NULL, 'OS07G0177000 PROTEIN', 247378),
(374685, 'PTHR33165:SF30', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 247378),
(374686, 'PTHR33165:SF52', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 247378),
(374687, 'PTHR33165:SF36', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 247378),
(374688, 'PTHR33165:SF58', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 247378),
(374689, 'PTHR33165:SF57', NULL, NULL, NULL, NULL, 'OS04G0280100 PROTEIN', 247378),
(374690, 'PTHR33165:SF35', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 247378),
(374691, 'PTHR33165:SF78', NULL, NULL, NULL, NULL, '', 247378);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(374692, 'PTHR33165:SF34', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 247378),
(374693, 'PTHR33165', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN-LIKE-RELATED', 247378),
(374694, 'PTHR33165:SF90', NULL, NULL, NULL, NULL, '', 247378),
(374695, 'PTHR33165:SF73', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 247378),
(374696, 'PTHR33165:SF50', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247378),
(374697, 'PTHR33165:SF72', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 247378),
(374698, 'PTHR33165:SF28', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 247378),
(374699, 'PTHR33165:SF49', NULL, NULL, NULL, NULL, '', 247378),
(374700, 'PTHR33165:SF88', NULL, NULL, NULL, NULL, 'OS04G0486300 PROTEIN', 247378),
(374701, 'PTHR33165:SF66', NULL, NULL, NULL, NULL, '', 247378),
(374702, 'PTHR33165:SF65', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 247378),
(374703, 'PTHR33165:SF87', NULL, NULL, NULL, NULL, '', 247378),
(374704, 'PTHR33165:SF64', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 247378),
(374705, 'PTHR33165:SF86', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247378),
(374706, 'PTHR33165:SF85', NULL, NULL, NULL, NULL, 'OS08G0285100 PROTEIN', 247378),
(374707, 'PTHR33165:SF41', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 247378),
(374708, 'PTHR33165:SF63', NULL, NULL, NULL, NULL, 'OS03G0792300 PROTEIN', 247378),
(374709, 'PTHR33165:SF67', NULL, NULL, NULL, NULL, '', 247378),
(374710, 'PTHR33165:SF89', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 247378),
(374711, 'PTHR33165:SF84', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 247378),
(374712, 'PTHR33165:SF62', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 247378),
(374713, 'PTHR33165:SF83', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 247378),
(374714, 'PTHR33165:SF82', NULL, NULL, NULL, NULL, 'OS08G0363000 PROTEIN', 247378),
(374715, 'PTHR33165:SF81', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN-LIKE', 247378),
(374716, 'PTHR47809:SF2', NULL, NULL, NULL, NULL, 'DNA-BINDING BROMODOMAIN-CONTAINING PROTEIN', 247379),
(374717, 'PTHR47809', NULL, NULL, NULL, NULL, 'DNA-BINDING BROMODOMAIN-CONTAINING PROTEIN', 247379),
(374718, 'PTHR28634:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER B-BOX DOMAIN-CONTAINING PROTEIN 1', 247380),
(374719, 'PTHR28634', NULL, NULL, NULL, NULL, 'ZINC FINGER B-BOX DOMAIN-CONTAINING PROTEIN 1', 247380),
(374720, 'PTHR40849:SF2', NULL, NULL, NULL, NULL, '', 247381),
(374721, 'PTHR40849', NULL, NULL, NULL, NULL, 'C2 CALCIUM-DEPENDENT MEMBRANE TARGETING', 247381),
(374722, 'PTHR11315:SF10', NULL, NULL, NULL, NULL, 'FOLATE GAMMA-GLUTAMYL HYDROLASE', 247382),
(374723, 'PTHR11315:SF21', NULL, NULL, NULL, NULL, 'FOLATE GAMMA-GLUTAMYL HYDROLASE', 247382),
(374724, 'PTHR11315:SF20', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYL HYDROLASE', 247382),
(374725, 'PTHR11315', NULL, NULL, NULL, NULL, 'PROTEASE FAMILY C26 GAMMA-GLUTAMYL HYDROLASE', 247382),
(374726, 'PTHR11315:SF1', NULL, NULL, NULL, NULL, 'FOLATE GAMMA-GLUTAMYL HYDROLASE', 247382),
(374727, 'PTHR11315:SF14', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYL HYDROLASE A', 247382),
(374728, 'PTHR11315:SF13', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYL HYDROLASE 3-RELATED', 247382),
(374729, 'PTHR11315:SF0', NULL, NULL, NULL, NULL, 'FOLATE GAMMA-GLUTAMYL HYDROLASE', 247382),
(374730, 'PTHR11315:SF12', NULL, NULL, NULL, NULL, 'FOLATE GAMMA-GLUTAMYL HYDROLASE', 247382),
(374731, 'PTHR11315:SF16', NULL, NULL, NULL, NULL, 'FOLATE GAMMA-GLUTAMYL HYDROLASE', 247382),
(374732, 'PTHR11315:SF15', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYL HYDROLASE 1', 247382),
(374733, 'PTHR11315:SF19', NULL, NULL, NULL, NULL, 'FOLATE GAMMA-GLUTAMYL HYDROLASE', 247382),
(374734, 'PTHR44307:SF10', NULL, NULL, NULL, NULL, 'PHOSPHOETHANOLAMINE N-METHYLTRANSFERASE', 247383),
(374735, 'PTHR44307:SF2', NULL, NULL, NULL, NULL, 'PHOSPHOETHANOLAMINE METHYLTRANSFERASE', 247383),
(374736, 'PTHR44307:SF12', NULL, NULL, NULL, NULL, 'METHYLTRANSF_25 DOMAIN-CONTAINING PROTEIN', 247383);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(374737, 'PTHR44307:SF13', NULL, NULL, NULL, NULL, 'PHOSPHOETHANOLAMINE N-METHYLTRANSFERASE 1-LIKE', 247383),
(374738, 'PTHR44307:SF6', NULL, NULL, NULL, NULL, 'PHOSPHOETHANOLAMINE N-METHYLTRANSFERASE 1', 247383),
(374739, 'PTHR44307', NULL, NULL, NULL, NULL, 'PHOSPHOETHANOLAMINE METHYLTRANSFERASE', 247383),
(374740, 'PTHR44307:SF14', NULL, NULL, NULL, NULL, 'OS05G0548900 PROTEIN', 247383),
(374741, 'PTHR44307:SF16', NULL, NULL, NULL, NULL, 'PHOSPHOETHANOLAMINE N-METHYLTRANSFERASE-LIKE', 247383),
(374742, 'PTHR44307:SF8', NULL, NULL, NULL, NULL, 'PHOSPHOETHANOLAMINE N-METHYLTRANSFERASE-RELATED', 247383),
(374743, 'PTHR44307:SF17', NULL, NULL, NULL, NULL, 'PHOSPHOETHANOLAMINE N-METHYLTRANSFERASE 3', 247383),
(374744, 'PTHR44307:SF18', NULL, NULL, NULL, NULL, 'PHOSPHOETHANOLAMINE N-METHYLTRANSFERASE 1', 247383),
(374745, 'PTHR14226:SF79', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 247384),
(374746, 'PTHR14226:SF57', NULL, NULL, NULL, NULL, 'BLR7027 PROTEIN', 247384),
(374747, 'PTHR14226:SF25', NULL, NULL, NULL, NULL, 'PHOSPHOESTERASE-RELATED', 247384),
(374748, 'PTHR14226:SF77', NULL, NULL, NULL, NULL, 'ACYL TRANSFERASE/ACYL HYDROLASE/LYSOPHOSPHOLIPASE, TRIACYLGLYCEROL LIPASE-RELATED', 247384),
(374749, 'PTHR14226:SF44', NULL, NULL, NULL, NULL, 'TRIACYLGLYCEROL LIPASE 3', 247384),
(374750, 'PTHR14226:SF66', NULL, NULL, NULL, NULL, 'TRIACYLGLYCEROL LIPASE PTL2', 247384),
(374751, 'PTHR14226:SF23', NULL, NULL, NULL, NULL, 'PATATIN-LIKE PHOSPHOLIPASE DOMAIN-CONTAINING PROTEIN 7', 247384),
(374752, 'PTHR14226:SF78', NULL, NULL, NULL, NULL, 'SLR0060 PROTEIN', 247384),
(374753, 'PTHR14226:SF29', NULL, NULL, NULL, NULL, 'NEUROPATHY TARGET ESTERASE SWS', 247384),
(374754, 'PTHR14226:SF26', NULL, NULL, NULL, NULL, 'PATATIN-LIKE PHOSPHOLIPASE DOMAIN-CONTAINING PROTEIN 6', 247384),
(374755, 'PTHR14226:SF71', NULL, NULL, NULL, NULL, 'TRIACYLGLYCEROL LIPASE SDP1-LIKE ISOFORM X1', 247384),
(374756, 'PTHR14226:SF72', NULL, NULL, NULL, NULL, 'TRIACYLGLYCEROL LIPASE-RELATED', 247384),
(374757, 'PTHR14226:SF80', NULL, NULL, NULL, NULL, 'PNPLA DOMAIN-CONTAINING PROTEIN', 247384),
(374758, 'PTHR14226:SF70', NULL, NULL, NULL, NULL, 'PNPLA DOMAIN-CONTAINING PROTEIN', 247384),
(374759, 'PTHR14226:SF64', NULL, NULL, NULL, NULL, 'PNPLA DOMAIN-CONTAINING PROTEIN', 247384),
(374760, 'PTHR14226:SF75', NULL, NULL, NULL, NULL, 'TRIACYLGLYCEROL LIPASE SDP1L', 247384),
(374761, 'PTHR14226:SF21', NULL, NULL, NULL, NULL, 'PATATIN-LIKE PHOSPHOLIPASE DOMAIN-CONTAINING PROTEIN M110.7-RELATED', 247384),
(374762, 'PTHR14226:SF10', NULL, NULL, NULL, NULL, 'TRIACYLGLYCEROL LIPASE 4-RELATED', 247384),
(374763, 'PTHR14226:SF76', NULL, NULL, NULL, NULL, 'NTE FAMILY PROTEIN RSSA', 247384),
(374764, 'PTHR14226:SF73', NULL, NULL, NULL, NULL, 'PNPLA DOMAIN-CONTAINING PROTEIN', 247384),
(374765, 'PTHR14226:SF30', NULL, NULL, NULL, NULL, 'OS03G0810900 PROTEIN', 247384),
(374766, 'PTHR14226:SF74', NULL, NULL, NULL, NULL, 'BLR4684 PROTEIN', 247384),
(374767, 'PTHR14226', NULL, NULL, NULL, NULL, 'NEUROPATHY TARGET ESTERASE/SWISS CHEESE D.MELANOGASTER', 247384),
(374768, 'PTHR17490:SF14', NULL, NULL, NULL, NULL, 'YRDC-LIKE DOMAIN-CONTAINING PROTEIN', 247385),
(374769, 'PTHR17490:SF16', NULL, NULL, NULL, NULL, 'THREONYLCARBAMOYL-AMP SYNTHASE', 247385),
(374770, 'PTHR17490:SF17', NULL, NULL, NULL, NULL, 'YRDC-LIKE DOMAIN-CONTAINING PROTEIN', 247385),
(374771, 'PTHR17490:SF18', NULL, NULL, NULL, NULL, 'THREONYLCARBAMOYL-AMP SYNTHASE', 247385),
(374772, 'PTHR17490', NULL, NULL, NULL, NULL, 'SUA5', 247385),
(374773, 'PTHR17490:SF10', NULL, NULL, NULL, NULL, 'YRDC DOMAIN-CONTAINING PROTEIN, MITOCHONDRIAL', 247385),
(374774, 'PTHR31448:SF43', NULL, NULL, NULL, NULL, 'ZEIN-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 247386),
(374775, 'PTHR31448:SF32', NULL, NULL, NULL, NULL, 'MYOSIN-BINDING PROTEIN 1', 247386),
(374776, 'PTHR31448:SF33', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247386),
(374777, 'PTHR31448:SF45', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247386),
(374778, 'PTHR31448:SF34', NULL, NULL, NULL, NULL, 'MYOSIN-BINDING PROTEIN 3', 247386);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(374779, 'PTHR31448:SF23', NULL, NULL, NULL, NULL, 'MYOSIN-BINDING PROTEIN 3', 247386),
(374780, 'PTHR31448:SF12', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247386),
(374781, 'PTHR31448:SF46', NULL, NULL, NULL, NULL, 'MYOSIN-BINDING PROTEIN 2-LIKE ISOFORM X1', 247386),
(374782, 'PTHR31448:SF37', NULL, NULL, NULL, NULL, 'GTD-BINDING DOMAIN-CONTAINING PROTEIN', 247386),
(374783, 'PTHR31448:SF48', NULL, NULL, NULL, NULL, 'GTD-BINDING DOMAIN-CONTAINING PROTEIN', 247386),
(374784, 'PTHR31448:SF38', NULL, NULL, NULL, NULL, 'GTD-BINDING DOMAIN-CONTAINING PROTEIN', 247386),
(374785, 'PTHR31448:SF49', NULL, NULL, NULL, NULL, 'MYOSIN-BINDING PROTEIN 5 ISOFORM X1-RELATED', 247386),
(374786, 'PTHR31448:SF39', NULL, NULL, NULL, NULL, 'MYOSIN-BINDING PROTEIN 4-RELATED', 247386),
(374787, 'PTHR31448:SF3', NULL, NULL, NULL, NULL, 'MYOSIN-BINDING PROTEIN 2', 247386),
(374788, 'PTHR31448:SF50', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN', 247386),
(374789, 'PTHR31448', NULL, NULL, NULL, NULL, 'MYOSIN-BINDING PROTEIN 2', 247386),
(374790, 'PTHR31448:SF51', NULL, NULL, NULL, NULL, 'MYOSIN-BINDING PROTEIN 6-RELATED', 247386),
(374791, 'PTHR31448:SF30', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247386),
(374792, 'PTHR31448:SF52', NULL, NULL, NULL, NULL, 'ZEIN-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 247386),
(374793, 'PTHR31448:SF31', NULL, NULL, NULL, NULL, 'MYOSIN-BINDING PROTEIN 5-RELATED', 247386),
(374794, 'PTHR31448:SF42', NULL, NULL, NULL, NULL, 'GTD-BINDING DOMAIN-CONTAINING PROTEIN', 247386),
(374795, 'PTHR31448:SF9', NULL, NULL, NULL, NULL, 'MYOSIN-BINDING PROTEIN 5-RELATED', 247386),
(374796, 'PTHR47064', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_1G08990)-RELATED', 247387),
(374797, 'PTHR47064:SF2', NULL, NULL, NULL, NULL, 'SGL DOMAIN-CONTAINING PROTEIN-RELATED', 247387),
(374798, 'PTHR36017:SF1', NULL, NULL, NULL, NULL, 'EMBRYO DEFECTIVE 1381', 247388),
(374799, 'PTHR36017', NULL, NULL, NULL, NULL, 'EMBRYO DEFECTIVE 1381', 247388),
(374800, 'PTHR22761:SF82', NULL, NULL, NULL, NULL, 'SNF7 FAMILY-RELATED', 247389),
(374801, 'PTHR22761:SF81', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 60.2', 247389),
(374802, 'PTHR22761:SF41', NULL, NULL, NULL, NULL, 'CHARGED MULTIVESICULAR BODY PROTEIN 4B-LIKE PROTEIN CHMP4BP1-RELATED', 247389),
(374803, 'PTHR22761:SF85', NULL, NULL, NULL, NULL, 'CHARGED MULTIVESICULAR BODY PROTEIN 5', 247389),
(374804, 'PTHR22761:SF66', NULL, NULL, NULL, NULL, 'CHARGED MULTIVESICULAR BODY PROTEIN 5-LIKE', 247389),
(374805, 'PTHR22761:SF88', NULL, NULL, NULL, NULL, 'CHARGED MULTIVESICULAR BODY PROTEIN 6', 247389),
(374806, 'PTHR22761:SF65', NULL, NULL, NULL, NULL, '', 247389),
(374807, 'PTHR22761:SF21', NULL, NULL, NULL, NULL, 'CHARGED MULTIVESICULAR BODY PROTEIN 7', 247389),
(374808, 'PTHR22761:SF87', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 32 HOMOLOG 2-LIKE', 247389),
(374809, 'PTHR22761:SF68', NULL, NULL, NULL, NULL, 'BNAA07G00950D PROTEIN', 247389),
(374810, 'PTHR22761:SF46', NULL, NULL, NULL, NULL, 'CHARGED MULTIVESICULAR BODY PROTEIN HOMOLOG', 247389),
(374811, 'PTHR22761:SF89', NULL, NULL, NULL, NULL, 'OS06G0608500 PROTEIN', 247389),
(374812, 'PTHR22761:SF47', NULL, NULL, NULL, NULL, '', 247389),
(374813, 'PTHR22761:SF91', NULL, NULL, NULL, NULL, 'OS07G0490700 PROTEIN', 247389),
(374814, 'PTHR22761:SF90', NULL, NULL, NULL, NULL, 'AEL183CP', 247389),
(374815, 'PTHR22761:SF93', NULL, NULL, NULL, NULL, '', 247389),
(374816, 'PTHR22761:SF92', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 32 HOMOLOG 2-LIKE', 247389),
(374817, 'PTHR22761:SF50', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 20 HOMOLOG 1', 247389),
(374818, 'PTHR22761:SF94', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 32 HOMOLOG 2', 247389),
(374819, 'PTHR22761:SF75', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 32 HOMOLOG 2', 247389),
(374820, 'PTHR22761:SF53', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 32 HOMOLOG 2-LIKE', 247389);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(374821, 'PTHR22761:SF52', NULL, NULL, NULL, NULL, '', 247389),
(374822, 'PTHR22761:SF77', NULL, NULL, NULL, NULL, 'CHARGED MULTIVESICULAR BODY PROTEIN 4C', 247389),
(374823, 'PTHR22761:SF10', NULL, NULL, NULL, NULL, 'GH13992P', 247389),
(374824, 'PTHR22761:SF57', NULL, NULL, NULL, NULL, '', 247389),
(374825, 'PTHR22761:SF56', NULL, NULL, NULL, NULL, 'OS11G0123500 PROTEIN', 247389),
(374826, 'PTHR22761:SF78', NULL, NULL, NULL, NULL, 'PROTEIN CBG02567', 247389),
(374827, 'PTHR22761:SF12', NULL, NULL, NULL, NULL, 'CHARGED MULTIVESICULAR BODY PROTEIN 5', 247389),
(374828, 'PTHR22761:SF14', NULL, NULL, NULL, NULL, 'CHARGED MULTIVESICULAR BODY PROTEIN 4A', 247389),
(374829, 'PTHR22761:SF17', NULL, NULL, NULL, NULL, 'OS01G0103000 PROTEIN', 247389),
(374830, 'PTHR22761', NULL, NULL, NULL, NULL, 'CHARGED MULTIVESICULAR BODY PROTEIN', 247389),
(374831, 'PTHR22761:SF18', NULL, NULL, NULL, NULL, 'SORTING PROTEIN SNF7 FAMILY PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G16692)-RELATED', 247389),
(374832, 'PTHR22761:SF7', NULL, NULL, NULL, NULL, 'SNF7 FAMILY PROTEIN', 247389),
(374833, 'PTHR22761:SF5', NULL, NULL, NULL, NULL, 'BCDNA.GH08385', 247389),
(374834, 'PTHR22761:SF4', NULL, NULL, NULL, NULL, 'CHARGED MULTIVESICULAR BODY PROTEIN 4B', 247389),
(374835, 'PTHR32212:SF348', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN, FBD DOMAIN, LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 247390),
(374836, 'PTHR32212:SF349', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374837, 'PTHR32212:SF342', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374838, 'PTHR32212:SF340', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374839, 'PTHR32212:SF341', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374840, 'PTHR32212:SF346', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 247390),
(374841, 'PTHR32212:SF347', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374842, 'PTHR32212:SF344', NULL, NULL, NULL, NULL, 'FBD DOMAIN FAMILY', 247390),
(374843, 'PTHR32212', NULL, NULL, NULL, NULL, 'CYCLIN-LIKE F-BOX', 247390),
(374844, 'PTHR32212:SF359', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374845, 'PTHR32212:SF354', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374846, 'PTHR32212:SF351', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 13-LIKE', 247390),
(374847, 'PTHR32212:SF357', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 247390),
(374848, 'PTHR32212:SF358', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374849, 'PTHR32212:SF234', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374850, 'PTHR32212:SF350', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374851, 'PTHR32212:SF406', NULL, NULL, NULL, NULL, 'BNAA02G05760D PROTEIN', 247390),
(374852, 'PTHR32212:SF408', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374853, 'PTHR32212:SF401', NULL, NULL, NULL, NULL, 'FBD-LIKE DOMAIN FAMILY PROTEIN', 247390),
(374854, 'PTHR32212:SF402', NULL, NULL, NULL, NULL, 'RNI-LIKE SUPERFAMILY PROTEIN-RELATED', 247390),
(374855, 'PTHR32212:SF248', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374856, 'PTHR32212:SF366', NULL, NULL, NULL, NULL, 'BNAC02G44930D PROTEIN', 247390),
(374857, 'PTHR32212:SF367', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374858, 'PTHR32212:SF247', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 247390),
(374859, 'PTHR32212:SF360', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 247390),
(374860, 'PTHR32212:SF361', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 247390),
(374861, 'PTHR32212:SF416', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 247390),
(374862, 'PTHR32212:SF415', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 247390),
(374863, 'PTHR32212:SF419', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374864, 'PTHR32212:SF375', NULL, NULL, NULL, NULL, 'BNAA03G10800D PROTEIN', 247390);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(374865, 'PTHR32212:SF376', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 247390),
(374866, 'PTHR32212:SF252', NULL, NULL, NULL, NULL, 'FBD / LEUCINE RICH REPEAT DOMAINS CONTAINING PROTEIN', 247390),
(374867, 'PTHR32212:SF255', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 247390),
(374868, 'PTHR32212:SF373', NULL, NULL, NULL, NULL, 'RNI-LIKE SUPERFAMILY PROTEIN', 247390),
(374869, 'PTHR32212:SF412', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374870, 'PTHR32212:SF256', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374871, 'PTHR32212:SF413', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374872, 'PTHR32212:SF377', NULL, NULL, NULL, NULL, 'BNACNNG44720D PROTEIN', 247390),
(374873, 'PTHR32212:SF378', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374874, 'PTHR32212:SF411', NULL, NULL, NULL, NULL, 'F-BOX FAMILY PROTEIN', 247390),
(374875, 'PTHR32212:SF372', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374876, 'PTHR32212:SF370', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 247390),
(374877, 'PTHR32212:SF250', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374878, 'PTHR32212:SF427', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374879, 'PTHR32212:SF305', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 247390),
(374880, 'PTHR32212:SF304', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374881, 'PTHR32212:SF428', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 247390),
(374882, 'PTHR32212:SF425', NULL, NULL, NULL, NULL, 'F-BOX/RNI/FBD-LIKE DOMAIN PROTEIN', 247390),
(374883, 'PTHR32212:SF307', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 247390),
(374884, 'PTHR32212:SF426', NULL, NULL, NULL, NULL, 'F-BOX/RNI-LIKE SUPERFAMILY PROTEIN-RELATED', 247390),
(374885, 'PTHR32212:SF429', NULL, NULL, NULL, NULL, 'ZF-HD HOMEOBOX PROTEIN', 247390),
(374886, 'PTHR32212:SF264', NULL, NULL, NULL, NULL, 'BNAC03G13640D PROTEIN', 247390),
(374887, 'PTHR32212:SF420', NULL, NULL, NULL, NULL, 'F-BOX/RNI/FBD-LIKE DOMAIN PROTEIN', 247390),
(374888, 'PTHR32212:SF384', NULL, NULL, NULL, NULL, 'F-BOX/RNI-LIKE SUPERFAMILY PROTEIN-RELATED', 247390),
(374889, 'PTHR32212:SF385', NULL, NULL, NULL, NULL, 'F-BOX/RNI/FBD-LIKE DOMAIN PROTEIN', 247390),
(374890, 'PTHR32212:SF301', NULL, NULL, NULL, NULL, 'FBD / LEUCINE RICH REPEAT DOMAINS CONTAINING PROTEIN', 247390),
(374891, 'PTHR32212:SF423', NULL, NULL, NULL, NULL, '', 247390),
(374892, 'PTHR32212:SF267', NULL, NULL, NULL, NULL, 'F-BOX/RNI/FBD-LIKE DOMAIN PROTEIN', 247390),
(374893, 'PTHR32212:SF424', NULL, NULL, NULL, NULL, 'SUPERFAMILY PROTEIN, PUTATIVE-RELATED', 247390),
(374894, 'PTHR32212:SF388', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374895, 'PTHR32212:SF421', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374896, 'PTHR32212:SF422', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374897, 'PTHR32212:SF302', NULL, NULL, NULL, NULL, 'FBD / LEUCINE RICH REPEAT DOMAINS CONTAINING PROTEIN', 247390),
(374898, 'PTHR32212:SF269', NULL, NULL, NULL, NULL, 'F-BOX/RNI/FBD-LIKE DOMAIN PROTEIN', 247390),
(374899, 'PTHR32212:SF389', NULL, NULL, NULL, NULL, 'BNAA03G10780D PROTEIN', 247390),
(374900, 'PTHR32212:SF382', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 247390),
(374901, 'PTHR32212:SF260', NULL, NULL, NULL, NULL, 'F-BOX/RNI-LIKE SUPERFAMILY PROTEIN-RELATED', 247390),
(374902, 'PTHR32212:SF383', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT (LRR) FAMILY PROTEIN', 247390),
(374903, 'PTHR32212:SF262', NULL, NULL, NULL, NULL, 'FBD, F-BOX AND LEUCINE RICH REPEAT DOMAINS CONTAINING PROTEIN', 247390),
(374904, 'PTHR32212:SF381', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374905, 'PTHR32212:SF438', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374906, 'PTHR32212:SF439', NULL, NULL, NULL, NULL, 'F-BOX/RNI/FBD-LIKE DOMAIN PROTEIN', 247390);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(374907, 'PTHR32212:SF318', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374908, 'PTHR32212:SF436', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374909, 'PTHR32212:SF437', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 247390),
(374910, 'PTHR32212:SF317', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 247390),
(374911, 'PTHR32212:SF319', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 247390),
(374912, 'PTHR32212:SF430', NULL, NULL, NULL, NULL, 'F-BOX/RNI/FBD-LIKE DOMAIN PROTEIN', 247390),
(374913, 'PTHR32212:SF431', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374914, 'PTHR32212:SF395', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374915, 'PTHR32212:SF279', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374916, 'PTHR32212:SF434', NULL, NULL, NULL, NULL, 'F-BOX/RNI/FBD-LIKE DOMAIN PROTEIN', 247390),
(374917, 'PTHR32212:SF312', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT PROTEIN FAMILY', 247390),
(374918, 'PTHR32212:SF435', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374919, 'PTHR32212:SF311', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 247390),
(374920, 'PTHR32212:SF432', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374921, 'PTHR32212:SF314', NULL, NULL, NULL, NULL, 'BNAA10G06930D PROTEIN', 247390),
(374922, 'PTHR32212:SF433', NULL, NULL, NULL, NULL, 'PROTEIN WITH RNI-LIKE/FBD-LIKE DOMAIN', 247390),
(374923, 'PTHR32212:SF313', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 247390),
(374924, 'PTHR32212:SF271', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 13-RELATED', 247390),
(374925, 'PTHR32212:SF391', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 247390),
(374926, 'PTHR32212:SF392', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374927, 'PTHR32212:SF449', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374928, 'PTHR32212:SF327', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 247390),
(374929, 'PTHR32212:SF326', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN, FBD DOMAIN, LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 247390),
(374930, 'PTHR32212:SF329', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 247390),
(374931, 'PTHR32212:SF447', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374932, 'PTHR32212:SF328', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374933, 'PTHR32212:SF448', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374934, 'PTHR32212:SF441', NULL, NULL, NULL, NULL, 'F-BOX_5 DOMAIN-CONTAINING PROTEIN', 247390),
(374935, 'PTHR32212:SF442', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374936, 'PTHR32212:SF320', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374937, 'PTHR32212:SF440', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374938, 'PTHR32212:SF323', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 247390),
(374939, 'PTHR32212:SF445', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374940, 'PTHR32212:SF446', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374941, 'PTHR32212:SF443', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 247390),
(374942, 'PTHR32212:SF325', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 247390),
(374943, 'PTHR32212:SF324', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374944, 'PTHR32212:SF444', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374945, 'PTHR32212:SF337', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374946, 'PTHR32212:SF330', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374947, 'PTHR32212:SF297', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374948, 'PTHR32212:SF296', NULL, NULL, NULL, NULL, 'F-BOX/RNI/FBD-LIKE DOMAIN PROTEIN', 247390);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(374949, 'PTHR32212:SF450', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374950, 'PTHR32212:SF298', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374951, 'PTHR32212:SF451', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374952, 'PTHR32212:SF331', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374953, 'PTHR32212:SF291', NULL, NULL, NULL, NULL, '', 247390),
(374954, 'PTHR32212:SF290', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 247390),
(374955, 'PTHR32212:SF292', NULL, NULL, NULL, NULL, 'F-BOX/RNI/FBD-LIKE DOMAIN PROTEIN', 247390),
(374956, 'PTHR32212:SF295', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247390),
(374957, 'PTHR32212:SF294', NULL, NULL, NULL, NULL, 'FBD / LEUCINE RICH REPEAT DOMAINS CONTAINING PROTEIN', 247390),
(374958, 'PTHR28283', NULL, NULL, NULL, NULL, '3'',5''-CYCLIC-NUCLEOTIDE PHOSPHODIESTERASE 1', 247391),
(374959, 'PTHR28283:SF1', NULL, NULL, NULL, NULL, '3'',5''-CYCLIC-NUCLEOTIDE PHOSPHODIESTERASE 1', 247391),
(374960, 'PTHR35501:SF9', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 247392),
(374961, 'PTHR35501:SF7', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN C4', 247392),
(374962, 'PTHR35501:SF8', NULL, NULL, NULL, NULL, 'PROTEIN 108', 247392),
(374963, 'PTHR35501:SF5', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN-RELATED', 247392),
(374964, 'PTHR35501:SF6', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 247392),
(374965, 'PTHR35501:SF3', NULL, NULL, NULL, NULL, 'PROTEIN YY1', 247392),
(374966, 'PTHR35501', NULL, NULL, NULL, NULL, 'PROTEIN YY1', 247392),
(374967, 'PTHR15646:SF5', NULL, NULL, NULL, NULL, 'LINKER FOR ACTIVATION OF T-CELLS FAMILY MEMBER 2', 247393),
(374968, 'PTHR15646', NULL, NULL, NULL, NULL, 'LINKER FOR ACTIVATION OF T-CELLS FAMILY MEMBER 2', 247393),
(374969, 'PTHR47202:SF2', NULL, NULL, NULL, NULL, 'HISTIDINE-RICH GLYCOPROTEIN', 247394),
(374970, 'PTHR47202:SF3', NULL, NULL, NULL, NULL, '', 247394),
(374971, 'PTHR47202:SF4', NULL, NULL, NULL, NULL, '', 247394),
(374972, 'PTHR47202', NULL, NULL, NULL, NULL, 'HISTIDINE-RICH GLYCOPROTEIN', 247394),
(374973, 'PTHR21105:SF0', NULL, NULL, NULL, NULL, 'GH16255P', 247395),
(374974, 'PTHR21105:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG10838', 247395),
(374975, 'PTHR21105', NULL, NULL, NULL, NULL, 'GH16255P', 247395),
(374976, 'PTHR15588:SF18', NULL, NULL, NULL, NULL, 'U6 SNRNA-ASSOCIATED SM-LIKE PROTEIN LSM1', 247396),
(374977, 'PTHR15588:SF8', NULL, NULL, NULL, NULL, 'U6 SNRNA-ASSOCIATED SM-LIKE PROTEIN LSM1', 247396),
(374978, 'PTHR15588:SF21', NULL, NULL, NULL, NULL, 'SM-LIKE PROTEIN LSM1A', 247396),
(374979, 'PTHR15588:SF20', NULL, NULL, NULL, NULL, 'SM-LIKE PROTEIN LSM1B', 247396),
(374980, 'PTHR15588:SF9', NULL, NULL, NULL, NULL, 'U6 SNRNA-ASSOCIATED SM-LIKE PROTEIN LSM8', 247396),
(374981, 'PTHR15588:SF23', NULL, NULL, NULL, NULL, 'U6 SNRNA-ASSOCIATED SM-LIKE PROTEIN LSM1', 247396),
(374982, 'PTHR15588:SF22', NULL, NULL, NULL, NULL, 'U6 SNRNA-ASSOCIATED SM-LIKE PROTEIN LSM1', 247396),
(374983, 'PTHR15588', NULL, NULL, NULL, NULL, 'LSM1', 247396),
(374984, 'PTHR15588:SF16', NULL, NULL, NULL, NULL, 'U6 SNRNA-ASSOCIATED SM-LIKE PROTEIN LSM1', 247396),
(374985, 'PTHR15588:SF15', NULL, NULL, NULL, NULL, 'U6 SNRNA-ASSOCIATED SM-LIKE PROTEIN LSM8', 247396),
(374986, 'PTHR43663:SF2', NULL, NULL, NULL, NULL, 'CHROMATE TRANSPORT PROTEIN-RELATED', 247397),
(374987, 'PTHR43663:SF1', NULL, NULL, NULL, NULL, 'CHROMATE TRANSPORTER', 247397),
(374988, 'PTHR43663', NULL, NULL, NULL, NULL, 'CHROMATE TRANSPORT PROTEIN-RELATED', 247397),
(374989, 'PTHR39429:SF3', NULL, NULL, NULL, NULL, 'LIGHT-INDEPENDENT PROTOCHLOROPHYLLIDE REDUCTASE SUBUNIT N', 247398),
(374990, 'PTHR39429', NULL, NULL, NULL, NULL, 'LIGHT-INDEPENDENT PROTOCHLOROPHYLLIDE REDUCTASE SUBUNIT N', 247398),
(374991, 'PTHR16557:SF3', NULL, NULL, NULL, NULL, '2OG-FEII_OXY_2 DOMAIN-CONTAINING PROTEIN', 247399),
(374992, 'PTHR16557:SF2', NULL, NULL, NULL, NULL, 'NUCLEIC ACID DIOXYGENASE ALKBH1', 247399);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(374993, 'PTHR16557:SF10', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE-DEPENDENT DIOXYGENASE FAMILY PROTEIN', 247399),
(374994, 'PTHR16557:SF11', NULL, NULL, NULL, NULL, 'ALPHA-KETOGLUTARATE-DEPENDENT DIOXYGENASE ALKB', 247399),
(374995, 'PTHR16557', NULL, NULL, NULL, NULL, 'ALKYLATED DNA REPAIR PROTEIN ALKB-RELATED', 247399),
(374996, 'PTHR22635', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247400),
(374997, 'PTHR22635:SF0', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 207', 247400),
(374998, 'PTHR44324:SF6', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN ON Y CHROMOSOME', 247401),
(374999, 'PTHR44324:SF1', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 49', 247401),
(375000, 'PTHR44324:SF2', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 64', 247401),
(375001, 'PTHR44324:SF3', NULL, NULL, NULL, NULL, 'SI:DKEY-202C14.3', 247401),
(375002, 'PTHR44324:SF4', NULL, NULL, NULL, NULL, 'WD40 REPEAT DOMAIN 95', 247401),
(375003, 'PTHR44324', NULL, NULL, NULL, NULL, 'WD40 REPEAT DOMAIN 95', 247401),
(375004, 'PTHR44324:SF5', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT BETA-LIKE PROTEIN', 247401),
(375005, 'PTHR38116:SF8', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 247402),
(375006, 'PTHR38116:SF9', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 247402),
(375007, 'PTHR38116:SF5', NULL, NULL, NULL, NULL, '', 247402),
(375008, 'PTHR38116:SF1', NULL, NULL, NULL, NULL, 'HTH CENPB-TYPE DOMAIN-CONTAINING PROTEIN', 247402),
(375009, 'PTHR38116', NULL, NULL, NULL, NULL, 'CHROMOSOME 7, WHOLE GENOME SHOTGUN SEQUENCE', 247402),
(375010, 'PTHR30390', NULL, NULL, NULL, NULL, 'SEDOHEPTULOSE 7-PHOSPHATE ISOMERASE / DNAA INITIATOR-ASSOCIATING FACTOR FOR REPLICATION INITIATION', 247403),
(375011, 'PTHR30390:SF7', NULL, NULL, NULL, NULL, 'PHOSPHOHEPTOSE ISOMERASE', 247403),
(375012, 'PTHR30390:SF6', NULL, NULL, NULL, NULL, 'DNAA INITIATOR-ASSOCIATING PROTEIN DIAA', 247403),
(375013, 'PTHR30390:SF8', NULL, NULL, NULL, NULL, 'SUGAR ISOMERASE (SIS)', 247403),
(375014, 'PTHR46260', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 247404),
(375015, 'PTHR46260:SF1', NULL, NULL, NULL, NULL, 'KELCH DOMAIN-CONTAINING PROTEIN 8A', 247404),
(375016, 'PTHR46260:SF2', NULL, NULL, NULL, NULL, 'KELCH DOMAIN-CONTAINING PROTEIN 8B', 247404),
(375017, 'PTHR46260:SF3', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 247404),
(375018, 'PTHR46333:SF4', NULL, NULL, NULL, NULL, 'KYPHOSCOLIOSIS PEPTIDASE', 247405),
(375019, 'PTHR46333:SF5', NULL, NULL, NULL, NULL, 'TGC DOMAIN-CONTAINING PROTEIN', 247405),
(375020, 'PTHR46333:SF2', NULL, NULL, NULL, NULL, 'CYTOKINESIS PROTEIN 3', 247405),
(375021, 'PTHR46333:SF3', NULL, NULL, NULL, NULL, 'KYPHOSCOLIOSIS PEPTIDASE', 247405),
(375022, 'PTHR46333', NULL, NULL, NULL, NULL, 'CYTOKINESIS PROTEIN 3', 247405),
(375023, 'PTHR43991:SF25', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN', 247406),
(375024, 'PTHR43991:SF39', NULL, NULL, NULL, NULL, 'OS08G0497600 PROTEIN', 247406),
(375025, 'PTHR43991:SF38', NULL, NULL, NULL, NULL, 'OS02G0721600 PROTEIN', 247406),
(375026, 'PTHR43991:SF33', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 247406),
(375027, 'PTHR43991:SF22', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 247406),
(375028, 'PTHR43991:SF43', NULL, NULL, NULL, NULL, 'WD40-REPEAT-CONTAINING DOMAIN-CONTAINING PROTEIN-RELATED', 247406),
(375029, 'PTHR43991:SF21', NULL, NULL, NULL, NULL, 'GAMYB-BINDING PROTEIN', 247406),
(375030, 'PTHR43991:SF32', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN', 247406),
(375031, 'PTHR43991:SF35', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 247406),
(375032, 'PTHR43991:SF34', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 247406),
(375033, 'PTHR43991:SF23', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 247406),
(375034, 'PTHR43991:SF12', NULL, NULL, NULL, NULL, 'WD REPEAT PROTEIN (AFU_ORTHOLOGUE AFUA_8G05640)', 247406);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(375035, 'PTHR43991:SF31', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 247406),
(375036, 'PTHR43991:SF42', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR WD40-LIKE FAMILY-RELATED', 247406),
(375037, 'PTHR43991:SF30', NULL, NULL, NULL, NULL, 'OS08G0408200 PROTEIN', 247406),
(375038, 'PTHR43991:SF41', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 247406),
(375039, 'PTHR43991', NULL, NULL, NULL, NULL, 'WD REPEAT PROTEIN (AFU_ORTHOLOGUE AFUA_8G05640)-RELATED', 247406),
(375040, 'PTHR43991:SF19', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 247406),
(375041, 'PTHR43991:SF9', NULL, NULL, NULL, NULL, 'DUF2415 DOMAIN-CONTAINING PROTEIN', 247406),
(375042, 'PTHR43991:SF18', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN', 247406),
(375043, 'PTHR11014:SF156', NULL, NULL, NULL, NULL, 'M20_DIMER DOMAIN-CONTAINING PROTEIN', 247407),
(375044, 'PTHR11014:SF157', NULL, NULL, NULL, NULL, 'IAA-AMINO ACID HYDROLASE ILR1-LIKE 3', 247407),
(375045, 'PTHR11014:SF158', NULL, NULL, NULL, NULL, 'IAA-AMINO ACID HYDROLASE ILR1-LIKE 1-RELATED', 247407),
(375046, 'PTHR11014:SF159', NULL, NULL, NULL, NULL, 'M20_DIMER DOMAIN-CONTAINING PROTEIN', 247407),
(375047, 'PTHR11014:SF153', NULL, NULL, NULL, NULL, 'PEPTIDASE M20, DIMERIZATION DOMAIN-CONTAINING PROTEIN-RELATED', 247407),
(375048, 'PTHR11014:SF62', NULL, NULL, NULL, NULL, 'IAA-AMINO ACID HYDROLASE ILR1-LIKE 6', 247407),
(375049, 'PTHR11014:SF63', NULL, NULL, NULL, NULL, 'METALLOPEPTIDASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G09600)-RELATED', 247407),
(375050, 'PTHR11014', NULL, NULL, NULL, NULL, 'PEPTIDASE M20 FAMILY MEMBER', 247407),
(375051, 'PTHR11014:SF119', NULL, NULL, NULL, NULL, 'IAA-AMINO ACID HYDROLASE ILR1-LIKE 1', 247407),
(375052, 'PTHR11014:SF167', NULL, NULL, NULL, NULL, 'IAA-AMINO ACID HYDROLASE ILR1-LIKE 9', 247407),
(375053, 'PTHR11014:SF168', NULL, NULL, NULL, NULL, 'IAA-AMINO ACID HYDROLASE ILR1', 247407),
(375054, 'PTHR11014:SF55', NULL, NULL, NULL, NULL, 'IAA-AMINO ACID HYDROLASE ILR1-LIKE 4-RELATED', 247407),
(375055, 'PTHR11014:SF99', NULL, NULL, NULL, NULL, 'IAA-AMINO ACID HYDROLASE ILR1-LIKE 3', 247407),
(375056, 'PTHR11014:SF122', NULL, NULL, NULL, NULL, 'AMIDOHYDROLASE AMHX', 247407),
(375057, 'PTHR11014:SF166', NULL, NULL, NULL, NULL, 'AMIDOHYDROLASE YHAA-RELATED', 247407),
(375058, 'PTHR11014:SF100', NULL, NULL, NULL, NULL, 'IAA-AMINO ACID HYDROLASE ILR1-LIKE 2', 247407),
(375059, 'PTHR11014:SF149', NULL, NULL, NULL, NULL, 'IAA-AMINO ACID HYDROLASE ILR1-LIKE 8', 247407),
(375060, 'PTHR11014:SF147', NULL, NULL, NULL, NULL, 'M20_DIMER DOMAIN-CONTAINING PROTEIN', 247407),
(375061, 'PTHR11014:SF148', NULL, NULL, NULL, NULL, 'AUXIN CONJUGATE HYDROLASE', 247407),
(375062, 'PTHR11014:SF160', NULL, NULL, NULL, NULL, 'M20_DIMER DOMAIN-CONTAINING PROTEIN', 247407),
(375063, 'PTHR11014:SF163', NULL, NULL, NULL, NULL, 'M20_DIMER DOMAIN-CONTAINING PROTEIN', 247407),
(375064, 'PTHR11014:SF98', NULL, NULL, NULL, NULL, 'N-ACETYLDIAMINOPIMELATE DEACETYLASE', 247407),
(375065, 'PTHR11014:SF164', NULL, NULL, NULL, NULL, 'N-ACYL-L-AMINO ACID AMIDOHYDROLASE', 247407),
(375066, 'PTHR11014:SF140', NULL, NULL, NULL, NULL, 'IAA-AMINO ACID HYDROLASE ILR1-LIKE 3', 247407),
(375067, 'PTHR11014:SF162', NULL, NULL, NULL, NULL, 'IAA-AMINO ACID HYDROLASE ILR1-LIKE 3 ISOFORM X1', 247407),
(375068, 'PTHR11014:SF108', NULL, NULL, NULL, NULL, 'IAA-AMINO ACID HYDROLASE ILR1', 247407),
(375069, 'PTHR10535:SF16', NULL, NULL, NULL, NULL, 'OS01G0805800 PROTEIN', 247408),
(375070, 'PTHR10535:SF18', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASES II 24 KDA POLYPEPTIDE', 247408),
(375071, 'PTHR10535:SF12', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE V SUBUNIT 5C', 247408),
(375072, 'PTHR10535:SF23', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASES II AND IV SUBUNIT 5A-LIKE', 247408),
(375073, 'PTHR10535:SF15', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT 5-LIKE PROTEIN 1', 247408),
(375074, 'PTHR10535:SF20', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASES I, II, AND III SUBUNIT RPABC1-RELATED', 247408);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(375075, 'PTHR10535:SF3', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II, PUTATIVE-RELATED', 247408),
(375076, 'PTHR10535:SF11', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 247408),
(375077, 'PTHR10535:SF22', NULL, NULL, NULL, NULL, '', 247408),
(375078, 'PTHR10535:SF21', NULL, NULL, NULL, NULL, 'BNAA05G17270D PROTEIN', 247408),
(375079, 'PTHR10535:SF10', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASES IV AND V SUBUNIT 5B', 247408),
(375080, 'PTHR10535:SF2', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE V SUBUNIT 5A', 247408),
(375081, 'PTHR10535:SF0', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASES I, II, AND III SUBUNIT RPABC1', 247408),
(375082, 'PTHR10535', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASES I, II, AND III SUBUNIT RPABC1', 247408),
(375083, 'PTHR31414:SF22', NULL, NULL, NULL, NULL, 'ENVELOPE GLYCOPROTEIN B', 247409),
(375084, 'PTHR31414:SF33', NULL, NULL, NULL, NULL, 'BNAA09G07310D PROTEIN', 247409),
(375085, 'PTHR31414:SF12', NULL, NULL, NULL, NULL, '', 247409),
(375086, 'PTHR31414:SF20', NULL, NULL, NULL, NULL, 'MPN DOMAIN-CONTAINING PROTEIN', 247409),
(375087, 'PTHR31414:SF31', NULL, NULL, NULL, NULL, '', 247409),
(375088, 'PTHR31414:SF21', NULL, NULL, NULL, NULL, '', 247409),
(375089, 'PTHR31414:SF32', NULL, NULL, NULL, NULL, '', 247409),
(375090, 'PTHR31414:SF10', NULL, NULL, NULL, NULL, 'OS04G0644000 PROTEIN', 247409),
(375091, 'PTHR31414:SF26', NULL, NULL, NULL, NULL, '', 247409),
(375092, 'PTHR31414:SF15', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE FUSION PROTEIN', 247409),
(375093, 'PTHR31414:SF16', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 247409),
(375094, 'PTHR31414:SF27', NULL, NULL, NULL, NULL, '', 247409),
(375095, 'PTHR31414:SF35', NULL, NULL, NULL, NULL, '', 247409),
(375096, 'PTHR31414:SF13', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 247409),
(375097, 'PTHR31414:SF25', NULL, NULL, NULL, NULL, 'BNAC06G40440D PROTEIN', 247409),
(375098, 'PTHR31414:SF19', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 247409),
(375099, 'PTHR31414:SF17', NULL, NULL, NULL, NULL, '', 247409),
(375100, 'PTHR31414:SF28', NULL, NULL, NULL, NULL, 'BNAA09G08220D PROTEIN', 247409),
(375101, 'PTHR31414:SF18', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN DDB_G0292058', 247409),
(375102, 'PTHR31414', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN DDB_G0292058', 247409),
(375103, 'PTHR31414:SF3', NULL, NULL, NULL, NULL, '', 247409),
(375104, 'PTHR31414:SF30', NULL, NULL, NULL, NULL, '', 247409),
(375105, 'PTHR31414:SF7', NULL, NULL, NULL, NULL, '', 247409),
(375106, 'PTHR47346:SF1', NULL, NULL, NULL, NULL, 'HYDROLASES, ACTING ON ESTER BOND', 247410),
(375107, 'PTHR47346:SF2', NULL, NULL, NULL, NULL, 'BNACNNG16160D PROTEIN', 247410),
(375108, 'PTHR47346', NULL, NULL, NULL, NULL, 'HYDROLASES, ACTING ON ESTER BOND', 247410),
(375109, 'PTHR43634:SF11', NULL, NULL, NULL, NULL, 'MSCS-LIKE 3-RELATED', 247411),
(375110, 'PTHR43634:SF10', NULL, NULL, NULL, NULL, 'BNAANNG21790D PROTEIN', 247411),
(375111, 'PTHR43634', NULL, NULL, NULL, NULL, 'OW CONDUCTANCE MECHANOSENSITIVE CHANNEL', 247411),
(375112, 'PTHR43634:SF8', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN 3, CHLOROPLASTIC-LIKE ISOFORM X1', 247411),
(375113, 'PTHR43634:SF7', NULL, NULL, NULL, NULL, '', 247411),
(375114, 'PTHR43634:SF14', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL-LIKE PROTEIN', 247411),
(375115, 'PTHR43634:SF5', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL-LIKE PROTEIN', 247411),
(375116, 'PTHR43634:SF13', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN 3, CHLOROPLASTIC', 247411),
(375117, 'PTHR43634:SF12', NULL, NULL, NULL, NULL, 'BNACNNG60870D PROTEIN', 247411),
(375118, 'PTHR43634:SF2', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN 2, CHLOROPLASTIC', 247411),
(375119, 'PTHR48106:SF3', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 247412),
(375120, 'PTHR48106:SF13', NULL, NULL, NULL, NULL, 'QUINONE OXIDOREDUCTASE-RELATED', 247412),
(375121, 'PTHR48106:SF14', NULL, NULL, NULL, NULL, 'DEHYDROGENASE ORSE-RELATED', 247412);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(375122, 'PTHR48106:SF2', NULL, NULL, NULL, NULL, 'ZN2+-BINDING DEHYDROGENASE', 247412),
(375123, 'PTHR48106:SF1', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE SUPERFAMILY, ZINC-TYPE-RELATED', 247412),
(375124, 'PTHR48106:SF11', NULL, NULL, NULL, NULL, 'OS10G0561100 PROTEIN', 247412),
(375125, 'PTHR48106:SF12', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE ZINC-BINDING DEHYDROGENASE FAMILY PROTEIN', 247412),
(375126, 'PTHR48106:SF7', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, ZINC-CONTAINING, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G10220)-RELATED', 247412),
(375127, 'PTHR48106:SF17', NULL, NULL, NULL, NULL, 'ADH5P', 247412),
(375128, 'PTHR48106:SF18', NULL, NULL, NULL, NULL, 'QUINONE OXIDOREDUCTASE PIG3', 247412),
(375129, 'PTHR48106:SF6', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE SUPERFAMILY, ZINC-TYPE-RELATED', 247412),
(375130, 'PTHR48106:SF5', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 247412),
(375131, 'PTHR48106:SF4', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE, ZINC-BINDING DEHYDROGENASE FAMILY SUPERFAMILY (AFU_ORTHOLOGUE AFUA_4G11710)', 247412),
(375132, 'PTHR48106:SF10', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 247412),
(375133, 'PTHR48106', NULL, NULL, NULL, NULL, 'QUINONE OXIDOREDUCTASE PIG3-RELATED', 247412),
(375134, 'PTHR48106:SF8', NULL, NULL, NULL, NULL, 'OS02G0805600 PROTEIN', 247412),
(375135, 'PTHR40135:SF1', NULL, NULL, NULL, NULL, '', 247413),
(375136, 'PTHR40135', NULL, NULL, NULL, NULL, '', 247413),
(375137, 'PTHR12911:SF8', NULL, NULL, NULL, NULL, 'SAD1 AND UNC84 DOMAIN-CONTAINING 1-RELATED', 247414),
(375138, 'PTHR12911:SF16', NULL, NULL, NULL, NULL, 'SPERM-ASSOCIATED ANTIGEN 4 PROTEIN', 247414),
(375139, 'PTHR12911', NULL, NULL, NULL, NULL, 'SAD1/UNC-84-LIKE PROTEIN-RELATED', 247414),
(375140, 'PTHR12911:SF22', NULL, NULL, NULL, NULL, 'SUN DOMAIN-CONTAINING PROTEIN 2', 247414),
(375141, 'PTHR12911:SF2', NULL, NULL, NULL, NULL, 'SUN DOMAIN-CONTAINING PROTEIN 1', 247414),
(375142, 'PTHR12911:SF44', NULL, NULL, NULL, NULL, 'SUN DOMAIN-CONTAINING PROTEIN 5', 247414),
(375143, 'PTHR12911:SF47', NULL, NULL, NULL, NULL, 'SUN DOMAIN-CONTAINING PROTEIN 2', 247414),
(375144, 'PTHR12911:SF24', NULL, NULL, NULL, NULL, 'SUN DOMAIN-CONTAINING PROTEIN 3', 247414),
(375145, 'PTHR12911:SF45', NULL, NULL, NULL, NULL, 'OS01G0267600 PROTEIN', 247414),
(375146, 'PTHR12911:SF23', NULL, NULL, NULL, NULL, 'SUN DOMAIN-CONTAINING PROTEIN 1', 247414),
(375147, 'PTHR45925:SF4', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 217', 247415),
(375148, 'PTHR45925', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 247415),
(375149, 'PTHR45925:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 219', 247415),
(375150, 'PTHR45925:SF3', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 516', 247415),
(375151, 'PTHR45925:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 536', 247415),
(375152, 'PTHR36920:SF1', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN W', 247416),
(375153, 'PTHR36920', NULL, NULL, NULL, NULL, '', 247416),
(375154, 'PTHR11242:SF2', NULL, NULL, NULL, NULL, 'ARYL-HYDROCARBON-INTERACTING PROTEIN-LIKE 1', 247417),
(375155, 'PTHR11242:SF1', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 247417),
(375156, 'PTHR11242:SF0', NULL, NULL, NULL, NULL, 'ARYL HYDROCARBON RECEPTOR INTERACTING PROTEIN (AIP) RELATED', 247417),
(375157, 'PTHR11242:SF14', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 9C', 247417),
(375158, 'PTHR11242:SF9', NULL, NULL, NULL, NULL, 'FK506-BINDING PROTEIN-LIKE', 247417),
(375159, 'PTHR11242:SF15', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 9A', 247417),
(375160, 'PTHR11242:SF12', NULL, NULL, NULL, NULL, 'ISOMERASE, PUTATIVE-RELATED', 247417),
(375161, 'PTHR11242:SF13', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 9B', 247417),
(375162, 'PTHR11242:SF10', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 247417),
(375163, 'PTHR11242:SF11', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP42', 247417),
(375164, 'PTHR11242', NULL, NULL, NULL, NULL, 'ARYL HYDROCARBON RECEPTOR INTERACTING PROTEIN RELATED', 247417);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(375165, 'PTHR11242:SF3', NULL, NULL, NULL, NULL, 'AH RECEPTOR-INTERACTING PROTEIN', 247417),
(375166, 'PTHR11011:SF45', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE 1', 247418),
(375167, 'PTHR11011:SF67', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE 1', 247418),
(375168, 'PTHR11011:SF24', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418),
(375169, 'PTHR11011:SF85', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418),
(375170, 'PTHR11011:SF63', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE 4-RELATED', 247418),
(375171, 'PTHR11011:SF64', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418),
(375172, 'PTHR11011:SF86', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418),
(375173, 'PTHR11011:SF65', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE CG5065-RELATED', 247418),
(375174, 'PTHR11011:SF44', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418),
(375175, 'PTHR11011:SF88', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418),
(375176, 'PTHR11011:SF66', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE 6, CHLOROPLASTIC', 247418),
(375177, 'PTHR11011:SF81', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418),
(375178, 'PTHR11011:SF60', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE 2', 247418),
(375179, 'PTHR11011:SF82', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE 8-RELATED', 247418),
(375180, 'PTHR11011:SF61', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418),
(375181, 'PTHR11011:SF84', NULL, NULL, NULL, NULL, 'ACYL-COA REDUCTASE-LIKE PROTEIN, PUTATIVE-RELATED', 247418),
(375182, 'PTHR11011:SF113', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418),
(375183, 'PTHR11011:SF27', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE CG8306-RELATED', 247418),
(375184, 'PTHR11011:SF110', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418),
(375185, 'PTHR11011', NULL, NULL, NULL, NULL, 'MALE STERILITY PROTEIN 2-RELATED', 247418),
(375186, 'PTHR11011:SF111', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418),
(375187, 'PTHR11011:SF112', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418),
(375188, 'PTHR11011:SF12', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418),
(375189, 'PTHR11011:SF57', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418),
(375190, 'PTHR11011:SF75', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418),
(375191, 'PTHR11011:SF98', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418),
(375192, 'PTHR11011:SF99', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE 3', 247418),
(375193, 'PTHR11011:SF77', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418),
(375194, 'PTHR11011:SF71', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418),
(375195, 'PTHR11011:SF93', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418),
(375196, 'PTHR11011:SF72', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418),
(375197, 'PTHR11011:SF73', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418),
(375198, 'PTHR11011:SF95', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418),
(375199, 'PTHR11011:SF90', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418),
(375200, 'PTHR11011:SF91', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418),
(375201, 'PTHR11011:SF102', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418),
(375202, 'PTHR11011:SF104', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418),
(375203, 'PTHR11011:SF105', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418),
(375204, 'PTHR11011:SF106', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418),
(375205, 'PTHR11011:SF107', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418),
(375206, 'PTHR11011:SF108', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418),
(375207, 'PTHR11011:SF109', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE 7-RELATED', 247418),
(375208, 'PTHR11011:SF39', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418),
(375209, 'PTHR11011:SF101', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA REDUCTASE', 247418); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(375210, 'PTHR42085:SF3', NULL, NULL, NULL, NULL, '', 247419),
(375211, 'PTHR42085:SF2', NULL, NULL, NULL, NULL, '', 247419),
(375212, 'PTHR42085:SF1', NULL, NULL, NULL, NULL, '', 247419),
(375213, 'PTHR42085', NULL, NULL, NULL, NULL, '', 247419),
(375214, 'PTHR42085:SF6', NULL, NULL, NULL, NULL, '', 247419),
(375215, 'PTHR42085:SF4', NULL, NULL, NULL, NULL, '', 247419),
(375216, 'PTHR43047:SF71', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE CONTAINING CHEY-HOMOLOGOUS RECEIVER DOMAIN-RELATED', 247420),
(375217, 'PTHR43047:SF70', NULL, NULL, NULL, NULL, 'SENSOR HISTIDINE KINASE YVCQ', 247420),
(375218, 'PTHR43047:SF73', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE DOMAIN-CONTAINING PROTEIN', 247420),
(375219, 'PTHR43047:SF62', NULL, NULL, NULL, NULL, 'SENSOR HISTIDINE KINASE DPIB', 247420),
(375220, 'PTHR43047:SF40', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE 5-RELATED', 247420),
(375221, 'PTHR43047:SF72', NULL, NULL, NULL, NULL, 'PHOSPHOTRANSFERASE RCSD', 247420),
(375222, 'PTHR43047:SF75', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE DOMAIN-CONTAINING PROTEIN', 247420),
(375223, 'PTHR43047:SF64', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE', 247420),
(375224, 'PTHR43047:SF74', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE D5-RELATED', 247420),
(375225, 'PTHR43047:SF52', NULL, NULL, NULL, NULL, 'SENSOR HISTIDINE KINASE YVRG', 247420),
(375226, 'PTHR43047:SF63', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE', 247420),
(375227, 'PTHR43047:SF77', NULL, NULL, NULL, NULL, 'SENSOR-LIKE HISTIDINE KINASE SENX3', 247420),
(375228, 'PTHR43047:SF66', NULL, NULL, NULL, NULL, 'CHROMOSOME 8, WHOLE GENOME SHOTGUN SEQUENCE', 247420),
(375229, 'PTHR43047:SF76', NULL, NULL, NULL, NULL, 'PHYTOCHROME-LIKE HISTIDINE KINASE 2', 247420),
(375230, 'PTHR43047:SF65', NULL, NULL, NULL, NULL, 'CHEY-HOMOLOGOUS RECEIVER DOMAIN AND PAS DOMAIN-CONTAINING PROTEIN', 247420),
(375231, 'PTHR43047:SF46', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE/RESPONSE REGULATOR, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G12550)-RELATED', 247420),
(375232, 'PTHR43047:SF68', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE 5', 247420),
(375233, 'PTHR43047:SF67', NULL, NULL, NULL, NULL, 'BNAANNG24980D PROTEIN', 247420),
(375234, 'PTHR43047:SF2', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE M7', 247420),
(375235, 'PTHR43047:SF69', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE CONTAINING CHEY-HOMOLOGOUS RECEIVER DOMAIN-RELATED', 247420),
(375236, 'PTHR43047:SF58', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE CYTOKININ RECEPTOR', 247420),
(375237, 'PTHR43047', NULL, NULL, NULL, NULL, 'TWO-COMPONENT HISTIDINE PROTEIN KINASE', 247420),
(375238, 'PTHR43047:SF5', NULL, NULL, NULL, NULL, 'OSMOSENSING HISTIDINE PROTEIN KINASE SLN1', 247420),
(375239, 'PTHR43047:SF9', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE', 247420),
(375240, 'PTHR12748', NULL, NULL, NULL, NULL, 'ORIGIN RECOGNITION COMPLEX SUBUNIT 3', 247421),
(375241, 'PTHR12748:SF0', NULL, NULL, NULL, NULL, 'ORIGIN RECOGNITION COMPLEX SUBUNIT 3', 247421),
(375242, 'PTHR12748:SF1', NULL, NULL, NULL, NULL, 'ORIGIN RECOGNITION COMPLEX SUBUNIT 3', 247421),
(375243, 'PTHR12748:SF2', NULL, NULL, NULL, NULL, '', 247421),
(375244, 'PTHR47513:SF1', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER', 247422),
(375245, 'PTHR47513', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER', 247422),
(375246, 'PTHR36813', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 247423),
(375247, 'PTHR36813:SF2', NULL, NULL, NULL, NULL, 'SMALL VCP/P97-INTERACTING PROTEIN-RELATED', 247423),
(375248, 'PTHR36813:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 247423),
(375249, 'PTHR12618', NULL, NULL, NULL, NULL, 'PHD AND RING FINGER DOMAIN-CONTAINING PROTEIN 1', 247424),
(375250, 'PTHR12618:SF20', NULL, NULL, NULL, NULL, 'PHD AND RING FINGER DOMAIN-CONTAINING PROTEIN 1', 247424),
(375251, 'PTHR12147:SF52', NULL, NULL, NULL, NULL, 'PEPTIDASE M28 FAMILY', 247425),
(375252, 'PTHR12147:SF51', NULL, NULL, NULL, NULL, 'ALKALINE PHOSPHATASE ISOZYME CONVERSION PROTEIN', 247425),
(375253, 'PTHR12147:SF54', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM METALLOPEPTIDASE 1-RELATED', 247425),
(375254, 'PTHR12147', NULL, NULL, NULL, NULL, 'METALLOPEPTIDASE M28 FAMILY MEMBER', 247425); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(375255, 'PTHR12147:SF11', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM METALLOPEPTIDASE 1-B-RELATED', 247425),
(375256, 'PTHR12147:SF55', NULL, NULL, NULL, NULL, 'PEPTIDE HYDROLASE', 247425),
(375257, 'PTHR12147:SF22', NULL, NULL, NULL, NULL, 'ZN-DEPENDENT EXOPEPTIDASES SUPERFAMILY PROTEIN', 247425),
(375258, 'PTHR12147:SF46', NULL, NULL, NULL, NULL, 'PEPTIDASE_M28 DOMAIN-CONTAINING PROTEIN', 247425),
(375259, 'PTHR12147:SF48', NULL, NULL, NULL, NULL, 'PEPTIDASE_M28 DOMAIN-CONTAINING PROTEIN', 247425),
(375260, 'PTHR12147:SF26', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM METALLOPEPTIDASE 1', 247425),
(375261, 'PTHR12147:SF17', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE Y', 247425),
(375262, 'PTHR34841:SF6', NULL, NULL, NULL, NULL, '', 247426),
(375263, 'PTHR34841:SF9', NULL, NULL, NULL, NULL, 'MYB-LIKE PROTEIN V', 247426),
(375264, 'PTHR34841:SF8', NULL, NULL, NULL, NULL, '', 247426),
(375265, 'PTHR34841:SF7', NULL, NULL, NULL, NULL, '', 247426),
(375266, 'PTHR34841', NULL, NULL, NULL, NULL, 'MYB-LIKE PROTEIN V', 247426),
(375267, 'PTHR34841:SF10', NULL, NULL, NULL, NULL, '', 247426),
(375268, 'PTHR46116:SF23', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 247427),
(375269, 'PTHR46116:SF24', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 247427),
(375270, 'PTHR46116:SF26', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 Z', 247427),
(375271, 'PTHR46116:SF27', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 247427),
(375272, 'PTHR46116:SF28', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 247427),
(375273, 'PTHR46116:SF40', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 247427),
(375274, 'PTHR46116:SF41', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 25-RELATED', 247427),
(375275, 'PTHR46116:SF42', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 25-RELATED', 247427),
(375276, 'PTHR46116:SF20', NULL, NULL, NULL, NULL, 'OS09G0294300 PROTEIN', 247427),
(375277, 'PTHR46116:SF21', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 23-RELATED', 247427),
(375278, 'PTHR46116:SF43', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME', 247427),
(375279, 'PTHR46116:SF22', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 26-RELATED', 247427),
(375280, 'PTHR46116:SF44', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME/RWD-LIKE PROTEIN-RELATED', 247427),
(375281, 'PTHR46116:SF34', NULL, NULL, NULL, NULL, 'OS01G0232500 PROTEIN', 247427),
(375282, 'PTHR46116:SF12', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME PROTEIN 17-RELATED', 247427),
(375283, 'PTHR46116:SF13', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 38-RELATED', 247427),
(375284, 'PTHR46116:SF35', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 247427),
(375285, 'PTHR46116:SF15', NULL, NULL, NULL, NULL, '(E3-INDEPENDENT) E2 UBIQUITIN-CONJUGATING ENZYME', 247427),
(375286, 'PTHR46116:SF38', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2', 247427),
(375287, 'PTHR46116:SF17', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 25-RELATED', 247427),
(375288, 'PTHR46116:SF39', NULL, NULL, NULL, NULL, 'BACULOVIRAL IAP REPEAT-CONTAINING PROTEIN 6', 247427),
(375289, 'PTHR46116:SF18', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 247427),
(375290, 'PTHR46116:SF19', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME FAMILY PROTEIN', 247427),
(375291, 'PTHR46116:SF32', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 247427),
(375292, 'PTHR46116:SF10', NULL, NULL, NULL, NULL, 'OS05G0232500 PROTEIN', 247427),
(375293, 'PTHR46116', NULL, NULL, NULL, NULL, '(E3-INDEPENDENT) E2 UBIQUITIN-CONJUGATING ENZYME', 247427),
(375294, 'PTHR46116:SF11', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 247427),
(375295, 'PTHR23101', NULL, NULL, NULL, NULL, 'RAB GDP/GTP EXCHANGE FACTOR', 247428),
(375296, 'PTHR23101:SF98', NULL, NULL, NULL, NULL, 'VPS9 DOMAIN-CONTAINING PROTEIN 1', 247428),
(375297, 'PTHR23101:SF97', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G10890)-RELATED', 247428);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(375298, 'PTHR23101:SF110', NULL, NULL, NULL, NULL, 'VPS9 DOMAIN-CONTAINING PROTEIN', 247428),
(375299, 'PTHR23101:SF25', NULL, NULL, NULL, NULL, 'GTPASE-ACTIVATING PROTEIN AND VPS9 DOMAIN-CONTAINING PROTEIN 1', 247428),
(375300, 'PTHR23101:SF58', NULL, NULL, NULL, NULL, 'RAS AND RAB INTERACTOR 3', 247428),
(375301, 'PTHR23101:SF122', NULL, NULL, NULL, NULL, 'RAB5 GDP/GTP EXCHANGE FACTOR', 247428),
(375302, 'PTHR23101:SF103', NULL, NULL, NULL, NULL, 'RAB5 GDP/GTP EXCHANGE FACTOR-LIKE', 247428),
(375303, 'PTHR23101:SF125', NULL, NULL, NULL, NULL, 'VPS9 DOMAIN-CONTAINING PROTEIN', 247428),
(375304, 'PTHR23101:SF104', NULL, NULL, NULL, NULL, 'PROTEIN SPRINT', 247428),
(375305, 'PTHR23101:SF115', NULL, NULL, NULL, NULL, 'VPS9 DOMAIN-CONTAINING PROTEIN', 247428),
(375306, 'PTHR23101:SF112', NULL, NULL, NULL, NULL, '', 247428),
(375307, 'PTHR23101:SF123', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED 9A-LIKE PROTEIN', 247428),
(375308, 'PTHR23101:SF124', NULL, NULL, NULL, NULL, 'PROTEIN MUK1', 247428),
(375309, 'PTHR23101:SF83', NULL, NULL, NULL, NULL, 'VPS9 DOMAIN-CONTAINING PROTEIN', 247428),
(375310, 'PTHR23101:SF72', NULL, NULL, NULL, NULL, 'RAS AND RAB INTERACTOR-LIKE PROTEIN', 247428),
(375311, 'PTHR23101:SF107', NULL, NULL, NULL, NULL, 'RAB GUANINE NUCLEOTIDE EXCHANGE FACTOR (GEF) 1-RELATED', 247428),
(375312, 'PTHR23101:SF108', NULL, NULL, NULL, NULL, '', 247428),
(375313, 'PTHR23101:SF63', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 9A-LIKE ISOFORM X1', 247428),
(375314, 'PTHR23101:SF116', NULL, NULL, NULL, NULL, 'VPS9 DOMAIN-CONTAINING PROTEIN-RELATED', 247428),
(375315, 'PTHR23101:SF52', NULL, NULL, NULL, NULL, 'VPS9 DOMAIN-CONTAINING PROTEIN', 247428),
(375316, 'PTHR23101:SF62', NULL, NULL, NULL, NULL, 'RAS AND RAB INTERACTOR 1', 247428),
(375317, 'PTHR23101:SF51', NULL, NULL, NULL, NULL, 'RAS AND RAB INTERACTOR 2', 247428),
(375318, 'PTHR10522:SF0', NULL, NULL, NULL, NULL, 'PROGONADOLIBERIN-1', 247429),
(375319, 'PTHR10522', NULL, NULL, NULL, NULL, 'GONADOLIBERIN', 247429),
(375320, 'PTHR10522:SF7', NULL, NULL, NULL, NULL, 'GONADOLIBERIN', 247429),
(375321, 'PTHR10522:SF6', NULL, NULL, NULL, NULL, 'PROGONADOLIBERIN-2', 247429),
(375322, 'PTHR10522:SF5', NULL, NULL, NULL, NULL, '', 247429),
(375323, 'PTHR12948', NULL, NULL, NULL, NULL, 'NEDD8 ULTIMATE BUSTER-1  BS4 PROTEIN', 247430),
(375324, 'PTHR12948:SF3', NULL, NULL, NULL, NULL, 'NEDD8 ULTIMATE BUSTER 1', 247430),
(375325, 'PTHR48158:SF1', NULL, NULL, NULL, NULL, 'OS11G0453550 PROTEIN', 247431),
(375326, 'PTHR48158', NULL, NULL, NULL, NULL, 'OS11G0453550 PROTEIN', 247431),
(375327, 'PTHR34807:SF10', NULL, NULL, NULL, NULL, 'BNAA03G50370D PROTEIN', 247432),
(375328, 'PTHR34807:SF9', NULL, NULL, NULL, NULL, '', 247432),
(375329, 'PTHR34807:SF6', NULL, NULL, NULL, NULL, '', 247432),
(375330, 'PTHR34807:SF8', NULL, NULL, NULL, NULL, 'BNAA01G06520D PROTEIN', 247432),
(375331, 'PTHR34807:SF3', NULL, NULL, NULL, NULL, 'OS08G0270800 PROTEIN', 247432),
(375332, 'PTHR34807', NULL, NULL, NULL, NULL, 'OS08G0270800 PROTEIN', 247432),
(375333, 'PTHR34807:SF15', NULL, NULL, NULL, NULL, 'BNAA02G08010D PROTEIN', 247432),
(375334, 'PTHR34807:SF16', NULL, NULL, NULL, NULL, 'OS09G0421500 PROTEIN', 247432),
(375335, 'PTHR34766', NULL, NULL, NULL, NULL, 'UPF0449 PROTEIN C19ORF25', 247433),
(375336, 'PTHR34766:SF1', NULL, NULL, NULL, NULL, 'UPF0449 PROTEIN C19ORF25', 247433),
(375337, 'PTHR37337:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING GLUTAMATE-RICH PROTEIN 1', 247434),
(375338, 'PTHR37337', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING GLUTAMATE-RICH PROTEIN 1', 247434),
(375339, 'PTHR12942:SF5', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR SLU7', 247435),
(375340, 'PTHR12942', NULL, NULL, NULL, NULL, 'STEP II SPLICING FACTOR SLU7', 247435),
(375341, 'PTHR12942:SF6', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR SLU7-A', 247435),
(375342, 'PTHR12942:SF2', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR SLU7', 247435),
(375343, 'PTHR12942:SF3', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR SLU7', 247435);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(375344, 'PTHR12942:SF4', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR SLU7', 247435),
(375345, 'PTHR34657:SF16', NULL, NULL, NULL, NULL, 'BNAC08G43650D PROTEIN', 247436),
(375346, 'PTHR34657:SF15', NULL, NULL, NULL, NULL, 'OS04G0512500 PROTEIN', 247436),
(375347, 'PTHR34657', NULL, NULL, NULL, NULL, 'EMBRYO SAC DEVELOPMENT ARREST 6', 247436),
(375348, 'PTHR34657:SF4', NULL, NULL, NULL, NULL, 'EMBRYO SAC DEVELOPMENT ARREST 6', 247436),
(375349, 'PTHR34657:SF10', NULL, NULL, NULL, NULL, 'F21M11.6 PROTEIN', 247436),
(375350, 'PTHR34657:SF7', NULL, NULL, NULL, NULL, 'OS10G0472501 PROTEIN', 247436),
(375351, 'PTHR34657:SF9', NULL, NULL, NULL, NULL, 'EMBRYO SAC DEVELOPMENT ARREST PROTEIN', 247436),
(375352, 'PTHR34657:SF13', NULL, NULL, NULL, NULL, 'BNAA06G36350D PROTEIN', 247436),
(375353, 'PTHR43350:SF20', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 247437),
(375354, 'PTHR43350:SF21', NULL, NULL, NULL, NULL, 'S-NITROSOMYCOTHIOL REDUCTASE MSCR', 247437),
(375355, 'PTHR43350:SF2', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G01780)-RELATED', 247437),
(375356, 'PTHR43350:SF11', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 247437),
(375357, 'PTHR43350:SF14', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE (ZN CONTAINING) (ADH-8)', 247437),
(375358, 'PTHR43350', NULL, NULL, NULL, NULL, 'NAD-DEPENDENT ALCOHOL DEHYDROGENASE', 247437),
(375359, 'PTHR43350:SF17', NULL, NULL, NULL, NULL, 'NAD-DEPENDENT ALCOHOL DEHYDROGENASE', 247437),
(375360, 'PTHR43350:SF18', NULL, NULL, NULL, NULL, '', 247437),
(375361, 'PTHR43350:SF19', NULL, NULL, NULL, NULL, 'D-GULOSIDE 3-DEHYDROGENASE', 247437),
(375362, 'PTHR21586:SF1', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 247438),
(375363, 'PTHR21586:SF2', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C-RELATED PROTEIN', 247438),
(375364, 'PTHR21586:SF0', NULL, NULL, NULL, NULL, 'PP2C-LIKE DOMAIN-CONTAINING PROTEIN CG9801', 247438),
(375365, 'PTHR21586:SF4', NULL, NULL, NULL, NULL, '', 247438),
(375366, 'PTHR21586', NULL, NULL, NULL, NULL, 'TIPA', 247438),
(375367, 'PTHR33452:SF20', NULL, NULL, NULL, NULL, 'BLR2393 PROTEIN', 247439),
(375368, 'PTHR33452:SF10', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE MHQP-RELATED', 247439),
(375369, 'PTHR33452:SF1', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YPHA-RELATED', 247439),
(375370, 'PTHR33452:SF19', NULL, NULL, NULL, NULL, 'DOXD-LIKE INNER MEMBRANE PROTEIN', 247439),
(375371, 'PTHR33452:SF4', NULL, NULL, NULL, NULL, 'BLL4328 PROTEIN', 247439),
(375372, 'PTHR33452', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE CATD-RELATED', 247439),
(375373, 'PTHR33452:SF7', NULL, NULL, NULL, NULL, '', 247439),
(375374, 'PTHR39447:SF2', NULL, NULL, NULL, NULL, 'ALPHA-L-ARABINOFURANOSIDASE B', 247440),
(375375, 'PTHR39447', NULL, NULL, NULL, NULL, 'ALPHA-L-ARABINOFURANOSIDASE B', 247440),
(375376, 'PTHR32097:SF17', NULL, NULL, NULL, NULL, 'CAMP-BINDING PROTEIN 1-RELATED', 247441),
(375377, 'PTHR32097:SF18', NULL, NULL, NULL, NULL, 'HYPOTHETICAL CYTOSOLIC PROTEIN', 247441),
(375378, 'PTHR32097:SF15', NULL, NULL, NULL, NULL, 'STRESS RESPONSE PROTEIN SCP2', 247441),
(375379, 'PTHR32097:SF3', NULL, NULL, NULL, NULL, 'TELLURITE RESISTANCE PROTEIN-RELATED', 247441),
(375380, 'PTHR32097', NULL, NULL, NULL, NULL, 'CAMP-BINDING PROTEIN 1-RELATED', 247441),
(375381, 'PTHR32097:SF4', NULL, NULL, NULL, NULL, 'GENERAL STRESS PROTEIN 16U', 247441),
(375382, 'PTHR32097:SF14', NULL, NULL, NULL, NULL, 'TELLURIUM RESISTANCE PROTEIN TERD', 247441),
(375383, 'PTHR34571:SF1', NULL, NULL, NULL, NULL, '(S)-UREIDOGLYCINE AMINOHYDROLASE', 247442),
(375384, 'PTHR34571', NULL, NULL, NULL, NULL, '(S)-UREIDOGLYCINE AMINOHYDROLASE', 247442),
(375385, 'PTHR35383', NULL, NULL, NULL, NULL, 'MUCIN 12EA-RELATED', 247443),
(375386, 'PTHR35383:SF1', NULL, NULL, NULL, NULL, 'MUCIN 12EA-RELATED', 247443),
(375387, 'PTHR30483:SF6', NULL, NULL, NULL, NULL, 'PERIPLASMIC BINDING PROTEIN OF ABC TRANSPORTER FOR NATURAL AMINO ACIDS', 247444),
(375388, 'PTHR30483:SF40', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE', 247444);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(375389, 'PTHR30483:SF37', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER SUBSTRATE-BINDING PROTEIN', 247444),
(375390, 'PTHR30483:SF38', NULL, NULL, NULL, NULL, 'BLR7848 PROTEIN', 247444),
(375391, 'PTHR30483', NULL, NULL, NULL, NULL, 'LEUCINE-SPECIFIC-BINDING PROTEIN', 247444),
(375392, 'PTHR33085:SF80', NULL, NULL, NULL, NULL, '', 247445),
(375393, 'PTHR33085:SF44', NULL, NULL, NULL, NULL, '', 247445),
(375394, 'PTHR33085:SF88', NULL, NULL, NULL, NULL, 'OS02G0140900 PROTEIN', 247445),
(375395, 'PTHR33085:SF89', NULL, NULL, NULL, NULL, '', 247445),
(375396, 'PTHR33085:SF42', NULL, NULL, NULL, NULL, '', 247445),
(375397, 'PTHR33085:SF43', NULL, NULL, NULL, NULL, '', 247445),
(375398, 'PTHR33085:SF87', NULL, NULL, NULL, NULL, '', 247445),
(375399, 'PTHR33085:SF40', NULL, NULL, NULL, NULL, 'OS06G0189600 PROTEIN', 247445),
(375400, 'PTHR33085:SF84', NULL, NULL, NULL, NULL, '', 247445),
(375401, 'PTHR33085:SF85', NULL, NULL, NULL, NULL, '', 247445),
(375402, 'PTHR33085:SF41', NULL, NULL, NULL, NULL, 'OS12G0624700 PROTEIN', 247445),
(375403, 'PTHR33085:SF82', NULL, NULL, NULL, NULL, 'OS02G0604200 PROTEIN', 247445),
(375404, 'PTHR33085:SF83', NULL, NULL, NULL, NULL, '', 247445),
(375405, 'PTHR33085:SF113', NULL, NULL, NULL, NULL, '', 247445),
(375406, 'PTHR33085:SF114', NULL, NULL, NULL, NULL, '', 247445),
(375407, 'PTHR33085:SF49', NULL, NULL, NULL, NULL, 'OS03G0778800 PROTEIN', 247445),
(375408, 'PTHR33085:SF47', NULL, NULL, NULL, NULL, 'OS02G0513400 PROTEIN', 247445),
(375409, 'PTHR33085:SF2', NULL, NULL, NULL, NULL, 'OS03G0817600 PROTEIN', 247445),
(375410, 'PTHR33085:SF119', NULL, NULL, NULL, NULL, '', 247445),
(375411, 'PTHR33085:SF118', NULL, NULL, NULL, NULL, '', 247445),
(375412, 'PTHR33085', NULL, NULL, NULL, NULL, 'OS12G0113100 PROTEIN-RELATED', 247445),
(375413, 'PTHR33085:SF77', NULL, NULL, NULL, NULL, '', 247445),
(375414, 'PTHR33085:SF78', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247445),
(375415, 'PTHR33085:SF32', NULL, NULL, NULL, NULL, 'OS03G0236675 PROTEIN', 247445),
(375416, 'PTHR33085:SF71', NULL, NULL, NULL, NULL, '', 247445),
(375417, 'PTHR33085:SF102', NULL, NULL, NULL, NULL, '', 247445),
(375418, 'PTHR33085:SF101', NULL, NULL, NULL, NULL, '', 247445),
(375419, 'PTHR33085:SF104', NULL, NULL, NULL, NULL, '', 247445),
(375420, 'PTHR33085:SF103', NULL, NULL, NULL, NULL, '', 247445),
(375421, 'PTHR33085:SF37', NULL, NULL, NULL, NULL, 'OS11G0143700 PROTEIN', 247445),
(375422, 'PTHR33085:SF38', NULL, NULL, NULL, NULL, '', 247445),
(375423, 'PTHR33085:SF100', NULL, NULL, NULL, NULL, '', 247445),
(375424, 'PTHR33085:SF105', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 247445),
(375425, 'PTHR33085:SF64', NULL, NULL, NULL, NULL, 'OS09G0555900 PROTEIN', 247445),
(375426, 'PTHR33085:SF62', NULL, NULL, NULL, NULL, 'OS03G0632600 PROTEIN', 247445),
(375427, 'PTHR33085:SF63', NULL, NULL, NULL, NULL, '', 247445),
(375428, 'PTHR33085:SF60', NULL, NULL, NULL, NULL, 'OS08G0271800 PROTEIN', 247445),
(375429, 'PTHR33085:SF131', NULL, NULL, NULL, NULL, '', 247445),
(375430, 'PTHR33085:SF130', NULL, NULL, NULL, NULL, 'OS05G0126000 PROTEIN', 247445),
(375431, 'PTHR33085:SF133', NULL, NULL, NULL, NULL, '', 247445),
(375432, 'PTHR33085:SF68', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 247445),
(375433, 'PTHR33085:SF69', NULL, NULL, NULL, NULL, 'OS07G0234700 PROTEIN', 247445),
(375434, 'PTHR33085:SF132', NULL, NULL, NULL, NULL, 'OS02G0198100 PROTEIN', 247445),
(375435, 'PTHR33085:SF56', NULL, NULL, NULL, NULL, 'OS07G0513400 PROTEIN', 247445),
(375436, 'PTHR33085:SF97', NULL, NULL, NULL, NULL, '', 247445),
(375437, 'PTHR33085:SF53', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 247445),
(375438, 'PTHR33085:SF51', NULL, NULL, NULL, NULL, '', 247445),
(375439, 'PTHR33085:SF95', NULL, NULL, NULL, NULL, '', 247445),
(375440, 'PTHR33085:SF52', NULL, NULL, NULL, NULL, 'OS07G0690600 PROTEIN', 247445),
(375441, 'PTHR33085:SF96', NULL, NULL, NULL, NULL, '', 247445),
(375442, 'PTHR33085:SF93', NULL, NULL, NULL, NULL, '', 247445),
(375443, 'PTHR33085:SF50', NULL, NULL, NULL, NULL, '', 247445); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(375444, 'PTHR33085:SF124', NULL, NULL, NULL, NULL, '', 247445),
(375445, 'PTHR33085:SF123', NULL, NULL, NULL, NULL, '', 247445),
(375446, 'PTHR33085:SF126', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247445),
(375447, 'PTHR33085:SF125', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247445),
(375448, 'PTHR33085:SF120', NULL, NULL, NULL, NULL, 'OS05G0302200 PROTEIN', 247445),
(375449, 'PTHR33085:SF13', NULL, NULL, NULL, NULL, 'OS02G0146900 PROTEIN', 247445),
(375450, 'PTHR33085:SF122', NULL, NULL, NULL, NULL, 'OS02G0141400 PROTEIN', 247445),
(375451, 'PTHR33085:SF121', NULL, NULL, NULL, NULL, 'OS03G0781800 PROTEIN', 247445),
(375452, 'PTHR33085:SF128', NULL, NULL, NULL, NULL, '', 247445),
(375453, 'PTHR33085:SF127', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247445),
(375454, 'PTHR33085:SF129', NULL, NULL, NULL, NULL, 'OS04G0426500 PROTEIN', 247445),
(375455, 'PTHR15633:SF3', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 11', 247446),
(375456, 'PTHR15633:SF4', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 11', 247446),
(375457, 'PTHR15633:SF2', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 11', 247446),
(375458, 'PTHR15633', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247446),
(375459, 'PTHR14063:SF7', NULL, NULL, NULL, NULL, 'PROTEIN LIN-7 HOMOLOG B', 247447),
(375460, 'PTHR14063:SF8', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN', 247447),
(375461, 'PTHR14063:SF5', NULL, NULL, NULL, NULL, 'PROTEIN LIN-7 HOMOLOG C', 247447),
(375462, 'PTHR14063', NULL, NULL, NULL, NULL, 'PROTEIN LIN-7 HOMOLOG', 247447),
(375463, 'PTHR14063:SF4', NULL, NULL, NULL, NULL, 'PROTEIN LIN-7 HOMOLOG A', 247447),
(375464, 'PTHR14063:SF1', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN 11', 247447),
(375465, 'PTHR14063:SF2', NULL, NULL, NULL, NULL, 'PROTEIN LIN-7 HOMOLOG', 247447),
(375466, 'PTHR14063:SF9', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN 11', 247447),
(375467, 'PTHR46096', NULL, NULL, NULL, NULL, 'PERFORIN-1', 247448),
(375468, 'PTHR46096:SF5', NULL, NULL, NULL, NULL, 'PERFORIN 1.2-RELATED', 247448),
(375469, 'PTHR46096:SF3', NULL, NULL, NULL, NULL, 'PERFORIN-1', 247448),
(375470, 'PTHR46096:SF1', NULL, NULL, NULL, NULL, 'PERFORIN 1.5-RELATED', 247448),
(375471, 'PTHR13636', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247449),
(375472, 'PTHR13636:SF0', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 258', 247449),
(375473, 'PTHR46875:SF1', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 5', 247450),
(375474, 'PTHR46875', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 5', 247450),
(375475, 'PTHR38602:SF1', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', 247451),
(375476, 'PTHR38602', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', 247451),
(375477, 'PTHR24061:SF495', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F3_4 DOMAIN-CONTAINING PROTEIN', 247452),
(375478, 'PTHR24061:SF492', NULL, NULL, NULL, NULL, 'VOMERONASAL 2, RECEPTOR 100-RELATED', 247452),
(375479, 'PTHR24061:SF0', NULL, NULL, NULL, NULL, 'VOMERONASAL 2, RECEPTOR 18-RELATED', 247452),
(375480, 'PTHR24061:SF1', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-2 RECEPTOR 1', 247452),
(375481, 'PTHR24061:SF529', NULL, NULL, NULL, NULL, 'VOMERONASAL 2, RECEPTOR 53-RELATED', 247452),
(375482, 'PTHR24061:SF409', NULL, NULL, NULL, NULL, 'VOMERONASAL 2, RECEPTOR 76', 247452),
(375483, 'PTHR24061', NULL, NULL, NULL, NULL, 'CALCIUM-SENSING RECEPTOR-RELATED', 247452),
(375484, 'PTHR24061:SF528', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F3_4 DOMAIN-CONTAINING PROTEIN', 247452),
(375485, 'PTHR24061:SF506', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR C FAMILY, B1', 247452),
(375486, 'PTHR24061:SF404', NULL, NULL, NULL, NULL, 'VOMERONASAL 2, RECEPTOR 105', 247452),
(375487, 'PTHR24061:SF504', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR C FAMILY, V2', 247452),
(375488, 'PTHR24061:SF405', NULL, NULL, NULL, NULL, 'VOMERONASAL 2, RECEPTOR 118', 247452),
(375489, 'PTHR24061:SF403', NULL, NULL, NULL, NULL, 'VOMERONASAL 2, RECEPTOR 113-RELATED', 247452),
(375490, 'PTHR24061:SF524', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F3_4 DOMAIN-CONTAINING PROTEIN', 247452);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(375491, 'PTHR24061:SF502', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F3_4 DOMAIN-CONTAINING PROTEIN', 247452),
(375492, 'PTHR24061:SF422', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F3_4 DOMAIN-CONTAINING PROTEIN', 247452),
(375493, 'PTHR24061:SF541', NULL, NULL, NULL, NULL, 'VOMERONASAL 2, RECEPTOR 57-RELATED', 247452),
(375494, 'PTHR24061:SF540', NULL, NULL, NULL, NULL, 'VOMERONASAL 2, RECEPTOR 120', 247452),
(375495, 'PTHR24061:SF441', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR, TYPE 1, MEMBER 2, TANDEM DUPLICATE 2', 247452),
(375496, 'PTHR24061:SF5', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR FAMILY C GROUP 6 MEMBER A', 247452),
(375497, 'PTHR24061:SF3', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 1 MEMBER 1', 247452),
(375498, 'PTHR24061:SF519', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F3_4 DOMAIN-CONTAINING PROTEIN', 247452),
(375499, 'PTHR24061:SF538', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR C FAMILY, H1', 247452),
(375500, 'PTHR24061:SF418', NULL, NULL, NULL, NULL, 'C-FAMILY ODORANT RECEPTOR OLFCQ19-RELATED', 247452),
(375501, 'PTHR24061:SF539', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR C FAMILY, S1', 247452),
(375502, 'PTHR24061:SF517', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 1 MEMBER 2', 247452),
(375503, 'PTHR24061:SF415', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR C FAMILY, R1', 247452),
(375504, 'PTHR24061:SF536', NULL, NULL, NULL, NULL, 'VOMERONASAL 2, RECEPTOR 19-RELATED', 247452),
(375505, 'PTHR24061:SF537', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR C FAMILY, J1', 247452),
(375506, 'PTHR24061:SF413', NULL, NULL, NULL, NULL, 'VOMERONASAL 2, RECEPTOR 66-RELATED', 247452),
(375507, 'PTHR24061:SF457', NULL, NULL, NULL, NULL, 'EC1-V2R PHEROMONE RECEPTOR PROTEIN-RELATED', 247452),
(375508, 'PTHR24061:SF358', NULL, NULL, NULL, NULL, 'EXTRACELLULAR CALCIUM-SENSING RECEPTOR', 247452),
(375509, 'PTHR24061:SF435', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 1 MEMBER 3', 247452),
(375510, 'PTHR24061:SF534', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F3_4 DOMAIN-CONTAINING PROTEIN-RELATED', 247452),
(375511, 'PTHR24061:SF436', NULL, NULL, NULL, NULL, 'EC2-V2R PHEROMONE RECEPTOR PROTEIN-RELATED', 247452),
(375512, 'PTHR24061:SF535', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F3_4 DOMAIN-CONTAINING PROTEIN-RELATED', 247452),
(375513, 'PTHR24061:SF532', NULL, NULL, NULL, NULL, 'VOMERONASAL 2, RECEPTOR 16-RELATED', 247452),
(375514, 'PTHR24061:SF411', NULL, NULL, NULL, NULL, 'VOMERONASAL 2, RECEPTOR 10-RELATED', 247452),
(375515, 'PTHR24061:SF511', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR C FAMILY, X1-RELATED', 247452),
(375516, 'PTHR24061:SF530', NULL, NULL, NULL, NULL, 'VOMERONASAL 2 RECEPTOR 128-RELATED', 247452),
(375517, 'PTHR24061:SF398', NULL, NULL, NULL, NULL, 'VOMERONASAL 2, RECEPTOR 111-RELATED', 247452),
(375518, 'PTHR35670:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 81', 247453),
(375519, 'PTHR35670', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 81', 247453),
(375520, 'PTHR14356:SF2', NULL, NULL, NULL, NULL, 'INTERLEUKIN-21', 247454),
(375521, 'PTHR14356:SF3', NULL, NULL, NULL, NULL, 'INTERLEUKIN-15', 247454),
(375522, 'PTHR14356', NULL, NULL, NULL, NULL, 'INTERLEUKIN-15-RELATED', 247454),
(375523, 'PTHR11955:SF89', NULL, NULL, NULL, NULL, 'FATTY ACID-BINDING PROTEIN, INTESTINAL', 247455),
(375524, 'PTHR11955:SF67', NULL, NULL, NULL, NULL, 'FABP DOMAIN-CONTAINING PROTEIN-RELATED', 247455),
(375525, 'PTHR11955:SF66', NULL, NULL, NULL, NULL, 'LIPOCLN_CYTOSOLIC_FA-BD_DOM DOMAIN-CONTAINING PROTEIN', 247455),
(375526, 'PTHR11955:SF64', NULL, NULL, NULL, NULL, 'MYELIN P2 PROTEIN', 247455),
(375527, 'PTHR11955:SF69', NULL, NULL, NULL, NULL, 'GASTROTROPIN', 247455),
(375528, 'PTHR11955:SF139', NULL, NULL, NULL, NULL, 'LIPOCLN_CYTOSOLIC_FA-BD_DOM DOMAIN-CONTAINING PROTEIN', 247455),
(375529, 'PTHR11955:SF135', NULL, NULL, NULL, NULL, 'FATTY ACID BINDING PROTEIN, ISOFORM C', 247455),
(375530, 'PTHR11955:SF153', NULL, NULL, NULL, NULL, 'FATTY ACID-BINDING PROTEIN HOMOLOG 9', 247455),
(375531, 'PTHR11955:SF152', NULL, NULL, NULL, NULL, 'CELLULAR RETINOIC ACID-BINDING PROTEIN 2', 247455);
INSERT INTO "PUBLIC"."MODEL" VALUES
(375532, 'PTHR11955:SF133', NULL, NULL, NULL, NULL, 'CELLULAR RETINOIC ACID-BINDING PROTEIN 2, B', 247455),
(375533, 'PTHR11955', NULL, NULL, NULL, NULL, 'FATTY ACID BINDING PROTEIN', 247455),
(375534, 'PTHR11955:SF151', NULL, NULL, NULL, NULL, 'LIPOCLN_CYTOSOLIC_FA-BD_DOM DOMAIN-CONTAINING PROTEIN', 247455),
(375535, 'PTHR11955:SF150', NULL, NULL, NULL, NULL, 'ADIPOCYTE FATTY ACID-BINDING PROTEIN-RELATED', 247455),
(375536, 'PTHR11955:SF70', NULL, NULL, NULL, NULL, 'FATTY ACID-BINDING PROTEIN 9', 247455),
(375537, 'PTHR11955:SF90', NULL, NULL, NULL, NULL, 'FATTY ACID BINDING PROTEIN 11A', 247455),
(375538, 'PTHR11955:SF74', NULL, NULL, NULL, NULL, 'RETINOL-BINDING PROTEIN 5', 247455),
(375539, 'PTHR11955:SF96', NULL, NULL, NULL, NULL, 'FATTY ACID-BINDING PROTEIN, LIVER', 247455),
(375540, 'PTHR11955:SF56', NULL, NULL, NULL, NULL, 'RETINOL-BINDING PROTEIN 1', 247455),
(375541, 'PTHR11955:SF76', NULL, NULL, NULL, NULL, 'FATTY ACID-BINDING PROTEIN 12', 247455),
(375542, 'PTHR11955:SF75', NULL, NULL, NULL, NULL, 'FATTY ACID-BINDING PROTEIN HOMOLOG 7-RELATED', 247455),
(375543, 'PTHR11955:SF97', NULL, NULL, NULL, NULL, 'RETINOID-BINDING PROTEIN 7', 247455),
(375544, 'PTHR11955:SF59', NULL, NULL, NULL, NULL, 'RETINOL-BINDING PROTEIN 2', 247455),
(375545, 'PTHR11955:SF58', NULL, NULL, NULL, NULL, 'FATTY ACID-BINDING PROTEIN 5', 247455),
(375546, 'PTHR11955:SF57', NULL, NULL, NULL, NULL, 'FATTY ACID-BINDING PROTEIN, BRAIN', 247455),
(375547, 'PTHR11955:SF145', NULL, NULL, NULL, NULL, 'RETINOL BINDING PROTEIN 1', 247455),
(375548, 'PTHR11955:SF147', NULL, NULL, NULL, NULL, '', 247455),
(375549, 'PTHR11955:SF144', NULL, NULL, NULL, NULL, 'FATTY ACID-BINDING PROTEIN 5-LIKE PROTEIN 3-RELATED', 247455),
(375550, 'PTHR11955:SF81', NULL, NULL, NULL, NULL, 'RETINOL-BINDING PROTEIN 7A, CELLULAR', 247455),
(375551, 'PTHR11955:SF62', NULL, NULL, NULL, NULL, 'CELLULAR RETINOIC ACID-BINDING PROTEIN 1', 247455),
(375552, 'PTHR11955:SF83', NULL, NULL, NULL, NULL, 'FATTY ACID-BINDING PROTEIN, ADIPOCYTE', 247455),
(375553, 'PTHR11955:SF61', NULL, NULL, NULL, NULL, 'FATTY ACID-BINDING PROTEIN, HEART', 247455),
(375554, 'PTHR11955:SF82', NULL, NULL, NULL, NULL, 'FATTY ACID-BINDING PROTEIN HOMOLOG 5', 247455),
(375555, 'PTHR32021:SF41', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 5B2', 247456),
(375556, 'PTHR32021:SF22', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 247456),
(375557, 'PTHR32021:SF21', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 5C2', 247456),
(375558, 'PTHR32021:SF24', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 247456),
(375559, 'PTHR32021:SF45', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 247456),
(375560, 'PTHR32021:SF48', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 5B1', 247456),
(375561, 'PTHR32021:SF47', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 247456),
(375562, 'PTHR32021:SF40', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 247456),
(375563, 'PTHR32021:SF5', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 5B3', 247456),
(375564, 'PTHR32021:SF0', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 5B2', 247456),
(375565, 'PTHR32021:SF49', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 5B2', 247456),
(375566, 'PTHR32021:SF29', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 247456),
(375567, 'PTHR32021:SF1', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 5A1', 247456),
(375568, 'PTHR32021:SF30', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 5C1', 247456),
(375569, 'PTHR32021:SF33', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 247456),
(375570, 'PTHR32021:SF32', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 5C3', 247456),
(375571, 'PTHR32021:SF35', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 247456),
(375572, 'PTHR32021:SF37', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 247456),
(375573, 'PTHR32021:SF36', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 247456),
(375574, 'PTHR32021:SF51', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 5B3', 247456),
(375575, 'PTHR32021:SF50', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 247456),
(375576, 'PTHR32021:SF39', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN', 247456),
(375577, 'PTHR32021:SF16', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 5A2', 247456);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(375578, 'PTHR32021:SF19', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 5A2', 247456),
(375579, 'PTHR32021', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 5B3', 247456),
(375580, 'PTHR38814', NULL, NULL, NULL, NULL, 'ENDONUCLEASE NUCS', 247457),
(375581, 'PTHR38814:SF1', NULL, NULL, NULL, NULL, 'ENDONUCLEASE NUCS', 247457),
(375582, 'PTHR13109:SF7', NULL, NULL, NULL, NULL, 'NEUROCHONDRIN', 247458),
(375583, 'PTHR13109', NULL, NULL, NULL, NULL, 'NEUROCHONDRIN', 247458),
(375584, 'PTHR37293', NULL, NULL, NULL, NULL, 'PHAGE REPLICATION PROTEIN-RELATED', 247459),
(375585, 'PTHR37293:SF8', NULL, NULL, NULL, NULL, 'PHAGE REPLICATION PROTEIN-RELATED', 247459),
(375586, 'PTHR37293:SF7', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PHAGE PROTEIN', 247459),
(375587, 'PTHR37293:SF6', NULL, NULL, NULL, NULL, 'DNA REPLICATION PROTEIN DNAD', 247459),
(375588, 'PTHR37293:SF5', NULL, NULL, NULL, NULL, 'SLL1169 PROTEIN', 247459),
(375589, 'PTHR48212', NULL, NULL, NULL, NULL, '', 247460),
(375590, 'PTHR48212:SF1', NULL, NULL, NULL, NULL, '', 247460),
(375591, 'PTHR43570:SF25', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE FAMILY 3 MEMBER I1, CHLOROPLASTIC', 247461),
(375592, 'PTHR43570', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE', 247461),
(375593, 'PTHR43570:SF12', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE FAMILY 3 MEMBER B2-RELATED', 247461),
(375594, 'PTHR43570:SF23', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE', 247461),
(375595, 'PTHR43570:SF11', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE', 247461),
(375596, 'PTHR43570:SF22', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE', 247461),
(375597, 'PTHR43570:SF33', NULL, NULL, NULL, NULL, 'ALDEDH DOMAIN-CONTAINING PROTEIN', 247461),
(375598, 'PTHR43570:SF21', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE', 247461),
(375599, 'PTHR43570:SF32', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE', 247461),
(375600, 'PTHR43570:SF20', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE ALDX-RELATED', 247461),
(375601, 'PTHR43570:SF31', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE', 247461),
(375602, 'PTHR43570:SF30', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE', 247461),
(375603, 'PTHR43570:SF9', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE FAMILY 3 MEMBER A2', 247461),
(375604, 'PTHR43570:SF28', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE', 247461),
(375605, 'PTHR43570:SF5', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE', 247461),
(375606, 'PTHR43570:SF17', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE FAMILY 3 MEMBER F1', 247461),
(375607, 'PTHR43570:SF6', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE FAMILY 3 MEMBER B2', 247461),
(375608, 'PTHR43570:SF16', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE TYPE III, ISOFORM Q', 247461),
(375609, 'PTHR43570:SF26', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE', 247461),
(375610, 'PTHR43570:SF7', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE', 247461),
(375611, 'PTHR43570:SF15', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE, DIMERIC NADP-PREFERRING', 247461),
(375612, 'PTHR43570:SF2', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE FAMILY 3 MEMBER B1', 247461),
(375613, 'PTHR21717:SF74', NULL, NULL, NULL, NULL, 'TRF-LIKE 9-RELATED', 247462),
(375614, 'PTHR21717:SF64', NULL, NULL, NULL, NULL, 'TELOMERE REPEAT-BINDING PROTEIN 4', 247462),
(375615, 'PTHR21717:SF61', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 247462),
(375616, 'PTHR21717:SF83', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 247462),
(375617, 'PTHR21717:SF72', NULL, NULL, NULL, NULL, 'TELOMERE-BINDING PROTEIN 1', 247462),
(375618, 'PTHR21717:SF84', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE, UBIQUITIN-RELATED DOMAIN PROTEIN-RELATED', 247462),
(375619, 'PTHR21717:SF73', NULL, NULL, NULL, NULL, 'TELOMERE-BINDING PROTEIN, PUTATIVE-RELATED', 247462),
(375620, 'PTHR21717:SF67', NULL, NULL, NULL, NULL, 'TELOMERE REPEAT-BINDING PROTEIN 4-LIKE', 247462),
(375621, 'PTHR21717:SF56', NULL, NULL, NULL, NULL, 'TELOMERE-BINDING PROTEIN, PUTATIVE-RELATED', 247462),
(375622, 'PTHR21717:SF78', NULL, NULL, NULL, NULL, 'TELOMERE REPEAT-BINDING PROTEIN 4-LIKE', 247462);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(375623, 'PTHR21717:SF79', NULL, NULL, NULL, NULL, 'TELOMERE REPEAT-BINDING PROTEIN 6', 247462),
(375624, 'PTHR21717:SF76', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 247462),
(375625, 'PTHR21717:SF65', NULL, NULL, NULL, NULL, 'TELOMERE REPEAT-BINDING PROTEIN 1', 247462),
(375626, 'PTHR21717:SF77', NULL, NULL, NULL, NULL, 'BNAANNG26340D PROTEIN', 247462),
(375627, 'PTHR21717:SF66', NULL, NULL, NULL, NULL, 'BNAC01G38480D PROTEIN', 247462),
(375628, 'PTHR21717:SF81', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE, UBIQUITIN-RELATED DOMAIN PROTEIN-RELATED', 247462),
(375629, 'PTHR21717:SF70', NULL, NULL, NULL, NULL, 'TELOMERE REPEAT-BINDING PROTEIN 2-RELATED', 247462),
(375630, 'PTHR21717:SF82', NULL, NULL, NULL, NULL, 'TELOMERE REPEAT-BINDING PROTEIN 5-LIKE ISOFORM X2', 247462),
(375631, 'PTHR21717:SF71', NULL, NULL, NULL, NULL, 'TELOMERE REPEAT-BINDING PROTEIN 2-LIKE ISOFORM X1', 247462),
(375632, 'PTHR21717:SF80', NULL, NULL, NULL, NULL, 'TELOMERE REPEAT-BINDING PROTEIN 3', 247462),
(375633, 'PTHR21717', NULL, NULL, NULL, NULL, 'TELOMERIC REPEAT BINDING PROTEIN', 247462),
(375634, 'PTHR11138:SF5', NULL, NULL, NULL, NULL, 'METHIONYL-TRNA FORMYLTRANSFERASE, MITOCHONDRIAL', 247463),
(375635, 'PTHR11138:SF6', NULL, NULL, NULL, NULL, 'METHIONYL-TRNA FORMYLTRANSFERASE-RELATED', 247463),
(375636, 'PTHR11138', NULL, NULL, NULL, NULL, 'METHIONYL-TRNA FORMYLTRANSFERASE', 247463),
(375637, 'PTHR47463:SF2', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SKIP16', 247464),
(375638, 'PTHR47463:SF3', NULL, NULL, NULL, NULL, 'APAG DOMAIN-CONTAINING PROTEIN', 247464),
(375639, 'PTHR47463', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SKIP16', 247464),
(375640, 'PTHR36684', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY PROTEIN COX14', 247465),
(375641, 'PTHR36684:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY PROTEIN COX14', 247465),
(375642, 'PTHR30448:SF0', NULL, NULL, NULL, NULL, 'RNASE ADAPTER PROTEIN RAPZ', 247466),
(375643, 'PTHR30448', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247466),
(375644, 'PTHR46257:SF2', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE NON-RECEPTOR TYPE', 247467),
(375645, 'PTHR46257', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE CORKSCREW', 247467),
(375646, 'PTHR46257:SF1', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE NON-RECEPTOR TYPE', 247467),
(375647, 'PTHR46257:SF4', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE NON-RECEPTOR TYPE 6', 247467),
(375648, 'PTHR46257:SF3', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE CORKSCREW', 247467),
(375649, 'PTHR12847:SF5', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER I FAMILY MEMBER 19', 247468),
(375650, 'PTHR12847', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE  ABC  TRANSPORTER-RELATED', 247468),
(375651, 'PTHR12847:SF3', NULL, NULL, NULL, NULL, 'EAR-BINDING COAT-ASSOCIATED PROTEIN 2, PUTATIVE, EXPRESSED-RELATED', 247468),
(375652, 'PTHR12847:SF10', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER I FAMILY MEMBER 21', 247468),
(375653, 'PTHR12847:SF12', NULL, NULL, NULL, NULL, 'CCR4-ASSOCIATED FACTOR 16', 247468),
(375654, 'PTHR12847:SF9', NULL, NULL, NULL, NULL, 'NECAP-LIKE PROTEIN CG9132', 247468),
(375655, 'PTHR12847:SF15', NULL, NULL, NULL, NULL, 'ADAPTIN EAR-BINDING COAT-ASSOCIATED PROTEIN 1', 247468),
(375656, 'PTHR12847:SF14', NULL, NULL, NULL, NULL, 'DUF1681 DOMAIN-CONTAINING PROTEIN', 247468),
(375657, 'PTHR12847:SF17', NULL, NULL, NULL, NULL, 'DUF1681 DOMAIN-CONTAINING PROTEIN', 247468),
(375658, 'PTHR12847:SF16', NULL, NULL, NULL, NULL, 'ADAPTIN EAR-BINDING COAT-ASSOCIATED PROTEIN 2', 247468),
(375659, 'PTHR39603:SF1', NULL, NULL, NULL, NULL, '', 247469),
(375660, 'PTHR39603', NULL, NULL, NULL, NULL, '', 247469),
(375661, 'PTHR33390:SF5', NULL, NULL, NULL, NULL, 'STRESS UP-REGULATED NOD 19-RELATED', 247470),
(375662, 'PTHR33390:SF1', NULL, NULL, NULL, NULL, 'STRESS UP-REGULATED NOD 19 PROTEIN', 247470),
(375663, 'PTHR33390', NULL, NULL, NULL, NULL, 'STRESS UP-REGULATED NOD 19 PROTEIN', 247470),
(375664, 'PTHR33390:SF3', NULL, NULL, NULL, NULL, '', 247470),
(375665, 'PTHR33390:SF4', NULL, NULL, NULL, NULL, 'STRESS UP-REGULATED NOD 19-RELATED', 247470);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(375666, 'PTHR33390:SF9', NULL, NULL, NULL, NULL, 'MTN19', 247470),
(375667, 'PTHR39523:SF1', NULL, NULL, NULL, NULL, '', 247471),
(375668, 'PTHR39523', NULL, NULL, NULL, NULL, '', 247471),
(375669, 'PTHR42912:SF79', NULL, NULL, NULL, NULL, 'METHYLTRANSF_25 DOMAIN-CONTAINING PROTEIN', 247472),
(375670, 'PTHR42912:SF58', NULL, NULL, NULL, NULL, 'BLR1400 PROTEIN', 247472),
(375671, 'PTHR42912:SF15', NULL, NULL, NULL, NULL, '', 247472),
(375672, 'PTHR42912:SF85', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE TYPE 11', 247472),
(375673, 'PTHR42912:SF86', NULL, NULL, NULL, NULL, 'BLL4992 PROTEIN', 247472),
(375674, 'PTHR42912:SF87', NULL, NULL, NULL, NULL, 'PHTHIOTRIOL/PHENOLPHTHIOTRIOL DIMYCOCEROSATES METHYLTRANSFERASE', 247472),
(375675, 'PTHR42912:SF88', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 247472),
(375676, 'PTHR42912:SF81', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 247472),
(375677, 'PTHR42912:SF82', NULL, NULL, NULL, NULL, 'HISTAMINE N-METHYLTRANSFERASE', 247472),
(375678, 'PTHR42912:SF60', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE OMS1, MITOCHONDRIAL', 247472),
(375679, 'PTHR42912:SF83', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE TPCH', 247472),
(375680, 'PTHR42912:SF84', NULL, NULL, NULL, NULL, 'METHYLTRANFER_DOM DOMAIN-CONTAINING PROTEIN', 247472),
(375681, 'PTHR42912:SF80', NULL, NULL, NULL, NULL, 'DEMETHYLMENAQUINONE METHYLTRANSFERASE', 247472),
(375682, 'PTHR42912:SF6', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 247472),
(375683, 'PTHR42912', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 247472),
(375684, 'PTHR42912:SF45', NULL, NULL, NULL, NULL, '23S RRNA (GUANINE(745)-N(1))-METHYLTRANSFERASE', 247472),
(375685, 'PTHR42912:SF89', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 247472),
(375686, 'PTHR42912:SF68', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 247472),
(375687, 'PTHR42912:SF96', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLETHANOLAMINE N-METHYLTRANSFERASE', 247472),
(375688, 'PTHR42912:SF97', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 247472),
(375689, 'PTHR42912:SF92', NULL, NULL, NULL, NULL, 'METHYLTRANSF_25 DOMAIN-CONTAINING PROTEIN', 247472),
(375690, 'PTHR42912:SF71', NULL, NULL, NULL, NULL, '', 247472),
(375691, 'PTHR42912:SF93', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE-LIKE PROTEIN 7A', 247472),
(375692, 'PTHR42912:SF94', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 247472),
(375693, 'PTHR42912:SF95', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 247472),
(375694, 'PTHR42912:SF90', NULL, NULL, NULL, NULL, 'METHYLTRANSF_25 DOMAIN-CONTAINING PROTEIN', 247472),
(375695, 'PTHR42912:SF91', NULL, NULL, NULL, NULL, '', 247472),
(375696, 'PTHR43779', NULL, NULL, NULL, NULL, 'DIOXYGENASE RV0097-RELATED', 247473),
(375697, 'PTHR43779:SF3', NULL, NULL, NULL, NULL, 'DIOXYGENASE RV0097-RELATED', 247473),
(375698, 'PTHR43779:SF2', NULL, NULL, NULL, NULL, 'ALPHA-KETOGLUTARATE-DEPENDENT XANTHINE DIOXYGENASE XAN1', 247473),
(375699, 'PTHR46171', NULL, NULL, NULL, NULL, 'GH10160P', 247474),
(375700, 'PTHR46171:SF2', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 44', 247474),
(375701, 'PTHR46171:SF3', NULL, NULL, NULL, NULL, 'GH10160P', 247474),
(375702, 'PTHR46171:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF38', 247474),
(375703, 'PTHR13462:SF55', NULL, NULL, NULL, NULL, 'CALCIUM UNIPORTER PROTEIN', 247475),
(375704, 'PTHR13462:SF54', NULL, NULL, NULL, NULL, 'CALCIUM UNIPORTER PROTEIN', 247475),
(375705, 'PTHR13462:SF10', NULL, NULL, NULL, NULL, 'CALCIUM UNIPORTER PROTEIN, MITOCHONDRIAL', 247475),
(375706, 'PTHR13462:SF34', NULL, NULL, NULL, NULL, 'CALCIUM UNIPORTER PROTEIN 2, MITOCHONDRIAL', 247475),
(375707, 'PTHR13462:SF51', NULL, NULL, NULL, NULL, 'CALCIUM UNIPORTER PROTEIN', 247475),
(375708, 'PTHR13462:SF6', NULL, NULL, NULL, NULL, 'CALCIUM UNIPORTER REGULATORY SUBUNIT MCUB, MITOCHONDRIAL', 247475),
(375709, 'PTHR13462:SF31', NULL, NULL, NULL, NULL, 'CALCIUM UNIPORTER PROTEIN 1, MITOCHONDRIAL', 247475);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(375710, 'PTHR13462:SF53', NULL, NULL, NULL, NULL, 'CALCIUM UNIPORTER PROTEIN', 247475),
(375711, 'PTHR13462:SF52', NULL, NULL, NULL, NULL, 'CALCIUM UNIPORTER PROTEIN', 247475),
(375712, 'PTHR13462:SF19', NULL, NULL, NULL, NULL, 'CALCIUM UNIPORTER PROTEIN', 247475),
(375713, 'PTHR13462:SF37', NULL, NULL, NULL, NULL, 'CALCIUM UNIPORTER PROTEIN', 247475),
(375714, 'PTHR13462:SF39', NULL, NULL, NULL, NULL, 'CALCIUM UNIPORTER PROTEIN 3, MITOCHONDRIAL', 247475),
(375715, 'PTHR13462:SF17', NULL, NULL, NULL, NULL, 'CALCIUM UNIPORTER PROTEIN 4, MITOCHONDRIAL', 247475),
(375716, 'PTHR13462:SF38', NULL, NULL, NULL, NULL, 'CALCIUM UNIPORTER PROTEIN', 247475),
(375717, 'PTHR13462:SF16', NULL, NULL, NULL, NULL, 'CALCIUM UNIPORTER PROTEIN, MITOCHONDRIAL', 247475),
(375718, 'PTHR13462:SF44', NULL, NULL, NULL, NULL, 'CALCIUM UNIPORTER PROTEIN', 247475),
(375719, 'PTHR13462:SF43', NULL, NULL, NULL, NULL, 'CALCIUM UNIPORTER PROTEIN', 247475),
(375720, 'PTHR13462:SF46', NULL, NULL, NULL, NULL, 'CALCIUM UNIPORTER PROTEIN', 247475),
(375721, 'PTHR13462:SF40', NULL, NULL, NULL, NULL, 'CALCIUM UNIPORTER PROTEIN', 247475),
(375722, 'PTHR13462:SF42', NULL, NULL, NULL, NULL, 'CALCIUM UNIPORTER PROTEIN', 247475),
(375723, 'PTHR13462:SF41', NULL, NULL, NULL, NULL, 'CALCIUM UNIPORTER PROTEIN 6, MITOCHONDRIAL', 247475),
(375724, 'PTHR13462:SF48', NULL, NULL, NULL, NULL, 'CALCIUM UNIPORTER PROTEIN', 247475),
(375725, 'PTHR13462', NULL, NULL, NULL, NULL, 'CALCIUM UNIPORTER PROTEIN, MITOCHONDRIAL', 247475),
(375726, 'PTHR13462:SF47', NULL, NULL, NULL, NULL, 'CALCIUM UNIPORTER PROTEIN', 247475),
(375727, 'PTHR13462:SF49', NULL, NULL, NULL, NULL, 'CALCIUM UNIPORTER PROTEIN', 247475),
(375728, 'PTHR13242:SF0', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT L', 247476),
(375729, 'PTHR13242:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG06962', 247476),
(375730, 'PTHR13242', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3', 247476),
(375731, 'PTHR13242:SF3', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT L', 247476),
(375732, 'PTHR47982:SF5', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247477),
(375733, 'PTHR47982:SF47', NULL, NULL, NULL, NULL, 'PROLINE-RICH RECEPTOR-LIKE PROTEIN KINASE PERK5', 247477),
(375734, 'PTHR47982:SF6', NULL, NULL, NULL, NULL, 'PROLINE-RICH RECEPTOR-LIKE PROTEIN KINASE PERK4', 247477),
(375735, 'PTHR47982:SF48', NULL, NULL, NULL, NULL, 'OS05G0516400 PROTEIN', 247477),
(375736, 'PTHR47982:SF3', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247477),
(375737, 'PTHR47982:SF45', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247477),
(375738, 'PTHR47982:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN KINASE FAMILY PROTEIN-RELATED', 247477),
(375739, 'PTHR47982:SF46', NULL, NULL, NULL, NULL, 'OS07G0568100 PROTEIN', 247477),
(375740, 'PTHR47982:SF43', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247477),
(375741, 'PTHR47982:SF9', NULL, NULL, NULL, NULL, 'PROTEIN KINASE APK1A, CHLOROPLASTIC-LIKE', 247477),
(375742, 'PTHR47982:SF44', NULL, NULL, NULL, NULL, 'PROLINE-RICH RECEPTOR-LIKE PROTEIN KINASE PERK13-RELATED', 247477),
(375743, 'PTHR47982:SF41', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE', 247477),
(375744, 'PTHR47982:SF7', NULL, NULL, NULL, NULL, 'PROLINE-RICH RECEPTOR-LIKE PROTEIN KINASE PERK6-RELATED', 247477),
(375745, 'PTHR47982:SF8', NULL, NULL, NULL, NULL, 'PROLINE-RICH RECEPTOR-LIKE PROTEIN KINASE PERK15', 247477),
(375746, 'PTHR47982:SF42', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247477),
(375747, 'PTHR47982:SF40', NULL, NULL, NULL, NULL, 'PROLINE-RICH RECEPTOR-LIKE PROTEIN KINASE PERK1', 247477),
(375748, 'PTHR47982:SF1', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE', 247477),
(375749, 'PTHR47982:SF2', NULL, NULL, NULL, NULL, 'OS01G0227200 PROTEIN', 247477),
(375750, 'PTHR47982:SF49', NULL, NULL, NULL, NULL, 'INACTIVE PROTEIN KINASE SELMODRAFT_444075', 247477),
(375751, 'PTHR47982:SF14', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247477);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(375752, 'PTHR47982:SF58', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247477),
(375753, 'PTHR47982:SF59', NULL, NULL, NULL, NULL, 'PROLINE-RICH RECEPTOR-LIKE PROTEIN KINASE PERK6-RELATED', 247477),
(375754, 'PTHR47982:SF15', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE, ACTIVE SITE PROTEIN-RELATED', 247477),
(375755, 'PTHR47982:SF12', NULL, NULL, NULL, NULL, 'SERINE-THREONINE/TYROSINE-PROTEIN KINASE CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 247477),
(375756, 'PTHR47982:SF56', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247477),
(375757, 'PTHR47982:SF57', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247477),
(375758, 'PTHR47982:SF13', NULL, NULL, NULL, NULL, 'PTO-INTERACTING PROTEIN 1-LIKE ISOFORM X1', 247477),
(375759, 'PTHR47982:SF10', NULL, NULL, NULL, NULL, 'OS07G0137800 PROTEIN', 247477),
(375760, 'PTHR47982:SF54', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 247477),
(375761, 'PTHR47982:SF11', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247477),
(375762, 'PTHR47982:SF55', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247477),
(375763, 'PTHR47982:SF53', NULL, NULL, NULL, NULL, 'BNACNNG49640D PROTEIN', 247477),
(375764, 'PTHR47982:SF50', NULL, NULL, NULL, NULL, 'OS01G0750600 PROTEIN', 247477),
(375765, 'PTHR47982', NULL, NULL, NULL, NULL, 'PROLINE-RICH RECEPTOR-LIKE PROTEIN KINASE PERK4', 247477),
(375766, 'PTHR47982:SF51', NULL, NULL, NULL, NULL, 'PROLINE-RICH RECEPTOR-LIKE PROTEIN KINASE PERK2', 247477),
(375767, 'PTHR47982:SF18', NULL, NULL, NULL, NULL, 'PROLINE-RICH RECEPTOR-LIKE PROTEIN KINASE PERK7', 247477),
(375768, 'PTHR47982:SF19', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247477),
(375769, 'PTHR47982:SF17', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247477),
(375770, 'PTHR47982:SF25', NULL, NULL, NULL, NULL, 'OS03G0269300 PROTEIN', 247477),
(375771, 'PTHR47982:SF26', NULL, NULL, NULL, NULL, 'PROLINE-RICH RECEPTOR-LIKE PROTEIN KINASE PERK6 ISOFORM X1-RELATED', 247477),
(375772, 'PTHR47982:SF23', NULL, NULL, NULL, NULL, 'PROLINE-RICH RECEPTOR-LIKE PROTEIN KINASE PERK6-RELATED', 247477),
(375773, 'PTHR47982:SF24', NULL, NULL, NULL, NULL, 'KINASE', 247477),
(375774, 'PTHR47982:SF21', NULL, NULL, NULL, NULL, 'PROLINE-RICH RECEPTOR-LIKE PROTEIN KINASE PERK12', 247477),
(375775, 'PTHR47982:SF65', NULL, NULL, NULL, NULL, 'OS10G0104800 PROTEIN', 247477),
(375776, 'PTHR47982:SF22', NULL, NULL, NULL, NULL, 'PROLINE-RICH RECEPTOR-LIKE PROTEIN KINASE PERK14', 247477),
(375777, 'PTHR47982:SF63', NULL, NULL, NULL, NULL, 'OS06G0486000 PROTEIN', 247477),
(375778, 'PTHR47982:SF64', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247477),
(375779, 'PTHR47982:SF20', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 247477),
(375780, 'PTHR47982:SF61', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247477),
(375781, 'PTHR47982:SF60', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247477),
(375782, 'PTHR47982:SF29', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247477),
(375783, 'PTHR47982:SF27', NULL, NULL, NULL, NULL, 'ATP BINDING PROTEIN', 247477),
(375784, 'PTHR47982:SF28', NULL, NULL, NULL, NULL, 'PROLINE-RICH RECEPTOR-LIKE PROTEIN KINASE PERK11-RELATED', 247477),
(375785, 'PTHR47982:SF36', NULL, NULL, NULL, NULL, 'PROLINE-RICH RECEPTOR-LIKE PROTEIN KINASE PERK5', 247477),
(375786, 'PTHR47982:SF37', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247477),
(375787, 'PTHR47982:SF34', NULL, NULL, NULL, NULL, 'INACTIVE PROTEIN KINASE SELMODRAFT_444075-LIKE ISOFORM X1', 247477),
(375788, 'PTHR47982:SF35', NULL, NULL, NULL, NULL, 'PROLINE-RICH RECEPTOR-LIKE PROTEIN KINASE PERK1-RELATED', 247477),
(375789, 'PTHR47982:SF32', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247477),
(375790, 'PTHR47982:SF33', NULL, NULL, NULL, NULL, 'PROLINE-RICH RECEPTOR-LIKE PROTEIN KINASE PERK15', 247477);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(375791, 'PTHR47982:SF31', NULL, NULL, NULL, NULL, 'OS03G0226901 PROTEIN', 247477),
(375792, 'PTHR47982:SF38', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247477),
(375793, 'PTHR47982:SF39', NULL, NULL, NULL, NULL, 'PROLINE-RICH RECEPTOR-LIKE PROTEIN KINASE PERK1', 247477),
(375794, 'PTHR34469', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REACTION CENTER PROTEIN H', 247478),
(375795, 'PTHR34469:SF4', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REACTION CENTER PROTEIN H', 247478),
(375796, 'PTHR34469:SF6', NULL, NULL, NULL, NULL, '', 247478),
(375797, 'PTHR34469:SF7', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II PSBH, PHOSPHOPROTEIN-RELATED', 247478),
(375798, 'PTHR11365:SF9', NULL, NULL, NULL, NULL, '', 247479),
(375799, 'PTHR11365:SF2', NULL, NULL, NULL, NULL, '5-OXOPROLINASE', 247479),
(375800, 'PTHR11365:SF23', NULL, NULL, NULL, NULL, 'HYPOTHETICAL 5-OXOPROLINASE (EUROFUNG)-RELATED', 247479),
(375801, 'PTHR11365', NULL, NULL, NULL, NULL, '5-OXOPROLINASE RELATED', 247479),
(375802, 'PTHR11365:SF10', NULL, NULL, NULL, NULL, 'HYDANTOINASE', 247479),
(375803, 'PTHR11365:SF26', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 247479),
(375804, 'PTHR32409:SF9', NULL, NULL, NULL, NULL, 'BNAA07G08810D PROTEIN', 247480),
(375805, 'PTHR32409:SF10', NULL, NULL, NULL, NULL, 'BNAC03G57640D PROTEIN', 247480),
(375806, 'PTHR32409:SF11', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM20', 247480),
(375807, 'PTHR32409:SF8', NULL, NULL, NULL, NULL, 'TRANSLOCASE OUTER MEMBRANE 20-2-RELATED', 247480),
(375808, 'PTHR32409:SF7', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM20-2', 247480),
(375809, 'PTHR32409:SF13', NULL, NULL, NULL, NULL, 'IMPORT RECEPTOR SUBUNIT TOM20, PUTATIVE-RELATED', 247480),
(375810, 'PTHR32409:SF14', NULL, NULL, NULL, NULL, 'PLANT SPECIFIC MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM20-RELATED', 247480),
(375811, 'PTHR32409', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM20-1-RELATED', 247480),
(375812, 'PTHR32409:SF3', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM20-1-RELATED', 247480),
(375813, 'PTHR47375', NULL, NULL, NULL, NULL, 'GB|AAF34833.1', 247481),
(375814, 'PTHR47375:SF3', NULL, NULL, NULL, NULL, 'BHLH-MYC_N DOMAIN-CONTAINING PROTEIN', 247481),
(375815, 'PTHR47375:SF4', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE WNK (WITH NO LYSINE)-RELATED PROTEIN-RELATED', 247481),
(375816, 'PTHR47375:SF1', NULL, NULL, NULL, NULL, 'GB|AAF34833.1', 247481),
(375817, 'PTHR47375:SF2', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE WNK (WITH NO LYSINE)-LIKE PROTEIN', 247481),
(375818, 'PTHR21707', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247482),
(375819, 'PTHR21707:SF42', NULL, NULL, NULL, NULL, 'FLAGELLUM-ASSOCIATED COILED-COIL DOMAIN-CONTAINING PROTEIN 1', 247482),
(375820, 'PTHR33446:SF12', NULL, NULL, NULL, NULL, 'PROTEIN TONB', 247483),
(375821, 'PTHR33446', NULL, NULL, NULL, NULL, 'PROTEIN TONB-RELATED', 247483),
(375822, 'PTHR33446:SF11', NULL, NULL, NULL, NULL, 'TONB3', 247483),
(375823, 'PTHR33446:SF8', NULL, NULL, NULL, NULL, 'PROTEIN TONB', 247483),
(375824, 'PTHR33446:SF2', NULL, NULL, NULL, NULL, 'PROTEIN TONB', 247483),
(375825, 'PTHR30456', NULL, NULL, NULL, NULL, 'PYRIDOXINE 5''-PHOSPHATE SYNTHASE', 247484),
(375826, 'PTHR30456:SF0', NULL, NULL, NULL, NULL, 'PYRIDOXINE 5''-PHOSPHATE SYNTHASE', 247484),
(375827, 'PTHR46228', NULL, NULL, NULL, NULL, 'KELCH DOMAIN-CONTAINING PROTEIN', 247485),
(375828, 'PTHR46228:SF2', NULL, NULL, NULL, NULL, 'KELCH REPEAT PROTEIN (AFU_ORTHOLOGUE AFUA_4G14350)', 247485),
(375829, 'PTHR46228:SF1', NULL, NULL, NULL, NULL, 'KELCH DOMAIN-CONTAINING PROTEIN 1', 247485),
(375830, 'PTHR46228:SF3', NULL, NULL, NULL, NULL, 'KELCH DOMAIN-CONTAINING PROTEIN 2', 247485),
(375831, 'PTHR23067:SF14', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 247486),
(375832, 'PTHR23067:SF12', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 385D', 247486),
(375833, 'PTHR23067:SF13', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 385A', 247486);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(375834, 'PTHR23067', NULL, NULL, NULL, NULL, 'DOUBLE-STRANDED RNA-BINDING ZINC FINGER PROTEIN', 247486),
(375835, 'PTHR23067:SF6', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 385C', 247486),
(375836, 'PTHR23067:SF8', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 385B', 247486),
(375837, 'PTHR14519', NULL, NULL, NULL, NULL, 'VITAMIN K EPOXIDE REDUCTASE COMPLEX, SUBUNIT 1', 247487),
(375838, 'PTHR14519:SF5', NULL, NULL, NULL, NULL, 'VITAMIN K EPOXIDE REDUCTASE COMPLEX SUBUNIT 1-LIKE PROTEIN 1', 247487),
(375839, 'PTHR14519:SF8', NULL, NULL, NULL, NULL, 'VITAMIN-K-EPOXIDE REDUCTASE (WARFARIN-SENSITIVE)', 247487),
(375840, 'PTHR14519:SF11', NULL, NULL, NULL, NULL, 'VITAMIN K EPOXIDE REDUCTASE COMPLEX SUBUNIT 1', 247487),
(375841, 'PTHR14519:SF0', NULL, NULL, NULL, NULL, 'VITAMIN K EPOXIDE REDUCTASE COMPLEX SUBUNIT 1', 247487),
(375842, 'PTHR16223:SF194', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375843, 'PTHR16223:SF109', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375844, 'PTHR16223:SF347', NULL, NULL, NULL, NULL, 'OS01G0900800 PROTEIN', 247488),
(375845, 'PTHR16223:SF346', NULL, NULL, NULL, NULL, 'OS02G0795800 PROTEIN', 247488),
(375846, 'PTHR16223:SF225', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH80', 247488),
(375847, 'PTHR16223:SF349', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH122-LIKE', 247488),
(375848, 'PTHR16223:SF228', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375849, 'PTHR16223:SF348', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR LRL3', 247488),
(375850, 'PTHR16223:SF343', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375851, 'PTHR16223:SF221', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375852, 'PTHR16223:SF100', NULL, NULL, NULL, NULL, 'OS06G0496400 PROTEIN', 247488),
(375853, 'PTHR16223:SF342', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375854, 'PTHR16223:SF345', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375855, 'PTHR16223:SF344', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375856, 'PTHR16223:SF223', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375857, 'PTHR16223:SF185', NULL, NULL, NULL, NULL, 'OS04G0631600 PROTEIN', 247488),
(375858, 'PTHR16223:SF220', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375859, 'PTHR16223:SF341', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH7', 247488),
(375860, 'PTHR16223:SF340', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR RSL3', 247488),
(375861, 'PTHR16223:SF186', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375862, 'PTHR16223:SF339', NULL, NULL, NULL, NULL, 'OS02G0276900 PROTEIN', 247488),
(375863, 'PTHR16223:SF336', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375864, 'PTHR16223:SF215', NULL, NULL, NULL, NULL, 'OS02G0564700 PROTEIN', 247488),
(375865, 'PTHR16223:SF214', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375866, 'PTHR16223:SF335', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375867, 'PTHR16223:SF338', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR RSL2', 247488),
(375868, 'PTHR16223:SF337', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH85-LIKE', 247488),
(375869, 'PTHR16223:SF299', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375870, 'PTHR16223:SF332', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375871, 'PTHR16223:SF331', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375872, 'PTHR16223:SF177', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH129', 247488),
(375873, 'PTHR16223:SF298', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH69', 247488),
(375874, 'PTHR16223:SF334', NULL, NULL, NULL, NULL, 'HELIX-LOOP-HELIX DNA-BINDING DOMAIN CONTAINING PROTEIN', 247488),
(375875, 'PTHR16223:SF333', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH139', 247488),
(375876, 'PTHR16223:SF295', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE, EXPRESSED-RELATED', 247488);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(375877, 'PTHR16223:SF330', NULL, NULL, NULL, NULL, 'OS03G0205300 PROTEIN', 247488),
(375878, 'PTHR16223:SF247', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH FAMILY-RELATED', 247488),
(375879, 'PTHR16223:SF249', NULL, NULL, NULL, NULL, 'BASIC HELIX-LOOP-HELIX (BHLH) DNA-BINDING SUPERFAMILY PROTEIN-RELATED', 247488),
(375880, 'PTHR16223:SF122', NULL, NULL, NULL, NULL, 'OS06G0210600 PROTEIN', 247488),
(375881, 'PTHR16223:SF56', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH110', 247488),
(375882, 'PTHR16223:SF125', NULL, NULL, NULL, NULL, 'OS09G0487900 PROTEIN', 247488),
(375883, 'PTHR16223:SF51', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH117-RELATED', 247488),
(375884, 'PTHR16223:SF242', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375885, 'PTHR16223:SF241', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375886, 'PTHR16223:SF53', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375887, 'PTHR16223:SF237', NULL, NULL, NULL, NULL, 'OS04G0493100 PROTEIN', 247488),
(375888, 'PTHR16223:SF357', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH133', 247488),
(375889, 'PTHR16223:SF238', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH114', 247488),
(375890, 'PTHR16223:SF354', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375891, 'PTHR16223:SF353', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR RHD6-RELATED', 247488),
(375892, 'PTHR16223:SF235', NULL, NULL, NULL, NULL, 'OS01G0230200 PROTEIN', 247488),
(375893, 'PTHR16223:SF356', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH66', 247488),
(375894, 'PTHR16223:SF355', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375895, 'PTHR16223:SF196', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375896, 'PTHR16223:SF350', NULL, NULL, NULL, NULL, 'OS07G0471900 PROTEIN', 247488),
(375897, 'PTHR16223:SF195', NULL, NULL, NULL, NULL, 'HLH DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 247488),
(375898, 'PTHR16223:SF62', NULL, NULL, NULL, NULL, 'OS06G0193400 PROTEIN', 247488),
(375899, 'PTHR16223:SF352', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH103', 247488),
(375900, 'PTHR16223:SF198', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375901, 'PTHR16223:SF351', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH130', 247488),
(375902, 'PTHR16223:SF197', NULL, NULL, NULL, NULL, 'OS11G0634700 PROTEIN', 247488),
(375903, 'PTHR16223:SF271', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375904, 'PTHR16223:SF149', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375905, 'PTHR16223:SF303', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375906, 'PTHR16223:SF302', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN-CONTAINING PROTEIN-RELATED', 247488),
(375907, 'PTHR16223:SF305', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375908, 'PTHR16223:SF266', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375909, 'PTHR16223:SF268', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS- AND OOGENESIS-SPECIFIC BASIC HELIX-LOOP-HELIX-CONTAINING PROTEIN 2', 247488),
(375910, 'PTHR16223:SF300', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH133', 247488),
(375911, 'PTHR16223:SF262', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375912, 'PTHR16223:SF264', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375913, 'PTHR16223:SF260', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375914, 'PTHR16223:SF49', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH52-RELATED', 247488),
(375915, 'PTHR16223:SF138', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375916, 'PTHR16223:SF139', NULL, NULL, NULL, NULL, 'HLH DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 247488),
(375917, 'PTHR16223:SF136', NULL, NULL, NULL, NULL, 'OS05G0228400 PROTEIN', 247488),
(375918, 'PTHR16223:SF46', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH123', 247488);
INSERT INTO "PUBLIC"."MODEL" VALUES
(375919, 'PTHR16223:SF256', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375920, 'PTHR16223:SF172', NULL, NULL, NULL, NULL, 'OS02G0710300 PROTEIN', 247488),
(375921, 'PTHR16223:SF171', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH111', 247488),
(375922, 'PTHR16223:SF9', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTION FACTOR', 247488),
(375923, 'PTHR16223:SF329', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH130-LIKE ISOFORM X1', 247488),
(375924, 'PTHR16223:SF328', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH68-LIKE', 247488),
(375925, 'PTHR16223:SF207', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375926, 'PTHR16223:SF325', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH128', 247488),
(375927, 'PTHR16223:SF204', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH153', 247488),
(375928, 'PTHR16223:SF324', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375929, 'PTHR16223:SF327', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR LRL1', 247488),
(375930, 'PTHR16223:SF205', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN-CONTAINING PROTEIN-RELATED', 247488),
(375931, 'PTHR16223:SF326', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375932, 'PTHR16223:SF321', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH133-RELATED', 247488),
(375933, 'PTHR16223:SF288', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH112', 247488),
(375934, 'PTHR16223:SF200', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR UNE12', 247488),
(375935, 'PTHR16223:SF320', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH84-LIKE', 247488),
(375936, 'PTHR16223:SF166', NULL, NULL, NULL, NULL, '', 247488),
(375937, 'PTHR16223:SF287', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH113', 247488),
(375938, 'PTHR16223:SF323', NULL, NULL, NULL, NULL, 'OS07G0588400 PROTEIN', 247488),
(375939, 'PTHR16223:SF202', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375940, 'PTHR16223:SF322', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR RSL2-LIKE', 247488),
(375941, 'PTHR16223:SF163', NULL, NULL, NULL, NULL, 'ELKS/RAB6-INTERACTING/CAST FAMILY PROTEIN', 247488),
(375942, 'PTHR16223:SF284', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375943, 'PTHR16223:SF162', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375944, 'PTHR16223:SF283', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375945, 'PTHR16223:SF286', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375946, 'PTHR16223', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH83-RELATED', 247488),
(375947, 'PTHR16223:SF318', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR UNE12-LIKE ISOFORM X1', 247488),
(375948, 'PTHR16223:SF317', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH139-LIKE', 247488),
(375949, 'PTHR16223:SF319', NULL, NULL, NULL, NULL, '', 247488),
(375950, 'PTHR16223:SF316', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247488),
(375951, 'PTHR16223:SF315', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH122-LIKE', 247488),
(375952, 'PTHR16223:SF156', NULL, NULL, NULL, NULL, 'CUE DOMAIN-CONTAINING PROTEIN', 247488),
(375953, 'PTHR16223:SF279', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH122', 247488),
(375954, 'PTHR16223:SF278', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN-CONTAINING PROTEIN-RELATED', 247488),
(375955, 'PTHR16223:SF272', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH110-LIKE', 247488),
(375956, 'PTHR16223:SF151', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH128', 247488),
(375957, 'PTHR16223:SF274', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH84', 247488),
(375958, 'PTHR31137:SF29', NULL, NULL, NULL, NULL, 'PROTEIN PSIK-RELATED', 247489),
(375959, 'PTHR31137:SF28', NULL, NULL, NULL, NULL, 'PROTEIN PSIA-RELATED', 247489),
(375960, 'PTHR31137:SF3', NULL, NULL, NULL, NULL, 'PROTEIN PSIN', 247489),
(375961, 'PTHR31137:SF2', NULL, NULL, NULL, NULL, 'PROTEIN PSIG', 247489),
(375962, 'PTHR31137:SF32', NULL, NULL, NULL, NULL, '', 247489);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(375963, 'PTHR31137:SF31', NULL, NULL, NULL, NULL, 'PROTEIN PSIH-RELATED', 247489),
(375964, 'PTHR31137:SF12', NULL, NULL, NULL, NULL, 'PROTEIN PSIJ', 247489),
(375965, 'PTHR31137:SF11', NULL, NULL, NULL, NULL, 'PROTEIN PSIF', 247489),
(375966, 'PTHR31137:SF13', NULL, NULL, NULL, NULL, 'PROTEIN PSID', 247489),
(375967, 'PTHR31137', NULL, NULL, NULL, NULL, 'PROTEIN PSIB-RELATED-RELATED', 247489),
(375968, 'PTHR31137:SF6', NULL, NULL, NULL, NULL, 'PROTEIN PSIC', 247489),
(375969, 'PTHR31137:SF5', NULL, NULL, NULL, NULL, 'PA14 DOMAIN-CONTAINING PROTEIN-RELATED', 247489),
(375970, 'PTHR31137:SF4', NULL, NULL, NULL, NULL, '', 247489),
(375971, 'PTHR31137:SF9', NULL, NULL, NULL, NULL, 'PA14 DOMAIN-CONTAINING PROTEIN', 247489),
(375972, 'PTHR31137:SF8', NULL, NULL, NULL, NULL, 'PROTEIN PSIB-RELATED', 247489),
(375973, 'PTHR43411:SF6', NULL, NULL, NULL, NULL, 'ADENYLOSUCCINATE LYASE', 247490),
(375974, 'PTHR43411:SF1', NULL, NULL, NULL, NULL, 'ADENYLOSUCCINATE LYASE', 247490),
(375975, 'PTHR43411', NULL, NULL, NULL, NULL, 'ADENYLOSUCCINATE LYASE', 247490),
(375976, 'PTHR12726', NULL, NULL, NULL, NULL, 'CERAMIDE GLUCOSYLTRANSFERASE', 247491),
(375977, 'PTHR12726:SF6', NULL, NULL, NULL, NULL, 'CERAMIDE GLUCOSYLTRANSFERASE', 247491),
(375978, 'PTHR12726:SF4', NULL, NULL, NULL, NULL, 'CERAMIDE GLUCOSYLTRANSFERASE', 247491),
(375979, 'PTHR12726:SF1', NULL, NULL, NULL, NULL, 'CERAMIDE GLUCOSYLTRANSFERASE 1-RELATED', 247491),
(375980, 'PTHR12726:SF2', NULL, NULL, NULL, NULL, 'CERAMIDE GLUCOSYLTRANSFERASE', 247491),
(375981, 'PTHR12726:SF0', NULL, NULL, NULL, NULL, 'CERAMIDE GLUCOSYLTRANSFERASE', 247491),
(375982, 'PTHR20922:SF15', NULL, NULL, NULL, NULL, 'A_TM021B04.14 PROTEIN', 247492),
(375983, 'PTHR20922:SF13', NULL, NULL, NULL, NULL, 'DNL-TYPE ZINC FINGER PROTEIN', 247492),
(375984, 'PTHR20922:SF22', NULL, NULL, NULL, NULL, 'DNL-TYPE DOMAIN-CONTAINING PROTEIN', 247492),
(375985, 'PTHR20922', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247492),
(375986, 'PTHR20922:SF19', NULL, NULL, NULL, NULL, 'F24J5.3', 247492),
(375987, 'PTHR13454:SF11', NULL, NULL, NULL, NULL, 'PROTEIN MCM10 HOMOLOG', 247493),
(375988, 'PTHR13454', NULL, NULL, NULL, NULL, 'PROTEIN MCM10 HOMOLOG', 247493),
(375989, 'PTHR24231:SF48', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 247494),
(375990, 'PTHR24231:SF15', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE RECEPTOR 1', 247494),
(375991, 'PTHR24231:SF47', NULL, NULL, NULL, NULL, 'SI:DKEY-216E24.9', 247494),
(375992, 'PTHR24231:SF25', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 247494),
(375993, 'PTHR24231:SF14', NULL, NULL, NULL, NULL, 'SUCCINATE RECEPTOR 1', 247494),
(375994, 'PTHR24231:SF17', NULL, NULL, NULL, NULL, 'P2Y PURINOCEPTOR 2', 247494),
(375995, 'PTHR24231:SF16', NULL, NULL, NULL, NULL, 'P2Y PURINOCEPTOR 6', 247494),
(375996, 'PTHR24231:SF49', NULL, NULL, NULL, NULL, 'LYSOPHOSPHATIDIC ACID RECEPTOR 6-LIKE', 247494),
(375997, 'PTHR24231:SF38', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 247494),
(375998, 'PTHR24231', NULL, NULL, NULL, NULL, 'PURINOCEPTOR-RELATED G-PROTEIN COUPLED RECEPTOR', 247494),
(375999, 'PTHR24231:SF50', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 247494),
(376000, 'PTHR24231:SF2', NULL, NULL, NULL, NULL, 'P2Y PURINOCEPTOR 1', 247494),
(376001, 'PTHR24231:SF21', NULL, NULL, NULL, NULL, 'P2Y PURINOCEPTOR 4', 247494),
(376002, 'PTHR24231:SF46', NULL, NULL, NULL, NULL, 'P2Y PURINOCEPTOR 11', 247494),
(376003, 'PTHR24231:SF35', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 247494),
(376004, 'PTHR24231:SF45', NULL, NULL, NULL, NULL, 'CYSTEINYL LEUKOTRIENE RECEPTOR 1', 247494),
(376005, 'PTHR36778:SF1', NULL, NULL, NULL, NULL, 'CADMIUM-INDUCED PROTEIN AS8', 247495),
(376006, 'PTHR36778', NULL, NULL, NULL, NULL, 'CADMIUM-INDUCED PROTEIN AS8', 247495),
(376007, 'PTHR24339', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN EMX-RELATED', 247496),
(376008, 'PTHR24339:SF60', NULL, NULL, NULL, NULL, 'VENTRAL ANTERIOR HOMEOBOX', 247496);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(376009, 'PTHR24339:SF26', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN EMX1', 247496),
(376010, 'PTHR24339:SF37', NULL, NULL, NULL, NULL, 'E5', 247496),
(376011, 'PTHR24339:SF29', NULL, NULL, NULL, NULL, 'GS HOMEOBOX 1', 247496),
(376012, 'PTHR24339:SF28', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN NOTOCHORD', 247496),
(376013, 'PTHR24339:SF30', NULL, NULL, NULL, NULL, 'LATERAL MUSCLES SCARCER, ISOFORM B', 247496),
(376014, 'PTHR24339:SF32', NULL, NULL, NULL, NULL, 'VENTRAL ANTERIOR HOMEOBOX 1', 247496),
(376015, 'PTHR24339:SF65', NULL, NULL, NULL, NULL, '', 247496),
(376016, 'PTHR24339:SF64', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 247496),
(376017, 'PTHR24339:SF34', NULL, NULL, NULL, NULL, 'VENTRAL ANTERIOR HOMEOBOX 2', 247496),
(376018, 'PTHR24339:SF66', NULL, NULL, NULL, NULL, 'SIMILAR TO OOCYTE-SPECIFIC HOMEOBOX 3', 247496),
(376019, 'PTHR24339:SF25', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN EMX2', 247496),
(376020, 'PTHR38052', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247497),
(376021, 'PTHR38052:SF1', NULL, NULL, NULL, NULL, 'ABM DOMAIN-CONTAINING PROTEIN', 247497),
(376022, 'PTHR47839', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G04830)-RELATED', 247498),
(376023, 'PTHR47839:SF1', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G04830)-RELATED', 247498),
(376024, 'PTHR37416:SF1', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247499),
(376025, 'PTHR37416', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247499),
(376026, 'PTHR43895:SF6', NULL, NULL, NULL, NULL, 'CBL-INTERACTING PROTEIN KINASE 19', 247500),
(376027, 'PTHR43895:SF7', NULL, NULL, NULL, NULL, 'CBL-INTERACTING PROTEIN KINASE 30', 247500),
(376028, 'PTHR43895:SF139', NULL, NULL, NULL, NULL, 'CBL-INTERACTING PROTEIN KINASE 5', 247500),
(376029, 'PTHR43895:SF136', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376030, 'PTHR43895:SF4', NULL, NULL, NULL, NULL, 'CBL-INTERACTING PROTEIN KINASE 25', 247500),
(376031, 'PTHR43895:SF28', NULL, NULL, NULL, NULL, 'CBL-INTERACTING SERINE/THREONINE-PROTEIN KINASE 15', 247500),
(376032, 'PTHR43895:SF3', NULL, NULL, NULL, NULL, 'CBL-INTERACTING SERINE/THREONINE-PROTEIN KINASE 20', 247500),
(376033, 'PTHR43895:SF27', NULL, NULL, NULL, NULL, 'CBL-INTERACTING PROTEIN KINASE 10', 247500),
(376034, 'PTHR43895:SF133', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376035, 'PTHR43895:SF26', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247500),
(376036, 'PTHR43895:SF25', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE STK11', 247500),
(376037, 'PTHR43895:SF69', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376038, 'PTHR43895:SF130', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376039, 'PTHR43895:SF68', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376040, 'PTHR43895:SF65', NULL, NULL, NULL, NULL, 'CBL-INTERACTING PROTEIN KINASE 21', 247500),
(376041, 'PTHR43895:SF21', NULL, NULL, NULL, NULL, 'CBL-INTERACTING PROTEIN KINASE 28', 247500),
(376042, 'PTHR43895:SF62', NULL, NULL, NULL, NULL, 'CBL-INTERACTING SERINE/THREONINE-PROTEIN KINASE 18', 247500),
(376043, 'PTHR43895:SF60', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376044, 'PTHR43895:SF109', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376045, 'PTHR43895:SF108', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247500),
(376046, 'PTHR43895:SF105', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376047, 'PTHR43895:SF149', NULL, NULL, NULL, NULL, 'CBL-INTERACTING PROTEIN KINASE 6', 247500),
(376048, 'PTHR43895:SF147', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376049, 'PTHR43895:SF148', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376050, 'PTHR43895:SF104', NULL, NULL, NULL, NULL, 'CBL-INTERACTING SERINE/THREONINE-PROTEIN KINASE 3', 247500);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(376051, 'PTHR43895:SF101', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376052, 'PTHR43895:SF145', NULL, NULL, NULL, NULL, 'CBL-INTERACTING SERINE/THREONINE-PROTEIN KINASE 9', 247500),
(376053, 'PTHR43895:SF39', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-DEPENDENT PROTEIN KINASE KINASE 2', 247500),
(376054, 'PTHR43895:SF102', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376055, 'PTHR43895:SF146', NULL, NULL, NULL, NULL, 'CBL-INTERACTING SERINE/THREONINE-PROTEIN KINASE 5', 247500),
(376056, 'PTHR43895:SF143', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376057, 'PTHR43895:SF144', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376058, 'PTHR43895:SF100', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376059, 'PTHR43895:SF141', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376060, 'PTHR43895:SF79', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376061, 'PTHR43895:SF142', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376062, 'PTHR43895:SF78', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376063, 'PTHR43895:SF140', NULL, NULL, NULL, NULL, 'CBL-INTERACTING SERINE/THREONINE-PROTEIN KINASE 12', 247500),
(376064, 'PTHR43895:SF33', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376065, 'PTHR43895:SF32', NULL, NULL, NULL, NULL, 'CBL-INTERACTING SERINE/THREONINE-PROTEIN KINASE 25', 247500),
(376066, 'PTHR43895:SF76', NULL, NULL, NULL, NULL, 'CBL-INTERACTING SERINE/THREONINE-PROTEIN KINASE 19', 247500),
(376067, 'PTHR43895:SF74', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247500),
(376068, 'PTHR43895:SF30', NULL, NULL, NULL, NULL, 'CBL-INTERACTING PROTEIN KINASE 11', 247500),
(376069, 'PTHR43895:SF72', NULL, NULL, NULL, NULL, 'CBL-INTERACTING SERINE/THREONINE-PROTEIN KINASE 13', 247500),
(376070, 'PTHR43895:SF92', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247500),
(376071, 'PTHR43895:SF91', NULL, NULL, NULL, NULL, 'CBL-INTERACTING SERINE/THREONINE-PROTEIN KINASE 6', 247500),
(376072, 'PTHR43895', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-DEPENDENT PROTEIN KINASE KINASE-RELATED', 247500),
(376073, 'PTHR43895:SF117', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376074, 'PTHR43895:SF158', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376075, 'PTHR43895:SF114', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376076, 'PTHR43895:SF156', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376077, 'PTHR43895:SF112', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376078, 'PTHR43895:SF157', NULL, NULL, NULL, NULL, 'CBL-INTERACTING SERINE/THREONINE-PROTEIN KINASE 16', 247500),
(376079, 'PTHR43895:SF154', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376080, 'PTHR43895:SF111', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376081, 'PTHR43895:SF155', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE CHK1', 247500),
(376082, 'PTHR43895:SF47', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376083, 'PTHR43895:SF152', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE TOS3', 247500),
(376084, 'PTHR43895:SF46', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376085, 'PTHR43895:SF153', NULL, NULL, NULL, NULL, 'KINASE', 247500),
(376086, 'PTHR43895:SF89', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376087, 'PTHR43895:SF150', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-DEPENDENT PROTEIN KINASE KINASE', 247500),
(376088, 'PTHR43895:SF88', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(376089, 'PTHR43895:SF151', NULL, NULL, NULL, NULL, 'CBL-INTERACTING SERINE/THREONINE-PROTEIN KINASE 11', 247500),
(376090, 'PTHR43895:SF87', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376091, 'PTHR43895:SF86', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376092, 'PTHR43895:SF42', NULL, NULL, NULL, NULL, 'CBL-INTERACTING SERINE/THREONINE-PROTEIN KINASE 10', 247500),
(376093, 'PTHR43895:SF84', NULL, NULL, NULL, NULL, 'CBL-INTERACTING PROTEIN KINASE 15', 247500),
(376094, 'PTHR43895:SF82', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376095, 'PTHR43895:SF127', NULL, NULL, NULL, NULL, 'CBL-INTERACTING PROTEIN KINASE 22', 247500),
(376096, 'PTHR43895:SF128', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376097, 'PTHR43895:SF126', NULL, NULL, NULL, NULL, 'CBL-INTERACTING PROTEIN KINASE 2', 247500),
(376098, 'PTHR43895:SF123', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE OSK3', 247500),
(376099, 'PTHR43895:SF17', NULL, NULL, NULL, NULL, 'CBL-INTERACTING PROTEIN KINASE 13-RELATED', 247500),
(376100, 'PTHR43895:SF121', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376101, 'PTHR43895:SF122', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376102, 'PTHR43895:SF57', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376103, 'PTHR43895:SF120', NULL, NULL, NULL, NULL, 'CBL-INTERACTING SERINE/THREONINE-PROTEIN KINASE 2', 247500),
(376104, 'PTHR43895:SF56', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376105, 'PTHR43895:SF99', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376106, 'PTHR43895:SF55', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376107, 'PTHR43895:SF98', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376108, 'PTHR43895:SF53', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376109, 'PTHR43895:SF96', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376110, 'PTHR43895:SF94', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247500),
(376111, 'PTHR43895:SF93', NULL, NULL, NULL, NULL, 'CBL-INTERACTING SERINE/THREONINE-PROTEIN KINASE 22', 247500),
(376112, 'PTHR23404', NULL, NULL, NULL, NULL, 'MOLYBDOPTERIN SYNTHASE RELATED', 247501),
(376113, 'PTHR23404:SF3', NULL, NULL, NULL, NULL, 'MAP3K12-BINDING INHIBITORY PROTEIN 1', 247501),
(376114, 'PTHR23404:SF2', NULL, NULL, NULL, NULL, 'MOLYBDOPTERIN SYNTHASE CATALYTIC SUBUNIT', 247501),
(376115, 'PTHR23404:SF11', NULL, NULL, NULL, NULL, 'MOLYBDOPTERIN SYNTHASE CATALYTIC SUBUNIT', 247501),
(376116, 'PTHR12157:SF18', NULL, NULL, NULL, NULL, 'REGULATING SYNAPTIC MEMBRANE EXOCYTOSIS PROTEIN 1', 247502),
(376117, 'PTHR12157:SF17', NULL, NULL, NULL, NULL, 'REGULATING SYNAPTIC MEMBRANE EXOCYTOSIS PROTEIN 4', 247502),
(376118, 'PTHR12157', NULL, NULL, NULL, NULL, 'REGULATING SYNAPTIC MEMBRANE EXOCYTOSIS PROTEIN', 247502),
(376119, 'PTHR12157:SF15', NULL, NULL, NULL, NULL, 'REGULATING SYNAPTIC MEMBRANE EXOCYTOSIS PROTEIN 2', 247502),
(376120, 'PTHR12157:SF25', NULL, NULL, NULL, NULL, 'REGULATING SYNAPTIC MEMBRANE EXOCYTOSIS PROTEIN 3', 247502),
(376121, 'PTHR12157:SF24', NULL, NULL, NULL, NULL, 'FIFE, ISOFORM D', 247502),
(376122, 'PTHR12157:SF21', NULL, NULL, NULL, NULL, 'RAB3 INTERACTING MOLECULE, ISOFORM F', 247502),
(376123, 'PTHR31656:SF16', NULL, NULL, NULL, NULL, 'OS01G0968300 PROTEIN', 247503),
(376124, 'PTHR31656:SF59', NULL, NULL, NULL, NULL, '', 247503),
(376125, 'PTHR31656:SF37', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) PROTEIN-LIKE PROTEIN', 247503),
(376126, 'PTHR31656:SF36', NULL, NULL, NULL, NULL, '', 247503),
(376127, 'PTHR31656:SF35', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN-RELATED / LEA PROTEIN-RELATED', 247503),
(376128, 'PTHR31656:SF57', NULL, NULL, NULL, NULL, 'ROOT CAP/LATE EMBRYOGENESIS-LIKE PROTEIN', 247503);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(376129, 'PTHR31656:SF34', NULL, NULL, NULL, NULL, 'EMBRYOGENESIS ABUNDANT PROTEIN-RELATED / LEA PROTEIN-RELATED, PUTATIVE-RELATED', 247503),
(376130, 'PTHR31656:SF54', NULL, NULL, NULL, NULL, '', 247503),
(376131, 'PTHR31656:SF31', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN-RELATED / LEA PROTEIN-RELATED', 247503),
(376132, 'PTHR31656:SF0', NULL, NULL, NULL, NULL, 'ROOT CAP DOMAIN-CONTAINING PROTEIN', 247503),
(376133, 'PTHR31656:SF1', NULL, NULL, NULL, NULL, 'OS01G0968400 PROTEIN', 247503),
(376134, 'PTHR31656:SF19', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN-RELATED / LEA PROTEIN-RELATED', 247503),
(376135, 'PTHR31656:SF8', NULL, NULL, NULL, NULL, 'CONSTITUENT OF CELL WALL, PUTATIVE-RELATED', 247503),
(376136, 'PTHR31656:SF9', NULL, NULL, NULL, NULL, 'CONSTITUENT OF CELL WALL, PUTATIVE-RELATED', 247503),
(376137, 'PTHR31656:SF6', NULL, NULL, NULL, NULL, 'OS04G0410400 PROTEIN', 247503),
(376138, 'PTHR31656:SF63', NULL, NULL, NULL, NULL, 'ROOT CAP-RELATED', 247503),
(376139, 'PTHR31656:SF62', NULL, NULL, NULL, NULL, 'OS05G0552600 PROTEIN', 247503),
(376140, 'PTHR31656:SF61', NULL, NULL, NULL, NULL, 'BNAA01G26120D PROTEIN', 247503),
(376141, 'PTHR31656:SF60', NULL, NULL, NULL, NULL, 'STRUCTURAL CONSTITUENT OF CELL WALL', 247503),
(376142, 'PTHR31656:SF49', NULL, NULL, NULL, NULL, 'STRUCTURAL CONSTITUENT OF CELL WALL', 247503),
(376143, 'PTHR31656:SF48', NULL, NULL, NULL, NULL, 'BNACNNG43430D PROTEIN', 247503),
(376144, 'PTHR31656:SF26', NULL, NULL, NULL, NULL, '', 247503),
(376145, 'PTHR31656:SF25', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN-RELATED / LEA PROTEIN-RELATED', 247503),
(376146, 'PTHR31656:SF46', NULL, NULL, NULL, NULL, 'ROOT CAP-RELATED', 247503),
(376147, 'PTHR31656:SF24', NULL, NULL, NULL, NULL, 'ROOT-CAP PERIPHERY1', 247503),
(376148, 'PTHR31656:SF23', NULL, NULL, NULL, NULL, '', 247503),
(376149, 'PTHR31656:SF22', NULL, NULL, NULL, NULL, '', 247503),
(376150, 'PTHR31656:SF44', NULL, NULL, NULL, NULL, 'BNAA08G14110D PROTEIN', 247503),
(376151, 'PTHR31656:SF65', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN-RELATED / LEA PROTEIN-LIKE PROTEIN', 247503),
(376152, 'PTHR31656:SF20', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) PROTEIN-LIKE PROTEIN', 247503),
(376153, 'PTHR31656:SF42', NULL, NULL, NULL, NULL, 'BNAC03G14620D PROTEIN', 247503),
(376154, 'PTHR31656:SF64', NULL, NULL, NULL, NULL, 'STRUCTURAL CONSTITUENT OF CELL WALL', 247503),
(376155, 'PTHR31656:SF29', NULL, NULL, NULL, NULL, 'ROOT CAP FAMILY PROTEIN-RELATED', 247503),
(376156, 'PTHR31656:SF28', NULL, NULL, NULL, NULL, '', 247503),
(376157, 'PTHR31656', NULL, NULL, NULL, NULL, 'ROOT CAP DOMAIN-CONTAINING PROTEIN', 247503),
(376158, 'PTHR31656:SF30', NULL, NULL, NULL, NULL, '', 247503),
(376159, 'PTHR31656:SF51', NULL, NULL, NULL, NULL, 'STRUCTURAL CONSTITUENT OF CELL WALL', 247503),
(376160, 'PTHR31656:SF50', NULL, NULL, NULL, NULL, 'BNAA10G13310D PROTEIN', 247503),
(376161, 'PTHR38031:SF1', NULL, NULL, NULL, NULL, 'SULFUR CARRIER PROTEIN CYSO', 247504),
(376162, 'PTHR38031', NULL, NULL, NULL, NULL, 'SULFUR CARRIER PROTEIN SLR0821-RELATED', 247504),
(376163, 'PTHR21367:SF1', NULL, NULL, NULL, NULL, 'ARGINYL-TRNA--PROTEIN TRANSFERASE 1', 247505),
(376164, 'PTHR21367:SF4', NULL, NULL, NULL, NULL, 'ARGINYL-TRNA--PROTEIN TRANSFERASE 1', 247505),
(376165, 'PTHR21367', NULL, NULL, NULL, NULL, 'ARGININE-TRNA-PROTEIN TRANSFERASE 1', 247505),
(376166, 'PTHR47598:SF2', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP17-3, CHLOROPLASTIC', 247506),
(376167, 'PTHR47598', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP17-2, CHLOROPLASTIC', 247506),
(376168, 'PTHR47598:SF1', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP17-2, CHLOROPLASTIC', 247506),
(376169, 'PTHR30100:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATE ACYLTRANSFERASE', 247507),
(376170, 'PTHR30100', NULL, NULL, NULL, NULL, 'FATTY ACID/PHOSPHOLIPID SYNTHESIS PROTEIN PLSX', 247507),
(376171, 'PTHR22380', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 15', 247508);
INSERT INTO "PUBLIC"."MODEL" VALUES
(376172, 'PTHR22380:SF1', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 15', 247508),
(376173, 'PTHR43229:SF2', NULL, NULL, NULL, NULL, 'NODULATION PROTEIN J', 247509),
(376174, 'PTHR43229:SF3', NULL, NULL, NULL, NULL, 'ABC-TYPE MULTIDRUG TRANSPORT SYSTEM, PERMEASE COMPONENT', 247509),
(376175, 'PTHR43229', NULL, NULL, NULL, NULL, 'NODULATION PROTEIN J', 247509),
(376176, 'PTHR43229:SF6', NULL, NULL, NULL, NULL, 'ABC-TYPE MULTIDRUG TRANSPORT SYSTEM, PERMEASE COMPONENT', 247509),
(376177, 'PTHR34954:SF4', NULL, NULL, NULL, NULL, 'PROTEIN TRIGALACTOSYLDIACYLGLYCEROL 4, CHLOROPLASTIC', 247510),
(376178, 'PTHR34954', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247510),
(376179, 'PTHR34954:SF3', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247510),
(376180, 'PTHR43105', NULL, NULL, NULL, NULL, 'RESPIRATORY NITRATE REDUCTASE', 247511),
(376181, 'PTHR43105:SF9', NULL, NULL, NULL, NULL, 'NITRATE REDUCTASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G15190)-RELATED', 247511),
(376182, 'PTHR43105:SF8', NULL, NULL, NULL, NULL, 'RESPIRATORY NITRATE REDUCTASE 1 ALPHA CHAIN', 247511),
(376183, 'PTHR43105:SF4', NULL, NULL, NULL, NULL, 'PROTEIN YDEP', 247511),
(376184, 'PTHR43105:SF13', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE 75 KDA SUBUNIT, MITOCHONDRIAL', 247511),
(376185, 'PTHR43105:SF2', NULL, NULL, NULL, NULL, 'RESPIRATORY NITRATE REDUCTASE 2 ALPHA CHAIN', 247511),
(376186, 'PTHR43105:SF12', NULL, NULL, NULL, NULL, 'NADH-QUINONE OXIDOREDUCTASE SUBUNIT G', 247511),
(376187, 'PTHR43105:SF11', NULL, NULL, NULL, NULL, 'PERIPLASMIC NITRATE REDUCTASE', 247511),
(376188, 'PTHR43105:SF10', NULL, NULL, NULL, NULL, 'NADH-QUINONE OXIDOREDUCTASE SUBUNIT G', 247511),
(376189, 'PTHR34376:SF10', NULL, NULL, NULL, NULL, 'SERINE-TYPE ENDOPEPTIDASE INHIBITOR', 247512),
(376190, 'PTHR34376:SF11', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR, KAZAL-TYPE FAMILY PROTEIN', 247512),
(376191, 'PTHR34376:SF2', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR, KAZAL-TYPE FAMILY PROTEIN', 247512),
(376192, 'PTHR34376', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR, KAZAL-TYPE FAMILY PROTEIN', 247512),
(376193, 'PTHR34376:SF4', NULL, NULL, NULL, NULL, '', 247512),
(376194, 'PTHR34376:SF6', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR, KAZAL-TYPE FAMILY PROTEIN', 247512),
(376195, 'PTHR34376:SF7', NULL, NULL, NULL, NULL, 'KAZAL-LIKE DOMAIN-CONTAINING PROTEIN', 247512),
(376196, 'PTHR34376:SF8', NULL, NULL, NULL, NULL, 'ENDOPEPTIDASE INHIBITOR, PUTATIVE-RELATED', 247512),
(376197, 'PTHR34376:SF9', NULL, NULL, NULL, NULL, 'SERINE-TYPE ENDOPEPTIDASE INHIBITOR', 247512),
(376198, 'PTHR15953:SF0', NULL, NULL, NULL, NULL, 'APELIN', 247513),
(376199, 'PTHR15953', NULL, NULL, NULL, NULL, 'APELIN', 247513),
(376200, 'PTHR19848:SF0', NULL, NULL, NULL, NULL, 'NOTCHLESS PROTEIN HOMOLOG 1', 247514),
(376201, 'PTHR19848:SF6', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRAF7', 247514),
(376202, 'PTHR19848', NULL, NULL, NULL, NULL, 'WD40 REPEAT PROTEIN', 247514),
(376203, 'PTHR19848:SF9', NULL, NULL, NULL, NULL, '', 247514),
(376204, 'PTHR19848:SF7', NULL, NULL, NULL, NULL, 'F-BOX AND WD-40 DOMAIN PROTEIN 7', 247514),
(376205, 'PTHR19848:SF8', NULL, NULL, NULL, NULL, 'F-BOX/WD REPEAT-CONTAINING PROTEIN SEL-10', 247514),
(376206, 'PTHR45945:SF1', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING 12', 247515),
(376207, 'PTHR45945', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING LOCO', 247515),
(376208, 'PTHR45945:SF3', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING LOCO', 247515),
(376209, 'PTHR45945:SF2', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING 14', 247515),
(376210, 'PTHR37350:SF1', NULL, NULL, NULL, NULL, 'PROTEIN GAPT', 247516),
(376211, 'PTHR37350', NULL, NULL, NULL, NULL, 'PROTEIN GAPT', 247516),
(376212, 'PTHR46015:SF1', NULL, NULL, NULL, NULL, 'ZGC:172121', 247517),
(376213, 'PTHR46015:SF4', NULL, NULL, NULL, NULL, 'S-METHYLTRANSFERASE 2, PUTATIVE, EXPRESSED-RELATED', 247517),
(376214, 'PTHR46015:SF6', NULL, NULL, NULL, NULL, 'OS01G0772900 PROTEIN', 247517);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(376215, 'PTHR46015:SF5', NULL, NULL, NULL, NULL, 'HOMOCYSTEINE S-METHYLTRANSFERASE 2', 247517),
(376216, 'PTHR46015:SF8', NULL, NULL, NULL, NULL, 'HOMOCYSTEINE S-METHYLTRANSFERASE 2-LIKE ISOFORM X1', 247517),
(376217, 'PTHR46015:SF7', NULL, NULL, NULL, NULL, 'HOMOCYSTEINE S-METHYLTRANSFERASE 1', 247517),
(376218, 'PTHR46015:SF9', NULL, NULL, NULL, NULL, 'HOMOCYSTEINE METHYLTRANSFERASE 2-RELATED', 247517),
(376219, 'PTHR46015', NULL, NULL, NULL, NULL, 'ZGC:172121', 247517),
(376220, 'PTHR34935:SF2', NULL, NULL, NULL, NULL, '', 247518),
(376221, 'PTHR34935', NULL, NULL, NULL, NULL, 'PROTEIN TIC110, CHLOROPLASTIC', 247518),
(376222, 'PTHR34935:SF3', NULL, NULL, NULL, NULL, 'PROTEIN TIC110, CHLOROPLASTIC', 247518),
(376223, 'PTHR34935:SF4', NULL, NULL, NULL, NULL, 'BNAA10G28000D PROTEIN', 247518),
(376224, 'PTHR33402:SF17', NULL, NULL, NULL, NULL, 'VQ MOTIF-CONTAINING PROTEIN 33', 247519),
(376225, 'PTHR33402:SF28', NULL, NULL, NULL, NULL, 'BNAA05G09870D PROTEIN', 247519),
(376226, 'PTHR33402:SF16', NULL, NULL, NULL, NULL, 'VQ MOTIF-CONTAINING PROTEIN 13-RELATED', 247519),
(376227, 'PTHR33402:SF38', NULL, NULL, NULL, NULL, 'VQ MOTIF-CONTAINING PROTEIN-RELATED', 247519),
(376228, 'PTHR33402:SF27', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 247519),
(376229, 'PTHR33402:SF15', NULL, NULL, NULL, NULL, 'OS05G0519000 PROTEIN', 247519),
(376230, 'PTHR33402:SF26', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 247519),
(376231, 'PTHR33402', NULL, NULL, NULL, NULL, 'VQ MOTIF-CONTAINING PROTEIN 11-LIKE', 247519),
(376232, 'PTHR33402:SF25', NULL, NULL, NULL, NULL, 'BNAC03G58490D PROTEIN', 247519),
(376233, 'PTHR33402:SF3', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 247519),
(376234, 'PTHR33402:SF19', NULL, NULL, NULL, NULL, 'VQ MOTIF-CONTAINING PROTEIN 11', 247519),
(376235, 'PTHR33402:SF42', NULL, NULL, NULL, NULL, 'VQ MOTIF PROTEIN', 247519),
(376236, 'PTHR33402:SF45', NULL, NULL, NULL, NULL, 'OS01G0201250 PROTEIN', 247519),
(376237, 'PTHR33402:SF22', NULL, NULL, NULL, NULL, 'VQ MOTIF-CONTAINING PROTEIN 31', 247519),
(376238, 'PTHR33402:SF44', NULL, NULL, NULL, NULL, 'VQ MOTIF-CONTAINING PROTEIN 19', 247519),
(376239, 'PTHR33402:SF43', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 247519),
(376240, 'PTHR46415', NULL, NULL, NULL, NULL, 'ADAPTOR PROTEIN, PHOSPHOTYROSINE INTERACTION, PH DOMAIN AND LEUCINE ZIPPER-CONTAINING 2', 247520),
(376241, 'PTHR46415:SF3', NULL, NULL, NULL, NULL, 'DCC-INTERACTING PROTEIN 13-ALPHA', 247520),
(376242, 'PTHR46415:SF1', NULL, NULL, NULL, NULL, 'DCC-INTERACTING PROTEIN 13-BETA', 247520),
(376243, 'PTHR46415:SF2', NULL, NULL, NULL, NULL, 'ADAPTOR PROTEIN, PHOSPHOTYROSINE INTERACTION, PH DOMAIN AND LEUCINE ZIPPER-CONTAINING 2', 247520),
(376244, 'PTHR37380', NULL, NULL, NULL, NULL, 'CLE FAMILY OSCLE501 PROTEIN', 247521),
(376245, 'PTHR37380:SF1', NULL, NULL, NULL, NULL, 'CLE FAMILY OSCLE501 PROTEIN', 247521),
(376246, 'PTHR36318', NULL, NULL, NULL, NULL, 'OS06G0581300 PROTEIN', 247522),
(376247, 'PTHR36318:SF4', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE, RNA-DEPENDENT DNA POLYMERASE-RELATED', 247522),
(376248, 'PTHR36318:SF3', NULL, NULL, NULL, NULL, 'OS06G0581300 PROTEIN', 247522),
(376249, 'PTHR37164', NULL, NULL, NULL, NULL, 'BACTERIOHEMERYTHRIN', 247523),
(376250, 'PTHR37164:SF1', NULL, NULL, NULL, NULL, 'BACTERIOHEMERYTHRIN', 247523),
(376251, 'PTHR48107:SF8', NULL, NULL, NULL, NULL, 'OS06G0185100 PROTEIN', 247524),
(376252, 'PTHR48107:SF7', NULL, NULL, NULL, NULL, 'RE15974P', 247524),
(376253, 'PTHR48107:SF9', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 247524),
(376254, 'PTHR48107', NULL, NULL, NULL, NULL, 'NADPH-DEPENDENT ALDEHYDE REDUCTASE-LIKE PROTEIN, CHLOROPLASTIC-RELATED', 247524),
(376255, 'PTHR48107:SF18', NULL, NULL, NULL, NULL, 'NAD DEPENDENT EPIMERASE/DEHYDRATASE FAMILY PROTEIN, EXPRESSED', 247524),
(376256, 'PTHR48107:SF29', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/REDUCTASE', 247524),
(376257, 'PTHR48107:SF28', NULL, NULL, NULL, NULL, 'CHAIN DEHYDROGENASE, PUTATIVE-RELATED', 247524);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(376258, 'PTHR48107:SF17', NULL, NULL, NULL, NULL, 'CHAIN DEHYDROGENASE, PUTATIVE-RELATED', 247524),
(376259, 'PTHR48107:SF16', NULL, NULL, NULL, NULL, 'NADPH-DEPENDENT ALDEHYDE REDUCTASE 1, CHLOROPLASTIC', 247524),
(376260, 'PTHR48107:SF26', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE, SHORT-CHAIN DEHYDROGENASE/REDUCTASE FAMILY (AFU_ORTHOLOGUE AFUA_4G05870)', 247524),
(376261, 'PTHR48107:SF3', NULL, NULL, NULL, NULL, 'NAD DEPENDENT EPIMERASE/DEHYDRATASE FAMILY PROTEIN, EXPRESSED', 247524),
(376262, 'PTHR48107:SF14', NULL, NULL, NULL, NULL, 'OS07G0170000 PROTEIN', 247524),
(376263, 'PTHR48107:SF25', NULL, NULL, NULL, NULL, 'SHORT CHAIN DEHYDROGENASE', 247524),
(376264, 'PTHR48107:SF6', NULL, NULL, NULL, NULL, 'GLUCOSE AND RIBITOL DEHYDROGENASE HOMOLOG 2', 247524),
(376265, 'PTHR48107:SF12', NULL, NULL, NULL, NULL, 'NADPH-DEPENDENT ALDEHYDE REDUCTASE-LIKE PROTEIN, CHLOROPLASTIC', 247524),
(376266, 'PTHR48107:SF21', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/REDUCTASE SDR-RELATED', 247524),
(376267, 'PTHR48107:SF20', NULL, NULL, NULL, NULL, 'NADPH-DEPENDENT ALDEHYDE REDUCTASE 2, CHLOROPLASTIC', 247524),
(376268, 'PTHR38826', NULL, NULL, NULL, NULL, 'RIBONUCLEASE VAPC13', 247525),
(376269, 'PTHR38826:SF5', NULL, NULL, NULL, NULL, 'RIBONUCLEASE VAPC13', 247525),
(376270, 'PTHR43584:SF2', NULL, NULL, NULL, NULL, 'NUCLEOSIDE-DIPHOSPHATE-SUGAR PYROPHOSPHORYLASES-RELATED', 247526),
(376271, 'PTHR43584:SF3', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL PROTEIN GLMU', 247526),
(376272, 'PTHR43584:SF5', NULL, NULL, NULL, NULL, 'PROTEIN LICC', 247526),
(376273, 'PTHR43584:SF8', NULL, NULL, NULL, NULL, 'N-ACETYLMURAMATE ALPHA-1-PHOSPHATE URIDYLYLTRANSFERASE', 247526),
(376274, 'PTHR43584', NULL, NULL, NULL, NULL, 'NUCLEOTIDYL TRANSFERASE', 247526),
(376275, 'PTHR45691:SF16', NULL, NULL, NULL, NULL, 'EXCRETORY CANAL ABNORMAL PROTEIN 6', 247527),
(376276, 'PTHR45691:SF15', NULL, NULL, NULL, NULL, 'FH2 DOMAIN-CONTAINING PROTEIN', 247527),
(376277, 'PTHR45691:SF6', NULL, NULL, NULL, NULL, 'PROTEIN DIAPHANOUS', 247527),
(376278, 'PTHR45691:SF7', NULL, NULL, NULL, NULL, 'FH2 DOMAIN-CONTAINING 2', 247527),
(376279, 'PTHR45691', NULL, NULL, NULL, NULL, 'PROTEIN DIAPHANOUS', 247527),
(376280, 'PTHR45691:SF17', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', 247527),
(376281, 'PTHR45691:SF9', NULL, NULL, NULL, NULL, 'PROTEIN DIAPHANOUS HOMOLOG 3', 247527),
(376282, 'PTHR45691:SF3', NULL, NULL, NULL, NULL, 'PROTEIN DIAPHANOUS HOMOLOG 2', 247527),
(376283, 'PTHR45691:SF4', NULL, NULL, NULL, NULL, 'PROTEIN DIAPHANOUS HOMOLOG 1', 247527),
(376284, 'PTHR45691:SF1', NULL, NULL, NULL, NULL, 'FH2 DOMAIN-CONTAINING PROTEIN 1-RELATED', 247527),
(376285, 'PTHR46859:SF8', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE, TRANSMEMBRANE FRAGILE-X-F-ASSOCIATED PROTEIN-RELATED', 247528),
(376286, 'PTHR46859:SF6', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE FRAGILE-X-F-ASSOCIATED PROTEIN', 247528),
(376287, 'PTHR46859:SF5', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 247528),
(376288, 'PTHR46859', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE FRAGILE-X-F-ASSOCIATED PROTEIN', 247528),
(376289, 'PTHR46859:SF3', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 247528),
(376290, 'PTHR46859:SF11', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE FRAGILE-X-F-ASSOCIATED PROTEIN', 247528),
(376291, 'PTHR46859:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE FRAGILE-X-F-ASSOCIATED PROTEIN', 247528),
(376292, 'PTHR46859:SF9', NULL, NULL, NULL, NULL, 'BNAA02G14030D PROTEIN', 247528),
(376293, 'PTHR16399:SF10', NULL, NULL, NULL, NULL, 'PEJVAKIN', 247529),
(376294, 'PTHR16399:SF21', NULL, NULL, NULL, NULL, 'GASDERMIN-C', 247529),
(376295, 'PTHR16399:SF20', NULL, NULL, NULL, NULL, 'GASDERMIN-B', 247529),
(376296, 'PTHR16399:SF31', NULL, NULL, NULL, NULL, 'GASDERMIN DOMAIN-CONTAINING PROTEIN RGD1359449', 247529),
(376297, 'PTHR16399:SF18', NULL, NULL, NULL, NULL, 'GASDERMIN-A', 247529),
(376298, 'PTHR16399', NULL, NULL, NULL, NULL, 'GASDERMIN', 247529),
(376299, 'PTHR16399:SF15', NULL, NULL, NULL, NULL, 'GASDERMIN-D', 247529),
(376300, 'PTHR15127:SF29', NULL, NULL, NULL, NULL, 'SH2 DOMAIN-CONTAINING ADAPTER PROTEIN E', 247530);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(376301, 'PTHR15127:SF31', NULL, NULL, NULL, NULL, 'SH2 DOMAIN-CONTAINING ADAPTER PROTEIN B', 247530),
(376302, 'PTHR15127', NULL, NULL, NULL, NULL, 'HEAVYWEIGHT, ISOFORM A', 247530),
(376303, 'PTHR15127:SF32', NULL, NULL, NULL, NULL, 'HEAVYWEIGHT, ISOFORM A', 247530),
(376304, 'PTHR15127:SF33', NULL, NULL, NULL, NULL, 'SH2 DOMAIN-CONTAINING ADAPTER PROTEIN D', 247530),
(376305, 'PTHR15127:SF28', NULL, NULL, NULL, NULL, 'SH2 DOMAIN-CONTAINING ADAPTER PROTEIN F', 247530),
(376306, 'PTHR47277:SF1', NULL, NULL, NULL, NULL, 'CHROMOBOX PROTEIN HOMOLOG 7', 247531),
(376307, 'PTHR47277', NULL, NULL, NULL, NULL, 'CHROMOBOX PROTEIN HOMOLOG 7', 247531),
(376308, 'PTHR13598:SF2', NULL, NULL, NULL, NULL, 'NUCLEAR ENVELOPE INTEGRAL MEMBRANE PROTEIN 1', 247532),
(376309, 'PTHR13598:SF1', NULL, NULL, NULL, NULL, 'AT07567P-RELATED', 247532),
(376310, 'PTHR13598:SF4', NULL, NULL, NULL, NULL, 'NUCLEAR ENVELOPE INTEGRAL MEMBRANE PROTEIN 1', 247532),
(376311, 'PTHR13598:SF3', NULL, NULL, NULL, NULL, 'NUCLEAR ENVELOPE INTEGRAL MEMBRANE PROTEIN 2', 247532),
(376312, 'PTHR13598:SF5', NULL, NULL, NULL, NULL, 'NUCLEAR ENVELOPE INTEGRAL MEMBRANE PROTEIN 2', 247532),
(376313, 'PTHR13598', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247532),
(376314, 'PTHR31124:SF10', NULL, NULL, NULL, NULL, 'BNAC01G28650D PROTEIN', 247533),
(376315, 'PTHR31124:SF11', NULL, NULL, NULL, NULL, 'BNAC09G52530D PROTEIN', 247533),
(376316, 'PTHR31124:SF7', NULL, NULL, NULL, NULL, 'APICAL MERISTEM FORMATION PROTEIN-RELATED', 247533),
(376317, 'PTHR31124', NULL, NULL, NULL, NULL, 'APICAL MERISTEM FORMATION PROTEIN-RELATED-RELATED', 247533),
(376318, 'PTHR31124:SF8', NULL, NULL, NULL, NULL, 'BNAA09G19790D PROTEIN', 247533),
(376319, 'PTHR31124:SF9', NULL, NULL, NULL, NULL, 'BNAA10G10080D PROTEIN', 247533),
(376320, 'PTHR16138:SF7', NULL, NULL, NULL, NULL, 'PALMITOYL-PROTEIN THIOESTERASE ABHD10, MITOCHONDRIAL', 247534),
(376321, 'PTHR16138', NULL, NULL, NULL, NULL, 'MYCOPHENOLIC ACID ACYL-GLUCURONIDE ESTERASE, MITOCHONDRIAL', 247534),
(376322, 'PTHR37480', NULL, NULL, NULL, NULL, 'ENOYL-[ACYL-CARRIER-PROTEIN] REDUCTASE [NADH]', 247535),
(376323, 'PTHR37480:SF1', NULL, NULL, NULL, NULL, 'ENOYL-[ACYL-CARRIER-PROTEIN] REDUCTASE [NADH]', 247535),
(376324, 'PTHR12749', NULL, NULL, NULL, NULL, 'EXCISION REPAIR CROSS-COMPLEMENTING 1 ERCC1', 247536),
(376325, 'PTHR12749:SF0', NULL, NULL, NULL, NULL, 'DNA EXCISION REPAIR PROTEIN ERCC-1', 247536),
(376326, 'PTHR11506', NULL, NULL, NULL, NULL, 'LYSOSOME-ASSOCIATED MEMBRANE GLYCOPROTEIN', 247537),
(376327, 'PTHR11506:SF27', NULL, NULL, NULL, NULL, 'LYSOSOME-ASSOCIATED MEMBRANE GLYCOPROTEIN 1', 247537),
(376328, 'PTHR11506:SF28', NULL, NULL, NULL, NULL, '', 247537),
(376329, 'PTHR11506:SF39', NULL, NULL, NULL, NULL, 'LAMP FAMILY PROTEIN LMP-1', 247537),
(376330, 'PTHR11506:SF35', NULL, NULL, NULL, NULL, 'LYSOSOME-ASSOCIATED MEMBRANE GLYCOPROTEIN 5', 247537),
(376331, 'PTHR11506:SF40', NULL, NULL, NULL, NULL, 'AGAP011069-PA', 247537),
(376332, 'PTHR11506:SF30', NULL, NULL, NULL, NULL, 'LYSOSOME-ASSOCIATED MEMBRANE GLYCOPROTEIN 3', 247537),
(376333, 'PTHR11506:SF6', NULL, NULL, NULL, NULL, 'LYSOSOME-ASSOCIATED MEMBRANE GLYCOPROTEIN 2', 247537),
(376334, 'PTHR11506:SF2', NULL, NULL, NULL, NULL, 'MACROSIALIN', 247537),
(376335, 'PTHR16529', NULL, NULL, NULL, NULL, 'CD177 ANTIGEN', 247538),
(376336, 'PTHR16529:SF3', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 101', 247538),
(376337, 'PTHR16529:SF6', NULL, NULL, NULL, NULL, 'LY6/PLAUR DOMAIN-CONTAINING PROTEIN 4', 247538),
(376338, 'PTHR16529:SF8', NULL, NULL, NULL, NULL, 'CD177 ANTIGEN', 247538),
(376339, 'PTHR16529:SF9', NULL, NULL, NULL, NULL, 'LY6/PLAUR DOMAIN-CONTAINING 10-RELATED', 247538),
(376340, 'PTHR34799:SF2', NULL, NULL, NULL, NULL, 'OS07G0656300 PROTEIN', 247539),
(376341, 'PTHR34799', NULL, NULL, NULL, NULL, 'OS07G0656300 PROTEIN', 247539),
(376342, 'PTHR34799:SF4', NULL, NULL, NULL, NULL, '', 247539),
(376343, 'PTHR34799:SF6', NULL, NULL, NULL, NULL, 'SANTA DOMAIN-CONTAINING PROTEIN', 247539),
(376344, 'PTHR14633:SF3', NULL, NULL, NULL, NULL, 'LITTLE ELONGATION COMPLEX SUBUNIT 2', 247540);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(376345, 'PTHR14633', NULL, NULL, NULL, NULL, 'LITTLE ELONGATION COMPLEX SUBUNIT 2', 247540),
(376346, 'PTHR36619:SF3', NULL, NULL, NULL, NULL, '', 247541),
(376347, 'PTHR36619:SF2', NULL, NULL, NULL, NULL, 'OS04G0208900 PROTEIN', 247541),
(376348, 'PTHR36619', NULL, NULL, NULL, NULL, 'OS04G0208900 PROTEIN', 247541),
(376349, 'PTHR36619:SF4', NULL, NULL, NULL, NULL, '', 247541),
(376350, 'PTHR16022', NULL, NULL, NULL, NULL, 'WD REPEAT DOMAIN 60', 247542),
(376351, 'PTHR16022:SF0', NULL, NULL, NULL, NULL, 'CYTOPLASMIC DYNEIN 2 INTERMEDIATE CHAIN 1', 247542),
(376352, 'PTHR34463:SF20', NULL, NULL, NULL, NULL, 'GLYCINE-RICH CELL WALL STRUCTURAL PROTEIN-LIKE', 247543),
(376353, 'PTHR34463:SF4', NULL, NULL, NULL, NULL, 'BNAA01G23450D PROTEIN', 247543),
(376354, 'PTHR34463:SF11', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN LIKE', 247543),
(376355, 'PTHR34463:SF22', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN', 247543),
(376356, 'PTHR34463:SF6', NULL, NULL, NULL, NULL, 'WAG22 ANTIGEN-LIKE', 247543),
(376357, 'PTHR34463:SF24', NULL, NULL, NULL, NULL, 'BNAA03G58800D PROTEIN', 247543),
(376358, 'PTHR34463:SF12', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN', 247543),
(376359, 'PTHR34463:SF23', NULL, NULL, NULL, NULL, 'BNAA01G07900D PROTEIN', 247543),
(376360, 'PTHR34463:SF15', NULL, NULL, NULL, NULL, 'BNAA08G28000D PROTEIN', 247543),
(376361, 'PTHR34463', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN', 247543),
(376362, 'PTHR34463:SF17', NULL, NULL, NULL, NULL, 'ACANTHOSCURRIN-1-LIKE', 247543),
(376363, 'PTHR34463:SF18', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 247543),
(376364, 'PTHR12563:SF16', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE 1, MITOCHONDRIAL', 247544),
(376365, 'PTHR12563:SF15', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE 2, MITOCHONDRIAL', 247544),
(376366, 'PTHR12563:SF23', NULL, NULL, NULL, NULL, 'BCDNA.GH07066', 247544),
(376367, 'PTHR12563:SF22', NULL, NULL, NULL, NULL, 'SI:CH73-21K16.5', 247544),
(376368, 'PTHR12563:SF20', NULL, NULL, NULL, NULL, 'GLYCERONEPHOSPHATE O-ACYLTRANSFERASE', 247544),
(376369, 'PTHR12563', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE', 247544),
(376370, 'PTHR12563:SF17', NULL, NULL, NULL, NULL, 'DIHYDROXYACETONE PHOSPHATE ACYLTRANSFERASE', 247544),
(376371, 'PTHR45187', NULL, NULL, NULL, NULL, 'RHODANESE-LIKE DOMAIN-CONTAINING PROTEIN 11, CHLOROPLASTIC', 247545),
(376372, 'PTHR45187:SF2', NULL, NULL, NULL, NULL, 'RHODANESE-LIKE DOMAIN-CONTAINING PROTEIN 11, CHLOROPLASTIC', 247545),
(376373, 'PTHR46515', NULL, NULL, NULL, NULL, 'TATA ELEMENT MODULATORY FACTOR TMF1', 247546),
(376374, 'PTHR46515:SF1', NULL, NULL, NULL, NULL, 'TATA ELEMENT MODULATORY FACTOR', 247546),
(376375, 'PTHR45954', NULL, NULL, NULL, NULL, 'LD33695P', 247547),
(376376, 'PTHR45954:SF2', NULL, NULL, NULL, NULL, 'G-PROTEIN-SIGNALING MODULATOR 1', 247547),
(376377, 'PTHR45954:SF3', NULL, NULL, NULL, NULL, 'G-PROTEIN-SIGNALING MODULATOR 2', 247547),
(376378, 'PTHR45954:SF1', NULL, NULL, NULL, NULL, 'LD33695P', 247547),
(376379, 'PTHR46741:SF4', NULL, NULL, NULL, NULL, 'FINGER FYVE DOMAIN PROTEIN, PUTATIVE (DUF1666)-RELATED', 247548),
(376380, 'PTHR46741:SF2', NULL, NULL, NULL, NULL, 'OS09G0413600 PROTEIN', 247548),
(376381, 'PTHR46741:SF1', NULL, NULL, NULL, NULL, 'DUF1666 FAMILY PROTEIN', 247548),
(376382, 'PTHR46741:SF8', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L34', 247548),
(376383, 'PTHR46741:SF7', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 247548),
(376384, 'PTHR46741', NULL, NULL, NULL, NULL, 'OS09G0413600 PROTEIN', 247548),
(376385, 'PTHR16655:SF0', NULL, NULL, NULL, NULL, 'COCAINE- AND AMPHETAMINE-REGULATED TRANSCRIPT PROTEIN', 247549),
(376386, 'PTHR16655', NULL, NULL, NULL, NULL, 'COCAINE AND AMPHETAMINE REGULATED TRANSCRIPT PROTEIN', 247549),
(376387, 'PTHR16655:SF3', NULL, NULL, NULL, NULL, 'CART4', 247549),
(376388, 'PTHR16655:SF2', NULL, NULL, NULL, NULL, 'COCAINE-AND AMPHETAMINE-REGULATED TRANSCRIPT PROTEIN-LIKE', 247549),
(376389, 'PTHR16655:SF5', NULL, NULL, NULL, NULL, 'COCAINE- AND AMPHETAMINE-REGULATED TRANSCRIPT 2-RELATED', 247549);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(376390, 'PTHR16655:SF4', NULL, NULL, NULL, NULL, 'CART PREPROPEPTIDE', 247549),
(376391, 'PTHR16295:SF28', NULL, NULL, NULL, NULL, 'TRAF-TYPE ZINC FINGER PROTEIN', 247550),
(376392, 'PTHR16295:SF17', NULL, NULL, NULL, NULL, 'XIAP-ASSOCIATED FACTOR 1', 247550),
(376393, 'PTHR16295:SF19', NULL, NULL, NULL, NULL, 'TRAF-TYPE ZINC FINGER DOMAIN-CONTAINING PROTEIN 1', 247550),
(376394, 'PTHR16295', NULL, NULL, NULL, NULL, 'TRAF-TYPE ZINC FINGER PROTEIN-RELATED', 247550),
(376395, 'PTHR16295:SF30', NULL, NULL, NULL, NULL, 'TRAF-TYPE DOMAIN-CONTAINING PROTEIN', 247550),
(376396, 'PTHR16295:SF10', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247550),
(376397, 'PTHR16295:SF31', NULL, NULL, NULL, NULL, 'OS03G0356652 PROTEIN', 247550),
(376398, 'PTHR16295:SF25', NULL, NULL, NULL, NULL, 'XIAP-ASSOCIATED FACTOR 1-LIKE', 247550),
(376399, 'PTHR42963:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME PARTITION PROTEIN MUKB', 247551),
(376400, 'PTHR42963', NULL, NULL, NULL, NULL, 'CHROMOSOME PARTITION PROTEIN MUKB', 247551),
(376401, 'PTHR11103:SF10', NULL, NULL, NULL, NULL, 'HOMOCYSTEINE S-METHYLTRANSFERASE 1-RELATED', 247552),
(376402, 'PTHR11103', NULL, NULL, NULL, NULL, 'SLR1189 PROTEIN', 247552),
(376403, 'PTHR11103:SF18', NULL, NULL, NULL, NULL, 'SLR1189 PROTEIN', 247552),
(376404, 'PTHR45630:SF9', NULL, NULL, NULL, NULL, 'CATION-TRANSPORTING ATPASE CATP-5', 247553),
(376405, 'PTHR45630', NULL, NULL, NULL, NULL, 'CATION-TRANSPORTING ATPASE-RELATED', 247553),
(376406, 'PTHR45630:SF11', NULL, NULL, NULL, NULL, 'CATION_ATPASE_N DOMAIN-CONTAINING PROTEIN', 247553),
(376407, 'PTHR45630:SF12', NULL, NULL, NULL, NULL, 'POLYAMINE-TRANSPORTING ATPASE 13A3', 247553),
(376408, 'PTHR45630:SF13', NULL, NULL, NULL, NULL, 'BNAC02G48770D PROTEIN', 247553),
(376409, 'PTHR45630:SF14', NULL, NULL, NULL, NULL, 'CATION-TRANSPORTING ATPASE', 247553),
(376410, 'PTHR45630:SF15', NULL, NULL, NULL, NULL, 'CATION-TRANSPORTING ATPASE 5', 247553),
(376411, 'PTHR45630:SF2', NULL, NULL, NULL, NULL, 'POLYAMINE-TRANSPORTING ATPASE 13A2', 247553),
(376412, 'PTHR45630:SF1', NULL, NULL, NULL, NULL, 'CATION-TRANSPORTING ATPASE 13A4-RELATED', 247553),
(376413, 'PTHR45630:SF4', NULL, NULL, NULL, NULL, 'CATION-TRANSPORTING ATPASE 13A5-RELATED', 247553),
(376414, 'PTHR45630:SF6', NULL, NULL, NULL, NULL, 'CATION_ATPASE_N DOMAIN-CONTAINING PROTEIN', 247553),
(376415, 'PTHR45630:SF5', NULL, NULL, NULL, NULL, 'CATION-TRANSPORTING ATPASE', 247553),
(376416, 'PTHR45630:SF8', NULL, NULL, NULL, NULL, 'CATION-TRANSPORTING ATPASE', 247553),
(376417, 'PTHR45630:SF7', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM TRANSMEMBRANE HELIX TRANSLOCASE', 247553),
(376418, 'PTHR36264', NULL, NULL, NULL, NULL, '', 247554),
(376419, 'PTHR36264:SF6', NULL, NULL, NULL, NULL, '', 247554),
(376420, 'PTHR36264:SF7', NULL, NULL, NULL, NULL, '', 247554),
(376421, 'PTHR36264:SF2', NULL, NULL, NULL, NULL, '', 247554),
(376422, 'PTHR36264:SF3', NULL, NULL, NULL, NULL, '', 247554),
(376423, 'PTHR36264:SF4', NULL, NULL, NULL, NULL, '', 247554),
(376424, 'PTHR36264:SF5', NULL, NULL, NULL, NULL, '', 247554),
(376425, 'PTHR42194:SF1', NULL, NULL, NULL, NULL, 'UPF0276 PROTEIN HI_1600', 247555),
(376426, 'PTHR42194', NULL, NULL, NULL, NULL, 'UPF0276 PROTEIN HI_1600', 247555),
(376427, 'PTHR24652:SF68', NULL, NULL, NULL, NULL, 'CUB DOMAIN-CONTAINING PROTEIN', 247556),
(376428, 'PTHR24652:SF67', NULL, NULL, NULL, NULL, 'LOW-DENSITY LIPOPROTEIN RECEPTOR CLASS A DOMAIN-CONTAINING PROTEIN 2', 247556),
(376429, 'PTHR24652', NULL, NULL, NULL, NULL, 'LOW-DENSITY LIPOPROTEIN RECEPTOR CLASS A DOMAIN-CONTAINING PROTEIN 2', 247556),
(376430, 'PTHR47163', NULL, NULL, NULL, NULL, 'DDE_TNP_IS1595 DOMAIN-CONTAINING PROTEIN', 247557),
(376431, 'PTHR47163:SF2', NULL, NULL, NULL, NULL, 'SI:DKEY-17M8.2', 247557),
(376432, 'PTHR23209', NULL, NULL, NULL, NULL, 'A-KINASE ANCHOR PROTEIN 12', 247558),
(376433, 'PTHR23209:SF4', NULL, NULL, NULL, NULL, 'A-KINASE ANCHOR PROTEIN 12', 247558),
(376434, 'PTHR36101', NULL, NULL, NULL, NULL, 'ATP SYNTHASE PROTEIN 8', 247559),
(376435, 'PTHR36101:SF1', NULL, NULL, NULL, NULL, 'ATP SYNTHASE PROTEIN 8', 247559);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(376436, 'PTHR47455:SF1', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE DOMAIN-CONTAINING PROTEIN', 247560),
(376437, 'PTHR47455', NULL, NULL, NULL, NULL, 'ADENYLYL CYCLASE BETA', 247560),
(376438, 'PTHR16262', NULL, NULL, NULL, NULL, 'PEROXISOME ASSEMBLY PROTEIN 26', 247561),
(376439, 'PTHR16262:SF2', NULL, NULL, NULL, NULL, 'PEROXISOME ASSEMBLY PROTEIN 26', 247561),
(376440, 'PTHR11515:SF25', NULL, NULL, NULL, NULL, 'CHORIOGONADOTROPIN SUBUNIT BETA 3-RELATED', 247562),
(376441, 'PTHR11515:SF14', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN HORMONE BETA-5', 247562),
(376442, 'PTHR11515:SF13', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN HORMONE BETA 5, ISOFORM A', 247562),
(376443, 'PTHR11515', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN HORMONE BETA CHAIN', 247562),
(376444, 'PTHR11515:SF5', NULL, NULL, NULL, NULL, 'THYROTROPIN SUBUNIT BETA', 247562),
(376445, 'PTHR11515:SF11', NULL, NULL, NULL, NULL, 'LUTROPIN SUBUNIT BETA', 247562),
(376446, 'PTHR11515:SF29', NULL, NULL, NULL, NULL, 'CYS_KNOT DOMAIN-CONTAINING PROTEIN', 247562),
(376447, 'PTHR11515:SF28', NULL, NULL, NULL, NULL, 'SI:DKEY-23I12.9', 247562),
(376448, 'PTHR11515:SF17', NULL, NULL, NULL, NULL, 'FOLLITROPIN SUBUNIT BETA', 247562),
(376449, 'PTHR46752:SF1', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 39', 247563),
(376450, 'PTHR46752', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 39', 247563),
(376451, 'PTHR16442', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 17', 247564),
(376452, 'PTHR16442:SF1', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 17', 247564),
(376453, 'PTHR46492', NULL, NULL, NULL, NULL, 'DYNEIN ASSEMBLY FACTOR 4, AXONEMAL', 247565),
(376454, 'PTHR46492:SF1', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL ASSEMBLY FACTOR 4', 247565),
(376455, 'PTHR46209', NULL, NULL, NULL, NULL, 'PX DOMAIN-CONTAINING PROTEIN', 247566),
(376456, 'PTHR46209:SF1', NULL, NULL, NULL, NULL, 'SORTING NEXIN-11', 247566),
(376457, 'PTHR46209:SF3', NULL, NULL, NULL, NULL, 'PX DOMAIN-CONTAINING PROTEIN', 247566),
(376458, 'PTHR46209:SF2', NULL, NULL, NULL, NULL, 'SORTING NEXIN-10', 247566),
(376459, 'PTHR46209:SF4', NULL, NULL, NULL, NULL, 'PX DOMAIN-CONTAINING PROTEIN-RELATED', 247566),
(376460, 'PTHR43720', NULL, NULL, NULL, NULL, '2-AMINOMUCONIC SEMIALDEHYDE DEHYDROGENASE', 247567),
(376461, 'PTHR43720:SF2', NULL, NULL, NULL, NULL, '2-AMINOMUCONIC SEMIALDEHYDE DEHYDROGENASE', 247567),
(376462, 'PTHR43720:SF3', NULL, NULL, NULL, NULL, 'ALDEDH DOMAIN-CONTAINING PROTEIN-RELATED', 247567),
(376463, 'PTHR36536:SF3', NULL, NULL, NULL, NULL, 'UPF0111 PROTEIN HI_1603', 247568),
(376464, 'PTHR36536', NULL, NULL, NULL, NULL, 'UPF0111 PROTEIN HI_1603', 247568),
(376465, 'PTHR36438', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER REPAIR PROTEIN YTFE', 247569),
(376466, 'PTHR36438:SF1', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER REPAIR PROTEIN YTFE', 247569),
(376467, 'PTHR14659:SF1', NULL, NULL, NULL, NULL, 'ALPHA- AND GAMMA-ADAPTIN-BINDING PROTEIN P34', 247570),
(376468, 'PTHR14659', NULL, NULL, NULL, NULL, 'ALPHA- AND GAMMA-ADAPTIN-BINDING PROTEIN P34', 247570),
(376469, 'PTHR24096:SF375', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE-LIKE 7', 247571),
(376470, 'PTHR24096:SF298', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE-LIKE 5', 247571),
(376471, 'PTHR24096:SF374', NULL, NULL, NULL, NULL, 'BNAC08G19270D PROTEIN', 247571),
(376472, 'PTHR24096:SF377', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE-LIKE 7', 247571),
(376473, 'PTHR24096:SF333', NULL, NULL, NULL, NULL, '', 247571),
(376474, 'PTHR24096:SF410', NULL, NULL, NULL, NULL, 'AMP-BINDING DOMAIN-CONTAINING PROTEIN', 247571),
(376475, 'PTHR24096:SF376', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE', 247571),
(376476, 'PTHR24096:SF332', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE', 247571),
(376477, 'PTHR24096:SF412', NULL, NULL, NULL, NULL, '4-COUMARATE:COA LIGASE-LIKE PROTEIN', 247571),
(376478, 'PTHR24096:SF411', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE-LIKE 7', 247571),
(376479, 'PTHR24096:SF257', NULL, NULL, NULL, NULL, 'ACYL-COA SYNTHETASE 7', 247571),
(376480, 'PTHR24096:SF414', NULL, NULL, NULL, NULL, 'DEPENDENT LIGASE/SYNTHETASE, PUTATIVE-RELATED', 247571);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(376481, 'PTHR24096:SF337', NULL, NULL, NULL, NULL, 'LONG-CHAIN ACYL-COA SYNTHETASE', 247571),
(376482, 'PTHR24096:SF413', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE-LIKE 5', 247571),
(376483, 'PTHR24096:SF336', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE 5', 247571),
(376484, 'PTHR24096:SF416', NULL, NULL, NULL, NULL, 'AMP-BINDING DOMAIN-CONTAINING PROTEIN', 247571),
(376485, 'PTHR24096:SF339', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE-LIKE 3-RELATED', 247571),
(376486, 'PTHR24096:SF217', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE 1', 247571),
(376487, 'PTHR24096:SF338', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE-LIKE 8-RELATED', 247571),
(376488, 'PTHR24096:SF415', NULL, NULL, NULL, NULL, '4-COUMARATE:COA LIGASE-LIKE PROTEIN', 247571),
(376489, 'PTHR24096:SF418', NULL, NULL, NULL, NULL, 'LONG-CHAIN-FATTY-ACID--COA LIGASE-RELATED', 247571),
(376490, 'PTHR24096:SF417', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE', 247571),
(376491, 'PTHR24096:SF261', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE-LIKE 6', 247571),
(376492, 'PTHR24096:SF381', NULL, NULL, NULL, NULL, 'FATTY ACID COA SYNTHETASE FAMILY', 247571),
(376493, 'PTHR24096:SF260', NULL, NULL, NULL, NULL, 'LONG-CHAIN-FATTY-ACID--COA LIGASE ACSBG2', 247571),
(376494, 'PTHR24096:SF384', NULL, NULL, NULL, NULL, 'AMP-BINDING DOMAIN-CONTAINING PROTEIN', 247571),
(376495, 'PTHR24096:SF320', NULL, NULL, NULL, NULL, 'BLR5963 PROTEIN', 247571),
(376496, 'PTHR24096:SF168', NULL, NULL, NULL, NULL, 'PROTEIN CBR-MEC-18', 247571),
(376497, 'PTHR24096:SF366', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE-LIKE 1', 247571),
(376498, 'PTHR24096:SF365', NULL, NULL, NULL, NULL, 'AMP-BINDING DOMAIN-CONTAINING PROTEIN', 247571),
(376499, 'PTHR24096:SF368', NULL, NULL, NULL, NULL, 'BNAC03G74270D PROTEIN', 247571),
(376500, 'PTHR24096:SF401', NULL, NULL, NULL, NULL, 'BLL7293 PROTEIN', 247571),
(376501, 'PTHR24096:SF246', NULL, NULL, NULL, NULL, 'ACYL-COA SYNTHETASE BUBBLEGUM FAMILY MEMBER 3', 247571),
(376502, 'PTHR24096:SF400', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE 1-RELATED', 247571),
(376503, 'PTHR24096:SF367', NULL, NULL, NULL, NULL, 'AMP-BINDING DOMAIN-CONTAINING PROTEIN', 247571),
(376504, 'PTHR24096:SF169', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE 3', 247571),
(376505, 'PTHR24096:SF323', NULL, NULL, NULL, NULL, 'BLR3536 PROTEIN', 247571),
(376506, 'PTHR24096:SF402', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE 1', 247571),
(376507, 'PTHR24096:SF369', NULL, NULL, NULL, NULL, 'DIDEMETHYLASTERRIQUINONE D SYNTHETASE TDIA-RELATED', 247571),
(376508, 'PTHR24096:SF405', NULL, NULL, NULL, NULL, '4-COUMARATE:COA LIGASE-LIKE PROTEIN', 247571),
(376509, 'PTHR24096:SF404', NULL, NULL, NULL, NULL, 'FATTY ACID COA SYNTHETASE FAMILY', 247571),
(376510, 'PTHR24096:SF406', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE 2', 247571),
(376511, 'PTHR24096:SF409', NULL, NULL, NULL, NULL, 'FATTY ACID COA SYNTHETASE FAMILY', 247571),
(376512, 'PTHR24096', NULL, NULL, NULL, NULL, 'LONG-CHAIN-FATTY-ACID--COA LIGASE', 247571),
(376513, 'PTHR24096:SF371', NULL, NULL, NULL, NULL, 'BNAA06G14440D PROTEIN', 247571),
(376514, 'PTHR24096:SF370', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE', 247571),
(376515, 'PTHR24096:SF296', NULL, NULL, NULL, NULL, 'LONG-CHAIN-FATTY-ACID--COA LIGASE ACSBG1', 247571),
(376516, 'PTHR24096:SF295', NULL, NULL, NULL, NULL, 'AMP-BINDING DOMAIN-CONTAINING PROTEIN', 247571),
(376517, 'PTHR24096:SF251', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE-LIKE 9', 247571),
(376518, 'PTHR24096:SF372', NULL, NULL, NULL, NULL, 'BNAC08G19290D PROTEIN', 247571),
(376519, 'PTHR24096:SF353', NULL, NULL, NULL, NULL, 'GH16244P-RELATED', 247571),
(376520, 'PTHR24096:SF352', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE 1', 247571),
(376521, 'PTHR24096:SF399', NULL, NULL, NULL, NULL, 'FATTY-ACID--COA LIGASE FADD11-RELATED', 247571),
(376522, 'PTHR24096:SF312', NULL, NULL, NULL, NULL, 'BCDNA.GH02901', 247571),
(376523, 'PTHR24096:SF359', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE 4', 247571),
(376524, 'PTHR24096:SF314', NULL, NULL, NULL, NULL, 'BLL7864 PROTEIN', 247571);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(376525, 'PTHR24096:SF358', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE-LIKE 8', 247571),
(376526, 'PTHR24096:SF317', NULL, NULL, NULL, NULL, 'NICOTINIC ACID-COA LIGASE PYR1', 247571),
(376527, 'PTHR24096:SF160', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE-LIKE 5', 247571),
(376528, 'PTHR24096:SF362', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE', 247571),
(376529, 'PTHR24096:SF265', NULL, NULL, NULL, NULL, 'ENZYME, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G14270)-RELATED', 247571),
(376530, 'PTHR24096:SF341', NULL, NULL, NULL, NULL, 'PROTEIN CBG08050', 247571),
(376531, 'PTHR24096:SF267', NULL, NULL, NULL, NULL, 'MALONATE--COA LIGASE ACSF3, MITOCHONDRIAL', 247571),
(376532, 'PTHR24096:SF300', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE 3', 247571),
(376533, 'PTHR24096:SF387', NULL, NULL, NULL, NULL, 'BNAUNNG04240D PROTEIN', 247571),
(376534, 'PTHR24096:SF346', NULL, NULL, NULL, NULL, '', 247571),
(376535, 'PTHR24096:SF345', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE-LIKE 2', 247571),
(376536, 'PTHR24096:SF389', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE-LIKE 1', 247571),
(376537, 'PTHR24096:SF149', NULL, NULL, NULL, NULL, '2-SUCCINYLBENZOATE--COA LIGASE-RELATED', 247571),
(376538, 'PTHR24096:SF306', NULL, NULL, NULL, NULL, 'FATTY ACID COA SYNTHETASE FAMILY', 247571),
(376539, 'PTHR24096:SF391', NULL, NULL, NULL, NULL, 'LONG-CHAIN-FATTY-ACID--COA LIGASE HEIMDALL-RELATED', 247571),
(376540, 'PTHR24096:SF390', NULL, NULL, NULL, NULL, 'BNAA05G36600D PROTEIN', 247571),
(376541, 'PTHR24096:SF393', NULL, NULL, NULL, NULL, 'CHROMOSOME 8, WHOLE GENOME SHOTGUN SEQUENCE', 247571),
(376542, 'PTHR24096:SF392', NULL, NULL, NULL, NULL, 'BNAC07G15330D PROTEIN', 247571),
(376543, 'PTHR24096:SF271', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A SYNTHETASE-RELATED', 247571),
(376544, 'PTHR24096:SF194', NULL, NULL, NULL, NULL, '', 247571),
(376545, 'PTHR24096:SF394', NULL, NULL, NULL, NULL, 'VERY LONG-CHAIN-FATTY-ACID--COA LIGASE BUBBLEGUM-LIKE PROTEIN', 247571),
(376546, 'PTHR47992:SF19', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 16', 247572),
(376547, 'PTHR47992:SF15', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376548, 'PTHR47992:SF16', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 247572),
(376549, 'PTHR47992:SF18', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 247572),
(376550, 'PTHR47992:SF91', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 71-RELATED', 247572),
(376551, 'PTHR47992:SF211', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 51', 247572),
(376552, 'PTHR47992:SF178', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 247572),
(376553, 'PTHR47992:SF179', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 56', 247572),
(376554, 'PTHR47992:SF212', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 247572),
(376555, 'PTHR47992:SF9', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376556, 'PTHR47992:SF176', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 30-RELATED', 247572),
(376557, 'PTHR47992:SF93', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 37', 247572),
(376558, 'PTHR47992:SF177', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 40-RELATED', 247572),
(376559, 'PTHR47992:SF210', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376560, 'PTHR47992:SF6', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 78-RELATED', 247572),
(376561, 'PTHR47992:SF175', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C FAMILY PROTEIN', 247572),
(376562, 'PTHR47992:SF5', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376563, 'PTHR47992:SF90', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376564, 'PTHR47992:SF173', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376565, 'PTHR47992:SF11', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 33-RELATED', 247572),
(376566, 'PTHR47992:SF219', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 41-RELATED', 247572);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(376567, 'PTHR47992:SF3', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376568, 'PTHR47992:SF217', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376569, 'PTHR47992:SF13', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376570, 'PTHR47992:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 15-RELATED', 247572),
(376571, 'PTHR47992:SF218', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 53', 247572),
(376572, 'PTHR47992:SF215', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN, PROTEIN PHOSPHATASE 2C FAMILY-RELATED', 247572),
(376573, 'PTHR47992:SF216', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376574, 'PTHR47992:SF96', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 3', 247572),
(376575, 'PTHR47992:SF97', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 68-RELATED', 247572),
(376576, 'PTHR47992:SF213', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 12-RELATED', 247572),
(376577, 'PTHR47992:SF214', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 59-RELATED', 247572),
(376578, 'PTHR47992:SF10', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376579, 'PTHR47992:SF98', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 6-RELATED', 247572),
(376580, 'PTHR47992:SF192', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376581, 'PTHR47992:SF191', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 12-RELATED', 247572),
(376582, 'PTHR47992:SF101', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376583, 'PTHR47992:SF222', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376584, 'PTHR47992:SF80', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376585, 'PTHR47992:SF189', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376586, 'PTHR47992:SF81', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 6 ISOFORM X1-RELATED', 247572),
(376587, 'PTHR47992:SF223', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376588, 'PTHR47992:SF220', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376589, 'PTHR47992:SF82', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 247572),
(376590, 'PTHR47992:SF187', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376591, 'PTHR47992:SF221', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 63-RELATED', 247572),
(376592, 'PTHR47992:SF83', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 247572),
(376593, 'PTHR47992:SF183', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 9-RELATED', 247572),
(376594, 'PTHR47992:SF109', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376595, 'PTHR47992:SF89', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376596, 'PTHR47992:SF107', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376597, 'PTHR47992:SF228', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN, PROTEIN PHOSPHATASE 2C FAMILY-RELATED', 247572),
(376598, 'PTHR47992:SF108', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376599, 'PTHR47992:SF229', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376600, 'PTHR47992:SF84', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 50', 247572),
(376601, 'PTHR47992:SF226', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1K, MITOCHONDRIAL', 247572),
(376602, 'PTHR47992:SF105', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1B', 247572),
(376603, 'PTHR47992:SF85', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376604, 'PTHR47992:SF227', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 68-RELATED', 247572),
(376605, 'PTHR47992:SF86', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376606, 'PTHR47992:SF103', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 65-RELATED', 247572),
(376607, 'PTHR47992:SF224', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(376608, 'PTHR47992:SF225', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376609, 'PTHR47992:SF87', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 52-RELATED', 247572),
(376610, 'PTHR47992:SF104', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376611, 'PTHR47992:SF37', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 67-RELATED', 247572),
(376612, 'PTHR47992:SF39', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376613, 'PTHR47992:SF160', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 77', 247572),
(376614, 'PTHR47992:SF157', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN, PROTEIN PHOSPHATASE 2C FAMILY-RELATED', 247572),
(376615, 'PTHR47992:SF155', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 247572),
(376616, 'PTHR47992:SF150', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 5-RELATED', 247572),
(376617, 'PTHR47992:SF151', NULL, NULL, NULL, NULL, 'PROTEIN KINASE AND PP2C-LIKE DOMAIN-CONTAINING PROTEIN', 247572),
(376618, 'PTHR47992:SF34', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 1-RELATED', 247572),
(376619, 'PTHR47992:SF36', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 247572),
(376620, 'PTHR47992:SF30', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 247572),
(376621, 'PTHR47992:SF31', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 78-RELATED', 247572),
(376622, 'PTHR47992:SF159', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 42-RELATED', 247572),
(376623, 'PTHR47992:SF32', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 48-RELATED', 247572),
(376624, 'PTHR47992:SF26', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 50-RELATED', 247572),
(376625, 'PTHR47992:SF28', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN, PROTEIN PHOSPHATASE 2C FAMILY-RELATED', 247572),
(376626, 'PTHR47992:SF167', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376627, 'PTHR47992:SF200', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376628, 'PTHR47992:SF201', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376629, 'PTHR47992:SF165', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376630, 'PTHR47992:SF161', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 65-RELATED', 247572),
(376631, 'PTHR47992:SF22', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 7', 247572),
(376632, 'PTHR47992:SF208', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376633, 'PTHR47992:SF209', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376634, 'PTHR47992:SF23', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 72-RELATED', 247572),
(376635, 'PTHR47992:SF206', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376636, 'PTHR47992:SF24', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 29-RELATED', 247572),
(376637, 'PTHR47992:SF25', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 58-RELATED', 247572),
(376638, 'PTHR47992:SF207', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 51-RELATED', 247572),
(376639, 'PTHR47992:SF204', NULL, NULL, NULL, NULL, 'TGF-BETA-ACTIVATED KINASE 1 AND MAP3K7-BINDING PROTEIN 1', 247572),
(376640, 'PTHR47992:SF205', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 14-RELATED', 247572),
(376641, 'PTHR47992:SF169', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376642, 'PTHR47992:SF20', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 28-RELATED', 247572),
(376643, 'PTHR47992:SF202', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 247572),
(376644, 'PTHR47992:SF203', NULL, NULL, NULL, NULL, 'CATALYTIC/PROTEIN PHOSPHATASE TYPE 2C', 247572),
(376645, 'PTHR47992:SF21', NULL, NULL, NULL, NULL, 'PHOSPHATASE 2C FAMILY PROTEIN', 247572),
(376646, 'PTHR47992:SF59', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1N-RELATED', 247572),
(376647, 'PTHR47992', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE', 247572),
(376648, 'PTHR47992:SF134', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(376649, 'PTHR47992:SF50', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 74-RELATED', 247572),
(376650, 'PTHR47992:SF133', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 247572),
(376651, 'PTHR47992:SF130', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376652, 'PTHR47992:SF55', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376653, 'PTHR47992:SF57', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 72-RELATED', 247572),
(376654, 'PTHR47992:SF58', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 34-RELATED', 247572),
(376655, 'PTHR47992:SF52', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 49-RELATED', 247572),
(376656, 'PTHR47992:SF53', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 46-RELATED', 247572),
(376657, 'PTHR47992:SF54', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 45-RELATED', 247572),
(376658, 'PTHR47992:SF137', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376659, 'PTHR47992:SF48', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 34-RELATED', 247572),
(376660, 'PTHR47992:SF49', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 247572),
(376661, 'PTHR47992:SF146', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376662, 'PTHR47992:SF143', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 247572),
(376663, 'PTHR47992:SF144', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 247572),
(376664, 'PTHR47992:SF141', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 75-RELATED', 247572),
(376665, 'PTHR47992:SF140', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 69-RELATED', 247572),
(376666, 'PTHR47992:SF45', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376667, 'PTHR47992:SF46', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 247572),
(376668, 'PTHR47992:SF47', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 247572),
(376669, 'PTHR47992:SF149', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376670, 'PTHR47992:SF40', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 24-RELATED', 247572),
(376671, 'PTHR47992:SF42', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376672, 'PTHR47992:SF43', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 11-RELATED', 247572),
(376673, 'PTHR47992:SF148', NULL, NULL, NULL, NULL, 'PHOSPHATASE 2C, PUTATIVE-RELATED', 247572),
(376674, 'PTHR47992:SF233', NULL, NULL, NULL, NULL, 'ALPHABET, ISOFORM E', 247572),
(376675, 'PTHR47992:SF112', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 59-RELATED', 247572),
(376676, 'PTHR47992:SF70', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376677, 'PTHR47992:SF231', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376678, 'PTHR47992:SF198', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 247572),
(376679, 'PTHR47992:SF110', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C-LIKE PROTEIN 44-RELATED', 247572),
(376680, 'PTHR47992:SF72', NULL, NULL, NULL, NULL, 'PHOSPHATASE 2C FAMILY PROTEIN', 247572),
(376681, 'PTHR47992:SF232', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 20-RELATED', 247572),
(376682, 'PTHR47992:SF199', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 43-RELATED', 247572),
(376683, 'PTHR47992:SF230', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376684, 'PTHR47992:SF79', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1D', 247572),
(376685, 'PTHR47992:SF118', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 61-RELATED', 247572),
(376686, 'PTHR47992:SF119', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 33-RELATED', 247572),
(376687, 'PTHR47992:SF73', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376688, 'PTHR47992:SF74', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 54-RELATED', 247572),
(376689, 'PTHR47992:SF117', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 38-RELATED', 247572);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(376690, 'PTHR47992:SF114', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 15-RELATED', 247572),
(376691, 'PTHR47992:SF115', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376692, 'PTHR47992:SF123', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376693, 'PTHR47992:SF124', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376694, 'PTHR47992:SF60', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 247572),
(376695, 'PTHR47992:SF121', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1A', 247572),
(376696, 'PTHR47992:SF61', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 247572),
(376697, 'PTHR47992:SF66', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 18-RELATED', 247572),
(376698, 'PTHR47992:SF67', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PHOSPHATASES FAMILY 2C CATALYTIC DOMAIN CONTAINING PROTEIN', 247572),
(376699, 'PTHR47992:SF129', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 69-RELATED', 247572),
(376700, 'PTHR47992:SF68', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 73-RELATED', 247572),
(376701, 'PTHR47992:SF69', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 38-RELATED', 247572),
(376702, 'PTHR47992:SF62', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 52-RELATED', 247572),
(376703, 'PTHR47992:SF128', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 64-RELATED', 247572),
(376704, 'PTHR47992:SF63', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 8-RELATED', 247572),
(376705, 'PTHR47992:SF64', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 33-RELATED', 247572),
(376706, 'PTHR35100:SF5', NULL, NULL, NULL, NULL, 'FOLD PROTEIN', 247573),
(376707, 'PTHR35100:SF3', NULL, NULL, NULL, NULL, '', 247573),
(376708, 'PTHR35100:SF1', NULL, NULL, NULL, NULL, 'F15H11.13 PROTEIN', 247573),
(376709, 'PTHR35100', NULL, NULL, NULL, NULL, 'FOLD PROTEIN', 247573),
(376710, 'PTHR43414:SF3', NULL, NULL, NULL, NULL, 'LMO2377 PROTEIN', 247574),
(376711, 'PTHR43414', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN MDTG', 247574),
(376712, 'PTHR43414:SF6', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN MDTG', 247574),
(376713, 'PTHR43414:SF1', NULL, NULL, NULL, NULL, 'PEPTIDE PERMEASE', 247574),
(376714, 'PTHR13447:SF2', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S28, MITOCHONDRIAL', 247575),
(376715, 'PTHR13447', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 28S RIBOSOMAL PROTEIN S28', 247575),
(376716, 'PTHR43185:SF2', NULL, NULL, NULL, NULL, 'FERROUS IRON TRANSPORT PROTEIN B', 247576),
(376717, 'PTHR43185', NULL, NULL, NULL, NULL, 'FERROUS IRON TRANSPORT PROTEIN B', 247576),
(376718, 'PTHR43185:SF1', NULL, NULL, NULL, NULL, 'FE(2+) TRANSPORTER FEOB', 247576),
(376719, 'PTHR31220:SF3', NULL, NULL, NULL, NULL, 'PROTEIN FAM126B', 247577),
(376720, 'PTHR31220:SF4', NULL, NULL, NULL, NULL, 'HYCCIN', 247577),
(376721, 'PTHR31220:SF1', NULL, NULL, NULL, NULL, 'GH21176P', 247577),
(376722, 'PTHR31220:SF10', NULL, NULL, NULL, NULL, 'HYCCIN', 247577),
(376723, 'PTHR31220', NULL, NULL, NULL, NULL, 'HYCCIN RELATED', 247577),
(376724, 'PTHR38118:SF1', NULL, NULL, NULL, NULL, 'ANCHORED CELL WALL PROTEIN 11', 247578),
(376725, 'PTHR38118:SF2', NULL, NULL, NULL, NULL, '', 247578),
(376726, 'PTHR38118', NULL, NULL, NULL, NULL, 'ANCHORED CELL WALL PROTEIN 11-RELATED', 247578),
(376727, 'PTHR37727', NULL, NULL, NULL, NULL, 'ECOTROPIC VIRAL INTEGRATION SITE PROTEIN', 247579),
(376728, 'PTHR37727:SF1', NULL, NULL, NULL, NULL, 'ECOTROPIC VIRAL INTEGRATION SITE PROTEIN', 247579),
(376729, 'PTHR33416:SF30', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP1-LIKE', 247580),
(376730, 'PTHR33416:SF35', NULL, NULL, NULL, NULL, '', 247580),
(376731, 'PTHR33416', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP1', 247580),
(376732, 'PTHR33416:SF14', NULL, NULL, NULL, NULL, 'OS06G0658500 PROTEIN', 247580),
(376733, 'PTHR33416:SF36', NULL, NULL, NULL, NULL, 'NUCLEOPORIN-RELATED', 247580),
(376734, 'PTHR33416:SF16', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP1', 247580),
(376735, 'PTHR33416:SF31', NULL, NULL, NULL, NULL, 'BNAA01G05810D PROTEIN', 247580);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(376736, 'PTHR33416:SF20', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP1', 247580),
(376737, 'PTHR33416:SF32', NULL, NULL, NULL, NULL, '', 247580),
(376738, 'PTHR33416:SF33', NULL, NULL, NULL, NULL, '', 247580),
(376739, 'PTHR33416:SF34', NULL, NULL, NULL, NULL, '', 247580),
(376740, 'PTHR33416:SF17', NULL, NULL, NULL, NULL, 'PROTEIN KAKU4', 247580),
(376741, 'PTHR33416:SF18', NULL, NULL, NULL, NULL, 'NUCLEOPORIN-LIKE PROTEIN', 247580),
(376742, 'PTHR44675:SF2', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 247581),
(376743, 'PTHR44675:SF1', NULL, NULL, NULL, NULL, 'P21-ACTIVATED PROTEIN KINASE-INTERACTING PROTEIN 1', 247581),
(376744, 'PTHR44675', NULL, NULL, NULL, NULL, 'PAK1 INTERACTING PROTEIN 1', 247581),
(376745, 'PTHR31223:SF81', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE', 247582),
(376746, 'PTHR31223:SF80', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE LOGL5-RELATED', 247582),
(376747, 'PTHR31223:SF72', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE LOG7', 247582),
(376748, 'PTHR31223:SF50', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE', 247582),
(376749, 'PTHR31223:SF71', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE', 247582),
(376750, 'PTHR31223:SF74', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE LOG4', 247582),
(376751, 'PTHR31223:SF51', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE LOG4-RELATED', 247582),
(376752, 'PTHR31223:SF76', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE', 247582),
(376753, 'PTHR31223:SF75', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE', 247582),
(376754, 'PTHR31223:SF56', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE', 247582),
(376755, 'PTHR31223:SF77', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE', 247582),
(376756, 'PTHR31223:SF11', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE LOG8-RELATED', 247582),
(376757, 'PTHR31223:SF55', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE LOGL8-RELATED', 247582),
(376758, 'PTHR31223:SF14', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE LOG5', 247582),
(376759, 'PTHR31223:SF58', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE', 247582),
(376760, 'PTHR31223:SF79', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE', 247582),
(376761, 'PTHR31223:SF57', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE', 247582),
(376762, 'PTHR31223:SF16', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE LOGL7-RELATED', 247582),
(376763, 'PTHR31223', NULL, NULL, NULL, NULL, 'LOG FAMILY PROTEIN YJL055W', 247582),
(376764, 'PTHR31223:SF70', NULL, NULL, NULL, NULL, 'LOG FAMILY PROTEIN YJL055W', 247582),
(376765, 'PTHR31223:SF83', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE LOGL6-RELATED', 247582),
(376766, 'PTHR31223:SF82', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE', 247582),
(376767, 'PTHR31223:SF85', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE', 247582),
(376768, 'PTHR31223:SF40', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE LOGL3-RELATED', 247582),
(376769, 'PTHR31223:SF84', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE', 247582),
(376770, 'PTHR31223:SF62', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE', 247582),
(376771, 'PTHR31223:SF65', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE LOG1', 247582);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(376772, 'PTHR31223:SF86', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE', 247582),
(376773, 'PTHR31223:SF64', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE', 247582),
(376774, 'PTHR31223:SF67', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE', 247582),
(376775, 'PTHR31223:SF69', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE LOG3', 247582),
(376776, 'PTHR31223:SF68', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE LOG2', 247582),
(376777, 'PTHR31223:SF48', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE', 247582),
(376778, 'PTHR23003:SF6', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN M', 247583),
(376779, 'PTHR23003:SF51', NULL, NULL, NULL, NULL, 'SERINE-ARGININE PROTEIN 55', 247583),
(376780, 'PTHR23003:SF50', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 247583),
(376781, 'PTHR23003:SF3', NULL, NULL, NULL, NULL, 'SERINE AND ARGININE-RICH-SPLICING FACTOR 5A', 247583),
(376782, 'PTHR23003:SF53', NULL, NULL, NULL, NULL, 'SERINE-ARGININE PROTEIN 55-LIKE PROTEIN', 247583),
(376783, 'PTHR23003:SF42', NULL, NULL, NULL, NULL, 'NUCLEOLIN', 247583),
(376784, 'PTHR23003:SF52', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR 6', 247583),
(376785, 'PTHR23003:SF33', NULL, NULL, NULL, NULL, 'OS08G0117100 PROTEIN', 247583),
(376786, 'PTHR23003:SF46', NULL, NULL, NULL, NULL, 'PROTEIN PAINTING OF FOURTH', 247583),
(376787, 'PTHR23003:SF35', NULL, NULL, NULL, NULL, 'OS08G0483200 PROTEIN', 247583),
(376788, 'PTHR23003:SF45', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR 4', 247583),
(376789, 'PTHR23003:SF15', NULL, NULL, NULL, NULL, 'MYELIN EXPRESSION FACTOR 2', 247583),
(376790, 'PTHR23003:SF48', NULL, NULL, NULL, NULL, 'SINGLE-STRANDED NUCLEIC ACID-BINDING PROTEIN', 247583),
(376791, 'PTHR23003:SF47', NULL, NULL, NULL, NULL, 'FI21236P1', 247583),
(376792, 'PTHR23003:SF17', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN PIN4', 247583),
(376793, 'PTHR23003:SF49', NULL, NULL, NULL, NULL, 'MULTIPLE RNA-BINDING DOMAIN-CONTAINING PROTEIN 1-RELATED', 247583),
(376794, 'PTHR23003', NULL, NULL, NULL, NULL, 'RNA RECOGNITION MOTIF  RRM  DOMAIN CONTAINING PROTEIN', 247583),
(376795, 'PTHR16487:SF0', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 4 REGULATORY SUBUNIT 2', 247584),
(376796, 'PTHR16487:SF3', NULL, NULL, NULL, NULL, '', 247584),
(376797, 'PTHR16487:SF1', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 4 REGULATORY SUBUNIT 2', 247584),
(376798, 'PTHR16487', NULL, NULL, NULL, NULL, 'PPP4R2-RELATED PROTEIN', 247584),
(376799, 'PTHR33973:SF4', NULL, NULL, NULL, NULL, 'OS07G0153300 PROTEIN', 247585),
(376800, 'PTHR33973', NULL, NULL, NULL, NULL, 'OS07G0153300 PROTEIN', 247585),
(376801, 'PTHR14965:SF1', NULL, NULL, NULL, NULL, 'APOPTOSIS FACILITATOR BCL-2-LIKE PROTEIN 14', 247586),
(376802, 'PTHR14965:SF2', NULL, NULL, NULL, NULL, 'BCL-2-LIKE PROTEIN 12', 247586),
(376803, 'PTHR14965:SF8', NULL, NULL, NULL, NULL, '', 247586),
(376804, 'PTHR14965', NULL, NULL, NULL, NULL, 'SI:CH73-248E21.1', 247586),
(376805, 'PTHR14965:SF7', NULL, NULL, NULL, NULL, '', 247586),
(376806, 'PTHR22750:SF20', NULL, NULL, NULL, NULL, 'SPHINGOSINE 1-PHOSPHATE RECEPTOR 5', 247587),
(376807, 'PTHR22750:SF49', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 247587),
(376808, 'PTHR22750:SF25', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 247587),
(376809, 'PTHR22750:SF47', NULL, NULL, NULL, NULL, 'CANNABINOID RECEPTOR 1', 247587),
(376810, 'PTHR22750:SF24', NULL, NULL, NULL, NULL, 'SPHINGOSINE 1-PHOSPHATE RECEPTOR 3', 247587),
(376811, 'PTHR22750:SF21', NULL, NULL, NULL, NULL, 'LYSOPHOSPHATIDIC ACID RECEPTOR 3', 247587),
(376812, 'PTHR22750:SF22', NULL, NULL, NULL, NULL, 'LYSOPHOSPHATIDIC ACID RECEPTOR 1', 247587),
(376813, 'PTHR22750', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR', 247587);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(376814, 'PTHR22750:SF5', NULL, NULL, NULL, NULL, 'MELANOCORTIN RECEPTOR 5', 247587),
(376815, 'PTHR22750:SF6', NULL, NULL, NULL, NULL, 'MELANOCORTIN RECEPTOR 4', 247587),
(376816, 'PTHR22750:SF7', NULL, NULL, NULL, NULL, 'GLUCOSE-DEPENDENT INSULINOTROPIC RECEPTOR', 247587),
(376817, 'PTHR22750:SF8', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 12', 247587),
(376818, 'PTHR22750:SF2', NULL, NULL, NULL, NULL, 'MELANOCYTE-STIMULATING HORMONE RECEPTOR', 247587),
(376819, 'PTHR22750:SF3', NULL, NULL, NULL, NULL, 'ADRENOCORTICOTROPIC HORMONE RECEPTOR', 247587),
(376820, 'PTHR22750:SF4', NULL, NULL, NULL, NULL, 'MELANOCORTIN RECEPTOR 3', 247587),
(376821, 'PTHR22750:SF52', NULL, NULL, NULL, NULL, 'SPHINGOSINE-1-PHOSPHATE RECEPTOR 3A', 247587),
(376822, 'PTHR22750:SF51', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 247587),
(376823, 'PTHR22750:SF38', NULL, NULL, NULL, NULL, 'LYSOPHOSPHATIDIC ACID RECEPTOR 2', 247587),
(376824, 'PTHR22750:SF16', NULL, NULL, NULL, NULL, 'SPHINGOSINE 1-PHOSPHATE RECEPTOR 1', 247587),
(376825, 'PTHR22750:SF39', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 3', 247587),
(376826, 'PTHR22750:SF17', NULL, NULL, NULL, NULL, 'SPHINGOSINE 1-PHOSPHATE RECEPTOR 2', 247587),
(376827, 'PTHR22750:SF58', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR 186', 247587),
(376828, 'PTHR22750:SF56', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 247587),
(376829, 'PTHR22750:SF13', NULL, NULL, NULL, NULL, 'SPHINGOSINE 1-PHOSPHATE RECEPTOR 4', 247587),
(376830, 'PTHR22750:SF57', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 247587),
(376831, 'PTHR22750:SF10', NULL, NULL, NULL, NULL, 'CANNABINOID RECEPTOR 2', 247587),
(376832, 'PTHR22750:SF19', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 6', 247587),
(376833, 'PTHR21608:SF8', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF26B', 247588),
(376834, 'PTHR21608', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247588),
(376835, 'PTHR21608:SF5', NULL, NULL, NULL, NULL, 'KINESIN FAMILY MEMBER 26AA', 247588),
(376836, 'PTHR21608:SF7', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN CG14535', 247588),
(376837, 'PTHR21608:SF6', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF26A', 247588),
(376838, 'PTHR42811:SF20', NULL, NULL, NULL, NULL, 'SERINE O-ACETYLTRANSFERASE', 247589),
(376839, 'PTHR42811:SF8', NULL, NULL, NULL, NULL, 'SERINE ACETYLTRANSFERASE 2-RELATED', 247589),
(376840, 'PTHR42811:SF5', NULL, NULL, NULL, NULL, 'SERINE ACETYLTRANSFERASE-RELATED', 247589),
(376841, 'PTHR42811', NULL, NULL, NULL, NULL, 'SERINE ACETYLTRANSFERASE', 247589),
(376842, 'PTHR42811:SF27', NULL, NULL, NULL, NULL, 'SERINE O-ACETYLTRANSFERASE', 247589),
(376843, 'PTHR42811:SF16', NULL, NULL, NULL, NULL, 'SERINE O-ACETYLTRANSFERASE', 247589),
(376844, 'PTHR42811:SF17', NULL, NULL, NULL, NULL, 'SERINE O-ACETYLTRANSFERASE', 247589),
(376845, 'PTHR42811:SF25', NULL, NULL, NULL, NULL, 'SERINE O-ACETYLTRANSFERASE', 247589),
(376846, 'PTHR42811:SF26', NULL, NULL, NULL, NULL, 'SERINE O-ACETYLTRANSFERASE', 247589),
(376847, 'PTHR42811:SF15', NULL, NULL, NULL, NULL, 'SERINE O-ACETYLTRANSFERASE', 247589),
(376848, 'PTHR42811:SF12', NULL, NULL, NULL, NULL, 'SERINE O-ACETYLTRANSFERASE', 247589),
(376849, 'PTHR42811:SF23', NULL, NULL, NULL, NULL, 'SERINE ACETYLTRANSFERASE 1-RELATED', 247589),
(376850, 'PTHR42811:SF24', NULL, NULL, NULL, NULL, 'SERINE O-ACETYLTRANSFERASE', 247589),
(376851, 'PTHR42811:SF21', NULL, NULL, NULL, NULL, 'SERINE O-ACETYLTRANSFERASE', 247589),
(376852, 'PTHR42811:SF10', NULL, NULL, NULL, NULL, 'SERINE ACETYLTRANSFERASE 3, MITOCHONDRIAL', 247589),
(376853, 'PTHR42811:SF22', NULL, NULL, NULL, NULL, 'SERINE O-ACETYLTRANSFERASE', 247589),
(376854, 'PTHR42811:SF11', NULL, NULL, NULL, NULL, 'SERINE ACETYLTRANSFERASE 1, CHLOROPLASTIC', 247589),
(376855, 'PTHR12776:SF2', NULL, NULL, NULL, NULL, 'KAZRIN, PERIPLAKIN-INTERACTING PROTEIN B', 247590),
(376856, 'PTHR12776:SF3', NULL, NULL, NULL, NULL, 'KAZRIN-A', 247590),
(376857, 'PTHR12776:SF1', NULL, NULL, NULL, NULL, 'KAZRIN', 247590);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(376858, 'PTHR12776', NULL, NULL, NULL, NULL, 'KAZRIN-RELATED', 247590),
(376859, 'PTHR34023:SF6', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 247591),
(376860, 'PTHR34023:SF5', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 247591),
(376861, 'PTHR34023:SF4', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 247591),
(376862, 'PTHR34023:SF7', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 247591),
(376863, 'PTHR34023', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 247591),
(376864, 'PTHR14324:SF4', NULL, NULL, NULL, NULL, 'CONDENSIN-2 COMPLEX SUBUNIT H2', 247592),
(376865, 'PTHR14324:SF3', NULL, NULL, NULL, NULL, 'CONDENSIN-2 COMPLEX SUBUNIT H2', 247592),
(376866, 'PTHR14324', NULL, NULL, NULL, NULL, 'CONDENSIN-2 COMPLEX SUBUNIT H2', 247592),
(376867, 'PTHR19304:SF10', NULL, NULL, NULL, NULL, 'CYCLIC AMP-DEPENDENT TRANSCRIPTION FACTOR ATF-7', 247593),
(376868, 'PTHR19304:SF43', NULL, NULL, NULL, NULL, 'ATFA', 247593),
(376869, 'PTHR19304', NULL, NULL, NULL, NULL, 'CYCLIC-AMP RESPONSE ELEMENT BINDING PROTEIN', 247593),
(376870, 'PTHR19304:SF9', NULL, NULL, NULL, NULL, 'CYCLIC AMP-DEPENDENT TRANSCRIPTION FACTOR ATF-2', 247593),
(376871, 'PTHR19304:SF40', NULL, NULL, NULL, NULL, 'ATF/CREB ACTIVATOR 1-RELATED', 247593),
(376872, 'PTHR19304:SF8', NULL, NULL, NULL, NULL, 'CYCLIC AMP-RESPONSIVE ELEMENT-BINDING PROTEIN 5', 247593),
(376873, 'PTHR19304:SF5', NULL, NULL, NULL, NULL, 'ACTIVATING TRANSCRIPTION FACTOR-2', 247593),
(376874, 'PTHR19304:SF45', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 247593),
(376875, 'PTHR19304:SF44', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR ATF1-RELATED', 247593),
(376876, 'PTHR30446', NULL, NULL, NULL, NULL, 'RECOMBINATION PROTEIN RECR', 247594),
(376877, 'PTHR30446:SF0', NULL, NULL, NULL, NULL, 'RECOMBINATION PROTEIN RECR', 247594),
(376878, 'PTHR46384:SF1', NULL, NULL, NULL, NULL, 'MOTILE SPERM DOMAIN-CONTAINING PROTEIN 2', 247595),
(376879, 'PTHR46384:SF2', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 247595),
(376880, 'PTHR46384', NULL, NULL, NULL, NULL, 'MOTILE SPERM DOMAIN-CONTAINING PROTEIN 2', 247595),
(376881, 'PTHR31881:SF20', NULL, NULL, NULL, NULL, '', 247596),
(376882, 'PTHR31881:SF21', NULL, NULL, NULL, NULL, 'PLANT/F12B17-70 PROTEIN', 247596),
(376883, 'PTHR31881:SF19', NULL, NULL, NULL, NULL, '', 247596),
(376884, 'PTHR31881:SF6', NULL, NULL, NULL, NULL, 'OS09G0494600 PROTEIN', 247596),
(376885, 'PTHR31881:SF15', NULL, NULL, NULL, NULL, 'PLANT/F12B17-70 PROTEIN', 247596),
(376886, 'PTHR31881:SF17', NULL, NULL, NULL, NULL, '', 247596),
(376887, 'PTHR31881:SF18', NULL, NULL, NULL, NULL, 'BNAC02G00230D PROTEIN', 247596),
(376888, 'PTHR31881:SF9', NULL, NULL, NULL, NULL, 'OS08G0521000 PROTEIN', 247596),
(376889, 'PTHR31881', NULL, NULL, NULL, NULL, '', 247596),
(376890, 'PTHR31881:SF11', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 247596),
(376891, 'PTHR31881:SF12', NULL, NULL, NULL, NULL, 'PLANT/F12B17-70 PROTEIN', 247596),
(376892, 'PTHR31881:SF13', NULL, NULL, NULL, NULL, '', 247596),
(376893, 'PTHR46747', NULL, NULL, NULL, NULL, 'ALPHA-PROTEIN KINASE 1', 247597),
(376894, 'PTHR46747:SF1', NULL, NULL, NULL, NULL, 'ALPHA-PROTEIN KINASE 1', 247597),
(376895, 'PTHR30238:SF0', NULL, NULL, NULL, NULL, 'THYLAKOID MEMBRANE PROTEIN TERC, CHLOROPLASTIC', 247598),
(376896, 'PTHR30238', NULL, NULL, NULL, NULL, 'MEMBRANE BOUND PREDICTED REDOX MODULATOR', 247598),
(376897, 'PTHR30238:SF6', NULL, NULL, NULL, NULL, 'TERC-LIKE PROTEIN', 247598),
(376898, 'PTHR30238:SF4', NULL, NULL, NULL, NULL, 'SLL1022 PROTEIN', 247598),
(376899, 'PTHR46727:SF3', NULL, NULL, NULL, NULL, 'CHROMOBOX PROTEIN HOMOLOG 7', 247599),
(376900, 'PTHR46727', NULL, NULL, NULL, NULL, 'E3 SUMO-PROTEIN LIGASE CBX4', 247599),
(376901, 'PTHR46727:SF1', NULL, NULL, NULL, NULL, 'E3 SUMO-PROTEIN LIGASE CBX4', 247599),
(376902, 'PTHR23073:SF85', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 247600),
(376903, 'PTHR23073:SF127', NULL, NULL, NULL, NULL, '26S PROTEASOME REGULATORY SUBUNIT 6A HOMOLOG B', 247600);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(376904, 'PTHR23073:SF126', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 247600),
(376905, 'PTHR23073:SF129', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 247600),
(376906, 'PTHR23073:SF8', NULL, NULL, NULL, NULL, '26S PROTEASOME REGULATORY SUBUNIT 6B HOMOLOG', 247600),
(376907, 'PTHR23073', NULL, NULL, NULL, NULL, '26S PROTEASOME REGULATORY SUBUNIT', 247600),
(376908, 'PTHR23073:SF7', NULL, NULL, NULL, NULL, '26S PROTEASOME REGULATORY SUBUNIT 6A', 247600),
(376909, 'PTHR23073:SF89', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 247600),
(376910, 'PTHR23073:SF88', NULL, NULL, NULL, NULL, '26S PROTEASE REGULATORY SUBUNIT S10B HOMOLOG B', 247600),
(376911, 'PTHR23073:SF96', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 247600),
(376912, 'PTHR23073:SF157', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 247600),
(376913, 'PTHR23073:SF156', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 247600),
(376914, 'PTHR23073:SF95', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 247600),
(376915, 'PTHR23073:SF155', NULL, NULL, NULL, NULL, '26S PROTEASOME REGULATORY SUBUNIT 6B', 247600),
(376916, 'PTHR23073:SF111', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 247600),
(376917, 'PTHR23073:SF154', NULL, NULL, NULL, NULL, '26S PROTEASOME REGULATORY SUBUNIT 4 HOMOLOG A-LIKE', 247600),
(376918, 'PTHR23073:SF110', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 247600),
(376919, 'PTHR23073:SF115', NULL, NULL, NULL, NULL, 'OS09G0560200 PROTEIN', 247600),
(376920, 'PTHR23073:SF114', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 247600),
(376921, 'PTHR23073:SF90', NULL, NULL, NULL, NULL, '26S PROTEASOME REGULATORY SUBUNIT 6A', 247600),
(376922, 'PTHR23073:SF12', NULL, NULL, NULL, NULL, '26S PROTEASOME REGULATORY SUBUNIT 8', 247600),
(376923, 'PTHR23073:SF13', NULL, NULL, NULL, NULL, '26S PROTEASOME REGULATORY SUBUNIT 7', 247600),
(376924, 'PTHR23073:SF146', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 247600),
(376925, 'PTHR23073:SF101', NULL, NULL, NULL, NULL, 'OS04G0284600 PROTEIN', 247600),
(376926, 'PTHR23073:SF145', NULL, NULL, NULL, NULL, '26S PROTEASOME REGULATORY SUBUNIT 10B HOMOLOG A', 247600),
(376927, 'PTHR23073:SF64', NULL, NULL, NULL, NULL, 'TRANSITIONAL ENDOPLASMIC RETICULUM ATPASE', 247600),
(376928, 'PTHR23073:SF106', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 247600),
(376929, 'PTHR23073:SF149', NULL, NULL, NULL, NULL, '26S PROTEASOME REGULATORY SUBUNIT 4 HOMOLOG A-RELATED', 247600),
(376930, 'PTHR23073:SF148', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 247600),
(376931, 'PTHR23073:SF147', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 247600),
(376932, 'PTHR23073:SF103', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 247600),
(376933, 'PTHR23073:SF27', NULL, NULL, NULL, NULL, '26S PROTEASOME REGULATORY SUBUNIT HOMOLOG MJ1494-RELATED', 247600),
(376934, 'PTHR23073:SF26', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 247600),
(376935, 'PTHR23073:SF153', NULL, NULL, NULL, NULL, '26S PROTEASOME REGULATORY COMPLEX PROTEIN', 247600),
(376936, 'PTHR23073:SF152', NULL, NULL, NULL, NULL, 'BNAA02G17210D PROTEIN', 247600),
(376937, 'PTHR23073:SF151', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 247600),
(376938, 'PTHR23073:SF150', NULL, NULL, NULL, NULL, 'PROTEASE REGULATORY SUBUNIT 4, PUTATIVE, EXPRESSED-RELATED', 247600),
(376939, 'PTHR23073:SF24', NULL, NULL, NULL, NULL, '26S PROTEASOME REGULATORY SUBUNIT 4', 247600),
(376940, 'PTHR23073:SF135', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 247600),
(376941, 'PTHR23073:SF74', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 247600),
(376942, 'PTHR23073:SF134', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 247600),
(376943, 'PTHR23073:SF76', NULL, NULL, NULL, NULL, '26S PROTEASOME REGULATORY SUBUNIT 10B', 247600),
(376944, 'PTHR23073:SF31', NULL, NULL, NULL, NULL, '26S PROTEASOME REGULATORY SUBUNIT 10B', 247600),
(376945, 'PTHR23073:SF70', NULL, NULL, NULL, NULL, 'ATPASE_AAA_CORE DOMAIN-CONTAINING PROTEIN', 247600);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(376946, 'PTHR23073:SF138', NULL, NULL, NULL, NULL, '26S PROTEASE REGULATORY SUBUNIT 7 HOMOLOG A-LIKE', 247600),
(376947, 'PTHR23073:SF137', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 247600),
(376948, 'PTHR23073:SF78', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 247600),
(376949, 'PTHR23073:SF77', NULL, NULL, NULL, NULL, '26S PROTEASOME REGULATORY SUBUNIT 4', 247600),
(376950, 'PTHR23073:SF140', NULL, NULL, NULL, NULL, 'PROTEASOME-ACTIVATING NUCLEOTIDASE 1', 247600),
(376951, 'PTHR23073:SF79', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 247600),
(376952, 'PTHR23035:SF1', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 97', 247601),
(376953, 'PTHR23035', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247601),
(376954, 'PTHR23035:SF2', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 97', 247601),
(376955, 'PTHR12435:SF4', NULL, NULL, NULL, NULL, 'BNAC08G40070D PROTEIN', 247602),
(376956, 'PTHR12435:SF2', NULL, NULL, NULL, NULL, 'PROTEIN KTI12 HOMOLOG', 247602),
(376957, 'PTHR12435', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247602),
(376958, 'PTHR43461:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 256', 247603),
(376959, 'PTHR43461', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 256', 247603),
(376960, 'PTHR31169:SF23', NULL, NULL, NULL, NULL, 'OS03G0572250 PROTEIN', 247604),
(376961, 'PTHR31169:SF34', NULL, NULL, NULL, NULL, 'ZF-4CXXC_R1 DOMAIN-CONTAINING PROTEIN', 247604),
(376962, 'PTHR31169:SF24', NULL, NULL, NULL, NULL, 'ZF-4CXXC_R1 DOMAIN-CONTAINING PROTEIN', 247604),
(376963, 'PTHR31169:SF35', NULL, NULL, NULL, NULL, 'DDT DOMAIN-CONTAINING PROTEIN', 247604),
(376964, 'PTHR31169:SF32', NULL, NULL, NULL, NULL, 'ZINC-FINGER DOMAIN OF MONOAMINE-OXIDASE A REPRESSOR R1', 247604),
(376965, 'PTHR31169:SF22', NULL, NULL, NULL, NULL, 'ZINC-FINGER DOMAIN OF MONOAMINE-OXIDASE A REPRESSOR R1 PROTEIN-RELATED', 247604),
(376966, 'PTHR31169:SF33', NULL, NULL, NULL, NULL, 'ZF-4CXXC_R1 DOMAIN-CONTAINING PROTEIN', 247604),
(376967, 'PTHR31169:SF31', NULL, NULL, NULL, NULL, 'DDT DOMAIN-CONTAINING PROTEIN', 247604),
(376968, 'PTHR31169:SF4', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE-ASSOCIATED 7-LIKE PROTEIN', 247604),
(376969, 'PTHR31169:SF18', NULL, NULL, NULL, NULL, 'DDT DOMAIN-CONTAINING PROTEIN', 247604),
(376970, 'PTHR31169:SF2', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE-ASSOCIATED PROTEIN 7', 247604),
(376971, 'PTHR31169:SF27', NULL, NULL, NULL, NULL, 'DDT DOMAIN-CONTAINING PROTEIN', 247604),
(376972, 'PTHR31169:SF15', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247604),
(376973, 'PTHR31169', NULL, NULL, NULL, NULL, 'OS05G0300700 PROTEIN', 247604),
(376974, 'PTHR31169:SF8', NULL, NULL, NULL, NULL, 'ZINC-FINGER DOMAIN OF MONOAMINE-OXIDASE A REPRESSOR R1 PROTEIN', 247604),
(376975, 'PTHR35375:SF2', NULL, NULL, NULL, NULL, 'NEMATODE SPECIFIC PEPTIDE FAMILY, GROUP D', 247605),
(376976, 'PTHR35375', NULL, NULL, NULL, NULL, 'NEMATODE SPECIFIC PEPTIDE FAMILY, GROUP D', 247605),
(376977, 'PTHR30009:SF4', NULL, NULL, NULL, NULL, 'PTS SYSTEM N-ACETYLGLUCOSAMINE-SPECIFIC EIICBA COMPONENT', 247606),
(376978, 'PTHR30009:SF20', NULL, NULL, NULL, NULL, 'PTS SYSTEM GLUCOSE-SPECIFIC EIICB COMPONENT-RELATED', 247606),
(376979, 'PTHR30009', NULL, NULL, NULL, NULL, 'CYTOCHROME C-TYPE SYNTHESIS PROTEIN AND PTS TRANSMEMBRANE COMPONENT', 247606),
(376980, 'PTHR30009:SF8', NULL, NULL, NULL, NULL, 'PTS SYSTEM, IIBC COMPONENT', 247606),
(376981, 'PTHR30009:SF24', NULL, NULL, NULL, NULL, 'PTS SYSTEM, IIBC COMPONENT', 247606),
(376982, 'PTHR30009:SF12', NULL, NULL, NULL, NULL, 'PHOSPHOTRANSFERASE IIC COMPONENT GLVC', 247606),
(376983, 'PTHR43041', NULL, NULL, NULL, NULL, 'HYDROLASE, METALLO-BETA-LACTAMASE SUPERFAMILY', 247607),
(376984, 'PTHR43041:SF1', NULL, NULL, NULL, NULL, 'LACTAMASE_B DOMAIN-CONTAINING PROTEIN', 247607),
(376985, 'PTHR31391:SF150', NULL, NULL, NULL, NULL, '', 247608),
(376986, 'PTHR31391:SF151', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN REM19-LIKE', 247608),
(376987, 'PTHR31391:SF149', NULL, NULL, NULL, NULL, 'DNA-BINDING PSEUDOBARREL DOMAIN-CONTAINING PROTEIN-RELATED', 247608);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(376988, 'PTHR31391:SF105', NULL, NULL, NULL, NULL, '', 247608),
(376989, 'PTHR31391:SF106', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS01G0723500', 247608),
(376990, 'PTHR31391:SF107', NULL, NULL, NULL, NULL, 'DNA-BINDING PSEUDOBARREL DOMAIN-CONTAINING PROTEIN-RELATED', 247608),
(376991, 'PTHR31391:SF108', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS01G0905400-LIKE ISOFORM X1', 247608),
(376992, 'PTHR31391:SF109', NULL, NULL, NULL, NULL, '', 247608),
(376993, 'PTHR31391:SF141', NULL, NULL, NULL, NULL, '', 247608),
(376994, 'PTHR31391:SF64', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS06G0112300', 247608),
(376995, 'PTHR31391:SF142', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS01G0234100', 247608),
(376996, 'PTHR31391:SF65', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN', 247608),
(376997, 'PTHR31391:SF143', NULL, NULL, NULL, NULL, 'B3 DNA-BINDING DOMAIN PROTEIN', 247608),
(376998, 'PTHR31391:SF67', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 247608),
(376999, 'PTHR31391:SF144', NULL, NULL, NULL, NULL, '', 247608),
(377000, 'PTHR31391:SF23', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS03G0619800', 247608),
(377001, 'PTHR31391:SF101', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 247608),
(377002, 'PTHR31391:SF145', NULL, NULL, NULL, NULL, '', 247608),
(377003, 'PTHR31391:SF146', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 247608),
(377004, 'PTHR31391:SF147', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 247608),
(377005, 'PTHR31391:SF148', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 247608),
(377006, 'PTHR31391:SF79', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 247608),
(377007, 'PTHR31391:SF3', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS05G0481400', 247608),
(377008, 'PTHR31391:SF4', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS03G0184500', 247608),
(377009, 'PTHR31391:SF140', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS12G0591400', 247608),
(377010, 'PTHR31391:SF70', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS03G0622200', 247608),
(377011, 'PTHR31391:SF131', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 247608),
(377012, 'PTHR31391:SF77', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 247608),
(377013, 'PTHR31391:SF132', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS08G0325100-RELATED', 247608),
(377014, 'PTHR31391:SF134', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS04G0386900', 247608),
(377015, 'PTHR31391:SF135', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 247608),
(377016, 'PTHR31391:SF137', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING TRANSCRIPTION FACTOR VRN1-LIKE ISOFORM X1', 247608),
(377017, 'PTHR31391', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS11G0197600-RELATED', 247608),
(377018, 'PTHR31391:SF48', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS03G0620500', 247608),
(377019, 'PTHR31391:SF128', NULL, NULL, NULL, NULL, '', 247608),
(377020, 'PTHR31391:SF129', NULL, NULL, NULL, NULL, '', 247608),
(377021, 'PTHR31391:SF81', NULL, NULL, NULL, NULL, 'DNA BINDING PROTEIN', 247608),
(377022, 'PTHR31391:SF87', NULL, NULL, NULL, NULL, '', 247608),
(377023, 'PTHR31391:SF121', NULL, NULL, NULL, NULL, '', 247608),
(377024, 'PTHR31391:SF88', NULL, NULL, NULL, NULL, 'DNA-BINDING PSEUDOBARREL DOMAIN-CONTAINING PROTEIN-RELATED', 247608),
(377025, 'PTHR31391:SF122', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 247608),
(377026, 'PTHR31391:SF83', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE-RELATED', 247608),
(377027, 'PTHR31391:SF124', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS01G0905400', 247608),
(377028, 'PTHR31391:SF85', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 247608),
(377029, 'PTHR31391:SF116', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN-RELATED', 247608),
(377030, 'PTHR31391:SF90', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 247608);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(377031, 'PTHR31391:SF117', NULL, NULL, NULL, NULL, '', 247608),
(377032, 'PTHR31391:SF91', NULL, NULL, NULL, NULL, '', 247608),
(377033, 'PTHR31391:SF152', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 247608),
(377034, 'PTHR31391:SF10', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 247608),
(377035, 'PTHR31391:SF153', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN', 247608),
(377036, 'PTHR31391:SF99', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS06G0194400', 247608),
(377037, 'PTHR31391:SF154', NULL, NULL, NULL, NULL, '', 247608),
(377038, 'PTHR31391:SF155', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS11G0197600', 247608),
(377039, 'PTHR31391:SF156', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 247608),
(377040, 'PTHR31391:SF93', NULL, NULL, NULL, NULL, '', 247608),
(377041, 'PTHR31391:SF157', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN REM16', 247608),
(377042, 'PTHR31391:SF95', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 247608),
(377043, 'PTHR31391:SF158', NULL, NULL, NULL, NULL, '', 247608),
(377044, 'PTHR37175', NULL, NULL, NULL, NULL, 'BNAA08G28800D PROTEIN', 247609),
(377045, 'PTHR37175:SF1', NULL, NULL, NULL, NULL, 'CONSTANS-LIKE PROTEIN-RELATED', 247609),
(377046, 'PTHR46603', NULL, NULL, NULL, NULL, 'ABSCISSION/NOCUT CHECKPOINT REGULATOR', 247610),
(377047, 'PTHR46603:SF1', NULL, NULL, NULL, NULL, 'ABSCISSION/NOCUT CHECKPOINT REGULATOR', 247610),
(377048, 'PTHR15221', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX SUBUNIT 3', 247611),
(377049, 'PTHR15221:SF0', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX SUBUNIT 3', 247611),
(377050, 'PTHR34611:SF2', NULL, NULL, NULL, NULL, 'INACTIVE RECOMBINATION-PROMOTING NUCLEASE-LIKE PROTEIN RPNE-RELATED', 247612),
(377051, 'PTHR34611', NULL, NULL, NULL, NULL, '', 247612),
(377052, 'PTHR34611:SF3', NULL, NULL, NULL, NULL, 'RECOMBINATION-PROMOTING NUCLEASE PSLT051', 247612),
(377053, 'PTHR46256:SF1', NULL, NULL, NULL, NULL, 'MYOSIN-IIIB', 247613),
(377054, 'PTHR46256', NULL, NULL, NULL, NULL, 'AGAP011099-PA', 247613),
(377055, 'PTHR46256:SF4', NULL, NULL, NULL, NULL, 'MYOSIN-IIIA', 247613),
(377056, 'PTHR46256:SF3', NULL, NULL, NULL, NULL, 'MYOSIN III', 247613),
(377057, 'PTHR46256:SF2', NULL, NULL, NULL, NULL, 'NEITHER INACTIVATION NOR AFTERPOTENTIAL PROTEIN C', 247613),
(377058, 'PTHR33494:SF26', NULL, NULL, NULL, NULL, '', 247614),
(377059, 'PTHR33494:SF16', NULL, NULL, NULL, NULL, '', 247614),
(377060, 'PTHR33494:SF27', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 247614),
(377061, 'PTHR33494:SF17', NULL, NULL, NULL, NULL, 'BNAC03G67900D PROTEIN', 247614),
(377062, 'PTHR33494:SF28', NULL, NULL, NULL, NULL, '', 247614),
(377063, 'PTHR33494:SF29', NULL, NULL, NULL, NULL, '', 247614),
(377064, 'PTHR33494:SF13', NULL, NULL, NULL, NULL, '', 247614),
(377065, 'PTHR33494:SF14', NULL, NULL, NULL, NULL, 'BNAC05G19210D PROTEIN', 247614),
(377066, 'PTHR33494:SF30', NULL, NULL, NULL, NULL, '', 247614),
(377067, 'PTHR33494:SF20', NULL, NULL, NULL, NULL, 'BNAA01G06350D PROTEIN', 247614),
(377068, 'PTHR33494:SF1', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', 247614),
(377069, 'PTHR33494:SF21', NULL, NULL, NULL, NULL, '', 247614),
(377070, 'PTHR33494:SF7', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 247614),
(377071, 'PTHR33494:SF5', NULL, NULL, NULL, NULL, 'F10A16.6 PROTEIN', 247614),
(377072, 'PTHR33494', NULL, NULL, NULL, NULL, 'OS02G0793800 PROTEIN', 247614),
(377073, 'PTHR33494:SF8', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 247614),
(377074, 'PTHR28246:SF1', NULL, NULL, NULL, NULL, 'G1-SPECIFIC TRANSCRIPTIONAL REPRESSOR WHI5-RELATED', 247615),
(377075, 'PTHR28246', NULL, NULL, NULL, NULL, 'G1-SPECIFIC TRANSCRIPTIONAL REPRESSOR WHI5-RELATED', 247615),
(377076, 'PTHR12665:SF25', NULL, NULL, NULL, NULL, 'ORMDL FAMILY-RELATED', 247616),
(377077, 'PTHR12665:SF15', NULL, NULL, NULL, NULL, 'OS07G0452500 PROTEIN', 247616),
(377078, 'PTHR12665:SF23', NULL, NULL, NULL, NULL, 'ORM1-LIKE PROTEIN 2', 247616);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(377079, 'PTHR12665:SF12', NULL, NULL, NULL, NULL, 'ORM1-LIKE PROTEIN 1', 247616),
(377080, 'PTHR12665:SF24', NULL, NULL, NULL, NULL, 'BNAANNG20920D PROTEIN', 247616),
(377081, 'PTHR12665:SF13', NULL, NULL, NULL, NULL, 'ORM1-LIKE PROTEIN 2', 247616),
(377082, 'PTHR12665:SF29', NULL, NULL, NULL, NULL, '', 247616),
(377083, 'PTHR12665:SF28', NULL, NULL, NULL, NULL, 'ORMDL FAMILY PROTEIN', 247616),
(377084, 'PTHR12665:SF22', NULL, NULL, NULL, NULL, 'BNACNNG08600D PROTEIN', 247616),
(377085, 'PTHR12665:SF11', NULL, NULL, NULL, NULL, 'ORM1-LIKE PROTEIN 3', 247616),
(377086, 'PTHR12665:SF30', NULL, NULL, NULL, NULL, 'ORM1-LIKE PROTEIN 2', 247616),
(377087, 'PTHR12665:SF7', NULL, NULL, NULL, NULL, 'ORM1-LIKE PROTEIN', 247616),
(377088, 'PTHR12665', NULL, NULL, NULL, NULL, 'ORMDL PROTEINS', 247616),
(377089, 'PTHR45886:SF8', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 247617),
(377090, 'PTHR45886:SF9', NULL, NULL, NULL, NULL, 'NR LBD DOMAIN-CONTAINING PROTEIN-RELATED', 247617),
(377091, 'PTHR45886:SF6', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 247617),
(377092, 'PTHR45886:SF7', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 247617),
(377093, 'PTHR45886', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY-RELATED-RELATED', 247617),
(377094, 'PTHR45886:SF12', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 247617),
(377095, 'PTHR45886:SF11', NULL, NULL, NULL, NULL, 'NR LBD DOMAIN-CONTAINING PROTEIN-RELATED', 247617),
(377096, 'PTHR45886:SF1', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 247617),
(377097, 'PTHR45886:SF10', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 247617),
(377098, 'PTHR45886:SF5', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 247617),
(377099, 'PTHR45886:SF2', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY-RELATED', 247617),
(377100, 'PTHR45886:SF3', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 247617),
(377101, 'PTHR45886:SF17', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-9', 247617),
(377102, 'PTHR45886:SF16', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 247617),
(377103, 'PTHR45886:SF15', NULL, NULL, NULL, NULL, 'NR LBD DOMAIN-CONTAINING PROTEIN', 247617),
(377104, 'PTHR45886:SF14', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY-RELATED', 247617),
(377105, 'PTHR45886:SF13', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 247617),
(377106, 'PTHR45647:SF100', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 36-RELATED', 247618),
(377107, 'PTHR45647:SF141', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 52-LIKE ISOFORM X1', 247618),
(377108, 'PTHR45647:SF140', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247618),
(377109, 'PTHR45647:SF71', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247618),
(377110, 'PTHR45647:SF73', NULL, NULL, NULL, NULL, 'KINASE WITH ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE DOMAIN-CONTAINING PROTEIN', 247618),
(377111, 'PTHR45647:SF72', NULL, NULL, NULL, NULL, 'U-BOX KINASE FAMILY PROTEIN', 247618),
(377112, 'PTHR45647:SF63', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 51', 247618),
(377113, 'PTHR45647:SF22', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 32', 247618),
(377114, 'PTHR45647:SF66', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 57-RELATED', 247618),
(377115, 'PTHR45647:SF65', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 34', 247618),
(377116, 'PTHR45647:SF67', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE', 247618),
(377117, 'PTHR45647:SF25', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN', 247618),
(377118, 'PTHR45647:SF28', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 33-LIKE', 247618),
(377119, 'PTHR45647:SF109', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE', 247618),
(377120, 'PTHR45647:SF3', NULL, NULL, NULL, NULL, 'OS10G0552400 PROTEIN', 247618),
(377121, 'PTHR45647:SF29', NULL, NULL, NULL, NULL, 'KINASE WITH ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE DOMAIN-CONTAINING PROTEIN', 247618);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(377122, 'PTHR45647:SF105', NULL, NULL, NULL, NULL, 'BNAA09G52450D PROTEIN', 247618),
(377123, 'PTHR45647:SF7', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 70', 247618),
(377124, 'PTHR45647:SF103', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247618),
(377125, 'PTHR45647:SF102', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE', 247618),
(377126, 'PTHR45647:SF112', NULL, NULL, NULL, NULL, 'BNAA06G16210D PROTEIN', 247618),
(377127, 'PTHR45647:SF111', NULL, NULL, NULL, NULL, 'KINASE WITH ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE DOMAIN-CONTAINING PROTEIN', 247618),
(377128, 'PTHR45647', NULL, NULL, NULL, NULL, 'OS02G0152300 PROTEIN', 247618),
(377129, 'PTHR45647:SF80', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 52', 247618),
(377130, 'PTHR45647:SF84', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 52-LIKE ISOFORM X1', 247618),
(377131, 'PTHR45647:SF83', NULL, NULL, NULL, NULL, 'SERINE THREONINE KINASE', 247618),
(377132, 'PTHR45647:SF31', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247618),
(377133, 'PTHR45647:SF30', NULL, NULL, NULL, NULL, 'KINASE WITH ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE DOMAIN-CONTAINING PROTEIN', 247618),
(377134, 'PTHR45647:SF76', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247618),
(377135, 'PTHR45647:SF32', NULL, NULL, NULL, NULL, 'KINASE WITH ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE DOMAIN-CONTAINING PROTEIN', 247618),
(377136, 'PTHR45647:SF35', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 55-RELATED', 247618),
(377137, 'PTHR45647:SF79', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247618),
(377138, 'PTHR45647:SF78', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247618),
(377139, 'PTHR45647:SF34', NULL, NULL, NULL, NULL, 'U-BOX KINASE FAMILY PROTEIN', 247618),
(377140, 'PTHR45647:SF37', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 35-LIKE', 247618),
(377141, 'PTHR45647:SF36', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASE-LIKE DOMAIN KINASE', 247618),
(377142, 'PTHR45647:SF39', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 34-LIKE', 247618),
(377143, 'PTHR45647:SF38', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE', 247618),
(377144, 'PTHR45647:SF118', NULL, NULL, NULL, NULL, 'OS01G0581400 PROTEIN', 247618),
(377145, 'PTHR45647:SF117', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247618),
(377146, 'PTHR45647:SF114', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE', 247618),
(377147, 'PTHR45647:SF123', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE', 247618),
(377148, 'PTHR45647:SF121', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE', 247618),
(377149, 'PTHR45647:SF91', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247618),
(377150, 'PTHR45647:SF93', NULL, NULL, NULL, NULL, 'KINASE WITH ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE DOMAIN-CONTAINING PROTEIN', 247618),
(377151, 'PTHR45647:SF92', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE', 247618),
(377152, 'PTHR45647:SF95', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN', 247618),
(377153, 'PTHR45647:SF51', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 247618),
(377154, 'PTHR45647:SF94', NULL, NULL, NULL, NULL, 'OS06G0191900 PROTEIN', 247618),
(377155, 'PTHR45647:SF50', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 57', 247618),
(377156, 'PTHR45647:SF41', NULL, NULL, NULL, NULL, 'OS02G0218400 PROTEIN', 247618),
(377157, 'PTHR45647:SF43', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE', 247618),
(377158, 'PTHR45647:SF87', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 35-LIKE', 247618),
(377159, 'PTHR45647:SF46', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE', 247618),
(377160, 'PTHR45647:SF45', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 33-LIKE', 247618),
(377161, 'PTHR45647:SF47', NULL, NULL, NULL, NULL, 'KINASE WITH ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE DOMAIN-CONTAINING PROTEIN', 247618),
(377162, 'PTHR45647:SF129', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247618);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(377163, 'PTHR45647:SF128', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE', 247618),
(377164, 'PTHR45647:SF125', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247618),
(377165, 'PTHR45647:SF124', NULL, NULL, NULL, NULL, 'BNAC04G04610D PROTEIN', 247618),
(377166, 'PTHR45647:SF134', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 33', 247618),
(377167, 'PTHR45647:SF133', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE', 247618),
(377168, 'PTHR45647:SF132', NULL, NULL, NULL, NULL, 'KINASE WITH ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE DOMAIN-CONTAINING PROTEIN', 247618),
(377169, 'PTHR45647:SF131', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE', 247618),
(377170, 'PTHR45647:SF130', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE', 247618),
(377171, 'PTHR45647:SF62', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 56', 247618),
(377172, 'PTHR45647:SF97', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE', 247618),
(377173, 'PTHR45647:SF96', NULL, NULL, NULL, NULL, 'PROTEIN KINASE FAMILY PROTEIN', 247618),
(377174, 'PTHR45647:SF52', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE', 247618),
(377175, 'PTHR45647:SF54', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 53-RELATED', 247618),
(377176, 'PTHR45647:SF98', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE', 247618),
(377177, 'PTHR45647:SF56', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 50-RELATED', 247618),
(377178, 'PTHR45647:SF12', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE', 247618),
(377179, 'PTHR45647:SF15', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 35', 247618),
(377180, 'PTHR45647:SF59', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE', 247618),
(377181, 'PTHR45647:SF19', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE', 247618),
(377182, 'PTHR45647:SF139', NULL, NULL, NULL, NULL, 'OS02G0152300 PROTEIN', 247618),
(377183, 'PTHR45647:SF18', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 33', 247618),
(377184, 'PTHR45647:SF138', NULL, NULL, NULL, NULL, 'U-BOX KINASE FAMILY PROTEIN', 247618),
(377185, 'PTHR45647:SF137', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE', 247618),
(377186, 'PTHR45647:SF136', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 33', 247618),
(377187, 'PTHR45647:SF135', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASE-LIKE DOMAIN KINASE', 247618),
(377188, 'PTHR43099:SF6', NULL, NULL, NULL, NULL, 'UPF0053 PROTEIN RV1842C', 247619),
(377189, 'PTHR43099', NULL, NULL, NULL, NULL, 'UPF0053 PROTEIN YRKA', 247619),
(377190, 'PTHR43099:SF2', NULL, NULL, NULL, NULL, 'UPF0053 PROTEIN YRKA', 247619),
(377191, 'PTHR43099:SF5', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN-RELATED', 247619),
(377192, 'PTHR43099:SF4', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN-RELATED', 247619),
(377193, 'PTHR41523', NULL, NULL, NULL, NULL, 'TWO-COMPONENT SYSTEM SENSOR PROTEIN', 247620),
(377194, 'PTHR41523:SF8', NULL, NULL, NULL, NULL, 'ETHYLENE RESPONSE SENSOR PROTEIN', 247620),
(377195, 'PTHR41523:SF7', NULL, NULL, NULL, NULL, 'TWO-COMPONENT SYSTEM SENSOR PROTEIN', 247620),
(377196, 'PTHR45081:SF3', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING TETRATRICOPEPTIDE FAMILY PROTEIN-RELATED', 247621),
(377197, 'PTHR45081', NULL, NULL, NULL, NULL, 'EF HAND FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 247621),
(377198, 'PTHR45081:SF1', NULL, NULL, NULL, NULL, 'EF HAND FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 247621),
(377199, 'PTHR43885', NULL, NULL, NULL, NULL, 'HALOACID DEHALOGENASE-LIKE HYDROLASE', 247622),
(377200, 'PTHR43885:SF1', NULL, NULL, NULL, NULL, 'SUPERFAMILY HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G13290)-RELATED', 247622),
(377201, 'PTHR43885:SF2', NULL, NULL, NULL, NULL, 'BNACNNG52020D PROTEIN', 247622),
(377202, 'PTHR47828', NULL, NULL, NULL, NULL, 'ARCHAEAL HISTONE A', 247623),
(377203, 'PTHR47828:SF1', NULL, NULL, NULL, NULL, 'ARCHAEAL HISTONE A', 247623),
(377204, 'PTHR31891:SF8', NULL, NULL, NULL, NULL, 'FORMAMIDASE-LIKE ISOFORM X1', 247624),
(377205, 'PTHR31891:SF1', NULL, NULL, NULL, NULL, 'FORMAMIDASE C869.04-RELATED', 247624);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(377206, 'PTHR31891', NULL, NULL, NULL, NULL, 'FORMAMIDASE C869.04-RELATED', 247624),
(377207, 'PTHR31891:SF9', NULL, NULL, NULL, NULL, 'ACETAMIDASE/FORMAMIDASE FAMILY PROTEIN', 247624),
(377208, 'PTHR24253:SF81', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEASE SERINE 9', 247625),
(377209, 'PTHR24253:SF46', NULL, NULL, NULL, NULL, 'SERINE PROTEASE P83', 247625),
(377210, 'PTHR24253:SF45', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEASE SERINE 11D', 247625),
(377211, 'PTHR24253:SF89', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEASE SERINE 2', 247625),
(377212, 'PTHR24253:SF88', NULL, NULL, NULL, NULL, 'NOTOPLEURAL, ISOFORM A', 247625),
(377213, 'PTHR24253:SF44', NULL, NULL, NULL, NULL, 'COAGULATION FACTOR XI', 247625),
(377214, 'PTHR24253:SF86', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEASE SERINE 3', 247625),
(377215, 'PTHR24253:SF42', NULL, NULL, NULL, NULL, 'PROTEASE, SERINE 47', 247625),
(377216, 'PTHR24253:SF41', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEASE SERINE 11A', 247625),
(377217, 'PTHR24253:SF84', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEASE SERINE 11E', 247625),
(377218, 'PTHR24253:SF132', NULL, NULL, NULL, NULL, 'SERINE PROTEASE-LIKE PROTEIN 51', 247625),
(377219, 'PTHR24253:SF136', NULL, NULL, NULL, NULL, 'SERINE PROTEINASE STUBBLE-LIKE PROTEIN', 247625),
(377220, 'PTHR24253:SF48', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 247625),
(377221, 'PTHR24253:SF47', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEASE SERINE 11G', 247625),
(377222, 'PTHR24253:SF133', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 247625),
(377223, 'PTHR24253:SF91', NULL, NULL, NULL, NULL, 'COMPLEMENT FACTOR I', 247625),
(377224, 'PTHR24253:SF90', NULL, NULL, NULL, NULL, 'SERINE PROTEASE 55', 247625),
(377225, 'PTHR24253:SF56', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEASE SERINE 11B', 247625),
(377226, 'PTHR24253:SF55', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEASE SERINE 13', 247625),
(377227, 'PTHR24253:SF10', NULL, NULL, NULL, NULL, 'TRYPTASE GAMMA 1', 247625),
(377228, 'PTHR24253:SF54', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF TUMORIGENICITY 14 PROTEIN HOMOLOG', 247625),
(377229, 'PTHR24253:SF52', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEASE SERINE 11C', 247625),
(377230, 'PTHR24253:SF95', NULL, NULL, NULL, NULL, 'CLIP DOMAIN-CONTAINING SERINE PROTEASE', 247625),
(377231, 'PTHR24253:SF50', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF TUMORIGENICITY 14 PROTEIN', 247625),
(377232, 'PTHR24253:SF124', NULL, NULL, NULL, NULL, 'SERINE PROTEASE H42', 247625),
(377233, 'PTHR24253:SF58', NULL, NULL, NULL, NULL, 'SERINE PROTEASE 33', 247625),
(377234, 'PTHR24253:SF128', NULL, NULL, NULL, NULL, 'ZGC:55888', 247625),
(377235, 'PTHR24253:SF127', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 247625),
(377236, 'PTHR24253:SF24', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 247625),
(377237, 'PTHR24253:SF8', NULL, NULL, NULL, NULL, 'SERINE PROTEASE 52', 247625),
(377238, 'PTHR24253:SF66', NULL, NULL, NULL, NULL, 'SERINE PROTEINASE STUBBLE', 247625),
(377239, 'PTHR24253:SF65', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEASE SERINE 11F', 247625),
(377240, 'PTHR24253:SF6', NULL, NULL, NULL, NULL, 'BRAIN-SPECIFIC SERINE PROTEASE 4', 247625),
(377241, 'PTHR24253:SF64', NULL, NULL, NULL, NULL, 'PLASMA KALLIKREIN', 247625),
(377242, 'PTHR24253', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEASE SERINE', 247625),
(377243, 'PTHR24253:SF63', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 247625),
(377244, 'PTHR24253:SF62', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEASE SERINE 6', 247625),
(377245, 'PTHR24253:SF154', NULL, NULL, NULL, NULL, 'OVOCHYMASE 1', 247625),
(377246, 'PTHR24253:SF153', NULL, NULL, NULL, NULL, 'FI06405P-RELATED', 247625),
(377247, 'PTHR24253:SF152', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 247625),
(377248, 'PTHR24253:SF151', NULL, NULL, NULL, NULL, 'ZMP:0000001114', 247625),
(377249, 'PTHR24253:SF29', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEASE SERINE 11B-LIKE PROTEIN', 247625); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(377250, 'PTHR24253:SF158', NULL, NULL, NULL, NULL, 'SERINE PROTEASE 33-LIKE', 247625),
(377251, 'PTHR24253:SF114', NULL, NULL, NULL, NULL, 'CORIN, ISOFORM B', 247625),
(377252, 'PTHR24253:SF157', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 247625),
(377253, 'PTHR24253:SF156', NULL, NULL, NULL, NULL, 'SERINE PROTEASE 48', 247625),
(377254, 'PTHR24253:SF26', NULL, NULL, NULL, NULL, 'COAGULATION FACTOR XII', 247625),
(377255, 'PTHR24253:SF155', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 247625),
(377256, 'PTHR24253:SF118', NULL, NULL, NULL, NULL, 'AGAP002422-PA', 247625),
(377257, 'PTHR24253:SF119', NULL, NULL, NULL, NULL, 'SERINE PROTEASE 27', 247625),
(377258, 'PTHR24253:SF71', NULL, NULL, NULL, NULL, 'ENTEROPEPTIDASE', 247625),
(377259, 'PTHR24253:SF70', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEASE SERINE 5', 247625),
(377260, 'PTHR24253:SF35', NULL, NULL, NULL, NULL, 'THREONINE PROTEASE PRSS50-RELATED', 247625),
(377261, 'PTHR24253:SF79', NULL, NULL, NULL, NULL, 'SERINE PROTEASE 41', 247625),
(377262, 'PTHR24253:SF32', NULL, NULL, NULL, NULL, 'TRYPTASE DELTA 1', 247625),
(377263, 'PTHR24253:SF31', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEASE SERINE 4', 247625),
(377264, 'PTHR24253:SF150', NULL, NULL, NULL, NULL, 'SERINE PROTEASE HEPSIN', 247625),
(377265, 'PTHR24253:SF74', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 247625),
(377266, 'PTHR24253:SF72', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 247625),
(377267, 'PTHR24253:SF142', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 247625),
(377268, 'PTHR24253:SF103', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEASE SERINE 7', 247625),
(377269, 'PTHR24253:SF147', NULL, NULL, NULL, NULL, 'SERINE PROTEASE P74', 247625),
(377270, 'PTHR24253:SF146', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEASE SERINE 12', 247625),
(377271, 'PTHR24253:SF145', NULL, NULL, NULL, NULL, 'SERINE PROTEASE FILZIG', 247625),
(377272, 'PTHR24253:SF101', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE SERINE PROTEASE 5', 247625),
(377273, 'PTHR24253:SF144', NULL, NULL, NULL, NULL, 'PROSTASIN', 247625),
(377274, 'PTHR24253:SF100', NULL, NULL, NULL, NULL, 'POLYSERASE-2', 247625),
(377275, 'PTHR24253:SF149', NULL, NULL, NULL, NULL, 'HEPSIN', 247625),
(377276, 'PTHR24253:SF148', NULL, NULL, NULL, NULL, 'CLIP-DOMAIN SERINE PROTEASE', 247625),
(377277, 'PTHR24253:SF108', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 247625),
(377278, 'PTHR45984:SF3', NULL, NULL, NULL, NULL, 'SPERM-ASSOCIATED ANTIGEN 1', 247626),
(377279, 'PTHR45984:SF4', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 247626),
(377280, 'PTHR45984:SF1', NULL, NULL, NULL, NULL, 'SPAG1 AXONEMAL DYNEIN ASSEMBLY FACTOR', 247626),
(377281, 'PTHR45984', NULL, NULL, NULL, NULL, 'RNA (RNA) POLYMERASE II ASSOCIATED PROTEIN HOMOLOG', 247626),
(377282, 'PTHR45984:SF2', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM34', 247626),
(377283, 'PTHR46399:SF10', NULL, NULL, NULL, NULL, 'RYANODINE RECEPTOR 1', 247627),
(377284, 'PTHR46399:SF9', NULL, NULL, NULL, NULL, 'RYANODINE RECEPTOR 3', 247627),
(377285, 'PTHR46399:SF8', NULL, NULL, NULL, NULL, 'RYANODINE RECEPTOR 44F-LIKE PROTEIN', 247627),
(377286, 'PTHR46399:SF7', NULL, NULL, NULL, NULL, 'RYANODINE RECEPTOR 2', 247627),
(377287, 'PTHR46399:SF6', NULL, NULL, NULL, NULL, 'RYANODINE RECEPTOR 1', 247627),
(377288, 'PTHR46399', NULL, NULL, NULL, NULL, 'B30.2/SPRY DOMAIN-CONTAINING PROTEIN', 247627),
(377289, 'PTHR35121:SF4', NULL, NULL, NULL, NULL, 'HOMEODOMAIN PROTEIN 8, PUTATIVE-RELATED', 247628),
(377290, 'PTHR35121:SF2', NULL, NULL, NULL, NULL, 'BNAC04G52100D PROTEIN', 247628),
(377291, 'PTHR35121:SF10', NULL, NULL, NULL, NULL, '', 247628),
(377292, 'PTHR35121', NULL, NULL, NULL, NULL, 'HOMEODOMAIN PROTEIN 8, PUTATIVE-RELATED', 247628),
(377293, 'PTHR35121:SF7', NULL, NULL, NULL, NULL, 'ZINC FINGER, SWIM-TYPE-RELATED', 247628),
(377294, 'PTHR35121:SF5', NULL, NULL, NULL, NULL, 'GB|AAD20160.1', 247628),
(377295, 'PTHR35121:SF6', NULL, NULL, NULL, NULL, '', 247628);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(377296, 'PTHR37013:SF7', NULL, NULL, NULL, NULL, '', 247629),
(377297, 'PTHR37013:SF5', NULL, NULL, NULL, NULL, '', 247629),
(377298, 'PTHR37013:SF6', NULL, NULL, NULL, NULL, '', 247629),
(377299, 'PTHR37013', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_1G05950)-RELATED', 247629),
(377300, 'PTHR37013:SF3', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_1G05950)', 247629),
(377301, 'PTHR37013:SF4', NULL, NULL, NULL, NULL, '', 247629),
(377302, 'PTHR43053:SF4', NULL, NULL, NULL, NULL, 'MYOGENESIS-REGULATING GLYCOSIDASE', 247630),
(377303, 'PTHR43053:SF6', NULL, NULL, NULL, NULL, 'SI:CH211-236L14.4', 247630),
(377304, 'PTHR43053', NULL, NULL, NULL, NULL, 'GLYCOSIDASE FAMILY 31', 247630),
(377305, 'PTHR43053:SF3', NULL, NULL, NULL, NULL, 'ALPHA-GALACTOSIDASE-RELATED', 247630),
(377306, 'PTHR31490', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE', 247631),
(377307, 'PTHR31490:SF80', NULL, NULL, NULL, NULL, 'ENDO-1,4-BETA-XYLANASE A-LIKE ISOFORM X1', 247631),
(377308, 'PTHR31490:SF60', NULL, NULL, NULL, NULL, 'ENDO-1,4-BETA-XYLANASE 3', 247631),
(377309, 'PTHR31490:SF82', NULL, NULL, NULL, NULL, 'ENDO-1,4-BETA-XYLANASE A-LIKE', 247631),
(377310, 'PTHR31490:SF83', NULL, NULL, NULL, NULL, 'EXOGLUCANASE/XYLANASE-LIKE', 247631),
(377311, 'PTHR31490:SF61', NULL, NULL, NULL, NULL, 'GH10 DOMAIN-CONTAINING PROTEIN', 247631),
(377312, 'PTHR31490:SF84', NULL, NULL, NULL, NULL, 'OS03G0201500 PROTEIN', 247631),
(377313, 'PTHR31490:SF62', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE, FAMILY 35-RELATED', 247631),
(377314, 'PTHR31490:SF85', NULL, NULL, NULL, NULL, 'GH10 DOMAIN-CONTAINING PROTEIN', 247631),
(377315, 'PTHR31490:SF63', NULL, NULL, NULL, NULL, 'GH10 DOMAIN-CONTAINING PROTEIN', 247631),
(377316, 'PTHR31490:SF41', NULL, NULL, NULL, NULL, 'ENDO-1,4-BETA-XYLANASE 4', 247631),
(377317, 'PTHR31490:SF42', NULL, NULL, NULL, NULL, 'GH10 DOMAIN-CONTAINING PROTEIN', 247631),
(377318, 'PTHR31490:SF86', NULL, NULL, NULL, NULL, 'ENDO-1,4-BETA-XYLANASE A-LIKE', 247631),
(377319, 'PTHR31490:SF87', NULL, NULL, NULL, NULL, 'PUTATIVE, EXPRESSED-RELATED', 247631),
(377320, 'PTHR31490:SF88', NULL, NULL, NULL, NULL, 'BETA-XYLANASE', 247631),
(377321, 'PTHR31490:SF66', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE FAMILY 10 PROTEIN / CARBOHYDRATE-BINDING DOMAIN-CONTAINING PROTEIN', 247631),
(377322, 'PTHR31490:SF46', NULL, NULL, NULL, NULL, 'ENDO-1,4-BETA-XYLANASE A-LIKE PROTEIN', 247631),
(377323, 'PTHR31490:SF68', NULL, NULL, NULL, NULL, '1,4-BETA-XYLANASE-RELATED', 247631),
(377324, 'PTHR31490:SF47', NULL, NULL, NULL, NULL, 'GH10 DOMAIN-CONTAINING PROTEIN', 247631),
(377325, 'PTHR31490:SF48', NULL, NULL, NULL, NULL, 'GH10 DOMAIN-CONTAINING PROTEIN', 247631),
(377326, 'PTHR31490:SF49', NULL, NULL, NULL, NULL, 'ENDO-1,4-BETA-XYLANASE A-LIKE', 247631),
(377327, 'PTHR31490:SF72', NULL, NULL, NULL, NULL, 'GH10 DOMAIN-CONTAINING PROTEIN', 247631),
(377328, 'PTHR31490:SF50', NULL, NULL, NULL, NULL, 'ENDO-1,4-BETA-XYLANASE C-RELATED', 247631),
(377329, 'PTHR31490:SF73', NULL, NULL, NULL, NULL, 'GH10 DOMAIN-CONTAINING PROTEIN', 247631),
(377330, 'PTHR31490:SF52', NULL, NULL, NULL, NULL, 'ENDO-1,4-BETA-XYLANASE 5-RELATED', 247631),
(377331, 'PTHR31490:SF75', NULL, NULL, NULL, NULL, 'GH10 DOMAIN-CONTAINING PROTEIN', 247631),
(377332, 'PTHR31490:SF76', NULL, NULL, NULL, NULL, 'ENDO-1,4-BETA-XYLANASE C', 247631),
(377333, 'PTHR31490:SF10', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE FAMILY 10 PROTEIN, EXPRESSED', 247631),
(377334, 'PTHR31490:SF55', NULL, NULL, NULL, NULL, 'ENDO-1,4-BETA-XYLANASE A-LIKE', 247631),
(377335, 'PTHR31490:SF56', NULL, NULL, NULL, NULL, 'ENDO-1,4-BETA-XYLANASE C-RELATED', 247631),
(377336, 'PTHR31490:SF79', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE FAMILY 10 PROTEIN', 247631),
(377337, 'PTHR31490:SF35', NULL, NULL, NULL, NULL, 'ENDO-1,4-BETA-XYLANASE', 247631),
(377338, 'PTHR31490:SF14', NULL, NULL, NULL, NULL, 'OS01G0134900 PROTEIN', 247631),
(377339, 'PTHR31490:SF58', NULL, NULL, NULL, NULL, 'ENDO-1,4-BETA-XYLANASE 2', 247631),
(377340, 'PTHR31490:SF59', NULL, NULL, NULL, NULL, 'GH10 DOMAIN-CONTAINING PROTEIN', 247631);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(377341, 'PTHR31490:SF8', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE FAMILY 10 PROTEIN', 247631),
(377342, 'PTHR31490:SF1', NULL, NULL, NULL, NULL, 'ENDO-1,4-BETA-XYLANASE 1', 247631),
(377343, 'PTHR31490:SF2', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE FAMILY 10 PROTEIN', 247631),
(377344, 'PTHR31490:SF3', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE FAMILY 10 PROTEIN', 247631),
(377345, 'PTHR24353:SF87', NULL, NULL, NULL, NULL, '', 247632),
(377346, 'PTHR24353:SF64', NULL, NULL, NULL, NULL, '', 247632),
(377347, 'PTHR24353:SF67', NULL, NULL, NULL, NULL, 'PROTEIN KINASE A CATALYTIC SUBUNIT ISOFORM 2', 247632),
(377348, 'PTHR24353:SF24', NULL, NULL, NULL, NULL, '', 247632),
(377349, 'PTHR24353:SF68', NULL, NULL, NULL, NULL, '', 247632),
(377350, 'PTHR24353', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-DEPENDENT PROTEIN KINASE', 247632),
(377351, 'PTHR24353:SF82', NULL, NULL, NULL, NULL, 'CAMP-DEPENDENT PROTEIN KINASE CATALYTIC SUBUNIT ALPHA', 247632),
(377352, 'PTHR24353:SF135', NULL, NULL, NULL, NULL, 'CAMP-DEPENDENT PROTEIN KINASE', 247632),
(377353, 'PTHR24353:SF134', NULL, NULL, NULL, NULL, '', 247632),
(377354, 'PTHR24353:SF133', NULL, NULL, NULL, NULL, 'CAMP-DEPENDENT PROTEIN KINASE CATALYTIC SUBUNIT PRKX-RELATED', 247632),
(377355, 'PTHR24353:SF111', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247632),
(377356, 'PTHR24353:SF110', NULL, NULL, NULL, NULL, 'DEVELOPMENTALLY-REGULATED PROTEIN KINASE 1', 247632),
(377357, 'PTHR24353:SF150', NULL, NULL, NULL, NULL, 'CAMP-DEPENDENT PROTEIN KINASE CATALYTIC SUBUNIT BETA', 247632),
(377358, 'PTHR24353:SF118', NULL, NULL, NULL, NULL, 'PROTEIN KINASE CGMP-DEPENDENT 3', 247632),
(377359, 'PTHR24353:SF139', NULL, NULL, NULL, NULL, '', 247632),
(377360, 'PTHR24353:SF116', NULL, NULL, NULL, NULL, 'CAMP-DEPENDENT PROTEIN KINASE', 247632),
(377361, 'PTHR24353:SF137', NULL, NULL, NULL, NULL, 'CAMP-DEPENDENT PROTEIN KINASE CATALYTIC SUBUNIT GAMMA', 247632),
(377362, 'PTHR24353:SF73', NULL, NULL, NULL, NULL, 'CAMP-DEPENDENT PROTEIN KINASE TYPE 1-RELATED', 247632),
(377363, 'PTHR24353:SF91', NULL, NULL, NULL, NULL, '', 247632),
(377364, 'PTHR24353:SF146', NULL, NULL, NULL, NULL, 'CAMP-DEPENDENT PROTEIN KINASE CATALYTIC SUBUNIT (EUROFUNG)', 247632),
(377365, 'PTHR24353:SF145', NULL, NULL, NULL, NULL, '', 247632),
(377366, 'PTHR24353:SF144', NULL, NULL, NULL, NULL, '', 247632),
(377367, 'PTHR24353:SF143', NULL, NULL, NULL, NULL, '', 247632),
(377368, 'PTHR24353:SF142', NULL, NULL, NULL, NULL, 'CAMP CGMP-DEPENDENT PROTEIN KINASE', 247632),
(377369, 'PTHR24353:SF37', NULL, NULL, NULL, NULL, 'UT01108P-RELATED', 247632),
(377370, 'PTHR24353:SF127', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C AND CYCLIC NUCLEOTIDE-BINDING/KINASE DOMAIN-CONTAINING PROTEIN', 247632),
(377371, 'PTHR24353:SF149', NULL, NULL, NULL, NULL, 'CAMP-DEPENDENT PROTEIN KINASE CATALYTIC SUBUNIT PRKX', 247632),
(377372, 'PTHR24353:SF148', NULL, NULL, NULL, NULL, 'CAMP-DEPENDENT PROTEIN KINASE', 247632),
(377373, 'PTHR24353:SF147', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE', 247632),
(377374, 'PTHR34297:SF2', NULL, NULL, NULL, NULL, 'HYPOTHETICAL CYTOSOLIC PROTEIN', 247633),
(377375, 'PTHR34297:SF3', NULL, NULL, NULL, NULL, 'ALKALINE SHOCK PROTEIN 23', 247633),
(377376, 'PTHR34297:SF1', NULL, NULL, NULL, NULL, 'ALKALINE SHOCK PROTEIN 23', 247633),
(377377, 'PTHR34297', NULL, NULL, NULL, NULL, 'HYPOTHETICAL CYTOSOLIC PROTEIN-RELATED', 247633),
(377378, 'PTHR10796:SF15', NULL, NULL, NULL, NULL, 'PATCHED DOMAIN-CONTAINING PROTEIN 4', 247634),
(377379, 'PTHR10796:SF36', NULL, NULL, NULL, NULL, 'PATCHED DOMAIN-CONTAINING PROTEIN 1', 247634),
(377380, 'PTHR10796:SF95', NULL, NULL, NULL, NULL, 'SSD DOMAIN-CONTAINING PROTEIN', 247634),
(377381, 'PTHR10796:SF96', NULL, NULL, NULL, NULL, 'PATCHED-RELATED PROTEIN 9', 247634),
(377382, 'PTHR10796:SF94', NULL, NULL, NULL, NULL, 'SSD DOMAIN-CONTAINING PROTEIN', 247634),
(377383, 'PTHR10796:SF97', NULL, NULL, NULL, NULL, 'SSD DOMAIN-CONTAINING PROTEIN', 247634),
(377384, 'PTHR10796:SF192', NULL, NULL, NULL, NULL, 'SSD DOMAIN-CONTAINING PROTEIN', 247634);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(377385, 'PTHR10796:SF193', NULL, NULL, NULL, NULL, 'SSD DOMAIN-CONTAINING PROTEIN', 247634),
(377386, 'PTHR10796:SF191', NULL, NULL, NULL, NULL, 'SSD DOMAIN-CONTAINING PROTEIN', 247634),
(377387, 'PTHR10796:SF112', NULL, NULL, NULL, NULL, 'SSD DOMAIN-CONTAINING PROTEIN', 247634),
(377388, 'PTHR10796:SF130', NULL, NULL, NULL, NULL, 'PATCHED DOMAIN-CONTAINING PROTEIN 3-LIKE PROTEIN', 247634),
(377389, 'PTHR10796:SF108', NULL, NULL, NULL, NULL, 'SSD DOMAIN-CONTAINING PROTEIN', 247634),
(377390, 'PTHR10796:SF105', NULL, NULL, NULL, NULL, 'SSD DOMAIN-CONTAINING PROTEIN', 247634),
(377391, 'PTHR10796:SF85', NULL, NULL, NULL, NULL, 'SSD DOMAIN-CONTAINING PROTEIN', 247634),
(377392, 'PTHR10796:SF60', NULL, NULL, NULL, NULL, 'PATCHED DOMAIN-CONTAINING PROTEIN 3', 247634),
(377393, 'PTHR10796:SF88', NULL, NULL, NULL, NULL, 'SSD DOMAIN-CONTAINING PROTEIN', 247634),
(377394, 'PTHR10796:SF87', NULL, NULL, NULL, NULL, 'SSD DOMAIN-CONTAINING PROTEIN', 247634),
(377395, 'PTHR10796:SF181', NULL, NULL, NULL, NULL, 'SSD DOMAIN-CONTAINING PROTEIN', 247634),
(377396, 'PTHR10796:SF91', NULL, NULL, NULL, NULL, 'SSD DOMAIN-CONTAINING PROTEIN', 247634),
(377397, 'PTHR10796:SF92', NULL, NULL, NULL, NULL, 'PATCHED-RELATED, ISOFORM A', 247634),
(377398, 'PTHR10796:SF90', NULL, NULL, NULL, NULL, 'SSD DOMAIN-CONTAINING PROTEIN', 247634),
(377399, 'PTHR10796:SF103', NULL, NULL, NULL, NULL, 'SSD DOMAIN-CONTAINING PROTEIN', 247634),
(377400, 'PTHR10796:SF104', NULL, NULL, NULL, NULL, 'SSD DOMAIN-CONTAINING PROTEIN', 247634),
(377401, 'PTHR10796:SF189', NULL, NULL, NULL, NULL, 'SSD DOMAIN-CONTAINING PROTEIN', 247634),
(377402, 'PTHR10796', NULL, NULL, NULL, NULL, 'PATCHED-RELATED', 247634),
(377403, 'PTHR10796:SF124', NULL, NULL, NULL, NULL, 'SSD DOMAIN-CONTAINING PROTEIN', 247634),
(377404, 'PTHR10796:SF102', NULL, NULL, NULL, NULL, 'SSD DOMAIN-CONTAINING PROTEIN', 247634),
(377405, 'PTHR10796:SF187', NULL, NULL, NULL, NULL, 'SSD DOMAIN-CONTAINING PROTEIN', 247634),
(377406, 'PTHR10796:SF122', NULL, NULL, NULL, NULL, 'SSD DOMAIN-CONTAINING PROTEIN', 247634),
(377407, 'PTHR10796:SF185', NULL, NULL, NULL, NULL, 'SSD DOMAIN-CONTAINING PROTEIN', 247634),
(377408, 'PTHR13101:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOMEVALONATE KINASE', 247635),
(377409, 'PTHR13101', NULL, NULL, NULL, NULL, 'PHOSPHOMEVALONATE KINASE', 247635),
(377410, 'PTHR10071', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GATA FAMILY MEMBER', 247636),
(377411, 'PTHR10071:SF190', NULL, NULL, NULL, NULL, 'ERYTHROID TRANSCRIPTION FACTOR', 247636),
(377412, 'PTHR10071:SF281', NULL, NULL, NULL, NULL, 'BOX A-BINDING FACTOR-RELATED', 247636),
(377413, 'PTHR10071:SF334', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR ELT-2', 247636),
(377414, 'PTHR10071:SF312', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 247636),
(377415, 'PTHR10071:SF106', NULL, NULL, NULL, NULL, 'TRANS-ACTING T-CELL-SPECIFIC TRANSCRIPTION FACTOR GATA-3', 247636),
(377416, 'PTHR10071:SF149', NULL, NULL, NULL, NULL, 'ENDOTHELIAL TRANSCRIPTION FACTOR GATA-2', 247636),
(377417, 'PTHR10071:SF155', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 247636),
(377418, 'PTHR10071:SF331', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF FERRIC UPTAKE 1', 247636),
(377419, 'PTHR10071:SF154', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GATA-4', 247636),
(377420, 'PTHR10071:SF330', NULL, NULL, NULL, NULL, 'GATA-BINDING FACTOR A', 247636),
(377421, 'PTHR10071:SF322', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 247636),
(377422, 'PTHR10071:SF333', NULL, NULL, NULL, NULL, 'NITROGEN REGULATORY PROTEIN AREA', 247636),
(377423, 'PTHR10071:SF289', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GATA-5', 247636),
(377424, 'PTHR10071:SF233', NULL, NULL, NULL, NULL, 'GATA-LIKE TRANSCRIPTION FACTOR ELT-6', 247636),
(377425, 'PTHR10071:SF332', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR END-1', 247636),
(377426, 'PTHR10071:SF328', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR ELT-1-RELATED', 247636),
(377427, 'PTHR10071:SF23', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GATA-6', 247636);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(377428, 'PTHR10071:SF327', NULL, NULL, NULL, NULL, 'GATA-TYPE TRANSCRIPTION FACTOR SREA', 247636),
(377429, 'PTHR10071:SF329', NULL, NULL, NULL, NULL, '', 247636),
(377430, 'PTHR45758:SF3', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN E', 247637),
(377431, 'PTHR45758', NULL, NULL, NULL, NULL, 'MITOFERRIN-1-RELATED', 247637),
(377432, 'PTHR45758:SF4', NULL, NULL, NULL, NULL, 'MITOFERRIN-1', 247637),
(377433, 'PTHR45758:SF18', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN', 247637),
(377434, 'PTHR45758:SF19', NULL, NULL, NULL, NULL, 'CARRIER PROTEIN, PUTATIVE-RELATED', 247637),
(377435, 'PTHR45758:SF13', NULL, NULL, NULL, NULL, 'BNAA05G12200D PROTEIN', 247637),
(377436, 'PTHR45758:SF16', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN U', 247637),
(377437, 'PTHR45758:SF20', NULL, NULL, NULL, NULL, 'MITOFERRIN-2', 247637),
(377438, 'PTHR45758:SF12', NULL, NULL, NULL, NULL, 'MITOFERRIN-LIKE', 247637),
(377439, 'PTHR45758:SF11', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN', 247637),
(377440, 'PTHR45255', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 24', 247638),
(377441, 'PTHR45255:SF1', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 24', 247638),
(377442, 'PTHR10545:SF61', NULL, NULL, NULL, NULL, 'N-HYDROXYCINNAMOYL-COA:TYRAMINE N-HYDROXYCINNAMOYL TRANSFERASE THT7-1', 247639),
(377443, 'PTHR10545:SF54', NULL, NULL, NULL, NULL, 'TYRAMINE N-FERULOYLTRANSFERASE 4/11', 247639),
(377444, 'PTHR10545:SF65', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 247639),
(377445, 'PTHR10545:SF53', NULL, NULL, NULL, NULL, 'TYRAMINE N-FERULOYLTRANSFERASE 4/11-LIKE', 247639),
(377446, 'PTHR10545:SF42', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE', 247639),
(377447, 'PTHR10545:SF52', NULL, NULL, NULL, NULL, 'SPERMIDINE/SPERMINE N1-ACETYLTRANSFERASE FAMILY MEMBER 2B', 247639),
(377448, 'PTHR10545:SF63', NULL, NULL, NULL, NULL, 'SPERMIDINE/SPERMINE N(1)-ACETYLTRANSFERASE-LIKE PROTEIN 1', 247639),
(377449, 'PTHR10545:SF51', NULL, NULL, NULL, NULL, 'THIALYSINE N-EPSILON-ACETYLTRANSFERASE', 247639),
(377450, 'PTHR10545:SF36', NULL, NULL, NULL, NULL, 'DIAMINE ACETYLTRANSFERASE 1', 247639),
(377451, 'PTHR10545:SF58', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 247639),
(377452, 'PTHR10545:SF57', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 247639),
(377453, 'PTHR10545', NULL, NULL, NULL, NULL, 'DIAMINE N-ACETYLTRANSFERASE', 247639),
(377454, 'PTHR10545:SF56', NULL, NULL, NULL, NULL, 'TYRAMINE N-FERULOYLTRANSFERASE 4/11-LIKE', 247639),
(377455, 'PTHR10545:SF66', NULL, NULL, NULL, NULL, 'SAT2 PROTEIN-RELATED', 247639),
(377456, 'PTHR10545:SF55', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE NATA1-LIKE-RELATED', 247639),
(377457, 'PTHR10545:SF29', NULL, NULL, NULL, NULL, 'DIAMINE ACETYLTRANSFERASE 1', 247639),
(377458, 'PTHR10545:SF59', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE NATA1-LIKE-RELATED', 247639),
(377459, 'PTHR21407', NULL, NULL, NULL, NULL, 'RE43931P-RELATED', 247640),
(377460, 'PTHR21407:SF1', NULL, NULL, NULL, NULL, 'RE43931P', 247640),
(377461, 'PTHR21407:SF5', NULL, NULL, NULL, NULL, 'HL04814P', 247640),
(377462, 'PTHR21407:SF3', NULL, NULL, NULL, NULL, 'LD12305P', 247640),
(377463, 'PTHR10672:SF21', NULL, NULL, NULL, NULL, 'ALDOLASE_II DOMAIN-CONTAINING PROTEIN', 247641),
(377464, 'PTHR10672:SF6', NULL, NULL, NULL, NULL, 'BETA-ADDUCIN', 247641),
(377465, 'PTHR10672:SF5', NULL, NULL, NULL, NULL, 'GAMMA-ADDUCIN', 247641),
(377466, 'PTHR10672:SF25', NULL, NULL, NULL, NULL, 'MEIOTICALLY UP-REGULATED GENE 14 PROTEIN', 247641),
(377467, 'PTHR10672:SF4', NULL, NULL, NULL, NULL, 'ALPHA-ADDUCIN', 247641),
(377468, 'PTHR10672:SF39', NULL, NULL, NULL, NULL, 'ALDOLASE_II DOMAIN-CONTAINING PROTEIN', 247641),
(377469, 'PTHR10672:SF3', NULL, NULL, NULL, NULL, 'PROTEIN HU-LI TAI SHAO', 247641),
(377470, 'PTHR10672', NULL, NULL, NULL, NULL, 'ADDUCIN', 247641),
(377471, 'PTHR10672:SF40', NULL, NULL, NULL, NULL, 'CLASS II ALDOLASE/ADDUCIN DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_3G09800)', 247641); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(377472, 'PTHR10672:SF41', NULL, NULL, NULL, NULL, 'CLASS II ALDOLASE/ADDUCIN DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_3G01330)', 247641),
(377473, 'PTHR10672:SF42', NULL, NULL, NULL, NULL, 'ADDUCIN-RELATED PROTEIN 2', 247641),
(377474, 'PTHR18887', NULL, NULL, NULL, NULL, 'GOLGI-ASSOCIATED PROTEIN GCP360-RELATED', 247642),
(377475, 'PTHR18887:SF5', NULL, NULL, NULL, NULL, '', 247642),
(377476, 'PTHR18887:SF4', NULL, NULL, NULL, NULL, 'SI:CH211-220F16.2', 247642),
(377477, 'PTHR18887:SF2', NULL, NULL, NULL, NULL, 'GOLGIN SUBFAMILY B MEMBER 1', 247642),
(377478, 'PTHR36320:SF1', NULL, NULL, NULL, NULL, 'OS04G0611300 PROTEIN', 247643),
(377479, 'PTHR36320:SF2', NULL, NULL, NULL, NULL, 'BNACNNG11070D PROTEIN', 247643),
(377480, 'PTHR36320', NULL, NULL, NULL, NULL, 'OS04G0611300 PROTEIN', 247643),
(377481, 'PTHR35294', NULL, NULL, NULL, NULL, 'UBIQUITIN-ASSOCIATED/TRANSLATION ELONGATION FACTOR EF1B PROTEIN', 247644),
(377482, 'PTHR35294:SF1', NULL, NULL, NULL, NULL, 'UBA DOMAIN-CONTAINING PROTEIN', 247644),
(377483, 'PTHR35294:SF3', NULL, NULL, NULL, NULL, 'UBA DOMAIN-CONTAINING PROTEIN', 247644),
(377484, 'PTHR35294:SF5', NULL, NULL, NULL, NULL, 'UBA DOMAIN-CONTAINING PROTEIN', 247644),
(377485, 'PTHR35294:SF4', NULL, NULL, NULL, NULL, 'UBA DOMAIN-CONTAINING PROTEIN', 247644),
(377486, 'PTHR46860:SF1', NULL, NULL, NULL, NULL, 'CHROMOBOX PROTEIN HOMOLOG 2', 247645),
(377487, 'PTHR46860', NULL, NULL, NULL, NULL, 'CHROMOBOX PROTEIN HOMOLOG 2', 247645),
(377488, 'PTHR42960', NULL, NULL, NULL, NULL, 'YCF46 PROTEIN', 247646),
(377489, 'PTHR42960:SF2', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE PROTEIN', 247646),
(377490, 'PTHR42960:SF1', NULL, NULL, NULL, NULL, 'YCF46 PROTEIN', 247646),
(377491, 'PTHR46194', NULL, NULL, NULL, NULL, 'PEPTIDYL-TRNA HYDROLASE PTRHD1-RELATED', 247647),
(377492, 'PTHR46194:SF1', NULL, NULL, NULL, NULL, 'PEPTIDYL-TRNA HYDROLASE PTRHD1-RELATED', 247647),
(377493, 'PTHR23338:SF73', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN SM D1', 247648),
(377494, 'PTHR23338:SF74', NULL, NULL, NULL, NULL, 'U6 SNRNA-ASSOCIATED SM-LIKE PROTEIN LSM4', 247648),
(377495, 'PTHR23338:SF54', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN SM D3', 247648),
(377496, 'PTHR23338:SF65', NULL, NULL, NULL, NULL, 'SM DOMAIN-CONTAINING PROTEIN', 247648),
(377497, 'PTHR23338:SF66', NULL, NULL, NULL, NULL, 'U6 SNRNA-ASSOCIATED SM-LIKE PROTEIN LSM4', 247648),
(377498, 'PTHR23338', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN SM', 247648),
(377499, 'PTHR23338:SF67', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN SM D1', 247648),
(377500, 'PTHR23338:SF68', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN SMD3B', 247648),
(377501, 'PTHR23338:SF69', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN SMD1B', 247648),
(377502, 'PTHR23338:SF25', NULL, NULL, NULL, NULL, 'NADAR DOMAIN-CONTAINING PROTEIN', 247648),
(377503, 'PTHR23338:SF36', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN SM D3', 247648),
(377504, 'PTHR23338:SF16', NULL, NULL, NULL, NULL, 'U6 SNRNA-ASSOCIATED SM-LIKE PROTEIN LSM4', 247648),
(377505, 'PTHR23338:SF38', NULL, NULL, NULL, NULL, 'NUCLEAR RIBONUCLEOPROTEIN SMD3, PUTATIVE-RELATED', 247648),
(377506, 'PTHR23338:SF17', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN SM D3', 247648),
(377507, 'PTHR23338:SF18', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN SM D1', 247648),
(377508, 'PTHR23338:SF70', NULL, NULL, NULL, NULL, 'U6 SNRNA-ASSOCIATED SM-LIKE PROTEIN LSM4', 247648),
(377509, 'PTHR23338:SF71', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN SM D1', 247648),
(377510, 'PTHR23338:SF60', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN SM D3', 247648),
(377511, 'PTHR23338:SF72', NULL, NULL, NULL, NULL, 'SM-LIKE PROTEIN LSM4', 247648),
(377512, 'PTHR23338:SF61', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN SM D1', 247648),
(377513, 'PTHR14796:SF5', NULL, NULL, NULL, NULL, 'NEURENSIN-2', 247649),
(377514, 'PTHR14796:SF3', NULL, NULL, NULL, NULL, 'NEURENSIN 1-RELATED', 247649),
(377515, 'PTHR14796:SF6', NULL, NULL, NULL, NULL, 'NEURENSIN-1', 247649);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(377516, 'PTHR14796', NULL, NULL, NULL, NULL, 'NEURENSIN 1-RELATED', 247649),
(377517, 'PTHR46642:SF3', NULL, NULL, NULL, NULL, 'PHOSPHOGLUCAN PHOSPHATASE DSP4, CHLOROPLASTIC', 247650),
(377518, 'PTHR46642:SF2', NULL, NULL, NULL, NULL, 'PHOSPHOGLUCAN PHOSPHATASE LSF2, CHLOROPLASTIC', 247650),
(377519, 'PTHR46642:SF8', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE FAMILY PROTEIN', 247650),
(377520, 'PTHR46642', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PHOSPHATASE, SUBGROUP, CATALYTIC DOMAIN', 247650),
(377521, 'PTHR46642:SF7', NULL, NULL, NULL, NULL, 'PHOSPHOGLUCAN PHOSPHATASE DSP4, AMYLOPLASTIC-RELATED', 247650),
(377522, 'PTHR46642:SF5', NULL, NULL, NULL, NULL, 'TYR_PHOSPHATASE_2 DOMAIN-CONTAINING PROTEIN', 247650),
(377523, 'PTHR10443:SF45', NULL, NULL, NULL, NULL, 'DIPEPTIDASE', 247651),
(377524, 'PTHR10443:SF12', NULL, NULL, NULL, NULL, 'DIPEPTIDASE', 247651),
(377525, 'PTHR10443:SF46', NULL, NULL, NULL, NULL, 'DIPEPTIDASE', 247651),
(377526, 'PTHR10443:SF14', NULL, NULL, NULL, NULL, 'DIPEPTIDASE 3', 247651),
(377527, 'PTHR10443:SF9', NULL, NULL, NULL, NULL, 'DIPEPTIDASE 2', 247651),
(377528, 'PTHR10443:SF38', NULL, NULL, NULL, NULL, 'DIPEPTIDASE 1', 247651),
(377529, 'PTHR10443', NULL, NULL, NULL, NULL, 'MICROSOMAL DIPEPTIDASE', 247651),
(377530, 'PTHR10443:SF21', NULL, NULL, NULL, NULL, 'DIPEPTIDASE', 247651),
(377531, 'PTHR10443:SF43', NULL, NULL, NULL, NULL, 'DIPEPTIDASE', 247651),
(377532, 'PTHR10443:SF44', NULL, NULL, NULL, NULL, 'DIPEPTIDASE GLIJ', 247651),
(377533, 'PTHR38710:SF1', NULL, NULL, NULL, NULL, 'WITH PUTATIVE URIDYL PYROPHOSPHORYLASE-RELATED', 247652),
(377534, 'PTHR38710', NULL, NULL, NULL, NULL, 'WITH PUTATIVE URIDYL PYROPHOSPHORYLASE-RELATED', 247652),
(377535, 'PTHR47647', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 12 MEMBER B', 247653),
(377536, 'PTHR47647:SF2', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 12, MEMBER A', 247653),
(377537, 'PTHR47647:SF1', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 12 MEMBER B', 247653),
(377538, 'PTHR16897:SF20', NULL, NULL, NULL, NULL, 'OS10G0105400 PROTEIN', 247654),
(377539, 'PTHR16897:SF21', NULL, NULL, NULL, NULL, '', 247654),
(377540, 'PTHR16897:SF15', NULL, NULL, NULL, NULL, '', 247654),
(377541, 'PTHR16897:SF16', NULL, NULL, NULL, NULL, 'BNAA03G19680D PROTEIN', 247654),
(377542, 'PTHR16897:SF2', NULL, NULL, NULL, NULL, 'STRESS RESPONSE PROTEIN NST1', 247654),
(377543, 'PTHR16897:SF17', NULL, NULL, NULL, NULL, 'BNACNNG44110D PROTEIN', 247654),
(377544, 'PTHR16897', NULL, NULL, NULL, NULL, 'OS10G0105400 PROTEIN', 247654),
(377545, 'PTHR41677', NULL, NULL, NULL, NULL, 'YALI0B19030P', 247655),
(377546, 'PTHR41677:SF1', NULL, NULL, NULL, NULL, 'YALI0B19030P', 247655),
(377547, 'PTHR23322', NULL, NULL, NULL, NULL, 'FAS-ASSOCIATED PROTEIN', 247656),
(377548, 'PTHR23322:SF1', NULL, NULL, NULL, NULL, 'FAS-ASSOCIATED FACTOR 2', 247656),
(377549, 'PTHR23322:SF55', NULL, NULL, NULL, NULL, 'PLANT UBX DOMAIN-CONTAINING PROTEIN 9', 247656),
(377550, 'PTHR23322:SF99', NULL, NULL, NULL, NULL, 'FAS-ASSOCIATED FACTOR FAMILY MEMBER 2', 247656),
(377551, 'PTHR23322:SF98', NULL, NULL, NULL, NULL, 'UBX DOMAIN-CONTAINING PROTEIN', 247656),
(377552, 'PTHR23322:SF57', NULL, NULL, NULL, NULL, 'SI:CH73-173P19.1', 247656),
(377553, 'PTHR23322:SF79', NULL, NULL, NULL, NULL, 'UBX DOMAIN-CONTAINING PROTEIN', 247656),
(377554, 'PTHR23322:SF34', NULL, NULL, NULL, NULL, '', 247656),
(377555, 'PTHR23322:SF56', NULL, NULL, NULL, NULL, 'FAS-ASSOCIATED FACTOR 1', 247656),
(377556, 'PTHR23322:SF6', NULL, NULL, NULL, NULL, 'UBX DOMAIN-CONTAINING PROTEIN 7', 247656),
(377557, 'PTHR23322:SF78', NULL, NULL, NULL, NULL, 'PLANT UBX DOMAIN-CONTAINING PROTEIN 16-RELATED', 247656),
(377558, 'PTHR23322:SF97', NULL, NULL, NULL, NULL, 'UBX DOMAIN-CONTAINING PROTEIN 3', 247656),
(377559, 'PTHR23322:SF96', NULL, NULL, NULL, NULL, 'CASPAR, ISOFORM A', 247656),
(377560, 'PTHR23322:SF93', NULL, NULL, NULL, NULL, 'UBX DOMAIN-CONTAINING PROTEIN', 247656),
(377561, 'PTHR23322:SF71', NULL, NULL, NULL, NULL, 'UBIQUITIN-ASSOCIATED (UBA) PROTEIN-RELATED', 247656);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(377562, 'PTHR23322:SF70', NULL, NULL, NULL, NULL, 'UBX DOMAIN-CONTAINING PROTEIN', 247656),
(377563, 'PTHR23322:SF100', NULL, NULL, NULL, NULL, 'PLANT UBX DOMAIN-CONTAINING PROTEIN 10-LIKE', 247656),
(377564, 'PTHR23322:SF101', NULL, NULL, NULL, NULL, 'UBX DOMAIN-CONTAINING PROTEIN', 247656),
(377565, 'PTHR23322:SF102', NULL, NULL, NULL, NULL, 'UBX DOMAIN-CONTAINING PROTEIN', 247656),
(377566, 'PTHR23322:SF103', NULL, NULL, NULL, NULL, 'UBX DOMAIN-CONTAINING PROTEIN 3', 247656),
(377567, 'PTHR23322:SF69', NULL, NULL, NULL, NULL, 'UBX DOMAIN-CONTAINING PROTEIN', 247656),
(377568, 'PTHR23322:SF28', NULL, NULL, NULL, NULL, 'UBX DOMAIN-CONTAINING PROTEIN 10', 247656),
(377569, 'PTHR23322:SF21', NULL, NULL, NULL, NULL, 'UBX DOMAIN-CONTAINING PROTEIN 8', 247656),
(377570, 'PTHR23322:SF89', NULL, NULL, NULL, NULL, 'OS02G0522600 PROTEIN', 247656),
(377571, 'PTHR23322:SF84', NULL, NULL, NULL, NULL, 'UBX DOMAIN-CONTAINING PROTEIN', 247656),
(377572, 'PTHR23322:SF64', NULL, NULL, NULL, NULL, 'OS02G0640700 PROTEIN', 247656),
(377573, 'PTHR23322:SF86', NULL, NULL, NULL, NULL, 'BNAA05G10590D PROTEIN', 247656),
(377574, 'PTHR23322:SF85', NULL, NULL, NULL, NULL, 'UBX DOMAIN-CONTAINING PROTEIN', 247656),
(377575, 'PTHR23322:SF80', NULL, NULL, NULL, NULL, 'OS09G0525600 PROTEIN', 247656),
(377576, 'PTHR23322:SF81', NULL, NULL, NULL, NULL, 'BNAA05G10640D PROTEIN', 247656),
(377577, 'PTHR47224:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 25', 247657),
(377578, 'PTHR47224', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 25', 247657),
(377579, 'PTHR13198:SF4', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF25', 247658),
(377580, 'PTHR13198', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 25', 247658),
(377581, 'PTHR37309', NULL, NULL, NULL, NULL, 'SLR0284 PROTEIN', 247659),
(377582, 'PTHR37309:SF1', NULL, NULL, NULL, NULL, 'SLR0284 PROTEIN', 247659),
(377583, 'PTHR21712', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247660),
(377584, 'PTHR21712:SF35', NULL, NULL, NULL, NULL, 'FHA DOMAIN-CONTAINING PROTEIN FHA2', 247660),
(377585, 'PTHR21712:SF36', NULL, NULL, NULL, NULL, 'FHA DOMAIN-CONTAINING PROTEIN FHA2', 247660),
(377586, 'PTHR21712:SF39', NULL, NULL, NULL, NULL, 'FHA DOMAIN-CONTAINING PROTEIN', 247660),
(377587, 'PTHR21712:SF29', NULL, NULL, NULL, NULL, 'PRE-RRNA-PROCESSING PROTEIN FHL1', 247660),
(377588, 'PTHR21712:SF40', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR FHA1-LIKE', 247660),
(377589, 'PTHR30015', NULL, NULL, NULL, NULL, 'MRR RESTRICTION SYSTEM PROTEIN', 247661),
(377590, 'PTHR30015:SF8', NULL, NULL, NULL, NULL, 'MRR RESTRICTION SYSTEM PROTEIN', 247661),
(377591, 'PTHR30015:SF6', NULL, NULL, NULL, NULL, 'SLL1429 PROTEIN', 247661),
(377592, 'PTHR30015:SF7', NULL, NULL, NULL, NULL, 'MRR RESTRICTION SYSTEM PROTEIN', 247661),
(377593, 'PTHR38763:SF1', NULL, NULL, NULL, NULL, 'MAJOR OUTER MEMBRANE LIPOPROTEIN LPP', 247662),
(377594, 'PTHR38763', NULL, NULL, NULL, NULL, 'MAJOR OUTER MEMBRANE PROLIPOPROTEIN LPP', 247662),
(377595, 'PTHR45635:SF41', NULL, NULL, NULL, NULL, 'ADP,ATP CARRIER PROTEIN 1, MITOCHONDRIAL', 247663),
(377596, 'PTHR45635', NULL, NULL, NULL, NULL, 'ADP,ATP CARRIER PROTEIN 1-RELATED-RELATED', 247663),
(377597, 'PTHR45635:SF40', NULL, NULL, NULL, NULL, 'ADP/ATP TRANSLOCASE 4', 247663),
(377598, 'PTHR45635:SF43', NULL, NULL, NULL, NULL, 'ADP/ATP TRANSLOCASE', 247663),
(377599, 'PTHR45635:SF42', NULL, NULL, NULL, NULL, 'ADP/ATP TRANSLOCASE', 247663),
(377600, 'PTHR45635:SF20', NULL, NULL, NULL, NULL, 'ADP/ATP TRANSLOCASE', 247663),
(377601, 'PTHR45635:SF8', NULL, NULL, NULL, NULL, 'ADP,ATP CARRIER PROTEIN ER-ANT1', 247663),
(377602, 'PTHR45635:SF45', NULL, NULL, NULL, NULL, 'ADP,ATP CARRIER PROTEIN, MITOCHONDRIAL', 247663),
(377603, 'PTHR45635:SF23', NULL, NULL, NULL, NULL, 'ADP/ATP TRANSLOCASE', 247663),
(377604, 'PTHR45635:SF44', NULL, NULL, NULL, NULL, 'ADP/ATP TRANSLOCASE', 247663),
(377605, 'PTHR45635:SF47', NULL, NULL, NULL, NULL, 'ADP,ATP CARRIER PROTEIN 2, MITOCHONDRIAL', 247663),
(377606, 'PTHR45635:SF46', NULL, NULL, NULL, NULL, 'ADP/ATP TRANSLOCASE', 247663);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(377607, 'PTHR45635:SF49', NULL, NULL, NULL, NULL, 'ADP,ATP CARRIER PROTEIN, MITOCHONDRIAL', 247663),
(377608, 'PTHR45635:SF27', NULL, NULL, NULL, NULL, 'ADP/ATP TRANSLOCASE', 247663),
(377609, 'PTHR45635:SF48', NULL, NULL, NULL, NULL, 'ADP/ATP TRANSLOCASE', 247663),
(377610, 'PTHR45635:SF28', NULL, NULL, NULL, NULL, 'ADP/ATP TRANSLOCASE', 247663),
(377611, 'PTHR45635:SF3', NULL, NULL, NULL, NULL, 'ADP/ATP TRANSLOCASE 2', 247663),
(377612, 'PTHR45635:SF50', NULL, NULL, NULL, NULL, 'ADP/ATP TRANSLOCASE', 247663),
(377613, 'PTHR45635:SF10', NULL, NULL, NULL, NULL, 'ADP/ATP TRANSLOCASE', 247663),
(377614, 'PTHR45635:SF32', NULL, NULL, NULL, NULL, 'ADP/ATP TRANSLOCASE 1', 247663),
(377615, 'PTHR45635:SF31', NULL, NULL, NULL, NULL, 'ADP/ATP TRANSLOCASE', 247663),
(377616, 'PTHR45635:SF33', NULL, NULL, NULL, NULL, 'ADP/ATP TRANSLOCASE', 247663),
(377617, 'PTHR45635:SF14', NULL, NULL, NULL, NULL, 'ADP/ATP TRANSLOCASE', 247663),
(377618, 'PTHR45635:SF13', NULL, NULL, NULL, NULL, 'ADP/ATP TRANSLOCASE 3', 247663),
(377619, 'PTHR45635:SF38', NULL, NULL, NULL, NULL, 'ADP/ATP TRANSLOCASE', 247663),
(377620, 'PTHR45635:SF16', NULL, NULL, NULL, NULL, 'ADP/ATP TRANSLOCASE', 247663),
(377621, 'PTHR45635:SF37', NULL, NULL, NULL, NULL, 'ADP/ATP TRANSLOCASE', 247663),
(377622, 'PTHR31766:SF2', NULL, NULL, NULL, NULL, 'GLABROUS1 ENHANCER-BINDING PROTEIN-LIKE 2', 247664),
(377623, 'PTHR31766:SF5', NULL, NULL, NULL, NULL, 'STOREKEEPER PROTEIN, PUTATIVE, EXPRESSED-RELATED', 247664),
(377624, 'PTHR31766', NULL, NULL, NULL, NULL, 'GLABROUS1 ENHANCER-BINDING PROTEIN-LIKE 2', 247664),
(377625, 'PTHR31766:SF6', NULL, NULL, NULL, NULL, 'TRAM, LAG1 AND CLN8 (TLC) LIPID-SENSING DOMAIN CONTAINING PROTEIN', 247664),
(377626, 'PTHR31766:SF9', NULL, NULL, NULL, NULL, 'TRAM/LAG1/CLN8-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 247664),
(377627, 'PTHR31766:SF8', NULL, NULL, NULL, NULL, 'TRAM, LAG1 AND CLN8 (TLC) LIPID-SENSING DOMAIN CONTAINING PROTEIN', 247664),
(377628, 'PTHR31766:SF10', NULL, NULL, NULL, NULL, 'TRAM, LAG1 AND CLN8 (TLC) LIPID-SENSING DOMAIN CONTAINING PROTEIN-RELATED', 247664),
(377629, 'PTHR46463:SF44', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 247665),
(377630, 'PTHR46463:SF66', NULL, NULL, NULL, NULL, 'BNAC09G36590D PROTEIN', 247665),
(377631, 'PTHR46463:SF67', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE', 247665),
(377632, 'PTHR46463:SF46', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RHB1A-RELATED', 247665),
(377633, 'PTHR46463:SF68', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RHF2A-LIKE ISOFORM X1', 247665),
(377634, 'PTHR46463:SF47', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RHF2A-LIKE', 247665),
(377635, 'PTHR46463:SF69', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 247665),
(377636, 'PTHR46463:SF64', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 247665),
(377637, 'PTHR46463', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE', 247665),
(377638, 'PTHR46463:SF80', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RHF2A-LIKE PROTEIN', 247665),
(377639, 'PTHR46463:SF81', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RHB1A-RELATED', 247665),
(377640, 'PTHR46463:SF82', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 247665),
(377641, 'PTHR46463:SF60', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 247665),
(377642, 'PTHR46463:SF83', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 247665),
(377643, 'PTHR46463:SF48', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 247665),
(377644, 'PTHR46463:SF27', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RHF2A', 247665),
(377645, 'PTHR46463:SF77', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 247665),
(377646, 'PTHR46463:SF55', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE AIRP1', 247665),
(377647, 'PTHR46463:SF78', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 247665),
(377648, 'PTHR46463:SF12', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 247665);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(377649, 'PTHR46463:SF79', NULL, NULL, NULL, NULL, 'OS03G0788800 PROTEIN', 247665),
(377650, 'PTHR46463:SF58', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SDIR1-LIKE', 247665),
(377651, 'PTHR46463:SF73', NULL, NULL, NULL, NULL, 'OS03G0598700 PROTEIN', 247665),
(377652, 'PTHR46463:SF74', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 247665),
(377653, 'PTHR46463:SF31', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RHF2A-LIKE', 247665),
(377654, 'PTHR46463:SF75', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 247665),
(377655, 'PTHR46463:SF76', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 247665),
(377656, 'PTHR46463:SF54', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 247665),
(377657, 'PTHR46463:SF10', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 247665),
(377658, 'PTHR46463:SF70', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 247665),
(377659, 'PTHR46463:SF71', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 247665),
(377660, 'PTHR46463:SF72', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE RHF2A, PUTATIVE-RELATED', 247665),
(377661, 'PTHR46463:SF59', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RHF2A', 247665),
(377662, 'PTHR46463:SF16', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RHF1A', 247665),
(377663, 'PTHR46463:SF38', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 247665),
(377664, 'PTHR23534:SF1', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN', 247666),
(377665, 'PTHR23534', NULL, NULL, NULL, NULL, 'MFS PERMEASE', 247666),
(377666, 'PTHR14494', NULL, NULL, NULL, NULL, 'ALADIN/ADRACALIN/AAAS', 247667),
(377667, 'PTHR14494:SF0', NULL, NULL, NULL, NULL, 'ALADIN', 247667),
(377668, 'PTHR30569', NULL, NULL, NULL, NULL, 'CYTOSINE TRANSPORTER CODB', 247668),
(377669, 'PTHR30569:SF0', NULL, NULL, NULL, NULL, 'CYTOSINE PERMEASE', 247668),
(377670, 'PTHR42974:SF1', NULL, NULL, NULL, NULL, 'TYPE-3 GLUTAMINE SYNTHETASE', 247669),
(377671, 'PTHR42974', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE', 247669),
(377672, 'PTHR35287:SF2', NULL, NULL, NULL, NULL, 'BNAA02G11880D PROTEIN', 247670),
(377673, 'PTHR35287:SF1', NULL, NULL, NULL, NULL, 'SI:ZFOS-911D5.4', 247670),
(377674, 'PTHR35287', NULL, NULL, NULL, NULL, 'SI:ZFOS-911D5.4', 247670),
(377675, 'PTHR30636', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247671),
(377676, 'PTHR30636:SF3', NULL, NULL, NULL, NULL, 'UPF0701 PROTEIN YICC', 247671),
(377677, 'PTHR17972:SF0', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 6', 247672),
(377678, 'PTHR17972', NULL, NULL, NULL, NULL, 'NUCLEOLAR RNA-ASSOCIATED PROTEIN', 247672),
(377679, 'PTHR14255:SF40', NULL, NULL, NULL, NULL, '', 247673),
(377680, 'PTHR14255:SF42', NULL, NULL, NULL, NULL, 'BNAA09G13620D PROTEIN', 247673),
(377681, 'PTHR14255:SF43', NULL, NULL, NULL, NULL, 'PROTEIN CEREBLON', 247673),
(377682, 'PTHR14255:SF44', NULL, NULL, NULL, NULL, '', 247673),
(377683, 'PTHR14255:SF23', NULL, NULL, NULL, NULL, 'OS01G0743600 PROTEIN', 247673),
(377684, 'PTHR14255:SF46', NULL, NULL, NULL, NULL, '', 247673),
(377685, 'PTHR14255:SF24', NULL, NULL, NULL, NULL, '', 247673),
(377686, 'PTHR14255:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CEREBLON', 247673),
(377687, 'PTHR14255:SF5', NULL, NULL, NULL, NULL, 'SULFITE EXPORTER TAUE/SAFE FAMILY PROTEIN 4', 247673),
(377688, 'PTHR14255:SF48', NULL, NULL, NULL, NULL, 'SULFITE EXPORTER TAUE/SAFE FAMILY PROTEIN 3-LIKE', 247673),
(377689, 'PTHR14255:SF26', NULL, NULL, NULL, NULL, '', 247673),
(377690, 'PTHR14255:SF49', NULL, NULL, NULL, NULL, 'BNAA04G15090D PROTEIN', 247673),
(377691, 'PTHR14255:SF28', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN TAUE-RELATED', 247673),
(377692, 'PTHR14255:SF29', NULL, NULL, NULL, NULL, '', 247673),
(377693, 'PTHR14255:SF3', NULL, NULL, NULL, NULL, 'SULFITE EXPORTER TAUE/SAFE FAMILY PROTEIN 1-RELATED', 247673),
(377694, 'PTHR14255:SF1', NULL, NULL, NULL, NULL, 'SULFITE EXPORTER TAUE/SAFE FAMILY PROTEIN 3', 247673),
(377695, 'PTHR14255:SF52', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN TAUE-RELATED', 247673);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(377696, 'PTHR14255:SF31', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN TAUE-RELATED', 247673),
(377697, 'PTHR14255:SF53', NULL, NULL, NULL, NULL, 'SULFITE EXPORTER TAUE/SAFE FAMILY PROTEIN 5-RELATED', 247673),
(377698, 'PTHR14255:SF54', NULL, NULL, NULL, NULL, 'SULFITE EXPORTER TAUE/SAFE FAMILY PROTEIN', 247673),
(377699, 'PTHR14255:SF32', NULL, NULL, NULL, NULL, 'SULFITE EXPORTER TAUE/SAFE FAMILY PROTEIN', 247673),
(377700, 'PTHR14255:SF56', NULL, NULL, NULL, NULL, '', 247673),
(377701, 'PTHR14255:SF57', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN TAUE-LIKE PROTEIN-RELATED', 247673),
(377702, 'PTHR14255:SF35', NULL, NULL, NULL, NULL, 'OS01G0786700 PROTEIN', 247673),
(377703, 'PTHR14255:SF58', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN', 247673),
(377704, 'PTHR14255:SF50', NULL, NULL, NULL, NULL, '', 247673),
(377705, 'PTHR14255:SF37', NULL, NULL, NULL, NULL, 'SULFITE EXPORTER TAUE/SAFE FAMILY PROTEIN', 247673),
(377706, 'PTHR14255', NULL, NULL, NULL, NULL, 'CEREBLON', 247673),
(377707, 'PTHR15827', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 2-INTERACTING PROTEIN', 247674),
(377708, 'PTHR15827:SF2', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 2-INTERACTING PROTEIN', 247674),
(377709, 'PTHR47126:SF9', NULL, NULL, NULL, NULL, '5''-ADENYLYLSULFATE REDUCTASE-LIKE 6-RELATED', 247675),
(377710, 'PTHR47126:SF5', NULL, NULL, NULL, NULL, '5''-ADENYLYLSULFATE REDUCTASE-LIKE 5', 247675),
(377711, 'PTHR47126:SF7', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 247675),
(377712, 'PTHR47126:SF8', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 247675),
(377713, 'PTHR47126:SF2', NULL, NULL, NULL, NULL, '5''-ADENYLYLSULFATE REDUCTASE-LIKE 6', 247675),
(377714, 'PTHR47126', NULL, NULL, NULL, NULL, '5''-ADENYLYLSULFATE REDUCTASE-LIKE 7', 247675),
(377715, 'PTHR47126:SF3', NULL, NULL, NULL, NULL, '5''-ADENYLYLSULFATE REDUCTASE-LIKE 7', 247675),
(377716, 'PTHR42745', NULL, NULL, NULL, NULL, '', 247676),
(377717, 'PTHR42745:SF2', NULL, NULL, NULL, NULL, 'ARABINOSE 5-PHOSPHATE ISOMERASE GUTQ', 247676),
(377718, 'PTHR42745:SF1', NULL, NULL, NULL, NULL, 'ARABINOSE 5-PHOSPHATE ISOMERASE KDSD', 247676),
(377719, 'PTHR31379', NULL, NULL, NULL, NULL, 'F-BOX C PROTEIN-RELATED-RELATED', 247677),
(377720, 'PTHR31379:SF5', NULL, NULL, NULL, NULL, 'F-BOX C PROTEIN', 247677),
(377721, 'PTHR31379:SF4', NULL, NULL, NULL, NULL, 'F-BOX C PROTEIN', 247677),
(377722, 'PTHR31379:SF3', NULL, NULL, NULL, NULL, 'F-BOX C PROTEIN', 247677),
(377723, 'PTHR31379:SF1', NULL, NULL, NULL, NULL, 'F-BOX C PROTEIN-RELATED', 247677),
(377724, 'PTHR34836', NULL, NULL, NULL, NULL, 'OS06G0188250 PROTEIN', 247678),
(377725, 'PTHR34836:SF5', NULL, NULL, NULL, NULL, '', 247678),
(377726, 'PTHR34836:SF1', NULL, NULL, NULL, NULL, 'OS09G0428600 PROTEIN', 247678),
(377727, 'PTHR24213:SF17', NULL, NULL, NULL, NULL, 'DEMATIN', 247679),
(377728, 'PTHR24213:SF6', NULL, NULL, NULL, NULL, 'ACTIN-BINDING LIM PROTEIN 2', 247679),
(377729, 'PTHR24213', NULL, NULL, NULL, NULL, 'ACTIN-BINDING LIM PROTEIN', 247679),
(377730, 'PTHR24213:SF0', NULL, NULL, NULL, NULL, 'ACTIN-BINDING LIM PROTEIN 3', 247679),
(377731, 'PTHR24213:SF9', NULL, NULL, NULL, NULL, 'UNCOORDINATED 115A, ISOFORM B-RELATED', 247679),
(377732, 'PTHR24213:SF18', NULL, NULL, NULL, NULL, 'ACTIN-BINDING LIM PROTEIN 1', 247679),
(377733, 'PTHR45948', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE DDB_G0269404-RELATED', 247680),
(377734, 'PTHR45948:SF2', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE DDB_G0269404-RELATED', 247680),
(377735, 'PTHR45948:SF1', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE 22-A', 247680),
(377736, 'PTHR45948:SF4', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE 15', 247680),
(377737, 'PTHR45948:SF3', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE 22', 247680),
(377738, 'PTHR45948:SF5', NULL, NULL, NULL, NULL, 'SPECIFICITY PROTEIN PHOSPHATASE, PUTATIVE-RELATED', 247680),
(377739, 'PTHR47109', NULL, NULL, NULL, NULL, 'NUCLEOREDOXIN-LIKE PROTEIN 1', 247681);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(377740, 'PTHR47109:SF1', NULL, NULL, NULL, NULL, 'NUCLEOREDOXIN-LIKE PROTEIN 1', 247681),
(377741, 'PTHR44525', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 27', 247682),
(377742, 'PTHR44525:SF1', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 27', 247682),
(377743, 'PTHR45532:SF4', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 247683),
(377744, 'PTHR45532:SF3', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 247683),
(377745, 'PTHR45532', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 97', 247683),
(377746, 'PTHR45532:SF1', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 97', 247683),
(377747, 'PTHR42864', NULL, NULL, NULL, NULL, 'LIGHT-INDEPENDENT PROTOCHLOROPHYLLIDE REDUCTASE IRON-SULFUR ATP-BINDING PROTEIN', 247684),
(377748, 'PTHR42864:SF2', NULL, NULL, NULL, NULL, 'LIGHT-INDEPENDENT PROTOCHLOROPHYLLIDE REDUCTASE IRON-SULFUR ATP-BINDING PROTEIN', 247684),
(377749, 'PTHR13697:SF56', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE', 247685),
(377750, 'PTHR13697:SF57', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE SUBUNIT ALPHA', 247685),
(377751, 'PTHR13697:SF58', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE', 247685),
(377752, 'PTHR13697:SF14', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE, LIVER TYPE', 247685),
(377753, 'PTHR13697', NULL, NULL, NULL, NULL, 'PHOSPHOFRUCTOKINASE', 247685),
(377754, 'PTHR13697:SF4', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE, MUSCLE TYPE', 247685),
(377755, 'PTHR13697:SF52', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE 3', 247685),
(377756, 'PTHR13697:SF5', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE, PLATELET TYPE', 247685),
(377757, 'PTHR13697:SF53', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE', 247685),
(377758, 'PTHR13697:SF8', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE 2', 247685),
(377759, 'PTHR45947:SF15', NULL, NULL, NULL, NULL, 'TEICHURONIC ACID BIOSYNTHESIS GLYCOSYLTRANSFERASE TUAC-RELATED', 247686),
(377760, 'PTHR45947:SF9', NULL, NULL, NULL, NULL, 'BNAA10G27550D PROTEIN', 247686),
(377761, 'PTHR45947', NULL, NULL, NULL, NULL, 'SULFOQUINOVOSYL TRANSFERASE SQD2', 247686),
(377762, 'PTHR45947:SF11', NULL, NULL, NULL, NULL, 'SLR1508 PROTEIN', 247686),
(377763, 'PTHR45947:SF12', NULL, NULL, NULL, NULL, 'GROUP 1 FAMILY GLYCOSYLTRANSFERASE', 247686),
(377764, 'PTHR45947:SF13', NULL, NULL, NULL, NULL, 'TRANSFERASE-RELATED', 247686),
(377765, 'PTHR45947:SF14', NULL, NULL, NULL, NULL, 'SLL1723 PROTEIN', 247686),
(377766, 'PTHR45947:SF3', NULL, NULL, NULL, NULL, 'SULFOQUINOVOSYL TRANSFERASE SQD2', 247686),
(377767, 'PTHR45947:SF2', NULL, NULL, NULL, NULL, 'OS01G0142300 PROTEIN', 247686),
(377768, 'PTHR45947:SF1', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE, GROUP 1 FAMILY PROTEIN, EXPRESSED', 247686),
(377769, 'PTHR45947:SF10', NULL, NULL, NULL, NULL, 'GDP-MANNOSE-DEPENDENT ALPHA-MANNOSYLTRANSFERASE-RELATED', 247686),
(377770, 'PTHR45947:SF7', NULL, NULL, NULL, NULL, 'SULFOQUINOVOSYL TRANSFERASE SQD2-LIKE', 247686),
(377771, 'PTHR44147:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG19152', 247687),
(377772, 'PTHR44147:SF2', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE SDR FAMILY MEMBER 1', 247687),
(377773, 'PTHR44147:SF3', NULL, NULL, NULL, NULL, 'DEHYDROGENASES, SHORT CHAIN', 247687),
(377774, 'PTHR44147', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE SDR FAMILY MEMBER 1', 247687),
(377775, 'PTHR47751:SF2', NULL, NULL, NULL, NULL, 'DLTD N-TERMINAL DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_8G00380)-RELATED', 247688),
(377776, 'PTHR47751:SF1', NULL, NULL, NULL, NULL, 'SUPERFAMILY HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G16580)-RELATED', 247688),
(377777, 'PTHR47751', NULL, NULL, NULL, NULL, 'SUPERFAMILY HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G16580)-RELATED', 247688),
(377778, 'PTHR46263:SF1', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING PROTEIN 7', 247689),
(377779, 'PTHR46263', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING PROTEIN 7', 247689);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(377780, 'PTHR46263:SF2', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING PROTEIN', 247689),
(377781, 'PTHR14024:SF25', NULL, NULL, NULL, NULL, 'PERILIPIN-2', 247690),
(377782, 'PTHR14024:SF11', NULL, NULL, NULL, NULL, 'PERILIPIN-3', 247690),
(377783, 'PTHR14024:SF53', NULL, NULL, NULL, NULL, 'LIPID STORAGE DROPLETS SURFACE-BINDING PROTEIN 2', 247690),
(377784, 'PTHR14024:SF51', NULL, NULL, NULL, NULL, 'PERILIPIN', 247690),
(377785, 'PTHR14024:SF9', NULL, NULL, NULL, NULL, 'PERILIPIN-5', 247690),
(377786, 'PTHR14024:SF48', NULL, NULL, NULL, NULL, 'PERILIPIN 6', 247690),
(377787, 'PTHR14024', NULL, NULL, NULL, NULL, 'PERILIPIN', 247690),
(377788, 'PTHR14024:SF49', NULL, NULL, NULL, NULL, 'LIPID STORAGE DROPLETS SURFACE-BINDING PROTEIN 1', 247690),
(377789, 'PTHR41807', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE 3', 247691),
(377790, 'PTHR41807:SF1', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE 3', 247691),
(377791, 'PTHR11347:SF179', NULL, NULL, NULL, NULL, '3'',5''-CYCLIC PHOSPHODIESTERASE PDE-3-RELATED', 247692),
(377792, 'PTHR11347:SF135', NULL, NULL, NULL, NULL, 'CAMP-SPECIFIC 3'',5''-CYCLIC PHOSPHODIESTERASE 4C', 247692),
(377793, 'PTHR11347:SF111', NULL, NULL, NULL, NULL, 'CAMP AND CAMP-INHIBITED CGMP 3'',5''-CYCLIC PHOSPHODIESTERASE 10A', 247692),
(377794, 'PTHR11347:SF210', NULL, NULL, NULL, NULL, '3'',5''-CYCLIC-NUCLEOTIDE PHOSPHODIESTERASE REGA', 247692),
(377795, 'PTHR11347:SF211', NULL, NULL, NULL, NULL, 'PDEASE DOMAIN-CONTAINING PROTEIN', 247692),
(377796, 'PTHR11347:SF198', NULL, NULL, NULL, NULL, 'HIGH AFFINITY CGMP-SPECIFIC 3'',5''-CYCLIC PHOSPHODIESTERASE 9A', 247692),
(377797, 'PTHR11347:SF130', NULL, NULL, NULL, NULL, 'DUAL 3'',5''-CYCLIC-AMP AND -GMP PHOSPHODIESTERASE 11A', 247692),
(377798, 'PTHR11347:SF196', NULL, NULL, NULL, NULL, 'PHOSPHODIESTERASE', 247692),
(377799, 'PTHR11347:SF194', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-DEPENDENT 3'',5''-CYCLIC NUCLEOTIDE PHOSPHODIESTERASE 1B', 247692),
(377800, 'PTHR11347:SF191', NULL, NULL, NULL, NULL, 'PHOSPHODIESTERASE', 247692),
(377801, 'PTHR11347:SF34', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-DEPENDENT 3'',5''-CYCLIC NUCLEOTIDE PHOSPHODIESTERASE 1A', 247692),
(377802, 'PTHR11347:SF218', NULL, NULL, NULL, NULL, 'PHOSPHODIESTERASE', 247692),
(377803, 'PTHR11347:SF32', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-DEPENDENT 3'',5''-CYCLIC NUCLEOTIDE PHOSPHODIESTERASE 1C', 247692),
(377804, 'PTHR11347:SF98', NULL, NULL, NULL, NULL, 'HIGH AFFINITY CAMP-SPECIFIC AND IBMX-INSENSITIVE 3'',5''-CYCLIC PHOSPHODIESTERASE 8B', 247692),
(377805, 'PTHR11347:SF219', NULL, NULL, NULL, NULL, 'CAMP-SPECIFIC 3'',5''-CYCLIC PHOSPHODIESTERASE, ISOFORM I', 247692),
(377806, 'PTHR11347:SF139', NULL, NULL, NULL, NULL, 'PHOSPHODIESTERASE', 247692),
(377807, 'PTHR11347:SF216', NULL, NULL, NULL, NULL, 'PHOSPHODIESTERASE', 247692),
(377808, 'PTHR11347:SF74', NULL, NULL, NULL, NULL, 'CAMP-SPECIFIC 3'',5''-CYCLIC PHOSPHODIESTERASE 4A', 247692),
(377809, 'PTHR11347:SF96', NULL, NULL, NULL, NULL, 'HIGH AFFINITY CAMP-SPECIFIC 3'',5''-CYCLIC PHOSPHODIESTERASE 7A', 247692),
(377810, 'PTHR11347:SF73', NULL, NULL, NULL, NULL, 'ROD CGMP-SPECIFIC 3'',5''-CYCLIC PHOSPHODIESTERASE SUBUNIT BETA', 247692),
(377811, 'PTHR11347:SF115', NULL, NULL, NULL, NULL, 'ROD CGMP-SPECIFIC 3'',5''-CYCLIC PHOSPHODIESTERASE SUBUNIT ALPHA', 247692),
(377812, 'PTHR11347:SF72', NULL, NULL, NULL, NULL, 'CAMP-SPECIFIC 3'',5''-CYCLIC PHOSPHODIESTERASE 7B', 247692),
(377813, 'PTHR11347:SF223', NULL, NULL, NULL, NULL, 'PHOSPHODIESTERASE', 247692),
(377814, 'PTHR11347:SF102', NULL, NULL, NULL, NULL, '3'',5''-CYCLIC PHOSPHODIESTERASE PDE-2-RELATED', 247692),
(377815, 'PTHR11347:SF224', NULL, NULL, NULL, NULL, 'PHOSPHODIESTERASE', 247692),
(377816, 'PTHR11347:SF91', NULL, NULL, NULL, NULL, 'CAMP-SPECIFIC 3'',5''-CYCLIC PHOSPHODIESTERASE 4D', 247692),
(377817, 'PTHR11347:SF221', NULL, NULL, NULL, NULL, 'DUAL 3'',5''-CYCLIC-AMP AND -GMP PHOSPHODIESTERASE 11', 247692),
(377818, 'PTHR11347:SF222', NULL, NULL, NULL, NULL, '3''5''-CYCLIC NUCLEOTIDE PHOSPHODIESTERASE', 247692);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(377819, 'PTHR11347:SF220', NULL, NULL, NULL, NULL, 'PHOSPHODIESTERASE', 247692),
(377820, 'PTHR11347:SF184', NULL, NULL, NULL, NULL, 'PHOSPHODIESTERASE', 247692),
(377821, 'PTHR11347:SF29', NULL, NULL, NULL, NULL, 'PHOSPHODIESTERASE', 247692),
(377822, 'PTHR11347', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE PHOSPHODIESTERASE', 247692),
(377823, 'PTHR11347:SF209', NULL, NULL, NULL, NULL, 'HIGH AFFINITY CGMP-SPECIFIC 3'',5''-CYCLIC PHOSPHODIESTERASE 9A', 247692),
(377824, 'PTHR11347:SF23', NULL, NULL, NULL, NULL, 'CONE CGMP-SPECIFIC 3'',5''-CYCLIC PHOSPHODIESTERASE SUBUNIT ALPHA''', 247692),
(377825, 'PTHR11347:SF108', NULL, NULL, NULL, NULL, 'CAMP-SPECIFIC 3'',5''-CYCLIC PHOSPHODIESTERASE 4B', 247692),
(377826, 'PTHR11347:SF20', NULL, NULL, NULL, NULL, 'PHOSPHODIESTERASE', 247692),
(377827, 'PTHR11347:SF85', NULL, NULL, NULL, NULL, 'HIGH AFFINITY CAMP-SPECIFIC AND IBMX-INSENSITIVE 3'',5''-CYCLIC PHOSPHODIESTERASE 8A', 247692),
(377828, 'PTHR11347:SF206', NULL, NULL, NULL, NULL, 'HIGH AFFINITY CAMP-SPECIFIC AND IBMX-INSENSITIVE 3'',5''-CYCLIC PHOSPHODIESTERASE 8', 247692),
(377829, 'PTHR11347:SF104', NULL, NULL, NULL, NULL, 'PHOSPHODIESTERASE', 247692),
(377830, 'PTHR11347:SF225', NULL, NULL, NULL, NULL, 'GAF DOMAIN CONTAINING PROTEIN', 247692),
(377831, 'PTHR11347:SF226', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-DEPENDENT 3'',5''-CYCLIC NUCLEOTIDE PHOSPHODIESTERASE 1', 247692),
(377832, 'PTHR48012:SF1', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE OSR1', 247693),
(377833, 'PTHR48012:SF3', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0292350-RELATED', 247693),
(377834, 'PTHR48012:SF2', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 10', 247693),
(377835, 'PTHR48012:SF4', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE A', 247693),
(377836, 'PTHR48012:SF17', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE KINASE 3', 247693),
(377837, 'PTHR48012:SF7', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 26', 247693),
(377838, 'PTHR48012:SF28', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PAKE-RELATED', 247693),
(377839, 'PTHR48012:SF18', NULL, NULL, NULL, NULL, 'HAPPYHOUR, ISOFORM A', 247693),
(377840, 'PTHR48012:SF6', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE KINASE 2', 247693),
(377841, 'PTHR48012:SF29', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NAK1', 247693),
(377842, 'PTHR48012:SF9', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 25', 247693),
(377843, 'PTHR48012:SF19', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE KINASE 5', 247693),
(377844, 'PTHR48012:SF8', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247693),
(377845, 'PTHR48012:SF14', NULL, NULL, NULL, NULL, 'STE20/SPS1-RELATED PROLINE-ALANINE-RICH PROTEIN KINASE', 247693),
(377846, 'PTHR48012:SF26', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0283821-RELATED', 247693),
(377847, 'PTHR48012:SF15', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE KINASE 1', 247693),
(377848, 'PTHR48012:SF16', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247693),
(377849, 'PTHR48012:SF27', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SID1', 247693),
(377850, 'PTHR48012:SF10', NULL, NULL, NULL, NULL, 'FI20177P1', 247693),
(377851, 'PTHR48012:SF21', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE KIC1', 247693),
(377852, 'PTHR48012:SF11', NULL, NULL, NULL, NULL, 'STE20-LIKE SERINE/THREONINE-PROTEIN KINASE', 247693),
(377853, 'PTHR48012:SF22', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 24', 247693),
(377854, 'PTHR48012:SF12', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 247693),
(377855, 'PTHR48012', NULL, NULL, NULL, NULL, 'STERILE20-LIKE KINASE, ISOFORM B-RELATED', 247693),
(377856, 'PTHR40412', NULL, NULL, NULL, NULL, 'SF-ASSEMBLIN', 247694),
(377857, 'PTHR40412:SF1', NULL, NULL, NULL, NULL, 'ASSEMBLING PROTEIN, PUTATIVE-RELATED', 247694);
INSERT INTO "PUBLIC"."MODEL" VALUES
(377858, 'PTHR11132:SF495', NULL, NULL, NULL, NULL, 'TRIOSE PHOSPHATE/PHOSPHATE TRANSLOCATOR TPT, CHLOROPLASTIC', 247695),
(377859, 'PTHR11132:SF374', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377860, 'PTHR11132:SF494', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377861, 'PTHR11132:SF497', NULL, NULL, NULL, NULL, 'OS06G0153200 PROTEIN', 247695),
(377862, 'PTHR11132:SF255', NULL, NULL, NULL, NULL, 'GDP-FUCOSE TRANSPORTER 1', 247695),
(377863, 'PTHR11132:SF530', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE/PHOSPHATE TRANSLOCATOR-LIKE PROTEIN', 247695),
(377864, 'PTHR11132:SF375', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377865, 'PTHR11132:SF496', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE/PHOSPHATE TRANSLOCATOR 1, CHLOROPLASTIC', 247695),
(377866, 'PTHR11132:SF491', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE/PHOSPHATE TRANSLOCATOR 1, CHLOROPLASTIC', 247695),
(377867, 'PTHR11132:SF490', NULL, NULL, NULL, NULL, 'OS05G0168700 PROTEIN', 247695),
(377868, 'PTHR11132:SF493', NULL, NULL, NULL, NULL, 'UDP-GALACTOSE TRANSPORTER 2', 247695),
(377869, 'PTHR11132:SF251', NULL, NULL, NULL, NULL, 'GDP-MANNOSE TRANSPORTER GONST1', 247695),
(377870, 'PTHR11132:SF372', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377871, 'PTHR11132:SF250', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 35 MEMBER E3', 247695),
(377872, 'PTHR11132:SF492', NULL, NULL, NULL, NULL, 'UDP-RHAMNOSE/UDP-GALACTOSE TRANSPORTER 2', 247695),
(377873, 'PTHR11132:SF416', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377874, 'PTHR11132:SF257', NULL, NULL, NULL, NULL, 'UDP-XYLOSE TRANSPORTER 1', 247695),
(377875, 'PTHR11132:SF499', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377876, 'PTHR11132:SF531', NULL, NULL, NULL, NULL, 'OS07G0581000 PROTEIN', 247695),
(377877, 'PTHR11132:SF410', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377878, 'PTHR11132:SF498', NULL, NULL, NULL, NULL, 'NUCLEOTIDE/SUGAR TRANSPORTER FAMILY', 247695),
(377879, 'PTHR11132:SF413', NULL, NULL, NULL, NULL, 'BNAA02G17980D PROTEIN', 247695),
(377880, 'PTHR11132:SF412', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377881, 'PTHR11132:SF258', NULL, NULL, NULL, NULL, 'GDP-MANNOSE TRANSPORTER 1-RELATED', 247695),
(377882, 'PTHR11132:SF379', NULL, NULL, NULL, NULL, 'SUGAR PHOSPHATE TRANSPORTER DOMAIN-CONTAINING PROTEIN-RELATED', 247695),
(377883, 'PTHR11132:SF419', NULL, NULL, NULL, NULL, 'UDP-GALACTOSE TRANSPORTER 2-LIKE', 247695),
(377884, 'PTHR11132:SF420', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377885, 'PTHR11132:SF387', NULL, NULL, NULL, NULL, 'BNAANNG38660D PROTEIN', 247695),
(377886, 'PTHR11132:SF380', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377887, 'PTHR11132:SF262', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE/UDP-GLUCOSE/GDP-MANNOSE TRANSPORTER', 247695),
(377888, 'PTHR11132:SF426', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_2G17760)', 247695),
(377889, 'PTHR11132:SF425', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377890, 'PTHR11132:SF304', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377891, 'PTHR11132:SF307', NULL, NULL, NULL, NULL, 'OS08G0187800 PROTEIN', 247695),
(377892, 'PTHR11132:SF427', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 35 MEMBER E1', 247695),
(377893, 'PTHR11132:SF422', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377894, 'PTHR11132:SF421', NULL, NULL, NULL, NULL, 'TRIOSE PHOSPHATE/PHOSPHOENOLPYRUVATE TRANSLOCATOR-RELATED', 247695),
(377895, 'PTHR11132:SF388', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377896, 'PTHR11132:SF303', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377897, 'PTHR11132:SF424', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377898, 'PTHR11132:SF423', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377899, 'PTHR11132:SF269', NULL, NULL, NULL, NULL, 'TRIOSE PHOSPHATE/PHOSPHATE TRANSLOCATOR TPT, CHLOROPLASTIC', 247695);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(377900, 'PTHR11132:SF309', NULL, NULL, NULL, NULL, 'OS08G0135100 PROTEIN', 247695),
(377901, 'PTHR11132:SF308', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377902, 'PTHR11132:SF390', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377903, 'PTHR11132:SF274', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE/PHOSPHATE TRANSLOCATOR 2 CHLOROPLASTIC', 247695),
(377904, 'PTHR11132:SF431', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377905, 'PTHR11132:SF392', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377906, 'PTHR11132:SF270', NULL, NULL, NULL, NULL, 'OS02G0154600 PROTEIN', 247695),
(377907, 'PTHR11132:SF273', NULL, NULL, NULL, NULL, '', 247695),
(377908, 'PTHR11132:SF393', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377909, 'PTHR11132:SF437', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377910, 'PTHR11132:SF439', NULL, NULL, NULL, NULL, 'UDP-RHAMNOSE/UDP-GALACTOSE TRANSPORTER 1', 247695),
(377911, 'PTHR11132:SF318', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE/PHOSPHATE TRANSLOCATOR 3, CHLOROPLASTIC', 247695),
(377912, 'PTHR11132:SF312', NULL, NULL, NULL, NULL, 'TRIOSE-PHOSPHATE / PHOSPHATE TRANSLOCATOR', 247695),
(377913, 'PTHR11132:SF432', NULL, NULL, NULL, NULL, 'NUCLEOTIDE/SUGAR TRANSPORTER FAMILY PROTEIN', 247695),
(377914, 'PTHR11132:SF313', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-SUGAR TRANSPORTER FAMILY PROTEIN', 247695),
(377915, 'PTHR11132', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 35', 247695),
(377916, 'PTHR11132:SF285', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377917, 'PTHR11132:SF321', NULL, NULL, NULL, NULL, 'UDP-RHAMNOSE/UDP-GALACTOSE TRANSPORTER 3', 247695),
(377918, 'PTHR11132:SF441', NULL, NULL, NULL, NULL, 'SUGAR PHOSPHATE TRANSPORTER DOMAIN-CONTAINING PROTEIN-RELATED', 247695),
(377919, 'PTHR11132:SF282', NULL, NULL, NULL, NULL, 'UDP-GALACTOSE/UDP-GLUCOSE TRANSPORTER 7', 247695),
(377920, 'PTHR11132:SF161', NULL, NULL, NULL, NULL, 'DMT FAMILY ORGANIC ANION TRANSPORTER (EUROFUNG)', 247695),
(377921, 'PTHR11132:SF283', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN, PUTATIVE, EXPRESSED-RELATED', 247695),
(377922, 'PTHR11132:SF326', NULL, NULL, NULL, NULL, 'UDP-RHAMNOSE/UDP-GALACTOSE TRANSPORTER 6', 247695),
(377923, 'PTHR11132:SF447', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377924, 'PTHR11132:SF329', NULL, NULL, NULL, NULL, 'OS12G0154000 PROTEIN', 247695),
(377925, 'PTHR11132:SF323', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377926, 'PTHR11132:SF444', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377927, 'PTHR11132:SF289', NULL, NULL, NULL, NULL, 'OS03G0622700 PROTEIN', 247695),
(377928, 'PTHR11132:SF443', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 247695),
(377929, 'PTHR11132:SF291', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377930, 'PTHR11132:SF451', NULL, NULL, NULL, NULL, 'UDP-XYLOSE TRANSPORTER 2-RELATED', 247695),
(377931, 'PTHR11132:SF453', NULL, NULL, NULL, NULL, 'OS01G0802850 PROTEIN', 247695),
(377932, 'PTHR11132:SF298', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE/UDP-GLUCOSE/GDP-MANNOSE TRANSPORTER', 247695),
(377933, 'PTHR11132:SF293', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 35 MEMBER E4', 247695),
(377934, 'PTHR11132:SF292', NULL, NULL, NULL, NULL, 'OS05G0121900 PROTEIN', 247695),
(377935, 'PTHR11132:SF455', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377936, 'PTHR11132:SF333', NULL, NULL, NULL, NULL, 'OS09G0314333 PROTEIN', 247695),
(377937, 'PTHR11132:SF454', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377938, 'PTHR11132:SF457', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377939, 'PTHR11132:SF336', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377940, 'PTHR11132:SF456', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377941, 'PTHR11132:SF461', NULL, NULL, NULL, NULL, 'NODULIN MTN21 /EAMA-LIKE TRANSPORTER FAMILY PROTEIN-RELATED', 247695);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(377942, 'PTHR11132:SF464', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377943, 'PTHR11132:SF503', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377944, 'PTHR11132:SF348', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377945, 'PTHR11132:SF502', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-SUGAR TRANSPORTER', 247695),
(377946, 'PTHR11132:SF505', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377947, 'PTHR11132:SF504', NULL, NULL, NULL, NULL, 'GDP-MANNOSE TRANSPORTER GONST3', 247695),
(377948, 'PTHR11132:SF466', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-SUGAR TRANSPORTER FAMILY PROTEIN', 247695),
(377949, 'PTHR11132:SF345', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377950, 'PTHR11132:SF344', NULL, NULL, NULL, NULL, 'NUCLEOTIDE/SUGAR TRANSPORTER FAMILY PROTEIN ISOFORM 1', 247695),
(377951, 'PTHR11132:SF501', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE/PHOSPHATE TRANSLOCATOR 2, CHLOROPLASTIC-RELATED', 247695),
(377952, 'PTHR11132:SF347', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377953, 'PTHR11132:SF346', NULL, NULL, NULL, NULL, 'NUCLEOTIDE/SUGAR TRANSPORTER FAMILY PROTEIN', 247695),
(377954, 'PTHR11132:SF500', NULL, NULL, NULL, NULL, 'OS03G0286300 PROTEIN', 247695),
(377955, 'PTHR11132:SF507', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377956, 'PTHR11132:SF506', NULL, NULL, NULL, NULL, 'OS02G0724500 PROTEIN', 247695),
(377957, 'PTHR11132:SF509', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377958, 'PTHR11132:SF508', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377959, 'PTHR11132:SF473', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-SUGAR TRANSPORTER FAMILY PROTEIN', 247695),
(377960, 'PTHR11132:SF352', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377961, 'PTHR11132:SF351', NULL, NULL, NULL, NULL, 'XYLULOSE 5-PHOSPHATE/PHOSPHATE TRANSLOCATOR, CHLOROPLASTIC', 247695),
(377962, 'PTHR11132:SF472', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377963, 'PTHR11132:SF474', NULL, NULL, NULL, NULL, 'SUGAR PHOSPHATE TRANSPORTER DOMAIN-CONTAINING PROTEIN-RELATED', 247695),
(377964, 'PTHR11132:SF471', NULL, NULL, NULL, NULL, 'GDP-MANNOSE TRANSPORTER GONST3-LIKE', 247695),
(377965, 'PTHR11132:SF470', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377966, 'PTHR11132:SF239', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377967, 'PTHR11132:SF514', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377968, 'PTHR11132:SF513', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377969, 'PTHR11132:SF238', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 35 MEMBER C2', 247695),
(377970, 'PTHR11132:SF516', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377971, 'PTHR11132:SF515', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 35 MEMBER D3', 247695),
(377972, 'PTHR11132:SF510', NULL, NULL, NULL, NULL, 'SUGAR PHOSPHATE TRANSPORTER DOMAIN-CONTAINING PROTEIN-RELATED', 247695),
(377973, 'PTHR11132:SF356', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377974, 'PTHR11132:SF476', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377975, 'PTHR11132:SF512', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377976, 'PTHR11132:SF478', NULL, NULL, NULL, NULL, 'GDP-MANNOSE TRANSPORTER', 247695),
(377977, 'PTHR11132:SF511', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 241', 247695),
(377978, 'PTHR11132:SF518', NULL, NULL, NULL, NULL, 'OS04G0692000 PROTEIN', 247695),
(377979, 'PTHR11132:SF517', NULL, NULL, NULL, NULL, 'UDP-RHAMNOSE/UDP-GALACTOSE TRANSPORTER 2-LIKE', 247695),
(377980, 'PTHR11132:SF519', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE/PHOSPHATE TRANSLOCATOR 1, CHLOROPLASTIC', 247695),
(377981, 'PTHR11132:SF363', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377982, 'PTHR11132:SF484', NULL, NULL, NULL, NULL, 'UDP-RHAMNOSE/UDP-GALACTOSE TRANSPORTER 4', 247695);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(377983, 'PTHR11132:SF483', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE/PHOSPHATE TRANSLOCATOR 2, CHLOROPLASTIC', 247695),
(377984, 'PTHR11132:SF241', NULL, NULL, NULL, NULL, 'GDP-FUCOSE TRANSPORTER 1', 247695),
(377985, 'PTHR11132:SF486', NULL, NULL, NULL, NULL, 'OS07G0523400 PROTEIN', 247695),
(377986, 'PTHR11132:SF485', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377987, 'PTHR11132:SF364', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE/PHOSPHATE TRANSLOCATOR 2, CHLOROPLASTIC', 247695),
(377988, 'PTHR11132:SF480', NULL, NULL, NULL, NULL, 'GDP-MANNOSE TRANSPORTER 2', 247695),
(377989, 'PTHR11132:SF482', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377990, 'PTHR11132:SF240', NULL, NULL, NULL, NULL, 'UDP-SUGAR TRANSPORTER UST74C', 247695),
(377991, 'PTHR11132:SF481', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377992, 'PTHR11132:SF525', NULL, NULL, NULL, NULL, 'TRIOSE-PHOSPHATE TRANSPORTER FAMILY PROTEIN', 247695),
(377993, 'PTHR11132:SF524', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377994, 'PTHR11132:SF527', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377995, 'PTHR11132:SF526', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377996, 'PTHR11132:SF405', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(377997, 'PTHR11132:SF521', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 35 MEMBER E2A-RELATED', 247695),
(377998, 'PTHR11132:SF488', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE/PHOSPHATE TRANSLOCATOR 1, CHLOROPLASTIC-LIKE', 247695),
(377999, 'PTHR11132:SF400', NULL, NULL, NULL, NULL, 'UDP-URONIC ACID TRANSPORTER 1', 247695),
(378000, 'PTHR11132:SF520', NULL, NULL, NULL, NULL, 'DMT FAMILY TRANSPORTER (EUROFUNG)', 247695),
(378001, 'PTHR11132:SF487', NULL, NULL, NULL, NULL, 'BNAC02G09280D PROTEIN', 247695),
(378002, 'PTHR11132:SF523', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-SUGAR TRANSPORTER FAMILY PROTEIN-RELATED', 247695),
(378003, 'PTHR11132:SF247', NULL, NULL, NULL, NULL, 'UDP-GLUCURONIC ACID/UDP-N-ACETYLGALACTOSAMINE TRANSPORTER', 247695),
(378004, 'PTHR11132:SF522', NULL, NULL, NULL, NULL, 'NUCLEOTIDE/SUGAR TRANSPORTER FAMILY PROTEIN', 247695),
(378005, 'PTHR11132:SF489', NULL, NULL, NULL, NULL, 'OS02G0614500 PROTEIN', 247695),
(378006, 'PTHR11132:SF529', NULL, NULL, NULL, NULL, 'SUGAR PHOSPHATE TRANSPORTER DOMAIN-CONTAINING PROTEIN-RELATED', 247695),
(378007, 'PTHR11132:SF528', NULL, NULL, NULL, NULL, 'GDP-MANNOSE TRANSPORTER GONST5', 247695),
(378008, 'PTHR11132:SF409', NULL, NULL, NULL, NULL, 'TPT DOMAIN-CONTAINING PROTEIN', 247695),
(378009, 'PTHR12505:SF22', NULL, NULL, NULL, NULL, 'BAH AND COILED-COIL DOMAIN-CONTAINING PROTEIN 1', 247696),
(378010, 'PTHR12505:SF21', NULL, NULL, NULL, NULL, 'TRINUCLEOTIDE REPEAT-CONTAINING GENE 18 PROTEIN', 247696),
(378011, 'PTHR12505', NULL, NULL, NULL, NULL, 'PHD FINGER TRANSCRIPTION FACTOR', 247696),
(378012, 'PTHR12505:SF25', NULL, NULL, NULL, NULL, 'BAH DOMAIN AND COILED-COIL-CONTAINING 1A', 247696),
(378013, 'PTHR12505:SF24', NULL, NULL, NULL, NULL, 'PROTEIN WINGED EYE', 247696),
(378014, 'PTHR47844:SF1', NULL, NULL, NULL, NULL, 'EXOSTOSIN-LIKE 2', 247697),
(378015, 'PTHR47844', NULL, NULL, NULL, NULL, 'SYNTHASE CPS1, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G02500)-RELATED', 247697),
(378016, 'PTHR43681:SF1', NULL, NULL, NULL, NULL, 'SARCALUMENIN', 247698),
(378017, 'PTHR43681', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE GTPASE FZO', 247698),
(378018, 'PTHR28624:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL POTASSIUM CHANNEL', 247699),
(378019, 'PTHR28624', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 51', 247699),
(378020, 'PTHR21963:SF1', NULL, NULL, NULL, NULL, 'SPERM-ASSOCIATED ANTIGEN 17', 247700),
(378021, 'PTHR21963', NULL, NULL, NULL, NULL, 'PF6', 247700),
(378022, 'PTHR46586:SF3', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 247701),
(378023, 'PTHR46586:SF2', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 247701),
(378024, 'PTHR46586:SF5', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 247701);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(378025, 'PTHR46586:SF4', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 247701),
(378026, 'PTHR46586:SF7', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING PROTEIN', 247701),
(378027, 'PTHR46586', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING PROTEIN', 247701),
(378028, 'PTHR46586:SF1', NULL, NULL, NULL, NULL, '', 247701),
(378029, 'PTHR16301:SF25', NULL, NULL, NULL, NULL, 'PROTEIN IMPACT', 247702),
(378030, 'PTHR16301:SF24', NULL, NULL, NULL, NULL, 'RWD DOMAIN-CONTAINING PROTEIN', 247702),
(378031, 'PTHR16301:SF20', NULL, NULL, NULL, NULL, 'IMPACT FAMILY MEMBER YIGZ', 247702),
(378032, 'PTHR16301:SF4', NULL, NULL, NULL, NULL, 'UPF0029 DOMAIN-CONTAINING PROTEIN', 247702),
(378033, 'PTHR16301:SF17', NULL, NULL, NULL, NULL, 'IMPACT FAMILY MEMBER YDL177C', 247702),
(378034, 'PTHR16301', NULL, NULL, NULL, NULL, 'IMPACT-RELATED', 247702),
(378035, 'PTHR16301:SF26', NULL, NULL, NULL, NULL, 'IMPACT FAMILY MEMBER C14C8.09C', 247702),
(378036, 'PTHR33076:SF5', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN 14-RELATED', 247703),
(378037, 'PTHR33076:SF170', NULL, NULL, NULL, NULL, 'PROTEIN ARABIDOPSIS THALIANA ANTHER 7', 247703),
(378038, 'PTHR33076:SF171', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN LAC S 1', 247703),
(378039, 'PTHR33076:SF128', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378040, 'PTHR33076:SF125', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378041, 'PTHR33076:SF72', NULL, NULL, NULL, NULL, 'LIPID TRANSFER PROTEIN', 247703),
(378042, 'PTHR33076:SF169', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN 2A', 247703),
(378043, 'PTHR33076:SF126', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN 1-RELATED', 247703),
(378044, 'PTHR33076:SF71', NULL, NULL, NULL, NULL, 'PLANT LIPID TRANSFER PROTEIN/PAR ALLERGEN-RELATED', 247703),
(378045, 'PTHR33076:SF129', NULL, NULL, NULL, NULL, 'OS03G0808500 PROTEIN', 247703),
(378046, 'PTHR33076:SF78', NULL, NULL, NULL, NULL, 'LIPID TRANSFER PROTEIN', 247703),
(378047, 'PTHR33076:SF163', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378048, 'PTHR33076:SF77', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378049, 'PTHR33076:SF164', NULL, NULL, NULL, NULL, '', 247703),
(378050, 'PTHR33076:SF161', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN 1', 247703),
(378051, 'PTHR33076:SF162', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN 4', 247703),
(378052, 'PTHR33076:SF74', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378053, 'PTHR33076:SF167', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN 15-RELATED', 247703),
(378054, 'PTHR33076:SF168', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378055, 'PTHR33076:SF73', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 247703),
(378056, 'PTHR33076:SF165', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378057, 'PTHR33076:SF75', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378058, 'PTHR33076:SF166', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378059, 'PTHR33076:SF160', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 247703),
(378060, 'PTHR33076:SF116', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378061, 'PTHR33076:SF117', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378062, 'PTHR33076:SF158', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378063, 'PTHR33076:SF115', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378064, 'PTHR33076:SF159', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378065, 'PTHR33076:SF118', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378066, 'PTHR33076:SF67', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN 2-LIKE', 247703),
(378067, 'PTHR33076:SF66', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN 3', 247703);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(378068, 'PTHR33076:SF153', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378069, 'PTHR33076:SF69', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN 9', 247703),
(378070, 'PTHR33076:SF24', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN 2', 247703),
(378071, 'PTHR33076', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN 2-RELATED', 247703),
(378072, 'PTHR33076:SF112', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378073, 'PTHR33076:SF156', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378074, 'PTHR33076:SF62', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN 8', 247703),
(378075, 'PTHR33076:SF157', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 247703),
(378076, 'PTHR33076:SF65', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378077, 'PTHR33076:SF21', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN 13', 247703),
(378078, 'PTHR33076:SF110', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 247703),
(378079, 'PTHR33076:SF64', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378080, 'PTHR33076:SF59', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378081, 'PTHR33076:SF92', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378082, 'PTHR33076:SF105', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378083, 'PTHR33076:SF106', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN 11', 247703),
(378084, 'PTHR33076:SF94', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 247703),
(378085, 'PTHR33076:SF50', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN 10-RELATED', 247703),
(378086, 'PTHR33076:SF148', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378087, 'PTHR33076:SF104', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378088, 'PTHR33076:SF90', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 247703),
(378089, 'PTHR33076:SF107', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 247703),
(378090, 'PTHR33076:SF56', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378091, 'PTHR33076:SF141', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378092, 'PTHR33076:SF55', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378093, 'PTHR33076:SF58', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378094, 'PTHR33076:SF57', NULL, NULL, NULL, NULL, 'LIPID TRANSFER PROTEIN', 247703),
(378095, 'PTHR33076:SF145', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN 3-LIKE', 247703),
(378096, 'PTHR33076:SF146', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN 2', 247703),
(378097, 'PTHR33076:SF102', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378098, 'PTHR33076:SF95', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378099, 'PTHR33076:SF51', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN 1', 247703),
(378100, 'PTHR33076:SF54', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN-LIKE', 247703),
(378101, 'PTHR33076:SF98', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN 13-LIKE', 247703),
(378102, 'PTHR33076:SF100', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378103, 'PTHR33076:SF53', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378104, 'PTHR33076:SF49', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378105, 'PTHR33076:SF138', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378106, 'PTHR33076:SF81', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', 247703),
(378107, 'PTHR33076:SF80', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN 3-RELATED', 247703),
(378108, 'PTHR33076:SF139', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(378109, 'PTHR33076:SF82', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN 5', 247703),
(378110, 'PTHR33076:SF137', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378111, 'PTHR33076:SF130', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378112, 'PTHR33076:SF174', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN 13-LIKE', 247703),
(378113, 'PTHR33076:SF131', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378114, 'PTHR33076:SF175', NULL, NULL, NULL, NULL, 'LIPID TRANSFER PROTEIN', 247703),
(378115, 'PTHR33076:SF172', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 247703),
(378116, 'PTHR33076:SF173', NULL, NULL, NULL, NULL, '', 247703),
(378117, 'PTHR33076:SF46', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN 1-LIKE', 247703),
(378118, 'PTHR33076:SF134', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN 1', 247703),
(378119, 'PTHR33076:SF85', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN 12', 247703),
(378120, 'PTHR33076:SF135', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378121, 'PTHR33076:SF132', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378122, 'PTHR33076:SF133', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN', 247703),
(378123, 'PTHR35892:SF2', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN PAGN', 247704),
(378124, 'PTHR35892:SF3', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN X', 247704),
(378125, 'PTHR35892', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN PAGN-RELATED', 247704),
(378126, 'PTHR30327:SF1', NULL, NULL, NULL, NULL, 'UPF0301 PROTEIN YQGE', 247705),
(378127, 'PTHR30327', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN YQGE', 247705),
(378128, 'PTHR47047:SF1', NULL, NULL, NULL, NULL, 'CYSTEINE PEPTIDASE, PUTATIVE CYSTEINE PEPTIDASE, CLAN CA, FAMILY C2, PUTATIVE-RELATED', 247706),
(378129, 'PTHR47047:SF8', NULL, NULL, NULL, NULL, 'CYSTEINE PEPTIDASE, PUTATIVE-RELATED', 247706),
(378130, 'PTHR47047:SF7', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 247706),
(378131, 'PTHR47047', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED-RELATED', 247706),
(378132, 'PTHR47047:SF4', NULL, NULL, NULL, NULL, 'CYSTEINE PEPTIDASE, PUTATIVE CYSTEINE PEPTIDASE, CLAN CA, FAMILY C2, PUTATIVE-RELATED', 247706),
(378133, 'PTHR47047:SF3', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 247706),
(378134, 'PTHR47047:SF6', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE CALPAIN-LIKE CYSTEINE PEPTIDASE, CLAN CA, FAMILY C2-RELATED', 247706),
(378135, 'PTHR47047:SF5', NULL, NULL, NULL, NULL, 'CYSTEINE PEPTIDASE, PUTATIVE-RELATED', 247706),
(378136, 'PTHR34788', NULL, NULL, NULL, NULL, 'F15I1.22', 247707),
(378137, 'PTHR34788:SF12', NULL, NULL, NULL, NULL, 'OS02G0779400 PROTEIN', 247707),
(378138, 'PTHR34788:SF4', NULL, NULL, NULL, NULL, 'F15I1.22', 247707),
(378139, 'PTHR34788:SF11', NULL, NULL, NULL, NULL, 'OS06G0199700 PROTEIN', 247707),
(378140, 'PTHR34788:SF7', NULL, NULL, NULL, NULL, '', 247707),
(378141, 'PTHR34788:SF8', NULL, NULL, NULL, NULL, '', 247707),
(378142, 'PTHR34788:SF5', NULL, NULL, NULL, NULL, 'BNAA01G29640D PROTEIN', 247707),
(378143, 'PTHR34788:SF6', NULL, NULL, NULL, NULL, 'OS02G0565150 PROTEIN', 247707),
(378144, 'PTHR34788:SF9', NULL, NULL, NULL, NULL, 'BNAC06G10520D PROTEIN', 247707),
(378145, 'PTHR35350:SF1', NULL, NULL, NULL, NULL, 'HYPOTHETICAL LOC314168', 247708),
(378146, 'PTHR35350', NULL, NULL, NULL, NULL, 'HYPOTHETICAL LOC314168', 247708),
(378147, 'PTHR23408', NULL, NULL, NULL, NULL, 'METHYLMALONYL-COA MUTASE', 247709),
(378148, 'PTHR23408:SF3', NULL, NULL, NULL, NULL, 'METHYLMALONIC ACIDURIA TYPE A PROTEIN, MITOCHONDRIAL', 247709),
(378149, 'PTHR21665', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247710),
(378150, 'PTHR21665:SF2', NULL, NULL, NULL, NULL, 'C2 CALCIUM-DEPENDENT DOMAIN-CONTAINING 6', 247710),
(378151, 'PTHR39940:SF4', NULL, NULL, NULL, NULL, 'PROTEIN TRUNK', 247711),
(378152, 'PTHR39940:SF1', NULL, NULL, NULL, NULL, 'PROTHORACICOTROPIC HORMONE, ISOFORM F', 247711);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(378153, 'PTHR39940', NULL, NULL, NULL, NULL, 'PROTHORACICOTROPIC HORMONE, ISOFORM F', 247711),
(378154, 'PTHR37517:SF4', NULL, NULL, NULL, NULL, '', 247712),
(378155, 'PTHR37517', NULL, NULL, NULL, NULL, '', 247712),
(378156, 'PTHR37517:SF1', NULL, NULL, NULL, NULL, '', 247712),
(378157, 'PTHR37517:SF3', NULL, NULL, NULL, NULL, '', 247712),
(378158, 'PTHR37517:SF2', NULL, NULL, NULL, NULL, '', 247712),
(378159, 'PTHR10629:SF42', NULL, NULL, NULL, NULL, 'DNA (CYTOSINE-5)-METHYLTRANSFERASE CMT1-RELATED', 247713),
(378160, 'PTHR10629:SF52', NULL, NULL, NULL, NULL, 'DNA (CYTOSINE-5)-METHYLTRANSFERASE 1', 247713),
(378161, 'PTHR10629:SF51', NULL, NULL, NULL, NULL, 'DNA (CYTOSINE-5)-METHYLTRANSFERASE', 247713),
(378162, 'PTHR10629:SF50', NULL, NULL, NULL, NULL, 'DNA (CYTOSINE-5)-METHYLTRANSFERASE CMT3', 247713),
(378163, 'PTHR10629:SF34', NULL, NULL, NULL, NULL, 'DNA (CYTOSINE-5)-METHYLTRANSFERASE CMT2', 247713),
(378164, 'PTHR10629:SF44', NULL, NULL, NULL, NULL, 'BROMO ADJACENT HOMOLOGY (BAH) DOMAIN PROTEIN-RELATED', 247713),
(378165, 'PTHR10629:SF54', NULL, NULL, NULL, NULL, 'DNA METHYLTRANSFERASE DIM-2', 247713),
(378166, 'PTHR10629:SF49', NULL, NULL, NULL, NULL, 'DNA (CYTOSINE-5)-METHYLTRANSFERASE CMT3', 247713),
(378167, 'PTHR10629:SF58', NULL, NULL, NULL, NULL, 'DNA (CYTOSINE-5)-METHYLTRANSFERASE 1B', 247713),
(378168, 'PTHR10629:SF47', NULL, NULL, NULL, NULL, 'CYTOSINE-SPECIFIC METHYLTRANSFERASE', 247713),
(378169, 'PTHR10629', NULL, NULL, NULL, NULL, 'CYTOSINE-SPECIFIC METHYLTRANSFERASE', 247713),
(378170, 'PTHR20905:SF30', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 247714),
(378171, 'PTHR20905:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG11298', 247714),
(378172, 'PTHR20905:SF32', NULL, NULL, NULL, NULL, 'ARYLALKYLAMINE N-ACETYLTRANSFERASE-LIKE 7, ISOFORM A', 247714),
(378173, 'PTHR20905:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG06006', 247714),
(378174, 'PTHR20905', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE-RELATED', 247714),
(378175, 'PTHR20905:SF16', NULL, NULL, NULL, NULL, 'PROTEIN CBG11056', 247714),
(378176, 'PTHR20905:SF28', NULL, NULL, NULL, NULL, 'GH28833P-RELATED', 247714),
(378177, 'PTHR20905:SF17', NULL, NULL, NULL, NULL, 'AANAT (ARYLALKYLAMINE N-ACETYLTRANSFERASE) HOMOLOG', 247714),
(378178, 'PTHR20905:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG11057', 247714),
(378179, 'PTHR20905:SF1', NULL, NULL, NULL, NULL, 'AT07410P-RELATED', 247714),
(378180, 'PTHR33835', NULL, NULL, NULL, NULL, 'YALI0C07656P', 247715),
(378181, 'PTHR33835:SF2', NULL, NULL, NULL, NULL, 'LYSINE-TRNA LIGASE', 247715),
(378182, 'PTHR33835:SF1', NULL, NULL, NULL, NULL, 'YALI0C07656P', 247715),
(378183, 'PTHR45816', NULL, NULL, NULL, NULL, 'MIR DOMAIN-CONTAINING PROTEIN', 247716),
(378184, 'PTHR45816:SF1', NULL, NULL, NULL, NULL, 'INOSITOL 1,4,5-TRISPHOSPHATE RECEPTOR TYPE 3', 247716),
(378185, 'PTHR45816:SF2', NULL, NULL, NULL, NULL, 'INOSITOL 1,4,5-TRISPHOSPHATE RECEPTOR, TYPE 1A', 247716),
(378186, 'PTHR45816:SF3', NULL, NULL, NULL, NULL, 'INOSITOL 1,4,5-TRISPHOSPHATE RECEPTOR TYPE 2', 247716),
(378187, 'PTHR45816:SF4', NULL, NULL, NULL, NULL, '', 247716),
(378188, 'PTHR47228:SF1', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 16', 247717),
(378189, 'PTHR47228', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 16', 247717),
(378190, 'PTHR39184', NULL, NULL, NULL, NULL, '', 247718),
(378191, 'PTHR39184:SF1', NULL, NULL, NULL, NULL, 'PBSX PHAGE TERMINASE LARGE SUBUNIT', 247718),
(378192, 'PTHR12346:SF38', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE COMPLEX, SIN3 COMPONENT', 247719),
(378193, 'PTHR12346:SF59', NULL, NULL, NULL, NULL, 'PAIRED AMPHIPATHIC HELIX PROTEIN SIN3-LIKE 3', 247719),
(378194, 'PTHR12346:SF37', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE INTERACTING DOMAIN, SIN3-RELATED', 247719),
(378195, 'PTHR12346:SF58', NULL, NULL, NULL, NULL, 'PAIRED AMPHIPATHIC HELIX PROTEIN PST2', 247719),
(378196, 'PTHR12346:SF36', NULL, NULL, NULL, NULL, 'PAIRED AMPHIPATHIC HELIX PROTEIN SIN3-LIKE 2', 247719),
(378197, 'PTHR12346:SF57', NULL, NULL, NULL, NULL, 'HDAC_INTERACT DOMAIN-CONTAINING PROTEIN', 247719); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(378198, 'PTHR12346:SF56', NULL, NULL, NULL, NULL, 'HDAC_INTERACT DOMAIN-CONTAINING PROTEIN', 247719),
(378199, 'PTHR12346:SF55', NULL, NULL, NULL, NULL, 'PAIRED AMPHIPATHIC HELIX (PAH2) SUPERFAMILY PROTEIN', 247719),
(378200, 'PTHR12346:SF33', NULL, NULL, NULL, NULL, '', 247719),
(378201, 'PTHR12346:SF54', NULL, NULL, NULL, NULL, 'PAIRED AMPHIPATHIC HELIX PROTEIN', 247719),
(378202, 'PTHR12346:SF32', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE INTERACTING DOMAIN, SIN3-RELATED', 247719),
(378203, 'PTHR12346:SF31', NULL, NULL, NULL, NULL, 'PAIRED AMPHIPATHIC HELIX PROTEIN SIN3-LIKE 5', 247719),
(378204, 'PTHR12346:SF53', NULL, NULL, NULL, NULL, 'HDAC_INTERACT DOMAIN-CONTAINING PROTEIN', 247719),
(378205, 'PTHR12346:SF30', NULL, NULL, NULL, NULL, 'F17L21.3-RELATED', 247719),
(378206, 'PTHR12346:SF52', NULL, NULL, NULL, NULL, 'SIN3 COMPONENT, HISTONE DEACETYLASE COMPLEX', 247719),
(378207, 'PTHR12346:SF51', NULL, NULL, NULL, NULL, 'PAIRED AMPHIPATHIC HELIX PROTEIN', 247719),
(378208, 'PTHR12346:SF50', NULL, NULL, NULL, NULL, 'OS10G0374200 PROTEIN', 247719),
(378209, 'PTHR12346', NULL, NULL, NULL, NULL, 'SIN3B-RELATED', 247719),
(378210, 'PTHR12346:SF29', NULL, NULL, NULL, NULL, 'PAIRED AMPHIPATHIC HELIX PROTEIN SIN3-LIKE 2 ISOFORM X1', 247719),
(378211, 'PTHR12346:SF27', NULL, NULL, NULL, NULL, 'HDAC_INTERACT DOMAIN-CONTAINING PROTEIN', 247719),
(378212, 'PTHR12346:SF48', NULL, NULL, NULL, NULL, 'PAIRED AMPHIPATHIC HELIX PROTEIN SIN3-LIKE 2', 247719),
(378213, 'PTHR12346:SF47', NULL, NULL, NULL, NULL, 'HDAC_INTERACT DOMAIN-CONTAINING PROTEIN', 247719),
(378214, 'PTHR12346:SF25', NULL, NULL, NULL, NULL, 'OS05G0588700 PROTEIN', 247719),
(378215, 'PTHR12346:SF46', NULL, NULL, NULL, NULL, 'BNAC02G19550D PROTEIN', 247719),
(378216, 'PTHR12346:SF8', NULL, NULL, NULL, NULL, 'PAIRED AMPHIPATHIC HELIX PROTEIN SIN3-LIKE 1', 247719),
(378217, 'PTHR12346:SF24', NULL, NULL, NULL, NULL, 'PAIRED AMPHIPATHIC HELIX PROTEIN SIN3-LIKE 6', 247719),
(378218, 'PTHR12346:SF23', NULL, NULL, NULL, NULL, 'PAIRED AMPHIPATHIC HELIX SIN3-LIKE PROTEIN-RELATED', 247719),
(378219, 'PTHR12346:SF45', NULL, NULL, NULL, NULL, 'BNAA07G24000D PROTEIN', 247719),
(378220, 'PTHR12346:SF42', NULL, NULL, NULL, NULL, 'HDAC_INTERACT DOMAIN-CONTAINING PROTEIN', 247719),
(378221, 'PTHR12346:SF64', NULL, NULL, NULL, NULL, 'PAIRED AMPHIPATHIC HELIX PROTEIN PST3', 247719),
(378222, 'PTHR12346:SF41', NULL, NULL, NULL, NULL, 'HDAC_INTERACT DOMAIN-CONTAINING PROTEIN', 247719),
(378223, 'PTHR12346:SF63', NULL, NULL, NULL, NULL, 'BNAA01G24270D PROTEIN', 247719),
(378224, 'PTHR12346:SF62', NULL, NULL, NULL, NULL, 'BNAC02G19540D PROTEIN', 247719),
(378225, 'PTHR12346:SF40', NULL, NULL, NULL, NULL, 'BNAA05G13180D PROTEIN', 247719),
(378226, 'PTHR12346:SF61', NULL, NULL, NULL, NULL, 'HDAC_INTERACT DOMAIN-CONTAINING PROTEIN', 247719),
(378227, 'PTHR12346:SF60', NULL, NULL, NULL, NULL, 'HDAC_INTERACT DOMAIN-CONTAINING PROTEIN', 247719),
(378228, 'PTHR12346:SF2', NULL, NULL, NULL, NULL, 'PAIRED AMPHIPATHIC HELIX PROTEIN SIN3A', 247719),
(378229, 'PTHR12346:SF1', NULL, NULL, NULL, NULL, 'PAIRED AMPHIPATHIC HELIX PROTEIN SIN3B', 247719),
(378230, 'PTHR12346:SF0', NULL, NULL, NULL, NULL, 'SIN3A, ISOFORM G', 247719),
(378231, 'PTHR35765:SF2', NULL, NULL, NULL, NULL, 'OS05G0569200 PROTEIN', 247720),
(378232, 'PTHR35765', NULL, NULL, NULL, NULL, 'OS05G0569200 PROTEIN', 247720),
(378233, 'PTHR23152:SF32', NULL, NULL, NULL, NULL, 'OXOGLUTARATE DEHYDROGENASE (SUCCINYL-TRANSFERRING)', 247721),
(378234, 'PTHR23152:SF31', NULL, NULL, NULL, NULL, 'OXOGLUTARATE DEHYDROGENASE (SUCCINYL-TRANSFERRING)', 247721),
(378235, 'PTHR23152:SF34', NULL, NULL, NULL, NULL, 'OXOGLUTARATE DEHYDROGENASE (SUCCINYL-TRANSFERRING)', 247721),
(378236, 'PTHR23152:SF23', NULL, NULL, NULL, NULL, 'OXOGLUTARATE DEHYDROGENASE (SUCCINYL-TRANSFERRING)', 247721),
(378237, 'PTHR23152:SF12', NULL, NULL, NULL, NULL, 'OXOGLUTARATE DEHYDROGENASE (SUCCINYL-TRANSFERRING)', 247721),
(378238, 'PTHR23152:SF7', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE DEHYDROGENASE, MITOCHONDRIAL', 247721),
(378239, 'PTHR23152:SF30', NULL, NULL, NULL, NULL, 'OXOGLUTARATE DEHYDROGENASE (SUCCINYL-TRANSFERRING)', 247721);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(378240, 'PTHR23152:SF4', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE DEHYDROGENASE E1 COMPONENT DHKTD1, MITOCHONDRIAL-RELATED', 247721),
(378241, 'PTHR23152:SF5', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE DEHYDROGENASE-LIKE, MITOCHONDRIAL', 247721),
(378242, 'PTHR23152', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE DEHYDROGENASE', 247721),
(378243, 'PTHR23152:SF25', NULL, NULL, NULL, NULL, 'OXOGLUTARATE DEHYDROGENASE (SUCCINYL-TRANSFERRING)', 247721),
(378244, 'PTHR23152:SF36', NULL, NULL, NULL, NULL, 'OXOGLUTARATE DEHYDROGENASE (SUCCINYL-TRANSFERRING)', 247721),
(378245, 'PTHR23152:SF35', NULL, NULL, NULL, NULL, 'OXOGLUTARATE DEHYDROGENASE (SUCCINYL-TRANSFERRING)', 247721),
(378246, 'PTHR23152:SF37', NULL, NULL, NULL, NULL, 'OXOGLUTARATE DEHYDROGENASE (SUCCINYL-TRANSFERRING)', 247721),
(378247, 'PTHR12214', NULL, NULL, NULL, NULL, 'GC-RICH SEQUENCE DNA-BINDING FACTOR', 247722),
(378248, 'PTHR12214:SF4', NULL, NULL, NULL, NULL, 'INTRON LARGE COMPLEX COMPONENT GCFC2', 247722),
(378249, 'PTHR12214:SF2', NULL, NULL, NULL, NULL, 'PAX3- AND PAX7-BINDING PROTEIN 1', 247722),
(378250, 'PTHR12214:SF0', NULL, NULL, NULL, NULL, 'LD29489P', 247722),
(378251, 'PTHR13273:SF18', NULL, NULL, NULL, NULL, 'ANAMORSIN HOMOLOG', 247723),
(378252, 'PTHR13273:SF16', NULL, NULL, NULL, NULL, 'ANAMORSIN', 247723),
(378253, 'PTHR13273', NULL, NULL, NULL, NULL, 'ANAMORSIN', 247723),
(378254, 'PTHR13273:SF17', NULL, NULL, NULL, NULL, 'ANAMORSIN', 247723),
(378255, 'PTHR13273:SF14', NULL, NULL, NULL, NULL, 'ANAMORSIN', 247723),
(378256, 'PTHR13273:SF15', NULL, NULL, NULL, NULL, 'ANAMORSIN HOMOLOG 2-LIKE ISOFORM X1', 247723),
(378257, 'PTHR12895:SF9', NULL, NULL, NULL, NULL, 'DYMECLIN', 247724),
(378258, 'PTHR12895:SF11', NULL, NULL, NULL, NULL, 'DYMECLIN', 247724),
(378259, 'PTHR12895', NULL, NULL, NULL, NULL, 'DYMECLIN', 247724),
(378260, 'PTHR39322', NULL, NULL, NULL, NULL, 'ACYL-HOMOSERINE-LACTONE SYNTHASE', 247725),
(378261, 'PTHR39322:SF1', NULL, NULL, NULL, NULL, 'ISOVALERYL-HOMOSERINE LACTONE SYNTHASE', 247725),
(378262, 'PTHR34772:SF1', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN HFQ', 247726),
(378263, 'PTHR34772', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN HFQ', 247726),
(378264, 'PTHR43920', NULL, NULL, NULL, NULL, 'CHLORIDE INTRACELLULAR CHANNEL, ISOFORM A', 247727),
(378265, 'PTHR43920:SF1', NULL, NULL, NULL, NULL, 'CHLORIDE INTRACELLULAR CHANNEL PROTEIN', 247727),
(378266, 'PTHR43920:SF2', NULL, NULL, NULL, NULL, 'CHLORIDE INTRACELLULAR CHANNEL PROTEIN 1', 247727),
(378267, 'PTHR43920:SF7', NULL, NULL, NULL, NULL, 'CHLORIDE INTRACELLULAR CHANNEL PROTEIN 4', 247727),
(378268, 'PTHR43920:SF9', NULL, NULL, NULL, NULL, 'CHLORIDE INTRACELLULAR CHANNEL, ISOFORM A', 247727),
(378269, 'PTHR43920:SF3', NULL, NULL, NULL, NULL, 'CHLORIDE INTRACELLULAR CHANNEL PROTEIN 3', 247727),
(378270, 'PTHR43920:SF4', NULL, NULL, NULL, NULL, 'CHLORIDE INTRACELLULAR CHANNEL PROTEIN 2', 247727),
(378271, 'PTHR43920:SF5', NULL, NULL, NULL, NULL, 'CHLORIDE INTRACELLULAR CHANNEL EXL-1', 247727),
(378272, 'PTHR43920:SF6', NULL, NULL, NULL, NULL, 'CHLORIDE INTRACELLULAR CHANNEL PROTEIN 5', 247727),
(378273, 'PTHR33571:SF18', NULL, NULL, NULL, NULL, 'BSL3053 PROTEIN', 247728),
(378274, 'PTHR33571', NULL, NULL, NULL, NULL, 'SSL8005 PROTEIN', 247728),
(378275, 'PTHR33571:SF14', NULL, NULL, NULL, NULL, 'PROTEIN ADENYLYLTRANSFERASE MJ0128-RELATED', 247728),
(378276, 'PTHR33571:SF12', NULL, NULL, NULL, NULL, 'POLBETA DOMAIN-CONTAINING PROTEIN', 247728),
(378277, 'PTHR11852:SF7', NULL, NULL, NULL, NULL, '', 247729),
(378278, 'PTHR11852:SF1', NULL, NULL, NULL, NULL, 'PLATELET-ACTIVATING FACTOR ACETYLHYDROLASE IB SUBUNIT ALPHA2', 247729),
(378279, 'PTHR11852', NULL, NULL, NULL, NULL, 'PLATELET-ACTIVATING FACTOR ACETYLHYDROLASE', 247729),
(378280, 'PTHR11852:SF0', NULL, NULL, NULL, NULL, 'PLATELET-ACTIVATING FACTOR ACETYLHYDROLASE IB SUBUNIT BETA HOMOLOG', 247729),
(378281, 'PTHR11852:SF2', NULL, NULL, NULL, NULL, 'PLATELET-ACTIVATING FACTOR ACETYLHYDROLASE IB SUBUNIT ALPHA1', 247729),
(378282, 'PTHR11852:SF4', NULL, NULL, NULL, NULL, 'LITTLE ELONGATION COMPLEX SUBUNIT 1', 247729);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(378283, 'PTHR12444:SF9', NULL, NULL, NULL, NULL, 'AGAP013133-PA', 247730),
(378284, 'PTHR12444:SF8', NULL, NULL, NULL, NULL, 'PROTEIN EFR3 HOMOLOG CMP44E', 247730),
(378285, 'PTHR12444:SF1', NULL, NULL, NULL, NULL, 'PROTEIN EFR3 HOMOLOG A', 247730),
(378286, 'PTHR12444', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247730),
(378287, 'PTHR12444:SF4', NULL, NULL, NULL, NULL, 'PROTEIN EFR3 HOMOLOG B', 247730),
(378288, 'PTHR11956', NULL, NULL, NULL, NULL, 'ARGINYL-TRNA SYNTHETASE', 247731),
(378289, 'PTHR11956:SF5', NULL, NULL, NULL, NULL, 'ARGININE--TRNA LIGASE, CYTOPLASMIC', 247731),
(378290, 'PTHR11956:SF11', NULL, NULL, NULL, NULL, 'ARGININE--TRNA LIGASE, MITOCHONDRIAL-RELATED', 247731),
(378291, 'PTHR11956:SF8', NULL, NULL, NULL, NULL, 'ARGINYL-TRNA SYNTHETASE', 247731),
(378292, 'PTHR11956:SF9', NULL, NULL, NULL, NULL, 'ARGINYL-TRNA SYNTHETASE', 247731),
(378293, 'PTHR36561:SF2', NULL, NULL, NULL, NULL, '', 247732),
(378294, 'PTHR36561', NULL, NULL, NULL, NULL, '', 247732),
(378295, 'PTHR36561:SF1', NULL, NULL, NULL, NULL, '', 247732),
(378296, 'PTHR11819:SF96', NULL, NULL, NULL, NULL, 'SODIUM/GLUCOSE COTRANSPORTER 4', 247733),
(378297, 'PTHR11819:SF77', NULL, NULL, NULL, NULL, 'SODIUM/GLUCOSE COTRANSPORT PROTEIN', 247733),
(378298, 'PTHR11819', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 5', 247733),
(378299, 'PTHR11819:SF128', NULL, NULL, NULL, NULL, 'SODIUM/GLUCOSE COTRANSPORTER 5', 247733),
(378300, 'PTHR11819:SF110', NULL, NULL, NULL, NULL, 'GENE 5134-RELATED', 247733),
(378301, 'PTHR11819:SF112', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 5 MEMBER 4', 247733),
(378302, 'PTHR11819:SF145', NULL, NULL, NULL, NULL, 'SODIUM/GLUCOSE COTRANSPORTER 2', 247733),
(378303, 'PTHR11819:SF150', NULL, NULL, NULL, NULL, 'SODIUM/MYO-INOSITOL COTRANSPORTER', 247733),
(378304, 'PTHR11819:SF171', NULL, NULL, NULL, NULL, 'SODIUM/MYO-INOSITOL COTRANSPORTER 2', 247733),
(378305, 'PTHR11819:SF196', NULL, NULL, NULL, NULL, '', 247733),
(378306, 'PTHR11819:SF130', NULL, NULL, NULL, NULL, 'SGLT3-B', 247733),
(378307, 'PTHR11819:SF195', NULL, NULL, NULL, NULL, '', 247733),
(378308, 'PTHR11819:SF151', NULL, NULL, NULL, NULL, 'SODIUM/GLUCOSE COTRANSPORTER 1', 247733),
(378309, 'PTHR35410:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247734),
(378310, 'PTHR35410', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247734),
(378311, 'PTHR35410:SF2', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 247734),
(378312, 'PTHR35687:SF9', NULL, NULL, NULL, NULL, 'BNACNNG18060D PROTEIN', 247735),
(378313, 'PTHR35687:SF8', NULL, NULL, NULL, NULL, 'BNACNNG71110D PROTEIN', 247735),
(378314, 'PTHR35687:SF10', NULL, NULL, NULL, NULL, 'BNAC03G29990D PROTEIN', 247735),
(378315, 'PTHR35687:SF7', NULL, NULL, NULL, NULL, 'BNAA09G20290D PROTEIN', 247735),
(378316, 'PTHR35687:SF6', NULL, NULL, NULL, NULL, 'BNAA09G47600D PROTEIN', 247735),
(378317, 'PTHR35687:SF5', NULL, NULL, NULL, NULL, '', 247735),
(378318, 'PTHR35687:SF2', NULL, NULL, NULL, NULL, '', 247735),
(378319, 'PTHR35687', NULL, NULL, NULL, NULL, 'OS07G0516700 PROTEIN', 247735),
(378320, 'PTHR35687:SF1', NULL, NULL, NULL, NULL, 'OS07G0516700 PROTEIN', 247735),
(378321, 'PTHR32488:SF76', NULL, NULL, NULL, NULL, 'UPF0746 PROTEIN DDB_G0280785-RELATED', 247736),
(378322, 'PTHR32488:SF77', NULL, NULL, NULL, NULL, 'DEFECTIVE IN TIP FORMATION PROTEIN A-RELATED', 247736),
(378323, 'PTHR32488:SF85', NULL, NULL, NULL, NULL, 'SAP DNA-BINDING DOMAIN-CONTAINING PROTEIN', 247736),
(378324, 'PTHR32488:SF84', NULL, NULL, NULL, NULL, '', 247736),
(378325, 'PTHR32488:SF80', NULL, NULL, NULL, NULL, 'LISH DOMAIN-CONTAINING PROTEIN', 247736),
(378326, 'PTHR32488', NULL, NULL, NULL, NULL, 'UPF0746 PROTEIN DDB_G0280785-RELATED', 247736),
(378327, 'PTHR32479', NULL, NULL, NULL, NULL, 'GLYCOLATE OXIDASE IRON-SULFUR SUBUNIT', 247737),
(378328, 'PTHR32479:SF20', NULL, NULL, NULL, NULL, 'OXIDO/REDUCTASE IRON SULFUR PROTEIN', 247737),
(378329, 'PTHR32479:SF19', NULL, NULL, NULL, NULL, 'ANAEROBIC GLYCEROL-3-PHOSPHATE DEHYDROGENASE SUBUNIT C', 247737),
(378330, 'PTHR32479:SF17', NULL, NULL, NULL, NULL, 'GLYCOLATE OXIDASE IRON-SULFUR SUBUNIT', 247737);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(378331, 'PTHR24085:SF0', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR SUBFAMILY 4 GROUP A MEMBER 2', 247738),
(378332, 'PTHR24085:SF1', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR SUBFAMILY 4 GROUP A MEMBER 1', 247738),
(378333, 'PTHR24085', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR', 247738),
(378334, 'PTHR24085:SF2', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR SUBFAMILY 4 GROUP A MEMBER 3', 247738),
(378335, 'PTHR24085:SF4', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR HR38-RELATED', 247738),
(378336, 'PTHR24085:SF5', NULL, NULL, NULL, NULL, 'RETINOIC ACID RECEPTOR BETA', 247738),
(378337, 'PTHR24085:SF7', NULL, NULL, NULL, NULL, 'RETINOIC ACID RECEPTOR GAMMA', 247738),
(378338, 'PTHR24085:SF8', NULL, NULL, NULL, NULL, 'RETINOIC ACID RECEPTOR ALPHA', 247738),
(378339, 'PTHR24085:SF9', NULL, NULL, NULL, NULL, '', 247738),
(378340, 'PTHR45861:SF1', NULL, NULL, NULL, NULL, 'DNA POLYMERASE ALPHA CATALYTIC SUBUNIT', 247739),
(378341, 'PTHR45861:SF2', NULL, NULL, NULL, NULL, 'DNA POLYMERASE', 247739),
(378342, 'PTHR45861', NULL, NULL, NULL, NULL, 'DNA POLYMERASE ALPHA CATALYTIC SUBUNIT', 247739),
(378343, 'PTHR23110:SF108', NULL, NULL, NULL, NULL, 'LD19131P', 247740),
(378344, 'PTHR23110:SF107', NULL, NULL, NULL, NULL, 'PROTEIN TWEETY HOMOLOG-RELATED', 247740),
(378345, 'PTHR23110:SF98', NULL, NULL, NULL, NULL, 'PROTEIN ABRUPT', 247740),
(378346, 'PTHR23110:SF10', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GAGA', 247740),
(378347, 'PTHR23110:SF84', NULL, NULL, NULL, NULL, 'AGAP003685-PA', 247740),
(378348, 'PTHR23110:SF109', NULL, NULL, NULL, NULL, 'FI07618P-RELATED', 247740),
(378349, 'PTHR23110:SF104', NULL, NULL, NULL, NULL, 'MATERNAL GENE REQUIRED FOR MEIOSIS, ISOFORM H', 247740),
(378350, 'PTHR23110:SF99', NULL, NULL, NULL, NULL, 'BROAD-COMPLEX CORE PROTEIN ISOFORM 6', 247740),
(378351, 'PTHR23110:SF106', NULL, NULL, NULL, NULL, 'FI01104P', 247740),
(378352, 'PTHR23110:SF105', NULL, NULL, NULL, NULL, 'RIBBON, ISOFORM C', 247740),
(378353, 'PTHR23110:SF111', NULL, NULL, NULL, NULL, 'LONGITUDINALS LACKING PROTEIN, ISOFORMS F/I/K/T', 247740),
(378354, 'PTHR23110:SF110', NULL, NULL, NULL, NULL, 'AGAP003189-PA', 247740),
(378355, 'PTHR23110', NULL, NULL, NULL, NULL, 'BTB DOMAIN TRANSCRIPTION FACTOR', 247740),
(378356, 'PTHR23110:SF102', NULL, NULL, NULL, NULL, 'PIPSQUEAK, ISOFORM O', 247740),
(378357, 'PTHR23110:SF101', NULL, NULL, NULL, NULL, 'PROTEIN JIM LOVELL', 247740),
(378358, 'PTHR23110:SF82', NULL, NULL, NULL, NULL, 'PROTEIN TRAMTRACK, ALPHA ISOFORM', 247740),
(378359, 'PTHR23110:SF93', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 14-LIKE PROTEIN', 247740),
(378360, 'PTHR23110:SF94', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CHINMO', 247740),
(378361, 'PTHR23110:SF81', NULL, NULL, NULL, NULL, 'BTB-PROTEIN-VII, ISOFORM F-RELATED', 247740),
(378362, 'PTHR23110:SF92', NULL, NULL, NULL, NULL, 'MODIFIER OF MDG4', 247740),
(378363, 'PTHR47860:SF1', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP17-1, CHLOROPLASTIC', 247741),
(378364, 'PTHR47860', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP17-1, CHLOROPLASTIC', 247741),
(378365, 'PTHR35849', NULL, NULL, NULL, NULL, 'BLR2341 PROTEIN', 247742),
(378366, 'PTHR35849:SF1', NULL, NULL, NULL, NULL, 'INTERMEMBRANE PHOSPHOLIPID TRANSPORT SYSTEM BINDING PROTEIN MLAB', 247742),
(378367, 'PTHR35849:SF2', NULL, NULL, NULL, NULL, 'BLR2341 PROTEIN', 247742),
(378368, 'PTHR43477:SF1', NULL, NULL, NULL, NULL, 'DIHYDROANTICAPSIN 7-DEHYDROGENASE', 247743),
(378369, 'PTHR43477:SF4', NULL, NULL, NULL, NULL, '3-HYDROXYBUTYRATE DEHYDROGENASE TYPE 2', 247743),
(378370, 'PTHR43477', NULL, NULL, NULL, NULL, 'DIHYDROANTICAPSIN 7-DEHYDROGENASE', 247743),
(378371, 'PTHR24394:SF18', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 18', 247744),
(378372, 'PTHR24394:SF19', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 3', 247744),
(378373, 'PTHR24394:SF38', NULL, NULL, NULL, NULL, 'CENTROSOME-ASSOCIATED ZINC FINGER PROTEIN CP190', 247744),
(378374, 'PTHR24394:SF16', NULL, NULL, NULL, NULL, 'HYPERMETHYLATED IN CANCER 1 PROTEIN', 247744);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(378375, 'PTHR24394:SF17', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 5', 247744),
(378376, 'PTHR24394:SF14', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 7A', 247744),
(378377, 'PTHR24394:SF36', NULL, NULL, NULL, NULL, 'BCL6A TRANSCRIPTION REPRESSOR A', 247744),
(378378, 'PTHR24394:SF37', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 771', 247744),
(378379, 'PTHR24394:SF15', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 21', 247744),
(378380, 'PTHR24394:SF34', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN CONTAINING 33', 247744),
(378381, 'PTHR24394:SF35', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING 11', 247744),
(378382, 'PTHR24394:SF13', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN CONTAINING 48', 247744),
(378383, 'PTHR24394:SF0', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 40', 247744),
(378384, 'PTHR24394:SF32', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 22', 247744),
(378385, 'PTHR24394:SF33', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 8B', 247744),
(378386, 'PTHR24394:SF30', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING 8A', 247744),
(378387, 'PTHR24394:SF31', NULL, NULL, NULL, NULL, '', 247744),
(378388, 'PTHR24394:SF29', NULL, NULL, NULL, NULL, 'GM08392P', 247744),
(378389, 'PTHR24394:SF27', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 791', 247744),
(378390, 'PTHR24394:SF23', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 281A', 247744),
(378391, 'PTHR24394:SF24', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 47', 247744),
(378392, 'PTHR24394', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 247744),
(378393, 'PTHR24394:SF21', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 652', 247744),
(378394, 'PTHR24394:SF22', NULL, NULL, NULL, NULL, 'HYPERMETHYLATED IN CANCER 2 PROTEIN', 247744),
(378395, 'PTHR24394:SF20', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 42', 247744),
(378396, 'PTHR46740:SF6', NULL, NULL, NULL, NULL, 'OS12G0623300 PROTEIN', 247745),
(378397, 'PTHR46740:SF2', NULL, NULL, NULL, NULL, 'PROTEIN DYAD', 247745),
(378398, 'PTHR46740:SF1', NULL, NULL, NULL, NULL, 'DYAD PROTEIN', 247745),
(378399, 'PTHR46740', NULL, NULL, NULL, NULL, 'PROTEIN DYAD', 247745),
(378400, 'PTHR47945:SF5', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 84A1-RELATED', 247746),
(378401, 'PTHR47945:SF10', NULL, NULL, NULL, NULL, 'P450 84A1, PUTATIVE, EXPRESSED-RELATED', 247746),
(378402, 'PTHR47945:SF7', NULL, NULL, NULL, NULL, '', 247746),
(378403, 'PTHR47945', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 84A1-RELATED', 247746),
(378404, 'PTHR47945:SF6', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY MONOOXYGENASE', 247746),
(378405, 'PTHR47945:SF9', NULL, NULL, NULL, NULL, '', 247746),
(378406, 'PTHR47945:SF12', NULL, NULL, NULL, NULL, 'CYTOCHROME P450-RELATED', 247746),
(378407, 'PTHR47945:SF11', NULL, NULL, NULL, NULL, '', 247746),
(378408, 'PTHR47945:SF1', NULL, NULL, NULL, NULL, 'FERULATE-5-HYDROXYLASE', 247746),
(378409, 'PTHR47945:SF2', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 247746),
(378410, 'PTHR31711:SF5', NULL, NULL, NULL, NULL, '', 247747),
(378411, 'PTHR31711:SF2', NULL, NULL, NULL, NULL, 'ARGININE/GLUTAMATE-RICH 1 PROTEIN', 247747),
(378412, 'PTHR31711', NULL, NULL, NULL, NULL, 'ARGININE AND GLUTAMATE-RICH PROTEIN 1', 247747),
(378413, 'PTHR31711:SF1', NULL, NULL, NULL, NULL, 'ARGININE AND GLUTAMATE-RICH PROTEIN 1', 247747),
(378414, 'PTHR12914', NULL, NULL, NULL, NULL, 'PARTNER OF SLD5', 247748),
(378415, 'PTHR12914:SF3', NULL, NULL, NULL, NULL, 'SLD5 DOMAIN-CONTAINING PROTEIN', 247748),
(378416, 'PTHR12914:SF2', NULL, NULL, NULL, NULL, 'DNA REPLICATION COMPLEX GINS PROTEIN PSF1', 247748),
(378417, 'PTHR22778', NULL, NULL, NULL, NULL, 'OVARIAN CANCER GENE-2 PROTEIN-RELATED', 247749),
(378418, 'PTHR22778:SF51', NULL, NULL, NULL, NULL, 'FSH1 DOMAIN-CONTAINING PROTEIN', 247749),
(378419, 'PTHR22778:SF53', NULL, NULL, NULL, NULL, 'FSH1 DOMAIN-CONTAINING PROTEIN', 247749);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(378420, 'PTHR22778:SF52', NULL, NULL, NULL, NULL, 'FSH1 DOMAIN-CONTAINING PROTEIN', 247749),
(378421, 'PTHR22778:SF55', NULL, NULL, NULL, NULL, 'FSH1 DOMAIN-CONTAINING PROTEIN', 247749),
(378422, 'PTHR22778:SF54', NULL, NULL, NULL, NULL, 'FSH1 DOMAIN-CONTAINING PROTEIN', 247749),
(378423, 'PTHR47376:SF5', NULL, NULL, NULL, NULL, 'OS01G0907200 PROTEIN', 247750),
(378424, 'PTHR47376:SF7', NULL, NULL, NULL, NULL, 'BAG FAMILY MOLECULAR CHAPERONE REGULATOR 2-LIKE', 247750),
(378425, 'PTHR47376:SF15', NULL, NULL, NULL, NULL, 'BCL-2 BINDING ANTHANOGENE-1', 247750),
(378426, 'PTHR47376:SF16', NULL, NULL, NULL, NULL, 'UBIQUITIN-RELATED DOMAIN-CONTAINING PROTEIN-RELATED', 247750),
(378427, 'PTHR47376:SF14', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 247750),
(378428, 'PTHR47376', NULL, NULL, NULL, NULL, 'OS02G0597700 PROTEIN', 247750),
(378429, 'PTHR47376:SF2', NULL, NULL, NULL, NULL, 'OS02G0597700 PROTEIN', 247750),
(378430, 'PTHR47376:SF3', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 247750),
(378431, 'PTHR47376:SF10', NULL, NULL, NULL, NULL, 'UBIQUITIN-RELATED DOMAIN-CONTAINING PROTEIN-RELATED', 247750),
(378432, 'PTHR46084:SF9', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE', 247751),
(378433, 'PTHR46084:SF31', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247751),
(378434, 'PTHR46084:SF8', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247751),
(378435, 'PTHR46084:SF1', NULL, NULL, NULL, NULL, 'PROTEIN MALE DISCOVERER 2', 247751),
(378436, 'PTHR46084:SF4', NULL, NULL, NULL, NULL, 'OS05G0471000 PROTEIN', 247751),
(378437, 'PTHR46084:SF19', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247751),
(378438, 'PTHR46084:SF32', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247751),
(378439, 'PTHR46084:SF33', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247751),
(378440, 'PTHR46084:SF11', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE', 247751),
(378441, 'PTHR46084:SF12', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE MRH1 ISOFORM X1-RELATED', 247751),
(378442, 'PTHR46084:SF34', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247751),
(378443, 'PTHR46084:SF13', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE', 247751),
(378444, 'PTHR46084:SF14', NULL, NULL, NULL, NULL, 'OS03G0294800 PROTEIN', 247751),
(378445, 'PTHR46084:SF37', NULL, NULL, NULL, NULL, 'OS01G0206800 PROTEIN', 247751),
(378446, 'PTHR46084:SF15', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE', 247751),
(378447, 'PTHR46084:SF38', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247751),
(378448, 'PTHR46084:SF39', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 247751),
(378449, 'PTHR46084:SF40', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247751),
(378450, 'PTHR46084:SF41', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE-RELATED', 247751),
(378451, 'PTHR46084:SF29', NULL, NULL, NULL, NULL, 'OS05G0353500 PROTEIN', 247751),
(378452, 'PTHR46084', NULL, NULL, NULL, NULL, 'PROTEIN MALE DISCOVERER 2', 247751),
(378453, 'PTHR46084:SF21', NULL, NULL, NULL, NULL, 'PROTEIN MALE DISCOVERER 1', 247751),
(378454, 'PTHR46084:SF22', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE PROTEIN KINSAE', 247751),
(378455, 'PTHR46084:SF23', NULL, NULL, NULL, NULL, 'OS07G0693000 PROTEIN', 247751),
(378456, 'PTHR46084:SF25', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN, PLANT-TYPE-RELATED', 247751),
(378457, 'PTHR46084:SF26', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 247751),
(378458, 'PTHR46084:SF28', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN, PLANT-TYPE-RELATED', 247751),
(378459, 'PTHR23253:SF81', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR ISOFORM 4G-1', 247752),
(378460, 'PTHR23253:SF80', NULL, NULL, NULL, NULL, 'MIF4G DOMAIN-CONTAINING PROTEIN', 247752),
(378461, 'PTHR23253:SF76', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4 GAMMA 2', 247752);
INSERT INTO "PUBLIC"."MODEL" VALUES
(378462, 'PTHR23253:SF10', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4 GAMMA 1', 247752),
(378463, 'PTHR23253:SF53', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR ISOFORM 4G-1-RELATED', 247752),
(378464, 'PTHR23253:SF64', NULL, NULL, NULL, NULL, 'MIF4G DOMAIN-CONTAINING PROTEIN', 247752),
(378465, 'PTHR23253:SF75', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR ISOFORM 4G-2', 247752),
(378466, 'PTHR23253', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4 GAMMA', 247752),
(378467, 'PTHR23253:SF73', NULL, NULL, NULL, NULL, 'MIF4G DOMAIN-CONTAINING PROTEIN', 247752),
(378468, 'PTHR23253:SF62', NULL, NULL, NULL, NULL, 'MI DOMAIN-CONTAINING PROTEIN', 247752),
(378469, 'PTHR23253:SF58', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR-LIKE', 247752),
(378470, 'PTHR23253:SF69', NULL, NULL, NULL, NULL, 'MI DOMAIN-CONTAINING PROTEIN', 247752),
(378471, 'PTHR23253:SF9', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4 GAMMA 2', 247752),
(378472, 'PTHR23253:SF79', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4G-LIKE PROTEIN', 247752),
(378473, 'PTHR23253:SF35', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4G', 247752),
(378474, 'PTHR23253:SF23', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4 GAMMA 3', 247752),
(378475, 'PTHR23253:SF78', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4G1, ISOFORM B-RELATED', 247752),
(378476, 'PTHR23253:SF77', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4 GAMMA 2', 247752),
(378477, 'PTHR23253:SF55', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4G-LIKE', 247752),
(378478, 'PTHR23253:SF66', NULL, NULL, NULL, NULL, 'MIF4G DOMAIN-CONTAINING PROTEIN', 247752),
(378479, 'PTHR23253:SF27', NULL, NULL, NULL, NULL, 'MIF4G DOMAIN-CONTAINING PROTEIN', 247752),
(378480, 'PTHR42731:SF4', NULL, NULL, NULL, NULL, 'RADICAL SAM DOMAIN PROTEIN', 247753),
(378481, 'PTHR42731:SF5', NULL, NULL, NULL, NULL, 'RADICAL SAM DOMAIN PROTEIN', 247753),
(378482, 'PTHR42731', NULL, NULL, NULL, NULL, 'SLL1084 PROTEIN', 247753),
(378483, 'PTHR42731:SF1', NULL, NULL, NULL, NULL, 'RADICAL SAM DOMAIN PROTEIN', 247753),
(378484, 'PTHR16130', NULL, NULL, NULL, NULL, 'LYSOSOMAL COBALAMIN TRANSPORTER-RELATED', 247754),
(378485, 'PTHR16130:SF2', NULL, NULL, NULL, NULL, 'LYSOSOMAL COBALAMIN TRANSPORT ESCORT PROTEIN LMBD1', 247754),
(378486, 'PTHR47493', NULL, NULL, NULL, NULL, 'OS08G0520200 PROTEIN', 247755),
(378487, 'PTHR47493:SF3', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 247755),
(378488, 'PTHR47493:SF1', NULL, NULL, NULL, NULL, 'OS08G0520200 PROTEIN', 247755),
(378489, 'PTHR42034', NULL, NULL, NULL, NULL, 'CHROMOSOME 7, WHOLE GENOME SHOTGUN SEQUENCE-RELATED', 247756),
(378490, 'PTHR42034:SF1', NULL, NULL, NULL, NULL, '', 247756),
(378491, 'PTHR42034:SF2', NULL, NULL, NULL, NULL, 'ACYL-COA-DEPENDENT ACYLTRANSFERASE MAC1', 247756),
(378492, 'PTHR42034:SF3', NULL, NULL, NULL, NULL, 'ACYL-COA-DEPENDENT ACYLTRANSFERASE MAC2', 247756),
(378493, 'PTHR42030', NULL, NULL, NULL, NULL, 'DRBM DOMAIN-CONTAINING PROTEIN', 247757),
(378494, 'PTHR42030:SF1', NULL, NULL, NULL, NULL, 'DRBM DOMAIN-CONTAINING PROTEIN', 247757),
(378495, 'PTHR12582:SF7', NULL, NULL, NULL, NULL, 'NETRIN RECEPTOR UNC5C', 247758),
(378496, 'PTHR12582:SF5', NULL, NULL, NULL, NULL, 'NETRIN RECEPTOR UNC5D', 247758),
(378497, 'PTHR12582:SF47', NULL, NULL, NULL, NULL, 'NETRIN RECEPTOR UNC-5', 247758),
(378498, 'PTHR12582:SF48', NULL, NULL, NULL, NULL, 'NETRIN RECEPTOR UNC5', 247758),
(378499, 'PTHR12582:SF6', NULL, NULL, NULL, NULL, 'NETRIN RECEPTOR UNC5B', 247758),
(378500, 'PTHR12582:SF4', NULL, NULL, NULL, NULL, 'NETRIN RECEPTOR UNC5A', 247758),
(378501, 'PTHR12582:SF41', NULL, NULL, NULL, NULL, 'UNC5C-LIKE PROTEIN', 247758),
(378502, 'PTHR12582', NULL, NULL, NULL, NULL, 'NETRIN RECEPTOR UNC5', 247758),
(378503, 'PTHR11080:SF32', NULL, NULL, NULL, NULL, 'ISOCHORISMATASE DOMAIN-CONTAINING PROTEIN', 247759);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(378504, 'PTHR11080:SF31', NULL, NULL, NULL, NULL, 'ISOCHORISMATASE DOMAIN-CONTAINING PROTEIN', 247759),
(378505, 'PTHR11080', NULL, NULL, NULL, NULL, 'PYRAZINAMIDASE/NICOTINAMIDASE', 247759),
(378506, 'PTHR11080:SF2', NULL, NULL, NULL, NULL, 'LD05707P', 247759),
(378507, 'PTHR47799', NULL, NULL, NULL, NULL, 'OMEGA-AMIDASE YAFV', 247760),
(378508, 'PTHR47799:SF1', NULL, NULL, NULL, NULL, 'OMEGA-AMIDASE YAFV', 247760),
(378509, 'PTHR47373', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR 2', 247761),
(378510, 'PTHR47373:SF5', NULL, NULL, NULL, NULL, 'CYSTATIN DOMAIN-CONTAINING PROTEIN', 247761),
(378511, 'PTHR47373:SF6', NULL, NULL, NULL, NULL, 'PHYTOCYSTATIN 2-RELATED', 247761),
(378512, 'PTHR47373:SF4', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR B-LIKE', 247761),
(378513, 'PTHR47373:SF1', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR 2', 247761),
(378514, 'PTHR47373:SF2', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR 10', 247761),
(378515, 'PTHR11390', NULL, NULL, NULL, NULL, 'PROKARYOTIC DNA TOPOISOMERASE', 247762),
(378516, 'PTHR11390:SF20', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE 3-BETA-1', 247762),
(378517, 'PTHR11390:SF26', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE 1', 247762),
(378518, 'PTHR11390:SF21', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE 3-ALPHA', 247762),
(378519, 'PTHR45702:SF7', NULL, NULL, NULL, NULL, 'ADAM METALLOPEPTIDASE DOMAIN 17A', 247763),
(378520, 'PTHR45702', NULL, NULL, NULL, NULL, 'ADAM10/ADAM17 METALLOPEPTIDASE FAMILY MEMBER', 247763),
(378521, 'PTHR45702:SF4', NULL, NULL, NULL, NULL, 'DISINTEGRIN AND METALLOPROTEINASE DOMAIN-CONTAINING PROTEIN 10', 247763),
(378522, 'PTHR45702:SF3', NULL, NULL, NULL, NULL, 'KUZBANIAN-LIKE, ISOFORM A', 247763),
(378523, 'PTHR45702:SF6', NULL, NULL, NULL, NULL, 'DISINTEGRIN AND METALLOPROTEINASE DOMAIN-CONTAINING PROTEIN 17', 247763),
(378524, 'PTHR45702:SF5', NULL, NULL, NULL, NULL, 'ADAM METALLOPEPTIDASE DOMAIN 17B', 247763),
(378525, 'PTHR45702:SF2', NULL, NULL, NULL, NULL, 'KUZBANIAN, ISOFORM A', 247763),
(378526, 'PTHR45702:SF1', NULL, NULL, NULL, NULL, 'SI:CH1073-396H14.1', 247763),
(378527, 'PTHR16237:SF3', NULL, NULL, NULL, NULL, 'ODONTOGENIC AMELOBLAST-ASSOCIATED PROTEIN', 247764),
(378528, 'PTHR16237', NULL, NULL, NULL, NULL, 'ODONTOGENIC AMELOBLAST-ASSOCIATED PROTEIN', 247764),
(378529, 'PTHR47154:SF2', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR MTH-RELATED', 247765),
(378530, 'PTHR47154', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR MTH-RELATED', 247765),
(378531, 'PTHR35368:SF1', NULL, NULL, NULL, NULL, 'HYDROPEROXIDE REDUCTASE', 247766),
(378532, 'PTHR35368', NULL, NULL, NULL, NULL, 'HYDROPEROXIDE REDUCTASE', 247766),
(378533, 'PTHR45153:SF1', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 16', 247767),
(378534, 'PTHR45153', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 16', 247767),
(378535, 'PTHR30558:SF9', NULL, NULL, NULL, NULL, 'BIOPOLYMER TRANSPORT PROTEIN EXBD', 247768),
(378536, 'PTHR30558', NULL, NULL, NULL, NULL, 'EXBD MEMBRANE COMPONENT OF PMF-DRIVEN MACROMOLECULE IMPORT SYSTEM', 247768),
(378537, 'PTHR30558:SF14', NULL, NULL, NULL, NULL, 'BIOPOLYMER TRANSPORT PROTEIN EXBD', 247768),
(378538, 'PTHR30558:SF3', NULL, NULL, NULL, NULL, 'BIOPOLYMER TRANSPORT PROTEIN EXBD-RELATED', 247768),
(378539, 'PTHR30558:SF13', NULL, NULL, NULL, NULL, 'BIOPOLYMER TRANSPORT PROTEIN EXBD2', 247768),
(378540, 'PTHR30558:SF12', NULL, NULL, NULL, NULL, 'BIOPOLYMER TRANSPORT PROTEIN EXBD-LIKE 2-RELATED', 247768),
(378541, 'PTHR30558:SF7', NULL, NULL, NULL, NULL, 'TOL-PAL SYSTEM PROTEIN TOLR', 247768),
(378542, 'PTHR15732', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247769),
(378543, 'PTHR15732:SF4', NULL, NULL, NULL, NULL, 'PROTEIN MOONRAKER', 247769),
(378544, 'PTHR46564:SF1', NULL, NULL, NULL, NULL, 'TRANSPOSASE', 247770),
(378545, 'PTHR46564', NULL, NULL, NULL, NULL, 'TRANSPOSASE', 247770),
(378546, 'PTHR33918:SF2', NULL, NULL, NULL, NULL, 'OS01G0704200 PROTEIN', 247771),
(378547, 'PTHR33918', NULL, NULL, NULL, NULL, 'OS01G0704200 PROTEIN', 247771);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(378548, 'PTHR33918:SF3', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 247771),
(378549, 'PTHR33918:SF4', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 247771),
(378550, 'PTHR33918:SF5', NULL, NULL, NULL, NULL, 'BNAA09G38610D PROTEIN', 247771),
(378551, 'PTHR33918:SF6', NULL, NULL, NULL, NULL, '', 247771),
(378552, 'PTHR39594:SF1', NULL, NULL, NULL, NULL, 'PROTEIN YCHQ', 247772),
(378553, 'PTHR39594', NULL, NULL, NULL, NULL, 'PROTEIN YCHQ', 247772),
(378554, 'PTHR28058', NULL, NULL, NULL, NULL, '37S RIBOSOMAL PROTEIN MRP51, MITOCHONDRIAL', 247773),
(378555, 'PTHR28058:SF1', NULL, NULL, NULL, NULL, '37S RIBOSOMAL PROTEIN MRP51, MITOCHONDRIAL', 247773),
(378556, 'PTHR48170', NULL, NULL, NULL, NULL, '', 247774),
(378557, 'PTHR48170:SF1', NULL, NULL, NULL, NULL, '', 247774),
(378558, 'PTHR40267:SF1', NULL, NULL, NULL, NULL, 'BLR3294 PROTEIN', 247775),
(378559, 'PTHR40267', NULL, NULL, NULL, NULL, 'BLR3294 PROTEIN', 247775),
(378560, 'PTHR23539', NULL, NULL, NULL, NULL, 'MFS TRANSPORTER', 247776),
(378561, 'PTHR23539:SF1', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 247776),
(378562, 'PTHR24299:SF28', NULL, NULL, NULL, NULL, 'OS04G0539300 PROTEIN', 247777),
(378563, 'PTHR24299:SF49', NULL, NULL, NULL, NULL, 'OS07G0293000 PROTEIN', 247777),
(378564, 'PTHR24299', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 1', 247777),
(378565, 'PTHR24299:SF24', NULL, NULL, NULL, NULL, 'OS06G0642500 PROTEIN', 247777),
(378566, 'PTHR24299:SF46', NULL, NULL, NULL, NULL, '', 247777),
(378567, 'PTHR24299:SF47', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A9-LIKE', 247777),
(378568, 'PTHR24299:SF20', NULL, NULL, NULL, NULL, 'CYTOCHROME P450-RELATED', 247777),
(378569, 'PTHR24299:SF44', NULL, NULL, NULL, NULL, '', 247777),
(378570, 'PTHR24299:SF21', NULL, NULL, NULL, NULL, 'OS09G0441600 PROTEIN', 247777),
(378571, 'PTHR24299:SF60', NULL, NULL, NULL, NULL, 'P450, PUTATIVE-RELATED', 247777),
(378572, 'PTHR24299:SF61', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 71 PROTEIN', 247777),
(378573, 'PTHR24299:SF4', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 1, SUBFAMILY C, POLYPEPTIDE 1-RELATED', 247777),
(378574, 'PTHR24299:SF7', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 1A2', 247777),
(378575, 'PTHR24299:SF8', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 1A1', 247777),
(378576, 'PTHR24299:SF17', NULL, NULL, NULL, NULL, 'GERANIOL 8-HYDROXYLASE', 247777),
(378577, 'PTHR24299:SF38', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 SUPERFAMILY PROTEIN', 247777),
(378578, 'PTHR24299:SF57', NULL, NULL, NULL, NULL, 'GERANIOL 10-HYDROXYLASE', 247777),
(378579, 'PTHR24299:SF34', NULL, NULL, NULL, NULL, '(S)-N-METHYLCOCLAURINE 3''-HYDROXYLASE ISOZYME 1-LIKE', 247777),
(378580, 'PTHR24299:SF56', NULL, NULL, NULL, NULL, 'UNSPECIFIC MONOOXYGENASE', 247777),
(378581, 'PTHR24299:SF15', NULL, NULL, NULL, NULL, 'OS02G0504000 PROTEIN', 247777),
(378582, 'PTHR24299:SF59', NULL, NULL, NULL, NULL, 'OS08G0226300 PROTEIN', 247777),
(378583, 'PTHR24299:SF14', NULL, NULL, NULL, NULL, 'OS10G0514300 PROTEIN', 247777),
(378584, 'PTHR24299:SF58', NULL, NULL, NULL, NULL, 'CYTOCHROME 76A2', 247777),
(378585, 'PTHR24299:SF31', NULL, NULL, NULL, NULL, 'FLAVONOID 3'',5''-HYDROXYLASE 2-LIKE', 247777),
(378586, 'PTHR24299:SF52', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 247777),
(378587, 'PTHR24299:SF55', NULL, NULL, NULL, NULL, 'OS06G0642000 PROTEIN', 247777),
(378588, 'PTHR24299:SF11', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 1B1', 247777),
(378589, 'PTHR24299:SF54', NULL, NULL, NULL, NULL, 'OS02G0601500 PROTEIN', 247777),
(378590, 'PTHR33753:SF6', NULL, NULL, NULL, NULL, '1,4-BETA-D-GLUCAN CELLOBIOHYDROLASE A-RELATED', 247778),
(378591, 'PTHR33753:SF2', NULL, NULL, NULL, NULL, '1,4-BETA-D-GLUCAN CELLOBIOHYDROLASE B', 247778),
(378592, 'PTHR33753', NULL, NULL, NULL, NULL, '1,4-BETA-D-GLUCAN CELLOBIOHYDROLASE B', 247778),
(378593, 'PTHR33753:SF1', NULL, NULL, NULL, NULL, 'ENDO-BETA-1,4-GLUCANASE CELB', 247778),
(378594, 'PTHR43071', NULL, NULL, NULL, NULL, '2-AMINO-4-HYDROXY-6-HYDROXYMETHYLDIHYDROPTERIDINE PYROPHOSPHOKINASE', 247779);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(378595, 'PTHR43071:SF2', NULL, NULL, NULL, NULL, '2-AMINO-4-HYDROXY-6-HYDROXYMETHYLDIHYDROPTERIDINE PYROPHOSPHOKINASE', 247779),
(378596, 'PTHR43071:SF1', NULL, NULL, NULL, NULL, '2-AMINO-4-HYDROXY-6-HYDROXYMETHYLDIHYDROPTERIDINE PYROPHOSPHOKINASE', 247779),
(378597, 'PTHR15578:SF0', NULL, NULL, NULL, NULL, 'CHROMOSOME 22 OPEN READING FRAME 31', 247780),
(378598, 'PTHR15578', NULL, NULL, NULL, NULL, 'CHROMOSOME 8 C22ORF31 HOMOLOG', 247780),
(378599, 'PTHR21636', NULL, NULL, NULL, NULL, 'PROTEIN DOK-7', 247781),
(378600, 'PTHR21636:SF2', NULL, NULL, NULL, NULL, 'PROTEIN DOK-7', 247781),
(378601, 'PTHR11406:SF23', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE KINASE 1, CHLOROPLASTIC-RELATED', 247782),
(378602, 'PTHR11406', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE KINASE', 247782),
(378603, 'PTHR11406:SF24', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE KINASE', 247782),
(378604, 'PTHR11406:SF32', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE KINASE', 247782),
(378605, 'PTHR11406:SF10', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE KINASE 2', 247782),
(378606, 'PTHR11406:SF27', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE KINASE 3, CYTOSOLIC', 247782),
(378607, 'PTHR11406:SF14', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE KINASE 1', 247782),
(378608, 'PTHR11406:SF0', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE KINASE', 247782),
(378609, 'PTHR11406:SF29', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE KINASE', 247782),
(378610, 'PTHR11406:SF31', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE KINASE, CYTOSOLIC', 247782),
(378611, 'PTHR35979', NULL, NULL, NULL, NULL, 'SINGLE-PASS MEMBRANE AND COILED-COIL DOMAIN-CONTAINING PROTEIN 1', 247783),
(378612, 'PTHR35979:SF1', NULL, NULL, NULL, NULL, 'SINGLE-PASS MEMBRANE AND COILED-COIL DOMAIN-CONTAINING PROTEIN 1', 247783),
(378613, 'PTHR44991:SF1', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN SUPERFAMILY MEMBER 5', 247784),
(378614, 'PTHR44991', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN SUPERFAMILY MEMBER 5', 247784),
(378615, 'PTHR43863', NULL, NULL, NULL, NULL, 'HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G03140)-RELATED', 247785),
(378616, 'PTHR43863:SF2', NULL, NULL, NULL, NULL, 'HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G03140)-RELATED', 247785),
(378617, 'PTHR47431:SF1', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 247786),
(378618, 'PTHR47431:SF3', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 247786),
(378619, 'PTHR47431:SF2', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 247786),
(378620, 'PTHR47431', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 247786),
(378621, 'PTHR47431:SF5', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 247786),
(378622, 'PTHR47431:SF4', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 247786),
(378623, 'PTHR42686:SF1', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN-RELATED', 247787),
(378624, 'PTHR42686', NULL, NULL, NULL, NULL, 'GH17980P-RELATED', 247787),
(378625, 'PTHR13451:SF16', NULL, NULL, NULL, NULL, 'ERCC4 DOMAIN-CONTAINING PROTEIN', 247788),
(378626, 'PTHR13451:SF17', NULL, NULL, NULL, NULL, '', 247788),
(378627, 'PTHR13451:SF15', NULL, NULL, NULL, NULL, '(BREAD WHEAT) HYPOTHETICAL PROTEIN', 247788),
(378628, 'PTHR13451:SF8', NULL, NULL, NULL, NULL, 'CROSSOVER JUNCTION ENDONUCLEASE MUS81-RELATED', 247788),
(378629, 'PTHR13451:SF12', NULL, NULL, NULL, NULL, 'CROSSOVER JUNCTION ENDONUCLEASE MUS81', 247788),
(378630, 'PTHR13451:SF13', NULL, NULL, NULL, NULL, 'ERCC4 DOMAIN-CONTAINING PROTEIN', 247788),
(378631, 'PTHR13451', NULL, NULL, NULL, NULL, 'CLASS II CROSSOVER JUNCTION ENDONUCLEASE MUS81', 247788),
(378632, 'PTHR13451:SF10', NULL, NULL, NULL, NULL, 'ESSENTIAL MEIOTIC ENDONUCLEASE', 247788),
(378633, 'PTHR13451:SF0', NULL, NULL, NULL, NULL, 'CROSSOVER JUNCTION ENDONUCLEASE MUS81', 247788),
(378634, 'PTHR20982:SF3', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOME RECYCLING FACTOR', 247789),
(378635, 'PTHR20982:SF13', NULL, NULL, NULL, NULL, '', 247789);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(378636, 'PTHR20982:SF10', NULL, NULL, NULL, NULL, 'RIBOSOME-RECYCLING FACTOR, MITOCHONDRIAL', 247789),
(378637, 'PTHR20982:SF11', NULL, NULL, NULL, NULL, '', 247789),
(378638, 'PTHR20982', NULL, NULL, NULL, NULL, 'RIBOSOME RECYCLING FACTOR', 247789),
(378639, 'PTHR43064:SF1', NULL, NULL, NULL, NULL, 'SLL1489 PROTEIN', 247790),
(378640, 'PTHR43064', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLAMINOIMIDAZOLE CARBOXYLASE-RELATED', 247790),
(378641, 'PTHR33401:SF3', NULL, NULL, NULL, NULL, 'LOW AFFINITY POTASSIUM TRANSPORT SYSTEM PROTEIN', 247791),
(378642, 'PTHR33401:SF22', NULL, NULL, NULL, NULL, '', 247791),
(378643, 'PTHR33401:SF2', NULL, NULL, NULL, NULL, 'OS03G0138400 PROTEIN', 247791),
(378644, 'PTHR33401:SF10', NULL, NULL, NULL, NULL, 'BNACNNG69740D PROTEIN', 247791),
(378645, 'PTHR33401:SF19', NULL, NULL, NULL, NULL, 'BNAC06G41620D PROTEIN', 247791),
(378646, 'PTHR33401:SF17', NULL, NULL, NULL, NULL, 'BNAC01G37610D PROTEIN', 247791),
(378647, 'PTHR33401:SF18', NULL, NULL, NULL, NULL, 'BNAC08G08880D PROTEIN', 247791),
(378648, 'PTHR33401:SF15', NULL, NULL, NULL, NULL, '', 247791),
(378649, 'PTHR33401:SF26', NULL, NULL, NULL, NULL, '', 247791),
(378650, 'PTHR33401:SF16', NULL, NULL, NULL, NULL, 'BNACNNG22130D PROTEIN', 247791),
(378651, 'PTHR33401:SF13', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247791),
(378652, 'PTHR33401:SF25', NULL, NULL, NULL, NULL, 'NUCLEAR POLYADENYLATED RNA-BINDING PROTEIN', 247791),
(378653, 'PTHR33401', NULL, NULL, NULL, NULL, 'LIGHT-HARVESTING COMPLEX-LIKE PROTEIN OHP2, CHLOROPLASTIC', 247791),
(378654, 'PTHR36880:SF1', NULL, NULL, NULL, NULL, '9130008F23RIK PROTEIN', 247792),
(378655, 'PTHR36880', NULL, NULL, NULL, NULL, '9130008F23RIK PROTEIN', 247792),
(378656, 'PTHR16194', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 16', 247793),
(378657, 'PTHR16194:SF0', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 16', 247793),
(378658, 'PTHR41786:SF1', NULL, NULL, NULL, NULL, 'MOTILITY ACCESSORY FACTOR MAF', 247794),
(378659, 'PTHR41786', NULL, NULL, NULL, NULL, 'MOTILITY ACCESSORY FACTOR MAF', 247794),
(378660, 'PTHR33558:SF1', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-LIKE PROTEIN C5ORF63 HOMOLOG', 247795),
(378661, 'PTHR33558', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-LIKE PROTEIN C5ORF63 HOMOLOG', 247795),
(378662, 'PTHR33558:SF2', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-LIKE PROTEIN C5ORF63', 247795),
(378663, 'PTHR45859:SF4', NULL, NULL, NULL, NULL, 'BNAA01G32370D PROTEIN', 247796),
(378664, 'PTHR45859:SF5', NULL, NULL, NULL, NULL, 'INITIATION FACTOR EIF-2B BETA SUBUNIT, PUTATIVE-RELATED', 247796),
(378665, 'PTHR45859', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR EIF-2B SUBUNIT BETA', 247796),
(378666, 'PTHR45859:SF2', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR EIF-2B SUBUNIT BETA-LIKE', 247796),
(378667, 'PTHR45859:SF1', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR EIF-2B SUBUNIT BETA', 247796),
(378668, 'PTHR35757', NULL, NULL, NULL, NULL, 'THERMOSOME SUBUNIT GAMMA', 247797),
(378669, 'PTHR35757:SF1', NULL, NULL, NULL, NULL, 'THERMOSOME SUBUNIT GAMMA', 247797),
(378670, 'PTHR46562:SF2', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 247798),
(378671, 'PTHR46562:SF1', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE ULK4', 247798),
(378672, 'PTHR46562', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-KINASE ULK4-LIKE PROTEIN-RELATED', 247798),
(378673, 'PTHR42971', NULL, NULL, NULL, NULL, 'TRNA (CYTIDINE(34)-2''-O)-METHYLTRANSFERASE', 247799),
(378674, 'PTHR42971:SF1', NULL, NULL, NULL, NULL, 'TRNA (CYTIDINE(34)-2''-O)-METHYLTRANSFERASE', 247799),
(378675, 'PTHR47283', NULL, NULL, NULL, NULL, 'ENT-KAURENE OXIDASE, CHLOROPLASTIC', 247800),
(378676, 'PTHR47283:SF2', NULL, NULL, NULL, NULL, '', 247800),
(378677, 'PTHR47283:SF1', NULL, NULL, NULL, NULL, 'ENT-KAURENE OXIDASE, CHLOROPLASTIC', 247800),
(378678, 'PTHR47283:SF3', NULL, NULL, NULL, NULL, 'GA REQUIRING 3-RELATED', 247800),
(378679, 'PTHR17609', NULL, NULL, NULL, NULL, 'HMG DOMAIN-CONTAINING PROTEIN 3', 247801),
(378680, 'PTHR17609:SF2', NULL, NULL, NULL, NULL, 'HMG DOMAIN-CONTAINING PROTEIN 3', 247801);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(378681, 'PTHR17609:SF1', NULL, NULL, NULL, NULL, 'ZGC:165409', 247801),
(378682, 'PTHR47757', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS E (EPSILON)-RELATED', 247802),
(378683, 'PTHR47757:SF1', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS E (EPSILON)', 247802),
(378684, 'PTHR47757:SF2', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS E (EPSILON)', 247802),
(378685, 'PTHR35130', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 16', 247803),
(378686, 'PTHR35130:SF2', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 16', 247803),
(378687, 'PTHR35130:SF1', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 16', 247803),
(378688, 'PTHR20886', NULL, NULL, NULL, NULL, 'VANG-LIKE PROTEIN', 247804),
(378689, 'PTHR20886:SF10', NULL, NULL, NULL, NULL, 'VANG-LIKE PROTEIN 2', 247804),
(378690, 'PTHR20886:SF11', NULL, NULL, NULL, NULL, 'VANG-LIKE PROTEIN', 247804),
(378691, 'PTHR20886:SF8', NULL, NULL, NULL, NULL, 'VANG-LIKE PROTEIN 1', 247804),
(378692, 'PTHR46458:SF19', NULL, NULL, NULL, NULL, 'NEUROGLOBIN', 247805),
(378693, 'PTHR46458:SF17', NULL, NULL, NULL, NULL, 'GLOBIN RELATED', 247805),
(378694, 'PTHR46458:SF18', NULL, NULL, NULL, NULL, 'GLOBIN RELATED', 247805),
(378695, 'PTHR46458:SF15', NULL, NULL, NULL, NULL, 'GLOBIN DOMAIN-CONTAINING PROTEIN', 247805),
(378696, 'PTHR46458:SF16', NULL, NULL, NULL, NULL, 'GLOBIN RELATED-RELATED', 247805),
(378697, 'PTHR46458:SF14', NULL, NULL, NULL, NULL, 'GLOBIN DOMAIN-CONTAINING PROTEIN', 247805),
(378698, 'PTHR46458:SF11', NULL, NULL, NULL, NULL, 'GLOBIN-LIKE PROTEIN 9', 247805),
(378699, 'PTHR46458:SF12', NULL, NULL, NULL, NULL, 'GLOBIN RELATED', 247805),
(378700, 'PTHR46458:SF20', NULL, NULL, NULL, NULL, 'GLOBIN DOMAIN-CONTAINING PROTEIN', 247805),
(378701, 'PTHR46458:SF1', NULL, NULL, NULL, NULL, 'GLOBIN DOMAIN-CONTAINING PROTEIN', 247805),
(378702, 'PTHR46458:SF2', NULL, NULL, NULL, NULL, 'X GLOBIN', 247805),
(378703, 'PTHR46458', NULL, NULL, NULL, NULL, 'BLR2807 PROTEIN', 247805),
(378704, 'PTHR46458:SF5', NULL, NULL, NULL, NULL, 'GLOBIN DOMAIN-CONTAINING PROTEIN', 247805),
(378705, 'PTHR46458:SF6', NULL, NULL, NULL, NULL, 'GLOBIN DOMAIN-CONTAINING PROTEIN', 247805),
(378706, 'PTHR46458:SF7', NULL, NULL, NULL, NULL, 'GLOBIN DOMAIN-CONTAINING PROTEIN', 247805),
(378707, 'PTHR46458:SF8', NULL, NULL, NULL, NULL, 'GLOBIN-LIKE PROTEIN 6', 247805),
(378708, 'PTHR10804:SF133', NULL, NULL, NULL, NULL, 'ERBB-3 BINDING PROTEIN 1-LIKE', 247806),
(378709, 'PTHR10804:SF132', NULL, NULL, NULL, NULL, 'PEPTIDASE_M24 DOMAIN-CONTAINING PROTEIN', 247806),
(378710, 'PTHR10804:SF130', NULL, NULL, NULL, NULL, 'PROLIFERATION-ASSOCIATED PROTEIN 2G4', 247806),
(378711, 'PTHR10804', NULL, NULL, NULL, NULL, 'PROTEASE FAMILY M24  METHIONYL AMINOPEPTIDASE, AMINOPEPTIDASE P', 247806),
(378712, 'PTHR10804:SF137', NULL, NULL, NULL, NULL, 'ERBB-3 BINDING PROTEIN 1', 247806),
(378713, 'PTHR10804:SF136', NULL, NULL, NULL, NULL, 'PEPTIDASE_M24 DOMAIN-CONTAINING PROTEIN', 247806),
(378714, 'PTHR10804:SF102', NULL, NULL, NULL, NULL, 'METALLOPROTEASE ARX1-RELATED', 247806),
(378715, 'PTHR10804:SF134', NULL, NULL, NULL, NULL, 'PROLIFERATION-ASSOCIATED 2G4-LIKE PROTEIN', 247806),
(378716, 'PTHR10804:SF11', NULL, NULL, NULL, NULL, 'PROLIFERATION-ASSOCIATED PROTEIN 2G4', 247806),
(378717, 'PTHR10804:SF138', NULL, NULL, NULL, NULL, 'PEPTIDASE M24, METHIONINE AMINOPEPTIDASE-RELATED', 247806),
(378718, 'PTHR14209:SF38', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 247807),
(378719, 'PTHR14209', NULL, NULL, NULL, NULL, 'ISOAMYL ACETATE-HYDROLYZING ESTERASE 1', 247807),
(378720, 'PTHR14209:SF39', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE PLANT-LIKE PROTEIN', 247807),
(378721, 'PTHR14209:SF29', NULL, NULL, NULL, NULL, 'SGNH_HYDRO DOMAIN-CONTAINING PROTEIN', 247807),
(378722, 'PTHR14209:SF19', NULL, NULL, NULL, NULL, 'ISOAMYL ACETATE-HYDROLYZING ESTERASE 1 HOMOLOG', 247807),
(378723, 'PTHR14209:SF34', NULL, NULL, NULL, NULL, 'SGNH_HYDRO DOMAIN-CONTAINING PROTEIN', 247807),
(378724, 'PTHR14209:SF23', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 247807);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(378725, 'PTHR14209:SF36', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE FAMILY PROTEIN, EXPRESSED', 247807),
(378726, 'PTHR14209:SF37', NULL, NULL, NULL, NULL, 'SGNH_HYDRO DOMAIN-CONTAINING PROTEIN', 247807),
(378727, 'PTHR14209:SF30', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE CPRD49-LIKE', 247807),
(378728, 'PTHR14209:SF9', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE CPRD49', 247807),
(378729, 'PTHR14209:SF31', NULL, NULL, NULL, NULL, 'SGNH_HYDRO DOMAIN-CONTAINING PROTEIN', 247807),
(378730, 'PTHR14209:SF20', NULL, NULL, NULL, NULL, 'OS01G0214200 PROTEIN', 247807),
(378731, 'PTHR14209:SF10', NULL, NULL, NULL, NULL, 'SGNH_HYDRO DOMAIN-CONTAINING PROTEIN', 247807),
(378732, 'PTHR14209:SF21', NULL, NULL, NULL, NULL, 'HYDROLYZING ESTERASE-LIKE PROTEIN, PUTATIVE-RELATED', 247807),
(378733, 'PTHR14209:SF33', NULL, NULL, NULL, NULL, 'SGNH_HYDRO DOMAIN-CONTAINING PROTEIN', 247807),
(378734, 'PTHR20371:SF1', NULL, NULL, NULL, NULL, 'ENOLASE-PHOSPHATASE E1', 247808),
(378735, 'PTHR20371:SF3', NULL, NULL, NULL, NULL, 'ENOLASE-PHOSPHATASE E1', 247808),
(378736, 'PTHR20371:SF2', NULL, NULL, NULL, NULL, '', 247808),
(378737, 'PTHR20371', NULL, NULL, NULL, NULL, 'ENOLASE-PHOSPHATASE E1', 247808),
(378738, 'PTHR46897:SF1', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE PROTEIN 4', 247809),
(378739, 'PTHR46897', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE PROTEIN 4', 247809),
(378740, 'PTHR42100', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE 178 KDA SUBUNIT, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G04320)-RELATED', 247810),
(378741, 'PTHR42100:SF1', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE 178 KDA SUBUNIT, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G04320)-RELATED', 247810),
(378742, 'PTHR44144:SF1', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 9', 247811),
(378743, 'PTHR44144', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 9', 247811),
(378744, 'PTHR11786:SF8', NULL, NULL, NULL, NULL, 'ARYLAMINE N-ACETYLTRANSFERASE 1', 247812),
(378745, 'PTHR11786:SF6', NULL, NULL, NULL, NULL, 'ARYLAMINE N-ACETYLTRANSFERASE 2', 247812),
(378746, 'PTHR11786:SF0', NULL, NULL, NULL, NULL, 'ARYLAMINE N-ACETYLTRANSFERASE-RELATED', 247812),
(378747, 'PTHR11786', NULL, NULL, NULL, NULL, 'N-HYDROXYARYLAMINE O-ACETYLTRANSFERASE', 247812),
(378748, 'PTHR11786:SF5', NULL, NULL, NULL, NULL, 'ARYLAMINE N-ACETYLTRANSFERASE 3', 247812),
(378749, 'PTHR11786:SF2', NULL, NULL, NULL, NULL, 'ARYLAMINE N-ACETYLTRANSFERASE 1', 247812),
(378750, 'PTHR11786:SF3', NULL, NULL, NULL, NULL, 'ARYLAMINE N-ACETYLTRANSFERASE', 247812),
(378751, 'PTHR33090:SF102', NULL, NULL, NULL, NULL, 'OS08G0178500 PROTEIN', 247813),
(378752, 'PTHR33090:SF101', NULL, NULL, NULL, NULL, '', 247813),
(378753, 'PTHR33090:SF100', NULL, NULL, NULL, NULL, '', 247813),
(378754, 'PTHR33090:SF60', NULL, NULL, NULL, NULL, 'WOUND INDUCED PROTEIN', 247813),
(378755, 'PTHR33090:SF66', NULL, NULL, NULL, NULL, 'OS07G0558900 PROTEIN', 247813),
(378756, 'PTHR33090:SF68', NULL, NULL, NULL, NULL, 'OS04G0634800 PROTEIN', 247813),
(378757, 'PTHR33090:SF69', NULL, NULL, NULL, NULL, 'WOUND-RESPONSIVE FAMILY PROTEIN', 247813),
(378758, 'PTHR33090:SF65', NULL, NULL, NULL, NULL, '', 247813),
(378759, 'PTHR33090:SF26', NULL, NULL, NULL, NULL, 'BNAA09G10410D PROTEIN', 247813),
(378760, 'PTHR33090:SF3', NULL, NULL, NULL, NULL, 'OS06G0683700 PROTEIN', 247813),
(378761, 'PTHR33090:SF28', NULL, NULL, NULL, NULL, 'OS04G0635500 PROTEIN', 247813),
(378762, 'PTHR33090:SF6', NULL, NULL, NULL, NULL, 'OS04G0635000 PROTEIN', 247813),
(378763, 'PTHR33090:SF70', NULL, NULL, NULL, NULL, 'BNAA06G17220D PROTEIN', 247813),
(378764, 'PTHR33090:SF71', NULL, NULL, NULL, NULL, 'WOUND-RESPONSIVE FAMILY PROTEIN', 247813),
(378765, 'PTHR33090:SF77', NULL, NULL, NULL, NULL, '', 247813),
(378766, 'PTHR33090:SF33', NULL, NULL, NULL, NULL, 'WOUND-RESPONSIVE FAMILY PROTEIN', 247813),
(378767, 'PTHR33090:SF106', NULL, NULL, NULL, NULL, '', 247813),
(378768, 'PTHR33090:SF73', NULL, NULL, NULL, NULL, 'BNAA09G19970D PROTEIN', 247813),
(378769, 'PTHR33090:SF105', NULL, NULL, NULL, NULL, 'WOUND INDUCED PROTEIN', 247813);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(378770, 'PTHR33090:SF30', NULL, NULL, NULL, NULL, '', 247813),
(378771, 'PTHR33090:SF75', NULL, NULL, NULL, NULL, 'WOUND-RESPONSIVE FAMILY PROTEIN', 247813),
(378772, 'PTHR33090:SF104', NULL, NULL, NULL, NULL, '', 247813),
(378773, 'PTHR33090:SF103', NULL, NULL, NULL, NULL, '2-NONAPRENYL-3-METHYL-6-METHOXY-1,4-BENZOQUINOL HYDROXYLASE', 247813),
(378774, 'PTHR33090:SF32', NULL, NULL, NULL, NULL, 'WOUND-RESPONSIVE FAMILY PROTEIN', 247813),
(378775, 'PTHR33090:SF37', NULL, NULL, NULL, NULL, '', 247813),
(378776, 'PTHR33090:SF39', NULL, NULL, NULL, NULL, 'BNAC06G41740D PROTEIN', 247813),
(378777, 'PTHR33090', NULL, NULL, NULL, NULL, 'DUF3774 DOMAIN PROTEIN-RELATED', 247813),
(378778, 'PTHR33090:SF82', NULL, NULL, NULL, NULL, 'WOUND INDUCED PROTEIN', 247813),
(378779, 'PTHR33090:SF83', NULL, NULL, NULL, NULL, 'OS07G0559100 PROTEIN', 247813),
(378780, 'PTHR33090:SF88', NULL, NULL, NULL, NULL, '', 247813),
(378781, 'PTHR33090:SF89', NULL, NULL, NULL, NULL, '', 247813),
(378782, 'PTHR33090:SF84', NULL, NULL, NULL, NULL, '2-NONAPRENYL-3-METHYL-6-METHOXY-1,4-BENZOQUINOL HYDROXYLASE', 247813),
(378783, 'PTHR33090:SF85', NULL, NULL, NULL, NULL, 'WOUND-RESPONSIVE FAMILY PROTEIN', 247813),
(378784, 'PTHR33090:SF86', NULL, NULL, NULL, NULL, '', 247813),
(378785, 'PTHR33090:SF87', NULL, NULL, NULL, NULL, '', 247813),
(378786, 'PTHR33090:SF48', NULL, NULL, NULL, NULL, '', 247813),
(378787, 'PTHR33090:SF49', NULL, NULL, NULL, NULL, '', 247813),
(378788, 'PTHR33090:SF91', NULL, NULL, NULL, NULL, '', 247813),
(378789, 'PTHR33090:SF92', NULL, NULL, NULL, NULL, '', 247813),
(378790, 'PTHR33090:SF93', NULL, NULL, NULL, NULL, 'WOUND-RESPONSIVE FAMILY PROTEIN', 247813),
(378791, 'PTHR33090:SF94', NULL, NULL, NULL, NULL, 'WOUND-RESPONSIVE FAMILY PROTEIN', 247813),
(378792, 'PTHR33090:SF90', NULL, NULL, NULL, NULL, '', 247813),
(378793, 'PTHR33090:SF55', NULL, NULL, NULL, NULL, 'WOUND-RESPONSIVE FAMILY PROTEIN', 247813),
(378794, 'PTHR33090:SF99', NULL, NULL, NULL, NULL, 'BNAA08G13840D PROTEIN', 247813),
(378795, 'PTHR33090:SF95', NULL, NULL, NULL, NULL, '', 247813),
(378796, 'PTHR33090:SF96', NULL, NULL, NULL, NULL, '', 247813),
(378797, 'PTHR33090:SF97', NULL, NULL, NULL, NULL, '', 247813),
(378798, 'PTHR33090:SF53', NULL, NULL, NULL, NULL, 'WOUND-RESPONSIVE FAMILY PROTEIN', 247813),
(378799, 'PTHR33090:SF98', NULL, NULL, NULL, NULL, '', 247813),
(378800, 'PTHR33090:SF54', NULL, NULL, NULL, NULL, 'OS02G0160900 PROTEIN', 247813),
(378801, 'PTHR33090:SF59', NULL, NULL, NULL, NULL, 'BNAC01G20750D PROTEIN', 247813),
(378802, 'PTHR37947', NULL, NULL, NULL, NULL, 'BLL2462 PROTEIN', 247814),
(378803, 'PTHR37947:SF2', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 247814),
(378804, 'PTHR37947:SF1', NULL, NULL, NULL, NULL, 'BLL2462 PROTEIN', 247814),
(378805, 'PTHR21469', NULL, NULL, NULL, NULL, 'EXOPHILIN-5', 247815),
(378806, 'PTHR21469:SF4', NULL, NULL, NULL, NULL, 'EXOPHILIN-5', 247815),
(378807, 'PTHR34809:SF3', NULL, NULL, NULL, NULL, 'BNAC09G40390D PROTEIN', 247816),
(378808, 'PTHR34809:SF4', NULL, NULL, NULL, NULL, 'MALTOSE EXCESS PROTEIN 1-LIKE, CHLOROPLASTIC', 247816),
(378809, 'PTHR34809', NULL, NULL, NULL, NULL, 'MALTOSE EXCESS PROTEIN 1, CHLOROPLASTIC-RELATED', 247816),
(378810, 'PTHR34809:SF1', NULL, NULL, NULL, NULL, 'MALTOSE EXCESS PROTEIN 1, CHLOROPLASTIC-RELATED', 247816),
(378811, 'PTHR46406:SF1', NULL, NULL, NULL, NULL, 'NITRIC OXIDE-ASSOCIATED PROTEIN 1', 247817),
(378812, 'PTHR46406', NULL, NULL, NULL, NULL, 'NITRIC OXIDE-ASSOCIATED PROTEIN 1', 247817),
(378813, 'PTHR42240', NULL, NULL, NULL, NULL, '', 247818),
(378814, 'PTHR42240:SF1', NULL, NULL, NULL, NULL, '', 247818),
(378815, 'PTHR23515:SF22', NULL, NULL, NULL, NULL, '', 247819),
(378816, 'PTHR23515:SF21', NULL, NULL, NULL, NULL, 'HIGH AFFINITY NITRATE TRANSPORTER 2.4-LIKE', 247819),
(378817, 'PTHR23515:SF20', NULL, NULL, NULL, NULL, 'HIGH AFFINITY NITRATE TRANSPORTER 2.6', 247819),
(378818, 'PTHR23515:SF41', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 247819),
(378819, 'PTHR23515:SF29', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY NITRATE TRANSPORTER 2.1-RELATED', 247819);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(378820, 'PTHR23515:SF27', NULL, NULL, NULL, NULL, 'BNAC08G43370D PROTEIN', 247819),
(378821, 'PTHR23515', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY NITRATE TRANSPORTER 2.3', 247819),
(378822, 'PTHR23515:SF40', NULL, NULL, NULL, NULL, 'NITRATE/NITRITE TRANSPORTER', 247819),
(378823, 'PTHR23515:SF9', NULL, NULL, NULL, NULL, 'NITRATE/NITRITE TRANSPORTER NARK', 247819),
(378824, 'PTHR23515:SF6', NULL, NULL, NULL, NULL, 'NITRATE/NITRITE TRANSPORTER NARU', 247819),
(378825, 'PTHR23515:SF37', NULL, NULL, NULL, NULL, '', 247819),
(378826, 'PTHR23515:SF36', NULL, NULL, NULL, NULL, 'HIGH AFFINITY NITRATE TRANSPORTER 2.4-LIKE', 247819),
(378827, 'PTHR23515:SF35', NULL, NULL, NULL, NULL, '', 247819),
(378828, 'PTHR23515:SF2', NULL, NULL, NULL, NULL, 'HIGH AFFINITY NITRATE TRANSPORTER 2.5', 247819),
(378829, 'PTHR23515:SF34', NULL, NULL, NULL, NULL, '', 247819),
(378830, 'PTHR23515:SF12', NULL, NULL, NULL, NULL, 'HIGH AFFINITY NITRATE TRANSPORTER 2.4-LIKE', 247819),
(378831, 'PTHR23515:SF33', NULL, NULL, NULL, NULL, '', 247819),
(378832, 'PTHR23515:SF10', NULL, NULL, NULL, NULL, 'HIGH AFFINITY NITRATE TRANSPORTER 2.7', 247819),
(378833, 'PTHR23515:SF32', NULL, NULL, NULL, NULL, '', 247819),
(378834, 'PTHR23515:SF31', NULL, NULL, NULL, NULL, 'HIGH AFFINITY NITRATE TRANSPORTER 2.4', 247819),
(378835, 'PTHR23515:SF30', NULL, NULL, NULL, NULL, 'NITRATE TRANSPORTER 2:1-RELATED', 247819),
(378836, 'PTHR23515:SF19', NULL, NULL, NULL, NULL, 'HIGH AFFINITY NITRATE TRANSPORTER 2.3', 247819),
(378837, 'PTHR23515:SF17', NULL, NULL, NULL, NULL, 'NITRATE TRANSPORT3', 247819),
(378838, 'PTHR23515:SF39', NULL, NULL, NULL, NULL, 'BNAC08G02430D PROTEIN', 247819),
(378839, 'PTHR23515:SF16', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY NITRATE TRANSPORTER 2.1-LIKE', 247819),
(378840, 'PTHR23515:SF38', NULL, NULL, NULL, NULL, 'NITRITE EXTRUSION PROTEIN', 247819),
(378841, 'PTHR34986', NULL, NULL, NULL, NULL, 'EVOLVED BETA-GALACTOSIDASE SUBUNIT BETA', 247820),
(378842, 'PTHR34986:SF4', NULL, NULL, NULL, NULL, 'TOXIN-ANTITOXIN BIOFILM PROTEIN TABA', 247820),
(378843, 'PTHR34986:SF3', NULL, NULL, NULL, NULL, 'PROTEIN YIAL', 247820),
(378844, 'PTHR34986:SF1', NULL, NULL, NULL, NULL, 'EVOLVED BETA-GALACTOSIDASE SUBUNIT BETA', 247820),
(378845, 'PTHR14657:SF2', NULL, NULL, NULL, NULL, 'IGF-LIKE FAMILY RECEPTOR 1', 247821),
(378846, 'PTHR14657', NULL, NULL, NULL, NULL, 'IGF-LIKE FAMILY RECEPTOR 1', 247821),
(378847, 'PTHR26450:SF175', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 52E6', 247822),
(378848, 'PTHR26450:SF66', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 51I1', 247822),
(378849, 'PTHR26450:SF67', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 51V1', 247822),
(378850, 'PTHR26450:SF170', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 52E8', 247822),
(378851, 'PTHR26450:SF69', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 56B1', 247822),
(378852, 'PTHR26450:SF63', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 52Z1', 247822),
(378853, 'PTHR26450:SF64', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378854, 'PTHR26450:SF166', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 51D1', 247822),
(378855, 'PTHR26450:SF167', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 51E1', 247822),
(378856, 'PTHR26450:SF60', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378857, 'PTHR26450:SF168', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 51A2-RELATED', 247822),
(378858, 'PTHR26450:SF59', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378859, 'PTHR26450:SF180', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378860, 'PTHR26450:SF181', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378861, 'PTHR26450:SF58', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 52W1', 247822),
(378862, 'PTHR26450:SF51', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378863, 'PTHR26450:SF52', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 680, PSEUDOGENE 1-RELATED', 247822),
(378864, 'PTHR26450:SF53', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 51H1', 247822),
(378865, 'PTHR26450:SF54', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378866, 'PTHR26450:SF177', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 52I1-RELATED', 247822);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(378867, 'PTHR26450:SF179', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378868, 'PTHR26450:SF194', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 52N4', 247822),
(378869, 'PTHR26450:SF48', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 52A5', 247822),
(378870, 'PTHR26450:SF195', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378871, 'PTHR26450:SF196', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378872, 'PTHR26450:SF351', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378873, 'PTHR26450:SF44', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 51M1', 247822),
(378874, 'PTHR26450:SF45', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378875, 'PTHR26450:SF46', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 51F1', 247822),
(378876, 'PTHR26450:SF192', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378877, 'PTHR26450:SF193', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378878, 'PTHR26450:SF109', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378879, 'PTHR26450:SF103', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378880, 'PTHR26450:SF40', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 56A3', 247822),
(378881, 'PTHR26450:SF104', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378882, 'PTHR26450:SF42', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378883, 'PTHR26450:SF105', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 52H1-LIKE', 247822),
(378884, 'PTHR26450:SF106', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378885, 'PTHR26450:SF43', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378886, 'PTHR26450:SF100', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378887, 'PTHR26450:SF189', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 52A4', 247822),
(378888, 'PTHR26450:SF101', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378889, 'PTHR26450:SF37', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 51L1', 247822),
(378890, 'PTHR26450:SF38', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 605', 247822),
(378891, 'PTHR26450:SF360', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 663', 247822),
(378892, 'PTHR26450:SF39', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR FAMILY 52 SUBFAMILY X MEMBER 3', 247822),
(378893, 'PTHR26450:SF120', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 51A7', 247822),
(378894, 'PTHR26450:SF35', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378895, 'PTHR26450:SF36', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378896, 'PTHR26450', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 56B1-RELATED', 247822),
(378897, 'PTHR26450:SF30', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 572', 247822),
(378898, 'PTHR26450:SF115', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378899, 'PTHR26450:SF116', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378900, 'PTHR26450:SF31', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 645', 247822),
(378901, 'PTHR26450:SF32', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 52B6', 247822),
(378902, 'PTHR26450:SF117', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378903, 'PTHR26450:SF110', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378904, 'PTHR26450:SF198', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378905, 'PTHR26450:SF111', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378906, 'PTHR26450:SF353', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 52L2-RELATED', 247822),
(378907, 'PTHR26450:SF354', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378908, 'PTHR26450:SF112', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 51I2', 247822),
(378909, 'PTHR26450:SF355', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 52J3', 247822),
(378910, 'PTHR26450:SF26', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 56B2-RELATED', 247822),
(378911, 'PTHR26450:SF130', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 601', 247822),
(378912, 'PTHR26450:SF29', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 609', 247822),
(378913, 'PTHR26450:SF22', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 51B6', 247822),
(378914, 'PTHR26450:SF23', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 52E5', 247822);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(378915, 'PTHR26450:SF24', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 655', 247822),
(378916, 'PTHR26450:SF25', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378917, 'PTHR26450:SF408', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378918, 'PTHR26450:SF404', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 52K2', 247822),
(378919, 'PTHR26450:SF405', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378920, 'PTHR26450:SF406', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378921, 'PTHR26450:SF407', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 247822),
(378922, 'PTHR26450:SF367', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378923, 'PTHR26450:SF126', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378924, 'PTHR26450:SF401', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 52K1', 247822),
(378925, 'PTHR26450:SF20', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378926, 'PTHR26450:SF402', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR FAMILY 52 SUBFAMILY N MEMBER 4K', 247822),
(378927, 'PTHR26450:SF128', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378928, 'PTHR26450:SF121', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378929, 'PTHR26450:SF365', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378930, 'PTHR26450:SF123', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 52H1', 247822),
(378931, 'PTHR26450:SF124', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378932, 'PTHR26450:SF16', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378933, 'PTHR26450:SF140', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 51G1', 247822),
(378934, 'PTHR26450:SF141', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378935, 'PTHR26450:SF17', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378936, 'PTHR26450:SF384', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 56A5', 247822),
(378937, 'PTHR26450:SF142', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 56B4', 247822),
(378938, 'PTHR26450:SF18', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 52N5', 247822),
(378939, 'PTHR26450:SF11', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378940, 'PTHR26450:SF12', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378941, 'PTHR26450:SF13', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 52E4', 247822),
(378942, 'PTHR26450:SF14', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378943, 'PTHR26450:SF19', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378944, 'PTHR26450:SF419', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 247822),
(378945, 'PTHR26450:SF416', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR, FAMILY D, SUBFAMILY 107, MEMBER 1', 247822),
(378946, 'PTHR26450:SF417', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR-RELATED', 247822),
(378947, 'PTHR26450:SF418', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378948, 'PTHR26450:SF136', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 52M1', 247822),
(378949, 'PTHR26450:SF411', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378950, 'PTHR26450:SF412', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378951, 'PTHR26450:SF379', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 247822),
(378952, 'PTHR26450:SF96', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 52L1', 247822),
(378953, 'PTHR26450:SF138', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378954, 'PTHR26450:SF97', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378955, 'PTHR26450:SF98', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 52A1', 247822),
(378956, 'PTHR26450:SF414', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR FAMILY 56 SUBFAMILY A MEMBER 22', 247822),
(378957, 'PTHR26450:SF132', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 654', 247822),
(378958, 'PTHR26450:SF92', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 51E2', 247822),
(378959, 'PTHR26450:SF133', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 51G2', 247822),
(378960, 'PTHR26450:SF410', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(378961, 'PTHR26450:SF94', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378962, 'PTHR26450:SF392', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 52E2', 247822),
(378963, 'PTHR26450:SF393', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378964, 'PTHR26450:SF151', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 52B2', 247822),
(378965, 'PTHR26450:SF394', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378966, 'PTHR26450:SF152', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378967, 'PTHR26450:SF395', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378968, 'PTHR26450:SF89', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 52B4', 247822),
(378969, 'PTHR26450:SF390', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378970, 'PTHR26450:SF391', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN-RELATED', 247822),
(378971, 'PTHR26450:SF426', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378972, 'PTHR26450:SF422', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378973, 'PTHR26450:SF84', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 51Q1', 247822),
(378974, 'PTHR26450:SF148', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378975, 'PTHR26450:SF423', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378976, 'PTHR26450:SF424', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 56A4', 247822),
(378977, 'PTHR26450:SF149', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378978, 'PTHR26450:SF87', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 51F2', 247822),
(378979, 'PTHR26450:SF425', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 56A1', 247822),
(378980, 'PTHR26450:SF81', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 51J1', 247822),
(378981, 'PTHR26450:SF386', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378982, 'PTHR26450:SF145', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 52N1', 247822),
(378983, 'PTHR26450:SF420', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378984, 'PTHR26450:SF421', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 573, PSEUDOGENE 1', 247822),
(378985, 'PTHR26450:SF83', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 52P1-RELATED', 247822),
(378986, 'PTHR26450:SF388', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378987, 'PTHR26450:SF146', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378988, 'PTHR26450:SF161', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 52N2', 247822),
(378989, 'PTHR26450:SF6', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 51T1', 247822),
(378990, 'PTHR26450:SF7', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378991, 'PTHR26450:SF5', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378992, 'PTHR26450:SF164', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 51B2', 247822),
(378993, 'PTHR26450:SF77', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378994, 'PTHR26450:SF2', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(378995, 'PTHR26450:SF3', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 52E1', 247822),
(378996, 'PTHR26450:SF79', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 247822),
(378997, 'PTHR26450:SF160', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 553', 247822),
(378998, 'PTHR26450:SF1', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 613', 247822),
(378999, 'PTHR26450:SF73', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 51S1', 247822),
(379000, 'PTHR26450:SF75', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 52D1', 247822),
(379001, 'PTHR26450:SF76', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 51B5', 247822),
(379002, 'PTHR26450:SF154', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 51B4', 247822),
(379003, 'PTHR26450:SF396', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(379004, 'PTHR26450:SF397', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(379005, 'PTHR26450:SF70', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 593', 247822),
(379006, 'PTHR26450:SF156', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 52R1', 247822),
(379007, 'PTHR26450:SF399', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(379008, 'PTHR26450:SF72', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 247822),
(379009, 'PTHR26450:SF157', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 688-RELATED', 247822),
(379010, 'PTHR21465:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 469', 247823),
(379011, 'PTHR21465', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 469', 247823),
(379012, 'PTHR14911:SF21', NULL, NULL, NULL, NULL, 'N2-METHYLGUANOSINE TRNA METHYLTRANSFERASE', 247824),
(379013, 'PTHR14911:SF13', NULL, NULL, NULL, NULL, 'THUMP DOMAIN-CONTAINING PROTEIN 3', 247824),
(379014, 'PTHR14911:SF1', NULL, NULL, NULL, NULL, 'THUMP DOMAIN-CONTAINING PROTEIN 2', 247824),
(379015, 'PTHR14911', NULL, NULL, NULL, NULL, 'THUMP DOMAIN-CONTAINING', 247824),
(379016, 'PTHR14911:SF14', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN, CONTAINING THUMP DOMAIN', 247824),
(379017, 'PTHR19969:SF20', NULL, NULL, NULL, NULL, 'CRK-LIKE PROTEIN', 247825),
(379018, 'PTHR19969:SF10', NULL, NULL, NULL, NULL, 'GTPASE ACTIVATING PROTEIN FAMILY', 247825),
(379019, 'PTHR19969', NULL, NULL, NULL, NULL, 'SH2-SH3 ADAPTOR PROTEIN-RELATED', 247825),
(379020, 'PTHR19969:SF22', NULL, NULL, NULL, NULL, 'GRB2-RELATED ADAPTER PROTEIN-LIKE', 247825),
(379021, 'PTHR19969:SF12', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN NCK2', 247825),
(379022, 'PTHR19969:SF13', NULL, NULL, NULL, NULL, 'GRB2 RELATED ADAPTOR PROTEIN 2', 247825),
(379023, 'PTHR19969:SF8', NULL, NULL, NULL, NULL, 'ADAPTER MOLECULE CRK', 247825),
(379024, 'PTHR19969:SF14', NULL, NULL, NULL, NULL, 'DREADLOCKS, ISOFORM B', 247825),
(379025, 'PTHR19969:SF15', NULL, NULL, NULL, NULL, 'SRC-LIKE-ADAPTOR 2', 247825),
(379026, 'PTHR19969:SF16', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN NCK1', 247825),
(379027, 'PTHR19969:SF18', NULL, NULL, NULL, NULL, 'GRB2 RELATED ADAPTOR PROTEIN', 247825),
(379028, 'PTHR19969:SF19', NULL, NULL, NULL, NULL, 'DMD-8', 247825),
(379029, 'PTHR19969:SF5', NULL, NULL, NULL, NULL, 'ADAPTER MOLECULE CRK', 247825),
(379030, 'PTHR28574', NULL, NULL, NULL, NULL, 'RIKEN CDNA 6820408C15', 247826),
(379031, 'PTHR28574:SF1', NULL, NULL, NULL, NULL, 'RIKEN CDNA 6820408C15 GENE', 247826),
(379032, 'PTHR42105:SF1', NULL, NULL, NULL, NULL, 'DIM2-ASSOCIATED PROTEIN 1', 247827),
(379033, 'PTHR42105', NULL, NULL, NULL, NULL, 'DIM2-ASSOCIATED PROTEIN 1', 247827),
(379034, 'PTHR12125:SF13', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 44', 247828),
(379035, 'PTHR12125:SF12', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 6', 247828),
(379036, 'PTHR12125:SF9', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 27', 247828),
(379037, 'PTHR12125:SF11', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 2', 247828),
(379038, 'PTHR12125', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 6-LIKE PROTEIN', 247828),
(379039, 'PTHR12125:SF1', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 50', 247828),
(379040, 'PTHR12125:SF7', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 17', 247828),
(379041, 'PTHR12125:SF5', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 6-LIKE PROTEIN', 247828),
(379042, 'PTHR47505', NULL, NULL, NULL, NULL, 'DNA UTILIZATION PROTEIN YHGH', 247829),
(379043, 'PTHR47505:SF1', NULL, NULL, NULL, NULL, 'DNA UTILIZATION PROTEIN YHGH', 247829),
(379044, 'PTHR46394', NULL, NULL, NULL, NULL, 'ANNEXIN', 247830),
(379045, 'PTHR46394:SF1', NULL, NULL, NULL, NULL, 'PNPLA DOMAIN-CONTAINING PROTEIN', 247830),
(379046, 'PTHR48017:SF50', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379047, 'PTHR48017:SF214', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE, EXPRESSED-RELATED', 247831),
(379048, 'PTHR48017:SF217', NULL, NULL, NULL, NULL, 'ACID TRANSPORTER FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 247831),
(379049, 'PTHR48017:SF216', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER, TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN-RELATED', 247831),
(379050, 'PTHR48017:SF53', NULL, NULL, NULL, NULL, 'LYSINE HISTIDINE TRANSPORTER 2', 247831),
(379051, 'PTHR48017:SF211', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE 7-RELATED', 247831),
(379052, 'PTHR48017:SF178', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(379053, 'PTHR48017:SF177', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379054, 'PTHR48017:SF213', NULL, NULL, NULL, NULL, 'LYSINE HISTIDINE TRANSPORTER-LIKE 3-RELATED', 247831),
(379055, 'PTHR48017:SF179', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379056, 'PTHR48017:SF59', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE 1', 247831),
(379057, 'PTHR48017:SF173', NULL, NULL, NULL, NULL, 'OS01G0878700 PROTEIN', 247831),
(379058, 'PTHR48017:SF176', NULL, NULL, NULL, NULL, 'AUXIN TRANSPORTER-LIKE PROTEIN 3', 247831),
(379059, 'PTHR48017:SF175', NULL, NULL, NULL, NULL, 'LOW QUALITY PROTEIN: AMINO ACID PERMEASE 6-LIKE', 247831),
(379060, 'PTHR48017:SF54', NULL, NULL, NULL, NULL, 'GABA TRANSPORTER 2-RELATED', 247831),
(379061, 'PTHR48017:SF56', NULL, NULL, NULL, NULL, 'VACUOLAR AMINO ACID TRANSPORTER 1-LIKE', 247831),
(379062, 'PTHR48017:SF57', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE 6', 247831),
(379063, 'PTHR48017:SF219', NULL, NULL, NULL, NULL, 'PROLINE TRANSPORTER 2', 247831),
(379064, 'PTHR48017:SF218', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER, TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN-RELATED', 247831),
(379065, 'PTHR48017:SF40', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE 1-RELATED', 247831),
(379066, 'PTHR48017:SF206', NULL, NULL, NULL, NULL, 'VESICULAR GABA TRANSPORTER', 247831),
(379067, 'PTHR48017:SF41', NULL, NULL, NULL, NULL, 'OS01G0586500 PROTEIN', 247831),
(379068, 'PTHR48017:SF205', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379069, 'PTHR48017:SF42', NULL, NULL, NULL, NULL, 'LYSINE HISTIDINE TRANSPORTER-LIKE 5', 247831),
(379070, 'PTHR48017:SF167', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE 4-LIKE ISOFORM X1', 247831),
(379071, 'PTHR48017:SF166', NULL, NULL, NULL, NULL, 'BNAA06G38000D PROTEIN', 247831),
(379072, 'PTHR48017:SF169', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER AVT1H', 247831),
(379073, 'PTHR48017:SF168', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379074, 'PTHR48017:SF163', NULL, NULL, NULL, NULL, 'LYSINE HISTIDINE TRANSPORTER-LIKE 8', 247831),
(379075, 'PTHR48017:SF47', NULL, NULL, NULL, NULL, 'OS04G0562100 PROTEIN', 247831),
(379076, 'PTHR48017:SF48', NULL, NULL, NULL, NULL, 'MAHOGANY', 247831),
(379077, 'PTHR48017:SF162', NULL, NULL, NULL, NULL, 'OS01G0908600 PROTEIN', 247831),
(379078, 'PTHR48017:SF165', NULL, NULL, NULL, NULL, 'LYSINE HISTIDINE TRANSPORTER 1-LIKE', 247831),
(379079, 'PTHR48017:SF49', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379080, 'PTHR48017:SF164', NULL, NULL, NULL, NULL, 'LHT1', 247831),
(379081, 'PTHR48017:SF43', NULL, NULL, NULL, NULL, 'BNAC05G49210D PROTEIN', 247831),
(379082, 'PTHR48017:SF161', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE 7-RELATED', 247831),
(379083, 'PTHR48017:SF45', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379084, 'PTHR48017:SF160', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER, TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN-RELATED', 247831),
(379085, 'PTHR48017:SF46', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE 1', 247831),
(379086, 'PTHR48017:SF237', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379087, 'PTHR48017:SF116', NULL, NULL, NULL, NULL, 'LYSINE HISTIDINE TRANSPORTER-LIKE 1', 247831),
(379088, 'PTHR48017:SF115', NULL, NULL, NULL, NULL, 'PROLINE TRANSPORTER 2', 247831),
(379089, 'PTHR48017:SF236', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379090, 'PTHR48017:SF118', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER AVT1J', 247831),
(379091, 'PTHR48017:SF30', NULL, NULL, NULL, NULL, 'LHT1', 247831),
(379092, 'PTHR48017:SF239', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AMINO ACID TRANSPORTER FAMILY PROTEIN', 247831),
(379093, 'PTHR48017:SF31', NULL, NULL, NULL, NULL, 'AUXIN TRANSPORTER-LIKE PROTEIN 2', 247831),
(379094, 'PTHR48017:SF238', NULL, NULL, NULL, NULL, 'LYSINE HISTIDINE TRANSPORTER 1-LIKE', 247831),
(379095, 'PTHR48017:SF112', NULL, NULL, NULL, NULL, 'OS10G0415100 PROTEIN', 247831);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(379096, 'PTHR48017:SF233', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379097, 'PTHR48017:SF111', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER AVT1A', 247831),
(379098, 'PTHR48017:SF232', NULL, NULL, NULL, NULL, 'OS05G0237800 PROTEIN', 247831),
(379099, 'PTHR48017:SF199', NULL, NULL, NULL, NULL, 'OS02G0102200 PROTEIN', 247831),
(379100, 'PTHR48017:SF235', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379101, 'PTHR48017:SF114', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379102, 'PTHR48017:SF234', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379103, 'PTHR48017:SF113', NULL, NULL, NULL, NULL, 'OS01G0597600 PROTEIN', 247831),
(379104, 'PTHR48017:SF196', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379105, 'PTHR48017:SF36', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER AVT1F-RELATED', 247831),
(379106, 'PTHR48017:SF195', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379107, 'PTHR48017:SF37', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER AVT1B', 247831),
(379108, 'PTHR48017:SF198', NULL, NULL, NULL, NULL, 'ACID CARRIER, PUTATIVE, EXPRESSED-RELATED', 247831),
(379109, 'PTHR48017:SF231', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379110, 'PTHR48017:SF38', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379111, 'PTHR48017:SF197', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379112, 'PTHR48017:SF230', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER AVT1I', 247831),
(379113, 'PTHR48017:SF32', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379114, 'PTHR48017:SF34', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379115, 'PTHR48017:SF119', NULL, NULL, NULL, NULL, 'GABA TRANSPORTER 1', 247831),
(379116, 'PTHR48017:SF105', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER, TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN-RELATED', 247831),
(379117, 'PTHR48017:SF226', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 247831),
(379118, 'PTHR48017:SF225', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379119, 'PTHR48017:SF228', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER, TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN-RELATED', 247831),
(379120, 'PTHR48017:SF107', NULL, NULL, NULL, NULL, 'AUXIN TRANSPORTER-LIKE PROTEIN 2-RELATED', 247831),
(379121, 'PTHR48017:SF106', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER, TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN-RELATED', 247831),
(379122, 'PTHR48017:SF20', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE 3-LIKE', 247831),
(379123, 'PTHR48017:SF227', NULL, NULL, NULL, NULL, 'AUXIN TRANSPORTER-LIKE PROTEIN 1', 247831),
(379124, 'PTHR48017:SF189', NULL, NULL, NULL, NULL, 'OS06G0228500 PROTEIN', 247831),
(379125, 'PTHR48017:SF101', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE 2', 247831),
(379126, 'PTHR48017:SF222', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379127, 'PTHR48017:SF221', NULL, NULL, NULL, NULL, 'LYSINE HISTIDINE TRANSPORTER 2', 247831),
(379128, 'PTHR48017:SF224', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379129, 'PTHR48017:SF102', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379130, 'PTHR48017:SF223', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE 2', 247831),
(379131, 'PTHR48017:SF185', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379132, 'PTHR48017:SF25', NULL, NULL, NULL, NULL, 'BNACNNG40740D PROTEIN', 247831),
(379133, 'PTHR48017:SF26', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER, TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN-RELATED', 247831),
(379134, 'PTHR48017:SF220', NULL, NULL, NULL, NULL, 'VACUOLAR AMINO ACID TRANSPORTER 1-LIKE', 247831),
(379135, 'PTHR48017:SF186', NULL, NULL, NULL, NULL, 'OS01G0878400 PROTEIN', 247831),
(379136, 'PTHR48017:SF28', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379137, 'PTHR48017:SF21', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER AVT1E', 247831);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(379138, 'PTHR48017:SF181', NULL, NULL, NULL, NULL, 'LYSINE HISTIDINE TRANSPORTER-LIKE 5', 247831),
(379139, 'PTHR48017:SF23', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379140, 'PTHR48017:SF24', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379141, 'PTHR48017:SF109', NULL, NULL, NULL, NULL, 'OS04G0460300 PROTEIN', 247831),
(379142, 'PTHR48017:SF229', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER, TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN-RELATED', 247831),
(379143, 'PTHR48017:SF108', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379144, 'PTHR48017:SF138', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379145, 'PTHR48017:SF94', NULL, NULL, NULL, NULL, 'OS01G0882800 PROTEIN', 247831),
(379146, 'PTHR48017:SF95', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379147, 'PTHR48017:SF137', NULL, NULL, NULL, NULL, 'ACID TRANSPORTER, PUTATIVE, EXPRESSED-RELATED', 247831),
(379148, 'PTHR48017:SF96', NULL, NULL, NULL, NULL, 'OS06G0228800 PROTEIN', 247831),
(379149, 'PTHR48017:SF97', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379150, 'PTHR48017:SF134', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379151, 'PTHR48017:SF90', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379152, 'PTHR48017:SF91', NULL, NULL, NULL, NULL, 'VESICULAR INHIBITORY AMINO ACID TRANSPORTER', 247831),
(379153, 'PTHR48017:SF133', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379154, 'PTHR48017:SF92', NULL, NULL, NULL, NULL, 'LYSINE HISTIDINE TRANSPORTER 1-LIKE', 247831),
(379155, 'PTHR48017:SF136', NULL, NULL, NULL, NULL, 'OS05G0586500 PROTEIN', 247831),
(379156, 'PTHR48017:SF93', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE 2', 247831),
(379157, 'PTHR48017:SF14', NULL, NULL, NULL, NULL, 'PROLINE TRANSPORTER 3-LIKE ISOFORM X1', 247831),
(379158, 'PTHR48017:SF15', NULL, NULL, NULL, NULL, 'LYSINE HISTIDINE TRANSPORTER-LIKE 2', 247831),
(379159, 'PTHR48017:SF16', NULL, NULL, NULL, NULL, 'LYSINE HISTIDINE TRANSPORTER-LIKE 6', 247831),
(379160, 'PTHR48017:SF131', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379161, 'PTHR48017:SF17', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER, TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN-RELATED', 247831),
(379162, 'PTHR48017:SF10', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379163, 'PTHR48017:SF99', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER, TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN-RELATED', 247831),
(379164, 'PTHR48017:SF12', NULL, NULL, NULL, NULL, 'LYSINE HISTIDINE TRANSPORTER 2', 247831),
(379165, 'PTHR48017:SF13', NULL, NULL, NULL, NULL, 'AUXIN TRANSPORTER PROTEIN 1', 247831),
(379166, 'PTHR48017:SF127', NULL, NULL, NULL, NULL, 'AUXIN TRANSPORTER-LIKE PROTEIN 3', 247831),
(379167, 'PTHR48017:SF84', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE 7-RELATED', 247831),
(379168, 'PTHR48017:SF126', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AMINO ACID TRANSPORTER FAMILY PROTEIN-RELATED', 247831),
(379169, 'PTHR48017:SF85', NULL, NULL, NULL, NULL, 'OS02G0101000 PROTEIN', 247831),
(379170, 'PTHR48017:SF128', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379171, 'PTHR48017:SF123', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE 2', 247831),
(379172, 'PTHR48017:SF244', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AMINO ACID TRANSPORTER FAMILY PROTEIN-RELATED', 247831),
(379173, 'PTHR48017:SF122', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379174, 'PTHR48017:SF243', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379175, 'PTHR48017:SF125', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379176, 'PTHR48017:SF124', NULL, NULL, NULL, NULL, 'LYSINE HISTIDINE TRANSPORTER-LIKE 8', 247831),
(379177, 'PTHR48017:SF245', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER AVT1C', 247831),
(379178, 'PTHR48017:SF82', NULL, NULL, NULL, NULL, 'LYSINE HISTIDINE TRANSPORTER 2-LIKE', 247831);
INSERT INTO "PUBLIC"."MODEL" VALUES
(379179, 'PTHR48017:SF240', NULL, NULL, NULL, NULL, 'VACUOLAR AMINO ACID TRANSPORTER 1-LIKE ISOFORM X1', 247831),
(379180, 'PTHR48017:SF242', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379181, 'PTHR48017:SF241', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE 7 ISOFORM X1-RELATED', 247831),
(379182, 'PTHR48017:SF87', NULL, NULL, NULL, NULL, 'PROLINE TRANSPORTER 3', 247831),
(379183, 'PTHR48017:SF89', NULL, NULL, NULL, NULL, 'LYSINE HISTIDINE TRANSPORTER 2', 247831),
(379184, 'PTHR48017:SF72', NULL, NULL, NULL, NULL, 'OS06G0228600 PROTEIN', 247831),
(379185, 'PTHR48017:SF73', NULL, NULL, NULL, NULL, 'PROLINE TRANSPORTER 2-LIKE ISOFORM X1', 247831),
(379186, 'PTHR48017:SF75', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AMINO ACID TRANSPORTER FAMILY PROTEIN', 247831),
(379187, 'PTHR48017:SF156', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379188, 'PTHR48017:SF155', NULL, NULL, NULL, NULL, 'BNAA03G56630D PROTEIN', 247831),
(379189, 'PTHR48017:SF158', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379190, 'PTHR48017:SF70', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379191, 'PTHR48017:SF71', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379192, 'PTHR48017:SF157', NULL, NULL, NULL, NULL, 'AND HISTIDINE SPECIFIC TRANSPORTER, PUTATIVE, EXPRESSED-RELATED', 247831),
(379193, 'PTHR48017:SF151', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379194, 'PTHR48017:SF153', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE 2', 247831),
(379195, 'PTHR48017:SF77', NULL, NULL, NULL, NULL, 'LYSINE HISTIDINE TRANSPORTER-LIKE 7', 247831),
(379196, 'PTHR48017:SF78', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE 8', 247831),
(379197, 'PTHR48017:SF79', NULL, NULL, NULL, NULL, 'LYSINE HISTIDINE TRANSPORTER 1', 247831),
(379198, 'PTHR48017:SF1', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE 7-RELATED', 247831),
(379199, 'PTHR48017:SF61', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379200, 'PTHR48017:SF148', NULL, NULL, NULL, NULL, 'PROLINE TRANSPORTER 1', 247831),
(379201, 'PTHR48017:SF62', NULL, NULL, NULL, NULL, 'AUXIN TRANSPORTER-LIKE PROTEIN 1', 247831),
(379202, 'PTHR48017:SF63', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379203, 'PTHR48017:SF3', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379204, 'PTHR48017:SF64', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE 3', 247831),
(379205, 'PTHR48017:SF4', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379206, 'PTHR48017:SF145', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE 7-RELATED', 247831),
(379207, 'PTHR48017:SF5', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379208, 'PTHR48017:SF6', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE 4', 247831),
(379209, 'PTHR48017:SF144', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379210, 'PTHR48017:SF60', NULL, NULL, NULL, NULL, 'GABA TRANSPORTER 2 ISOFORM X1-RELATED', 247831),
(379211, 'PTHR48017:SF146', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER, TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN-RELATED', 247831),
(379212, 'PTHR48017:SF69', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER, TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN-RELATED', 247831),
(379213, 'PTHR48017:SF141', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE 5', 247831),
(379214, 'PTHR48017:SF140', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE 6', 247831),
(379215, 'PTHR48017:SF143', NULL, NULL, NULL, NULL, 'OS06G0556000 PROTEIN', 247831),
(379216, 'PTHR48017:SF65', NULL, NULL, NULL, NULL, 'AUXIN TRANSPORTER-LIKE PROTEIN 2', 247831),
(379217, 'PTHR48017:SF66', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 247831),
(379218, 'PTHR48017:SF67', NULL, NULL, NULL, NULL, 'LYSINE HISTIDINE TRANSPORTER 1-LIKE', 247831),
(379219, 'PTHR48017', NULL, NULL, NULL, NULL, 'OS05G0424000 PROTEIN-RELATED', 247831),
(379220, 'PTHR48017:SF9', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER, TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN-RELATED', 247831);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(379221, 'PTHR46189:SF3', NULL, NULL, NULL, NULL, 'WD REPEAT AND FYVE DOMAIN-CONTAINING PROTEIN 2', 247832),
(379222, 'PTHR46189', NULL, NULL, NULL, NULL, 'LD41958P', 247832),
(379223, 'PTHR46189:SF1', NULL, NULL, NULL, NULL, 'LD41958P', 247832),
(379224, 'PTHR46189:SF2', NULL, NULL, NULL, NULL, 'WD REPEAT AND FYVE DOMAIN-CONTAINING PROTEIN 1', 247832),
(379225, 'PTHR21505', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247833),
(379226, 'PTHR21505:SF11', NULL, NULL, NULL, NULL, 'MADF DOMAIN-CONTAINING PROTEIN-RELATED', 247833),
(379227, 'PTHR21505:SF12', NULL, NULL, NULL, NULL, 'RE18252P', 247833),
(379228, 'PTHR21505:SF9', NULL, NULL, NULL, NULL, 'MADF DOMAIN-CONTAINING PROTEIN', 247833),
(379229, 'PTHR21505:SF8', NULL, NULL, NULL, NULL, 'FI09734P-RELATED', 247833),
(379230, 'PTHR11086:SF22', NULL, NULL, NULL, NULL, 'TRNA-SPECIFIC ADENOSINE DEAMINASE', 247834),
(379231, 'PTHR11086:SF18', NULL, NULL, NULL, NULL, 'DEOXYCYTIDYLATE DEAMINASE', 247834),
(379232, 'PTHR11086', NULL, NULL, NULL, NULL, 'DEOXYCYTIDYLATE DEAMINASE-RELATED', 247834),
(379233, 'PTHR11086:SF14', NULL, NULL, NULL, NULL, 'CYTIDINE AND DCMP DEAMINASE DOMAIN-CONTAINING PROTEIN 1', 247834),
(379234, 'PTHR46218:SF4', NULL, NULL, NULL, NULL, 'LIM AND SH3 DOMAIN PROTEIN LASP', 247835),
(379235, 'PTHR46218', NULL, NULL, NULL, NULL, 'LASP', 247835),
(379236, 'PTHR46218:SF2', NULL, NULL, NULL, NULL, 'LIM AND SH3 DOMAIN PROTEIN 1', 247835),
(379237, 'PTHR46218:SF3', NULL, NULL, NULL, NULL, 'NEBULETTE', 247835),
(379238, 'PTHR11835:SF62', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NAD] REGULATORY SUBUNIT 1, MITOCHONDRIAL-LIKE', 247836),
(379239, 'PTHR11835:SF61', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NAD] CATALYTIC SUBUNIT 6, MITOCHONDRIAL', 247836),
(379240, 'PTHR11835:SF64', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NAD] REGULATORY SUBUNIT 1, MITOCHONDRIAL-LIKE', 247836),
(379241, 'PTHR11835:SF42', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NAD] SUBUNIT BETA, MITOCHONDRIAL', 247836),
(379242, 'PTHR11835:SF74', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NAD] SUBUNIT, MITOCHONDRIAL', 247836),
(379243, 'PTHR11835:SF63', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NAD] REGULATORY SUBUNIT 3, MITOCHONDRIAL', 247836),
(379244, 'PTHR11835:SF60', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NAD] SUBUNIT GAMMA, MITOCHONDRIAL', 247836),
(379245, 'PTHR11835:SF71', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NAD] SUBUNIT, MITOCHONDRIAL', 247836),
(379246, 'PTHR11835:SF48', NULL, NULL, NULL, NULL, 'HOMOISOCITRATE DEHYDROGENASE, MITOCHONDRIAL', 247836),
(379247, 'PTHR11835:SF58', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NAD] SUBUNIT GAMMA 1, MITOCHONDRIAL', 247836),
(379248, 'PTHR11835', NULL, NULL, NULL, NULL, 'DECARBOXYLATING DEHYDROGENASES-ISOCITRATE, ISOPROPYLMALATE, TARTRATE', 247836),
(379249, 'PTHR11835:SF69', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NAD] REGULATORY SUBUNIT 2, MITOCHONDRIAL', 247836),
(379250, 'PTHR11835:SF77', NULL, NULL, NULL, NULL, 'ISOCITRATE/ISOPROPYLMALATE DEHYDROGENASE FAMILY PROTEIN', 247836),
(379251, 'PTHR11835:SF76', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NAD] SUBUNIT, MITOCHONDRIAL', 247836),
(379252, 'PTHR11835:SF43', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE (NADP(+))', 247836),
(379253, 'PTHR11835:SF54', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NAD] GAMMA 2, MITOCHONDRIAL-RELATED', 247836),
(379254, 'PTHR11835:SF68', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NAD] SUBUNIT, MITOCHONDRIAL', 247836),
(379255, 'PTHR11835:SF34', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NAD] SUBUNIT ALPHA, MITOCHONDRIAL', 247836),
(379256, 'PTHR11835:SF56', NULL, NULL, NULL, NULL, 'NAD-DEPENDENT ISOCITRATE DEHYDROGENASE C1', 247836),
(379257, 'PTHR32133:SF339', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379258, 'PTHR32133:SF379', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379259, 'PTHR32133:SF258', NULL, NULL, NULL, NULL, '', 247837),
(379260, 'PTHR32133:SF335', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(379261, 'PTHR32133:SF377', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN', 247837),
(379262, 'PTHR32133:SF378', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', 247837),
(379263, 'PTHR32133:SF257', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379264, 'PTHR32133:SF375', NULL, NULL, NULL, NULL, 'OS07G0120400 PROTEIN', 247837),
(379265, 'PTHR32133:SF134', NULL, NULL, NULL, NULL, 'OS05G0320100 PROTEIN', 247837),
(379266, 'PTHR32133:SF376', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379267, 'PTHR32133:SF373', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379268, 'PTHR32133:SF374', NULL, NULL, NULL, NULL, '', 247837),
(379269, 'PTHR32133:SF297', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379270, 'PTHR32133:SF371', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379271, 'PTHR32133:SF251', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379272, 'PTHR32133:SF372', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379273, 'PTHR32133:SF370', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379274, 'PTHR32133:SF293', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', 247837),
(379275, 'PTHR32133', NULL, NULL, NULL, NULL, 'OS07G0120400 PROTEIN', 247837),
(379276, 'PTHR32133:SF291', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379277, 'PTHR32133:SF328', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379278, 'PTHR32133:SF327', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379279, 'PTHR32133:SF368', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379280, 'PTHR32133:SF369', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379281, 'PTHR32133:SF322', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379282, 'PTHR32133:SF366', NULL, NULL, NULL, NULL, 'OS07G0122900 PROTEIN', 247837),
(379283, 'PTHR32133:SF367', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379284, 'PTHR32133:SF320', NULL, NULL, NULL, NULL, 'FBA_1 DOMAIN-CONTAINING PROTEIN', 247837),
(379285, 'PTHR32133:SF364', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379286, 'PTHR32133:SF321', NULL, NULL, NULL, NULL, '', 247837),
(379287, 'PTHR32133:SF365', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379288, 'PTHR32133:SF362', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379289, 'PTHR32133:SF285', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379290, 'PTHR32133:SF363', NULL, NULL, NULL, NULL, '', 247837),
(379291, 'PTHR32133:SF360', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379292, 'PTHR32133:SF283', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379293, 'PTHR32133:SF361', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379294, 'PTHR32133:SF280', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379295, 'PTHR32133:SF317', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379296, 'PTHR32133:SF318', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379297, 'PTHR32133:SF315', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379298, 'PTHR32133:SF359', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379299, 'PTHR32133:SF357', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379300, 'PTHR32133:SF314', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379301, 'PTHR32133:SF358', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379302, 'PTHR32133:SF312', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379303, 'PTHR32133:SF279', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379304, 'PTHR32133:SF356', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(379305, 'PTHR32133:SF276', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379306, 'PTHR32133:SF277', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379307, 'PTHR32133:SF352', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379308, 'PTHR32133:SF275', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379309, 'PTHR32133:SF350', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379310, 'PTHR32133:SF273', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379311, 'PTHR32133:SF271', NULL, NULL, NULL, NULL, 'OS10G0144800 PROTEIN', 247837),
(379312, 'PTHR32133:SF308', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379313, 'PTHR32133:SF309', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379314, 'PTHR32133:SF306', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379315, 'PTHR32133:SF307', NULL, NULL, NULL, NULL, 'OS08G0299600 PROTEIN', 247837),
(379316, 'PTHR32133:SF348', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379317, 'PTHR32133:SF305', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379318, 'PTHR32133:SF269', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379319, 'PTHR32133:SF302', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', 247837),
(379320, 'PTHR32133:SF303', NULL, NULL, NULL, NULL, '', 247837),
(379321, 'PTHR32133:SF301', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379322, 'PTHR32133:SF268', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379323, 'PTHR32133:SF266', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379324, 'PTHR32133:SF343', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379325, 'PTHR32133:SF340', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379326, 'PTHR32133:SF263', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379327, 'PTHR32133:SF261', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379328, 'PTHR32133:SF380', NULL, NULL, NULL, NULL, 'OS10G0137700 PROTEIN', 247837),
(379329, 'PTHR32133:SF260', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379330, 'PTHR32133:SF381', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247837),
(379331, 'PTHR12101:SF15', NULL, NULL, NULL, NULL, 'POPEYE DOMAIN-CONTAINING PROTEIN 2', 247838),
(379332, 'PTHR12101:SF1', NULL, NULL, NULL, NULL, 'BVES', 247838),
(379333, 'PTHR12101:SF18', NULL, NULL, NULL, NULL, 'POPEYE DOMAIN-CONTAINING PROTEIN 3', 247838),
(379334, 'PTHR12101:SF17', NULL, NULL, NULL, NULL, 'BLOOD VESSEL EPICARDIAL SUBSTANCE', 247838),
(379335, 'PTHR12101:SF30', NULL, NULL, NULL, NULL, 'POPEYE DOMAIN-CONTAINING PROTEIN 3-LIKE PROTEIN', 247838),
(379336, 'PTHR12101', NULL, NULL, NULL, NULL, 'POPEYE DOMAIN CONTAINING PROTEIN', 247838),
(379337, 'PTHR22639:SF5', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 247839),
(379338, 'PTHR22639', NULL, NULL, NULL, NULL, 'GAG-RELATED PROTEIN', 247839),
(379339, 'PTHR22639:SF4', NULL, NULL, NULL, NULL, 'ZINC FINGER CCHC DOMAIN-CONTAINING PROTEIN 3', 247839),
(379340, 'PTHR22639:SF3', NULL, NULL, NULL, NULL, '', 247839),
(379341, 'PTHR10571:SF0', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE--DOLICHYL-PHOSPHATE N-ACETYLGLUCOSAMINEPHOSPHOTRANSFERASE', 247840),
(379342, 'PTHR10571:SF2', NULL, NULL, NULL, NULL, 'GLCNAC-1-P TRANSFERASE', 247840),
(379343, 'PTHR10571', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE--DOLICHYL-PHOSPHATE N-ACETYLGLUCOSAMINEPHOSPHOTRANSFERASE', 247840),
(379344, 'PTHR10571:SF1', NULL, NULL, NULL, NULL, 'GLCNAC-1-P TRANSFERASE', 247840),
(379345, 'PTHR46090:SF1', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 13A', 247841),
(379346, 'PTHR46090:SF2', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 13B', 247841),
(379347, 'PTHR46090:SF3', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 13B', 247841);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(379348, 'PTHR46090', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 13B', 247841),
(379349, 'PTHR10033:SF14', NULL, NULL, NULL, NULL, 'CALSEQUESTRIN-1', 247842),
(379350, 'PTHR10033:SF15', NULL, NULL, NULL, NULL, 'CALSEQUESTRIN-2', 247842),
(379351, 'PTHR10033:SF0', NULL, NULL, NULL, NULL, 'CALSEQUESTRIN', 247842),
(379352, 'PTHR10033', NULL, NULL, NULL, NULL, 'CALSEQUESTRIN', 247842),
(379353, 'PTHR17204:SF28', NULL, NULL, NULL, NULL, '', 247843),
(379354, 'PTHR17204:SF31', NULL, NULL, NULL, NULL, 'BNAA08G27700D PROTEIN', 247843),
(379355, 'PTHR17204:SF21', NULL, NULL, NULL, NULL, 'PRE-MRNA-PROCESSING FACTOR 39', 247843),
(379356, 'PTHR17204:SF24', NULL, NULL, NULL, NULL, 'SI:CH211-114C17.1', 247843),
(379357, 'PTHR17204:SF23', NULL, NULL, NULL, NULL, 'U1 SMALL NUCLEAR RIBONUCLEOPROTEIN COMPONENT PRP42', 247843),
(379358, 'PTHR17204:SF5', NULL, NULL, NULL, NULL, 'PRE-MRNA-PROCESSING FACTOR 39', 247843),
(379359, 'PTHR17204', NULL, NULL, NULL, NULL, 'PRE-MRNA PROCESSING PROTEIN PRP39-RELATED', 247843),
(379360, 'PTHR17204:SF26', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 247843),
(379361, 'PTHR17204:SF25', NULL, NULL, NULL, NULL, 'EMBRYO DEFECTIVE 140', 247843),
(379362, 'PTHR47056:SF1', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 39', 247844),
(379363, 'PTHR47056', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 39', 247844),
(379364, 'PTHR40101:SF1', NULL, NULL, NULL, NULL, '4FE-4S DOMAIN-CONTAINING PROTEIN', 247845),
(379365, 'PTHR40101', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', 247845),
(379366, 'PTHR46611:SF7', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN', 247846),
(379367, 'PTHR46611:SF8', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN', 247846),
(379368, 'PTHR46611:SF5', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN', 247846),
(379369, 'PTHR46611:SF6', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 247846),
(379370, 'PTHR46611:SF3', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN', 247846),
(379371, 'PTHR46611:SF4', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN-RELATED', 247846),
(379372, 'PTHR46611:SF1', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN', 247846),
(379373, 'PTHR46611:SF2', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN', 247846),
(379374, 'PTHR46611', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS X-RELATED', 247846),
(379375, 'PTHR40841:SF2', NULL, NULL, NULL, NULL, 'SIDEROPHORE-DEGRADING ESTERASE (EUROFUNG)-RELATED', 247847),
(379376, 'PTHR40841', NULL, NULL, NULL, NULL, 'SIDEROPHORE TRIACETYLFUSARININE C ESTERASE', 247847),
(379377, 'PTHR24254:SF11', NULL, NULL, NULL, NULL, '', 247848),
(379378, 'PTHR24254:SF12', NULL, NULL, NULL, NULL, '', 247848),
(379379, 'PTHR24254:SF10', NULL, NULL, NULL, NULL, 'PROTHROMBIN', 247848),
(379380, 'PTHR24254:SF6', NULL, NULL, NULL, NULL, 'CUBILIN', 247848),
(379381, 'PTHR24254:SF9', NULL, NULL, NULL, NULL, 'INACTIVE SERINE PROTEASE PAMR1', 247848),
(379382, 'PTHR24254', NULL, NULL, NULL, NULL, 'PROTHROMBIN', 247848),
(379383, 'PTHR47229', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 141', 247849),
(379384, 'PTHR47229:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 141', 247849),
(379385, 'PTHR11106:SF27', NULL, NULL, NULL, NULL, 'MACRO DOMAIN-CONTAINING PROTEIN', 247850),
(379386, 'PTHR11106:SF114', NULL, NULL, NULL, NULL, 'PROTEIN GDAP2 HOMOLOG', 247850),
(379387, 'PTHR11106:SF103', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 247850),
(379388, 'PTHR11106:SF104', NULL, NULL, NULL, NULL, 'ADP-RIBOSE GLYCOHYDROLASE MACROD2', 247850),
(379389, 'PTHR11106:SF98', NULL, NULL, NULL, NULL, 'OS01G0948300 PROTEIN', 247850),
(379390, 'PTHR11106:SF96', NULL, NULL, NULL, NULL, 'MACRO DOMAIN-CONTAINING PROTEIN VPA0103-LIKE ISOFORM X1', 247850),
(379391, 'PTHR11106:SF118', NULL, NULL, NULL, NULL, 'OS04G0561200 PROTEIN', 247850),
(379392, 'PTHR11106:SF108', NULL, NULL, NULL, NULL, 'MACRO DOMAIN-CONTAINING PROTEIN', 247850);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(379393, 'PTHR11106:SF119', NULL, NULL, NULL, NULL, 'APPR-1-P PROCESSING ENZYME FAMILY PROTEIN', 247850),
(379394, 'PTHR11106:SF72', NULL, NULL, NULL, NULL, 'GANGLIOSIDE-INDUCED DIFFERENTIATION-ASSOCIATED PROTEIN 2', 247850),
(379395, 'PTHR11106:SF93', NULL, NULL, NULL, NULL, 'ADP-RIBOSE GLYCOHYDROLASE MACROD1', 247850),
(379396, 'PTHR11106', NULL, NULL, NULL, NULL, 'GANGLIOSIDE INDUCED DIFFERENTIATION ASSOCIATED PROTEIN 2-RELATED', 247850),
(379397, 'PTHR11106:SF111', NULL, NULL, NULL, NULL, 'MACRO DOMAIN-CONTAINING PROTEIN', 247850),
(379398, 'PTHR17985:SF16', NULL, NULL, NULL, NULL, 'TRANSPORT/GOLGI ORGANIZATION-LIKE PROTEIN (DUF833)', 247851),
(379399, 'PTHR17985:SF8', NULL, NULL, NULL, NULL, 'TRANSPORT AND GOLGI ORGANIZATION PROTEIN 2 HOMOLOG', 247851),
(379400, 'PTHR17985:SF22', NULL, NULL, NULL, NULL, 'OS04G0564500 PROTEIN', 247851),
(379401, 'PTHR17985:SF23', NULL, NULL, NULL, NULL, 'BNAANNG03270D PROTEIN', 247851),
(379402, 'PTHR17985', NULL, NULL, NULL, NULL, 'SER/THR-RICH PROTEIN T10 IN DGCR REGION', 247851),
(379403, 'PTHR17985:SF24', NULL, NULL, NULL, NULL, 'PROTEIN CBG23817', 247851),
(379404, 'PTHR43780:SF8', NULL, NULL, NULL, NULL, 'PALP DOMAIN-CONTAINING PROTEIN', 247852),
(379405, 'PTHR43780:SF7', NULL, NULL, NULL, NULL, 'D-CYSTEINE DESULFHYDRASE 2, MITOCHONDRIAL', 247852),
(379406, 'PTHR43780', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE DEAMINASE-RELATED', 247852),
(379407, 'PTHR43780:SF2', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE DEAMINASE-RELATED', 247852),
(379408, 'PTHR31778:SF2', NULL, NULL, NULL, NULL, 'BUD SITE SELECTION PROTEIN RAX2', 247853),
(379409, 'PTHR31778', NULL, NULL, NULL, NULL, 'BUD SITE SELECTION PROTEIN RAX2', 247853),
(379410, 'PTHR46031:SF33', NULL, NULL, NULL, NULL, 'DSRNA-BINDING PROTEIN 5-RELATED', 247854),
(379411, 'PTHR46031:SF10', NULL, NULL, NULL, NULL, 'DOUBLE-STRANDED RNA-BINDING PROTEIN 5', 247854),
(379412, 'PTHR46031:SF32', NULL, NULL, NULL, NULL, 'DOUBLE-STRANDED RNA-BINDING MOTIF PROTEIN', 247854),
(379413, 'PTHR46031:SF20', NULL, NULL, NULL, NULL, 'BNAC04G15870D PROTEIN', 247854),
(379414, 'PTHR46031:SF31', NULL, NULL, NULL, NULL, 'DRBM DOMAIN-CONTAINING PROTEIN', 247854),
(379415, 'PTHR46031:SF30', NULL, NULL, NULL, NULL, 'DOUBLE-STRANDED RNA-BINDING PROTEIN 3', 247854),
(379416, 'PTHR46031:SF7', NULL, NULL, NULL, NULL, 'DOUBLE-STRANDED RNA-BINDING PROTEIN 2-LIKE', 247854),
(379417, 'PTHR46031', NULL, NULL, NULL, NULL, '', 247854),
(379418, 'PTHR46031:SF2', NULL, NULL, NULL, NULL, 'DOUBLE-STRANDED RNA-BINDING PROTEIN 2', 247854),
(379419, 'PTHR46031:SF26', NULL, NULL, NULL, NULL, 'DOUBLE-STRANDED RNA-BINDING PROTEIN 2', 247854),
(379420, 'PTHR46031:SF15', NULL, NULL, NULL, NULL, 'DOUBLE-STRANDED RNA-BINDING PROTEIN 3', 247854),
(379421, 'PTHR46031:SF36', NULL, NULL, NULL, NULL, 'DOUBLE-STRANDED RNA-BINDING PROTEIN 1', 247854),
(379422, 'PTHR46031:SF24', NULL, NULL, NULL, NULL, 'BNAA09G24500D PROTEIN', 247854),
(379423, 'PTHR46031:SF35', NULL, NULL, NULL, NULL, 'BCPLH PROTEIN', 247854),
(379424, 'PTHR46031:SF34', NULL, NULL, NULL, NULL, 'DRBM DOMAIN-CONTAINING PROTEIN', 247854),
(379425, 'PTHR46031:SF29', NULL, NULL, NULL, NULL, 'DOUBLE-STRANDED RNA-BINDING PROTEIN 2 ISOFORM X1', 247854),
(379426, 'PTHR46031:SF28', NULL, NULL, NULL, NULL, 'DOUBLE-STRANDED RNA-BINDING PROTEIN 2-LIKE', 247854),
(379427, 'PTHR46031:SF16', NULL, NULL, NULL, NULL, 'DOUBLE-STRANDED RNA-BINDING PROTEIN 4', 247854),
(379428, 'PTHR47662:SF4', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 247855),
(379429, 'PTHR47662:SF5', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL56-LIKE', 247855),
(379430, 'PTHR47662:SF2', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL57-LIKE', 247855),
(379431, 'PTHR47662:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C2H2 FAMILY-RELATED', 247855),
(379432, 'PTHR47662', NULL, NULL, NULL, NULL, '', 247855),
(379433, 'PTHR47662:SF1', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 247855),
(379434, 'PTHR14593', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 11', 247856);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(379435, 'PTHR14593:SF6', NULL, NULL, NULL, NULL, 'TRANSDUCIN FAMILY PROTEIN / WD-40 REPEAT FAMILY PROTEIN', 247856),
(379436, 'PTHR14593:SF5', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 11', 247856),
(379437, 'PTHR14593:SF7', NULL, NULL, NULL, NULL, 'WD40/YVTN REPEAT-LIKE-CONTAINING DOMAIN-CONTAINING PROTEIN-RELATED', 247856),
(379438, 'PTHR35845', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED SERINE-RICH PROTEIN 1', 247857),
(379439, 'PTHR35845:SF1', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED SERINE-RICH PROTEIN 1', 247857),
(379440, 'PTHR31716', NULL, NULL, NULL, NULL, 'PROTEIN FMC1 HOMOLOG', 247858),
(379441, 'PTHR31716:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FMC1 HOMOLOG', 247858),
(379442, 'PTHR12395:SF24', NULL, NULL, NULL, NULL, 'DECAPPING NUCLEASE', 247859),
(379443, 'PTHR12395:SF12', NULL, NULL, NULL, NULL, 'DECAPPING NUCLEASE', 247859),
(379444, 'PTHR12395:SF26', NULL, NULL, NULL, NULL, 'DECAPPING NUCLEASE', 247859),
(379445, 'PTHR12395:SF25', NULL, NULL, NULL, NULL, 'DECAPPING AND EXORIBONUCLEASE PROTEIN 1', 247859),
(379446, 'PTHR12395:SF14', NULL, NULL, NULL, NULL, 'DECAPPING NUCLEASE', 247859),
(379447, 'PTHR12395', NULL, NULL, NULL, NULL, 'DOM-3 RELATED', 247859),
(379448, 'PTHR12395:SF9', NULL, NULL, NULL, NULL, 'DECAPPING AND EXORIBONUCLEASE PROTEIN', 247859),
(379449, 'PTHR34002:SF11', NULL, NULL, NULL, NULL, '', 247860),
(379450, 'PTHR34002:SF10', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 247860),
(379451, 'PTHR34002', NULL, NULL, NULL, NULL, 'BLR1656 PROTEIN', 247860),
(379452, 'PTHR34002:SF9', NULL, NULL, NULL, NULL, 'XYLOGLUCAN-SPECIFIC ENDO-BETA-1,4-GLUCANASE A', 247860),
(379453, 'PTHR42848', NULL, NULL, NULL, NULL, '', 247861),
(379454, 'PTHR42848:SF1', NULL, NULL, NULL, NULL, 'HOLLIDAY JUNCTION ATP-DEPENDENT DNA HELICASE RUVB', 247861),
(379455, 'PTHR12022:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 7', 247862),
(379456, 'PTHR12022:SF3', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 7-1, MITOCHONDRIAL', 247862),
(379457, 'PTHR12022:SF12', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 7', 247862),
(379458, 'PTHR12022:SF0', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 7', 247862),
(379459, 'PTHR12022:SF1', NULL, NULL, NULL, NULL, 'COMPLEX III SUBUNIT VII', 247862),
(379460, 'PTHR12022:SF7', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 7', 247862),
(379461, 'PTHR12022:SF4', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 7', 247862),
(379462, 'PTHR12022', NULL, NULL, NULL, NULL, 'UBIQUINOL-CYTOCHROME C REDUCTASE COMPLEX 14 KD PROTEIN', 247862),
(379463, 'PTHR12022:SF8', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 7', 247862),
(379464, 'PTHR12022:SF9', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 7-2-LIKE ISOFORM X1', 247862),
(379465, 'PTHR43237', NULL, NULL, NULL, NULL, 'NADP-DEPENDENT MALIC ENZYME', 247863),
(379466, 'PTHR43237:SF4', NULL, NULL, NULL, NULL, 'NADP-DEPENDENT MALIC ENZYME', 247863),
(379467, 'PTHR13778:SF70', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247864),
(379468, 'PTHR13778:SF71', NULL, NULL, NULL, NULL, 'GALACTURONOSYLTRANSFERASE-LIKE 5-RELATED', 247864),
(379469, 'PTHR13778:SF43', NULL, NULL, NULL, NULL, 'GALACTURONOSYLTRANSFERASE-LIKE 8-RELATED', 247864),
(379470, 'PTHR13778:SF65', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247864),
(379471, 'PTHR13778:SF66', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247864),
(379472, 'PTHR13778:SF67', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247864),
(379473, 'PTHR13778:SF45', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247864),
(379474, 'PTHR13778:SF68', NULL, NULL, NULL, NULL, 'GALACTURONOSYLTRANSFERASE-LIKE 6-RELATED', 247864),
(379475, 'PTHR13778:SF61', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247864),
(379476, 'PTHR13778', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE 8 DOMAIN-CONTAINING PROTEIN', 247864),
(379477, 'PTHR13778:SF62', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247864),
(379478, 'PTHR13778:SF40', NULL, NULL, NULL, NULL, 'GALACTURONOSYLTRANSFERASE-LIKE 9-RELATED', 247864);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(379479, 'PTHR13778:SF63', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247864),
(379480, 'PTHR13778:SF42', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247864),
(379481, 'PTHR13778:SF64', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE 1,2-GLUCOSYLTRANSFERASE', 247864),
(379482, 'PTHR13778:SF69', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247864),
(379483, 'PTHR13778:SF47', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE 1,3-GALACTOSYLTRANSFERASE', 247864),
(379484, 'PTHR13778:SF48', NULL, NULL, NULL, NULL, 'GALACTURONOSYLTRANSFERASE-LIKE 7-RELATED', 247864),
(379485, 'PTHR13778:SF2', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE 8 DOMAIN-CONTAINING PROTEIN 2', 247864),
(379486, 'PTHR13778:SF3', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE 8 DOMAIN-CONTAINING PROTEIN 1', 247864),
(379487, 'PTHR13778:SF54', NULL, NULL, NULL, NULL, 'GALACTURONOSYLTRANSFERASE-LIKE 4-RELATED', 247864),
(379488, 'PTHR13778:SF57', NULL, NULL, NULL, NULL, 'GALACTURONOSYLTRANSFERASE-LIKE 10-RELATED', 247864),
(379489, 'PTHR13778:SF13', NULL, NULL, NULL, NULL, 'GALACTURONOSYLTRANSFERASE-LIKE 3-RELATED', 247864),
(379490, 'PTHR13778:SF50', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247864),
(379491, 'PTHR13778:SF72', NULL, NULL, NULL, NULL, 'GALACTURONOSYLTRANSFERASE-LIKE 2-RELATED', 247864),
(379492, 'PTHR13778:SF51', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247864),
(379493, 'PTHR13778:SF18', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247864),
(379494, 'PTHR13778:SF58', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247864),
(379495, 'PTHR13778:SF5', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247864),
(379496, 'PTHR13778:SF59', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247864),
(379497, 'PTHR13778:SF16', NULL, NULL, NULL, NULL, 'GALACTURONOSYLTRANSFERASE-LIKE 1-RELATED', 247864),
(379498, 'PTHR13778:SF39', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 247864),
(379499, 'PTHR21190', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247865),
(379500, 'PTHR21190:SF1', NULL, NULL, NULL, NULL, 'GH10077P', 247865),
(379501, 'PTHR36222:SF1', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR RV3364C', 247866),
(379502, 'PTHR36222', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR RV3364C', 247866),
(379503, 'PTHR35303:SF8', NULL, NULL, NULL, NULL, 'GBBH-LIKE_N DOMAIN-CONTAINING PROTEIN', 247867),
(379504, 'PTHR35303:SF7', NULL, NULL, NULL, NULL, 'GBBH-LIKE_N DOMAIN-CONTAINING PROTEIN', 247867),
(379505, 'PTHR35303:SF5', NULL, NULL, NULL, NULL, 'OS02G0197800 PROTEIN', 247867),
(379506, 'PTHR35303', NULL, NULL, NULL, NULL, 'OS02G0197800 PROTEIN', 247867),
(379507, 'PTHR12135:SF0', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN COMPLEMENTING XP-C CELLS', 247868),
(379508, 'PTHR12135', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN XP-C / RAD4', 247868),
(379509, 'PTHR12135:SF2', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RAD34', 247868),
(379510, 'PTHR14334:SF2', NULL, NULL, NULL, NULL, 'B-CELL ANTIGEN RECEPTOR COMPLEX-ASSOCIATED PROTEIN BETA CHAIN', 247869),
(379511, 'PTHR14334:SF3', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 247869),
(379512, 'PTHR14334', NULL, NULL, NULL, NULL, 'B-CELL ANTIGEN RECEPTOR COMPLEX-ASSOCIATED PROTEIN', 247869),
(379513, 'PTHR14334:SF1', NULL, NULL, NULL, NULL, 'B-CELL ANTIGEN RECEPTOR COMPLEX-ASSOCIATED PROTEIN ALPHA CHAIN', 247869),
(379514, 'PTHR47145', NULL, NULL, NULL, NULL, 'BPI FOLD-CONTAINING FAMILY A MEMBER 2', 247870),
(379515, 'PTHR47145:SF1', NULL, NULL, NULL, NULL, 'BPI FOLD-CONTAINING FAMILY A MEMBER 2', 247870),
(379516, 'PTHR21845', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE ANCHOR PROTEIN 1', 247871),
(379517, 'PTHR21845:SF2', NULL, NULL, NULL, NULL, 'MATRIX-REMODELING-ASSOCIATED PROTEIN 7', 247871),
(379518, 'PTHR35593', NULL, NULL, NULL, NULL, 'LISH DOMAIN-CONTAINING PROTEIN', 247872),
(379519, 'PTHR35593:SF1', NULL, NULL, NULL, NULL, 'DOMAIN-CONTAINING PROTEIN, PUTATIVE-RELATED', 247872),
(379520, 'PTHR42706:SF4', NULL, NULL, NULL, NULL, 'FORMYLTETRAHYDROFOLATE DEFORMYLASE 1, MITOCHONDRIAL', 247873),
(379521, 'PTHR42706', NULL, NULL, NULL, NULL, 'FORMYLTETRAHYDROFOLATE DEFORMYLASE', 247873);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(379522, 'PTHR42706:SF2', NULL, NULL, NULL, NULL, 'FORMYLTETRAHYDROFOLATE DEFORMYLASE 1, MITOCHONDRIAL-LIKE', 247873),
(379523, 'PTHR42706:SF1', NULL, NULL, NULL, NULL, 'FORMYLTETRAHYDROFOLATE DEFORMYLASE 2, MITOCHONDRIAL', 247873),
(379524, 'PTHR10654:SF21', NULL, NULL, NULL, NULL, 'EMBRYONAL FYN-ASSOCIATED SUBSTRATE', 247874),
(379525, 'PTHR10654', NULL, NULL, NULL, NULL, 'CAS SCAFFOLDING PROTEIN', 247874),
(379526, 'PTHR10654:SF20', NULL, NULL, NULL, NULL, 'ENHANCER OF FILAMENTATION 1', 247874),
(379527, 'PTHR10654:SF18', NULL, NULL, NULL, NULL, 'IP17195P', 247874),
(379528, 'PTHR10654:SF19', NULL, NULL, NULL, NULL, 'CAS SCAFFOLDING PROTEIN FAMILY MEMBER 4', 247874),
(379529, 'PTHR10654:SF14', NULL, NULL, NULL, NULL, 'EMBRYONAL FYN-ASSOCIATED SUBSTRATE', 247874),
(379530, 'PTHR10654:SF15', NULL, NULL, NULL, NULL, 'BREAST CANCER ANTI-ESTROGEN RESISTANCE PROTEIN 1', 247874),
(379531, 'PTHR34397:SF19', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 247875),
(379532, 'PTHR34397:SF27', NULL, NULL, NULL, NULL, '', 247875),
(379533, 'PTHR34397:SF16', NULL, NULL, NULL, NULL, '', 247875),
(379534, 'PTHR34397:SF28', NULL, NULL, NULL, NULL, '', 247875),
(379535, 'PTHR34397:SF17', NULL, NULL, NULL, NULL, 'OS08G0290200 PROTEIN', 247875),
(379536, 'PTHR34397:SF14', NULL, NULL, NULL, NULL, 'OS02G0166300 PROTEIN', 247875),
(379537, 'PTHR34397:SF25', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247875),
(379538, 'PTHR34397:SF26', NULL, NULL, NULL, NULL, 'OS05G0567000 PROTEIN', 247875),
(379539, 'PTHR34397:SF15', NULL, NULL, NULL, NULL, 'OS08G0282100 PROTEIN', 247875),
(379540, 'PTHR34397:SF5', NULL, NULL, NULL, NULL, '', 247875),
(379541, 'PTHR34397:SF12', NULL, NULL, NULL, NULL, 'OS07G0424000 PROTEIN', 247875),
(379542, 'PTHR34397:SF23', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247875),
(379543, 'PTHR34397:SF24', NULL, NULL, NULL, NULL, '', 247875),
(379544, 'PTHR34397:SF13', NULL, NULL, NULL, NULL, '', 247875),
(379545, 'PTHR34397:SF21', NULL, NULL, NULL, NULL, '', 247875),
(379546, 'PTHR34397:SF22', NULL, NULL, NULL, NULL, 'OS05G0237600 PROTEIN', 247875),
(379547, 'PTHR34397', NULL, NULL, NULL, NULL, 'OS05G0237600 PROTEIN', 247875),
(379548, 'PTHR46714:SF8', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 247876),
(379549, 'PTHR46714', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR HAC1', 247876),
(379550, 'PTHR46714:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR HAC1', 247876),
(379551, 'PTHR46714:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR HY5-LIKE', 247876),
(379552, 'PTHR46714:SF4', NULL, NULL, NULL, NULL, 'OS01G0174000 PROTEIN', 247876),
(379553, 'PTHR47710:SF1', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN', 247877),
(379554, 'PTHR47710:SF2', NULL, NULL, NULL, NULL, 'UNIVERSAL STRESS PROTEIN A-LIKE PROTEIN', 247877),
(379555, 'PTHR47710', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN', 247877),
(379556, 'PTHR40062', NULL, NULL, NULL, NULL, 'GTP-SENSING TRANSCRIPTIONAL PLEIOTROPIC REPRESSOR CODY', 247878),
(379557, 'PTHR40062:SF1', NULL, NULL, NULL, NULL, 'GTP-SENSING TRANSCRIPTIONAL PLEIOTROPIC REPRESSOR CODY', 247878),
(379558, 'PTHR21566:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG11549', 247879),
(379559, 'PTHR21566:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG06703', 247879),
(379560, 'PTHR21566', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247879),
(379561, 'PTHR21566:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG11544', 247879),
(379562, 'PTHR21566:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG18525', 247879),
(379563, 'PTHR21566:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG18514', 247879),
(379564, 'PTHR43861:SF1', NULL, NULL, NULL, NULL, 'TRANS-ACONITATE 2-METHYLTRANSFERASE', 247880),
(379565, 'PTHR43861:SF2', NULL, NULL, NULL, NULL, 'CARBOXY-S-ADENOSYL-L-METHIONINE SYNTHASE', 247880),
(379566, 'PTHR43861:SF3', NULL, NULL, NULL, NULL, 'SLR1183 PROTEIN', 247880),
(379567, 'PTHR43861:SF4', NULL, NULL, NULL, NULL, '3-DEMETHYLUBIQUINONE-9 3-O-METHYLTRANSFERASE', 247880);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(379568, 'PTHR43861:SF5', NULL, NULL, NULL, NULL, 'BLL5978 PROTEIN', 247880),
(379569, 'PTHR43861', NULL, NULL, NULL, NULL, 'TRANS-ACONITATE 2-METHYLTRANSFERASE-RELATED', 247880),
(379570, 'PTHR28036', NULL, NULL, NULL, NULL, 'DASH COMPLEX SUBUNIT DAD2', 247881),
(379571, 'PTHR28036:SF1', NULL, NULL, NULL, NULL, 'DASH COMPLEX SUBUNIT DAD2', 247881),
(379572, 'PTHR14211:SF10', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS PROTEIN NOP53', 247882),
(379573, 'PTHR14211:SF8', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS PROTEIN NOP53', 247882),
(379574, 'PTHR14211:SF9', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS PROTEIN NOP53', 247882),
(379575, 'PTHR14211:SF7', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS PROTEIN NOP53', 247882),
(379576, 'PTHR14211', NULL, NULL, NULL, NULL, 'GLIOMA SUPPRESSOR CANDIDATE REGION GENE 2', 247882),
(379577, 'PTHR13512:SF2', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 28', 247883),
(379578, 'PTHR13512', NULL, NULL, NULL, NULL, 'MEDIATOR COMPLEX SUBUNIT 28', 247883),
(379579, 'PTHR42032:SF1', NULL, NULL, NULL, NULL, 'YALI0E30679P', 247884),
(379580, 'PTHR42032', NULL, NULL, NULL, NULL, 'YALI0E30679P', 247884),
(379581, 'PTHR43549', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN YPNP-RELATED', 247885),
(379582, 'PTHR43549:SF1', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN NORM-RELATED', 247885),
(379583, 'PTHR43549:SF2', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN YPNP-RELATED', 247885),
(379584, 'PTHR13891', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247886),
(379585, 'PTHR13891:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY FACTOR 7', 247886),
(379586, 'PTHR47750:SF3', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247887),
(379587, 'PTHR47750:SF1', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SNE', 247887),
(379588, 'PTHR47750:SF6', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247887),
(379589, 'PTHR47750:SF5', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN-RELATED', 247887),
(379590, 'PTHR47750:SF4', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247887),
(379591, 'PTHR47750', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SNE', 247887),
(379592, 'PTHR36608:SF1', NULL, NULL, NULL, NULL, 'PPO1_KFDV DOMAIN-CONTAINING PROTEIN', 247888),
(379593, 'PTHR36608:SF2', NULL, NULL, NULL, NULL, 'PPO1_KFDV DOMAIN-CONTAINING PROTEIN', 247888),
(379594, 'PTHR36608', NULL, NULL, NULL, NULL, 'POLYPHENOL OXIDASE C, CHLOROPLASTIC-LIKE', 247888),
(379595, 'PTHR38613', NULL, NULL, NULL, NULL, 'PROTEIN CBG03211-RELATED', 247889),
(379596, 'PTHR38613:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG11062', 247889),
(379597, 'PTHR38613:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG03211', 247889),
(379598, 'PTHR38613:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG03047', 247889),
(379599, 'PTHR15705', NULL, NULL, NULL, NULL, 'MCG7194, ISOFORM CRA_A', 247890),
(379600, 'PTHR15705:SF1', NULL, NULL, NULL, NULL, 'RIKEN CDNA 9330159F19 GENE', 247890),
(379601, 'PTHR21431:SF0', NULL, NULL, NULL, NULL, 'PREFOLDIN SUBUNIT 6', 247891),
(379602, 'PTHR21431', NULL, NULL, NULL, NULL, 'PREFOLDIN SUBUNIT 6', 247891),
(379603, 'PTHR13338:SF4', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX ASSEMBLY FACTOR 4', 247892),
(379604, 'PTHR13338', NULL, NULL, NULL, NULL, 'UPF0240 PROTEIN', 247892),
(379605, 'PTHR13338:SF7', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX ASSEMBLY FACTOR 4', 247892),
(379606, 'PTHR13338:SF6', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX ASSEMBLY FACTOR 4', 247892),
(379607, 'PTHR13338:SF5', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX ASSEMBLY FACTOR 4', 247892),
(379608, 'PTHR40943', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 247893),
(379609, 'PTHR40943:SF2', NULL, NULL, NULL, NULL, 'CUPIN_3 DOMAIN-CONTAINING PROTEIN', 247893),
(379610, 'PTHR40943:SF1', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 247893),
(379611, 'PTHR46718', NULL, NULL, NULL, NULL, 'ASPARTATE-SEMIALDEHYDE DEHYDROGENASE', 247894);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(379612, 'PTHR46718:SF1', NULL, NULL, NULL, NULL, 'ASPARTATE-SEMIALDEHYDE DEHYDROGENASE', 247894),
(379613, 'PTHR11595:SF19', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-BETA/1-DELTA 2-RELATED', 247895),
(379614, 'PTHR11595:SF85', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 247895),
(379615, 'PTHR11595:SF74', NULL, NULL, NULL, NULL, 'EF1_GNE DOMAIN-CONTAINING PROTEIN', 247895),
(379616, 'PTHR11595:SF84', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-BETA 1', 247895),
(379617, 'PTHR11595:SF61', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-BETA', 247895),
(379618, 'PTHR11595:SF83', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-DELTA 2', 247895),
(379619, 'PTHR11595:SF82', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-BETA, PUTATIVE-RELATED', 247895),
(379620, 'PTHR11595:SF71', NULL, NULL, NULL, NULL, 'EF1_GNE DOMAIN-CONTAINING PROTEIN', 247895),
(379621, 'PTHR11595:SF60', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-BETA', 247895),
(379622, 'PTHR11595:SF70', NULL, NULL, NULL, NULL, 'EF1_GNE DOMAIN-CONTAINING PROTEIN', 247895),
(379623, 'PTHR11595:SF59', NULL, NULL, NULL, NULL, 'EF-HAND AND COILED-COIL DOMAIN-CONTAINING 1', 247895),
(379624, 'PTHR11595:SF26', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-DELTA', 247895),
(379625, 'PTHR11595:SF68', NULL, NULL, NULL, NULL, 'EF1_GNE DOMAIN-CONTAINING PROTEIN', 247895),
(379626, 'PTHR11595:SF78', NULL, NULL, NULL, NULL, 'EF1_GNE DOMAIN-CONTAINING PROTEIN', 247895),
(379627, 'PTHR11595:SF77', NULL, NULL, NULL, NULL, 'TRANSLATION ELONGATION FACTOR EF1B/RIBOSOMAL PROTEIN S6 FAMILY PROTEIN-RELATED', 247895),
(379628, 'PTHR11595:SF66', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-BETA 2', 247895),
(379629, 'PTHR11595:SF55', NULL, NULL, NULL, NULL, 'SI:CH211-112F3.4', 247895),
(379630, 'PTHR11595', NULL, NULL, NULL, NULL, 'EF-HAND AND COILED-COIL DOMAIN-CONTAINING FAMILY MEMBER', 247895),
(379631, 'PTHR11595:SF21', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-BETA', 247895),
(379632, 'PTHR11595:SF53', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-BETA', 247895),
(379633, 'PTHR11595:SF75', NULL, NULL, NULL, NULL, 'EF1_GNE DOMAIN-CONTAINING PROTEIN', 247895),
(379634, 'PTHR15740:SF2', NULL, NULL, NULL, NULL, 'ACTIVITY-DEPENDENT NEUROPROTECTOR HOMEOBOX PROTEIN 2', 247896),
(379635, 'PTHR15740:SF1', NULL, NULL, NULL, NULL, 'ACTIVITY-DEPENDENT NEUROPROTECTOR HOMEOBOX PROTEIN', 247896),
(379636, 'PTHR15740', NULL, NULL, NULL, NULL, 'NEUROPROTECTIVE PEPTIDE-CONTAINING PROTEIN', 247896),
(379637, 'PTHR42646:SF4', NULL, NULL, NULL, NULL, '5''-3'' EXONUCLEASE FAMILY PROTEIN', 247897),
(379638, 'PTHR42646:SF3', NULL, NULL, NULL, NULL, '5_3_EXONUC_N DOMAIN-CONTAINING PROTEIN', 247897),
(379639, 'PTHR42646:SF2', NULL, NULL, NULL, NULL, 'DNA-DIRECTED DNA POLYMERASE', 247897),
(379640, 'PTHR42646', NULL, NULL, NULL, NULL, 'FLAP ENDONUCLEASE XNI', 247897),
(379641, 'PTHR23227:SF77', NULL, NULL, NULL, NULL, 'CRANIOFACIAL DEVELOPMENT PROTEIN 2', 247898),
(379642, 'PTHR23227:SF45', NULL, NULL, NULL, NULL, 'OS01G0328500 PROTEIN', 247898),
(379643, 'PTHR23227:SF67', NULL, NULL, NULL, NULL, 'CRANIOFACIAL DEVELOPMENT PROTEIN 1', 247898),
(379644, 'PTHR23227:SF57', NULL, NULL, NULL, NULL, 'BUCENTAUR', 247898),
(379645, 'PTHR23227', NULL, NULL, NULL, NULL, 'BUCENTAUR RELATED', 247898),
(379646, 'PTHR23227:SF81', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 247898),
(379647, 'PTHR23227:SF82', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 247898),
(379648, 'PTHR40254', NULL, NULL, NULL, NULL, 'BLR0577 PROTEIN', 247899),
(379649, 'PTHR40254:SF1', NULL, NULL, NULL, NULL, 'BLR0577 PROTEIN', 247899),
(379650, 'PTHR47902', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 119', 247900),
(379651, 'PTHR47902:SF1', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 119', 247900),
(379652, 'PTHR15541:SF2', NULL, NULL, NULL, NULL, 'GRANULYSIN', 247901),
(379653, 'PTHR15541', NULL, NULL, NULL, NULL, 'GRANULYSIN RELATED', 247901),
(379654, 'PTHR47728:SF1', NULL, NULL, NULL, NULL, 'RAB GTPASE-ACTIVATING PROTEIN 1-LIKE', 247902),
(379655, 'PTHR47728', NULL, NULL, NULL, NULL, 'RAB GTPASE-ACTIVATING PROTEIN 1-LIKE', 247902);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(379656, 'PTHR15863:SF2', NULL, NULL, NULL, NULL, 'MRN COMPLEX-INTERACTING PROTEIN', 247903),
(379657, 'PTHR15863', NULL, NULL, NULL, NULL, 'MRN COMPLEX-INTERACTING PROTEIN', 247903),
(379658, 'PTHR12461:SF18', NULL, NULL, NULL, NULL, 'JMJC DOMAIN-CONTAINING PROTEIN', 247904),
(379659, 'PTHR12461:SF37', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 247904),
(379660, 'PTHR12461:SF27', NULL, NULL, NULL, NULL, 'JMJC DOMAIN-CONTAINING PROTEIN', 247904),
(379661, 'PTHR12461:SF90', NULL, NULL, NULL, NULL, 'JUMONJI-LIKE PROTEIN', 247904),
(379662, 'PTHR12461:SF91', NULL, NULL, NULL, NULL, 'JMJC DOMAIN-CONTAINING PROTEIN', 247904),
(379663, 'PTHR12461:SF81', NULL, NULL, NULL, NULL, 'JMJC DOMAIN-CONTAINING PROTEIN C', 247904),
(379664, 'PTHR12461:SF93', NULL, NULL, NULL, NULL, 'HYPOXIA-INDUCIBLE FACTOR 1-ALPHA INHIBITOR', 247904),
(379665, 'PTHR12461:SF43', NULL, NULL, NULL, NULL, 'HSPB1-ASSOCIATED PROTEIN 1', 247904),
(379666, 'PTHR12461:SF21', NULL, NULL, NULL, NULL, 'JMJC DOMAIN-CONTAINING PROTEIN F', 247904),
(379667, 'PTHR12461:SF89', NULL, NULL, NULL, NULL, 'TRNA WYBUTOSINE-SYNTHESIZING PROTEIN 4', 247904),
(379668, 'PTHR12461:SF35', NULL, NULL, NULL, NULL, 'JMJC DOMAIN-CONTAINING PROTEIN', 247904),
(379669, 'PTHR12461:SF94', NULL, NULL, NULL, NULL, 'JMJC DOMAIN-CONTAINING PROTEIN', 247904),
(379670, 'PTHR12461:SF83', NULL, NULL, NULL, NULL, 'JMJC DOMAIN-CONTAINING PROTEIN', 247904),
(379671, 'PTHR12461', NULL, NULL, NULL, NULL, 'HYPOXIA-INDUCIBLE FACTOR 1 ALPHA INHIBITOR-RELATED', 247904),
(379672, 'PTHR12461:SF95', NULL, NULL, NULL, NULL, 'JMJC DOMAIN-CONTAINING PROTEIN', 247904),
(379673, 'PTHR12461:SF96', NULL, NULL, NULL, NULL, 'OS08G0508500 PROTEIN', 247904),
(379674, 'PTHR12461:SF52', NULL, NULL, NULL, NULL, 'JMJC DOMAIN-CONTAINING PROTEIN', 247904),
(379675, 'PTHR12461:SF41', NULL, NULL, NULL, NULL, 'JMJC DOMAIN-CONTAINING PROTEIN', 247904),
(379676, 'PTHR12461:SF97', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL PEPTIDASE AND (3S)-LYSYL HYDROXYLASE JMJD7-RELATED', 247904),
(379677, 'PTHR12461:SF42', NULL, NULL, NULL, NULL, 'JMJC DOMAIN-CONTAINING PROTEIN', 247904),
(379678, 'PTHR12461:SF53', NULL, NULL, NULL, NULL, 'JMJC DOMAIN-CONTAINING PROTEIN', 247904),
(379679, 'PTHR31558:SF19', NULL, NULL, NULL, NULL, 'DUF1336 DOMAIN-CONTAINING PROTEIN', 247905),
(379680, 'PTHR31558:SF29', NULL, NULL, NULL, NULL, 'PROTEIN ENHANCED DISEASE RESISTANCE 2-LIKE', 247905),
(379681, 'PTHR31558:SF5', NULL, NULL, NULL, NULL, 'OS03G0759000 PROTEIN', 247905),
(379682, 'PTHR31558:SF39', NULL, NULL, NULL, NULL, 'DUF1336 DOMAIN-CONTAINING PROTEIN', 247905),
(379683, 'PTHR31558:SF27', NULL, NULL, NULL, NULL, 'DUF1336 DOMAIN-CONTAINING PROTEIN', 247905),
(379684, 'PTHR31558:SF16', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE (DUF1336)-RELATED', 247905),
(379685, 'PTHR31558:SF38', NULL, NULL, NULL, NULL, 'DUF1336 DOMAIN-CONTAINING PROTEIN', 247905),
(379686, 'PTHR31558:SF26', NULL, NULL, NULL, NULL, 'DUF1336 DOMAIN-CONTAINING PROTEIN', 247905),
(379687, 'PTHR31558:SF37', NULL, NULL, NULL, NULL, 'DUF1336 DOMAIN-CONTAINING PROTEIN', 247905),
(379688, 'PTHR31558:SF36', NULL, NULL, NULL, NULL, 'DUF1336 DOMAIN-CONTAINING PROTEIN', 247905),
(379689, 'PTHR31558:SF35', NULL, NULL, NULL, NULL, 'DUF1336 DOMAIN-CONTAINING PROTEIN', 247905),
(379690, 'PTHR31558:SF23', NULL, NULL, NULL, NULL, 'DUF1336 DOMAIN-CONTAINING PROTEIN', 247905),
(379691, 'PTHR31558:SF34', NULL, NULL, NULL, NULL, 'DUF1336 DOMAIN-CONTAINING PROTEIN', 247905),
(379692, 'PTHR31558:SF33', NULL, NULL, NULL, NULL, 'DUF1336 DOMAIN CONTAINING PROTEIN EXPRESSED', 247905),
(379693, 'PTHR31558:SF3', NULL, NULL, NULL, NULL, 'CW14 PROTEIN', 247905),
(379694, 'PTHR31558:SF32', NULL, NULL, NULL, NULL, 'DUF1336 DOMAIN-CONTAINING PROTEIN', 247905),
(379695, 'PTHR31558:SF31', NULL, NULL, NULL, NULL, 'DUF1336 DOMAIN-CONTAINING PROTEIN', 247905),
(379696, 'PTHR31558:SF41', NULL, NULL, NULL, NULL, 'DUF1336 DOMAIN-CONTAINING PROTEIN', 247905),
(379697, 'PTHR31558:SF40', NULL, NULL, NULL, NULL, 'DUF1336 DOMAIN-CONTAINING PROTEIN', 247905),
(379698, 'PTHR31558', NULL, NULL, NULL, NULL, 'CW14 PROTEIN', 247905);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(379699, 'PTHR46996:SF11', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L34', 247906),
(379700, 'PTHR46996:SF9', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L34', 247906),
(379701, 'PTHR46996:SF10', NULL, NULL, NULL, NULL, 'BNAC09G54710D PROTEIN', 247906),
(379702, 'PTHR46996:SF6', NULL, NULL, NULL, NULL, 'OS05G0488500 PROTEIN', 247906),
(379703, 'PTHR46996:SF3', NULL, NULL, NULL, NULL, 'OS01G0815100 PROTEIN', 247906),
(379704, 'PTHR46996:SF4', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L34', 247906),
(379705, 'PTHR46996', NULL, NULL, NULL, NULL, 'OS05G0488500 PROTEIN', 247906),
(379706, 'PTHR47859', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 247907),
(379707, 'PTHR47859:SF1', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 247907),
(379708, 'PTHR36521:SF1', NULL, NULL, NULL, NULL, 'FIP (FUNGUS-INDUCED PROTEIN) RELATED', 247908),
(379709, 'PTHR36521', NULL, NULL, NULL, NULL, 'GEO07177P1', 247908),
(379710, 'PTHR36521:SF2', NULL, NULL, NULL, NULL, 'CAENACIN (CAENORHABDITIS BACTERIOCIN)', 247908),
(379711, 'PTHR47484:SF2', NULL, NULL, NULL, NULL, 'EMB1793', 247909),
(379712, 'PTHR47484:SF1', NULL, NULL, NULL, NULL, 'COMPLEX 1 PROTEIN CONTAINING PROTEIN, EXPRESSED', 247909),
(379713, 'PTHR47484', NULL, NULL, NULL, NULL, 'COMPLEX 1 PROTEIN CONTAINING PROTEIN, EXPRESSED', 247909),
(379714, 'PTHR14139', NULL, NULL, NULL, NULL, 'CALSYNTENIN', 247910),
(379715, 'PTHR14139:SF2', NULL, NULL, NULL, NULL, 'CALSYNTENIN-1', 247910),
(379716, 'PTHR14139:SF5', NULL, NULL, NULL, NULL, 'CALSYNTENIN-3', 247910),
(379717, 'PTHR14139:SF6', NULL, NULL, NULL, NULL, 'CALSYNTENIN 2', 247910),
(379718, 'PTHR14139:SF3', NULL, NULL, NULL, NULL, 'CALSYNTENIN-2', 247910),
(379719, 'PTHR14139:SF4', NULL, NULL, NULL, NULL, 'CALSYNTENIN-1', 247910),
(379720, 'PTHR38166', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', 247911),
(379721, 'PTHR38166:SF1', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 247911),
(379722, 'PTHR38166:SF2', NULL, NULL, NULL, NULL, '', 247911),
(379723, 'PTHR23159:SF1', NULL, NULL, NULL, NULL, 'CENTROSOME-ASSOCIATED PROTEIN CEP250', 247912),
(379724, 'PTHR23159', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN 2', 247912),
(379725, 'PTHR23159:SF18', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 135 KDA', 247912),
(379726, 'PTHR23159:SF17', NULL, NULL, NULL, NULL, 'ROOTLETIN', 247912),
(379727, 'PTHR23159:SF16', NULL, NULL, NULL, NULL, 'CILIARY ROOTLET COILED-COIL PROTEIN 2', 247912),
(379728, 'PTHR23159:SF49', NULL, NULL, NULL, NULL, 'CHROMOSOME SEGREGATION PROTEIN', 247912),
(379729, 'PTHR23159:SF48', NULL, NULL, NULL, NULL, '', 247912),
(379730, 'PTHR23159:SF58', NULL, NULL, NULL, NULL, 'SI:DKEY-230P4.1', 247912),
(379731, 'PTHR23159:SF14', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC GENE 10 PROTEIN', 247912),
(379732, 'PTHR23159:SF47', NULL, NULL, NULL, NULL, 'SI:DKEY-230P4.1', 247912),
(379733, 'PTHR23159:SF57', NULL, NULL, NULL, NULL, '', 247912),
(379734, 'PTHR23159:SF56', NULL, NULL, NULL, NULL, 'PLASTID-LIPID-ASSOCIATED PROTEIN 14 CHLOROPLASTIC-RELATED', 247912),
(379735, 'PTHR23159:SF55', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN (IMH1), PUTATIVE-RELATED', 247912),
(379736, 'PTHR23159:SF54', NULL, NULL, NULL, NULL, 'OS04G0161100 PROTEIN', 247912),
(379737, 'PTHR23159:SF31', NULL, NULL, NULL, NULL, 'LIN-5 (FIVE) INTERACTING PROTEIN-RELATED', 247912),
(379738, 'PTHR23159:SF53', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN 135KDA, ISOFORM B', 247912),
(379739, 'PTHR23159:SF52', NULL, NULL, NULL, NULL, '', 247912),
(379740, 'PTHR23159:SF51', NULL, NULL, NULL, NULL, 'INVOLUCRIN REPEAT PROTEIN (AFU_ORTHOLOGUE AFUA_4G11410)', 247912),
(379741, 'PTHR23159:SF50', NULL, NULL, NULL, NULL, 'UDS1 DOMAIN-CONTAINING PROTEIN', 247912),
(379742, 'PTHR43854', NULL, NULL, NULL, NULL, 'INDOLEPYRUVATE OXIDOREDUCTASE SUBUNIT IORB', 247913),
(379743, 'PTHR43854:SF1', NULL, NULL, NULL, NULL, 'INDOLEPYRUVATE OXIDOREDUCTASE SUBUNIT IORB', 247913),
(379744, 'PTHR38733:SF1', NULL, NULL, NULL, NULL, 'PROTEIN MCRC', 247914);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(379745, 'PTHR38733', NULL, NULL, NULL, NULL, 'PROTEIN MCRC', 247914),
(379746, 'PTHR11514:SF140', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTION FACTOR', 247915),
(379747, 'PTHR11514:SF141', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYC3', 247915),
(379748, 'PTHR11514:SF142', NULL, NULL, NULL, NULL, 'ABA-INDUCIBLE BHLH-TYPE TRANSCRIPTION FACTOR', 247915),
(379749, 'PTHR11514:SF144', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYC3-LIKE', 247915),
(379750, 'PTHR11514:SF123', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247915),
(379751, 'PTHR11514:SF124', NULL, NULL, NULL, NULL, 'OS04G0300600 PROTEIN', 247915),
(379752, 'PTHR11514:SF102', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYC4-LIKE', 247915),
(379753, 'PTHR11514:SF147', NULL, NULL, NULL, NULL, 'BHLH-MYC_N DOMAIN-CONTAINING PROTEIN', 247915),
(379754, 'PTHR11514:SF103', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247915),
(379755, 'PTHR11514:SF125', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247915),
(379756, 'PTHR11514:SF43', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYC4', 247915),
(379757, 'PTHR11514:SF126', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247915),
(379758, 'PTHR11514:SF104', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247915),
(379759, 'PTHR11514:SF148', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247915),
(379760, 'PTHR11514:SF149', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247915),
(379761, 'PTHR11514:SF105', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247915),
(379762, 'PTHR11514:SF128', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247915),
(379763, 'PTHR11514:SF107', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MTB1', 247915),
(379764, 'PTHR11514:SF129', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTION FACTOR', 247915),
(379765, 'PTHR11514:SF108', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH6', 247915),
(379766, 'PTHR11514:SF47', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH13', 247915),
(379767, 'PTHR11514:SF109', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYC2', 247915),
(379768, 'PTHR11514', NULL, NULL, NULL, NULL, 'MYC', 247915),
(379769, 'PTHR11514:SF150', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247915),
(379770, 'PTHR11514:SF151', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247915),
(379771, 'PTHR11514:SF152', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247915),
(379772, 'PTHR11514:SF131', NULL, NULL, NULL, NULL, 'BASIC HELIX-LOOP-HELIX (BHLH) DNA-BINDING FAMILY PROTEIN-RELATED', 247915),
(379773, 'PTHR11514:SF153', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN, TRANSCRIPTION FACTOR MYC/MYB N-TERMINAL-RELATED', 247915),
(379774, 'PTHR11514:SF154', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247915),
(379775, 'PTHR11514:SF133', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247915),
(379776, 'PTHR11514:SF40', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH14', 247915),
(379777, 'PTHR11514:SF135', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247915),
(379778, 'PTHR11514:SF136', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247915),
(379779, 'PTHR11514:SF53', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH3', 247915),
(379780, 'PTHR11514:SF137', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247915),
(379781, 'PTHR11514:SF115', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 247915),
(379782, 'PTHR11514:SF116', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH28', 247915),
(379783, 'PTHR11514:SF138', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYC1', 247915),
(379784, 'PTHR11514:SF139', NULL, NULL, NULL, NULL, 'OS01G0705700 PROTEIN', 247915),
(379785, 'PTHR11514:SF119', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR ABA-INDUCIBLE BHLH-TYPE', 247915),
(379786, 'PTHR43462:SF2', NULL, NULL, NULL, NULL, 'THREONYL AND ALANYL TRNA SYNTHETASE SECOND ADDITIONAL DOMAIN-CONTAINING PROTEIN', 247916),
(379787, 'PTHR43462:SF1', NULL, NULL, NULL, NULL, 'ALANYL-TRNA EDITING PROTEIN AARSD1', 247916);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(379788, 'PTHR43462', NULL, NULL, NULL, NULL, 'ALANYL-TRNA EDITING PROTEIN', 247916),
(379789, 'PTHR36916', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 247917),
(379790, 'PTHR36916:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 247917),
(379791, 'PTHR36916:SF2', NULL, NULL, NULL, NULL, 'SI:CH1073-263O8.2-RELATED', 247917),
(379792, 'PTHR43833:SF7', NULL, NULL, NULL, NULL, 'KTR SYSTEM POTASSIUM UPTAKE PROTEIN C', 247918),
(379793, 'PTHR43833:SF9', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL PROTEIN 2-RELATED', 247918),
(379794, 'PTHR43833:SF11', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL', 247918),
(379795, 'PTHR43833:SF8', NULL, NULL, NULL, NULL, 'TRK SYSTEM POTASSIUM UPTAKE PROTEIN TRKA', 247918),
(379796, 'PTHR43833:SF12', NULL, NULL, NULL, NULL, 'VOLTAGE-GATED POTASSIUM CHANNEL KCH', 247918),
(379797, 'PTHR43833', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL PROTEIN 2-RELATED-RELATED', 247918),
(379798, 'PTHR43833:SF5', NULL, NULL, NULL, NULL, 'TRK SYSTEM POTASSIUM UPTAKE PROTEIN TRKA', 247918),
(379799, 'PTHR43833:SF4', NULL, NULL, NULL, NULL, 'RCK N-TERMINAL DOMAIN-CONTAINING PROTEIN', 247918),
(379800, 'PTHR12318', NULL, NULL, NULL, NULL, 'TESTOSTERONE-REGULATED PROTEIN RP2', 247919),
(379801, 'PTHR12318:SF0', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE-LINKED MOIETY X MOTIF 19', 247919),
(379802, 'PTHR47347:SF2', NULL, NULL, NULL, NULL, 'GOLGIN CANDIDATE 5', 247920),
(379803, 'PTHR47347', NULL, NULL, NULL, NULL, 'GOLGIN CANDIDATE 5', 247920),
(379804, 'PTHR43114:SF2', NULL, NULL, NULL, NULL, 'ADENINE DEAMINASE', 247921),
(379805, 'PTHR43114:SF6', NULL, NULL, NULL, NULL, 'ADENOSINE/ADENINE DEAMINASE-RELATED', 247921),
(379806, 'PTHR43114', NULL, NULL, NULL, NULL, 'ADENINE DEAMINASE', 247921),
(379807, 'PTHR23535', NULL, NULL, NULL, NULL, 'SUGAR EFFLUX TRANSPORTER A-RELATED', 247922),
(379808, 'PTHR23535:SF1', NULL, NULL, NULL, NULL, 'MFS FAMILY TRANSPORT PROTEIN-RELATED', 247922),
(379809, 'PTHR23535:SF2', NULL, NULL, NULL, NULL, 'SUGAR EFFLUX TRANSPORTER A-RELATED', 247922),
(379810, 'PTHR41805', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247923),
(379811, 'PTHR41805:SF1', NULL, NULL, NULL, NULL, 'RRNA-PROCESSING PROTEIN FYV7', 247923),
(379812, 'PTHR39083:SF1', NULL, NULL, NULL, NULL, 'CYCLIC DI-GMP-BINDING PROTEIN', 247924),
(379813, 'PTHR39083', NULL, NULL, NULL, NULL, 'CYCLIC DI-GMP-BINDING PROTEIN', 247924),
(379814, 'PTHR42905:SF3', NULL, NULL, NULL, NULL, 'OXALOACETATE DECARBOXYLASE', 247925),
(379815, 'PTHR42905:SF5', NULL, NULL, NULL, NULL, 'CARBOXYVINYL-CARBOXYPHOSPHONATE PHOSPHORYLMUTASE, CHLOROPLASTIC', 247925),
(379816, 'PTHR42905:SF7', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE PHOSPHOMUTASE-RELATED', 247925),
(379817, 'PTHR42905:SF16', NULL, NULL, NULL, NULL, 'CARBOXYPHOSPHONOENOLPYRUVATE PHOSPHONOMUTASE-LIKE PROTEIN (AFU_ORTHOLOGUE AFUA_5G07230)', 247925),
(379818, 'PTHR42905', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYLASE', 247925),
(379819, 'PTHR42905:SF9', NULL, NULL, NULL, NULL, 'BNACNNG47390D PROTEIN', 247925),
(379820, 'PTHR42905:SF13', NULL, NULL, NULL, NULL, 'CARBOXYVINYL-CARBOXYPHOSPHONATE PHOSPHORYLMUTASE (AFU_ORTHOLOGUE AFUA_2G00120)', 247925),
(379821, 'PTHR42905:SF15', NULL, NULL, NULL, NULL, 'PHOSPHONOMUTASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G03820)-RELATED', 247925),
(379822, 'PTHR42905:SF10', NULL, NULL, NULL, NULL, 'OS04G0386600 PROTEIN', 247925),
(379823, 'PTHR42905:SF2', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYLASE FAMILY PROTEIN', 247925),
(379824, 'PTHR47747', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P PROTEIN SUBUNIT P38-LIKE PROTEIN', 247926),
(379825, 'PTHR47747:SF3', NULL, NULL, NULL, NULL, 'OS03G0853600 PROTEIN', 247926),
(379826, 'PTHR47747:SF2', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P PROTEIN SUBUNIT P38-LIKE PROTEIN', 247926),
(379827, 'PTHR16193:SF0', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 27', 247927),
(379828, 'PTHR16193', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247927),
(379829, 'PTHR47815', NULL, NULL, NULL, NULL, 'UNIVERSAL STRESS PROTEIN A FAMILY PROTEIN C25B2.10', 247928);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(379830, 'PTHR47815:SF1', NULL, NULL, NULL, NULL, 'UNIVERSAL STRESS PROTEIN A FAMILY PROTEIN C25B2.10', 247928),
(379831, 'PTHR46147:SF3', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE ASH1', 247929),
(379832, 'PTHR46147:SF1', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE ASH1L', 247929),
(379833, 'PTHR46147:SF2', NULL, NULL, NULL, NULL, 'SET-BINDING PROTEIN', 247929),
(379834, 'PTHR46147', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE ASH1', 247929),
(379835, 'PTHR28635:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE INNER EAR EXPRESSED PROTEIN', 247930),
(379836, 'PTHR28635', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE INNER EAR EXPRESSED PROTEIN', 247930),
(379837, 'PTHR13217:SF10', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING, FAMILY G (WITH RHOGEF DOMAIN) MEMBER 6', 247931),
(379838, 'PTHR13217:SF6', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY G MEMBER 7', 247931),
(379839, 'PTHR13217:SF11', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY G MEMBER 5', 247931),
(379840, 'PTHR13217:SF12', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING, FAMILY G (WITH RHOGEF DOMAIN) MEMBER 5A-RELATED', 247931),
(379841, 'PTHR13217:SF13', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 247931),
(379842, 'PTHR13217', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY G MEMBER 7', 247931),
(379843, 'PTHR31052:SF33', NULL, NULL, NULL, NULL, 'BNAA02G05280D PROTEIN', 247932),
(379844, 'PTHR31052:SF34', NULL, NULL, NULL, NULL, 'OS07G0690900 PROTEIN', 247932),
(379845, 'PTHR31052:SF12', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN 7', 247932),
(379846, 'PTHR31052:SF24', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN 7', 247932),
(379847, 'PTHR31052:SF14', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN 11', 247932),
(379848, 'PTHR31052:SF30', NULL, NULL, NULL, NULL, 'BNAA01G36400D PROTEIN', 247932),
(379849, 'PTHR31052:SF20', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN 9', 247932),
(379850, 'PTHR31052:SF32', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN 7', 247932),
(379851, 'PTHR31052:SF21', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN 10', 247932),
(379852, 'PTHR31052:SF2', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN 10', 247932),
(379853, 'PTHR31052:SF3', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN 7', 247932),
(379854, 'PTHR31052:SF19', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN 7', 247932),
(379855, 'PTHR31052', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN 7', 247932),
(379856, 'PTHR31052:SF27', NULL, NULL, NULL, NULL, 'BNAC01G19270D PROTEIN', 247932),
(379857, 'PTHR31052:SF28', NULL, NULL, NULL, NULL, 'COBRA, PLANT-RELATED', 247932),
(379858, 'PTHR31052:SF18', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN 8', 247932),
(379859, 'PTHR36381', NULL, NULL, NULL, NULL, 'ETHYLENE-REGULATED TRANSCRIPT 2 (ERT2)', 247933),
(379860, 'PTHR36381:SF5', NULL, NULL, NULL, NULL, 'ETHYLENE-REGULATED NUCLEAR PROTEIN ERT2-LIKE PROTEIN', 247933),
(379861, 'PTHR36381:SF7', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE NUCLEAR PROTEIN', 247933),
(379862, 'PTHR36381:SF6', NULL, NULL, NULL, NULL, 'BNAA02G22670D PROTEIN', 247933),
(379863, 'PTHR36381:SF9', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247933),
(379864, 'PTHR36381:SF1', NULL, NULL, NULL, NULL, 'ETHYLENE-REGULATED TRANSCRIPT 2 (ERT2)', 247933),
(379865, 'PTHR43088:SF1', NULL, NULL, NULL, NULL, 'SUBUNIT OF PYRUVATE:FLAVODOXIN OXIDOREDUCTASE-RELATED', 247934),
(379866, 'PTHR43088', NULL, NULL, NULL, NULL, 'SUBUNIT OF PYRUVATE:FLAVODOXIN OXIDOREDUCTASE-RELATED', 247934),
(379867, 'PTHR38038:SF1', NULL, NULL, NULL, NULL, 'PENICILLIN-BINDING PROTEIN ACTIVATOR LPOA', 247935),
(379868, 'PTHR38038', NULL, NULL, NULL, NULL, 'PENICILLIN-BINDING PROTEIN ACTIVATOR LPOA', 247935),
(379869, 'PTHR35388', NULL, NULL, NULL, NULL, '', 247936),
(379870, 'PTHR35388:SF2', NULL, NULL, NULL, NULL, '', 247936),
(379871, 'PTHR42784', NULL, NULL, NULL, NULL, 'PYRANOSE 2-OXIDASE', 247937),
(379872, 'PTHR42784:SF1', NULL, NULL, NULL, NULL, 'PYRANOSE 2-OXIDASE', 247937);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(379873, 'PTHR13675:SF3', NULL, NULL, NULL, NULL, 'LYR MOTIF-CONTAINING PROTEIN 2', 247938),
(379874, 'PTHR13675:SF2', NULL, NULL, NULL, NULL, 'LYR MOTIF CONTAINING 2', 247938),
(379875, 'PTHR13675:SF1', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE ASSEMBLY FACTOR 1, MITOCHONDRIAL', 247938),
(379876, 'PTHR13675:SF5', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE ASSEMBLY FACTOR 1B, MITOCHONDRIAL', 247938),
(379877, 'PTHR13675', NULL, NULL, NULL, NULL, 'LYR MOTIF-CONTAINING PROTEIN 2', 247938),
(379878, 'PTHR13675:SF0', NULL, NULL, NULL, NULL, 'LYR MOTIF-CONTAINING PROTEIN 2', 247938),
(379879, 'PTHR34774:SF4', NULL, NULL, NULL, NULL, '', 247939),
(379880, 'PTHR34774:SF1', NULL, NULL, NULL, NULL, 'EPHRIN-A3 PROTEIN', 247939),
(379881, 'PTHR34774:SF3', NULL, NULL, NULL, NULL, 'BNAA06G10790D PROTEIN', 247939),
(379882, 'PTHR34774:SF2', NULL, NULL, NULL, NULL, '', 247939),
(379883, 'PTHR34774', NULL, NULL, NULL, NULL, 'EPHRIN-A3 PROTEIN', 247939),
(379884, 'PTHR30212', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247940),
(379885, 'PTHR30212:SF2', NULL, NULL, NULL, NULL, 'PROTEIN YIIM', 247940),
(379886, 'PTHR30212:SF4', NULL, NULL, NULL, NULL, 'MOSC DOMAIN-CONTAINING PROTEIN', 247940),
(379887, 'PTHR39420', NULL, NULL, NULL, NULL, '', 247941),
(379888, 'PTHR39420:SF1', NULL, NULL, NULL, NULL, 'DUF2342 FAMILY PROTEIN', 247941),
(379889, 'PTHR39420:SF2', NULL, NULL, NULL, NULL, '', 247941),
(379890, 'PTHR42266', NULL, NULL, NULL, NULL, 'GIM5B PROTEIN', 247942),
(379891, 'PTHR42266:SF1', NULL, NULL, NULL, NULL, 'GIM5B PROTEIN', 247942),
(379892, 'PTHR11516:SF70', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT SUBUNIT ALPHA', 247943),
(379893, 'PTHR11516:SF60', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT SUBUNIT ALPHA', 247943),
(379894, 'PTHR11516:SF41', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT SUBUNIT ALPHA', 247943),
(379895, 'PTHR11516:SF52', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT SUBUNIT ALPHA, SOMATIC FORM, MITOCHONDRIAL', 247943),
(379896, 'PTHR11516:SF63', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT SUBUNIT ALPHA', 247943),
(379897, 'PTHR11516:SF64', NULL, NULL, NULL, NULL, 'E1_DH DOMAIN-CONTAINING PROTEIN', 247943),
(379898, 'PTHR11516:SF61', NULL, NULL, NULL, NULL, 'E1_DH DOMAIN-CONTAINING PROTEIN', 247943),
(379899, 'PTHR11516:SF51', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT SUBUNIT ALPHA, SOMATIC FORM, MITOCHONDRIAL', 247943),
(379900, 'PTHR11516', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT, ALPHA SUBUNIT  BACTERIAL AND ORGANELLAR', 247943),
(379901, 'PTHR11516:SF2', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE ALPHA SUBUNIT-RELATED', 247943),
(379902, 'PTHR11516:SF23', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT SUBUNIT ALPHA, TESTIS-SPECIFIC FORM, MITOCHONDRIAL', 247943),
(379903, 'PTHR11516:SF56', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT SUBUNIT ALPHA-2, MITOCHONDRIAL', 247943),
(379904, 'PTHR11516:SF65', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT SUBUNIT ALPHA, MITOCHONDRIAL', 247943),
(379905, 'PTHR11516:SF66', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT SUBUNIT ALPHA', 247943),
(379906, 'PTHR11516:SF27', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT SUBUNIT ALPHA, TESTIS-SPECIFIC FORM, MITOCHONDRIAL', 247943),
(379907, 'PTHR11516:SF38', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT SUBUNIT ALPHA-2, MITOCHONDRIAL', 247943),
(379908, 'PTHR11516:SF58', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT SUBUNIT ALPHA', 247943),
(379909, 'PTHR11516:SF69', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT SUBUNIT ALPHA', 247943),
(379910, 'PTHR45826:SF9', NULL, NULL, NULL, NULL, 'CATIONIC AMINO ACID TRANSPORTER', 247944),
(379911, 'PTHR45826', NULL, NULL, NULL, NULL, 'POLYAMINE TRANSPORTER PUT1', 247944),
(379912, 'PTHR45826:SF8', NULL, NULL, NULL, NULL, 'CATIONIC AMINO ACID TRANSPORTER', 247944),
(379913, 'PTHR45826:SF4', NULL, NULL, NULL, NULL, 'NEUTRAL AMINO ACID TRANSPORTER', 247944); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(379914, 'PTHR45826:SF7', NULL, NULL, NULL, NULL, 'ACID TRANSPORTER, PUTATIVE-RELATED', 247944),
(379915, 'PTHR45826:SF10', NULL, NULL, NULL, NULL, 'NEUTRAL AMINO ACID TRANSPORT PROTEIN', 247944),
(379916, 'PTHR45826:SF21', NULL, NULL, NULL, NULL, 'BNAA05G20530D PROTEIN', 247944),
(379917, 'PTHR45826:SF2', NULL, NULL, NULL, NULL, 'ACID PERMEASE FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 247944),
(379918, 'PTHR45826:SF13', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER', 247944),
(379919, 'PTHR45826:SF14', NULL, NULL, NULL, NULL, 'POLYAMINE TRANSPORTER RMV1', 247944),
(379920, 'PTHR45826:SF25', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE-LIKE PROTEIN', 247944),
(379921, 'PTHR45826:SF22', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247944),
(379922, 'PTHR45826:SF23', NULL, NULL, NULL, NULL, '', 247944),
(379923, 'PTHR45826:SF12', NULL, NULL, NULL, NULL, 'DUF4218 DOMAIN-CONTAINING PROTEIN', 247944),
(379924, 'PTHR45826:SF17', NULL, NULL, NULL, NULL, 'OS12G0580400 PROTEIN', 247944),
(379925, 'PTHR45826:SF18', NULL, NULL, NULL, NULL, 'NEUTRAL AMINO ACID TRANSPORTER', 247944),
(379926, 'PTHR45826:SF26', NULL, NULL, NULL, NULL, 'POLYAMINE TRANSPORTER PUT1', 247944),
(379927, 'PTHR45826:SF16', NULL, NULL, NULL, NULL, 'BNAA09G24860D PROTEIN', 247944),
(379928, 'PTHR45826:SF19', NULL, NULL, NULL, NULL, 'AMINO ACID/POLYAMINE TRANSPORTER I-RELATED', 247944),
(379929, 'PTHR11236:SF41', NULL, NULL, NULL, NULL, 'AMINODEOXYCHORISMATE SYNTHASE COMPONENT 1', 247945),
(379930, 'PTHR11236:SF50', NULL, NULL, NULL, NULL, 'AMINODEOXYCHORISMATE SYNTHASE COMPONENT 1', 247945),
(379931, 'PTHR11236:SF33', NULL, NULL, NULL, NULL, 'ANTHRANILATE SYNTHASE-RELATED', 247945),
(379932, 'PTHR11236:SF32', NULL, NULL, NULL, NULL, 'ANTHRANILATE SYNTHASE ALPHA SUBUNIT 2, CHLOROPLASTIC', 247945),
(379933, 'PTHR11236:SF42', NULL, NULL, NULL, NULL, 'P-AMINOBENZOIC ACID SYNTHASE', 247945),
(379934, 'PTHR11236:SF49', NULL, NULL, NULL, NULL, 'ANTHRANILATE SYNTHASE COMPONENT 1', 247945),
(379935, 'PTHR11236:SF9', NULL, NULL, NULL, NULL, 'ANTHRANILATE SYNTHASE COMPONENT 1', 247945),
(379936, 'PTHR11236:SF48', NULL, NULL, NULL, NULL, 'ANTHRANILATE SYNTHASE COMPONENT 1', 247945),
(379937, 'PTHR11236:SF47', NULL, NULL, NULL, NULL, 'ANTHRANILATE SYNTHASE', 247945),
(379938, 'PTHR11236:SF46', NULL, NULL, NULL, NULL, 'ANTHRANILATE SYNTHASE COMPONENT 1', 247945),
(379939, 'PTHR11236:SF18', NULL, NULL, NULL, NULL, 'AMINODEOXYCHORISMATE SYNTHASE', 247945),
(379940, 'PTHR11236:SF39', NULL, NULL, NULL, NULL, 'ANTHRANILATE SYNTHASE', 247945),
(379941, 'PTHR11236', NULL, NULL, NULL, NULL, 'AMINOBENZOATE/ANTHRANILATE SYNTHASE', 247945),
(379942, 'PTHR35995:SF3', NULL, NULL, NULL, NULL, 'BNAA06G15550D PROTEIN', 247946),
(379943, 'PTHR35995:SF2', NULL, NULL, NULL, NULL, 'BNAA10G08730D PROTEIN', 247946),
(379944, 'PTHR35995:SF1', NULL, NULL, NULL, NULL, 'OS04G0690500 PROTEIN', 247946),
(379945, 'PTHR35995', NULL, NULL, NULL, NULL, 'OS04G0690500 PROTEIN', 247946),
(379946, 'PTHR35995:SF4', NULL, NULL, NULL, NULL, 'BNAC08G19980D PROTEIN', 247946),
(379947, 'PTHR21494', NULL, NULL, NULL, NULL, 'ACTIVATING SIGNAL COINTEGRATOR 1 COMPLEX SUBUNIT 2  ASC-1 COMPLEX SUBUNIT P100', 247947),
(379948, 'PTHR21494:SF0', NULL, NULL, NULL, NULL, 'ACTIVATING SIGNAL COINTEGRATOR 1 COMPLEX SUBUNIT 2', 247947),
(379949, 'PTHR21494:SF2', NULL, NULL, NULL, NULL, 'NUCLEIC ACID BINDING PROTEIN', 247947),
(379950, 'PTHR10109', NULL, NULL, NULL, NULL, 'MATRIX GLA PROTEIN', 247948),
(379951, 'PTHR10109:SF0', NULL, NULL, NULL, NULL, 'MATRIX GLA PROTEIN', 247948),
(379952, 'PTHR42785:SF5', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE TYPE IA CORE', 247949),
(379953, 'PTHR42785:SF4', NULL, NULL, NULL, NULL, 'OMEGA-PROTEIN', 247949),
(379954, 'PTHR42785:SF1', NULL, NULL, NULL, NULL, 'OMEGA-PROTEIN', 247949),
(379955, 'PTHR42785', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE, TYPE IA, CORE', 247949),
(379956, 'PTHR23072:SF1', NULL, NULL, NULL, NULL, 'GPI ETHANOLAMINE PHOSPHATE TRANSFERASE 2', 247950),
(379957, 'PTHR23072', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL GLYCAN-RELATED', 247950);
INSERT INTO "PUBLIC"."MODEL" VALUES
(379958, 'PTHR23072:SF0', NULL, NULL, NULL, NULL, 'GPI ETHANOLAMINE PHOSPHATE TRANSFERASE 2', 247950),
(379959, 'PTHR23068:SF9', NULL, NULL, NULL, NULL, 'DNA (CYTOSINE-5)-METHYLTRANSFERASE 3B', 247951),
(379960, 'PTHR23068:SF49', NULL, NULL, NULL, NULL, 'PWWP DOMAINCONTAINING PROTEIN', 247951),
(379961, 'PTHR23068:SF38', NULL, NULL, NULL, NULL, 'SAM-DEPENDENT MTASE DRM-TYPE DOMAIN-CONTAINING PROTEIN', 247951),
(379962, 'PTHR23068:SF48', NULL, NULL, NULL, NULL, 'SAM-DEPENDENT MTASE DRM-TYPE DOMAIN-CONTAINING PROTEIN', 247951),
(379963, 'PTHR23068:SF25', NULL, NULL, NULL, NULL, 'DNA (CYTOSINE-5)-METHYLTRANSFERASE DRM2', 247951),
(379964, 'PTHR23068:SF36', NULL, NULL, NULL, NULL, 'SAM-DEPENDENT MTASE DRM-TYPE DOMAIN-CONTAINING PROTEIN', 247951),
(379965, 'PTHR23068:SF47', NULL, NULL, NULL, NULL, 'SAM-DEPENDENT MTASE DRM-TYPE DOMAIN-CONTAINING PROTEIN', 247951),
(379966, 'PTHR23068:SF46', NULL, NULL, NULL, NULL, 'DNA (CYTOSINE-5-)-METHYLTRANSFERASE', 247951),
(379967, 'PTHR23068:SF13', NULL, NULL, NULL, NULL, 'DNA (CYTOSINE-5)-METHYLTRANSFERASE 3-LIKE', 247951),
(379968, 'PTHR23068:SF6', NULL, NULL, NULL, NULL, 'PWWP DOMAIN-CONTAINING PROTEIN 2B', 247951),
(379969, 'PTHR23068:SF45', NULL, NULL, NULL, NULL, 'DNA (CYTOSINE-5)-METHYLTRANSFERASE DRM1', 247951),
(379970, 'PTHR23068:SF44', NULL, NULL, NULL, NULL, 'SAM-DEPENDENT MTASE DRM-TYPE DOMAIN-CONTAINING PROTEIN', 247951),
(379971, 'PTHR23068:SF4', NULL, NULL, NULL, NULL, 'PWWP DOMAIN-CONTAINING PROTEIN 2A', 247951),
(379972, 'PTHR23068:SF11', NULL, NULL, NULL, NULL, 'INACTIVE DNA (CYTOSINE-5)-METHYLTRANSFERASE DRM3-RELATED', 247951),
(379973, 'PTHR23068:SF10', NULL, NULL, NULL, NULL, 'DNA (CYTOSINE-5)-METHYLTRANSFERASE 3A', 247951),
(379974, 'PTHR23068:SF43', NULL, NULL, NULL, NULL, 'SAM-DEPENDENT MTASE DRM-TYPE DOMAIN-CONTAINING PROTEIN', 247951),
(379975, 'PTHR23068:SF31', NULL, NULL, NULL, NULL, 'SAM-DEPENDENT MTASE DRM-TYPE DOMAIN-CONTAINING PROTEIN', 247951),
(379976, 'PTHR23068:SF52', NULL, NULL, NULL, NULL, 'DUF3444 DOMAIN-CONTAINING PROTEIN', 247951),
(379977, 'PTHR23068', NULL, NULL, NULL, NULL, 'DNA  CYTOSINE-5- -METHYLTRANSFERASE 3-RELATED', 247951),
(379978, 'PTHR23068:SF40', NULL, NULL, NULL, NULL, 'DNA METHYLTRANSFERASE', 247951),
(379979, 'PTHR23068:SF51', NULL, NULL, NULL, NULL, 'SAM-DEPENDENT MTASE DRM-TYPE DOMAIN-CONTAINING PROTEIN', 247951),
(379980, 'PTHR23068:SF50', NULL, NULL, NULL, NULL, 'DNA CYTOSINE METHYLTRANSFERASE', 247951),
(379981, 'PTHR23068:SF39', NULL, NULL, NULL, NULL, 'DNA METHYLTRANSFERASE', 247951),
(379982, 'PTHR13438', NULL, NULL, NULL, NULL, 'AMINOACYL TRNA SYNTHASE COMPLEX-INTERACTING MULTIFUNCTIONAL PROTEIN', 247952),
(379983, 'PTHR13438:SF2', NULL, NULL, NULL, NULL, 'AMINOACYL TRNA SYNTHASE COMPLEX-INTERACTING MULTIFUNCTIONAL PROTEIN 2', 247952),
(379984, 'PTHR12081:SF89', NULL, NULL, NULL, NULL, 'OS04G0112200 PROTEIN', 247953),
(379985, 'PTHR12081:SF25', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR E2F7', 247953),
(379986, 'PTHR12081:SF86', NULL, NULL, NULL, NULL, 'BNAA06G16850D PROTEIN', 247953),
(379987, 'PTHR12081:SF42', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR E2F4', 247953),
(379988, 'PTHR12081:SF43', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR E2F1', 247953),
(379989, 'PTHR12081:SF44', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR E2F3', 247953),
(379990, 'PTHR12081:SF81', NULL, NULL, NULL, NULL, 'E2F_TDP DOMAIN-CONTAINING PROTEIN', 247953),
(379991, 'PTHR12081:SF82', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR E2FB', 247953),
(379992, 'PTHR12081:SF40', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR E2F8', 247953),
(379993, 'PTHR12081:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR EFL-3', 247953),
(379994, 'PTHR12081:SF101', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR EFL-2', 247953),
(379995, 'PTHR12081:SF100', NULL, NULL, NULL, NULL, 'E2F TRANSCRIPTION FACTOR-LIKE E2FF', 247953),
(379996, 'PTHR12081:SF18', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR E2F2', 247953),
(379997, 'PTHR12081', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR E2F', 247953),
(379998, 'PTHR12081:SF19', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR E2F6', 247953);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(379999, 'PTHR12081:SF103', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR E2FB', 247953),
(380000, 'PTHR12081:SF102', NULL, NULL, NULL, NULL, 'SI:CH211-160F23.5', 247953),
(380001, 'PTHR12081:SF35', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR E2F5', 247953),
(380002, 'PTHR12081:SF105', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR E2FA', 247953),
(380003, 'PTHR12081:SF104', NULL, NULL, NULL, NULL, 'E2F TRANSCRIPTION FACTOR-LIKE E2FD', 247953),
(380004, 'PTHR12081:SF96', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR E2F1', 247953),
(380005, 'PTHR12081:SF75', NULL, NULL, NULL, NULL, 'OS06G0245900 PROTEIN', 247953),
(380006, 'PTHR12081:SF97', NULL, NULL, NULL, NULL, 'WINGED HELIX-TURN-HELIX DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 247953),
(380007, 'PTHR12081:SF98', NULL, NULL, NULL, NULL, 'E2F-DP TRANSCRIPTION FACTOR', 247953),
(380008, 'PTHR12081:SF99', NULL, NULL, NULL, NULL, 'E2F TRANSCRIPTION FACTOR-LIKE E2FF ISOFORM X1', 247953),
(380009, 'PTHR12081:SF50', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR E2F2', 247953),
(380010, 'PTHR12081:SF94', NULL, NULL, NULL, NULL, 'E2F_TDP DOMAIN-CONTAINING PROTEIN', 247953),
(380011, 'PTHR12081:SF51', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR E2FC', 247953),
(380012, 'PTHR35083', NULL, NULL, NULL, NULL, 'RGD1565685 PROTEIN', 247954),
(380013, 'PTHR35083:SF1', NULL, NULL, NULL, NULL, 'RGD1565685 PROTEIN', 247954),
(380014, 'PTHR35083:SF2', NULL, NULL, NULL, NULL, 'CHROMOSOME LG17 OPEN READING FRAME, HUMAN CXORF38', 247954),
(380015, 'PTHR35083:SF3', NULL, NULL, NULL, NULL, 'SI:CH211-91P5.3-RELATED', 247954),
(380016, 'PTHR42838', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT II', 247955),
(380017, 'PTHR42838:SF2', NULL, NULL, NULL, NULL, 'BLL4481 PROTEIN', 247955),
(380018, 'PTHR42838:SF1', NULL, NULL, NULL, NULL, 'NITROUS-OXIDE REDUCTASE', 247955),
(380019, 'PTHR12591:SF3', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATASE CATALYTIC SUBUNIT 1', 247956),
(380020, 'PTHR12591:SF5', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATASE', 247956),
(380021, 'PTHR12591', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATASE', 247956),
(380022, 'PTHR12591:SF0', NULL, NULL, NULL, NULL, 'FI19814P1', 247956),
(380023, 'PTHR12591:SF2', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATASE 3', 247956),
(380024, 'PTHR12591:SF1', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATASE 2', 247956),
(380025, 'PTHR44750:SF1', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE T1-RELATED', 247957),
(380026, 'PTHR44750:SF2', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE T1', 247957),
(380027, 'PTHR44750:SF3', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE, AMINO-TERMINAL DOMAIN PROTEIN', 247957),
(380028, 'PTHR44750:SF5', NULL, NULL, NULL, NULL, 'BNAC06G42280D PROTEIN', 247957),
(380029, 'PTHR44750', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE T1-RELATED', 247957),
(380030, 'PTHR44750:SF7', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE T1-LIKE', 247957),
(380031, 'PTHR44750:SF8', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE T1', 247957),
(380032, 'PTHR34827:SF6', NULL, NULL, NULL, NULL, 'INSULIN GROWTH FACTOR-LIKE FAMILY MEMBER 2', 247958),
(380033, 'PTHR34827:SF5', NULL, NULL, NULL, NULL, 'INSULIN GROWTH FACTOR-LIKE FAMILY MEMBER 3', 247958),
(380034, 'PTHR34827', NULL, NULL, NULL, NULL, 'INSULIN GROWTH FACTOR-LIKE FAMILY MEMBER 3-RELATED', 247958),
(380035, 'PTHR34827:SF2', NULL, NULL, NULL, NULL, 'INSULIN GROWTH FACTOR-LIKE FAMILY MEMBER 1', 247958),
(380036, 'PTHR34827:SF1', NULL, NULL, NULL, NULL, 'INSULIN GROWTH FACTOR-LIKE FAMILY MEMBER 4', 247958),
(380037, 'PTHR33645:SF12', NULL, NULL, NULL, NULL, '', 247959),
(380038, 'PTHR33645:SF8', NULL, NULL, NULL, NULL, '', 247959),
(380039, 'PTHR33645:SF11', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE (DUF3754)', 247959),
(380040, 'PTHR33645:SF13', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247959),
(380041, 'PTHR33645', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE (DUF3754)', 247959),
(380042, 'PTHR33645:SF5', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE', 247959),
(380043, 'PTHR33645:SF4', NULL, NULL, NULL, NULL, 'OS01G0929000 PROTEIN', 247959);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(380044, 'PTHR33645:SF10', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE', 247959),
(380045, 'PTHR33645:SF2', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE (DUF3754)-RELATED', 247959),
(380046, 'PTHR12845', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE EXCHANGE FACTOR', 247960),
(380047, 'PTHR12845:SF2', NULL, NULL, NULL, NULL, 'DH DOMAIN-CONTAINING PROTEIN-RELATED', 247960),
(380048, 'PTHR12845:SF3', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 16', 247960),
(380049, 'PTHR12845:SF4', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 26', 247960),
(380050, 'PTHR12845:SF5', NULL, NULL, NULL, NULL, 'EPHEXIN, ISOFORM D', 247960),
(380051, 'PTHR12845:SF6', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 19', 247960),
(380052, 'PTHR12845:SF7', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 15', 247960),
(380053, 'PTHR12845:SF8', NULL, NULL, NULL, NULL, 'EPHEXIN-1', 247960),
(380054, 'PTHR18911:SF5', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 186', 247961),
(380055, 'PTHR18911', NULL, NULL, NULL, NULL, 'CTCL TUMOR ANTIGEN HD-CL-01', 247961),
(380056, 'PTHR23139:SF120', NULL, NULL, NULL, NULL, 'U2 SNRNP AUXILIARY FACTOR LARGE SUBUNIT', 247962),
(380057, 'PTHR23139', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN', 247962),
(380058, 'PTHR23139:SF124', NULL, NULL, NULL, NULL, 'SPLICING FACTOR U2AF LARGE SUBUNIT B', 247962),
(380059, 'PTHR23139:SF114', NULL, NULL, NULL, NULL, 'SPLICING FACTOR U2AF LARGE SUBUNIT B', 247962),
(380060, 'PTHR23139:SF125', NULL, NULL, NULL, NULL, '', 247962),
(380061, 'PTHR23139:SF9', NULL, NULL, NULL, NULL, 'SPLICING FACTOR U2AF 65 KDA SUBUNIT', 247962),
(380062, 'PTHR23139:SF56', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 247962),
(380063, 'PTHR23139:SF126', NULL, NULL, NULL, NULL, 'U2 SNRNP AUXILIARY FACTOR LARGE SUBUNIT', 247962),
(380064, 'PTHR23139:SF115', NULL, NULL, NULL, NULL, 'U2 SNRNP AUXILIARY FACTOR LARGE SUBUNIT', 247962),
(380065, 'PTHR23139:SF105', NULL, NULL, NULL, NULL, 'SPLICING FACTOR U2AF LARGE SUBUNIT A', 247962),
(380066, 'PTHR23139:SF127', NULL, NULL, NULL, NULL, '', 247962),
(380067, 'PTHR23139:SF116', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 247962),
(380068, 'PTHR23139:SF128', NULL, NULL, NULL, NULL, 'U2 SNRNP AUXILIARY FACTOR LARGE SUBUNIT', 247962),
(380069, 'PTHR23139:SF118', NULL, NULL, NULL, NULL, 'U2 SNRNP AUXILIARY FACTOR LARGE SUBUNIT', 247962),
(380070, 'PTHR23139:SF129', NULL, NULL, NULL, NULL, 'SPLICING FACTOR U2AF LARGE SUBUNIT A', 247962),
(380071, 'PTHR23139:SF108', NULL, NULL, NULL, NULL, 'SPLICING FACTOR U2AF LARGE SUBUNIT A-LIKE ISOFORM X1', 247962),
(380072, 'PTHR46838', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 14', 247963),
(380073, 'PTHR46838:SF2', NULL, NULL, NULL, NULL, 'SI:CH211-261N11.8', 247963),
(380074, 'PTHR46838:SF1', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 14', 247963),
(380075, 'PTHR31723:SF4', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED FAMILY PROTEIN', 247964),
(380076, 'PTHR31723:SF8', NULL, NULL, NULL, NULL, 'PATHOGEN-RELATED PROTEIN-LIKE', 247964),
(380077, 'PTHR31723:SF12', NULL, NULL, NULL, NULL, 'PATHOGEN-RELATED PROTEIN-LIKE ISOFORM X1', 247964),
(380078, 'PTHR31723', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED FAMILY PROTEIN', 247964),
(380079, 'PTHR31723:SF7', NULL, NULL, NULL, NULL, 'NTF2-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 247964),
(380080, 'PTHR31723:SF5', NULL, NULL, NULL, NULL, 'OS01G0248500 PROTEIN', 247964),
(380081, 'PTHR31723:SF10', NULL, NULL, NULL, NULL, 'PATHOGEN-RELATED PROTEIN-LIKE', 247964),
(380082, 'PTHR31723:SF9', NULL, NULL, NULL, NULL, '', 247964),
(380083, 'PTHR47950:SF18', NULL, NULL, NULL, NULL, '3''-HYDROXYLASE ISOZYME, PUTATIVE-RELATED', 247965),
(380084, 'PTHR47950:SF39', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 247965),
(380085, 'PTHR47950', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 76, SUBFAMILY C, POLYPEPTIDE 5-RELATED', 247965),
(380086, 'PTHR47950:SF30', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 247965); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(380087, 'PTHR47950:SF32', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 76 SUBFAMILY C POLYPEPTIDE 7', 247965),
(380088, 'PTHR47950:SF10', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 98A8', 247965),
(380089, 'PTHR47950:SF31', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 76A1-LIKE', 247965),
(380090, 'PTHR47950:SF12', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 247965),
(380091, 'PTHR47950:SF34', NULL, NULL, NULL, NULL, 'P450, PUTATIVE-RELATED', 247965),
(380092, 'PTHR47950:SF11', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN, EXPRESSED', 247965),
(380093, 'PTHR47950:SF33', NULL, NULL, NULL, NULL, '', 247965),
(380094, 'PTHR47950:SF36', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 76A2-LIKE', 247965),
(380095, 'PTHR47950:SF14', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 247965),
(380096, 'PTHR47950:SF13', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 76, SUBFAMILY G, POLYPEPTIDE 1', 247965),
(380097, 'PTHR47950:SF35', NULL, NULL, NULL, NULL, 'OS06G0294600 PROTEIN', 247965),
(380098, 'PTHR47950:SF16', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 247965),
(380099, 'PTHR47950:SF38', NULL, NULL, NULL, NULL, 'P450, PUTATIVE-RELATED', 247965),
(380100, 'PTHR47950:SF15', NULL, NULL, NULL, NULL, 'P450, PUTATIVE-RELATED', 247965),
(380101, 'PTHR47950:SF37', NULL, NULL, NULL, NULL, '', 247965),
(380102, 'PTHR47950:SF29', NULL, NULL, NULL, NULL, 'GERANIOL 8-HYDROXYLASE-LIKE', 247965),
(380103, 'PTHR47950:SF28', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY MONOOXYGENASE', 247965),
(380104, 'PTHR47950:SF41', NULL, NULL, NULL, NULL, '(S)-N-METHYLCOCLAURINE 3''-HYDROXYLASE ISOZYME 2-RELATED', 247965),
(380105, 'PTHR47950:SF40', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 76C4', 247965),
(380106, 'PTHR47950:SF4', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 76, SUBFAMILY C, POLYPEPTIDE 5-RELATED', 247965),
(380107, 'PTHR47950:SF23', NULL, NULL, NULL, NULL, 'GERANIOL 8-HYDROXYLASE-LIKE', 247965),
(380108, 'PTHR47950:SF22', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 76C1-RELATED', 247965),
(380109, 'PTHR47950:SF6', NULL, NULL, NULL, NULL, '3''-HYDROXYLASE ISOZYME, PUTATIVE-RELATED', 247965),
(380110, 'PTHR47950:SF25', NULL, NULL, NULL, NULL, '', 247965),
(380111, 'PTHR47950:SF24', NULL, NULL, NULL, NULL, '', 247965),
(380112, 'PTHR47950:SF7', NULL, NULL, NULL, NULL, 'OS12G0196700 PROTEIN', 247965),
(380113, 'PTHR47950:SF27', NULL, NULL, NULL, NULL, '', 247965),
(380114, 'PTHR47950:SF9', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 76A1-LIKE', 247965),
(380115, 'PTHR47950:SF26', NULL, NULL, NULL, NULL, '', 247965),
(380116, 'PTHR33387:SF3', NULL, NULL, NULL, NULL, 'CUPIN_5 DOMAIN-CONTAINING PROTEIN', 247966),
(380117, 'PTHR33387', NULL, NULL, NULL, NULL, 'RMLC-LIKE JELLY ROLL FOLD PROTEIN', 247966),
(380118, 'PTHR33387:SF5', NULL, NULL, NULL, NULL, 'OS06G0198500 PROTEIN', 247966),
(380119, 'PTHR24114:SF41', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 247967),
(380120, 'PTHR24114:SF31', NULL, NULL, NULL, NULL, 'NLR FAMILY MEMBER X1', 247967),
(380121, 'PTHR24114', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT FAMILY PROTEIN', 247967),
(380122, 'PTHR24114:SF45', NULL, NULL, NULL, NULL, '', 247967),
(380123, 'PTHR24114:SF46', NULL, NULL, NULL, NULL, '', 247967),
(380124, 'PTHR24114:SF22', NULL, NULL, NULL, NULL, '', 247967),
(380125, 'PTHR24114:SF47', NULL, NULL, NULL, NULL, '', 247967),
(380126, 'PTHR24114:SF2', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 74A', 247967),
(380127, 'PTHR24114:SF37', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 74B', 247967),
(380128, 'PTHR24114:SF48', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 247967),
(380129, 'PTHR45638:SF20', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED CHANNEL SUBUNIT ALPHA 1A', 247968),
(380130, 'PTHR45638', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED CATION CHANNEL SUBUNIT A', 247968),
(380131, 'PTHR45638:SF3', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED OLFACTORY CHANNEL', 247968),
(380132, 'PTHR45638:SF4', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 247968);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(380133, 'PTHR45638:SF1', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL SUBUNIT B, ISOFORM A', 247968),
(380134, 'PTHR45638:SF2', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED CATION CHANNEL ALPHA-4', 247968),
(380135, 'PTHR45638:SF7', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL-LIKE, ISOFORM E', 247968),
(380136, 'PTHR45638:SF8', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED CATION CHANNEL BETA-3', 247968),
(380137, 'PTHR45638:SF5', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 247968),
(380138, 'PTHR45638:SF19', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED POTASSIUM CHANNEL', 247968),
(380139, 'PTHR45638:SF6', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED CATION CHANNEL ALPHA-3', 247968),
(380140, 'PTHR45638:SF16', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED CATION CHANNEL BETA-1', 247968),
(380141, 'PTHR45638:SF15', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 247968),
(380142, 'PTHR45638:SF9', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED CHANNEL ROD PHOTORECEPTOR SUBUNIT ALPHA', 247968),
(380143, 'PTHR45638:SF14', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 247968),
(380144, 'PTHR45638:SF13', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 247968),
(380145, 'PTHR45638:SF24', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_2G03170)', 247968),
(380146, 'PTHR45638:SF23', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED CHANNEL SUBUNIT BETA 3, TANDEM DUPLICATE 2', 247968),
(380147, 'PTHR45638:SF11', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED CATION CHANNEL SUBUNIT A', 247968),
(380148, 'PTHR45638:SF10', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-BINDING DOMAIN-CONTAINING PROTEIN', 247968),
(380149, 'PTHR21514', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247969),
(380150, 'PTHR21514:SF0', NULL, NULL, NULL, NULL, 'AP-4 COMPLEX ACCESSORY SUBUNIT TEPSIN', 247969),
(380151, 'PTHR21514:SF1', NULL, NULL, NULL, NULL, 'OS01G0232400 PROTEIN', 247969),
(380152, 'PTHR34529', NULL, NULL, NULL, NULL, 'AP-1 COMPLEX-ASSOCIATED REGULATORY PROTEIN', 247970),
(380153, 'PTHR34529:SF1', NULL, NULL, NULL, NULL, 'AP-1 COMPLEX-ASSOCIATED REGULATORY PROTEIN', 247970),
(380154, 'PTHR13235:SF2', NULL, NULL, NULL, NULL, 'SINGLE-STRAND SELECTIVE MONOFUNCTIONAL URACIL DNA GLYCOSYLASE', 247971),
(380155, 'PTHR13235', NULL, NULL, NULL, NULL, 'SINGLE-STRAND SELECTIVE MONOFUNCTIONAL URACIL DNA GLYCOSYLASE', 247971),
(380156, 'PTHR37385', NULL, NULL, NULL, NULL, 'PROTEIN LOW PSII ACCUMULATION 2, CHLOROPLASTIC', 247972),
(380157, 'PTHR37385:SF2', NULL, NULL, NULL, NULL, 'PROTEIN LPA2', 247972),
(380158, 'PTHR31883:SF7', NULL, NULL, NULL, NULL, 'PROTEIN FRG2-RELATED', 247973),
(380159, 'PTHR31883:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FRG2-LIKE-2', 247973),
(380160, 'PTHR31883', NULL, NULL, NULL, NULL, 'PROTEIN FRG2-RELATED', 247973),
(380161, 'PTHR34997:SF10', NULL, NULL, NULL, NULL, 'LYSM DOMAIN-CONTAINING PROTEIN', 247974),
(380162, 'PTHR34997', NULL, NULL, NULL, NULL, 'AM15', 247974),
(380163, 'PTHR34997:SF1', NULL, NULL, NULL, NULL, 'LYSM DOMAIN-CONTAINING PROTEIN-RELATED', 247974),
(380164, 'PTHR34997:SF2', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE-RELATED', 247974),
(380165, 'PTHR34997:SF20', NULL, NULL, NULL, NULL, 'LYSM DOMAIN-CONTAINING PROTEIN', 247974),
(380166, 'PTHR34997:SF19', NULL, NULL, NULL, NULL, 'LYSM DOMAIN-CONTAINING PROTEIN', 247974),
(380167, 'PTHR34997:SF18', NULL, NULL, NULL, NULL, 'LYSM DOMAIN-CONTAINING PROTEIN', 247974),
(380168, 'PTHR34997:SF8', NULL, NULL, NULL, NULL, 'LYSM DOMAIN PROTEIN', 247974),
(380169, 'PTHR34997:SF17', NULL, NULL, NULL, NULL, 'LYSM DOMAIN-CONTAINING PROTEIN', 247974),
(380170, 'PTHR34997:SF16', NULL, NULL, NULL, NULL, '', 247974),
(380171, 'PTHR10855:SF1', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 12', 247975),
(380172, 'PTHR10855', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 12/COP9 SIGNALOSOME COMPLEX SUBUNIT 4', 247975);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(380173, 'PTHR10855:SF4', NULL, NULL, NULL, NULL, 'PCI DOMAIN-CONTAINING PROTEIN', 247975),
(380174, 'PTHR10855:SF2', NULL, NULL, NULL, NULL, 'COP9 SIGNALOSOME COMPLEX SUBUNIT 4', 247975),
(380175, 'PTHR10855:SF10', NULL, NULL, NULL, NULL, 'PCI DOMAIN-CONTAINING PROTEIN', 247975),
(380176, 'PTHR10855:SF9', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 12 HOMOLOG A-LIKE', 247975),
(380177, 'PTHR10855:SF7', NULL, NULL, NULL, NULL, 'PCI DOMAIN-CONTAINING PROTEIN', 247975),
(380178, 'PTHR45274:SF2', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 247976),
(380179, 'PTHR45274:SF3', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', 247976),
(380180, 'PTHR45274', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 247976),
(380181, 'PTHR42073:SF1', NULL, NULL, NULL, NULL, 'MEIOTIC EXPRESSION UP-REGULATED PROTEIN 6', 247977),
(380182, 'PTHR42073', NULL, NULL, NULL, NULL, 'MEIOTIC EXPRESSION UP-REGULATED PROTEIN 6', 247977),
(380183, 'PTHR46167:SF1', NULL, NULL, NULL, NULL, 'N-LYSINE METHYLTRANSFERASE KMT5A', 247978),
(380184, 'PTHR46167', NULL, NULL, NULL, NULL, 'N-LYSINE METHYLTRANSFERASE KMT5A', 247978),
(380185, 'PTHR47684:SF1', NULL, NULL, NULL, NULL, 'PROTEIN TONSOKU', 247979),
(380186, 'PTHR47684', NULL, NULL, NULL, NULL, 'PROTEIN TONSOKU', 247979),
(380187, 'PTHR42057', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_4G00200)', 247980),
(380188, 'PTHR42057:SF2', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_4G00200)-RELATED', 247980),
(380189, 'PTHR23166:SF5', NULL, NULL, NULL, NULL, 'CTTNBP2 N-TERMINAL-LIKE PROTEIN', 247981),
(380190, 'PTHR23166:SF3', NULL, NULL, NULL, NULL, 'FILAMIN-A-INTERACTING PROTEIN 1', 247981),
(380191, 'PTHR23166:SF4', NULL, NULL, NULL, NULL, 'FILAMIN A-INTERACTING PROTEIN 1-LIKE', 247981),
(380192, 'PTHR23166:SF9', NULL, NULL, NULL, NULL, 'CTTNBP2 N-TERMINAL-LIKE PROTEIN', 247981),
(380193, 'PTHR23166:SF7', NULL, NULL, NULL, NULL, 'LEUCINE ZIPPER PROTEIN 1', 247981),
(380194, 'PTHR23166', NULL, NULL, NULL, NULL, 'FILAMIN/GPBP-INTERACTING PROTEIN', 247981),
(380195, 'PTHR44042', NULL, NULL, NULL, NULL, 'DUPLICATED HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN-RELATED', 247982),
(380196, 'PTHR44042:SF26', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR DIVARICATA-LIKE', 247982),
(380197, 'PTHR44042:SF48', NULL, NULL, NULL, NULL, 'BNAA04G21820D PROTEIN', 247982),
(380198, 'PTHR44042:SF28', NULL, NULL, NULL, NULL, 'DUPLICATED HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN', 247982),
(380199, 'PTHR44042:SF49', NULL, NULL, NULL, NULL, 'MYB DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 247982),
(380200, 'PTHR44042:SF44', NULL, NULL, NULL, NULL, 'MYB DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 247982),
(380201, 'PTHR44042:SF22', NULL, NULL, NULL, NULL, 'SANT DOMAIN-CONTAINING PROTEIN', 247982),
(380202, 'PTHR44042:SF43', NULL, NULL, NULL, NULL, 'BNAANNG39140D PROTEIN', 247982),
(380203, 'PTHR44042:SF24', NULL, NULL, NULL, NULL, 'GID2 PROTEIN ISOFORM 1', 247982),
(380204, 'PTHR44042:SF6', NULL, NULL, NULL, NULL, 'DUPLICATED HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN', 247982),
(380205, 'PTHR44042:SF23', NULL, NULL, NULL, NULL, 'OS01G0863300 PROTEIN', 247982),
(380206, 'PTHR44042:SF62', NULL, NULL, NULL, NULL, 'OS02G0511200 PROTEIN', 247982),
(380207, 'PTHR44042:SF61', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 247982),
(380208, 'PTHR44042:SF64', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR DIVARICATA-LIKE', 247982),
(380209, 'PTHR44042:SF42', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 247982),
(380210, 'PTHR44042:SF41', NULL, NULL, NULL, NULL, 'DUPLICATED HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN-RELATED', 247982),
(380211, 'PTHR44042:SF63', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR DIVARICATA-LIKE', 247982),
(380212, 'PTHR44042:SF60', NULL, NULL, NULL, NULL, '', 247982),
(380213, 'PTHR44042:SF19', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 247982),
(380214, 'PTHR44042:SF15', NULL, NULL, NULL, NULL, 'MYB-LIKE PROTEIN I', 247982);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(380215, 'PTHR44042:SF59', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 247982),
(380216, 'PTHR44042:SF37', NULL, NULL, NULL, NULL, 'OS05G0442400 PROTEIN', 247982),
(380217, 'PTHR44042:SF36', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 247982),
(380218, 'PTHR44042:SF58', NULL, NULL, NULL, NULL, 'DUPLICATED HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN', 247982),
(380219, 'PTHR44042:SF39', NULL, NULL, NULL, NULL, 'MYB DOMAIN, PLANT, HOMEODOMAIN-LIKE PROTEIN-RELATED', 247982),
(380220, 'PTHR44042:SF17', NULL, NULL, NULL, NULL, 'MYB DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 247982),
(380221, 'PTHR44042:SF11', NULL, NULL, NULL, NULL, 'OS06G0173800 PROTEIN', 247982),
(380222, 'PTHR44042:SF32', NULL, NULL, NULL, NULL, 'MYB DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 247982),
(380223, 'PTHR44042:SF54', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 247982),
(380224, 'PTHR44042:SF35', NULL, NULL, NULL, NULL, 'BNAA01G31080D PROTEIN', 247982),
(380225, 'PTHR44042:SF57', NULL, NULL, NULL, NULL, 'MYB-RELATED TRANSCRIPTION FACTOR', 247982),
(380226, 'PTHR44042:SF34', NULL, NULL, NULL, NULL, 'BNAC03G21050D PROTEIN', 247982),
(380227, 'PTHR44042:SF51', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 247982),
(380228, 'PTHR44042:SF53', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR MYB51', 247982),
(380229, 'PTHR44042:SF30', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 247982),
(380230, 'PTHR21597:SF3', NULL, NULL, NULL, NULL, '', 247983),
(380231, 'PTHR21597:SF0', NULL, NULL, NULL, NULL, 'THO COMPLEX SUBUNIT 2', 247983),
(380232, 'PTHR21597:SF2', NULL, NULL, NULL, NULL, 'THO COMPLEX SUBUNIT 2', 247983),
(380233, 'PTHR21597:SF1', NULL, NULL, NULL, NULL, 'THO COMPLEX SUBUNIT 2', 247983),
(380234, 'PTHR21597', NULL, NULL, NULL, NULL, 'THO2 PROTEIN', 247983),
(380235, 'PTHR31037', NULL, NULL, NULL, NULL, 'RELT-LIKE PROTEIN 1-RELATED', 247984),
(380236, 'PTHR31037:SF2', NULL, NULL, NULL, NULL, 'TNFR-CYS DOMAIN-CONTAINING PROTEIN', 247984),
(380237, 'PTHR31037:SF1', NULL, NULL, NULL, NULL, 'RELT-LIKE PROTEIN 1', 247984),
(380238, 'PTHR32120', NULL, NULL, NULL, NULL, 'SMALL RIBOSOMAL SUBUNIT BIOGENESIS GTPASE RSGA', 247985),
(380239, 'PTHR32120:SF10', NULL, NULL, NULL, NULL, 'SMALL RIBOSOMAL SUBUNIT BIOGENESIS GTPASE RSGA', 247985),
(380240, 'PTHR32120:SF11', NULL, NULL, NULL, NULL, 'SMALL RIBOSOMAL SUBUNIT BIOGENESIS GTPASE RSGA 1, MITOCHONDRIAL-RELATED', 247985),
(380241, 'PTHR44086:SF4', NULL, NULL, NULL, NULL, 'RHODANESE DOMAIN-CONTAINING PROTEIN', 247986),
(380242, 'PTHR44086:SF3', NULL, NULL, NULL, NULL, 'RHODANESE DOMAIN-CONTAINING PROTEIN-RELATED', 247986),
(380243, 'PTHR44086:SF10', NULL, NULL, NULL, NULL, 'THIOSULFATE SULFURTRANSFERASE/RHODANESE-LIKE DOMAIN-CONTAINING PROTEIN 3', 247986),
(380244, 'PTHR44086:SF13', NULL, NULL, NULL, NULL, 'EXPORTED PROTEIN-RELATED', 247986),
(380245, 'PTHR44086:SF15', NULL, NULL, NULL, NULL, 'FED TICK SALIVARY PROTEIN 7', 247986),
(380246, 'PTHR44086', NULL, NULL, NULL, NULL, 'THIOSULFATE SULFURTRANSFERASE RDL2, MITOCHONDRIAL-RELATED', 247986),
(380247, 'PTHR44086:SF14', NULL, NULL, NULL, NULL, 'THIOSULFATE SULFURTRANSFERASE/RHODANESE-LIKE DOMAIN-CONTAINING PROTEIN 1', 247986),
(380248, 'PTHR44086:SF9', NULL, NULL, NULL, NULL, 'RHODANESE DOMAIN-CONTAINING PROTEIN', 247986),
(380249, 'PTHR44086:SF8', NULL, NULL, NULL, NULL, 'RHODANESE DOMAIN-CONTAINING PROTEIN', 247986),
(380250, 'PTHR44086:SF5', NULL, NULL, NULL, NULL, 'RHODANESE DOMAIN-CONTAINING PROTEIN', 247986),
(380251, 'PTHR28474', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 72', 247987),
(380252, 'PTHR28474:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 72', 247987),
(380253, 'PTHR47514:SF2', NULL, NULL, NULL, NULL, 'TRANSKETOLASE', 247988),
(380254, 'PTHR47514:SF1', NULL, NULL, NULL, NULL, 'TRANSKETOLASE N-TERMINAL SECTION-RELATED', 247988),
(380255, 'PTHR47514', NULL, NULL, NULL, NULL, 'TRANSKETOLASE N-TERMINAL SECTION-RELATED', 247988),
(380256, 'PTHR46083:SF1', NULL, NULL, NULL, NULL, 'GLYCOGEN SYNTHASE 1', 247989),
(380257, 'PTHR46083', NULL, NULL, NULL, NULL, '', 247989);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(380258, 'PTHR46083:SF9', NULL, NULL, NULL, NULL, 'STARCH SYNTHASE, CHLOROPLASTIC/AMYLOPLASTIC', 247989),
(380259, 'PTHR46083:SF7', NULL, NULL, NULL, NULL, 'OS04G0624600 PROTEIN', 247989),
(380260, 'PTHR46083:SF5', NULL, NULL, NULL, NULL, 'STARCH SYNTHASE 3, CHLOROPLASTIC/AMYLOPLASTIC', 247989),
(380261, 'PTHR46083:SF3', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE SUPERFAMILY PROTEIN', 247989),
(380262, 'PTHR46083:SF2', NULL, NULL, NULL, NULL, 'STARCH SYNTHASE 4, CHLOROPLASTIC/AMYLOPLASTIC-RELATED', 247989),
(380263, 'PTHR11690:SF184', NULL, NULL, NULL, NULL, 'PICKPOCKET 31', 247990),
(380264, 'PTHR11690:SF261', NULL, NULL, NULL, NULL, 'DEGENERIN-LIKE PROTEIN DEL-10', 247990),
(380265, 'PTHR11690:SF179', NULL, NULL, NULL, NULL, 'PICKPOCKET 10', 247990),
(380266, 'PTHR11690:SF252', NULL, NULL, NULL, NULL, 'ACID-SENSING (PROTON-GATED) ION CHANNEL 1C', 247990),
(380267, 'PTHR11690:SF175', NULL, NULL, NULL, NULL, 'PICKPOCKET 13', 247990),
(380268, 'PTHR11690:SF177', NULL, NULL, NULL, NULL, 'EGF PLUS ASC DOMAIN ION CHANNEL', 247990),
(380269, 'PTHR11690:SF132', NULL, NULL, NULL, NULL, 'AMILORIDE-SENSITIVE SODIUM CHANNEL SUBUNIT DELTA', 247990),
(380270, 'PTHR11690:SF253', NULL, NULL, NULL, NULL, 'PICKPOCKET 18-RELATED', 247990),
(380271, 'PTHR11690:SF267', NULL, NULL, NULL, NULL, 'DEGENERIN MEC-10', 247990),
(380272, 'PTHR11690:SF222', NULL, NULL, NULL, NULL, 'PROTEIN CBG11983', 247990),
(380273, 'PTHR11690:SF269', NULL, NULL, NULL, NULL, 'DEGENERIN-LIKE PROTEIN ASIC-2', 247990),
(380274, 'PTHR11690:SF263', NULL, NULL, NULL, NULL, 'PICKPOCKET 6-RELATED', 247990),
(380275, 'PTHR11690:SF227', NULL, NULL, NULL, NULL, 'DEGENERIN LIKE', 247990),
(380276, 'PTHR11690:SF228', NULL, NULL, NULL, NULL, 'ACID-SENSING ION CHANNEL 3', 247990),
(380277, 'PTHR11690:SF13', NULL, NULL, NULL, NULL, 'ACID-SENSING ION CHANNEL 4', 247990),
(380278, 'PTHR11690:SF18', NULL, NULL, NULL, NULL, 'AMILORIDE-SENSITIVE SODIUM CHANNEL SUBUNIT BETA', 247990),
(380279, 'PTHR11690:SF19', NULL, NULL, NULL, NULL, 'AMILORIDE-SENSITIVE SODIUM CHANNEL SUBUNIT GAMMA', 247990),
(380280, 'PTHR11690:SF281', NULL, NULL, NULL, NULL, '', 247990),
(380281, 'PTHR11690:SF283', NULL, NULL, NULL, NULL, 'KRINGLE DOMAIN-CONTAINING PROTEIN', 247990),
(380282, 'PTHR11690:SF282', NULL, NULL, NULL, NULL, 'DEGENERIN-LIKE PROTEIN ASIC-1', 247990),
(380283, 'PTHR11690:SF157', NULL, NULL, NULL, NULL, 'PICKPOCKET 15-RELATED', 247990),
(380284, 'PTHR11690:SF277', NULL, NULL, NULL, NULL, 'DEGENERIN-RELATED TOUCH-INVOLVED CHANNEL', 247990),
(380285, 'PTHR11690:SF279', NULL, NULL, NULL, NULL, 'DEGENERIN-LIKE PROTEIN UNC-105', 247990),
(380286, 'PTHR11690:SF153', NULL, NULL, NULL, NULL, 'DEGENERIN LIKE', 247990),
(380287, 'PTHR11690:SF273', NULL, NULL, NULL, NULL, 'DEGENERIN LINKED TO MECHANOSENSATION', 247990),
(380288, 'PTHR11690:SF152', NULL, NULL, NULL, NULL, 'PROTEIN CBG04873', 247990),
(380289, 'PTHR11690:SF276', NULL, NULL, NULL, NULL, 'DEGENERIN DEG-1', 247990),
(380290, 'PTHR11690:SF232', NULL, NULL, NULL, NULL, 'DEGENERIN LIKE', 247990),
(380291, 'PTHR11690:SF275', NULL, NULL, NULL, NULL, 'DEGENERIN MEC-4', 247990),
(380292, 'PTHR11690:SF237', NULL, NULL, NULL, NULL, 'PICKPOCKET 16-RELATED', 247990),
(380293, 'PTHR11690:SF118', NULL, NULL, NULL, NULL, '', 247990),
(380294, 'PTHR11690', NULL, NULL, NULL, NULL, 'AMILORIDE-SENSITIVE SODIUM CHANNEL-RELATED', 247990),
(380295, 'PTHR11690:SF292', NULL, NULL, NULL, NULL, 'ACID-SENSING ION CHANNEL 1B', 247990),
(380296, 'PTHR11690:SF291', NULL, NULL, NULL, NULL, '', 247990),
(380297, 'PTHR11690:SF170', NULL, NULL, NULL, NULL, 'ACID-SENSING ION CHANNEL 1', 247990),
(380298, 'PTHR11690:SF293', NULL, NULL, NULL, NULL, '', 247990),
(380299, 'PTHR11690:SF290', NULL, NULL, NULL, NULL, 'PICKPOCKET PROTEIN 19', 247990),
(380300, 'PTHR11690:SF124', NULL, NULL, NULL, NULL, 'AMILORIDE-SENSITIVE SODIUM CHANNEL SUBUNIT ALPHA', 247990),
(380301, 'PTHR11690:SF289', NULL, NULL, NULL, NULL, '', 247990),
(380302, 'PTHR11690:SF288', NULL, NULL, NULL, NULL, 'AMILORIDE-SENSITIVE NA+ CHANNEL-RELATED', 247990),
(380303, 'PTHR11690:SF244', NULL, NULL, NULL, NULL, 'DEGENERIN LIKE', 247990);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(380304, 'PTHR11690:SF247', NULL, NULL, NULL, NULL, 'PICKPOCKET 23, ISOFORM C', 247990),
(380305, 'PTHR11690:SF285', NULL, NULL, NULL, NULL, 'PICKPOCKET 3', 247990),
(380306, 'PTHR11690:SF120', NULL, NULL, NULL, NULL, 'FLR-1', 247990),
(380307, 'PTHR11690:SF284', NULL, NULL, NULL, NULL, 'PROTEIN CBR-TAG-324', 247990),
(380308, 'PTHR11690:SF240', NULL, NULL, NULL, NULL, 'PICKPOCKET 25-RELATED', 247990),
(380309, 'PTHR11690:SF243', NULL, NULL, NULL, NULL, 'PICKPOCKET 12-RELATED', 247990),
(380310, 'PTHR11690:SF287', NULL, NULL, NULL, NULL, 'AMILORIDE-SENSITIVE SODIUM CHANNEL SUBUNIT GAMMA-2-LIKE', 247990),
(380311, 'PTHR11690:SF286', NULL, NULL, NULL, NULL, 'ACID-SENSING ION CHANNEL 5', 247990),
(380312, 'PTHR11690:SF242', NULL, NULL, NULL, NULL, 'DEGENERIN UNC-8', 247990),
(380313, 'PTHR11690:SF5', NULL, NULL, NULL, NULL, 'DEGENERIN LIKE', 247990),
(380314, 'PTHR11690:SF128', NULL, NULL, NULL, NULL, 'ACID-SENSING ION CHANNEL 2', 247990),
(380315, 'PTHR11690:SF248', NULL, NULL, NULL, NULL, 'PICKPOCKET 17, ISOFORM A', 247990),
(380316, 'PTHR11690:SF1', NULL, NULL, NULL, NULL, 'DEGENERIN LIKE', 247990),
(380317, 'PTHR43198:SF6', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL TENA-E PROTEIN-RELATED', 247991),
(380318, 'PTHR43198:SF9', NULL, NULL, NULL, NULL, 'AMINOPYRIMIDINE AMINOHYDROLASE, MITOCHONDRIAL ISOFORM X1-RELATED', 247991),
(380319, 'PTHR43198:SF8', NULL, NULL, NULL, NULL, 'HEME OXYGENASE-LIKE, MULTI-HELICAL-RELATED', 247991),
(380320, 'PTHR43198:SF2', NULL, NULL, NULL, NULL, 'SI:CH1073-67J19.1-RELATED', 247991),
(380321, 'PTHR43198:SF5', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL TENA-E PROTEIN', 247991),
(380322, 'PTHR43198', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL TH2 PROTEIN', 247991),
(380323, 'PTHR40705', NULL, NULL, NULL, NULL, 'TRNA(ILE2) 2-AGMATINYLCYTIDINE SYNTHETASE TIAS', 247992),
(380324, 'PTHR40705:SF2', NULL, NULL, NULL, NULL, 'DUF1743 DOMAIN-CONTAINING PROTEIN', 247992),
(380325, 'PTHR40705:SF1', NULL, NULL, NULL, NULL, 'TRNA(ILE2) 2-AGMATINYLCYTIDINE SYNTHETASE TIAS', 247992),
(380326, 'PTHR36028:SF9', NULL, NULL, NULL, NULL, 'ATP SYNTHASE E CHAIN', 247993),
(380327, 'PTHR36028:SF6', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT E, MITOCHONDRIAL', 247993),
(380328, 'PTHR36028:SF7', NULL, NULL, NULL, NULL, 'BNAC09G42530D PROTEIN', 247993),
(380329, 'PTHR36028:SF2', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT E, MITOCHONDRIAL', 247993),
(380330, 'PTHR36028', NULL, NULL, NULL, NULL, 'OSJNBB0050O03.8 PROTEIN', 247993),
(380331, 'PTHR36028:SF3', NULL, NULL, NULL, NULL, '', 247993),
(380332, 'PTHR34810', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN BIN4', 247994),
(380333, 'PTHR34810:SF1', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN BIN4', 247994),
(380334, 'PTHR31514:SF1', NULL, NULL, NULL, NULL, 'MUSCULAR LMNA-INTERACTING PROTEIN', 247995),
(380335, 'PTHR31514', NULL, NULL, NULL, NULL, 'MUSCULAR LMNA-INTERACTING PROTEIN MLIP', 247995),
(380336, 'PTHR37217:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247996),
(380337, 'PTHR37217', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 247996),
(380338, 'PTHR11139:SF115', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE TOR', 247997),
(380339, 'PTHR11139:SF85', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247997),
(380340, 'PTHR11139:SF105', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247997),
(380341, 'PTHR11139:SF119', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SMG1', 247997),
(380342, 'PTHR11139:SF68', NULL, NULL, NULL, NULL, 'DNA-DEPENDENT PROTEIN KINASE CATALYTIC SUBUNIT', 247997),
(380343, 'PTHR11139:SF69', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE ATR', 247997),
(380344, 'PTHR11139:SF9', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE MTOR', 247997),
(380345, 'PTHR11139:SF1', NULL, NULL, NULL, NULL, 'TRANSFORMATION/TRANSCRIPTION DOMAIN-ASSOCIATED PROTEIN', 247997),
(380346, 'PTHR11139', NULL, NULL, NULL, NULL, 'ATAXIA TELANGIECTASIA MUTATED  ATM -RELATED', 247997),
(380347, 'PTHR11139:SF120', NULL, NULL, NULL, NULL, 'BNAA06G25470D PROTEIN', 247997);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(380348, 'PTHR11139:SF121', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 247997),
(380349, 'PTHR11139:SF122', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE TOR1', 247997),
(380350, 'PTHR11139:SF123', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE TOR', 247997),
(380351, 'PTHR11139:SF71', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SMG1', 247997),
(380352, 'PTHR11139:SF72', NULL, NULL, NULL, NULL, 'SERINE-PROTEIN KINASE ATM', 247997),
(380353, 'PTHR12360', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR, X-BOX BINDING 1  NFX1', 247998),
(380354, 'PTHR12360:SF14', NULL, NULL, NULL, NULL, 'BNAA09G48270D PROTEIN', 247998),
(380355, 'PTHR12360:SF1', NULL, NULL, NULL, NULL, 'NF-X1-TYPE ZINC FINGER PROTEIN NFXL1', 247998),
(380356, 'PTHR12360:SF12', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR NF-X1', 247998),
(380357, 'PTHR12360:SF13', NULL, NULL, NULL, NULL, 'NF-X1-TYPE ZINC FINGER PROTEIN NFXL1', 247998),
(380358, 'PTHR22527', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 247999),
(380359, 'PTHR22527:SF2', NULL, NULL, NULL, NULL, 'PLACENTA-EXPRESSED TRANSCRIPT 1 PROTEIN', 247999),
(380360, 'PTHR21604', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248000),
(380361, 'PTHR21604:SF0', NULL, NULL, NULL, NULL, 'RETROELEMENT SILENCING FACTOR 1', 248000),
(380362, 'PTHR46723', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND IQ DOMAIN-CONTAINING PROTEIN 3', 248001),
(380363, 'PTHR46723:SF1', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND IQ DOMAIN-CONTAINING PROTEIN 3', 248001),
(380364, 'PTHR47142', NULL, NULL, NULL, NULL, 'BETA-CATENIN-INTERACTING PROTEIN 1', 248002),
(380365, 'PTHR47142:SF1', NULL, NULL, NULL, NULL, 'BETA-CATENIN-INTERACTING PROTEIN 1', 248002),
(380366, 'PTHR46712', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLGLYCEROPHOSPHATASE AND PROTEIN-TYROSINE PHOSPHATASE 1', 248003),
(380367, 'PTHR46712:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLGLYCEROPHOSPHATASE AND PROTEIN-TYROSINE PHOSPHATASE 1', 248003),
(380368, 'PTHR35113:SF2', NULL, NULL, NULL, NULL, 'FERREDOXIN-THIOREDOXIN REDUCTASE CATALYTIC CHAIN, CHLOROPLASTIC', 248004),
(380369, 'PTHR35113:SF1', NULL, NULL, NULL, NULL, 'FERREDOXIN-THIOREDOXIN REDUCTASE CATALYTIC CHAIN, CHLOROPLASTIC', 248004),
(380370, 'PTHR35113', NULL, NULL, NULL, NULL, 'FERREDOXIN-THIOREDOXIN REDUCTASE CATALYTIC CHAIN, CHLOROPLASTIC', 248004),
(380371, 'PTHR15955:SF10', NULL, NULL, NULL, NULL, 'DUF1115 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_5G14750)', 248005),
(380372, 'PTHR15955:SF8', NULL, NULL, NULL, NULL, 'RWD DOMAIN-CONTAINING PROTEIN 2B-RELATED', 248005),
(380373, 'PTHR15955', NULL, NULL, NULL, NULL, 'RWD DOMAIN CONTAINING PROTEIN 2', 248005),
(380374, 'PTHR15955:SF3', NULL, NULL, NULL, NULL, 'RWD DOMAIN-CONTAINING PROTEIN 2A', 248005),
(380375, 'PTHR36077', NULL, NULL, NULL, NULL, 'BNAA02G07370D PROTEIN', 248006),
(380376, 'PTHR36077:SF1', NULL, NULL, NULL, NULL, 'BNAA02G07370D PROTEIN', 248006),
(380377, 'PTHR43356:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATE ACETYLTRANSFERASE EUTD', 248007),
(380378, 'PTHR43356:SF2', NULL, NULL, NULL, NULL, 'PHOSPHATE ACETYLTRANSFERASE', 248007),
(380379, 'PTHR43356:SF3', NULL, NULL, NULL, NULL, 'PHOSPHATE ACETYLTRANSFERASE', 248007),
(380380, 'PTHR43356', NULL, NULL, NULL, NULL, 'PHOSPHATE ACETYLTRANSFERASE', 248007),
(380381, 'PTHR15813:SF8', NULL, NULL, NULL, NULL, 'SORTING NEXIN-22', 248008),
(380382, 'PTHR15813:SF10', NULL, NULL, NULL, NULL, 'SORTING NEXIN-24', 248008),
(380383, 'PTHR15813:SF9', NULL, NULL, NULL, NULL, 'NEXIN-24, PUTATIVE-RELATED', 248008),
(380384, 'PTHR15813', NULL, NULL, NULL, NULL, 'SORTING NEXIN-22 AND 24', 248008),
(380385, 'PTHR33459:SF16', NULL, NULL, NULL, NULL, '', 248009),
(380386, 'PTHR33459:SF17', NULL, NULL, NULL, NULL, 'DD-GDCA PROTEIN', 248009),
(380387, 'PTHR33459:SF1', NULL, NULL, NULL, NULL, '', 248009),
(380388, 'PTHR33459:SF2', NULL, NULL, NULL, NULL, '', 248009),
(380389, 'PTHR33459:SF13', NULL, NULL, NULL, NULL, '', 248009),
(380390, 'PTHR33459:SF15', NULL, NULL, NULL, NULL, '', 248009),
(380391, 'PTHR33459:SF10', NULL, NULL, NULL, NULL, 'DICKKOPF_N DOMAIN-CONTAINING PROTEIN-RELATED', 248009);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(380392, 'PTHR33459:SF11', NULL, NULL, NULL, NULL, 'DIFFERENTIATION-ASSOCIATED PROTEIN 1', 248009),
(380393, 'PTHR33459', NULL, NULL, NULL, NULL, 'DD-GDCA PROTEIN', 248009),
(380394, 'PTHR33459:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG23037', 248009),
(380395, 'PTHR33459:SF8', NULL, NULL, NULL, NULL, '', 248009),
(380396, 'PTHR33459:SF6', NULL, NULL, NULL, NULL, '', 248009),
(380397, 'PTHR33459:SF4', NULL, NULL, NULL, NULL, 'DICKKOPF_N DOMAIN-CONTAINING PROTEIN', 248009),
(380398, 'PTHR43228:SF19', NULL, NULL, NULL, NULL, 'RESPONSE REGULATOR RECEIVER DOMAIN PROTEIN', 248010),
(380399, 'PTHR43228:SF18', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 248010),
(380400, 'PTHR43228:SF5', NULL, NULL, NULL, NULL, 'STAGE 0 SPORULATION PROTEIN A', 248010),
(380401, 'PTHR43228:SF17', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE RESPONSE REGULATOR AND TRANSCRIPTION FACTOR RR-A-TYPE FAMILY-RELATED', 248010),
(380402, 'PTHR43228', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR', 248010),
(380403, 'PTHR43228:SF6', NULL, NULL, NULL, NULL, 'RESPONSE REGULATOR RECEIVER', 248010),
(380404, 'PTHR43228:SF9', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 248010),
(380405, 'PTHR43228:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN GLNL', 248010),
(380406, 'PTHR43228:SF23', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ARR22-LIKE', 248010),
(380407, 'PTHR43228:SF12', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR 24', 248010),
(380408, 'PTHR43228:SF22', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE/RESPONSE REGULATOR HYBRID PROTEIN', 248010),
(380409, 'PTHR43228:SF21', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ORR41', 248010),
(380410, 'PTHR43228:SF20', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 248010),
(380411, 'PTHR43228:SF1', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ARR22', 248010),
(380412, 'PTHR31496:SF6', NULL, NULL, NULL, NULL, 'MYB-LIKE DNA-BINDING DOMAIN, SHAQKYF CLASS FAMILY PROTEIN, EXPRESSED', 248011),
(380413, 'PTHR31496:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR KAN1', 248011),
(380414, 'PTHR31496:SF19', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR KAN1-LIKE', 248011),
(380415, 'PTHR31496:SF49', NULL, NULL, NULL, NULL, 'SANT DOMAIN-CONTAINING PROTEIN', 248011),
(380416, 'PTHR31496:SF48', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR KAN2-RELATED', 248011),
(380417, 'PTHR31496:SF18', NULL, NULL, NULL, NULL, 'OS02G0696900 PROTEIN', 248011),
(380418, 'PTHR31496:SF28', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR KAN4-RELATED', 248011),
(380419, 'PTHR31496:SF45', NULL, NULL, NULL, NULL, 'SANT DOMAIN-CONTAINING PROTEIN', 248011),
(380420, 'PTHR31496:SF23', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR KAN3-RELATED', 248011),
(380421, 'PTHR31496:SF55', NULL, NULL, NULL, NULL, 'OS08G0426866 PROTEIN', 248011),
(380422, 'PTHR31496:SF33', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR RL9-RELATED', 248011),
(380423, 'PTHR31496:SF47', NULL, NULL, NULL, NULL, 'SANT DOMAIN-CONTAINING PROTEIN', 248011),
(380424, 'PTHR31496:SF25', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR KAN4-RELATED', 248011),
(380425, 'PTHR31496:SF46', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR KAN2 ISOFORM X1-RELATED', 248011),
(380426, 'PTHR31496:SF52', NULL, NULL, NULL, NULL, 'SANT DOMAIN-CONTAINING PROTEIN', 248011),
(380427, 'PTHR31496:SF41', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR KAN1-LIKE ISOFORM X1', 248011),
(380428, 'PTHR31496:SF51', NULL, NULL, NULL, NULL, 'G2-LIKE-TRANSCRIPTION FACTOR50', 248011),
(380429, 'PTHR31496:SF54', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB-HB-LIKE FAMILY-RELATED', 248011),
(380430, 'PTHR31496:SF43', NULL, NULL, NULL, NULL, 'SANT DOMAIN-CONTAINING PROTEIN', 248011),
(380431, 'PTHR31496:SF53', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR KAN1-LIKE ISOFORM X1', 248011),
(380432, 'PTHR31496', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR KAN2-RELATED', 248011),
(380433, 'PTHR31496:SF50', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR', 248011);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(380434, 'PTHR44163', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RNA-ASSOCIATED PROTEIN 4 HOMOLOG', 248012),
(380435, 'PTHR44163:SF1', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RNA-ASSOCIATED PROTEIN 4 HOMOLOG', 248012),
(380436, 'PTHR44662:SF1', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 81', 248013),
(380437, 'PTHR44662', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 81', 248013),
(380438, 'PTHR47903', NULL, NULL, NULL, NULL, 'OS07G0636400 PROTEIN', 248014),
(380439, 'PTHR47903:SF2', NULL, NULL, NULL, NULL, 'OS07G0636400 PROTEIN', 248014),
(380440, 'PTHR10468:SF6', NULL, NULL, NULL, NULL, 'GLCNAC TRANSFERASE', 248015),
(380441, 'PTHR10468', NULL, NULL, NULL, NULL, 'PROTEIN O-LINKED-MANNOSE BETA-1,2-N-ACETYLGLUCOSAMINYLTRANSFERASE 1/ALPHA-1,3-MANNOSYL-GLYCOPROTEIN 2-BETA-N-ACETYLGLUCOSAMINYLTRANSFERASE', 248015),
(380442, 'PTHR10468:SF0', NULL, NULL, NULL, NULL, 'ALPHA-1,3-MANNOSYL-GLYCOPROTEIN 2-BETA-N-ACETYLGLUCOSAMINYLTRANSFERASE', 248015),
(380443, 'PTHR10468:SF10', NULL, NULL, NULL, NULL, 'ALPHA-1,3-MANNOSYL-GLYCOPROTEIN 2-BETA-N-ACETYLGLUCOSAMINYLTRANSFERASE-RELATED', 248015),
(380444, 'PTHR10468:SF3', NULL, NULL, NULL, NULL, 'GLYCOSYLATION RELATED', 248015),
(380445, 'PTHR32014:SF2', NULL, NULL, NULL, NULL, 'BCL-2-MODIFYING FACTOR', 248016),
(380446, 'PTHR32014:SF3', NULL, NULL, NULL, NULL, 'BCL2-MODIFYING FACTOR 2', 248016),
(380447, 'PTHR32014', NULL, NULL, NULL, NULL, 'BCL-2-MODIFYING FACTOR', 248016),
(380448, 'PTHR39465', NULL, NULL, NULL, NULL, 'DNA LIGASE D, 3''-PHOSPHOESTERASE DOMAIN', 248017),
(380449, 'PTHR39465:SF1', NULL, NULL, NULL, NULL, 'LIGD_N DOMAIN-CONTAINING PROTEIN', 248017),
(380450, 'PTHR47921:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG14850', 248018),
(380451, 'PTHR47921:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG25653', 248018),
(380452, 'PTHR47921:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG04898', 248018),
(380453, 'PTHR47921:SF1', NULL, NULL, NULL, NULL, '', 248018),
(380454, 'PTHR47921', NULL, NULL, NULL, NULL, 'PROTEIN CBG14847-RELATED', 248018),
(380455, 'PTHR11568', NULL, NULL, NULL, NULL, 'HEPATOCYTE NUCLEAR FACTOR 1', 248019),
(380456, 'PTHR11568:SF1', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 248019),
(380457, 'PTHR11568:SF2', NULL, NULL, NULL, NULL, 'HEPATOCYTE NUCLEAR FACTOR 1-BETA', 248019),
(380458, 'PTHR11568:SF4', NULL, NULL, NULL, NULL, 'HEPATOCYTE NUCLEAR FACTOR 1-ALPHA', 248019),
(380459, 'PTHR15744', NULL, NULL, NULL, NULL, 'BLOM7', 248020),
(380460, 'PTHR15744:SF3', NULL, NULL, NULL, NULL, 'BNAA05G13040D PROTEIN', 248020),
(380461, 'PTHR15744:SF2', NULL, NULL, NULL, NULL, 'BRINGS LOTS OF MONEY 7', 248020),
(380462, 'PTHR15744:SF1', NULL, NULL, NULL, NULL, 'KH HOMOLOGY DOMAIN-CONTAINING PROTEIN 4', 248020),
(380463, 'PTHR15744:SF0', NULL, NULL, NULL, NULL, 'KH HOMOLOGY DOMAIN-CONTAINING PROTEIN 4', 248020),
(380464, 'PTHR10783:SF120', NULL, NULL, NULL, NULL, 'BNAA09G02520D PROTEIN', 248021),
(380465, 'PTHR10783:SF102', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER PHO1-1', 248021),
(380466, 'PTHR10783:SF124', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER PHO1 HOMOLOG 9', 248021),
(380467, 'PTHR10783:SF100', NULL, NULL, NULL, NULL, 'EXS DOMAIN-CONTAINING PROTEIN', 248021),
(380468, 'PTHR10783:SF122', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER PHO1-LIKE PROTEIN 9', 248021),
(380469, 'PTHR10783:SF105', NULL, NULL, NULL, NULL, 'BNAA02G35630D PROTEIN', 248021),
(380470, 'PTHR10783:SF127', NULL, NULL, NULL, NULL, 'LD30826P', 248021),
(380471, 'PTHR10783:SF89', NULL, NULL, NULL, NULL, 'SPX AND EXS DOMAIN-CONTAINING PROTEIN 1-LIKE ISOFORM X1', 248021),
(380472, 'PTHR10783:SF106', NULL, NULL, NULL, NULL, 'EXS DOMAIN-CONTAINING PROTEIN', 248021),
(380473, 'PTHR10783:SF128', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER PHO1 HOMOLOG 5', 248021),
(380474, 'PTHR10783:SF103', NULL, NULL, NULL, NULL, 'XENOTROPIC AND POLYTROPIC RETROVIRUS RECEPTOR 1', 248021),
(380475, 'PTHR10783:SF126', NULL, NULL, NULL, NULL, 'BNAA06G38150D PROTEIN', 248021),
(380476, 'PTHR10783:SF46', NULL, NULL, NULL, NULL, 'PROTEIN ERD1 HOMOLOG 2', 248021);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(380477, 'PTHR10783:SF104', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER PHO1 HOMOLOG 10', 248021),
(380478, 'PTHR10783:SF109', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER PHO1 HOMOLOG 3-LIKE', 248021),
(380479, 'PTHR10783:SF129', NULL, NULL, NULL, NULL, 'EXS (ERD1/XPR1/SYG1) FAMILY PROTEIN', 248021),
(380480, 'PTHR10783:SF107', NULL, NULL, NULL, NULL, 'BNAC08G39940D PROTEIN', 248021),
(380481, 'PTHR10783:SF108', NULL, NULL, NULL, NULL, 'BNAA06G33790D PROTEIN', 248021),
(380482, 'PTHR10783', NULL, NULL, NULL, NULL, 'XENOTROPIC AND POLYTROPIC RETROVIRUS RECEPTOR 1-RELATED', 248021),
(380483, 'PTHR10783:SF96', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER PHO1 HOMOLOG 2', 248021),
(380484, 'PTHR10783:SF98', NULL, NULL, NULL, NULL, 'BNAA08G19850D PROTEIN', 248021),
(380485, 'PTHR10783:SF130', NULL, NULL, NULL, NULL, 'EXS DOMAIN-CONTAINING PROTEIN', 248021),
(380486, 'PTHR10783:SF91', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER PHO1 HOMOLOG 7-LIKE', 248021),
(380487, 'PTHR10783:SF131', NULL, NULL, NULL, NULL, 'EXS (ERD1/XPR1/SYG1) FAMILY PROTEIN', 248021),
(380488, 'PTHR10783:SF93', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER PHO1 HOMOLOG 6', 248021),
(380489, 'PTHR10783:SF134', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER PHO1-LIKE', 248021),
(380490, 'PTHR10783:SF112', NULL, NULL, NULL, NULL, 'EXS-RELATED', 248021),
(380491, 'PTHR10783:SF113', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER PHO1 HOMOLOG 7-RELATED', 248021),
(380492, 'PTHR10783:SF135', NULL, NULL, NULL, NULL, 'XENOTROPIC AND POLYTROPIC RETROVIRUS RECEPTOR 1 HOMOLOG', 248021),
(380493, 'PTHR10783:SF132', NULL, NULL, NULL, NULL, 'SI:DKEY-6N6.7 PROTEIN', 248021),
(380494, 'PTHR10783:SF133', NULL, NULL, NULL, NULL, 'SPX DOMAIN-CONTAINING PROTEIN', 248021),
(380495, 'PTHR10783:SF111', NULL, NULL, NULL, NULL, 'EXS-RELATED', 248021),
(380496, 'PTHR10783:SF116', NULL, NULL, NULL, NULL, 'BNAA09G45890D PROTEIN', 248021),
(380497, 'PTHR10783:SF78', NULL, NULL, NULL, NULL, 'SPX AND EXS DOMAIN-CONTAINING PROTEIN 2-RELATED', 248021),
(380498, 'PTHR10783:SF117', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER PHO1 HOMOLOG 10-LIKE ISOFORM X1', 248021),
(380499, 'PTHR10783:SF99', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER PHO1 HOMOLOG 4', 248021),
(380500, 'PTHR10783:SF136', NULL, NULL, NULL, NULL, 'PROTEIN ERD1 HOMOLOG 1', 248021),
(380501, 'PTHR10783:SF35', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER PHO1 HOMOLOG 1', 248021),
(380502, 'PTHR10783:SF115', NULL, NULL, NULL, NULL, 'BNAA07G24450D PROTEIN', 248021),
(380503, 'PTHR10783:SF118', NULL, NULL, NULL, NULL, 'BNAA06G38130D PROTEIN', 248021),
(380504, 'PTHR10783:SF119', NULL, NULL, NULL, NULL, 'BNAC02G34860D PROTEIN', 248021),
(380505, 'PTHR10783:SF4', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER PHO1 HOMOLOG 3', 248021),
(380506, 'PTHR46569', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRAIP', 248022),
(380507, 'PTHR46569:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RFWD3-RELATED', 248022),
(380508, 'PTHR45982:SF1', NULL, NULL, NULL, NULL, 'REGULATOR OF CHROMOSOME CONDENSATION', 248023),
(380509, 'PTHR45982:SF3', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN POF9', 248023),
(380510, 'PTHR45982:SF4', NULL, NULL, NULL, NULL, '', 248023),
(380511, 'PTHR45982:SF5', NULL, NULL, NULL, NULL, 'RCC DOMAIN-CONTAINING PROTEIN ATS1', 248023),
(380512, 'PTHR45982:SF6', NULL, NULL, NULL, NULL, 'SCF-ASSOCIATED FACTOR 1', 248023),
(380513, 'PTHR45982:SF7', NULL, NULL, NULL, NULL, '', 248023),
(380514, 'PTHR45982:SF8', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HERC2-LIKE PROTEIN-RELATED', 248023),
(380515, 'PTHR45982', NULL, NULL, NULL, NULL, 'REGULATOR OF CHROMOSOME CONDENSATION', 248023),
(380516, 'PTHR43038', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE, SUB-FAMILY H, MEMBER 1', 248024),
(380517, 'PTHR43038:SF3', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN-RELATED', 248024),
(380518, 'PTHR43038:SF4', NULL, NULL, NULL, NULL, 'RIBOSOME-ASSOCIATED ATPASE', 248024),
(380519, 'PTHR43038:SF2', NULL, NULL, NULL, NULL, 'RH61964P', 248024);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(380520, 'PTHR43038:SF7', NULL, NULL, NULL, NULL, 'ABC TRANSPORT SYSTEM ATP-BINDING PROTEIN', 248024),
(380521, 'PTHR43038:SF8', NULL, NULL, NULL, NULL, 'ABC-TYPE MULTIDRUG TRANSPORT SYSTEM, ATPASE COMPONENT', 248024),
(380522, 'PTHR43038:SF5', NULL, NULL, NULL, NULL, 'RE14039P', 248024),
(380523, 'PTHR30620:SF100', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE FAMILY 3 C-TERMINAL DOMAIN-CONTAINING PROTEIN-RELATED', 248025),
(380524, 'PTHR30620:SF101', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE BOGH3B-LIKE', 248025),
(380525, 'PTHR30620:SF83', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE FAMILY 3 N TERMINAL DOMAIN CONTAINING PROTEIN, EXPRESSED', 248025),
(380526, 'PTHR30620:SF82', NULL, NULL, NULL, NULL, '', 248025),
(380527, 'PTHR30620:SF81', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE BOGH3B-LIKE', 248025),
(380528, 'PTHR30620:SF80', NULL, NULL, NULL, NULL, 'BETA-D-GLUCOSIDE GLUCOHYDROLASE', 248025),
(380529, 'PTHR30620:SF98', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE', 248025),
(380530, 'PTHR30620:SF75', NULL, NULL, NULL, NULL, 'PERIPLASMIC BETA-GLUCOSIDASE', 248025),
(380531, 'PTHR30620:SF35', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE FAMILY PROTEIN', 248025),
(380532, 'PTHR30620:SF99', NULL, NULL, NULL, NULL, '', 248025),
(380533, 'PTHR30620:SF77', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE BOGH3B-LIKE', 248025),
(380534, 'PTHR30620:SF33', NULL, NULL, NULL, NULL, 'BETA-D-GLUCAN EXOHYDROLASE-LIKE PROTEIN-RELATED', 248025),
(380535, 'PTHR30620:SF108', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_3_C DOMAIN-CONTAINING PROTEIN', 248025),
(380536, 'PTHR30620:SF16', NULL, NULL, NULL, NULL, 'LYSOSOMAL BETA GLUCOSIDASE', 248025),
(380537, 'PTHR30620:SF109', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE', 248025),
(380538, 'PTHR30620:SF103', NULL, NULL, NULL, NULL, 'BNAA03G01500D PROTEIN', 248025),
(380539, 'PTHR30620:SF106', NULL, NULL, NULL, NULL, 'BNAC09G36920D PROTEIN', 248025),
(380540, 'PTHR30620:SF105', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE FAMILY 3-RELATED', 248025),
(380541, 'PTHR30620:SF112', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE BOGH3B-LIKE ISOFORM X1', 248025),
(380542, 'PTHR30620:SF90', NULL, NULL, NULL, NULL, 'BETA-D-GLUCAN EXOHYDROLASE-LIKE PROTEIN', 248025),
(380543, 'PTHR30620:SF94', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE', 248025),
(380544, 'PTHR30620:SF93', NULL, NULL, NULL, NULL, '', 248025),
(380545, 'PTHR30620:SF91', NULL, NULL, NULL, NULL, 'BETA-D-GLUCOSIDE GLUCOHYDROLASE', 248025),
(380546, 'PTHR30620:SF87', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE', 248025),
(380547, 'PTHR30620', NULL, NULL, NULL, NULL, 'PERIPLASMIC BETA-GLUCOSIDASE-RELATED', 248025),
(380548, 'PTHR30620:SF85', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE', 248025),
(380549, 'PTHR30620:SF46', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE FAMILY 3 N TERMINAL DOMAIN CONTAINING PROTEIN, EXPRESSED', 248025),
(380550, 'PTHR30620:SF23', NULL, NULL, NULL, NULL, 'OS02G0131400 PROTEIN', 248025),
(380551, 'PTHR30620:SF89', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE BOGH3B-LIKE', 248025),
(380552, 'PTHR30620:SF88', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 248025),
(380553, 'PTHR30620:SF119', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE FAMILY PROTEIN', 248025),
(380554, 'PTHR30620:SF118', NULL, NULL, NULL, NULL, 'BETA-D-GLUCAN EXOHYDROLASE', 248025),
(380555, 'PTHR30620:SF115', NULL, NULL, NULL, NULL, '', 248025),
(380556, 'PTHR30620:SF117', NULL, NULL, NULL, NULL, 'BETA-1,4-XYLOSIDASE (EUROFUNG)', 248025),
(380557, 'PTHR30620:SF116', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE-LIKE PROTEIN', 248025),
(380558, 'PTHR23225:SF3', NULL, NULL, NULL, NULL, '', 248026),
(380559, 'PTHR23225:SF4', NULL, NULL, NULL, NULL, 'C2H2 FINGER DOMAIN-CONTAINING PROTEIN', 248026),
(380560, 'PTHR23225:SF2', NULL, NULL, NULL, NULL, 'AT09679P-RELATED', 248026),
(380561, 'PTHR23225', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 248026),
(380562, 'PTHR32278:SF104', NULL, NULL, NULL, NULL, 'PHLOEM PROTEIN 2-LIKE PROTEIN-RELATED', 248027),
(380563, 'PTHR32278:SF27', NULL, NULL, NULL, NULL, 'LECTIN-LIKE', 248027),
(380564, 'PTHR32278:SF29', NULL, NULL, NULL, NULL, 'PROTEIN PHLOEM PROTEIN 2-LIKE A1', 248027);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(380565, 'PTHR32278:SF108', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248027),
(380566, 'PTHR32278:SF68', NULL, NULL, NULL, NULL, 'BNAA08G26600D PROTEIN', 248027),
(380567, 'PTHR32278:SF26', NULL, NULL, NULL, NULL, 'OS02G0812500 PROTEIN', 248027),
(380568, 'PTHR32278:SF69', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 248027),
(380569, 'PTHR32278:SF107', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248027),
(380570, 'PTHR32278:SF61', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN, PHLOEM PROTEIN 2-LIKE PROTEIN-RELATED', 248027),
(380571, 'PTHR32278:SF80', NULL, NULL, NULL, NULL, 'BNAC03G63410D PROTEIN', 248027),
(380572, 'PTHR32278:SF116', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-B10-LIKE', 248027),
(380573, 'PTHR32278:SF111', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-B1-RELATED', 248027),
(380574, 'PTHR32278:SF110', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248027),
(380575, 'PTHR32278:SF119', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-B10-RELATED', 248027),
(380576, 'PTHR32278:SF34', NULL, NULL, NULL, NULL, 'PHLOEM PROTEIN 2-A10', 248027),
(380577, 'PTHR32278:SF78', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN', 248027),
(380578, 'PTHR32278:SF117', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248027),
(380579, 'PTHR32278:SF118', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN, PHLOEM PROTEIN 2-LIKE PROTEIN-RELATED', 248027),
(380580, 'PTHR32278:SF36', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-B11-LIKE', 248027),
(380581, 'PTHR32278:SF75', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248027),
(380582, 'PTHR32278:SF77', NULL, NULL, NULL, NULL, 'PHLOEM PROTEIN 2-LIKE PROTEIN-RELATED', 248027),
(380583, 'PTHR32278:SF76', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248027),
(380584, 'PTHR32278:SF70', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248027),
(380585, 'PTHR32278:SF73', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN, PHLOEM PROTEIN 2-LIKE PROTEIN-RELATED', 248027),
(380586, 'PTHR32278:SF72', NULL, NULL, NULL, NULL, 'BNAA06G34240D PROTEIN', 248027),
(380587, 'PTHR32278:SF91', NULL, NULL, NULL, NULL, 'F-BOX FAMILY PROTEIN', 248027),
(380588, 'PTHR32278:SF90', NULL, NULL, NULL, NULL, '', 248027),
(380589, 'PTHR32278:SF126', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-B13-LIKE', 248027),
(380590, 'PTHR32278:SF127', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248027),
(380591, 'PTHR32278:SF124', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248027),
(380592, 'PTHR32278:SF125', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248027),
(380593, 'PTHR32278:SF122', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-B15', 248027),
(380594, 'PTHR32278:SF121', NULL, NULL, NULL, NULL, 'PHLOEM-SPECIFIC LECTIN', 248027),
(380595, 'PTHR32278:SF46', NULL, NULL, NULL, NULL, '', 248027),
(380596, 'PTHR32278:SF128', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN, PHLOEM PROTEIN 2-LIKE PROTEIN-RELATED', 248027),
(380597, 'PTHR32278:SF129', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-B10-LIKE', 248027),
(380598, 'PTHR32278:SF42', NULL, NULL, NULL, NULL, 'PROTEIN PHLOEM PROTEIN 2-LIKE A2', 248027),
(380599, 'PTHR32278:SF86', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-B10-LIKE ISOFORM X1', 248027),
(380600, 'PTHR32278:SF85', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-B11-LIKE', 248027),
(380601, 'PTHR32278:SF41', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN', 248027),
(380602, 'PTHR32278:SF88', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248027),
(380603, 'PTHR32278:SF87', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248027),
(380604, 'PTHR32278:SF81', NULL, NULL, NULL, NULL, 'F-BOX FAMILY PROTEIN', 248027),
(380605, 'PTHR32278:SF84', NULL, NULL, NULL, NULL, 'OS02G0813166 PROTEIN', 248027),
(380606, 'PTHR32278', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248027),
(380607, 'PTHR32278:SF83', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248027),
(380608, 'PTHR32278:SF130', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248027);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(380609, 'PTHR32278:SF137', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248027),
(380610, 'PTHR32278:SF135', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248027),
(380611, 'PTHR32278:SF136', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-B10-LIKE', 248027),
(380612, 'PTHR32278:SF133', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248027),
(380613, 'PTHR32278:SF134', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-B11', 248027),
(380614, 'PTHR32278:SF131', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-A13', 248027),
(380615, 'PTHR32278:SF132', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-B10-LIKE', 248027),
(380616, 'PTHR32278:SF57', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-B5-RELATED', 248027),
(380617, 'PTHR32278:SF56', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-B2-RELATED', 248027),
(380618, 'PTHR32278:SF12', NULL, NULL, NULL, NULL, 'OS08G0150700 PROTEIN', 248027),
(380619, 'PTHR32278:SF15', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-B13-RELATED', 248027),
(380620, 'PTHR32278:SF59', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-B12 ISOFORM X1-RELATED', 248027),
(380621, 'PTHR32278:SF11', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN', 248027),
(380622, 'PTHR32278:SF55', NULL, NULL, NULL, NULL, 'PROTEIN PHLOEM PROTEIN 2-LIKE A9-LIKE', 248027),
(380623, 'PTHR32278:SF99', NULL, NULL, NULL, NULL, 'GALACTOSE-BINDING LIKE', 248027),
(380624, 'PTHR32278:SF93', NULL, NULL, NULL, NULL, 'BNAA06G34210D PROTEIN', 248027),
(380625, 'PTHR32278:SF92', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248027),
(380626, 'PTHR32278:SF95', NULL, NULL, NULL, NULL, 'PHLOEM PROTEIN 2-B1', 248027),
(380627, 'PTHR32278:SF51', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-B10', 248027),
(380628, 'PTHR32278:SF2', NULL, NULL, NULL, NULL, 'PROTEIN PHLOEM PROTEIN 2-LIKE A9', 248027),
(380629, 'PTHR32278:SF94', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248027),
(380630, 'PTHR32278:SF50', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-B12-RELATED', 248027),
(380631, 'PTHR14709', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248028),
(380632, 'PTHR14709:SF1', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 12', 248028),
(380633, 'PTHR14709:SF2', NULL, NULL, NULL, NULL, 'GLUTAMINE AND SERINE-RICH PROTEIN 1', 248028),
(380634, 'PTHR43132:SF2', NULL, NULL, NULL, NULL, 'ARSENICAL RESISTANCE OPERON REPRESSOR ARSR-RELATED', 248029),
(380635, 'PTHR43132:SF7', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR NMTR', 248029),
(380636, 'PTHR43132:SF6', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REPRESSOR CZRA', 248029),
(380637, 'PTHR43132', NULL, NULL, NULL, NULL, 'ARSENICAL RESISTANCE OPERON REPRESSOR ARSR-RELATED', 248029),
(380638, 'PTHR32028', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN M', 248030),
(380639, 'PTHR32028:SF1', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN M', 248030),
(380640, 'PTHR13594:SF1', NULL, NULL, NULL, NULL, 'CENTRIOLAR COILED-COIL PROTEIN OF 110 KDA', 248031),
(380641, 'PTHR13594:SF2', NULL, NULL, NULL, NULL, 'SI:CH73-100L22.3', 248031),
(380642, 'PTHR13594:SF3', NULL, NULL, NULL, NULL, 'CENTRIOLAR COILED-COIL PROTEIN 110', 248031),
(380643, 'PTHR13594', NULL, NULL, NULL, NULL, 'CENTRIOLAR COILED-COIL PROTEIN OF 110 KDA', 248031),
(380644, 'PTHR31687', NULL, NULL, NULL, NULL, '', 248032),
(380645, 'PTHR31687:SF3', NULL, NULL, NULL, NULL, 'PROTEIN URG3', 248032),
(380646, 'PTHR43080:SF28', NULL, NULL, NULL, NULL, 'OS04G0136700 PROTEIN', 248033),
(380647, 'PTHR43080:SF29', NULL, NULL, NULL, NULL, 'CBS DOMAIN-CONTAINING PROTEIN', 248033),
(380648, 'PTHR43080:SF2', NULL, NULL, NULL, NULL, 'CBS DOMAIN-CONTAINING PROTEIN CBSX3, MITOCHONDRIAL', 248033),
(380649, 'PTHR43080', NULL, NULL, NULL, NULL, 'CBS DOMAIN-CONTAINING PROTEIN CBSX3, MITOCHONDRIAL', 248033),
(380650, 'PTHR43080:SF4', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REGULATOR, CONTAINING CBS DOMAINS-RELATED', 248033),
(380651, 'PTHR43080:SF10', NULL, NULL, NULL, NULL, '', 248033),
(380652, 'PTHR43080:SF11', NULL, NULL, NULL, NULL, 'CBS DOMAIN CONTAINING PROTEIN', 248033),
(380653, 'PTHR43080:SF12', NULL, NULL, NULL, NULL, 'CYSTATHIONINE BETA-SYNTHASE (CBS) FAMILY PROTEIN', 248033);
INSERT INTO "PUBLIC"."MODEL" VALUES
(380654, 'PTHR43080:SF26', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN-RELATED', 248033),
(380655, 'PTHR43080:SF27', NULL, NULL, NULL, NULL, 'CBS DOMAIN-CONTAINING PROTEIN YKUL', 248033),
(380656, 'PTHR47345', NULL, NULL, NULL, NULL, 'CUT9-INTERACTING PROTEIN SCN1', 248034),
(380657, 'PTHR47345:SF1', NULL, NULL, NULL, NULL, 'CUT9-INTERACTING PROTEIN SCN1', 248034),
(380658, 'PTHR22849:SF11', NULL, NULL, NULL, NULL, 'OS11G0573500 PROTEIN', 248035),
(380659, 'PTHR22849:SF108', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 248035),
(380660, 'PTHR22849:SF129', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 20', 248035),
(380661, 'PTHR22849:SF128', NULL, NULL, NULL, NULL, 'OS12G0161100 PROTEIN', 248035),
(380662, 'PTHR22849:SF148', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 248035),
(380663, 'PTHR22849:SF147', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 248035),
(380664, 'PTHR22849:SF103', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 248035),
(380665, 'PTHR22849:SF146', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE PUB22', 248035),
(380666, 'PTHR22849:SF144', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 248035),
(380667, 'PTHR22849:SF143', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 248035),
(380668, 'PTHR22849:SF142', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 31', 248035),
(380669, 'PTHR22849:SF163', NULL, NULL, NULL, NULL, 'OS05G0439400 PROTEIN', 248035),
(380670, 'PTHR22849:SF141', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 248035),
(380671, 'PTHR22849:SF162', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 248035),
(380672, 'PTHR22849:SF161', NULL, NULL, NULL, NULL, 'OS01G0787300 PROTEIN', 248035),
(380673, 'PTHR22849:SF160', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 248035),
(380674, 'PTHR22849:SF24', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE PUB24', 248035),
(380675, 'PTHR22849:SF49', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 248035),
(380676, 'PTHR22849:SF20', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 27-RELATED', 248035),
(380677, 'PTHR22849:SF66', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 248035),
(380678, 'PTHR22849:SF23', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 248035),
(380679, 'PTHR22849:SF119', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 248035),
(380680, 'PTHR22849', NULL, NULL, NULL, NULL, 'WDSAM1 PROTEIN', 248035),
(380681, 'PTHR22849:SF61', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 21', 248035),
(380682, 'PTHR22849:SF118', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 248035),
(380683, 'PTHR22849:SF139', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 248035),
(380684, 'PTHR22849:SF116', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 25', 248035),
(380685, 'PTHR22849:SF115', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 248035),
(380686, 'PTHR22849:SF159', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 248035),
(380687, 'PTHR22849:SF114', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 248035),
(380688, 'PTHR22849:SF136', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 248035),
(380689, 'PTHR22849:SF158', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 248035),
(380690, 'PTHR22849:SF157', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 248035),
(380691, 'PTHR22849:SF113', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 29', 248035),
(380692, 'PTHR22849:SF112', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 26', 248035),
(380693, 'PTHR22849:SF134', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 248035),
(380694, 'PTHR22849:SF155', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 248035),
(380695, 'PTHR22849:SF111', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 248035),
(380696, 'PTHR22849:SF133', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 248035);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(380697, 'PTHR22849:SF132', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE PUB23', 248035),
(380698, 'PTHR22849:SF152', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 248035),
(380699, 'PTHR22849:SF130', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 248035),
(380700, 'PTHR22849:SF151', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 30', 248035),
(380701, 'PTHR22849:SF6', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 248035),
(380702, 'PTHR22849:SF16', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 248035),
(380703, 'PTHR16861:SF7', NULL, NULL, NULL, NULL, 'OPY2 DOMAIN-CONTAINING PROTEIN', 248036),
(380704, 'PTHR16861:SF8', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-CONTAINING PROTEIN', 248036),
(380705, 'PTHR16861:SF5', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 248036),
(380706, 'PTHR16861:SF6', NULL, NULL, NULL, NULL, 'METALLOENDOPEPTIDASE', 248036),
(380707, 'PTHR16861:SF4', NULL, NULL, NULL, NULL, 'CELL WALL INTEGRITY AND STRESS RESPONSE COMPONENT 1', 248036),
(380708, 'PTHR16861', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN 38', 248036),
(380709, 'PTHR45822', NULL, NULL, NULL, NULL, 'FREE FATTY ACID RECEPTOR 2-RELATED', 248037),
(380710, 'PTHR45822:SF8', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 248037),
(380711, 'PTHR45822:SF5', NULL, NULL, NULL, NULL, 'FREE FATTY ACID RECEPTOR 2', 248037),
(380712, 'PTHR45822:SF4', NULL, NULL, NULL, NULL, 'FREE FATTY ACID RECEPTOR 1', 248037),
(380713, 'PTHR45822:SF7', NULL, NULL, NULL, NULL, 'SI:CH211-231M23.4', 248037),
(380714, 'PTHR45822:SF6', NULL, NULL, NULL, NULL, 'FREE FATTY ACID RECEPTOR 3-RELATED', 248037),
(380715, 'PTHR45822:SF1', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 248037),
(380716, 'PTHR45822:SF3', NULL, NULL, NULL, NULL, 'LOC794123 PROTEIN-RELATED', 248037),
(380717, 'PTHR24390:SF209', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 770', 248038),
(380718, 'PTHR24390:SF202', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 711', 248038),
(380719, 'PTHR24390:SF201', NULL, NULL, NULL, NULL, 'AGAP003991-PA', 248038),
(380720, 'PTHR24390:SF124', NULL, NULL, NULL, NULL, 'TISSUE-RESIDENT T-CELL TRANSCRIPTION REGULATOR PROTEIN ZNF683', 248038),
(380721, 'PTHR24390:SF204', NULL, NULL, NULL, NULL, 'OOCYTE ZINC FINGER PROTEIN XLCOF6-LIKE', 248038),
(380722, 'PTHR24390:SF203', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 248038),
(380723, 'PTHR24390:SF129', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 707', 248038),
(380724, 'PTHR24390:SF206', NULL, NULL, NULL, NULL, 'ZGC:162623 PROTEIN', 248038),
(380725, 'PTHR24390:SF205', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN CONTAINING 49', 248038),
(380726, 'PTHR24390:SF208', NULL, NULL, NULL, NULL, 'AGAP003562-PA', 248038),
(380727, 'PTHR24390:SF70', NULL, NULL, NULL, NULL, 'FEZ FAMILY ZINC FINGER PROTEIN 1', 248038),
(380728, 'PTHR24390:SF207', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 41-LIKE PROTEIN', 248038),
(380729, 'PTHR24390:SF172', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 569', 248038),
(380730, 'PTHR24390:SF76', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 581', 248038),
(380731, 'PTHR24390:SF74', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 410', 248038),
(380732, 'PTHR24390:SF173', NULL, NULL, NULL, NULL, '', 248038),
(380733, 'PTHR24390:SF211', NULL, NULL, NULL, NULL, 'PLAG1 ZINC FINGER', 248038),
(380734, 'PTHR24390:SF79', NULL, NULL, NULL, NULL, 'ASPARAGINE-RICH ZINC FINGER PROTEIN AZF1', 248038),
(380735, 'PTHR24390:SF210', NULL, NULL, NULL, NULL, 'ZFP92 ZINC FINGER PROTEIN', 248038),
(380736, 'PTHR24390:SF39', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 662', 248038),
(380737, 'PTHR24390:SF38', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 366', 248038),
(380738, 'PTHR24390:SF213', NULL, NULL, NULL, NULL, 'VASCULAR ENDOTHELIAL ZINC FINGER 1A-RELATED', 248038),
(380739, 'PTHR24390:SF135', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 740A-RELATED', 248038),
(380740, 'PTHR24390:SF212', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 367', 248038);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(380741, 'PTHR24390:SF215', NULL, NULL, NULL, NULL, 'EXPRESSED SEQUENCE AI854703', 248038),
(380742, 'PTHR24390:SF214', NULL, NULL, NULL, NULL, 'AGAP004178-PA', 248038),
(380743, 'PTHR24390:SF62', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 865', 248038),
(380744, 'PTHR24390:SF217', NULL, NULL, NULL, NULL, 'FINGER PROTEIN, PUTATIVE-RELATED', 248038),
(380745, 'PTHR24390:SF139', NULL, NULL, NULL, NULL, 'TELOMERE ZINC FINGER-ASSOCIATED PROTEIN', 248038),
(380746, 'PTHR24390:SF216', NULL, NULL, NULL, NULL, 'ADULT ENHANCER FACTOR 1-LIKE PROTEIN', 248038),
(380747, 'PTHR24390:SF219', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 782-LIKE PROTEIN', 248038),
(380748, 'PTHR24390:SF218', NULL, NULL, NULL, NULL, '', 248038),
(380749, 'PTHR24390:SF64', NULL, NULL, NULL, NULL, 'PLEIOMORPHIC ADENOMA GENE-LIKE 1', 248038),
(380750, 'PTHR24390:SF220', NULL, NULL, NULL, NULL, 'IP01252P-RELATED', 248038),
(380751, 'PTHR24390:SF222', NULL, NULL, NULL, NULL, 'FEZ FAMILY ZINC FINGER PROTEIN', 248038),
(380752, 'PTHR24390:SF221', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 484', 248038),
(380753, 'PTHR24390:SF144', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 691', 248038),
(380754, 'PTHR24390:SF180', NULL, NULL, NULL, NULL, 'PLAG1 ZINC FINGER', 248038),
(380755, 'PTHR24390:SF224', NULL, NULL, NULL, NULL, 'GH23506P-RELATED', 248038),
(380756, 'PTHR24390:SF90', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 652', 248038),
(380757, 'PTHR24390:SF223', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 391', 248038),
(380758, 'PTHR24390:SF105', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 692', 248038),
(380759, 'PTHR24390:SF148', NULL, NULL, NULL, NULL, 'CTCF', 248038),
(380760, 'PTHR24390:SF50', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 574-RELATED', 248038),
(380761, 'PTHR24390:SF94', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR E4F1', 248038),
(380762, 'PTHR24390:SF109', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 524', 248038),
(380763, 'PTHR24390:SF196', NULL, NULL, NULL, NULL, '', 248038),
(380764, 'PTHR24390:SF96', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 362', 248038),
(380765, 'PTHR24390:SF195', NULL, NULL, NULL, NULL, 'PROTEIN KRUEPPEL', 248038),
(380766, 'PTHR24390:SF198', NULL, NULL, NULL, NULL, 'FI23536P1-RELATED', 248038),
(380767, 'PTHR24390:SF154', NULL, NULL, NULL, NULL, 'LSY-2-LIKE', 248038),
(380768, 'PTHR24390:SF153', NULL, NULL, NULL, NULL, 'SI:DKEYP-121D2.7', 248038),
(380769, 'PTHR24390:SF197', NULL, NULL, NULL, NULL, 'GH09339P-RELATED', 248038),
(380770, 'PTHR24390:SF199', NULL, NULL, NULL, NULL, '', 248038),
(380771, 'PTHR24390:SF192', NULL, NULL, NULL, NULL, 'ZINC FINGER FAMILY MEMBER 783', 248038),
(380772, 'PTHR24390:SF158', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 383-RELATED', 248038),
(380773, 'PTHR24390:SF159', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN SENS', 248038),
(380774, 'PTHR24390:SF118', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 281', 248038),
(380775, 'PTHR24390:SF83', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN CONTAINING 17', 248038),
(380776, 'PTHR24390:SF119', NULL, NULL, NULL, NULL, 'SI:CH73-221F6.4-RELATED', 248038),
(380777, 'PTHR24390:SF88', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 239', 248038),
(380778, 'PTHR24390:SF44', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 671', 248038),
(380779, 'PTHR24390:SF43', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 710', 248038),
(380780, 'PTHR24390:SF162', NULL, NULL, NULL, NULL, 'FEZ FAMILY ZINC FINGER PROTEIN 2', 248038),
(380781, 'PTHR24390:SF41', NULL, NULL, NULL, NULL, '', 248038),
(380782, 'PTHR24390:SF46', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 667', 248038),
(380783, 'PTHR24390:SF167', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 358', 248038),
(380784, 'PTHR24390', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 248038),
(380785, 'PTHR24390:SF200', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 763', 248038),
(380786, 'PTHR24390:SF166', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 184', 248038),
(380787, 'PTHR24390:SF122', NULL, NULL, NULL, NULL, 'MYC-ASSOCIATED ZINC FINGER PROTEIN', 248038);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(380788, 'PTHR24390:SF49', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 212', 248038),
(380789, 'PTHR10684:SF4', NULL, NULL, NULL, NULL, 'TAIMAN, ISOFORM G', 248039),
(380790, 'PTHR10684:SF2', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR COACTIVATOR 2', 248039),
(380791, 'PTHR10684:SF3', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR COACTIVATOR 3', 248039),
(380792, 'PTHR10684:SF1', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR COACTIVATOR 1', 248039),
(380793, 'PTHR10684', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR COACTIVATOR', 248039),
(380794, 'PTHR41283:SF1', NULL, NULL, NULL, NULL, 'APH DOMAIN-CONTAINING PROTEIN', 248040),
(380795, 'PTHR41283', NULL, NULL, NULL, NULL, 'AMINOGLYCOSIDE PHOSPHOTRANSFERASE', 248040),
(380796, 'PTHR31428:SF6', NULL, NULL, NULL, NULL, 'REPULSIVE GUIDANCE MOLECULE B HOMOLOG DRAG-1', 248041),
(380797, 'PTHR31428:SF5', NULL, NULL, NULL, NULL, 'REPULSIVE GUIDANCE MOLECULE B', 248041),
(380798, 'PTHR31428:SF4', NULL, NULL, NULL, NULL, 'REPULSIVE GUIDANCE MOLECULE A', 248041),
(380799, 'PTHR31428:SF3', NULL, NULL, NULL, NULL, 'HEMOJUVELIN', 248041),
(380800, 'PTHR31428', NULL, NULL, NULL, NULL, 'RGM DOMAIN FAMILY MEMBER DRAG-1', 248041),
(380801, 'PTHR31428:SF7', NULL, NULL, NULL, NULL, 'RGM DOMAIN FAMILY, MEMBER D', 248041),
(380802, 'PTHR46615:SF1', NULL, NULL, NULL, NULL, 'ARYLSULFATASE K', 248042),
(380803, 'PTHR46615', NULL, NULL, NULL, NULL, 'ARYLSULFATASE K', 248042),
(380804, 'PTHR47944:SF8', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 SUPERFAMILY PROTEIN-RELATED', 248043),
(380805, 'PTHR47944:SF7', NULL, NULL, NULL, NULL, 'OS09G0264400 PROTEIN', 248043),
(380806, 'PTHR47944:SF6', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 84A1', 248043),
(380807, 'PTHR47944', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 98A9', 248043),
(380808, 'PTHR47944:SF5', NULL, NULL, NULL, NULL, 'FLAVONOID 3''-MONOOXYGENASE-LIKE', 248043),
(380809, 'PTHR47944:SF9', NULL, NULL, NULL, NULL, 'FLAVONOID 3-MONOOXYGENASE', 248043),
(380810, 'PTHR47944:SF14', NULL, NULL, NULL, NULL, '', 248043),
(380811, 'PTHR47944:SF12', NULL, NULL, NULL, NULL, '', 248043),
(380812, 'PTHR47944:SF10', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 98A9', 248043),
(380813, 'PTHR47944:SF11', NULL, NULL, NULL, NULL, 'DIMETHYLNONATRIENE SYNTHASE', 248043),
(380814, 'PTHR47944:SF4', NULL, NULL, NULL, NULL, 'OS09G0441700 PROTEIN', 248043),
(380815, 'PTHR47944:SF3', NULL, NULL, NULL, NULL, 'TRIMETHYLTRIDECATETRAENE SYNTHASE', 248043),
(380816, 'PTHR47944:SF2', NULL, NULL, NULL, NULL, '', 248043),
(380817, 'PTHR47944:SF1', NULL, NULL, NULL, NULL, 'OS08G0456200 PROTEIN', 248043),
(380818, 'PTHR21043:SF3', NULL, NULL, NULL, NULL, 'BNAC05G40400D PROTEIN', 248044),
(380819, 'PTHR21043:SF0', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ASSEMBLY OF RIBOSOMAL LARGE SUBUNIT PROTEIN 1', 248044),
(380820, 'PTHR21043', NULL, NULL, NULL, NULL, 'IOJAP SUPERFAMILY ORTHOLOG', 248044),
(380821, 'PTHR21043:SF2', NULL, NULL, NULL, NULL, 'PROTEIN IOJAP, CHLOROPLASTIC', 248044),
(380822, 'PTHR35486:SF8', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248045),
(380823, 'PTHR35486:SF7', NULL, NULL, NULL, NULL, 'BNAA04G25790D PROTEIN', 248045),
(380824, 'PTHR35486:SF9', NULL, NULL, NULL, NULL, 'OSJNBB0016D16.16-LIKE PROTEIN', 248045),
(380825, 'PTHR35486:SF4', NULL, NULL, NULL, NULL, 'BNAANNG19180D PROTEIN', 248045),
(380826, 'PTHR35486:SF3', NULL, NULL, NULL, NULL, '', 248045),
(380827, 'PTHR35486:SF6', NULL, NULL, NULL, NULL, '', 248045),
(380828, 'PTHR35486:SF5', NULL, NULL, NULL, NULL, 'BNAC04G22330D PROTEIN', 248045),
(380829, 'PTHR35486', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248045),
(380830, 'PTHR35486:SF2', NULL, NULL, NULL, NULL, 'BNAA09G38280D PROTEIN', 248045),
(380831, 'PTHR35486:SF1', NULL, NULL, NULL, NULL, 'OS02G0689500 PROTEIN', 248045),
(380832, 'PTHR12303:SF11', NULL, NULL, NULL, NULL, 'N2227 DOMAIN-CONTAINING PROTEIN', 248046),
(380833, 'PTHR12303:SF6', NULL, NULL, NULL, NULL, 'CARNOSINE N-METHYLTRANSFERASE', 248046),
(380834, 'PTHR12303', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248046),
(380835, 'PTHR12303:SF13', NULL, NULL, NULL, NULL, 'N2227 DOMAIN-CONTAINING PROTEIN', 248046); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(380836, 'PTHR13061:SF57', NULL, NULL, NULL, NULL, 'BNACNNG50110D PROTEIN', 248047),
(380837, 'PTHR13061:SF58', NULL, NULL, NULL, NULL, 'GAMMA CARBONIC ANHYDRASE 1, MITOCHONDRIAL', 248047),
(380838, 'PTHR13061:SF36', NULL, NULL, NULL, NULL, 'BNAA02G33720D PROTEIN', 248047),
(380839, 'PTHR13061:SF48', NULL, NULL, NULL, NULL, 'BNAA06G39160D PROTEIN', 248047),
(380840, 'PTHR13061:SF26', NULL, NULL, NULL, NULL, '', 248047),
(380841, 'PTHR13061:SF59', NULL, NULL, NULL, NULL, '', 248047),
(380842, 'PTHR13061:SF49', NULL, NULL, NULL, NULL, 'GAMMA CARBONIC ANHYDRASE 1, MITOCHONDRIAL-LIKE', 248047),
(380843, 'PTHR13061:SF42', NULL, NULL, NULL, NULL, 'BNAA06G13770D PROTEIN', 248047),
(380844, 'PTHR13061:SF54', NULL, NULL, NULL, NULL, 'GAMMA CARBONIC ANHYDRASE 2, MITOCHONDRIAL', 248047),
(380845, 'PTHR13061', NULL, NULL, NULL, NULL, 'DYNACTIN SUBUNIT P25', 248047),
(380846, 'PTHR13061:SF55', NULL, NULL, NULL, NULL, 'GAMMA CARBONIC ANHYDRASE-LIKE PROTEIN', 248047),
(380847, 'PTHR13061:SF33', NULL, NULL, NULL, NULL, 'GAMMA CARBONIC ANHYDRASE 1, MITOCHONDRIAL-LIKE', 248047),
(380848, 'PTHR13061:SF56', NULL, NULL, NULL, NULL, 'PROTEIN YRDA', 248047),
(380849, 'PTHR13061:SF34', NULL, NULL, NULL, NULL, '', 248047),
(380850, 'PTHR13061:SF29', NULL, NULL, NULL, NULL, 'GAMMA CARBONIC ANHYDRASE-LIKE 1, MITOCHONDRIAL-RELATED', 248047),
(380851, 'PTHR13061:SF60', NULL, NULL, NULL, NULL, '', 248047),
(380852, 'PTHR13061:SF61', NULL, NULL, NULL, NULL, 'OS01G0283100 PROTEIN', 248047),
(380853, 'PTHR13061:SF50', NULL, NULL, NULL, NULL, 'GAMMA CARBONIC ANHYDRASE 1, MITOCHONDRIAL', 248047),
(380854, 'PTHR13061:SF40', NULL, NULL, NULL, NULL, '', 248047),
(380855, 'PTHR13061:SF62', NULL, NULL, NULL, NULL, 'GAMMA CARBONIC ANHYDRASE 3, MITOCHONDRIAL', 248047),
(380856, 'PTHR13061:SF41', NULL, NULL, NULL, NULL, 'YRDA, PUTATIVE-RELATED', 248047),
(380857, 'PTHR13061:SF52', NULL, NULL, NULL, NULL, 'GAMMA CARBONIC ANHYDRASE 1-RELATED', 248047),
(380858, 'PTHR13061:SF30', NULL, NULL, NULL, NULL, 'BNACNNG55730D PROTEIN', 248047),
(380859, 'PTHR48073', NULL, NULL, NULL, NULL, 'O-SUCCINYLBENZOATE SYNTHASE-RELATED', 248048),
(380860, 'PTHR48073:SF2', NULL, NULL, NULL, NULL, 'O-SUCCINYLBENZOATE SYNTHASE', 248048),
(380861, 'PTHR48073:SF4', NULL, NULL, NULL, NULL, 'DIPEPTIDE EPIMERASE', 248048),
(380862, 'PTHR48073:SF5', NULL, NULL, NULL, NULL, 'O-SUCCINYLBENZOATE SYNTHASE', 248048),
(380863, 'PTHR10136:SF8', NULL, NULL, NULL, NULL, 'SECRETOGLOBIN FAMILY 1C MEMBER 1-RELATED', 248049),
(380864, 'PTHR10136:SF6', NULL, NULL, NULL, NULL, 'UTEROGLOBIN', 248049),
(380865, 'PTHR10136', NULL, NULL, NULL, NULL, 'SECRETOGLOBIN FAMILY 1 MEMBER', 248049),
(380866, 'PTHR43178:SF12', NULL, NULL, NULL, NULL, 'DIHYDROLIPOAMIDE ACETYLTRANSFERASE COMPONENT OF PYRUVATE DEHYDROGENASE COMPLEX', 248050),
(380867, 'PTHR43178:SF9', NULL, NULL, NULL, NULL, 'PERIPHERAL SUBUNIT-BINDING (PSBD) DOMAIN-CONTAINING PROTEIN', 248050),
(380868, 'PTHR43178:SF13', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYLLYSINE-RESIDUE ACETYLTRANSFERASE COMPONENT 2 OF PYRUVATE DEHYDROGENASE COMPLEX, MITOCHONDRIAL', 248050),
(380869, 'PTHR43178:SF2', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYLLYSINE-RESIDUE ACETYLTRANSFERASE COMPONENT OF PYRUVATE DEHYDROGENASE COMPLEX', 248050),
(380870, 'PTHR43178:SF1', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYLLYSINE-RESIDUE ACETYLTRANSFERASE COMPONENT 3 OF PYRUVATE DEHYDROGENASE COMPLEX, MITOCHONDRIAL', 248050),
(380871, 'PTHR43178', NULL, NULL, NULL, NULL, 'DIHYDROLIPOAMIDE ACETYLTRANSFERASE COMPONENT OF PYRUVATE DEHYDROGENASE COMPLEX', 248050),
(380872, 'PTHR43178:SF5', NULL, NULL, NULL, NULL, 'LIPOAMIDE ACYLTRANSFERASE COMPONENT OF BRANCHED-CHAIN ALPHA-KETO ACID DEHYDROGENASE COMPLEX, MITOCHONDRIAL', 248050),
(380873, 'PTHR43178:SF10', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE COMPONENT OF PYRUVATE DEHYDROGENASE COMPLEX', 248050),
(380874, 'PTHR35021:SF2', NULL, NULL, NULL, NULL, '', 248051),
(380875, 'PTHR35021', NULL, NULL, NULL, NULL, '', 248051),
(380876, 'PTHR35021:SF7', NULL, NULL, NULL, NULL, 'FIBER FB17-LIKE PROTEIN', 248051),
(380877, 'PTHR35021:SF8', NULL, NULL, NULL, NULL, 'PROTEIN FB17, PUTATIVE-RELATED', 248051);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(380878, 'PTHR11579:SF19', NULL, NULL, NULL, NULL, 'PROTEIN-L-ISOASPARTATE O-METHYLTRANSFERASE', 248052),
(380879, 'PTHR11579:SF28', NULL, NULL, NULL, NULL, 'PROTEIN-L-ISOASPARTATE O-METHYLTRANSFERASE 1', 248052),
(380880, 'PTHR11579', NULL, NULL, NULL, NULL, 'PROTEIN-L-ISOASPARTATE O-METHYLTRANSFERASE', 248052),
(380881, 'PTHR11579:SF18', NULL, NULL, NULL, NULL, 'L-ISOASPARTYL PROTEIN CARBOXYL METHYLTRANSFERASE', 248052),
(380882, 'PTHR11579:SF2', NULL, NULL, NULL, NULL, 'PROTEIN-L-ISOASPARTATE O-METHYLTRANSFERASE DOMAIN-CONTAINING PROTEIN 2', 248052),
(380883, 'PTHR11579:SF0', NULL, NULL, NULL, NULL, 'PROTEIN-L-ISOASPARTATE(D-ASPARTATE) O-METHYLTRANSFERASE', 248052),
(380884, 'PTHR11579:SF27', NULL, NULL, NULL, NULL, 'PROTEIN-L-ISOASPARTATE O-METHYLTRANSFERASE', 248052),
(380885, 'PTHR11579:SF7', NULL, NULL, NULL, NULL, 'PROTEIN-L-ISOASPARTATE(D-ASPARTATE) O-METHYLTRANSFERASE', 248052),
(380886, 'PTHR11579:SF4', NULL, NULL, NULL, NULL, 'PROTEIN-L-ISOASPARTATE O-METHYLTRANSFERASE DOMAIN-CONTAINING PROTEIN 1', 248052),
(380887, 'PTHR11579:SF20', NULL, NULL, NULL, NULL, 'PROTEIN-L-ISOASPARTATE O-METHYLTRANSFERASE 2', 248052),
(380888, 'PTHR11579:SF9', NULL, NULL, NULL, NULL, 'PROTEIN-L-ISOASPARTATE O-METHYLTRANSFERASE DOMAIN-CONTAINING PROTEIN 1-LIKE PROTEIN', 248052),
(380889, 'PTHR31579:SF81', NULL, NULL, NULL, NULL, '', 248053),
(380890, 'PTHR31579:SF61', NULL, NULL, NULL, NULL, 'BNAA01G32350D PROTEIN', 248053),
(380891, 'PTHR31579:SF83', NULL, NULL, NULL, NULL, 'T14N5.3 PROTEIN', 248053),
(380892, 'PTHR31579:SF82', NULL, NULL, NULL, NULL, '', 248053),
(380893, 'PTHR31579:SF60', NULL, NULL, NULL, NULL, 'BNAC03G21670D PROTEIN', 248053),
(380894, 'PTHR31579:SF63', NULL, NULL, NULL, NULL, 'BNAC08G15290D PROTEIN', 248053),
(380895, 'PTHR31579:SF85', NULL, NULL, NULL, NULL, 'OS01G0915000 PROTEIN', 248053),
(380896, 'PTHR31579:SF40', NULL, NULL, NULL, NULL, 'BNAA01G19160D PROTEIN', 248053),
(380897, 'PTHR31579:SF84', NULL, NULL, NULL, NULL, 'IMPORT ATP-BINDING PROTEIN, PUTATIVE (DUF506)-RELATED', 248053),
(380898, 'PTHR31579:SF34', NULL, NULL, NULL, NULL, 'OS01G0879600 PROTEIN', 248053),
(380899, 'PTHR31579:SF14', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SUBUNIT BETA-BETA PROTEIN, PUTATIVE (DUF506)-RELATED', 248053),
(380900, 'PTHR31579:SF58', NULL, NULL, NULL, NULL, 'PLANT-SPECIFIC DOMAIN TIGR01615 FAMILY PROTEIN EXPRESSED', 248053),
(380901, 'PTHR31579:SF79', NULL, NULL, NULL, NULL, '', 248053),
(380902, 'PTHR31579:SF38', NULL, NULL, NULL, NULL, 'PLANT-SPECIFIC DOMAIN TIGR01615 FAMILY PROTEIN', 248053),
(380903, 'PTHR31579:SF37', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248053),
(380904, 'PTHR31579:SF59', NULL, NULL, NULL, NULL, 'BNAC01G20890D PROTEIN', 248053),
(380905, 'PTHR31579:SF39', NULL, NULL, NULL, NULL, 'OS01G0973600 PROTEIN', 248053),
(380906, 'PTHR31579:SF8', NULL, NULL, NULL, NULL, 'OS10G0417800 PROTEIN', 248053),
(380907, 'PTHR31579:SF2', NULL, NULL, NULL, NULL, 'DUF506 FAMILY PROTEIN', 248053),
(380908, 'PTHR31579:SF70', NULL, NULL, NULL, NULL, '', 248053),
(380909, 'PTHR31579:SF50', NULL, NULL, NULL, NULL, '', 248053),
(380910, 'PTHR31579:SF43', NULL, NULL, NULL, NULL, 'DUF506 FAMILY PROTEIN', 248053),
(380911, 'PTHR31579:SF87', NULL, NULL, NULL, NULL, '', 248053),
(380912, 'PTHR31579:SF65', NULL, NULL, NULL, NULL, 'BNAA09G43630D PROTEIN', 248053),
(380913, 'PTHR31579:SF86', NULL, NULL, NULL, NULL, 'OS03G0162500 PROTEIN', 248053),
(380914, 'PTHR31579:SF64', NULL, NULL, NULL, NULL, '', 248053),
(380915, 'PTHR31579:SF42', NULL, NULL, NULL, NULL, 'DUF506 FAMILY PROTEIN (DUF506)', 248053),
(380916, 'PTHR31579', NULL, NULL, NULL, NULL, 'OS03G0796600 PROTEIN', 248053),
(380917, 'PTHR31579:SF45', NULL, NULL, NULL, NULL, '', 248053),
(380918, 'PTHR31579:SF89', NULL, NULL, NULL, NULL, 'F21O3.6 PROTEIN', 248053),
(380919, 'PTHR31579:SF88', NULL, NULL, NULL, NULL, '', 248053),
(380920, 'PTHR31579:SF47', NULL, NULL, NULL, NULL, 'PLANT-SPECIFIC DOMAIN TIGR01615 FAMILY PROTEIN', 248053),
(380921, 'PTHR31579:SF69', NULL, NULL, NULL, NULL, '', 248053),
(380922, 'PTHR31579:SF46', NULL, NULL, NULL, NULL, 'OS05G0519300 PROTEIN', 248053);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(380923, 'PTHR31579:SF49', NULL, NULL, NULL, NULL, 'DUF506 FAMILY PROTEIN', 248053),
(380924, 'PTHR31579:SF1', NULL, NULL, NULL, NULL, 'OS03G0796600 PROTEIN', 248053),
(380925, 'PTHR42869:SF1', NULL, NULL, NULL, NULL, 'SLL0572 PROTEIN', 248054),
(380926, 'PTHR42869', NULL, NULL, NULL, NULL, 'SLL0572 PROTEIN', 248054),
(380927, 'PTHR16255', NULL, NULL, NULL, NULL, 'REQUIRED FOR MEIOTIC NUCLEAR DIVISION PROTEIN 1 HOMOLOG', 248055),
(380928, 'PTHR16255:SF15', NULL, NULL, NULL, NULL, 'SPORULATION PROTEIN RMD1', 248055),
(380929, 'PTHR16255:SF16', NULL, NULL, NULL, NULL, 'PROTEIN RETARDED ROOT GROWTH, MITOCHONDRIAL', 248055),
(380930, 'PTHR16255:SF6', NULL, NULL, NULL, NULL, 'PROTEIN RETARDED ROOT GROWTH-LIKE', 248055),
(380931, 'PTHR16255:SF19', NULL, NULL, NULL, NULL, 'DUF155 DOMAIN-CONTAINING PROTEIN', 248055),
(380932, 'PTHR16255:SF4', NULL, NULL, NULL, NULL, 'SPORULATION PROTEIN RMD8', 248055),
(380933, 'PTHR16255:SF5', NULL, NULL, NULL, NULL, 'DUF155 DOMAIN-CONTAINING PROTEIN', 248055),
(380934, 'PTHR16255:SF20', NULL, NULL, NULL, NULL, 'DUF155 DOMAIN-CONTAINING PROTEIN', 248055),
(380935, 'PTHR16255:SF21', NULL, NULL, NULL, NULL, 'OS01G0764300 PROTEIN', 248055),
(380936, 'PTHR16255:SF1', NULL, NULL, NULL, NULL, 'REQUIRED FOR MEIOTIC NUCLEAR DIVISION PROTEIN 1 HOMOLOG', 248055),
(380937, 'PTHR45096', NULL, NULL, NULL, NULL, 'PROTEIN NEDD1', 248056),
(380938, 'PTHR45096:SF2', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 248056),
(380939, 'PTHR45096:SF1', NULL, NULL, NULL, NULL, 'PROTEIN NEDD1', 248056),
(380940, 'PTHR47203', NULL, NULL, NULL, NULL, '', 248057),
(380941, 'PTHR47203:SF1', NULL, NULL, NULL, NULL, 'HYPOTHETICAL BASE EXCISION DNA REPAIR PROTEIN (EUROFUNG)', 248057),
(380942, 'PTHR48067:SF1', NULL, NULL, NULL, NULL, 'GPI-ANCHOR TRANSAMIDASE', 248058),
(380943, 'PTHR48067:SF2', NULL, NULL, NULL, NULL, '', 248058),
(380944, 'PTHR48067', NULL, NULL, NULL, NULL, 'GPI-ANCHOR TRANSAMIDASE', 248058),
(380945, 'PTHR11829:SF380', NULL, NULL, NULL, NULL, 'PROTEIN FORK HEAD', 248059),
(380946, 'PTHR11829:SF180', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN I1', 248059),
(380947, 'PTHR11829:SF209', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN B1', 248059),
(380948, 'PTHR11829:SF206', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN Q1', 248059),
(380949, 'PTHR11829:SF204', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN L1', 248059),
(380950, 'PTHR11829:SF348', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN D1', 248059),
(380951, 'PTHR11829:SF389', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN D4-LIKE 1', 248059),
(380952, 'PTHR11829:SF368', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN E1', 248059),
(380953, 'PTHR11829:SF167', NULL, NULL, NULL, NULL, 'HEPATOCYTE NUCLEAR FACTOR 3-BETA', 248059),
(380954, 'PTHR11829:SF189', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN C2', 248059),
(380955, 'PTHR11829:SF387', NULL, NULL, NULL, NULL, 'FORK-HEAD DOMAIN-CONTAINING PROTEIN', 248059),
(380956, 'PTHR11829:SF343', NULL, NULL, NULL, NULL, 'FORK HEAD DOMAIN-CONTAINING PROTEIN FD3-RELATED', 248059),
(380957, 'PTHR11829:SF388', NULL, NULL, NULL, NULL, 'FORK HEAD DOMAIN TRANSCRIPTION FACTOR SLP1-RELATED', 248059),
(380958, 'PTHR11829:SF201', NULL, NULL, NULL, NULL, 'HEPATOCYTE NUCLEAR FACTOR 3-GAMMA', 248059),
(380959, 'PTHR11829:SF341', NULL, NULL, NULL, NULL, 'FORK-HEAD DOMAIN-CONTAINING PROTEIN', 248059),
(380960, 'PTHR11829:SF363', NULL, NULL, NULL, NULL, 'FORK-HEAD DOMAIN-CONTAINING PROTEIN', 248059),
(380961, 'PTHR11829:SF385', NULL, NULL, NULL, NULL, 'FORKHEAD BOX Q1A', 248059),
(380962, 'PTHR11829:SF342', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN L2', 248059),
(380963, 'PTHR11829:SF386', NULL, NULL, NULL, NULL, 'FORKHEAD BOX Q1B', 248059),
(380964, 'PTHR11829:SF361', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN D3', 248059),
(380965, 'PTHR11829:SF383', NULL, NULL, NULL, NULL, 'FORKHEAD BOX I2', 248059),
(380966, 'PTHR11829:SF68', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN C1', 248059),
(380967, 'PTHR11829:SF384', NULL, NULL, NULL, NULL, 'FORK-HEAD DOMAIN-CONTAINING PROTEIN', 248059);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(380968, 'PTHR11829:SF340', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN H1', 248059),
(380969, 'PTHR11829:SF142', NULL, NULL, NULL, NULL, 'FORKHEAD BOX Q2', 248059),
(380970, 'PTHR11829:SF382', NULL, NULL, NULL, NULL, 'DEFECTIVE PHARYNGEAL DEVELOPMENT PROTEIN 4', 248059),
(380971, 'PTHR11829:SF390', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN C2', 248059),
(380972, 'PTHR11829:SF391', NULL, NULL, NULL, NULL, 'FORKHEAD BOX L1-RELATED', 248059),
(380973, 'PTHR11829', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN', 248059),
(380974, 'PTHR11829:SF358', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN F', 248059),
(380975, 'PTHR11829:SF215', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN B2', 248059),
(380976, 'PTHR11829:SF335', NULL, NULL, NULL, NULL, 'FORKHEAD BOX D2', 248059),
(380977, 'PTHR11829:SF310', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN I3', 248059),
(380978, 'PTHR11829:SF211', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN L3', 248059),
(380979, 'PTHR11829:SF156', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN E3', 248059),
(380980, 'PTHR11829:SF377', NULL, NULL, NULL, NULL, 'FORK HEAD DOMAIN-CONTAINING PROTEIN FD4-RELATED', 248059),
(380981, 'PTHR11829:SF372', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN I2', 248059),
(380982, 'PTHR11829:SF394', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR FOXL2', 248059),
(380983, 'PTHR11829:SF350', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN D4-RELATED', 248059),
(380984, 'PTHR11829:SF373', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN D2', 248059),
(380985, 'PTHR11829:SF395', NULL, NULL, NULL, NULL, 'FORK HEAD DOMAIN-CONTAINING PROTEIN CROCODILE', 248059),
(380986, 'PTHR11829:SF392', NULL, NULL, NULL, NULL, 'FORKHEAD BOX E1', 248059),
(380987, 'PTHR11829:SF370', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN S1', 248059),
(380988, 'PTHR11829:SF195', NULL, NULL, NULL, NULL, 'HEPATOCYTE NUCLEAR FACTOR 3-ALPHA', 248059),
(380989, 'PTHR11829:SF393', NULL, NULL, NULL, NULL, 'FORK HEAD DOMAIN-CONTAINING PROTEIN FD3-LIKE PROTEIN', 248059),
(380990, 'PTHR15606', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 8/LIPOPOLYSACCHARIDE SPECIFIC RESPONSE-7-RELATED', 248060),
(380991, 'PTHR15606:SF5', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 248060),
(380992, 'PTHR15606:SF4', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 8', 248060),
(380993, 'PTHR15606:SF7', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 8', 248060),
(380994, 'PTHR11679:SF62', NULL, NULL, NULL, NULL, 'SI:RP71-10D23.3', 248061),
(380995, 'PTHR11679:SF84', NULL, NULL, NULL, NULL, 'BNAC05G09460D PROTEIN', 248061),
(380996, 'PTHR11679:SF83', NULL, NULL, NULL, NULL, 'BNAA02G28070D PROTEIN', 248061),
(380997, 'PTHR11679:SF3', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 45', 248061),
(380998, 'PTHR11679:SF72', NULL, NULL, NULL, NULL, '', 248061),
(380999, 'PTHR11679:SF82', NULL, NULL, NULL, NULL, 'SEC1 FAMILY TRANSPORT PROTEIN SLY1-LIKE', 248061),
(381000, 'PTHR11679:SF71', NULL, NULL, NULL, NULL, 'SEC1 FAMILY DOMAIN-CONTAINING PROTEIN 2', 248061),
(381001, 'PTHR11679:SF28', NULL, NULL, NULL, NULL, 'PROTEIN CBG13544', 248061),
(381002, 'PTHR11679', NULL, NULL, NULL, NULL, 'VESICLE PROTEIN SORTING-ASSOCIATED', 248061),
(381003, 'PTHR11679:SF27', NULL, NULL, NULL, NULL, 'SYNTAXIN-BINDING PROTEIN 2', 248061),
(381004, 'PTHR11679:SF37', NULL, NULL, NULL, NULL, '', 248061),
(381005, 'PTHR11679:SF35', NULL, NULL, NULL, NULL, 'SYNTAXIN-BINDING PROTEIN 1', 248061),
(381006, 'PTHR11679:SF68', NULL, NULL, NULL, NULL, 'SEC1 FAMILY TRANSPORT PROTEIN SLY1', 248061),
(381007, 'PTHR11679:SF57', NULL, NULL, NULL, NULL, '', 248061),
(381008, 'PTHR11679:SF33', NULL, NULL, NULL, NULL, 'SYNTAXIN-BINDING PROTEIN 3', 248061),
(381009, 'PTHR11679:SF88', NULL, NULL, NULL, NULL, 'SEC1-LIKE PROTEIN-RELATED', 248061),
(381010, 'PTHR11679:SF65', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT SEC1B', 248061),
(381011, 'PTHR11679:SF76', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT SEC1A', 248061),
(381012, 'PTHR11679:SF2', NULL, NULL, NULL, NULL, 'SEC1 FAMILY DOMAIN-CONTAINING PROTEIN 1', 248061);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(381013, 'PTHR11679:SF42', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT SEC1A-RELATED', 248061),
(381014, 'PTHR11679:SF86', NULL, NULL, NULL, NULL, 'SNARE-INTERACTING KEULE-LIKE PROTEIN', 248061),
(381015, 'PTHR11679:SF85', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 33A', 248061),
(381016, 'PTHR11679:SF30', NULL, NULL, NULL, NULL, 'PROTEIN ROP', 248061),
(381017, 'PTHR11679:SF1', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 33B', 248061),
(381018, 'PTHR42260:SF2', NULL, NULL, NULL, NULL, '', 248062),
(381019, 'PTHR42260', NULL, NULL, NULL, NULL, '', 248062),
(381020, 'PTHR42260:SF1', NULL, NULL, NULL, NULL, '', 248062),
(381021, 'PTHR37163', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', 248063),
(381022, 'PTHR37163:SF1', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', 248063),
(381023, 'PTHR46711:SF1', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SETD2', 248064),
(381024, 'PTHR46711', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SETD2', 248064),
(381025, 'PTHR34573:SF1', NULL, NULL, NULL, NULL, 'VKC DOMAIN-CONTAINING PROTEIN', 248065),
(381026, 'PTHR34573', NULL, NULL, NULL, NULL, 'VKC DOMAIN-CONTAINING PROTEIN', 248065),
(381027, 'PTHR21731:SF0', NULL, NULL, NULL, NULL, 'SYNAPTONEMAL COMPLEX CENTRAL ELEMENT PROTEIN 1', 248066),
(381028, 'PTHR21731', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248066),
(381029, 'PTHR21731:SF1', NULL, NULL, NULL, NULL, 'SYNAPTONEMAL COMPLEX CENTRAL ELEMENT PROTEIN 1-LIKE', 248066),
(381030, 'PTHR21415', NULL, NULL, NULL, NULL, 'U7 SNRNA-ASSOCIATED SM-LIKE PROTEIN LSM11', 248067),
(381031, 'PTHR21415:SF1', NULL, NULL, NULL, NULL, 'U7 SNRNA-ASSOCIATED SM-LIKE PROTEIN LSM11', 248067),
(381032, 'PTHR19424', NULL, NULL, NULL, NULL, 'HEAT SHOCK FACTOR BINDING PROTEIN 1', 248068),
(381033, 'PTHR19424:SF9', NULL, NULL, NULL, NULL, 'HEAT SHOCK FACTOR-BINDING PROTEIN', 248068),
(381034, 'PTHR19424:SF8', NULL, NULL, NULL, NULL, 'HEAT SHOCK FACTOR-BINDING PROTEIN 1-LIKE', 248068),
(381035, 'PTHR19424:SF7', NULL, NULL, NULL, NULL, '', 248068),
(381036, 'PTHR19424:SF10', NULL, NULL, NULL, NULL, 'HEAT SHOCK FACTOR-BINDING PROTEIN 1-LIKE', 248068),
(381037, 'PTHR19424:SF4', NULL, NULL, NULL, NULL, 'HEAT SHOCK FACTOR-BINDING PROTEIN 1-LIKE PROTEIN 1', 248068),
(381038, 'PTHR19424:SF3', NULL, NULL, NULL, NULL, 'HEAT SHOCK FACTOR-BINDING PROTEIN 1', 248068),
(381039, 'PTHR19424:SF0', NULL, NULL, NULL, NULL, 'HEAT SHOCK FACTOR BINDING PROTEIN 1-RELATED', 248068),
(381040, 'PTHR16803:SF0', NULL, NULL, NULL, NULL, 'HIGH AFFINITY IMMUNOGLOBULIN EPSILON RECEPTOR SUBUNIT GAMMA', 248069),
(381041, 'PTHR16803', NULL, NULL, NULL, NULL, 'HIGH AFFINITY IMMUNOGLOBULIN EPSILON RECEPTOR GAMMA-SUBUNIT', 248069),
(381042, 'PTHR31604:SF43', NULL, NULL, NULL, NULL, 'BNAANNG09150D PROTEIN', 248070),
(381043, 'PTHR31604:SF22', NULL, NULL, NULL, NULL, 'PROTEIN SHI RELATED SEQUENCE 6', 248070),
(381044, 'PTHR31604:SF42', NULL, NULL, NULL, NULL, 'PROTEIN SHI RELATED SEQUENCE 1-LIKE', 248070),
(381045, 'PTHR31604:SF20', NULL, NULL, NULL, NULL, 'PROTEIN SHI RELATED SEQUENCE 1', 248070),
(381046, 'PTHR31604:SF40', NULL, NULL, NULL, NULL, 'PROTEIN SHI RELATED SEQUENCE 5', 248070),
(381047, 'PTHR31604:SF2', NULL, NULL, NULL, NULL, 'PROTEIN SHI RELATED SEQUENCE 7', 248070),
(381048, 'PTHR31604:SF5', NULL, NULL, NULL, NULL, 'OS06G0712600 PROTEIN', 248070),
(381049, 'PTHR31604:SF4', NULL, NULL, NULL, NULL, 'PROTEIN SHI RELATED SEQUENCE 1 ISOFORM X1', 248070),
(381050, 'PTHR31604', NULL, NULL, NULL, NULL, 'PROTEIN LATERAL ROOT PRIMORDIUM 1', 248070),
(381051, 'PTHR31604:SF18', NULL, NULL, NULL, NULL, 'PROTEIN EXPRESSION OF TERPENOIDS 1', 248070),
(381052, 'PTHR31604:SF16', NULL, NULL, NULL, NULL, 'PROTEIN SHI RELATED SEQUENCE 3', 248070),
(381053, 'PTHR31604:SF36', NULL, NULL, NULL, NULL, 'PROTEIN SHI RELATED SEQUENCE 1-RELATED', 248070),
(381054, 'PTHR31604:SF15', NULL, NULL, NULL, NULL, 'PROTEIN SHI RELATED SEQUENCE 1', 248070),
(381055, 'PTHR31604:SF54', NULL, NULL, NULL, NULL, 'PROTEIN SHI RELATED SEQUENCE 3-LIKE', 248070),
(381056, 'PTHR31604:SF33', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR STY-LRP1 FAMILY-RELATED', 248070);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(381057, 'PTHR31604:SF55', NULL, NULL, NULL, NULL, 'PROTEIN SHI RELATED SEQUENCE 1-LIKE', 248070),
(381058, 'PTHR31604:SF30', NULL, NULL, NULL, NULL, 'PROTEIN LATERAL ROOT PRIMORDIUM 1', 248070),
(381059, 'PTHR31604:SF52', NULL, NULL, NULL, NULL, '', 248070),
(381060, 'PTHR31604:SF53', NULL, NULL, NULL, NULL, '', 248070),
(381061, 'PTHR31604:SF50', NULL, NULL, NULL, NULL, 'OS08G0547600 PROTEIN', 248070),
(381062, 'PTHR31604:SF51', NULL, NULL, NULL, NULL, '', 248070),
(381063, 'PTHR31604:SF29', NULL, NULL, NULL, NULL, 'BNAC02G24360D PROTEIN', 248070),
(381064, 'PTHR31604:SF28', NULL, NULL, NULL, NULL, 'PROTEIN SHI RELATED SEQUENCE 6', 248070),
(381065, 'PTHR31604:SF25', NULL, NULL, NULL, NULL, 'PROTEIN SHORT INTERNODES', 248070),
(381066, 'PTHR31604:SF48', NULL, NULL, NULL, NULL, 'PROTEIN SHI RELATED SEQUENCE 2', 248070),
(381067, 'PTHR31604:SF26', NULL, NULL, NULL, NULL, 'PROTEIN SHI RELATED SEQUENCE 4', 248070),
(381068, 'PTHR31604:SF46', NULL, NULL, NULL, NULL, 'LRP1 CARBOXY-TERMINAL DOMAIN PROTEIN', 248070),
(381069, 'PTHR47582:SF1', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 248071),
(381070, 'PTHR47582', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 248071),
(381071, 'PTHR36380', NULL, NULL, NULL, NULL, 'BNAA03G58330D PROTEIN', 248072),
(381072, 'PTHR36380:SF1', NULL, NULL, NULL, NULL, 'BNAA03G58330D PROTEIN', 248072),
(381073, 'PTHR14527:SF2', NULL, NULL, NULL, NULL, 'PROTEIN MIS12 HOMOLOG', 248073),
(381074, 'PTHR14527', NULL, NULL, NULL, NULL, 'PROTEIN MIS12 HOMOLOG', 248073),
(381075, 'PTHR36815', NULL, NULL, NULL, NULL, 'BNAC03G48760D PROTEIN', 248074),
(381076, 'PTHR36815:SF1', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 248074),
(381077, 'PTHR12975', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN  TRAPP', 248075),
(381078, 'PTHR12975:SF6', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT 8', 248075),
(381079, 'PTHR12975:SF7', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN PARTICLE SUBUNIT TRS85-1', 248075),
(381080, 'PTHR47160:SF5', NULL, NULL, NULL, NULL, 'MULE DOMAIN-CONTAINING PROTEIN', 248076),
(381081, 'PTHR47160', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 248076),
(381082, 'PTHR47160:SF9', NULL, NULL, NULL, NULL, 'MULE DOMAIN-CONTAINING PROTEIN', 248076),
(381083, 'PTHR47160:SF8', NULL, NULL, NULL, NULL, 'MULE DOMAIN-CONTAINING PROTEIN', 248076),
(381084, 'PTHR47160:SF12', NULL, NULL, NULL, NULL, 'FLYWCH-TYPE DOMAIN-CONTAINING PROTEIN', 248076),
(381085, 'PTHR47160:SF13', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 248076),
(381086, 'PTHR47160:SF10', NULL, NULL, NULL, NULL, 'THAP-TYPE DOMAIN-CONTAINING PROTEIN', 248076),
(381087, 'PTHR47160:SF11', NULL, NULL, NULL, NULL, '', 248076),
(381088, 'PTHR47115:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 183', 248077),
(381089, 'PTHR47115', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 183', 248077),
(381090, 'PTHR44579', NULL, NULL, NULL, NULL, 'OS01G0730500 PROTEIN', 248078),
(381091, 'PTHR44579:SF2', NULL, NULL, NULL, NULL, 'OS01G0730500 PROTEIN', 248078),
(381092, 'PTHR44579:SF4', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 248078),
(381093, 'PTHR44579:SF5', NULL, NULL, NULL, NULL, 'OS05G0529700 PROTEIN', 248078),
(381094, 'PTHR44579:SF6', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK AMINO-TERMINAL DOMAIN PROTEIN', 248078),
(381095, 'PTHR15544:SF0', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 33', 248079),
(381096, 'PTHR15544', NULL, NULL, NULL, NULL, 'OSMOSIS RESPONSIVE FACTOR', 248079),
(381097, 'PTHR11105:SF0', NULL, NULL, NULL, NULL, 'CITRAMALYL-COA LYASE, MITOCHONDRIAL', 248080),
(381098, 'PTHR11105', NULL, NULL, NULL, NULL, 'CITRATE LYASE SUBUNIT BETA-RELATED', 248080),
(381099, 'PTHR37729', NULL, NULL, NULL, NULL, 'NEUROFILAMENT PROTEIN-LIKE PROTEIN', 248081),
(381100, 'PTHR37729:SF1', NULL, NULL, NULL, NULL, 'NEUROFILAMENT PROTEIN-LIKE PROTEIN', 248081),
(381101, 'PTHR10851:SF0', NULL, NULL, NULL, NULL, 'PYRIDOXINE-5''-PHOSPHATE OXIDASE', 248082),
(381102, 'PTHR10851', NULL, NULL, NULL, NULL, 'PYRIDOXINE-5-PHOSPHATE OXIDASE', 248082);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(381103, 'PTHR10851:SF4', NULL, NULL, NULL, NULL, 'PYRIDOXAL 5''-PHOSPHATE SYNTHASE', 248082),
(381104, 'PTHR10851:SF3', NULL, NULL, NULL, NULL, 'PYRIDOXINE/PYRIDOXAMINE 5''-PHOSPHATE OXIDASE 2', 248082),
(381105, 'PTHR39385', NULL, NULL, NULL, NULL, 'PROTEIN CBG20422', 248083),
(381106, 'PTHR39385:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG20423', 248083),
(381107, 'PTHR39385:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG07297', 248083),
(381108, 'PTHR39385:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG20422', 248083),
(381109, 'PTHR39385:SF4', NULL, NULL, NULL, NULL, 'CUB DOMAIN-CONTAINING PROTEIN', 248083),
(381110, 'PTHR39385:SF3', NULL, NULL, NULL, NULL, 'ELRR (EXTRACELLULAR LEUCINE-RICH REPEAT) ONLY', 248083),
(381111, 'PTHR10698:SF0', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT H', 248084),
(381112, 'PTHR10698', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT H', 248084),
(381113, 'PTHR10698:SF3', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT H', 248084),
(381114, 'PTHR10698:SF1', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT H 1-RELATED', 248084),
(381115, 'PTHR10698:SF6', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT H', 248084),
(381116, 'PTHR33644', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 62-RELATED', 248085),
(381117, 'PTHR33644:SF7', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 248085),
(381118, 'PTHR33644:SF5', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 62', 248085),
(381119, 'PTHR33644:SF4', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 63', 248085),
(381120, 'PTHR33644:SF3', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 248085),
(381121, 'PTHR33644:SF2', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 248085),
(381122, 'PTHR15711:SF53', NULL, NULL, NULL, NULL, 'RAP-GAP DOMAIN-CONTAINING PROTEIN', 248086),
(381123, 'PTHR15711:SF64', NULL, NULL, NULL, NULL, 'ZMP:0000001168', 248086),
(381124, 'PTHR15711:SF21', NULL, NULL, NULL, NULL, 'RAPA GUANOSINE TRIPHOSPHATASE-ACTIVATING PROTEIN B', 248086),
(381125, 'PTHR15711:SF32', NULL, NULL, NULL, NULL, 'RAP GTPASE ACTIVATING PROTEIN 1, ISOFORM H', 248086),
(381126, 'PTHR15711:SF10', NULL, NULL, NULL, NULL, 'SIGNAL-INDUCED PROLIFERATION-ASSOCIATED 1-LIKE PROTEIN 1', 248086),
(381127, 'PTHR15711:SF7', NULL, NULL, NULL, NULL, 'SIGNAL-INDUCED PROLIFERATION-ASSOCIATED 1-LIKE PROTEIN 2', 248086),
(381128, 'PTHR15711:SF65', NULL, NULL, NULL, NULL, 'RAP-GAP DOMAIN-CONTAINING PROTEIN', 248086),
(381129, 'PTHR15711:SF62', NULL, NULL, NULL, NULL, 'GTPASE-ACTIVATING RAP/RAN-GAP DOMAIN-LIKE PROTEIN 3', 248086),
(381130, 'PTHR15711:SF61', NULL, NULL, NULL, NULL, 'RAPA GUANOSINE TRIPHOSPHATASE-ACTIVATING PROTEIN 1', 248086),
(381131, 'PTHR15711:SF3', NULL, NULL, NULL, NULL, 'RAP1 GTPASE-ACTIVATING PROTEIN 1', 248086),
(381132, 'PTHR15711:SF1', NULL, NULL, NULL, NULL, 'GTPASE ACTIVATING PROTEIN RAP1-GAP', 248086),
(381133, 'PTHR15711:SF17', NULL, NULL, NULL, NULL, 'RAP1 GTPASE-ACTIVATING PROTEIN 2', 248086),
(381134, 'PTHR15711:SF15', NULL, NULL, NULL, NULL, 'SIGNAL-INDUCED PROLIFERATION-ASSOCIATED 1-LIKE PROTEIN 3', 248086),
(381135, 'PTHR15711:SF59', NULL, NULL, NULL, NULL, 'RAP-GAP DOMAIN-CONTAINING PROTEIN', 248086),
(381136, 'PTHR15711:SF16', NULL, NULL, NULL, NULL, 'RAP-GAP DOMAIN-CONTAINING PROTEIN', 248086),
(381137, 'PTHR15711:SF25', NULL, NULL, NULL, NULL, 'RADISH, ISOFORM I', 248086),
(381138, 'PTHR15711:SF14', NULL, NULL, NULL, NULL, 'SIGNAL-INDUCED PROLIFERATION-ASSOCIATED PROTEIN 1', 248086),
(381139, 'PTHR15711:SF22', NULL, NULL, NULL, NULL, 'RAP-GAP DOMAIN-CONTAINING PROTEIN', 248086),
(381140, 'PTHR15711', NULL, NULL, NULL, NULL, 'RAP GTPASE-ACTIVATING PROTEIN', 248086),
(381141, 'PTHR15711:SF8', NULL, NULL, NULL, NULL, 'PH AND RAP-GAP DOMAIN-CONTAINING PROTEIN DDB_G0271806', 248086),
(381142, 'PTHR48053:SF4', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248087),
(381143, 'PTHR48053:SF70', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248087);
INSERT INTO "PUBLIC"."MODEL" VALUES
(381144, 'PTHR48053:SF71', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT FAMILY PROTEIN, EXPRESSED', 248087),
(381145, 'PTHR48053:SF130', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 248087),
(381146, 'PTHR48053:SF31', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE BRI1-LIKE 1', 248087),
(381147, 'PTHR48053:SF132', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248087),
(381148, 'PTHR48053:SF6', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE EFR', 248087),
(381149, 'PTHR48053:SF131', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE BAM2', 248087),
(381150, 'PTHR48053:SF73', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248087),
(381151, 'PTHR48053:SF9', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248087),
(381152, 'PTHR48053', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT FAMILY PROTEIN, EXPRESSED', 248087),
(381153, 'PTHR48053:SF78', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248087),
(381154, 'PTHR48053:SF123', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248087),
(381155, 'PTHR48053:SF122', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 248087),
(381156, 'PTHR48053:SF32', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT FAMILY PROTEIN, EXPRESSED', 248087),
(381157, 'PTHR48053:SF125', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE FAMILY PROTEIN', 248087),
(381158, 'PTHR48053:SF124', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE FAMILY PROTEIN', 248087),
(381159, 'PTHR48053:SF127', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248087),
(381160, 'PTHR48053:SF126', NULL, NULL, NULL, NULL, 'MDIS1-INTERACTING RECEPTOR LIKE KINASE 2-LIKE ISOFORM X1', 248087),
(381161, 'PTHR48053:SF39', NULL, NULL, NULL, NULL, 'SERINE-THREONINE PROTEIN KINASE, PLANT-TYPE', 248087),
(381162, 'PTHR48053:SF129', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248087),
(381163, 'PTHR48053:SF128', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248087),
(381164, 'PTHR48053:SF37', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 248087),
(381165, 'PTHR48053:SF141', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 248087),
(381166, 'PTHR48053:SF63', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT (LRR) FAMILY PROTEIN', 248087),
(381167, 'PTHR48053:SF20', NULL, NULL, NULL, NULL, 'OS03G0228800 PROTEIN', 248087),
(381168, 'PTHR48053:SF140', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 248087),
(381169, 'PTHR48053:SF64', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE RGI5', 248087),
(381170, 'PTHR48053:SF143', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE EFR', 248087),
(381171, 'PTHR48053:SF142', NULL, NULL, NULL, NULL, 'REPEAT RECEPTOR-LIKE PROTEIN KINASE FAMILY PROTEIN, PUTATIVE-RELATED', 248087),
(381172, 'PTHR48053:SF23', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248087),
(381173, 'PTHR48053:SF134', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248087),
(381174, 'PTHR48053:SF133', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINE RECEPTOR 1', 248087),
(381175, 'PTHR48053:SF136', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248087),
(381176, 'PTHR48053:SF65', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE FAMILY PROTEIN', 248087),
(381177, 'PTHR48053:SF22', NULL, NULL, NULL, NULL, 'MDIS1-INTERACTING RECEPTOR LIKE KINASE 2-LIKE', 248087),
(381178, 'PTHR48053:SF135', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 248087),
(381179, 'PTHR48053:SF138', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248087),
(381180, 'PTHR48053:SF28', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT FAMILY PROTEIN, EXPRESSED', 248087),
(381181, 'PTHR48053:SF137', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE FAMILY PROTEIN-RELATED', 248087);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(381182, 'PTHR48053:SF139', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN KINASE', 248087),
(381183, 'PTHR48053:SF96', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248087),
(381184, 'PTHR48053:SF50', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248087),
(381185, 'PTHR48053:SF51', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE EFR', 248087),
(381186, 'PTHR48053:SF109', NULL, NULL, NULL, NULL, 'PROTEIN KINASE', 248087),
(381187, 'PTHR48053:SF145', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248087),
(381188, 'PTHR48053:SF144', NULL, NULL, NULL, NULL, 'OS02G0216000 PROTEIN', 248087),
(381189, 'PTHR48053:SF57', NULL, NULL, NULL, NULL, 'OS07G0134200 PROTEIN', 248087),
(381190, 'PTHR48053:SF103', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248087),
(381191, 'PTHR48053:SF147', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248087),
(381192, 'PTHR48053:SF102', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 248087),
(381193, 'PTHR48053:SF55', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE BRI1-LIKE 2', 248087),
(381194, 'PTHR48053:SF11', NULL, NULL, NULL, NULL, 'PROTEIN BRASSINOSTEROID INSENSITIVE 1', 248087),
(381195, 'PTHR48053:SF146', NULL, NULL, NULL, NULL, 'MDIS1-INTERACTING RECEPTOR LIKE KINASE 2-LIKE', 248087),
(381196, 'PTHR48053:SF149', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE FAMILY PROTEIN', 248087),
(381197, 'PTHR48053:SF105', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR KINASE', 248087),
(381198, 'PTHR48053:SF148', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 248087),
(381199, 'PTHR48053:SF107', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE BAM1', 248087),
(381200, 'PTHR48053:SF14', NULL, NULL, NULL, NULL, '', 248087),
(381201, 'PTHR48053:SF58', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248087),
(381202, 'PTHR48053:SF59', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 248087),
(381203, 'PTHR48053:SF106', NULL, NULL, NULL, NULL, 'BRASSINOSTEROID LRR RECEPTOR KINASE BRL3', 248087),
(381204, 'PTHR48053:SF81', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE FAMILY PROTEIN-RELATED', 248087),
(381205, 'PTHR48053:SF42', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE', 248087),
(381206, 'PTHR48053:SF121', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE FAMILY PROTEIN-RELATED', 248087),
(381207, 'PTHR48053:SF120', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248087),
(381208, 'PTHR48053:SF40', NULL, NULL, NULL, NULL, 'LEUCINE-RICH RECEPTOR KINASE', 248087),
(381209, 'PTHR48053:SF84', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248087),
(381210, 'PTHR48053:SF119', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE FAMILY PROTEIN', 248087),
(381211, 'PTHR48053:SF112', NULL, NULL, NULL, NULL, 'MDIS1-INTERACTING RECEPTOR LIKE KINASE 2', 248087),
(381212, 'PTHR48053:SF43', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE BAM3', 248087),
(381213, 'PTHR48053:SF114', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 248087),
(381214, 'PTHR48053:SF44', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-CONTAINING PROTEIN-RELATED', 248087),
(381215, 'PTHR48053:SF113', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248087),
(381216, 'PTHR48053:SF116', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248087),
(381217, 'PTHR48053:SF115', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248087),
(381218, 'PTHR48053:SF47', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248087),
(381219, 'PTHR48053:SF118', NULL, NULL, NULL, NULL, 'OS07G0498400 PROTEIN', 248087),
(381220, 'PTHR48053:SF117', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248087);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(381221, 'PTHR48053:SF48', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE BRI1-LIKE 3', 248087),
(381222, 'PTHR40732', NULL, NULL, NULL, NULL, 'UPF0218 PROTEIN TK1697', 248088),
(381223, 'PTHR40732:SF1', NULL, NULL, NULL, NULL, 'GTP-DEPENDENT DEPHOSPHO-COA KINASE', 248088),
(381224, 'PTHR19956', NULL, NULL, NULL, NULL, 'LAMIN TAIL DOMAIN-CONTAINING PROTEIN 2', 248089),
(381225, 'PTHR19956:SF5', NULL, NULL, NULL, NULL, 'LAMIN TAIL DOMAIN-CONTAINING PROTEIN 2', 248089),
(381226, 'PTHR28527', NULL, NULL, NULL, NULL, 'MATING-TYPE SWITCHING PROTEIN SWI2-RELATED', 248090),
(381227, 'PTHR28527:SF2', NULL, NULL, NULL, NULL, 'MATING-TYPE SWITCHING PROTEIN SWI2', 248090),
(381228, 'PTHR28527:SF1', NULL, NULL, NULL, NULL, 'SWI5-DEPENDENT RECOMBINATION DNA REPAIR PROTEIN 1', 248090),
(381229, 'PTHR42985:SF2', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT MULTIVITAMIN TRANSPORTER', 248091),
(381230, 'PTHR42985:SF40', NULL, NULL, NULL, NULL, 'SODIUM-COUPLED PERMEASE', 248091),
(381231, 'PTHR42985', NULL, NULL, NULL, NULL, 'SODIUM-COUPLED MONOCARBOXYLATE TRANSPORTER', 248091),
(381232, 'PTHR42985:SF25', NULL, NULL, NULL, NULL, 'SODIUM-COUPLED MONOCARBOXYLATE TRANSPORTER 1', 248091),
(381233, 'PTHR42985:SF15', NULL, NULL, NULL, NULL, 'SODIUM-COUPLED MONOCARBOXYLATE TRANSPORTER 2', 248091),
(381234, 'PTHR42985:SF10', NULL, NULL, NULL, NULL, 'SODIUM-COUPLED MONOCARBOXYLATE TRANSPORTER 1', 248091),
(381235, 'PTHR42985:SF21', NULL, NULL, NULL, NULL, 'FI02923P-RELATED', 248091),
(381236, 'PTHR42985:SF43', NULL, NULL, NULL, NULL, 'SODIUM/GLUCOSE COTRANSPORTER-RELATED', 248091),
(381237, 'PTHR42985:SF32', NULL, NULL, NULL, NULL, 'SODIUM IODIDE SYMPORTER', 248091),
(381238, 'PTHR42985:SF11', NULL, NULL, NULL, NULL, 'SODIUM/IODIDE COTRANSPORTER', 248091),
(381239, 'PTHR42985:SF41', NULL, NULL, NULL, NULL, 'GH19970P-RELATED', 248091),
(381240, 'PTHR42985:SF42', NULL, NULL, NULL, NULL, 'PROTEIN CBG02091', 248091),
(381241, 'PTHR42985:SF31', NULL, NULL, NULL, NULL, 'LD47995P-RELATED', 248091),
(381242, 'PTHR42985:SF5', NULL, NULL, NULL, NULL, 'FI02094P-RELATED', 248091),
(381243, 'PTHR42985:SF38', NULL, NULL, NULL, NULL, 'FI02016P', 248091),
(381244, 'PTHR42985:SF39', NULL, NULL, NULL, NULL, 'GH10366P', 248091),
(381245, 'PTHR42985:SF28', NULL, NULL, NULL, NULL, '', 248091),
(381246, 'PTHR35754', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT B', 248092),
(381247, 'PTHR35754:SF2', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT B', 248092),
(381248, 'PTHR30634', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE LOLAB LIPOPROTEIN INSERTION APPARATUS', 248093),
(381249, 'PTHR30634:SF14', NULL, NULL, NULL, NULL, '', 248093),
(381250, 'PTHR30634:SF15', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 248093),
(381251, 'PTHR30634:SF7', NULL, NULL, NULL, NULL, '', 248093),
(381252, 'PTHR30634:SF13', NULL, NULL, NULL, NULL, 'OUTER-MEMBRANE LIPOPROTEIN LOLB-RELATED', 248093),
(381253, 'PTHR36183:SF3', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_79C DOMAIN-CONTAINING PROTEIN', 248094),
(381254, 'PTHR36183', NULL, NULL, NULL, NULL, 'BETA-GLUCURONIDASE', 248094),
(381255, 'PTHR36183:SF2', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_79C DOMAIN-CONTAINING PROTEIN', 248094),
(381256, 'PTHR36183:SF4', NULL, NULL, NULL, NULL, 'CHROMOSOME 23, WHOLE GENOME SHOTGUN SEQUENCE', 248094),
(381257, 'PTHR35574:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG14602', 248095),
(381258, 'PTHR35574:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG21625', 248095),
(381259, 'PTHR35574', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 248095),
(381260, 'PTHR35574:SF3', NULL, NULL, NULL, NULL, '', 248095),
(381261, 'PTHR35574:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBR-HPO-30', 248095),
(381262, 'PTHR45616:SF29', NULL, NULL, NULL, NULL, 'KERATIN, TYPE II CYTOSKELETAL 2 ORAL', 248096),
(381263, 'PTHR45616', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 248096),
(381264, 'PTHR45616:SF44', NULL, NULL, NULL, NULL, 'IF ROD DOMAIN-CONTAINING PROTEIN', 248096),
(381265, 'PTHR45616:SF22', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 248096),
(381266, 'PTHR45616:SF21', NULL, NULL, NULL, NULL, 'KERATIN, TYPE II CYTOSKELETAL 7', 248096);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(381267, 'PTHR45616:SF43', NULL, NULL, NULL, NULL, 'KERATIN, TYPE II CUTICULAR HB5', 248096),
(381268, 'PTHR45616:SF24', NULL, NULL, NULL, NULL, 'KERATIN, TYPE II CYTOSKELETAL 1B', 248096),
(381269, 'PTHR45616:SF46', NULL, NULL, NULL, NULL, 'IF ROD DOMAIN-CONTAINING PROTEIN', 248096),
(381270, 'PTHR45616:SF45', NULL, NULL, NULL, NULL, 'IF ROD DOMAIN-CONTAINING PROTEIN', 248096),
(381271, 'PTHR45616:SF26', NULL, NULL, NULL, NULL, 'KERATIN, TYPE II CYTOSKELETAL 8', 248096),
(381272, 'PTHR45616:SF47', NULL, NULL, NULL, NULL, 'KERATIN, TYPE II CYTOSKELETAL 6C', 248096),
(381273, 'PTHR45616:SF49', NULL, NULL, NULL, NULL, 'KERATIN 89', 248096),
(381274, 'PTHR45616:SF51', NULL, NULL, NULL, NULL, 'IF ROD DOMAIN-CONTAINING PROTEIN', 248096),
(381275, 'PTHR45616:SF31', NULL, NULL, NULL, NULL, 'KERATIN, TYPE II CYTOSKELETAL 73', 248096),
(381276, 'PTHR45616:SF52', NULL, NULL, NULL, NULL, 'KERATIN, TYPE II CUTICULAR HB1', 248096),
(381277, 'PTHR45616:SF19', NULL, NULL, NULL, NULL, 'KERATIN 90', 248096),
(381278, 'PTHR45616:SF18', NULL, NULL, NULL, NULL, 'KERATIN, TYPE II CYTOSKELETAL 78', 248096),
(381279, 'PTHR45616:SF9', NULL, NULL, NULL, NULL, 'SI:DKEY-222F2.1', 248096),
(381280, 'PTHR45616:SF5', NULL, NULL, NULL, NULL, 'KERATIN, TYPE II CYTOSKELETAL 74', 248096),
(381281, 'PTHR45616:SF33', NULL, NULL, NULL, NULL, 'KERATIN, TYPE II CYTOSKELETAL 1', 248096),
(381282, 'PTHR45616:SF55', NULL, NULL, NULL, NULL, 'KERATIN, TYPE II CUTICULAR HB3', 248096),
(381283, 'PTHR45616:SF10', NULL, NULL, NULL, NULL, 'KERATIN, TYPE II CYTOSKELETAL 79', 248096),
(381284, 'PTHR45616:SF32', NULL, NULL, NULL, NULL, 'KERATIN, TYPE II CYTOSKELETAL 5', 248096),
(381285, 'PTHR45616:SF7', NULL, NULL, NULL, NULL, 'KERATIN, TYPE II CUTICULAR HB6', 248096),
(381286, 'PTHR45616:SF57', NULL, NULL, NULL, NULL, 'IF ROD DOMAIN-CONTAINING PROTEIN', 248096),
(381287, 'PTHR45616:SF13', NULL, NULL, NULL, NULL, 'KERATIN, TYPE II CYTOSKELETAL 75', 248096),
(381288, 'PTHR45616:SF12', NULL, NULL, NULL, NULL, 'KERATIN, TYPE II CUTICULAR HB2', 248096),
(381289, 'PTHR45616:SF8', NULL, NULL, NULL, NULL, 'IF ROD DOMAIN-CONTAINING PROTEIN', 248096),
(381290, 'PTHR45616:SF56', NULL, NULL, NULL, NULL, 'KERATIN, TYPE II CUTICULAR 87', 248096),
(381291, 'PTHR45616:SF34', NULL, NULL, NULL, NULL, 'IF ROD DOMAIN-CONTAINING PROTEIN', 248096),
(381292, 'PTHR45616:SF1', NULL, NULL, NULL, NULL, 'KERATIN, TYPE II CYTOSKELETAL 80', 248096),
(381293, 'PTHR45616:SF59', NULL, NULL, NULL, NULL, 'KERATIN, TYPE II CYTOSKELETAL 8', 248096),
(381294, 'PTHR45616:SF14', NULL, NULL, NULL, NULL, 'KERATIN, TYPE II CYTOSKELETAL 2 EPIDERMAL', 248096),
(381295, 'PTHR45616:SF58', NULL, NULL, NULL, NULL, 'KERATIN 75', 248096),
(381296, 'PTHR45616:SF2', NULL, NULL, NULL, NULL, 'KERATIN, TYPE II CYTOSKELETAL 72', 248096),
(381297, 'PTHR45616:SF3', NULL, NULL, NULL, NULL, 'KERATIN, TYPE II CYTOSKELETAL 4', 248096),
(381298, 'PTHR45616:SF39', NULL, NULL, NULL, NULL, 'KERATIN, TYPE II CYTOSKELETAL 6A-RELATED', 248096),
(381299, 'PTHR45616:SF17', NULL, NULL, NULL, NULL, 'KERATIN, TYPE II CUTICULAR HB4', 248096),
(381300, 'PTHR45616:SF4', NULL, NULL, NULL, NULL, 'SI:DKEY-183I3.5', 248096),
(381301, 'PTHR45616:SF16', NULL, NULL, NULL, NULL, 'KERATIN, TYPE II CYTOSKELETAL 71', 248096),
(381302, 'PTHR45616:SF38', NULL, NULL, NULL, NULL, 'KERATIN, TYPE II CYTOSKELETAL 3', 248096),
(381303, 'PTHR45616:SF42', NULL, NULL, NULL, NULL, 'IF ROD DOMAIN-CONTAINING PROTEIN', 248096),
(381304, 'PTHR14503:SF11', NULL, NULL, NULL, NULL, 'D-AMINO-ACID OXIDASE-RELATED', 248097),
(381305, 'PTHR14503:SF12', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L34', 248097),
(381306, 'PTHR14503:SF4', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L34, MITOCHONDRIAL', 248097),
(381307, 'PTHR14503', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOMAL PROTEIN 34 FAMILY MEMBER', 248097),
(381308, 'PTHR14503:SF9', NULL, NULL, NULL, NULL, 'BNAC06G17900D PROTEIN', 248097),
(381309, 'PTHR12353:SF19', NULL, NULL, NULL, NULL, 'DISKS LARGE-ASSOCIATED PROTEIN 4', 248098),
(381310, 'PTHR12353:SF1', NULL, NULL, NULL, NULL, 'DISKS LARGE-ASSOCIATED PROTEIN 5', 248098);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(381311, 'PTHR12353:SF4', NULL, NULL, NULL, NULL, 'DISKS LARGE-ASSOCIATED PROTEIN 3', 248098),
(381312, 'PTHR12353:SF3', NULL, NULL, NULL, NULL, 'DISKS LARGE-ASSOCIATED PROTEIN 2', 248098),
(381313, 'PTHR12353:SF7', NULL, NULL, NULL, NULL, 'DISKS LARGE-ASSOCIATED PROTEIN 1', 248098),
(381314, 'PTHR12353:SF31', NULL, NULL, NULL, NULL, 'LD44824P', 248098),
(381315, 'PTHR12353', NULL, NULL, NULL, NULL, 'DISKS LARGE-ASSOCIATED PROTEIN  DAP   SAP90/PSD-95-ASSOCIATED PROTEIN', 248098),
(381316, 'PTHR31351:SF2', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE BINDING PROTEIN', 248099),
(381317, 'PTHR31351:SF4', NULL, NULL, NULL, NULL, 'AUXIN CANALIZATION PROTEIN (DUF828)', 248099),
(381318, 'PTHR31351:SF18', NULL, NULL, NULL, NULL, 'AUXIN_CANALIS DOMAIN-CONTAINING PROTEIN', 248099),
(381319, 'PTHR31351:SF39', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248099),
(381320, 'PTHR31351:SF17', NULL, NULL, NULL, NULL, 'AUXIN CANALIZATION PROTEIN', 248099),
(381321, 'PTHR31351:SF34', NULL, NULL, NULL, NULL, 'BNAA10G11650D PROTEIN', 248099),
(381322, 'PTHR31351:SF22', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 248099),
(381323, 'PTHR31351:SF33', NULL, NULL, NULL, NULL, 'BNAA08G29430D PROTEIN', 248099),
(381324, 'PTHR31351:SF32', NULL, NULL, NULL, NULL, 'AUXIN CANALIZATION PROTEIN (DUF828)', 248099),
(381325, 'PTHR31351:SF20', NULL, NULL, NULL, NULL, '', 248099),
(381326, 'PTHR31351:SF42', NULL, NULL, NULL, NULL, '', 248099),
(381327, 'PTHR31351:SF31', NULL, NULL, NULL, NULL, 'VAN3-BINDING PROTEIN', 248099),
(381328, 'PTHR31351:SF27', NULL, NULL, NULL, NULL, 'BNAA06G36500D PROTEIN', 248099),
(381329, 'PTHR31351:SF26', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 248099),
(381330, 'PTHR31351:SF36', NULL, NULL, NULL, NULL, 'BNAA02G22400D PROTEIN', 248099),
(381331, 'PTHR31351:SF25', NULL, NULL, NULL, NULL, 'AUXIN CANALIZATION PROTEIN (DUF828)', 248099),
(381332, 'PTHR31351:SF24', NULL, NULL, NULL, NULL, 'VAN3-BINDING PROTEIN', 248099),
(381333, 'PTHR31351', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248099),
(381334, 'PTHR31351:SF30', NULL, NULL, NULL, NULL, 'OS02G0689600 PROTEIN', 248099),
(381335, 'PTHR31351:SF41', NULL, NULL, NULL, NULL, 'VAN3-BINDING PROTEIN-LIKE', 248099),
(381336, 'PTHR31351:SF40', NULL, NULL, NULL, NULL, 'BNAA01G35330D PROTEIN', 248099),
(381337, 'PTHR17503', NULL, NULL, NULL, NULL, 'SYNCOLLIN', 248100),
(381338, 'PTHR17503:SF0', NULL, NULL, NULL, NULL, 'SYNCOLLIN', 248100),
(381339, 'PTHR42067:SF1', NULL, NULL, NULL, NULL, 'YALI0C15378P', 248101),
(381340, 'PTHR42067', NULL, NULL, NULL, NULL, 'YALI0C15378P', 248101),
(381341, 'PTHR10934:SF8', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L18E/L15P DOMAIN-CONTAINING PROTEIN', 248102),
(381342, 'PTHR10934', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L18', 248102),
(381343, 'PTHR10934:SF10', NULL, NULL, NULL, NULL, 'OS07G0674700 PROTEIN', 248102),
(381344, 'PTHR10934:SF21', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L18-RELATED', 248102),
(381345, 'PTHR10934:SF16', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L18E/L15P DOMAIN-CONTAINING PROTEIN', 248102),
(381346, 'PTHR10934:SF15', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L18-2-LIKE', 248102),
(381347, 'PTHR10934:SF17', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L18E/L15P DOMAIN-CONTAINING PROTEIN', 248102),
(381348, 'PTHR10934:SF2', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L18', 248102),
(381349, 'PTHR10934:SF12', NULL, NULL, NULL, NULL, '', 248102),
(381350, 'PTHR10934:SF5', NULL, NULL, NULL, NULL, 'OS05G0155100 PROTEIN', 248102),
(381351, 'PTHR10934:SF11', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L18-1-RELATED', 248102),
(381352, 'PTHR10934:SF6', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L18', 248102),
(381353, 'PTHR18978', NULL, NULL, NULL, NULL, 'GRIP-1 ASSOCIATED PROTEIN 1', 248103),
(381354, 'PTHR18978:SF1', NULL, NULL, NULL, NULL, 'GRIP1-ASSOCIATED PROTEIN 1', 248103),
(381355, 'PTHR11351:SF96', NULL, NULL, NULL, NULL, 'FA_DESATURASE DOMAIN-CONTAINING PROTEIN', 248104),
(381356, 'PTHR11351:SF74', NULL, NULL, NULL, NULL, 'FA_DESATURASE DOMAIN-CONTAINING PROTEIN', 248104);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(381357, 'PTHR11351:SF97', NULL, NULL, NULL, NULL, 'STEAROYL-COA DESATURASE 2', 248104),
(381358, 'PTHR11351:SF75', NULL, NULL, NULL, NULL, 'FATTY ACID DESATURASE, TYPE 1, CORE-RELATED', 248104),
(381359, 'PTHR11351:SF31', NULL, NULL, NULL, NULL, 'STEAROYL-COA DESATURASE-RELATED', 248104),
(381360, 'PTHR11351:SF3', NULL, NULL, NULL, NULL, 'BLL4393 PROTEIN', 248104),
(381361, 'PTHR11351:SF76', NULL, NULL, NULL, NULL, 'FA_DESATURASE DOMAIN-CONTAINING PROTEIN', 248104),
(381362, 'PTHR11351:SF77', NULL, NULL, NULL, NULL, 'FA_DESATURASE DOMAIN-CONTAINING PROTEIN', 248104),
(381363, 'PTHR11351:SF33', NULL, NULL, NULL, NULL, 'DELTA-9 FATTY ACID DESATURASE, DESA', 248104),
(381364, 'PTHR11351:SF78', NULL, NULL, NULL, NULL, 'FA_DESATURASE DOMAIN-CONTAINING PROTEIN', 248104),
(381365, 'PTHR11351:SF79', NULL, NULL, NULL, NULL, 'FA_DESATURASE DOMAIN-CONTAINING PROTEIN', 248104),
(381366, 'PTHR11351:SF92', NULL, NULL, NULL, NULL, 'ACYL-COA DESATURASE 2-LIKE PROTEIN', 248104),
(381367, 'PTHR11351:SF93', NULL, NULL, NULL, NULL, 'LIPID DESATURASE ADS3.2, CHLOROPLASTIC-RELATED', 248104),
(381368, 'PTHR11351:SF71', NULL, NULL, NULL, NULL, 'DELTA-9 DESATURASE-LIKE 1 PROTEIN-RELATED', 248104),
(381369, 'PTHR11351:SF39', NULL, NULL, NULL, NULL, 'ACYL-COA DESATURASE 3', 248104),
(381370, 'PTHR11351', NULL, NULL, NULL, NULL, 'ACYL-COA DESATURASE', 248104),
(381371, 'PTHR11351:SF85', NULL, NULL, NULL, NULL, '16:0DELTA9 DESATURASE 2-RELATED', 248104),
(381372, 'PTHR11351:SF86', NULL, NULL, NULL, NULL, 'FA_DESATURASE DOMAIN-CONTAINING PROTEIN', 248104),
(381373, 'PTHR11351:SF20', NULL, NULL, NULL, NULL, 'STEAROYL-COA DESATURASE 4', 248104),
(381374, 'PTHR11351:SF65', NULL, NULL, NULL, NULL, 'DELTA-9 ACYL-LIPID DESATURASE 1', 248104),
(381375, 'PTHR11351:SF87', NULL, NULL, NULL, NULL, 'FATTY ACID DESATURASE, TYPE 1, CORE-RELATED', 248104),
(381376, 'PTHR11351:SF21', NULL, NULL, NULL, NULL, 'GH07782P', 248104),
(381377, 'PTHR11351:SF88', NULL, NULL, NULL, NULL, 'FATTY ACID DESATURASE, TYPE 1, CORE-RELATED', 248104),
(381378, 'PTHR11351:SF66', NULL, NULL, NULL, NULL, 'DELTA-9 DESATURASE-LIKE 4 PROTEIN-RELATED', 248104),
(381379, 'PTHR11351:SF89', NULL, NULL, NULL, NULL, 'FA_DESATURASE DOMAIN-CONTAINING PROTEIN', 248104),
(381380, 'PTHR11351:SF68', NULL, NULL, NULL, NULL, 'DELTA-9 ACYL-LIPID DESATURASE 2', 248104),
(381381, 'PTHR11351:SF69', NULL, NULL, NULL, NULL, 'ACYL-COA DESATURASE 1', 248104),
(381382, 'PTHR11351:SF80', NULL, NULL, NULL, NULL, 'FA_DESATURASE DOMAIN-CONTAINING PROTEIN', 248104),
(381383, 'PTHR11351:SF81', NULL, NULL, NULL, NULL, 'FA_DESATURASE DOMAIN-CONTAINING PROTEIN', 248104),
(381384, 'PTHR11351:SF82', NULL, NULL, NULL, NULL, 'BNAC05G04360D PROTEIN', 248104),
(381385, 'PTHR11351:SF83', NULL, NULL, NULL, NULL, 'FA_DESATURASE DOMAIN-CONTAINING PROTEIN', 248104),
(381386, 'PTHR11351:SF61', NULL, NULL, NULL, NULL, 'RH14937P', 248104),
(381387, 'PTHR11351:SF26', NULL, NULL, NULL, NULL, 'AGAP003050-PA', 248104),
(381388, 'PTHR11351:SF27', NULL, NULL, NULL, NULL, 'DELTA(9)-FATTY-ACID DESATURASE FAT-5', 248104),
(381389, 'PTHR11351:SF29', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 HEME-BINDING DOMAIN-CONTAINING PROTEIN', 248104),
(381390, 'PTHR20208:SF10', NULL, NULL, NULL, NULL, 'STRUCTURE-SPECIFIC ENDONUCLEASE SUBUNIT SLX1', 248105),
(381391, 'PTHR20208', NULL, NULL, NULL, NULL, 'STRUCTURE-SPECIFIC ENDONUCLEASE SUBUNIT SLX1', 248105),
(381392, 'PTHR20208:SF13', NULL, NULL, NULL, NULL, 'EMB|CAB76036.1', 248105),
(381393, 'PTHR31409', NULL, NULL, NULL, NULL, 'WASH COMPLEX SUBUNIT 4', 248106),
(381394, 'PTHR31409:SF0', NULL, NULL, NULL, NULL, 'WASH COMPLEX SUBUNIT 4', 248106),
(381395, 'PTHR14826:SF12', NULL, NULL, NULL, NULL, 'ANGIOMOTIN-LIKE PROTEIN 1', 248107),
(381396, 'PTHR14826:SF14', NULL, NULL, NULL, NULL, 'ANGIOMOTIN_C DOMAIN-CONTAINING PROTEIN', 248107),
(381397, 'PTHR14826', NULL, NULL, NULL, NULL, 'ANGIOMOTIN', 248107),
(381398, 'PTHR14826:SF6', NULL, NULL, NULL, NULL, 'ANGIOMOTIN', 248107),
(381399, 'PTHR14826:SF3', NULL, NULL, NULL, NULL, 'ANGIOMOTIN-LIKE PROTEIN 2', 248107),
(381400, 'PTHR43149', NULL, NULL, NULL, NULL, 'ENOYL-COA HYDRATASE', 248108);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(381401, 'PTHR43149:SF3', NULL, NULL, NULL, NULL, 'DELTA(3,5)-DELTA(2,4)-DIENOYL-COA ISOMERASE, PEROXISOMAL-LIKE', 248108),
(381402, 'PTHR43149:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG19637', 248108),
(381403, 'PTHR43149:SF1', NULL, NULL, NULL, NULL, 'DELTA(3,5)-DELTA(2,4)-DIENOYL-COA ISOMERASE, MITOCHONDRIAL', 248108),
(381404, 'PTHR12069', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASES III 80 KDA POLYPEPTIDE  RNA POLYMERASE III SUBUNIT 5', 248109),
(381405, 'PTHR12069:SF0', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE III SUBUNIT RPC5', 248109),
(381406, 'PTHR12386:SF15', NULL, NULL, NULL, NULL, 'OS01G0720100 PROTEIN', 248110),
(381407, 'PTHR12386:SF37', NULL, NULL, NULL, NULL, 'BNAA03G49560D PROTEIN', 248110),
(381408, 'PTHR12386:SF25', NULL, NULL, NULL, NULL, '', 248110),
(381409, 'PTHR12386:SF35', NULL, NULL, NULL, NULL, 'ATPASE, F0 COMPLEX, SUBUNIT G-RELATED', 248110),
(381410, 'PTHR12386:SF13', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT G 1, MITOCHONDRIAL-RELATED', 248110),
(381411, 'PTHR12386:SF45', NULL, NULL, NULL, NULL, '', 248110),
(381412, 'PTHR12386:SF12', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT G 2, MITOCHONDRIAL-RELATED', 248110),
(381413, 'PTHR12386:SF34', NULL, NULL, NULL, NULL, 'ATPASE, F0 COMPLEX, SUBUNIT G-RELATED', 248110),
(381414, 'PTHR12386:SF44', NULL, NULL, NULL, NULL, 'COPIA-LIKE RETROELEMENT POL POLYPROTEIN', 248110),
(381415, 'PTHR12386:SF33', NULL, NULL, NULL, NULL, 'HYDROGEN-TRANSPORTING ATP SYNTHASE, ROTATIONAL MECHANISM', 248110),
(381416, 'PTHR12386:SF32', NULL, NULL, NULL, NULL, 'ATP SYNTHASE, ROTATIONAL MECHANISM, PUTATIVE-RELATED', 248110),
(381417, 'PTHR12386:SF43', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ATP SYNTHASE SUBUNIT G PROTEIN', 248110),
(381418, 'PTHR12386:SF42', NULL, NULL, NULL, NULL, 'ATP SYNTHASE G SUBUNIT FAMILY PROTEIN', 248110),
(381419, 'PTHR12386:SF41', NULL, NULL, NULL, NULL, 'COPIA-LIKE RETROELEMENT POL POLYPROTEIN', 248110),
(381420, 'PTHR12386:SF28', NULL, NULL, NULL, NULL, '', 248110),
(381421, 'PTHR12386', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT', 248110),
(381422, 'PTHR13992:SF5', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR COREPRESSOR 1', 248111),
(381423, 'PTHR13992:SF39', NULL, NULL, NULL, NULL, 'SMRTER, ISOFORM G', 248111),
(381424, 'PTHR13992:SF21', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR COREPRESSOR 2', 248111),
(381425, 'PTHR13992', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR CO-REPRESSOR RELATED  NCOR', 248111),
(381426, 'PTHR24279:SF117', NULL, NULL, NULL, NULL, '', 248112),
(381427, 'PTHR24279:SF118', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 27 SUBFAMILY A MEMBER 1', 248112),
(381428, 'PTHR24279:SF115', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 11B1, MITOCHONDRIAL', 248112),
(381429, 'PTHR24279:SF116', NULL, NULL, NULL, NULL, 'STEROID 11-BETA-MONOOXYGENASE', 248112),
(381430, 'PTHR24279:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 11B2, MITOCHONDRIAL', 248112),
(381431, 'PTHR24279', NULL, NULL, NULL, NULL, '', 248112),
(381432, 'PTHR24279:SF3', NULL, NULL, NULL, NULL, 'CHOLESTEROL SIDE-CHAIN CLEAVAGE ENZYME, MITOCHONDRIAL', 248112),
(381433, 'PTHR41710:SF2', NULL, NULL, NULL, NULL, 'PMT DOMAIN-CONTAINING PROTEIN', 248113),
(381434, 'PTHR41710', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE, FAMILY 39', 248113),
(381435, 'PTHR30068:SF3', NULL, NULL, NULL, NULL, 'PLSC DOMAIN-CONTAINING PROTEIN', 248114),
(381436, 'PTHR30068:SF4', NULL, NULL, NULL, NULL, 'URONATE ISOMERASE', 248114),
(381437, 'PTHR30068', NULL, NULL, NULL, NULL, 'URONATE ISOMERASE', 248114),
(381438, 'PTHR46953:SF1', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR MTH-LIKE 1-RELATED', 248115),
(381439, 'PTHR46953:SF3', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR MTH-LIKE 14-RELATED', 248115),
(381440, 'PTHR46953:SF2', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR MTH-LIKE 5-RELATED', 248115),
(381441, 'PTHR46953', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR MTH-LIKE 1-RELATED', 248115),
(381442, 'PTHR33269:SF5', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT 6, CHLOROPLASTIC', 248116);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(381443, 'PTHR33269:SF17', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE CHAIN 6', 248116),
(381444, 'PTHR33269', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE CHAIN 6', 248116),
(381445, 'PTHR33269:SF19', NULL, NULL, NULL, NULL, 'NADH-QUINONE OXIDOREDUCTASE SUBUNIT J', 248116),
(381446, 'PTHR36485:SF1', NULL, NULL, NULL, NULL, 'OS01G0939000 PROTEIN', 248117),
(381447, 'PTHR36485:SF2', NULL, NULL, NULL, NULL, '', 248117),
(381448, 'PTHR36485', NULL, NULL, NULL, NULL, 'OS01G0939000 PROTEIN', 248117),
(381449, 'PTHR15871:SF2', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY O MEMBER 2', 248118),
(381450, 'PTHR15871:SF1', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY O MEMBER 1', 248118),
(381451, 'PTHR15871:SF5', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 248118),
(381452, 'PTHR15871', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 248118),
(381453, 'PTHR32149', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 6 COMPLEX LOCUS PROTEIN G6C', 248119),
(381454, 'PTHR32149:SF2', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 6 COMPLEX LOCUS PROTEIN G6C', 248119),
(381455, 'PTHR28159:SF1', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX II-SPECIFIC SUBUNIT 65', 248120),
(381456, 'PTHR28159', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX II-SPECIFIC SUBUNIT 65', 248120),
(381457, 'PTHR47890', NULL, NULL, NULL, NULL, 'LD24308P', 248121),
(381458, 'PTHR47890:SF1', NULL, NULL, NULL, NULL, 'LD24308P', 248121),
(381459, 'PTHR45933', NULL, NULL, NULL, NULL, 'PROTEIN C2-DOMAIN ABA-RELATED 4', 248122),
(381460, 'PTHR45933:SF29', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 248122),
(381461, 'PTHR45933:SF27', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT LIPID-BINDING (CALB DOMAIN) FAMILY PROTEIN-RELATED', 248122),
(381462, 'PTHR45933:SF28', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN-RELATED', 248122),
(381463, 'PTHR45933:SF21', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT LIPID-BINDING (CALB DOMAIN) FAMILY PROTEIN', 248122),
(381464, 'PTHR45933:SF43', NULL, NULL, NULL, NULL, 'PROTEIN C2-DOMAIN ABA-RELATED 11-LIKE', 248122),
(381465, 'PTHR45933:SF44', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT LIPID-BINDING (CALB DOMAIN) FAMILY PROTEIN-RELATED', 248122),
(381466, 'PTHR45933:SF22', NULL, NULL, NULL, NULL, 'PROTEIN C2-DOMAIN ABA-RELATED 6-RELATED', 248122),
(381467, 'PTHR45933:SF41', NULL, NULL, NULL, NULL, 'PROTEIN C2-DOMAIN ABA-RELATED 10', 248122),
(381468, 'PTHR45933:SF42', NULL, NULL, NULL, NULL, 'GTPASE ACTIVATING PROTEIN 1-LIKE', 248122),
(381469, 'PTHR45933:SF20', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 248122),
(381470, 'PTHR45933:SF25', NULL, NULL, NULL, NULL, 'PROTEIN C2-DOMAIN ABA-RELATED 8', 248122),
(381471, 'PTHR45933:SF26', NULL, NULL, NULL, NULL, 'PROTEIN C2-DOMAIN ABA-RELATED 4-LIKE', 248122),
(381472, 'PTHR45933:SF45', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 248122),
(381473, 'PTHR45933:SF23', NULL, NULL, NULL, NULL, 'PROTEIN C2-DOMAIN ABA-RELATED 2', 248122),
(381474, 'PTHR45933:SF18', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 248122),
(381475, 'PTHR45933:SF38', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN-RELATED', 248122),
(381476, 'PTHR45933:SF17', NULL, NULL, NULL, NULL, 'PROTEIN C2-DOMAIN ABA-RELATED 7-LIKE', 248122),
(381477, 'PTHR45933:SF39', NULL, NULL, NULL, NULL, 'PROTEIN C2-DOMAIN ABA-RELATED 1-LIKE', 248122),
(381478, 'PTHR45933:SF10', NULL, NULL, NULL, NULL, 'PROTEIN C2-DOMAIN ABA-RELATED 3', 248122),
(381479, 'PTHR45933:SF32', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 248122),
(381480, 'PTHR45933:SF33', NULL, NULL, NULL, NULL, 'BNAC06G24460D PROTEIN', 248122),
(381481, 'PTHR45933:SF11', NULL, NULL, NULL, NULL, 'PROTEIN C2-DOMAIN ABA-RELATED 1', 248122),
(381482, 'PTHR45933:SF30', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 248122),
(381483, 'PTHR45933:SF7', NULL, NULL, NULL, NULL, 'OS07G0501700 PROTEIN', 248122),
(381484, 'PTHR45933:SF5', NULL, NULL, NULL, NULL, 'PROTEIN C2-DOMAIN ABA-RELATED 4', 248122);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(381485, 'PTHR45933:SF14', NULL, NULL, NULL, NULL, 'PROTEIN C2-DOMAIN ABA-RELATED 5', 248122),
(381486, 'PTHR45933:SF15', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT ARF-TYPE GTPASE ACTIVATING FAMILY PROTEIN', 248122),
(381487, 'PTHR45933:SF6', NULL, NULL, NULL, NULL, 'PROTEIN C2-DOMAIN ABA-RELATED 11', 248122),
(381488, 'PTHR45933:SF12', NULL, NULL, NULL, NULL, 'PROTEIN C2-DOMAIN ABA-RELATED 9', 248122),
(381489, 'PTHR45933:SF3', NULL, NULL, NULL, NULL, 'PROTEIN C2-DOMAIN ABA-RELATED 4', 248122),
(381490, 'PTHR45933:SF34', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 248122),
(381491, 'PTHR45933:SF35', NULL, NULL, NULL, NULL, 'GTPASE ACTIVATING PROTEIN 1-RELATED', 248122),
(381492, 'PTHR45933:SF4', NULL, NULL, NULL, NULL, 'OS07G0500300 PROTEIN', 248122),
(381493, 'PTHR46694:SF1', NULL, NULL, NULL, NULL, 'OS08G0451700 PROTEIN', 248123),
(381494, 'PTHR46694', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 4', 248123),
(381495, 'PTHR46694:SF7', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 4', 248123),
(381496, 'PTHR46694:SF6', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 4', 248123),
(381497, 'PTHR46694:SF5', NULL, NULL, NULL, NULL, 'ARID/BRIGHT DNA-BINDING DOMAIN PROTEIN', 248123),
(381498, 'PTHR47599:SF2', NULL, NULL, NULL, NULL, 'VIRAL MOVEMENT PROTEIN-RELATED', 248124),
(381499, 'PTHR47599:SF1', NULL, NULL, NULL, NULL, 'CELL-TO-CELL MOVEMENT PROTEIN', 248124),
(381500, 'PTHR47599', NULL, NULL, NULL, NULL, 'CELL-TO-CELL MOVEMENT PROTEIN', 248124),
(381501, 'PTHR12112:SF51', NULL, NULL, NULL, NULL, 'ATCAY KINESIN LIGHT CHAIN-INTERACTING CAYTAXIN A', 248125),
(381502, 'PTHR12112:SF52', NULL, NULL, NULL, NULL, 'DHHA2 DOMAIN-CONTAINING PROTEIN', 248125),
(381503, 'PTHR12112:SF49', NULL, NULL, NULL, NULL, 'DHHA2 DOMAIN-CONTAINING PROTEIN', 248125),
(381504, 'PTHR12112:SF14', NULL, NULL, NULL, NULL, 'PROTEIN PRUNE HOMOLOG 2-LIKE PROTEIN', 248125),
(381505, 'PTHR12112:SF47', NULL, NULL, NULL, NULL, 'EXOPOLYPHOSPHATASE PRUNE1', 248125),
(381506, 'PTHR12112:SF11', NULL, NULL, NULL, NULL, 'PROTEIN PRUNE HOMOLOG 2', 248125),
(381507, 'PTHR12112:SF22', NULL, NULL, NULL, NULL, 'MANGANESE-DEPENDENT INORGANIC PYROPHOSPHATASE-RELATED', 248125),
(381508, 'PTHR12112:SF12', NULL, NULL, NULL, NULL, 'BCL2/ADENOVIRUS E1B 19 KDA PROTEIN-INTERACTING PROTEIN 2', 248125),
(381509, 'PTHR12112:SF20', NULL, NULL, NULL, NULL, '', 248125),
(381510, 'PTHR12112:SF21', NULL, NULL, NULL, NULL, 'BCL-2/ADENOVIRUS E1B 19 KDA-INTERACTING PROTEIN 2-LIKE PROTEIN', 248125),
(381511, 'PTHR12112:SF39', NULL, NULL, NULL, NULL, 'EG:152A3.5 PROTEIN (FBGN0003116_PN PROTEIN)', 248125),
(381512, 'PTHR12112:SF9', NULL, NULL, NULL, NULL, 'CAYTAXIN', 248125),
(381513, 'PTHR12112', NULL, NULL, NULL, NULL, 'BNIP - RELATED', 248125),
(381514, 'PTHR28061:SF1', NULL, NULL, NULL, NULL, 'INO80 COMPLEX SUBUNIT 4', 248126),
(381515, 'PTHR28061', NULL, NULL, NULL, NULL, 'INO EIGHTY SUBUNIT 4', 248126),
(381516, 'PTHR30604:SF1', NULL, NULL, NULL, NULL, 'DNA UTILIZATION PROTEIN HOFQ', 248127),
(381517, 'PTHR30604', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN HOFQ', 248127),
(381518, 'PTHR40072:SF1', NULL, NULL, NULL, NULL, 'MOLYBDOPTERIN-GUANINE DINUCLEOTIDE BIOSYNTHESIS ADAPTER PROTEIN', 248128),
(381519, 'PTHR40072', NULL, NULL, NULL, NULL, 'MOLYBDOPTERIN-GUANINE DINUCLEOTIDE BIOSYNTHESIS ADAPTER PROTEIN-RELATED', 248128),
(381520, 'PTHR34152:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG26430', 248129),
(381521, 'PTHR34152:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG25271', 248129),
(381522, 'PTHR34152', NULL, NULL, NULL, NULL, 'PROTEIN CBG12353-RELATED', 248129),
(381523, 'PTHR34152:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG23098', 248129),
(381524, 'PTHR34152:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG12353', 248129),
(381525, 'PTHR34152:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG26219', 248129),
(381526, 'PTHR34152:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG23099', 248129),
(381527, 'PTHR34152:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG04891', 248129),
(381528, 'PTHR34152:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG04886', 248129);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(381529, 'PTHR24314:SF20', NULL, NULL, NULL, NULL, 'STEROL CARRIER PROTEIN 2', 248130),
(381530, 'PTHR24314:SF21', NULL, NULL, NULL, NULL, 'CHLOROPHYLL(IDE) B REDUCTASE NYC1, CHLOROPLASTIC-RELATED', 248130),
(381531, 'PTHR24314:SF27', NULL, NULL, NULL, NULL, 'CHLOROPHYLL(IDE) B REDUCTASE NYC1 PROTEIN-RELATED', 248130),
(381532, 'PTHR24314', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN-RELATED', 248130),
(381533, 'PTHR24314:SF23', NULL, NULL, NULL, NULL, '', 248130),
(381534, 'PTHR24314:SF26', NULL, NULL, NULL, NULL, '', 248130),
(381535, 'PTHR24314:SF15', NULL, NULL, NULL, NULL, 'CHLOROPHYLL(IDE) B REDUCTASE NOL, CHLOROPLASTIC', 248130),
(381536, 'PTHR32175:SF0', NULL, NULL, NULL, NULL, 'TYROSINE KINASE FAMILY PROTEIN', 248131),
(381537, 'PTHR32175:SF9', NULL, NULL, NULL, NULL, 'OS01G0784600 PROTEIN', 248131),
(381538, 'PTHR32175:SF17', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN', 248131),
(381539, 'PTHR32175:SF4', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 248131),
(381540, 'PTHR32175:SF5', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 248131),
(381541, 'PTHR32175:SF18', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 248131),
(381542, 'PTHR32175:SF24', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 248131),
(381543, 'PTHR32175:SF23', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 248131),
(381544, 'PTHR32175:SF26', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE, EXPRESSED-RELATED', 248131),
(381545, 'PTHR32175:SF25', NULL, NULL, NULL, NULL, 'BNAA07G04110D PROTEIN', 248131),
(381546, 'PTHR32175:SF20', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 248131),
(381547, 'PTHR32175:SF22', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 248131),
(381548, 'PTHR32175:SF21', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 248131),
(381549, 'PTHR32175', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE, EXPRESSED-RELATED', 248131),
(381550, 'PTHR42790:SF19', NULL, NULL, NULL, NULL, 'AROMATIC AMINO ACID AMINOTRANSFERASE DDB_G0272014', 248132),
(381551, 'PTHR42790:SF17', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, GNTR FAMILY', 248132),
(381552, 'PTHR42790', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE', 248132),
(381553, 'PTHR42790:SF2', NULL, NULL, NULL, NULL, 'AROMATIC AMINO ACID AMINOTRANSFERASE 2', 248132),
(381554, 'PTHR42790:SF1', NULL, NULL, NULL, NULL, 'AROMATIC AMINO ACID AMINOTRANSFERASE, HYPOTHETICAL (EUROFUNG)', 248132),
(381555, 'PTHR42790:SF21', NULL, NULL, NULL, NULL, 'AROMATIC/AMINOADIPATE AMINOTRANSFERASE 1', 248132),
(381556, 'PTHR42790:SF4', NULL, NULL, NULL, NULL, 'VALINE--PYRUVATE AMINOTRANSFERASE', 248132),
(381557, 'PTHR42790:SF3', NULL, NULL, NULL, NULL, 'KYNURENINE/ALPHA-AMINOADIPATE AMINOTRANSFERASE, MITOCHONDRIAL', 248132),
(381558, 'PTHR42790:SF22', NULL, NULL, NULL, NULL, 'GNTR FAMILY REGULATORY PROTEIN', 248132),
(381559, 'PTHR42790:SF6', NULL, NULL, NULL, NULL, 'GNTR-FAMILY TRANSCRIPTIONAL REGULATOR-RELATED', 248132),
(381560, 'PTHR42790:SF20', NULL, NULL, NULL, NULL, 'GNTR-FAMILY TRANSCRIPTIONAL REGULATOR', 248132),
(381561, 'PTHR42790:SF8', NULL, NULL, NULL, NULL, 'GNTR-FAMILY TRANSCRIPTIONAL REGULATOR', 248132),
(381562, 'PTHR42790:SF7', NULL, NULL, NULL, NULL, 'GNTR FAMILY TRANSCRIPTIONAL REGULATORY PROTEIN', 248132),
(381563, 'PTHR42790:SF9', NULL, NULL, NULL, NULL, 'GNTR FAMILY REGULATORY PROTEIN-RELATED', 248132),
(381564, 'PTHR39335:SF1', NULL, NULL, NULL, NULL, 'BLL4220 PROTEIN', 248133),
(381565, 'PTHR39335', NULL, NULL, NULL, NULL, 'BLL4220 PROTEIN', 248133),
(381566, 'PTHR48038:SF1', NULL, NULL, NULL, NULL, 'RIBONUCLEOPROTEIN RB97D', 248134),
(381567, 'PTHR48038:SF2', NULL, NULL, NULL, NULL, 'OS02G0536400 PROTEIN', 248134),
(381568, 'PTHR48038', NULL, NULL, NULL, NULL, 'RIBONUCLEOPROTEIN RB97D', 248134),
(381569, 'PTHR31499:SF54', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 248135),
(381570, 'PTHR31499:SF76', NULL, NULL, NULL, NULL, 'OS08G0346400 PROTEIN', 248135),
(381571, 'PTHR31499:SF11', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR PHL8', 248135),
(381572, 'PTHR31499:SF55', NULL, NULL, NULL, NULL, 'MYB-LIKE TRANSCRIPTION FACTOR FAMILY PROTEIN', 248135);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(381573, 'PTHR31499:SF77', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 248135),
(381574, 'PTHR31499:SF78', NULL, NULL, NULL, NULL, '', 248135),
(381575, 'PTHR31499:SF50', NULL, NULL, NULL, NULL, 'BNAA07G24220D PROTEIN', 248135),
(381576, 'PTHR31499:SF73', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 248135),
(381577, 'PTHR31499:SF52', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE, MYB-CC TYPE TRANSCRIPTION FACTOR, LHEQLE-CONTAINING DOMAIN PROTEIN-RELATED', 248135),
(381578, 'PTHR31499:SF74', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 248135),
(381579, 'PTHR31499:SF31', NULL, NULL, NULL, NULL, 'OS07G0685300 PROTEIN', 248135),
(381580, 'PTHR31499:SF53', NULL, NULL, NULL, NULL, 'PROTEIN PHR1-LIKE 3', 248135),
(381581, 'PTHR31499:SF75', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR APL-LIKE', 248135),
(381582, 'PTHR31499:SF70', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 248135),
(381583, 'PTHR31499:SF71', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 248135),
(381584, 'PTHR31499:SF6', NULL, NULL, NULL, NULL, 'PROTEIN PHR1-LIKE 2', 248135),
(381585, 'PTHR31499', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR PHL11', 248135),
(381586, 'PTHR31499:SF69', NULL, NULL, NULL, NULL, 'G2-LIKE TRANSCRIPTION FACTOR', 248135),
(381587, 'PTHR31499:SF48', NULL, NULL, NULL, NULL, 'MYB-LIKE TRANSCRIPTION FACTOR FAMILY PROTEIN', 248135),
(381588, 'PTHR31499:SF49', NULL, NULL, NULL, NULL, 'MYB_CC_LHEQLE DOMAIN-CONTAINING PROTEIN', 248135),
(381589, 'PTHR31499:SF43', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR APL', 248135),
(381590, 'PTHR31499:SF65', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR APL-LIKE', 248135),
(381591, 'PTHR31499:SF66', NULL, NULL, NULL, NULL, 'MYB-LIKE TRANSCRIPTION FACTOR FAMILY PROTEIN', 248135),
(381592, 'PTHR31499:SF67', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR KAN3-RELATED', 248135),
(381593, 'PTHR31499:SF23', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR PHL11', 248135),
(381594, 'PTHR31499:SF2', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN 2', 248135),
(381595, 'PTHR31499:SF24', NULL, NULL, NULL, NULL, 'OS05G0488600 PROTEIN', 248135),
(381596, 'PTHR31499:SF68', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN', 248135),
(381597, 'PTHR31499:SF46', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN 1', 248135),
(381598, 'PTHR31499:SF62', NULL, NULL, NULL, NULL, 'MYB_CC_LHEQLE DOMAIN-CONTAINING PROTEIN', 248135),
(381599, 'PTHR31499:SF40', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE II SUBUNIT RPB1-LIKE', 248135),
(381600, 'PTHR31499:SF42', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR PHL12', 248135),
(381601, 'PTHR31499:SF64', NULL, NULL, NULL, NULL, 'MYB_CC_LHEQLE DOMAIN-CONTAINING PROTEIN', 248135),
(381602, 'PTHR12831:SF0', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR IIH SUBUNIT 3', 248136),
(381603, 'PTHR12831', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIH  TFIIH , POLYPEPTIDE 3-RELATED', 248136),
(381604, 'PTHR14164', NULL, NULL, NULL, NULL, 'PERICENTRIOLAR MATERIAL 1-RELATED', 248137),
(381605, 'PTHR14164:SF12', NULL, NULL, NULL, NULL, 'PERICENTRIOLAR MATERIAL 1 PROTEIN', 248137),
(381606, 'PTHR10204:SF1', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE [QUINONE] 1', 248138),
(381607, 'PTHR10204', NULL, NULL, NULL, NULL, 'NAD P H OXIDOREDUCTASE-RELATED', 248138),
(381608, 'PTHR10204:SF33', NULL, NULL, NULL, NULL, 'RIBOSYLDIHYDRONICOTINAMIDE DEHYDROGENASE [QUINONE]', 248138),
(381609, 'PTHR10204:SF34', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE, QUINONE 1', 248138),
(381610, 'PTHR14583', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN C19ORF57 FAMILY MEMBER', 248139),
(381611, 'PTHR14583:SF0', NULL, NULL, NULL, NULL, 'BREAK REPAIR MEIOTIC RECOMBINASE RECRUITMENT FACTOR 1', 248139),
(381612, 'PTHR33312:SF5', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED KINASE REGULATOR 4-RELATED', 248140),
(381613, 'PTHR33312:SF20', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED KINASE REGULATOR 4-RELATED', 248140);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(381614, 'PTHR33312:SF31', NULL, NULL, NULL, NULL, 'BRI1 KINASE INHIBITOR 1-LIKE', 248140),
(381615, 'PTHR33312:SF21', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED KINASE REGULATOR 3-RELATED', 248140),
(381616, 'PTHR33312:SF33', NULL, NULL, NULL, NULL, 'OS01G0836900 PROTEIN', 248140),
(381617, 'PTHR33312:SF34', NULL, NULL, NULL, NULL, 'OS05G0120900 PROTEIN', 248140),
(381618, 'PTHR33312:SF35', NULL, NULL, NULL, NULL, 'TPRXL', 248140),
(381619, 'PTHR33312:SF36', NULL, NULL, NULL, NULL, 'F12M16.3', 248140),
(381620, 'PTHR33312:SF37', NULL, NULL, NULL, NULL, 'BRI1 KINASE INHIBITOR 1', 248140),
(381621, 'PTHR33312:SF27', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED KINASE REGULATOR 4-RELATED', 248140),
(381622, 'PTHR33312:SF28', NULL, NULL, NULL, NULL, 'BNAA09G04310D PROTEIN', 248140),
(381623, 'PTHR33312:SF29', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED KINASE REGULATOR 4-RELATED', 248140),
(381624, 'PTHR33312:SF19', NULL, NULL, NULL, NULL, 'BRI1 KINASE INHIBITOR 1', 248140),
(381625, 'PTHR33312:SF7', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248140),
(381626, 'PTHR33312:SF8', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED KINASE REGULATOR 1-RELATED', 248140),
(381627, 'PTHR33312', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED KINASE REGULATOR 4-RELATED', 248140),
(381628, 'PTHR37944:SF1', NULL, NULL, NULL, NULL, 'PORIN B', 248141),
(381629, 'PTHR37944', NULL, NULL, NULL, NULL, 'PORIN B', 248141),
(381630, 'PTHR12741:SF47', NULL, NULL, NULL, NULL, 'CALLOSE SYNTHASE 9', 248142),
(381631, 'PTHR12741:SF67', NULL, NULL, NULL, NULL, 'CALLOSE SYNTHASE 10', 248142),
(381632, 'PTHR12741:SF22', NULL, NULL, NULL, NULL, 'CALLOSE SYNTHASE 8-RELATED', 248142),
(381633, 'PTHR12741:SF66', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCAN SYNTHASE', 248142),
(381634, 'PTHR12741:SF88', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCAN SYNTHASE', 248142),
(381635, 'PTHR12741:SF29', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCAN SYNTHASE COMPONENT FKS1-RELATED', 248142),
(381636, 'PTHR12741:SF7', NULL, NULL, NULL, NULL, 'CALLOSE SYNTHASE 12', 248142),
(381637, 'PTHR12741:SF48', NULL, NULL, NULL, NULL, 'CALLOSE SYNTHASE 3-RELATED', 248142),
(381638, 'PTHR12741:SF103', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCAN SYNTHASE', 248142),
(381639, 'PTHR12741:SF104', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCAN SYNTHASE', 248142),
(381640, 'PTHR12741:SF105', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCAN SYNTHASE COMPONENT BGS1', 248142),
(381641, 'PTHR12741:SF81', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCAN SYNTHASE', 248142),
(381642, 'PTHR12741:SF80', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCAN SYNTHASE', 248142),
(381643, 'PTHR12741:SF65', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCAN SYNTHASE', 248142),
(381644, 'PTHR12741:SF100', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCAN SYNTHASE COMPONENT BGS3', 248142),
(381645, 'PTHR12741:SF86', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCAN SYNTHASE', 248142),
(381646, 'PTHR12741:SF85', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCAN SYNTHASE', 248142),
(381647, 'PTHR12741:SF101', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCAN SYNTHASE', 248142),
(381648, 'PTHR12741:SF102', NULL, NULL, NULL, NULL, 'CALLOSE SYNTHASE 11', 248142),
(381649, 'PTHR12741:SF84', NULL, NULL, NULL, NULL, 'FKS1_DOM1 DOMAIN-CONTAINING PROTEIN', 248142),
(381650, 'PTHR12741:SF90', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCAN SYNTHASE', 248142),
(381651, 'PTHR12741', NULL, NULL, NULL, NULL, 'LYST-INTERACTING PROTEIN LIP5  DOPAMINE RESPONSIVE PROTEIN DRG-1', 248142),
(381652, 'PTHR12741:SF58', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCAN SYNTHASE', 248142),
(381653, 'PTHR12741:SF13', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCAN SYNTHASE', 248142),
(381654, 'PTHR12741:SF99', NULL, NULL, NULL, NULL, 'CALLOSE SYNTHASE 3', 248142),
(381655, 'PTHR12741:SF55', NULL, NULL, NULL, NULL, 'CALLOSE SYNTHASE 6-RELATED', 248142),
(381656, 'PTHR12741:SF16', NULL, NULL, NULL, NULL, 'CALLOSE SYNTHASE 7', 248142),
(381657, 'PTHR12741:SF15', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCAN SYNTHASE COMPONENT FKS3', 248142),
(381658, 'PTHR12741:SF59', NULL, NULL, NULL, NULL, 'CALLOSE SYNTHASE 1', 248142),
(381659, 'PTHR12741:SF94', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCAN SYNTHASE', 248142);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(381660, 'PTHR12741:SF93', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCAN SYNTHASE', 248142),
(381661, 'PTHR12741:SF71', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCAN SYNTHASE', 248142),
(381662, 'PTHR12741:SF70', NULL, NULL, NULL, NULL, 'CALLOSE SYNTHASE 2', 248142),
(381663, 'PTHR12741:SF91', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCAN SYNTHASE', 248142),
(381664, 'PTHR12741:SF98', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCAN SYNTHASE', 248142),
(381665, 'PTHR12741:SF53', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCAN SYNTHASE', 248142),
(381666, 'PTHR12741:SF75', NULL, NULL, NULL, NULL, '', 248142),
(381667, 'PTHR12741:SF97', NULL, NULL, NULL, NULL, '1,3-BETA-D-GLUCAN-UDP GLUCOSYLTRANSFERASE', 248142),
(381668, 'PTHR12741:SF96', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCAN SYNTHASE COMPONENT BGS2', 248142),
(381669, 'PTHR12741:SF51', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCAN SYNTHASE', 248142),
(381670, 'PTHR35358:SF7', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248143),
(381671, 'PTHR35358:SF8', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE-LIKE PROTEIN (PEARLI 4) FAMILY PROTEIN', 248143),
(381672, 'PTHR35358:SF19', NULL, NULL, NULL, NULL, 'PLANT PHOSPHOLIPASE-LIKE PROTEIN', 248143),
(381673, 'PTHR35358:SF18', NULL, NULL, NULL, NULL, 'PEPTIDASE S8, SUBTILISIN-RELATED PROTEIN-RELATED', 248143),
(381674, 'PTHR35358:SF17', NULL, NULL, NULL, NULL, '', 248143),
(381675, 'PTHR35358:SF16', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE-LIKE PROTEIN (PEARLI 4) FAMILY PROTEIN', 248143),
(381676, 'PTHR35358:SF15', NULL, NULL, NULL, NULL, 'BNAA09G43500D PROTEIN', 248143),
(381677, 'PTHR35358:SF14', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE', 248143),
(381678, 'PTHR35358:SF13', NULL, NULL, NULL, NULL, 'PEARLI 4 PROTEIN-RELATED', 248143),
(381679, 'PTHR35358:SF12', NULL, NULL, NULL, NULL, 'BNAA09G43510D PROTEIN', 248143),
(381680, 'PTHR35358:SF11', NULL, NULL, NULL, NULL, 'BNACNNG61640D PROTEIN', 248143),
(381681, 'PTHR35358:SF10', NULL, NULL, NULL, NULL, 'PLANT PHOSPHOLIPASE-LIKE PROTEIN', 248143),
(381682, 'PTHR35358:SF5', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE-LIKE PROTEIN (PEARLI 4) FAMILY PROTEIN', 248143),
(381683, 'PTHR35358', NULL, NULL, NULL, NULL, 'OS06G0711100 PROTEIN', 248143),
(381684, 'PTHR15349', NULL, NULL, NULL, NULL, 'ENDOTHELIAL PROTEIN C RECEPTOR', 248144),
(381685, 'PTHR15349:SF0', NULL, NULL, NULL, NULL, 'ENDOTHELIAL PROTEIN C RECEPTOR', 248144),
(381686, 'PTHR46355:SF1', NULL, NULL, NULL, NULL, 'STING ER EXIT PROTEIN', 248145),
(381687, 'PTHR46355', NULL, NULL, NULL, NULL, 'UPF0428 PROTEIN CXORF56', 248145),
(381688, 'PTHR47696:SF1', NULL, NULL, NULL, NULL, 'THAP DOMAIN-CONTAINING PROTEIN 2', 248146),
(381689, 'PTHR47696', NULL, NULL, NULL, NULL, 'THAP DOMAIN-CONTAINING PROTEIN 2', 248146),
(381690, 'PTHR23305:SF18', NULL, NULL, NULL, NULL, 'OBG-TYPE G DOMAIN-CONTAINING PROTEIN', 248147),
(381691, 'PTHR23305', NULL, NULL, NULL, NULL, 'OBG GTPASE FAMILY', 248147),
(381692, 'PTHR23305:SF17', NULL, NULL, NULL, NULL, 'OBG-LIKE ATPASE 1', 248147),
(381693, 'PTHR23305:SF1', NULL, NULL, NULL, NULL, 'OBG-TYPE G DOMAIN-CONTAINING PROTEIN', 248147),
(381694, 'PTHR23305:SF7', NULL, NULL, NULL, NULL, 'OBG-TYPE G DOMAIN-CONTAINING PROTEIN', 248147),
(381695, 'PTHR23305:SF11', NULL, NULL, NULL, NULL, 'OBG-LIKE ATPASE 1', 248147),
(381696, 'PTHR23305:SF9', NULL, NULL, NULL, NULL, 'OBG-LIKE ATPASE HOMOLOG', 248147),
(381697, 'PTHR16504:SF4', NULL, NULL, NULL, NULL, '5''(3'')-DEOXYRIBONUCLEOTIDASE', 248148),
(381698, 'PTHR16504:SF5', NULL, NULL, NULL, NULL, '5''(3'')-DEOXYRIBONUCLEOTIDASE, CYTOSOLIC TYPE', 248148),
(381699, 'PTHR16504:SF6', NULL, NULL, NULL, NULL, '5''(3'')-DEOXYRIBONUCLEOTIDASE, MITOCHONDRIAL', 248148),
(381700, 'PTHR16504', NULL, NULL, NULL, NULL, '5''(3'')-DEOXYRIBONUCLEOTIDASE', 248148),
(381701, 'PTHR43628', NULL, NULL, NULL, NULL, 'ACTIVATOR OF C KINASE PROTEIN 1-RELATED', 248149),
(381702, 'PTHR43628:SF1', NULL, NULL, NULL, NULL, 'CHITIN SYNTHASE REGULATORY FACTOR 2-RELATED', 248149),
(381703, 'PTHR43628:SF11', NULL, NULL, NULL, NULL, 'PROTEIN DSF2', 248149),
(381704, 'PTHR10441', NULL, NULL, NULL, NULL, 'CD8 ALPHA CHAIN', 248150);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(381705, 'PTHR10441:SF2', NULL, NULL, NULL, NULL, 'T-CELL SURFACE GLYCOPROTEIN CD8 ALPHA CHAIN', 248150),
(381706, 'PTHR31184', NULL, NULL, NULL, NULL, 'HUNTINGTIN-INTERACTING PROTEIN K FAMILY MEMBER', 248151),
(381707, 'PTHR31184:SF3', NULL, NULL, NULL, NULL, 'HYPK_UBA DOMAIN-CONTAINING PROTEIN', 248151),
(381708, 'PTHR31184:SF2', NULL, NULL, NULL, NULL, 'HUNTINGTIN-INTERACTING PROTEIN K', 248151),
(381709, 'PTHR33787', NULL, NULL, NULL, NULL, '', 248152),
(381710, 'PTHR33787:SF4', NULL, NULL, NULL, NULL, 'YCF20-LIKE PROTEIN', 248152),
(381711, 'PTHR33787:SF3', NULL, NULL, NULL, NULL, 'YCF20-LIKE PROTEIN', 248152),
(381712, 'PTHR33787:SF5', NULL, NULL, NULL, NULL, 'YCF20-LIKE PROTEIN', 248152),
(381713, 'PTHR35711:SF9', NULL, NULL, NULL, NULL, 'BNAC03G45130D PROTEIN', 248153),
(381714, 'PTHR35711:SF8', NULL, NULL, NULL, NULL, 'ALDOSE 1-EPIMERASE', 248153),
(381715, 'PTHR35711:SF4', NULL, NULL, NULL, NULL, 'ACTING ON PEPTIDE BONDS (PEPTIDASE)-RELATED', 248153),
(381716, 'PTHR35711:SF3', NULL, NULL, NULL, NULL, 'CALSEQUESTRIN', 248153),
(381717, 'PTHR35711:SF2', NULL, NULL, NULL, NULL, 'PROSTATIC SPERMINE-BINDING PROTEIN-LIKE', 248153),
(381718, 'PTHR35711:SF1', NULL, NULL, NULL, NULL, 'ECTODERMAL, ISOFORM F', 248153),
(381719, 'PTHR35711', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248153),
(381720, 'PTHR35711:SF10', NULL, NULL, NULL, NULL, '', 248153),
(381721, 'PTHR35711:SF11', NULL, NULL, NULL, NULL, 'GLUTAMIC ACID-RICH PROTEIN-LIKE', 248153),
(381722, 'PTHR35711:SF12', NULL, NULL, NULL, NULL, 'OS02G0184100 PROTEIN', 248153),
(381723, 'PTHR30314:SF30', NULL, NULL, NULL, NULL, 'CELL DIVISION FTSZ-LIKE PROTEIN', 248154),
(381724, 'PTHR30314:SF4', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL DIVISION PROTEIN FSZB', 248154),
(381725, 'PTHR30314', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN FTSZ-RELATED', 248154),
(381726, 'PTHR30314:SF3', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL DIVISION PROTEIN FSZA', 248154),
(381727, 'PTHR30314:SF17', NULL, NULL, NULL, NULL, 'FTSZ-LIKE PROTEIN', 248154),
(381728, 'PTHR30314:SF9', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN FTSZ 2', 248154),
(381729, 'PTHR30314:SF29', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN FTSZ HOMOLOG 2-1, CHLOROPLASTIC-LIKE', 248154),
(381730, 'PTHR30314:SF13', NULL, NULL, NULL, NULL, 'OS05G0443800 PROTEIN', 248154),
(381731, 'PTHR30314:SF24', NULL, NULL, NULL, NULL, 'BNAA02G09160D PROTEIN', 248154),
(381732, 'PTHR30314:SF25', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN FTSZ HOMOLOG 2-2, CHLOROPLASTIC-LIKE ISOFORM X1', 248154),
(381733, 'PTHR30314:SF26', NULL, NULL, NULL, NULL, 'FTSZ 2', 248154),
(381734, 'PTHR30314:SF16', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN FTSZ HOMOLOG 2-1, CHLOROPLASTIC', 248154),
(381735, 'PTHR30314:SF27', NULL, NULL, NULL, NULL, 'FTSZ1-2 PLASTID DIVISION PROTEIN', 248154),
(381736, 'PTHR30314:SF10', NULL, NULL, NULL, NULL, 'TUBULIN-LIKE PROTEIN CETZ', 248154),
(381737, 'PTHR30314:SF23', NULL, NULL, NULL, NULL, 'PLASTID DIVISION PROTEIN FTSZ', 248154),
(381738, 'PTHR30314:SF12', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN FTSZ HOMOLOG 1, CHLOROPLASTIC', 248154),
(381739, 'PTHR28040', NULL, NULL, NULL, NULL, 'PYRIDOXAMINE 5''-PHOSPHATE OXIDASE YLR456W HOMOLOG-RELATED', 248155),
(381740, 'PTHR28040:SF1', NULL, NULL, NULL, NULL, 'PYRIDOXAMINE 5''-PHOSPHATE OXIDASE YLR456W HOMOLOG-RELATED', 248155),
(381741, 'PTHR45738:SF12', NULL, NULL, NULL, NULL, 'SAC DOMAIN-CONTAINING PROTEIN', 248156),
(381742, 'PTHR45738:SF25', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHATASE SAC3-RELATED', 248156),
(381743, 'PTHR45738:SF14', NULL, NULL, NULL, NULL, 'SAC DOMAIN-CONTAINING PROTEIN', 248156),
(381744, 'PTHR45738', NULL, NULL, NULL, NULL, 'POLYPHOSPHOINOSITIDE PHOSPHATASE', 248156),
(381745, 'PTHR45738:SF15', NULL, NULL, NULL, NULL, 'SAC DOMAIN-CONTAINING PROTEIN', 248156),
(381746, 'PTHR45738:SF16', NULL, NULL, NULL, NULL, 'SAC DOMAIN, PHOSPHOINOSITIDE PHOSPHATASE SAC, PLANT-RELATED', 248156),
(381747, 'PTHR45738:SF17', NULL, NULL, NULL, NULL, 'SAC DOMAIN-CONTAINING PROTEIN', 248156),
(381748, 'PTHR45738:SF18', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHATASE SAC4', 248156);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(381749, 'PTHR45738:SF8', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHATASE SAC2', 248156),
(381750, 'PTHR45738:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHATASE SAC2', 248156),
(381751, 'PTHR45738:SF2', NULL, NULL, NULL, NULL, 'OS06G0195600 PROTEIN', 248156),
(381752, 'PTHR45738:SF3', NULL, NULL, NULL, NULL, 'OS03G0182400 PROTEIN', 248156),
(381753, 'PTHR45738:SF5', NULL, NULL, NULL, NULL, 'POLYPHOSPHOINOSITIDE PHOSPHATASE', 248156),
(381754, 'PTHR45738:SF20', NULL, NULL, NULL, NULL, 'SAC DOMAIN-CONTAINING PROTEIN', 248156),
(381755, 'PTHR45738:SF6', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHATASE SAC5', 248156),
(381756, 'PTHR45738:SF21', NULL, NULL, NULL, NULL, 'SAC DOMAIN-CONTAINING PROTEIN', 248156),
(381757, 'PTHR45738:SF10', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHATASE SAC2-LIKE', 248156),
(381758, 'PTHR35082', NULL, NULL, NULL, NULL, 'BEN DOMAIN-CONTAINING PROTEIN 4', 248157),
(381759, 'PTHR35082:SF1', NULL, NULL, NULL, NULL, 'BEN DOMAIN-CONTAINING PROTEIN 4', 248157),
(381760, 'PTHR44984:SF1', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NEK3', 248158),
(381761, 'PTHR44984', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NEK3', 248158),
(381762, 'PTHR41252:SF1', NULL, NULL, NULL, NULL, 'BLR2505 PROTEIN', 248159),
(381763, 'PTHR41252', NULL, NULL, NULL, NULL, 'BLR2505 PROTEIN', 248159),
(381764, 'PTHR13647', NULL, NULL, NULL, NULL, 'INSULIN-LIKE PEPTIDE 2-RELATED', 248160),
(381765, 'PTHR13647:SF5', NULL, NULL, NULL, NULL, 'INSULIN-LIKE PEPTIDE 2-RELATED', 248160),
(381766, 'PTHR13647:SF4', NULL, NULL, NULL, NULL, 'INSULIN-LIKE PEPTIDE 1-RELATED', 248160),
(381767, 'PTHR13647:SF6', NULL, NULL, NULL, NULL, 'INSULIN-LIKE PEPTIDE 3-RELATED', 248160),
(381768, 'PTHR28366', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248161),
(381769, 'PTHR28366:SF1', NULL, NULL, NULL, NULL, 'ZGC:194224', 248161),
(381770, 'PTHR22640:SF2', NULL, NULL, NULL, NULL, 'STRUCTURAL MAINTENANCE OF CHROMOSOMES FLEXIBLE HINGE DOMAIN-CONTAINING PROTEIN 1', 248162),
(381771, 'PTHR22640', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248162),
(381772, 'PTHR10579:SF51', NULL, NULL, NULL, NULL, 'ZINC FINGER (C3HC4-TYPE RING FINGER) FAMILY PROTEIN', 248163),
(381773, 'PTHR10579:SF129', NULL, NULL, NULL, NULL, 'OS01G0640200 PROTEIN', 248163),
(381774, 'PTHR10579:SF125', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 248163),
(381775, 'PTHR10579:SF126', NULL, NULL, NULL, NULL, 'ZINC FINGER (C3HC4-TYPE RING FINGER) FAMILY PROTEIN', 248163),
(381776, 'PTHR10579:SF165', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE WAVH1', 248163),
(381777, 'PTHR10579:SF120', NULL, NULL, NULL, NULL, 'CHROMATIN REGULATOR PHD FAMILY-RELATED', 248163),
(381778, 'PTHR10579:SF164', NULL, NULL, NULL, NULL, 'ZINC FINGER (C3HC4-TYPE RING FINGER) FAMILY PROTEIN', 248163),
(381779, 'PTHR10579:SF49', NULL, NULL, NULL, NULL, 'OS04G0508800 PROTEIN', 248163),
(381780, 'PTHR10579:SF123', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 248163),
(381781, 'PTHR10579:SF122', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 248163),
(381782, 'PTHR10579:SF166', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 248163),
(381783, 'PTHR10579:SF161', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 248163),
(381784, 'PTHR10579:SF160', NULL, NULL, NULL, NULL, 'CALCIUM-ACTIVATED CHLORIDE CHANNEL REGULATOR 3A-1-RELATED', 248163),
(381785, 'PTHR10579:SF163', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 248163),
(381786, 'PTHR10579:SF162', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 248163),
(381787, 'PTHR10579:SF42', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL ACCESSORY 3B', 248163),
(381788, 'PTHR10579:SF43', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL ACCESSORY 1', 248163),
(381789, 'PTHR10579:SF47', NULL, NULL, NULL, NULL, 'OS09G0298500 PROTEIN', 248163),
(381790, 'PTHR10579:SF135', NULL, NULL, NULL, NULL, 'OS12G0203500 PROTEIN', 248163),
(381791, 'PTHR10579:SF137', NULL, NULL, NULL, NULL, 'BNAC02G43940D PROTEIN', 248163),
(381792, 'PTHR10579:SF132', NULL, NULL, NULL, NULL, 'OS10G0464800 PROTEIN', 248163);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(381793, 'PTHR10579:SF131', NULL, NULL, NULL, NULL, 'T6D22.13', 248163),
(381794, 'PTHR10579', NULL, NULL, NULL, NULL, 'CALCIUM-ACTIVATED CHLORIDE CHANNEL REGULATOR', 248163),
(381795, 'PTHR10579:SF52', NULL, NULL, NULL, NULL, 'CALCIUM-ACTIVATED CHLORIDE CHANNEL REGULATOR 1', 248163),
(381796, 'PTHR10579:SF55', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE WAV3', 248163),
(381797, 'PTHR10579:SF54', NULL, NULL, NULL, NULL, 'OS10G0464500 PROTEIN', 248163),
(381798, 'PTHR10579:SF57', NULL, NULL, NULL, NULL, 'OS11G0687100 PROTEIN', 248163),
(381799, 'PTHR10579:SF59', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE EDA40-RELATED', 248163),
(381800, 'PTHR10579:SF109', NULL, NULL, NULL, NULL, 'OS02G0806700 PROTEIN', 248163),
(381801, 'PTHR10579:SF103', NULL, NULL, NULL, NULL, 'ACTIVATED CHLORINE CHANNEL, PUTATIVE-RELATED', 248163),
(381802, 'PTHR10579:SF146', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 248163),
(381803, 'PTHR10579:SF102', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248163),
(381804, 'PTHR10579:SF105', NULL, NULL, NULL, NULL, 'ZINC FINGER (C3HC4-TYPE RING FINGER) FAMILY PROTEIN', 248163),
(381805, 'PTHR10579:SF141', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR, TYPE A, ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 248163),
(381806, 'PTHR10579:SF140', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 248163),
(381807, 'PTHR10579:SF66', NULL, NULL, NULL, NULL, 'CALCIUM-ACTIVATED CHLORIDE CHANNEL REGULATOR 2', 248163),
(381808, 'PTHR10579:SF2', NULL, NULL, NULL, NULL, 'CALCIUM-ACTIVATED CHLORIDE CHANNEL REGULATOR 4', 248163),
(381809, 'PTHR10579:SF119', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248163),
(381810, 'PTHR10579:SF158', NULL, NULL, NULL, NULL, 'RETROELEMENT POL POLYPROTEIN-LIKE', 248163),
(381811, 'PTHR10579:SF114', NULL, NULL, NULL, NULL, 'ZINC FINGER (C3HC4-TYPE RING FINGER) FAMILY PROTEIN', 248163),
(381812, 'PTHR10579:SF157', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR, TYPE A-RELATED', 248163),
(381813, 'PTHR10579:SF159', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 248163),
(381814, 'PTHR10579:SF110', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 248163),
(381815, 'PTHR10579:SF153', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE WAVH2-RELATED', 248163),
(381816, 'PTHR10579:SF156', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 248163),
(381817, 'PTHR10579:SF112', NULL, NULL, NULL, NULL, 'OS04G0198300 PROTEIN', 248163),
(381818, 'PTHR10579:SF155', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 248163),
(381819, 'PTHR10579:SF150', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 248163),
(381820, 'PTHR10579:SF152', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 248163),
(381821, 'PTHR19339:SF0', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 41', 248164),
(381822, 'PTHR19339', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 39', 248164),
(381823, 'PTHR19339:SF8', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 248164),
(381824, 'PTHR19339:SF9', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 248164),
(381825, 'PTHR19339:SF2', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 22', 248164),
(381826, 'PTHR19339:SF5', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 248164),
(381827, 'PTHR47067:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR ATRX-LIKE PROTEIN', 248165),
(381828, 'PTHR47067:SF6', NULL, NULL, NULL, NULL, 'PROTEIN WVD2-LIKE 7', 248165),
(381829, 'PTHR47067:SF5', NULL, NULL, NULL, NULL, 'OS02G0558600 PROTEIN', 248165),
(381830, 'PTHR47067:SF4', NULL, NULL, NULL, NULL, 'OS05G0420500 PROTEIN', 248165),
(381831, 'PTHR47067:SF3', NULL, NULL, NULL, NULL, 'BNAC06G13140D PROTEIN', 248165),
(381832, 'PTHR47067', NULL, NULL, NULL, NULL, 'TPX2 (TARGETING PROTEIN FOR XKLP2) PROTEIN FAMILY-RELATED', 248165),
(381833, 'PTHR47067:SF19', NULL, NULL, NULL, NULL, 'TPX2 (TARGETING PROTEIN FOR XKLP2) PROTEIN FAMILY', 248165),
(381834, 'PTHR47067:SF17', NULL, NULL, NULL, NULL, 'BNAA06G32160D PROTEIN', 248165);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(381835, 'PTHR47067:SF16', NULL, NULL, NULL, NULL, 'TPX2 DOMAIN-CONTAINING PROTEIN', 248165),
(381836, 'PTHR47067:SF15', NULL, NULL, NULL, NULL, 'BNAA04G10550D PROTEIN', 248165),
(381837, 'PTHR47067:SF14', NULL, NULL, NULL, NULL, 'PROTEIN WVD2-LIKE 7 ISOFORM X1', 248165),
(381838, 'PTHR47067:SF12', NULL, NULL, NULL, NULL, 'PROTEIN WVD2-LIKE 7 ISOFORM X1', 248165),
(381839, 'PTHR47067:SF11', NULL, NULL, NULL, NULL, 'BNAC07G13330D PROTEIN', 248165),
(381840, 'PTHR47067:SF21', NULL, NULL, NULL, NULL, 'TPX2 (TARGETING PROTEIN FOR XKLP2) PROTEIN FAMILY', 248165),
(381841, 'PTHR47067:SF20', NULL, NULL, NULL, NULL, '', 248165),
(381842, 'PTHR31182:SF13', NULL, NULL, NULL, NULL, 'C2 NT-TYPE DOMAIN-CONTAINING PROTEIN', 248166),
(381843, 'PTHR31182:SF14', NULL, NULL, NULL, NULL, 'SPLICING FACTOR 3A SUBUNIT', 248166),
(381844, 'PTHR31182:SF15', NULL, NULL, NULL, NULL, 'F26K24.5 PROTEIN', 248166),
(381845, 'PTHR31182:SF16', NULL, NULL, NULL, NULL, 'C2 NT-TYPE DOMAIN-CONTAINING PROTEIN', 248166),
(381846, 'PTHR31182:SF17', NULL, NULL, NULL, NULL, 'EEIG1/EHBP1 PROTEIN AMINO-TERMINAL DOMAIN PROTEIN', 248166),
(381847, 'PTHR31182:SF18', NULL, NULL, NULL, NULL, 'C2 NT-TYPE DOMAIN-CONTAINING PROTEIN', 248166),
(381848, 'PTHR31182:SF6', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248166),
(381849, 'PTHR31182', NULL, NULL, NULL, NULL, 'C2 NT-TYPE DOMAIN-CONTAINING PROTEIN', 248166),
(381850, 'PTHR31182:SF2', NULL, NULL, NULL, NULL, '', 248166),
(381851, 'PTHR31182:SF20', NULL, NULL, NULL, NULL, 'C2 NT-TYPE DOMAIN-CONTAINING PROTEIN', 248166),
(381852, 'PTHR31516:SF22', NULL, NULL, NULL, NULL, '', 248167),
(381853, 'PTHR31516:SF21', NULL, NULL, NULL, NULL, 'PROTEIN CBG07669', 248167),
(381854, 'PTHR31516:SF9', NULL, NULL, NULL, NULL, 'STABILIZER OF AXONEMAL MICROTUBULES 1', 248167),
(381855, 'PTHR31516', NULL, NULL, NULL, NULL, 'STABILIZER OF AXONEMAL MICROTUBULES 2', 248167),
(381856, 'PTHR31516:SF17', NULL, NULL, NULL, NULL, 'STABILIZER OF AXONEMAL MICROTUBULES 2', 248167),
(381857, 'PTHR31516:SF16', NULL, NULL, NULL, NULL, '', 248167),
(381858, 'PTHR31516:SF19', NULL, NULL, NULL, NULL, 'PROTEIN CBG10706', 248167),
(381859, 'PTHR31516:SF18', NULL, NULL, NULL, NULL, '', 248167),
(381860, 'PTHR31516:SF6', NULL, NULL, NULL, NULL, 'STABILIZER OF AXONEMAL MICROTUBULES 2', 248167),
(381861, 'PTHR15386', NULL, NULL, NULL, NULL, 'FIBRINOGEN SILENCER-BINDING PROTEIN', 248168),
(381862, 'PTHR15386:SF0', NULL, NULL, NULL, NULL, 'FIBRINOGEN SILENCER-BINDING PROTEIN', 248168),
(381863, 'PTHR10707:SF9', NULL, NULL, NULL, NULL, 'MAINTENANCE OF TELOMERE CAPPING PROTEIN 3, MITOCHONDRIAL', 248169),
(381864, 'PTHR10707:SF15', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 4', 248169),
(381865, 'PTHR10707:SF13', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 4', 248169),
(381866, 'PTHR10707:SF14', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 4', 248169),
(381867, 'PTHR10707:SF11', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 4 ISOFORM 2, MITOCHONDRIAL', 248169),
(381868, 'PTHR10707:SF12', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 4 ISOFORM 1, MITOCHONDRIAL', 248169),
(381869, 'PTHR10707:SF10', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 4', 248169),
(381870, 'PTHR10707', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT IV', 248169),
(381871, 'PTHR37529', NULL, NULL, NULL, NULL, 'TRANSPOSASE INSG FOR INSERTION SEQUENCE ELEMENT IS4-RELATED', 248170),
(381872, 'PTHR37529:SF1', NULL, NULL, NULL, NULL, 'TRANSPOSASE INSG FOR INSERTION SEQUENCE ELEMENT IS4-RELATED', 248170),
(381873, 'PTHR45793', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN', 248171),
(381874, 'PTHR45793:SF17', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 248171),
(381875, 'PTHR45793:SF16', NULL, NULL, NULL, NULL, 'ARGININE-FIFTY HOMEOBOX', 248171),
(381876, 'PTHR45793:SF18', NULL, NULL, NULL, NULL, 'PAIRED-LIKE HOMEODOMAIN TRANSCRIPTION FACTOR LEUTX', 248171),
(381877, 'PTHR45793:SF9', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN OTX1', 248171),
(381878, 'PTHR45793:SF24', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 248171);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(381879, 'PTHR45793:SF23', NULL, NULL, NULL, NULL, 'CONE-ROD HOMEOBOX-RELATED', 248171),
(381880, 'PTHR45793:SF12', NULL, NULL, NULL, NULL, 'TETRA-PEPTIDE REPEAT HOMEOBOX PROTEIN 1', 248171),
(381881, 'PTHR45793:SF15', NULL, NULL, NULL, NULL, 'DIVERGENT PAIRED-RELATED HOMEOBOX', 248171),
(381882, 'PTHR45793:SF7', NULL, NULL, NULL, NULL, 'CONE-ROD HOMEOBOX PROTEIN', 248171),
(381883, 'PTHR45793:SF25', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN CEH-36', 248171),
(381884, 'PTHR45793:SF5', NULL, NULL, NULL, NULL, 'HOMEOTIC PROTEIN OCELLILESS', 248171),
(381885, 'PTHR45793:SF22', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN OTX5', 248171),
(381886, 'PTHR45793:SF21', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 248171),
(381887, 'PTHR45793:SF1', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 248171),
(381888, 'PTHR45793:SF2', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN OTX2', 248171),
(381889, 'PTHR35766', NULL, NULL, NULL, NULL, 'OS08G0543600 PROTEIN', 248172),
(381890, 'PTHR35766:SF1', NULL, NULL, NULL, NULL, 'OS08G0543600 PROTEIN', 248172),
(381891, 'PTHR39412:SF1', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 46', 248173),
(381892, 'PTHR39412', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 46', 248173),
(381893, 'PTHR11259:SF4', NULL, NULL, NULL, NULL, 'RAS-RELATED GTP-BINDING PROTEIN B', 248174),
(381894, 'PTHR11259:SF1', NULL, NULL, NULL, NULL, 'RAS-RELATED GTP-BINDING PROTEIN', 248174),
(381895, 'PTHR11259:SF2', NULL, NULL, NULL, NULL, 'GH16429P', 248174),
(381896, 'PTHR11259', NULL, NULL, NULL, NULL, 'RAS-RELATED GTP BINDING RAG/GTR YEAST', 248174),
(381897, 'PTHR11259:SF7', NULL, NULL, NULL, NULL, 'RAS-RELATED GTP-BINDING PROTEIN A', 248174),
(381898, 'PTHR11259:SF5', NULL, NULL, NULL, NULL, 'RAS-RELATED GTP-BINDING PROTEIN D', 248174),
(381899, 'PTHR11259:SF6', NULL, NULL, NULL, NULL, 'RAS-RELATED GTP-BINDING PROTEIN C', 248174),
(381900, 'PTHR33157:SF13', NULL, NULL, NULL, NULL, '', 248175),
(381901, 'PTHR33157:SF12', NULL, NULL, NULL, NULL, '', 248175),
(381902, 'PTHR33157:SF11', NULL, NULL, NULL, NULL, '', 248175),
(381903, 'PTHR33157:SF8', NULL, NULL, NULL, NULL, 'OS11G0485000 PROTEIN', 248175),
(381904, 'PTHR33157:SF10', NULL, NULL, NULL, NULL, 'AUTONOMOUS TRANSPOSABLE ELEMENT EN-1 MOSAIC PROTEIN', 248175),
(381905, 'PTHR33157:SF5', NULL, NULL, NULL, NULL, 'OS09G0314100 PROTEIN', 248175),
(381906, 'PTHR33157', NULL, NULL, NULL, NULL, 'AUTONOMOUS TRANSPOSABLE ELEMENT EN-1 MOSAIC PROTEIN-RELATED', 248175),
(381907, 'PTHR11681:SF13', NULL, NULL, NULL, NULL, 'ISOTOCIN', 248176),
(381908, 'PTHR11681:SF14', NULL, NULL, NULL, NULL, 'VASOTOCIN-NEUROPHYSIN VT', 248176),
(381909, 'PTHR11681:SF2', NULL, NULL, NULL, NULL, 'OXYTOCIN-NEUROPHYSIN 1', 248176),
(381910, 'PTHR11681:SF9', NULL, NULL, NULL, NULL, 'VASOPRESSIN-NEUROPHYSIN 2-COPEPTIN', 248176),
(381911, 'PTHR11681:SF5', NULL, NULL, NULL, NULL, 'OXYTOCIN', 248176),
(381912, 'PTHR11681', NULL, NULL, NULL, NULL, 'NEUROPHYSIN', 248176),
(381913, 'PTHR31554', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 184', 248177),
(381914, 'PTHR31554:SF2', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 184', 248177),
(381915, 'PTHR23043:SF38', NULL, NULL, NULL, NULL, 'NEURONAL PAS DOMAIN-CONTAINING PROTEIN 4A-RELATED', 248178),
(381916, 'PTHR23043:SF17', NULL, NULL, NULL, NULL, 'PROTEIN SIMILAR', 248178),
(381917, 'PTHR23043:SF36', NULL, NULL, NULL, NULL, 'PROTEIN SINGLE-MINDED', 248178),
(381918, 'PTHR23043:SF25', NULL, NULL, NULL, NULL, 'NEURONAL PAS DOMAIN-CONTAINING PROTEIN 1', 248178),
(381919, 'PTHR23043:SF26', NULL, NULL, NULL, NULL, 'PROTEIN TRACHEALESS', 248178),
(381920, 'PTHR23043', NULL, NULL, NULL, NULL, 'HYPOXIA-INDUCIBLE FACTOR 1 ALPHA', 248178),
(381921, 'PTHR23043:SF37', NULL, NULL, NULL, NULL, 'NEURONAL PAS DOMAIN-CONTAINING PROTEIN 4-LIKE', 248178),
(381922, 'PTHR23043:SF18', NULL, NULL, NULL, NULL, 'HYPOXIA-INDUCIBLE FACTOR 3-ALPHA', 248178),
(381923, 'PTHR23043:SF19', NULL, NULL, NULL, NULL, 'SINGLE-MINDED HOMOLOG 2', 248178),
(381924, 'PTHR23043:SF30', NULL, NULL, NULL, NULL, 'NEURONAL PAS DOMAIN-CONTAINING PROTEIN 3', 248178);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(381925, 'PTHR23043:SF8', NULL, NULL, NULL, NULL, 'ENDOTHELIAL PAS DOMAIN-CONTAINING PROTEIN 1', 248178),
(381926, 'PTHR23043:SF34', NULL, NULL, NULL, NULL, 'HYPOXIA-INDUCIBLE FACTOR 1 SUBUNIT ALPHA,-LIKE', 248178),
(381927, 'PTHR23043:SF24', NULL, NULL, NULL, NULL, 'NEURONAL PAS DOMAIN-CONTAINING PROTEIN 4', 248178),
(381928, 'PTHR23043:SF35', NULL, NULL, NULL, NULL, 'HIF-1A_CTAD DOMAIN-CONTAINING PROTEIN', 248178),
(381929, 'PTHR23043:SF7', NULL, NULL, NULL, NULL, 'HYPOXIA-INDUCIBLE FACTOR 1-ALPHA', 248178),
(381930, 'PTHR23043:SF22', NULL, NULL, NULL, NULL, 'SINGLE-MINDED HOMOLOG 1', 248178),
(381931, 'PTHR44874:SF1', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 34', 248179),
(381932, 'PTHR44874', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 34', 248179),
(381933, 'PTHR16125:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 74', 248180),
(381934, 'PTHR16125:SF1', NULL, NULL, NULL, NULL, '', 248180),
(381935, 'PTHR16125', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 74', 248180),
(381936, 'PTHR16125:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 74B', 248180),
(381937, 'PTHR15531:SF0', NULL, NULL, NULL, NULL, 'PROSAAS', 248181),
(381938, 'PTHR15531', NULL, NULL, NULL, NULL, 'PROSAAS', 248181),
(381939, 'PTHR28108:SF1', NULL, NULL, NULL, NULL, 'SWR1-COMPLEX PROTEIN 3', 248182),
(381940, 'PTHR28108', NULL, NULL, NULL, NULL, 'SWR1-COMPLEX PROTEIN 3', 248182),
(381941, 'PTHR32487:SF4', NULL, NULL, NULL, NULL, '', 248183),
(381942, 'PTHR32487:SF0', NULL, NULL, NULL, NULL, 'NAD DEPENDENT EPIMERASE/DEHYDRATASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_8G00600)', 248183),
(381943, 'PTHR32487:SF8', NULL, NULL, NULL, NULL, '', 248183),
(381944, 'PTHR32487:SF21', NULL, NULL, NULL, NULL, 'BNAA03G46530D PROTEIN', 248183),
(381945, 'PTHR32487:SF10', NULL, NULL, NULL, NULL, '3-OXO-DELTA(4,5)-STEROID 5-BETA-REDUCTASE-LIKE', 248183),
(381946, 'PTHR32487:SF11', NULL, NULL, NULL, NULL, '', 248183),
(381947, 'PTHR32487:SF22', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 248183),
(381948, 'PTHR32487:SF12', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 248183),
(381949, 'PTHR32487:SF23', NULL, NULL, NULL, NULL, '3-OXO-DELTA(4,5)-STEROID 5-BETA-REDUCTASE-RELATED', 248183),
(381950, 'PTHR32487:SF13', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 248183),
(381951, 'PTHR32487:SF14', NULL, NULL, NULL, NULL, 'OS07G0601600 PROTEIN', 248183),
(381952, 'PTHR32487:SF26', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL POLYMYXIN RESISTANCE PROTEIN, ARNA-RELATED', 248183),
(381953, 'PTHR32487:SF16', NULL, NULL, NULL, NULL, '', 248183),
(381954, 'PTHR32487:SF17', NULL, NULL, NULL, NULL, '3-OXO-DELTA(45)-STEROID 5-BETA-REDUCTASE', 248183),
(381955, 'PTHR32487:SF28', NULL, NULL, NULL, NULL, '3-OXO-DELTA(4,5)-STEROID 5-BETA-REDUCTASE-LIKE', 248183),
(381956, 'PTHR32487:SF18', NULL, NULL, NULL, NULL, '3-OXO-DELTA(4,5)-STEROID 5-BETA-REDUCTASE-LIKE', 248183),
(381957, 'PTHR32487:SF29', NULL, NULL, NULL, NULL, '', 248183),
(381958, 'PTHR32487', NULL, NULL, NULL, NULL, '3-OXO-DELTA(4,5)-STEROID 5-BETA-REDUCTASE', 248183),
(381959, 'PTHR32487:SF19', NULL, NULL, NULL, NULL, '3-OXO-DELTA(4,5)-STEROID 5-BETA-REDUCTASE', 248183),
(381960, 'PTHR35268:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CCSMST1', 248184),
(381961, 'PTHR35268', NULL, NULL, NULL, NULL, 'PROTEIN CCSMST1', 248184),
(381962, 'PTHR47377:SF1', NULL, NULL, NULL, NULL, 'RHODANESE-LIKE DOMAIN-CONTAINING PROTEIN 4, CHLOROPLASTIC', 248185),
(381963, 'PTHR47377', NULL, NULL, NULL, NULL, 'RHODANESE-LIKE DOMAIN-CONTAINING PROTEIN 4, CHLOROPLASTIC', 248185),
(381964, 'PTHR47377:SF4', NULL, NULL, NULL, NULL, 'RHODANESE-LIKE DOMAIN-CONTAINING PROTEIN 4, CHLOROPLASTIC', 248185),
(381965, 'PTHR47377:SF3', NULL, NULL, NULL, NULL, 'RHODANESE-LIKE DOMAIN-CONTAINING PROTEIN 4A, CHLOROPLASTIC', 248185),
(381966, 'PTHR28307:SF3', NULL, NULL, NULL, NULL, 'PROTEIN PAL1', 248186),
(381967, 'PTHR28307:SF2', NULL, NULL, NULL, NULL, 'PROTEIN PAL1', 248186),
(381968, 'PTHR28307:SF1', NULL, NULL, NULL, NULL, '', 248186),
(381969, 'PTHR28307', NULL, NULL, NULL, NULL, 'PROTEIN PAL1', 248186);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(381970, 'PTHR46803', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE CHIP', 248187),
(381971, 'PTHR46803:SF4', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE CHIP', 248187),
(381972, 'PTHR46803:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE CHIP', 248187),
(381973, 'PTHR46623:SF10', NULL, NULL, NULL, NULL, 'CARBOXYMETHYLENEBUTENOLIDASE HOMOLOG', 248188),
(381974, 'PTHR46623:SF8', NULL, NULL, NULL, NULL, 'DLH DOMAIN-CONTAINING PROTEIN', 248188),
(381975, 'PTHR46623:SF7', NULL, NULL, NULL, NULL, 'CARBOXYMETHYLENEBUTENOLIDASE', 248188),
(381976, 'PTHR46623:SF6', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 248188),
(381977, 'PTHR46623:SF5', NULL, NULL, NULL, NULL, 'DLH DOMAIN-CONTAINING PROTEIN', 248188),
(381978, 'PTHR46623', NULL, NULL, NULL, NULL, 'CARBOXYMETHYLENEBUTENOLIDASE-RELATED', 248188),
(381979, 'PTHR42752:SF1', NULL, NULL, NULL, NULL, 'IMIDAZOLONEPROPIONASE-RELATED', 248189),
(381980, 'PTHR42752', NULL, NULL, NULL, NULL, 'IMIDAZOLONEPROPIONASE', 248189),
(381981, 'PTHR46076:SF3', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RING1', 248190),
(381982, 'PTHR46076:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RING1', 248190),
(381983, 'PTHR46076:SF5', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RING1', 248190),
(381984, 'PTHR46076:SF4', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RING2', 248190),
(381985, 'PTHR46076', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RING1 / RING 2 FAMILY MEMBER', 248190),
(381986, 'PTHR17920:SF22', NULL, NULL, NULL, NULL, 'DUF726 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_2G12860)', 248191),
(381987, 'PTHR17920:SF23', NULL, NULL, NULL, NULL, '', 248191),
(381988, 'PTHR17920:SF7', NULL, NULL, NULL, NULL, 'OS10G0512100 PROTEIN', 248191),
(381989, 'PTHR17920:SF12', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE/COILED-COIL PROTEIN (DUF726)', 248191),
(381990, 'PTHR17920:SF20', NULL, NULL, NULL, NULL, '', 248191),
(381991, 'PTHR17920:SF21', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE/COILED-COIL PROTEIN (DUF726)', 248191),
(381992, 'PTHR17920', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AND COILED-COIL DOMAIN-CONTAINING PROTEIN 4 TMCO4', 248191),
(381993, 'PTHR17920:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AND COILED-COIL DOMAIN-CONTAINING PROTEIN 4', 248191),
(381994, 'PTHR17920:SF4', NULL, NULL, NULL, NULL, 'VPS9 DOMAIN-CONTAINING PROTEIN', 248191),
(381995, 'PTHR37689', NULL, NULL, NULL, NULL, 'PROTEIN FDHE', 248192),
(381996, 'PTHR37689:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FDHE', 248192),
(381997, 'PTHR44298:SF1', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY B MEMBER 11', 248193),
(381998, 'PTHR44298', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY B MEMBER 11', 248193),
(381999, 'PTHR12326:SF3', NULL, NULL, NULL, NULL, 'DIFFERENTIALLY EXPRESSED IN FDCP 8 HOMOLOG', 248194),
(382000, 'PTHR12326:SF12', NULL, NULL, NULL, NULL, 'RUN DOMAIN-CONTAINING PROTEIN', 248194),
(382001, 'PTHR12326', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN CONTAINING PROTEIN', 248194),
(382002, 'PTHR12326:SF13', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY AND RUN DOMAIN CONTAINING M1', 248194),
(382003, 'PTHR12326:SF10', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY M MEMBER 3', 248194),
(382004, 'PTHR12326:SF5', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY M MEMBER 1', 248194),
(382005, 'PTHR47563:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FMP25, MITOCHONDRIAL', 248195),
(382006, 'PTHR47563', NULL, NULL, NULL, NULL, 'PROTEIN FMP25, MITOCHONDRIAL', 248195),
(382007, 'PTHR20956', NULL, NULL, NULL, NULL, 'HEH2P', 248196),
(382008, 'PTHR20956:SF12', NULL, NULL, NULL, NULL, 'FLYWCH-TYPE DOMAIN-CONTAINING PROTEIN', 248196),
(382009, 'PTHR20956:SF13', NULL, NULL, NULL, NULL, 'MULE DOMAIN-CONTAINING PROTEIN', 248196),
(382010, 'PTHR20956:SF14', NULL, NULL, NULL, NULL, '', 248196),
(382011, 'PTHR20956:SF15', NULL, NULL, NULL, NULL, 'MULE DOMAIN-CONTAINING PROTEIN', 248196),
(382012, 'PTHR34253:SF2', NULL, NULL, NULL, NULL, '', 248197),
(382013, 'PTHR34253:SF3', NULL, NULL, NULL, NULL, 'PROTEIN LLP HOMOLOG', 248197);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(382014, 'PTHR34253:SF1', NULL, NULL, NULL, NULL, 'PROTEIN LLP HOMOLOG', 248197),
(382015, 'PTHR34253', NULL, NULL, NULL, NULL, 'PROTEIN LLP HOMOLOG', 248197),
(382016, 'PTHR38096:SF1', NULL, NULL, NULL, NULL, 'ENTEROBACTIN SYNTHASE COMPONENT D', 248198),
(382017, 'PTHR38096', NULL, NULL, NULL, NULL, 'ENTEROBACTIN SYNTHASE COMPONENT D', 248198),
(382018, 'PTHR19980', NULL, NULL, NULL, NULL, 'RNA CLEAVAGE STIMULATION FACTOR', 248199),
(382019, 'PTHR19980:SF0', NULL, NULL, NULL, NULL, 'CLEAVAGE STIMULATION FACTOR SUBUNIT 3', 248199),
(382020, 'PTHR33590:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM186A', 248200),
(382021, 'PTHR33590:SF1', NULL, NULL, NULL, NULL, 'GLUTENIN, HIGH MOLECULAR WEIGHT SUBUNIT PW212-RELATED PROTEIN', 248200),
(382022, 'PTHR33590', NULL, NULL, NULL, NULL, 'GLUTENIN, HIGH MOLECULAR WEIGHT SUBUNIT PW212-RELATED PROTEIN', 248200),
(382023, 'PTHR33590:SF3', NULL, NULL, NULL, NULL, 'PROTEIN FAM186B', 248200),
(382024, 'PTHR15034', NULL, NULL, NULL, NULL, 'DEATH DOMAIN-CONTAINING PROTEIN CRADD', 248201),
(382025, 'PTHR15034:SF5', NULL, NULL, NULL, NULL, 'DEATH DOMAIN-CONTAINING PROTEIN CRADD', 248201),
(382026, 'PTHR15034:SF6', NULL, NULL, NULL, NULL, 'CASPASE DRONC', 248201),
(382027, 'PTHR15034:SF7', NULL, NULL, NULL, NULL, 'CARD DOMAIN-CONTAINING PROTEIN', 248201),
(382028, 'PTHR36832:SF1', NULL, NULL, NULL, NULL, 'SLR1174 PROTEIN', 248202),
(382029, 'PTHR36832:SF2', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN-RELATED', 248202),
(382030, 'PTHR36832', NULL, NULL, NULL, NULL, 'SLR1174 PROTEIN-RELATED', 248202),
(382031, 'PTHR10334:SF502', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382032, 'PTHR10334:SF503', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382033, 'PTHR10334:SF504', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382034, 'PTHR10334:SF505', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED PROTEIN 1', 248203),
(382035, 'PTHR10334:SF506', NULL, NULL, NULL, NULL, 'VENOM-ALLERGEN-LIKE PROTEIN', 248203),
(382036, 'PTHR10334:SF507', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382037, 'PTHR10334:SF508', NULL, NULL, NULL, NULL, 'CAP (CYSTEINE-RICH SECRETORY PROTEINS, ANTIGEN 5, AND PATHOGENESIS-RELATED 1 PROTEIN) SUPERFAMILY PROTEIN', 248203),
(382038, 'PTHR10334:SF460', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382039, 'PTHR10334:SF461', NULL, NULL, NULL, NULL, 'PEPTIDASE INHIBITOR 16', 248203),
(382040, 'PTHR10334:SF220', NULL, NULL, NULL, NULL, 'GLIPR1-LIKE PROTEIN 1', 248203),
(382041, 'PTHR10334:SF462', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382042, 'PTHR10334:SF346', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH SECRETORY PROTEIN LCCL DOMAIN-CONTAINING 1A', 248203),
(382043, 'PTHR10334:SF467', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED PROTEIN 1-8', 248203),
(382044, 'PTHR10334:SF513', NULL, NULL, NULL, NULL, 'GLI PATHOGENESIS-RELATED 2-RELATED', 248203),
(382045, 'PTHR10334:SF515', NULL, NULL, NULL, NULL, 'EXTRACELLULAR PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G12350)-RELATED', 248203),
(382046, 'PTHR10334:SF516', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED PROTEIN 1-11', 248203),
(382047, 'PTHR10334:SF517', NULL, NULL, NULL, NULL, 'GOLGI-ASSOCIATED PLANT PATHOGENESIS-RELATED PROTEIN 1', 248203),
(382048, 'PTHR10334:SF73', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH SECRETORY PROTEIN LCCL DOMAIN-CONTAINING 1', 248203),
(382049, 'PTHR10334:SF470', NULL, NULL, NULL, NULL, 'CAP (CYSTEINE-RICH SECRETORY PROTEINS ANTIGEN 5 AND PATHOGENESIS-RELATED 1 PROTEIN) SUPERFAMILY PROTEIN', 248203),
(382050, 'PTHR10334:SF474', NULL, NULL, NULL, NULL, 'CAP (CYSTEINE-RICH SECRETORY PROTEINS, ANTIGEN 5, AND PATHOGENESIS-RELATED 1 PROTEIN) SUPERFAMILY PROTEIN', 248203),
(382051, 'PTHR10334:SF477', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382052, 'PTHR10334:SF510', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382053, 'PTHR10334:SF236', NULL, NULL, NULL, NULL, 'GLIPR1-LIKE PROTEIN 2', 248203),
(382054, 'PTHR10334:SF478', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED LEAF PROTEIN 6', 248203);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(382055, 'PTHR10334:SF523', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382056, 'PTHR10334:SF403', NULL, NULL, NULL, NULL, 'CAP (CYSTEINE-RICH SECRETORY PROTEINS, ANTIGEN 5, AND PATHOGENESIS-RELATED 1 PROTEIN) SUPERFAMILY PROTEIN', 248203),
(382057, 'PTHR10334:SF524', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH SECRETORY PROTEIN, ALLERGEN V5/TPX-1-RELATED PROTEIN-RELATED', 248203),
(382058, 'PTHR10334:SF525', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382059, 'PTHR10334:SF528', NULL, NULL, NULL, NULL, 'BASIC FORM OF PATHOGENESIS-RELATED PROTEIN 1-LIKE', 248203),
(382060, 'PTHR10334:SF529', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382061, 'PTHR10334:SF481', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382062, 'PTHR10334:SF482', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382063, 'PTHR10334:SF486', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382064, 'PTHR10334:SF521', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 18 MEMBER A-RELATED', 248203),
(382065, 'PTHR10334:SF247', NULL, NULL, NULL, NULL, 'OS05G0595000 PROTEIN', 248203),
(382066, 'PTHR10334:SF534', NULL, NULL, NULL, NULL, 'SHKT DOMAIN-CONTAINING PROTEIN', 248203),
(382067, 'PTHR10334:SF535', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382068, 'PTHR10334:SF536', NULL, NULL, NULL, NULL, 'SHKT DOMAIN-CONTAINING PROTEIN', 248203),
(382069, 'PTHR10334:SF537', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382070, 'PTHR10334:SF416', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382071, 'PTHR10334:SF417', NULL, NULL, NULL, NULL, 'CAP (CYSTEINE-RICH SECRETORY PROTEINS, ANTIGEN 5, AND PATHOGENESIS-RELATED 1 PROTEIN) SUPERFAMILY PROTEIN', 248203),
(382072, 'PTHR10334:SF538', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382073, 'PTHR10334:SF418', NULL, NULL, NULL, NULL, 'SHKT DOMAIN-CONTAINING PROTEIN', 248203),
(382074, 'PTHR10334:SF539', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382075, 'PTHR10334:SF490', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382076, 'PTHR10334:SF491', NULL, NULL, NULL, NULL, 'BNACNNG34480D PROTEIN', 248203),
(382077, 'PTHR10334:SF492', NULL, NULL, NULL, NULL, 'OS07G0128800 PROTEIN', 248203),
(382078, 'PTHR10334:SF371', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED PROTEIN 1-17', 248203),
(382079, 'PTHR10334:SF493', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382080, 'PTHR10334:SF497', NULL, NULL, NULL, NULL, 'CAP (CYSTEINE-RICH SECRETORY PROTEINS, ANTIGEN 5, AND PATHOGENESIS-RELATED 1 PROTEIN) SUPERFAMILY PROTEIN', 248203),
(382081, 'PTHR10334:SF530', NULL, NULL, NULL, NULL, 'CAP (CYSTEINE-RICH SECRETORY PROTEINS, ANTIGEN 5, AND PATHOGENESIS-RELATED 1 PROTEIN) SUPERFAMILY PROTEIN-RELATED', 248203),
(382082, 'PTHR10334:SF377', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED PROTEIN 1', 248203),
(382083, 'PTHR10334:SF498', NULL, NULL, NULL, NULL, 'VENOM-ALLERGEN-LIKE PROTEIN', 248203),
(382084, 'PTHR10334:SF499', NULL, NULL, NULL, NULL, 'BASIC FORM OF PATHOGENESIS-RELATED PROTEIN 1', 248203),
(382085, 'PTHR10334:SF532', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED PROTEIN-RELATED', 248203),
(382086, 'PTHR10334:SF545', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED PROTEIN 1C-RELATED', 248203),
(382087, 'PTHR10334:SF546', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382088, 'PTHR10334:SF547', NULL, NULL, NULL, NULL, 'PROTEIN CBG03516', 248203),
(382089, 'PTHR10334:SF548', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH SECRETORY PROTEIN 2-LIKE PROTEIN', 248203),
(382090, 'PTHR10334:SF549', NULL, NULL, NULL, NULL, 'OS02G0787000 PROTEIN', 248203),
(382091, 'PTHR10334:SF429', NULL, NULL, NULL, NULL, 'OS05G0595200 PROTEIN', 248203),
(382092, 'PTHR10334:SF385', NULL, NULL, NULL, NULL, 'CAP (CYSTEINE-RICH SECRETORY PROTEINS, ANTIGEN 5, AND PATHOGENESIS-RELATED 1 PROTEIN) SUPERFAMILY PROTEIN', 248203),
(382093, 'PTHR10334:SF540', NULL, NULL, NULL, NULL, 'CYSTEINE RICH SECRETORY PROTEIN 2', 248203); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(382094, 'PTHR10334:SF420', NULL, NULL, NULL, NULL, 'OS10G0191300 PROTEIN', 248203),
(382095, 'PTHR10334:SF541', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382096, 'PTHR10334:SF421', NULL, NULL, NULL, NULL, 'OS04G0289600 PROTEIN', 248203),
(382097, 'PTHR10334:SF542', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382098, 'PTHR10334:SF543', NULL, NULL, NULL, NULL, 'AT04879P-RELATED', 248203),
(382099, 'PTHR10334:SF422', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED PROTEIN 1', 248203),
(382100, 'PTHR10334:SF544', NULL, NULL, NULL, NULL, 'OS12G0633400 PROTEIN', 248203),
(382101, 'PTHR10334:SF556', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382102, 'PTHR10334:SF314', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED PROTEIN PRMS', 248203),
(382103, 'PTHR10334:SF557', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382104, 'PTHR10334:SF437', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382105, 'PTHR10334:SF558', NULL, NULL, NULL, NULL, 'PR1 PROTEIN', 248203),
(382106, 'PTHR10334:SF559', NULL, NULL, NULL, NULL, 'OS04G0289500 PROTEIN', 248203),
(382107, 'PTHR10334:SF439', NULL, NULL, NULL, NULL, 'OS02G0786900 PROTEIN', 248203),
(382108, 'PTHR10334:SF390', NULL, NULL, NULL, NULL, 'CAP (CYSTEINE-RICH SECRETORY PROTEINS, ANTIGEN 5, AND PATHOGENESIS-RELATED 1 PROTEIN) SUPERFAMILY PROTEIN', 248203),
(382109, 'PTHR10334:SF391', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED PROTEIN 1', 248203),
(382110, 'PTHR10334:SF394', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED PROTEIN 1', 248203),
(382111, 'PTHR10334:SF550', NULL, NULL, NULL, NULL, 'CYTOPLASMIC SMALL HEAT SHOCK PROTEIN CLASS I', 248203),
(382112, 'PTHR10334', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH SECRETORY PROTEIN-RELATED', 248203),
(382113, 'PTHR10334:SF551', NULL, NULL, NULL, NULL, 'LD39025P', 248203),
(382114, 'PTHR10334:SF430', NULL, NULL, NULL, NULL, 'CAP (CYSTEINE-RICH SECRETORY PROTEINS, ANTIGEN 5, AND PATHOGENESIS-RELATED 1 PROTEIN) SUPERFAMILY PROTEIN', 248203),
(382115, 'PTHR10334:SF552', NULL, NULL, NULL, NULL, 'MIP16674P', 248203),
(382116, 'PTHR10334:SF553', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH SECRETORY PROTEIN, PUTATIVE-RELATED', 248203),
(382117, 'PTHR10334:SF432', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382118, 'PTHR10334:SF433', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED PROTEIN PRMS-LIKE', 248203),
(382119, 'PTHR10334:SF554', NULL, NULL, NULL, NULL, 'VENOM ALLERGEN 3-LIKE PROTEIN', 248203),
(382120, 'PTHR10334:SF555', NULL, NULL, NULL, NULL, 'OS07G0125000 PROTEIN', 248203),
(382121, 'PTHR10334:SF567', NULL, NULL, NULL, NULL, 'OS02G0472500 PROTEIN', 248203),
(382122, 'PTHR10334:SF568', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH SECRETORY PROTEIN 3', 248203),
(382123, 'PTHR10334:SF569', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382124, 'PTHR10334:SF449', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH SECRETORY PROTEIN 1-RELATED', 248203),
(382125, 'PTHR10334:SF64', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH SECRETORY PROTEIN LCCL DOMAIN-CONTAINING 2', 248203),
(382126, 'PTHR10334:SF62', NULL, NULL, NULL, NULL, 'PEPTIDASE INHIBITOR R3HDML', 248203),
(382127, 'PTHR10334:SF63', NULL, NULL, NULL, NULL, 'PEPTIDASE INHIBITOR 15', 248203),
(382128, 'PTHR10334:SF161', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382129, 'PTHR10334:SF164', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382130, 'PTHR10334:SF560', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382131, 'PTHR10334:SF440', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH SECRETORY PROTEIN, ALLERGEN V5/TPX-1-RELATED PROTEIN-RELATED', 248203),
(382132, 'PTHR10334:SF561', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382133, 'PTHR10334:SF562', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED PROTEIN 1A-LIKE', 248203),
(382134, 'PTHR10334:SF563', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382135, 'PTHR10334:SF564', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(382136, 'PTHR10334:SF565', NULL, NULL, NULL, NULL, '', 248203),
(382137, 'PTHR10334:SF566', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED PROTEIN 1B', 248203),
(382138, 'PTHR10334:SF457', NULL, NULL, NULL, NULL, 'AT27079P-RELATED', 248203),
(382139, 'PTHR10334:SF458', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382140, 'PTHR10334:SF217', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382141, 'PTHR10334:SF459', NULL, NULL, NULL, NULL, 'GLIOMA PATHOGENESIS-RELATED PROTEIN 1', 248203),
(382142, 'PTHR10334:SF570', NULL, NULL, NULL, NULL, 'OS07G0127900 PROTEIN', 248203),
(382143, 'PTHR10334:SF571', NULL, NULL, NULL, NULL, 'BASIC FORM OF PATHOGENESIS-RELATED PROTEIN 1-LIKE', 248203),
(382144, 'PTHR10334:SF572', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH SECRETORY PROTEIN 2', 248203),
(382145, 'PTHR10334:SF452', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382146, 'PTHR10334:SF455', NULL, NULL, NULL, NULL, 'SCP DOMAIN-CONTAINING PROTEIN', 248203),
(382147, 'PTHR10334:SF213', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH SECRETORY PROTEIN 1', 248203),
(382148, 'PTHR22940:SF4', NULL, NULL, NULL, NULL, 'PROTEIN TIMELESS HOMOLOG', 248204),
(382149, 'PTHR22940:SF5', NULL, NULL, NULL, NULL, 'PROTEIN TIMELESS', 248204),
(382150, 'PTHR22940', NULL, NULL, NULL, NULL, 'TIMEOUT/TIMELESS-2', 248204),
(382151, 'PTHR33641:SF19', NULL, NULL, NULL, NULL, 'BNAC05G51340D PROTEIN', 248205),
(382152, 'PTHR33641:SF21', NULL, NULL, NULL, NULL, 'AVR9/CF-9 RAPIDLY ELICITED PROTEIN 65', 248205),
(382153, 'PTHR33641:SF20', NULL, NULL, NULL, NULL, 'BNAA05G17920D PROTEIN', 248205),
(382154, 'PTHR33641:SF14', NULL, NULL, NULL, NULL, '', 248205),
(382155, 'PTHR33641:SF25', NULL, NULL, NULL, NULL, 'BNAA08G06880D PROTEIN', 248205),
(382156, 'PTHR33641:SF24', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 248205),
(382157, 'PTHR33641:SF16', NULL, NULL, NULL, NULL, 'AVR9/CF-9 RAPIDLY ELICITED PROTEIN', 248205),
(382158, 'PTHR33641:SF15', NULL, NULL, NULL, NULL, 'AVR9/CF-9 RAPIDLY ELICITED PROTEIN', 248205),
(382159, 'PTHR33641:SF18', NULL, NULL, NULL, NULL, 'OS04G0119000 PROTEIN', 248205),
(382160, 'PTHR33641', NULL, NULL, NULL, NULL, 'OS06G0133500 PROTEIN', 248205),
(382161, 'PTHR36360', NULL, NULL, NULL, NULL, 'ACTIN T1-LIKE PROTEIN', 248206),
(382162, 'PTHR36360:SF1', NULL, NULL, NULL, NULL, 'ACTIN T1-LIKE PROTEIN', 248206),
(382163, 'PTHR43822:SF14', NULL, NULL, NULL, NULL, '3-ISOPROPYLMALATE DEHYDRATASE', 248207),
(382164, 'PTHR43822:SF16', NULL, NULL, NULL, NULL, '3-ISOPROPYLMALATE DEHYDRATASE LARGE SUBUNIT 2', 248207),
(382165, 'PTHR43822:SF2', NULL, NULL, NULL, NULL, 'HOMOACONITASE, MITOCHONDRIAL', 248207),
(382166, 'PTHR43822', NULL, NULL, NULL, NULL, 'HOMOACONITASE, MITOCHONDRIAL-RELATED', 248207),
(382167, 'PTHR43822:SF15', NULL, NULL, NULL, NULL, '3-ISOPROPYLMALATE DEHYDRATASE', 248207),
(382168, 'PTHR43822:SF21', NULL, NULL, NULL, NULL, '3-ISOPROPYLMALATE DEHYDRATASE LARGE SUBUNIT 1', 248207),
(382169, 'PTHR43822:SF20', NULL, NULL, NULL, NULL, '3-ISOPROPYLMALATE DEHYDRATASE', 248207),
(382170, 'PTHR43822:SF9', NULL, NULL, NULL, NULL, '3-ISOPROPYLMALATE DEHYDRATASE', 248207),
(382171, 'PTHR43822:SF6', NULL, NULL, NULL, NULL, '3-ISOPROPYLMALATE DEHYDRATASE', 248207),
(382172, 'PTHR43822:SF23', NULL, NULL, NULL, NULL, '3-ISOPROPYLMALATE DEHYDRATASE', 248207),
(382173, 'PTHR43822:SF22', NULL, NULL, NULL, NULL, 'ISOPROPYLMALATE/CITRAMALATE ISOMERASE LARGE SUBUNIT', 248207),
(382174, 'PTHR43822:SF11', NULL, NULL, NULL, NULL, '3-ISOPROPYLMALATE DEHYDRATASE', 248207),
(382175, 'PTHR34576:SF5', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248208),
(382176, 'PTHR34576:SF15', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED KINASE REGULATOR 6-RELATED', 248208),
(382177, 'PTHR34576:SF14', NULL, NULL, NULL, NULL, 'KINASE REGULATOR-LIKE PROTEIN, PUTATIVE-RELATED', 248208),
(382178, 'PTHR34576:SF13', NULL, NULL, NULL, NULL, 'BNAC09G28980D PROTEIN', 248208),
(382179, 'PTHR34576:SF3', NULL, NULL, NULL, NULL, '', 248208),
(382180, 'PTHR34576:SF12', NULL, NULL, NULL, NULL, '', 248208);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(382181, 'PTHR34576:SF2', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED KINASE REGULATOR 6-RELATED', 248208),
(382182, 'PTHR34576:SF11', NULL, NULL, NULL, NULL, '', 248208),
(382183, 'PTHR34576:SF10', NULL, NULL, NULL, NULL, 'BNAC03G15310D PROTEIN', 248208),
(382184, 'PTHR34576:SF9', NULL, NULL, NULL, NULL, '', 248208),
(382185, 'PTHR34576', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED KINASE REGULATOR 6-RELATED', 248208),
(382186, 'PTHR10082', NULL, NULL, NULL, NULL, 'INTEGRIN BETA SUBUNIT', 248209),
(382187, 'PTHR10082:SF60', NULL, NULL, NULL, NULL, 'INTEGRIN BETA-PS', 248209),
(382188, 'PTHR10082:SF61', NULL, NULL, NULL, NULL, 'INTEGRIN BETA-1', 248209),
(382189, 'PTHR10082:SF42', NULL, NULL, NULL, NULL, 'INTEGRIN BETA-4', 248209),
(382190, 'PTHR10082:SF9', NULL, NULL, NULL, NULL, 'INTEGRIN BETA-8', 248209),
(382191, 'PTHR10082:SF11', NULL, NULL, NULL, NULL, 'INTEGRIN BETA-6', 248209),
(382192, 'PTHR10082:SF25', NULL, NULL, NULL, NULL, 'INTEGRIN BETA-3', 248209),
(382193, 'PTHR10082:SF36', NULL, NULL, NULL, NULL, 'INTEGRIN BETA-7', 248209),
(382194, 'PTHR10082:SF15', NULL, NULL, NULL, NULL, 'INTEGRIN BETA-2', 248209),
(382195, 'PTHR10082:SF59', NULL, NULL, NULL, NULL, 'INTEGRIN BETA-NU', 248209),
(382196, 'PTHR10082:SF26', NULL, NULL, NULL, NULL, 'INTEGRIN BETA-5', 248209),
(382197, 'PTHR10082:SF28', NULL, NULL, NULL, NULL, 'INTEGRIN BETA-1', 248209),
(382198, 'PTHR10082:SF3', NULL, NULL, NULL, NULL, 'INTEGRIN BETA-LIKE PROTEIN 1', 248209),
(382199, 'PTHR34070', NULL, NULL, NULL, NULL, 'ARMADILLO-TYPE FOLD', 248210),
(382200, 'PTHR34070:SF1', NULL, NULL, NULL, NULL, 'DNA ALKYLATION REPAIR ENZYME-LIKE PROTEIN', 248210),
(382201, 'PTHR36079', NULL, NULL, NULL, NULL, 'PROTEIN LEAFY', 248211),
(382202, 'PTHR36079:SF2', NULL, NULL, NULL, NULL, 'FLORICAULA/LEAFY-LIKE TRANSCRIPTION FACTOR', 248211),
(382203, 'PTHR36079:SF1', NULL, NULL, NULL, NULL, 'PROTEIN LEAFY', 248211),
(382204, 'PTHR33270:SF5', NULL, NULL, NULL, NULL, 'GB|AAC00605.1', 248212),
(382205, 'PTHR33270:SF19', NULL, NULL, NULL, NULL, '', 248212),
(382206, 'PTHR33270:SF6', NULL, NULL, NULL, NULL, 'BNACNNG23130D PROTEIN', 248212),
(382207, 'PTHR33270:SF7', NULL, NULL, NULL, NULL, 'OS02G0527200 PROTEIN', 248212),
(382208, 'PTHR33270', NULL, NULL, NULL, NULL, 'BNAC05G50380D PROTEIN', 248212),
(382209, 'PTHR33270:SF35', NULL, NULL, NULL, NULL, 'BNAC02G20240D PROTEIN', 248212),
(382210, 'PTHR33270:SF36', NULL, NULL, NULL, NULL, '', 248212),
(382211, 'PTHR33270:SF34', NULL, NULL, NULL, NULL, '', 248212),
(382212, 'PTHR33270:SF39', NULL, NULL, NULL, NULL, 'BNAC06G31940D PROTEIN', 248212),
(382213, 'PTHR33270:SF18', NULL, NULL, NULL, NULL, 'SENESCENCE-ASSOCIATED PROTEIN', 248212),
(382214, 'PTHR33270:SF37', NULL, NULL, NULL, NULL, 'BNAC09G20760D PROTEIN', 248212),
(382215, 'PTHR33270:SF38', NULL, NULL, NULL, NULL, 'BNAA01G12460D PROTEIN', 248212),
(382216, 'PTHR33270:SF50', NULL, NULL, NULL, NULL, '', 248212),
(382217, 'PTHR33270:SF51', NULL, NULL, NULL, NULL, 'OS06G0136300 PROTEIN', 248212),
(382218, 'PTHR33270:SF30', NULL, NULL, NULL, NULL, '', 248212),
(382219, 'PTHR33270:SF24', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248212),
(382220, 'PTHR33270:SF46', NULL, NULL, NULL, NULL, '', 248212),
(382221, 'PTHR33270:SF47', NULL, NULL, NULL, NULL, 'BNAA02G21500D PROTEIN', 248212),
(382222, 'PTHR33270:SF22', NULL, NULL, NULL, NULL, '', 248212),
(382223, 'PTHR33270:SF44', NULL, NULL, NULL, NULL, '', 248212),
(382224, 'PTHR33270:SF45', NULL, NULL, NULL, NULL, '', 248212),
(382225, 'PTHR33270:SF28', NULL, NULL, NULL, NULL, '', 248212),
(382226, 'PTHR33270:SF29', NULL, NULL, NULL, NULL, '', 248212),
(382227, 'PTHR33270:SF26', NULL, NULL, NULL, NULL, '', 248212),
(382228, 'PTHR33270:SF48', NULL, NULL, NULL, NULL, '', 248212),
(382229, 'PTHR33270:SF27', NULL, NULL, NULL, NULL, 'BNAC07G20880D PROTEIN', 248212),
(382230, 'PTHR33270:SF49', NULL, NULL, NULL, NULL, '', 248212),
(382231, 'PTHR33270:SF42', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 248212),
(382232, 'PTHR33270:SF21', NULL, NULL, NULL, NULL, 'BNAC06G24500D PROTEIN', 248212);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(382233, 'PTHR21021:SF15', NULL, NULL, NULL, NULL, 'FREE METHIONINE-R-SULFOXIDE REDUCTASE', 248213),
(382234, 'PTHR21021', NULL, NULL, NULL, NULL, 'GAF/PUTATIVE CYTOSKELETAL PROTEIN', 248213),
(382235, 'PTHR21021:SF17', NULL, NULL, NULL, NULL, 'TIP41-LIKE PROTEIN ISOFORM X1', 248213),
(382236, 'PTHR21021:SF16', NULL, NULL, NULL, NULL, 'TIP41-LIKE PROTEIN', 248213),
(382237, 'PTHR45991:SF1', NULL, NULL, NULL, NULL, 'PACHYTENE CHECKPOINT PROTEIN 2 HOMOLOG', 248214),
(382238, 'PTHR45991', NULL, NULL, NULL, NULL, 'PACHYTENE CHECKPOINT PROTEIN 2', 248214),
(382239, 'PTHR33905:SF1', NULL, NULL, NULL, NULL, 'CST COMPLEX SUBUNIT TEN1', 248215),
(382240, 'PTHR33905', NULL, NULL, NULL, NULL, 'CST COMPLEX SUBUNIT TEN1', 248215),
(382241, 'PTHR35908:SF1', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', 248216),
(382242, 'PTHR35908', NULL, NULL, NULL, NULL, 'HYPOTHETICAL FUSION PROTEIN', 248216),
(382243, 'PTHR33371:SF15', NULL, NULL, NULL, NULL, 'LIPOPROTEIN LPRN', 248217),
(382244, 'PTHR33371:SF16', NULL, NULL, NULL, NULL, 'MCE-FAMILY PROTEIN MCE3F', 248217),
(382245, 'PTHR33371:SF17', NULL, NULL, NULL, NULL, 'MCE-FAMILY PROTEIN MCE1B', 248217),
(382246, 'PTHR33371', NULL, NULL, NULL, NULL, 'INTERMEMBRANE PHOSPHOLIPID TRANSPORT SYSTEM BINDING PROTEIN MLAD-RELATED', 248217),
(382247, 'PTHR33371:SF18', NULL, NULL, NULL, NULL, 'MCE-FAMILY PROTEIN MCE3C', 248217),
(382248, 'PTHR33371:SF19', NULL, NULL, NULL, NULL, 'MCE-FAMILY PROTEIN MCE4A', 248217),
(382249, 'PTHR33371:SF4', NULL, NULL, NULL, NULL, 'INTERMEMBRANE PHOSPHOLIPID TRANSPORT SYSTEM BINDING PROTEIN MLAD', 248217),
(382250, 'PTHR46951:SF1', NULL, NULL, NULL, NULL, 'BED-TYPE DOMAIN-CONTAINING PROTEIN', 248218),
(382251, 'PTHR46951', NULL, NULL, NULL, NULL, 'BED-TYPE DOMAIN-CONTAINING PROTEIN', 248218),
(382252, 'PTHR10986:SF25', NULL, NULL, NULL, NULL, 'LP04985P', 248219),
(382253, 'PTHR10986:SF12', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L20, CHLOROPLASTIC', 248219),
(382254, 'PTHR10986:SF24', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L20', 248219),
(382255, 'PTHR10986', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L20', 248219),
(382256, 'PTHR10986:SF20', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L20', 248219),
(382257, 'PTHR10986:SF16', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L20, MITOCHONDRIAL', 248219),
(382258, 'PTHR23180:SF244', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN AGD2', 248220),
(382259, 'PTHR23180:SF197', NULL, NULL, NULL, NULL, 'ARF-GAP WITH COILED-COIL, ANK REPEAT AND PH DOMAIN-CONTAINING PROTEIN 1', 248220),
(382260, 'PTHR23180:SF241', NULL, NULL, NULL, NULL, 'ARF-GAP WITH COILED-COIL, ANK REPEAT AND PH DOMAIN-CONTAINING PROTEIN 2', 248220),
(382261, 'PTHR23180:SF242', NULL, NULL, NULL, NULL, 'OS08G0537600 PROTEIN', 248220),
(382262, 'PTHR23180:SF160', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN EFFECTOR PROTEIN 1', 248220),
(382263, 'PTHR23180:SF405', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN AGD1', 248220),
(382264, 'PTHR23180:SF406', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN AGD10', 248220),
(382265, 'PTHR23180', NULL, NULL, NULL, NULL, 'CENTAURIN/ARF', 248220),
(382266, 'PTHR23180:SF403', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN AGD3-LIKE', 248220),
(382267, 'PTHR23180:SF404', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN AGD4', 248220),
(382268, 'PTHR23180:SF412', NULL, NULL, NULL, NULL, '', 248220),
(382269, 'PTHR23180:SF402', NULL, NULL, NULL, NULL, 'ZGC:162872', 248220),
(382270, 'PTHR23180:SF413', NULL, NULL, NULL, NULL, '', 248220),
(382271, 'PTHR23180:SF399', NULL, NULL, NULL, NULL, 'BLOWN FUSE, ISOFORM A-RELATED', 248220),
(382272, 'PTHR23180:SF410', NULL, NULL, NULL, NULL, 'BAR DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_2G11475)', 248220),
(382273, 'PTHR23180:SF411', NULL, NULL, NULL, NULL, 'BAR DOMAIN-CONTAINING PROTEIN', 248220),
(382274, 'PTHR23180:SF409', NULL, NULL, NULL, NULL, 'PROTEIN CSX2', 248220),
(382275, 'PTHR23180:SF407', NULL, NULL, NULL, NULL, 'ARF-GAP WITH COILED-COIL, ANK REPEAT AND PH DOMAIN-CONTAINING PROTEIN 3', 248220);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(382276, 'PTHR23180:SF408', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN AGD10', 248220),
(382277, 'PTHR34388:SF1', NULL, NULL, NULL, NULL, 'DNA POLYMERASE III SUBUNIT DELTA', 248221),
(382278, 'PTHR34388', NULL, NULL, NULL, NULL, 'DNA POLYMERASE III SUBUNIT DELTA', 248221),
(382279, 'PTHR18868:SF41', NULL, NULL, NULL, NULL, '', 248222),
(382280, 'PTHR18868:SF40', NULL, NULL, NULL, NULL, '', 248222),
(382281, 'PTHR18868', NULL, NULL, NULL, NULL, 'OS07G0665300 PROTEIN-RELATED', 248222),
(382282, 'PTHR18868:SF38', NULL, NULL, NULL, NULL, 'OS01G0776500 PROTEIN', 248222),
(382283, 'PTHR18868:SF37', NULL, NULL, NULL, NULL, 'OS07G0665300 PROTEIN', 248222),
(382284, 'PTHR18868:SF29', NULL, NULL, NULL, NULL, '', 248222),
(382285, 'PTHR18868:SF28', NULL, NULL, NULL, NULL, '', 248222),
(382286, 'PTHR18868:SF45', NULL, NULL, NULL, NULL, '', 248222),
(382287, 'PTHR18868:SF44', NULL, NULL, NULL, NULL, '', 248222),
(382288, 'PTHR18868:SF33', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248222),
(382289, 'PTHR18868:SF36', NULL, NULL, NULL, NULL, '', 248222),
(382290, 'PTHR18868:SF47', NULL, NULL, NULL, NULL, 'OS11G0147200 PROTEIN', 248222),
(382291, 'PTHR18868:SF35', NULL, NULL, NULL, NULL, 'BULB-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 248222),
(382292, 'PTHR18868:SF46', NULL, NULL, NULL, NULL, '', 248222),
(382293, 'PTHR35572:SF3', NULL, NULL, NULL, NULL, 'ABNORMAL CELL MIGRATION PROTEIN 18', 248223),
(382294, 'PTHR35572:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG15747', 248223),
(382295, 'PTHR35572:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG06690', 248223),
(382296, 'PTHR35572', NULL, NULL, NULL, NULL, 'PROTEIN CBG04538-RELATED', 248223),
(382297, 'PTHR35572:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG13288', 248223),
(382298, 'PTHR35572:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG04538', 248223),
(382299, 'PTHR43110:SF1', NULL, NULL, NULL, NULL, 'THIOL PEROXIDASE', 248224),
(382300, 'PTHR43110', NULL, NULL, NULL, NULL, 'THIOL PEROXIDASE', 248224),
(382301, 'PTHR37486', NULL, NULL, NULL, NULL, 'STRINGENT STARVATION PROTEIN B', 248225),
(382302, 'PTHR37486:SF1', NULL, NULL, NULL, NULL, 'STRINGENT STARVATION PROTEIN B', 248225),
(382303, 'PTHR48111:SF50', NULL, NULL, NULL, NULL, 'KDP OPERON TRANSCRIPTIONAL REGULATORY PROTEIN KDPE', 248226),
(382304, 'PTHR48111:SF52', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN YVRH', 248226),
(382305, 'PTHR48111:SF54', NULL, NULL, NULL, NULL, 'STAGE 0 SPORULATION PROTEIN A HOMOLOG', 248226),
(382306, 'PTHR48111:SF10', NULL, NULL, NULL, NULL, 'STAGE 0 SPORULATION PROTEIN A HOMOLOG', 248226),
(382307, 'PTHR48111:SF55', NULL, NULL, NULL, NULL, 'AEROBIC RESPIRATION CONTROL PROTEIN ARCA', 248226),
(382308, 'PTHR48111:SF11', NULL, NULL, NULL, NULL, 'TWO-COMPONENT SYSTEM RESPONSE REGULATOR', 248226),
(382309, 'PTHR48111:SF56', NULL, NULL, NULL, NULL, 'TETRATHIONATE RESPONSE REGULATORY PROTEIN TTRR', 248226),
(382310, 'PTHR48111:SF58', NULL, NULL, NULL, NULL, 'TORCAD OPERON TRANSCRIPTIONAL REGULATORY PROTEIN TORR', 248226),
(382311, 'PTHR48111:SF15', NULL, NULL, NULL, NULL, 'OMPR SUBFAMILY', 248226),
(382312, 'PTHR48111:SF59', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN BAER', 248226),
(382313, 'PTHR48111:SF16', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN GLNR', 248226),
(382314, 'PTHR48111:SF17', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN YPDB', 248226),
(382315, 'PTHR48111:SF62', NULL, NULL, NULL, NULL, 'TWO-COMPONENT SYSTEM REGULATORY PROTEIN', 248226),
(382316, 'PTHR48111:SF21', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN CRDR', 248226),
(382317, 'PTHR48111:SF65', NULL, NULL, NULL, NULL, 'OMPR SUBFAMILY', 248226),
(382318, 'PTHR48111:SF22', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN BASR', 248226),
(382319, 'PTHR48111:SF23', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR CADC', 248226),
(382320, 'PTHR48111:SF67', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN TCTD', 248226),
(382321, 'PTHR48111:SF9', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR RECEIVER PROTEIN', 248226);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(382322, 'PTHR48111:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN CREB', 248226),
(382323, 'PTHR48111:SF24', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN CSSR', 248226),
(382324, 'PTHR48111:SF68', NULL, NULL, NULL, NULL, 'OMPR SUBFAMILY', 248226),
(382325, 'PTHR48111:SF1', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR ORR33', 248226),
(382326, 'PTHR48111:SF69', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN-RELATED', 248226),
(382327, 'PTHR48111:SF26', NULL, NULL, NULL, NULL, 'STAGE 0 SPORULATION PROTEIN A HOMOLOG', 248226),
(382328, 'PTHR48111:SF27', NULL, NULL, NULL, NULL, 'SENSORY TRANSDUCTION PROTEIN BCER', 248226),
(382329, 'PTHR48111:SF28', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN TCRX-RELATED', 248226),
(382330, 'PTHR48111:SF4', NULL, NULL, NULL, NULL, 'DNA-BINDING DUAL TRANSCRIPTIONAL REGULATOR OMPR', 248226),
(382331, 'PTHR48111:SF5', NULL, NULL, NULL, NULL, 'RESPONSE REGULATOR RPPA', 248226),
(382332, 'PTHR48111:SF2', NULL, NULL, NULL, NULL, 'RESPONSE REGULATOR SAER', 248226),
(382333, 'PTHR48111:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN BTSR', 248226),
(382334, 'PTHR48111:SF71', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN PHOP', 248226),
(382335, 'PTHR48111:SF72', NULL, NULL, NULL, NULL, 'SENSORY TRANSDUCTION PROTEIN REGX3', 248226),
(382336, 'PTHR48111:SF73', NULL, NULL, NULL, NULL, 'ALKALINE PHOSPHATASE SYNTHESIS TRANSCRIPTIONAL REGULATORY PROTEIN PHOP', 248226),
(382337, 'PTHR48111:SF74', NULL, NULL, NULL, NULL, 'REGULATOR OF RPOS', 248226),
(382338, 'PTHR48111:SF31', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN YXDJ', 248226),
(382339, 'PTHR48111:SF32', NULL, NULL, NULL, NULL, 'STAGE 0 SPORULATION PROTEIN A HOMOLOG', 248226),
(382340, 'PTHR48111:SF70', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR YBDJ', 248226),
(382341, 'PTHR48111', NULL, NULL, NULL, NULL, 'REGULATOR OF RPOS', 248226),
(382342, 'PTHR48111:SF35', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN QSEB', 248226),
(382343, 'PTHR48111:SF36', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN CUTR', 248226),
(382344, 'PTHR48111:SF37', NULL, NULL, NULL, NULL, 'RESPONSE REGULATOR PROTEIN CARR', 248226),
(382345, 'PTHR48111:SF38', NULL, NULL, NULL, NULL, 'TWO COMPONENT SYSTEM RESPONSE REGULATOR-RELATED', 248226),
(382346, 'PTHR48111:SF39', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN CPXR', 248226),
(382347, 'PTHR48111:SF40', NULL, NULL, NULL, NULL, 'PHOSPHATE REGULON TRANSCRIPTIONAL REGULATORY PROTEIN PHOB', 248226),
(382348, 'PTHR48111:SF41', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN CUSR-RELATED', 248226),
(382349, 'PTHR48111:SF43', NULL, NULL, NULL, NULL, 'STAGE 0 SPORULATION PROTEIN A HOMOLOG', 248226),
(382350, 'PTHR48111:SF44', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN RESD', 248226),
(382351, 'PTHR48111:SF46', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR', 248226),
(382352, 'PTHR48111:SF47', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN RSTA', 248226),
(382353, 'PTHR48111:SF49', NULL, NULL, NULL, NULL, 'HEME RESPONSE REGULATOR HSSR', 248226),
(382354, 'PTHR38788:SF5', NULL, NULL, NULL, NULL, 'CLR5 DOMAIN-CONTAINING PROTEIN', 248227),
(382355, 'PTHR38788:SF3', NULL, NULL, NULL, NULL, 'CLR5 DOMAIN-CONTAINING PROTEIN', 248227),
(382356, 'PTHR38788', NULL, NULL, NULL, NULL, 'CLR5 DOMAIN-CONTAINING PROTEIN', 248227),
(382357, 'PTHR46676:SF1', NULL, NULL, NULL, NULL, 'PROTEIN AMBP', 248228),
(382358, 'PTHR46676', NULL, NULL, NULL, NULL, 'PROTEIN AMBP', 248228),
(382359, 'PTHR33790:SF10', NULL, NULL, NULL, NULL, 'PROTEIN EARLY RESPONSIVE TO DEHYDRATION 15', 248229),
(382360, 'PTHR33790:SF9', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN-INTERACTING PROTEIN 2', 248229),
(382361, 'PTHR33790:SF12', NULL, NULL, NULL, NULL, 'DEHYDRATION-INDUCED PROTEIN (ERD15)-RELATED', 248229),
(382362, 'PTHR33790:SF7', NULL, NULL, NULL, NULL, 'RESPONSIVE TO DEHYDRATION PROTEIN, PUTATIVE-RELATED', 248229),
(382363, 'PTHR33790:SF2', NULL, NULL, NULL, NULL, '17.7 KDA LOW TEMPERATURE INDUCED PROTEIN', 248229);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(382364, 'PTHR33790:SF18', NULL, NULL, NULL, NULL, 'PAM2 DOMAIN-CONTAINING PROTEIN', 248229),
(382365, 'PTHR33790:SF1', NULL, NULL, NULL, NULL, 'PROTEIN EARLY RESPONSIVE TO DEHYDRATION 15', 248229),
(382366, 'PTHR33790', NULL, NULL, NULL, NULL, 'OS05G0344200 PROTEIN', 248229),
(382367, 'PTHR33790:SF15', NULL, NULL, NULL, NULL, 'EARLY RESPONSIVE TO DEHYDRATION 1 PROTEIN', 248229),
(382368, 'PTHR33790:SF17', NULL, NULL, NULL, NULL, 'PAM2 DOMAIN-CONTAINING PROTEIN', 248229),
(382369, 'PTHR33790:SF16', NULL, NULL, NULL, NULL, 'OS07G0661400 PROTEIN', 248229),
(382370, 'PTHR14190:SF11', NULL, NULL, NULL, NULL, 'OS10G0488300 PROTEIN', 248230),
(382371, 'PTHR14190:SF7', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 52 HOMOLOG', 248230),
(382372, 'PTHR14190', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF ACTIN MUTATIONS 2/VACUOLAR PROTEIN SORTING 52', 248230),
(382373, 'PTHR14190:SF15', NULL, NULL, NULL, NULL, '', 248230),
(382374, 'PTHR14190:SF14', NULL, NULL, NULL, NULL, '', 248230),
(382375, 'PTHR15535:SF25', NULL, NULL, NULL, NULL, 'G8 DOMAIN-CONTAINING PROTEIN', 248231),
(382376, 'PTHR15535:SF24', NULL, NULL, NULL, NULL, 'HYALURONOGLUCOSAMINIDASE', 248231),
(382377, 'PTHR15535', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 2-RELATED', 248231),
(382378, 'PTHR15535:SF28', NULL, NULL, NULL, NULL, '', 248231),
(382379, 'PTHR15535:SF17', NULL, NULL, NULL, NULL, 'PROTEIN DDB_G0287365', 248231),
(382380, 'PTHR15535:SF15', NULL, NULL, NULL, NULL, 'CELL MIGRATION-INDUCING AND HYALURONAN-BINDING PROTEIN', 248231),
(382381, 'PTHR15535:SF26', NULL, NULL, NULL, NULL, 'CELL SURFACE HYALURONIDASE', 248231),
(382382, 'PTHR24113:SF14', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT FAMILY PROTEIN', 248232),
(382383, 'PTHR24113:SF5', NULL, NULL, NULL, NULL, 'RAN GTPASE-ACTIVATING PROTEIN 1', 248232),
(382384, 'PTHR24113:SF12', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248232),
(382385, 'PTHR24113', NULL, NULL, NULL, NULL, 'RAN GTPASE-ACTIVATING PROTEIN 1', 248232),
(382386, 'PTHR12791:SF52', NULL, NULL, NULL, NULL, 'TARGET SNARE COILED-COIL DOMAIN PROTEIN', 248233),
(382387, 'PTHR12791:SF53', NULL, NULL, NULL, NULL, 'BET1 HOMOLOG', 248233),
(382388, 'PTHR12791:SF31', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248233),
(382389, 'PTHR12791:SF61', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 248233),
(382390, 'PTHR12791:SF50', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 248233),
(382391, 'PTHR12791:SF51', NULL, NULL, NULL, NULL, 'TARGET SNARE COILED-COIL DOMAIN-CONTAINING PROTEIN-RELATED', 248233),
(382392, 'PTHR12791:SF62', NULL, NULL, NULL, NULL, 'OS07G0577900 PROTEIN', 248233),
(382393, 'PTHR12791:SF56', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 248233),
(382394, 'PTHR12791:SF54', NULL, NULL, NULL, NULL, 'BET1-LIKE SNARE 1-1', 248233),
(382395, 'PTHR12791:SF55', NULL, NULL, NULL, NULL, 'BNAC03G58880D PROTEIN', 248233),
(382396, 'PTHR12791:SF60', NULL, NULL, NULL, NULL, 'SYNTAXIN 6-RELATED', 248233),
(382397, 'PTHR12791:SF28', NULL, NULL, NULL, NULL, 'BET1 HOMOLOG', 248233),
(382398, 'PTHR12791:SF58', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SFT1', 248233),
(382399, 'PTHR12791:SF36', NULL, NULL, NULL, NULL, 'BET1-LIKE SNARE 1-2', 248233),
(382400, 'PTHR12791:SF48', NULL, NULL, NULL, NULL, 'OS08G0563300 PROTEIN', 248233),
(382401, 'PTHR12791:SF37', NULL, NULL, NULL, NULL, 'BET1-LIKE PROTEIN', 248233),
(382402, 'PTHR12791:SF59', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 248233),
(382403, 'PTHR12791', NULL, NULL, NULL, NULL, 'GOLGI SNARE BET1-RELATED', 248233),
(382404, 'PTHR12436:SF37', NULL, NULL, NULL, NULL, 'SAC3 FAMILY PROTEIN 1', 248234),
(382405, 'PTHR12436:SF17', NULL, NULL, NULL, NULL, 'SAC3 FAMILY PROTEIN B', 248234),
(382406, 'PTHR12436:SF38', NULL, NULL, NULL, NULL, 'SAC3 DOMAIN-CONTAINING PROTEIN 1', 248234),
(382407, 'PTHR12436', NULL, NULL, NULL, NULL, '80 KDA MCM3-ASSOCIATED PROTEIN', 248234),
(382408, 'PTHR12436:SF3', NULL, NULL, NULL, NULL, 'GERMINAL-CENTER ASSOCIATED NUCLEAR PROTEIN', 248234);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(382409, 'PTHR12436:SF4', NULL, NULL, NULL, NULL, 'LEUKOCYTE RECEPTOR CLUSTER MEMBER 8', 248234),
(382410, 'PTHR12436:SF33', NULL, NULL, NULL, NULL, 'OS05G0462600 PROTEIN', 248234),
(382411, 'PTHR12436:SF35', NULL, NULL, NULL, NULL, 'PCI DOMAIN-CONTAINING PROTEIN', 248234),
(382412, 'PTHR21389:SF0', NULL, NULL, NULL, NULL, 'ETOPOSIDE-INDUCED PROTEIN 2.4 HOMOLOG', 248235),
(382413, 'PTHR21389', NULL, NULL, NULL, NULL, 'P53 INDUCED PROTEIN', 248235),
(382414, 'PTHR46400:SF10', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 248236),
(382415, 'PTHR46400:SF11', NULL, NULL, NULL, NULL, 'OS04G0571200 PROTEIN', 248236),
(382416, 'PTHR46400:SF13', NULL, NULL, NULL, NULL, 'SUPERFAMILY PROTEIN, PUTATIVE-RELATED', 248236),
(382417, 'PTHR46400:SF14', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 248236),
(382418, 'PTHR46400:SF15', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE BIG BROTHER-LIKE ISOFORM X1', 248236),
(382419, 'PTHR46400:SF16', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 248236),
(382420, 'PTHR46400:SF17', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE BIG BROTHER-LIKE PROTEIN', 248236),
(382421, 'PTHR46400:SF8', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 248236),
(382422, 'PTHR46400:SF6', NULL, NULL, NULL, NULL, 'OS09G0525400 PROTEIN', 248236),
(382423, 'PTHR46400:SF5', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE BIG BROTHER-RELATED', 248236),
(382424, 'PTHR46400', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 248236),
(382425, 'PTHR46400:SF3', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 248236),
(382426, 'PTHR46400:SF9', NULL, NULL, NULL, NULL, 'E3 LIGASE', 248236),
(382427, 'PTHR45892:SF1', NULL, NULL, NULL, NULL, 'AMINOACYLASE-1', 248237),
(382428, 'PTHR45892', NULL, NULL, NULL, NULL, 'AMINOACYLASE-1', 248237),
(382429, 'PTHR45892:SF4', NULL, NULL, NULL, NULL, 'N-ACYL-L-AMINO-ACID AMIDOHYDROLASE', 248237),
(382430, 'PTHR45892:SF3', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 248237),
(382431, 'PTHR34561:SF1', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX ASSEMBLY FACTOR 8', 248238),
(382432, 'PTHR34561', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX ASSEMBLY FACTOR 8', 248238),
(382433, 'PTHR46039:SF2', NULL, NULL, NULL, NULL, 'SUCROSE-PHOSPHATE SYNTHASE 1', 248239),
(382434, 'PTHR46039:SF1', NULL, NULL, NULL, NULL, 'SUCROSE-PHOSPHATE SYNTHASE 4-RELATED', 248239),
(382435, 'PTHR46039:SF6', NULL, NULL, NULL, NULL, 'SUCROSE-PHOSPHATE SYNTHASE', 248239),
(382436, 'PTHR46039:SF5', NULL, NULL, NULL, NULL, 'SUCROSE-PHOSPHATE SYNTHASE 3-RELATED', 248239),
(382437, 'PTHR46039:SF4', NULL, NULL, NULL, NULL, 'SUCROSE-PHOSPHATE SYNTHASE 3-RELATED', 248239),
(382438, 'PTHR46039:SF3', NULL, NULL, NULL, NULL, 'SUCROSE-PHOSPHATE SYNTHASE 2-RELATED', 248239),
(382439, 'PTHR46039:SF10', NULL, NULL, NULL, NULL, 'SUCROSE-PHOSPHATE SYNTHASE', 248239),
(382440, 'PTHR46039:SF8', NULL, NULL, NULL, NULL, 'SUCROSE-PHOSPHATE SYNTHASE', 248239),
(382441, 'PTHR46039:SF7', NULL, NULL, NULL, NULL, 'SUCROSE-PHOSPHATE SYNTHASE 2-RELATED', 248239),
(382442, 'PTHR46039', NULL, NULL, NULL, NULL, 'SUCROSE-PHOSPHATE SYNTHASE 3-RELATED', 248239),
(382443, 'PTHR15493', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 5 AND 43', 248240),
(382444, 'PTHR15493:SF9', NULL, NULL, NULL, NULL, 'GH14043P', 248240),
(382445, 'PTHR15493:SF8', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 5', 248240),
(382446, 'PTHR15493:SF1', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 43', 248240),
(382447, 'PTHR23135:SF7', NULL, NULL, NULL, NULL, 'LIPID II ISOGLUTAMINYL SYNTHASE (GLUTAMINE-HYDROLYZING) SUBUNIT MURT', 248241),
(382448, 'PTHR23135:SF4', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLMURAMOYL-L-ALANYL-D-GLUTAMATE--2,6-DIAMINOPIMELATE LIGASE MURE HOMOLOG, CHLOROPLASTIC', 248241),
(382449, 'PTHR23135:SF18', NULL, NULL, NULL, NULL, 'CYANOPHYCIN SYNTHETASE', 248241),
(382450, 'PTHR23135', NULL, NULL, NULL, NULL, 'MUR LIGASE FAMILY MEMBER', 248241),
(382451, 'PTHR39767:SF2', NULL, NULL, NULL, NULL, 'FURIN-LIKE_2 DOMAIN-CONTAINING PROTEIN', 248242);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(382452, 'PTHR39767', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-BINDING MEMBRANE PROTEIN PCM4-RELATED', 248242),
(382453, 'PTHR36287:SF1', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 13', 248243),
(382454, 'PTHR36287:SF2', NULL, NULL, NULL, NULL, 'PROLINE RICH 13', 248243),
(382455, 'PTHR36287:SF3', NULL, NULL, NULL, NULL, 'PROLINE RICH 13', 248243),
(382456, 'PTHR36287', NULL, NULL, NULL, NULL, '', 248243),
(382457, 'PTHR45453:SF2', NULL, NULL, NULL, NULL, 'TWO-COMPONENT SENSOR HISTIDINE KINASE', 248244),
(382458, 'PTHR45453:SF3', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE', 248244),
(382459, 'PTHR45453', NULL, NULL, NULL, NULL, 'PHOSPHATE REGULON SENSOR PROTEIN PHOR', 248244),
(382460, 'PTHR45453:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATE REGULON SENSOR PROTEIN PHOR', 248244),
(382461, 'PTHR33576:SF3', NULL, NULL, NULL, NULL, '', 248245),
(382462, 'PTHR33576:SF4', NULL, NULL, NULL, NULL, '', 248245),
(382463, 'PTHR33576:SF5', NULL, NULL, NULL, NULL, '', 248245),
(382464, 'PTHR33576:SF6', NULL, NULL, NULL, NULL, '', 248245),
(382465, 'PTHR33576:SF1', NULL, NULL, NULL, NULL, '', 248245),
(382466, 'PTHR33576:SF2', NULL, NULL, NULL, NULL, '', 248245),
(382467, 'PTHR33576:SF7', NULL, NULL, NULL, NULL, '', 248245),
(382468, 'PTHR33576', NULL, NULL, NULL, NULL, '', 248245),
(382469, 'PTHR33576:SF8', NULL, NULL, NULL, NULL, '', 248245),
(382470, 'PTHR33576:SF9', NULL, NULL, NULL, NULL, '', 248245),
(382471, 'PTHR45620:SF19', NULL, NULL, NULL, NULL, 'CORTICOTROPIN-RELEASING FACTOR RECEPTOR 2', 248246),
(382472, 'PTHR45620:SF32', NULL, NULL, NULL, NULL, 'DIURETIC HORMONE 31 RECEPTOR, ISOFORM C', 248246),
(382473, 'PTHR45620:SF30', NULL, NULL, NULL, NULL, 'GLUCAGON RECEPTOR-LIKE PROTEIN', 248246),
(382474, 'PTHR45620:SF13', NULL, NULL, NULL, NULL, 'SECRETIN RECEPTOR', 248246),
(382475, 'PTHR45620:SF14', NULL, NULL, NULL, NULL, 'GROWTH HORMONE-RELEASING HORMONE RECEPTOR', 248246),
(382476, 'PTHR45620:SF36', NULL, NULL, NULL, NULL, '', 248246),
(382477, 'PTHR45620:SF12', NULL, NULL, NULL, NULL, 'PITUITARY ADENYLATE CYCLASE-ACTIVATING POLYPEPTIDE TYPE I RECEPTOR', 248246),
(382478, 'PTHR45620:SF17', NULL, NULL, NULL, NULL, 'PDF RECEPTOR', 248246),
(382479, 'PTHR45620:SF18', NULL, NULL, NULL, NULL, 'PTH/PTHRP TYPE I RECEPTOR', 248246),
(382480, 'PTHR45620:SF37', NULL, NULL, NULL, NULL, 'SECRETIN/CLASS B GPCR', 248246),
(382481, 'PTHR45620:SF15', NULL, NULL, NULL, NULL, 'DIURETIC HORMONE 44 RECEPTOR 1', 248246),
(382482, 'PTHR45620:SF16', NULL, NULL, NULL, NULL, 'GROWTH HORMONE-RELEASING HORMONE RECEPTOR 2', 248246),
(382483, 'PTHR45620:SF8', NULL, NULL, NULL, NULL, 'CALCITONIN RECEPTOR', 248246),
(382484, 'PTHR45620', NULL, NULL, NULL, NULL, 'PDF RECEPTOR-LIKE PROTEIN-RELATED', 248246),
(382485, 'PTHR45620:SF4', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F2_4 DOMAIN-CONTAINING PROTEIN', 248246),
(382486, 'PTHR45620:SF5', NULL, NULL, NULL, NULL, 'GASTRIC INHIBITORY POLYPEPTIDE RECEPTOR', 248246),
(382487, 'PTHR45620:SF6', NULL, NULL, NULL, NULL, 'GROWTH HORMONE-RELEASING HORMONE-LIKE PEPTIDE RECEPTOR', 248246),
(382488, 'PTHR45620:SF7', NULL, NULL, NULL, NULL, 'PARATHYROID HORMONE 2 RECEPTOR', 248246),
(382489, 'PTHR45620:SF42', NULL, NULL, NULL, NULL, 'HECTOR, ISOFORM A', 248246),
(382490, 'PTHR45620:SF21', NULL, NULL, NULL, NULL, 'CALCITONIN GENE-RELATED PEPTIDE TYPE 1 RECEPTOR', 248246),
(382491, 'PTHR45620:SF1', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F2_4 DOMAIN-CONTAINING PROTEIN', 248246),
(382492, 'PTHR45620:SF40', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F2_4 DOMAIN-CONTAINING PROTEIN', 248246),
(382493, 'PTHR45620:SF2', NULL, NULL, NULL, NULL, 'CORTICOTROPIN-RELEASING FACTOR RECEPTOR 1', 248246),
(382494, 'PTHR45620:SF41', NULL, NULL, NULL, NULL, 'DIURETIC HORMONE 44 RECEPTOR 2, ISOFORM B', 248246),
(382495, 'PTHR45620:SF24', NULL, NULL, NULL, NULL, 'VASOACTIVE INTESTINAL POLYPEPTIDE RECEPTOR 1', 248246),
(382496, 'PTHR45620:SF25', NULL, NULL, NULL, NULL, 'GLUCAGON-LIKE PEPTIDE 1 RECEPTOR', 248246),
(382497, 'PTHR45620:SF22', NULL, NULL, NULL, NULL, 'VASOACTIVE INTESTINAL POLYPEPTIDE RECEPTOR 2', 248246);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(382498, 'PTHR45620:SF23', NULL, NULL, NULL, NULL, 'GLUCAGON-LIKE PEPTIDE 2 RECEPTOR', 248246),
(382499, 'PTHR45620:SF29', NULL, NULL, NULL, NULL, 'GLUCAGON RECEPTOR', 248246),
(382500, 'PTHR45620:SF27', NULL, NULL, NULL, NULL, 'PARATHYROID HORMONE/PARATHYROID HORMONE-RELATED PEPTIDE RECEPTOR', 248246),
(382501, 'PTHR10744:SF42', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S17, CHLOROPLASTIC', 248247),
(382502, 'PTHR10744:SF30', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S17, CHLOROPLASTIC', 248247),
(382503, 'PTHR10744:SF33', NULL, NULL, NULL, NULL, 'RIBOSOMAL_S17_N DOMAIN-CONTAINING PROTEIN', 248247),
(382504, 'PTHR10744:SF22', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S11', 248247),
(382505, 'PTHR10744:SF46', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S11-2', 248247),
(382506, 'PTHR10744:SF7', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S17, CHLOROPLASTIC', 248247),
(382507, 'PTHR10744:SF37', NULL, NULL, NULL, NULL, 'BNAA06G38660D PROTEIN', 248247),
(382508, 'PTHR10744:SF26', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S11-1', 248247),
(382509, 'PTHR10744:SF48', NULL, NULL, NULL, NULL, 'RIBOSOMAL_S17_N DOMAIN-CONTAINING PROTEIN', 248247),
(382510, 'PTHR10744:SF47', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S11-1-RELATED', 248247),
(382511, 'PTHR10744:SF9', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S11', 248247),
(382512, 'PTHR10744:SF49', NULL, NULL, NULL, NULL, 'RIBOSOMAL_S17_N DOMAIN-CONTAINING PROTEIN', 248247),
(382513, 'PTHR10744:SF38', NULL, NULL, NULL, NULL, 'RIBOSOMAL_S17_N DOMAIN-CONTAINING PROTEIN', 248247),
(382514, 'PTHR10744', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S11 FAMILY MEMBER', 248247),
(382515, 'PTHR10744:SF51', NULL, NULL, NULL, NULL, 'RIBOSOMAL_S17_N DOMAIN-CONTAINING PROTEIN', 248247),
(382516, 'PTHR10744:SF50', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S11-BETA', 248247),
(382517, 'PTHR10744:SF1', NULL, NULL, NULL, NULL, '37S RIBOSOMAL PROTEIN S17, MITOCHONDRIAL', 248247),
(382518, 'PTHR36477:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 225', 248248),
(382519, 'PTHR36477', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 225', 248248),
(382520, 'PTHR36477:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 225B', 248248),
(382521, 'PTHR47166:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 831', 248249),
(382522, 'PTHR47166', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 831', 248249),
(382523, 'PTHR46506:SF59', NULL, NULL, NULL, NULL, 'JACALIN-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 248250),
(382524, 'PTHR46506:SF37', NULL, NULL, NULL, NULL, 'JACALIN-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 248250),
(382525, 'PTHR46506', NULL, NULL, NULL, NULL, 'OS05G0143600 PROTEIN', 248250),
(382526, 'PTHR46506:SF35', NULL, NULL, NULL, NULL, 'OS01G0354100 PROTEIN', 248250),
(382527, 'PTHR46506:SF13', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 248250),
(382528, 'PTHR46506:SF58', NULL, NULL, NULL, NULL, '', 248250),
(382529, 'PTHR46506:SF14', NULL, NULL, NULL, NULL, 'OS04G0123125 PROTEIN', 248250),
(382530, 'PTHR46506:SF36', NULL, NULL, NULL, NULL, '', 248250),
(382531, 'PTHR46506:SF55', NULL, NULL, NULL, NULL, 'JACALIN-LIKE LECTIN DOMAIN-CONTAINING PROTEIN-RELATED', 248250),
(382532, 'PTHR46506:SF34', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 248250),
(382533, 'PTHR46506:SF31', NULL, NULL, NULL, NULL, 'OS11G0165700 PROTEIN', 248250),
(382534, 'PTHR46506:SF1', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 248250),
(382535, 'PTHR46506:SF39', NULL, NULL, NULL, NULL, 'JACALIN-LIKE LECTIN DOMAIN, TRANSPOSASE-ASSOCIATED DOMAIN PROTEIN-RELATED', 248250),
(382536, 'PTHR46506:SF17', NULL, NULL, NULL, NULL, 'JACALIN-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 248250),
(382537, 'PTHR46506:SF4', NULL, NULL, NULL, NULL, 'JACALIN-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 248250),
(382538, 'PTHR46506:SF3', NULL, NULL, NULL, NULL, 'PROTEIN GOS9', 248250),
(382539, 'PTHR46506:SF9', NULL, NULL, NULL, NULL, 'OS05G0143600 PROTEIN', 248250),
(382540, 'PTHR46506:SF40', NULL, NULL, NULL, NULL, 'JACALIN-LIKE LECTIN DOMAIN-CONTAINING PROTEIN-RELATED', 248250);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(382541, 'PTHR46506:SF41', NULL, NULL, NULL, NULL, 'JACALIN-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 248250),
(382542, 'PTHR46506:SF49', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 248250),
(382543, 'PTHR46506:SF68', NULL, NULL, NULL, NULL, 'JACALIN-LIKE LECTIN DOMAIN CONTAINING PROTEIN, EXPRESSED', 248250),
(382544, 'PTHR46506:SF69', NULL, NULL, NULL, NULL, 'JACALIN-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 248250),
(382545, 'PTHR46506:SF47', NULL, NULL, NULL, NULL, 'JACALIN-LIKE LECTIN DOMAIN-CONTAINING PROTEIN-RELATED', 248250),
(382546, 'PTHR46506:SF66', NULL, NULL, NULL, NULL, 'HORCOLIN', 248250),
(382547, 'PTHR46506:SF67', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 248250),
(382548, 'PTHR46506:SF28', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 248250),
(382549, 'PTHR46506:SF73', NULL, NULL, NULL, NULL, 'JACALIN-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 248250),
(382550, 'PTHR46506:SF51', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 248250),
(382551, 'PTHR46506:SF30', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 248250),
(382552, 'PTHR46506:SF71', NULL, NULL, NULL, NULL, 'JACALIN-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 248250),
(382553, 'PTHR46506:SF72', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 248250),
(382554, 'PTHR46506:SF70', NULL, NULL, NULL, NULL, 'OS11G0524400 PROTEIN', 248250),
(382555, 'PTHR10416', NULL, NULL, NULL, NULL, 'DNA POLYMERASE DELTA SUBUNIT 2', 248251),
(382556, 'PTHR10416:SF0', NULL, NULL, NULL, NULL, 'DNA POLYMERASE DELTA SUBUNIT 2', 248251),
(382557, 'PTHR35860:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAM24A', 248252),
(382558, 'PTHR35860', NULL, NULL, NULL, NULL, 'PROTEIN FAM24B', 248252),
(382559, 'PTHR35860:SF5', NULL, NULL, NULL, NULL, 'PROTEIN FAM24B', 248252),
(382560, 'PTHR35860:SF4', NULL, NULL, NULL, NULL, 'PROTEIN FAM24A-LIKE', 248252),
(382561, 'PTHR10916', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L35/50S RIBOSOMAL PROTEIN L29', 248253),
(382562, 'PTHR10916:SF1', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L29, CHLOROPLASTIC', 248253),
(382563, 'PTHR10916:SF0', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L29, CHLOROPLASTIC', 248253),
(382564, 'PTHR32378:SF19', NULL, NULL, NULL, NULL, 'GGL DOMAIN PROTEIN', 248254),
(382565, 'PTHR32378:SF17', NULL, NULL, NULL, NULL, 'BNAA01G25080D PROTEIN', 248254),
(382566, 'PTHR32378:SF18', NULL, NULL, NULL, NULL, 'G-PROTEIN GAMMA-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 248254),
(382567, 'PTHR32378:SF15', NULL, NULL, NULL, NULL, 'G PROTEIN GAMMA DOMAIN-CONTAINING PROTEIN', 248254),
(382568, 'PTHR32378:SF16', NULL, NULL, NULL, NULL, 'G PROTEIN GAMMA DOMAIN-CONTAINING PROTEIN', 248254),
(382569, 'PTHR32378:SF14', NULL, NULL, NULL, NULL, 'G PROTEIN GAMMA DOMAIN-CONTAINING PROTEIN', 248254),
(382570, 'PTHR32378:SF12', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT GAMMA 2', 248254),
(382571, 'PTHR32378:SF10', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT GAMMA 3', 248254),
(382572, 'PTHR32378:SF7', NULL, NULL, NULL, NULL, 'OS03G0407400 PROTEIN', 248254),
(382573, 'PTHR32378', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT GAMMA 3', 248254),
(382574, 'PTHR35248:SF2', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 248255),
(382575, 'PTHR35248', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 248255),
(382576, 'PTHR12173', NULL, NULL, NULL, NULL, 'GDNF SUBFAMILY OF TGF-BETA FAMILY', 248256),
(382577, 'PTHR12173:SF9', NULL, NULL, NULL, NULL, 'ARTEMIN', 248256),
(382578, 'PTHR12173:SF8', NULL, NULL, NULL, NULL, 'PERSEPHIN', 248256),
(382579, 'PTHR12173:SF3', NULL, NULL, NULL, NULL, 'NEURTURIN', 248256),
(382580, 'PTHR12173:SF1', NULL, NULL, NULL, NULL, 'GLIAL CELL LINE-DERIVED NEUROTROPHIC FACTOR', 248256),
(382581, 'PTHR11348:SF33', NULL, NULL, NULL, NULL, 'CELLULAR COMMUNICATION NETWORK FACTOR 1,-LIKE 1-RELATED', 248257),
(382582, 'PTHR11348:SF22', NULL, NULL, NULL, NULL, 'CCN FAMILY MEMBER 5', 248257),
(382583, 'PTHR11348:SF34', NULL, NULL, NULL, NULL, 'EPIDERMAL CELL SURFACE RECEPTOR-RELATED', 248257),
(382584, 'PTHR11348:SF23', NULL, NULL, NULL, NULL, 'CELLULAR COMMUNICATION NETWORK FACTOR 2B', 248257);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(382585, 'PTHR11348:SF7', NULL, NULL, NULL, NULL, 'CCN FAMILY MEMBER 2', 248257),
(382586, 'PTHR11348:SF4', NULL, NULL, NULL, NULL, 'CCN FAMILY MEMBER 4', 248257),
(382587, 'PTHR11348', NULL, NULL, NULL, NULL, 'CONNECTIVE TISSUE GROWTH FACTOR-RELATED', 248257),
(382588, 'PTHR11348:SF8', NULL, NULL, NULL, NULL, 'CCN FAMILY MEMBER 3', 248257),
(382589, 'PTHR11348:SF20', NULL, NULL, NULL, NULL, 'SI:CH211-106H11.3', 248257),
(382590, 'PTHR11348:SF3', NULL, NULL, NULL, NULL, 'CELLULAR COMMUNICATION NETWORK FACTOR 6', 248257),
(382591, 'PTHR11348:SF17', NULL, NULL, NULL, NULL, 'CCN', 248257),
(382592, 'PTHR11348:SF18', NULL, NULL, NULL, NULL, 'CCN FAMILY MEMBER 1', 248257),
(382593, 'PTHR21325:SF31', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE B1, MEMBRANE-ASSOCIATED', 248258),
(382594, 'PTHR21325:SF32', NULL, NULL, NULL, NULL, 'LIPASE_GDSL DOMAIN-CONTAINING PROTEIN', 248258),
(382595, 'PTHR21325:SF51', NULL, NULL, NULL, NULL, 'LIPASE_GDSL DOMAIN-CONTAINING PROTEIN', 248258),
(382596, 'PTHR21325', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE B, PLB1', 248258),
(382597, 'PTHR21325:SF24', NULL, NULL, NULL, NULL, 'LIPASE_GDSL DOMAIN-CONTAINING PROTEIN', 248258),
(382598, 'PTHR21325:SF44', NULL, NULL, NULL, NULL, 'LIPASE_GDSL DOMAIN-CONTAINING PROTEIN', 248258),
(382599, 'PTHR21325:SF23', NULL, NULL, NULL, NULL, 'LIPASE_GDSL DOMAIN-CONTAINING PROTEIN', 248258),
(382600, 'PTHR21325:SF45', NULL, NULL, NULL, NULL, 'SI:DKEY-177P2.18', 248258),
(382601, 'PTHR21325:SF28', NULL, NULL, NULL, NULL, 'PROTEIN CBG12154', 248258),
(382602, 'PTHR21325:SF26', NULL, NULL, NULL, NULL, 'LIPASE_GDSL DOMAIN-CONTAINING PROTEIN', 248258),
(382603, 'PTHR21325:SF48', NULL, NULL, NULL, NULL, 'LYSOPHOSPHOLIPASE', 248258),
(382604, 'PTHR21325:SF50', NULL, NULL, NULL, NULL, 'LIPASE_GDSL DOMAIN-CONTAINING PROTEIN', 248258),
(382605, 'PTHR21614:SF3', NULL, NULL, NULL, NULL, 'SHORT COILED-COIL PROTEIN B', 248259),
(382606, 'PTHR21614:SF1', NULL, NULL, NULL, NULL, 'SHORT COILED-COIL PROTEIN', 248259),
(382607, 'PTHR21614', NULL, NULL, NULL, NULL, 'SHORT COILED COIL PROTEIN', 248259),
(382608, 'PTHR21614:SF0', NULL, NULL, NULL, NULL, 'GEO08385P1', 248259),
(382609, 'PTHR12297:SF3', NULL, NULL, NULL, NULL, 'HIG1 DOMAIN FAMILY MEMBER 2A', 248260),
(382610, 'PTHR12297:SF16', NULL, NULL, NULL, NULL, 'HIG1 HYPOXIA INDUCIBLE DOMAIN FAMILY MEMBER 1A', 248260),
(382611, 'PTHR12297:SF17', NULL, NULL, NULL, NULL, 'HIG1 DOMAIN-CONTAINING PROTEIN', 248260),
(382612, 'PTHR12297:SF10', NULL, NULL, NULL, NULL, 'HIG1 DOMAIN FAMILY MEMBER 1C', 248260),
(382613, 'PTHR12297:SF9', NULL, NULL, NULL, NULL, 'HIG1 DOMAIN FAMILY MEMBER 1B', 248260),
(382614, 'PTHR12297:SF8', NULL, NULL, NULL, NULL, 'HIG1 DOMAIN FAMILY MEMBER 2B-RELATED', 248260),
(382615, 'PTHR12297', NULL, NULL, NULL, NULL, 'HYPOXIA-INDUCBILE GENE 1  HIG1 -RELATED', 248260),
(382616, 'PTHR12297:SF6', NULL, NULL, NULL, NULL, 'HIG1 HYPOXIA-INDUCIBLE DOMAIN FAMILY, MEMBER 1A', 248260),
(382617, 'PTHR12297:SF11', NULL, NULL, NULL, NULL, 'HIG1 DOMAIN FAMILY MEMBER 2A, MITOCHONDRIAL', 248260),
(382618, 'PTHR12297:SF5', NULL, NULL, NULL, NULL, 'HIG1 DOMAIN FAMILY MEMBER 1A, MITOCHONDRIAL', 248260),
(382619, 'PTHR12297:SF14', NULL, NULL, NULL, NULL, 'HIG1 DOMAIN-CONTAINING PROTEIN', 248260),
(382620, 'PTHR12297:SF13', NULL, NULL, NULL, NULL, 'HIG1 DOMAIN-CONTAINING PROTEIN', 248260),
(382621, 'PTHR21054:SF2', NULL, NULL, NULL, NULL, 'MIP04191P', 248261),
(382622, 'PTHR21054', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE-RELATED', 248261),
(382623, 'PTHR47499:SF1', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR KAZAL-TYPE 7', 248262),
(382624, 'PTHR47499', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR KAZAL-TYPE 7 SPINK7', 248262),
(382625, 'PTHR47499:SF4', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR KAZAL-TYPE 12', 248262),
(382626, 'PTHR47499:SF3', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR KAZAL-TYPE 14', 248262),
(382627, 'PTHR47499:SF2', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR KAZAL-TYPE 9', 248262),
(382628, 'PTHR47499:SF6', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR KAZAL-TYPE 6', 248262);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(382629, 'PTHR47781:SF1', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L36 2', 248263),
(382630, 'PTHR47781', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L36 2', 248263),
(382631, 'PTHR33988', NULL, NULL, NULL, NULL, 'ENDORIBONUCLEASE MAZF-RELATED', 248264),
(382632, 'PTHR33988:SF2', NULL, NULL, NULL, NULL, 'ENDORIBONUCLEASE ENDOA', 248264),
(382633, 'PTHR33988:SF3', NULL, NULL, NULL, NULL, 'ENDORIBONUCLEASE TOXIN CHPB-RELATED', 248264),
(382634, 'PTHR33988:SF1', NULL, NULL, NULL, NULL, 'ENDORIBONUCLEASE MAZF7-RELATED', 248264),
(382635, 'PTHR38342', NULL, NULL, NULL, NULL, 'SLR5037 PROTEIN', 248265),
(382636, 'PTHR38342:SF1', NULL, NULL, NULL, NULL, 'SLR5037 PROTEIN', 248265),
(382637, 'PTHR38342:SF2', NULL, NULL, NULL, NULL, 'INNER MEMBRANE OR EXPORTED-RELATED', 248265),
(382638, 'PTHR13049:SF7', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 25', 248266),
(382639, 'PTHR13049:SF5', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 25', 248266),
(382640, 'PTHR13049:SF3', NULL, NULL, NULL, NULL, 'OS01G0750500 PROTEIN', 248266),
(382641, 'PTHR13049:SF2', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 25', 248266),
(382642, 'PTHR13049', NULL, NULL, NULL, NULL, 'DUF814-RELATED', 248266),
(382643, 'PTHR13049:SF8', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 25', 248266),
(382644, 'PTHR14399:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 47', 248267),
(382645, 'PTHR14399:SF4', NULL, NULL, NULL, NULL, 'P53 APOPTOSIS EFFECTOR RELATED TO PMP-22', 248267),
(382646, 'PTHR14399:SF5', NULL, NULL, NULL, NULL, 'CELL JUNCTION PROTEIN VAB-9', 248267),
(382647, 'PTHR14399:SF13', NULL, NULL, NULL, NULL, '', 248267),
(382648, 'PTHR14399:SF12', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 47-LIKE', 248267),
(382649, 'PTHR14399:SF14', NULL, NULL, NULL, NULL, '', 248267),
(382650, 'PTHR14399', NULL, NULL, NULL, NULL, 'P53-INDUCED PROTEIN RELATED', 248267),
(382651, 'PTHR43358', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASE', 248268),
(382652, 'PTHR43358:SF8', NULL, NULL, NULL, NULL, 'ALPHA/BETA SUPERFAMILY HYDROLASE', 248268),
(382653, 'PTHR43358:SF9', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 248268),
(382654, 'PTHR43358:SF4', NULL, NULL, NULL, NULL, 'ALPHA/BETA HYDROLASE FOLD-1 DOMAIN-CONTAINING PROTEIN', 248268),
(382655, 'PTHR43358:SF5', NULL, NULL, NULL, NULL, 'EXPORTED PROTEIN-RELATED', 248268),
(382656, 'PTHR43358:SF13', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 248268),
(382657, 'PTHR43358:SF12', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 248268),
(382658, 'PTHR43358:SF1', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 248268),
(382659, 'PTHR43358:SF11', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 248268),
(382660, 'PTHR43358:SF10', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 248268),
(382661, 'PTHR36587', NULL, NULL, NULL, NULL, 'EXPRESSION SITE-ASSOCIATED GENE 3 (ESAG3)-LIKE PROTEIN', 248269),
(382662, 'PTHR36587:SF2', NULL, NULL, NULL, NULL, 'EXPRESSION SITE-ASSOCIATED GENE 3 (ESAG3)-LIKE PROTEIN', 248269),
(382663, 'PTHR46715', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 3-PHOSPHATE 5-KINASE', 248270),
(382664, 'PTHR46715:SF1', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 3-PHOSPHATE 5-KINASE', 248270),
(382665, 'PTHR36767', NULL, NULL, NULL, NULL, 'OS05G0126200 PROTEIN', 248271),
(382666, 'PTHR36767:SF1', NULL, NULL, NULL, NULL, 'OS05G0126200 PROTEIN', 248271),
(382667, 'PTHR40711:SF2', NULL, NULL, NULL, NULL, 'EXTRACELLULAR GLYCOPROTEIN LACRITIN', 248272),
(382668, 'PTHR40711:SF1', NULL, NULL, NULL, NULL, 'DERMCIDIN', 248272),
(382669, 'PTHR40711', NULL, NULL, NULL, NULL, 'DERMCIDIN-RELATED', 248272),
(382670, 'PTHR11739:SF29', NULL, NULL, NULL, NULL, 'CITRATE SYNTHASE', 248273),
(382671, 'PTHR11739:SF28', NULL, NULL, NULL, NULL, 'CITRATE SYNTHASE', 248273),
(382672, 'PTHR11739:SF27', NULL, NULL, NULL, NULL, 'CITRATE SYNTHASE 1, PEROXISOMAL-RELATED', 248273),
(382673, 'PTHR11739:SF15', NULL, NULL, NULL, NULL, 'CITRATE SYNTHASE 3, MITOCHONDRIAL', 248273); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(382674, 'PTHR11739:SF25', NULL, NULL, NULL, NULL, 'CITRATE SYNTHASE-RELATED PROTEIN DDB_G0287281', 248273),
(382675, 'PTHR11739:SF3', NULL, NULL, NULL, NULL, 'CITRATE SYNTHASE', 248273),
(382676, 'PTHR11739:SF4', NULL, NULL, NULL, NULL, 'CITRATE SYNTHASE, PEROXISOMAL', 248273),
(382677, 'PTHR11739', NULL, NULL, NULL, NULL, 'CITRATE SYNTHASE', 248273),
(382678, 'PTHR11739:SF23', NULL, NULL, NULL, NULL, 'CITRATE SYNTHASE 2-RELATED', 248273),
(382679, 'PTHR11739:SF34', NULL, NULL, NULL, NULL, 'CITRATE SYNTHASE', 248273),
(382680, 'PTHR11739:SF11', NULL, NULL, NULL, NULL, 'CITRATE/2-METHYLCITRATE SYNTHASE', 248273),
(382681, 'PTHR11739:SF33', NULL, NULL, NULL, NULL, 'CITRATE SYNTHASE 4, MITOCHONDRIAL', 248273),
(382682, 'PTHR11739:SF32', NULL, NULL, NULL, NULL, 'CITRATE SYNTHASE', 248273),
(382683, 'PTHR11739:SF31', NULL, NULL, NULL, NULL, 'CITRATE SYNTHASE', 248273),
(382684, 'PTHR11739:SF8', NULL, NULL, NULL, NULL, 'CITRATE SYNTHASE, MITOCHONDRIAL', 248273),
(382685, 'PTHR22599:SF8', NULL, NULL, NULL, NULL, 'MOB KINASE ACTIVATOR-LIKE 1', 248274),
(382686, 'PTHR22599', NULL, NULL, NULL, NULL, 'MPS ONE BINDER KINASE ACTIVATOR-LIKE  MOB', 248274),
(382687, 'PTHR22599:SF68', NULL, NULL, NULL, NULL, 'MOB KINASE ACTIVATOR-LIKE 1A ISOFORM X1', 248274),
(382688, 'PTHR22599:SF25', NULL, NULL, NULL, NULL, 'MOB KINASE ACTIVATOR-LIKE 2A', 248274),
(382689, 'PTHR22599:SF69', NULL, NULL, NULL, NULL, 'MOB KINASE ACTIVATOR-LIKE 1 HOMOLOG A', 248274),
(382690, 'PTHR22599:SF1', NULL, NULL, NULL, NULL, 'MOB-LIKE PROTEIN PHOCEIN', 248274),
(382691, 'PTHR22599:SF48', NULL, NULL, NULL, NULL, 'MOB KINASE ACTIVATOR 2-LIKE', 248274),
(382692, 'PTHR22599:SF61', NULL, NULL, NULL, NULL, 'MOB KINASE ACTIVATOR-LIKE 2', 248274),
(382693, 'PTHR22599:SF63', NULL, NULL, NULL, NULL, 'MOB KINASE ACTIVATOR 1B', 248274),
(382694, 'PTHR22599:SF20', NULL, NULL, NULL, NULL, 'CBK1 KINASE ACTIVATOR PROTEIN MOB2', 248274),
(382695, 'PTHR22599:SF21', NULL, NULL, NULL, NULL, 'MOB KINASE ACTIVATOR 2', 248274),
(382696, 'PTHR22599:SF65', NULL, NULL, NULL, NULL, '', 248274),
(382697, 'PTHR22599:SF66', NULL, NULL, NULL, NULL, 'MOB KINASE ACTIVATOR-LIKE 1A', 248274),
(382698, 'PTHR22599:SF22', NULL, NULL, NULL, NULL, 'MOB KINASE ACTIVATOR 3B', 248274),
(382699, 'PTHR22599:SF67', NULL, NULL, NULL, NULL, 'MOB KINASE ACTIVATOR-LIKE 2A-RELATED', 248274),
(382700, 'PTHR22599:SF57', NULL, NULL, NULL, NULL, 'MOB KINASE ACTIVATOR-LIKE 2A', 248274),
(382701, 'PTHR22599:SF58', NULL, NULL, NULL, NULL, 'MOB KINASE ACTIVATOR-LIKE 1A', 248274),
(382702, 'PTHR22599:SF51', NULL, NULL, NULL, NULL, '', 248274),
(382703, 'PTHR22599:SF52', NULL, NULL, NULL, NULL, 'MOB KINASE ACTIVATOR-LIKE 1 HOMOLOG C', 248274),
(382704, 'PTHR22599:SF30', NULL, NULL, NULL, NULL, 'MOB KINASE ACTIVATOR 1A', 248274),
(382705, 'PTHR22599:SF53', NULL, NULL, NULL, NULL, 'ONE BINDER KINASE ACTIVATOR-LIKE 1A, PUTATIVE, EXPRESSED-RELATED', 248274),
(382706, 'PTHR22599:SF10', NULL, NULL, NULL, NULL, 'MOB KINASE ACTIVATOR 3A', 248274),
(382707, 'PTHR22599:SF32', NULL, NULL, NULL, NULL, 'MOB KINASE ACTIVATOR 2A-RELATED', 248274),
(382708, 'PTHR22599:SF11', NULL, NULL, NULL, NULL, 'MOB KINASE ACTIVATOR-LIKE 3', 248274),
(382709, 'PTHR22599:SF56', NULL, NULL, NULL, NULL, 'MOB-LIKE PROTEIN PHOCEIN', 248274),
(382710, 'PTHR22599:SF12', NULL, NULL, NULL, NULL, 'MOB KINASE ACTIVATOR 3C', 248274),
(382711, 'PTHR47315:SF3', NULL, NULL, NULL, NULL, 'FIBROUS SHEATH INTERACTING PROTEIN 2', 248275),
(382712, 'PTHR47315:SF2', NULL, NULL, NULL, NULL, '', 248275),
(382713, 'PTHR47315', NULL, NULL, NULL, NULL, 'FIBROUS SHEATH INTERACTING PROTEIN 2', 248275),
(382714, 'PTHR31193:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 268', 248276),
(382715, 'PTHR31193', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN C9ORF91', 248276),
(382716, 'PTHR44366:SF1', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE--PEPTIDE N-ACETYLGLUCOSAMINYLTRANSFERASE 110 KDA SUBUNIT', 248277),
(382717, 'PTHR44366:SF4', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE--PEPTIDE N-ACETYLGLUCOSAMINYLTRANSFERASE SPINDLY-RELATED', 248277);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(382718, 'PTHR44366', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE--PEPTIDE N-ACETYLGLUCOSAMINYLTRANSFERASE 110 KDA SUBUNIT', 248277),
(382719, 'PTHR46794:SF5', NULL, NULL, NULL, NULL, 'AMELOGENIN, X ISOFORM', 248278),
(382720, 'PTHR46794:SF2', NULL, NULL, NULL, NULL, 'AMELOGENIN, Y ISOFORM', 248278),
(382721, 'PTHR46794', NULL, NULL, NULL, NULL, 'AMELOGENIN, Y ISOFORM', 248278),
(382722, 'PTHR45795:SF2', NULL, NULL, NULL, NULL, 'EARLY GAMETOCYTE ENRICHED PHOSPHOPROTEIN EGXP', 248279),
(382723, 'PTHR45795:SF1', NULL, NULL, NULL, NULL, '', 248279),
(382724, 'PTHR45795', NULL, NULL, NULL, NULL, 'EARLY GAMETOCYTE ENRICHED PHOSPHOPROTEIN EGXP', 248279),
(382725, 'PTHR36888', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN-CONTAINING PROTEIN-RELATED', 248280),
(382726, 'PTHR36888:SF2', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN-CONTAINING PROTEIN-RELATED', 248280),
(382727, 'PTHR16266', NULL, NULL, NULL, NULL, 'WD REPEAT DOMAIN 9', 248281),
(382728, 'PTHR16266:SF32', NULL, NULL, NULL, NULL, 'PH-INTERACTING PROTEIN-LIKE ISOFORM X1', 248281),
(382729, 'PTHR16266:SF33', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 248281),
(382730, 'PTHR16266:SF34', NULL, NULL, NULL, NULL, 'WD40/YVTN REPEAT CONTAINING DOMAIN-CONTAINING PROTEIN', 248281),
(382731, 'PTHR16266:SF30', NULL, NULL, NULL, NULL, 'BROMODOMAIN AND WD REPEAT-CONTAINING PROTEIN 3-LIKE ISOFORM X1', 248281),
(382732, 'PTHR16266:SF17', NULL, NULL, NULL, NULL, 'BRWD3', 248281),
(382733, 'PTHR16266:SF4', NULL, NULL, NULL, NULL, 'PH-INTERACTING PROTEIN', 248281),
(382734, 'PTHR16266:SF29', NULL, NULL, NULL, NULL, 'BROMO DOMAIN-CONTAINING PROTEIN', 248281),
(382735, 'PTHR16266:SF25', NULL, NULL, NULL, NULL, 'BROMODOMAIN AND WD REPEAT-CONTAINING PROTEIN 3', 248281),
(382736, 'PTHR16266:SF37', NULL, NULL, NULL, NULL, 'WD40 DOMAIN-CONTAINING PROTEIN', 248281),
(382737, 'PTHR16266:SF26', NULL, NULL, NULL, NULL, 'BROMODOMAIN AND WD REPEAT-CONTAINING PROTEIN 1', 248281),
(382738, 'PTHR45724:SF26', NULL, NULL, NULL, NULL, 'AQUAPORIN NIP7-1-RELATED', 248282),
(382739, 'PTHR45724:SF46', NULL, NULL, NULL, NULL, 'AQUAPORIN NIP4-1-RELATED', 248282),
(382740, 'PTHR45724:SF23', NULL, NULL, NULL, NULL, 'AQUAPORIN NIP4-2-RELATED', 248282),
(382741, 'PTHR45724:SF22', NULL, NULL, NULL, NULL, 'AQUAPORIN NIP1-3', 248282),
(382742, 'PTHR45724:SF44', NULL, NULL, NULL, NULL, 'MAJOR INTRINSIC PROTEIN, AQUAPORIN-LIKE PROTEIN-RELATED', 248282),
(382743, 'PTHR45724:SF21', NULL, NULL, NULL, NULL, 'MAJOR INTRINSIC PROTEIN', 248282),
(382744, 'PTHR45724:SF41', NULL, NULL, NULL, NULL, 'BNAA02G36290D PROTEIN', 248282),
(382745, 'PTHR45724:SF6', NULL, NULL, NULL, NULL, 'AQUAPORIN NIP-TYPE-RELATED', 248282),
(382746, 'PTHR45724:SF9', NULL, NULL, NULL, NULL, 'AQUAPORIN NIP2-2', 248282),
(382747, 'PTHR45724:SF28', NULL, NULL, NULL, NULL, 'AQUAPORIN NIP4-3S', 248282),
(382748, 'PTHR45724:SF8', NULL, NULL, NULL, NULL, 'AQUAPORIN NIP1-4', 248282),
(382749, 'PTHR45724:SF49', NULL, NULL, NULL, NULL, 'BNAC05G29150D PROTEIN', 248282),
(382750, 'PTHR45724:SF27', NULL, NULL, NULL, NULL, 'AQUAPORIN NIP2-1-RELATED', 248282),
(382751, 'PTHR45724:SF51', NULL, NULL, NULL, NULL, 'AQUAPORIN NIP1-2', 248282),
(382752, 'PTHR45724:SF50', NULL, NULL, NULL, NULL, 'AQUAPORIN NIP-TYPE-RELATED', 248282),
(382753, 'PTHR45724:SF15', NULL, NULL, NULL, NULL, 'AQUAPORIN NIP5-1-RELATED', 248282),
(382754, 'PTHR45724:SF36', NULL, NULL, NULL, NULL, 'BNAA05G09450D PROTEIN', 248282),
(382755, 'PTHR45724:SF14', NULL, NULL, NULL, NULL, 'MAJOR INTRINSIC PROTEIN (MIP) FAMILY TRANSPORTER', 248282),
(382756, 'PTHR45724:SF35', NULL, NULL, NULL, NULL, 'AQUAPORIN NIP5-1-RELATED', 248282),
(382757, 'PTHR45724:SF13', NULL, NULL, NULL, NULL, 'AQUAPORIN NIP1-1-RELATED', 248282),
(382758, 'PTHR45724', NULL, NULL, NULL, NULL, 'AQUAPORIN NIP2-1', 248282),
(382759, 'PTHR45724:SF12', NULL, NULL, NULL, NULL, 'AQUAPORIN NIP3-1', 248282),
(382760, 'PTHR45724:SF11', NULL, NULL, NULL, NULL, 'AQUAPORIN NIP5-1-RELATED', 248282),
(382761, 'PTHR45724:SF32', NULL, NULL, NULL, NULL, 'NODULIN-26 LIKE INTRINSIC PROTEIN', 248282);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(382762, 'PTHR45724:SF53', NULL, NULL, NULL, NULL, 'AQUAPORIN NIP5-1 ISOFORM X1-RELATED', 248282),
(382763, 'PTHR45724:SF31', NULL, NULL, NULL, NULL, 'MAJOR INTRINSIC PROTEIN, AQUAPORIN-LIKE PROTEIN-RELATED', 248282),
(382764, 'PTHR45724:SF52', NULL, NULL, NULL, NULL, 'MAJOR INTRINSIC PROTEIN (MIP) FAMILY TRANSPORTER', 248282),
(382765, 'PTHR45724:SF19', NULL, NULL, NULL, NULL, 'AQUAPORIN NIP6-1', 248282),
(382766, 'PTHR45724:SF18', NULL, NULL, NULL, NULL, 'NODULIN-26', 248282),
(382767, 'PTHR45724:SF39', NULL, NULL, NULL, NULL, '', 248282),
(382768, 'PTHR45724:SF16', NULL, NULL, NULL, NULL, 'AQUAPORIN NIP2-1', 248282),
(382769, 'PTHR45724:SF40', NULL, NULL, NULL, NULL, 'AQUAPORIN NIP1.1', 248282),
(382770, 'PTHR47882:SF1', NULL, NULL, NULL, NULL, 'BIOGENESIS OF LYSOSOME-RELATED ORGANELLES COMPLEX 1 SUBUNIT 2', 248283),
(382771, 'PTHR47882', NULL, NULL, NULL, NULL, 'BIOGENESIS OF LYSOSOME-RELATED ORGANELLES COMPLEX 1 SUBUNIT 2', 248283),
(382772, 'PTHR23163', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN-RELATED', 248284),
(382773, 'PTHR23163:SF6', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE BRL1', 248284),
(382774, 'PTHR23163:SF5', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN PROTEIN LIGASE', 248284),
(382775, 'PTHR23163:SF4', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE BRE1B', 248284),
(382776, 'PTHR23163:SF3', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE BRE1-LIKE 1', 248284),
(382777, 'PTHR23163:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE BRE1A', 248284),
(382778, 'PTHR23163:SF0', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE BRE1', 248284),
(382779, 'PTHR46709:SF6', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 248285),
(382780, 'PTHR46709:SF5', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 248285),
(382781, 'PTHR46709:SF8', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 248285),
(382782, 'PTHR46709:SF7', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 248285),
(382783, 'PTHR46709:SF9', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 248285),
(382784, 'PTHR46709:SF15', NULL, NULL, NULL, NULL, 'PROTEIN CBG14462', 248285),
(382785, 'PTHR46709:SF14', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 248285),
(382786, 'PTHR46709:SF2', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 248285),
(382787, 'PTHR46709:SF1', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 248285),
(382788, 'PTHR46709:SF4', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 248285),
(382789, 'PTHR46709:SF3', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 248285),
(382790, 'PTHR46709:SF13', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 248285),
(382791, 'PTHR46709:SF12', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 248285),
(382792, 'PTHR46709', NULL, NULL, NULL, NULL, 'PROTEIN CBG23488-RELATED', 248285),
(382793, 'PTHR46709:SF11', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 248285),
(382794, 'PTHR46709:SF10', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 248285),
(382795, 'PTHR42917:SF3', NULL, NULL, NULL, NULL, '2,4-DIENOYL-COA REDUCTASE-LIKE PROTEIN', 248286),
(382796, 'PTHR42917:SF2', NULL, NULL, NULL, NULL, '2,4-DIENOYL-COA REDUCTASE [(2E)-ENOYL-COA-PRODUCING]', 248286),
(382797, 'PTHR42917', NULL, NULL, NULL, NULL, '2,4-DIENOYL-COA REDUCTASE', 248286),
(382798, 'PTHR15233:SF2', NULL, NULL, NULL, NULL, 'ATP SYNTHASE MEMBRANE SUBUNIT 6.8PL', 248287),
(382799, 'PTHR15233:SF1', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT ATP5MJ, MITOCHONDRIAL', 248287),
(382800, 'PTHR15233', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PROTEOLIPID', 248287),
(382801, 'PTHR36586:SF47', NULL, NULL, NULL, NULL, 'PROLINE-RICH EXTENSIN-LIKE FAMILY PROTEIN', 248288),
(382802, 'PTHR36586:SF48', NULL, NULL, NULL, NULL, 'EXTENSIN-2-LIKE', 248288);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(382803, 'PTHR36586:SF26', NULL, NULL, NULL, NULL, 'PROCYCLIC FORM SURFACE GLYCOPROTEIN', 248288),
(382804, 'PTHR36586:SF45', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN (HRGP)', 248288),
(382805, 'PTHR36586:SF34', NULL, NULL, NULL, NULL, 'EXTENSIN-1', 248288),
(382806, 'PTHR36586:SF46', NULL, NULL, NULL, NULL, 'PROLINE-RICH EXTENSIN-LIKE FAMILY PROTEIN', 248288),
(382807, 'PTHR36586:SF24', NULL, NULL, NULL, NULL, 'EXTENSIN-1-LIKE', 248288),
(382808, 'PTHR36586:SF43', NULL, NULL, NULL, NULL, 'EXTENSIN-LIKE PROTEIN-RELATED', 248288),
(382809, 'PTHR36586:SF33', NULL, NULL, NULL, NULL, 'BNAA08G20330D PROTEIN', 248288),
(382810, 'PTHR36586:SF44', NULL, NULL, NULL, NULL, '', 248288),
(382811, 'PTHR36586:SF41', NULL, NULL, NULL, NULL, 'EXTENSIN DOMAIN-CONTAINING PROTEIN-RELATED', 248288),
(382812, 'PTHR36586:SF42', NULL, NULL, NULL, NULL, 'POLLEN PROTEIN OLE E I-LIKE PROTEIN', 248288),
(382813, 'PTHR36586:SF50', NULL, NULL, NULL, NULL, 'EXTENSIN-LIKE', 248288),
(382814, 'PTHR36586:SF40', NULL, NULL, NULL, NULL, 'EXTENSIN-2-LIKE', 248288),
(382815, 'PTHR36586', NULL, NULL, NULL, NULL, 'PROLINE-RICH EXTENSIN-LIKE', 248288),
(382816, 'PTHR36586:SF49', NULL, NULL, NULL, NULL, 'EXTENSIN_2 DOMAIN-CONTAINING PROTEIN', 248288),
(382817, 'PTHR36586:SF16', NULL, NULL, NULL, NULL, 'EXTENSIN-2-RELATED', 248288),
(382818, 'PTHR36586:SF27', NULL, NULL, NULL, NULL, 'EXTENSIN-LIKE', 248288),
(382819, 'PTHR36586:SF38', NULL, NULL, NULL, NULL, 'EXTENSIN-3', 248288),
(382820, 'PTHR36586:SF39', NULL, NULL, NULL, NULL, 'EXTENSIN-2-LIKE', 248288),
(382821, 'PTHR13900', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID', 248289),
(382822, 'PTHR13900:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 1', 248289),
(382823, 'PTHR13900:SF0', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 1', 248289),
(382824, 'PTHR13900:SF3', NULL, NULL, NULL, NULL, 'BNAA01G26290D PROTEIN', 248289),
(382825, 'PTHR13900:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 1-LIKE', 248289),
(382826, 'PTHR28088', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR HAA1-RELATED', 248290),
(382827, 'PTHR28088:SF8', NULL, NULL, NULL, NULL, 'COPPER FIST DNA BINDING DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_6G07780)', 248290),
(382828, 'PTHR28088:SF7', NULL, NULL, NULL, NULL, 'METAL-BINDING ACTIVATOR 1', 248290),
(382829, 'PTHR28088:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR HAA1-RELATED', 248290),
(382830, 'PTHR35774:SF1', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REACTION CENTER PROTEIN M', 248291),
(382831, 'PTHR35774', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REACTION CENTER PROTEIN M', 248291),
(382832, 'PTHR21590:SF6', NULL, NULL, NULL, NULL, '', 248292),
(382833, 'PTHR21590', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248292),
(382834, 'PTHR21590:SF4', NULL, NULL, NULL, NULL, 'UPF0606 PROTEIN KIAA1549', 248292),
(382835, 'PTHR21590:SF3', NULL, NULL, NULL, NULL, 'UPF0606 PROTEIN KIAA1549L', 248292),
(382836, 'PTHR43908:SF9', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 248293),
(382837, 'PTHR43908:SF4', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY B MEMBER 14', 248293),
(382838, 'PTHR43908:SF3', NULL, NULL, NULL, NULL, 'AT29763P-RELATED', 248293),
(382839, 'PTHR43908:SF2', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 18', 248293),
(382840, 'PTHR43908', NULL, NULL, NULL, NULL, 'AT29763P-RELATED', 248293),
(382841, 'PTHR43908:SF8', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY B MEMBER 12', 248293),
(382842, 'PTHR43908:SF11', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ 49-LIKE', 248293),
(382843, 'PTHR43908:SF6', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN DDB_G0295729', 248293),
(382844, 'PTHR43908:SF5', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ 49', 248293),
(382845, 'PTHR43908:SF10', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 248293),
(382846, 'PTHR21547', NULL, NULL, NULL, NULL, 'CLUSTERIN ASSOCIATED PROTEIN 1', 248294),
(382847, 'PTHR21547:SF0', NULL, NULL, NULL, NULL, 'CLUSTERIN-ASSOCIATED PROTEIN 1', 248294);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(382848, 'PTHR42693:SF27', NULL, NULL, NULL, NULL, 'ARYLSULFATASE B [PRECURSOR]', 248295),
(382849, 'PTHR42693:SF16', NULL, NULL, NULL, NULL, 'ARYLSULFATASE H', 248295),
(382850, 'PTHR42693:SF15', NULL, NULL, NULL, NULL, 'ARYLSULFATASE', 248295),
(382851, 'PTHR42693', NULL, NULL, NULL, NULL, 'ARYLSULFATASE FAMILY MEMBER', 248295),
(382852, 'PTHR42693:SF46', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_5G12940)-RELATED', 248295),
(382853, 'PTHR42693:SF12', NULL, NULL, NULL, NULL, 'ARYLSULFATASE D', 248295),
(382854, 'PTHR42693:SF45', NULL, NULL, NULL, NULL, 'ENDO-4-O-SULFATASE', 248295),
(382855, 'PTHR42693:SF9', NULL, NULL, NULL, NULL, 'STERYL-SULFATASE', 248295),
(382856, 'PTHR42693:SF33', NULL, NULL, NULL, NULL, 'ARYLSULFATASE G-RELATED', 248295),
(382857, 'PTHR42693:SF11', NULL, NULL, NULL, NULL, 'ARYLSULFATASE A', 248295),
(382858, 'PTHR42693:SF44', NULL, NULL, NULL, NULL, 'SULFATASE DOMAIN-CONTAINING PROTEIN', 248295),
(382859, 'PTHR42693:SF32', NULL, NULL, NULL, NULL, 'SULFATASE DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_2G17610)', 248295),
(382860, 'PTHR42693:SF43', NULL, NULL, NULL, NULL, 'BLL2667 PROTEIN', 248295),
(382861, 'PTHR42693:SF42', NULL, NULL, NULL, NULL, 'SULFATASE ASLA-RELATED', 248295),
(382862, 'PTHR42693:SF5', NULL, NULL, NULL, NULL, 'ARYLSULFATASE L', 248295),
(382863, 'PTHR42693:SF2', NULL, NULL, NULL, NULL, 'ARYLSULFATASE F', 248295),
(382864, 'PTHR16983:SF28', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 6 COMPLEX, LOCUS M', 248296),
(382865, 'PTHR16983:SF27', NULL, NULL, NULL, NULL, 'LY-6/NEUROTOXIN-LIKE PROTEIN 1', 248296),
(382866, 'PTHR16983:SF16', NULL, NULL, NULL, NULL, 'UPAR/LY6 DOMAIN-CONTAINING PROTEIN', 248296),
(382867, 'PTHR16983:SF31', NULL, NULL, NULL, NULL, 'PROSTATE AND TESTIS EXPRESSED PROTEIN Q-RELATED', 248296),
(382868, 'PTHR16983:SF10', NULL, NULL, NULL, NULL, 'PROSTATE STEM CELL ANTIGEN-LIKE', 248296),
(382869, 'PTHR16983:SF30', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 6E-RELATED', 248296),
(382870, 'PTHR16983:SF13', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 6E', 248296),
(382871, 'PTHR16983:SF14', NULL, NULL, NULL, NULL, 'SECRETED LY-6/UPAR DOMAIN-CONTAINING PROTEIN 2', 248296),
(382872, 'PTHR16983', NULL, NULL, NULL, NULL, 'UPAR/LY6 DOMAIN-CONTAINING PROTEIN', 248296),
(382873, 'PTHR16983:SF12', NULL, NULL, NULL, NULL, 'GLYCOSYLPHOSPHATIDYLINOSITOL-ANCHORED HIGH DENSITY LIPOPROTEIN-BINDING PROTEIN 1', 248296),
(382874, 'PTHR16983:SF1', NULL, NULL, NULL, NULL, 'PROSTATE STEM CELL ANTIGEN', 248296),
(382875, 'PTHR47282:SF1', NULL, NULL, NULL, NULL, 'PGC-1 AND ERR-INDUCED REGULATOR IN MUSCLE PROTEIN 1', 248297),
(382876, 'PTHR47282', NULL, NULL, NULL, NULL, 'PGC-1 AND ERR-INDUCED REGULATOR IN MUSCLE PROTEIN 1', 248297),
(382877, 'PTHR30411', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248298),
(382878, 'PTHR30411:SF0', NULL, NULL, NULL, NULL, 'CYS-TRNA(PRO)/CYS-TRNA(CYS) DEACYLASE YBAK', 248298),
(382879, 'PTHR30411:SF1', NULL, NULL, NULL, NULL, 'YBAK / PROLYL-TRNA SYNTHETASES ASSOCIATED DOMAIN CONTAINING PROTEIN', 248298),
(382880, 'PTHR30411:SF9', NULL, NULL, NULL, NULL, 'PROLYL-TRNA SYNTHETASE ASSOCIATED DOMAIN-CONTAINING PROTEIN 1', 248298),
(382881, 'PTHR30411:SF4', NULL, NULL, NULL, NULL, 'YBAK/AMINOACYL-TRNA SYNTHETASE-ASSOCIATED DOMAIN-CONTAINING PROTEIN', 248298),
(382882, 'PTHR36966', NULL, NULL, NULL, NULL, 'REP-ASSOCIATED TYROSINE TRANSPOSASE', 248299),
(382883, 'PTHR36966:SF1', NULL, NULL, NULL, NULL, 'REP-ASSOCIATED TYROSINE TRANSPOSASE', 248299),
(382884, 'PTHR13932:SF5', NULL, NULL, NULL, NULL, 'HEME CHAPERONE-RELATED', 248300),
(382885, 'PTHR13932:SF6', NULL, NULL, NULL, NULL, 'OXYGEN-INDEPENDENT COPROPORPHYRINOGEN III OXIDASE', 248300),
(382886, 'PTHR13932:SF10', NULL, NULL, NULL, NULL, 'RADICAL S-ADENOSYL METHIONINE DOMAIN-CONTAINING PROTEIN 1, MITOCHONDRIAL', 248300),
(382887, 'PTHR13932:SF9', NULL, NULL, NULL, NULL, 'COPROPORPHYRINOGEN III OXIDASE-RELATED', 248300),
(382888, 'PTHR13932', NULL, NULL, NULL, NULL, 'COPROPORPHYRINIGEN III OXIDASE', 248300),
(382889, 'PTHR13932:SF1', NULL, NULL, NULL, NULL, 'OXYGEN-INDEPENDENT COPROPORPHYRINOGEN-III OXIDASE-LIKE PROTEIN HEMZ', 248300);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(382890, 'PTHR12305:SF96', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 3,4,5-TRISPHOSPHATE 3-PHOSPHATASE AND PROTEIN-TYROSINE-PHOSPHATASE PTEN2A', 248301),
(382891, 'PTHR12305:SF52', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 3,4,5-TRISPHOSPHATE 3-PHOSPHATASE CNRN', 248301),
(382892, 'PTHR12305:SF84', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-3,4,5-TRISPHOSPHATE 3-PHOSPHATASE', 248301),
(382893, 'PTHR12305:SF87', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 3,4,5-TRISPHOSPHATE 3-PHOSPHATASE AND PROTEIN-TYROSINE-PHOSPHATASE PTEN2B', 248301),
(382894, 'PTHR12305:SF97', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-3,4,5-TRISPHOSPHATE 3-PHOSPHATASE', 248301),
(382895, 'PTHR12305', NULL, NULL, NULL, NULL, 'PHOSPHATASE WITH HOMOLOGY TO TENSIN', 248301),
(382896, 'PTHR12305:SF88', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 3,4,5-TRISPHOSPHATE 3-PHOSPHATASE AND PROTEIN-TYROSINE-PHOSPHATASE PTEN2A-LIKE', 248301),
(382897, 'PTHR12305:SF81', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 3,4,5-TRISPHOSPHATE 3-PHOSPHATASE AND DUAL-SPECIFICITY PROTEIN PHOSPHATASE PTEN', 248301),
(382898, 'PTHR12305:SF91', NULL, NULL, NULL, NULL, 'BNAA01G26130D PROTEIN', 248301),
(382899, 'PTHR12305:SF94', NULL, NULL, NULL, NULL, '', 248301),
(382900, 'PTHR12305:SF60', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 3,4,5-TRISPHOSPHATE 3-PHOSPHATASE TPTE2-RELATED', 248301),
(382901, 'PTHR12305:SF93', NULL, NULL, NULL, NULL, 'BNAC06G12600D PROTEIN', 248301),
(382902, 'PTHR39741:SF12', NULL, NULL, NULL, NULL, 'BNAA09G51760D PROTEIN', 248302),
(382903, 'PTHR39741:SF6', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248302),
(382904, 'PTHR39741:SF18', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', 248302),
(382905, 'PTHR39741', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', 248302),
(382906, 'PTHR39741:SF14', NULL, NULL, NULL, NULL, 'F-BOX FAMILY PROTEIN', 248302),
(382907, 'PTHR39741:SF17', NULL, NULL, NULL, NULL, 'F-BOX FAMILY PROTEIN', 248302),
(382908, 'PTHR39741:SF16', NULL, NULL, NULL, NULL, 'F-BOX FAMILY PROTEIN', 248302),
(382909, 'PTHR39741:SF2', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248302),
(382910, 'PTHR46105:SF16', NULL, NULL, NULL, NULL, 'BCL6B TRANSCRIPTION REPRESSOR', 248303),
(382911, 'PTHR46105:SF17', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN CONTAINING 34', 248303),
(382912, 'PTHR46105:SF18', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING 37', 248303),
(382913, 'PTHR46105:SF19', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING 22B', 248303),
(382914, 'PTHR46105:SF12', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 8A', 248303),
(382915, 'PTHR46105:SF13', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 9', 248303),
(382916, 'PTHR46105:SF14', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 22', 248303),
(382917, 'PTHR46105:SF15', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 43', 248303),
(382918, 'PTHR46105:SF9', NULL, NULL, NULL, NULL, 'BTB AND CNC HOMOLOGY 1, BASIC LEUCINE ZIPPER TRANSCRIPTION FACTOR 1 A', 248303),
(382919, 'PTHR46105:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REGULATOR PROTEIN BACH2', 248303),
(382920, 'PTHR46105:SF10', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 248303),
(382921, 'PTHR46105:SF7', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 7C', 248303),
(382922, 'PTHR46105:SF11', NULL, NULL, NULL, NULL, 'PLZFA', 248303),
(382923, 'PTHR46105', NULL, NULL, NULL, NULL, 'AGAP004733-PA', 248303),
(382924, 'PTHR46105:SF2', NULL, NULL, NULL, NULL, 'NUCLEUS ACCUMBENS-ASSOCIATED PROTEIN 2', 248303),
(382925, 'PTHR46105:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REGULATOR PROTEIN BACH1', 248303),
(382926, 'PTHR46105:SF6', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 7A', 248303),
(382927, 'PTHR46105:SF5', NULL, NULL, NULL, NULL, 'AGAP004733-PA', 248303),
(382928, 'PTHR46105:SF4', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 7B', 248303); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(382929, 'PTHR46105:SF3', NULL, NULL, NULL, NULL, 'NUCLEUS ACCUMBENS-ASSOCIATED PROTEIN 1', 248303),
(382930, 'PTHR47515', NULL, NULL, NULL, NULL, 'LOW CALCIUM RESPONSE LOCUS PROTEIN T', 248304),
(382931, 'PTHR47515:SF1', NULL, NULL, NULL, NULL, 'TRANSPOSASE-RELATED', 248304),
(382932, 'PTHR47515:SF2', NULL, NULL, NULL, NULL, 'LOW CALCIUM RESPONSE LOCUS PROTEIN T', 248304),
(382933, 'PTHR46259:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER CCHC-TYPE AND RNA-BINDING MOTIF-CONTAINING PROTEIN 1', 248305),
(382934, 'PTHR46259:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER CCHC-TYPE AND RNA-BINDING MOTIF-CONTAINING PROTEIN 1', 248305),
(382935, 'PTHR46259:SF3', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 248305),
(382936, 'PTHR46259', NULL, NULL, NULL, NULL, 'ZINC FINGER CCHC-TYPE AND RNA-BINDING MOTIF-CONTAINING PROTEIN 1', 248305),
(382937, 'PTHR15993:SF6', NULL, NULL, NULL, NULL, 'HEMOGEN', 248306),
(382938, 'PTHR15993', NULL, NULL, NULL, NULL, 'HEMOGEN', 248306),
(382939, 'PTHR30437', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR GREA', 248307),
(382940, 'PTHR30437:SF5', NULL, NULL, NULL, NULL, 'REGULATOR OF NUCLEOSIDE DIPHOSPHATE KINASE', 248307),
(382941, 'PTHR30437:SF4', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR GREA', 248307),
(382942, 'PTHR30437:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR GREB', 248307),
(382943, 'PTHR11740:SF0', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT BETA', 248308),
(382944, 'PTHR11740:SF31', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT BETA', 248308),
(382945, 'PTHR11740:SF21', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT BETA', 248308),
(382946, 'PTHR11740:SF32', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT BETA', 248308),
(382947, 'PTHR11740:SF40', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT BETA', 248308),
(382948, 'PTHR11740:SF41', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT BETA-1', 248308),
(382949, 'PTHR11740:SF5', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT BETA', 248308),
(382950, 'PTHR11740:SF35', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT BETA-4-RELATED', 248308),
(382951, 'PTHR11740', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT BETA', 248308),
(382952, 'PTHR11740:SF36', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT BETA', 248308),
(382953, 'PTHR11740:SF22', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT BETA-3', 248308),
(382954, 'PTHR11740:SF34', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT BETA', 248308),
(382955, 'PTHR11740:SF39', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT BETA''', 248308),
(382956, 'PTHR11740:SF28', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT BETA', 248308),
(382957, 'PTHR11740:SF29', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT BETA', 248308),
(382958, 'PTHR11740:SF26', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT BETA', 248308),
(382959, 'PTHR11740:SF37', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT BETA', 248308),
(382960, 'PTHR11740:SF38', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT BETA', 248308),
(382961, 'PTHR11740:SF27', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT BETA', 248308),
(382962, 'PTHR28015:SF1', NULL, NULL, NULL, NULL, 'ATP SYNTHASE ASSEMBLY FACTOR FMC1, MITOCHONDRIAL', 248309),
(382963, 'PTHR28015', NULL, NULL, NULL, NULL, 'ATP SYNTHASE ASSEMBLY FACTOR FMC1, MITOCHONDRIAL', 248309),
(382964, 'PTHR31128:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG25559', 248310),
(382965, 'PTHR31128', NULL, NULL, NULL, NULL, 'PROTEIN CBR-CLEC-135-RELATED', 248310),
(382966, 'PTHR31128:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG12549', 248310),
(382967, 'PTHR31128:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG02793', 248310),
(382968, 'PTHR31128:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG04039', 248310),
(382969, 'PTHR43737:SF1', NULL, NULL, NULL, NULL, 'CBM6 DOMAIN-CONTAINING PROTEIN', 248311),
(382970, 'PTHR43737', NULL, NULL, NULL, NULL, 'BLL7424 PROTEIN', 248311),
(382971, 'PTHR31282:SF24', NULL, NULL, NULL, NULL, 'OS05G0478700 PROTEIN', 248312),
(382972, 'PTHR31282:SF214', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 248312);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(382973, 'PTHR31282:SF215', NULL, NULL, NULL, NULL, 'OS05G0478400 PROTEIN', 248312),
(382974, 'PTHR31282:SF25', NULL, NULL, NULL, NULL, 'OS12G0116700 PROTEIN', 248312),
(382975, 'PTHR31282:SF216', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 69-RELATED', 248312),
(382976, 'PTHR31282:SF139', NULL, NULL, NULL, NULL, 'OS04G0605100 PROTEIN', 248312),
(382977, 'PTHR31282:SF217', NULL, NULL, NULL, NULL, 'FACTOR, PUTATIVE-RELATED', 248312),
(382978, 'PTHR31282:SF218', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 248312),
(382979, 'PTHR31282', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 21-RELATED', 248312),
(382980, 'PTHR31282:SF174', NULL, NULL, NULL, NULL, 'OS03G0321700 PROTEIN', 248312),
(382981, 'PTHR31282:SF177', NULL, NULL, NULL, NULL, 'WRKY DOMAIN, ZN-CLUSTER DOMAIN PROTEIN-RELATED', 248312),
(382982, 'PTHR31282:SF133', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 1', 248312),
(382983, 'PTHR31282:SF210', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 70-RELATED', 248312),
(382984, 'PTHR31282:SF134', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 248312),
(382985, 'PTHR31282:SF211', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 55', 248312),
(382986, 'PTHR31282:SF212', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 7-RELATED', 248312),
(382987, 'PTHR31282:SF136', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 248312),
(382988, 'PTHR31282:SF213', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 11-RELATED', 248312),
(382989, 'PTHR31282:SF171', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 248312),
(382990, 'PTHR31282:SF70', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 15-RELATED', 248312),
(382991, 'PTHR31282:SF73', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 30-RELATED', 248312),
(382992, 'PTHR31282:SF32', NULL, NULL, NULL, NULL, 'WRKY DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 248312),
(382993, 'PTHR31282:SF79', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 248312),
(382994, 'PTHR31282:SF78', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 248312),
(382995, 'PTHR31282:SF34', NULL, NULL, NULL, NULL, 'OS11G0685700 PROTEIN', 248312),
(382996, 'PTHR31282:SF203', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 38-RELATED', 248312),
(382997, 'PTHR31282:SF36', NULL, NULL, NULL, NULL, 'OS11G0117600 PROTEIN', 248312),
(382998, 'PTHR31282:SF204', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 248312),
(382999, 'PTHR31282:SF205', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 248312),
(383000, 'PTHR31282:SF128', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 21-RELATED', 248312),
(383001, 'PTHR31282:SF206', NULL, NULL, NULL, NULL, 'WRKY FAMILY TRANSCRIPTION FACTOR', 248312),
(383002, 'PTHR31282:SF207', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR WRKY FAMILY-RELATED', 248312),
(383003, 'PTHR31282:SF208', NULL, NULL, NULL, NULL, 'OS02G0462800 PROTEIN', 248312),
(383004, 'PTHR31282:SF209', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 248312),
(383005, 'PTHR31282:SF162', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 248312),
(383006, 'PTHR31282:SF163', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 248312),
(383007, 'PTHR31282:SF7', NULL, NULL, NULL, NULL, 'OS12G0116400 PROTEIN', 248312),
(383008, 'PTHR31282:SF164', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 248312),
(383009, 'PTHR31282:SF5', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 30-RELATED', 248312),
(383010, 'PTHR31282:SF165', NULL, NULL, NULL, NULL, 'WRKY DOMAIN, ZN-CLUSTER DOMAIN PROTEIN-RELATED', 248312),
(383011, 'PTHR31282:SF121', NULL, NULL, NULL, NULL, 'WRKY DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 248312),
(383012, 'PTHR31282:SF200', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN-RELATED', 248312),
(383013, 'PTHR31282:SF201', NULL, NULL, NULL, NULL, 'OS03G0798500 PROTEIN', 248312),
(383014, 'PTHR31282:SF9', NULL, NULL, NULL, NULL, 'OS05G0129800 PROTEIN', 248312),
(383015, 'PTHR31282:SF202', NULL, NULL, NULL, NULL, 'OS05G0321900 PROTEIN', 248312);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(383016, 'PTHR31282:SF125', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 248312),
(383017, 'PTHR31282:SF169', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 27-RELATED', 248312),
(383018, 'PTHR31282:SF80', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 248312),
(383019, 'PTHR31282:SF160', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 248312),
(383020, 'PTHR31282:SF83', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 248312),
(383021, 'PTHR31282:SF85', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 248312),
(383022, 'PTHR31282:SF87', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 248312),
(383023, 'PTHR31282:SF89', NULL, NULL, NULL, NULL, 'WRKY DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 248312),
(383024, 'PTHR31282:SF159', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 248312),
(383025, 'PTHR31282:SF115', NULL, NULL, NULL, NULL, 'WRKY DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 248312),
(383026, 'PTHR31282:SF116', NULL, NULL, NULL, NULL, 'WRKY74-SUPERFAMILY OF TFS HAVING WRKY AND ZINC FINGER DOMAINS', 248312),
(383027, 'PTHR31282:SF118', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 248312),
(383028, 'PTHR31282:SF119', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 248312),
(383029, 'PTHR31282:SF152', NULL, NULL, NULL, NULL, 'WRKY DNA-BINDING PROTEIN 54-RELATED', 248312),
(383030, 'PTHR31282:SF196', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 248312),
(383031, 'PTHR31282:SF153', NULL, NULL, NULL, NULL, 'OS05G0233100 PROTEIN', 248312),
(383032, 'PTHR31282:SF110', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 70-RELATED', 248312),
(383033, 'PTHR31282:SF198', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 248312),
(383034, 'PTHR31282:SF199', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 248312),
(383035, 'PTHR31282:SF155', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 65-RELATED', 248312),
(383036, 'PTHR31282:SF112', NULL, NULL, NULL, NULL, 'WRKY DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 248312),
(383037, 'PTHR31282:SF156', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 11-RELATED', 248312),
(383038, 'PTHR31282:SF158', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 248312),
(383039, 'PTHR31282:SF114', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR WRKY FAMILY-RELATED', 248312),
(383040, 'PTHR31282:SF190', NULL, NULL, NULL, NULL, 'OS12G0597700 PROTEIN', 248312),
(383041, 'PTHR31282:SF191', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 248312),
(383042, 'PTHR31282:SF193', NULL, NULL, NULL, NULL, 'WRKY DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 248312),
(383043, 'PTHR31282:SF93', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 248312),
(383044, 'PTHR31282:SF194', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 74-RELATED', 248312),
(383045, 'PTHR31282:SF96', NULL, NULL, NULL, NULL, 'OS01G0820900 PROTEIN', 248312),
(383046, 'PTHR31282:SF98', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 248312),
(383047, 'PTHR31282:SF10', NULL, NULL, NULL, NULL, 'OS01G0821600 PROTEIN', 248312),
(383048, 'PTHR31282:SF15', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR WRKY FAMILY-RELATED', 248312),
(383049, 'PTHR31282:SF148', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 15-RELATED', 248312),
(383050, 'PTHR31282:SF104', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 17-RELATED', 248312),
(383051, 'PTHR31282:SF14', NULL, NULL, NULL, NULL, 'OS05G0322900 PROTEIN', 248312),
(383052, 'PTHR31282:SF106', NULL, NULL, NULL, NULL, 'PROTEIN WRKY1', 248312),
(383053, 'PTHR31282:SF107', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 38-RELATED', 248312),
(383054, 'PTHR31282:SF108', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 41 ISOFORM X1-RELATED', 248312),
(383055, 'PTHR31282:SF19', NULL, NULL, NULL, NULL, 'OS07G0680400 PROTEIN', 248312),
(383056, 'PTHR31282:SF143', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 70-RELATED', 248312),
(383057, 'PTHR31282:SF100', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 248312);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(383058, 'PTHR31282:SF189', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 39-RELATED', 248312),
(383059, 'PTHR31282:SF147', NULL, NULL, NULL, NULL, 'OS01G0820700 PROTEIN', 248312),
(383060, 'PTHR46244:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE-DEPENDENT PHOSPHOTRANSFERASE SYSTEM', 248313),
(383061, 'PTHR46244', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE-PROTEIN PHOSPHOTRANSFERASE', 248313),
(383062, 'PTHR46244:SF5', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE-PROTEIN PHOSPHOTRANSFERASE', 248313),
(383063, 'PTHR46244:SF3', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE-PROTEIN PHOSPHOTRANSFERASE', 248313),
(383064, 'PTHR46244:SF4', NULL, NULL, NULL, NULL, 'MULTIPHOSPHORYL TRANSFER PROTEIN 1-RELATED', 248313),
(383065, 'PTHR28526', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT 13', 248314),
(383066, 'PTHR28526:SF1', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT 13', 248314),
(383067, 'PTHR38160:SF3', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 40', 248315),
(383068, 'PTHR38160:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 40', 248315),
(383069, 'PTHR38160', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 40', 248315),
(383070, 'PTHR45888', NULL, NULL, NULL, NULL, 'HL01030P-RELATED', 248316),
(383071, 'PTHR45888:SF10', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN DPF3', 248316),
(383072, 'PTHR45888:SF8', NULL, NULL, NULL, NULL, 'FHA DOMAIN-CONTAINING PROTEIN-RELATED', 248316),
(383073, 'PTHR45888:SF9', NULL, NULL, NULL, NULL, 'HMG1/2 (HIGH MOBILITY GROUP) BOX-CONTAINING PROTEIN-RELATED', 248316),
(383074, 'PTHR45888:SF12', NULL, NULL, NULL, NULL, 'CNN_1N DOMAIN-CONTAINING PROTEIN', 248316),
(383075, 'PTHR45888:SF6', NULL, NULL, NULL, NULL, 'HL01030P', 248316),
(383076, 'PTHR45888:SF7', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN UBI-D4', 248316),
(383077, 'PTHR45888:SF11', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN NEURO-D4', 248316),
(383078, 'PTHR45888:SF4', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN 10', 248316),
(383079, 'PTHR45888:SF5', NULL, NULL, NULL, NULL, 'D4, ISOFORM A-RELATED', 248316),
(383080, 'PTHR45888:SF2', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE 2D', 248316),
(383081, 'PTHR45888:SF1', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE 2C', 248316),
(383082, 'PTHR14471:SF5', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MARCHF10-RELATED', 248317),
(383083, 'PTHR14471', NULL, NULL, NULL, NULL, 'MARCH7/10 E3 UBIQUITIN PROTEIN LIGASE FAMILY MEMBER', 248317),
(383084, 'PTHR14471:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MARCHF7', 248317),
(383085, 'PTHR42714:SF2', NULL, NULL, NULL, NULL, 'TRNA MODIFICATION GTPASE GTPBP3, MITOCHONDRIAL', 248318),
(383086, 'PTHR42714:SF6', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR IF-2', 248318),
(383087, 'PTHR42714:SF3', NULL, NULL, NULL, NULL, 'HFLX-TYPE G DOMAIN-CONTAINING PROTEIN', 248318),
(383088, 'PTHR42714', NULL, NULL, NULL, NULL, 'TRNA MODIFICATION GTPASE GTPBP3', 248318),
(383089, 'PTHR42714:SF7', NULL, NULL, NULL, NULL, 'G DOMAIN-CONTAINING PROTEIN', 248318),
(383090, 'PTHR43495:SF1', NULL, NULL, NULL, NULL, 'L-ASPARAGINE PERMEASE', 248319),
(383091, 'PTHR43495:SF6', NULL, NULL, NULL, NULL, 'AA_PERMEASE DOMAIN-CONTAINING PROTEIN', 248319),
(383092, 'PTHR43495:SF7', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN YIFK-RELATED', 248319),
(383093, 'PTHR43495', NULL, NULL, NULL, NULL, 'GABA PERMEASE', 248319),
(383094, 'PTHR43495:SF4', NULL, NULL, NULL, NULL, 'AROMATIC AMINO ACID TRANSPORT PROTEIN AROP', 248319),
(383095, 'PTHR43495:SF5', NULL, NULL, NULL, NULL, 'GABA PERMEASE', 248319),
(383096, 'PTHR43495:SF2', NULL, NULL, NULL, NULL, 'D-SERINE/D-ALANINE/GLYCINE TRANSPORTER', 248319),
(383097, 'PTHR43495:SF3', NULL, NULL, NULL, NULL, 'PHENYLALANINE-SPECIFIC PERMEASE', 248319),
(383098, 'PTHR24417', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE LMTK1', 248320),
(383099, 'PTHR24417:SF8', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE LMTK2', 248320);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(383100, 'PTHR24417:SF7', NULL, NULL, NULL, NULL, 'CHROMATIN MODIFICATION-RELATED PROTEIN EAF1', 248320),
(383101, 'PTHR24417:SF2', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE LMTK3', 248320),
(383102, 'PTHR24417:SF0', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE LMTK1', 248320),
(383103, 'PTHR45495', NULL, NULL, NULL, NULL, 'DNAJ PROTEIN JJJ1 HOMOLOG', 248321),
(383104, 'PTHR45495:SF1', NULL, NULL, NULL, NULL, 'DNAJ PROTEIN JJJ1 HOMOLOG', 248321),
(383105, 'PTHR24401', NULL, NULL, NULL, NULL, 'SI:CH211-243P7.3-RELATED', 248322),
(383106, 'PTHR24401:SF29', NULL, NULL, NULL, NULL, 'SI:CH211-243P7.3-RELATED', 248322),
(383107, 'PTHR40942', NULL, NULL, NULL, NULL, '', 248323),
(383108, 'PTHR40942:SF4', NULL, NULL, NULL, NULL, 'CYTOCHROME C5', 248323),
(383109, 'PTHR40942:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME-RELATED', 248323),
(383110, 'PTHR21656', NULL, NULL, NULL, NULL, 'MALE-SPECIFIC LETHAL-1 PROTEIN', 248324),
(383111, 'PTHR21656:SF2', NULL, NULL, NULL, NULL, 'MALE-SPECIFIC LETHAL 1 HOMOLOG', 248324),
(383112, 'PTHR43660:SF1', NULL, NULL, NULL, NULL, 'DIPEPTIDYL CARBOXYPEPTIDASE', 248325),
(383113, 'PTHR43660', NULL, NULL, NULL, NULL, 'DIPEPTIDYL CARBOXYPEPTIDASE', 248325),
(383114, 'PTHR30404:SF5', NULL, NULL, NULL, NULL, 'SPORULATION-SPECIFIC N-ACETYLMURAMOYL-L-ALANINE AMIDASE', 248326),
(383115, 'PTHR30404:SF6', NULL, NULL, NULL, NULL, 'N-ACETYLMURAMOYL-L-ALANINE AMIDASE AMIB', 248326),
(383116, 'PTHR30404:SF0', NULL, NULL, NULL, NULL, 'N-ACETYLMURAMOYL-L-ALANINE AMIDASE AMIC', 248326),
(383117, 'PTHR30404', NULL, NULL, NULL, NULL, 'N-ACETYLMURAMOYL-L-ALANINE AMIDASE', 248326),
(383118, 'PTHR30404:SF2', NULL, NULL, NULL, NULL, 'N-ACETYLMURAMOYL-L-ALANINE AMIDASE AMIA', 248326),
(383119, 'PTHR42354', NULL, NULL, NULL, NULL, '', 248327),
(383120, 'PTHR42354:SF1', NULL, NULL, NULL, NULL, '', 248327),
(383121, 'PTHR37219', NULL, NULL, NULL, NULL, 'PROTEIN PALE CRESS, CHLOROPLASTIC', 248328),
(383122, 'PTHR37219:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PALE CRESS, CHLOROPLASTIC', 248328),
(383123, 'PTHR41155', NULL, NULL, NULL, NULL, 'FI19525P1', 248329),
(383124, 'PTHR41155:SF1', NULL, NULL, NULL, NULL, 'FI19525P1', 248329),
(383125, 'PTHR31824', NULL, NULL, NULL, NULL, 'PROTEIN CBG17809', 248330),
(383126, 'PTHR31824:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG03903', 248330),
(383127, 'PTHR31824:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG17809', 248330),
(383128, 'PTHR33437', NULL, NULL, NULL, NULL, 'OS06G0361200 PROTEIN', 248331),
(383129, 'PTHR33437:SF3', NULL, NULL, NULL, NULL, '', 248331),
(383130, 'PTHR33437:SF2', NULL, NULL, NULL, NULL, 'OS06G0361200 PROTEIN', 248331),
(383131, 'PTHR45510:SF1', NULL, NULL, NULL, NULL, 'RHODANESE-LIKE DOMAIN-CONTAINING PROTEIN 10', 248332),
(383132, 'PTHR45510', NULL, NULL, NULL, NULL, 'RHODANESE-LIKE DOMAIN-CONTAINING PROTEIN 10', 248332),
(383133, 'PTHR34920', NULL, NULL, NULL, NULL, 'B-CELL LYMPHOMA/LEUKEMIA 10', 248333),
(383134, 'PTHR34920:SF1', NULL, NULL, NULL, NULL, 'B-CELL LYMPHOMA/LEUKEMIA 10', 248333),
(383135, 'PTHR10332:SF59', NULL, NULL, NULL, NULL, 'OS07G0557200 PROTEIN', 248334),
(383136, 'PTHR10332:SF38', NULL, NULL, NULL, NULL, 'EQUILIBRATIVE NUCLEOTIDE TRANSPORTER 3-RELATED', 248334),
(383137, 'PTHR10332:SF17', NULL, NULL, NULL, NULL, 'EQUILIBRATIVE NUCLEOSIDE TRANSPORTER 3', 248334),
(383138, 'PTHR10332:SF77', NULL, NULL, NULL, NULL, 'EQUILIBRATIVE NUCLEOTIDE TRANSPORTER 8', 248334),
(383139, 'PTHR10332:SF79', NULL, NULL, NULL, NULL, 'BNAA09G19940D PROTEIN', 248334),
(383140, 'PTHR10332:SF36', NULL, NULL, NULL, NULL, 'EQUILIBRATIVE NUCLEOSIDE TRANSPORTER', 248334),
(383141, 'PTHR10332:SF30', NULL, NULL, NULL, NULL, 'EQUILIBRATIVE NUCLEOTIDE TRANSPORTER 2', 248334),
(383142, 'PTHR10332:SF75', NULL, NULL, NULL, NULL, 'EQUILIBRATIVE NUCLEOSIDE TRANSPORTER, MAJOR FACILITATOR SUPERFAMILY DOMAIN PROTEIN-RELATED', 248334),
(383143, 'PTHR10332:SF76', NULL, NULL, NULL, NULL, 'EQUILIBRATIVE NUCLEOSIDE TRANSPORTER, MAJOR FACILITATOR SUPERFAMILY DOMAIN PROTEIN-RELATED', 248334),
(383144, 'PTHR10332:SF10', NULL, NULL, NULL, NULL, 'EQUILIBRATIVE NUCLEOSIDE TRANSPORTER 4', 248334);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(383145, 'PTHR10332:SF71', NULL, NULL, NULL, NULL, 'BNACNNG04420D PROTEIN', 248334),
(383146, 'PTHR10332:SF26', NULL, NULL, NULL, NULL, 'EQUILIBRATIVE NUCLEOSIDE TRANSPORTER', 248334),
(383147, 'PTHR10332:SF28', NULL, NULL, NULL, NULL, 'EQUILIBRATIVE NUCLEOSIDE TRANSPORTER', 248334),
(383148, 'PTHR10332:SF88', NULL, NULL, NULL, NULL, 'EQUILIBRATIVE NUCLEOSIDE TRANSPORTER 1, ISOFORM A', 248334),
(383149, 'PTHR10332:SF67', NULL, NULL, NULL, NULL, 'EQUILIBRATIVE NUCLEOTIDE TRANSPORTER 4', 248334),
(383150, 'PTHR10332:SF84', NULL, NULL, NULL, NULL, 'OS07G0557100 PROTEIN', 248334),
(383151, 'PTHR10332:SF63', NULL, NULL, NULL, NULL, 'EQUILIBRATIVE NUCLEOTIDE TRANSPORTER 2', 248334),
(383152, 'PTHR10332:SF85', NULL, NULL, NULL, NULL, 'EQUILIBRATIVE NUCLEOSIDE TRANSPORTER', 248334),
(383153, 'PTHR10332:SF86', NULL, NULL, NULL, NULL, 'EQUILIBRATIVE NUCLEOSIDE TRANSPORTER 6', 248334),
(383154, 'PTHR10332:SF87', NULL, NULL, NULL, NULL, 'EQUILIBRATIVE NUCLEOTIDE TRANSPORTER 3-LIKE', 248334),
(383155, 'PTHR10332:SF65', NULL, NULL, NULL, NULL, 'EQUILIBRATIVE NUCLEOTIDE TRANSPORTER 7', 248334),
(383156, 'PTHR10332:SF80', NULL, NULL, NULL, NULL, 'EQUILIBRATIVE NUCLEOSIDE TRANSPORTER 2, ISOFORM A', 248334),
(383157, 'PTHR10332:SF81', NULL, NULL, NULL, NULL, 'BNAANNG16100D PROTEIN', 248334),
(383158, 'PTHR10332:SF82', NULL, NULL, NULL, NULL, 'TRANSPORTER 2, PUTATIVE-RELATED', 248334),
(383159, 'PTHR10332:SF9', NULL, NULL, NULL, NULL, 'EQUILIBRATIVE NUCLEOSIDE TRANSPORTER 1', 248334),
(383160, 'PTHR10332:SF8', NULL, NULL, NULL, NULL, 'EQUILIBRATIVE NUCLEOSIDE TRANSPORTER 2', 248334),
(383161, 'PTHR10332', NULL, NULL, NULL, NULL, 'EQUILIBRATIVE NUCLEOSIDE TRANSPORTER', 248334),
(383162, 'PTHR39460', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248335),
(383163, 'PTHR39460:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248335),
(383164, 'PTHR10970:SF4', NULL, NULL, NULL, NULL, '', 248336),
(383165, 'PTHR10970', NULL, NULL, NULL, NULL, 'CLUSTERIN', 248336),
(383166, 'PTHR10970:SF1', NULL, NULL, NULL, NULL, 'CLUSTERIN', 248336),
(383167, 'PTHR10970:SF2', NULL, NULL, NULL, NULL, 'CLUSTERIN-LIKE PROTEIN 1', 248336),
(383168, 'PTHR48159', NULL, NULL, NULL, NULL, 'MULE DOMAIN-CONTAINING PROTEIN', 248337),
(383169, 'PTHR48159:SF1', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED GIANT PROTEIN ANTIGEN, PUTATIVE-RELATED', 248337),
(383170, 'PTHR14307', NULL, NULL, NULL, NULL, 'C6ORF47 FAMILY MEMBER', 248338),
(383171, 'PTHR14307:SF0', NULL, NULL, NULL, NULL, 'SI:CH73-25F10.6', 248338),
(383172, 'PTHR31729:SF6', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 248339),
(383173, 'PTHR31729:SF7', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF008', 248339),
(383174, 'PTHR31729:SF16', NULL, NULL, NULL, NULL, 'OS04G0648900 PROTEIN', 248339),
(383175, 'PTHR31729:SF8', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF010-RELATED', 248339),
(383176, 'PTHR31729:SF12', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR', 248339),
(383177, 'PTHR31729:SF13', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF011-LIKE', 248339),
(383178, 'PTHR31729:SF14', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 248339),
(383179, 'PTHR31729', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR RAP2-1-RELATED', 248339),
(383180, 'PTHR31729:SF15', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF011-LIKE', 248339),
(383181, 'PTHR31729:SF0', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR RAP2-10', 248339),
(383182, 'PTHR31729:SF2', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR RAP2-1-RELATED', 248339),
(383183, 'PTHR31729:SF11', NULL, NULL, NULL, NULL, 'RELATED TO AP2 1-RELATED', 248339),
(383184, 'PTHR23304:SF188', NULL, NULL, NULL, NULL, '', 248340),
(383185, 'PTHR23304:SF189', NULL, NULL, NULL, NULL, '', 248340),
(383186, 'PTHR23304:SF186', NULL, NULL, NULL, NULL, '', 248340),
(383187, 'PTHR23304:SF164', NULL, NULL, NULL, NULL, 'RAMA DOMAIN-CONTAINING PROTEIN', 248340);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(383188, 'PTHR23304', NULL, NULL, NULL, NULL, 'SPOT2-RELATED', 248340),
(383189, 'PTHR23304:SF187', NULL, NULL, NULL, NULL, '', 248340),
(383190, 'PTHR23304:SF184', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 248340),
(383191, 'PTHR23304:SF185', NULL, NULL, NULL, NULL, '', 248340),
(383192, 'PTHR23304:SF183', NULL, NULL, NULL, NULL, '', 248340),
(383193, 'PTHR23304:SF159', NULL, NULL, NULL, NULL, '', 248340),
(383194, 'PTHR14885:SF1', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 43', 248341),
(383195, 'PTHR14885:SF3', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 44', 248341),
(383196, 'PTHR14885', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248341),
(383197, 'PTHR15077', NULL, NULL, NULL, NULL, 'FAS-ASSOCIATING DEATH DOMAIN-CONTAINING PROTEIN FADD', 248342),
(383198, 'PTHR15077:SF10', NULL, NULL, NULL, NULL, 'FAS-ASSOCIATED DEATH DOMAIN PROTEIN', 248342),
(383199, 'PTHR15077:SF9', NULL, NULL, NULL, NULL, 'DEATH DOMAIN-CONTAINING PROTEIN', 248342),
(383200, 'PTHR15077:SF11', NULL, NULL, NULL, NULL, 'DEATH DOMAIN-CONTAINING PROTEIN', 248342),
(383201, 'PTHR11586:SF41', NULL, NULL, NULL, NULL, 'AMINOACYL TRNA SYNTHETASE COMPLEX-INTERACTING MULTIFUNCTIONAL PROTEIN 1A', 248343),
(383202, 'PTHR11586:SF43', NULL, NULL, NULL, NULL, 'TYROSINE--TRNA LIGASE, CYTOPLASMIC', 248343),
(383203, 'PTHR11586:SF42', NULL, NULL, NULL, NULL, 'AMINOACYL TRNA SYNTHETASE COMPLEX-INTERACTING MULTIFUNCTIONAL PROTEIN 1B', 248343),
(383204, 'PTHR11586', NULL, NULL, NULL, NULL, 'TRNA-AMINOACYLATION COFACTOR ARC1 FAMILY MEMBER', 248343),
(383205, 'PTHR11586:SF37', NULL, NULL, NULL, NULL, 'TRNA-BINDING DOMAIN-CONTAINING PROTEIN', 248343),
(383206, 'PTHR11586:SF45', NULL, NULL, NULL, NULL, 'TRNA-BINDING DOMAIN-CONTAINING PROTEIN', 248343),
(383207, 'PTHR11586:SF33', NULL, NULL, NULL, NULL, 'AMINOACYL TRNA SYNTHASE COMPLEX-INTERACTING MULTIFUNCTIONAL PROTEIN 1', 248343),
(383208, 'PTHR11586:SF44', NULL, NULL, NULL, NULL, 'TRNA-BINDING DOMAIN-CONTAINING PROTEIN', 248343),
(383209, 'PTHR11586:SF35', NULL, NULL, NULL, NULL, 'TRNA-BINDING DOMAIN PROTEIN', 248343),
(383210, 'PTHR11586:SF46', NULL, NULL, NULL, NULL, 'NUCLEIC ACID-BINDING, OB-FOLD-LIKE PROTEIN', 248343),
(383211, 'PTHR39207:SF1', NULL, NULL, NULL, NULL, 'ALPHA-GLUCURONIDASE A', 248344),
(383212, 'PTHR39207', NULL, NULL, NULL, NULL, 'ALPHA-GLUCURONIDASE A', 248344),
(383213, 'PTHR41373', NULL, NULL, NULL, NULL, 'DUF2156 DOMAIN-CONTAINING PROTEIN', 248345),
(383214, 'PTHR41373:SF1', NULL, NULL, NULL, NULL, 'DUF2156 DOMAIN-CONTAINING PROTEIN', 248345),
(383215, 'PTHR33651:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG06246', 248346),
(383216, 'PTHR33651:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG24699', 248346),
(383217, 'PTHR33651', NULL, NULL, NULL, NULL, 'PROTEIN CBG06246', 248346),
(383218, 'PTHR34386:SF1', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-LIKE PROTEIN NRDH', 248347),
(383219, 'PTHR34386', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN', 248347),
(383220, 'PTHR34386:SF3', NULL, NULL, NULL, NULL, 'THIOREDOXIN/GLUTAREDOXIN 2 FAMILY PROTEIN', 248347),
(383221, 'PTHR42040', NULL, NULL, NULL, NULL, 'INNER KINETOCHORE SUBUNIT FTA4', 248348),
(383222, 'PTHR42040:SF1', NULL, NULL, NULL, NULL, 'INNER KINETOCHORE SUBUNIT FTA4', 248348),
(383223, 'PTHR39229', NULL, NULL, NULL, NULL, 'MCG1037962', 248349),
(383224, 'PTHR39229:SF1', NULL, NULL, NULL, NULL, 'RAD51-ASSOCIATED PROTEIN 2', 248349),
(383225, 'PTHR11375:SF20', NULL, NULL, NULL, NULL, '', 248350),
(383226, 'PTHR11375:SF0', NULL, NULL, NULL, NULL, 'ACIDIC LEUCINE-RICH NUCLEAR PHOSPHOPROTEIN 32 FAMILY MEMBER A', 248350),
(383227, 'PTHR11375:SF21', NULL, NULL, NULL, NULL, '', 248350),
(383228, 'PTHR11375:SF1', NULL, NULL, NULL, NULL, 'ACIDIC LEUCINE-RICH NUCLEAR PHOSPHOPROTEIN 32 FAMILY MEMBER A', 248350),
(383229, 'PTHR11375:SF22', NULL, NULL, NULL, NULL, 'ACIDIC LEUCINE-RICH NUCLEAR PHOSPHOPROTEIN 32 FAMILY MEMBER B', 248350),
(383230, 'PTHR11375:SF23', NULL, NULL, NULL, NULL, 'ZZ-TYPE DOMAIN-CONTAINING PROTEIN', 248350),
(383231, 'PTHR11375:SF15', NULL, NULL, NULL, NULL, 'ACIDIC LEUCINE-RICH NUCLEAR PHOSPHOPROTEIN 32 FAMILY MEMBER C', 248350);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(383232, 'PTHR11375:SF18', NULL, NULL, NULL, NULL, 'ACIDIC LEUCINE-RICH NUCLEAR PHOSPHOPROTEIN 32-RELATED PROTEIN 2', 248350),
(383233, 'PTHR11375:SF19', NULL, NULL, NULL, NULL, '', 248350),
(383234, 'PTHR11375:SF5', NULL, NULL, NULL, NULL, 'ACIDIC LEUCINE-RICH NUCLEAR PHOSPHOPROTEIN 32 FAMILY MEMBER E', 248350),
(383235, 'PTHR11375:SF2', NULL, NULL, NULL, NULL, 'ACIDIC LEUCINE-RICH NUCLEAR PHOSPHOPROTEIN 32 FAMILY MEMBER B', 248350),
(383236, 'PTHR11375', NULL, NULL, NULL, NULL, 'ACIDIC LEUCINE-RICH NUCLEAR PHOSPHOPROTEIN 32', 248350),
(383237, 'PTHR38765:SF1', NULL, NULL, NULL, NULL, '', 248351),
(383238, 'PTHR38765', NULL, NULL, NULL, NULL, '', 248351),
(383239, 'PTHR35017:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG16223', 248352),
(383240, 'PTHR35017:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG14064', 248352),
(383241, 'PTHR35017:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG09605', 248352),
(383242, 'PTHR35017:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG14685', 248352),
(383243, 'PTHR35017', NULL, NULL, NULL, NULL, 'PROTEIN CBG16223-RELATED', 248352),
(383244, 'PTHR35017:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG16222', 248352),
(383245, 'PTHR35017:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG14686', 248352),
(383246, 'PTHR46649', NULL, NULL, NULL, NULL, '', 248353),
(383247, 'PTHR46649:SF7', NULL, NULL, NULL, NULL, 'HALOACID DEHALOGENASE-LIKE HYDROLASE (HAD) SUPERFAMILY PROTEIN', 248353),
(383248, 'PTHR46649:SF4', NULL, NULL, NULL, NULL, 'HALOACID DEHALOGENASE-LIKE HYDROLASE (HAD) SUPERFAMILY PROTEIN', 248353),
(383249, 'PTHR46649:SF5', NULL, NULL, NULL, NULL, 'F14L17.7 PROTEIN', 248353),
(383250, 'PTHR23501:SF168', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 248354),
(383251, 'PTHR23501:SF169', NULL, NULL, NULL, NULL, 'SLR0616 PROTEIN', 248354),
(383252, 'PTHR23501', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY', 248354),
(383253, 'PTHR23501:SF163', NULL, NULL, NULL, NULL, 'EFFLUX PUMP ALNA', 248354),
(383254, 'PTHR23501:SF67', NULL, NULL, NULL, NULL, 'MFS MULTIDRUG EFFLUX TRANSPORTER (EUROFUNG)', 248354),
(383255, 'PTHR23501:SF170', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN 3', 248354),
(383256, 'PTHR23501:SF5', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN-RELATED', 248354),
(383257, 'PTHR23501:SF3', NULL, NULL, NULL, NULL, 'SIDEROPHORE IRON TRANSPORTER', 248354),
(383258, 'PTHR23501:SF1', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN HSRA-RELATED', 248354),
(383259, 'PTHR23501:SF174', NULL, NULL, NULL, NULL, 'MULTIDRUG EXPORT PROTEIN EMRB-RELATED', 248354),
(383260, 'PTHR23501:SF175', NULL, NULL, NULL, NULL, 'SIDEROPHORE IRON TRANSPORTER MIRC-RELATED', 248354),
(383261, 'PTHR23501:SF177', NULL, NULL, NULL, NULL, 'MULTIDRUG TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G16910)-RELATED', 248354),
(383262, 'PTHR23501:SF59', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 248354),
(383263, 'PTHR23501:SF58', NULL, NULL, NULL, NULL, 'LOW AFFINITY HEME TRANSPORTER STR3', 248354),
(383264, 'PTHR23501:SF55', NULL, NULL, NULL, NULL, 'SIDEROPHORE IRON TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G03440)-RELATED', 248354),
(383265, 'PTHR23501:SF12', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 248354),
(383266, 'PTHR23501:SF51', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN B', 248354),
(383267, 'PTHR23501:SF6', NULL, NULL, NULL, NULL, 'MULTIDRUG TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G14560)-RELATED', 248354),
(383268, 'PTHR23501:SF94', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 248354),
(383269, 'PTHR23501:SF50', NULL, NULL, NULL, NULL, 'SIDEROPHORE IRON TRANSPORTER 2', 248354),
(383270, 'PTHR23501:SF92', NULL, NULL, NULL, NULL, 'GLUTATHIONE EXCHANGER 1-RELATED', 248354),
(383271, 'PTHR23501:SF189', NULL, NULL, NULL, NULL, 'DRUG TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G03920)-RELATED', 248354),
(383272, 'PTHR23501:SF102', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 248354),
(383273, 'PTHR23501:SF147', NULL, NULL, NULL, NULL, 'AZOLE RESISTANCE PROTEIN 1-RELATED', 248354),
(383274, 'PTHR23501:SF185', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 248354);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(383275, 'PTHR23501:SF187', NULL, NULL, NULL, NULL, 'MFS-TYPE EFFLUX TRANSPORTER PHMH', 248354),
(383276, 'PTHR23501:SF188', NULL, NULL, NULL, NULL, 'TETRACYCLINE RESISTANCE PROTEIN', 248354),
(383277, 'PTHR23501:SF109', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 248354),
(383278, 'PTHR23501:SF149', NULL, NULL, NULL, NULL, 'MULTIDRUG TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G10430)-RELATED', 248354),
(383279, 'PTHR23501:SF49', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 248354),
(383280, 'PTHR23501:SF107', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G04730)-RELATED', 248354),
(383281, 'PTHR23501:SF47', NULL, NULL, NULL, NULL, 'VACUOLAR BASIC AMINO ACID TRANSPORTER 1', 248354),
(383282, 'PTHR23501:SF43', NULL, NULL, NULL, NULL, 'MULTIDRUG TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G03040)-RELATED', 248354),
(383283, 'PTHR23501:SF87', NULL, NULL, NULL, NULL, 'SIDEROPHORE IRON TRANSPORTER 1', 248354),
(383284, 'PTHR23501:SF84', NULL, NULL, NULL, NULL, 'VACUOLAR MEMBRANE AMINO ACID UPTAKE TRANSPORTER FNX2', 248354),
(383285, 'PTHR23501:SF192', NULL, NULL, NULL, NULL, 'TRANSPORTER', 248354),
(383286, 'PTHR23501:SF81', NULL, NULL, NULL, NULL, 'VACUOLAR BASIC AMINO ACID TRANSPORTER 2', 248354),
(383287, 'PTHR23501:SF193', NULL, NULL, NULL, NULL, 'MULTIDRUG TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G00940)-RELATED', 248354),
(383288, 'PTHR23501:SF194', NULL, NULL, NULL, NULL, 'EFFLUX PUMP ANTIBIOTIC RESISTANCE PROTEIN', 248354),
(383289, 'PTHR23501:SF195', NULL, NULL, NULL, NULL, 'PEP5', 248354),
(383290, 'PTHR23501:SF190', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY MFS_1', 248354),
(383291, 'PTHR23501:SF191', NULL, NULL, NULL, NULL, 'VACUOLAR BASIC AMINO ACID TRANSPORTER 4', 248354),
(383292, 'PTHR23501:SF156', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE-RELATED', 248354),
(383293, 'PTHR23501:SF158', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G14490)-RELATED', 248354),
(383294, 'PTHR23501:SF153', NULL, NULL, NULL, NULL, 'MFS AFLATOXIN EFFLUX PUMP', 248354),
(383295, 'PTHR23501:SF154', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE TRANSPORT PROTEIN-RELATED', 248354),
(383296, 'PTHR23501:SF155', NULL, NULL, NULL, NULL, 'EFFLUX PUMP AFOB', 248354),
(383297, 'PTHR23501:SF39', NULL, NULL, NULL, NULL, 'MULTIDRUG TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G05010)-RELATED', 248354),
(383298, 'PTHR23501:SF38', NULL, NULL, NULL, NULL, 'PERMEASE-RELATED', 248354),
(383299, 'PTHR23501:SF36', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN MDTD-RELATED', 248354),
(383300, 'PTHR23501:SF33', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 248354),
(383301, 'PTHR23501:SF78', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 248354),
(383302, 'PTHR15415:SF7', NULL, NULL, NULL, NULL, 'MICOS COMPLEX SUBUNIT MIC60', 248355),
(383303, 'PTHR15415', NULL, NULL, NULL, NULL, 'MITOFILIN', 248355),
(383304, 'PTHR15415:SF13', NULL, NULL, NULL, NULL, 'MICOS COMPLEX SUBUNIT MIC60-2', 248355),
(383305, 'PTHR22146:SF17', NULL, NULL, NULL, NULL, 'PROTEIN FAM166B-LIKE PROTEIN', 248356),
(383306, 'PTHR22146', NULL, NULL, NULL, NULL, 'CAT EYE SYNDROME CRITICAL REGION PROTEIN 6', 248356),
(383307, 'PTHR22146:SF8', NULL, NULL, NULL, NULL, 'PROTEIN FAM166B', 248356),
(383308, 'PTHR11735:SF14', NULL, NULL, NULL, NULL, 'TRNA N6-ADENOSINE THREONYLCARBAMOYLTRANSFERASE-RELATED', 248357),
(383309, 'PTHR11735:SF11', NULL, NULL, NULL, NULL, 'TRNA THREONYLCARBAMOYLADENOSINE BIOSYNTHESIS PROTEIN TSAB', 248357),
(383310, 'PTHR11735', NULL, NULL, NULL, NULL, 'TRNA N6-ADENOSINE THREONYLCARBAMOYLTRANSFERASE', 248357),
(383311, 'PTHR11735:SF6', NULL, NULL, NULL, NULL, 'TRNA N6-ADENOSINE THREONYLCARBAMOYLTRANSFERASE, MITOCHONDRIAL-RELATED', 248357),
(383312, 'PTHR32286:SF10', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 6 COMPLEX LOCUS PROTEIN G6F', 248358),
(383313, 'PTHR32286:SF9', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 6 COMPLEX LOCUS PROTEIN G6D', 248358),
(383314, 'PTHR32286', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 6 COMPLEX LOCUS PROTEIN G6F', 248358);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(383315, 'PTHR13297:SF5', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 23', 248359),
(383316, 'PTHR13297:SF7', NULL, NULL, NULL, NULL, 'RABGAP/TBC DOMAIN-CONTAINING PROTEIN', 248359),
(383317, 'PTHR13297:SF8', NULL, NULL, NULL, NULL, 'SAP DOMAIN-CONTAINING PROTEIN', 248359),
(383318, 'PTHR13297:SF9', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 248359),
(383319, 'PTHR13297', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248359),
(383320, 'PTHR43805:SF1', NULL, NULL, NULL, NULL, 'GP-PDE DOMAIN-CONTAINING PROTEIN', 248360),
(383321, 'PTHR43805', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHORYL DIESTER PHOSPHODIESTERASE', 248360),
(383322, 'PTHR11062:SF234', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383323, 'PTHR11062:SF355', NULL, NULL, NULL, NULL, 'BNAA02G13130D PROTEIN', 248361),
(383324, 'PTHR11062:SF235', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383325, 'PTHR11062:SF114', NULL, NULL, NULL, NULL, 'OS04G0574100 PROTEIN', 248361),
(383326, 'PTHR11062:SF356', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383327, 'PTHR11062:SF357', NULL, NULL, NULL, NULL, 'GLUCURONOXYLAN GLUCURONOSYLTRANSFERASE F8H-RELATED', 248361),
(383328, 'PTHR11062:SF236', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE PLANT-LIKE PROTEIN', 248361),
(383329, 'PTHR11062:SF358', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383330, 'PTHR11062:SF230', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383331, 'PTHR11062:SF352', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383332, 'PTHR11062:SF231', NULL, NULL, NULL, NULL, 'GLUCOSAMINE INOSITOLPHOSPHORYLCERAMIDE TRANSFERASE 1', 248361),
(383333, 'PTHR11062:SF198', NULL, NULL, NULL, NULL, 'OS03G0324700 PROTEIN', 248361),
(383334, 'PTHR11062:SF353', NULL, NULL, NULL, NULL, 'EXOSTOSIN FAMILY PROTEIN', 248361),
(383335, 'PTHR11062:SF112', NULL, NULL, NULL, NULL, 'GLUCOSAMINE INOSITOLPHOSPHORYLCERAMIDE TRANSFERASE 1', 248361),
(383336, 'PTHR11062:SF95', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383337, 'PTHR11062:SF359', NULL, NULL, NULL, NULL, 'OS06G0705000 PROTEIN', 248361),
(383338, 'PTHR11062:SF117', NULL, NULL, NULL, NULL, 'XYLOGLUCAN-SPECIFIC GALACTURONOSYLTRANSFERASE 1', 248361),
(383339, 'PTHR11062:SF97', NULL, NULL, NULL, NULL, 'EXOSTOSIN-1', 248361),
(383340, 'PTHR11062:SF239', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE OS04G0398600-RELATED', 248361),
(383341, 'PTHR11062:SF99', NULL, NULL, NULL, NULL, 'EXOSTOSIN FAMILY PROTEIN', 248361),
(383342, 'PTHR11062:SF360', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383343, 'PTHR11062:SF361', NULL, NULL, NULL, NULL, 'EXOSTOSIN-1C', 248361),
(383344, 'PTHR11062:SF345', NULL, NULL, NULL, NULL, 'EXOSTOSIN FAMILY PROTEIN', 248361),
(383345, 'PTHR11062:SF220', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383346, 'PTHR11062:SF189', NULL, NULL, NULL, NULL, 'XYLOGLUCAN GALACTOSYLTRANSFERASE MUR3', 248361),
(383347, 'PTHR11062:SF343', NULL, NULL, NULL, NULL, 'OS01G0107700 PROTEIN', 248361),
(383348, 'PTHR11062:SF227', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE OS02G0520750-RELATED', 248361),
(383349, 'PTHR11062:SF229', NULL, NULL, NULL, NULL, 'GLUCURONOXYLAN GLUCURONOSYLTRANSFERASE IRX7-RELATED', 248361),
(383350, 'PTHR11062:SF108', NULL, NULL, NULL, NULL, 'EXOSTOSIN FAMILY PROTEIN', 248361),
(383351, 'PTHR11062:SF8', NULL, NULL, NULL, NULL, 'EXOSTOSIN-LIKE 1', 248361),
(383352, 'PTHR11062:SF191', NULL, NULL, NULL, NULL, 'EXOSTOSIN FAMILY PROTEIN, EXPRESSED', 248361),
(383353, 'PTHR11062:SF214', NULL, NULL, NULL, NULL, 'XYLOGLUCAN GALACTOSYLTRANSFERASE XLT2', 248361),
(383354, 'PTHR11062:SF335', NULL, NULL, NULL, NULL, 'XYLOGLUCAN GALACTOSYLTRANSFERASE GT20-RELATED', 248361),
(383355, 'PTHR11062:SF215', NULL, NULL, NULL, NULL, 'BETA-14-XYLOSYLTRANSFERASE IRX10L-RELATED', 248361),
(383356, 'PTHR11062:SF336', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383357, 'PTHR11062:SF330', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(383358, 'PTHR11062:SF210', NULL, NULL, NULL, NULL, 'EXOSTOSIN FAMILY PROTEIN', 248361),
(383359, 'PTHR11062:SF299', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE, PUTATIVE-RELATED', 248361),
(383360, 'PTHR11062:SF216', NULL, NULL, NULL, NULL, 'BNAA05G32810D PROTEIN', 248361),
(383361, 'PTHR11062:SF337', NULL, NULL, NULL, NULL, 'OS06G0176100 PROTEIN', 248361),
(383362, 'PTHR11062:SF217', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383363, 'PTHR11062:SF339', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE OS01G0926700-RELATED', 248361),
(383364, 'PTHR11062:SF219', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383365, 'PTHR11062:SF184', NULL, NULL, NULL, NULL, 'EXOSTOSIN FAMILY PROTEIN', 248361),
(383366, 'PTHR11062:SF322', NULL, NULL, NULL, NULL, 'OS03G0144300 PROTEIN', 248361),
(383367, 'PTHR11062:SF204', NULL, NULL, NULL, NULL, 'XYLOGLUCAN GALACTOSYLTRANSFERASE GT15-RELATED', 248361),
(383368, 'PTHR11062:SF286', NULL, NULL, NULL, NULL, 'GLYCOSYLINOSITOL PHOSPHORYLCERAMIDE MANNOSYL TRANSFERASE 1', 248361),
(383369, 'PTHR11062:SF320', NULL, NULL, NULL, NULL, 'BNAA09G42910D PROTEIN', 248361),
(383370, 'PTHR11062:SF287', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383371, 'PTHR11062:SF321', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383372, 'PTHR11062:SF200', NULL, NULL, NULL, NULL, 'BETA-1,4-XYLOSYLTRANSFERASE IRX10L-RELATED', 248361),
(383373, 'PTHR11062:SF326', NULL, NULL, NULL, NULL, 'BNAANNG31440D PROTEIN', 248361),
(383374, 'PTHR11062:SF205', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383375, 'PTHR11062:SF206', NULL, NULL, NULL, NULL, 'EXOSTOSIN FAMILY PROTEIN', 248361),
(383376, 'PTHR11062:SF207', NULL, NULL, NULL, NULL, 'OS07G0188700 PROTEIN', 248361),
(383377, 'PTHR11062:SF329', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383378, 'PTHR11062:SF294', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383379, 'PTHR11062:SF290', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 248361),
(383380, 'PTHR11062:SF278', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383381, 'PTHR11062:SF313', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383382, 'PTHR11062:SF274', NULL, NULL, NULL, NULL, 'EXOSTOSIN FAMILY PROTEIN', 248361),
(383383, 'PTHR11062:SF277', NULL, NULL, NULL, NULL, 'BNAA03G01060D PROTEIN', 248361),
(383384, 'PTHR11062:SF319', NULL, NULL, NULL, NULL, 'BNAA04G16810D PROTEIN', 248361),
(383385, 'PTHR11062:SF50', NULL, NULL, NULL, NULL, 'ARABINOSYLTRANSFERASE ARAD1-RELATED', 248361),
(383386, 'PTHR11062:SF315', NULL, NULL, NULL, NULL, 'EXOSTOSIN FAMILY PROTEIN', 248361),
(383387, 'PTHR11062:SF316', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383388, 'PTHR11062:SF56', NULL, NULL, NULL, NULL, 'XYLOGLUCAN GALACTOSYLTRANSFERASE MUR3', 248361),
(383389, 'PTHR11062:SF58', NULL, NULL, NULL, NULL, 'XYLOGLUCAN GALACTOSYLTRANSFERASE GT19-RELATED', 248361),
(383390, 'PTHR11062:SF59', NULL, NULL, NULL, NULL, 'EXOSTOSIN FAMILY PROTEIN', 248361),
(383391, 'PTHR11062:SF281', NULL, NULL, NULL, NULL, 'EXOSTOSIN FAMILY PROTEIN', 248361),
(383392, 'PTHR11062:SF282', NULL, NULL, NULL, NULL, 'XYLOGLUCAN GALACTOSYLTRANSFERASE GT11-RELATED', 248361),
(383393, 'PTHR11062:SF267', NULL, NULL, NULL, NULL, 'BNAC09G37520D PROTEIN', 248361),
(383394, 'PTHR11062:SF300', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383395, 'PTHR11062:SF268', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 248361),
(383396, 'PTHR11062:SF384', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383397, 'PTHR11062:SF263', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383398, 'PTHR11062:SF385', NULL, NULL, NULL, NULL, 'EXOSTOSIN FAMILY PROTEIN', 248361),
(383399, 'PTHR11062:SF264', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383400, 'PTHR11062:SF266', NULL, NULL, NULL, NULL, 'XYLOGLUCAN GALACTOSYLTRANSFERASE MUR3', 248361);
INSERT INTO "PUBLIC"."MODEL" VALUES
(383401, 'PTHR11062:SF309', NULL, NULL, NULL, NULL, 'BNAA09G10260D PROTEIN', 248361),
(383402, 'PTHR11062:SF306', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383403, 'PTHR11062:SF43', NULL, NULL, NULL, NULL, 'EXOSTOSIN FAMILY PROTEIN', 248361),
(383404, 'PTHR11062:SF307', NULL, NULL, NULL, NULL, 'ARABINOSYLTRANSFERASE ARAD2-RELATED', 248361),
(383405, 'PTHR11062:SF48', NULL, NULL, NULL, NULL, 'OJ1485_B09.5 PROTEIN', 248361),
(383406, 'PTHR11062:SF270', NULL, NULL, NULL, NULL, 'EXOSTOSIN FAMILY PROTEIN', 248361),
(383407, 'PTHR11062:SF272', NULL, NULL, NULL, NULL, 'EXOSTOSIN FAMILY PROTEIN', 248361),
(383408, 'PTHR11062:SF273', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383409, 'PTHR11062:SF377', NULL, NULL, NULL, NULL, 'BNACNNG36170D PROTEIN', 248361),
(383410, 'PTHR11062:SF256', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383411, 'PTHR11062:SF378', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383412, 'PTHR11062', NULL, NULL, NULL, NULL, 'EXOSTOSIN  HEPARAN SULFATE GLYCOSYLTRANSFERASE -RELATED', 248361),
(383413, 'PTHR11062:SF379', NULL, NULL, NULL, NULL, 'OS10G0459300 PROTEIN', 248361),
(383414, 'PTHR11062:SF373', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383415, 'PTHR11062:SF374', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383416, 'PTHR11062:SF253', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383417, 'PTHR11062:SF375', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383418, 'PTHR11062:SF254', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY PROTEIN 64 C3', 248361),
(383419, 'PTHR11062:SF376', NULL, NULL, NULL, NULL, 'EXOSTOSIN FAMILY PROTEIN', 248361),
(383420, 'PTHR11062:SF255', NULL, NULL, NULL, NULL, 'XYLOGLUCAN GALACTOSYLTRANSFERASE GT17-RELATED', 248361),
(383421, 'PTHR11062:SF73', NULL, NULL, NULL, NULL, 'EXOSTOSIN-LIKE 3', 248361),
(383422, 'PTHR11062:SF74', NULL, NULL, NULL, NULL, 'XYLOGLUCAN GALACTOSYLTRANSFERASE GT15-RELATED', 248361),
(383423, 'PTHR11062:SF77', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY EXOSTOSIN PROTEIN', 248361),
(383424, 'PTHR11062:SF78', NULL, NULL, NULL, NULL, 'XYLOGLUCAN GALACTOSYLTRANSFERASE MUR3', 248361),
(383425, 'PTHR11062:SF380', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383426, 'PTHR11062:SF381', NULL, NULL, NULL, NULL, 'EXOSTOSIN-2', 248361),
(383427, 'PTHR11062:SF260', NULL, NULL, NULL, NULL, 'XYLOGLUCAN GALACTOSYLTRANSFERASE GT15-RELATED', 248361),
(383428, 'PTHR11062:SF382', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383429, 'PTHR11062:SF262', NULL, NULL, NULL, NULL, 'XYLOGLUCAN GALACTOSYLTRANSFERASE GT13-RELATED', 248361),
(383430, 'PTHR11062:SF383', NULL, NULL, NULL, NULL, 'XYLOGALACTURONAN BETA-1,3-XYLOSYLTRANSFERASE-RELATED', 248361),
(383431, 'PTHR11062:SF124', NULL, NULL, NULL, NULL, 'XYLOGALACTURONAN BETA-1,3-XYLOSYLTRANSFERASE', 248361),
(383432, 'PTHR11062:SF366', NULL, NULL, NULL, NULL, 'XYLOGLUCAN GALACTOSYLTRANSFERASE GT12-RELATED', 248361),
(383433, 'PTHR11062:SF246', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383434, 'PTHR11062:SF125', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE OS01G0926400-RELATED', 248361),
(383435, 'PTHR11062:SF367', NULL, NULL, NULL, NULL, '', 248361),
(383436, 'PTHR11062:SF247', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 248361),
(383437, 'PTHR11062:SF368', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383438, 'PTHR11062:SF369', NULL, NULL, NULL, NULL, 'BNAC09G50610D PROTEIN', 248361),
(383439, 'PTHR11062:SF248', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383440, 'PTHR11062:SF241', NULL, NULL, NULL, NULL, 'XYLOGLUCAN GALACTOSYLTRANSFERASE GT14-RELATED', 248361),
(383441, 'PTHR11062:SF362', NULL, NULL, NULL, NULL, 'XYLOGLUCAN GALACTOSYLTRANSFERASE GT19-RELATED', 248361),
(383442, 'PTHR11062:SF363', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(383443, 'PTHR11062:SF364', NULL, NULL, NULL, NULL, 'EXOSTOSIN-LIKE GLYCOSYLTRANSFERASE 2', 248361),
(383444, 'PTHR11062:SF365', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383445, 'PTHR11062:SF60', NULL, NULL, NULL, NULL, 'EXOSTOSIN FAMILY PROTEIN', 248361),
(383446, 'PTHR11062:SF61', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 248361),
(383447, 'PTHR11062:SF249', NULL, NULL, NULL, NULL, 'OS08G0438600 PROTEIN', 248361),
(383448, 'PTHR11062:SF129', NULL, NULL, NULL, NULL, 'EXOSTOSIN-1', 248361),
(383449, 'PTHR11062:SF370', NULL, NULL, NULL, NULL, 'BETA-1,4-XYLOSYLTRANSFERASE IRX10-RELATED', 248361),
(383450, 'PTHR11062:SF371', NULL, NULL, NULL, NULL, 'XYLOGLUCAN GALACTOSYLTRANSFERASE MUR3', 248361),
(383451, 'PTHR11062:SF251', NULL, NULL, NULL, NULL, 'XYLOGLUCAN GALACTOSYLTRANSFERASE MUR3', 248361),
(383452, 'PTHR11062:SF372', NULL, NULL, NULL, NULL, 'EXOSTOSIN DOMAIN-CONTAINING PROTEIN', 248361),
(383453, 'PTHR33529', NULL, NULL, NULL, NULL, 'SLR0882 PROTEIN-RELATED', 248362),
(383454, 'PTHR33529:SF7', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE EXPORT SYSTEM PERMEASE PROTEIN LPTF', 248362),
(383455, 'PTHR33529:SF8', NULL, NULL, NULL, NULL, 'PERMEASE, YJGP/YJGQ FAMILY-RELATED', 248362),
(383456, 'PTHR33529:SF6', NULL, NULL, NULL, NULL, 'SLR0882 PROTEIN', 248362),
(383457, 'PTHR33529:SF2', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE EXPORT SYSTEM PERMEASE PROTEIN LPTG', 248362),
(383458, 'PTHR35485:SF9', NULL, NULL, NULL, NULL, 'OS09G0518750 PROTEIN', 248363),
(383459, 'PTHR35485:SF8', NULL, NULL, NULL, NULL, '', 248363),
(383460, 'PTHR35485:SF4', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248363),
(383461, 'PTHR35485:SF11', NULL, NULL, NULL, NULL, 'BNAC04G03280D PROTEIN', 248363),
(383462, 'PTHR35485:SF12', NULL, NULL, NULL, NULL, '', 248363),
(383463, 'PTHR35485', NULL, NULL, NULL, NULL, 'OS01G0888900 PROTEIN', 248363),
(383464, 'PTHR35485:SF10', NULL, NULL, NULL, NULL, 'OS05G0417600 PROTEIN', 248363),
(383465, 'PTHR24388:SF92', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 281', 248364),
(383466, 'PTHR24388:SF91', NULL, NULL, NULL, NULL, '', 248364),
(383467, 'PTHR24388:SF90', NULL, NULL, NULL, NULL, '', 248364),
(383468, 'PTHR24388:SF52', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 423', 248364),
(383469, 'PTHR24388:SF73', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZFAT', 248364),
(383470, 'PTHR24388:SF51', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 507', 248364),
(383471, 'PTHR24388:SF95', NULL, NULL, NULL, NULL, 'PLEIOMORPHIC ADENOMA GENE 1', 248364),
(383472, 'PTHR24388:SF94', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING 4', 248364),
(383473, 'PTHR24388:SF50', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 648-RELATED', 248364),
(383474, 'PTHR24388:SF93', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 672', 248364),
(383475, 'PTHR24388:SF71', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 38', 248364),
(383476, 'PTHR24388:SF56', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 280B', 248364),
(383477, 'PTHR24388:SF34', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 280D', 248364),
(383478, 'PTHR24388:SF55', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 143', 248364),
(383479, 'PTHR24388:SF76', NULL, NULL, NULL, NULL, '', 248364),
(383480, 'PTHR24388:SF54', NULL, NULL, NULL, NULL, 'KAHULI-RELATED', 248364),
(383481, 'PTHR24388:SF53', NULL, NULL, NULL, NULL, 'AT-RICH BINDING PROTEIN-RELATED', 248364),
(383482, 'PTHR24388:SF75', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 248364),
(383483, 'PTHR24388:SF38', NULL, NULL, NULL, NULL, 'FINGER, C2H2 TYPE, PUTATIVE-RELATED', 248364),
(383484, 'PTHR24388:SF37', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN SNAI1', 248364),
(383485, 'PTHR24388:SF58', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 4', 248364),
(383486, 'PTHR24388:SF36', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 221-RELATED', 248364),
(383487, 'PTHR24388:SF79', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 143-LIKE PROTEIN', 248364),
(383488, 'PTHR24388:SF85', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 367', 248364);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(383489, 'PTHR24388:SF41', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 646', 248364),
(383490, 'PTHR24388:SF63', NULL, NULL, NULL, NULL, 'ZGC:153635', 248364),
(383491, 'PTHR24388:SF40', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN SNAI3', 248364),
(383492, 'PTHR24388:SF62', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 280C', 248364),
(383493, 'PTHR24388:SF83', NULL, NULL, NULL, NULL, 'LOC792194 PROTEIN-RELATED', 248364),
(383494, 'PTHR24388:SF60', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR SCRATCH 1', 248364),
(383495, 'PTHR24388:SF89', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 518B', 248364),
(383496, 'PTHR24388:SF45', NULL, NULL, NULL, NULL, 'POGO TRANSPOSABLE ELEMENT-DERIVED WITH ZNF DOMAIN A', 248364),
(383497, 'PTHR24388:SF67', NULL, NULL, NULL, NULL, 'EOR-1', 248364),
(383498, 'PTHR24388:SF88', NULL, NULL, NULL, NULL, 'SNAIL FAMILY ZINC FINGER 2-RELATED', 248364),
(383499, 'PTHR24388:SF66', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 521', 248364),
(383500, 'PTHR24388:SF43', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 513', 248364),
(383501, 'PTHR24388:SF87', NULL, NULL, NULL, NULL, 'ZINC FINGER-LIKE PROTEIN', 248364),
(383502, 'PTHR24388:SF86', NULL, NULL, NULL, NULL, 'FINGER PROTEIN, PUTATIVE-RELATED', 248364),
(383503, 'PTHR24388:SF42', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN SNAI2', 248364),
(383504, 'PTHR24388:SF49', NULL, NULL, NULL, NULL, 'ZINC FINGER X-CHROMOSOMAL PROTEIN', 248364),
(383505, 'PTHR24388:SF48', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR SCRATCH 2', 248364),
(383506, 'PTHR24388:SF47', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 280A', 248364),
(383507, 'PTHR24388:SF69', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN PLAG1', 248364),
(383508, 'PTHR24388', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 248364),
(383509, 'PTHR24388:SF68', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN CONTAINING 11', 248364),
(383510, 'PTHR24388:SF46', NULL, NULL, NULL, NULL, 'CCCTC-BINDING FACTOR (ZINC FINGER PROTEIN)', 248364),
(383511, 'PTHR24388:SF28', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 341', 248364),
(383512, 'PTHR11545:SF36', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L13A', 248365),
(383513, 'PTHR11545:SF25', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 248365),
(383514, 'PTHR11545:SF37', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L13A-4', 248365),
(383515, 'PTHR11545:SF26', NULL, NULL, NULL, NULL, 'BNACNNG21840D PROTEIN', 248365),
(383516, 'PTHR11545:SF27', NULL, NULL, NULL, NULL, 'BNAA02G18970D PROTEIN', 248365),
(383517, 'PTHR11545:SF38', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L13A-4-LIKE', 248365),
(383518, 'PTHR11545:SF28', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L13A-2', 248365),
(383519, 'PTHR11545:SF18', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L13A-4', 248365),
(383520, 'PTHR11545:SF29', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L13A-4-LIKE', 248365),
(383521, 'PTHR11545:SF19', NULL, NULL, NULL, NULL, 'OS07G0109500 PROTEIN', 248365),
(383522, 'PTHR11545', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L13', 248365),
(383523, 'PTHR11545:SF2', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L13, MITOCHONDRIAL', 248365),
(383524, 'PTHR11545:SF3', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L13A', 248365),
(383525, 'PTHR11545:SF30', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L13A', 248365),
(383526, 'PTHR11545:SF32', NULL, NULL, NULL, NULL, 'OS03G0755700 PROTEIN', 248365),
(383527, 'PTHR11545:SF33', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L13A-4-LIKE', 248365),
(383528, 'PTHR11545:SF23', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L13A', 248365),
(383529, 'PTHR11545:SF34', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L13A', 248365),
(383530, 'PTHR11545:SF24', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L13, CHLOROPLASTIC-LIKE', 248365),
(383531, 'PTHR38037:SF1', NULL, NULL, NULL, NULL, 'ZN_PROTEASE DOMAIN-CONTAINING PROTEIN', 248366),
(383532, 'PTHR38037:SF2', NULL, NULL, NULL, NULL, 'ZN_PROTEASE DOMAIN-CONTAINING PROTEIN', 248366),
(383533, 'PTHR38037', NULL, NULL, NULL, NULL, 'ZN_PROTEASE DOMAIN-CONTAINING PROTEIN', 248366);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(383534, 'PTHR33365:SF14', NULL, NULL, NULL, NULL, 'YALI0B05434P', 248367),
(383535, 'PTHR33365:SF6', NULL, NULL, NULL, NULL, '', 248367),
(383536, 'PTHR33365:SF7', NULL, NULL, NULL, NULL, '', 248367),
(383537, 'PTHR33365:SF11', NULL, NULL, NULL, NULL, '', 248367),
(383538, 'PTHR33365:SF13', NULL, NULL, NULL, NULL, '', 248367),
(383539, 'PTHR33365:SF4', NULL, NULL, NULL, NULL, '', 248367),
(383540, 'PTHR33365:SF12', NULL, NULL, NULL, NULL, '', 248367),
(383541, 'PTHR33365', NULL, NULL, NULL, NULL, 'YALI0B05434P', 248367),
(383542, 'PTHR33370', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR IF-1, CHLOROPLASTIC', 248368),
(383543, 'PTHR33370:SF2', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR IF-1, CHLOROPLASTIC', 248368),
(383544, 'PTHR33370:SF1', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR IF-1, CHLOROPLASTIC', 248368),
(383545, 'PTHR33370:SF3', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR IF-1, CHLOROPLASTIC', 248368),
(383546, 'PTHR43761:SF1', NULL, NULL, NULL, NULL, 'D-ISOMER SPECIFIC 2-HYDROXYACID DEHYDROGENASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_1G13630)', 248369),
(383547, 'PTHR43761', NULL, NULL, NULL, NULL, 'D-ISOMER SPECIFIC 2-HYDROXYACID DEHYDROGENASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_1G13630)', 248369),
(383548, 'PTHR44085', NULL, NULL, NULL, NULL, 'SEPIAPTERIN REDUCTASE', 248370),
(383549, 'PTHR44085:SF2', NULL, NULL, NULL, NULL, 'SEPIAPTERIN REDUCTASE', 248370),
(383550, 'PTHR28047', NULL, NULL, NULL, NULL, 'PROTEIN DCG1', 248371),
(383551, 'PTHR28047:SF6', NULL, NULL, NULL, NULL, 'CN HYDROLASE DOMAIN-CONTAINING PROTEIN', 248371),
(383552, 'PTHR28047:SF7', NULL, NULL, NULL, NULL, 'HYDANTOIN RACEMASE FAMILY PROTEIN', 248371),
(383553, 'PTHR28047:SF5', NULL, NULL, NULL, NULL, 'PROTEIN DCG1', 248371),
(383554, 'PTHR30457:SF24', NULL, NULL, NULL, NULL, 'SURE DOMAIN-CONTAINING PROTEIN', 248372),
(383555, 'PTHR30457:SF16', NULL, NULL, NULL, NULL, 'SURE DOMAIN-CONTAINING PROTEIN', 248372),
(383556, 'PTHR30457', NULL, NULL, NULL, NULL, '5''-NUCLEOTIDASE SURE', 248372),
(383557, 'PTHR30457:SF15', NULL, NULL, NULL, NULL, '5''-NUCLEOTIDASE SURE-LIKE ISOFORM X1', 248372),
(383558, 'PTHR30457:SF21', NULL, NULL, NULL, NULL, 'SURE DOMAIN-CONTAINING PROTEIN', 248372),
(383559, 'PTHR30457:SF5', NULL, NULL, NULL, NULL, 'OS01G0709400 PROTEIN', 248372),
(383560, 'PTHR30457:SF12', NULL, NULL, NULL, NULL, '5''/3''-NUCLEOTIDASE SURE', 248372),
(383561, 'PTHR30457:SF23', NULL, NULL, NULL, NULL, 'PHOSPHATASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G03660)-RELATED', 248372),
(383562, 'PTHR30457:SF0', NULL, NULL, NULL, NULL, 'PHOSPHATASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G01070)-RELATED', 248372),
(383563, 'PTHR30457:SF18', NULL, NULL, NULL, NULL, '5''-NUCLEOTIDASE SURE-LIKE', 248372),
(383564, 'PTHR30457:SF17', NULL, NULL, NULL, NULL, '5''-NUCLEOTIDASE SURE-LIKE', 248372),
(383565, 'PTHR36858', NULL, NULL, NULL, NULL, 'AMELOTIN', 248373),
(383566, 'PTHR36858:SF1', NULL, NULL, NULL, NULL, 'AMELOTIN', 248373),
(383567, 'PTHR16771:SF11', NULL, NULL, NULL, NULL, '26S PROTEASOME COMPLEX SUBUNIT DSS1', 248374),
(383568, 'PTHR16771', NULL, NULL, NULL, NULL, '26 PROTEASOME COMPLEX SUBUNIT DSS1', 248374),
(383569, 'PTHR16771:SF17', NULL, NULL, NULL, NULL, 'PROTEIN DELETION OF SUV3 SUPPRESSOR 1(I)-RELATED', 248374),
(383570, 'PTHR16771:SF16', NULL, NULL, NULL, NULL, '', 248374),
(383571, 'PTHR16771:SF15', NULL, NULL, NULL, NULL, 'PROTEIN DELETION OF SUV3 SUPPRESSOR 1(I)-LIKE', 248374),
(383572, 'PTHR16771:SF0', NULL, NULL, NULL, NULL, '26S PROTEASOME COMPLEX SUBUNIT SEM1', 248374),
(383573, 'PTHR16771:SF14', NULL, NULL, NULL, NULL, 'PROTEIN SEM1, ISOFORM 2-RELATED', 248374),
(383574, 'PTHR16771:SF13', NULL, NULL, NULL, NULL, 'BNACNNG23950D PROTEIN', 248374),
(383575, 'PTHR16771:SF12', NULL, NULL, NULL, NULL, 'OS01G0316800 PROTEIN', 248374),
(383576, 'PTHR37324:SF2', NULL, NULL, NULL, NULL, 'PTS SYSTEM GALACTITOL-SPECIFIC EIIC COMPONENT', 248375),
(383577, 'PTHR37324', NULL, NULL, NULL, NULL, 'PTS SYSTEM GALACTITOL-SPECIFIC EIIC COMPONENT', 248375),
(383578, 'PTHR37324:SF4', NULL, NULL, NULL, NULL, 'PERMEASE IIC COMPONENT-RELATED', 248375); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(383579, 'PTHR13050:SF7', NULL, NULL, NULL, NULL, 'VESICLE TRANSPORT PROTEIN USE1', 248376),
(383580, 'PTHR13050:SF9', NULL, NULL, NULL, NULL, 'VESICLE TRANSPORT PROTEIN, USE1-RELATED', 248376),
(383581, 'PTHR13050:SF8', NULL, NULL, NULL, NULL, 'OS09G0272500 PROTEIN', 248376),
(383582, 'PTHR13050', NULL, NULL, NULL, NULL, 'USE1-LIKE PROTEIN', 248376),
(383583, 'PTHR15860:SF26', NULL, NULL, NULL, NULL, 'OS01G0168400 PROTEIN', 248377),
(383584, 'PTHR15860:SF14', NULL, NULL, NULL, NULL, 'RING FINGER AND TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN 1-LIKE', 248377),
(383585, 'PTHR15860:SF27', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 248377),
(383586, 'PTHR15860:SF2', NULL, NULL, NULL, NULL, 'RING FINGER AND TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN 2', 248377),
(383587, 'PTHR15860:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNFT1', 248377),
(383588, 'PTHR15860:SF0', NULL, NULL, NULL, NULL, 'LP20373P', 248377),
(383589, 'PTHR15860:SF22', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 248377),
(383590, 'PTHR15860:SF21', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 248377),
(383591, 'PTHR15860:SF24', NULL, NULL, NULL, NULL, 'RING FINGER AND TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN 2-LIKE', 248377),
(383592, 'PTHR15860', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED RING FINGER-CONTAINING PROTEIN', 248377),
(383593, 'PTHR46065:SF1', NULL, NULL, NULL, NULL, 'ZGC:158785', 248378),
(383594, 'PTHR46065:SF4', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MARCHF2', 248378),
(383595, 'PTHR46065:SF5', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 248378),
(383596, 'PTHR46065:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MARCHF3', 248378),
(383597, 'PTHR46065', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MARCH 2/3 FAMILY MEMBER', 248378),
(383598, 'PTHR46065:SF3', NULL, NULL, NULL, NULL, 'FI20425P1', 248378),
(383599, 'PTHR36461', NULL, NULL, NULL, NULL, 'COORDINATOR OF PRMT5 AND DIFFERENTIATION STIMULATOR', 248379),
(383600, 'PTHR36461:SF1', NULL, NULL, NULL, NULL, 'COORDINATOR OF PRMT5 AND DIFFERENTIATION STIMULATOR', 248379),
(383601, 'PTHR36915', NULL, NULL, NULL, NULL, '', 248380),
(383602, 'PTHR36915:SF2', NULL, NULL, NULL, NULL, '', 248380),
(383603, 'PTHR36915:SF1', NULL, NULL, NULL, NULL, '', 248380),
(383604, 'PTHR11749', NULL, NULL, NULL, NULL, 'RIBULOSE-5-PHOSPHATE-3-EPIMERASE', 248381),
(383605, 'PTHR11749:SF17', NULL, NULL, NULL, NULL, 'PENTOSE-5-PHOSPHATE 3-EPIMERASE', 248381),
(383606, 'PTHR11749:SF16', NULL, NULL, NULL, NULL, 'RIBULOSE-PHOSPHATE 3-EPIMERASE', 248381),
(383607, 'PTHR11749:SF13', NULL, NULL, NULL, NULL, 'PENTOSE-5-PHOSPHATE 3-EPIMERASE', 248381),
(383608, 'PTHR11749:SF3', NULL, NULL, NULL, NULL, 'RIBULOSE-PHOSPHATE 3-EPIMERASE-RELATED', 248381),
(383609, 'PTHR11749:SF15', NULL, NULL, NULL, NULL, 'PENTOSE-5-PHOSPHATE 3-EPIMERASE', 248381),
(383610, 'PTHR11749:SF5', NULL, NULL, NULL, NULL, 'PROTEIN SGCE', 248381),
(383611, 'PTHR22808:SF29', NULL, NULL, NULL, NULL, 'MULTISITE-SPECIFIC TRNA:(CYTOSINE-C(5))-METHYLTRANSFERASE TRM4A', 248382),
(383612, 'PTHR22808:SF18', NULL, NULL, NULL, NULL, 'TRNA (CYTOSINE(34)-C(5))-METHYLTRANSFERASE-LIKE', 248382),
(383613, 'PTHR22808:SF28', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 248382),
(383614, 'PTHR22808:SF27', NULL, NULL, NULL, NULL, 'SAM_MT_RSMB_NOP DOMAIN-CONTAINING PROTEIN', 248382),
(383615, 'PTHR22808:SF25', NULL, NULL, NULL, NULL, 'TRNA (CYTOSINE(34)-C(5))-METHYLTRANSFERASE-RELATED', 248382),
(383616, 'PTHR22808:SF14', NULL, NULL, NULL, NULL, 'OS08G0484400 PROTEIN', 248382),
(383617, 'PTHR22808:SF24', NULL, NULL, NULL, NULL, 'SAM_MT_RSMB_NOP DOMAIN-CONTAINING PROTEIN', 248382),
(383618, 'PTHR22808:SF21', NULL, NULL, NULL, NULL, 'SPERM HEAD AND TAIL ASSOCIATED PROTEIN', 248382),
(383619, 'PTHR22808:SF10', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 248382),
(383620, 'PTHR22808:SF1', NULL, NULL, NULL, NULL, 'NOL1/NOP2/SUN DOMAIN FAMILY MEMBER 2-RELATED', 248382),
(383621, 'PTHR22808:SF20', NULL, NULL, NULL, NULL, 'RNA CYTOSINE C(5)-METHYLTRANSFERASE NSUN2', 248382);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(383622, 'PTHR22808:SF30', NULL, NULL, NULL, NULL, '', 248382),
(383623, 'PTHR22808:SF6', NULL, NULL, NULL, NULL, '', 248382),
(383624, 'PTHR22808', NULL, NULL, NULL, NULL, 'NCL1 YEAST -RELATED NOL1/NOP2/FMU SUN  DOMAIN-CONTAINING', 248382),
(383625, 'PTHR22808:SF3', NULL, NULL, NULL, NULL, '5-METHYLCYTOSINE RRNA METHYLTRANSFERASE NSUN4', 248382),
(383626, 'PTHR22808:SF8', NULL, NULL, NULL, NULL, 'TRNA (CYTOSINE(34)-C(5))-METHYLTRANSFERASE, MITOCHONDRIAL', 248382),
(383627, 'PTHR22808:SF7', NULL, NULL, NULL, NULL, 'SAM_MT_RSMB_NOP DOMAIN-CONTAINING PROTEIN', 248382),
(383628, 'PTHR34405', NULL, NULL, NULL, NULL, 'CRISPR-ASSOCIATED ENDORIBONUCLEASE CAS2', 248383),
(383629, 'PTHR34405:SF3', NULL, NULL, NULL, NULL, 'CRISPR-ASSOCIATED ENDORIBONUCLEASE CAS2 3', 248383),
(383630, 'PTHR34405:SF1', NULL, NULL, NULL, NULL, 'CRISPR-ASSOCIATED ENDORIBONUCLEASE CAS2', 248383),
(383631, 'PTHR45677:SF12', NULL, NULL, NULL, NULL, 'BLACK, ISOFORM A', 248384),
(383632, 'PTHR45677:SF11', NULL, NULL, NULL, NULL, 'GLUTAMATE DECARBOXYLASE 2', 248384),
(383633, 'PTHR45677:SF8', NULL, NULL, NULL, NULL, 'CYSTEINE SULFINIC ACID DECARBOXYLASE', 248384),
(383634, 'PTHR45677:SF10', NULL, NULL, NULL, NULL, 'GLUTAMATE DECARBOXYLASE', 248384),
(383635, 'PTHR45677:SF6', NULL, NULL, NULL, NULL, 'ZGC:163121', 248384),
(383636, 'PTHR45677:SF5', NULL, NULL, NULL, NULL, 'GLUTAMATE DECARBOXYLASE 1', 248384),
(383637, 'PTHR45677:SF1', NULL, NULL, NULL, NULL, 'ACIDIC AMINO ACID DECARBOXYLASE GADL1', 248384),
(383638, 'PTHR45677', NULL, NULL, NULL, NULL, 'GLUTAMATE DECARBOXYLASE-RELATED', 248384),
(383639, 'PTHR46190', NULL, NULL, NULL, NULL, 'SI:CH211-201H21.5-RELATED', 248385),
(383640, 'PTHR46190:SF1', NULL, NULL, NULL, NULL, 'SI:CH211-201H21.5-RELATED', 248385),
(383641, 'PTHR31550:SF10', NULL, NULL, NULL, NULL, '', 248386),
(383642, 'PTHR31550:SF2', NULL, NULL, NULL, NULL, '', 248386),
(383643, 'PTHR31550', NULL, NULL, NULL, NULL, '', 248386),
(383644, 'PTHR28156', NULL, NULL, NULL, NULL, 'FAS1 DOMAIN-CONTAINING PROTEIN YDR262W', 248387),
(383645, 'PTHR28156:SF1', NULL, NULL, NULL, NULL, 'FAS1 DOMAIN-CONTAINING PROTEIN YDR262W', 248387),
(383646, 'PTHR31844:SF2', NULL, NULL, NULL, NULL, 'MYELIN-ASSOCIATED NEURITE-OUTGROWTH INHIBITOR', 248388),
(383647, 'PTHR31844:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAM168A', 248388),
(383648, 'PTHR31844', NULL, NULL, NULL, NULL, 'MYELIN-ASSOCIATED NEURITE-OUTGROWTH INHIBITOR-RELATED', 248388),
(383649, 'PTHR37842:SF2', NULL, NULL, NULL, NULL, 'GH115_C DOMAIN-CONTAINING PROTEIN', 248389),
(383650, 'PTHR37842', NULL, NULL, NULL, NULL, '', 248389),
(383651, 'PTHR38743:SF2', NULL, NULL, NULL, NULL, 'DUF2185 DOMAIN-CONTAINING PROTEIN', 248390),
(383652, 'PTHR38743', NULL, NULL, NULL, NULL, 'SIMILAR TO GLYOXYLASE I FAMILY PROTEIN', 248390),
(383653, 'PTHR22957:SF507', NULL, NULL, NULL, NULL, 'RAB GTPASE-ACTIVATING PROTEIN 22', 248391),
(383654, 'PTHR22957:SF462', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 22B', 248391),
(383655, 'PTHR22957:SF187', NULL, NULL, NULL, NULL, 'SMALL G PROTEIN SIGNALING MODULATOR 1', 248391),
(383656, 'PTHR22957:SF466', NULL, NULL, NULL, NULL, 'SI:DKEY-238D18.4', 248391),
(383657, 'PTHR22957:SF621', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 2B', 248391),
(383658, 'PTHR22957:SF467', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 12', 248391),
(383659, 'PTHR22957:SF588', NULL, NULL, NULL, NULL, 'RAB-GAP TBC DOMAIN-CONTAINING PROTEIN', 248391),
(383660, 'PTHR22957:SF225', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 9B', 248391),
(383661, 'PTHR22957:SF502', NULL, NULL, NULL, NULL, 'TRABUCO, ISOFORM C', 248391),
(383662, 'PTHR22957:SF582', NULL, NULL, NULL, NULL, 'YPT/RAB-GAP DOMAIN OF GYP1P SUPERFAMILY PROTEIN', 248391),
(383663, 'PTHR22957:SF26', NULL, NULL, NULL, NULL, 'LD44506P', 248391),
(383664, 'PTHR22957:SF27', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 13', 248391),
(383665, 'PTHR22957:SF514', NULL, NULL, NULL, NULL, 'RAB-GAP TBC DOMAIN-CONTAINING PROTEIN', 248391),
(383666, 'PTHR22957:SF639', NULL, NULL, NULL, NULL, 'GROWTH HORMONE-REGULATED TBC PROTEIN 6', 248391);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(383667, 'PTHR22957:SF352', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER WHACKED', 248391),
(383668, 'PTHR22957:SF597', NULL, NULL, NULL, NULL, 'RAB-GAP TBC DOMAIN-CONTAINING PROTEIN', 248391),
(383669, 'PTHR22957:SF631', NULL, NULL, NULL, NULL, 'SMALL G PROTEIN SIGNALING MODULATOR 2-LIKE ISOFORM X1', 248391),
(383670, 'PTHR22957:SF598', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 26', 248391),
(383671, 'PTHR22957:SF632', NULL, NULL, NULL, NULL, 'RAB-GAP TBC DOMAIN-CONTAINING PROTEIN', 248391),
(383672, 'PTHR22957:SF357', NULL, NULL, NULL, NULL, 'YPT/RAB-GAP DOMAIN OF GYP1P SUPERFAMILY PROTEIN', 248391),
(383673, 'PTHR22957:SF633', NULL, NULL, NULL, NULL, 'RAB-GAP TBC DOMAIN-CONTAINING PROTEIN', 248391),
(383674, 'PTHR22957:SF193', NULL, NULL, NULL, NULL, 'USP6 N-TERMINAL-LIKE PROTEIN', 248391),
(383675, 'PTHR22957:SF194', NULL, NULL, NULL, NULL, 'SMALL G PROTEIN SIGNALING MODULATOR 2', 248391),
(383676, 'PTHR22957:SF195', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 4', 248391),
(383677, 'PTHR22957:SF472', NULL, NULL, NULL, NULL, 'ACTIVATING PROTEIN (EVI5), PUTATIVE (AFU_ORTHOLOGUE AFUA_6G13850)-RELATED', 248391),
(383678, 'PTHR22957:SF593', NULL, NULL, NULL, NULL, 'RAB-GAP TBC DOMAIN-CONTAINING PROTEIN', 248391),
(383679, 'PTHR22957:SF646', NULL, NULL, NULL, NULL, 'YPT/RAB-GAP DOMAIN OF GYP1P SUPERFAMILY PROTEIN', 248391),
(383680, 'PTHR22957:SF647', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY, MEMBER 10C', 248391),
(383681, 'PTHR22957:SF648', NULL, NULL, NULL, NULL, 'OS08G0547200 PROTEIN', 248391),
(383682, 'PTHR22957:SF649', NULL, NULL, NULL, NULL, 'TBC DOMAIN-CONTAINING PROTEIN C23D3.03C', 248391),
(383683, 'PTHR22957:SF640', NULL, NULL, NULL, NULL, 'RABGAP/TBC DOMAIN-CONTAINING PROTEIN', 248391),
(383684, 'PTHR22957:SF641', NULL, NULL, NULL, NULL, 'OS06G0661700 PROTEIN', 248391),
(383685, 'PTHR22957:SF488', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 15-LIKE', 248391),
(383686, 'PTHR22957:SF642', NULL, NULL, NULL, NULL, 'GTPASE ACTIVATOR PROTEIN OF RAB-LIKE SMALL GTPASES-LIKE PROTEIN', 248391),
(383687, 'PTHR22957:SF367', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 14', 248391),
(383688, 'PTHR22957:SF643', NULL, NULL, NULL, NULL, 'RAB-GTPASE-TBC DOMAIN-CONTAINING PROTEIN-RELATED', 248391),
(383689, 'PTHR22957:SF489', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 21', 248391),
(383690, 'PTHR22957:SF644', NULL, NULL, NULL, NULL, 'SMALL G PROTEIN SIGNALING MODULATOR 2-LIKE', 248391),
(383691, 'PTHR22957:SF645', NULL, NULL, NULL, NULL, 'LD27216P', 248391),
(383692, 'PTHR22957:SF360', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 17', 248391),
(383693, 'PTHR22957:SF657', NULL, NULL, NULL, NULL, 'SMALL G PROTEIN SIGNALING MODULATOR 3', 248391),
(383694, 'PTHR22957:SF536', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 9', 248391),
(383695, 'PTHR22957:SF658', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 13-LIKE', 248391),
(383696, 'PTHR22957:SF537', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 3B', 248391),
(383697, 'PTHR22957:SF659', NULL, NULL, NULL, NULL, 'OS07G0525400 PROTEIN', 248391),
(383698, 'PTHR22957:SF495', NULL, NULL, NULL, NULL, 'RAB-GAP TBC DOMAIN-CONTAINING PROTEIN', 248391),
(383699, 'PTHR22957:SF650', NULL, NULL, NULL, NULL, 'OS10G0518100 PROTEIN', 248391),
(383700, 'PTHR22957:SF254', NULL, NULL, NULL, NULL, 'EVI5-LIKE PROTEIN', 248391),
(383701, 'PTHR22957:SF651', NULL, NULL, NULL, NULL, 'RAB-GAP TBC DOMAIN-CONTAINING PROTEIN', 248391),
(383702, 'PTHR22957:SF255', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 22A', 248391),
(383703, 'PTHR22957:SF497', NULL, NULL, NULL, NULL, 'ECOTROPIC VIRAL INTEGRATION SITE 5 ORTHOLOG', 248391),
(383704, 'PTHR22957:SF652', NULL, NULL, NULL, NULL, 'RAB-GAP TBC DOMAIN-CONTAINING PROTEIN', 248391),
(383705, 'PTHR22957:SF498', NULL, NULL, NULL, NULL, 'RAB-GAP TBC DOMAIN-CONTAINING PROTEIN', 248391),
(383706, 'PTHR22957:SF532', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 15-LIKE ISOFORM X1', 248391),
(383707, 'PTHR22957:SF653', NULL, NULL, NULL, NULL, 'FI17814P1', 248391);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(383708, 'PTHR22957:SF654', NULL, NULL, NULL, NULL, 'RAB-GAP TBC DOMAIN-CONTAINING PROTEIN', 248391),
(383709, 'PTHR22957:SF533', NULL, NULL, NULL, NULL, 'OS02G0810500 PROTEIN', 248391),
(383710, 'PTHR22957:SF655', NULL, NULL, NULL, NULL, 'TBC (TRE-2/BUB2/CDC16) DOMAIN FAMILY', 248391),
(383711, 'PTHR22957:SF656', NULL, NULL, NULL, NULL, 'RAB-GTPASE-TBC DOMAIN-CONTAINING PROTEIN-RELATED', 248391),
(383712, 'PTHR22957:SF547', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 16', 248391),
(383713, 'PTHR22957:SF668', NULL, NULL, NULL, NULL, 'RABGAP/TBC DOMAIN-CONTAINING PROTEIN', 248391),
(383714, 'PTHR22957:SF669', NULL, NULL, NULL, NULL, 'PLANT ADHESION MOLECULE 1', 248391),
(383715, 'PTHR22957:SF549', NULL, NULL, NULL, NULL, 'RAB-GAP TBC DOMAIN-CONTAINING PROTEIN', 248391),
(383716, 'PTHR22957:SF660', NULL, NULL, NULL, NULL, 'RAB-GAP TBC DOMAIN-CONTAINING PROTEIN-RELATED', 248391),
(383717, 'PTHR22957:SF540', NULL, NULL, NULL, NULL, 'YPT/RAB-GAP DOMAIN OF GYP1P SUPERFAMILY PROTEIN', 248391),
(383718, 'PTHR22957:SF661', NULL, NULL, NULL, NULL, 'GH16847P', 248391),
(383719, 'PTHR22957:SF662', NULL, NULL, NULL, NULL, 'YPT/RAB-GAP DOMAIN OF GYP1P SUPERFAMILY PROTEIN', 248391),
(383720, 'PTHR22957:SF541', NULL, NULL, NULL, NULL, 'RAB-GAP TBC DOMAIN-CONTAINING PROTEIN', 248391),
(383721, 'PTHR22957:SF300', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 15', 248391),
(383722, 'PTHR22957:SF542', NULL, NULL, NULL, NULL, 'RAB-GAP TBC DOMAIN-CONTAINING PROTEIN', 248391),
(383723, 'PTHR22957:SF663', NULL, NULL, NULL, NULL, 'RAB-GTPASE-TBC DOMAIN-CONTAINING PROTEIN-RELATED', 248391),
(383724, 'PTHR22957:SF664', NULL, NULL, NULL, NULL, 'GROWTH HORMONE-REGULATED TBC PROTEIN 1B', 248391),
(383725, 'PTHR22957:SF268', NULL, NULL, NULL, NULL, 'RAB-GAP TBC DOMAIN-CONTAINING PROTEIN', 248391),
(383726, 'PTHR22957:SF665', NULL, NULL, NULL, NULL, 'RAB-GTPASE-TBC DOMAIN-CONTAINING PROTEIN-RELATED', 248391),
(383727, 'PTHR22957:SF544', NULL, NULL, NULL, NULL, 'YPT/RAB-GAP DOMAIN OF GYP1P SUPERFAMILY PROTEIN', 248391),
(383728, 'PTHR22957:SF666', NULL, NULL, NULL, NULL, 'SI:CH211-266K8.4', 248391),
(383729, 'PTHR22957:SF667', NULL, NULL, NULL, NULL, 'OS09G0528800 PROTEIN', 248391),
(383730, 'PTHR22957:SF260', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 8', 248391),
(383731, 'PTHR22957:SF263', NULL, NULL, NULL, NULL, 'MITOTIC CHECK POINT PROTEIN BUB2', 248391),
(383732, 'PTHR22957:SF679', NULL, NULL, NULL, NULL, 'ECOTROPIC VIRAL INTEGRATION SITE 5 PROTEIN HOMOLOG', 248391),
(383733, 'PTHR22957:SF438', NULL, NULL, NULL, NULL, 'YPT/RAB-GAP DOMAIN OF GYP1P SUPERFAMILY PROTEIN', 248391),
(383734, 'PTHR22957:SF671', NULL, NULL, NULL, NULL, 'RAB-GAP TBC DOMAIN-CONTAINING PROTEIN', 248391),
(383735, 'PTHR22957:SF672', NULL, NULL, NULL, NULL, 'RAB-GAP TBC DOMAIN-CONTAINING PROTEIN', 248391),
(383736, 'PTHR22957:SF673', NULL, NULL, NULL, NULL, 'RAB-GAP TBC DOMAIN-CONTAINING PROTEIN', 248391),
(383737, 'PTHR22957:SF674', NULL, NULL, NULL, NULL, 'YPT/RAB-GAP DOMAIN OF GYP1P SUPERFAMILY PROTEIN-RELATED', 248391),
(383738, 'PTHR22957:SF675', NULL, NULL, NULL, NULL, 'DRAININ', 248391),
(383739, 'PTHR22957:SF676', NULL, NULL, NULL, NULL, 'TBC (TRE-2/BUB2/CDC16) DOMAIN FAMILY', 248391),
(383740, 'PTHR22957:SF677', NULL, NULL, NULL, NULL, 'RAB-GAP TBC DOMAIN-CONTAINING PROTEIN', 248391),
(383741, 'PTHR22957:SF678', NULL, NULL, NULL, NULL, 'RAB-GTPASE-TBC DOMAIN-CONTAINING PROTEIN-RELATED', 248391),
(383742, 'PTHR22957:SF670', NULL, NULL, NULL, NULL, 'YPT/RAB-GAP DOMAIN OF GYP1P SUPERFAMILY PROTEIN-RELATED', 248391),
(383743, 'PTHR22957:SF569', NULL, NULL, NULL, NULL, 'RAB-GTPASE-TBC DOMAIN-CONTAINING PROTEIN-RELATED', 248391),
(383744, 'PTHR22957:SF448', NULL, NULL, NULL, NULL, 'OS01G0908100 PROTEIN', 248391),
(383745, 'PTHR22957:SF207', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 10B', 248391),
(383746, 'PTHR22957:SF605', NULL, NULL, NULL, NULL, 'GROWTH HORMONE-REGULATED TBC PROTEIN 1-LIKE', 248391),
(383747, 'PTHR22957', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER GTPASE-ACTIVATING PROTEIN', 248391),
(383748, 'PTHR22957:SF609', NULL, NULL, NULL, NULL, 'RAB-GTPASE-TBC DOMAIN-CONTAINING PROTEIN-RELATED', 248391);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(383749, 'PTHR22957:SF320', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 8B', 248391),
(383750, 'PTHR22957:SF168', NULL, NULL, NULL, NULL, 'TBC DOMAIN-CONTAINING PROTEIN KINASE-LIKE PROTEIN', 248391),
(383751, 'PTHR22957:SF444', NULL, NULL, NULL, NULL, 'RAB-GAP TBC DOMAIN-CONTAINING PROTEIN', 248391),
(383752, 'PTHR22957:SF565', NULL, NULL, NULL, NULL, 'TBC DOMAIN-CONTAINING PROTEIN C1778.09', 248391),
(383753, 'PTHR22957:SF324', NULL, NULL, NULL, NULL, 'CARABIN', 248391),
(383754, 'PTHR22957:SF204', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 1', 248391),
(383755, 'PTHR22957:SF325', NULL, NULL, NULL, NULL, 'RAB-GAP TBC DOMAIN-CONTAINING PROTEIN', 248391),
(383756, 'PTHR22957:SF601', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 30', 248391),
(383757, 'PTHR22957:SF616', NULL, NULL, NULL, NULL, 'RAB-GAP TBC DOMAIN-CONTAINING PROTEIN', 248391),
(383758, 'PTHR22957:SF618', NULL, NULL, NULL, NULL, 'RE02292P', 248391),
(383759, 'PTHR22957:SF572', NULL, NULL, NULL, NULL, 'YPT/RAB-GAP DOMAIN OF GYP1P SUPERFAMILY PROTEIN-RELATED', 248391),
(383760, 'PTHR22957:SF333', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 25', 248391),
(383761, 'PTHR22957:SF575', NULL, NULL, NULL, NULL, 'RAB-GAP TBC DOMAIN-CONTAINING PROTEIN', 248391),
(383762, 'PTHR22957:SF212', NULL, NULL, NULL, NULL, 'GROWTH HORMONE-REGULATED TBC PROTEIN 1', 248391),
(383763, 'PTHR22957:SF456', NULL, NULL, NULL, NULL, 'YPT/RAB-GAP DOMAIN OF GYP1P SUPERFAMILY PROTEIN', 248391),
(383764, 'PTHR22957:SF457', NULL, NULL, NULL, NULL, 'RAB-GAP TBC DOMAIN-CONTAINING PROTEIN-RELATED', 248391),
(383765, 'PTHR22957:SF215', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 10A', 248391),
(383766, 'PTHR22957:SF612', NULL, NULL, NULL, NULL, 'OS05G0465100 PROTEIN', 248391),
(383767, 'PTHR22957:SF337', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 5', 248391),
(383768, 'PTHR22957:SF458', NULL, NULL, NULL, NULL, 'RELATED TO THE N TERMINUS OF TRE ONCOGENE, ISOFORM A', 248391),
(383769, 'PTHR22957:SF570', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 2A', 248391),
(383770, 'PTHR22957:SF571', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 3-RELATED', 248391),
(383771, 'PTHR13471', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL', 248392),
(383772, 'PTHR13471:SF0', NULL, NULL, NULL, NULL, 'NUCLEAR EXOSOME REGULATOR NRDE2', 248392),
(383773, 'PTHR36960:SF1', NULL, NULL, NULL, NULL, 'SI:DKEY-32E6.3', 248393),
(383774, 'PTHR36960', NULL, NULL, NULL, NULL, 'SI:DKEY-32E6.3', 248393),
(383775, 'PTHR31960:SF8', NULL, NULL, NULL, NULL, 'OS02G0675800 PROTEIN', 248394),
(383776, 'PTHR31960:SF30', NULL, NULL, NULL, NULL, 'OS04G0571300 PROTEIN', 248394),
(383777, 'PTHR31960:SF3', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-A13', 248394),
(383778, 'PTHR31960:SF22', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-A12', 248394),
(383779, 'PTHR31960:SF2', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-A15', 248394),
(383780, 'PTHR31960:SF32', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-A13', 248394),
(383781, 'PTHR31960:SF21', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN', 248394),
(383782, 'PTHR31960:SF20', NULL, NULL, NULL, NULL, 'OS09G0525300 PROTEIN', 248394),
(383783, 'PTHR31960:SF16', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-A11', 248394),
(383784, 'PTHR31960:SF27', NULL, NULL, NULL, NULL, 'PHLOEM PROTEIN 2-A11-RELATED', 248394),
(383785, 'PTHR31960:SF37', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-A13-LIKE', 248394),
(383786, 'PTHR31960:SF26', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN', 248394),
(383787, 'PTHR31960:SF36', NULL, NULL, NULL, NULL, '', 248394),
(383788, 'PTHR31960:SF25', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-A15-LIKE', 248394),
(383789, 'PTHR31960:SF35', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-A13-LIKE', 248394),
(383790, 'PTHR31960:SF19', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-A15-LIKE', 248394),
(383791, 'PTHR31960:SF18', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-A14', 248394),
(383792, 'PTHR31960:SF29', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248394),
(383793, 'PTHR31960', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-A15', 248394);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(383794, 'PTHR31960:SF28', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN, PHLOEM PROTEIN 2-LIKE PROTEIN-RELATED', 248394),
(383795, 'PTHR31960:SF17', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-A12-LIKE', 248394),
(383796, 'PTHR33164:SF93', NULL, NULL, NULL, NULL, 'POSSIBLE TRANSCRIPTIONAL REGULATORY PROTEIN (PROBABLY MARR-FAMILY)', 248395),
(383797, 'PTHR33164:SF94', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', 248395),
(383798, 'PTHR33164:SF91', NULL, NULL, NULL, NULL, 'HTH MARR-TYPE DOMAIN-CONTAINING PROTEIN', 248395),
(383799, 'PTHR33164:SF92', NULL, NULL, NULL, NULL, 'MARR-FAMILY TRANSCRIPTIONAL REGULATOR', 248395),
(383800, 'PTHR33164:SF90', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 248395),
(383801, 'PTHR33164:SF13', NULL, NULL, NULL, NULL, '4-HYDROXYPHENYLACETATE CATABOLISM PROTEIN', 248395),
(383802, 'PTHR33164:SF57', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR MPRA', 248395),
(383803, 'PTHR33164:SF58', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR HPR', 248395),
(383804, 'PTHR33164:SF5', NULL, NULL, NULL, NULL, 'ORGANIC HYDROPEROXIDE RESISTANCE TRANSCRIPTIONAL REGULATOR', 248395),
(383805, 'PTHR33164:SF56', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR MHQR', 248395),
(383806, 'PTHR33164:SF97', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR ROT', 248395),
(383807, 'PTHR33164:SF98', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 248395),
(383808, 'PTHR33164:SF54', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REPRESSOR RV2887', 248395),
(383809, 'PTHR33164:SF95', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR SARR', 248395),
(383810, 'PTHR33164:SF96', NULL, NULL, NULL, NULL, 'MARR-FAMILY TRANSCRIPTIONAL REGULATOR', 248395),
(383811, 'PTHR33164', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, MARR FAMILY', 248395),
(383812, 'PTHR33164:SF44', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 248395),
(383813, 'PTHR33164:SF88', NULL, NULL, NULL, NULL, 'MARR-FAMILY TRANSCRIPTONAL REGULATOR-RELATED', 248395),
(383814, 'PTHR33164:SF67', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, MARR FAMILY', 248395),
(383815, 'PTHR33164:SF45', NULL, NULL, NULL, NULL, 'POSSIBLE TRANSCRIPTIONAL REGULATORY PROTEIN', 248395),
(383816, 'PTHR33164:SF89', NULL, NULL, NULL, NULL, 'MARR FAMILY REGULATORY PROTEIN', 248395),
(383817, 'PTHR33164:SF86', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN-RELATED', 248395),
(383818, 'PTHR33164:SF64', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR SLYA', 248395),
(383819, 'PTHR33164:SF87', NULL, NULL, NULL, NULL, 'MULTIPLE ANTIBIOTIC RESISTANCE PROTEIN MARR', 248395),
(383820, 'PTHR33164:SF43', NULL, NULL, NULL, NULL, 'MARR-FAMILY TRANSCRIPTIONAL REGULATOR-RELATED', 248395),
(383821, 'PTHR33164:SF40', NULL, NULL, NULL, NULL, 'MARR FAMILY TRANSCRIPTIONAL REGULATORY PROTEIN', 248395),
(383822, 'PTHR33164:SF85', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, MARR FAMILY', 248395),
(383823, 'PTHR32035:SF3', NULL, NULL, NULL, NULL, 'AURORA KINASE A-INTERACTING PROTEIN', 248396),
(383824, 'PTHR32035:SF11', NULL, NULL, NULL, NULL, 'DUF1713 DOMAIN-CONTAINING PROTEIN', 248396),
(383825, 'PTHR32035', NULL, NULL, NULL, NULL, 'AURORA KINASE A-INTERACTING PROTEIN', 248396),
(383826, 'PTHR31276:SF17', NULL, NULL, NULL, NULL, 'BNAANNG04830D PROTEIN', 248397),
(383827, 'PTHR31276:SF15', NULL, NULL, NULL, NULL, 'BNAC05G50330D PROTEIN', 248397),
(383828, 'PTHR31276:SF16', NULL, NULL, NULL, NULL, 'BNAA03G17460D PROTEIN', 248397),
(383829, 'PTHR31276:SF13', NULL, NULL, NULL, NULL, 'PROTEIN MIZU-KUSSEI 1-LIKE', 248397),
(383830, 'PTHR31276:SF14', NULL, NULL, NULL, NULL, 'PROTEIN MIZU-KUSSEI 1-LIKE', 248397),
(383831, 'PTHR31276:SF11', NULL, NULL, NULL, NULL, '', 248397),
(383832, 'PTHR31276:SF12', NULL, NULL, NULL, NULL, 'BNAANNG33630D PROTEIN', 248397),
(383833, 'PTHR31276:SF6', NULL, NULL, NULL, NULL, 'PROTEIN MIZU-KUSSEI 1', 248397),
(383834, 'PTHR31276:SF10', NULL, NULL, NULL, NULL, 'PROTEIN MIZU-KUSSEI 1', 248397),
(383835, 'PTHR31276:SF4', NULL, NULL, NULL, NULL, 'DUF617 FAMILY PROTEIN', 248397);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(383836, 'PTHR31276', NULL, NULL, NULL, NULL, '', 248397),
(383837, 'PTHR40269:SF1', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN-RELATED', 248398),
(383838, 'PTHR40269', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN-RELATED', 248398),
(383839, 'PTHR46405', NULL, NULL, NULL, NULL, 'OS05G0141500 PROTEIN', 248399),
(383840, 'PTHR46405:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RF4-RELATED', 248399),
(383841, 'PTHR46405:SF3', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 248399),
(383842, 'PTHR46405:SF2', NULL, NULL, NULL, NULL, 'OS05G0141500 PROTEIN', 248399),
(383843, 'PTHR46405:SF11', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RF298 ISOFORM X1-RELATED', 248399),
(383844, 'PTHR46405:SF9', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RF298-RELATED', 248399),
(383845, 'PTHR46405:SF4', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RF298-RELATED', 248399),
(383846, 'PTHR46405:SF7', NULL, NULL, NULL, NULL, 'MND1-INTERACTING PROTEIN 1', 248399),
(383847, 'PTHR46405:SF6', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 248399),
(383848, 'PTHR19375:SF481', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAK2-RELATED', 248400),
(383849, 'PTHR19375:SF483', NULL, NULL, NULL, NULL, '', 248400),
(383850, 'PTHR19375:SF484', NULL, NULL, NULL, NULL, 'HEAT SHOCK COGNATE 70', 248400),
(383851, 'PTHR19375:SF364', NULL, NULL, NULL, NULL, '', 248400),
(383852, 'PTHR19375:SF485', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70-RELATED PROTEIN 5', 248400),
(383853, 'PTHR19375:SF398', NULL, NULL, NULL, NULL, 'SHOCK 70 KDA PROTEIN, PUTATIVE, EXPRESSED-RELATED', 248400),
(383854, 'PTHR19375:SF476', NULL, NULL, NULL, NULL, 'BNAA08G14780D PROTEIN', 248400),
(383855, 'PTHR19375:SF157', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM CHAPERONE BIP HOMOLOG', 248400),
(383856, 'PTHR19375:SF355', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN (HSP70/DNAK)-RELATED', 248400),
(383857, 'PTHR19375:SF399', NULL, NULL, NULL, NULL, '', 248400),
(383858, 'PTHR19375:SF356', NULL, NULL, NULL, NULL, 'OS09G0491772 PROTEIN', 248400),
(383859, 'PTHR19375:SF510', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN, MITOCHONDRIAL', 248400),
(383860, 'PTHR19375:SF511', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN 1-RELATED', 248400),
(383861, 'PTHR19375:SF434', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN 3', 248400),
(383862, 'PTHR19375:SF357', NULL, NULL, NULL, NULL, '', 248400),
(383863, 'PTHR19375:SF512', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN 6, CHLOROPLASTIC-RELATED', 248400),
(383864, 'PTHR19375:SF479', NULL, NULL, NULL, NULL, 'HEAT SHOCK COGNATE 70 KDA PROTEIN 2-LIKE', 248400),
(383865, 'PTHR19375:SF513', NULL, NULL, NULL, NULL, 'SLR0086 PROTEIN', 248400),
(383866, 'PTHR19375:SF514', NULL, NULL, NULL, NULL, 'BNAA03G17100D PROTEIN', 248400),
(383867, 'PTHR19375:SF515', NULL, NULL, NULL, NULL, 'SHOCK PROTEIN 70, PUTATIVE-RELATED', 248400),
(383868, 'PTHR19375:SF438', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN 14', 248400),
(383869, 'PTHR19375:SF439', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN HSCC', 248400),
(383870, 'PTHR19375:SF516', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248400),
(383871, 'PTHR19375:SF517', NULL, NULL, NULL, NULL, 'HEAT SHOCK COGNATE 70-KD PROTEIN, TANDEM DUPLICATE 2-RELATED', 248400),
(383872, 'PTHR19375:SF518', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 68-RELATED', 248400),
(383873, 'PTHR19375:SF519', NULL, NULL, NULL, NULL, '', 248400),
(383874, 'PTHR19375', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 70KDA', 248400),
(383875, 'PTHR19375:SF492', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN BIP1-RELATED', 248400),
(383876, 'PTHR19375:SF493', NULL, NULL, NULL, NULL, '70 KDA HEAT SHOCK PROTEIN', 248400),
(383877, 'PTHR19375:SF495', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN', 248400),
(383878, 'PTHR19375:SF176', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN HSCA', 248400),
(383879, 'PTHR19375:SF452', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 248400),
(383880, 'PTHR19375:SF210', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN 1-LIKE', 248400);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(383881, 'PTHR19375:SF443', NULL, NULL, NULL, NULL, '', 248400),
(383882, 'PTHR19375:SF168', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN 6-RELATED', 248400),
(383883, 'PTHR19375:SF520', NULL, NULL, NULL, NULL, 'HEAT SHOCK COGNATE 70 KDA PROTEIN 2-LIKE', 248400),
(383884, 'PTHR19375:SF201', NULL, NULL, NULL, NULL, 'OS06G0212900 PROTEIN', 248400),
(383885, 'PTHR19375:SF521', NULL, NULL, NULL, NULL, 'HEAT SHOCK COGNATE 70 KDA PROTEIN 2', 248400),
(383886, 'PTHR19375:SF169', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN 13', 248400),
(383887, 'PTHR19375:SF444', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN, MITOCHONDRIAL', 248400),
(383888, 'PTHR19375:SF522', NULL, NULL, NULL, NULL, 'HSP70 FAMILY CHAPERONE', 248400),
(383889, 'PTHR19375:SF489', NULL, NULL, NULL, NULL, '', 248400),
(383890, 'PTHR19375:SF369', NULL, NULL, NULL, NULL, '', 248400),
(383891, 'PTHR19375:SF523', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 37C-RELATED', 248400),
(383892, 'PTHR19375:SF524', NULL, NULL, NULL, NULL, 'OS12G0569700 PROTEIN', 248400),
(383893, 'PTHR19375:SF525', NULL, NULL, NULL, NULL, 'HEAT SHOCK COGNATE 70 KDA PROTEIN-RELATED', 248400),
(383894, 'PTHR19375:SF526', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 70B', 248400),
(383895, 'PTHR19375:SF207', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN', 248400),
(383896, 'PTHR19375:SF405', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN BIP4', 248400),
(383897, 'PTHR19375:SF408', NULL, NULL, NULL, NULL, '', 248400),
(383898, 'PTHR19375:SF380', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM CHAPERONE BIP', 248400),
(383899, 'PTHR19375:SF381', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN', 248400),
(383900, 'PTHR19375:SF382', NULL, NULL, NULL, NULL, 'HEAT SHOCK-RELATED 70 KDA PROTEIN 2', 248400),
(383901, 'PTHR19375:SF184', NULL, NULL, NULL, NULL, 'STRESS-70 PROTEIN, MITOCHONDRIAL', 248400),
(383902, 'PTHR19375:SF461', NULL, NULL, NULL, NULL, 'HEAT SHOCK COGNATE PROTEIN 70-1-RELATED', 248400),
(383903, 'PTHR19375:SF462', NULL, NULL, NULL, NULL, '', 248400),
(383904, 'PTHR19375:SF385', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN SSA3-RELATED', 248400),
(383905, 'PTHR19375:SF144', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM CHAPERONE BIP', 248400),
(383906, 'PTHR19375:SF463', NULL, NULL, NULL, NULL, 'HSP70-LIKE PROTEIN', 248400),
(383907, 'PTHR19375:SF211', NULL, NULL, NULL, NULL, '70 KDA HEAT SHOCK PROTEIN', 248400),
(383908, 'PTHR19375:SF498', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN', 248400),
(383909, 'PTHR19375:SF454', NULL, NULL, NULL, NULL, 'HEAT SHOCK COGNATE 70 KDA PROTEIN 2-LIKE', 248400),
(383910, 'PTHR19375:SF412', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 70 FAMILY, PEPTIDE-BINDING DOMAIN PROTEIN-RELATED', 248400),
(383911, 'PTHR19375:SF379', NULL, NULL, NULL, NULL, 'HEAT SHOCK COGNATE 71 KDA PROTEIN', 248400),
(383912, 'PTHR19375:SF415', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 70 FAMILY, PEPTIDE-BINDING DOMAIN PROTEIN-RELATED', 248400),
(383913, 'PTHR19375:SF416', NULL, NULL, NULL, NULL, '', 248400),
(383914, 'PTHR19375:SF419', NULL, NULL, NULL, NULL, 'BNAA03G55950D PROTEIN', 248400),
(383915, 'PTHR19375:SF197', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER BIOGENESIS CHAPERONE, MITOCHONDRIAL', 248400),
(383916, 'PTHR19375:SF395', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN COGNATE 1-RELATED', 248400),
(383917, 'PTHR19375:SF396', NULL, NULL, NULL, NULL, '', 248400),
(383918, 'PTHR19375:SF430', NULL, NULL, NULL, NULL, 'OS01G0688900 PROTEIN', 248400),
(383919, 'PTHR19375:SF397', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN 9, MITOCHONDRIAL', 248400),
(383920, 'PTHR19375:SF464', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 70-3', 248400),
(383921, 'PTHR19375:SF101', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN 8', 248400),
(383922, 'PTHR19375:SF421', NULL, NULL, NULL, NULL, 'LUMINAL-BINDING PROTEIN 4-LIKE', 248400),
(383923, 'PTHR19375:SF465', NULL, NULL, NULL, NULL, 'HEAT SHOCK COGNATE 70 KDA PROTEIN 1', 248400),
(383924, 'PTHR19375:SF223', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN 1A-RELATED', 248400);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(383925, 'PTHR19375:SF467', NULL, NULL, NULL, NULL, 'RIBOSOME-ASSOCIATED MOLECULAR CHAPERONE SSB1-RELATED', 248400),
(383926, 'PTHR19375:SF423', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 70 FAMILY, PEPTIDE-BINDING DOMAIN PROTEIN-RELATED', 248400),
(383927, 'PTHR19375:SF501', NULL, NULL, NULL, NULL, 'BNAC07G48050D PROTEIN', 248400),
(383928, 'PTHR19375:SF502', NULL, NULL, NULL, NULL, 'SHOCK COGNATE 70 KDA PROTEIN 2, PUTATIVE, EXPRESSED-RELATED', 248400),
(383929, 'PTHR19375:SF503', NULL, NULL, NULL, NULL, 'CHLOROPLAST HEAT SHOCK PROTEIN HSP70-1', 248400),
(383930, 'PTHR19375:SF504', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 70 FAMILY-RELATED', 248400),
(383931, 'PTHR19375:SF505', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN 10, MITOCHONDRIAL', 248400),
(383932, 'PTHR19375:SF506', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAK2', 248400),
(383933, 'PTHR19375:SF429', NULL, NULL, NULL, NULL, '', 248400),
(383934, 'PTHR19375:SF507', NULL, NULL, NULL, NULL, 'BNAA01G13780D PROTEIN', 248400),
(383935, 'PTHR19375:SF508', NULL, NULL, NULL, NULL, '', 248400),
(383936, 'PTHR19375:SF509', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 70', 248400),
(383937, 'PTHR33917:SF2', NULL, NULL, NULL, NULL, 'PROTEIN EXECUTER 2, CHLOROPLASTIC', 248401),
(383938, 'PTHR33917:SF3', NULL, NULL, NULL, NULL, 'PROTEIN EXECUTER 1, CHLOROPLASTIC', 248401),
(383939, 'PTHR33917', NULL, NULL, NULL, NULL, 'PROTEIN EXECUTER 1, CHLOROPLASTIC', 248401),
(383940, 'PTHR33917:SF4', NULL, NULL, NULL, NULL, 'DUF3506 DOMAIN-CONTAINING PROTEIN', 248401),
(383941, 'PTHR28038:SF1', NULL, NULL, NULL, NULL, 'ADL329WP', 248402),
(383942, 'PTHR28038', NULL, NULL, NULL, NULL, 'ADL329WP', 248402),
(383943, 'PTHR12253:SF19', NULL, NULL, NULL, NULL, 'GROUP 3 SECRETORY PHOSPHOLIPASE A2', 248403),
(383944, 'PTHR12253:SF38', NULL, NULL, NULL, NULL, 'PA2C DOMAIN-CONTAINING PROTEIN-RELATED', 248403),
(383945, 'PTHR12253:SF37', NULL, NULL, NULL, NULL, 'PROTEIN-INTERACTING WITH CYCLIN A1', 248403),
(383946, 'PTHR12253:SF17', NULL, NULL, NULL, NULL, 'PROTEIN PROCA1', 248403),
(383947, 'PTHR12253:SF39', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLCHOLINE 2-ACYLHYDROLASE', 248403),
(383948, 'PTHR12253:SF34', NULL, NULL, NULL, NULL, 'PA2C DOMAIN-CONTAINING PROTEIN', 248403),
(383949, 'PTHR12253:SF36', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLCHOLINE 2-ACYLHYDROLASE', 248403),
(383950, 'PTHR12253', NULL, NULL, NULL, NULL, 'RH14732P', 248403),
(383951, 'PTHR12253:SF41', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLCHOLINE 2-ACYLHYDROLASE', 248403),
(383952, 'PTHR12253:SF42', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLCHOLINE 2-ACYLHYDROLASE', 248403),
(383953, 'PTHR47779:SF1', NULL, NULL, NULL, NULL, 'SYNTHASE (CCG-9), PUTATIVE (AFU_ORTHOLOGUE AFUA_3G12100)-RELATED', 248404),
(383954, 'PTHR47779:SF2', NULL, NULL, NULL, NULL, 'SHOCK TREHALOSE SYNTHASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G14780)-RELATED', 248404),
(383955, 'PTHR47779', NULL, NULL, NULL, NULL, 'SYNTHASE (CCG-9), PUTATIVE (AFU_ORTHOLOGUE AFUA_3G12100)-RELATED', 248404),
(383956, 'PTHR10240', NULL, NULL, NULL, NULL, 'ALPHA-S1-CASEIN', 248405),
(383957, 'PTHR10240:SF0', NULL, NULL, NULL, NULL, 'ALPHA-S1-CASEIN', 248405),
(383958, 'PTHR23275:SF31', NULL, NULL, NULL, NULL, 'TNFR-CYS DOMAIN-CONTAINING PROTEIN', 248406),
(383959, 'PTHR23275:SF99', NULL, NULL, NULL, NULL, '', 248406),
(383960, 'PTHR23275', NULL, NULL, NULL, NULL, 'CABRIOLET.-RELATED', 248406),
(383961, 'PTHR23275:SF100', NULL, NULL, NULL, NULL, 'TNFR-CYS DOMAIN-CONTAINING PROTEIN', 248406),
(383962, 'PTHR46082:SF6', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN-RELATED', 248407),
(383963, 'PTHR46082', NULL, NULL, NULL, NULL, 'ATP/GTP-BINDING PROTEIN-RELATED', 248407),
(383964, 'PTHR46082:SF8', NULL, NULL, NULL, NULL, 'PNP_UDP_1 DOMAIN-CONTAINING PROTEIN-RELATED', 248407),
(383965, 'PTHR46082:SF10', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 248407),
(383966, 'PTHR12335:SF7', NULL, NULL, NULL, NULL, 'RT03134P', 248408),
(383967, 'PTHR12335:SF3', NULL, NULL, NULL, NULL, 'IP11896P', 248408),
(383968, 'PTHR12335:SF4', NULL, NULL, NULL, NULL, 'TIPE HOMOLOG 1, ISOFORM B', 248408);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(383969, 'PTHR12335:SF5', NULL, NULL, NULL, NULL, 'IP20336P', 248408),
(383970, 'PTHR12335:SF6', NULL, NULL, NULL, NULL, 'PROTEIN TIPE', 248408),
(383971, 'PTHR12335', NULL, NULL, NULL, NULL, 'TIPE PROTEIN  TEMPERATURE-INDUCED PARALYTIC E', 248408),
(383972, 'PTHR41263', NULL, NULL, NULL, NULL, 'ASPARTYL-PHOSPHATE PHOSPHATASE YISI', 248409),
(383973, 'PTHR41263:SF1', NULL, NULL, NULL, NULL, 'ASPARTYL-PHOSPHATE PHOSPHATASE YISI', 248409),
(383974, 'PTHR40129:SF2', NULL, NULL, NULL, NULL, '', 248410),
(383975, 'PTHR40129', NULL, NULL, NULL, NULL, '', 248410),
(383976, 'PTHR34237:SF5', NULL, NULL, NULL, NULL, 'PAREP8', 248411),
(383977, 'PTHR34237:SF4', NULL, NULL, NULL, NULL, 'PAREP8', 248411),
(383978, 'PTHR34237', NULL, NULL, NULL, NULL, 'PAREP8-RELATED', 248411),
(383979, 'PTHR34237:SF1', NULL, NULL, NULL, NULL, 'PAREP8', 248411),
(383980, 'PTHR12110:SF55', NULL, NULL, NULL, NULL, 'AP_ENDONUC_2 DOMAIN-CONTAINING PROTEIN', 248412),
(383981, 'PTHR12110:SF47', NULL, NULL, NULL, NULL, '', 248412),
(383982, 'PTHR12110:SF41', NULL, NULL, NULL, NULL, 'INOSOSE DEHYDRATASE', 248412),
(383983, 'PTHR12110:SF52', NULL, NULL, NULL, NULL, 'BLR2842 PROTEIN', 248412),
(383984, 'PTHR12110:SF53', NULL, NULL, NULL, NULL, 'BLR5974 PROTEIN', 248412),
(383985, 'PTHR12110:SF54', NULL, NULL, NULL, NULL, 'XYLOSE ISOMERASE', 248412),
(383986, 'PTHR12110:SF21', NULL, NULL, NULL, NULL, 'DEHYDRATASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G08740)-RELATED', 248412),
(383987, 'PTHR12110', NULL, NULL, NULL, NULL, 'HYDROXYPYRUVATE ISOMERASE', 248412),
(383988, 'PTHR12110:SF48', NULL, NULL, NULL, NULL, 'BLL3656 PROTEIN', 248412),
(383989, 'PTHR12110:SF38', NULL, NULL, NULL, NULL, 'DIOXYGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G00240)-RELATED', 248412),
(383990, 'PTHR31871:SF49', NULL, NULL, NULL, NULL, 'BNAA02G25270D PROTEIN', 248413),
(383991, 'PTHR31871:SF46', NULL, NULL, NULL, NULL, 'RESPONSE REGULATORY DOMAIN-CONTAINING PROTEIN', 248413),
(383992, 'PTHR31871:SF24', NULL, NULL, NULL, NULL, '', 248413),
(383993, 'PTHR31871:SF48', NULL, NULL, NULL, NULL, 'ANGIOTENSIN-CONVERTING ENZYME 2-RELATED', 248413),
(383994, 'PTHR31871:SF47', NULL, NULL, NULL, NULL, 'BNAC04G01240D PROTEIN', 248413),
(383995, 'PTHR31871:SF42', NULL, NULL, NULL, NULL, 'BNAC06G02700D PROTEIN', 248413),
(383996, 'PTHR31871:SF41', NULL, NULL, NULL, NULL, 'BNAA05G28530D PROTEIN', 248413),
(383997, 'PTHR31871:SF22', NULL, NULL, NULL, NULL, 'CALPAIN CATALYTIC DOMAIN-CONTAINING PROTEIN', 248413),
(383998, 'PTHR31871:SF60', NULL, NULL, NULL, NULL, 'ANGIOTENSIN-CONVERTING ENZYME 2-RELATED', 248413),
(383999, 'PTHR31871:SF38', NULL, NULL, NULL, NULL, 'OS03G0280400 PROTEIN', 248413),
(384000, 'PTHR31871:SF16', NULL, NULL, NULL, NULL, '', 248413),
(384001, 'PTHR31871:SF35', NULL, NULL, NULL, NULL, 'OS06G0705300 PROTEIN', 248413),
(384002, 'PTHR31871:SF9', NULL, NULL, NULL, NULL, 'HELICASE WITH ZINC FINGER PROTEIN', 248413),
(384003, 'PTHR31871:SF57', NULL, NULL, NULL, NULL, 'WAX2_C DOMAIN-CONTAINING PROTEIN', 248413),
(384004, 'PTHR31871:SF56', NULL, NULL, NULL, NULL, 'BNAA02G25280D PROTEIN', 248413),
(384005, 'PTHR31871:SF59', NULL, NULL, NULL, NULL, '', 248413),
(384006, 'PTHR31871:SF37', NULL, NULL, NULL, NULL, '', 248413),
(384007, 'PTHR31871:SF8', NULL, NULL, NULL, NULL, 'OS01G0837600 PROTEIN', 248413),
(384008, 'PTHR31871:SF14', NULL, NULL, NULL, NULL, 'OS01G0220200 PROTEIN', 248413),
(384009, 'PTHR31871:SF58', NULL, NULL, NULL, NULL, 'BNAA05G34580D PROTEIN', 248413),
(384010, 'PTHR31871:SF31', NULL, NULL, NULL, NULL, '', 248413),
(384011, 'PTHR31871:SF53', NULL, NULL, NULL, NULL, '', 248413),
(384012, 'PTHR31871:SF52', NULL, NULL, NULL, NULL, '', 248413),
(384013, 'PTHR31871:SF55', NULL, NULL, NULL, NULL, '', 248413),
(384014, 'PTHR31871:SF54', NULL, NULL, NULL, NULL, 'OS02G0658350 PROTEIN', 248413),
(384015, 'PTHR31871:SF51', NULL, NULL, NULL, NULL, 'ANGIOTENSIN-CONVERTING ENZYME 2-RELATED', 248413),
(384016, 'PTHR31871:SF50', NULL, NULL, NULL, NULL, 'ARGININOSUCCINATE LYASE', 248413),
(384017, 'PTHR31871:SF5', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 248413);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(384018, 'PTHR31871:SF1', NULL, NULL, NULL, NULL, 'HISTIDINE-TRNA LIGASE', 248413),
(384019, 'PTHR31871:SF2', NULL, NULL, NULL, NULL, 'OS05G0462000 PROTEIN', 248413),
(384020, 'PTHR31871', NULL, NULL, NULL, NULL, 'OS02G0137100 PROTEIN', 248413),
(384021, 'PTHR28615:SF1', NULL, NULL, NULL, NULL, 'PAK4-INHIBITOR INKA1', 248414),
(384022, 'PTHR28615:SF2', NULL, NULL, NULL, NULL, 'PAK4-INHIBITOR INKA2', 248414),
(384023, 'PTHR28615', NULL, NULL, NULL, NULL, 'PAK4-INHIBITOR INKA1-RELATED', 248414),
(384024, 'PTHR12270', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE-RELATED', 248415),
(384025, 'PTHR12270:SF23', NULL, NULL, NULL, NULL, 'LARGE XYLOSYL- AND GLUCURONYLTRANSFERASE 2', 248415),
(384026, 'PTHR12270:SF48', NULL, NULL, NULL, NULL, 'LARGE XYLOSYL- AND GLUCURONYLTRANSFERASE 1', 248415),
(384027, 'PTHR12270:SF25', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE-LIKE PROTEIN LARGE', 248415),
(384028, 'PTHR12270:SF53', NULL, NULL, NULL, NULL, '', 248415),
(384029, 'PTHR12270:SF52', NULL, NULL, NULL, NULL, '', 248415),
(384030, 'PTHR12270:SF51', NULL, NULL, NULL, NULL, '', 248415),
(384031, 'PTHR12270:SF50', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE-LIKE PROTEIN GNT12-RELATED', 248415),
(384032, 'PTHR45969:SF46', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 248416),
(384033, 'PTHR45969:SF68', NULL, NULL, NULL, NULL, 'FINGER DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G12190)-RELATED', 248416),
(384034, 'PTHR45969:SF69', NULL, NULL, NULL, NULL, 'ZINC FINGER, C3HC4 TYPE FAMILY PROTEIN', 248416),
(384035, 'PTHR45969:SF25', NULL, NULL, NULL, NULL, 'OS02G0682300 PROTEIN', 248416),
(384036, 'PTHR45969:SF22', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RHA1B-LIKE', 248416),
(384037, 'PTHR45969:SF44', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 248416),
(384038, 'PTHR45969:SF45', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 248416),
(384039, 'PTHR45969:SF49', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RHA1B-LIKE', 248416),
(384040, 'PTHR45969:SF71', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 248416),
(384041, 'PTHR45969:SF1', NULL, NULL, NULL, NULL, 'BRASSINOSTEROID-RESPONSIVE RING-H2', 248416),
(384042, 'PTHR45969:SF72', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 248416),
(384043, 'PTHR45969:SF70', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 248416),
(384044, 'PTHR45969:SF53', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 248416),
(384045, 'PTHR45969:SF5', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RHA2A', 248416),
(384046, 'PTHR45969:SF31', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 248416),
(384047, 'PTHR45969:SF75', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RHA1B-LIKE', 248416),
(384048, 'PTHR45969:SF10', NULL, NULL, NULL, NULL, 'BRASSINOSTEROID-RESPONSIVE RING PROTEIN 1-RELATED', 248416),
(384049, 'PTHR45969:SF54', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 248416),
(384050, 'PTHR45969:SF76', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RHA2A-LIKE', 248416),
(384051, 'PTHR45969:SF51', NULL, NULL, NULL, NULL, 'OS02G0681200 PROTEIN', 248416),
(384052, 'PTHR45969:SF73', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT 11 RING-H2 FINGER PROTEIN', 248416),
(384053, 'PTHR45969:SF74', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RHA2B', 248416),
(384054, 'PTHR45969:SF9', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 248416),
(384055, 'PTHR45969:SF8', NULL, NULL, NULL, NULL, 'OS04G0580800 PROTEIN', 248416),
(384056, 'PTHR45969', NULL, NULL, NULL, NULL, 'RING ZINC FINGER PROTEIN-RELATED', 248416),
(384057, 'PTHR45969:SF79', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 248416),
(384058, 'PTHR45969:SF58', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RHA2B-RELATED', 248416),
(384059, 'PTHR45969:SF11', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 248416),
(384060, 'PTHR45969:SF77', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT 11 RING-H2 FINGER PROTEIN', 248416); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(384061, 'PTHR45969:SF55', NULL, NULL, NULL, NULL, 'OS07G0686300 PROTEIN', 248416),
(384062, 'PTHR45969:SF33', NULL, NULL, NULL, NULL, 'RING ZINC FINGER PROTEIN-RELATED', 248416),
(384063, 'PTHR45969:SF78', NULL, NULL, NULL, NULL, 'ZINC FINGER, C3HC4 TYPE (RING FINGER) PROTEIN', 248416),
(384064, 'PTHR45969:SF12', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RHA1A-RELATED', 248416),
(384065, 'PTHR45969:SF56', NULL, NULL, NULL, NULL, 'OS01G0266100 PROTEIN', 248416),
(384066, 'PTHR45969:SF82', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 248416),
(384067, 'PTHR45969:SF83', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 248416),
(384068, 'PTHR45969:SF80', NULL, NULL, NULL, NULL, 'ZINC FINGER, C3HC4 TYPE FAMILY PROTEIN', 248416),
(384069, 'PTHR45969:SF81', NULL, NULL, NULL, NULL, 'OS04G0580866 PROTEIN', 248416),
(384070, 'PTHR45969:SF42', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 248416),
(384071, 'PTHR45969:SF20', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 248416),
(384072, 'PTHR45969:SF65', NULL, NULL, NULL, NULL, 'OS08G0157400 PROTEIN', 248416),
(384073, 'PTHR45969:SF84', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 248416),
(384074, 'PTHR45969:SF62', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 248416),
(384075, 'PTHR45969:SF41', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 248416),
(384076, 'PTHR12287:SF22', NULL, NULL, NULL, NULL, 'EPIDERMAL GROWTH FACTOR RECEPTOR KINASE SUBSTRATE 8-LIKE PROTEIN 3', 248417),
(384077, 'PTHR12287:SF21', NULL, NULL, NULL, NULL, 'EPIDERMAL GROWTH FACTOR RECEPTOR KINASE SUBSTRATE 8', 248417),
(384078, 'PTHR12287:SF20', NULL, NULL, NULL, NULL, 'EPIDERMAL GROWTH FACTOR RECEPTOR KINASE SUBSTRATE 8-LIKE PROTEIN 2', 248417),
(384079, 'PTHR12287:SF24', NULL, NULL, NULL, NULL, 'EPS8-LIKE 1B', 248417),
(384080, 'PTHR12287:SF23', NULL, NULL, NULL, NULL, 'AROUSER, ISOFORM A-RELATED', 248417),
(384081, 'PTHR12287:SF19', NULL, NULL, NULL, NULL, 'EPIDERMAL GROWTH FACTOR RECEPTOR KINASE SUBSTRATE 8-LIKE PROTEIN 1', 248417),
(384082, 'PTHR12287', NULL, NULL, NULL, NULL, 'EPIDERMAL GROWTH FACTOR RECEPTOR KINASE SUBSTRATE EPS8-RELATED PROTEIN', 248417),
(384083, 'PTHR47589:SF4', NULL, NULL, NULL, NULL, 'FATTY-ACID-BINDING PROTEIN 1-LIKE', 248418),
(384084, 'PTHR47589:SF5', NULL, NULL, NULL, NULL, 'CHALCONE_ISOMERASE DOMAIN-CONTAINING PROTEIN', 248418),
(384085, 'PTHR47589:SF6', NULL, NULL, NULL, NULL, 'CHALCONE_ISOMERASE DOMAIN-CONTAINING PROTEIN', 248418),
(384086, 'PTHR47589', NULL, NULL, NULL, NULL, 'FATTY-ACID-BINDING PROTEIN 1', 248418),
(384087, 'PTHR11846', NULL, NULL, NULL, NULL, 'ADENYLOSUCCINATE SYNTHETASE', 248419),
(384088, 'PTHR11846:SF11', NULL, NULL, NULL, NULL, 'ADENYLOSUCCINATE SYNTHETASE', 248419),
(384089, 'PTHR11846:SF12', NULL, NULL, NULL, NULL, 'ADENYLOSUCCINATE SYNTHETASE 2, CHLOROPLASTIC', 248419),
(384090, 'PTHR11846:SF13', NULL, NULL, NULL, NULL, 'ADENYLOSUCCINATE SYNTHETASE ISOZYME 2', 248419),
(384091, 'PTHR11846:SF2', NULL, NULL, NULL, NULL, 'ADENYLOSUCCINATE SYNTHETASE ISOZYME 1', 248419),
(384092, 'PTHR11846:SF15', NULL, NULL, NULL, NULL, 'ADENYLOSUCCINATE SYNTHETASE, CHLOROPLASTIC', 248419),
(384093, 'PTHR11846:SF16', NULL, NULL, NULL, NULL, 'ADENYLOSUCCINATE SYNTHETASE, CHLOROPLASTIC', 248419),
(384094, 'PTHR11846:SF18', NULL, NULL, NULL, NULL, 'ADENYLOSUCCINATE SYNTHETASE, CHLOROPLASTIC', 248419),
(384095, 'PTHR11846:SF0', NULL, NULL, NULL, NULL, 'ADENYLOSUCCINATE SYNTHETASE', 248419),
(384096, 'PTHR36935', NULL, NULL, NULL, NULL, 'PROTEIN CBG00261', 248420),
(384097, 'PTHR36935:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG00261', 248420),
(384098, 'PTHR36935:SF1', NULL, NULL, NULL, NULL, '', 248420),
(384099, 'PTHR46107', NULL, NULL, NULL, NULL, 'DUMPY: SHORTER THAN WILD-TYPE', 248421),
(384100, 'PTHR46107:SF4', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 248421),
(384101, 'PTHR46107:SF3', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 248421),
(384102, 'PTHR46107:SF2', NULL, NULL, NULL, NULL, 'THIOREDOXIN-RELATED TRANSMEMBRANE PROTEIN 1', 248421);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(384103, 'PTHR46107:SF1', NULL, NULL, NULL, NULL, 'THIOREDOXIN-RELATED TRANSMEMBRANE PROTEIN 4', 248421),
(384104, 'PTHR30462:SF1', NULL, NULL, NULL, NULL, 'INTERMEMBRANE TRANSPORT PROTEIN YEBS', 248422),
(384105, 'PTHR30462:SF0', NULL, NULL, NULL, NULL, 'INTERMEMBRANE TRANSPORT PROTEIN YEBT', 248422),
(384106, 'PTHR30462', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248422),
(384107, 'PTHR30462:SF3', NULL, NULL, NULL, NULL, 'INTERMEMBRANE TRANSPORT PROTEIN PQIA', 248422),
(384108, 'PTHR30462:SF2', NULL, NULL, NULL, NULL, 'INTERMEMBRANE TRANSPORT PROTEIN PQIB', 248422),
(384109, 'PTHR43222:SF4', NULL, NULL, NULL, NULL, 'BLR2458 PROTEIN', 248423),
(384110, 'PTHR43222:SF11', NULL, NULL, NULL, NULL, 'PHOSPHATASE NUDJ', 248423),
(384111, 'PTHR43222:SF2', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 23, CHLOROPLASTIC', 248423),
(384112, 'PTHR43222:SF10', NULL, NULL, NULL, NULL, 'MUTATOR MUTT PROTEIN (7,8-DIHYDRO-8-OXOGUANINE-TRIPHOSPHATASE)', 248423),
(384113, 'PTHR43222:SF9', NULL, NULL, NULL, NULL, '8-OXO-(D)GTP PHOSPHATASE', 248423),
(384114, 'PTHR43222', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 23', 248423),
(384115, 'PTHR43222:SF8', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 248423),
(384116, 'PTHR30282:SF0', NULL, NULL, NULL, NULL, 'P-AMINOBENZOYL-GLUTAMATE TRANSPORT PROTEIN', 248424),
(384117, 'PTHR30282:SF1', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE EFFLUX PROTEIN-RELATED', 248424),
(384118, 'PTHR30282', NULL, NULL, NULL, NULL, 'P-AMINOBENZOYL GLUTAMATE TRANSPORTER', 248424),
(384119, 'PTHR13304:SF0', NULL, NULL, NULL, NULL, 'GLYCOSYLPHOSPHATIDYLINOSITOL ANCHOR ATTACHMENT 1 PROTEIN', 248425),
(384120, 'PTHR13304:SF1', NULL, NULL, NULL, NULL, '', 248425),
(384121, 'PTHR13304', NULL, NULL, NULL, NULL, 'GLYCOSYLPHOSPHATIDYLINOSITOL ANCHOR ATTACHMENT 1 PROTEIN', 248425),
(384122, 'PTHR43431:SF1', NULL, NULL, NULL, NULL, 'OS08G0476300 PROTEIN', 248426),
(384123, 'PTHR43431:SF5', NULL, NULL, NULL, NULL, '3-KETODIHYDROSPHINGOSINE REDUCTASE-LIKE', 248426),
(384124, 'PTHR43431', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE, SHORT CHAIN DEHYDROGENASE/REDUCTASE FAMILY (AFU_ORTHOLOGUE AFUA_5G14000)', 248426),
(384125, 'PTHR43431:SF6', NULL, NULL, NULL, NULL, 'BNACNNG45710D PROTEIN', 248426),
(384126, 'PTHR43431:SF7', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE, SHORT CHAIN DEHYDROGENASE/REDUCTASE FAMILY (AFU_ORTHOLOGUE AFUA_5G14000)', 248426),
(384127, 'PTHR23425:SF18', NULL, NULL, NULL, NULL, 'NUCLEOPORIN AMO1-LIKE', 248427),
(384128, 'PTHR23425', NULL, NULL, NULL, NULL, 'NUCLEOPORIN AMO1-LIKE', 248427),
(384129, 'PTHR23425:SF16', NULL, NULL, NULL, NULL, 'SPERM PROTEIN ASSOCIATED WITH THE NUCLEUS ON THE X CHROMOSOME A-RELATED', 248427),
(384130, 'PTHR23425:SF2', NULL, NULL, NULL, NULL, 'SPERM PROTEIN ASSOCIATED WITH THE NUCLEUS ON THE X CHROMOSOME N4', 248427),
(384131, 'PTHR23425:SF8', NULL, NULL, NULL, NULL, 'AAA_11 DOMAIN-CONTAINING PROTEIN', 248427),
(384132, 'PTHR23425:SF7', NULL, NULL, NULL, NULL, 'SPERM PROTEIN ASSOCIATED WITH THE NUCLEUS ON THE X CHROMOSOME N2-RELATED', 248427),
(384133, 'PTHR33824:SF9', NULL, NULL, NULL, NULL, 'POLYKETIDE_CYC DOMAIN-CONTAINING PROTEIN', 248428),
(384134, 'PTHR33824', NULL, NULL, NULL, NULL, 'POLYKETIDE CYCLASE/DEHYDRASE AND LIPID TRANSPORT SUPERFAMILY PROTEIN', 248428),
(384135, 'PTHR33824:SF4', NULL, NULL, NULL, NULL, 'POLYKETIDE CYCLASE/DEHYDRASE AND LIPID TRANSPORT SUPERFAMILY PROTEIN', 248428),
(384136, 'PTHR33824:SF7', NULL, NULL, NULL, NULL, 'POLYKETIDE CYCLASE/DEHYDRASE AND LIPID TRANSPORT SUPERFAMILY PROTEIN', 248428),
(384137, 'PTHR33824:SF8', NULL, NULL, NULL, NULL, 'POLYKETIDE_CYC DOMAIN-CONTAINING PROTEIN', 248428),
(384138, 'PTHR33824:SF5', NULL, NULL, NULL, NULL, 'POLYKETIDE CYCLASE / DEHYDRASE AND LIPID TRANSPORT PROTEIN', 248428),
(384139, 'PTHR13339:SF1', NULL, NULL, NULL, NULL, 'COP9 SIGNALOSOME COMPLEX SUBUNIT 8', 248429),
(384140, 'PTHR13339:SF0', NULL, NULL, NULL, NULL, 'COP9 SIGNALOSOME COMPLEX SUBUNIT 8', 248429),
(384141, 'PTHR13339', NULL, NULL, NULL, NULL, 'COP9 SIGNALOSOME COMPLEX SUBUNIT 8', 248429),
(384142, 'PTHR14407', NULL, NULL, NULL, NULL, 'HERMANSKY-PUDLAK SYNDROME 4 PROTEIN  LIGHT-EAR PROTEIN-RELATED', 248430);
INSERT INTO "PUBLIC"."MODEL" VALUES
(384143, 'PTHR14407:SF9', NULL, NULL, NULL, NULL, 'HERMANSKY-PUDLAK SYNDROME 4 PROTEIN', 248430),
(384144, 'PTHR37560:SF2', NULL, NULL, NULL, NULL, 'UPF0210 PROTEIN SPR0218', 248431),
(384145, 'PTHR37560', NULL, NULL, NULL, NULL, 'UPF0210 PROTEIN SPR0218', 248431),
(384146, 'PTHR37560:SF1', NULL, NULL, NULL, NULL, 'UPF0210 PROTEIN MJ1665', 248431),
(384147, 'PTHR46344:SF6', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248432),
(384148, 'PTHR46344:SF19', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248432),
(384149, 'PTHR46344:SF9', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248432),
(384150, 'PTHR46344:SF17', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN, GALACTOSE OXIDASE, BETA-PROPELLER-RELATED', 248432),
(384151, 'PTHR46344:SF3', NULL, NULL, NULL, NULL, 'KELCH MOTIF FAMILY PROTEIN, EXPRESSED', 248432),
(384152, 'PTHR46344:SF4', NULL, NULL, NULL, NULL, 'OS07G0153400 PROTEIN', 248432),
(384153, 'PTHR46344', NULL, NULL, NULL, NULL, 'OS02G0202900 PROTEIN', 248432),
(384154, 'PTHR46344:SF1', NULL, NULL, NULL, NULL, 'OS02G0504900 PROTEIN', 248432),
(384155, 'PTHR46344:SF23', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248432),
(384156, 'PTHR46344:SF11', NULL, NULL, NULL, NULL, 'OS04G0380300 PROTEIN', 248432),
(384157, 'PTHR46344:SF22', NULL, NULL, NULL, NULL, 'KELCH REPEAT F-BOX PROTEIN', 248432),
(384158, 'PTHR46344:SF21', NULL, NULL, NULL, NULL, 'KELCH REPEAT SUPERFAMILY PROTEIN', 248432),
(384159, 'PTHR46344:SF20', NULL, NULL, NULL, NULL, 'KELCH MOTIF FAMILY PROTEIN, EXPRESSED', 248432),
(384160, 'PTHR46344:SF16', NULL, NULL, NULL, NULL, 'OS02G0202900 PROTEIN', 248432),
(384161, 'PTHR46344:SF15', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248432),
(384162, 'PTHR46344:SF14', NULL, NULL, NULL, NULL, 'GALACTOSE OXIDASE/KELCH REPEAT SUPERFAMILY PROTEIN-RELATED', 248432),
(384163, 'PTHR46344:SF13', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248432),
(384164, 'PTHR31997', NULL, NULL, NULL, NULL, 'AGAP003710-PA', 248433),
(384165, 'PTHR31997:SF0', NULL, NULL, NULL, NULL, 'PRIMARY CILIUM ASSEMBLY PROTEIN FAM149B1', 248433),
(384166, 'PTHR31997:SF1', NULL, NULL, NULL, NULL, 'AGAP003710-PA', 248433),
(384167, 'PTHR31997:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM149A', 248433),
(384168, 'PTHR31997:SF3', NULL, NULL, NULL, NULL, 'DUF3719 DOMAIN-CONTAINING PROTEIN', 248433),
(384169, 'PTHR38698:SF1', NULL, NULL, NULL, NULL, 'FUNGAL PROTEIN', 248434),
(384170, 'PTHR38698', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248434),
(384171, 'PTHR33507:SF7', NULL, NULL, NULL, NULL, 'HYPOTHETICAL MEMBRANE PROTEIN, CONSERVED', 248435),
(384172, 'PTHR33507', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YBBJ', 248435),
(384173, 'PTHR33507:SF3', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YBBJ', 248435),
(384174, 'PTHR33507:SF4', NULL, NULL, NULL, NULL, 'NODULATION COMPETITIVENESS PROTEIN NFED', 248435),
(384175, 'PTHR33740:SF8', NULL, NULL, NULL, NULL, 'SLH DOMAIN-CONTAINING PROTEIN', 248436),
(384176, 'PTHR33740:SF7', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE/TRANSITION METAL ION-BINDING PROTEIN', 248436),
(384177, 'PTHR33740:SF1', NULL, NULL, NULL, NULL, 'SLH DOMAIN PROTEIN', 248436),
(384178, 'PTHR33740:SF3', NULL, NULL, NULL, NULL, 'GPI-ANCHORED ADHESIN-LIKE PROTEIN', 248436),
(384179, 'PTHR33740', NULL, NULL, NULL, NULL, 'GPI-ANCHORED ADHESIN-LIKE PROTEIN', 248436),
(384180, 'PTHR36221:SF1', NULL, NULL, NULL, NULL, '', 248437),
(384181, 'PTHR36221', NULL, NULL, NULL, NULL, '', 248437),
(384182, 'PTHR47851:SF1', NULL, NULL, NULL, NULL, 'OS06G0588700 PROTEIN', 248438),
(384183, 'PTHR47851', NULL, NULL, NULL, NULL, 'OS06G0588700 PROTEIN-RELATED', 248438),
(384184, 'PTHR47851:SF6', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 248438),
(384185, 'PTHR47851:SF5', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 248438),
(384186, 'PTHR47851:SF4', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 29', 248438),
(384187, 'PTHR47851:SF2', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 248438);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(384188, 'PTHR31586:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY PROTEIN COX20, MITOCHONDRIAL', 248439),
(384189, 'PTHR31586:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY PROTEIN COX20, MITOCHONDRIAL', 248439),
(384190, 'PTHR31586', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE PROTEIN 20', 248439),
(384191, 'PTHR10762:SF2', NULL, NULL, NULL, NULL, '2-(3-AMINO-3-CARBOXYPROPYL)HISTIDINE SYNTHASE SUBUNIT 2', 248440),
(384192, 'PTHR10762:SF1', NULL, NULL, NULL, NULL, '2-(3-AMINO-3-CARBOXYPROPYL)HISTIDINE SYNTHASE SUBUNIT 1', 248440),
(384193, 'PTHR10762', NULL, NULL, NULL, NULL, 'DIPHTHAMIDE BIOSYNTHESIS PROTEIN', 248440),
(384194, 'PTHR15410:SF2', NULL, NULL, NULL, NULL, 'HIRA-INTERACTING PROTEIN 3', 248441),
(384195, 'PTHR15410', NULL, NULL, NULL, NULL, 'HIRA-INTERACTING PROTEIN 3', 248441),
(384196, 'PTHR11002:SF19', NULL, NULL, NULL, NULL, 'BETA CARBONIC ANHYDRASE 6, MITOCHONDRIAL', 248442),
(384197, 'PTHR11002:SF56', NULL, NULL, NULL, NULL, 'BETA CARBONIC ANHYDRASE 2, CHLOROPLASTIC', 248442),
(384198, 'PTHR11002:SF78', NULL, NULL, NULL, NULL, 'BETA CARBONIC ANHYDRASE 4', 248442),
(384199, 'PTHR11002:SF12', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 248442),
(384200, 'PTHR11002:SF13', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 248442),
(384201, 'PTHR11002:SF57', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 248442),
(384202, 'PTHR11002:SF54', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 248442),
(384203, 'PTHR11002:SF76', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 248442),
(384204, 'PTHR11002:SF77', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 248442),
(384205, 'PTHR11002:SF59', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 248442),
(384206, 'PTHR11002:SF74', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 248442),
(384207, 'PTHR11002:SF52', NULL, NULL, NULL, NULL, 'BETA CARBONIC ANHYDRASE 3', 248442),
(384208, 'PTHR11002:SF75', NULL, NULL, NULL, NULL, 'BETA CARBONIC ANHYDRASE 5, CHLOROPLASTIC', 248442),
(384209, 'PTHR11002:SF51', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 248442),
(384210, 'PTHR11002:SF73', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 248442),
(384211, 'PTHR11002:SF45', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 248442),
(384212, 'PTHR11002:SF46', NULL, NULL, NULL, NULL, 'BETA CARBONIC ANHYDRASE 1, CHLOROPLASTIC', 248442),
(384213, 'PTHR11002:SF66', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 248442),
(384214, 'PTHR11002:SF69', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 248442),
(384215, 'PTHR11002:SF48', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 248442),
(384216, 'PTHR11002', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 248442),
(384217, 'PTHR11002:SF60', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 248442),
(384218, 'PTHR11002:SF42', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE 1', 248442),
(384219, 'PTHR11002:SF61', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 248442),
(384220, 'PTHR11002:SF62', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 248442),
(384221, 'PTHR34121:SF1', NULL, NULL, NULL, NULL, 'MYOSIN-11', 248443),
(384222, 'PTHR34121:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248443),
(384223, 'PTHR34121:SF9', NULL, NULL, NULL, NULL, '', 248443),
(384224, 'PTHR34121:SF10', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF15', 248443),
(384225, 'PTHR34121:SF8', NULL, NULL, NULL, NULL, '', 248443),
(384226, 'PTHR34121', NULL, NULL, NULL, NULL, 'MYOSIN-11', 248443),
(384227, 'PTHR34121:SF5', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 135 KDA-LIKE PROTEIN', 248443),
(384228, 'PTHR34121:SF4', NULL, NULL, NULL, NULL, 'OS05G0162200 PROTEIN', 248443),
(384229, 'PTHR34121:SF7', NULL, NULL, NULL, NULL, '', 248443),
(384230, 'PTHR34121:SF6', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 18-LIKE ISOFORM X1', 248443),
(384231, 'PTHR12905', NULL, NULL, NULL, NULL, 'METALLOPHOSPHOESTERASE', 248444),
(384232, 'PTHR12905:SF31', NULL, NULL, NULL, NULL, 'METALLOPHOSPHOESTERASE DOMAIN-CONTAINING PROTEIN 1', 248444),
(384233, 'PTHR12905:SF13', NULL, NULL, NULL, NULL, 'METALLOPHOSPHOESTERASE MPPED2', 248444);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(384234, 'PTHR12905:SF0', NULL, NULL, NULL, NULL, 'METALLOPHOS DOMAIN-CONTAINING PROTEIN', 248444),
(384235, 'PTHR12905:SF16', NULL, NULL, NULL, NULL, 'SER/THR PROTEIN PHOSPHATASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_1G06000)', 248444),
(384236, 'PTHR12905:SF28', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONATE LYASE C-RELATED', 248444),
(384237, 'PTHR12905:SF29', NULL, NULL, NULL, NULL, 'UPF0046 PROTEIN T07D4.2', 248444),
(384238, 'PTHR12905:SF18', NULL, NULL, NULL, NULL, 'ESTER HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G03130)-RELATED', 248444),
(384239, 'PTHR12905:SF19', NULL, NULL, NULL, NULL, 'UPF0046 PROTEIN K07C11.7', 248444),
(384240, 'PTHR23285:SF8', NULL, NULL, NULL, NULL, 'RNA-BINDING E3 UBIQUITIN-PROTEIN LIGASE MEX3C', 248445),
(384241, 'PTHR23285:SF7', NULL, NULL, NULL, NULL, 'LD09246P1', 248445),
(384242, 'PTHR23285:SF5', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN MEX3B', 248445),
(384243, 'PTHR23285', NULL, NULL, NULL, NULL, 'RING FINGER AND KH DOMAIN CONTAINING PROTEIN 1', 248445),
(384244, 'PTHR23285:SF3', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN MEX3D', 248445),
(384245, 'PTHR23285:SF2', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN MEX3A', 248445),
(384246, 'PTHR47456:SF1', NULL, NULL, NULL, NULL, 'SWIM-TYPE DOMAIN-CONTAINING PROTEIN', 248446),
(384247, 'PTHR47456', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', 248446),
(384248, 'PTHR47456:SF3', NULL, NULL, NULL, NULL, 'SWIM-TYPE DOMAIN-CONTAINING PROTEIN', 248446),
(384249, 'PTHR42851:SF7', NULL, NULL, NULL, NULL, 'OS07G0694500 PROTEIN', 248447),
(384250, 'PTHR42851:SF8', NULL, NULL, NULL, NULL, 'PWWP DOMAIN-CONTAINING PROTEIN', 248447),
(384251, 'PTHR42851:SF19', NULL, NULL, NULL, NULL, 'TUDOR/PWWP/MBT SUPERFAMILY PROTEIN', 248447),
(384252, 'PTHR42851:SF5', NULL, NULL, NULL, NULL, 'TUDOR/PWWP/MBT SUPERFAMILY PROTEIN', 248447),
(384253, 'PTHR42851:SF16', NULL, NULL, NULL, NULL, 'TUDOR/PWWP/MBT SUPERFAMILY PROTEIN', 248447),
(384254, 'PTHR42851:SF9', NULL, NULL, NULL, NULL, 'KETOSE-BISPHOSPHATE ALDOLASE CLASS-II FAMILY PROTEIN', 248447),
(384255, 'PTHR42851:SF13', NULL, NULL, NULL, NULL, 'OS08G0477800 PROTEIN', 248447),
(384256, 'PTHR42851:SF24', NULL, NULL, NULL, NULL, 'PWWP DOMAIN-CONTAINING PROTEIN', 248447),
(384257, 'PTHR42851:SF23', NULL, NULL, NULL, NULL, 'PWWP DOMAIN PROTEIN', 248447),
(384258, 'PTHR42851:SF12', NULL, NULL, NULL, NULL, 'PWWP DOMAIN PROTEIN', 248447),
(384259, 'PTHR42851:SF10', NULL, NULL, NULL, NULL, 'TUDOR/PWWP/MBT SUPERFAMILY PROTEIN', 248447),
(384260, 'PTHR42851', NULL, NULL, NULL, NULL, 'ALDOLASE-RELATED', 248447),
(384261, 'PTHR42851:SF4', NULL, NULL, NULL, NULL, 'PWWP DOMAIN-CONTAINING PROTEIN', 248447),
(384262, 'PTHR22928:SF3', NULL, NULL, NULL, NULL, 'TELOMERE-ASSOCIATED PROTEIN RIF1', 248448),
(384263, 'PTHR22928', NULL, NULL, NULL, NULL, 'TELOMERE-ASSOCIATED PROTEIN  RIF1', 248448),
(384264, 'PTHR13160:SF11', NULL, NULL, NULL, NULL, 'OLIGOSACCHARYLTRANSFERASE COMPLEX SUBUNIT', 248449),
(384265, 'PTHR13160:SF12', NULL, NULL, NULL, NULL, 'OLIGOSACCHARYLTRANSFERASE COMPLEX SUBUNIT', 248449),
(384266, 'PTHR13160:SF4', NULL, NULL, NULL, NULL, 'OLIGOSACCHARYLTRANSFERASE COMPLEX SUBUNIT OSTC', 248449),
(384267, 'PTHR13160:SF13', NULL, NULL, NULL, NULL, 'BNAA01G07110D PROTEIN', 248449),
(384268, 'PTHR13160:SF14', NULL, NULL, NULL, NULL, 'OLIGOSACCHARYLTRANSFERASE COMPLEX SUBUNIT', 248449),
(384269, 'PTHR13160', NULL, NULL, NULL, NULL, 'OLIGOSACCHARYLTRANSFERASE COMPLEX SUBUNIT OSTC', 248449),
(384270, 'PTHR13160:SF9', NULL, NULL, NULL, NULL, 'OLIGOSACCHARYLTRANSFERASE COMPLEX SUBUNIT OSTC', 248449),
(384271, 'PTHR43386:SF21', NULL, NULL, NULL, NULL, 'D,D-DIPEPTIDE TRANSPORT SYSTEM PERMEASE PROTEIN DDPC-RELATED', 248450),
(384272, 'PTHR43386:SF2', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORT SYSTEM PERMEASE PROTEIN OPPC', 248450),
(384273, 'PTHR43386:SF1', NULL, NULL, NULL, NULL, 'NICKEL IMPORT SYSTEM PERMEASE PROTEIN NIKC', 248450),
(384274, 'PTHR43386:SF22', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORT SYSTEM PERMEASE PROTEIN OPPC', 248450),
(384275, 'PTHR43386:SF23', NULL, NULL, NULL, NULL, 'OPPC IN A BINDING PROTEIN-DEPENDENT TRANSPORT SYSTEM', 248450);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(384276, 'PTHR43386:SF3', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSPORT SYSTEM PERMEASE PROTEIN GSID', 248450),
(384277, 'PTHR43386:SF6', NULL, NULL, NULL, NULL, 'DIPEPTIDE-TRANSPORT INTEGRAL MEMBRANE PROTEIN ABC TRANSPORTER DPPC-RELATED', 248450),
(384278, 'PTHR43386:SF14', NULL, NULL, NULL, NULL, 'NICKEL TRANSPORT SYSTEM PERMEASE PROTEIN NIKC', 248450),
(384279, 'PTHR43386:SF5', NULL, NULL, NULL, NULL, 'PUTRESCINE EXPORT SYSTEM PERMEASE PROTEIN SAPC', 248450),
(384280, 'PTHR43386:SF8', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE ABC TRANSPORTER, PERMEASE PROTEIN', 248450),
(384281, 'PTHR43386', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORT SYSTEM PERMEASE PROTEIN APPC', 248450),
(384282, 'PTHR43386:SF20', NULL, NULL, NULL, NULL, 'BINDING-PROTEIN-DEPENDENT TRANSPORT SYSTEMS INNER MEMBRANE COMPONENT', 248450),
(384283, 'PTHR31627:SF3', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS G (GAMMA)-RELATED', 248451),
(384284, 'PTHR31627:SF2', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA-30', 248451),
(384285, 'PTHR31627:SF4', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA-9', 248451),
(384286, 'PTHR31627:SF14', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS V-RELATED', 248451),
(384287, 'PTHR31627:SF36', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA', 248451),
(384288, 'PTHR31627:SF35', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA', 248451),
(384289, 'PTHR31627:SF13', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA-1-RELATED', 248451),
(384290, 'PTHR31627:SF16', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA-69', 248451),
(384291, 'PTHR31627:SF7', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA-7', 248451),
(384292, 'PTHR31627:SF9', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA-3', 248451),
(384293, 'PTHR31627:SF8', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA-6-RELATED', 248451),
(384294, 'PTHR31627:SF41', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA', 248451),
(384295, 'PTHR31627:SF10', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA-16', 248451),
(384296, 'PTHR31627:SF43', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA-15', 248451),
(384297, 'PTHR31627:SF42', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS V-1', 248451),
(384298, 'PTHR31627:SF31', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA', 248451),
(384299, 'PTHR31627', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA-RELATED', 248451),
(384300, 'PTHR31627:SF12', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA-11-RELATED', 248451),
(384301, 'PTHR15361', NULL, NULL, NULL, NULL, 'RAD51/NUKS-INTERACTING PROTEIN', 248452),
(384302, 'PTHR15361:SF5', NULL, NULL, NULL, NULL, 'RAD51_INTERACT DOMAIN-CONTAINING PROTEIN', 248452),
(384303, 'PTHR15361:SF7', NULL, NULL, NULL, NULL, 'RAD51_INTERACT DOMAIN-CONTAINING PROTEIN', 248452),
(384304, 'PTHR15361:SF1', NULL, NULL, NULL, NULL, 'NUCLEAR UBIQUITOUS CASEIN AND CYCLIN-DEPENDENT KINASE SUBSTRATE 1', 248452),
(384305, 'PTHR15361:SF4', NULL, NULL, NULL, NULL, 'RAD51-ASSOCIATED PROTEIN 1', 248452),
(384306, 'PTHR31583', NULL, NULL, NULL, NULL, '', 248453),
(384307, 'PTHR31583:SF2', NULL, NULL, NULL, NULL, '', 248453),
(384308, 'PTHR12772:SF0', NULL, NULL, NULL, NULL, 'DNA REPLICATION COMPLEX GINS PROTEIN PSF2', 248454),
(384309, 'PTHR12772', NULL, NULL, NULL, NULL, 'DNA REPLICATION COMPLEX GINS PROTEIN PSF2', 248454),
(384310, 'PTHR46510:SF1', NULL, NULL, NULL, NULL, 'BROMODOMAIN ADJACENT TO ZINC FINGER DOMAIN PROTEIN 1A', 248455),
(384311, 'PTHR46510', NULL, NULL, NULL, NULL, 'BROMODOMAIN ADJACENT TO ZINC FINGER DOMAIN PROTEIN 1A', 248455),
(384312, 'PTHR38773:SF1', NULL, NULL, NULL, NULL, 'PROTEIN SPRT', 248456),
(384313, 'PTHR38773', NULL, NULL, NULL, NULL, 'PROTEIN SPRT', 248456),
(384314, 'PTHR15512:SF0', NULL, NULL, NULL, NULL, 'TERF1-INTERACTING NUCLEAR FACTOR 2', 248457),
(384315, 'PTHR15512:SF2', NULL, NULL, NULL, NULL, 'ZGC:113263', 248457),
(384316, 'PTHR15512', NULL, NULL, NULL, NULL, 'TERF1-INTERACTING NUCLEAR FACTOR 2', 248457);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(384317, 'PTHR12990:SF10', NULL, NULL, NULL, NULL, 'MESENCEPHALIC ASTROCYTE-DERIVED NEUROTROPHIC FACTOR', 248458),
(384318, 'PTHR12990:SF5', NULL, NULL, NULL, NULL, 'MESENCEPHALIC ASTROCYTE-DERIVED NEUROTROPHIC FACTOR HOMOLOG', 248458),
(384319, 'PTHR12990', NULL, NULL, NULL, NULL, 'ARMET-LIKE PROTEIN', 248458),
(384320, 'PTHR12990:SF9', NULL, NULL, NULL, NULL, 'CEREBRAL DOPAMINE NEUROTROPHIC FACTOR', 248458),
(384321, 'PTHR31218:SF203', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384322, 'PTHR31218:SF169', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384323, 'PTHR31218:SF202', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384324, 'PTHR31218:SF323', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384325, 'PTHR31218:SF205', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384326, 'PTHR31218:SF204', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384327, 'PTHR31218:SF166', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384328, 'PTHR31218:SF287', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384329, 'PTHR31218:SF286', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384330, 'PTHR31218:SF201', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384331, 'PTHR31218:SF289', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384332, 'PTHR31218:SF288', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384333, 'PTHR31218:SF200', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384334, 'PTHR31218:SF61', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384335, 'PTHR31218:SF60', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384336, 'PTHR31218:SF207', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384337, 'PTHR31218:SF328', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384338, 'PTHR31218:SF64', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384339, 'PTHR31218:SF209', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384340, 'PTHR31218:SF208', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384341, 'PTHR31218:SF329', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 248459),
(384342, 'PTHR31218:SF56', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384343, 'PTHR31218:SF283', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384344, 'PTHR31218:SF162', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384345, 'PTHR31218:SF161', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384346, 'PTHR31218:SF282', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384347, 'PTHR31218:SF284', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384348, 'PTHR31218:SF281', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384349, 'PTHR31218:SF313', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384350, 'PTHR31218:SF159', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384351, 'PTHR31218:SF312', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384352, 'PTHR31218:SF7', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384353, 'PTHR31218:SF279', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384354, 'PTHR31218:SF315', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384355, 'PTHR31218:SF314', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384356, 'PTHR31218:SF397', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384357, 'PTHR31218:SF275', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384358, 'PTHR31218:SF154', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384359, 'PTHR31218:SF396', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384360, 'PTHR31218:SF311', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384361, 'PTHR31218:SF399', NULL, NULL, NULL, NULL, 'OS05G0409500 PROTEIN', 248459),
(384362, 'PTHR31218:SF156', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384363, 'PTHR31218:SF1', NULL, NULL, NULL, NULL, 'PROTEIN WALLS ARE THIN 1', 248459);
INSERT INTO "PUBLIC"."MODEL" VALUES
(384364, 'PTHR31218:SF398', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384365, 'PTHR31218:SF277', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384366, 'PTHR31218:SF50', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384367, 'PTHR31218:SF317', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384368, 'PTHR31218:SF316', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384369, 'PTHR31218:SF319', NULL, NULL, NULL, NULL, 'EAMA DOMAIN, JMJC DOMAIN, WAT1-RELATED PROTEIN-RELATED', 248459),
(384370, 'PTHR31218:SF47', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384371, 'PTHR31218:SF46', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384372, 'PTHR31218:SF48', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384373, 'PTHR31218:SF272', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384374, 'PTHR31218:SF393', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384375, 'PTHR31218:SF151', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384376, 'PTHR31218:SF392', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384377, 'PTHR31218:SF153', NULL, NULL, NULL, NULL, 'EAMA DOMAIN-CONTAINING PROTEIN', 248459),
(384378, 'PTHR31218:SF395', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384379, 'PTHR31218:SF274', NULL, NULL, NULL, NULL, 'BNAC06G31330D PROTEIN', 248459),
(384380, 'PTHR31218:SF394', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384381, 'PTHR31218:SF273', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384382, 'PTHR31218:SF152', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384383, 'PTHR31218:SF270', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384384, 'PTHR31218:SF391', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384385, 'PTHR31218:SF390', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384386, 'PTHR31218:SF227', NULL, NULL, NULL, NULL, 'OS10G0197700 PROTEIN', 248459),
(384387, 'PTHR31218:SF347', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384388, 'PTHR31218:SF226', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384389, 'PTHR31218:SF221', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384390, 'PTHR31218:SF188', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384391, 'PTHR31218:SF187', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384392, 'PTHR31218:SF223', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384393, 'PTHR31218:SF344', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384394, 'PTHR31218:SF343', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384395, 'PTHR31218:SF189', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384396, 'PTHR31218:SF229', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384397, 'PTHR31218:SF349', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384398, 'PTHR31218:SF184', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384399, 'PTHR31218:SF183', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384400, 'PTHR31218:SF340', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384401, 'PTHR31218:SF185', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384402, 'PTHR31218:SF182', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384403, 'PTHR31218:SF181', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384404, 'PTHR31218:SF335', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384405, 'PTHR31218:SF214', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384406, 'PTHR31218:SF213', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384407, 'PTHR31218:SF334', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384408, 'PTHR31218:SF216', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384409, 'PTHR31218:SF337', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384410, 'PTHR31218:SF336', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384411, 'PTHR31218:SF215', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(384412, 'PTHR31218:SF177', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384413, 'PTHR31218:SF331', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384414, 'PTHR31218:SF298', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384415, 'PTHR31218:SF330', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384416, 'PTHR31218:SF297', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384417, 'PTHR31218:SF212', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384418, 'PTHR31218:SF179', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384419, 'PTHR31218:SF211', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384420, 'PTHR31218:SF332', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384421, 'PTHR31218:SF178', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384422, 'PTHR31218:SF71', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384423, 'PTHR31218:SF218', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384424, 'PTHR31218:SF219', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384425, 'PTHR31218:SF68', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384426, 'PTHR31218:SF293', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384427, 'PTHR31218:SF296', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384428, 'PTHR31218:SF175', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384429, 'PTHR31218:SF295', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384430, 'PTHR31218:SF290', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384431, 'PTHR31218:SF171', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384432, 'PTHR31218:SF291', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384433, 'PTHR31218:SF170', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384434, 'PTHR31218:SF247', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384435, 'PTHR31218:SF401', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384436, 'PTHR31218:SF400', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384437, 'PTHR31218:SF249', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384438, 'PTHR31218:SF248', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384439, 'PTHR31218:SF243', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384440, 'PTHR31218:SF242', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384441, 'PTHR31218:SF245', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384442, 'PTHR31218:SF244', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384443, 'PTHR31218:SF21', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384444, 'PTHR31218:SF14', NULL, NULL, NULL, NULL, 'OS11G0588100 PROTEIN', 248459),
(384445, 'PTHR31218:SF16', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384446, 'PTHR31218:SF15', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384447, 'PTHR31218:SF240', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384448, 'PTHR31218:SF236', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384449, 'PTHR31218:SF235', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384450, 'PTHR31218:SF359', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384451, 'PTHR31218:SF237', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384452, 'PTHR31218:SF232', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384453, 'PTHR31218:SF353', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384454, 'PTHR31218:SF199', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384455, 'PTHR31218:SF198', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384456, 'PTHR31218:SF352', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384457, 'PTHR31218:SF355', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384458, 'PTHR31218:SF233', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384459, 'PTHR31218:SF239', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(384460, 'PTHR31218', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384461, 'PTHR31218:SF194', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384462, 'PTHR31218:SF351', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384463, 'PTHR31218:SF197', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384464, 'PTHR31218:SF230', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384465, 'PTHR31218:SF196', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384466, 'PTHR31218:SF350', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384467, 'PTHR31218:SF190', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384468, 'PTHR31218:SF193', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384469, 'PTHR31218:SF302', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384470, 'PTHR31218:SF301', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384471, 'PTHR31218:SF389', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384472, 'PTHR31218:SF268', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384473, 'PTHR31218:SF304', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384474, 'PTHR31218:SF265', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384475, 'PTHR31218:SF386', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384476, 'PTHR31218:SF385', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384477, 'PTHR31218:SF388', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384478, 'PTHR31218:SF300', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384479, 'PTHR31218:SF146', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384480, 'PTHR31218:SF387', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384481, 'PTHR31218:SF309', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384482, 'PTHR31218:SF42', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384483, 'PTHR31218:SF305', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384484, 'PTHR31218:SF307', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384485, 'PTHR31218:SF36', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384486, 'PTHR31218:SF37', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384487, 'PTHR31218:SF382', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE FAMILY 35 PROTEIN', 248459),
(384488, 'PTHR31218:SF260', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384489, 'PTHR31218:SF381', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384490, 'PTHR31218:SF384', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384491, 'PTHR31218:SF383', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384492, 'PTHR31218:SF262', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384493, 'PTHR31218:SF380', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384494, 'PTHR31218:SF258', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384495, 'PTHR31218:SF257', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384496, 'PTHR31218:SF259', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384497, 'PTHR31218:SF254', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384498, 'PTHR31218:SF133', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384499, 'PTHR31218:SF253', NULL, NULL, NULL, NULL, 'NODULIN MTN21/EAMA-LIKE TRANSPORTER FAMILY PROTEIN', 248459),
(384500, 'PTHR31218:SF377', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384501, 'PTHR31218:SF256', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384502, 'PTHR31218:SF376', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384503, 'PTHR31218:SF31', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384504, 'PTHR31218:SF25', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384505, 'PTHR31218:SF22', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384506, 'PTHR31218:SF29', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384507, 'PTHR31218:SF28', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(384508, 'PTHR31218:SF250', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384509, 'PTHR31218:SF370', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384510, 'PTHR31218:SF373', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384511, 'PTHR31218:SF252', NULL, NULL, NULL, NULL, 'NODULIN MTN21 /EAMA-LIKE TRANSPORTER FAMILY PROTEIN', 248459),
(384512, 'PTHR31218:SF251', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', 248459),
(384513, 'PTHR38418', NULL, NULL, NULL, NULL, 'SUGAR ISOMERASE, KPSF/GUTQ (AFU_ORTHOLOGUE AFUA_6G08860)', 248460),
(384514, 'PTHR38418:SF2', NULL, NULL, NULL, NULL, 'SUGAR ISOMERASE, KPSF/GUTQ (AFU_ORTHOLOGUE AFUA_6G08860)', 248460),
(384515, 'PTHR33697:SF1', NULL, NULL, NULL, NULL, 'TUDOR/PWWP/MBT SUPERFAMILY PROTEIN', 248461),
(384516, 'PTHR33697:SF2', NULL, NULL, NULL, NULL, 'T17B22.17 PROTEIN', 248461),
(384517, 'PTHR33697:SF5', NULL, NULL, NULL, NULL, 'PWWP DOMAIN-CONTAINING PROTEIN-RELATED', 248461),
(384518, 'PTHR33697:SF6', NULL, NULL, NULL, NULL, 'PWWP DOMAIN-CONTAINING PROTEIN', 248461),
(384519, 'PTHR33697:SF3', NULL, NULL, NULL, NULL, 'TUDOR/PWWP/MBT SUPERFAMILY PROTEIN', 248461),
(384520, 'PTHR33697:SF4', NULL, NULL, NULL, NULL, 'PWWP DOMAIN-CONTAINING PROTEIN', 248461),
(384521, 'PTHR33697:SF9', NULL, NULL, NULL, NULL, 'PWWP DOMAIN-CONTAINING PROTEIN', 248461),
(384522, 'PTHR33697:SF7', NULL, NULL, NULL, NULL, 'PWWP DOMAIN-CONTAINING PROTEIN', 248461),
(384523, 'PTHR33697:SF10', NULL, NULL, NULL, NULL, 'PWWP DOMAIN-CONTAINING PROTEIN', 248461),
(384524, 'PTHR33697:SF8', NULL, NULL, NULL, NULL, 'PWWP DOMAIN-CONTAINING PROTEIN', 248461),
(384525, 'PTHR33697', NULL, NULL, NULL, NULL, 'T17B22.17 PROTEIN-RELATED', 248461),
(384526, 'PTHR14089:SF2', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR CWC2', 248462),
(384527, 'PTHR14089:SF13', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 49-LIKE', 248462),
(384528, 'PTHR14089:SF12', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 4-RELATED', 248462),
(384529, 'PTHR14089:SF10', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN NAB6', 248462),
(384530, 'PTHR14089:SF15', NULL, NULL, NULL, NULL, 'C3H1-TYPE DOMAIN-CONTAINING PROTEIN', 248462),
(384531, 'PTHR14089:SF14', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 248462),
(384532, 'PTHR14089:SF6', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR RBM22', 248462),
(384533, 'PTHR14089', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR RBM22', 248462),
(384534, 'PTHR14089:SF19', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED GENE 16', 248462),
(384535, 'PTHR14089:SF8', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN MRN1', 248462),
(384536, 'PTHR14089:SF18', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR RBM22', 248462),
(384537, 'PTHR38682', NULL, NULL, NULL, NULL, 'V-TYPE ATP SYNTHASE SUBUNIT C', 248463),
(384538, 'PTHR38682:SF1', NULL, NULL, NULL, NULL, 'V-TYPE ATP SYNTHASE SUBUNIT C', 248463),
(384539, 'PTHR37865:SF1', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 23', 248464),
(384540, 'PTHR37865', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 23', 248464),
(384541, 'PTHR13211:SF0', NULL, NULL, NULL, NULL, 'TELOMERASE CAJAL BODY PROTEIN 1', 248465),
(384542, 'PTHR13211', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248465),
(384543, 'PTHR22946:SF0', NULL, NULL, NULL, NULL, 'DLH DOMAIN-CONTAINING PROTEIN', 248466),
(384544, 'PTHR22946:SF2', NULL, NULL, NULL, NULL, 'DLH DOMAIN-CONTAINING PROTEIN', 248466),
(384545, 'PTHR22946:SF5', NULL, NULL, NULL, NULL, 'PEPTIDASE_S9 DOMAIN-CONTAINING PROTEIN', 248466),
(384546, 'PTHR22946:SF4', NULL, NULL, NULL, NULL, 'ESTERASE FRSA', 248466),
(384547, 'PTHR22946', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248466),
(384548, 'PTHR22946:SF9', NULL, NULL, NULL, NULL, 'POLYKETIDE TRANSFERASE AF380', 248466),
(384549, 'PTHR22946:SF8', NULL, NULL, NULL, NULL, 'AXE1 DOMAIN-CONTAINING PROTEIN', 248466),
(384550, 'PTHR22946:SF13', NULL, NULL, NULL, NULL, 'ALPHA/BETA HYDROLASE PSOB', 248466),
(384551, 'PTHR22946:SF12', NULL, NULL, NULL, NULL, 'CONIDIAL PIGMENT BIOSYNTHESIS PROTEIN AYG1 (AFU_ORTHOLOGUE AFUA_2G17550)', 248466);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(384552, 'PTHR22946:SF11', NULL, NULL, NULL, NULL, 'DLH DOMAIN-CONTAINING PROTEIN', 248466),
(384553, 'PTHR12607:SF3', NULL, NULL, NULL, NULL, 'ADENOMATOUS POLYPOSIS COLI PROTEIN 2', 248467),
(384554, 'PTHR12607:SF11', NULL, NULL, NULL, NULL, 'ADENOMATOUS POLYPOSIS COLI PROTEIN', 248467),
(384555, 'PTHR12607', NULL, NULL, NULL, NULL, 'ADENOMATOUS POLYPOSIS COLI PROTEIN FAMILY', 248467),
(384556, 'PTHR12607:SF12', NULL, NULL, NULL, NULL, 'APC-LIKE, ISOFORM A-RELATED', 248467),
(384557, 'PTHR18916:SF92', NULL, NULL, NULL, NULL, 'CAP-GLY DOMAIN-CONTAINING LINKER PROTEIN 1 HOMOLOG', 248468),
(384558, 'PTHR18916:SF91', NULL, NULL, NULL, NULL, 'DYNACTIN SUBUNIT 1', 248468),
(384559, 'PTHR18916:SF83', NULL, NULL, NULL, NULL, 'TIP ELONGATION PROTEIN 1', 248468),
(384560, 'PTHR18916:SF93', NULL, NULL, NULL, NULL, 'RESTIN HOMOLOG', 248468),
(384561, 'PTHR18916:SF82', NULL, NULL, NULL, NULL, 'DOMAIN-CONTAINING LINKER PROTEIN, PUTATIVE-RELATED', 248468),
(384562, 'PTHR18916:SF90', NULL, NULL, NULL, NULL, 'CAP-GLY DOMAIN-CONTAINING PROTEIN', 248468),
(384563, 'PTHR18916', NULL, NULL, NULL, NULL, 'DYNACTIN 1-RELATED MICROTUBULE-BINDING', 248468),
(384564, 'PTHR18916:SF6', NULL, NULL, NULL, NULL, 'DYNACTIN SUBUNIT 1', 248468),
(384565, 'PTHR18916:SF89', NULL, NULL, NULL, NULL, 'FAMILY 2LIKE, PUTATIVE-RELATED', 248468),
(384566, 'PTHR18916:SF88', NULL, NULL, NULL, NULL, '', 248468),
(384567, 'PTHR18916:SF44', NULL, NULL, NULL, NULL, 'CAP-GLY DOMAIN-CONTAINING LINKER PROTEIN 1', 248468),
(384568, 'PTHR18916:SF77', NULL, NULL, NULL, NULL, 'CAP-GLY DOMAIN-CONTAINING LINKER PROTEIN 3', 248468),
(384569, 'PTHR18916:SF85', NULL, NULL, NULL, NULL, 'TUBULIN-FOLDING COFACTOR B', 248468),
(384570, 'PTHR18916:SF32', NULL, NULL, NULL, NULL, 'CAP-GLY DOMAIN-CONTAINING LINKER PROTEIN 4', 248468),
(384571, 'PTHR18916:SF10', NULL, NULL, NULL, NULL, 'CAP-GLY DOMAIN-CONTAINING LINKER PROTEIN 2', 248468),
(384572, 'PTHR43309', NULL, NULL, NULL, NULL, '5-OXOPROLINASE SUBUNIT C', 248469),
(384573, 'PTHR43309:SF3', NULL, NULL, NULL, NULL, '5-OXOPROLINASE SUBUNIT C', 248469),
(384574, 'PTHR43206', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE', 248470),
(384575, 'PTHR43206:SF1', NULL, NULL, NULL, NULL, '4-AMINOBUTYRATE AMINOTRANSFERASE, MITOCHONDRIAL', 248470),
(384576, 'PTHR43206:SF2', NULL, NULL, NULL, NULL, '4-AMINOBUTYRATE AMINOTRANSFERASE GABT', 248470),
(384577, 'PTHR43206:SF3', NULL, NULL, NULL, NULL, '4-AMINOBUTYRATE AMINOTRANSFERASE PUUE', 248470),
(384578, 'PTHR43206:SF4', NULL, NULL, NULL, NULL, '4-AMINOBUTYRATE AMINOTRANSFERASE, MITOCHONDRIAL', 248470),
(384579, 'PTHR31923:SF1', NULL, NULL, NULL, NULL, 'BSD DOMAIN-CONTAINING PROTEIN', 248471),
(384580, 'PTHR31923:SF3', NULL, NULL, NULL, NULL, 'BSD DOMAIN-CONTAINING PROTEIN', 248471),
(384581, 'PTHR31923:SF4', NULL, NULL, NULL, NULL, 'BSD DOMAIN-CONTAINING PROTEIN', 248471),
(384582, 'PTHR31923:SF22', NULL, NULL, NULL, NULL, 'OS01G0766600 PROTEIN', 248471),
(384583, 'PTHR31923:SF5', NULL, NULL, NULL, NULL, 'BSD DOMAIN-CONTAINING PROTEIN', 248471),
(384584, 'PTHR31923:SF33', NULL, NULL, NULL, NULL, 'BSD DOMAIN CONTAINING PROTEIN, EXPRESSED', 248471),
(384585, 'PTHR31923:SF10', NULL, NULL, NULL, NULL, 'BSD DOMAIN-CONTAINING PROTEIN', 248471),
(384586, 'PTHR31923:SF9', NULL, NULL, NULL, NULL, 'BSD DOMAIN-CONTAINING PROTEIN', 248471),
(384587, 'PTHR31923', NULL, NULL, NULL, NULL, 'BSD DOMAIN-CONTAINING PROTEIN', 248471),
(384588, 'PTHR31923:SF35', NULL, NULL, NULL, NULL, 'BSD DOMAIN-CONTAINING PROTEIN', 248471),
(384589, 'PTHR31923:SF36', NULL, NULL, NULL, NULL, 'BSD DOMAIN-CONTAINING PROTEIN', 248471),
(384590, 'PTHR31923:SF25', NULL, NULL, NULL, NULL, 'BSD DOMAIN-CONTAINING PROTEIN', 248471),
(384591, 'PTHR31923:SF27', NULL, NULL, NULL, NULL, 'BSD DOMAIN-CONTAINING PROTEIN', 248471),
(384592, 'PTHR31923:SF38', NULL, NULL, NULL, NULL, 'BSD DOMAIN-CONTAINING PROTEIN', 248471),
(384593, 'PTHR31923:SF29', NULL, NULL, NULL, NULL, 'BSD DOMAIN-CONTAINING PROTEIN', 248471),
(384594, 'PTHR19136:SF52', NULL, NULL, NULL, NULL, '2,3,4,5-TETRAHYDROPYRIDINE-2,6-DICARBOXYLATE N-SUCCINYLTRANSFERASE', 248472);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(384595, 'PTHR19136:SF85', NULL, NULL, NULL, NULL, 'MOLYBDENUM COFACTOR GUANYLYLTRANSFERASE-RELATED', 248472),
(384596, 'PTHR19136:SF81', NULL, NULL, NULL, NULL, 'MOLYBDENUM COFACTOR GUANYLYLTRANSFERASE', 248472),
(384597, 'PTHR19136:SF84', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL IPC TRANSFERASE AND DIPP SYNTHASE', 248472),
(384598, 'PTHR19136', NULL, NULL, NULL, NULL, 'MOLYBDENUM COFACTOR GUANYLYLTRANSFERASE', 248472),
(384599, 'PTHR43137', NULL, NULL, NULL, NULL, 'DIHYDROOROTASE', 248473),
(384600, 'PTHR43137:SF1', NULL, NULL, NULL, NULL, 'DIHYDROOROTASE', 248473),
(384601, 'PTHR12658:SF0', NULL, NULL, NULL, NULL, 'TUBULIN-SPECIFIC CHAPERONE D', 248474),
(384602, 'PTHR12658', NULL, NULL, NULL, NULL, 'BETA-TUBULIN COFACTOR D', 248474),
(384603, 'PTHR45865', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SHPRH FAMILY MEMBER', 248475),
(384604, 'PTHR45865:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SHPRH', 248475),
(384605, 'PTHR22909:SF22', NULL, NULL, NULL, NULL, 'GOLGI INTEGRAL MEMBRANE PROTEIN 4', 248476),
(384606, 'PTHR22909:SF24', NULL, NULL, NULL, NULL, 'GOLGI INTEGRAL MEMBRANE PROTEIN 4B', 248476),
(384607, 'PTHR22909:SF23', NULL, NULL, NULL, NULL, 'GOLGI INTEGRAL MEMBRANE PROTEIN 4', 248476),
(384608, 'PTHR22909', NULL, NULL, NULL, NULL, 'GOLGI INTEGRAL MEMBRANE PROTEIN 4', 248476),
(384609, 'PTHR37212', NULL, NULL, NULL, NULL, 'ACTIN PROTEIN 2/3 COMPLEX SUBUNIT-LIKE PROTEIN', 248477),
(384610, 'PTHR37212:SF2', NULL, NULL, NULL, NULL, 'ACTIN PROTEIN 2/3 COMPLEX SUBUNIT-LIKE PROTEIN', 248477),
(384611, 'PTHR12431:SF17', NULL, NULL, NULL, NULL, 'SORTING NEXIN 27B', 248478),
(384612, 'PTHR12431:SF19', NULL, NULL, NULL, NULL, 'SORTING NEXIN-27', 248478),
(384613, 'PTHR12431:SF20', NULL, NULL, NULL, NULL, 'SORTING NEXIN 27A', 248478),
(384614, 'PTHR12431:SF14', NULL, NULL, NULL, NULL, 'LD15323P', 248478),
(384615, 'PTHR12431', NULL, NULL, NULL, NULL, 'SORTING NEXIN 17 AND 27', 248478),
(384616, 'PTHR12431:SF16', NULL, NULL, NULL, NULL, 'SORTING NEXIN-17', 248478),
(384617, 'PTHR12431:SF15', NULL, NULL, NULL, NULL, 'SORTING NEXIN-31', 248478),
(384618, 'PTHR10511:SF2', NULL, NULL, NULL, NULL, 'GRANULOCYTE COLONY-STIMULATING FACTOR', 248479),
(384619, 'PTHR10511:SF3', NULL, NULL, NULL, NULL, 'INTERLEUKIN-6', 248479),
(384620, 'PTHR10511', NULL, NULL, NULL, NULL, 'GRANULOCYTE COLONY-STIMULATING FACTOR', 248479),
(384621, 'PTHR31056:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 179B', 248480),
(384622, 'PTHR31056', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 179B', 248480),
(384623, 'PTHR46277:SF9', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 248481),
(384624, 'PTHR46277:SF8', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL TRANSFER PROTEIN CSR1', 248481),
(384625, 'PTHR46277:SF7', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 248481),
(384626, 'PTHR46277:SF5', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 248481),
(384627, 'PTHR46277:SF3', NULL, NULL, NULL, NULL, 'OS01G0926800 PROTEIN', 248481),
(384628, 'PTHR46277:SF22', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 248481),
(384629, 'PTHR46277:SF11', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 248481),
(384630, 'PTHR46277:SF21', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 248481),
(384631, 'PTHR46277:SF10', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 248481),
(384632, 'PTHR46277:SF20', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 248481),
(384633, 'PTHR46277', NULL, NULL, NULL, NULL, 'OS03G0850700 PROTEIN', 248481),
(384634, 'PTHR46277:SF15', NULL, NULL, NULL, NULL, 'BNAA09G45450D PROTEIN', 248481),
(384635, 'PTHR46277:SF14', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 248481),
(384636, 'PTHR46277:SF24', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 248481),
(384637, 'PTHR46277:SF13', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 248481),
(384638, 'PTHR46277:SF12', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE-RELATED', 248481);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(384639, 'PTHR46277:SF23', NULL, NULL, NULL, NULL, 'OS03G0850700 PROTEIN', 248481),
(384640, 'PTHR46277:SF19', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 248481),
(384641, 'PTHR46277:SF18', NULL, NULL, NULL, NULL, 'BNAA09G45440D PROTEIN', 248481),
(384642, 'PTHR46277:SF16', NULL, NULL, NULL, NULL, 'BNACNNG08810D PROTEIN', 248481),
(384643, 'PTHR18935:SF7', NULL, NULL, NULL, NULL, 'JANUS KINASE AND MICROTUBULE-INTERACTING PROTEIN 2', 248482),
(384644, 'PTHR18935:SF8', NULL, NULL, NULL, NULL, 'JAKMIP_CC3 DOMAIN-CONTAINING PROTEIN', 248482),
(384645, 'PTHR18935:SF9', NULL, NULL, NULL, NULL, 'JANUS KINASE AND MICROTUBULE-INTERACTING PROTEIN 3', 248482),
(384646, 'PTHR18935', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248482),
(384647, 'PTHR18935:SF6', NULL, NULL, NULL, NULL, 'JANUS KINASE AND MICROTUBULE-INTERACTING PROTEIN 1', 248482),
(384648, 'PTHR14428:SF5', NULL, NULL, NULL, NULL, 'NUCLEOLAR COMPLEX PROTEIN 3 HOMOLOG', 248483),
(384649, 'PTHR14428', NULL, NULL, NULL, NULL, 'NUCLEOLAR COMPLEX PROTEIN 3', 248483),
(384650, 'PTHR13434:SF0', NULL, NULL, NULL, NULL, 'PROTEIN CASC3', 248484),
(384651, 'PTHR13434', NULL, NULL, NULL, NULL, 'PROTEIN CASC3', 248484),
(384652, 'PTHR47532:SF2', NULL, NULL, NULL, NULL, 'GOLD DOMAIN-CONTAINING PROTEIN-RELATED', 248485),
(384653, 'PTHR47532', NULL, NULL, NULL, NULL, 'RETINAL-BINDING PROTEIN', 248485),
(384654, 'PTHR47532:SF1', NULL, NULL, NULL, NULL, 'RETINAL-BINDING PROTEIN', 248485),
(384655, 'PTHR12935', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248486),
(384656, 'PTHR12935:SF0', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYLCYCLOTRANSFERASE', 248486),
(384657, 'PTHR12935:SF13', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYLCYCLOTRANSFERASE', 248486),
(384658, 'PTHR12935:SF14', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYLCYCLOTRANSFERASE', 248486),
(384659, 'PTHR10239:SF30', NULL, NULL, NULL, NULL, 'ISTHMIN-1', 248487),
(384660, 'PTHR10239:SF29', NULL, NULL, NULL, NULL, 'AMOP DOMAIN-CONTAINING PROTEIN', 248487),
(384661, 'PTHR10239:SF28', NULL, NULL, NULL, NULL, 'ISTHMIN-2', 248487),
(384662, 'PTHR10239', NULL, NULL, NULL, NULL, 'ISTHMIN-2', 248487),
(384663, 'PTHR10239:SF31', NULL, NULL, NULL, NULL, 'ISTHMIN-2', 248487),
(384664, 'PTHR10239:SF22', NULL, NULL, NULL, NULL, 'ADHESION G PROTEIN-COUPLED RECEPTOR B2', 248487),
(384665, 'PTHR11032:SF1', NULL, NULL, NULL, NULL, 'FMS-RELATED TYROSINE KINASE 3 LIGAND', 248488),
(384666, 'PTHR11032', NULL, NULL, NULL, NULL, 'SL CYTOKINE', 248488),
(384667, 'PTHR13501:SF10', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L22, CHLOROPLASTIC', 248489),
(384668, 'PTHR13501:SF8', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L22, MITOCHONDRIAL', 248489),
(384669, 'PTHR13501', NULL, NULL, NULL, NULL, 'CHLOROPLAST 50S RIBOSOMAL PROTEIN L22-RELATED', 248489),
(384670, 'PTHR13501:SF13', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L22/L17-RELATED', 248489),
(384671, 'PTHR10660:SF6', NULL, NULL, NULL, NULL, 'PROTEASOME ACTIVATOR COMPLEX SUBUNIT 2', 248490),
(384672, 'PTHR10660:SF7', NULL, NULL, NULL, NULL, '', 248490),
(384673, 'PTHR10660:SF2', NULL, NULL, NULL, NULL, 'LD45860P', 248490),
(384674, 'PTHR10660:SF4', NULL, NULL, NULL, NULL, 'PROTEASOME ACTIVATOR COMPLEX SUBUNIT 3', 248490),
(384675, 'PTHR10660:SF5', NULL, NULL, NULL, NULL, 'PROTEASOME ACTIVATOR COMPLEX SUBUNIT 1', 248490),
(384676, 'PTHR10660', NULL, NULL, NULL, NULL, 'PROTEASOME REGULATOR PA28', 248490),
(384677, 'PTHR23311', NULL, NULL, NULL, NULL, 'HEAT SHOCK REGULATED 2', 248491),
(384678, 'PTHR23311:SF7', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 72 KDA', 248491),
(384679, 'PTHR23311:SF6', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 36', 248491),
(384680, 'PTHR23311:SF5', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 72 KDA', 248491),
(384681, 'PTHR31596:SF9', NULL, NULL, NULL, NULL, '', 248492),
(384682, 'PTHR31596:SF10', NULL, NULL, NULL, NULL, 'DUF4460 DOMAIN-CONTAINING PROTEIN', 248492),
(384683, 'PTHR31596:SF1', NULL, NULL, NULL, NULL, 'T-CELL ACTIVATION INHIBITOR, MITOCHONDRIAL', 248492),
(384684, 'PTHR31596:SF5', NULL, NULL, NULL, NULL, 'DUF4460 DOMAIN-CONTAINING PROTEIN', 248492);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(384685, 'PTHR31596', NULL, NULL, NULL, NULL, 'T-CELL ACTIVATION INHIBITOR, MITOCHONDRIAL', 248492),
(384686, 'PTHR45624:SF46', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 25 MEMBER 15B', 248493),
(384687, 'PTHR45624:SF24', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN G', 248493),
(384688, 'PTHR45624:SF47', NULL, NULL, NULL, NULL, '', 248493),
(384689, 'PTHR45624:SF22', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ORNITHINE TRANSPORTER 1', 248493),
(384690, 'PTHR45624:SF23', NULL, NULL, NULL, NULL, 'SI:DKEY-150I13.2', 248493),
(384691, 'PTHR45624:SF45', NULL, NULL, NULL, NULL, 'ORNITHINE TRANSPORTER 1, PUTATIVE-RELATED', 248493),
(384692, 'PTHR45624:SF42', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL AMINO ACID CARRIER', 248493),
(384693, 'PTHR45624:SF20', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ORNITHINE TRANSPORTER 2', 248493),
(384694, 'PTHR45624:SF43', NULL, NULL, NULL, NULL, 'BNAA09G18190D PROTEIN', 248493),
(384695, 'PTHR45624:SF41', NULL, NULL, NULL, NULL, 'BASIC AMINO ACIDS TRANSPORTER-RELATED', 248493),
(384696, 'PTHR45624:SF29', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CARRIER PROTEIN', 248493),
(384697, 'PTHR45624:SF48', NULL, NULL, NULL, NULL, 'CARRIER PROTEIN, PUTATIVE-RELATED', 248493),
(384698, 'PTHR45624:SF26', NULL, NULL, NULL, NULL, 'CARRIER PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G07710)-RELATED', 248493),
(384699, 'PTHR45624:SF50', NULL, NULL, NULL, NULL, 'CARNITINE/ACYLCARNITINE CARRIER CACL-LIKE PROTEIN', 248493),
(384700, 'PTHR45624:SF57', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN L', 248493),
(384701, 'PTHR45624:SF35', NULL, NULL, NULL, NULL, 'OS10G0573800 PROTEIN', 248493),
(384702, 'PTHR45624', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL BASIC AMINO ACIDS TRANSPORTER-RELATED', 248493),
(384703, 'PTHR45624:SF36', NULL, NULL, NULL, NULL, 'BNAANNG10350D PROTEIN', 248493),
(384704, 'PTHR45624:SF9', NULL, NULL, NULL, NULL, 'CARRIER PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G06390)-RELATED', 248493),
(384705, 'PTHR45624:SF58', NULL, NULL, NULL, NULL, 'CARRIER PROTEIN, PUTATIVE-RELATED', 248493),
(384706, 'PTHR45624:SF55', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CARNITINE/ACYLCARNITINE CARRIER-LIKE PROTEIN', 248493),
(384707, 'PTHR45624:SF11', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ORNITHINE TRANSPORTER 1', 248493),
(384708, 'PTHR45624:SF56', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CARNITINE/ACYLCARNITINE CARRIER PROTEIN', 248493),
(384709, 'PTHR45624:SF34', NULL, NULL, NULL, NULL, 'CARNITINE/ACYLCARNITINE CARRIER-LIKE PROTEIN', 248493),
(384710, 'PTHR45624:SF12', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN S-RELATED', 248493),
(384711, 'PTHR45624:SF53', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CARRIER PROTEIN', 248493),
(384712, 'PTHR45624:SF31', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ORNITHINE TRANSPORTER 1', 248493),
(384713, 'PTHR45624:SF4', NULL, NULL, NULL, NULL, 'CONGESTED-LIKE TRACHEA PROTEIN-RELATED', 248493),
(384714, 'PTHR45624:SF54', NULL, NULL, NULL, NULL, 'PROTEIN CBG23372', 248493),
(384715, 'PTHR45624:SF10', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL BASIC AMINO ACIDS TRANSPORTER', 248493),
(384716, 'PTHR45624:SF6', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 25 MEMBER 45', 248493),
(384717, 'PTHR45624:SF51', NULL, NULL, NULL, NULL, 'CARRIER PROTEIN YMC2, MITOCHONDRIAL-RELATED', 248493),
(384718, 'PTHR45624:SF52', NULL, NULL, NULL, NULL, 'CHROMOSOME 10, WHOLE GENOME SHOTGUN SEQUENCE', 248493),
(384719, 'PTHR45624:SF30', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CARNITINE/ACYLCARNITINE CARRIER PROTEIN', 248493),
(384720, 'PTHR45624:SF7', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 25 MEMBER 48', 248493),
(384721, 'PTHR45624:SF39', NULL, NULL, NULL, NULL, 'SUBSTRATE CARRIER PROTEIN-RELATED', 248493),
(384722, 'PTHR45624:SF18', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN D', 248493),
(384723, 'PTHR45624:SF15', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ARGININE TRANSPORTER BAC1', 248493),
(384724, 'PTHR45624:SF38', NULL, NULL, NULL, NULL, 'BNAA06G40370D PROTEIN', 248493),
(384725, 'PTHR45624:SF1', NULL, NULL, NULL, NULL, 'SD08189P', 248493);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(384726, 'PTHR45624:SF3', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 25 MEMBER 47', 248493),
(384727, 'PTHR23521:SF3', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 248494),
(384728, 'PTHR23521:SF2', NULL, NULL, NULL, NULL, 'TRANSPORTER MFS SUPERFAMILY', 248494),
(384729, 'PTHR23521', NULL, NULL, NULL, NULL, 'TRANSPORTER MFS SUPERFAMILY', 248494),
(384730, 'PTHR46914:SF2', NULL, NULL, NULL, NULL, 'NLR FAMILY, APOPTOSIS INHIBITORY PROTEIN', 248495),
(384731, 'PTHR46914:SF1', NULL, NULL, NULL, NULL, 'BACULOVIRAL IAP REPEAT-CONTAINING PROTEIN 1', 248495),
(384732, 'PTHR46914', NULL, NULL, NULL, NULL, 'BACULOVIRAL IAP REPEAT-CONTAINING PROTEIN 1', 248495),
(384733, 'PTHR14744', NULL, NULL, NULL, NULL, 'N-ALPHA-ACETYLTRANSFERASE 60', 248496),
(384734, 'PTHR14744:SF15', NULL, NULL, NULL, NULL, 'N-ALPHA-ACETYLTRANSFERASE 60', 248496),
(384735, 'PTHR14744:SF16', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE MCC1', 248496),
(384736, 'PTHR14744:SF17', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 248496),
(384737, 'PTHR31363:SF1', NULL, NULL, NULL, NULL, 'MIP-T3 DOMAIN-CONTAINING PROTEIN', 248497),
(384738, 'PTHR31363:SF0', NULL, NULL, NULL, NULL, 'TRAF3-INTERACTING PROTEIN 1', 248497),
(384739, 'PTHR31363', NULL, NULL, NULL, NULL, 'TRAF3-INTERACTING PROTEIN 1', 248497),
(384740, 'PTHR38620', NULL, NULL, NULL, NULL, 'PROTEIN CBG07292-RELATED', 248498),
(384741, 'PTHR38620:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG07292', 248498),
(384742, 'PTHR14978:SF0', NULL, NULL, NULL, NULL, 'BETA-CATENIN-LIKE PROTEIN 1', 248499),
(384743, 'PTHR14978:SF3', NULL, NULL, NULL, NULL, 'DUF1716 DOMAIN-CONTAINING PROTEIN', 248499),
(384744, 'PTHR14978', NULL, NULL, NULL, NULL, 'BETA-CATENIN-LIKE PROTEIN 1  NUCLEAR ASSOCIATED PROTEIN', 248499),
(384745, 'PTHR14978:SF4', NULL, NULL, NULL, NULL, 'BETA-CATENIN-LIKE PROTEIN 1', 248499),
(384746, 'PTHR46631:SF18', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L18A-LIKE PROTEIN', 248500),
(384747, 'PTHR46631:SF19', NULL, NULL, NULL, NULL, 'BNAA09G45170D PROTEIN', 248500),
(384748, 'PTHR46631:SF2', NULL, NULL, NULL, NULL, 'OS01G0242900 PROTEIN', 248500),
(384749, 'PTHR46631:SF4', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L18A-LIKE PROTEIN', 248500),
(384750, 'PTHR46631:SF6', NULL, NULL, NULL, NULL, 'OS06G0359400 PROTEIN', 248500),
(384751, 'PTHR46631', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L18A-LIKE', 248500),
(384752, 'PTHR46631:SF9', NULL, NULL, NULL, NULL, '', 248500),
(384753, 'PTHR46631:SF23', NULL, NULL, NULL, NULL, 'BNAA06G00860D PROTEIN', 248500),
(384754, 'PTHR46631:SF24', NULL, NULL, NULL, NULL, 'OS01G0667100 PROTEIN', 248500),
(384755, 'PTHR46631:SF13', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L18A-LIKE PROTEIN', 248500),
(384756, 'PTHR46631:SF21', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L18A', 248500),
(384757, 'PTHR46631:SF22', NULL, NULL, NULL, NULL, '', 248500),
(384758, 'PTHR46631:SF25', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L18A-LIKE PROTEIN', 248500),
(384759, 'PTHR46631:SF14', NULL, NULL, NULL, NULL, '', 248500),
(384760, 'PTHR46631:SF26', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L18A-LIKE PROTEIN', 248500),
(384761, 'PTHR46631:SF15', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L18AE FAMILY-RELATED', 248500),
(384762, 'PTHR37006:SF1', NULL, NULL, NULL, NULL, 'RETROVIRAL-LIKE ASPARTIC PROTEASE 1', 248501),
(384763, 'PTHR37006', NULL, NULL, NULL, NULL, 'RETROVIRAL-LIKE ASPARTIC PROTEASE 1', 248501),
(384764, 'PTHR35724', NULL, NULL, NULL, NULL, 'PROTEIN CHLORORESPIRATORY REDUCTION 6, CHLOROPLASTIC', 248502),
(384765, 'PTHR35724:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CHLORORESPIRATORY REDUCTION 6, CHLOROPLASTIC', 248502),
(384766, 'PTHR33924:SF1', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT BETA', 248503),
(384767, 'PTHR33924:SF4', NULL, NULL, NULL, NULL, '', 248503),
(384768, 'PTHR33924:SF5', NULL, NULL, NULL, NULL, 'CATION-TRANSPORTING ATPASE', 248503),
(384769, 'PTHR33924:SF6', NULL, NULL, NULL, NULL, '', 248503),
(384770, 'PTHR33924', NULL, NULL, NULL, NULL, 'CATION-TRANSPORTING ATPASE', 248503);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(384771, 'PTHR19316:SF33', NULL, NULL, NULL, NULL, 'TOG DOMAIN-CONTAINING PROTEIN', 248504),
(384772, 'PTHR19316:SF21', NULL, NULL, NULL, NULL, 'HEAT REPEAT FAMILY PROTEIN, EXPRESSED', 248504),
(384773, 'PTHR19316:SF32', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 248504),
(384774, 'PTHR19316', NULL, NULL, NULL, NULL, 'PROTEIN FOLDING REGULATOR', 248504),
(384775, 'PTHR19316:SF31', NULL, NULL, NULL, NULL, 'FES1B', 248504),
(384776, 'PTHR19316:SF30', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 248504),
(384777, 'PTHR19316:SF35', NULL, NULL, NULL, NULL, 'NUCLEOTIDE EXCHANGE FACTOR SIL1', 248504),
(384778, 'PTHR19316:SF34', NULL, NULL, NULL, NULL, 'NUCLEOTIDE EXCHANGE FACTOR SIL1', 248504),
(384779, 'PTHR19316:SF18', NULL, NULL, NULL, NULL, 'HSP70-BINDING PROTEIN 1', 248504),
(384780, 'PTHR36043:SF3', NULL, NULL, NULL, NULL, '', 248505),
(384781, 'PTHR36043:SF1', NULL, NULL, NULL, NULL, '2,3-BISPHOSPHOGLYCERATE-INDEPENDENT PHOSPHOGLYCERATE MUTASE', 248505),
(384782, 'PTHR36043', NULL, NULL, NULL, NULL, '2,3-BISPHOSPHOGLYCERATE-INDEPENDENT PHOSPHOGLYCERATE MUTASE', 248505),
(384783, 'PTHR46077:SF4', NULL, NULL, NULL, NULL, '', 248506),
(384784, 'PTHR46077:SF3', NULL, NULL, NULL, NULL, 'TOPOISOMERASE I-BINDING, ARGININE/SERINE-RICH-LIKE', 248506),
(384785, 'PTHR46077:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TOPORS', 248506),
(384786, 'PTHR46077:SF1', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 248506),
(384787, 'PTHR46077', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TOPORS', 248506),
(384788, 'PTHR46077:SF6', NULL, NULL, NULL, NULL, '', 248506),
(384789, 'PTHR46077:SF5', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 248506),
(384790, 'PTHR34662:SF8', NULL, NULL, NULL, NULL, '', 248507),
(384791, 'PTHR34662', NULL, NULL, NULL, NULL, 'OS04G0422700 PROTEIN', 248507),
(384792, 'PTHR34662:SF7', NULL, NULL, NULL, NULL, 'OS04G0422700 PROTEIN', 248507),
(384793, 'PTHR34662:SF3', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 248507),
(384794, 'PTHR48010:SF46', NULL, NULL, NULL, NULL, 'ATP BINDING PROTEIN', 248508),
(384795, 'PTHR48010:SF5', NULL, NULL, NULL, NULL, 'PROTEIN TOO MANY MOUTHS', 248508),
(384796, 'PTHR48010:SF4', NULL, NULL, NULL, NULL, 'OS04G0463000 PROTEIN', 248508),
(384797, 'PTHR48010:SF7', NULL, NULL, NULL, NULL, 'OS09G0400500 PROTEIN', 248508),
(384798, 'PTHR48010:SF88', NULL, NULL, NULL, NULL, 'OS05G0480400 PROTEIN', 248508),
(384799, 'PTHR48010:SF44', NULL, NULL, NULL, NULL, 'F16P17.10 PROTEIN', 248508),
(384800, 'PTHR48010:SF45', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN, PLANT-TYPE-RELATED', 248508),
(384801, 'PTHR48010:SF6', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384802, 'PTHR48010:SF89', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384803, 'PTHR48010:SF1', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384804, 'PTHR48010:SF48', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384805, 'PTHR48010:SF2', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE FAMILY PROTEIN', 248508),
(384806, 'PTHR48010:SF49', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384807, 'PTHR48010:SF8', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384808, 'PTHR48010', NULL, NULL, NULL, NULL, 'OS05G0588300 PROTEIN', 248508),
(384809, 'PTHR48010:SF82', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384810, 'PTHR48010:SF83', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384811, 'PTHR48010:SF80', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 248508),
(384812, 'PTHR48010:SF81', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE', 248508),
(384813, 'PTHR48010:SF86', NULL, NULL, NULL, NULL, 'OS07G0574100 PROTEIN', 248508),
(384814, 'PTHR48010:SF42', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384815, 'PTHR48010:SF87', NULL, NULL, NULL, NULL, 'INACTIVE RECEPTOR KINASE-RELATED', 248508);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(384816, 'PTHR48010:SF40', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE', 248508),
(384817, 'PTHR48010:SF84', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384818, 'PTHR48010:SF85', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384819, 'PTHR48010:SF79', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384820, 'PTHR48010:SF36', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN, PLANT-TYPE-RELATED', 248508),
(384821, 'PTHR48010:SF77', NULL, NULL, NULL, NULL, 'INACTIVE RECEPTOR KINASE RLK902-RELATED', 248508),
(384822, 'PTHR48010:SF33', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384823, 'PTHR48010:SF78', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE-RELATED', 248508),
(384824, 'PTHR48010:SF34', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384825, 'PTHR48010:SF39', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384826, 'PTHR48010:SF38', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384827, 'PTHR48010:SF71', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384828, 'PTHR48010:SF72', NULL, NULL, NULL, NULL, 'OS08G0117700 PROTEIN', 248508),
(384829, 'PTHR48010:SF70', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE FAMILY PROTEIN-RELATED', 248508),
(384830, 'PTHR48010:SF75', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 248508),
(384831, 'PTHR48010:SF32', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384832, 'PTHR48010:SF76', NULL, NULL, NULL, NULL, 'INACTIVE RECEPTOR KINASE RLK902-RELATED', 248508),
(384833, 'PTHR48010:SF73', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384834, 'PTHR48010:SF74', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN-RELATED', 248508),
(384835, 'PTHR48010:SF24', NULL, NULL, NULL, NULL, 'INACTIVE RECEPTOR KINASE-RELATED', 248508),
(384836, 'PTHR48010:SF22', NULL, NULL, NULL, NULL, 'OS09G0376600 PROTEIN', 248508),
(384837, 'PTHR48010:SF29', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384838, 'PTHR48010:SF26', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE', 248508),
(384839, 'PTHR48010:SF27', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384840, 'PTHR48010:SF60', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384841, 'PTHR48010:SF61', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384842, 'PTHR48010:SF64', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384843, 'PTHR48010:SF20', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384844, 'PTHR48010:SF21', NULL, NULL, NULL, NULL, 'OS07G0681100 PROTEIN', 248508),
(384845, 'PTHR48010:SF63', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE', 248508),
(384846, 'PTHR48010:SF57', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384847, 'PTHR48010:SF58', NULL, NULL, NULL, NULL, 'OS05G0595800 PROTEIN', 248508),
(384848, 'PTHR48010:SF14', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384849, 'PTHR48010:SF55', NULL, NULL, NULL, NULL, 'OS01G0607900 PROTEIN', 248508),
(384850, 'PTHR48010:SF11', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384851, 'PTHR48010:SF17', NULL, NULL, NULL, NULL, 'PIRIFORMOSPORA INDICA-INSENSITIVE PROTEIN 2-LIKE', 248508),
(384852, 'PTHR48010:SF15', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384853, 'PTHR48010:SF59', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384854, 'PTHR48010:SF16', NULL, NULL, NULL, NULL, 'OS03G0332900 PROTEIN', 248508),
(384855, 'PTHR48010:SF19', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384856, 'PTHR48010:SF50', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(384857, 'PTHR48010:SF54', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384858, 'PTHR48010:SF10', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384859, 'PTHR48010:SF52', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248508),
(384860, 'PTHR31989:SF33', NULL, NULL, NULL, NULL, 'CONTAINING PROTEIN 90, PUTATIVE, EXPRESSED-RELATED', 248509),
(384861, 'PTHR31989:SF413', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 86', 248509),
(384862, 'PTHR31989:SF412', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384863, 'PTHR31989:SF411', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384864, 'PTHR31989:SF25', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384865, 'PTHR31989:SF415', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 43-LIKE', 248509),
(384866, 'PTHR31989:SF29', NULL, NULL, NULL, NULL, 'NAC DOMAIN CONTAINING PROTEIN 50-RELATED', 248509),
(384867, 'PTHR31989:SF28', NULL, NULL, NULL, NULL, 'OS11G0179300 PROTEIN', 248509),
(384868, 'PTHR31989:SF418', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN-RELATED', 248509),
(384869, 'PTHR31989:SF40', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 89', 248509),
(384870, 'PTHR31989:SF405', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 96', 248509),
(384871, 'PTHR31989:SF34', NULL, NULL, NULL, NULL, '', 248509),
(384872, 'PTHR31989:SF409', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 30-LIKE', 248509),
(384873, 'PTHR31989:SF39', NULL, NULL, NULL, NULL, 'PROTEIN BEARSKIN1-RELATED', 248509),
(384874, 'PTHR31989:SF310', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384875, 'PTHR31989:SF430', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384876, 'PTHR31989:SF314', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384877, 'PTHR31989:SF313', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384878, 'PTHR31989:SF432', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384879, 'PTHR31989', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 82-RELATED', 248509),
(384880, 'PTHR31989:SF439', NULL, NULL, NULL, NULL, 'NAC (NO APICAL MERISTEM) DOMAIN TRANSCRIPTIONAL REGULATOR SUPERFAMILY PROTEIN', 248509),
(384881, 'PTHR31989:SF317', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384882, 'PTHR31989:SF438', NULL, NULL, NULL, NULL, 'OS06G0101800 PROTEIN', 248509),
(384883, 'PTHR31989:SF316', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384884, 'PTHR31989:SF20', NULL, NULL, NULL, NULL, 'NAC4 PROTEIN', 248509),
(384885, 'PTHR31989:SF303', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN-RELATED', 248509),
(384886, 'PTHR31989:SF424', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 3-RELATED', 248509),
(384887, 'PTHR31989:SF423', NULL, NULL, NULL, NULL, 'NAC DOMAIN CONTAINING 69-LIKE PROTEIN ISOFORM 1', 248509),
(384888, 'PTHR31989:SF422', NULL, NULL, NULL, NULL, 'OS02G0745250 PROTEIN', 248509),
(384889, 'PTHR31989:SF300', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384890, 'PTHR31989:SF421', NULL, NULL, NULL, NULL, 'OS01G0811500 PROTEIN', 248509),
(384891, 'PTHR31989:SF307', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384892, 'PTHR31989:SF306', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384893, 'PTHR31989:SF427', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384894, 'PTHR31989:SF426', NULL, NULL, NULL, NULL, 'OS04G0536500 PROTEIN', 248509),
(384895, 'PTHR31989:SF305', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 66', 248509),
(384896, 'PTHR31989:SF309', NULL, NULL, NULL, NULL, 'NAC TRANSCRIPTION FACTOR', 248509),
(384897, 'PTHR31989:SF308', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384898, 'PTHR31989:SF429', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384899, 'PTHR31989:SF16', NULL, NULL, NULL, NULL, 'PROTEIN SOMBRERO', 248509); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(384900, 'PTHR31989:SF332', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384901, 'PTHR31989:SF453', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN-RELATED', 248509),
(384902, 'PTHR31989:SF211', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 40', 248509),
(384903, 'PTHR31989:SF452', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384904, 'PTHR31989:SF451', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384905, 'PTHR31989:SF330', NULL, NULL, NULL, NULL, 'OS05G0515800 PROTEIN', 248509),
(384906, 'PTHR31989:SF450', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384907, 'PTHR31989:SF457', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384908, 'PTHR31989:SF215', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 1', 248509),
(384909, 'PTHR31989:SF456', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384910, 'PTHR31989:SF335', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384911, 'PTHR31989:SF455', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384912, 'PTHR31989:SF454', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 72', 248509),
(384913, 'PTHR31989:SF333', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384914, 'PTHR31989:SF218', NULL, NULL, NULL, NULL, 'OS01G0862800 PROTEIN', 248509),
(384915, 'PTHR31989:SF338', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN-RELATED', 248509),
(384916, 'PTHR31989:SF459', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384917, 'PTHR31989:SF216', NULL, NULL, NULL, NULL, 'OS10G0402100 PROTEIN', 248509),
(384918, 'PTHR31989:SF458', NULL, NULL, NULL, NULL, 'OS06G0726300 PROTEIN', 248509),
(384919, 'PTHR31989:SF442', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 43-LIKE', 248509),
(384920, 'PTHR31989:SF441', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 62-LIKE', 248509),
(384921, 'PTHR31989:SF320', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 14-RELATED', 248509),
(384922, 'PTHR31989:SF440', NULL, NULL, NULL, NULL, 'NO APICAL MERISTEM PROTEIN, EXPRESSED', 248509),
(384923, 'PTHR31989:SF446', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 83', 248509),
(384924, 'PTHR31989:SF325', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN-RELATED', 248509),
(384925, 'PTHR31989:SF445', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384926, 'PTHR31989:SF444', NULL, NULL, NULL, NULL, 'NAC DOMAIN TRANSCRIPTION FACTOR SUPERFAMILY PROTEIN-RELATED', 248509),
(384927, 'PTHR31989:SF443', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 90-LIKE', 248509),
(384928, 'PTHR31989:SF322', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384929, 'PTHR31989:SF208', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 37', 248509),
(384930, 'PTHR31989:SF329', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 45-LIKE', 248509),
(384931, 'PTHR31989:SF449', NULL, NULL, NULL, NULL, 'NAC DOMAIN CONTAINING PROTEIN 76-RELATED', 248509),
(384932, 'PTHR31989:SF327', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384933, 'PTHR31989:SF448', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384934, 'PTHR31989:SF205', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 17', 248509),
(384935, 'PTHR31989:SF447', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384936, 'PTHR31989:SF51', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 71', 248509),
(384937, 'PTHR31989:SF54', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 91', 248509),
(384938, 'PTHR31989:SF471', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 2-LIKE', 248509),
(384939, 'PTHR31989:SF470', NULL, NULL, NULL, NULL, 'DOMAIN-CONTAINING PROTEIN, PUTATIVE-RELATED', 248509),
(384940, 'PTHR31989:SF354', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384941, 'PTHR31989:SF475', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 86-LIKE', 248509);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(384942, 'PTHR31989:SF474', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384943, 'PTHR31989:SF232', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 61-RELATED', 248509),
(384944, 'PTHR31989:SF473', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384945, 'PTHR31989:SF472', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384946, 'PTHR31989:SF351', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384947, 'PTHR31989:SF358', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 86-LIKE', 248509),
(384948, 'PTHR31989:SF479', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 83-LIKE ISOFORM X1', 248509),
(384949, 'PTHR31989:SF478', NULL, NULL, NULL, NULL, 'OS12G0135850 PROTEIN', 248509),
(384950, 'PTHR31989:SF236', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 60-LIKE', 248509),
(384951, 'PTHR31989:SF356', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384952, 'PTHR31989:SF477', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384953, 'PTHR31989:SF234', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384954, 'PTHR31989:SF476', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384955, 'PTHR31989:SF46', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 53', 248509),
(384956, 'PTHR31989:SF359', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384957, 'PTHR31989:SF238', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 62', 248509),
(384958, 'PTHR31989:SF62', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384959, 'PTHR31989:SF460', NULL, NULL, NULL, NULL, 'NAC TRANSCRIPTION FACTORS 77', 248509),
(384960, 'PTHR31989:SF101', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 68-LIKE', 248509),
(384961, 'PTHR31989:SF464', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 26-RELATED', 248509),
(384962, 'PTHR31989:SF221', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384963, 'PTHR31989:SF463', NULL, NULL, NULL, NULL, 'F5D14.30 PROTEIN', 248509),
(384964, 'PTHR31989:SF220', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384965, 'PTHR31989:SF462', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 7-LIKE', 248509),
(384966, 'PTHR31989:SF461', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 7-LIKE', 248509),
(384967, 'PTHR31989:SF340', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384968, 'PTHR31989:SF226', NULL, NULL, NULL, NULL, 'NAC TRANSCRIPTION FACTOR-LIKE PROTEIN', 248509),
(384969, 'PTHR31989:SF468', NULL, NULL, NULL, NULL, 'NAC DOMAIN CONTAINING PROTEIN 12-RELATED', 248509),
(384970, 'PTHR31989:SF467', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384971, 'PTHR31989:SF346', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 68-LIKE', 248509),
(384972, 'PTHR31989:SF104', NULL, NULL, NULL, NULL, 'NAC DOMAIN TRANSCRIPTION FACTOR SUPERFAMILY PROTEIN-RELATED', 248509),
(384973, 'PTHR31989:SF224', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 16', 248509),
(384974, 'PTHR31989:SF466', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 6', 248509),
(384975, 'PTHR31989:SF345', NULL, NULL, NULL, NULL, 'OS02G0643600 PROTEIN', 248509),
(384976, 'PTHR31989:SF344', NULL, NULL, NULL, NULL, 'NAC DOMAIN CONTAINING PROTEIN 53-RELATED', 248509),
(384977, 'PTHR31989:SF223', NULL, NULL, NULL, NULL, 'OS01G0378400 PROTEIN', 248509),
(384978, 'PTHR31989:SF465', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384979, 'PTHR31989:SF229', NULL, NULL, NULL, NULL, 'NAC DOMAIN CONTAINING PROTEIN 20', 248509),
(384980, 'PTHR31989:SF228', NULL, NULL, NULL, NULL, 'NAC TRANSCRIPTION FACTORS 68', 248509),
(384981, 'PTHR31989:SF348', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 78-LIKE', 248509),
(384982, 'PTHR31989:SF227', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384983, 'PTHR31989:SF469', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(384984, 'PTHR31989:SF493', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384985, 'PTHR31989:SF372', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384986, 'PTHR31989:SF492', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384987, 'PTHR31989:SF491', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 86-LIKE', 248509),
(384988, 'PTHR31989:SF490', NULL, NULL, NULL, NULL, 'NAC DOMAIN TRANSCRIPTION FACTOR SUPERFAMILY PROTEIN-RELATED', 248509),
(384989, 'PTHR31989:SF376', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384990, 'PTHR31989:SF133', NULL, NULL, NULL, NULL, 'OS08G0327800 PROTEIN', 248509),
(384991, 'PTHR31989:SF132', NULL, NULL, NULL, NULL, 'NAC DOMAIN CONTAINING PROTEIN 36', 248509),
(384992, 'PTHR31989:SF495', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384993, 'PTHR31989:SF374', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN-RELATED', 248509),
(384994, 'PTHR31989:SF252', NULL, NULL, NULL, NULL, 'PLANT NAC DOMAIN PROTEIN', 248509),
(384995, 'PTHR31989:SF494', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384996, 'PTHR31989:SF131', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(384997, 'PTHR31989:SF138', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 12', 248509),
(384998, 'PTHR31989:SF259', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 86-LIKE ISOFORM X1', 248509),
(384999, 'PTHR31989:SF379', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(385000, 'PTHR31989:SF258', NULL, NULL, NULL, NULL, 'OS06G0131700 PROTEIN', 248509),
(385001, 'PTHR31989:SF377', NULL, NULL, NULL, NULL, 'OS02G0745300 PROTEIN', 248509),
(385002, 'PTHR31989:SF361', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 101-LIKE', 248509),
(385003, 'PTHR31989:SF482', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(385004, 'PTHR31989:SF481', NULL, NULL, NULL, NULL, 'OS04G0475400 PROTEIN', 248509),
(385005, 'PTHR31989:SF360', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(385006, 'PTHR31989:SF480', NULL, NULL, NULL, NULL, 'NAC TRANSCRIPTION FACTOR 29-LIKE', 248509),
(385007, 'PTHR31989:SF486', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 76-LIKE', 248509),
(385008, 'PTHR31989:SF365', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 78', 248509),
(385009, 'PTHR31989:SF244', NULL, NULL, NULL, NULL, 'SWN2', 248509),
(385010, 'PTHR31989:SF485', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 43-LIKE', 248509),
(385011, 'PTHR31989:SF243', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 101', 248509),
(385012, 'PTHR31989:SF363', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 30', 248509),
(385013, 'PTHR31989:SF484', NULL, NULL, NULL, NULL, 'NAC DOMAIN CONTAINING PROTEIN 49', 248509),
(385014, 'PTHR31989:SF483', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR JUNGBRUNNEN 1', 248509),
(385015, 'PTHR31989:SF241', NULL, NULL, NULL, NULL, 'OS12G0177600 PROTEIN', 248509),
(385016, 'PTHR31989:SF369', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(385017, 'PTHR31989:SF127', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 35', 248509),
(385018, 'PTHR31989:SF247', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 94 ISOFORM X1-RELATED', 248509),
(385019, 'PTHR31989:SF489', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(385020, 'PTHR31989:SF368', NULL, NULL, NULL, NULL, 'PROTEIN BEARSKIN2-LIKE', 248509),
(385021, 'PTHR31989:SF126', NULL, NULL, NULL, NULL, 'OS02G0822400 PROTEIN', 248509),
(385022, 'PTHR31989:SF488', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 43-LIKE', 248509),
(385023, 'PTHR31989:SF367', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(385024, 'PTHR31989:SF366', NULL, NULL, NULL, NULL, 'OS09G0295000 PROTEIN', 248509),
(385025, 'PTHR31989:SF487', NULL, NULL, NULL, NULL, 'NAC DOMAIN TRANSCRIPTION FACTOR SUPERFAMILY PROTEIN-RELATED', 248509),
(385026, 'PTHR31989:SF245', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 13', 248509);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(385027, 'PTHR31989:SF99', NULL, NULL, NULL, NULL, 'NAC DOMAIN TRANSCRIPTION FACTOR SUPERFAMILY PROTEIN-RELATED', 248509),
(385028, 'PTHR31989:SF272', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(385029, 'PTHR31989:SF150', NULL, NULL, NULL, NULL, 'NAC DOMAIN CONTAINING PROTEIN 57', 248509),
(385030, 'PTHR31989:SF392', NULL, NULL, NULL, NULL, 'NO APICAL MERISTEM PROTEIN, EXPRESSED', 248509),
(385031, 'PTHR31989:SF277', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(385032, 'PTHR31989:SF276', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN-RELATED', 248509),
(385033, 'PTHR31989:SF154', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(385034, 'PTHR31989:SF274', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(385035, 'PTHR31989:SF395', NULL, NULL, NULL, NULL, 'TCV-INTERACTING PROTEIN-RELATED', 248509),
(385036, 'PTHR31989:SF153', NULL, NULL, NULL, NULL, 'F11O4.3-RELATED', 248509),
(385037, 'PTHR31989:SF159', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(385038, 'PTHR31989:SF157', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(385039, 'PTHR31989:SF140', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 105', 248509),
(385040, 'PTHR31989:SF260', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 76', 248509),
(385041, 'PTHR31989:SF145', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 92-LIKE', 248509),
(385042, 'PTHR31989:SF386', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 41', 248509),
(385043, 'PTHR31989:SF385', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(385044, 'PTHR31989:SF149', NULL, NULL, NULL, NULL, 'NAC TRANSCRIPTION FACTOR 14', 248509),
(385045, 'PTHR31989:SF269', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 60', 248509),
(385046, 'PTHR31989:SF148', NULL, NULL, NULL, NULL, 'OS01G0339500 PROTEIN', 248509),
(385047, 'PTHR31989:SF388', NULL, NULL, NULL, NULL, 'NAC TRANSCRIPTION FACTOR 25-LIKE', 248509),
(385048, 'PTHR31989:SF146', NULL, NULL, NULL, NULL, 'OS06G0104200 PROTEIN', 248509),
(385049, 'PTHR31989:SF170', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 76', 248509),
(385050, 'PTHR31989:SF294', NULL, NULL, NULL, NULL, 'NAC DOMAIN PROTEIN', 248509),
(385051, 'PTHR31989:SF293', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(385052, 'PTHR31989:SF171', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 82-LIKE', 248509),
(385053, 'PTHR31989:SF299', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 43', 248509),
(385054, 'PTHR31989:SF298', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(385055, 'PTHR31989:SF177', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 76-LIKE', 248509),
(385056, 'PTHR31989:SF280', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(385057, 'PTHR31989:SF284', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 82', 248509),
(385058, 'PTHR31989:SF281', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(385059, 'PTHR31989:SF287', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(385060, 'PTHR31989:SF286', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(385061, 'PTHR31989:SF285', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 74', 248509),
(385062, 'PTHR31989:SF4', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 90', 248509),
(385063, 'PTHR31989:SF6', NULL, NULL, NULL, NULL, 'F12P19.8 PROTEIN', 248509),
(385064, 'PTHR31989:SF169', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 83-LIKE', 248509),
(385065, 'PTHR31989:SF168', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 4-LIKE ISOFORM X1', 248509),
(385066, 'PTHR31989:SF289', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(385067, 'PTHR31989:SF192', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(385068, 'PTHR31989:SF191', NULL, NULL, NULL, NULL, 'NAC DOMAIN CONTAINING PROTEIN 103', 248509),
(385069, 'PTHR31989:SF199', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 45', 248509);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(385070, 'PTHR31989:SF181', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 78-LIKE', 248509),
(385071, 'PTHR31989:SF188', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(385072, 'PTHR31989:SF186', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 248509),
(385073, 'PTHR31882:SF2', NULL, NULL, NULL, NULL, 'TNFAIP3-INTERACTING PROTEIN 3', 248510),
(385074, 'PTHR31882:SF3', NULL, NULL, NULL, NULL, 'TNFAIP3-INTERACTING PROTEIN 1', 248510),
(385075, 'PTHR31882:SF6', NULL, NULL, NULL, NULL, 'TNFAIP3-INTERACTING PROTEIN 2', 248510),
(385076, 'PTHR31882:SF8', NULL, NULL, NULL, NULL, 'CCHC NOA-TYPE DOMAIN-CONTAINING PROTEIN', 248510),
(385077, 'PTHR31882:SF9', NULL, NULL, NULL, NULL, 'SI:CH211-153B23.7', 248510),
(385078, 'PTHR31882:SF11', NULL, NULL, NULL, NULL, 'HDA1 COMPLEX SUBUNIT 2', 248510),
(385079, 'PTHR31882', NULL, NULL, NULL, NULL, 'TNFAIP3-INTERACTING PROTEIN COILED COIL FAMILY MEMBER', 248510),
(385080, 'PTHR46316', NULL, NULL, NULL, NULL, 'SNF1-RELATED PROTEIN KINASE REGULATORY SUBUNIT BETA-1', 248511),
(385081, 'PTHR46316:SF15', NULL, NULL, NULL, NULL, 'DBD_TNP_MUT DOMAIN-CONTAINING PROTEIN', 248511),
(385082, 'PTHR46316:SF3', NULL, NULL, NULL, NULL, 'OS07G0687300 PROTEIN', 248511),
(385083, 'PTHR46316:SF4', NULL, NULL, NULL, NULL, 'BETA SUBUNIT 1 OF SNRK1', 248511),
(385084, 'PTHR46316:SF2', NULL, NULL, NULL, NULL, 'SNF1-RELATED PROTEIN KINASE REGULATORY SUBUNIT BETA-2', 248511),
(385085, 'PTHR46316:SF12', NULL, NULL, NULL, NULL, 'AMPKBI DOMAIN-CONTAINING PROTEIN', 248511),
(385086, 'PTHR46316:SF13', NULL, NULL, NULL, NULL, 'AMPKBI DOMAIN-CONTAINING PROTEIN', 248511),
(385087, 'PTHR46316:SF11', NULL, NULL, NULL, NULL, 'AMPKBI DOMAIN-CONTAINING PROTEIN', 248511),
(385088, 'PTHR46316:SF7', NULL, NULL, NULL, NULL, 'SNF1-RELATED PROTEIN KINASE REGULATORY SUBUNIT BETA-2-LIKE', 248511),
(385089, 'PTHR46316:SF8', NULL, NULL, NULL, NULL, 'SNF1-RELATED PROTEIN KINASE REGULATORY SUBUNIT BETA-2-LIKE ISOFORM X1', 248511),
(385090, 'PTHR46316:SF5', NULL, NULL, NULL, NULL, 'SNF1-RELATED PROTEIN KINASE REGULATORY SUBUNIT BETA-3', 248511),
(385091, 'PTHR46316:SF6', NULL, NULL, NULL, NULL, 'AMPKBI DOMAIN-CONTAINING PROTEIN', 248511),
(385092, 'PTHR46316:SF9', NULL, NULL, NULL, NULL, 'SNF1-RELATED PROTEIN KINASE REGULATORY SUBUNIT BETA-1', 248511),
(385093, 'PTHR23216', NULL, NULL, NULL, NULL, 'NUCLEOLAR AND COILED-BODY PHOSPHOPROTEIN 1', 248512),
(385094, 'PTHR23216:SF1', NULL, NULL, NULL, NULL, 'NUCLEOLAR AND COILED-BODY PHOSPHOPROTEIN 1', 248512),
(385095, 'PTHR15286:SF6', NULL, NULL, NULL, NULL, 'GH01133P', 248513),
(385096, 'PTHR15286:SF16', NULL, NULL, NULL, NULL, 'RAS-ASSOCIATING DOMAIN-CONTAINING PROTEIN', 248513),
(385097, 'PTHR15286', NULL, NULL, NULL, NULL, 'RAS-ASSOCIATING DOMAIN CONTAINING PROTEIN', 248513),
(385098, 'PTHR15286:SF12', NULL, NULL, NULL, NULL, 'RAS ASSOCIATION DOMAIN FAMILY MEMBER 8A', 248513),
(385099, 'PTHR15286:SF13', NULL, NULL, NULL, NULL, 'RAS ASSOCIATION DOMAIN-CONTAINING PROTEIN 10', 248513),
(385100, 'PTHR15286:SF1', NULL, NULL, NULL, NULL, 'FI07216P', 248513),
(385101, 'PTHR15286:SF15', NULL, NULL, NULL, NULL, 'MERU, ISOFORM A', 248513),
(385102, 'PTHR15286:SF10', NULL, NULL, NULL, NULL, 'RAS ASSOCIATION DOMAIN-CONTAINING PROTEIN 9', 248513),
(385103, 'PTHR15286:SF11', NULL, NULL, NULL, NULL, 'RAS ASSOCIATION DOMAIN-CONTAINING PROTEIN 7', 248513),
(385104, 'PTHR15286:SF9', NULL, NULL, NULL, NULL, 'RAS ASSOCIATION DOMAIN-CONTAINING PROTEIN 8', 248513),
(385105, 'PTHR30544', NULL, NULL, NULL, NULL, '23S RRNA METHYLTRANSFERASE', 248514),
(385106, 'PTHR30544:SF8', NULL, NULL, NULL, NULL, 'RADICAL SAM SUPERFAMILY PROTEIN', 248514),
(385107, 'PTHR30544:SF5', NULL, NULL, NULL, NULL, 'RADICAL_SAM DOMAIN-CONTAINING PROTEIN', 248514),
(385108, 'PTHR36856', NULL, NULL, NULL, NULL, 'OS07G0175200 PROTEIN', 248515),
(385109, 'PTHR36856:SF1', NULL, NULL, NULL, NULL, 'OS07G0175200 PROTEIN', 248515),
(385110, 'PTHR36856:SF2', NULL, NULL, NULL, NULL, '', 248515),
(385111, 'PTHR38683:SF1', NULL, NULL, NULL, NULL, 'CHORISMATE PYRUVATE-LYASE', 248516);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(385112, 'PTHR38683', NULL, NULL, NULL, NULL, 'CHORISMATE PYRUVATE-LYASE', 248516),
(385113, 'PTHR23430:SF249', NULL, NULL, NULL, NULL, 'HISTONE H2A.5-RELATED', 248517),
(385114, 'PTHR23430:SF125', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385115, 'PTHR23430:SF367', NULL, NULL, NULL, NULL, 'HISTONE H2A.7-RELATED', 248517),
(385116, 'PTHR23430:SF59', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385117, 'PTHR23430:SF245', NULL, NULL, NULL, NULL, 'HISTONE H2A TYPE 1', 248517),
(385118, 'PTHR23430:SF366', NULL, NULL, NULL, NULL, 'HISTONE H2AXA-RELATED', 248517),
(385119, 'PTHR23430:SF56', NULL, NULL, NULL, NULL, 'HISTONE H2A TYPE 1-D', 248517),
(385120, 'PTHR23430:SF369', NULL, NULL, NULL, NULL, 'LATE HISTONE H2A.L3', 248517),
(385121, 'PTHR23430:SF368', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385122, 'PTHR23430:SF363', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385123, 'PTHR23430:SF362', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385124, 'PTHR23430:SF244', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385125, 'PTHR23430:SF365', NULL, NULL, NULL, NULL, 'HISTONE H2A VARIANT 2-RELATED', 248517),
(385126, 'PTHR23430:SF243', NULL, NULL, NULL, NULL, 'HISTONE H2A.6', 248517),
(385127, 'PTHR23430:SF364', NULL, NULL, NULL, NULL, 'HISTONE H2A.5-RELATED', 248517),
(385128, 'PTHR23430:SF50', NULL, NULL, NULL, NULL, 'HISTONE H2A.1-RELATED', 248517),
(385129, 'PTHR23430:SF361', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385130, 'PTHR23430:SF360', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385131, 'PTHR23430:SF238', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385132, 'PTHR23430:SF359', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385133, 'PTHR23430:SF63', NULL, NULL, NULL, NULL, 'HUNTINGTIN-INTERACTING PROTEIN M', 248517),
(385134, 'PTHR23430:SF356', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385135, 'PTHR23430:SF69', NULL, NULL, NULL, NULL, 'H2A, PUTATIVE-RELATED', 248517),
(385136, 'PTHR23430:SF234', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385137, 'PTHR23430:SF355', NULL, NULL, NULL, NULL, 'HISTONE H2A.J', 248517),
(385138, 'PTHR23430:SF358', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385139, 'PTHR23430:SF357', NULL, NULL, NULL, NULL, 'HISTONE H2A.2-RELATED', 248517),
(385140, 'PTHR23430:SF351', NULL, NULL, NULL, NULL, 'HISTONE H2A VARIANT 3-RELATED', 248517),
(385141, 'PTHR23430:SF354', NULL, NULL, NULL, NULL, 'HISTONE H2A.3-RELATED', 248517),
(385142, 'PTHR23430:SF353', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385143, 'PTHR23430:SF199', NULL, NULL, NULL, NULL, 'HISTONE H2AX', 248517),
(385144, 'PTHR23430:SF350', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385145, 'PTHR23430:SF196', NULL, NULL, NULL, NULL, 'HISTONE H2A TYPE 1-B/E', 248517),
(385146, 'PTHR23430:SF223', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385147, 'PTHR23430:SF37', NULL, NULL, NULL, NULL, 'CORE HISTONE MACRO-H2A.2', 248517),
(385148, 'PTHR23430:SF346', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385149, 'PTHR23430:SF220', NULL, NULL, NULL, NULL, 'HISTONE H2A TYPE 3', 248517),
(385150, 'PTHR23430:SF340', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385151, 'PTHR23430:SF339', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385152, 'PTHR23430:SF42', NULL, NULL, NULL, NULL, 'HISTONE H2A TYPE 2-A', 248517),
(385153, 'PTHR23430:SF334', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385154, 'PTHR23430:SF47', NULL, NULL, NULL, NULL, 'HISTONE H2A.Z', 248517),
(385155, 'PTHR23430:SF297', NULL, NULL, NULL, NULL, 'HISTONE H2A VARIANT 2-RELATED', 248517),
(385156, 'PTHR23430:SF296', NULL, NULL, NULL, NULL, 'HISTONE H2A.2.1', 248517),
(385157, 'PTHR23430:SF332', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385158, 'PTHR23430:SF299', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385159, 'PTHR23430:SF331', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385160, 'PTHR23430:SF298', NULL, NULL, NULL, NULL, 'HISTONE H2A.7-RELATED', 248517),
(385161, 'PTHR23430:SF292', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385162, 'PTHR23430:SF209', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(385163, 'PTHR23430:SF11', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385164, 'PTHR23430:SF329', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385165, 'PTHR23430:SF207', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385166, 'PTHR23430:SF328', NULL, NULL, NULL, NULL, 'HISTONE_H2A_C DOMAIN-CONTAINING PROTEIN', 248517),
(385167, 'PTHR23430:SF289', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385168, 'PTHR23430:SF204', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385169, 'PTHR23430:SF324', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385170, 'PTHR23430:SF285', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385171, 'PTHR23430:SF321', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385172, 'PTHR23430:SF288', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385173, 'PTHR23430:SF200', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385174, 'PTHR23430:SF287', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385175, 'PTHR23430:SF282', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385176, 'PTHR23430:SF95', NULL, NULL, NULL, NULL, 'HISTONE H2A.1-RELATED', 248517),
(385177, 'PTHR23430:SF281', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385178, 'PTHR23430:SF284', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385179, 'PTHR23430:SF283', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385180, 'PTHR23430:SF280', NULL, NULL, NULL, NULL, 'HISTONE H2A.V', 248517),
(385181, 'PTHR23430:SF29', NULL, NULL, NULL, NULL, 'HISTONE H2A TYPE 1-H', 248517),
(385182, 'PTHR23430:SF28', NULL, NULL, NULL, NULL, 'HISTONE H2A TYPE 1-C', 248517),
(385183, 'PTHR23430', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385184, 'PTHR23430:SF316', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385185, 'PTHR23430:SF318', NULL, NULL, NULL, NULL, 'HISTONE H2A.2-RELATED', 248517),
(385186, 'PTHR23430:SF20', NULL, NULL, NULL, NULL, 'CORE HISTONE MACRO-H2A.1', 248517),
(385187, 'PTHR23430:SF312', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385188, 'PTHR23430:SF314', NULL, NULL, NULL, NULL, 'HISTONE H2A.4-RELATED', 248517),
(385189, 'PTHR23430:SF23', NULL, NULL, NULL, NULL, 'HISTONE H2A-BBD TYPE 1-RELATED', 248517),
(385190, 'PTHR23430:SF274', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385191, 'PTHR23430:SF310', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385192, 'PTHR23430:SF277', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385193, 'PTHR23430:SF273', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385194, 'PTHR23430:SF272', NULL, NULL, NULL, NULL, 'HISTONE H2A.1-RELATED', 248517),
(385195, 'PTHR23430:SF308', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385196, 'PTHR23430:SF305', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385197, 'PTHR23430:SF306', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385198, 'PTHR23430:SF303', NULL, NULL, NULL, NULL, 'HISTONE H2AX', 248517),
(385199, 'PTHR23430:SF385', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385200, 'PTHR23430:SF384', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385201, 'PTHR23430:SF72', NULL, NULL, NULL, NULL, 'HISTONE H2A TYPE 2-B', 248517),
(385202, 'PTHR23430:SF381', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385203, 'PTHR23430:SF380', NULL, NULL, NULL, NULL, 'HISTONE H2A.4-RELATED', 248517),
(385204, 'PTHR23430:SF383', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385205, 'PTHR23430:SF382', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385206, 'PTHR23430:SF378', NULL, NULL, NULL, NULL, 'HISTONE H2A TYPE 1-J', 248517),
(385207, 'PTHR23430:SF257', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385208, 'PTHR23430:SF7', NULL, NULL, NULL, NULL, 'HISTONE H2A.V', 248517),
(385209, 'PTHR23430:SF135', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385210, 'PTHR23430:SF377', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385211, 'PTHR23430:SF259', NULL, NULL, NULL, NULL, 'HISTONE H2A VARIANT 1', 248517),
(385212, 'PTHR23430:SF137', NULL, NULL, NULL, NULL, 'HISTONE H2A TYPE 1-A', 248517),
(385213, 'PTHR23430:SF379', NULL, NULL, NULL, NULL, 'PROTEIN H2A.5', 248517),
(385214, 'PTHR23430:SF374', NULL, NULL, NULL, NULL, 'HISTONE H2A.V3', 248517);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(385215, 'PTHR23430:SF373', NULL, NULL, NULL, NULL, 'HISTONE H2A-RELATED', 248517),
(385216, 'PTHR23430:SF376', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385217, 'PTHR23430:SF254', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385218, 'PTHR23430:SF375', NULL, NULL, NULL, NULL, 'HISTONE H2A, EMBRYONIC', 248517),
(385219, 'PTHR23430:SF370', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385220, 'PTHR23430:SF130', NULL, NULL, NULL, NULL, 'HISTONE H2A TYPE 2-C', 248517),
(385221, 'PTHR23430:SF372', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385222, 'PTHR23430:SF250', NULL, NULL, NULL, NULL, 'PROTEIN H2A.6', 248517),
(385223, 'PTHR23430:SF371', NULL, NULL, NULL, NULL, 'HISTONE H2A', 248517),
(385224, 'PTHR28492:SF1', NULL, NULL, NULL, NULL, 'PROTEIN BRAWNIN', 248518),
(385225, 'PTHR28492:SF2', NULL, NULL, NULL, NULL, '', 248518),
(385226, 'PTHR28492', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC691921', 248518),
(385227, 'PTHR28492:SF3', NULL, NULL, NULL, NULL, 'BNAA03G47800D PROTEIN', 248518),
(385228, 'PTHR47209', NULL, NULL, NULL, NULL, 'OS06G0639500 PROTEIN', 248519),
(385229, 'PTHR47209:SF1', NULL, NULL, NULL, NULL, 'OS06G0639500 PROTEIN', 248519),
(385230, 'PTHR47209:SF10', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE KEG-LIKE', 248519),
(385231, 'PTHR47209:SF5', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248519),
(385232, 'PTHR47209:SF4', NULL, NULL, NULL, NULL, 'SEED DORMANCY CONTROL PROTEIN', 248519),
(385233, 'PTHR47209:SF8', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248519),
(385234, 'PTHR45978', NULL, NULL, NULL, NULL, 'SPX DOMAIN-CONTAINING PROTEIN 3', 248520),
(385235, 'PTHR45978:SF1', NULL, NULL, NULL, NULL, 'SPX DOMAIN-CONTAINING PROTEIN', 248520),
(385236, 'PTHR45978:SF2', NULL, NULL, NULL, NULL, 'SPX DOMAIN-CONTAINING PROTEIN 3', 248520),
(385237, 'PTHR45978:SF13', NULL, NULL, NULL, NULL, 'SPX DOMAIN-CONTAINING PROTEIN', 248520),
(385238, 'PTHR45978:SF3', NULL, NULL, NULL, NULL, 'SPX DOMAIN-CONTAINING PROTEIN', 248520),
(385239, 'PTHR45978:SF4', NULL, NULL, NULL, NULL, 'SPX DOMAIN-CONTAINING PROTEIN 6', 248520),
(385240, 'PTHR45978:SF5', NULL, NULL, NULL, NULL, 'SPX DOMAIN-CONTAINING PROTEIN 2', 248520),
(385241, 'PTHR45978:SF7', NULL, NULL, NULL, NULL, 'SPX DOMAIN-CONTAINING PROTEIN 4', 248520),
(385242, 'PTHR45978:SF10', NULL, NULL, NULL, NULL, 'SPX DOMAIN-CONTAINING PROTEIN 1', 248520),
(385243, 'PTHR45978:SF8', NULL, NULL, NULL, NULL, 'SPX DOMAIN-CONTAINING PROTEIN 1', 248520),
(385244, 'PTHR45978:SF11', NULL, NULL, NULL, NULL, 'SPX DOMAIN-CONTAINING PROTEIN', 248520),
(385245, 'PTHR45978:SF9', NULL, NULL, NULL, NULL, 'SPX DOMAIN-CONTAINING PROTEIN 5', 248520),
(385246, 'PTHR45978:SF12', NULL, NULL, NULL, NULL, 'SPX DOMAIN-CONTAINING PROTEIN-RELATED', 248520),
(385247, 'PTHR42755:SF1', NULL, NULL, NULL, NULL, '3-DEOXY-D-MANNO-OCTULOSONIC ACID TRANSFERASE, MITOCHONDRIAL-RELATED', 248521),
(385248, 'PTHR42755', NULL, NULL, NULL, NULL, '3-DEOXY-MANNO-OCTULOSONATE CYTIDYLYLTRANSFERASE', 248521),
(385249, 'PTHR48174:SF3', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN (DUF946)', 248522),
(385250, 'PTHR48174:SF5', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 62-LIKE PROTEIN', 248522),
(385251, 'PTHR48174', NULL, NULL, NULL, NULL, 'DUF946 FAMILY PROTEIN', 248522),
(385252, 'PTHR16514:SF5', NULL, NULL, NULL, NULL, 'PROTEIN TMEPAI', 248523),
(385253, 'PTHR16514:SF4', NULL, NULL, NULL, NULL, 'LOW-DENSITY LIPOPROTEIN RECEPTOR CLASS A DOMAIN-CONTAINING PROTEIN 4', 248523),
(385254, 'PTHR16514:SF3', NULL, NULL, NULL, NULL, '', 248523),
(385255, 'PTHR16514', NULL, NULL, NULL, NULL, 'LOW DENSITY LIPOPROTEIN RECEPTOR CLASS A DOMAIN-CONTAINING 4A', 248523),
(385256, 'PTHR10857:SF6', NULL, NULL, NULL, NULL, 'COPINE-7', 248524),
(385257, 'PTHR10857:SF4', NULL, NULL, NULL, NULL, 'COPINE-4', 248524),
(385258, 'PTHR10857:SF5', NULL, NULL, NULL, NULL, 'COPINE-6', 248524),
(385259, 'PTHR10857:SF2', NULL, NULL, NULL, NULL, 'COPINE-1', 248524),
(385260, 'PTHR10857:SF58', NULL, NULL, NULL, NULL, 'COPINE-C', 248524);
INSERT INTO "PUBLIC"."MODEL" VALUES
(385261, 'PTHR10857:SF3', NULL, NULL, NULL, NULL, 'COPINE-2', 248524),
(385262, 'PTHR10857:SF22', NULL, NULL, NULL, NULL, 'COPINE-3', 248524),
(385263, 'PTHR10857:SF136', NULL, NULL, NULL, NULL, 'NICOTINIC RECEPTOR-ASSOCIATED PROTEIN 1', 248524),
(385264, 'PTHR10857:SF137', NULL, NULL, NULL, NULL, '', 248524),
(385265, 'PTHR10857:SF106', NULL, NULL, NULL, NULL, 'GON-2 EXTRAGENIC MODIFIER', 248524),
(385266, 'PTHR10857:SF117', NULL, NULL, NULL, NULL, 'PROTEIN BONZAI 1-LIKE', 248524),
(385267, 'PTHR10857:SF133', NULL, NULL, NULL, NULL, 'COPINE-8', 248524),
(385268, 'PTHR10857:SF111', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 248524),
(385269, 'PTHR10857:SF134', NULL, NULL, NULL, NULL, 'PROTEIN BONZAI 2', 248524),
(385270, 'PTHR10857:SF112', NULL, NULL, NULL, NULL, 'COPINE-9', 248524),
(385271, 'PTHR10857:SF101', NULL, NULL, NULL, NULL, 'COPINE FAMILY PROTEIN 5', 248524),
(385272, 'PTHR10857:SF102', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 248524),
(385273, 'PTHR10857:SF135', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PHOSPHOLIPID-BINDING COPINE FAMILY PROTEIN-RELATED', 248524),
(385274, 'PTHR10857', NULL, NULL, NULL, NULL, 'COPINE', 248524),
(385275, 'PTHR10857:SF130', NULL, NULL, NULL, NULL, '', 248524),
(385276, 'PTHR10857:SF120', NULL, NULL, NULL, NULL, 'PROTEIN BONZAI 3', 248524),
(385277, 'PTHR10857:SF131', NULL, NULL, NULL, NULL, 'COPINE DOMAIN-CONTAINING PROTEIN', 248524),
(385278, 'PTHR10857:SF30', NULL, NULL, NULL, NULL, 'COPINE-B-RELATED', 248524),
(385279, 'PTHR10857:SF51', NULL, NULL, NULL, NULL, 'COPINE-5', 248524),
(385280, 'PTHR47468:SF3', NULL, NULL, NULL, NULL, 'METAL ION TRANSPORTER', 248525),
(385281, 'PTHR47468:SF1', NULL, NULL, NULL, NULL, 'OS08G0130000 PROTEIN', 248525),
(385282, 'PTHR47468', NULL, NULL, NULL, NULL, 'OS08G0130000 PROTEIN', 248525),
(385283, 'PTHR46094:SF2', NULL, NULL, NULL, NULL, 'BETA-CASP DOMAIN-CONTAINING PROTEIN', 248526),
(385284, 'PTHR46094', NULL, NULL, NULL, NULL, 'INTEGRATOR COMPLEX SUBUNIT 9', 248526),
(385285, 'PTHR46094:SF1', NULL, NULL, NULL, NULL, 'INTEGRATOR COMPLEX SUBUNIT 9', 248526),
(385286, 'PTHR36341', NULL, NULL, NULL, NULL, 'DUF2996 FAMILY PROTEIN', 248527),
(385287, 'PTHR36341:SF3', NULL, NULL, NULL, NULL, 'DUF2996 FAMILY PROTEIN', 248527),
(385288, 'PTHR24072:SF327', NULL, NULL, NULL, NULL, 'BNAA01G19510D PROTEIN', 248528),
(385289, 'PTHR24072:SF325', NULL, NULL, NULL, NULL, 'RAS-RELATED C3 BOTULINUM TOXIN SUBSTRATE 3', 248528),
(385290, 'PTHR24072:SF326', NULL, NULL, NULL, NULL, 'BNAA07G03440D PROTEIN', 248528),
(385291, 'PTHR24072:SF169', NULL, NULL, NULL, NULL, 'RAS-RELATED C3 BOTULINUM TOXIN SUBSTRATE 2', 248528),
(385292, 'PTHR24072:SF168', NULL, NULL, NULL, NULL, 'RAS-LIKE GTP-BINDING PROTEIN RHO1', 248528),
(385293, 'PTHR24072:SF289', NULL, NULL, NULL, NULL, 'RAC-LIKE GTP-BINDING PROTEIN 1', 248528),
(385294, 'PTHR24072:SF330', NULL, NULL, NULL, NULL, 'NTGP2', 248528),
(385295, 'PTHR24072:SF175', NULL, NULL, NULL, NULL, 'RHO-RELATED GTP-BINDING PROTEIN RHOD', 248528),
(385296, 'PTHR24072:SF172', NULL, NULL, NULL, NULL, 'SMALL GTPASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G13340)-RELATED', 248528),
(385297, 'PTHR24072:SF294', NULL, NULL, NULL, NULL, 'RAC-LIKE GTP-BINDING PROTEIN ARAC9', 248528),
(385298, 'PTHR24072:SF339', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RHO GTPASE', 248528),
(385299, 'PTHR24072:SF337', NULL, NULL, NULL, NULL, 'CELL DIVISION CONTROL PROTEIN 42 HOMOLOG', 248528),
(385300, 'PTHR24072:SF334', NULL, NULL, NULL, NULL, 'BNAC02G47270D PROTEIN', 248528),
(385301, 'PTHR24072:SF335', NULL, NULL, NULL, NULL, 'RHO, PUTATIVE-RELATED', 248528),
(385302, 'PTHR24072:SF179', NULL, NULL, NULL, NULL, 'RAC-LIKE GTPASE 1 TRANSCRIPT VARIANT 2', 248528),
(385303, 'PTHR24072:SF341', NULL, NULL, NULL, NULL, '', 248528),
(385304, 'PTHR24072:SF100', NULL, NULL, NULL, NULL, 'RHO-RELATED GTP-BINDING PROTEIN RHOC', 248528),
(385305, 'PTHR24072:SF340', NULL, NULL, NULL, NULL, 'BNAC09G50900D PROTEIN', 248528),
(385306, 'PTHR24072:SF186', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN RHO3', 248528),
(385307, 'PTHR24072:SF181', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN RHO4', 248528);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(385308, 'PTHR24072:SF349', NULL, NULL, NULL, NULL, 'RAC-LIKE GTP-BINDING PROTEIN ARAC6', 248528),
(385309, 'PTHR24072:SF105', NULL, NULL, NULL, NULL, 'RAS-RELATED C3 BOTULINUM TOXIN SUBSTRATE 1', 248528),
(385310, 'PTHR24072:SF347', NULL, NULL, NULL, NULL, 'BNAA09G03750D PROTEIN', 248528),
(385311, 'PTHR24072:SF348', NULL, NULL, NULL, NULL, 'BNAC07G14810D PROTEIN', 248528),
(385312, 'PTHR24072:SF346', NULL, NULL, NULL, NULL, 'RAC-LIKE GTP-BINDING PROTEIN ARAC7', 248528),
(385313, 'PTHR24072:SF344', NULL, NULL, NULL, NULL, 'ROP', 248528),
(385314, 'PTHR24072:SF190', NULL, NULL, NULL, NULL, 'CDC-42 RELATED PROTEIN', 248528),
(385315, 'PTHR24072:SF73', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RHO GTPASE', 248528),
(385316, 'PTHR24072:SF110', NULL, NULL, NULL, NULL, 'RHO GTPASE', 248528),
(385317, 'PTHR24072:SF350', NULL, NULL, NULL, NULL, '', 248528),
(385318, 'PTHR24072:SF192', NULL, NULL, NULL, NULL, 'CDC42 HOMOLOG', 248528),
(385319, 'PTHR24072:SF359', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAC1-RELATED', 248528),
(385320, 'PTHR24072:SF356', NULL, NULL, NULL, NULL, '', 248528),
(385321, 'PTHR24072:SF355', NULL, NULL, NULL, NULL, 'RAC-LIKE GTP-BINDING PROTEIN ARAC3', 248528),
(385322, 'PTHR24072:SF0', NULL, NULL, NULL, NULL, 'RHO-RELATED GTP-BINDING PROTEIN RHOB', 248528),
(385323, 'PTHR24072:SF363', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RHO GTPASE', 248528),
(385324, 'PTHR24072:SF364', NULL, NULL, NULL, NULL, 'RHO-RELATED PROTEIN RACB', 248528),
(385325, 'PTHR24072:SF120', NULL, NULL, NULL, NULL, 'RHO-RELATED BTB DOMAIN-CONTAINING PROTEIN 1', 248528),
(385326, 'PTHR24072:SF127', NULL, NULL, NULL, NULL, 'RAC-LIKE GTP-BINDING PROTEIN ARAC7', 248528),
(385327, 'PTHR24072:SF369', NULL, NULL, NULL, NULL, 'RHO-RELATED GTP-BINDING PROTEIN RHOA-B', 248528),
(385328, 'PTHR24072:SF367', NULL, NULL, NULL, NULL, 'RAC-LIKE GTP-BINDING PROTEIN RAC13-RELATED', 248528),
(385329, 'PTHR24072:SF17', NULL, NULL, NULL, NULL, 'RHO-RELATED GTP-BINDING PROTEIN RHOJ', 248528),
(385330, 'PTHR24072:SF368', NULL, NULL, NULL, NULL, 'BNAC07G32180D PROTEIN', 248528),
(385331, 'PTHR24072:SF247', NULL, NULL, NULL, NULL, 'RIF PROTEIN', 248528),
(385332, 'PTHR24072:SF124', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RHO GTPASE 1', 248528),
(385333, 'PTHR24072:SF366', NULL, NULL, NULL, NULL, 'RAC-LIKE GTP-BINDING PROTEIN 5', 248528),
(385334, 'PTHR24072:SF13', NULL, NULL, NULL, NULL, 'RHO-RELATED GTP-BINDING PROTEIN RHOQ', 248528),
(385335, 'PTHR24072:SF99', NULL, NULL, NULL, NULL, 'RHO-RELATED GTP-BINDING PROTEIN RHOF', 248528),
(385336, 'PTHR24072:SF374', NULL, NULL, NULL, NULL, 'RAC-LIKE GTP-BINDING PROTEIN ARAC5', 248528),
(385337, 'PTHR24072:SF375', NULL, NULL, NULL, NULL, 'RAC-LIKE GTP-BINDING PROTEIN ARAC2', 248528),
(385338, 'PTHR24072:SF372', NULL, NULL, NULL, NULL, '', 248528),
(385339, 'PTHR24072:SF373', NULL, NULL, NULL, NULL, 'RAC-LIKE GTP-BINDING PROTEIN ARAC4', 248528),
(385340, 'PTHR24072:SF371', NULL, NULL, NULL, NULL, 'RAC-LIKE GTP-BINDING PROTEIN RHO1', 248528),
(385341, 'PTHR24072:SF378', NULL, NULL, NULL, NULL, '', 248528),
(385342, 'PTHR24072:SF136', NULL, NULL, NULL, NULL, 'CELL DIVISION CONTROL PROTEIN 42 HOMOLOG', 248528),
(385343, 'PTHR24072:SF137', NULL, NULL, NULL, NULL, 'RHO-RELATED BTB DOMAIN-CONTAINING PROTEIN 2', 248528),
(385344, 'PTHR24072:SF28', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN RHO2', 248528),
(385345, 'PTHR24072:SF379', NULL, NULL, NULL, NULL, '', 248528),
(385346, 'PTHR24072:SF376', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RHO GTPASE GEMA-RELATED', 248528),
(385347, 'PTHR24072:SF135', NULL, NULL, NULL, NULL, 'RHO-RELATED PROTEIN RACH', 248528),
(385348, 'PTHR24072:SF377', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN RHO5', 248528),
(385349, 'PTHR24072:SF24', NULL, NULL, NULL, NULL, 'RHO-RELATED GTP-BINDING PROTEIN RHOE', 248528),
(385350, 'PTHR24072:SF21', NULL, NULL, NULL, NULL, 'RHO-RELATED GTP-BINDING PROTEIN RHON', 248528),
(385351, 'PTHR24072:SF23', NULL, NULL, NULL, NULL, 'RHO-RELATED GTP-BINDING PROTEIN RHO6', 248528),
(385352, 'PTHR24072:SF143', NULL, NULL, NULL, NULL, 'RHO-RELATED PROTEIN RACE', 248528);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(385353, 'PTHR24072:SF385', NULL, NULL, NULL, NULL, 'RAC-LIKE GTP-BINDING PROTEIN ARAC1-RELATED', 248528),
(385354, 'PTHR24072:SF386', NULL, NULL, NULL, NULL, 'RHO GTPASE-RELATED', 248528),
(385355, 'PTHR24072:SF144', NULL, NULL, NULL, NULL, 'RHO-RELATED GTP-BINDING PROTEIN RHOV', 248528),
(385356, 'PTHR24072:SF262', NULL, NULL, NULL, NULL, 'CELL DIVISION CONTROL PROTEIN 42 HOMOLOG', 248528),
(385357, 'PTHR24072:SF141', NULL, NULL, NULL, NULL, 'RHO-RELATED BTB DOMAIN-CONTAINING 4', 248528),
(385358, 'PTHR24072:SF383', NULL, NULL, NULL, NULL, 'SMALL GTPASE SUPERFAMILY, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 248528),
(385359, 'PTHR24072:SF142', NULL, NULL, NULL, NULL, 'RHOU, ISOFORM B', 248528),
(385360, 'PTHR24072:SF384', NULL, NULL, NULL, NULL, 'RAS HOMOLOG FAMILY MEMBER UA-RELATED', 248528),
(385361, 'PTHR24072:SF381', NULL, NULL, NULL, NULL, 'SMALL GTPASE SUPERFAMILY, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 248528),
(385362, 'PTHR24072:SF382', NULL, NULL, NULL, NULL, 'RHO FAMILY GTPASE', 248528),
(385363, 'PTHR24072:SF380', NULL, NULL, NULL, NULL, 'BNAANNG08340D PROTEIN', 248528),
(385364, 'PTHR24072:SF305', NULL, NULL, NULL, NULL, 'RAS-LIKE GTP-BINDING PROTEIN RHOL', 248528),
(385365, 'PTHR24072:SF306', NULL, NULL, NULL, NULL, 'RHO-RELATED GTP-BINDING PROTEIN RHOH', 248528),
(385366, 'PTHR24072:SF303', NULL, NULL, NULL, NULL, '', 248528),
(385367, 'PTHR24072:SF149', NULL, NULL, NULL, NULL, 'RAC-LIKE GTP-BINDING PROTEIN ARAC10-RELATED', 248528),
(385368, 'PTHR24072:SF389', NULL, NULL, NULL, NULL, 'NTGP2', 248528),
(385369, 'PTHR24072:SF148', NULL, NULL, NULL, NULL, 'RHO-RELATED GTP-BINDING PROTEIN RHOU', 248528),
(385370, 'PTHR24072:SF387', NULL, NULL, NULL, NULL, 'RHO-RELATED PROTEIN RACA', 248528),
(385371, 'PTHR24072:SF388', NULL, NULL, NULL, NULL, 'RAC-LIKE GTP-BINDING PROTEIN RAC2', 248528),
(385372, 'PTHR24072:SF152', NULL, NULL, NULL, NULL, 'RHO-RELATED PROTEIN RACL', 248528),
(385373, 'PTHR24072:SF153', NULL, NULL, NULL, NULL, 'TRANSFORMING PROTEIN RHOA', 248528),
(385374, 'PTHR24072:SF150', NULL, NULL, NULL, NULL, 'RAS HOMOLOG GENE FAMILY, MEMBER GC-RELATED', 248528),
(385375, 'PTHR24072:SF272', NULL, NULL, NULL, NULL, 'RHO-RELATED PROTEIN RACG', 248528),
(385376, 'PTHR24072:SF390', NULL, NULL, NULL, NULL, 'RAC-LIKE GTP-BINDING PROTEIN RAC13', 248528),
(385377, 'PTHR24072:SF391', NULL, NULL, NULL, NULL, '', 248528),
(385378, 'PTHR24072:SF315', NULL, NULL, NULL, NULL, 'RAC-LIKE GTP-BINDING PROTEIN 4', 248528),
(385379, 'PTHR24072:SF158', NULL, NULL, NULL, NULL, 'RHO-RELATED GTP-BINDING PROTEIN RHOG', 248528),
(385380, 'PTHR24072:SF312', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RHO GTPASE 3', 248528),
(385381, 'PTHR24072:SF313', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RHO GTPASE 2', 248528),
(385382, 'PTHR24072:SF310', NULL, NULL, NULL, NULL, 'RHO-RELATED PROTEIN RACC', 248528),
(385383, 'PTHR24072:SF277', NULL, NULL, NULL, NULL, 'RHO-RELATED PROTEIN RACJ', 248528),
(385384, 'PTHR24072:SF156', NULL, NULL, NULL, NULL, 'RHO-RELATED BTB DOMAIN CONTAINING, ISOFORM B', 248528),
(385385, 'PTHR24072:SF311', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RHO GTPASE 2', 248528),
(385386, 'PTHR24072:SF318', NULL, NULL, NULL, NULL, 'BNAC09G09590D PROTEIN', 248528),
(385387, 'PTHR24072:SF319', NULL, NULL, NULL, NULL, 'SMALL GTPASE SUPERFAMILY, RAN GTPASE, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 248528),
(385388, 'PTHR24072', NULL, NULL, NULL, NULL, 'RHO FAMILY GTPASE', 248528),
(385389, 'PTHR24072:SF286', NULL, NULL, NULL, NULL, 'RAC-LIKE GTP-BINDING PROTEIN 7', 248528),
(385390, 'PTHR24072:SF165', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4930544G11 GENE', 248528),
(385391, 'PTHR24072:SF320', NULL, NULL, NULL, NULL, 'BNACNNG35340D PROTEIN', 248528),
(385392, 'PTHR24072:SF284', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RHO GTPASE', 248528),
(385393, 'PTHR13069:SF33', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 248529),
(385394, 'PTHR13069:SF34', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 248529);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(385395, 'PTHR13069:SF21', NULL, NULL, NULL, NULL, 'ALKYLATED DNA REPAIR PROTEIN ALKB HOMOLOG 8', 248529),
(385396, 'PTHR13069:SF37', NULL, NULL, NULL, NULL, 'FIRE DANCER', 248529),
(385397, 'PTHR13069:SF35', NULL, NULL, NULL, NULL, 'TRNA METHYLTRANSFERASE 9B', 248529),
(385398, 'PTHR13069:SF8', NULL, NULL, NULL, NULL, 'ALKYLATED DNA REPAIR PROTEIN ALKBH8 HOMOLOG', 248529),
(385399, 'PTHR13069:SF36', NULL, NULL, NULL, NULL, 'TRNA METHYLTRANSFERASE 9B-RELATED', 248529),
(385400, 'PTHR13069', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248529),
(385401, 'PTHR41401:SF1', NULL, NULL, NULL, NULL, 'RGD1559909', 248530),
(385402, 'PTHR41401', NULL, NULL, NULL, NULL, 'RGD1559909', 248530),
(385403, 'PTHR31017', NULL, NULL, NULL, NULL, 'LATE SECRETORY PATHWAY PROTEIN AVL9-RELATED', 248531),
(385404, 'PTHR31017:SF2', NULL, NULL, NULL, NULL, 'DENN DOMAIN-CONTAINING PROTEIN 11', 248531),
(385405, 'PTHR31017:SF1', NULL, NULL, NULL, NULL, 'LATE SECRETORY PATHWAY PROTEIN AVL9 HOMOLOG', 248531),
(385406, 'PTHR31970:SF0', NULL, NULL, NULL, NULL, 'MOLYBDATE TRANSPORTER 1', 248532),
(385407, 'PTHR31970:SF9', NULL, NULL, NULL, NULL, 'MOLYBDATE TRANSPORTER 2', 248532),
(385408, 'PTHR31970:SF10', NULL, NULL, NULL, NULL, 'BNAA09G40790D PROTEIN', 248532),
(385409, 'PTHR31970', NULL, NULL, NULL, NULL, '', 248532),
(385410, 'PTHR31970:SF8', NULL, NULL, NULL, NULL, 'MOLYBDATE TRANSPORTER 1/2-RELATED', 248532),
(385411, 'PTHR23124:SF143', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN 141', 248533),
(385412, 'PTHR23124:SF132', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 248533),
(385413, 'PTHR23124:SF50', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 248533),
(385414, 'PTHR23124:SF131', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 248533),
(385415, 'PTHR23124:SF130', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 248533),
(385416, 'PTHR23124:SF141', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN-RELATED', 248533),
(385417, 'PTHR23124:SF74', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 248533),
(385418, 'PTHR23124:SF151', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN', 248533),
(385419, 'PTHR23124:SF140', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN 158', 248533),
(385420, 'PTHR23124:SF150', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN', 248533),
(385421, 'PTHR23124:SF129', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 248533),
(385422, 'PTHR23124:SF139', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN', 248533),
(385423, 'PTHR23124:SF138', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 248533),
(385424, 'PTHR23124:SF149', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN', 248533),
(385425, 'PTHR23124:SF148', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 248533),
(385426, 'PTHR23124:SF136', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 248533),
(385427, 'PTHR23124:SF147', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 248533),
(385428, 'PTHR23124:SF135', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN', 248533),
(385429, 'PTHR23124:SF146', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN', 248533),
(385430, 'PTHR23124:SF44', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 248533),
(385431, 'PTHR23124:SF134', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 248533),
(385432, 'PTHR23124:SF145', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 248533),
(385433, 'PTHR23124:SF144', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN-RELATED', 248533),
(385434, 'PTHR23124', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248533),
(385435, 'PTHR12319', NULL, NULL, NULL, NULL, 'CYSTATIN-RELATED', 248534),
(385436, 'PTHR12319:SF2', NULL, NULL, NULL, NULL, 'CYSTATIN-LIKE PROTEIN-RELATED', 248534),
(385437, 'PTHR21519:SF1', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN 8', 248535),
(385438, 'PTHR21519', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN 8', 248535),
(385439, 'PTHR38386:SF7', NULL, NULL, NULL, NULL, 'TOPOISOMERASE 1-ASSOCIATED FACTOR 1', 248536);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(385440, 'PTHR38386', NULL, NULL, NULL, NULL, 'OS05G0426900 PROTEIN', 248536),
(385441, 'PTHR38386:SF8', NULL, NULL, NULL, NULL, '', 248536),
(385442, 'PTHR38386:SF5', NULL, NULL, NULL, NULL, 'OS01G0877900 PROTEIN', 248536),
(385443, 'PTHR38386:SF6', NULL, NULL, NULL, NULL, 'OS05G0426900 PROTEIN', 248536),
(385444, 'PTHR43454', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE', 248537),
(385445, 'PTHR43454:SF1', NULL, NULL, NULL, NULL, 'GP_DH_N DOMAIN-CONTAINING PROTEIN', 248537),
(385446, 'PTHR10738', NULL, NULL, NULL, NULL, 'PROTEIN ARGININE N-METHYLTRANSFERASE 5', 248538),
(385447, 'PTHR10738:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ARGININE N-METHYLTRANSFERASE', 248538),
(385448, 'PTHR10738:SF0', NULL, NULL, NULL, NULL, 'PROTEIN ARGININE N-METHYLTRANSFERASE 5', 248538),
(385449, 'PTHR11229:SF8', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L3, MITOCHONDRIAL', 248539),
(385450, 'PTHR11229', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L3', 248539),
(385451, 'PTHR11229:SF12', NULL, NULL, NULL, NULL, '', 248539),
(385452, 'PTHR11229:SF16', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L3-1, CHLOROPLASTIC', 248539),
(385453, 'PTHR11229:SF15', NULL, NULL, NULL, NULL, 'BNAA01G27990D PROTEIN', 248539),
(385454, 'PTHR11229:SF13', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L3, MITOCHONDRIAL', 248539),
(385455, 'PTHR45918', NULL, NULL, NULL, NULL, 'ALPHA-1,3/1,6-MANNOSYLTRANSFERASE ALG2', 248540),
(385456, 'PTHR45918:SF2', NULL, NULL, NULL, NULL, 'ALPHA-1,3/1,6-MANNOSYLTRANSFERASE ALG2', 248540),
(385457, 'PTHR45918:SF1', NULL, NULL, NULL, NULL, 'ALPHA-1,3/1,6-MANNOSYLTRANSFERASE ALG2', 248540),
(385458, 'PTHR28155', NULL, NULL, NULL, NULL, 'ACR243WP', 248541),
(385459, 'PTHR28155:SF1', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE I SUBUNIT', 248541),
(385460, 'PTHR10457:SF24', NULL, NULL, NULL, NULL, 'MEVALONATE/GALACTOKINASE FAMILY PROTEIN', 248542),
(385461, 'PTHR10457:SF35', NULL, NULL, NULL, NULL, 'L-ARABINOKINASE', 248542),
(385462, 'PTHR10457', NULL, NULL, NULL, NULL, 'MEVALONATE KINASE/GALACTOKINASE', 248542),
(385463, 'PTHR10457:SF33', NULL, NULL, NULL, NULL, '', 248542),
(385464, 'PTHR10457:SF34', NULL, NULL, NULL, NULL, 'L-ARABINOKINASE-LIKE', 248542),
(385465, 'PTHR10457:SF12', NULL, NULL, NULL, NULL, 'OS06G0702500 PROTEIN', 248542),
(385466, 'PTHR10457:SF28', NULL, NULL, NULL, NULL, 'BNAA01G32760D PROTEIN', 248542),
(385467, 'PTHR10457:SF29', NULL, NULL, NULL, NULL, 'LMBP PROTEIN', 248542),
(385468, 'PTHR10457:SF26', NULL, NULL, NULL, NULL, '', 248542),
(385469, 'PTHR10457:SF9', NULL, NULL, NULL, NULL, 'D-GLYCERO-ALPHA-D-MANNO-HEPTOSE 7-PHOSPHATE KINASE', 248542),
(385470, 'PTHR10457:SF6', NULL, NULL, NULL, NULL, 'GALACTURONOKINASE', 248542),
(385471, 'PTHR10457:SF7', NULL, NULL, NULL, NULL, 'GALACTOKINASE-RELATED', 248542),
(385472, 'PTHR21588:SF17', NULL, NULL, NULL, NULL, 'COILED-COIL-HELIX-COILED-COIL-HELIX DOMAIN-CONTAINING 6B-RELATED', 248543),
(385473, 'PTHR21588', NULL, NULL, NULL, NULL, 'COILED-COIL-HELIX-COILED-COIL-HELIX DOMAIN CONTAINING 6', 248543),
(385474, 'PTHR21588:SF18', NULL, NULL, NULL, NULL, 'COILED-COIL-HELIX-COILED-COIL-HELIX DOMAIN CONTAINING 3', 248543),
(385475, 'PTHR21588:SF19', NULL, NULL, NULL, NULL, '', 248543),
(385476, 'PTHR21588:SF2', NULL, NULL, NULL, NULL, 'MICOS COMPLEX SUBUNIT MIC19', 248543),
(385477, 'PTHR21588:SF20', NULL, NULL, NULL, NULL, 'COILED-COIL-HELIX-COILED-COIL-HELIX DOMAIN CONTAINING 3', 248543),
(385478, 'PTHR21588:SF21', NULL, NULL, NULL, NULL, '', 248543),
(385479, 'PTHR12956:SF71', NULL, NULL, NULL, NULL, 'BNAC05G21710D PROTEIN', 248544),
(385480, 'PTHR12956:SF61', NULL, NULL, NULL, NULL, 'TRNA (MET) CYTIDINE ACETYLTRANSFERASE-RELATED', 248544),
(385481, 'PTHR12956:SF73', NULL, NULL, NULL, NULL, '', 248544),
(385482, 'PTHR12956:SF74', NULL, NULL, NULL, NULL, 'BNAA07G08570D PROTEIN', 248544),
(385483, 'PTHR12956:SF17', NULL, NULL, NULL, NULL, 'OS01G0749100 PROTEIN', 248544),
(385484, 'PTHR12956', NULL, NULL, NULL, NULL, 'ALKALINE CERAMIDASE-RELATED', 248544),
(385485, 'PTHR12956:SF24', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN (DUF616)', 248544);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(385486, 'PTHR12956:SF13', NULL, NULL, NULL, NULL, 'OS01G0210400 PROTEIN', 248544),
(385487, 'PTHR12956:SF68', NULL, NULL, NULL, NULL, 'BNAA02G24370D PROTEIN', 248544),
(385488, 'PTHR12956:SF69', NULL, NULL, NULL, NULL, 'BNAC04G44140D PROTEIN', 248544),
(385489, 'PTHR12956:SF27', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 248544),
(385490, 'PTHR12956:SF38', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE MUCI70-RELATED', 248544),
(385491, 'PTHR12956:SF75', NULL, NULL, NULL, NULL, 'OS01G0304300 PROTEIN', 248544),
(385492, 'PTHR12956:SF64', NULL, NULL, NULL, NULL, 'BNAC06G06090D PROTEIN', 248544),
(385493, 'PTHR12956:SF54', NULL, NULL, NULL, NULL, 'OS03G0769050 PROTEIN', 248544),
(385494, 'PTHR12956:SF76', NULL, NULL, NULL, NULL, '', 248544),
(385495, 'PTHR12956:SF22', NULL, NULL, NULL, NULL, 'OS06G0724300 PROTEIN', 248544),
(385496, 'PTHR12956:SF77', NULL, NULL, NULL, NULL, '', 248544),
(385497, 'PTHR12956:SF56', NULL, NULL, NULL, NULL, 'DUF616 FAMILY PROTEIN', 248544),
(385498, 'PTHR34649', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 99', 248545),
(385499, 'PTHR34649:SF1', NULL, NULL, NULL, NULL, 'CILIA AND FLAGELLA-ASSOCIATED PROTEIN 99', 248545),
(385500, 'PTHR48078:SF17', NULL, NULL, NULL, NULL, 'THREONINE DEHYDRATASE', 248546),
(385501, 'PTHR48078:SF18', NULL, NULL, NULL, NULL, 'THREONINE AMMONIA-LYASE', 248546),
(385502, 'PTHR48078:SF15', NULL, NULL, NULL, NULL, 'THREONINE DEHYDRATASE', 248546),
(385503, 'PTHR48078:SF16', NULL, NULL, NULL, NULL, 'SERINE DEHYDRATASE-LIKE', 248546),
(385504, 'PTHR48078:SF13', NULL, NULL, NULL, NULL, 'THREONINE DEHYDRATASE', 248546),
(385505, 'PTHR48078:SF14', NULL, NULL, NULL, NULL, 'L-SERINE AMMONIA-LYASE', 248546),
(385506, 'PTHR48078:SF1', NULL, NULL, NULL, NULL, 'THREONINE DEHYDRATASE', 248546),
(385507, 'PTHR48078:SF11', NULL, NULL, NULL, NULL, 'THREONINE DEHYDRATASE, MITOCHONDRIAL', 248546),
(385508, 'PTHR48078:SF10', NULL, NULL, NULL, NULL, 'THREONINE DEHYDRATASE 2 BIOSYNTHETIC, CHLOROPLASTIC', 248546),
(385509, 'PTHR48078:SF5', NULL, NULL, NULL, NULL, 'THREONINE DEHYDRATASE', 248546),
(385510, 'PTHR48078:SF4', NULL, NULL, NULL, NULL, 'DEHYDRATASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G07810)-RELATED', 248546),
(385511, 'PTHR48078', NULL, NULL, NULL, NULL, 'THREONINE DEHYDRATASE, MITOCHONDRIAL-RELATED', 248546),
(385512, 'PTHR48078:SF3', NULL, NULL, NULL, NULL, 'THREONINE DEHYDRATASE', 248546),
(385513, 'PTHR48078:SF2', NULL, NULL, NULL, NULL, 'CATABOLIC L-SERINE/THREONINE DEHYDRATASE', 248546),
(385514, 'PTHR48078:SF9', NULL, NULL, NULL, NULL, 'D-SERINE DEHYDRATASE', 248546),
(385515, 'PTHR48078:SF8', NULL, NULL, NULL, NULL, 'L-SERINE DEHYDRATASE/L-THREONINE DEAMINASE', 248546),
(385516, 'PTHR48078:SF7', NULL, NULL, NULL, NULL, 'BLL6502 PROTEIN', 248546),
(385517, 'PTHR48078:SF6', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN', 248546),
(385518, 'PTHR23084:SF218', NULL, NULL, NULL, NULL, '', 248547),
(385519, 'PTHR23084:SF255', NULL, NULL, NULL, NULL, 'PROTEIN ACCUMULATION AND REPLICATION OFS PROTEIN', 248547),
(385520, 'PTHR23084:SF179', NULL, NULL, NULL, NULL, 'OS10G0565000 PROTEIN', 248547),
(385521, 'PTHR23084:SF245', NULL, NULL, NULL, NULL, 'MORN MOTIF PROTEIN-RELATED', 248547),
(385522, 'PTHR23084:SF256', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-4-PHOSPHATE 5-KINASE-LIKE PROTEIN', 248547),
(385523, 'PTHR23084:SF135', NULL, NULL, NULL, NULL, '', 248547),
(385524, 'PTHR23084:SF264', NULL, NULL, NULL, NULL, '', 248547),
(385525, 'PTHR23084:SF220', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL-4-PHOSPHATE 5-KINASE', 248547),
(385526, 'PTHR23084:SF176', NULL, NULL, NULL, NULL, 'HISTONE H3 K4-SPECIFIC METHYLTRANSFERASE SET7/9 FAMILY PROTEIN', 248547),
(385527, 'PTHR23084:SF253', NULL, NULL, NULL, NULL, 'HISTONE H3 K4-SPECIFIC METHYLTRANSFERASE SET7/9 FAMILY PROTEIN', 248547),
(385528, 'PTHR23084:SF254', NULL, NULL, NULL, NULL, 'HISTONE H3 K4-SPECIFIC METHYLTRANSFERASE SET7/9 FAMILY PROTEIN', 248547),
(385529, 'PTHR23084:SF243', NULL, NULL, NULL, NULL, 'MORN MOTIF PROTEIN-RELATED', 248547),
(385530, 'PTHR23084:SF259', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 5-KINASE 3-LIKE ISOFORM X1', 248547);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(385531, 'PTHR23084:SF248', NULL, NULL, NULL, NULL, 'JUNCTOPHILIN-3-LIKE', 248547),
(385532, 'PTHR23084:SF238', NULL, NULL, NULL, NULL, 'PROTEIN TIC 100', 248547),
(385533, 'PTHR23084:SF227', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 248547),
(385534, 'PTHR23084:SF257', NULL, NULL, NULL, NULL, 'MORN REPEAT-CONTAINING PROTEIN 1', 248547),
(385535, 'PTHR23084:SF258', NULL, NULL, NULL, NULL, 'BNAANNG04110D PROTEIN', 248547),
(385536, 'PTHR23084:SF262', NULL, NULL, NULL, NULL, 'FYVE-TYPE DOMAIN-CONTAINING PROTEIN', 248547),
(385537, 'PTHR23084:SF263', NULL, NULL, NULL, NULL, 'DUF1336 DOMAIN-CONTAINING PROTEIN', 248547),
(385538, 'PTHR23084:SF260', NULL, NULL, NULL, NULL, '', 248547),
(385539, 'PTHR23084', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-4-PHOSPHATE 5-KINASE RELATED', 248547),
(385540, 'PTHR23084:SF261', NULL, NULL, NULL, NULL, '', 248547),
(385541, 'PTHR12269', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4E TRANSPORTER', 248548),
(385542, 'PTHR12269:SF1', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4E TRANSPORTER', 248548),
(385543, 'PTHR28206:SF1', NULL, NULL, NULL, NULL, 'NUCLEOPORIN POM152', 248549),
(385544, 'PTHR28206', NULL, NULL, NULL, NULL, 'NUCLEOPORIN POM152', 248549),
(385545, 'PTHR36463', NULL, NULL, NULL, NULL, 'KERATINOCYTE DIFFERENTIATION-ASSOCIATED PROTEIN', 248550),
(385546, 'PTHR36463:SF1', NULL, NULL, NULL, NULL, 'KERATINOCYTE DIFFERENTIATION-ASSOCIATED PROTEIN', 248550),
(385547, 'PTHR24215:SF23', NULL, NULL, NULL, NULL, 'CYSTEINE AND GLYCINE-RICH PROTEIN 1', 248551),
(385548, 'PTHR24215:SF35', NULL, NULL, NULL, NULL, 'MUSCLE LIM PROTEIN MLP84B', 248551),
(385549, 'PTHR24215:SF1', NULL, NULL, NULL, NULL, 'CYSTEINE AND GLYCINE-RICH PROTEIN 3', 248551),
(385550, 'PTHR24215:SF37', NULL, NULL, NULL, NULL, 'LIM ZINC-BINDING DOMAIN-CONTAINING PROTEIN', 248551),
(385551, 'PTHR24215:SF29', NULL, NULL, NULL, NULL, 'CYSTEINE RICH PROTEIN 2', 248551),
(385552, 'PTHR24215:SF3', NULL, NULL, NULL, NULL, 'CYSTEINE AND GLYCINE-RICH PROTEIN 2', 248551),
(385553, 'PTHR24215', NULL, NULL, NULL, NULL, 'RHO-GTPASE-ACTIVATING PROTEIN LRG1', 248551),
(385554, 'PTHR24215:SF7', NULL, NULL, NULL, NULL, 'AGAP004186-PA', 248551),
(385555, 'PTHR24215:SF31', NULL, NULL, NULL, NULL, 'CYSTEINE RICH PROTEIN 3', 248551),
(385556, 'PTHR24215:SF10', NULL, NULL, NULL, NULL, 'RHO-GTPASE-ACTIVATING PROTEIN LRG1', 248551),
(385557, 'PTHR46873:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248552),
(385558, 'PTHR46873:SF2', NULL, NULL, NULL, NULL, 'PPIASE CYCLOPHILIN-TYPE DOMAIN-CONTAINING PROTEIN', 248552),
(385559, 'PTHR46873:SF3', NULL, NULL, NULL, NULL, 'PPIASE CYCLOPHILIN-TYPE DOMAIN-CONTAINING PROTEIN', 248552),
(385560, 'PTHR46873', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248552),
(385561, 'PTHR28029:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ILM1', 248553),
(385562, 'PTHR28029', NULL, NULL, NULL, NULL, 'PROTEIN ILM1', 248553),
(385563, 'PTHR40067', NULL, NULL, NULL, NULL, 'UPF0297 PROTEIN YRZL', 248554),
(385564, 'PTHR40067:SF1', NULL, NULL, NULL, NULL, 'UPF0297 PROTEIN YRZL', 248554),
(385565, 'PTHR11743:SF60', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL OUTER MEMBRANE PROTEIN PORIN 1', 248555),
(385566, 'PTHR11743:SF50', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL OUTER MEMBRANE PROTEIN PORIN 3', 248555),
(385567, 'PTHR11743:SF72', NULL, NULL, NULL, NULL, 'BNAC09G32780D PROTEIN', 248555),
(385568, 'PTHR11743:SF73', NULL, NULL, NULL, NULL, '', 248555),
(385569, 'PTHR11743:SF51', NULL, NULL, NULL, NULL, '', 248555),
(385570, 'PTHR11743:SF30', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL OUTER MEMBRANE PROTEIN PORIN 4', 248555),
(385571, 'PTHR11743:SF53', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL OUTER MEMBRANE PROTEIN PORIN 2-LIKE', 248555),
(385572, 'PTHR11743:SF76', NULL, NULL, NULL, NULL, 'BNACNNG52100D PROTEIN', 248555),
(385573, 'PTHR11743:SF55', NULL, NULL, NULL, NULL, '', 248555),
(385574, 'PTHR11743:SF77', NULL, NULL, NULL, NULL, 'BNAA09G07330D PROTEIN', 248555),
(385575, 'PTHR11743:SF12', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT ANION-SELECTIVE CHANNEL PROTEIN 2', 248555);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(385576, 'PTHR11743:SF34', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL OUTER MEMBRANE PROTEIN PORIN 2', 248555),
(385577, 'PTHR11743:SF56', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL OUTER MEMBRANE PROTEIN PORIN OF 34 KDA', 248555),
(385578, 'PTHR11743:SF35', NULL, NULL, NULL, NULL, 'PORIN/VOLTAGE-DEPENDENT ANION-SELECTIVE CHANNEL PROTEIN', 248555),
(385579, 'PTHR11743:SF13', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT ANION-SELECTIVE CHANNEL PROTEIN 1', 248555),
(385580, 'PTHR11743:SF59', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL OUTER MEMBRANE PROTEIN PORIN 2-LIKE ISOFORM X1', 248555),
(385581, 'PTHR11743:SF70', NULL, NULL, NULL, NULL, 'GH26960P-RELATED', 248555),
(385582, 'PTHR11743:SF61', NULL, NULL, NULL, NULL, 'PORIN/VOLTAGE-DEPENDENT ANION-SELECTIVE CHANNEL PROTEIN', 248555),
(385583, 'PTHR11743:SF62', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL OUTER MEMBRANE PROTEIN PORIN 3', 248555),
(385584, 'PTHR11743:SF63', NULL, NULL, NULL, NULL, '', 248555),
(385585, 'PTHR11743:SF64', NULL, NULL, NULL, NULL, 'BNAA05G37480D PROTEIN', 248555),
(385586, 'PTHR11743:SF65', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL OUTER MEMBRANE PROTEIN PORIN 2', 248555),
(385587, 'PTHR11743', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT ANION-SELECTIVE CHANNEL', 248555),
(385588, 'PTHR11743:SF66', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT ANION-SELECTIVE CHANNEL', 248555),
(385589, 'PTHR11743:SF23', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL OUTER MEMBRANE PROTEIN PORIN 5-RELATED', 248555),
(385590, 'PTHR11743:SF68', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN PORIN-RELATED', 248555),
(385591, 'PTHR11743:SF69', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN PORIN-RELATED', 248555),
(385592, 'PTHR11743:SF27', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL OUTER MEMBRANE PROTEIN PORIN 4', 248555),
(385593, 'PTHR11743:SF28', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT ANION-SELECTIVE CHANNEL PROTEIN 3', 248555),
(385594, 'PTHR37888:SF8', NULL, NULL, NULL, NULL, 'BROMO DOMAIN-CONTAINING PROTEIN', 248556),
(385595, 'PTHR37888:SF11', NULL, NULL, NULL, NULL, 'DNA-BINDING BROMODOMAIN-CONTAINING PROTEIN', 248556),
(385596, 'PTHR37888:SF13', NULL, NULL, NULL, NULL, 'BROMO DOMAIN-CONTAINING PROTEIN', 248556),
(385597, 'PTHR37888:SF4', NULL, NULL, NULL, NULL, 'OS07G0565300 PROTEIN', 248556),
(385598, 'PTHR37888:SF6', NULL, NULL, NULL, NULL, 'DNA-BINDING BROMODOMAIN-CONTAINING PROTEIN', 248556),
(385599, 'PTHR37888:SF15', NULL, NULL, NULL, NULL, 'DNA-BINDING BROMODOMAIN-CONTAINING PROTEIN', 248556),
(385600, 'PTHR37888', NULL, NULL, NULL, NULL, 'DNA-BINDING BROMODOMAIN-CONTAINING PROTEIN', 248556),
(385601, 'PTHR37888:SF17', NULL, NULL, NULL, NULL, 'BROMO DOMAIN-CONTAINING PROTEIN', 248556),
(385602, 'PTHR47451', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 248557),
(385603, 'PTHR47451:SF2', NULL, NULL, NULL, NULL, '', 248557),
(385604, 'PTHR47451:SF1', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 248557),
(385605, 'PTHR37771:SF2', NULL, NULL, NULL, NULL, 'OS02G0593400 PROTEIN', 248558),
(385606, 'PTHR37771:SF3', NULL, NULL, NULL, NULL, 'BNACNNG15720D PROTEIN', 248558),
(385607, 'PTHR37771', NULL, NULL, NULL, NULL, 'OS02G0593400 PROTEIN', 248558),
(385608, 'PTHR15312:SF1', NULL, NULL, NULL, NULL, 'PROTEIN TYROSINE PHOSPHATASE RECEPTOR TYPE C-ASSOCIATED PROTEIN', 248559),
(385609, 'PTHR15312', NULL, NULL, NULL, NULL, 'PROTEIN TYROSINE PHOSPHATASE RECEPTOR TYPE C-ASSOCIATED PROTEIN', 248559),
(385610, 'PTHR21555', NULL, NULL, NULL, NULL, 'SPECIFICALLY ANDROGEN-REGULATED GENE PROTEIN', 248560),
(385611, 'PTHR21555:SF0', NULL, NULL, NULL, NULL, 'SPECIFICALLY ANDROGEN-REGULATED GENE PROTEIN', 248560),
(385612, 'PTHR46050:SF11', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 248561),
(385613, 'PTHR46050:SF22', NULL, NULL, NULL, NULL, 'TPR REPEAT-CONTAINING THIOREDOXIN TTL1-LIKE', 248561),
(385614, 'PTHR46050:SF12', NULL, NULL, NULL, NULL, 'BNAA05G34270D PROTEIN', 248561),
(385615, 'PTHR46050:SF23', NULL, NULL, NULL, NULL, 'INACTIVE TPR REPEAT-CONTAINING THIOREDOXIN TTL3', 248561),
(385616, 'PTHR46050', NULL, NULL, NULL, NULL, 'TPR REPEAT-CONTAINING THIOREDOXIN', 248561);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(385617, 'PTHR46050:SF20', NULL, NULL, NULL, NULL, 'INACTIVE TPR REPEAT-CONTAINING THIOREDOXIN TTL3-LIKE', 248561),
(385618, 'PTHR46050:SF7', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 248561),
(385619, 'PTHR46050:SF10', NULL, NULL, NULL, NULL, 'TPR REPEAT-CONTAINING THIOREDOXIN TTL4', 248561),
(385620, 'PTHR46050:SF26', NULL, NULL, NULL, NULL, 'TPR REPEAT-CONTAINING THIOREDOXIN TTL1', 248561),
(385621, 'PTHR46050:SF4', NULL, NULL, NULL, NULL, 'OS05G0587300 PROTEIN', 248561),
(385622, 'PTHR46050:SF15', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 248561),
(385623, 'PTHR46050:SF16', NULL, NULL, NULL, NULL, 'BNAA01G24400D PROTEIN', 248561),
(385624, 'PTHR46050:SF27', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE A, AUXILIARY SUBUNIT-RELATED', 248561),
(385625, 'PTHR46050:SF24', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 248561),
(385626, 'PTHR46050:SF13', NULL, NULL, NULL, NULL, 'TPR REPEAT-CONTAINING THIOREDOXIN TTL2', 248561),
(385627, 'PTHR46050:SF14', NULL, NULL, NULL, NULL, '43KDA POSTSYNAPTIC PROTEIN-RELATED', 248561),
(385628, 'PTHR46050:SF3', NULL, NULL, NULL, NULL, 'TPR REPEAT-CONTAINING THIOREDOXIN TTL1', 248561),
(385629, 'PTHR46050:SF19', NULL, NULL, NULL, NULL, '80A08_7', 248561),
(385630, 'PTHR46050:SF17', NULL, NULL, NULL, NULL, 'BNAC01G31360D PROTEIN', 248561),
(385631, 'PTHR46050:SF18', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 248561),
(385632, 'PTHR46699:SF5', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248562),
(385633, 'PTHR46699:SF6', NULL, NULL, NULL, NULL, 'PLASTID-LIPID-ASSOCIATED PROTEIN 14, CHLOROPLASTIC-RELATED', 248562),
(385634, 'PTHR46699:SF4', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE STN7, CHLOROPLASTIC', 248562),
(385635, 'PTHR46699:SF1', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE STN8, CHLOROPLASTIC', 248562),
(385636, 'PTHR46699:SF7', NULL, NULL, NULL, NULL, 'SERINE/THREONINE KINASE DOMAIN PROTEIN', 248562),
(385637, 'PTHR46699', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE STN8, CHLOROPLASTIC-RELATED', 248562),
(385638, 'PTHR40088', NULL, NULL, NULL, NULL, 'PECTATE LYASE (EUROFUNG)', 248563),
(385639, 'PTHR40088:SF1', NULL, NULL, NULL, NULL, 'PECTATE LYASE (EUROFUNG)', 248563),
(385640, 'PTHR16740:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME B5-RELATED PROTEIN-RELATED', 248564),
(385641, 'PTHR16740', NULL, NULL, NULL, NULL, 'CYTOCHROME B5-RELATED PROTEIN-RELATED', 248564),
(385642, 'PTHR22574:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM71B', 248565),
(385643, 'PTHR22574:SF5', NULL, NULL, NULL, NULL, 'PROTEIN FAM71E1', 248565),
(385644, 'PTHR22574:SF6', NULL, NULL, NULL, NULL, 'PROTEIN FAM71D', 248565),
(385645, 'PTHR22574:SF13', NULL, NULL, NULL, NULL, 'PROTEIN FAM71F1', 248565),
(385646, 'PTHR22574:SF12', NULL, NULL, NULL, NULL, 'PROTEIN FAM71E2', 248565),
(385647, 'PTHR22574:SF11', NULL, NULL, NULL, NULL, 'PROTEIN FAM71C', 248565),
(385648, 'PTHR22574:SF10', NULL, NULL, NULL, NULL, 'PROTEIN FAM71F2', 248565),
(385649, 'PTHR22574:SF15', NULL, NULL, NULL, NULL, 'PROTEIN FAM71A', 248565),
(385650, 'PTHR22574:SF14', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN-RELATED', 248565),
(385651, 'PTHR22574', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248565),
(385652, 'PTHR22526', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248566),
(385653, 'PTHR22526:SF4', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT 15', 248566),
(385654, 'PTHR22526:SF2', NULL, NULL, NULL, NULL, 'ANAPHASE PROMOTING COMPLEX C SUBUNIT 15, PSEUDOGENE-RELATED', 248566),
(385655, 'PTHR22526:SF3', NULL, NULL, NULL, NULL, '', 248566),
(385656, 'PTHR10279:SF11', NULL, NULL, NULL, NULL, 'ORNITHINE DECARBOXYLASE ANTIZYME 2', 248567),
(385657, 'PTHR10279:SF10', NULL, NULL, NULL, NULL, 'ORNITHINE DECARBOXYLASE ANTIZYME', 248567),
(385658, 'PTHR10279:SF9', NULL, NULL, NULL, NULL, 'ORNITHINE DECARBOXYLASE ANTIZYME 3', 248567),
(385659, 'PTHR10279:SF8', NULL, NULL, NULL, NULL, 'ORNITHINE DECARBOXYLASE ANTIZYME 1', 248567);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(385660, 'PTHR10279:SF6', NULL, NULL, NULL, NULL, 'ORNITHINE DECARBOXYLASE ANTIZYME 2', 248567),
(385661, 'PTHR10279', NULL, NULL, NULL, NULL, 'ORNITHINE DECARBOXYLASE ANTIZYME', 248567),
(385662, 'PTHR34703', NULL, NULL, NULL, NULL, 'ANTIPORTER SUBUNIT MNHG2-RELATED', 248568),
(385663, 'PTHR34703:SF1', NULL, NULL, NULL, NULL, 'NA(+)/H(+) ANTIPORTER SUBUNIT G', 248568),
(385664, 'PTHR34703:SF2', NULL, NULL, NULL, NULL, 'NA(+)/H(+) ANTIPORTER SUBUNIT G1', 248568),
(385665, 'PTHR12161:SF44', NULL, NULL, NULL, NULL, 'REGULATOR OF VPS4 ACTIVITY IN THE MVB PATHWAY PROTEIN', 248569),
(385666, 'PTHR12161:SF46', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN IST1-RELATED', 248569),
(385667, 'PTHR12161:SF47', NULL, NULL, NULL, NULL, '', 248569),
(385668, 'PTHR12161:SF69', NULL, NULL, NULL, NULL, 'REGULATOR OF VPS4 ACTIVITY IN THE MVB PATHWAY PROTEIN', 248569),
(385669, 'PTHR12161:SF26', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248569),
(385670, 'PTHR12161:SF49', NULL, NULL, NULL, NULL, 'REGULATOR OF VPS4 ACTIVITY IN THE MVB PATHWAY PROTEIN', 248569),
(385671, 'PTHR12161:SF5', NULL, NULL, NULL, NULL, 'IST1 HOMOLOG', 248569),
(385672, 'PTHR12161:SF80', NULL, NULL, NULL, NULL, '', 248569),
(385673, 'PTHR12161:SF81', NULL, NULL, NULL, NULL, 'OS01G0687700 PROTEIN', 248569),
(385674, 'PTHR12161:SF82', NULL, NULL, NULL, NULL, 'BNAC05G08840D PROTEIN', 248569),
(385675, 'PTHR12161:SF60', NULL, NULL, NULL, NULL, 'REGULATOR OF VPS4 ACTIVITY IN THE MVB PATHWAY PROTEIN', 248569),
(385676, 'PTHR12161:SF83', NULL, NULL, NULL, NULL, '', 248569),
(385677, 'PTHR12161:SF84', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN IST1-RELATED', 248569),
(385678, 'PTHR12161:SF41', NULL, NULL, NULL, NULL, 'OS02G0159200 PROTEIN', 248569),
(385679, 'PTHR12161:SF63', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN IST1-RELATED', 248569),
(385680, 'PTHR12161:SF64', NULL, NULL, NULL, NULL, 'BNAA09G46310D PROTEIN', 248569),
(385681, 'PTHR12161:SF65', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN IST1-RELATED', 248569),
(385682, 'PTHR12161', NULL, NULL, NULL, NULL, 'IST1 FAMILY MEMBER', 248569),
(385683, 'PTHR12161:SF55', NULL, NULL, NULL, NULL, 'REGULATOR OF VPS4 ACTIVITY IN THE MVB PATHWAY PROTEIN', 248569),
(385684, 'PTHR12161:SF56', NULL, NULL, NULL, NULL, 'IST1 HOMOLOG', 248569),
(385685, 'PTHR12161:SF78', NULL, NULL, NULL, NULL, 'IST1P', 248569),
(385686, 'PTHR12161:SF13', NULL, NULL, NULL, NULL, 'REGULATOR OF VPS4 ACTIVITY IN THE MVB PATHWAY PROTEIN', 248569),
(385687, 'PTHR12161:SF79', NULL, NULL, NULL, NULL, '', 248569),
(385688, 'PTHR12161:SF58', NULL, NULL, NULL, NULL, 'REGULATOR OF VPS4 ACTIVITY IN THE MVB PATHWAY PROTEIN', 248569),
(385689, 'PTHR12161:SF14', NULL, NULL, NULL, NULL, 'REGULATOR OF VPS4 ACTIVITY IN THE MVB PATHWAY PROTEIN', 248569),
(385690, 'PTHR12161:SF59', NULL, NULL, NULL, NULL, '', 248569),
(385691, 'PTHR12161:SF16', NULL, NULL, NULL, NULL, 'REGULATOR OF VPS4 ACTIVITY IN THE MVB PATHWAY PROTEIN', 248569),
(385692, 'PTHR12161:SF17', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248569),
(385693, 'PTHR12161:SF71', NULL, NULL, NULL, NULL, 'REGULATOR OF VPS4 ACTIVITY IN THE MVB PATHWAY PROTEIN', 248569),
(385694, 'PTHR12161:SF50', NULL, NULL, NULL, NULL, '', 248569),
(385695, 'PTHR12161:SF72', NULL, NULL, NULL, NULL, 'BNAA05G14960D PROTEIN', 248569),
(385696, 'PTHR12161:SF51', NULL, NULL, NULL, NULL, 'IST1 HOMOLOG', 248569),
(385697, 'PTHR12161:SF74', NULL, NULL, NULL, NULL, '', 248569),
(385698, 'PTHR12161:SF76', NULL, NULL, NULL, NULL, '', 248569),
(385699, 'PTHR40535:SF1', NULL, NULL, NULL, NULL, '', 248570),
(385700, 'PTHR40535', NULL, NULL, NULL, NULL, '', 248570),
(385701, 'PTHR47319', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN KIC', 248571),
(385702, 'PTHR47319:SF8', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 248571),
(385703, 'PTHR47319:SF5', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF-HAND PROTEIN', 248571),
(385704, 'PTHR47319:SF17', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF-HAND PROTEIN', 248571);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(385705, 'PTHR47319:SF28', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 248571),
(385706, 'PTHR47319:SF16', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 248571),
(385707, 'PTHR47319:SF6', NULL, NULL, NULL, NULL, 'OS06G0683400 PROTEIN', 248571),
(385708, 'PTHR47319:SF27', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN PBP1-LIKE', 248571),
(385709, 'PTHR47319:SF19', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN PBP1-LIKE', 248571),
(385710, 'PTHR47319:SF4', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN KIC', 248571),
(385711, 'PTHR47319:SF18', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 248571),
(385712, 'PTHR47319:SF29', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN KRP1', 248571),
(385713, 'PTHR47319:SF24', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN PBP1-LIKE', 248571),
(385714, 'PTHR47319:SF23', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 248571),
(385715, 'PTHR47319:SF15', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN PBP1', 248571),
(385716, 'PTHR47319:SF26', NULL, NULL, NULL, NULL, 'OS01G0783700 PROTEIN', 248571),
(385717, 'PTHR47319:SF25', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN PBP1', 248571),
(385718, 'PTHR47319:SF21', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF-HAND FAMILY PROTEIN-RELATED', 248571),
(385719, 'PTHR47319:SF10', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN PBP1-LIKE', 248571),
(385720, 'PTHR47319:SF2', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 248571),
(385721, 'PTHR37159', NULL, NULL, NULL, NULL, 'GH11867P', 248572),
(385722, 'PTHR37159:SF1', NULL, NULL, NULL, NULL, 'GH11867P', 248572),
(385723, 'PTHR46508', NULL, NULL, NULL, NULL, 'PHD FINGER FAMILY PROTEIN', 248573),
(385724, 'PTHR46508:SF8', NULL, NULL, NULL, NULL, 'DDT DOMAIN-CONTAINING PROTEIN PTM', 248573),
(385725, 'PTHR46508:SF7', NULL, NULL, NULL, NULL, 'DDT DOMAIN-CONTAINING PROTEIN PTM', 248573),
(385726, 'PTHR46508:SF5', NULL, NULL, NULL, NULL, 'PHD-FINGER AND DNA BINDING DOMAIN-CONTAINING PROTEIN', 248573),
(385727, 'PTHR46508:SF2', NULL, NULL, NULL, NULL, 'INCREASED DNA METHYLATION 1', 248573),
(385728, 'PTHR46508:SF3', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASE WITH RING/FYVE/PHD-TYPE ZINC FINGER PROTEIN', 248573),
(385729, 'PTHR46508:SF10', NULL, NULL, NULL, NULL, 'DNA-BINDING AND ZINC-FINGER PROTEIN', 248573),
(385730, 'PTHR46508:SF1', NULL, NULL, NULL, NULL, 'PHD FINGER FAMILY PROTEIN', 248573),
(385731, 'PTHR46508:SF22', NULL, NULL, NULL, NULL, '', 248573),
(385732, 'PTHR46508:SF11', NULL, NULL, NULL, NULL, 'OS11G0148800 PROTEIN', 248573),
(385733, 'PTHR46508:SF23', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', 248573),
(385734, 'PTHR46508:SF12', NULL, NULL, NULL, NULL, 'DDT DOMAIN-CONTAINING PROTEIN PTM-LIKE ISOFORM X1', 248573),
(385735, 'PTHR46508:SF24', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', 248573),
(385736, 'PTHR46508:SF25', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE, ACYL-COA N-ACYLTRANSFERASE, JAS TPL-BINDING DOMAIN PROTEIN-RELATED', 248573),
(385737, 'PTHR46508:SF15', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASE WITH RING/FYVE/PHD-TYPE ZINC FINGER PROTEIN', 248573),
(385738, 'PTHR46508:SF26', NULL, NULL, NULL, NULL, 'INCREASED DNA METHYLATION 1', 248573),
(385739, 'PTHR42925:SF1', NULL, NULL, NULL, NULL, 'MULTIDRUG AND TOXIN EFFLUX PROTEIN MATE FAMILY', 248574),
(385740, 'PTHR42925', NULL, NULL, NULL, NULL, 'MULTIDRUG AND TOXIN EFFLUX PROTEIN MATE FAMILY', 248574),
(385741, 'PTHR42925:SF2', NULL, NULL, NULL, NULL, 'NA+ DRIVEN MULTIDRUG EFFLUX PUMP', 248574),
(385742, 'PTHR11793:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR E2-ALPHA', 248575),
(385743, 'PTHR11793:SF13', NULL, NULL, NULL, NULL, 'PROTEIN DAUGHTERLESS', 248575),
(385744, 'PTHR11793:SF11', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR 12', 248575),
(385745, 'PTHR11793:SF10', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR 4', 248575),
(385746, 'PTHR11793', NULL, NULL, NULL, NULL, 'BASIC HELIX-LOOP-HELIX TRANSCRIPTION FACTOR', 248575),
(385747, 'PTHR46558', NULL, NULL, NULL, NULL, 'TRACRIPTIONAL REGULATORY PROTEIN-RELATED-RELATED', 248576);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(385748, 'PTHR46558:SF9', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, PBSX FAMILY', 248576),
(385749, 'PTHR46558:SF7', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN-RELATED', 248576),
(385750, 'PTHR46558:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REGULATOR', 248576),
(385751, 'PTHR46558:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, PBSX FAMILY', 248576),
(385752, 'PTHR46558:SF3', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN', 248576),
(385753, 'PTHR46558:SF13', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR IMMR', 248576),
(385754, 'PTHR46558:SF4', NULL, NULL, NULL, NULL, 'TRACRIPTIONAL REGULATORY PROTEIN-RELATED', 248576),
(385755, 'PTHR46558:SF12', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN-RELATED', 248576),
(385756, 'PTHR46558:SF11', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR ANSR', 248576),
(385757, 'PTHR33524', NULL, NULL, NULL, NULL, 'C5ORF35', 248577),
(385758, 'PTHR33524:SF5', NULL, NULL, NULL, NULL, 'C5ORF35', 248577),
(385759, 'PTHR33524:SF4', NULL, NULL, NULL, NULL, '', 248577),
(385760, 'PTHR33524:SF3', NULL, NULL, NULL, NULL, '', 248577),
(385761, 'PTHR33524:SF2', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN 9', 248577),
(385762, 'PTHR33524:SF1', NULL, NULL, NULL, NULL, 'C5ORF35', 248577),
(385763, 'PTHR45914:SF58', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 248578),
(385764, 'PTHR45914:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR LAX PANICLE 1', 248578),
(385765, 'PTHR45914:SF57', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH87-LIKE', 248578),
(385766, 'PTHR45914:SF12', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH87', 248578),
(385767, 'PTHR45914:SF56', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 248578),
(385768, 'PTHR45914:SF34', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 248578),
(385769, 'PTHR45914:SF55', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN-CONTAINING PROTEIN-RELATED', 248578),
(385770, 'PTHR45914', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR HEC3-RELATED', 248578),
(385771, 'PTHR45914:SF39', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 248578),
(385772, 'PTHR45914:SF17', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 248578),
(385773, 'PTHR45914:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR HEC3-RELATED', 248578),
(385774, 'PTHR45914:SF37', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 248578),
(385775, 'PTHR45914:SF43', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN-CONTAINING PROTEIN-RELATED', 248578),
(385776, 'PTHR45914:SF40', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR LATE FLOWERING', 248578),
(385777, 'PTHR45914:SF24', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 248578),
(385778, 'PTHR45914:SF46', NULL, NULL, NULL, NULL, 'OS09G0455300 PROTEIN', 248578),
(385779, 'PTHR45914:SF28', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 248578),
(385780, 'PTHR45914:SF27', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN-CONTAINING PROTEIN-RELATED', 248578),
(385781, 'PTHR45914:SF48', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR HEC2', 248578),
(385782, 'PTHR45914:SF50', NULL, NULL, NULL, NULL, 'OS08G0471401 PROTEIN', 248578),
(385783, 'PTHR45914:SF54', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR HEC1-LIKE', 248578),
(385784, 'PTHR45914:SF31', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 248578),
(385785, 'PTHR45914:SF53', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR HEC2-LIKE', 248578),
(385786, 'PTHR45914:SF52', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR HEC1', 248578),
(385787, 'PTHR45914:SF51', NULL, NULL, NULL, NULL, 'OS01G0707500 PROTEIN', 248578),
(385788, 'PTHR28145', NULL, NULL, NULL, NULL, '12 KDA HEAT SHOCK PROTEIN', 248579),
(385789, 'PTHR28145:SF1', NULL, NULL, NULL, NULL, '12 KDA HEAT SHOCK PROTEIN', 248579),
(385790, 'PTHR28145:SF4', NULL, NULL, NULL, NULL, 'CHAPERONE/HEAT SHOCK PROTEIN', 248579),
(385791, 'PTHR31697', NULL, NULL, NULL, NULL, 'INTEGRATOR COMPLEX SUBUNIT 5', 248580);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(385792, 'PTHR31697:SF2', NULL, NULL, NULL, NULL, 'INTEGRATOR COMPLEX SUBUNIT 5', 248580),
(385793, 'PTHR39079', NULL, NULL, NULL, NULL, 'FI08034P-RELATED', 248581),
(385794, 'PTHR39079:SF1', NULL, NULL, NULL, NULL, 'GH11706P-RELATED', 248581),
(385795, 'PTHR15536:SF1', NULL, NULL, NULL, NULL, 'TACHYKININ-3', 248582),
(385796, 'PTHR15536', NULL, NULL, NULL, NULL, 'TACHYKININ-3', 248582),
(385797, 'PTHR42879:SF4', NULL, NULL, NULL, NULL, '3-OXOACYL-(ACYL-CARRIER-PROTEIN) REDUCTASE FABG', 248583),
(385798, 'PTHR42879', NULL, NULL, NULL, NULL, '3-OXOACYL-(ACYL-CARRIER-PROTEIN) REDUCTASE', 248583),
(385799, 'PTHR42879:SF5', NULL, NULL, NULL, NULL, 'SHORT-CHAIN ALCOHOL DEHYDROGENASE', 248583),
(385800, 'PTHR42879:SF6', NULL, NULL, NULL, NULL, 'BLR7888 PROTEIN', 248583),
(385801, 'PTHR42879:SF2', NULL, NULL, NULL, NULL, 'NADPH-DEPENDENT REDUCTASE BACG', 248583),
(385802, 'PTHR41142', NULL, NULL, NULL, NULL, 'SI:DKEY-16J16.4', 248584),
(385803, 'PTHR41142:SF1', NULL, NULL, NULL, NULL, 'SI:DKEY-16J16.4', 248584),
(385804, 'PTHR47032:SF7', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 248585),
(385805, 'PTHR47032', NULL, NULL, NULL, NULL, 'UDP-D-XYLOSE:L-FUCOSE ALPHA-1,3-D-XYLOSYLTRANSFERASE-RELATED', 248585),
(385806, 'PTHR47032:SF1', NULL, NULL, NULL, NULL, 'UDP-D-XYLOSE:L-FUCOSE ALPHA-1,3-D-XYLOSYLTRANSFERASE-RELATED', 248585),
(385807, 'PTHR47032:SF2', NULL, NULL, NULL, NULL, 'UDP-D-XYLOSE:L-FUCOSE ALPHA-1,3-D-XYLOSYLTRANSFERASE 3', 248585),
(385808, 'PTHR47032:SF5', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 248585),
(385809, 'PTHR47032:SF6', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 248585),
(385810, 'PTHR47032:SF3', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 248585),
(385811, 'PTHR34293', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR TRMBL2', 248586),
(385812, 'PTHR34293:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, TRMB', 248586),
(385813, 'PTHR34293:SF1', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR TRMBL2', 248586),
(385814, 'PTHR41309', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 248587),
(385815, 'PTHR41309:SF2', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 248587),
(385816, 'PTHR13794:SF58', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ENOLASE SUPERFAMILY MEMBER 1', 248588),
(385817, 'PTHR13794', NULL, NULL, NULL, NULL, 'ENOLASE SUPERFAMILY, MANDELATE RACEMASE', 248588),
(385818, 'PTHR23053', NULL, NULL, NULL, NULL, 'DLEC1  DELETED IN LUNG AND ESOPHAGEAL CANCER 1', 248589),
(385819, 'PTHR23053:SF0', NULL, NULL, NULL, NULL, 'HYDROCEPHALUS-INDUCING PROTEIN HOMOLOG', 248589),
(385820, 'PTHR36371', NULL, NULL, NULL, NULL, 'PROTEIN PLASTID TRANSCRIPTIONALLY ACTIVE 10', 248590),
(385821, 'PTHR36371:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PLASTID TRANSCRIPTIONALLY ACTIVE 10', 248590),
(385822, 'PTHR46997:SF2', NULL, NULL, NULL, NULL, 'TYROSINE-SPECIFIC TRANSPORT PROTEIN', 248591),
(385823, 'PTHR46997', NULL, NULL, NULL, NULL, 'LOW AFFINITY TRYPTOPHAN PERMEASE-RELATED', 248591),
(385824, 'PTHR46997:SF1', NULL, NULL, NULL, NULL, 'LOW AFFINITY TRYPTOPHAN PERMEASE-RELATED', 248591),
(385825, 'PTHR33676:SF17', NULL, NULL, NULL, NULL, 'COLD-REGULATED PROTEIN 28', 248592),
(385826, 'PTHR33676:SF18', NULL, NULL, NULL, NULL, '', 248592),
(385827, 'PTHR33676:SF19', NULL, NULL, NULL, NULL, 'BNAANNG40190D PROTEIN', 248592),
(385828, 'PTHR33676:SF24', NULL, NULL, NULL, NULL, '', 248592),
(385829, 'PTHR33676:SF14', NULL, NULL, NULL, NULL, '', 248592),
(385830, 'PTHR33676:SF15', NULL, NULL, NULL, NULL, 'OS02G0674233 PROTEIN', 248592),
(385831, 'PTHR33676:SF16', NULL, NULL, NULL, NULL, '', 248592),
(385832, 'PTHR33676:SF11', NULL, NULL, NULL, NULL, 'OS07G0618700 PROTEIN', 248592),
(385833, 'PTHR33676:SF22', NULL, NULL, NULL, NULL, '', 248592),
(385834, 'PTHR33676:SF12', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248592),
(385835, 'PTHR33676:SF23', NULL, NULL, NULL, NULL, 'BNAA03G50790D PROTEIN', 248592),
(385836, 'PTHR33676', NULL, NULL, NULL, NULL, 'COLD REGULATED PROTEIN 27', 248592),
(385837, 'PTHR33676:SF3', NULL, NULL, NULL, NULL, 'COLD-REGULATED PROTEIN 27', 248592);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(385838, 'PTHR34570:SF15', NULL, NULL, NULL, NULL, 'BNAC07G33690D PROTEIN', 248593),
(385839, 'PTHR34570:SF16', NULL, NULL, NULL, NULL, 'OS03G0593100 PROTEIN', 248593),
(385840, 'PTHR34570:SF7', NULL, NULL, NULL, NULL, 'BNACNNG40280D PROTEIN', 248593),
(385841, 'PTHR34570:SF13', NULL, NULL, NULL, NULL, 'BNAANNG35530D PROTEIN', 248593),
(385842, 'PTHR34570', NULL, NULL, NULL, NULL, 'OS03G0593100 PROTEIN', 248593),
(385843, 'PTHR34570:SF17', NULL, NULL, NULL, NULL, '', 248593),
(385844, 'PTHR34570:SF2', NULL, NULL, NULL, NULL, '', 248593),
(385845, 'PTHR34570:SF12', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248593),
(385846, 'PTHR45617:SF160', NULL, NULL, NULL, NULL, 'LP04042P', 248594),
(385847, 'PTHR45617:SF95', NULL, NULL, NULL, NULL, '18 WHEELER', 248594),
(385848, 'PTHR45617:SF96', NULL, NULL, NULL, NULL, 'LRRCT DOMAIN-CONTAINING PROTEIN', 248594),
(385849, 'PTHR45617', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT FAMILY PROTEIN', 248594),
(385850, 'PTHR45617:SF142', NULL, NULL, NULL, NULL, 'SI:DKEY-90M5.4', 248594),
(385851, 'PTHR45617:SF94', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT TRANSMEMBRANE NEURONAL 1', 248594),
(385852, 'PTHR45617:SF163', NULL, NULL, NULL, NULL, 'CHAOPTIN-LIKE PROTEIN', 248594),
(385853, 'PTHR45617:SF72', NULL, NULL, NULL, NULL, 'SYM-1 PROTEIN', 248594),
(385854, 'PTHR45617:SF141', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 15-LIKE PROTEIN', 248594),
(385855, 'PTHR45617:SF140', NULL, NULL, NULL, NULL, 'CONNECTIN-LIKE PROTEIN', 248594),
(385856, 'PTHR45617:SF162', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING 32', 248594),
(385857, 'PTHR45617:SF161', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEATS AND IMMUNOGLOBULIN-LIKE DOMAINS PROTEIN 3', 248594),
(385858, 'PTHR45617:SF109', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 15', 248594),
(385859, 'PTHR45617:SF146', NULL, NULL, NULL, NULL, '1D304', 248594),
(385860, 'PTHR45617:SF2', NULL, NULL, NULL, NULL, 'INSULIN LIKE GROWTH FACTOR BINDING PROTEIN ACID LABILE SUBUNIT', 248594),
(385861, 'PTHR45617:SF101', NULL, NULL, NULL, NULL, 'LEUCINE-RICH ALPHA-2-GLYCOPROTEIN', 248594),
(385862, 'PTHR45617:SF145', NULL, NULL, NULL, NULL, 'AGAP007445-PA', 248594),
(385863, 'PTHR45617:SF144', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 248594),
(385864, 'PTHR45617:SF143', NULL, NULL, NULL, NULL, 'CHAOPTIN-LIKE PROTEIN', 248594),
(385865, 'PTHR45617:SF121', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 70', 248594),
(385866, 'PTHR45617:SF69', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR-BINDING PROTEIN COMPLEX ACID LABILE SUBUNIT', 248594),
(385867, 'PTHR45617:SF7', NULL, NULL, NULL, NULL, 'TRANSFORMING GROWTH FACTOR BETA ACTIVATOR LRRC33', 248594),
(385868, 'PTHR45617:SF149', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN EGG-6', 248594),
(385869, 'PTHR45617:SF4', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING 32', 248594),
(385870, 'PTHR45617:SF148', NULL, NULL, NULL, NULL, 'ASTROCYTIC LEUCINE-RICH REPEAT MOLECULE-RELATED', 248594),
(385871, 'PTHR45617:SF147', NULL, NULL, NULL, NULL, '', 248594),
(385872, 'PTHR45617:SF20', NULL, NULL, NULL, NULL, 'TLR4 INTERACTOR WITH LEUCINE-RICH REPEATS', 248594),
(385873, 'PTHR45617:SF153', NULL, NULL, NULL, NULL, 'TOLL-LIKE RECEPTOR TOLLO', 248594),
(385874, 'PTHR45617:SF152', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 248594),
(385875, 'PTHR45617:SF151', NULL, NULL, NULL, NULL, 'LRRCT DOMAIN-CONTAINING PROTEIN-RELATED', 248594),
(385876, 'PTHR45617:SF150', NULL, NULL, NULL, NULL, 'AGAP001004-PA', 248594),
(385877, 'PTHR45617:SF157', NULL, NULL, NULL, NULL, 'PROTEIN ARTICHOKE', 248594),
(385878, 'PTHR45617:SF135', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 66', 248594),
(385879, 'PTHR45617:SF134', NULL, NULL, NULL, NULL, 'LRRCT DOMAIN-CONTAINING PROTEIN', 248594),
(385880, 'PTHR45617:SF156', NULL, NULL, NULL, NULL, 'LRRCT DOMAIN-CONTAINING PROTEIN', 248594),
(385881, 'PTHR45617:SF133', NULL, NULL, NULL, NULL, 'ACID LABILE SUBUNIT', 248594); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(385882, 'PTHR45617:SF155', NULL, NULL, NULL, NULL, 'TOLL-7-LIKE PROTEIN', 248594),
(385883, 'PTHR45617:SF154', NULL, NULL, NULL, NULL, '2MIT, ISOFORM B-RELATED', 248594),
(385884, 'PTHR45617:SF38', NULL, NULL, NULL, NULL, 'PLATELET GLYCOPROTEIN V', 248594),
(385885, 'PTHR45617:SF139', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE N SUBUNIT 2-LIKE PROTEIN', 248594),
(385886, 'PTHR45617:SF138', NULL, NULL, NULL, NULL, 'NYCTALOPIN-RELATED', 248594),
(385887, 'PTHR45617:SF14', NULL, NULL, NULL, NULL, 'TSUKUSHI', 248594),
(385888, 'PTHR45617:SF99', NULL, NULL, NULL, NULL, '', 248594),
(385889, 'PTHR45617:SF137', NULL, NULL, NULL, NULL, 'ELRR (EXTRACELLULAR LEUCINE-RICH REPEAT) ONLY', 248594),
(385890, 'PTHR45617:SF159', NULL, NULL, NULL, NULL, 'CAPRICIOUS, ISOFORM E', 248594),
(385891, 'PTHR45617:SF136', NULL, NULL, NULL, NULL, 'CONNECTIN-RELATED', 248594),
(385892, 'PTHR45617:SF78', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT DOMAIN-CONTAINING PROTEIN YDDK', 248594),
(385893, 'PTHR45617:SF158', NULL, NULL, NULL, NULL, '', 248594),
(385894, 'PTHR40638', NULL, NULL, NULL, NULL, 'UPF0591 MEMBRANE PROTEIN C15E1.02C', 248595),
(385895, 'PTHR40638:SF1', NULL, NULL, NULL, NULL, 'UPF0591 MEMBRANE PROTEIN C15E1.02C', 248595),
(385896, 'PTHR35678:SF1', NULL, NULL, NULL, NULL, 'PROTEIN STPG4', 248596),
(385897, 'PTHR35678', NULL, NULL, NULL, NULL, 'PROTEIN STPG4', 248596),
(385898, 'PTHR13522', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248597),
(385899, 'PTHR13522:SF3', NULL, NULL, NULL, NULL, 'U6 SNRNA PHOSPHODIESTERASE', 248597),
(385900, 'PTHR11759:SF62', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S14', 248598),
(385901, 'PTHR11759:SF30', NULL, NULL, NULL, NULL, '', 248598),
(385902, 'PTHR11759:SF52', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S14', 248598),
(385903, 'PTHR11759:SF63', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S14', 248598),
(385904, 'PTHR11759:SF64', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S11, CHLOROPLASTIC', 248598),
(385905, 'PTHR11759:SF42', NULL, NULL, NULL, NULL, 'BNAA10G30460D PROTEIN', 248598),
(385906, 'PTHR11759:SF65', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S14-3', 248598),
(385907, 'PTHR11759:SF43', NULL, NULL, NULL, NULL, '', 248598),
(385908, 'PTHR11759:SF60', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S14', 248598),
(385909, 'PTHR11759:SF61', NULL, NULL, NULL, NULL, '', 248598),
(385910, 'PTHR11759:SF37', NULL, NULL, NULL, NULL, '', 248598),
(385911, 'PTHR11759', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S14/30S RIBOSOMAL PROTEIN S11', 248598),
(385912, 'PTHR11759:SF59', NULL, NULL, NULL, NULL, '', 248598),
(385913, 'PTHR11759:SF27', NULL, NULL, NULL, NULL, '', 248598),
(385914, 'PTHR11759:SF39', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 248598),
(385915, 'PTHR11759:SF29', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S14', 248598),
(385916, 'PTHR11759:SF44', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S14-2-LIKE', 248598),
(385917, 'PTHR11759:SF34', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S11, MITOCHONDRIAL-RELATED', 248598),
(385918, 'PTHR11759:SF57', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S11', 248598),
(385919, 'PTHR11759:SF46', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 248598),
(385920, 'PTHR11759:SF47', NULL, NULL, NULL, NULL, '', 248598),
(385921, 'PTHR11759:SF36', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S14-LIKE', 248598),
(385922, 'PTHR11759:SF3', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S11, MITOCHONDRIAL', 248598),
(385923, 'PTHR11759:SF1', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S14', 248598),
(385924, 'PTHR34147:SF2', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 248599),
(385925, 'PTHR34147', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 248599),
(385926, 'PTHR12898', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 24', 248600),
(385927, 'PTHR12898:SF1', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 24', 248600),
(385928, 'PTHR15009:SF4', NULL, NULL, NULL, NULL, 'MUELLERIAN-INHIBITING FACTOR', 248601);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(385929, 'PTHR15009', NULL, NULL, NULL, NULL, 'MUELLERIAN-INHIBITING FACTOR', 248601),
(385930, 'PTHR45875:SF6', NULL, NULL, NULL, NULL, 'MTS DOMAIN-CONTAINING PROTEIN', 248602),
(385931, 'PTHR45875:SF3', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE N6AMT1', 248602),
(385932, 'PTHR45875:SF2', NULL, NULL, NULL, NULL, 'MTS DOMAIN-CONTAINING PROTEIN', 248602),
(385933, 'PTHR45875:SF1', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE N6AMT1', 248602),
(385934, 'PTHR45875', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE N6AMT1', 248602),
(385935, 'PTHR35866:SF1', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 248603),
(385936, 'PTHR35866', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 248603),
(385937, 'PTHR46216:SF2', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR 37-LIKE 1B', 248604),
(385938, 'PTHR46216:SF3', NULL, NULL, NULL, NULL, 'PROSAPOSIN RECEPTOR GPR37', 248604),
(385939, 'PTHR46216:SF4', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 37-LIKE 1', 248604),
(385940, 'PTHR46216', NULL, NULL, NULL, NULL, 'PROSAPOSIN RECEPTOR GPR37 FAMILY MEMBER', 248604),
(385941, 'PTHR33570:SF2', NULL, NULL, NULL, NULL, 'CMD DOMAIN-CONTAINING PROTEIN', 248605),
(385942, 'PTHR33570', NULL, NULL, NULL, NULL, '4-CARBOXYMUCONOLACTONE DECARBOXYLASE FAMILY PROTEIN', 248605),
(385943, 'PTHR33570:SF9', NULL, NULL, NULL, NULL, 'BLL4600 PROTEIN', 248605),
(385944, 'PTHR36480', NULL, NULL, NULL, NULL, 'OS06G0118900 PROTEIN-RELATED', 248606),
(385945, 'PTHR36480:SF10', NULL, NULL, NULL, NULL, '', 248606),
(385946, 'PTHR36480:SF3', NULL, NULL, NULL, NULL, 'OS06G0118900 PROTEIN', 248606),
(385947, 'PTHR36480:SF5', NULL, NULL, NULL, NULL, '', 248606),
(385948, 'PTHR36480:SF9', NULL, NULL, NULL, NULL, 'OS06G0121700 PROTEIN', 248606),
(385949, 'PTHR36480:SF8', NULL, NULL, NULL, NULL, '', 248606),
(385950, 'PTHR11500:SF0', NULL, NULL, NULL, NULL, 'BETA-CASEIN', 248607),
(385951, 'PTHR11500', NULL, NULL, NULL, NULL, 'BETA CASEIN', 248607),
(385952, 'PTHR10006', NULL, NULL, NULL, NULL, 'MUCIN-1-RELATED', 248608),
(385953, 'PTHR10006:SF19', NULL, NULL, NULL, NULL, 'MUCIN-1', 248608),
(385954, 'PTHR19971:SF32', NULL, NULL, NULL, NULL, 'SIGNAL-REGULATORY PROTEIN BETA-1', 248609),
(385955, 'PTHR19971:SF9', NULL, NULL, NULL, NULL, 'SIGNAL-REGULATORY PROTEIN BETA-2', 248609),
(385956, 'PTHR19971:SF5', NULL, NULL, NULL, NULL, 'RIKEN CDNA F830045P16 GENE', 248609),
(385957, 'PTHR19971:SF6', NULL, NULL, NULL, NULL, 'SIGNAL-REGULATORY PROTEIN GAMMA', 248609),
(385958, 'PTHR19971:SF36', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 248609),
(385959, 'PTHR19971:SF25', NULL, NULL, NULL, NULL, 'SIGNAL-REGULATORY PROTEIN DELTA', 248609),
(385960, 'PTHR19971', NULL, NULL, NULL, NULL, 'SIGNAL-REGULATORY PROTEIN BETA', 248609),
(385961, 'PTHR19971:SF35', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE NON-RECEPTOR TYPE SUBSTRATE 1', 248609),
(385962, 'PTHR19971:SF24', NULL, NULL, NULL, NULL, '', 248609),
(385963, 'PTHR19971:SF34', NULL, NULL, NULL, NULL, 'SIGNAL-REGULATORY PROTEIN BETA-1-LIKE', 248609),
(385964, 'PTHR19971:SF23', NULL, NULL, NULL, NULL, 'GENE 9733-RELATED', 248609),
(385965, 'PTHR19971:SF11', NULL, NULL, NULL, NULL, 'SIGNAL-REGULATORY PROTEIN BETA 1A-RELATED', 248609),
(385966, 'PTHR47979:SF80', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABB1A-RELATED', 248610),
(385967, 'PTHR47979:SF81', NULL, NULL, NULL, NULL, 'RAB11B, MEMBER RAS ONCOGENE FAMILY, A', 248610),
(385968, 'PTHR47979:SF84', NULL, NULL, NULL, NULL, 'OS05G0564400 PROTEIN', 248610),
(385969, 'PTHR47979:SF40', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABQ', 248610),
(385970, 'PTHR47979:SF39', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN, PUTATIVE-RELATED', 248610),
(385971, 'PTHR47979:SF38', NULL, NULL, NULL, NULL, 'GH01619P', 248610),
(385972, 'PTHR47979:SF75', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-14', 248610),
(385973, 'PTHR47979:SF31', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA5B-LIKE', 248610),
(385974, 'PTHR47979:SF30', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA5C', 248610),
(385975, 'PTHR47979:SF74', NULL, NULL, NULL, NULL, 'RABA2', 248610);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(385976, 'PTHR47979:SF33', NULL, NULL, NULL, NULL, 'DRAB11', 248610),
(385977, 'PTHR47979:SF76', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-15-LIKE', 248610),
(385978, 'PTHR47979:SF79', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA6A', 248610),
(385979, 'PTHR47979:SF36', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA5A', 248610),
(385980, 'PTHR47979:SF91', NULL, NULL, NULL, NULL, 'NOVEL PROTEIN SIMILAR TO VERTEBRATE RAB25, MEMBER RAS ONCOGENE FAMILY (RAB25)', 248610),
(385981, 'PTHR47979:SF95', NULL, NULL, NULL, NULL, 'SMALL GTPASE SUPERFAMILY, RAN GTPASE, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 248610),
(385982, 'PTHR47979:SF50', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-2B', 248610),
(385983, 'PTHR47979:SF94', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA1D', 248610),
(385984, 'PTHR47979:SF109', NULL, NULL, NULL, NULL, 'SMALL GTPASE SUPERFAMILY, RAN GTPASE, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 248610),
(385985, 'PTHR47979:SF108', NULL, NULL, NULL, NULL, 'OS02G0586400 PROTEIN', 248610),
(385986, 'PTHR47979:SF107', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB11C', 248610),
(385987, 'PTHR47979:SF106', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN, PUTATIVE-RELATED', 248610),
(385988, 'PTHR47979:SF105', NULL, NULL, NULL, NULL, 'SECRETION RELATED GTPASE SRGD (AFU_ORTHOLOGUE AFUA_1G07680)', 248610),
(385989, 'PTHR47979:SF104', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA1G', 248610),
(385990, 'PTHR47979:SF103', NULL, NULL, NULL, NULL, 'NT-RAB11E PROTEIN', 248610),
(385991, 'PTHR47979:SF102', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-2A', 248610),
(385992, 'PTHR47979:SF101', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABB1C-LIKE', 248610),
(385993, 'PTHR47979:SF100', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABB1C ISOFORM X2', 248610),
(385994, 'PTHR47979:SF42', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABB1C-LIKE', 248610),
(385995, 'PTHR47979:SF41', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-11B', 248610),
(385996, 'PTHR47979:SF88', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA1H-RELATED', 248610),
(385997, 'PTHR47979:SF43', NULL, NULL, NULL, NULL, 'RAB42, MEMBER RAS ONCOGENE FAMILY-RELATED', 248610),
(385998, 'PTHR47979:SF46', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-39A-LIKE', 248610),
(385999, 'PTHR47979:SF47', NULL, NULL, NULL, NULL, 'BNAA04G19900D PROTEIN', 248610),
(386000, 'PTHR47979', NULL, NULL, NULL, NULL, 'DRAB11-RELATED', 248610),
(386001, 'PTHR47979:SF62', NULL, NULL, NULL, NULL, 'BNAA08G30220D PROTEIN', 248610),
(386002, 'PTHR47979:SF3', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-39A', 248610),
(386003, 'PTHR47979:SF5', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-42', 248610),
(386004, 'PTHR47979:SF6', NULL, NULL, NULL, NULL, 'RAB11A, MEMBER RAS ONCOGENE FAMILY,-LIKE', 248610),
(386005, 'PTHR47979:SF7', NULL, NULL, NULL, NULL, 'INTRAFLAGELLAR TRANSPORT PROTEIN 27 HOMOLOG', 248610),
(386006, 'PTHR47979:SF8', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-25', 248610),
(386007, 'PTHR47979:SF112', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB2BV-LIKE', 248610),
(386008, 'PTHR47979:SF17', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-4B', 248610),
(386009, 'PTHR47979:SF111', NULL, NULL, NULL, NULL, '', 248610),
(386010, 'PTHR47979:SF16', NULL, NULL, NULL, NULL, 'RAB GTP-BINDING PROTEIN', 248610),
(386011, 'PTHR47979:SF110', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-11A', 248610),
(386012, 'PTHR47979:SF18', NULL, NULL, NULL, NULL, 'RAS GTPASE_ SIGMA-54 FACTOR, INTERACTION REGION', 248610),
(386013, 'PTHR47979:SF97', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA1F', 248610),
(386014, 'PTHR47979:SF53', NULL, NULL, NULL, NULL, 'FI07418P', 248610),
(386015, 'PTHR47979:SF52', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA6B', 248610),
(386016, 'PTHR47979:SF96', NULL, NULL, NULL, NULL, 'BNAC03G76820D PROTEIN', 248610),
(386017, 'PTHR47979:SF55', NULL, NULL, NULL, NULL, '', 248610),
(386018, 'PTHR47979:SF11', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE REGULATORY PROTEIN', 248610);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(386019, 'PTHR47979:SF99', NULL, NULL, NULL, NULL, 'SMALL GTPASE SUPERFAMILY, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 248610),
(386020, 'PTHR47979:SF98', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA1F-LIKE', 248610),
(386021, 'PTHR47979:SF57', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN GTP1', 248610),
(386022, 'PTHR47979:SF12', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-2A', 248610),
(386023, 'PTHR47979:SF56', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB11B', 248610),
(386024, 'PTHR47979:SF71', NULL, NULL, NULL, NULL, 'BNAA09G27200D PROTEIN', 248610),
(386025, 'PTHR47979:SF73', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-4A', 248610),
(386026, 'PTHR47979:SF29', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA1F-LIKE', 248610),
(386027, 'PTHR47979:SF20', NULL, NULL, NULL, NULL, 'SMALL GTPASE SUPERFAMILY, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 248610),
(386028, 'PTHR47979:SF63', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB2BV', 248610),
(386029, 'PTHR47979:SF22', NULL, NULL, NULL, NULL, 'RABA2', 248610),
(386030, 'PTHR47979:SF65', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA1A', 248610),
(386031, 'PTHR47979:SF21', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA1E', 248610),
(386032, 'PTHR47979:SF24', NULL, NULL, NULL, NULL, 'SMALL MONOMERIC GTPASE', 248610),
(386033, 'PTHR47979:SF25', NULL, NULL, NULL, NULL, 'BNAC01G40910D PROTEIN', 248610),
(386034, 'PTHR47979:SF69', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-39B', 248610),
(386035, 'PTHR31921:SF1', NULL, NULL, NULL, NULL, 'PROTEIN DPCD', 248611),
(386036, 'PTHR31921', NULL, NULL, NULL, NULL, 'PROTEIN DPCD', 248611),
(386037, 'PTHR31591:SF5', NULL, NULL, NULL, NULL, '', 248612),
(386038, 'PTHR31591:SF4', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_7G00330)-RELATED', 248612),
(386039, 'PTHR31591:SF7', NULL, NULL, NULL, NULL, '', 248612),
(386040, 'PTHR31591:SF6', NULL, NULL, NULL, NULL, 'BNAC09G38800D PROTEIN', 248612),
(386041, 'PTHR31591', NULL, NULL, NULL, NULL, 'UPF0613 PROTEIN PB24D3.06C', 248612),
(386042, 'PTHR31591:SF1', NULL, NULL, NULL, NULL, 'UPF0613 PROTEIN PB24D3.06C', 248612),
(386043, 'PTHR46122:SF17', NULL, NULL, NULL, NULL, 'GALACTOSE OXIDASE, BETA-PROPELLER-RELATED', 248613),
(386044, 'PTHR46122', NULL, NULL, NULL, NULL, 'GALACTOSE OXIDASE/KELCH REPEAT PROTEIN-RELATED', 248613),
(386045, 'PTHR46122:SF18', NULL, NULL, NULL, NULL, 'BNAC03G76170D PROTEIN', 248613),
(386046, 'PTHR46122:SF15', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248613),
(386047, 'PTHR46122:SF16', NULL, NULL, NULL, NULL, 'BNAA09G53710D PROTEIN', 248613),
(386048, 'PTHR46122:SF19', NULL, NULL, NULL, NULL, 'BNAA02G26610D PROTEIN', 248613),
(386049, 'PTHR46122:SF6', NULL, NULL, NULL, NULL, 'F-BOX/KELCH-REPEAT PROTEIN', 248613),
(386050, 'PTHR46122:SF20', NULL, NULL, NULL, NULL, 'BNAANNG18510D PROTEIN', 248613),
(386051, 'PTHR46122:SF10', NULL, NULL, NULL, NULL, 'GALACTOSE OXIDASE/KELCH REPEAT PROTEIN', 248613),
(386052, 'PTHR46122:SF7', NULL, NULL, NULL, NULL, 'GALACTOSE OXIDASE/KELCH REPEAT SUPERFAMILY PROTEIN', 248613),
(386053, 'PTHR46122:SF21', NULL, NULL, NULL, NULL, 'F-BOX/KELCH-REPEAT PROTEIN SKIP11', 248613),
(386054, 'PTHR46122:SF5', NULL, NULL, NULL, NULL, 'KELCH REPEAT F-BOX PROTEIN', 248613),
(386055, 'PTHR46122:SF24', NULL, NULL, NULL, NULL, 'F-BOX/KELCH-REPEAT PROTEIN SKIP11', 248613),
(386056, 'PTHR46122:SF13', NULL, NULL, NULL, NULL, 'F-BOX/KELCH-REPEAT PROTEIN SKIP11-LIKE', 248613),
(386057, 'PTHR46122:SF8', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248613),
(386058, 'PTHR46122:SF22', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING F-BOX FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 248613),
(386059, 'PTHR46122:SF12', NULL, NULL, NULL, NULL, 'BNAA09G29390D PROTEIN', 248613),
(386060, 'PTHR46122:SF9', NULL, NULL, NULL, NULL, 'GALACTOSE OXIDASE/KELCH REPEAT PROTEIN', 248613),
(386061, 'PTHR46122:SF23', NULL, NULL, NULL, NULL, 'OS02G0748300 PROTEIN', 248613),
(386062, 'PTHR46122:SF2', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING F-BOX FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 248613);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(386063, 'PTHR46122:SF1', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248613),
(386064, 'PTHR43123:SF4', NULL, NULL, NULL, NULL, 'POLYSACCHARIDE DEACETYLASE', 248614),
(386065, 'PTHR43123:SF1', NULL, NULL, NULL, NULL, 'POLYSACCHARIDE DEACETYLASE-RELATED', 248614),
(386066, 'PTHR43123', NULL, NULL, NULL, NULL, 'POLYSACCHARIDE DEACETYLASE-RELATED', 248614),
(386067, 'PTHR43123:SF3', NULL, NULL, NULL, NULL, 'NODB HOMOLOGY DOMAIN-CONTAINING PROTEIN', 248614),
(386068, 'PTHR47952:SF1', NULL, NULL, NULL, NULL, 'TRYPTAMINE 5-HYDROXYLASE', 248615),
(386069, 'PTHR47952', NULL, NULL, NULL, NULL, 'TRYPTAMINE 5-HYDROXYLASE', 248615),
(386070, 'PTHR43153:SF1', NULL, NULL, NULL, NULL, 'ELECTRON TRANSFER FLAVOPROTEIN SUBUNIT ALPHA, MITOCHONDRIAL', 248616),
(386071, 'PTHR43153:SF5', NULL, NULL, NULL, NULL, 'PROTEIN FIXB-RELATED', 248616),
(386072, 'PTHR43153', NULL, NULL, NULL, NULL, 'ELECTRON TRANSFER FLAVOPROTEIN ALPHA', 248616),
(386073, 'PTHR43153:SF11', NULL, NULL, NULL, NULL, 'ELECTRON TRANSFER FLAVOPROTEIN, SUBUNIT ALPHA (ETFA)', 248616),
(386074, 'PTHR40627:SF5', NULL, NULL, NULL, NULL, 'INDOLE PRENYLTRANSFERASE TDIB', 248617),
(386075, 'PTHR40627:SF4', NULL, NULL, NULL, NULL, 'PRENYLTRANSFERASE ASQH1-RELATED', 248617),
(386076, 'PTHR40627', NULL, NULL, NULL, NULL, 'INDOLE PRENYLTRANSFERASE TDIB-RELATED', 248617),
(386077, 'PTHR40627:SF3', NULL, NULL, NULL, NULL, 'PRENYLTRANSFERASE ASQH2-RELATED', 248617),
(386078, 'PTHR35292', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248618),
(386079, 'PTHR35292:SF10', NULL, NULL, NULL, NULL, '', 248618),
(386080, 'PTHR35292:SF7', NULL, NULL, NULL, NULL, 'BNAA07G00590D PROTEIN', 248618),
(386081, 'PTHR35292:SF6', NULL, NULL, NULL, NULL, '', 248618),
(386082, 'PTHR35292:SF12', NULL, NULL, NULL, NULL, '', 248618),
(386083, 'PTHR35292:SF11', NULL, NULL, NULL, NULL, '', 248618),
(386084, 'PTHR35292:SF3', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248618),
(386085, 'PTHR36703', NULL, NULL, NULL, NULL, 'TRIACYLGLYCEROL LIPASE-LIKE PROTEIN', 248619),
(386086, 'PTHR36703:SF1', NULL, NULL, NULL, NULL, 'TRIACYLGLYCEROL LIPASE-LIKE PROTEIN', 248619),
(386087, 'PTHR40463', NULL, NULL, NULL, NULL, 'PH-RESPONSE REGULATOR PROTEIN PALC', 248620),
(386088, 'PTHR40463:SF1', NULL, NULL, NULL, NULL, 'PH-RESPONSE REGULATOR PROTEIN PALC', 248620),
(386089, 'PTHR46262:SF3', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN F2', 248621),
(386090, 'PTHR46262:SF1', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN F1', 248621),
(386091, 'PTHR46262:SF2', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN BINIOU', 248621),
(386092, 'PTHR46262', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN BINIOU', 248621),
(386093, 'PTHR46812', NULL, NULL, NULL, NULL, 'CARBOXYMETHYLENEBUTENOLIDASE HOMOLOG', 248622),
(386094, 'PTHR46812:SF1', NULL, NULL, NULL, NULL, 'CARBOXYMETHYLENEBUTENOLIDASE HOMOLOG', 248622),
(386095, 'PTHR15821:SF0', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR MN1', 248623),
(386096, 'PTHR15821', NULL, NULL, NULL, NULL, 'PROTEIN MN1', 248623),
(386097, 'PTHR35344', NULL, NULL, NULL, NULL, 'GAS VESICLE STRUCTURAL PROTEIN 2-RELATED', 248624),
(386098, 'PTHR35344:SF4', NULL, NULL, NULL, NULL, 'GAS VESICLE STRUCTURAL PROTEIN 2-RELATED', 248624),
(386099, 'PTHR35131', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248625),
(386100, 'PTHR35131:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248625),
(386101, 'PTHR35131:SF4', NULL, NULL, NULL, NULL, '', 248625),
(386102, 'PTHR35131:SF2', NULL, NULL, NULL, NULL, 'GAG-POL POLYPROTEIN', 248625),
(386103, 'PTHR35607', NULL, NULL, NULL, NULL, 'GPI-ANCHORED PROTEIN 10', 248626),
(386104, 'PTHR35607:SF11', NULL, NULL, NULL, NULL, 'CELL WALL PROTEIN 1', 248626),
(386105, 'PTHR13582', NULL, NULL, NULL, NULL, 'M-PHASE PHOSPHOPROTEIN 6', 248627),
(386106, 'PTHR13582:SF0', NULL, NULL, NULL, NULL, 'M-PHASE PHOSPHOPROTEIN 6', 248627),
(386107, 'PTHR28031', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN HUA1', 248628),
(386108, 'PTHR28031:SF1', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN HUA1', 248628),
(386109, 'PTHR31566', NULL, NULL, NULL, NULL, 'CYTOCHROME C BIOGENESIS PROTEIN CCS1, CHLOROPLASTIC', 248629);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(386110, 'PTHR31566:SF5', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN-RELATED', 248629),
(386111, 'PTHR31566:SF4', NULL, NULL, NULL, NULL, 'RESB DOMAIN-CONTAINING PROTEIN', 248629),
(386112, 'PTHR31566:SF0', NULL, NULL, NULL, NULL, 'CYTOCHROME C BIOGENESIS PROTEIN CCS1, CHLOROPLASTIC', 248629),
(386113, 'PTHR22504', NULL, NULL, NULL, NULL, 'REPRESSOR OF RNA POLYMERASE III TRANSCRIPTION MAF1', 248630),
(386114, 'PTHR22504:SF0', NULL, NULL, NULL, NULL, 'REPRESSOR OF RNA POLYMERASE III TRANSCRIPTION MAF1 HOMOLOG', 248630),
(386115, 'PTHR22504:SF4', NULL, NULL, NULL, NULL, 'REPRESSOR OF RNA POLYMERASE III TRANSCRIPTION MAF1', 248630),
(386116, 'PTHR22504:SF5', NULL, NULL, NULL, NULL, 'REPRESSOR OF RNA POLYMERASE III TRANSCRIPTION MAF1 HOMOLOG', 248630),
(386117, 'PTHR14094', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE 72', 248631),
(386118, 'PTHR14094:SF9', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE SUBUNIT SRP72', 248631),
(386119, 'PTHR33146:SF10', NULL, NULL, NULL, NULL, 'I NUCLEASE, PUTATIVE-RELATED', 248632),
(386120, 'PTHR33146:SF21', NULL, NULL, NULL, NULL, 'ASPERGILLUS NUCLEASE S(1)', 248632),
(386121, 'PTHR33146:SF20', NULL, NULL, NULL, NULL, 'ASPERGILLUS NUCLEASE S(1)', 248632),
(386122, 'PTHR33146:SF25', NULL, NULL, NULL, NULL, 'ASPERGILLUS NUCLEASE S(1)', 248632),
(386123, 'PTHR33146:SF14', NULL, NULL, NULL, NULL, 'ENDONUCLEASE 1', 248632),
(386124, 'PTHR33146:SF13', NULL, NULL, NULL, NULL, 'ASPERGILLUS NUCLEASE S(1)', 248632),
(386125, 'PTHR33146:SF24', NULL, NULL, NULL, NULL, 'ASPERGILLUS NUCLEASE S(1)', 248632),
(386126, 'PTHR33146:SF23', NULL, NULL, NULL, NULL, 'ENDONUCLEASE 5', 248632),
(386127, 'PTHR33146:SF22', NULL, NULL, NULL, NULL, 'ASPERGILLUS NUCLEASE S(1)', 248632),
(386128, 'PTHR33146:SF18', NULL, NULL, NULL, NULL, 'ASPERGILLUS NUCLEASE S(1)', 248632),
(386129, 'PTHR33146:SF29', NULL, NULL, NULL, NULL, '', 248632),
(386130, 'PTHR33146:SF28', NULL, NULL, NULL, NULL, 'ASPERGILLUS NUCLEASE S(1)', 248632),
(386131, 'PTHR33146:SF16', NULL, NULL, NULL, NULL, 'ENDONUCLEASE 3', 248632),
(386132, 'PTHR33146:SF27', NULL, NULL, NULL, NULL, 'ENDONUCLEASE 2', 248632),
(386133, 'PTHR33146:SF26', NULL, NULL, NULL, NULL, 'ENDONUCLEASE 4', 248632),
(386134, 'PTHR33146:SF19', NULL, NULL, NULL, NULL, 'ASPERGILLUS NUCLEASE S(1)', 248632),
(386135, 'PTHR33146', NULL, NULL, NULL, NULL, 'ENDONUCLEASE 4', 248632),
(386136, 'PTHR33398:SF6', NULL, NULL, NULL, NULL, 'BNAA01G28980D PROTEIN', 248633),
(386137, 'PTHR33398:SF1', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S20, CHLOROPLASTIC', 248633),
(386138, 'PTHR33398', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S20', 248633),
(386139, 'PTHR33398:SF4', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S20, CHLOROPLASTIC-LIKE', 248633),
(386140, 'PTHR46906', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN BETA-8', 248634),
(386141, 'PTHR46906:SF1', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN BETA-8', 248634),
(386142, 'PTHR21642:SF6', NULL, NULL, NULL, NULL, 'CCM2_C DOMAIN-CONTAINING PROTEIN', 248635),
(386143, 'PTHR21642:SF2', NULL, NULL, NULL, NULL, 'CEREBRAL CAVERNOUS MALFORMATIONS 2 PROTEIN-LIKE', 248635),
(386144, 'PTHR21642:SF4', NULL, NULL, NULL, NULL, 'CEREBRAL CAVERNOUS MALFORMATIONS 2 PROTEIN', 248635),
(386145, 'PTHR21642', NULL, NULL, NULL, NULL, 'CEREBRAL CAVERNOUS MALFORMATIONS PROTEIN 2 HOMOLOG', 248635),
(386146, 'PTHR40781', NULL, NULL, NULL, NULL, '', 248636),
(386147, 'PTHR40781:SF1', NULL, NULL, NULL, NULL, '', 248636),
(386148, 'PTHR21392', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248637),
(386149, 'PTHR21392:SF0', NULL, NULL, NULL, NULL, 'TRNA-URIDINE AMINOCARBOXYPROPYLTRANSFERASE 2', 248637),
(386150, 'PTHR21392:SF1', NULL, NULL, NULL, NULL, 'TRNA-URIDINE AMINOCARBOXYPROPYLTRANSFERASE', 248637),
(386151, 'PTHR21392:SF4', NULL, NULL, NULL, NULL, 'TRNA-URIDINE AMINOCARBOXYPROPYLTRANSFERASE', 248637),
(386152, 'PTHR33498:SF1', NULL, NULL, NULL, NULL, 'TRANSPOSASE FOR INSERTION SEQUENCE ELEMENT IS1557', 248638),
(386153, 'PTHR33498', NULL, NULL, NULL, NULL, 'TRANSPOSASE FOR INSERTION SEQUENCE ELEMENT IS1557', 248638);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(386154, 'PTHR36950:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG24899', 248639),
(386155, 'PTHR36950:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG24898', 248639),
(386156, 'PTHR36950:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG08549', 248639),
(386157, 'PTHR36950', NULL, NULL, NULL, NULL, 'PROTEIN CBG24898-RELATED', 248639),
(386158, 'PTHR36950:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG05660', 248639),
(386159, 'PTHR24413:SF108', NULL, NULL, NULL, NULL, 'SPECKLE-TYPE BTB/POZ PROTEIN FAMILY MEMBER 1-RELATED', 248640),
(386160, 'PTHR24413:SF229', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 248640),
(386161, 'PTHR24413:SF228', NULL, NULL, NULL, NULL, 'BTB AND MATH DOMAIN-CONTAINING PROTEIN 40-RELATED', 248640),
(386162, 'PTHR24413:SF106', NULL, NULL, NULL, NULL, 'PROTEIN MATERNAL EFFECT LETHAL 26', 248640),
(386163, 'PTHR24413', NULL, NULL, NULL, NULL, 'SPECKLE-TYPE POZ PROTEIN', 248640),
(386164, 'PTHR24413:SF91', NULL, NULL, NULL, NULL, 'SPECKLE-TYPE POZ PROTEIN-LIKE', 248640),
(386165, 'PTHR24413:SF97', NULL, NULL, NULL, NULL, 'SPECKLE-TYPE POZ PROTEIN', 248640),
(386166, 'PTHR24413:SF226', NULL, NULL, NULL, NULL, 'BTB AND MATH DOMAIN-CONTAINING PROTEIN 41', 248640),
(386167, 'PTHR24413:SF237', NULL, NULL, NULL, NULL, 'RHO-RELATED BTB DOMAIN-CONTAINING PROTEIN 3', 248640),
(386168, 'PTHR24413:SF225', NULL, NULL, NULL, NULL, 'BTB AND MATH DOMAIN CONTAINING', 248640),
(386169, 'PTHR24413:SF236', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 248640),
(386170, 'PTHR24413:SF235', NULL, NULL, NULL, NULL, 'GH01369P', 248640),
(386171, 'PTHR24413:SF213', NULL, NULL, NULL, NULL, 'FI01029P-RELATED', 248640),
(386172, 'PTHR24413:SF234', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 248640),
(386173, 'PTHR24413:SF233', NULL, NULL, NULL, NULL, '', 248640),
(386174, 'PTHR24413:SF232', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 248640),
(386175, 'PTHR24413:SF231', NULL, NULL, NULL, NULL, '', 248640),
(386176, 'PTHR24413:SF230', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 248640),
(386177, 'PTHR44927:SF1', NULL, NULL, NULL, NULL, 'FK506-BINDING PROTEIN 15', 248641),
(386178, 'PTHR44927', NULL, NULL, NULL, NULL, 'FK506-BINDING PROTEIN 15', 248641),
(386179, 'PTHR38978:SF2', NULL, NULL, NULL, NULL, '', 248642),
(386180, 'PTHR38978', NULL, NULL, NULL, NULL, '', 248642),
(386181, 'PTHR14514:SF4', NULL, NULL, NULL, NULL, 'NESPRIN-2', 248643),
(386182, 'PTHR14514:SF3', NULL, NULL, NULL, NULL, 'NESPRIN-1', 248643),
(386183, 'PTHR14514:SF2', NULL, NULL, NULL, NULL, 'A-KINASE ANCHOR PROTEIN 6', 248643),
(386184, 'PTHR14514', NULL, NULL, NULL, NULL, 'PKA ANCHORING PROTEIN', 248643),
(386185, 'PTHR14514:SF6', NULL, NULL, NULL, NULL, 'KASH DOMAIN-CONTAINING PROTEIN', 248643),
(386186, 'PTHR42109', NULL, NULL, NULL, NULL, 'UNPLACED GENOMIC SCAFFOLD UM_SCAF_CONTIG_1.265, WHOLE GENOME SHOTGUN SEQUENCE', 248644),
(386187, 'PTHR42109:SF3', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_5G00100)', 248644),
(386188, 'PTHR42109:SF2', NULL, NULL, NULL, NULL, 'UNPLACED GENOMIC SCAFFOLD UM_SCAF_CONTIG_1.265, WHOLE GENOME SHOTGUN SEQUENCE', 248644),
(386189, 'PTHR12294:SF14', NULL, NULL, NULL, NULL, '', 248645),
(386190, 'PTHR12294:SF25', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF HAND PROTEIN', 248645),
(386191, 'PTHR12294:SF13', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CALCIUM UPTAKE 3, ISOFORM D', 248645),
(386192, 'PTHR12294:SF23', NULL, NULL, NULL, NULL, 'CALCIUM UPTAKE PROTEIN, MITOCHONDRIAL', 248645),
(386193, 'PTHR12294', NULL, NULL, NULL, NULL, 'EF HAND DOMAIN FAMILY A1,A2-RELATED', 248645),
(386194, 'PTHR12294:SF29', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF HAND FAMILY PROTEIN-RELATED', 248645),
(386195, 'PTHR12294:SF27', NULL, NULL, NULL, NULL, 'CALCIUM UPTAKE PROTEIN 1 HOMOLOG, MITOCHONDRIAL-LIKE ISOFORM X1', 248645),
(386196, 'PTHR12294:SF3', NULL, NULL, NULL, NULL, 'CALCIUM UPTAKE PROTEIN 2, MITOCHONDRIAL', 248645),
(386197, 'PTHR12294:SF10', NULL, NULL, NULL, NULL, 'CALCIUM UPTAKE PROTEIN 3, MITOCHONDRIAL', 248645),
(386198, 'PTHR12294:SF30', NULL, NULL, NULL, NULL, 'OS04G0502900 PROTEIN', 248645);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(386199, 'PTHR12294:SF1', NULL, NULL, NULL, NULL, 'CALCIUM UPTAKE PROTEIN 1, MITOCHONDRIAL', 248645),
(386200, 'PTHR46230:SF6', NULL, NULL, NULL, NULL, 'PROTEIN BOLA1, CHLOROPLASTIC', 248646),
(386201, 'PTHR46230', NULL, NULL, NULL, NULL, '', 248646),
(386202, 'PTHR46230:SF3', NULL, NULL, NULL, NULL, 'SUFE-LIKE PROTEIN 1, CHLOROPLASTIC/MITOCHONDRIAL', 248646),
(386203, 'PTHR46230:SF5', NULL, NULL, NULL, NULL, 'BOLA PROTEIN, FE-S METABOLISM ASSOCIATED DOMAIN, SUFE-LIKE PROTEIN-RELATED', 248646),
(386204, 'PTHR46230:SF4', NULL, NULL, NULL, NULL, 'BOLA-LIKE PROTEIN 1', 248646),
(386205, 'PTHR13116:SF6', NULL, NULL, NULL, NULL, 'ER MEMBRANE PROTEIN COMPLEX SUBUNIT 3', 248647),
(386206, 'PTHR13116:SF5', NULL, NULL, NULL, NULL, 'ER MEMBRANE PROTEIN COMPLEX SUBUNIT 3', 248647),
(386207, 'PTHR13116:SF10', NULL, NULL, NULL, NULL, 'ER MEMBRANE PROTEIN COMPLEX SUBUNIT 3', 248647),
(386208, 'PTHR13116', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248647),
(386209, 'PTHR13116:SF8', NULL, NULL, NULL, NULL, 'ER MEMBRANE PROTEIN COMPLEX SUBUNIT 3', 248647),
(386210, 'PTHR11097:SF31', NULL, NULL, NULL, NULL, '', 248648),
(386211, 'PTHR11097:SF30', NULL, NULL, NULL, NULL, 'BNAA05G29900D PROTEIN', 248648),
(386212, 'PTHR11097:SF8', NULL, NULL, NULL, NULL, 'EXOSOME COMPLEX COMPONENT RRP42', 248648),
(386213, 'PTHR11097:SF9', NULL, NULL, NULL, NULL, 'EXOSOME COMPLEX COMPONENT RRP43', 248648),
(386214, 'PTHR11097:SF34', NULL, NULL, NULL, NULL, '', 248648),
(386215, 'PTHR11097:SF33', NULL, NULL, NULL, NULL, 'RNASEPH-LIKE PROTEIN EXOSOME-ASSOCIATED PROTEIN 1 RRP42 HOMOLOGUE', 248648),
(386216, 'PTHR11097:SF28', NULL, NULL, NULL, NULL, '3''-5''-EXORIBONUCLEASE/RNA BINDING PROTEIN', 248648),
(386217, 'PTHR11097:SF27', NULL, NULL, NULL, NULL, 'POLYRIBONUCLEOTIDE NUCLEOTIDYLTRANSFERASE, PNPASE/RNASE PH DOMAIN PROTEIN-RELATED', 248648),
(386218, 'PTHR11097:SF26', NULL, NULL, NULL, NULL, 'EXOSOME COMPLEX COMPONENT RRP45A-LIKE', 248648),
(386219, 'PTHR11097:SF14', NULL, NULL, NULL, NULL, 'EXOSOME COMPLEX COMPONENT RRP45', 248648),
(386220, 'PTHR11097', NULL, NULL, NULL, NULL, 'EXOSOME COMPLEX EXONUCLEASE  RIBOSOMAL RNA PROCESSING PROTEIN', 248648),
(386221, 'PTHR36310:SF1', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT PROTEIN KINASE INHIBITOR SMR11', 248649),
(386222, 'PTHR36310:SF2', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT PROTEIN KINASE INHIBITOR SMR16', 248649),
(386223, 'PTHR36310', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT PROTEIN KINASE INHIBITOR SMR11', 248649),
(386224, 'PTHR43141:SF2', NULL, NULL, NULL, NULL, 'BLR3729 PROTEIN', 248650),
(386225, 'PTHR43141:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME BD-II UBIQUINOL OXIDASE SUBUNIT 2', 248650),
(386226, 'PTHR43141', NULL, NULL, NULL, NULL, 'CYTOCHROME BD2 SUBUNIT II', 248650),
(386227, 'PTHR43141:SF4', NULL, NULL, NULL, NULL, 'CYTOCHROME BD2 SUBUNIT II', 248650),
(386228, 'PTHR43141:SF5', NULL, NULL, NULL, NULL, 'CYTOCHROME BD-I UBIQUINOL OXIDASE SUBUNIT 2', 248650),
(386229, 'PTHR33514', NULL, NULL, NULL, NULL, 'PROTEIN ABCI12, CHLOROPLASTIC', 248651),
(386230, 'PTHR33514:SF13', NULL, NULL, NULL, NULL, 'PROTEIN ABCI12, CHLOROPLASTIC', 248651),
(386231, 'PTHR33514:SF15', NULL, NULL, NULL, NULL, 'COBALT TRANSPORT PROTEIN', 248651),
(386232, 'PTHR33514:SF1', NULL, NULL, NULL, NULL, 'COBALT TRANSPORT PROTEIN CBIQ', 248651),
(386233, 'PTHR38102:SF1', NULL, NULL, NULL, NULL, 'PERIPLASMIC CHAPERONE SPY', 248652),
(386234, 'PTHR38102:SF2', NULL, NULL, NULL, NULL, 'PERIPLASMIC PROTEIN CPXP', 248652),
(386235, 'PTHR38102', NULL, NULL, NULL, NULL, 'PERIPLASMIC CHAPERONE SPY', 248652),
(386236, 'PTHR11237', NULL, NULL, NULL, NULL, 'COENZYME Q10 BIOSYNTHESIS PROTEIN 7', 248653),
(386237, 'PTHR11237:SF4', NULL, NULL, NULL, NULL, '5-DEMETHOXYUBIQUINONE HYDROXYLASE, MITOCHONDRIAL', 248653),
(386238, 'PTHR35394', NULL, NULL, NULL, NULL, '', 248654),
(386239, 'PTHR35394:SF7', NULL, NULL, NULL, NULL, '', 248654),
(386240, 'PTHR35394:SF6', NULL, NULL, NULL, NULL, '', 248654),
(386241, 'PTHR35394:SF5', NULL, NULL, NULL, NULL, '', 248654),
(386242, 'PTHR33108:SF51', NULL, NULL, NULL, NULL, 'DUF1677 FAMILY PROTEIN (DUF1677)', 248655);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(386243, 'PTHR33108:SF73', NULL, NULL, NULL, NULL, 'BNAC09G37200D PROTEIN', 248655),
(386244, 'PTHR33108:SF46', NULL, NULL, NULL, NULL, '', 248655),
(386245, 'PTHR33108', NULL, NULL, NULL, NULL, 'OS01G0745000 PROTEIN', 248655),
(386246, 'PTHR33108:SF48', NULL, NULL, NULL, NULL, '', 248655),
(386247, 'PTHR33108:SF49', NULL, NULL, NULL, NULL, '', 248655),
(386248, 'PTHR33108:SF42', NULL, NULL, NULL, NULL, '', 248655),
(386249, 'PTHR33108:SF64', NULL, NULL, NULL, NULL, '', 248655),
(386250, 'PTHR33108:SF65', NULL, NULL, NULL, NULL, 'BNAC03G42880D PROTEIN', 248655),
(386251, 'PTHR33108:SF43', NULL, NULL, NULL, NULL, 'BNAC01G22740D PROTEIN', 248655),
(386252, 'PTHR33108:SF66', NULL, NULL, NULL, NULL, 'BNAA08G05510D PROTEIN', 248655),
(386253, 'PTHR33108:SF82', NULL, NULL, NULL, NULL, 'DUF1677 FAMILY PROTEIN', 248655),
(386254, 'PTHR33108:SF61', NULL, NULL, NULL, NULL, '', 248655),
(386255, 'PTHR33108:SF83', NULL, NULL, NULL, NULL, '', 248655),
(386256, 'PTHR33108:SF40', NULL, NULL, NULL, NULL, '', 248655),
(386257, 'PTHR33108:SF62', NULL, NULL, NULL, NULL, 'DUF1677 FAMILY PROTEIN', 248655),
(386258, 'PTHR33108:SF84', NULL, NULL, NULL, NULL, '', 248655),
(386259, 'PTHR33108:SF8', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248655),
(386260, 'PTHR33108:SF3', NULL, NULL, NULL, NULL, 'DUF1677 FAMILY PROTEIN', 248655),
(386261, 'PTHR33108:SF2', NULL, NULL, NULL, NULL, 'OS03G0665700 PROTEIN', 248655),
(386262, 'PTHR33108:SF80', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248655),
(386263, 'PTHR33108:SF81', NULL, NULL, NULL, NULL, 'BNAA06G01330D PROTEIN', 248655),
(386264, 'PTHR33108:SF57', NULL, NULL, NULL, NULL, '', 248655),
(386265, 'PTHR33108:SF79', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN (DUF1677)', 248655),
(386266, 'PTHR33108:SF13', NULL, NULL, NULL, NULL, 'DUF1677 FAMILY PROTEIN', 248655),
(386267, 'PTHR33108:SF14', NULL, NULL, NULL, NULL, 'OS01G0745000 PROTEIN', 248655),
(386268, 'PTHR33108:SF36', NULL, NULL, NULL, NULL, '', 248655),
(386269, 'PTHR33108:SF75', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248655),
(386270, 'PTHR33108:SF32', NULL, NULL, NULL, NULL, 'DUF1677 FAMILY PROTEIN (DUF1677)', 248655),
(386271, 'PTHR33108:SF76', NULL, NULL, NULL, NULL, 'OS06G0199402 PROTEIN', 248655),
(386272, 'PTHR33108:SF10', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248655),
(386273, 'PTHR33108:SF11', NULL, NULL, NULL, NULL, 'OS01G0199700 PROTEIN', 248655),
(386274, 'PTHR33108:SF33', NULL, NULL, NULL, NULL, 'OS01G0200200 PROTEIN', 248655),
(386275, 'PTHR33108:SF56', NULL, NULL, NULL, NULL, '', 248655),
(386276, 'PTHR33108:SF78', NULL, NULL, NULL, NULL, 'DUF1677 FAMILY PROTEIN', 248655),
(386277, 'PTHR33108:SF12', NULL, NULL, NULL, NULL, 'OS02G0229900 PROTEIN', 248655),
(386278, 'PTHR40139:SF1', NULL, NULL, NULL, NULL, 'PROTEIN TNT', 248656),
(386279, 'PTHR40139', NULL, NULL, NULL, NULL, 'PROTEIN TNT', 248656),
(386280, 'PTHR43797', NULL, NULL, NULL, NULL, 'HOMOCYSTEINE/CYSTEINE SYNTHASE', 248657),
(386281, 'PTHR43797:SF2', NULL, NULL, NULL, NULL, 'HOMOCYSTEINE/CYSTEINE SYNTHASE', 248657),
(386282, 'PTHR43797:SF3', NULL, NULL, NULL, NULL, 'O-ACETYLHOMOSERINE SULFHYDRYLASE', 248657),
(386283, 'PTHR36529', NULL, NULL, NULL, NULL, 'SLL1095 PROTEIN', 248658),
(386284, 'PTHR36529:SF1', NULL, NULL, NULL, NULL, 'SLL1095 PROTEIN', 248658),
(386285, 'PTHR34861:SF9', NULL, NULL, NULL, NULL, '', 248659),
(386286, 'PTHR34861:SF8', NULL, NULL, NULL, NULL, '', 248659),
(386287, 'PTHR34861:SF10', NULL, NULL, NULL, NULL, 'SECRETED METAL-DEPENDENT CYCLASE', 248659),
(386288, 'PTHR34861', NULL, NULL, NULL, NULL, '', 248659),
(386289, 'PTHR37296:SF1', NULL, NULL, NULL, NULL, 'CONSERVED VIRULENCE FACTOR B', 248660),
(386290, 'PTHR37296', NULL, NULL, NULL, NULL, 'CONSERVED VIRULENCE FACTOR B', 248660),
(386291, 'PTHR34892:SF2', NULL, NULL, NULL, NULL, 'VACUOLAR ATP SYNTHASE CATALYTIC SUBUNIT-RELATED / V-ATPASE-RELATED / VACUOLAR PROTON PUMP-LIKE PROTEIN', 248661),
(386292, 'PTHR34892:SF1', NULL, NULL, NULL, NULL, 'VACUOLAR ATP SYNTHASE CATALYTIC SUBUNIT-RELATED / V-ATPASE-RELATED / VACUOLAR PROTON PUMP-RELATED', 248661);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(386293, 'PTHR34892', NULL, NULL, NULL, NULL, 'VACUOLAR ATP SYNTHASE CATALYTIC SUBUNIT-RELATED / V-ATPASE-RELATED / VACUOLAR PROTON PUMP-LIKE PROTEIN', 248661),
(386294, 'PTHR38649', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 33', 248662),
(386295, 'PTHR38649:SF1', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 33', 248662),
(386296, 'PTHR30580', NULL, NULL, NULL, NULL, 'PRIMOSOMAL PROTEIN N', 248663),
(386297, 'PTHR30580:SF0', NULL, NULL, NULL, NULL, 'PRIMOSOMAL PROTEIN N''', 248663),
(386298, 'PTHR30580:SF1', NULL, NULL, NULL, NULL, 'COMF OPERON PROTEIN 1', 248663),
(386299, 'PTHR23276:SF2', NULL, NULL, NULL, NULL, 'PROTEIN PRRC1', 248664),
(386300, 'PTHR23276', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248664),
(386301, 'PTHR23076:SF111', NULL, NULL, NULL, NULL, 'INACTIVE ATP-DEPENDENT ZINC METALLOPROTEASE FTSHI 1, CHLOROPLASTIC-RELATED', 248665),
(386302, 'PTHR23076:SF113', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT ZINC METALLOPROTEASE FTSH 1, CHLOROPLASTIC-RELATED', 248665),
(386303, 'PTHR23076:SF130', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT ZINC METALLOPROTEASE FTSH 9, CHLOROPLASTIC', 248665),
(386304, 'PTHR23076:SF110', NULL, NULL, NULL, NULL, 'INACTIVE ATP-DEPENDENT ZINC METALLOPROTEASE FTSHI 3, CHLOROPLASTIC-RELATED', 248665),
(386305, 'PTHR23076:SF131', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT ZINC METALLOPROTEASE FTSH 8, CHLOROPLASTIC', 248665),
(386306, 'PTHR23076:SF116', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 248665),
(386307, 'PTHR23076:SF115', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 248665),
(386308, 'PTHR23076:SF49', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT ZINC METALLOPROTEASE FTSH 7, CHLOROPLASTIC', 248665),
(386309, 'PTHR23076:SF118', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT ZINC METALLOPROTEASE FTSH 6, CHLOROPLASTIC', 248665),
(386310, 'PTHR23076:SF117', NULL, NULL, NULL, NULL, 'ATPASE, AAA-TYPE, CORE-RELATED', 248665),
(386311, 'PTHR23076:SF99', NULL, NULL, NULL, NULL, 'INACTIVE ATP-DEPENDENT ZINC METALLOPROTEASE FTSHI 4, CHLOROPLASTIC-RELATED', 248665),
(386312, 'PTHR23076:SF78', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT METALLOPROTEASE', 248665),
(386313, 'PTHR23076:SF56', NULL, NULL, NULL, NULL, 'INACTIVE ATP-DEPENDENT ZINC METALLOPROTEASE FTSHI 2, CHLOROPLASTIC-RELATED', 248665),
(386314, 'PTHR23076:SF97', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT ZINC METALLOPROTEASE YME1L1', 248665),
(386315, 'PTHR23076', NULL, NULL, NULL, NULL, 'METALLOPROTEASE M41 FTSH', 248665),
(386316, 'PTHR23076:SF122', NULL, NULL, NULL, NULL, 'ATPASE, AAA-TYPE, CORE-RELATED', 248665),
(386317, 'PTHR23076:SF125', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT ZINC METALLOPROTEASE FTSH PROTEIN', 248665),
(386318, 'PTHR23076:SF103', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT ZINC METALLOPROTEASE FTSH 4 MITOCHONDRIAL', 248665),
(386319, 'PTHR23076:SF120', NULL, NULL, NULL, NULL, 'ATPASE, AAA-TYPE, CORE, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 248665),
(386320, 'PTHR23076:SF108', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT ZINC METALLOPROTEASE FTSH 4, MITOCHONDRIAL-LIKE', 248665),
(386321, 'PTHR23076:SF127', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 248665),
(386322, 'PTHR23076:SF58', NULL, NULL, NULL, NULL, 'INACTIVE ATP-DEPENDENT ZINC METALLOPROTEASE FTSHI 5, CHLOROPLASTIC-RELATED', 248665),
(386323, 'PTHR23076:SF37', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT ZINC METALLOPROTEASE FTSH 4, MITOCHONDRIAL', 248665),
(386324, 'PTHR23076:SF126', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 248665),
(386325, 'PTHR23076:SF129', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT ZINC METALLOPROTEASE-RELATED', 248665),
(386326, 'PTHR23076:SF128', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT ZINC METALLOPROTEASE FTSH 11, CHLOROPLASTIC/MITOCHONDRIAL', 248665),
(386327, 'PTHR13690:SF107', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR VIP1-LIKE', 248666),
(386328, 'PTHR13690:SF129', NULL, NULL, NULL, NULL, 'BASIC-LEUCINE ZIPPER DOMAIN-CONTAINING PROTEIN-RELATED', 248666),
(386329, 'PTHR13690:SF121', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR SUPERFAMILY PROTEIN-RELATED', 248666); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(386330, 'PTHR13690:SF143', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 248666),
(386331, 'PTHR13690:SF78', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR FAMILY PROTEIN, EXPRESSED', 248666),
(386332, 'PTHR13690:SF144', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 248666),
(386333, 'PTHR13690:SF122', NULL, NULL, NULL, NULL, 'ATBZIP TRANSCRIPTION FACTOR', 248666),
(386334, 'PTHR13690:SF124', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR RF2A', 248666),
(386335, 'PTHR13690:SF79', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR', 248666),
(386336, 'PTHR13690:SF146', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 248666),
(386337, 'PTHR13690:SF103', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR RF2B', 248666),
(386338, 'PTHR13690:SF147', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR RSG, PUTATIVE, EXPRESSED-RELATED', 248666),
(386339, 'PTHR13690:SF148', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR POSF21-RELATED', 248666),
(386340, 'PTHR13690:SF126', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR RF2B-LIKE', 248666),
(386341, 'PTHR13690:SF149', NULL, NULL, NULL, NULL, '', 248666),
(386342, 'PTHR13690:SF105', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR POSF21-RELATED', 248666),
(386343, 'PTHR13690:SF127', NULL, NULL, NULL, NULL, 'VIRE2-INTERACTING PROTEIN 1-RELATED', 248666),
(386344, 'PTHR13690:SF150', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 248666),
(386345, 'PTHR13690:SF151', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR', 248666),
(386346, 'PTHR13690:SF152', NULL, NULL, NULL, NULL, 'BASIC-LEUCINE ZIPPER DOMAIN-CONTAINING PROTEIN-RELATED', 248666),
(386347, 'PTHR13690:SF153', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR 18', 248666),
(386348, 'PTHR13690:SF131', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 248666),
(386349, 'PTHR13690', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR POSF21-RELATED', 248666),
(386350, 'PTHR13690:SF132', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 248666),
(386351, 'PTHR13690:SF154', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 248666),
(386352, 'PTHR13690:SF111', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR', 248666),
(386353, 'PTHR13690:SF155', NULL, NULL, NULL, NULL, 'FAMILY TRANSCRIPTION FACTOR, PUTATIVE, EXPRESSED-RELATED', 248666),
(386354, 'PTHR13690:SF156', NULL, NULL, NULL, NULL, 'BNAC01G20250D PROTEIN', 248666),
(386355, 'PTHR13690:SF134', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 248666),
(386356, 'PTHR13690:SF112', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR RF2A-LIKE', 248666),
(386357, 'PTHR13690:SF135', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 248666),
(386358, 'PTHR13690:SF114', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR RF2A-LIKE', 248666),
(386359, 'PTHR13690:SF137', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 248666),
(386360, 'PTHR13690:SF116', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR', 248666),
(386361, 'PTHR13690:SF138', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 248666),
(386362, 'PTHR13690:SF117', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR FAMILY PROTEIN-RELATED', 248666),
(386363, 'PTHR13690:SF80', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR 30', 248666),
(386364, 'PTHR13690:SF140', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 248666),
(386365, 'PTHR13690:SF141', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 248666),
(386366, 'PTHR13690:SF142', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR', 248666),
(386367, 'PTHR13690:SF120', NULL, NULL, NULL, NULL, 'BASIC-LEUCINE ZIPPER (BZIP) TRANSCRIPTION FACTOR FAMILY PROTEIN', 248666),
(386368, 'PTHR13690:SF86', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR VIP1', 248666),
(386369, 'PTHR34256:SF1', NULL, NULL, NULL, NULL, 'UPF0561 PROTEIN C2ORF68', 248667),
(386370, 'PTHR34256', NULL, NULL, NULL, NULL, 'UPF0561 PROTEIN C2ORF68', 248667),
(386371, 'PTHR24214:SF61', NULL, NULL, NULL, NULL, '', 248668),
(386372, 'PTHR24214:SF60', NULL, NULL, NULL, NULL, 'PDZ AND LIM DOMAIN 5B', 248668);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(386373, 'PTHR24214:SF32', NULL, NULL, NULL, NULL, 'PDZ AND LIM DOMAIN PROTEIN 5', 248668),
(386374, 'PTHR24214:SF31', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN', 248668),
(386375, 'PTHR24214:SF58', NULL, NULL, NULL, NULL, 'AGAP003937-PD', 248668),
(386376, 'PTHR24214', NULL, NULL, NULL, NULL, 'PDZ AND LIM DOMAIN PROTEIN ZASP', 248668),
(386377, 'PTHR24214:SF34', NULL, NULL, NULL, NULL, 'PRICKLE-LIKE PROTEIN 4', 248668),
(386378, 'PTHR24214:SF55', NULL, NULL, NULL, NULL, 'Z BAND ALTERNATIVELY SPLICED PDZ-MOTIF PROTEIN 66, ISOFORM E', 248668),
(386379, 'PTHR24214:SF9', NULL, NULL, NULL, NULL, 'LIM DOMAIN-BINDING PROTEIN 3', 248668),
(386380, 'PTHR24214:SF38', NULL, NULL, NULL, NULL, 'PDZ AND LIM DOMAIN PROTEIN ZASP', 248668),
(386381, 'PTHR24214:SF59', NULL, NULL, NULL, NULL, 'Z BAND ALTERNATIVELY SPLICED PDZ-MOTIF PROTEIN 67, ISOFORM G', 248668),
(386382, 'PTHR24214:SF5', NULL, NULL, NULL, NULL, 'PDZ AND LIM DOMAIN PROTEIN 1', 248668),
(386383, 'PTHR24214:SF7', NULL, NULL, NULL, NULL, 'PDZ AND LIM DOMAIN PROTEIN 3', 248668),
(386384, 'PTHR24214:SF6', NULL, NULL, NULL, NULL, 'PDZ AND LIM DOMAIN PROTEIN 4', 248668),
(386385, 'PTHR24214:SF1', NULL, NULL, NULL, NULL, 'PDZ AND LIM DOMAIN PROTEIN 2', 248668),
(386386, 'PTHR24214:SF0', NULL, NULL, NULL, NULL, 'PDZ AND LIM DOMAIN PROTEIN 7', 248668),
(386387, 'PTHR40706:SF1', NULL, NULL, NULL, NULL, 'RIBOFLAVIN KINASE', 248669),
(386388, 'PTHR40706', NULL, NULL, NULL, NULL, 'RIBOFLAVIN KINASE', 248669),
(386389, 'PTHR43427:SF3', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN CLC-F', 248670),
(386390, 'PTHR43427', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN CLC-E', 248670),
(386391, 'PTHR43427:SF6', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN CLC-E', 248670),
(386392, 'PTHR43427:SF7', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN', 248670),
(386393, 'PTHR43427:SF9', NULL, NULL, NULL, NULL, 'ION-TRANSPORT PROTEIN YFEO-RELATED', 248670),
(386394, 'PTHR43427:SF10', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN', 248670),
(386395, 'PTHR43427:SF13', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN', 248670),
(386396, 'PTHR43427:SF12', NULL, NULL, NULL, NULL, 'CHLORIDE TRANSPORTER', 248670),
(386397, 'PTHR34560:SF1', NULL, NULL, NULL, NULL, 'START DOMAIN-CONTAINING PROTEIN', 248671),
(386398, 'PTHR34560:SF3', NULL, NULL, NULL, NULL, 'POLYKETIDE CYCLASE/DEHYDRASE AND LIPID TRANSPORT SUPERFAMILY PROTEIN', 248671),
(386399, 'PTHR34560', NULL, NULL, NULL, NULL, 'POLYKETIDE CYCLASE/DEHYDRASE/LIPID TRANSPORT SUPERFAMILY PROTEIN', 248671),
(386400, 'PTHR34560:SF5', NULL, NULL, NULL, NULL, 'PYL-LIKE-1', 248671),
(386401, 'PTHR34560:SF6', NULL, NULL, NULL, NULL, 'BNAA05G27350D PROTEIN', 248671),
(386402, 'PTHR34560:SF7', NULL, NULL, NULL, NULL, 'BNAA03G55370D PROTEIN', 248671),
(386403, 'PTHR34560:SF8', NULL, NULL, NULL, NULL, 'START-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 248671),
(386404, 'PTHR31224', NULL, NULL, NULL, NULL, 'UNC119-BINDING PROTEIN C5ORF30', 248672),
(386405, 'PTHR31224:SF2', NULL, NULL, NULL, NULL, 'MACROPHAGE IMMUNOMETABOLISM REGULATOR', 248672),
(386406, 'PTHR15601:SF28', NULL, NULL, NULL, NULL, 'BNAC03G57580D PROTEIN', 248673),
(386407, 'PTHR15601:SF29', NULL, NULL, NULL, NULL, 'OS12G0514100 PROTEIN', 248673),
(386408, 'PTHR15601:SF15', NULL, NULL, NULL, NULL, 'STRESS-ASSOCIATED ENDOPLASMIC RETICULUM PROTEIN', 248673),
(386409, 'PTHR15601:SF24', NULL, NULL, NULL, NULL, 'BNAC03G57570D PROTEIN', 248673),
(386410, 'PTHR15601:SF25', NULL, NULL, NULL, NULL, 'BNAANNG21710D PROTEIN', 248673),
(386411, 'PTHR15601:SF14', NULL, NULL, NULL, NULL, 'STRESS-ASSOCIATED ENDOPLASMIC RETICULUM PROTEIN 1', 248673),
(386412, 'PTHR15601:SF33', NULL, NULL, NULL, NULL, '', 248673),
(386413, 'PTHR15601:SF23', NULL, NULL, NULL, NULL, 'STRESS ASSOCIATED ENDOPLASMIC RETICULUM PROTEIN', 248673),
(386414, 'PTHR15601:SF20', NULL, NULL, NULL, NULL, 'STRESS-ASSOCIATED ENDOPLASMIC RETICULUM PROTEIN 2', 248673),
(386415, 'PTHR15601:SF32', NULL, NULL, NULL, NULL, 'OS11G0637501 PROTEIN', 248673),
(386416, 'PTHR15601:SF1', NULL, NULL, NULL, NULL, 'SERP1 HOMOLOG', 248673);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(386417, 'PTHR15601', NULL, NULL, NULL, NULL, 'STRESS ASSOCIATED ENDOPLASMIC RETICULUM PROTEIN  SERP1/RAMP4', 248673),
(386418, 'PTHR15601:SF0', NULL, NULL, NULL, NULL, 'GEO09675P1', 248673),
(386419, 'PTHR46912', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP B PROTEIN 13', 248674),
(386420, 'PTHR46912:SF2', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP B PROTEIN 6', 248674),
(386421, 'PTHR46912:SF1', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP B PROTEIN 13', 248674),
(386422, 'PTHR23246:SF13', NULL, NULL, NULL, NULL, 'ACTIN-BINDING PROTEIN F', 248675),
(386423, 'PTHR23246:SF23', NULL, NULL, NULL, NULL, 'MYB-LIKE DOMAIN-CONTAINING PROTEIN', 248675),
(386424, 'PTHR23246:SF22', NULL, NULL, NULL, NULL, 'GH12359P', 248675),
(386425, 'PTHR23246:SF17', NULL, NULL, NULL, NULL, '', 248675),
(386426, 'PTHR23246:SF21', NULL, NULL, NULL, NULL, 'E2F_TDP DOMAIN-CONTAINING PROTEIN-RELATED', 248675),
(386427, 'PTHR23246', NULL, NULL, NULL, NULL, 'NEW-GLUE PROTEIN', 248675),
(386428, 'PTHR12581:SF0', NULL, NULL, NULL, NULL, 'KRR1 SMALL SUBUNIT PROCESSOME COMPONENT HOMOLOG', 248676),
(386429, 'PTHR12581', NULL, NULL, NULL, NULL, 'HIV-1 REV BINDING PROTEIN 2, 3', 248676),
(386430, 'PTHR12010:SF13', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S29', 248677),
(386431, 'PTHR12010:SF2', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S29', 248677),
(386432, 'PTHR12010:SF24', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S29', 248677),
(386433, 'PTHR12010:SF23', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S14-RELATED', 248677),
(386434, 'PTHR12010:SF22', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S29', 248677),
(386435, 'PTHR12010:SF17', NULL, NULL, NULL, NULL, 'BNAA03G50690D PROTEIN', 248677),
(386436, 'PTHR12010', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S29', 248677),
(386437, 'PTHR12010:SF18', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S14P/S29E FAMILY PROTEIN-RELATED', 248677),
(386438, 'PTHR41532', NULL, NULL, NULL, NULL, 'FIXS PROTEIN', 248678),
(386439, 'PTHR41532:SF1', NULL, NULL, NULL, NULL, 'FIXS PROTEIN', 248678),
(386440, 'PTHR24117:SF6', NULL, NULL, NULL, NULL, 'BCL-6 COREPRESSOR-LIKE PROTEIN 1', 248679),
(386441, 'PTHR24117:SF9', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 248679),
(386442, 'PTHR24117:SF8', NULL, NULL, NULL, NULL, 'BCL-6 COREPRESSOR', 248679),
(386443, 'PTHR24117', NULL, NULL, NULL, NULL, 'AGAP007537-PB', 248679),
(386444, 'PTHR11802:SF25', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE 24', 248680),
(386445, 'PTHR11802:SF480', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386446, 'PTHR11802:SF481', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 19', 248680),
(386447, 'PTHR11802:SF29', NULL, NULL, NULL, NULL, 'OS10G0101100 PROTEIN', 248680),
(386448, 'PTHR11802:SF482', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386449, 'PTHR11802:SF361', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 11-RELATED', 248680),
(386450, 'PTHR11802:SF362', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386451, 'PTHR11802:SF483', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386452, 'PTHR11802:SF484', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386453, 'PTHR11802:SF243', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386454, 'PTHR11802:SF485', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE, PUTATIVE-RELATED', 248680),
(386455, 'PTHR11802:SF364', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386456, 'PTHR11802:SF123', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386457, 'PTHR11802:SF486', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386458, 'PTHR11802:SF244', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 26', 248680),
(386459, 'PTHR11802:SF366', NULL, NULL, NULL, NULL, 'BNAC04G31880D PROTEIN', 248680),
(386460, 'PTHR11802:SF487', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 13', 248680),
(386461, 'PTHR11802:SF245', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386462, 'PTHR11802:SF367', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386463, 'PTHR11802:SF125', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(386464, 'PTHR11802:SF488', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386465, 'PTHR11802:SF489', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386466, 'PTHR11802:SF369', NULL, NULL, NULL, NULL, 'BNAC02G06770D PROTEIN', 248680),
(386467, 'PTHR11802:SF248', NULL, NULL, NULL, NULL, '', 248680),
(386468, 'PTHR11802:SF249', NULL, NULL, NULL, NULL, '', 248680),
(386469, 'PTHR11802:SF31', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 34', 248680),
(386470, 'PTHR11802:SF38', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE CTSA-1.2', 248680),
(386471, 'PTHR11802:SF32', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 29', 248680),
(386472, 'PTHR11802:SF33', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE CTSA-3.2', 248680),
(386473, 'PTHR11802:SF490', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386474, 'PTHR11802:SF491', NULL, NULL, NULL, NULL, 'OS04G0321700 PROTEIN', 248680),
(386475, 'PTHR11802:SF371', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 248680),
(386476, 'PTHR11802:SF373', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386477, 'PTHR11802:SF131', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386478, 'PTHR11802:SF374', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386479, 'PTHR11802:SF132', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 36-RELATED', 248680),
(386480, 'PTHR11802:SF254', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 20', 248680),
(386481, 'PTHR11802:SF377', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE PROTEIN', 248680),
(386482, 'PTHR11802:SF378', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386483, 'PTHR11802:SF257', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE', 248680),
(386484, 'PTHR11802:SF258', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386485, 'PTHR11802:SF259', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 48', 248680),
(386486, 'PTHR11802:SF460', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386487, 'PTHR11802:SF461', NULL, NULL, NULL, NULL, 'OS02G0687900 PROTEIN', 248680),
(386488, 'PTHR11802:SF340', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386489, 'PTHR11802:SF220', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386490, 'PTHR11802:SF462', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386491, 'PTHR11802:SF463', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386492, 'PTHR11802:SF464', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 32', 248680),
(386493, 'PTHR11802:SF344', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386494, 'PTHR11802:SF465', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 44', 248680),
(386495, 'PTHR11802:SF223', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386496, 'PTHR11802:SF466', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386497, 'PTHR11802:SF224', NULL, NULL, NULL, NULL, 'GLUCOSE ACYLTRANSFERASE', 248680),
(386498, 'PTHR11802:SF346', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386499, 'PTHR11802:SF467', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386500, 'PTHR11802:SF468', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386501, 'PTHR11802:SF347', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 18', 248680),
(386502, 'PTHR11802:SF469', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386503, 'PTHR11802:SF106', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386504, 'PTHR11802:SF227', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 44', 248680),
(386505, 'PTHR11802:SF349', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386506, 'PTHR11802:SF229', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386507, 'PTHR11802:SF15', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 31-RELATED', 248680),
(386508, 'PTHR11802:SF470', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386509, 'PTHR11802:SF471', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386510, 'PTHR11802:SF350', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE', 248680),
(386511, 'PTHR11802:SF472', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE CPVL-RELATED', 248680);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(386512, 'PTHR11802:SF351', NULL, NULL, NULL, NULL, '1-O-ACYLGLUCOSE:ANTHOCYANIN-O-ACYLTRANSFERASE', 248680),
(386513, 'PTHR11802:SF473', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386514, 'PTHR11802:SF352', NULL, NULL, NULL, NULL, 'BNACNNG22970D PROTEIN', 248680),
(386515, 'PTHR11802:SF474', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386516, 'PTHR11802', NULL, NULL, NULL, NULL, 'SERINE PROTEASE FAMILY S10 SERINE CARBOXYPEPTIDASE', 248680),
(386517, 'PTHR11802:SF354', NULL, NULL, NULL, NULL, 'BNAA04G13410D PROTEIN', 248680),
(386518, 'PTHR11802:SF233', NULL, NULL, NULL, NULL, '', 248680),
(386519, 'PTHR11802:SF475', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386520, 'PTHR11802:SF113', NULL, NULL, NULL, NULL, 'LYSOSOMAL PROTECTIVE PROTEIN', 248680),
(386521, 'PTHR11802:SF476', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386522, 'PTHR11802:SF355', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386523, 'PTHR11802:SF356', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386524, 'PTHR11802:SF235', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 33', 248680),
(386525, 'PTHR11802:SF477', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE, PUTATIVE-RELATED', 248680),
(386526, 'PTHR11802:SF478', NULL, NULL, NULL, NULL, '', 248680),
(386527, 'PTHR11802:SF236', NULL, NULL, NULL, NULL, 'OS02G0463500 PROTEIN', 248680),
(386528, 'PTHR11802:SF479', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386529, 'PTHR11802:SF116', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386530, 'PTHR11802:SF358', NULL, NULL, NULL, NULL, 'GLUCOSE ACYLTRANSFERASE', 248680),
(386531, 'PTHR11802:SF238', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386532, 'PTHR11802:SF359', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386533, 'PTHR11802:SF239', NULL, NULL, NULL, NULL, 'PEPTIDASE S10, SERINE CARBOXYPEPTIDASE, ALPHA/BETA HYDROLASE-RELATED', 248680),
(386534, 'PTHR11802:SF20', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 41-RELATED', 248680),
(386535, 'PTHR11802:SF440', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386536, 'PTHR11802:SF320', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386537, 'PTHR11802:SF321', NULL, NULL, NULL, NULL, '', 248680),
(386538, 'PTHR11802:SF442', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386539, 'PTHR11802:SF201', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386540, 'PTHR11802:SF322', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386541, 'PTHR11802:SF203', NULL, NULL, NULL, NULL, 'OS04G0176400 PROTEIN', 248680),
(386542, 'PTHR11802:SF204', NULL, NULL, NULL, NULL, 'OS11G0460800 PROTEIN', 248680),
(386543, 'PTHR11802:SF446', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 49', 248680),
(386544, 'PTHR11802:SF447', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386545, 'PTHR11802:SF448', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386546, 'PTHR11802:SF327', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386547, 'PTHR11802:SF449', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386548, 'PTHR11802:SF328', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386549, 'PTHR11802:SF329', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 17', 248680),
(386550, 'PTHR11802:SF450', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 7', 248680),
(386551, 'PTHR11802:SF330', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386552, 'PTHR11802:SF451', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386553, 'PTHR11802:SF452', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386554, 'PTHR11802:SF453', NULL, NULL, NULL, NULL, 'S1, PUTATIVE-RELATED', 248680),
(386555, 'PTHR11802:SF454', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 50', 248680),
(386556, 'PTHR11802:SF334', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 21', 248680),
(386557, 'PTHR11802:SF455', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 7', 248680),
(386558, 'PTHR11802:SF335', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 17', 248680);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(386559, 'PTHR11802:SF456', NULL, NULL, NULL, NULL, 'PEPTIDASE S10, SERINE CARBOXYPEPTIDASE, ALPHA/BETA HYDROLASE FOLD PROTEIN-RELATED', 248680),
(386560, 'PTHR11802:SF457', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 1-RELATED', 248680),
(386561, 'PTHR11802:SF458', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386562, 'PTHR11802:SF217', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386563, 'PTHR11802:SF459', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE 1', 248680),
(386564, 'PTHR11802:SF339', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386565, 'PTHR11802:SF219', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386566, 'PTHR11802:SF300', NULL, NULL, NULL, NULL, '', 248680),
(386567, 'PTHR11802:SF421', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386568, 'PTHR11802:SF301', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 18', 248680),
(386569, 'PTHR11802:SF423', NULL, NULL, NULL, NULL, 'BNAC09G47010D PROTEIN', 248680),
(386570, 'PTHR11802:SF303', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE 1', 248680),
(386571, 'PTHR11802:SF426', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386572, 'PTHR11802:SF305', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386573, 'PTHR11802:SF427', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE CTSA-4.1', 248680),
(386574, 'PTHR11802:SF306', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 28', 248680),
(386575, 'PTHR11802:SF307', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 47', 248680),
(386576, 'PTHR11802:SF308', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386577, 'PTHR11802:SF310', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 18', 248680),
(386578, 'PTHR11802:SF432', NULL, NULL, NULL, NULL, 'Y, PUTATIVE-RELATED', 248680),
(386579, 'PTHR11802:SF311', NULL, NULL, NULL, NULL, '1-O-ACYLGLUCOSE:ANTHOCYANIN-O-ACYLTRANSFERASE', 248680),
(386580, 'PTHR11802:SF434', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386581, 'PTHR11802:SF313', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE', 248680),
(386582, 'PTHR11802:SF314', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386583, 'PTHR11802:SF435', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 45', 248680),
(386584, 'PTHR11802:SF316', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 14-RELATED', 248680),
(386585, 'PTHR11802:SF438', NULL, NULL, NULL, NULL, 'PEPTIDASE S10, SERINE CARBOXYPEPTIDASE, ALPHA/BETA HYDROLASE FOLD PROTEIN-RELATED', 248680),
(386586, 'PTHR11802:SF318', NULL, NULL, NULL, NULL, 'PEPTIDASE S10, SERINE CARBOXYPEPTIDASE, ALPHA/BETA HYDROLASE FOLD PROTEIN-RELATED', 248680),
(386587, 'PTHR11802:SF319', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386588, 'PTHR11802:SF400', NULL, NULL, NULL, NULL, '', 248680),
(386589, 'PTHR11802:SF401', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386590, 'PTHR11802:SF404', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386591, 'PTHR11802:SF405', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386592, 'PTHR11802:SF408', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386593, 'PTHR11802:SF413', NULL, NULL, NULL, NULL, 'PEPTIDASE S10, SERINE CARBOXYPEPTIDASE, ALPHA/BETA HYDROLASE-RELATED', 248680),
(386594, 'PTHR11802:SF418', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE CTSA-1.1', 248680),
(386595, 'PTHR11802:SF87', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 25', 248680),
(386596, 'PTHR11802:SF189', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386597, 'PTHR11802:SF98', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386598, 'PTHR11802:SF190', NULL, NULL, NULL, NULL, 'PHEROMONE-PROCESSING CARBOXYPEPTIDASE KEX1', 248680),
(386599, 'PTHR11802:SF196', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 10-RELATED', 248680),
(386600, 'PTHR11802:SF198', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 27', 248680),
(386601, 'PTHR11802:SF65', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386602, 'PTHR11802:SF280', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 35', 248680);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(386603, 'PTHR11802:SF281', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386604, 'PTHR11802:SF286', NULL, NULL, NULL, NULL, '1-O-ACYLGLUCOSE:ANTHOCYANIN ACYLTRANSFERASE', 248680),
(386605, 'PTHR11802:SF75', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386606, 'PTHR11802:SF70', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE CTSA-3.1', 248680),
(386607, 'PTHR11802:SF78', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386608, 'PTHR11802:SF290', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386609, 'PTHR11802:SF294', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386610, 'PTHR11802:SF295', NULL, NULL, NULL, NULL, 'BNAC05G23740D PROTEIN', 248680),
(386611, 'PTHR11802:SF296', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386612, 'PTHR11802:SF297', NULL, NULL, NULL, NULL, 'OS06G0520000 PROTEIN', 248680),
(386613, 'PTHR11802:SF298', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 22-RELATED', 248680),
(386614, 'PTHR11802:SF83', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386615, 'PTHR11802:SF46', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386616, 'PTHR11802:SF380', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386617, 'PTHR11802:SF381', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386618, 'PTHR11802:SF260', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 19', 248680),
(386619, 'PTHR11802:SF382', NULL, NULL, NULL, NULL, 'PEPTIDASE S10, SERINE CARBOXYPEPTIDASE, ALPHA/BETA HYDROLASE FOLD PROTEIN-RELATED', 248680),
(386620, 'PTHR11802:SF385', NULL, NULL, NULL, NULL, 'PEPTIDASE S10, SERINE CARBOXYPEPTIDASE, ALPHA/BETA HYDROLASE FOLD PROTEIN-RELATED', 248680),
(386621, 'PTHR11802:SF268', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386622, 'PTHR11802:SF389', NULL, NULL, NULL, NULL, '1-O-ACYLGLUCOSE:ANTHOCYANIN-O-ACYLTRANSFERASE', 248680),
(386623, 'PTHR11802:SF51', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE YBR139W-RELATED', 248680),
(386624, 'PTHR11802:SF53', NULL, NULL, NULL, NULL, 'OS10G0101200 PROTEIN', 248680),
(386625, 'PTHR11802:SF58', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386626, 'PTHR11802:SF59', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386627, 'PTHR11802:SF55', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386628, 'PTHR11802:SF393', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386629, 'PTHR11802:SF272', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386630, 'PTHR11802:SF394', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386631, 'PTHR11802:SF395', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386632, 'PTHR11802:SF397', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386633, 'PTHR11802:SF399', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386634, 'PTHR11802:SF278', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 248680),
(386635, 'PTHR11802:SF279', NULL, NULL, NULL, NULL, 'SERINE CARBOXYPEPTIDASE-LIKE 46', 248680),
(386636, 'PTHR11802:SF64', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE 2-RELATED', 248680),
(386637, 'PTHR11802:SF3', NULL, NULL, NULL, NULL, 'RETINOID-INDUCIBLE SERINE CARBOXYPEPTIDASE', 248680),
(386638, 'PTHR11802:SF60', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE', 248680),
(386639, 'PTHR38490', NULL, NULL, NULL, NULL, 'CYSTEINE AND TYROSINE-RICH PROTEIN 1', 248681),
(386640, 'PTHR38490:SF1', NULL, NULL, NULL, NULL, 'CYSTEINE AND TYROSINE-RICH PROTEIN 1', 248681),
(386641, 'PTHR28013:SF6', NULL, NULL, NULL, NULL, 'MEIOTICALLY UP-REGULATED GENE 33 PROTEIN', 248682),
(386642, 'PTHR28013', NULL, NULL, NULL, NULL, 'PROTEIN DCV1-RELATED', 248682),
(386643, 'PTHR28013:SF5', NULL, NULL, NULL, NULL, 'MEMBRANE-ANCHORED PROTEIN 1', 248682),
(386644, 'PTHR28013:SF4', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 248682),
(386645, 'PTHR28013:SF3', NULL, NULL, NULL, NULL, 'PROTEIN DCV1-RELATED', 248682),
(386646, 'PTHR38115:SF1', NULL, NULL, NULL, NULL, '', 248683),
(386647, 'PTHR38115', NULL, NULL, NULL, NULL, '', 248683),
(386648, 'PTHR41400:SF1', NULL, NULL, NULL, NULL, 'MGC152344 PROTEIN', 248684);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(386649, 'PTHR41400', NULL, NULL, NULL, NULL, 'MGC152344 PROTEIN', 248684),
(386650, 'PTHR22603', NULL, NULL, NULL, NULL, 'CHOLINE/ETHANOALAMINE KINASE', 248685),
(386651, 'PTHR22603:SF35', NULL, NULL, NULL, NULL, 'CHOLINE/ETHANOLAMINE KINASE', 248685),
(386652, 'PTHR22603:SF68', NULL, NULL, NULL, NULL, '', 248685),
(386653, 'PTHR22603:SF36', NULL, NULL, NULL, NULL, 'CHOLINE KINASE ALPHA', 248685),
(386654, 'PTHR22603:SF25', NULL, NULL, NULL, NULL, 'CHOLINE KINASE B1-RELATED', 248685),
(386655, 'PTHR22603:SF26', NULL, NULL, NULL, NULL, 'CHOLINE KINASE B3-RELATED', 248685),
(386656, 'PTHR22603:SF97', NULL, NULL, NULL, NULL, 'CHOLINE/ETHANOLAMINE KINASE', 248685),
(386657, 'PTHR22603:SF75', NULL, NULL, NULL, NULL, 'CHOLINE KINASE 3-RELATED', 248685),
(386658, 'PTHR22603:SF98', NULL, NULL, NULL, NULL, 'CHOLINE KINASE A2', 248685),
(386659, 'PTHR22603:SF66', NULL, NULL, NULL, NULL, 'ETHANOLAMINE KINASE', 248685),
(386660, 'PTHR22603:SF99', NULL, NULL, NULL, NULL, 'RE24176P', 248685),
(386661, 'PTHR22603:SF93', NULL, NULL, NULL, NULL, 'CHOLINE KINASE 1-RELATED', 248685),
(386662, 'PTHR22603:SF94', NULL, NULL, NULL, NULL, 'ETHANOLAMINE KINASE 2', 248685),
(386663, 'PTHR22603:SF95', NULL, NULL, NULL, NULL, 'ETHANOLAMINE KINASE B-RELATED', 248685),
(386664, 'PTHR22603:SF74', NULL, NULL, NULL, NULL, 'OS01G0183000 PROTEIN', 248685),
(386665, 'PTHR22603:SF96', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 248685),
(386666, 'PTHR22603:SF30', NULL, NULL, NULL, NULL, 'CHOLINE KINASE B', 248685),
(386667, 'PTHR22603:SF90', NULL, NULL, NULL, NULL, 'OS05G0535400 PROTEIN', 248685),
(386668, 'PTHR22603:SF80', NULL, NULL, NULL, NULL, 'BNAC06G07990D PROTEIN', 248685),
(386669, 'PTHR22603:SF91', NULL, NULL, NULL, NULL, 'ETHANOLAMINE KINASE 1', 248685),
(386670, 'PTHR22603:SF81', NULL, NULL, NULL, NULL, 'CHOLINE KINASE 2-RELATED', 248685),
(386671, 'PTHR19288:SF75', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCOLATE PHOSPHATASE 2', 248686),
(386672, 'PTHR19288:SF94', NULL, NULL, NULL, NULL, 'CHRONOPHIN', 248686),
(386673, 'PTHR19288:SF83', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCOLATE PHOSPHATASE HOMOLOG', 248686),
(386674, 'PTHR19288:SF93', NULL, NULL, NULL, NULL, 'FI11325P-RELATED', 248686),
(386675, 'PTHR19288:SF92', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE PHOSPHATASE', 248686),
(386676, 'PTHR19288:SF91', NULL, NULL, NULL, NULL, 'NITROPHENYL PHOSPHATASE', 248686),
(386677, 'PTHR19288:SF90', NULL, NULL, NULL, NULL, 'OS08G0542600 PROTEIN', 248686),
(386678, 'PTHR19288:SF4', NULL, NULL, NULL, NULL, 'RE04130P-RELATED', 248686),
(386679, 'PTHR19288:SF25', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLGLYCEROPHOSPHATASE GEP4, MITOCHONDRIAL', 248686),
(386680, 'PTHR19288', NULL, NULL, NULL, NULL, '4-NITROPHENYLPHOSPHATASE-RELATED', 248686),
(386681, 'PTHR19288:SF46', NULL, NULL, NULL, NULL, 'HALOACID DEHALOGENASE-LIKE HYDROLASE DOMAIN-CONTAINING PROTEIN 2', 248686),
(386682, 'PTHR19288:SF89', NULL, NULL, NULL, NULL, '', 248686),
(386683, 'PTHR19288:SF44', NULL, NULL, NULL, NULL, 'PHOSPHOLYSINE PHOSPHOHISTIDINE INORGANIC PYROPHOSPHATE PHOSPHATASE', 248686),
(386684, 'PTHR19288:SF88', NULL, NULL, NULL, NULL, 'HALOACID DEHALOGENASE SUPERFAMILY PROTEIN', 248686),
(386685, 'PTHR35285:SF1', NULL, NULL, NULL, NULL, '2-C-METHYL-D-ERYTHRITOL 4-PHOSPHATE CYTIDYLYLTRANSFERASE', 248687),
(386686, 'PTHR35285', NULL, NULL, NULL, NULL, '2-C-METHYL-D-ERYTHRITOL 4-PHOSPHATE CYTIDYLYLTRANSFERASE', 248687),
(386687, 'PTHR35285:SF2', NULL, NULL, NULL, NULL, 'BNAC01G44830D PROTEIN', 248687),
(386688, 'PTHR36215:SF1', NULL, NULL, NULL, NULL, 'BLL4998 PROTEIN', 248688),
(386689, 'PTHR36215', NULL, NULL, NULL, NULL, 'BLL4998 PROTEIN', 248688),
(386690, 'PTHR11630:SF105', NULL, NULL, NULL, NULL, 'DNA REPLICATION LICENSING FACTOR MCM7', 248689),
(386691, 'PTHR11630:SF46', NULL, NULL, NULL, NULL, 'DNA REPLICATION LICENSING FACTOR MCM3', 248689),
(386692, 'PTHR11630:SF47', NULL, NULL, NULL, NULL, 'DNA HELICASE MCM8', 248689),
(386693, 'PTHR11630:SF66', NULL, NULL, NULL, NULL, 'DNA REPLICATION LICENSING FACTOR MCM4', 248689),
(386694, 'PTHR11630:SF44', NULL, NULL, NULL, NULL, 'DNA REPLICATION LICENSING FACTOR MCM2', 248689);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(386695, 'PTHR11630:SF103', NULL, NULL, NULL, NULL, 'DNA HELICASE', 248689),
(386696, 'PTHR11630:SF104', NULL, NULL, NULL, NULL, 'DNA HELICASE', 248689),
(386697, 'PTHR11630:SF101', NULL, NULL, NULL, NULL, 'DNA REPLICATION LICENSING FACTOR MCM2', 248689),
(386698, 'PTHR11630:SF102', NULL, NULL, NULL, NULL, 'DNA HELICASE', 248689),
(386699, 'PTHR11630:SF48', NULL, NULL, NULL, NULL, 'DNA HELICASE MCM9', 248689),
(386700, 'PTHR11630:SF26', NULL, NULL, NULL, NULL, 'DNA REPLICATION LICENSING FACTOR MCM7', 248689),
(386701, 'PTHR11630:SF100', NULL, NULL, NULL, NULL, 'BNAA02G22770D PROTEIN', 248689),
(386702, 'PTHR11630:SF93', NULL, NULL, NULL, NULL, 'DNA HELICASE', 248689),
(386703, 'PTHR11630:SF71', NULL, NULL, NULL, NULL, 'DNA HELICASE', 248689),
(386704, 'PTHR11630:SF42', NULL, NULL, NULL, NULL, 'DNA REPLICATION LICENSING FACTOR MCM5', 248689),
(386705, 'PTHR11630:SF75', NULL, NULL, NULL, NULL, 'MINICHROMOSOME MAINTENANCE DOMAIN-CONTAINING PROTEIN 2', 248689),
(386706, 'PTHR11630:SF43', NULL, NULL, NULL, NULL, 'DNA REPLICATION LICENSING FACTOR MCM6', 248689),
(386707, 'PTHR11630:SF73', NULL, NULL, NULL, NULL, 'DNA REPLICATION LICENSING FACTOR MCM6', 248689),
(386708, 'PTHR11630', NULL, NULL, NULL, NULL, 'DNA REPLICATION LICENSING FACTOR MCM FAMILY MEMBER', 248689),
(386709, 'PTHR31909:SF2', NULL, NULL, NULL, NULL, 'RIKEN CDNA 2410004P03 GENE', 248690),
(386710, 'PTHR31909:SF3', NULL, NULL, NULL, NULL, 'RCG40914', 248690),
(386711, 'PTHR31909', NULL, NULL, NULL, NULL, 'CHROMOSOME 20 ORF85 FAMILY MEMBER', 248690),
(386712, 'PTHR43866:SF1', NULL, NULL, NULL, NULL, 'METHYLMALONATE-SEMIALDEHYDE DEHYDROGENASE (COA ACYLATING)', 248691),
(386713, 'PTHR43866', NULL, NULL, NULL, NULL, 'MALONATE-SEMIALDEHYDE DEHYDROGENASE', 248691),
(386714, 'PTHR43866:SF10', NULL, NULL, NULL, NULL, 'METHYLMALONATE-SEMIALDEHYDE DEHYDROGENASE (COA ACYLATING)', 248691),
(386715, 'PTHR43866:SF9', NULL, NULL, NULL, NULL, 'METHYLMALONATE-SEMIALDEHYDE DEHYDROGENASE (COA ACYLATING)', 248691),
(386716, 'PTHR43866:SF6', NULL, NULL, NULL, NULL, 'METHYLMALONATE-SEMIALDEHYDE DEHYDROGENASE (COA ACYLATING)', 248691),
(386717, 'PTHR43866:SF4', NULL, NULL, NULL, NULL, 'MALONATE-SEMIALDEHYDE DEHYDROGENASE', 248691),
(386718, 'PTHR43866:SF3', NULL, NULL, NULL, NULL, 'METHYLMALONATE-SEMIALDEHYDE DEHYDROGENASE [ACYLATING], MITOCHONDRIAL', 248691),
(386719, 'PTHR47619', NULL, NULL, NULL, NULL, 'METALLO-HYDROLASE YYCJ-RELATED', 248692),
(386720, 'PTHR47619:SF1', NULL, NULL, NULL, NULL, 'METALLO-HYDROLASE YYCJ-RELATED', 248692),
(386721, 'PTHR15967', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248693),
(386722, 'PTHR15967:SF0', NULL, NULL, NULL, NULL, 'E2F-ASSOCIATED PHOSPHOPROTEIN', 248693),
(386723, 'PTHR12856:SF1', NULL, NULL, NULL, NULL, '', 248694),
(386724, 'PTHR12856:SF0', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR IIH SUBUNIT 1', 248694),
(386725, 'PTHR12856', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIH-RELATED', 248694),
(386726, 'PTHR46805', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN J1', 248695),
(386727, 'PTHR46805:SF2', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN J1-A', 248695),
(386728, 'PTHR46805:SF3', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN J1-B', 248695),
(386729, 'PTHR46805:SF1', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN J1', 248695),
(386730, 'PTHR33495:SF2', NULL, NULL, NULL, NULL, 'ANTI-SIGMA FACTOR ANTAGONIST TM_1081-RELATED', 248696),
(386731, 'PTHR33495', NULL, NULL, NULL, NULL, 'ANTI-SIGMA FACTOR ANTAGONIST TM_1081-RELATED-RELATED', 248696),
(386732, 'PTHR33495:SF6', NULL, NULL, NULL, NULL, 'ANTI-SIGMA FACTOR ANTAGONIST', 248696),
(386733, 'PTHR33495:SF13', NULL, NULL, NULL, NULL, 'ANTI-SIGMA-F FACTOR ANTAGONIST RSFB', 248696),
(386734, 'PTHR33495:SF9', NULL, NULL, NULL, NULL, 'ANTI-SIGMA-B FACTOR ANTAGONIST', 248696),
(386735, 'PTHR34605:SF4', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE', 248697),
(386736, 'PTHR34605:SF3', NULL, NULL, NULL, NULL, 'TYR RECOMBINASE DOMAIN-CONTAINING PROTEIN', 248697),
(386737, 'PTHR34605', NULL, NULL, NULL, NULL, 'PHAGE_INTEGRASE DOMAIN-CONTAINING PROTEIN', 248697);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(386738, 'PTHR18841', NULL, NULL, NULL, NULL, 'VITELLINE MEMBRANE OUTER LAYER PROTEIN I-RELATED', 248698),
(386739, 'PTHR18841:SF1', NULL, NULL, NULL, NULL, '', 248698),
(386740, 'PTHR18841:SF2', NULL, NULL, NULL, NULL, 'VITELLINE MEMBRANE OUTER LAYER PROTEIN 1 HOMOLOG', 248698),
(386741, 'PTHR18841:SF0', NULL, NULL, NULL, NULL, 'VITELLINE MEMBRANE OUTER LAYER 1 HOMOLOG A-RELATED', 248698),
(386742, 'PTHR16131', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248699),
(386743, 'PTHR16131:SF2', NULL, NULL, NULL, NULL, 'LIGAND-DEPENDENT NUCLEAR RECEPTOR-INTERACTING FACTOR 1', 248699),
(386744, 'PTHR28009', NULL, NULL, NULL, NULL, 'PHEROMONE ALPHA FACTOR RECEPTOR', 248700),
(386745, 'PTHR28009:SF1', NULL, NULL, NULL, NULL, 'PHEROMONE ALPHA FACTOR RECEPTOR', 248700),
(386746, 'PTHR47718:SF1', NULL, NULL, NULL, NULL, 'OS01G0519700 PROTEIN', 248701),
(386747, 'PTHR47718', NULL, NULL, NULL, NULL, 'OS01G0519700 PROTEIN', 248701),
(386748, 'PTHR34285:SF11', NULL, NULL, NULL, NULL, 'OS08G0510800 PROTEIN', 248702),
(386749, 'PTHR34285:SF10', NULL, NULL, NULL, NULL, '', 248702),
(386750, 'PTHR34285:SF3', NULL, NULL, NULL, NULL, 'OS09G0491676 PROTEIN', 248702),
(386751, 'PTHR34285:SF6', NULL, NULL, NULL, NULL, '', 248702),
(386752, 'PTHR34285:SF8', NULL, NULL, NULL, NULL, 'OS09G0278700 PROTEIN', 248702),
(386753, 'PTHR34285', NULL, NULL, NULL, NULL, 'OS08G0510800 PROTEIN', 248702),
(386754, 'PTHR31322:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TM129', 248703),
(386755, 'PTHR31322', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TM129', 248703),
(386756, 'PTHR28579:SF1', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT CDC26', 248704),
(386757, 'PTHR28579', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT CDC26', 248704),
(386758, 'PTHR43084:SF8', NULL, NULL, NULL, NULL, 'METALLO-BETA-LACTAMASE SUPERFAMILY PROTEIN', 248705),
(386759, 'PTHR43084:SF7', NULL, NULL, NULL, NULL, 'BETA-LACTAMASE DOMAIN PROTEIN', 248705),
(386760, 'PTHR43084:SF10', NULL, NULL, NULL, NULL, 'LACTAMASE_B DOMAIN-CONTAINING PROTEIN', 248705),
(386761, 'PTHR43084', NULL, NULL, NULL, NULL, 'PERSULFIDE DIOXYGENASE ETHE1', 248705),
(386762, 'PTHR43084:SF1', NULL, NULL, NULL, NULL, 'PERSULFIDE DIOXYGENASE ETHE1, MITOCHONDRIAL', 248705),
(386763, 'PTHR14247:SF11', NULL, NULL, NULL, NULL, 'SH2 DOMAIN-CONTAINING PROTEIN 3A', 248706),
(386764, 'PTHR14247:SF10', NULL, NULL, NULL, NULL, 'BREAST CANCER ANTI-ESTROGEN RESISTANCE PROTEIN 3', 248706),
(386765, 'PTHR14247', NULL, NULL, NULL, NULL, 'BREAST CANCER ANTI-ESTROGEN RESISTANCE PROTEIN 3 HOMOLOG-LIKE PROTEIN', 248706),
(386766, 'PTHR14247:SF6', NULL, NULL, NULL, NULL, 'SH2 DOMAIN-CONTAINING PROTEIN 3C', 248706),
(386767, 'PTHR14247:SF8', NULL, NULL, NULL, NULL, 'RAS-GEF DOMAIN-CONTAINING PROTEIN', 248706),
(386768, 'PTHR47179:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SIS3', 248707),
(386769, 'PTHR47179', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SIS3', 248707),
(386770, 'PTHR47179:SF5', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 248707),
(386771, 'PTHR47179:SF6', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 248707),
(386772, 'PTHR47179:SF3', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SIS3-LIKE ISOFORM X1', 248707),
(386773, 'PTHR47179:SF4', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 248707),
(386774, 'PTHR21405:SF0', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 36', 248708),
(386775, 'PTHR21405', NULL, NULL, NULL, NULL, 'CDNA SEQUENCE BC021608', 248708),
(386776, 'PTHR32089:SF117', NULL, NULL, NULL, NULL, 'METHYL ACCEPTING SENSORY TRANSDUCER WITH CACHE_1 SMALL MOLECULE BINDING DOMAIN', 248709),
(386777, 'PTHR32089:SF118', NULL, NULL, NULL, NULL, 'HEME-BASED AEROTACTIC TRANSDUCER HEMAT', 248709),
(386778, 'PTHR32089:SF112', NULL, NULL, NULL, NULL, 'METHYL-ACCEPTING CHEMOTAXIS PROTEIN CTPH', 248709),
(386779, 'PTHR32089:SF114', NULL, NULL, NULL, NULL, 'METHYL-ACCEPTING CHEMOTAXIS PROTEIN MCPB', 248709),
(386780, 'PTHR32089:SF94', NULL, NULL, NULL, NULL, 'CHEMOTAXIS SIGNAL TRANSDUCTION SYSTEM METHYL ACCEPTING SENSORY TRANSDUCER WITH PAS SENSORY DOMAIN', 248709);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(386781, 'PTHR32089:SF41', NULL, NULL, NULL, NULL, 'METHYL-ACCEPTING CHEMOTAXIS PROTEIN', 248709),
(386782, 'PTHR32089:SF74', NULL, NULL, NULL, NULL, 'AEROTAXIS RECEPTOR AER', 248709),
(386783, 'PTHR32089:SF52', NULL, NULL, NULL, NULL, 'CHEMOTAXIS SIGNAL TRANSDUCTION SYSTEM METHYL ACCEPTING SENSORY TRANSDUCER WITH PAS SENSORY DOMAIN', 248709),
(386784, 'PTHR32089:SF119', NULL, NULL, NULL, NULL, 'METHYL-ACCEPTING CHEMOTAXIS PROTEIN PA2652', 248709),
(386785, 'PTHR32089:SF70', NULL, NULL, NULL, NULL, 'ENERGY TAXIS MODULATING METHYL ACCEPTING SENSORY TRANSDUCER', 248709),
(386786, 'PTHR32089:SF92', NULL, NULL, NULL, NULL, 'LYSOZYME-LIKE PROTEIN-RELATED', 248709),
(386787, 'PTHR32089:SF39', NULL, NULL, NULL, NULL, 'METHYL-ACCEPTING CHEMOTAXIS PROTEIN HLYB', 248709),
(386788, 'PTHR32089:SF33', NULL, NULL, NULL, NULL, 'TOXIN COREGULATED PILUS BIOSYNTHESIS PROTEIN I', 248709),
(386789, 'PTHR32089:SF55', NULL, NULL, NULL, NULL, 'METHYL ACCEPTING SENSORY TRANSDUCER WITH CACHE_2 SMALL MOLECULE BINDING DOMAIN', 248709),
(386790, 'PTHR32089:SF65', NULL, NULL, NULL, NULL, 'CHEMOTAXIS SIGNAL TRANSDUCTION SYSTEM METHYL ACCEPTING SENSORY TRANSDUCER', 248709),
(386791, 'PTHR32089', NULL, NULL, NULL, NULL, 'METHYL-ACCEPTING CHEMOTAXIS PROTEIN MCPB', 248709),
(386792, 'PTHR36049:SF3', NULL, NULL, NULL, NULL, '', 248710),
(386793, 'PTHR36049:SF4', NULL, NULL, NULL, NULL, 'BNAA01G17430D PROTEIN', 248710),
(386794, 'PTHR36049', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 248710),
(386795, 'PTHR15492:SF2', NULL, NULL, NULL, NULL, 'CYCLIN-D1-BINDING PROTEIN', 248711),
(386796, 'PTHR15492:SF3', NULL, NULL, NULL, NULL, 'CYCLIN-D1-BINDING PROTEIN 1', 248711),
(386797, 'PTHR15492:SF4', NULL, NULL, NULL, NULL, 'CYCLIN-D1-BINDING PROTEIN 1', 248711),
(386798, 'PTHR15492', NULL, NULL, NULL, NULL, 'CYCLIN D1-BINDING PROTEIN 1', 248711),
(386799, 'PTHR15492:SF1', NULL, NULL, NULL, NULL, 'CYCLIN-D1-BINDING PROTEIN 1', 248711),
(386800, 'PTHR42806', NULL, NULL, NULL, NULL, 'GLYCINE CLEAVAGE SYSTEM P-PROTEIN', 248712),
(386801, 'PTHR42806:SF1', NULL, NULL, NULL, NULL, 'GLYCINE DEHYDROGENASE (DECARBOXYLATING)', 248712),
(386802, 'PTHR14343:SF3', NULL, NULL, NULL, NULL, 'DUF4537 DOMAIN-CONTAINING PROTEIN', 248713),
(386803, 'PTHR14343', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 248713),
(386804, 'PTHR36378:SF3', NULL, NULL, NULL, NULL, '', 248714),
(386805, 'PTHR36378:SF2', NULL, NULL, NULL, NULL, 'COTTON FIBER PROTEIN', 248714),
(386806, 'PTHR36378:SF1', NULL, NULL, NULL, NULL, 'COTTON FIBER PROTEIN', 248714),
(386807, 'PTHR36378', NULL, NULL, NULL, NULL, 'COTTON FIBER PROTEIN', 248714),
(386808, 'PTHR16915', NULL, NULL, NULL, NULL, 'IMMEDIATE EARLY RESPONSE 3', 248715),
(386809, 'PTHR16915:SF0', NULL, NULL, NULL, NULL, 'RADIATION-INDUCIBLE IMMEDIATE-EARLY GENE IEX-1', 248715),
(386810, 'PTHR12268:SF19', NULL, NULL, NULL, NULL, 'DYSTROBREVIN ALPHA', 248716),
(386811, 'PTHR12268:SF21', NULL, NULL, NULL, NULL, 'DISCONTINUOUS ACTIN HEXAGON', 248716),
(386812, 'PTHR12268:SF25', NULL, NULL, NULL, NULL, 'DYSTROPHIN', 248716),
(386813, 'PTHR12268:SF14', NULL, NULL, NULL, NULL, 'DYSTROPHIN-1', 248716),
(386814, 'PTHR12268', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE KCMF1', 248716),
(386815, 'PTHR12268:SF13', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE KCMF1', 248716),
(386816, 'PTHR12268:SF22', NULL, NULL, NULL, NULL, 'DYSTROBREVIN BETA', 248716),
(386817, 'PTHR12268:SF18', NULL, NULL, NULL, NULL, 'DYSTROTELIN', 248716),
(386818, 'PTHR12268:SF16', NULL, NULL, NULL, NULL, 'DYSTROPHIN-RELATED PROTEIN 2', 248716),
(386819, 'PTHR12268:SF27', NULL, NULL, NULL, NULL, 'DYSTROBREVIN, ISOFORM F', 248716),
(386820, 'PTHR12268:SF26', NULL, NULL, NULL, NULL, 'UTROPHIN', 248716),
(386821, 'PTHR47159:SF6', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 248717),
(386822, 'PTHR47159:SF5', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 248717),
(386823, 'PTHR47159:SF2', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 248717),
(386824, 'PTHR47159:SF1', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN F28H7.8', 248717);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(386825, 'PTHR47159:SF4', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 248717),
(386826, 'PTHR47159:SF3', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 248717),
(386827, 'PTHR47159', NULL, NULL, NULL, NULL, 'PROTEIN CBG07705-RELATED', 248717),
(386828, 'PTHR13718:SF114', NULL, NULL, NULL, NULL, 'S5 DRBM DOMAIN-CONTAINING PROTEIN', 248718),
(386829, 'PTHR13718:SF102', NULL, NULL, NULL, NULL, 'S5 DRBM DOMAIN-CONTAINING PROTEIN', 248718),
(386830, 'PTHR13718:SF105', NULL, NULL, NULL, NULL, 'S5 DRBM DOMAIN-CONTAINING PROTEIN', 248718),
(386831, 'PTHR13718:SF116', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S2', 248718),
(386832, 'PTHR13718:SF115', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S2-1-RELATED', 248718),
(386833, 'PTHR13718:SF110', NULL, NULL, NULL, NULL, 'OS02G0102400 PROTEIN', 248718),
(386834, 'PTHR13718:SF101', NULL, NULL, NULL, NULL, 'S5 DRBM DOMAIN-CONTAINING PROTEIN', 248718),
(386835, 'PTHR13718:SF111', NULL, NULL, NULL, NULL, 'S5 DRBM DOMAIN-CONTAINING PROTEIN', 248718),
(386836, 'PTHR13718:SF107', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S2', 248718),
(386837, 'PTHR13718:SF117', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S2', 248718),
(386838, 'PTHR13718:SF88', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S2-1', 248718),
(386839, 'PTHR13718', NULL, NULL, NULL, NULL, 'RIBOSOMAL S SUBUNIT', 248718),
(386840, 'PTHR13718:SF61', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S5, MITOCHONDRIAL', 248718),
(386841, 'PTHR13718:SF93', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S2', 248718),
(386842, 'PTHR13718:SF92', NULL, NULL, NULL, NULL, 'RIBOSOMAL_S5_C DOMAIN-CONTAINING PROTEIN', 248718),
(386843, 'PTHR13718:SF90', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S5, MITOCHONDRIAL', 248718),
(386844, 'PTHR13718:SF4', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S2', 248718),
(386845, 'PTHR35473:SF3', NULL, NULL, NULL, NULL, '1-ACYL-SN-GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE', 248719),
(386846, 'PTHR35473', NULL, NULL, NULL, NULL, '1-ACYL-SN-GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE', 248719),
(386847, 'PTHR22850:SF201', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 248720),
(386848, 'PTHR22850:SF104', NULL, NULL, NULL, NULL, 'CHROMATIN ASSEMBLY FACTOR 1 SUBUNIT P50', 248720),
(386849, 'PTHR22850:SF82', NULL, NULL, NULL, NULL, 'HISTONE-BINDING PROTEIN RBBP7', 248720),
(386850, 'PTHR22850:SF203', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 248720),
(386851, 'PTHR22850:SF204', NULL, NULL, NULL, NULL, 'WD-40 REPEAT-CONTAINING PROTEIN MSI5', 248720),
(386852, 'PTHR22850:SF27', NULL, NULL, NULL, NULL, 'WD-40 REPEAT-CONTAINING PROTEIN MSI4', 248720),
(386853, 'PTHR22850', NULL, NULL, NULL, NULL, 'WD40 REPEAT FAMILY', 248720),
(386854, 'PTHR22850:SF206', NULL, NULL, NULL, NULL, 'BNAANNG11080D PROTEIN', 248720),
(386855, 'PTHR22850:SF90', NULL, NULL, NULL, NULL, 'HISTONE-BINDING PROTEIN RBBP4', 248720),
(386856, 'PTHR22850:SF207', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 248720),
(386857, 'PTHR22850:SF208', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 248720),
(386858, 'PTHR22850:SF209', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 248720),
(386859, 'PTHR22850:SF199', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL MODULATOR WTM1-RELATED', 248720),
(386860, 'PTHR22850:SF133', NULL, NULL, NULL, NULL, 'HISTONE-BINDING PROTEIN RBA-1-RELATED', 248720),
(386861, 'PTHR22850:SF211', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 248720),
(386862, 'PTHR22850:SF212', NULL, NULL, NULL, NULL, 'HISTONE-BINDING PROTEIN RBBP4-RELATED', 248720),
(386863, 'PTHR22850:SF214', NULL, NULL, NULL, NULL, 'CHROMATIN ASSEMBLY FACTOR 1 P55 SUBUNIT', 248720),
(386864, 'PTHR22850:SF215', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 248720),
(386865, 'PTHR22850:SF216', NULL, NULL, NULL, NULL, 'RB BINDING PROTEIN 4, CHROMATIN REMODELING FACTOR', 248720),
(386866, 'PTHR22850:SF193', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 248720);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(386867, 'PTHR22850:SF194', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 248720),
(386868, 'PTHR22850:SF196', NULL, NULL, NULL, NULL, 'WD-40 REPEAT-CONTAINING PROTEIN MSI2-RELATED', 248720),
(386869, 'PTHR22850:SF197', NULL, NULL, NULL, NULL, 'CAF1C_H4-BD DOMAIN-CONTAINING PROTEIN', 248720),
(386870, 'PTHR22850:SF217', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 248720),
(386871, 'PTHR22850:SF218', NULL, NULL, NULL, NULL, 'CAF ASSEMBLY FACTOR COMPLEX SUBUNIT C', 248720),
(386872, 'PTHR22850:SF219', NULL, NULL, NULL, NULL, 'RBAP48-RELATED WD40 REPEAT-CONTAINING PROTEIN PRW1', 248720),
(386873, 'PTHR35373:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG04547', 248721),
(386874, 'PTHR35373:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG16894', 248721),
(386875, 'PTHR35373:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG24194', 248721),
(386876, 'PTHR35373:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG02080', 248721),
(386877, 'PTHR35373', NULL, NULL, NULL, NULL, 'PROTEIN CBG16894', 248721),
(386878, 'PTHR15040:SF3', NULL, NULL, NULL, NULL, 'SI:DKEY-14D8.6-RELATED', 248722),
(386879, 'PTHR15040', NULL, NULL, NULL, NULL, 'DERMATOPONTIN-RELATED', 248722),
(386880, 'PTHR15040:SF2', NULL, NULL, NULL, NULL, 'DERMATOPONTIN', 248722),
(386881, 'PTHR15040:SF1', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 248722),
(386882, 'PTHR23531:SF2', NULL, NULL, NULL, NULL, 'PERMEASE-RELATED', 248723),
(386883, 'PTHR23531:SF1', NULL, NULL, NULL, NULL, 'QUINOLENE RESISTANCE PROTEIN NORA', 248723),
(386884, 'PTHR23531', NULL, NULL, NULL, NULL, 'QUINOLENE RESISTANCE PROTEIN NORA', 248723),
(386885, 'PTHR48098', NULL, NULL, NULL, NULL, 'ENTEROCHELIN ESTERASE-RELATED', 248724),
(386886, 'PTHR48098:SF5', NULL, NULL, NULL, NULL, 'FERRI-BACILLIBACTIN ESTERASE BESA', 248724),
(386887, 'PTHR48098:SF1', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL ACYLTRANSFERASE/MYCOLYLTRANSFERASE AG85C', 248724),
(386888, 'PTHR48098:SF3', NULL, NULL, NULL, NULL, 'IRON(III) ENTEROBACTIN ESTERASE', 248724),
(386889, 'PTHR44305', NULL, NULL, NULL, NULL, 'SI:DKEY-192D15.2-RELATED', 248725),
(386890, 'PTHR44305:SF23', NULL, NULL, NULL, NULL, 'ARID DOMAIN-CONTAINING PROTEIN', 248725),
(386891, 'PTHR44305:SF24', NULL, NULL, NULL, NULL, 'SI:DKEY-192D15.2', 248725),
(386892, 'PTHR44305:SF21', NULL, NULL, NULL, NULL, '', 248725),
(386893, 'PTHR44305:SF22', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NRKA', 248725),
(386894, 'PTHR44305:SF20', NULL, NULL, NULL, NULL, 'STE FAMILY PROTEIN KINASE', 248725),
(386895, 'PTHR44305:SF2', NULL, NULL, NULL, NULL, 'EG:8D8.5 PROTEIN', 248725),
(386896, 'PTHR44305:SF19', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 248725),
(386897, 'PTHR14060:SF2', NULL, NULL, NULL, NULL, 'T-CELL LEUKEMIA/LYMPHOMA PROTEIN 1B', 248726),
(386898, 'PTHR14060', NULL, NULL, NULL, NULL, 'PROTEIN P13 MTCP-1', 248726),
(386899, 'PTHR14060:SF4', NULL, NULL, NULL, NULL, 'T-CELL LEUKEMIA/LYMPHOMA PROTEIN 1A', 248726),
(386900, 'PTHR14060:SF8', NULL, NULL, NULL, NULL, 'PROTEIN P13 MTCP-1', 248726),
(386901, 'PTHR39573', NULL, NULL, NULL, NULL, 'STRESS RESPONSE KINASE A', 248727),
(386902, 'PTHR39573:SF1', NULL, NULL, NULL, NULL, 'STRESS RESPONSE KINASE A', 248727),
(386903, 'PTHR34495:SF4', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 248728),
(386904, 'PTHR34495', NULL, NULL, NULL, NULL, 'UNC-51-LIKE AUTOPHAGY-ACTIVATING KINASE 1A', 248728),
(386905, 'PTHR34890:SF2', NULL, NULL, NULL, NULL, '', 248729),
(386906, 'PTHR34890:SF17', NULL, NULL, NULL, NULL, 'PROTEIN TIC 214', 248729),
(386907, 'PTHR34890:SF15', NULL, NULL, NULL, NULL, '', 248729),
(386908, 'PTHR34890:SF18', NULL, NULL, NULL, NULL, '', 248729),
(386909, 'PTHR34890:SF19', NULL, NULL, NULL, NULL, '', 248729),
(386910, 'PTHR34890:SF20', NULL, NULL, NULL, NULL, '', 248729),
(386911, 'PTHR34890:SF9', NULL, NULL, NULL, NULL, '', 248729),
(386912, 'PTHR34890', NULL, NULL, NULL, NULL, '', 248729),
(386913, 'PTHR34890:SF21', NULL, NULL, NULL, NULL, '', 248729),
(386914, 'PTHR34890:SF7', NULL, NULL, NULL, NULL, '', 248729);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(386915, 'PTHR34890:SF11', NULL, NULL, NULL, NULL, '', 248729),
(386916, 'PTHR34890:SF22', NULL, NULL, NULL, NULL, '', 248729),
(386917, 'PTHR30562:SF1', NULL, NULL, NULL, NULL, 'UVRABC SYSTEM PROTEIN C', 248730),
(386918, 'PTHR30562:SF10', NULL, NULL, NULL, NULL, 'EXCINUCLEASE CHO', 248730),
(386919, 'PTHR30562', NULL, NULL, NULL, NULL, 'UVRC/OXIDOREDUCTASE', 248730),
(386920, 'PTHR10515', NULL, NULL, NULL, NULL, 'THYMIDINE PHOSPHORYLASE', 248731),
(386921, 'PTHR10515:SF0', NULL, NULL, NULL, NULL, 'THYMIDINE PHOSPHORYLASE', 248731),
(386922, 'PTHR47255:SF15', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 22-RELATED', 248732),
(386923, 'PTHR47255:SF4', NULL, NULL, NULL, NULL, 'GATA ZINC FINGER DOMAIN-CONTAINING PROTEIN 12', 248732),
(386924, 'PTHR47255:SF5', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 248732),
(386925, 'PTHR47255:SF8', NULL, NULL, NULL, NULL, 'ZINC FINGER, NHR/GATA-TYPE-RELATED', 248732),
(386926, 'PTHR47255', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 22-RELATED', 248732),
(386927, 'PTHR47255:SF12', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 21', 248732),
(386928, 'PTHR47255:SF11', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 248732),
(386929, 'PTHR47255:SF14', NULL, NULL, NULL, NULL, 'PROTEIN CYTOKININ-RESPONSIVE GATA TRANSCRIPTION FACTOR 1', 248732),
(386930, 'PTHR47255:SF13', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 248732),
(386931, 'PTHR19325:SF558', NULL, NULL, NULL, NULL, 'PROTEIN LEV-9', 248733),
(386932, 'PTHR19325', NULL, NULL, NULL, NULL, 'COMPLEMENT COMPONENT-RELATED SUSHI DOMAIN-CONTAINING', 248733),
(386933, 'PTHR19325:SF557', NULL, NULL, NULL, NULL, '', 248733),
(386934, 'PTHR19325:SF534', NULL, NULL, NULL, NULL, 'COMPLEMENT COMPONENT RECEPTOR 1-LIKE PROTEIN', 248733),
(386935, 'PTHR19325:SF556', NULL, NULL, NULL, NULL, 'CUB AND SUSHI MULTIPLE DOMAINS 3', 248733),
(386936, 'PTHR19325:SF555', NULL, NULL, NULL, NULL, 'HIG-ANCHORING SCAFFOLD PROTEIN, ISOFORM G', 248733),
(386937, 'PTHR19325:SF317', NULL, NULL, NULL, NULL, 'COMPLEMENT DECAY-ACCELERATING FACTOR', 248733),
(386938, 'PTHR19325:SF559', NULL, NULL, NULL, NULL, 'SUSHI DOMAIN (SCR REPEAT) DOMAINCONTAINING PROTEIN', 248733),
(386939, 'PTHR19325:SF537', NULL, NULL, NULL, NULL, 'FURROWED, ISOFORM A', 248733),
(386940, 'PTHR19325:SF493', NULL, NULL, NULL, NULL, 'E-SELECTIN', 248733),
(386941, 'PTHR19325:SF554', NULL, NULL, NULL, NULL, 'REGULATOR OF COMPLEMENT ACTIVATION GROUP 2 GENE 1-RELATED', 248733),
(386942, 'PTHR19325:SF553', NULL, NULL, NULL, NULL, 'SUSHI DOMAIN-CONTAINING PROTEIN', 248733),
(386943, 'PTHR19325:SF552', NULL, NULL, NULL, NULL, '', 248733),
(386944, 'PTHR19325:SF497', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN (CTL)', 248733),
(386945, 'PTHR19325:SF551', NULL, NULL, NULL, NULL, 'C4B-BINDING PROTEIN ALPHA CHAIN', 248733),
(386946, 'PTHR19325:SF43', NULL, NULL, NULL, NULL, 'SUSHI, VON WILLEBRAND FACTOR TYPE A, EGF AND PENTRAXIN DOMAIN-CONTAINING PROTEIN 1', 248733),
(386947, 'PTHR19325:SF502', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN H', 248733),
(386948, 'PTHR19325:SF468', NULL, NULL, NULL, NULL, 'MEMBRANE COFACTOR PROTEIN', 248733),
(386949, 'PTHR19325:SF545', NULL, NULL, NULL, NULL, 'COMPLEMENT RECEPTOR TYPE 1', 248733),
(386950, 'PTHR19325:SF544', NULL, NULL, NULL, NULL, 'SELECTIN E', 248733),
(386951, 'PTHR19325:SF549', NULL, NULL, NULL, NULL, 'BETA-2-GLYCOPROTEIN 1', 248733),
(386952, 'PTHR19325:SF561', NULL, NULL, NULL, NULL, 'ZONA PELLUCIDA SPERM-BINDING PROTEIN 3 RECEPTOR', 248733),
(386953, 'PTHR19325:SF484', NULL, NULL, NULL, NULL, 'P-SELECTIN', 248733),
(386954, 'PTHR19325:SF560', NULL, NULL, NULL, NULL, 'SUSHI DOMAIN-CONTAINING PROTEIN', 248733),
(386955, 'PTHR19325:SF543', NULL, NULL, NULL, NULL, 'L-SELECTIN', 248733),
(386956, 'PTHR19325:SF521', NULL, NULL, NULL, NULL, 'MEMBRANE COFACTOR PROTEIN', 248733),
(386957, 'PTHR19325:SF542', NULL, NULL, NULL, NULL, 'MEMBRANE COFACTOR PROTEIN', 248733),
(386958, 'PTHR19325:SF563', NULL, NULL, NULL, NULL, 'LOCOMOTION-RELATED PROTEIN HIKARU GENKI', 248733);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(386959, 'PTHR19325:SF562', NULL, NULL, NULL, NULL, 'SELECTIN P', 248733),
(386960, 'PTHR19325:SF391', NULL, NULL, NULL, NULL, 'COMPLEMENT RECEPTOR TYPE 2', 248733),
(386961, 'PTHR33932', NULL, NULL, NULL, NULL, 'NA(+)/H(+) ANTIPORTER SUBUNIT B', 248734),
(386962, 'PTHR33932:SF4', NULL, NULL, NULL, NULL, 'NA(+)/H(+) ANTIPORTER SUBUNIT B', 248734),
(386963, 'PTHR43312:SF2', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE-RELATED', 248735),
(386964, 'PTHR43312:SF1', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 248735),
(386965, 'PTHR43312', NULL, NULL, NULL, NULL, 'D-THREO-ALDOSE 1-DEHYDROGENASE', 248735),
(386966, 'PTHR31477', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 44 KDA', 248736),
(386967, 'PTHR31477:SF1', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 44 KDA', 248736),
(386968, 'PTHR23042:SF107', NULL, NULL, NULL, NULL, 'FI10506P-RELATED', 248737),
(386969, 'PTHR23042', NULL, NULL, NULL, NULL, 'CIRCADIAN PROTEIN CLOCK/ARNT/BMAL/PAS', 248737),
(386970, 'PTHR23042:SF48', NULL, NULL, NULL, NULL, 'ARYL HYDROCARBON RECEPTOR NUCLEAR TRANSLOCATOR-LIKE PROTEIN 2', 248737),
(386971, 'PTHR23042:SF76', NULL, NULL, NULL, NULL, 'ARYL HYDROCARBON RECEPTOR NUCLEAR TRANSLOCATOR HOMOLOG', 248737),
(386972, 'PTHR23042:SF6', NULL, NULL, NULL, NULL, 'ARYL HYDROCARBON RECEPTOR NUCLEAR TRANSLOCATOR 2', 248737),
(386973, 'PTHR23042:SF99', NULL, NULL, NULL, NULL, 'PROTEIN CYCLE', 248737),
(386974, 'PTHR23042:SF50', NULL, NULL, NULL, NULL, 'ARYL HYDROCARBON RECEPTOR NUCLEAR TRANSLOCATOR', 248737),
(386975, 'PTHR23042:SF52', NULL, NULL, NULL, NULL, 'ARYL HYDROCARBON RECEPTOR NUCLEAR TRANSLOCATOR-LIKE PROTEIN 1', 248737),
(386976, 'PTHR20899', NULL, NULL, NULL, NULL, 'PIERCE HOMOLOG', 248738),
(386977, 'PTHR20899:SF4', NULL, NULL, NULL, NULL, 'CELL CYCLE PROGRESSION 1, OPPOSITE STRAND', 248738),
(386978, 'PTHR20899:SF1', NULL, NULL, NULL, NULL, 'UPF0691 PROTEIN C9ORF116', 248738),
(386979, 'PTHR45845', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR-RELATED', 248739),
(386980, 'PTHR45845:SF2', NULL, NULL, NULL, NULL, 'SIMILAR TO HYPOTHETICAL PROTEIN D630003M21', 248739),
(386981, 'PTHR45845:SF1', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY AND RHOGEF DOMAIN CONTAINING G4B', 248739),
(386982, 'PTHR45845:SF4', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING, FAMILY G (WITH RHOGEF DOMAIN) MEMBER 4', 248739),
(386983, 'PTHR45845:SF3', NULL, NULL, NULL, NULL, 'PURATROPHIN-1-LIKE, ISOFORM A', 248739),
(386984, 'PTHR45845:SF5', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 40', 248739),
(386985, 'PTHR37155:SF2', NULL, NULL, NULL, NULL, 'MUCIN 26B', 248740),
(386986, 'PTHR37155', NULL, NULL, NULL, NULL, 'MUCIN 26B', 248740),
(386987, 'PTHR41967:SF6', NULL, NULL, NULL, NULL, 'FI19406P1-RELATED', 248741),
(386988, 'PTHR41967', NULL, NULL, NULL, NULL, 'FI19406P1-RELATED', 248741),
(386989, 'PTHR38742:SF1', NULL, NULL, NULL, NULL, 'SECRETED PROTEIN C', 248742),
(386990, 'PTHR38742:SF5', NULL, NULL, NULL, NULL, 'SECRETED PROTEIN A', 248742),
(386991, 'PTHR38742', NULL, NULL, NULL, NULL, 'PROTEIN GP17', 248742),
(386992, 'PTHR38742:SF3', NULL, NULL, NULL, NULL, 'SECRETED PROTEIN B', 248742),
(386993, 'PTHR22917:SF1', NULL, NULL, NULL, NULL, 'PROTEOGLYCAN 4', 248743),
(386994, 'PTHR22917:SF3', NULL, NULL, NULL, NULL, 'VITRONECTIN', 248743),
(386995, 'PTHR22917', NULL, NULL, NULL, NULL, 'HEMOPEXIN DOMAIN-CONTAINING PROTEIN', 248743),
(386996, 'PTHR22917:SF6', NULL, NULL, NULL, NULL, 'EG:8D8.2 PROTEIN-RELATED', 248743),
(386997, 'PTHR22917:SF7', NULL, NULL, NULL, NULL, 'VITRONECTIN A', 248743),
(386998, 'PTHR22917:SF8', NULL, NULL, NULL, NULL, 'PROTEOGLYCAN 4A', 248743),
(386999, 'PTHR22917:SF9', NULL, NULL, NULL, NULL, 'HEMOPEXIN', 248743),
(387000, 'PTHR48230', NULL, NULL, NULL, NULL, '', 248744),
(387001, 'PTHR48230:SF1', NULL, NULL, NULL, NULL, 'TMEM189_B_DMAIN DOMAIN-CONTAINING PROTEIN', 248744),
(387002, 'PTHR32308', NULL, NULL, NULL, NULL, 'LYASE BETA SUBUNIT, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G13030)-RELATED', 248745),
(387003, 'PTHR32308:SF0', NULL, NULL, NULL, NULL, 'HPCH_HPAI DOMAIN-CONTAINING PROTEIN', 248745);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(387004, 'PTHR32308:SF1', NULL, NULL, NULL, NULL, 'HPCH_HPAI DOMAIN-CONTAINING PROTEIN', 248745),
(387005, 'PTHR32308:SF10', NULL, NULL, NULL, NULL, 'CITRATE LYASE SUBUNIT BETA', 248745),
(387006, 'PTHR13820:SF4', NULL, NULL, NULL, NULL, 'BETA-SYNUCLEIN', 248746),
(387007, 'PTHR13820:SF5', NULL, NULL, NULL, NULL, 'ALPHA-SYNUCLEIN', 248746),
(387008, 'PTHR13820:SF11', NULL, NULL, NULL, NULL, 'GAMMA-SYNUCLEIN', 248746),
(387009, 'PTHR13820:SF10', NULL, NULL, NULL, NULL, 'GAMMA-SYNUCLEIN', 248746),
(387010, 'PTHR13820', NULL, NULL, NULL, NULL, 'SYNUCLEIN', 248746),
(387011, 'PTHR36312:SF14', NULL, NULL, NULL, NULL, 'THIONIN-LIKE PROTEIN', 248747),
(387012, 'PTHR36312:SF7', NULL, NULL, NULL, NULL, 'THIONIN-LIKE PROTEIN 2', 248747),
(387013, 'PTHR36312:SF13', NULL, NULL, NULL, NULL, 'BNAA09G46990D PROTEIN', 248747),
(387014, 'PTHR36312:SF16', NULL, NULL, NULL, NULL, 'THIONIN-LIKE PROTEIN 2', 248747),
(387015, 'PTHR36312:SF9', NULL, NULL, NULL, NULL, 'THIONIN-LIKE PROTEIN 1', 248747),
(387016, 'PTHR36312:SF15', NULL, NULL, NULL, NULL, 'THIONIN-LIKE PROTEIN', 248747),
(387017, 'PTHR36312:SF8', NULL, NULL, NULL, NULL, 'BNAA05G19200D PROTEIN', 248747),
(387018, 'PTHR36312:SF10', NULL, NULL, NULL, NULL, 'BNACNNG07530D PROTEIN', 248747),
(387019, 'PTHR36312:SF3', NULL, NULL, NULL, NULL, '', 248747),
(387020, 'PTHR36312:SF2', NULL, NULL, NULL, NULL, '', 248747),
(387021, 'PTHR36312:SF12', NULL, NULL, NULL, NULL, 'BNACNNG31580D PROTEIN', 248747),
(387022, 'PTHR36312:SF5', NULL, NULL, NULL, NULL, 'PROTEIN TAP1-LIKE', 248747),
(387023, 'PTHR36312:SF11', NULL, NULL, NULL, NULL, 'BNAA05G19190D PROTEIN', 248747),
(387024, 'PTHR36312:SF1', NULL, NULL, NULL, NULL, 'OS01G0594500 PROTEIN', 248747),
(387025, 'PTHR36312', NULL, NULL, NULL, NULL, 'THIONIN-LIKE PROTEIN 1', 248747),
(387026, 'PTHR14379:SF55', NULL, NULL, NULL, NULL, 'BNAC03G21430D PROTEIN', 248748),
(387027, 'PTHR14379:SF54', NULL, NULL, NULL, NULL, 'BNAA04G28080D PROTEIN', 248748),
(387028, 'PTHR14379:SF57', NULL, NULL, NULL, NULL, 'NYN DOMAIN-CONTAINING PROTEIN', 248748),
(387029, 'PTHR14379:SF56', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 248748),
(387030, 'PTHR14379:SF59', NULL, NULL, NULL, NULL, 'NYN DOMAIN-CONTAINING PROTEIN', 248748),
(387031, 'PTHR14379:SF15', NULL, NULL, NULL, NULL, 'NYN DOMAIN-CONTAINING PROTEIN', 248748),
(387032, 'PTHR14379:SF58', NULL, NULL, NULL, NULL, 'BNAC05G51950D PROTEIN', 248748),
(387033, 'PTHR14379:SF16', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN-LIKE PROTEIN', 248748),
(387034, 'PTHR14379:SF51', NULL, NULL, NULL, NULL, 'BNACNNG57250D PROTEIN', 248748),
(387035, 'PTHR14379:SF50', NULL, NULL, NULL, NULL, 'BNAA07G25600D PROTEIN', 248748),
(387036, 'PTHR14379:SF53', NULL, NULL, NULL, NULL, 'BNAANNG24850D PROTEIN', 248748),
(387037, 'PTHR14379:SF52', NULL, NULL, NULL, NULL, 'NYN DOMAIN-CONTAINING PROTEIN', 248748),
(387038, 'PTHR14379:SF19', NULL, NULL, NULL, NULL, 'ENDONUCLEASE/GLYCOSYL HYDROLASE-RELATED', 248748),
(387039, 'PTHR14379:SF18', NULL, NULL, NULL, NULL, 'NYN DOMAIN-CONTAINING PROTEIN', 248748),
(387040, 'PTHR14379:SF88', NULL, NULL, NULL, NULL, 'ENDONUCLEASE OR GLYCOSYL HYDROLASE-RELATED', 248748),
(387041, 'PTHR14379:SF44', NULL, NULL, NULL, NULL, 'NYN DOMAIN-CONTAINING PROTEIN', 248748),
(387042, 'PTHR14379:SF87', NULL, NULL, NULL, NULL, 'NYN DOMAIN-CONTAINING PROTEIN', 248748),
(387043, 'PTHR14379:SF43', NULL, NULL, NULL, NULL, 'BNAA05G18550D PROTEIN', 248748),
(387044, 'PTHR14379:SF46', NULL, NULL, NULL, NULL, 'NYN DOMAIN-CONTAINING PROTEIN', 248748),
(387045, 'PTHR14379:SF45', NULL, NULL, NULL, NULL, 'BNAA02G37100D PROTEIN', 248748),
(387046, 'PTHR14379:SF89', NULL, NULL, NULL, NULL, 'BNAA08G03420D PROTEIN', 248748),
(387047, 'PTHR14379:SF47', NULL, NULL, NULL, NULL, 'NYN DOMAIN-CONTAINING PROTEIN', 248748),
(387048, 'PTHR14379:SF49', NULL, NULL, NULL, NULL, 'NYN DOMAIN-CONTAINING PROTEIN', 248748),
(387049, 'PTHR14379:SF80', NULL, NULL, NULL, NULL, 'BNACNNG72790D PROTEIN', 248748),
(387050, 'PTHR14379:SF3', NULL, NULL, NULL, NULL, 'MEIOSIS REGULATOR AND MRNA STABILITY FACTOR 1', 248748);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(387051, 'PTHR14379:SF82', NULL, NULL, NULL, NULL, 'OS08G0230500 PROTEIN', 248748),
(387052, 'PTHR14379:SF81', NULL, NULL, NULL, NULL, 'OS12G0162900 PROTEIN', 248748),
(387053, 'PTHR14379:SF7', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', 248748),
(387054, 'PTHR14379:SF84', NULL, NULL, NULL, NULL, 'BNACNNG67380D PROTEIN', 248748),
(387055, 'PTHR14379:SF83', NULL, NULL, NULL, NULL, 'NYN DOMAIN-CONTAINING PROTEIN', 248748),
(387056, 'PTHR14379:SF86', NULL, NULL, NULL, NULL, 'EMB|CAB71880.1', 248748),
(387057, 'PTHR14379:SF42', NULL, NULL, NULL, NULL, 'BNAA04G28620D PROTEIN', 248748),
(387058, 'PTHR14379:SF41', NULL, NULL, NULL, NULL, 'NYN DOMAIN-CONTAINING PROTEIN', 248748),
(387059, 'PTHR14379:SF6', NULL, NULL, NULL, NULL, 'EMB|CAB71880.1', 248748),
(387060, 'PTHR14379:SF85', NULL, NULL, NULL, NULL, 'BNAA09G30230D PROTEIN', 248748),
(387061, 'PTHR14379', NULL, NULL, NULL, NULL, 'LIMKAIN B  LKAP', 248748),
(387062, 'PTHR14379:SF77', NULL, NULL, NULL, NULL, 'BNAA08G03430D PROTEIN', 248748),
(387063, 'PTHR14379:SF32', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 248748),
(387064, 'PTHR14379:SF76', NULL, NULL, NULL, NULL, 'BNAA03G17910D PROTEIN', 248748),
(387065, 'PTHR14379:SF79', NULL, NULL, NULL, NULL, 'MEIOSIS ARREST FEMALE PROTEIN 1 HOMOLOG-LIKE PROTEIN', 248748),
(387066, 'PTHR14379:SF35', NULL, NULL, NULL, NULL, 'BNAA03G46680D PROTEIN', 248748),
(387067, 'PTHR14379:SF78', NULL, NULL, NULL, NULL, 'BNAA03G52410D PROTEIN', 248748),
(387068, 'PTHR14379:SF34', NULL, NULL, NULL, NULL, 'BNAC05G23890D PROTEIN', 248748),
(387069, 'PTHR14379:SF37', NULL, NULL, NULL, NULL, '', 248748),
(387070, 'PTHR14379:SF36', NULL, NULL, NULL, NULL, 'NYN DOMAIN-CONTAINING PROTEIN', 248748),
(387071, 'PTHR14379:SF39', NULL, NULL, NULL, NULL, 'NYN DOMAIN-CONTAINING PROTEIN', 248748),
(387072, 'PTHR14379:SF38', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 248748),
(387073, 'PTHR14379:SF71', NULL, NULL, NULL, NULL, 'BNAC02G42090D PROTEIN', 248748),
(387074, 'PTHR14379:SF70', NULL, NULL, NULL, NULL, 'NYN DOMAIN-CONTAINING PROTEIN', 248748),
(387075, 'PTHR14379:SF73', NULL, NULL, NULL, NULL, 'NYN DOMAIN-CONTAINING PROTEIN', 248748),
(387076, 'PTHR14379:SF31', NULL, NULL, NULL, NULL, 'BNAA01G07790D PROTEIN', 248748),
(387077, 'PTHR14379:SF75', NULL, NULL, NULL, NULL, 'BNAC07G03020D PROTEIN', 248748),
(387078, 'PTHR14379:SF30', NULL, NULL, NULL, NULL, 'BNAA01G26400D PROTEIN', 248748),
(387079, 'PTHR14379:SF74', NULL, NULL, NULL, NULL, '', 248748),
(387080, 'PTHR14379:SF22', NULL, NULL, NULL, NULL, 'ENDONUCLEASE OR GLYCOSYL HYDROLASE-RELATED', 248748),
(387081, 'PTHR14379:SF24', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 248748),
(387082, 'PTHR14379:SF68', NULL, NULL, NULL, NULL, 'BNAA01G25090D PROTEIN', 248748),
(387083, 'PTHR14379:SF23', NULL, NULL, NULL, NULL, 'OS03G0370200 PROTEIN', 248748),
(387084, 'PTHR14379:SF26', NULL, NULL, NULL, NULL, 'NYN DOMAIN-CONTAINING PROTEIN', 248748),
(387085, 'PTHR14379:SF28', NULL, NULL, NULL, NULL, 'EMB|CAB71865.1-RELATED', 248748),
(387086, 'PTHR14379:SF27', NULL, NULL, NULL, NULL, 'BNAA01G07780D PROTEIN', 248748),
(387087, 'PTHR14379:SF60', NULL, NULL, NULL, NULL, 'NYN DOMAIN-CONTAINING PROTEIN', 248748),
(387088, 'PTHR14379:SF62', NULL, NULL, NULL, NULL, 'BNAC01G40510D PROTEIN', 248748),
(387089, 'PTHR14379:SF61', NULL, NULL, NULL, NULL, 'BNAA05G34190D PROTEIN', 248748),
(387090, 'PTHR14379:SF64', NULL, NULL, NULL, NULL, 'BNAC02G02960D PROTEIN', 248748),
(387091, 'PTHR14379:SF63', NULL, NULL, NULL, NULL, 'ENDONUCLEASE OR GLYCOSYL HYDROLASE-RELATED', 248748),
(387092, 'PTHR35704:SF10', NULL, NULL, NULL, NULL, 'BNAA03G46310D PROTEIN', 248749),
(387093, 'PTHR35704', NULL, NULL, NULL, NULL, 'OS02G0254600 PROTEIN', 248749),
(387094, 'PTHR35704:SF12', NULL, NULL, NULL, NULL, 'BNAA10G06970D PROTEIN', 248749),
(387095, 'PTHR35704:SF11', NULL, NULL, NULL, NULL, 'BNAA02G21870D PROTEIN', 248749),
(387096, 'PTHR35704:SF1', NULL, NULL, NULL, NULL, 'OS02G0254600 PROTEIN', 248749),
(387097, 'PTHR35704:SF6', NULL, NULL, NULL, NULL, 'OS06G0529900 PROTEIN', 248749);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(387098, 'PTHR35704:SF9', NULL, NULL, NULL, NULL, 'BNAA08G15100D PROTEIN', 248749),
(387099, 'PTHR35704:SF4', NULL, NULL, NULL, NULL, 'BNAC09G12200D PROTEIN', 248749),
(387100, 'PTHR35704:SF5', NULL, NULL, NULL, NULL, 'BNAANNG19700D PROTEIN', 248749),
(387101, 'PTHR13256:SF16', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE 9', 248750),
(387102, 'PTHR13256', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE 9', 248750),
(387103, 'PTHR42721:SF40', NULL, NULL, NULL, NULL, 'FN3_LIKE DOMAIN-CONTAINING PROTEIN', 248751),
(387104, 'PTHR42721', NULL, NULL, NULL, NULL, 'SUGAR HYDROLASE-RELATED', 248751),
(387105, 'PTHR42721:SF19', NULL, NULL, NULL, NULL, 'FN3_LIKE DOMAIN-CONTAINING PROTEIN', 248751),
(387106, 'PTHR42721:SF39', NULL, NULL, NULL, NULL, 'FN3_LIKE DOMAIN-CONTAINING PROTEIN', 248751),
(387107, 'PTHR42721:SF17', NULL, NULL, NULL, NULL, 'O-GLYCOSYL HYDROLASE SUPERFAMILY PROTEIN-RELATED', 248751),
(387108, 'PTHR42721:SF38', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE FAMILY 3 C-TERMINAL DOMAIN-CONTAINING PROTEIN-RELATED', 248751),
(387109, 'PTHR42721:SF11', NULL, NULL, NULL, NULL, 'BETA-D-XYLOSIDASE 5-RELATED', 248751),
(387110, 'PTHR42721:SF31', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE FAMILY 3 C-TERMINAL DOMAIN-CONTAINING PROTEIN-RELATED', 248751),
(387111, 'PTHR42721:SF30', NULL, NULL, NULL, NULL, 'ALPHA-L-ARABINOFURANOSIDASE/BETA-D-XYLOSIDASE', 248751),
(387112, 'PTHR42721:SF14', NULL, NULL, NULL, NULL, 'BETA-D-XYLOSIDASE 4-RELATED', 248751),
(387113, 'PTHR42721:SF36', NULL, NULL, NULL, NULL, 'FN3_LIKE DOMAIN-CONTAINING PROTEIN', 248751),
(387114, 'PTHR42721:SF13', NULL, NULL, NULL, NULL, 'EXO-1,4-BETA-XYLOSIDASE XLND', 248751),
(387115, 'PTHR42721:SF1', NULL, NULL, NULL, NULL, 'BETA-D-XYLOSIDASE 6-RELATED', 248751),
(387116, 'PTHR42721:SF28', NULL, NULL, NULL, NULL, 'FN3_LIKE DOMAIN-CONTAINING PROTEIN', 248751),
(387117, 'PTHR42721:SF27', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE FAMILY 3 PROTEIN', 248751),
(387118, 'PTHR42721:SF44', NULL, NULL, NULL, NULL, 'BETA-D-XYLOSIDASE 7-RELATED', 248751),
(387119, 'PTHR42721:SF8', NULL, NULL, NULL, NULL, 'BETA-D-XYLOSIDASE 1', 248751),
(387120, 'PTHR42721:SF43', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE FAMILY PROTEIN-RELATED', 248751),
(387121, 'PTHR42721:SF21', NULL, NULL, NULL, NULL, 'BETA-XYLOSIDASE/ALPHA-L-ARABINOFURANOSIDASE 2-LIKE', 248751),
(387122, 'PTHR42721:SF20', NULL, NULL, NULL, NULL, 'BETA-D-XYLOSIDASE 3', 248751),
(387123, 'PTHR42721:SF42', NULL, NULL, NULL, NULL, 'FN3_LIKE DOMAIN-CONTAINING PROTEIN', 248751),
(387124, 'PTHR42721:SF41', NULL, NULL, NULL, NULL, 'FN3_LIKE DOMAIN-CONTAINING PROTEIN', 248751),
(387125, 'PTHR42721:SF9', NULL, NULL, NULL, NULL, 'OS11G0297300 PROTEIN', 248751),
(387126, 'PTHR42721:SF4', NULL, NULL, NULL, NULL, 'OS11G0291000 PROTEIN', 248751),
(387127, 'PTHR42721:SF47', NULL, NULL, NULL, NULL, 'FN3_LIKE DOMAIN-CONTAINING PROTEIN', 248751),
(387128, 'PTHR42721:SF3', NULL, NULL, NULL, NULL, 'BETA-D-XYLOSIDASE 5-RELATED', 248751),
(387129, 'PTHR42721:SF24', NULL, NULL, NULL, NULL, 'BETA-D-XYLOSIDASE 7-RELATED', 248751),
(387130, 'PTHR42721:SF46', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE FAMILY 3 C TERMINAL DOMAIN CONTAINING PROTEIN', 248751),
(387131, 'PTHR42721:SF45', NULL, NULL, NULL, NULL, 'BETA-D-XYLOSIDASE 2-RELATED', 248751),
(387132, 'PTHR42721:SF23', NULL, NULL, NULL, NULL, 'BETA-XYLOSIDASE/ALPHA-L-ARABINOFURANOSIDASE-LIKE PROTEIN', 248751),
(387133, 'PTHR36785:SF1', NULL, NULL, NULL, NULL, 'OS05G0502500 PROTEIN', 248752),
(387134, 'PTHR36785', NULL, NULL, NULL, NULL, 'OS05G0502500 PROTEIN', 248752),
(387135, 'PTHR19282:SF40', NULL, NULL, NULL, NULL, 'TETRASPANIN-4', 248753),
(387136, 'PTHR19282:SF462', NULL, NULL, NULL, NULL, 'TETRASPANIN-12', 248753),
(387137, 'PTHR19282:SF44', NULL, NULL, NULL, NULL, 'CD82 ANTIGEN', 248753),
(387138, 'PTHR19282:SF41', NULL, NULL, NULL, NULL, 'TETRASPANIN-9', 248753),
(387139, 'PTHR19282:SF48', NULL, NULL, NULL, NULL, 'TETRASPANIN-3', 248753),
(387140, 'PTHR19282:SF184', NULL, NULL, NULL, NULL, 'PHOTORECEPTOR OUTER SEGMENT MEMBRANE GLYCOPROTEIN 2', 248753);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(387141, 'PTHR19282:SF216', NULL, NULL, NULL, NULL, 'TETRASPANIN-1', 248753),
(387142, 'PTHR19282:SF459', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387143, 'PTHR19282:SF452', NULL, NULL, NULL, NULL, 'LD03691P', 248753),
(387144, 'PTHR19282:SF51', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387145, 'PTHR19282:SF453', NULL, NULL, NULL, NULL, 'TETRASPANIN-20', 248753),
(387146, 'PTHR19282:SF211', NULL, NULL, NULL, NULL, 'TETRASPANIN-19', 248753),
(387147, 'PTHR19282:SF456', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387148, 'PTHR19282:SF214', NULL, NULL, NULL, NULL, 'CD81 ANTIGEN', 248753),
(387149, 'PTHR19282:SF455', NULL, NULL, NULL, NULL, 'TETRASPANIN-16', 248753),
(387150, 'PTHR19282:SF440', NULL, NULL, NULL, NULL, 'RETINAL OUTER SEGMENT MEMBRANE PROTEIN 1A', 248753),
(387151, 'PTHR19282:SF203', NULL, NULL, NULL, NULL, 'TETRASPANIN-13', 248753),
(387152, 'PTHR19282:SF445', NULL, NULL, NULL, NULL, 'TETRASPANIN FAMILY', 248753),
(387153, 'PTHR19282:SF168', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387154, 'PTHR19282:SF169', NULL, NULL, NULL, NULL, 'TETRASPANIN-6', 248753),
(387155, 'PTHR19282:SF202', NULL, NULL, NULL, NULL, 'PERIPHERIN-2', 248753),
(387156, 'PTHR19282:SF3', NULL, NULL, NULL, NULL, 'TETRASPANIN-31', 248753),
(387157, 'PTHR19282:SF25', NULL, NULL, NULL, NULL, 'UROPLAKIN-1A', 248753),
(387158, 'PTHR19282:SF163', NULL, NULL, NULL, NULL, 'CD9 ANTIGEN', 248753),
(387159, 'PTHR19282:SF28', NULL, NULL, NULL, NULL, 'IP01956P-RELATED', 248753),
(387160, 'PTHR19282:SF397', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387161, 'PTHR19282:SF155', NULL, NULL, NULL, NULL, 'TETRASPANIN-2', 248753),
(387162, 'PTHR19282:SF431', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387163, 'PTHR19282:SF154', NULL, NULL, NULL, NULL, 'TETRASPANIN-33', 248753),
(387164, 'PTHR19282:SF159', NULL, NULL, NULL, NULL, 'TETRASPANIN-15', 248753),
(387165, 'PTHR19282:SF432', NULL, NULL, NULL, NULL, 'TETRASPANIN-19-LIKE', 248753),
(387166, 'PTHR19282:SF158', NULL, NULL, NULL, NULL, 'TETRASPANIN-19', 248753),
(387167, 'PTHR19282:SF273', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387168, 'PTHR19282:SF39', NULL, NULL, NULL, NULL, 'LEUKOCYTE SURFACE ANTIGEN CD53', 248753),
(387169, 'PTHR19282:SF428', NULL, NULL, NULL, NULL, 'TETRASPANIN 68C, ISOFORM A', 248753),
(387170, 'PTHR19282:SF425', NULL, NULL, NULL, NULL, 'OS08G0159100 PROTEIN', 248753),
(387171, 'PTHR19282:SF426', NULL, NULL, NULL, NULL, 'TETRASPANIN-32', 248753),
(387172, 'PTHR19282:SF263', NULL, NULL, NULL, NULL, 'LEUKOCYTE ANTIGEN CD37', 248753),
(387173, 'PTHR19282:SF424', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387174, 'PTHR19282:SF422', NULL, NULL, NULL, NULL, 'TETRASPANIN-19-LIKE', 248753),
(387175, 'PTHR19282:SF261', NULL, NULL, NULL, NULL, 'TETRASPANIN-14', 248753),
(387176, 'PTHR19282:SF380', NULL, NULL, NULL, NULL, 'TETRASPANIN-8', 248753),
(387177, 'PTHR19282:SF537', NULL, NULL, NULL, NULL, 'TETRASPANIN-1', 248753),
(387178, 'PTHR19282:SF538', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387179, 'PTHR19282:SF417', NULL, NULL, NULL, NULL, 'TETRASPANIN-15', 248753),
(387180, 'PTHR19282:SF535', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387181, 'PTHR19282:SF536', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387182, 'PTHR19282:SF539', NULL, NULL, NULL, NULL, 'TETRASPANIN TSPA-RELATED', 248753),
(387183, 'PTHR19282:SF530', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387184, 'PTHR19282:SF252', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387185, 'PTHR19282:SF495', NULL, NULL, NULL, NULL, 'RETINAL OUTER SEGMENT MEMBRANE PROTEIN 1B', 248753),
(387186, 'PTHR19282:SF533', NULL, NULL, NULL, NULL, 'BNAC05G28640D PROTEIN', 248753),
(387187, 'PTHR19282:SF534', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387188, 'PTHR19282:SF377', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387189, 'PTHR19282:SF531', NULL, NULL, NULL, NULL, 'TOBAMOVIRUS MULTIPLICATION PROTEIN 2A-LIKE', 248753),
(387190, 'PTHR19282:SF257', NULL, NULL, NULL, NULL, 'TETRASPANIN-7', 248753),
(387191, 'PTHR19282:SF136', NULL, NULL, NULL, NULL, 'TETRASPANIN-18', 248753);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(387192, 'PTHR19282:SF532', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 248753),
(387193, 'PTHR19282:SF378', NULL, NULL, NULL, NULL, 'TETRASPANIN FAMILY', 248753),
(387194, 'PTHR19282:SF526', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387195, 'PTHR19282:SF527', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387196, 'PTHR19282:SF524', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387197, 'PTHR19282:SF249', NULL, NULL, NULL, NULL, 'TETRASPANIN-18', 248753),
(387198, 'PTHR19282:SF525', NULL, NULL, NULL, NULL, 'TETRASPANIN FAMILY', 248753),
(387199, 'PTHR19282:SF528', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387200, 'PTHR19282:SF529', NULL, NULL, NULL, NULL, 'TETRASPANIN FAMILY', 248753),
(387201, 'PTHR19282:SF364', NULL, NULL, NULL, NULL, 'TETRASPANIN-9', 248753),
(387202, 'PTHR19282:SF120', NULL, NULL, NULL, NULL, 'TETRASPANIN-36', 248753),
(387203, 'PTHR19282:SF522', NULL, NULL, NULL, NULL, 'OS08G0282000 PROTEIN', 248753),
(387204, 'PTHR19282:SF489', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387205, 'PTHR19282:SF523', NULL, NULL, NULL, NULL, 'TETRASPANIN TSPE-RELATED', 248753),
(387206, 'PTHR19282:SF63', NULL, NULL, NULL, NULL, 'TETRASPANIN-5', 248753),
(387207, 'PTHR19282:SF520', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387208, 'PTHR19282:SF487', NULL, NULL, NULL, NULL, 'CD151 ANTIGEN', 248753),
(387209, 'PTHR19282:SF521', NULL, NULL, NULL, NULL, 'AT12771P-RELATED', 248753),
(387210, 'PTHR19282:SF488', NULL, NULL, NULL, NULL, 'TOBAMOVIRUS MULTIPLICATION 2A-RELATED', 248753),
(387211, 'PTHR19282:SF482', NULL, NULL, NULL, NULL, 'FI23944P1-RELATED', 248753),
(387212, 'PTHR19282:SF515', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387213, 'PTHR19282:SF516', NULL, NULL, NULL, NULL, 'TETRASPANIN FAMILY', 248753),
(387214, 'PTHR19282:SF513', NULL, NULL, NULL, NULL, 'TETRASPANIN FAMILY PROTEIN', 248753),
(387215, 'PTHR19282:SF238', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387216, 'PTHR19282:SF514', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387217, 'PTHR19282:SF519', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387218, 'PTHR19282:SF517', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387219, 'PTHR19282:SF518', NULL, NULL, NULL, NULL, 'TOBAMOVIRUS MULTIPLICATION PROTEIN 2A', 248753),
(387220, 'PTHR19282:SF199', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387221, 'PTHR19282:SF475', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387222, 'PTHR19282:SF198', NULL, NULL, NULL, NULL, 'TETRASPANIN-11', 248753),
(387223, 'PTHR19282:SF511', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387224, 'PTHR19282:SF478', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387225, 'PTHR19282:SF512', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387226, 'PTHR19282:SF234', NULL, NULL, NULL, NULL, 'ROD OUTER SEGMENT MEMBRANE PROTEIN 1', 248753),
(387227, 'PTHR19282:SF477', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387228, 'PTHR19282:SF510', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387229, 'PTHR19282:SF470', NULL, NULL, NULL, NULL, 'TETRASPANIN-17', 248753),
(387230, 'PTHR19282:SF471', NULL, NULL, NULL, NULL, 'CD63 ANTIGEN', 248753),
(387231, 'PTHR19282', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387232, 'PTHR19282:SF504', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387233, 'PTHR19282:SF505', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387234, 'PTHR19282:SF502', NULL, NULL, NULL, NULL, 'TETRASPANIN-14', 248753),
(387235, 'PTHR19282:SF503', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387236, 'PTHR19282:SF508', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387237, 'PTHR19282:SF509', NULL, NULL, NULL, NULL, 'TETRASPANIN-10', 248753),
(387238, 'PTHR19282:SF506', NULL, NULL, NULL, NULL, 'TETRASPANIN TSPB-RELATED', 248753),
(387239, 'PTHR19282:SF507', NULL, NULL, NULL, NULL, 'TETRASPANIN', 248753),
(387240, 'PTHR15944:SF0', NULL, NULL, NULL, NULL, 'PRENYLCYS_LYASE DOMAIN-CONTAINING PROTEIN', 248754),
(387241, 'PTHR15944', NULL, NULL, NULL, NULL, 'FARNESYLCYSTEINE LYASE', 248754),
(387242, 'PTHR15944:SF3', NULL, NULL, NULL, NULL, 'PRENYLCYSTEINE OXIDASE 1', 248754);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(387243, 'PTHR15944:SF2', NULL, NULL, NULL, NULL, 'PRENYLCYSTEINE OXIDASE-LIKE', 248754),
(387244, 'PTHR42753:SF9', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L39, MITOCHONDRIAL', 248755),
(387245, 'PTHR42753:SF10', NULL, NULL, NULL, NULL, 'PROLINE--TRNA LIGASE, MITOCHONDRIAL-RELATED', 248755),
(387246, 'PTHR42753:SF2', NULL, NULL, NULL, NULL, 'PROLYL-TRNA SYNTHETASE', 248755),
(387247, 'PTHR42753', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOME PROTEIN L39/PROLYL-TRNA LIGASE FAMILY MEMBER', 248755),
(387248, 'PTHR14112:SF24', NULL, NULL, NULL, NULL, 'PROTEIN SSX2-RELATED', 248756),
(387249, 'PTHR14112:SF23', NULL, NULL, NULL, NULL, 'PROTEIN SSX5', 248756),
(387250, 'PTHR14112:SF1', NULL, NULL, NULL, NULL, 'KRAB-RELATED DOMAIN-CONTAINING PROTEIN', 248756),
(387251, 'PTHR14112:SF8', NULL, NULL, NULL, NULL, 'PROTEIN SSX4', 248756),
(387252, 'PTHR14112:SF19', NULL, NULL, NULL, NULL, 'PROTEIN SSX3', 248756),
(387253, 'PTHR14112:SF28', NULL, NULL, NULL, NULL, 'GENE, 21876-RELATED', 248756),
(387254, 'PTHR14112:SF27', NULL, NULL, NULL, NULL, 'PROTEIN SSX6-RELATED', 248756),
(387255, 'PTHR14112:SF26', NULL, NULL, NULL, NULL, 'PROTEIN SSX1', 248756),
(387256, 'PTHR14112', NULL, NULL, NULL, NULL, 'SYNOVIAL SARCOMA, X MEMBER', 248756),
(387257, 'PTHR14112:SF5', NULL, NULL, NULL, NULL, 'SSXB10 PROTEIN-RELATED', 248756),
(387258, 'PTHR36560:SF1', NULL, NULL, NULL, NULL, 'CELLULOSE-BINDING DOMAIN-CONTAINING PROTEIN', 248757),
(387259, 'PTHR36560', NULL, NULL, NULL, NULL, 'CELLULOSE-BINDING DOMAIN-CONTAINING PROTEIN', 248757),
(387260, 'PTHR21075', NULL, NULL, NULL, NULL, 'ANAEROBIC RIBONUCLEOSIDE-TRIPHOSPHATE REDUCTASE', 248758),
(387261, 'PTHR21075:SF0', NULL, NULL, NULL, NULL, 'ANAEROBIC RIBONUCLEOSIDE-TRIPHOSPHATE REDUCTASE', 248758),
(387262, 'PTHR10670:SF0', NULL, NULL, NULL, NULL, 'DNA POLYMERASE EPSILON CATALYTIC SUBUNIT A', 248759),
(387263, 'PTHR10670', NULL, NULL, NULL, NULL, 'DNA POLYMERASE EPSILON CATALYTIC SUBUNIT A', 248759),
(387264, 'PTHR31647', NULL, NULL, NULL, NULL, '2-CELL-STAGE, VARIABLE GROUP, MEMBER 1-RELATED', 248760),
(387265, 'PTHR31647:SF13', NULL, NULL, NULL, NULL, '2-CELL-STAGE, VARIABLE GROUP, MEMBER 1-RELATED', 248760),
(387266, 'PTHR16798', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA GROUP C PROTEIN FANCC', 248761),
(387267, 'PTHR16798:SF0', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA GROUP C PROTEIN', 248761),
(387268, 'PTHR48050:SF2', NULL, NULL, NULL, NULL, 'STEROL 3-BETA-GLUCOSYLTRANSFERASE-RELATED', 248762),
(387269, 'PTHR48050:SF29', NULL, NULL, NULL, NULL, '', 248762),
(387270, 'PTHR48050:SF28', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE SUPERFAMILY PROTEIN-RELATED', 248762),
(387271, 'PTHR48050:SF16', NULL, NULL, NULL, NULL, 'STEROL 3-BETA-GLUCOSYLTRANSFERASE UGT80B1', 248762),
(387272, 'PTHR48050:SF27', NULL, NULL, NULL, NULL, 'GLUCOSYLTRANSFERASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G04880)-RELATED', 248762),
(387273, 'PTHR48050', NULL, NULL, NULL, NULL, 'STEROL 3-BETA-GLUCOSYLTRANSFERASE', 248762),
(387274, 'PTHR48050:SF26', NULL, NULL, NULL, NULL, 'STEROL 3-BETA-GLUCOSYLTRANSFERASE', 248762),
(387275, 'PTHR48050:SF19', NULL, NULL, NULL, NULL, 'GLYCO_TRAN_28_C DOMAIN-CONTAINING PROTEIN-RELATED', 248762),
(387276, 'PTHR48050:SF5', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE,STEROL TRANSFERASE', 248762),
(387277, 'PTHR48050:SF10', NULL, NULL, NULL, NULL, 'OS07G0419500 PROTEIN', 248762),
(387278, 'PTHR48050:SF4', NULL, NULL, NULL, NULL, 'GLYCO_TRANSF_28 DOMAIN-CONTAINING PROTEIN', 248762),
(387279, 'PTHR48050:SF7', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE 1-6', 248762),
(387280, 'PTHR48050:SF6', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE 1A10-RELATED', 248762),
(387281, 'PTHR48050:SF14', NULL, NULL, NULL, NULL, 'STEROL 3-BETA-GLUCOSYLTRANSFERASE UGT80A2-LIKE ISOFORM X1', 248762),
(387282, 'PTHR48050:SF25', NULL, NULL, NULL, NULL, 'STEROL 3-BETA-GLUCOSYLTRANSFERASE', 248762),
(387283, 'PTHR48050:SF24', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE 1-2', 248762),
(387284, 'PTHR48050:SF8', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE 1A1', 248762); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(387285, 'PTHR48050:SF13', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE', 248762),
(387286, 'PTHR48050:SF23', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE 1A7', 248762),
(387287, 'PTHR48050:SF12', NULL, NULL, NULL, NULL, 'UDP-GLUCURONOSYLTRANSFERASE 1A3-RELATED', 248762),
(387288, 'PTHR48050:SF11', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 248762),
(387289, 'PTHR10352:SF18', NULL, NULL, NULL, NULL, 'RNA-BINDING MOTIF PROTEIN 45', 248763),
(387290, 'PTHR10352:SF53', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-BINDING ALPHA-BETA PLAIT DOMAIN-CONTAINING PROTEIN-RELATED', 248763),
(387291, 'PTHR10352:SF75', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT G', 248763),
(387292, 'PTHR10352:SF31', NULL, NULL, NULL, NULL, 'OS05G0303600 PROTEIN', 248763),
(387293, 'PTHR10352:SF54', NULL, NULL, NULL, NULL, 'UBP1-ASSOCIATED PROTEIN 2A-LIKE', 248763),
(387294, 'PTHR10352:SF76', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT G', 248763),
(387295, 'PTHR10352:SF10', NULL, NULL, NULL, NULL, 'NUCLEOLYSIN TIA-1 ISOFORM P40', 248763),
(387296, 'PTHR10352:SF11', NULL, NULL, NULL, NULL, 'NUCLEOLYSIN TIAR', 248763),
(387297, 'PTHR10352:SF33', NULL, NULL, NULL, NULL, 'OS12G0606300 PROTEIN', 248763),
(387298, 'PTHR10352:SF12', NULL, NULL, NULL, NULL, 'ELAV-LIKE PROTEIN 2', 248763),
(387299, 'PTHR10352:SF35', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN P', 248763),
(387300, 'PTHR10352:SF13', NULL, NULL, NULL, NULL, 'ELAV-LIKE PROTEIN 1', 248763),
(387301, 'PTHR10352:SF58', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 248763),
(387302, 'PTHR10352:SF14', NULL, NULL, NULL, NULL, 'OS01G0766700 PROTEIN', 248763),
(387303, 'PTHR10352:SF15', NULL, NULL, NULL, NULL, 'ELAV-LIKE PROTEIN 3', 248763),
(387304, 'PTHR10352:SF37', NULL, NULL, NULL, NULL, 'UBP1-ASSOCIATED PROTEIN 2B', 248763),
(387305, 'PTHR10352:SF0', NULL, NULL, NULL, NULL, 'RNA-BINDING MOTIF PROTEIN 14A', 248763),
(387306, 'PTHR10352:SF38', NULL, NULL, NULL, NULL, 'UBP1-ASSOCIATED PROTEIN 2A-LIKE', 248763),
(387307, 'PTHR10352:SF70', NULL, NULL, NULL, NULL, 'FI04408P', 248763),
(387308, 'PTHR10352:SF71', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT G', 248763),
(387309, 'PTHR10352:SF72', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT G', 248763),
(387310, 'PTHR10352:SF73', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 248763),
(387311, 'PTHR10352:SF9', NULL, NULL, NULL, NULL, 'ELAV-LIKE PROTEIN 4', 248763),
(387312, 'PTHR10352:SF52', NULL, NULL, NULL, NULL, 'UBP1-ASSOCIATED PROTEIN 2A-RELATED', 248763),
(387313, 'PTHR10352:SF74', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT G', 248763),
(387314, 'PTHR10352:SF30', NULL, NULL, NULL, NULL, 'OS09G0372200 PROTEIN', 248763),
(387315, 'PTHR10352:SF64', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT G', 248763),
(387316, 'PTHR10352:SF42', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN R', 248763),
(387317, 'PTHR10352:SF65', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 248763),
(387318, 'PTHR10352:SF45', NULL, NULL, NULL, NULL, 'OS05G0303700 PROTEIN', 248763),
(387319, 'PTHR10352:SF46', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT G', 248763),
(387320, 'PTHR10352:SF68', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 248763),
(387321, 'PTHR10352:SF25', NULL, NULL, NULL, NULL, 'FOUND IN NEURONS, ISOFORM A-RELATED', 248763),
(387322, 'PTHR10352:SF69', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 248763),
(387323, 'PTHR10352:SF49', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT G', 248763),
(387324, 'PTHR10352:SF27', NULL, NULL, NULL, NULL, 'PROTEIN ELAV', 248763),
(387325, 'PTHR10352:SF61', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN, PUTATIVE-RELATED', 248763),
(387326, 'PTHR10352:SF40', NULL, NULL, NULL, NULL, 'TRIVET, ISOFORM I', 248763),
(387327, 'PTHR10352', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT G', 248763);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(387328, 'PTHR10352:SF63', NULL, NULL, NULL, NULL, 'UBP1-ASSOCIATED PROTEIN 2A', 248763),
(387329, 'PTHR10352:SF41', NULL, NULL, NULL, NULL, 'RNA RECOGNITION MOTIF', 248763),
(387330, 'PTHR16195:SF16', NULL, NULL, NULL, NULL, 'ZINC FINGER CCHC DOMAIN-CONTAINING PROTEIN 14', 248764),
(387331, 'PTHR16195', NULL, NULL, NULL, NULL, 'ZINC FINGER CCHC DOMAIN CONTAINING PROTEIN', 248764),
(387332, 'PTHR14187', NULL, NULL, NULL, NULL, 'ALPHA KINASE/ELONGATION FACTOR 2 KINASE', 248765),
(387333, 'PTHR14187:SF46', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN 12A', 248765),
(387334, 'PTHR14187:SF79', NULL, NULL, NULL, NULL, 'HSP70 FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_1G15200)', 248765),
(387335, 'PTHR14187:SF81', NULL, NULL, NULL, NULL, 'HSP70 FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_4G14040)', 248765),
(387336, 'PTHR14187:SF80', NULL, NULL, NULL, NULL, '', 248765),
(387337, 'PTHR14187:SF39', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN 12B', 248765),
(387338, 'PTHR14187:SF5', NULL, NULL, NULL, NULL, 'FAMILY CHAPERONE, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G08575)-RELATED', 248765),
(387339, 'PTHR14187:SF61', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN FAMILY A (HSP70) MEMBER 12A.1-RELATED', 248765),
(387340, 'PTHR43330:SF13', NULL, NULL, NULL, NULL, 'METHIONINE AMINOPEPTIDASE 2', 248766),
(387341, 'PTHR43330:SF25', NULL, NULL, NULL, NULL, 'METHIONINE AMINOPEPTIDASE', 248766),
(387342, 'PTHR43330:SF15', NULL, NULL, NULL, NULL, 'METHIONINE AMINOPEPTIDASE', 248766),
(387343, 'PTHR43330:SF16', NULL, NULL, NULL, NULL, 'METHIONINE AMINOPEPTIDASE 2', 248766),
(387344, 'PTHR43330:SF21', NULL, NULL, NULL, NULL, 'METHIONINE AMINOPEPTIDASE 1C, CHLOROPLASTIC/MITOCHONDRIAL', 248766),
(387345, 'PTHR43330:SF11', NULL, NULL, NULL, NULL, 'METHIONINE AMINOPEPTIDASE', 248766),
(387346, 'PTHR43330:SF23', NULL, NULL, NULL, NULL, 'METHIONINE AMINOPEPTIDASE', 248766),
(387347, 'PTHR43330', NULL, NULL, NULL, NULL, 'METHIONINE AMINOPEPTIDASE', 248766),
(387348, 'PTHR43330:SF6', NULL, NULL, NULL, NULL, 'METHIONINE AMINOPEPTIDASE', 248766),
(387349, 'PTHR43330:SF7', NULL, NULL, NULL, NULL, 'METHIONINE AMINOPEPTIDASE 1', 248766),
(387350, 'PTHR43330:SF8', NULL, NULL, NULL, NULL, 'METHIONINE AMINOPEPTIDASE 1D, MITOCHONDRIAL', 248766),
(387351, 'PTHR43330:SF5', NULL, NULL, NULL, NULL, 'METHIONINE AMINOPEPTIDASE', 248766),
(387352, 'PTHR43330:SF1', NULL, NULL, NULL, NULL, 'METHIONINE AMINOPEPTIDASE 1B, CHLOROPLASTIC', 248766),
(387353, 'PTHR43330:SF17', NULL, NULL, NULL, NULL, 'METHIONINE AMINOPEPTIDASE', 248766),
(387354, 'PTHR43292', NULL, NULL, NULL, NULL, 'ACYL-COA DEHYDROGENASE', 248767),
(387355, 'PTHR43292:SF4', NULL, NULL, NULL, NULL, 'ACYL-COA DEHYDROGENASE FADE34', 248767),
(387356, 'PTHR43292:SF3', NULL, NULL, NULL, NULL, 'ACYL-COA DEHYDROGENASE FADE29', 248767),
(387357, 'PTHR45963:SF2', NULL, NULL, NULL, NULL, 'RE52028P', 248768),
(387358, 'PTHR45963:SF3', NULL, NULL, NULL, NULL, 'SORTING NEXIN-12', 248768),
(387359, 'PTHR45963:SF1', NULL, NULL, NULL, NULL, 'SORTING NEXIN-3', 248768),
(387360, 'PTHR45963', NULL, NULL, NULL, NULL, 'RE52028P', 248768),
(387361, 'PTHR43324', NULL, NULL, NULL, NULL, '', 248769),
(387362, 'PTHR43324:SF1', NULL, NULL, NULL, NULL, 'ELP3 DOMAIN-CONTAINING PROTEIN', 248769),
(387363, 'PTHR46656:SF3', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 248770),
(387364, 'PTHR46656', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 248770),
(387365, 'PTHR31328:SF2', NULL, NULL, NULL, NULL, 'BIOGENESIS OF LYSOSOME-RELATED ORGANELLES COMPLEX 1 SUBUNIT 6', 248771),
(387366, 'PTHR31328', NULL, NULL, NULL, NULL, 'BIOGENESIS OF LYSOSOME-RELATED ORGANELLES COMPLEX 1 SUBUNIT 6', 248771),
(387367, 'PTHR35752:SF1', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR', 248772),
(387368, 'PTHR35752', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR', 248772),
(387369, 'PTHR13798:SF11', NULL, NULL, NULL, NULL, 'RNA-BINDING MOTIF PROTEIN 11-RELATED', 248773),
(387370, 'PTHR13798:SF9', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 248773),
(387371, 'PTHR13798:SF4', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 7', 248773);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(387372, 'PTHR13798:SF3', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 248773),
(387373, 'PTHR13798:SF13', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 248773),
(387374, 'PTHR13798:SF5', NULL, NULL, NULL, NULL, 'SPLICING REGULATOR RBM11', 248773),
(387375, 'PTHR13798', NULL, NULL, NULL, NULL, 'RNA BINDING MOTIF RBM PROTEIN -RELATED', 248773),
(387376, 'PTHR47156', NULL, NULL, NULL, NULL, 'PROTEIN CBG20824', 248774),
(387377, 'PTHR47156:SF6', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', 248774),
(387378, 'PTHR47156:SF7', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 248774),
(387379, 'PTHR47156:SF5', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 248774),
(387380, 'PTHR47156:SF10', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 248774),
(387381, 'PTHR47156:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG26870', 248774),
(387382, 'PTHR36322:SF5', NULL, NULL, NULL, NULL, '', 248775),
(387383, 'PTHR36322', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 248775),
(387384, 'PTHR36322:SF6', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248775),
(387385, 'PTHR36322:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 248775),
(387386, 'PTHR34502:SF6', NULL, NULL, NULL, NULL, '', 248776),
(387387, 'PTHR34502', NULL, NULL, NULL, NULL, '', 248776),
(387388, 'PTHR34502:SF5', NULL, NULL, NULL, NULL, '', 248776),
(387389, 'PTHR34502:SF4', NULL, NULL, NULL, NULL, '', 248776),
(387390, 'PTHR34502:SF3', NULL, NULL, NULL, NULL, '', 248776),
(387391, 'PTHR21470:SF7', NULL, NULL, NULL, NULL, 'RAB6-INTERACTING GOLGIN', 248777),
(387392, 'PTHR21470:SF20', NULL, NULL, NULL, NULL, 'RAB6-INTERACTING GOLGIN', 248777),
(387393, 'PTHR21470:SF12', NULL, NULL, NULL, NULL, 'RAB6-INTERACTING GOLGIN', 248777),
(387394, 'PTHR21470:SF23', NULL, NULL, NULL, NULL, 'RAB6-INTERACTING GOLGIN', 248777),
(387395, 'PTHR21470:SF24', NULL, NULL, NULL, NULL, 'RAB6-INTERACTING GOLGIN', 248777),
(387396, 'PTHR21470:SF10', NULL, NULL, NULL, NULL, 'RAB6-INTERACTING GOLGIN', 248777),
(387397, 'PTHR21470:SF21', NULL, NULL, NULL, NULL, 'RAB6-INTERACTING GOLGIN', 248777),
(387398, 'PTHR21470:SF11', NULL, NULL, NULL, NULL, 'RAB6-INTERACTING GOLGIN', 248777),
(387399, 'PTHR21470', NULL, NULL, NULL, NULL, 'RAB6-INTERACTING PROTEIN GORAB', 248777),
(387400, 'PTHR21470:SF3', NULL, NULL, NULL, NULL, 'RAB6-INTERACTING GOLGIN', 248777),
(387401, 'PTHR21470:SF2', NULL, NULL, NULL, NULL, 'RAB6-INTERACTING GOLGIN', 248777),
(387402, 'PTHR21470:SF14', NULL, NULL, NULL, NULL, 'RAB6-INTERACTING GOLGIN', 248777),
(387403, 'PTHR21470:SF15', NULL, NULL, NULL, NULL, 'RAB6-INTERACTING GOLGIN', 248777),
(387404, 'PTHR21470:SF18', NULL, NULL, NULL, NULL, 'RAB6-INTERACTING GOLGIN', 248777),
(387405, 'PTHR35510:SF1', NULL, NULL, NULL, NULL, 'DBH-LIKE MONOOXYGENASE', 248778),
(387406, 'PTHR35510:SF2', NULL, NULL, NULL, NULL, 'OS08G0520600 PROTEIN', 248778),
(387407, 'PTHR35510:SF3', NULL, NULL, NULL, NULL, 'OS09G0494500 PROTEIN', 248778),
(387408, 'PTHR35510', NULL, NULL, NULL, NULL, 'DBH-LIKE MONOOXYGENASE', 248778),
(387409, 'PTHR46427', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND LEM DOMAIN-CONTAINING PROTEIN 1', 248779),
(387410, 'PTHR46427:SF1', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND LEM DOMAIN-CONTAINING PROTEIN 1', 248779),
(387411, 'PTHR11255:SF109', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE ETA', 248780),
(387412, 'PTHR11255:SF34', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE THETA', 248780),
(387413, 'PTHR11255:SF106', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE', 248780),
(387414, 'PTHR11255:SF98', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE 5-RELATED', 248780),
(387415, 'PTHR11255:SF54', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE EPSILON', 248780),
(387416, 'PTHR11255:SF104', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE 2', 248780),
(387417, 'PTHR11255:SF32', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE BETA', 248780),
(387418, 'PTHR11255:SF99', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE', 248780),
(387419, 'PTHR11255:SF33', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE KAPPA', 248780);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(387420, 'PTHR11255:SF38', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE ALPHA', 248780),
(387421, 'PTHR11255:SF102', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE', 248780),
(387422, 'PTHR11255:SF103', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE', 248780),
(387423, 'PTHR11255:SF36', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE GAMMA', 248780),
(387424, 'PTHR11255:SF100', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE', 248780),
(387425, 'PTHR11255:SF101', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE', 248780),
(387426, 'PTHR11255:SF37', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE ETA', 248780),
(387427, 'PTHR11255:SF92', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE IOTA', 248780),
(387428, 'PTHR11255', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE', 248780),
(387429, 'PTHR11255:SF96', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE', 248780),
(387430, 'PTHR11255:SF30', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE DELTA', 248780),
(387431, 'PTHR11255:SF53', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE', 248780),
(387432, 'PTHR11255:SF29', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE', 248780),
(387433, 'PTHR11255:SF43', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE ZETA', 248780),
(387434, 'PTHR11255:SF115', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE 7', 248780),
(387435, 'PTHR11255:SF88', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE 4', 248780),
(387436, 'PTHR11255:SF113', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE', 248780),
(387437, 'PTHR11255:SF114', NULL, NULL, NULL, NULL, 'EYE-SPECIFIC DIACYLGLYCEROL KINASE', 248780),
(387438, 'PTHR11255:SF47', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE', 248780),
(387439, 'PTHR11255:SF111', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE', 248780),
(387440, 'PTHR11255:SF112', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE', 248780),
(387441, 'PTHR11255:SF48', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE 1', 248780),
(387442, 'PTHR11255:SF81', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE', 248780),
(387443, 'PTHR11255:SF82', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE', 248780),
(387444, 'PTHR11255:SF80', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE 3', 248780),
(387445, 'PTHR24257:SF24', NULL, NULL, NULL, NULL, 'CHYMOTRYPSIN-LIKE ELASTASE FAMILY MEMBER 2A', 248781),
(387446, 'PTHR24257:SF11', NULL, NULL, NULL, NULL, 'CHYMOTRYPSIN-LIKE ELASTASE FAMILY MEMBER 3A', 248781),
(387447, 'PTHR24257:SF22', NULL, NULL, NULL, NULL, 'CHYMOTRYPSIN-LIKE ELASTASE FAMILY MEMBER 3B', 248781),
(387448, 'PTHR24257:SF10', NULL, NULL, NULL, NULL, 'ZGC:112285-RELATED', 248781),
(387449, 'PTHR24257:SF17', NULL, NULL, NULL, NULL, '', 248781),
(387450, 'PTHR24257:SF16', NULL, NULL, NULL, NULL, 'NEUTROPHIL ELASTASE', 248781),
(387451, 'PTHR24257:SF15', NULL, NULL, NULL, NULL, 'MYELOBLASTIN', 248781),
(387452, 'PTHR24257:SF25', NULL, NULL, NULL, NULL, 'CHYMOTRYPSIN-C', 248781),
(387453, 'PTHR24257', NULL, NULL, NULL, NULL, 'CHYMOTRYPSIN-LIKE ELASTASE FAMILY MEMBER', 248781),
(387454, 'PTHR24257:SF19', NULL, NULL, NULL, NULL, 'CHYMOTRYPSIN-LIKE ELASTASE FAMILY MEMBER 2B', 248781),
(387455, 'PTHR24257:SF0', NULL, NULL, NULL, NULL, 'CHYMOTRYPSIN-LIKE ELASTASE FAMILY MEMBER 1', 248781),
(387456, 'PTHR13174', NULL, NULL, NULL, NULL, 'D-GLUCURONYL C5-EPIMERASE', 248782),
(387457, 'PTHR13174:SF3', NULL, NULL, NULL, NULL, 'D-GLUCURONYL C5-EPIMERASE', 248782),
(387458, 'PTHR28616', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 125', 248783),
(387459, 'PTHR28616:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 125', 248783),
(387460, 'PTHR46525', NULL, NULL, NULL, NULL, 'EMB|CAB72159.1', 248784),
(387461, 'PTHR46525:SF6', NULL, NULL, NULL, NULL, 'ARABIDOPSIS THALIANA GENOMIC DNA, CHROMOSOME 5, P1 CLONE:MOK16', 248784),
(387462, 'PTHR46525:SF7', NULL, NULL, NULL, NULL, 'HELICASE C-TERMINAL DOMAIN-CONTAINING PROTEIN', 248784),
(387463, 'PTHR46525:SF2', NULL, NULL, NULL, NULL, 'EMB|CAB72159.1', 248784),
(387464, 'PTHR46525:SF18', NULL, NULL, NULL, NULL, '', 248784),
(387465, 'PTHR46525:SF4', NULL, NULL, NULL, NULL, 'DUF584 DOMAIN-CONTAINING PROTEIN', 248784);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(387466, 'PTHR46525:SF19', NULL, NULL, NULL, NULL, '', 248784),
(387467, 'PTHR46525:SF16', NULL, NULL, NULL, NULL, '', 248784),
(387468, 'PTHR46525:SF17', NULL, NULL, NULL, NULL, '', 248784),
(387469, 'PTHR46525:SF23', NULL, NULL, NULL, NULL, 'OS02G0629000 PROTEIN', 248784),
(387470, 'PTHR46525:SF13', NULL, NULL, NULL, NULL, 'SENESCENCE REGULATOR S40-RELATED', 248784),
(387471, 'PTHR46525:SF10', NULL, NULL, NULL, NULL, '', 248784),
(387472, 'PTHR46525:SF21', NULL, NULL, NULL, NULL, 'SENESCENCE REGULATOR S40-RELATED', 248784),
(387473, 'PTHR46525:SF22', NULL, NULL, NULL, NULL, 'BNACNNG02970D PROTEIN', 248784),
(387474, 'PTHR46525:SF20', NULL, NULL, NULL, NULL, 'SENESCENCE REGULATOR', 248784),
(387475, 'PTHR31465:SF1', NULL, NULL, NULL, NULL, 'PROTEIN RTA1-RELATED', 248785),
(387476, 'PTHR31465:SF33', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G01310)-RELATED', 248785),
(387477, 'PTHR31465:SF11', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G10770)-RELATED', 248785),
(387478, 'PTHR31465:SF7', NULL, NULL, NULL, NULL, '', 248785),
(387479, 'PTHR31465:SF34', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G00480)-RELATED', 248785),
(387480, 'PTHR31465:SF31', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G09550)-RELATED', 248785),
(387481, 'PTHR31465:SF8', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G14140)-RELATED', 248785),
(387482, 'PTHR31465:SF9', NULL, NULL, NULL, NULL, 'SPHINGOID LONG-CHAIN BASE TRANSPORTER RSB1', 248785),
(387483, 'PTHR31465:SF32', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE-RELATED', 248785),
(387484, 'PTHR31465:SF30', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE-RELATED', 248785),
(387485, 'PTHR31465:SF17', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G09900)-RELATED', 248785),
(387486, 'PTHR31465:SF28', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE-RELATED', 248785),
(387487, 'PTHR31465:SF29', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G17890)-RELATED', 248785),
(387488, 'PTHR31465:SF37', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248785),
(387489, 'PTHR31465:SF15', NULL, NULL, NULL, NULL, 'LIPID TRANSPORTER ATNI-RELATED', 248785),
(387490, 'PTHR31465:SF27', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G01030)-RELATED', 248785),
(387491, 'PTHR31465:SF13', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G12830)-RELATED', 248785),
(387492, 'PTHR31465', NULL, NULL, NULL, NULL, 'PROTEIN RTA1-RELATED', 248785),
(387493, 'PTHR31465:SF35', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G01970)-RELATED', 248785),
(387494, 'PTHR13009:SF8', NULL, NULL, NULL, NULL, 'AHA1 DOMAIN-CONTAINING PROTEIN', 248786),
(387495, 'PTHR13009:SF4', NULL, NULL, NULL, NULL, 'ACTIVATOR OF 90 KDA HEAT SHOCK PROTEIN ATPASE HOMOLOG 2-RELATED', 248786),
(387496, 'PTHR13009:SF7', NULL, NULL, NULL, NULL, 'ACTIVATOR OF 90 KDA HEAT SHOCK PROTEIN ATPASE HOMOLOG 1', 248786),
(387497, 'PTHR13009:SF34', NULL, NULL, NULL, NULL, 'AHA1, ACTIVATOR OF HEAT SHOCK PROTEIN ATPASE HOMOLOG 1B', 248786),
(387498, 'PTHR13009:SF23', NULL, NULL, NULL, NULL, 'AHA1_N DOMAIN-CONTAINING PROTEIN', 248786),
(387499, 'PTHR13009:SF33', NULL, NULL, NULL, NULL, 'AHA1, ACTIVATOR OF HEAT SHOCK PROTEIN ATPASE HOMOLOG 1A', 248786),
(387500, 'PTHR13009:SF22', NULL, NULL, NULL, NULL, 'LD43819P', 248786),
(387501, 'PTHR13009', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 90  HSP90  CO-CHAPERONE AHA-1', 248786),
(387502, 'PTHR13009:SF32', NULL, NULL, NULL, NULL, 'AHA1_N DOMAIN-CONTAINING PROTEIN', 248786),
(387503, 'PTHR13009:SF21', NULL, NULL, NULL, NULL, 'ACTIVATOR OF HSP90 ATPASE', 248786),
(387504, 'PTHR13009:SF31', NULL, NULL, NULL, NULL, 'OS02G0139100 PROTEIN', 248786),
(387505, 'PTHR13009:SF15', NULL, NULL, NULL, NULL, 'HSP90 CO-CHAPERONE HCH1', 248786),
(387506, 'PTHR13009:SF29', NULL, NULL, NULL, NULL, 'ACTIVATOR OF 90 KDA HEAT SHOCK ATPASE-LIKE PROTEIN', 248786);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(387507, 'PTHR23277:SF120', NULL, NULL, NULL, NULL, 'PVR CELL ADHESION MOLECULE-RELATED 2-LIKE-RELATED', 248787),
(387508, 'PTHR23277', NULL, NULL, NULL, NULL, 'NECTIN-RELATED', 248787),
(387509, 'PTHR23277:SF12', NULL, NULL, NULL, NULL, 'NECTIN-3', 248787),
(387510, 'PTHR23277:SF106', NULL, NULL, NULL, NULL, 'SI:CH211-141E20.2-RELATED', 248787),
(387511, 'PTHR23277:SF117', NULL, NULL, NULL, NULL, 'IMMUNOGLOBIN SUPERFAMILY, MEMBER 21A', 248787),
(387512, 'PTHR23277:SF11', NULL, NULL, NULL, NULL, 'NECTIN-4', 248787),
(387513, 'PTHR23277:SF118', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN SUPERFAMILY MEMBER 21', 248787),
(387514, 'PTHR23277:SF107', NULL, NULL, NULL, NULL, 'HEMICENTIN-1', 248787),
(387515, 'PTHR23277:SF119', NULL, NULL, NULL, NULL, 'IGSF21B', 248787),
(387516, 'PTHR23277:SF108', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 248787),
(387517, 'PTHR23277:SF69', NULL, NULL, NULL, NULL, 'NECTIN-1', 248787),
(387518, 'PTHR23277:SF114', NULL, NULL, NULL, NULL, 'NECTIN CELL ADHESION MOLECULE 1A', 248787),
(387519, 'PTHR23277:SF109', NULL, NULL, NULL, NULL, 'POLIOVIRUS RECEPTOR', 248787),
(387520, 'PTHR38745:SF1', NULL, NULL, NULL, NULL, 'TYR_PHOSPHATASE_2 DOMAIN-CONTAINING PROTEIN', 248788),
(387521, 'PTHR38745', NULL, NULL, NULL, NULL, 'PHOSPHATASE, PUTATIVE-RELATED', 248788),
(387522, 'PTHR38745:SF2', NULL, NULL, NULL, NULL, 'PHOSPHATASE, PUTATIVE-RELATED', 248788),
(387523, 'PTHR31239', NULL, NULL, NULL, NULL, 'NICOLIN 1', 248789),
(387524, 'PTHR31239:SF3', NULL, NULL, NULL, NULL, '', 248789),
(387525, 'PTHR31239:SF4', NULL, NULL, NULL, NULL, 'NICOLIN-1', 248789),
(387526, 'PTHR31239:SF2', NULL, NULL, NULL, NULL, 'NICOLIN-1', 248789),
(387527, 'PTHR31636:SF305', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387528, 'PTHR31636:SF269', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387529, 'PTHR31636:SF302', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387530, 'PTHR31636:SF148', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387531, 'PTHR31636:SF301', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 14', 248790),
(387532, 'PTHR31636:SF304', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GRAS-RELATED', 248790),
(387533, 'PTHR31636:SF149', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 27', 248790),
(387534, 'PTHR31636:SF303', NULL, NULL, NULL, NULL, 'CHITIN-INDUCIBLE GIBBERELLIN-RESPONSIVE PROTEIN 2', 248790),
(387535, 'PTHR31636:SF265', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387536, 'PTHR31636:SF144', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387537, 'PTHR31636:SF300', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387538, 'PTHR31636:SF266', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387539, 'PTHR31636:SF145', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 18', 248790),
(387540, 'PTHR31636:SF261', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GRAS-RELATED', 248790),
(387541, 'PTHR31636:SF260', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GRAS-RELATED', 248790),
(387542, 'PTHR31636:SF142', NULL, NULL, NULL, NULL, 'GRAS FAMILY TRANSCRIPTION FACTOR', 248790),
(387543, 'PTHR31636:SF263', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GRAS, SCARECROW-LIKE PROTEIN 8-RELATED', 248790),
(387544, 'PTHR31636:SF262', NULL, NULL, NULL, NULL, 'DELLA PROTEIN GAI', 248790),
(387545, 'PTHR31636:SF258', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 9', 248790),
(387546, 'PTHR31636:SF136', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 6', 248790),
(387547, 'PTHR31636:SF139', NULL, NULL, NULL, NULL, 'OS04G0555000 PROTEIN', 248790),
(387548, 'PTHR31636:SF259', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387549, 'PTHR31636:SF138', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387550, 'PTHR31636:SF254', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GRAS-RELATED', 248790),
(387551, 'PTHR31636:SF253', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(387552, 'PTHR31636:SF255', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 31', 248790),
(387553, 'PTHR31636:SF131', NULL, NULL, NULL, NULL, 'OS01G0842200 PROTEIN', 248790),
(387554, 'PTHR31636:SF252', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387555, 'PTHR31636:SF207', NULL, NULL, NULL, NULL, 'GRAS FAMILY TRANSCRIPTION FACTOR', 248790),
(387556, 'PTHR31636:SF209', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387557, 'PTHR31636:SF208', NULL, NULL, NULL, NULL, 'GRAS TRANSCRIPTION FACTOR', 248790),
(387558, 'PTHR31636:SF169', NULL, NULL, NULL, NULL, 'PROTEIN SHORT-ROOT 2', 248790),
(387559, 'PTHR31636:SF205', NULL, NULL, NULL, NULL, 'OS10G0551200 PROTEIN', 248790),
(387560, 'PTHR31636:SF166', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 34', 248790),
(387561, 'PTHR31636:SF165', NULL, NULL, NULL, NULL, 'GRAS TRANSCRIPTION FACTOR', 248790),
(387562, 'PTHR31636:SF286', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387563, 'PTHR31636:SF201', NULL, NULL, NULL, NULL, 'GRAS FAMILY TRANSCRIPTION FACTOR', 248790),
(387564, 'PTHR31636:SF168', NULL, NULL, NULL, NULL, 'DELLA PROTEIN RGL3', 248790),
(387565, 'PTHR31636:SF200', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 3', 248790),
(387566, 'PTHR31636:SF167', NULL, NULL, NULL, NULL, 'CHITIN-INDUCIBLE GIBBERELLIN-RESPONSIVE PROTEIN 1-LIKE', 248790),
(387567, 'PTHR31636:SF288', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387568, 'PTHR31636:SF161', NULL, NULL, NULL, NULL, 'OS02G0197300 PROTEIN', 248790),
(387569, 'PTHR31636:SF163', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387570, 'PTHR31636:SF284', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GRAS-RELATED', 248790),
(387571, 'PTHR31636:SF281', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 30', 248790),
(387572, 'PTHR31636:SF160', NULL, NULL, NULL, NULL, 'GRAS FAMILY TRANSCRIPTION FACTOR', 248790),
(387573, 'PTHR31636:SF280', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GRAS, SCARECROW-LIKE PROTEIN 29/NODULATION SIGNALING PATHWAY 1-RELATED', 248790),
(387574, 'PTHR31636:SF20', NULL, NULL, NULL, NULL, 'GRAS FAMILY TRANSCRIPTION FACTOR CONTAINING PROTEIN, EXPRESSED', 248790),
(387575, 'PTHR31636:SF21', NULL, NULL, NULL, NULL, 'OS12G0138200 PROTEIN', 248790),
(387576, 'PTHR31636:SF159', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 3', 248790),
(387577, 'PTHR31636:SF158', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 33', 248790),
(387578, 'PTHR31636:SF279', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387579, 'PTHR31636:SF276', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387580, 'PTHR31636:SF275', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387581, 'PTHR31636:SF278', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 11', 248790),
(387582, 'PTHR31636:SF157', NULL, NULL, NULL, NULL, 'GRAS FAMILY TRANSCRIPTION FACTOR', 248790),
(387583, 'PTHR31636:SF277', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 22', 248790),
(387584, 'PTHR31636:SF156', NULL, NULL, NULL, NULL, 'OS05G0574900 PROTEIN', 248790),
(387585, 'PTHR31636:SF151', NULL, NULL, NULL, NULL, 'CHITIN-INDUCIBLE GIBBERELLIN-RESPONSIVE PROTEIN 1', 248790),
(387586, 'PTHR31636:SF150', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387587, 'PTHR31636:SF271', NULL, NULL, NULL, NULL, 'DELLA PROTEIN GAI-RELATED', 248790),
(387588, 'PTHR31636:SF19', NULL, NULL, NULL, NULL, 'OSJNBA0084A10.13 PROTEIN', 248790),
(387589, 'PTHR31636:SF274', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387590, 'PTHR31636:SF153', NULL, NULL, NULL, NULL, 'OS02G0662700 PROTEIN', 248790),
(387591, 'PTHR31636:SF273', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GRAS-RELATED', 248790),
(387592, 'PTHR31636', NULL, NULL, NULL, NULL, 'OSJNBA0084A10.13 PROTEIN-RELATED', 248790),
(387593, 'PTHR31636:SF13', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 3', 248790),
(387594, 'PTHR31636:SF14', NULL, NULL, NULL, NULL, 'GRAS FAMILY TRANSCRIPTION FACTOR CONTAINING PROTEIN, EXPRESSED', 248790); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(387595, 'PTHR31636:SF12', NULL, NULL, NULL, NULL, 'PROTEIN SCARECROW', 248790),
(387596, 'PTHR31636:SF18', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE TRANSCRIPTION FACTOR PAT1', 248790),
(387597, 'PTHR31636:SF16', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 28', 248790),
(387598, 'PTHR31636:SF229', NULL, NULL, NULL, NULL, 'GRAS FAMILY TRANSCRIPTION FACTOR-RELATED', 248790),
(387599, 'PTHR31636:SF228', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387600, 'PTHR31636:SF32', NULL, NULL, NULL, NULL, 'OS11G0141500 PROTEIN', 248790),
(387601, 'PTHR31636:SF9', NULL, NULL, NULL, NULL, 'PROTEIN SHORT-ROOT', 248790),
(387602, 'PTHR31636:SF225', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GRAS-RELATED', 248790),
(387603, 'PTHR31636:SF4', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 1', 248790),
(387604, 'PTHR31636:SF5', NULL, NULL, NULL, NULL, 'OS05G0500600 PROTEIN', 248790),
(387605, 'PTHR31636:SF224', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 13', 248790),
(387606, 'PTHR31636:SF227', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387607, 'PTHR31636:SF7', NULL, NULL, NULL, NULL, 'OS01G0646300 PROTEIN', 248790),
(387608, 'PTHR31636:SF226', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 14', 248790),
(387609, 'PTHR31636:SF188', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387610, 'PTHR31636:SF221', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 8', 248790),
(387611, 'PTHR31636:SF220', NULL, NULL, NULL, NULL, 'GRAS FAMILY TRANSCRIPTION REGULATOR', 248790),
(387612, 'PTHR31636:SF187', NULL, NULL, NULL, NULL, 'DELLA PROTEIN RGL1-LIKE', 248790),
(387613, 'PTHR31636:SF223', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387614, 'PTHR31636:SF2', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 18', 248790),
(387615, 'PTHR31636:SF3', NULL, NULL, NULL, NULL, 'GRAS FAMILY PROTEIN RAM1', 248790),
(387616, 'PTHR31636:SF189', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 3', 248790),
(387617, 'PTHR31636:SF184', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387618, 'PTHR31636:SF183', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 9', 248790),
(387619, 'PTHR31636:SF186', NULL, NULL, NULL, NULL, 'GRAS FAMILY TRANSCRIPTION FACTOR', 248790),
(387620, 'PTHR31636:SF180', NULL, NULL, NULL, NULL, 'GRAS FAMILY TRANSCRIPTION FACTOR', 248790),
(387621, 'PTHR31636:SF182', NULL, NULL, NULL, NULL, 'OS02G0681900 PROTEIN', 248790),
(387622, 'PTHR31636:SF181', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 21', 248790),
(387623, 'PTHR31636:SF24', NULL, NULL, NULL, NULL, 'GRAS FAMILY PROTEIN RAD1', 248790),
(387624, 'PTHR31636:SF25', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 26', 248790),
(387625, 'PTHR31636:SF22', NULL, NULL, NULL, NULL, 'OS05G0485400 PROTEIN', 248790),
(387626, 'PTHR31636:SF23', NULL, NULL, NULL, NULL, 'OS04G0590400 PROTEIN', 248790),
(387627, 'PTHR31636:SF27', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387628, 'PTHR31636:SF218', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387629, 'PTHR31636:SF217', NULL, NULL, NULL, NULL, 'DELLA PROTEIN RGL1-LIKE', 248790),
(387630, 'PTHR31636:SF43', NULL, NULL, NULL, NULL, 'OS06G0105350 PROTEIN', 248790),
(387631, 'PTHR31636:SF40', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 29', 248790),
(387632, 'PTHR31636:SF41', NULL, NULL, NULL, NULL, 'GRAS FAMILY TRANSCRIPTION FACTOR CONTAINING PROTEIN', 248790),
(387633, 'PTHR31636:SF214', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387634, 'PTHR31636:SF216', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387635, 'PTHR31636:SF215', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387636, 'PTHR31636:SF210', NULL, NULL, NULL, NULL, 'DELLA PROTEIN RGL1-LIKE', 248790),
(387637, 'PTHR31636:SF298', NULL, NULL, NULL, NULL, 'DELLA PROTEIN RGA2-LIKE', 248790),
(387638, 'PTHR31636:SF176', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 29', 248790),
(387639, 'PTHR31636:SF297', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(387640, 'PTHR31636:SF179', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387641, 'PTHR31636:SF178', NULL, NULL, NULL, NULL, 'GRAS FAMILY TRANSCRIPTION FACTOR', 248790),
(387642, 'PTHR31636:SF299', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387643, 'PTHR31636:SF294', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387644, 'PTHR31636:SF172', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387645, 'PTHR31636:SF293', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 13', 248790),
(387646, 'PTHR31636:SF175', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 3', 248790),
(387647, 'PTHR31636:SF296', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GRAS-RELATED', 248790),
(387648, 'PTHR31636:SF295', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387649, 'PTHR31636:SF171', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387650, 'PTHR31636:SF292', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GRAS, PROTEIN SHORT-ROOT-RELATED', 248790),
(387651, 'PTHR31636:SF291', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387652, 'PTHR31636:SF170', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387653, 'PTHR31636:SF35', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 23', 248790),
(387654, 'PTHR31636:SF34', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387655, 'PTHR31636:SF129', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 14', 248790),
(387656, 'PTHR31636:SF51', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 32', 248790),
(387657, 'PTHR31636:SF247', NULL, NULL, NULL, NULL, 'DELLA PROTEIN', 248790),
(387658, 'PTHR31636:SF246', NULL, NULL, NULL, NULL, 'DELLA PROTEIN RGL2', 248790),
(387659, 'PTHR31636:SF249', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387660, 'PTHR31636:SF248', NULL, NULL, NULL, NULL, 'GRAS FAMILY TRANSCRIPTION FACTOR', 248790),
(387661, 'PTHR31636:SF243', NULL, NULL, NULL, NULL, 'NODULATION-SIGNALING PATHWAY 1 PROTEIN-LIKE', 248790),
(387662, 'PTHR31636:SF242', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387663, 'PTHR31636:SF245', NULL, NULL, NULL, NULL, 'DELLA PROTEIN', 248790),
(387664, 'PTHR31636:SF244', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GRAS-RELATED', 248790),
(387665, 'PTHR31636:SF241', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387666, 'PTHR31636:SF47', NULL, NULL, NULL, NULL, 'DELLA PROTEIN RGL1', 248790),
(387667, 'PTHR31636:SF45', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 13', 248790),
(387668, 'PTHR31636:SF48', NULL, NULL, NULL, NULL, 'GRAS FAMILY PROTEIN TF80', 248790),
(387669, 'PTHR31636:SF60', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387670, 'PTHR31636:SF65', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 4-RELATED', 248790),
(387671, 'PTHR31636:SF239', NULL, NULL, NULL, NULL, 'GRAS FAMILY TRANSCRIPTION FACTOR', 248790),
(387672, 'PTHR31636:SF235', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387673, 'PTHR31636:SF238', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387674, 'PTHR31636:SF237', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387675, 'PTHR31636:SF232', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387676, 'PTHR31636:SF199', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387677, 'PTHR31636:SF231', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387678, 'PTHR31636:SF198', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 15', 248790),
(387679, 'PTHR31636:SF234', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387680, 'PTHR31636:SF233', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387681, 'PTHR31636:SF194', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387682, 'PTHR31636:SF197', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387683, 'PTHR31636:SF230', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(387684, 'PTHR31636:SF191', NULL, NULL, NULL, NULL, 'GRAS FAMILY TRANSCRIPTION FACTOR', 248790),
(387685, 'PTHR31636:SF193', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 5', 248790),
(387686, 'PTHR31636:SF192', NULL, NULL, NULL, NULL, 'GRAS DOMAIN-CONTAINING PROTEIN', 248790),
(387687, 'PTHR31636:SF55', NULL, NULL, NULL, NULL, 'OS11G0160550 PROTEIN', 248790),
(387688, 'PTHR31636:SF56', NULL, NULL, NULL, NULL, 'SCARECROW-LIKE PROTEIN 30', 248790),
(387689, 'PTHR31636:SF59', NULL, NULL, NULL, NULL, 'OS11G0139600 PROTEIN', 248790),
(387690, 'PTHR47701:SF3', NULL, NULL, NULL, NULL, 'PROTEIN MODIFIER OF SNC1 11-LIKE', 248791),
(387691, 'PTHR47701:SF2', NULL, NULL, NULL, NULL, 'PROTEIN MODIFIER OF SNC1 11', 248791),
(387692, 'PTHR47701:SF5', NULL, NULL, NULL, NULL, 'THO1_MOS11_C DOMAIN-CONTAINING PROTEIN', 248791),
(387693, 'PTHR47701', NULL, NULL, NULL, NULL, 'PROTEIN MODIFIER OF SNC1 11', 248791),
(387694, 'PTHR10902:SF23', NULL, NULL, NULL, NULL, '', 248792),
(387695, 'PTHR10902:SF12', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L33-B', 248792),
(387696, 'PTHR10902:SF13', NULL, NULL, NULL, NULL, 'OS05G0556900 PROTEIN', 248792),
(387697, 'PTHR10902:SF28', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L35A-1-LIKE', 248792),
(387698, 'PTHR10902:SF19', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L35A', 248792),
(387699, 'PTHR10902', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L35A', 248792),
(387700, 'PTHR10902:SF30', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L35A', 248792),
(387701, 'PTHR10902:SF20', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L35A-1', 248792),
(387702, 'PTHR10902:SF31', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L35A-3-LIKE', 248792),
(387703, 'PTHR10902:SF32', NULL, NULL, NULL, NULL, '', 248792),
(387704, 'PTHR10902:SF21', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L35A-1-RELATED', 248792),
(387705, 'PTHR10902:SF33', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L35A, TRANSLATION PROTEIN, BETA-BARREL DOMAIN PROTEIN-RELATED', 248792),
(387706, 'PTHR10902:SF0', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L35A', 248792),
(387707, 'PTHR10902:SF22', NULL, NULL, NULL, NULL, 'BNAA02G16870D PROTEIN', 248792),
(387708, 'PTHR10500:SF0', NULL, NULL, NULL, NULL, '', 248793),
(387709, 'PTHR10500', NULL, NULL, NULL, NULL, 'BETA-MICROSEMINOPROTEIN', 248793),
(387710, 'PTHR10500:SF4', NULL, NULL, NULL, NULL, 'PROSTATE-ASSOCIATED MICROSEMINOPROTEIN', 248793),
(387711, 'PTHR10500:SF6', NULL, NULL, NULL, NULL, '', 248793),
(387712, 'PTHR10500:SF8', NULL, NULL, NULL, NULL, 'BETA-MICROSEMINOPROTEIN', 248793),
(387713, 'PTHR10500:SF7', NULL, NULL, NULL, NULL, 'SI:CH73-288O11.4', 248793),
(387714, 'PTHR39555', NULL, NULL, NULL, NULL, 'FIMBRIAL ASSEMBLY PROTEIN PILO-LIKE PROTEIN-RELATED', 248794),
(387715, 'PTHR39555:SF1', NULL, NULL, NULL, NULL, 'TYPE IV PILUS INNER MEMBRANE COMPONENT PILO', 248794),
(387716, 'PTHR46599:SF1', NULL, NULL, NULL, NULL, 'POGO TRANSPOSABLE ELEMENT-DERIVED WITH ZNF DOMAIN B', 248795),
(387717, 'PTHR46599:SF2', NULL, NULL, NULL, NULL, 'SI:CH211-130M23.5', 248795),
(387718, 'PTHR46599:SF3', NULL, NULL, NULL, NULL, 'LD40589P', 248795),
(387719, 'PTHR46599:SF6', NULL, NULL, NULL, NULL, 'DDE_TNP_1_7 DOMAIN-CONTAINING PROTEIN', 248795),
(387720, 'PTHR46599:SF8', NULL, NULL, NULL, NULL, 'PIGGYBAC TRANSPOSABLE ELEMENT-DERIVED PROTEIN 4', 248795),
(387721, 'PTHR46599', NULL, NULL, NULL, NULL, 'PIGGYBAC TRANSPOSABLE ELEMENT-DERIVED PROTEIN 4', 248795),
(387722, 'PTHR11414', NULL, NULL, NULL, NULL, 'CYSTATIN FAMILY MEMBER', 248796),
(387723, 'PTHR11414:SF17', NULL, NULL, NULL, NULL, 'STEFIN A2-LIKE 1-RELATED', 248796),
(387724, 'PTHR11414:SF16', NULL, NULL, NULL, NULL, 'CYSTATIN A FAMILY MEMBER 3-RELATED', 248796),
(387725, 'PTHR11414:SF25', NULL, NULL, NULL, NULL, '2010005H15RIK PROTEIN-RELATED', 248796),
(387726, 'PTHR11414:SF22', NULL, NULL, NULL, NULL, 'CYSTATIN-B', 248796),
(387727, 'PTHR11414:SF21', NULL, NULL, NULL, NULL, 'CYSTATIN 14A, TANDEM DUPLICATE 1-RELATED', 248796),
(387728, 'PTHR11414:SF20', NULL, NULL, NULL, NULL, 'CYSTATIN-A', 248796);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(387729, 'PTHR16036:SF2', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND ZINC FINGER DOMAIN-CONTAINING PROTEIN 1', 248797),
(387730, 'PTHR16036:SF3', NULL, NULL, NULL, NULL, 'ZINC FINGER, C2H2, ANKYRIN REPEAT-CONTAINING DOMAIN PROTEIN-RELATED', 248797),
(387731, 'PTHR16036', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND ZINC FINGER DOMAIN-CONTAINING PROTEIN 1', 248797),
(387732, 'PTHR36843:SF1', NULL, NULL, NULL, NULL, 'COPROHEME DECARBOXYLASE', 248798),
(387733, 'PTHR36843', NULL, NULL, NULL, NULL, 'HEME-DEPENDENT PEROXIDASE YWFI-RELATED', 248798),
(387734, 'PTHR30572:SF9', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN-RELATED', 248799),
(387735, 'PTHR30572:SF14', NULL, NULL, NULL, NULL, 'MACROLIDE EXPORT ATP-BINDING/PERMEASE PROTEIN MACB', 248799),
(387736, 'PTHR30572:SF17', NULL, NULL, NULL, NULL, 'ABC-TYPE MACROLIDE FAMILY EXPORT SYSTEM PERMEASE COMPONENT 2', 248799),
(387737, 'PTHR30572:SF15', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, MEMBRANE PROTEIN', 248799),
(387738, 'PTHR30572:SF4', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE YTRF', 248799),
(387739, 'PTHR30572', NULL, NULL, NULL, NULL, 'MEMBRANE COMPONENT OF TRANSPORTER-RELATED', 248799),
(387740, 'PTHR30572:SF7', NULL, NULL, NULL, NULL, 'MACROLIDE EXPORT ATP-BINDING/PERMEASE PROTEIN MACB', 248799),
(387741, 'PTHR11228:SF34', NULL, NULL, NULL, NULL, 'TUNGSTEN-CONTAINING ALDEHYDE FERREDOXIN OXIDOREDUCTASE COFACTOR MODIFYING PROTEIN', 248800),
(387742, 'PTHR11228:SF35', NULL, NULL, NULL, NULL, 'MOLYBDENUM COFACTOR BIOSYNTHESIS PROTEIN A-RELATED', 248800),
(387743, 'PTHR11228:SF22', NULL, NULL, NULL, NULL, 'SLR1507 PROTEIN', 248800),
(387744, 'PTHR11228:SF7', NULL, NULL, NULL, NULL, 'ANTILISTERIAL BACTERIOCIN SUBTILOSIN BIOSYNTHESIS PROTEIN ALBA', 248800),
(387745, 'PTHR11228', NULL, NULL, NULL, NULL, 'RADICAL SAM DOMAIN PROTEIN', 248800),
(387746, 'PTHR11228:SF27', NULL, NULL, NULL, NULL, 'GLYCYL-RADICAL ENZYME ACTIVATING ENZYME MJ1227-RELATED', 248800),
(387747, 'PTHR33878', NULL, NULL, NULL, NULL, 'OS08G0559000 PROTEIN', 248801),
(387748, 'PTHR33878:SF1', NULL, NULL, NULL, NULL, 'OS08G0559000 PROTEIN', 248801),
(387749, 'PTHR33878:SF4', NULL, NULL, NULL, NULL, 'OS08G0558900 PROTEIN', 248801),
(387750, 'PTHR33878:SF11', NULL, NULL, NULL, NULL, 'OS02G0533800 PROTEIN', 248801),
(387751, 'PTHR33878:SF3', NULL, NULL, NULL, NULL, 'ATPASE INHIBITOR', 248801),
(387752, 'PTHR33878:SF12', NULL, NULL, NULL, NULL, '', 248801),
(387753, 'PTHR33878:SF8', NULL, NULL, NULL, NULL, '', 248801),
(387754, 'PTHR33878:SF6', NULL, NULL, NULL, NULL, '', 248801),
(387755, 'PTHR46436:SF1', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 76 KDA', 248802),
(387756, 'PTHR46436:SF2', NULL, NULL, NULL, NULL, 'DOUBLE C2-LIKE DOMAIN-CONTAINING PROTEIN', 248802),
(387757, 'PTHR46436', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 76 KDA', 248802),
(387758, 'PTHR11280', NULL, NULL, NULL, NULL, 'GLUCOSAMINE-6-PHOSPHATE ISOMERASE', 248803),
(387759, 'PTHR11280:SF9', NULL, NULL, NULL, NULL, 'GLUCOSAMINE-6-PHOSPHATE ISOMERASE 2', 248803),
(387760, 'PTHR11280:SF8', NULL, NULL, NULL, NULL, 'GLUCOSAMINE-6-PHOSPHATE ISOMERASE 1', 248803),
(387761, 'PTHR11280:SF5', NULL, NULL, NULL, NULL, 'GLUCOSAMINE-6-PHOSPHATE ISOMERASE', 248803),
(387762, 'PTHR11280:SF6', NULL, NULL, NULL, NULL, 'GLUCOSAMINE-6-PHOSPHATE ISOMERASE NAGB', 248803),
(387763, 'PTHR40620:SF1', NULL, NULL, NULL, NULL, 'RESISTANCE PROTEIN CRD2, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G04318)-RELATED', 248804),
(387764, 'PTHR40620', NULL, NULL, NULL, NULL, 'RESISTANCE PROTEIN CRD2, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G04318)-RELATED', 248804),
(387765, 'PTHR39666:SF1', NULL, NULL, NULL, NULL, 'RANBP2-TYPE DOMAIN-CONTAINING PROTEIN', 248805),
(387766, 'PTHR39666:SF4', NULL, NULL, NULL, NULL, '', 248805),
(387767, 'PTHR39666', NULL, NULL, NULL, NULL, 'RANBP2-TYPE DOMAIN-CONTAINING PROTEIN', 248805),
(387768, 'PTHR19328:SF67', NULL, NULL, NULL, NULL, 'HIPL1 PROTEIN-LIKE', 248806),
(387769, 'PTHR19328:SF66', NULL, NULL, NULL, NULL, 'CATALYTICS', 248806),
(387770, 'PTHR19328:SF55', NULL, NULL, NULL, NULL, 'BLR6566 PROTEIN', 248806);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(387771, 'PTHR19328:SF32', NULL, NULL, NULL, NULL, 'HHIP-LIKE PROTEIN 1', 248806),
(387772, 'PTHR19328:SF54', NULL, NULL, NULL, NULL, 'HHIP-LIKE PROTEIN 2', 248806),
(387773, 'PTHR19328:SF53', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 248806),
(387774, 'PTHR19328', NULL, NULL, NULL, NULL, 'HEDGEHOG-INTERACTING PROTEIN', 248806),
(387775, 'PTHR19328:SF27', NULL, NULL, NULL, NULL, 'HEDGEHOG-INTERACTING PROTEIN', 248806),
(387776, 'PTHR19328:SF59', NULL, NULL, NULL, NULL, 'HIPL1 PROTEIN-LIKE', 248806),
(387777, 'PTHR19328:SF69', NULL, NULL, NULL, NULL, 'SIX-BLADED BETA-PROPELLER, TOLB-LIKE PROTEIN-RELATED', 248806),
(387778, 'PTHR19328:SF58', NULL, NULL, NULL, NULL, 'SI:CH211-136A13.1', 248806),
(387779, 'PTHR19328:SF35', NULL, NULL, NULL, NULL, 'OS07G0193000 PROTEIN', 248806),
(387780, 'PTHR19328:SF13', NULL, NULL, NULL, NULL, 'HIPL1 PROTEIN', 248806),
(387781, 'PTHR19328:SF70', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 248806),
(387782, 'PTHR19328:SF74', NULL, NULL, NULL, NULL, 'GSDH DOMAIN-CONTAINING PROTEIN', 248806),
(387783, 'PTHR19328:SF40', NULL, NULL, NULL, NULL, 'BLL0591 PROTEIN', 248806),
(387784, 'PTHR19328:SF73', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE, EXPRESSED-RELATED', 248806),
(387785, 'PTHR19328:SF61', NULL, NULL, NULL, NULL, 'HIPL2 PROTEIN', 248806),
(387786, 'PTHR19328:SF60', NULL, NULL, NULL, NULL, 'HIPL1 PROTEIN-LIKE', 248806),
(387787, 'PTHR19328:SF29', NULL, NULL, NULL, NULL, 'CALX-BETA DOMAIN-CONTAINING PROTEIN', 248806),
(387788, 'PTHR10949:SF0', NULL, NULL, NULL, NULL, 'LIPOYL SYNTHASE, MITOCHONDRIAL', 248807),
(387789, 'PTHR10949:SF31', NULL, NULL, NULL, NULL, 'LIPOYL SYNTHASE 1, CHLOROPLASTIC', 248807),
(387790, 'PTHR10949:SF36', NULL, NULL, NULL, NULL, 'LIPOYL SYNTHASE, MITOCHONDRIAL', 248807),
(387791, 'PTHR10949:SF37', NULL, NULL, NULL, NULL, 'LIPOYL SYNTHASE, CHLOROPLASTIC', 248807),
(387792, 'PTHR10949', NULL, NULL, NULL, NULL, 'LIPOYL SYNTHASE', 248807),
(387793, 'PTHR36570', NULL, NULL, NULL, NULL, 'DISULFIDE BOND FORMATION PROTEIN B', 248808),
(387794, 'PTHR36570:SF3', NULL, NULL, NULL, NULL, 'DISULFIDE BOND FORMATION PROTEIN B', 248808),
(387795, 'PTHR36570:SF2', NULL, NULL, NULL, NULL, 'DISULFIDE BOND FORMATION PROTEIN B', 248808),
(387796, 'PTHR36570:SF1', NULL, NULL, NULL, NULL, 'PROTEIN-DISULFIDE OXIDOREDUCTASE DSBI', 248808),
(387797, 'PTHR10657:SF37', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 248809),
(387798, 'PTHR10657:SF38', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 248809),
(387799, 'PTHR10657:SF31', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE NIMA-INTERACTING 1', 248809),
(387800, 'PTHR10657', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 248809),
(387801, 'PTHR10657:SF4', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE-RELATED', 248809),
(387802, 'PTHR10657:SF40', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 248809),
(387803, 'PTHR10657:SF41', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE PIN1', 248809),
(387804, 'PTHR10657:SF30', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 248809),
(387805, 'PTHR10657:SF39', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 248809),
(387806, 'PTHR13153:SF5', NULL, NULL, NULL, NULL, 'GATOR COMPLEX PROTEIN NPRL3', 248810),
(387807, 'PTHR13153', NULL, NULL, NULL, NULL, 'CGTHBA PROTEIN  -14 GENE PROTEIN', 248810),
(387808, 'PTHR21343:SF8', NULL, NULL, NULL, NULL, 'DRTGG DOMAIN-CONTAINING PROTEIN', 248811),
(387809, 'PTHR21343:SF9', NULL, NULL, NULL, NULL, 'LIPID II ISOGLUTAMINYL SYNTHASE (GLUTAMINE-HYDROLYZING) SUBUNIT GATD', 248811),
(387810, 'PTHR21343:SF10', NULL, NULL, NULL, NULL, '', 248811),
(387811, 'PTHR21343:SF1', NULL, NULL, NULL, NULL, 'COBYRIC ACID SYNTHASE', 248811),
(387812, 'PTHR21343', NULL, NULL, NULL, NULL, 'DETHIOBIOTIN SYNTHETASE', 248811),
(387813, 'PTHR21659:SF84', NULL, NULL, NULL, NULL, 'HYDROPHOBIC PROTEIN RCI2B-LIKE', 248812),
(387814, 'PTHR21659:SF40', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLSERINE DECARBOXYLASE', 248812);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(387815, 'PTHR21659:SF41', NULL, NULL, NULL, NULL, 'PROTEIN LTI6B, PUTATIVE, EXPRESSED-RELATED', 248812),
(387816, 'PTHR21659:SF85', NULL, NULL, NULL, NULL, 'CHROMOSOME 8, WHOLE GENOME SHOTGUN SEQUENCE', 248812),
(387817, 'PTHR21659:SF63', NULL, NULL, NULL, NULL, '', 248812),
(387818, 'PTHR21659:SF86', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 248812),
(387819, 'PTHR21659:SF42', NULL, NULL, NULL, NULL, 'UPF0057 MEMBRANE PROTEIN ZK632.10', 248812),
(387820, 'PTHR21659:SF21', NULL, NULL, NULL, NULL, 'OS06G0651900 PROTEIN', 248812),
(387821, 'PTHR21659:SF87', NULL, NULL, NULL, NULL, '', 248812),
(387822, 'PTHR21659:SF81', NULL, NULL, NULL, NULL, 'LOW TEMPERATURE AND SALT RESPONSIVE PROTEIN', 248812),
(387823, 'PTHR21659:SF83', NULL, NULL, NULL, NULL, 'BNAA01G06480D PROTEIN', 248812),
(387824, 'PTHR21659:SF119', NULL, NULL, NULL, NULL, 'LOW TEMPERATURE AND SALT RESPONSIVE PROTEIN FAMILY-RELATED', 248812),
(387825, 'PTHR21659:SF118', NULL, NULL, NULL, NULL, 'HYDROPHOBIC PROTEIN OSR8-RELATED', 248812),
(387826, 'PTHR21659:SF115', NULL, NULL, NULL, NULL, 'HYDROPHOBIC PROTEIN OSR8', 248812),
(387827, 'PTHR21659:SF114', NULL, NULL, NULL, NULL, 'PROTEIN SNA4', 248812),
(387828, 'PTHR21659:SF16', NULL, NULL, NULL, NULL, 'UPF0057 MEMBRANE PROTEIN C04G6.5-RELATED', 248812),
(387829, 'PTHR21659:SF117', NULL, NULL, NULL, NULL, 'OS03G0286900 PROTEIN', 248812),
(387830, 'PTHR21659:SF116', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE PROTEOLIPID 3', 248812),
(387831, 'PTHR21659:SF99', NULL, NULL, NULL, NULL, 'OS05G0122700 PROTEIN', 248812),
(387832, 'PTHR21659:SF11', NULL, NULL, NULL, NULL, 'PROTEIN CBG05141', 248812),
(387833, 'PTHR21659:SF111', NULL, NULL, NULL, NULL, 'PROTEOLIPID MEMBRANE POTENTIAL MODULATOR-RELATED', 248812),
(387834, 'PTHR21659:SF77', NULL, NULL, NULL, NULL, 'BNAC04G36850D PROTEIN', 248812),
(387835, 'PTHR21659:SF113', NULL, NULL, NULL, NULL, 'HYDROPHOBIC PROTEIN RCI2A', 248812),
(387836, 'PTHR21659:SF57', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE PROTEOLIPID 31', 248812),
(387837, 'PTHR21659:SF112', NULL, NULL, NULL, NULL, 'PROTEIN SNA2-RELATED', 248812),
(387838, 'PTHR21659:SF73', NULL, NULL, NULL, NULL, 'HYDROPHOBIC PROTEIN RCI2B', 248812),
(387839, 'PTHR21659:SF96', NULL, NULL, NULL, NULL, 'BNAA04G22250D PROTEIN', 248812),
(387840, 'PTHR21659:SF120', NULL, NULL, NULL, NULL, 'HYDROPHOBIC PROTEIN LTI6B', 248812),
(387841, 'PTHR21659:SF76', NULL, NULL, NULL, NULL, 'HYDROPHOBIC PROTEIN LTI6B', 248812),
(387842, 'PTHR21659:SF10', NULL, NULL, NULL, NULL, 'PROTEIN CBG12708', 248812),
(387843, 'PTHR21659:SF70', NULL, NULL, NULL, NULL, 'HYDROPHOBIC PROTEIN LTI6A', 248812),
(387844, 'PTHR21659', NULL, NULL, NULL, NULL, 'HYDROPHOBIC PROTEIN RCI2  LOW TEMPERATURE AND SALT RESPONSIVE PROTEIN LTI6 -RELATED', 248812),
(387845, 'PTHR21659:SF94', NULL, NULL, NULL, NULL, '', 248812),
(387846, 'PTHR21659:SF90', NULL, NULL, NULL, NULL, 'PROTEIN CBG04231', 248812),
(387847, 'PTHR21659:SF107', NULL, NULL, NULL, NULL, 'PROTEOLIPID MEMBRANE POTENTIAL MODULATOR-RELATED', 248812),
(387848, 'PTHR21659:SF104', NULL, NULL, NULL, NULL, 'SALT AND LOW TEMPERATURE RESPONSE PROTEIN', 248812),
(387849, 'PTHR21659:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG11423', 248812),
(387850, 'PTHR21659:SF5', NULL, NULL, NULL, NULL, 'UPF0057 MEMBRANE PROTEIN T23F2.3-RELATED', 248812),
(387851, 'PTHR21659:SF106', NULL, NULL, NULL, NULL, 'LOW TEMPERATURE AND SALT RESPONSIVE PROTEIN FAMILY', 248812),
(387852, 'PTHR21659:SF105', NULL, NULL, NULL, NULL, 'UPF0057 MEMBRANE PROTEIN T23F2.5', 248812),
(387853, 'PTHR34982:SF3', NULL, NULL, NULL, NULL, 'FLAGELLAR ASSEMBLY PROTEIN FLIH', 248813),
(387854, 'PTHR34982:SF4', NULL, NULL, NULL, NULL, 'TYPE 3 SECRETION SYSTEM STATOR PROTEIN', 248813),
(387855, 'PTHR34982:SF1', NULL, NULL, NULL, NULL, 'FLAGELLAR ASSEMBLY PROTEIN FLIH-RELATED', 248813),
(387856, 'PTHR34982', NULL, NULL, NULL, NULL, 'YOP PROTEINS TRANSLOCATION PROTEIN L', 248813),
(387857, 'PTHR12372', NULL, NULL, NULL, NULL, 'PECANEX', 248814),
(387858, 'PTHR12372:SF7', NULL, NULL, NULL, NULL, 'PROTEIN PECANEX', 248814),
(387859, 'PTHR12372:SF6', NULL, NULL, NULL, NULL, 'PECANEX-LIKE PROTEIN 4', 248814);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(387860, 'PTHR12372:SF2', NULL, NULL, NULL, NULL, 'PECANEX-LIKE PROTEIN 1', 248814),
(387861, 'PTHR12372:SF5', NULL, NULL, NULL, NULL, 'PECANEX-LIKE PROTEIN 2', 248814),
(387862, 'PTHR12372:SF4', NULL, NULL, NULL, NULL, 'PECANEX-LIKE PROTEIN 3', 248814),
(387863, 'PTHR32510:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 98', 248815),
(387864, 'PTHR32510:SF5', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 98', 248815),
(387865, 'PTHR32510:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 98', 248815),
(387866, 'PTHR32510', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 98', 248815),
(387867, 'PTHR33179:SF9', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN 25', 248816),
(387868, 'PTHR33179:SF74', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN DDB_G0274915-LIKE', 248816),
(387869, 'PTHR33179:SF52', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 248816),
(387870, 'PTHR33179:SF30', NULL, NULL, NULL, NULL, 'VQ MOTIF-CONTAINING PROTEIN 22-LIKE', 248816),
(387871, 'PTHR33179:SF73', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 248816),
(387872, 'PTHR33179:SF4', NULL, NULL, NULL, NULL, 'VQ MOTIF-CONTAINING PROTEIN', 248816),
(387873, 'PTHR33179:SF51', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 248816),
(387874, 'PTHR33179:SF76', NULL, NULL, NULL, NULL, 'OS09G0370500 PROTEIN', 248816),
(387875, 'PTHR33179:SF10', NULL, NULL, NULL, NULL, 'OS02G0753700 PROTEIN', 248816),
(387876, 'PTHR33179:SF75', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 248816),
(387877, 'PTHR33179:SF70', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 248816),
(387878, 'PTHR33179:SF50', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN 25-LIKE', 248816),
(387879, 'PTHR33179:SF72', NULL, NULL, NULL, NULL, 'VQ-RELATED', 248816),
(387880, 'PTHR33179:SF71', NULL, NULL, NULL, NULL, 'VQ', 248816),
(387881, 'PTHR33179:SF59', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 248816),
(387882, 'PTHR33179:SF39', NULL, NULL, NULL, NULL, 'VQ MOTIF PROTEIN', 248816),
(387883, 'PTHR33179:SF78', NULL, NULL, NULL, NULL, 'OS07G0686600 PROTEIN', 248816),
(387884, 'PTHR33179:SF56', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 248816),
(387885, 'PTHR33179:SF11', NULL, NULL, NULL, NULL, 'OS03G0320600 PROTEIN', 248816),
(387886, 'PTHR33179:SF77', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 248816),
(387887, 'PTHR33179:SF58', NULL, NULL, NULL, NULL, 'OS08G0409500 PROTEIN', 248816),
(387888, 'PTHR33179:SF35', NULL, NULL, NULL, NULL, 'VQ MOTIF-CONTAINING PROTEIN', 248816),
(387889, 'PTHR33179:SF57', NULL, NULL, NULL, NULL, 'OS02G0173200 PROTEIN', 248816),
(387890, 'PTHR33179:SF63', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 248816),
(387891, 'PTHR33179:SF41', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 248816),
(387892, 'PTHR33179:SF64', NULL, NULL, NULL, NULL, 'OS11G0131100 PROTEIN', 248816),
(387893, 'PTHR33179:SF61', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 248816),
(387894, 'PTHR33179:SF29', NULL, NULL, NULL, NULL, 'OS06G0666400 PROTEIN', 248816),
(387895, 'PTHR33179:SF66', NULL, NULL, NULL, NULL, 'VQ MOTIF-CONTAINING PROTEIN 22-LIKE', 248816),
(387896, 'PTHR33179', NULL, NULL, NULL, NULL, 'VQ MOTIF-CONTAINING PROTEIN', 248816),
(387897, 'PTHR33179:SF46', NULL, NULL, NULL, NULL, 'VQ MOTIF-CONTAINING PROTEIN 22', 248816),
(387898, 'PTHR30615:SF14', NULL, NULL, NULL, NULL, '', 248817),
(387899, 'PTHR30615:SF16', NULL, NULL, NULL, NULL, 'SECONDARY THIAMINE-PHOSPHATE SYNTHASE ENZYME', 248817),
(387900, 'PTHR30615:SF2', NULL, NULL, NULL, NULL, '', 248817),
(387901, 'PTHR30615:SF15', NULL, NULL, NULL, NULL, 'BNAC08G19650D PROTEIN', 248817),
(387902, 'PTHR30615', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN YJBQ-RELATED', 248817),
(387903, 'PTHR30615:SF8', NULL, NULL, NULL, NULL, 'UPF0047 PROTEIN C4A8.02C', 248817),
(387904, 'PTHR34303:SF6', NULL, NULL, NULL, NULL, 'OS01G0890400 PROTEIN', 248818),
(387905, 'PTHR34303:SF7', NULL, NULL, NULL, NULL, '', 248818),
(387906, 'PTHR34303:SF8', NULL, NULL, NULL, NULL, 'OS09G0372600 PROTEIN', 248818);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(387907, 'PTHR34303:SF9', NULL, NULL, NULL, NULL, '', 248818),
(387908, 'PTHR34303:SF3', NULL, NULL, NULL, NULL, '', 248818),
(387909, 'PTHR34303:SF4', NULL, NULL, NULL, NULL, '', 248818),
(387910, 'PTHR34303', NULL, NULL, NULL, NULL, 'OS01G0890400 PROTEIN-RELATED', 248818),
(387911, 'PTHR12939:SF10', NULL, NULL, NULL, NULL, 'EG:4F1.1 PROTEIN', 248819),
(387912, 'PTHR12939:SF4', NULL, NULL, NULL, NULL, 'GAMMA-SARCOGLYCAN', 248819),
(387913, 'PTHR12939:SF5', NULL, NULL, NULL, NULL, 'ZETA-SARCOGLYCAN', 248819),
(387914, 'PTHR12939:SF6', NULL, NULL, NULL, NULL, 'DELTA-SARCOGLYCAN', 248819),
(387915, 'PTHR12939', NULL, NULL, NULL, NULL, 'SARCOGLYCAN', 248819),
(387916, 'PTHR10917:SF0', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASES I, II, AND III SUBUNIT RPABC3', 248820),
(387917, 'PTHR10917', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASES I, II, AND III SUBUNIT RPABC3', 248820),
(387918, 'PTHR10917:SF1', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE I, II', 248820),
(387919, 'PTHR11736:SF88', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN B17', 248821),
(387920, 'PTHR11736:SF145', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN B16', 248821),
(387921, 'PTHR11736:SF146', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN 11', 248821),
(387922, 'PTHR11736:SF48', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN 4', 248821),
(387923, 'PTHR11736:SF49', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN 1', 248821),
(387924, 'PTHR11736:SF91', NULL, NULL, NULL, NULL, 'MAGE-G2', 248821),
(387925, 'PTHR11736:SF140', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN B1', 248821),
(387926, 'PTHR11736:SF50', NULL, NULL, NULL, NULL, 'MAGE FAMILY MEMBER A1-RELATED', 248821),
(387927, 'PTHR11736:SF53', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN B3', 248821),
(387928, 'PTHR11736:SF142', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN 12', 248821),
(387929, 'PTHR11736:SF79', NULL, NULL, NULL, NULL, 'ASSOCIATED PROTEIN CAP20, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G06350)-RELATED', 248821),
(387930, 'PTHR11736:SF35', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN B5', 248821),
(387931, 'PTHR11736:SF37', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN D4', 248821),
(387932, 'PTHR11736:SF36', NULL, NULL, NULL, NULL, 'NON-STRUCTURAL MAINTENANCE OF CHROMOSOMES ELEMENT 3 HOMOLOG', 248821),
(387933, 'PTHR11736:SF139', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN B6', 248821),
(387934, 'PTHR11736:SF81', NULL, NULL, NULL, NULL, 'MAGE DOMAIN-CONTAINING PROTEIN', 248821),
(387935, 'PTHR11736:SF84', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN C2', 248821),
(387936, 'PTHR11736:SF83', NULL, NULL, NULL, NULL, 'TROPHININ', 248821),
(387937, 'PTHR11736:SF86', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN C3', 248821),
(387938, 'PTHR11736:SF85', NULL, NULL, NULL, NULL, 'MAGE DOMAIN-CONTAINING PROTEIN MAGEA13P-RELATED', 248821),
(387939, 'PTHR11736:SF66', NULL, NULL, NULL, NULL, 'MAGE-LIKE PROTEIN 2', 248821),
(387940, 'PTHR11736:SF22', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN B4', 248821),
(387941, 'PTHR11736:SF65', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN 8', 248821),
(387942, 'PTHR11736:SF24', NULL, NULL, NULL, NULL, 'MAGE DOMAIN-CONTAINING PROTEIN', 248821),
(387943, 'PTHR11736:SF23', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN B18', 248821),
(387944, 'PTHR11736:SF67', NULL, NULL, NULL, NULL, 'MAGE FAMILY MEMBER B6B', 248821),
(387945, 'PTHR11736:SF69', NULL, NULL, NULL, NULL, 'MAGE DOMAIN-CONTAINING PROTEIN', 248821),
(387946, 'PTHR11736:SF28', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN D1', 248821),
(387947, 'PTHR11736', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN  MAGE ANTIGEN', 248821),
(387948, 'PTHR11736:SF160', NULL, NULL, NULL, NULL, 'MAGE DOMAIN-CONTAINING PROTEIN', 248821),
(387949, 'PTHR11736:SF74', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN 2', 248821),
(387950, 'PTHR11736:SF9', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN E1', 248821),
(387951, 'PTHR11736:SF55', NULL, NULL, NULL, NULL, '1700080O16RIK PROTEIN', 248821);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(387952, 'PTHR11736:SF155', NULL, NULL, NULL, NULL, 'MAGE DOMAIN-CONTAINING PROTEIN', 248821),
(387953, 'PTHR11736:SF11', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN D2', 248821),
(387954, 'PTHR11736:SF156', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN B10', 248821),
(387955, 'PTHR11736:SF10', NULL, NULL, NULL, NULL, 'NECDIN', 248821),
(387956, 'PTHR11736:SF157', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN B10', 248821),
(387957, 'PTHR11736:SF158', NULL, NULL, NULL, NULL, 'MAGE FAMILY MEMBER B6B1', 248821),
(387958, 'PTHR11736:SF7', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN E2', 248821),
(387959, 'PTHR11736:SF159', NULL, NULL, NULL, NULL, 'MAGE DOMAIN-CONTAINING PROTEIN', 248821),
(387960, 'PTHR11736:SF8', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN H1', 248821),
(387961, 'PTHR11736:SF14', NULL, NULL, NULL, NULL, 'MAGE PROTEIN', 248821),
(387962, 'PTHR11736:SF17', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN C1', 248821),
(387963, 'PTHR11736:SF60', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN 3-RELATED', 248821),
(387964, 'PTHR11736:SF62', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN 9', 248821),
(387965, 'PTHR11736:SF152', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN B2', 248821),
(387966, 'PTHR11736:SF61', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN F1', 248821),
(387967, 'PTHR11736:SF153', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN 10', 248821),
(387968, 'PTHR11736:SF64', NULL, NULL, NULL, NULL, 'MAGE DOMAIN-CONTAINING PROTEIN-RELATED', 248821),
(387969, 'PTHR11736:SF154', NULL, NULL, NULL, NULL, 'MAGE DOMAIN-CONTAINING PROTEIN', 248821),
(387970, 'PTHR11736:SF63', NULL, NULL, NULL, NULL, 'MAGE FAMILY MEMBER A9', 248821),
(387971, 'PTHR46853:SF1', NULL, NULL, NULL, NULL, 'PROTEIN VALOIS', 248822),
(387972, 'PTHR46853:SF2', NULL, NULL, NULL, NULL, '4-GALACTOSYL-N-ACETYLGLUCOSAMINIDE 3-ALPHA-L-FUCOSYLTRANSFERASE FUT6', 248822),
(387973, 'PTHR46853:SF3', NULL, NULL, NULL, NULL, 'METHYLOSOME PROTEIN 50', 248822),
(387974, 'PTHR46853', NULL, NULL, NULL, NULL, 'METHYLOSOME PROTEIN 50', 248822),
(387975, 'PTHR38597', NULL, NULL, NULL, NULL, 'BLL3834 PROTEIN', 248823),
(387976, 'PTHR38597:SF1', NULL, NULL, NULL, NULL, 'BLL3834 PROTEIN', 248823),
(387977, 'PTHR36411', NULL, NULL, NULL, NULL, '', 248824),
(387978, 'PTHR36411:SF2', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REACTION CENTER PROTEIN T', 248824),
(387979, 'PTHR36411:SF4', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REACTION CENTER PROTEIN T', 248824),
(387980, 'PTHR31613', NULL, NULL, NULL, NULL, 'AUGURIN', 248825),
(387981, 'PTHR31613:SF2', NULL, NULL, NULL, NULL, 'AUGURIN', 248825),
(387982, 'PTHR45027:SF2', NULL, NULL, NULL, NULL, '', 248826),
(387983, 'PTHR45027:SF1', NULL, NULL, NULL, NULL, '', 248826),
(387984, 'PTHR45027:SF4', NULL, NULL, NULL, NULL, 'GLUTATHIONE HYDROLASE LIGHT CHAIN 1', 248826),
(387985, 'PTHR45027:SF6', NULL, NULL, NULL, NULL, 'GLUTATHIONE HYDROLASE LIGHT CHAIN 3-RELATED', 248826),
(387986, 'PTHR45027:SF5', NULL, NULL, NULL, NULL, 'GLUTATHIONE HYDROLASE LIGHT CHAIN 2', 248826),
(387987, 'PTHR45027', NULL, NULL, NULL, NULL, 'PUTATIVE GLUTATHIONE HYDROLASE LIGHT CHAIN', 248826),
(387988, 'PTHR16784:SF2', NULL, NULL, NULL, NULL, 'ENAMELIN', 248827),
(387989, 'PTHR16784', NULL, NULL, NULL, NULL, 'ENAMELIN', 248827),
(387990, 'PTHR43239', NULL, NULL, NULL, NULL, 'UPF0734 PROTEIN DDB_G0273871/DDB_G0273177', 248828),
(387991, 'PTHR43239:SF1', NULL, NULL, NULL, NULL, 'UPF0734 PROTEIN DDB_G0273871/DDB_G0273177', 248828),
(387992, 'PTHR16082:SF2', NULL, NULL, NULL, NULL, 'AP-5 COMPLEX SUBUNIT MU-1', 248829),
(387993, 'PTHR16082', NULL, NULL, NULL, NULL, 'AP-5 COMPLEX SUBUNIT MU-1', 248829),
(387994, 'PTHR34308', NULL, NULL, NULL, NULL, 'COBALAMIN BIOSYNTHESIS PROTEIN CBIB', 248830),
(387995, 'PTHR34308:SF1', NULL, NULL, NULL, NULL, 'COBALAMIN BIOSYNTHESIS PROTEIN CBIB', 248830),
(387996, 'PTHR47885:SF1', NULL, NULL, NULL, NULL, 'AP-5 COMPLEX SUBUNIT ZETA-1', 248831),
(387997, 'PTHR47885', NULL, NULL, NULL, NULL, 'AP-5 COMPLEX SUBUNIT ZETA-1', 248831);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(387998, 'PTHR41368:SF1', NULL, NULL, NULL, NULL, 'PROTEIN YGHO', 248832),
(387999, 'PTHR41368', NULL, NULL, NULL, NULL, 'PROTEIN YGHO', 248832),
(388000, 'PTHR46501:SF2', NULL, NULL, NULL, NULL, 'MYOMEGALIN', 248833),
(388001, 'PTHR46501:SF6', NULL, NULL, NULL, NULL, 'SI:CH73-95L15.5', 248833),
(388002, 'PTHR46501:SF9', NULL, NULL, NULL, NULL, 'SI:CH211-242B18.1', 248833),
(388003, 'PTHR46501:SF7', NULL, NULL, NULL, NULL, 'CDK5 REGULATORY SUBUNIT-ASSOCIATED PROTEIN 2', 248833),
(388004, 'PTHR46501', NULL, NULL, NULL, NULL, 'MYOMEGALIN', 248833),
(388005, 'PTHR22722', NULL, NULL, NULL, NULL, 'LOW-DENSITY LIPOPROTEIN RECEPTOR-RELATED PROTEIN 2-RELATED', 248834),
(388006, 'PTHR22722:SF5', NULL, NULL, NULL, NULL, 'LOW-DENSITY LIPOPROTEIN RECEPTOR-RELATED PROTEIN 1B', 248834),
(388007, 'PTHR22722:SF12', NULL, NULL, NULL, NULL, 'SI:DKEY-88L16.3', 248834),
(388008, 'PTHR22722:SF11', NULL, NULL, NULL, NULL, 'LOW-DENSITY LIPOPROTEIN RECEPTOR-RELATED PROTEIN 2', 248834),
(388009, 'PTHR22722:SF14', NULL, NULL, NULL, NULL, 'MEGALIN, ISOFORM A', 248834),
(388010, 'PTHR22722:SF10', NULL, NULL, NULL, NULL, 'CUB DOMAIN-CONTAINING PROTEIN', 248834),
(388011, 'PTHR31227:SF1', NULL, NULL, NULL, NULL, 'WSN DOMAIN-CONTAINING PROTEIN', 248835),
(388012, 'PTHR31227', NULL, NULL, NULL, NULL, 'PROTEIN CBG15697', 248835),
(388013, 'PTHR19411:SF0', NULL, NULL, NULL, NULL, 'PROTEIN BUD31 HOMOLOG', 248836),
(388014, 'PTHR19411:SF1', NULL, NULL, NULL, NULL, 'PROTEIN BUD31 HOMOLOG 3', 248836),
(388015, 'PTHR19411:SF6', NULL, NULL, NULL, NULL, 'G10, PUTATIVE-RELATED', 248836),
(388016, 'PTHR19411:SF7', NULL, NULL, NULL, NULL, 'PROTEIN BUD31 HOMOLOG 1', 248836),
(388017, 'PTHR19411:SF8', NULL, NULL, NULL, NULL, 'PROTEIN BUD31 HOMOLOG 1-LIKE', 248836),
(388018, 'PTHR19411:SF9', NULL, NULL, NULL, NULL, 'BNAA03G58540D PROTEIN', 248836),
(388019, 'PTHR19411', NULL, NULL, NULL, NULL, 'PROTEIN BUD31-RELATED', 248836),
(388020, 'PTHR35474:SF1', NULL, NULL, NULL, NULL, 'ATP PHOSPHORIBOSYLTRANSFERASE REGULATORY SUBUNIT', 248837),
(388021, 'PTHR35474', NULL, NULL, NULL, NULL, 'ATP PHOSPHORIBOSYLTRANSFERASE REGULATORY SUBUNIT', 248837),
(388022, 'PTHR35474:SF3', NULL, NULL, NULL, NULL, 'PROTEIN SHORT HYPOCOTYL IN WHITE LIGHT 1', 248837),
(388023, 'PTHR10472:SF1', NULL, NULL, NULL, NULL, 'D-AMINOACYL-TRNA DEACYLASE 2', 248838),
(388024, 'PTHR10472:SF5', NULL, NULL, NULL, NULL, 'D-AMINOACYL-TRNA DEACYLASE 1', 248838),
(388025, 'PTHR10472', NULL, NULL, NULL, NULL, 'D-TYROSYL-TRNA TYR  DEACYLASE', 248838),
(388026, 'PTHR37564:SF5', NULL, NULL, NULL, NULL, '', 248839),
(388027, 'PTHR37564:SF4', NULL, NULL, NULL, NULL, 'DNA-ASSOCIATED PROTEIN, PUTATIVE-RELATED', 248839),
(388028, 'PTHR37564:SF2', NULL, NULL, NULL, NULL, 'DNA-ASSOCIATED PROTEIN, PUTATIVE-RELATED', 248839),
(388029, 'PTHR37564:SF1', NULL, NULL, NULL, NULL, 'DNA-ASSOCIATED PROTEIN, PUTATIVE-RELATED', 248839),
(388030, 'PTHR37564', NULL, NULL, NULL, NULL, '', 248839),
(388031, 'PTHR11039:SF39', NULL, NULL, NULL, NULL, 'NEBULIN-RELATED-ANCHORING PROTEIN', 248840),
(388032, 'PTHR11039', NULL, NULL, NULL, NULL, 'NEBULIN', 248840),
(388033, 'PTHR11039:SF48', NULL, NULL, NULL, NULL, 'NEBULETTE', 248840),
(388034, 'PTHR11039:SF37', NULL, NULL, NULL, NULL, 'NEBULIN', 248840),
(388035, 'PTHR11039:SF65', NULL, NULL, NULL, NULL, '', 248840),
(388036, 'PTHR11039:SF64', NULL, NULL, NULL, NULL, 'LIM ZINC-BINDING DOMAIN-CONTAINING PROTEIN', 248840),
(388037, 'PTHR33542:SF5', NULL, NULL, NULL, NULL, 'FERROCHELATASE CHE1', 248841),
(388038, 'PTHR33542:SF3', NULL, NULL, NULL, NULL, 'SIROHYDROCHLORIN FERROCHELATASE, CHLOROPLASTIC', 248841),
(388039, 'PTHR33542', NULL, NULL, NULL, NULL, 'SIROHYDROCHLORIN FERROCHELATASE, CHLOROPLASTIC', 248841),
(388040, 'PTHR31394:SF4', NULL, NULL, NULL, NULL, 'BNAA02G10570D PROTEIN', 248842),
(388041, 'PTHR31394', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 199', 248842),
(388042, 'PTHR31394:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 199', 248842),
(388043, 'PTHR16684', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN C', 248843),
(388044, 'PTHR16684:SF13', NULL, NULL, NULL, NULL, '', 248843);
INSERT INTO "PUBLIC"."MODEL" VALUES
(388045, 'PTHR16684:SF12', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN C', 248843),
(388046, 'PTHR16684:SF11', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN C', 248843),
(388047, 'PTHR46308', NULL, NULL, NULL, NULL, 'MATH (MEPRIN-ASSOCIATED TRAF HOMOLOGY) DOMAIN CONTAINING', 248844),
(388048, 'PTHR46308:SF1', NULL, NULL, NULL, NULL, 'MATH (MEPRIN-ASSOCIATED TRAF HOMOLOGY) DOMAIN CONTAINING-RELATED', 248844),
(388049, 'PTHR32166:SF65', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE-RELATED', 248845),
(388050, 'PTHR32166:SF88', NULL, NULL, NULL, NULL, 'HAT TRANSPOSON SUPERFAMILY', 248845),
(388051, 'PTHR32166:SF67', NULL, NULL, NULL, NULL, 'HAT TRANSPOSON SUPERFAMILY', 248845),
(388052, 'PTHR32166:SF24', NULL, NULL, NULL, NULL, 'OS02G0450000 PROTEIN', 248845),
(388053, 'PTHR32166:SF63', NULL, NULL, NULL, NULL, 'HAT TRANSPOSON SUPERFAMILY PROTEIN', 248845),
(388054, 'PTHR32166:SF85', NULL, NULL, NULL, NULL, 'DUF659 DOMAIN-CONTAINING PROTEIN', 248845),
(388055, 'PTHR32166:SF81', NULL, NULL, NULL, NULL, 'HAT TRANSPOSON SUPERFAMILY PROTEIN', 248845),
(388056, 'PTHR32166:SF110', NULL, NULL, NULL, NULL, '', 248845),
(388057, 'PTHR32166:SF115', NULL, NULL, NULL, NULL, 'PUTATIVE ISOFORM 1-RELATED', 248845),
(388058, 'PTHR32166:SF116', NULL, NULL, NULL, NULL, 'DUF659 DOMAIN-CONTAINING PROTEIN', 248845),
(388059, 'PTHR32166:SF117', NULL, NULL, NULL, NULL, 'OS09G0499600 PROTEIN', 248845),
(388060, 'PTHR32166:SF118', NULL, NULL, NULL, NULL, 'DUF659 DOMAIN-CONTAINING PROTEIN', 248845),
(388061, 'PTHR32166:SF111', NULL, NULL, NULL, NULL, 'OS05G0326650 PROTEIN', 248845),
(388062, 'PTHR32166:SF112', NULL, NULL, NULL, NULL, 'DUF659 DOMAIN-CONTAINING PROTEIN', 248845),
(388063, 'PTHR32166:SF113', NULL, NULL, NULL, NULL, '', 248845),
(388064, 'PTHR32166:SF114', NULL, NULL, NULL, NULL, 'AND BED ZINC FINGER DOMAIN-CONTAINING PROTEIN, PUTATIVE-RELATED', 248845),
(388065, 'PTHR32166:SF108', NULL, NULL, NULL, NULL, 'HAT DIMERIZATION DOMAIN-CONTAINING PROTEIN ISOFORM 1', 248845),
(388066, 'PTHR32166:SF109', NULL, NULL, NULL, NULL, 'BNAC03G73690D PROTEIN', 248845),
(388067, 'PTHR32166:SF95', NULL, NULL, NULL, NULL, 'HAT TRANSPOSON SUPERFAMILY-RELATED', 248845),
(388068, 'PTHR32166:SF96', NULL, NULL, NULL, NULL, 'F16P17.2 PROTEIN', 248845),
(388069, 'PTHR32166:SF74', NULL, NULL, NULL, NULL, 'OS01G0379800 PROTEIN', 248845),
(388070, 'PTHR32166:SF104', NULL, NULL, NULL, NULL, 'BNAA08G24770D PROTEIN', 248845),
(388071, 'PTHR32166:SF105', NULL, NULL, NULL, NULL, 'HAT DIMERIZATION DOMAIN-CONTAINING PROTEIN', 248845),
(388072, 'PTHR32166:SF107', NULL, NULL, NULL, NULL, 'OS04G0261400 PROTEIN', 248845),
(388073, 'PTHR32166', NULL, NULL, NULL, NULL, 'OSJNBA0013A04.12 PROTEIN', 248845),
(388074, 'PTHR32166:SF101', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 248845),
(388075, 'PTHR12469:SF6', NULL, NULL, NULL, NULL, 'FLAVINATOR OF SUCCINATE DEHYDROGENASE-RELATED', 248846),
(388076, 'PTHR12469', NULL, NULL, NULL, NULL, 'PROTEIN EMI5 HOMOLOG, MITOCHONDRIAL', 248846),
(388077, 'PTHR12469:SF2', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE ASSEMBLY FACTOR 2, MITOCHONDRIAL', 248846),
(388078, 'PTHR35035:SF7', NULL, NULL, NULL, NULL, '', 248847),
(388079, 'PTHR35035:SF4', NULL, NULL, NULL, NULL, '', 248847),
(388080, 'PTHR35035:SF3', NULL, NULL, NULL, NULL, 'DISCOIDIN-INDUCING COMPLEX SUBUNIT B', 248847),
(388081, 'PTHR35035:SF5', NULL, NULL, NULL, NULL, '', 248847),
(388082, 'PTHR35035', NULL, NULL, NULL, NULL, '', 248847),
(388083, 'PTHR35035:SF2', NULL, NULL, NULL, NULL, '', 248847),
(388084, 'PTHR35035:SF1', NULL, NULL, NULL, NULL, '', 248847),
(388085, 'PTHR35035:SF14', NULL, NULL, NULL, NULL, '', 248847),
(388086, 'PTHR35035:SF15', NULL, NULL, NULL, NULL, '', 248847),
(388087, 'PTHR36115:SF4', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 248848),
(388088, 'PTHR36115:SF8', NULL, NULL, NULL, NULL, 'CONSERVED MEMBRANE PROTEIN-RELATED', 248848),
(388089, 'PTHR36115:SF6', NULL, NULL, NULL, NULL, 'PROLINE-RICH ANTIGEN HOMOLOG', 248848),
(388090, 'PTHR36115', NULL, NULL, NULL, NULL, 'PROLINE-RICH ANTIGEN HOMOLOG-RELATED', 248848);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(388091, 'PTHR38465:SF1', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR YVAV-RELATED', 248849),
(388092, 'PTHR38465', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR MJ1563-RELATED', 248849),
(388093, 'PTHR39606', NULL, NULL, NULL, NULL, 'SURFACE PROTEIN, PUTATIVE-RELATED', 248850),
(388094, 'PTHR39606:SF1', NULL, NULL, NULL, NULL, 'SURFACE PROTEIN, PUTATIVE-RELATED', 248850),
(388095, 'PTHR12979', NULL, NULL, NULL, NULL, 'CCR4-NOT TRANSCRIPTION COMPLEX SUBUNIT 10', 248851),
(388096, 'PTHR12979:SF5', NULL, NULL, NULL, NULL, 'CCR4-NOT TRANSCRIPTION COMPLEX SUBUNIT 10', 248851),
(388097, 'PTHR21698:SF5', NULL, NULL, NULL, NULL, '', 248852),
(388098, 'PTHR21698', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248852),
(388099, 'PTHR21698:SF4', NULL, NULL, NULL, NULL, 'EXTENSIN-LIKE', 248852),
(388100, 'PTHR16070:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM222A', 248853),
(388101, 'PTHR16070:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAM222B', 248853),
(388102, 'PTHR16070', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248853),
(388103, 'PTHR21420:SF9', NULL, NULL, NULL, NULL, 'GDP-FUCOSE PROTEIN O-FUCOSYLTRANSFERASE 1', 248854),
(388104, 'PTHR21420:SF3', NULL, NULL, NULL, NULL, 'GDP-FUCOSE PROTEIN O-FUCOSYLTRANSFERASE 1', 248854),
(388105, 'PTHR21420:SF10', NULL, NULL, NULL, NULL, 'GDP-FUCOSE PROTEIN O-FUCOSYLTRANSFERASE 1', 248854),
(388106, 'PTHR21420', NULL, NULL, NULL, NULL, 'GDP-FUCOSE PROTEIN O-FUCOSYLTRANSFERASE 1', 248854),
(388107, 'PTHR46211:SF8', NULL, NULL, NULL, NULL, 'PHOSPHODIESTERASE-RELATED', 248855),
(388108, 'PTHR46211:SF7', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE 1-RELATED', 248855),
(388109, 'PTHR46211:SF5', NULL, NULL, NULL, NULL, 'BLR6584 PROTEIN', 248855),
(388110, 'PTHR46211:SF10', NULL, NULL, NULL, NULL, 'EXPORTED PROTEIN-RELATED', 248855),
(388111, 'PTHR46211', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHORYL DIESTER PHOSPHODIESTERASE', 248855),
(388112, 'PTHR46211:SF1', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE, CYTOPLASMIC', 248855),
(388113, 'PTHR46211:SF12', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE', 248855),
(388114, 'PTHR39474:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248856),
(388115, 'PTHR39474', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', 248856),
(388116, 'PTHR39074', NULL, NULL, NULL, NULL, 'AGAP007547-PA', 248857),
(388117, 'PTHR39074:SF1', NULL, NULL, NULL, NULL, 'AGAP007547-PA', 248857),
(388118, 'PTHR48195', NULL, NULL, NULL, NULL, 'FRIEND VIRUS SUSCEPTIBILITY PROTEIN 1', 248858),
(388119, 'PTHR48195:SF1', NULL, NULL, NULL, NULL, 'FRIEND VIRUS SUSCEPTIBILITY PROTEIN 1-RELATED', 248858),
(388120, 'PTHR11465:SF61', NULL, NULL, NULL, NULL, 'CATALASE', 248859),
(388121, 'PTHR11465:SF60', NULL, NULL, NULL, NULL, 'CATALASE ISOZYME B', 248859),
(388122, 'PTHR11465:SF43', NULL, NULL, NULL, NULL, 'CATALASE-3', 248859),
(388123, 'PTHR11465:SF53', NULL, NULL, NULL, NULL, 'CATALASE', 248859),
(388124, 'PTHR11465:SF64', NULL, NULL, NULL, NULL, 'CATALASE ISOZYME 1', 248859),
(388125, 'PTHR11465:SF9', NULL, NULL, NULL, NULL, 'CATALASE', 248859),
(388126, 'PTHR11465:SF41', NULL, NULL, NULL, NULL, 'CATALASE ISOZYME 2', 248859),
(388127, 'PTHR11465:SF63', NULL, NULL, NULL, NULL, 'CATALASE', 248859),
(388128, 'PTHR11465:SF62', NULL, NULL, NULL, NULL, 'CATALASE T', 248859),
(388129, 'PTHR11465:SF25', NULL, NULL, NULL, NULL, 'PEROXISOMAL CATALASE 1', 248859),
(388130, 'PTHR11465:SF47', NULL, NULL, NULL, NULL, 'CATALASE', 248859),
(388131, 'PTHR11465:SF46', NULL, NULL, NULL, NULL, 'CATALASE', 248859),
(388132, 'PTHR11465:SF57', NULL, NULL, NULL, NULL, 'CATALASE', 248859),
(388133, 'PTHR11465:SF13', NULL, NULL, NULL, NULL, 'CATALASE (EUROFUNG)', 248859),
(388134, 'PTHR11465:SF45', NULL, NULL, NULL, NULL, 'CATALASE ISOZYME A', 248859),
(388135, 'PTHR11465:SF23', NULL, NULL, NULL, NULL, 'CATALASE-2', 248859),
(388136, 'PTHR11465:SF55', NULL, NULL, NULL, NULL, 'CATALASE', 248859),
(388137, 'PTHR11465:SF39', NULL, NULL, NULL, NULL, 'CATALASE-1', 248859),
(388138, 'PTHR11465:SF49', NULL, NULL, NULL, NULL, 'CATALASE', 248859);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(388139, 'PTHR11465:SF26', NULL, NULL, NULL, NULL, 'CATALASE 2', 248859),
(388140, 'PTHR11465', NULL, NULL, NULL, NULL, 'CATALASE', 248859),
(388141, 'PTHR16821:SF4', NULL, NULL, NULL, NULL, 'FRATAXIN, MITOCHONDRIAL', 248860),
(388142, 'PTHR16821:SF2', NULL, NULL, NULL, NULL, 'FRATAXIN, MITOCHONDRIAL', 248860),
(388143, 'PTHR16821:SF7', NULL, NULL, NULL, NULL, 'FERROXIDASE', 248860),
(388144, 'PTHR16821:SF5', NULL, NULL, NULL, NULL, 'FRATAXIN INTERMEDIATE FORM', 248860),
(388145, 'PTHR16821:SF6', NULL, NULL, NULL, NULL, 'FERROXIDASE', 248860),
(388146, 'PTHR16821', NULL, NULL, NULL, NULL, 'FRATAXIN', 248860),
(388147, 'PTHR35265', NULL, NULL, NULL, NULL, 'LEUKOSIALIN', 248861),
(388148, 'PTHR35265:SF1', NULL, NULL, NULL, NULL, 'LEUKOSIALIN', 248861),
(388149, 'PTHR10662:SF46', NULL, NULL, NULL, NULL, 'NUCLEAR RNA EXPORT FACTOR 2', 248862),
(388150, 'PTHR10662', NULL, NULL, NULL, NULL, 'NUCLEAR RNA EXPORT FACTOR', 248862),
(388151, 'PTHR10662:SF22', NULL, NULL, NULL, NULL, 'NUCLEAR RNA EXPORT FACTOR 1-RELATED', 248862),
(388152, 'PTHR10662:SF12', NULL, NULL, NULL, NULL, 'NUCLEAR RNA EXPORT FACTOR 3', 248862),
(388153, 'PTHR10662:SF45', NULL, NULL, NULL, NULL, 'NUCLEAR RNA EXPORT FACTOR 7', 248862),
(388154, 'PTHR10662:SF15', NULL, NULL, NULL, NULL, 'NUCLEAR RNA EXPORT FACTOR 5', 248862),
(388155, 'PTHR10662:SF48', NULL, NULL, NULL, NULL, '', 248862),
(388156, 'PTHR10662:SF49', NULL, NULL, NULL, NULL, 'NUCLEAR RNA EXPORT FACTOR 2', 248862),
(388157, 'PTHR10662:SF27', NULL, NULL, NULL, NULL, 'NUCLEAR RNA EXPORT FACTOR 1', 248862),
(388158, 'PTHR24221:SF395', NULL, NULL, NULL, NULL, 'SERINE PROTEASE/ABC TRANSPORTER B FAMILY PROTEIN TAGC-RELATED', 248863),
(388159, 'PTHR24221:SF552', NULL, NULL, NULL, NULL, 'BNAA09G02390D PROTEIN', 248863),
(388160, 'PTHR24221:SF397', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, ATP-BINDING TRANSMEMBRANE PROTEIN', 248863),
(388161, 'PTHR24221:SF276', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, ATP-BINDING/PERMEASE PROTEIN', 248863),
(388162, 'PTHR24221:SF430', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE ABC TRANSPORTER ATP-BINDING/PERMEASE PROTEIN YHEH-RELATED', 248863),
(388163, 'PTHR24221:SF551', NULL, NULL, NULL, NULL, 'BNACNNG20890D PROTEIN', 248863),
(388164, 'PTHR24221:SF557', NULL, NULL, NULL, NULL, 'P-GLYCOPROTEIN RELATED', 248863),
(388165, 'PTHR24221:SF436', NULL, NULL, NULL, NULL, 'LMO0107 PROTEIN', 248863),
(388166, 'PTHR24221:SF438', NULL, NULL, NULL, NULL, 'P-GLYCOPROTEIN RELATED', 248863),
(388167, 'PTHR24221:SF558', NULL, NULL, NULL, NULL, 'BNAA10G12020D PROTEIN', 248863),
(388168, 'PTHR24221:SF281', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER H FAMILY MEMBER 4', 248863),
(388169, 'PTHR24221:SF564', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER TAP-LIKE, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 248863),
(388170, 'PTHR24221:SF200', NULL, NULL, NULL, NULL, 'P-GLYCOPROTEIN RELATED', 248863),
(388171, 'PTHR24221:SF288', NULL, NULL, NULL, NULL, 'ABC A-PHEROMONE EFFLUX PUMP ATRD', 248863),
(388172, 'PTHR24221:SF563', NULL, NULL, NULL, NULL, 'BNAA03G47690D PROTEIN', 248863),
(388173, 'PTHR24221:SF562', NULL, NULL, NULL, NULL, 'BNAC09G18000D PROTEIN', 248863),
(388174, 'PTHR24221:SF165', NULL, NULL, NULL, NULL, 'BILE SALT EXPORT PUMP', 248863),
(388175, 'PTHR24221:SF561', NULL, NULL, NULL, NULL, 'BNAA03G18640D PROTEIN', 248863),
(388176, 'PTHR24221:SF440', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 6', 248863),
(388177, 'PTHR24221:SF601', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER', 248863),
(388178, 'PTHR24221:SF568', NULL, NULL, NULL, NULL, '', 248863),
(388179, 'PTHR24221:SF446', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT PERMEASE MDL1, MITOCHONDRIAL', 248863),
(388180, 'PTHR24221:SF600', NULL, NULL, NULL, NULL, 'OS03G0181750 PROTEIN', 248863),
(388181, 'PTHR24221:SF203', NULL, NULL, NULL, NULL, 'ATP-BINDING/PERMEASE FUSION ABC TRANSPORTER-RELATED', 248863),
(388182, 'PTHR24221:SF566', NULL, NULL, NULL, NULL, 'P-GLYCOPROTEIN RELATED', 248863),
(388183, 'PTHR24221:SF565', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY PROTEIN', 248863);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(388184, 'PTHR24221:SF605', NULL, NULL, NULL, NULL, 'HALF TRANSPORTER (PGP RELATED)', 248863),
(388185, 'PTHR24221:SF604', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 9', 248863),
(388186, 'PTHR24221:SF603', NULL, NULL, NULL, NULL, 'MULTIDRUG/PHEROMONE EXPORTER, MDR FAMILY, ABC TRANSPORTER FAMILY', 248863),
(388187, 'PTHR24221:SF5', NULL, NULL, NULL, NULL, 'HALF TRANSPORTER (PGP RELATED)', 248863),
(388188, 'PTHR24221:SF608', NULL, NULL, NULL, NULL, 'LMO2752 PROTEIN', 248863),
(388189, 'PTHR24221:SF606', NULL, NULL, NULL, NULL, 'COLICIN V SECRETION-PROCESSING ATP-BINDING PROTEIN', 248863),
(388190, 'PTHR24221:SF494', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 23, MITOCHONDRIAL-RELATED', 248863),
(388191, 'PTHR24221:SF251', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT TRANSLOCASE ABCB1', 248863),
(388192, 'PTHR24221:SF491', NULL, NULL, NULL, NULL, '', 248863),
(388193, 'PTHR24221:SF410', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN HOMOLOG 49-RELATED', 248863),
(388194, 'PTHR24221:SF498', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 16-RELATED', 248863),
(388195, 'PTHR24221:SF531', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 21', 248863),
(388196, 'PTHR24221:SF530', NULL, NULL, NULL, NULL, 'BNAA08G27160D PROTEIN', 248863),
(388197, 'PTHR24221:SF651', NULL, NULL, NULL, NULL, 'HEAVY METAL TOLERANCE PROTEIN', 248863),
(388198, 'PTHR24221:SF497', NULL, NULL, NULL, NULL, 'OS05G0548500 PROTEIN', 248863),
(388199, 'PTHR24221:SF650', NULL, NULL, NULL, NULL, 'LD18126P', 248863),
(388200, 'PTHR24221:SF535', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 3', 248863),
(388201, 'PTHR24221:SF499', NULL, NULL, NULL, NULL, 'FATTY ACID ABC TRANSPORTER ATP-BINDING/PERMEASE PROTEIN', 248863),
(388202, 'PTHR24221:SF539', NULL, NULL, NULL, NULL, 'RESISTANCE PROTEIN 1, 2, PUTATIVE-RELATED', 248863),
(388203, 'PTHR24221:SF415', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 13-RELATED', 248863),
(388204, 'PTHR24221:SF536', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 27-LIKE', 248863),
(388205, 'PTHR24221:SF384', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 19', 248863),
(388206, 'PTHR24221:SF261', NULL, NULL, NULL, NULL, 'ATP-BINDING/PERMEASE PROTEIN CYDD', 248863),
(388207, 'PTHR24221:SF300', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE-LIKE ATP-BINDING PROTEIN MDLA', 248863),
(388208, 'PTHR24221:SF542', NULL, NULL, NULL, NULL, 'BILE SALT EXPORT PUMP-RELATED', 248863),
(388209, 'PTHR24221:SF420', NULL, NULL, NULL, NULL, 'ABC MULTIDRUG TRANSPORTER ATRC', 248863),
(388210, 'PTHR24221:SF541', NULL, NULL, NULL, NULL, 'BNAA09G27580D PROTEIN', 248863),
(388211, 'PTHR24221:SF540', NULL, NULL, NULL, NULL, 'NHPM BACTERIOCIN SYSTEM ABC TRANSPORTER, PEPTIDASE/ATP-BINDING PROTEIN-RELATED', 248863),
(388212, 'PTHR24221:SF304', NULL, NULL, NULL, NULL, 'P-GLYCOPROTEIN RELATED', 248863),
(388213, 'PTHR24221:SF546', NULL, NULL, NULL, NULL, 'MDR-LIKE ABC TRANSPORTER', 248863),
(388214, 'PTHR24221:SF303', NULL, NULL, NULL, NULL, 'TRANSPORTER FAMILY PROTEIN, PUTATIVE-RELATED', 248863),
(388215, 'PTHR24221:SF423', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER', 248863),
(388216, 'PTHR24221:SF548', NULL, NULL, NULL, NULL, 'TRANSPORTER ABC DOMAIN PROTEIN', 248863),
(388217, 'PTHR24221:SF547', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 27', 248863),
(388218, 'PTHR24221:SF472', NULL, NULL, NULL, NULL, 'OS08G0153200 PROTEIN', 248863),
(388219, 'PTHR24221:SF592', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 4-LIKE', 248863),
(388220, 'PTHR24221:SF470', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ABC TRANSPORTER ATM', 248863),
(388221, 'PTHR24221:SF590', NULL, NULL, NULL, NULL, '''COMPONENT LINKED WITH THE ASSEMBLY OF CYTOCHROME'' TRANSPORT TRANSMEMBRANE ATP-BINDING PROTEIN ABC TRANSPORTER CYDD-RELATED', 248863),
(388222, 'PTHR24221:SF476', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY PROTEIN', 248863),
(388223, 'PTHR24221:SF630', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 29, CHLOROPLASTIC', 248863),
(388224, 'PTHR24221:SF233', NULL, NULL, NULL, NULL, 'ATP-BINDING/PERMEASE FUSION ABC TRANSPORTER-RELATED', 248863);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(388225, 'PTHR24221:SF474', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 3-RELATED', 248863),
(388226, 'PTHR24221:SF634', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN PGP-1', 248863),
(388227, 'PTHR24221:SF237', NULL, NULL, NULL, NULL, 'ANTIGEN PEPTIDE TRANSPORTER 2', 248863),
(388228, 'PTHR24221:SF633', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE-RELATED', 248863),
(388229, 'PTHR24221:SF479', NULL, NULL, NULL, NULL, '', 248863),
(388230, 'PTHR24221:SF632', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT LIPID A-CORE FLIPPASE', 248863),
(388231, 'PTHR24221:SF478', NULL, NULL, NULL, NULL, '', 248863),
(388232, 'PTHR24221:SF477', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 20', 248863),
(388233, 'PTHR24221:SF631', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN 3', 248863),
(388234, 'PTHR24221:SF638', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 1', 248863),
(388235, 'PTHR24221:SF637', NULL, NULL, NULL, NULL, 'BILE SALT EXPORT PUMP', 248863),
(388236, 'PTHR24221:SF636', NULL, NULL, NULL, NULL, '', 248863),
(388237, 'PTHR24221:SF635', NULL, NULL, NULL, NULL, 'RESISTANCE PROTEIN 1, 2, PUTATIVE-RELATED', 248863),
(388238, 'PTHR24221:SF519', NULL, NULL, NULL, NULL, 'OS01G0534700 PROTEIN', 248863),
(388239, 'PTHR24221:SF639', NULL, NULL, NULL, NULL, 'HALF TRANSPORTER (PGP RELATED)', 248863),
(388240, 'PTHR24221:SF518', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 2', 248863),
(388241, 'PTHR24221:SF241', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLCHOLINE TRANSLOCATOR ABCB4', 248863),
(388242, 'PTHR24221:SF482', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 10', 248863),
(388243, 'PTHR24221:SF641', NULL, NULL, NULL, NULL, 'ABC MULTIDRUG TRANSPORTER MDR4', 248863),
(388244, 'PTHR24221:SF520', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER OF THE MITOCHONDRION 1-RELATED', 248863),
(388245, 'PTHR24221:SF245', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY PROTEIN', 248863),
(388246, 'PTHR24221:SF640', NULL, NULL, NULL, NULL, 'MULTIDRUG EXPORT ATP-BINDING/PERMEASE PROTEIN YGAD-RELATED', 248863),
(388247, 'PTHR24221:SF243', NULL, NULL, NULL, NULL, 'P-GLYCOPROTEIN RELATED', 248863),
(388248, 'PTHR24221:SF242', NULL, NULL, NULL, NULL, 'ABC-TYPE OLIGOPEPTIDE TRANSPORTER ABCB9', 248863),
(388249, 'PTHR24221:SF128', NULL, NULL, NULL, NULL, 'P-GLYCOPROTEIN RELATED', 248863),
(388250, 'PTHR24221:SF249', NULL, NULL, NULL, NULL, 'ANTIGEN PEPTIDE TRANSPORTER 1', 248863),
(388251, 'PTHR24221:SF645', NULL, NULL, NULL, NULL, 'LP14331P', 248863),
(388252, 'PTHR24221:SF524', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE ABC TRANSPORTER ATP-BINDING/PERMEASE PROTEIN BMRA', 248863),
(388253, 'PTHR24221:SF644', NULL, NULL, NULL, NULL, 'OS07G0464600 PROTEIN', 248863),
(388254, 'PTHR24221:SF127', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 25', 248863),
(388255, 'PTHR24221:SF523', NULL, NULL, NULL, NULL, '', 248863),
(388256, 'PTHR24221:SF402', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTERS TRANSPORTER ABCB7, MITOCHONDRIAL', 248863),
(388257, 'PTHR24221:SF248', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER TRANSMEMBRANE REGION-RELATED', 248863),
(388258, 'PTHR24221:SF522', NULL, NULL, NULL, NULL, 'MULTIDRUG/PHEROMONE EXPORTER, MDR FAMILY, ABC TRANSPORTER FAMILY', 248863),
(388259, 'PTHR24221:SF489', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 1', 248863),
(388260, 'PTHR24221:SF643', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL POTASSIUM CHANNEL ATP-BINDING SUBUNIT', 248863),
(388261, 'PTHR24221:SF488', NULL, NULL, NULL, NULL, 'ABC TRANSMEMBRANE TYPE-1 DOMAIN-CONTAINING PROTEIN', 248863),
(388262, 'PTHR24221:SF642', NULL, NULL, NULL, NULL, 'SERINE PROTEASE/ABC TRANSPORTER B FAMILY PROTEIN TAGA', 248863),
(388263, 'PTHR24221:SF125', NULL, NULL, NULL, NULL, 'HALF TRANSPORTER (PGP RELATED)', 248863),
(388264, 'PTHR24221:SF528', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 15', 248863),
(388265, 'PTHR24221:SF407', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT TRANSLOCASE ABCB1', 248863),
(388266, 'PTHR24221:SF649', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY PROTEIN', 248863);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(388267, 'PTHR24221:SF527', NULL, NULL, NULL, NULL, 'ABC TRANSMEMBRANE TYPE-1 DOMAIN-CONTAINING PROTEIN', 248863),
(388268, 'PTHR24221:SF648', NULL, NULL, NULL, NULL, 'ABC-TYPE TRANSPORTER ATR1', 248863),
(388269, 'PTHR24221:SF526', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 248863),
(388270, 'PTHR24221:SF647', NULL, NULL, NULL, NULL, 'HLYB/MSBA FAMILY ABC TRANSPORTER', 248863),
(388271, 'PTHR24221:SF525', NULL, NULL, NULL, NULL, 'TRANSPORTER-ASSOCIATED WITH ANTIGEN-PROCESSING, SUBUNIT TYPE T, TELEOST-SPECIFIC', 248863),
(388272, 'PTHR24221:SF646', NULL, NULL, NULL, NULL, 'HAEMOLYSIN SECRETION ATP-BINDING PROTEIN', 248863),
(388273, 'PTHR24221:SF529', NULL, NULL, NULL, NULL, 'BNAC04G06010D PROTEIN', 248863),
(388274, 'PTHR24221:SF490', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 11-RELATED', 248863),
(388275, 'PTHR24221:SF571', NULL, NULL, NULL, NULL, '', 248863),
(388276, 'PTHR24221:SF450', NULL, NULL, NULL, NULL, 'ATRH', 248863),
(388277, 'PTHR24221:SF174', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 7', 248863),
(388278, 'PTHR24221:SF294', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE, SUB-FAMILY B (MDR/TAP), MEMBER 5', 248863),
(388279, 'PTHR24221:SF575', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE ABC TRANSPORTER ATP-BINDING AND PERMEASE PROTEIN', 248863),
(388280, 'PTHR24221:SF574', NULL, NULL, NULL, NULL, '', 248863),
(388281, 'PTHR24221:SF573', NULL, NULL, NULL, NULL, 'NHPM BACTERIOCIN SYSTEM ABC TRANSPORTER, ATP-BINDING PROTEIN-RELATED', 248863),
(388282, 'PTHR24221:SF572', NULL, NULL, NULL, NULL, 'P-GLYCOPROTEIN 16-RELATED', 248863),
(388283, 'PTHR24221:SF579', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER', 248863),
(388284, 'PTHR24221:SF612', NULL, NULL, NULL, NULL, 'P-GLYCOPROTEIN RELATED', 248863),
(388285, 'PTHR24221:SF578', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE ABC TRANSPORTER ATP-BINDING/PERMEASE PROTEIN YHEI-RELATED', 248863),
(388286, 'PTHR24221:SF611', NULL, NULL, NULL, NULL, 'P-GLYCOPROTEIN RELATED', 248863),
(388287, 'PTHR24221:SF610', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 6', 248863),
(388288, 'PTHR24221:SF577', NULL, NULL, NULL, NULL, 'BNACNNG55980D PROTEIN', 248863),
(388289, 'PTHR24221:SF455', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN PGP-3', 248863),
(388290, 'PTHR24221:SF213', NULL, NULL, NULL, NULL, 'ABC MULTIDRUG TRANSPORTER (EUROFUNG)', 248863),
(388291, 'PTHR24221:SF616', NULL, NULL, NULL, NULL, 'HLYB/MSBA FAMILY ABC TRANSPORTER', 248863),
(388292, 'PTHR24221:SF615', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE-LIKE ATP-BINDING PROTEIN MDLB', 248863),
(388293, 'PTHR24221:SF219', NULL, NULL, NULL, NULL, 'ABC MULTIDRUG TRANSPORTER (EUROFUNG)', 248863),
(388294, 'PTHR24221:SF614', NULL, NULL, NULL, NULL, 'ATP-BINDING/PERMEASE PROTEIN CYDC', 248863),
(388295, 'PTHR24221:SF217', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY B MEMBER 5', 248863),
(388296, 'PTHR24221:SF619', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 4-LIKE', 248863),
(388297, 'PTHR24221:SF618', NULL, NULL, NULL, NULL, 'LMO2751 PROTEIN', 248863),
(388298, 'PTHR24221:SF617', NULL, NULL, NULL, NULL, 'P-GLYCOPROTEIN RELATED', 248863),
(388299, 'PTHR24221:SF582', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 248863),
(388300, 'PTHR24221:SF581', NULL, NULL, NULL, NULL, '', 248863),
(388301, 'PTHR24221:SF465', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 9', 248863),
(388302, 'PTHR24221:SF586', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY B MEMBER 6', 248863),
(388303, 'PTHR24221:SF464', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN 1 HOMOLOG', 248863),
(388304, 'PTHR24221:SF583', NULL, NULL, NULL, NULL, 'HALF TRANSPORTER (PGP RELATED)', 248863),
(388305, 'PTHR24221:SF623', NULL, NULL, NULL, NULL, 'OS08G0153000 PROTEIN', 248863),
(388306, 'PTHR24221:SF622', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 4-LIKE ISOFORM X1', 248863),
(388307, 'PTHR24221:SF468', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER', 248863),
(388308, 'PTHR24221:SF589', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER', 248863);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(388309, 'PTHR24221:SF621', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 21', 248863),
(388310, 'PTHR24221:SF467', NULL, NULL, NULL, NULL, 'OS01G0695700 PROTEIN', 248863),
(388311, 'PTHR24221:SF620', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER', 248863),
(388312, 'PTHR24221:SF587', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER RELATED', 248863),
(388313, 'PTHR24221:SF466', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 248863),
(388314, 'PTHR24221:SF506', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 4', 248863),
(388315, 'PTHR24221:SF627', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY PROTEIN', 248863),
(388316, 'PTHR24221:SF626', NULL, NULL, NULL, NULL, '', 248863),
(388317, 'PTHR24221', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY B', 248863),
(388318, 'PTHR24221:SF625', NULL, NULL, NULL, NULL, 'SERINE PROTEASE/ABC TRANSPORTER B FAMILY PROTEIN TAGB', 248863),
(388319, 'PTHR24221:SF624', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY PROTEIN', 248863),
(388320, 'PTHR24221:SF228', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 8-RELATED', 248863),
(388321, 'PTHR24221:SF503', NULL, NULL, NULL, NULL, 'GH19726P', 248863),
(388322, 'PTHR24221:SF509', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 11-LIKE ISOFORM X1', 248863),
(388323, 'PTHR24221:SF629', NULL, NULL, NULL, NULL, 'MULTIDRUG EFFLUX ATP-BINDING/PERMEASE PROTEIN RV0194', 248863),
(388324, 'PTHR24221:SF628', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 7', 248863),
(388325, 'PTHR13258:SF3', NULL, NULL, NULL, NULL, '', 248864),
(388326, 'PTHR13258', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248864),
(388327, 'PTHR13258:SF0', NULL, NULL, NULL, NULL, 'SYNDETIN', 248864),
(388328, 'PTHR13258:SF4', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN-RELATED', 248864),
(388329, 'PTHR46491:SF3', NULL, NULL, NULL, NULL, 'CDGSH IRON-SULFUR DOMAIN-CONTAINING PROTEIN 3, MITOCHONDRIAL', 248865),
(388330, 'PTHR46491:SF6', NULL, NULL, NULL, NULL, '', 248865),
(388331, 'PTHR46491', NULL, NULL, NULL, NULL, 'CDGSH IRON SULFUR DOMAIN PROTEIN HOMOLOG', 248865),
(388332, 'PTHR46491:SF7', NULL, NULL, NULL, NULL, '', 248865),
(388333, 'PTHR46491:SF9', NULL, NULL, NULL, NULL, 'CDGSH IRON SULFUR DOMAIN PROTEIN HOMOLOG', 248865),
(388334, 'PTHR46420:SF1', NULL, NULL, NULL, NULL, 'BETA-1,4-GLUCURONYLTRANSFERASE 1', 248866),
(388335, 'PTHR46420', NULL, NULL, NULL, NULL, 'BETA-1,4-GLUCURONYLTRANSFERASE 1', 248866),
(388336, 'PTHR35525', NULL, NULL, NULL, NULL, 'BLL6575 PROTEIN', 248867),
(388337, 'PTHR35525:SF3', NULL, NULL, NULL, NULL, 'BLL6575 PROTEIN', 248867),
(388338, 'PTHR37952', NULL, NULL, NULL, NULL, '', 248868),
(388339, 'PTHR37952:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CREA', 248868),
(388340, 'PTHR47640:SF25', NULL, NULL, NULL, NULL, 'OLIGOURIDYLATE-BINDING PROTEIN 1B-LIKE', 248869),
(388341, 'PTHR47640:SF69', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 248869),
(388342, 'PTHR47640:SF47', NULL, NULL, NULL, NULL, 'BNAA03G48370D PROTEIN', 248869),
(388343, 'PTHR47640:SF68', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN RBP45-LIKE ISOFORM X1', 248869),
(388344, 'PTHR47640:SF67', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN RBP45-RELATED', 248869),
(388345, 'PTHR47640:SF23', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN L', 248869),
(388346, 'PTHR47640:SF66', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN RBP47-LIKE', 248869),
(388347, 'PTHR47640:SF21', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 248869),
(388348, 'PTHR47640:SF65', NULL, NULL, NULL, NULL, 'BNAC03G40810D PROTEIN', 248869),
(388349, 'PTHR47640:SF42', NULL, NULL, NULL, NULL, 'BNAA08G02390D PROTEIN', 248869),
(388350, 'PTHR47640:SF64', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 42-LIKE ISOFORM X1', 248869),
(388351, 'PTHR47640:SF63', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-BINDING ALPHA-BETA PLAIT DOMAIN-CONTAINING PROTEIN-RELATED', 248869),
(388352, 'PTHR47640:SF62', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 248869);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(388353, 'PTHR47640:SF40', NULL, NULL, NULL, NULL, 'OLIGOURIDYLATE-BINDING PROTEIN 1-LIKE', 248869),
(388354, 'PTHR47640:SF27', NULL, NULL, NULL, NULL, 'OS07G0615400 PROTEIN', 248869),
(388355, 'PTHR47640:SF48', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN RBP45B', 248869),
(388356, 'PTHR47640:SF72', NULL, NULL, NULL, NULL, 'OLIGOURIDYLATE-BINDING PROTEIN 1B', 248869),
(388357, 'PTHR47640:SF5', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN-RELATED', 248869),
(388358, 'PTHR47640:SF71', NULL, NULL, NULL, NULL, 'BNAANNG22220D PROTEIN', 248869),
(388359, 'PTHR47640:SF70', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 248869),
(388360, 'PTHR47640:SF6', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN RBP45A', 248869),
(388361, 'PTHR47640:SF9', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN RBP47B', 248869),
(388362, 'PTHR47640:SF14', NULL, NULL, NULL, NULL, 'OS07G0516900 PROTEIN', 248869),
(388363, 'PTHR47640:SF58', NULL, NULL, NULL, NULL, 'OS08G0190200 PROTEIN', 248869),
(388364, 'PTHR47640:SF13', NULL, NULL, NULL, NULL, 'OS04G0449900 PROTEIN', 248869),
(388365, 'PTHR47640:SF35', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 248869),
(388366, 'PTHR47640:SF56', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN RBP45C', 248869),
(388367, 'PTHR47640:SF11', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 42', 248869),
(388368, 'PTHR47640', NULL, NULL, NULL, NULL, 'TRNA SELENOCYSTEINE 1-ASSOCIATED PROTEIN 1-RELATED-RELATED', 248869),
(388369, 'PTHR47640:SF10', NULL, NULL, NULL, NULL, 'TRNA SELENOCYSTEINE 1-ASSOCIATED PROTEIN 1-RELATED', 248869),
(388370, 'PTHR47640:SF32', NULL, NULL, NULL, NULL, 'BNAC03G78250D PROTEIN', 248869),
(388371, 'PTHR47640:SF31', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN RBP47A', 248869),
(388372, 'PTHR47640:SF74', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-BINDING ALPHA-BETA PLAIT DOMAIN-CONTAINING PROTEIN-RELATED', 248869),
(388373, 'PTHR47640:SF3', NULL, NULL, NULL, NULL, 'OS11G0620100 PROTEIN', 248869),
(388374, 'PTHR47640:SF73', NULL, NULL, NULL, NULL, 'AGAP012564-PA', 248869),
(388375, 'PTHR47640:SF19', NULL, NULL, NULL, NULL, 'OLIGOURIDYLATE-BINDING PROTEIN 1A-RELATED', 248869),
(388376, 'PTHR47640:SF18', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN RBP45-LIKE', 248869),
(388377, 'PTHR47640:SF16', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN RBP47C-RELATED', 248869),
(388378, 'PTHR47640:SF15', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN RBP47B', 248869),
(388379, 'PTHR47640:SF59', NULL, NULL, NULL, NULL, 'OLIGOURIDYLATE BINDING PROTEIN 1B-RELATED', 248869),
(388380, 'PTHR47640:SF37', NULL, NULL, NULL, NULL, 'BNAA05G16080D PROTEIN', 248869),
(388381, 'PTHR14054', NULL, NULL, NULL, NULL, 'REPETIN', 248870),
(388382, 'PTHR14054:SF14', NULL, NULL, NULL, NULL, 'REPETIN', 248870),
(388383, 'PTHR35835', NULL, NULL, NULL, NULL, 'SEA DOMAIN-CONTAINING PROTEIN', 248871),
(388384, 'PTHR35835:SF1', NULL, NULL, NULL, NULL, 'SEA DOMAIN-CONTAINING PROTEIN', 248871),
(388385, 'PTHR33656', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', 248872),
(388386, 'PTHR33656:SF1', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 248872),
(388387, 'PTHR33656:SF7', NULL, NULL, NULL, NULL, '', 248872),
(388388, 'PTHR22050', NULL, NULL, NULL, NULL, 'RW1 PROTEIN HOMOLOG', 248873),
(388389, 'PTHR22050:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 131', 248873),
(388390, 'PTHR22050:SF0', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 131 HOMOLOG', 248873),
(388391, 'PTHR22050:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 131-LIKE', 248873),
(388392, 'PTHR31343:SF8', NULL, NULL, NULL, NULL, 'OS07G0246600 PROTEIN', 248874),
(388393, 'PTHR31343:SF36', NULL, NULL, NULL, NULL, '', 248874),
(388394, 'PTHR31343:SF58', NULL, NULL, NULL, NULL, 'BNACNNG15960D PROTEIN', 248874),
(388395, 'PTHR31343:SF37', NULL, NULL, NULL, NULL, 'OSJNBA0038O10.24-LIKE PROTEIN', 248874),
(388396, 'PTHR31343:SF59', NULL, NULL, NULL, NULL, '', 248874),
(388397, 'PTHR31343:SF34', NULL, NULL, NULL, NULL, 'PLANT/F9H3-4 PROTEIN', 248874);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(388398, 'PTHR31343:SF57', NULL, NULL, NULL, NULL, '', 248874),
(388399, 'PTHR31343:SF54', NULL, NULL, NULL, NULL, 'BNAC05G01960D PROTEIN', 248874),
(388400, 'PTHR31343:SF3', NULL, NULL, NULL, NULL, 'PLANT/F9H3-4 PROTEIN', 248874),
(388401, 'PTHR31343:SF4', NULL, NULL, NULL, NULL, '', 248874),
(388402, 'PTHR31343:SF30', NULL, NULL, NULL, NULL, 'BNAA02G16400D PROTEIN', 248874),
(388403, 'PTHR31343:SF5', NULL, NULL, NULL, NULL, 'DUF789 FAMILY PROTEIN', 248874),
(388404, 'PTHR31343:SF50', NULL, NULL, NULL, NULL, 'GB|AAD11584.1', 248874),
(388405, 'PTHR31343', NULL, NULL, NULL, NULL, 'T15D22.8', 248874),
(388406, 'PTHR31343:SF29', NULL, NULL, NULL, NULL, 'PLANT/F9H3-4 PROTEIN', 248874),
(388407, 'PTHR31343:SF27', NULL, NULL, NULL, NULL, 'OS01G0138500 PROTEIN', 248874),
(388408, 'PTHR31343:SF49', NULL, NULL, NULL, NULL, 'BNAA02G30660D PROTEIN', 248874),
(388409, 'PTHR31343:SF47', NULL, NULL, NULL, NULL, '', 248874),
(388410, 'PTHR31343:SF48', NULL, NULL, NULL, NULL, 'BNAC06G23730D PROTEIN', 248874),
(388411, 'PTHR31343:SF46', NULL, NULL, NULL, NULL, 'BNAA08G27520D PROTEIN', 248874),
(388412, 'PTHR31343:SF43', NULL, NULL, NULL, NULL, 'BNACNNG50270D PROTEIN', 248874),
(388413, 'PTHR31343:SF44', NULL, NULL, NULL, NULL, '', 248874),
(388414, 'PTHR31343:SF63', NULL, NULL, NULL, NULL, 'BNAC07G33420D PROTEIN', 248874),
(388415, 'PTHR31343:SF64', NULL, NULL, NULL, NULL, '', 248874),
(388416, 'PTHR31343:SF42', NULL, NULL, NULL, NULL, 'T15D22.8', 248874),
(388417, 'PTHR31343:SF61', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248874),
(388418, 'PTHR31343:SF62', NULL, NULL, NULL, NULL, 'OS01G0513400 PROTEIN', 248874),
(388419, 'PTHR31343:SF60', NULL, NULL, NULL, NULL, 'BNAA02G27040D PROTEIN', 248874),
(388420, 'PTHR13618', NULL, NULL, NULL, NULL, 'LEUCINE ZIPPER CONTAINING TRANSCRIPTION FACTOR  LZF1', 248875),
(388421, 'PTHR13618:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ROGDI HOMOLOG', 248875),
(388422, 'PTHR33211:SF107', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248876),
(388423, 'PTHR33211', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248876),
(388424, 'PTHR16253:SF0', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 22', 248877),
(388425, 'PTHR16253', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 22', 248877),
(388426, 'PTHR24115:SF978', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF13B', 248878),
(388427, 'PTHR24115:SF979', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-UA', 248878),
(388428, 'PTHR24115:SF734', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF3C', 248878),
(388429, 'PTHR24115:SF976', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 248878),
(388430, 'PTHR24115:SF977', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF22', 248878),
(388431, 'PTHR24115:SF974', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 248878),
(388432, 'PTHR24115:SF578', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 248878),
(388433, 'PTHR24115:SF853', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 248878),
(388434, 'PTHR24115:SF458', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF13A', 248878),
(388435, 'PTHR24115:SF975', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 248878),
(388436, 'PTHR24115:SF972', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 248878),
(388437, 'PTHR24115:SF576', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF17', 248878),
(388438, 'PTHR24115:SF973', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 248878),
(388439, 'PTHR24115:SF852', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 248878),
(388440, 'PTHR24115:SF454', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF2C', 248878),
(388441, 'PTHR24115:SF971', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 248878),
(388442, 'PTHR24115:SF965', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 248878),
(388443, 'PTHR24115:SF328', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF1B', 248878),
(388444, 'PTHR24115:SF162', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 248878),
(388445, 'PTHR24115:SF600', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF23', 248878),
(388446, 'PTHR24115:SF963', NULL, NULL, NULL, NULL, 'PHRAGMOPLAST-ASSOCIATED KINESIN-RELATED PROTEIN', 248878);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(388447, 'PTHR24115:SF601', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 248878),
(388448, 'PTHR24115:SF323', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 248878),
(388449, 'PTHR24115:SF445', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF7', 248878),
(388450, 'PTHR24115:SF322', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF1C', 248878),
(388451, 'PTHR24115:SF564', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 248878),
(388452, 'PTHR24115:SF287', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 248878),
(388453, 'PTHR24115:SF917', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-14C-RELATED', 248878),
(388454, 'PTHR24115:SF998', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 248878),
(388455, 'PTHR24115:SF911', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-12B', 248878),
(388456, 'PTHR24115:SF999', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-UB', 248878),
(388457, 'PTHR24115:SF472', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF3A', 248878),
(388458, 'PTHR24115:SF590', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-UC', 248878),
(388459, 'PTHR24115:SF194', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF6', 248878),
(388460, 'PTHR24115:SF191', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF9', 248878),
(388461, 'PTHR24115:SF996', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 248878),
(388462, 'PTHR24115:SF479', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIFC2', 248878),
(388463, 'PTHR24115:SF513', NULL, NULL, NULL, NULL, 'KINESIN-1 HEAVY CHAIN', 248878),
(388464, 'PTHR24115:SF997', NULL, NULL, NULL, NULL, 'KINESIN HEAVY CHAIN 73, ISOFORM E', 248878),
(388465, 'PTHR24115:SF994', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN 1', 248878),
(388466, 'PTHR24115:SF995', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 248878),
(388467, 'PTHR24115:SF992', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-7K, CHLOROPLASTIC', 248878),
(388468, 'PTHR24115:SF993', NULL, NULL, NULL, NULL, 'KINESIN-LIKE MOTOR PROTEIN 9', 248878),
(388469, 'PTHR24115:SF990', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 248878),
(388470, 'PTHR24115:SF352', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF20A', 248878),
(388471, 'PTHR24115:SF991', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 248878),
(388472, 'PTHR24115:SF906', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 248878),
(388473, 'PTHR24115:SF747', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 248878),
(388474, 'PTHR24115:SF989', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 248878),
(388475, 'PTHR24115:SF987', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF15', 248878),
(388476, 'PTHR24115:SF745', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 248878),
(388477, 'PTHR24115:SF988', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 248878),
(388478, 'PTHR24115:SF0', NULL, NULL, NULL, NULL, 'FI21273P1-RELATED', 248878),
(388479, 'PTHR24115:SF908', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-10C', 248878),
(388480, 'PTHR24115:SF9', NULL, NULL, NULL, NULL, 'KINESIN HEAVY CHAIN', 248878),
(388481, 'PTHR24115:SF985', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 248878),
(388482, 'PTHR24115:SF865', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-14S', 248878),
(388483, 'PTHR24115:SF986', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 248878),
(388484, 'PTHR24115:SF744', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF3B', 248878),
(388485, 'PTHR24115:SF983', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 248878),
(388486, 'PTHR24115:SF984', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 248878),
(388487, 'PTHR24115:SF981', NULL, NULL, NULL, NULL, 'KINESIN MOTOR CATALYTIC DOMAIN PROTEIN', 248878),
(388488, 'PTHR24115:SF586', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 248878),
(388489, 'PTHR24115:SF344', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF28P', 248878),
(388490, 'PTHR24115:SF982', NULL, NULL, NULL, NULL, 'KINESIN, PUTATIVE-RELATED', 248878),
(388491, 'PTHR24115:SF980', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 248878),
(388492, 'PTHR24115:SF817', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-12A-RELATED', 248878);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(388493, 'PTHR24115:SF818', NULL, NULL, NULL, NULL, 'KINESIN-LIKE CALMODULIN-BINDING PROTEIN', 248878),
(388494, 'PTHR24115:SF937', NULL, NULL, NULL, NULL, 'KINESIN HEAVY CHAIN ISOFORM 5A', 248878),
(388495, 'PTHR24115:SF934', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN SUBITO', 248878),
(388496, 'PTHR24115:SF935', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-UB', 248878),
(388497, 'PTHR24115:SF418', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF12', 248878),
(388498, 'PTHR24115:SF899', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-7D, MITOCHONDRIAL', 248878),
(388499, 'PTHR24115:SF932', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 248878),
(388500, 'PTHR24115:SF416', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-10A', 248878),
(388501, 'PTHR24115:SF933', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 248878),
(388502, 'PTHR24115', NULL, NULL, NULL, NULL, 'KINESIN-RELATED', 248878),
(388503, 'PTHR24115:SF372', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 248878),
(388504, 'PTHR24115:SF1000', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-10B', 248878),
(388505, 'PTHR24115:SF534', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF20B', 248878),
(388506, 'PTHR24115:SF930', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-7L, CHLOROPLASTIC', 248878),
(388507, 'PTHR24115:SF414', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF18B', 248878),
(388508, 'PTHR24115:SF931', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIFC1', 248878),
(388509, 'PTHR24115:SF412', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 248878),
(388510, 'PTHR24115:SF497', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-7M, CHLOROPLASTIC', 248878),
(388511, 'PTHR24115:SF893', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF21B', 248878),
(388512, 'PTHR24115:SF408', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 248878),
(388513, 'PTHR24115:SF925', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 248878),
(388514, 'PTHR24115:SF926', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF22', 248878),
(388515, 'PTHR24115:SF802', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN UNC-104', 248878),
(388516, 'PTHR24115:SF924', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 248878),
(388517, 'PTHR24115:SF889', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF27', 248878),
(388518, 'PTHR24115:SF801', NULL, NULL, NULL, NULL, 'KINESIN FAMILY MEMBER 19A', 248878),
(388519, 'PTHR24115:SF929', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN AT 31E, ISOFORM A', 248878),
(388520, 'PTHR24115:SF361', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF1A', 248878),
(388521, 'PTHR24115:SF886', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 248878),
(388522, 'PTHR24115:SF524', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF2B', 248878),
(388523, 'PTHR24115:SF400', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF16B', 248878),
(388524, 'PTHR24115:SF486', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF2A', 248878),
(388525, 'PTHR24115:SF718', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 248878),
(388526, 'PTHR24115:SF957', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-14N', 248878),
(388527, 'PTHR24115:SF833', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-14T', 248878),
(388528, 'PTHR24115:SF955', NULL, NULL, NULL, NULL, 'KINESIN-RELATED PROTEIN 7', 248878),
(388529, 'PTHR24115:SF799', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 248878),
(388530, 'PTHR24115:SF953', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 248878),
(388531, 'PTHR24115:SF434', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF19', 248878),
(388532, 'PTHR24115:SF951', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 248878),
(388533, 'PTHR24115:SF398', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF21A', 248878),
(388534, 'PTHR24115:SF399', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF18A', 248878),
(388535, 'PTHR24115:SF949', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN COSTA', 248878),
(388536, 'PTHR24115:SF829', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-12F', 248878),
(388537, 'PTHR24115:SF826', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN PROTEIN', 248878);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(388538, 'PTHR24115:SF948', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 248878),
(388539, 'PTHR24115:SF549', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 248878),
(388540, 'PTHR24115:SF789', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KLP68D', 248878),
(388541, 'PTHR24115:SF380', NULL, NULL, NULL, NULL, 'KINESIN HEAVY CHAIN ISOFORM 5C', 248878),
(388542, 'PTHR24115:SF545', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 248878),
(388543, 'PTHR24115:SF820', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 248878),
(388544, 'PTHR24115:SF546', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF14', 248878),
(388545, 'PTHR24115:SF821', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 248878),
(388546, 'PTHR24115:SF422', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 248878),
(388547, 'PTHR24115:SF421', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF25', 248878),
(388548, 'PTHR31365:SF20', NULL, NULL, NULL, NULL, 'COPPER ION BINDING PROTEIN', 248879),
(388549, 'PTHR31365:SF2', NULL, NULL, NULL, NULL, 'OS01G0771100 PROTEIN', 248879),
(388550, 'PTHR31365:SF22', NULL, NULL, NULL, NULL, '', 248879),
(388551, 'PTHR31365:SF4', NULL, NULL, NULL, NULL, 'PROTEIN PXR1-LIKE', 248879),
(388552, 'PTHR31365:SF18', NULL, NULL, NULL, NULL, '', 248879),
(388553, 'PTHR31365:SF13', NULL, NULL, NULL, NULL, 'BNAC03G67090D PROTEIN', 248879),
(388554, 'PTHR31365:SF23', NULL, NULL, NULL, NULL, 'COPPER ION BINDING PROTEIN-RELATED', 248879),
(388555, 'PTHR31365:SF12', NULL, NULL, NULL, NULL, 'OS01G0179300 PROTEIN', 248879),
(388556, 'PTHR31365:SF15', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248879),
(388557, 'PTHR31365', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248879),
(388558, 'PTHR16052', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248880),
(388559, 'PTHR16052:SF3', NULL, NULL, NULL, NULL, 'TBCC DOMAIN-CONTAINING PROTEIN 1', 248880),
(388560, 'PTHR16052:SF0', NULL, NULL, NULL, NULL, 'TBCC DOMAIN-CONTAINING PROTEIN 1', 248880),
(388561, 'PTHR16052:SF2', NULL, NULL, NULL, NULL, 'TBCC DOMAIN-CONTAINING PROTEIN 1', 248880),
(388562, 'PTHR16052:SF1', NULL, NULL, NULL, NULL, 'TBCC DOMAIN-CONTAINING PROTEIN 1', 248880),
(388563, 'PTHR15489:SF2', NULL, NULL, NULL, NULL, 'CASP8-ASSOCIATED PROTEIN 2', 248881),
(388564, 'PTHR15489', NULL, NULL, NULL, NULL, 'CASPASE 8 ASSOCIATED PROTEIN 2', 248881),
(388565, 'PTHR23362:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG26377', 248882),
(388566, 'PTHR23362:SF8', NULL, NULL, NULL, NULL, 'SET (TRITHORAX/POLYCOMB) DOMAIN CONTAINING-RELATED', 248882),
(388567, 'PTHR23362:SF2', NULL, NULL, NULL, NULL, 'SPK DOMAIN-CONTAINING PROTEIN', 248882),
(388568, 'PTHR23362', NULL, NULL, NULL, NULL, 'L-PLASTIN-RELATED', 248882),
(388569, 'PTHR23362:SF0', NULL, NULL, NULL, NULL, 'CASPASE A-RELATED', 248882),
(388570, 'PTHR33065:SF59', NULL, NULL, NULL, NULL, '', 248883),
(388571, 'PTHR33065:SF19', NULL, NULL, NULL, NULL, 'OS09G0246700 PROTEIN', 248883),
(388572, 'PTHR33065:SF97', NULL, NULL, NULL, NULL, 'OS12G0228350 PROTEIN', 248883),
(388573, 'PTHR33065:SF153', NULL, NULL, NULL, NULL, 'OS08G0141000 PROTEIN', 248883),
(388574, 'PTHR33065:SF98', NULL, NULL, NULL, NULL, 'OS11G0596700 PROTEIN', 248883),
(388575, 'PTHR33065:SF10', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 248883),
(388576, 'PTHR33065:SF152', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 248883),
(388577, 'PTHR33065:SF95', NULL, NULL, NULL, NULL, 'OS07G0646300 PROTEIN', 248883),
(388578, 'PTHR33065:SF96', NULL, NULL, NULL, NULL, '', 248883),
(388579, 'PTHR33065:SF113', NULL, NULL, NULL, NULL, '', 248883),
(388580, 'PTHR33065:SF58', NULL, NULL, NULL, NULL, '', 248883),
(388581, 'PTHR33065:SF112', NULL, NULL, NULL, NULL, '', 248883),
(388582, 'PTHR33065:SF156', NULL, NULL, NULL, NULL, '', 248883),
(388583, 'PTHR33065:SF99', NULL, NULL, NULL, NULL, '', 248883),
(388584, 'PTHR33065:SF55', NULL, NULL, NULL, NULL, '', 248883),
(388585, 'PTHR33065:SF111', NULL, NULL, NULL, NULL, '', 248883),
(388586, 'PTHR33065:SF154', NULL, NULL, NULL, NULL, '', 248883),
(388587, 'PTHR33065:SF110', NULL, NULL, NULL, NULL, '', 248883);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(388588, 'PTHR33065:SF117', NULL, NULL, NULL, NULL, 'OS01G0590200 PROTEIN', 248883),
(388589, 'PTHR33065:SF90', NULL, NULL, NULL, NULL, '', 248883),
(388590, 'PTHR33065:SF115', NULL, NULL, NULL, NULL, '', 248883),
(388591, 'PTHR33065:SF158', NULL, NULL, NULL, NULL, '', 248883),
(388592, 'PTHR33065:SF114', NULL, NULL, NULL, NULL, '', 248883),
(388593, 'PTHR33065', NULL, NULL, NULL, NULL, 'OS07G0486400 PROTEIN', 248883),
(388594, 'PTHR33065:SF93', NULL, NULL, NULL, NULL, '', 248883),
(388595, 'PTHR33065:SF91', NULL, NULL, NULL, NULL, '', 248883),
(388596, 'PTHR33065:SF119', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 248883),
(388597, 'PTHR33065:SF118', NULL, NULL, NULL, NULL, '', 248883),
(388598, 'PTHR33065:SF92', NULL, NULL, NULL, NULL, '', 248883),
(388599, 'PTHR33065:SF190', NULL, NULL, NULL, NULL, '', 248883),
(388600, 'PTHR33065:SF64', NULL, NULL, NULL, NULL, 'OS12G0619700 PROTEIN', 248883),
(388601, 'PTHR33065:SF186', NULL, NULL, NULL, NULL, 'OS08G0134900 PROTEIN', 248883),
(388602, 'PTHR33065:SF142', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 248883),
(388603, 'PTHR33065:SF65', NULL, NULL, NULL, NULL, '', 248883),
(388604, 'PTHR33065:SF185', NULL, NULL, NULL, NULL, '', 248883),
(388605, 'PTHR33065:SF141', NULL, NULL, NULL, NULL, 'OS04G0455401 PROTEIN', 248883),
(388606, 'PTHR33065:SF62', NULL, NULL, NULL, NULL, '', 248883),
(388607, 'PTHR33065:SF184', NULL, NULL, NULL, NULL, '', 248883),
(388608, 'PTHR33065:SF63', NULL, NULL, NULL, NULL, '', 248883),
(388609, 'PTHR33065:SF183', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 248883),
(388610, 'PTHR33065:SF146', NULL, NULL, NULL, NULL, '', 248883),
(388611, 'PTHR33065:SF101', NULL, NULL, NULL, NULL, '', 248883),
(388612, 'PTHR33065:SF145', NULL, NULL, NULL, NULL, 'OS05G0506400 PROTEIN', 248883),
(388613, 'PTHR33065:SF189', NULL, NULL, NULL, NULL, '', 248883),
(388614, 'PTHR33065:SF188', NULL, NULL, NULL, NULL, '', 248883),
(388615, 'PTHR33065:SF22', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 248883),
(388616, 'PTHR33065:SF144', NULL, NULL, NULL, NULL, '', 248883),
(388617, 'PTHR33065:SF187', NULL, NULL, NULL, NULL, '', 248883),
(388618, 'PTHR33065:SF104', NULL, NULL, NULL, NULL, '', 248883),
(388619, 'PTHR33065:SF103', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248883),
(388620, 'PTHR33065:SF61', NULL, NULL, NULL, NULL, '', 248883),
(388621, 'PTHR33065:SF108', NULL, NULL, NULL, NULL, '', 248883),
(388622, 'PTHR33065:SF182', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 248883),
(388623, 'PTHR33065:SF181', NULL, NULL, NULL, NULL, '', 248883),
(388624, 'PTHR33065:SF180', NULL, NULL, NULL, NULL, '', 248883),
(388625, 'PTHR33065:SF175', NULL, NULL, NULL, NULL, '', 248883),
(388626, 'PTHR33065:SF131', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248883),
(388627, 'PTHR33065:SF174', NULL, NULL, NULL, NULL, 'OS12G0211050 PROTEIN', 248883),
(388628, 'PTHR33065:SF130', NULL, NULL, NULL, NULL, 'OS05G0554800 PROTEIN', 248883),
(388629, 'PTHR33065:SF73', NULL, NULL, NULL, NULL, '', 248883),
(388630, 'PTHR33065:SF172', NULL, NULL, NULL, NULL, '', 248883),
(388631, 'PTHR33065:SF179', NULL, NULL, NULL, NULL, '', 248883),
(388632, 'PTHR33065:SF178', NULL, NULL, NULL, NULL, '', 248883),
(388633, 'PTHR33065:SF133', NULL, NULL, NULL, NULL, '', 248883),
(388634, 'PTHR33065:SF177', NULL, NULL, NULL, NULL, '', 248883),
(388635, 'PTHR33065:SF78', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 248883),
(388636, 'PTHR33065:SF132', NULL, NULL, NULL, NULL, 'OS12G0535200 PROTEIN', 248883),
(388637, 'PTHR33065:SF176', NULL, NULL, NULL, NULL, '', 248883),
(388638, 'PTHR33065:SF139', NULL, NULL, NULL, NULL, '', 248883),
(388639, 'PTHR33065:SF138', NULL, NULL, NULL, NULL, 'OS09G0442000 PROTEIN', 248883),
(388640, 'PTHR33065:SF71', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 248883),
(388641, 'PTHR33065:SF72', NULL, NULL, NULL, NULL, '', 248883),
(388642, 'PTHR33065:SF70', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 248883),
(388643, 'PTHR33065:SF171', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 248883);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(388644, 'PTHR33065:SF163', NULL, NULL, NULL, NULL, 'OS05G0112700 PROTEIN', 248883),
(388645, 'PTHR33065:SF87', NULL, NULL, NULL, NULL, '', 248883),
(388646, 'PTHR33065:SF84', NULL, NULL, NULL, NULL, '', 248883),
(388647, 'PTHR33065:SF85', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 248883),
(388648, 'PTHR33065:SF167', NULL, NULL, NULL, NULL, '', 248883),
(388649, 'PTHR33065:SF88', NULL, NULL, NULL, NULL, 'OS11G0104220 PROTEIN', 248883),
(388650, 'PTHR33065:SF121', NULL, NULL, NULL, NULL, '', 248883),
(388651, 'PTHR33065:SF165', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 248883),
(388652, 'PTHR33065:SF128', NULL, NULL, NULL, NULL, '', 248883),
(388653, 'PTHR33065:SF126', NULL, NULL, NULL, NULL, '', 248883),
(388654, 'PTHR33065:SF169', NULL, NULL, NULL, NULL, '', 248883),
(388655, 'PTHR33065:SF82', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 248883),
(388656, 'PTHR33065:SF83', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 248883),
(388657, 'PTHR33065:SF81', NULL, NULL, NULL, NULL, 'OS03G0703700 PROTEIN', 248883),
(388658, 'PTHR15478:SF10', NULL, NULL, NULL, NULL, '', 248884),
(388659, 'PTHR15478:SF5', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY-LIKE DOMAIN FAMILY A MEMBER 3', 248884),
(388660, 'PTHR15478:SF4', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY-LIKE DOMAIN FAMILY A MEMBER 1', 248884),
(388661, 'PTHR15478:SF12', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY-LIKE DOMAIN FAMILY A MEMBER 3', 248884),
(388662, 'PTHR15478:SF11', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY-LIKE DOMAIN, FAMILY A, MEMBER 3', 248884),
(388663, 'PTHR15478:SF8', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY-LIKE DOMAIN FAMILY A MEMBER 2', 248884),
(388664, 'PTHR15478', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY-LIKE DOMAIN, PQ-RICH PROTEIN', 248884),
(388665, 'PTHR47881:SF1', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 4', 248885),
(388666, 'PTHR47881', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUBFAMILY MEMBER 4', 248885),
(388667, 'PTHR23323', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN', 248886),
(388668, 'PTHR23323:SF24', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 11 HOMOLOG', 248886),
(388669, 'PTHR23323:SF27', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 248886),
(388670, 'PTHR23323:SF26', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 18 HOMOLOG', 248886),
(388671, 'PTHR23323:SF28', NULL, NULL, NULL, NULL, 'PEP5-LIKE ZINC FINGER PROTEIN C16A10.03C', 248886),
(388672, 'PTHR43823:SF3', NULL, NULL, NULL, NULL, 'MULTIDRUG EXPORT PROTEIN MEPA', 248887),
(388673, 'PTHR43823:SF4', NULL, NULL, NULL, NULL, 'SPORULATION PROTEIN YKVU', 248887),
(388674, 'PTHR43823', NULL, NULL, NULL, NULL, 'SPORULATION PROTEIN YKVU', 248887),
(388675, 'PTHR35109', NULL, NULL, NULL, NULL, 'GLUTAMATE RACEMASE', 248888),
(388676, 'PTHR35109:SF1', NULL, NULL, NULL, NULL, 'GLUTAMATE RACEMASE', 248888),
(388677, 'PTHR35109:SF2', NULL, NULL, NULL, NULL, 'BNAA02G16300D PROTEIN', 248888),
(388678, 'PTHR35109:SF5', NULL, NULL, NULL, NULL, 'BNAA01G36870D PROTEIN', 248888),
(388679, 'PTHR35109:SF3', NULL, NULL, NULL, NULL, 'BNAA05G20540D PROTEIN', 248888),
(388680, 'PTHR35109:SF4', NULL, NULL, NULL, NULL, 'BNAC06G43900D PROTEIN', 248888),
(388681, 'PTHR21556', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248889),
(388682, 'PTHR21556:SF2', NULL, NULL, NULL, NULL, 'TRESLIN', 248889),
(388683, 'PTHR38497:SF1', NULL, NULL, NULL, NULL, 'KINOCILIN', 248890),
(388684, 'PTHR38497', NULL, NULL, NULL, NULL, 'KINOCILIN', 248890),
(388685, 'PTHR46737', NULL, NULL, NULL, NULL, 'OS02G0827600 PROTEIN', 248891),
(388686, 'PTHR46737:SF4', NULL, NULL, NULL, NULL, 'BNAANNG06110D PROTEIN', 248891),
(388687, 'PTHR46737:SF3', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE/TRANSITION METAL ION-BINDING PROTEIN (DUF3531)', 248891),
(388688, 'PTHR46737:SF2', NULL, NULL, NULL, NULL, 'OS02G0827600 PROTEIN', 248891),
(388689, 'PTHR16776:SF3', NULL, NULL, NULL, NULL, 'EXTRACELLULAR MATRIX PROTEIN 1', 248892);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(388690, 'PTHR16776', NULL, NULL, NULL, NULL, 'EXTRACELLULAR MATRIX PROTEIN 1', 248892),
(388691, 'PTHR13260', NULL, NULL, NULL, NULL, 'ANAPHASE PROMOTING COMPLEX SUBUNIT 4  APC4', 248893),
(388692, 'PTHR13260:SF0', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT 4', 248893),
(388693, 'PTHR47518:SF6', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS E (EPSILON)', 248894),
(388694, 'PTHR47518', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS EPSILON-13-RELATED', 248894),
(388695, 'PTHR47518:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG06684', 248894),
(388696, 'PTHR47518:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG06692', 248894),
(388697, 'PTHR47518:SF9', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR', 248894),
(388698, 'PTHR47518:SF2', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS E (EPSILON)', 248894),
(388699, 'PTHR47518:SF3', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS EPSILON-13', 248894),
(388700, 'PTHR47518:SF4', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS E (EPSILON)', 248894),
(388701, 'PTHR47518:SF5', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS E (EPSILON)', 248894),
(388702, 'PTHR47518:SF11', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS E (EPSILON)-RELATED', 248894),
(388703, 'PTHR47518:SF12', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS E (EPSILON)', 248894),
(388704, 'PTHR47518:SF10', NULL, NULL, NULL, NULL, 'PROTEIN CBG09758', 248894),
(388705, 'PTHR47518:SF1', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS E (EPSILON)', 248894),
(388706, 'PTHR32428', NULL, NULL, NULL, NULL, 'TARGET OF RAPAMYCIN COMPLEX 2 SUBUNIT BIT61-RELATED', 248895),
(388707, 'PTHR32428:SF2', NULL, NULL, NULL, NULL, 'TARGET OF RAPAMYCIN COMPLEX 2 SUBUNIT BIT61-RELATED', 248895),
(388708, 'PTHR32428:SF3', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 5-LIKE', 248895),
(388709, 'PTHR32428:SF4', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 5', 248895),
(388710, 'PTHR33721', NULL, NULL, NULL, NULL, '', 248896),
(388711, 'PTHR33721:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 255B', 248896),
(388712, 'PTHR33721:SF4', NULL, NULL, NULL, NULL, 'SI:DKEY-283J8.1', 248896),
(388713, 'PTHR33721:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 255A', 248896),
(388714, 'PTHR33721:SF5', NULL, NULL, NULL, NULL, '', 248896),
(388715, 'PTHR15169:SF0', NULL, NULL, NULL, NULL, 'DNA DAMAGE-BINDING PROTEIN 2', 248897),
(388716, 'PTHR15169', NULL, NULL, NULL, NULL, 'DAMAGE-SPECIFIC DNA BINDING PROTEIN 2', 248897),
(388717, 'PTHR37200:SF1', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 248898),
(388718, 'PTHR37200', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 248898),
(388719, 'PTHR23508:SF2', NULL, NULL, NULL, NULL, 'METABOLITE TRANSPORT PROTEIN YJHB-RELATED', 248899),
(388720, 'PTHR23508', NULL, NULL, NULL, NULL, 'CARBOXYLIC ACID TRANSPORTER PROTEIN HOMOLOG', 248899),
(388721, 'PTHR23508:SF3', NULL, NULL, NULL, NULL, 'SIALIC ACID TRANSPORTER NANT', 248899),
(388722, 'PTHR23508:SF9', NULL, NULL, NULL, NULL, 'CARBOXYLIC ACID TRANSPORT PROTEIN (AFU_ORTHOLOGUE AFUA_2G09450)', 248899),
(388723, 'PTHR23508:SF10', NULL, NULL, NULL, NULL, 'CARBOXYLIC ACID TRANSPORTER PROTEIN HOMOLOG', 248899),
(388724, 'PTHR43003:SF8', NULL, NULL, NULL, NULL, 'ENDO3C DOMAIN-CONTAINING PROTEIN', 248900),
(388725, 'PTHR43003:SF7', NULL, NULL, NULL, NULL, 'ENDO3C DOMAIN-CONTAINING PROTEIN', 248900),
(388726, 'PTHR43003:SF9', NULL, NULL, NULL, NULL, 'DNA-3-METHYLADENINE GLYCOSYLASE 1-LIKE', 248900),
(388727, 'PTHR43003:SF6', NULL, NULL, NULL, NULL, '', 248900),
(388728, 'PTHR43003:SF5', NULL, NULL, NULL, NULL, 'DNA-3-METHYLADENINE GLYCOSYLASE', 248900),
(388729, 'PTHR43003:SF12', NULL, NULL, NULL, NULL, 'DNA-3-METHYLADENINE GLYCOSYLASE', 248900),
(388730, 'PTHR43003:SF13', NULL, NULL, NULL, NULL, 'DNA-3-METHYLADENINE GLYCOSYLASE 2', 248900),
(388731, 'PTHR43003', NULL, NULL, NULL, NULL, 'DNA-3-METHYLADENINE GLYCOSYLASE', 248900),
(388732, 'PTHR43003:SF2', NULL, NULL, NULL, NULL, 'OS05G0567500 PROTEIN', 248900),
(388733, 'PTHR38646:SF1', NULL, NULL, NULL, NULL, 'DUF202 DOMAIN-CONTAINING PROTEIN', 248901);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(388734, 'PTHR38646', NULL, NULL, NULL, NULL, 'YALI0F00814P', 248901),
(388735, 'PTHR10414:SF27', NULL, NULL, NULL, NULL, 'CHOLINE/ETHANOLAMINEPHOSPHOTRANSFERASE 1', 248902),
(388736, 'PTHR10414:SF49', NULL, NULL, NULL, NULL, 'OS06G0204400 PROTEIN', 248902),
(388737, 'PTHR10414:SF76', NULL, NULL, NULL, NULL, 'BNAC08G40270D PROTEIN', 248902),
(388738, 'PTHR10414:SF32', NULL, NULL, NULL, NULL, 'CHOLINEPHOSPHOTRANSFERASE 1', 248902),
(388739, 'PTHR10414:SF66', NULL, NULL, NULL, NULL, 'CHOLINE/ETHANOLAMINEPHOSPHOTRANSFERASE 1-RELATED', 248902),
(388740, 'PTHR10414:SF30', NULL, NULL, NULL, NULL, '', 248902),
(388741, 'PTHR10414:SF41', NULL, NULL, NULL, NULL, 'CHOLINE/ETHANOLAMINEPHOSPHOTRANSFERASE', 248902),
(388742, 'PTHR10414:SF75', NULL, NULL, NULL, NULL, '', 248902),
(388743, 'PTHR10414:SF36', NULL, NULL, NULL, NULL, 'GH11618P', 248902),
(388744, 'PTHR10414:SF47', NULL, NULL, NULL, NULL, 'ETHANOLAMINEPHOSPHOTRANSFERASE 1', 248902),
(388745, 'PTHR10414:SF69', NULL, NULL, NULL, NULL, 'CHOLINE/ETHANOLAMINEPHOSPHOTRANSFERASE 2', 248902),
(388746, 'PTHR10414:SF37', NULL, NULL, NULL, NULL, 'BB IN A BOXCAR, ISOFORM C', 248902),
(388747, 'PTHR10414:SF67', NULL, NULL, NULL, NULL, '', 248902),
(388748, 'PTHR10414:SF35', NULL, NULL, NULL, NULL, 'ETHANOLAMINEPHOSPHOTRANSFERASE 1-LIKE', 248902),
(388749, 'PTHR10414:SF68', NULL, NULL, NULL, NULL, 'ETHANOLAMINE PHOSPHOTRANSFERASE-RELATED', 248902),
(388750, 'PTHR10414:SF72', NULL, NULL, NULL, NULL, 'AMINOALCOHOLPHOSPHOTRANSFERASE 1-RELATED', 248902),
(388751, 'PTHR10414:SF73', NULL, NULL, NULL, NULL, 'BNAA06G33540D PROTEIN', 248902),
(388752, 'PTHR10414', NULL, NULL, NULL, NULL, 'ETHANOLAMINEPHOSPHOTRANSFERASE', 248902),
(388753, 'PTHR10414:SF71', NULL, NULL, NULL, NULL, 'FI05338P', 248902),
(388754, 'PTHR35547:SF13', NULL, NULL, NULL, NULL, '', 248903),
(388755, 'PTHR35547:SF1', NULL, NULL, NULL, NULL, 'OS02G0737300 PROTEIN', 248903),
(388756, 'PTHR35547', NULL, NULL, NULL, NULL, 'OS06G0249350 PROTEIN-RELATED', 248903),
(388757, 'PTHR35547:SF2', NULL, NULL, NULL, NULL, 'OS06G0249350 PROTEIN', 248903),
(388758, 'PTHR35547:SF9', NULL, NULL, NULL, NULL, '', 248903),
(388759, 'PTHR35547:SF19', NULL, NULL, NULL, NULL, '', 248903),
(388760, 'PTHR35547:SF16', NULL, NULL, NULL, NULL, '', 248903),
(388761, 'PTHR35547:SF17', NULL, NULL, NULL, NULL, '', 248903),
(388762, 'PTHR35547:SF8', NULL, NULL, NULL, NULL, '', 248903),
(388763, 'PTHR35547:SF5', NULL, NULL, NULL, NULL, 'OS06G0249100 PROTEIN', 248903),
(388764, 'PTHR35547:SF14', NULL, NULL, NULL, NULL, '', 248903),
(388765, 'PTHR35547:SF6', NULL, NULL, NULL, NULL, '', 248903),
(388766, 'PTHR21637:SF6', NULL, NULL, NULL, NULL, 'BTB_3 DOMAIN-CONTAINING PROTEIN', 248904),
(388767, 'PTHR21637:SF5', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN 10', 248904),
(388768, 'PTHR21637:SF0', NULL, NULL, NULL, NULL, 'AT10158P', 248904),
(388769, 'PTHR21637', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN 10-RELATED', 248904),
(388770, 'PTHR21637:SF1', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN KCTD20', 248904),
(388771, 'PTHR12716:SF12', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIE SUBUNIT BETA', 248905),
(388772, 'PTHR12716', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIE, BETA SUBUNIT', 248905),
(388773, 'PTHR12716:SF13', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIE SUBUNIT BETA', 248905),
(388774, 'PTHR12716:SF16', NULL, NULL, NULL, NULL, 'TFA2_WINGED_2 DOMAIN-CONTAINING PROTEIN', 248905),
(388775, 'PTHR12716:SF18', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIE SUBUNIT BETA', 248905),
(388776, 'PTHR12716:SF17', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIE SUBUNIT BETA', 248905),
(388777, 'PTHR12716:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIE SUBUNIT BETA', 248905),
(388778, 'PTHR46029:SF8', NULL, NULL, NULL, NULL, '', 248906),
(388779, 'PTHR46029:SF7', NULL, NULL, NULL, NULL, 'C-TERMINAL-BINDING PROTEIN', 248906),
(388780, 'PTHR46029:SF6', NULL, NULL, NULL, NULL, '', 248906),
(388781, 'PTHR46029:SF5', NULL, NULL, NULL, NULL, '', 248906);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(388782, 'PTHR46029:SF4', NULL, NULL, NULL, NULL, '', 248906),
(388783, 'PTHR46029:SF3', NULL, NULL, NULL, NULL, 'C-TERMINAL-BINDING PROTEIN 2', 248906),
(388784, 'PTHR46029:SF2', NULL, NULL, NULL, NULL, 'C-TERMINAL-BINDING PROTEIN 1', 248906),
(388785, 'PTHR46029:SF1', NULL, NULL, NULL, NULL, 'C-TERMINAL-BINDING PROTEIN 1', 248906),
(388786, 'PTHR46029', NULL, NULL, NULL, NULL, 'C-TERMINAL-BINDING PROTEIN', 248906),
(388787, 'PTHR34484:SF4', NULL, NULL, NULL, NULL, 'BNAA02G04570D PROTEIN', 248907),
(388788, 'PTHR34484:SF3', NULL, NULL, NULL, NULL, 'PRLI-INTERACTING FACTOR A', 248907),
(388789, 'PTHR34484:SF2', NULL, NULL, NULL, NULL, 'OS02G0832600 PROTEIN', 248907),
(388790, 'PTHR34484:SF1', NULL, NULL, NULL, NULL, 'OS09G0553700 PROTEIN', 248907),
(388791, 'PTHR34484', NULL, NULL, NULL, NULL, 'OS02G0832600 PROTEIN', 248907),
(388792, 'PTHR30146:SF60', NULL, NULL, NULL, NULL, 'PERIPLASMIC PROTEIN TORT', 248908),
(388793, 'PTHR30146:SF109', NULL, NULL, NULL, NULL, 'ARABINOSE METABOLISM TRANSCRIPTIONAL REPRESSOR', 248908),
(388794, 'PTHR30146:SF107', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', 248908),
(388795, 'PTHR30146:SF105', NULL, NULL, NULL, NULL, 'CATABOLITE CONTROL PROTEIN B', 248908),
(388796, 'PTHR30146:SF98', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR GALR', 248908),
(388797, 'PTHR30146:SF33', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', 248908),
(388798, 'PTHR30146:SF55', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR GALS', 248908),
(388799, 'PTHR30146:SF143', NULL, NULL, NULL, NULL, 'LACTOSE OPERON REPRESSOR', 248908),
(388800, 'PTHR30146:SF121', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR EBGR-RELATED', 248908),
(388801, 'PTHR30146:SF142', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REPRESSOR PURR-RELATED', 248908),
(388802, 'PTHR30146:SF120', NULL, NULL, NULL, NULL, 'ALANINE RACEMASE', 248908),
(388803, 'PTHR30146:SF141', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REPRESSOR EXUR-RELATED', 248908),
(388804, 'PTHR30146:SF95', NULL, NULL, NULL, NULL, 'RIBOSE OPERON REPRESSOR', 248908),
(388805, 'PTHR30146:SF140', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR PTXS', 248908),
(388806, 'PTHR30146:SF37', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR IDNR', 248908),
(388807, 'PTHR30146:SF139', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 248908),
(388808, 'PTHR30146:SF138', NULL, NULL, NULL, NULL, 'AUTOINDUCER 2-BINDING PERIPLASMIC PROTEIN LUXP', 248908),
(388809, 'PTHR30146:SF137', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR TRER', 248908),
(388810, 'PTHR30146:SF136', NULL, NULL, NULL, NULL, 'NTD BIOSYNTHESIS OPERON REGULATOR NTDR', 248908),
(388811, 'PTHR30146', NULL, NULL, NULL, NULL, 'LACI-RELATED TRANSCRIPTIONAL REPRESSOR', 248908),
(388812, 'PTHR30146:SF45', NULL, NULL, NULL, NULL, 'CATABOLITE REPRESSOR/ACTIVATOR', 248908),
(388813, 'PTHR30146:SF67', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', 248908),
(388814, 'PTHR30146:SF24', NULL, NULL, NULL, NULL, 'XYLOSE OPERON REGULATORY PROTEIN', 248908),
(388815, 'PTHR30146:SF134', NULL, NULL, NULL, NULL, 'OPERON REPRESSOR, PUTATIVE-RELATED', 248908),
(388816, 'PTHR30146:SF110', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REPRESSOR CYTR', 248908),
(388817, 'PTHR30146:SF131', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR ASCG', 248908),
(388818, 'PTHR30146:SF2', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR GNTR', 248908),
(388819, 'PTHR15464:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR 19', 248909),
(388820, 'PTHR15464', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR 19', 248909),
(388821, 'PTHR47769', NULL, NULL, NULL, NULL, 'WAP FOUR-DISULFIDE CORE DOMAIN PROTEIN 8', 248910),
(388822, 'PTHR47769:SF1', NULL, NULL, NULL, NULL, 'WAP FOUR-DISULFIDE CORE DOMAIN PROTEIN 8', 248910),
(388823, 'PTHR13060', NULL, NULL, NULL, NULL, 'SGT1 PROTEIN  HSGT1   SUPPRESSOR OF GCR2', 248911),
(388824, 'PTHR13060:SF0', NULL, NULL, NULL, NULL, 'PROTEIN ECDYSONELESS HOMOLOG', 248911);
INSERT INTO "PUBLIC"."MODEL" VALUES
(388825, 'PTHR31318', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', 248912),
(388826, 'PTHR31318:SF3', NULL, NULL, NULL, NULL, '', 248912),
(388827, 'PTHR31318:SF6', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248912),
(388828, 'PTHR31318:SF1', NULL, NULL, NULL, NULL, '', 248912),
(388829, 'PTHR31318:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248912),
(388830, 'PTHR43864', NULL, NULL, NULL, NULL, 'HYPOXANTHINE/GUANINE PHOSPHORIBOSYLTRANSFERASE', 248913),
(388831, 'PTHR43864:SF2', NULL, NULL, NULL, NULL, 'PUR OPERON REPRESSOR', 248913),
(388832, 'PTHR43864:SF3', NULL, NULL, NULL, NULL, 'ADENINE PHOSPHORIBOSYLTRANSFERASE, FUSED TO N-TERMINAL DNA-BINDING DOMAIN', 248913),
(388833, 'PTHR43864:SF1', NULL, NULL, NULL, NULL, 'XANTHINE PHOSPHORIBOSYLTRANSFERASE', 248913),
(388834, 'PTHR42663', NULL, NULL, NULL, NULL, 'HYDROLASE C777.06C-RELATED-RELATED', 248914),
(388835, 'PTHR42663:SF9', NULL, NULL, NULL, NULL, 'LACTAMASE_B DOMAIN-CONTAINING PROTEIN', 248914),
(388836, 'PTHR42663:SF6', NULL, NULL, NULL, NULL, 'HYDROLASE C777.06C-RELATED', 248914),
(388837, 'PTHR42663:SF7', NULL, NULL, NULL, NULL, 'COENZYME PQQ SYNTHESIS PROTEIN B', 248914),
(388838, 'PTHR42663:SF13', NULL, NULL, NULL, NULL, 'LACTAMASE_B DOMAIN-CONTAINING PROTEIN', 248914),
(388839, 'PTHR42663:SF14', NULL, NULL, NULL, NULL, 'METALLO-HYDROLASE/OXIDOREDUCTASE SUPERFAMILY PROTEIN', 248914),
(388840, 'PTHR42663:SF15', NULL, NULL, NULL, NULL, 'BNAC06G00010D PROTEIN', 248914),
(388841, 'PTHR42663:SF16', NULL, NULL, NULL, NULL, 'LACTAMASE_B DOMAIN-CONTAINING PROTEIN', 248914),
(388842, 'PTHR42663:SF4', NULL, NULL, NULL, NULL, 'SLL1036 PROTEIN', 248914),
(388843, 'PTHR42663:SF10', NULL, NULL, NULL, NULL, 'METALLO-HYDROLASE/OXIDOREDUCTASE SUPERFAMILY PROTEIN', 248914),
(388844, 'PTHR42663:SF11', NULL, NULL, NULL, NULL, 'LACTAMASE_B DOMAIN-CONTAINING PROTEIN', 248914),
(388845, 'PTHR42663:SF2', NULL, NULL, NULL, NULL, 'OS03G0642900 PROTEIN', 248914),
(388846, 'PTHR42663:SF3', NULL, NULL, NULL, NULL, 'OS09G0363800 PROTEIN', 248914),
(388847, 'PTHR42663:SF12', NULL, NULL, NULL, NULL, 'ATP-BINDING PROTEIN PHNP', 248914),
(388848, 'PTHR35978', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN M', 248915),
(388849, 'PTHR35978:SF1', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN M', 248915),
(388850, 'PTHR39470', NULL, NULL, NULL, NULL, 'CHROMOSOME 10, WHOLE GENOME SHOTGUN SEQUENCE', 248916),
(388851, 'PTHR39470:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 10, WHOLE GENOME SHOTGUN SEQUENCE', 248916),
(388852, 'PTHR22960:SF28', NULL, NULL, NULL, NULL, 'GTP 3'',8-CYCLASE', 248917),
(388853, 'PTHR22960:SF29', NULL, NULL, NULL, NULL, 'CYCLIC PYRANOPTERIN MONOPHOSPHATE SYNTHASE', 248917),
(388854, 'PTHR22960:SF26', NULL, NULL, NULL, NULL, 'MOLYBDENUM COFACTOR BIOSYNTHESIS PROTEIN 1', 248917),
(388855, 'PTHR22960:SF25', NULL, NULL, NULL, NULL, 'GTP 3'',8-CYCLASE', 248917),
(388856, 'PTHR22960:SF0', NULL, NULL, NULL, NULL, 'MOLYBDENUM COFACTOR BIOSYNTHESIS PROTEIN 1', 248917),
(388857, 'PTHR22960', NULL, NULL, NULL, NULL, 'MOLYBDOPTERIN COFACTOR SYNTHESIS PROTEIN A', 248917),
(388858, 'PTHR38924', NULL, NULL, NULL, NULL, 'ASPARAGINE AND ASPARTATE RICH PROTEIN 1', 248918),
(388859, 'PTHR38924:SF2', NULL, NULL, NULL, NULL, 'UBR-TYPE DOMAIN-CONTAINING PROTEIN', 248918),
(388860, 'PTHR12247:SF72', NULL, NULL, NULL, NULL, 'LETHAL(3)MALIGNANT BRAIN TUMOR-LIKE PROTEIN 3', 248919),
(388861, 'PTHR12247:SF62', NULL, NULL, NULL, NULL, 'SCM-LIKE WITH FOUR MBT DOMAINS PROTEIN 2', 248919),
(388862, 'PTHR12247:SF84', NULL, NULL, NULL, NULL, 'SEX COMB ON MIDLEG-LIKE PROTEIN 2', 248919),
(388863, 'PTHR12247:SF129', NULL, NULL, NULL, NULL, 'SOP-2-RELATED PROTEIN 3', 248919),
(388864, 'PTHR12247:SF128', NULL, NULL, NULL, NULL, 'SEX COMB ON MIDLEG-LIKE PROTEIN 1', 248919),
(388865, 'PTHR12247:SF139', NULL, NULL, NULL, NULL, 'STERILE ALPHA MOTIF DOMAIN-CONTAINING 1A', 248919),
(388866, 'PTHR12247:SF88', NULL, NULL, NULL, NULL, 'POLYHOMEOTIC-LIKE PROTEIN 3', 248919),
(388867, 'PTHR12247:SF77', NULL, NULL, NULL, NULL, 'SCM-LIKE WITH FOUR MBT DOMAINS PROTEIN 1', 248919);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(388868, 'PTHR12247:SF85', NULL, NULL, NULL, NULL, 'SEX COMB ON MIDLEG-LIKE PROTEIN 4', 248919),
(388869, 'PTHR12247:SF20', NULL, NULL, NULL, NULL, 'POLYHOMEOTIC-LIKE PROTEIN 1', 248919),
(388870, 'PTHR12247:SF64', NULL, NULL, NULL, NULL, 'LETHAL(3)MALIGNANT BRAIN TUMOR-LIKE PROTEIN 2', 248919),
(388871, 'PTHR12247:SF86', NULL, NULL, NULL, NULL, 'POLYHOMEOTIC-LIKE PROTEIN 2', 248919),
(388872, 'PTHR12247:SF69', NULL, NULL, NULL, NULL, 'LETHAL(3)MALIGNANT BRAIN TUMOR-LIKE PROTEIN 1', 248919),
(388873, 'PTHR12247:SF89', NULL, NULL, NULL, NULL, 'STERILE ALPHA MOTIF DOMAIN-CONTAINING PROTEIN 7', 248919),
(388874, 'PTHR12247:SF67', NULL, NULL, NULL, NULL, 'STERILE ALPHA MOTIF DOMAIN-CONTAINING PROTEIN 11', 248919),
(388875, 'PTHR12247:SF78', NULL, NULL, NULL, NULL, 'LETHAL(3)MALIGNANT BRAIN TUMOR-LIKE PROTEIN 4', 248919),
(388876, 'PTHR12247:SF79', NULL, NULL, NULL, NULL, 'MBT DOMAIN-CONTAINING PROTEIN 1', 248919),
(388877, 'PTHR12247:SF68', NULL, NULL, NULL, NULL, 'POLYCOMB PROTEIN SCMH1', 248919),
(388878, 'PTHR12247:SF130', NULL, NULL, NULL, NULL, 'SAM DOMAIN-CONTAINING PROTEIN', 248919),
(388879, 'PTHR12247:SF132', NULL, NULL, NULL, NULL, 'POLYCOMB PROTEIN SCM', 248919),
(388880, 'PTHR12247', NULL, NULL, NULL, NULL, 'POLYCOMB GROUP PROTEIN', 248919),
(388881, 'PTHR12247:SF131', NULL, NULL, NULL, NULL, 'LD05287P', 248919),
(388882, 'PTHR12247:SF138', NULL, NULL, NULL, NULL, 'POLYHOMEOTIC DISTAL, ISOFORM A-RELATED', 248919),
(388883, 'PTHR12247:SF104', NULL, NULL, NULL, NULL, 'POLYCOMB PROTEIN SFMBT', 248919),
(388884, 'PTHR19878:SF17', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN', 248920),
(388885, 'PTHR19878:SF18', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT PROTEIN', 248920),
(388886, 'PTHR19878', NULL, NULL, NULL, NULL, 'AUTOPHAGY PROTEIN 16-LIKE', 248920),
(388887, 'PTHR19878:SF7', NULL, NULL, NULL, NULL, 'PROTEIN ATG16L2', 248920),
(388888, 'PTHR19878:SF6', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 16-1', 248920),
(388889, 'PTHR19878:SF8', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED 16, ISOFORM F', 248920),
(388890, 'PTHR19878:SF14', NULL, NULL, NULL, NULL, 'AUTOPHAGIC-RELATED PROTEIN 16.2', 248920),
(388891, 'PTHR31325:SF92', NULL, NULL, NULL, NULL, 'OS05G0324300 PROTEIN', 248921),
(388892, 'PTHR31325:SF193', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388893, 'PTHR31325:SF194', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388894, 'PTHR31325:SF94', NULL, NULL, NULL, NULL, 'OS09G0562750 PROTEIN', 248921),
(388895, 'PTHR31325:SF196', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388896, 'PTHR31325:SF95', NULL, NULL, NULL, NULL, 'OS05G0236600 PROTEIN', 248921),
(388897, 'PTHR31325:SF230', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 248921),
(388898, 'PTHR31325:SF197', NULL, NULL, NULL, NULL, 'OS11G0171050 PROTEIN', 248921),
(388899, 'PTHR31325:SF110', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388900, 'PTHR31325:SF231', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388901, 'PTHR31325:SF90', NULL, NULL, NULL, NULL, 'OS04G0139400 PROTEIN', 248921),
(388902, 'PTHR31325:SF199', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388903, 'PTHR31325:SF233', NULL, NULL, NULL, NULL, 'OS06G0122200 PROTEIN', 248921),
(388904, 'PTHR31325:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248921),
(388905, 'PTHR31325:SF190', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388906, 'PTHR31325:SF191', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248921),
(388907, 'PTHR31325:SF192', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388908, 'PTHR31325:SF7', NULL, NULL, NULL, NULL, 'OS06G0124300 PROTEIN', 248921),
(388909, 'PTHR31325:SF6', NULL, NULL, NULL, NULL, 'OS02G0543500 PROTEIN', 248921),
(388910, 'PTHR31325:SF89', NULL, NULL, NULL, NULL, 'OS01G0333600 PROTEIN', 248921),
(388911, 'PTHR31325:SF235', NULL, NULL, NULL, NULL, 'OS04G0197700 PROTEIN', 248921);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(388912, 'PTHR31325:SF114', NULL, NULL, NULL, NULL, 'OS06G0119300 PROTEIN', 248921),
(388913, 'PTHR31325:SF236', NULL, NULL, NULL, NULL, 'OS04G0146975 PROTEIN', 248921),
(388914, 'PTHR31325:SF115', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388915, 'PTHR31325:SF237', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388916, 'PTHR31325:SF238', NULL, NULL, NULL, NULL, 'DUF594 FAMILY PROTEIN', 248921),
(388917, 'PTHR31325:SF117', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388918, 'PTHR31325:SF118', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388919, 'PTHR31325:SF239', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388920, 'PTHR31325:SF119', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388921, 'PTHR31325:SF185', NULL, NULL, NULL, NULL, 'OS10G0482200 PROTEIN', 248921),
(388922, 'PTHR31325:SF100', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388923, 'PTHR31325:SF221', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388924, 'PTHR31325:SF222', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF594)-RELATED', 248921),
(388925, 'PTHR31325:SF101', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388926, 'PTHR31325:SF180', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388927, 'PTHR31325:SF181', NULL, NULL, NULL, NULL, 'OS04G0154000 PROTEIN', 248921),
(388928, 'PTHR31325:SF224', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388929, 'PTHR31325:SF13', NULL, NULL, NULL, NULL, 'OS02G0299850 PROTEIN', 248921),
(388930, 'PTHR31325:SF103', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388931, 'PTHR31325:SF225', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388932, 'PTHR31325:SF104', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388933, 'PTHR31325:SF105', NULL, NULL, NULL, NULL, 'OS11G0171100 PROTEIN', 248921),
(388934, 'PTHR31325:SF226', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388935, 'PTHR31325:SF97', NULL, NULL, NULL, NULL, 'OS05G0508500 PROTEIN', 248921),
(388936, 'PTHR31325:SF108', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF594)-RELATED', 248921),
(388937, 'PTHR31325:SF229', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388938, 'PTHR31325:SF109', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388939, 'PTHR31325:SF250', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388940, 'PTHR31325:SF251', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388941, 'PTHR31325:SF252', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388942, 'PTHR31325:SF131', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388943, 'PTHR31325:SF253', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388944, 'PTHR31325:SF133', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388945, 'PTHR31325:SF254', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388946, 'PTHR31325:SF255', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388947, 'PTHR31325:SF256', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388948, 'PTHR31325:SF135', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388949, 'PTHR31325:SF257', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388950, 'PTHR31325:SF258', NULL, NULL, NULL, NULL, 'OS04G0154800 PROTEIN', 248921),
(388951, 'PTHR31325:SF138', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388952, 'PTHR31325:SF259', NULL, NULL, NULL, NULL, 'OS01G0798800 PROTEIN', 248921),
(388953, 'PTHR31325:SF139', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 248921),
(388954, 'PTHR31325:SF241', NULL, NULL, NULL, NULL, 'OSJNBA0089E12.13-LIKE PROTEIN', 248921);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(388955, 'PTHR31325:SF121', NULL, NULL, NULL, NULL, 'OSJNBB0045P24.5-LIKE PROTEIN', 248921),
(388956, 'PTHR31325:SF243', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388957, 'PTHR31325:SF244', NULL, NULL, NULL, NULL, 'DUF594 FAMILY PROTEIN', 248921),
(388958, 'PTHR31325:SF123', NULL, NULL, NULL, NULL, 'OS01G0953100 PROTEIN', 248921),
(388959, 'PTHR31325:SF124', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388960, 'PTHR31325:SF245', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388961, 'PTHR31325:SF79', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388962, 'PTHR31325:SF246', NULL, NULL, NULL, NULL, 'OS04G0221800 PROTEIN', 248921),
(388963, 'PTHR31325:SF247', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388964, 'PTHR31325:SF126', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF594)-RELATED', 248921),
(388965, 'PTHR31325:SF127', NULL, NULL, NULL, NULL, 'OS02G0243700 PROTEIN', 248921),
(388966, 'PTHR31325:SF248', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388967, 'PTHR31325:SF249', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388968, 'PTHR31325:SF129', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388969, 'PTHR31325:SF150', NULL, NULL, NULL, NULL, 'OS07G0105800 PROTEIN', 248921),
(388970, 'PTHR31325:SF152', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388971, 'PTHR31325:SF153', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388972, 'PTHR31325', NULL, NULL, NULL, NULL, 'OS01G0798800 PROTEIN-RELATED', 248921),
(388973, 'PTHR31325:SF45', NULL, NULL, NULL, NULL, 'OS11G0638700 PROTEIN', 248921),
(388974, 'PTHR31325:SF157', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248921),
(388975, 'PTHR31325:SF158', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388976, 'PTHR31325:SF44', NULL, NULL, NULL, NULL, 'OS11G0681100 PROTEIN', 248921),
(388977, 'PTHR31325:SF260', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388978, 'PTHR31325:SF261', NULL, NULL, NULL, NULL, 'OS06G0703300 PROTEIN', 248921),
(388979, 'PTHR31325:SF262', NULL, NULL, NULL, NULL, 'BNAC09G52950D PROTEIN', 248921),
(388980, 'PTHR31325:SF263', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388981, 'PTHR31325:SF264', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388982, 'PTHR31325:SF143', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388983, 'PTHR31325:SF265', NULL, NULL, NULL, NULL, 'OS04G0143200 PROTEIN', 248921),
(388984, 'PTHR31325:SF266', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248921),
(388985, 'PTHR31325:SF267', NULL, NULL, NULL, NULL, 'OSJNBB0045P24.5-LIKE PROTEIN', 248921),
(388986, 'PTHR31325:SF146', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388987, 'PTHR31325:SF268', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388988, 'PTHR31325:SF269', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388989, 'PTHR31325:SF171', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388990, 'PTHR31325:SF172', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN-RELATED', 248921),
(388991, 'PTHR31325:SF173', NULL, NULL, NULL, NULL, 'OSJNBA0089E12.13-LIKE PROTEIN', 248921),
(388992, 'PTHR31325:SF174', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388993, 'PTHR31325:SF175', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388994, 'PTHR31325:SF176', NULL, NULL, NULL, NULL, 'OS07G0115700 PROTEIN', 248921),
(388995, 'PTHR31325:SF28', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388996, 'PTHR31325:SF29', NULL, NULL, NULL, NULL, 'OS01G0373500 PROTEIN', 248921),
(388997, 'PTHR31325:SF23', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(388998, 'PTHR31325:SF213', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248921);
INSERT INTO "PUBLIC"."MODEL" VALUES
(388999, 'PTHR31325:SF214', NULL, NULL, NULL, NULL, 'OS07G0116300 PROTEIN', 248921),
(389000, 'PTHR31325:SF26', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(389001, 'PTHR31325:SF215', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(389002, 'PTHR31325:SF216', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(389003, 'PTHR31325:SF217', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(389004, 'PTHR31325:SF219', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(389005, 'PTHR31325:SF22', NULL, NULL, NULL, NULL, 'OS07G0180100 PROTEIN', 248921),
(389006, 'PTHR31325:SF160', NULL, NULL, NULL, NULL, 'OSJNBB0040D15.7-LIKE PROTEIN', 248921),
(389007, 'PTHR31325:SF162', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(389008, 'PTHR31325:SF40', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(389009, 'PTHR31325:SF164', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(389010, 'PTHR31325:SF166', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(389011, 'PTHR31325:SF200', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(389012, 'PTHR31325:SF167', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(389013, 'PTHR31325:SF209', NULL, NULL, NULL, NULL, 'DUF4220 DOMAIN-CONTAINING PROTEIN', 248921),
(389014, 'PTHR31325:SF34', NULL, NULL, NULL, NULL, 'OS06G0119100 PROTEIN', 248921),
(389015, 'PTHR31325:SF169', NULL, NULL, NULL, NULL, 'OS08G0194900 PROTEIN', 248921),
(389016, 'PTHR31325:SF36', NULL, NULL, NULL, NULL, 'OS06G0120200 PROTEIN', 248921),
(389017, 'PTHR31325:SF205', NULL, NULL, NULL, NULL, 'OS01G0143400 PROTEIN', 248921),
(389018, 'PTHR46145:SF3', NULL, NULL, NULL, NULL, 'HEPARANASE', 248922),
(389019, 'PTHR46145:SF4', NULL, NULL, NULL, NULL, 'HEPARANASE-LIKE PROTEIN', 248922),
(389020, 'PTHR46145:SF1', NULL, NULL, NULL, NULL, 'INACTIVE HEPARANASE-2', 248922),
(389021, 'PTHR46145', NULL, NULL, NULL, NULL, 'HEPARANASE', 248922),
(389022, 'PTHR33417:SF18', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE REDUCTASE COMPLEX 1 MLRQ SUBUNIT-RELATED', 248923),
(389023, 'PTHR33417:SF6', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE REDUCTASE COMPLEX 1 MLRQ SUBUNIT', 248923),
(389024, 'PTHR33417:SF5', NULL, NULL, NULL, NULL, 'OS07G0274400 PROTEIN', 248923),
(389025, 'PTHR33417', NULL, NULL, NULL, NULL, 'G-BOX BINDING PROTEIN', 248923),
(389026, 'PTHR33417:SF1', NULL, NULL, NULL, NULL, 'B12D PROTEIN', 248923),
(389027, 'PTHR33417:SF22', NULL, NULL, NULL, NULL, 'OS07G0604600 PROTEIN', 248923),
(389028, 'PTHR33417:SF21', NULL, NULL, NULL, NULL, 'OS07G0274700 PROTEIN', 248923),
(389029, 'PTHR33417:SF13', NULL, NULL, NULL, NULL, 'G-BOX BINDING PROTEIN', 248923),
(389030, 'PTHR33417:SF15', NULL, NULL, NULL, NULL, 'B12D PROTEIN', 248923),
(389031, 'PTHR33417:SF14', NULL, NULL, NULL, NULL, '', 248923),
(389032, 'PTHR33417:SF17', NULL, NULL, NULL, NULL, 'BNAA06G20770D PROTEIN', 248923),
(389033, 'PTHR35336:SF5', NULL, NULL, NULL, NULL, 'ADENOSYLCOBINAMIDE AMIDOHYDROLASE', 248924),
(389034, 'PTHR35336', NULL, NULL, NULL, NULL, 'ADENOSYLCOBINAMIDE AMIDOHYDROLASE', 248924),
(389035, 'PTHR35336:SF7', NULL, NULL, NULL, NULL, 'PGPA DOMAIN-CONTAINING PROTEIN', 248924),
(389036, 'PTHR35889', NULL, NULL, NULL, NULL, 'CYCLOINULO-OLIGOSACCHARIDE FRUCTANOTRANSFERASE-RELATED', 248925),
(389037, 'PTHR35889:SF8', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248925),
(389038, 'PTHR35889:SF3', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 248925),
(389039, 'PTHR45902:SF2', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F2_4 DOMAIN-CONTAINING PROTEIN', 248926),
(389040, 'PTHR45902:SF1', NULL, NULL, NULL, NULL, 'LATROPHILIN RECEPTOR-LIKE PROTEIN A', 248926),
(389041, 'PTHR45902:SF3', NULL, NULL, NULL, NULL, 'COUPLED RECEPTOR MTH2, PUTATIVE-RELATED', 248926),
(389042, 'PTHR45902', NULL, NULL, NULL, NULL, 'LATROPHILIN RECEPTOR-LIKE PROTEIN A', 248926),
(389043, 'PTHR47421:SF1', NULL, NULL, NULL, NULL, 'GS HOMEOBOX 2', 248927);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(389044, 'PTHR47421', NULL, NULL, NULL, NULL, 'GS HOMEOBOX 2', 248927),
(389045, 'PTHR45804:SF7', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 248928),
(389046, 'PTHR45804:SF6', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-B13', 248928),
(389047, 'PTHR45804:SF5', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-C13', 248928),
(389048, 'PTHR45804:SF4', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-D13', 248928),
(389049, 'PTHR45804:SF3', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-A13', 248928),
(389050, 'PTHR45804', NULL, NULL, NULL, NULL, 'SEGMENTATION PROTEIN FUSHI TARAZU-LIKE PROTEIN', 248928),
(389051, 'PTHR45804:SF8', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-A13A-RELATED', 248928),
(389052, 'PTHR35986:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248929),
(389053, 'PTHR35986', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248929),
(389054, 'PTHR16677:SF2', NULL, NULL, NULL, NULL, 'SI:CH211-286O17.1', 248930),
(389055, 'PTHR16677', NULL, NULL, NULL, NULL, 'HEMATOPOIETIC PROGENITOR CELL ANTIGEN CD34', 248930),
(389056, 'PTHR16677:SF1', NULL, NULL, NULL, NULL, 'HEMATOPOIETIC PROGENITOR CELL ANTIGEN CD34', 248930),
(389057, 'PTHR13145:SF8', NULL, NULL, NULL, NULL, 'BNAA08G11620D PROTEIN', 248931),
(389058, 'PTHR13145:SF7', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 248931),
(389059, 'PTHR13145:SF9', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING-CH-TYPE, ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 248931),
(389060, 'PTHR13145:SF4', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 248931),
(389061, 'PTHR13145:SF3', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER SUPERFAMILY PROTEIN', 248931),
(389062, 'PTHR13145:SF6', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 248931),
(389063, 'PTHR13145:SF0', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MARCHF6', 248931),
(389064, 'PTHR13145:SF2', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 248931),
(389065, 'PTHR13145:SF1', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 248931),
(389066, 'PTHR13145', NULL, NULL, NULL, NULL, 'SSM4 PROTEIN', 248931),
(389067, 'PTHR15140:SF39', NULL, NULL, NULL, NULL, 'LATE BLIGHT RESISTANCE PROTEIN HOMOLOG R1B-8-RELATED', 248932),
(389068, 'PTHR15140', NULL, NULL, NULL, NULL, 'TUBULIN-SPECIFIC CHAPERONE E', 248932),
(389069, 'PTHR15140:SF35', NULL, NULL, NULL, NULL, 'TUBULIN-SPECIFIC CHAPERONE E', 248932),
(389070, 'PTHR15140:SF36', NULL, NULL, NULL, NULL, 'LATE BLIGHT RESISTANCE PROTEIN HOMOLOG R1A-3-RELATED', 248932),
(389071, 'PTHR15140:SF37', NULL, NULL, NULL, NULL, 'TUBULIN-FOLDING COFACTOR E', 248932),
(389072, 'PTHR15140:SF38', NULL, NULL, NULL, NULL, 'PLANT RESISTANCE PROTEIN', 248932),
(389073, 'PTHR15140:SF31', NULL, NULL, NULL, NULL, 'TUBULIN-SPECIFIC CHAPERONE E', 248932),
(389074, 'PTHR15140:SF53', NULL, NULL, NULL, NULL, 'HERO RESISTANCE PROTEIN', 248932),
(389075, 'PTHR15140:SF54', NULL, NULL, NULL, NULL, 'RPI-VNT1', 248932),
(389076, 'PTHR15140:SF33', NULL, NULL, NULL, NULL, 'LATE BLIGHT RESISTANCE PROTEIN HOMOLOG R1B-16-RELATED', 248932),
(389077, 'PTHR15140:SF50', NULL, NULL, NULL, NULL, 'LATE BLIGHT RESISTANCE PROTEIN HOMOLOG R1B-16-RELATED', 248932),
(389078, 'PTHR15140:SF51', NULL, NULL, NULL, NULL, 'LATE BLIGHT RESISTANCE PROTEIN HOMOLOG R1B-16-RELATED', 248932),
(389079, 'PTHR15140:SF52', NULL, NULL, NULL, NULL, 'PLANT RESISTANCE PROTEIN', 248932),
(389080, 'PTHR15140:SF6', NULL, NULL, NULL, NULL, 'TUBULIN-SPECIFIC CHAPERONE COFACTOR E-LIKE PROTEIN', 248932),
(389081, 'PTHR15140:SF28', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN', 248932),
(389082, 'PTHR15140:SF29', NULL, NULL, NULL, NULL, 'LATE BLIGHT RESISTANCE PROTEIN HOMOLOG R1A-3-RELATED', 248932),
(389083, 'PTHR15140:SF46', NULL, NULL, NULL, NULL, 'NRC1', 248932),
(389084, 'PTHR15140:SF47', NULL, NULL, NULL, NULL, 'LATE BLIGHT RESISTANCE PROTEIN HOMOLOG R1A-3 ISOFORM X1-RELATED', 248932),
(389085, 'PTHR15140:SF48', NULL, NULL, NULL, NULL, 'LATE BLIGHT RESISTANCE PROTEIN HOMOLOG R1B-14-RELATED', 248932);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(389086, 'PTHR15140:SF27', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN BS2', 248932),
(389087, 'PTHR15140:SF49', NULL, NULL, NULL, NULL, 'LATE BLIGHT RESISTANCE PROTEIN HOMOLOG R1A-3-RELATED', 248932),
(389088, 'PTHR15140:SF42', NULL, NULL, NULL, NULL, 'LATE BLIGHT RESISTANCE PROTEIN HOMOLOG R1B-16-RELATED', 248932),
(389089, 'PTHR15140:SF43', NULL, NULL, NULL, NULL, 'LATE BLIGHT RESISTANCE PROTEIN HOMOLOG R1B-17-RELATED', 248932),
(389090, 'PTHR15140:SF21', NULL, NULL, NULL, NULL, 'CAP-GLY DOMAIN-CONTAINING PROTEIN', 248932),
(389091, 'PTHR15140:SF22', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 248932),
(389092, 'PTHR15140:SF44', NULL, NULL, NULL, NULL, 'LATE BLIGHT RESISTANCE PROTEIN HOMOLOG R1B-23 ISOFORM X1-RELATED', 248932),
(389093, 'PTHR15140:SF45', NULL, NULL, NULL, NULL, 'LATE BLIGHT RESISTANCE PROTEIN HOMOLOG R1B-8-RELATED', 248932),
(389094, 'PTHR15140:SF40', NULL, NULL, NULL, NULL, 'LATE BLIGHT RESISTANCE PROTEIN HOMOLOG R1B-23-RELATED', 248932),
(389095, 'PTHR15140:SF41', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RF45 ISOFORM X1-RELATED', 248932),
(389096, 'PTHR36873', NULL, NULL, NULL, NULL, 'HYPOTHETICAL GENE SUPPORTED BY BC079057', 248933),
(389097, 'PTHR36873:SF1', NULL, NULL, NULL, NULL, 'HYPOTHETICAL GENE SUPPORTED BY BC079057', 248933),
(389098, 'PTHR24078:SF555', NULL, NULL, NULL, NULL, 'DNAJ CHAPERONE CARBOXY-TERMINAL DOMAIN PROTEIN', 248934),
(389099, 'PTHR24078:SF532', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 248934),
(389100, 'PTHR24078:SF576', NULL, NULL, NULL, NULL, 'AT19485P-RELATED', 248934),
(389101, 'PTHR24078:SF539', NULL, NULL, NULL, NULL, 'DNAJ PROTEIN', 248934),
(389102, 'PTHR24078:SF538', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK FAMILY PROTEIN', 248934),
(389103, 'PTHR24078:SF559', NULL, NULL, NULL, NULL, 'ZGC:122979', 248934),
(389104, 'PTHR24078:SF218', NULL, NULL, NULL, NULL, 'OS08G0374400 PROTEIN', 248934),
(389105, 'PTHR24078:SF558', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 248934),
(389106, 'PTHR24078:SF175', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK FAMILY PROTEIN', 248934),
(389107, 'PTHR24078:SF571', NULL, NULL, NULL, NULL, 'DNAJ_C DOMAIN-CONTAINING PROTEIN', 248934),
(389108, 'PTHR24078:SF553', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY B MEMBER 5', 248934),
(389109, 'PTHR24078:SF575', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK FAMILY PROTEIN', 248934),
(389110, 'PTHR24078:SF531', NULL, NULL, NULL, NULL, 'OS02G0128400 PROTEIN', 248934),
(389111, 'PTHR24078:SF574', NULL, NULL, NULL, NULL, 'OS01G0875700 PROTEIN', 248934),
(389112, 'PTHR24078', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER', 248934),
(389113, 'PTHR24078:SF573', NULL, NULL, NULL, NULL, 'POTYVIRAL CAPSID PROTEIN INTERACTING PROTEIN 2B', 248934),
(389114, 'PTHR24078:SF551', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 248934),
(389115, 'PTHR24078:SF572', NULL, NULL, NULL, NULL, 'DNAJ_C DOMAIN-CONTAINING PROTEIN', 248934),
(389116, 'PTHR24078:SF550', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 248934),
(389117, 'PTHR24078:SF519', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY B MEMBER 13', 248934),
(389118, 'PTHR24078:SF524', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK FAMILY PROTEIN', 248934),
(389119, 'PTHR24078:SF568', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY B MEMBER 1', 248934),
(389120, 'PTHR24078:SF567', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK PROTEIN FAMILY (HSP40) MEMBER B5', 248934),
(389121, 'PTHR24078:SF545', NULL, NULL, NULL, NULL, 'HSP40/DNAJ PEPTIDE-BINDING PROTEIN', 248934),
(389122, 'PTHR24078:SF522', NULL, NULL, NULL, NULL, 'DNAJ CHAPERONE C-TERMINAL DOMAIN-CONTAINING PROTEIN', 248934),
(389123, 'PTHR24078:SF301', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN', 248934),
(389124, 'PTHR24078:SF565', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK FAMILY PROTEIN', 248934),
(389125, 'PTHR24078:SF548', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK FAMILY PROTEIN', 248934),
(389126, 'PTHR24078:SF547', NULL, NULL, NULL, NULL, 'DNAJ_C DOMAIN-CONTAINING PROTEIN', 248934);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(389127, 'PTHR24078:SF288', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY B MEMBER 4', 248934),
(389128, 'PTHR24078:SF562', NULL, NULL, NULL, NULL, 'DNAJ DOMAIN CONTAINING PROTEIN', 248934),
(389129, 'PTHR24078:SF561', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 248934),
(389130, 'PTHR24078:SF529', NULL, NULL, NULL, NULL, 'HEAT-SHOCK PROTEIN DNAJ', 248934),
(389131, 'PTHR33374:SF37', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN PEPTIDE, AGP-RELATED', 248935),
(389132, 'PTHR33374:SF48', NULL, NULL, NULL, NULL, 'OS01G0657000 PROTEIN', 248935),
(389133, 'PTHR33374:SF36', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN PEPTIDE 20', 248935),
(389134, 'PTHR33374:SF47', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN PROTEIN 20-RELATED', 248935),
(389135, 'PTHR33374:SF46', NULL, NULL, NULL, NULL, 'OS05G0217000 PROTEIN', 248935),
(389136, 'PTHR33374:SF23', NULL, NULL, NULL, NULL, 'OS01G0592500 PROTEIN', 248935),
(389137, 'PTHR33374:SF22', NULL, NULL, NULL, NULL, 'OS01G0718500 PROTEIN', 248935),
(389138, 'PTHR33374:SF43', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN PEPTIDE 22-LIKE', 248935),
(389139, 'PTHR33374:SF32', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN PROTEIN 16', 248935),
(389140, 'PTHR33374:SF31', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN PEPTIDE 22-LIKE', 248935),
(389141, 'PTHR33374:SF42', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN PEPTIDE-LIKE PROTEIN', 248935),
(389142, 'PTHR33374:SF41', NULL, NULL, NULL, NULL, '', 248935),
(389143, 'PTHR33374:SF52', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN PROTEIN 20', 248935),
(389144, 'PTHR33374:SF51', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN PEPTIDE 20-LIKE', 248935),
(389145, 'PTHR33374:SF50', NULL, NULL, NULL, NULL, 'OS02G0209300 PROTEIN', 248935),
(389146, 'PTHR33374:SF7', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN PEPTIDE-LIKE PROTEIN', 248935),
(389147, 'PTHR33374', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN PROTEIN 20', 248935),
(389148, 'PTHR33374:SF39', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN PROTEIN 22', 248935),
(389149, 'PTHR33374:SF28', NULL, NULL, NULL, NULL, '', 248935),
(389150, 'PTHR33374:SF27', NULL, NULL, NULL, NULL, 'OS01G0591400 PROTEIN', 248935),
(389151, 'PTHR33374:SF38', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN PROTEIN 41', 248935),
(389152, 'PTHR33374:SF49', NULL, NULL, NULL, NULL, 'BNAA03G12370D PROTEIN', 248935),
(389153, 'PTHR10367:SF23', NULL, NULL, NULL, NULL, 'GTP--RNA GUANYLYLTRANSFERASE', 248936),
(389154, 'PTHR10367:SF12', NULL, NULL, NULL, NULL, 'GTP--RNA GUANYLYLTRANSFERASE', 248936),
(389155, 'PTHR10367:SF22', NULL, NULL, NULL, NULL, 'GTP--RNA GUANYLYLTRANSFERASE', 248936),
(389156, 'PTHR10367:SF11', NULL, NULL, NULL, NULL, 'GTP--RNA GUANYLYLTRANSFERASE', 248936),
(389157, 'PTHR10367:SF21', NULL, NULL, NULL, NULL, 'GTP--RNA GUANYLYLTRANSFERASE', 248936),
(389158, 'PTHR10367:SF18', NULL, NULL, NULL, NULL, 'RNA/RNP COMPLEX-1-INTERACTING PHOSPHATASE', 248936),
(389159, 'PTHR10367:SF17', NULL, NULL, NULL, NULL, 'MRNA-CAPPING ENZYME', 248936),
(389160, 'PTHR10367:SF15', NULL, NULL, NULL, NULL, 'GTP--RNA GUANYLYLTRANSFERASE', 248936),
(389161, 'PTHR10367:SF25', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PHOSPHATASE CATALYTIC DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_1G03540)', 248936),
(389162, 'PTHR10367:SF13', NULL, NULL, NULL, NULL, 'GTP--RNA GUANYLYLTRANSFERASE', 248936),
(389163, 'PTHR10367:SF24', NULL, NULL, NULL, NULL, 'TYR_PHOSPHATASE_2 DOMAIN-CONTAINING PROTEIN', 248936),
(389164, 'PTHR10367', NULL, NULL, NULL, NULL, 'MRNA-CAPPING ENZYME', 248936),
(389165, 'PTHR10367:SF9', NULL, NULL, NULL, NULL, 'DUAL-SPECIFICITY PHOSPHATASE 11 (RNA/RNP COMPLEX 1-INTERACTING)', 248936),
(389166, 'PTHR12092', NULL, NULL, NULL, NULL, 'PLECKSTRIN', 248937),
(389167, 'PTHR12092:SF1', NULL, NULL, NULL, NULL, 'PLECKSTRIN', 248937),
(389168, 'PTHR12092:SF2', NULL, NULL, NULL, NULL, 'PLECKSTRIN-2', 248937),
(389169, 'PTHR12092:SF39', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 248937),
(389170, 'PTHR12092:SF16', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 248937),
(389171, 'PTHR12092:SF38', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 248937);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(389172, 'PTHR36170', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 89 KDA', 248938),
(389173, 'PTHR36170:SF1', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 89 KDA', 248938),
(389174, 'PTHR46363', NULL, NULL, NULL, NULL, 'DEOXYRIBONUCLEASE TATDN2-RELATED', 248939),
(389175, 'PTHR46363:SF1', NULL, NULL, NULL, NULL, 'DEOXYRIBONUCLEASE TATDN2-RELATED', 248939),
(389176, 'PTHR35721:SF1', NULL, NULL, NULL, NULL, 'UREIDOGLYCOLATE HYDROLASE', 248940),
(389177, 'PTHR35721', NULL, NULL, NULL, NULL, 'UREIDOGLYCOLATE HYDROLASE', 248940),
(389178, 'PTHR22947', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', 248941),
(389179, 'PTHR22947:SF41', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', 248941),
(389180, 'PTHR22947:SF20', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', 248941),
(389181, 'PTHR22947:SF10', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', 248941),
(389182, 'PTHR22947:SF11', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', 248941),
(389183, 'PTHR22947:SF40', NULL, NULL, NULL, NULL, 'MSP DOMAIN-CONTAINING PROTEIN', 248941),
(389184, 'PTHR22947:SF39', NULL, NULL, NULL, NULL, 'MSP DOMAIN-CONTAINING PROTEIN', 248941),
(389185, 'PTHR22947:SF18', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', 248941),
(389186, 'PTHR22947:SF19', NULL, NULL, NULL, NULL, 'MSP DOMAIN-CONTAINING PROTEIN', 248941),
(389187, 'PTHR22947:SF34', NULL, NULL, NULL, NULL, 'MSP DOMAIN-CONTAINING PROTEIN-RELATED', 248941),
(389188, 'PTHR22947:SF12', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', 248941),
(389189, 'PTHR22947:SF15', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', 248941),
(389190, 'PTHR22947:SF37', NULL, NULL, NULL, NULL, 'MSP DOMAIN-CONTAINING PROTEIN-RELATED', 248941),
(389191, 'PTHR22947:SF7', NULL, NULL, NULL, NULL, 'MSP DOMAIN-CONTAINING PROTEIN-RELATED', 248941),
(389192, 'PTHR22947:SF6', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', 248941),
(389193, 'PTHR22947:SF5', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', 248941),
(389194, 'PTHR22947:SF4', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', 248941),
(389195, 'PTHR22947:SF3', NULL, NULL, NULL, NULL, 'MSP DOMAIN-CONTAINING PROTEIN-RELATED', 248941),
(389196, 'PTHR22947:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG16675', 248941),
(389197, 'PTHR16002', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 248-LIKE', 248942),
(389198, 'PTHR16002:SF6', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR-BINDING PROTEIN 3 RECEPTOR', 248942),
(389199, 'PTHR16002:SF5', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 248', 248942),
(389200, 'PTHR16002:SF4', NULL, NULL, NULL, NULL, 'TMEM219 DOMAIN-CONTAINING PROTEIN', 248942),
(389201, 'PTHR18763:SF4', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 248943),
(389202, 'PTHR18763:SF3', NULL, NULL, NULL, NULL, 'OS09G0477800 PROTEIN', 248943),
(389203, 'PTHR18763:SF0', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 18', 248943),
(389204, 'PTHR18763', NULL, NULL, NULL, NULL, 'WD-REPEAT PROTEIN 18', 248943),
(389205, 'PTHR15750:SF4', NULL, NULL, NULL, NULL, 'TUBULINYL-TYR CARBOXYPEPTIDASE 2', 248944),
(389206, 'PTHR15750:SF2', NULL, NULL, NULL, NULL, '', 248944),
(389207, 'PTHR15750:SF5', NULL, NULL, NULL, NULL, 'TUBULINYL-TYR CARBOXYPEPTIDASE 1', 248944),
(389208, 'PTHR15750', NULL, NULL, NULL, NULL, 'VASOHIBIN-1-LIKE ISOFORM X2', 248944),
(389209, 'PTHR38130', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 248945),
(389210, 'PTHR38130:SF1', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 248945),
(389211, 'PTHR34663:SF9', NULL, NULL, NULL, NULL, 'OS06G0637400 PROTEIN', 248946),
(389212, 'PTHR34663:SF18', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER FAMILY PROTEIN', 248946),
(389213, 'PTHR34663:SF19', NULL, NULL, NULL, NULL, '', 248946),
(389214, 'PTHR34663:SF14', NULL, NULL, NULL, NULL, 'BNAA03G53880D PROTEIN', 248946),
(389215, 'PTHR34663:SF15', NULL, NULL, NULL, NULL, '', 248946),
(389216, 'PTHR34663:SF16', NULL, NULL, NULL, NULL, '', 248946),
(389217, 'PTHR34663:SF10', NULL, NULL, NULL, NULL, 'PAMP-INDUCED SECRETED PEPTIDE 2', 248946),
(389218, 'PTHR34663:SF11', NULL, NULL, NULL, NULL, 'DERMOKINE-LIKE', 248946);
INSERT INTO "PUBLIC"."MODEL" VALUES
(389219, 'PTHR34663:SF12', NULL, NULL, NULL, NULL, 'BNAA04G13530D PROTEIN', 248946),
(389220, 'PTHR34663:SF13', NULL, NULL, NULL, NULL, 'PRECURSOR OF CEP16', 248946),
(389221, 'PTHR34663:SF8', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 248946),
(389222, 'PTHR34663:SF20', NULL, NULL, NULL, NULL, '', 248946),
(389223, 'PTHR34663', NULL, NULL, NULL, NULL, 'OS06G0637400 PROTEIN', 248946),
(389224, 'PTHR45773:SF9', NULL, NULL, NULL, NULL, 'SLIT AND NTRK-LIKE FAMILY, MEMBER 3B', 248947),
(389225, 'PTHR45773:SF6', NULL, NULL, NULL, NULL, 'SLIT AND NTRK-LIKE PROTEIN 3', 248947),
(389226, 'PTHR45773:SF5', NULL, NULL, NULL, NULL, 'SLIT AND NTRK-LIKE PROTEIN 5', 248947),
(389227, 'PTHR45773:SF8', NULL, NULL, NULL, NULL, 'SLIT AND NTRK-LIKE FAMILY, MEMBER 5B', 248947),
(389228, 'PTHR45773:SF7', NULL, NULL, NULL, NULL, 'SLIT AND NTRK-LIKE PROTEIN 1', 248947),
(389229, 'PTHR45773', NULL, NULL, NULL, NULL, 'SLIT AND NTRK-LIKE PROTEIN 4-RELATED', 248947),
(389230, 'PTHR45773:SF1', NULL, NULL, NULL, NULL, 'SLIT AND NTRK-LIKE PROTEIN 6', 248947),
(389231, 'PTHR45773:SF4', NULL, NULL, NULL, NULL, 'SLIT AND NTRK-LIKE PROTEIN 2', 248947),
(389232, 'PTHR45773:SF3', NULL, NULL, NULL, NULL, 'SLIT AND NTRK-LIKE PROTEIN 4', 248947),
(389233, 'PTHR45809:SF5', NULL, NULL, NULL, NULL, 'PHOSDUCIN DOMAIN-CONTAINING PROTEIN', 248948),
(389234, 'PTHR45809:SF6', NULL, NULL, NULL, NULL, 'PHOSDUCIN DOMAIN-CONTAINING PROTEIN', 248948),
(389235, 'PTHR45809:SF3', NULL, NULL, NULL, NULL, 'VIRAL IAP-ASSOCIATED FACTOR HOMOLOG', 248948),
(389236, 'PTHR45809:SF4', NULL, NULL, NULL, NULL, 'PHOSDUCIN-LIKE PROTEIN 3', 248948),
(389237, 'PTHR45809:SF1', NULL, NULL, NULL, NULL, 'PHOSDUCIN-LIKE PROTEIN 2', 248948),
(389238, 'PTHR45809:SF2', NULL, NULL, NULL, NULL, 'PHOSDUCIN-LIKE PROTEIN 1', 248948),
(389239, 'PTHR45809', NULL, NULL, NULL, NULL, 'VIRAL IAP-ASSOCIATED FACTOR HOMOLOG', 248948),
(389240, 'PTHR42901:SF1', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE', 248949),
(389241, 'PTHR42901', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE', 248949),
(389242, 'PTHR47994:SF5', NULL, NULL, NULL, NULL, 'F14D16.11-RELATED', 248950),
(389243, 'PTHR47994:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB80', 248950),
(389244, 'PTHR47994:SF11', NULL, NULL, NULL, NULL, '', 248950),
(389245, 'PTHR47994:SF9', NULL, NULL, NULL, NULL, 'BNAA10G10260D PROTEIN', 248950),
(389246, 'PTHR47994:SF8', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 248950),
(389247, 'PTHR47994:SF10', NULL, NULL, NULL, NULL, 'MYB-LIKE HTH TRANSCRIPTIONAL REGULATOR FAMILY PROTEIN-RELATED', 248950),
(389248, 'PTHR47994', NULL, NULL, NULL, NULL, 'F14D16.11-RELATED', 248950),
(389249, 'PTHR12387:SF3', NULL, NULL, NULL, NULL, 'CSN8_PSD8_EIF3K DOMAIN-CONTAINING PROTEIN', 248951),
(389250, 'PTHR12387:SF4', NULL, NULL, NULL, NULL, 'PCI DOMAIN-CONTAINING PROTEIN', 248951),
(389251, 'PTHR12387:SF5', NULL, NULL, NULL, NULL, 'PCI DOMAIN-CONTAINING PROTEIN', 248951),
(389252, 'PTHR12387:SF0', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 8', 248951),
(389253, 'PTHR12387', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 8', 248951),
(389254, 'PTHR12387:SF1', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 8', 248951),
(389255, 'PTHR11482:SF59', NULL, NULL, NULL, NULL, 'DIAMINOPIMELATE DECARBOXYLASE 2 CHLOROPLASTIC', 248952),
(389256, 'PTHR11482:SF4', NULL, NULL, NULL, NULL, 'ANTIZYME INHIBITOR 2', 248952),
(389257, 'PTHR11482:SF58', NULL, NULL, NULL, NULL, 'DIAMINOPIMELATE DECARBOXYLASE 2 CHLOROPLASTIC', 248952),
(389258, 'PTHR11482:SF62', NULL, NULL, NULL, NULL, '', 248952),
(389259, 'PTHR11482:SF61', NULL, NULL, NULL, NULL, 'ORNITHINE DECARBOXYLASE-LIKE', 248952),
(389260, 'PTHR11482:SF42', NULL, NULL, NULL, NULL, 'ORNITHINE DECARBOXYLASE', 248952),
(389261, 'PTHR11482:SF63', NULL, NULL, NULL, NULL, 'ORNITHINE DECARBOXYLASE-LIKE', 248952),
(389262, 'PTHR11482:SF7', NULL, NULL, NULL, NULL, 'ANTIZYME INHIBITOR 1', 248952),
(389263, 'PTHR11482', NULL, NULL, NULL, NULL, 'ARGININE/DIAMINOPIMELATE/ORNITHINE DECARBOXYLASE', 248952);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(389264, 'PTHR11482:SF57', NULL, NULL, NULL, NULL, 'GENE MODEL 853, (NCBI)', 248952),
(389265, 'PTHR11482:SF6', NULL, NULL, NULL, NULL, 'ORNITHINE DECARBOXYLASE 1-RELATED', 248952),
(389266, 'PTHR11482:SF56', NULL, NULL, NULL, NULL, 'PROTEIN CBG12014', 248952),
(389267, 'PTHR36148:SF2', NULL, NULL, NULL, NULL, 'GROUND-LIKE DOMAIN-CONTAINING PROTEIN', 248953),
(389268, 'PTHR36148:SF3', NULL, NULL, NULL, NULL, '50 KDA SPICULE MATRIX PROTEIN', 248953),
(389269, 'PTHR36148', NULL, NULL, NULL, NULL, '50 KDA SPICULE MATRIX PROTEIN-RELATED', 248953),
(389270, 'PTHR19433:SF135', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 27', 248954),
(389271, 'PTHR19433:SF72', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA CHAIN MC.7.G5-RELATED', 248954),
(389272, 'PTHR19433:SF114', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 20-RELATED', 248954),
(389273, 'PTHR19433:SF131', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 248954),
(389274, 'PTHR19433:SF76', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 5', 248954),
(389275, 'PTHR19433:SF132', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 26-1', 248954),
(389276, 'PTHR19433:SF111', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 4', 248954),
(389277, 'PTHR19433:SF133', NULL, NULL, NULL, NULL, 'IG DOMAIN-CONTAINING PROTEIN-RELATED', 248954),
(389278, 'PTHR19433:SF52', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 21', 248954),
(389279, 'PTHR19433:SF134', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 248954),
(389280, 'PTHR19433:SF117', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 13-2', 248954),
(389281, 'PTHR19433:SF119', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 35', 248954),
(389282, 'PTHR19433', NULL, NULL, NULL, NULL, 'T-CELL RECEPTOR ALPHA CHAIN V REGION-RELATED', 248954),
(389283, 'PTHR19433:SF83', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 36/DELTA VARIABLE 7', 248954),
(389284, 'PTHR19433:SF103', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 10', 248954),
(389285, 'PTHR19433:SF84', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 34', 248954),
(389286, 'PTHR19433:SF127', NULL, NULL, NULL, NULL, 'NOVEL IMMUNE-TYPE RECEPTOR 3A-RELATED', 248954),
(389287, 'PTHR19433:SF105', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 1-1-RELATED', 248954),
(389288, 'PTHR19433:SF120', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 30', 248954),
(389289, 'PTHR19433:SF121', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 6', 248954),
(389290, 'PTHR19433:SF85', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 17', 248954),
(389291, 'PTHR19433:SF123', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 24', 248954),
(389292, 'PTHR19433:SF86', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 26-2', 248954),
(389293, 'PTHR19433:SF64', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 13-1', 248954),
(389294, 'PTHR19433:SF128', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 248954),
(389295, 'PTHR19433:SF80', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 25', 248954),
(389296, 'PTHR19433:SF129', NULL, NULL, NULL, NULL, 'IGV DOMAIN-CONTAINING PROTEIN-RELATED', 248954),
(389297, 'PTHR33832:SF6', NULL, NULL, NULL, NULL, 'PROTEINASE INHIBITOR TYPE-2', 248955),
(389298, 'PTHR33832:SF9', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 248955),
(389299, 'PTHR33832:SF20', NULL, NULL, NULL, NULL, 'WOUND-INDUCED PROTEINASE INHIBITOR 2', 248955),
(389300, 'PTHR33832:SF10', NULL, NULL, NULL, NULL, 'PROTEINASE INHIBITOR TYPE-2 P303.51-LIKE', 248955),
(389301, 'PTHR33832:SF21', NULL, NULL, NULL, NULL, 'TRYPSIN PROTEINASE INHIBITOR', 248955),
(389302, 'PTHR33832', NULL, NULL, NULL, NULL, 'SERINE-TYPE ENDOPEPTIDASE INHIBITOR', 248955),
(389303, 'PTHR33832:SF13', NULL, NULL, NULL, NULL, 'OS03G0733900 PROTEIN', 248955),
(389304, 'PTHR33832:SF24', NULL, NULL, NULL, NULL, 'PROTEINASE INHIBITOR TYPE-2', 248955),
(389305, 'PTHR33832:SF25', NULL, NULL, NULL, NULL, 'OS03G0734300 PROTEIN', 248955);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(389306, 'PTHR33832:SF12', NULL, NULL, NULL, NULL, '', 248955),
(389307, 'PTHR33832:SF23', NULL, NULL, NULL, NULL, 'PROTEINASE INHIBITOR TYPE-2 P303.51', 248955),
(389308, 'PTHR33832:SF17', NULL, NULL, NULL, NULL, 'PROTEINASE INHIBITOR TYPE-2 CEVI57', 248955),
(389309, 'PTHR33832:SF15', NULL, NULL, NULL, NULL, 'SERINE-TYPE ENDOPEPTIDASE INHIBITOR', 248955),
(389310, 'PTHR33832:SF26', NULL, NULL, NULL, NULL, 'PROTEINASE INHIBITOR TYPE-2 TR8', 248955),
(389311, 'PTHR33832:SF16', NULL, NULL, NULL, NULL, 'PROTEINASE INHIBITOR PSI-1.2-LIKE', 248955),
(389312, 'PTHR37223', NULL, NULL, NULL, NULL, 'OS08G0528601 PROTEIN', 248956),
(389313, 'PTHR37223:SF1', NULL, NULL, NULL, NULL, 'OS08G0528601 PROTEIN', 248956),
(389314, 'PTHR40112:SF1', NULL, NULL, NULL, NULL, 'H2HPP ISOMERASE', 248957),
(389315, 'PTHR40112', NULL, NULL, NULL, NULL, 'H2HPP ISOMERASE', 248957),
(389316, 'PTHR31368', NULL, NULL, NULL, NULL, 'DEVELOPMENT PLURPOTENCY-ASSOCIATED PROTEIN 1/5 FAMILY MEMBER', 248958),
(389317, 'PTHR31368:SF4', NULL, NULL, NULL, NULL, 'DEVELOPMENTAL PLURIPOTENCY-ASSOCIATED 5 PROTEIN', 248958),
(389318, 'PTHR31368:SF5', NULL, NULL, NULL, NULL, 'KHDC1-LIKE PROTEIN-RELATED', 248958),
(389319, 'PTHR31368:SF6', NULL, NULL, NULL, NULL, 'KH HOMOLOGY DOMAIN-CONTAINING PROTEIN 1', 248958),
(389320, 'PTHR31368:SF7', NULL, NULL, NULL, NULL, 'MOEP19 DOMAIN-CONTAINING PROTEIN', 248958),
(389321, 'PTHR15573', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 160-RELATED', 248959),
(389322, 'PTHR15573:SF0', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 160-RELATED', 248959),
(389323, 'PTHR16471:SF0', NULL, NULL, NULL, NULL, 'CMT1A DUPLICATED REGION TRANSCRIPT 15 PROTEIN-LIKE PROTEIN', 248960),
(389324, 'PTHR16471', NULL, NULL, NULL, NULL, 'CMT1A DUPLICATED REGION TRANSCRIPT 15 PROTEIN-LIKE PROTEIN', 248960),
(389325, 'PTHR16471:SF4', NULL, NULL, NULL, NULL, '', 248960),
(389326, 'PTHR16471:SF5', NULL, NULL, NULL, NULL, '', 248960),
(389327, 'PTHR16471:SF2', NULL, NULL, NULL, NULL, '', 248960),
(389328, 'PTHR16471:SF3', NULL, NULL, NULL, NULL, 'CMT1A DUPLICATED REGION TRANSCRIPT 15 PROTEIN', 248960),
(389329, 'PTHR34990', NULL, NULL, NULL, NULL, 'UDP-2,3-DIACYLGLUCOSAMINE HYDROLASE-RELATED', 248961),
(389330, 'PTHR34990:SF2', NULL, NULL, NULL, NULL, 'BLL8164 PROTEIN', 248961),
(389331, 'PTHR34990:SF1', NULL, NULL, NULL, NULL, 'UDP-2,3-DIACYLGLUCOSAMINE HYDROLASE', 248961),
(389332, 'PTHR45850:SF6', NULL, NULL, NULL, NULL, 'PX DOMAIN-CONTAINING PROTEIN', 248962),
(389333, 'PTHR45850:SF5', NULL, NULL, NULL, NULL, 'SORTING NEXIN-5', 248962),
(389334, 'PTHR45850:SF4', NULL, NULL, NULL, NULL, 'SORTING NEXIN-6', 248962),
(389335, 'PTHR45850', NULL, NULL, NULL, NULL, 'SORTING NEXIN FAMILY MEMBER', 248962),
(389336, 'PTHR45850:SF3', NULL, NULL, NULL, NULL, 'SORTING NEXIN-32', 248962),
(389337, 'PTHR45850:SF2', NULL, NULL, NULL, NULL, 'SI:DKEY-28N18.9', 248962),
(389338, 'PTHR45850:SF1', NULL, NULL, NULL, NULL, 'SORTING NEXIN 6, ISOFORM B', 248962),
(389339, 'PTHR33443:SF33', NULL, NULL, NULL, NULL, 'OS10G0573300 PROTEIN', 248963),
(389340, 'PTHR33443:SF34', NULL, NULL, NULL, NULL, 'BNAA07G00190D PROTEIN', 248963),
(389341, 'PTHR33443:SF12', NULL, NULL, NULL, NULL, '', 248963),
(389342, 'PTHR33443:SF13', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 248963),
(389343, 'PTHR33443:SF35', NULL, NULL, NULL, NULL, 'OS03G0140900 PROTEIN', 248963),
(389344, 'PTHR33443:SF24', NULL, NULL, NULL, NULL, 'OS10G0573200 PROTEIN', 248963),
(389345, 'PTHR33443:SF25', NULL, NULL, NULL, NULL, '', 248963),
(389346, 'PTHR33443:SF15', NULL, NULL, NULL, NULL, 'BNAA03G12100D PROTEIN', 248963),
(389347, 'PTHR33443:SF27', NULL, NULL, NULL, NULL, 'BNAC01G09780D PROTEIN', 248963),
(389348, 'PTHR33443:SF30', NULL, NULL, NULL, NULL, 'ZGC:112980', 248963),
(389349, 'PTHR33443:SF20', NULL, NULL, NULL, NULL, 'BNAA09G10200D PROTEIN', 248963),
(389350, 'PTHR33443:SF31', NULL, NULL, NULL, NULL, '', 248963),
(389351, 'PTHR33443:SF32', NULL, NULL, NULL, NULL, 'BNAA03G48760D PROTEIN', 248963),
(389352, 'PTHR33443:SF19', NULL, NULL, NULL, NULL, 'BNAANNG13750D PROTEIN', 248963);
INSERT INTO "PUBLIC"."MODEL" VALUES
(389353, 'PTHR33443', NULL, NULL, NULL, NULL, 'ZGC:112980', 248963),
(389354, 'PTHR14516:SF9', NULL, NULL, NULL, NULL, 'INTERMEDIATE FILAMENT FAMILY ORPHAN 1A', 248964),
(389355, 'PTHR14516:SF8', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 1 MEMBER 2', 248964),
(389356, 'PTHR14516:SF6', NULL, NULL, NULL, NULL, 'MULTIFUNCTIONAL FUSION PROTEIN', 248964),
(389357, 'PTHR14516', NULL, NULL, NULL, NULL, '1-PYRROLINE-5-CARBOXYLATE DEHYDROGENASE FAMILY MEMBER', 248964),
(389358, 'PTHR14516:SF3', NULL, NULL, NULL, NULL, 'DELTA-1-PYRROLINE-5-CARBOXYLATE DEHYDROGENASE, MITOCHONDRIAL', 248964),
(389359, 'PTHR14516:SF2', NULL, NULL, NULL, NULL, 'NON-HOMOLOGOUS END JOINING FACTOR IFFO1', 248964),
(389360, 'PTHR14516:SF1', NULL, NULL, NULL, NULL, 'INTERMEDIATE FILAMENT FAMILY ORPHAN 2', 248964),
(389361, 'PTHR33327', NULL, NULL, NULL, NULL, 'ENDONUCLEASE', 248965),
(389362, 'PTHR33327:SF3', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 248965),
(389363, 'PTHR31131:SF12', NULL, NULL, NULL, NULL, '', 248966),
(389364, 'PTHR31131', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 248966),
(389365, 'PTHR31131:SF6', NULL, NULL, NULL, NULL, 'ACT_7 DOMAIN-CONTAINING PROTEIN', 248966),
(389366, 'PTHR31131:SF3', NULL, NULL, NULL, NULL, 'CYTOSOLIC ARGININE SENSOR FOR MTORC1 SUBUNIT 1', 248966),
(389367, 'PTHR31131:SF2', NULL, NULL, NULL, NULL, 'CYTOSOLIC ARGININE SENSOR FOR MTORC1 SUBUNIT 2-RELATED', 248966),
(389368, 'PTHR21166:SF2', NULL, NULL, NULL, NULL, 'MEIOSIS-SPECIFIC WITH OB DOMAIN-CONTAINING PROTEIN', 248967),
(389369, 'PTHR21166', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248967),
(389370, 'PTHR47478:SF1', NULL, NULL, NULL, NULL, 'PYRIMIDINE 5''-NUCLEOTIDASE YJJG', 248968),
(389371, 'PTHR47478', NULL, NULL, NULL, NULL, '', 248968),
(389372, 'PTHR31577', NULL, NULL, NULL, NULL, 'DEVELOPMENTAL PLURIPOTENCY-ASSOCIATED PROTEIN 3-RELATED', 248969),
(389373, 'PTHR31577:SF3', NULL, NULL, NULL, NULL, 'PROTEIN FAM156A/FAM156B', 248969),
(389374, 'PTHR31577:SF2', NULL, NULL, NULL, NULL, 'DEVELOPMENTAL PLURIPOTENCY-ASSOCIATED PROTEIN 3', 248969),
(389375, 'PTHR46289:SF2', NULL, NULL, NULL, NULL, 'SI:DKEY-250D21.1', 248970),
(389376, 'PTHR46289:SF12', NULL, NULL, NULL, NULL, '52 KDA REPRESSOR OF THE INHIBITOR OF THE PROTEIN KINASE', 248970),
(389377, 'PTHR46289', NULL, NULL, NULL, NULL, '52 KDA REPRESSOR OF THE INHIBITOR OF THE PROTEIN KINASE-LIKE PROTEIN-RELATED', 248970),
(389378, 'PTHR46289:SF5', NULL, NULL, NULL, NULL, 'THAP-TYPE DOMAIN-CONTAINING PROTEIN', 248970),
(389379, 'PTHR46289:SF15', NULL, NULL, NULL, NULL, 'DUF4371 DOMAIN-CONTAINING PROTEIN', 248970),
(389380, 'PTHR46289:SF14', NULL, NULL, NULL, NULL, '52 KDA REPRESSOR OF THE INHIBITOR OF THE PROTEIN KINASE', 248970),
(389381, 'PTHR46289:SF13', NULL, NULL, NULL, NULL, 'THAP DOMAIN-CONTAINING 12A-RELATED', 248970),
(389382, 'PTHR30224:SF4', NULL, NULL, NULL, NULL, 'ELECTRON TRANSPORT PROTEIN YCCM-RELATED', 248971),
(389383, 'PTHR30224', NULL, NULL, NULL, NULL, 'ELECTRON TRANSPORT PROTEIN', 248971),
(389384, 'PTHR10814:SF33', NULL, NULL, NULL, NULL, 'SI:CH211-81I17.1', 248972),
(389385, 'PTHR10814:SF32', NULL, NULL, NULL, NULL, 'TLE FAMILY MEMBER 2, TRANSCRIPTIONAL COREPRESSOR B-RELATED', 248972),
(389386, 'PTHR10814:SF21', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR UNC-37', 248972),
(389387, 'PTHR10814', NULL, NULL, NULL, NULL, 'TRANSDUCIN-LIKE ENHANCER PROTEIN', 248972),
(389388, 'PTHR10814:SF31', NULL, NULL, NULL, NULL, 'TRANSDUCIN-LIKE ENHANCER PROTEIN 4', 248972),
(389389, 'PTHR10814:SF19', NULL, NULL, NULL, NULL, 'TRANSDUCIN-LIKE ENHANCER PROTEIN 7', 248972),
(389390, 'PTHR10814:SF29', NULL, NULL, NULL, NULL, 'TRANSDUCIN-LIKE ENHANCER PROTEIN 1', 248972),
(389391, 'PTHR10814:SF2', NULL, NULL, NULL, NULL, 'TRANSDUCIN-LIKE ENHANCER PROTEIN 6', 248972),
(389392, 'PTHR10814:SF4', NULL, NULL, NULL, NULL, 'TRANSDUCIN-LIKE ENHANCER PROTEIN 2', 248972),
(389393, 'PTHR10814:SF24', NULL, NULL, NULL, NULL, 'TRANSDUCIN-LIKE ENHANCER PROTEIN 3', 248972),
(389394, 'PTHR10814:SF35', NULL, NULL, NULL, NULL, 'PROTEIN GROUCHO', 248972);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(389395, 'PTHR10814:SF34', NULL, NULL, NULL, NULL, 'TLE FAMILY MEMBER 1, TRANSCRIPTIONAL COREPRESSOR', 248972),
(389396, 'PTHR16216:SF10', NULL, NULL, NULL, NULL, '', 248973),
(389397, 'PTHR16216', NULL, NULL, NULL, NULL, 'DYNEIN ASSEMBLY FACTOR 5, AXONEMAL', 248973),
(389398, 'PTHR16216:SF2', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL ASSEMBLY FACTOR 5', 248973),
(389399, 'PTHR48045:SF8', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 248974),
(389400, 'PTHR48045:SF10', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 248974),
(389401, 'PTHR48045:SF20', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 91A1-LIKE', 248974),
(389402, 'PTHR48045:SF6', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 248974),
(389403, 'PTHR48045:SF12', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 248974),
(389404, 'PTHR48045:SF11', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 72B1', 248974),
(389405, 'PTHR48045:SF1', NULL, NULL, NULL, NULL, 'UDPGT DOMAIN-CONTAINING PROTEIN', 248974),
(389406, 'PTHR48045:SF4', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 248974),
(389407, 'PTHR48045:SF5', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 72B2-RELATED', 248974),
(389408, 'PTHR48045:SF2', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 248974),
(389409, 'PTHR48045:SF3', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 248974),
(389410, 'PTHR48045', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 72B1', 248974),
(389411, 'PTHR48045:SF18', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 248974),
(389412, 'PTHR48045:SF17', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 248974),
(389413, 'PTHR48045:SF19', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 248974),
(389414, 'PTHR48045:SF15', NULL, NULL, NULL, NULL, 'UDPGT DOMAIN-CONTAINING PROTEIN', 248974),
(389415, 'PTHR11709:SF71', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389416, 'PTHR11709:SF419', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389417, 'PTHR11709:SF418', NULL, NULL, NULL, NULL, 'CUPREDOXIN-RELATED', 248975),
(389418, 'PTHR11709:SF387', NULL, NULL, NULL, NULL, 'OS04G0561900 PROTEIN', 248975),
(389419, 'PTHR11709:SF266', NULL, NULL, NULL, NULL, 'LACCASE-4', 248975),
(389420, 'PTHR11709:SF145', NULL, NULL, NULL, NULL, 'LCC1', 248975),
(389421, 'PTHR11709:SF384', NULL, NULL, NULL, NULL, 'BNAC07G16450D PROTEIN', 248975),
(389422, 'PTHR11709:SF263', NULL, NULL, NULL, NULL, 'L-ASCORBATE OXIDASE HOMOLOG', 248975),
(389423, 'PTHR11709:SF262', NULL, NULL, NULL, NULL, 'LACCASE-14', 248975),
(389424, 'PTHR11709:SF383', NULL, NULL, NULL, NULL, 'LACCASE-12', 248975),
(389425, 'PTHR11709:SF261', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389426, 'PTHR11709:SF260', NULL, NULL, NULL, NULL, 'OS08G0154250 PROTEIN', 248975),
(389427, 'PTHR11709:SF381', NULL, NULL, NULL, NULL, 'BNACNNG43000D PROTEIN', 248975),
(389428, 'PTHR11709:SF428', NULL, NULL, NULL, NULL, 'L-ASCORBATE OXIDASE HOMOLOG', 248975),
(389429, 'PTHR11709:SF307', NULL, NULL, NULL, NULL, 'L-ASCORBATE OXIDASE PECTINESTERASE-LIKE PROTEIN POLLEN-SPECIFIC PROTEIN-LIKE', 248975),
(389430, 'PTHR11709:SF306', NULL, NULL, NULL, NULL, 'L-ASCORBATE OXIDASE HOMOLOG', 248975),
(389431, 'PTHR11709:SF305', NULL, NULL, NULL, NULL, 'L-ASCORBATE OXIDASE HOMOLOG', 248975),
(389432, 'PTHR11709:SF425', NULL, NULL, NULL, NULL, 'COPPER-RESISTANCE PROTEIN COPA-RELATED', 248975),
(389433, 'PTHR11709:SF424', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389434, 'PTHR11709:SF302', NULL, NULL, NULL, NULL, 'L-ASCORBATE OXIDASE', 248975),
(389435, 'PTHR11709:SF267', NULL, NULL, NULL, NULL, 'MULTI-COPPER OXIDASE TYPE I FAMILY PROTEIN-RELATED', 248975),
(389436, 'PTHR11709:SF309', NULL, NULL, NULL, NULL, 'L-ASCORBATE OXIDASE HOMOLOG', 248975),
(389437, 'PTHR11709:SF308', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389438, 'PTHR11709:SF86', NULL, NULL, NULL, NULL, 'LACCASE-18', 248975),
(389439, 'PTHR11709:SF87', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE TPCJ', 248975),
(389440, 'PTHR11709:SF431', NULL, NULL, NULL, NULL, 'LACCASE-5', 248975),
(389441, 'PTHR11709:SF310', NULL, NULL, NULL, NULL, 'L-ASCORBATE OXIDASE', 248975),
(389442, 'PTHR11709:SF398', NULL, NULL, NULL, NULL, 'LACCASE', 248975);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(389443, 'PTHR11709:SF276', NULL, NULL, NULL, NULL, 'LACCASE-5-RELATED', 248975),
(389444, 'PTHR11709:SF430', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389445, 'PTHR11709:SF397', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389446, 'PTHR11709:SF275', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389447, 'PTHR11709:SF2', NULL, NULL, NULL, NULL, 'MULTICOPPER OXIDASE LPR1', 248975),
(389448, 'PTHR11709:SF395', NULL, NULL, NULL, NULL, 'BNAA02G11730D PROTEIN', 248975),
(389449, 'PTHR11709:SF394', NULL, NULL, NULL, NULL, 'FI03373P-RELATED', 248975),
(389450, 'PTHR11709:SF393', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389451, 'PTHR11709:SF392', NULL, NULL, NULL, NULL, 'L-ASCORBATE OXIDASE', 248975),
(389452, 'PTHR11709:SF270', NULL, NULL, NULL, NULL, 'MONOCOPPER OXIDASE-LIKE PROTEIN SKS1', 248975),
(389453, 'PTHR11709:SF318', NULL, NULL, NULL, NULL, 'MULTI-COPPER OXIDASE TYPE I FAMILY PROTEIN-RELATED', 248975),
(389454, 'PTHR11709:SF439', NULL, NULL, NULL, NULL, 'LACCASE-24', 248975),
(389455, 'PTHR11709:SF317', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389456, 'PTHR11709:SF437', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389457, 'PTHR11709:SF9', NULL, NULL, NULL, NULL, 'LACCASE-7', 248975),
(389458, 'PTHR11709:SF314', NULL, NULL, NULL, NULL, 'CERULOPLASMIN-LIKE', 248975),
(389459, 'PTHR11709:SF434', NULL, NULL, NULL, NULL, 'IRON TRANSPORT MULTICOPPER OXIDASE FET5', 248975),
(389460, 'PTHR11709:SF433', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389461, 'PTHR11709:SF312', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389462, 'PTHR11709:SF278', NULL, NULL, NULL, NULL, 'L-ASCORBATE OXIDASE', 248975),
(389463, 'PTHR11709:SF311', NULL, NULL, NULL, NULL, 'MULTI-COPPER OXIDASE-LIKE PROTEIN', 248975),
(389464, 'PTHR11709:SF432', NULL, NULL, NULL, NULL, 'MULTI-COPPER OXIDASE-LIKE PROTEIN', 248975),
(389465, 'PTHR11709:SF58', NULL, NULL, NULL, NULL, 'SKU5 SIMILAR 3', 248975),
(389466, 'PTHR11709:SF486', NULL, NULL, NULL, NULL, 'MULTICOPPER OXIDASE', 248975),
(389467, 'PTHR11709:SF123', NULL, NULL, NULL, NULL, 'MONOCOPPER OXIDASE-LIKE PROTEIN SKU5', 248975),
(389468, 'PTHR11709:SF364', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389469, 'PTHR11709:SF485', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389470, 'PTHR11709:SF242', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389471, 'PTHR11709:SF484', NULL, NULL, NULL, NULL, 'LACCASE-RELATED', 248975),
(389472, 'PTHR11709:SF483', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389473, 'PTHR11709:SF361', NULL, NULL, NULL, NULL, 'IRON TRANSPORT MULTICOPPER OXIDASE FET3-RELATED', 248975),
(389474, 'PTHR11709:SF482', NULL, NULL, NULL, NULL, 'COPPER-CONTAINING NITRITE REDUCTASE', 248975),
(389475, 'PTHR11709:SF481', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389476, 'PTHR11709:SF480', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389477, 'PTHR11709:SF405', NULL, NULL, NULL, NULL, 'L-ASCORBATE OXIDASE HOMOLOG', 248975),
(389478, 'PTHR11709:SF403', NULL, NULL, NULL, NULL, 'BNAC05G39970D PROTEIN', 248975),
(389479, 'PTHR11709:SF369', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389480, 'PTHR11709:SF401', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389481, 'PTHR11709:SF489', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389482, 'PTHR11709:SF247', NULL, NULL, NULL, NULL, 'SKU5-SIMILAR 6', 248975),
(389483, 'PTHR11709:SF367', NULL, NULL, NULL, NULL, 'BNAC01G37690D PROTEIN', 248975),
(389484, 'PTHR11709:SF488', NULL, NULL, NULL, NULL, 'LACCASE-RELATED', 248975),
(389485, 'PTHR11709:SF246', NULL, NULL, NULL, NULL, 'L-ASCORBATE OXIDASE-LIKE PROTEIN', 248975),
(389486, 'PTHR11709:SF400', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389487, 'PTHR11709:SF487', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389488, 'PTHR11709:SF245', NULL, NULL, NULL, NULL, 'SKU5 SIMILAR 16', 248975),
(389489, 'PTHR11709:SF409', NULL, NULL, NULL, NULL, 'MONOCOPPER OXIDASE-LIKE PROTEIN SKU5', 248975),
(389490, 'PTHR11709:SF407', NULL, NULL, NULL, NULL, 'PLASTOCYANIN-LIKE DOMAIN-CONTAINING PROTEIN', 248975),
(389491, 'PTHR11709:SF67', NULL, NULL, NULL, NULL, 'LACCASE-11-RELATED', 248975);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(389492, 'PTHR11709:SF68', NULL, NULL, NULL, NULL, 'LACCASE-13', 248975),
(389493, 'PTHR11709:SF497', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389494, 'PTHR11709:SF255', NULL, NULL, NULL, NULL, 'BNAA06G00300D PROTEIN', 248975),
(389495, 'PTHR11709:SF375', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389496, 'PTHR11709:SF496', NULL, NULL, NULL, NULL, 'MULTICOPPER OXIDASE LPR2', 248975),
(389497, 'PTHR11709:SF253', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389498, 'PTHR11709:SF495', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389499, 'PTHR11709:SF494', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389500, 'PTHR11709:SF372', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389501, 'PTHR11709:SF493', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389502, 'PTHR11709:SF251', NULL, NULL, NULL, NULL, 'LACCASE-8-RELATED', 248975),
(389503, 'PTHR11709:SF492', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389504, 'PTHR11709:SF491', NULL, NULL, NULL, NULL, 'MULTI-COPPER OXIDASE-LIKE PROTEIN', 248975),
(389505, 'PTHR11709:SF370', NULL, NULL, NULL, NULL, 'LACCASE-4', 248975),
(389506, 'PTHR11709:SF490', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389507, 'PTHR11709:SF417', NULL, NULL, NULL, NULL, 'LACCASE-17', 248975),
(389508, 'PTHR11709:SF415', NULL, NULL, NULL, NULL, 'LACCASE-3', 248975),
(389509, 'PTHR11709:SF414', NULL, NULL, NULL, NULL, 'PLASTOCYANIN-LIKE DOMAIN-CONTAINING PROTEIN', 248975),
(389510, 'PTHR11709:SF379', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389511, 'PTHR11709:SF258', NULL, NULL, NULL, NULL, 'LACCASE-14-LIKE ISOFORM X1', 248975),
(389512, 'PTHR11709:SF412', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389513, 'PTHR11709:SF499', NULL, NULL, NULL, NULL, 'LACCASE-15', 248975),
(389514, 'PTHR11709:SF136', NULL, NULL, NULL, NULL, 'L-ASCORBATE OXIDASE', 248975),
(389515, 'PTHR11709:SF378', NULL, NULL, NULL, NULL, 'BNAC01G37680D PROTEIN', 248975),
(389516, 'PTHR11709:SF256', NULL, NULL, NULL, NULL, 'LACCASE-2', 248975),
(389517, 'PTHR11709:SF410', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389518, 'PTHR11709:SF498', NULL, NULL, NULL, NULL, 'MONOCOPPER OXIDASE-LIKE PROTEIN SKU5', 248975),
(389519, 'PTHR11709:SF343', NULL, NULL, NULL, NULL, 'LACCASE-15', 248975),
(389520, 'PTHR11709:SF101', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389521, 'PTHR11709:SF221', NULL, NULL, NULL, NULL, 'HEPHAESTIN', 248975),
(389522, 'PTHR11709:SF463', NULL, NULL, NULL, NULL, 'COAGULATION FACTOR 8-RELATED', 248975),
(389523, 'PTHR11709:SF462', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389524, 'PTHR11709:SF340', NULL, NULL, NULL, NULL, 'MULTICOPPER OXIDASE LPR1 HOMOLOG 1', 248975),
(389525, 'PTHR11709:SF27', NULL, NULL, NULL, NULL, 'OS01G0816700 PROTEIN', 248975),
(389526, 'PTHR11709:SF505', NULL, NULL, NULL, NULL, 'MONOCOPPER OXIDASE-LIKE PROTEIN SKS2', 248975),
(389527, 'PTHR11709:SF109', NULL, NULL, NULL, NULL, 'LACCASE-7', 248975),
(389528, 'PTHR11709:SF504', NULL, NULL, NULL, NULL, '', 248975),
(389529, 'PTHR11709:SF503', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389530, 'PTHR11709:SF349', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389531, 'PTHR11709:SF348', NULL, NULL, NULL, NULL, 'PS60 PROTEIN', 248975),
(389532, 'PTHR11709:SF469', NULL, NULL, NULL, NULL, 'L-ASCORBATE OXIDASE HOMOLOG', 248975),
(389533, 'PTHR11709:SF502', NULL, NULL, NULL, NULL, '', 248975),
(389534, 'PTHR11709:SF501', NULL, NULL, NULL, NULL, 'OS06G0104300 PROTEIN', 248975),
(389535, 'PTHR11709:SF226', NULL, NULL, NULL, NULL, 'CERULOPLASMIN', 248975),
(389536, 'PTHR11709:SF467', NULL, NULL, NULL, NULL, 'L-ASCORBATE OXIDASE-LIKE PROTEIN', 248975),
(389537, 'PTHR11709:SF500', NULL, NULL, NULL, NULL, 'L-ASCORBATE OXIDASE HOMOLOG', 248975),
(389538, 'PTHR11709:SF509', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389539, 'PTHR11709:SF508', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389540, 'PTHR11709:SF507', NULL, NULL, NULL, NULL, 'MONOCOPPER OXIDASE-LIKE PROTEIN SKU5', 248975),
(389541, 'PTHR11709:SF506', NULL, NULL, NULL, NULL, 'LACCASE-8', 248975),
(389542, 'PTHR11709', NULL, NULL, NULL, NULL, 'MULTI-COPPER OXIDASE', 248975);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(389543, 'PTHR11709:SF233', NULL, NULL, NULL, NULL, 'FERROXIDASE HEPHL1', 248975),
(389544, 'PTHR11709:SF475', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389545, 'PTHR11709:SF232', NULL, NULL, NULL, NULL, 'STRAW, ISOFORM G', 248975),
(389546, 'PTHR11709:SF474', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389547, 'PTHR11709:SF473', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389548, 'PTHR11709:SF352', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389549, 'PTHR11709:SF351', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389550, 'PTHR11709:SF472', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389551, 'PTHR11709:SF471', NULL, NULL, NULL, NULL, 'BNAA05G25900D PROTEIN', 248975),
(389552, 'PTHR11709:SF350', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN FTSP', 248975),
(389553, 'PTHR11709:SF470', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389554, 'PTHR11709:SF117', NULL, NULL, NULL, NULL, 'MULTICOPPER OXIDASE LPR1 HOMOLOG 4', 248975),
(389555, 'PTHR11709:SF479', NULL, NULL, NULL, NULL, 'LACCASE-12', 248975),
(389556, 'PTHR11709:SF237', NULL, NULL, NULL, NULL, 'L-ASCORBATE OXIDASE', 248975),
(389557, 'PTHR11709:SF116', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389558, 'PTHR11709:SF115', NULL, NULL, NULL, NULL, 'L-ASCORBATE OXIDASE HOMOLOG', 248975),
(389559, 'PTHR11709:SF478', NULL, NULL, NULL, NULL, 'OS05G0485800 PROTEIN', 248975),
(389560, 'PTHR11709:SF357', NULL, NULL, NULL, NULL, 'L-ASCORBATE OXIDASE HOMOLOG', 248975),
(389561, 'PTHR11709:SF510', NULL, NULL, NULL, NULL, 'L-ASCORBATE OXIDASE HOMOLOG', 248975),
(389562, 'PTHR11709:SF356', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389563, 'PTHR11709:SF477', NULL, NULL, NULL, NULL, 'MONOCOPPER OXIDASE-LIKE PROTEIN SKU5', 248975),
(389564, 'PTHR11709:SF476', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389565, 'PTHR11709:SF90', NULL, NULL, NULL, NULL, 'L-ASCORBATE OXIDASE HOMOLOG', 248975),
(389566, 'PTHR11709:SF319', NULL, NULL, NULL, NULL, 'LACCASE-16', 248975),
(389567, 'PTHR11709:SF91', NULL, NULL, NULL, NULL, 'L-ASCORBATE OXIDASE', 248975),
(389568, 'PTHR11709:SF11', NULL, NULL, NULL, NULL, 'L-ASCORBATE OXIDASE HOMOLOG', 248975),
(389569, 'PTHR11709:SF288', NULL, NULL, NULL, NULL, 'L-ASCORBATE OXIDASE HOMOLOG', 248975),
(389570, 'PTHR11709:SF287', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389571, 'PTHR11709:SF281', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389572, 'PTHR11709:SF329', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389573, 'PTHR11709:SF207', NULL, NULL, NULL, NULL, 'LACCASE-11', 248975),
(389574, 'PTHR11709:SF448', NULL, NULL, NULL, NULL, 'SKU5 SIMILAR 5-RELATED', 248975),
(389575, 'PTHR11709:SF447', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389576, 'PTHR11709:SF446', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389577, 'PTHR11709:SF445', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389578, 'PTHR11709:SF324', NULL, NULL, NULL, NULL, 'LACCASE-6', 248975),
(389579, 'PTHR11709:SF444', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389580, 'PTHR11709:SF289', NULL, NULL, NULL, NULL, 'LACCASE-10', 248975),
(389581, 'PTHR11709:SF443', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389582, 'PTHR11709:SF322', NULL, NULL, NULL, NULL, 'L-ASCORBATE OXIDASE', 248975),
(389583, 'PTHR11709:SF299', NULL, NULL, NULL, NULL, 'PECTINESTERASE LIKE PROTEIN', 248975),
(389584, 'PTHR11709:SF453', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389585, 'PTHR11709:SF452', NULL, NULL, NULL, NULL, 'LACCASE-2', 248975),
(389586, 'PTHR11709:SF331', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389587, 'PTHR11709:SF296', NULL, NULL, NULL, NULL, 'MULTI-COPPER OXIDASE TYPE I FAMILY PROTEIN', 248975),
(389588, 'PTHR11709:SF292', NULL, NULL, NULL, NULL, 'LACCASE-1', 248975),
(389589, 'PTHR11709:SF339', NULL, NULL, NULL, NULL, 'LACCASE-6', 248975),
(389590, 'PTHR11709:SF218', NULL, NULL, NULL, NULL, 'L-ASCORBATE OXIDASE', 248975),
(389591, 'PTHR11709:SF337', NULL, NULL, NULL, NULL, 'BNAA10G29650D PROTEIN', 248975),
(389592, 'PTHR11709:SF457', NULL, NULL, NULL, NULL, 'LACCASE-17-RELATED', 248975),
(389593, 'PTHR11709:SF336', NULL, NULL, NULL, NULL, 'LACCASE', 248975);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(389594, 'PTHR11709:SF456', NULL, NULL, NULL, NULL, 'LACCASE', 248975),
(389595, 'PTHR11709:SF213', NULL, NULL, NULL, NULL, 'OS06G0678800 PROTEIN', 248975),
(389596, 'PTHR11709:SF334', NULL, NULL, NULL, NULL, 'BNAC02G16540D PROTEIN', 248975),
(389597, 'PTHR11709:SF455', NULL, NULL, NULL, NULL, 'BNAC03G70650D PROTEIN', 248975),
(389598, 'PTHR11709:SF333', NULL, NULL, NULL, NULL, 'L-ASCORBATE OXIDASE', 248975),
(389599, 'PTHR21831:SF2', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN 10', 248976),
(389600, 'PTHR21831', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 248976),
(389601, 'PTHR10653:SF6', NULL, NULL, NULL, NULL, 'F-ACTIN-CAPPING PROTEIN SUBUNIT ALPHA-3', 248977),
(389602, 'PTHR10653:SF20', NULL, NULL, NULL, NULL, 'F-ACTIN-CAPPING PROTEIN SUBUNIT ALPHA', 248977),
(389603, 'PTHR10653:SF22', NULL, NULL, NULL, NULL, 'F-ACTIN-CAPPING PROTEIN SUBUNIT ALPHA-2', 248977),
(389604, 'PTHR10653:SF0', NULL, NULL, NULL, NULL, 'F-ACTIN-CAPPING PROTEIN SUBUNIT ALPHA', 248977),
(389605, 'PTHR10653', NULL, NULL, NULL, NULL, 'F-ACTIN-CAPPING PROTEIN SUBUNIT ALPHA', 248977),
(389606, 'PTHR10653:SF4', NULL, NULL, NULL, NULL, 'F-ACTIN-CAPPING PROTEIN SUBUNIT ALPHA', 248977),
(389607, 'PTHR10653:SF18', NULL, NULL, NULL, NULL, 'F-ACTIN-CAPPING PROTEIN SUBUNIT ALPHA', 248977),
(389608, 'PTHR10653:SF5', NULL, NULL, NULL, NULL, 'F-ACTIN-CAPPING PROTEIN SUBUNIT ALPHA-1', 248977),
(389609, 'PTHR10653:SF2', NULL, NULL, NULL, NULL, 'F-ACTIN-CAPPING PROTEIN SUBUNIT ALPHA-2', 248977),
(389610, 'PTHR10653:SF19', NULL, NULL, NULL, NULL, 'F-ACTIN-CAPPING PROTEIN SUBUNIT ALPHA', 248977),
(389611, 'PTHR46283', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MARCH5', 248978),
(389612, 'PTHR46283:SF4', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MARCHF5', 248978),
(389613, 'PTHR46283:SF2', NULL, NULL, NULL, NULL, 'AT07234P-RELATED', 248978),
(389614, 'PTHR46283:SF3', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MARCHF5', 248978),
(389615, 'PTHR35614', NULL, NULL, NULL, NULL, '', 248979),
(389616, 'PTHR35614:SF7', NULL, NULL, NULL, NULL, '', 248979),
(389617, 'PTHR35614:SF6', NULL, NULL, NULL, NULL, '', 248979),
(389618, 'PTHR35614:SF5', NULL, NULL, NULL, NULL, '', 248979),
(389619, 'PTHR15712:SF14', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING X-LINKED PROTEIN 1', 248980),
(389620, 'PTHR15712:SF23', NULL, NULL, NULL, NULL, 'ARM_2 DOMAIN-CONTAINING PROTEIN', 248980),
(389621, 'PTHR15712:SF6', NULL, NULL, NULL, NULL, 'PROTEIN ARMCX6', 248980),
(389622, 'PTHR15712:SF19', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING PROTEIN 10', 248980),
(389623, 'PTHR15712', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT CONTAINING PROTEIN', 248980),
(389624, 'PTHR15712:SF8', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING X-LINKED PROTEIN 3', 248980),
(389625, 'PTHR15712:SF9', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING X-LINKED PROTEIN 2', 248980),
(389626, 'PTHR22781:SF13', NULL, NULL, NULL, NULL, 'AP-3 COMPLEX SUBUNIT DELTA', 248981),
(389627, 'PTHR22781:SF12', NULL, NULL, NULL, NULL, 'AP-3 COMPLEX SUBUNIT DELTA-1', 248981),
(389628, 'PTHR22781', NULL, NULL, NULL, NULL, 'DELTA ADAPTIN-RELATED', 248981),
(389629, 'PTHR30492:SF0', NULL, NULL, NULL, NULL, 'METHYLGLYOXAL SYNTHASE', 248982),
(389630, 'PTHR30492', NULL, NULL, NULL, NULL, 'METHYLGLYOXAL SYNTHASE', 248982),
(389631, 'PTHR14605', NULL, NULL, NULL, NULL, 'CHST5 PROTEIN', 248983),
(389632, 'PTHR14605:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 231', 248983),
(389633, 'PTHR39290', NULL, NULL, NULL, NULL, 'C3H1-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', 248984),
(389634, 'PTHR39290:SF7', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 248984),
(389635, 'PTHR39290:SF6', NULL, NULL, NULL, NULL, '', 248984),
(389636, 'PTHR39290:SF1', NULL, NULL, NULL, NULL, 'C3H1-TYPE DOMAIN-CONTAINING PROTEIN', 248984),
(389637, 'PTHR42684', NULL, NULL, NULL, NULL, 'ADENOSYLMETHIONINE-8-AMINO-7-OXONONANOATE AMINOTRANSFERASE', 248985),
(389638, 'PTHR42684:SF3', NULL, NULL, NULL, NULL, 'ADENOSYLMETHIONINE-8-AMINO-7-OXONONANOATE AMINOTRANSFERASE', 248985);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(389639, 'PTHR42684:SF1', NULL, NULL, NULL, NULL, 'BETA-ALANINE--PYRUVATE AMINOTRANSFERASE', 248985),
(389640, 'PTHR42684:SF18', NULL, NULL, NULL, NULL, 'GAMMA AMINOBUTYRATE TRANSAMINASE 3 PROTEIN-RELATED', 248985),
(389641, 'PTHR42684:SF19', NULL, NULL, NULL, NULL, 'GAMMA AMINOBUTYRATE TRANSAMINASE 3, CHLOROPLASTIC', 248985),
(389642, 'PTHR42684:SF17', NULL, NULL, NULL, NULL, 'ADENOSYLMETHIONINE-8-AMINO-7-OXONONANOATE AMINOTRANSFERASE', 248985),
(389643, 'PTHR42684:SF14', NULL, NULL, NULL, NULL, 'BNAA05G17400D PROTEIN', 248985),
(389644, 'PTHR42684:SF15', NULL, NULL, NULL, NULL, 'BNAC06G05970D PROTEIN', 248985),
(389645, 'PTHR42684:SF12', NULL, NULL, NULL, NULL, 'EIF3_N DOMAIN-CONTAINING PROTEIN', 248985),
(389646, 'PTHR42684:SF13', NULL, NULL, NULL, NULL, 'BNAA01G24820D PROTEIN', 248985),
(389647, 'PTHR42684:SF10', NULL, NULL, NULL, NULL, 'GAMMA AMINOBUTYRATE TRANSAMINASE 2', 248985),
(389648, 'PTHR42684:SF20', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRATE TRANSAMINASE 1, MITOCHONDRIAL', 248985),
(389649, 'PTHR42684:SF8', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRATE TRANSAMINASE 4-RELATED', 248985),
(389650, 'PTHR12400:SF102', NULL, NULL, NULL, NULL, 'KINASE', 248986),
(389651, 'PTHR12400:SF101', NULL, NULL, NULL, NULL, 'INOSITOL POLYPHOSPHATE MULTIKINASE ALPHA', 248986),
(389652, 'PTHR12400:SF100', NULL, NULL, NULL, NULL, 'INOSITOL HEXAKISPHOSPHATE KINASE 1', 248986),
(389653, 'PTHR12400:SF47', NULL, NULL, NULL, NULL, 'INOSITOL HEXAKISPHOSPHATE KINASE 2', 248986),
(389654, 'PTHR12400:SF89', NULL, NULL, NULL, NULL, 'INOSITOL POLYPHOSPHATE MULTIKINASE', 248986),
(389655, 'PTHR12400:SF26', NULL, NULL, NULL, NULL, 'INOSITOL-TRISPHOSPHATE 3-KINASE C', 248986),
(389656, 'PTHR12400:SF82', NULL, NULL, NULL, NULL, 'INOSITOL POLYPHOSPHATE MULTIKINASE', 248986),
(389657, 'PTHR12400', NULL, NULL, NULL, NULL, 'INOSITOL POLYPHOSPHATE KINASE', 248986),
(389658, 'PTHR12400:SF83', NULL, NULL, NULL, NULL, 'KINASE', 248986),
(389659, 'PTHR12400:SF80', NULL, NULL, NULL, NULL, 'INOSITOL POLYPHOSPHATE MULTIKINASE', 248986),
(389660, 'PTHR12400:SF81', NULL, NULL, NULL, NULL, 'KINASE', 248986),
(389661, 'PTHR12400:SF21', NULL, NULL, NULL, NULL, 'KINASE', 248986),
(389662, 'PTHR12400:SF40', NULL, NULL, NULL, NULL, 'INOSITOL HEXAKISPHOSPHATE KINASE 3', 248986),
(389663, 'PTHR12400:SF41', NULL, NULL, NULL, NULL, 'KINASE', 248986),
(389664, 'PTHR12400:SF55', NULL, NULL, NULL, NULL, 'INOSITOL-TRISPHOSPHATE 3-KINASE A', 248986),
(389665, 'PTHR12400:SF77', NULL, NULL, NULL, NULL, 'KINASE', 248986),
(389666, 'PTHR12400:SF99', NULL, NULL, NULL, NULL, 'KINASE', 248986),
(389667, 'PTHR12400:SF78', NULL, NULL, NULL, NULL, 'KINASE', 248986),
(389668, 'PTHR12400:SF93', NULL, NULL, NULL, NULL, 'INOSITOL POLYPHOSPHATE MULTIKINASE', 248986),
(389669, 'PTHR12400:SF4', NULL, NULL, NULL, NULL, 'INOSITOL-TRISPHOSPHATE 3-KINASE B', 248986),
(389670, 'PTHR12400:SF97', NULL, NULL, NULL, NULL, 'KINASE', 248986),
(389671, 'PTHR12400:SF98', NULL, NULL, NULL, NULL, 'KINASE', 248986),
(389672, 'PTHR12400:SF51', NULL, NULL, NULL, NULL, 'INOSITOL POLYPHOSPHATE MULTIKINASE', 248986),
(389673, 'PTHR12400:SF73', NULL, NULL, NULL, NULL, 'INOSITOL HEXAKISPHOSPHATE KINASE 1', 248986),
(389674, 'PTHR12400:SF74', NULL, NULL, NULL, NULL, 'KINASE', 248986),
(389675, 'PTHR24052:SF11', NULL, NULL, NULL, NULL, 'PROTEIN DELTA HOMOLOG 1', 248987),
(389676, 'PTHR24052', NULL, NULL, NULL, NULL, 'DELTA-RELATED', 248987),
(389677, 'PTHR24052:SF12', NULL, NULL, NULL, NULL, 'PLATELET ENDOTHELIAL AGGREGATION RECEPTOR 1', 248987),
(389678, 'PTHR24052:SF8', NULL, NULL, NULL, NULL, 'NIMROD A, ISOFORM E', 248987),
(389679, 'PTHR12757:SF5', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR ALPHA-INDUCED PROTEIN 8-LIKE PROTEIN 3', 248988),
(389680, 'PTHR12757:SF4', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR ALPHA-INDUCED PROTEIN 8-LIKE PROTEIN 2', 248988),
(389681, 'PTHR12757:SF3', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR ALPHA-INDUCED PROTEIN 8', 248988),
(389682, 'PTHR12757', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR INDUCED PROTEIN', 248988),
(389683, 'PTHR12757:SF2', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR ALPHA-INDUCED PROTEIN 8-LIKE PROTEIN 1', 248988);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(389684, 'PTHR12757:SF1', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR ALPHA-INDUCED PROTEIN 8-LIKE PROTEIN', 248988),
(389685, 'PTHR10029:SF3', NULL, NULL, NULL, NULL, 'ACYLPHOSPHATASE-RELATED', 248989),
(389686, 'PTHR10029:SF20', NULL, NULL, NULL, NULL, 'ACYLPHOSPHATASE-2', 248989),
(389687, 'PTHR10029:SF10', NULL, NULL, NULL, NULL, 'GEO08407P1', 248989),
(389688, 'PTHR10029', NULL, NULL, NULL, NULL, 'ACYLPHOSPHATASE', 248989),
(389689, 'PTHR10029:SF21', NULL, NULL, NULL, NULL, 'ACYLPHOSPHATASE-1', 248989),
(389690, 'PTHR10029:SF22', NULL, NULL, NULL, NULL, 'ACYLPHOSPHATASE', 248989),
(389691, 'PTHR35372', NULL, NULL, NULL, NULL, 'ATP BINDING PROTEIN-RELATED', 248990),
(389692, 'PTHR35372:SF2', NULL, NULL, NULL, NULL, 'SF3 HELICASE DOMAIN-CONTAINING PROTEIN', 248990),
(389693, 'PTHR35372:SF3', NULL, NULL, NULL, NULL, 'SF3 HELICASE DOMAIN-CONTAINING PROTEIN', 248990),
(389694, 'PTHR43466:SF1', NULL, NULL, NULL, NULL, '2-OXO-4-HYDROXY-4-CARBOXY-5-UREIDOIMIDAZOLINE DECARBOXYLASE-RELATED', 248991),
(389695, 'PTHR43466', NULL, NULL, NULL, NULL, '2-OXO-4-HYDROXY-4-CARBOXY-5-UREIDOIMIDAZOLINE DECARBOXYLASE-RELATED', 248991),
(389696, 'PTHR13403:SF6', NULL, NULL, NULL, NULL, 'SNURPORTIN-1', 248992),
(389697, 'PTHR13403', NULL, NULL, NULL, NULL, 'SNURPORTIN1  RNUT1 PROTEIN   RNA, U TRANSPORTER 1', 248992),
(389698, 'PTHR21262:SF32', NULL, NULL, NULL, NULL, 'GTP DIPHOSPHOKINASE', 248993),
(389699, 'PTHR21262:SF31', NULL, NULL, NULL, NULL, 'GTP PYROPHOSPHOKINASE', 248993),
(389700, 'PTHR21262:SF0', NULL, NULL, NULL, NULL, 'GTP DIPHOSPHOKINASE RSH3, CHLOROPLASTIC-RELATED', 248993),
(389701, 'PTHR21262:SF36', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL (P)PPGPP SYNTHASE/HYDROLASE SPOT', 248993),
(389702, 'PTHR21262:SF34', NULL, NULL, NULL, NULL, 'GTP DIPHOSPHOKINASE RSH2, CHLOROPLASTIC-RELATED', 248993),
(389703, 'PTHR21262:SF12', NULL, NULL, NULL, NULL, 'GTP DIPHOSPHOKINASE CRSH, CHLOROPLASTIC-RELATED', 248993),
(389704, 'PTHR21262:SF33', NULL, NULL, NULL, NULL, 'GTP DIPHOSPHOKINASE RSH2, CHLOROPLASTIC-RELATED', 248993),
(389705, 'PTHR21262:SF39', NULL, NULL, NULL, NULL, 'GTP DIPHOSPHOKINASE', 248993),
(389706, 'PTHR21262', NULL, NULL, NULL, NULL, 'GUANOSINE-3'',5''-BIS DIPHOSPHATE  3''-PYROPHOSPHOHYDROLASE', 248993),
(389707, 'PTHR21262:SF38', NULL, NULL, NULL, NULL, 'GTP DIPHOSPHOKINASE', 248993),
(389708, 'PTHR21262:SF37', NULL, NULL, NULL, NULL, 'GTP DIPHOSPHOKINASE', 248993),
(389709, 'PTHR42820:SF15', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE REDUCTASE 3A-RELATED', 248994),
(389710, 'PTHR42820:SF24', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 248994),
(389711, 'PTHR42820:SF13', NULL, NULL, NULL, NULL, '(-)-ISOPIPERITENOL/(-)-CARVEOL DEHYDROGENASE, MITOCHONDRIAL-LIKE', 248994),
(389712, 'PTHR42820:SF23', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE', 248994),
(389713, 'PTHR42820:SF12', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE REDUCTASE 3C', 248994),
(389714, 'PTHR42820:SF11', NULL, NULL, NULL, NULL, 'XANTHOXIN DEHYDROGENASE-LIKE', 248994),
(389715, 'PTHR42820:SF10', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE REDUCTASE 3B-LIKE', 248994),
(389716, 'PTHR42820:SF21', NULL, NULL, NULL, NULL, 'OS03G0833100 PROTEIN', 248994),
(389717, 'PTHR42820:SF20', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE REDUCTASE 3B-LIKE', 248994),
(389718, 'PTHR42820:SF1', NULL, NULL, NULL, NULL, 'XANTHOXIN DEHYDROGENASE', 248994),
(389719, 'PTHR42820:SF19', NULL, NULL, NULL, NULL, 'BNAA09G45350D PROTEIN', 248994),
(389720, 'PTHR42820:SF18', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', 248994),
(389721, 'PTHR42820', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE REDUCTASE', 248994),
(389722, 'PTHR42820:SF17', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE-RELATED', 248994),
(389723, 'PTHR42820:SF16', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE REDUCTASE 3B', 248994),
(389724, 'PTHR42820:SF9', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE-RELATED', 248994),
(389725, 'PTHR42820:SF4', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE', 248994),
(389726, 'PTHR42820:SF5', NULL, NULL, NULL, NULL, '', 248994);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(389727, 'PTHR22595:SF118', NULL, NULL, NULL, NULL, 'CHITINASE', 248995),
(389728, 'PTHR22595:SF119', NULL, NULL, NULL, NULL, 'ENDOCHITINASE EP3-LIKE', 248995),
(389729, 'PTHR22595:SF117', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_19_CAT DOMAIN-CONTAINING PROTEIN', 248995),
(389730, 'PTHR22595:SF114', NULL, NULL, NULL, NULL, 'CHITINASE 5', 248995),
(389731, 'PTHR22595:SF159', NULL, NULL, NULL, NULL, 'ACIDIC 26 KDA ENDOCHITINASE', 248995),
(389732, 'PTHR22595:SF156', NULL, NULL, NULL, NULL, 'CHITIN-BINDING TYPE-1 DOMAIN-CONTAINING PROTEIN', 248995),
(389733, 'PTHR22595:SF157', NULL, NULL, NULL, NULL, 'CHITIN-BINDING TYPE-1 DOMAIN-CONTAINING PROTEIN', 248995),
(389734, 'PTHR22595:SF154', NULL, NULL, NULL, NULL, 'CHITIN-BINDING TYPE-1 DOMAIN-CONTAINING PROTEIN', 248995),
(389735, 'PTHR22595:SF111', NULL, NULL, NULL, NULL, 'CHITINASE FAMILY PROTEIN', 248995),
(389736, 'PTHR22595:SF155', NULL, NULL, NULL, NULL, 'CHITIN-BINDING TYPE-1 DOMAIN-CONTAINING PROTEIN', 248995),
(389737, 'PTHR22595:SF152', NULL, NULL, NULL, NULL, 'CHITINASE FAMILY PROTEIN', 248995),
(389738, 'PTHR22595:SF196', NULL, NULL, NULL, NULL, 'CHITIN-BINDING TYPE-1 DOMAIN-CONTAINING PROTEIN', 248995),
(389739, 'PTHR22595:SF153', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_19_CAT DOMAIN-CONTAINING PROTEIN', 248995),
(389740, 'PTHR22595:SF194', NULL, NULL, NULL, NULL, 'ENDOCHITINASE CHI', 248995),
(389741, 'PTHR22595:SF195', NULL, NULL, NULL, NULL, 'CHITINASE', 248995),
(389742, 'PTHR22595:SF192', NULL, NULL, NULL, NULL, 'CHITIN-BINDING TYPE-1 DOMAIN-CONTAINING PROTEIN', 248995),
(389743, 'PTHR22595:SF193', NULL, NULL, NULL, NULL, 'ENDOCHITINASE EP3', 248995),
(389744, 'PTHR22595:SF190', NULL, NULL, NULL, NULL, 'CHITIN-BINDING TYPE-1 DOMAIN-CONTAINING PROTEIN', 248995),
(389745, 'PTHR22595:SF191', NULL, NULL, NULL, NULL, 'CHITINASE FAMILY PROTEIN', 248995),
(389746, 'PTHR22595:SF96', NULL, NULL, NULL, NULL, 'CHITINASE-LIKE PROTEIN 1', 248995),
(389747, 'PTHR22595:SF149', NULL, NULL, NULL, NULL, 'BASIC 30 KDA ENDOCHITINASE', 248995),
(389748, 'PTHR22595:SF147', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_19_CAT DOMAIN-CONTAINING PROTEIN', 248995),
(389749, 'PTHR22595:SF101', NULL, NULL, NULL, NULL, 'CHITINASE', 248995),
(389750, 'PTHR22595:SF189', NULL, NULL, NULL, NULL, 'CHITIN-BINDING TYPE-1 DOMAIN-CONTAINING PROTEIN', 248995),
(389751, 'PTHR22595:SF146', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE, FAMILY 19, LYSOZYME-LIKE DOMAIN PROTEIN-RELATED', 248995),
(389752, 'PTHR22595:SF187', NULL, NULL, NULL, NULL, 'ENDOCHITINASE A', 248995),
(389753, 'PTHR22595:SF143', NULL, NULL, NULL, NULL, 'BASIC ENDOCHITINASE B', 248995),
(389754, 'PTHR22595:SF188', NULL, NULL, NULL, NULL, 'CHITIN-BINDING TYPE-1 DOMAIN-CONTAINING PROTEIN', 248995),
(389755, 'PTHR22595:SF141', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE, FAMILY 19, CATALYTIC, LYSOZYME-LIKE DOMAIN PROTEIN-RELATED', 248995),
(389756, 'PTHR22595:SF185', NULL, NULL, NULL, NULL, 'BNAC04G48920D PROTEIN', 248995),
(389757, 'PTHR22595:SF186', NULL, NULL, NULL, NULL, 'ENDOCHITINASE EP3-LIKE', 248995),
(389758, 'PTHR22595:SF183', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_19_CAT DOMAIN-CONTAINING PROTEIN', 248995),
(389759, 'PTHR22595:SF184', NULL, NULL, NULL, NULL, 'ENDOCHITINASE A', 248995),
(389760, 'PTHR22595:SF140', NULL, NULL, NULL, NULL, 'CHITINASE 2', 248995),
(389761, 'PTHR22595:SF181', NULL, NULL, NULL, NULL, 'ENDOCHITINASE EP3-LIKE', 248995),
(389762, 'PTHR22595:SF182', NULL, NULL, NULL, NULL, 'CHITINASE', 248995),
(389763, 'PTHR22595:SF180', NULL, NULL, NULL, NULL, 'CHITINASE', 248995),
(389764, 'PTHR22595', NULL, NULL, NULL, NULL, 'CHITINASE-RELATED', 248995),
(389765, 'PTHR22595:SF45', NULL, NULL, NULL, NULL, 'CHITINASE 11', 248995),
(389766, 'PTHR22595:SF178', NULL, NULL, NULL, NULL, 'BNAC03G24280D PROTEIN', 248995),
(389767, 'PTHR22595:SF176', NULL, NULL, NULL, NULL, 'CHITINASE-LIKE PROTEIN 2', 248995),
(389768, 'PTHR22595:SF130', NULL, NULL, NULL, NULL, 'CHITINASE-LIKE PROTEIN 1', 248995),
(389769, 'PTHR22595:SF174', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_19_CAT DOMAIN-CONTAINING PROTEIN', 248995);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(389770, 'PTHR22595:SF173', NULL, NULL, NULL, NULL, 'CHITINASE', 248995),
(389771, 'PTHR22595:SF171', NULL, NULL, NULL, NULL, 'CHITINASE 8', 248995),
(389772, 'PTHR22595:SF79', NULL, NULL, NULL, NULL, 'CHITINASE 12', 248995),
(389773, 'PTHR22595:SF127', NULL, NULL, NULL, NULL, 'CHITINASE', 248995),
(389774, 'PTHR22595:SF125', NULL, NULL, NULL, NULL, 'CHITINASE', 248995),
(389775, 'PTHR22595:SF126', NULL, NULL, NULL, NULL, 'CHITIN-BINDING TYPE-1 DOMAIN-CONTAINING PROTEIN', 248995),
(389776, 'PTHR22595:SF168', NULL, NULL, NULL, NULL, 'CHITIN-BINDING TYPE-1 DOMAIN-CONTAINING PROTEIN', 248995),
(389777, 'PTHR22595:SF166', NULL, NULL, NULL, NULL, 'ENDOCHITINASE', 248995),
(389778, 'PTHR22595:SF163', NULL, NULL, NULL, NULL, 'CHITIN-BINDING TYPE-1 DOMAIN-CONTAINING PROTEIN', 248995),
(389779, 'PTHR22595:SF120', NULL, NULL, NULL, NULL, 'CHITINASE', 248995),
(389780, 'PTHR22595:SF161', NULL, NULL, NULL, NULL, 'CHITIN-BINDING TYPE-1 DOMAIN-CONTAINING PROTEIN', 248995),
(389781, 'PTHR14353:SF13', NULL, NULL, NULL, NULL, 'MARCKS-RELATED PROTEIN 1-B', 248996),
(389782, 'PTHR14353:SF9', NULL, NULL, NULL, NULL, 'MYRISTOYLATED ALANINE-RICH C-KINASE SUBSTRATE', 248996),
(389783, 'PTHR14353', NULL, NULL, NULL, NULL, 'MYRISTOYLATED ALANINE-RICH C-KINASE SUBSTRATE  MARCKS', 248996),
(389784, 'PTHR14353:SF8', NULL, NULL, NULL, NULL, 'MARCKS-RELATED PROTEIN', 248996),
(389785, 'PTHR31828:SF16', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1-IIBETA', 248997),
(389786, 'PTHR31828:SF38', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1', 248997),
(389787, 'PTHR31828:SF39', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1-II 4', 248997),
(389788, 'PTHR31828', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1-IIGAMMA', 248997),
(389789, 'PTHR31828:SF40', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1', 248997),
(389790, 'PTHR31828:SF41', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1', 248997),
(389791, 'PTHR31828:SF20', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1', 248997),
(389792, 'PTHR31828:SF21', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1', 248997),
(389793, 'PTHR31828:SF44', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1', 248997),
(389794, 'PTHR31828:SF22', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1', 248997),
(389795, 'PTHR31828:SF45', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1', 248997),
(389796, 'PTHR31828:SF23', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1', 248997),
(389797, 'PTHR31828:SF46', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1', 248997),
(389798, 'PTHR31828:SF25', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1', 248997),
(389799, 'PTHR31828:SF48', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1', 248997),
(389800, 'PTHR31828:SF49', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1', 248997),
(389801, 'PTHR31828:SF28', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1', 248997),
(389802, 'PTHR31828:SF29', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1', 248997),
(389803, 'PTHR31828:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1-IIGAMMA', 248997),
(389804, 'PTHR31828:SF5', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1-II 2', 248997),
(389805, 'PTHR31828:SF6', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1-II 1', 248997),
(389806, 'PTHR31828:SF8', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1-II 3', 248997),
(389807, 'PTHR31828:SF50', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1', 248997),
(389808, 'PTHR31828:SF30', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1', 248997),
(389809, 'PTHR31828:SF31', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1', 248997),
(389810, 'PTHR31828:SF10', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1-IIDELTA', 248997),
(389811, 'PTHR31828:SF33', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1', 248997),
(389812, 'PTHR31828:SF12', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1-II 6', 248997),
(389813, 'PTHR31828:SF34', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1', 248997),
(389814, 'PTHR31828:SF13', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1', 248997),
(389815, 'PTHR31828:SF35', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1', 248997),
(389816, 'PTHR31828:SF36', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1', 248997),
(389817, 'PTHR31828:SF14', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1-IIALPHA', 248997);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(389818, 'PTHR31828:SF37', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1', 248997),
(389819, 'PTHR31828:SF15', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1', 248997),
(389820, 'PTHR30061:SF50', NULL, NULL, NULL, NULL, 'MALTOSE/MALTODEXTRIN-BINDING PERIPLASMIC PROTEIN', 248998),
(389821, 'PTHR30061', NULL, NULL, NULL, NULL, 'MALTOSE-BINDING PERIPLASMIC PROTEIN', 248998),
(389822, 'PTHR14881:SF4', NULL, NULL, NULL, NULL, 'LISH DOMAIN-CONTAINING PROTEIN ARMC9', 248999),
(389823, 'PTHR14881', NULL, NULL, NULL, NULL, 'LISH DOMAIN-CONTAINING PROTEIN ARMC9', 248999),
(389824, 'PTHR35803', NULL, NULL, NULL, NULL, 'GLUCAN 1,4-ALPHA-GLUCOSIDASE SUSB-RELATED', 249000),
(389825, 'PTHR35803:SF3', NULL, NULL, NULL, NULL, 'ALPHA-GLUCOSIDASE', 249000),
(389826, 'PTHR35803:SF2', NULL, NULL, NULL, NULL, 'RETAINING ALPHA-GALACTOSIDASE', 249000),
(389827, 'PTHR35803:SF1', NULL, NULL, NULL, NULL, 'GLUCAN 1,4-ALPHA-GLUCOSIDASE SUSB', 249000),
(389828, 'PTHR47675', NULL, NULL, NULL, NULL, 'MOLYBDOPTERIN BINDING DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_5G11210)', 249001),
(389829, 'PTHR47675:SF1', NULL, NULL, NULL, NULL, 'MOLYBDOPTERIN BINDING DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_5G11210)', 249001),
(389830, 'PTHR21183', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L47, MITOCHONDRIAL-RELATED', 249002),
(389831, 'PTHR21183:SF18', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L47, MITOCHONDRIAL', 249002),
(389832, 'PTHR48241', NULL, NULL, NULL, NULL, '', 249003),
(389833, 'PTHR48241:SF1', NULL, NULL, NULL, NULL, '', 249003),
(389834, 'PTHR36959', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN 24, MITOCHONDRIAL', 249004),
(389835, 'PTHR36959:SF2', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN 24, MITOCHONDRIAL', 249004),
(389836, 'PTHR21610', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR A DOMAIN-CONTAINING PROTEIN 8', 249005),
(389837, 'PTHR21610:SF9', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR A DOMAIN-CONTAINING PROTEIN 8', 249005),
(389838, 'PTHR21344:SF1', NULL, NULL, NULL, NULL, 'RAL GTPASE-ACTIVATING PROTEIN SUBUNIT BETA', 249006),
(389839, 'PTHR21344', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 249006),
(389840, 'PTHR33271:SF33', NULL, NULL, NULL, NULL, 'CUPIN_3 DOMAIN-CONTAINING PROTEIN', 249007),
(389841, 'PTHR33271:SF22', NULL, NULL, NULL, NULL, 'OS04G0445200 PROTEIN', 249007),
(389842, 'PTHR33271:SF32', NULL, NULL, NULL, NULL, 'OS02G0620400 PROTEIN', 249007),
(389843, 'PTHR33271:SF31', NULL, NULL, NULL, NULL, 'CUPIN_3 DOMAIN-CONTAINING PROTEIN', 249007),
(389844, 'PTHR33271', NULL, NULL, NULL, NULL, 'OS04G0445200 PROTEIN', 249007),
(389845, 'PTHR33271:SF1', NULL, NULL, NULL, NULL, 'CUPIN_3 DOMAIN-CONTAINING PROTEIN', 249007),
(389846, 'PTHR33271:SF3', NULL, NULL, NULL, NULL, 'RMLC-LIKE CUPINS SUPERFAMILY PROTEIN', 249007),
(389847, 'PTHR33271:SF18', NULL, NULL, NULL, NULL, 'RMLC-LIKE JELLY ROLL PROTEIN-RELATED', 249007),
(389848, 'PTHR33271:SF29', NULL, NULL, NULL, NULL, 'CUPIN_3 DOMAIN-CONTAINING PROTEIN', 249007),
(389849, 'PTHR33271:SF17', NULL, NULL, NULL, NULL, 'RMLC-LIKE CUPINS SUPERFAMILY PROTEIN', 249007),
(389850, 'PTHR33271:SF7', NULL, NULL, NULL, NULL, 'PLASTID TRANSCRIPTIONALLY ACTIVE 18', 249007),
(389851, 'PTHR33271:SF26', NULL, NULL, NULL, NULL, 'CUPIN_3 DOMAIN-CONTAINING PROTEIN', 249007),
(389852, 'PTHR33271:SF34', NULL, NULL, NULL, NULL, 'CUPIN_3 DOMAIN-CONTAINING PROTEIN', 249007),
(389853, 'PTHR34708:SF1', NULL, NULL, NULL, NULL, 'OS08G0126400 PROTEIN', 249008),
(389854, 'PTHR34708:SF2', NULL, NULL, NULL, NULL, 'OS07G0440000 PROTEIN', 249008),
(389855, 'PTHR34708:SF4', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 249008),
(389856, 'PTHR34708', NULL, NULL, NULL, NULL, 'OS07G0440000 PROTEIN', 249008),
(389857, 'PTHR34708:SF5', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 249008),
(389858, 'PTHR34552:SF5', NULL, NULL, NULL, NULL, 'PSII 6.1 KDA PROTEIN', 249009),
(389859, 'PTHR34552:SF4', NULL, NULL, NULL, NULL, 'PSII 6.1 KDA PROTEIN', 249009),
(389860, 'PTHR34552:SF3', NULL, NULL, NULL, NULL, 'PSII 6.1 KDA PROTEIN', 249009);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(389861, 'PTHR34552:SF2', NULL, NULL, NULL, NULL, 'PSII 6.1 KDA PROTEIN', 249009),
(389862, 'PTHR34552:SF9', NULL, NULL, NULL, NULL, 'PSII 6.1 KDA PROTEIN', 249009),
(389863, 'PTHR34552:SF8', NULL, NULL, NULL, NULL, 'PSII 6.1 KDA PROTEIN', 249009),
(389864, 'PTHR34552:SF7', NULL, NULL, NULL, NULL, 'PSII 6.1 KDA PROTEIN', 249009),
(389865, 'PTHR34552:SF6', NULL, NULL, NULL, NULL, 'PSII 6.1 KDA PROTEIN', 249009),
(389866, 'PTHR34552:SF1', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REACTION CENTER W PROTEIN, CHLOROPLASTIC', 249009),
(389867, 'PTHR34552:SF12', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REACTION CENTER W PROTEIN, CHLOROPLASTIC', 249009),
(389868, 'PTHR34552:SF11', NULL, NULL, NULL, NULL, 'PSII 6.1 KDA PROTEIN', 249009),
(389869, 'PTHR34552:SF10', NULL, NULL, NULL, NULL, 'PSII 6.1 KDA PROTEIN', 249009),
(389870, 'PTHR34552', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REACTION CENTER W PROTEIN, CHLOROPLASTIC', 249009),
(389871, 'PTHR20941', NULL, NULL, NULL, NULL, 'FOLATE SYNTHESIS PROTEINS', 249010),
(389872, 'PTHR20941:SF1', NULL, NULL, NULL, NULL, 'FOLIC ACID SYNTHESIS PROTEIN FOL1', 249010),
(389873, 'PTHR20941:SF8', NULL, NULL, NULL, NULL, 'INACTIVE DIHYDROPTEROATE SYNTHASE 2', 249010),
(389874, 'PTHR40128:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249011),
(389875, 'PTHR40128', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249011),
(389876, 'PTHR28110', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 249012),
(389877, 'PTHR28110:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 249012),
(389878, 'PTHR38827:SF1', NULL, NULL, NULL, NULL, '', 249013),
(389879, 'PTHR38827:SF2', NULL, NULL, NULL, NULL, '', 249013),
(389880, 'PTHR38827', NULL, NULL, NULL, NULL, '', 249013),
(389881, 'PTHR38827:SF3', NULL, NULL, NULL, NULL, '', 249013),
(389882, 'PTHR43347', NULL, NULL, NULL, NULL, 'ACYL-COA SYNTHETASE', 249014),
(389883, 'PTHR43347:SF4', NULL, NULL, NULL, NULL, 'ACETYL-COA SYNETHETASE-RELATED', 249014),
(389884, 'PTHR43347:SF3', NULL, NULL, NULL, NULL, 'ACYL-COA SYNTHETASE SHORT-CHAIN FAMILY MEMBER 3, MITOCHONDRIAL', 249014),
(389885, 'PTHR43347:SF1', NULL, NULL, NULL, NULL, '', 249014),
(389886, 'PTHR46166:SF2', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-B8', 249015),
(389887, 'PTHR46166:SF3', NULL, NULL, NULL, NULL, 'EGL-5', 249015),
(389888, 'PTHR46166:SF1', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-D8', 249015),
(389889, 'PTHR46166', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 249015),
(389890, 'PTHR46166:SF4', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-C8', 249015),
(389891, 'PTHR36607:SF24', NULL, NULL, NULL, NULL, 'PMD DOMAIN-CONTAINING PROTEIN', 249016),
(389892, 'PTHR36607:SF23', NULL, NULL, NULL, NULL, 'PMD DOMAIN-CONTAINING PROTEIN', 249016),
(389893, 'PTHR36607:SF26', NULL, NULL, NULL, NULL, 'PMD DOMAIN-CONTAINING PROTEIN', 249016),
(389894, 'PTHR36607', NULL, NULL, NULL, NULL, '1,2-DIHYDROXY-3-KETO-5-METHYLTHIOPENTENE DIOXYGENASE 4', 249016),
(389895, 'PTHR36607:SF25', NULL, NULL, NULL, NULL, '', 249016),
(389896, 'PTHR36607:SF18', NULL, NULL, NULL, NULL, 'PMD DOMAIN-CONTAINING PROTEIN', 249016),
(389897, 'PTHR36607:SF20', NULL, NULL, NULL, NULL, 'PMD DOMAIN-CONTAINING PROTEIN', 249016),
(389898, 'PTHR47290', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN', 249017),
(389899, 'PTHR47290:SF7', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN', 249017),
(389900, 'PTHR47290:SF6', NULL, NULL, NULL, NULL, '', 249017),
(389901, 'PTHR47290:SF5', NULL, NULL, NULL, NULL, 'OS12G0479100 PROTEIN', 249017),
(389902, 'PTHR47290:SF4', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN', 249017),
(389903, 'PTHR47290:SF3', NULL, NULL, NULL, NULL, 'BNACNNG36360D PROTEIN', 249017),
(389904, 'PTHR47290:SF2', NULL, NULL, NULL, NULL, 'OS01G0928400 PROTEIN', 249017),
(389905, 'PTHR33923:SF3', NULL, NULL, NULL, NULL, 'CALMODULIN BINDING PROTEIN PICBP', 249018),
(389906, 'PTHR33923:SF13', NULL, NULL, NULL, NULL, 'PLANT CALMODULIN-BINDING PROTEIN-RELATED', 249018),
(389907, 'PTHR33923:SF10', NULL, NULL, NULL, NULL, 'CAM_BINDING DOMAIN-CONTAINING PROTEIN', 249018),
(389908, 'PTHR33923:SF2', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN-RELATED', 249018);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(389909, 'PTHR33923:SF11', NULL, NULL, NULL, NULL, 'PLANT CALMODULIN-BINDING-LIKE PROTEIN', 249018),
(389910, 'PTHR33923', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN-RELATED', 249018),
(389911, 'PTHR38779:SF2', NULL, NULL, NULL, NULL, 'TYPE II SECRETION SYSTEM PROTEIN I-RELATED', 249019),
(389912, 'PTHR38779', NULL, NULL, NULL, NULL, 'TYPE II SECRETION SYSTEM PROTEIN I-RELATED', 249019),
(389913, 'PTHR30573:SF0', NULL, NULL, NULL, NULL, 'QUINOLINATE SYNTHASE, CHLOROPLASTIC', 249020),
(389914, 'PTHR30573', NULL, NULL, NULL, NULL, 'QUINOLINATE SYNTHETASE A', 249020),
(389915, 'PTHR46734:SF5', NULL, NULL, NULL, NULL, 'TELOMERIC REPEAT-BINDING FACTOR', 249021),
(389916, 'PTHR46734', NULL, NULL, NULL, NULL, 'TELOMERIC REPEAT-BINDING FACTOR 1 TERF1', 249021),
(389917, 'PTHR46734:SF2', NULL, NULL, NULL, NULL, 'TELOMERIC REPEAT-BINDING FACTOR', 249021),
(389918, 'PTHR46734:SF1', NULL, NULL, NULL, NULL, 'TELOMERIC REPEAT-BINDING FACTOR 1', 249021),
(389919, 'PTHR46734:SF4', NULL, NULL, NULL, NULL, 'TELOMERIC REPEAT-BINDING FACTOR', 249021),
(389920, 'PTHR46734:SF3', NULL, NULL, NULL, NULL, 'TELOMERIC REPEAT-BINDING FACTOR 1', 249021),
(389921, 'PTHR23155:SF969', NULL, NULL, NULL, NULL, 'RX_N DOMAIN-CONTAINING PROTEIN', 249022),
(389922, 'PTHR23155:SF968', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN CONTAINING PROTEIN, EXPRESSED', 249022),
(389923, 'PTHR23155:SF1045', NULL, NULL, NULL, NULL, 'OS02G0504200 PROTEIN', 249022),
(389924, 'PTHR23155:SF1166', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN CONTAINING PROTEIN, EXPRESSED', 249022),
(389925, 'PTHR23155:SF1165', NULL, NULL, NULL, NULL, 'OS11G0676100 PROTEIN', 249022),
(389926, 'PTHR23155:SF1044', NULL, NULL, NULL, NULL, 'OS09G0272900 PROTEIN', 249022),
(389927, 'PTHR23155:SF1203', NULL, NULL, NULL, NULL, 'OS09G0479500 PROTEIN', 249022),
(389928, 'PTHR23155:SF1202', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE RPP13-LIKE PROTEIN 1-RELATED', 249022),
(389929, 'PTHR23155:SF1047', NULL, NULL, NULL, NULL, 'OS09G0327800 PROTEIN', 249022),
(389930, 'PTHR23155:SF1201', NULL, NULL, NULL, NULL, 'OS02G0301800 PROTEIN', 249022),
(389931, 'PTHR23155:SF1200', NULL, NULL, NULL, NULL, 'OS11G0647000 PROTEIN', 249022),
(389932, 'PTHR23155:SF1046', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN CONTAINING PROTEIN, EXPRESSED', 249022),
(389933, 'PTHR23155:SF1167', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN CONTAINING PROTEIN, EXPRESSED', 249022),
(389934, 'PTHR23155:SF1207', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 249022),
(389935, 'PTHR23155:SF1206', NULL, NULL, NULL, NULL, 'OS04G0312000 PROTEIN', 249022),
(389936, 'PTHR23155:SF1205', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN CONTAINING PROTEIN, EXPRESSED', 249022),
(389937, 'PTHR23155:SF1204', NULL, NULL, NULL, NULL, 'L-ZIP+NBS+LRR-LIKE PROTEIN', 249022),
(389938, 'PTHR23155:SF1209', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN CONTAINING PROTEIN, EXPRESSED', 249022),
(389939, 'PTHR23155:SF1208', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RPM1', 249022),
(389940, 'PTHR23155:SF961', NULL, NULL, NULL, NULL, 'DISEASE RELATED PROTEIN 2', 249022),
(389941, 'PTHR23155:SF963', NULL, NULL, NULL, NULL, 'OS06G0287000 PROTEIN', 249022),
(389942, 'PTHR23155:SF687', NULL, NULL, NULL, NULL, 'OS07G0481400 PROTEIN', 249022),
(389943, 'PTHR23155:SF957', NULL, NULL, NULL, NULL, 'OS11G0606800 PROTEIN', 249022),
(389944, 'PTHR23155:SF959', NULL, NULL, NULL, NULL, 'OS01G0269700 PROTEIN', 249022),
(389945, 'PTHR23155:SF1173', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN-RELATED', 249022),
(389946, 'PTHR23155:SF1052', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN CONTAINING PROTEIN EXPRESSED', 249022),
(389947, 'PTHR23155:SF1172', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE RPP13-LIKE PROTEIN 4', 249022),
(389948, 'PTHR23155:SF1171', NULL, NULL, NULL, NULL, 'OS01G0799100 PROTEIN', 249022),
(389949, 'PTHR23155:SF1170', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE RPP13-LIKE PROTEIN 1-RELATED', 249022),
(389950, 'PTHR23155:SF1210', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RPM1', 249022),
(389951, 'PTHR23155:SF1176', NULL, NULL, NULL, NULL, 'OS04G0111900 PROTEIN', 249022);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(389952, 'PTHR23155:SF1214', NULL, NULL, NULL, NULL, 'OS09G0270700 PROTEIN', 249022),
(389953, 'PTHR23155:SF1213', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RPM1', 249022),
(389954, 'PTHR23155:SF1058', NULL, NULL, NULL, NULL, 'OS11G0668100 PROTEIN', 249022),
(389955, 'PTHR23155:SF1212', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 249022),
(389956, 'PTHR23155:SF1211', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN CONTAINING PROTEIN, EXPRESSED', 249022),
(389957, 'PTHR23155:SF1218', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE RPP13-LIKE PROTEIN 1-RELATED', 249022),
(389958, 'PTHR23155:SF1217', NULL, NULL, NULL, NULL, 'OS08G0246100 PROTEIN', 249022),
(389959, 'PTHR23155:SF1216', NULL, NULL, NULL, NULL, 'OS04G0219600 PROTEIN', 249022),
(389960, 'PTHR23155:SF1215', NULL, NULL, NULL, NULL, 'OS05G0492600 PROTEIN', 249022),
(389961, 'PTHR23155:SF1219', NULL, NULL, NULL, NULL, 'OS08G0543500 PROTEIN', 249022),
(389962, 'PTHR23155:SF950', NULL, NULL, NULL, NULL, 'OS05G0585200 PROTEIN', 249022),
(389963, 'PTHR23155:SF955', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 249022),
(389964, 'PTHR23155:SF947', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN PIK6-NP', 249022),
(389965, 'PTHR23155:SF704', NULL, NULL, NULL, NULL, 'OS12G0511600 PROTEIN', 249022),
(389966, 'PTHR23155:SF949', NULL, NULL, NULL, NULL, 'OS01G0781200 PROTEIN', 249022),
(389967, 'PTHR23155:SF1143', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN CONTAINING PROTEIN', 249022),
(389968, 'PTHR23155:SF1020', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 249022),
(389969, 'PTHR23155:SF1149', NULL, NULL, NULL, NULL, 'OS11G0429100 PROTEIN', 249022),
(389970, 'PTHR23155:SF1028', NULL, NULL, NULL, NULL, 'OS08G0174800 PROTEIN', 249022),
(389971, 'PTHR23155:SF943', NULL, NULL, NULL, NULL, 'OS08G0193700 PROTEIN', 249022),
(389972, 'PTHR23155:SF945', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN CONTAINING PROTEIN, EXPRESSED', 249022),
(389973, 'PTHR23155:SF944', NULL, NULL, NULL, NULL, 'PI15', 249022),
(389974, 'PTHR23155:SF937', NULL, NULL, NULL, NULL, 'OS08G0296700 PROTEIN', 249022),
(389975, 'PTHR23155:SF1150', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 249022),
(389976, 'PTHR23155:SF1032', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RFL1-RELATED', 249022),
(389977, 'PTHR23155:SF1152', NULL, NULL, NULL, NULL, 'TOMV SUSCEPTIBLE PROTEIN TM-2', 249022),
(389978, 'PTHR23155:SF1156', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND WD REPEAT-CONTAINING PROTEIN 1', 249022),
(389979, 'PTHR23155:SF931', NULL, NULL, NULL, NULL, 'OS01G0547000 PROTEIN', 249022),
(389980, 'PTHR23155:SF934', NULL, NULL, NULL, NULL, 'OS11G0604900 PROTEIN', 249022),
(389981, 'PTHR23155:SF933', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RPM1', 249022),
(389982, 'PTHR23155:SF1080', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN CONTAINING PROTEIN', 249022),
(389983, 'PTHR23155:SF1084', NULL, NULL, NULL, NULL, 'OS05G0414300 PROTEIN', 249022),
(389984, 'PTHR23155:SF1089', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN CONTAINING PROTEIN, EXPRESSED', 249022),
(389985, 'PTHR23155:SF1122', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN CONTAINING PROTEIN, EXPRESSED', 249022),
(389986, 'PTHR23155:SF1001', NULL, NULL, NULL, NULL, 'OS07G0599100 PROTEIN', 249022),
(389987, 'PTHR23155:SF1121', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE RPP13-LIKE PROTEIN 4', 249022),
(389988, 'PTHR23155:SF1087', NULL, NULL, NULL, NULL, 'OS11G0462900 PROTEIN', 249022),
(389989, 'PTHR23155:SF1120', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RPM1', 249022),
(389990, 'PTHR23155:SF1005', NULL, NULL, NULL, NULL, 'OS07G0197300 PROTEIN', 249022),
(389991, 'PTHR23155:SF1123', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RGA4', 249022),
(389992, 'PTHR23155:SF1129', NULL, NULL, NULL, NULL, '', 249022),
(389993, 'PTHR23155:SF1128', NULL, NULL, NULL, NULL, 'OS03G0849500 PROTEIN', 249022),
(389994, 'PTHR23155:SF889', NULL, NULL, NULL, NULL, 'OS03G0379801 PROTEIN', 249022),
(389995, 'PTHR23155:SF1092', NULL, NULL, NULL, NULL, 'OS01G0536501 PROTEIN', 249022);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(389996, 'PTHR23155:SF759', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 249022),
(389997, 'PTHR23155:SF1091', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249022),
(389998, 'PTHR23155:SF1095', NULL, NULL, NULL, NULL, 'OS05G0250700 PROTEIN', 249022),
(389999, 'PTHR23155:SF917', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE RPP13-LIKE PROTEIN 4', 249022),
(390000, 'PTHR23155:SF1094', NULL, NULL, NULL, NULL, 'OS11G0686400 PROTEIN', 249022),
(390001, 'PTHR23155:SF1133', NULL, NULL, NULL, NULL, 'NBS-LRR-LIKE PROTEIN', 249022),
(390002, 'PTHR23155', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RP', 249022),
(390003, 'PTHR23155:SF1011', NULL, NULL, NULL, NULL, 'OS11G0258500 PROTEIN', 249022),
(390004, 'PTHR23155:SF1098', NULL, NULL, NULL, NULL, 'OS08G0260800 PROTEIN', 249022),
(390005, 'PTHR23155:SF1137', NULL, NULL, NULL, NULL, 'OS08G0387700 PROTEIN', 249022),
(390006, 'PTHR23155:SF1136', NULL, NULL, NULL, NULL, 'OS01G0335700 PROTEIN', 249022),
(390007, 'PTHR23155:SF1135', NULL, NULL, NULL, NULL, 'OS08G0246300 PROTEIN', 249022),
(390008, 'PTHR23155:SF1013', NULL, NULL, NULL, NULL, 'OS10G0131800 PROTEIN', 249022),
(390009, 'PTHR23155:SF1134', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 249022),
(390010, 'PTHR23155:SF1139', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 249022),
(390011, 'PTHR23155:SF990', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN CONTAINING PROTEIN, EXPRESSED', 249022),
(390012, 'PTHR23155:SF991', NULL, NULL, NULL, NULL, 'OS02G0199000 PROTEIN', 249022),
(390013, 'PTHR23155:SF872', NULL, NULL, NULL, NULL, 'OS02G0456800 PROTEIN', 249022),
(390014, 'PTHR23155:SF912', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN CONTAINING PROTEIN, EXPRESSED', 249022),
(390015, 'PTHR23155:SF999', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN CONTAINING PROTEIN, EXPRESSED', 249022),
(390016, 'PTHR23155:SF1180', NULL, NULL, NULL, NULL, 'OS02G0262800 PROTEIN', 249022),
(390017, 'PTHR23155:SF906', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN CONTAINING PROTEIN, EXPRESSED', 249022),
(390018, 'PTHR23155:SF1062', NULL, NULL, NULL, NULL, 'OS06G0276300 PROTEIN', 249022),
(390019, 'PTHR23155:SF909', NULL, NULL, NULL, NULL, 'OS11G0673900 PROTEIN', 249022),
(390020, 'PTHR23155:SF1182', NULL, NULL, NULL, NULL, 'OS07G0186500 PROTEIN', 249022),
(390021, 'PTHR23155:SF1060', NULL, NULL, NULL, NULL, 'NBS-LRR DISEASE RESISTANCE PROTEIN', 249022),
(390022, 'PTHR23155:SF1181', NULL, NULL, NULL, NULL, 'RX_N DOMAIN-CONTAINING PROTEIN', 249022),
(390023, 'PTHR23155:SF1221', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN CONTAINING PROTEIN, EXPRESSED', 249022),
(390024, 'PTHR23155:SF1100', NULL, NULL, NULL, NULL, 'OS08G0332600 PROTEIN', 249022),
(390025, 'PTHR23155:SF1188', NULL, NULL, NULL, NULL, 'OS11G0492300 PROTEIN', 249022),
(390026, 'PTHR23155:SF1220', NULL, NULL, NULL, NULL, 'OS01G0798900 PROTEIN', 249022),
(390027, 'PTHR23155:SF1185', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE RPP8-LIKE PROTEIN 3-RELATED', 249022),
(390028, 'PTHR23155:SF1225', NULL, NULL, NULL, NULL, 'OS11G0550500 PROTEIN', 249022),
(390029, 'PTHR23155:SF1224', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN CONTAINING PROTEIN, EXPRESSED', 249022),
(390030, 'PTHR23155:SF1223', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE RPP13-LIKE PROTEIN 1-RELATED', 249022),
(390031, 'PTHR23155:SF1068', NULL, NULL, NULL, NULL, 'OS07G0273900 PROTEIN', 249022),
(390032, 'PTHR23155:SF1189', NULL, NULL, NULL, NULL, 'OS11G0462500 PROTEIN', 249022),
(390033, 'PTHR23155:SF1222', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 249022),
(390034, 'PTHR23155:SF1107', NULL, NULL, NULL, NULL, 'OS08G0373000 PROTEIN', 249022),
(390035, 'PTHR23155:SF860', NULL, NULL, NULL, NULL, 'OS01G0359800 PROTEIN', 249022),
(390036, 'PTHR23155:SF981', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN CONTAINING PROTEIN, EXPRESSED', 249022),
(390037, 'PTHR23155:SF983', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN CONTAINING PROTEIN, EXPRESSED', 249022),
(390038, 'PTHR23155:SF864', NULL, NULL, NULL, NULL, 'OS09G0313500 PROTEIN', 249022),
(390039, 'PTHR23155:SF901', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RPM1', 249022);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(390040, 'PTHR23155:SF988', NULL, NULL, NULL, NULL, 'OS06G0707733 PROTEIN', 249022),
(390041, 'PTHR23155:SF859', NULL, NULL, NULL, NULL, 'OS04G0491000 PROTEIN', 249022),
(390042, 'PTHR23155:SF1191', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE GENE ANALOG PIC17', 249022),
(390043, 'PTHR23155:SF1190', NULL, NULL, NULL, NULL, 'OS04G0491100 PROTEIN', 249022),
(390044, 'PTHR23155:SF1195', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 249022),
(390045, 'PTHR23155:SF1194', NULL, NULL, NULL, NULL, 'OS01G0520600 PROTEIN', 249022),
(390046, 'PTHR23155:SF1193', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RPP13-RELATED', 249022),
(390047, 'PTHR23155:SF1071', NULL, NULL, NULL, NULL, 'OS04G0374000 PROTEIN', 249022),
(390048, 'PTHR23155:SF1192', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RPS2', 249022),
(390049, 'PTHR23155:SF1199', NULL, NULL, NULL, NULL, 'ABC_TRANS_N DOMAIN-CONTAINING PROTEIN', 249022),
(390050, 'PTHR23155:SF1110', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT FAMILY PROTEIN, EXPRESSED', 249022),
(390051, 'PTHR23155:SF1198', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RGA5', 249022),
(390052, 'PTHR23155:SF1076', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT (LRR) FAMILY PROTEIN-RELATED', 249022),
(390053, 'PTHR23155:SF1197', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RPM1', 249022),
(390054, 'PTHR23155:SF1075', NULL, NULL, NULL, NULL, 'OS06G0644300 PROTEIN', 249022),
(390055, 'PTHR23155:SF1196', NULL, NULL, NULL, NULL, 'OS07G0521800 PROTEIN', 249022),
(390056, 'PTHR23155:SF1114', NULL, NULL, NULL, NULL, 'OS02G0475500 PROTEIN', 249022),
(390057, 'PTHR23155:SF1113', NULL, NULL, NULL, NULL, 'OS01G0808000 PROTEIN', 249022),
(390058, 'PTHR23155:SF1116', NULL, NULL, NULL, NULL, 'OS11G0657900 PROTEIN', 249022),
(390059, 'PTHR23155:SF972', NULL, NULL, NULL, NULL, 'OS11G0238700 PROTEIN', 249022),
(390060, 'PTHR43056:SF12', NULL, NULL, NULL, NULL, 'PEPTIDASE_S9 DOMAIN-CONTAINING PROTEIN', 249023),
(390061, 'PTHR43056:SF13', NULL, NULL, NULL, NULL, 'PEPTIDASE_S9 DOMAIN-CONTAINING PROTEIN', 249023),
(390062, 'PTHR43056:SF10', NULL, NULL, NULL, NULL, 'COCE/NOND FAMILY, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G00600)-RELATED', 249023),
(390063, 'PTHR43056:SF11', NULL, NULL, NULL, NULL, 'OS06G0215400 PROTEIN', 249023),
(390064, 'PTHR43056:SF5', NULL, NULL, NULL, NULL, 'ACYL-PEPTIDE HYDROLASE', 249023),
(390065, 'PTHR43056', NULL, NULL, NULL, NULL, 'PEPTIDASE S9 PROLYL OLIGOPEPTIDASE', 249023),
(390066, 'PTHR43056:SF2', NULL, NULL, NULL, NULL, 'PEPX_C DOMAIN-CONTAINING PROTEIN', 249023),
(390067, 'PTHR43056:SF14', NULL, NULL, NULL, NULL, 'PEPTIDASE_S9 DOMAIN-CONTAINING PROTEIN', 249023),
(390068, 'PTHR23351:SF6', NULL, NULL, NULL, NULL, 'FOS-RELATED ANTIGEN 1', 249024),
(390069, 'PTHR23351:SF14', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER TRANSCRIPTIONAL FACTOR ATF-LIKE', 249024),
(390070, 'PTHR23351:SF25', NULL, NULL, NULL, NULL, 'FOS-RELATED ANTIGEN 2', 249024),
(390071, 'PTHR23351', NULL, NULL, NULL, NULL, 'FOS TRANSCRIPTION FACTOR-RELATED', 249024),
(390072, 'PTHR23351:SF4', NULL, NULL, NULL, NULL, 'PROTO-ONCOGENE C-FOS', 249024),
(390073, 'PTHR23351:SF3', NULL, NULL, NULL, NULL, 'PROTEIN FOSB', 249024),
(390074, 'PTHR23351:SF52', NULL, NULL, NULL, NULL, 'SI:CH211-153J24.3-RELATED', 249024),
(390075, 'PTHR23351:SF51', NULL, NULL, NULL, NULL, 'SI:DKEY-23I12.7', 249024),
(390076, 'PTHR23351:SF56', NULL, NULL, NULL, NULL, 'KAYAK', 249024),
(390077, 'PTHR23351:SF23', NULL, NULL, NULL, NULL, 'CYCLIC AMP-DEPENDENT TRANSCRIPTION FACTOR ATF-3', 249024),
(390078, 'PTHR23351:SF13', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER TRANSCRIPTIONAL FACTOR ATF-LIKE 3', 249024),
(390079, 'PTHR23351:SF24', NULL, NULL, NULL, NULL, 'ACTIVATING TRANSCRIPTION FACTOR 3-RELATED', 249024),
(390080, 'PTHR23351:SF57', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR FOS-1', 249024),
(390081, 'PTHR23351:SF10', NULL, NULL, NULL, NULL, 'JUN DIMERIZATION PROTEIN 2', 249024),
(390082, 'PTHR23351:SF11', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER TRANSCRIPTIONAL FACTOR ATF-LIKE 2', 249024),
(390083, 'PTHR10004:SF8', NULL, NULL, NULL, NULL, 'OS06G0538200 PROTEIN', 249025);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(390084, 'PTHR10004', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 249025),
(390085, 'PTHR37859', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 3', 249026),
(390086, 'PTHR37859:SF1', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 3', 249026),
(390087, 'PTHR35818:SF1', NULL, NULL, NULL, NULL, 'RGD1564171', 249027),
(390088, 'PTHR35818', NULL, NULL, NULL, NULL, 'C1ORF189', 249027),
(390089, 'PTHR11938:SF91', NULL, NULL, NULL, NULL, 'NADPH:ADRENODOXIN OXIDOREDUCTASE, MITOCHONDRIAL', 249028),
(390090, 'PTHR11938:SF138', NULL, NULL, NULL, NULL, 'FERREDOXIN-DEPENDENT GLUTAMATE SYNTHASE 2, CHLOROPLASTIC', 249028),
(390091, 'PTHR11938:SF1', NULL, NULL, NULL, NULL, 'FERREDOXIN-DEPENDENT GLUTAMATE SYNTHASE 1, CHLOROPLASTIC/MITOCHONDRIAL', 249028),
(390092, 'PTHR11938:SF145', NULL, NULL, NULL, NULL, 'GLU_SYNTHASE DOMAIN-CONTAINING PROTEIN', 249028),
(390093, 'PTHR11938:SF134', NULL, NULL, NULL, NULL, 'GLUTAMINE AMIDOTRANSFERASE TYPE-2 DOMAIN-CONTAINING PROTEIN', 249028),
(390094, 'PTHR11938:SF133', NULL, NULL, NULL, NULL, 'GLUTAMINE AMIDOTRANSFERASE TYPE-2 DOMAIN-CONTAINING PROTEIN', 249028),
(390095, 'PTHR11938:SF147', NULL, NULL, NULL, NULL, 'GLUTAMATE SYNTHASE (NADPH)', 249028),
(390096, 'PTHR11938:SF146', NULL, NULL, NULL, NULL, 'GLUTAMATE SYNTHASE 2 [NADH], CHLOROPLASTIC', 249028),
(390097, 'PTHR11938', NULL, NULL, NULL, NULL, 'FAD NADPH DEHYDROGENASE/OXIDOREDUCTASE', 249028),
(390098, 'PTHR28152', NULL, NULL, NULL, NULL, 'HYDROXYACYL-THIOESTER DEHYDRATASE TYPE 2, MITOCHONDRIAL', 249029),
(390099, 'PTHR28152:SF1', NULL, NULL, NULL, NULL, 'HYDROXYACYL-THIOESTER DEHYDRATASE TYPE 2, MITOCHONDRIAL', 249029),
(390100, 'PTHR28152:SF2', NULL, NULL, NULL, NULL, '', 249029),
(390101, 'PTHR36442:SF1', NULL, NULL, NULL, NULL, 'CYCLIC-DI-AMP PHOSPHODIESTERASE PGPH', 249030),
(390102, 'PTHR36442', NULL, NULL, NULL, NULL, 'CYCLIC-DI-AMP PHOSPHODIESTERASE PGPH', 249030),
(390103, 'PTHR24365:SF530', NULL, NULL, NULL, NULL, 'TOLL-9, ISOFORM A', 249031),
(390104, 'PTHR24365:SF541', NULL, NULL, NULL, NULL, 'MSTPROX-RELATED', 249031),
(390105, 'PTHR24365:SF261', NULL, NULL, NULL, NULL, 'TOLL-LIKE RECEPTOR 1', 249031),
(390106, 'PTHR24365:SF547', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 249031),
(390107, 'PTHR24365:SF525', NULL, NULL, NULL, NULL, 'TOLL-LIKE RECEPTOR 5', 249031),
(390108, 'PTHR24365:SF524', NULL, NULL, NULL, NULL, 'TOLL-LIKE RECEPTOR 3', 249031),
(390109, 'PTHR24365:SF17', NULL, NULL, NULL, NULL, 'TOLL-LIKE RECEPTOR 2', 249031),
(390110, 'PTHR24365:SF527', NULL, NULL, NULL, NULL, 'TOLL-LIKE RECEPTOR 11', 249031),
(390111, 'PTHR24365:SF521', NULL, NULL, NULL, NULL, 'TOLL-LIKE RECEPTOR 4', 249031),
(390112, 'PTHR24365:SF422', NULL, NULL, NULL, NULL, 'TOLL-LIKE RECEPTOR 6', 249031),
(390113, 'PTHR24365', NULL, NULL, NULL, NULL, 'TOLL-LIKE RECEPTOR', 249031),
(390114, 'PTHR24365:SF545', NULL, NULL, NULL, NULL, 'TOLL-LIKE RECEPTOR 12', 249031),
(390115, 'PTHR24365:SF522', NULL, NULL, NULL, NULL, 'TOLL-LIKE RECEPTOR 13', 249031),
(390116, 'PTHR24365:SF544', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 249031),
(390117, 'PTHR24365:SF23', NULL, NULL, NULL, NULL, 'TOLL-LIKE RECEPTOR 10', 249031),
(390118, 'PTHR24365:SF539', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 249031),
(390119, 'PTHR24365:SF26', NULL, NULL, NULL, NULL, 'TOLL-LIKE RECEPTOR 18', 249031),
(390120, 'PTHR11985:SF33', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE DEHYDROGENASE', 249032),
(390121, 'PTHR11985:SF11', NULL, NULL, NULL, NULL, 'DEHYDROGENASE (FAD-DEPENDENT), PUTATIVE-RELATED', 249032),
(390122, 'PTHR11985:SF32', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE DEHYDROGENASE', 249032),
(390123, 'PTHR11985:SF10', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE DEHYDROGENASE', 249032),
(390124, 'PTHR11985:SF35', NULL, NULL, NULL, NULL, 'ANAEROBIC GLYCEROL-3-PHOSPHATE DEHYDROGENASE SUBUNIT A', 249032),
(390125, 'PTHR11985', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE DEHYDROGENASE', 249032),
(390126, 'PTHR11985:SF31', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE DEHYDROGENASE 2', 249032);
INSERT INTO "PUBLIC"."MODEL" VALUES
(390127, 'PTHR11985:SF30', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE DEHYDROGENASE', 249032),
(390128, 'PTHR11985:SF29', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE DEHYDROGENASE, MITOCHONDRIAL', 249032),
(390129, 'PTHR11985:SF15', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE DEHYDROGENASE, MITOCHONDRIAL', 249032),
(390130, 'PTHR11985:SF26', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE DEHYDROGENASE', 249032),
(390131, 'PTHR11985:SF25', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE DEHYDROGENASE, MITOCHONDRIAL', 249032),
(390132, 'PTHR47385:SF9', NULL, NULL, NULL, NULL, 'CALPONIN-HOMOLOGY (CH) DOMAIN-CONTAINING PROTEIN', 249033),
(390133, 'PTHR47385:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG16761', 249033),
(390134, 'PTHR47385:SF7', NULL, NULL, NULL, NULL, 'CALPONIN-2', 249033),
(390135, 'PTHR47385:SF6', NULL, NULL, NULL, NULL, 'TRANSGELIN', 249033),
(390136, 'PTHR47385:SF5', NULL, NULL, NULL, NULL, 'TRANSGELIN', 249033),
(390137, 'PTHR47385:SF10', NULL, NULL, NULL, NULL, 'TRANSGELIN-3', 249033),
(390138, 'PTHR47385:SF21', NULL, NULL, NULL, NULL, 'CALPONIN-HOMOLOGY (CH) DOMAIN-CONTAINING PROTEIN', 249033),
(390139, 'PTHR47385:SF20', NULL, NULL, NULL, NULL, 'TRANSGELIN-2', 249033),
(390140, 'PTHR47385:SF12', NULL, NULL, NULL, NULL, 'CALPONIN-1', 249033),
(390141, 'PTHR47385:SF23', NULL, NULL, NULL, NULL, 'CALPONIN-LIKE PROTEINS', 249033),
(390142, 'PTHR47385:SF11', NULL, NULL, NULL, NULL, 'PROTEIN UNC-87', 249033),
(390143, 'PTHR47385:SF22', NULL, NULL, NULL, NULL, 'GH21596P', 249033),
(390144, 'PTHR47385:SF18', NULL, NULL, NULL, NULL, 'CALPONIN', 249033),
(390145, 'PTHR47385:SF17', NULL, NULL, NULL, NULL, 'CALPONIN-3', 249033),
(390146, 'PTHR47385:SF19', NULL, NULL, NULL, NULL, 'TRANSGELIN', 249033),
(390147, 'PTHR47385:SF14', NULL, NULL, NULL, NULL, 'MUSCLE-SPECIFIC PROTEIN 20', 249033),
(390148, 'PTHR47385', NULL, NULL, NULL, NULL, 'CALPONIN', 249033),
(390149, 'PTHR47385:SF13', NULL, NULL, NULL, NULL, 'CALPONIN', 249033),
(390150, 'PTHR47385:SF16', NULL, NULL, NULL, NULL, 'TRANSGELIN', 249033),
(390151, 'PTHR47385:SF15', NULL, NULL, NULL, NULL, 'CALPONIN-HOMOLOGY (CH) DOMAIN-CONTAINING PROTEIN', 249033),
(390152, 'PTHR46007:SF10', NULL, NULL, NULL, NULL, '', 249034),
(390153, 'PTHR46007:SF7', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 12', 249034),
(390154, 'PTHR46007:SF9', NULL, NULL, NULL, NULL, 'AT HOOK TRANSCRIPTION FACTOR FAMILY-RELATED', 249034),
(390155, 'PTHR46007:SF8', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 12', 249034),
(390156, 'PTHR46007:SF3', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 12-LIKE PROTEIN', 249034),
(390157, 'PTHR46007:SF2', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 12', 249034),
(390158, 'PTHR46007', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 12', 249034),
(390159, 'PTHR12705', NULL, NULL, NULL, NULL, 'ORIGIN RECOGNITION COMPLEX SUBUNIT 5', 249035),
(390160, 'PTHR12705:SF0', NULL, NULL, NULL, NULL, 'ORIGIN RECOGNITION COMPLEX SUBUNIT 5', 249035),
(390161, 'PTHR43209:SF1', NULL, NULL, NULL, NULL, 'TRNA SULFURTRANSFERASE', 249036),
(390162, 'PTHR43209', NULL, NULL, NULL, NULL, 'TRNA SULFURTRANSFERASE', 249036),
(390163, 'PTHR38016:SF1', NULL, NULL, NULL, NULL, 'LCIB_C_CA DOMAIN-CONTAINING PROTEIN', 249037),
(390164, 'PTHR38016', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', 249037),
(390165, 'PTHR23138:SF91', NULL, NULL, NULL, NULL, 'RAN-BINDING PROTEIN 3', 249038),
(390166, 'PTHR23138:SF161', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN-RELATED', 249038),
(390167, 'PTHR23138:SF140', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP50B-LIKE', 249038),
(390168, 'PTHR23138:SF160', NULL, NULL, NULL, NULL, 'RAN BINDING PROTEIN 1', 249038),
(390169, 'PTHR23138:SF165', NULL, NULL, NULL, NULL, 'NUCLEOPORIN NUP61', 249038),
(390170, 'PTHR23138:SF166', NULL, NULL, NULL, NULL, 'RAN-BINDING PROTEIN 1 HOMOLOG B-LIKE', 249038),
(390171, 'PTHR23138:SF141', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP50', 249038);
INSERT INTO "PUBLIC"."MODEL" VALUES
(390172, 'PTHR23138:SF142', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP50A-RELATED', 249038),
(390173, 'PTHR23138:SF164', NULL, NULL, NULL, NULL, 'RAN-BINDING PROTEIN 1 HOMOLOG C-LIKE', 249038),
(390174, 'PTHR23138:SF169', NULL, NULL, NULL, NULL, 'E3 SUMO-PROTEIN LIGASE RANBP2', 249038),
(390175, 'PTHR23138:SF147', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP50', 249038),
(390176, 'PTHR23138:SF148', NULL, NULL, NULL, NULL, 'RANBD1 DOMAIN-CONTAINING PROTEIN', 249038),
(390177, 'PTHR23138:SF167', NULL, NULL, NULL, NULL, 'OS05G0350600 PROTEIN', 249038),
(390178, 'PTHR23138:SF101', NULL, NULL, NULL, NULL, 'NUCLEOPORIN NUP2', 249038),
(390179, 'PTHR23138:SF145', NULL, NULL, NULL, NULL, 'RANBD1 DOMAIN-CONTAINING PROTEIN', 249038),
(390180, 'PTHR23138:SF168', NULL, NULL, NULL, NULL, 'RANBP2-LIKE AND GRIP DOMAIN-CONTAINING PROTEIN 1-RELATED', 249038),
(390181, 'PTHR23138:SF149', NULL, NULL, NULL, NULL, 'RANBD1 DOMAIN-CONTAINING PROTEIN', 249038),
(390182, 'PTHR23138:SF88', NULL, NULL, NULL, NULL, 'RAN-BINDING PROTEIN 3-LIKE', 249038),
(390183, 'PTHR23138:SF87', NULL, NULL, NULL, NULL, 'RAN-SPECIFIC GTPASE-ACTIVATING PROTEIN 1-RELATED', 249038),
(390184, 'PTHR23138:SF150', NULL, NULL, NULL, NULL, 'RANBD1 DOMAIN-CONTAINING PROTEIN', 249038),
(390185, 'PTHR23138:SF172', NULL, NULL, NULL, NULL, 'BREFELDIN A RESISTANCE PROTEIN', 249038),
(390186, 'PTHR23138:SF151', NULL, NULL, NULL, NULL, 'LD02979P', 249038),
(390187, 'PTHR23138:SF173', NULL, NULL, NULL, NULL, 'PROTEIN EXPORT PROTEIN YRB2, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G10810)-RELATED', 249038),
(390188, 'PTHR23138:SF170', NULL, NULL, NULL, NULL, 'RANBD1 DOMAIN-CONTAINING PROTEIN', 249038),
(390189, 'PTHR23138:SF171', NULL, NULL, NULL, NULL, 'RANBD1 DOMAIN-CONTAINING PROTEIN', 249038),
(390190, 'PTHR23138:SF133', NULL, NULL, NULL, NULL, 'RAN-BINDING PROTEIN 1 HOMOLOG A', 249038),
(390191, 'PTHR23138:SF155', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1700123L14 GENE', 249038),
(390192, 'PTHR23138:SF174', NULL, NULL, NULL, NULL, 'PROTEIN (RANBP), PUTATIVE-RELATED', 249038),
(390193, 'PTHR23138:SF152', NULL, NULL, NULL, NULL, 'RANBD1 DOMAIN-CONTAINING PROTEIN', 249038),
(390194, 'PTHR23138:SF175', NULL, NULL, NULL, NULL, 'E3 SUMO-PROTEIN LIGASE RANBP2-RELATED', 249038),
(390195, 'PTHR23138', NULL, NULL, NULL, NULL, 'RAN BINDING PROTEIN', 249038),
(390196, 'PTHR23138:SF135', NULL, NULL, NULL, NULL, 'RAN-SPECIFIC GTPASE-ACTIVATING PROTEIN', 249038),
(390197, 'PTHR23138:SF138', NULL, NULL, NULL, NULL, 'RANBD1 DOMAIN-CONTAINING PROTEIN', 249038),
(390198, 'PTHR23138:SF94', NULL, NULL, NULL, NULL, 'RAN-SPECIFIC GTPASE-ACTIVATING PROTEIN', 249038),
(390199, 'PTHR13268:SF10', NULL, NULL, NULL, NULL, 'BCAS3 DOMAIN-CONTAINING PROTEIN', 249039),
(390200, 'PTHR13268:SF12', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 18H', 249039),
(390201, 'PTHR13268:SF13', NULL, NULL, NULL, NULL, 'BCAS3 DOMAIN-CONTAINING PROTEIN', 249039),
(390202, 'PTHR13268:SF14', NULL, NULL, NULL, NULL, 'BNAA09G15650D PROTEIN', 249039),
(390203, 'PTHR13268:SF15', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 18F-LIKE', 249039),
(390204, 'PTHR13268:SF16', NULL, NULL, NULL, NULL, 'ATG18-LIKE PROTEIN-RELATED', 249039),
(390205, 'PTHR13268:SF7', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 18F', 249039),
(390206, 'PTHR13268', NULL, NULL, NULL, NULL, 'BREAST CARCINOMA AMPLIFIED SEQUENCE 3', 249039),
(390207, 'PTHR13268:SF0', NULL, NULL, NULL, NULL, 'BCAS3 MICROTUBULE ASSOCIATED CELL MIGRATION FACTOR', 249039),
(390208, 'PTHR47144:SF1', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING PROTEIN 12', 249040),
(390209, 'PTHR47144', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING PROTEIN 12', 249040),
(390210, 'PTHR23507', NULL, NULL, NULL, NULL, 'ZGC:174356', 249041),
(390211, 'PTHR23507:SF32', NULL, NULL, NULL, NULL, 'SI:DKEY-5G14.1', 249041),
(390212, 'PTHR23507:SF31', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G14230)-RELATED', 249041),
(390213, 'PTHR23507:SF40', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE-RELATED', 249041);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(390214, 'PTHR23507:SF3', NULL, NULL, NULL, NULL, 'THYMIC STROMAL COTRANSPORTER HOMOLOG', 249041),
(390215, 'PTHR23507:SF2', NULL, NULL, NULL, NULL, 'PROTON-COUPLED FOLATE TRANSPORTER', 249041),
(390216, 'PTHR23507:SF1', NULL, NULL, NULL, NULL, 'ZGC:174356', 249041),
(390217, 'PTHR23507:SF6', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY RELATED', 249041),
(390218, 'PTHR23507:SF36', NULL, NULL, NULL, NULL, 'THYMIC STROMAL COTRANSPORTER HOMOLOG', 249041),
(390219, 'PTHR23507:SF13', NULL, NULL, NULL, NULL, '', 249041),
(390220, 'PTHR23507:SF9', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 46 MEMBER 3', 249041),
(390221, 'PTHR23507:SF11', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY RELATED', 249041),
(390222, 'PTHR23507:SF8', NULL, NULL, NULL, NULL, '', 249041),
(390223, 'PTHR23507:SF39', NULL, NULL, NULL, NULL, 'GH23453P-RELATED', 249041),
(390224, 'PTHR23507:SF27', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY RELATED', 249041),
(390225, 'PTHR23507:SF37', NULL, NULL, NULL, NULL, 'GH08173P', 249041),
(390226, 'PTHR31198', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 84', 249042),
(390227, 'PTHR31198:SF1', NULL, NULL, NULL, NULL, 'CENTROSOMAL AT-AC SPLICING FACTOR', 249042),
(390228, 'PTHR36191', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN-RELATED', 249043),
(390229, 'PTHR36191:SF4', NULL, NULL, NULL, NULL, '', 249043),
(390230, 'PTHR36191:SF1', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 249043),
(390231, 'PTHR36191:SF8', NULL, NULL, NULL, NULL, '', 249043),
(390232, 'PTHR36191:SF10', NULL, NULL, NULL, NULL, '', 249043),
(390233, 'PTHR36191:SF11', NULL, NULL, NULL, NULL, '', 249043),
(390234, 'PTHR36191:SF9', NULL, NULL, NULL, NULL, '', 249043),
(390235, 'PTHR10615:SF180', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE SAS2', 249044),
(390236, 'PTHR10615:SF186', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE', 249044),
(390237, 'PTHR10615:SF164', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE', 249044),
(390238, 'PTHR10615:SF161', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE KAT5', 249044),
(390239, 'PTHR10615:SF102', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE', 249044),
(390240, 'PTHR10615:SF127', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER SUPERFAMILY PROTEIN', 249044),
(390241, 'PTHR10615:SF203', NULL, NULL, NULL, NULL, '', 249044),
(390242, 'PTHR10615:SF208', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE', 249044),
(390243, 'PTHR10615:SF82', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE KAT8', 249044),
(390244, 'PTHR10615:SF209', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE OF THE MYST FAMILY 1', 249044),
(390245, 'PTHR10615:SF26', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE KAT6A', 249044),
(390246, 'PTHR10615:SF170', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE ATXR5', 249044),
(390247, 'PTHR10615:SF190', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN EHD3', 249044),
(390248, 'PTHR10615:SF174', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN 10', 249044),
(390249, 'PTHR10615:SF175', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE ATXR6', 249044),
(390250, 'PTHR10615:SF194', NULL, NULL, NULL, NULL, 'PHD FINGER FAMILY PROTEIN-RELATED', 249044),
(390251, 'PTHR10615:SF172', NULL, NULL, NULL, NULL, 'OS04G0425100 PROTEIN', 249044),
(390252, 'PTHR10615:SF173', NULL, NULL, NULL, NULL, 'PHD FINGER FAMILY PROTEIN', 249044),
(390253, 'PTHR10615:SF211', NULL, NULL, NULL, NULL, 'MYST-TYPE HAT DOMAIN-CONTAINING PROTEIN', 249044),
(390254, 'PTHR10615', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE', 249044),
(390255, 'PTHR10615:SF212', NULL, NULL, NULL, NULL, 'ZINC FINGER SUPERFAMILY PROTEIN, PUTATIVE ISOFORM 1-RELATED', 249044),
(390256, 'PTHR10615:SF176', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD-TYPE ZINC FINGER FAMILY PROTEIN', 249044),
(390257, 'PTHR10615:SF210', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE KAT7', 249044),
(390258, 'PTHR10615:SF215', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE OF THE MYST FAMILY 2', 249044);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(390259, 'PTHR10615:SF216', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE KAT7', 249044),
(390260, 'PTHR10615:SF213', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE', 249044),
(390261, 'PTHR10615:SF214', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE', 249044),
(390262, 'PTHR10615:SF73', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE KAT6B', 249044),
(390263, 'PTHR12860:SF0', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE SUBUNIT SRP68', 249045),
(390264, 'PTHR12860', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE 68 KDA PROTEIN', 249045),
(390265, 'PTHR31481:SF0', NULL, NULL, NULL, NULL, 'RELT-LIKE PROTEIN 2', 249046),
(390266, 'PTHR31481', NULL, NULL, NULL, NULL, 'RELT-LIKE PROTEIN 2 RELL2', 249046),
(390267, 'PTHR30595:SF6', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 249047),
(390268, 'PTHR30595:SF13', NULL, NULL, NULL, NULL, 'ALBA_2 DOMAIN-CONTAINING PROTEIN', 249047),
(390269, 'PTHR30595', NULL, NULL, NULL, NULL, 'GLPR-RELATED TRANSCRIPTIONAL REPRESSOR', 249047),
(390270, 'PTHR14890', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA CORE COMPLEX-ASSOCIATED PROTEIN 100', 249048),
(390271, 'PTHR14890:SF1', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA CORE COMPLEX-ASSOCIATED PROTEIN 100', 249048),
(390272, 'PTHR48049:SF60', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 91B1', 249049),
(390273, 'PTHR48049:SF61', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 71B5', 249049),
(390274, 'PTHR48049:SF62', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390275, 'PTHR48049:SF63', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 72C1', 249049),
(390276, 'PTHR48049:SF64', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390277, 'PTHR48049:SF65', NULL, NULL, NULL, NULL, 'ANTHOCYANIDIN 3-O-GLUCOSYLTRANSFERASE', 249049),
(390278, 'PTHR48049:SF66', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390279, 'PTHR48049:SF67', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 79B30', 249049),
(390280, 'PTHR48049:SF68', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 71C5', 249049),
(390281, 'PTHR48049:SF69', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390282, 'PTHR48049:SF117', NULL, NULL, NULL, NULL, '7-DEOXYLOGANETIC ACID GLUCOSYLTRANSFERASE-LIKE ISOFORM X1', 249049),
(390283, 'PTHR48049:SF116', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390284, 'PTHR48049:SF119', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390285, 'PTHR48049:SF118', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390286, 'PTHR48049:SF115', NULL, NULL, NULL, NULL, 'ANTHOCYANIDIN 3-O-GLUCOSYLTRANSFERASE', 249049),
(390287, 'PTHR48049:SF114', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390288, 'PTHR48049:SF110', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390289, 'PTHR48049:SF70', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 249049),
(390290, 'PTHR48049:SF71', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390291, 'PTHR48049:SF72', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390292, 'PTHR48049:SF73', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390293, 'PTHR48049:SF74', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390294, 'PTHR48049:SF75', NULL, NULL, NULL, NULL, 'UDP-RHAMNOSE:RHAMNOSYLTRANSFERASE 1-RELATED', 249049),
(390295, 'PTHR48049:SF76', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 71B6', 249049),
(390296, 'PTHR48049:SF77', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 79B6', 249049),
(390297, 'PTHR48049:SF128', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390298, 'PTHR48049:SF127', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390299, 'PTHR48049:SF129', NULL, NULL, NULL, NULL, 'UDP-GLUCOSYLTRANSFERASE', 249049),
(390300, 'PTHR48049:SF124', NULL, NULL, NULL, NULL, 'OS11G0202500 PROTEIN', 249049),
(390301, 'PTHR48049:SF123', NULL, NULL, NULL, NULL, 'SOYASAPOGENOL B GLUCURONIDE GALACTOSYLTRANSFERASE-RELATED', 249049),
(390302, 'PTHR48049:SF126', NULL, NULL, NULL, NULL, 'ANTHOCYANIDIN 3-O-GLUCOSIDE 2''''-O-GLUCOSYLTRANSFERASE-RELATED', 249049);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(390303, 'PTHR48049:SF125', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390304, 'PTHR48049:SF120', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 71B2', 249049),
(390305, 'PTHR48049:SF122', NULL, NULL, NULL, NULL, 'SOYASAPONIN III RHAMNOSYLTRANSFERASE-RELATED', 249049),
(390306, 'PTHR48049:SF121', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390307, 'PTHR48049:SF80', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390308, 'PTHR48049:SF83', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390309, 'PTHR48049:SF84', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 79A6', 249049),
(390310, 'PTHR48049:SF85', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390311, 'PTHR48049:SF88', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390312, 'PTHR48049:SF89', NULL, NULL, NULL, NULL, 'OS03G0757000 PROTEIN', 249049),
(390313, 'PTHR48049:SF139', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390314, 'PTHR48049:SF138', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 91C1', 249049),
(390315, 'PTHR48049:SF135', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390316, 'PTHR48049:SF134', NULL, NULL, NULL, NULL, 'GLYCO_TRANS_4-LIKE_N DOMAIN-CONTAINING PROTEIN', 249049),
(390317, 'PTHR48049:SF137', NULL, NULL, NULL, NULL, 'ANTHOCYANIDIN 3-O-GLUCOSYLTRANSFERASE 2-LIKE', 249049),
(390318, 'PTHR48049:SF136', NULL, NULL, NULL, NULL, 'UDPGT DOMAIN-CONTAINING PROTEIN', 249049),
(390319, 'PTHR48049:SF131', NULL, NULL, NULL, NULL, 'FLAVONOL 3-O-GLUCOSYLTRANSFERASE UGT71C4', 249049),
(390320, 'PTHR48049:SF130', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 79B7-RELATED', 249049),
(390321, 'PTHR48049:SF133', NULL, NULL, NULL, NULL, 'GT2', 249049),
(390322, 'PTHR48049:SF132', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 88A1', 249049),
(390323, 'PTHR48049:SF90', NULL, NULL, NULL, NULL, '', 249049),
(390324, 'PTHR48049:SF91', NULL, NULL, NULL, NULL, 'ANTHOCYANIDIN 3-O-GLUCOSIDE 2''''''-O-XYLOSYLTRANSFERASE-RELATED', 249049),
(390325, 'PTHR48049:SF94', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390326, 'PTHR48049:SF98', NULL, NULL, NULL, NULL, '', 249049),
(390327, 'PTHR48049:SF99', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390328, 'PTHR48049:SF11', NULL, NULL, NULL, NULL, 'OS09G0119600 PROTEIN', 249049),
(390329, 'PTHR48049:SF12', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390330, 'PTHR48049:SF13', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390331, 'PTHR48049:SF14', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390332, 'PTHR48049:SF15', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390333, 'PTHR48049:SF149', NULL, NULL, NULL, NULL, 'SOYASAPOGENOL B GLUCURONIDE GALACTOSYLTRANSFERASE-RELATED', 249049),
(390334, 'PTHR48049:SF146', NULL, NULL, NULL, NULL, 'GLUCOSYL TRANSFERASE-RELATED', 249049),
(390335, 'PTHR48049:SF145', NULL, NULL, NULL, NULL, 'UDP-GLUCOSYLTRANSFERASE', 249049),
(390336, 'PTHR48049:SF148', NULL, NULL, NULL, NULL, 'SOYASAPONIN III RHAMNOSYLTRANSFERASE', 249049),
(390337, 'PTHR48049:SF147', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390338, 'PTHR48049:SF142', NULL, NULL, NULL, NULL, 'SCOPOLETIN GLUCOSYLTRANSFERASE-LIKE', 249049),
(390339, 'PTHR48049:SF141', NULL, NULL, NULL, NULL, 'OS07G0201500 PROTEIN', 249049),
(390340, 'PTHR48049:SF144', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390341, 'PTHR48049:SF143', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390342, 'PTHR48049:SF140', NULL, NULL, NULL, NULL, 'OS03G0757500 PROTEIN', 249049),
(390343, 'PTHR48049:SF20', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 79B4-RELATED', 249049),
(390344, 'PTHR48049:SF21', NULL, NULL, NULL, NULL, 'SOYASAPOGENOL B GLUCURONIDE GALACTOSYLTRANSFERASE', 249049),
(390345, 'PTHR48049', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390346, 'PTHR48049:SF23', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 71D1-RELATED', 249049),
(390347, 'PTHR48049:SF24', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390348, 'PTHR48049:SF25', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 249049); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(390349, 'PTHR48049:SF27', NULL, NULL, NULL, NULL, 'ANTHOCYANIDIN 3-O-GLUCOSYLTRANSFERASE 7-LIKE ISOFORM X1', 249049),
(390350, 'PTHR48049:SF28', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390351, 'PTHR48049:SF29', NULL, NULL, NULL, NULL, 'FLAVONOL 3-O-GLUCOSYLTRANSFERASE-RELATED', 249049),
(390352, 'PTHR48049:SF157', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390353, 'PTHR48049:SF156', NULL, NULL, NULL, NULL, '7-DEOXYLOGANETIC ACID GLUCOSYLTRANSFERASE-LIKE', 249049),
(390354, 'PTHR48049:SF159', NULL, NULL, NULL, NULL, 'OS10G0332000 PROTEIN', 249049),
(390355, 'PTHR48049:SF158', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390356, 'PTHR48049:SF153', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390357, 'PTHR48049:SF152', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390358, 'PTHR48049:SF155', NULL, NULL, NULL, NULL, '', 249049),
(390359, 'PTHR48049:SF154', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390360, 'PTHR48049:SF151', NULL, NULL, NULL, NULL, '', 249049),
(390361, 'PTHR48049:SF150', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390362, 'PTHR48049:SF30', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390363, 'PTHR48049:SF31', NULL, NULL, NULL, NULL, 'SOYASAPOGENOL B GLUCURONIDE GALACTOSYLTRANSFERASE-RELATED', 249049),
(390364, 'PTHR48049:SF32', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 92A1', 249049),
(390365, 'PTHR48049:SF34', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390366, 'PTHR48049:SF35', NULL, NULL, NULL, NULL, 'UDP-GLUCOSYL TRANSFERASE 73B2-RELATED', 249049),
(390367, 'PTHR48049:SF37', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 73B4-RELATED', 249049),
(390368, 'PTHR48049:SF164', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390369, 'PTHR48049:SF163', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390370, 'PTHR48049:SF165', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390371, 'PTHR48049:SF160', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 91A1', 249049),
(390372, 'PTHR48049:SF162', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390373, 'PTHR48049:SF161', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390374, 'PTHR48049:SF1', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE SUPERFAMILY PROTEIN', 249049),
(390375, 'PTHR48049:SF41', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390376, 'PTHR48049:SF5', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390377, 'PTHR48049:SF43', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 71B1', 249049),
(390378, 'PTHR48049:SF44', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390379, 'PTHR48049:SF45', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390380, 'PTHR48049:SF9', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390381, 'PTHR48049:SF47', NULL, NULL, NULL, NULL, 'FLAVONOL 3-O-GLUCOSYLTRANSFERASE UGT71C1-RELATED', 249049),
(390382, 'PTHR48049:SF7', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 73B1', 249049),
(390383, 'PTHR48049:SF48', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 71B7-RELATED', 249049),
(390384, 'PTHR48049:SF49', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390385, 'PTHR48049:SF52', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 79B2-RELATED', 249049),
(390386, 'PTHR48049:SF53', NULL, NULL, NULL, NULL, 'UDP-GLUCOSYLTRANSFERASE 73B2', 249049),
(390387, 'PTHR48049:SF54', NULL, NULL, NULL, NULL, 'SOYASAPOGENOL B GLUCURONIDE GALACTOSYLTRANSFERASE-RELATED', 249049),
(390388, 'PTHR48049:SF56', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390389, 'PTHR48049:SF57', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 91A1-LIKE', 249049),
(390390, 'PTHR48049:SF58', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 71C3', 249049),
(390391, 'PTHR48049:SF59', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390392, 'PTHR48049:SF107', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249049),
(390393, 'PTHR46272', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 249050);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(390394, 'PTHR46272:SF1', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 142-RELATED', 249050),
(390395, 'PTHR46272:SF3', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 139-RELATED', 249050),
(390396, 'PTHR46272:SF2', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 249050),
(390397, 'PTHR46272:SF5', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 249050),
(390398, 'PTHR46272:SF4', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 249050),
(390399, 'PTHR35558', NULL, NULL, NULL, NULL, 'SGNH_HYDRO DOMAIN-CONTAINING PROTEIN', 249051),
(390400, 'PTHR35558:SF1', NULL, NULL, NULL, NULL, 'SGNH_HYDRO DOMAIN-CONTAINING PROTEIN', 249051),
(390401, 'PTHR37339:SF1', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 29', 249052),
(390402, 'PTHR37339', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 29', 249052),
(390403, 'PTHR16015:SF0', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 51', 249053),
(390404, 'PTHR16015', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 51', 249053),
(390405, 'PTHR16047:SF7', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RFWD3', 249054),
(390406, 'PTHR16047:SF13', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 249054),
(390407, 'PTHR16047:SF10', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN', 249054),
(390408, 'PTHR16047', NULL, NULL, NULL, NULL, 'RFWD3 PROTEIN', 249054),
(390409, 'PTHR30213', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 249055),
(390410, 'PTHR30213:SF0', NULL, NULL, NULL, NULL, 'UPF0761 MEMBRANE PROTEIN YIHY', 249055),
(390411, 'PTHR30213:SF1', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YHJD', 249055),
(390412, 'PTHR32266:SF16', NULL, NULL, NULL, NULL, 'NICOTIANAMINE SYNTHASE 4-RELATED', 249056),
(390413, 'PTHR32266:SF15', NULL, NULL, NULL, NULL, '', 249056),
(390414, 'PTHR32266:SF18', NULL, NULL, NULL, NULL, 'NICOTIANAMINE SYNTHASE 2', 249056),
(390415, 'PTHR32266:SF28', NULL, NULL, NULL, NULL, 'NICOTIANAMINE SYNTHASE, S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASE-RELATED', 249056),
(390416, 'PTHR32266:SF17', NULL, NULL, NULL, NULL, 'SYNTHASE, PUTATIVE-RELATED', 249056),
(390417, 'PTHR32266:SF12', NULL, NULL, NULL, NULL, 'NICOTIANAMINE SYNTHASE 3', 249056),
(390418, 'PTHR32266:SF23', NULL, NULL, NULL, NULL, 'NICOTIANAMINE SYNTHASE', 249056),
(390419, 'PTHR32266:SF11', NULL, NULL, NULL, NULL, 'NICOTIANAMINE SYNTHASE', 249056),
(390420, 'PTHR32266:SF22', NULL, NULL, NULL, NULL, 'BNAC09G32590D PROTEIN', 249056),
(390421, 'PTHR32266:SF14', NULL, NULL, NULL, NULL, 'NICOTIANAMINE SYNTHASE 1', 249056),
(390422, 'PTHR32266:SF25', NULL, NULL, NULL, NULL, 'NICOTIANAMINE SYNTHASE 4-RELATED', 249056),
(390423, 'PTHR32266:SF24', NULL, NULL, NULL, NULL, 'NICOTIANAMINE SYNTHASE', 249056),
(390424, 'PTHR32266:SF21', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 249056),
(390425, 'PTHR32266:SF10', NULL, NULL, NULL, NULL, 'NICOTIANAMINE SYNTHASE 2', 249056),
(390426, 'PTHR32266:SF20', NULL, NULL, NULL, NULL, 'NICOTIANAMINE SYNTHASE', 249056),
(390427, 'PTHR32266', NULL, NULL, NULL, NULL, 'NICOTIANAMINE SYNTHASE 3', 249056),
(390428, 'PTHR31248:SF24', NULL, NULL, NULL, NULL, 'RHODOPSIN', 249057),
(390429, 'PTHR31248:SF12', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN A3-LIKE', 249057),
(390430, 'PTHR31248:SF26', NULL, NULL, NULL, NULL, 'RHODOPSIN', 249057),
(390431, 'PTHR31248:SF15', NULL, NULL, NULL, NULL, 'RHODOPSIN', 249057),
(390432, 'PTHR31248:SF25', NULL, NULL, NULL, NULL, '', 249057),
(390433, 'PTHR31248:SF22', NULL, NULL, NULL, NULL, 'BNAC07G18380D PROTEIN', 249057),
(390434, 'PTHR31248:SF6', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249057),
(390435, 'PTHR31248:SF17', NULL, NULL, NULL, NULL, 'ANNEXIN A7-LIKE', 249057),
(390436, 'PTHR31248:SF28', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH TM MODULE STRESS TOLERANCE PROTEIN', 249057),
(390437, 'PTHR31248:SF27', NULL, NULL, NULL, NULL, 'RHODOPSIN', 249057),
(390438, 'PTHR31248:SF19', NULL, NULL, NULL, NULL, '', 249057),
(390439, 'PTHR31248:SF29', NULL, NULL, NULL, NULL, 'BNAA08G07700D PROTEIN', 249057);
INSERT INTO "PUBLIC"."MODEL" VALUES
(390440, 'PTHR31248', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G04290)-RELATED', 249057),
(390441, 'PTHR31248:SF2', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G04290)-RELATED', 249057),
(390442, 'PTHR31066:SF85', NULL, NULL, NULL, NULL, 'PB1 DOMAIN-CONTAINING PROTEIN', 249058),
(390443, 'PTHR31066:SF42', NULL, NULL, NULL, NULL, 'OCTICOSAPEPTIDE/PHOX/BEM1P FAMILY PROTEIN', 249058),
(390444, 'PTHR31066:SF64', NULL, NULL, NULL, NULL, 'PB1 DOMAIN-CONTAINING PROTEIN', 249058),
(390445, 'PTHR31066:SF86', NULL, NULL, NULL, NULL, 'OS04G0284800 PROTEIN', 249058),
(390446, 'PTHR31066:SF83', NULL, NULL, NULL, NULL, 'OCTICOSAPEPTIDE/PHOX/BEM1P FAMILY PROTEIN', 249058),
(390447, 'PTHR31066:SF61', NULL, NULL, NULL, NULL, 'PB1 DOMAIN-CONTAINING PROTEIN-RELATED', 249058),
(390448, 'PTHR31066:SF84', NULL, NULL, NULL, NULL, 'PB1 DOMAIN-CONTAINING PROTEIN', 249058),
(390449, 'PTHR31066:SF62', NULL, NULL, NULL, NULL, 'PB1 DOMAIN-CONTAINING PROTEIN', 249058),
(390450, 'PTHR31066:SF60', NULL, NULL, NULL, NULL, 'PB1 DOMAIN-CONTAINING PROTEIN', 249058),
(390451, 'PTHR31066:SF27', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249058),
(390452, 'PTHR31066:SF47', NULL, NULL, NULL, NULL, 'PB1 DOMAIN-CONTAINING PROTEIN', 249058),
(390453, 'PTHR31066:SF69', NULL, NULL, NULL, NULL, 'PB1 DOMAIN-CONTAINING PROTEIN', 249058),
(390454, 'PTHR31066:SF89', NULL, NULL, NULL, NULL, 'OCTICOSAPEPTIDE/PHOX/BEM1P FAMILY PROTEIN', 249058),
(390455, 'PTHR31066:SF45', NULL, NULL, NULL, NULL, 'OCTICOSAPEPTIDE/PHOX/BEM1P FAMILY PROTEIN', 249058),
(390456, 'PTHR31066:SF68', NULL, NULL, NULL, NULL, 'PB1 DOMAIN-CONTAINING PROTEIN', 249058),
(390457, 'PTHR31066:SF87', NULL, NULL, NULL, NULL, 'PB1 DOMAIN-CONTAINING PROTEIN', 249058),
(390458, 'PTHR31066:SF65', NULL, NULL, NULL, NULL, 'PB1 DOMAIN-CONTAINING PROTEIN', 249058),
(390459, 'PTHR31066:SF66', NULL, NULL, NULL, NULL, 'PB1 DOMAIN PROTEIN', 249058),
(390460, 'PTHR31066:SF88', NULL, NULL, NULL, NULL, 'PB1 DOMAIN-CONTAINING PROTEIN', 249058),
(390461, 'PTHR31066', NULL, NULL, NULL, NULL, 'OS05G0427100 PROTEIN-RELATED', 249058),
(390462, 'PTHR31066:SF96', NULL, NULL, NULL, NULL, 'OCTICOSAPEPTIDE/PHOX/BEM1P', 249058),
(390463, 'PTHR31066:SF74', NULL, NULL, NULL, NULL, 'PB1 DOMAIN-CONTAINING PROTEIN', 249058),
(390464, 'PTHR31066:SF75', NULL, NULL, NULL, NULL, 'PB1 DOMAIN-CONTAINING PROTEIN', 249058),
(390465, 'PTHR31066:SF97', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249058),
(390466, 'PTHR31066:SF94', NULL, NULL, NULL, NULL, 'OS03G0401100 PROTEIN', 249058),
(390467, 'PTHR31066:SF95', NULL, NULL, NULL, NULL, 'GB|AAD14519.1', 249058),
(390468, 'PTHR31066:SF70', NULL, NULL, NULL, NULL, 'OCTICOSAPEPTIDE/PHOX/BEM1P FAMILY PROTEIN-RELATED', 249058),
(390469, 'PTHR31066:SF92', NULL, NULL, NULL, NULL, 'PB1 DOMAIN-CONTAINING PROTEIN', 249058),
(390470, 'PTHR31066:SF71', NULL, NULL, NULL, NULL, 'PB1 DOMAIN-CONTAINING PROTEIN-RELATED', 249058),
(390471, 'PTHR31066:SF93', NULL, NULL, NULL, NULL, 'OCTICOSAPEPTIDE/PHOX/BEM1P FAMILY PROTEIN', 249058),
(390472, 'PTHR31066:SF90', NULL, NULL, NULL, NULL, '', 249058),
(390473, 'PTHR31066:SF91', NULL, NULL, NULL, NULL, 'OS05G0427100 PROTEIN', 249058),
(390474, 'PTHR31066:SF38', NULL, NULL, NULL, NULL, 'PB1 DOMAIN-CONTAINING PROTEIN', 249058),
(390475, 'PTHR31066:SF79', NULL, NULL, NULL, NULL, 'PB1 DOMAIN-CONTAINING PROTEIN', 249058),
(390476, 'PTHR31066:SF57', NULL, NULL, NULL, NULL, 'OCTICOSAPEPTIDE/PHOX/BEM1P FAMILY PROTEIN', 249058),
(390477, 'PTHR31066:SF10', NULL, NULL, NULL, NULL, 'OS11G0444900 PROTEIN', 249058),
(390478, 'PTHR31066:SF76', NULL, NULL, NULL, NULL, 'PB1 DOMAIN-CONTAINING PROTEIN', 249058),
(390479, 'PTHR31066:SF54', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 8-RELATED', 249058),
(390480, 'PTHR31066:SF55', NULL, NULL, NULL, NULL, 'PB1 DOMAIN-CONTAINING PROTEIN', 249058),
(390481, 'PTHR31066:SF33', NULL, NULL, NULL, NULL, 'PB1 DOMAIN-CONTAINING PROTEIN', 249058),
(390482, 'PTHR31066:SF5', NULL, NULL, NULL, NULL, 'PB1 DOMAIN-CONTAINING PROTEIN', 249058);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(390483, 'PTHR11537:SF91', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY G MEMBER 3', 249059),
(390484, 'PTHR11537:SF90', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY G MEMBER 2', 249059),
(390485, 'PTHR11537:SF234', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 249059),
(390486, 'PTHR11537:SF278', NULL, NULL, NULL, NULL, 'SHAW-LIKE, ISOFORM C', 249059),
(390487, 'PTHR11537:SF113', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY A MEMBER 4', 249059),
(390488, 'PTHR11537:SF277', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL, SHAW-RELATED SUBFAMILY, MEMBER 3B', 249059),
(390489, 'PTHR11537:SF114', NULL, NULL, NULL, NULL, 'ION_TRANS DOMAIN-CONTAINING PROTEIN', 249059),
(390490, 'PTHR11537:SF235', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 249059),
(390491, 'PTHR11537:SF279', NULL, NULL, NULL, NULL, 'ION_TRANS DOMAIN-CONTAINING PROTEIN', 249059),
(390492, 'PTHR11537:SF274', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY KQT MEMBER 1', 249059),
(390493, 'PTHR11537:SF44', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY A MEMBER 10', 249059),
(390494, 'PTHR11537:SF88', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY G MEMBER 1', 249059),
(390495, 'PTHR11537:SF155', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY A MEMBER 7', 249059),
(390496, 'PTHR11537:SF276', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL, SUBFAMILY F, MEMBER 1', 249059),
(390497, 'PTHR11537:SF87', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY C MEMBER 1', 249059),
(390498, 'PTHR11537:SF270', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL, SHAKER-RELATED SUBFAMILY, MEMBER 1A', 249059),
(390499, 'PTHR11537:SF271', NULL, NULL, NULL, NULL, 'PROTEIN CBR-KVS-3', 249059),
(390500, 'PTHR11537:SF245', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL PROTEIN EGL-36', 249059),
(390501, 'PTHR11537:SF63', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY B MEMBER 1', 249059),
(390502, 'PTHR11537:SF167', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY G MEMBER 4', 249059),
(390503, 'PTHR11537:SF126', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY C MEMBER 4', 249059),
(390504, 'PTHR11537:SF61', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY S MEMBER 1', 249059),
(390505, 'PTHR11537:SF246', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL, SHAW-RELATED SUBFAMILY, MEMBER 4', 249059),
(390506, 'PTHR11537:SF60', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY S MEMBER 2', 249059),
(390507, 'PTHR11537:SF5', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY KQT MEMBER 3', 249059),
(390508, 'PTHR11537:SF6', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY KQT MEMBER 2', 249059),
(390509, 'PTHR11537:SF121', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 249059),
(390510, 'PTHR11537:SF259', NULL, NULL, NULL, NULL, 'KCNQ POTASSIUM CHANNEL, ISOFORM F', 249059),
(390511, 'PTHR11537:SF134', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY B MEMBER 2', 249059),
(390512, 'PTHR11537:SF28', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY A MEMBER 3', 249059),
(390513, 'PTHR11537', NULL, NULL, NULL, NULL, 'VOLTAGE-GATED POTASSIUM CHANNEL', 249059),
(390514, 'PTHR11537:SF252', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL PROTEIN SHAW', 249059),
(390515, 'PTHR11537:SF23', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY A MEMBER 2', 249059),
(390516, 'PTHR11537:SF174', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY D MEMBER 1', 249059),
(390517, 'PTHR11537:SF65', NULL, NULL, NULL, NULL, 'SI:RP71-39B20.4', 249059),
(390518, 'PTHR11537:SF254', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL PROTEIN SHAB', 249059),
(390519, 'PTHR11537:SF133', NULL, NULL, NULL, NULL, 'PROTEIN CBR-EXP-2', 249059),
(390520, 'PTHR11537:SF171', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY F MEMBER 1', 249059);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(390521, 'PTHR11537:SF173', NULL, NULL, NULL, NULL, 'ION_TRANS DOMAIN-CONTAINING PROTEIN', 249059),
(390522, 'PTHR11537:SF250', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY A MEMBER 5', 249059),
(390523, 'PTHR11537:SF172', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY C MEMBER 2', 249059),
(390524, 'PTHR11537:SF24', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY A MEMBER 1', 249059),
(390525, 'PTHR11537:SF105', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL PROTEIN SHAL', 249059),
(390526, 'PTHR11537:SF40', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY V MEMBER 2', 249059),
(390527, 'PTHR11537:SF104', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY A MEMBER 6', 249059),
(390528, 'PTHR11537:SF39', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY S MEMBER 3', 249059),
(390529, 'PTHR11537:SF262', NULL, NULL, NULL, NULL, 'PROTEIN CBR-KVS-1', 249059),
(390530, 'PTHR11537:SF265', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY D MEMBER 2', 249059),
(390531, 'PTHR11537:SF38', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY V MEMBER 1', 249059),
(390532, 'PTHR11537:SF182', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY D MEMBER 3', 249059),
(390533, 'PTHR11537:SF184', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY C MEMBER 3', 249059),
(390534, 'PTHR12150', NULL, NULL, NULL, NULL, 'CLASS IV SAM-BINDING METHYLTRANSFERASE-RELATED', 249060),
(390535, 'PTHR12150:SF13', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE C9ORF114-RELATED', 249060),
(390536, 'PTHR23098:SF16', NULL, NULL, NULL, NULL, 'NUCLEAR APOPTOSIS-INDUCING FACTOR 1', 249061),
(390537, 'PTHR23098:SF17', NULL, NULL, NULL, NULL, 'NUCLEAR APOPTOSIS-INDUCING FACTOR 1', 249061),
(390538, 'PTHR23098:SF15', NULL, NULL, NULL, NULL, 'NUCLEAR APOPTOSIS-INDUCING FACTOR 1', 249061),
(390539, 'PTHR23098:SF7', NULL, NULL, NULL, NULL, 'NUCLEAR APOPTOSIS-INDUCING FACTOR 1', 249061),
(390540, 'PTHR23098:SF18', NULL, NULL, NULL, NULL, 'NUCLEAR APOPTOSIS-INDUCING FACTOR 1', 249061),
(390541, 'PTHR23098:SF19', NULL, NULL, NULL, NULL, 'T-SNARE DOMAIN CONTAINING 1', 249061),
(390542, 'PTHR23098:SF3', NULL, NULL, NULL, NULL, 'NUCLEAR APOPTOSIS-INDUCING FACTOR 1', 249061),
(390543, 'PTHR23098', NULL, NULL, NULL, NULL, 'AGAP001331-PA-RELATED', 249061),
(390544, 'PTHR35532:SF5', NULL, NULL, NULL, NULL, 'CARB-BD_DOM_FAM9 DOMAIN-CONTAINING PROTEIN', 249062),
(390545, 'PTHR35532', NULL, NULL, NULL, NULL, 'SIMILAR TO POLYHYDROXYALKANOATE DEPOLYMERASE', 249062),
(390546, 'PTHR12882:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR SPT4', 249063),
(390547, 'PTHR12882:SF4', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR SPT4 HOMOLOG 2', 249063),
(390548, 'PTHR12882', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF TY 4', 249063),
(390549, 'PTHR42877:SF1', NULL, NULL, NULL, NULL, 'STERIGMATOCYSTIN BIOSYNTHESIS MONOOXYGENASE STCW-RELATED', 249064),
(390550, 'PTHR42877:SF2', NULL, NULL, NULL, NULL, '', 249064),
(390551, 'PTHR42877:SF4', NULL, NULL, NULL, NULL, 'PYR_REDOX_2 DOMAIN-CONTAINING PROTEIN-RELATED', 249064),
(390552, 'PTHR42877:SF5', NULL, NULL, NULL, NULL, 'L-ORNITHINE N(5)-MONOOXYGENASE', 249064),
(390553, 'PTHR42877:SF6', NULL, NULL, NULL, NULL, 'MONOOXYGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G15050)-RELATED', 249064),
(390554, 'PTHR42877:SF7', NULL, NULL, NULL, NULL, 'MONOOXYGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G03020)-RELATED', 249064),
(390555, 'PTHR42877:SF8', NULL, NULL, NULL, NULL, 'MONOOXYGENASE', 249064),
(390556, 'PTHR42877:SF10', NULL, NULL, NULL, NULL, 'MONOOXYGENASE', 249064),
(390557, 'PTHR42877:SF11', NULL, NULL, NULL, NULL, 'MONOOXYGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G13790)-RELATED', 249064),
(390558, 'PTHR42877:SF12', NULL, NULL, NULL, NULL, 'MONOOXYGENASE', 249064),
(390559, 'PTHR42877:SF13', NULL, NULL, NULL, NULL, '', 249064),
(390560, 'PTHR42877', NULL, NULL, NULL, NULL, '', 249064),
(390561, 'PTHR10906:SF50', NULL, NULL, NULL, NULL, 'SECY PROTEIN TRANSPORT FAMILY PROTEIN', 249065);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(390562, 'PTHR10906:SF40', NULL, NULL, NULL, NULL, 'OS09G0512600 PROTEIN', 249065),
(390563, 'PTHR10906:SF34', NULL, NULL, NULL, NULL, 'PLUG_TRANSLOCON DOMAIN-CONTAINING PROTEIN', 249065),
(390564, 'PTHR10906:SF45', NULL, NULL, NULL, NULL, 'SECY PROTEIN TRANSPORT FAMILY PROTEIN', 249065),
(390565, 'PTHR10906:SF46', NULL, NULL, NULL, NULL, 'F9K20.24 PROTEIN', 249065),
(390566, 'PTHR10906:SF47', NULL, NULL, NULL, NULL, 'TRANSLOCON SUBUNIT SEC61', 249065),
(390567, 'PTHR10906:SF26', NULL, NULL, NULL, NULL, 'OS09G0512000 PROTEIN', 249065),
(390568, 'PTHR10906:SF48', NULL, NULL, NULL, NULL, 'PLUG_TRANSLOCON DOMAIN-CONTAINING PROTEIN', 249065),
(390569, 'PTHR10906:SF41', NULL, NULL, NULL, NULL, 'SECY PROTEIN TRANSPORT FAMILY PROTEIN-RELATED', 249065),
(390570, 'PTHR10906:SF20', NULL, NULL, NULL, NULL, 'PLUG_TRANSLOCON DOMAIN-CONTAINING PROTEIN', 249065),
(390571, 'PTHR10906:SF10', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC61 SUBUNIT ALPHA ISOFORM 2', 249065),
(390572, 'PTHR10906', NULL, NULL, NULL, NULL, 'SECY/SEC61-ALPHA FAMILY MEMBER', 249065),
(390573, 'PTHR10906:SF22', NULL, NULL, NULL, NULL, '', 249065),
(390574, 'PTHR10906:SF33', NULL, NULL, NULL, NULL, 'PLUG_TRANSLOCON DOMAIN-CONTAINING PROTEIN', 249065),
(390575, 'PTHR10906:SF1', NULL, NULL, NULL, NULL, 'DSEC61ALPHA', 249065),
(390576, 'PTHR10906:SF2', NULL, NULL, NULL, NULL, 'PREPROTEIN TRANSLOCASE SUBUNIT SCY2, CHLOROPLASTIC', 249065),
(390577, 'PTHR10906:SF49', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC61 SUBUNIT ALPHA-LIKE', 249065),
(390578, 'PTHR10906:SF19', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC61 SUBUNIT ALPHA ISOFORM 1', 249065),
(390579, 'PTHR10906:SF9', NULL, NULL, NULL, NULL, 'PREPROTEIN TRANSLOCASE SUBUNIT SCY1, CHLOROPLASTIC', 249065),
(390580, 'PTHR10906:SF5', NULL, NULL, NULL, NULL, 'SEC SIXTY-ONE PROTEIN HOMOLOG', 249065),
(390581, 'PTHR20873', NULL, NULL, NULL, NULL, 'L-SERYL-TRNA(SEC) KINASE', 249066),
(390582, 'PTHR20873:SF0', NULL, NULL, NULL, NULL, 'L-SERYL-TRNA(SEC) KINASE', 249066),
(390583, 'PTHR45228', NULL, NULL, NULL, NULL, 'CYCLIC DI-GMP PHOSPHODIESTERASE TM_0186-RELATED', 249067),
(390584, 'PTHR45228:SF8', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR-RELATED', 249067),
(390585, 'PTHR45228:SF9', NULL, NULL, NULL, NULL, '3''3''-CGAMP-SPECIFIC PHOSPHODIESTERASE 2', 249067),
(390586, 'PTHR45228:SF4', NULL, NULL, NULL, NULL, 'LIPOPROTEIN-RELATED', 249067),
(390587, 'PTHR45228:SF5', NULL, NULL, NULL, NULL, 'CYCLIC DI-GMP PHOSPHODIESTERASE VC_1348-RELATED', 249067),
(390588, 'PTHR45228:SF1', NULL, NULL, NULL, NULL, 'CYCLIC DI-GMP PHOSPHODIESTERASE TM_0186', 249067),
(390589, 'PTHR33840:SF2', NULL, NULL, NULL, NULL, 'DUF2235 DOMAIN-CONTAINING PROTEIN', 249068),
(390590, 'PTHR33840:SF1', NULL, NULL, NULL, NULL, 'DUF2235 DOMAIN-CONTAINING PROTEIN', 249068),
(390591, 'PTHR33840:SF15', NULL, NULL, NULL, NULL, 'DUF2235 DOMAIN-CONTAINING PROTEIN', 249068),
(390592, 'PTHR33840', NULL, NULL, NULL, NULL, '', 249068),
(390593, 'PTHR28611:SF1', NULL, NULL, NULL, NULL, 'NORRIN', 249069),
(390594, 'PTHR28611', NULL, NULL, NULL, NULL, 'NORRIN', 249069),
(390595, 'PTHR16719:SF1', NULL, NULL, NULL, NULL, 'CHAPERONE-RELATED', 249070),
(390596, 'PTHR16719:SF11', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE COPPER CHAPERONE', 249070),
(390597, 'PTHR16719:SF10', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE COPPER CHAPERONE 1', 249070),
(390598, 'PTHR16719', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE COPPER CHAPERONE', 249070),
(390599, 'PTHR16719:SF0', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE COPPER CHAPERONE', 249070),
(390600, 'PTHR45333:SF1', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 249071),
(390601, 'PTHR45333', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 249071),
(390602, 'PTHR11076:SF34', NULL, NULL, NULL, NULL, 'PROTEIN UMUC', 249072),
(390603, 'PTHR11076:SF33', NULL, NULL, NULL, NULL, 'DNA POLYMERASE KAPPA', 249072),
(390604, 'PTHR11076:SF35', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN HOMOLOG YOBH', 249072),
(390605, 'PTHR11076', NULL, NULL, NULL, NULL, 'DNA REPAIR POLYMERASE UMUC / TRANSFERASE FAMILY MEMBER', 249072);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(390606, 'PTHR36465:SF1', NULL, NULL, NULL, NULL, 'UBIQUINOL-CYTOCHROME-C REDUCTASE COMPLEX ASSEMBLY FACTOR 3', 249073),
(390607, 'PTHR36465', NULL, NULL, NULL, NULL, 'UBIQUINOL-CYTOCHROME-C REDUCTASE COMPLEX ASSEMBLY FACTOR 3', 249073),
(390608, 'PTHR10137:SF6', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT C', 249074),
(390609, 'PTHR10137:SF5', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT C 1', 249074),
(390610, 'PTHR10137:SF8', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT C', 249074),
(390611, 'PTHR10137', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT C', 249074),
(390612, 'PTHR10137:SF9', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT C', 249074),
(390613, 'PTHR10137:SF10', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT C', 249074),
(390614, 'PTHR10137:SF0', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT C', 249074),
(390615, 'PTHR10137:SF4', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT C 2', 249074),
(390616, 'PTHR35377', NULL, NULL, NULL, NULL, 'ANTITOXIN VAPB49-RELATED-RELATED', 249075),
(390617, 'PTHR35377:SF4', NULL, NULL, NULL, NULL, 'SSL2138 PROTEIN', 249075),
(390618, 'PTHR35377:SF5', NULL, NULL, NULL, NULL, 'ANTITOXIN VAPB46', 249075),
(390619, 'PTHR35377:SF6', NULL, NULL, NULL, NULL, 'ANTITOXIN VAPB22', 249075),
(390620, 'PTHR47879:SF4', NULL, NULL, NULL, NULL, 'RETICULON DOMAIN-CONTAINING PROTEIN', 249076),
(390621, 'PTHR47879', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN B22', 249076),
(390622, 'PTHR47879:SF2', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN B22', 249076),
(390623, 'PTHR47879:SF3', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN B23', 249076),
(390624, 'PTHR44378:SF8', NULL, NULL, NULL, NULL, 'AMP-BINDING DOMAIN-CONTAINING PROTEIN', 249077),
(390625, 'PTHR44378:SF2', NULL, NULL, NULL, NULL, 'ACYL-ACTIVATING ENZYME 17, PEROXISOMAL-RELATED', 249077),
(390626, 'PTHR44378:SF1', NULL, NULL, NULL, NULL, 'ACYL-ACTIVATING ENZYME 18, PEROXISOMAL-RELATED', 249077),
(390627, 'PTHR44378:SF4', NULL, NULL, NULL, NULL, 'ACYL-ACTIVATING ENZYME 18, PEROXISOMAL ISOFORM X1-RELATED', 249077),
(390628, 'PTHR44378:SF3', NULL, NULL, NULL, NULL, 'ENZYME 17, PEROXISOMAL PROTEIN, PUTATIVE-RELATED', 249077),
(390629, 'PTHR44378', NULL, NULL, NULL, NULL, 'ACYL-ACTIVATING ENZYME 17, PEROXISOMAL-RELATED', 249077),
(390630, 'PTHR44378:SF5', NULL, NULL, NULL, NULL, '4-COUMARATE--COA LIGASE', 249077),
(390631, 'PTHR13850:SF1', NULL, NULL, NULL, NULL, 'PLEIOTROPHIN', 249078),
(390632, 'PTHR13850:SF5', NULL, NULL, NULL, NULL, 'PTN_MK_N DOMAIN-CONTAINING PROTEIN', 249078),
(390633, 'PTHR13850', NULL, NULL, NULL, NULL, 'PLEIOTROPHIN FAMILY MEMBER', 249078),
(390634, 'PTHR13850:SF2', NULL, NULL, NULL, NULL, 'MIDKINE', 249078),
(390635, 'PTHR21690:SF2', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 249079),
(390636, 'PTHR21690', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 249079),
(390637, 'PTHR40459:SF1', NULL, NULL, NULL, NULL, 'CONSERVED HYPOTHETICAL ALANINE AND LEUCINE RICH PROTEIN', 249080),
(390638, 'PTHR40459', NULL, NULL, NULL, NULL, 'CONSERVED HYPOTHETICAL ALANINE AND LEUCINE RICH PROTEIN', 249080),
(390639, 'PTHR47138:SF1', NULL, NULL, NULL, NULL, 'PERILIPIN-1', 249081),
(390640, 'PTHR47138', NULL, NULL, NULL, NULL, 'PERILIPIN-1', 249081),
(390641, 'PTHR11670:SF72', NULL, NULL, NULL, NULL, 'ACONITATE HYDRATASE 2, MITOCHONDRIAL', 249082),
(390642, 'PTHR11670:SF71', NULL, NULL, NULL, NULL, 'ACONITATE HYDRATASE', 249082),
(390643, 'PTHR11670:SF70', NULL, NULL, NULL, NULL, 'CYTOPLASMIC-LIKE ACONITATE HYDRATASE', 249082),
(390644, 'PTHR11670:SF32', NULL, NULL, NULL, NULL, 'CYTOPLASMIC ACONITATE HYDRATASE', 249082),
(390645, 'PTHR11670:SF43', NULL, NULL, NULL, NULL, '2-METHYLCITRATE DEHYDRATASE (2-METHYL-TRANS-ACONITATE FORMING)', 249082),
(390646, 'PTHR11670:SF54', NULL, NULL, NULL, NULL, 'CITRATE HYDRO-LYASE', 249082),
(390647, 'PTHR11670:SF31', NULL, NULL, NULL, NULL, 'IRON-RESPONSIVE ELEMENT-BINDING PROTEIN 2', 249082),
(390648, 'PTHR11670:SF63', NULL, NULL, NULL, NULL, 'ACONITATE HYDRATASE', 249082),
(390649, 'PTHR11670:SF62', NULL, NULL, NULL, NULL, 'ACONITATE HYDRATASE 1', 249082);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(390650, 'PTHR11670:SF69', NULL, NULL, NULL, NULL, 'ACONITATE HYDRATASE', 249082),
(390651, 'PTHR11670:SF68', NULL, NULL, NULL, NULL, 'ACONITATE HYDRATASE', 249082),
(390652, 'PTHR11670:SF67', NULL, NULL, NULL, NULL, 'ACONITATE HYDRATASE', 249082),
(390653, 'PTHR11670:SF55', NULL, NULL, NULL, NULL, 'ACONITATE HYDRATASE 3 MITOCHONDRIAL', 249082),
(390654, 'PTHR11670', NULL, NULL, NULL, NULL, 'ACONITASE/IRON-RESPONSIVE ELEMENT FAMILY MEMBER', 249082),
(390655, 'PTHR34999', NULL, NULL, NULL, NULL, '', 249083),
(390656, 'PTHR34999:SF2', NULL, NULL, NULL, NULL, '', 249083),
(390657, 'PTHR34999:SF3', NULL, NULL, NULL, NULL, '', 249083),
(390658, 'PTHR34999:SF4', NULL, NULL, NULL, NULL, '', 249083),
(390659, 'PTHR46781:SF9', NULL, NULL, NULL, NULL, 'GB3_SYNTH DOMAIN-CONTAINING PROTEIN', 249084),
(390660, 'PTHR46781:SF8', NULL, NULL, NULL, NULL, 'ALPHA 1,4-GLYCOSYLTRANSFERASE FAMILY PROTEIN', 249084),
(390661, 'PTHR46781:SF7', NULL, NULL, NULL, NULL, 'ALPHA 1,4-GLYCOSYLTRANSFERASE FAMILY PROTEIN', 249084),
(390662, 'PTHR46781:SF6', NULL, NULL, NULL, NULL, 'ALPHA 1,4-GLYCOSYLTRANSFERASE FAMILY PROTEIN', 249084),
(390663, 'PTHR46781:SF5', NULL, NULL, NULL, NULL, 'ALPHA 1,4-GLYCOSYLTRANSFERASE FAMILY PROTEIN', 249084),
(390664, 'PTHR46781', NULL, NULL, NULL, NULL, 'ALPHA 1,4-GLYCOSYLTRANSFERASE FAMILY PROTEIN', 249084),
(390665, 'PTHR46781:SF2', NULL, NULL, NULL, NULL, 'ALPHA 1,4-GLYCOSYLTRANSFERASE FAMILY PROTEIN', 249084),
(390666, 'PTHR46781:SF12', NULL, NULL, NULL, NULL, 'GB3_SYNTH DOMAIN-CONTAINING PROTEIN', 249084),
(390667, 'PTHR46781:SF10', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE, DXD SUGAR-BINDING MOTIF PROTEIN-RELATED', 249084),
(390668, 'PTHR46781:SF11', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE, DXD SUGAR-BINDING MOTIF PROTEIN-RELATED', 249084),
(390669, 'PTHR10838:SF8', NULL, NULL, NULL, NULL, 'SYNAPTOGYRIN-3', 249085),
(390670, 'PTHR10838:SF7', NULL, NULL, NULL, NULL, 'SYNAPTOGYRIN-1', 249085),
(390671, 'PTHR10838:SF22', NULL, NULL, NULL, NULL, 'SYNAPTOGYRIN-4', 249085),
(390672, 'PTHR10838:SF20', NULL, NULL, NULL, NULL, 'SYNAPTOGYRIN', 249085),
(390673, 'PTHR10838:SF30', NULL, NULL, NULL, NULL, 'SYNAPTOGYRIN-2', 249085),
(390674, 'PTHR10838:SF19', NULL, NULL, NULL, NULL, 'SYNAPTOGYRIN-2 LIKE PROTEIN-RELATED', 249085),
(390675, 'PTHR10838', NULL, NULL, NULL, NULL, 'SYNAPTOGYRIN', 249085),
(390676, 'PTHR35006:SF3', NULL, NULL, NULL, NULL, 'GLYOXALASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_3G06020)', 249086),
(390677, 'PTHR35006:SF2', NULL, NULL, NULL, NULL, 'GLYOXALASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_5G14830)', 249086),
(390678, 'PTHR35006:SF1', NULL, NULL, NULL, NULL, 'BLL2941 PROTEIN', 249086),
(390679, 'PTHR35006', NULL, NULL, NULL, NULL, 'GLYOXALASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_5G14830)', 249086),
(390680, 'PTHR46783', NULL, NULL, NULL, NULL, 'CYTOGLOBIN', 249087),
(390681, 'PTHR46783:SF1', NULL, NULL, NULL, NULL, 'CYTOGLOBIN', 249087),
(390682, 'PTHR13423:SF2', NULL, NULL, NULL, NULL, 'OUT AT FIRST PROTEIN HOMOLOG', 249088),
(390683, 'PTHR13423', NULL, NULL, NULL, NULL, 'OUT AT FIRST', 249088),
(390684, 'PTHR21860:SF2', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR 3C POLYPEPTIDE 6', 249089),
(390685, 'PTHR21860', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIIC TFIIIC , POLYPEPTIDE 6-RELATED', 249089),
(390686, 'PTHR36826', NULL, NULL, NULL, NULL, 'PROTEIN ECM13', 249090),
(390687, 'PTHR36826:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ECM13', 249090),
(390688, 'PTHR31987:SF12', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_3G10910)-RELATED', 249091),
(390689, 'PTHR31987:SF11', NULL, NULL, NULL, NULL, 'DUF2433 DOMAIN-CONTAINING PROTEIN', 249091),
(390690, 'PTHR31987:SF1', NULL, NULL, NULL, NULL, 'GLUTAMINASE A', 249091),
(390691, 'PTHR31987', NULL, NULL, NULL, NULL, 'GLUTAMINASE A-RELATED', 249091),
(390692, 'PTHR31987:SF14', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_6G09910)-RELATED', 249091),
(390693, 'PTHR10778:SF16', NULL, NULL, NULL, NULL, 'NUCLEOTIDE SUGAR TRANSPORTER FAMILY', 249092),
(390694, 'PTHR10778:SF36', NULL, NULL, NULL, NULL, 'UDP-GALACTOSE/UDP-GLUCOSE TRANSPORTER 1', 249092);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(390695, 'PTHR10778:SF13', NULL, NULL, NULL, NULL, 'ADENOSINE 3''-PHOSPHO 5''-PHOSPHOSULFATE TRANSPORTER 1', 249092),
(390696, 'PTHR10778:SF46', NULL, NULL, NULL, NULL, 'UAA TRANSPORTER-RELATED', 249092),
(390697, 'PTHR10778:SF45', NULL, NULL, NULL, NULL, 'UAA TRANSPORTER-RELATED', 249092),
(390698, 'PTHR10778:SF44', NULL, NULL, NULL, NULL, 'UDP-GALACTOSE/UDP-GLUCOSE TRANSPORTER 4-LIKE', 249092),
(390699, 'PTHR10778:SF43', NULL, NULL, NULL, NULL, 'UDP-GALACTOSE/UDP-GLUCOSE TRANSPORTER 2-LIKE', 249092),
(390700, 'PTHR10778:SF10', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 35 MEMBER B1', 249092),
(390701, 'PTHR10778:SF42', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 35 MEMBER B1-RELATED', 249092),
(390702, 'PTHR10778:SF53', NULL, NULL, NULL, NULL, 'BNAA06G09170D PROTEIN', 249092),
(390703, 'PTHR10778:SF18', NULL, NULL, NULL, NULL, '', 249092),
(390704, 'PTHR10778:SF39', NULL, NULL, NULL, NULL, 'UDP-GALACTOSE/UDP-GLUCOSE TRANSPORTER 5-LIKE', 249092),
(390705, 'PTHR10778', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 35 MEMBER B', 249092),
(390706, 'PTHR10778:SF52', NULL, NULL, NULL, NULL, 'UDP-GALACTOSE/UDP-GLUCOSE TRANSPORTER 5B', 249092),
(390707, 'PTHR10778:SF51', NULL, NULL, NULL, NULL, 'UDP-GALACTOSE/UDP-GLUCOSE TRANSPORTER 3', 249092),
(390708, 'PTHR10778:SF50', NULL, NULL, NULL, NULL, 'UDP-GALACTOSE/UDP-GLUCOSE TRANSPORTER 2', 249092),
(390709, 'PTHR10778:SF4', NULL, NULL, NULL, NULL, 'UDP-XYLOSE AND UDP-N-ACETYLGLUCOSAMINE TRANSPORTER', 249092),
(390710, 'PTHR10778:SF8', NULL, NULL, NULL, NULL, 'ADENOSINE 3''-PHOSPHO 5''-PHOSPHOSULFATE TRANSPORTER 2', 249092),
(390711, 'PTHR14586', NULL, NULL, NULL, NULL, 'THIAMINE-TRIPHOSPHATASE', 249093),
(390712, 'PTHR14586:SF1', NULL, NULL, NULL, NULL, 'THIAMINE-TRIPHOSPHATASE', 249093),
(390713, 'PTHR47275:SF3', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT I, CHLOROPLASTIC', 249094),
(390714, 'PTHR47275', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT I, CHLOROPLASTIC', 249094),
(390715, 'PTHR47275:SF1', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT I, CHLOROPLASTIC', 249094),
(390716, 'PTHR37278', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 33-RELATED', 249095),
(390717, 'PTHR37278:SF1', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 33-RELATED', 249095),
(390718, 'PTHR13045:SF0', NULL, NULL, NULL, NULL, '7-METHYLGUANOSINE PHOSPHATE-SPECIFIC 5''-NUCLEOTIDASE', 249096),
(390719, 'PTHR13045:SF14', NULL, NULL, NULL, NULL, 'CYTOSOLIC 5''-NUCLEOTIDASE 3A', 249096),
(390720, 'PTHR13045:SF13', NULL, NULL, NULL, NULL, '7-METHYLGUANOSINE PHOSPHATE-SPECIFIC 5''-NUCLEOTIDASE', 249096),
(390721, 'PTHR13045:SF12', NULL, NULL, NULL, NULL, 'CYTOSOLIC 5''-NUCLEOTIDASE 3A', 249096),
(390722, 'PTHR13045:SF11', NULL, NULL, NULL, NULL, '5''-NUCLEOTIDASE', 249096),
(390723, 'PTHR13045', NULL, NULL, NULL, NULL, '5''-NUCLEOTIDASE', 249096),
(390724, 'PTHR31679', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN PEX30-RELATED', 249097),
(390725, 'PTHR31679:SF3', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN PEX32', 249097),
(390726, 'PTHR31679:SF2', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN PEX30-RELATED', 249097),
(390727, 'PTHR45504', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', 249098),
(390728, 'PTHR45504:SF3', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', 249098),
(390729, 'PTHR45504:SF2', NULL, NULL, NULL, NULL, 'OS02G0693200 PROTEIN', 249098),
(390730, 'PTHR10041:SF8', NULL, NULL, NULL, NULL, 'COLIPASE', 249099),
(390731, 'PTHR10041:SF7', NULL, NULL, NULL, NULL, 'COLIPASE-LIKE PROTEIN 1', 249099),
(390732, 'PTHR10041:SF6', NULL, NULL, NULL, NULL, 'LEUCINE-RICH COLIPASE-LIKE PROTEIN 1', 249099),
(390733, 'PTHR10041:SF5', NULL, NULL, NULL, NULL, 'SALIVARY GLAND PEPTIDE, PUTATIVE-RELATED', 249099),
(390734, 'PTHR10041:SF9', NULL, NULL, NULL, NULL, 'COLIPASE', 249099),
(390735, 'PTHR10041', NULL, NULL, NULL, NULL, 'COLIPASE', 249099),
(390736, 'PTHR10041:SF3', NULL, NULL, NULL, NULL, 'COLIPASE-LIKE PROTEIN 2', 249099),
(390737, 'PTHR47060', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN NOBOX', 249100);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(390738, 'PTHR47060:SF1', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN NOBOX', 249100),
(390739, 'PTHR28218:SF1', NULL, NULL, NULL, NULL, 'VPS4-ASSOCIATED PROTEIN 1', 249101),
(390740, 'PTHR28218', NULL, NULL, NULL, NULL, 'VPS4-ASSOCIATED PROTEIN 1', 249101),
(390741, 'PTHR37035:SF1', NULL, NULL, NULL, NULL, '', 249102),
(390742, 'PTHR37035:SF2', NULL, NULL, NULL, NULL, '', 249102),
(390743, 'PTHR37035:SF4', NULL, NULL, NULL, NULL, '', 249102),
(390744, 'PTHR37035:SF6', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN ZC3H20', 249102),
(390745, 'PTHR37035:SF7', NULL, NULL, NULL, NULL, '', 249102),
(390746, 'PTHR37035', NULL, NULL, NULL, NULL, '', 249102),
(390747, 'PTHR37242:SF4', NULL, NULL, NULL, NULL, 'BNAA03G58270D PROTEIN', 249103),
(390748, 'PTHR37242:SF1', NULL, NULL, NULL, NULL, 'OS09G0569450 PROTEIN', 249103),
(390749, 'PTHR37242', NULL, NULL, NULL, NULL, 'OS09G0569450 PROTEIN', 249103),
(390750, 'PTHR31943:SF14', NULL, NULL, NULL, NULL, 'INTERFERON LAMBDA-1', 249104),
(390751, 'PTHR31943:SF17', NULL, NULL, NULL, NULL, 'INTERFERON LAMBDA-4', 249104),
(390752, 'PTHR31943:SF16', NULL, NULL, NULL, NULL, 'INTERFERON LAMBDA 1', 249104),
(390753, 'PTHR31943', NULL, NULL, NULL, NULL, 'INTERLEUKIN-28 AND 29', 249104),
(390754, 'PTHR31943:SF1', NULL, NULL, NULL, NULL, 'INTERFERON LAMBDA-2-RELATED', 249104),
(390755, 'PTHR31943:SF18', NULL, NULL, NULL, NULL, '', 249104),
(390756, 'PTHR14068:SF4', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT B', 249105),
(390757, 'PTHR14068:SF5', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT B', 249105),
(390758, 'PTHR14068:SF0', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT B', 249105),
(390759, 'PTHR14068', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3  EIF3 -RELATED', 249105),
(390760, 'PTHR35193:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG21974', 249106),
(390761, 'PTHR35193', NULL, NULL, NULL, NULL, 'MUCIN 13A, CELL SURFACE-ASSOCIATED-RELATED', 249106),
(390762, 'PTHR35193:SF6', NULL, NULL, NULL, NULL, 'MAM DOMAIN-CONTAINING PROTEIN', 249106),
(390763, 'PTHR35193:SF5', NULL, NULL, NULL, NULL, 'MUCIN 13A, CELL SURFACE-ASSOCIATED-RELATED', 249106),
(390764, 'PTHR35127:SF1', NULL, NULL, NULL, NULL, 'SORGHUM BICOLOR PROTEIN TARGETED EITHER TO MITOCHONDRIA OR CHLOROPLAST PROTEINS T50848', 249107),
(390765, 'PTHR35127:SF6', NULL, NULL, NULL, NULL, 'BNAC04G24950D PROTEIN', 249107),
(390766, 'PTHR35127:SF5', NULL, NULL, NULL, NULL, '', 249107),
(390767, 'PTHR35127:SF4', NULL, NULL, NULL, NULL, 'SORGHUM BICOLOR PROTEIN TARGETED EITHER TO MITOCHONDRIA OR CHLOROPLAST PROTEINS T50848', 249107),
(390768, 'PTHR35127:SF3', NULL, NULL, NULL, NULL, 'BNAA09G35810D PROTEIN', 249107),
(390769, 'PTHR35127', NULL, NULL, NULL, NULL, 'OS03G0736900 PROTEIN', 249107),
(390770, 'PTHR11271:SF6', NULL, NULL, NULL, NULL, 'GUANINE DEAMINASE', 249108),
(390771, 'PTHR11271:SF37', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G00460)-RELATED', 249108),
(390772, 'PTHR11271:SF48', NULL, NULL, NULL, NULL, 'AMIDOHYDRO-REL DOMAIN-CONTAINING PROTEIN', 249108),
(390773, 'PTHR11271', NULL, NULL, NULL, NULL, 'GUANINE DEAMINASE', 249108),
(390774, 'PTHR11271:SF49', NULL, NULL, NULL, NULL, 'GUANINE DEAMINASE', 249108),
(390775, 'PTHR15895:SF12', NULL, NULL, NULL, NULL, 'IMMEDIATE EARLY RESPONSE GENE 5 PROTEIN', 249109),
(390776, 'PTHR15895:SF13', NULL, NULL, NULL, NULL, '', 249109),
(390777, 'PTHR15895:SF11', NULL, NULL, NULL, NULL, 'IMMEDIATE EARLY RESPONSE GENE 5-LIKE PROTEIN', 249109),
(390778, 'PTHR15895', NULL, NULL, NULL, NULL, 'IMMEDIATE EARLY RESPONSE GENE', 249109),
(390779, 'PTHR15895:SF4', NULL, NULL, NULL, NULL, 'IMMEDIATE EARLY RESPONSE GENE 2 PROTEIN', 249109),
(390780, 'PTHR23355:SF59', NULL, NULL, NULL, NULL, 'EXORIBONUCLEASE II, MITOCHONDRIAL', 249110),
(390781, 'PTHR23355:SF37', NULL, NULL, NULL, NULL, 'EXORIBONUCLEASE 2', 249110),
(390782, 'PTHR23355:SF35', NULL, NULL, NULL, NULL, 'EXOSOME COMPLEX EXONUCLEASE RRP44', 249110),
(390783, 'PTHR23355:SF65', NULL, NULL, NULL, NULL, 'RNB DOMAIN-CONTAINING PROTEIN', 249110);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(390784, 'PTHR23355:SF54', NULL, NULL, NULL, NULL, 'RNB DOMAIN-CONTAINING PROTEIN', 249110),
(390785, 'PTHR23355:SF55', NULL, NULL, NULL, NULL, 'RNB DOMAIN-CONTAINING PROTEIN', 249110),
(390786, 'PTHR23355:SF44', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', 249110),
(390787, 'PTHR23355', NULL, NULL, NULL, NULL, 'RIBONUCLEASE', 249110),
(390788, 'PTHR23355:SF30', NULL, NULL, NULL, NULL, 'DIS3-LIKE EXONUCLEASE 1', 249110),
(390789, 'PTHR23355:SF63', NULL, NULL, NULL, NULL, 'RNB DOMAIN-CONTAINING PROTEIN', 249110),
(390790, 'PTHR23355:SF64', NULL, NULL, NULL, NULL, 'RIBONUCLEASE II FAMILY PROTEIN', 249110),
(390791, 'PTHR23355:SF42', NULL, NULL, NULL, NULL, 'RIBONUCLEASE II, CHLOROPLASTIC/MITOCHONDRIAL', 249110),
(390792, 'PTHR23355:SF61', NULL, NULL, NULL, NULL, 'PROTEIN STS5', 249110),
(390793, 'PTHR23355:SF62', NULL, NULL, NULL, NULL, 'WALL BIOGENESIS PROTEIN PHOSPHATASE SSD1, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G11420)-RELATED', 249110),
(390794, 'PTHR23355:SF60', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL EXORIBONUCLEASE DSS-1', 249110),
(390795, 'PTHR23355:SF9', NULL, NULL, NULL, NULL, 'DIS3-LIKE EXONUCLEASE 2', 249110),
(390796, 'PTHR11706:SF101', NULL, NULL, NULL, NULL, 'MANGANESE TRANSPORTER SMF1', 249111),
(390797, 'PTHR11706:SF92', NULL, NULL, NULL, NULL, 'BNAC06G40180D PROTEIN', 249111),
(390798, 'PTHR11706:SF104', NULL, NULL, NULL, NULL, 'METAL TRANSPORTER NRAMP2', 249111),
(390799, 'PTHR11706:SF100', NULL, NULL, NULL, NULL, 'BNAC08G04640D PROTEIN', 249111),
(390800, 'PTHR11706:SF99', NULL, NULL, NULL, NULL, 'METAL TRANSPORTER NRAMP5-LIKE', 249111),
(390801, 'PTHR11706:SF77', NULL, NULL, NULL, NULL, 'METAL TRANSPORTER NRAMP5', 249111),
(390802, 'PTHR11706:SF33', NULL, NULL, NULL, NULL, 'PROTEIN MALVOLIO', 249111),
(390803, 'PTHR11706:SF109', NULL, NULL, NULL, NULL, 'METAL TRANSPORTER NRAMP3', 249111),
(390804, 'PTHR11706:SF75', NULL, NULL, NULL, NULL, 'ETHYLENE-INSENSITIVE PROTEIN 2', 249111),
(390805, 'PTHR11706:SF98', NULL, NULL, NULL, NULL, '', 249111),
(390806, 'PTHR11706:SF32', NULL, NULL, NULL, NULL, 'NRAMP-LIKE TRANSPORTER SMF-3', 249111),
(390807, 'PTHR11706:SF76', NULL, NULL, NULL, NULL, 'METAL TRANSPORTER NRAMP3', 249111),
(390808, 'PTHR11706:SF54', NULL, NULL, NULL, NULL, 'METAL TRANSPORTER NRAMP1', 249111),
(390809, 'PTHR11706:SF106', NULL, NULL, NULL, NULL, '', 249111),
(390810, 'PTHR11706:SF52', NULL, NULL, NULL, NULL, 'NATURAL RESISTANCE-ASSOCIATED MACROPHAGE PROTEIN 1', 249111),
(390811, 'PTHR11706:SF96', NULL, NULL, NULL, NULL, 'NRAMP METAL ION TRANSPORTER FAMILY PROTEIN-RELATED', 249111),
(390812, 'PTHR11706:SF30', NULL, NULL, NULL, NULL, 'TRANSPORTER SMF1/ESP1', 249111),
(390813, 'PTHR11706:SF108', NULL, NULL, NULL, NULL, 'METAL TRANSPORTER NRAMP6', 249111),
(390814, 'PTHR11706:SF93', NULL, NULL, NULL, NULL, 'NATURAL RESISTANCE-ASSOCIATED MACROPHAGE PROTEIN, EXPRESSED', 249111),
(390815, 'PTHR11706:SF94', NULL, NULL, NULL, NULL, 'METAL TRANSPORTER NRAT1-RELATED', 249111),
(390816, 'PTHR11706:SF107', NULL, NULL, NULL, NULL, '', 249111),
(390817, 'PTHR11706:SF50', NULL, NULL, NULL, NULL, 'MANGANESE TRANSPORTER SMF2', 249111),
(390818, 'PTHR11706:SF29', NULL, NULL, NULL, NULL, 'IRON TRANSPORTER SMF3', 249111),
(390819, 'PTHR11706:SF48', NULL, NULL, NULL, NULL, 'METAL TRANSPORTER NRAT1', 249111),
(390820, 'PTHR11706:SF26', NULL, NULL, NULL, NULL, 'NRAMP-LIKE TRANSPORTER SMF-2', 249111),
(390821, 'PTHR11706:SF47', NULL, NULL, NULL, NULL, 'METAL TRANSPORTER NRAMP4', 249111),
(390822, 'PTHR11706:SF81', NULL, NULL, NULL, NULL, '', 249111),
(390823, 'PTHR11706:SF111', NULL, NULL, NULL, NULL, 'METAL TRANSPORTER NRAMP4', 249111),
(390824, 'PTHR11706:SF110', NULL, NULL, NULL, NULL, 'NATURAL RESISTANCE-ASSOCIATED MACROPHAGE PROTEIN 3-RELATED', 249111),
(390825, 'PTHR11706:SF88', NULL, NULL, NULL, NULL, 'METAL TRANSPORTER NRAMP5', 249111),
(390826, 'PTHR11706:SF89', NULL, NULL, NULL, NULL, 'METAL TRANSPORTER NRAMP3 PROTEIN', 249111),
(390827, 'PTHR11706:SF86', NULL, NULL, NULL, NULL, 'METAL TRANSPORTER NRAMP2-LIKE', 249111),
(390828, 'PTHR11706:SF87', NULL, NULL, NULL, NULL, 'ETHYLENE-INSENSITIVE PROTEIN 2', 249111);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(390829, 'PTHR11706:SF40', NULL, NULL, NULL, NULL, 'NATURAL RESISTANCE-ASSOCIATED MACROPHAGE PROTEIN 2', 249111),
(390830, 'PTHR11706:SF41', NULL, NULL, NULL, NULL, 'METAL TRANSPORTER NRAMP1', 249111),
(390831, 'PTHR11706:SF3', NULL, NULL, NULL, NULL, 'METAL ION TRANSPORT PROTEIN-RELATED', 249111),
(390832, 'PTHR11706:SF83', NULL, NULL, NULL, NULL, 'ETHYLENE-INSENSITIVE PROTEIN 2', 249111),
(390833, 'PTHR11706:SF2', NULL, NULL, NULL, NULL, 'TRANSPORTER PROTEIN', 249111),
(390834, 'PTHR11706', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER PROTEIN FAMILY 11 MEMBER', 249111),
(390835, 'PTHR11706:SF79', NULL, NULL, NULL, NULL, 'METAL TRANSPORTER NRAMP3 PROTEIN', 249111),
(390836, 'PTHR36789:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 249112),
(390837, 'PTHR36789', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 249112),
(390838, 'PTHR15256:SF6', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN DGCR2/IDD', 249113),
(390839, 'PTHR15256', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN DGCR2/IDD', 249113),
(390840, 'PTHR42840:SF4', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE-RELATED', 249114),
(390841, 'PTHR42840:SF10', NULL, NULL, NULL, NULL, 'BINDING ROSSMANN FOLD OXIDOREDUCTASE, PUTATIVE-RELATED', 249114),
(390842, 'PTHR42840:SF11', NULL, NULL, NULL, NULL, 'BINDING ROSSMANN FOLD OXIDOREDUCTASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G09900)-RELATED', 249114),
(390843, 'PTHR42840:SF3', NULL, NULL, NULL, NULL, 'BINDING ROSSMANN FOLD OXIDOREDUCTASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G10240)-RELATED', 249114),
(390844, 'PTHR42840:SF14', NULL, NULL, NULL, NULL, '', 249114),
(390845, 'PTHR42840:SF8', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE', 249114),
(390846, 'PTHR42840:SF7', NULL, NULL, NULL, NULL, 'BINDING ROSSMANN FOLD OXIDOREDUCTASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G10190)-RELATED', 249114),
(390847, 'PTHR42840:SF6', NULL, NULL, NULL, NULL, 'BINDING ROSSMANN FOLD OXIDOREDUCTASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G11930)-RELATED', 249114),
(390848, 'PTHR42840:SF5', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 249114),
(390849, 'PTHR42840', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN-RELATED', 249114),
(390850, 'PTHR11467:SF86', NULL, NULL, NULL, NULL, 'HISTONE H1.2', 249115),
(390851, 'PTHR11467:SF42', NULL, NULL, NULL, NULL, 'HISTONE H1.8', 249115),
(390852, 'PTHR11467:SF171', NULL, NULL, NULL, NULL, 'H15 DOMAIN-CONTAINING PROTEIN', 249115),
(390853, 'PTHR11467:SF170', NULL, NULL, NULL, NULL, 'LINKER HISTONE H1M', 249115),
(390854, 'PTHR11467:SF172', NULL, NULL, NULL, NULL, 'LINKER HISTONE H1 AND H5 FAMILY PROTEIN', 249115),
(390855, 'PTHR11467:SF135', NULL, NULL, NULL, NULL, 'H15 DOMAIN-CONTAINING PROTEIN', 249115),
(390856, 'PTHR11467:SF137', NULL, NULL, NULL, NULL, 'HISTONE H1.3', 249115),
(390857, 'PTHR11467:SF131', NULL, NULL, NULL, NULL, 'HISTONE H1', 249115),
(390858, 'PTHR11467:SF130', NULL, NULL, NULL, NULL, 'HISTONE H1-LIKE ISOFORM X1', 249115),
(390859, 'PTHR11467:SF36', NULL, NULL, NULL, NULL, 'HISTONE H1', 249115),
(390860, 'PTHR11467:SF129', NULL, NULL, NULL, NULL, 'H15 DOMAIN-CONTAINING PROTEIN', 249115),
(390861, 'PTHR11467:SF160', NULL, NULL, NULL, NULL, 'HISTONE H5, AT HOOK-LIKE PROTEIN-RELATED', 249115),
(390862, 'PTHR11467:SF162', NULL, NULL, NULL, NULL, 'HMG-Y-RELATED PROTEIN A', 249115),
(390863, 'PTHR11467:SF161', NULL, NULL, NULL, NULL, 'HISTONE H1.2-RELATED', 249115),
(390864, 'PTHR11467:SF168', NULL, NULL, NULL, NULL, 'HISTONE H1.1', 249115),
(390865, 'PTHR11467:SF167', NULL, NULL, NULL, NULL, 'H15 DOMAIN-CONTAINING PROTEIN-RELATED', 249115),
(390866, 'PTHR11467', NULL, NULL, NULL, NULL, 'HISTONE H1', 249115),
(390867, 'PTHR11467:SF169', NULL, NULL, NULL, NULL, 'HISTONE H1-LIKE', 249115),
(390868, 'PTHR11467:SF164', NULL, NULL, NULL, NULL, 'H15 DOMAIN-CONTAINING PROTEIN', 249115),
(390869, 'PTHR11467:SF163', NULL, NULL, NULL, NULL, 'HISTONE H1.2', 249115),
(390870, 'PTHR11467:SF166', NULL, NULL, NULL, NULL, 'OS05G0597150-LIKE PROTEIN', 249115),
(390871, 'PTHR11467:SF165', NULL, NULL, NULL, NULL, 'H15 DOMAIN-CONTAINING PROTEIN', 249115);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(390872, 'PTHR11467:SF121', NULL, NULL, NULL, NULL, 'HISTONE H1.2', 249115),
(390873, 'PTHR11467:SF29', NULL, NULL, NULL, NULL, 'OS03G0711600 PROTEIN', 249115),
(390874, 'PTHR11467:SF28', NULL, NULL, NULL, NULL, 'HISTONE H1.1-RELATED', 249115),
(390875, 'PTHR11467:SF117', NULL, NULL, NULL, NULL, 'H15 DOMAIN-CONTAINING PROTEIN', 249115),
(390876, 'PTHR11467:SF24', NULL, NULL, NULL, NULL, 'HISTONE H1.5', 249115),
(390877, 'PTHR11467:SF119', NULL, NULL, NULL, NULL, 'HISTONE H5-RELATED', 249115),
(390878, 'PTHR11467:SF118', NULL, NULL, NULL, NULL, 'H15 DOMAIN-CONTAINING PROTEIN', 249115),
(390879, 'PTHR11467:SF21', NULL, NULL, NULL, NULL, 'HISTONE H1.10', 249115),
(390880, 'PTHR11467:SF20', NULL, NULL, NULL, NULL, 'HISTONE H1.4', 249115),
(390881, 'PTHR11467:SF61', NULL, NULL, NULL, NULL, 'HISTONE H1.X', 249115),
(390882, 'PTHR11467:SF151', NULL, NULL, NULL, NULL, 'H15 DOMAIN-CONTAINING PROTEIN', 249115),
(390883, 'PTHR11467:SF150', NULL, NULL, NULL, NULL, 'HMG-Y-RELATED PROTEIN A-LIKE', 249115),
(390884, 'PTHR11467:SF113', NULL, NULL, NULL, NULL, 'OS09G0402100 PROTEIN', 249115),
(390885, 'PTHR11467:SF157', NULL, NULL, NULL, NULL, 'H15 DOMAIN-CONTAINING PROTEIN', 249115),
(390886, 'PTHR11467:SF156', NULL, NULL, NULL, NULL, 'LINKER HISTONE H1 AND H5 FAMILY PROTEIN', 249115),
(390887, 'PTHR11467:SF159', NULL, NULL, NULL, NULL, 'OS07G0184800 PROTEIN', 249115),
(390888, 'PTHR11467:SF158', NULL, NULL, NULL, NULL, 'HISTONE H5-RELATED', 249115),
(390889, 'PTHR11467:SF154', NULL, NULL, NULL, NULL, 'HISTONE H1.0', 249115),
(390890, 'PTHR11467:SF18', NULL, NULL, NULL, NULL, 'HISTONE H1T', 249115),
(390891, 'PTHR11467:SF109', NULL, NULL, NULL, NULL, 'H15 DOMAIN-CONTAINING PROTEIN', 249115),
(390892, 'PTHR11467:SF14', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC H1 HISTONE', 249115),
(390893, 'PTHR11467:SF105', NULL, NULL, NULL, NULL, 'HISTONE H1', 249115),
(390894, 'PTHR11467:SF98', NULL, NULL, NULL, NULL, 'H15 DOMAIN-CONTAINING PROTEIN', 249115),
(390895, 'PTHR11467:SF97', NULL, NULL, NULL, NULL, 'H15 DOMAIN-CONTAINING PROTEIN', 249115),
(390896, 'PTHR11467:SF140', NULL, NULL, NULL, NULL, 'H15 DOMAIN-CONTAINING PROTEIN', 249115),
(390897, 'PTHR11467:SF145', NULL, NULL, NULL, NULL, 'WINGED HELIX-TURN-HELIX DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 249115),
(390898, 'PTHR11467:SF147', NULL, NULL, NULL, NULL, 'H15 DOMAIN-CONTAINING PROTEIN', 249115),
(390899, 'PTHR11467:SF103', NULL, NULL, NULL, NULL, 'HMG-Y-RELATED PROTEIN A', 249115),
(390900, 'PTHR11467:SF144', NULL, NULL, NULL, NULL, 'OS06G0130800 PROTEIN', 249115),
(390901, 'PTHR11467:SF143', NULL, NULL, NULL, NULL, 'HISTONE H1', 249115),
(390902, 'PTHR21462', NULL, NULL, NULL, NULL, 'CELL SURFACE GLYCOPROTEIN OX2 RECEPTOR PRECURSOR', 249116),
(390903, 'PTHR21462:SF2', NULL, NULL, NULL, NULL, 'CELL SURFACE GLYCOPROTEIN CD200 RECEPTOR 1', 249116),
(390904, 'PTHR21462:SF3', NULL, NULL, NULL, NULL, 'CELL SURFACE GLYCOPROTEIN CD200 RECEPTOR 2', 249116),
(390905, 'PTHR34458:SF5', NULL, NULL, NULL, NULL, 'POLLEN OLE E 1 ALLERGEN AND EXTENSIN FAMILY PROTEIN', 249117),
(390906, 'PTHR34458:SF7', NULL, NULL, NULL, NULL, 'OS07G0674400 PROTEIN', 249117),
(390907, 'PTHR34458:SF17', NULL, NULL, NULL, NULL, 'BNAA08G19300D PROTEIN', 249117),
(390908, 'PTHR34458:SF16', NULL, NULL, NULL, NULL, 'BNAC03G75730D PROTEIN', 249117),
(390909, 'PTHR34458', NULL, NULL, NULL, NULL, 'POLLEN OLE E 1 ALLERGEN AND EXTENSIN FAMILY PROTEIN-RELATED', 249117),
(390910, 'PTHR34458:SF15', NULL, NULL, NULL, NULL, 'BNAA02G13680D PROTEIN', 249117),
(390911, 'PTHR34458:SF14', NULL, NULL, NULL, NULL, 'BNAC01G34880D PROTEIN', 249117),
(390912, 'PTHR34458:SF19', NULL, NULL, NULL, NULL, '', 249117),
(390913, 'PTHR34458:SF18', NULL, NULL, NULL, NULL, 'BNAANNG38080D PROTEIN', 249117),
(390914, 'PTHR34458:SF13', NULL, NULL, NULL, NULL, 'OS07G0674500 PROTEIN', 249117),
(390915, 'PTHR34458:SF12', NULL, NULL, NULL, NULL, '', 249117),
(390916, 'PTHR34458:SF11', NULL, NULL, NULL, NULL, 'MALE SPECIFIC SPERM PROTEIN', 249117),
(390917, 'PTHR34458:SF21', NULL, NULL, NULL, NULL, 'POLLEN OLE E 1 ALLERGEN AND EXTENSIN FAMILY PROTEIN', 249117);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(390918, 'PTHR46981', NULL, NULL, NULL, NULL, 'BIS(5''-ADENOSYL)-TRIPHOSPHATASE', 249118),
(390919, 'PTHR46981:SF1', NULL, NULL, NULL, NULL, 'BIS(5''-ADENOSYL)-TRIPHOSPHATASE', 249118),
(390920, 'PTHR23254:SF15', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN-INTERACTING PROTEIN 1', 249119),
(390921, 'PTHR23254:SF16', NULL, NULL, NULL, NULL, 'CBP80/20-DEPENDENT TRANSLATION INITIATION FACTOR', 249119),
(390922, 'PTHR23254:SF17', NULL, NULL, NULL, NULL, 'MIF4G DOMAIN-CONTAINING PROTEIN', 249119),
(390923, 'PTHR23254', NULL, NULL, NULL, NULL, 'EIF4G DOMAIN PROTEIN', 249119),
(390924, 'PTHR23254:SF18', NULL, NULL, NULL, NULL, 'RE28271P', 249119),
(390925, 'PTHR40422:SF1', NULL, NULL, NULL, NULL, 'TRANSLATION MACHINERY-ASSOCIATED PROTEIN 17', 249120),
(390926, 'PTHR40422', NULL, NULL, NULL, NULL, 'TRANSLATION MACHINERY-ASSOCIATED PROTEIN 17', 249120),
(390927, 'PTHR33530:SF20', NULL, NULL, NULL, NULL, '', 249121),
(390928, 'PTHR33530:SF9', NULL, NULL, NULL, NULL, 'OS01G0184600 PROTEIN', 249121),
(390929, 'PTHR33530:SF18', NULL, NULL, NULL, NULL, '', 249121),
(390930, 'PTHR33530:SF15', NULL, NULL, NULL, NULL, 'OS01G0147100 PROTEIN', 249121),
(390931, 'PTHR33530:SF8', NULL, NULL, NULL, NULL, 'OS04G0591500 PROTEIN', 249121),
(390932, 'PTHR33530:SF10', NULL, NULL, NULL, NULL, '', 249121),
(390933, 'PTHR33530', NULL, NULL, NULL, NULL, 'OS01G0147100 PROTEIN', 249121),
(390934, 'PTHR33530:SF4', NULL, NULL, NULL, NULL, 'OS01G0145800 PROTEIN', 249121),
(390935, 'PTHR33530:SF12', NULL, NULL, NULL, NULL, '', 249121),
(390936, 'PTHR35103:SF2', NULL, NULL, NULL, NULL, '', 249122),
(390937, 'PTHR35103:SF1', NULL, NULL, NULL, NULL, 'OS06G0115700 PROTEIN', 249122),
(390938, 'PTHR35103:SF4', NULL, NULL, NULL, NULL, 'BNAA03G49180D PROTEIN', 249122),
(390939, 'PTHR35103:SF6', NULL, NULL, NULL, NULL, '', 249122),
(390940, 'PTHR35103:SF5', NULL, NULL, NULL, NULL, 'BNAC01G20840D PROTEIN', 249122),
(390941, 'PTHR35103', NULL, NULL, NULL, NULL, 'OS06G0115700 PROTEIN', 249122),
(390942, 'PTHR43650:SF9', NULL, NULL, NULL, NULL, 'PYROPHOSPHATE--FRUCTOSE 6-PHOSPHATE 1-PHOSPHOTRANSFERASE SUBUNIT ALPHA', 249123),
(390943, 'PTHR43650', NULL, NULL, NULL, NULL, 'PYROPHOSPHATE--FRUCTOSE 6-PHOSPHATE 1-PHOSPHOTRANSFERASE', 249123),
(390944, 'PTHR43650:SF29', NULL, NULL, NULL, NULL, 'PYROPHOSPHATE--FRUCTOSE 6-PHOSPHATE 1-PHOSPHOTRANSFERASE SUBUNIT BETA 1', 249123),
(390945, 'PTHR43650:SF25', NULL, NULL, NULL, NULL, 'PYROPHOSPHATE--FRUCTOSE 6-PHOSPHATE 1-PHOSPHOTRANSFERASE SUBUNIT ALPHA', 249123),
(390946, 'PTHR43650:SF1', NULL, NULL, NULL, NULL, 'PYROPHOSPHATE--FRUCTOSE 6-PHOSPHATE 1-PHOSPHOTRANSFERASE SUBUNIT BETA 2', 249123),
(390947, 'PTHR43650:SF15', NULL, NULL, NULL, NULL, 'PYROPHOSPHATE--FRUCTOSE 6-PHOSPHATE 1-PHOSPHOTRANSFERASE SUBUNIT ALPHA', 249123),
(390948, 'PTHR43650:SF26', NULL, NULL, NULL, NULL, 'PYROPHOSPHATE--FRUCTOSE 6-PHOSPHATE 1-PHOSPHOTRANSFERASE SUBUNIT BETA', 249123),
(390949, 'PTHR43650:SF27', NULL, NULL, NULL, NULL, 'PYROPHOSPHATE--FRUCTOSE 6-PHOSPHATE 1-PHOSPHOTRANSFERASE SUBUNIT ALPHA', 249123),
(390950, 'PTHR43650:SF17', NULL, NULL, NULL, NULL, 'PYROPHOSPHATE--FRUCTOSE 6-PHOSPHATE 1-PHOSPHOTRANSFERASE SUBUNIT ALPHA 1', 249123),
(390951, 'PTHR43650:SF28', NULL, NULL, NULL, NULL, 'PYROPHOSPHATE--FRUCTOSE 6-PHOSPHATE 1-PHOSPHOTRANSFERASE SUBUNIT BETA', 249123),
(390952, 'PTHR43650:SF21', NULL, NULL, NULL, NULL, 'PYROPHOSPHATE--FRUCTOSE 6-PHOSPHATE 1-PHOSPHOTRANSFERASE SUBUNIT ALPHA', 249123),
(390953, 'PTHR43650:SF6', NULL, NULL, NULL, NULL, 'PYROPHOSPHATE--FRUCTOSE 6-PHOSPHATE 1-PHOSPHOTRANSFERASE SUBUNIT BETA', 249123),
(390954, 'PTHR43650:SF7', NULL, NULL, NULL, NULL, 'PYROPHOSPHATE--FRUCTOSE 6-PHOSPHATE 1-PHOSPHOTRANSFERASE SUBUNIT ALPHA', 249123),
(390955, 'PTHR43650:SF23', NULL, NULL, NULL, NULL, 'PYROPHOSPHATE--FRUCTOSE 6-PHOSPHATE 1-PHOSPHOTRANSFERASE SUBUNIT ALPHA 2', 249123),
(390956, 'PTHR43650:SF8', NULL, NULL, NULL, NULL, 'PYROPHOSPHATE--FRUCTOSE 6-PHOSPHATE 1-PHOSPHOTRANSFERASE SUBUNIT ALPHA', 249123),
(390957, 'PTHR43650:SF13', NULL, NULL, NULL, NULL, 'PYROPHOSPHATE--FRUCTOSE 6-PHOSPHATE 1-PHOSPHOTRANSFERASE SUBUNIT BETA', 249123);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(390958, 'PTHR43650:SF20', NULL, NULL, NULL, NULL, 'PYROPHOSPHATE--FRUCTOSE 6-PHOSPHATE 1-PHOSPHOTRANSFERASE SUBUNIT ALPHA', 249123),
(390959, 'PTHR35605', NULL, NULL, NULL, NULL, '', 249124),
(390960, 'PTHR35605:SF1', NULL, NULL, NULL, NULL, '', 249124),
(390961, 'PTHR12119', NULL, NULL, NULL, NULL, 'UBIQUINOL-CYTOCHROME C REDUCTASE COMPLEX UBIQUINONE-BINDING PROTEIN QP-C', 249125),
(390962, 'PTHR12119:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 8', 249125),
(390963, 'PTHR47120', NULL, NULL, NULL, NULL, 'THAP DOMAIN-CONTAINING PROTEIN 3', 249126),
(390964, 'PTHR47120:SF1', NULL, NULL, NULL, NULL, 'THAP DOMAIN-CONTAINING PROTEIN 3', 249126),
(390965, 'PTHR35799:SF1', NULL, NULL, NULL, NULL, 'S-RIBOSYLHOMOCYSTEINE LYASE', 249127),
(390966, 'PTHR35799', NULL, NULL, NULL, NULL, 'S-RIBOSYLHOMOCYSTEINE LYASE', 249127),
(390967, 'PTHR36922', NULL, NULL, NULL, NULL, 'BLL2446 PROTEIN', 249128),
(390968, 'PTHR36922:SF1', NULL, NULL, NULL, NULL, 'BLL2446 PROTEIN', 249128),
(390969, 'PTHR37401:SF1', NULL, NULL, NULL, NULL, 'YALI0E18722P', 249129),
(390970, 'PTHR37401', NULL, NULL, NULL, NULL, 'YALI0E18722P', 249129),
(390971, 'PTHR39308', NULL, NULL, NULL, NULL, 'HEAVY PROTEIN, PUTATIVE-RELATED', 249130),
(390972, 'PTHR39308:SF3', NULL, NULL, NULL, NULL, '', 249130),
(390973, 'PTHR39308:SF2', NULL, NULL, NULL, NULL, 'HEAVY PROTEIN, PUTATIVE-RELATED', 249130),
(390974, 'PTHR39308:SF5', NULL, NULL, NULL, NULL, '', 249130),
(390975, 'PTHR39308:SF4', NULL, NULL, NULL, NULL, '', 249130),
(390976, 'PTHR38474', NULL, NULL, NULL, NULL, 'SLR0299 PROTEIN', 249131),
(390977, 'PTHR38474:SF1', NULL, NULL, NULL, NULL, 'SLR0299 PROTEIN', 249131),
(390978, 'PTHR31480:SF0', NULL, NULL, NULL, NULL, 'PHYTOENE SYNTHASE 2, CHLOROPLASTIC', 249132),
(390979, 'PTHR31480:SF2', NULL, NULL, NULL, NULL, 'PHYTOENE SYNTHASE, CHLOROPLASTIC', 249132),
(390980, 'PTHR31480:SF21', NULL, NULL, NULL, NULL, 'PHYTOENE SYNTHASE 1, CHLOROPLASTIC', 249132),
(390981, 'PTHR31480:SF22', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL 15-CIS-PHYTOENE SYNTHASE, CHROMOPLASTIC-RELATED', 249132),
(390982, 'PTHR31480:SF17', NULL, NULL, NULL, NULL, 'BLR3001 PROTEIN', 249132),
(390983, 'PTHR31480', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL LYCOPENE CYCLASE/PHYTOENE SYNTHASE', 249132),
(390984, 'PTHR31480:SF6', NULL, NULL, NULL, NULL, 'PHYTOENE SYNTHASE 3, CHLOROPLASTIC', 249132),
(390985, 'PTHR31480:SF9', NULL, NULL, NULL, NULL, '15-CIS-PHYTOENE SYNTHASE-RELATED', 249132),
(390986, 'PTHR12427', NULL, NULL, NULL, NULL, 'ATP SYNTHASE E CHAIN, MITOCHONDRIAL', 249133),
(390987, 'PTHR12427:SF1', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT E, MITOCHONDRIAL', 249133),
(390988, 'PTHR48219', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 62-RELATED', 249134),
(390989, 'PTHR48219:SF2', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 62-RELATED', 249134),
(390990, 'PTHR48219:SF1', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 62-RELATED', 249134),
(390991, 'PTHR47752:SF1', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REPRESSOR FABR', 249135),
(390992, 'PTHR47752', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REPRESSOR FABR', 249135),
(390993, 'PTHR36302:SF1', NULL, NULL, NULL, NULL, 'BLR7088 PROTEIN', 249136),
(390994, 'PTHR36302', NULL, NULL, NULL, NULL, 'BLR7088 PROTEIN', 249136),
(390995, 'PTHR31441:SF2', NULL, NULL, NULL, NULL, 'FOLLICULIN', 249137),
(390996, 'PTHR31441', NULL, NULL, NULL, NULL, 'FOLLICULIN FAMILY MEMBER', 249137),
(390997, 'PTHR46748:SF1', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE-III DOMAIN-CONTAINING PROTEIN', 249138),
(390998, 'PTHR46748', NULL, NULL, NULL, NULL, 'LRRNT DOMAIN-CONTAINING PROTEIN', 249138),
(390999, 'PTHR30548:SF5', NULL, NULL, NULL, NULL, 'SUBUNIT OF OXYGEN-SENSITIVE 2-HYDROXYISOCAPROYL-COA DEHYDRATASE', 249139),
(391000, 'PTHR30548:SF6', NULL, NULL, NULL, NULL, 'DEHYDRATASE SUBUNIT YJIM-RELATED', 249139),
(391001, 'PTHR30548:SF3', NULL, NULL, NULL, NULL, '2-HYDROXYACYL-COA DEHYDRATASE-RELATED', 249139),
(391002, 'PTHR30548:SF4', NULL, NULL, NULL, NULL, 'SUBUNIT OF OXYGEN-SENSITIVE 2-HYDROXYISOCAPROYL-COA DEHYDRATASE', 249139);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(391003, 'PTHR30548:SF1', NULL, NULL, NULL, NULL, 'DEHYDRATASE SUBUNIT MJ0007-RELATED', 249139),
(391004, 'PTHR30548:SF2', NULL, NULL, NULL, NULL, '2-HYDROXYACYL-COA DEHYDRATASE,D-COMPONENT-RELATED', 249139),
(391005, 'PTHR30548', NULL, NULL, NULL, NULL, '2-HYDROXYGLUTARYL-COA DEHYDRATASE, D-COMPONENT-RELATED', 249139),
(391006, 'PTHR35352:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 150', 249140),
(391007, 'PTHR35352', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 150', 249140),
(391008, 'PTHR10953:SF222', NULL, NULL, NULL, NULL, 'E1 UBIQUITIN-ACTIVATING ENZYME', 249141),
(391009, 'PTHR10953:SF244', NULL, NULL, NULL, NULL, 'NEDD8-ACTIVATING ENZYME E1 REGULATORY SUBUNIT', 249141),
(391010, 'PTHR10953:SF243', NULL, NULL, NULL, NULL, 'E1 UBIQUITIN-ACTIVATING ENZYME', 249141),
(391011, 'PTHR10953:SF242', NULL, NULL, NULL, NULL, 'E1 UBIQUITIN-ACTIVATING ENZYME', 249141),
(391012, 'PTHR10953:SF143', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE MODIFIER-ACTIVATING ENZYME 7', 249141),
(391013, 'PTHR10953:SF220', NULL, NULL, NULL, NULL, 'ADENYLYLTRANSFERASE AND SULFURTRANSFERASE MOCS3', 249141),
(391014, 'PTHR10953:SF241', NULL, NULL, NULL, NULL, 'NEDD8-ACTIVATING ENZYME E1 REGULATORY SUBUNIT', 249141),
(391015, 'PTHR10953:SF186', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE MODIFIER-ACTIVATING ENZYME 6', 249141),
(391016, 'PTHR10953:SF240', NULL, NULL, NULL, NULL, 'SULFUR CARRIER PROTEIN THIS ADENYLYLTRANSFERASE', 249141),
(391017, 'PTHR10953:SF162', NULL, NULL, NULL, NULL, 'SUMO-ACTIVATING ENZYME SUBUNIT 1', 249141),
(391018, 'PTHR10953:SF9', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE MODIFIER-ACTIVATING ENZYME 5', 249141),
(391019, 'PTHR10953:SF227', NULL, NULL, NULL, NULL, 'E1 UBIQUITIN-ACTIVATING ENZYME', 249141),
(391020, 'PTHR10953:SF226', NULL, NULL, NULL, NULL, 'UBIQUITIN-ACTIVATING ENZYME E1 3', 249141),
(391021, 'PTHR10953:SF204', NULL, NULL, NULL, NULL, 'UBIQUITIN-ACTIVATING ENZYME E1 1', 249141),
(391022, 'PTHR10953:SF3', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE MODIFIER-ACTIVATING ENZYME ATG7', 249141),
(391023, 'PTHR10953:SF225', NULL, NULL, NULL, NULL, 'THIF DOMAIN-CONTAINING PROTEIN', 249141),
(391024, 'PTHR10953:SF4', NULL, NULL, NULL, NULL, 'UBIQUITIN-ACTIVATING ENZYME E1', 249141),
(391025, 'PTHR10953:SF246', NULL, NULL, NULL, NULL, 'UBIQUITIN ACTIVATING ENZYME', 249141),
(391026, 'PTHR10953:SF169', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE MODIFIER-ACTIVATING ENZYME 1 Y', 249141),
(391027, 'PTHR10953:SF202', NULL, NULL, NULL, NULL, 'THIF DOMAIN-CONTAINING PROTEIN', 249141),
(391028, 'PTHR10953:SF5', NULL, NULL, NULL, NULL, 'SUMO-ACTIVATING ENZYME SUBUNIT 2', 249141),
(391029, 'PTHR10953:SF201', NULL, NULL, NULL, NULL, 'SUMO-ACTIVATING ENZYME SUBUNIT 1', 249141),
(391030, 'PTHR10953:SF6', NULL, NULL, NULL, NULL, 'NEDD8-ACTIVATING ENZYME E1 CATALYTIC SUBUNIT', 249141),
(391031, 'PTHR10953:SF102', NULL, NULL, NULL, NULL, 'ADENYLYLTRANSFERASE AND SULFURTRANSFERASE MOCS3', 249141),
(391032, 'PTHR10953:SF245', NULL, NULL, NULL, NULL, 'E1 UBIQUITIN-ACTIVATING ENZYME', 249141),
(391033, 'PTHR10953:SF29', NULL, NULL, NULL, NULL, 'NEDD8-ACTIVATING ENZYME E1 REGULATORY SUBUNIT', 249141),
(391034, 'PTHR10953:SF233', NULL, NULL, NULL, NULL, 'NEDD8-ACTIVATING ENZYME E1 CATALYTIC SUBUNIT', 249141),
(391035, 'PTHR10953:SF155', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE MODIFIER-ACTIVATING ENZYME 1', 249141),
(391036, 'PTHR10953:SF232', NULL, NULL, NULL, NULL, 'NEDD8-ACTIVATING ENZYME E1 REGULATORY SUBUNIT AXL', 249141),
(391037, 'PTHR10953:SF199', NULL, NULL, NULL, NULL, 'THIF DOMAIN-CONTAINING PROTEIN', 249141),
(391038, 'PTHR10953:SF231', NULL, NULL, NULL, NULL, 'SUMO-ACTIVATING ENZYME SUBUNIT', 249141),
(391039, 'PTHR10953:SF198', NULL, NULL, NULL, NULL, 'UBIQUITIN-ACTIVATING ENZYME E1', 249141),
(391040, 'PTHR10953:SF195', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE MODIFIER-ACTIVATING ENZYME 1', 249141),
(391041, 'PTHR10953:SF194', NULL, NULL, NULL, NULL, 'MOLYBDOPTERIN-SYNTHASE ADENYLYLTRANSFERASE', 249141),
(391042, 'PTHR10953:SF239', NULL, NULL, NULL, NULL, 'NEDD8-ACTIVATING ENZYME E1 REGULATORY SUBUNIT', 249141);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(391043, 'PTHR10953:SF238', NULL, NULL, NULL, NULL, 'ADENYLYLTRANSFERASE AND SULFURTRANSFERASE MOCS3-1', 249141),
(391044, 'PTHR10953:SF215', NULL, NULL, NULL, NULL, 'UBIQUITIN-ACTIVATING ENZYME E1 1', 249141),
(391045, 'PTHR10953:SF237', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE MODIFIER-ACTIVATING ENZYME 5', 249141),
(391046, 'PTHR10953:SF213', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S12', 249141),
(391047, 'PTHR10953:SF235', NULL, NULL, NULL, NULL, 'UBIQUITIN-ACTIVATING ENZYME E1 2', 249141),
(391048, 'PTHR10953', NULL, NULL, NULL, NULL, 'UBIQUITIN-ACTIVATING ENZYME E1', 249141),
(391049, 'PTHR42986:SF1', NULL, NULL, NULL, NULL, 'BENZALDEHYDE DEHYDROGENASE YFMT', 249142),
(391050, 'PTHR42986', NULL, NULL, NULL, NULL, 'BENZALDEHYDE DEHYDROGENASE YFMT', 249142),
(391051, 'PTHR28014', NULL, NULL, NULL, NULL, 'NEGATIVE REGULATOR OF RAS-CAMP PATHWAY', 249143),
(391052, 'PTHR28014:SF1', NULL, NULL, NULL, NULL, 'NEGATIVE REGULATOR OF RAS-CAMP PATHWAY', 249143),
(391053, 'PTHR43112:SF21', NULL, NULL, NULL, NULL, 'FERREDOXIN', 249144),
(391054, 'PTHR43112:SF32', NULL, NULL, NULL, NULL, 'FERREDOXIN', 249144),
(391055, 'PTHR43112:SF10', NULL, NULL, NULL, NULL, 'FERREDOXIN C 2, CHLOROPLASTIC', 249144),
(391056, 'PTHR43112:SF20', NULL, NULL, NULL, NULL, 'FERREDOXIN', 249144),
(391057, 'PTHR43112:SF30', NULL, NULL, NULL, NULL, 'FERREDOXIN-3, CHLOROPLASTIC', 249144),
(391058, 'PTHR43112:SF41', NULL, NULL, NULL, NULL, 'FERREDOXIN', 249144),
(391059, 'PTHR43112:SF29', NULL, NULL, NULL, NULL, 'FERREDOXIN', 249144),
(391060, 'PTHR43112:SF2', NULL, NULL, NULL, NULL, 'FERREDOXIN', 249144),
(391061, 'PTHR43112:SF3', NULL, NULL, NULL, NULL, 'FERREDOXIN-2, CHLOROPLASTIC', 249144),
(391062, 'PTHR43112:SF17', NULL, NULL, NULL, NULL, 'FERREDOXIN-1, CHLOROPLASTIC', 249144),
(391063, 'PTHR43112:SF28', NULL, NULL, NULL, NULL, 'FERREDOXIN', 249144),
(391064, 'PTHR43112:SF39', NULL, NULL, NULL, NULL, 'FERREDOXIN', 249144),
(391065, 'PTHR43112:SF27', NULL, NULL, NULL, NULL, 'FERREDOXIN', 249144),
(391066, 'PTHR43112:SF16', NULL, NULL, NULL, NULL, 'FERREDOXIN', 249144),
(391067, 'PTHR43112:SF36', NULL, NULL, NULL, NULL, 'FERREDOXIN-3, CHLOROPLASTIC-LIKE', 249144),
(391068, 'PTHR43112:SF25', NULL, NULL, NULL, NULL, 'FERREDOXIN', 249144),
(391069, 'PTHR43112', NULL, NULL, NULL, NULL, 'FERREDOXIN', 249144),
(391070, 'PTHR43112:SF24', NULL, NULL, NULL, NULL, 'FERREDOXIN', 249144),
(391071, 'PTHR43112:SF35', NULL, NULL, NULL, NULL, 'FERREDOXIN', 249144),
(391072, 'PTHR43112:SF23', NULL, NULL, NULL, NULL, 'FERREDOXIN-4, CHLOROPLASTIC-RELATED', 249144),
(391073, 'PTHR43112:SF34', NULL, NULL, NULL, NULL, 'FERREDOXIN', 249144),
(391074, 'PTHR43112:SF11', NULL, NULL, NULL, NULL, 'FERREDOXIN-6, CHLOROPLASTIC', 249144),
(391075, 'PTHR43112:SF9', NULL, NULL, NULL, NULL, 'FERREDOXIN C 1, CHLOROPLASTIC', 249144),
(391076, 'PTHR46575:SF1', NULL, NULL, NULL, NULL, 'AMYLOID PROTEIN-BINDING PROTEIN 2', 249145),
(391077, 'PTHR46575', NULL, NULL, NULL, NULL, 'AMYLOID PROTEIN-BINDING PROTEIN 2', 249145),
(391078, 'PTHR35385', NULL, NULL, NULL, NULL, 'PROTEIN B, PUTATIVE-RELATED-RELATED', 249146),
(391079, 'PTHR35385:SF2', NULL, NULL, NULL, NULL, 'SI:DKEY-75A21.2', 249146),
(391080, 'PTHR10825:SF72', NULL, NULL, NULL, NULL, 'POLYCOMB GROUP PROTEIN PSC-RELATED', 249147),
(391081, 'PTHR10825', NULL, NULL, NULL, NULL, 'RING FINGER DOMAIN-CONTAINING, POLYCOMB GROUP COMPONENT', 249147),
(391082, 'PTHR10825:SF21', NULL, NULL, NULL, NULL, 'POLYCOMB COMPLEX PROTEIN BMI-1', 249147),
(391083, 'PTHR10825:SF74', NULL, NULL, NULL, NULL, 'POLYCOMB GROUP RING FINGER 6', 249147),
(391084, 'PTHR10825:SF31', NULL, NULL, NULL, NULL, 'POLYCOMB GROUP RING FINGER PROTEIN 2', 249147),
(391085, 'PTHR10825:SF29', NULL, NULL, NULL, NULL, 'POLYCOMB GROUP RING FINGER PROTEIN 1', 249147),
(391086, 'PTHR31666', NULL, NULL, NULL, NULL, 'PROTEIN CXORF40A-RELATED', 249148),
(391087, 'PTHR31666:SF0', NULL, NULL, NULL, NULL, 'PROTEIN EOLA1-RELATED', 249148),
(391088, 'PTHR35316', NULL, NULL, NULL, NULL, '28S RIBOSOMAL S34 PROTEIN', 249149),
(391089, 'PTHR35316:SF2', NULL, NULL, NULL, NULL, '', 249149);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(391090, 'PTHR35316:SF1', NULL, NULL, NULL, NULL, '28S RIBOSOMAL S34 PROTEIN', 249149),
(391091, 'PTHR11252:SF9', NULL, NULL, NULL, NULL, 'POLYRIBONUCLEOTIDE NUCLEOTIDYLTRANSFERASE 1, MITOCHONDRIAL', 249150),
(391092, 'PTHR11252:SF14', NULL, NULL, NULL, NULL, 'BNAA08G12540D PROTEIN', 249150),
(391093, 'PTHR11252:SF10', NULL, NULL, NULL, NULL, 'POLYRIBONUCLEOTIDE NUCLEOTIDYLTRANSFERASE', 249150),
(391094, 'PTHR11252:SF0', NULL, NULL, NULL, NULL, 'POLYRIBONUCLEOTIDE NUCLEOTIDYLTRANSFERASE 1, MITOCHONDRIAL', 249150),
(391095, 'PTHR11252:SF15', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDE PHOSPHORYLASE 1', 249150),
(391096, 'PTHR11252', NULL, NULL, NULL, NULL, 'POLYRIBONUCLEOTIDE NUCLEOTIDYLTRANSFERASE', 249150),
(391097, 'PTHR11252:SF16', NULL, NULL, NULL, NULL, 'POLYRIBONUCLEOTIDE NUCLEOTIDYLTRANSFERASE 2, MITOCHONDRIAL', 249150),
(391098, 'PTHR37218:SF3', NULL, NULL, NULL, NULL, 'BNAC04G04270D PROTEIN', 249151),
(391099, 'PTHR37218:SF2', NULL, NULL, NULL, NULL, 'COILED-COIL PROTEIN', 249151),
(391100, 'PTHR37218', NULL, NULL, NULL, NULL, 'COILED-COIL PROTEIN', 249151),
(391101, 'PTHR33434:SF7', NULL, NULL, NULL, NULL, 'PROTEIN DEGV', 249152),
(391102, 'PTHR33434:SF4', NULL, NULL, NULL, NULL, 'PHOSPHATASE PROTEIN-RELATED', 249152),
(391103, 'PTHR33434:SF2', NULL, NULL, NULL, NULL, 'DEGV DOMAIN-CONTAINING PROTEIN DR_1986', 249152),
(391104, 'PTHR33434:SF3', NULL, NULL, NULL, NULL, 'FATTY ACID-BINDING PROTEIN TM_1468', 249152),
(391105, 'PTHR33434', NULL, NULL, NULL, NULL, 'DEGV DOMAIN-CONTAINING PROTEIN DR_1986-RELATED', 249152),
(391106, 'PTHR21603:SF16', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE-ASSOCIATED PROTEIN 2', 249153),
(391107, 'PTHR21603:SF17', NULL, NULL, NULL, NULL, 'PROLIFERATION MARKER PROTEIN KI-67', 249153),
(391108, 'PTHR21603', NULL, NULL, NULL, NULL, 'ANTIGEN KI-67-LIKE PROTEIN', 249153),
(391109, 'PTHR21603:SF18', NULL, NULL, NULL, NULL, 'ANTIGEN KI-67-LIKE PROTEIN', 249153),
(391110, 'PTHR45683:SF2', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL NICOTINAMIDE ADENINE DINUCLEOTIDE TRANSPORTER 1-RELATED', 249154),
(391111, 'PTHR45683:SF16', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN M', 249154),
(391112, 'PTHR45683:SF17', NULL, NULL, NULL, NULL, 'FOLATE CARRIER PROTEIN', 249154),
(391113, 'PTHR45683:SF6', NULL, NULL, NULL, NULL, 'CARRIER PROTEIN, PUTATIVE-RELATED', 249154),
(391114, 'PTHR45683:SF5', NULL, NULL, NULL, NULL, 'OS02G0225000 PROTEIN', 249154),
(391115, 'PTHR45683', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL NICOTINAMIDE ADENINE DINUCLEOTIDE TRANSPORTER 1-RELATED-RELATED', 249154),
(391116, 'PTHR45683:SF3', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL FOLATE TRANSPORTER/CARRIER', 249154),
(391117, 'PTHR45683:SF9', NULL, NULL, NULL, NULL, 'NICOTINAMIDE ADENINE DINUCLEOTIDE TRANSPORTER 1, CHLOROPLASTIC', 249154),
(391118, 'PTHR45683:SF8', NULL, NULL, NULL, NULL, 'PEROXISOMAL NICOTINAMIDE ADENINE DINUCLEOTIDE CARRIER', 249154),
(391119, 'PTHR45683:SF14', NULL, NULL, NULL, NULL, 'BNAC04G05390D PROTEIN', 249154),
(391120, 'PTHR45683:SF12', NULL, NULL, NULL, NULL, 'BNAA09G07970D PROTEIN', 249154),
(391121, 'PTHR45683:SF10', NULL, NULL, NULL, NULL, 'BNAA09G28490D PROTEIN', 249154),
(391122, 'PTHR45683:SF11', NULL, NULL, NULL, NULL, 'BNAC06G30010D PROTEIN', 249154),
(391123, 'PTHR36721:SF4', NULL, NULL, NULL, NULL, 'BNACNNG28470D PROTEIN', 249155),
(391124, 'PTHR36721:SF7', NULL, NULL, NULL, NULL, 'BNAC04G15770D PROTEIN', 249155),
(391125, 'PTHR36721:SF6', NULL, NULL, NULL, NULL, 'CLASSICAL ARABINOGALACTAN PROTEIN 1-LIKE', 249155),
(391126, 'PTHR36721:SF1', NULL, NULL, NULL, NULL, 'OS04G0446401 PROTEIN', 249155),
(391127, 'PTHR36721:SF10', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249155),
(391128, 'PTHR36721:SF3', NULL, NULL, NULL, NULL, '', 249155),
(391129, 'PTHR36721:SF14', NULL, NULL, NULL, NULL, 'BNAA10G13440D PROTEIN', 249155),
(391130, 'PTHR36721:SF13', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 249155),
(391131, 'PTHR36721:SF12', NULL, NULL, NULL, NULL, 'PROLINE-RICH FAMILY PROTEIN', 249155),
(391132, 'PTHR36721:SF11', NULL, NULL, NULL, NULL, 'EN/SPM-LIKE TRANSPOSON PROTEIN', 249155);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(391133, 'PTHR36721:SF8', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 249155),
(391134, 'PTHR36721', NULL, NULL, NULL, NULL, 'PROLINE-RICH FAMILY PROTEIN', 249155),
(391135, 'PTHR15065', NULL, NULL, NULL, NULL, 'INSULINOMA-ASSOCIATED 1', 249156),
(391136, 'PTHR15065:SF6', NULL, NULL, NULL, NULL, 'INSULINOMA-ASSOCIATED PROTEIN 2', 249156),
(391137, 'PTHR15065:SF5', NULL, NULL, NULL, NULL, 'INSULINOMA-ASSOCIATED PROTEIN 1', 249156),
(391138, 'PTHR15065:SF4', NULL, NULL, NULL, NULL, 'LD18634P', 249156),
(391139, 'PTHR15065:SF10', NULL, NULL, NULL, NULL, 'NERVOUS FINGERS 2, ISOFORM B', 249156),
(391140, 'PTHR16551:SF5', NULL, NULL, NULL, NULL, 'AGOUTI-RELATED PEPTIDE 2', 249157),
(391141, 'PTHR16551', NULL, NULL, NULL, NULL, 'AGOUTI RELATED', 249157),
(391142, 'PTHR16551:SF4', NULL, NULL, NULL, NULL, 'AGOUTI-RELATED PROTEIN', 249157),
(391143, 'PTHR16551:SF1', NULL, NULL, NULL, NULL, 'AGOUTI-SIGNALING PROTEIN', 249157),
(391144, 'PTHR12274:SF3', NULL, NULL, NULL, NULL, 'PROGRANULIN', 249158),
(391145, 'PTHR12274:SF8', NULL, NULL, NULL, NULL, 'GRANULIN A', 249158),
(391146, 'PTHR12274:SF7', NULL, NULL, NULL, NULL, 'GRANULIN 1-RELATED', 249158),
(391147, 'PTHR12274:SF6', NULL, NULL, NULL, NULL, 'GRANULIN B', 249158),
(391148, 'PTHR12274', NULL, NULL, NULL, NULL, 'GRANULIN', 249158),
(391149, 'PTHR38705:SF1', NULL, NULL, NULL, NULL, 'PROTEIN RDS1', 249159),
(391150, 'PTHR38705', NULL, NULL, NULL, NULL, 'PROTEIN RDS1', 249159),
(391151, 'PTHR38705:SF5', NULL, NULL, NULL, NULL, 'RESPONSE PROTEIN RDS1, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G12490)-RELATED', 249159),
(391152, 'PTHR31392', NULL, NULL, NULL, NULL, 'ALPHA-1,3-MANNOSYLTRANSFERASE MNN1-RELATED', 249160),
(391153, 'PTHR31392:SF1', NULL, NULL, NULL, NULL, 'ALPHA-1,3-MANNOSYLTRANSFERASE MNN1-RELATED', 249160),
(391154, 'PTHR15858:SF3', NULL, NULL, NULL, NULL, '', 249161),
(391155, 'PTHR15858:SF0', NULL, NULL, NULL, NULL, 'IMMEDIATE EARLY RESPONSE 3-INTERACTING PROTEIN 1', 249161),
(391156, 'PTHR15858', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 249161),
(391157, 'PTHR15858:SF6', NULL, NULL, NULL, NULL, 'IMMEDIATE EARLY RESPONSE 3-INTERACTING PROTEIN 1-LIKE', 249161),
(391158, 'PTHR15858:SF4', NULL, NULL, NULL, NULL, 'YOS1-LIKE PROTEIN', 249161),
(391159, 'PTHR15858:SF5', NULL, NULL, NULL, NULL, 'IMMEDIATE EARLY RESPONSE 3-INTERACTING PROTEIN 1-LIKE', 249161),
(391160, 'PTHR31373:SF18', NULL, NULL, NULL, NULL, '', 249162),
(391161, 'PTHR31373:SF17', NULL, NULL, NULL, NULL, 'OS06G0652100 PROTEIN', 249162),
(391162, 'PTHR31373:SF19', NULL, NULL, NULL, NULL, '', 249162),
(391163, 'PTHR31373:SF21', NULL, NULL, NULL, NULL, '', 249162),
(391164, 'PTHR31373:SF20', NULL, NULL, NULL, NULL, 'OS09G0499400 PROTEIN', 249162),
(391165, 'PTHR31373', NULL, NULL, NULL, NULL, 'OS06G0652100 PROTEIN', 249162),
(391166, 'PTHR31373:SF25', NULL, NULL, NULL, NULL, 'OS02G0179600 PROTEIN', 249162),
(391167, 'PTHR31373:SF13', NULL, NULL, NULL, NULL, '', 249162),
(391168, 'PTHR31373:SF24', NULL, NULL, NULL, NULL, '', 249162),
(391169, 'PTHR31373:SF27', NULL, NULL, NULL, NULL, 'EMB|CAB86628.1', 249162),
(391170, 'PTHR31373:SF26', NULL, NULL, NULL, NULL, '', 249162),
(391171, 'PTHR24327:SF26', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN DLX-6', 249163),
(391172, 'PTHR24327:SF25', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN CEH-23', 249163),
(391173, 'PTHR24327:SF28', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN DLX-3', 249163),
(391174, 'PTHR24327', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN', 249163),
(391175, 'PTHR24327:SF29', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN VENTX', 249163),
(391176, 'PTHR24327:SF84', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 249163),
(391177, 'PTHR24327:SF83', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN NANOG2-RELATED', 249163),
(391178, 'PTHR24327:SF72', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN NANOG', 249163),
(391179, 'PTHR24327:SF31', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN DLX-5', 249163),
(391180, 'PTHR24327:SF41', NULL, NULL, NULL, NULL, 'BRAIN-SPECIFIC HOMEOBOX PROTEIN', 249163),
(391181, 'PTHR24327:SF33', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN DLX-1', 249163);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(391182, 'PTHR24327:SF21', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN DLX-4', 249163),
(391183, 'PTHR24327:SF68', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 249163),
(391184, 'PTHR24327:SF35', NULL, NULL, NULL, NULL, 'BRAIN-SPECIFIC HOMEOBOX PROTEIN HOMOLOG', 249163),
(391185, 'PTHR24327:SF79', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN NANOG-RELATED', 249163),
(391186, 'PTHR24327:SF67', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 249163),
(391187, 'PTHR24327:SF23', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN DLX-2', 249163),
(391188, 'PTHR24327:SF82', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN DLX2B', 249163),
(391189, 'PTHR24327:SF70', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 249163),
(391190, 'PTHR24327:SF81', NULL, NULL, NULL, NULL, 'HOMEOTIC PROTEIN DISTAL-LESS-RELATED', 249163),
(391191, 'PTHR23282:SF116', NULL, NULL, NULL, NULL, 'MAM DOMAIN-CONTAINING PROTEIN 2', 249164),
(391192, 'PTHR23282:SF137', NULL, NULL, NULL, NULL, 'MAM DOMAIN-CONTAINING GLYCOSYLPHOSPHATIDYLINOSITOL ANCHOR PROTEIN 2', 249164),
(391193, 'PTHR23282:SF123', NULL, NULL, NULL, NULL, 'MAM DOMAIN-CONTAINING GLYCOSYLPHOSPHATIDYLINOSITOL ANCHOR PROTEIN 1', 249164),
(391194, 'PTHR23282:SF101', NULL, NULL, NULL, NULL, 'CLASS C SCAVENGER RECEPTOR (SUSHI/SCR/CCP AND SOMATOMEDIN B DOMAINS)', 249164),
(391195, 'PTHR23282:SF143', NULL, NULL, NULL, NULL, 'MAM DOMAIN-CONTAINING PROTEIN', 249164),
(391196, 'PTHR23282', NULL, NULL, NULL, NULL, 'APICAL ENDOSOMAL GLYCOPROTEIN PRECURSOR.', 249164),
(391197, 'PTHR23282:SF133', NULL, NULL, NULL, NULL, 'MAM DOMAIN-CONTAINING 2B', 249164),
(391198, 'PTHR23282:SF141', NULL, NULL, NULL, NULL, 'SI:CH211-106H4.4', 249164),
(391199, 'PTHR23282:SF142', NULL, NULL, NULL, NULL, 'RT07201P-RELATED', 249164),
(391200, 'PTHR23282:SF140', NULL, NULL, NULL, NULL, 'MAM AND LDL-RECEPTOR CLASS A DOMAIN-CONTAINING PROTEIN 1', 249164),
(391201, 'PTHR23282:SF129', NULL, NULL, NULL, NULL, 'APICAL ENDOSOMAL GLYCOPROTEIN', 249164),
(391202, 'PTHR35573:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG21099', 249165),
(391203, 'PTHR35573:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG14359', 249165),
(391204, 'PTHR35573:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG22129', 249165),
(391205, 'PTHR35573', NULL, NULL, NULL, NULL, 'PROTEIN CBG22129', 249165),
(391206, 'PTHR35573:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG21098', 249165),
(391207, 'PTHR35739:SF1', NULL, NULL, NULL, NULL, 'OS01G0861700 PROTEIN', 249166),
(391208, 'PTHR35739:SF3', NULL, NULL, NULL, NULL, 'HEMERYTHRIN HHE CATION-BINDING DOMAIN PROTEIN', 249166),
(391209, 'PTHR35739', NULL, NULL, NULL, NULL, 'OS01G0861700 PROTEIN', 249166),
(391210, 'PTHR23330:SF10', NULL, NULL, NULL, NULL, '', 249167),
(391211, 'PTHR23330:SF6', NULL, NULL, NULL, NULL, 'WASP HOMOLOG-ASSOCIATED PROTEIN WITH ACTIN, MEMBRANES AND MICROTUBULES', 249167),
(391212, 'PTHR23330', NULL, NULL, NULL, NULL, 'P300 TRANSCRIPTIONAL COFACTOR JMY-RELATED', 249167),
(391213, 'PTHR23330:SF9', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 11', 249167),
(391214, 'PTHR23330:SF8', NULL, NULL, NULL, NULL, 'JUNCTION-MEDIATING AND -REGULATORY PROTEIN', 249167),
(391215, 'PTHR46403:SF1', NULL, NULL, NULL, NULL, 'TP53-REGULATED INHIBITOR OF APOPTOSIS 1', 249168),
(391216, 'PTHR46403', NULL, NULL, NULL, NULL, 'TP53-REGULATED INHIBITOR OF APOPTOSIS 1', 249168),
(391217, 'PTHR39569:SF1', NULL, NULL, NULL, NULL, 'INORGANIC TRIPHOSPHATASE', 249169),
(391218, 'PTHR39569', NULL, NULL, NULL, NULL, 'INORGANIC TRIPHOSPHATASE', 249169),
(391219, 'PTHR31388:SF191', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391220, 'PTHR31388:SF194', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391221, 'PTHR31388:SF195', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391222, 'PTHR31388:SF23', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391223, 'PTHR31388:SF231', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391224, 'PTHR31388:SF24', NULL, NULL, NULL, NULL, 'PEROXIDASE 52', 249170),
(391225, 'PTHR31388:SF198', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391226, 'PTHR31388:SF199', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(391227, 'PTHR31388:SF232', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391228, 'PTHR31388:SF230', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391229, 'PTHR31388:SF27', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391230, 'PTHR31388:SF197', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391231, 'PTHR31388:SF235', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391232, 'PTHR31388:SF28', NULL, NULL, NULL, NULL, 'PEROXIDASE 40', 249170),
(391233, 'PTHR31388:SF114', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391234, 'PTHR31388:SF115', NULL, NULL, NULL, NULL, 'PEROXIDASE 5', 249170),
(391235, 'PTHR31388:SF112', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391236, 'PTHR31388:SF233', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391237, 'PTHR31388:SF113', NULL, NULL, NULL, NULL, 'PEROXIDASE 37-RELATED', 249170),
(391238, 'PTHR31388:SF239', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391239, 'PTHR31388:SF116', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391240, 'PTHR31388:SF237', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391241, 'PTHR31388:SF117', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391242, 'PTHR31388:SF238', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391243, 'PTHR31388:SF180', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391244, 'PTHR31388:SF5', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391245, 'PTHR31388:SF2', NULL, NULL, NULL, NULL, 'PEROXIDASE 17', 249170),
(391246, 'PTHR31388:SF3', NULL, NULL, NULL, NULL, 'PEROXIDASE 72', 249170),
(391247, 'PTHR31388:SF183', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391248, 'PTHR31388:SF11', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391249, 'PTHR31388:SF99', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391250, 'PTHR31388:SF182', NULL, NULL, NULL, NULL, 'PEROXIDASE 49', 249170),
(391251, 'PTHR31388:SF220', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391252, 'PTHR31388:SF13', NULL, NULL, NULL, NULL, 'PEROXIDASE 2', 249170),
(391253, 'PTHR31388:SF187', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391254, 'PTHR31388:SF221', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391255, 'PTHR31388:SF188', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391256, 'PTHR31388:SF185', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391257, 'PTHR31388:SF17', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391258, 'PTHR31388:SF225', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391259, 'PTHR31388:SF104', NULL, NULL, NULL, NULL, 'PEROXIDASE 14-RELATED', 249170),
(391260, 'PTHR31388:SF189', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391261, 'PTHR31388:SF19', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391262, 'PTHR31388:SF222', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391263, 'PTHR31388:SF228', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391264, 'PTHR31388:SF229', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391265, 'PTHR31388:SF226', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391266, 'PTHR31388:SF227', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391267, 'PTHR31388:SF106', NULL, NULL, NULL, NULL, 'PEROXIDASE 32', 249170),
(391268, 'PTHR31388:SF9', NULL, NULL, NULL, NULL, 'PEROXIDASE 11', 249170),
(391269, 'PTHR31388:SF6', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391270, 'PTHR31388:SF253', NULL, NULL, NULL, NULL, 'PEROXIDASE 4', 249170),
(391271, 'PTHR31388:SF132', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391272, 'PTHR31388:SF133', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391273, 'PTHR31388:SF254', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391274, 'PTHR31388:SF251', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391275, 'PTHR31388:SF252', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391276, 'PTHR31388:SF136', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391277, 'PTHR31388:SF257', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391278, 'PTHR31388:SF258', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391279, 'PTHR31388:SF137', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391280, 'PTHR31388:SF134', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(391281, 'PTHR31388:SF256', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391282, 'PTHR31388:SF259', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391283, 'PTHR31388:SF139', NULL, NULL, NULL, NULL, 'PEROXIDASE 53', 249170),
(391284, 'PTHR31388:SF247', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391285, 'PTHR31388:SF126', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391286, 'PTHR31388:SF244', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391287, 'PTHR31388:SF123', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391288, 'PTHR31388:SF245', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391289, 'PTHR31388:SF129', NULL, NULL, NULL, NULL, 'PEROXIDASE 54', 249170),
(391290, 'PTHR31388:SF127', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391291, 'PTHR31388:SF128', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391292, 'PTHR31388:SF249', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391293, 'PTHR31388:SF271', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391294, 'PTHR31388:SF150', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391295, 'PTHR31388:SF272', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391296, 'PTHR31388:SF270', NULL, NULL, NULL, NULL, 'PEROXIDASE 22-RELATED', 249170),
(391297, 'PTHR31388:SF155', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391298, 'PTHR31388:SF152', NULL, NULL, NULL, NULL, 'PEROXIDASE 20', 249170),
(391299, 'PTHR31388:SF153', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391300, 'PTHR31388:SF158', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391301, 'PTHR31388:SF159', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391302, 'PTHR31388:SF157', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391303, 'PTHR31388:SF52', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391304, 'PTHR31388:SF260', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391305, 'PTHR31388:SF54', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391306, 'PTHR31388:SF261', NULL, NULL, NULL, NULL, 'SUBERIZATION-ASSOCIATED ANIONIC PEROXIDASE 2', 249170),
(391307, 'PTHR31388:SF264', NULL, NULL, NULL, NULL, 'PEROXIDASE 59', 249170),
(391308, 'PTHR31388:SF144', NULL, NULL, NULL, NULL, 'PEROXIDASE 67', 249170),
(391309, 'PTHR31388:SF265', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391310, 'PTHR31388:SF262', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391311, 'PTHR31388:SF141', NULL, NULL, NULL, NULL, 'PEROXIDASE 33-RELATED', 249170),
(391312, 'PTHR31388:SF263', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391313, 'PTHR31388:SF142', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391314, 'PTHR31388:SF268', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391315, 'PTHR31388:SF147', NULL, NULL, NULL, NULL, 'PEROXIDASE 58', 249170),
(391316, 'PTHR31388:SF269', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391317, 'PTHR31388:SF266', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391318, 'PTHR31388:SF267', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391319, 'PTHR31388:SF170', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391320, 'PTHR31388:SF45', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391321, 'PTHR31388:SF210', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391322, 'PTHR31388:SF177', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391323, 'PTHR31388:SF48', NULL, NULL, NULL, NULL, 'PEROXIDASE 70', 249170),
(391324, 'PTHR31388:SF174', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391325, 'PTHR31388:SF214', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391326, 'PTHR31388:SF211', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391327, 'PTHR31388:SF178', NULL, NULL, NULL, NULL, 'PEROXIDASE 36', 249170),
(391328, 'PTHR31388:SF179', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391329, 'PTHR31388:SF217', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391330, 'PTHR31388:SF218', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391331, 'PTHR31388:SF215', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391332, 'PTHR31388:SF216', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391333, 'PTHR31388:SF219', NULL, NULL, NULL, NULL, 'PEROXIDASE 68', 249170),
(391334, 'PTHR31388', NULL, NULL, NULL, NULL, 'PEROXIDASE 72-RELATED', 249170);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(391335, 'PTHR31388:SF161', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391336, 'PTHR31388:SF31', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391337, 'PTHR31388:SF34', NULL, NULL, NULL, NULL, 'PEROXIDASE 10', 249170),
(391338, 'PTHR31388:SF160', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391339, 'PTHR31388:SF163', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391340, 'PTHR31388:SF38', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391341, 'PTHR31388:SF164', NULL, NULL, NULL, NULL, 'PEROXIDASE 9', 249170),
(391342, 'PTHR31388:SF169', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391343, 'PTHR31388:SF202', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391344, 'PTHR31388:SF203', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391345, 'PTHR31388:SF167', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391346, 'PTHR31388:SF200', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391347, 'PTHR31388:SF201', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391348, 'PTHR31388:SF207', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391349, 'PTHR31388:SF204', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391350, 'PTHR31388:SF205', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391351, 'PTHR31388:SF208', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391352, 'PTHR31388:SF209', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249170),
(391353, 'PTHR10590:SF4', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 28 MEMBER 3', 249171),
(391354, 'PTHR10590', NULL, NULL, NULL, NULL, 'SODIUM/NUCLEOSIDE COTRANSPORTER', 249171),
(391355, 'PTHR10590:SF22', NULL, NULL, NULL, NULL, 'SODIUM/NUCLEOSIDE COTRANSPORTER', 249171),
(391356, 'PTHR10590:SF11', NULL, NULL, NULL, NULL, 'SODIUM/NUCLEOSIDE COTRANSPORTER 2', 249171),
(391357, 'PTHR10590:SF23', NULL, NULL, NULL, NULL, 'NUCLEOSIDE PERMEASE NUPC', 249171),
(391358, 'PTHR10590:SF20', NULL, NULL, NULL, NULL, 'SODIUM/NUCLEOSIDE COTRANSPORTER', 249171),
(391359, 'PTHR10590:SF21', NULL, NULL, NULL, NULL, 'NUCLEOSIDE PERMEASE NUPC', 249171),
(391360, 'PTHR10590:SF16', NULL, NULL, NULL, NULL, 'SODIUM/NUCLEOSIDE COTRANSPORTER 1', 249171),
(391361, 'PTHR10590:SF13', NULL, NULL, NULL, NULL, 'NUCLEOSIDE PERMEASE NUPC', 249171),
(391362, 'PTHR10590:SF19', NULL, NULL, NULL, NULL, 'PURINE NUCLEOSIDE TRANSPORT PROTEIN NUPG', 249171),
(391363, 'PTHR39535:SF1', NULL, NULL, NULL, NULL, 'HTTM DOMAIN-CONTAINING PROTEIN', 249172),
(391364, 'PTHR39535:SF3', NULL, NULL, NULL, NULL, 'HTTM DOMAIN-CONTAINING PROTEIN', 249172),
(391365, 'PTHR39535:SF2', NULL, NULL, NULL, NULL, 'HTTM DOMAIN-CONTAINING PROTEIN', 249172),
(391366, 'PTHR39535:SF4', NULL, NULL, NULL, NULL, 'HTTM DOMAIN-CONTAINING PROTEIN', 249172),
(391367, 'PTHR39535', NULL, NULL, NULL, NULL, 'SPORULATION-DELAYING PROTEIN SDPB', 249172),
(391368, 'PTHR46830:SF1', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 249173),
(391369, 'PTHR46830', NULL, NULL, NULL, NULL, 'TRANSFERASE, PUTATIVE-RELATED', 249173),
(391370, 'PTHR11205:SF18', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S5', 249174),
(391371, 'PTHR11205:SF39', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S7', 249174),
(391372, 'PTHR11205:SF38', NULL, NULL, NULL, NULL, 'RIBOSOMAL_S7 DOMAIN-CONTAINING PROTEIN', 249174),
(391373, 'PTHR11205:SF59', NULL, NULL, NULL, NULL, 'RIBOSOMAL_S7 DOMAIN-CONTAINING PROTEIN', 249174),
(391374, 'PTHR11205:SF48', NULL, NULL, NULL, NULL, 'RIBOSOMAL_S7 DOMAIN-CONTAINING PROTEIN', 249174),
(391375, 'PTHR11205:SF37', NULL, NULL, NULL, NULL, 'RIBOSOMAL_S7 DOMAIN-CONTAINING PROTEIN', 249174),
(391376, 'PTHR11205', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S7', 249174),
(391377, 'PTHR11205:SF19', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S7, MITOCHONDRIAL', 249174),
(391378, 'PTHR11205:SF43', NULL, NULL, NULL, NULL, 'RIBOSOMAL_S7 DOMAIN-CONTAINING PROTEIN', 249174),
(391379, 'PTHR11205:SF32', NULL, NULL, NULL, NULL, 'RIBOSOMAL_S7 DOMAIN-CONTAINING PROTEIN', 249174),
(391380, 'PTHR11205:SF54', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S5-1', 249174),
(391381, 'PTHR11205:SF53', NULL, NULL, NULL, NULL, 'RIBOSOMAL_S7 DOMAIN-CONTAINING PROTEIN', 249174);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(391382, 'PTHR11205:SF41', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S7, CHLOROPLASTIC', 249174),
(391383, 'PTHR11205:SF52', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S5/S7-RELATED', 249174),
(391384, 'PTHR11205:SF40', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S7-RELATED', 249174),
(391385, 'PTHR11205:SF58', NULL, NULL, NULL, NULL, 'RIBOSOMAL_S7 DOMAIN-CONTAINING PROTEIN', 249174),
(391386, 'PTHR11205:SF57', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S7, CHLOROPLASTIC', 249174),
(391387, 'PTHR11205:SF56', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S7', 249174),
(391388, 'PTHR11205:SF34', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S5', 249174),
(391389, 'PTHR11205:SF45', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S5-LIKE', 249174),
(391390, 'PTHR11205:SF33', NULL, NULL, NULL, NULL, 'RIBOSOMAL_S7 DOMAIN-CONTAINING PROTEIN', 249174),
(391391, 'PTHR11205:SF55', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S5-2', 249174),
(391392, 'PTHR11205:SF44', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S7, CHLOROPLASTIC', 249174),
(391393, 'PTHR15657', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 249175),
(391394, 'PTHR15657:SF1', NULL, NULL, NULL, NULL, 'THYROID TRANSCRIPTION FACTOR 1-ASSOCIATED PROTEIN 26', 249175),
(391395, 'PTHR11278:SF3', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S7', 249176),
(391396, 'PTHR11278:SF21', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S7', 249176),
(391397, 'PTHR11278:SF0', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S7', 249176),
(391398, 'PTHR11278:SF10', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S7-3', 249176),
(391399, 'PTHR11278:SF20', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S7', 249176),
(391400, 'PTHR11278:SF7', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S7', 249176),
(391401, 'PTHR11278:SF5', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S7', 249176),
(391402, 'PTHR11278:SF16', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S7', 249176),
(391403, 'PTHR11278:SF27', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S7', 249176),
(391404, 'PTHR11278:SF26', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S7', 249176),
(391405, 'PTHR11278:SF18', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S7', 249176),
(391406, 'PTHR11278:SF12', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S7', 249176),
(391407, 'PTHR11278:SF23', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S7-2', 249176),
(391408, 'PTHR11278:SF22', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S7', 249176),
(391409, 'PTHR11278:SF25', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S7', 249176),
(391410, 'PTHR11278:SF24', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S7', 249176),
(391411, 'PTHR11278', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S7', 249176),
(391412, 'PTHR11278:SF8', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S7', 249176),
(391413, 'PTHR47051', NULL, NULL, NULL, NULL, 'NESTIN', 249177),
(391414, 'PTHR47051:SF1', NULL, NULL, NULL, NULL, 'NESTIN', 249177),
(391415, 'PTHR42805', NULL, NULL, NULL, NULL, 'PTERIN-4-ALPHA-CARBINOLAMINE DEHYDRATASE-RELATED', 249178),
(391416, 'PTHR42805:SF1', NULL, NULL, NULL, NULL, 'PTERIN-4-ALPHA-CARBINOLAMINE DEHYDRATASE-RELATED', 249178),
(391417, 'PTHR47785:SF2', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249179),
(391418, 'PTHR47785:SF3', NULL, NULL, NULL, NULL, 'ZN(2)-C6 FUNGAL-TYPE DOMAIN-CONTAINING PROTEIN', 249179),
(391419, 'PTHR47785:SF4', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249179),
(391420, 'PTHR47785:SF5', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249179),
(391421, 'PTHR47785:SF6', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249179),
(391422, 'PTHR47785:SF7', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249179),
(391423, 'PTHR47785', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED-RELATED', 249179),
(391424, 'PTHR47785:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G14530)-RELATED', 249179);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(391425, 'PTHR11717', NULL, NULL, NULL, NULL, 'LOW MOLECULAR WEIGHT PROTEIN TYROSINE PHOSPHATASE', 249180),
(391426, 'PTHR11717:SF29', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE', 249180),
(391427, 'PTHR11717:SF7', NULL, NULL, NULL, NULL, 'LOW MOLECULAR WEIGHT PHOSPHOTYROSINE PROTEIN PHOSPHATASE', 249180),
(391428, 'PTHR11717:SF32', NULL, NULL, NULL, NULL, 'LOW MOLECULAR WEIGHT PHOSPHOTYROSINE PROTEIN PHOSPHATASE', 249180),
(391429, 'PTHR11717:SF31', NULL, NULL, NULL, NULL, 'LOW MOLECULAR WEIGHT PROTEIN-TYROSINE-PHOSPHATASE ETP-RELATED', 249180),
(391430, 'PTHR11717:SF33', NULL, NULL, NULL, NULL, 'LOW MOLECULAR WEIGHT CYTOSOLIC ACID PHOSPHATASE', 249180),
(391431, 'PTHR21435:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM29', 249181),
(391432, 'PTHR21435', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 249181),
(391433, 'PTHR36356', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249182),
(391434, 'PTHR36356:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249182),
(391435, 'PTHR38469', NULL, NULL, NULL, NULL, '', 249183),
(391436, 'PTHR38469:SF1', NULL, NULL, NULL, NULL, 'DIPEPTIDYL-PEPTIDASE', 249183),
(391437, 'PTHR20997', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 249184),
(391438, 'PTHR20997:SF2', NULL, NULL, NULL, NULL, 'EG:BACR42I17.2 PROTEIN-RELATED', 249184),
(391439, 'PTHR31383:SF2', NULL, NULL, NULL, NULL, 'OXIDATIVE STRESS-RESPONSIVE SERINE-RICH PROTEIN 1', 249185),
(391440, 'PTHR31383', NULL, NULL, NULL, NULL, 'OXIDATIVE STRESS-RESPONSE SERINE-RICH PROTEIN 1', 249185),
(391441, 'PTHR14312:SF1', NULL, NULL, NULL, NULL, 'CREB/ATF BZIP TRANSCRIPTION FACTOR', 249186),
(391442, 'PTHR14312:SF4', NULL, NULL, NULL, NULL, 'BASIC-LEUCINE ZIPPER TRANSCRIPTION FACTOR A', 249186),
(391443, 'PTHR14312:SF5', NULL, NULL, NULL, NULL, 'AGAP007164-PA', 249186),
(391444, 'PTHR14312:SF2', NULL, NULL, NULL, NULL, 'BASIC-LEUCINE ZIPPER TRANSCRIPTION FACTOR I-RELATED', 249186),
(391445, 'PTHR14312', NULL, NULL, NULL, NULL, 'CREB/ATF BZIP TRANSCRIPTION FACTOR', 249186),
(391446, 'PTHR14312:SF6', NULL, NULL, NULL, NULL, 'SAP DNA-BINDING DOMAIN-CONTAINING PROTEIN', 249186),
(391447, 'PTHR11660:SF57', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 40 PROTEIN', 249187),
(391448, 'PTHR11660:SF68', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 40 MEMBER 1', 249187),
(391449, 'PTHR11660:SF69', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 40 PROTEIN', 249187),
(391450, 'PTHR11660:SF47', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 40 MEMBER 1', 249187),
(391451, 'PTHR11660:SF53', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 40 MEMBER 3, CHLOROPLASTIC', 249187),
(391452, 'PTHR11660:SF70', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 40 PROTEIN', 249187),
(391453, 'PTHR11660:SF51', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 40 MEMBER 3, CHLOROPLASTIC', 249187),
(391454, 'PTHR11660:SF50', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 40 PROTEIN', 249187),
(391455, 'PTHR11660', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 40 MEMBER', 249187),
(391456, 'PTHR12126:SF8', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 249188),
(391457, 'PTHR12126:SF9', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 249188),
(391458, 'PTHR12126:SF10', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX SUBUNIT 9, MITOCHONDRIAL', 249188),
(391459, 'PTHR12126:SF11', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX SUBUNIT 9, MITOCHONDRIAL', 249188),
(391460, 'PTHR12126:SF13', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 249188),
(391461, 'PTHR12126', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE 39 KDA SUBUNIT-RELATED', 249188),
(391462, 'PTHR12126:SF15', NULL, NULL, NULL, NULL, 'NAD(P)-BD_DOM DOMAIN-CONTAINING PROTEIN', 249188),
(391463, 'PTHR12126:SF16', NULL, NULL, NULL, NULL, 'MIOREX COMPLEX COMPONENT 2', 249188),
(391464, 'PTHR12126:SF6', NULL, NULL, NULL, NULL, '3BETA_HSD DOMAIN-CONTAINING PROTEIN', 249188),
(391465, 'PTHR12126:SF5', NULL, NULL, NULL, NULL, 'OS04G0403500 PROTEIN', 249188);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(391466, 'PTHR37850:SF1', NULL, NULL, NULL, NULL, 'SAF DOMAIN PROTEIN', 249189),
(391467, 'PTHR37850:SF3', NULL, NULL, NULL, NULL, 'BLR7815 PROTEIN', 249189),
(391468, 'PTHR37850:SF2', NULL, NULL, NULL, NULL, 'SAF DOMAIN PROTEIN', 249189),
(391469, 'PTHR37850', NULL, NULL, NULL, NULL, 'STRU PROTEIN', 249189),
(391470, 'PTHR45664:SF18', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 249190),
(391471, 'PTHR45664:SF2', NULL, NULL, NULL, NULL, 'HOMEOTIC PROTEIN PROBOSCIPEDIA', 249190),
(391472, 'PTHR45664:SF3', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-A2', 249190),
(391473, 'PTHR45664:SF13', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-A3', 249190),
(391474, 'PTHR45664:SF5', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-D3', 249190),
(391475, 'PTHR45664:SF11', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-B3', 249190),
(391476, 'PTHR45664:SF12', NULL, NULL, NULL, NULL, 'PANCREAS/DUODENUM HOMEOBOX PROTEIN 1', 249190),
(391477, 'PTHR45664:SF7', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-B2', 249190),
(391478, 'PTHR45664:SF20', NULL, NULL, NULL, NULL, 'AGAP001560-PA', 249190),
(391479, 'PTHR45664', NULL, NULL, NULL, NULL, 'PROTEIN ZERKNUELLT 1-RELATED', 249190),
(391480, 'PTHR45664:SF19', NULL, NULL, NULL, NULL, 'AGAP002372-PA', 249190),
(391481, 'PTHR23132:SF26', NULL, NULL, NULL, NULL, 'BLR7451 PROTEIN', 249191),
(391482, 'PTHR23132:SF0', NULL, NULL, NULL, NULL, 'D-ALANINE-D-ALANINE LIGASE FAMILY', 249191),
(391483, 'PTHR23132', NULL, NULL, NULL, NULL, 'D-ALANINE--D-ALANINE LIGASE', 249191),
(391484, 'PTHR23132:SF23', NULL, NULL, NULL, NULL, 'D-ALANINE--D-ALANINE LIGASE B', 249191),
(391485, 'PTHR23132:SF14', NULL, NULL, NULL, NULL, 'ATP-GRASP DOMAIN-CONTAINING PROTEIN', 249191),
(391486, 'PTHR23132:SF25', NULL, NULL, NULL, NULL, 'D-ALANINE--D-ALANINE LIGASE A', 249191),
(391487, 'PTHR47929:SF139', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249192),
(391488, 'PTHR47929:SF138', NULL, NULL, NULL, NULL, 'OS08G0511000 PROTEIN', 249192),
(391489, 'PTHR47929:SF22', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391490, 'PTHR47929:SF21', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249192),
(391491, 'PTHR47929:SF131', NULL, NULL, NULL, NULL, 'BNAA03G19160D PROTEIN', 249192),
(391492, 'PTHR47929:SF130', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391493, 'PTHR47929:SF133', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391494, 'PTHR47929:SF132', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 249192),
(391495, 'PTHR47929:SF135', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249192),
(391496, 'PTHR47929:SF134', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391497, 'PTHR47929:SF137', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391498, 'PTHR47929:SF136', NULL, NULL, NULL, NULL, 'BNAC04G08260D PROTEIN', 249192),
(391499, 'PTHR47929:SF14', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN-RELATED', 249192),
(391500, 'PTHR47929:SF19', NULL, NULL, NULL, NULL, '', 249192),
(391501, 'PTHR47929:SF17', NULL, NULL, NULL, NULL, '', 249192),
(391502, 'PTHR47929:SF18', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391503, 'PTHR47929:SF128', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249192),
(391504, 'PTHR47929:SF127', NULL, NULL, NULL, NULL, 'OS02G0529900 PROTEIN', 249192),
(391505, 'PTHR47929:SF129', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391506, 'PTHR47929:SF33', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391507, 'PTHR47929:SF34', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249192),
(391508, 'PTHR47929:SF32', NULL, NULL, NULL, NULL, 'OS03G0852700 PROTEIN', 249192),
(391509, 'PTHR47929:SF120', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(391510, 'PTHR47929:SF122', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391511, 'PTHR47929:SF121', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391512, 'PTHR47929:SF124', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391513, 'PTHR47929:SF123', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391514, 'PTHR47929:SF126', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391515, 'PTHR47929:SF125', NULL, NULL, NULL, NULL, '', 249192),
(391516, 'PTHR47929:SF25', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN DOT4, CHLOROPLASTIC-LIKE', 249192),
(391517, 'PTHR47929:SF117', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391518, 'PTHR47929:SF84', NULL, NULL, NULL, NULL, '', 249192),
(391519, 'PTHR47929:SF85', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391520, 'PTHR47929:SF116', NULL, NULL, NULL, NULL, 'BNAA04G15120D PROTEIN', 249192),
(391521, 'PTHR47929:SF119', NULL, NULL, NULL, NULL, 'OS06G0625800 PROTEIN', 249192),
(391522, 'PTHR47929:SF82', NULL, NULL, NULL, NULL, '', 249192),
(391523, 'PTHR47929:SF83', NULL, NULL, NULL, NULL, '', 249192),
(391524, 'PTHR47929:SF118', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249192),
(391525, 'PTHR47929:SF88', NULL, NULL, NULL, NULL, 'OS06G0114366 PROTEIN', 249192),
(391526, 'PTHR47929:SF89', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391527, 'PTHR47929:SF86', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391528, 'PTHR47929:SF87', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391529, 'PTHR47929:SF111', NULL, NULL, NULL, NULL, 'OS02G0818800 PROTEIN', 249192),
(391530, 'PTHR47929:SF110', NULL, NULL, NULL, NULL, '', 249192),
(391531, 'PTHR47929:SF80', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391532, 'PTHR47929:SF113', NULL, NULL, NULL, NULL, '', 249192),
(391533, 'PTHR47929:SF81', NULL, NULL, NULL, NULL, 'ROTAMASE', 249192),
(391534, 'PTHR47929:SF112', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN, DYW DOMAIN PROTEIN-RELATED', 249192),
(391535, 'PTHR47929:SF115', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391536, 'PTHR47929:SF114', NULL, NULL, NULL, NULL, '', 249192),
(391537, 'PTHR47929:SF79', NULL, NULL, NULL, NULL, '', 249192),
(391538, 'PTHR47929:SF95', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249192),
(391539, 'PTHR47929:SF106', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391540, 'PTHR47929:SF96', NULL, NULL, NULL, NULL, '', 249192),
(391541, 'PTHR47929:SF105', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391542, 'PTHR47929:SF93', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391543, 'PTHR47929:SF108', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249192),
(391544, 'PTHR47929:SF94', NULL, NULL, NULL, NULL, '', 249192),
(391545, 'PTHR47929:SF107', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 249192),
(391546, 'PTHR47929:SF11', NULL, NULL, NULL, NULL, 'OS04G0432800 PROTEIN', 249192),
(391547, 'PTHR47929:SF99', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249192),
(391548, 'PTHR47929', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391549, 'PTHR47929:SF109', NULL, NULL, NULL, NULL, '', 249192),
(391550, 'PTHR47929:SF97', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 249192),
(391551, 'PTHR47929:SF98', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249192),
(391552, 'PTHR47929:SF100', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249192),
(391553, 'PTHR47929:SF102', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249192);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(391554, 'PTHR47929:SF91', NULL, NULL, NULL, NULL, '', 249192),
(391555, 'PTHR47929:SF92', NULL, NULL, NULL, NULL, 'OS10G0558600 PROTEIN', 249192),
(391556, 'PTHR47929:SF101', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 249192),
(391557, 'PTHR47929:SF104', NULL, NULL, NULL, NULL, 'OS07G0172600 PROTEIN', 249192),
(391558, 'PTHR47929:SF90', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 249192),
(391559, 'PTHR47929:SF103', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391560, 'PTHR47929:SF62', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 249192),
(391561, 'PTHR47929:SF63', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391562, 'PTHR47929:SF60', NULL, NULL, NULL, NULL, '', 249192),
(391563, 'PTHR47929:SF61', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 249192),
(391564, 'PTHR47929:SF66', NULL, NULL, NULL, NULL, 'BNAA06G10220D PROTEIN', 249192),
(391565, 'PTHR47929:SF67', NULL, NULL, NULL, NULL, '', 249192),
(391566, 'PTHR47929:SF64', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 249192),
(391567, 'PTHR47929:SF65', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391568, 'PTHR47929:SF59', NULL, NULL, NULL, NULL, 'OS10G0477200 PROTEIN', 249192),
(391569, 'PTHR47929:SF57', NULL, NULL, NULL, NULL, '', 249192),
(391570, 'PTHR47929:SF58', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391571, 'PTHR47929:SF73', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 249192),
(391572, 'PTHR47929:SF74', NULL, NULL, NULL, NULL, '', 249192),
(391573, 'PTHR47929:SF71', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391574, 'PTHR47929:SF72', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391575, 'PTHR47929:SF77', NULL, NULL, NULL, NULL, 'OS05G0534900 PROTEIN', 249192),
(391576, 'PTHR47929:SF78', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391577, 'PTHR47929:SF75', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391578, 'PTHR47929:SF76', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391579, 'PTHR47929:SF70', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391580, 'PTHR47929:SF68', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 249192),
(391581, 'PTHR47929:SF69', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT PROTEIN-RELATED', 249192),
(391582, 'PTHR47929:SF40', NULL, NULL, NULL, NULL, '', 249192),
(391583, 'PTHR47929:SF41', NULL, NULL, NULL, NULL, '', 249192),
(391584, 'PTHR47929:SF44', NULL, NULL, NULL, NULL, '', 249192),
(391585, 'PTHR47929:SF45', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391586, 'PTHR47929:SF42', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391587, 'PTHR47929:SF43', NULL, NULL, NULL, NULL, '', 249192),
(391588, 'PTHR47929:SF37', NULL, NULL, NULL, NULL, '', 249192),
(391589, 'PTHR47929:SF38', NULL, NULL, NULL, NULL, '', 249192),
(391590, 'PTHR47929:SF35', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN-RELATED', 249192),
(391591, 'PTHR47929:SF36', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249192),
(391592, 'PTHR47929:SF39', NULL, NULL, NULL, NULL, '', 249192),
(391593, 'PTHR47929:SF51', NULL, NULL, NULL, NULL, '', 249192),
(391594, 'PTHR47929:SF52', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 249192),
(391595, 'PTHR47929:SF50', NULL, NULL, NULL, NULL, 'BNAC09G28900D PROTEIN', 249192),
(391596, 'PTHR47929:SF55', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391597, 'PTHR47929:SF56', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 249192),
(391598, 'PTHR47929:SF53', NULL, NULL, NULL, NULL, '', 249192),
(391599, 'PTHR47929:SF54', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192);
INSERT INTO "PUBLIC"."MODEL" VALUES
(391600, 'PTHR47929:SF142', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391601, 'PTHR47929:SF141', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391602, 'PTHR47929:SF9', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 249192),
(391603, 'PTHR47929:SF140', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391604, 'PTHR47929:SF48', NULL, NULL, NULL, NULL, 'BNAA05G20200D PROTEIN', 249192),
(391605, 'PTHR47929:SF49', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249192),
(391606, 'PTHR47929:SF46', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249192),
(391607, 'PTHR47929:SF47', NULL, NULL, NULL, NULL, 'OSJNBB0004A17.12 PROTEIN', 249192),
(391608, 'PTHR47405:SF4', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 249193),
(391609, 'PTHR47405:SF3', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 249193),
(391610, 'PTHR47405', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H-RELATED', 249193),
(391611, 'PTHR47405:SF2', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 249193),
(391612, 'PTHR47405:SF1', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', 249193),
(391613, 'PTHR43115', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE SDR FAMILY MEMBER 11', 249194),
(391614, 'PTHR43115:SF10', NULL, NULL, NULL, NULL, 'AGAP005502-PA', 249194),
(391615, 'PTHR43115:SF4', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE SDR FAMILY MEMBER 11', 249194),
(391616, 'PTHR43007', NULL, NULL, NULL, NULL, '2-PHOSPHO-L-LACTATE TRANSFERASE', 249195),
(391617, 'PTHR43007:SF1', NULL, NULL, NULL, NULL, '2-PHOSPHO-L-LACTATE TRANSFERASE', 249195),
(391618, 'PTHR14955:SF6', NULL, NULL, NULL, NULL, 'RETINOIC ACID-INDUCED PROTEIN 1', 249196),
(391619, 'PTHR14955', NULL, NULL, NULL, NULL, 'RETINOIC ACID INDUCED 1/TRANSCRIPTION FACTOR 20', 249196),
(391620, 'PTHR14955:SF8', NULL, NULL, NULL, NULL, 'SI:CH211-165G14.1-RELATED', 249196),
(391621, 'PTHR14955:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR 20', 249196),
(391622, 'PTHR14955:SF4', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', 249196),
(391623, 'PTHR36942:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG24735', 249197),
(391624, 'PTHR36942', NULL, NULL, NULL, NULL, 'PROTEIN CBG10268', 249197),
(391625, 'PTHR24134:SF26', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 249198),
(391626, 'PTHR24134:SF25', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 4 INHIBITOR C-RELATED', 249198),
(391627, 'PTHR24134:SF24', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX CONTAINING 18', 249198),
(391628, 'PTHR24134:SF23', NULL, NULL, NULL, NULL, 'SI:DKEY-74K8.4-RELATED', 249198),
(391629, 'PTHR24134:SF22', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN-RELATED', 249198),
(391630, 'PTHR24134:SF21', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 249198),
(391631, 'PTHR24134:SF20', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR 2C (P18, INHIBITS CDK4)', 249198),
(391632, 'PTHR24134:SF2', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 249198),
(391633, 'PTHR24134', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING PROTEIN DDB_G0279043', 249198),
(391634, 'PTHR24134:SF9', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX PROTEIN 8', 249198),
(391635, 'PTHR24134:SF19', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 249198),
(391636, 'PTHR24134:SF28', NULL, NULL, NULL, NULL, '', 249198),
(391637, 'PTHR24134:SF16', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 249198),
(391638, 'PTHR24134:SF27', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING DOMAIN-CONTAINING PROTEIN-RELATED', 249198),
(391639, 'PTHR42836', NULL, NULL, NULL, NULL, '7-CARBOXY-7-DEAZAGUANINE SYNTHASE', 249199),
(391640, 'PTHR42836:SF2', NULL, NULL, NULL, NULL, 'PROTEIN YFKA-RELATED', 249199),
(391641, 'PTHR42836:SF1', NULL, NULL, NULL, NULL, '7-CARBOXY-7-DEAZAGUANINE SYNTHASE', 249199),
(391642, 'PTHR11967', NULL, NULL, NULL, NULL, 'ALPHA-1-ACID GLYCOPROTEIN', 249200);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(391643, 'PTHR11967:SF3', NULL, NULL, NULL, NULL, 'ALPHA-1-ACID GLYCOPROTEIN 2', 249200),
(391644, 'PTHR11967:SF2', NULL, NULL, NULL, NULL, 'ALPHA-1-ACID GLYCOPROTEIN 1', 249200),
(391645, 'PTHR21552:SF2', NULL, NULL, NULL, NULL, 'CREB3 REGULATORY FACTOR', 249201),
(391646, 'PTHR21552', NULL, NULL, NULL, NULL, 'ADULT RETINA PROTEIN', 249201),
(391647, 'PTHR24338:SF10', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN MSX-2', 249202),
(391648, 'PTHR24338:SF9', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN MSX-3', 249202),
(391649, 'PTHR24338:SF13', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 249202),
(391650, 'PTHR24338', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN MSX', 249202),
(391651, 'PTHR24338:SF8', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN MSX-1', 249202),
(391652, 'PTHR24338:SF0', NULL, NULL, NULL, NULL, 'MUSCLE SEGMENTATION HOMEOBOX', 249202),
(391653, 'PTHR15892', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOMAL PROTEIN L30', 249203),
(391654, 'PTHR15892:SF3', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L30 DOMAIN-CONTAINING PROTEIN', 249203),
(391655, 'PTHR15892:SF2', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L30, MITOCHONDRIAL', 249203),
(391656, 'PTHR14871:SF1', NULL, NULL, NULL, NULL, 'DYNEIN REGULATORY COMPLEX PROTEIN 9', 249204),
(391657, 'PTHR14871', NULL, NULL, NULL, NULL, 'DYNEIN REGULATORY COMPLEX PROTEIN 9', 249204),
(391658, 'PTHR36347:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249205),
(391659, 'PTHR36347', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249205),
(391660, 'PTHR34362:SF1', NULL, NULL, NULL, NULL, 'WPP DOMAIN-CONTAINING PROTEIN 1-RELATED', 249206),
(391661, 'PTHR34362:SF8', NULL, NULL, NULL, NULL, 'WPP DOMAIN-CONTAINING PROTEIN', 249206),
(391662, 'PTHR34362', NULL, NULL, NULL, NULL, 'WPP DOMAIN-CONTAINING PROTEIN 1-RELATED', 249206),
(391663, 'PTHR34362:SF11', NULL, NULL, NULL, NULL, 'MFP1 ATTACHMENT FACTOR-LIKE PROTEIN', 249206),
(391664, 'PTHR34362:SF10', NULL, NULL, NULL, NULL, 'MFP1 ATTACHMENT FACTOR 1-LIKE', 249206),
(391665, 'PTHR34362:SF9', NULL, NULL, NULL, NULL, 'WPP DOMAIN-CONTAINING PROTEIN 2', 249206),
(391666, 'PTHR28228:SF1', NULL, NULL, NULL, NULL, 'SECRETORY COMPONENT PROTEIN SHR3', 249207),
(391667, 'PTHR28228', NULL, NULL, NULL, NULL, 'SECRETORY COMPONENT PROTEIN SHR3', 249207),
(391668, 'PTHR34377:SF7', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249208),
(391669, 'PTHR34377:SF4', NULL, NULL, NULL, NULL, 'OS09G0309600 PROTEIN', 249208),
(391670, 'PTHR34377:SF3', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 249208),
(391671, 'PTHR34377:SF1', NULL, NULL, NULL, NULL, '', 249208),
(391672, 'PTHR34377:SF12', NULL, NULL, NULL, NULL, 'ARYLAMINE N-ACETYLTRANSFERASE', 249208),
(391673, 'PTHR34377:SF10', NULL, NULL, NULL, NULL, '', 249208),
(391674, 'PTHR34377:SF11', NULL, NULL, NULL, NULL, '', 249208),
(391675, 'PTHR34377', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 249208),
(391676, 'PTHR31517:SF8', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249209),
(391677, 'PTHR31517:SF14', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249209),
(391678, 'PTHR31517:SF79', NULL, NULL, NULL, NULL, 'PEROXIDASE 35-RELATED', 249209),
(391679, 'PTHR31517:SF35', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249209),
(391680, 'PTHR31517:SF57', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249209),
(391681, 'PTHR31517:SF59', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249209),
(391682, 'PTHR31517:SF17', NULL, NULL, NULL, NULL, 'PEROXIDASE 6', 249209),
(391683, 'PTHR31517:SF3', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249209),
(391684, 'PTHR31517:SF81', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249209),
(391685, 'PTHR31517:SF80', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249209),
(391686, 'PTHR31517:SF61', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249209),
(391687, 'PTHR31517:SF60', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249209),
(391688, 'PTHR31517:SF82', NULL, NULL, NULL, NULL, 'PEROXIDASE 50-RELATED', 249209),
(391689, 'PTHR31517:SF63', NULL, NULL, NULL, NULL, 'PEROXIDASE 65', 249209),
(391690, 'PTHR31517:SF40', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249209);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(391691, 'PTHR31517:SF21', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249209),
(391692, 'PTHR31517:SF64', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249209),
(391693, 'PTHR31517:SF42', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249209),
(391694, 'PTHR31517:SF67', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249209),
(391695, 'PTHR31517:SF45', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249209),
(391696, 'PTHR31517:SF66', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249209),
(391697, 'PTHR31517:SF44', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249209),
(391698, 'PTHR31517:SF47', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249209),
(391699, 'PTHR31517:SF69', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249209),
(391700, 'PTHR31517:SF68', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249209),
(391701, 'PTHR31517:SF46', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249209),
(391702, 'PTHR31517:SF49', NULL, NULL, NULL, NULL, 'PEROXIDASE 63', 249209),
(391703, 'PTHR31517:SF48', NULL, NULL, NULL, NULL, 'PEROXIDASE 16-RELATED', 249209),
(391704, 'PTHR31517:SF70', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249209),
(391705, 'PTHR31517', NULL, NULL, NULL, NULL, '', 249209),
(391706, 'PTHR31517:SF50', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249209),
(391707, 'PTHR31517:SF71', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249209),
(391708, 'PTHR31517:SF73', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249209),
(391709, 'PTHR31517:SF51', NULL, NULL, NULL, NULL, 'PEROXIDASE 55', 249209),
(391710, 'PTHR31517:SF76', NULL, NULL, NULL, NULL, 'PEROXIDASE 41', 249209),
(391711, 'PTHR31517:SF53', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249209),
(391712, 'PTHR31517:SF78', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249209),
(391713, 'PTHR31517:SF34', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249209),
(391714, 'PTHR31517:SF11', NULL, NULL, NULL, NULL, 'PEROXIDASE 31', 249209),
(391715, 'PTHR31517:SF77', NULL, NULL, NULL, NULL, 'PEROXIDASE', 249209),
(391716, 'PTHR30330:SF5', NULL, NULL, NULL, NULL, 'SODIUM/GLUTAMINE SYMPORTER GLNT-RELATED', 249210),
(391717, 'PTHR30330:SF7', NULL, NULL, NULL, NULL, 'SODIUM/PROTON-DEPENDENT ALANINE CARRIER PROTEIN YRBD-RELATED', 249210),
(391718, 'PTHR30330:SF1', NULL, NULL, NULL, NULL, 'AMINO-ACID CARRIER PROTEIN ALST', 249210),
(391719, 'PTHR30330', NULL, NULL, NULL, NULL, 'AGSS FAMILY TRANSPORTER, SODIUM-ALANINE', 249210),
(391720, 'PTHR30330:SF14', NULL, NULL, NULL, NULL, 'SODIUM/ALANINE SYMPORTER-RELATED', 249210),
(391721, 'PTHR30330:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, LRP FAMILY-RELATED', 249210),
(391722, 'PTHR14624:SF5', NULL, NULL, NULL, NULL, 'POLYPRENOL REDUCTASE', 249211),
(391723, 'PTHR14624', NULL, NULL, NULL, NULL, 'DFG10 PROTEIN', 249211),
(391724, 'PTHR14624:SF2', NULL, NULL, NULL, NULL, 'POLYPRENOL REDUCTASE', 249211),
(391725, 'PTHR14624:SF0', NULL, NULL, NULL, NULL, 'POLYPRENOL REDUCTASE', 249211),
(391726, 'PTHR47427', NULL, NULL, NULL, NULL, 'PROTEIN STE12', 249212),
(391727, 'PTHR47427:SF1', NULL, NULL, NULL, NULL, 'PROTEIN STE12', 249212),
(391728, 'PTHR13490', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 28S RIBOSOMAL PROTEIN S28', 249213),
(391729, 'PTHR13490:SF0', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S35, MITOCHONDRIAL', 249213),
(391730, 'PTHR34851:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG05235', 249214),
(391731, 'PTHR34851:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG22009', 249214),
(391732, 'PTHR34851:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG17557', 249214),
(391733, 'PTHR34851:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG16728', 249214),
(391734, 'PTHR34851', NULL, NULL, NULL, NULL, 'PROTEIN CBG05235-RELATED', 249214),
(391735, 'PTHR14256:SF3', NULL, NULL, NULL, NULL, 'NORMAL MUCOSA OF ESOPHAGUS-SPECIFIC GENE 1 PROTEIN', 249215),
(391736, 'PTHR14256:SF4', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT NDUFA4', 249215),
(391737, 'PTHR14256:SF5', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX SUBUNIT 4-LIKE 2', 249215),
(391738, 'PTHR14256:SF6', NULL, NULL, NULL, NULL, '', 249215),
(391739, 'PTHR14256:SF7', NULL, NULL, NULL, NULL, '', 249215),
(391740, 'PTHR14256', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE MLRQ SUBUNIT', 249215);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(391741, 'PTHR14256:SF1', NULL, NULL, NULL, NULL, 'GEO09626P1', 249215),
(391742, 'PTHR47412:SF1', NULL, NULL, NULL, NULL, 'FI01434P-RELATED', 249216),
(391743, 'PTHR47412', NULL, NULL, NULL, NULL, 'FI01434P-RELATED', 249216),
(391744, 'PTHR47312:SF1', NULL, NULL, NULL, NULL, 'MELANOMA-DERIVED GROWTH REGULATORY PROTEIN', 249217),
(391745, 'PTHR47312', NULL, NULL, NULL, NULL, 'MELANOMA-DERIVED GROWTH REGULATORY PROTEIN', 249217),
(391746, 'PTHR45288:SF1', NULL, NULL, NULL, NULL, 'THIOREDOXIN FAMILY PROTEIN', 249218),
(391747, 'PTHR45288:SF3', NULL, NULL, NULL, NULL, 'BNAANNG34120D PROTEIN', 249218),
(391748, 'PTHR45288:SF2', NULL, NULL, NULL, NULL, 'THIOREDOXIN FAMILY PROTEIN', 249218),
(391749, 'PTHR45288:SF5', NULL, NULL, NULL, NULL, 'BNAA03G01120D PROTEIN', 249218),
(391750, 'PTHR45288', NULL, NULL, NULL, NULL, 'THIOREDOXIN FAMILY PROTEIN', 249218),
(391751, 'PTHR31030:SF1', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE FUSION PROTEIN PRM1', 249219),
(391752, 'PTHR31030', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE FUSION PROTEIN PRM1', 249219),
(391753, 'PTHR34367:SF3', NULL, NULL, NULL, NULL, '', 249220),
(391754, 'PTHR34367:SF1', NULL, NULL, NULL, NULL, 'OS04G0528600 PROTEIN', 249220),
(391755, 'PTHR34367:SF7', NULL, NULL, NULL, NULL, '', 249220),
(391756, 'PTHR34367:SF4', NULL, NULL, NULL, NULL, 'OO_BA0013J05-OO_BA0033A15.14 PROTEIN', 249220),
(391757, 'PTHR34367:SF8', NULL, NULL, NULL, NULL, 'BNACNNG25400D PROTEIN', 249220),
(391758, 'PTHR34367', NULL, NULL, NULL, NULL, 'OS02G0734667 PROTEIN', 249220),
(391759, 'PTHR47623:SF1', NULL, NULL, NULL, NULL, 'OS09G0287300 PROTEIN', 249221),
(391760, 'PTHR47623', NULL, NULL, NULL, NULL, 'OS09G0287300 PROTEIN', 249221),
(391761, 'PTHR13204:SF1', NULL, NULL, NULL, NULL, 'ESTER HYDROLASE C11ORF54', 249222),
(391762, 'PTHR13204', NULL, NULL, NULL, NULL, 'PTD012 PROTEIN', 249222),
(391763, 'PTHR28054', NULL, NULL, NULL, NULL, 'RNA POLYMERASE I-SPECIFIC TRANSCRIPTION INITIATION FACTOR RRN10', 249223),
(391764, 'PTHR28054:SF1', NULL, NULL, NULL, NULL, 'RNA POLYMERASE I-SPECIFIC TRANSCRIPTION INITIATION FACTOR RRN10', 249223),
(391765, 'PTHR22084:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG15708', 249224),
(391766, 'PTHR22084:SF4', NULL, NULL, NULL, NULL, 'GEX INTERACTING PROTEIN', 249224),
(391767, 'PTHR22084', NULL, NULL, NULL, NULL, 'GEX INTERACTING PROTEIN PROTEIN 4', 249224),
(391768, 'PTHR22893', NULL, NULL, NULL, NULL, 'NADH OXIDOREDUCTASE-RELATED', 249225),
(391769, 'PTHR22893:SF119', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 249225),
(391770, 'PTHR22893:SF118', NULL, NULL, NULL, NULL, 'OXIDORED_FMN DOMAIN-CONTAINING PROTEIN', 249225),
(391771, 'PTHR22893:SF137', NULL, NULL, NULL, NULL, '12-OXOPHYTODIENOATE REDUCTASE-LIKE PROTEIN', 249225),
(391772, 'PTHR22893:SF136', NULL, NULL, NULL, NULL, 'OXIDORED_FMN DOMAIN-CONTAINING PROTEIN', 249225),
(391773, 'PTHR22893:SF114', NULL, NULL, NULL, NULL, '12-OXOPHYTODIENOATE REDUCTASE 2', 249225),
(391774, 'PTHR22893:SF113', NULL, NULL, NULL, NULL, '12-OXOPHYTODIENOATE REDUCTASE 13-RELATED', 249225),
(391775, 'PTHR22893:SF135', NULL, NULL, NULL, NULL, 'NAD(P)H:FLAVIN OXIDOREDUCTASE SYE2', 249225),
(391776, 'PTHR22893:SF134', NULL, NULL, NULL, NULL, 'OXIDORED_FMN DOMAIN-CONTAINING PROTEIN', 249225),
(391777, 'PTHR22893:SF112', NULL, NULL, NULL, NULL, '12-OXOPHYTODIENOATE REDUCTASE 3', 249225),
(391778, 'PTHR22893:SF111', NULL, NULL, NULL, NULL, '12-OXOPHYTODIENOATE REDUCTASE-LIKE PROTEIN 2A-RELATED', 249225),
(391779, 'PTHR22893:SF44', NULL, NULL, NULL, NULL, '12-OXOPHYTODIENOATE REDUCTASE 1', 249225),
(391780, 'PTHR22893:SF133', NULL, NULL, NULL, NULL, 'OXIDORED_FMN DOMAIN-CONTAINING PROTEIN', 249225),
(391781, 'PTHR22893:SF110', NULL, NULL, NULL, NULL, '12-OXOPHYTODIENOATE REDUCTASE 1-RELATED', 249225),
(391782, 'PTHR22893:SF132', NULL, NULL, NULL, NULL, '12-OXO-PHYTODIENOIC ACID REDUCTASE', 249225),
(391783, 'PTHR22893:SF62', NULL, NULL, NULL, NULL, '12-OXOPHYTODIENOATE REDUCTASE-LIKE PROTEIN', 249225),
(391784, 'PTHR22893:SF109', NULL, NULL, NULL, NULL, '12-OXOPHYTODIENOATE REDUCTASE 8-RELATED', 249225);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(391785, 'PTHR22893:SF108', NULL, NULL, NULL, NULL, 'OXIDORED_FMN DOMAIN-CONTAINING PROTEIN', 249225),
(391786, 'PTHR22893:SF107', NULL, NULL, NULL, NULL, '12-OXOPHYTODIENOATE REDUCTASE-LIKE PROTEIN 1-RELATED', 249225),
(391787, 'PTHR22893:SF129', NULL, NULL, NULL, NULL, 'FLAVIN OXIDOREDUCTASE HXNT', 249225),
(391788, 'PTHR22893:SF106', NULL, NULL, NULL, NULL, 'OXIDORED_FMN DOMAIN-CONTAINING PROTEIN', 249225),
(391789, 'PTHR22893:SF105', NULL, NULL, NULL, NULL, '12-OXO-PHYTODIENOIC ACID REDUCTASE', 249225),
(391790, 'PTHR22893:SF127', NULL, NULL, NULL, NULL, 'OXIDORED_FMN DOMAIN-CONTAINING PROTEIN', 249225),
(391791, 'PTHR22893:SF103', NULL, NULL, NULL, NULL, 'OXIDORED_FMN DOMAIN-CONTAINING PROTEIN', 249225),
(391792, 'PTHR22893:SF125', NULL, NULL, NULL, NULL, 'OXIDORED_FMN DOMAIN-CONTAINING PROTEIN', 249225),
(391793, 'PTHR22893:SF102', NULL, NULL, NULL, NULL, '12-OXOPHYTODIENOATE REDUCTASE 11-RELATED', 249225),
(391794, 'PTHR22893:SF123', NULL, NULL, NULL, NULL, 'OXIDORED_FMN DOMAIN-CONTAINING PROTEIN', 249225),
(391795, 'PTHR22893:SF98', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE', 249225),
(391796, 'PTHR22893:SF55', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE-RELATED', 249225),
(391797, 'PTHR22893:SF99', NULL, NULL, NULL, NULL, 'OXIDORED_FMN DOMAIN-CONTAINING PROTEIN', 249225),
(391798, 'PTHR22893:SF96', NULL, NULL, NULL, NULL, '12-OXOPHYTODIENOATE REDUCTASE 10-RELATED', 249225),
(391799, 'PTHR22893:SF121', NULL, NULL, NULL, NULL, 'OXIDORED_FMN DOMAIN-CONTAINING PROTEIN', 249225),
(391800, 'PTHR22893:SF97', NULL, NULL, NULL, NULL, 'OXIDORED_FMN DOMAIN-CONTAINING PROTEIN', 249225),
(391801, 'PTHR22893:SF93', NULL, NULL, NULL, NULL, 'HYPOTHETICAL OXIDOREDUCTASE (EUROFUNG)', 249225),
(391802, 'PTHR22893:SF91', NULL, NULL, NULL, NULL, 'NADPH DEHYDROGENASE 2-RELATED', 249225),
(391803, 'PTHR46435:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HECTD4-RELATED', 249226),
(391804, 'PTHR46435', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HECTD4-RELATED', 249226),
(391805, 'PTHR32251:SF24', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE', 249227),
(391806, 'PTHR32251:SF25', NULL, NULL, NULL, NULL, 'S5A_REDUCTASE DOMAIN-CONTAINING PROTEIN', 249227),
(391807, 'PTHR32251:SF23', NULL, NULL, NULL, NULL, '3-OXO-5-ALPHA-STEROID 4-DEHYDROGENASE (DUF1295)', 249227),
(391808, 'PTHR32251:SF32', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID METHYLTRANSFERASE', 249227),
(391809, 'PTHR32251:SF30', NULL, NULL, NULL, NULL, 'S5A_REDUCTASE DOMAIN-CONTAINING PROTEIN', 249227),
(391810, 'PTHR32251', NULL, NULL, NULL, NULL, '3-OXO-5-ALPHA-STEROID 4-DEHYDROGENASE', 249227),
(391811, 'PTHR32251:SF17', NULL, NULL, NULL, NULL, 'SI:CH211-210C8.6', 249227),
(391812, 'PTHR32251:SF15', NULL, NULL, NULL, NULL, '3-OXO-5-ALPHA-STEROID 4-DEHYDROGENASE (DUF1295)', 249227),
(391813, 'PTHR32251:SF27', NULL, NULL, NULL, NULL, 'S5A_REDUCTASE DOMAIN-CONTAINING PROTEIN', 249227),
(391814, 'PTHR47491:SF5', NULL, NULL, NULL, NULL, 'CAP-GLY DOMAIN LINKER', 249228),
(391815, 'PTHR47491', NULL, NULL, NULL, NULL, 'CAP-GLY DOMAIN LINKER', 249228),
(391816, 'PTHR47491:SF2', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN-LIKE', 249228),
(391817, 'PTHR47491:SF3', NULL, NULL, NULL, NULL, 'OS07G0686400 PROTEIN', 249228),
(391818, 'PTHR47491:SF6', NULL, NULL, NULL, NULL, 'BNAC03G22020D PROTEIN', 249228),
(391819, 'PTHR47491:SF7', NULL, NULL, NULL, NULL, 'CAP-GLY DOMAIN LINKER', 249228),
(391820, 'PTHR19872:SF7', NULL, NULL, NULL, NULL, 'CMT1A DUPLICATED REGION TRANSCRIPT 1 PROTEIN-RELATED', 249229),
(391821, 'PTHR19872:SF9', NULL, NULL, NULL, NULL, 'UBIQUITIN-BINDING SDF UBIQUITIN LIGASE COMPLEX SUBUNIT', 249229),
(391822, 'PTHR19872', NULL, NULL, NULL, NULL, 'UBIQUITIN LIGASE SPECIFICITY FACTOR/HREP PROTEIN', 249229),
(391823, 'PTHR31230:SF1', NULL, NULL, NULL, NULL, 'MYELOID-DERIVED GROWTH FACTOR', 249230),
(391824, 'PTHR31230', NULL, NULL, NULL, NULL, 'MYELOID-DERIVED GROWTH FACTOR MYDGF', 249230),
(391825, 'PTHR48080:SF7', NULL, NULL, NULL, NULL, 'BLL6349 PROTEIN', 249231),
(391826, 'PTHR48080:SF6', NULL, NULL, NULL, NULL, 'STARVATION-SENSING PROTEIN RSPA', 249231);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(391827, 'PTHR48080:SF5', NULL, NULL, NULL, NULL, 'D(-)-TARTRATE DEHYDRATASE', 249231),
(391828, 'PTHR48080:SF4', NULL, NULL, NULL, NULL, 'GLUCARATE DEHYDRATASE', 249231),
(391829, 'PTHR48080:SF3', NULL, NULL, NULL, NULL, 'ENOLASE SUPERFAMILY MEMBER DDB_G0284701', 249231),
(391830, 'PTHR48080', NULL, NULL, NULL, NULL, 'D-GALACTONATE DEHYDRATASE-RELATED', 249231),
(391831, 'PTHR48080:SF2', NULL, NULL, NULL, NULL, 'D-GALACTONATE DEHYDRATASE', 249231),
(391832, 'PTHR48080:SF1', NULL, NULL, NULL, NULL, 'GLUCARATE DEHYDRATASE-RELATED PROTEIN', 249231),
(391833, 'PTHR46264:SF11', NULL, NULL, NULL, NULL, 'TYROSINE--TRNA LIGASE', 249232),
(391834, 'PTHR46264:SF4', NULL, NULL, NULL, NULL, 'TYROSINE--TRNA LIGASE, CYTOPLASMIC', 249232),
(391835, 'PTHR46264:SF5', NULL, NULL, NULL, NULL, 'TYROSINE--TRNA LIGASE', 249232),
(391836, 'PTHR46264', NULL, NULL, NULL, NULL, 'TYROSINE-TRNA LIGASE', 249232),
(391837, 'PTHR46264:SF7', NULL, NULL, NULL, NULL, 'TYROSINE--TRNA LIGASE', 249232),
(391838, 'PTHR46264:SF8', NULL, NULL, NULL, NULL, 'BNAANNG11300D PROTEIN', 249232),
(391839, 'PTHR44186:SF1', NULL, NULL, NULL, NULL, 'BARDET-BIEDL SYNDROME 4 PROTEIN', 249233),
(391840, 'PTHR44186', NULL, NULL, NULL, NULL, '', 249233),
(391841, 'PTHR22753:SF42', NULL, NULL, NULL, NULL, 'BNAA08G04850D PROTEIN', 249234),
(391842, 'PTHR22753:SF43', NULL, NULL, NULL, NULL, 'ESTERASE/LIPASE/THIOESTERASE FAMILY PROTEIN', 249234),
(391843, 'PTHR22753:SF32', NULL, NULL, NULL, NULL, 'TRANSFERASE', 249234),
(391844, 'PTHR22753:SF44', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 249234),
(391845, 'PTHR22753:SF22', NULL, NULL, NULL, NULL, 'PLSC DOMAIN-CONTAINING PROTEIN', 249234),
(391846, 'PTHR22753:SF34', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE', 249234),
(391847, 'PTHR22753:SF45', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID/GLYCEROL ACYLTRANSFERASE-RELATED', 249234),
(391848, 'PTHR22753:SF23', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 68', 249234),
(391849, 'PTHR22753:SF40', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE', 249234),
(391850, 'PTHR22753:SF30', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 249234),
(391851, 'PTHR22753:SF39', NULL, NULL, NULL, NULL, 'TRANSFERASE TRANSFERRING ACYL GROUPS OTHER THAN AMINO-ACYL GROUPS', 249234),
(391852, 'PTHR22753:SF24', NULL, NULL, NULL, NULL, 'ESTERASE/LIPASE/THIOESTERASE FAMILY PROTEIN', 249234),
(391853, 'PTHR22753:SF9', NULL, NULL, NULL, NULL, 'OS01G0361500 PROTEIN', 249234),
(391854, 'PTHR22753:SF46', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 249234),
(391855, 'PTHR22753', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 68', 249234),
(391856, 'PTHR22753:SF35', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 249234),
(391857, 'PTHR22753:SF36', NULL, NULL, NULL, NULL, 'ESTERASE/LIPASE/THIOESTERASE FAMILY PROTEIN', 249234),
(391858, 'PTHR22753:SF25', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE-LIKE PROTEIN CHLOROPLASTIC', 249234),
(391859, 'PTHR22753:SF14', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 68', 249234),
(391860, 'PTHR22753:SF37', NULL, NULL, NULL, NULL, 'BNAC02G36410D PROTEIN', 249234),
(391861, 'PTHR22753:SF38', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 249234),
(391862, 'PTHR19919:SF3', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 249235),
(391863, 'PTHR19919:SF10', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPARENT TESTA GLABRA 1', 249235),
(391864, 'PTHR19919:SF11', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN LWD1-LIKE', 249235),
(391865, 'PTHR19919:SF12', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 249235),
(391866, 'PTHR19919', NULL, NULL, NULL, NULL, 'WD REPEAT CONTAINING PROTEIN', 249235),
(391867, 'PTHR19919:SF0', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 7', 249235),
(391868, 'PTHR36351:SF2', NULL, NULL, NULL, NULL, '', 249236),
(391869, 'PTHR36351:SF1', NULL, NULL, NULL, NULL, 'EMBRYO SAC DEVELOPMENT ARREST 12', 249236),
(391870, 'PTHR36351', NULL, NULL, NULL, NULL, 'EMBRYO SAC DEVELOPMENT ARREST 12', 249236); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(391871, 'PTHR36351:SF4', NULL, NULL, NULL, NULL, '', 249236),
(391872, 'PTHR24216:SF27', NULL, NULL, NULL, NULL, 'TRANSFORMING GROWTH FACTOR BETA-1-INDUCED TRANSCRIPT 1 PROTEIN', 249237),
(391873, 'PTHR24216:SF65', NULL, NULL, NULL, NULL, 'PAXILLIN-LIKE PROTEIN 1', 249237),
(391874, 'PTHR24216:SF64', NULL, NULL, NULL, NULL, 'PAXILLIN', 249237),
(391875, 'PTHR24216:SF23', NULL, NULL, NULL, NULL, 'LEUPAXIN', 249237),
(391876, 'PTHR24216:SF8', NULL, NULL, NULL, NULL, 'PAXILLIN', 249237),
(391877, 'PTHR24216:SF11', NULL, NULL, NULL, NULL, 'PAXILLIN', 249237),
(391878, 'PTHR24216:SF55', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 249237),
(391879, 'PTHR24216', NULL, NULL, NULL, NULL, 'PAXILLIN-RELATED', 249237),
(391880, 'PTHR24216:SF63', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING PROTEIN A-RELATED', 249237),
(391881, 'PTHR14430:SF4', NULL, NULL, NULL, NULL, 'SEC2P DOMAIN-CONTAINING PROTEIN', 249238),
(391882, 'PTHR14430:SF2', NULL, NULL, NULL, NULL, 'RAB-3A-INTERACTING PROTEIN', 249238),
(391883, 'PTHR14430:SF0', NULL, NULL, NULL, NULL, 'RAB GUANINE NUCLEOTIDE EXCHANGE FACTOR SEC2', 249238),
(391884, 'PTHR14430:SF5', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE EXCHANGE FACTOR FOR RAB-3A', 249238),
(391885, 'PTHR14430', NULL, NULL, NULL, NULL, 'RABIN3-RELATED', 249238),
(391886, 'PTHR31191:SF4', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 126 KDA', 249239),
(391887, 'PTHR31191', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN CEP126', 249239),
(391888, 'PTHR40084:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOHYDROLASE, PHP FAMILY', 249240),
(391889, 'PTHR40084', NULL, NULL, NULL, NULL, 'PHOSPHOHYDROLASE, PHP FAMILY', 249240),
(391890, 'PTHR34688:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME C6, CHLOROPLASTIC', 249241),
(391891, 'PTHR34688', NULL, NULL, NULL, NULL, 'CYTOCHROME C6, CHLOROPLASTIC', 249241),
(391892, 'PTHR15838:SF3', NULL, NULL, NULL, NULL, 'PROTEIN PIGMENT DEFECTIVE 338, CHLOROPLASTIC', 249242),
(391893, 'PTHR15838:SF2', NULL, NULL, NULL, NULL, 'OS05G0535800 PROTEIN', 249242),
(391894, 'PTHR15838', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN OF 40 KDA', 249242),
(391895, 'PTHR15838:SF1', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN OF 40 KDA', 249242),
(391896, 'PTHR47927:SF2', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE FAMILY PROTEIN', 249243),
(391897, 'PTHR47927:SF3', NULL, NULL, NULL, NULL, 'BNAA08G24530D PROTEIN', 249243),
(391898, 'PTHR47927', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 249243),
(391899, 'PTHR42859:SF15', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER BINDING PROTEIN', 249244),
(391900, 'PTHR42859:SF3', NULL, NULL, NULL, NULL, 'ION-TRANSLOCATING OXIDOREDUCTASE COMPLEX SUBUNIT B', 249244),
(391901, 'PTHR42859:SF14', NULL, NULL, NULL, NULL, 'DIMETHYLSULFOXIDE REDUCTASE CHAIN B', 249244),
(391902, 'PTHR42859:SF2', NULL, NULL, NULL, NULL, 'FERREDOXIN 1', 249244),
(391903, 'PTHR42859', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE', 249244),
(391904, 'PTHR42859:SF10', NULL, NULL, NULL, NULL, 'ELECTRON TRANSPORT PROTEIN HYDN-RELATED', 249244),
(391905, 'PTHR47459:SF3', NULL, NULL, NULL, NULL, 'OS03G0149400 PROTEIN', 249245),
(391906, 'PTHR47459:SF1', NULL, NULL, NULL, NULL, 'KINESIN LIGHT CHAIN-RELATED', 249245),
(391907, 'PTHR47459', NULL, NULL, NULL, NULL, 'KINESIN LIGHT CHAIN-RELATED', 249245),
(391908, 'PTHR28284', NULL, NULL, NULL, NULL, 'NUCLEOPORIN NUP60', 249246),
(391909, 'PTHR28284:SF1', NULL, NULL, NULL, NULL, 'NUCLEOPORIN NUP60', 249246),
(391910, 'PTHR31826:SF3', NULL, NULL, NULL, NULL, 'PEPTIDASE_M28 DOMAIN-CONTAINING PROTEIN', 249247),
(391911, 'PTHR31826:SF4', NULL, NULL, NULL, NULL, 'NICALIN-1', 249247),
(391912, 'PTHR31826:SF0', NULL, NULL, NULL, NULL, 'NICALIN', 249247),
(391913, 'PTHR31826', NULL, NULL, NULL, NULL, 'NICALIN', 249247),
(391914, 'PTHR31826:SF6', NULL, NULL, NULL, NULL, 'NICALIN-1-LIKE ISOFORM X1', 249247),
(391915, 'PTHR31826:SF7', NULL, NULL, NULL, NULL, 'NICALIN', 249247),
(391916, 'PTHR13135', NULL, NULL, NULL, NULL, 'CYTOSOLIC RESINIFERATOXIN BINDING PROTEIN RBP-26', 249248),
(391917, 'PTHR13135:SF0', NULL, NULL, NULL, NULL, 'PHOSPHORYLATED ADAPTER RNA EXPORT PROTEIN', 249248);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(391918, 'PTHR46338:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 8', 249249),
(391919, 'PTHR46338', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 8', 249249),
(391920, 'PTHR46338:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 8', 249249),
(391921, 'PTHR46338:SF20', NULL, NULL, NULL, NULL, 'BROMODOMAIN TRANSCRIPTION FACTOR-RELATED', 249249),
(391922, 'PTHR46338:SF10', NULL, NULL, NULL, NULL, 'BROMODOMAIN TRANSCRIPTION FACTOR', 249249),
(391923, 'PTHR46338:SF13', NULL, NULL, NULL, NULL, 'OS02G0699900 PROTEIN', 249249),
(391924, 'PTHR46338:SF15', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 8', 249249),
(391925, 'PTHR46338:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 8', 249249),
(391926, 'PTHR46338:SF19', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 8', 249249),
(391927, 'PTHR35891:SF1', NULL, NULL, NULL, NULL, 'THIOL:DISULFIDE INTERCHANGE PROTEIN DSBL', 249250),
(391928, 'PTHR35891:SF2', NULL, NULL, NULL, NULL, 'THIOL:DISULFIDE INTERCHANGE PROTEIN DSBA', 249250),
(391929, 'PTHR35891', NULL, NULL, NULL, NULL, 'THIOL:DISULFIDE INTERCHANGE PROTEIN DSBA', 249250),
(391930, 'PTHR31635', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN-RELATED', 249251),
(391931, 'PTHR31635:SF195', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 249251),
(391932, 'PTHR31635:SF193', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 249251),
(391933, 'PTHR38650', NULL, NULL, NULL, NULL, 'KITA-KYUSHU LUNG CANCER ANTIGEN 1', 249252),
(391934, 'PTHR38650:SF1', NULL, NULL, NULL, NULL, 'KITA-KYUSHU LUNG CANCER ANTIGEN 1', 249252),
(391935, 'PTHR38650:SF4', NULL, NULL, NULL, NULL, '', 249252),
(391936, 'PTHR23514:SF3', NULL, NULL, NULL, NULL, 'BYPASS OF STOP CODON PROTEIN 6', 249253),
(391937, 'PTHR23514:SF13', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YBJJ', 249253),
(391938, 'PTHR23514', NULL, NULL, NULL, NULL, 'BYPASS OF STOP CODON PROTEIN 6', 249253),
(391939, 'PTHR23514:SF14', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 249253),
(391940, 'PTHR23514:SF15', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G05090)-RELATED', 249253),
(391941, 'PTHR23514:SF16', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G17270)-RELATED', 249253),
(391942, 'PTHR23514:SF6', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 249253),
(391943, 'PTHR37379', NULL, NULL, NULL, NULL, 'OS01G0220500 PROTEIN', 249254),
(391944, 'PTHR37379:SF1', NULL, NULL, NULL, NULL, 'OS01G0220500 PROTEIN', 249254),
(391945, 'PTHR16207', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 249255),
(391946, 'PTHR16207:SF1', NULL, NULL, NULL, NULL, 'PROTEIN TASOR', 249255),
(391947, 'PTHR16207:SF11', NULL, NULL, NULL, NULL, 'DUF3715 DOMAIN-CONTAINING PROTEIN', 249255),
(391948, 'PTHR16207:SF10', NULL, NULL, NULL, NULL, 'PROTEIN TASOR 2', 249255),
(391949, 'PTHR47590', NULL, NULL, NULL, NULL, 'F-BOX/KELCH-REPEAT PROTEIN SKIP25', 249256),
(391950, 'PTHR47590:SF1', NULL, NULL, NULL, NULL, 'F-BOX/KELCH-REPEAT PROTEIN SKIP25', 249256),
(391951, 'PTHR47590:SF4', NULL, NULL, NULL, NULL, 'KAR-UP F-BOX 1-RELATED', 249256),
(391952, 'PTHR47590:SF5', NULL, NULL, NULL, NULL, 'F-BOX/KELCH-REPEAT PROTEIN SKIP25-LIKE', 249256),
(391953, 'PTHR47590:SF2', NULL, NULL, NULL, NULL, 'F-BOX/KELCH-REPEAT PROTEIN SKIP25-LIKE', 249256),
(391954, 'PTHR47590:SF3', NULL, NULL, NULL, NULL, 'F-BOX/KELCH-REPEAT PROTEIN SKIP25-LIKE', 249256),
(391955, 'PTHR38482:SF1', NULL, NULL, NULL, NULL, '', 249257),
(391956, 'PTHR38482', NULL, NULL, NULL, NULL, '', 249257),
(391957, 'PTHR34720', NULL, NULL, NULL, NULL, 'MICROCYSTIN DEPENDENT PROTEIN', 249258),
(391958, 'PTHR34720:SF8', NULL, NULL, NULL, NULL, 'BLR4714 PROTEIN', 249258),
(391959, 'PTHR34720:SF9', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL AUTOTRANSPORTER / ADHESIN CADHERIN FAMILY', 249258),
(391960, 'PTHR43109:SF1', NULL, NULL, NULL, NULL, 'NDK DOMAIN-CONTAINING PROTEIN', 249259);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(391961, 'PTHR43109:SF2', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE KINASE 7', 249259),
(391962, 'PTHR43109', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE KINASE 7', 249259),
(391963, 'PTHR16035', NULL, NULL, NULL, NULL, 'PROTEIN FAM90A1', 249260),
(391964, 'PTHR16035:SF16', NULL, NULL, NULL, NULL, 'PROTEIN FAM90A1-RELATED', 249260),
(391965, 'PTHR16035:SF14', NULL, NULL, NULL, NULL, 'PROTEIN FAM90A10P-RELATED', 249260),
(391966, 'PTHR34580:SF8', NULL, NULL, NULL, NULL, 'DEOR-FAMILY TRANSCRIPTIONAL REGULATOR', 249261),
(391967, 'PTHR34580', NULL, NULL, NULL, NULL, '', 249261),
(391968, 'PTHR34580:SF7', NULL, NULL, NULL, NULL, 'PROTEIN PAFC', 249261),
(391969, 'PTHR34580:SF3', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN-RELATED', 249261),
(391970, 'PTHR34580:SF6', NULL, NULL, NULL, NULL, 'HTH DEOR-TYPE DOMAIN-CONTAINING PROTEIN', 249261),
(391971, 'PTHR34580:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PAFB', 249261),
(391972, 'PTHR31654', NULL, NULL, NULL, NULL, 'SECRETED BETA-GLUCOSIDASE ADG3-RELATED', 249262),
(391973, 'PTHR31654:SF0', NULL, NULL, NULL, NULL, 'SECRETED BETA-GLUCOSIDASE ADG3-RELATED', 249262),
(391974, 'PTHR30309:SF0', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE-RELATED', 249263),
(391975, 'PTHR30309:SF1', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE 1', 249263),
(391976, 'PTHR30309', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YGIH', 249263),
(391977, 'PTHR40447:SF1', NULL, NULL, NULL, NULL, 'ANAEROBIC SULFITE REDUCTASE SUBUNIT A', 249264),
(391978, 'PTHR40447', NULL, NULL, NULL, NULL, 'ANAEROBIC SULFITE REDUCTASE SUBUNIT A', 249264),
(391979, 'PTHR38034:SF1', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YPJD', 249265),
(391980, 'PTHR38034', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YPJD', 249265),
(391981, 'PTHR44461:SF1', NULL, NULL, NULL, NULL, 'QUINONE OXIDOREDUCTASE-LIKE PROTEIN 1', 249266),
(391982, 'PTHR44461', NULL, NULL, NULL, NULL, 'QUINONE OXIDOREDUCTASE-LIKE PROTEIN 1', 249266),
(391983, 'PTHR34125:SF6', NULL, NULL, NULL, NULL, 'BNAC08G10690D PROTEIN', 249267),
(391984, 'PTHR34125:SF7', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 249267),
(391985, 'PTHR34125:SF5', NULL, NULL, NULL, NULL, 'BNAA01G29960D PROTEIN', 249267),
(391986, 'PTHR34125:SF2', NULL, NULL, NULL, NULL, 'OS01G0762900 PROTEIN', 249267),
(391987, 'PTHR34125:SF8', NULL, NULL, NULL, NULL, 'BNAC07G33630D PROTEIN', 249267),
(391988, 'PTHR34125:SF9', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 249267),
(391989, 'PTHR34125', NULL, NULL, NULL, NULL, 'OS01G0762900 PROTEIN', 249267),
(391990, 'PTHR31323', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN MSY2', 249268),
(391991, 'PTHR31323:SF13', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 249268),
(391992, 'PTHR31323:SF1', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN MSY1', 249268),
(391993, 'PTHR31323:SF11', NULL, NULL, NULL, NULL, 'CHROMOSOME 19, WHOLE GENOME SHOTGUN SEQUENCE', 249268),
(391994, 'PTHR31323:SF14', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN MSY2', 249268),
(391995, 'PTHR47137', NULL, NULL, NULL, NULL, 'ERMIN', 249269),
(391996, 'PTHR47137:SF1', NULL, NULL, NULL, NULL, 'ERMIN', 249269),
(391997, 'PTHR36885:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249270),
(391998, 'PTHR36885:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249270),
(391999, 'PTHR36885:SF3', NULL, NULL, NULL, NULL, 'OS12G0485150 PROTEIN', 249270),
(392000, 'PTHR36885:SF6', NULL, NULL, NULL, NULL, '', 249270),
(392001, 'PTHR36885', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249270),
(392002, 'PTHR20836:SF0', NULL, NULL, NULL, NULL, '4-HYDROXY-TETRAHYDRODIPICOLINATE REDUCTASE 1, CHLOROPLASTIC-RELATED', 249271),
(392003, 'PTHR20836', NULL, NULL, NULL, NULL, 'DIHYDRODIPICOLINATE REDUCTASE', 249271),
(392004, 'PTHR20836:SF3', NULL, NULL, NULL, NULL, '4-HYDROXY-TETRAHYDRODIPICOLINATE REDUCTASE 2, CHLOROPLASTIC-RELATED', 249271),
(392005, 'PTHR20836:SF8', NULL, NULL, NULL, NULL, 'BNAA04G25510D PROTEIN', 249271),
(392006, 'PTHR20836:SF7', NULL, NULL, NULL, NULL, '4-HYDROXY-TETRAHYDRODIPICOLINATE REDUCTASE', 249271);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(392007, 'PTHR20836:SF6', NULL, NULL, NULL, NULL, 'DIHYDRODIPICOLINATE REDUCTASE-LIKE PROTEIN CRR1, CHLOROPLASTIC', 249271),
(392008, 'PTHR11125:SF8', NULL, NULL, NULL, NULL, 'PROTEIN RNA-DIRECTED DNA METHYLATION 3', 249272),
(392009, 'PTHR11125:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR SPT5', 249272),
(392010, 'PTHR11125:SF18', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR SPT5', 249272),
(392011, 'PTHR11125', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF TY 5', 249272),
(392012, 'PTHR11125:SF17', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR SPT5 HOMOLOG 2-RELATED', 249272),
(392013, 'PTHR11125:SF14', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR SPT5 HOMOLOG 1-RELATED', 249272),
(392014, 'PTHR11125:SF15', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR SPT5', 249272),
(392015, 'PTHR11767:SF100', NULL, NULL, NULL, NULL, 'SI:CH211-113J13.2', 249273),
(392016, 'PTHR11767:SF51', NULL, NULL, NULL, NULL, 'INWARD RECTIFIER POTASSIUM CHANNEL IRK-1', 249273),
(392017, 'PTHR11767:SF20', NULL, NULL, NULL, NULL, 'ATP-SENSITIVE INWARD RECTIFIER POTASSIUM CHANNEL 15', 249273),
(392018, 'PTHR11767:SF105', NULL, NULL, NULL, NULL, 'IRK_C DOMAIN-CONTAINING PROTEIN', 249273),
(392019, 'PTHR11767:SF21', NULL, NULL, NULL, NULL, 'ATP-SENSITIVE INWARD RECTIFIER POTASSIUM CHANNEL 10', 249273),
(392020, 'PTHR11767:SF43', NULL, NULL, NULL, NULL, 'INWARD RECTIFIER POTASSIUM CHANNEL 2', 249273),
(392021, 'PTHR11767:SF102', NULL, NULL, NULL, NULL, 'INWARDLY RECTIFYING POTASSIUM CHANNEL 1, ISOFORM F-RELATED', 249273),
(392022, 'PTHR11767:SF44', NULL, NULL, NULL, NULL, 'ATP-SENSITIVE INWARD RECTIFIER POTASSIUM CHANNEL 11', 249273),
(392023, 'PTHR11767:SF103', NULL, NULL, NULL, NULL, '', 249273),
(392024, 'PTHR11767:SF6', NULL, NULL, NULL, NULL, 'ATP-SENSITIVE INWARD RECTIFIER POTASSIUM CHANNEL 1', 249273),
(392025, 'PTHR11767:SF109', NULL, NULL, NULL, NULL, 'G PROTEIN-ACTIVATED INWARD RECTIFIER POTASSIUM CHANNEL 1', 249273),
(392026, 'PTHR11767:SF24', NULL, NULL, NULL, NULL, 'INWARD RECTIFIER POTASSIUM CHANNEL 16', 249273),
(392027, 'PTHR11767:SF106', NULL, NULL, NULL, NULL, 'ZGC:162160', 249273),
(392028, 'PTHR11767:SF3', NULL, NULL, NULL, NULL, 'INWARD RECTIFIER POTASSIUM CHANNEL 13', 249273),
(392029, 'PTHR11767:SF111', NULL, NULL, NULL, NULL, 'IRK DOMAIN-CONTAINING PROTEIN', 249273),
(392030, 'PTHR11767:SF112', NULL, NULL, NULL, NULL, 'G PROTEIN-ACTIVATED INWARD RECTIFIER POTASSIUM CHANNEL 4', 249273),
(392031, 'PTHR11767:SF61', NULL, NULL, NULL, NULL, 'IRK_C DOMAIN-CONTAINING PROTEIN', 249273),
(392032, 'PTHR11767:SF40', NULL, NULL, NULL, NULL, 'ATP-SENSITIVE INWARD RECTIFIER POTASSIUM CHANNEL 14', 249273),
(392033, 'PTHR11767:SF52', NULL, NULL, NULL, NULL, 'G PROTEIN-ACTIVATED INWARD RECTIFIER POTASSIUM CHANNEL 4', 249273),
(392034, 'PTHR11767:SF53', NULL, NULL, NULL, NULL, 'INWARD RECTIFIER POTASSIUM CHANNEL 4', 249273),
(392035, 'PTHR11767:SF113', NULL, NULL, NULL, NULL, 'INWARDLY RECTIFYING POTASSIUM CHANNEL 2, ISOFORM D', 249273),
(392036, 'PTHR11767:SF114', NULL, NULL, NULL, NULL, 'IRK_C DOMAIN-CONTAINING PROTEIN', 249273),
(392037, 'PTHR11767:SF11', NULL, NULL, NULL, NULL, 'ATP-SENSITIVE INWARD RECTIFIER POTASSIUM CHANNEL 8', 249273),
(392038, 'PTHR11767:SF99', NULL, NULL, NULL, NULL, 'G PROTEIN-ACTIVATED INWARD RECTIFIER POTASSIUM CHANNEL 1', 249273),
(392039, 'PTHR11767:SF55', NULL, NULL, NULL, NULL, 'KIR6.3 PROTEIN', 249273),
(392040, 'PTHR11767:SF14', NULL, NULL, NULL, NULL, 'ATP-SENSITIVE INWARD RECTIFIER POTASSIUM CHANNEL 12-RELATED', 249273),
(392041, 'PTHR11767', NULL, NULL, NULL, NULL, 'INWARD RECTIFIER POTASSIUM CHANNEL', 249273),
(392042, 'PTHR11767:SF16', NULL, NULL, NULL, NULL, 'G PROTEIN-ACTIVATED INWARD RECTIFIER POTASSIUM CHANNEL 1', 249273),
(392043, 'PTHR11767:SF17', NULL, NULL, NULL, NULL, 'G PROTEIN-ACTIVATED INWARD RECTIFIER POTASSIUM CHANNEL 3', 249273),
(392044, 'PTHR11767:SF19', NULL, NULL, NULL, NULL, 'G PROTEIN-ACTIVATED INWARD RECTIFIER POTASSIUM CHANNEL 2', 249273),
(392045, 'PTHR31001:SF77', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G12940)-RELATED', 249274); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(392046, 'PTHR31001:SF45', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249274),
(392047, 'PTHR31001:SF78', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 249274),
(392048, 'PTHR31001:SF56', NULL, NULL, NULL, NULL, 'ZN(2)-C6 FUNGAL-TYPE DOMAIN-CONTAINING PROTEIN', 249274),
(392049, 'PTHR31001:SF79', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249274),
(392050, 'PTHR31001:SF57', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249274),
(392051, 'PTHR31001:SF58', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249274),
(392052, 'PTHR31001:SF47', NULL, NULL, NULL, NULL, 'FUNGAL SPECIFIC TRANSCRIPTION FACTOR DOMAIN-CONTAINING PROTEIN', 249274),
(392053, 'PTHR31001:SF49', NULL, NULL, NULL, NULL, 'C6 TRANSCRIPTION FACTOR', 249274),
(392054, 'PTHR31001:SF80', NULL, NULL, NULL, NULL, 'FUNGAL_TRANS DOMAIN-CONTAINING PROTEIN', 249274),
(392055, 'PTHR31001:SF81', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249274),
(392056, 'PTHR31001:SF82', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249274),
(392057, 'PTHR31001:SF83', NULL, NULL, NULL, NULL, 'COL-23', 249274),
(392058, 'PTHR31001:SF61', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249274),
(392059, 'PTHR31001:SF50', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249274),
(392060, 'PTHR31001:SF62', NULL, NULL, NULL, NULL, 'FUNGAL_TRANS DOMAIN-CONTAINING PROTEIN', 249274),
(392061, 'PTHR31001:SF40', NULL, NULL, NULL, NULL, 'CENTROMERE DNA-BINDING PROTEIN COMPLEX CBF3 SUBUNIT B-RELATED', 249274),
(392062, 'PTHR31001:SF84', NULL, NULL, NULL, NULL, 'FUNGAL SPECIFIC TRANSCRIPTION FACTOR', 249274),
(392063, 'PTHR31001', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED TRANSCRIPTIONAL REGULATORY PROTEIN', 249274),
(392064, 'PTHR31001:SF41', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249274),
(392065, 'PTHR31001:SF74', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249274),
(392066, 'PTHR31001:SF75', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR', 249274),
(392067, 'PTHR31001:SF53', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249274),
(392068, 'PTHR31001:SF76', NULL, NULL, NULL, NULL, 'ZN(2)-C6 FUNGAL-TYPE DOMAIN-CONTAINING PROTEIN', 249274),
(392069, 'PTHR36941:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG01626', 249275),
(392070, 'PTHR36941:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG01621', 249275),
(392071, 'PTHR36941:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG01628', 249275),
(392072, 'PTHR36941', NULL, NULL, NULL, NULL, 'PROTEIN CBG01621-RELATED', 249275),
(392073, 'PTHR46079:SF3', NULL, NULL, NULL, NULL, 'FERM DOMAIN-CONTAINING PROTEIN 4A', 249276),
(392074, 'PTHR46079:SF2', NULL, NULL, NULL, NULL, 'FERM DOMAIN-CONTAINING PROTEIN', 249276),
(392075, 'PTHR46079:SF1', NULL, NULL, NULL, NULL, 'FERM DOMAIN-CONTAINING PROTEIN 4B', 249276),
(392076, 'PTHR46079', NULL, NULL, NULL, NULL, 'FERM DOMAIN-CONTAINING PROTEIN 4', 249276),
(392077, 'PTHR35282:SF12', NULL, NULL, NULL, NULL, '', 249277),
(392078, 'PTHR35282:SF11', NULL, NULL, NULL, NULL, 'EG5651', 249277),
(392079, 'PTHR35282:SF10', NULL, NULL, NULL, NULL, 'BNAANNG37630D PROTEIN', 249277),
(392080, 'PTHR35282', NULL, NULL, NULL, NULL, 'F5D14.24 PROTEIN', 249277),
(392081, 'PTHR35282:SF2', NULL, NULL, NULL, NULL, 'F5D14.24 PROTEIN', 249277),
(392082, 'PTHR35282:SF8', NULL, NULL, NULL, NULL, '', 249277),
(392083, 'PTHR46275:SF1', NULL, NULL, NULL, NULL, 'HEPATOCYTE GROWTH FACTOR-REGULATED TYROSINE KINASE SUBSTRATE', 249278),
(392084, 'PTHR46275', NULL, NULL, NULL, NULL, 'HEPATOCYTE GROWTH FACTOR-REGULATED TYROSINE KINASE SUBSTRATE', 249278),
(392085, 'PTHR39188', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED ZINC METALLOPROTEASE M50B', 249279),
(392086, 'PTHR39188:SF3', NULL, NULL, NULL, NULL, 'STAGE IV SPORULATION PROTEIN FB', 249279);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(392087, 'PTHR47095', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 222', 249280),
(392088, 'PTHR47095:SF1', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 222', 249280),
(392089, 'PTHR13108:SF9', NULL, NULL, NULL, NULL, 'CONDENSIN COMPLEX SUBUNIT 2', 249281),
(392090, 'PTHR13108:SF10', NULL, NULL, NULL, NULL, 'CONDENSIN COMPLEX SUBUNIT 2', 249281),
(392091, 'PTHR13108', NULL, NULL, NULL, NULL, 'CONDENSIN COMPLEX SUBUNIT 2', 249281),
(392092, 'PTHR13108:SF11', NULL, NULL, NULL, NULL, 'CONDENSIN COMPLEX SUBUNIT 2', 249281),
(392093, 'PTHR13108:SF13', NULL, NULL, NULL, NULL, 'CONDENSIN COMPLEX SUBUNIT 2', 249281),
(392094, 'PTHR10749:SF7', NULL, NULL, NULL, NULL, 'PHOSPHORYLASE B KINASE REGULATORY SUBUNIT ALPHA-RELATED', 249282),
(392095, 'PTHR10749:SF8', NULL, NULL, NULL, NULL, 'PHOSPHORYLASE B KINASE REGULATORY SUBUNIT BETA', 249282),
(392096, 'PTHR10749', NULL, NULL, NULL, NULL, 'PHOSPHORYLASE B KINASE REGULATORY SUBUNIT', 249282),
(392097, 'PTHR10749:SF4', NULL, NULL, NULL, NULL, 'PHOSPHORYLASE B KINASE REGULATORY SUBUNIT ALPHA, SKELETAL MUSCLE ISOFORM', 249282),
(392098, 'PTHR10749:SF5', NULL, NULL, NULL, NULL, 'PHOSPHORYLASE B KINASE REGULATORY SUBUNIT ALPHA, LIVER ISOFORM', 249282),
(392099, 'PTHR42938:SF40', NULL, NULL, NULL, NULL, 'ERYTHRONATE-4-PHOSPHATE DEHYDROGENASE', 249283),
(392100, 'PTHR42938:SF24', NULL, NULL, NULL, NULL, '', 249283),
(392101, 'PTHR42938:SF45', NULL, NULL, NULL, NULL, 'D-3-PHOSPHOGLYCERATE DEHYDROGENASE', 249283),
(392102, 'PTHR42938:SF34', NULL, NULL, NULL, NULL, 'D-3-PHOSPHOGLYCERATE DEHYDROGENASE', 249283),
(392103, 'PTHR42938:SF26', NULL, NULL, NULL, NULL, 'FORMATE DEHYDROGENASE, MITOCHONDRIAL', 249283),
(392104, 'PTHR42938:SF6', NULL, NULL, NULL, NULL, 'D-3-PHOSPHOGLYCERATE DEHYDROGENASE', 249283),
(392105, 'PTHR42938:SF25', NULL, NULL, NULL, NULL, 'D-ISOMER SPECIFIC 2-HYDROXYACID DEHYDROGENASE FAMILY PROTEIN', 249283),
(392106, 'PTHR42938:SF5', NULL, NULL, NULL, NULL, 'D-3-PHOSPHOGLYCERATE DEHYDROGENASE 3, CHLOROPLASTIC', 249283),
(392107, 'PTHR42938:SF42', NULL, NULL, NULL, NULL, 'D-3-PHOSPHOGLYCERATE DEHYDROGENASE 1, CHLOROPLASTIC', 249283),
(392108, 'PTHR42938:SF31', NULL, NULL, NULL, NULL, 'BNAA07G31940D PROTEIN', 249283),
(392109, 'PTHR42938:SF20', NULL, NULL, NULL, NULL, 'D-3-PHOSPHOGLYCERATE DEHYDROGENASE', 249283),
(392110, 'PTHR42938:SF30', NULL, NULL, NULL, NULL, 'ERYTHRONATE-4-PHOSPHATE DEHYDROGENASE FAMILY PROTEIN-RELATED', 249283),
(392111, 'PTHR42938:SF41', NULL, NULL, NULL, NULL, 'D-3-PHOSPHOGLYCERATE DEHYDROGENASE', 249283),
(392112, 'PTHR42938:SF7', NULL, NULL, NULL, NULL, 'ERYTHRONATE-4-PHOSPHATE DEHYDROGENASE FAMILY PROTEIN', 249283),
(392113, 'PTHR42938:SF22', NULL, NULL, NULL, NULL, 'D-3-PHOSPHOGLYCERATE DEHYDROGENASE', 249283),
(392114, 'PTHR42938:SF11', NULL, NULL, NULL, NULL, 'ERYTHRONATE-4-PHOSPHATE DEHYDROGENASE FAMILY PROTEIN', 249283),
(392115, 'PTHR42938:SF44', NULL, NULL, NULL, NULL, 'D-ISOMER SPECIFIC 2-HYDROXYACID DEHYDROGENASE NAD-BINDING', 249283),
(392116, 'PTHR42938:SF9', NULL, NULL, NULL, NULL, 'FORMATE DEHYDROGENASE 1', 249283),
(392117, 'PTHR42938:SF43', NULL, NULL, NULL, NULL, '2-HYDROXYACID DEHYDROGENASE', 249283),
(392118, 'PTHR42938:SF28', NULL, NULL, NULL, NULL, 'BNACNNG08110D PROTEIN', 249283),
(392119, 'PTHR42938', NULL, NULL, NULL, NULL, 'FORMATE DEHYDROGENASE 1', 249283),
(392120, 'PTHR42938:SF27', NULL, NULL, NULL, NULL, 'BNACNNG08710D PROTEIN', 249283),
(392121, 'PTHR42938:SF19', NULL, NULL, NULL, NULL, 'OS08G0151600 PROTEIN', 249283),
(392122, 'PTHR42938:SF18', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249283),
(392123, 'PTHR46919', NULL, NULL, NULL, NULL, 'ZINC FINGER, C3HC4 TYPE (RING FINGER) FAMILY PROTEIN', 249284),
(392124, 'PTHR46919:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER, C3HC4 TYPE (RING FINGER) FAMILY PROTEIN', 249284),
(392125, 'PTHR15651:SF7', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING PROTEIN 8', 249285),
(392126, 'PTHR15651', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING PROTEIN 8', 249285),
(392127, 'PTHR38396', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 249286);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(392128, 'PTHR38396:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 249286),
(392129, 'PTHR37696:SF1', NULL, NULL, NULL, NULL, 'ADENYLOSUCCINATE SYNTHETASE-RELATED', 249287),
(392130, 'PTHR37696', NULL, NULL, NULL, NULL, 'ADENYLOSUCCINATE SYNTHETASE-RELATED', 249287),
(392131, 'PTHR32078:SF1', NULL, NULL, NULL, NULL, 'NUCLEAR PROTEIN MDM1', 249288),
(392132, 'PTHR32078', NULL, NULL, NULL, NULL, 'NUCLEAR PROTEIN MDM1', 249288),
(392133, 'PTHR47895', NULL, NULL, NULL, NULL, 'CYSTEINE AND HISTIDINE-RICH DOMAIN-CONTAINING PROTEIN RAR1', 249289),
(392134, 'PTHR47895:SF2', NULL, NULL, NULL, NULL, 'CYSTEINE AND HISTIDINE-RICH DOMAIN-CONTAINING PROTEIN RAR1', 249289),
(392135, 'PTHR37919', NULL, NULL, NULL, NULL, 'PROTEIN CBG05606', 249290),
(392136, 'PTHR37919:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG05606', 249290),
(392137, 'PTHR37919:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG02558', 249290),
(392138, 'PTHR32285:SF23', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 12', 249291),
(392139, 'PTHR32285:SF190', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 33', 249291),
(392140, 'PTHR32285:SF192', NULL, NULL, NULL, NULL, 'DUF231 DOMAIN CONTAINING FAMILY PROTEIN-RELATED', 249291),
(392141, 'PTHR32285:SF22', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE', 249291),
(392142, 'PTHR32285:SF341', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 10', 249291),
(392143, 'PTHR32285:SF182', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 34', 249291),
(392144, 'PTHR32285:SF27', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 26', 249291),
(392145, 'PTHR32285:SF28', NULL, NULL, NULL, NULL, 'PROTEIN ALTERED XYLOGLUCAN 4-LIKE', 249291),
(392146, 'PTHR32285:SF183', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 25', 249291),
(392147, 'PTHR32285:SF184', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 19', 249291),
(392148, 'PTHR32285:SF29', NULL, NULL, NULL, NULL, 'OS07G0656000 PROTEIN', 249291),
(392149, 'PTHR32285:SF185', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 41', 249291),
(392150, 'PTHR32285:SF348', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392151, 'PTHR32285:SF227', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 28', 249291),
(392152, 'PTHR32285:SF228', NULL, NULL, NULL, NULL, 'PMR5/CAS1P GDSL/SGNH-LIKE ACYL-ESTERASE FAMILY PROTEIN', 249291),
(392153, 'PTHR32285:SF349', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 33 ISOFORM X1', 249291),
(392154, 'PTHR32285:SF229', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 20', 249291),
(392155, 'PTHR32285:SF344', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 23', 249291),
(392156, 'PTHR32285:SF345', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392157, 'PTHR32285:SF346', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392158, 'PTHR32285:SF347', NULL, NULL, NULL, NULL, 'PMR5/CAS1P GDSL/SGNH-LIKE ACYL-ESTERASE FAMILY PROTEIN', 249291),
(392159, 'PTHR32285:SF226', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 33 ISOFORM X1', 249291),
(392160, 'PTHR32285:SF12', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 13', 249291),
(392161, 'PTHR32285:SF13', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392162, 'PTHR32285:SF180', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 34 ISOFORM X1', 249291),
(392163, 'PTHR32285:SF14', NULL, NULL, NULL, NULL, 'PROTEIN PMR5', 249291),
(392164, 'PTHR32285:SF181', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 26', 249291),
(392165, 'PTHR32285:SF10', NULL, NULL, NULL, NULL, 'PROTEIN ESKIMO 1', 249291),
(392166, 'PTHR32285:SF11', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 34', 249291),
(392167, 'PTHR32285:SF296', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392168, 'PTHR32285:SF210', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 8', 249291),
(392169, 'PTHR32285:SF177', NULL, NULL, NULL, NULL, 'OS01G0217000 PROTEIN', 249291);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(392170, 'PTHR32285:SF299', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 3', 249291),
(392171, 'PTHR32285:SF178', NULL, NULL, NULL, NULL, 'PMR5/CAS1P GDSL/SGNH-LIKE ACYL-ESTERASE FAMILY PROTEIN', 249291),
(392172, 'PTHR32285:SF211', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392173, 'PTHR32285:SF171', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 12', 249291),
(392174, 'PTHR32285:SF292', NULL, NULL, NULL, NULL, 'PMR5/CAS1P GDSL/SGNH-LIKE ACYL-ESTERASE FAMILY PROTEIN', 249291),
(392175, 'PTHR32285:SF172', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392176, 'PTHR32285:SF293', NULL, NULL, NULL, NULL, 'PROTEIN ESKIMO 1-LIKE', 249291),
(392177, 'PTHR32285:SF173', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 40', 249291),
(392178, 'PTHR32285:SF18', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 18', 249291),
(392179, 'PTHR32285:SF174', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392180, 'PTHR32285:SF19', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 6', 249291),
(392181, 'PTHR32285:SF295', NULL, NULL, NULL, NULL, 'PMR5 DOMAIN, PC-ESTERASE, PROTEIN TRICHOME BIREFRINGENCE-LIKE 37/38-RELATED', 249291),
(392182, 'PTHR32285:SF217', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 31', 249291),
(392183, 'PTHR32285:SF338', NULL, NULL, NULL, NULL, 'PROTEIN YLS7', 249291),
(392184, 'PTHR32285:SF339', NULL, NULL, NULL, NULL, 'OS02G0773732 PROTEIN', 249291),
(392185, 'PTHR32285:SF219', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 24', 249291),
(392186, 'PTHR32285:SF333', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 16', 249291),
(392187, 'PTHR32285:SF179', NULL, NULL, NULL, NULL, 'PMR5/CAS1P GDSL/SGNH-LIKE ACYL-ESTERASE FAMILY PROTEIN', 249291),
(392188, 'PTHR32285:SF212', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 11', 249291),
(392189, 'PTHR32285:SF213', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 11', 249291),
(392190, 'PTHR32285:SF48', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 19', 249291),
(392191, 'PTHR32285:SF170', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 43', 249291),
(392192, 'PTHR32285:SF42', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 37', 249291),
(392193, 'PTHR32285:SF43', NULL, NULL, NULL, NULL, 'OS02G0729100 PROTEIN', 249291),
(392194, 'PTHR32285:SF44', NULL, NULL, NULL, NULL, 'OS06G0531400 PROTEIN', 249291),
(392195, 'PTHR32285:SF285', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249291),
(392196, 'PTHR32285:SF164', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 1', 249291),
(392197, 'PTHR32285:SF286', NULL, NULL, NULL, NULL, 'PMR5 N-TERMINAL DOMAIN, PC-ESTERASE-RELATED', 249291),
(392198, 'PTHR32285:SF166', NULL, NULL, NULL, NULL, 'PROTEIN ESKIMO 1-LIKE', 249291),
(392199, 'PTHR32285:SF287', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392200, 'PTHR32285:SF8', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 5', 249291),
(392201, 'PTHR32285:SF7', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 3', 249291),
(392202, 'PTHR32285:SF167', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392203, 'PTHR32285:SF200', NULL, NULL, NULL, NULL, 'PMR5/CAS1P GDSL/SGNH-LIKE ACYL-ESTERASE FAMILY PROTEIN', 249291),
(392204, 'PTHR32285:SF321', NULL, NULL, NULL, NULL, 'TRICHOME BIREFRINGENCE-LIKE 25-RELATED', 249291),
(392205, 'PTHR32285:SF49', NULL, NULL, NULL, NULL, 'PROTEIN ESKIMO 1', 249291),
(392206, 'PTHR32285:SF160', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 39', 249291),
(392207, 'PTHR32285:SF281', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392208, 'PTHR32285:SF282', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 32', 249291),
(392209, 'PTHR32285:SF163', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 10', 249291),
(392210, 'PTHR32285:SF327', NULL, NULL, NULL, NULL, 'OS07G0693600 PROTEIN', 249291);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(392211, 'PTHR32285:SF206', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 38', 249291),
(392212, 'PTHR32285:SF328', NULL, NULL, NULL, NULL, 'PMR5 N-TERMINAL DOMAIN, PC-ESTERASE-RELATED', 249291),
(392213, 'PTHR32285:SF208', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 2', 249291),
(392214, 'PTHR32285:SF329', NULL, NULL, NULL, NULL, 'PROTEIN PMR5-LIKE ISOFORM X1', 249291),
(392215, 'PTHR32285:SF322', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392216, 'PTHR32285:SF168', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 19', 249291),
(392217, 'PTHR32285:SF202', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 35', 249291),
(392218, 'PTHR32285:SF323', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 41 ISOFORM X1', 249291),
(392219, 'PTHR32285:SF324', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 25', 249291),
(392220, 'PTHR32285:SF204', NULL, NULL, NULL, NULL, 'OS05G0426300 PROTEIN', 249291),
(392221, 'PTHR32285:SF319', NULL, NULL, NULL, NULL, 'PMR5 N-TERMINAL DOMAIN, PC-ESTERASE-RELATED', 249291),
(392222, 'PTHR32285:SF34', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BEREFRINGENCE-LIKE 7', 249291),
(392223, 'PTHR32285:SF36', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392224, 'PTHR32285:SF280', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 38', 249291),
(392225, 'PTHR32285:SF37', NULL, NULL, NULL, NULL, 'OS05G0354400 PROTEIN', 249291),
(392226, 'PTHR32285:SF30', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 42', 249291),
(392227, 'PTHR32285:SF274', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392228, 'PTHR32285:SF276', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249291),
(392229, 'PTHR32285:SF155', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 36', 249291),
(392230, 'PTHR32285:SF156', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392231, 'PTHR32285:SF310', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392232, 'PTHR32285:SF38', NULL, NULL, NULL, NULL, 'OS01G0614300 PROTEIN', 249291),
(392233, 'PTHR32285:SF39', NULL, NULL, NULL, NULL, 'OS02G0729200 PROTEIN', 249291),
(392234, 'PTHR32285:SF271', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392235, 'PTHR32285:SF272', NULL, NULL, NULL, NULL, 'OS06G0273200 PROTEIN', 249291),
(392236, 'PTHR32285:SF315', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 34', 249291),
(392237, 'PTHR32285', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 9-RELATED', 249291),
(392238, 'PTHR32285:SF318', NULL, NULL, NULL, NULL, 'DUF231 DOMAIN CONTAINING FAMILY PROTEIN-RELATED', 249291),
(392239, 'PTHR32285:SF157', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 30', 249291),
(392240, 'PTHR32285:SF278', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392241, 'PTHR32285:SF311', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 45', 249291),
(392242, 'PTHR32285:SF313', NULL, NULL, NULL, NULL, 'PMR5/CAS1P GDSL/SGNH-LIKE ACYL-ESTERASE FAMILY PROTEIN', 249291),
(392243, 'PTHR32285:SF314', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392244, 'PTHR32285:SF61', NULL, NULL, NULL, NULL, 'OS06G0272800 PROTEIN', 249291),
(392245, 'PTHR32285:SF62', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 33', 249291),
(392246, 'PTHR32285:SF309', NULL, NULL, NULL, NULL, 'PMR5 N-TERMINAL DOMAIN, PC-ESTERASE-RELATED', 249291),
(392247, 'PTHR32285:SF67', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249291),
(392248, 'PTHR32285:SF63', NULL, NULL, NULL, NULL, 'OS01G0880400 PROTEIN', 249291),
(392249, 'PTHR32285:SF64', NULL, NULL, NULL, NULL, 'OS06G0273700 PROTEIN', 249291),
(392250, 'PTHR32285:SF264', NULL, NULL, NULL, NULL, 'TRICHOME BIREFRINGENCE-LIKE 38-RELATED', 249291),
(392251, 'PTHR32285:SF144', NULL, NULL, NULL, NULL, 'OS07G0255900 PROTEIN', 249291),
(392252, 'PTHR32285:SF266', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE', 249291);
INSERT INTO "PUBLIC"."MODEL" VALUES
(392253, 'PTHR32285:SF260', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392254, 'PTHR32285:SF261', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392255, 'PTHR32285:SF262', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392256, 'PTHR32285:SF307', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392257, 'PTHR32285:SF300', NULL, NULL, NULL, NULL, 'PMR5 N-TERMINAL DOMAIN, PC-ESTERASE, TRICHOME BIREFRINGENCE/TRICHOME BIREFRINGENCE-LIKE 1-RELATED', 249291),
(392258, 'PTHR32285:SF301', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392259, 'PTHR32285:SF268', NULL, NULL, NULL, NULL, 'TRICHOME BIREFRINGENCE-LIKE 20', 249291),
(392260, 'PTHR32285:SF302', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392261, 'PTHR32285:SF148', NULL, NULL, NULL, NULL, 'TRICHOME BIREFRINGENCE-LIKE 20', 249291),
(392262, 'PTHR32285:SF303', NULL, NULL, NULL, NULL, 'PMR5 N-TERMINAL DOMAIN, PC-ESTERASE, PROTEIN TRICHOME BIREFRINGENCE-LIKE 34-RELATED', 249291),
(392263, 'PTHR32285:SF149', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392264, 'PTHR32285:SF56', NULL, NULL, NULL, NULL, 'OS01G0652800 PROTEIN', 249291),
(392265, 'PTHR32285:SF57', NULL, NULL, NULL, NULL, 'PROTEIN ALTERED XYLOGLUCAN 4', 249291),
(392266, 'PTHR32285:SF58', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 41', 249291),
(392267, 'PTHR32285:SF53', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 9', 249291),
(392268, 'PTHR32285:SF252', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 19', 249291),
(392269, 'PTHR32285:SF253', NULL, NULL, NULL, NULL, 'OS06G0234400 PROTEIN', 249291),
(392270, 'PTHR32285:SF255', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 33', 249291),
(392271, 'PTHR32285:SF370', NULL, NULL, NULL, NULL, 'OS05G0356700 PROTEIN', 249291),
(392272, 'PTHR32285:SF250', NULL, NULL, NULL, NULL, 'PMR5/CAS1P GDSL/SGNH-LIKE ACYL-ESTERASE FAMILY PROTEIN', 249291),
(392273, 'PTHR32285:SF371', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392274, 'PTHR32285:SF256', NULL, NULL, NULL, NULL, 'PROTEIN ALTERED XYLOGLUCAN 4', 249291),
(392275, 'PTHR32285:SF136', NULL, NULL, NULL, NULL, 'OS11G0586825 PROTEIN', 249291),
(392276, 'PTHR32285:SF258', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 4', 249291),
(392277, 'PTHR32285:SF259', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392278, 'PTHR32285:SF241', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 4', 249291),
(392279, 'PTHR32285:SF362', NULL, NULL, NULL, NULL, 'PMR5/CAS1P GDSL/SGNH-LIKE ACYL-ESTERASE FAMILY PROTEIN', 249291),
(392280, 'PTHR32285:SF363', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 43', 249291),
(392281, 'PTHR32285:SF242', NULL, NULL, NULL, NULL, 'PMR5/CAS1P GDSL/SGNH-LIKE ACYL-ESTERASE FAMILY PROTEIN', 249291),
(392282, 'PTHR32285:SF243', NULL, NULL, NULL, NULL, 'OS06G0235000 PROTEIN', 249291),
(392283, 'PTHR32285:SF364', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 41 ISOFORM X1', 249291),
(392284, 'PTHR32285:SF365', NULL, NULL, NULL, NULL, 'OS09G0375300 PROTEIN', 249291),
(392285, 'PTHR32285:SF360', NULL, NULL, NULL, NULL, 'TRICHOME BIREFRINGENCE-LIKE 33-RELATED', 249291),
(392286, 'PTHR32285:SF361', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392287, 'PTHR32285:SF366', NULL, NULL, NULL, NULL, 'PMR5/CAS1P GDSL/SGNH-LIKE ACYL-ESTERASE FAMILY PROTEIN', 249291),
(392288, 'PTHR32285:SF245', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 41', 249291),
(392289, 'PTHR32285:SF367', NULL, NULL, NULL, NULL, 'PMR5/CAS1P GDSL/SGNH-LIKE ACYL-ESTERASE FAMILY PROTEIN', 249291),
(392290, 'PTHR32285:SF246', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392291, 'PTHR32285:SF368', NULL, NULL, NULL, NULL, 'PMR5/CAS1P GDSL/SGNH-LIKE ACYL-ESTERASE FAMILY PROTEIN', 249291),
(392292, 'PTHR32285:SF247', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 19', 249291);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(392293, 'PTHR32285:SF248', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392294, 'PTHR32285:SF369', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392295, 'PTHR32285:SF71', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 39', 249291),
(392296, 'PTHR32285:SF197', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249291),
(392297, 'PTHR32285:SF230', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392298, 'PTHR32285:SF351', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 21', 249291),
(392299, 'PTHR32285:SF198', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 249291),
(392300, 'PTHR32285:SF352', NULL, NULL, NULL, NULL, 'ALPHA GALACTOSIDASE', 249291),
(392301, 'PTHR32285:SF353', NULL, NULL, NULL, NULL, 'PMR5 N-TERMINAL DOMAIN, PC-ESTERASE, PROTEIN TRICHOME BIREFRINGENCE-LIKE 28/ESKIMO 1-RELATED', 249291),
(392302, 'PTHR32285:SF354', NULL, NULL, NULL, NULL, 'PMR5/CAS1P GDSL/SGNH-LIKE ACYL-ESTERASE FAMILY PROTEIN', 249291),
(392303, 'PTHR32285:SF233', NULL, NULL, NULL, NULL, 'DUF231 DOMAIN CONTAINING FAMILY PROTEIN-RELATED', 249291),
(392304, 'PTHR32285:SF194', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 19', 249291),
(392305, 'PTHR32285:SF195', NULL, NULL, NULL, NULL, 'DUF231 DOMAIN CONTAINING FAMILY PROTEIN-RELATED', 249291),
(392306, 'PTHR32285:SF350', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 43', 249291),
(392307, 'PTHR32285:SF196', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 39', 249291),
(392308, 'PTHR32285:SF359', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 11', 249291),
(392309, 'PTHR32285:SF239', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 34', 249291),
(392310, 'PTHR32285:SF355', NULL, NULL, NULL, NULL, 'PMR5/CAS1P GDSL/SGNH-LIKE ACYL-ESTERASE FAMILY PROTEIN', 249291),
(392311, 'PTHR32285:SF235', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 16', 249291),
(392312, 'PTHR32285:SF356', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BEREFRINGENCE-LIKE 7', 249291),
(392313, 'PTHR32285:SF357', NULL, NULL, NULL, NULL, 'PMR5 N-TERMINAL DOMAIN, PC-ESTERASE-RELATED', 249291),
(392314, 'PTHR32285:SF358', NULL, NULL, NULL, NULL, '', 249291),
(392315, 'PTHR12649:SF11', NULL, NULL, NULL, NULL, 'PEPTIDYL-TRNA HYDROLASE 2, MITOCHONDRIAL', 249292),
(392316, 'PTHR12649', NULL, NULL, NULL, NULL, 'PEPTIDYL-TRNA HYDROLASE 2', 249292),
(392317, 'PTHR12649:SF26', NULL, NULL, NULL, NULL, 'AMINOACYL-TRNA HYDROLASE', 249292),
(392318, 'PTHR12649:SF25', NULL, NULL, NULL, NULL, 'AMINOACYL-TRNA HYDROLASE', 249292),
(392319, 'PTHR12649:SF28', NULL, NULL, NULL, NULL, 'AMINOACYL-TRNA HYDROLASE', 249292),
(392320, 'PTHR12649:SF27', NULL, NULL, NULL, NULL, 'AMINOACYL-TRNA HYDROLASE', 249292),
(392321, 'PTHR45765:SF10', NULL, NULL, NULL, NULL, 'METHIONYL-TRNA SYNTHETASE', 249293),
(392322, 'PTHR45765:SF4', NULL, NULL, NULL, NULL, 'METHIONYL-TRNA SYNTHETASE', 249293),
(392323, 'PTHR45765:SF12', NULL, NULL, NULL, NULL, 'METHIONYL-TRNA SYNTHETASE', 249293),
(392324, 'PTHR45765:SF1', NULL, NULL, NULL, NULL, 'METHIONINE--TRNA LIGASE, CYTOPLASMIC', 249293),
(392325, 'PTHR45765:SF6', NULL, NULL, NULL, NULL, 'METHIONYL-TRNA SYNTHETASE', 249293),
(392326, 'PTHR45765:SF7', NULL, NULL, NULL, NULL, 'METHIONYL-TRNA SYNTHETASE', 249293),
(392327, 'PTHR45765', NULL, NULL, NULL, NULL, 'METHIONINE--TRNA LIGASE', 249293),
(392328, 'PTHR45765:SF9', NULL, NULL, NULL, NULL, 'METHIONYL-TRNA SYNTHETASE', 249293),
(392329, 'PTHR30109:SF6', NULL, NULL, NULL, NULL, 'ACETYL-COA DECARBONYLASE/SYNTHASE COMPLEX SUBUNIT ALPHA', 249294),
(392330, 'PTHR30109', NULL, NULL, NULL, NULL, 'HYDROXYLAMINE REDUCTASE', 249294),
(392331, 'PTHR30109:SF0', NULL, NULL, NULL, NULL, 'HYDROXYLAMINE REDUCTASE', 249294),
(392332, 'PTHR30109:SF4', NULL, NULL, NULL, NULL, 'CARBON MONOXIDE DEHYDROGENASE', 249294),
(392333, 'PTHR48206:SF1', NULL, NULL, NULL, NULL, 'CHLOROPLAST SENSOR KINASE, CHLOROPLASTIC', 249295),
(392334, 'PTHR48206', NULL, NULL, NULL, NULL, 'CHLOROPLAST SENSOR KINASE, CHLOROPLASTIC', 249295);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(392335, 'PTHR48267:SF1', NULL, NULL, NULL, NULL, 'CUPREDOXIN SUPERFAMILY PROTEIN', 249296),
(392336, 'PTHR48267', NULL, NULL, NULL, NULL, 'CUPREDOXIN SUPERFAMILY PROTEIN', 249296),
(392337, 'PTHR22726:SF23', NULL, NULL, NULL, NULL, 'PEPTIDASE_M48 DOMAIN-CONTAINING PROTEIN', 249297),
(392338, 'PTHR22726:SF8', NULL, NULL, NULL, NULL, 'METALLOPROTEASE YCAL', 249297),
(392339, 'PTHR22726:SF24', NULL, NULL, NULL, NULL, 'M48 PEPTIDASE FAMILY PROTEIN', 249297),
(392340, 'PTHR22726', NULL, NULL, NULL, NULL, 'METALLOENDOPEPTIDASE OMA1', 249297),
(392341, 'PTHR22726:SF18', NULL, NULL, NULL, NULL, 'PEPTIDASE_M48 DOMAIN-CONTAINING PROTEIN', 249297),
(392342, 'PTHR22726:SF1', NULL, NULL, NULL, NULL, 'METALLOENDOPEPTIDASE OMA1, MITOCHONDRIAL', 249297),
(392343, 'PTHR22726:SF7', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', 249297),
(392344, 'PTHR22726:SF4', NULL, NULL, NULL, NULL, 'METALLOPROTEASE LOIP', 249297),
(392345, 'PTHR21092', NULL, NULL, NULL, NULL, 'NICASTRIN', 249298),
(392346, 'PTHR21092:SF0', NULL, NULL, NULL, NULL, 'NICASTRIN', 249298),
(392347, 'PTHR43551:SF1', NULL, NULL, NULL, NULL, 'HETERODISULFIDE REDUCTASE', 249299),
(392348, 'PTHR43551:SF2', NULL, NULL, NULL, NULL, 'FUMARATE REDUCTASE IRON-SULFUR SUBUNIT', 249299),
(392349, 'PTHR43551', NULL, NULL, NULL, NULL, 'FUMARATE REDUCTASE IRON-SULFUR SUBUNIT', 249299),
(392350, 'PTHR11444:SF22', NULL, NULL, NULL, NULL, 'FUMARATE HYDRATASE CLASS II', 249300),
(392351, 'PTHR11444:SF25', NULL, NULL, NULL, NULL, 'FUMARATE HYDRATASE', 249300),
(392352, 'PTHR11444:SF26', NULL, NULL, NULL, NULL, 'FUMARATE HYDRATASE', 249300),
(392353, 'PTHR11444:SF1', NULL, NULL, NULL, NULL, 'FUMARATE HYDRATASE, MITOCHONDRIAL', 249300),
(392354, 'PTHR11444', NULL, NULL, NULL, NULL, 'ASPARTATEAMMONIA/ARGININOSUCCINATE/ADENYLOSUCCINATE LYASE', 249300),
(392355, 'PTHR11444:SF24', NULL, NULL, NULL, NULL, 'FUMARATE HYDRATASE', 249300),
(392356, 'PTHR36306:SF5', NULL, NULL, NULL, NULL, 'SLR1535 PROTEIN', 249301),
(392357, 'PTHR36306', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE-RELATED-RELATED', 249301),
(392358, 'PTHR36306:SF1', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE-RELATED', 249301),
(392359, 'PTHR36306:SF4', NULL, NULL, NULL, NULL, '4-ALPHA-GLUCANOTRANSFERASE', 249301),
(392360, 'PTHR36306:SF3', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE FAMILY 57', 249301),
(392361, 'PTHR34811:SF1', NULL, NULL, NULL, NULL, 'MATURASE K', 249302),
(392362, 'PTHR34811', NULL, NULL, NULL, NULL, 'MATURASE K', 249302),
(392363, 'PTHR11730:SF48', NULL, NULL, NULL, NULL, 'RH50-LIKE PROTEIN', 249303),
(392364, 'PTHR11730:SF118', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER 1-RELATED', 249303),
(392365, 'PTHR11730:SF117', NULL, NULL, NULL, NULL, 'RH-ASSOCIATED GLYCOPROTEIN', 249303),
(392366, 'PTHR11730:SF89', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER SLL0108-RELATED', 249303),
(392367, 'PTHR11730:SF29', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER 3-RELATED', 249303),
(392368, 'PTHR11730:SF62', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER SLL1017-RELATED', 249303),
(392369, 'PTHR11730:SF60', NULL, NULL, NULL, NULL, 'RH50, ISOFORM D', 249303),
(392370, 'PTHR11730:SF43', NULL, NULL, NULL, NULL, 'BLOOD GROUP RH(CE) POLYPEPTIDE-RELATED', 249303),
(392371, 'PTHR11730:SF42', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER RH TYPE B', 249303),
(392372, 'PTHR11730:SF112', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER', 249303),
(392373, 'PTHR11730:SF110', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER RH TYPE C-LIKE 2', 249303),
(392374, 'PTHR11730', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER', 249303),
(392375, 'PTHR11730:SF116', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 249303),
(392376, 'PTHR11730:SF115', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER 3', 249303),
(392377, 'PTHR11730:SF114', NULL, NULL, NULL, NULL, 'AMMONIUM_TRANSP DOMAIN-CONTAINING PROTEIN', 249303),
(392378, 'PTHR11730:SF113', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER', 249303),
(392379, 'PTHR11730:SF108', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER 1 MEMBER 2', 249303),
(392380, 'PTHR11730:SF58', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER', 249303);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(392381, 'PTHR11730:SF95', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER 1 MEMBER 3', 249303),
(392382, 'PTHR11730:SF94', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER', 249303),
(392383, 'PTHR11730:SF93', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER', 249303),
(392384, 'PTHR11730:SF6', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER', 249303),
(392385, 'PTHR11730:SF32', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER RH TYPE A', 249303),
(392386, 'PTHR11730:SF30', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER RH TYPE C', 249303),
(392387, 'PTHR11730:SF101', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER 1 MEMBER 4', 249303),
(392388, 'PTHR11730:SF100', NULL, NULL, NULL, NULL, 'RH-LIKE PROTEIN IC', 249303),
(392389, 'PTHR11730:SF104', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER 1 MEMBER 2', 249303),
(392390, 'PTHR11730:SF103', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER 1 MEMBER 3', 249303),
(392391, 'PTHR11730:SF102', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER 1 MEMBER 5-RELATED', 249303),
(392392, 'PTHR11096', NULL, NULL, NULL, NULL, 'RNA 3'' TERMINAL PHOSPHATE CYCLASE', 249304),
(392393, 'PTHR11096:SF1', NULL, NULL, NULL, NULL, 'RNA 3''-TERMINAL PHOSPHATE CYCLASE-LIKE PROTEIN', 249304),
(392394, 'PTHR11096:SF0', NULL, NULL, NULL, NULL, 'RNA 3''-TERMINAL PHOSPHATE CYCLASE', 249304),
(392395, 'PTHR11096:SF2', NULL, NULL, NULL, NULL, 'BNAC08G04140D PROTEIN', 249304),
(392396, 'PTHR12704', NULL, NULL, NULL, NULL, 'TRANS-GOLGI PROTEIN GMX33', 249305),
(392397, 'PTHR12704:SF2', NULL, NULL, NULL, NULL, 'GOLGI PHOSPHOPROTEIN 3 HOMOLOG SAURON', 249305),
(392398, 'PTHR12704:SF3', NULL, NULL, NULL, NULL, 'GOLGI PHOSPHOPROTEIN 3', 249305),
(392399, 'PTHR12704:SF4', NULL, NULL, NULL, NULL, 'GOLGI PHOSPHOPROTEIN 3-LIKE', 249305),
(392400, 'PTHR34257:SF3', NULL, NULL, NULL, NULL, 'TRAF3-INTERACTING PROTEIN 2-LIKE', 249306),
(392401, 'PTHR34257:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE TRAF3IP2', 249306),
(392402, 'PTHR34257', NULL, NULL, NULL, NULL, 'ADAPTER PROTEIN CIKS', 249306),
(392403, 'PTHR10649', NULL, NULL, NULL, NULL, 'ARYL HYDROCARBON RECEPTOR', 249307),
(392404, 'PTHR10649:SF3', NULL, NULL, NULL, NULL, 'ARYL HYDROCARBON RECEPTOR REPRESSOR', 249307),
(392405, 'PTHR10649:SF12', NULL, NULL, NULL, NULL, 'SPINELESS, ISOFORM C', 249307),
(392406, 'PTHR10649:SF14', NULL, NULL, NULL, NULL, 'ARYL HYDROCARBON RECEPTOR 2', 249307),
(392407, 'PTHR10649:SF9', NULL, NULL, NULL, NULL, 'ARYL HYDROCARBON RECEPTOR', 249307),
(392408, 'PTHR10649:SF17', NULL, NULL, NULL, NULL, 'ARYL HYDROCARBON RECEPTOR', 249307),
(392409, 'PTHR10649:SF18', NULL, NULL, NULL, NULL, 'ARYL HYDROCARBON RECEPTOR 1B', 249307),
(392410, 'PTHR48132', NULL, NULL, NULL, NULL, 'ZGC:171772', 249308),
(392411, 'PTHR48132:SF3', NULL, NULL, NULL, NULL, 'ZGC:171772', 249308),
(392412, 'PTHR43850:SF2', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN MA_4021-RELATED', 249309),
(392413, 'PTHR43850', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN MA_4021-RELATED', 249309),
(392414, 'PTHR43850:SF1', NULL, NULL, NULL, NULL, 'TRANSPORT ATP-BINDING PROTEIN (CBIO-2) HOMOLOG, PUTATIVE-RELATED', 249309),
(392415, 'PTHR23334:SF3', NULL, NULL, NULL, NULL, 'CCAAT/ENHANCER-BINDING PROTEIN DELTA', 249310),
(392416, 'PTHR23334:SF48', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER 19', 249310),
(392417, 'PTHR23334:SF27', NULL, NULL, NULL, NULL, 'CCAAT/ENHANCER-BINDING PROTEIN EPSILON', 249310),
(392418, 'PTHR23334:SF49', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER 23', 249310),
(392419, 'PTHR23334:SF56', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 249310),
(392420, 'PTHR23334:SF67', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 249310),
(392421, 'PTHR23334:SF5', NULL, NULL, NULL, NULL, 'CCAAT/ENHANCER-BINDING PROTEIN ALPHA', 249310),
(392422, 'PTHR23334:SF69', NULL, NULL, NULL, NULL, 'CCAAT/ENHANCER-BINDING PROTEIN GAMMA', 249310),
(392423, 'PTHR23334:SF62', NULL, NULL, NULL, NULL, 'CCAAT/ENHANCER-BINDING PROTEIN (C/EBP) 1', 249310),
(392424, 'PTHR23334:SF52', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER 23-LIKE', 249310);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(392425, 'PTHR23334', NULL, NULL, NULL, NULL, 'CCAAT/ENHANCER BINDING PROTEIN', 249310),
(392426, 'PTHR23334:SF20', NULL, NULL, NULL, NULL, 'CCAAT/ENHANCER-BINDING PROTEIN-RELATED', 249310),
(392427, 'PTHR23334:SF65', NULL, NULL, NULL, NULL, 'OS11G0139500 PROTEIN', 249310),
(392428, 'PTHR23334:SF54', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 249310),
(392429, 'PTHR23334:SF43', NULL, NULL, NULL, NULL, 'C/EBP (CCAAT/ENHANCER-BINDING PROTEIN) HOMOLOG-RELATED', 249310),
(392430, 'PTHR23334:SF21', NULL, NULL, NULL, NULL, 'CCAAT/ENHANCER-BINDING PROTEIN BETA', 249310),
(392431, 'PTHR23334:SF70', NULL, NULL, NULL, NULL, 'BASIC-LEUCINE ZIPPER (BZIP) TRANSCRIPTION FACTOR FAMILY PROTEIN-RELATED', 249310),
(392432, 'PTHR23334:SF60', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 249310),
(392433, 'PTHR23334:SF71', NULL, NULL, NULL, NULL, 'OS05G0495200 PROTEIN', 249310),
(392434, 'PTHR23334:SF72', NULL, NULL, NULL, NULL, 'PROTEIN MABIKI', 249310),
(392435, 'PTHR23334:SF19', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR ZIP-2', 249310),
(392436, 'PTHR37483:SF1', NULL, NULL, NULL, NULL, 'UPF0125 PROTEIN RATB', 249311),
(392437, 'PTHR37483', NULL, NULL, NULL, NULL, 'UPF0125 PROTEIN RATB', 249311),
(392438, 'PTHR21028', NULL, NULL, NULL, NULL, 'SI:CH211-156B7.4', 249312),
(392439, 'PTHR21028:SF2', NULL, NULL, NULL, NULL, 'SI:CH211-156B7.4', 249312),
(392440, 'PTHR37195', NULL, NULL, NULL, NULL, 'OS01G0332900 PROTEIN', 249313),
(392441, 'PTHR37195:SF2', NULL, NULL, NULL, NULL, 'SARCOPLASMIC RETICULUM HISTIDINE-RICH CALCIUM-BINDING PROTEIN ISOFORM X1', 249313),
(392442, 'PTHR10504:SF139', NULL, NULL, NULL, NULL, 'PROTEIN CBG16502', 249314),
(392443, 'PTHR10504:SF17', NULL, NULL, NULL, NULL, 'BPI FOLD-CONTAINING FAMILY C PROTEIN', 249314),
(392444, 'PTHR10504:SF137', NULL, NULL, NULL, NULL, 'PROTEIN CBG03384', 249314),
(392445, 'PTHR10504:SF16', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID TRANSFER PROTEIN', 249314),
(392446, 'PTHR10504:SF66', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE-BINDING PROTEIN', 249314),
(392447, 'PTHR10504:SF76', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE-BINDING PROTEIN-LIKE', 249314),
(392448, 'PTHR10504:SF136', NULL, NULL, NULL, NULL, 'NOSE RESISTANT TO FLUOXETINE PROTEIN 5', 249314),
(392449, 'PTHR10504:SF144', NULL, NULL, NULL, NULL, 'BPI2 DOMAIN-CONTAINING PROTEIN', 249314),
(392450, 'PTHR10504:SF133', NULL, NULL, NULL, NULL, 'BPI2 DOMAIN-CONTAINING PROTEIN', 249314),
(392451, 'PTHR10504:SF145', NULL, NULL, NULL, NULL, 'PROTEIN CBG15266', 249314),
(392452, 'PTHR10504:SF134', NULL, NULL, NULL, NULL, 'PROTEIN CBG19248', 249314),
(392453, 'PTHR10504', NULL, NULL, NULL, NULL, 'BACTERICIDAL PERMEABILITY-INCREASING  BPI  PROTEIN-RELATED', 249314),
(392454, 'PTHR10504:SF84', NULL, NULL, NULL, NULL, 'BACTERICIDAL PERMEABILITY-INCREASING PROTEIN', 249314),
(392455, 'PTHR10504:SF142', NULL, NULL, NULL, NULL, 'UPF0522 PROTEIN A-RELATED', 249314),
(392456, 'PTHR10504:SF131', NULL, NULL, NULL, NULL, 'UPF0522 PROTEIN C', 249314),
(392457, 'PTHR10504:SF132', NULL, NULL, NULL, NULL, 'BPI FOLD-CONTAINING FAMILY C,-LIKE', 249314),
(392458, 'PTHR10504:SF143', NULL, NULL, NULL, NULL, 'PROTEIN CBG19877', 249314),
(392459, 'PTHR10504:SF140', NULL, NULL, NULL, NULL, 'PROTEIN CBG17409', 249314),
(392460, 'PTHR38101:SF1', NULL, NULL, NULL, NULL, 'UPF0307 PROTEIN YJGA', 249315),
(392461, 'PTHR38101', NULL, NULL, NULL, NULL, 'UPF0307 PROTEIN YJGA', 249315),
(392462, 'PTHR23171:SF16', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE II SUBUNIT GRINL1A', 249316),
(392463, 'PTHR23171:SF13', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE II SUBUNIT GRINL1A', 249316),
(392464, 'PTHR23171', NULL, NULL, NULL, NULL, 'GDOWN1', 249316),
(392465, 'PTHR23171:SF2', NULL, NULL, NULL, NULL, 'MYOCARDIAL ZONULA ADHERENS PROTEIN', 249316),
(392466, 'PTHR23171:SF3', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 68', 249316),
(392467, 'PTHR23171:SF4', NULL, NULL, NULL, NULL, 'TUFTELIN', 249316),
(392468, 'PTHR23171:SF5', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE II SUBUNIT GRINL1A', 249316);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(392469, 'PTHR23005:SF3', NULL, NULL, NULL, NULL, 'RETINITIS PIGMENTOSA 1-LIKE 1 PROTEIN', 249317),
(392470, 'PTHR23005:SF4', NULL, NULL, NULL, NULL, 'OXYGEN-REGULATED PROTEIN 1', 249317),
(392471, 'PTHR23005:SF5', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 249317),
(392472, 'PTHR23005:SF6', NULL, NULL, NULL, NULL, 'RP1-LIKE 1B', 249317),
(392473, 'PTHR23005', NULL, NULL, NULL, NULL, 'RETINITIS PIGMENTOSA 1 PROTEIN', 249317),
(392474, 'PTHR11636:SF5', NULL, NULL, NULL, NULL, 'POU DOMAIN MOTIF 3, ISOFORM F', 249318),
(392475, 'PTHR11636:SF128', NULL, NULL, NULL, NULL, 'POU DOMAIN, CLASS 5, TRANSCRIPTION FACTOR 1', 249318),
(392476, 'PTHR11636:SF47', NULL, NULL, NULL, NULL, 'POU DOMAIN, CLASS 2, TRANSCRIPTION FACTOR 1', 249318),
(392477, 'PTHR11636:SF46', NULL, NULL, NULL, NULL, 'POU DOMAIN, CLASS 2, TRANSCRIPTION FACTOR 2', 249318),
(392478, 'PTHR11636:SF68', NULL, NULL, NULL, NULL, 'POU DOMAIN, CLASS 6, TRANSCRIPTION FACTOR 2', 249318),
(392479, 'PTHR11636:SF89', NULL, NULL, NULL, NULL, 'POU DOMAIN PROTEIN CF1A', 249318),
(392480, 'PTHR11636:SF44', NULL, NULL, NULL, NULL, 'BRAIN-SPECIFIC HOMEOBOX/POU DOMAIN PROTEIN 3', 249318),
(392481, 'PTHR11636:SF43', NULL, NULL, NULL, NULL, 'POU DOMAIN, CLASS 4, TRANSCRIPTION FACTOR 3', 249318),
(392482, 'PTHR11636:SF125', NULL, NULL, NULL, NULL, 'POU DOMAIN, CLASS 3, TRANSCRIPTION FACTOR 3', 249318),
(392483, 'PTHR11636:SF42', NULL, NULL, NULL, NULL, 'POU DOMAIN, CLASS 4, TRANSCRIPTION FACTOR 1', 249318),
(392484, 'PTHR11636:SF6', NULL, NULL, NULL, NULL, 'POU DOMAIN, CLASS 6, TRANSCRIPTION FACTOR 1', 249318),
(392485, 'PTHR11636:SF86', NULL, NULL, NULL, NULL, 'POU DOMAIN, CLASS 5, TRANSCRIPTION FACTOR 1-RELATED', 249318),
(392486, 'PTHR11636', NULL, NULL, NULL, NULL, 'POU DOMAIN', 249318),
(392487, 'PTHR11636:SF70', NULL, NULL, NULL, NULL, 'INHIBITORY POU PROTEIN', 249318),
(392488, 'PTHR11636:SF14', NULL, NULL, NULL, NULL, 'POU DOMAIN, CLASS 5, TRANSCRIPTION FACTOR 2', 249318),
(392489, 'PTHR11636:SF76', NULL, NULL, NULL, NULL, 'POU DOMAIN PROTEIN 2, ISOFORM B-RELATED', 249318),
(392490, 'PTHR11636:SF75', NULL, NULL, NULL, NULL, 'POU DOMAIN, CLASS 3, TRANSCRIPTION FACTOR 1', 249318),
(392491, 'PTHR11636:SF115', NULL, NULL, NULL, NULL, 'POU DOMAIN, CLASS 3, TRANSCRIPTION FACTOR 2', 249318),
(392492, 'PTHR11636:SF41', NULL, NULL, NULL, NULL, 'POU DOMAIN, CLASS 4, TRANSCRIPTION FACTOR 2', 249318),
(392493, 'PTHR11636:SF84', NULL, NULL, NULL, NULL, 'NETRIN-1-RELATED', 249318),
(392494, 'PTHR11636:SF131', NULL, NULL, NULL, NULL, 'POU DOMAIN PROTEIN', 249318),
(392495, 'PTHR11636:SF132', NULL, NULL, NULL, NULL, 'POU DOMAIN PROTEIN-RELATED', 249318),
(392496, 'PTHR11636:SF83', NULL, NULL, NULL, NULL, 'POU DOMAIN, CLASS 3, TRANSCRIPTION FACTOR 4', 249318),
(392497, 'PTHR11636:SF133', NULL, NULL, NULL, NULL, 'POU DOMAIN, CLASS 3, TRANSCRIPTION FACTOR 1', 249318),
(392498, 'PTHR11636:SF81', NULL, NULL, NULL, NULL, 'POU DOMAIN, CLASS 2, TRANSCRIPTION FACTOR 3', 249318),
(392499, 'PTHR11636:SF80', NULL, NULL, NULL, NULL, 'HIGHLY DIVERGENT HOMEOBOX', 249318),
(392500, 'PTHR39434:SF1', NULL, NULL, NULL, NULL, 'VOC DOMAIN-CONTAINING PROTEIN', 249319),
(392501, 'PTHR39434', NULL, NULL, NULL, NULL, '', 249319),
(392502, 'PTHR10283:SF109', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 13 MEMBER 5', 249320),
(392503, 'PTHR10283:SF127', NULL, NULL, NULL, NULL, 'OS08G0503700 PROTEIN', 249320),
(392504, 'PTHR10283:SF129', NULL, NULL, NULL, NULL, 'TONOPLAST DICARBOXYLATE TRANSPORTER', 249320),
(392505, 'PTHR10283:SF133', NULL, NULL, NULL, NULL, 'BNAA02G25550D PROTEIN', 249320),
(392506, 'PTHR10283:SF134', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 13 MEMBER 5A', 249320),
(392507, 'PTHR10283:SF135', NULL, NULL, NULL, NULL, '', 249320),
(392508, 'PTHR10283:SF125', NULL, NULL, NULL, NULL, 'CITRATE TRANSPORTER', 249320),
(392509, 'PTHR10283:SF131', NULL, NULL, NULL, NULL, 'BNAC09G20290D PROTEIN', 249320),
(392510, 'PTHR10283:SF110', NULL, NULL, NULL, NULL, 'INORGANIC PHOSPHATE TRANSPORTER PHO87-RELATED', 249320),
(392511, 'PTHR10283:SF77', NULL, NULL, NULL, NULL, 'PROTEIN CBG18085', 249320);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(392512, 'PTHR10283:SF65', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 13 MEMBER 1', 249320),
(392513, 'PTHR10283:SF85', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT HIGH-AFFINITY DICARBOXYLATE TRANSPORTER 3', 249320),
(392514, 'PTHR10283:SF63', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 13 MEMBER 4', 249320),
(392515, 'PTHR10283:SF62', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 13 MEMBER 3', 249320),
(392516, 'PTHR10283:SF84', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT HIGH-AFFINITY DICARBOXYLATE TRANSPORTER 2', 249320),
(392517, 'PTHR10283:SF82', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 13 MEMBER 2', 249320),
(392518, 'PTHR10283:SF92', NULL, NULL, NULL, NULL, 'LOW-AFFINITY PHOSPHATE TRANSPORTER PHO91', 249320),
(392519, 'PTHR10283', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 13 MEMBER', 249320),
(392520, 'PTHR11358:SF28', NULL, NULL, NULL, NULL, 'HYPOTHETICAL ARGINASE FAMILY PROTEIN (EUROFUNG)', 249321),
(392521, 'PTHR11358:SF26', NULL, NULL, NULL, NULL, 'AGMATINASE, MITOCHONDRIAL', 249321),
(392522, 'PTHR11358', NULL, NULL, NULL, NULL, 'ARGINASE/AGMATINASE', 249321),
(392523, 'PTHR11358:SF30', NULL, NULL, NULL, NULL, 'AGMATINASE 1-RELATED', 249321),
(392524, 'PTHR11358:SF41', NULL, NULL, NULL, NULL, 'ARGINASE-RELATED', 249321),
(392525, 'PTHR11358:SF42', NULL, NULL, NULL, NULL, 'ARGINASE 1, MITOCHONDRIAL', 249321),
(392526, 'PTHR11358:SF35', NULL, NULL, NULL, NULL, 'FORMIMIDOYLGLUTAMASE', 249321),
(392527, 'PTHR11358:SF32', NULL, NULL, NULL, NULL, 'ARGINASE 2, CHLOROPLASTIC/MITOCHONDRIAL', 249321),
(392528, 'PTHR35093', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN NMB0088-RELATED', 249322),
(392529, 'PTHR35093:SF1', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE LONG-CHAIN FATTY ACID RECEPTOR FADL FAMILY', 249322),
(392530, 'PTHR35093:SF8', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN NMB0088-RELATED', 249322),
(392531, 'PTHR35093:SF3', NULL, NULL, NULL, NULL, 'LONG-CHAIN FATTY ACID TRANSPORT PROTEIN', 249322),
(392532, 'PTHR22414', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 249323),
(392533, 'PTHR22414:SF0', NULL, NULL, NULL, NULL, 'LEUCINE ZIPPER PROTEIN 2', 249323),
(392534, 'PTHR12871:SF4', NULL, NULL, NULL, NULL, 'ALPHA-1,6-MANNOSYL-GLYCOPROTEIN 2-BETA-N-ACETYLGLUCOSAMINYLTRANSFERASE', 249324),
(392535, 'PTHR12871:SF5', NULL, NULL, NULL, NULL, 'ALPHA-1,6-MANNOSYL-GLYCOPROTEIN 2-BETA-N-ACETYLGLUCOSAMINYLTRANSFERASE', 249324),
(392536, 'PTHR12871:SF3', NULL, NULL, NULL, NULL, 'ALPHA-1,6-MANNOSYL-GLYCOPROTEIN 2-BETA-N-ACETYLGLUCOSAMINYLTRANSFERASE', 249324),
(392537, 'PTHR12871:SF0', NULL, NULL, NULL, NULL, 'ALPHA-1,6-MANNOSYL-GLYCOPROTEIN 2-BETA-N-ACETYLGLUCOSAMINYLTRANSFERASE', 249324),
(392538, 'PTHR12871', NULL, NULL, NULL, NULL, 'BETA-1,2-N-ACETYLGLUCOSAMINYLTRANSFERASE II', 249324),
(392539, 'PTHR43353:SF2', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_8G05520)', 249325),
(392540, 'PTHR43353:SF3', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE-RELATED', 249325),
(392541, 'PTHR43353:SF5', NULL, NULL, NULL, NULL, 'SUCCINATE-SEMIALDEHYDE DEHYDROGENASE, MITOCHONDRIAL', 249325),
(392542, 'PTHR43353', NULL, NULL, NULL, NULL, 'SUCCINATE-SEMIALDEHYDE DEHYDROGENASE, MITOCHONDRIAL', 249325),
(392543, 'PTHR43353:SF12', NULL, NULL, NULL, NULL, 'SUCCINATE-SEMIALDEHYDE DEHYDROGENASE C139.05 [NADP(+)]-RELATED', 249325),
(392544, 'PTHR43353:SF6', NULL, NULL, NULL, NULL, 'CYTOPLASMIC ALDEHYDE DEHYDROGENASE (EUROFUNG)', 249325),
(392545, 'PTHR43353:SF7', NULL, NULL, NULL, NULL, 'SUCCINATE SEMIALDEHYDE DEHYDROGENASE (EUROFUNG)', 249325),
(392546, 'PTHR43353:SF11', NULL, NULL, NULL, NULL, 'SUCCINATE SEMIALDEHYDE DEHYDROGENASE (EUROFUNG)', 249325),
(392547, 'PTHR43353:SF10', NULL, NULL, NULL, NULL, 'SUCCINATE-SEMIALDEHYDE DEHYDROGENASE (NADP+)', 249325),
(392548, 'PTHR10671:SF9', NULL, NULL, NULL, NULL, 'LENS FIBER MEMBRANE INTRINSIC PROTEIN', 249326),
(392549, 'PTHR10671:SF94', NULL, NULL, NULL, NULL, 'OUTER DENSE FIBER PROTEIN 4', 249326),
(392550, 'PTHR10671:SF8', NULL, NULL, NULL, NULL, 'EPITHELIAL MEMBRANE PROTEIN 3', 249326),
(392551, 'PTHR10671:SF7', NULL, NULL, NULL, NULL, 'PERIPHERAL MYELIN PROTEIN 22', 249326);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(392552, 'PTHR10671:SF51', NULL, NULL, NULL, NULL, 'NEURONAL SYMMETRY', 249326),
(392553, 'PTHR10671:SF30', NULL, NULL, NULL, NULL, 'CLAUDIN DOMAIN-CONTAINING PROTEIN 2', 249326),
(392554, 'PTHR10671:SF96', NULL, NULL, NULL, NULL, 'CLC-LIKE PROTEIN 5', 249326),
(392555, 'PTHR10671:SF6', NULL, NULL, NULL, NULL, 'EPITHELIAL MEMBRANE PROTEIN 1', 249326),
(392556, 'PTHR10671:SF92', NULL, NULL, NULL, NULL, 'GSG1-LIKE 2A', 249326),
(392557, 'PTHR10671:SF35', NULL, NULL, NULL, NULL, 'GERM CELL-SPECIFIC GENE 1-LIKE PROTEIN', 249326),
(392558, 'PTHR10671:SF32', NULL, NULL, NULL, NULL, 'EPITHELIAL MEMBRANE PROTEIN 2', 249326),
(392559, 'PTHR10671:SF54', NULL, NULL, NULL, NULL, 'CLC-LIKE PROTEIN 2', 249326),
(392560, 'PTHR10671:SF99', NULL, NULL, NULL, NULL, '', 249326),
(392561, 'PTHR10671:SF78', NULL, NULL, NULL, NULL, 'SI:CH211-232M10.6', 249326),
(392562, 'PTHR10671:SF34', NULL, NULL, NULL, NULL, 'PROTEIN NKG7', 249326),
(392563, 'PTHR10671:SF109', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1700028J19 GENE', 249326),
(392564, 'PTHR10671:SF82', NULL, NULL, NULL, NULL, 'FI18012P1', 249326),
(392565, 'PTHR10671:SF84', NULL, NULL, NULL, NULL, 'LENS INTRINSIC MEMBRANE PROTEIN 2.4', 249326),
(392566, 'PTHR10671:SF40', NULL, NULL, NULL, NULL, 'GERM CELL-SPECIFIC GENE 1-LIKE PROTEIN 2', 249326),
(392567, 'PTHR10671:SF85', NULL, NULL, NULL, NULL, 'EPITHELIAL MEMBRANE PROTEIN 1', 249326),
(392568, 'PTHR10671:SF100', NULL, NULL, NULL, NULL, 'APPLE DOMAIN-CONTAINING PROTEIN', 249326),
(392569, 'PTHR10671:SF101', NULL, NULL, NULL, NULL, 'SI:CH211-149K23.9', 249326),
(392570, 'PTHR10671:SF25', NULL, NULL, NULL, NULL, 'LENS INTRINSIC MEMBRANE PROTEIN 2.1-RELATED', 249326),
(392571, 'PTHR10671:SF103', NULL, NULL, NULL, NULL, 'CLAUDIN-LIKE IN CAENORHABDITIS', 249326),
(392572, 'PTHR10671:SF104', NULL, NULL, NULL, NULL, 'PROTEIN CBG06012', 249326),
(392573, 'PTHR10671:SF42', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 202', 249326),
(392574, 'PTHR10671:SF105', NULL, NULL, NULL, NULL, '', 249326),
(392575, 'PTHR10671:SF43', NULL, NULL, NULL, NULL, 'GERM CELL-SPECIFIC GENE 1 PROTEIN', 249326),
(392576, 'PTHR10671:SF106', NULL, NULL, NULL, NULL, 'LENS INTRINSIC MEMBRANE PROTEIN 2.2', 249326),
(392577, 'PTHR10671:SF107', NULL, NULL, NULL, NULL, 'PERIPHERAL MYELIN PROTEIN 22', 249326),
(392578, 'PTHR10671:SF88', NULL, NULL, NULL, NULL, 'PROTEIN CBG10848', 249326),
(392579, 'PTHR10671', NULL, NULL, NULL, NULL, 'EPITHELIAL MEMBRANE PROTEIN-RELATED', 249326),
(392580, 'PTHR10671:SF45', NULL, NULL, NULL, NULL, 'PROTEIN CBG23133', 249326),
(392581, 'PTHR10671:SF108', NULL, NULL, NULL, NULL, 'GH19567P', 249326),
(392582, 'PTHR24006:SF926', NULL, NULL, NULL, NULL, 'INACTIVE UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 17-LIKE PROTEIN 4-RELATED', 249327),
(392583, 'PTHR24006:SF925', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1', 249327),
(392584, 'PTHR24006:SF924', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1', 249327),
(392585, 'PTHR24006:SF923', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE SUPERFAMILY PROTEIN-RELATED', 249327),
(392586, 'PTHR24006:SF889', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 21', 249327),
(392587, 'PTHR24006:SF768', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 7', 249327),
(392588, 'PTHR24006:SF922', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1', 249327),
(392589, 'PTHR24006:SF647', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 12', 249327),
(392590, 'PTHR24006:SF921', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1', 249327),
(392591, 'PTHR24006:SF888', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 249327),
(392592, 'PTHR24006:SF920', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 249327),
(392593, 'PTHR24006:SF766', NULL, NULL, NULL, NULL, 'OS04G0452400 PROTEIN', 249327),
(392594, 'PTHR24006:SF887', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 249327),
(392595, 'PTHR24006:SF807', NULL, NULL, NULL, NULL, 'OS08G0527300 PROTEIN', 249327),
(392596, 'PTHR24006:SF886', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 249327); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(392597, 'PTHR24006:SF644', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE K02C4.3-RELATED', 249327),
(392598, 'PTHR24006:SF885', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE FAF-X-RELATED', 249327),
(392599, 'PTHR24006:SF884', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 249327),
(392600, 'PTHR24006:SF883', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1', 249327),
(392601, 'PTHR24006:SF882', NULL, NULL, NULL, NULL, 'CLAN CA, FAMILY C19, UBIQUITIN HYDROLASE-LIKE CYSTEINE PEPTIDASE', 249327),
(392602, 'PTHR24006:SF761', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 7', 249327),
(392603, 'PTHR24006:SF881', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1', 249327),
(392604, 'PTHR24006:SF880', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 7', 249327),
(392605, 'PTHR24006:SF916', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 249327),
(392606, 'PTHR24006:SF915', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE-RELATED', 249327),
(392607, 'PTHR24006:SF914', NULL, NULL, NULL, NULL, 'CARBOXYL-TERMINAL HYDROLASE, PUTATIVE-RELATED', 249327),
(392608, 'PTHR24006:SF913', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1', 249327),
(392609, 'PTHR24006:SF879', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 249327),
(392610, 'PTHR24006:SF758', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 36', 249327),
(392611, 'PTHR24006:SF912', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1', 249327),
(392612, 'PTHR24006:SF878', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 249327),
(392613, 'PTHR24006:SF911', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 26', 249327),
(392614, 'PTHR24006:SF910', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1', 249327),
(392615, 'PTHR24006:SF756', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 249327),
(392616, 'PTHR24006:SF919', NULL, NULL, NULL, NULL, 'TRAF-LIKE PROTEIN-RELATED', 249327),
(392617, 'PTHR24006:SF918', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 26', 249327),
(392618, 'PTHR24006:SF917', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1', 249327),
(392619, 'PTHR24006:SF874', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 16', 249327),
(392620, 'PTHR24006:SF905', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 1', 249327),
(392621, 'PTHR24006:SF904', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 249327),
(392622, 'PTHR24006:SF903', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 19', 249327),
(392623, 'PTHR24006:SF902', NULL, NULL, NULL, NULL, 'UBIQUITIN-SPECIFIC PEPTIDASE 47', 249327),
(392624, 'PTHR24006:SF901', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1', 249327),
(392625, 'PTHR24006:SF747', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 20', 249327),
(392626, 'PTHR24006:SF900', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1', 249327),
(392627, 'PTHR24006:SF746', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 21', 249327),
(392628, 'PTHR24006:SF909', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1-RELATED', 249327),
(392629, 'PTHR24006:SF908', NULL, NULL, NULL, NULL, 'DEUBIQUITINATING APOPTOTIC INHIBITOR, ISOFORM A', 249327),
(392630, 'PTHR24006:SF907', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1', 249327),
(392631, 'PTHR24006:SF906', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1', 249327),
(392632, 'PTHR24006:SF863', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 249327),
(392633, 'PTHR24006:SF862', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 249327),
(392634, 'PTHR24006:SF860', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 249327),
(392635, 'PTHR24006:SF858', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 249327),
(392636, 'PTHR24006:SF857', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXY-TERMINAL HYDROLASE', 249327),
(392637, 'PTHR24006:SF854', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 249327);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(392638, 'PTHR24006:SF733', NULL, NULL, NULL, NULL, 'RE52890P', 249327),
(392639, 'PTHR24006:SF690', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 17', 249327),
(392640, 'PTHR24006:SF852', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 249327),
(392641, 'PTHR24006:SF693', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE FAF-Y-RELATED', 249327),
(392642, 'PTHR24006:SF729', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 24', 249327),
(392643, 'PTHR24006:SF849', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 249327),
(392644, 'PTHR24006:SF727', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 42', 249327),
(392645, 'PTHR24006:SF722', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 48', 249327),
(392646, 'PTHR24006:SF842', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 40', 249327),
(392647, 'PTHR24006:SF721', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 249327),
(392648, 'PTHR24006:SF687', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 10', 249327),
(392649, 'PTHR24006:SF840', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 249327),
(392650, 'PTHR24006:SF686', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 37', 249327),
(392651, 'PTHR24006:SF685', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 15', 249327),
(392652, 'PTHR24006:SF682', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 13', 249327),
(392653, 'PTHR24006:SF839', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 249327),
(392654, 'PTHR24006:SF837', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 249327),
(392655, 'PTHR24006:SF716', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 2', 249327),
(392656, 'PTHR24006:SF836', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 249327),
(392657, 'PTHR24006:SF714', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 46', 249327),
(392658, 'PTHR24006:SF834', NULL, NULL, NULL, NULL, 'BNAA09G41280D PROTEIN', 249327),
(392659, 'PTHR24006:SF711', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 29', 249327),
(392660, 'PTHR24006:SF832', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1', 249327),
(392661, 'PTHR24006:SF799', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 249327),
(392662, 'PTHR24006:SF678', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 28', 249327),
(392663, 'PTHR24006', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 249327),
(392664, 'PTHR24006:SF710', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 38', 249327),
(392665, 'PTHR24006:SF677', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 18', 249327),
(392666, 'PTHR24006:SF796', NULL, NULL, NULL, NULL, 'UBL CARBOXYL-TERMINAL HYDROLASE 18-RELATED', 249327),
(392667, 'PTHR24006:SF672', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 249327),
(392668, 'PTHR24006:SF791', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1', 249327),
(392669, 'PTHR24006:SF827', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 34', 249327),
(392670, 'PTHR24006:SF825', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 249327),
(392671, 'PTHR24006:SF702', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 47', 249327),
(392672, 'PTHR24006:SF823', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 249327),
(392673, 'PTHR24006:SF787', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 249327),
(392674, 'PTHR24006:SF666', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 25', 249327),
(392675, 'PTHR24006:SF665', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 249327),
(392676, 'PTHR24006:SF786', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1-RELATED', 249327),
(392677, 'PTHR24006:SF664', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 249327),
(392678, 'PTHR24006:SF784', NULL, NULL, NULL, NULL, 'OS02G0795000 PROTEIN', 249327);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(392679, 'PTHR24006:SF663', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 23', 249327),
(392680, 'PTHR24006:SF781', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1', 249327),
(392681, 'PTHR24006:SF660', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 35', 249327),
(392682, 'PTHR24006:SF780', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 249327),
(392683, 'PTHR24006:SF814', NULL, NULL, NULL, NULL, 'BNAA03G46800D PROTEIN', 249327),
(392684, 'PTHR24006:SF813', NULL, NULL, NULL, NULL, '', 249327),
(392685, 'PTHR24006:SF899', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 249327),
(392686, 'PTHR24006:SF898', NULL, NULL, NULL, NULL, 'CLAN CA, FAMILY C19, UBIQUITIN HYDROLASE-LIKE CYSTEINE PEPTIDASE', 249327),
(392687, 'PTHR24006:SF897', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE FAF-X-RELATED', 249327),
(392688, 'PTHR24006:SF655', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 5', 249327),
(392689, 'PTHR24006:SF896', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1', 249327),
(392690, 'PTHR24006:SF653', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 36', 249327),
(392691, 'PTHR24006:SF895', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 249327),
(392692, 'PTHR24006:SF894', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 3-RELATED', 249327),
(392693, 'PTHR24006:SF651', NULL, NULL, NULL, NULL, 'INACTIVE UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 17-LIKE PROTEIN 7-RELATED', 249327),
(392694, 'PTHR24006:SF893', NULL, NULL, NULL, NULL, 'PEPTIDASE C19, UBIQUITIN CARBOXYL-TERMINAL HYDROLASE-RELATED', 249327),
(392695, 'PTHR24006:SF650', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 30', 249327),
(392696, 'PTHR24006:SF892', NULL, NULL, NULL, NULL, 'OS09G0464400 PROTEIN', 249327),
(392697, 'PTHR24006:SF771', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1', 249327),
(392698, 'PTHR24006:SF891', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 2', 249327),
(392699, 'PTHR24006:SF890', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 16-RELATED', 249327),
(392700, 'PTHR42795', NULL, NULL, NULL, NULL, 'ALANINE DEHYDROGENASE', 249328),
(392701, 'PTHR42795:SF1', NULL, NULL, NULL, NULL, 'ALANINE DEHYDROGENASE', 249328),
(392702, 'PTHR46085:SF9', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN AGD6-RELATED', 249329),
(392703, 'PTHR46085', NULL, NULL, NULL, NULL, 'ARFGAP/RECO-RELATED', 249329),
(392704, 'PTHR46085:SF3', NULL, NULL, NULL, NULL, 'ARF-GAP DOMAIN-CONTAINING PROTEIN', 249329),
(392705, 'PTHR46085:SF16', NULL, NULL, NULL, NULL, 'ARF-GAP DOMAIN-CONTAINING PROTEIN', 249329),
(392706, 'PTHR46085:SF17', NULL, NULL, NULL, NULL, 'OS01G0813900 PROTEIN', 249329),
(392707, 'PTHR46085:SF12', NULL, NULL, NULL, NULL, 'ARF-GAP DOMAIN-CONTAINING PROTEIN', 249329),
(392708, 'PTHR46085:SF11', NULL, NULL, NULL, NULL, 'ARFGAP/RECO-LIKE ZINC FINGER DOMAIN-CONTAINING PROTEIN', 249329),
(392709, 'PTHR46085:SF6', NULL, NULL, NULL, NULL, 'ARF GTPASE ACTIVATOR', 249329),
(392710, 'PTHR46085:SF4', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN AGD14-RELATED', 249329),
(392711, 'PTHR23281:SF40', NULL, NULL, NULL, NULL, 'FERM DOMAIN-CONTAINING PROTEIN', 249330),
(392712, 'PTHR23281:SF41', NULL, NULL, NULL, NULL, 'FERM DOMAIN-CONTAINING PROTEIN', 249330),
(392713, 'PTHR23281:SF20', NULL, NULL, NULL, NULL, 'FERM DOMAIN-CONTAINING PROTEIN', 249330),
(392714, 'PTHR23281:SF18', NULL, NULL, NULL, NULL, 'MOESIN/EZRIN/RADIXIN HOMOLOG 1', 249330),
(392715, 'PTHR23281', NULL, NULL, NULL, NULL, 'MERLIN/MOESIN/EZRIN/RADIXIN', 249330),
(392716, 'PTHR23281:SF14', NULL, NULL, NULL, NULL, 'RADIXIN', 249330),
(392717, 'PTHR23281:SF26', NULL, NULL, NULL, NULL, 'MOESIN', 249330),
(392718, 'PTHR23281:SF39', NULL, NULL, NULL, NULL, 'MOESIN/EZRIN/RADIXIN HOMOLOG 2', 249330),
(392719, 'PTHR23281:SF23', NULL, NULL, NULL, NULL, 'MERLIN', 249330),
(392720, 'PTHR23281:SF13', NULL, NULL, NULL, NULL, 'EZRIN', 249330);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(392721, 'PTHR39196', NULL, NULL, NULL, NULL, 'PRIMOSOME, DNAD SUBUNIT', 249331),
(392722, 'PTHR39196:SF1', NULL, NULL, NULL, NULL, 'PRIMOSOME, DNAD SUBUNIT', 249331),
(392723, 'PTHR11964:SF1', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE SYNTHASE', 249332),
(392724, 'PTHR11964:SF70', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE SYNTHASE 4', 249332),
(392725, 'PTHR11964:SF72', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE SYNTHASE', 249332),
(392726, 'PTHR11964:SF61', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE SYNTHASE 3', 249332),
(392727, 'PTHR11964:SF11', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE SYNTHASE ISOFORM TYPE-1', 249332),
(392728, 'PTHR11964:SF55', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE SYNTHASE', 249332),
(392729, 'PTHR11964:SF66', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE SYNTHASE', 249332),
(392730, 'PTHR11964:SF77', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE SYNTHASE', 249332),
(392731, 'PTHR11964:SF78', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE SYNTHASE', 249332),
(392732, 'PTHR11964:SF67', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE SYNTHASE 3', 249332),
(392733, 'PTHR11964:SF13', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE SYNTHASE 1-RELATED', 249332),
(392734, 'PTHR11964:SF79', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE SYNTHASE', 249332),
(392735, 'PTHR11964:SF69', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE SYNTHASE', 249332),
(392736, 'PTHR11964', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE SYNTHETASE', 249332),
(392737, 'PTHR11964:SF73', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE SYNTHASE ISOFORM TYPE-2', 249332),
(392738, 'PTHR11964:SF74', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE SYNTHASE 1', 249332),
(392739, 'PTHR11964:SF63', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE SYNTHASE 1-RELATED', 249332),
(392740, 'PTHR11964:SF42', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE SYNTHASE 1', 249332),
(392741, 'PTHR11964:SF75', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE SYNTHASE 3-RELATED', 249332),
(392742, 'PTHR11964:SF53', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE SYNTHASE', 249332),
(392743, 'PTHR11964:SF54', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE SYNTHASE', 249332),
(392744, 'PTHR11964:SF76', NULL, NULL, NULL, NULL, 'METHIONINE ADENOSYLTRANSFERASE', 249332),
(392745, 'PTHR11964:SF38', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE SYNTHASE', 249332),
(392746, 'PTHR31332:SF0', NULL, NULL, NULL, NULL, '7-HYDROXYMETHYL CHLOROPHYLL A REDUCTASE, CHLOROPLASTIC', 249333),
(392747, 'PTHR31332:SF6', NULL, NULL, NULL, NULL, 'FORMATE DEHYDROGENASE SUBUNIT BETA', 249333),
(392748, 'PTHR31332', NULL, NULL, NULL, NULL, '7-HYDROXYMETHYL CHLOROPHYLL A REDUCTASE, CHLOROPLASTIC', 249333),
(392749, 'PTHR36838', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER FAMILY PROTEIN', 249334),
(392750, 'PTHR36838:SF3', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER FAMILY PROTEIN', 249334),
(392751, 'PTHR36838:SF2', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER', 249334),
(392752, 'PTHR36838:SF1', NULL, NULL, NULL, NULL, 'SLR1864 PROTEIN', 249334),
(392753, 'PTHR43370', NULL, NULL, NULL, NULL, 'SUGAR ABC TRANSPORTER INTEGRAL MEMBRANE PROTEIN-RELATED', 249335),
(392754, 'PTHR43370:SF2', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN', 249335),
(392755, 'PTHR43370:SF1', NULL, NULL, NULL, NULL, 'GUANOSINE ABC TRANSPORTER PERMEASE PROTEIN NUPQ', 249335),
(392756, 'PTHR46509', NULL, NULL, NULL, NULL, 'PHOSPHOADENOSINE PHOSPHOSULFATE REDUCTASE', 249336),
(392757, 'PTHR46509:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOADENOSINE PHOSPHOSULFATE REDUCTASE', 249336),
(392758, 'PTHR46509:SF2', NULL, NULL, NULL, NULL, 'PHOSPHOADENOSINE PHOSPHOSULFATE REDUCTASE', 249336),
(392759, 'PTHR36835', NULL, NULL, NULL, NULL, 'CYTOCHROME BO(3) UBIQUINOL OXIDASE SUBUNIT 4', 249337),
(392760, 'PTHR36835:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME BO(3) UBIQUINOL OXIDASE SUBUNIT 4', 249337),
(392761, 'PTHR12825', NULL, NULL, NULL, NULL, 'BNIP1-RELATED', 249338),
(392762, 'PTHR12825:SF0', NULL, NULL, NULL, NULL, 'VESICLE TRANSPORT PROTEIN SEC20', 249338),
(392763, 'PTHR12825:SF1', NULL, NULL, NULL, NULL, 'SEC20 FAMILY PROTEIN', 249338);
INSERT INTO "PUBLIC"."MODEL" VALUES
(392764, 'PTHR31043:SF3', NULL, NULL, NULL, NULL, 'NEPHROCYSTIN-4', 249339),
(392765, 'PTHR31043', NULL, NULL, NULL, NULL, 'NEPHROCYSTIN-4', 249339),
(392766, 'PTHR46396:SF1', NULL, NULL, NULL, NULL, 'PROTEIN O-LINKED-MANNOSE BETA-1,2-N-ACETYLGLUCOSAMINYLTRANSFERASE 1', 249340),
(392767, 'PTHR46396', NULL, NULL, NULL, NULL, 'PROTEIN O-LINKED-MANNOSE BETA-1,2-N-ACETYLGLUCOSAMINYLTRANSFERASE 1', 249340),
(392768, 'PTHR36345:SF1', NULL, NULL, NULL, NULL, 'CCG-BINDING PROTEIN 1', 249341),
(392769, 'PTHR36345', NULL, NULL, NULL, NULL, 'CCG-BINDING PROTEIN 1', 249341),
(392770, 'PTHR44419:SF7', NULL, NULL, NULL, NULL, 'PROTOCHLOROPHYLLIDE REDUCTASE B, CHLOROPLASTIC', 249342),
(392771, 'PTHR44419:SF12', NULL, NULL, NULL, NULL, 'NADPH-PROTOCHLOROPHYLLIDE OXIDOREDUCTASE', 249342),
(392772, 'PTHR44419:SF15', NULL, NULL, NULL, NULL, 'PROTOCHLOROPHYLLIDE REDUCTASE C, CHLOROPLASTIC', 249342),
(392773, 'PTHR44419:SF17', NULL, NULL, NULL, NULL, 'NADPH-PROTOCHLOROPHYLLIDE OXIDOREDUCTASE', 249342),
(392774, 'PTHR44419:SF16', NULL, NULL, NULL, NULL, 'NADPH-PROTOCHLOROPHYLLIDE OXIDOREDUCTASE', 249342),
(392775, 'PTHR44419:SF19', NULL, NULL, NULL, NULL, 'PROTOCHLOROPHYLLIDE REDUCTASE A, CHLOROPLASTIC', 249342),
(392776, 'PTHR44419', NULL, NULL, NULL, NULL, 'PROTOCHLOROPHYLLIDE REDUCTASE C, CHLOROPLASTIC', 249342),
(392777, 'PTHR44419:SF18', NULL, NULL, NULL, NULL, 'NADPH-PROTOCHLOROPHYLLIDE OXIDOREDUCTASE', 249342),
(392778, 'PTHR44419:SF11', NULL, NULL, NULL, NULL, 'NADPH-PROTOCHLOROPHYLLIDE OXIDOREDUCTASE', 249342),
(392779, 'PTHR44419:SF6', NULL, NULL, NULL, NULL, 'PROTOCHLOROPHYLLIDE REDUCTASE A, CHLOROPLASTIC', 249342),
(392780, 'PTHR16469:SF48', NULL, NULL, NULL, NULL, 'BNAC06G42780D PROTEIN', 249343),
(392781, 'PTHR16469:SF26', NULL, NULL, NULL, NULL, 'PROTEIN CBG23268', 249343),
(392782, 'PTHR16469:SF27', NULL, NULL, NULL, NULL, 'UBIQUITIN-ASSOCIATED AND SH3 DOMAIN-CONTAINING BA-RELATED', 249343),
(392783, 'PTHR16469:SF49', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE FAMILY PROTEIN', 249343),
(392784, 'PTHR16469:SF43', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE FAMILY PROTEIN', 249343),
(392785, 'PTHR16469:SF44', NULL, NULL, NULL, NULL, '', 249343),
(392786, 'PTHR16469:SF45', NULL, NULL, NULL, NULL, 'BNAA04G27420D PROTEIN', 249343),
(392787, 'PTHR16469:SF23', NULL, NULL, NULL, NULL, 'PROTEIN CBG23349', 249343),
(392788, 'PTHR16469:SF46', NULL, NULL, NULL, NULL, 'BNAC04G55150D PROTEIN', 249343),
(392789, 'PTHR16469:SF51', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TAU 55 KDA SUBUNIT', 249343),
(392790, 'PTHR16469:SF42', NULL, NULL, NULL, NULL, 'BNAA04G27410D PROTEIN', 249343),
(392791, 'PTHR16469:SF7', NULL, NULL, NULL, NULL, 'UBIQUITIN-ASSOCIATED AND SH3 DOMAIN-CONTAINING PROTEIN A', 249343),
(392792, 'PTHR16469:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG20630', 249343),
(392793, 'PTHR16469', NULL, NULL, NULL, NULL, 'UBIQUITIN-ASSOCIATED AND SH3 DOMAIN-CONTAINING BA-RELATED', 249343),
(392794, 'PTHR16469:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG12398', 249343),
(392795, 'PTHR16469:SF29', NULL, NULL, NULL, NULL, 'UBIQUITIN-ASSOCIATED AND SH3 DOMAIN-CONTAINING PROTEIN B', 249343),
(392796, 'PTHR10621:SF60', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 249344),
(392797, 'PTHR10621:SF33', NULL, NULL, NULL, NULL, 'OS09G0481650 PROTEIN', 249344),
(392798, 'PTHR10621:SF56', NULL, NULL, NULL, NULL, 'UBIQUITIN RECEPTOR RAD23', 249344),
(392799, 'PTHR10621:SF13', NULL, NULL, NULL, NULL, 'UV EXCISION REPAIR PROTEIN RAD23 HOMOLOG B', 249344),
(392800, 'PTHR10621:SF35', NULL, NULL, NULL, NULL, 'UBIQUITIN RECEPTOR RAD23C', 249344),
(392801, 'PTHR10621', NULL, NULL, NULL, NULL, 'UV EXCISION REPAIR PROTEIN RAD23', 249344),
(392802, 'PTHR10621:SF51', NULL, NULL, NULL, NULL, 'UBIQUITIN RECEPTOR RAD23', 249344),
(392803, 'PTHR10621:SF59', NULL, NULL, NULL, NULL, 'UBIQUITIN RECEPTOR RAD23-RELATED', 249344),
(392804, 'PTHR10621:SF38', NULL, NULL, NULL, NULL, 'UBIQUITIN DOMAIN-CONTAINING PROTEIN 7SL RNA1-RELATED', 249344),
(392805, 'PTHR10621:SF39', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE SUPERFAMILY PROTEIN', 249344);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(392806, 'PTHR10621:SF7', NULL, NULL, NULL, NULL, 'UBIQUITIN RECEPTOR RAD23', 249344),
(392807, 'PTHR10621:SF43', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 249344),
(392808, 'PTHR10621:SF44', NULL, NULL, NULL, NULL, 'BNAC09G00330D PROTEIN', 249344),
(392809, 'PTHR10621:SF46', NULL, NULL, NULL, NULL, 'UBIQUITIN RECEPTOR RAD23', 249344),
(392810, 'PTHR10621:SF61', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 249344),
(392811, 'PTHR10621:SF62', NULL, NULL, NULL, NULL, 'UBIQUITIN RECEPTOR RAD23', 249344),
(392812, 'PTHR10621:SF63', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 249344),
(392813, 'PTHR10621:SF41', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 249344),
(392814, 'PTHR10621:SF64', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 249344),
(392815, 'PTHR10621:SF42', NULL, NULL, NULL, NULL, 'UBIQUITIN RECEPTOR RAD23', 249344),
(392816, 'PTHR10621:SF4', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 249344),
(392817, 'PTHR10621:SF29', NULL, NULL, NULL, NULL, 'UV EXCISION REPAIR PROTEIN RAD23 HOMOLOG A', 249344),
(392818, 'PTHR10621:SF47', NULL, NULL, NULL, NULL, 'BNAC09G41740D PROTEIN', 249344),
(392819, 'PTHR10621:SF0', NULL, NULL, NULL, NULL, 'UV EXCISION REPAIR PROTEIN RAD23', 249344),
(392820, 'PTHR10621:SF48', NULL, NULL, NULL, NULL, 'UBIQUITIN RECEPTOR RAD23', 249344),
(392821, 'PTHR10621:SF49', NULL, NULL, NULL, NULL, 'UBIQUITIN RECEPTOR RAD23D', 249344),
(392822, 'PTHR10621:SF27', NULL, NULL, NULL, NULL, 'UV EXCISION REPAIR PROTEIN RAD23', 249344),
(392823, 'PTHR10621:SF28', NULL, NULL, NULL, NULL, 'UV EXCISION REPAIR PROTEIN RAD23', 249344),
(392824, 'PTHR28298:SF1', NULL, NULL, NULL, NULL, 'EISOSOME PROTEIN 1', 249345),
(392825, 'PTHR28298', NULL, NULL, NULL, NULL, 'EISOSOME PROTEIN 1', 249345),
(392826, 'PTHR12828:SF7', NULL, NULL, NULL, NULL, '', 249346),
(392827, 'PTHR12828', NULL, NULL, NULL, NULL, 'PROTEASOME MATURATION PROTEIN  UMP1', 249346),
(392828, 'PTHR12828:SF9', NULL, NULL, NULL, NULL, 'BNAA02G13000D PROTEIN', 249346),
(392829, 'PTHR12828:SF3', NULL, NULL, NULL, NULL, 'PROTEASOME MATURATION PROTEIN', 249346),
(392830, 'PTHR12828:SF4', NULL, NULL, NULL, NULL, 'PROTEASOME MATURATION FACTOR UMP1', 249346),
(392831, 'PTHR47482:SF19', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249347),
(392832, 'PTHR47482:SF20', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249347),
(392833, 'PTHR47482:SF21', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249347),
(392834, 'PTHR47482', NULL, NULL, NULL, NULL, 'OS11G0632001 PROTEIN', 249347),
(392835, 'PTHR47482:SF22', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249347),
(392836, 'PTHR47482:SF13', NULL, NULL, NULL, NULL, 'FAR1 DOMAIN-CONTAINING PROTEIN', 249347),
(392837, 'PTHR47482:SF14', NULL, NULL, NULL, NULL, 'OS11G0632001 PROTEIN', 249347),
(392838, 'PTHR47482:SF15', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249347),
(392839, 'PTHR47482:SF16', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249347),
(392840, 'PTHR47482:SF5', NULL, NULL, NULL, NULL, 'FAR1 DOMAIN-CONTAINING PROTEIN', 249347),
(392841, 'PTHR47482:SF17', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249347),
(392842, 'PTHR47482:SF18', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249347),
(392843, 'PTHR44845:SF7', NULL, NULL, NULL, NULL, 'PLIPASTATIN SYNTHASE SUBUNIT D', 249348),
(392844, 'PTHR44845:SF6', NULL, NULL, NULL, NULL, 'BETA-ALANINE-ACTIVATING ENZYME', 249348),
(392845, 'PTHR44845', NULL, NULL, NULL, NULL, 'CARRIER DOMAIN-CONTAINING PROTEIN', 249348),
(392846, 'PTHR44845:SF4', NULL, NULL, NULL, NULL, 'NONRIBOSOMAL PEPTIDE SYNTHASE INPA', 249348),
(392847, 'PTHR44845:SF1', NULL, NULL, NULL, NULL, 'L-2-AMINOADIPATE REDUCTASE', 249348),
(392848, 'PTHR46091', NULL, NULL, NULL, NULL, 'BLR7054 PROTEIN', 249349),
(392849, 'PTHR46091:SF1', NULL, NULL, NULL, NULL, 'ALL-TRANS-RETINOL 13,14-REDUCTASE', 249349),
(392850, 'PTHR46091:SF2', NULL, NULL, NULL, NULL, 'INACTIVE ALL-TRANS-RETINOL 13,14-REDUCTASE-RELATED', 249349);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(392851, 'PTHR46091:SF3', NULL, NULL, NULL, NULL, 'BLR7054 PROTEIN', 249349),
(392852, 'PTHR47317', NULL, NULL, NULL, NULL, 'PROTEIN LHCP TRANSLOCATION DEFECT', 249350),
(392853, 'PTHR47317:SF2', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 249350),
(392854, 'PTHR47317:SF1', NULL, NULL, NULL, NULL, 'PROTEIN LHCP TRANSLOCATION DEFECT', 249350),
(392855, 'PTHR47317:SF3', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 249350),
(392856, 'PTHR31890:SF14', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR SUPERFAMILY PROTEIN', 249351),
(392857, 'PTHR31890:SF13', NULL, NULL, NULL, NULL, 'BNM1 LIKE PROTEIN', 249351),
(392858, 'PTHR31890:SF24', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR PROTEIN', 249351),
(392859, 'PTHR31890:SF16', NULL, NULL, NULL, NULL, 'BNACNNG40360D PROTEIN', 249351),
(392860, 'PTHR31890:SF15', NULL, NULL, NULL, NULL, 'P18 PROTEIN', 249351),
(392861, 'PTHR31890:SF21', NULL, NULL, NULL, NULL, 'P18 PROTEIN', 249351),
(392862, 'PTHR31890:SF10', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 249351),
(392863, 'PTHR31890:SF20', NULL, NULL, NULL, NULL, 'BNAA02G14590D PROTEIN', 249351),
(392864, 'PTHR31890:SF23', NULL, NULL, NULL, NULL, 'BNAA06G40340D PROTEIN', 249351),
(392865, 'PTHR31890:SF12', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249351),
(392866, 'PTHR31890:SF11', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 249351),
(392867, 'PTHR31890:SF22', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 249351),
(392868, 'PTHR31890:SF18', NULL, NULL, NULL, NULL, 'P18 PROTEIN', 249351),
(392869, 'PTHR31890:SF17', NULL, NULL, NULL, NULL, 'BNAC03G27610D PROTEIN', 249351),
(392870, 'PTHR31890:SF19', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 249351),
(392871, 'PTHR31890', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR SUPERFAMILY PROTEIN', 249351),
(392872, 'PTHR31890:SF9', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR SUPERFAMILY PROTEIN', 249351),
(392873, 'PTHR34154:SF11', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_CC DOMAIN-CONTAINING PROTEIN', 249352),
(392874, 'PTHR34154:SF3', NULL, NULL, NULL, NULL, 'ALKALI-SENSITIVE LINKAGE PROTEIN 1', 249352),
(392875, 'PTHR34154:SF12', NULL, NULL, NULL, NULL, 'CHROMOSOME 16, WHOLE GENOME SHOTGUN SEQUENCE', 249352),
(392876, 'PTHR34154', NULL, NULL, NULL, NULL, 'ALKALI-SENSITIVE LINKAGE PROTEIN 1', 249352),
(392877, 'PTHR34154:SF10', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_CC DOMAIN-CONTAINING PROTEIN', 249352),
(392878, 'PTHR47049:SF2', NULL, NULL, NULL, NULL, 'PIEZO-TYPE MECHANOSENSITIVE ION CHANNEL HOMOLOG', 249353),
(392879, 'PTHR47049:SF4', NULL, NULL, NULL, NULL, 'PIEZO-TYPE MECHANOSENSITIVE ION CHANNEL COMPONENT', 249353),
(392880, 'PTHR47049:SF3', NULL, NULL, NULL, NULL, 'PIEZO-TYPE MECHANOSENSITIVE ION CHANNEL COMPONENT', 249353),
(392881, 'PTHR47049', NULL, NULL, NULL, NULL, 'PIEZO-TYPE MECHANOSENSITIVE ION CHANNEL HOMOLOG', 249353),
(392882, 'PTHR40695:SF1', NULL, NULL, NULL, NULL, '4-PHOSPHOPANTOATE--BETA-ALANINE LIGASE', 249354),
(392883, 'PTHR40695', NULL, NULL, NULL, NULL, '4-PHOSPHOPANTOATE--BETA-ALANINE LIGASE', 249354),
(392884, 'PTHR46317', NULL, NULL, NULL, NULL, 'HYDROLASE OF PHP SUPERFAMILY-RELATED PROTEIN', 249355),
(392885, 'PTHR46317:SF1', NULL, NULL, NULL, NULL, 'HYDROLASE OF PHP SUPERFAMILY-RELATED PROTEIN', 249355),
(392886, 'PTHR46317:SF3', NULL, NULL, NULL, NULL, 'DEOXYRIBONUCLEASE TATDN3-RELATED', 249355),
(392887, 'PTHR46317:SF5', NULL, NULL, NULL, NULL, 'NADH UBIQUINONE OXIDOREDUCTASE FE-S PROTEIN', 249355),
(392888, 'PTHR46317:SF7', NULL, NULL, NULL, NULL, 'DEOXYRIBONUCLEASE TATDN3-RELATED', 249355),
(392889, 'PTHR28596', NULL, NULL, NULL, NULL, 'BBSOME-INTERACTING PROTEIN 1', 249356),
(392890, 'PTHR28596:SF1', NULL, NULL, NULL, NULL, 'BBSOME-INTERACTING PROTEIN 1', 249356),
(392891, 'PTHR35077:SF2', NULL, NULL, NULL, NULL, 'SIMILAR TO AI661453 PROTEIN', 249357),
(392892, 'PTHR35077', NULL, NULL, NULL, NULL, 'SIMILAR TO AI661453 PROTEIN', 249357);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(392893, 'PTHR35257:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 82', 249358),
(392894, 'PTHR35257', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 82', 249358),
(392895, 'PTHR43300:SF4', NULL, NULL, NULL, NULL, 'ACYL-[ACYL-CARRIER-PROTEIN]--UDP-N-ACETYLGLUCOSAMINE O-ACYLTRANSFERASE', 249359),
(392896, 'PTHR43300:SF6', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE YVOF-RELATED', 249359),
(392897, 'PTHR43300:SF7', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLBACILLOSAMINE N-ACETYLTRANSFERASE', 249359),
(392898, 'PTHR43300', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE', 249359),
(392899, 'PTHR43300:SF11', NULL, NULL, NULL, NULL, 'CHLORAMPHENICOL ACETYLTRANSFERASE', 249359),
(392900, 'PTHR43300:SF9', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE', 249359),
(392901, 'PTHR43300:SF10', NULL, NULL, NULL, NULL, '2,3,4,5-TETRAHYDROPYRIDINE-2,6-DICARBOXYLATE N-ACETYLTRANSFERASE', 249359),
(392902, 'PTHR20875', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING DOMAIN-CONTAINING PROTEIN 6-RELATED', 249360),
(392903, 'PTHR20875:SF0', NULL, NULL, NULL, NULL, 'GH12158P', 249360),
(392904, 'PTHR20875:SF2', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING DOMAIN-CONTAINING PROTEIN 6', 249360),
(392905, 'PTHR20875:SF5', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING DOMAIN-CONTAINING PROTEIN 6-LIKE', 249360),
(392906, 'PTHR31669:SF145', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392907, 'PTHR31669:SF265', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392908, 'PTHR31669:SF220', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392909, 'PTHR31669:SF149', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE 12-RELATED', 249361),
(392910, 'PTHR31669:SF269', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392911, 'PTHR31669:SF225', NULL, NULL, NULL, NULL, 'OS03G0655600 PROTEIN', 249361),
(392912, 'PTHR31669:SF268', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392913, 'PTHR31669:SF228', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE 8', 249361),
(392914, 'PTHR31669:SF88', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392915, 'PTHR31669:SF10', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE 6', 249361),
(392916, 'PTHR31669:SF180', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392917, 'PTHR31669:SF263', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392918, 'PTHR31669:SF185', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392919, 'PTHR31669:SF261', NULL, NULL, NULL, NULL, 'FAR1 FAMILY PROTEIN, EXPRESSED', 249361),
(392920, 'PTHR31669:SF184', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE 11', 249361),
(392921, 'PTHR31669:SF157', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392922, 'PTHR31669:SF278', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392923, 'PTHR31669:SF277', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392924, 'PTHR31669:SF276', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392925, 'PTHR31669:SF275', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392926, 'PTHR31669:SF238', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392927, 'PTHR31669:SF237', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392928, 'PTHR31669:SF236', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392929, 'PTHR31669:SF279', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392930, 'PTHR31669:SF37', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392931, 'PTHR31669:SF42', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE 4', 249361),
(392932, 'PTHR31669:SF270', NULL, NULL, NULL, NULL, 'MUTATOR-LIKE TRANSPOSASE', 249361),
(392933, 'PTHR31669:SF274', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392934, 'PTHR31669:SF273', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392935, 'PTHR31669:SF272', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(392936, 'PTHR31669:SF271', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392937, 'PTHR31669:SF289', NULL, NULL, NULL, NULL, 'OS09G0268600 PROTEIN', 249361),
(392938, 'PTHR31669:SF168', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392939, 'PTHR31669:SF167', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392940, 'PTHR31669:SF288', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392941, 'PTHR31669:SF244', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392942, 'PTHR31669:SF287', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392943, 'PTHR31669:SF286', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392944, 'PTHR31669:SF248', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392945, 'PTHR31669:SF247', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392946, 'PTHR31669:SF23', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392947, 'PTHR31669:SF206', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392948, 'PTHR31669', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE 10-RELATED', 249361),
(392949, 'PTHR31669:SF281', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392950, 'PTHR31669:SF160', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392951, 'PTHR31669:SF280', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE 2', 249361),
(392952, 'PTHR31669:SF285', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392953, 'PTHR31669:SF240', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE 9', 249361),
(392954, 'PTHR31669:SF284', NULL, NULL, NULL, NULL, 'SWIM-TYPE DOMAIN-CONTAINING PROTEIN', 249361),
(392955, 'PTHR31669:SF162', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE 5', 249361),
(392956, 'PTHR31669:SF283', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392957, 'PTHR31669:SF161', NULL, NULL, NULL, NULL, 'PROTEIN FAR-RED ELONGATED HYPOCOTYL 3', 249361),
(392958, 'PTHR31669:SF282', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392959, 'PTHR31669:SF179', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE 5', 249361),
(392960, 'PTHR31669:SF256', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392961, 'PTHR31669:SF211', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392962, 'PTHR31669:SF258', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392963, 'PTHR31669:SF214', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392964, 'PTHR31669:SF218', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE 3', 249361),
(392965, 'PTHR31669:SF217', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392966, 'PTHR31669:SF21', NULL, NULL, NULL, NULL, 'PROTEIN FAR-RED IMPAIRED RESPONSE 1', 249361),
(392967, 'PTHR31669:SF62', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE 1', 249361),
(392968, 'PTHR31669:SF292', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392969, 'PTHR31669:SF291', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392970, 'PTHR31669:SF290', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392971, 'PTHR31669:SF251', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392972, 'PTHR31669:SF174', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE 10-RELATED', 249361),
(392973, 'PTHR31669:SF294', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE', 249361),
(392974, 'PTHR31669:SF293', NULL, NULL, NULL, NULL, 'FAR1 DNA-BINDING DOMAIN PROTEIN', 249361),
(392975, 'PTHR37389:SF15', NULL, NULL, NULL, NULL, 'GLYCINE-RICH RNA-BINDING PROTEIN 2-LIKE ISOFORM X1', 249362),
(392976, 'PTHR37389:SF37', NULL, NULL, NULL, NULL, 'GLYCINE RICH PROTEIN-RELATED', 249362),
(392977, 'PTHR37389:SF26', NULL, NULL, NULL, NULL, 'BNAC03G74330D PROTEIN', 249362),
(392978, 'PTHR37389:SF36', NULL, NULL, NULL, NULL, '', 249362),
(392979, 'PTHR37389:SF13', NULL, NULL, NULL, NULL, 'PRISILKIN-39-LIKE ISOFORM X1', 249362);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(392980, 'PTHR37389:SF35', NULL, NULL, NULL, NULL, 'PLUS AGGLUTININ', 249362),
(392981, 'PTHR37389:SF34', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN', 249362),
(392982, 'PTHR37389:SF11', NULL, NULL, NULL, NULL, 'GLYCINE-RICH RNA-BINDING PROTEIN 10-LIKE', 249362),
(392983, 'PTHR37389:SF33', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN-LIKE', 249362),
(392984, 'PTHR37389:SF32', NULL, NULL, NULL, NULL, 'BNACNNG10710D PROTEIN', 249362),
(392985, 'PTHR37389:SF31', NULL, NULL, NULL, NULL, 'GLYCINE-RICH CELL WALL STRUCTURAL PROTEIN', 249362),
(392986, 'PTHR37389:SF6', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN M17', 249362),
(392987, 'PTHR37389:SF9', NULL, NULL, NULL, NULL, 'NODULIN-24', 249362),
(392988, 'PTHR37389', NULL, NULL, NULL, NULL, 'NODULIN-24', 249362),
(392989, 'PTHR37389:SF19', NULL, NULL, NULL, NULL, 'BNAA04G17930D PROTEIN', 249362),
(392990, 'PTHR37389:SF28', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN', 249362),
(392991, 'PTHR37389:SF39', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN', 249362),
(392992, 'PTHR37389:SF17', NULL, NULL, NULL, NULL, 'BNAC04G01780D PROTEIN', 249362),
(392993, 'PTHR37389:SF38', NULL, NULL, NULL, NULL, 'OS02G0587800 PROTEIN', 249362),
(392994, 'PTHR37389:SF16', NULL, NULL, NULL, NULL, 'COLD AND DROUGHT-REGULATED PROTEIN CORA-LIKE', 249362),
(392995, 'PTHR37389:SF27', NULL, NULL, NULL, NULL, 'BNAA09G54870D PROTEIN', 249362),
(392996, 'PTHR46192:SF14', NULL, NULL, NULL, NULL, 'BNAA05G31980D PROTEIN', 249363),
(392997, 'PTHR46192:SF12', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE/BISPHOSPHOGLYCERATE MUTASE FAMILY PROTEIN', 249363),
(392998, 'PTHR46192:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE-RELATED', 249363),
(392999, 'PTHR46192', NULL, NULL, NULL, NULL, 'BROAD-RANGE ACID PHOSPHATASE DET1', 249363),
(393000, 'PTHR46192:SF2', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE-LIKE PROTEIN AT74', 249363),
(393001, 'PTHR46192:SF10', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE-LIKE PROTEIN AT74H', 249363),
(393002, 'PTHR46192:SF11', NULL, NULL, NULL, NULL, 'BROAD-RANGE ACID PHOSPHATASE DET1', 249363),
(393003, 'PTHR46192:SF7', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE-LIKE PROTEIN AT74', 249363),
(393004, 'PTHR46192:SF8', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE-LIKE PROTEIN AT74', 249363),
(393005, 'PTHR46192:SF9', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE-LIKE PROTEIN AT74H', 249363),
(393006, 'PTHR46192:SF16', NULL, NULL, NULL, NULL, '', 249363),
(393007, 'PTHR46192:SF17', NULL, NULL, NULL, NULL, 'HISTIDINE PHOSPHATASE SUPERFAMILY-RELATED', 249363),
(393008, 'PTHR45161', NULL, NULL, NULL, NULL, 'CYTOSKELETON-ASSOCIATED PROTEIN 4', 249364),
(393009, 'PTHR45161:SF2', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE RAS GEF', 249364),
(393010, 'PTHR45161:SF3', NULL, NULL, NULL, NULL, 'METHYL-ACCEPTING CHEMOTAXIS PROTEIN', 249364),
(393011, 'PTHR45161:SF1', NULL, NULL, NULL, NULL, 'CYTOSKELETON-ASSOCIATED PROTEIN 4', 249364),
(393012, 'PTHR10809:SF51', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN', 249365),
(393013, 'PTHR10809', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE PROTEIN-ASSOCIATED PROTEIN', 249365),
(393014, 'PTHR10809:SF12', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE PROTEIN-ASSOCIATED PROTEIN B/C', 249365),
(393015, 'PTHR10809:SF58', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED PROTEIN 4-2', 249365),
(393016, 'PTHR10809:SF150', NULL, NULL, NULL, NULL, 'OS08G0155100 PROTEIN', 249365),
(393017, 'PTHR10809:SF153', NULL, NULL, NULL, NULL, 'MSP DOMAIN-CONTAINING PROTEIN', 249365),
(393018, 'PTHR10809:SF154', NULL, NULL, NULL, NULL, 'OS08G0156700 PROTEIN', 249365),
(393019, 'PTHR10809:SF132', NULL, NULL, NULL, NULL, 'MSP DOMAIN-CONTAINING PROTEIN', 249365),
(393020, 'PTHR10809:SF110', NULL, NULL, NULL, NULL, 'MSP DOMAIN-CONTAINING PROTEIN', 249365),
(393021, 'PTHR10809:SF151', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE-PROTEIN-ASSOCIATED PROTEIN-RELATED', 249365),
(393022, 'PTHR10809:SF152', NULL, NULL, NULL, NULL, 'MSP DOMAIN-CONTAINING PROTEIN', 249365);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(393023, 'PTHR10809:SF6', NULL, NULL, NULL, NULL, 'AT11025P-RELATED', 249365),
(393024, 'PTHR10809:SF157', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED PROTEIN 2-2-LIKE', 249365),
(393025, 'PTHR10809:SF113', NULL, NULL, NULL, NULL, 'OS07G0558800 PROTEIN', 249365),
(393026, 'PTHR10809:SF136', NULL, NULL, NULL, NULL, 'MSP DOMAIN CONTAINING PROTEIN, EXPRESSED', 249365),
(393027, 'PTHR10809:SF114', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED PROTEIN 4-1-LIKE', 249365),
(393028, 'PTHR10809:SF158', NULL, NULL, NULL, NULL, 'OS05G0373000 PROTEIN', 249365),
(393029, 'PTHR10809:SF133', NULL, NULL, NULL, NULL, 'MSP DOMAIN-CONTAINING PROTEIN', 249365),
(393030, 'PTHR10809:SF155', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE PROTEIN-ASSOCIATED PROTEIN A', 249365),
(393031, 'PTHR10809:SF134', NULL, NULL, NULL, NULL, 'MSP DOMAIN-CONTAINING PROTEIN', 249365),
(393032, 'PTHR10809:SF156', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE-PROTEIN-ASSOCIATED PROTEIN-RELATED', 249365),
(393033, 'PTHR10809:SF112', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED PROTEIN 1-1-LIKE', 249365),
(393034, 'PTHR10809:SF117', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED PROTEIN 1-1-RELATED', 249365),
(393035, 'PTHR10809:SF118', NULL, NULL, NULL, NULL, 'MSP DOMAIN-CONTAINING PROTEIN', 249365),
(393036, 'PTHR10809:SF116', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED PROTEIN 4-3', 249365),
(393037, 'PTHR10809:SF119', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED PROTEIN 1-2-RELATED', 249365),
(393038, 'PTHR10809:SF42', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED PROTEIN 2-1', 249365),
(393039, 'PTHR10809:SF67', NULL, NULL, NULL, NULL, 'PROTEIN CBG20367', 249365),
(393040, 'PTHR10809:SF45', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED PROTEIN 2-2', 249365),
(393041, 'PTHR10809:SF142', NULL, NULL, NULL, NULL, 'MSP DOMAIN-CONTAINING PROTEIN', 249365),
(393042, 'PTHR10809:SF121', NULL, NULL, NULL, NULL, 'MSP DOMAIN-CONTAINING PROTEIN', 249365),
(393043, 'PTHR10809:SF143', NULL, NULL, NULL, NULL, 'MSP DOMAIN-CONTAINING PROTEIN', 249365),
(393044, 'PTHR10809:SF141', NULL, NULL, NULL, NULL, 'OS04G0534400 PROTEIN', 249365),
(393045, 'PTHR10809:SF146', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', 249365),
(393046, 'PTHR10809:SF102', NULL, NULL, NULL, NULL, 'MSP DOMAIN-CONTAINING PROTEIN', 249365),
(393047, 'PTHR10809:SF124', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED PROTEIN 2-1-LIKE', 249365),
(393048, 'PTHR10809:SF125', NULL, NULL, NULL, NULL, 'MSP DOMAIN-CONTAINING PROTEIN', 249365),
(393049, 'PTHR10809:SF103', NULL, NULL, NULL, NULL, 'OS02G0643000 PROTEIN', 249365),
(393050, 'PTHR10809:SF144', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', 249365),
(393051, 'PTHR10809:SF100', NULL, NULL, NULL, NULL, 'MSP DOMAIN-CONTAINING PROTEIN', 249365),
(393052, 'PTHR10809:SF122', NULL, NULL, NULL, NULL, 'MSP DOMAIN-CONTAINING PROTEIN', 249365),
(393053, 'PTHR10809:SF145', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', 249365),
(393054, 'PTHR10809:SF101', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED PROTEIN 4-1', 249365),
(393055, 'PTHR10809:SF129', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN (MSP) DOMAIN, VESICLE-ASSOCIATED MEMBRANE-PROTEIN-ASSOCIATED PROTEIN-RELATED', 249365),
(393056, 'PTHR10809:SF148', NULL, NULL, NULL, NULL, 'OS01G0936800 PROTEIN', 249365),
(393057, 'PTHR48130:SF1', NULL, NULL, NULL, NULL, 'OS12G0467600 PROTEIN', 249366),
(393058, 'PTHR48130', NULL, NULL, NULL, NULL, 'OS12G0467600 PROTEIN', 249366),
(393059, 'PTHR10811:SF92', NULL, NULL, NULL, NULL, '', 249367),
(393060, 'PTHR10811:SF91', NULL, NULL, NULL, NULL, 'BNAC09G24010D PROTEIN', 249367),
(393061, 'PTHR10811:SF94', NULL, NULL, NULL, NULL, 'FRINGE', 249367),
(393062, 'PTHR10811:SF96', NULL, NULL, NULL, NULL, 'BNAA05G27650D PROTEIN', 249367),
(393063, 'PTHR10811:SF95', NULL, NULL, NULL, NULL, 'BNAA10G29920D PROTEIN', 249367),
(393064, 'PTHR10811:SF87', NULL, NULL, NULL, NULL, 'BNAANNG16280D PROTEIN', 249367),
(393065, 'PTHR10811:SF123', NULL, NULL, NULL, NULL, '', 249367),
(393066, 'PTHR10811:SF80', NULL, NULL, NULL, NULL, '', 249367),
(393067, 'PTHR10811:SF83', NULL, NULL, NULL, NULL, 'BNAA10G03350D PROTEIN', 249367);
INSERT INTO "PUBLIC"."MODEL" VALUES
(393068, 'PTHR10811:SF82', NULL, NULL, NULL, NULL, 'BNAC07G50040D PROTEIN', 249367),
(393069, 'PTHR10811:SF85', NULL, NULL, NULL, NULL, 'BNACNNG24830D PROTEIN', 249367),
(393070, 'PTHR10811:SF78', NULL, NULL, NULL, NULL, 'TRANSFERASE, TRANSFERRING GLYCOSYL GROUPS', 249367),
(393071, 'PTHR10811:SF77', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE, EXPRESSED-RELATED', 249367),
(393072, 'PTHR10811:SF79', NULL, NULL, NULL, NULL, 'BNAA10G29940D PROTEIN', 249367),
(393073, 'PTHR10811', NULL, NULL, NULL, NULL, 'FRINGE-RELATED', 249367),
(393074, 'PTHR10811:SF121', NULL, NULL, NULL, NULL, '', 249367),
(393075, 'PTHR10811:SF122', NULL, NULL, NULL, NULL, 'TRANSFERRING GLYCOSYL GROUP TRANSFERASE', 249367),
(393076, 'PTHR10811:SF120', NULL, NULL, NULL, NULL, 'BNAA10G29930D PROTEIN', 249367),
(393077, 'PTHR10811:SF114', NULL, NULL, NULL, NULL, 'TRANSFERASE, TRANSFERRING GLYCOSYL GROUPS', 249367),
(393078, 'PTHR10811:SF115', NULL, NULL, NULL, NULL, '', 249367),
(393079, 'PTHR10811:SF112', NULL, NULL, NULL, NULL, '', 249367),
(393080, 'PTHR10811:SF113', NULL, NULL, NULL, NULL, 'TRANSFERRING GLYCOSYL GROUP TRANSFERASE', 249367),
(393081, 'PTHR10811:SF118', NULL, NULL, NULL, NULL, 'BETA-1,3-GLUCOSYLTRANSFERASE-LIKE PROTEIN', 249367),
(393082, 'PTHR10811:SF119', NULL, NULL, NULL, NULL, 'BNAA08G28250D PROTEIN', 249367),
(393083, 'PTHR10811:SF116', NULL, NULL, NULL, NULL, 'TRANSFERRING GLYCOSYL GROUP TRANSFERASE', 249367),
(393084, 'PTHR10811:SF117', NULL, NULL, NULL, NULL, 'BNAA03G58710D PROTEIN', 249367),
(393085, 'PTHR10811:SF72', NULL, NULL, NULL, NULL, '', 249367),
(393086, 'PTHR10811:SF71', NULL, NULL, NULL, NULL, 'TRANSFERASE, TRANSFERRING GLYCOSYL GROUPS', 249367),
(393087, 'PTHR10811:SF74', NULL, NULL, NULL, NULL, 'BNAANNG13620D PROTEIN', 249367),
(393088, 'PTHR10811:SF73', NULL, NULL, NULL, NULL, 'FRINGE', 249367),
(393089, 'PTHR10811:SF65', NULL, NULL, NULL, NULL, 'FRINGE', 249367),
(393090, 'PTHR10811:SF66', NULL, NULL, NULL, NULL, 'TRANSFERRING GLYCOSYL GROUP TRANSFERASE', 249367),
(393091, 'PTHR10811:SF25', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249367),
(393092, 'PTHR10811:SF27', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249367),
(393093, 'PTHR10811:SF26', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE, EXPRESSED-RELATED', 249367),
(393094, 'PTHR10811:SF110', NULL, NULL, NULL, NULL, 'BETA-1,3-GLUCOSYLTRANSFERASE', 249367),
(393095, 'PTHR10811:SF111', NULL, NULL, NULL, NULL, 'TRANSFERRING GLYCOSYL GROUP TRANSFERASE', 249367),
(393096, 'PTHR10811:SF1', NULL, NULL, NULL, NULL, 'BETA-1,3-N-ACETYLGLUCOSAMINYLTRANSFERASE RADICAL FRINGE', 249367),
(393097, 'PTHR10811:SF104', NULL, NULL, NULL, NULL, '', 249367),
(393098, 'PTHR10811:SF101', NULL, NULL, NULL, NULL, 'BNAA10G29950D PROTEIN', 249367),
(393099, 'PTHR10811:SF102', NULL, NULL, NULL, NULL, '', 249367),
(393100, 'PTHR10811:SF108', NULL, NULL, NULL, NULL, '', 249367),
(393101, 'PTHR10811:SF106', NULL, NULL, NULL, NULL, 'FRINGE', 249367),
(393102, 'PTHR10811:SF109', NULL, NULL, NULL, NULL, 'TRANSFERASE, TRANSFERRING GLYCOSYL GROUPS', 249367),
(393103, 'PTHR10811:SF60', NULL, NULL, NULL, NULL, 'BNAC06G42370D PROTEIN', 249367),
(393104, 'PTHR10811:SF98', NULL, NULL, NULL, NULL, '', 249367),
(393105, 'PTHR10811:SF97', NULL, NULL, NULL, NULL, 'BNAANNG23960D PROTEIN', 249367),
(393106, 'PTHR10811:SF56', NULL, NULL, NULL, NULL, 'RADICAL FRINGE PROTEIN, PUTATIVE (DUF604)-RELATED', 249367),
(393107, 'PTHR10811:SF99', NULL, NULL, NULL, NULL, 'BNAC05G03320D PROTEIN', 249367),
(393108, 'PTHR10811:SF55', NULL, NULL, NULL, NULL, 'OS02G0681100 PROTEIN', 249367),
(393109, 'PTHR10811:SF13', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249367),
(393110, 'PTHR10811:SF57', NULL, NULL, NULL, NULL, 'F22L4.11 PROTEIN', 249367),
(393111, 'PTHR10811:SF16', NULL, NULL, NULL, NULL, 'FRINGE', 249367),
(393112, 'PTHR10811:SF7', NULL, NULL, NULL, NULL, 'BETA-1,3-N-ACETYLGLUCOSAMINYLTRANSFERASE LUNATIC FRINGE', 249367),
(393113, 'PTHR10811:SF19', NULL, NULL, NULL, NULL, '(C)1 PROVIRUS ANCESTRAL ENV POLYPROTEIN, PUTATIVE (DUF604)-RELATED', 249367),
(393114, 'PTHR10811:SF6', NULL, NULL, NULL, NULL, 'BETA-1,3-N-ACETYLGLUCOSAMINYLTRANSFERASE MANIC FRINGE', 249367);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(393115, 'PTHR10811:SF5', NULL, NULL, NULL, NULL, 'FRINGE GLYCOSYLTRANSFERASE', 249367),
(393116, 'PTHR11426:SF261', NULL, NULL, NULL, NULL, 'OS02G0457300 PROTEIN', 249368),
(393117, 'PTHR11426:SF262', NULL, NULL, NULL, NULL, 'HISTONE H3.X-RELATED', 249368),
(393118, 'PTHR11426:SF260', NULL, NULL, NULL, NULL, 'HISTONE H3-LIKE CENTROMERIC PROTEIN CNP1', 249368),
(393119, 'PTHR11426:SF265', NULL, NULL, NULL, NULL, 'HISTONE H3.2', 249368),
(393120, 'PTHR11426:SF266', NULL, NULL, NULL, NULL, 'HISTONE H3', 249368),
(393121, 'PTHR11426:SF244', NULL, NULL, NULL, NULL, 'HISTONE DOMAIN-CONTAINING PROTEIN', 249368),
(393122, 'PTHR11426:SF263', NULL, NULL, NULL, NULL, 'HISTONE DOMAIN-CONTAINING PROTEIN', 249368),
(393123, 'PTHR11426:SF242', NULL, NULL, NULL, NULL, 'HISTONE H3.1', 249368),
(393124, 'PTHR11426:SF264', NULL, NULL, NULL, NULL, 'HISTONE DOMAIN-CONTAINING PROTEIN', 249368),
(393125, 'PTHR11426:SF209', NULL, NULL, NULL, NULL, 'HISTONE H3.2', 249368),
(393126, 'PTHR11426:SF247', NULL, NULL, NULL, NULL, 'HISTONE HIST2H3PS2', 249368),
(393127, 'PTHR11426:SF223', NULL, NULL, NULL, NULL, 'HISTONE H3-LIKE CENTROMERIC PROTEIN HTR12', 249368),
(393128, 'PTHR11426:SF267', NULL, NULL, NULL, NULL, 'HISTONE H3-LIKE CENTROMERIC PROTEIN CID', 249368),
(393129, 'PTHR11426:SF202', NULL, NULL, NULL, NULL, 'HISTONE DOMAIN-CONTAINING PROTEIN', 249368),
(393130, 'PTHR11426:SF44', NULL, NULL, NULL, NULL, 'HISTONE H3.3C', 249368),
(393131, 'PTHR11426:SF207', NULL, NULL, NULL, NULL, 'HISTONE H3-4-LIKE', 249368),
(393132, 'PTHR11426:SF205', NULL, NULL, NULL, NULL, 'HISTONE H3', 249368),
(393133, 'PTHR11426:SF227', NULL, NULL, NULL, NULL, 'HISTONE H3', 249368),
(393134, 'PTHR11426:SF249', NULL, NULL, NULL, NULL, 'HISTONE H3', 249368),
(393135, 'PTHR11426:SF228', NULL, NULL, NULL, NULL, 'HISTONE H3.3-RELATED', 249368),
(393136, 'PTHR11426:SF250', NULL, NULL, NULL, NULL, 'HISTONE H3.1', 249368),
(393137, 'PTHR11426:SF251', NULL, NULL, NULL, NULL, 'HISTONES H3 AND H4-RELATED', 249368),
(393138, 'PTHR11426:SF194', NULL, NULL, NULL, NULL, 'HISTONE H3', 249368),
(393139, 'PTHR11426:SF254', NULL, NULL, NULL, NULL, 'HISTONE H3-LIKE CENTROMERIC PROTEIN CSE4', 249368),
(393140, 'PTHR11426:SF210', NULL, NULL, NULL, NULL, 'HISTONE H3.3', 249368),
(393141, 'PTHR11426:SF255', NULL, NULL, NULL, NULL, 'HISTONE H3-LIKE CENTROMERIC PROTEIN A', 249368),
(393142, 'PTHR11426:SF233', NULL, NULL, NULL, NULL, 'HISTONE H3', 249368),
(393143, 'PTHR11426:SF252', NULL, NULL, NULL, NULL, 'HISTONE H3', 249368),
(393144, 'PTHR11426:SF253', NULL, NULL, NULL, NULL, 'HISTONE DOMAIN-CONTAINING PROTEIN', 249368),
(393145, 'PTHR11426:SF198', NULL, NULL, NULL, NULL, 'HISTONE H3', 249368),
(393146, 'PTHR11426:SF191', NULL, NULL, NULL, NULL, 'HISTONE H3-LIKE CENTROMERIC PROTEIN A', 249368),
(393147, 'PTHR11426:SF190', NULL, NULL, NULL, NULL, 'HISTONE H3.3', 249368),
(393148, 'PTHR11426', NULL, NULL, NULL, NULL, 'HISTONE H3', 249368),
(393149, 'PTHR11426:SF258', NULL, NULL, NULL, NULL, 'HISTONE H3.3 TYPE A-RELATED', 249368),
(393150, 'PTHR11426:SF259', NULL, NULL, NULL, NULL, 'HISTONE H3', 249368),
(393151, 'PTHR11426:SF256', NULL, NULL, NULL, NULL, 'HISTONE H3', 249368),
(393152, 'PTHR11426:SF212', NULL, NULL, NULL, NULL, 'HISTONE H3', 249368),
(393153, 'PTHR11426:SF257', NULL, NULL, NULL, NULL, 'HISTONE H3.1T', 249368),
(393154, 'PTHR11426:SF235', NULL, NULL, NULL, NULL, 'HISTONE DOMAIN-CONTAINING PROTEIN', 249368),
(393155, 'PTHR11426:SF238', NULL, NULL, NULL, NULL, 'HISTONE H3', 249368),
(393156, 'PTHR11426:SF217', NULL, NULL, NULL, NULL, 'HISTONE H3-LIKE 2-RELATED', 249368),
(393157, 'PTHR11426:SF118', NULL, NULL, NULL, NULL, 'HISTONE H3.3 TYPE 2-RELATED', 249368),
(393158, 'PTHR43303', NULL, NULL, NULL, NULL, 'NADPH DEHYDROGENASE C23G7.10C-RELATED', 249369),
(393159, 'PTHR43303:SF1', NULL, NULL, NULL, NULL, 'NADH:FLAVIN OXIDOREDUCTASE/NADH OXIDASE DOMAIN-CONTAINING PROTEIN-RELATED', 249369),
(393160, 'PTHR43303:SF2', NULL, NULL, NULL, NULL, 'INDOLEAMINE 2,3-DIOXYGENASE PYRROLE 2,3-DIOXYGENASE (AFU_ORTHOLOGUE AFUA_5G01450', 249369),
(393161, 'PTHR43303:SF3', NULL, NULL, NULL, NULL, 'BLR3436 PROTEIN', 249369);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(393162, 'PTHR43303:SF4', NULL, NULL, NULL, NULL, 'NADPH DEHYDROGENASE C23G7.10C-RELATED', 249369),
(393163, 'PTHR43303:SF7', NULL, NULL, NULL, NULL, 'FLAVIN OXIDOREDUCTASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G06420)-RELATED', 249369),
(393164, 'PTHR43303:SF8', NULL, NULL, NULL, NULL, 'OXIDORED_FMN DOMAIN-CONTAINING PROTEIN', 249369),
(393165, 'PTHR34944', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM7', 249370),
(393166, 'PTHR34944:SF2', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM7', 249370),
(393167, 'PTHR34944:SF4', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM7-2', 249370),
(393168, 'PTHR34944:SF10', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM7-1-LIKE', 249370),
(393169, 'PTHR34944:SF9', NULL, NULL, NULL, NULL, 'OS01G0732000 PROTEIN', 249370),
(393170, 'PTHR34944:SF8', NULL, NULL, NULL, NULL, '', 249370),
(393171, 'PTHR34496', NULL, NULL, NULL, NULL, 'GLCNAC TRANSFERASE-RELATED', 249371),
(393172, 'PTHR34496:SF6', NULL, NULL, NULL, NULL, 'GLCNAC TRANSFERASE', 249371),
(393173, 'PTHR34496:SF7', NULL, NULL, NULL, NULL, '', 249371),
(393174, 'PTHR34496:SF9', NULL, NULL, NULL, NULL, '[SKP1-PROTEIN]-HYDROXYPROLINE N-ACETYLGLUCOSAMINYLTRANSFERASE', 249371),
(393175, 'PTHR43574', NULL, NULL, NULL, NULL, 'EPIMERASE-RELATED', 249372),
(393176, 'PTHR43574:SF36', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE 4-EPIMERASE 1-LIKE', 249372),
(393177, 'PTHR43574:SF79', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE 4-EPIMERASE 5', 249372),
(393178, 'PTHR43574:SF13', NULL, NULL, NULL, NULL, 'GDP-MANNOSE 3,5-EPIMERASE 2', 249372),
(393179, 'PTHR43574:SF78', NULL, NULL, NULL, NULL, 'BNAA03G18360D PROTEIN', 249372),
(393180, 'PTHR43574:SF34', NULL, NULL, NULL, NULL, 'NAD(P)-BD_DOM DOMAIN-CONTAINING PROTEIN', 249372),
(393181, 'PTHR43574:SF56', NULL, NULL, NULL, NULL, 'UDP-D-GLUCURONATE 4-EPIMERASE 6-RELATED', 249372),
(393182, 'PTHR43574:SF77', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE 4-EPIMERASE 3', 249372),
(393183, 'PTHR43574:SF55', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 249372),
(393184, 'PTHR43574:SF11', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 249372),
(393185, 'PTHR43574:SF18', NULL, NULL, NULL, NULL, 'GDP-MANNOSE 3,5-EPIMERASE', 249372),
(393186, 'PTHR43574:SF17', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE 4-EPIMERASE 1', 249372),
(393187, 'PTHR43574:SF38', NULL, NULL, NULL, NULL, 'OS01G0367400 PROTEIN', 249372),
(393188, 'PTHR43574:SF72', NULL, NULL, NULL, NULL, 'NAD(P)-BD_DOM DOMAIN-CONTAINING PROTEIN', 249372),
(393189, 'PTHR43574:SF71', NULL, NULL, NULL, NULL, 'GDP-MANNOSE 3,5-EPIMERASE 1-LIKE', 249372),
(393190, 'PTHR43574:SF70', NULL, NULL, NULL, NULL, 'NAD DEPENDENT EPIMERASE/DEHYDRATASE FAMILY PROTEIN, EXPRESSED', 249372),
(393191, 'PTHR43574:SF76', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 249372),
(393192, 'PTHR43574:SF75', NULL, NULL, NULL, NULL, 'NAD(P)-BD_DOM DOMAIN-CONTAINING PROTEIN', 249372),
(393193, 'PTHR43574:SF30', NULL, NULL, NULL, NULL, 'GDP-MANNOSE 3,5-EPIMERASE 1', 249372),
(393194, 'PTHR43574:SF74', NULL, NULL, NULL, NULL, 'NAD(P)-BD_DOM DOMAIN-CONTAINING PROTEIN', 249372),
(393195, 'PTHR43574:SF73', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE 4-EPIMERASE 4-LIKE', 249372),
(393196, 'PTHR43574:SF8', NULL, NULL, NULL, NULL, 'PROTEIN HIGH CHLOROPHYLL FLUORESCENCE PHENOTYPE 173, CHLOROPLASTIC', 249372),
(393197, 'PTHR43574:SF68', NULL, NULL, NULL, NULL, 'ROSSMANN-FOLD PROTEIN, PUTATIVE-RELATED', 249372),
(393198, 'PTHR43574:SF24', NULL, NULL, NULL, NULL, 'NAD(P)-BD_DOM DOMAIN-CONTAINING PROTEIN', 249372),
(393199, 'PTHR43574:SF67', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE 4-EPIMERASE 6-LIKE', 249372),
(393200, 'PTHR43574:SF45', NULL, NULL, NULL, NULL, 'NUCLEOTIDE SUGAR EPIMERASE-RELATED', 249372),
(393201, 'PTHR43574:SF89', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE 4-EPIMERASE 4', 249372),
(393202, 'PTHR43574:SF88', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 249372),
(393203, 'PTHR43574:SF66', NULL, NULL, NULL, NULL, 'NAD(P)-BD_DOM DOMAIN-CONTAINING PROTEIN', 249372);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(393204, 'PTHR43574:SF29', NULL, NULL, NULL, NULL, 'NAD(P)-BD_DOM DOMAIN-CONTAINING PROTEIN', 249372),
(393205, 'PTHR43574:SF28', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE 4-EPIMERASE 6', 249372),
(393206, 'PTHR43574:SF49', NULL, NULL, NULL, NULL, 'NAD(P)-BD_DOM DOMAIN-CONTAINING PROTEIN', 249372),
(393207, 'PTHR43574:SF83', NULL, NULL, NULL, NULL, 'GDP-MANNOSE 3,5-EPIMERASE 2 ISOFORM 1', 249372),
(393208, 'PTHR43574:SF82', NULL, NULL, NULL, NULL, 'NAD(P)-BD_DOM DOMAIN-CONTAINING PROTEIN', 249372),
(393209, 'PTHR43574:SF60', NULL, NULL, NULL, NULL, 'OS06G0704700 PROTEIN', 249372),
(393210, 'PTHR43574:SF6', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 249372),
(393211, 'PTHR43574:SF81', NULL, NULL, NULL, NULL, 'NUCLEOTIDE SUGAR EPIMERASE, BIFUNCTIONAL POLYMYXIN RESISTANCE PROTEIN, ARNA-RELATED', 249372),
(393212, 'PTHR43574:SF80', NULL, NULL, NULL, NULL, 'UDP-D-GLUCURONATE 4-EPIMERASE 1-RELATED', 249372),
(393213, 'PTHR43574:SF87', NULL, NULL, NULL, NULL, '', 249372),
(393214, 'PTHR43574:SF42', NULL, NULL, NULL, NULL, 'NAD(P)-BD_DOM DOMAIN-CONTAINING PROTEIN', 249372),
(393215, 'PTHR43574:SF86', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 4-EPIMERASE/UDP-SULFOQUINOVOSE SYNTHASE', 249372),
(393216, 'PTHR43574:SF85', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE 4-EPIMERASE 2-RELATED', 249372),
(393217, 'PTHR43574:SF84', NULL, NULL, NULL, NULL, 'OS09G0504000 PROTEIN', 249372),
(393218, 'PTHR43574:SF3', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE 4-EPIMERASE 1', 249372),
(393219, 'PTHR31269:SF24', NULL, NULL, NULL, NULL, '', 249373),
(393220, 'PTHR31269:SF46', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 249373),
(393221, 'PTHR31269:SF23', NULL, NULL, NULL, NULL, 'OS07G0181100 PROTEIN', 249373),
(393222, 'PTHR31269:SF22', NULL, NULL, NULL, NULL, 'OS05G0269200 PROTEIN', 249373),
(393223, 'PTHR31269:SF44', NULL, NULL, NULL, NULL, 'TELLURITE RESISTANCE PROTEIN TEHA', 249373),
(393224, 'PTHR31269:SF41', NULL, NULL, NULL, NULL, 'SLAC1-LIKE PROTEIN-RELATED', 249373),
(393225, 'PTHR31269:SF40', NULL, NULL, NULL, NULL, '', 249373),
(393226, 'PTHR31269:SF27', NULL, NULL, NULL, NULL, 'S-TYPE ANION CHANNEL SLAH4-LIKE', 249373),
(393227, 'PTHR31269:SF49', NULL, NULL, NULL, NULL, 'BNAA02G32730D PROTEIN', 249373),
(393228, 'PTHR31269', NULL, NULL, NULL, NULL, 'S-TYPE ANION CHANNEL SLAH3', 249373),
(393229, 'PTHR31269:SF58', NULL, NULL, NULL, NULL, '', 249373),
(393230, 'PTHR31269:SF57', NULL, NULL, NULL, NULL, 'BNAA09G13390D PROTEIN', 249373),
(393231, 'PTHR31269:SF35', NULL, NULL, NULL, NULL, 'S-TYPE ANION CHANNEL SLAH3', 249373),
(393232, 'PTHR31269:SF2', NULL, NULL, NULL, NULL, 'S-TYPE ANION CHANNEL SLAH3', 249373),
(393233, 'PTHR31269:SF34', NULL, NULL, NULL, NULL, 'S-TYPE ANION CHANNEL SLAH3', 249373),
(393234, 'PTHR31269:SF56', NULL, NULL, NULL, NULL, 'S-TYPE ANION CHANNEL SLAH4-LIKE', 249373),
(393235, 'PTHR31269:SF11', NULL, NULL, NULL, NULL, 'GUARD CELL S-TYPE ANION CHANNEL SLAC1', 249373),
(393236, 'PTHR31269:SF33', NULL, NULL, NULL, NULL, 'S-TYPE ANION CHANNEL SLAH2', 249373),
(393237, 'PTHR31269:SF55', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT ANION CHANNEL-RELATED', 249373),
(393238, 'PTHR31269:SF54', NULL, NULL, NULL, NULL, 'S-TYPE ANION CHANNEL SLAH2-LIKE', 249373),
(393239, 'PTHR31269:SF53', NULL, NULL, NULL, NULL, 'BNAA09G13380D PROTEIN', 249373),
(393240, 'PTHR31269:SF52', NULL, NULL, NULL, NULL, 'ZINC FINGER, CCHC-TYPE, VOLTAGE-DEPENDENT ANION CHANNEL-RELATED', 249373),
(393241, 'PTHR31269:SF51', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 249373),
(393242, 'PTHR31269:SF38', NULL, NULL, NULL, NULL, '', 249373),
(393243, 'PTHR31269:SF59', NULL, NULL, NULL, NULL, 'S-TYPE ANION CHANNEL SLAH4', 249373),
(393244, 'PTHR31269:SF61', NULL, NULL, NULL, NULL, 'C4-DICARBOXYLATE TRANSPORTER/MALIC ACID PROTEIN', 249373),
(393245, 'PTHR31269:SF60', NULL, NULL, NULL, NULL, 'S-TYPE ANION CHANNEL SLAH1', 249373),
(393246, 'PTHR31269:SF5', NULL, NULL, NULL, NULL, 'OS01G0226600 PROTEIN', 249373),
(393247, 'PTHR31269:SF6', NULL, NULL, NULL, NULL, 'S-TYPE ANION CHANNEL SLAH3', 249373);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(393248, 'PTHR47673:SF1', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 249374),
(393249, 'PTHR47673', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 249374),
(393250, 'PTHR47822:SF3', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 249375),
(393251, 'PTHR47822:SF2', NULL, NULL, NULL, NULL, 'F-BOX AND WD-40 DOMAIN PROTEIN 7', 249375),
(393252, 'PTHR47822', NULL, NULL, NULL, NULL, 'CARBOHYDRATE BINDING DOMAIN CONTAINING PROTEIN', 249375),
(393253, 'PTHR14217:SF1', NULL, NULL, NULL, NULL, 'INOSITOL-TETRAKISPHOSPHATE 1-KINASE', 249376),
(393254, 'PTHR14217:SF2', NULL, NULL, NULL, NULL, 'INOSITOL-TETRAKISPHOSPHATE 1-KINASE 4', 249376),
(393255, 'PTHR14217:SF24', NULL, NULL, NULL, NULL, 'INOSITOL-TETRAKISPHOSPHATE 1-KINASE 5', 249376),
(393256, 'PTHR14217:SF25', NULL, NULL, NULL, NULL, 'INOSITOL-TETRAKISPHOSPHATE 1-KINASE', 249376),
(393257, 'PTHR14217:SF36', NULL, NULL, NULL, NULL, 'INOSITOL-TETRAKISPHOSPHATE 1-KINASE 3', 249376),
(393258, 'PTHR14217:SF37', NULL, NULL, NULL, NULL, 'INOSITOL-TETRAKISPHOSPHATE 1-KINASE', 249376),
(393259, 'PTHR14217:SF26', NULL, NULL, NULL, NULL, 'INOSITOL-TETRAKISPHOSPHATE 1-KINASE', 249376),
(393260, 'PTHR14217:SF27', NULL, NULL, NULL, NULL, 'INOSITOL-TETRAKISPHOSPHATE 1-KINASE', 249376),
(393261, 'PTHR14217:SF38', NULL, NULL, NULL, NULL, 'INOSITOL-TETRAKISPHOSPHATE 1-KINASE 1', 249376),
(393262, 'PTHR14217:SF7', NULL, NULL, NULL, NULL, 'INOSITOL-TETRAKISPHOSPHATE 1-KINASE 2', 249376),
(393263, 'PTHR14217:SF39', NULL, NULL, NULL, NULL, 'INOSITOL-TETRAKISPHOSPHATE 1-KINASE 3', 249376),
(393264, 'PTHR14217:SF29', NULL, NULL, NULL, NULL, 'INOSITOL-TETRAKISPHOSPHATE 1-KINASE', 249376),
(393265, 'PTHR14217:SF18', NULL, NULL, NULL, NULL, 'INOSITOL-TETRAKISPHOSPHATE 1-KINASE', 249376),
(393266, 'PTHR14217:SF19', NULL, NULL, NULL, NULL, 'INOSITOL-TETRAKISPHOSPHATE 1-KINASE 2', 249376),
(393267, 'PTHR14217', NULL, NULL, NULL, NULL, 'INOSITOL-TETRAKISPHOSPHATE 1-KINASE', 249376),
(393268, 'PTHR14217:SF31', NULL, NULL, NULL, NULL, 'INOSITOL-TETRAKISPHOSPHATE 1-KINASE', 249376),
(393269, 'PTHR14217:SF20', NULL, NULL, NULL, NULL, 'INOSITOL-TETRAKISPHOSPHATE 1-KINASE', 249376),
(393270, 'PTHR14217:SF21', NULL, NULL, NULL, NULL, 'INOSITOL-TETRAKISPHOSPHATE 1-KINASE', 249376),
(393271, 'PTHR14217:SF22', NULL, NULL, NULL, NULL, '', 249376),
(393272, 'PTHR14217:SF34', NULL, NULL, NULL, NULL, 'INOSITOL-TETRAKISPHOSPHATE 1-KINASE', 249376),
(393273, 'PTHR14217:SF23', NULL, NULL, NULL, NULL, 'INOSITOL-TETRAKISPHOSPHATE 1-KINASE', 249376),
(393274, 'PTHR34998:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249377),
(393275, 'PTHR34998', NULL, NULL, NULL, NULL, 'OS04G0357400 PROTEIN-RELATED', 249377),
(393276, 'PTHR34998:SF8', NULL, NULL, NULL, NULL, '', 249377),
(393277, 'PTHR34998:SF9', NULL, NULL, NULL, NULL, 'OS04G0357400 PROTEIN', 249377),
(393278, 'PTHR34998:SF4', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249377),
(393279, 'PTHR34998:SF5', NULL, NULL, NULL, NULL, '', 249377),
(393280, 'PTHR34998:SF7', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249377),
(393281, 'PTHR17530', NULL, NULL, NULL, NULL, 'PRO-THYROTROPIN-RELEASING HORMONE', 249378),
(393282, 'PTHR17530:SF2', NULL, NULL, NULL, NULL, 'PRO-THYROTROPIN-RELEASING HORMONE', 249378),
(393283, 'PTHR18957', NULL, NULL, NULL, NULL, 'CENTLEIN', 249379),
(393284, 'PTHR18957:SF0', NULL, NULL, NULL, NULL, 'CENTLEIN', 249379),
(393285, 'PTHR37787:SF1', NULL, NULL, NULL, NULL, 'BIOGENESIS OF LYSOSOME-RELATED ORGANELLES COMPLEX 1 SUBUNIT KXD1', 249380),
(393286, 'PTHR37787', NULL, NULL, NULL, NULL, 'BIOGENESIS OF LYSOSOME-RELATED ORGANELLES COMPLEX 1 SUBUNIT KXD1', 249380),
(393287, 'PTHR34005:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG15054', 249381),
(393288, 'PTHR34005:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG13612', 249381),
(393289, 'PTHR34005', NULL, NULL, NULL, NULL, 'PROTEIN CBG15054-RELATED', 249381),
(393290, 'PTHR34005:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG08730', 249381),
(393291, 'PTHR12925', NULL, NULL, NULL, NULL, 'HIKESHI FAMILY MEMBER', 249382),
(393292, 'PTHR12925:SF0', NULL, NULL, NULL, NULL, 'PROTEIN HIKESHI', 249382);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(393293, 'PTHR12925:SF1', NULL, NULL, NULL, NULL, 'DUF775 DOMAIN-CONTAINING PROTEIN', 249382),
(393294, 'PTHR30622', NULL, NULL, NULL, NULL, 'UNDECAPRENYL-DIPHOSPHATASE', 249383),
(393295, 'PTHR30622:SF4', NULL, NULL, NULL, NULL, 'UNDECAPRENYL-DIPHOSPHATASE', 249383),
(393296, 'PTHR30622:SF2', NULL, NULL, NULL, NULL, 'UNDECAPRENYL-DIPHOSPHATASE', 249383),
(393297, 'PTHR30622:SF3', NULL, NULL, NULL, NULL, 'UNDECAPRENYL-DIPHOSPHATASE', 249383),
(393298, 'PTHR45364:SF10', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE', 249384),
(393299, 'PTHR45364:SF1', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE 9', 249384),
(393300, 'PTHR45364:SF8', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE 5', 249384),
(393301, 'PTHR45364:SF7', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE 4', 249384),
(393302, 'PTHR45364', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE 9-RELATED', 249384),
(393303, 'PTHR45364:SF9', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE 7', 249384),
(393304, 'PTHR45364:SF6', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE', 249384),
(393305, 'PTHR15644:SF2', NULL, NULL, NULL, NULL, 'OSTEOPETROSIS-ASSOCIATED TRANSMEMBRANE PROTEIN 1', 249385),
(393306, 'PTHR15644', NULL, NULL, NULL, NULL, 'OSTEOPETROSIS ASSOCIATED TRANSMEMBRANE PROTEIN 1', 249385),
(393307, 'PTHR28573:SF1', NULL, NULL, NULL, NULL, 'SPINDLE AND KINETOCHORE-ASSOCIATED PROTEIN 1', 249386),
(393308, 'PTHR28573', NULL, NULL, NULL, NULL, 'SPINDLE AND KINETOCHORE-ASSOCIATED PROTEIN 1', 249386),
(393309, 'PTHR16056:SF15', NULL, NULL, NULL, NULL, 'REGULATOR OF MICROTUBULE DYNAMICS PROTEIN 2', 249387),
(393310, 'PTHR16056', NULL, NULL, NULL, NULL, 'REGULATOR OF MICROTUBULE DYNAMICS PROTEIN', 249387),
(393311, 'PTHR16056:SF36', NULL, NULL, NULL, NULL, 'PROTEIN CBG15695', 249387),
(393312, 'PTHR16056:SF35', NULL, NULL, NULL, NULL, '', 249387),
(393313, 'PTHR16056:SF12', NULL, NULL, NULL, NULL, 'REGULATOR OF MICROTUBULE DYNAMICS', 249387),
(393314, 'PTHR16056:SF18', NULL, NULL, NULL, NULL, 'REGULATOR OF MICROTUBULE DYNAMICS PROTEIN 3', 249387),
(393315, 'PTHR16056:SF16', NULL, NULL, NULL, NULL, 'REGULATOR OF MICROTUBULE DYNAMICS PROTEIN 1', 249387),
(393316, 'PTHR16056:SF5', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 249387),
(393317, 'PTHR16056:SF4', NULL, NULL, NULL, NULL, 'REGULATOR OF MICROTUBULE DYNAMICS PROTEIN 1', 249387),
(393318, 'PTHR16056:SF2', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 10', 249387),
(393319, 'PTHR16056:SF20', NULL, NULL, NULL, NULL, 'SUPPRESSOR-RELATED', 249387),
(393320, 'PTHR43747', NULL, NULL, NULL, NULL, 'FAD-BINDING PROTEIN', 249388),
(393321, 'PTHR43747:SF4', NULL, NULL, NULL, NULL, 'FLAVIN-DEPENDENT TRYPTOPHAN HALOGENASE', 249388),
(393322, 'PTHR43747:SF1', NULL, NULL, NULL, NULL, 'FAD_BINDING_3 DOMAIN-CONTAINING PROTEIN', 249388),
(393323, 'PTHR37298', NULL, NULL, NULL, NULL, 'UPF0111 PROTEIN YKAA', 249389),
(393324, 'PTHR37298:SF1', NULL, NULL, NULL, NULL, 'UPF0111 PROTEIN YKAA', 249389),
(393325, 'PTHR11700:SF38', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S20', 249390),
(393326, 'PTHR11700:SF26', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOMAL PROTEIN S10', 249390),
(393327, 'PTHR11700:SF37', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S20', 249390),
(393328, 'PTHR11700:SF9', NULL, NULL, NULL, NULL, '37S RIBOSOMAL PROTEIN S10, MITOCHONDRIAL', 249390),
(393329, 'PTHR11700:SF8', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S20', 249390),
(393330, 'PTHR11700', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S10 FAMILY MEMBER', 249390),
(393331, 'PTHR11700:SF7', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S10, MITOCHONDRIAL', 249390),
(393332, 'PTHR11700:SF30', NULL, NULL, NULL, NULL, 'RIBOSOMAL_S10 DOMAIN-CONTAINING PROTEIN', 249390),
(393333, 'PTHR11700:SF41', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S20-2', 249390),
(393334, 'PTHR11700:SF43', NULL, NULL, NULL, NULL, 'RIBOSOMAL_S10 DOMAIN-CONTAINING PROTEIN', 249390),
(393335, 'PTHR11700:SF32', NULL, NULL, NULL, NULL, 'RIBOSOMAL_S10 DOMAIN-CONTAINING PROTEIN', 249390),
(393336, 'PTHR11700:SF20', NULL, NULL, NULL, NULL, 'RIBOSOMAL_S10 DOMAIN-CONTAINING PROTEIN', 249390);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(393337, 'PTHR11700:SF42', NULL, NULL, NULL, NULL, 'RIBOSOMAL_S10 DOMAIN-CONTAINING PROTEIN', 249390),
(393338, 'PTHR11700:SF45', NULL, NULL, NULL, NULL, 'RIBOSOMAL_S10 DOMAIN-CONTAINING PROTEIN', 249390),
(393339, 'PTHR11700:SF34', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S20', 249390),
(393340, 'PTHR11700:SF44', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S20, PUTATIVE, EXPRESSED-RELATED', 249390),
(393341, 'PTHR11700:SF22', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S20-1-RELATED', 249390),
(393342, 'PTHR11700:SF47', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S10-RELATED', 249390),
(393343, 'PTHR11700:SF46', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S20', 249390),
(393344, 'PTHR11700:SF35', NULL, NULL, NULL, NULL, 'RIBOSOMAL_S10 DOMAIN-CONTAINING PROTEIN', 249390),
(393345, 'PTHR36696', NULL, NULL, NULL, NULL, 'AGAP012002-PA', 249391),
(393346, 'PTHR36696:SF1', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 249391),
(393347, 'PTHR42339:SF1', NULL, NULL, NULL, NULL, '', 249392),
(393348, 'PTHR42339', NULL, NULL, NULL, NULL, '', 249392),
(393349, 'PTHR35321:SF1', NULL, NULL, NULL, NULL, 'OS02G0753200 PROTEIN', 249393),
(393350, 'PTHR35321', NULL, NULL, NULL, NULL, 'OS02G0753200 PROTEIN', 249393),
(393351, 'PTHR28144', NULL, NULL, NULL, NULL, 'ER MEMBRANE PROTEIN COMPLEX SUBUNIT 5', 249394),
(393352, 'PTHR28144:SF1', NULL, NULL, NULL, NULL, 'ER MEMBRANE PROTEIN COMPLEX SUBUNIT 5', 249394),
(393353, 'PTHR22999', NULL, NULL, NULL, NULL, 'PX SERINE/THREONINE KINASE  PXK', 249395),
(393354, 'PTHR22999:SF40', NULL, NULL, NULL, NULL, 'PX DOMAIN-CONTAINING PROTEIN KINASE-LIKE PROTEIN', 249395),
(393355, 'PTHR22999:SF28', NULL, NULL, NULL, NULL, 'PHOX (PX) DOMAIN-CONTAINING PROTEIN', 249395),
(393356, 'PTHR22999:SF39', NULL, NULL, NULL, NULL, 'PHOX DOMAIN, SORTING NEXIN-RELATED', 249395),
(393357, 'PTHR22999:SF35', NULL, NULL, NULL, NULL, 'PHOX DOMAIN-CONTAINING PROTEIN-RELATED', 249395),
(393358, 'PTHR22999:SF38', NULL, NULL, NULL, NULL, '', 249395),
(393359, 'PTHR22999:SF31', NULL, NULL, NULL, NULL, 'SLOWPOKE-BINDING PROTEIN', 249395),
(393360, 'PTHR22999:SF23', NULL, NULL, NULL, NULL, 'SORTING NEXIN-16', 249395),
(393361, 'PTHR22999:SF34', NULL, NULL, NULL, NULL, 'BNAA09G56730D PROTEIN', 249395),
(393362, 'PTHR46452', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 3', 249396),
(393363, 'PTHR46452:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 3', 249396),
(393364, 'PTHR47196', NULL, NULL, NULL, NULL, 'KELCH DOMAIN-CONTAINING PROTEIN 9', 249397),
(393365, 'PTHR47196:SF1', NULL, NULL, NULL, NULL, 'KELCH DOMAIN-CONTAINING PROTEIN 9', 249397),
(393366, 'PTHR23326:SF6', NULL, NULL, NULL, NULL, 'NOT TRANSCRIPTION COMPLEX SUBUNIT VIP2-RELATED', 249398),
(393367, 'PTHR23326', NULL, NULL, NULL, NULL, 'CCR4 NOT-RELATED', 249398),
(393368, 'PTHR23326:SF30', NULL, NULL, NULL, NULL, 'NOT2_3_5 DOMAIN-CONTAINING PROTEIN', 249398),
(393369, 'PTHR23326:SF20', NULL, NULL, NULL, NULL, 'NOT2_3_5 DOMAIN-CONTAINING PROTEIN', 249398),
(393370, 'PTHR23326:SF31', NULL, NULL, NULL, NULL, 'CCR4-NOT TRANSCRIPTION COMPLEX SUBUNIT 2', 249398),
(393371, 'PTHR23326:SF32', NULL, NULL, NULL, NULL, 'BNAA10G16600D PROTEIN', 249398),
(393372, 'PTHR23326:SF22', NULL, NULL, NULL, NULL, 'NOT3 DOMAIN-CONTAINING PROTEIN', 249398),
(393373, 'PTHR23326:SF23', NULL, NULL, NULL, NULL, 'CCR4-NOT TRANSCRIPTION COMPLEX, SUBUNIT 3B', 249398),
(393374, 'PTHR23326:SF24', NULL, NULL, NULL, NULL, 'CCR4-NOT TRANSCRIPTION COMPLEX, SUBUNIT 3A', 249398),
(393375, 'PTHR23326:SF25', NULL, NULL, NULL, NULL, 'NOT2_3_5 DOMAIN-CONTAINING PROTEIN', 249398),
(393376, 'PTHR23326:SF15', NULL, NULL, NULL, NULL, 'NOT TRANSCRIPTION COMPLEX SUBUNIT VIP2 ISOFORM X1-RELATED', 249398),
(393377, 'PTHR23326:SF16', NULL, NULL, NULL, NULL, 'GENERAL NEGATIVE REGULATOR OF TRANSCRIPTION SUBUNIT 3', 249398),
(393378, 'PTHR23326:SF28', NULL, NULL, NULL, NULL, 'NOT2_3_5 DOMAIN-CONTAINING PROTEIN', 249398),
(393379, 'PTHR23326:SF18', NULL, NULL, NULL, NULL, 'NOT TRANSCRIPTION COMPLEX SUBUNIT VIP2-RELATED', 249398);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(393380, 'PTHR23326:SF29', NULL, NULL, NULL, NULL, '', 249398),
(393381, 'PTHR23326:SF3', NULL, NULL, NULL, NULL, 'CCR4-NOT TRANSCRIPTION COMPLEX SUBUNIT 2', 249398),
(393382, 'PTHR23326:SF19', NULL, NULL, NULL, NULL, 'NOT2/NOT3/NOT5-RELATED', 249398),
(393383, 'PTHR23326:SF1', NULL, NULL, NULL, NULL, 'CCR4-NOT TRANSCRIPTION COMPLEX SUBUNIT 3', 249398),
(393384, 'PTHR47912', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE 4, CHLOROPLASTIC', 249399),
(393385, 'PTHR47912:SF1', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE 4, CHLOROPLASTIC', 249399),
(393386, 'PTHR43742', NULL, NULL, NULL, NULL, 'TRIMETHYLAMINE-N-OXIDE REDUCTASE', 249400),
(393387, 'PTHR43742:SF9', NULL, NULL, NULL, NULL, 'TETRATHIONATE REDUCTASE SUBUNIT A', 249400),
(393388, 'PTHR43742:SF7', NULL, NULL, NULL, NULL, 'DIMETHYL SULFOXIDE REDUCTASE CHAIN YNFE-RELATED', 249400),
(393389, 'PTHR43742:SF8', NULL, NULL, NULL, NULL, 'ANAEROBIC DIMETHYL SULFOXIDE REDUCTASE, SUBUNIT A-RELATED', 249400),
(393390, 'PTHR43742:SF10', NULL, NULL, NULL, NULL, 'TRIMETHYLAMINE-N-OXIDE REDUCTASE 2', 249400),
(393391, 'PTHR43742:SF5', NULL, NULL, NULL, NULL, 'BIOTIN SULFOXIDE REDUCTASE', 249400),
(393392, 'PTHR43742:SF6', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE YYAE-RELATED', 249400),
(393393, 'PTHR43742:SF3', NULL, NULL, NULL, NULL, 'DIMETHYL SULFOXIDE REDUCTASE DMSA', 249400),
(393394, 'PTHR43742:SF4', NULL, NULL, NULL, NULL, 'TRIMETHYLAMINE-N-OXIDE REDUCTASE 1', 249400),
(393395, 'PTHR43742:SF1', NULL, NULL, NULL, NULL, 'DIMETHYL SULFOXIDE REDUCTASE CHAIN YNFF-RELATED', 249400),
(393396, 'PTHR43742:SF2', NULL, NULL, NULL, NULL, 'ASSIMILATORY NITRATE REDUCTASE CATALYTIC SUBUNIT', 249400),
(393397, 'PTHR32208:SF70', NULL, NULL, NULL, NULL, 'WSC DOMAIN-CONTAINING PROTEIN ARB_07867-LIKE', 249401),
(393398, 'PTHR32208:SF91', NULL, NULL, NULL, NULL, 'BNAA02G04330D PROTEIN', 249401),
(393399, 'PTHR32208:SF93', NULL, NULL, NULL, NULL, 'ALDEHYDE OXIDASE GLOX1', 249401),
(393400, 'PTHR32208:SF71', NULL, NULL, NULL, NULL, 'GLYOXAL OXIDASE-RELATED PROTEIN', 249401),
(393401, 'PTHR32208:SF74', NULL, NULL, NULL, NULL, 'WSC DOMAIN-CONTAINING PROTEIN ARB_07867-LIKE', 249401),
(393402, 'PTHR32208:SF96', NULL, NULL, NULL, NULL, 'GLYOXALOXIDASE 2', 249401),
(393403, 'PTHR32208:SF73', NULL, NULL, NULL, NULL, 'GLYOXAL OXIDASE-RELATED PROTEIN-RELATED', 249401),
(393404, 'PTHR32208:SF54', NULL, NULL, NULL, NULL, 'ALDEHYDE OXIDASE GLOX-LIKE', 249401),
(393405, 'PTHR32208:SF76', NULL, NULL, NULL, NULL, 'BNAC07G14960D PROTEIN', 249401),
(393406, 'PTHR32208:SF98', NULL, NULL, NULL, NULL, 'DUF1929 DOMAIN-CONTAINING PROTEIN', 249401),
(393407, 'PTHR32208:SF75', NULL, NULL, NULL, NULL, 'GALACTOSE OXIDASE/KELCH, BETA-PROPELLER-RELATED', 249401),
(393408, 'PTHR32208:SF89', NULL, NULL, NULL, NULL, 'BNAA08G31280D PROTEIN', 249401),
(393409, 'PTHR32208:SF66', NULL, NULL, NULL, NULL, 'WSC DOMAIN-CONTAINING PROTEIN ARB_07867-LIKE ISOFORM X2', 249401),
(393410, 'PTHR32208:SF88', NULL, NULL, NULL, NULL, 'GALACTOSE OXIDASE/KELCH, BETA-PROPELLER-RELATED', 249401),
(393411, 'PTHR32208:SF68', NULL, NULL, NULL, NULL, 'GALACTOSE OXIDASE', 249401),
(393412, 'PTHR32208:SF81', NULL, NULL, NULL, NULL, 'GALACTOSE OXIDASE/KELCH, BETA-PROPELLER-RELATED', 249401),
(393413, 'PTHR32208:SF80', NULL, NULL, NULL, NULL, 'BNAA02G17340D PROTEIN', 249401),
(393414, 'PTHR32208:SF103', NULL, NULL, NULL, NULL, '', 249401),
(393415, 'PTHR32208:SF83', NULL, NULL, NULL, NULL, 'GALACTOSE OXIDASE/KELCH, BETA-PROPELLER-RELATED', 249401),
(393416, 'PTHR32208:SF61', NULL, NULL, NULL, NULL, 'F10A5.18', 249401),
(393417, 'PTHR32208:SF82', NULL, NULL, NULL, NULL, 'GALACTOSE OXIDASE/KELCH, BETA-PROPELLER-RELATED', 249401),
(393418, 'PTHR32208:SF104', NULL, NULL, NULL, NULL, 'OS05G0559000 PROTEIN', 249401),
(393419, 'PTHR32208:SF85', NULL, NULL, NULL, NULL, 'GLYOXAL OXIDASE N-TERMINUS FAMILY PROTEIN, EXPRESSED', 249401),
(393420, 'PTHR32208:SF63', NULL, NULL, NULL, NULL, 'GLYOXAL OXIDASE-RELATED PROTEIN', 249401),
(393421, 'PTHR32208:SF101', NULL, NULL, NULL, NULL, 'BNAC07G14990D PROTEIN', 249401),
(393422, 'PTHR32208:SF102', NULL, NULL, NULL, NULL, 'GLYOXALOXIDASE 1', 249401);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(393423, 'PTHR32208:SF62', NULL, NULL, NULL, NULL, 'OXIDASE, PUTATIVE, EXPRESSED-RELATED', 249401),
(393424, 'PTHR32208:SF21', NULL, NULL, NULL, NULL, 'GALACTOSE OXIDASE-RELATED PROTEIN', 249401),
(393425, 'PTHR32208:SF87', NULL, NULL, NULL, NULL, 'GALACTOSE OXIDASE', 249401),
(393426, 'PTHR32208:SF86', NULL, NULL, NULL, NULL, 'BNAA09G57100D PROTEIN', 249401),
(393427, 'PTHR32208:SF100', NULL, NULL, NULL, NULL, 'GLYOXAL OXIDASE AMINO-TERMINAL PROTEIN', 249401),
(393428, 'PTHR32208:SF64', NULL, NULL, NULL, NULL, '', 249401),
(393429, 'PTHR32208:SF56', NULL, NULL, NULL, NULL, 'GALACTOSE OXIDASE-RELATED', 249401),
(393430, 'PTHR32208:SF99', NULL, NULL, NULL, NULL, 'GLYOXAL_OXID_N DOMAIN-CONTAINING PROTEIN', 249401),
(393431, 'PTHR32208:SF77', NULL, NULL, NULL, NULL, 'GALACTOSE OXIDASE/KELCH, BETA-PROPELLER, GALACTOSE OXIDASE, BETA-PROPELLER-RELATED', 249401),
(393432, 'PTHR32208:SF58', NULL, NULL, NULL, NULL, 'WSC DOMAIN-CONTAINING PROTEIN ARB_07867-LIKE', 249401),
(393433, 'PTHR32208:SF79', NULL, NULL, NULL, NULL, 'GALACTOSE OXIDASE/KELCH, BETA-PROPELLER, GALACTOSE OXIDASE, BETA-PROPELLER-RELATED', 249401),
(393434, 'PTHR32208:SF57', NULL, NULL, NULL, NULL, 'F14L17.20 PROTEIN', 249401),
(393435, 'PTHR32208', NULL, NULL, NULL, NULL, 'SECRETED PROTEIN-RELATED', 249401),
(393436, 'PTHR32208:SF59', NULL, NULL, NULL, NULL, 'WSC DOMAIN-CONTAINING PROTEIN ARB_07867-LIKE', 249401),
(393437, 'PTHR31680:SF16', NULL, NULL, NULL, NULL, 'DUF4378 DOMAIN-CONTAINING PROTEIN', 249402),
(393438, 'PTHR31680:SF17', NULL, NULL, NULL, NULL, 'DUF4378 DOMAIN-CONTAINING PROTEIN', 249402),
(393439, 'PTHR31680:SF12', NULL, NULL, NULL, NULL, 'OS11G0587300 PROTEIN', 249402),
(393440, 'PTHR31680:SF13', NULL, NULL, NULL, NULL, 'DUF3741-ASSOCIATED SEQUENCE MOTIF PROTEIN-RELATED', 249402),
(393441, 'PTHR31680:SF15', NULL, NULL, NULL, NULL, 'PROTEIN LONGIFOLIA 2', 249402),
(393442, 'PTHR31680:SF20', NULL, NULL, NULL, NULL, 'PROTEIN LONGIFOLIA 1-LIKE', 249402),
(393443, 'PTHR31680:SF21', NULL, NULL, NULL, NULL, 'DUF4378 DOMAIN-CONTAINING PROTEIN', 249402),
(393444, 'PTHR31680:SF22', NULL, NULL, NULL, NULL, 'PROTEIN LONGIFOLIA 1', 249402),
(393445, 'PTHR31680:SF11', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249402),
(393446, 'PTHR31680:SF4', NULL, NULL, NULL, NULL, 'LONGIFOLIA PROTEIN', 249402),
(393447, 'PTHR31680', NULL, NULL, NULL, NULL, 'LONGIFOLIA PROTEIN', 249402),
(393448, 'PTHR31680:SF7', NULL, NULL, NULL, NULL, 'PROTEIN LONGIFOLIA 2', 249402),
(393449, 'PTHR31680:SF8', NULL, NULL, NULL, NULL, 'LONGIFOLIA PROTEIN', 249402),
(393450, 'PTHR31680:SF9', NULL, NULL, NULL, NULL, 'LONGIFOLIA PROTEIN', 249402),
(393451, 'PTHR13874:SF10', NULL, NULL, NULL, NULL, 'ENDOTHELIN-1', 249403),
(393452, 'PTHR13874:SF9', NULL, NULL, NULL, NULL, 'ENDOTHELIN-2', 249403),
(393453, 'PTHR13874', NULL, NULL, NULL, NULL, 'ENDOTHELIN', 249403),
(393454, 'PTHR13874:SF11', NULL, NULL, NULL, NULL, 'ENDOTHELIN-3', 249403),
(393455, 'PTHR13874:SF12', NULL, NULL, NULL, NULL, 'ENDOTHELIN-3A', 249403),
(393456, 'PTHR19924:SF26', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RNA-ASSOCIATED PROTEIN 15 HOMOLOG', 249404),
(393457, 'PTHR19924:SF27', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 249404),
(393458, 'PTHR19924', NULL, NULL, NULL, NULL, 'UTP15 U3 SMALL NUCLEOLAR RNA-ASSOCIATED PROTEIN 15 FAMILY MEMBER', 249404),
(393459, 'PTHR19924:SF31', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN JIP5', 249404),
(393460, 'PTHR31649:SF11', NULL, NULL, NULL, NULL, 'PROTEIN UNZIPPED', 249405),
(393461, 'PTHR31649:SF10', NULL, NULL, NULL, NULL, 'DUF3421 DOMAIN-CONTAINING PROTEIN-RELATED', 249405),
(393462, 'PTHR31649', NULL, NULL, NULL, NULL, 'AGAP009604-PA', 249405),
(393463, 'PTHR31649:SF1', NULL, NULL, NULL, NULL, 'DUF3421 DOMAIN-CONTAINING PROTEIN', 249405),
(393464, 'PTHR13104:SF0', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 6', 249406),
(393465, 'PTHR13104:SF1', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RNA (SNRNA) ASSOCIATED PROTEIN', 249406),
(393466, 'PTHR13104:SF2', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 6', 249406);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(393467, 'PTHR13104', NULL, NULL, NULL, NULL, 'MED-6-RELATED', 249406),
(393468, 'PTHR46231:SF1', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND BTB/POZ DOMAIN-CONTAINING PROTEIN 1', 249407),
(393469, 'PTHR46231', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND BTB/POZ DOMAIN-CONTAINING PROTEIN 1', 249407),
(393470, 'PTHR33526:SF30', NULL, NULL, NULL, NULL, '', 249408),
(393471, 'PTHR33526:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249408),
(393472, 'PTHR33526:SF6', NULL, NULL, NULL, NULL, '', 249408),
(393473, 'PTHR33526', NULL, NULL, NULL, NULL, 'OS07G0123800 PROTEIN', 249408),
(393474, 'PTHR33526:SF39', NULL, NULL, NULL, NULL, '', 249408),
(393475, 'PTHR33526:SF29', NULL, NULL, NULL, NULL, 'BNACNNG24890D PROTEIN', 249408),
(393476, 'PTHR33526:SF19', NULL, NULL, NULL, NULL, 'OS01G0766300 PROTEIN', 249408),
(393477, 'PTHR33526:SF4', NULL, NULL, NULL, NULL, 'OS07G0123800 PROTEIN', 249408),
(393478, 'PTHR33526:SF13', NULL, NULL, NULL, NULL, 'BNAC08G42370D PROTEIN', 249408),
(393479, 'PTHR33526:SF24', NULL, NULL, NULL, NULL, 'BNAC08G14010D PROTEIN', 249408),
(393480, 'PTHR33526:SF36', NULL, NULL, NULL, NULL, '', 249408),
(393481, 'PTHR33526:SF14', NULL, NULL, NULL, NULL, 'OS05G0512100 PROTEIN', 249408),
(393482, 'PTHR33526:SF25', NULL, NULL, NULL, NULL, '', 249408),
(393483, 'PTHR33526:SF26', NULL, NULL, NULL, NULL, 'BNAA06G24870D PROTEIN', 249408),
(393484, 'PTHR33526:SF37', NULL, NULL, NULL, NULL, 'BNAC03G48710D PROTEIN', 249408),
(393485, 'PTHR33526:SF27', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249408),
(393486, 'PTHR33526:SF38', NULL, NULL, NULL, NULL, 'BNAC02G16830D PROTEIN', 249408),
(393487, 'PTHR33526:SF20', NULL, NULL, NULL, NULL, '', 249408),
(393488, 'PTHR33526:SF31', NULL, NULL, NULL, NULL, 'BNAC09G15340D PROTEIN', 249408),
(393489, 'PTHR33526:SF21', NULL, NULL, NULL, NULL, '', 249408),
(393490, 'PTHR11258:SF14', NULL, NULL, NULL, NULL, '2'',5''-OLIGOADENYLATE SYNTHETASE-LIKE 6', 249409),
(393491, 'PTHR11258:SF13', NULL, NULL, NULL, NULL, '2''-5''-OLIGOADENYLATE SYNTHASE 1', 249409),
(393492, 'PTHR11258:SF7', NULL, NULL, NULL, NULL, '2''-5''-OLIGOADENYLATE SYNTHASE-LIKE PROTEIN 2', 249409),
(393493, 'PTHR11258:SF16', NULL, NULL, NULL, NULL, '2''-5''-OLIGOADENYLATE SYNTHASE-LIKE PROTEIN', 249409),
(393494, 'PTHR11258:SF17', NULL, NULL, NULL, NULL, '2''-5'' OLIGOADENYLATE SYNTHETASE 1E-RELATED', 249409),
(393495, 'PTHR11258:SF19', NULL, NULL, NULL, NULL, 'INACTIVE 2''-5''-OLIGOADENYLATE SYNTHASE 1B', 249409),
(393496, 'PTHR11258', NULL, NULL, NULL, NULL, '2-5 OLIGOADENYLATE SYNTHETASE', 249409),
(393497, 'PTHR11258:SF21', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 249409),
(393498, 'PTHR11258:SF3', NULL, NULL, NULL, NULL, '2''-5''-OLIGOADENYLATE SYNTHASE 2', 249409),
(393499, 'PTHR11258:SF4', NULL, NULL, NULL, NULL, '2''-5''-OLIGOADENYLATE SYNTHASE 3', 249409),
(393500, 'PTHR11258:SF11', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 249409),
(393501, 'PTHR32019', NULL, NULL, NULL, NULL, 'R3H DOMAIN-CONTAINING PROTEIN 4', 249410),
(393502, 'PTHR32019:SF2', NULL, NULL, NULL, NULL, 'R3H DOMAIN-CONTAINING PROTEIN 4', 249410),
(393503, 'PTHR21426:SF17', NULL, NULL, NULL, NULL, 'OS07G0200000 PROTEIN', 249411),
(393504, 'PTHR21426', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT 8', 249411),
(393505, 'PTHR21426:SF18', NULL, NULL, NULL, NULL, 'EXO84_C DOMAIN-CONTAINING PROTEIN', 249411),
(393506, 'PTHR21426:SF2', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT EXO84C', 249411),
(393507, 'PTHR21426:SF12', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT 8', 249411),
(393508, 'PTHR21426:SF13', NULL, NULL, NULL, NULL, 'OS08G0566700 PROTEIN', 249411),
(393509, 'PTHR21426:SF15', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT EXO84A', 249411),
(393510, 'PTHR37984:SF4', NULL, NULL, NULL, NULL, '', 249412),
(393511, 'PTHR37984:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG26694', 249412),
(393512, 'PTHR37984:SF3', NULL, NULL, NULL, NULL, '', 249412),
(393513, 'PTHR37984:SF6', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 249412);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(393514, 'PTHR37984', NULL, NULL, NULL, NULL, 'PROTEIN CBG26694', 249412),
(393515, 'PTHR47333', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR C AND EGF DOMAIN-CONTAINING PROTEIN', 249413),
(393516, 'PTHR47333:SF1', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR C AND EGF DOMAIN-CONTAINING PROTEIN', 249413),
(393517, 'PTHR32017', NULL, NULL, NULL, NULL, 'SPINDLE AND KINETOCHORE-ASSOCIATED PROTEIN 2', 249414),
(393518, 'PTHR32017:SF3', NULL, NULL, NULL, NULL, 'SPINDLE AND KINETOCHORE-ASSOCIATED PROTEIN 2', 249414),
(393519, 'PTHR45772:SF1', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN', 249415),
(393520, 'PTHR45772:SF10', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE EXPORT SYSTEM ATP-BINDING PROTEIN LPTB', 249415),
(393521, 'PTHR45772:SF11', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY BRANCHED-CHAIN AMINO ACID TRANSPORT ATP-BINDING PROTEIN LIVG', 249415),
(393522, 'PTHR45772:SF9', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN AMINO ACID TRANSPORT ATP-BINDING PROTEIN', 249415),
(393523, 'PTHR45772:SF8', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY BRANCHED-CHAIN AMINO ACID TRANSPORT ATP-BINDING PROTEIN', 249415),
(393524, 'PTHR45772:SF7', NULL, NULL, NULL, NULL, 'AMINO ACID ABC TRANSPORTER ATP-BINDING PROTEIN', 249415),
(393525, 'PTHR45772', NULL, NULL, NULL, NULL, 'CONSERVED COMPONENT OF ABC TRANSPORTER FOR NATURAL AMINO ACIDS-RELATED', 249415),
(393526, 'PTHR45772:SF5', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN AMINO ACID TRANSPORT ATP-BINDING PROTEIN LIVG-RELATED', 249415),
(393527, 'PTHR45772:SF4', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN', 249415),
(393528, 'PTHR45772:SF3', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN', 249415),
(393529, 'PTHR45772:SF2', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING/PERMEASE PROTEIN', 249415),
(393530, 'PTHR45868:SF61', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORT/DETOXIFICATION DOMAIN PROTEIN', 249416),
(393531, 'PTHR45868:SF62', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 249416),
(393532, 'PTHR45868:SF63', NULL, NULL, NULL, NULL, 'GJ16813', 249416),
(393533, 'PTHR45868:SF13', NULL, NULL, NULL, NULL, '', 249416),
(393534, 'PTHR45868:SF57', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED DOMAIN, HMA-RELATED', 249416),
(393535, 'PTHR45868:SF14', NULL, NULL, NULL, NULL, 'OS08G0205500 PROTEIN', 249416),
(393536, 'PTHR45868:SF53', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 249416),
(393537, 'PTHR45868:SF97', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED DOMAIN, HMA, ARMADILLO-TYPE FOLD PROTEIN-RELATED', 249416),
(393538, 'PTHR45868:SF10', NULL, NULL, NULL, NULL, 'OS07G0671400 PROTEIN', 249416),
(393539, 'PTHR45868:SF98', NULL, NULL, NULL, NULL, 'OS05G0368600 PROTEIN', 249416),
(393540, 'PTHR45868:SF99', NULL, NULL, NULL, NULL, '', 249416),
(393541, 'PTHR45868:SF9', NULL, NULL, NULL, NULL, 'OS01G0933200 PROTEIN', 249416),
(393542, 'PTHR45868:SF19', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 37', 249416),
(393543, 'PTHR45868:SF71', NULL, NULL, NULL, NULL, 'COPPER-BINDING FAMILY PROTEIN', 249416),
(393544, 'PTHR45868:SF72', NULL, NULL, NULL, NULL, 'METAL TRANSPORT/DETOXIFICATION SUPERFAMILY PROTEIN, PUTATIVE-RELATED', 249416),
(393545, 'PTHR45868:SF74', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 33', 249416),
(393546, 'PTHR45868:SF70', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE CLKA-RELATED', 249416),
(393547, 'PTHR45868:SF69', NULL, NULL, NULL, NULL, 'F15K9.8-RELATED', 249416),
(393548, 'PTHR45868:SF64', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 249416),
(393549, 'PTHR45868:SF65', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORT/DETOXIFICATION SUPERFAMILY PROTEIN', 249416),
(393550, 'PTHR45868:SF22', NULL, NULL, NULL, NULL, 'METAL ION-BINDING PROTEIN', 249416),
(393551, 'PTHR45868:SF66', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 249416),
(393552, 'PTHR45868:SF82', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORT/DETOXIFICATION SUPERFAMILY PROTEIN', 249416),
(393553, 'PTHR45868:SF83', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 249416);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(393554, 'PTHR45868:SF84', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 249416),
(393555, 'PTHR45868:SF85', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 32', 249416),
(393556, 'PTHR45868:SF80', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 249416),
(393557, 'PTHR45868:SF81', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORT/DETOXIFICATION PROTEIN', 249416),
(393558, 'PTHR45868:SF35', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 249416),
(393559, 'PTHR45868:SF79', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 34', 249416),
(393560, 'PTHR45868:SF37', NULL, NULL, NULL, NULL, 'BNAC05G26330D PROTEIN', 249416),
(393561, 'PTHR45868:SF76', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED DOMAIN, HMA-RELATED', 249416),
(393562, 'PTHR45868:SF32', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 249416),
(393563, 'PTHR45868:SF77', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORT/DETOXIFICATION SUPERFAMILY PROTEIN', 249416),
(393564, 'PTHR45868', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 33-RELATED', 249416),
(393565, 'PTHR45868:SF93', NULL, NULL, NULL, NULL, 'OS12G0144600 PROTEIN', 249416),
(393566, 'PTHR45868:SF94', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 249416),
(393567, 'PTHR45868:SF95', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 35', 249416),
(393568, 'PTHR45868:SF96', NULL, NULL, NULL, NULL, 'BNAA02G09010D PROTEIN', 249416),
(393569, 'PTHR45868:SF90', NULL, NULL, NULL, NULL, '', 249416),
(393570, 'PTHR45868:SF91', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORT/DETOXIFICATION DOMAIN PROTEIN', 249416),
(393571, 'PTHR45868:SF92', NULL, NULL, NULL, NULL, '', 249416),
(393572, 'PTHR45868:SF47', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 42', 249416),
(393573, 'PTHR45868:SF48', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 249416),
(393574, 'PTHR45868:SF86', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 249416),
(393575, 'PTHR45868:SF42', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORT/DETOXIFICATION SUPERFAMILY PROTEIN', 249416),
(393576, 'PTHR45868:SF87', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 249416),
(393577, 'PTHR45868:SF88', NULL, NULL, NULL, NULL, 'KERATIN, TYPE I CYTOSKELETAL 9', 249416),
(393578, 'PTHR45868:SF89', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 249416),
(393579, 'PTHR14352', NULL, NULL, NULL, NULL, 'HAUS AUGMIN-LIKE COMPLEX SUBUNIT 7', 249417),
(393580, 'PTHR14352:SF2', NULL, NULL, NULL, NULL, 'HAUS AUGMIN-LIKE COMPLEX SUBUNIT 7', 249417),
(393581, 'PTHR37976:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG16925', 249418),
(393582, 'PTHR37976:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG16926', 249418),
(393583, 'PTHR37976:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG16927', 249418),
(393584, 'PTHR37976', NULL, NULL, NULL, NULL, 'PROTEIN CBG16927', 249418),
(393585, 'PTHR31104:SF3', NULL, NULL, NULL, NULL, 'OS01G0208400 PROTEIN', 249419),
(393586, 'PTHR31104:SF1', NULL, NULL, NULL, NULL, 'PEPTIDE-N4-(N-ACETYL-BETA-GLUCOSAMINYL)ASPARAGINE AMIDASE A PROTEIN', 249419),
(393587, 'PTHR31104', NULL, NULL, NULL, NULL, 'PEPTIDE-N4-(N-ACETYL-BETA-GLUCOSAMINYL)ASPARAGINE AMIDASE A PROTEIN', 249419),
(393588, 'PTHR31104:SF15', NULL, NULL, NULL, NULL, 'PEPTIDE-N4-(N-ACETYL-BETA- GLUCOSAMINYL)ASPARAGINE AMIDASE A-LIKE', 249419),
(393589, 'PTHR31104:SF6', NULL, NULL, NULL, NULL, '', 249419),
(393590, 'PTHR31104:SF16', NULL, NULL, NULL, NULL, 'PEPTIDE-N4-(N-ACETYL-BETA- GLUCOSAMINYL)ASPARAGINE AMIDASE A-LIKE', 249419),
(393591, 'PTHR31104:SF4', NULL, NULL, NULL, NULL, 'PEPTIDE-N4-(N-ACETYL-BETA-GLUCOSAMINYL)ASPARAGINE AMIDASE A PROTEIN', 249419),
(393592, 'PTHR31104:SF17', NULL, NULL, NULL, NULL, '', 249419),
(393593, 'PTHR31104:SF5', NULL, NULL, NULL, NULL, 'OS05G0395000 PROTEIN', 249419),
(393594, 'PTHR31104:SF19', NULL, NULL, NULL, NULL, 'AMIDASE A, PUTATIVE-RELATED', 249419),
(393595, 'PTHR31104:SF20', NULL, NULL, NULL, NULL, 'PEPTIDE-N4-(N-ACETYL-BETA-GLUCOSAMINYL)ASPARAGINE AMIDASE A', 249419);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(393596, 'PTHR31104:SF21', NULL, NULL, NULL, NULL, 'PEPTIDE-N4-(N-ACETYL-BETA- GLUCOSAMINYL)ASPARAGINE AMIDASE A-LIKE', 249419),
(393597, 'PTHR31104:SF22', NULL, NULL, NULL, NULL, 'PEPTIDE-N4-(N-ACETYL-BETA- GLUCOSAMINYL)ASPARAGINE AMIDASE A-LIKE', 249419),
(393598, 'PTHR31104:SF14', NULL, NULL, NULL, NULL, '', 249419),
(393599, 'PTHR37539', NULL, NULL, NULL, NULL, 'SECRETED PROTEIN-RELATED', 249420),
(393600, 'PTHR37539:SF1', NULL, NULL, NULL, NULL, 'DUF2236 DOMAIN-CONTAINING PROTEIN', 249420),
(393601, 'PTHR37686', NULL, NULL, NULL, NULL, 'LD36006P', 249421),
(393602, 'PTHR37686:SF1', NULL, NULL, NULL, NULL, 'LD36006P', 249421),
(393603, 'PTHR43649', NULL, NULL, NULL, NULL, 'ARABINOSE-BINDING PROTEIN-RELATED', 249422),
(393604, 'PTHR43649:SF20', NULL, NULL, NULL, NULL, 'BLL4138 PROTEIN', 249422),
(393605, 'PTHR43649:SF22', NULL, NULL, NULL, NULL, 'DIACETYLCHITOBIOSE BINDING PROTEIN DASA', 249422),
(393606, 'PTHR43649:SF11', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER SUBSTRATE-BINDING PROTEIN YESO-RELATED', 249422),
(393607, 'PTHR43649:SF24', NULL, NULL, NULL, NULL, 'GLUCOSE-BINDING PROTEIN GLCS', 249422),
(393608, 'PTHR43649:SF13', NULL, NULL, NULL, NULL, 'SOLUTE-BINDING PROTEIN-RELATED', 249422),
(393609, 'PTHR43649:SF23', NULL, NULL, NULL, NULL, 'SN-GLYCEROL-3-PHOSPHATE-BINDING PERIPLASMIC PROTEIN UGPB', 249422),
(393610, 'PTHR43649:SF12', NULL, NULL, NULL, NULL, 'ARABINOOLIGOSACCHARIDE-BINDING PROTEIN', 249422),
(393611, 'PTHR43649:SF26', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER SUBSTRATE-BINDING PROTEIN', 249422),
(393612, 'PTHR43649:SF25', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERIPLASMIC-BINDING PROTEIN YCJN-RELATED', 249422),
(393613, 'PTHR43649:SF14', NULL, NULL, NULL, NULL, 'BLR3389 PROTEIN', 249422),
(393614, 'PTHR43649:SF17', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER SOLUTE BINDING PROTEIN-SUGAR TRANSPORT', 249422),
(393615, 'PTHR43649:SF5', NULL, NULL, NULL, NULL, 'SRRA', 249422),
(393616, 'PTHR43649:SF16', NULL, NULL, NULL, NULL, 'SUGAR-BINDING LIPOPROTEIN-RELATED', 249422),
(393617, 'PTHR43649:SF6', NULL, NULL, NULL, NULL, 'SLR1865 PROTEIN', 249422),
(393618, 'PTHR43649:SF27', NULL, NULL, NULL, NULL, 'EXTRACELLULAR SOLUTE-BINDING PROTEIN FAMILY 1', 249422),
(393619, 'PTHR43649:SF7', NULL, NULL, NULL, NULL, 'OSMOPROTECTIVE COMPOUNDS-BINDING PROTEIN GGTB', 249422),
(393620, 'PTHR15462', NULL, NULL, NULL, NULL, 'SERINE PROTEASE', 249423),
(393621, 'PTHR15462:SF19', NULL, NULL, NULL, NULL, 'SECRETED PROTEIN-RELATED', 249423),
(393622, 'PTHR15462:SF17', NULL, NULL, NULL, NULL, 'INACTIVE SERINE PROTEASE 35', 249423),
(393623, 'PTHR15462:SF9', NULL, NULL, NULL, NULL, 'SERINE PROTEASE', 249423),
(393624, 'PTHR15462:SF10', NULL, NULL, NULL, NULL, 'SERINE PROTEASE 23', 249423),
(393625, 'PTHR15462:SF8', NULL, NULL, NULL, NULL, 'SERINE PROTEASE', 249423),
(393626, 'PTHR34374:SF1', NULL, NULL, NULL, NULL, 'LARGE RIBOSOMAL RNA SUBUNIT ACCUMULATION PROTEIN YCED HOMOLOG 1, CHLOROPLASTIC', 249424),
(393627, 'PTHR34374', NULL, NULL, NULL, NULL, 'LARGE RIBOSOMAL RNA SUBUNIT ACCUMULATION PROTEIN YCED HOMOLOG 1, CHLOROPLASTIC', 249424),
(393628, 'PTHR46622:SF1', NULL, NULL, NULL, NULL, 'DNA-DEPENDENT METALLOPROTEASE WSS1', 249425),
(393629, 'PTHR46622:SF3', NULL, NULL, NULL, NULL, 'ZINC ION BINDING PROTEIN', 249425),
(393630, 'PTHR46622', NULL, NULL, NULL, NULL, 'DNA-DEPENDENT METALLOPROTEASE WSS1', 249425),
(393631, 'PTHR37235', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE AUREOLYSIN', 249426),
(393632, 'PTHR37235:SF2', NULL, NULL, NULL, NULL, 'OS05G0371500 PROTEIN', 249426),
(393633, 'PTHR11750:SF26', NULL, NULL, NULL, NULL, 'PROTEIN N-TERMINAL AMIDASE', 249427),
(393634, 'PTHR11750', NULL, NULL, NULL, NULL, 'PROTEIN N-TERMINAL AMIDASE', 249427),
(393635, 'PTHR21453:SF3', NULL, NULL, NULL, NULL, 'DUF281 DOMAIN-CONTAINING PROTEIN-RELATED', 249428),
(393636, 'PTHR21453:SF7', NULL, NULL, NULL, NULL, 'DUF19 DOMAIN-CONTAINING PROTEIN', 249428),
(393637, 'PTHR21453:SF4', NULL, NULL, NULL, NULL, 'DUF19 DOMAIN-CONTAINING PROTEIN', 249428),
(393638, 'PTHR21453', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 249428);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(393639, 'PTHR21453:SF28', NULL, NULL, NULL, NULL, 'DUF19 DOMAIN-CONTAINING PROTEIN-RELATED', 249428),
(393640, 'PTHR21453:SF29', NULL, NULL, NULL, NULL, 'DUF19 DOMAIN-CONTAINING PROTEIN', 249428),
(393641, 'PTHR21453:SF11', NULL, NULL, NULL, NULL, 'DUF19 DOMAIN-CONTAINING PROTEIN', 249428),
(393642, 'PTHR21453:SF13', NULL, NULL, NULL, NULL, 'DUF19 DOMAIN-CONTAINING PROTEIN', 249428),
(393643, 'PTHR21453:SF14', NULL, NULL, NULL, NULL, 'DUF19 DOMAIN-CONTAINING PROTEIN', 249428),
(393644, 'PTHR21453:SF30', NULL, NULL, NULL, NULL, 'DUF19 DOMAIN-CONTAINING PROTEIN', 249428),
(393645, 'PTHR21453:SF31', NULL, NULL, NULL, NULL, 'DUF19 DOMAIN-CONTAINING PROTEIN', 249428),
(393646, 'PTHR21453:SF9', NULL, NULL, NULL, NULL, 'DUF19 DOMAIN-CONTAINING PROTEIN', 249428),
(393647, 'PTHR21453:SF10', NULL, NULL, NULL, NULL, 'DUF19 DOMAIN-CONTAINING PROTEIN', 249428),
(393648, 'PTHR21453:SF8', NULL, NULL, NULL, NULL, 'DUF19 DOMAIN-CONTAINING PROTEIN', 249428),
(393649, 'PTHR45952:SF2', NULL, NULL, NULL, NULL, 'OS04G0679400 PROTEIN', 249429),
(393650, 'PTHR45952:SF5', NULL, NULL, NULL, NULL, 'ALUMINUM INDUCED PROTEIN WITH YGL AND LRDR MOTIFS', 249429),
(393651, 'PTHR45952:SF4', NULL, NULL, NULL, NULL, 'ALUMINUM INDUCED PROTEIN WITH YGL AND LRDR MOTIFS', 249429),
(393652, 'PTHR45952', NULL, NULL, NULL, NULL, 'ALUMINUM INDUCED PROTEIN WITH YGL AND LRDR MOTIFS', 249429),
(393653, 'PTHR45952:SF11', NULL, NULL, NULL, NULL, 'ALUMINUM INDUCED PROTEIN WITH YGL AND LRDR MOTIFS', 249429),
(393654, 'PTHR45952:SF12', NULL, NULL, NULL, NULL, 'STEM-SPECIFIC PROTEIN TSJT1-LIKE', 249429),
(393655, 'PTHR45952:SF20', NULL, NULL, NULL, NULL, 'DUF3700 DOMAIN-CONTAINING PROTEIN', 249429),
(393656, 'PTHR45952:SF21', NULL, NULL, NULL, NULL, 'DUF3700 DOMAIN-CONTAINING PROTEIN', 249429),
(393657, 'PTHR45952:SF10', NULL, NULL, NULL, NULL, 'ALUMINUM INDUCED PROTEIN WITH YGL AND LRDR MOTIF PROTEIN', 249429),
(393658, 'PTHR45952:SF15', NULL, NULL, NULL, NULL, 'NUCLEOPHILE AMINOHYDROLASE-RELATED', 249429),
(393659, 'PTHR45952:SF7', NULL, NULL, NULL, NULL, 'DUF3700 DOMAIN-CONTAINING PROTEIN', 249429),
(393660, 'PTHR45952:SF16', NULL, NULL, NULL, NULL, 'DUF3700 DOMAIN-CONTAINING PROTEIN', 249429),
(393661, 'PTHR45952:SF6', NULL, NULL, NULL, NULL, 'DUF3700 DOMAIN-CONTAINING PROTEIN', 249429),
(393662, 'PTHR45952:SF13', NULL, NULL, NULL, NULL, 'STEM-SPECIFIC PROTEIN TSJT1-LIKE', 249429),
(393663, 'PTHR45952:SF14', NULL, NULL, NULL, NULL, 'DUF3700 DOMAIN-CONTAINING PROTEIN', 249429),
(393664, 'PTHR45952:SF8', NULL, NULL, NULL, NULL, 'STEM-SPECIFIC PROTEIN TSJT1', 249429),
(393665, 'PTHR45952:SF19', NULL, NULL, NULL, NULL, 'ALUMINUM INDUCED PROTEIN WITH YGL AND LRDR MOTIFS', 249429),
(393666, 'PTHR45952:SF18', NULL, NULL, NULL, NULL, 'DUF3700 DOMAIN-CONTAINING PROTEIN', 249429),
(393667, 'PTHR34120:SF18', NULL, NULL, NULL, NULL, '', 249430),
(393668, 'PTHR34120:SF27', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-DEPENDENT PROTEIN KINASE-RELATED', 249430),
(393669, 'PTHR34120:SF17', NULL, NULL, NULL, NULL, '', 249430),
(393670, 'PTHR34120:SF25', NULL, NULL, NULL, NULL, '', 249430),
(393671, 'PTHR34120:SF26', NULL, NULL, NULL, NULL, '', 249430),
(393672, 'PTHR34120:SF15', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN PROTEIN KINASE', 249430),
(393673, 'PTHR34120:SF23', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249430),
(393674, 'PTHR34120:SF13', NULL, NULL, NULL, NULL, 'OS02G0533700 PROTEIN', 249430),
(393675, 'PTHR34120:SF3', NULL, NULL, NULL, NULL, 'OS04G0412700 PROTEIN', 249430),
(393676, 'PTHR34120:SF24', NULL, NULL, NULL, NULL, 'BNAANNG07550D PROTEIN', 249430),
(393677, 'PTHR34120:SF10', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN PROTEIN KINASE', 249430),
(393678, 'PTHR34120:SF2', NULL, NULL, NULL, NULL, 'OS01G0860900 PROTEIN', 249430),
(393679, 'PTHR34120:SF11', NULL, NULL, NULL, NULL, '', 249430),
(393680, 'PTHR34120', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249430),
(393681, 'PTHR34120:SF9', NULL, NULL, NULL, NULL, '', 249430),
(393682, 'PTHR34858:SF1', NULL, NULL, NULL, NULL, 'CYSO-CYSTEINE PEPTIDASE', 249431),
(393683, 'PTHR34858', NULL, NULL, NULL, NULL, 'CYSO-CYSTEINE PEPTIDASE', 249431);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(393684, 'PTHR35673', NULL, NULL, NULL, NULL, 'UPF0500 PROTEIN C1ORF216', 249432),
(393685, 'PTHR35673:SF1', NULL, NULL, NULL, NULL, 'UPF0500 PROTEIN C1ORF216', 249432),
(393686, 'PTHR46134:SF5', NULL, NULL, NULL, NULL, 'ARFGAP WITH FG REPEATS 1B', 249433),
(393687, 'PTHR46134:SF4', NULL, NULL, NULL, NULL, 'ARF-GAP DOMAIN AND FG REPEAT-CONTAINING PROTEIN 2', 249433),
(393688, 'PTHR46134:SF3', NULL, NULL, NULL, NULL, 'DRONGO, ISOFORM F', 249433),
(393689, 'PTHR46134', NULL, NULL, NULL, NULL, 'DRONGO, ISOFORM F', 249433),
(393690, 'PTHR46134:SF1', NULL, NULL, NULL, NULL, 'ARF-GAP DOMAIN AND FG REPEAT-CONTAINING PROTEIN 1', 249433),
(393691, 'PTHR31419:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PIN-LIKES 6', 249434),
(393692, 'PTHR31419:SF13', NULL, NULL, NULL, NULL, '', 249434),
(393693, 'PTHR31419:SF2', NULL, NULL, NULL, NULL, 'PROTEIN PIN-LIKES 2', 249434),
(393694, 'PTHR31419:SF11', NULL, NULL, NULL, NULL, 'BNAANNG15560D PROTEIN', 249434),
(393695, 'PTHR31419', NULL, NULL, NULL, NULL, 'PROTEIN PIN-LIKES 2', 249434),
(393696, 'PTHR31419:SF8', NULL, NULL, NULL, NULL, 'PROTEIN PIN-LIKES 2-LIKE', 249434),
(393697, 'PTHR31419:SF9', NULL, NULL, NULL, NULL, '', 249434),
(393698, 'PTHR46921', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 21', 249435),
(393699, 'PTHR46921:SF1', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 21', 249435),
(393700, 'PTHR15377:SF3', NULL, NULL, NULL, NULL, 'WW DOMAIN-CONTAINING PROTEIN', 249436),
(393701, 'PTHR15377:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION REGULATOR 1', 249436),
(393702, 'PTHR15377:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION REGULATOR 1-LIKE PROTEIN', 249436),
(393703, 'PTHR15377', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION REGULATOR 1', 249436),
(393704, 'PTHR43485:SF1', NULL, NULL, NULL, NULL, 'FORMATE HYDROGENLYASE SUBUNIT 5-RELATED', 249437),
(393705, 'PTHR43485', NULL, NULL, NULL, NULL, 'HYDROGENASE-4 COMPONENT G', 249437),
(393706, 'PTHR31069:SF31', NULL, NULL, NULL, NULL, 'ARGININE METABOLISM REGULATION PROTEIN II', 249438),
(393707, 'PTHR31069:SF21', NULL, NULL, NULL, NULL, 'CHROMATIN STRUCTURE-REMODELING COMPLEX PROTEIN RSC3-RELATED', 249438),
(393708, 'PTHR31069:SF22', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249438),
(393709, 'PTHR31069:SF12', NULL, NULL, NULL, NULL, 'THIAMINE BIOSYNTHESIS REGULATORY PROTEIN', 249438),
(393710, 'PTHR31069:SF30', NULL, NULL, NULL, NULL, 'OLEATE ACTIVATED TRANSCRIPTION FACTOR 3', 249438),
(393711, 'PTHR31069:SF28', NULL, NULL, NULL, NULL, 'ZN(2)-C6 FUNGAL-TYPE DOMAIN-CONTAINING PROTEIN', 249438),
(393712, 'PTHR31069:SF29', NULL, NULL, NULL, NULL, 'OLEATE-ACTIVATED TRANSCRIPTION FACTOR 1-RELATED', 249438),
(393713, 'PTHR31069:SF25', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249438),
(393714, 'PTHR31069', NULL, NULL, NULL, NULL, 'OLEATE-ACTIVATED TRANSCRIPTION FACTOR 1-RELATED', 249438),
(393715, 'PTHR31069:SF26', NULL, NULL, NULL, NULL, 'ZN(2)-C6 FUNGAL-TYPE DOMAIN-CONTAINING PROTEIN', 249438),
(393716, 'PTHR31069:SF27', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR ALNR-RELATED', 249438),
(393717, 'PTHR33026:SF7', NULL, NULL, NULL, NULL, 'OS03G0100275 PROTEIN', 249439),
(393718, 'PTHR33026:SF6', NULL, NULL, NULL, NULL, '', 249439),
(393719, 'PTHR33026', NULL, NULL, NULL, NULL, 'OS06G0360600 PROTEIN', 249439),
(393720, 'PTHR14043:SF17', NULL, NULL, NULL, NULL, 'PROTEIN CASP', 249440),
(393721, 'PTHR14043', NULL, NULL, NULL, NULL, 'CCAAT DISPLACEMENT PROTEIN-RELATED', 249440),
(393722, 'PTHR14043:SF15', NULL, NULL, NULL, NULL, 'PROTEIN CASP', 249440),
(393723, 'PTHR14043:SF4', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN CUT-LIKE 1', 249440),
(393724, 'PTHR14043:SF5', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN CUT-LIKE 2', 249440),
(393725, 'PTHR14043:SF2', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN CUT', 249440),
(393726, 'PTHR43077:SF9', NULL, NULL, NULL, NULL, 'TRANSPORT PERMEASE YVFS-RELATED', 249441),
(393727, 'PTHR43077:SF8', NULL, NULL, NULL, NULL, 'DOXORUBICIN RESISTANCE ABC TRANSPORTER PERMEASE PROTEIN DRRB', 249441);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(393728, 'PTHR43077:SF5', NULL, NULL, NULL, NULL, 'PHAGE INFECTION PROTEIN', 249441),
(393729, 'PTHR43077:SF10', NULL, NULL, NULL, NULL, 'TRANSPORT PERMEASE PROTEIN', 249441),
(393730, 'PTHR43077', NULL, NULL, NULL, NULL, 'TRANSPORT PERMEASE YVFS-RELATED', 249441),
(393731, 'PTHR45994:SF1', NULL, NULL, NULL, NULL, 'FI21225P1', 249442),
(393732, 'PTHR45994:SF3', NULL, NULL, NULL, NULL, 'PROTEIN UNC-45 HOMOLOG A', 249442),
(393733, 'PTHR45994:SF2', NULL, NULL, NULL, NULL, 'PROTEIN UNC-45 HOMOLOG B', 249442),
(393734, 'PTHR45994', NULL, NULL, NULL, NULL, 'FI21225P1', 249442),
(393735, 'PTHR47706', NULL, NULL, NULL, NULL, 'NMRA-LIKE FAMILY PROTEIN', 249443),
(393736, 'PTHR47706:SF9', NULL, NULL, NULL, NULL, 'NMRA DOMAIN-CONTAINING PROTEIN-RELATED', 249443),
(393737, 'PTHR47706:SF8', NULL, NULL, NULL, NULL, 'NMRA DOMAIN-CONTAINING PROTEIN', 249443),
(393738, 'PTHR47706:SF7', NULL, NULL, NULL, NULL, 'CIPA-LIKE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G01630)-RELATED', 249443),
(393739, 'PTHR47706:SF6', NULL, NULL, NULL, NULL, 'NMRA-LIKE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_6G00280)', 249443),
(393740, 'PTHR47706:SF5', NULL, NULL, NULL, NULL, 'ISOFLAVONE REDUCTASE', 249443),
(393741, 'PTHR47706:SF4', NULL, NULL, NULL, NULL, 'NMRA DOMAIN-CONTAINING PROTEIN', 249443),
(393742, 'PTHR47706:SF11', NULL, NULL, NULL, NULL, 'ISOFLAVONE REDUCTASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_1G12510)', 249443),
(393743, 'PTHR47706:SF10', NULL, NULL, NULL, NULL, 'NMRA DOMAIN-CONTAINING PROTEIN', 249443),
(393744, 'PTHR47706:SF2', NULL, NULL, NULL, NULL, 'ISOFLAVONE REDUCTASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_2G05290)', 249443),
(393745, 'PTHR47706:SF1', NULL, NULL, NULL, NULL, 'CIPA-LIKE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G12460)-RELATED', 249443),
(393746, 'PTHR11711:SF329', NULL, NULL, NULL, NULL, '', 249444),
(393747, 'PTHR11711:SF449', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR 2', 249444),
(393748, 'PTHR11711:SF448', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE RECEPTOR SUBUNIT BETA', 249444),
(393749, 'PTHR11711:SF447', NULL, NULL, NULL, NULL, '', 249444),
(393750, 'PTHR11711:SF446', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR 2', 249444),
(393751, 'PTHR11711:SF368', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR', 249444),
(393752, 'PTHR11711:SF445', NULL, NULL, NULL, NULL, 'BNAC04G49910D PROTEIN', 249444),
(393753, 'PTHR11711:SF444', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR 1', 249444),
(393754, 'PTHR11711:SF323', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR 5', 249444),
(393755, 'PTHR11711', NULL, NULL, NULL, NULL, 'ADP RIBOSYLATION FACTOR-RELATED', 249444),
(393756, 'PTHR11711:SF21', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 6', 249444),
(393757, 'PTHR11711:SF443', NULL, NULL, NULL, NULL, 'RIBOSYLATION FACTOR 79F, PUTATIVE-RELATED', 249444),
(393758, 'PTHR11711:SF322', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR 6', 249444),
(393759, 'PTHR11711:SF366', NULL, NULL, NULL, NULL, '', 249444),
(393760, 'PTHR11711:SF442', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR 1-LIKE 2', 249444),
(393761, 'PTHR11711:SF441', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE RECEPTOR SUBUNIT BETA', 249444),
(393762, 'PTHR11711:SF440', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR 2-A', 249444),
(393763, 'PTHR11711:SF163', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM23', 249444),
(393764, 'PTHR11711:SF360', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR 2-LIKE ISOFORM X1', 249444),
(393765, 'PTHR11711:SF29', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 14', 249444),
(393766, 'PTHR11711:SF439', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR 1-LIKE 1', 249444),
(393767, 'PTHR11711:SF119', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 4C', 249444),
(393768, 'PTHR11711:SF438', NULL, NULL, NULL, NULL, '', 249444),
(393769, 'PTHR11711:SF437', NULL, NULL, NULL, NULL, 'ADP RIBOSYLATION FACTOR', 249444),
(393770, 'PTHR11711:SF436', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-RELATED', 249444),
(393771, 'PTHR11711:SF435', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR B1B', 249444);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(393772, 'PTHR11711:SF434', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR D', 249444),
(393773, 'PTHR11711:SF357', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR 1', 249444),
(393774, 'PTHR11711:SF433', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR 1', 249444),
(393775, 'PTHR11711:SF193', NULL, NULL, NULL, NULL, '', 249444),
(393776, 'PTHR11711:SF30', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR 1-RELATED', 249444),
(393777, 'PTHR11711:SF31', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE 5', 249444),
(393778, 'PTHR11711:SF432', NULL, NULL, NULL, NULL, 'BNAC06G24690D PROTEIN', 249444),
(393779, 'PTHR11711:SF156', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-RELATED', 249444),
(393780, 'PTHR11711:SF431', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR A1B-RELATED', 249444),
(393781, 'PTHR11711:SF353', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR F-RELATED', 249444),
(393782, 'PTHR11711:SF430', NULL, NULL, NULL, NULL, 'OS01G0265100 PROTEIN', 249444),
(393783, 'PTHR11711:SF396', NULL, NULL, NULL, NULL, 'FACTOR, PUTATIVE-RELATED', 249444),
(393784, 'PTHR11711:SF352', NULL, NULL, NULL, NULL, 'BNAA07G03830D PROTEIN', 249444),
(393785, 'PTHR11711:SF110', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR 4', 249444),
(393786, 'PTHR11711:SF393', NULL, NULL, NULL, NULL, 'BNAA01G19150D PROTEIN', 249444),
(393787, 'PTHR11711:SF392', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR 2', 249444),
(393788, 'PTHR11711:SF429', NULL, NULL, NULL, NULL, 'OS07G0223100 PROTEIN', 249444),
(393789, 'PTHR11711:SF428', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR 3', 249444),
(393790, 'PTHR11711:SF427', NULL, NULL, NULL, NULL, '', 249444),
(393791, 'PTHR11711:SF426', NULL, NULL, NULL, NULL, '', 249444),
(393792, 'PTHR11711:SF349', NULL, NULL, NULL, NULL, 'ARF6/ARFB-FAMILY SMALL GTPASE', 249444),
(393793, 'PTHR11711:SF227', NULL, NULL, NULL, NULL, 'FACTOR-LIKE PROTEIN, PUTATIVE-RELATED', 249444),
(393794, 'PTHR11711:SF348', NULL, NULL, NULL, NULL, '', 249444),
(393795, 'PTHR11711:SF425', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-RELATED', 249444),
(393796, 'PTHR11711:SF424', NULL, NULL, NULL, NULL, '', 249444),
(393797, 'PTHR11711:SF347', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 17', 249444),
(393798, 'PTHR11711:SF148', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 5C-RELATED', 249444),
(393799, 'PTHR11711:SF423', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR 2', 249444),
(393800, 'PTHR11711:SF103', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE 5C', 249444),
(393801, 'PTHR11711:SF147', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 5A', 249444),
(393802, 'PTHR11711:SF422', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR 3', 249444),
(393803, 'PTHR11711:SF389', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR 1-LIKE 2', 249444),
(393804, 'PTHR11711:SF380', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR 1 ISOFORM X1', 249444),
(393805, 'PTHR11711:SF41', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 1', 249444),
(393806, 'PTHR11711:SF421', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR 2-B', 249444),
(393807, 'PTHR11711:SF344', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR B1C', 249444),
(393808, 'PTHR11711:SF146', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 5B', 249444),
(393809, 'PTHR11711:SF101', NULL, NULL, NULL, NULL, 'FACTOR, PUTATIVE-RELATED', 249444),
(393810, 'PTHR11711:SF420', NULL, NULL, NULL, NULL, 'BNACNNG16950D PROTEIN', 249444),
(393811, 'PTHR11711:SF343', NULL, NULL, NULL, NULL, '', 249444),
(393812, 'PTHR11711:SF222', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR L', 249444),
(393813, 'PTHR11711:SF186', NULL, NULL, NULL, NULL, 'ADP RIBOSYLATION FACTOR-LIKE 4, ISOFORM B', 249444),
(393814, 'PTHR11711:SF418', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR', 249444),
(393815, 'PTHR11711:SF417', NULL, NULL, NULL, NULL, '', 249444),
(393816, 'PTHR11711:SF339', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR D1A-RELATED', 249444),
(393817, 'PTHR11711:SF338', NULL, NULL, NULL, NULL, 'OS06G0114200 PROTEIN', 249444);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(393818, 'PTHR11711:SF139', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 4A', 249444),
(393819, 'PTHR11711:SF335', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR B1B', 249444),
(393820, 'PTHR11711:SF137', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 4D', 249444),
(393821, 'PTHR11711:SF334', NULL, NULL, NULL, NULL, '', 249444),
(393822, 'PTHR11711:SF377', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR 1', 249444),
(393823, 'PTHR11711:SF452', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR 1-LIKE ISOFORM X2', 249444),
(393824, 'PTHR11711:SF451', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE RECEPTOR SUBUNIT BETA', 249444),
(393825, 'PTHR11711:SF450', NULL, NULL, NULL, NULL, 'FACTOR, ARF, PUTATIVE-RELATED', 249444),
(393826, 'PTHR11711:SF172', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 11', 249444),
(393827, 'PTHR43809:SF1', NULL, NULL, NULL, NULL, 'NITRITE REDUCTASE (NADH) LARGE SUBUNIT', 249445),
(393828, 'PTHR43809', NULL, NULL, NULL, NULL, 'NITRITE REDUCTASE (NADH) LARGE SUBUNIT', 249445),
(393829, 'PTHR21180:SF9', NULL, NULL, NULL, NULL, 'TYPE II SECRETION SYSTEM PROTEIN K', 249446),
(393830, 'PTHR21180', NULL, NULL, NULL, NULL, 'ENDONUCLEASE/EXONUCLEASE/PHOSPHATASE FAMILY DOMAIN-CONTAINING PROTEIN 1', 249446),
(393831, 'PTHR21180:SF32', NULL, NULL, NULL, NULL, 'ENDONUCLEASE/EXONUCLEASE/PHOSPHATASE FAMILY DOMAIN-CONTAINING PROTEIN 1', 249446),
(393832, 'PTHR45907:SF21', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS J', 249447),
(393833, 'PTHR45907:SF20', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS J', 249447),
(393834, 'PTHR45907:SF12', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS J', 249447),
(393835, 'PTHR45907:SF23', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS J', 249447),
(393836, 'PTHR45907:SF22', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR', 249447),
(393837, 'PTHR45907:SF11', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS J', 249447),
(393838, 'PTHR45907:SF5', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS J', 249447),
(393839, 'PTHR45907:SF6', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS J', 249447),
(393840, 'PTHR45907:SF8', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS J', 249447),
(393841, 'PTHR45907:SF9', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS J', 249447),
(393842, 'PTHR45907:SF18', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS J', 249447),
(393843, 'PTHR45907', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS J', 249447),
(393844, 'PTHR45907:SF17', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS J', 249447),
(393845, 'PTHR45907:SF16', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS J-RELATED', 249447),
(393846, 'PTHR45907:SF15', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS J', 249447),
(393847, 'PTHR45907:SF1', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS J', 249447),
(393848, 'PTHR45907:SF19', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS J', 249447),
(393849, 'PTHR13768:SF8', NULL, NULL, NULL, NULL, 'ALPHA-SOLUBLE NSF ATTACHMENT PROTEIN', 249448),
(393850, 'PTHR13768:SF39', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 249448),
(393851, 'PTHR13768:SF29', NULL, NULL, NULL, NULL, 'ALPHA-SOLUBLE NSF ATTACHMENT PROTEIN', 249448),
(393852, 'PTHR13768:SF27', NULL, NULL, NULL, NULL, 'ALPHA-SOLUBLE NSF ATTACHMENT PROTEIN-LIKE', 249448),
(393853, 'PTHR13768:SF38', NULL, NULL, NULL, NULL, 'NSF ATTACHMENT PROTEIN-RELATED', 249448),
(393854, 'PTHR13768:SF35', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 249448),
(393855, 'PTHR13768:SF36', NULL, NULL, NULL, NULL, 'OS01G0812500 PROTEIN', 249448),
(393856, 'PTHR13768:SF33', NULL, NULL, NULL, NULL, 'NSF ATTACHMENT PROTEIN-RELATED', 249448),
(393857, 'PTHR13768:SF23', NULL, NULL, NULL, NULL, 'ALPHA-SOLUBLE NSF ATTACHMENT PROTEIN', 249448),
(393858, 'PTHR13768:SF34', NULL, NULL, NULL, NULL, 'N-ETHYLMALEIMIDE-SENSITIVE FACTOR ATTACHMENT PROTEIN, BETA A', 249448),
(393859, 'PTHR13768:SF12', NULL, NULL, NULL, NULL, 'BETA-SOLUBLE NSF ATTACHMENT PROTEIN', 249448);
INSERT INTO "PUBLIC"."MODEL" VALUES
(393860, 'PTHR13768:SF31', NULL, NULL, NULL, NULL, 'ALPHA-SOLUBLE NSF ATTACHMENT PROTEIN', 249448),
(393861, 'PTHR13768:SF42', NULL, NULL, NULL, NULL, '', 249448),
(393862, 'PTHR13768:SF40', NULL, NULL, NULL, NULL, 'ALPHA-SOLUBLE NSF ATTACHMENT PROTEIN', 249448),
(393863, 'PTHR13768:SF41', NULL, NULL, NULL, NULL, 'SNAP PROTEIN-RELATED', 249448),
(393864, 'PTHR13768', NULL, NULL, NULL, NULL, 'SOLUBLE NSF ATTACHMENT PROTEIN  SNAP', 249448),
(393865, 'PTHR13768:SF2', NULL, NULL, NULL, NULL, 'GAMMA-SOLUBLE NSF ATTACHMENT PROTEIN', 249448),
(393866, 'PTHR14069', NULL, NULL, NULL, NULL, 'FILENSIN', 249449),
(393867, 'PTHR14069:SF0', NULL, NULL, NULL, NULL, 'FILENSIN', 249449),
(393868, 'PTHR42760:SF127', NULL, NULL, NULL, NULL, 'CARRIER PROTEIN REDUCTASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G14380)-RELATED', 249450),
(393869, 'PTHR42760:SF105', NULL, NULL, NULL, NULL, 'SORBITOL-6-PHOSPHATE 2-DEHYDROGENASE', 249450),
(393870, 'PTHR42760:SF106', NULL, NULL, NULL, NULL, 'PROTEIN FIXR', 249450),
(393871, 'PTHR42760:SF128', NULL, NULL, NULL, NULL, 'ESTRADIOL 17-BETA-DEHYDROGENASE 8', 249450),
(393872, 'PTHR42760:SF125', NULL, NULL, NULL, NULL, 'D-ARABINITOL DEHYDROGENASE', 249450),
(393873, 'PTHR42760:SF103', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/REDUCTASE SDR', 249450),
(393874, 'PTHR42760', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASES/REDUCTASES FAMILY MEMBER', 249450),
(393875, 'PTHR42760:SF104', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', 249450),
(393876, 'PTHR42760:SF126', NULL, NULL, NULL, NULL, 'D-BETA-HYDROXYBUTYRATE DEHYDROGENASE', 249450),
(393877, 'PTHR42760:SF123', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE', 249450),
(393878, 'PTHR42760:SF101', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', 249450),
(393879, 'PTHR42760:SF102', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', 249450),
(393880, 'PTHR42760:SF124', NULL, NULL, NULL, NULL, '', 249450),
(393881, 'PTHR42760:SF121', NULL, NULL, NULL, NULL, '3-OXOACYL-(ACYL-CARRIER-PROTEIN) REDUCTASE', 249450),
(393882, 'PTHR42760:SF122', NULL, NULL, NULL, NULL, '3-OXOACYL-(ACYL CARRIER PROTEIN) REDUCTASE (FABG-8)', 249450),
(393883, 'PTHR42760:SF120', NULL, NULL, NULL, NULL, '(3R)-3-HYDROXYACYL-COA DEHYDROGENASE', 249450),
(393884, 'PTHR42760:SF37', NULL, NULL, NULL, NULL, 'CLAVALDEHYDE DEHYDROGENASE', 249450),
(393885, 'PTHR42760:SF36', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE YTKK-RELATED', 249450),
(393886, 'PTHR42760:SF78', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE [NADH]', 249450),
(393887, 'PTHR42760:SF76', NULL, NULL, NULL, NULL, 'CHAIN OXIDOREDUCTASE/DEHYDROGENASE, PUTATIVE-RELATED', 249450),
(393888, 'PTHR42760:SF97', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/REDUCTASE FAMILY, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G01040)-RELATED', 249450),
(393889, 'PTHR42760:SF53', NULL, NULL, NULL, NULL, 'BLR4183 PROTEIN', 249450),
(393890, 'PTHR42760:SF96', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE FABG', 249450),
(393891, 'PTHR42760:SF50', NULL, NULL, NULL, NULL, '3-OXOACYL-(ACYL CARRIER PROTEIN) REDUCTASE', 249450),
(393892, 'PTHR42760:SF93', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', 249450),
(393893, 'PTHR42760:SF107', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', 249450),
(393894, 'PTHR42760:SF129', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE', 249450),
(393895, 'PTHR42760:SF91', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', 249450),
(393896, 'PTHR42760:SF115', NULL, NULL, NULL, NULL, 'ZGC:113054', 249450),
(393897, 'PTHR42760:SF111', NULL, NULL, NULL, NULL, '3-OXOACYL-(ACYL-CARRIER-PROTEIN) REDUCTASE (AFU_ORTHOLOGUE AFUA_1G10100)', 249450),
(393898, 'PTHR42760:SF130', NULL, NULL, NULL, NULL, 'BLL7782 PROTEIN', 249450),
(393899, 'PTHR42760:SF131', NULL, NULL, NULL, NULL, '3-ALPHA-(OR 20-BETA)-HYDROXYSTEROID DEHYDROGENASE', 249450),
(393900, 'PTHR42760:SF45', NULL, NULL, NULL, NULL, 'SHORT CHAIN DEHYDROGENASE/REDUCTASE FAMILY PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G09150)-RELATED', 249450);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(393901, 'PTHR42760:SF88', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', 249450),
(393902, 'PTHR42760:SF62', NULL, NULL, NULL, NULL, 'ADH4P', 249450),
(393903, 'PTHR42760:SF40', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', 249450),
(393904, 'PTHR42760:SF83', NULL, NULL, NULL, NULL, '(3R)-3-HYDROXYACYL-COA DEHYDROGENASE', 249450),
(393905, 'PTHR42760:SF5', NULL, NULL, NULL, NULL, '2-DEHYDRO-3-DEOXY-D-GLUCONATE 5-DEHYDROGENASE', 249450),
(393906, 'PTHR16650', NULL, NULL, NULL, NULL, 'C21ORF13-RELATED', 249451),
(393907, 'PTHR16650:SF10', NULL, NULL, NULL, NULL, 'LEBERCILIN', 249451),
(393908, 'PTHR16650:SF9', NULL, NULL, NULL, NULL, 'LEBERCILIN-LIKE PROTEIN', 249451),
(393909, 'PTHR16650:SF6', NULL, NULL, NULL, NULL, 'GH21622P', 249451),
(393910, 'PTHR18867', NULL, NULL, NULL, NULL, 'RAD50', 249452),
(393911, 'PTHR18867:SF12', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RAD50', 249452),
(393912, 'PTHR12480:SF40', NULL, NULL, NULL, NULL, 'IP10855P', 249453),
(393913, 'PTHR12480', NULL, NULL, NULL, NULL, 'ARGININE DEMETHYLASE AND LYSYL-HYDROXYLASE JMJD', 249453),
(393914, 'PTHR12480:SF32', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL ARGININE DEMETHYLASE AND LYSYL-HYDROXYLASE JMJD6', 249453),
(393915, 'PTHR12480:SF21', NULL, NULL, NULL, NULL, 'JMJC DOMAIN-CONTAINING PROTEIN', 249453),
(393916, 'PTHR12480:SF19', NULL, NULL, NULL, NULL, 'CUPIN_8 DOMAIN-CONTAINING PROTEIN', 249453),
(393917, 'PTHR12480:SF6', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE AND IRON-DEPENDENT OXYGENASE JMJD4', 249453),
(393918, 'PTHR12480:SF22', NULL, NULL, NULL, NULL, 'JMJC DOMAIN-CONTAINING PROTEIN', 249453),
(393919, 'PTHR12480:SF34', NULL, NULL, NULL, NULL, '', 249453),
(393920, 'PTHR12480:SF13', NULL, NULL, NULL, NULL, 'LD14533P', 249453),
(393921, 'PTHR12480:SF35', NULL, NULL, NULL, NULL, 'JMJC DOMAIN-CONTAINING PROTEIN 8', 249453),
(393922, 'PTHR10694:SF130', NULL, NULL, NULL, NULL, 'JMJC DOMAIN, JMJN DOMAIN, ZINC FINGER, C5HC2-TYPE-RELATED', 249454),
(393923, 'PTHR10694:SF116', NULL, NULL, NULL, NULL, 'BNAANNG07270D PROTEIN', 249454),
(393924, 'PTHR10694:SF138', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE 4B-RELATED', 249454),
(393925, 'PTHR10694:SF137', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE 5D', 249454),
(393926, 'PTHR10694:SF115', NULL, NULL, NULL, NULL, 'BNAA04G20420D PROTEIN', 249454),
(393927, 'PTHR10694:SF139', NULL, NULL, NULL, NULL, 'LID2 COMPLEX COMPONENT LID2', 249454),
(393928, 'PTHR10694:SF134', NULL, NULL, NULL, NULL, 'MULTICOPY SUPPRESSOR OF CHK1 PROTEIN 1', 249454),
(393929, 'PTHR10694:SF111', NULL, NULL, NULL, NULL, 'BNAA04G20920D PROTEIN', 249454),
(393930, 'PTHR10694:SF133', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR JUMONJI (JMJC) DOMAIN-CONTAINING PROTEIN', 249454),
(393931, 'PTHR10694:SF136', NULL, NULL, NULL, NULL, '[HISTONE H3]-TRIMETHYL-L-LYSINE(4) DEMETHYLASE', 249454),
(393932, 'PTHR10694:SF135', NULL, NULL, NULL, NULL, '', 249454),
(393933, 'PTHR10694:SF113', NULL, NULL, NULL, NULL, 'PROTEIN JUMONJI', 249454),
(393934, 'PTHR10694:SF17', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE 5A', 249454),
(393935, 'PTHR10694:SF38', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE REF6', 249454),
(393936, 'PTHR10694:SF34', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE 4E', 249454),
(393937, 'PTHR10694:SF119', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE 4A', 249454),
(393938, 'PTHR10694:SF33', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE LID', 249454),
(393939, 'PTHR10694:SF54', NULL, NULL, NULL, NULL, 'INACTIVE LYSINE-SPECIFIC DEMETHYLASE JMJ19-RELATED', 249454),
(393940, 'PTHR10694:SF98', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE JMJ16-RELATED', 249454),
(393941, 'PTHR10694:SF30', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE 4B', 249454),
(393942, 'PTHR10694:SF51', NULL, NULL, NULL, NULL, '[HISTONE H3]-TRIMETHYL-L-LYSINE(9) DEMETHYLASE', 249454),
(393943, 'PTHR10694:SF50', NULL, NULL, NULL, NULL, 'JMJC DOMAIN CONTAINING PROTEIN, EXPRESSED', 249454),
(393944, 'PTHR10694:SF92', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE JMJ706-LIKE', 249454); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(393945, 'PTHR10694:SF90', NULL, NULL, NULL, NULL, 'LYSINE DEMETHYLASE 4F', 249454),
(393946, 'PTHR10694:SF141', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE 5C', 249454),
(393947, 'PTHR10694:SF140', NULL, NULL, NULL, NULL, 'OS05G0302300 PROTEIN', 249454),
(393948, 'PTHR10694:SF121', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE JMJ706-LIKE', 249454),
(393949, 'PTHR10694:SF127', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE JMJ15-RELATED', 249454),
(393950, 'PTHR10694:SF105', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE JMJ14-RELATED', 249454),
(393951, 'PTHR10694:SF126', NULL, NULL, NULL, NULL, 'INACTIVE LYSINE-SPECIFIC DEMETHYLASE JMJ19 ISOFORM X1-RELATED', 249454),
(393952, 'PTHR10694:SF104', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE 4C', 249454),
(393953, 'PTHR10694:SF107', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE JMJ706', 249454),
(393954, 'PTHR10694:SF129', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE 4A-RELATED', 249454),
(393955, 'PTHR10694:SF106', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR JUMONJI FAMILY PROTEIN', 249454),
(393956, 'PTHR10694:SF123', NULL, NULL, NULL, NULL, 'BNAC03G72230D PROTEIN', 249454),
(393957, 'PTHR10694:SF100', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE JMJ16 ISOFORM X1-RELATED', 249454),
(393958, 'PTHR10694:SF103', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE JMJ14-RELATED', 249454),
(393959, 'PTHR10694:SF124', NULL, NULL, NULL, NULL, 'BNAA08G05240D PROTEIN', 249454),
(393960, 'PTHR10694:SF109', NULL, NULL, NULL, NULL, 'JUMONJI 14-RELATED', 249454),
(393961, 'PTHR10694:SF45', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE ELF6-RELATED', 249454),
(393962, 'PTHR10694:SF21', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE 4D', 249454),
(393963, 'PTHR10694:SF43', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE 5C', 249454),
(393964, 'PTHR10694', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE', 249454),
(393965, 'PTHR10694:SF3', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE 5B', 249454),
(393966, 'PTHR10694:SF84', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE 5D', 249454),
(393967, 'PTHR10694:SF7', NULL, NULL, NULL, NULL, '[HISTONE H3]-TRIMETHYL-L-LYSINE(9) DEMETHYLASE', 249454),
(393968, 'PTHR22976:SF2', NULL, NULL, NULL, NULL, 'BIOTIN SYNTHASE, MITOCHONDRIAL', 249455),
(393969, 'PTHR22976', NULL, NULL, NULL, NULL, 'BIOTIN SYNTHASE', 249455),
(393970, 'PTHR24157:SF0', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 34A-RELATED', 249456),
(393971, 'PTHR24157:SF3', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT, SAM AND BASIC LEUCINE ZIPPER DOMAIN-CONTAINING PROTEIN 1', 249456),
(393972, 'PTHR24157', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT, SAM AND BASIC LEUCINE ZIPPER DOMAIN-CONTAINING PROTEIN 1', 249456),
(393973, 'PTHR28434:SF1', NULL, NULL, NULL, NULL, 'PROTEIN C3ORF33', 249457),
(393974, 'PTHR28434', NULL, NULL, NULL, NULL, 'PROTEIN C3ORF33', 249457),
(393975, 'PTHR47616', NULL, NULL, NULL, NULL, 'CHOLESTERYL ESTER TRANSFER PROTEIN', 249458),
(393976, 'PTHR47616:SF1', NULL, NULL, NULL, NULL, 'CHOLESTERYL ESTER TRANSFER PROTEIN', 249458),
(393977, 'PTHR12151:SF8', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 249459),
(393978, 'PTHR12151', NULL, NULL, NULL, NULL, 'ELECTRON TRANSPORT PROTIN SCO1/SENC FAMILY MEMBER', 249459),
(393979, 'PTHR12151:SF22', NULL, NULL, NULL, NULL, 'BNAA01G05740D PROTEIN', 249459),
(393980, 'PTHR12151:SF25', NULL, NULL, NULL, NULL, 'LDI DOMAIN-CONTAINING PROTEIN', 249459),
(393981, 'PTHR12151:SF2', NULL, NULL, NULL, NULL, 'PROTEIN SCO2 HOMOLOG, MITOCHONDRIAL', 249459),
(393982, 'PTHR12151:SF23', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 249459),
(393983, 'PTHR12151:SF1', NULL, NULL, NULL, NULL, 'PROTEIN SCO1 HOMOLOG 2, MITOCHONDRIAL', 249459),
(393984, 'PTHR12151:SF4', NULL, NULL, NULL, NULL, 'PROTEIN SCO1 HOMOLOG, MITOCHONDRIAL', 249459),
(393985, 'PTHR12151:SF3', NULL, NULL, NULL, NULL, 'C OXIDASE ASSEMBLY FACTOR, PUTATIVE ELECTRON TRANSPORT PROTEIN SCO1/2, PUTATIVE-RELATED', 249459);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(393986, 'PTHR12151:SF5', NULL, NULL, NULL, NULL, 'AT19154P', 249459),
(393987, 'PTHR40617:SF1', NULL, NULL, NULL, NULL, 'TERPENE CYCLASE ASQC', 249460),
(393988, 'PTHR40617', NULL, NULL, NULL, NULL, 'TERPENE CYCLASE ASQC', 249460),
(393989, 'PTHR36892:SF4', NULL, NULL, NULL, NULL, '', 249461),
(393990, 'PTHR36892:SF1', NULL, NULL, NULL, NULL, 'OS01G0201800 PROTEIN', 249461),
(393991, 'PTHR36892:SF7', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEIN F', 249461),
(393992, 'PTHR36892:SF6', NULL, NULL, NULL, NULL, '', 249461),
(393993, 'PTHR36892', NULL, NULL, NULL, NULL, 'OS01G0201800 PROTEIN', 249461),
(393994, 'PTHR36892:SF9', NULL, NULL, NULL, NULL, 'OS05G0518200 PROTEIN', 249461),
(393995, 'PTHR45644:SF8', NULL, NULL, NULL, NULL, 'OUTER MITOCHONDRIAL TRANSMEMBRANE HELIX TRANSLOCASE', 249462),
(393996, 'PTHR45644:SF70', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 249462),
(393997, 'PTHR45644:SF62', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN', 249462),
(393998, 'PTHR45644:SF4', NULL, NULL, NULL, NULL, 'OS05G0584600 PROTEIN', 249462),
(393999, 'PTHR45644:SF2', NULL, NULL, NULL, NULL, 'OUTER MITOCHONDRIAL TRANSMEMBRANE HELIX TRANSLOCASE', 249462),
(394000, 'PTHR45644:SF3', NULL, NULL, NULL, NULL, 'FI08533P-RELATED', 249462),
(394001, 'PTHR45644:SF22', NULL, NULL, NULL, NULL, 'TRANSITIONAL ENDOPLASMIC RETICULUM ATPASE HOMOLOG 2-LIKE ISOFORM X1', 249462),
(394002, 'PTHR45644:SF66', NULL, NULL, NULL, NULL, 'P-LOOP NUCLEOSIDE TRIPHOSPHATE HYDROLASE SUPERFAMILY PROTEIN', 249462),
(394003, 'PTHR45644:SF67', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 249462),
(394004, 'PTHR45644:SF45', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 249462),
(394005, 'PTHR45644:SF42', NULL, NULL, NULL, NULL, 'AAA-TYPE ATPASE FAMILY PROTEIN', 249462),
(394006, 'PTHR45644:SF20', NULL, NULL, NULL, NULL, '', 249462),
(394007, 'PTHR45644:SF65', NULL, NULL, NULL, NULL, 'FIDGETIN-LIKE PROTEIN 1', 249462),
(394008, 'PTHR45644:SF68', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN-RELATED', 249462),
(394009, 'PTHR45644:SF24', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 249462),
(394010, 'PTHR45644:SF69', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 249462),
(394011, 'PTHR45644:SF25', NULL, NULL, NULL, NULL, 'OS01G0623500 PROTEIN', 249462),
(394012, 'PTHR45644:SF47', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 249462),
(394013, 'PTHR45644:SF28', NULL, NULL, NULL, NULL, '26S PROTEASOME REGULATORY PARTICLE CHAIN RPT6-LIKE PROTEIN', 249462),
(394014, 'PTHR45644', NULL, NULL, NULL, NULL, 'AAA ATPASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G12920)-RELATED-RELATED', 249462),
(394015, 'PTHR45644:SF73', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 249462),
(394016, 'PTHR45644:SF74', NULL, NULL, NULL, NULL, 'ATPASE FAMILY AAA DOMAIN-CONTAINING PROTEIN 1-A-LIKE', 249462),
(394017, 'PTHR45644:SF30', NULL, NULL, NULL, NULL, 'OS07G0672500 PROTEIN', 249462),
(394018, 'PTHR45644:SF71', NULL, NULL, NULL, NULL, 'ATPASE, AAA-TYPE, CORE, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 249462),
(394019, 'PTHR45644:SF72', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 249462),
(394020, 'PTHR45644:SF33', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 249462),
(394021, 'PTHR45644:SF55', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN', 249462),
(394022, 'PTHR45644:SF56', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN', 249462),
(394023, 'PTHR45644:SF53', NULL, NULL, NULL, NULL, 'ATPASE, AAA-TYPE, CORE, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 249462),
(394024, 'PTHR45644:SF75', NULL, NULL, NULL, NULL, 'ATPASE FAMILY AAA DOMAIN-CONTAINING PROTEIN 1-LIKE', 249462),
(394025, 'PTHR45644:SF31', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE SUPERFAMILY PROTEIN', 249462),
(394026, 'PTHR45644:SF32', NULL, NULL, NULL, NULL, 'THIAMINE DIPHOSPHOKINASE', 249462);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(394027, 'PTHR45644:SF36', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN', 249462),
(394028, 'PTHR45644:SF58', NULL, NULL, NULL, NULL, 'ATP BINDING PROTEIN', 249462),
(394029, 'PTHR45644:SF19', NULL, NULL, NULL, NULL, 'ATPASE FAMILY AAA DOMAIN-CONTAINING PROTEIN 1-B-LIKE', 249462),
(394030, 'PTHR45644:SF39', NULL, NULL, NULL, NULL, 'AAA-TYPE ATPASE FAMILY PROTEIN-RELATED', 249462),
(394031, 'PTHR45644:SF18', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN', 249462),
(394032, 'PTHR46555:SF1', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE PROTEIN 4A', 249463),
(394033, 'PTHR46555', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE PROTEIN 4A', 249463),
(394034, 'PTHR31246:SF5', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN 70-5', 249464),
(394035, 'PTHR31246:SF18', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN 70-1-LIKE', 249464),
(394036, 'PTHR31246', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN 70-2', 249464),
(394037, 'PTHR31246:SF19', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN, CLONE', 249464),
(394038, 'PTHR31246:SF26', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN 70-2-RELATED', 249464),
(394039, 'PTHR31246:SF15', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN 70-1', 249464),
(394040, 'PTHR31246:SF16', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN 70-3', 249464),
(394041, 'PTHR31246:SF27', NULL, NULL, NULL, NULL, 'BNAA08G19220D PROTEIN', 249464),
(394042, 'PTHR31246:SF28', NULL, NULL, NULL, NULL, 'BNAANNG06460D PROTEIN', 249464),
(394043, 'PTHR31246:SF4', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN 70-3', 249464),
(394044, 'PTHR31246:SF17', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN 70-2', 249464),
(394045, 'PTHR31246:SF21', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN 70-1', 249464),
(394046, 'PTHR31246:SF32', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN 70-1', 249464),
(394047, 'PTHR31246:SF22', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN, CLONE', 249464),
(394048, 'PTHR31246:SF33', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN 70-5-LIKE', 249464),
(394049, 'PTHR31246:SF23', NULL, NULL, NULL, NULL, 'BNAA09G45420D PROTEIN', 249464),
(394050, 'PTHR31246:SF13', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN 70-4', 249464),
(394051, 'PTHR31246:SF31', NULL, NULL, NULL, NULL, 'MYOSIN II HEAVY CHAIN FAMILY PROTEIN', 249464),
(394052, 'PTHR47794:SF1', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 27', 249465),
(394053, 'PTHR47794', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 27', 249465),
(394054, 'PTHR46560:SF11', NULL, NULL, NULL, NULL, 'GH09980P', 249466),
(394055, 'PTHR46560:SF12', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 249466),
(394056, 'PTHR46560:SF9', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 249466),
(394057, 'PTHR46560:SF6', NULL, NULL, NULL, NULL, 'ZYE', 249466),
(394058, 'PTHR46560:SF7', NULL, NULL, NULL, NULL, 'RE59626P', 249466),
(394059, 'PTHR46560', NULL, NULL, NULL, NULL, 'CYPHER, ISOFORM B', 249466),
(394060, 'PTHR46560:SF1', NULL, NULL, NULL, NULL, 'MINIATURE', 249466),
(394061, 'PTHR46560:SF4', NULL, NULL, NULL, NULL, 'DUSKY', 249466),
(394062, 'PTHR46560:SF5', NULL, NULL, NULL, NULL, 'CYPHER, ISOFORM B', 249466),
(394063, 'PTHR46560:SF13', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 249466),
(394064, 'PTHR46560:SF2', NULL, NULL, NULL, NULL, 'DUSKY-LIKE, ISOFORM A', 249466),
(394065, 'PTHR46560:SF3', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 249466),
(394066, 'PTHR22922', NULL, NULL, NULL, NULL, 'GPI-ANCHORED PROTEIN P137', 249467),
(394067, 'PTHR22922:SF19', NULL, NULL, NULL, NULL, 'CAPRIN HOMOLOG', 249467),
(394068, 'PTHR22922:SF5', NULL, NULL, NULL, NULL, 'CAPRIN-2', 249467),
(394069, 'PTHR22922:SF3', NULL, NULL, NULL, NULL, 'CAPRIN-1', 249467),
(394070, 'PTHR34923', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 20', 249468),
(394071, 'PTHR34923:SF1', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 20', 249468);
INSERT INTO "PUBLIC"."MODEL" VALUES
(394072, 'PTHR15822:SF22', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 249469),
(394073, 'PTHR15822:SF20', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 249469),
(394074, 'PTHR15822', NULL, NULL, NULL, NULL, 'TRAF AND TNF RECEPTOR-ASSOCIATED PROTEIN', 249469),
(394075, 'PTHR15822:SF23', NULL, NULL, NULL, NULL, 'ENDONUCLEASE/EXONUCLEASE/PHOSPHATASE FAMILY PROTEIN', 249469),
(394076, 'PTHR15822:SF4', NULL, NULL, NULL, NULL, 'TYROSYL-DNA PHOSPHODIESTERASE 2', 249469),
(394077, 'PTHR15822:SF24', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 249469),
(394078, 'PTHR15822:SF18', NULL, NULL, NULL, NULL, 'ENDONUCLEASE/EXONUCLEASE/PHOSPHATASE FAMILY PROTEIN', 249469),
(394079, 'PTHR47397:SF1', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 19L', 249470),
(394080, 'PTHR47397', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 19L', 249470),
(394081, 'PTHR46301:SF18', NULL, NULL, NULL, NULL, 'GRAS FAMILY TRANSCRIPTION FACTOR FAMILY PROTEIN', 249471),
(394082, 'PTHR46301', NULL, NULL, NULL, NULL, 'F-BOX/KELCH-REPEAT PROTEIN', 249471),
(394083, 'PTHR46301:SF79', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249471),
(394084, 'PTHR46301:SF57', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249471),
(394085, 'PTHR46301:SF12', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249471),
(394086, 'PTHR46301:SF78', NULL, NULL, NULL, NULL, '', 249471),
(394087, 'PTHR46301:SF34', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249471),
(394088, 'PTHR46301:SF55', NULL, NULL, NULL, NULL, 'OS01G0519100 PROTEIN', 249471),
(394089, 'PTHR46301:SF11', NULL, NULL, NULL, NULL, 'OS03G0373066 PROTEIN', 249471),
(394090, 'PTHR46301:SF33', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249471),
(394091, 'PTHR46301:SF77', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 13-RELATED', 249471),
(394092, 'PTHR46301:SF32', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249471),
(394093, 'PTHR46301:SF76', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249471),
(394094, 'PTHR46301:SF17', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249471),
(394095, 'PTHR46301:SF37', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249471),
(394096, 'PTHR46301:SF71', NULL, NULL, NULL, NULL, '', 249471),
(394097, 'PTHR46301:SF70', NULL, NULL, NULL, NULL, 'F-BOX ONLY-LIKE PROTEIN', 249471),
(394098, 'PTHR46301:SF75', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249471),
(394099, 'PTHR46301:SF31', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN, GALACTOSE OXIDASE/KELCH, BETA-PROPELLER, GALACTOSE OXIDASE, BETA-PROPELLER-RELATED', 249471),
(394100, 'PTHR46301:SF74', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249471),
(394101, 'PTHR46301:SF73', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249471),
(394102, 'PTHR46301:SF51', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249471),
(394103, 'PTHR46301:SF72', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249471),
(394104, 'PTHR46301:SF2', NULL, NULL, NULL, NULL, 'PROTEIN UNUSUAL FLORAL ORGANS', 249471),
(394105, 'PTHR46301:SF29', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249471),
(394106, 'PTHR46301:SF68', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249471),
(394107, 'PTHR46301:SF67', NULL, NULL, NULL, NULL, 'BNAC08G19470D PROTEIN', 249471),
(394108, 'PTHR46301:SF44', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249471),
(394109, 'PTHR46301:SF66', NULL, NULL, NULL, NULL, 'OS07G0667601 PROTEIN', 249471),
(394110, 'PTHR46301:SF21', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249471),
(394111, 'PTHR46301:SF49', NULL, NULL, NULL, NULL, 'BNACNNG49710D PROTEIN', 249471),
(394112, 'PTHR46301:SF27', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249471),
(394113, 'PTHR46301:SF48', NULL, NULL, NULL, NULL, '', 249471),
(394114, 'PTHR46301:SF69', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249471);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(394115, 'PTHR46301:SF25', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249471),
(394116, 'PTHR46301:SF60', NULL, NULL, NULL, NULL, 'F-BOX 1', 249471),
(394117, 'PTHR46301:SF20', NULL, NULL, NULL, NULL, 'F-BOX FAMILY PROTEIN', 249471),
(394118, 'PTHR46301:SF64', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE, EXPRESSED-RELATED', 249471),
(394119, 'PTHR31535', NULL, NULL, NULL, NULL, '', 249472),
(394120, 'PTHR31535:SF3', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN ZESTE', 249472),
(394121, 'PTHR13630:SF1', NULL, NULL, NULL, NULL, 'GAMMA-SECRETASE-ACTIVATING PROTEIN', 249473),
(394122, 'PTHR13630', NULL, NULL, NULL, NULL, 'GAMMA-SECRETASE-ACTIVATING PROTEIN', 249473),
(394123, 'PTHR47990:SF84', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394124, 'PTHR47990:SF1', NULL, NULL, NULL, NULL, 'JASMONATE-INDUCED OXYGENASE 1', 249474),
(394125, 'PTHR47990:SF82', NULL, NULL, NULL, NULL, 'OS05G0421900 PROTEIN', 249474),
(394126, 'PTHR47990:SF83', NULL, NULL, NULL, NULL, 'OXOGLUTARATE/IRON-DEPENDENT DIOXYGENASE-RELATED', 249474),
(394127, 'PTHR47990:SF5', NULL, NULL, NULL, NULL, 'LEUCOANTHOCYANIDIN DIOXYGENASE-LIKE PROTEIN', 249474),
(394128, 'PTHR47990:SF4', NULL, NULL, NULL, NULL, 'GIBBERELLIN 20 OXIDASE 2', 249474),
(394129, 'PTHR47990:SF89', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE-DEPENDENT DIOXYGENASE DIN11-RELATED', 249474),
(394130, 'PTHR47990:SF3', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394131, 'PTHR47990:SF153', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 249474),
(394132, 'PTHR47990:SF9', NULL, NULL, NULL, NULL, 'GIBBERELLIN 20-OXIDASE-LIKE PROTEIN', 249474),
(394133, 'PTHR47990:SF8', NULL, NULL, NULL, NULL, 'GIBBERELLIN 2-BETA-DIOXYGENASE 7', 249474),
(394134, 'PTHR47990:SF7', NULL, NULL, NULL, NULL, 'GIBBERELLIN 20 OXIDASE 3', 249474),
(394135, 'PTHR47990:SF6', NULL, NULL, NULL, NULL, 'GIBBERELLIN 2-BETA-DIOXYGENASE', 249474),
(394136, 'PTHR47990:SF154', NULL, NULL, NULL, NULL, 'GIBBERELLIN 3-BETA-DIOXYGENASE 3', 249474),
(394137, 'PTHR47990:SF157', NULL, NULL, NULL, NULL, 'OS02G0771600 PROTEIN', 249474),
(394138, 'PTHR47990:SF81', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 249474),
(394139, 'PTHR47990:SF158', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394140, 'PTHR47990:SF160', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 249474),
(394141, 'PTHR47990:SF162', NULL, NULL, NULL, NULL, 'GIBBERELLIN 2-BETA-DIOXYGENASE 4', 249474),
(394142, 'PTHR47990:SF161', NULL, NULL, NULL, NULL, 'FLAVONOL SYNTHASE 3', 249474),
(394143, 'PTHR47990:SF95', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN-RELATED', 249474),
(394144, 'PTHR47990:SF96', NULL, NULL, NULL, NULL, 'OXOGLUTARATE/IRON-DEPENDENT DIOXYGENASE-RELATED', 249474),
(394145, 'PTHR47990:SF204', NULL, NULL, NULL, NULL, 'GIBBERELLIN 20 OXIDASE 5', 249474),
(394146, 'PTHR47990:SF93', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394147, 'PTHR47990:SF94', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394148, 'PTHR47990:SF99', NULL, NULL, NULL, NULL, 'OS05G0514600 PROTEIN', 249474),
(394149, 'PTHR47990:SF11', NULL, NULL, NULL, NULL, 'FLAVANONE 3-DIOXYGENASE 1', 249474),
(394150, 'PTHR47990:SF12', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE-DEPENDENT DIOXYGENASE SLC2-RELATED', 249474),
(394151, 'PTHR47990:SF208', NULL, NULL, NULL, NULL, 'GIBBERELLIN 2-BETA-DIOXYGENASE 5', 249474),
(394152, 'PTHR47990:SF97', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394153, 'PTHR47990:SF98', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394154, 'PTHR47990:SF164', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394155, 'PTHR47990:SF163', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(394156, 'PTHR47990:SF166', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394157, 'PTHR47990:SF91', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394158, 'PTHR47990:SF168', NULL, NULL, NULL, NULL, 'OXIDASE, PUTATIVE, EXPRESSED-RELATED', 249474),
(394159, 'PTHR47990:SF92', NULL, NULL, NULL, NULL, 'GA2OX-B11 PROTEIN', 249474),
(394160, 'PTHR47990:SF167', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN-RELATED', 249474),
(394161, 'PTHR47990:SF200', NULL, NULL, NULL, NULL, 'ISOPENICILLIN N SYNTHASE-RELATED', 249474),
(394162, 'PTHR47990:SF90', NULL, NULL, NULL, NULL, 'PLANT GIBBERELLIN 2-OXIDASE', 249474),
(394163, 'PTHR47990:SF202', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE-DEPENDENT DIOXYGENASE AOP1-RELATED', 249474),
(394164, 'PTHR47990:SF171', NULL, NULL, NULL, NULL, 'GIBBERELLIN 20-OXIDASE', 249474),
(394165, 'PTHR47990:SF173', NULL, NULL, NULL, NULL, 'FLAVONOL SYNTHASE-LIKE PROTEIN', 249474),
(394166, 'PTHR47990:SF172', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE-RELATED', 249474),
(394167, 'PTHR47990:SF15', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394168, 'PTHR47990:SF16', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE-DEPENDENT DIOXYGENASE AOP3-RELATED', 249474),
(394169, 'PTHR47990:SF17', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394170, 'PTHR47990:SF18', NULL, NULL, NULL, NULL, 'GIBBERELLIN 2-BETA-DIOXYGENASE 1-LIKE', 249474),
(394171, 'PTHR47990:SF216', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE', 249474),
(394172, 'PTHR47990:SF62', NULL, NULL, NULL, NULL, 'SEXUAL DIFFERENTIATION PROCESS PROTEIN ISP7', 249474),
(394173, 'PTHR47990:SF60', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394174, 'PTHR47990:SF217', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE-DEPENDENT DIOXYGENASE AOP3-LIKE', 249474),
(394175, 'PTHR47990:SF66', NULL, NULL, NULL, NULL, 'FLAVONOL SYNTHASE/FLAVANONE 3-HYDROXYLASE', 249474),
(394176, 'PTHR47990:SF219', NULL, NULL, NULL, NULL, 'GIBBERELLIN 20 OXIDASE 3', 249474),
(394177, 'PTHR47990:SF64', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394178, 'PTHR47990:SF175', NULL, NULL, NULL, NULL, 'GIBBERELLIN 20 OXIDASE 4', 249474),
(394179, 'PTHR47990:SF174', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394180, 'PTHR47990:SF176', NULL, NULL, NULL, NULL, 'JASMONATE-INDUCED OXYGENASE 4', 249474),
(394181, 'PTHR47990:SF179', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 249474),
(394182, 'PTHR47990:SF212', NULL, NULL, NULL, NULL, 'GIBBERELLIN 2-BETA-DIOXYGENASE 2-LIKE', 249474),
(394183, 'PTHR47990:SF214', NULL, NULL, NULL, NULL, 'GIBBERELLIN 3-BETA-DIOXYGENASE 1', 249474),
(394184, 'PTHR47990:SF68', NULL, NULL, NULL, NULL, 'ISOPENICILLIN N SYNTHASE-RELATED', 249474),
(394185, 'PTHR47990:SF69', NULL, NULL, NULL, NULL, 'OXOGLUTARATE/IRON-DEPENDENT DIOXYGENASE-RELATED', 249474),
(394186, 'PTHR47990:SF73', NULL, NULL, NULL, NULL, 'GIBBERELLIN 3-BETA-DIOXYGENASE 2', 249474),
(394187, 'PTHR47990:SF227', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE-DEPENDENT DIOXYGENASE AOP1-RELATED', 249474),
(394188, 'PTHR47990:SF74', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE-DEPENDENT DIOXYGENASE-LIKE PROTEIN', 249474),
(394189, 'PTHR47990:SF105', NULL, NULL, NULL, NULL, 'GIBBERELLIN 3-BETA-DIOXYGENASE 1', 249474),
(394190, 'PTHR47990:SF226', NULL, NULL, NULL, NULL, 'GIBBERELLIN 2-OXIDASE 2', 249474),
(394191, 'PTHR47990:SF229', NULL, NULL, NULL, NULL, 'GIBBERELLIN 2-OXIDASE', 249474),
(394192, 'PTHR47990:SF71', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE 3', 249474),
(394193, 'PTHR47990:SF72', NULL, NULL, NULL, NULL, 'JASMONATE-INDUCED OXYGENASE 3', 249474),
(394194, 'PTHR47990:SF228', NULL, NULL, NULL, NULL, '2OG-FE(II) OXYGENASE FAMILY, PUTATIVE-RELATED', 249474),
(394195, 'PTHR47990:SF107', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(394196, 'PTHR47990:SF77', NULL, NULL, NULL, NULL, 'GA3OX-A3 PROTEIN', 249474),
(394197, 'PTHR47990:SF78', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394198, 'PTHR47990:SF76', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE 2', 249474),
(394199, 'PTHR47990:SF221', NULL, NULL, NULL, NULL, '2OG-FE(II) OXYGENASE', 249474),
(394200, 'PTHR47990:SF100', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394201, 'PTHR47990:SF187', NULL, NULL, NULL, NULL, 'OS05G0127500 PROTEIN', 249474),
(394202, 'PTHR47990:SF223', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394203, 'PTHR47990:SF70', NULL, NULL, NULL, NULL, 'PROTEIN DOWNY MILDEW RESISTANCE 6', 249474),
(394204, 'PTHR47990:SF101', NULL, NULL, NULL, NULL, 'GIBBERELLIN 2-BETA-DIOXYGENASE 3', 249474),
(394205, 'PTHR47990:SF104', NULL, NULL, NULL, NULL, 'OSJNBA0033G05.6-LIKE PROTEIN', 249474),
(394206, 'PTHR47990:SF225', NULL, NULL, NULL, NULL, 'GIBBERELLIN 2-BETA-DIOXYGENASE', 249474),
(394207, 'PTHR47990:SF224', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN-RELATED', 249474),
(394208, 'PTHR47990:SF190', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 249474),
(394209, 'PTHR47990:SF193', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394210, 'PTHR47990:SF192', NULL, NULL, NULL, NULL, 'OS08G0392300 PROTEIN', 249474),
(394211, 'PTHR47990:SF79', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394212, 'PTHR47990:SF117', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 249474),
(394213, 'PTHR47990:SF238', NULL, NULL, NULL, NULL, 'GIBBERELLIN 3-BETA-DIOXYGENASE 4', 249474),
(394214, 'PTHR47990:SF40', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 249474),
(394215, 'PTHR47990:SF237', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 249474),
(394216, 'PTHR47990:SF41', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394217, 'PTHR47990:SF116', NULL, NULL, NULL, NULL, 'FLAVANONE 3-DIOXYGENASE 2', 249474),
(394218, 'PTHR47990:SF119', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394219, 'PTHR47990:SF118', NULL, NULL, NULL, NULL, 'INACTIVE FLAVONOL SYNTHASE 2-RELATED', 249474),
(394220, 'PTHR47990:SF239', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE-DEPENDENT DIOXYGENASE AOP3-LIKE', 249474),
(394221, 'PTHR47990:SF44', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE-DEPENDENT DIOXYGENASE AOP1-RELATED', 249474),
(394222, 'PTHR47990:SF45', NULL, NULL, NULL, NULL, 'GIBBERELLIN 2-BETA-DIOXYGENASE 6', 249474),
(394223, 'PTHR47990:SF42', NULL, NULL, NULL, NULL, 'FLAVONOL SYNTHASE/FLAVANONE 3-HYDROXYLASE', 249474),
(394224, 'PTHR47990:SF43', NULL, NULL, NULL, NULL, 'GIBBERELLIN 3-OXIDASE 1-RELATED', 249474),
(394225, 'PTHR47990:SF230', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE-LIKE', 249474),
(394226, 'PTHR47990:SF197', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE-DEPENDENT DIOXYGENASE AFUA_1G01000', 249474),
(394227, 'PTHR47990:SF232', NULL, NULL, NULL, NULL, '', 249474),
(394228, 'PTHR47990:SF199', NULL, NULL, NULL, NULL, 'OS02G0592000 PROTEIN', 249474),
(394229, 'PTHR47990:SF198', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394230, 'PTHR47990:SF231', NULL, NULL, NULL, NULL, 'GIBBERELLIN 2-BETA-DIOXYGENASE 8', 249474),
(394231, 'PTHR47990:SF234', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394232, 'PTHR47990:SF113', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394233, 'PTHR47990:SF233', NULL, NULL, NULL, NULL, 'GIBBERELLIN 2-BETA-DIOXYGENASE 8-LIKE', 249474),
(394234, 'PTHR47990:SF112', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(394235, 'PTHR47990:SF236', NULL, NULL, NULL, NULL, 'FLAVONOL SYNTHASE/FLAVANONE 3-HYDROXYLASE', 249474),
(394236, 'PTHR47990:SF235', NULL, NULL, NULL, NULL, 'OS01G0832600 PROTEIN', 249474),
(394237, 'PTHR47990:SF114', NULL, NULL, NULL, NULL, 'GIBBERELLIN 20 OXIDASE 2', 249474),
(394238, 'PTHR47990:SF49', NULL, NULL, NULL, NULL, 'SPIROSOLANE 16-OXYGENASE', 249474),
(394239, 'PTHR47990:SF46', NULL, NULL, NULL, NULL, 'ISOPENICILLIN N SYNTHASE-RELATED', 249474),
(394240, 'PTHR47990:SF128', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 249474),
(394241, 'PTHR47990:SF249', NULL, NULL, NULL, NULL, 'LEUCOANTHOCYANIDIN DIOXYGENASE-LIKE PROTEIN', 249474),
(394242, 'PTHR47990:SF51', NULL, NULL, NULL, NULL, 'GIBBERELLIN 2-BETA-DIOXYGENASE 1-LIKE', 249474),
(394243, 'PTHR47990:SF127', NULL, NULL, NULL, NULL, 'LEUCOANTHOCYANIDIN DIOXYGENASE-LIKE PROTEIN', 249474),
(394244, 'PTHR47990:SF52', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394245, 'PTHR47990:SF248', NULL, NULL, NULL, NULL, 'NARINGENIN,2-OXOGLUTARATE 3-DIOXYGENASE', 249474),
(394246, 'PTHR47990:SF55', NULL, NULL, NULL, NULL, 'OS05G0560900 PROTEIN', 249474),
(394247, 'PTHR47990:SF56', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 249474),
(394248, 'PTHR47990:SF53', NULL, NULL, NULL, NULL, 'GIBBERELLIN 20 OXIDASE 1', 249474),
(394249, 'PTHR47990:SF241', NULL, NULL, NULL, NULL, '2OG-FE(II) OXYGENASE FAMILY, PUTATIVE-RELATED', 249474),
(394250, 'PTHR47990:SF120', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE-DEPENDENT DIOXYGENASE AOP1-RELATED', 249474),
(394251, 'PTHR47990:SF240', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394252, 'PTHR47990:SF122', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE 1', 249474),
(394253, 'PTHR47990:SF243', NULL, NULL, NULL, NULL, 'PROTEIN DMR6-LIKE OXYGENASE 2-LIKE', 249474),
(394254, 'PTHR47990:SF242', NULL, NULL, NULL, NULL, 'OS02G0630300 PROTEIN', 249474),
(394255, 'PTHR47990:SF121', NULL, NULL, NULL, NULL, 'GIBBERELLIN 2-BETA-DIOXYGENASE 2', 249474),
(394256, 'PTHR47990:SF245', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394257, 'PTHR47990:SF124', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE', 249474),
(394258, 'PTHR47990:SF244', NULL, NULL, NULL, NULL, 'JASMONATE-INDUCED OXYGENASE 2', 249474),
(394259, 'PTHR47990:SF123', NULL, NULL, NULL, NULL, 'GIBBERELLIN 2-BETA-DIOXYGENASE', 249474),
(394260, 'PTHR47990:SF247', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394261, 'PTHR47990:SF246', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE-DEPENDENT DIOXYGENASE AOP1-RELATED', 249474),
(394262, 'PTHR47990', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN-RELATED', 249474),
(394263, 'PTHR47990:SF250', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE-DEPENDENT DIOXYGENASE AOP1 ISOFORM X1-RELATED', 249474),
(394264, 'PTHR47990:SF59', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394265, 'PTHR47990:SF22', NULL, NULL, NULL, NULL, 'GIBBERELLIN 3-BETA-DIOXYGENASE 2', 249474),
(394266, 'PTHR47990:SF20', NULL, NULL, NULL, NULL, 'OS03G0122300 PROTEIN', 249474),
(394267, 'PTHR47990:SF131', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 249474),
(394268, 'PTHR47990:SF252', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE-DEPENDENT DIOXYGENASE', 249474),
(394269, 'PTHR47990:SF251', NULL, NULL, NULL, NULL, 'GIBBERELLIN 2-BETA-DIOXYGENASE 1', 249474),
(394270, 'PTHR47990:SF254', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE 4', 249474),
(394271, 'PTHR47990:SF133', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394272, 'PTHR47990:SF132', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE-DEPENDENT DIOXYGENASE AOP1-RELATED', 249474),
(394273, 'PTHR47990:SF253', NULL, NULL, NULL, NULL, '2OG-FE(II) OXYGENASE FAMILY, PUTATIVE-RELATED', 249474);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(394274, 'PTHR47990:SF135', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE 5', 249474),
(394275, 'PTHR47990:SF137', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394276, 'PTHR47990:SF136', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394277, 'PTHR47990:SF140', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394278, 'PTHR47990:SF26', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394279, 'PTHR47990:SF27', NULL, NULL, NULL, NULL, 'CHROMOSOME 10, WHOLE GENOME SHOTGUN SEQUENCE', 249474),
(394280, 'PTHR47990:SF24', NULL, NULL, NULL, NULL, 'GIBBERELLIN 2-BETA-DIOXYGENASE 6', 249474),
(394281, 'PTHR47990:SF25', NULL, NULL, NULL, NULL, 'OS01G0209700 PROTEIN', 249474),
(394282, 'PTHR47990:SF28', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394283, 'PTHR47990:SF29', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394284, 'PTHR47990:SF33', NULL, NULL, NULL, NULL, 'FLAVONOL SYNTHASE/FLAVANONE 3-HYDROXYLASE-RELATED', 249474),
(394285, 'PTHR47990:SF34', NULL, NULL, NULL, NULL, 'IRON/ASCORBATE OXIDOREDUCTASE DDB_G0283291-RELATED', 249474),
(394286, 'PTHR47990:SF31', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 249474),
(394287, 'PTHR47990:SF32', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394288, 'PTHR47990:SF142', NULL, NULL, NULL, NULL, 'GIBBERELLIN 20 OXIDASE 3-LIKE', 249474),
(394289, 'PTHR47990:SF141', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE-RELATED', 249474),
(394290, 'PTHR47990:SF144', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394291, 'PTHR47990:SF143', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394292, 'PTHR47990:SF146', NULL, NULL, NULL, NULL, 'OS04G0643500 PROTEIN', 249474),
(394293, 'PTHR47990:SF145', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 249474),
(394294, 'PTHR47990:SF148', NULL, NULL, NULL, NULL, 'PLANT GIBBERELLIN 2-OXIDASE', 249474),
(394295, 'PTHR47990:SF147', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394296, 'PTHR47990:SF151', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394297, 'PTHR47990:SF150', NULL, NULL, NULL, NULL, 'GIBBERELLIN 2-BETA-DIOXYGENASE 1', 249474),
(394298, 'PTHR47990:SF38', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 249474),
(394299, 'PTHR47990:SF35', NULL, NULL, NULL, NULL, '2OG-FE(II) OXYGENASE FAMILY, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G11160)-RELATED', 249474),
(394300, 'PTHR47990:SF36', NULL, NULL, NULL, NULL, 'OS02G0767300 PROTEIN', 249474),
(394301, 'PTHR47990:SF39', NULL, NULL, NULL, NULL, '2OG-FE(II) OXYGENASE FAMILY, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G00800)-RELATED', 249474),
(394302, 'PTHR45685:SF1', NULL, NULL, NULL, NULL, 'HELICASE SRCAP', 249475),
(394303, 'PTHR45685:SF2', NULL, NULL, NULL, NULL, 'CHROMATIN-REMODELING ATPASE INO80', 249475),
(394304, 'PTHR45685', NULL, NULL, NULL, NULL, 'HELICASE SRCAP-RELATED', 249475),
(394305, 'PTHR34009', NULL, NULL, NULL, NULL, 'PROTEIN STAR', 249476),
(394306, 'PTHR34009:SF2', NULL, NULL, NULL, NULL, 'PROTEIN STAR', 249476),
(394307, 'PTHR36506', NULL, NULL, NULL, NULL, 'PREFLAGELLIN PEPTIDASE', 249477),
(394308, 'PTHR36506:SF1', NULL, NULL, NULL, NULL, 'PREFLAGELLIN PEPTIDASE', 249477),
(394309, 'PTHR21496:SF1', NULL, NULL, NULL, NULL, '', 249478),
(394310, 'PTHR21496:SF18', NULL, NULL, NULL, NULL, 'RIESKE (FE-S) DOMAIN-CONTAINING', 249478),
(394311, 'PTHR21496:SF19', NULL, NULL, NULL, NULL, 'SI:CH211-212D10.2', 249478),
(394312, 'PTHR21496:SF16', NULL, NULL, NULL, NULL, 'RIESKE DOMAIN-CONTAINING PROTEIN', 249478),
(394313, 'PTHR21496:SF23', NULL, NULL, NULL, NULL, '3-PHENYLPROPIONATE/CINNAMIC ACID DIOXYGENASE FERREDOXIN SUBUNIT', 249478),
(394314, 'PTHR21496', NULL, NULL, NULL, NULL, 'FERREDOXIN-RELATED', 249478);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(394315, 'PTHR21496:SF24', NULL, NULL, NULL, NULL, 'SULREDOXIN-RELATED', 249478),
(394316, 'PTHR21496:SF0', NULL, NULL, NULL, NULL, 'RIESKE DOMAIN-CONTAINING PROTEIN', 249478),
(394317, 'PTHR33783:SF4', NULL, NULL, NULL, NULL, 'VQ MOTIF-CONTAINING PROTEIN 9', 249479),
(394318, 'PTHR33783:SF3', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 249479),
(394319, 'PTHR33783:SF1', NULL, NULL, NULL, NULL, 'PROTEIN HAIKU1', 249479),
(394320, 'PTHR33783:SF7', NULL, NULL, NULL, NULL, 'BNAA02G24670D PROTEIN', 249479),
(394321, 'PTHR33783', NULL, NULL, NULL, NULL, 'PROTEIN HAIKU1', 249479),
(394322, 'PTHR33783:SF6', NULL, NULL, NULL, NULL, 'LRX2', 249479),
(394323, 'PTHR33783:SF5', NULL, NULL, NULL, NULL, 'VQ MOTIF-CONTAINING PROTEIN 5', 249479),
(394324, 'PTHR13008', NULL, NULL, NULL, NULL, 'MAP-KINASE ACTIVATING DEATH DOMAIN PROTEIN  MADD /DENN/AEX-3 C.ELEGANS', 249480),
(394325, 'PTHR13008:SF7', NULL, NULL, NULL, NULL, 'MAP KINASE-ACTIVATING DEATH DOMAIN PROTEIN', 249480),
(394326, 'PTHR39697:SF1', NULL, NULL, NULL, NULL, '', 249481),
(394327, 'PTHR39697', NULL, NULL, NULL, NULL, '', 249481),
(394328, 'PTHR46655:SF1', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE ATXR3', 249482),
(394329, 'PTHR46655:SF5', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE ATXR3', 249482),
(394330, 'PTHR46655:SF6', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 249482),
(394331, 'PTHR46655', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE ATXR3', 249482),
(394332, 'PTHR31562:SF11', NULL, NULL, NULL, NULL, 'PROTEIN CBG12410', 249483),
(394333, 'PTHR31562:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG18972', 249483),
(394334, 'PTHR31562:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG06280', 249483),
(394335, 'PTHR31562:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG24330', 249483),
(394336, 'PTHR31562:SF13', NULL, NULL, NULL, NULL, 'PROTEIN CBG18974', 249483),
(394337, 'PTHR31562:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG18973', 249483),
(394338, 'PTHR31562:SF2', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN CONTAINING PROTEIN', 249483),
(394339, 'PTHR31562:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG15947', 249483),
(394340, 'PTHR31562', NULL, NULL, NULL, NULL, 'PROTEIN CBG18972', 249483),
(394341, 'PTHR31562:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG12400', 249483),
(394342, 'PTHR22809', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE-RELATED', 249484),
(394343, 'PTHR22809:SF3', NULL, NULL, NULL, NULL, 'MRNA N(3)-METHYLCYTIDINE METHYLTRANSFERASE METTL8', 249484),
(394344, 'PTHR22809:SF11', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE-LIKE PROTEIN', 249484),
(394345, 'PTHR22809:SF5', NULL, NULL, NULL, NULL, 'TRNA N(3)-METHYLCYTIDINE METHYLTRANSFERASE METTL6', 249484),
(394346, 'PTHR22809:SF4', NULL, NULL, NULL, NULL, 'TRNA N(3)-METHYLCYTIDINE METHYLTRANSFERASE METTL2A-RELATED', 249484),
(394347, 'PTHR22809:SF14', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE-LIKE PROTEIN', 249484),
(394348, 'PTHR22809:SF8', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE-LIKE PROTEIN', 249484),
(394349, 'PTHR36364:SF1', NULL, NULL, NULL, NULL, 'OS03G0203000 PROTEIN', 249485),
(394350, 'PTHR36364', NULL, NULL, NULL, NULL, 'OS03G0203000 PROTEIN', 249485),
(394351, 'PTHR33803:SF3', NULL, NULL, NULL, NULL, 'BLL1974 PROTEIN', 249486),
(394352, 'PTHR33803', NULL, NULL, NULL, NULL, 'IS1478 TRANSPOSASE', 249486),
(394353, 'PTHR39214:SF1', NULL, NULL, NULL, NULL, 'MICROBODY (PEROXISOME) BIOGENESIS PROTEIN PEROXIN 8 (EUROFUNG)', 249487),
(394354, 'PTHR39214', NULL, NULL, NULL, NULL, 'MICROBODY (PEROXISOME) BIOGENESIS PROTEIN PEROXIN 8 (EUROFUNG)', 249487),
(394355, 'PTHR19212:SF0', NULL, NULL, NULL, NULL, 'LD07988P', 249488),
(394356, 'PTHR19212:SF6', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT FLIGHTLESS-INTERACTING PROTEIN 2', 249488),
(394357, 'PTHR19212:SF7', NULL, NULL, NULL, NULL, '', 249488),
(394358, 'PTHR19212:SF5', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT FLIGHTLESS-INTERACTING PROTEIN 1', 249488),
(394359, 'PTHR19212', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT  IN FLII  INTERACTING PROTEIN', 249488);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(394360, 'PTHR33547', NULL, NULL, NULL, NULL, 'ZGC:174862', 249489),
(394361, 'PTHR33547:SF1', NULL, NULL, NULL, NULL, 'ZGC:174862', 249489),
(394362, 'PTHR33547:SF4', NULL, NULL, NULL, NULL, '', 249489),
(394363, 'PTHR33547:SF3', NULL, NULL, NULL, NULL, 'BNAC03G14070D PROTEIN', 249489),
(394364, 'PTHR34787:SF2', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I REACTION CENTER SUBUNIT VI-1, CHLOROPLASTIC', 249490),
(394365, 'PTHR34787:SF3', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I REACTION CENTER SUBUNIT VI-2, CHLOROPLASTIC-LIKE', 249490),
(394366, 'PTHR34787:SF4', NULL, NULL, NULL, NULL, 'BNAA06G01680D PROTEIN', 249490),
(394367, 'PTHR34787:SF5', NULL, NULL, NULL, NULL, 'BNAC01G35500D PROTEIN', 249490),
(394368, 'PTHR34787:SF1', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I REACTION CENTER SUBUNIT VI-2, CHLOROPLASTIC', 249490),
(394369, 'PTHR34787:SF6', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I REACTION CENTER SUBUNIT VI-1, CHLOROPLASTIC-LIKE', 249490),
(394370, 'PTHR34787', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I REACTION CENTER SUBUNIT VI-2, CHLOROPLASTIC', 249490),
(394371, 'PTHR22536:SF6', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 19A-LIKE', 249491),
(394372, 'PTHR22536', NULL, NULL, NULL, NULL, 'LUNG CANCER METASTASIS-RELATED  LCMR1  PROTEIN', 249491),
(394373, 'PTHR22536:SF4', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 19A-LIKE', 249491),
(394374, 'PTHR22536:SF3', NULL, NULL, NULL, NULL, '', 249491),
(394375, 'PTHR22536:SF10', NULL, NULL, NULL, NULL, '', 249491),
(394376, 'PTHR22536:SF11', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 19A', 249491),
(394377, 'PTHR22536:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249491),
(394378, 'PTHR22536:SF1', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 19', 249491),
(394379, 'PTHR34473:SF1', NULL, NULL, NULL, NULL, 'UPF0699 TRANSMEMBRANE PROTEIN YDBT', 249492),
(394380, 'PTHR34473:SF2', NULL, NULL, NULL, NULL, 'UPF0699 TRANSMEMBRANE PROTEIN YDBS', 249492),
(394381, 'PTHR34473', NULL, NULL, NULL, NULL, 'UPF0699 TRANSMEMBRANE PROTEIN YDBS', 249492),
(394382, 'PTHR34473:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN-RELATED', 249492),
(394383, 'PTHR43181:SF3', NULL, NULL, NULL, NULL, '2-C-METHYL-D-ERYTHRITOL 2,4-CYCLODIPHOSPHATE SYNTHASE', 249493),
(394384, 'PTHR43181', NULL, NULL, NULL, NULL, '2-C-METHYL-D-ERYTHRITOL 2,4-CYCLODIPHOSPHATE SYNTHASE, CHLOROPLASTIC', 249493),
(394385, 'PTHR43181:SF1', NULL, NULL, NULL, NULL, '2-C-METHYL-D-ERYTHRITOL 2,4-CYCLODIPHOSPHATE SYNTHASE, CHLOROPLASTIC', 249493),
(394386, 'PTHR45811:SF32', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED DOMAIN PROTEIN', 249494),
(394387, 'PTHR45811:SF76', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED DOMAIN, HMA-RELATED', 249494),
(394388, 'PTHR45811', NULL, NULL, NULL, NULL, 'COPPER TRANSPORT PROTEIN FAMILY-RELATED', 249494),
(394389, 'PTHR45811:SF31', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 249494),
(394390, 'PTHR45811:SF74', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 249494),
(394391, 'PTHR45811:SF52', NULL, NULL, NULL, NULL, 'FK506-BINDING PROTEIN 4-LIKE', 249494),
(394392, 'PTHR45811:SF51', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 249494),
(394393, 'PTHR45811:SF58', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 249494),
(394394, 'PTHR45811:SF36', NULL, NULL, NULL, NULL, 'POLLEN-SPECIFIC LEUCINE-RICH REPEAT EXTENSIN-LIKE PROTEIN 1', 249494),
(394395, 'PTHR45811:SF79', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 249494),
(394396, 'PTHR45811:SF35', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 39', 249494),
(394397, 'PTHR45811:SF13', NULL, NULL, NULL, NULL, 'OS04G0661100 PROTEIN', 249494),
(394398, 'PTHR45811:SF57', NULL, NULL, NULL, NULL, '', 249494),
(394399, 'PTHR45811:SF78', NULL, NULL, NULL, NULL, 'BNAA02G10710D PROTEIN', 249494),
(394400, 'PTHR45811:SF34', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 249494),
(394401, 'PTHR45811:SF56', NULL, NULL, NULL, NULL, 'BNAA02G10700D PROTEIN', 249494);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(394402, 'PTHR45811:SF77', NULL, NULL, NULL, NULL, 'ION-BINDING PROTEIN, PUTATIVE-RELATED', 249494),
(394403, 'PTHR45811:SF55', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 249494),
(394404, 'PTHR45811:SF33', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 2-RELATED', 249494),
(394405, 'PTHR45811:SF11', NULL, NULL, NULL, NULL, 'METAL-ASSOCIATED DOMAIN, PUTATIVE-RELATED', 249494),
(394406, 'PTHR45811:SF17', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED DOMAIN CONTAINING PROTEIN', 249494),
(394407, 'PTHR45811:SF39', NULL, NULL, NULL, NULL, 'METAL-ASSOCIATED DOMAIN PROTEIN, PUTATIVE-RELATED', 249494),
(394408, 'PTHR45811:SF16', NULL, NULL, NULL, NULL, 'COPPER TRANSPORT PROTEIN FAMILY-RELATED', 249494),
(394409, 'PTHR45811:SF38', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED DOMAIN PROTEIN', 249494),
(394410, 'PTHR45811:SF59', NULL, NULL, NULL, NULL, 'COPPER TRANSPORT PROTEIN FAMILY', 249494),
(394411, 'PTHR45811:SF37', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 249494),
(394412, 'PTHR45811:SF1', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 249494),
(394413, 'PTHR45811:SF81', NULL, NULL, NULL, NULL, 'COPPER TRANSPORT PROTEIN FAMILY-RELATED', 249494),
(394414, 'PTHR45811:SF80', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 12', 249494),
(394415, 'PTHR45811:SF43', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 39-LIKE ISOFORM X1', 249494),
(394416, 'PTHR45811:SF21', NULL, NULL, NULL, NULL, '', 249494),
(394417, 'PTHR45811:SF65', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 249494),
(394418, 'PTHR45811:SF64', NULL, NULL, NULL, NULL, '', 249494),
(394419, 'PTHR45811:SF41', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED DOMAIN CONTAINING PROTEIN, EXPRESSED', 249494),
(394420, 'PTHR45811:SF25', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 249494),
(394421, 'PTHR45811:SF24', NULL, NULL, NULL, NULL, '', 249494),
(394422, 'PTHR45811:SF46', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 249494),
(394423, 'PTHR45811:SF66', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED DOMAIN, HMA-RELATED', 249494),
(394424, 'PTHR45811:SF22', NULL, NULL, NULL, NULL, 'UPF0329 PROTEIN ECU05_1680/ECU11_0050-LIKE', 249494),
(394425, 'PTHR45811:SF28', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 249494),
(394426, 'PTHR45811:SF27', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 3-LIKE', 249494),
(394427, 'PTHR45811:SF49', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 249494),
(394428, 'PTHR45811:SF26', NULL, NULL, NULL, NULL, '', 249494),
(394429, 'PTHR45811:SF48', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 249494),
(394430, 'PTHR45811:SF50', NULL, NULL, NULL, NULL, 'COPPER TRANSPORT PROTEIN FAMILY-RELATED', 249494),
(394431, 'PTHR36434:SF1', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEASE YUGP-RELATED', 249495),
(394432, 'PTHR36434', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEASE YUGP-RELATED', 249495),
(394433, 'PTHR35498:SF4', NULL, NULL, NULL, NULL, 'PROTEIN LOW PSII ACCUMULATION 1, CHLOROPLASTIC', 249496),
(394434, 'PTHR35498:SF5', NULL, NULL, NULL, NULL, 'RUBREDOXIN FAMILY PROTEIN', 249496),
(394435, 'PTHR35498:SF3', NULL, NULL, NULL, NULL, 'PROTEIN MET1, CHLOROPLASTIC', 249496),
(394436, 'PTHR35498', NULL, NULL, NULL, NULL, 'PROTEIN LOW PSII ACCUMULATION 1, CHLOROPLASTIC', 249496),
(394437, 'PTHR35498:SF1', NULL, NULL, NULL, NULL, 'LOW PSII ACCUMULATION-LIKE PROTEIN', 249496),
(394438, 'PTHR42775:SF1', NULL, NULL, NULL, NULL, 'PERMEASE RV2963-RELATED', 249497),
(394439, 'PTHR42775:SF2', NULL, NULL, NULL, NULL, 'PERMEASE-RELATED', 249497),
(394440, 'PTHR42775', NULL, NULL, NULL, NULL, 'PERMEASE RV2963-RELATED', 249497),
(394441, 'PTHR48044:SF23', NULL, NULL, NULL, NULL, 'ZEATIN O-GLUCOSYLTRANSFERASE-LIKE', 249498),
(394442, 'PTHR48044:SF24', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394443, 'PTHR48044:SF25', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394444, 'PTHR48044:SF27', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(394445, 'PTHR48044:SF29', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394446, 'PTHR48044:SF60', NULL, NULL, NULL, NULL, 'BETA-D-GLUCOSYL CROCETIN BETA-1,6-GLUCOSYLTRANSFERASE-LIKE', 249498),
(394447, 'PTHR48044:SF64', NULL, NULL, NULL, NULL, 'CIS-ZEATIN O-GLUCOSYLTRANSFERASE 1', 249498),
(394448, 'PTHR48044:SF20', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394449, 'PTHR48044:SF21', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394450, 'PTHR48044:SF66', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394451, 'PTHR48044:SF22', NULL, NULL, NULL, NULL, 'OS04G0556400 PROTEIN', 249498),
(394452, 'PTHR48044:SF56', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 708D1', 249498),
(394453, 'PTHR48044:SF12', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394454, 'PTHR48044:SF57', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394455, 'PTHR48044:SF14', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394456, 'PTHR48044:SF58', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394457, 'PTHR48044:SF15', NULL, NULL, NULL, NULL, 'ZEATIN O-XYLOSYLTRANSFERASE-LIKE', 249498),
(394458, 'PTHR48044:SF59', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394459, 'PTHR48044:SF16', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394460, 'PTHR48044:SF17', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394461, 'PTHR48044:SF18', NULL, NULL, NULL, NULL, 'BETA-D-GLUCOSYL CROCETIN BETA-1,6-GLUCOSYLTRANSFERASE-LIKE', 249498),
(394462, 'PTHR48044:SF50', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394463, 'PTHR48044:SF51', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE:GLUCOSYLTRANSFERASE', 249498),
(394464, 'PTHR48044', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394465, 'PTHR48044:SF7', NULL, NULL, NULL, NULL, 'ZEATIN O-XYLOSYLTRANSFERASE-LIKE', 249498),
(394466, 'PTHR48044:SF52', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394467, 'PTHR48044:SF53', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394468, 'PTHR48044:SF8', NULL, NULL, NULL, NULL, 'ZEATIN O-GLUCOSYLTRANSFERASE-LIKE', 249498),
(394469, 'PTHR48044:SF10', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394470, 'PTHR48044:SF9', NULL, NULL, NULL, NULL, 'UDPGT DOMAIN-CONTAINING PROTEIN', 249498),
(394471, 'PTHR48044:SF11', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394472, 'PTHR48044:SF3', NULL, NULL, NULL, NULL, 'UDP-RHAMNOSE:RHAMNOSYLTRANSFERASE 1-RELATED', 249498),
(394473, 'PTHR48044:SF4', NULL, NULL, NULL, NULL, 'UDPGT DOMAIN-CONTAINING PROTEIN', 249498),
(394474, 'PTHR48044:SF6', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394475, 'PTHR48044:SF1', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394476, 'PTHR48044:SF90', NULL, NULL, NULL, NULL, 'ZEATIN O-XYLOSYLTRANSFERASE-LIKE', 249498),
(394477, 'PTHR48044:SF2', NULL, NULL, NULL, NULL, 'CYANIDIN-3-O-GLUCOSIDE 2-O-GLUCURONOSYLTRANSFERASE-LIKE', 249498),
(394478, 'PTHR48044:SF45', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394479, 'PTHR48044:SF89', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394480, 'PTHR48044:SF46', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394481, 'PTHR48044:SF47', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394482, 'PTHR48044:SF48', NULL, NULL, NULL, NULL, 'ZEATIN O-GLUCOSYLTRANSFERASE-LIKE', 249498),
(394483, 'PTHR48044:SF49', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394484, 'PTHR48044:SF81', NULL, NULL, NULL, NULL, 'UDPGT DOMAIN-CONTAINING PROTEIN', 249498),
(394485, 'PTHR48044:SF82', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394486, 'PTHR48044:SF83', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394487, 'PTHR48044:SF84', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394488, 'PTHR48044:SF40', NULL, NULL, NULL, NULL, 'ZEATIN O-GLUCOSYLTRANSFERASE-LIKE', 249498),
(394489, 'PTHR48044:SF85', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394490, 'PTHR48044:SF41', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(394491, 'PTHR48044:SF86', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394492, 'PTHR48044:SF42', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE CGT', 249498),
(394493, 'PTHR48044:SF87', NULL, NULL, NULL, NULL, 'GLUCOSYL/GLUCURONOSYL TRANSFERASES', 249498),
(394494, 'PTHR48044:SF88', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394495, 'PTHR48044:SF80', NULL, NULL, NULL, NULL, 'ZEATIN O-XYLOSYLTRANSFERASE-LIKE', 249498),
(394496, 'PTHR48044:SF78', NULL, NULL, NULL, NULL, 'CYANIDIN-3-O-GLUCOSIDE 2-O-GLUCURONOSYLTRANSFERASE-LIKE', 249498),
(394497, 'PTHR48044:SF34', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394498, 'PTHR48044:SF35', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394499, 'PTHR48044:SF79', NULL, NULL, NULL, NULL, 'GLUCOSYL/GLUCURONOSYL TRANSFERASES', 249498),
(394500, 'PTHR48044:SF39', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394501, 'PTHR48044:SF70', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394502, 'PTHR48044:SF30', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394503, 'PTHR48044:SF74', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394504, 'PTHR48044:SF75', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394505, 'PTHR48044:SF32', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249498),
(394506, 'PTHR11360:SF156', NULL, NULL, NULL, NULL, 'MONOCARBOXYLATE TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G14260)-RELATED', 249499),
(394507, 'PTHR11360:SF8', NULL, NULL, NULL, NULL, 'BCDNA.LD28120-RELATED', 249499),
(394508, 'PTHR11360:SF234', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 249499),
(394509, 'PTHR11360:SF158', NULL, NULL, NULL, NULL, 'MONOCARBOXYLATE TRANSPORTER 9', 249499),
(394510, 'PTHR11360', NULL, NULL, NULL, NULL, 'MONOCARBOXYLATE TRANSPORTER', 249499),
(394511, 'PTHR11360:SF230', NULL, NULL, NULL, NULL, 'MONOCARBOXYLATE TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G12790)-RELATED', 249499),
(394512, 'PTHR11360:SF111', NULL, NULL, NULL, NULL, 'CHASKI, ISOFORM A', 249499),
(394513, 'PTHR11360:SF237', NULL, NULL, NULL, NULL, 'MONOCARBOXYLATE TRANSPORTER 12-B-LIKE PROTEIN', 249499),
(394514, 'PTHR11360:SF238', NULL, NULL, NULL, NULL, 'SD10469P', 249499),
(394515, 'PTHR11360:SF239', NULL, NULL, NULL, NULL, 'MONOCARBOXYLATE TRANSPORTER 14', 249499),
(394516, 'PTHR11360:SF119', NULL, NULL, NULL, NULL, 'MONOCARBOXYLATE TRANSPORTER 10', 249499),
(394517, 'PTHR11360:SF280', NULL, NULL, NULL, NULL, 'MONOCARBOXYLATE TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G05170)-RELATED', 249499),
(394518, 'PTHR11360:SF281', NULL, NULL, NULL, NULL, 'ASPYRIDONES EFFLUX PROTEIN APDF-RELATED', 249499),
(394519, 'PTHR11360:SF300', NULL, NULL, NULL, NULL, '', 249499),
(394520, 'PTHR11360:SF224', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 249499),
(394521, 'PTHR11360:SF302', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 249499),
(394522, 'PTHR11360:SF301', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 249499),
(394523, 'PTHR11360:SF308', NULL, NULL, NULL, NULL, 'BLL3089 PROTEIN', 249499),
(394524, 'PTHR11360:SF307', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 249499),
(394525, 'PTHR11360:SF309', NULL, NULL, NULL, NULL, 'MONOCARBOXYLATE TRANSPORTER 7-LIKE PROTEIN', 249499),
(394526, 'PTHR11360:SF304', NULL, NULL, NULL, NULL, 'TRANSPORTER-RELATED', 249499),
(394527, 'PTHR11360:SF303', NULL, NULL, NULL, NULL, 'IP12869P', 249499),
(394528, 'PTHR11360:SF306', NULL, NULL, NULL, NULL, 'RE01051P', 249499),
(394529, 'PTHR11360:SF305', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 249499),
(394530, 'PTHR11360:SF229', NULL, NULL, NULL, NULL, 'AGAP007601-PA', 249499),
(394531, 'PTHR11360:SF84', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 249499),
(394532, 'PTHR11360:SF270', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 249499),
(394533, 'PTHR11360:SF80', NULL, NULL, NULL, NULL, 'MONOCARBOXYLATE TRANSPORTER 11', 249499),
(394534, 'PTHR11360:SF255', NULL, NULL, NULL, NULL, 'SI:DKEY-246G23.4', 249499);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(394535, 'PTHR11360:SF299', NULL, NULL, NULL, NULL, 'GEM-1', 249499),
(394536, 'PTHR11360:SF258', NULL, NULL, NULL, NULL, '', 249499),
(394537, 'PTHR11360:SF130', NULL, NULL, NULL, NULL, 'MONOCARBOXYLATE TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G05660)-RELATED', 249499),
(394538, 'PTHR11360:SF251', NULL, NULL, NULL, NULL, 'KARMOISIN, ISOFORM B', 249499),
(394539, 'PTHR11360:SF295', NULL, NULL, NULL, NULL, 'TRANSPORTER MCH4-RELATED', 249499),
(394540, 'PTHR11360:SF296', NULL, NULL, NULL, NULL, 'MONOCARBOXYLATE TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G12710)-RELATED', 249499),
(394541, 'PTHR11360:SF252', NULL, NULL, NULL, NULL, 'MONOCARBOXYLATE TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G00780)-RELATED', 249499),
(394542, 'PTHR11360:SF297', NULL, NULL, NULL, NULL, 'GON-2 EXTRAGENIC MODIFIER', 249499),
(394543, 'PTHR11360:SF177', NULL, NULL, NULL, NULL, 'RIBOFLAVIN TRANSPORTER MCH5', 249499),
(394544, 'PTHR11360:SF298', NULL, NULL, NULL, NULL, 'MONOCARBOXYLATE TRANSPORTER 12', 249499),
(394545, 'PTHR11360:SF14', NULL, NULL, NULL, NULL, 'MONOCARBOXYLATE TRANSPORTER 5', 249499),
(394546, 'PTHR11360:SF19', NULL, NULL, NULL, NULL, 'MONOCARBOXYLATE TRANSPORTER 13', 249499),
(394547, 'PTHR11360:SF93', NULL, NULL, NULL, NULL, 'MONOCARBOXYLATE TRANSPORTER 7-LIKE PROTEIN', 249499),
(394548, 'PTHR11360:SF260', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY', 249499),
(394549, 'PTHR11360:SF92', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 249499),
(394550, 'PTHR11360:SF123', NULL, NULL, NULL, NULL, 'MONOCARBOXYLATE TRANSPORTER 8', 249499),
(394551, 'PTHR11360:SF246', NULL, NULL, NULL, NULL, 'AGAP000795-PA', 249499),
(394552, 'PTHR11360:SF284', NULL, NULL, NULL, NULL, 'TRANSPORTER MCH2-RELATED', 249499),
(394553, 'PTHR11360:SF240', NULL, NULL, NULL, NULL, 'MONOCARBOXYLATE TRANSPORTER (EUROFUNG)-RELATED', 249499),
(394554, 'PTHR11360:SF163', NULL, NULL, NULL, NULL, 'MONOCARBOXYLATE TRANSPORTER 9-LIKE PROTEIN', 249499),
(394555, 'PTHR11360:SF164', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 249499),
(394556, 'PTHR11360:SF286', NULL, NULL, NULL, NULL, 'GH22266P', 249499),
(394557, 'PTHR11360:SF287', NULL, NULL, NULL, NULL, 'MFS MONOCARBOXYLATE TRANSPORTER', 249499),
(394558, 'PTHR11360:SF25', NULL, NULL, NULL, NULL, 'MONOCARBOXYLATE TRANSPORTER 2', 249499),
(394559, 'PTHR11360:SF24', NULL, NULL, NULL, NULL, 'MONOCARBOXYLATE TRANSPORTER 1', 249499),
(394560, 'PTHR11360:SF27', NULL, NULL, NULL, NULL, 'MONOCARBOXYLATE TRANSPORTER 4', 249499),
(394561, 'PTHR11360:SF26', NULL, NULL, NULL, NULL, 'MONOCARBOXYLATE TRANSPORTER 3', 249499),
(394562, 'PTHR11360:SF248', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 249499),
(394563, 'PTHR11360:SF21', NULL, NULL, NULL, NULL, 'MONOCARBOXYLATE TRANSPORTER 6', 249499),
(394564, 'PTHR11360:SF20', NULL, NULL, NULL, NULL, 'MONOCARBOXYLATE TRANSPORTER 7', 249499),
(394565, 'PTHR11360:SF292', NULL, NULL, NULL, NULL, 'PROTEIN CBG05646', 249499),
(394566, 'PTHR11360:SF293', NULL, NULL, NULL, NULL, 'HERMES, ISOFORM A', 249499),
(394567, 'PTHR11360:SF172', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 249499),
(394568, 'PTHR11360:SF250', NULL, NULL, NULL, NULL, 'MFS-TYPE TRANSPORTER AFUA_1G00970', 249499),
(394569, 'PTHR11360:SF294', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY TRANSPORTER', 249499),
(394570, 'PTHR11360:SF290', NULL, NULL, NULL, NULL, 'BLL4329 PROTEIN', 249499),
(394571, 'PTHR45780:SF9', NULL, NULL, NULL, NULL, 'CTP:PHOSPHOETHANOLAMINE CYTIDYLYLTRANSFERASE', 249500),
(394572, 'PTHR45780:SF11', NULL, NULL, NULL, NULL, 'CTP:PHOSPHOETHANOLAMINE CYTIDYLYLTRANSFERASE', 249500),
(394573, 'PTHR45780:SF10', NULL, NULL, NULL, NULL, 'CTP:PHOSPHOETHANOLAMINE CYTIDYLYLTRANSFERASE', 249500),
(394574, 'PTHR45780:SF7', NULL, NULL, NULL, NULL, 'CTP:PHOSPHOETHANOLAMINE CYTIDYLYLTRANSFERASE', 249500),
(394575, 'PTHR45780:SF5', NULL, NULL, NULL, NULL, 'CTP:PHOSPHOETHANOLAMINE CYTIDYLYLTRANSFERASE', 249500),
(394576, 'PTHR45780:SF12', NULL, NULL, NULL, NULL, 'CTP:PHOSPHOETHANOLAMINE CYTIDYLYLTRANSFERASE', 249500),
(394577, 'PTHR45780', NULL, NULL, NULL, NULL, 'ETHANOLAMINE-PHOSPHATE CYTIDYLYLTRANSFERASE', 249500);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(394578, 'PTHR45780:SF3', NULL, NULL, NULL, NULL, 'CTP:PHOSPHOETHANOLAMINE CYTIDYLYLTRANSFERASE', 249500),
(394579, 'PTHR45780:SF2', NULL, NULL, NULL, NULL, 'ETHANOLAMINE-PHOSPHATE CYTIDYLYLTRANSFERASE', 249500),
(394580, 'PTHR45780:SF1', NULL, NULL, NULL, NULL, 'CTP:PHOSPHOETHANOLAMINE CYTIDYLYLTRANSFERASE', 249500),
(394581, 'PTHR11746:SF308', NULL, NULL, NULL, NULL, 'FLAVONOID O-METHYLTRANSFERASE-LIKE PROTEIN OS11G0303600', 249501),
(394582, 'PTHR11746:SF307', NULL, NULL, NULL, NULL, '3-AMINOMETHYLINDOLE N-METHYLTRANSFERASE', 249501),
(394583, 'PTHR11746:SF309', NULL, NULL, NULL, NULL, 'TRANS-RESVERATROL DI-O-METHYLTRANSFERASE-LIKE', 249501),
(394584, 'PTHR11746:SF267', NULL, NULL, NULL, NULL, 'CATECHOL O-METHYLTRANSFERASE', 249501),
(394585, 'PTHR11746:SF300', NULL, NULL, NULL, NULL, 'CAFFEIC ACID 3-O-METHYLTRANSFERASE 2-RELATED', 249501),
(394586, 'PTHR11746:SF269', NULL, NULL, NULL, NULL, 'BNAC02G13760D PROTEIN', 249501),
(394587, 'PTHR11746:SF302', NULL, NULL, NULL, NULL, 'TRANS-RESVERATROL DI-O-METHYLTRANSFERASE-LIKE', 249501),
(394588, 'PTHR11746:SF148', NULL, NULL, NULL, NULL, 'OS05G0515500 PROTEIN', 249501),
(394589, 'PTHR11746:SF301', NULL, NULL, NULL, NULL, 'INDOLE GLUCOSINOLATE O-METHYLTRANSFERASE 2-RELATED', 249501),
(394590, 'PTHR11746:SF147', NULL, NULL, NULL, NULL, 'ACETYLSEROTONIN O-METHYLTRANSFERASE', 249501),
(394591, 'PTHR11746:SF304', NULL, NULL, NULL, NULL, 'O-METHYLTRANSFERASE ZRP4', 249501),
(394592, 'PTHR11746:SF303', NULL, NULL, NULL, NULL, 'ACETYLSEROTONIN O-METHYLTRANSFERASE', 249501),
(394593, 'PTHR11746:SF306', NULL, NULL, NULL, NULL, '3''-HYDROXY-N-METHYL-(S)-COCLAURINE 4''-O-METHYLTRANSFERASE 2-LIKE', 249501),
(394594, 'PTHR11746:SF98', NULL, NULL, NULL, NULL, 'ACETYLSEROTONIN O-METHYLTRANSFERASE-RELATED', 249501),
(394595, 'PTHR11746:SF305', NULL, NULL, NULL, NULL, 'METHYLTRANSF_2 DOMAIN-CONTAINING PROTEIN', 249501),
(394596, 'PTHR11746:SF142', NULL, NULL, NULL, NULL, 'TRIBOA-GLUCOSIDE O-METHYLTRANSFERASE BX7', 249501),
(394597, 'PTHR11746:SF262', NULL, NULL, NULL, NULL, 'BNAA08G29990D PROTEIN', 249501),
(394598, 'PTHR11746:SF143', NULL, NULL, NULL, NULL, 'O-METHYLTRANSFERASE 12-RELATED', 249501),
(394599, 'PTHR11746:SF319', NULL, NULL, NULL, NULL, 'O-METHYLTRANSFERASE', 249501),
(394600, 'PTHR11746:SF318', NULL, NULL, NULL, NULL, '5-PENTADECATRIENYL RESORCINOL O-METHYLTRANSFERASE', 249501),
(394601, 'PTHR11746:SF311', NULL, NULL, NULL, NULL, 'DESMETHYLXANTHOHUMOL 6''-O-METHYLTRANSFERASE-LIKE', 249501),
(394602, 'PTHR11746:SF157', NULL, NULL, NULL, NULL, '', 249501),
(394603, 'PTHR11746:SF156', NULL, NULL, NULL, NULL, '', 249501),
(394604, 'PTHR11746:SF310', NULL, NULL, NULL, NULL, 'METHYLTRANSF_2 DOMAIN-CONTAINING PROTEIN', 249501),
(394605, 'PTHR11746:SF159', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 249501),
(394606, 'PTHR11746:SF313', NULL, NULL, NULL, NULL, 'TRANS-RESVERATROL DI-O-METHYLTRANSFERASE-LIKE', 249501),
(394607, 'PTHR11746:SF158', NULL, NULL, NULL, NULL, '', 249501),
(394608, 'PTHR11746:SF312', NULL, NULL, NULL, NULL, 'BNAA06G14930D PROTEIN', 249501),
(394609, 'PTHR11746:SF279', NULL, NULL, NULL, NULL, 'TRANS-RESVERATROL DI-O-METHYLTRANSFERASE-LIKE', 249501),
(394610, 'PTHR11746:SF315', NULL, NULL, NULL, NULL, '6A-HYDROXYMAACKIAIN METHYLTRANSFERASE FAMILY PROTEIN', 249501),
(394611, 'PTHR11746:SF314', NULL, NULL, NULL, NULL, 'CAFFEIC ACID O-METHYLTRANSFERASE', 249501),
(394612, 'PTHR11746:SF317', NULL, NULL, NULL, NULL, 'CAFFEIC ACID O-METHYLTRANSFERASE', 249501),
(394613, 'PTHR11746:SF316', NULL, NULL, NULL, NULL, 'F16P17.4 PROTEIN-RELATED', 249501),
(394614, 'PTHR11746:SF151', NULL, NULL, NULL, NULL, 'CAFFEIC ACID 3-O-METHYLTRANSFERASE 1-LIKE', 249501),
(394615, 'PTHR11746:SF272', NULL, NULL, NULL, NULL, 'ACETYLSEROTONIN O-METHYLTRANSFERASE 3', 249501),
(394616, 'PTHR11746:SF271', NULL, NULL, NULL, NULL, 'OSJNBB0026E15.9-LIKE PROTEIN', 249501),
(394617, 'PTHR11746:SF150', NULL, NULL, NULL, NULL, 'ACETYLSEROTONIN O-METHYLTRANSFERASE 2', 249501),
(394618, 'PTHR11746:SF274', NULL, NULL, NULL, NULL, 'BNAC08G19680D PROTEIN', 249501);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(394619, 'PTHR11746:SF273', NULL, NULL, NULL, NULL, 'BNAA03G59140D PROTEIN', 249501),
(394620, 'PTHR11746:SF152', NULL, NULL, NULL, NULL, 'ASMT2', 249501),
(394621, 'PTHR11746:SF276', NULL, NULL, NULL, NULL, 'O-METHYLTRANSFERASE FAMILY PROTEIN', 249501),
(394622, 'PTHR11746:SF155', NULL, NULL, NULL, NULL, 'TRANS-RESVERATROL DI-O-METHYLTRANSFERASE-LIKE', 249501),
(394623, 'PTHR11746', NULL, NULL, NULL, NULL, 'O-METHYLTRANSFERASE', 249501),
(394624, 'PTHR11746:SF154', NULL, NULL, NULL, NULL, 'BENZOXAZINONE SYNTHESIS10', 249501),
(394625, 'PTHR11746:SF275', NULL, NULL, NULL, NULL, 'ORCINOL O-METHYLTRANSFERASE', 249501),
(394626, 'PTHR11746:SF322', NULL, NULL, NULL, NULL, 'BNAC03G14720D PROTEIN', 249501),
(394627, 'PTHR11746:SF321', NULL, NULL, NULL, NULL, 'METHYLTRANSF_2 DOMAIN-CONTAINING PROTEIN', 249501),
(394628, 'PTHR11746:SF200', NULL, NULL, NULL, NULL, '', 249501),
(394629, 'PTHR11746:SF167', NULL, NULL, NULL, NULL, 'METHYLTRANSF_2 DOMAIN-CONTAINING PROTEIN', 249501),
(394630, 'PTHR11746:SF324', NULL, NULL, NULL, NULL, 'OS07G0464200 PROTEIN', 249501),
(394631, 'PTHR11746:SF323', NULL, NULL, NULL, NULL, 'TRANS-RESVERATROL DI-O-METHYLTRANSFERASE', 249501),
(394632, 'PTHR11746:SF204', NULL, NULL, NULL, NULL, '', 249501),
(394633, 'PTHR11746:SF160', NULL, NULL, NULL, NULL, 'NARINGENIN 7-O-METHYLTRANSFERASE', 249501),
(394634, 'PTHR11746:SF283', NULL, NULL, NULL, NULL, 'TRANS-RESVERATROL DI-O-METHYLTRANSFERASE-LIKE', 249501),
(394635, 'PTHR11746:SF161', NULL, NULL, NULL, NULL, 'O-METHYLTRANSFERASE ZRP4', 249501),
(394636, 'PTHR11746:SF282', NULL, NULL, NULL, NULL, 'ORCINOL O-METHYLTRANSFERASE', 249501),
(394637, 'PTHR11746:SF163', NULL, NULL, NULL, NULL, 'METHYLTRANSF_2 DOMAIN-CONTAINING PROTEIN', 249501),
(394638, 'PTHR11746:SF287', NULL, NULL, NULL, NULL, 'METHYLTRANSF_2 DOMAIN-CONTAINING PROTEIN', 249501),
(394639, 'PTHR11746:SF320', NULL, NULL, NULL, NULL, '5-PENTADECATRIENYL RESORCINOL O-METHYLTRANSFERASE', 249501),
(394640, 'PTHR11746:SF286', NULL, NULL, NULL, NULL, 'OS01G0753300 PROTEIN', 249501),
(394641, 'PTHR11746:SF179', NULL, NULL, NULL, NULL, 'FLAVONOID 4''-O-METHYLTRANSFERASE', 249501),
(394642, 'PTHR11746:SF212', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 249501),
(394643, 'PTHR11746:SF216', NULL, NULL, NULL, NULL, '', 249501),
(394644, 'PTHR11746:SF218', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 249501),
(394645, 'PTHR11746:SF217', NULL, NULL, NULL, NULL, 'O-METHYLTRANSFERASE ZRP4', 249501),
(394646, 'PTHR11746:SF291', NULL, NULL, NULL, NULL, 'O-METHYLTRANSFERASE ZRP4', 249501),
(394647, 'PTHR11746:SF94', NULL, NULL, NULL, NULL, 'METHYLTRANSF_2 DOMAIN-CONTAINING PROTEIN', 249501),
(394648, 'PTHR11746:SF172', NULL, NULL, NULL, NULL, '', 249501),
(394649, 'PTHR11746:SF93', NULL, NULL, NULL, NULL, '', 249501),
(394650, 'PTHR11746:SF296', NULL, NULL, NULL, NULL, 'OS04G0196200 PROTEIN', 249501),
(394651, 'PTHR11746:SF210', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 249501),
(394652, 'PTHR11746:SF90', NULL, NULL, NULL, NULL, 'NICOTINATE N-METHYLTRANSFERASE 1', 249501),
(394653, 'PTHR11746:SF297', NULL, NULL, NULL, NULL, 'BNAA03G59130D PROTEIN', 249501),
(394654, 'PTHR11746:SF290', NULL, NULL, NULL, NULL, 'METHYLTRANSF_2 DOMAIN-CONTAINING PROTEIN', 249501),
(394655, 'PTHR11746:SF223', NULL, NULL, NULL, NULL, 'CAFFEIC ACID O-METHYLTRANSFERASE', 249501),
(394656, 'PTHR11746:SF224', NULL, NULL, NULL, NULL, '', 249501),
(394657, 'PTHR11746:SF227', NULL, NULL, NULL, NULL, 'CAFFEIC ACID 3-O-METHYLTRANSFERASE-LIKE', 249501),
(394658, 'PTHR11746:SF226', NULL, NULL, NULL, NULL, 'METHYLTRANSF_2 DOMAIN-CONTAINING PROTEIN', 249501),
(394659, 'PTHR11746:SF228', NULL, NULL, NULL, NULL, 'ISOFLAVONE 4''-O-METHYLTRANSFERASE', 249501),
(394660, 'PTHR11746:SF182', NULL, NULL, NULL, NULL, 'METHYLTRANSF_2 DOMAIN-CONTAINING PROTEIN', 249501),
(394661, 'PTHR11746:SF184', NULL, NULL, NULL, NULL, 'O-METHYLTRANSFERASE FAMILY PROTEIN', 249501),
(394662, 'PTHR11746:SF186', NULL, NULL, NULL, NULL, 'METHYLTRANSF_2 DOMAIN-CONTAINING PROTEIN', 249501),
(394663, 'PTHR11746:SF185', NULL, NULL, NULL, NULL, 'TRANS-RESVERATROL DI-O-METHYLTRANSFERASE-LIKE', 249501);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(394664, 'PTHR11746:SF188', NULL, NULL, NULL, NULL, '', 249501),
(394665, 'PTHR11746:SF221', NULL, NULL, NULL, NULL, 'CAFFEIC ACID O-METHYLTRANSFERASE', 249501),
(394666, 'PTHR11746:SF220', NULL, NULL, NULL, NULL, 'CAFFEIC ACID 3-O-METHYLTRANSFERASE 1-LIKE', 249501),
(394667, 'PTHR11746:SF180', NULL, NULL, NULL, NULL, 'O-METHYLTRANSFERASE 2-RELATED', 249501),
(394668, 'PTHR11746:SF233', NULL, NULL, NULL, NULL, 'METHYLTRANSF_2 DOMAIN-CONTAINING PROTEIN', 249501),
(394669, 'PTHR11746:SF115', NULL, NULL, NULL, NULL, 'O-METHYLTRANSFERASE 10', 249501),
(394670, 'PTHR11746:SF236', NULL, NULL, NULL, NULL, 'BNAA02G18320D PROTEIN', 249501),
(394671, 'PTHR11746:SF238', NULL, NULL, NULL, NULL, 'BNAC01G20290D PROTEIN', 249501),
(394672, 'PTHR11746:SF117', NULL, NULL, NULL, NULL, 'OS12G0445300 PROTEIN', 249501),
(394673, 'PTHR11746:SF237', NULL, NULL, NULL, NULL, 'INDOLE GLUCOSINOLATE O-METHYLTRANSFERASE 1', 249501),
(394674, 'PTHR11746:SF193', NULL, NULL, NULL, NULL, 'O-METHYLTRANSFERASE ZRP4', 249501),
(394675, 'PTHR11746:SF195', NULL, NULL, NULL, NULL, 'CAFFEIC ACID 3-O-METHYLTRANSFERASE-LIKE PROTEIN-RELATED', 249501),
(394676, 'PTHR11746:SF194', NULL, NULL, NULL, NULL, 'INDOLE GLUCOSINOLATE O-METHYLTRANSFERASE 5', 249501),
(394677, 'PTHR11746:SF199', NULL, NULL, NULL, NULL, 'FLAVONE 3''-O-METHYLTRANSFERASE 1', 249501),
(394678, 'PTHR11746:SF232', NULL, NULL, NULL, NULL, 'INDOLE GLUCOSINOLATE O-METHYLTRANSFERASE 3', 249501),
(394679, 'PTHR11746:SF231', NULL, NULL, NULL, NULL, 'OS08G0290700 PROTEIN', 249501),
(394680, 'PTHR11746:SF190', NULL, NULL, NULL, NULL, 'TRANS-RESVERATROL DI-O-METHYLTRANSFERASE', 249501),
(394681, 'PTHR11746:SF244', NULL, NULL, NULL, NULL, 'ASMT1', 249501),
(394682, 'PTHR11746:SF247', NULL, NULL, NULL, NULL, 'BNAA06G14950D PROTEIN', 249501),
(394683, 'PTHR11746:SF246', NULL, NULL, NULL, NULL, 'LOW QUALITY PROTEIN: (S)-SCOULERINE 9-O-METHYLTRANSFERASE-LIKE', 249501),
(394684, 'PTHR11746:SF120', NULL, NULL, NULL, NULL, 'CAFFEATE O-METHYLTRANSFERASE-LIKE PROTEIN 2', 249501),
(394685, 'PTHR11746:SF240', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 249501),
(394686, 'PTHR11746:SF243', NULL, NULL, NULL, NULL, 'BNAC07G48680D PROTEIN', 249501),
(394687, 'PTHR11746:SF242', NULL, NULL, NULL, NULL, 'BNAA10G07250D PROTEIN', 249501),
(394688, 'PTHR11746:SF256', NULL, NULL, NULL, NULL, 'BNAA02G18290D PROTEIN', 249501),
(394689, 'PTHR11746:SF255', NULL, NULL, NULL, NULL, 'METHYLTRANSF_2 DOMAIN-CONTAINING PROTEIN', 249501),
(394690, 'PTHR11746:SF258', NULL, NULL, NULL, NULL, 'BNAANNG10770D PROTEIN', 249501),
(394691, 'PTHR11746:SF252', NULL, NULL, NULL, NULL, 'METHYLTRANSF_2 DOMAIN-CONTAINING PROTEIN', 249501),
(394692, 'PTHR11746:SF251', NULL, NULL, NULL, NULL, 'BNAA03G48770D PROTEIN', 249501),
(394693, 'PTHR11746:SF254', NULL, NULL, NULL, NULL, '3''-HYDROXY-N-METHYL-(S)-COCLAURINE 4''-O-METHYLTRANSFERASE-LIKE', 249501),
(394694, 'PTHR11746:SF253', NULL, NULL, NULL, NULL, 'METHYLTRANSF_2 DOMAIN-CONTAINING PROTEIN', 249501),
(394695, 'PTHR21087:SF4', NULL, NULL, NULL, NULL, 'INACTIVE SHIKIMATE KINASE LIKE 1, CHLOROPLASTIC-RELATED', 249502),
(394696, 'PTHR21087:SF26', NULL, NULL, NULL, NULL, 'SHIKIMATE KINASE 3, CHLOROPLASTIC', 249502),
(394697, 'PTHR21087:SF23', NULL, NULL, NULL, NULL, 'INACTIVE SHIKIMATE KINASE LIKE 2, CHLOROPLASTIC-RELATED', 249502),
(394698, 'PTHR21087:SF24', NULL, NULL, NULL, NULL, 'SHIKIMATE KINASE', 249502),
(394699, 'PTHR21087:SF10', NULL, NULL, NULL, NULL, 'SHIKIMATE KINASE 1, CHLOROPLASTIC', 249502),
(394700, 'PTHR21087:SF21', NULL, NULL, NULL, NULL, 'SHIKIMATE KINASE 2', 249502),
(394701, 'PTHR21087:SF22', NULL, NULL, NULL, NULL, 'SHIKIMATE KINASE 2, CHLOROPLASTIC', 249502),
(394702, 'PTHR21087:SF20', NULL, NULL, NULL, NULL, 'SHIKIMATE KINASE', 249502),
(394703, 'PTHR21087', NULL, NULL, NULL, NULL, 'SHIKIMATE KINASE', 249502),
(394704, 'PTHR21087:SF16', NULL, NULL, NULL, NULL, 'SHIKIMATE KINASE 1, CHLOROPLASTIC', 249502),
(394705, 'PTHR43851:SF1', NULL, NULL, NULL, NULL, 'ATYPICAL KINASE COQ8A, MITOCHONDRIAL', 249503),
(394706, 'PTHR43851:SF4', NULL, NULL, NULL, NULL, 'ATYPICAL KINASE COQ8B, MITOCHONDRIAL', 249503);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(394707, 'PTHR43851:SF3', NULL, NULL, NULL, NULL, 'COENZYME Q8', 249503),
(394708, 'PTHR43851', NULL, NULL, NULL, NULL, '', 249503),
(394709, 'PTHR41774:SF1', NULL, NULL, NULL, NULL, 'ATP PHOSPHORIBOSYLTRANSFERASE', 249504),
(394710, 'PTHR41774', NULL, NULL, NULL, NULL, '', 249504),
(394711, 'PTHR39159', NULL, NULL, NULL, NULL, '', 249505),
(394712, 'PTHR39159:SF1', NULL, NULL, NULL, NULL, 'UPF0374 PROTEIN YGAC', 249505),
(394713, 'PTHR14261', NULL, NULL, NULL, NULL, 'ONCOSTATIN M', 249506),
(394714, 'PTHR14261:SF0', NULL, NULL, NULL, NULL, 'ONCOSTATIN-M', 249506),
(394715, 'PTHR38147', NULL, NULL, NULL, NULL, '5-FORMAMINOIMIDAZOLE-4-CARBOXAMIDE-1-(BETA)-D-RIBOFURANOSYL 5''-MONOPHOSPHATE SYNTHETASE-RELATED', 249507),
(394716, 'PTHR38147:SF1', NULL, NULL, NULL, NULL, 'ATP-GRASP DOMAIN-CONTAINING PROTEIN', 249507),
(394717, 'PTHR38147:SF2', NULL, NULL, NULL, NULL, '5-FORMAMINOIMIDAZOLE-4-CARBOXAMIDE-1-(BETA)-D-RIBOFURANOSYL 5''-MONOPHOSPHATE SYNTHETASE', 249507),
(394718, 'PTHR47628:SF1', NULL, NULL, NULL, NULL, 'ALIPHATIC AMIDASE EXPRESSION-REGULATING PROTEIN', 249508),
(394719, 'PTHR47628', NULL, NULL, NULL, NULL, '', 249508),
(394720, 'PTHR46128:SF140', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394721, 'PTHR46128:SF261', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394722, 'PTHR46128:SF301', NULL, NULL, NULL, NULL, 'BNAA01G32380D PROTEIN', 249509),
(394723, 'PTHR46128:SF268', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394724, 'PTHR46128:SF148', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394725, 'PTHR46128:SF302', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394726, 'PTHR46128:SF266', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394727, 'PTHR46128:SF145', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394728, 'PTHR46128:SF267', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394729, 'PTHR46128:SF262', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394730, 'PTHR46128:SF142', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394731, 'PTHR46128:SF67', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394732, 'PTHR46128:SF66', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394733, 'PTHR46128:SF307', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394734, 'PTHR46128:SF308', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN-CONTAINING PROTEIN-RELATED', 249509),
(394735, 'PTHR46128:SF306', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394736, 'PTHR46128:SF62', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394737, 'PTHR46128:SF60', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394738, 'PTHR46128:SF304', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL', 249509),
(394739, 'PTHR46128:SF69', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT', 249509),
(394740, 'PTHR46128:SF68', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 249509),
(394741, 'PTHR46128:SF136', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394742, 'PTHR46128:SF81', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394743, 'PTHR46128:SF258', NULL, NULL, NULL, NULL, 'RESTORER OF FERTILITY-LIKE PROTEIN', 249509),
(394744, 'PTHR46128:SF134', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394745, 'PTHR46128:SF253', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394746, 'PTHR46128:SF133', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394747, 'PTHR46128:SF130', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394748, 'PTHR46128:SF251', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(394749, 'PTHR46128:SF252', NULL, NULL, NULL, NULL, '', 249509),
(394750, 'PTHR46128:SF77', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394751, 'PTHR46128:SF76', NULL, NULL, NULL, NULL, 'BNAC01G42390D PROTEIN', 249509),
(394752, 'PTHR46128:SF75', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394753, 'PTHR46128:SF73', NULL, NULL, NULL, NULL, 'PROTEIN RF1, MITOCHONDRIAL-LIKE', 249509),
(394754, 'PTHR46128:SF72', NULL, NULL, NULL, NULL, 'REPEAT 336, PUTATIVE-RELATED', 249509),
(394755, 'PTHR46128:SF139', NULL, NULL, NULL, NULL, 'BNAC08G43070D PROTEIN', 249509),
(394756, 'PTHR46128:SF79', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394757, 'PTHR46128:SF282', NULL, NULL, NULL, NULL, 'PPR1 PROTEIN', 249509),
(394758, 'PTHR46128:SF283', NULL, NULL, NULL, NULL, '', 249509),
(394759, 'PTHR46128:SF162', NULL, NULL, NULL, NULL, '', 249509),
(394760, 'PTHR46128:SF281', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394761, 'PTHR46128:SF202', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394762, 'PTHR46128:SF323', NULL, NULL, NULL, NULL, '', 249509),
(394763, 'PTHR46128:SF324', NULL, NULL, NULL, NULL, '', 249509),
(394764, 'PTHR46128:SF167', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394765, 'PTHR46128:SF321', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN-RELATED', 249509),
(394766, 'PTHR46128:SF200', NULL, NULL, NULL, NULL, 'FERTILITY RESTORER', 249509),
(394767, 'PTHR46128:SF288', NULL, NULL, NULL, NULL, '', 249509),
(394768, 'PTHR46128:SF201', NULL, NULL, NULL, NULL, 'BNAA07G01370D PROTEIN', 249509),
(394769, 'PTHR46128:SF322', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394770, 'PTHR46128:SF289', NULL, NULL, NULL, NULL, 'PPR1 PROTEIN', 249509),
(394771, 'PTHR46128:SF287', NULL, NULL, NULL, NULL, '', 249509),
(394772, 'PTHR46128:SF320', NULL, NULL, NULL, NULL, 'SMR DOMAIN-CONTAINING PROTEIN', 249509),
(394773, 'PTHR46128:SF166', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394774, 'PTHR46128:SF164', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN, MITOCHONDRIAL', 249509),
(394775, 'PTHR46128:SF285', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 249509),
(394776, 'PTHR46128:SF44', NULL, NULL, NULL, NULL, 'BNAC09G20840D PROTEIN', 249509),
(394777, 'PTHR46128:SF329', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT DOMAIN CONTAINING PROTEIN-RELATED', 249509),
(394778, 'PTHR46128:SF208', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 249509),
(394779, 'PTHR46128:SF206', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT (PPR) SUPERFAMILY PROTEIN-RELATED', 249509),
(394780, 'PTHR46128:SF327', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 249509),
(394781, 'PTHR46128:SF207', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394782, 'PTHR46128:SF328', NULL, NULL, NULL, NULL, 'BNACNNG18110D PROTEIN', 249509),
(394783, 'PTHR46128:SF40', NULL, NULL, NULL, NULL, '', 249509),
(394784, 'PTHR46128:SF325', NULL, NULL, NULL, NULL, '', 249509),
(394785, 'PTHR46128:SF326', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 249509),
(394786, 'PTHR46128:SF159', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394787, 'PTHR46128:SF156', NULL, NULL, NULL, NULL, '', 249509),
(394788, 'PTHR46128:SF277', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394789, 'PTHR46128:SF157', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394790, 'PTHR46128:SF154', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394791, 'PTHR46128:SF276', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394792, 'PTHR46128:SF273', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394793, 'PTHR46128:SF152', NULL, NULL, NULL, NULL, '', 249509); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(394794, 'PTHR46128:SF55', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394795, 'PTHR46128:SF54', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394796, 'PTHR46128:SF53', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394797, 'PTHR46128:SF51', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394798, 'PTHR46128:SF315', NULL, NULL, NULL, NULL, 'FERTILITY RESTORER', 249509),
(394799, 'PTHR46128:SF59', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394800, 'PTHR46128:SF58', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394801, 'PTHR46128:SF183', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394802, 'PTHR46128:SF184', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394803, 'PTHR46128:SF181', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394804, 'PTHR46128:SF182', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394805, 'PTHR46128:SF180', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394806, 'PTHR46128:SF345', NULL, NULL, NULL, NULL, '', 249509),
(394807, 'PTHR46128:SF224', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394808, 'PTHR46128:SF346', NULL, NULL, NULL, NULL, '', 249509),
(394809, 'PTHR46128:SF189', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394810, 'PTHR46128:SF343', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 249509),
(394811, 'PTHR46128:SF223', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394812, 'PTHR46128:SF102', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 249509),
(394813, 'PTHR46128:SF344', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394814, 'PTHR46128:SF341', NULL, NULL, NULL, NULL, '', 249509),
(394815, 'PTHR46128:SF220', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 249509),
(394816, 'PTHR46128:SF187', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394817, 'PTHR46128:SF342', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394818, 'PTHR46128:SF340', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 249509),
(394819, 'PTHR46128:SF107', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394820, 'PTHR46128:SF228', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394821, 'PTHR46128:SF349', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 249509),
(394822, 'PTHR46128:SF108', NULL, NULL, NULL, NULL, '', 249509),
(394823, 'PTHR46128:SF347', NULL, NULL, NULL, NULL, '', 249509),
(394824, 'PTHR46128:SF105', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN, CHLOROPLASTIC', 249509),
(394825, 'PTHR46128:SF348', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394826, 'PTHR46128:SF227', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394827, 'PTHR46128:SF29', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394828, 'PTHR46128:SF28', NULL, NULL, NULL, NULL, '', 249509),
(394829, 'PTHR46128:SF25', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN, MITOCHONDRIAL', 249509),
(394830, 'PTHR46128:SF172', NULL, NULL, NULL, NULL, '', 249509),
(394831, 'PTHR46128:SF170', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 249509),
(394832, 'PTHR46128:SF334', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394833, 'PTHR46128:SF214', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394834, 'PTHR46128:SF335', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394835, 'PTHR46128:SF332', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(394836, 'PTHR46128:SF178', NULL, NULL, NULL, NULL, 'UBA DOMAIN-CONTAINING PROTEIN', 249509),
(394837, 'PTHR46128:SF211', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394838, 'PTHR46128:SF212', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394839, 'PTHR46128:SF333', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394840, 'PTHR46128:SF176', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394841, 'PTHR46128:SF330', NULL, NULL, NULL, NULL, '', 249509),
(394842, 'PTHR46128:SF331', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394843, 'PTHR46128:SF177', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394844, 'PTHR46128:SF296', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394845, 'PTHR46128:SF175', NULL, NULL, NULL, NULL, 'ALUMINUM-INDUCED PROTEIN', 249509),
(394846, 'PTHR46128:SF219', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394847, 'PTHR46128:SF31', NULL, NULL, NULL, NULL, '', 249509),
(394848, 'PTHR46128:SF338', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394849, 'PTHR46128:SF218', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394850, 'PTHR46128:SF339', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394851, 'PTHR46128:SF336', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 249509),
(394852, 'PTHR46128:SF337', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT 336', 249509),
(394853, 'PTHR46128:SF216', NULL, NULL, NULL, NULL, '', 249509),
(394854, 'PTHR46128:SF39', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394855, 'PTHR46128:SF125', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394856, 'PTHR46128:SF247', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394857, 'PTHR46128:SF126', NULL, NULL, NULL, NULL, '', 249509),
(394858, 'PTHR46128:SF123', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394859, 'PTHR46128:SF245', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394860, 'PTHR46128:SF124', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394861, 'PTHR46128:SF121', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394862, 'PTHR46128:SF122', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394863, 'PTHR46128:SF240', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394864, 'PTHR46128', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL GROUP I INTRON SPLICING FACTOR CCM1', 249509),
(394865, 'PTHR46128:SF89', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394866, 'PTHR46128:SF88', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394867, 'PTHR46128:SF87', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394868, 'PTHR46128:SF86', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL GROUP I INTRON SPLICING FACTOR DMR1', 249509),
(394869, 'PTHR46128:SF129', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394870, 'PTHR46128:SF127', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394871, 'PTHR46128:SF248', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394872, 'PTHR46128:SF82', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394873, 'PTHR46128:SF249', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394874, 'PTHR46128:SF194', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394875, 'PTHR46128:SF195', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394876, 'PTHR46128:SF193', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(394877, 'PTHR46128:SF191', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394878, 'PTHR46128:SF114', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394879, 'PTHR46128:SF233', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394880, 'PTHR46128:SF234', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394881, 'PTHR46128:SF231', NULL, NULL, NULL, NULL, 'PROTEIN RF1, MITOCHONDRIAL-LIKE', 249509),
(394882, 'PTHR46128:SF198', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 249509),
(394883, 'PTHR46128:SF196', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN-RELATED', 249509),
(394884, 'PTHR46128:SF350', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394885, 'PTHR46128:SF351', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE (PPR) REPEAT-CONTAINING PROTEIN', 249509),
(394886, 'PTHR46128:SF230', NULL, NULL, NULL, NULL, 'BNAC06G40430D PROTEIN', 249509),
(394887, 'PTHR46128:SF98', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394888, 'PTHR46128:SF97', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394889, 'PTHR46128:SF96', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394890, 'PTHR46128:SF95', NULL, NULL, NULL, NULL, '', 249509),
(394891, 'PTHR46128:SF94', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394892, 'PTHR46128:SF116', NULL, NULL, NULL, NULL, 'BNAC04G02050D PROTEIN', 249509),
(394893, 'PTHR46128:SF117', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 249509),
(394894, 'PTHR28659:SF3', NULL, NULL, NULL, NULL, 'RETICULOPHAGY REGULATOR 1', 249510),
(394895, 'PTHR28659', NULL, NULL, NULL, NULL, '', 249510),
(394896, 'PTHR28659:SF1', NULL, NULL, NULL, NULL, 'RETICULOPHAGY REGULATOR 3', 249510),
(394897, 'PTHR28659:SF2', NULL, NULL, NULL, NULL, '', 249510),
(394898, 'PTHR46776:SF30', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR 4', 249511),
(394899, 'PTHR46776:SF31', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR 3', 249511),
(394900, 'PTHR46776:SF32', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR', 249511),
(394901, 'PTHR46776:SF33', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR 1', 249511),
(394902, 'PTHR46776:SF16', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR 6', 249511),
(394903, 'PTHR46776:SF38', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR-RELATED', 249511),
(394904, 'PTHR46776:SF39', NULL, NULL, NULL, NULL, 'CDI DOMAIN-CONTAINING PROTEIN', 249511),
(394905, 'PTHR46776:SF17', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR 6', 249511),
(394906, 'PTHR46776:SF18', NULL, NULL, NULL, NULL, 'CDI DOMAIN-CONTAINING PROTEIN', 249511),
(394907, 'PTHR46776:SF34', NULL, NULL, NULL, NULL, 'CDI DOMAIN-CONTAINING PROTEIN', 249511),
(394908, 'PTHR46776:SF12', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR 4-LIKE ISOFORM X1', 249511),
(394909, 'PTHR46776:SF35', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR-RELATED', 249511),
(394910, 'PTHR46776:SF36', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR 5', 249511),
(394911, 'PTHR46776:SF15', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR', 249511),
(394912, 'PTHR46776:SF37', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR', 249511),
(394913, 'PTHR46776:SF3', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR 5', 249511),
(394914, 'PTHR46776', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR 4-RELATED', 249511),
(394915, 'PTHR46776:SF7', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR FAMILY PROTEIN', 249511),
(394916, 'PTHR46776:SF20', NULL, NULL, NULL, NULL, 'BNAC08G08800D PROTEIN', 249511),
(394917, 'PTHR46776:SF8', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR 2', 249511),
(394918, 'PTHR46776:SF9', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR 7', 249511); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(394919, 'PTHR46776:SF27', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR 2', 249511),
(394920, 'PTHR46776:SF28', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR 3', 249511),
(394921, 'PTHR46776:SF24', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR', 249511),
(394922, 'PTHR46776:SF26', NULL, NULL, NULL, NULL, 'CDI DOMAIN-CONTAINING PROTEIN', 249511),
(394923, 'PTHR32444:SF217', NULL, NULL, NULL, NULL, 'PROTEIN KINASE FAMILY PROTEIN, PUTATIVE-RELATED', 249512),
(394924, 'PTHR32444:SF218', NULL, NULL, NULL, NULL, 'EPIDERMIS-SPECIFIC SECRETED GLYCOPROTEIN EP1-LIKE', 249512),
(394925, 'PTHR32444:SF215', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394926, 'PTHR32444:SF216', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394927, 'PTHR32444:SF219', NULL, NULL, NULL, NULL, 'BULB-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 249512),
(394928, 'PTHR32444:SF172', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394929, 'PTHR32444:SF171', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394930, 'PTHR32444:SF210', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN S6, PUTATIVE-RELATED', 249512),
(394931, 'PTHR32444:SF175', NULL, NULL, NULL, NULL, 'CELL ATTACHMENT PROTEIN IN SOMATIC EMBRYOGENESIS', 249512),
(394932, 'PTHR32444:SF43', NULL, NULL, NULL, NULL, 'OS04G0226600 PROTEIN', 249512),
(394933, 'PTHR32444:SF213', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394934, 'PTHR32444:SF214', NULL, NULL, NULL, NULL, 'APPLE DOMAIN-CONTAINING PROTEIN', 249512),
(394935, 'PTHR32444:SF211', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394936, 'PTHR32444:SF179', NULL, NULL, NULL, NULL, 'EP1-LIKE GLYCOPROTEIN 2', 249512),
(394937, 'PTHR32444:SF212', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 249512),
(394938, 'PTHR32444:SF107', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394939, 'PTHR32444:SF108', NULL, NULL, NULL, NULL, 'OS02G0527900 PROTEIN', 249512),
(394940, 'PTHR32444:SF226', NULL, NULL, NULL, NULL, 'BULB-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 249512),
(394941, 'PTHR32444:SF227', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394942, 'PTHR32444:SF106', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394943, 'PTHR32444:SF58', NULL, NULL, NULL, NULL, 'EP1-LIKE GLYCOPROTEIN 1', 249512),
(394944, 'PTHR32444:SF183', NULL, NULL, NULL, NULL, 'S-LOCUS LECTIN KINASE FAMILY PROTEIN', 249512),
(394945, 'PTHR32444:SF184', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394946, 'PTHR32444:SF181', NULL, NULL, NULL, NULL, 'EP1-LIKE GLYCOPROTEIN 4', 249512),
(394947, 'PTHR32444:SF182', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394948, 'PTHR32444:SF220', NULL, NULL, NULL, NULL, 'G-TYPE LECTIN S-RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394949, 'PTHR32444:SF221', NULL, NULL, NULL, NULL, 'S-LOCUS GLYCOPROTEIN DOMAIN, BULB-TYPE LECTIN DOMAIN, PAN/APPLE DOMAIN PROTEIN-RELATED', 249512),
(394950, 'PTHR32444:SF185', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394951, 'PTHR32444:SF51', NULL, NULL, NULL, NULL, 'BULB-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 249512),
(394952, 'PTHR32444:SF186', NULL, NULL, NULL, NULL, 'BULB-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 249512),
(394953, 'PTHR32444:SF103', NULL, NULL, NULL, NULL, 'PAN DOMAIN-CONTAINING PROTEIN', 249512),
(394954, 'PTHR32444:SF224', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 249512),
(394955, 'PTHR32444:SF104', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394956, 'PTHR32444:SF225', NULL, NULL, NULL, NULL, 'BNACNNG38150D PROTEIN', 249512),
(394957, 'PTHR32444:SF222', NULL, NULL, NULL, NULL, 'OS08G0236400 PROTEIN', 249512);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(394958, 'PTHR32444:SF189', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394959, 'PTHR32444:SF102', NULL, NULL, NULL, NULL, 'S-LOCUS-SPECIFIC GLYCOPROTEIN S13', 249512),
(394960, 'PTHR32444:SF223', NULL, NULL, NULL, NULL, 'BNAANNG22710D PROTEIN', 249512),
(394961, 'PTHR32444:SF118', NULL, NULL, NULL, NULL, 'OS01G0783900 PROTEIN', 249512),
(394962, 'PTHR32444:SF117', NULL, NULL, NULL, NULL, 'OS11G0208700 PROTEIN', 249512),
(394963, 'PTHR32444:SF191', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394964, 'PTHR32444:SF68', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394965, 'PTHR32444:SF194', NULL, NULL, NULL, NULL, 'BULB-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 249512),
(394966, 'PTHR32444:SF195', NULL, NULL, NULL, NULL, 'G-TYPE LECTIN S-RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE CES101', 249512),
(394967, 'PTHR32444:SF192', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394968, 'PTHR32444:SF193', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394969, 'PTHR32444:SF198', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394970, 'PTHR32444:SF60', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394971, 'PTHR32444:SF199', NULL, NULL, NULL, NULL, 'S-LOCUS GLYCOPROTEIN DOMAIN-CONTAINING PROTEIN-RELATED', 249512),
(394972, 'PTHR32444:SF63', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394973, 'PTHR32444:SF196', NULL, NULL, NULL, NULL, 'S-LOCUS GLYCOPROTEIN FAMILY PROTEIN', 249512),
(394974, 'PTHR32444:SF197', NULL, NULL, NULL, NULL, 'S GLYCOPROTEIN', 249512),
(394975, 'PTHR32444:SF115', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394976, 'PTHR32444:SF66', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394977, 'PTHR32444:SF127', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 249512),
(394978, 'PTHR32444:SF128', NULL, NULL, NULL, NULL, 'CURCULIN-LIKE (MANNOSE-BINDING) LECTIN FAMILY PROTEIN', 249512),
(394979, 'PTHR32444:SF121', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394980, 'PTHR32444:SF122', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394981, 'PTHR32444:SF73', NULL, NULL, NULL, NULL, 'RECEPTOR KINASE', 249512),
(394982, 'PTHR32444:SF120', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394983, 'PTHR32444:SF125', NULL, NULL, NULL, NULL, 'BULB-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 249512),
(394984, 'PTHR32444:SF126', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE', 249512),
(394985, 'PTHR32444:SF78', NULL, NULL, NULL, NULL, 'G-TYPE LECTIN S-RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE LECRK3', 249512),
(394986, 'PTHR32444', NULL, NULL, NULL, NULL, 'BULB-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 249512),
(394987, 'PTHR32444:SF77', NULL, NULL, NULL, NULL, 'OS05G0163500 PROTEIN', 249512),
(394988, 'PTHR32444:SF139', NULL, NULL, NULL, NULL, 'OS09G0551150 PROTEIN', 249512),
(394989, 'PTHR32444:SF90', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394990, 'PTHR32444:SF83', NULL, NULL, NULL, NULL, 'BULB-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 249512),
(394991, 'PTHR32444:SF132', NULL, NULL, NULL, NULL, 'BULB-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 249512),
(394992, 'PTHR32444:SF130', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394993, 'PTHR32444:SF134', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394994, 'PTHR32444:SF89', NULL, NULL, NULL, NULL, 'INACTIVE G-TYPE LECTIN S-RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE SRK-RELATED', 249512),
(394995, 'PTHR32444:SF149', NULL, NULL, NULL, NULL, 'S-LOCUS-SPECIFIC GLYCOPROTEIN BS29-2-RELATED', 249512),
(394996, 'PTHR32444:SF94', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(394997, 'PTHR32444:SF143', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394998, 'PTHR32444:SF93', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(394999, 'PTHR32444:SF96', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(395000, 'PTHR32444:SF95', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(395001, 'PTHR32444:SF142', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 6', 249512),
(395002, 'PTHR32444:SF98', NULL, NULL, NULL, NULL, 'BULB-TYPE LECTIN DOMAIN-CONTAINING PROTEIN-RELATED', 249512),
(395003, 'PTHR32444:SF10', NULL, NULL, NULL, NULL, 'CURCULIN-LIKE (MANNOSE-BINDING) LECTIN FAMILY PROTEIN-RELATED', 249512),
(395004, 'PTHR32444:SF145', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE', 249512),
(395005, 'PTHR32444:SF99', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(395006, 'PTHR32444:SF150', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(395007, 'PTHR32444:SF6', NULL, NULL, NULL, NULL, 'D-MANNOSE BINDING LECTIN PROTEIN WITH APPLE-LIKE CARBOHYDRATE-BINDING DOMAIN-CONTAINING PROTEIN', 249512),
(395008, 'PTHR32444:SF158', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(395009, 'PTHR32444:SF159', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(395010, 'PTHR32444:SF206', NULL, NULL, NULL, NULL, 'BNAC02G16590D PROTEIN', 249512),
(395011, 'PTHR32444:SF207', NULL, NULL, NULL, NULL, 'BULB-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 249512),
(395012, 'PTHR32444:SF204', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(395013, 'PTHR32444:SF205', NULL, NULL, NULL, NULL, '', 249512),
(395014, 'PTHR32444:SF208', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE SD1-8', 249512),
(395015, 'PTHR32444:SF209', NULL, NULL, NULL, NULL, 'EPIDERMIS-SPECIFIC SECRETED GLYCOPROTEIN EP1-LIKE', 249512),
(395016, 'PTHR32444:SF160', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(395017, 'PTHR32444:SF166', NULL, NULL, NULL, NULL, '', 249512),
(395018, 'PTHR32444:SF30', NULL, NULL, NULL, NULL, 'OS11G0149900 PROTEIN', 249512),
(395019, 'PTHR32444:SF202', NULL, NULL, NULL, NULL, 'OS06G0619200 PROTEIN', 249512),
(395020, 'PTHR32444:SF203', NULL, NULL, NULL, NULL, 'BULB-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 249512),
(395021, 'PTHR32444:SF200', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 249512),
(395022, 'PTHR32444:SF201', NULL, NULL, NULL, NULL, 'BULB-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 249512),
(395023, 'PTHR16465:SF0', NULL, NULL, NULL, NULL, 'ZINC FINGER MATRIN-TYPE PROTEIN 5', 249513),
(395024, 'PTHR16465', NULL, NULL, NULL, NULL, 'NUCLEASE-RELATED', 249513),
(395025, 'PTHR11493:SF54', NULL, NULL, NULL, NULL, 'ANAEROBIC SULFITE REDUCTASE SUBUNIT C', 249514),
(395026, 'PTHR11493:SF61', NULL, NULL, NULL, NULL, 'ASSIMILATORY SULFITE REDUCTASE (FERREDOXIN)', 249514),
(395027, 'PTHR11493:SF47', NULL, NULL, NULL, NULL, 'SULFITE REDUCTASE [NADPH] SUBUNIT BETA', 249514),
(395028, 'PTHR11493', NULL, NULL, NULL, NULL, 'SULFITE REDUCTASE [NADPH] SUBUNIT BETA-RELATED', 249514),
(395029, 'PTHR13481', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 249515),
(395030, 'PTHR13481:SF0', NULL, NULL, NULL, NULL, 'SREBP REGULATING GENE PROTEIN', 249515),
(395031, 'PTHR47648', NULL, NULL, NULL, NULL, 'KILLER CELL LECTIN-LIKE RECEPTOR SUBFAMILY G MEMBER 1', 249516),
(395032, 'PTHR47648:SF1', NULL, NULL, NULL, NULL, 'KILLER CELL LECTIN-LIKE RECEPTOR SUBFAMILY G MEMBER 1', 249516),
(395033, 'PTHR12048:SF0', NULL, NULL, NULL, NULL, 'CCAAT/ENHANCER-BINDING PROTEIN ZETA', 249517),
(395034, 'PTHR12048', NULL, NULL, NULL, NULL, 'CCAAT-BINDING FACTOR-RELATED', 249517),
(395035, 'PTHR28264', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 7A', 249518),
(395036, 'PTHR28264:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 6C', 249518);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(395037, 'PTHR40037:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOESTERASE SAOUHSC_00951-RELATED', 249519),
(395038, 'PTHR40037', NULL, NULL, NULL, NULL, 'PHOSPHOESTERASE YJCG-RELATED', 249519),
(395039, 'PTHR47365:SF1', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249520),
(395040, 'PTHR47365:SF3', NULL, NULL, NULL, NULL, '', 249520),
(395041, 'PTHR47365:SF2', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 23', 249520),
(395042, 'PTHR47365', NULL, NULL, NULL, NULL, 'PLANT PROTEIN, PUTATIVE-RELATED', 249520),
(395043, 'PTHR43653:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME C-TYPE BIOGENESIS PROTEIN CCMF', 249521),
(395044, 'PTHR43653:SF4', NULL, NULL, NULL, NULL, 'CYTOCHROME C BIOGENESIS CCMF N-TERMINAL-LIKE MITOCHONDRIAL PROTEIN 1-RELATED', 249521),
(395045, 'PTHR43653:SF3', NULL, NULL, NULL, NULL, 'CYTOCHROME C-TYPE BIOGENESIS PROTEIN NRFE-RELATED', 249521),
(395046, 'PTHR43653', NULL, NULL, NULL, NULL, 'CYTOCHROME C ASSEMBLY PROTEIN-RELATED', 249521),
(395047, 'PTHR10465', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE GTPASE FZO1', 249522),
(395048, 'PTHR10465:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE GTPASE MARF-RELATED', 249522),
(395049, 'PTHR10465:SF4', NULL, NULL, NULL, NULL, '', 249522),
(395050, 'PTHR10465:SF1', NULL, NULL, NULL, NULL, 'MITOFUSIN-2', 249522),
(395051, 'PTHR10465:SF2', NULL, NULL, NULL, NULL, 'MITOFUSIN-1', 249522),
(395052, 'PTHR10465:SF0', NULL, NULL, NULL, NULL, 'SARCALUMENIN', 249522),
(395053, 'PTHR28630:SF26', NULL, NULL, NULL, NULL, 'OS03G0729300 PROTEIN', 249523),
(395054, 'PTHR28630', NULL, NULL, NULL, NULL, '', 249523),
(395055, 'PTHR28630:SF24', NULL, NULL, NULL, NULL, '', 249523),
(395056, 'PTHR28630:SF29', NULL, NULL, NULL, NULL, 'PROSTAMIDE/PROSTAGLANDIN F SYNTHASE', 249523),
(395057, 'PTHR28630:SF28', NULL, NULL, NULL, NULL, 'PROSTAMIDE/PROSTAGLANDIN F SYNTHASE', 249523),
(395058, 'PTHR28630:SF30', NULL, NULL, NULL, NULL, 'PEROXIREDOXIN-LIKE 2A', 249523),
(395059, 'PTHR28630:SF23', NULL, NULL, NULL, NULL, 'THIOREDOXIN SUPERFAMILY PROTEIN', 249523),
(395060, 'PTHR28630:SF11', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE PROTEIN AAED1, CHLOROPLASTIC', 249523),
(395061, 'PTHR28630:SF3', NULL, NULL, NULL, NULL, 'PEROXIREDOXIN-LIKE 2C', 249523),
(395062, 'PTHR28630:SF32', NULL, NULL, NULL, NULL, '', 249523),
(395063, 'PTHR28630:SF31', NULL, NULL, NULL, NULL, 'PEROXIREDOXIN-LIKE 2 ACTIVATED IN M-CSF STIMULATED MONOCYTES', 249523),
(395064, 'PTHR36386', NULL, NULL, NULL, NULL, 'OS06G0683900 PROTEIN', 249524),
(395065, 'PTHR36386:SF1', NULL, NULL, NULL, NULL, 'OS06G0683900 PROTEIN', 249524),
(395066, 'PTHR13326:SF23', NULL, NULL, NULL, NULL, '', 249525),
(395067, 'PTHR13326:SF21', NULL, NULL, NULL, NULL, 'PSEUDOURIDYLATE SYNTHASE 7 HOMOLOG', 249525),
(395068, 'PTHR13326:SF30', NULL, NULL, NULL, NULL, 'PSEUDOURIDYLATE SYNTHASE 7 HOMOLOG-LIKE PROTEIN', 249525),
(395069, 'PTHR13326:SF19', NULL, NULL, NULL, NULL, 'PSEUDOURIDINE SYNTHASE, PUTATIVE-RELATED', 249525),
(395070, 'PTHR13326:SF28', NULL, NULL, NULL, NULL, '', 249525),
(395071, 'PTHR13326', NULL, NULL, NULL, NULL, 'TRNA PSEUDOURIDINE SYNTHASE D', 249525),
(395072, 'PTHR13326:SF8', NULL, NULL, NULL, NULL, 'PSEUDOURIDINE SYNTHASE FAMILY PROTEIN', 249525),
(395073, 'PTHR13326:SF26', NULL, NULL, NULL, NULL, 'TRUD DOMAIN-CONTAINING PROTEIN', 249525),
(395074, 'PTHR13326:SF27', NULL, NULL, NULL, NULL, 'TRUD DOMAIN-CONTAINING PROTEIN', 249525),
(395075, 'PTHR13326:SF24', NULL, NULL, NULL, NULL, 'TRUD DOMAIN-CONTAINING PROTEIN', 249525),
(395076, 'PTHR13326:SF25', NULL, NULL, NULL, NULL, '', 249525),
(395077, 'PTHR22379', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4930407I10 GENE', 249526),
(395078, 'PTHR22379:SF1', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4930407I10 GENE', 249526),
(395079, 'PTHR30348:SF9', NULL, NULL, NULL, NULL, 'UPF0759 PROTEIN YECE', 249527),
(395080, 'PTHR30348:SF13', NULL, NULL, NULL, NULL, 'UPF0759 PROTEIN YUNF', 249527),
(395081, 'PTHR30348', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN YECE', 249527),
(395082, 'PTHR30348:SF14', NULL, NULL, NULL, NULL, 'BLR8050 PROTEIN', 249527),
(395083, 'PTHR30348:SF4', NULL, NULL, NULL, NULL, 'BLR5641 PROTEIN', 249527); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(395084, 'PTHR28666:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 240', 249528),
(395085, 'PTHR28666', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 240', 249528),
(395086, 'PTHR34476', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT OMEGA', 249529),
(395087, 'PTHR34476:SF1', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT OMEGA', 249529),
(395088, 'PTHR10291', NULL, NULL, NULL, NULL, 'DEHYDRODOLICHYL DIPHOSPHATE SYNTHASE FAMILY MEMBER', 249530),
(395089, 'PTHR10291:SF19', NULL, NULL, NULL, NULL, 'ALKYL TRANSFERASE', 249530),
(395090, 'PTHR10291:SF35', NULL, NULL, NULL, NULL, 'ALKYL TRANSFERASE', 249530),
(395091, 'PTHR10291:SF33', NULL, NULL, NULL, NULL, 'ALKYL TRANSFERASE', 249530),
(395092, 'PTHR10291:SF18', NULL, NULL, NULL, NULL, 'DEHYDRODOLICHYL DIPHOSPHATE SYNTHASE CPT3', 249530),
(395093, 'PTHR10291:SF17', NULL, NULL, NULL, NULL, 'ALKYL TRANSFERASE', 249530),
(395094, 'PTHR10291:SF16', NULL, NULL, NULL, NULL, '(2Z,6Z)-FARNESYL DIPHOSPHATE SYNTHASE CPT6, CHLOROPLASTIC', 249530),
(395095, 'PTHR10291:SF38', NULL, NULL, NULL, NULL, 'ALKYL TRANSFERASE', 249530),
(395096, 'PTHR10291:SF15', NULL, NULL, NULL, NULL, 'ALKYL TRANSFERASE', 249530),
(395097, 'PTHR10291:SF32', NULL, NULL, NULL, NULL, 'ALKYL TRANSFERASE', 249530),
(395098, 'PTHR10291:SF31', NULL, NULL, NULL, NULL, 'ALKYL TRANSFERASE', 249530),
(395099, 'PTHR10291:SF25', NULL, NULL, NULL, NULL, 'ALKYL TRANSFERASE-RELATED', 249530),
(395100, 'PTHR10291:SF46', NULL, NULL, NULL, NULL, 'CIS-PRENYLTRANSFERASE 4, CHLOROPLASTIC', 249530),
(395101, 'PTHR10291:SF24', NULL, NULL, NULL, NULL, 'ALKYL TRANSFERASE', 249530),
(395102, 'PTHR10291:SF23', NULL, NULL, NULL, NULL, 'ALKYL TRANSFERASE', 249530),
(395103, 'PTHR10291:SF45', NULL, NULL, NULL, NULL, 'ALKYL TRANSFERASE', 249530),
(395104, 'PTHR10291:SF22', NULL, NULL, NULL, NULL, 'NERYLNERYL DIPHOSPHATE SYNTHASE CPT2, CHLOROPLASTIC', 249530),
(395105, 'PTHR10291:SF44', NULL, NULL, NULL, NULL, 'DUF2236 DOMAIN-CONTAINING PROTEIN', 249530),
(395106, 'PTHR10291:SF28', NULL, NULL, NULL, NULL, 'UNDECAPRENYL DIPHOSPHATE SYNTHASE', 249530),
(395107, 'PTHR10291:SF27', NULL, NULL, NULL, NULL, 'ALKYL TRANSFERASE', 249530),
(395108, 'PTHR10291:SF26', NULL, NULL, NULL, NULL, 'ALKYL TRANSFERASE', 249530),
(395109, 'PTHR10291:SF0', NULL, NULL, NULL, NULL, 'DEHYDRODOLICHYL DIPHOSPHATE SYNTHASE 2', 249530),
(395110, 'PTHR10291:SF2', NULL, NULL, NULL, NULL, 'DEHYDRODOLICHYL DIPHOSPHATE SYNTHASE COMPLEX SUBUNIT SRT1', 249530),
(395111, 'PTHR10291:SF43', NULL, NULL, NULL, NULL, 'DEHYDRODOLICHYL DIPHOSPHATE SYNTHASE COMPLEX SUBUNIT DHDDS', 249530),
(395112, 'PTHR10291:SF42', NULL, NULL, NULL, NULL, 'DEHYDRODOLICHYL DIPHOSPHATE SYNTHASE 7-RELATED', 249530),
(395113, 'PTHR10291:SF20', NULL, NULL, NULL, NULL, 'DEHYDRODOLICHYL DIPHOSPHATE SYNTHASE 5', 249530),
(395114, 'PTHR10291:SF41', NULL, NULL, NULL, NULL, 'CIS-PRENYLTRANSFERASE 7, CHLOROPLASTIC', 249530),
(395115, 'PTHR10291:SF40', NULL, NULL, NULL, NULL, 'ALKYL TRANSFERASE', 249530),
(395116, 'PTHR35688', NULL, NULL, NULL, NULL, 'NAD(P)-LINKED OXIDOREDUCTASE SUPERFAMILY PROTEIN', 249531),
(395117, 'PTHR35688:SF2', NULL, NULL, NULL, NULL, 'NAD(P)-LINKED OXIDOREDUCTASE SUPERFAMILY PROTEIN', 249531),
(395118, 'PTHR12972', NULL, NULL, NULL, NULL, 'DOWNSTREAM NEIGHBOR OF SON', 249532),
(395119, 'PTHR12972:SF0', NULL, NULL, NULL, NULL, 'PROTEIN DOWNSTREAM NEIGHBOR OF SON', 249532),
(395120, 'PTHR12972:SF1', NULL, NULL, NULL, NULL, '', 249532),
(395121, 'PTHR30294:SF46', NULL, NULL, NULL, NULL, 'ABC-TYPE EFFLUX SYSTEM PERMEASE COMPONENT 2', 249533),
(395122, 'PTHR30294:SF45', NULL, NULL, NULL, NULL, 'LINEARMYCIN RESISTANCE PERMEASE PROTEIN LNRM', 249533),
(395123, 'PTHR30294:SF48', NULL, NULL, NULL, NULL, 'CYTOLYSIN ABC TRANSPORTER-RELATED', 249533),
(395124, 'PTHR30294:SF47', NULL, NULL, NULL, NULL, 'ABC-TYPE EFFLUX SYSTEM PERMEASE COMPONENT 1', 249533),
(395125, 'PTHR30294:SF31', NULL, NULL, NULL, NULL, 'INNER MEMBRANE TRANSPORT PERMEASE YHHJ', 249533),
(395126, 'PTHR30294:SF44', NULL, NULL, NULL, NULL, 'MULTIDRUG ABC TRANSPORTER PERMEASE YBHR-RELATED', 249533);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(395127, 'PTHR30294', NULL, NULL, NULL, NULL, 'MEMBRANE COMPONENT OF ABC TRANSPORTER YHHJ-RELATED', 249533),
(395128, 'PTHR30294:SF49', NULL, NULL, NULL, NULL, 'ABC-TYPE SODIUM EFFLUX PUMP SYSTEM, PERMEASE COMPONENT', 249533),
(395129, 'PTHR30294:SF38', NULL, NULL, NULL, NULL, 'LINEARMYCIN RESISTANCE PERMEASE PROTEIN LNRN', 249533),
(395130, 'PTHR30294:SF29', NULL, NULL, NULL, NULL, 'MULTIDRUG ABC TRANSPORTER PERMEASE YBHS-RELATED', 249533),
(395131, 'PTHR46149:SF7', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAP-1B', 249534),
(395132, 'PTHR46149:SF5', NULL, NULL, NULL, NULL, 'SMALL MONOMERIC GTPASE', 249534),
(395133, 'PTHR46149:SF4', NULL, NULL, NULL, NULL, 'DEXAMETHASONE-INDUCED RAS-RELATED PROTEIN 1', 249534),
(395134, 'PTHR46149:SF3', NULL, NULL, NULL, NULL, 'MIP08469P', 249534),
(395135, 'PTHR46149:SF2', NULL, NULL, NULL, NULL, 'SMALL MONOMERIC GTPASE', 249534),
(395136, 'PTHR46149:SF1', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN RHES', 249534),
(395137, 'PTHR46149', NULL, NULL, NULL, NULL, 'MIP08469P', 249534),
(395138, 'PTHR30246', NULL, NULL, NULL, NULL, '2-KETO-3-DEOXY-6-PHOSPHOGLUCONATE ALDOLASE', 249535),
(395139, 'PTHR30246:SF1', NULL, NULL, NULL, NULL, '2-DEHYDRO-3-DEOXY-6-PHOSPHOGALACTONATE ALDOLASE-RELATED', 249535),
(395140, 'PTHR30325', NULL, NULL, NULL, NULL, 'MEMBRANE COMPONENT OF ABC TRANSPORTER', 249536),
(395141, 'PTHR30325:SF0', NULL, NULL, NULL, NULL, 'INNER MEMBRANE ABC TRANSPORTER PERMEASE PROTEIN YEJE', 249536),
(395142, 'PTHR34531:SF1', NULL, NULL, NULL, NULL, 'ZGC:153352', 249537),
(395143, 'PTHR34531', NULL, NULL, NULL, NULL, 'ZGC:153352', 249537),
(395144, 'PTHR36964:SF1', NULL, NULL, NULL, NULL, 'PROTEIN-METHIONINE-SULFOXIDE REDUCTASE HEME-BINDING SUBUNIT MSRQ', 249538),
(395145, 'PTHR36964', NULL, NULL, NULL, NULL, 'PROTEIN-METHIONINE-SULFOXIDE REDUCTASE HEME-BINDING SUBUNIT MSRQ', 249538),
(395146, 'PTHR47406:SF2', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_67N DOMAIN-CONTAINING PROTEIN', 249539),
(395147, 'PTHR47406', NULL, NULL, NULL, NULL, 'COAGULATION FACTOR 5/8 TYPE, C-TERMINAL', 249539),
(395148, 'PTHR43469:SF1', NULL, NULL, NULL, NULL, 'DISULFIDE FORMATION PROTEIN-RELATED', 249540),
(395149, 'PTHR43469', NULL, NULL, NULL, NULL, 'DISULFIDE FORMATION PROTEIN-RELATED', 249540),
(395150, 'PTHR31100:SF52', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 249541),
(395151, 'PTHR31100:SF2', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN 18-RELATED', 249541),
(395152, 'PTHR31100:SF96', NULL, NULL, NULL, NULL, 'OS01G0246601 PROTEIN', 249541),
(395153, 'PTHR31100:SF3', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN 20', 249541),
(395154, 'PTHR31100:SF73', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 249541),
(395155, 'PTHR31100:SF51', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN 29', 249541),
(395156, 'PTHR31100:SF54', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN 28-LIKE', 249541),
(395157, 'PTHR31100:SF98', NULL, NULL, NULL, NULL, 'PPC DOMAIN-CONTAINING PROTEIN-RELATED', 249541),
(395158, 'PTHR31100:SF97', NULL, NULL, NULL, NULL, 'PPC DOMAIN-CONTAINING PROTEIN', 249541),
(395159, 'PTHR31100:SF53', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 249541),
(395160, 'PTHR31100:SF75', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 249541),
(395161, 'PTHR31100:SF6', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 249541),
(395162, 'PTHR31100:SF70', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 249541),
(395163, 'PTHR31100:SF16', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN 25', 249541),
(395164, 'PTHR31100:SF59', NULL, NULL, NULL, NULL, 'OS02G0713700 PROTEIN', 249541),
(395165, 'PTHR31100:SF15', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN 24-RELATED', 249541),
(395166, 'PTHR31100:SF56', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 249541),
(395167, 'PTHR31100:SF55', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN 27', 249541);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(395168, 'PTHR31100:SF99', NULL, NULL, NULL, NULL, 'PPC DOMAIN-CONTAINING PROTEIN', 249541),
(395169, 'PTHR31100:SF77', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 249541),
(395170, 'PTHR31100:SF14', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN 15', 249541),
(395171, 'PTHR31100:SF79', NULL, NULL, NULL, NULL, 'BNAA06G19560D PROTEIN', 249541),
(395172, 'PTHR31100:SF100', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 249541),
(395173, 'PTHR31100:SF8', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN 19', 249541),
(395174, 'PTHR31100', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN 15', 249541),
(395175, 'PTHR31100:SF63', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 249541),
(395176, 'PTHR31100:SF62', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN 23', 249541),
(395177, 'PTHR31100:SF87', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 249541),
(395178, 'PTHR31100:SF65', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 249541),
(395179, 'PTHR31100:SF86', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN 23-LIKE', 249541),
(395180, 'PTHR31100:SF20', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 249541),
(395181, 'PTHR31100:SF80', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 249541),
(395182, 'PTHR31100:SF83', NULL, NULL, NULL, NULL, 'PPC DOMAIN-CONTAINING PROTEIN', 249541),
(395183, 'PTHR31100:SF82', NULL, NULL, NULL, NULL, 'PPC DOMAIN-CONTAINING PROTEIN', 249541),
(395184, 'PTHR31100:SF49', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE, EXPRESSED-RELATED', 249541),
(395185, 'PTHR31100:SF48', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN 16', 249541),
(395186, 'PTHR31100:SF67', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN 21', 249541),
(395187, 'PTHR31100:SF89', NULL, NULL, NULL, NULL, 'OS08G0478466 PROTEIN', 249541),
(395188, 'PTHR31100:SF66', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 249541),
(395189, 'PTHR31100:SF88', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN', 249541),
(395190, 'PTHR31100:SF69', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN 17-RELATED', 249541),
(395191, 'PTHR31100:SF68', NULL, NULL, NULL, NULL, 'PPC DOMAIN-CONTAINING PROTEIN', 249541),
(395192, 'PTHR31100:SF46', NULL, NULL, NULL, NULL, 'OS06G0136900 PROTEIN', 249541),
(395193, 'PTHR16777:SF2', NULL, NULL, NULL, NULL, 'PROTEIN ECT2', 249542),
(395194, 'PTHR16777', NULL, NULL, NULL, NULL, 'PROTEIN ECT2', 249542),
(395195, 'PTHR47260', NULL, NULL, NULL, NULL, 'UPF0644 PROTEIN PB2B4.06', 249543),
(395196, 'PTHR47260:SF1', NULL, NULL, NULL, NULL, 'UPF0644 PROTEIN PB2B4.06', 249543),
(395197, 'PTHR47260:SF3', NULL, NULL, NULL, NULL, 'THIOESTERASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_7G03960)', 249543),
(395198, 'PTHR47260:SF2', NULL, NULL, NULL, NULL, '4HBT DOMAIN-CONTAINING PROTEIN-RELATED', 249543),
(395199, 'PTHR47260:SF5', NULL, NULL, NULL, NULL, 'THIOESTERASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_6G02390)', 249543),
(395200, 'PTHR47260:SF4', NULL, NULL, NULL, NULL, 'MIOREX COMPLEX COMPONENT 3', 249543),
(395201, 'PTHR47260:SF6', NULL, NULL, NULL, NULL, '4HBT DOMAIN-CONTAINING PROTEIN', 249543),
(395202, 'PTHR11753:SF45', NULL, NULL, NULL, NULL, 'AP-1 COMPLEX SUBUNIT SIGMA-2', 249544),
(395203, 'PTHR11753:SF42', NULL, NULL, NULL, NULL, 'AP COMPLEX SUBUNIT SIGMA', 249544),
(395204, 'PTHR11753:SF20', NULL, NULL, NULL, NULL, 'AP-1 COMPLEX SUBUNIT SIGMA-2', 249544),
(395205, 'PTHR11753:SF40', NULL, NULL, NULL, NULL, 'AP-1 COMPLEX SUBUNIT SIGMA-1', 249544),
(395206, 'PTHR11753:SF60', NULL, NULL, NULL, NULL, 'AP COMPLEX SUBUNIT SIGMA', 249544),
(395207, 'PTHR11753', NULL, NULL, NULL, NULL, 'ADAPTOR COMPLEXES SMALL SUBUNIT FAMILY', 249544),
(395208, 'PTHR11753:SF47', NULL, NULL, NULL, NULL, 'AP-2 COMPLEX SUBUNIT SIGMA', 249544),
(395209, 'PTHR11753:SF6', NULL, NULL, NULL, NULL, 'AP-2 COMPLEX SUBUNIT SIGMA', 249544); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(395210, 'PTHR11753:SF55', NULL, NULL, NULL, NULL, 'AP COMPLEX SUBUNIT SIGMA', 249544),
(395211, 'PTHR11753:SF34', NULL, NULL, NULL, NULL, 'AP COMPLEX SUBUNIT SIGMA', 249544),
(395212, 'PTHR11753:SF12', NULL, NULL, NULL, NULL, 'AP-3 COMPLEX SUBUNIT SIGMA-1', 249544),
(395213, 'PTHR11753:SF53', NULL, NULL, NULL, NULL, 'ADAPTOR RELATED PROTEIN COMPLEX 4 SUBUNIT SIGMA 1', 249544),
(395214, 'PTHR11753:SF10', NULL, NULL, NULL, NULL, 'AP-3 COMPLEX SUBUNIT SIGMA-2', 249544),
(395215, 'PTHR11753:SF51', NULL, NULL, NULL, NULL, 'AP COMPLEX SUBUNIT SIGMA', 249544),
(395216, 'PTHR11753:SF2', NULL, NULL, NULL, NULL, 'ADAPTOR PROTEIN COMPLEX AP-3 SMALL CHAIN SIGMA3', 249544),
(395217, 'PTHR11753:SF5', NULL, NULL, NULL, NULL, 'AP COMPLEX SUBUNIT SIGMA', 249544),
(395218, 'PTHR11753:SF50', NULL, NULL, NULL, NULL, 'AP COMPLEX SUBUNIT SIGMA', 249544),
(395219, 'PTHR11753:SF4', NULL, NULL, NULL, NULL, 'CLAT_ADAPTOR_S DOMAIN-CONTAINING PROTEIN', 249544),
(395220, 'PTHR11753:SF19', NULL, NULL, NULL, NULL, 'AP-1 COMPLEX SUBUNIT SIGMA-2', 249544),
(395221, 'PTHR11753:SF18', NULL, NULL, NULL, NULL, 'AP-1 COMPLEX SUBUNIT SIGMA-3', 249544),
(395222, 'PTHR11753:SF59', NULL, NULL, NULL, NULL, 'AP-1 COMPLEX SUBUNIT SIGMA-2', 249544),
(395223, 'PTHR11753:SF38', NULL, NULL, NULL, NULL, 'AP COMPLEX SUBUNIT SIGMA', 249544),
(395224, 'PTHR11753:SF35', NULL, NULL, NULL, NULL, 'AP COMPLEX SUBUNIT SIGMA', 249544),
(395225, 'PTHR11753:SF57', NULL, NULL, NULL, NULL, 'AP-4 COMPLEX SUBUNIT SIGMA-1', 249544),
(395226, 'PTHR11753:SF14', NULL, NULL, NULL, NULL, 'AP-1 COMPLEX SUBUNIT SIGMA-1A', 249544),
(395227, 'PTHR11753:SF58', NULL, NULL, NULL, NULL, 'CLAT_ADAPTOR_S DOMAIN-CONTAINING PROTEIN', 249544),
(395228, 'PTHR47486:SF1', NULL, NULL, NULL, NULL, 'SIALYLTRANSFERASE-LIKE PROTEIN 1', 249545),
(395229, 'PTHR47486', NULL, NULL, NULL, NULL, 'SIALYLTRANSFERASE-LIKE PROTEIN 1', 249545),
(395230, 'PTHR40462', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 249546),
(395231, 'PTHR40462:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 249546),
(395232, 'PTHR43764', NULL, NULL, NULL, NULL, 'MOLYBDENUM COFACTOR BIOSYNTHESIS', 249547),
(395233, 'PTHR43764:SF1', NULL, NULL, NULL, NULL, 'MOLYBDOPTERIN MOLYBDENUMTRANSFERASE', 249547),
(395234, 'PTHR23272:SF158', NULL, NULL, NULL, NULL, 'BED-TYPE DOMAIN-CONTAINING PROTEIN', 249548),
(395235, 'PTHR23272:SF135', NULL, NULL, NULL, NULL, 'DIMER_TNP_HAT DOMAIN-CONTAINING PROTEIN', 249548),
(395236, 'PTHR23272:SF154', NULL, NULL, NULL, NULL, 'ZINC FINGER BED DOMAIN-CONTAINING PROTEIN RICESLEEPER 3-LIKE', 249548),
(395237, 'PTHR23272:SF132', NULL, NULL, NULL, NULL, 'ZINC FINGER BED DOMAIN-CONTAINING PROTEIN RICESLEEPER 1-LIKE ISOFORM X1', 249548),
(395238, 'PTHR23272:SF15', NULL, NULL, NULL, NULL, 'BED-TYPE DOMAIN-CONTAINING PROTEIN', 249548),
(395239, 'PTHR23272:SF139', NULL, NULL, NULL, NULL, 'BED-TYPE DOMAIN-CONTAINING PROTEIN', 249548),
(395240, 'PTHR23272', NULL, NULL, NULL, NULL, 'BED FINGER-RELATED', 249548),
(395241, 'PTHR23272:SF52', NULL, NULL, NULL, NULL, 'ZINC FINGER BED DOMAIN-CONTAINING PROTEIN DAYSLEEPER', 249548),
(395242, 'PTHR23272:SF161', NULL, NULL, NULL, NULL, 'OS01G0698300 PROTEIN', 249548),
(395243, 'PTHR23272:SF169', NULL, NULL, NULL, NULL, 'ZINC FINGER BED DOMAIN-CONTAINING PROTEIN DAYSLEEPER', 249548),
(395244, 'PTHR23272:SF168', NULL, NULL, NULL, NULL, 'DUF4413 DOMAIN-CONTAINING PROTEIN', 249548),
(395245, 'PTHR23272:SF148', NULL, NULL, NULL, NULL, 'BED-TYPE DOMAIN-CONTAINING PROTEIN', 249548),
(395246, 'PTHR23272:SF126', NULL, NULL, NULL, NULL, 'ZINC FINGER BED DOMAIN-CONTAINING PROTEIN DAYSLEEPER', 249548),
(395247, 'PTHR23272:SF104', NULL, NULL, NULL, NULL, 'OS08G0198100 PROTEIN', 249548),
(395248, 'PTHR23272:SF143', NULL, NULL, NULL, NULL, 'ZINC FINGER BED DOMAIN-CONTAINING PROTEIN RICESLEEPER 1-LIKE', 249548),
(395249, 'PTHR23272:SF167', NULL, NULL, NULL, NULL, 'ZINC FINGER BED DOMAIN-CONTAINING PROTEIN DAYSLEEPER-LIKE', 249548),
(395250, 'PTHR23272:SF123', NULL, NULL, NULL, NULL, 'AC9 TRANSPOSASE-RELATED', 249548);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(395251, 'PTHR23272:SF145', NULL, NULL, NULL, NULL, 'BED-TYPE DOMAIN-CONTAINING PROTEIN', 249548),
(395252, 'PTHR23272:SF166', NULL, NULL, NULL, NULL, 'ZINC FINGER BED DOMAIN-CONTAINING PROTEIN RICESLEEPER 4-LIKE', 249548),
(395253, 'PTHR23272:SF144', NULL, NULL, NULL, NULL, 'BED-TYPE DOMAIN-CONTAINING PROTEIN', 249548),
(395254, 'PTHR23272:SF21', NULL, NULL, NULL, NULL, 'BED ZINC FINGER AND HAT DIMERIZATION DOMAIN-CONTAINING PROTEIN', 249548),
(395255, 'PTHR23272:SF64', NULL, NULL, NULL, NULL, 'OS04G0628400 PROTEIN', 249548),
(395256, 'PTHR23272:SF172', NULL, NULL, NULL, NULL, 'ZINC FINGER BED DOMAIN-CONTAINING PROTEIN DAYSLEEPER-LIKE', 249548),
(395257, 'PTHR23272:SF171', NULL, NULL, NULL, NULL, 'ZINC FINGER BED DOMAIN-CONTAINING PROTEIN RICESLEEPER 1-LIKE ISOFORM X1', 249548),
(395258, 'PTHR23272:SF174', NULL, NULL, NULL, NULL, 'ZINC FINGER BED DOMAIN-CONTAINING PROTEIN RICESLEEPER 3-LIKE ISOFORM X1', 249548),
(395259, 'PTHR23272:SF173', NULL, NULL, NULL, NULL, 'BED-TYPE DOMAIN-CONTAINING PROTEIN', 249548),
(395260, 'PTHR23272:SF170', NULL, NULL, NULL, NULL, 'OS05G0102300 PROTEIN', 249548),
(395261, 'PTHR46785', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR A DOMAIN-CONTAINING PROTEIN 3B', 249549),
(395262, 'PTHR46785:SF1', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR A DOMAIN-CONTAINING PROTEIN 3B', 249549),
(395263, 'PTHR47711:SF2', NULL, NULL, NULL, NULL, 'PROTEIN PLASTID TRANSCRIPTIONALLY ACTIVE 16, CHLOROPLASTIC', 249550),
(395264, 'PTHR47711', NULL, NULL, NULL, NULL, 'PROTEIN PLASTID TRANSCRIPTIONALLY ACTIVE 16, CHLOROPLASTIC', 249550),
(395265, 'PTHR38455:SF1', NULL, NULL, NULL, NULL, 'HYPOTHETICAL CYTOSOLIC PROTEIN', 249551),
(395266, 'PTHR38455', NULL, NULL, NULL, NULL, 'HYPOTHETICAL CYTOSOLIC PROTEIN', 249551),
(395267, 'PTHR11219', NULL, NULL, NULL, NULL, 'TENEURIN AND N-ACETYLGLUCOSAMINE-1-PHOSPHODIESTER ALPHA-N-ACETYLGLUCOSAMINIDASE', 249552),
(395268, 'PTHR11219:SF69', NULL, NULL, NULL, NULL, 'TENEURIN-A', 249552),
(395269, 'PTHR11219:SF9', NULL, NULL, NULL, NULL, 'TENEURIN-4', 249552),
(395270, 'PTHR11219:SF65', NULL, NULL, NULL, NULL, 'TENEURIN-3', 249552),
(395271, 'PTHR11219:SF72', NULL, NULL, NULL, NULL, 'TENEURIN-M', 249552),
(395272, 'PTHR11219:SF63', NULL, NULL, NULL, NULL, 'SI:DKEY-237H12.3', 249552),
(395273, 'PTHR11219:SF8', NULL, NULL, NULL, NULL, 'TENEURIN-2', 249552),
(395274, 'PTHR11219:SF7', NULL, NULL, NULL, NULL, 'TENEURIN-1', 249552),
(395275, 'PTHR11219:SF70', NULL, NULL, NULL, NULL, 'PROTEIN CBG11506', 249552),
(395276, 'PTHR23048:SF10', NULL, NULL, NULL, NULL, 'MYOSIN, LIGHT CHAIN 1, ALKALI_ SKELETAL, FAST', 249553),
(395277, 'PTHR23048:SF43', NULL, NULL, NULL, NULL, 'MYOSIN LIGHT POLYPEPTIDE 6', 249553),
(395278, 'PTHR23048:SF32', NULL, NULL, NULL, NULL, 'DYNEIN REGULATORY COMPLEX PROTEIN 8', 249553),
(395279, 'PTHR23048:SF42', NULL, NULL, NULL, NULL, 'EF-HAND SUPERFAMILY PROTEIN', 249553),
(395280, 'PTHR23048:SF41', NULL, NULL, NULL, NULL, '', 249553),
(395281, 'PTHR23048:SF30', NULL, NULL, NULL, NULL, 'CARDIAC MYOSIN LIGHT CHAIN-1', 249553),
(395282, 'PTHR23048:SF40', NULL, NULL, NULL, NULL, 'MYOSIN LIGHT POLYPEPTIDE 6', 249553),
(395283, 'PTHR23048:SF7', NULL, NULL, NULL, NULL, 'MYOSIN, LIGHT CHAIN 6, ALKALI, SMOOTH MUSCLE AND NON-MUSCLE-RELATED', 249553),
(395284, 'PTHR23048:SF13', NULL, NULL, NULL, NULL, 'MYOSIN LIGHT CHAIN', 249553),
(395285, 'PTHR23048:SF33', NULL, NULL, NULL, NULL, 'MYOSIN LIGHT CHAIN ALKALI', 249553),
(395286, 'PTHR23048:SF5', NULL, NULL, NULL, NULL, 'MYOSIN LIGHT CHAIN 6B', 249553),
(395287, 'PTHR23048:SF44', NULL, NULL, NULL, NULL, 'ATRIAL MYOSIN LIGHT CHAIN', 249553),
(395288, 'PTHR23048:SF2', NULL, NULL, NULL, NULL, 'MYOSIN LIGHT CHAIN 3', 249553),
(395289, 'PTHR23048:SF3', NULL, NULL, NULL, NULL, 'MYOSIN LIGHT CHAIN 1/3, SKELETAL MUSCLE ISOFORM', 249553),
(395290, 'PTHR23048:SF0', NULL, NULL, NULL, NULL, 'FI08416P-RELATED', 249553),
(395291, 'PTHR23048', NULL, NULL, NULL, NULL, 'MYOSIN LIGHT CHAIN 1, 3', 249553),
(395292, 'PTHR23048:SF38', NULL, NULL, NULL, NULL, 'FAST SKELETAL MUSCLE MYOSIN LIGHT POLYPEPTIDE 3', 249553);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(395293, 'PTHR23048:SF15', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 249553),
(395294, 'PTHR23048:SF1', NULL, NULL, NULL, NULL, 'MYOSIN LIGHT CHAIN 4', 249553),
(395295, 'PTHR47076:SF12', NULL, NULL, NULL, NULL, 'IS10 TRANSPOSASE', 249554),
(395296, 'PTHR47076:SF13', NULL, NULL, NULL, NULL, 'OS02G0743200 PROTEIN', 249554),
(395297, 'PTHR47076:SF14', NULL, NULL, NULL, NULL, '', 249554),
(395298, 'PTHR47076:SF1', NULL, NULL, NULL, NULL, 'NHL DOMAIN PROTEIN', 249554),
(395299, 'PTHR47076:SF2', NULL, NULL, NULL, NULL, 'BNAA02G33580D PROTEIN', 249554),
(395300, 'PTHR47076', NULL, NULL, NULL, NULL, 'NHL DOMAIN PROTEIN', 249554),
(395301, 'PTHR47076:SF9', NULL, NULL, NULL, NULL, 'NHL DOMAIN PROTEIN', 249554),
(395302, 'PTHR47076:SF7', NULL, NULL, NULL, NULL, 'NHL DOMAIN PROTEIN', 249554),
(395303, 'PTHR47076:SF8', NULL, NULL, NULL, NULL, 'IS10 TRANSPOSASE', 249554),
(395304, 'PTHR47076:SF11', NULL, NULL, NULL, NULL, 'BNAA06G16930D PROTEIN', 249554),
(395305, 'PTHR34129', NULL, NULL, NULL, NULL, 'BLR1139 PROTEIN', 249555),
(395306, 'PTHR34129:SF1', NULL, NULL, NULL, NULL, 'BLR1139 PROTEIN', 249555),
(395307, 'PTHR31423', NULL, NULL, NULL, NULL, 'YBAK DOMAIN-CONTAINING PROTEIN', 249556),
(395308, 'PTHR31423:SF4', NULL, NULL, NULL, NULL, 'TRNA_EDIT DOMAIN-CONTAINING PROTEIN', 249556),
(395309, 'PTHR31423:SF3', NULL, NULL, NULL, NULL, 'PROLYL-TRNA SYNTHETASE ASSOCIATED DOMAIN-CONTAINING PROTEIN 1-RELATED', 249556),
(395310, 'PTHR24016:SF0', NULL, NULL, NULL, NULL, 'CONSERVED OLIGOMERIC GOLGI COMPLEX SUBUNIT 4', 249557),
(395311, 'PTHR24016', NULL, NULL, NULL, NULL, 'CONSERVED OLIGOMERIC GOLGI COMPLEX SUBUNIT 4', 249557),
(395312, 'PTHR24016:SF20', NULL, NULL, NULL, NULL, 'COMPONENT OF OLIGOMERIC GOLGI COMPLEX 4', 249557),
(395313, 'PTHR43363:SF1', NULL, NULL, NULL, NULL, 'HYPOXANTHINE-GUANINE PHOSPHORIBOSYLTRANSFERASE', 249558),
(395314, 'PTHR43363', NULL, NULL, NULL, NULL, 'HYPOXANTHINE PHOSPHORIBOSYLTRANSFERASE', 249558),
(395315, 'PTHR43363:SF3', NULL, NULL, NULL, NULL, 'XANTHINE-GUANINE PHOSPHORIBOSYLTRANSFERASE', 249558),
(395316, 'PTHR43363:SF2', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLTRANSFERASE', 249558),
(395317, 'PTHR43363:SF4', NULL, NULL, NULL, NULL, 'XANTHINE PHOSPHORIBOSYLTRANSFERASE 1', 249558),
(395318, 'PTHR23160:SF6', NULL, NULL, NULL, NULL, 'OS04G0592400 PROTEIN', 249559),
(395319, 'PTHR23160:SF7', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN-RELATED PROTEIN', 249559),
(395320, 'PTHR23160:SF1', NULL, NULL, NULL, NULL, 'PROTEIN GRIP', 249559),
(395321, 'PTHR23160:SF20', NULL, NULL, NULL, NULL, 'OS02G0439200 PROTEIN', 249559),
(395322, 'PTHR23160:SF3', NULL, NULL, NULL, NULL, 'SYNAPTONEMAL COMPLEX PROTEIN 1-RELATED', 249559),
(395323, 'PTHR23160:SF9', NULL, NULL, NULL, NULL, 'OS10G0577100 PROTEIN', 249559),
(395324, 'PTHR23160:SF19', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN-RELATED PROTEIN', 249559),
(395325, 'PTHR23160', NULL, NULL, NULL, NULL, 'SYNAPTONEMAL COMPLEX PROTEIN-RELATED', 249559),
(395326, 'PTHR23160:SF22', NULL, NULL, NULL, NULL, 'BNAA02G11870D PROTEIN', 249559),
(395327, 'PTHR23160:SF24', NULL, NULL, NULL, NULL, 'WEB FAMILY PROTEIN CHLOROPLASTIC-RELATED', 249559),
(395328, 'PTHR23160:SF23', NULL, NULL, NULL, NULL, 'BNAANNG15270D PROTEIN', 249559),
(395329, 'PTHR23160:SF12', NULL, NULL, NULL, NULL, 'ATP BINDING PROTEIN', 249559),
(395330, 'PTHR23160:SF15', NULL, NULL, NULL, NULL, 'BNAC01G20180D PROTEIN', 249559),
(395331, 'PTHR23160:SF14', NULL, NULL, NULL, NULL, 'WEB FAMILY PROTEIN-RELATED', 249559),
(395332, 'PTHR23160:SF25', NULL, NULL, NULL, NULL, 'BNAA09G17620D PROTEIN', 249559),
(395333, 'PTHR23160:SF17', NULL, NULL, NULL, NULL, 'MYOSIN-11 ISOFORM X1', 249559),
(395334, 'PTHR23160:SF16', NULL, NULL, NULL, NULL, 'BNAA05G33210D PROTEIN', 249559),
(395335, 'PTHR28163', NULL, NULL, NULL, NULL, 'PROTEIN PET117 HOMOLOG, MITOCHONDRIAL', 249560),
(395336, 'PTHR28163:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PET117 HOMOLOG, MITOCHONDRIAL', 249560),
(395337, 'PTHR34677:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 249561),
(395338, 'PTHR34677:SF3', NULL, NULL, NULL, NULL, 'BIG_12 DOMAIN-CONTAINING PROTEIN', 249561);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(395339, 'PTHR34677', NULL, NULL, NULL, NULL, '', 249561),
(395340, 'PTHR37703', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L31-RELATED', 249562),
(395341, 'PTHR37703:SF2', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L31-RELATED', 249562),
(395342, 'PTHR37703:SF3', NULL, NULL, NULL, NULL, 'BNAA07G36640D PROTEIN', 249562),
(395343, 'PTHR33325', NULL, NULL, NULL, NULL, 'ZINC FINGER, CCHC-TYPE-RELATED', 249563),
(395344, 'PTHR33325:SF5', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 249563),
(395345, 'PTHR33325:SF8', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 249563),
(395346, 'PTHR33325:SF7', NULL, NULL, NULL, NULL, '', 249563),
(395347, 'PTHR33325:SF9', NULL, NULL, NULL, NULL, '', 249563),
(395348, 'PTHR31690', NULL, NULL, NULL, NULL, 'FUCOSE MUTAROTASE', 249564),
(395349, 'PTHR31690:SF4', NULL, NULL, NULL, NULL, 'FUCOSE MUTAROTASE', 249564),
(395350, 'PTHR15152', NULL, NULL, NULL, NULL, 'CD70 ANTIGEN', 249565),
(395351, 'PTHR15152:SF0', NULL, NULL, NULL, NULL, 'CD70 ANTIGEN', 249565),
(395352, 'PTHR46271', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN, PUTATIVE-RELATED', 249566),
(395353, 'PTHR46271:SF4', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN, PUTATIVE-RELATED', 249566),
(395354, 'PTHR46271:SF3', NULL, NULL, NULL, NULL, 'RETINAL HOMEOBOX PROTEIN RX', 249566),
(395355, 'PTHR46271:SF2', NULL, NULL, NULL, NULL, 'RETINA AND ANTERIOR NEURAL FOLD HOMEOBOX PROTEIN 2', 249566),
(395356, 'PTHR11487:SF0', NULL, NULL, NULL, NULL, 'S-ACYL FATTY ACID SYNTHASE THIOESTERASE, MEDIUM CHAIN', 249567),
(395357, 'PTHR11487', NULL, NULL, NULL, NULL, 'THIOESTERASE', 249567),
(395358, 'PTHR47788:SF1', NULL, NULL, NULL, NULL, 'A-ADDING TRNA NUCLEOTIDYLTRANSFERASE', 249568),
(395359, 'PTHR47788', NULL, NULL, NULL, NULL, 'POLYA POLYMERASE', 249568),
(395360, 'PTHR30085:SF2', NULL, NULL, NULL, NULL, 'GLUTAMATE/ASPARTATE IMPORT SOLUTE-BINDING PROTEIN', 249569),
(395361, 'PTHR30085', NULL, NULL, NULL, NULL, 'AMINO ACID ABC TRANSPORTER PERMEASE', 249569),
(395362, 'PTHR30085:SF6', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER GLUTAMINE-BINDING PROTEIN GLNH', 249569),
(395363, 'PTHR30085:SF7', NULL, NULL, NULL, NULL, 'AMINO-ACID ABC TRANSPORTER-BINDING PROTEIN YHDW-RELATED', 249569),
(395364, 'PTHR45889:SF7', NULL, NULL, NULL, NULL, 'CELL ADHESION MOLECULE 2B', 249570),
(395365, 'PTHR45889:SF8', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 249570),
(395366, 'PTHR45889', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 249570),
(395367, 'PTHR45889:SF3', NULL, NULL, NULL, NULL, 'CELL ADHESION MOLECULE 4', 249570),
(395368, 'PTHR45889:SF5', NULL, NULL, NULL, NULL, 'CELL ADHESION MOLECULE 3', 249570),
(395369, 'PTHR45889:SF1', NULL, NULL, NULL, NULL, 'CELL ADHESION MOLECULE 2', 249570),
(395370, 'PTHR45889:SF2', NULL, NULL, NULL, NULL, 'CELL ADHESION MOLECULE 1', 249570),
(395371, 'PTHR47980:SF70', NULL, NULL, NULL, NULL, 'RAB GTPASE-LIKE PROTEIN A5B', 249571),
(395372, 'PTHR47980:SF71', NULL, NULL, NULL, NULL, 'SMALL MONOMERIC GTPASE-RELATED', 249571),
(395373, 'PTHR47980:SF10', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABE1A', 249571),
(395374, 'PTHR47980:SF11', NULL, NULL, NULL, NULL, 'BNAANNG08190D PROTEIN', 249571),
(395375, 'PTHR47980:SF33', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-8A', 249571),
(395376, 'PTHR47980:SF13', NULL, NULL, NULL, NULL, '', 249571),
(395377, 'PTHR47980:SF35', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-12', 249571),
(395378, 'PTHR47980:SF50', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-10', 249571),
(395379, 'PTHR47980:SF30', NULL, NULL, NULL, NULL, 'SMALL GTP-BINDING PROTEIN RAB18', 249571),
(395380, 'PTHR47980:SF53', NULL, NULL, NULL, NULL, 'OS07G0239400 PROTEIN', 249571),
(395381, 'PTHR47980:SF18', NULL, NULL, NULL, NULL, '', 249571),
(395382, 'PTHR47980:SF19', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-3', 249571),
(395383, 'PTHR47980:SF15', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-3C', 249571),
(395384, 'PTHR47980:SF59', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABE1D', 249571),
(395385, 'PTHR47980:SF16', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-40B', 249571);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(395386, 'PTHR47980:SF17', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-3D', 249571),
(395387, 'PTHR47980:SF9', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-3A', 249571),
(395388, 'PTHR47980:SF60', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABE1A', 249571),
(395389, 'PTHR47980:SF5', NULL, NULL, NULL, NULL, 'BNAA07G37610D PROTEIN', 249571),
(395390, 'PTHR47980:SF6', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-8B', 249571),
(395391, 'PTHR47980:SF21', NULL, NULL, NULL, NULL, 'RE54550P', 249571),
(395392, 'PTHR47980:SF43', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-40A-RELATED', 249571),
(395393, 'PTHR47980:SF65', NULL, NULL, NULL, NULL, 'OS05G0461300 PROTEIN', 249571),
(395394, 'PTHR47980:SF22', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-3B', 249571),
(395395, 'PTHR47980:SF66', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABE1C-LIKE', 249571),
(395396, 'PTHR47980:SF4', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-15', 249571),
(395397, 'PTHR47980:SF45', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABE1C-LIKE', 249571),
(395398, 'PTHR47980:SF23', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-10', 249571),
(395399, 'PTHR47980', NULL, NULL, NULL, NULL, 'LD44762P', 249571),
(395400, 'PTHR47980:SF67', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN ARA-3-RELATED', 249571),
(395401, 'PTHR47980:SF24', NULL, NULL, NULL, NULL, 'IP08727P-RELATED', 249571),
(395402, 'PTHR47980:SF2', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-40C', 249571),
(395403, 'PTHR47980:SF46', NULL, NULL, NULL, NULL, 'RAB40B, MEMBER RAS ONCOGENE FAMILY', 249571),
(395404, 'PTHR47980:SF68', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABE1C-LIKE', 249571),
(395405, 'PTHR47980:SF61', NULL, NULL, NULL, NULL, 'BNAC03G27830D PROTEIN', 249571),
(395406, 'PTHR47980:SF62', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB8-3', 249571),
(395407, 'PTHR47980:SF40', NULL, NULL, NULL, NULL, 'PROTEIN CBG02097', 249571),
(395408, 'PTHR47980:SF41', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABE1E', 249571),
(395409, 'PTHR47980:SF63', NULL, NULL, NULL, NULL, 'SMALL MONOMERIC GTPASE-RELATED', 249571),
(395410, 'PTHR47980:SF42', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-13', 249571),
(395411, 'PTHR47980:SF64', NULL, NULL, NULL, NULL, 'SMALL MONOMERIC GTPASE-RELATED', 249571),
(395412, 'PTHR47980:SF29', NULL, NULL, NULL, NULL, 'RABX4', 249571),
(395413, 'PTHR47980:SF69', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABE1C', 249571),
(395414, 'PTHR47980:SF26', NULL, NULL, NULL, NULL, 'BNAA02G06750D PROTEIN', 249571),
(395415, 'PTHR47980:SF28', NULL, NULL, NULL, NULL, 'BNACNNG73200D PROTEIN', 249571),
(395416, 'PTHR11614:SF186', NULL, NULL, NULL, NULL, 'LYSOPHOSPHOLIPASE L2', 249572),
(395417, 'PTHR11614:SF185', NULL, NULL, NULL, NULL, 'LIPASE, PUTATIVE-RELATED', 249572),
(395418, 'PTHR11614:SF163', NULL, NULL, NULL, NULL, 'CAFFEOYLSHIKIMATE ESTERASE', 249572),
(395419, 'PTHR11614:SF188', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE FAMILY PROTEIN-RELATED', 249572),
(395420, 'PTHR11614:SF92', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 249572),
(395421, 'PTHR11614:SF187', NULL, NULL, NULL, NULL, 'BLL3777 PROTEIN', 249572),
(395422, 'PTHR11614:SF143', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 249572),
(395423, 'PTHR11614:SF121', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE', 249572),
(395424, 'PTHR11614:SF160', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 249572),
(395425, 'PTHR11614:SF182', NULL, NULL, NULL, NULL, 'CAFFEOYLSHIKIMATE ESTERASE-LIKE', 249572),
(395426, 'PTHR11614:SF94', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 249572),
(395427, 'PTHR11614:SF181', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 249572),
(395428, 'PTHR11614:SF162', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 249572),
(395429, 'PTHR11614:SF184', NULL, NULL, NULL, NULL, 'MONOGLYCERIDE LIPASE', 249572),
(395430, 'PTHR11614:SF183', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 249572);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(395431, 'PTHR11614:SF161', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 249572),
(395432, 'PTHR11614:SF87', NULL, NULL, NULL, NULL, 'MONOGLYCERIDE LIPASE', 249572),
(395433, 'PTHR11614:SF149', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 249572),
(395434, 'PTHR11614:SF20', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 249572),
(395435, 'PTHR11614:SF88', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 249572),
(395436, 'PTHR11614:SF167', NULL, NULL, NULL, NULL, 'SERINE AMINOPEPTIDASE, S33, ALPHA/BETA HYDROLASE FOLD PROTEIN-RELATED', 249572),
(395437, 'PTHR11614:SF189', NULL, NULL, NULL, NULL, 'HYDROLASE OR ACYLTRANSFERASE', 249572),
(395438, 'PTHR11614:SF101', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 249572),
(395439, 'PTHR11614', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE-RELATED', 249572),
(395440, 'PTHR11614:SF147', NULL, NULL, NULL, NULL, 'MONOGLYCERIDE LIPASE', 249572),
(395441, 'PTHR11614:SF109', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 249572),
(395442, 'PTHR11614:SF191', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 249572),
(395443, 'PTHR11614:SF190', NULL, NULL, NULL, NULL, 'BIOSYNTHESIS PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G01450)-RELATED', 249572),
(395444, 'PTHR11614:SF175', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 249572),
(395445, 'PTHR11614:SF152', NULL, NULL, NULL, NULL, 'HYDROLASE, ALPHA/BETA FOLD FAMILY PROTEIN', 249572),
(395446, 'PTHR11614:SF177', NULL, NULL, NULL, NULL, 'SERINE AMINOPEPTIDASE, S33, ALPHA/BETA HYDROLASE FOLD PROTEIN-RELATED', 249572),
(395447, 'PTHR11614:SF155', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 249572),
(395448, 'PTHR11614:SF171', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 249572),
(395449, 'PTHR11614:SF193', NULL, NULL, NULL, NULL, 'LYSOPHOSPHOLIPASE VOLA', 249572),
(395450, 'PTHR11614:SF192', NULL, NULL, NULL, NULL, 'OS09G0394700 PROTEIN', 249572),
(395451, 'PTHR11614:SF173', NULL, NULL, NULL, NULL, 'BNAA05G35650D PROTEIN', 249572),
(395452, 'PTHR11614:SF151', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 249572),
(395453, 'PTHR11614:SF150', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 249572),
(395454, 'PTHR11614:SF172', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 249572),
(395455, 'PTHR11614:SF157', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 249572),
(395456, 'PTHR11614:SF158', NULL, NULL, NULL, NULL, 'CAFFEOYLSHIKIMATE ESTERASE-LIKE', 249572),
(395457, 'PTHR30106', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YEIH-RELATED', 249573),
(395458, 'PTHR30106:SF2', NULL, NULL, NULL, NULL, 'UPF0324 INNER MEMBRANE PROTEIN YEIH', 249573),
(395459, 'PTHR30106:SF1', NULL, NULL, NULL, NULL, 'UPF0324 MEMBRANE PROTEIN FN0533', 249573),
(395460, 'PTHR24155:SF10', NULL, NULL, NULL, NULL, 'OSTEOCLAST-STIMULATING FACTOR 1', 249574),
(395461, 'PTHR24155:SF11', NULL, NULL, NULL, NULL, 'CASKIN, ISOFORM B', 249574),
(395462, 'PTHR24155', NULL, NULL, NULL, NULL, 'OSTEOCLAST-STIMULATING FACTOR 1', 249574),
(395463, 'PTHR36692:SF3', NULL, NULL, NULL, NULL, 'PROTEIN SNAKESKIN', 249575),
(395464, 'PTHR36692:SF2', NULL, NULL, NULL, NULL, 'GEO12064P1', 249575),
(395465, 'PTHR36692:SF1', NULL, NULL, NULL, NULL, 'GH08457P', 249575),
(395466, 'PTHR36692', NULL, NULL, NULL, NULL, 'PROTEIN SNAKESKIN', 249575),
(395467, 'PTHR19432:SF26', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 249576),
(395468, 'PTHR19432:SF89', NULL, NULL, NULL, NULL, 'SUCROSE/H+ SYMPORTER, PLANT, MAJOR FACILITATOR SUPERFAMILY DOMAIN-CONTAINING PROTEIN-RELATED', 249576),
(395469, 'PTHR19432:SF67', NULL, NULL, NULL, NULL, 'SUCROSE TRANSPORT PROTEIN SUC2', 249576),
(395470, 'PTHR19432:SF88', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED TRANSPORTER PROTEIN', 249576),
(395471, 'PTHR19432:SF68', NULL, NULL, NULL, NULL, 'SUCROSE TRANSPORT PROTEIN SUC8-LIKE', 249576),
(395472, 'PTHR19432:SF84', NULL, NULL, NULL, NULL, 'BNAA09G30430D PROTEIN', 249576);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(395473, 'PTHR19432:SF87', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 45 MEMBER 2', 249576),
(395474, 'PTHR19432:SF43', NULL, NULL, NULL, NULL, 'SUCROSE TRANSPORT PROTEIN SUT5', 249576),
(395475, 'PTHR19432:SF64', NULL, NULL, NULL, NULL, 'SUCROSE TRANSPORT PROTEIN SUT1', 249576),
(395476, 'PTHR19432:SF81', NULL, NULL, NULL, NULL, 'SUCROSE TRANSPORT PROTEIN SUC1-RELATED', 249576),
(395477, 'PTHR19432', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER', 249576),
(395478, 'PTHR19432:SF80', NULL, NULL, NULL, NULL, 'BNAA03G01930D PROTEIN', 249576),
(395479, 'PTHR19432:SF83', NULL, NULL, NULL, NULL, 'BNAC08G42460D PROTEIN', 249576),
(395480, 'PTHR19432:SF6', NULL, NULL, NULL, NULL, 'PROTON-ASSOCIATED SUGAR TRANSPORTER A', 249576),
(395481, 'PTHR19432:SF7', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 45 MEMBER 4', 249576),
(395482, 'PTHR19432:SF82', NULL, NULL, NULL, NULL, 'BNAA02G26600D PROTEIN', 249576),
(395483, 'PTHR19432:SF37', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 45 MEMBER 3', 249576),
(395484, 'PTHR19432:SF39', NULL, NULL, NULL, NULL, 'SUCROSE TRANSPORT PROTEIN SUT3', 249576),
(395485, 'PTHR19432:SF34', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED TRANSPORTER PROTEIN', 249576),
(395486, 'PTHR19432:SF79', NULL, NULL, NULL, NULL, 'SUCROSE/H+ SYMPORTER, PLANT, MAJOR FACILITATOR SUPERFAMILY DOMAIN-CONTAINING PROTEIN-RELATED', 249576),
(395487, 'PTHR19432:SF35', NULL, NULL, NULL, NULL, 'ZGC:77158', 249576),
(395488, 'PTHR19432:SF90', NULL, NULL, NULL, NULL, 'SUCROSE TRANSPORT PROTEIN SUC4', 249576),
(395489, 'PTHR19432:SF76', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (EUROFUNG)-RELATED', 249576),
(395490, 'PTHR19432:SF75', NULL, NULL, NULL, NULL, 'BNAA03G52810D PROTEIN', 249576),
(395491, 'PTHR19432:SF70', NULL, NULL, NULL, NULL, 'SUCROSE TRANSPORT PROTEIN SUC7-RELATED', 249576),
(395492, 'PTHR19432:SF92', NULL, NULL, NULL, NULL, '', 249576),
(395493, 'PTHR19432:SF91', NULL, NULL, NULL, NULL, '', 249576),
(395494, 'PTHR19432:SF72', NULL, NULL, NULL, NULL, 'SUCROSE TRANSPORT PROTEIN SUC2-LIKE', 249576),
(395495, 'PTHR37701:SF14', NULL, NULL, NULL, NULL, 'METHYL-CPG-BINDING DOMAIN PROTEIN', 249577),
(395496, 'PTHR37701:SF13', NULL, NULL, NULL, NULL, 'MBD DOMAIN-CONTAINING PROTEIN', 249577),
(395497, 'PTHR37701:SF19', NULL, NULL, NULL, NULL, 'METHYL-CPG-BINDING DOMAIN PROTEIN', 249577),
(395498, 'PTHR37701:SF18', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 249577),
(395499, 'PTHR37701:SF17', NULL, NULL, NULL, NULL, 'METHYL BINDING DOMAIN117', 249577),
(395500, 'PTHR37701:SF16', NULL, NULL, NULL, NULL, 'METHYL-CPG-BINDING DOMAIN-CONTAINING PROTEIN 8', 249577),
(395501, 'PTHR37701:SF9', NULL, NULL, NULL, NULL, 'ZINC FINGER, C2H2, DNA-BINDING DOMAIN PROTEIN-RELATED', 249577),
(395502, 'PTHR37701', NULL, NULL, NULL, NULL, 'METHYL-CPG-BINDING DOMAIN-CONTAINING PROTEIN 8', 249577),
(395503, 'PTHR37701:SF10', NULL, NULL, NULL, NULL, 'ZINC FINGER, C2H2-LIKE, DNA-BINDING DOMAIN PROTEIN-RELATED', 249577),
(395504, 'PTHR35444:SF1', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1700001C19 GENE', 249578),
(395505, 'PTHR35444', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1700001C19 GENE', 249578),
(395506, 'PTHR36931:SF1', NULL, NULL, NULL, NULL, 'UPF0153 PROTEIN YEIW', 249579),
(395507, 'PTHR36931', NULL, NULL, NULL, NULL, 'UPF0153 PROTEIN YEIW', 249579),
(395508, 'PTHR30588', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN AMINO ACID TRANSPORT SYSTEM 2 CARRIER PROTEIN', 249580),
(395509, 'PTHR30588:SF0', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN AMINO ACID TRANSPORT SYSTEM 2 CARRIER PROTEIN', 249580),
(395510, 'PTHR30588:SF7', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN AMINO ACID CARRIER PROTEIN SAOUHSC_01411-RELATED', 249580),
(395511, 'PTHR24384:SF131', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 430', 249581),
(395512, 'PTHR24384:SF179', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 679', 249581),
(395513, 'PTHR24384:SF211', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 138-RELATED', 249581),
(395514, 'PTHR24384:SF178', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 716', 249581),
(395515, 'PTHR24384:SF214', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 66-RELATED', 249581);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(395516, 'PTHR24384:SF218', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 626', 249581),
(395517, 'PTHR24384:SF80', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 713', 249581),
(395518, 'PTHR24384:SF81', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 732', 249581),
(395519, 'PTHR24384:SF180', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 506', 249581),
(395520, 'PTHR24384:SF87', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 195', 249581),
(395521, 'PTHR24384:SF181', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 253', 249581),
(395522, 'PTHR24384:SF88', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 431', 249581),
(395523, 'PTHR24384:SF186', NULL, NULL, NULL, NULL, 'NOVEL PROTEIN SIMILAR TO VERTEBRATE ZINC FINGER PROTEIN 384 (ZNF384)-RELATED', 249581),
(395524, 'PTHR24384:SF15', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 460', 249581),
(395525, 'PTHR24384:SF220', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 628', 249581),
(395526, 'PTHR24384:SF223', NULL, NULL, NULL, NULL, '', 249581),
(395527, 'PTHR24384:SF102', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 141', 249581),
(395528, 'PTHR24384:SF189', NULL, NULL, NULL, NULL, 'CKII-ALPHA SUBUNIT INTERACTOR-1-RELATED', 249581),
(395529, 'PTHR24384:SF222', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 562', 249581),
(395530, 'PTHR24384:SF104', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 714', 249581),
(395531, 'PTHR24384:SF225', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 768-RELATED', 249581),
(395532, 'PTHR24384:SF227', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 977', 249581),
(395533, 'PTHR24384:SF226', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 408', 249581),
(395534, 'PTHR24384:SF108', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 492-RELATED', 249581),
(395535, 'PTHR24384:SF228', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 479-RELATED', 249581),
(395536, 'PTHR24384:SF92', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 90', 249581),
(395537, 'PTHR24384:SF191', NULL, NULL, NULL, NULL, 'GDNF-INDUCIBLE ZINC FINGER PROTEIN 1', 249581),
(395538, 'PTHR24384:SF95', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 486', 249581),
(395539, 'PTHR24384:SF193', NULL, NULL, NULL, NULL, 'PR/SET DOMAIN 15', 249581),
(395540, 'PTHR24384:SF98', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 736', 249581),
(395541, 'PTHR24384:SF192', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING 47A', 249581),
(395542, 'PTHR24384:SF99', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 805', 249581),
(395543, 'PTHR24384:SF195', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 543', 249581),
(395544, 'PTHR24384:SF230', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 719', 249581),
(395545, 'PTHR24384:SF196', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 11', 249581),
(395546, 'PTHR24384:SF232', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 322', 249581),
(395547, 'PTHR24384:SF231', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 114', 249581),
(395548, 'PTHR24384:SF110', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 730-RELATED', 249581),
(395549, 'PTHR24384:SF234', NULL, NULL, NULL, NULL, 'SI:CH211-235I11.4-RELATED', 249581),
(395550, 'PTHR24384:SF112', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 676', 249581),
(395551, 'PTHR24384:SF233', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 331', 249581),
(395552, 'PTHR24384:SF236', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 502', 249581),
(395553, 'PTHR24384:SF115', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 675', 249581),
(395554, 'PTHR24384:SF235', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 519', 249581),
(395555, 'PTHR24384:SF116', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 682', 249581),
(395556, 'PTHR24384:SF237', NULL, NULL, NULL, NULL, '', 249581),
(395557, 'PTHR24384:SF119', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 695', 249581),
(395558, 'PTHR24384', NULL, NULL, NULL, NULL, 'FINGER PUTATIVE TRANSCRIPTION FACTOR FAMILY-RELATED', 249581),
(395559, 'PTHR24384:SF120', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 117', 249581),
(395560, 'PTHR24384:SF121', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 680', 249581);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(395561, 'PTHR24384:SF201', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 100-RELATED', 249581),
(395562, 'PTHR24384:SF126', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 773', 249581),
(395563, 'PTHR24384:SF203', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 723', 249581),
(395564, 'PTHR24384:SF128', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 737', 249581),
(395565, 'PTHR24384:SF127', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 257-RELATED', 249581),
(395566, 'PTHR24384:SF204', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 726', 249581),
(395567, 'PTHR24384:SF206', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 727-RELATED', 249581),
(395568, 'PTHR24384:SF208', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 718', 249581),
(395569, 'PTHR24384:SF2', NULL, NULL, NULL, NULL, 'MYELOID ZINC FINGER 1', 249581),
(395570, 'PTHR24384:SF30', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 664', 249581),
(395571, 'PTHR24384:SF6', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 114', 249581),
(395572, 'PTHR40056', NULL, NULL, NULL, NULL, 'HYPOTHETICAL CYTOSOLIC PROTEIN', 249582),
(395573, 'PTHR40056:SF1', NULL, NULL, NULL, NULL, 'HYPOTHETICAL CYTOSOLIC PROTEIN', 249582),
(395574, 'PTHR44117', NULL, NULL, NULL, NULL, 'INTRAFLAGELLAR TRANSPORT PROTEIN 88 HOMOLOG', 249583),
(395575, 'PTHR44117:SF1', NULL, NULL, NULL, NULL, 'INTRAFLAGELLAR TRANSPORT PROTEIN 88 HOMOLOG', 249583),
(395576, 'PTHR47189', NULL, NULL, NULL, NULL, 'MHC CLASS II TRANSACTIVATOR', 249584),
(395577, 'PTHR47189:SF1', NULL, NULL, NULL, NULL, 'MHC CLASS II TRANSACTIVATOR', 249584),
(395578, 'PTHR30443', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN', 249585),
(395579, 'PTHR30443:SF0', NULL, NULL, NULL, NULL, 'PHOSPHOETHANOLAMINE TRANSFERASE EPTA', 249585),
(395580, 'PTHR30443:SF2', NULL, NULL, NULL, NULL, 'PHOSPHOETHANOLAMINE TRANSFERASE EPTC', 249585),
(395581, 'PTHR30443:SF4', NULL, NULL, NULL, NULL, 'PHOSPHOETHANOLAMINE TRANSFERASE OPGE-RELATED', 249585),
(395582, 'PTHR30443:SF3', NULL, NULL, NULL, NULL, 'KDO(2)-LIPID A PHOSPHOETHANOLAMINE 7''''-TRANSFERASE', 249585),
(395583, 'PTHR14520', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOMAL PROTEIN 63', 249586),
(395584, 'PTHR14520:SF4', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN 63, MITOCHONDRIAL', 249586),
(395585, 'PTHR46442:SF10', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 249587),
(395586, 'PTHR46442:SF11', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN 12-RELATED', 249587),
(395587, 'PTHR46442:SF15', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 249587),
(395588, 'PTHR46442:SF12', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 249587),
(395589, 'PTHR46442:SF13', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 249587),
(395590, 'PTHR46442', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 249587),
(395591, 'PTHR46442:SF9', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 249587),
(395592, 'PTHR46442:SF8', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN 6', 249587),
(395593, 'PTHR46442:SF16', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 249587),
(395594, 'PTHR46442:SF7', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 249587),
(395595, 'PTHR46442:SF6', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN 5', 249587),
(395596, 'PTHR46442:SF5', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 249587),
(395597, 'PTHR46442:SF4', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 249587),
(395598, 'PTHR30476', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 249588),
(395599, 'PTHR30476:SF0', NULL, NULL, NULL, NULL, 'UPF0234 PROTEIN YAJQ', 249588),
(395600, 'PTHR46579:SF4', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 249589),
(395601, 'PTHR46579:SF2', NULL, NULL, NULL, NULL, '', 249589),
(395602, 'PTHR46579:SF1', NULL, NULL, NULL, NULL, '', 249589),
(395603, 'PTHR46579', NULL, NULL, NULL, NULL, 'F5/8 TYPE C DOMAIN-CONTAINING PROTEIN-RELATED', 249589),
(395604, 'PTHR32060:SF30', NULL, NULL, NULL, NULL, 'CARBOXY-TERMINAL PROCESSING PROTEASE CTPA', 249590),
(395605, 'PTHR32060:SF31', NULL, NULL, NULL, NULL, 'CARBOXYL-TERMINAL-PROCESSING PEPTIDASE 1, CHLOROPLASTIC', 249590),
(395606, 'PTHR32060', NULL, NULL, NULL, NULL, 'TAIL-SPECIFIC PROTEASE', 249590);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(395607, 'PTHR32060:SF7', NULL, NULL, NULL, NULL, 'CARBOXYL-TERMINAL-PROCESSING PEPTIDASE 2, CHLOROPLASTIC', 249590),
(395608, 'PTHR32060:SF29', NULL, NULL, NULL, NULL, 'CARBOXY-TERMINAL PROCESSING PROTEASE CTPB', 249590),
(395609, 'PTHR32060:SF28', NULL, NULL, NULL, NULL, 'PEPTIDASE S41 FAMILY PROTEIN', 249590),
(395610, 'PTHR32060:SF22', NULL, NULL, NULL, NULL, 'CARBOXYL-TERMINAL-PROCESSING PEPTIDASE 3, CHLOROPLASTIC', 249590),
(395611, 'PTHR46255:SF3', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 249591),
(395612, 'PTHR46255', NULL, NULL, NULL, NULL, 'SHORT STATURE HOMEOBOX', 249591),
(395613, 'PTHR46255:SF2', NULL, NULL, NULL, NULL, 'SHORT STATURE HOMEOBOX PROTEIN', 249591),
(395614, 'PTHR46255:SF1', NULL, NULL, NULL, NULL, 'SHORT STATURE HOMEOBOX PROTEIN 2', 249591),
(395615, 'PTHR37343', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 32', 249592),
(395616, 'PTHR37343:SF1', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 32', 249592),
(395617, 'PTHR39613', NULL, NULL, NULL, NULL, 'ANCHORED CELL WALL PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G08960)-RELATED', 249593),
(395618, 'PTHR39613:SF1', NULL, NULL, NULL, NULL, 'ANCHORED CELL WALL PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G08960)-RELATED', 249593),
(395619, 'PTHR36369:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 249594),
(395620, 'PTHR36369:SF3', NULL, NULL, NULL, NULL, 'OS06G0196200 PROTEIN', 249594),
(395621, 'PTHR36369:SF5', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 249594),
(395622, 'PTHR36369:SF6', NULL, NULL, NULL, NULL, 'BNAA02G05080D PROTEIN', 249594),
(395623, 'PTHR36369', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 249594),
(395624, 'PTHR33186:SF22', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249595),
(395625, 'PTHR33186:SF23', NULL, NULL, NULL, NULL, '', 249595),
(395626, 'PTHR33186:SF24', NULL, NULL, NULL, NULL, '', 249595),
(395627, 'PTHR33186:SF13', NULL, NULL, NULL, NULL, 'OS10G0136900 PROTEIN', 249595),
(395628, 'PTHR33186:SF25', NULL, NULL, NULL, NULL, 'OS10G0138300 PROTEIN', 249595),
(395629, 'PTHR33186', NULL, NULL, NULL, NULL, 'OS10G0136150 PROTEIN-RELATED', 249595),
(395630, 'PTHR33186:SF15', NULL, NULL, NULL, NULL, 'OS06G0249850 PROTEIN', 249595),
(395631, 'PTHR33186:SF16', NULL, NULL, NULL, NULL, '', 249595),
(395632, 'PTHR33186:SF18', NULL, NULL, NULL, NULL, 'OS10G0136150 PROTEIN', 249595),
(395633, 'PTHR15045', NULL, NULL, NULL, NULL, 'FUCOSE-1-PHOSPHATE GUANYLYLTRANSFERASE', 249596),
(395634, 'PTHR15045:SF1', NULL, NULL, NULL, NULL, 'FUCOSE-1-PHOSPHATE GUANYLYLTRANSFERASE', 249596),
(395635, 'PTHR21668', NULL, NULL, NULL, NULL, 'EIF-1A', 249597),
(395636, 'PTHR21668:SF4', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 1A, X-CHROMOSOMAL', 249597),
(395637, 'PTHR21668:SF28', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4C', 249597),
(395638, 'PTHR21668:SF17', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 1A, Y-CHROMOSOMAL', 249597),
(395639, 'PTHR21668:SF7', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 1A', 249597),
(395640, 'PTHR21668:SF19', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4C', 249597),
(395641, 'PTHR21668:SF6', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 1A-RELATED', 249597),
(395642, 'PTHR21668:SF14', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4C', 249597),
(395643, 'PTHR21668:SF27', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4C', 249597),
(395644, 'PTHR21668:SF16', NULL, NULL, NULL, NULL, 'S1-LIKE DOMAIN-CONTAINING PROTEIN', 249597),
(395645, 'PTHR21668:SF15', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4C', 249597),
(395646, 'PTHR21668:SF20', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4C', 249597),
(395647, 'PTHR21668:SF12', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4C', 249597),
(395648, 'PTHR21668:SF0', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4C', 249597),
(395649, 'PTHR48231', NULL, NULL, NULL, NULL, 'TMEM189_B_DMAIN DOMAIN-CONTAINING PROTEIN', 249598);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(395650, 'PTHR48231:SF1', NULL, NULL, NULL, NULL, 'OS08G0187900 PROTEIN', 249598),
(395651, 'PTHR48231:SF2', NULL, NULL, NULL, NULL, 'TMEM189_B_DMAIN DOMAIN-CONTAINING PROTEIN', 249598),
(395652, 'PTHR43545', NULL, NULL, NULL, NULL, 'FORMATE DEHYDROGENASE, NITRATE-INDUCIBLE, IRON-SULFUR SUBUNIT', 249599),
(395653, 'PTHR43545:SF4', NULL, NULL, NULL, NULL, 'FORMATE DEHYDROGENASE-O IRON-SULFUR SUBUNIT', 249599),
(395654, 'PTHR43545:SF5', NULL, NULL, NULL, NULL, 'FORMATE DEHYDROGENASE, NITRATE-INDUCIBLE, IRON-SULFUR SUBUNIT', 249599),
(395655, 'PTHR43545:SF1', NULL, NULL, NULL, NULL, 'HYDROGENASE-2 OPERON PROTEIN HYBA', 249599),
(395656, 'PTHR11289:SF0', NULL, NULL, NULL, NULL, 'BREAST CANCER TYPE 2 SUSCEPTIBILITY PROTEIN', 249600),
(395657, 'PTHR11289:SF3', NULL, NULL, NULL, NULL, 'BNAC06G42060D PROTEIN', 249600),
(395658, 'PTHR11289', NULL, NULL, NULL, NULL, 'BREAST CANCER TYPE 2 SUSCEPTIBILITY PROTEIN BRCA2', 249600),
(395659, 'PTHR38655:SF1', NULL, NULL, NULL, NULL, 'SIMILAR TO RIKEN CDNA 4930524B15', 249601),
(395660, 'PTHR38655', NULL, NULL, NULL, NULL, 'SIMILAR TO RIKEN CDNA 4930524B15', 249601),
(395661, 'PTHR34606:SF15', NULL, NULL, NULL, NULL, 'LIPOPROTEIN-RELATED', 249602),
(395662, 'PTHR34606:SF4', NULL, NULL, NULL, NULL, 'PERIPLASMIC PROTEIN-RELATED', 249602),
(395663, 'PTHR34606:SF11', NULL, NULL, NULL, NULL, 'OSMOTICALLY-INDUCIBLE PROTEIN Y', 249602),
(395664, 'PTHR34606:SF14', NULL, NULL, NULL, NULL, 'TRI-BON DOMAIN-CONTAINING PROTEIN', 249602),
(395665, 'PTHR34606', NULL, NULL, NULL, NULL, 'BON DOMAIN-CONTAINING PROTEIN', 249602),
(395666, 'PTHR45643:SF7', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE', 249603),
(395667, 'PTHR45643:SF8', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 249603),
(395668, 'PTHR45643:SF9', NULL, NULL, NULL, NULL, 'RT_RNASEH DOMAIN-CONTAINING PROTEIN', 249603),
(395669, 'PTHR45643', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE', 249603),
(395670, 'PTHR45643:SF13', NULL, NULL, NULL, NULL, 'RNA-DIRECTED DNA POLYMERASE HOMOLOG', 249603),
(395671, 'PTHR45643:SF12', NULL, NULL, NULL, NULL, '', 249603),
(395672, 'PTHR45643:SF14', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 249603),
(395673, 'PTHR45643:SF1', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 249603),
(395674, 'PTHR45643:SF11', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE', 249603),
(395675, 'PTHR45643:SF10', NULL, NULL, NULL, NULL, 'RETROTRANS_GAG DOMAIN-CONTAINING PROTEIN', 249603),
(395676, 'PTHR45643:SF2', NULL, NULL, NULL, NULL, 'OSJNBA0059D20.8-LIKE PROTEIN', 249603),
(395677, 'PTHR45643:SF3', NULL, NULL, NULL, NULL, 'RNA-DIRECTED DNA POLYMERASE HOMOLOG', 249603),
(395678, 'PTHR45643:SF4', NULL, NULL, NULL, NULL, 'RT_RNASEH_2 DOMAIN-CONTAINING PROTEIN', 249603),
(395679, 'PTHR45643:SF5', NULL, NULL, NULL, NULL, 'RNA-DIRECTED DNA POLYMERASE HOMOLOG', 249603),
(395680, 'PTHR45643:SF6', NULL, NULL, NULL, NULL, 'RT_RNASEH_2 DOMAIN-CONTAINING PROTEIN', 249603),
(395681, 'PTHR20531:SF1', NULL, NULL, NULL, NULL, 'N-ALPHA-ACETYLTRANSFERASE 40', 249604),
(395682, 'PTHR20531', NULL, NULL, NULL, NULL, 'N-ALPHA-ACETYLTRANSFERASE 40', 249604),
(395683, 'PTHR14027:SF2', NULL, NULL, NULL, NULL, 'RNA POLYMERASE-ASSOCIATED PROTEIN CTR9 HOMOLOG', 249605),
(395684, 'PTHR14027', NULL, NULL, NULL, NULL, 'RNA POLYMERASE-ASSOCIATED PROTEIN CTR9', 249605),
(395685, 'PTHR31469:SF17', NULL, NULL, NULL, NULL, 'PLANT/PROTEIN', 249606),
(395686, 'PTHR31469', NULL, NULL, NULL, NULL, 'OS07G0633600 PROTEIN', 249606),
(395687, 'PTHR31469:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249606),
(395688, 'PTHR31469:SF12', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 249606),
(395689, 'PTHR31469:SF4', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 249606),
(395690, 'PTHR31469:SF14', NULL, NULL, NULL, NULL, '', 249606),
(395691, 'PTHR31469:SF7', NULL, NULL, NULL, NULL, 'CALCIUM ION BINDING', 249606),
(395692, 'PTHR31469:SF16', NULL, NULL, NULL, NULL, 'BNACNNG45830D PROTEIN', 249606),
(395693, 'PTHR31469:SF8', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', 249606);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(395694, 'PTHR15285', NULL, NULL, NULL, NULL, 'NEURONATIN', 249607),
(395695, 'PTHR15285:SF0', NULL, NULL, NULL, NULL, 'NEURONATIN', 249607),
(395696, 'PTHR47222:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 687', 249608),
(395697, 'PTHR47222:SF3', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 532', 249608),
(395698, 'PTHR47222:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 592', 249608),
(395699, 'PTHR47222', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 532-RELATED', 249608),
(395700, 'PTHR47222:SF4', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 592', 249608),
(395701, 'PTHR18945:SF828', NULL, NULL, NULL, NULL, 'LIGAND-GATED ION CHANNEL 4', 249609),
(395702, 'PTHR18945:SF829', NULL, NULL, NULL, NULL, 'NEURONAL ACETYLCHOLINE RECEPTOR SUBUNIT EAT-2', 249609),
(395703, 'PTHR18945:SF824', NULL, NULL, NULL, NULL, 'NICOTINIC ACETYLCHOLINE RECEPTOR BETA 3 (DBETA3) SUBUNIT', 249609),
(395704, 'PTHR18945:SF429', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID RECEPTOR SUBUNIT BETA-1', 249609),
(395705, 'PTHR18945:SF426', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR SUBUNIT ALPHA-TYPE ACR-7', 249609),
(395706, 'PTHR18945:SF821', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR', 249609),
(395707, 'PTHR18945:SF786', NULL, NULL, NULL, NULL, 'SI:CH211-256E16.4-RELATED', 249609),
(395708, 'PTHR18945:SF784', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR SUBUNIT BETA-LIKE 1', 249609),
(395709, 'PTHR18945:SF385', NULL, NULL, NULL, NULL, 'NEURONAL ACETYLCHOLINE RECEPTOR SUBUNIT BETA-4', 249609),
(395710, 'PTHR18945:SF386', NULL, NULL, NULL, NULL, 'LIGAND-GATED ION CHANNEL', 249609),
(395711, 'PTHR18945:SF780', NULL, NULL, NULL, NULL, 'CHOLINERGIC RECEPTOR, NICOTINIC, BETA 5B', 249609),
(395712, 'PTHR18945:SF382', NULL, NULL, NULL, NULL, 'LIGAND-GATED ION CHANNEL', 249609),
(395713, 'PTHR18945:SF76', NULL, NULL, NULL, NULL, 'NEURONAL ACETYLCHOLINE RECEPTOR SUBUNIT ALPHA-5', 249609),
(395714, 'PTHR18945:SF75', NULL, NULL, NULL, NULL, 'NEURONAL ACETYLCHOLINE RECEPTOR SUBUNIT BETA-3', 249609),
(395715, 'PTHR18945:SF74', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR SUBUNIT ALPHA', 249609),
(395716, 'PTHR18945:SF819', NULL, NULL, NULL, NULL, 'PH-SENSITIVE CHLORIDE CHANNEL 1, ISOFORM N', 249609),
(395717, 'PTHR18945:SF818', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID TYPE A RECEPTOR SUBUNIT RHO2B', 249609),
(395718, 'PTHR18945:SF815', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR', 249609),
(395719, 'PTHR18945:SF538', NULL, NULL, NULL, NULL, 'GLYCINE RECEPTOR SUBUNIT BETA-TYPE 4', 249609),
(395720, 'PTHR18945:SF899', NULL, NULL, NULL, NULL, 'NEUR_CHAN_LBD DOMAIN-CONTAINING PROTEIN', 249609),
(395721, 'PTHR18945:SF415', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR', 249609),
(395722, 'PTHR18945:SF811', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE RECEPTOR 3E', 249609),
(395723, 'PTHR18945:SF897', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR', 249609),
(395724, 'PTHR18945:SF776', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE-GATED CHLORIDE CHANNEL SUBUNIT ACC-1', 249609),
(395725, 'PTHR18945:SF898', NULL, NULL, NULL, NULL, 'GLUTAMATE-GATED CHLORIDE CHANNEL', 249609),
(395726, 'PTHR18945:SF895', NULL, NULL, NULL, NULL, 'NICOTINIC ACETYLCHOLINE RECEPTOR ALPHA3, ISOFORM B', 249609),
(395727, 'PTHR18945:SF896', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR SUBUNIT ALPHA-LIKE 1-RELATED', 249609),
(395728, 'PTHR18945:SF533', NULL, NULL, NULL, NULL, 'PROTON-GATED ION CHANNEL SUBUNIT PBO-5', 249609),
(395729, 'PTHR18945:SF893', NULL, NULL, NULL, NULL, 'CHOLINERGIC RECEPTOR, NICOTINIC, BETA 1 (MUSCLE)-LIKE', 249609),
(395730, 'PTHR18945:SF410', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR SUBUNIT ALPHA-TYPE DES-2', 249609),
(395731, 'PTHR18945:SF894', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE RECEPTOR 3C-LIKE', 249609),
(395732, 'PTHR18945:SF498', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID RECEPTOR SUBUNIT GAMMA-2', 249609),
(395733, 'PTHR18945:SF892', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR SUBUNIT BETA-TYPE ACR-3', 249609),
(395734, 'PTHR18945:SF493', NULL, NULL, NULL, NULL, 'IP12579P', 249609);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(395735, 'PTHR18945:SF61', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR SUBUNIT DELTA', 249609),
(395736, 'PTHR18945:SF60', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR SUBUNIT GAMMA', 249609),
(395737, 'PTHR18945:SF492', NULL, NULL, NULL, NULL, 'LEV-8', 249609),
(395738, 'PTHR18945:SF846', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR SUBUNIT BETA-LIKE 2', 249609),
(395739, 'PTHR18945:SF844', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID TYPE A RECEPTOR SUBUNIT BETA1', 249609),
(395740, 'PTHR18945:SF569', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE-GATED CHLORIDE CHANNEL SUBUNIT ACC-2', 249609),
(395741, 'PTHR18945:SF449', NULL, NULL, NULL, NULL, 'LIGAND-GATED ION CHANNEL', 249609),
(395742, 'PTHR18945:SF600', NULL, NULL, NULL, NULL, 'NEUR_CHAN_LBD DOMAIN-CONTAINING PROTEIN', 249609),
(395743, 'PTHR18945:SF446', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE-GATED CHLORIDE CHANNEL SUBUNIT ACC-3', 249609),
(395744, 'PTHR18945:SF843', NULL, NULL, NULL, NULL, 'IP12572P-RELATED', 249609),
(395745, 'PTHR18945:SF840', NULL, NULL, NULL, NULL, 'NEUR_CHAN_LBD DOMAIN-CONTAINING PROTEIN', 249609),
(395746, 'PTHR18945:SF444', NULL, NULL, NULL, NULL, 'LIGAND-GATED ION CHANNEL', 249609),
(395747, 'PTHR18945:SF841', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID TYPE A RECEPTOR SUBUNIT PI', 249609),
(395748, 'PTHR18945:SF564', NULL, NULL, NULL, NULL, 'LIGAND-GATED ION CHANNEL', 249609),
(395749, 'PTHR18945:SF443', NULL, NULL, NULL, NULL, 'NEUR_CHAN_LBD DOMAIN-CONTAINING PROTEIN', 249609),
(395750, 'PTHR18945:SF440', NULL, NULL, NULL, NULL, 'LIGAND-GATED ION CHANNEL', 249609),
(395751, 'PTHR18945:SF441', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR', 249609),
(395752, 'PTHR18945:SF93', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID RECEPTOR SUBUNIT GAMMA-1', 249609),
(395753, 'PTHR18945', NULL, NULL, NULL, NULL, 'NEUROTRANSMITTER GATED ION CHANNEL', 249609),
(395754, 'PTHR18945:SF839', NULL, NULL, NULL, NULL, '', 249609),
(395755, 'PTHR18945:SF835', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID RECEPTOR ALPHA-LIKE', 249609),
(395756, 'PTHR18945:SF834', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID RECEPTOR EXP-1-RELATED', 249609),
(395757, 'PTHR18945:SF831', NULL, NULL, NULL, NULL, 'NEURONAL ACETYLCHOLINE RECEPTOR SUBUNIT ALPHA-3', 249609),
(395758, 'PTHR18945:SF557', NULL, NULL, NULL, NULL, 'LIGAND-GATED ION CHANNEL', 249609),
(395759, 'PTHR18945:SF436', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR', 249609),
(395760, 'PTHR18945:SF434', NULL, NULL, NULL, NULL, 'PROTON-GATED ION CHANNEL SUBUNIT PBO-6', 249609),
(395761, 'PTHR18945:SF797', NULL, NULL, NULL, NULL, 'CHOLINERGIC RECEPTOR, NICOTINIC, BETA 5A', 249609),
(395762, 'PTHR18945:SF555', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR', 249609),
(395763, 'PTHR18945:SF431', NULL, NULL, NULL, NULL, 'SEROTONIN-GATED CHLORIDE CHANNEL', 249609),
(395764, 'PTHR18945:SF397', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID RECEPTOR SUBUNIT EPSILON', 249609),
(395765, 'PTHR18945:SF430', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR SUBUNIT ALPHA-LIKE 2', 249609),
(395766, 'PTHR18945:SF82', NULL, NULL, NULL, NULL, 'NEURONAL ACETYLCHOLINE RECEPTOR SUBUNIT ALPHA-6', 249609),
(395767, 'PTHR18945:SF393', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID RECEPTOR SUBUNIT ALPHA-4', 249609),
(395768, 'PTHR18945:SF390', NULL, NULL, NULL, NULL, 'LIGAND-GATED ION CHANNEL', 249609),
(395769, 'PTHR18945:SF909', NULL, NULL, NULL, NULL, 'SUSHI DOMAIN-CONTAINING PROTEIN', 249609),
(395770, 'PTHR18945:SF907', NULL, NULL, NULL, NULL, 'NEURONAL ACETYLCHOLINE RECEPTOR SUBUNIT ALPHA-7', 249609),
(395771, 'PTHR18945:SF908', NULL, NULL, NULL, NULL, 'HISTAMINE-GATED CHLORIDE CHANNEL SUBUNIT 1', 249609),
(395772, 'PTHR18945:SF905', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID TYPE A RECEPTOR SUBUNIT BETA1', 249609),
(395773, 'PTHR18945:SF906', NULL, NULL, NULL, NULL, 'LIGAND-GATED ION CHANNEL', 249609),
(395774, 'PTHR18945:SF903', NULL, NULL, NULL, NULL, 'AGAP010059-PA', 249609),
(395775, 'PTHR18945:SF508', NULL, NULL, NULL, NULL, 'LIGAND-GATED ION CHANNEL', 249609);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(395776, 'PTHR18945:SF904', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR', 249609),
(395777, 'PTHR18945:SF901', NULL, NULL, NULL, NULL, 'NEURONAL ACETYLCHOLINE RECEPTOR SUBUNIT BETA-2', 249609),
(395778, 'PTHR18945:SF902', NULL, NULL, NULL, NULL, 'CHRNA7-FAM7A FUSION PROTEIN', 249609),
(395779, 'PTHR18945:SF869', NULL, NULL, NULL, NULL, 'LIGAND-GATED ION CHANNEL', 249609),
(395780, 'PTHR18945:SF503', NULL, NULL, NULL, NULL, 'LIGAND-GATED ION CHANNEL', 249609),
(395781, 'PTHR18945:SF866', NULL, NULL, NULL, NULL, 'ALPHA8 SUBUNIT OF NICOTINIC ACETYLCHOLINE RECEPTOR', 249609),
(395782, 'PTHR18945:SF867', NULL, NULL, NULL, NULL, 'LIGAND-GATED ION CHANNEL', 249609),
(395783, 'PTHR18945:SF504', NULL, NULL, NULL, NULL, 'GLUTAMATE-GATED CHLORIDE CHANNEL SUBUNIT BETA', 249609),
(395784, 'PTHR18945:SF900', NULL, NULL, NULL, NULL, 'CHOLINERGIC RECEPTOR NICOTINIC BETA 3 SUBUNIT A', 249609),
(395785, 'PTHR18945:SF864', NULL, NULL, NULL, NULL, 'GLYCINE RECEPTOR, ALPHA 4B', 249609),
(395786, 'PTHR18945:SF865', NULL, NULL, NULL, NULL, 'NICOTINIC ACETYLCHOLINE RECEPTOR ALPHA7, ISOFORM E', 249609),
(395787, 'PTHR18945:SF34', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID RECEPTOR SUBUNIT DELTA', 249609),
(395788, 'PTHR18945:SF862', NULL, NULL, NULL, NULL, 'NEUR_CHAN_LBD DOMAIN-CONTAINING PROTEIN', 249609),
(395789, 'PTHR18945:SF33', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID RECEPTOR SUBUNIT PI', 249609),
(395790, 'PTHR18945:SF462', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR', 249609),
(395791, 'PTHR18945:SF221', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID RECEPTOR SUBUNIT BETA-2', 249609),
(395792, 'PTHR18945:SF582', NULL, NULL, NULL, NULL, 'NEUR_CHAN_LBD DOMAIN-CONTAINING PROTEIN', 249609),
(395793, 'PTHR18945:SF30', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID RECEPTOR SUBUNIT RHO-1', 249609),
(395794, 'PTHR18945:SF857', NULL, NULL, NULL, NULL, 'NEUR_CHAN_MEMB DOMAIN-CONTAINING PROTEIN', 249609),
(395795, 'PTHR18945:SF856', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID RECEPTOR SUBUNIT BETA', 249609),
(395796, 'PTHR18945:SF218', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID RECEPTOR SUBUNIT ALPHA-2', 249609),
(395797, 'PTHR18945:SF578', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR SUBUNIT ALPHA-TYPE ACR-16', 249609),
(395798, 'PTHR18945:SF457', NULL, NULL, NULL, NULL, 'NEUR_CHAN_LBD DOMAIN-CONTAINING PROTEIN', 249609),
(395799, 'PTHR18945:SF216', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID RECEPTOR SUBUNIT ALPHA-3', 249609),
(395800, 'PTHR18945:SF579', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID RECEPTOR SUBUNIT THETA', 249609),
(395801, 'PTHR18945:SF854', NULL, NULL, NULL, NULL, 'NEUR_CHAN_LBD DOMAIN-CONTAINING PROTEIN', 249609),
(395802, 'PTHR18945:SF23', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID RECEPTOR SUBUNIT ALPHA-5', 249609),
(395803, 'PTHR18945:SF213', NULL, NULL, NULL, NULL, 'GLYCINE RECEPTOR SUBUNIT ALPHA-1', 249609),
(395804, 'PTHR18945:SF455', NULL, NULL, NULL, NULL, 'GLYCINE RECEPTOR SUBUNIT ALPHA-3', 249609),
(395805, 'PTHR18945:SF335', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID RECEPTOR SUBUNIT ALPHA-6', 249609),
(395806, 'PTHR18945:SF456', NULL, NULL, NULL, NULL, 'LIGAND-GATED ION CHANNEL', 249609),
(395807, 'PTHR18945:SF852', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR', 249609),
(395808, 'PTHR18945:SF211', NULL, NULL, NULL, NULL, 'GLYCINE RECEPTOR SUBUNIT ALPHA-4', 249609),
(395809, 'PTHR18945:SF29', NULL, NULL, NULL, NULL, 'GLYCINE RECEPTOR SUBUNIT BETA', 249609),
(395810, 'PTHR18945:SF453', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR', 249609),
(395811, 'PTHR18945:SF575', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID TYPE A RECEPTOR SUBUNIT ALPHA6A', 249609),
(395812, 'PTHR18945:SF28', NULL, NULL, NULL, NULL, 'GLYCINE RECEPTOR SUBUNIT ALPHA-2', 249609),
(395813, 'PTHR18945:SF452', NULL, NULL, NULL, NULL, 'GLUTAMATE-GATED CHLORIDE CHANNEL', 249609),
(395814, 'PTHR18945:SF571', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID RECEPTOR SUBUNIT BETA-3', 249609),
(395815, 'PTHR18945:SF450', NULL, NULL, NULL, NULL, 'GABA/GLYCINE RECEPTOR FAMILY (SEE GBR)', 249609); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(395816, 'PTHR18945:SF809', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID TYPE A RECEPTOR SUBUNIT ZETA', 249609),
(395817, 'PTHR18945:SF927', NULL, NULL, NULL, NULL, 'NICOTINIC ACETYLCHOLINE RECEPTOR ALPHA4, ISOFORM H', 249609),
(395818, 'PTHR18945:SF529', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR (51.1 KD) (ACR-22)-RELATED', 249609),
(395819, 'PTHR18945:SF925', NULL, NULL, NULL, NULL, 'PROTON-GATED ION CHANNEL', 249609),
(395820, 'PTHR18945:SF408', NULL, NULL, NULL, NULL, 'LIGAND-GATED ION CHANNEL', 249609),
(395821, 'PTHR18945:SF409', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE RECEPTOR 3D', 249609),
(395822, 'PTHR18945:SF926', NULL, NULL, NULL, NULL, 'NICOTINIC ACETYLCHOLINE RECEPTOR ALPHA5, ISOFORM I', 249609),
(395823, 'PTHR18945:SF406', NULL, NULL, NULL, NULL, 'LIGAND-GATED ION CHANNEL 46-RELATED', 249609),
(395824, 'PTHR18945:SF802', NULL, NULL, NULL, NULL, 'RH55021P', 249609),
(395825, 'PTHR18945:SF923', NULL, NULL, NULL, NULL, 'PROTEIN CBR-AVR-14', 249609),
(395826, 'PTHR18945:SF924', NULL, NULL, NULL, NULL, 'NICOTINIC ACETYLCHOLINE RECEPTOR SUBUNIT', 249609),
(395827, 'PTHR18945:SF921', NULL, NULL, NULL, NULL, 'NEUR_CHAN_LBD DOMAIN-CONTAINING PROTEIN', 249609),
(395828, 'PTHR18945:SF767', NULL, NULL, NULL, NULL, 'NEUR_CHAN_LBD DOMAIN-CONTAINING PROTEIN', 249609),
(395829, 'PTHR18945:SF922', NULL, NULL, NULL, NULL, '', 249609),
(395830, 'PTHR18945:SF889', NULL, NULL, NULL, NULL, 'NEURONAL ACETYLCHOLINE RECEPTOR SUBUNIT ALPHA-10', 249609),
(395831, 'PTHR18945:SF526', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR SUBUNIT ALPHA-TYPE ACR-5', 249609),
(395832, 'PTHR18945:SF920', NULL, NULL, NULL, NULL, 'RECEPTOR INVERTEBRATE, PUTATIVE-RELATED', 249609),
(395833, 'PTHR18945:SF403', NULL, NULL, NULL, NULL, 'GABA/GLYCINE RECEPTOR FAMILY (SEE GBR)', 249609),
(395834, 'PTHR18945:SF524', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR', 249609),
(395835, 'PTHR18945:SF488', NULL, NULL, NULL, NULL, 'NEUR_CHAN_LBD DOMAIN-CONTAINING PROTEIN', 249609),
(395836, 'PTHR18945:SF764', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE RECEPTOR 3C', 249609),
(395837, 'PTHR18945:SF401', NULL, NULL, NULL, NULL, 'NEURONAL ACETYLCHOLINE RECEPTOR SUBUNIT ALPHA-4', 249609),
(395838, 'PTHR18945:SF489', NULL, NULL, NULL, NULL, 'NEURONAL ACETYLCHOLINE RECEPTOR SUBUNIT ALPHA-9', 249609),
(395839, 'PTHR18945:SF882', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID TYPE A RECEPTOR PI SUBUNIT', 249609),
(395840, 'PTHR18945:SF520', NULL, NULL, NULL, NULL, 'LIGAND-GATED ION CHANNEL', 249609),
(395841, 'PTHR18945:SF883', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE RECEPTOR 3A-LIKE', 249609),
(395842, 'PTHR18945:SF880', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR', 249609),
(395843, 'PTHR18945:SF59', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR SUBUNIT EPSILON', 249609),
(395844, 'PTHR18945:SF881', NULL, NULL, NULL, NULL, 'NEUR_CHAN_LBD DOMAIN-CONTAINING PROTEIN', 249609),
(395845, 'PTHR18945:SF482', NULL, NULL, NULL, NULL, 'BETAINE RECEPTOR ACR-23', 249609),
(395846, 'PTHR18945:SF53', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE RECEPTOR 3B', 249609),
(395847, 'PTHR18945:SF52', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE RECEPTOR 3A', 249609),
(395848, 'PTHR18945:SF918', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR SUBUNIT BETA-TYPE ACR-2', 249609),
(395849, 'PTHR18945:SF919', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR-LIKE PROTEIN CUP-4', 249609),
(395850, 'PTHR18945:SF916', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID RECEPTOR SUBUNIT BETA-LIKE', 249609),
(395851, 'PTHR18945:SF917', NULL, NULL, NULL, NULL, 'CHOLINERGIC RECEPTOR, NICOTINIC, ALPHA 2B (NEURONAL)', 249609),
(395852, 'PTHR18945:SF914', NULL, NULL, NULL, NULL, 'NEUR_CHAN_LBD DOMAIN-CONTAINING PROTEIN', 249609),
(395853, 'PTHR18945:SF915', NULL, NULL, NULL, NULL, 'NEUR_CHAN_LBD DOMAIN-CONTAINING PROTEIN', 249609),
(395854, 'PTHR18945:SF516', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE-GATED ION CHANNEL ACC-4', 249609),
(395855, 'PTHR18945:SF879', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR', 249609),
(395856, 'PTHR18945:SF912', NULL, NULL, NULL, NULL, 'ZINC-ACTIVATED LIGAND-GATED ION CHANNEL', 249609);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(395857, 'PTHR18945:SF913', NULL, NULL, NULL, NULL, 'NEUR_CHAN_LBD DOMAIN-CONTAINING PROTEIN', 249609),
(395858, 'PTHR18945:SF877', NULL, NULL, NULL, NULL, 'LIGAND-GATED ION CHANNEL', 249609),
(395859, 'PTHR18945:SF910', NULL, NULL, NULL, NULL, 'SHKT DOMAIN-CONTAINING PROTEIN', 249609),
(395860, 'PTHR18945:SF514', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID RECEPTOR SUBUNIT ALPHA-1', 249609),
(395861, 'PTHR18945:SF911', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR SUBUNIT ALPHA-TYPE UNC-38', 249609),
(395862, 'PTHR18945:SF515', NULL, NULL, NULL, NULL, 'NEUR_CHAN_LBD DOMAIN-CONTAINING PROTEIN', 249609),
(395863, 'PTHR18945:SF757', NULL, NULL, NULL, NULL, 'NEURONAL ACETYLCHOLINE RECEPTOR SUBUNIT ALPHA-2', 249609),
(395864, 'PTHR18945:SF512', NULL, NULL, NULL, NULL, 'LIGAND-GATED ION CHANNEL 50', 249609),
(395865, 'PTHR18945:SF754', NULL, NULL, NULL, NULL, 'GLUTAMATE-GATED CHLORIDE CHANNEL ALPHA-RELATED', 249609),
(395866, 'PTHR18945:SF876', NULL, NULL, NULL, NULL, 'NICOTINIC ACETYLCHOLINE RECEPTOR ALPHA6, ISOFORM E', 249609),
(395867, 'PTHR18945:SF477', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR SUBUNIT BETA', 249609),
(395868, 'PTHR18945:SF598', NULL, NULL, NULL, NULL, 'HISTAMINE-GATED CHLORIDE CHANNEL ALPHA1 SUBUNIT', 249609),
(395869, 'PTHR18945:SF874', NULL, NULL, NULL, NULL, 'NEUR_CHAN_LBD DOMAIN-CONTAINING PROTEIN', 249609),
(395870, 'PTHR18945:SF753', NULL, NULL, NULL, NULL, 'LIGAND-GATED ION CHANNEL', 249609),
(395871, 'PTHR18945:SF475', NULL, NULL, NULL, NULL, 'NEUR_CHAN_LBD DOMAIN-CONTAINING PROTEIN', 249609),
(395872, 'PTHR18945:SF751', NULL, NULL, NULL, NULL, 'SI:CH211-39A7.1', 249609),
(395873, 'PTHR18945:SF870', NULL, NULL, NULL, NULL, 'LIGAND-GATED ION CHANNEL', 249609),
(395874, 'PTHR18945:SF471', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR SUBUNIT BETA-TYPE UNC-29', 249609),
(395875, 'PTHR18945:SF196', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID RECEPTOR SUBUNIT RHO-3', 249609),
(395876, 'PTHR18945:SF197', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID RECEPTOR SUBUNIT RHO-2', 249609),
(395877, 'PTHR18945:SF472', NULL, NULL, NULL, NULL, 'ACETYLCHOLINE RECEPTOR SUBUNIT ALPHA-TYPE DEG-3', 249609),
(395878, 'PTHR18945:SF195', NULL, NULL, NULL, NULL, 'GAMMA-AMINOBUTYRIC ACID RECEPTOR SUBUNIT GAMMA-3', 249609),
(395879, 'PTHR48175', NULL, NULL, NULL, NULL, 'OS04G0581700 PROTEIN', 249610),
(395880, 'PTHR48175:SF3', NULL, NULL, NULL, NULL, 'OS04G0581700 PROTEIN', 249610),
(395881, 'PTHR48175:SF2', NULL, NULL, NULL, NULL, '', 249610),
(395882, 'PTHR43679:SF2', NULL, NULL, NULL, NULL, 'OCTANOYL-[GCVH]:PROTEIN N-OCTANOYLTRANSFERASE', 249611),
(395883, 'PTHR43679', NULL, NULL, NULL, NULL, 'OCTANOYLTRANSFERASE LIPM-RELATED', 249611),
(395884, 'PTHR12228:SF17', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 7', 249612),
(395885, 'PTHR12228:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 7', 249612),
(395886, 'PTHR12228:SF16', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 7-LIKE', 249612),
(395887, 'PTHR12228:SF15', NULL, NULL, NULL, NULL, 'TAFII55_N DOMAIN-CONTAINING PROTEIN', 249612),
(395888, 'PTHR12228', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID 55 KD SUBUNIT-RELATED', 249612),
(395889, 'PTHR12228:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 7-LIKE', 249612),
(395890, 'PTHR12228:SF12', NULL, NULL, NULL, NULL, 'TAFII55_N DOMAIN-CONTAINING PROTEIN', 249612),
(395891, 'PTHR12228:SF0', NULL, NULL, NULL, NULL, 'TAFII55_N DOMAIN-CONTAINING PROTEIN', 249612),
(395892, 'PTHR47452:SF2', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 249613),
(395893, 'PTHR47452:SF1', NULL, NULL, NULL, NULL, '', 249613),
(395894, 'PTHR47452', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 249613),
(395895, 'PTHR13224:SF6', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 16', 249614),
(395896, 'PTHR13224', NULL, NULL, NULL, NULL, 'THYROID HORMONE RECEPTOR-ASSOCIATED PROTEIN-RELATED', 249614),
(395897, 'PTHR13166', NULL, NULL, NULL, NULL, 'PROTEIN C6ORF149', 249615);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(395898, 'PTHR13166:SF7', NULL, NULL, NULL, NULL, 'LYR MOTIF-CONTAINING PROTEIN 4', 249615),
(395899, 'PTHR36694:SF10', NULL, NULL, NULL, NULL, '', 249616),
(395900, 'PTHR36694:SF11', NULL, NULL, NULL, NULL, 'AGAP006415-PA', 249616),
(395901, 'PTHR36694:SF12', NULL, NULL, NULL, NULL, 'PROTEIN CBG18288', 249616),
(395902, 'PTHR36694:SF4', NULL, NULL, NULL, NULL, 'LD42595P', 249616),
(395903, 'PTHR36694:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG15784', 249616),
(395904, 'PTHR36694', NULL, NULL, NULL, NULL, 'PASIFLORA 1, ISOFORM A-RELATED', 249616),
(395905, 'PTHR36694:SF5', NULL, NULL, NULL, NULL, 'LP21121P', 249616),
(395906, 'PTHR36694:SF9', NULL, NULL, NULL, NULL, 'PASIFLORA 1, ISOFORM A', 249616),
(395907, 'PTHR10156:SF0', NULL, NULL, NULL, NULL, '2'',3''-CYCLIC-NUCLEOTIDE 3''-PHOSPHODIESTERASE', 249617),
(395908, 'PTHR10156', NULL, NULL, NULL, NULL, '2'',3''-CYCLIC-NUCLEOTIDE 3''-PHOSPHODIESTERASE', 249617),
(395909, 'PTHR37332', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249618),
(395910, 'PTHR37332:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249618),
(395911, 'PTHR21532:SF0', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 36', 249619),
(395912, 'PTHR21532', NULL, NULL, NULL, NULL, 'PHOSPHODIESTERASE HL', 249619),
(395913, 'PTHR11373:SF4', NULL, NULL, NULL, NULL, 'DEOXYNUCLEOSIDE TRIPHOSPHATE TRIPHOSPHOHYDROLASE SAMHD1', 249620),
(395914, 'PTHR11373:SF34', NULL, NULL, NULL, NULL, 'METAL-DEPENDENT PHOSPHOHYDROLASE', 249620),
(395915, 'PTHR11373:SF42', NULL, NULL, NULL, NULL, 'HD DOMAIN-CONTAINING PROTEIN', 249620),
(395916, 'PTHR11373:SF43', NULL, NULL, NULL, NULL, 'DEOXYGUANOSINETRIPHOSPHATE TRIPHOSPHOHYDROLASE-LIKE PROTEIN 1', 249620),
(395917, 'PTHR11373:SF32', NULL, NULL, NULL, NULL, 'DEOXYGUANOSINETRIPHOSPHATE TRIPHOSPHOHYDROLASE', 249620),
(395918, 'PTHR11373:SF40', NULL, NULL, NULL, NULL, 'DEOXYGUANOSINETRIPHOSPHATE TRIPHOSPHOHYDROLASE-LIKE PROTEIN 2', 249620),
(395919, 'PTHR11373:SF41', NULL, NULL, NULL, NULL, 'METAL-DEPENDENT PHOSPHOHYDROLASE', 249620),
(395920, 'PTHR11373', NULL, NULL, NULL, NULL, 'DEOXYNUCLEOSIDE TRIPHOSPHATE TRIPHOSPHOHYDROLASE', 249620),
(395921, 'PTHR34189:SF16', NULL, NULL, NULL, NULL, '', 249621),
(395922, 'PTHR34189:SF14', NULL, NULL, NULL, NULL, 'BNAANNG06920D PROTEIN', 249621),
(395923, 'PTHR34189:SF13', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 249621),
(395924, 'PTHR34189:SF11', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 249621),
(395925, 'PTHR34189:SF10', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 249621),
(395926, 'PTHR34189', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 249621),
(395927, 'PTHR34189:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 249621),
(395928, 'PTHR34189:SF9', NULL, NULL, NULL, NULL, '', 249621),
(395929, 'PTHR34189:SF19', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 249621),
(395930, 'PTHR34189:SF7', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 249621),
(395931, 'PTHR34189:SF18', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-KINASE RLCKVII PROTEIN', 249621),
(395932, 'PTHR34189:SF17', NULL, NULL, NULL, NULL, '', 249621),
(395933, 'PTHR47490', NULL, NULL, NULL, NULL, 'PROTEIN BLISTER', 249622),
(395934, 'PTHR47490:SF3', NULL, NULL, NULL, NULL, '', 249622),
(395935, 'PTHR47490:SF2', NULL, NULL, NULL, NULL, 'PROTEIN BLISTER', 249622),
(395936, 'PTHR24099:SF17', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF CONTAINING 55', 249623),
(395937, 'PTHR24099:SF16', NULL, NULL, NULL, NULL, 'B30.2/SPRY DOMAIN-CONTAINING PROTEIN', 249623),
(395938, 'PTHR24099:SF15', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM9', 249623),
(395939, 'PTHR24099:SF26', NULL, NULL, NULL, NULL, '', 249623),
(395940, 'PTHR24099:SF14', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE III DOMAIN CONTAINING PROTEIN 3C1-RELATED', 249623),
(395941, 'PTHR24099', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM36-RELATED', 249623),
(395942, 'PTHR24099:SF19', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE III DOMAIN-CONTAINING PROTEIN 3B', 249623),
(395943, 'PTHR24099:SF29', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING 46A', 249623);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(395944, 'PTHR24099:SF18', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM36', 249623),
(395945, 'PTHR24099:SF20', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 46', 249623),
(395946, 'PTHR24099:SF30', NULL, NULL, NULL, NULL, 'SPRY DOMAIN-CONTAINING 4', 249623),
(395947, 'PTHR24099:SF9', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE-III DOMAIN-CONTAINING PROTEIN 3A', 249623),
(395948, 'PTHR24099:SF13', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM9', 249623),
(395949, 'PTHR24099:SF6', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE III AND SPRY DOMAIN-CONTAINING PROTEIN 2', 249623),
(395950, 'PTHR24099:SF12', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MID2-RELATED', 249623),
(395951, 'PTHR24099:SF23', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MIDLINE-1', 249623),
(395952, 'PTHR24099:SF5', NULL, NULL, NULL, NULL, 'B30.2/SPRY DOMAIN-CONTAINING PROTEIN', 249623),
(395953, 'PTHR24099:SF8', NULL, NULL, NULL, NULL, 'FSD1-LIKE PROTEIN', 249623),
(395954, 'PTHR24099:SF11', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE III DOMAIN-CONTAINING 3BA-RELATED', 249623),
(395955, 'PTHR24099:SF7', NULL, NULL, NULL, NULL, 'CARDIOMYOPATHY-ASSOCIATED PROTEIN 5', 249623),
(395956, 'PTHR24099:SF21', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 67', 249623),
(395957, 'PTHR24099:SF4', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE III AND SPRY DOMAIN-CONTAINING PROTEIN 1', 249623),
(395958, 'PTHR13283', NULL, NULL, NULL, NULL, 'KREV INTERACTION TRAPPED 1-RELATED', 249624),
(395959, 'PTHR13283:SF10', NULL, NULL, NULL, NULL, 'FERM DOMAIN-CONTAINING PROTEIN 8', 249624),
(395960, 'PTHR13283:SF11', NULL, NULL, NULL, NULL, 'KREV INTERACTION TRAPPED PROTEIN 1', 249624),
(395961, 'PTHR13283:SF12', NULL, NULL, NULL, NULL, 'FERM DOMAIN-CONTAINING PROTEIN FRMD8P1-RELATED', 249624),
(395962, 'PTHR13283:SF13', NULL, NULL, NULL, NULL, 'FERM DOMAIN-CONTAINING PROTEIN 8', 249624),
(395963, 'PTHR37692', NULL, NULL, NULL, NULL, 'HYPOTHETICAL MEMBRANE SPANNING PROTEIN', 249625),
(395964, 'PTHR37692:SF1', NULL, NULL, NULL, NULL, 'DUF420 FAMILY PROTEIN', 249625),
(395965, 'PTHR23085', NULL, NULL, NULL, NULL, 'GH28348P', 249626),
(395966, 'PTHR23085:SF7', NULL, NULL, NULL, NULL, 'JUNCTOPHILIN-3', 249626),
(395967, 'PTHR23085:SF17', NULL, NULL, NULL, NULL, 'SI:CH211-146M13.3', 249626),
(395968, 'PTHR23085:SF6', NULL, NULL, NULL, NULL, 'JUNCTOPHILIN-1', 249626),
(395969, 'PTHR23085:SF27', NULL, NULL, NULL, NULL, 'JUNCTOPHILIN', 249626),
(395970, 'PTHR23085:SF16', NULL, NULL, NULL, NULL, 'GH28348P', 249626),
(395971, 'PTHR23085:SF26', NULL, NULL, NULL, NULL, 'JUNCTOPHILIN-2', 249626),
(395972, 'PTHR23085:SF14', NULL, NULL, NULL, NULL, 'JUNCTOPHILIN-4', 249626),
(395973, 'PTHR43434', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCOLATE PHOSPHATASE', 249627),
(395974, 'PTHR43434:SF20', NULL, NULL, NULL, NULL, '5''-NUCLEOTIDASE', 249627),
(395975, 'PTHR43434:SF22', NULL, NULL, NULL, NULL, 'PROTEIN CBG18783', 249627),
(395976, 'PTHR43434:SF3', NULL, NULL, NULL, NULL, 'GMP/IMP NUCLEOTIDASE YRFG', 249627),
(395977, 'PTHR43434:SF21', NULL, NULL, NULL, NULL, 'SLL0295 PROTEIN', 249627),
(395978, 'PTHR43434:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G00760)-RELATED', 249627),
(395979, 'PTHR43434:SF13', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCOLATE PHOSPHATASE', 249627),
(395980, 'PTHR43434:SF15', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCOLATE PHOSPHATASE', 249627),
(395981, 'PTHR43434:SF16', NULL, NULL, NULL, NULL, 'BLL8046 PROTEIN', 249627),
(395982, 'PTHR43434:SF19', NULL, NULL, NULL, NULL, 'PHOSPHONOACETALDEHYDE HYDROLASE', 249627),
(395983, 'PTHR43434:SF9', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE PTKA', 249627),
(395984, 'PTHR42853:SF1', NULL, NULL, NULL, NULL, 'ACETYL-COA CARBOXYTRANSFERASE', 249628),
(395985, 'PTHR42853', NULL, NULL, NULL, NULL, 'ACETYL-COENZYME A CARBOXYLASE CARBOXYL TRANSFERASE SUBUNIT ALPHA', 249628),
(395986, 'PTHR42853:SF3', NULL, NULL, NULL, NULL, 'ACETYL-COENZYME A CARBOXYLASE CARBOXYL TRANSFERASE SUBUNIT ALPHA, CHLOROPLASTIC', 249628),
(395987, 'PTHR42853:SF4', NULL, NULL, NULL, NULL, 'ACETYL-COA CARBOXYTRANSFERASE', 249628);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(395988, 'PTHR16290', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SMIF  DECAPPING ENZYME DCP1', 249629),
(395989, 'PTHR16290:SF0', NULL, NULL, NULL, NULL, 'DECAPPING PROTEIN 1, ISOFORM A', 249629),
(395990, 'PTHR16290:SF4', NULL, NULL, NULL, NULL, 'MRNA-DECAPPING ENZYME 1A', 249629),
(395991, 'PTHR16290:SF31', NULL, NULL, NULL, NULL, 'MRNA-DECAPPING ENZYME-LIKE PROTEIN', 249629),
(395992, 'PTHR16290:SF21', NULL, NULL, NULL, NULL, 'MRNA-DECAPPING ENZYME-LIKE PROTEIN', 249629),
(395993, 'PTHR16290:SF5', NULL, NULL, NULL, NULL, 'MRNA-DECAPPING ENZYME 1B', 249629),
(395994, 'PTHR16290:SF35', NULL, NULL, NULL, NULL, 'MRNA-DECAPPING ENZYME-LIKE PROTEIN', 249629),
(395995, 'PTHR16290:SF37', NULL, NULL, NULL, NULL, 'MRNA-DECAPPING ENZYME-LIKE PROTEIN', 249629),
(395996, 'PTHR16290:SF26', NULL, NULL, NULL, NULL, '', 249629),
(395997, 'PTHR16290:SF25', NULL, NULL, NULL, NULL, '', 249629),
(395998, 'PTHR16290:SF36', NULL, NULL, NULL, NULL, 'WH1 DOMAIN-CONTAINING PROTEIN', 249629),
(395999, 'PTHR16290:SF17', NULL, NULL, NULL, NULL, 'OS07G0249600 PROTEIN', 249629),
(396000, 'PTHR16290:SF29', NULL, NULL, NULL, NULL, 'BNAA08G27050D PROTEIN', 249629),
(396001, 'PTHR23036:SF172', NULL, NULL, NULL, NULL, 'CYTOKINE RECEPTOR COMMON SUBUNIT GAMMA', 249630),
(396002, 'PTHR23036:SF171', NULL, NULL, NULL, NULL, 'INTERLEUKIN-12 SUBUNIT BETA', 249630),
(396003, 'PTHR23036:SF151', NULL, NULL, NULL, NULL, 'DOMELESS', 249630),
(396004, 'PTHR23036:SF96', NULL, NULL, NULL, NULL, 'INTERLEUKIN-31 RECEPTOR SUBUNIT ALPHA', 249630),
(396005, 'PTHR23036:SF51', NULL, NULL, NULL, NULL, 'INTERLEUKIN-12 RECEPTOR SUBUNIT BETA-1', 249630),
(396006, 'PTHR23036:SF95', NULL, NULL, NULL, NULL, 'ONCOSTATIN-M-SPECIFIC RECEPTOR SUBUNIT BETA', 249630),
(396007, 'PTHR23036:SF156', NULL, NULL, NULL, NULL, 'INTERLEUKIN-12 SUBUNIT BETA', 249630),
(396008, 'PTHR23036:SF79', NULL, NULL, NULL, NULL, 'INTERLEUKIN-12 RECEPTOR SUBUNIT BETA-2', 249630),
(396009, 'PTHR23036:SF112', NULL, NULL, NULL, NULL, 'INTERLEUKIN-23 RECEPTOR', 249630),
(396010, 'PTHR23036:SF179', NULL, NULL, NULL, NULL, 'INTERLEUKIN-3 RECEPTOR SUBUNIT ALPHA', 249630),
(396011, 'PTHR23036:SF98', NULL, NULL, NULL, NULL, 'INTERLEUKIN-6 RECEPTOR SUBUNIT ALPHA', 249630),
(396012, 'PTHR23036:SF17', NULL, NULL, NULL, NULL, 'INTERLEUKIN-5 RECEPTOR SUBUNIT ALPHA', 249630),
(396013, 'PTHR23036:SF16', NULL, NULL, NULL, NULL, 'CYTOKINE RECEPTOR-LIKE FACTOR 1', 249630),
(396014, 'PTHR23036:SF109', NULL, NULL, NULL, NULL, 'LEPTIN RECEPTOR', 249630),
(396015, 'PTHR23036:SF108', NULL, NULL, NULL, NULL, 'GROWTH HORMONE RECEPTOR', 249630),
(396016, 'PTHR23036:SF29', NULL, NULL, NULL, NULL, 'INTERLEUKIN-11 RECEPTOR SUBUNIT ALPHA', 249630),
(396017, 'PTHR23036:SF190', NULL, NULL, NULL, NULL, 'GRANULOCYTE-MACROPHAGE COLONY-STIMULATING FACTOR RECEPTOR SUBUNIT ALPHA', 249630),
(396018, 'PTHR23036', NULL, NULL, NULL, NULL, 'CYTOKINE RECEPTOR', 249630),
(396019, 'PTHR23036:SF163', NULL, NULL, NULL, NULL, 'CYTOKINE RECEPTOR-LIKE FACTOR 2', 249630),
(396020, 'PTHR23036:SF86', NULL, NULL, NULL, NULL, 'PROLACTIN RECEPTOR', 249630),
(396021, 'PTHR23036:SF187', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE-III DOMAIN-CONTAINING PROTEIN', 249630),
(396022, 'PTHR23036:SF186', NULL, NULL, NULL, NULL, 'IL6RA-BIND DOMAIN-CONTAINING PROTEIN', 249630),
(396023, 'PTHR23036:SF83', NULL, NULL, NULL, NULL, 'INTERLEUKIN-6 RECEPTOR SUBUNIT BETA', 249630),
(396024, 'PTHR23036:SF101', NULL, NULL, NULL, NULL, 'INTERLEUKIN-13 RECEPTOR SUBUNIT ALPHA-2', 249630),
(396025, 'PTHR23036:SF189', NULL, NULL, NULL, NULL, 'LEPTIN RECEPTOR', 249630),
(396026, 'PTHR23036:SF6', NULL, NULL, NULL, NULL, 'INTERLEUKIN-27 RECEPTOR SUBUNIT ALPHA', 249630),
(396027, 'PTHR23036:SF167', NULL, NULL, NULL, NULL, 'INTERLEUKIN-27 SUBUNIT BETA', 249630),
(396028, 'PTHR23036:SF89', NULL, NULL, NULL, NULL, 'INTERLEUKIN-13 RECEPTOR SUBUNIT ALPHA-1', 249630),
(396029, 'PTHR23036:SF188', NULL, NULL, NULL, NULL, 'INTERLEUKIN-12 SUBUNIT BETA', 249630),
(396030, 'PTHR23036:SF103', NULL, NULL, NULL, NULL, 'GRANULOCYTE COLONY-STIMULATING FACTOR RECEPTOR', 249630);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(396031, 'PTHR23036:SF21', NULL, NULL, NULL, NULL, 'CILIARY NEUROTROPHIC FACTOR RECEPTOR SUBUNIT ALPHA', 249630),
(396032, 'PTHR23036:SF105', NULL, NULL, NULL, NULL, 'LEUKEMIA INHIBITORY FACTOR RECEPTOR', 249630),
(396033, 'PTHR36423:SF2', NULL, NULL, NULL, NULL, 'AFR070WP', 249631),
(396034, 'PTHR36423', NULL, NULL, NULL, NULL, 'AFR070WP', 249631),
(396035, 'PTHR33222:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CURVATURE THYLAKOID 1B, CHLOROPLASTIC', 249632),
(396036, 'PTHR33222:SF26', NULL, NULL, NULL, NULL, 'OS08G0430600 PROTEIN', 249632),
(396037, 'PTHR33222:SF36', NULL, NULL, NULL, NULL, '', 249632),
(396038, 'PTHR33222:SF28', NULL, NULL, NULL, NULL, 'CAAD DOMAIN-CONTAINING PROTEIN', 249632),
(396039, 'PTHR33222:SF27', NULL, NULL, NULL, NULL, 'CYANOBACTERIAL AMINOACYL-TRNA SYNTHETASE, CAAD DOMAIN-CONTAINING PROTEIN-RELATED', 249632),
(396040, 'PTHR33222:SF22', NULL, NULL, NULL, NULL, 'PROTEIN CURVATURE THYLAKOID 1A CHLOROPLASTIC', 249632),
(396041, 'PTHR33222:SF24', NULL, NULL, NULL, NULL, 'PROTEIN CURVATURE THYLAKOID 1A, CHLOROPLASTIC-LIKE', 249632),
(396042, 'PTHR33222:SF35', NULL, NULL, NULL, NULL, 'CYANOBACTERIAL AMINOACYL-TRNA SYNTHETASE, CAAD DOMAIN-CONTAINING PROTEIN-RELATED', 249632),
(396043, 'PTHR33222:SF34', NULL, NULL, NULL, NULL, 'OS09G0465800 PROTEIN', 249632),
(396044, 'PTHR33222:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CURVATURE THYLAKOID 1D, CHLOROPLASTIC', 249632),
(396045, 'PTHR33222:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CURVATURE THYLAKOID 1C, CHLOROPLASTIC', 249632),
(396046, 'PTHR33222:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CURVATURE THYLAKOID 1A, CHLOROPLASTIC', 249632),
(396047, 'PTHR33222:SF5', NULL, NULL, NULL, NULL, 'OS02G0759900 PROTEIN', 249632),
(396048, 'PTHR33222:SF6', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249632),
(396049, 'PTHR33222:SF29', NULL, NULL, NULL, NULL, 'CAAD DOMAIN-CONTAINING PROTEIN', 249632),
(396050, 'PTHR33222', NULL, NULL, NULL, NULL, '', 249632),
(396051, 'PTHR36375:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249633),
(396052, 'PTHR36375:SF1', NULL, NULL, NULL, NULL, 'OS05G0459300 PROTEIN', 249633),
(396053, 'PTHR36375', NULL, NULL, NULL, NULL, 'OS05G0459300 PROTEIN', 249633),
(396054, 'PTHR36749', NULL, NULL, NULL, NULL, 'F7O18.3 PROTEIN', 249634),
(396055, 'PTHR36749:SF1', NULL, NULL, NULL, NULL, 'F7O18.3 PROTEIN', 249634),
(396056, 'PTHR33928:SF5', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE QRT3-LIKE PROTEIN', 249635),
(396057, 'PTHR33928:SF4', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE QRT3-LIKE', 249635),
(396058, 'PTHR33928:SF7', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE QRT3', 249635),
(396059, 'PTHR33928:SF6', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE QRT3-LIKE PROTEIN', 249635),
(396060, 'PTHR33928:SF9', NULL, NULL, NULL, NULL, 'PECTATE_LYASE_3 DOMAIN-CONTAINING PROTEIN', 249635),
(396061, 'PTHR33928', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE QRT3', 249635),
(396062, 'PTHR33928:SF2', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_3G07520)-RELATED', 249635),
(396063, 'PTHR22663:SF27', NULL, NULL, NULL, NULL, 'ZIP HOMOLOGOUS PROTEIN 1-RELATED', 249636),
(396064, 'PTHR22663:SF29', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 212B', 249636),
(396065, 'PTHR22663:SF17', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN NARYA-RELATED', 249636),
(396066, 'PTHR22663:SF28', NULL, NULL, NULL, NULL, 'ZIP HOMOLOGOUS PROTEIN 3', 249636),
(396067, 'PTHR22663', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 249636),
(396068, 'PTHR22663:SF21', NULL, NULL, NULL, NULL, 'E3 SUMO-PROTEIN LIGASE RNF212-RELATED', 249636),
(396069, 'PTHR39112:SF3', NULL, NULL, NULL, NULL, '', 249637),
(396070, 'PTHR39112:SF4', NULL, NULL, NULL, NULL, 'BNACNNG55840D PROTEIN', 249637),
(396071, 'PTHR39112', NULL, NULL, NULL, NULL, 'PROTEIN RALF-LIKE 27-RELATED', 249637),
(396072, 'PTHR39112:SF5', NULL, NULL, NULL, NULL, 'PROTEIN RALF-LIKE 27', 249637),
(396073, 'PTHR39112:SF1', NULL, NULL, NULL, NULL, 'PROTEIN RALF-LIKE 27', 249637),
(396074, 'PTHR10574:SF409', NULL, NULL, NULL, NULL, 'LAMININ SUBUNIT ALPHA-1', 249638),
(396075, 'PTHR10574:SF406', NULL, NULL, NULL, NULL, 'LAMININ SUBUNIT ALPHA', 249638);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(396076, 'PTHR10574:SF428', NULL, NULL, NULL, NULL, 'LAMININ SUBUNIT ALPHA-1-LIKE PROTEIN', 249638),
(396077, 'PTHR10574:SF429', NULL, NULL, NULL, NULL, 'LAMININ, BETA 2 (LAMININ S)', 249638),
(396078, 'PTHR10574:SF402', NULL, NULL, NULL, NULL, '', 249638),
(396079, 'PTHR10574:SF422', NULL, NULL, NULL, NULL, 'LAMININ, ALPHA 4', 249638),
(396080, 'PTHR10574:SF268', NULL, NULL, NULL, NULL, 'LAMININ SUBUNIT BETA-3', 249638),
(396081, 'PTHR10574:SF365', NULL, NULL, NULL, NULL, 'NETRIN-A-RELATED', 249638),
(396082, 'PTHR10574:SF440', NULL, NULL, NULL, NULL, 'LAMININ RELATED. SEE ALSO LMB', 249638),
(396083, 'PTHR10574:SF441', NULL, NULL, NULL, NULL, 'LAMININ SUBUNIT GAMMA 2', 249638),
(396084, 'PTHR10574:SF240', NULL, NULL, NULL, NULL, 'LAMININ SUBUNIT GAMMA-3', 249638),
(396085, 'PTHR10574:SF262', NULL, NULL, NULL, NULL, 'NETRIN 5', 249638),
(396086, 'PTHR10574:SF383', NULL, NULL, NULL, NULL, 'NETRIN 5', 249638),
(396087, 'PTHR10574:SF285', NULL, NULL, NULL, NULL, 'LAMININ SUBUNIT ALPHA-3', 249638),
(396088, 'PTHR10574:SF282', NULL, NULL, NULL, NULL, 'NETRIN-4', 249638),
(396089, 'PTHR10574:SF36', NULL, NULL, NULL, NULL, 'LAMININ SUBUNIT BETA-2', 249638),
(396090, 'PTHR10574:SF261', NULL, NULL, NULL, NULL, 'LAMININ SUBUNIT ALPHA-5', 249638),
(396091, 'PTHR10574:SF419', NULL, NULL, NULL, NULL, 'NETRIN 4-RELATED', 249638),
(396092, 'PTHR10574:SF439', NULL, NULL, NULL, NULL, 'WING BLISTER, ISOFORM B', 249638),
(396093, 'PTHR10574:SF437', NULL, NULL, NULL, NULL, 'NETRIN-1', 249638),
(396094, 'PTHR10574:SF438', NULL, NULL, NULL, NULL, '', 249638),
(396095, 'PTHR10574:SF435', NULL, NULL, NULL, NULL, 'LAMININ SUBUNIT GAMMA-1', 249638),
(396096, 'PTHR10574:SF436', NULL, NULL, NULL, NULL, '', 249638),
(396097, 'PTHR10574:SF433', NULL, NULL, NULL, NULL, 'MULTIPLE EPIDERMAL GROWTH FACTOR-LIKE DOMAINS PROTEIN 8', 249638),
(396098, 'PTHR10574:SF378', NULL, NULL, NULL, NULL, 'NETRIN-1', 249638),
(396099, 'PTHR10574:SF279', NULL, NULL, NULL, NULL, 'LAMININ SUBUNIT BETA-4', 249638),
(396100, 'PTHR10574:SF434', NULL, NULL, NULL, NULL, 'PROTEIN TAG-53-RELATED', 249638),
(396101, 'PTHR10574:SF313', NULL, NULL, NULL, NULL, 'LAMININ SUBUNIT GAMMA-2', 249638),
(396102, 'PTHR10574:SF431', NULL, NULL, NULL, NULL, 'NETRIN-1', 249638),
(396103, 'PTHR10574:SF233', NULL, NULL, NULL, NULL, 'LAMININ SUBUNIT BETA-1', 249638),
(396104, 'PTHR10574:SF432', NULL, NULL, NULL, NULL, 'BASEMENT MEMBRANE-SPECIFIC HEPARAN SULFATE PROTEOGLYCAN CORE PROTEIN-LIKE PROTEIN', 249638),
(396105, 'PTHR10574:SF375', NULL, NULL, NULL, NULL, 'LAMININ SUBUNIT BETA-1', 249638),
(396106, 'PTHR10574:SF430', NULL, NULL, NULL, NULL, 'NETRIN-1', 249638),
(396107, 'PTHR10574:SF298', NULL, NULL, NULL, NULL, 'MULTIPLE EPIDERMAL GROWTH FACTOR-LIKE DOMAINS PROTEIN 9', 249638),
(396108, 'PTHR10574:SF273', NULL, NULL, NULL, NULL, 'BASEMENT MEMBRANE-SPECIFIC HEPARAN SULFATE PROTEOGLYCAN CORE PROTEIN', 249638),
(396109, 'PTHR10574', NULL, NULL, NULL, NULL, 'NETRIN/LAMININ-RELATED', 249638),
(396110, 'PTHR10574:SF197', NULL, NULL, NULL, NULL, 'LAMININ, BETA 2-LIKE', 249638),
(396111, 'PTHR10574:SF274', NULL, NULL, NULL, NULL, 'USHERIN', 249638),
(396112, 'PTHR10574:SF291', NULL, NULL, NULL, NULL, 'LAMININ SUBUNIT ALPHA-2', 249638),
(396113, 'PTHR10574:SF27', NULL, NULL, NULL, NULL, 'NETRIN-G2', 249638),
(396114, 'PTHR10574:SF292', NULL, NULL, NULL, NULL, 'NETRIN-3', 249638),
(396115, 'PTHR10574:SF270', NULL, NULL, NULL, NULL, 'LAMININ SUBUNIT GAMMA-1', 249638),
(396116, 'PTHR10574:SF28', NULL, NULL, NULL, NULL, 'NETRIN-G1', 249638),
(396117, 'PTHR16484', NULL, NULL, NULL, NULL, 'PARTITIONING DEFECTIVE 3 RELATED', 249639),
(396118, 'PTHR16484:SF17', NULL, NULL, NULL, NULL, 'BAZOOKA, ISOFORM B', 249639),
(396119, 'PTHR16484:SF4', NULL, NULL, NULL, NULL, 'PARTITIONING DEFECTIVE 3 HOMOLOG B', 249639),
(396120, 'PTHR16484:SF10', NULL, NULL, NULL, NULL, 'PARTITIONING DEFECTIVE 3 HOMOLOG', 249639),
(396121, 'PTHR24024:SF40', NULL, NULL, NULL, NULL, 'PULMONARY SURFACTANT-ASSOCIATED PROTEIN A2', 249640),
(396122, 'PTHR24024:SF19', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 249640);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(396123, 'PTHR24024:SF18', NULL, NULL, NULL, NULL, 'DOMAIN-CONTAINING PROTEIN, PUTATIVE-RELATED', 249640),
(396124, 'PTHR24024:SF15', NULL, NULL, NULL, NULL, 'PULMONARY SURFACTANT-ASSOCIATED PROTEIN D', 249640),
(396125, 'PTHR24024:SF14', NULL, NULL, NULL, NULL, 'COLLECTIN-11', 249640),
(396126, 'PTHR24024:SF13', NULL, NULL, NULL, NULL, 'PULMONARY SURFACTANT-ASSOCIATED PROTEIN A1', 249640),
(396127, 'PTHR24024:SF35', NULL, NULL, NULL, NULL, 'MANNOSE-BINDING PROTEIN A', 249640),
(396128, 'PTHR24024:SF34', NULL, NULL, NULL, NULL, 'MANNOSE-BINDING PROTEIN C', 249640),
(396129, 'PTHR24024:SF20', NULL, NULL, NULL, NULL, 'COLLECTIN-10', 249640),
(396130, 'PTHR24024', NULL, NULL, NULL, NULL, 'PULMONARY SURFACTANT-ASSOCIATED PROTEIN A', 249640),
(396131, 'PTHR24024:SF41', NULL, NULL, NULL, NULL, 'FARMER, ISOFORM H', 249640),
(396132, 'PTHR48086', NULL, NULL, NULL, NULL, 'SODIUM/PROLINE SYMPORTER-RELATED', 249641),
(396133, 'PTHR48086:SF5', NULL, NULL, NULL, NULL, 'NA(+):SOLUTE SYMPORTER (SSF FAMILY)', 249641),
(396134, 'PTHR48086:SF6', NULL, NULL, NULL, NULL, 'CATION/ACETATE SYMPORTER ACTP', 249641),
(396135, 'PTHR48086:SF7', NULL, NULL, NULL, NULL, 'SODIUM/SOLUTE SYMPORTER', 249641),
(396136, 'PTHR48086:SF8', NULL, NULL, NULL, NULL, 'MONOCARBOXYLIC ACID PERMEASE', 249641),
(396137, 'PTHR48086:SF10', NULL, NULL, NULL, NULL, 'UREA TRANSPORTER', 249641),
(396138, 'PTHR48086:SF1', NULL, NULL, NULL, NULL, 'OSMOREGULATED PROLINE TRANSPORTER OPUE', 249641),
(396139, 'PTHR48086:SF3', NULL, NULL, NULL, NULL, 'SODIUM/PROLINE SYMPORTER', 249641),
(396140, 'PTHR48086:SF4', NULL, NULL, NULL, NULL, 'SODIUM/PANTOTHENATE SYMPORTER', 249641),
(396141, 'PTHR46851:SF18', NULL, NULL, NULL, NULL, 'ZINC ION BINDING,DNA BINDING PROTEIN-RELATED', 249642),
(396142, 'PTHR46851:SF19', NULL, NULL, NULL, NULL, 'PLUS3 DOMAIN-CONTAINING PROTEIN', 249642),
(396143, 'PTHR46851:SF20', NULL, NULL, NULL, NULL, 'PLUS3 DOMAIN-CONTAINING PROTEIN', 249642),
(396144, 'PTHR46851:SF10', NULL, NULL, NULL, NULL, 'PLUS3 DOMAIN-CONTAINING PROTEIN', 249642),
(396145, 'PTHR46851:SF11', NULL, NULL, NULL, NULL, 'PLUS3 DOMAIN-CONTAINING PROTEIN', 249642),
(396146, 'PTHR46851:SF5', NULL, NULL, NULL, NULL, 'ZINC ION BINDING / DNA BINDING PROTEIN', 249642),
(396147, 'PTHR46851:SF6', NULL, NULL, NULL, NULL, 'SWIB/MDM2, PLUS-3 AND GYF DOMAIN-CONTAINING PROTEIN', 249642),
(396148, 'PTHR46851:SF14', NULL, NULL, NULL, NULL, 'ZINC ION BINDING', 249642),
(396149, 'PTHR46851:SF15', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 19-LIKE ISOFORM X1', 249642),
(396150, 'PTHR46851', NULL, NULL, NULL, NULL, 'OS01G0884500 PROTEIN', 249642),
(396151, 'PTHR46851:SF16', NULL, NULL, NULL, NULL, 'GYF DOMAIN-CONTAINING PROTEIN', 249642),
(396152, 'PTHR46851:SF17', NULL, NULL, NULL, NULL, 'ION BINDING,DNA BINDING, PUTATIVE ISOFORM 3-RELATED', 249642),
(396153, 'PTHR37312', NULL, NULL, NULL, NULL, 'MEMBRANE-BOUND ACYLTRANSFERASE YKRP-RELATED', 249643),
(396154, 'PTHR37312:SF1', NULL, NULL, NULL, NULL, 'MEMBRANE-BOUND ACYLTRANSFERASE YKRP-RELATED', 249643),
(396155, 'PTHR15136:SF5', NULL, NULL, NULL, NULL, 'STROMAL INTERACTION MOLECULE HOMOLOG', 249644),
(396156, 'PTHR15136:SF9', NULL, NULL, NULL, NULL, 'STROMAL INTERACTION MOLECULE 1', 249644),
(396157, 'PTHR15136', NULL, NULL, NULL, NULL, 'STROMAL INTERACTION MOLECULE HOMOLOG', 249644),
(396158, 'PTHR15136:SF2', NULL, NULL, NULL, NULL, 'STROMAL INTERACTION MOLECULE 2', 249644),
(396159, 'PTHR15136:SF12', NULL, NULL, NULL, NULL, 'TROMAL INTERACTION MOLECULE 2A', 249644),
(396160, 'PTHR35164:SF12', NULL, NULL, NULL, NULL, '', 249645),
(396161, 'PTHR35164:SF10', NULL, NULL, NULL, NULL, 'OS08G0481100 PROTEIN', 249645),
(396162, 'PTHR35164:SF5', NULL, NULL, NULL, NULL, 'OS02G0572600 PROTEIN', 249645),
(396163, 'PTHR35164', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249645),
(396164, 'PTHR35164:SF7', NULL, NULL, NULL, NULL, 'MYOSIN-13-LIKE', 249645),
(396165, 'PTHR35164:SF14', NULL, NULL, NULL, NULL, 'OS04G0450900 PROTEIN', 249645),
(396166, 'PTHR35164:SF9', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249645);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(396167, 'PTHR45736', NULL, NULL, NULL, NULL, 'ZINC FINGER MYM-TYPE PROTEIN', 249646),
(396168, 'PTHR45736:SF1', NULL, NULL, NULL, NULL, 'WITHOUT CHILDREN, ISOFORM B', 249646),
(396169, 'PTHR45736:SF10', NULL, NULL, NULL, NULL, 'DUF3504 DOMAIN-CONTAINING PROTEIN', 249646),
(396170, 'PTHR45736:SF6', NULL, NULL, NULL, NULL, 'ZINC FINGER MYM-TYPE PROTEIN 2', 249646),
(396171, 'PTHR45736:SF7', NULL, NULL, NULL, NULL, 'ZINC FINGER MYM-TYPE PROTEIN 5', 249646),
(396172, 'PTHR45736:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR QRICH1', 249646),
(396173, 'PTHR45736:SF9', NULL, NULL, NULL, NULL, 'ZINC FINGER MYM-TYPE PROTEIN 6', 249646),
(396174, 'PTHR45736:SF3', NULL, NULL, NULL, NULL, 'ZINC FINGER MYM-TYPE PROTEIN 3', 249646),
(396175, 'PTHR45736:SF4', NULL, NULL, NULL, NULL, 'ZINC FINGER MYM-TYPE PROTEIN 1', 249646),
(396176, 'PTHR45736:SF5', NULL, NULL, NULL, NULL, 'ZINC FINGER MYM-TYPE PROTEIN 4', 249646),
(396177, 'PTHR14380:SF11', NULL, NULL, NULL, NULL, 'OOCYTE-SECRETED PROTEIN 4A', 249647),
(396178, 'PTHR14380:SF10', NULL, NULL, NULL, NULL, 'OOCYTE-SECRETED PROTEIN 3', 249647),
(396179, 'PTHR14380', NULL, NULL, NULL, NULL, 'PLACENTA-SPECIFIC PROTEIN 1', 249647),
(396180, 'PTHR14380:SF2', NULL, NULL, NULL, NULL, 'PLACENTA-SPECIFIC PROTEIN 1', 249647),
(396181, 'PTHR14380:SF3', NULL, NULL, NULL, NULL, 'OOCYTE-SECRETED PROTEIN 1 HOMOLOG-RELATED', 249647),
(396182, 'PTHR14380:SF7', NULL, NULL, NULL, NULL, 'OOCYTE-SECRETED PROTEIN 2', 249647),
(396183, 'PTHR14380:SF8', NULL, NULL, NULL, NULL, 'OOCYTE-SECRETED PROTEIN 3', 249647),
(396184, 'PTHR14380:SF9', NULL, NULL, NULL, NULL, 'OOCYTE-SECRETED PROTEIN 4B', 249647),
(396185, 'PTHR10593:SF181', NULL, NULL, NULL, NULL, 'PROTEIN INDETERMINATE-DOMAIN 2-LIKE ISOFORM X1', 249648),
(396186, 'PTHR10593:SF214', NULL, NULL, NULL, NULL, 'PROTEIN INDETERMINATE-DOMAIN 5, CHLOROPLASTIC', 249648),
(396187, 'PTHR10593:SF179', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 249648),
(396188, 'PTHR10593:SF136', NULL, NULL, NULL, NULL, 'PROTEIN INDETERMINATE-DOMAIN 12', 249648),
(396189, 'PTHR10593:SF218', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 249648),
(396190, 'PTHR10593:SF219', NULL, NULL, NULL, NULL, 'PROTEIN INDETERMINATE-DOMAIN 9-LIKE ISOFORM X1', 249648),
(396191, 'PTHR10593:SF173', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 249648),
(396192, 'PTHR10593:SF130', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 249648),
(396193, 'PTHR10593:SF174', NULL, NULL, NULL, NULL, 'PROTEIN EARLY HEADING DATE 2', 249648),
(396194, 'PTHR10593:SF172', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 249648),
(396195, 'PTHR10593:SF210', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 249648),
(396196, 'PTHR10593:SF177', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 249648),
(396197, 'PTHR10593:SF134', NULL, NULL, NULL, NULL, 'OS01G0572300 PROTEIN', 249648),
(396198, 'PTHR10593:SF178', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN NUTCRACKER', 249648),
(396199, 'PTHR10593:SF211', NULL, NULL, NULL, NULL, 'C2H2-TYPE ZINC FINGER PROTEIN', 249648),
(396200, 'PTHR10593:SF131', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 567-LIKE', 249648),
(396201, 'PTHR10593:SF175', NULL, NULL, NULL, NULL, 'PROTEIN INDETERMINATE-DOMAIN 6, CHLOROPLASTIC', 249648),
(396202, 'PTHR10593:SF176', NULL, NULL, NULL, NULL, 'OS03G0237250 PROTEIN', 249648),
(396203, 'PTHR10593:SF170', NULL, NULL, NULL, NULL, 'PROTEIN INDETERMINATE-DOMAIN 11', 249648),
(396204, 'PTHR10593:SF209', NULL, NULL, NULL, NULL, 'ZINC FINGER C2H2-TYPE/INTEGRASE DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 249648),
(396205, 'PTHR10593:SF126', NULL, NULL, NULL, NULL, 'PROTEIN INDETERMINATE-DOMAIN 14', 249648),
(396206, 'PTHR10593:SF127', NULL, NULL, NULL, NULL, 'OS04G0566400 PROTEIN', 249648),
(396207, 'PTHR10593:SF168', NULL, NULL, NULL, NULL, 'PROTEIN SHOOT GRAVITROPISM 5', 249648),
(396208, 'PTHR10593:SF206', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 249648),
(396209, 'PTHR10593:SF162', NULL, NULL, NULL, NULL, 'ZINC FINGER, C2H2 TYPE FAMILY PROTEIN', 249648);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(396210, 'PTHR10593:SF163', NULL, NULL, NULL, NULL, 'ZINC FINGER C2H2-TYPE/INTEGRASE DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 249648),
(396211, 'PTHR10593:SF161', NULL, NULL, NULL, NULL, 'PROTEIN INDETERMINATE-DOMAIN 5, CHLOROPLASTIC-LIKE', 249648),
(396212, 'PTHR10593:SF29', NULL, NULL, NULL, NULL, 'PROTEIN INDETERMINATE-DOMAIN 11', 249648),
(396213, 'PTHR10593:SF122', NULL, NULL, NULL, NULL, 'OS02G0518500 PROTEIN', 249648),
(396214, 'PTHR10593:SF167', NULL, NULL, NULL, NULL, 'F-BOX ASSOCIATED PROTEIN', 249648),
(396215, 'PTHR10593:SF165', NULL, NULL, NULL, NULL, 'PROTEIN INDETERMINATE-DOMAIN 9-LIKE', 249648),
(396216, 'PTHR10593:SF10', NULL, NULL, NULL, NULL, 'PROTEIN INDETERMINATE-DOMAIN 16', 249648),
(396217, 'PTHR10593:SF236', NULL, NULL, NULL, NULL, 'PROTEIN INDETERMINATE-DOMAIN 7', 249648),
(396218, 'PTHR10593:SF116', NULL, NULL, NULL, NULL, 'INDETERMINATE DOMAIN P10', 249648),
(396219, 'PTHR10593:SF237', NULL, NULL, NULL, NULL, 'PROTEIN INDETERMINATE-DOMAIN 13-RELATED', 249648),
(396220, 'PTHR10593:SF113', NULL, NULL, NULL, NULL, 'OS09G0555700 PROTEIN', 249648),
(396221, 'PTHR10593:SF234', NULL, NULL, NULL, NULL, 'PROTEIN INDETERMINATE-DOMAIN 2-LIKE', 249648),
(396222, 'PTHR10593:SF235', NULL, NULL, NULL, NULL, 'BNAA02G22520D PROTEIN', 249648),
(396223, 'PTHR10593:SF114', NULL, NULL, NULL, NULL, 'PROTEIN INDETERMINATE-DOMAIN 5 CHLOROPLASTIC', 249648),
(396224, 'PTHR10593:SF158', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 249648),
(396225, 'PTHR10593:SF195', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 249648),
(396226, 'PTHR10593:SF151', NULL, NULL, NULL, NULL, 'OS01G0935000 PROTEIN', 249648),
(396227, 'PTHR10593:SF150', NULL, NULL, NULL, NULL, 'ZINC FINGER, C2H2-LIKE, ZINC FINGER, DOUBLE-STRANDED RNA BINDING PROTEIN-RELATED', 249648),
(396228, 'PTHR10593:SF232', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 249648),
(396229, 'PTHR10593:SF156', NULL, NULL, NULL, NULL, 'ZINC FINGER C2H2-TYPE/INTEGRASE DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 249648),
(396230, 'PTHR10593:SF233', NULL, NULL, NULL, NULL, 'PROTEIN INDETERMINATE-DOMAIN 2-LIKE', 249648),
(396231, 'PTHR10593:SF153', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 249648),
(396232, 'PTHR10593:SF230', NULL, NULL, NULL, NULL, 'DNA BINDING PROTEIN, MRNA', 249648),
(396233, 'PTHR10593:SF231', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 249648),
(396234, 'PTHR10593:SF192', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 249648),
(396235, 'PTHR10593:SF190', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 249648),
(396236, 'PTHR10593:SF225', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN GAI-ASSOCIATED FACTOR 1-LIKE ISOFORM X1', 249648),
(396237, 'PTHR10593:SF148', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN MAGPIE', 249648),
(396238, 'PTHR10593:SF226', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN GAI-ASSOCIATED FACTOR 1', 249648),
(396239, 'PTHR10593:SF223', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 249648),
(396240, 'PTHR10593:SF224', NULL, NULL, NULL, NULL, '', 249648),
(396241, 'PTHR10593:SF229', NULL, NULL, NULL, NULL, '', 249648),
(396242, 'PTHR10593:SF227', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN JACKDAW-LIKE ISOFORM X1', 249648),
(396243, 'PTHR10593:SF228', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN BALDIBIS', 249648),
(396244, 'PTHR10593:SF185', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 249648),
(396245, 'PTHR10593:SF183', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 249648),
(396246, 'PTHR10593:SF221', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 249648),
(396247, 'PTHR10593:SF188', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ENHYDROUS', 249648),
(396248, 'PTHR10593:SF222', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 249648),
(396249, 'PTHR10593', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE RIO', 249648),
(396250, 'PTHR10593:SF142', NULL, NULL, NULL, NULL, 'PROTEIN INDETERMINATE-DOMAIN 4, CHLOROPLASTIC', 249648);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(396251, 'PTHR10593:SF187', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 249648),
(396252, 'PTHR46819:SF1', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING DOMAIN-CONTAINING PROTEIN 7', 249649),
(396253, 'PTHR46819', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING DOMAIN-CONTAINING PROTEIN 7', 249649),
(396254, 'PTHR47962:SF4', NULL, NULL, NULL, NULL, 'HELICASE', 249650),
(396255, 'PTHR47962:SF3', NULL, NULL, NULL, NULL, 'LARGE ATP-DEPENDENT HELICASE-RELATED PROTEIN', 249650),
(396256, 'PTHR47962:SF6', NULL, NULL, NULL, NULL, 'LARGE HELICASE-RELATED PROTEIN', 249650),
(396257, 'PTHR47962:SF5', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT HELICASE LHR-RELATED', 249650),
(396258, 'PTHR47962', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT HELICASE LHR-RELATED-RELATED', 249650),
(396259, 'PTHR47962:SF7', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ATP-DEPENDENT HELICASE IRC3-RELATED', 249650),
(396260, 'PTHR15469', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE B15 SUBUNIT', 249651),
(396261, 'PTHR15469:SF0', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 BETA SUBCOMPLEX SUBUNIT 4', 249651),
(396262, 'PTHR15469:SF1', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 BETA SUBCOMPLEX SUBUNIT 4', 249651),
(396263, 'PTHR15469:SF2', NULL, NULL, NULL, NULL, 'COMPLEX I-B15', 249651),
(396264, 'PTHR43768:SF19', NULL, NULL, NULL, NULL, 'TREHALOSE-PHOSPHATE PHOSPHATASE 6-RELATED', 249652),
(396265, 'PTHR43768:SF34', NULL, NULL, NULL, NULL, 'TREHALOSE 6-PHOSPHATE PHOSPHATASE RA3', 249652),
(396266, 'PTHR43768:SF35', NULL, NULL, NULL, NULL, 'TREHALOSE-PHOSPHATE PHOSPHATASE 5-RELATED', 249652),
(396267, 'PTHR43768:SF10', NULL, NULL, NULL, NULL, 'TREHALOSE-PHOSPHATE PHOSPHATASE 8-RELATED', 249652),
(396268, 'PTHR43768:SF32', NULL, NULL, NULL, NULL, 'TREHALOSE-PHOSPHATE PHOSPHATASE C-RELATED', 249652),
(396269, 'PTHR43768:SF38', NULL, NULL, NULL, NULL, 'TREHALOSE 6-PHOSPHATE PHOSPHATASE', 249652),
(396270, 'PTHR43768:SF39', NULL, NULL, NULL, NULL, 'TREHALOSE 6-PHOSPHATE PHOSPHATASE', 249652),
(396271, 'PTHR43768:SF17', NULL, NULL, NULL, NULL, 'TREHALOSE-PHOSPHATE PHOSPHATASE F-RELATED', 249652),
(396272, 'PTHR43768:SF36', NULL, NULL, NULL, NULL, 'TREHALOSE-PHOSPHATE PHOSPHATASE 9-RELATED', 249652),
(396273, 'PTHR43768:SF37', NULL, NULL, NULL, NULL, 'TREHALOSE 6-PHOSPHATE PHOSPHATASE', 249652),
(396274, 'PTHR43768:SF40', NULL, NULL, NULL, NULL, 'TREHALOSE 6-PHOSPHATE PHOSPHATASE', 249652),
(396275, 'PTHR43768:SF29', NULL, NULL, NULL, NULL, 'TREHALOSE-PHOSPHATE PHOSPHATASE H-RELATED', 249652),
(396276, 'PTHR43768', NULL, NULL, NULL, NULL, 'TREHALOSE 6-PHOSPHATE PHOSPHATASE', 249652),
(396277, 'PTHR43768:SF23', NULL, NULL, NULL, NULL, 'TREHALOSE-PHOSPHATE PHOSPHATASE 1-RELATED', 249652),
(396278, 'PTHR43768:SF24', NULL, NULL, NULL, NULL, 'TREHALOSE 6-PHOSPHATE PHOSPHATASE', 249652),
(396279, 'PTHR43768:SF44', NULL, NULL, NULL, NULL, 'TREHALOSE-PHOSPHATE PHOSPHATASE J-RELATED', 249652),
(396280, 'PTHR43768:SF49', NULL, NULL, NULL, NULL, 'TREHALOSE 6-PHOSPHATE PHOSPHATASE', 249652),
(396281, 'PTHR43768:SF27', NULL, NULL, NULL, NULL, 'TREHALOSE-PHOSPHATE PHOSPHATASE A', 249652),
(396282, 'PTHR43768:SF28', NULL, NULL, NULL, NULL, 'TREHALOSE 6-PHOSPHATE PHOSPHATASE', 249652),
(396283, 'PTHR43768:SF47', NULL, NULL, NULL, NULL, 'TREHALOSE-PHOSPHATE PHOSPHATASE 2-RELATED', 249652),
(396284, 'PTHR43768:SF26', NULL, NULL, NULL, NULL, 'TREHALOSE 6-PHOSPHATE PHOSPHATASE', 249652),
(396285, 'PTHR43768:SF48', NULL, NULL, NULL, NULL, 'TREHALOSE 6-PHOSPHATE PHOSPHATASE', 249652),
(396286, 'PTHR43768:SF7', NULL, NULL, NULL, NULL, 'TREHALOSE-PHOSPHATE PHOSPHATASE 3-RELATED', 249652),
(396287, 'PTHR43768:SF30', NULL, NULL, NULL, NULL, 'TREHALOSE 6-PHOSPHATE PHOSPHATASE', 249652),
(396288, 'PTHR43768:SF52', NULL, NULL, NULL, NULL, 'TREHALOSE-PHOSPHATE PHOSPHATASE B', 249652),
(396289, 'PTHR43768:SF53', NULL, NULL, NULL, NULL, 'TREHALOSE 6-PHOSPHATE PHOSPHATASE', 249652),
(396290, 'PTHR43768:SF50', NULL, NULL, NULL, NULL, 'TREHALOSE-PHOSPHATE PHOSPHATASE I-RELATED', 249652),
(396291, 'PTHR43768:SF3', NULL, NULL, NULL, NULL, 'TREHALOSE 6-PHOSPHATE PHOSPHATASE', 249652);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(396292, 'PTHR43768:SF51', NULL, NULL, NULL, NULL, 'TREHALOSE 6-PHOSPHATE PHOSPHATASE', 249652),
(396293, 'PTHR24222:SF60', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 9', 249653),
(396294, 'PTHR24222:SF61', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 9', 249653),
(396295, 'PTHR24222:SF62', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 2', 249653),
(396296, 'PTHR24222:SF63', NULL, NULL, NULL, NULL, 'ATP BINDING CASSETTE SUBFAMILY B', 249653),
(396297, 'PTHR24222:SF64', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 26, CHLOROPLASTIC', 249653),
(396298, 'PTHR24222:SF65', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 9', 249653),
(396299, 'PTHR24222:SF66', NULL, NULL, NULL, NULL, 'COMPOSITE ABC TRANSPORTER, ATP-BINDING/PERMEASE PROTEIN', 249653),
(396300, 'PTHR24222:SF45', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, ATP-BINDING TRANSMEMBRANE PROTEIN', 249653),
(396301, 'PTHR24222:SF48', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 15', 249653),
(396302, 'PTHR24222:SF70', NULL, NULL, NULL, NULL, 'BRACHYTIC2', 249653),
(396303, 'PTHR24222:SF71', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING/PERMEASE PROTEIN HI_0664-RELATED', 249653),
(396304, 'PTHR24222:SF72', NULL, NULL, NULL, NULL, 'RESISTANCE PROTEIN 1, 2, PUTATIVE-RELATED', 249653),
(396305, 'PTHR24222:SF50', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 9-LIKE ISOFORM X2', 249653),
(396306, 'PTHR24222:SF73', NULL, NULL, NULL, NULL, 'MYCOBACTIN IMPORT ATP-BINDING/PERMEASE PROTEIN IRTA', 249653),
(396307, 'PTHR24222:SF30', NULL, NULL, NULL, NULL, 'ATP-BINDING/PERMEASE PROTEIN CYDC', 249653),
(396308, 'PTHR24222:SF52', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 20-RELATED', 249653),
(396309, 'PTHR24222:SF74', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT LIPID A-CORE FLIPPASE', 249653),
(396310, 'PTHR24222:SF53', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 15', 249653),
(396311, 'PTHR24222:SF75', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 9', 249653),
(396312, 'PTHR24222:SF54', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY MEMBER 13-LIKE', 249653),
(396313, 'PTHR24222:SF76', NULL, NULL, NULL, NULL, 'MYCOBACTIN IMPORT ATP-BINDING/PERMEASE PROTEIN IRTB', 249653),
(396314, 'PTHR24222:SF77', NULL, NULL, NULL, NULL, 'NHPM BACTERIOCIN SYSTEM ABC TRANSPORTER, PEPTIDASE/ATP-BINDING PROTEIN-RELATED', 249653),
(396315, 'PTHR24222:SF78', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, ATP-BINDING/PERMEASE PROTEIN-RELATED', 249653),
(396316, 'PTHR24222:SF56', NULL, NULL, NULL, NULL, 'ATP-BINDING ABC TRANSPORTER', 249653),
(396317, 'PTHR24222:SF79', NULL, NULL, NULL, NULL, 'ATP BINDING CASSETTE SUBFAMILY B', 249653),
(396318, 'PTHR24222:SF57', NULL, NULL, NULL, NULL, 'ABC TRANSMEMBRANE TYPE-1 DOMAIN-CONTAINING PROTEIN', 249653),
(396319, 'PTHR24222', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY', 249653),
(396320, 'PTHR24222:SF0', NULL, NULL, NULL, NULL, 'ALKALINE PROTEASE SECRETION ATP-BINDING PROTEIN APRD', 249653),
(396321, 'PTHR15001', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 123-RELATED', 249654),
(396322, 'PTHR15001:SF8', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 121', 249654),
(396323, 'PTHR15001:SF9', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 115', 249654),
(396324, 'PTHR15001:SF7', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 118', 249654),
(396325, 'PTHR15001:SF13', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 125', 249654),
(396326, 'PTHR15001:SF12', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 125', 249654),
(396327, 'PTHR15001:SF11', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN', 249654),
(396328, 'PTHR15001:SF5', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN', 249654),
(396329, 'PTHR15001:SF10', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 135', 249654),
(396330, 'PTHR15001:SF3', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 123', 249654),
(396331, 'PTHR24040', NULL, NULL, NULL, NULL, 'LAMININ G-LIKE DOMAIN-CONTAINING PROTEIN', 249655),
(396332, 'PTHR24040:SF7', NULL, NULL, NULL, NULL, 'FIBRILLIN 3', 249655),
(396333, 'PTHR24040:SF10', NULL, NULL, NULL, NULL, 'VITAMIN K-DEPENDENT PROTEIN S', 249655);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(396334, 'PTHR24040:SF8', NULL, NULL, NULL, NULL, 'FIBRILLIN 1', 249655),
(396335, 'PTHR24040:SF12', NULL, NULL, NULL, NULL, 'VITAMIN K-DEPENDENT PROTEIN S-LIKE', 249655),
(396336, 'PTHR24040:SF13', NULL, NULL, NULL, NULL, 'FIBROPELLIN-1', 249655),
(396337, 'PTHR24040:SF14', NULL, NULL, NULL, NULL, 'GROWTH ARREST-SPECIFIC PROTEIN 6', 249655),
(396338, 'PTHR24040:SF3', NULL, NULL, NULL, NULL, 'SEX HORMONE-BINDING GLOBULIN', 249655),
(396339, 'PTHR24040:SF0', NULL, NULL, NULL, NULL, 'VITAMIN K-DEPENDENT PROTEIN S', 249655),
(396340, 'PTHR41324:SF1', NULL, NULL, NULL, NULL, 'IG HYPOTHETICAL 15508', 249656),
(396341, 'PTHR41324', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 249656),
(396342, 'PTHR13285:SF19', NULL, NULL, NULL, NULL, 'PROTEIN-CYSTEINE N-PALMITOYLTRANSFERASE HHAT-LIKE PROTEIN', 249657),
(396343, 'PTHR13285', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE', 249657),
(396344, 'PTHR13285:SF18', NULL, NULL, NULL, NULL, 'PROTEIN-CYSTEINE N-PALMITOYLTRANSFERASE RASP', 249657),
(396345, 'PTHR13285:SF22', NULL, NULL, NULL, NULL, 'HOMOLOG OF HEDGEHOG ACYLTRANSFERASE', 249657),
(396346, 'PTHR13285:SF23', NULL, NULL, NULL, NULL, 'TEICHOIC ACID D-ALANYLTRANSFERASE', 249657),
(396347, 'PTHR13285:SF20', NULL, NULL, NULL, NULL, 'PROTEIN-CYSTEINE N-PALMITOYLTRANSFERASE HHAT', 249657),
(396348, 'PTHR13285:SF21', NULL, NULL, NULL, NULL, 'HEDGEHOG ACYLTRANSFERASE-LIKE, B', 249657),
(396349, 'PTHR47219', NULL, NULL, NULL, NULL, 'RAB GTPASE-ACTIVATING PROTEIN 1-LIKE', 249658),
(396350, 'PTHR47219:SF9', NULL, NULL, NULL, NULL, 'GTPASE ACTIVATING PROTEIN', 249658),
(396351, 'PTHR47219:SF8', NULL, NULL, NULL, NULL, 'GTPASE ACTIVATING PROTEIN AND CENTROSOME-ASSOCIATED, ISOFORM B', 249658),
(396352, 'PTHR47219:SF7', NULL, NULL, NULL, NULL, 'RAB GTPASE-ACTIVATING PROTEIN 1-LIKE', 249658),
(396353, 'PTHR47219:SF6', NULL, NULL, NULL, NULL, 'RAB GTPASE-ACTIVATING PROTEIN 1', 249658),
(396354, 'PTHR47219:SF5', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 1', 249658),
(396355, 'PTHR47219:SF4', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 10B', 249658),
(396356, 'PTHR38926:SF51', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249659),
(396357, 'PTHR38926:SF50', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 23-RELATED', 249659),
(396358, 'PTHR38926:SF71', NULL, NULL, NULL, NULL, 'OS08G0194350 PROTEIN', 249659),
(396359, 'PTHR38926:SF70', NULL, NULL, NULL, NULL, 'OS08G0193600 PROTEIN', 249659),
(396360, 'PTHR38926:SF2', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 21-RELATED', 249659),
(396361, 'PTHR38926:SF5', NULL, NULL, NULL, NULL, 'IM:7136021-RELATED', 249659),
(396362, 'PTHR38926:SF26', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249659),
(396363, 'PTHR38926:SF69', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249659),
(396364, 'PTHR38926:SF68', NULL, NULL, NULL, NULL, '', 249659),
(396365, 'PTHR38926:SF46', NULL, NULL, NULL, NULL, 'OS08G0195000 PROTEIN', 249659),
(396366, 'PTHR38926:SF67', NULL, NULL, NULL, NULL, 'RNI-LIKE SUPERFAMILY PROTEIN-RELATED', 249659),
(396367, 'PTHR38926:SF45', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249659),
(396368, 'PTHR38926:SF66', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249659),
(396369, 'PTHR38926:SF43', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249659),
(396370, 'PTHR38926:SF65', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 249659),
(396371, 'PTHR38926:SF64', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249659),
(396372, 'PTHR38926:SF42', NULL, NULL, NULL, NULL, 'BNAA09G10910D PROTEIN', 249659),
(396373, 'PTHR38926:SF63', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249659),
(396374, 'PTHR38926:SF29', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SKIP19', 249659),
(396375, 'PTHR38926:SF28', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SKIP19', 249659),
(396376, 'PTHR38926:SF27', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249659),
(396377, 'PTHR38926:SF49', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249659);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(396378, 'PTHR38926:SF40', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249659),
(396379, 'PTHR38926:SF62', NULL, NULL, NULL, NULL, 'F-BOX AND LEUCINE-RICH REPEAT PROTEIN 6', 249659),
(396380, 'PTHR38926:SF61', NULL, NULL, NULL, NULL, 'LD20162P', 249659),
(396381, 'PTHR38926:SF60', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249659),
(396382, 'PTHR38926:SF59', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 22-RELATED', 249659),
(396383, 'PTHR38926:SF37', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249659),
(396384, 'PTHR38926:SF36', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 23-RELATED', 249659),
(396385, 'PTHR38926:SF14', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 23-RELATED', 249659),
(396386, 'PTHR38926:SF58', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249659),
(396387, 'PTHR38926:SF13', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', 249659),
(396388, 'PTHR38926:SF35', NULL, NULL, NULL, NULL, 'BNAA04G14150D PROTEIN', 249659),
(396389, 'PTHR38926:SF57', NULL, NULL, NULL, NULL, 'F-BOX FAMILY PROTEIN', 249659),
(396390, 'PTHR38926:SF34', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249659),
(396391, 'PTHR38926:SF12', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', 249659),
(396392, 'PTHR38926:SF33', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249659),
(396393, 'PTHR38926:SF10', NULL, NULL, NULL, NULL, 'F-BOX/LRR PLANT PROTEIN', 249659),
(396394, 'PTHR38926:SF32', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249659),
(396395, 'PTHR38926:SF31', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249659),
(396396, 'PTHR38926', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', 249659),
(396397, 'PTHR38926:SF30', NULL, NULL, NULL, NULL, 'F-BOX FAMILY PROTEIN', 249659),
(396398, 'PTHR38926:SF52', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 249659),
(396399, 'PTHR38926:SF38', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 249659),
(396400, 'PTHR21513:SF24', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', 249660),
(396401, 'PTHR21513', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', 249660),
(396402, 'PTHR21513:SF2', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', 249660),
(396403, 'PTHR21513:SF26', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', 249660),
(396404, 'PTHR21513:SF25', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', 249660),
(396405, 'PTHR21513:SF20', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', 249660),
(396406, 'PTHR21513:SF28', NULL, NULL, NULL, NULL, 'CALPONIN-HOMOLOGY (CH) DOMAIN-CONTAINING PROTEIN', 249660),
(396407, 'PTHR21513:SF27', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', 249660),
(396408, 'PTHR21513:SF19', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', 249660),
(396409, 'PTHR35506', NULL, NULL, NULL, NULL, 'OS02G0135600 PROTEIN', 249661),
(396410, 'PTHR35506:SF1', NULL, NULL, NULL, NULL, 'OS02G0135600 PROTEIN', 249661),
(396411, 'PTHR42076', NULL, NULL, NULL, NULL, 'CYANOVIRIN-N HOMOLOG', 249662),
(396412, 'PTHR42076:SF1', NULL, NULL, NULL, NULL, 'CVNH DOMAIN-CONTAINING PROTEIN', 249662),
(396413, 'PTHR36436:SF6', NULL, NULL, NULL, NULL, 'WGR DOMAIN-CONTAINING PROTEIN', 249663),
(396414, 'PTHR36436:SF3', NULL, NULL, NULL, NULL, 'SLL5081 PROTEIN', 249663),
(396415, 'PTHR36436', NULL, NULL, NULL, NULL, 'SLL5081 PROTEIN', 249663),
(396416, 'PTHR35333', NULL, NULL, NULL, NULL, 'BETA-LACTAMASE', 249664),
(396417, 'PTHR35333:SF3', NULL, NULL, NULL, NULL, 'D-ALANYL-D-ALANINE ENDOPEPTIDASE', 249664),
(396418, 'PTHR35333:SF4', NULL, NULL, NULL, NULL, 'SLR0121 PROTEIN', 249664),
(396419, 'PTHR46274', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL PHOSPHATASE', 249665),
(396420, 'PTHR46274:SF15', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE PHOSPHATASE MITOCHONDRIAL 1, MITOCHONDRIAL', 249665),
(396421, 'PTHR46274:SF20', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE DSP8-RELATED', 249665),
(396422, 'PTHR46274:SF21', NULL, NULL, NULL, NULL, 'BNAA04G20710D PROTEIN', 249665); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(396423, 'PTHR46274:SF11', NULL, NULL, NULL, NULL, 'OS05G0524200 PROTEIN', 249665),
(396424, 'PTHR46274:SF7', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PHOSPHATASE, CATALYTIC DOMAIN CONTAINING PROTEIN, EXPRESSED', 249665),
(396425, 'PTHR46274:SF6', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL PHOSPHATASE', 249665),
(396426, 'PTHR46274:SF9', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLGLYCEROPHOSPHATE PHOSPHATASE PTPMT1', 249665),
(396427, 'PTHR13275:SF4', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 72 HOMOLOG', 249666),
(396428, 'PTHR13275', NULL, NULL, NULL, NULL, 'YL-1 PROTEIN  TRANSCRIPTION FACTOR-LIKE 1', 249666),
(396429, 'PTHR48123', NULL, NULL, NULL, NULL, 'ARL2_BIND_BART DOMAIN-CONTAINING PROTEIN', 249667),
(396430, 'PTHR48123:SF1', NULL, NULL, NULL, NULL, '', 249667),
(396431, 'PTHR37736', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN', 249668),
(396432, 'PTHR37736:SF4', NULL, NULL, NULL, NULL, '', 249668),
(396433, 'PTHR37736:SF1', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN', 249668),
(396434, 'PTHR37736:SF2', NULL, NULL, NULL, NULL, 'BNAA09G20500D PROTEIN', 249668),
(396435, 'PTHR13526:SF16', NULL, NULL, NULL, NULL, '', 249669),
(396436, 'PTHR13526:SF18', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SPT20 HOMOLOG', 249669),
(396437, 'PTHR13526:SF17', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SPT20 HOMOLOG-LIKE 1', 249669),
(396438, 'PTHR13526:SF3', NULL, NULL, NULL, NULL, 'SPT20 HOMOLOG, SAGA COMPLEX COMPONENT', 249669),
(396439, 'PTHR13526', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SPT20 HOMOLOG', 249669),
(396440, 'PTHR13526:SF20', NULL, NULL, NULL, NULL, 'OS01G0117800 PROTEIN', 249669),
(396441, 'PTHR13526:SF23', NULL, NULL, NULL, NULL, 'PROTEIN PHYTOCHROME-DEPENDENT LATE-FLOWERING-LIKE', 249669),
(396442, 'PTHR13526:SF25', NULL, NULL, NULL, NULL, '', 249669),
(396443, 'PTHR13526:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SPT20 HOMOLOG', 249669),
(396444, 'PTHR13526:SF24', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SPT20 HOMOLOG-LIKE 2-RELATED', 249669),
(396445, 'PTHR46106:SF1', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE TYROSINE-PROTEIN PHOSPHATASE-LIKE N', 249670),
(396446, 'PTHR46106:SF5', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE TYROSINE-PROTEIN PHOSPHATASE N2', 249670),
(396447, 'PTHR46106:SF4', NULL, NULL, NULL, NULL, 'IA-2 PROTEIN TYROSINE PHOSPHATASE, ISOFORM C', 249670),
(396448, 'PTHR46106', NULL, NULL, NULL, NULL, 'IA-2 PROTEIN TYROSINE PHOSPHATASE, ISOFORM C', 249670),
(396449, 'PTHR31815:SF0', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 200A', 249671),
(396450, 'PTHR31815:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 200C', 249671),
(396451, 'PTHR31815:SF1', NULL, NULL, NULL, NULL, 'AGAP005329-PA', 249671),
(396452, 'PTHR31815:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 200B', 249671),
(396453, 'PTHR31815', NULL, NULL, NULL, NULL, 'AGAP005329-PA', 249671),
(396454, 'PTHR23140:SF11', NULL, NULL, NULL, NULL, 'PROTEIN RRC1-LIKE ISOFORM X1', 249672),
(396455, 'PTHR23140:SF7', NULL, NULL, NULL, NULL, '', 249672),
(396456, 'PTHR23140:SF10', NULL, NULL, NULL, NULL, 'U2 SNRNP-ASSOCIATED SURP DOMAIN-CONTAINING', 249672),
(396457, 'PTHR23140', NULL, NULL, NULL, NULL, 'RNA PROCESSING PROTEIN LD23810P', 249672),
(396458, 'PTHR23140:SF2', NULL, NULL, NULL, NULL, '', 249672),
(396459, 'PTHR23140:SF1', NULL, NULL, NULL, NULL, 'SR-RELATED CTD ASSOCIATED FACTOR 8', 249672),
(396460, 'PTHR23140:SF0', NULL, NULL, NULL, NULL, 'U2 SNRNP-ASSOCIATED SURP MOTIF-CONTAINING PROTEIN', 249672),
(396461, 'PTHR23140:SF5', NULL, NULL, NULL, NULL, 'ZGC:163098', 249672),
(396462, 'PTHR23140:SF12', NULL, NULL, NULL, NULL, 'CLE-1', 249672),
(396463, 'PTHR23140:SF4', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 16', 249672),
(396464, 'PTHR23140:SF3', NULL, NULL, NULL, NULL, 'SR-RELATED AND CTD-ASSOCIATED FACTOR 4', 249672),
(396465, 'PTHR39221:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 7 OPEN READING FRAME 61', 249673),
(396466, 'PTHR39221', NULL, NULL, NULL, NULL, 'CHROMOSOME 7 OPEN READING FRAME 61', 249673),
(396467, 'PTHR24145:SF3', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 11', 249674); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(396468, 'PTHR24145', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 11', 249674),
(396469, 'PTHR15443:SF6', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 249675),
(396470, 'PTHR15443:SF4', NULL, NULL, NULL, NULL, 'ZONA PELLUCIDA-BINDING PROTEIN 2', 249675),
(396471, 'PTHR15443:SF5', NULL, NULL, NULL, NULL, 'ZONA PELLUCIDA-BINDING PROTEIN 1', 249675),
(396472, 'PTHR15443', NULL, NULL, NULL, NULL, 'ZONA PELLUCIDA BINDING PROTEIN  SP38', 249675),
(396473, 'PTHR14995:SF2', NULL, NULL, NULL, NULL, 'PROTEIN AMNIONLESS', 249676),
(396474, 'PTHR14995', NULL, NULL, NULL, NULL, 'AMNIONLESS', 249676),
(396475, 'PTHR21104:SF1', NULL, NULL, NULL, NULL, 'DUF4808 DOMAIN-CONTAINING PROTEIN', 249677),
(396476, 'PTHR21104:SF2', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE-III DOMAIN-CONTAINING PROTEIN', 249677),
(396477, 'PTHR21104', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 249677),
(396478, 'PTHR37542', NULL, NULL, NULL, NULL, 'HELO DOMAIN-CONTAINING PROTEIN-RELATED', 249678),
(396479, 'PTHR37542:SF2', NULL, NULL, NULL, NULL, 'HELO DOMAIN-CONTAINING PROTEIN', 249678),
(396480, 'PTHR37542:SF1', NULL, NULL, NULL, NULL, 'HELO DOMAIN-CONTAINING PROTEIN', 249678),
(396481, 'PTHR45847:SF6', NULL, NULL, NULL, NULL, 'FATTY ACID AMIDE HYDROLASE', 249679),
(396482, 'PTHR45847:SF8', NULL, NULL, NULL, NULL, 'AMIDASE DOMAIN-CONTAINING PROTEIN-RELATED', 249679),
(396483, 'PTHR45847:SF11', NULL, NULL, NULL, NULL, 'AMIDASE DOMAIN-CONTAINING PROTEIN', 249679),
(396484, 'PTHR45847:SF7', NULL, NULL, NULL, NULL, 'AMIDASE DOMAIN-CONTAINING PROTEIN', 249679),
(396485, 'PTHR45847:SF10', NULL, NULL, NULL, NULL, 'FATTY ACID AMIDE HYDROLASE 1', 249679),
(396486, 'PTHR45847:SF2', NULL, NULL, NULL, NULL, 'AMIDASE DOMAIN-CONTAINING PROTEIN', 249679),
(396487, 'PTHR45847', NULL, NULL, NULL, NULL, 'FATTY ACID AMIDE HYDROLASE', 249679),
(396488, 'PTHR45847:SF1', NULL, NULL, NULL, NULL, 'MONOGLYCERIDE LIPASE FAAH-4', 249679),
(396489, 'PTHR45847:SF3', NULL, NULL, NULL, NULL, 'FATTY-ACID AMIDE HYDROLASE 1', 249679),
(396490, 'PTHR37726', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 249680),
(396491, 'PTHR37726:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 249680),
(396492, 'PTHR37726:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249680),
(396493, 'PTHR28041:SF1', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN L25, MITOCHONDRIAL', 249681),
(396494, 'PTHR28041', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN L25, MITOCHONDRIAL', 249681),
(396495, 'PTHR24403:SF48', NULL, NULL, NULL, NULL, 'PR DOMAIN ZINC FINGER PROTEIN 10', 249682),
(396496, 'PTHR24403:SF69', NULL, NULL, NULL, NULL, 'ZINC FINGER Y-CHROMOSOMAL PROTEIN', 249682),
(396497, 'PTHR24403:SF63', NULL, NULL, NULL, NULL, 'SI:DKEY-154P10.3', 249682),
(396498, 'PTHR24403:SF62', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 827', 249682),
(396499, 'PTHR24403:SF60', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 407', 249682),
(396500, 'PTHR24403:SF82', NULL, NULL, NULL, NULL, 'ZINC FINGER-CONTAINING UBIQUITIN PEPTIDASE 1', 249682),
(396501, 'PTHR24403:SF67', NULL, NULL, NULL, NULL, 'ENHANCER OF VARIEGATION 3-9-RELATED', 249682),
(396502, 'PTHR24403:SF66', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 513', 249682),
(396503, 'PTHR24403:SF43', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 64', 249682),
(396504, 'PTHR24403:SF87', NULL, NULL, NULL, NULL, 'PEPTIDASE C78, UBIQUITIN MODIFIER-SPECIFIC PEPTIDASE 1/ 2-RELATED', 249682),
(396505, 'PTHR24403:SF86', NULL, NULL, NULL, NULL, 'SUPPRESSOR', 249682),
(396506, 'PTHR24403:SF59', NULL, NULL, NULL, NULL, 'POGO TRANSPOSABLE ELEMENT WITH ZNF DOMAIN', 249682),
(396507, 'PTHR24403:SF58', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 462', 249682),
(396508, 'PTHR24403:SF36', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 335', 249682),
(396509, 'PTHR24403:SF105', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', 249682),
(396510, 'PTHR24403:SF74', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 507', 249682),
(396511, 'PTHR24403:SF73', NULL, NULL, NULL, NULL, 'CCCTC-BINDING FACTOR', 249682),
(396512, 'PTHR24403:SF72', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 142', 249682);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(396513, 'PTHR24403:SF94', NULL, NULL, NULL, NULL, 'KUMGANG', 249682),
(396514, 'PTHR24403', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 249682),
(396515, 'PTHR24403:SF71', NULL, NULL, NULL, NULL, 'SI:CH211-113E8.10', 249682),
(396516, 'PTHR24403:SF56', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 646', 249682),
(396517, 'PTHR24403:SF99', NULL, NULL, NULL, NULL, 'LYS-63-SPECIFIC DEUBIQUITINASE ZUFSP', 249682),
(396518, 'PTHR24403:SF81', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 518A', 249682),
(396519, 'PTHR24403:SF103', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 451', 249682),
(396520, 'PTHR24403:SF104', NULL, NULL, NULL, NULL, 'LD40262P-RELATED', 249682),
(396521, 'PTHR24403:SF101', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 131', 249682),
(396522, 'PTHR24403:SF102', NULL, NULL, NULL, NULL, 'RE1-SILENCING TRANSCRIPTION FACTOR', 249682),
(396523, 'PTHR24403:SF100', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 249682),
(396524, 'PTHR37222:SF1', NULL, NULL, NULL, NULL, 'OS02G0718000 PROTEIN', 249683),
(396525, 'PTHR37222', NULL, NULL, NULL, NULL, 'OS02G0718000 PROTEIN', 249683),
(396526, 'PTHR48037:SF1', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 249684),
(396527, 'PTHR48037', NULL, NULL, NULL, NULL, 'ATPASE E1', 249684),
(396528, 'PTHR34455:SF6', NULL, NULL, NULL, NULL, 'ULTRAVIOLET-B-REPRESSIBLE PROTEIN', 249685),
(396529, 'PTHR34455:SF5', NULL, NULL, NULL, NULL, 'ULTRAVIOLET-B-REPRESSIBLE PROTEIN', 249685),
(396530, 'PTHR34455:SF1', NULL, NULL, NULL, NULL, 'OS07G0673550 PROTEIN', 249685),
(396531, 'PTHR34455:SF10', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249685),
(396532, 'PTHR34455:SF9', NULL, NULL, NULL, NULL, 'ULTRAVIOLET-B-REPRESSIBLE PROTEIN', 249685),
(396533, 'PTHR34455', NULL, NULL, NULL, NULL, 'OS07G0673550 PROTEIN', 249685),
(396534, 'PTHR34455:SF8', NULL, NULL, NULL, NULL, 'BNAA08G29910D PROTEIN', 249685),
(396535, 'PTHR35550:SF2', NULL, NULL, NULL, NULL, 'OS05G0401200 PROTEIN', 249686),
(396536, 'PTHR35550', NULL, NULL, NULL, NULL, '', 249686),
(396537, 'PTHR35295', NULL, NULL, NULL, NULL, 'DNA LIGASE-LIKE PROTEIN', 249687),
(396538, 'PTHR35295:SF2', NULL, NULL, NULL, NULL, 'OS07G0256300 PROTEIN', 249687),
(396539, 'PTHR35295:SF1', NULL, NULL, NULL, NULL, 'DNA LIGASE-LIKE PROTEIN', 249687),
(396540, 'PTHR35107:SF5', NULL, NULL, NULL, NULL, '', 249688),
(396541, 'PTHR35107', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249688),
(396542, 'PTHR35107:SF8', NULL, NULL, NULL, NULL, '', 249688),
(396543, 'PTHR35107:SF7', NULL, NULL, NULL, NULL, 'BNAC02G45580D PROTEIN', 249688),
(396544, 'PTHR35107:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249688),
(396545, 'PTHR35107:SF4', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249688),
(396546, 'PTHR41983', NULL, NULL, NULL, NULL, 'SHORT-CHAIN FATTY ACID TRANSPORTER-RELATED', 249689),
(396547, 'PTHR41983:SF2', NULL, NULL, NULL, NULL, 'SHORT-CHAIN FATTY ACID TRANSPORTER-RELATED', 249689),
(396548, 'PTHR44169:SF5', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 249690),
(396549, 'PTHR44169:SF6', NULL, NULL, NULL, NULL, 'NADPH-DEPENDENT 1-ACYLDIHYDROXYACETONE PHOSPHATE REDUCTASE', 249690),
(396550, 'PTHR44169:SF3', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE SRDE', 249690),
(396551, 'PTHR44169:SF12', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', 249690),
(396552, 'PTHR44169:SF14', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 249690),
(396553, 'PTHR44169:SF15', NULL, NULL, NULL, NULL, 'CHAIN DEHYDROGENASE/REDUCTASE (AYR1), PUTATIVE (AFU_ORTHOLOGUE AFUA_4G04530)-RELATED', 249690),
(396554, 'PTHR44169:SF11', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', 249690),
(396555, 'PTHR44169:SF9', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', 249690),
(396556, 'PTHR44169', NULL, NULL, NULL, NULL, 'NADPH-DEPENDENT 1-ACYLDIHYDROXYACETONE PHOSPHATE REDUCTASE', 249690),
(396557, 'PTHR24035:SF142', NULL, NULL, NULL, NULL, '', 249691),
(396558, 'PTHR24035:SF143', NULL, NULL, NULL, NULL, 'EGF_2 DOMAIN-CONTAINING PROTEIN', 249691);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(396559, 'PTHR24035:SF141', NULL, NULL, NULL, NULL, 'PROTEIN CBG18730', 249691),
(396560, 'PTHR24035:SF109', NULL, NULL, NULL, NULL, 'PROTEIN DRAPER', 249691),
(396561, 'PTHR24035:SF114', NULL, NULL, NULL, NULL, 'PLATELET ENDOTHELIAL AGGREGATION RECEPTOR 1', 249691),
(396562, 'PTHR24035:SF136', NULL, NULL, NULL, NULL, 'MULTIPLE EPIDERMAL GROWTH FACTOR-LIKE DOMAINS PROTEIN 10', 249691),
(396563, 'PTHR24035:SF137', NULL, NULL, NULL, NULL, 'MULTIPLE EPIDERMAL GROWTH FACTOR-LIKE DOMAINS PROTEIN 6', 249691),
(396564, 'PTHR24035', NULL, NULL, NULL, NULL, 'MULTIPLE EPIDERMAL GROWTH FACTOR-LIKE DOMAINS PROTEIN', 249691),
(396565, 'PTHR24035:SF138', NULL, NULL, NULL, NULL, 'MULTIPLE EPIDERMAL GROWTH FACTOR-LIKE DOMAINS PROTEIN 6', 249691),
(396566, 'PTHR24035:SF127', NULL, NULL, NULL, NULL, 'LAMININ SUBUNIT ALPHA-5-RELATED', 249691),
(396567, 'PTHR28039:SF8', NULL, NULL, NULL, NULL, 'CHALCONE--FLAVANONE ISOMERASE 1-RELATED', 249692),
(396568, 'PTHR28039:SF13', NULL, NULL, NULL, NULL, 'CHALCONE-FLAVONONE ISOMERASE FAMILY PROTEIN', 249692),
(396569, 'PTHR28039:SF12', NULL, NULL, NULL, NULL, 'CHALCONE-FLAVONONE ISOMERASE FAMILY PROTEIN', 249692),
(396570, 'PTHR28039:SF9', NULL, NULL, NULL, NULL, 'CHALCONE--FLAVANONE ISOMERASE 1B-1', 249692),
(396571, 'PTHR28039:SF11', NULL, NULL, NULL, NULL, 'CHALCONE-FLAVONONE ISOMERASE FAMILY PROTEIN', 249692),
(396572, 'PTHR28039', NULL, NULL, NULL, NULL, 'CHALCONE--FLAVONONE ISOMERASE 1-RELATED', 249692),
(396573, 'PTHR28039:SF10', NULL, NULL, NULL, NULL, 'CHALCONE--FLAVANONE ISOMERASE 1A', 249692),
(396574, 'PTHR24026:SF123', NULL, NULL, NULL, NULL, 'PROTOCADHERIN-23', 249693),
(396575, 'PTHR24026:SF122', NULL, NULL, NULL, NULL, '', 249693),
(396576, 'PTHR24026:SF125', NULL, NULL, NULL, NULL, 'FAT-LIKE CADHERIN-RELATED TUMOR SUPPRESSOR HOMOLOG', 249693),
(396577, 'PTHR24026:SF124', NULL, NULL, NULL, NULL, 'PROTOCADHERIN FAT 4', 249693),
(396578, 'PTHR24026:SF127', NULL, NULL, NULL, NULL, 'CADHERIN-RELATED HMR-1', 249693),
(396579, 'PTHR24026:SF126', NULL, NULL, NULL, NULL, 'CADHERIN-RELATED TUMOR SUPPRESSOR', 249693),
(396580, 'PTHR24026:SF42', NULL, NULL, NULL, NULL, 'PROTOCADHERIN FAT 1', 249693),
(396581, 'PTHR24026:SF129', NULL, NULL, NULL, NULL, 'CADHERIN-89D', 249693),
(396582, 'PTHR24026:SF106', NULL, NULL, NULL, NULL, 'CADHERIN 74A, ISOFORM A', 249693),
(396583, 'PTHR24026:SF128', NULL, NULL, NULL, NULL, 'PROTEIN DACHSOUS', 249693),
(396584, 'PTHR24026:SF88', NULL, NULL, NULL, NULL, 'CADHERIN FAMILY', 249693),
(396585, 'PTHR24026:SF121', NULL, NULL, NULL, NULL, 'CADHERIN RELATED FAMILY MEMBER 1', 249693),
(396586, 'PTHR24026:SF120', NULL, NULL, NULL, NULL, 'CADHERIN FAMILY', 249693),
(396587, 'PTHR24026:SF49', NULL, NULL, NULL, NULL, 'PROTOCADHERIN FAT 3', 249693),
(396588, 'PTHR24026', NULL, NULL, NULL, NULL, 'FAT ATYPICAL CADHERIN-RELATED', 249693),
(396589, 'PTHR24026:SF119', NULL, NULL, NULL, NULL, 'CADHERIN 23', 249693),
(396590, 'PTHR24026:SF93', NULL, NULL, NULL, NULL, 'CADHERIN-99C', 249693),
(396591, 'PTHR24026:SF113', NULL, NULL, NULL, NULL, '', 249693),
(396592, 'PTHR24026:SF51', NULL, NULL, NULL, NULL, 'PROTOCADHERIN-LIKE WING POLARITY PROTEIN STAN', 249693),
(396593, 'PTHR24026:SF118', NULL, NULL, NULL, NULL, 'DE-CADHERIN', 249693),
(396594, 'PTHR24026:SF75', NULL, NULL, NULL, NULL, 'CADHERIN-RELATED FAMILY MEMBER 2', 249693),
(396595, 'PTHR24026:SF96', NULL, NULL, NULL, NULL, 'CADHERIN-86C', 249693),
(396596, 'PTHR24026:SF32', NULL, NULL, NULL, NULL, 'CADHERIN EGF LAG SEVEN-PASS G-TYPE RECEPTOR 2', 249693),
(396597, 'PTHR24026:SF37', NULL, NULL, NULL, NULL, 'PROTOCADHERIN FAT 2', 249693),
(396598, 'PTHR24026:SF36', NULL, NULL, NULL, NULL, 'CADHERIN EGF LAG SEVEN-PASS G-TYPE RECEPTOR 1', 249693),
(396599, 'PTHR24026:SF38', NULL, NULL, NULL, NULL, 'CADHERIN EGF LAG SEVEN-PASS G-TYPE RECEPTOR 3', 249693),
(396600, 'PTHR12189:SF2', NULL, NULL, NULL, NULL, 'MRNA CAP GUANINE-N7 METHYLTRANSFERASE', 249694),
(396601, 'PTHR12189:SF3', NULL, NULL, NULL, NULL, 'MRNA (GUANINE-N(7)-)-METHYLTRANSFERASE', 249694),
(396602, 'PTHR12189:SF4', NULL, NULL, NULL, NULL, 'MRNA (GUANINE-N(7)-)-METHYLTRANSFERASE', 249694); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(396603, 'PTHR12189:SF6', NULL, NULL, NULL, NULL, 'MRNA CAP GUANINE-N7 METHYLTRANSFERASE', 249694),
(396604, 'PTHR12189:SF7', NULL, NULL, NULL, NULL, 'MRNA CAP GUANINE-N7 METHYLTRANSFERASE', 249694),
(396605, 'PTHR12189:SF8', NULL, NULL, NULL, NULL, 'MRNA CAP GUANINE-N7 METHYLTRANSFERASE', 249694),
(396606, 'PTHR12189', NULL, NULL, NULL, NULL, 'MRNA  GUANINE-7- METHYLTRANSFERASE', 249694),
(396607, 'PTHR12189:SF1', NULL, NULL, NULL, NULL, 'MRNA (GUANINE-N(7)-)-METHYLTRANSFERASE', 249694),
(396608, 'PTHR11863:SF214', NULL, NULL, NULL, NULL, 'METHYLSTEROL MONOOXYGENASE 2-2', 249695),
(396609, 'PTHR11863:SF137', NULL, NULL, NULL, NULL, 'METHYLSTEROL MONOOXYGENASE 2-2-LIKE ISOFORM X1', 249695),
(396610, 'PTHR11863:SF213', NULL, NULL, NULL, NULL, 'CHOLESTEROL 25-HYDROXYLASE', 249695),
(396611, 'PTHR11863:SF136', NULL, NULL, NULL, NULL, 'DELTA(7)-STEROL-C5(6)-DESATURASE 2-RELATED', 249695),
(396612, 'PTHR11863:SF131', NULL, NULL, NULL, NULL, 'PROTEIN ECERIFERUM 1-LIKE', 249695),
(396613, 'PTHR11863:SF174', NULL, NULL, NULL, NULL, 'BNAC03G12740D PROTEIN', 249695),
(396614, 'PTHR11863:SF177', NULL, NULL, NULL, NULL, 'STEROL DESATURASE', 249695),
(396615, 'PTHR11863:SF210', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN ALDEHYDE DECARBONYLASE GL1-5', 249695),
(396616, 'PTHR11863:SF133', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN ALDEHYDE DECARBONYLASE GL1-9', 249695),
(396617, 'PTHR11863:SF176', NULL, NULL, NULL, NULL, 'PROTEIN ECERIFERUM 3-LIKE', 249695),
(396618, 'PTHR11863:SF219', NULL, NULL, NULL, NULL, 'FATTY ACID HYDROXYLASE DOMAIN-CONTAINING PROTEIN', 249695),
(396619, 'PTHR11863:SF51', NULL, NULL, NULL, NULL, 'ALDEHYDE OXYGENASE (DEFORMYLATING)', 249695),
(396620, 'PTHR11863:SF138', NULL, NULL, NULL, NULL, 'ALDEHYDE OXYGENASE (DEFORMYLATING)', 249695),
(396621, 'PTHR11863:SF215', NULL, NULL, NULL, NULL, 'LATHOSTEROL OXIDASE', 249695),
(396622, 'PTHR11863:SF218', NULL, NULL, NULL, NULL, 'STEROL DELTA 5,6-DESATURASE ERG3 (AFU_ORTHOLOGUE AFUA_6G05140)', 249695),
(396623, 'PTHR11863:SF217', NULL, NULL, NULL, NULL, 'SPHINGANINE C4-MONOOXYGENASE 1-LIKE', 249695),
(396624, 'PTHR11863:SF124', NULL, NULL, NULL, NULL, 'ALDEHYDE OXYGENASE (DEFORMYLATING)', 249695),
(396625, 'PTHR11863:SF200', NULL, NULL, NULL, NULL, 'ALDEHYDE OXYGENASE (DEFORMYLATING)', 249695),
(396626, 'PTHR11863:SF167', NULL, NULL, NULL, NULL, 'BNAC03G12730D PROTEIN', 249695),
(396627, 'PTHR11863:SF126', NULL, NULL, NULL, NULL, 'ALDEHYDE OXYGENASE (DEFORMYLATING)', 249695),
(396628, 'PTHR11863:SF203', NULL, NULL, NULL, NULL, 'ALDEHYDE OXYGENASE (DEFORMYLATING)', 249695),
(396629, 'PTHR11863:SF202', NULL, NULL, NULL, NULL, 'FATTY ACID HYDROXYLASE DOMAIN-CONTAINING PROTEIN', 249695),
(396630, 'PTHR11863:SF169', NULL, NULL, NULL, NULL, 'FATTY ACID HYDROXYLASE DOMAIN-CONTAINING PROTEIN', 249695),
(396631, 'PTHR11863:SF164', NULL, NULL, NULL, NULL, 'METHYLSTEROL MONOOXYGENASE 1-3', 249695),
(396632, 'PTHR11863:SF163', NULL, NULL, NULL, NULL, 'FATTY ACID HYDROXYLASE-RELATED', 249695),
(396633, 'PTHR11863:SF122', NULL, NULL, NULL, NULL, 'SPHINGANINE C4-MONOOXYGENASE 1-LIKE', 249695),
(396634, 'PTHR11863:SF165', NULL, NULL, NULL, NULL, 'ALDEHYDE OXYGENASE (DEFORMYLATING)', 249695),
(396635, 'PTHR11863:SF121', NULL, NULL, NULL, NULL, 'METHYLSTEROL MONOOXYGENASE 1-1-LIKE', 249695),
(396636, 'PTHR11863:SF160', NULL, NULL, NULL, NULL, 'DELTA(7)-STEROL-C5(6)-DESATURASE', 249695),
(396637, 'PTHR11863:SF162', NULL, NULL, NULL, NULL, 'ALDEHYDE OXYGENASE (DEFORMYLATING)', 249695),
(396638, 'PTHR11863:SF161', NULL, NULL, NULL, NULL, 'METHYLSTEROL MONOOXYGENASE 1-2-LIKE', 249695),
(396639, 'PTHR11863:SF68', NULL, NULL, NULL, NULL, 'FATTY ACID HYDROXYLASE DOMAIN-CONTAINING PROTEIN', 249695),
(396640, 'PTHR11863:SF66', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN ALDEHYDE DECARBONYLASE CER3', 249695),
(396641, 'PTHR11863', NULL, NULL, NULL, NULL, 'STEROL DESATURASE', 249695),
(396642, 'PTHR11863:SF205', NULL, NULL, NULL, NULL, 'ALDEHYDE OXYGENASE (DEFORMYLATING)', 249695),
(396643, 'PTHR11863:SF128', NULL, NULL, NULL, NULL, 'ALDEHYDE OXYGENASE (DEFORMYLATING)', 249695);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(396644, 'PTHR11863:SF61', NULL, NULL, NULL, NULL, 'FATTY ACID HYDROXYLASE DOMAIN-CONTAINING PROTEIN', 249695),
(396645, 'PTHR11863:SF129', NULL, NULL, NULL, NULL, 'SPHINGANINE C4-MONOOXYGENASE 2', 249695),
(396646, 'PTHR11863:SF206', NULL, NULL, NULL, NULL, 'CHOLESTEROL 25-HYDROXYLASE-LIKE PROTEIN', 249695),
(396647, 'PTHR11863:SF113', NULL, NULL, NULL, NULL, 'CHOLESTEROL 25-HYDROXYLASE-LIKE PROTEIN 1, MEMBER 2', 249695),
(396648, 'PTHR11863:SF234', NULL, NULL, NULL, NULL, 'FATTY ACID HYDROXYLASE SUPERFAMILY PROTEIN', 249695),
(396649, 'PTHR11863:SF156', NULL, NULL, NULL, NULL, 'ALDEHYDE OXYGENASE (DEFORMYLATING)', 249695),
(396650, 'PTHR11863:SF233', NULL, NULL, NULL, NULL, 'FATTY ACID HYDROXYLASE DOMAIN-CONTAINING PROTEIN', 249695),
(396651, 'PTHR11863:SF115', NULL, NULL, NULL, NULL, 'PROTEIN ECERIFERUM 3-LIKE', 249695),
(396652, 'PTHR11863:SF158', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN ALDEHYDE DECARBONYLASE GL1-2', 249695),
(396653, 'PTHR11863:SF235', NULL, NULL, NULL, NULL, 'STEROL DESATURASE, PUTATIVE-RELATED', 249695),
(396654, 'PTHR11863:SF230', NULL, NULL, NULL, NULL, '', 249695),
(396655, 'PTHR11863:SF197', NULL, NULL, NULL, NULL, 'METHYLSTEROL MONOOXYGENASE 1-2', 249695),
(396656, 'PTHR11863:SF152', NULL, NULL, NULL, NULL, 'ALDEHYDE OXYGENASE (DEFORMYLATING)', 249695),
(396657, 'PTHR11863:SF232', NULL, NULL, NULL, NULL, 'METHYLSTEROL OXIDASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G01160)-RELATED', 249695),
(396658, 'PTHR11863:SF199', NULL, NULL, NULL, NULL, 'PROTEIN CER1-LIKE 1-RELATED', 249695),
(396659, 'PTHR11863:SF231', NULL, NULL, NULL, NULL, 'FATTY ACID HYDROXYLASE SUPERFAMILY PROTEIN', 249695),
(396660, 'PTHR11863:SF198', NULL, NULL, NULL, NULL, 'BNAA04G29140D PROTEIN', 249695),
(396661, 'PTHR11863:SF193', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN ALDEHYDE DECARBONYLASE CER1', 249695),
(396662, 'PTHR11863:SF150', NULL, NULL, NULL, NULL, 'PROTEIN ECERIFERUM 1-LIKE', 249695),
(396663, 'PTHR11863:SF194', NULL, NULL, NULL, NULL, 'DELTA(7)-STEROL-C5(6)-DESATURASE', 249695),
(396664, 'PTHR11863:SF190', NULL, NULL, NULL, NULL, 'FATTY ACID HYDROXYLASE DOMAIN-CONTAINING PROTEIN', 249695),
(396665, 'PTHR11863:SF37', NULL, NULL, NULL, NULL, 'FATTY ACID HYDROXYLASE DOMAIN-CONTAINING PROTEIN', 249695),
(396666, 'PTHR11863:SF36', NULL, NULL, NULL, NULL, 'FATTY ACID HYDROXYLASE DOMAIN-CONTAINING PROTEIN', 249695),
(396667, 'PTHR11863:SF34', NULL, NULL, NULL, NULL, 'CHOLESTEROL 25-HYDROXYLASE', 249695),
(396668, 'PTHR11863:SF146', NULL, NULL, NULL, NULL, 'SPHINGANINE C4-MONOOXYGENASE 1-LIKE', 249695),
(396669, 'PTHR11863:SF102', NULL, NULL, NULL, NULL, 'METHYL STEROL OXIDASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G02440)-RELATED', 249695),
(396670, 'PTHR11863:SF223', NULL, NULL, NULL, NULL, 'FATTY ACID HYDROXYLASE DOMAIN-CONTAINING PROTEIN', 249695),
(396671, 'PTHR11863:SF145', NULL, NULL, NULL, NULL, 'ALDEHYDE OXYGENASE (DEFORMYLATING)', 249695),
(396672, 'PTHR11863:SF222', NULL, NULL, NULL, NULL, 'DELTA(7)-STEROL 5(6)-DESATURASE ERG31', 249695),
(396673, 'PTHR11863:SF148', NULL, NULL, NULL, NULL, 'C-4 METHYLSTEROL OXIDASE', 249695),
(396674, 'PTHR11863:SF104', NULL, NULL, NULL, NULL, 'CHOLESTEROL 25-HYDROXYLASE-LIKE PROTEIN 1, MEMBER 1', 249695),
(396675, 'PTHR11863:SF225', NULL, NULL, NULL, NULL, 'METHYLSTEROL MONOOXYGENASE 1', 249695),
(396676, 'PTHR11863:SF224', NULL, NULL, NULL, NULL, 'SPHINGANINE C4-MONOOXYGENASE 1', 249695),
(396677, 'PTHR11863:SF186', NULL, NULL, NULL, NULL, 'BNAA10G11680D PROTEIN', 249695),
(396678, 'PTHR11863:SF142', NULL, NULL, NULL, NULL, 'SPHINGANINE C4-MONOOXYGENASE 1-LIKE', 249695),
(396679, 'PTHR11863:SF141', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN ALDEHYDE DECARBONYLASE GL1-7', 249695),
(396680, 'PTHR11863:SF144', NULL, NULL, NULL, NULL, 'METHYLSTEROL MONOOXYGENASE 2-1', 249695),
(396681, 'PTHR11863:SF221', NULL, NULL, NULL, NULL, 'PROTEIN ECERIFERUM 1-LIKE', 249695),
(396682, 'PTHR11863:SF220', NULL, NULL, NULL, NULL, 'FATTY ACID HYDROXYLASE SUPERFAMILY-RELATED', 249695),
(396683, 'PTHR11863:SF187', NULL, NULL, NULL, NULL, 'FATTY ACID HYDROXYLASE DOMAIN-CONTAINING PROTEIN', 249695);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(396684, 'PTHR11863:SF184', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN ALDEHYDE DECARBONYLASE GL1-3', 249695),
(396685, 'PTHR11863:SF140', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN ALDEHYDE DECARBONYLASE GL1-4', 249695),
(396686, 'PTHR11863:SF183', NULL, NULL, NULL, NULL, 'ALDEHYDE OXYGENASE (DEFORMYLATING)', 249695),
(396687, 'PTHR11863:SF227', NULL, NULL, NULL, NULL, 'FATTY ACID HYDROXYLASE-RELATED', 249695),
(396688, 'PTHR11863:SF106', NULL, NULL, NULL, NULL, 'CHOLESTEROL 25-HYDROXYLASE-LIKE PROTEIN 2', 249695),
(396689, 'PTHR11863:SF226', NULL, NULL, NULL, NULL, 'FATTY ACID HYDROXYLASE DOMAIN-CONTAINING PROTEIN 2-RELATED', 249695),
(396690, 'PTHR11863:SF149', NULL, NULL, NULL, NULL, 'ALDEHYDE OXYGENASE (DEFORMYLATING)', 249695),
(396691, 'PTHR11863:SF229', NULL, NULL, NULL, NULL, 'PROTEIN ECERIFERUM 1-LIKE', 249695),
(396692, 'PTHR11863:SF107', NULL, NULL, NULL, NULL, 'STEROL DESATURASE FAMILY', 249695),
(396693, 'PTHR11863:SF228', NULL, NULL, NULL, NULL, 'C-5 STEROL DESATURASE-LIKE PROTEIN-RELATED', 249695),
(396694, 'PTHR43421:SF1', NULL, NULL, NULL, NULL, 'METALLOPROTEASE PMBA', 249696),
(396695, 'PTHR43421', NULL, NULL, NULL, NULL, 'METALLOPROTEASE PMBA', 249696),
(396696, 'PTHR39163:SF1', NULL, NULL, NULL, NULL, 'FERREDOXIN', 249697),
(396697, 'PTHR39163', NULL, NULL, NULL, NULL, 'FERREDOXIN', 249697),
(396698, 'PTHR16096:SF8', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT 14', 249698),
(396699, 'PTHR16096', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN 11', 249698),
(396700, 'PTHR41747', NULL, NULL, NULL, NULL, '', 249699),
(396701, 'PTHR41747:SF1', NULL, NULL, NULL, NULL, '', 249699),
(396702, 'PTHR14889', NULL, NULL, NULL, NULL, 'RCG36411', 249700),
(396703, 'PTHR14889:SF3', NULL, NULL, NULL, NULL, 'TLR ADAPTER INTERACTING WITH SLC15A4 ON THE LYSOSOME', 249700),
(396704, 'PTHR14889:SF2', NULL, NULL, NULL, NULL, 'GENE 6377-RELATED', 249700),
(396705, 'PTHR13296', NULL, NULL, NULL, NULL, 'BCAS2 PROTEIN', 249701),
(396706, 'PTHR13296:SF0', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR SPF27', 249701),
(396707, 'PTHR13296:SF1', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR SPF27', 249701),
(396708, 'PTHR13296:SF4', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR SPF27', 249701),
(396709, 'PTHR13296:SF3', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR SPF27', 249701),
(396710, 'PTHR11470', NULL, NULL, NULL, NULL, 'KAPPA CASEIN', 249702),
(396711, 'PTHR11470:SF2', NULL, NULL, NULL, NULL, 'KAPPA-CASEIN', 249702),
(396712, 'PTHR13239:SF7', NULL, NULL, NULL, NULL, 'STRIATIN-INTERACTING PROTEIN 1', 249703),
(396713, 'PTHR13239', NULL, NULL, NULL, NULL, 'PROTEIN REQUIRED FOR HYPHAL ANASTOMOSIS  HAM-2', 249703),
(396714, 'PTHR13239:SF6', NULL, NULL, NULL, NULL, 'STRIATIN-INTERACTING PROTEIN 2', 249703),
(396715, 'PTHR13239:SF4', NULL, NULL, NULL, NULL, 'AT25231P', 249703),
(396716, 'PTHR23170', NULL, NULL, NULL, NULL, 'NY-REN-58 ANTIGEN', 249704),
(396717, 'PTHR23170:SF2', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 83 KDA', 249704),
(396718, 'PTHR23170:SF3', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 45', 249704),
(396719, 'PTHR36107:SF1', NULL, NULL, NULL, NULL, 'SMALL, ACID-SOLUBLE SPORE PROTEIN A', 249705),
(396720, 'PTHR36107', NULL, NULL, NULL, NULL, 'SMALL, ACID-SOLUBLE SPORE PROTEIN A', 249705),
(396721, 'PTHR13673:SF0', NULL, NULL, NULL, NULL, 'VPS35 ENDOSOMAL PROTEIN-SORTING FACTOR-LIKE', 249706),
(396722, 'PTHR13673', NULL, NULL, NULL, NULL, 'ESOPHAGEAL CANCER ASSOCIATED PROTEIN', 249706),
(396723, 'PTHR34948:SF2', NULL, NULL, NULL, NULL, 'OS08G0299200 PROTEIN', 249707),
(396724, 'PTHR34948', NULL, NULL, NULL, NULL, 'OS08G0299200 PROTEIN', 249707),
(396725, 'PTHR34948:SF5', NULL, NULL, NULL, NULL, 'CYTH DOMAIN-CONTAINING PROTEIN', 249707),
(396726, 'PTHR34948:SF4', NULL, NULL, NULL, NULL, 'TRIPHOSPHATE TUNEL METALLOENZYME 3-LIKE', 249707),
(396727, 'PTHR34948:SF8', NULL, NULL, NULL, NULL, 'TRIPHOSPHATE TUNNEL METALLOENZYME 3', 249707),
(396728, 'PTHR24242:SF227', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 249708);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(396729, 'PTHR24242:SF369', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 249708),
(396730, 'PTHR24242:SF248', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 9A2', 249708),
(396731, 'PTHR24242:SF126', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 9A1-RELATED', 249708),
(396732, 'PTHR24242:SF264', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 10X1', 249708),
(396733, 'PTHR24242:SF363', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 249708),
(396734, 'PTHR24242:SF165', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR FAMILY 11 SUBFAMILY K MEMBER 2', 249708),
(396735, 'PTHR24242:SF361', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 249708),
(396736, 'PTHR24242:SF246', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 249708),
(396737, 'PTHR24242:SF201', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 11H1-RELATED', 249708),
(396738, 'PTHR24242:SF366', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 249708),
(396739, 'PTHR24242:SF365', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 249708),
(396740, 'PTHR24242:SF364', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 249708),
(396741, 'PTHR24242:SF192', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 249708),
(396742, 'PTHR24242:SF239', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 249708),
(396743, 'PTHR24242:SF216', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 9A4', 249708),
(396744, 'PTHR24242:SF359', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR-RELATED', 249708),
(396745, 'PTHR24242:SF379', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 249708),
(396746, 'PTHR24242:SF357', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR FAMILY 6 SUBFAMILY Q MEMBER 1 (GENE/PSEUDOGENE)', 249708),
(396747, 'PTHR24242:SF218', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 249708),
(396748, 'PTHR24242:SF253', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 249708),
(396749, 'PTHR24242:SF90', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 11H6', 249708),
(396750, 'PTHR24242:SF374', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 249708),
(396751, 'PTHR24242:SF197', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 249708),
(396752, 'PTHR24242:SF373', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 249708),
(396753, 'PTHR24242:SF252', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 11H7', 249708),
(396754, 'PTHR24242:SF371', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 249708),
(396755, 'PTHR24242', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR', 249708),
(396756, 'PTHR24242:SF356', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 249708),
(396757, 'PTHR24242:SF158', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 9G1-RELATED', 249708),
(396758, 'PTHR24242:SF378', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 11A1', 249708),
(396759, 'PTHR24242:SF377', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 249708),
(396760, 'PTHR24242:SF256', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 249708),
(396761, 'PTHR24242:SF354', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 249708),
(396762, 'PTHR24242:SF376', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 249708),
(396763, 'PTHR24242:SF375', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', 249708),
(396764, 'PTHR24242:SF177', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 1346', 249708),
(396765, 'PTHR24242:SF183', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 11G2', 249708),
(396766, 'PTHR24242:SF381', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 11H4', 249708),
(396767, 'PTHR24242:SF380', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 5', 249708),
(396768, 'PTHR11915:SF325', NULL, NULL, NULL, NULL, 'SPECTRIN BETA CHAIN, NON-ERYTHROCYTIC 2', 249709),
(396769, 'PTHR11915:SF226', NULL, NULL, NULL, NULL, 'SPECTRIN BETA CHAIN, NON-ERYTHROCYTIC 1', 249709),
(396770, 'PTHR11915:SF435', NULL, NULL, NULL, NULL, 'SPECTRIN BETA CHAIN, NON-ERYTHROCYTIC 5', 249709),
(396771, 'PTHR11915:SF248', NULL, NULL, NULL, NULL, 'SPECTRIN BETA CHAIN, ERYTHROCYTIC', 249709),
(396772, 'PTHR11915:SF446', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 249709),
(396773, 'PTHR11915:SF425', NULL, NULL, NULL, NULL, 'ALPHA-ACTININ-4', 249709),
(396774, 'PTHR11915:SF447', NULL, NULL, NULL, NULL, 'SPECTRIN BETA CHAIN', 249709);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(396775, 'PTHR11915:SF427', NULL, NULL, NULL, NULL, 'SPECTRIN ALPHA CHAIN, NON-ERYTHROCYTIC 1', 249709),
(396776, 'PTHR11915:SF428', NULL, NULL, NULL, NULL, 'PROTEIN CBG16668', 249709),
(396777, 'PTHR11915:SF429', NULL, NULL, NULL, NULL, 'ALPHA-ACTININ-2', 249709),
(396778, 'PTHR11915:SF232', NULL, NULL, NULL, NULL, 'SPECTRIN BETA CHAIN, NON-ERYTHROCYTIC 4', 249709),
(396779, 'PTHR11915:SF431', NULL, NULL, NULL, NULL, 'SPECTRIN ALPHA CHAIN, ERYTHROCYTIC 1', 249709),
(396780, 'PTHR11915:SF442', NULL, NULL, NULL, NULL, 'ALPHA-ACTININ, SARCOMERIC-RELATED', 249709),
(396781, 'PTHR11915:SF432', NULL, NULL, NULL, NULL, 'ALPHA-ACTININ-3', 249709),
(396782, 'PTHR11915:SF422', NULL, NULL, NULL, NULL, 'SPECTRIN ALPHA CHAIN', 249709),
(396783, 'PTHR11915:SF445', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 249709),
(396784, 'PTHR11915:SF434', NULL, NULL, NULL, NULL, 'ALPHA-ACTININ-1', 249709),
(396785, 'PTHR11915', NULL, NULL, NULL, NULL, 'SPECTRIN/FILAMIN RELATED CYTOSKELETAL PROTEIN', 249709),
(396786, 'PTHR31702', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 33', 249710),
(396787, 'PTHR31702:SF2', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 33', 249710),
(396788, 'PTHR34273:SF2', NULL, NULL, NULL, NULL, 'METHYLTHIORIBOSE KINASE', 249711),
(396789, 'PTHR34273', NULL, NULL, NULL, NULL, 'METHYLTHIORIBOSE KINASE', 249711),
(396790, 'PTHR37988:SF1', NULL, NULL, NULL, NULL, 'UPF0592 MEMBRANE PROTEIN C7D4.03C', 249712),
(396791, 'PTHR37988', NULL, NULL, NULL, NULL, 'UPF0592 MEMBRANE PROTEIN C7D4.03C', 249712),
(396792, 'PTHR37291', NULL, NULL, NULL, NULL, '5-METHYLCYTOSINE-SPECIFIC RESTRICTION ENZYME B', 249713),
(396793, 'PTHR37291:SF1', NULL, NULL, NULL, NULL, '5-METHYLCYTOSINE-SPECIFIC RESTRICTION ENZYME B', 249713),
(396794, 'PTHR36526', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 154', 249714),
(396795, 'PTHR36526:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 154', 249714),
(396796, 'PTHR10058:SF0', NULL, NULL, NULL, NULL, 'MACROPHAGE COLONY-STIMULATING FACTOR 1', 249715),
(396797, 'PTHR10058', NULL, NULL, NULL, NULL, 'MACROPHAGE COLONY STIMULATING FACTOR', 249715),
(396798, 'PTHR48184', NULL, NULL, NULL, NULL, 'RICIN B-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 249716),
(396799, 'PTHR48184:SF2', NULL, NULL, NULL, NULL, '', 249716),
(396800, 'PTHR48184:SF1', NULL, NULL, NULL, NULL, 'RICIN B-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 249716),
(396801, 'PTHR16106:SF3', NULL, NULL, NULL, NULL, 'CHROMOSOME 4 OPEN READING FRAME 19', 249717),
(396802, 'PTHR16106', NULL, NULL, NULL, NULL, 'CHROMOSOME 4 OPEN READING FRAME 19', 249717),
(396803, 'PTHR10617', NULL, NULL, NULL, NULL, 'ELECTRON TRANSFER FLAVOPROTEIN-UBIQUINONE OXIDOREDUCTASE', 249718),
(396804, 'PTHR10617:SF107', NULL, NULL, NULL, NULL, 'ELECTRON TRANSFER FLAVOPROTEIN-UBIQUINONE OXIDOREDUCTASE, MITOCHONDRIAL', 249718),
(396805, 'PTHR46895:SF3', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR F59B2.13-RELATED', 249719),
(396806, 'PTHR46895:SF4', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 249719),
(396807, 'PTHR46895:SF1', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 249719),
(396808, 'PTHR46895:SF2', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 249719),
(396809, 'PTHR46895:SF7', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 249719),
(396810, 'PTHR46895', NULL, NULL, NULL, NULL, 'PROTEIN CBG20548-RELATED', 249719),
(396811, 'PTHR46895:SF8', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 249719),
(396812, 'PTHR46895:SF5', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 249719),
(396813, 'PTHR46895:SF6', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 249719),
(396814, 'PTHR16922:SF0', NULL, NULL, NULL, NULL, 'INTERLEUKIN-11', 249720),
(396815, 'PTHR16922', NULL, NULL, NULL, NULL, 'INTERLEUKIN 11', 249720),
(396816, 'PTHR13022:SF0', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT K', 249721),
(396817, 'PTHR13022:SF1', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT K', 249721);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(396818, 'PTHR13022', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT 11', 249721),
(396819, 'PTHR34555:SF7', NULL, NULL, NULL, NULL, '', 249722),
(396820, 'PTHR34555:SF3', NULL, NULL, NULL, NULL, 'OS04G0136900 PROTEIN', 249722),
(396821, 'PTHR34555', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE HEMOLYSIN-III-LIKE PROTEIN', 249722),
(396822, 'PTHR34555:SF1', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE HEMOLYSIN-III-LIKE PROTEIN', 249722),
(396823, 'PTHR39157', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN-RELATED', 249723),
(396824, 'PTHR39157:SF1', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN-RELATED', 249723),
(396825, 'PTHR21261:SF3', NULL, NULL, NULL, NULL, 'BEATEN PATH VII', 249724),
(396826, 'PTHR21261:SF2', NULL, NULL, NULL, NULL, 'GH04238P-RELATED', 249724),
(396827, 'PTHR21261:SF17', NULL, NULL, NULL, NULL, 'BEAT VI', 249724),
(396828, 'PTHR21261:SF15', NULL, NULL, NULL, NULL, 'BEATEN PATH IIIA, ISOFORM D-RELATED', 249724),
(396829, 'PTHR21261:SF14', NULL, NULL, NULL, NULL, 'BEATEN PATH IV, ISOFORM B', 249724),
(396830, 'PTHR21261', NULL, NULL, NULL, NULL, 'BEAT PROTEIN', 249724),
(396831, 'PTHR21261:SF8', NULL, NULL, NULL, NULL, 'BEATEN PATH IA, ISOFORM B-RELATED', 249724),
(396832, 'PTHR21261:SF6', NULL, NULL, NULL, NULL, 'BEATEN PATH IIA-RELATED', 249724),
(396833, 'PTHR21261:SF5', NULL, NULL, NULL, NULL, 'BEATEN PATH VA, ISOFORM A-RELATED', 249724),
(396834, 'PTHR30177:SF4', NULL, NULL, NULL, NULL, 'OSMOPROTECTANT IMPORT PERMEASE PROTEIN OSMW', 249725),
(396835, 'PTHR30177:SF28', NULL, NULL, NULL, NULL, 'CHOLINE TRANSPORT SYSTEM PERMEASE PROTEIN OPUBB', 249725),
(396836, 'PTHR30177:SF32', NULL, NULL, NULL, NULL, 'GLYCINE BETAINE UPTAKE SYSTEM PERMEASE PROTEIN YEHW', 249725),
(396837, 'PTHR30177:SF33', NULL, NULL, NULL, NULL, 'ABC TRANSPORT PERMEASE-RELATED', 249725),
(396838, 'PTHR30177:SF30', NULL, NULL, NULL, NULL, 'GLYCINE BETAINE UPTAKE SYSTEM PERMEASE PROTEIN YEHY', 249725),
(396839, 'PTHR30177', NULL, NULL, NULL, NULL, 'GLYCINE BETAINE/L-PROLINE TRANSPORT SYSTEM PERMEASE PROTEIN PROW', 249725),
(396840, 'PTHR11199:SF6', NULL, NULL, NULL, NULL, 'COHESIN SUBUNIT SA-1', 249726),
(396841, 'PTHR11199:SF8', NULL, NULL, NULL, NULL, 'COHESIN SUBUNIT SA-3', 249726),
(396842, 'PTHR11199:SF9', NULL, NULL, NULL, NULL, 'SI:CH211-269E2.1', 249726),
(396843, 'PTHR11199:SF2', NULL, NULL, NULL, NULL, 'SCD DOMAIN-CONTAINING PROTEIN', 249726),
(396844, 'PTHR11199:SF3', NULL, NULL, NULL, NULL, 'COHESIN SUBUNIT SA-2', 249726),
(396845, 'PTHR11199:SF0', NULL, NULL, NULL, NULL, 'LD34181P-RELATED', 249726),
(396846, 'PTHR11199:SF10', NULL, NULL, NULL, NULL, 'SCD DOMAIN-CONTAINING PROTEIN', 249726),
(396847, 'PTHR11199', NULL, NULL, NULL, NULL, 'STROMAL ANTIGEN', 249726),
(396848, 'PTHR46347:SF9', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 249727),
(396849, 'PTHR46347:SF8', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 249727),
(396850, 'PTHR46347:SF10', NULL, NULL, NULL, NULL, 'OS08G0384900 PROTEIN', 249727),
(396851, 'PTHR46347:SF7', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 249727),
(396852, 'PTHR46347:SF5', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 249727),
(396853, 'PTHR46347:SF4', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER SUPERFAMILY PROTEIN', 249727),
(396854, 'PTHR46347:SF2', NULL, NULL, NULL, NULL, 'OS02G0132300 PROTEIN', 249727),
(396855, 'PTHR46347:SF1', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER SUPERFAMILY PROTEIN', 249727),
(396856, 'PTHR46347', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER SUPERFAMILY PROTEIN', 249727),
(396857, 'PTHR13236:SF0', NULL, NULL, NULL, NULL, 'CYTOPLASMIC DYNEIN 2 LIGHT INTERMEDIATE CHAIN 1', 249728),
(396858, 'PTHR13236', NULL, NULL, NULL, NULL, 'DYNEIN 2 LIGHT INTERMEDIATE CHAIN, ISOFORM 2', 249728),
(396859, 'PTHR17045', NULL, NULL, NULL, NULL, 'MELANOCYTE SPECIFIC GENE RELATED  CITED', 249729),
(396860, 'PTHR17045:SF8', NULL, NULL, NULL, NULL, '', 249729),
(396861, 'PTHR17045:SF5', NULL, NULL, NULL, NULL, 'CBP/P300-INTERACTING TRANSACTIVATOR 4', 249729);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(396862, 'PTHR17045:SF6', NULL, NULL, NULL, NULL, 'CBP/P300-INTERACTING TRANSACTIVATOR 1', 249729),
(396863, 'PTHR17045:SF7', NULL, NULL, NULL, NULL, 'CBP/P300-INTERACTING TRANSACTIVATOR 2', 249729),
(396864, 'PTHR47865', NULL, NULL, NULL, NULL, 'OS05G0580550 PROTEIN', 249730),
(396865, 'PTHR47865:SF1', NULL, NULL, NULL, NULL, 'OS05G0580550 PROTEIN', 249730),
(396866, 'PTHR35138:SF1', NULL, NULL, NULL, NULL, 'TIC22 FAMILY PROTEIN', 249731),
(396867, 'PTHR35138', NULL, NULL, NULL, NULL, 'OS01G0225300 PROTEIN', 249731),
(396868, 'PTHR39394', NULL, NULL, NULL, NULL, 'YALI0E31793P', 249732),
(396869, 'PTHR39394:SF1', NULL, NULL, NULL, NULL, 'DUF1992 DOMAIN-CONTAINING PROTEIN', 249732),
(396870, 'PTHR10655:SF70', NULL, NULL, NULL, NULL, 'ABHYDROLASE_2 DOMAIN-CONTAINING PROTEIN', 249733),
(396871, 'PTHR10655:SF17', NULL, NULL, NULL, NULL, 'LYSOPHOSPHOLIPASE-LIKE PROTEIN 1', 249733),
(396872, 'PTHR10655', NULL, NULL, NULL, NULL, 'LYSOPHOSPHOLIPASE-RELATED', 249733),
(396873, 'PTHR10655:SF21', NULL, NULL, NULL, NULL, 'ACYL-PROTEIN THIOESTERASE 1 HOMOLOG 2', 249733),
(396874, 'PTHR10655:SF64', NULL, NULL, NULL, NULL, 'ABHYDROLASE_2 DOMAIN-CONTAINING PROTEIN', 249733),
(396875, 'PTHR10655:SF30', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE OS04G0669600-RELATED', 249733),
(396876, 'PTHR10655:SF63', NULL, NULL, NULL, NULL, 'ABHYDROLASE_2 DOMAIN-CONTAINING PROTEIN', 249733),
(396877, 'PTHR10655:SF62', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE SOBER1', 249733),
(396878, 'PTHR10655:SF58', NULL, NULL, NULL, NULL, 'ABHYDROLASE_2 DOMAIN-CONTAINING PROTEIN', 249733),
(396879, 'PTHR10655:SF69', NULL, NULL, NULL, NULL, 'LYSOPHOSPHOLIPASE ESTERASE-RELATED', 249733),
(396880, 'PTHR10655:SF13', NULL, NULL, NULL, NULL, 'ACYL-PROTEIN THIOESTERASE 2', 249733),
(396881, 'PTHR10655:SF68', NULL, NULL, NULL, NULL, 'ABHYDROLASE_2 DOMAIN-CONTAINING PROTEIN', 249733),
(396882, 'PTHR10655:SF57', NULL, NULL, NULL, NULL, 'INACTIVE CARBOXYLESTERASE OS04G0669700-RELATED', 249733),
(396883, 'PTHR10655:SF67', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE/CARBOXYLESTERASE SUPERFAMILY (AFU_ORTHOLOGUE AFUA_5G09340)', 249733),
(396884, 'PTHR10655:SF22', NULL, NULL, NULL, NULL, 'ACYL-PROTEIN THIOESTERASE 1', 249733),
(396885, 'PTHR10848:SF0', NULL, NULL, NULL, NULL, 'MEIOTIC RECOMBINATION PROTEIN SPO11', 249734),
(396886, 'PTHR10848', NULL, NULL, NULL, NULL, 'MEIOTIC RECOMBINATION PROTEIN SPO11', 249734),
(396887, 'PTHR10848:SF2', NULL, NULL, NULL, NULL, 'RECOMBINATION PROTEIN SPO11, PUTATIVE-RELATED', 249734),
(396888, 'PTHR10848:SF3', NULL, NULL, NULL, NULL, 'MEIOTIC RECOMBINATION PROTEIN SPO11-1', 249734),
(396889, 'PTHR10848:SF4', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE 6 SUBUNIT A', 249734),
(396890, 'PTHR24379', NULL, NULL, NULL, NULL, 'KRAB AND ZINC FINGER DOMAIN-CONTAINING', 249735),
(396891, 'PTHR24379:SF109', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 878', 249735),
(396892, 'PTHR24379:SF108', NULL, NULL, NULL, NULL, 'ZFP617 PROTEIN', 249735),
(396893, 'PTHR24379:SF107', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 625', 249735),
(396894, 'PTHR24379:SF106', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 791', 249735),
(396895, 'PTHR24379:SF104', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 669', 249735),
(396896, 'PTHR24379:SF80', NULL, NULL, NULL, NULL, 'SIMILAR TO ZINC FINGER PROTEIN 84 (HPF2)', 249735),
(396897, 'PTHR24379:SF81', NULL, NULL, NULL, NULL, 'CCCTC-BINDING FACTOR-LIKE', 249735),
(396898, 'PTHR24379:SF103', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 816', 249735),
(396899, 'PTHR24379:SF20', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 517', 249735),
(396900, 'PTHR24379:SF40', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 700', 249735),
(396901, 'PTHR24379:SF85', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 275', 249735),
(396902, 'PTHR24379:SF68', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 443', 249735),
(396903, 'PTHR24379:SF22', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 441', 249735),
(396904, 'PTHR24379:SF66', NULL, NULL, NULL, NULL, '', 249735),
(396905, 'PTHR24379:SF67', NULL, NULL, NULL, NULL, 'BLOODY FINGERS-RELATED', 249735);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(396906, 'PTHR24379:SF89', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 124', 249735),
(396907, 'PTHR24379:SF27', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 823', 249735),
(396908, 'PTHR24379:SF6', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 442', 249735),
(396909, 'PTHR24379:SF5', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 799', 249735),
(396910, 'PTHR24379:SF93', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 439', 249735),
(396911, 'PTHR24379:SF94', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 433-RELATED', 249735),
(396912, 'PTHR24379:SF115', NULL, NULL, NULL, NULL, 'EG636741 PROTEIN-RELATED', 249735),
(396913, 'PTHR24379:SF114', NULL, NULL, NULL, NULL, '', 249735),
(396914, 'PTHR24379:SF70', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 101', 249735),
(396915, 'PTHR24379:SF113', NULL, NULL, NULL, NULL, 'RIKEN CDNA 9130023H24 GENE', 249735),
(396916, 'PTHR24379:SF75', NULL, NULL, NULL, NULL, 'VASCULAR ENDOTHELIAL ZINC FINGER 1', 249735),
(396917, 'PTHR24379:SF97', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 440', 249735),
(396918, 'PTHR24379:SF112', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 708', 249735),
(396919, 'PTHR24379:SF98', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 44', 249735),
(396920, 'PTHR24379:SF95', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 799', 249735),
(396921, 'PTHR24379:SF111', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 14', 249735),
(396922, 'PTHR24379:SF9', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 57', 249735),
(396923, 'PTHR24379:SF110', NULL, NULL, NULL, NULL, '', 249735),
(396924, 'PTHR24379:SF14', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 563', 249735),
(396925, 'PTHR24379:SF99', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 709', 249735),
(396926, 'PTHR24379:SF77', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 696', 249735),
(396927, 'PTHR24379:SF78', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 627', 249735),
(396928, 'PTHR47343:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR SPT7', 249736),
(396929, 'PTHR47343', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR SPT7', 249736),
(396930, 'PTHR47511:SF2', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 249737),
(396931, 'PTHR47511:SF1', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP23', 249737),
(396932, 'PTHR47511', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP23', 249737),
(396933, 'PTHR45723', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE RIO1', 249738),
(396934, 'PTHR45723:SF1', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE RIO3', 249738),
(396935, 'PTHR45723:SF2', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE RIO1', 249738),
(396936, 'PTHR45723:SF4', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE RIO1', 249738),
(396937, 'PTHR45827', NULL, NULL, NULL, NULL, 'SORTING NEXIN', 249739),
(396938, 'PTHR45827:SF2', NULL, NULL, NULL, NULL, 'SORTING NEXIN-9', 249739),
(396939, 'PTHR45827:SF1', NULL, NULL, NULL, NULL, 'SORTING NEXIN', 249739),
(396940, 'PTHR45827:SF4', NULL, NULL, NULL, NULL, 'SORTING NEXIN-18', 249739),
(396941, 'PTHR45827:SF3', NULL, NULL, NULL, NULL, 'SORTING NEXIN-33', 249739),
(396942, 'PTHR22952:SF409', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR', 249740),
(396943, 'PTHR22952:SF446', NULL, NULL, NULL, NULL, 'ABSCISIC ACID-INSENSITIVE 5-LIKE PROTEIN 5-RELATED', 249740),
(396944, 'PTHR22952:SF445', NULL, NULL, NULL, NULL, 'ABSCISIC ACID-INSENSITIVE 5-LIKE PROTEIN 7', 249740),
(396945, 'PTHR22952:SF404', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 249740),
(396946, 'PTHR22952:SF447', NULL, NULL, NULL, NULL, 'BASIC-LEUCINE ZIPPER DOMAIN-CONTAINING PROTEIN-RELATED', 249740),
(396947, 'PTHR22952:SF406', NULL, NULL, NULL, NULL, 'OS06G0720900 PROTEIN', 249740),
(396948, 'PTHR22952:SF408', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 249740),
(396949, 'PTHR22952:SF442', NULL, NULL, NULL, NULL, 'OS03G0322700 PROTEIN', 249740),
(396950, 'PTHR22952:SF441', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 249740),
(396951, 'PTHR22952:SF413', NULL, NULL, NULL, NULL, 'ABSCISIC ACID-INSENSITIVE 5-LIKE PROTEIN 4', 249740);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(396952, 'PTHR22952:SF412', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 249740),
(396953, 'PTHR22952:SF459', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 249740),
(396954, 'PTHR22952:SF414', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 249740),
(396955, 'PTHR22952:SF458', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR', 249740),
(396956, 'PTHR22952:SF417', NULL, NULL, NULL, NULL, 'OS09G0456200 PROTEIN', 249740),
(396957, 'PTHR22952:SF419', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 249740),
(396958, 'PTHR22952:SF450', NULL, NULL, NULL, NULL, 'PROTEIN FD-LIKE', 249740),
(396959, 'PTHR22952:SF175', NULL, NULL, NULL, NULL, 'PROTEIN ABSCISIC ACID-INSENSITIVE 5', 249740),
(396960, 'PTHR22952:SF453', NULL, NULL, NULL, NULL, 'OS05G0437700 PROTEIN', 249740),
(396961, 'PTHR22952', NULL, NULL, NULL, NULL, 'CAMP-RESPONSE ELEMENT BINDING PROTEIN-RELATED', 249740),
(396962, 'PTHR22952:SF468', NULL, NULL, NULL, NULL, '', 249740),
(396963, 'PTHR22952:SF467', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 249740),
(396964, 'PTHR22952:SF469', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 249740),
(396965, 'PTHR22952:SF428', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 249740),
(396966, 'PTHR22952:SF427', NULL, NULL, NULL, NULL, 'ABA-RESPONSIVE ELEMENT BINDING PROTEIN 3-RELATED', 249740),
(396967, 'PTHR22952:SF429', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 249740),
(396968, 'PTHR22952:SF460', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 249740),
(396969, 'PTHR22952:SF184', NULL, NULL, NULL, NULL, 'G-BOX-BINDING FACTOR 4', 249740),
(396970, 'PTHR22952:SF385', NULL, NULL, NULL, NULL, 'OS01G0813100 PROTEIN', 249740),
(396971, 'PTHR22952:SF461', NULL, NULL, NULL, NULL, 'ABSCISIC ACID RESPONSIVE ELEMENT-BINDING FACTOR 1-RELATED', 249740),
(396972, 'PTHR22952:SF464', NULL, NULL, NULL, NULL, 'ABRE BINDING FACTOR', 249740),
(396973, 'PTHR22952:SF463', NULL, NULL, NULL, NULL, 'ABSCISIC ACID-INSENSITIVE 5-LIKE PROTEIN 7', 249740),
(396974, 'PTHR22952:SF389', NULL, NULL, NULL, NULL, 'ABSCISIC ACID-INSENSITIVE 5-LIKE PROTEIN 4 ISOFORM X1', 249740),
(396975, 'PTHR22952:SF466', NULL, NULL, NULL, NULL, 'ABSCISIC ACID-INSENSITIVE 5-LIKE PROTEIN 2', 249740),
(396976, 'PTHR22952:SF103', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR 23', 249740),
(396977, 'PTHR22952:SF388', NULL, NULL, NULL, NULL, 'OS02G0833600 PROTEIN', 249740),
(396978, 'PTHR22952:SF465', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 249740),
(396979, 'PTHR22952:SF435', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 249740),
(396980, 'PTHR22952:SF479', NULL, NULL, NULL, NULL, 'ABRE BINDING FACTOR', 249740),
(396981, 'PTHR22952:SF434', NULL, NULL, NULL, NULL, 'ABSCISIC ACID-INSENSITIVE 5-LIKE PROTEIN 3', 249740),
(396982, 'PTHR22952:SF478', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 249740),
(396983, 'PTHR22952:SF471', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR TRAB1', 249740),
(396984, 'PTHR22952:SF470', NULL, NULL, NULL, NULL, 'ABSCISIC ACID-INSENSITIVE 5-LIKE PROTEIN 6', 249740),
(396985, 'PTHR22952:SF473', NULL, NULL, NULL, NULL, 'BASIC-LEUCINE ZIPPER DOMAIN-CONTAINING PROTEIN-RELATED', 249740),
(396986, 'PTHR22952:SF395', NULL, NULL, NULL, NULL, 'ABSCISIC ACID-INSENSITIVE 5-LIKE PROTEIN 1', 249740),
(396987, 'PTHR22952:SF472', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR', 249740),
(396988, 'PTHR22952:SF475', NULL, NULL, NULL, NULL, 'OS08G0549600 PROTEIN', 249740),
(396989, 'PTHR22952:SF474', NULL, NULL, NULL, NULL, 'ABSCISIC ACID-INSENSITIVE 5-LIKE PROTEIN 6', 249740),
(396990, 'PTHR22952:SF477', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER TRANSCRIPTION FACTOR', 249740),
(396991, 'PTHR22952:SF433', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR 27', 249740),
(396992, 'PTHR22952:SF432', NULL, NULL, NULL, NULL, 'PROTEIN FD', 249740),
(396993, 'PTHR22952:SF355', NULL, NULL, NULL, NULL, 'OS09G0540800 PROTEIN', 249740),
(396994, 'PTHR22952:SF476', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR', 249740);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(396995, 'PTHR22952:SF390', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 249740),
(396996, 'PTHR22952:SF392', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR 12', 249740),
(396997, 'PTHR32195:SF24', NULL, NULL, NULL, NULL, 'TRYPTOPHAN OR TYROSINE TRANSPORTER PROTEIN', 249741),
(396998, 'PTHR32195:SF26', NULL, NULL, NULL, NULL, 'TRYPTOPHAN OR TYROSINE TRANSPORTER PROTEIN', 249741),
(396999, 'PTHR32195', NULL, NULL, NULL, NULL, 'OS07G0662800 PROTEIN', 249741),
(397000, 'PTHR16161', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 249742),
(397001, 'PTHR16161:SF0', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL PROTEIN SWT1', 249742),
(397002, 'PTHR11319', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR-RELATED', 249743),
(397003, 'PTHR11319:SF35', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN PMPC-RELATED', 249743),
(397004, 'PTHR11319:SF34', NULL, NULL, NULL, NULL, '', 249743),
(397005, 'PTHR47611:SF1', NULL, NULL, NULL, NULL, 'DIMER_TNP_HAT DOMAIN-CONTAINING PROTEIN', 249744),
(397006, 'PTHR47611:SF3', NULL, NULL, NULL, NULL, 'DIMER_TNP_HAT DOMAIN-CONTAINING PROTEIN', 249744),
(397007, 'PTHR47611', NULL, NULL, NULL, NULL, 'HAT DIMERISATION DOMAIN, C-TERMINAL', 249744),
(397008, 'PTHR39077', NULL, NULL, NULL, NULL, 'DUF4793 DOMAIN-CONTAINING PROTEIN', 249745),
(397009, 'PTHR39077:SF1', NULL, NULL, NULL, NULL, '', 249745),
(397010, 'PTHR39077:SF2', NULL, NULL, NULL, NULL, '', 249745),
(397011, 'PTHR15069:SF1', NULL, NULL, NULL, NULL, 'PROTEASOME ASSEMBLY CHAPERONE 1', 249746),
(397012, 'PTHR15069', NULL, NULL, NULL, NULL, 'PROTEASOME ASSEMBLY CHAPERONE 1', 249746),
(397013, 'PTHR31973:SF117', NULL, NULL, NULL, NULL, 'F10A16.15 PROTEIN', 249747),
(397014, 'PTHR31973:SF176', NULL, NULL, NULL, NULL, 'OS07G0646700 PROTEIN', 249747),
(397015, 'PTHR31973:SF155', NULL, NULL, NULL, NULL, 'OS02G0192200 PROTEIN', 249747),
(397016, 'PTHR31973:SF177', NULL, NULL, NULL, NULL, 'MUDR FAMILY TRANSPOSASE', 249747),
(397017, 'PTHR31973:SF178', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 249747),
(397018, 'PTHR31973:SF179', NULL, NULL, NULL, NULL, 'SWIM-TYPE DOMAIN-CONTAINING PROTEIN', 249747),
(397019, 'PTHR31973:SF157', NULL, NULL, NULL, NULL, 'SWIM-TYPE DOMAIN-CONTAINING PROTEIN', 249747),
(397020, 'PTHR31973:SF113', NULL, NULL, NULL, NULL, 'SWIM-TYPE DOMAIN-CONTAINING PROTEIN', 249747),
(397021, 'PTHR31973:SF173', NULL, NULL, NULL, NULL, 'OS12G0597300 PROTEIN', 249747),
(397022, 'PTHR31973:SF152', NULL, NULL, NULL, NULL, 'SWIM-TYPE DOMAIN-CONTAINING PROTEIN', 249747),
(397023, 'PTHR31973:SF174', NULL, NULL, NULL, NULL, 'GAG-POL POLYPROTEIN', 249747),
(397024, 'PTHR31973:SF175', NULL, NULL, NULL, NULL, 'OS08G0337601 PROTEIN', 249747),
(397025, 'PTHR31973:SF171', NULL, NULL, NULL, NULL, 'SWIM-TYPE DOMAIN-CONTAINING PROTEIN', 249747),
(397026, 'PTHR31973:SF92', NULL, NULL, NULL, NULL, 'SWIM-TYPE DOMAIN-CONTAINING PROTEIN', 249747),
(397027, 'PTHR31973:SF93', NULL, NULL, NULL, NULL, 'OS02G0685500 PROTEIN', 249747),
(397028, 'PTHR31973:SF129', NULL, NULL, NULL, NULL, 'SWIM-TYPE DOMAIN-CONTAINING PROTEIN', 249747),
(397029, 'PTHR31973:SF169', NULL, NULL, NULL, NULL, 'OS06G0704400 PROTEIN', 249747),
(397030, 'PTHR31973:SF149', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE', 249747),
(397031, 'PTHR31973', NULL, NULL, NULL, NULL, 'POLYPROTEIN, PUTATIVE-RELATED', 249747),
(397032, 'PTHR31973:SF166', NULL, NULL, NULL, NULL, 'OS06G0632700 PROTEIN', 249747),
(397033, 'PTHR31973:SF122', NULL, NULL, NULL, NULL, '', 249747),
(397034, 'PTHR31973:SF163', NULL, NULL, NULL, NULL, 'MUTATOR TRANSPOSASE MUDRA PROTEIN', 249747),
(397035, 'PTHR31973:SF180', NULL, NULL, NULL, NULL, 'ZNF_PMZ DOMAIN-CONTAINING PROTEIN', 249747),
(397036, 'PTHR31973:SF181', NULL, NULL, NULL, NULL, 'DBD_TNP_MUT DOMAIN-CONTAINING PROTEIN', 249747),
(397037, 'PTHR31973:SF182', NULL, NULL, NULL, NULL, 'TRANSPOSON PROTEIN, MUTATOR SUB-CLASS', 249747),
(397038, 'PTHR31973:SF160', NULL, NULL, NULL, NULL, 'SWIM-TYPE DOMAIN-CONTAINING PROTEIN', 249747),
(397039, 'PTHR43118', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN LYASE (EUROFUNG)', 249748);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(397040, 'PTHR43118:SF1', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN LYASE (EUROFUNG)', 249748),
(397041, 'PTHR10665:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR CBF12', 249749),
(397042, 'PTHR10665', NULL, NULL, NULL, NULL, 'RECOMBINING BINDING PROTEIN SUPPRESSOR OF HAIRLESS', 249749),
(397043, 'PTHR10665:SF0', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF HAIRLESS PROTEIN', 249749),
(397044, 'PTHR10665:SF4', NULL, NULL, NULL, NULL, '', 249749),
(397045, 'PTHR10665:SF3', NULL, NULL, NULL, NULL, 'RECOMBINING BINDING PROTEIN SUPPRESSOR OF HAIRLESS', 249749),
(397046, 'PTHR10665:SF2', NULL, NULL, NULL, NULL, 'RECOMBINING BINDING PROTEIN SUPPRESSOR OF HAIRLESS-LIKE PROTEIN', 249749),
(397047, 'PTHR44549', NULL, NULL, NULL, NULL, 'ENDOTHELIAL CELL-SELECTIVE ADHESION MOLECULE', 249750),
(397048, 'PTHR44549:SF1', NULL, NULL, NULL, NULL, 'ENDOTHELIAL CELL-SELECTIVE ADHESION MOLECULE', 249750),
(397049, 'PTHR21066:SF15', NULL, NULL, NULL, NULL, 'GH25962P-RELATED', 249751),
(397050, 'PTHR21066:SF3', NULL, NULL, NULL, NULL, 'IP02236P', 249751),
(397051, 'PTHR21066', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 249751),
(397052, 'PTHR21066:SF17', NULL, NULL, NULL, NULL, 'AGAP011368-PA', 249751),
(397053, 'PTHR21066:SF18', NULL, NULL, NULL, NULL, 'ODORANT-BINDING PROTEIN 73A, ISOFORM B', 249751),
(397054, 'PTHR21066:SF9', NULL, NULL, NULL, NULL, 'ODORANT-BINDING PROTEIN 59A', 249751),
(397055, 'PTHR28657:SF2', NULL, NULL, NULL, NULL, 'INDOLEAMINE 2,3-DIOXYGENASE 1', 249752),
(397056, 'PTHR28657:SF3', NULL, NULL, NULL, NULL, 'INDOLEAMINE 2,3-DIOXYGENASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_7G02010)', 249752),
(397057, 'PTHR28657:SF4', NULL, NULL, NULL, NULL, 'INDOLEAMINE 2,3-DIOXYGENASE 2', 249752),
(397058, 'PTHR28657:SF5', NULL, NULL, NULL, NULL, 'INDOLEAMINE 2,3-DIOXYGENASE', 249752),
(397059, 'PTHR28657:SF11', NULL, NULL, NULL, NULL, '', 249752),
(397060, 'PTHR28657:SF10', NULL, NULL, NULL, NULL, 'INDOLEAMINE 2,3-DIOXYGENASE', 249752),
(397061, 'PTHR28657', NULL, NULL, NULL, NULL, 'INDOLEAMINE 2,3-DIOXYGENASE', 249752),
(397062, 'PTHR16222', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLGLYCOHYDROLASE', 249753),
(397063, 'PTHR16222:SF28', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 249753),
(397064, 'PTHR16222:SF39', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLARGININE HYDROLASE', 249753),
(397065, 'PTHR16222:SF17', NULL, NULL, NULL, NULL, 'SELENOPROTEIN J', 249753),
(397066, 'PTHR16222:SF38', NULL, NULL, NULL, NULL, 'ADP-RIBOSE GLYCOHYDROLASE ARH3', 249753),
(397067, 'PTHR16222:SF26', NULL, NULL, NULL, NULL, '[PROTEIN ADP-RIBOSYLARGININE] HYDROLASE', 249753),
(397068, 'PTHR16222:SF37', NULL, NULL, NULL, NULL, '', 249753),
(397069, 'PTHR16222:SF14', NULL, NULL, NULL, NULL, '', 249753),
(397070, 'PTHR16222:SF36', NULL, NULL, NULL, NULL, '', 249753),
(397071, 'PTHR16222:SF24', NULL, NULL, NULL, NULL, 'ADP-RIBOSE GLYCOHYDROLASE ARH3', 249753),
(397072, 'PTHR16222:SF35', NULL, NULL, NULL, NULL, '', 249753),
(397073, 'PTHR16222:SF12', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLGLYCOHYDROLASE-RELATED', 249753),
(397074, 'PTHR16222:SF34', NULL, NULL, NULL, NULL, '', 249753),
(397075, 'PTHR16222:SF23', NULL, NULL, NULL, NULL, '[PROTEIN ADP-RIBOSYLARGININE] HYDROLASE-LIKE PROTEIN 1', 249753),
(397076, 'PTHR16222:SF21', NULL, NULL, NULL, NULL, '[PROTEIN ADP-RIBOSYLARGININE] HYDROLASE', 249753),
(397077, 'PTHR21231:SF3', NULL, NULL, NULL, NULL, 'GPN-LOOP GTPASE 2', 249754),
(397078, 'PTHR21231:SF7', NULL, NULL, NULL, NULL, 'GPN-LOOP GTPASE 3', 249754),
(397079, 'PTHR21231:SF8', NULL, NULL, NULL, NULL, 'GPN-LOOP GTPASE 1', 249754),
(397080, 'PTHR21231:SF9', NULL, NULL, NULL, NULL, 'GPN-LOOP GTPASE', 249754),
(397081, 'PTHR21231', NULL, NULL, NULL, NULL, 'XPA-BINDING PROTEIN 1-RELATED', 249754),
(397082, 'PTHR21231:SF10', NULL, NULL, NULL, NULL, 'BNAA03G57850D PROTEIN', 249754),
(397083, 'PTHR24276:SF61', NULL, NULL, NULL, NULL, 'SERINE PROTEASE 53', 249755),
(397084, 'PTHR24276:SF94', NULL, NULL, NULL, NULL, 'AT20289P-RELATED', 249755),
(397085, 'PTHR24276:SF91', NULL, NULL, NULL, NULL, 'AT26814P-RELATED', 249755),
(397086, 'PTHR24276:SF97', NULL, NULL, NULL, NULL, 'GH13245P2-RELATED', 249755);
INSERT INTO "PUBLIC"."MODEL" VALUES
(397087, 'PTHR24276:SF98', NULL, NULL, NULL, NULL, 'FI18310P1-RELATED', 249755),
(397088, 'PTHR24276:SF95', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 249755),
(397089, 'PTHR24276:SF62', NULL, NULL, NULL, NULL, 'POLYSERASE-2', 249755),
(397090, 'PTHR24276:SF96', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 249755),
(397091, 'PTHR24276', NULL, NULL, NULL, NULL, 'POLYSERASE-RELATED', 249755),
(397092, 'PTHR16435:SF6', NULL, NULL, NULL, NULL, 'IP09370P', 249756),
(397093, 'PTHR16435:SF5', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS ASSOCIATED 6-LIKE PROTEIN', 249756),
(397094, 'PTHR16435:SF3', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 6', 249756),
(397095, 'PTHR16435', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 6 SPATA6', 249756),
(397096, 'PTHR22696:SF2', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 249757),
(397097, 'PTHR22696', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF26', 249757),
(397098, 'PTHR22696:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF26', 249757),
(397099, 'PTHR46505', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE NAD-BINDING DOMAIN-CONTAINING PROTEIN 1', 249758),
(397100, 'PTHR46505:SF1', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE NAD-BINDING DOMAIN-CONTAINING PROTEIN 1', 249758),
(397101, 'PTHR44843', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 249759),
(397102, 'PTHR44843:SF2', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 249759),
(397103, 'PTHR44843:SF7', NULL, NULL, NULL, NULL, '', 249759),
(397104, 'PTHR44843:SF14', NULL, NULL, NULL, NULL, 'METHYLTRANSF_21 DOMAIN-CONTAINING PROTEIN', 249759),
(397105, 'PTHR44843:SF13', NULL, NULL, NULL, NULL, '', 249759),
(397106, 'PTHR44843:SF12', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASE-RELATED', 249759),
(397107, 'PTHR44843:SF11', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASE-RELATED', 249759),
(397108, 'PTHR44843:SF8', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE DOMAIN PROTEIN', 249759),
(397109, 'PTHR23133:SF2', NULL, NULL, NULL, NULL, 'IMIDAZOLEGLYCEROL-PHOSPHATE DEHYDRATASE', 249760),
(397110, 'PTHR23133', NULL, NULL, NULL, NULL, 'IMIDAZOLEGLYCEROL-PHOSPHATE DEHYDRATASE HIS7', 249760),
(397111, 'PTHR23133:SF5', NULL, NULL, NULL, NULL, 'IMIDAZOLEGLYCEROL-PHOSPHATE DEHYDRATASE', 249760),
(397112, 'PTHR47638', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE 5A-LIKE', 249761),
(397113, 'PTHR47638:SF2', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE 5A-LIKE', 249761),
(397114, 'PTHR10394:SF3', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S8', 249762),
(397115, 'PTHR10394:SF29', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S8', 249762),
(397116, 'PTHR10394:SF28', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S8', 249762),
(397117, 'PTHR10394:SF27', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S8', 249762),
(397118, 'PTHR10394:SF19', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S8', 249762),
(397119, 'PTHR10394:SF21', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S8', 249762),
(397120, 'PTHR10394:SF32', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S8', 249762),
(397121, 'PTHR10394:SF31', NULL, NULL, NULL, NULL, '', 249762),
(397122, 'PTHR10394:SF30', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S8', 249762),
(397123, 'PTHR10394:SF14', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S8', 249762),
(397124, 'PTHR10394:SF24', NULL, NULL, NULL, NULL, 'CMV 1A INTERACTING PROTEIN 1', 249762),
(397125, 'PTHR10394:SF12', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S8', 249762),
(397126, 'PTHR10394:SF23', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S8', 249762),
(397127, 'PTHR10394:SF22', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S8', 249762),
(397128, 'PTHR10394', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S8', 249762),
(397129, 'PTHR36747', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 249763),
(397130, 'PTHR36747:SF1', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 249763);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(397131, 'PTHR15026:SF0', NULL, NULL, NULL, NULL, 'GUIDED ENTRY OF TAIL-ANCHORED PROTEINS FACTOR CAMLG', 249764),
(397132, 'PTHR15026', NULL, NULL, NULL, NULL, 'CALCIUM-SIGNAL MODULATING CYCLOPHILIN LIGAND  CAML', 249764),
(397133, 'PTHR11824', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL BETA SUBUNIT', 249765),
(397134, 'PTHR11824:SF9', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT L-TYPE CALCIUM CHANNEL SUBUNIT BETA-2', 249765),
(397135, 'PTHR11824:SF8', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT L-TYPE CALCIUM CHANNEL SUBUNIT BETA-3', 249765),
(397136, 'PTHR11824:SF7', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT L-TYPE CALCIUM CHANNEL SUBUNIT BETA-4', 249765),
(397137, 'PTHR11824:SF10', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-CONTAINING PROTEIN', 249765),
(397138, 'PTHR11824:SF11', NULL, NULL, NULL, NULL, 'CALCIUM CHANNEL, VOLTAGE-DEPENDENT, BETA 2B', 249765),
(397139, 'PTHR11824:SF5', NULL, NULL, NULL, NULL, 'CA2+-CHANNEL-PROTEIN-BETA-SUBUNIT, ISOFORM L', 249765),
(397140, 'PTHR11824:SF17', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT L-TYPE CALCIUM CHANNEL SUBUNIT BETA-1', 249765),
(397141, 'PTHR11824:SF15', NULL, NULL, NULL, NULL, 'CALCIUM CHANNEL, VOLTAGE-DEPENDENT, BETA 4B SUBUNIT', 249765),
(397142, 'PTHR37981', NULL, NULL, NULL, NULL, 'LIPASE 2', 249766),
(397143, 'PTHR37981:SF1', NULL, NULL, NULL, NULL, 'SGNH_HYDRO DOMAIN-CONTAINING PROTEIN', 249766),
(397144, 'PTHR22652:SF0', NULL, NULL, NULL, NULL, 'NUCLEOPORIN NUP43', 249767),
(397145, 'PTHR22652', NULL, NULL, NULL, NULL, 'NUCLEOPORIN NUP43', 249767),
(397146, 'PTHR37819:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PSIE', 249768),
(397147, 'PTHR37819', NULL, NULL, NULL, NULL, 'PROTEIN PSIE', 249768),
(397148, 'PTHR10853:SF3', NULL, NULL, NULL, NULL, 'EUKARYOTIC RELEASE FACTOR 1 (ERF1) FAMILY PROTEIN', 249769),
(397149, 'PTHR10853:SF0', NULL, NULL, NULL, NULL, 'PROTEIN PELOTA HOMOLOG', 249769),
(397150, 'PTHR10853', NULL, NULL, NULL, NULL, 'PELOTA', 249769),
(397151, 'PTHR10853:SF8', NULL, NULL, NULL, NULL, 'PROTEIN PELOTA HOMOLOG', 249769),
(397152, 'PTHR10853:SF6', NULL, NULL, NULL, NULL, 'PROTEIN PELOTA HOMOLOG', 249769),
(397153, 'PTHR10853:SF5', NULL, NULL, NULL, NULL, 'PROTEIN PELOTA HOMOLOG', 249769),
(397154, 'PTHR45138:SF25', NULL, NULL, NULL, NULL, 'GGDEF DOMAIN PROTEIN', 249770),
(397155, 'PTHR45138:SF9', NULL, NULL, NULL, NULL, 'DIGUANYLATE CYCLASE DGCM-RELATED', 249770),
(397156, 'PTHR45138:SF24', NULL, NULL, NULL, NULL, 'DIGUANYLATE CYCLASE DGCC-RELATED', 249770),
(397157, 'PTHR45138:SF6', NULL, NULL, NULL, NULL, 'DIGUANYLATE CYCLASE DGCN', 249770),
(397158, 'PTHR45138:SF16', NULL, NULL, NULL, NULL, 'DIGUANYLATE CYCLASE DGCQ-RELATED', 249770),
(397159, 'PTHR45138:SF26', NULL, NULL, NULL, NULL, 'DIGUANYLATE CYCLASE', 249770),
(397160, 'PTHR45138:SF5', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL PERIPLASMIC SUBSTRATE BINDING PROTEIN/CYTOPLASMIC DIGUANYLATE CYCLASE', 249770),
(397161, 'PTHR45138:SF23', NULL, NULL, NULL, NULL, 'SIGNALING PROTEIN-RELATED', 249770),
(397162, 'PTHR45138', NULL, NULL, NULL, NULL, 'REGULATORY COMPONENTS OF SENSORY TRANSDUCTION SYSTEM', 249770),
(397163, 'PTHR45138:SF2', NULL, NULL, NULL, NULL, 'DIGUANYLATE CYCLASE VDCA', 249770),
(397164, 'PTHR45138:SF22', NULL, NULL, NULL, NULL, 'DIGUANYLATE CYCLASE DGCJ-RELATED', 249770),
(397165, 'PTHR37240', NULL, NULL, NULL, NULL, 'PREPROTEIN TRANSLOCASE SUBUNIT SECE1', 249771),
(397166, 'PTHR37240:SF1', NULL, NULL, NULL, NULL, 'PREPROTEIN TRANSLOCASE SUBUNIT SECE1', 249771),
(397167, 'PTHR46532:SF4', NULL, NULL, NULL, NULL, 'DYNEIN HEAVY CHAIN 8, AXONEMAL-LIKE PROTEIN', 249772),
(397168, 'PTHR46532:SF14', NULL, NULL, NULL, NULL, 'MALE FERTILITY FACTOR KL5', 249772),
(397169, 'PTHR46532:SF11', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL HEAVY CHAIN 12', 249772),
(397170, 'PTHR46532', NULL, NULL, NULL, NULL, 'MALE FERTILITY FACTOR KL5', 249772),
(397171, 'PTHR46532:SF13', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL HEAVY CHAIN 5', 249772),
(397172, 'PTHR14899:SF0', NULL, NULL, NULL, NULL, 'G KINASE-ANCHORING PROTEIN 1', 249773),
(397173, 'PTHR14899', NULL, NULL, NULL, NULL, 'G KINASE ANCHORING PROTEIN 1', 249773);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(397174, 'PTHR38030:SF2', NULL, NULL, NULL, NULL, 'PROTOPORPHYRINOGEN IX DEHYDROGENASE [QUINONE]', 249774),
(397175, 'PTHR38030', NULL, NULL, NULL, NULL, 'PROTOPORPHYRINOGEN IX DEHYDROGENASE [MENAQUINONE]', 249774),
(397176, 'PTHR44272:SF5', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ 39', 249775),
(397177, 'PTHR44272:SF2', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ 16', 249775),
(397178, 'PTHR44272:SF3', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 249775),
(397179, 'PTHR44272:SF1', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ 16', 249775),
(397180, 'PTHR44272', NULL, NULL, NULL, NULL, 'DNAJ DOMAIN (PROKARYOTIC HEAT SHOCK PROTEIN)', 249775),
(397181, 'PTHR44272:SF8', NULL, NULL, NULL, NULL, 'DNAJ DOMAIN-CONTAINING PROTEIN-RELATED', 249775),
(397182, 'PTHR44272:SF9', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 249775),
(397183, 'PTHR44272:SF6', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ 15-LIKE', 249775),
(397184, 'PTHR44272:SF10', NULL, NULL, NULL, NULL, 'DNAJ DOMAIN-CONTAINING PROTEIN-RELATED', 249775),
(397185, 'PTHR44272:SF7', NULL, NULL, NULL, NULL, 'BNAANNG10480D PROTEIN', 249775),
(397186, 'PTHR46816:SF11', NULL, NULL, NULL, NULL, 'OS03G0304500 PROTEIN', 249776),
(397187, 'PTHR46816:SF8', NULL, NULL, NULL, NULL, 'DNAJ DOMAIN, N-TERMINAL ACETYLTRANSFERASE A, AUXILIARY SUBUNIT-RELATED', 249776),
(397188, 'PTHR46816', NULL, NULL, NULL, NULL, 'OS01G0273500 PROTEIN', 249776),
(397189, 'PTHR46816:SF1', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 249776),
(397190, 'PTHR46816:SF3', NULL, NULL, NULL, NULL, 'T14P4.7 PROTEIN', 249776),
(397191, 'PTHR46816:SF2', NULL, NULL, NULL, NULL, '', 249776),
(397192, 'PTHR46816:SF5', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 249776),
(397193, 'PTHR46816:SF7', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 249776),
(397194, 'PTHR43542:SF1', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 249777),
(397195, 'PTHR43542', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 249777),
(397196, 'PTHR46910:SF8', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249778),
(397197, 'PTHR46910:SF7', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249778),
(397198, 'PTHR46910:SF5', NULL, NULL, NULL, NULL, 'MISCELLANEOUS ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249778),
(397199, 'PTHR46910:SF9', NULL, NULL, NULL, NULL, 'MISCELLANEOUS ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)', 249778),
(397200, 'PTHR46910:SF23', NULL, NULL, NULL, NULL, 'THIAMINE REPRESSIBLE GENES REGULATORY PROTEIN THI1', 249778),
(397201, 'PTHR46910:SF4', NULL, NULL, NULL, NULL, 'ZN(2)-C6 FUNGAL-TYPE DOMAIN-CONTAINING PROTEIN', 249778),
(397202, 'PTHR46910:SF3', NULL, NULL, NULL, NULL, 'HALOTOLERANCE PROTEIN 9-RELATED', 249778),
(397203, 'PTHR46910:SF2', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249778),
(397204, 'PTHR46910:SF1', NULL, NULL, NULL, NULL, 'FUNGAL_TRANS DOMAIN-CONTAINING PROTEIN', 249778),
(397205, 'PTHR46910:SF20', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249778),
(397206, 'PTHR46910:SF29', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN C16G5.16-RELATED', 249778),
(397207, 'PTHR46910:SF25', NULL, NULL, NULL, NULL, 'ABC-TRANSPORTER-REGULATING TRANSCRIPTION FACTOR-RELATED', 249778),
(397208, 'PTHR46910', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PDR1', 249778),
(397209, 'PTHR46910:SF32', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249778),
(397210, 'PTHR46910:SF11', NULL, NULL, NULL, NULL, 'FUNGAL_TRANS DOMAIN-CONTAINING PROTEIN', 249778),
(397211, 'PTHR46910:SF33', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, PUTATIVE-RELATED', 249778),
(397212, 'PTHR46910:SF12', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN CAT8', 249778),
(397213, 'PTHR46910:SF34', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249778),
(397214, 'PTHR46910:SF13', NULL, NULL, NULL, NULL, 'SPECIFIC TRANSCRIPTION FACTOR, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G06190)-RELATED', 249778); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(397215, 'PTHR46910:SF35', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT BETA', 249778),
(397216, 'PTHR46910:SF30', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249778),
(397217, 'PTHR46910:SF31', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249778),
(397218, 'PTHR46910:SF18', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249778),
(397219, 'PTHR46910:SF14', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249778),
(397220, 'PTHR46910:SF15', NULL, NULL, NULL, NULL, 'PRNA PROTEIN-RELATED', 249778),
(397221, 'PTHR46910:SF17', NULL, NULL, NULL, NULL, 'SCFA', 249778),
(397222, 'PTHR35192', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 249779),
(397223, 'PTHR35192:SF2', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 249779),
(397224, 'PTHR31860:SF9', NULL, NULL, NULL, NULL, 'HEAT-INDUCIBLE TRANSCRIPTION REPRESSOR (DUF639)', 249780),
(397225, 'PTHR31860:SF11', NULL, NULL, NULL, NULL, '', 249780),
(397226, 'PTHR31860:SF15', NULL, NULL, NULL, NULL, '', 249780),
(397227, 'PTHR31860:SF12', NULL, NULL, NULL, NULL, '', 249780),
(397228, 'PTHR31860:SF6', NULL, NULL, NULL, NULL, 'HEAT-INDUCIBLE TRANSCRIPTION REPRESSOR (DUF639)', 249780),
(397229, 'PTHR31860:SF18', NULL, NULL, NULL, NULL, 'BNAA04G12410D PROTEIN', 249780),
(397230, 'PTHR31860:SF19', NULL, NULL, NULL, NULL, 'OS04G0677400 PROTEIN', 249780),
(397231, 'PTHR31860:SF5', NULL, NULL, NULL, NULL, 'ARGH (DUF639)', 249780),
(397232, 'PTHR31860:SF16', NULL, NULL, NULL, NULL, '', 249780),
(397233, 'PTHR31860:SF4', NULL, NULL, NULL, NULL, 'OS02G0637800 PROTEIN', 249780),
(397234, 'PTHR31860', NULL, NULL, NULL, NULL, 'HEAT-INDUCIBLE TRANSCRIPTION REPRESSOR (DUF639)-RELATED', 249780),
(397235, 'PTHR31860:SF3', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF639)-RELATED', 249780),
(397236, 'PTHR10801', NULL, NULL, NULL, NULL, '24-DEHYDROCHOLESTEROL REDUCTASE', 249781),
(397237, 'PTHR10801:SF18', NULL, NULL, NULL, NULL, 'DELTA(24)-STEROL REDUCTASE', 249781),
(397238, 'PTHR10801:SF19', NULL, NULL, NULL, NULL, 'DELTA(24)-STEROL REDUCTASE', 249781),
(397239, 'PTHR10801:SF0', NULL, NULL, NULL, NULL, 'DELTA(24)-STEROL REDUCTASE', 249781),
(397240, 'PTHR10801:SF12', NULL, NULL, NULL, NULL, 'DELTA(24)-STEROL REDUCTASE', 249781),
(397241, 'PTHR10801:SF10', NULL, NULL, NULL, NULL, 'DELTA(24)-STEROL REDUCTASE', 249781),
(397242, 'PTHR10801:SF2', NULL, NULL, NULL, NULL, 'DELTA(24)-STEROL REDUCTASE', 249781),
(397243, 'PTHR10801:SF11', NULL, NULL, NULL, NULL, 'DELTA(24)-STEROL REDUCTASE-LIKE', 249781),
(397244, 'PTHR10801:SF17', NULL, NULL, NULL, NULL, 'DELTA(24)-STEROL REDUCTASE', 249781),
(397245, 'PTHR10801:SF14', NULL, NULL, NULL, NULL, 'BNAC06G03470D PROTEIN', 249781),
(397246, 'PTHR10801:SF15', NULL, NULL, NULL, NULL, 'DELTA(24)-STEROL REDUCTASE', 249781),
(397247, 'PTHR43219', NULL, NULL, NULL, NULL, 'CRISPR-ASSOCIATED ENDONUCLEASE CAS1', 249782),
(397248, 'PTHR43219:SF2', NULL, NULL, NULL, NULL, 'CRISPR-ASSOCIATED ENDONUCLEASE CAS1', 249782),
(397249, 'PTHR43219:SF1', NULL, NULL, NULL, NULL, 'CRISPR-ASSOCIATED ENDONUCLEASE CAS1', 249782),
(397250, 'PTHR43029:SF40', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER', 249783),
(397251, 'PTHR43029:SF4', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER MEP1-RELATED', 249783),
(397252, 'PTHR43029', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER MEP2', 249783),
(397253, 'PTHR43029:SF3', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER 3', 249783),
(397254, 'PTHR43029:SF9', NULL, NULL, NULL, NULL, 'SIMILAR TO AMMONIUM PERMEASE, BUT NOT NORMALLY ACTIVE (EUROFUNG)', 249783),
(397255, 'PTHR43029:SF8', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER 3 MEMBER 3', 249783),
(397256, 'PTHR43029:SF7', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER 2 MEMBER 5', 249783),
(397257, 'PTHR43029:SF38', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER 2', 249783),
(397258, 'PTHR43029:SF27', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER 2 MEMBER 3', 249783),
(397259, 'PTHR43029:SF17', NULL, NULL, NULL, NULL, 'TRANSPORTER 2, PUTATIVE-RELATED', 249783);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(397260, 'PTHR43029:SF39', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER', 249783),
(397261, 'PTHR43029:SF28', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER 2 MEMBER 4', 249783),
(397262, 'PTHR43029:SF36', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER 2 MEMBER 2', 249783),
(397263, 'PTHR43029:SF15', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER', 249783),
(397264, 'PTHR43029:SF37', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER 2', 249783),
(397265, 'PTHR43029:SF24', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER 2 MEMBER 3', 249783),
(397266, 'PTHR43029:SF10', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER MEP2', 249783),
(397267, 'PTHR43029:SF32', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER', 249783),
(397268, 'PTHR43029:SF2', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER 3 MEMBER 2', 249783),
(397269, 'PTHR43029:SF21', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER 1', 249783),
(397270, 'PTHR43029:SF1', NULL, NULL, NULL, NULL, 'AMMONIUM_TRANSP DOMAIN-CONTAINING PROTEIN', 249783),
(397271, 'PTHR43029:SF11', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER', 249783),
(397272, 'PTHR43029:SF30', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER', 249783),
(397273, 'PTHR43029:SF31', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER, AMMONIUM/UREA TRANSPORTER-RELATED', 249783),
(397274, 'PTHR41394:SF7', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER MGTE FAMILY', 249784),
(397275, 'PTHR41394:SF5', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER', 249784),
(397276, 'PTHR41394', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER MGTE', 249784),
(397277, 'PTHR13832:SF827', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C-LIKE DOMAIN-CONTAINING PROTEIN 1', 249785),
(397278, 'PTHR13832:SF826', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 2-RELATED', 249785),
(397279, 'PTHR13832:SF825', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 10 ISOFORM X1-RELATED', 249785),
(397280, 'PTHR13832:SF824', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 249785),
(397281, 'PTHR13832:SF703', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 40-RELATED', 249785),
(397282, 'PTHR13832:SF823', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 249785),
(397283, 'PTHR13832:SF305', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1J', 249785),
(397284, 'PTHR13832:SF822', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 249785),
(397285, 'PTHR13832:SF668', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 39-RELATED', 249785),
(397286, 'PTHR13832:SF667', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 14-RELATED', 249785),
(397287, 'PTHR13832:SF821', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 9-RELATED', 249785),
(397288, 'PTHR13832:SF820', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 249785),
(397289, 'PTHR13832:SF709', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 36-RELATED', 249785),
(397290, 'PTHR13832:SF829', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C', 249785),
(397291, 'PTHR13832:SF707', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 23-RELATED', 249785),
(397292, 'PTHR13832:SF828', NULL, NULL, NULL, NULL, '[PYRUVATE DEHYDROGENASE [ACETYL-TRANSFERRING]]-PHOSPHATASE 2, MITOCHONDRIAL', 249785),
(397293, 'PTHR13832:SF301', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 29', 249785),
(397294, 'PTHR13832:SF785', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 249785),
(397295, 'PTHR13832:SF541', NULL, NULL, NULL, NULL, 'PHOSPHATASE 2C, PUTATIVE-RELATED', 249785),
(397296, 'PTHR13832:SF662', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 55-RELATED', 249785),
(397297, 'PTHR13832:SF385', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 58-RELATED', 249785),
(397298, 'PTHR13832:SF781', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE, MG2+/MN2+-DEPENDENT, 1LA', 249785),
(397299, 'PTHR13832:SF386', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 249785),
(397300, 'PTHR13832:SF816', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C HOMOLOG 3', 249785),
(397301, 'PTHR13832:SF815', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 249785);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(397302, 'PTHR13832:SF814', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1L', 249785),
(397303, 'PTHR13832:SF659', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 7-RELATED', 249785),
(397304, 'PTHR13832:SF779', NULL, NULL, NULL, NULL, 'SI:CH211-15P9.2', 249785),
(397305, 'PTHR13832:SF657', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 249785),
(397306, 'PTHR13832:SF535', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1E', 249785),
(397307, 'PTHR13832:SF810', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 249785),
(397308, 'PTHR13832:SF777', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 249785),
(397309, 'PTHR13832:SF534', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE DDB_G0279461-RELATED', 249785),
(397310, 'PTHR13832:SF819', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 35-RELATED', 249785),
(397311, 'PTHR13832:SF818', NULL, NULL, NULL, NULL, 'SD03870P', 249785),
(397312, 'PTHR13832:SF817', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 249785),
(397313, 'PTHR13832:SF533', NULL, NULL, NULL, NULL, 'TGF-BETA-ACTIVATED KINASE 1 AND MAP3K7-BINDING PROTEIN 1', 249785),
(397314, 'PTHR13832:SF531', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 54-RELATED', 249785),
(397315, 'PTHR13832:SF770', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 249785),
(397316, 'PTHR13832:SF803', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1G', 249785),
(397317, 'PTHR13832:SF802', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT FAMILY PROTEIN', 249785),
(397318, 'PTHR13832:SF768', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C MEMBER 13, MITOCHONDRIAL-RELATED', 249785),
(397319, 'PTHR13832:SF765', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 17-RELATED', 249785),
(397320, 'PTHR13832:SF808', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 23-RELATED', 249785),
(397321, 'PTHR13832:SF643', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN-CONTAINING PROTEIN-RELATED', 249785),
(397322, 'PTHR13832:SF641', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 47-RELATED', 249785),
(397323, 'PTHR13832', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C', 249785),
(397324, 'PTHR13832:SF762', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 249785),
(397325, 'PTHR13832:SF760', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 42-RELATED', 249785),
(397326, 'PTHR13832:SF758', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 30-RELATED', 249785),
(397327, 'PTHR13832:SF636', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 249785),
(397328, 'PTHR13832:SF756', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 249785),
(397329, 'PTHR13832:SF754', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 249785),
(397330, 'PTHR13832:SF752', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 249785),
(397331, 'PTHR13832:SF631', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 21-RELATED', 249785),
(397332, 'PTHR13832:SF236', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1M', 249785),
(397333, 'PTHR13832:SF354', NULL, NULL, NULL, NULL, 'GM14138P', 249785),
(397334, 'PTHR13832:SF233', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1F', 249785),
(397335, 'PTHR13832:SF351', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 46-RELATED', 249785),
(397336, 'PTHR13832:SF627', NULL, NULL, NULL, NULL, '[PYRUVATE DEHYDROGENASE [ACETYL-TRANSFERRING]]-PHOSPHATASE 1, MITOCHONDRIAL', 249785),
(397337, 'PTHR13832:SF748', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE, MG2+/MN2+-DEPENDENT, 1LB', 249785),
(397338, 'PTHR13832:SF349', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 31-RELATED', 249785),
(397339, 'PTHR13832:SF746', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 249785),
(397340, 'PTHR13832:SF228', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 4-RELATED', 249785),
(397341, 'PTHR13832:SF589', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 57', 249785),
(397342, 'PTHR13832:SF580', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 70-RELATED', 249785),
(397343, 'PTHR13832:SF741', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE FEM-2', 249785);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(397344, 'PTHR13832:SF620', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 13-RELATED', 249785),
(397345, 'PTHR13832:SF343', NULL, NULL, NULL, NULL, '[PYRUVATE DEHYDROGENASE [ACETYL-TRANSFERRING]]-PHOSPHATASE 2, MITOCHONDRIAL', 249785),
(397346, 'PTHR13832:SF737', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 23-RELATED', 249785),
(397347, 'PTHR13832:SF736', NULL, NULL, NULL, NULL, '', 249785),
(397348, 'PTHR13832:SF734', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 249785),
(397349, 'PTHR13832:SF699', NULL, NULL, NULL, NULL, 'INTEGRIN-LINKED KINASE-ASSOCIATED SERINE/THREONINE PHOSPHATASE 2C', 249785),
(397350, 'PTHR13832:SF619', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 249785),
(397351, 'PTHR13832:SF291', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 249785),
(397352, 'PTHR13832:SF731', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 249785),
(397353, 'PTHR13832:SF851', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 249785),
(397354, 'PTHR13832:SF850', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 249785),
(397355, 'PTHR13832:SF849', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE, MG2+/MN2+-DEPENDENT, 1J', 249785),
(397356, 'PTHR13832:SF848', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 249785),
(397357, 'PTHR13832:SF726', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 23-RELATED', 249785),
(397358, 'PTHR13832:SF847', NULL, NULL, NULL, NULL, 'PHOSPHATASE 2C, PUTATIVE-RELATED', 249785),
(397359, 'PTHR13832:SF846', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 249785),
(397360, 'PTHR13832:SF845', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 249785),
(397361, 'PTHR13832:SF327', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 74-RELATED', 249785),
(397362, 'PTHR13832:SF723', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 10-RELATED', 249785),
(397363, 'PTHR13832:SF844', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 29', 249785),
(397364, 'PTHR13832:SF843', NULL, NULL, NULL, NULL, 'PHOSPHATASE 2C, PUTATIVE-RELATED', 249785),
(397365, 'PTHR13832:SF842', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 76-RELATED', 249785),
(397366, 'PTHR13832:SF688', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 32', 249785),
(397367, 'PTHR13832:SF841', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 249785),
(397368, 'PTHR13832:SF840', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 60-RELATED', 249785),
(397369, 'PTHR13832:SF565', NULL, NULL, NULL, NULL, 'AT28366P-RELATED', 249785),
(397370, 'PTHR13832:SF684', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 27-RELATED', 249785),
(397371, 'PTHR13832:SF165', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 49-RELATED', 249785),
(397372, 'PTHR13832:SF287', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1H', 249785),
(397373, 'PTHR13832:SF680', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 44-RELATED', 249785),
(397374, 'PTHR13832:SF285', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 22-RELATED', 249785),
(397375, 'PTHR13832:SF838', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1H', 249785),
(397376, 'PTHR13832:SF837', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C HOMOLOG 1', 249785),
(397377, 'PTHR13832:SF836', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 249785),
(397378, 'PTHR13832:SF835', NULL, NULL, NULL, NULL, 'PPM-TYPE PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 249785),
(397379, 'PTHR13832:SF834', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 249785),
(397380, 'PTHR13832:SF559', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 2-RELATED', 249785),
(397381, 'PTHR13832:SF833', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C-LIKE PROTEIN', 249785),
(397382, 'PTHR13832:SF832', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 249785),
(397383, 'PTHR13832:SF710', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 249785),
(397384, 'PTHR13832:SF831', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 249785);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(397385, 'PTHR13832:SF839', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 249785),
(397386, 'PTHR13832:SF830', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C-LIKE PROTEIN', 249785),
(397387, 'PTHR13832:SF797', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE/THREONINE PHOSPHATASE', 249785),
(397388, 'PTHR13832:SF673', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 27-RELATED', 249785),
(397389, 'PTHR13832:SF793', NULL, NULL, NULL, NULL, 'PHOSPHATASE 2C, PUTATIVE-RELATED', 249785),
(397390, 'PTHR13832:SF671', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 66-RELATED', 249785),
(397391, 'PTHR13832:SF792', NULL, NULL, NULL, NULL, 'GM14286P', 249785),
(397392, 'PTHR13832:SF550', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 40-RELATED', 249785),
(397393, 'PTHR13832:SF790', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C 22-RELATED', 249785),
(397394, 'PTHR34950:SF13', NULL, NULL, NULL, NULL, '', 249786),
(397395, 'PTHR34950:SF1', NULL, NULL, NULL, NULL, 'OS04G0457400 PROTEIN', 249786),
(397396, 'PTHR34950:SF11', NULL, NULL, NULL, NULL, 'BNACNNG62910D PROTEIN', 249786),
(397397, 'PTHR34950:SF2', NULL, NULL, NULL, NULL, 'BNAC01G00560D PROTEIN', 249786),
(397398, 'PTHR34950:SF12', NULL, NULL, NULL, NULL, '', 249786),
(397399, 'PTHR34950:SF4', NULL, NULL, NULL, NULL, 'BNAA09G42820D PROTEIN', 249786),
(397400, 'PTHR34950:SF5', NULL, NULL, NULL, NULL, 'BNAA04G12630D PROTEIN', 249786),
(397401, 'PTHR34950:SF7', NULL, NULL, NULL, NULL, '', 249786),
(397402, 'PTHR34950:SF8', NULL, NULL, NULL, NULL, '', 249786),
(397403, 'PTHR34950:SF10', NULL, NULL, NULL, NULL, 'OS10G0364900 PROTEIN', 249786),
(397404, 'PTHR34950', NULL, NULL, NULL, NULL, 'OS04G0457400 PROTEIN', 249786),
(397405, 'PTHR36910:SF8', NULL, NULL, NULL, NULL, '', 249787),
(397406, 'PTHR36910:SF3', NULL, NULL, NULL, NULL, 'VARIABLE CHARGE X-LINKED PROTEIN 3B', 249787),
(397407, 'PTHR36910', NULL, NULL, NULL, NULL, '', 249787),
(397408, 'PTHR36910:SF12', NULL, NULL, NULL, NULL, '', 249787),
(397409, 'PTHR46132:SF9', NULL, NULL, NULL, NULL, 'DIGALACTOSYLDIACYLGLYCEROL SYNTHASE 2, CHLOROPLASTIC-LIKE', 249788),
(397410, 'PTHR46132:SF8', NULL, NULL, NULL, NULL, 'DIGALACTOSYLDIACYLGLYCEROL SYNTHASE', 249788),
(397411, 'PTHR46132:SF7', NULL, NULL, NULL, NULL, 'SYNTHASE 2, PUTATIVE, EXPRESSED-RELATED', 249788),
(397412, 'PTHR46132:SF6', NULL, NULL, NULL, NULL, 'DIGALACTOSYLDIACYLGLYCEROL SYNTHASE 1, CHLOROPLASTIC', 249788),
(397413, 'PTHR46132:SF5', NULL, NULL, NULL, NULL, 'DIGALACTOSYLDIACYLGLYCEROL SYNTHASE', 249788),
(397414, 'PTHR46132', NULL, NULL, NULL, NULL, 'DIGALACTOSYLDIACYLGLYCEROL SYNTHASE 2, CHLOROPLASTIC', 249788),
(397415, 'PTHR46132:SF2', NULL, NULL, NULL, NULL, 'DIGALACTOSYLDIACYLGLYCEROL SYNTHASE', 249788),
(397416, 'PTHR46132:SF1', NULL, NULL, NULL, NULL, 'DIGALACTOSYLDIACYLGLYCEROL SYNTHASE 2, CHLOROPLASTIC', 249788),
(397417, 'PTHR34572:SF11', NULL, NULL, NULL, NULL, '', 249789),
(397418, 'PTHR34572:SF1', NULL, NULL, NULL, NULL, 'GOLGIN FAMILY A PROTEIN', 249789),
(397419, 'PTHR34572:SF2', NULL, NULL, NULL, NULL, 'OS09G0284300 PROTEIN', 249789),
(397420, 'PTHR34572:SF10', NULL, NULL, NULL, NULL, '', 249789),
(397421, 'PTHR34572:SF9', NULL, NULL, NULL, NULL, 'BNAA03G11500D PROTEIN', 249789),
(397422, 'PTHR34572:SF8', NULL, NULL, NULL, NULL, 'BNAC09G31710D PROTEIN', 249789),
(397423, 'PTHR34572', NULL, NULL, NULL, NULL, 'GOLGIN FAMILY A PROTEIN', 249789),
(397424, 'PTHR12002:SF206', NULL, NULL, NULL, NULL, 'CLAUDIN 34A', 249790),
(397425, 'PTHR12002:SF207', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED MULTIPASS TRANSMEMBRANE PROTEIN 3', 249790),
(397426, 'PTHR12002:SF203', NULL, NULL, NULL, NULL, 'CLAUDIN-3', 249790),
(397427, 'PTHR12002:SF200', NULL, NULL, NULL, NULL, 'CLAUDIN', 249790),
(397428, 'PTHR12002:SF35', NULL, NULL, NULL, NULL, 'CLAUDIN-5', 249790),
(397429, 'PTHR12002:SF78', NULL, NULL, NULL, NULL, 'CLAUDIN-7', 249790),
(397430, 'PTHR12002:SF208', NULL, NULL, NULL, NULL, 'CLAUDIN', 249790),
(397431, 'PTHR12002:SF76', NULL, NULL, NULL, NULL, 'GENE, EG434881-RELATED', 249790),
(397432, 'PTHR12002:SF32', NULL, NULL, NULL, NULL, 'CLAUDIN', 249790);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(397433, 'PTHR12002:SF209', NULL, NULL, NULL, NULL, 'CLAUDIN', 249790),
(397434, 'PTHR12002:SF75', NULL, NULL, NULL, NULL, 'CLAUDIN-17', 249790),
(397435, 'PTHR12002:SF74', NULL, NULL, NULL, NULL, 'CLAUDIN-15', 249790),
(397436, 'PTHR12002', NULL, NULL, NULL, NULL, 'CLAUDIN', 249790),
(397437, 'PTHR12002:SF110', NULL, NULL, NULL, NULL, 'CLAUDIN-2', 249790),
(397438, 'PTHR12002:SF194', NULL, NULL, NULL, NULL, 'CLAUDIN', 249790),
(397439, 'PTHR12002:SF192', NULL, NULL, NULL, NULL, 'CLAUDIN-RELATED', 249790),
(397440, 'PTHR12002:SF116', NULL, NULL, NULL, NULL, 'CLAUDIN', 249790),
(397441, 'PTHR12002:SF115', NULL, NULL, NULL, NULL, 'CLAUDIN', 249790),
(397442, 'PTHR12002:SF112', NULL, NULL, NULL, NULL, 'CLAUDIN-3', 249790),
(397443, 'PTHR12002:SF27', NULL, NULL, NULL, NULL, 'CLAUDIN-19', 249790),
(397444, 'PTHR12002:SF24', NULL, NULL, NULL, NULL, 'CLAUDIN-8', 249790),
(397445, 'PTHR12002:SF185', NULL, NULL, NULL, NULL, 'CLAUDIN', 249790),
(397446, 'PTHR12002:SF184', NULL, NULL, NULL, NULL, 'CLAUDIN', 249790),
(397447, 'PTHR12002:SF181', NULL, NULL, NULL, NULL, 'CLAUDIN', 249790),
(397448, 'PTHR12002:SF182', NULL, NULL, NULL, NULL, 'SI:DKEY-221L4.11', 249790),
(397449, 'PTHR12002:SF108', NULL, NULL, NULL, NULL, 'CLAUDIN', 249790),
(397450, 'PTHR12002:SF102', NULL, NULL, NULL, NULL, 'CLAUDIN 34B1-RELATED', 249790),
(397451, 'PTHR12002:SF17', NULL, NULL, NULL, NULL, 'CLAUDIN-20', 249790),
(397452, 'PTHR12002:SF15', NULL, NULL, NULL, NULL, 'CLAUDIN', 249790),
(397453, 'PTHR12002:SF13', NULL, NULL, NULL, NULL, 'CLAUDIN-10', 249790),
(397454, 'PTHR12002:SF56', NULL, NULL, NULL, NULL, 'CLAUDIN-16', 249790),
(397455, 'PTHR12002:SF99', NULL, NULL, NULL, NULL, 'CLAUDIN-14', 249790),
(397456, 'PTHR12002:SF97', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED MULTIPASS TRANSMEMBRANE PROTEIN 2B', 249790),
(397457, 'PTHR12002:SF191', NULL, NULL, NULL, NULL, 'CLAUDIN', 249790),
(397458, 'PTHR12002:SF94', NULL, NULL, NULL, NULL, 'CLAUDIN 34D', 249790),
(397459, 'PTHR12002:SF93', NULL, NULL, NULL, NULL, 'CLAUDIN 34C1-RELATED', 249790),
(397460, 'PTHR12002:SF92', NULL, NULL, NULL, NULL, 'CLAUDIN-1', 249790),
(397461, 'PTHR12002:SF176', NULL, NULL, NULL, NULL, '', 249790),
(397462, 'PTHR12002:SF210', NULL, NULL, NULL, NULL, 'CLAUDIN', 249790),
(397463, 'PTHR12002:SF177', NULL, NULL, NULL, NULL, 'CLAUDIN-RELATED', 249790),
(397464, 'PTHR12002:SF174', NULL, NULL, NULL, NULL, 'CLAUDIN', 249790),
(397465, 'PTHR12002:SF171', NULL, NULL, NULL, NULL, 'CLAUDIN', 249790),
(397466, 'PTHR12002:SF211', NULL, NULL, NULL, NULL, 'CLAUDIN-24-RELATED', 249790),
(397467, 'PTHR12002:SF212', NULL, NULL, NULL, NULL, 'CLAUDIN-24-RELATED', 249790),
(397468, 'PTHR12002:SF3', NULL, NULL, NULL, NULL, 'CLAUDIN-23', 249790),
(397469, 'PTHR12002:SF4', NULL, NULL, NULL, NULL, 'CLAUDIN-34', 249790),
(397470, 'PTHR12002:SF6', NULL, NULL, NULL, NULL, 'CLAUDIN-11', 249790),
(397471, 'PTHR12002:SF89', NULL, NULL, NULL, NULL, 'CLAUDIN-4', 249790),
(397472, 'PTHR12002:SF87', NULL, NULL, NULL, NULL, 'CLAUDIN-25-RELATED', 249790),
(397473, 'PTHR12002:SF42', NULL, NULL, NULL, NULL, 'CLAUDIN-9', 249790),
(397474, 'PTHR12002:SF9', NULL, NULL, NULL, NULL, 'CLAUDIN-18', 249790),
(397475, 'PTHR12002:SF41', NULL, NULL, NULL, NULL, 'CLAUDIN-6', 249790),
(397476, 'PTHR12002:SF84', NULL, NULL, NULL, NULL, 'CLAUDIN-22', 249790),
(397477, 'PTHR12002:SF83', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED MULTIPASS TRANSMEMBRANE PROTEIN 4', 249790),
(397478, 'PTHR12002:SF81', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED MULTIPASS TRANSMEMBRANE PROTEIN 1-RELATED', 249790),
(397479, 'PTHR12955', NULL, NULL, NULL, NULL, 'SARCOMA ANTIGEN NY-SAR-95-RELATED', 249791),
(397480, 'PTHR12955:SF1', NULL, NULL, NULL, NULL, 'INTEGRATOR COMPLEX SUBUNIT 13', 249791),
(397481, 'PTHR14315:SF20', NULL, NULL, NULL, NULL, 'SIMILAR TO VERTEBRATE MID1 INTERACTING-LIKE PROTEIN', 249792),
(397482, 'PTHR14315:SF21', NULL, NULL, NULL, NULL, 'MID1-INTERACTING PROTEIN 1-LIKE', 249792),
(397483, 'PTHR14315', NULL, NULL, NULL, NULL, 'SPOT14 FAMILY MEMBER', 249792),
(397484, 'PTHR14315:SF16', NULL, NULL, NULL, NULL, 'MID1-INTERACTING PROTEIN 1', 249792);
INSERT INTO "PUBLIC"."MODEL" VALUES
(397485, 'PTHR14315:SF17', NULL, NULL, NULL, NULL, 'MIP21584P', 249792),
(397486, 'PTHR14315:SF18', NULL, NULL, NULL, NULL, 'THYROID HORMONE-INDUCIBLE HEPATIC PROTEIN', 249792),
(397487, 'PTHR14315:SF19', NULL, NULL, NULL, NULL, 'MID1-INTERACTING PROTEIN 1-B-RELATED', 249792),
(397488, 'PTHR11667', NULL, NULL, NULL, NULL, '', 249793),
(397489, 'PTHR11667:SF27', NULL, NULL, NULL, NULL, '', 249793),
(397490, 'PTHR13146:SF3', NULL, NULL, NULL, NULL, 'EAMA DOMAIN-CONTAINING PROTEIN', 249794),
(397491, 'PTHR13146:SF7', NULL, NULL, NULL, NULL, 'EAMA DOMAIN-CONTAINING PROTEIN', 249794),
(397492, 'PTHR13146:SF6', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN, PUTATIVE-RELATED', 249794),
(397493, 'PTHR13146:SF1', NULL, NULL, NULL, NULL, 'DRUG/METABOLITE TRANSPORTER DMT2', 249794),
(397494, 'PTHR13146:SF0', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 35 MEMBER F6', 249794),
(397495, 'PTHR13146', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 249794),
(397496, 'PTHR14983', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 249795),
(397497, 'PTHR14983:SF1', NULL, NULL, NULL, NULL, 'CILIOGENESIS AND PLANAR POLARITY EFFECTOR 2', 249795),
(397498, 'PTHR37003:SF2', NULL, NULL, NULL, NULL, 'ENDOTOXIN_N DOMAIN-CONTAINING PROTEIN', 249796),
(397499, 'PTHR37003', NULL, NULL, NULL, NULL, 'ENDOTOXIN_N DOMAIN-CONTAINING PROTEIN-RELATED', 249796),
(397500, 'PTHR37003:SF4', NULL, NULL, NULL, NULL, 'ENDOTOXIN_N DOMAIN-CONTAINING PROTEIN', 249796),
(397501, 'PTHR43648', NULL, NULL, NULL, NULL, 'ELECTRON TRANSFER FLAVOPROTEIN BETA SUBUNIT LYSINE METHYLTRANSFERASE', 249797),
(397502, 'PTHR43648:SF1', NULL, NULL, NULL, NULL, 'ELECTRON TRANSFER FLAVOPROTEIN BETA SUBUNIT LYSINE METHYLTRANSFERASE', 249797),
(397503, 'PTHR33969', NULL, NULL, NULL, NULL, 'SEGREGATION AND CONDENSATION PROTEIN A', 249798),
(397504, 'PTHR33969:SF2', NULL, NULL, NULL, NULL, 'SEGREGATION AND CONDENSATION PROTEIN A', 249798),
(397505, 'PTHR47140', NULL, NULL, NULL, NULL, 'MAP3K7 C-TERMINAL-LIKE PROTEIN', 249799),
(397506, 'PTHR47140:SF1', NULL, NULL, NULL, NULL, 'MAP3K7 C-TERMINAL-LIKE PROTEIN', 249799),
(397507, 'PTHR36774:SF1', NULL, NULL, NULL, NULL, 'INSULIN-INDUCED PROTEIN', 249800),
(397508, 'PTHR36774', NULL, NULL, NULL, NULL, 'INSULIN-INDUCED PROTEIN', 249800),
(397509, 'PTHR43331:SF1', NULL, NULL, NULL, NULL, 'HOMOSERINE DEHYDROGENASE', 249801),
(397510, 'PTHR43331', NULL, NULL, NULL, NULL, 'HOMOSERINE DEHYDROGENASE', 249801),
(397511, 'PTHR15430', NULL, NULL, NULL, NULL, 'GLOMULIN', 249802),
(397512, 'PTHR15430:SF1', NULL, NULL, NULL, NULL, 'GLOMULIN', 249802),
(397513, 'PTHR45890:SF7', NULL, NULL, NULL, NULL, 'OS07G0558000 PROTEIN', 249803),
(397514, 'PTHR45890:SF8', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 249803),
(397515, 'PTHR45890:SF16', NULL, NULL, NULL, NULL, 'ABC1 DOMAIN-CONTAINING PROTEIN', 249803),
(397516, 'PTHR45890:SF19', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE ABKC-RELATED', 249803),
(397517, 'PTHR45890:SF9', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249803),
(397518, 'PTHR45890', NULL, NULL, NULL, NULL, 'AARF DOMAIN CONTAINING KINASE 2 (PREDICTED)', 249803),
(397519, 'PTHR45890:SF20', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249803),
(397520, 'PTHR45890:SF3', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249803),
(397521, 'PTHR45890:SF21', NULL, NULL, NULL, NULL, 'PROTEIN KINASE-LIKE', 249803),
(397522, 'PTHR45890:SF22', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE ABKC-RELATED', 249803),
(397523, 'PTHR45890:SF1', NULL, NULL, NULL, NULL, 'AARF DOMAIN CONTAINING KINASE 2 (PREDICTED)', 249803),
(397524, 'PTHR45890:SF13', NULL, NULL, NULL, NULL, 'CADMIUM-TRANSPORTING ATPASE-RELATED', 249803),
(397525, 'PTHR12966', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE  UBIQUINONE  1 ALPHA SUBCOMPLEX SUBUNIT 13', 249804),
(397526, 'PTHR12966:SF0', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX SUBUNIT 13', 249804),
(397527, 'PTHR31408:SF2', NULL, NULL, NULL, NULL, 'PROTEIN SPO16 HOMOLOG', 249805);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(397528, 'PTHR31408', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC689986', 249805),
(397529, 'PTHR34231:SF2', NULL, NULL, NULL, NULL, 'AGAP006868-PA', 249806),
(397530, 'PTHR34231:SF4', NULL, NULL, NULL, NULL, '', 249806),
(397531, 'PTHR34231:SF5', NULL, NULL, NULL, NULL, '', 249806),
(397532, 'PTHR34231:SF6', NULL, NULL, NULL, NULL, 'EXS-RELATED PROTEIN', 249806),
(397533, 'PTHR34231', NULL, NULL, NULL, NULL, 'EXS-RELATED PROTEIN', 249806),
(397534, 'PTHR34231:SF7', NULL, NULL, NULL, NULL, '', 249806),
(397535, 'PTHR24092:SF81', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE VA', 249807),
(397536, 'PTHR24092:SF80', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE IM-RELATED', 249807),
(397537, 'PTHR24092:SF169', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397538, 'PTHR24092:SF204', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397539, 'PTHR24092:SF205', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397540, 'PTHR24092:SF206', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE C4F10.16C-RELATED', 249807),
(397541, 'PTHR24092:SF207', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397542, 'PTHR24092:SF208', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397543, 'PTHR24092:SF209', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397544, 'PTHR24092:SF49', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE IIA-RELATED', 249807),
(397545, 'PTHR24092:SF48', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE IC', 249807),
(397546, 'PTHR24092:SF173', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE 7-RELATED', 249807),
(397547, 'PTHR24092:SF174', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE DNF3-RELATED', 249807),
(397548, 'PTHR24092:SF175', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397549, 'PTHR24092:SF176', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397550, 'PTHR24092:SF210', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397551, 'PTHR24092:SF177', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397552, 'PTHR24092:SF211', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397553, 'PTHR24092:SF178', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397554, 'PTHR24092:SF179', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE IB', 249807),
(397555, 'PTHR24092:SF84', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE VD', 249807),
(397556, 'PTHR24092:SF170', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397557, 'PTHR24092:SF46', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE ID', 249807),
(397558, 'PTHR24092:SF171', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397559, 'PTHR24092:SF70', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397560, 'PTHR24092:SF38', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE IG', 249807),
(397561, 'PTHR24092:SF183', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397562, 'PTHR24092:SF184', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE 11-RELATED', 249807),
(397563, 'PTHR24092:SF185', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397564, 'PTHR24092:SF187', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397565, 'PTHR24092', NULL, NULL, NULL, NULL, 'PROBABLE PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397566, 'PTHR24092:SF144', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE 10', 249807),
(397567, 'PTHR24092:SF189', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397568, 'PTHR24092:SF5', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397569, 'PTHR24092:SF78', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE IK', 249807),
(397570, 'PTHR24092:SF180', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE DNF1-RELATED', 249807);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(397571, 'PTHR24092:SF33', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE IH', 249807),
(397572, 'PTHR24092:SF181', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397573, 'PTHR24092:SF182', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397574, 'PTHR24092:SF79', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE VB', 249807),
(397575, 'PTHR24092:SF147', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397576, 'PTHR24092:SF148', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397577, 'PTHR24092:SF149', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE 6', 249807),
(397578, 'PTHR24092:SF194', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397579, 'PTHR24092:SF150', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE IA', 249807),
(397580, 'PTHR24092:SF152', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397581, 'PTHR24092:SF153', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397582, 'PTHR24092:SF198', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397583, 'PTHR24092:SF199', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397584, 'PTHR24092:SF157', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397585, 'PTHR24092:SF65', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397586, 'PTHR24092:SF190', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397587, 'PTHR24092:SF192', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397588, 'PTHR24092:SF193', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE 4-RELATED', 249807),
(397589, 'PTHR24092:SF91', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397590, 'PTHR24092:SF50', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE IIB-RELATED', 249807),
(397591, 'PTHR24092:SF161', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397592, 'PTHR24092:SF59', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397593, 'PTHR24092:SF165', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE 8-RELATED', 249807),
(397594, 'PTHR24092:SF166', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE 12-RELATED', 249807),
(397595, 'PTHR24092:SF19', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397596, 'PTHR24092:SF200', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397597, 'PTHR24092:SF168', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397598, 'PTHR24092:SF52', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE FETA', 249807),
(397599, 'PTHR24092:SF95', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397600, 'PTHR24092:SF51', NULL, NULL, NULL, NULL, 'P-TYPE PHOSPHOLIPID TRANSPORTER', 249807),
(397601, 'PTHR24092:SF98', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE IB', 249807),
(397602, 'PTHR24092:SF160', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE', 249807),
(397603, 'PTHR24092:SF57', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID-TRANSPORTING ATPASE IF', 249807),
(397604, 'PTHR34938', NULL, NULL, NULL, NULL, 'PROTEIN FERTILITY RESTORER RF2, MITOCHONDRIAL', 249808),
(397605, 'PTHR34938:SF6', NULL, NULL, NULL, NULL, '', 249808),
(397606, 'PTHR34938:SF5', NULL, NULL, NULL, NULL, 'BNAC03G59750D PROTEIN', 249808),
(397607, 'PTHR34938:SF4', NULL, NULL, NULL, NULL, '', 249808),
(397608, 'PTHR34938:SF3', NULL, NULL, NULL, NULL, 'PROTEIN YELLOW LEAF 1, CHOLOROPLASTIC', 249808),
(397609, 'PTHR34938:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FERTILITY RESTORER RF2, MITOCHONDRIAL', 249808),
(397610, 'PTHR22797:SF36', NULL, NULL, NULL, NULL, 'CASPASE RECRUITMENT DOMAIN-CONTAINING PROTEIN 6', 249809),
(397611, 'PTHR22797:SF37', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 3', 249809),
(397612, 'PTHR22797', NULL, NULL, NULL, NULL, 'CARD6/NUCLEOLAR PROTEIN 3', 249809),
(397613, 'PTHR47731', NULL, NULL, NULL, NULL, 'UBIQUITIN D', 249810); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(397614, 'PTHR47731:SF1', NULL, NULL, NULL, NULL, 'UBIQUITIN D', 249810),
(397615, 'PTHR38598:SF1', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YJCH', 249811),
(397616, 'PTHR38598', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YJCH', 249811),
(397617, 'PTHR34794:SF1', NULL, NULL, NULL, NULL, 'OS10G0101800 PROTEIN', 249812),
(397618, 'PTHR34794:SF9', NULL, NULL, NULL, NULL, 'OS03G0676400 PROTEIN', 249812),
(397619, 'PTHR34794', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249812),
(397620, 'PTHR34794:SF6', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 249812),
(397621, 'PTHR34794:SF5', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 249812),
(397622, 'PTHR34794:SF4', NULL, NULL, NULL, NULL, 'VQ MOTIF-CONTAINING PROTEIN 29-LIKE', 249812),
(397623, 'PTHR34794:SF10', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 249812),
(397624, 'PTHR34794:SF3', NULL, NULL, NULL, NULL, 'VQ MOTIF-CONTAINING PROTEIN 29', 249812),
(397625, 'PTHR37916', NULL, NULL, NULL, NULL, 'CHITIN-BINDING TYPE-4 DOMAIN-CONTAINING PROTEIN', 249813),
(397626, 'PTHR37916:SF1', NULL, NULL, NULL, NULL, '', 249813),
(397627, 'PTHR37916:SF2', NULL, NULL, NULL, NULL, 'CHITIN-BINDING TYPE-4 DOMAIN-CONTAINING PROTEIN', 249813),
(397628, 'PTHR38795', NULL, NULL, NULL, NULL, '', 249814),
(397629, 'PTHR38795:SF1', NULL, NULL, NULL, NULL, '', 249814),
(397630, 'PTHR38636', NULL, NULL, NULL, NULL, 'PROTEIN CBG20488', 249815),
(397631, 'PTHR38636:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG20488', 249815),
(397632, 'PTHR38636:SF2', NULL, NULL, NULL, NULL, 'TRANSCELLULAR CHAPERONE SIGNALING (X)CROSS TISSUE', 249815),
(397633, 'PTHR13230:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR IIIC, SUBUNIT 5', 249816),
(397634, 'PTHR13230', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR IIIC, POLYPEPTIDE 5', 249816),
(397635, 'PTHR13230:SF5', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR 3C POLYPEPTIDE 5', 249816),
(397636, 'PTHR45967:SF43', NULL, NULL, NULL, NULL, 'G-BOX BINDING PROTEIN', 249817),
(397637, 'PTHR45967:SF20', NULL, NULL, NULL, NULL, 'G-BOX-BINDING FACTOR 1', 249817),
(397638, 'PTHR45967:SF42', NULL, NULL, NULL, NULL, 'BASIC REGION/LEUCINE ZIPPER TRANSCRIPTION FACTOR 68-RELATED', 249817),
(397639, 'PTHR45967:SF31', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN EMBP-1', 249817),
(397640, 'PTHR45967:SF12', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR HBP-1A', 249817),
(397641, 'PTHR45967', NULL, NULL, NULL, NULL, 'G-BOX-BINDING FACTOR 3-RELATED', 249817),
(397642, 'PTHR45967:SF22', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 249817),
(397643, 'PTHR45967:SF44', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 249817),
(397644, 'PTHR45967:SF38', NULL, NULL, NULL, NULL, 'G-BOX-BINDING FACTOR 2', 249817),
(397645, 'PTHR45967:SF16', NULL, NULL, NULL, NULL, 'G-BOX-BINDING FACTOR 1-LIKE ISOFORM X1', 249817),
(397646, 'PTHR45967:SF37', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 249817),
(397647, 'PTHR45967:SF15', NULL, NULL, NULL, NULL, 'OS03G0239400 PROTEIN', 249817),
(397648, 'PTHR45967:SF26', NULL, NULL, NULL, NULL, 'OS07G0209800 PROTEIN', 249817),
(397649, 'PTHR45967:SF29', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 249817),
(397650, 'PTHR45967:SF18', NULL, NULL, NULL, NULL, 'BASIC-LEUCINE ZIPPER (BZIP) TRANSCRIPTION FACTOR FAMILY PROTEIN', 249817),
(397651, 'PTHR45967:SF28', NULL, NULL, NULL, NULL, 'BASIC-LEUCINE ZIPPER (BZIP) TRANSCRIPTION FACTOR FAMILY PROTEIN', 249817),
(397652, 'PTHR45967:SF39', NULL, NULL, NULL, NULL, 'BASIC-LEUCINE ZIPPER DOMAIN, G-BOX BINDING PROTEIN, MULTIFUNCTIONAL MOSAIC REGION-RELATED', 249817),
(397653, 'PTHR45967:SF1', NULL, NULL, NULL, NULL, 'G-BOX-BINDING FACTOR 3', 249817),
(397654, 'PTHR45967:SF7', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR 16', 249817),
(397655, 'PTHR45967:SF2', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR 68', 249817),
(397656, 'PTHR45967:SF30', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR TAF-1-LIKE ISOFORM X1', 249817),
(397657, 'PTHR45967:SF41', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR 16-LIKE', 249817);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(397658, 'PTHR45967:SF40', NULL, NULL, NULL, NULL, 'HOMOSERINE DEHYDROGENASE', 249817),
(397659, 'PTHR12377:SF9', NULL, NULL, NULL, NULL, 'FES_ASSEMBLY_P DOMAIN-CONTAINING PROTEIN', 249818),
(397660, 'PTHR12377:SF0', NULL, NULL, NULL, NULL, 'CYTOSOLIC IRON-SULFUR ASSEMBLY COMPONENT 2B', 249818),
(397661, 'PTHR12377:SF3', NULL, NULL, NULL, NULL, 'PROTEIN AE7-LIKE 1', 249818),
(397662, 'PTHR12377', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 249818),
(397663, 'PTHR12377:SF2', NULL, NULL, NULL, NULL, 'CYTOSOLIC IRON-SULFUR ASSEMBLY COMPONENT 2A', 249818),
(397664, 'PTHR12377:SF7', NULL, NULL, NULL, NULL, 'PROTEIN AE7-LIKE 2', 249818),
(397665, 'PTHR12377:SF6', NULL, NULL, NULL, NULL, 'CYTOSOLIC IRON-SULFUR ASSEMBLY COMPONENT 2A', 249818),
(397666, 'PTHR12377:SF10', NULL, NULL, NULL, NULL, 'FES_ASSEMBLY_P DOMAIN-CONTAINING PROTEIN', 249818),
(397667, 'PTHR12377:SF11', NULL, NULL, NULL, NULL, 'PROTEIN AE7', 249818),
(397668, 'PTHR12377:SF5', NULL, NULL, NULL, NULL, '', 249818),
(397669, 'PTHR36519:SF9', NULL, NULL, NULL, NULL, 'FIP (FUNGUS-INDUCED PROTEIN) RELATED-RELATED', 249819),
(397670, 'PTHR36519', NULL, NULL, NULL, NULL, 'FIP (FUNGUS-INDUCED PROTEIN) RELATED-RELATED', 249819),
(397671, 'PTHR36519:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG10907', 249819),
(397672, 'PTHR36519:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG14900', 249819),
(397673, 'PTHR36519:SF7', NULL, NULL, NULL, NULL, 'EB DOMAIN-CONTAINING PROTEIN', 249819),
(397674, 'PTHR36519:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG13630', 249819),
(397675, 'PTHR36519:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG13414', 249819),
(397676, 'PTHR36519:SF3', NULL, NULL, NULL, NULL, 'FIP (FUNGUS-INDUCED PROTEIN) RELATED', 249819),
(397677, 'PTHR36519:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG26157', 249819),
(397678, 'PTHR43413:SF7', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR PTR2', 249820),
(397679, 'PTHR43413:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, ASNC FAMILY', 249820),
(397680, 'PTHR43413', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, ASNC FAMILY', 249820),
(397681, 'PTHR43413:SF4', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR LYSM', 249820),
(397682, 'PTHR43413:SF3', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN ASNC', 249820),
(397683, 'PTHR43413:SF1', NULL, NULL, NULL, NULL, 'SIROHEME DECARBOXYLASE NIRL SUBUNIT', 249820),
(397684, 'PTHR24960:SF85', NULL, NULL, NULL, NULL, 'POLYFERREDOXIN PROTEIN VHUB', 249821),
(397685, 'PTHR24960:SF84', NULL, NULL, NULL, NULL, 'HYDROGENASE SUBUNIT', 249821),
(397686, 'PTHR24960:SF83', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER-BINDING PROTEIN', 249821),
(397687, 'PTHR24960:SF71', NULL, NULL, NULL, NULL, 'BSR3197 PROTEIN', 249821),
(397688, 'PTHR24960:SF70', NULL, NULL, NULL, NULL, 'FERREDOXIN', 249821),
(397689, 'PTHR24960:SF80', NULL, NULL, NULL, NULL, 'FERREDOXIN-RELATED', 249821),
(397690, 'PTHR24960:SF79', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I IRON-SULFUR CENTER', 249821),
(397691, 'PTHR24960:SF46', NULL, NULL, NULL, NULL, 'FERREDOXIN-TYPE PROTEIN NAPF', 249821),
(397692, 'PTHR24960:SF45', NULL, NULL, NULL, NULL, 'NITROGEN FIXATION PROTEIN', 249821),
(397693, 'PTHR24960:SF76', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER-BINDING PROTEIN', 249821),
(397694, 'PTHR24960:SF86', NULL, NULL, NULL, NULL, 'FERREDOXIN', 249821),
(397695, 'PTHR24960', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I IRON-SULFUR CENTER-RELATED', 249821),
(397696, 'PTHR39072:SF3', NULL, NULL, NULL, NULL, 'RE48511P', 249822),
(397697, 'PTHR39072:SF2', NULL, NULL, NULL, NULL, '', 249822),
(397698, 'PTHR39072', NULL, NULL, NULL, NULL, 'RE48511P', 249822),
(397699, 'PTHR17615:SF9', NULL, NULL, NULL, NULL, '', 249823),
(397700, 'PTHR17615:SF8', NULL, NULL, NULL, NULL, 'PROTEIN FAM189A2', 249823),
(397701, 'PTHR17615:SF7', NULL, NULL, NULL, NULL, 'PROTEIN FAM189B', 249823),
(397702, 'PTHR17615', NULL, NULL, NULL, NULL, 'PROTEIN FAM189A', 249823),
(397703, 'PTHR17615:SF6', NULL, NULL, NULL, NULL, 'PROTEIN FAM189A1', 249823),
(397704, 'PTHR13291:SF3', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1', 249824);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(397705, 'PTHR13291', NULL, NULL, NULL, NULL, 'JOSEPHIN 1, 2', 249824),
(397706, 'PTHR13291:SF2', NULL, NULL, NULL, NULL, 'JOSEPHIN-2', 249824),
(397707, 'PTHR13291:SF1', NULL, NULL, NULL, NULL, 'JOSEPHIN-1', 249824),
(397708, 'PTHR13291:SF0', NULL, NULL, NULL, NULL, 'JOSEPHIN-LIKE PROTEIN', 249824),
(397709, 'PTHR35539', NULL, NULL, NULL, NULL, 'CDNA SEQUENCE BC048562', 249825),
(397710, 'PTHR35539:SF1', NULL, NULL, NULL, NULL, 'CDNA SEQUENCE BC048562', 249825),
(397711, 'PTHR34848', NULL, NULL, NULL, NULL, '', 249826),
(397712, 'PTHR34848:SF1', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL ADENOSYLCOBALAMIN BIOSYNTHESIS PROTEIN COBU', 249826),
(397713, 'PTHR43735', NULL, NULL, NULL, NULL, 'APOPTOSIS-INDUCING FACTOR 1', 249827),
(397714, 'PTHR43735:SF3', NULL, NULL, NULL, NULL, 'FERROPTOSIS SUPPRESSOR PROTEIN 1', 249827),
(397715, 'PTHR43735:SF2', NULL, NULL, NULL, NULL, 'FE-REGULATED PROTEIN 8', 249827),
(397716, 'PTHR43735:SF8', NULL, NULL, NULL, NULL, 'OS11G0158200 PROTEIN', 249827),
(397717, 'PTHR43735:SF6', NULL, NULL, NULL, NULL, 'PYR_REDOX_2 DOMAIN-CONTAINING PROTEIN', 249827),
(397718, 'PTHR43735:SF5', NULL, NULL, NULL, NULL, 'PYR_REDOX_2 DOMAIN-CONTAINING PROTEIN', 249827),
(397719, 'PTHR43735:SF19', NULL, NULL, NULL, NULL, 'PYR_REDOX_2 DOMAIN-CONTAINING PROTEIN', 249827),
(397720, 'PTHR43735:SF18', NULL, NULL, NULL, NULL, 'APOPTOSIS-INDUCING FACTOR HOMOLOG B-LIKE', 249827),
(397721, 'PTHR43735:SF11', NULL, NULL, NULL, NULL, 'HYPOTHETICAL OXIDOREDUCTASE (EUROFUNG)', 249827),
(397722, 'PTHR43735:SF24', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-DISULPHIDE OXIDOREDUCTASE AMID-LIKE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G17180)-RELATED', 249827),
(397723, 'PTHR43735:SF26', NULL, NULL, NULL, NULL, 'APOPTOSIS-INDUCING FACTOR HOMOLOG B-LIKE', 249827),
(397724, 'PTHR43735:SF14', NULL, NULL, NULL, NULL, 'FAD/NAD(P)-BINDING OXIDOREDUCTASE FAMILY PROTEIN', 249827),
(397725, 'PTHR43735:SF25', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE 3', 249827),
(397726, 'PTHR43735:SF16', NULL, NULL, NULL, NULL, 'NADH:UBIQUINONE REDUCTASE (NON-ELECTROGENIC)-RELATED', 249827),
(397727, 'PTHR10201:SF76', NULL, NULL, NULL, NULL, 'MATRIX METALLOPROTEINASE-26', 249828),
(397728, 'PTHR10201:SF249', NULL, NULL, NULL, NULL, 'ZNMC DOMAIN-CONTAINING PROTEIN', 249828),
(397729, 'PTHR10201:SF129', NULL, NULL, NULL, NULL, 'STROMELYSIN-2', 249828),
(397730, 'PTHR10201:SF30', NULL, NULL, NULL, NULL, 'MATRIX METALLOPROTEINASE-9', 249828),
(397731, 'PTHR10201:SF284', NULL, NULL, NULL, NULL, 'ZNMC DOMAIN-CONTAINING PROTEIN', 249828),
(397732, 'PTHR10201:SF247', NULL, NULL, NULL, NULL, 'METALLOENDOPROTEINASE 2-MMP', 249828),
(397733, 'PTHR10201:SF169', NULL, NULL, NULL, NULL, 'MATRIX METALLOPROTEINASE-16-LIKE PROTEIN', 249828),
(397734, 'PTHR10201:SF125', NULL, NULL, NULL, NULL, 'MATRIX METALLOPROTEINASE-20', 249828),
(397735, 'PTHR10201:SF166', NULL, NULL, NULL, NULL, 'MATRIX METALLOPROTEINASE-19', 249828),
(397736, 'PTHR10201:SF287', NULL, NULL, NULL, NULL, 'MATRIX METALLOPEPTIDASE 25B', 249828),
(397737, 'PTHR10201:SF120', NULL, NULL, NULL, NULL, 'MATRIX METALLOPEPTIDASE 23BB', 249828),
(397738, 'PTHR10201:SF165', NULL, NULL, NULL, NULL, 'COLLAGENASE 3', 249828),
(397739, 'PTHR10201:SF7', NULL, NULL, NULL, NULL, 'MATRIX METALLOPROTEINASE-23', 249828),
(397740, 'PTHR10201:SF315', NULL, NULL, NULL, NULL, 'MATRIX METALLOPROTEINASE-A', 249828),
(397741, 'PTHR10201:SF316', NULL, NULL, NULL, NULL, 'COLLAGENASE 3', 249828),
(397742, 'PTHR10201:SF151', NULL, NULL, NULL, NULL, 'INTERSTITIAL COLLAGENASE', 249828),
(397743, 'PTHR10201:SF272', NULL, NULL, NULL, NULL, 'METALLOENDOPROTEINASE 5-MMP', 249828),
(397744, 'PTHR10201:SF270', NULL, NULL, NULL, NULL, 'STROMELYSIN-2', 249828),
(397745, 'PTHR10201:SF236', NULL, NULL, NULL, NULL, 'METALLOENDOPROTEINASE 3-MMP-LIKE', 249828),
(397746, 'PTHR10201:SF115', NULL, NULL, NULL, NULL, 'MATRIX METALLOPROTEINASE-27', 249828),
(397747, 'PTHR10201:SF313', NULL, NULL, NULL, NULL, 'ZNMC DOMAIN-CONTAINING PROTEIN', 249828),
(397748, 'PTHR10201:SF314', NULL, NULL, NULL, NULL, 'PEPTIDASE M10A AND M12B MATRIXIN AND ADAMALYSIN', 249828);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(397749, 'PTHR10201:SF311', NULL, NULL, NULL, NULL, 'ZNMC DOMAIN-CONTAINING PROTEIN', 249828),
(397750, 'PTHR10201:SF278', NULL, NULL, NULL, NULL, 'ZNMC DOMAIN-CONTAINING PROTEIN', 249828),
(397751, 'PTHR10201:SF312', NULL, NULL, NULL, NULL, 'ZNMC DOMAIN-CONTAINING PROTEIN', 249828),
(397752, 'PTHR10201:SF279', NULL, NULL, NULL, NULL, 'METALLOENDOPROTEINASE 1-MMP', 249828),
(397753, 'PTHR10201:SF310', NULL, NULL, NULL, NULL, 'MMP-LIKE PROTEIN', 249828),
(397754, 'PTHR10201:SF277', NULL, NULL, NULL, NULL, 'OS06G0239100 PROTEIN', 249828),
(397755, 'PTHR10201:SF274', NULL, NULL, NULL, NULL, 'ZNMC DOMAIN-CONTAINING PROTEIN', 249828),
(397756, 'PTHR10201:SF275', NULL, NULL, NULL, NULL, 'ZNMC DOMAIN-CONTAINING PROTEIN', 249828),
(397757, 'PTHR10201:SF308', NULL, NULL, NULL, NULL, 'MATRIX METALLOPROTEINASE 2', 249828),
(397758, 'PTHR10201:SF309', NULL, NULL, NULL, NULL, 'ZNMC DOMAIN-CONTAINING PROTEIN', 249828),
(397759, 'PTHR10201:SF306', NULL, NULL, NULL, NULL, 'MATRIX METALLOPEPTIDASE 20B (ENAMELYSIN)', 249828),
(397760, 'PTHR10201:SF307', NULL, NULL, NULL, NULL, 'MATRIX METALLOPROTEINASE-21', 249828),
(397761, 'PTHR10201:SF304', NULL, NULL, NULL, NULL, 'ZNMC DOMAIN-CONTAINING PROTEIN', 249828),
(397762, 'PTHR10201:SF305', NULL, NULL, NULL, NULL, 'MATRIX METALLOPROTEINASE-B', 249828),
(397763, 'PTHR10201:SF260', NULL, NULL, NULL, NULL, 'METALLOENDOPROTEINASE 1', 249828),
(397764, 'PTHR10201:SF302', NULL, NULL, NULL, NULL, 'MATRIX METALLOPEPTIDASE 13A', 249828),
(397765, 'PTHR10201:SF303', NULL, NULL, NULL, NULL, 'MATRILYSIN-LIKE', 249828),
(397766, 'PTHR10201', NULL, NULL, NULL, NULL, 'MATRIX METALLOPROTEINASE', 249828),
(397767, 'PTHR10201:SF300', NULL, NULL, NULL, NULL, 'OS10G0558125 PROTEIN', 249828),
(397768, 'PTHR10201:SF267', NULL, NULL, NULL, NULL, 'MACROPHAGE METALLOELASTASE', 249828),
(397769, 'PTHR10201:SF268', NULL, NULL, NULL, NULL, 'ZNMC DOMAIN-CONTAINING PROTEIN', 249828),
(397770, 'PTHR10201:SF301', NULL, NULL, NULL, NULL, 'INTERSTITIAL COLLAGENASE B', 249828),
(397771, 'PTHR10201:SF224', NULL, NULL, NULL, NULL, 'MATRIX METALLOPEPTIDASE 17B', 249828),
(397772, 'PTHR10201:SF266', NULL, NULL, NULL, NULL, 'MATRIXIN FAMILY PROTEIN-RELATED', 249828),
(397773, 'PTHR10201:SF142', NULL, NULL, NULL, NULL, 'MATRIX METALLOPROTEINASE-25', 249828),
(397774, 'PTHR10201:SF263', NULL, NULL, NULL, NULL, 'METALLOENDOPROTEINASE 3-MMP', 249828),
(397775, 'PTHR10201:SF143', NULL, NULL, NULL, NULL, 'MATRILYSIN', 249828),
(397776, 'PTHR10201:SF21', NULL, NULL, NULL, NULL, 'MATRIX METALLOPROTEINASE-17', 249828),
(397777, 'PTHR10201:SF20', NULL, NULL, NULL, NULL, 'STROMELYSIN-3', 249828),
(397778, 'PTHR10201:SF26', NULL, NULL, NULL, NULL, 'MATRIX METALLOPROTEINASE-16', 249828),
(397779, 'PTHR10201:SF25', NULL, NULL, NULL, NULL, 'MATRIX METALLOPROTEINASE-15', 249828),
(397780, 'PTHR10201:SF24', NULL, NULL, NULL, NULL, 'MATRIX METALLOPROTEINASE-14', 249828),
(397781, 'PTHR10201:SF29', NULL, NULL, NULL, NULL, '72 KDA TYPE IV COLLAGENASE', 249828),
(397782, 'PTHR10201:SF294', NULL, NULL, NULL, NULL, 'ZNMC DOMAIN-CONTAINING PROTEIN', 249828),
(397783, 'PTHR10201:SF295', NULL, NULL, NULL, NULL, 'ZNMC DOMAIN-CONTAINING PROTEIN', 249828),
(397784, 'PTHR10201:SF292', NULL, NULL, NULL, NULL, 'PEPTIDASE M10A, METALLOPEPTIDASE, CATALYTIC DOMAIN PROTEIN-RELATED', 249828),
(397785, 'PTHR10201:SF290', NULL, NULL, NULL, NULL, 'MATRIX METALLOPEPTIDASE 14A (MEMBRANE-INSERTED)', 249828),
(397786, 'PTHR10201:SF291', NULL, NULL, NULL, NULL, 'MATRIX METALLOPROTEINASE 1, ISOFORM C-RELATED', 249828),
(397787, 'PTHR10201:SF137', NULL, NULL, NULL, NULL, 'NEUTROPHIL COLLAGENASE', 249828),
(397788, 'PTHR10201:SF258', NULL, NULL, NULL, NULL, 'MATRIX METALLOPROTEINASE', 249828),
(397789, 'PTHR10201:SF138', NULL, NULL, NULL, NULL, 'MATRIX METALLOPROTEINASE-24', 249828),
(397790, 'PTHR10201:SF215', NULL, NULL, NULL, NULL, 'STROMELYSIN-1', 249828),
(397791, 'PTHR10201:SF259', NULL, NULL, NULL, NULL, 'MATRIXIN PROTEIN', 249828),
(397792, 'PTHR10201:SF136', NULL, NULL, NULL, NULL, 'HEMOPEXIN', 249828),
(397793, 'PTHR10201:SF213', NULL, NULL, NULL, NULL, 'ZNMC DOMAIN-CONTAINING PROTEIN', 249828);
INSERT INTO "PUBLIC"."MODEL" VALUES
(397794, 'PTHR10201:SF257', NULL, NULL, NULL, NULL, 'ZNMC DOMAIN-CONTAINING PROTEIN', 249828),
(397795, 'PTHR10201:SF298', NULL, NULL, NULL, NULL, 'MATRIX METALLOPROTEINASE-28', 249828),
(397796, 'PTHR10201:SF297', NULL, NULL, NULL, NULL, 'MATRIX METALLOPEPTIDASE 20A (ENAMELYSIN)', 249828),
(397797, 'PTHR21258:SF53', NULL, NULL, NULL, NULL, 'INSULIN RECEPTOR SUBSTRATE 1', 249829),
(397798, 'PTHR21258:SF42', NULL, NULL, NULL, NULL, 'DOCKING PROTEIN 3', 249829),
(397799, 'PTHR21258', NULL, NULL, NULL, NULL, 'DOCKING PROTEIN RELATED', 249829),
(397800, 'PTHR21258:SF40', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR RECEPTOR SUBSTRATE 2', 249829),
(397801, 'PTHR21258:SF45', NULL, NULL, NULL, NULL, 'DOCKING PROTEIN 5', 249829),
(397802, 'PTHR21258:SF56', NULL, NULL, NULL, NULL, 'IRS-TYPE PTB DOMAIN-CONTAINING PROTEIN', 249829),
(397803, 'PTHR21258:SF57', NULL, NULL, NULL, NULL, 'IRS-TYPE PTB DOMAIN-CONTAINING PROTEIN', 249829),
(397804, 'PTHR21258:SF46', NULL, NULL, NULL, NULL, 'DOCKING PROTEIN 1', 249829),
(397805, 'PTHR21258:SF43', NULL, NULL, NULL, NULL, 'DOCKING PROTEIN 6', 249829),
(397806, 'PTHR21258:SF55', NULL, NULL, NULL, NULL, 'FI23523P1', 249829),
(397807, 'PTHR21258:SF44', NULL, NULL, NULL, NULL, 'DOCKING PROTEIN 4', 249829),
(397808, 'PTHR21258:SF39', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR RECEPTOR SUBSTRATE 3', 249829),
(397809, 'PTHR21258:SF58', NULL, NULL, NULL, NULL, 'IRS-TYPE PTB DOMAIN-CONTAINING PROTEIN', 249829),
(397810, 'PTHR21258:SF14', NULL, NULL, NULL, NULL, 'DOCKING PROTEIN 2', 249829),
(397811, 'PTHR21258:SF59', NULL, NULL, NULL, NULL, 'IRS-TYPE PTB DOMAIN-CONTAINING PROTEIN', 249829),
(397812, 'PTHR11480:SF80', NULL, NULL, NULL, NULL, 'SAPOSIN-RELATED', 249830),
(397813, 'PTHR11480', NULL, NULL, NULL, NULL, 'SAPOSIN-RELATED', 249830),
(397814, 'PTHR11480:SF87', NULL, NULL, NULL, NULL, 'PROSAPOSIN-LIKE', 249830),
(397815, 'PTHR11480:SF86', NULL, NULL, NULL, NULL, 'BNACNNG40660D PROTEIN', 249830),
(397816, 'PTHR11480:SF84', NULL, NULL, NULL, NULL, 'BCDNA.GH08312', 249830),
(397817, 'PTHR11480:SF81', NULL, NULL, NULL, NULL, '', 249830),
(397818, 'PTHR11480:SF7', NULL, NULL, NULL, NULL, 'SAPOSIN-LIKE PROTEIN FAMILY', 249830),
(397819, 'PTHR11480:SF27', NULL, NULL, NULL, NULL, 'SAPOSIN A', 249830),
(397820, 'PTHR11480:SF68', NULL, NULL, NULL, NULL, '', 249830),
(397821, 'PTHR11480:SF89', NULL, NULL, NULL, NULL, 'SAPOSIN B-TYPE DOMAIN-CONTAINING PROTEIN', 249830),
(397822, 'PTHR11480:SF3', NULL, NULL, NULL, NULL, 'SAPOSIN-LIKE PROTEIN FAMILY', 249830),
(397823, 'PTHR11480:SF91', NULL, NULL, NULL, NULL, 'SAPLIP C PROTEIN-RELATED', 249830),
(397824, 'PTHR11480:SF90', NULL, NULL, NULL, NULL, 'OS12G0112200 PROTEIN', 249830),
(397825, 'PTHR11480:SF33', NULL, NULL, NULL, NULL, 'PULMONARY SURFACTANT-ASSOCIATED PROTEIN B', 249830),
(397826, 'PTHR11480:SF76', NULL, NULL, NULL, NULL, 'PROSAPOSIN-LIKE', 249830),
(397827, 'PTHR11480:SF53', NULL, NULL, NULL, NULL, 'SAPOSIN B-TYPE DOMAIN-CONTAINING PROTEIN', 249830),
(397828, 'PTHR11480:SF96', NULL, NULL, NULL, NULL, 'SAPOSIN B-TYPE DOMAIN-CONTAINING PROTEIN', 249830),
(397829, 'PTHR11480:SF95', NULL, NULL, NULL, NULL, 'PROSAPOSIN', 249830),
(397830, 'PTHR11480:SF72', NULL, NULL, NULL, NULL, '', 249830),
(397831, 'PTHR11480:SF94', NULL, NULL, NULL, NULL, '', 249830),
(397832, 'PTHR11480:SF93', NULL, NULL, NULL, NULL, 'B PROTEIN, PUTATIVE-RELATED', 249830),
(397833, 'PTHR11480:SF71', NULL, NULL, NULL, NULL, 'SAPOSIN B DOMAIN-CONTAINING PROTEIN', 249830),
(397834, 'PTHR11480:SF92', NULL, NULL, NULL, NULL, 'SAPOSIN-RELATED', 249830),
(397835, 'PTHR11480:SF39', NULL, NULL, NULL, NULL, 'PROACTIVATOR POLYPEPTIDE-LIKE 1', 249830),
(397836, 'PTHR11480:SF36', NULL, NULL, NULL, NULL, 'PROSAPOSIN', 249830),
(397837, 'PTHR28213:SF1', NULL, NULL, NULL, NULL, 'IMP-SPECIFIC 5''-NUCLEOTIDASE 1', 249831),
(397838, 'PTHR28213', NULL, NULL, NULL, NULL, 'IMP-SPECIFIC 5''-NUCLEOTIDASE 1', 249831),
(397839, 'PTHR21616', NULL, NULL, NULL, NULL, 'CENTROSOME SPINDLE POLE ASSOCIATED PROTEIN', 249832),
(397840, 'PTHR21616:SF3', NULL, NULL, NULL, NULL, 'AGAP000592-PA', 249832);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(397841, 'PTHR21616:SF2', NULL, NULL, NULL, NULL, 'CENTROSOME AND SPINDLE POLE-ASSOCIATED PROTEIN 1', 249832),
(397842, 'PTHR47766:SF1', NULL, NULL, NULL, NULL, 'PROTEIN EFR3', 249833),
(397843, 'PTHR47766', NULL, NULL, NULL, NULL, 'PROTEIN EFR3', 249833),
(397844, 'PTHR16019:SF23', NULL, NULL, NULL, NULL, 'BSD DOMAIN-CONTAINING PROTEIN', 249834),
(397845, 'PTHR16019:SF24', NULL, NULL, NULL, NULL, 'BSD DOMAIN-CONTAINING PROTEIN', 249834),
(397846, 'PTHR16019:SF16', NULL, NULL, NULL, NULL, 'BSD DOMAIN-CONTAINING PROTEIN', 249834),
(397847, 'PTHR16019:SF15', NULL, NULL, NULL, NULL, 'OS01G0273300 PROTEIN', 249834),
(397848, 'PTHR16019:SF5', NULL, NULL, NULL, NULL, 'BSD DOMAIN-CONTAINING PROTEIN 1', 249834),
(397849, 'PTHR16019', NULL, NULL, NULL, NULL, 'SYNAPSE-ASSOCIATED PROTEIN', 249834),
(397850, 'PTHR16019:SF6', NULL, NULL, NULL, NULL, 'SYNAPSE-ASSOCIATED PROTEIN 1', 249834),
(397851, 'PTHR16019:SF20', NULL, NULL, NULL, NULL, 'BSD DOMAIN-CONTAINING PROTEIN-RELATED', 249834),
(397852, 'PTHR43013:SF1', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA REDUCTASE', 249835),
(397853, 'PTHR43013', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA REDUCTASE', 249835),
(397854, 'PTHR23257:SF890', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0272254-RELATED', 249836),
(397855, 'PTHR23257:SF772', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 249836),
(397856, 'PTHR23257:SF894', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249836),
(397857, 'PTHR23257:SF891', NULL, NULL, NULL, NULL, 'INTEGRIN-LINKED PROTEIN KINASE FAMILY', 249836),
(397858, 'PTHR23257:SF770', NULL, NULL, NULL, NULL, 'STRESS-ACTIVATED PROTEIN KINASE ALPHA', 249836),
(397859, 'PTHR23257:SF892', NULL, NULL, NULL, NULL, 'INACTIVE SERINE/THREONINE-PROTEIN KINASE DDB_G0278909-RELATED', 249836),
(397860, 'PTHR23257:SF897', NULL, NULL, NULL, NULL, 'PB1 DOMAIN, PROTEIN KINASE DOMAIN, EPHRIN RECEPTOR TYPE-A /TYPE-B-RELATED', 249836),
(397861, 'PTHR23257:SF930', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249836),
(397862, 'PTHR23257:SF776', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PHG2', 249836),
(397863, 'PTHR23257:SF810', NULL, NULL, NULL, NULL, 'KINASE AND EXCHANGE FACTOR FOR RAC A', 249836),
(397864, 'PTHR23257:SF931', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0288147-RELATED', 249836),
(397865, 'PTHR23257:SF895', NULL, NULL, NULL, NULL, 'OS02G0174200 PROTEIN', 249836),
(397866, 'PTHR23257:SF775', NULL, NULL, NULL, NULL, 'KINASE SUPPRESSOR OF RAS 2', 249836),
(397867, 'PTHR23257:SF934', NULL, NULL, NULL, NULL, 'PROTEIN KINASE, PUTATIVE-RELATED', 249836),
(397868, 'PTHR23257:SF813', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE EDR1', 249836),
(397869, 'PTHR23257:SF935', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249836),
(397870, 'PTHR23257:SF932', NULL, NULL, NULL, NULL, 'OS08G0224100 PROTEIN', 249836),
(397871, 'PTHR23257:SF899', NULL, NULL, NULL, NULL, 'SEVEN TRANSMEMBRANE DOMAIN-CONTAINING TYROSINE-PROTEIN KINASE 1', 249836),
(397872, 'PTHR23257:SF812', NULL, NULL, NULL, NULL, 'ATP BINDING PROTEIN', 249836),
(397873, 'PTHR23257:SF779', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT SERINE/THREONINE-PROTEIN KINASE 1', 249836),
(397874, 'PTHR23257:SF933', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-KINASE HT1-LIKE PROTEIN', 249836),
(397875, 'PTHR23257:SF938', NULL, NULL, NULL, NULL, 'OCTICOSAPEPTIDE/PHOX/BEM1P_ PROTEIN KINASE', 249836),
(397876, 'PTHR23257:SF817', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249836),
(397877, 'PTHR23257:SF939', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0276181-RELATED', 249836),
(397878, 'PTHR23257:SF936', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE WNK4', 249836),
(397879, 'PTHR23257:SF816', NULL, NULL, NULL, NULL, 'ACT-DOMAIN CONTAINING PROTEIN KINASE FAMILY PROTEIN-RELATED', 249836),
(397880, 'PTHR23257:SF937', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 20', 249836),
(397881, 'PTHR23257:SF780', NULL, NULL, NULL, NULL, 'AT08303P', 249836);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(397882, 'PTHR23257:SF784', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0280461-RELATED', 249836),
(397883, 'PTHR23257:SF941', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249836),
(397884, 'PTHR23257:SF788', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249836),
(397885, 'PTHR23257:SF942', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249836),
(397886, 'PTHR23257:SF821', NULL, NULL, NULL, NULL, 'ATP BINDING PROTEIN', 249836),
(397887, 'PTHR23257:SF940', NULL, NULL, NULL, NULL, 'DUF1221-DOMAIN CONTAINING PROTEIN KINASE FAMILY PROTEIN-RELATED', 249836),
(397888, 'PTHR23257:SF945', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 13', 249836),
(397889, 'PTHR23257:SF703', NULL, NULL, NULL, NULL, 'RECEPTOR-INTERACTING SERINE/THREONINE-PROTEIN KINASE 3', 249836),
(397890, 'PTHR23257:SF824', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249836),
(397891, 'PTHR23257:SF946', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN KINASE SPLB-RELATED', 249836),
(397892, 'PTHR23257:SF943', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE GIN4-LIKE', 249836),
(397893, 'PTHR23257:SF944', NULL, NULL, NULL, NULL, 'PB1 DOMAIN-CONTAINING PROTEIN TYROSINE KINASE', 249836),
(397894, 'PTHR23257:SF828', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE MARK1-LIKE', 249836),
(397895, 'PTHR23257:SF949', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249836),
(397896, 'PTHR23257:SF707', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 12', 249836),
(397897, 'PTHR23257:SF829', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249836),
(397898, 'PTHR23257:SF947', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249836),
(397899, 'PTHR23257:SF706', NULL, NULL, NULL, NULL, 'PROTO-ONCOGENE SERINE/THREONINE-PROTEIN KINASE MOS', 249836),
(397900, 'PTHR23257:SF948', NULL, NULL, NULL, NULL, 'OS12G0594300 PROTEIN', 249836),
(397901, 'PTHR23257:SF795', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249836),
(397902, 'PTHR23257:SF792', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249836),
(397903, 'PTHR23257:SF793', NULL, NULL, NULL, NULL, 'SERINE/THREONINE/TYROSINE-PROTEIN KINASE HT1', 249836),
(397904, 'PTHR23257:SF952', NULL, NULL, NULL, NULL, 'OCTICOSAPEPTIDE/PHOX/BEM1P DOMAIN KINASE SUPERFAMILY PROTEIN', 249836),
(397905, 'PTHR23257:SF953', NULL, NULL, NULL, NULL, 'PROTEIN KINASE ATN1', 249836),
(397906, 'PTHR23257:SF711', NULL, NULL, NULL, NULL, 'CYCLIC GMP-BINDING PROTEIN C', 249836),
(397907, 'PTHR23257:SF950', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249836),
(397908, 'PTHR23257:SF951', NULL, NULL, NULL, NULL, 'RGS DOMAIN-CONTAINING SERINE/THREONINE-PROTEIN KINASE A', 249836),
(397909, 'PTHR23257:SF797', NULL, NULL, NULL, NULL, 'KINASE SUPERFAMILY WITH OCTICOSAPEPTIDE/PHOX/BEM1P DOMAIN-CONTAINING PROTEIN', 249836),
(397910, 'PTHR23257:SF835', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE HT1-LIKE', 249836),
(397911, 'PTHR23257:SF956', NULL, NULL, NULL, NULL, 'PROTEIN KINASE FAMILY PROTEIN', 249836),
(397912, 'PTHR23257:SF957', NULL, NULL, NULL, NULL, 'F3O9.7 PROTEIN-RELATED', 249836),
(397913, 'PTHR23257:SF712', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0281745-RELATED', 249836),
(397914, 'PTHR23257:SF954', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249836),
(397915, 'PTHR23257:SF955', NULL, NULL, NULL, NULL, 'SUPERFAMILY PROTEIN WITH OCTICOSAPEPTIDE/PHOX/BEM1P DOMAIN, PUTATIVE ISOFORM 1-RELATED', 249836),
(397916, 'PTHR23257:SF834', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249836),
(397917, 'PTHR23257:SF718', NULL, NULL, NULL, NULL, 'RASGEF DOMAIN-CONTAINING SERINE/THREONINE-PROTEIN KINASE X', 249836),
(397918, 'PTHR23257:SF839', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249836),
(397919, 'PTHR23257:SF716', NULL, NULL, NULL, NULL, 'KINASE SUPPRESSOR OF RAS 1', 249836);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(397920, 'PTHR23257:SF717', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE', 249836),
(397921, 'PTHR23257:SF842', NULL, NULL, NULL, NULL, 'KINASE SUPERFAMILY WITH OCTICOSAPEPTIDE/PHOX/BEM1P DOMAIN-CONTAINING PROTEIN', 249836),
(397922, 'PTHR23257:SF843', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN WITH OCTICOSAPEPTIDE/PHOX/BEM1P DOMAIN', 249836),
(397923, 'PTHR23257:SF841', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0290621-RELATED', 249836),
(397924, 'PTHR23257:SF724', NULL, NULL, NULL, NULL, 'INACTIVE SERINE/THREONINE-PROTEIN KINASE DDB_G0280131-RELATED', 249836),
(397925, 'PTHR23257:SF848', NULL, NULL, NULL, NULL, 'SERINE-THREONINE/TYROSINE-PROTEIN KINASE CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 249836),
(397926, 'PTHR23257:SF727', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE A-RAF', 249836),
(397927, 'PTHR23257:SF728', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE', 249836),
(397928, 'PTHR23257:SF611', NULL, NULL, NULL, NULL, 'PROTEIN KINASE ATN1-LIKE PROTEIN-RELATED', 249836),
(397929, 'PTHR23257:SF853', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249836),
(397930, 'PTHR23257:SF731', NULL, NULL, NULL, NULL, 'B-RAF PROTO-ONCOGENE, SERINE/THREONINE KINASE', 249836),
(397931, 'PTHR23257:SF734', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN KINASE ZAK2-RELATED', 249836),
(397932, 'PTHR23257:SF855', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249836),
(397933, 'PTHR23257:SF859', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249836),
(397934, 'PTHR23257:SF861', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249836),
(397935, 'PTHR23257:SF742', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE QKGA-RELATED', 249836),
(397936, 'PTHR23257:SF901', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN KINASE PYK3', 249836),
(397937, 'PTHR23257:SF868', NULL, NULL, NULL, NULL, 'KINASE SUPERFAMILY WITH OCTICOSAPEPTIDE/PHOX/BEM1P DOMAIN-CONTAINING PROTEIN', 249836),
(397938, 'PTHR23257:SF869', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING SERINE/THREONINE-PROTEIN KINASE DDB_G0286997-RELATED', 249836),
(397939, 'PTHR23257:SF745', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE KINY-RELATED', 249836),
(397940, 'PTHR23257:SF900', NULL, NULL, NULL, NULL, 'OS05G0585800 PROTEIN', 249836),
(397941, 'PTHR23257:SF906', NULL, NULL, NULL, NULL, '(RICE GENOME ANNOTATION PROJECT) MAP3K DELTA-1 PROTEIN KINASE', 249836),
(397942, 'PTHR23257:SF909', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0267686-RELATED', 249836),
(397943, 'PTHR23257:SF908', NULL, NULL, NULL, NULL, 'OS06G0181200 PROTEIN', 249836),
(397944, 'PTHR23257:SF750', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 21', 249836),
(397945, 'PTHR23257:SF871', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 53-RELATED', 249836),
(397946, 'PTHR23257:SF875', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE DDB_G0283397-RELATED', 249836),
(397947, 'PTHR23257:SF755', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE', 249836),
(397948, 'PTHR23257:SF873', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249836),
(397949, 'PTHR23257:SF752', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0275165-RELATED', 249836),
(397950, 'PTHR23257:SF753', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0268876-RELATED', 249836),
(397951, 'PTHR23257:SF758', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0282963-RELATED', 249836),
(397952, 'PTHR23257:SF879', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249836),
(397953, 'PTHR23257:SF913', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0278521-RELATED', 249836),
(397954, 'PTHR23257:SF910', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN KINASE SPLA', 249836),
(397955, 'PTHR23257:SF911', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE STY17-LIKE', 249836);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(397956, 'PTHR23257:SF878', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DRKC-RELATED', 249836),
(397957, 'PTHR23257:SF757', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE', 249836),
(397958, 'PTHR23257:SF917', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN SUPERFAMILY PROTEIN', 249836),
(397959, 'PTHR23257:SF761', NULL, NULL, NULL, NULL, 'OS02G0594100 PROTEIN', 249836),
(397960, 'PTHR23257:SF880', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE HT1-LIKE', 249836),
(397961, 'PTHR23257:SF881', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249836),
(397962, 'PTHR23257:SF760', NULL, NULL, NULL, NULL, 'KINASE SUPPRESSOR OF RAS B', 249836),
(397963, 'PTHR23257:SF765', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 249836),
(397964, 'PTHR23257:SF920', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 249836),
(397965, 'PTHR23257:SF763', NULL, NULL, NULL, NULL, 'RAF PROTO-ONCOGENE SERINE/THREONINE-PROTEIN KINASE', 249836),
(397966, 'PTHR23257', NULL, NULL, NULL, NULL, 'SERINE-THREONINE PROTEIN KINASE', 249836),
(397967, 'PTHR23257:SF923', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE ROCO8-RELATED', 249836),
(397968, 'PTHR23257:SF924', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249836),
(397969, 'PTHR23257:SF921', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DRKA-RELATED', 249836),
(397970, 'PTHR23257:SF800', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE 1', 249836),
(397971, 'PTHR23257:SF888', NULL, NULL, NULL, NULL, 'SERINE/THREONINE/DUAL SPECIFICITY PROTEIN KINASE, CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 249836),
(397972, 'PTHR23257:SF768', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE DDB_G0290471-RELATED', 249836),
(397973, 'PTHR23257:SF922', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0272092-RELATED', 249836),
(397974, 'PTHR23257:SF927', NULL, NULL, NULL, NULL, 'BNAA06G11100D PROTEIN', 249836),
(397975, 'PTHR23257:SF928', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249836),
(397976, 'PTHR23257:SF807', NULL, NULL, NULL, NULL, 'PUTATIVE, EXPRESSED-RELATED', 249836),
(397977, 'PTHR23257:SF925', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249836),
(397978, 'PTHR23257:SF926', NULL, NULL, NULL, NULL, 'SAM DOMAIN-CONTAINING PROTEIN', 249836),
(397979, 'PTHR23257:SF929', NULL, NULL, NULL, NULL, 'MITOSIS INHIBITOR PROTEIN KINASE WEE1-LIKE', 249836),
(397980, 'PTHR37844:SF1', NULL, NULL, NULL, NULL, 'METALLOPHOS DOMAIN-CONTAINING PROTEIN', 249837),
(397981, 'PTHR37844:SF2', NULL, NULL, NULL, NULL, 'SER/THR PROTEIN PHOSPHATASE SUPERFAMILY (AFU_ORTHOLOGUE AFUA_1G14840)', 249837),
(397982, 'PTHR37844', NULL, NULL, NULL, NULL, 'SER/THR PROTEIN PHOSPHATASE SUPERFAMILY (AFU_ORTHOLOGUE AFUA_1G14840)', 249837),
(397983, 'PTHR30385:SF8', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA-E FACTOR', 249838),
(397984, 'PTHR30385:SF1', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA-H FACTOR', 249838),
(397985, 'PTHR30385:SF7', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA FACTOR FLIA', 249838),
(397986, 'PTHR30385', NULL, NULL, NULL, NULL, 'SIGMA FACTOR F  FLAGELLAR', 249838),
(397987, 'PTHR30385:SF6', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA FACTOR SIGI', 249838),
(397988, 'PTHR30385:SF4', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA FACTOR SIGO', 249838),
(397989, 'PTHR10928:SF2', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF FUSED HOMOLOG', 249839),
(397990, 'PTHR10928', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF FUSED', 249839),
(397991, 'PTHR21256:SF13', NULL, NULL, NULL, NULL, 'HISTIDINOL DEHYDROGENASE, CHLOROPLASTIC', 249840),
(397992, 'PTHR21256:SF2', NULL, NULL, NULL, NULL, 'HISTIDINE BIOSYNTHESIS TRIFUNCTIONAL PROTEIN', 249840),
(397993, 'PTHR21256:SF14', NULL, NULL, NULL, NULL, 'HISTIDINOL DEHYDROGENASE', 249840),
(397994, 'PTHR21256', NULL, NULL, NULL, NULL, 'HISTIDINOL DEHYDROGENASE  HDH', 249840),
(397995, 'PTHR38654:SF1', NULL, NULL, NULL, NULL, 'BUCKY BALL-RELATED', 249841),
(397996, 'PTHR38654', NULL, NULL, NULL, NULL, 'BUCKY BALL-RELATED', 249841);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(397997, 'PTHR31527', NULL, NULL, NULL, NULL, 'RE64534P', 249842),
(397998, 'PTHR31527:SF0', NULL, NULL, NULL, NULL, 'RE64534P', 249842),
(397999, 'PTHR35114:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME OXIDASE COMPLEX ASSEMBLY PROTEIN', 249843),
(398000, 'PTHR35114:SF2', NULL, NULL, NULL, NULL, '', 249843),
(398001, 'PTHR35114', NULL, NULL, NULL, NULL, 'CYTOCHROME OXIDASE COMPLEX ASSEMBLY PROTEIN', 249843),
(398002, 'PTHR36779', NULL, NULL, NULL, NULL, 'OSJNBA0083N12.13 PROTEIN', 249844),
(398003, 'PTHR36779:SF1', NULL, NULL, NULL, NULL, 'OS04G0600400 PROTEIN', 249844),
(398004, 'PTHR36779:SF2', NULL, NULL, NULL, NULL, 'BNAC01G40960D PROTEIN', 249844),
(398005, 'PTHR28043', NULL, NULL, NULL, NULL, 'INCREASED RECOMBINATION CENTERS PROTEIN 6', 249845),
(398006, 'PTHR28043:SF1', NULL, NULL, NULL, NULL, 'INCREASED RECOMBINATION CENTERS PROTEIN 6', 249845),
(398007, 'PTHR23198:SF29', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN DDB_G0274915', 249846),
(398008, 'PTHR23198:SF28', NULL, NULL, NULL, NULL, 'NUCLEOPORIN NUP49/NSP49', 249846),
(398009, 'PTHR23198:SF15', NULL, NULL, NULL, NULL, 'OS01G0383900 PROTEIN', 249846),
(398010, 'PTHR23198:SF26', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP96', 249846),
(398011, 'PTHR23198:SF19', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP98A-LIKE', 249846),
(398012, 'PTHR23198:SF21', NULL, NULL, NULL, NULL, 'BNAC09G11300D PROTEIN', 249846),
(398013, 'PTHR23198:SF30', NULL, NULL, NULL, NULL, 'NUCLEOPORIN NUP100/NSP100-RELATED', 249846),
(398014, 'PTHR23198', NULL, NULL, NULL, NULL, 'NUCLEOPORIN', 249846),
(398015, 'PTHR23198:SF25', NULL, NULL, NULL, NULL, 'F2K11.10-RELATED', 249846),
(398016, 'PTHR23198:SF6', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP98-NUP96', 249846),
(398017, 'PTHR23198:SF22', NULL, NULL, NULL, NULL, 'PEPTIDASE S59 DOMAIN-CONTAINING PROTEIN', 249846),
(398018, 'PTHR23328:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF169', 249847),
(398019, 'PTHR23328:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF168', 249847),
(398020, 'PTHR23328:SF0', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 249847),
(398021, 'PTHR23328', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 249847),
(398022, 'PTHR23328:SF9', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RING1A-RELATED', 249847),
(398023, 'PTHR46753:SF2', NULL, NULL, NULL, NULL, 'FYVE AND COILED-COIL DOMAIN-CONTAINING PROTEIN 1', 249848),
(398024, 'PTHR46753:SF3', NULL, NULL, NULL, NULL, 'RUN DOMAIN-CONTAINING PROTEIN', 249848),
(398025, 'PTHR46753', NULL, NULL, NULL, NULL, 'FYVE AND COILED-COIL DOMAIN-CONTAINING PROTEIN 1', 249848),
(398026, 'PTHR10288:SF179', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN K', 249849),
(398027, 'PTHR10288:SF135', NULL, NULL, NULL, NULL, 'POLY(RC)-BINDING PROTEIN 3-LIKE', 249849),
(398028, 'PTHR10288:SF333', NULL, NULL, NULL, NULL, 'K DOMAIN-CONTAINING PROTEIN-RELATED', 249849),
(398029, 'PTHR10288:SF98', NULL, NULL, NULL, NULL, 'POLY(RC)-BINDING PROTEIN 3', 249849),
(398030, 'PTHR10288:SF97', NULL, NULL, NULL, NULL, 'POLY(RC)-BINDING PROTEIN 2', 249849),
(398031, 'PTHR10288:SF134', NULL, NULL, NULL, NULL, 'RNA-BINDING KH DOMAIN-CONTAINING PROTEIN RCF3', 249849),
(398032, 'PTHR10288:SF332', NULL, NULL, NULL, NULL, '', 249849),
(398033, 'PTHR10288:SF331', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN K', 249849),
(398034, 'PTHR10288:SF254', NULL, NULL, NULL, NULL, 'PROTEIN BTR1-LIKE ISOFORM X1', 249849),
(398035, 'PTHR10288:SF298', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 249849),
(398036, 'PTHR10288:SF96', NULL, NULL, NULL, NULL, 'POLY(RC)-BINDING PROTEIN 1', 249849),
(398037, 'PTHR10288:SF297', NULL, NULL, NULL, NULL, 'BNAA09G42440D PROTEIN', 249849),
(398038, 'PTHR10288:SF330', NULL, NULL, NULL, NULL, 'MESSENGER RNA-BINDING INHIBITOR OF APOPTOSIS 1', 249849),
(398039, 'PTHR10288:SF336', NULL, NULL, NULL, NULL, 'FLOWERING LOCUS K HOMOLOGY DOMAIN', 249849),
(398040, 'PTHR10288:SF138', NULL, NULL, NULL, NULL, 'FUBP (FUBP) LIKE', 249849);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(398041, 'PTHR10288:SF93', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR 2 MRNA-BINDING PROTEIN 2', 249849),
(398042, 'PTHR10288:SF259', NULL, NULL, NULL, NULL, 'POLY(RC)-BINDING-LIKE PROTEIN', 249849),
(398043, 'PTHR10288:SF137', NULL, NULL, NULL, NULL, 'RNA-BINDING KH DOMAIN-CONTAINING PROTEIN', 249849),
(398044, 'PTHR10288:SF335', NULL, NULL, NULL, NULL, 'BINDING TO TOMV RNA 1L (LONG FORM)-RELATED', 249849),
(398045, 'PTHR10288:SF92', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR 2 MRNA-BINDING PROTEIN 1', 249849),
(398046, 'PTHR10288:SF334', NULL, NULL, NULL, NULL, 'RNA-BINDING KH DOMAIN-CONTAINING PROTEIN', 249849),
(398047, 'PTHR10288:SF257', NULL, NULL, NULL, NULL, 'OS09G0498600 PROTEIN', 249849),
(398048, 'PTHR10288:SF292', NULL, NULL, NULL, NULL, 'BNAA05G28360D PROTEIN', 249849),
(398049, 'PTHR10288:SF171', NULL, NULL, NULL, NULL, 'P-ELEMENT SOMATIC INHIBITOR, ISOFORM C', 249849),
(398050, 'PTHR10288:SF251', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 14-LIKE', 249849),
(398051, 'PTHR10288:SF173', NULL, NULL, NULL, NULL, 'KH DOMAIN-CONTAINING PROTEIN HEN4-RELATED', 249849),
(398052, 'PTHR10288:SF99', NULL, NULL, NULL, NULL, 'FAR UPSTREAM ELEMENT-BINDING PROTEIN 1', 249849),
(398053, 'PTHR10288:SF267', NULL, NULL, NULL, NULL, 'F7A19.25 PROTEIN', 249849),
(398054, 'PTHR10288:SF145', NULL, NULL, NULL, NULL, 'KH DOMAIN-CONTAINING PROTEIN', 249849),
(398055, 'PTHR10288:SF101', NULL, NULL, NULL, NULL, 'FAR UPSTREAM ELEMENT-BINDING PROTEIN 2', 249849),
(398056, 'PTHR10288:SF265', NULL, NULL, NULL, NULL, 'POLY(RC)-BINDING PROTEIN 4-LIKE', 249849),
(398057, 'PTHR10288:SF264', NULL, NULL, NULL, NULL, 'FLOWERING LOCUS K HOMOLOGY DOMAIN', 249849),
(398058, 'PTHR10288:SF148', NULL, NULL, NULL, NULL, 'IGF-II MRNA-BINDING PROTEIN, ISOFORM L', 249849),
(398059, 'PTHR10288:SF269', NULL, NULL, NULL, NULL, 'RNA-BINDING KH DOMAIN-CONTAINING PROTEIN', 249849),
(398060, 'PTHR10288:SF302', NULL, NULL, NULL, NULL, 'FAR UPSTREAM ELEMENT-BINDING PROTEIN 1-LIKE ISOFORM X1', 249849),
(398061, 'PTHR10288:SF268', NULL, NULL, NULL, NULL, 'FLOWERING LOCUS K HOMOLOGY DOMAIN-LIKE ISOFORM X1', 249849),
(398062, 'PTHR10288:SF263', NULL, NULL, NULL, NULL, 'KH DOMAIN CONTAINING PROTEIN, EXPRESSED', 249849),
(398063, 'PTHR10288:SF142', NULL, NULL, NULL, NULL, 'PASILLA, ISOFORM R', 249849),
(398064, 'PTHR10288:SF140', NULL, NULL, NULL, NULL, 'FUBP (FUBP) LIKE', 249849),
(398065, 'PTHR10288:SF260', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN K', 249849),
(398066, 'PTHR10288:SF229', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN NOVA-1', 249849),
(398067, 'PTHR10288:SF305', NULL, NULL, NULL, NULL, 'BNAA06G33840D PROTEIN', 249849),
(398068, 'PTHR10288:SF309', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RNP K-LIKE PROTEIN 2', 249849),
(398069, 'PTHR10288:SF234', NULL, NULL, NULL, NULL, 'FAR UPSTREAM ELEMENT-BINDING PROTEIN 3', 249849),
(398070, 'PTHR10288:SF278', NULL, NULL, NULL, NULL, 'BNAC01G41560D PROTEIN', 249849),
(398071, 'PTHR10288:SF277', NULL, NULL, NULL, NULL, 'RNA-BINDING KH DOMAIN-CONTAINING PROTEIN PEPPER', 249849),
(398072, 'PTHR10288:SF154', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 31', 249849),
(398073, 'PTHR10288:SF315', NULL, NULL, NULL, NULL, 'RNA-BINDING KH DOMAIN-CONTAINING PROTEIN PEPPER-LIKE', 249849),
(398074, 'PTHR10288:SF158', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR 2 MRNA-BINDING PROTEIN 3', 249849),
(398075, 'PTHR10288:SF312', NULL, NULL, NULL, NULL, 'TWENTY ONE U-RNA (21U-RNA) BIOGENESIS FOULED UP', 249849),
(398076, 'PTHR10288:SF279', NULL, NULL, NULL, NULL, 'POLY(RC)-BINDING PROTEIN 4', 249849),
(398077, 'PTHR10288:SF270', NULL, NULL, NULL, NULL, '', 249849),
(398078, 'PTHR10288:SF274', NULL, NULL, NULL, NULL, 'KH DOMAIN-CONTAINING PROTEIN', 249849),
(398079, 'PTHR10288:SF273', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 36', 249849),
(398080, 'PTHR10288:SF271', NULL, NULL, NULL, NULL, 'BNAC09G50550D PROTEIN', 249849),
(398081, 'PTHR10288:SF318', NULL, NULL, NULL, NULL, 'K-LIKE DOMAIN PROTEIN-RELATED', 249849);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(398082, 'PTHR10288', NULL, NULL, NULL, NULL, 'KH DOMAIN CONTAINING RNA BINDING PROTEIN', 249849),
(398083, 'PTHR10288:SF239', NULL, NULL, NULL, NULL, 'KH DOMAIN-CONTAINING PROTEIN', 249849),
(398084, 'PTHR10288:SF289', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN NOVA-1', 249849),
(398085, 'PTHR10288:SF244', NULL, NULL, NULL, NULL, '', 249849),
(398086, 'PTHR10288:SF321', NULL, NULL, NULL, NULL, 'MUSHROOM-BODY EXPRESSED, ISOFORM K', 249849),
(398087, 'PTHR10288:SF243', NULL, NULL, NULL, NULL, 'RNA-BINDING KH DOMAIN-CONTAINING PROTEIN', 249849),
(398088, 'PTHR10288:SF166', NULL, NULL, NULL, NULL, 'POLY(RC)-BINDING PROTEIN 4', 249849),
(398089, 'PTHR10288:SF286', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 44', 249849),
(398090, 'PTHR10288:SF326', NULL, NULL, NULL, NULL, 'BNAC03G71240D PROTEIN', 249849),
(398091, 'PTHR10288:SF325', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 14', 249849),
(398092, 'PTHR10288:SF324', NULL, NULL, NULL, NULL, 'K-LIKE DOMAIN PROTEIN-RELATED', 249849),
(398093, 'PTHR10288:SF247', NULL, NULL, NULL, NULL, 'NUCLEIC ACID BINDING PROTEIN', 249849),
(398094, 'PTHR10288:SF323', NULL, NULL, NULL, NULL, 'BNAANNG09240D PROTEIN', 249849),
(398095, 'PTHR10288:SF169', NULL, NULL, NULL, NULL, 'OS02G0125500 PROTEIN', 249849),
(398096, 'PTHR10288:SF284', NULL, NULL, NULL, NULL, 'BNAA10G06430D PROTEIN', 249849),
(398097, 'PTHR10288:SF162', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN NOVA-2', 249849),
(398098, 'PTHR10288:SF283', NULL, NULL, NULL, NULL, 'LOW QUALITY PROTEIN: FLOWERING LOCUS K HOMOLOGY DOMAIN', 249849),
(398099, 'PTHR10288:SF329', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 14-LIKE', 249849),
(398100, 'PTHR10288:SF328', NULL, NULL, NULL, NULL, 'BNAA06G08990D PROTEIN', 249849),
(398101, 'PTHR10288:SF327', NULL, NULL, NULL, NULL, '', 249849),
(398102, 'PTHR21654:SF90', NULL, NULL, NULL, NULL, 'MYB-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 249850),
(398103, 'PTHR21654:SF91', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN-RELATED', 249850),
(398104, 'PTHR21654:SF92', NULL, NULL, NULL, NULL, 'BNAA03G01020D PROTEIN', 249850),
(398105, 'PTHR21654:SF21', NULL, NULL, NULL, NULL, 'GT-2-LIKE 1', 249850),
(398106, 'PTHR21654:SF65', NULL, NULL, NULL, NULL, 'TRIHELIX TRANSCRIPTION FACTOR GT-2', 249850),
(398107, 'PTHR21654:SF66', NULL, NULL, NULL, NULL, 'TRIHELIX TRANSCRIPTION FACTOR GT-3B', 249850),
(398108, 'PTHR21654:SF88', NULL, NULL, NULL, NULL, 'BNACNNG46430D PROTEIN', 249850),
(398109, 'PTHR21654:SF24', NULL, NULL, NULL, NULL, 'GT-2-LIKE 1', 249850),
(398110, 'PTHR21654:SF61', NULL, NULL, NULL, NULL, 'TRIHELIX TRANSCRIPTION FACTOR GTL2', 249850),
(398111, 'PTHR21654:SF83', NULL, NULL, NULL, NULL, 'BNAANNG11490D PROTEIN', 249850),
(398112, 'PTHR21654:SF62', NULL, NULL, NULL, NULL, 'TRIHELIX TRANSCRIPTION FACTOR GT-2-LIKE', 249850),
(398113, 'PTHR21654:SF84', NULL, NULL, NULL, NULL, 'SI:DKEY-66I24.7', 249850),
(398114, 'PTHR21654:SF85', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB FAMILY-RELATED', 249850),
(398115, 'PTHR21654:SF63', NULL, NULL, NULL, NULL, 'MYB-LIKE DOMAIN-CONTAINING PROTEIN', 249850),
(398116, 'PTHR21654:SF86', NULL, NULL, NULL, NULL, 'OS04G0486400 PROTEIN', 249850),
(398117, 'PTHR21654:SF102', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GT-3B', 249850),
(398118, 'PTHR21654:SF103', NULL, NULL, NULL, NULL, 'TRIHELIX TRANSCRIPTION FACTOR GTL1-LIKE', 249850),
(398119, 'PTHR21654', NULL, NULL, NULL, NULL, 'FI21293P1', 249850),
(398120, 'PTHR21654:SF101', NULL, NULL, NULL, NULL, 'MYB-LIKE DOMAIN-CONTAINING PROTEIN', 249850),
(398121, 'PTHR21654:SF60', NULL, NULL, NULL, NULL, 'TRIHELIX TRANSCRIPTION FACTOR PTL', 249850),
(398122, 'PTHR21654:SF54', NULL, NULL, NULL, NULL, 'TRIHELIX TRANSCRIPTION FACTOR GT-1', 249850),
(398123, 'PTHR21654:SF76', NULL, NULL, NULL, NULL, 'MYB-LIKE DOMAIN-CONTAINING PROTEIN', 249850),
(398124, 'PTHR21654:SF77', NULL, NULL, NULL, NULL, 'TRIHELIX TRANSCRIPTION FACTOR PTL-LIKE', 249850),
(398125, 'PTHR21654:SF99', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DNA-BINDING DOMAIN PROTEIN', 249850);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(398126, 'PTHR21654:SF78', NULL, NULL, NULL, NULL, 'SANT/MYB DOMAIN-CONTAINING PROTEIN-RELATED', 249850),
(398127, 'PTHR21654:SF94', NULL, NULL, NULL, NULL, 'BNAA02G17830D PROTEIN', 249850),
(398128, 'PTHR21654:SF73', NULL, NULL, NULL, NULL, 'TRIHELIX TRANSCRIPTION FACTOR GT-2', 249850),
(398129, 'PTHR21654:SF96', NULL, NULL, NULL, NULL, 'TRIHELIX TRANSCRIPTION FACTOR GT-3A', 249850),
(398130, 'PTHR21654:SF97', NULL, NULL, NULL, NULL, 'TRIHELIX TRANSCRIPTION FACTOR GT-4', 249850),
(398131, 'PTHR21654:SF31', NULL, NULL, NULL, NULL, 'TRIHELIX TRANSCRIPTION FACTOR GTL2', 249850),
(398132, 'PTHR21654:SF75', NULL, NULL, NULL, NULL, 'SANT/MYB DOMAIN-CONTAINING PROTEIN-RELATED', 249850),
(398133, 'PTHR21654:SF7', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN', 249850),
(398134, 'PTHR21654:SF14', NULL, NULL, NULL, NULL, 'TRIHELIX TRANSCRIPTION FACTOR GT-2-LIKE', 249850),
(398135, 'PTHR21654:SF106', NULL, NULL, NULL, NULL, 'TRIHELIX TRANSCRIPTION FACTOR PTL-LIKE', 249850),
(398136, 'PTHR21654:SF107', NULL, NULL, NULL, NULL, 'TRIHELIX TRANSCRIPTION FACTOR PTL-LIKE', 249850),
(398137, 'PTHR21654:SF59', NULL, NULL, NULL, NULL, 'TRIHELIX TRANSCRIPTION FACTOR DF1', 249850),
(398138, 'PTHR21654:SF104', NULL, NULL, NULL, NULL, 'BNACNNG02650D PROTEIN', 249850),
(398139, 'PTHR21654:SF105', NULL, NULL, NULL, NULL, 'MYB-LIKE DOMAIN-CONTAINING PROTEIN', 249850),
(398140, 'PTHR35800', NULL, NULL, NULL, NULL, 'PROTEIN JAG', 249851),
(398141, 'PTHR35800:SF1', NULL, NULL, NULL, NULL, 'PROTEIN JAG', 249851),
(398142, 'PTHR13742:SF31', NULL, NULL, NULL, NULL, 'BNACNNG22930D PROTEIN', 249852),
(398143, 'PTHR13742:SF20', NULL, NULL, NULL, NULL, 'RETINOBLASTOMA-LIKE PROTEIN 1', 249852),
(398144, 'PTHR13742:SF32', NULL, NULL, NULL, NULL, 'RB_A DOMAIN-CONTAINING PROTEIN', 249852),
(398145, 'PTHR13742:SF8', NULL, NULL, NULL, NULL, 'RETINOBLASTOMA-LIKE PROTEIN 2', 249852),
(398146, 'PTHR13742', NULL, NULL, NULL, NULL, 'RETINOBLASTOMA-ASSOCIATED PROTEIN  RB -RELATED', 249852),
(398147, 'PTHR13742:SF17', NULL, NULL, NULL, NULL, 'RETINOBLASTOMA-ASSOCIATED PROTEIN', 249852),
(398148, 'PTHR13742:SF22', NULL, NULL, NULL, NULL, 'RETINOBLASTOMA-RELATED PROTEIN 2', 249852),
(398149, 'PTHR13742:SF35', NULL, NULL, NULL, NULL, '', 249852),
(398150, 'PTHR33886:SF8', NULL, NULL, NULL, NULL, 'WALL GLYCOSYL HYDROLASE YTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G14630)-RELATED', 249853),
(398151, 'PTHR33886:SF10', NULL, NULL, NULL, NULL, 'UNSATURATED RHAMNOGALACTURONAN HYDROLASE (EUROFUNG)', 249853),
(398152, 'PTHR33886', NULL, NULL, NULL, NULL, 'UNSATURATED RHAMNOGALACTURONAN HYDROLASE (EUROFUNG)', 249853),
(398153, 'PTHR33886:SF9', NULL, NULL, NULL, NULL, 'UNSATURATED RHAMNOGALACTURONAN HYDROLASE (EUROFUNG)', 249853),
(398154, 'PTHR47167', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE TAO1-LIKE PROTEIN', 249854),
(398155, 'PTHR47167:SF8', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE TAO1', 249854),
(398156, 'PTHR47167:SF4', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE TAO', 249854),
(398157, 'PTHR47167:SF7', NULL, NULL, NULL, NULL, 'TAO KINASE 3', 249854),
(398158, 'PTHR47167:SF6', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE TAO2', 249854),
(398159, 'PTHR47303:SF1', NULL, NULL, NULL, NULL, 'NF-KAPPA-B INHIBITOR BETA', 249855),
(398160, 'PTHR47303', NULL, NULL, NULL, NULL, '', 249855),
(398161, 'PTHR21625:SF1', NULL, NULL, NULL, NULL, 'DYNEIN REGULATORY COMPLEX PROTEIN 1', 249856),
(398162, 'PTHR21625', NULL, NULL, NULL, NULL, 'NYD-SP28 PROTEIN', 249856),
(398163, 'PTHR21625:SF0', NULL, NULL, NULL, NULL, 'DYNEIN REGULATORY COMPLEX SUBUNIT 2', 249856),
(398164, 'PTHR40765:SF2', NULL, NULL, NULL, NULL, 'ESX-2 SECRETION SYSTEM ATPASE ECCB2', 249857),
(398165, 'PTHR40765', NULL, NULL, NULL, NULL, 'ESX-2 SECRETION SYSTEM ATPASE ECCB2', 249857),
(398166, 'PTHR14235:SF0', NULL, NULL, NULL, NULL, 'OSTEOCALCIN', 249858),
(398167, 'PTHR14235', NULL, NULL, NULL, NULL, 'OSTEOCALCIN', 249858),
(398168, 'PTHR13266:SF2', NULL, NULL, NULL, NULL, 'PI31_PROT_N DOMAIN-CONTAINING PROTEIN', 249859),
(398169, 'PTHR13266:SF1', NULL, NULL, NULL, NULL, 'PROTEASOME INHIBITOR PI31 SUBUNIT', 249859);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(398170, 'PTHR13266', NULL, NULL, NULL, NULL, 'PROTEASOME INHIBITOR', 249859),
(398171, 'PTHR12441:SF14', NULL, NULL, NULL, NULL, 'ATP SYNTHASE PERIPHERAL STALK SUBUNIT F6', 249860),
(398172, 'PTHR12441:SF13', NULL, NULL, NULL, NULL, 'ATP SYNTHASE-COUPLING FACTOR 6, MITOCHONDRIAL', 249860),
(398173, 'PTHR12441:SF10', NULL, NULL, NULL, NULL, 'ATP SYNTHASE-COUPLING FACTOR 6, MITOCHONDRIAL', 249860),
(398174, 'PTHR12441', NULL, NULL, NULL, NULL, 'ATP SYNTHASE COUPLING FACTOR 6, MITOCHONDRIAL', 249860),
(398175, 'PTHR28469:SF1', NULL, NULL, NULL, NULL, 'ECTODYSPLASIN-A RECEPTOR-ASSOCIATED ADAPTER PROTEIN', 249861),
(398176, 'PTHR28469', NULL, NULL, NULL, NULL, 'ECTODYSPLASIN-A RECEPTOR-ASSOCIATED ADAPTER PROTEIN', 249861),
(398177, 'PTHR23006:SF0', NULL, NULL, NULL, NULL, 'GLUTAMATE-RICH PROTEIN 5', 249862),
(398178, 'PTHR23006', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 249862),
(398179, 'PTHR37249:SF3', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 249863),
(398180, 'PTHR37249:SF7', NULL, NULL, NULL, NULL, 'BNACNNG03800D PROTEIN', 249863),
(398181, 'PTHR37249:SF6', NULL, NULL, NULL, NULL, 'OS03G0206201 PROTEIN', 249863),
(398182, 'PTHR37249:SF8', NULL, NULL, NULL, NULL, '', 249863),
(398183, 'PTHR37249', NULL, NULL, NULL, NULL, 'OS03G0206201 PROTEIN', 249863),
(398184, 'PTHR45528:SF8', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE', 249864),
(398185, 'PTHR45528', NULL, NULL, NULL, NULL, 'SENSOR HISTIDINE KINASE CPXA', 249864),
(398186, 'PTHR45528:SF1', NULL, NULL, NULL, NULL, 'SENSOR HISTIDINE KINASE CPXA', 249864),
(398187, 'PTHR45528:SF10', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE', 249864),
(398188, 'PTHR45528:SF11', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE', 249864),
(398189, 'PTHR45528:SF9', NULL, NULL, NULL, NULL, 'SENSOR HISTIDINE KINASE YBDK', 249864),
(398190, 'PTHR11538:SF104', NULL, NULL, NULL, NULL, 'DUF2431 DOMAIN-CONTAINING PROTEIN', 249865),
(398191, 'PTHR11538:SF81', NULL, NULL, NULL, NULL, 'DUF2431 DOMAIN-CONTAINING PROTEIN', 249865),
(398192, 'PTHR11538:SF82', NULL, NULL, NULL, NULL, 'DUF2431 DOMAIN-CONTAINING PROTEIN', 249865),
(398193, 'PTHR11538:SF100', NULL, NULL, NULL, NULL, 'DUF2431 DOMAIN-CONTAINING PROTEIN', 249865),
(398194, 'PTHR11538:SF40', NULL, NULL, NULL, NULL, 'PHENYLALANINE--TRNA LIGASE ALPHA SUBUNIT', 249865),
(398195, 'PTHR11538:SF62', NULL, NULL, NULL, NULL, 'ATP-BINDING PROTEIN (DUF2431)', 249865),
(398196, 'PTHR11538:SF84', NULL, NULL, NULL, NULL, 'DUF2431 DOMAIN-CONTAINING PROTEIN', 249865),
(398197, 'PTHR11538:SF101', NULL, NULL, NULL, NULL, 'DUF2431 DOMAIN-CONTAINING PROTEIN', 249865),
(398198, 'PTHR11538:SF41', NULL, NULL, NULL, NULL, 'PHENYLALANINE--TRNA LIGASE, MITOCHONDRIAL', 249865),
(398199, 'PTHR11538:SF63', NULL, NULL, NULL, NULL, 'DUF2431 DOMAIN-CONTAINING PROTEIN', 249865),
(398200, 'PTHR11538:SF102', NULL, NULL, NULL, NULL, '', 249865),
(398201, 'PTHR11538:SF85', NULL, NULL, NULL, NULL, 'DUF2431 DOMAIN-CONTAINING PROTEIN', 249865),
(398202, 'PTHR11538:SF103', NULL, NULL, NULL, NULL, 'DUF2431 DOMAIN PROTEIN', 249865),
(398203, 'PTHR11538:SF86', NULL, NULL, NULL, NULL, 'DUF2431 DOMAIN-CONTAINING PROTEIN', 249865),
(398204, 'PTHR11538:SF64', NULL, NULL, NULL, NULL, 'DUF2431 DOMAIN-CONTAINING PROTEIN', 249865),
(398205, 'PTHR11538:SF98', NULL, NULL, NULL, NULL, 'PHENYLALANINE--TRNA LIGASE', 249865),
(398206, 'PTHR11538:SF77', NULL, NULL, NULL, NULL, 'DUF2431 DOMAIN-CONTAINING PROTEIN', 249865),
(398207, 'PTHR11538', NULL, NULL, NULL, NULL, 'PHENYLALANYL-TRNA SYNTHETASE', 249865),
(398208, 'PTHR11538:SF99', NULL, NULL, NULL, NULL, 'DUF2431 DOMAIN PROTEIN', 249865),
(398209, 'PTHR11538:SF78', NULL, NULL, NULL, NULL, 'PHENYLALANINE--TRNA LIGASE', 249865),
(398210, 'PTHR11538:SF38', NULL, NULL, NULL, NULL, 'O-PHOSPHOSERINE--TRNA(CYS) LIGASE', 249865),
(398211, 'PTHR11538:SF70', NULL, NULL, NULL, NULL, 'DUF2431 DOMAIN-CONTAINING PROTEIN', 249865),
(398212, 'PTHR11538:SF95', NULL, NULL, NULL, NULL, 'DUF2431 DOMAIN-CONTAINING PROTEIN', 249865),
(398213, 'PTHR11538:SF96', NULL, NULL, NULL, NULL, 'DUF2431 DOMAIN-CONTAINING PROTEIN', 249865),
(398214, 'PTHR11538:SF97', NULL, NULL, NULL, NULL, 'DUF2431 DOMAIN-CONTAINING PROTEIN', 249865);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(398215, 'PTHR11538:SF65', NULL, NULL, NULL, NULL, 'SMALL DOMAIN PROTEIN, PUTATIVE (DUF2431)-RELATED', 249865),
(398216, 'PTHR11538:SF87', NULL, NULL, NULL, NULL, 'DUF2431 DOMAIN-CONTAINING PROTEIN', 249865),
(398217, 'PTHR11538:SF89', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF2431)-RELATED', 249865),
(398218, 'PTHR11538:SF26', NULL, NULL, NULL, NULL, 'FERREDOXIN-FOLD ANTICODON-BINDING DOMAIN-CONTAINING PROTEIN 1', 249865),
(398219, 'PTHR44665:SF1', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 14', 249866),
(398220, 'PTHR44665', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 14', 249866),
(398221, 'PTHR20583:SF1', NULL, NULL, NULL, NULL, 'TRIPLE QXXK/R MOTIF-CONTAINING PROTEIN', 249867),
(398222, 'PTHR20583', NULL, NULL, NULL, NULL, 'TRIPLE QXXK/R MOTIF-CONTAINING PROTEIN', 249867),
(398223, 'PTHR11807:SF12', NULL, NULL, NULL, NULL, 'CYTOPLASMIC TRNA 2-THIOLATION PROTEIN 1', 249868),
(398224, 'PTHR11807', NULL, NULL, NULL, NULL, 'ATPASES OF THE PP SUPERFAMILY-RELATED', 249868),
(398225, 'PTHR11807:SF27', NULL, NULL, NULL, NULL, 'TRNA-5-METHYLURIDINE(54) 2-SULFURTRANSFERASE', 249868),
(398226, 'PTHR47721:SF2', NULL, NULL, NULL, NULL, 'OS01G0235100 PROTEIN', 249869),
(398227, 'PTHR47721', NULL, NULL, NULL, NULL, 'OS01G0235100 PROTEIN', 249869),
(398228, 'PTHR21705:SF11', NULL, NULL, NULL, NULL, 'FHIP FAMILY PROTEIN CG3558', 249870),
(398229, 'PTHR21705', NULL, NULL, NULL, NULL, 'RAI16 PROTEIN-RELATED', 249870),
(398230, 'PTHR21705:SF12', NULL, NULL, NULL, NULL, 'AGAP003125-PA', 249870),
(398231, 'PTHR21705:SF4', NULL, NULL, NULL, NULL, 'FHF COMPLEX SUBUNIT HOOK INTERACTING PROTEIN 1B', 249870),
(398232, 'PTHR21705:SF10', NULL, NULL, NULL, NULL, 'FHF COMPLEX SUBUNIT HOOK INTERACTING PROTEIN 2A', 249870),
(398233, 'PTHR21705:SF6', NULL, NULL, NULL, NULL, 'FHF COMPLEX SUBUNIT HOOK INTERACTING PROTEIN 1A', 249870),
(398234, 'PTHR21705:SF9', NULL, NULL, NULL, NULL, 'FHF COMPLEX SUBUNIT HOOK INTERACTING PROTEIN 2B', 249870),
(398235, 'PTHR30149', NULL, NULL, NULL, NULL, 'HYDROGENASE PROTEIN ASSEMBLY PROTEIN HYPD', 249871),
(398236, 'PTHR30149:SF0', NULL, NULL, NULL, NULL, 'HYDROGENASE MATURATION FACTOR HYPD', 249871),
(398237, 'PTHR47023:SF3', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 249872),
(398238, 'PTHR47023:SF1', NULL, NULL, NULL, NULL, 'SEX PEPTIDE RECEPTOR', 249872),
(398239, 'PTHR47023', NULL, NULL, NULL, NULL, 'SEX PEPTIDE RECEPTOR', 249872),
(398240, 'PTHR47023:SF6', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', 249872),
(398241, 'PTHR47023:SF5', NULL, NULL, NULL, NULL, 'SEX PEPTIDE RECEPTOR-RELATED PROTEIN 2', 249872),
(398242, 'PTHR15176', NULL, NULL, NULL, NULL, 'NEPHROCYSTIN', 249873),
(398243, 'PTHR15176:SF1', NULL, NULL, NULL, NULL, 'NEPHROCYSTIN-1', 249873),
(398244, 'PTHR10316:SF12', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED GUANYLATE KINASE, WW AND PDZ DOMAIN-CONTAINING PROTEIN 1', 249874),
(398245, 'PTHR10316:SF77', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED GUANYLATE KINASE, WW AND PDZ DOMAIN-CONTAINING 1A', 249874),
(398246, 'PTHR10316:SF10', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED GUANYLATE KINASE, WW AND PDZ DOMAIN-CONTAINING PROTEIN 3', 249874),
(398247, 'PTHR10316:SF65', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED GUANYLATE KINASE, WW AND PDZ DOMAIN-CONTAINING 3B', 249874),
(398248, 'PTHR10316:SF76', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED GUANYLATE KINASE, WW AND PDZ DOMAIN-CONTAINING 2A', 249874),
(398249, 'PTHR10316:SF27', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED GUANYLATE KINASE, WW AND PDZ DOMAIN-CONTAINING PROTEIN 2', 249874),
(398250, 'PTHR10316:SF68', NULL, NULL, NULL, NULL, 'AGAP003128-PA', 249874),
(398251, 'PTHR10316', NULL, NULL, NULL, NULL, 'MEMBRANE ASSOCIATED GUANYLATE KINASE-RELATED', 249874),
(398252, 'PTHR10316:SF41', NULL, NULL, NULL, NULL, 'MAGI FAMILY MEMBER, X-LINKED A', 249874),
(398253, 'PTHR10316:SF40', NULL, NULL, NULL, NULL, 'LD27118P', 249874),
(398254, 'PTHR16166', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN  VPS13', 249875),
(398255, 'PTHR16166:SF93', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 13', 249875);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(398256, 'PTHR16166:SF22', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 13A', 249875),
(398257, 'PTHR16166:SF97', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 13F-RELATED', 249875),
(398258, 'PTHR16166:SF91', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 13B-RELATED', 249875),
(398259, 'PTHR16166:SF140', NULL, NULL, NULL, NULL, 'CHOREIN_N DOMAIN-CONTAINING PROTEIN', 249875),
(398260, 'PTHR16166:SF130', NULL, NULL, NULL, NULL, 'PROTEIN SORTING-ASSOCIATED PROTEIN, PUTATIVE (DUF1162)-RELATED', 249875),
(398261, 'PTHR16166:SF141', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 13D', 249875),
(398262, 'PTHR16166:SF142', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 13B', 249875),
(398263, 'PTHR16166:SF143', NULL, NULL, NULL, NULL, 'PROTEIN SORTING-ASSOCIATED PROTEIN, PUTATIVE (DUF1162)-RELATED', 249875),
(398264, 'PTHR16166:SF111', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 13E-RELATED', 249875),
(398265, 'PTHR16166:SF113', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 13C-RELATED', 249875),
(398266, 'PTHR16166:SF136', NULL, NULL, NULL, NULL, 'OS12G0594200 PROTEIN', 249875),
(398267, 'PTHR16166:SF125', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 13C', 249875),
(398268, 'PTHR16166:SF137', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY (PH) DOMAIN-CONTAINING PROTEIN', 249875),
(398269, 'PTHR16166:SF138', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 13D-RELATED', 249875),
(398270, 'PTHR48228:SF7', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA TRANSFERASE RV3272-RELATED', 249876),
(398271, 'PTHR48228:SF6', NULL, NULL, NULL, NULL, 'L-CARNITINE COA-TRANSFERASE', 249876),
(398272, 'PTHR48228:SF5', NULL, NULL, NULL, NULL, 'ALPHA-METHYLACYL-COA RACEMASE', 249876),
(398273, 'PTHR48228:SF4', NULL, NULL, NULL, NULL, 'BLR3030 PROTEIN', 249876),
(398274, 'PTHR48228:SF2', NULL, NULL, NULL, NULL, 'E-CINNAMOYL-COA:R-PHENYLLACTATE COA TRANSFERASE LARGE SUBUNIT', 249876),
(398275, 'PTHR48228', NULL, NULL, NULL, NULL, 'SUCCINYL-COA--D-CITRAMALATE COA-TRANSFERASE', 249876),
(398276, 'PTHR46520:SF1', NULL, NULL, NULL, NULL, 'SERINE BETA-LACTAMASE-LIKE PROTEIN LACTB, MITOCHONDRIAL', 249877),
(398277, 'PTHR46520', NULL, NULL, NULL, NULL, 'SERINE BETA-LACTAMASE-LIKE PROTEIN LACTB, MITOCHONDRIAL', 249877),
(398278, 'PTHR20837:SF0', NULL, NULL, NULL, NULL, 'COILED-COIL AND C2 DOMAIN-CONTAINING PROTEIN 2A', 249878),
(398279, 'PTHR20837:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CC2D2B', 249878),
(398280, 'PTHR20837', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN-RELATED', 249878),
(398281, 'PTHR20837:SF7', NULL, NULL, NULL, NULL, 'COILED-COIL AND C2 DOMAIN-CONTAINING PROTEIN 2A', 249878),
(398282, 'PTHR35470:SF7', NULL, NULL, NULL, NULL, 'OS02G0208500 PROTEIN', 249879),
(398283, 'PTHR35470:SF6', NULL, NULL, NULL, NULL, 'CYSTM DOMAIN-CONTAINING PROTEIN', 249879),
(398284, 'PTHR35470', NULL, NULL, NULL, NULL, 'CADMIUM TOLERANT 3', 249879),
(398285, 'PTHR35470:SF4', NULL, NULL, NULL, NULL, 'CYSTM DOMAIN-CONTAINING PROTEIN', 249879),
(398286, 'PTHR35470:SF9', NULL, NULL, NULL, NULL, 'CADMIUM TOLERANT 3', 249879),
(398287, 'PTHR33887:SF5', NULL, NULL, NULL, NULL, '', 249880),
(398288, 'PTHR33887:SF4', NULL, NULL, NULL, NULL, 'AB2-183', 249880),
(398289, 'PTHR33887', NULL, NULL, NULL, NULL, '', 249880),
(398290, 'PTHR33887:SF1', NULL, NULL, NULL, NULL, 'GENE 867-RELATED', 249880),
(398291, 'PTHR33887:SF2', NULL, NULL, NULL, NULL, '', 249880),
(398292, 'PTHR46809:SF7', NULL, NULL, NULL, NULL, 'STROMAL CELL-DERIVED FACTOR-RELATED', 249881),
(398293, 'PTHR46809:SF6', NULL, NULL, NULL, NULL, 'BNAA09G55850D PROTEIN', 249881),
(398294, 'PTHR46809:SF5', NULL, NULL, NULL, NULL, 'OS08G0440500 PROTEIN', 249881),
(398295, 'PTHR46809:SF3', NULL, NULL, NULL, NULL, 'STROMAL CELL-DERIVED FACTOR 2', 249881),
(398296, 'PTHR46809', NULL, NULL, NULL, NULL, 'STROMAL CELL-DERIVED FACTOR 2-LIKE PROTEIN', 249881),
(398297, 'PTHR46809:SF2', NULL, NULL, NULL, NULL, 'STROMAL CELL-DERIVED FACTOR 2-LIKE PROTEIN', 249881);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(398298, 'PTHR46809:SF1', NULL, NULL, NULL, NULL, 'STROMAL CELL-DERIVED FACTOR 2-LIKE PROTEIN 1', 249881),
(398299, 'PTHR43241', NULL, NULL, NULL, NULL, 'FLAVIN REDUCTASE DOMAIN PROTEIN', 249882),
(398300, 'PTHR43241:SF1', NULL, NULL, NULL, NULL, 'FLAVIN_REDUCT DOMAIN-CONTAINING PROTEIN', 249882),
(398301, 'PTHR31025:SF24', NULL, NULL, NULL, NULL, '', 249883),
(398302, 'PTHR31025:SF25', NULL, NULL, NULL, NULL, '', 249883),
(398303, 'PTHR31025:SF26', NULL, NULL, NULL, NULL, 'SI:CH211-111E20.1-RELATED', 249883),
(398304, 'PTHR31025:SF19', NULL, NULL, NULL, NULL, 'SI:CH211-155I14.1-RELATED', 249883),
(398305, 'PTHR31025:SF9', NULL, NULL, NULL, NULL, 'SI:CH211-196P9.1-RELATED', 249883),
(398306, 'PTHR31025:SF20', NULL, NULL, NULL, NULL, 'SI:CH211-166E11.5-RELATED', 249883),
(398307, 'PTHR31025', NULL, NULL, NULL, NULL, 'SI:CH211-196P9.1-RELATED', 249883),
(398308, 'PTHR31025:SF22', NULL, NULL, NULL, NULL, 'IP13529P', 249883),
(398309, 'PTHR31025:SF23', NULL, NULL, NULL, NULL, 'SI:CH1073-164K15.3-RELATED', 249883),
(398310, 'PTHR35440:SF1', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 36', 249884),
(398311, 'PTHR35440', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 36', 249884),
(398312, 'PTHR43879', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN', 249885),
(398313, 'PTHR43879:SF1', NULL, NULL, NULL, NULL, 'GLUCOSE IMPORT SYSTEM PERMEASE PROTEIN GLCU', 249885),
(398314, 'PTHR20857:SF23', NULL, NULL, NULL, NULL, 'THIAMINE BIOSYNTHETIC BIFUNCTIONAL ENZYME', 249886),
(398315, 'PTHR20857:SF15', NULL, NULL, NULL, NULL, 'THIAMINE-PHOSPHATE SYNTHASE', 249886),
(398316, 'PTHR20857', NULL, NULL, NULL, NULL, 'THIAMINE-PHOSPHATE PYROPHOSPHORYLASE', 249886),
(398317, 'PTHR20857:SF22', NULL, NULL, NULL, NULL, 'THIAZOLE TAUTOMERASE', 249886),
(398318, 'PTHR12107:SF27', NULL, NULL, NULL, NULL, 'CALCIUM CHANNEL, VOLTAGE-DEPENDENT, GAMMA SUBUNIT 8B', 249887),
(398319, 'PTHR12107:SF5', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL GAMMA-3 SUBUNIT', 249887),
(398320, 'PTHR12107', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL GAMMA SUBUNIT', 249887),
(398321, 'PTHR12107:SF4', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL GAMMA-5 SUBUNIT', 249887),
(398322, 'PTHR12107:SF7', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL GAMMA-4 SUBUNIT', 249887),
(398323, 'PTHR12107:SF6', NULL, NULL, NULL, NULL, 'STARGAZIN (MAMMALIAN CALCIUM CHANNEL) HOMOLOG', 249887),
(398324, 'PTHR12107:SF1', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL GAMMA-2 SUBUNIT', 249887),
(398325, 'PTHR12107:SF0', NULL, NULL, NULL, NULL, 'GH12419P1', 249887),
(398326, 'PTHR12107:SF2', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL GAMMA-8 SUBUNIT', 249887),
(398327, 'PTHR12107:SF12', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL GAMMA-7 SUBUNIT', 249887),
(398328, 'PTHR47533:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG08091', 249888),
(398329, 'PTHR47533:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG12424', 249888),
(398330, 'PTHR47533:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG21859', 249888),
(398331, 'PTHR47533:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG00837', 249888),
(398332, 'PTHR47533', NULL, NULL, NULL, NULL, 'PROTEIN CBG21859', 249888),
(398333, 'PTHR47533:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG21858', 249888),
(398334, 'PTHR36439', NULL, NULL, NULL, NULL, 'BLL4334 PROTEIN', 249889),
(398335, 'PTHR36439:SF1', NULL, NULL, NULL, NULL, 'BLL4334 PROTEIN', 249889),
(398336, 'PTHR16466:SF6', NULL, NULL, NULL, NULL, 'TELOMERIC REPEAT-BINDING FACTOR 2-INTERACTING PROTEIN 1', 249890),
(398337, 'PTHR16466', NULL, NULL, NULL, NULL, 'TELOMERE REPEAT-BINDING FACTOR 2-INTERACTING PROTEIN 1', 249890),
(398338, 'PTHR46707', NULL, NULL, NULL, NULL, 'PROTEIN CBG07468', 249891),
(398339, 'PTHR46707:SF1', NULL, NULL, NULL, NULL, 'COEXPRESSED WITH POLYCYSTINS', 249891),
(398340, 'PTHR10159:SF343', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE 16', 249892),
(398341, 'PTHR10159:SF521', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 249892); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(398342, 'PTHR10159:SF388', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE 9', 249892),
(398343, 'PTHR10159:SF40', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE 5', 249892),
(398344, 'PTHR10159:SF45', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE 6', 249892),
(398345, 'PTHR10159:SF525', NULL, NULL, NULL, NULL, 'MAP KINASE PHOSPHATASE WITH LEUCINE-RICH REPEATS PROTEIN 3', 249892),
(398346, 'PTHR10159:SF503', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE 1B', 249892),
(398347, 'PTHR10159:SF305', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE 7', 249892),
(398348, 'PTHR10159:SF524', NULL, NULL, NULL, NULL, 'SPECIFICITY PROTEIN PHOSPHATASE, PUTATIVE-RELATED', 249892),
(398349, 'PTHR10159:SF109', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE 2', 249892),
(398350, 'PTHR10159:SF108', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE 8', 249892),
(398351, 'PTHR10159:SF526', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE, PUTATIVE-RELATED', 249892),
(398352, 'PTHR10159:SF309', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE 1', 249892),
(398353, 'PTHR10159:SF529', NULL, NULL, NULL, NULL, 'DSPC DOMAIN-CONTAINING PROTEIN', 249892),
(398354, 'PTHR10159:SF528', NULL, NULL, NULL, NULL, 'PUCKERED, ISOFORM A', 249892),
(398355, 'PTHR10159:SF530', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE DDB_G0271350-RELATED', 249892),
(398356, 'PTHR10159:SF299', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE 10', 249892),
(398357, 'PTHR10159:SF111', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE 4', 249892),
(398358, 'PTHR10159:SF519', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE VHP-1', 249892),
(398359, 'PTHR10159', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE', 249892),
(398360, 'PTHR10159:SF314', NULL, NULL, NULL, NULL, 'SI:DKEY-175M17.7', 249892),
(398361, 'PTHR10159:SF511', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE 1', 249892),
(398362, 'PTHR10159:SF414', NULL, NULL, NULL, NULL, 'RHODANESE DOMAIN-CONTAINING DUAL SPECIFICITY PROTEIN PHOSPHATASE-RELATED', 249892),
(398363, 'PTHR10159:SF513', NULL, NULL, NULL, NULL, 'SPECIFICITY PROTEIN PHOSPHATASE, PUTATIVE-RELATED', 249892),
(398364, 'PTHR10159:SF516', NULL, NULL, NULL, NULL, 'SI:CH211-195B15.8', 249892),
(398365, 'PTHR10159:SF515', NULL, NULL, NULL, NULL, 'MAP KINASE PHOSPHATASE WITH LEUCINE-RICH REPEATS PROTEIN 1-RELATED', 249892),
(398366, 'PTHR10159:SF518', NULL, NULL, NULL, NULL, 'BNAA01G23680D PROTEIN', 249892),
(398367, 'PTHR10159:SF517', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE MPK3', 249892),
(398368, 'PTHR43235:SF4', NULL, NULL, NULL, NULL, 'CLASS I GLUTAMINE AMIDOTRANSFERASE-LIKE SUPERFAMILY PROTEIN', 249893),
(398369, 'PTHR43235:SF5', NULL, NULL, NULL, NULL, 'PROTEIN NTPR-LIKE', 249893),
(398370, 'PTHR43235:SF10', NULL, NULL, NULL, NULL, 'GLUTAMINE AMIDOTRANSFERASE PB2B2.05-RELATED', 249893),
(398371, 'PTHR43235:SF1', NULL, NULL, NULL, NULL, 'GLUTAMINE AMIDOTRANSFERASE PB2B2.05-RELATED', 249893),
(398372, 'PTHR43235:SF6', NULL, NULL, NULL, NULL, 'GLUTAMINE AMIDOTRANSFERASE TYPE-1 DOMAIN-CONTAINING PROTEIN', 249893),
(398373, 'PTHR43235:SF8', NULL, NULL, NULL, NULL, 'GLUTAMINE AMIDOTRANSFERASE GAT1_2.1-RELATED', 249893),
(398374, 'PTHR43235', NULL, NULL, NULL, NULL, 'GLUTAMINE AMIDOTRANSFERASE PB2B2.05-RELATED', 249893),
(398375, 'PTHR36476', NULL, NULL, NULL, NULL, 'OREXIGENIC NEUROPEPTIDE QRFP', 249894),
(398376, 'PTHR36476:SF1', NULL, NULL, NULL, NULL, 'OREXIGENIC NEUROPEPTIDE QRFP', 249894),
(398377, 'PTHR45983:SF4', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE NON-RECEPTOR TYPE 18', 249895),
(398378, 'PTHR45983:SF2', NULL, NULL, NULL, NULL, 'TYROSINE PHOSPHATSE N18, PUTATIVE-RELATED', 249895),
(398379, 'PTHR45983', NULL, NULL, NULL, NULL, 'TYROSINE PHOSPHATSE N18, PUTATIVE-RELATED', 249895),
(398380, 'PTHR45983:SF3', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE NON-RECEPTOR TYPE 12', 249895),
(398381, 'PTHR45983:SF1', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE NON-RECEPTOR TYPE 22', 249895);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(398382, 'PTHR24055:SF52', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN-RELATED', 249896),
(398383, 'PTHR24055:SF399', NULL, NULL, NULL, NULL, 'CELL DIVISION CONTROL PROTEIN 2(CCD2)-RELATED PROTEIN KINASE-LIKE', 249896),
(398384, 'PTHR24055:SF432', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398385, 'PTHR24055:SF553', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE P38A-RELATED', 249896),
(398386, 'PTHR24055:SF158', NULL, NULL, NULL, NULL, 'STRESS-ACTIVATED PROTEIN KINASE JNK', 249896),
(398387, 'PTHR24055:SF554', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398388, 'PTHR24055:SF430', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249896),
(398389, 'PTHR24055:SF397', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398390, 'PTHR24055:SF155', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE PMK-3', 249896),
(398391, 'PTHR24055:SF551', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398392, 'PTHR24055:SF552', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 14B', 249896),
(398393, 'PTHR24055:SF431', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 9-LIKE ISOFORM X1', 249896),
(398394, 'PTHR24055:SF153', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398395, 'PTHR24055:SF550', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249896),
(398396, 'PTHR24055:SF154', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE PMK-2', 249896),
(398397, 'PTHR24055:SF393', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 3', 249896),
(398398, 'PTHR24055:SF559', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249896),
(398399, 'PTHR24055:SF439', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 11-RELATED', 249896),
(398400, 'PTHR24055:SF557', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398401, 'PTHR24055:SF558', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249896),
(398402, 'PTHR24055:SF555', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 10', 249896),
(398403, 'PTHR24055:SF556', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249896),
(398404, 'PTHR24055:SF391', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 3', 249896),
(398405, 'PTHR24055:SF392', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 20', 249896),
(398406, 'PTHR24055:SF390', NULL, NULL, NULL, NULL, 'PROTEIN KINASE 5, PUTATIVE-RELATED', 249896),
(398407, 'PTHR24055:SF388', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249896),
(398408, 'PTHR24055:SF146', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 12', 249896),
(398409, 'PTHR24055:SF421', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249896),
(398410, 'PTHR24055:SF422', NULL, NULL, NULL, NULL, 'SYNTHASE KINASE-3 ALPHA, PUTATIVE-RELATED', 249896),
(398411, 'PTHR24055:SF543', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398412, 'PTHR24055:SF420', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 18', 249896),
(398413, 'PTHR24055:SF141', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249896),
(398414, 'PTHR24055:SF429', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 9', 249896),
(398415, 'PTHR24055:SF548', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398416, 'PTHR24055:SF549', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398417, 'PTHR24055:SF546', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE FUS3', 249896),
(398418, 'PTHR24055:SF547', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 249896),
(398419, 'PTHR24055:SF423', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398420, 'PTHR24055:SF148', NULL, NULL, NULL, NULL, 'PROTEIN KINASE, PUTATIVE-RELATED', 249896),
(398421, 'PTHR24055:SF544', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249896);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(398422, 'PTHR24055:SF545', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398423, 'PTHR24055:SF380', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NLK', 249896),
(398424, 'PTHR24055:SF381', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398425, 'PTHR24055:SF260', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE ICK', 249896),
(398426, 'PTHR24055:SF378', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 1', 249896),
(398427, 'PTHR24055:SF496', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398428, 'PTHR24055:SF530', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G02242)-RELATED', 249896),
(398429, 'PTHR24055:SF494', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249896),
(398430, 'PTHR24055:SF253', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249896),
(398431, 'PTHR24055:SF372', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249896),
(398432, 'PTHR24055:SF419', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 249896),
(398433, 'PTHR24055:SF538', NULL, NULL, NULL, NULL, 'INACTIVE SERINE/THREONINE-PROTEIN KINASE DDB_G0274613-RELATED', 249896),
(398434, 'PTHR24055:SF417', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 3', 249896),
(398435, 'PTHR24055:SF414', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 15', 249896),
(398436, 'PTHR24055:SF535', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398437, 'PTHR24055:SF415', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 16', 249896),
(398438, 'PTHR24055:SF533', NULL, NULL, NULL, NULL, 'MAPK/MAK/MRK OVERLAPPING KINASE', 249896),
(398439, 'PTHR24055:SF379', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 14', 249896),
(398440, 'PTHR24055:SF490', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249896),
(398441, 'PTHR24055:SF370', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 7', 249896),
(398442, 'PTHR24055:SF520', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398443, 'PTHR24055:SF488', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398444, 'PTHR24055:SF521', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE SMA-5', 249896),
(398445, 'PTHR24055:SF486', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249896),
(398446, 'PTHR24055:SF483', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249896),
(398447, 'PTHR24055:SF484', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398448, 'PTHR24055:SF403', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398449, 'PTHR24055:SF401', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398450, 'PTHR24055:SF25', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 4', 249896),
(398451, 'PTHR24055:SF480', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE-RELATED', 249896),
(398452, 'PTHR24055:SF510', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 14-RELATED', 249896),
(398453, 'PTHR24055:SF475', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249896),
(398454, 'PTHR24055:SF351', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 12', 249896),
(398455, 'PTHR24055:SF472', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE F-4-LIKE ISOFORM X1', 249896),
(398456, 'PTHR24055:SF110', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 14', 249896),
(398457, 'PTHR24055:SF198', NULL, NULL, NULL, NULL, 'SPORULATION-SPECIFIC MITOGEN-ACTIVATED PROTEIN KINASE SMK1', 249896),
(398458, 'PTHR24055:SF471', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398459, 'PTHR24055:SF517', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398460, 'PTHR24055:SF515', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398461, 'PTHR24055:SF478', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(398462, 'PTHR24055:SF511', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398463, 'PTHR24055:SF508', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN (MAP) KINASE, ERK3/4-RELATED', 249896),
(398464, 'PTHR24055:SF194', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE MAK', 249896),
(398465, 'PTHR24055:SF465', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 249896),
(398466, 'PTHR24055:SF463', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 8', 249896),
(398467, 'PTHR24055:SF188', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249896),
(398468, 'PTHR24055:SF222', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 8', 249896),
(398469, 'PTHR24055:SF464', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249896),
(398470, 'PTHR24055:SF461', NULL, NULL, NULL, NULL, 'OS02G0492300 PROTEIN', 249896),
(398471, 'PTHR24055:SF462', NULL, NULL, NULL, NULL, 'GLH-BINDING KINASE 1-RELATED', 249896),
(398472, 'PTHR24055:SF187', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 8', 249896),
(398473, 'PTHR24055:SF507', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249896),
(398474, 'PTHR24055:SF109', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 11', 249896),
(398475, 'PTHR24055:SF227', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 5', 249896),
(398476, 'PTHR24055:SF502', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398477, 'PTHR24055:SF469', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398478, 'PTHR24055:SF107', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 13', 249896),
(398479, 'PTHR24055:SF347', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN CONTAINING PROTEIN', 249896),
(398480, 'PTHR24055:SF501', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398481, 'PTHR24055:SF79', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 15', 249896),
(398482, 'PTHR24055:SF72', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE MHK', 249896),
(398483, 'PTHR24055', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398484, 'PTHR24055:SF575', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398485, 'PTHR24055:SF576', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN-RELATED', 249896),
(398486, 'PTHR24055:SF573', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398487, 'PTHR24055:SF574', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398488, 'PTHR24055:SF211', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 16', 249896),
(398489, 'PTHR24055:SF178', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398490, 'PTHR24055:SF571', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398491, 'PTHR24055:SF572', NULL, NULL, NULL, NULL, 'SPORULATION PROTEIN KINASE MDE3', 249896),
(398492, 'PTHR24055:SF570', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398493, 'PTHR24055:SF218', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 17', 249896),
(398494, 'PTHR24055:SF456', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 11', 249896),
(398495, 'PTHR24055:SF577', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398496, 'PTHR24055:SF335', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398497, 'PTHR24055:SF578', NULL, NULL, NULL, NULL, 'ATYPICAL SERINE/THREONINE PROTEIN KINASE BUD32', 249896),
(398498, 'PTHR24055:SF171', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 6', 249896),
(398499, 'PTHR24055:SF172', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 9', 249896),
(398500, 'PTHR24055:SF564', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398501, 'PTHR24055:SF565', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE MHK', 249896),
(398502, 'PTHR24055:SF562', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(398503, 'PTHR24055:SF200', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 19', 249896),
(398504, 'PTHR24055:SF563', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 6', 249896),
(398505, 'PTHR24055:SF560', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 17', 249896),
(398506, 'PTHR24055:SF561', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 7', 249896),
(398507, 'PTHR24055:SF162', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 10', 249896),
(398508, 'PTHR24055:SF568', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398509, 'PTHR24055:SF569', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE 1', 249896),
(398510, 'PTHR24055:SF566', NULL, NULL, NULL, NULL, 'ACTIVATED PROTEIN KINASE, PUTATIVE-RELATED', 249896),
(398511, 'PTHR24055:SF567', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398512, 'PTHR24055:SF446', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', 249896),
(398513, 'PTHR35524:SF1', NULL, NULL, NULL, NULL, 'ALPHA-ACETOLACTATE DECARBOXYLASE', 249897),
(398514, 'PTHR35524', NULL, NULL, NULL, NULL, 'ALPHA-ACETOLACTATE DECARBOXYLASE', 249897),
(398515, 'PTHR38553:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG19621', 249898),
(398516, 'PTHR38553', NULL, NULL, NULL, NULL, 'PROTEIN CBG19621', 249898),
(398517, 'PTHR33880:SF11', NULL, NULL, NULL, NULL, '', 249899),
(398518, 'PTHR33880:SF12', NULL, NULL, NULL, NULL, 'TRANSFERRING GLYCOSYL GROUPS, PUTATIVE-RELATED', 249899),
(398519, 'PTHR33880:SF13', NULL, NULL, NULL, NULL, 'TRANSFERASE, TRANSFERRING GLYCOSYL GROUPS', 249899),
(398520, 'PTHR33880:SF4', NULL, NULL, NULL, NULL, 'OS07G0189700 PROTEIN', 249899),
(398521, 'PTHR33880:SF3', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249899),
(398522, 'PTHR33880:SF2', NULL, NULL, NULL, NULL, '', 249899),
(398523, 'PTHR33880', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249899),
(398524, 'PTHR33880:SF16', NULL, NULL, NULL, NULL, 'TRANSFERRING GLYCOSYL GROUP TRANSFERASE', 249899),
(398525, 'PTHR33880:SF17', NULL, NULL, NULL, NULL, 'GLYCOSYL GROUPS, PUTATIVE-RELATED', 249899),
(398526, 'PTHR33880:SF18', NULL, NULL, NULL, NULL, 'TRANSFERRING GLYCOSYL GROUP TRANSFERASE', 249899),
(398527, 'PTHR11261', NULL, NULL, NULL, NULL, 'INTERPHOTORECEPTOR RETINOID-BINDING PROTEIN', 249900),
(398528, 'PTHR11261:SF3', NULL, NULL, NULL, NULL, 'RETINOL-BINDING PROTEIN 3', 249900),
(398529, 'PTHR11261:SF6', NULL, NULL, NULL, NULL, 'RETINOL-BINDING PROTEIN 3', 249900),
(398530, 'PTHR37625', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE LIPOPROTEIN-RELATED', 249901),
(398531, 'PTHR37625:SF4', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE LIPOPROTEIN-RELATED', 249901),
(398532, 'PTHR33258:SF1', NULL, NULL, NULL, NULL, 'TRANSPOSASE INSL FOR INSERTION SEQUENCE ELEMENT IS186A-RELATED', 249902),
(398533, 'PTHR33258', NULL, NULL, NULL, NULL, 'TRANSPOSASE INSL FOR INSERTION SEQUENCE ELEMENT IS186A-RELATED', 249902),
(398534, 'PTHR13593:SF140', NULL, NULL, NULL, NULL, 'OS09G0115600 PROTEIN', 249903),
(398535, 'PTHR13593:SF136', NULL, NULL, NULL, NULL, 'PLC-LIKE PHOSPHODIESTERASES SUPERFAMILY PROTEIN-RELATED', 249903),
(398536, 'PTHR13593:SF115', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 249903),
(398537, 'PTHR13593:SF137', NULL, NULL, NULL, NULL, 'BNAA06G03070D PROTEIN', 249903),
(398538, 'PTHR13593:SF134', NULL, NULL, NULL, NULL, 'F14J22.5 PROTEIN', 249903),
(398539, 'PTHR13593:SF112', NULL, NULL, NULL, NULL, 'PI-PLC X DOMAIN-CONTAINING PROTEIN 1', 249903),
(398540, 'PTHR13593:SF113', NULL, NULL, NULL, NULL, 'FI02810P', 249903),
(398541, 'PTHR13593:SF135', NULL, NULL, NULL, NULL, 'MAP3K-LIKE KINASE', 249903),
(398542, 'PTHR13593:SF133', NULL, NULL, NULL, NULL, 'PI-PLC X DOMAIN PLANT-LIKE PROTEIN', 249903),
(398543, 'PTHR13593:SF131', NULL, NULL, NULL, NULL, 'PI-PLC X DOMAIN-CONTAINING PROTEIN 1', 249903),
(398544, 'PTHR13593:SF33', NULL, NULL, NULL, NULL, 'PI-PLC X DOMAIN-CONTAINING PROTEIN 3', 249903),
(398545, 'PTHR13593:SF32', NULL, NULL, NULL, NULL, 'PI-PLC X DOMAIN-CONTAINING PROTEIN 2', 249903),
(398546, 'PTHR13593:SF95', NULL, NULL, NULL, NULL, 'PLC-LIKE PHOSPHODIESTERASE SUPERFAMILY PROTEIN', 249903);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(398547, 'PTHR13593:SF51', NULL, NULL, NULL, NULL, 'F21F23.12 PROTEIN', 249903),
(398548, 'PTHR13593:SF74', NULL, NULL, NULL, NULL, '', 249903),
(398549, 'PTHR13593:SF138', NULL, NULL, NULL, NULL, 'PLCXC DOMAIN-CONTAINING PROTEIN-RELATED', 249903),
(398550, 'PTHR13593:SF116', NULL, NULL, NULL, NULL, 'PLCXC DOMAIN-CONTAINING PROTEIN', 249903),
(398551, 'PTHR13593:SF139', NULL, NULL, NULL, NULL, 'C, PUTATIVE-RELATED', 249903),
(398552, 'PTHR13593', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 249903),
(398553, 'PTHR13593:SF48', NULL, NULL, NULL, NULL, 'OS04G0689300 PROTEIN', 249903),
(398554, 'PTHR13593:SF24', NULL, NULL, NULL, NULL, 'PI-PLC X DOMAIN-CONTAINING PROTEIN 1', 249903),
(398555, 'PTHR13593:SF80', NULL, NULL, NULL, NULL, '', 249903),
(398556, 'PTHR13593:SF103', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-SPECIFIC PHOSPHOLIPASE C X DOMAIN CONTAINING, ISOFORM A', 249903),
(398557, 'PTHR13593:SF104', NULL, NULL, NULL, NULL, 'PLC-LIKE PHOSPHODIESTERASES SUPERFAMILY PROTEIN-RELATED', 249903),
(398558, 'PTHR13593:SF101', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL PHOSPHODIESTERASE-LIKE PROTEIN', 249903),
(398559, 'PTHR13593:SF145', NULL, NULL, NULL, NULL, 'OS08G0103500 PROTEIN', 249903),
(398560, 'PTHR13593:SF146', NULL, NULL, NULL, NULL, '', 249903),
(398561, 'PTHR13593:SF124', NULL, NULL, NULL, NULL, 'PLCXC DOMAIN-CONTAINING PROTEIN', 249903),
(398562, 'PTHR13593:SF143', NULL, NULL, NULL, NULL, '', 249903),
(398563, 'PTHR13593:SF122', NULL, NULL, NULL, NULL, 'PLCXC DOMAIN-CONTAINING PROTEIN', 249903),
(398564, 'PTHR13593:SF144', NULL, NULL, NULL, NULL, 'RE10370P', 249903),
(398565, 'PTHR13593:SF141', NULL, NULL, NULL, NULL, 'PLC-LIKE PHOSPHODIESTERASE, TIM BETA/ALPHA-BARREL DOMAIN-CONTAINING PROTEIN-RELATED', 249903),
(398566, 'PTHR13593:SF142', NULL, NULL, NULL, NULL, 'PLCXC DOMAIN-CONTAINING PROTEIN', 249903),
(398567, 'PTHR13593:SF120', NULL, NULL, NULL, NULL, 'PI-PLC X-BOX DOMAIN-CONTAINING PROTEIN DDB_G0293730-LIKE', 249903),
(398568, 'PTHR13593:SF89', NULL, NULL, NULL, NULL, 'PLC-LIKE PHOSPHODIESTERASES SUPERFAMILY PROTEIN', 249903),
(398569, 'PTHR13593:SF129', NULL, NULL, NULL, NULL, '', 249903),
(398570, 'PTHR13593:SF85', NULL, NULL, NULL, NULL, 'MAP3K PROTEIN KINASE-LIKE PROTEIN', 249903),
(398571, 'PTHR13593:SF127', NULL, NULL, NULL, NULL, 'PLC-LIKE PHOSPHODIESTERASES SUPERFAMILY PROTEIN', 249903),
(398572, 'PTHR13593:SF106', NULL, NULL, NULL, NULL, 'PLCXC DOMAIN-CONTAINING PROTEIN', 249903),
(398573, 'PTHR24326:SF590', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-5', 249904),
(398574, 'PTHR24326:SF591', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-51-RELATED', 249904),
(398575, 'PTHR24326:SF554', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-7-LIKE', 249904),
(398576, 'PTHR24326:SF599', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 249904),
(398577, 'PTHR24326:SF552', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-7-LIKE ISOFORM X1', 249904),
(398578, 'PTHR24326:SF596', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 249904),
(398579, 'PTHR24326:SF234', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HOX22', 249904),
(398580, 'PTHR24326:SF597', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 249904),
(398581, 'PTHR24326:SF594', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 249904),
(398582, 'PTHR24326:SF595', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 249904),
(398583, 'PTHR24326:SF593', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 249904),
(398584, 'PTHR24326:SF559', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-16', 249904),
(398585, 'PTHR24326:SF522', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-52', 249904),
(398586, 'PTHR24326:SF566', NULL, NULL, NULL, NULL, 'LEUCINE ZIPPER, HOMEOBOX-ASSOCIATED, HOMEODOMAIN-LIKE PROTEIN-RELATED', 249904),
(398587, 'PTHR24326:SF563', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-20', 249904),
(398588, 'PTHR24326', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN', 249904);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(398589, 'PTHR24326:SF564', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-12', 249904),
(398590, 'PTHR24326:SF562', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 249904),
(398591, 'PTHR24326:SF122', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HOX6', 249904),
(398592, 'PTHR24326:SF606', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-54', 249904),
(398593, 'PTHR24326:SF604', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-7', 249904),
(398594, 'PTHR24326:SF527', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-40', 249904),
(398595, 'PTHR24326:SF525', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HOX25', 249904),
(398596, 'PTHR24326:SF603', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-12-LIKE', 249904),
(398597, 'PTHR24326:SF567', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 249904),
(398598, 'PTHR24326:SF601', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HAT5-LIKE', 249904),
(398599, 'PTHR24326:SF608', NULL, NULL, NULL, NULL, 'LEUCINE ZIPPER, HOMEOBOX-ASSOCIATED, HOMEODOMAIN-LIKE PROTEIN-RELATED', 249904),
(398600, 'PTHR24326:SF576', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 249904),
(398601, 'PTHR24326:SF610', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 249904),
(398602, 'PTHR24326:SF533', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-53', 249904),
(398603, 'PTHR24326:SF497', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HAT5', 249904),
(398604, 'PTHR24326:SF530', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HOX8', 249904),
(398605, 'PTHR24326:SF574', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 249904),
(398606, 'PTHR24326:SF531', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-22', 249904),
(398607, 'PTHR24326:SF495', NULL, NULL, NULL, NULL, 'HOMEOBOX LEUCINE ZIPPER FAMILY PROTEIN', 249904),
(398608, 'PTHR24326:SF176', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-13', 249904),
(398609, 'PTHR24326:SF573', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HAT7-LIKE ISOFORM X1', 249904),
(398610, 'PTHR24326:SF570', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 249904),
(398611, 'PTHR24326:SF617', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-23', 249904),
(398612, 'PTHR24326:SF618', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-54-LIKE', 249904),
(398613, 'PTHR24326:SF615', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 249904),
(398614, 'PTHR24326:SF538', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HAT7', 249904),
(398615, 'PTHR24326:SF616', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-6-LIKE', 249904),
(398616, 'PTHR24326:SF614', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 249904),
(398617, 'PTHR24326:SF537', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-21', 249904),
(398618, 'PTHR24326:SF578', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 249904),
(398619, 'PTHR24326:SF215', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HOX5', 249904),
(398620, 'PTHR24326:SF612', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HOX4', 249904),
(398621, 'PTHR24326:SF535', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 249904),
(398622, 'PTHR24326:SF619', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 249904),
(398623, 'PTHR24326:SF580', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 249904),
(398624, 'PTHR24326:SF587', NULL, NULL, NULL, NULL, 'LEUCINE ZIPPER, HOMEOBOX-ASSOCIATED, HOMEODOMAIN-LIKE, DNA REPAIR PROTEIN XRCC4-RELATED', 249904),
(398625, 'PTHR24326:SF620', NULL, NULL, NULL, NULL, 'HOMEOBOX ASSOCIATED LEUCINE ZIPPER PROTEIN', 249904),
(398626, 'PTHR24326:SF543', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-7-LIKE', 249904),
(398627, 'PTHR24326:SF621', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-6-LIKE', 249904);
INSERT INTO "PUBLIC"."MODEL" VALUES
(398628, 'PTHR24326:SF225', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HOX23', 249904),
(398629, 'PTHR24326:SF544', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-13-LIKE', 249904),
(398630, 'PTHR24326:SF585', NULL, NULL, NULL, NULL, 'HOMEOBOX ASSOCIATED LEUCINE ZIPPER PROTEIN', 249904),
(398631, 'PTHR24326:SF300', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HOX13', 249904),
(398632, 'PTHR24326:SF341', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HOX24', 249904),
(398633, 'PTHR24326:SF583', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 249904),
(398634, 'PTHR24326:SF584', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-52-LIKE', 249904),
(398635, 'PTHR24326:SF581', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 249904),
(398636, 'PTHR24326:SF626', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 249904),
(398637, 'PTHR24326:SF627', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-52-LIKE', 249904),
(398638, 'PTHR24326:SF547', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-6', 249904),
(398639, 'PTHR24326:SF624', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HOX20', 249904),
(398640, 'PTHR24326:SF625', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 249904),
(398641, 'PTHR24326:SF545', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HOX12', 249904),
(398642, 'PTHR24326:SF622', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 249904),
(398643, 'PTHR24326:SF623', NULL, NULL, NULL, NULL, 'HOMEOBOX ASSOCIATED LEUCINE ZIPPER PROTEIN', 249904),
(398644, 'PTHR33967', NULL, NULL, NULL, NULL, 'RAGULATOR COMPLEX PROTEIN LAMTOR4', 249905),
(398645, 'PTHR33967:SF1', NULL, NULL, NULL, NULL, 'RAGULATOR COMPLEX PROTEIN LAMTOR4', 249905),
(398646, 'PTHR10264:SF83', NULL, NULL, NULL, NULL, 'BLL5629 PROTEIN', 249906),
(398647, 'PTHR10264:SF72', NULL, NULL, NULL, NULL, 'PROTEIN UNC-1', 249906),
(398648, 'PTHR10264:SF49', NULL, NULL, NULL, NULL, 'STOMATIN-LIKE PROTEIN 3', 249906),
(398649, 'PTHR10264:SF66', NULL, NULL, NULL, NULL, 'PHB DOMAIN-CONTAINING PROTEIN', 249906),
(398650, 'PTHR10264:SF87', NULL, NULL, NULL, NULL, 'STOMATIN (EPB72)-LIKE 3A-RELATED', 249906),
(398651, 'PTHR10264:SF32', NULL, NULL, NULL, NULL, 'PHB DOMAIN-CONTAINING PROTEIN', 249906),
(398652, 'PTHR10264:SF130', NULL, NULL, NULL, NULL, 'STOMATIN-LIKE PROTEIN 1', 249906),
(398653, 'PTHR10264:SF19', NULL, NULL, NULL, NULL, 'AT06885P-RELATED', 249906),
(398654, 'PTHR10264:SF28', NULL, NULL, NULL, NULL, 'PHB DOMAIN-CONTAINING PROTEIN', 249906),
(398655, 'PTHR10264:SF126', NULL, NULL, NULL, NULL, 'MECHANOSENSORY PROTEIN 2', 249906),
(398656, 'PTHR10264:SF115', NULL, NULL, NULL, NULL, 'STOMATIN', 249906),
(398657, 'PTHR10264:SF127', NULL, NULL, NULL, NULL, 'PODOCIN', 249906),
(398658, 'PTHR10264:SF116', NULL, NULL, NULL, NULL, 'STOMATIN-3', 249906),
(398659, 'PTHR10264:SF117', NULL, NULL, NULL, NULL, 'ZGC:112408', 249906),
(398660, 'PTHR10264:SF129', NULL, NULL, NULL, NULL, 'STOMATIN-1', 249906),
(398661, 'PTHR10264', NULL, NULL, NULL, NULL, 'BAND 7 PROTEIN-RELATED', 249906),
(398662, 'PTHR40524:SF1', NULL, NULL, NULL, NULL, 'PEPTIDASE_C39_2 DOMAIN-CONTAINING PROTEIN', 249907),
(398663, 'PTHR40524', NULL, NULL, NULL, NULL, 'PEPTIDASE_C39_2 DOMAIN-CONTAINING PROTEIN', 249907),
(398664, 'PTHR45295', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ C76, CHLOROPLASTIC', 249908),
(398665, 'PTHR45295:SF1', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ C76, CHLOROPLASTIC', 249908),
(398666, 'PTHR45295:SF4', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 249908),
(398667, 'PTHR45295:SF3', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', 249908),
(398668, 'PTHR34953', NULL, NULL, NULL, NULL, 'ALPHA/BETA HYDROLASE RELATED PROTEIN', 249909),
(398669, 'PTHR34953:SF5', NULL, NULL, NULL, NULL, 'ALPHA/BETA HYDROLASE RELATED PROTEIN', 249909),
(398670, 'PTHR34953:SF3', NULL, NULL, NULL, NULL, 'BNAA09G35450D PROTEIN', 249909),
(398671, 'PTHR34953:SF4', NULL, NULL, NULL, NULL, 'MENTAL DOMAIN-CONTAINING PROTEIN', 249909);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(398672, 'PTHR34953:SF1', NULL, NULL, NULL, NULL, 'ALPHA/BETA HYDROLASE RELATED PROTEIN', 249909),
(398673, 'PTHR34953:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 249909),
(398674, 'PTHR31770:SF9', NULL, NULL, NULL, NULL, 'TAFA CHEMOKINE LIKE FAMILY MEMBER 3', 249910),
(398675, 'PTHR31770:SF2', NULL, NULL, NULL, NULL, 'CHEMOKINE-LIKE PROTEIN TAFA-1', 249910),
(398676, 'PTHR31770:SF1', NULL, NULL, NULL, NULL, 'CHEMOKINE-LIKE PROTEIN TAFA-2', 249910),
(398677, 'PTHR31770:SF3', NULL, NULL, NULL, NULL, 'CHEMOKINE-LIKE PROTEIN TAFA-3', 249910),
(398678, 'PTHR31770', NULL, NULL, NULL, NULL, 'CHEMOKINE-LIKE PROTEIN TAFA FAMILY MEMBER', 249910),
(398679, 'PTHR31770:SF7', NULL, NULL, NULL, NULL, 'CHEMOKINE-LIKE PROTEIN TAFA-4', 249910),
(398680, 'PTHR13347', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 249911),
(398681, 'PTHR13347:SF1', NULL, NULL, NULL, NULL, 'HEAT REPEAT-CONTAINING PROTEIN 3', 249911),
(398682, 'PTHR12900:SF3', NULL, NULL, NULL, NULL, 'CHECKPOINT PROTEIN HUS1B', 249912),
(398683, 'PTHR12900:SF4', NULL, NULL, NULL, NULL, 'CHECKPOINT PROTEIN HUS1', 249912),
(398684, 'PTHR12900', NULL, NULL, NULL, NULL, 'MITOTIC AND DNA DAMAGE CHECKPOINT PROTEIN HUS1', 249912),
(398685, 'PTHR12900:SF6', NULL, NULL, NULL, NULL, 'PROTEIN LTO1 HOMOLOG', 249912),
(398686, 'PTHR12900:SF0', NULL, NULL, NULL, NULL, 'CHECKPOINT PROTEIN', 249912),
(398687, 'PTHR46839', NULL, NULL, NULL, NULL, 'SUSHI DOMAIN-CONTAINING PROTEIN 6', 249913),
(398688, 'PTHR46839:SF3', NULL, NULL, NULL, NULL, 'ZGC:152863', 249913),
(398689, 'PTHR46839:SF2', NULL, NULL, NULL, NULL, 'SUSHI DOMAIN-CONTAINING PROTEIN 6', 249913),
(398690, 'PTHR46839:SF1', NULL, NULL, NULL, NULL, 'SUSHI DOMAIN-CONTAINING 6', 249913),
(398691, 'PTHR13191:SF0', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA-PROCESSING PROTEIN 7 HOMOLOG A-RELATED', 249914),
(398692, 'PTHR13191:SF3', NULL, NULL, NULL, NULL, 'RRP7 DOMAIN-CONTAINING PROTEIN', 249914),
(398693, 'PTHR13191', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA PROCESSING PROTEIN 7-RELATED', 249914),
(398694, 'PTHR11533:SF40', NULL, NULL, NULL, NULL, 'THYROTROPIN-RELEASING HORMONE-DEGRADING ECTOENZYME', 249915),
(398695, 'PTHR11533:SF106', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE', 249915),
(398696, 'PTHR11533:SF42', NULL, NULL, NULL, NULL, 'LEUCYL-CYSTINYL AMINOPEPTIDASE', 249915),
(398697, 'PTHR11533:SF21', NULL, NULL, NULL, NULL, 'PROTEIN CBG03367', 249915),
(398698, 'PTHR11533:SF201', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE-LIKE PROTEIN AC3.5', 249915),
(398699, 'PTHR11533:SF289', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE', 249915),
(398700, 'PTHR11533:SF288', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE', 249915),
(398701, 'PTHR11533:SF203', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE M1-C', 249915),
(398702, 'PTHR11533:SF269', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE', 249915),
(398703, 'PTHR11533:SF247', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE', 249915),
(398704, 'PTHR11533:SF285', NULL, NULL, NULL, NULL, 'PUROMYCIN-SENSITIVE AMINOPEPTIDASE-RELATED', 249915),
(398705, 'PTHR11533:SF284', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE', 249915),
(398706, 'PTHR11533:SF287', NULL, NULL, NULL, NULL, 'PROTEIN TMA108', 249915),
(398707, 'PTHR11533:SF286', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE', 249915),
(398708, 'PTHR11533:SF242', NULL, NULL, NULL, NULL, 'GLUTAMYL AMINOPEPTIDASE', 249915),
(398709, 'PTHR11533', NULL, NULL, NULL, NULL, 'PROTEASE M1 ZINC METALLOPROTEASE', 249915),
(398710, 'PTHR11533:SF282', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE M1-A', 249915),
(398711, 'PTHR11533:SF18', NULL, NULL, NULL, NULL, 'FI02158P', 249915),
(398712, 'PTHR11533:SF31', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE Q', 249915),
(398713, 'PTHR11533:SF259', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE', 249915),
(398714, 'PTHR11533:SF239', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM AMINOPEPTIDASE 2', 249915),
(398715, 'PTHR11533:SF277', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE', 249915),
(398716, 'PTHR11533:SF156', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM AMINOPEPTIDASE 1', 249915),
(398717, 'PTHR11533:SF257', NULL, NULL, NULL, NULL, 'PEPTIDASE_M1 DOMAIN-CONTAINING PROTEIN', 249915);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(398718, 'PTHR11533:SF279', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE', 249915),
(398719, 'PTHR11533:SF274', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE', 249915),
(398720, 'PTHR11533:SF296', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE', 249915),
(398721, 'PTHR11533:SF295', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE', 249915),
(398722, 'PTHR11533:SF174', NULL, NULL, NULL, NULL, 'ALANINE/ARGININE AMINOPEPTIDASE-RELATED', 249915),
(398723, 'PTHR11533:SF276', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE-RELATED', 249915),
(398724, 'PTHR11533:SF253', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE', 249915),
(398725, 'PTHR11533:SF171', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE', 249915),
(398726, 'PTHR11533:SF292', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE', 249915),
(398727, 'PTHR11533:SF291', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE-RELATED', 249915),
(398728, 'PTHR11533:SF170', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE', 249915),
(398729, 'PTHR11533:SF192', NULL, NULL, NULL, NULL, 'PROTEIN CBG20905', 249915),
(398730, 'PTHR11533:SF294', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE', 249915),
(398731, 'PTHR11533:SF271', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE', 249915),
(398732, 'PTHR11533:SF172', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE N', 249915),
(398733, 'PTHR11533:SF293', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE-2-RELATED', 249915),
(398734, 'PTHR11533:SF290', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE', 249915),
(398735, 'PTHR24039:SF0', NULL, NULL, NULL, NULL, 'FIBRILLIN-3', 249916),
(398736, 'PTHR24039', NULL, NULL, NULL, NULL, 'FIBRILLIN-RELATED', 249916),
(398737, 'PTHR24039:SF32', NULL, NULL, NULL, NULL, 'FIBULIN-2', 249916),
(398738, 'PTHR24039:SF33', NULL, NULL, NULL, NULL, 'EGF-CONTAINING FIBULIN-LIKE EXTRACELLULAR MATRIX PROTEIN 1', 249916),
(398739, 'PTHR24039:SF22', NULL, NULL, NULL, NULL, 'FIBRILLIN-1', 249916),
(398740, 'PTHR24039:SF40', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE MATRIX RECEPTOR MUP-4', 249916),
(398741, 'PTHR24039:SF51', NULL, NULL, NULL, NULL, 'PROTEIN CBG17988', 249916),
(398742, 'PTHR24039:SF38', NULL, NULL, NULL, NULL, 'PROTEIN CBR-MEC-9', 249916),
(398743, 'PTHR24039:SF49', NULL, NULL, NULL, NULL, '', 249916),
(398744, 'PTHR24039:SF28', NULL, NULL, NULL, NULL, 'FBN-1A.1', 249916),
(398745, 'PTHR24039:SF48', NULL, NULL, NULL, NULL, 'FIBULIN-1', 249916),
(398746, 'PTHR24039:SF26', NULL, NULL, NULL, NULL, 'FIBRILLIN-2', 249916),
(398747, 'PTHR24039:SF34', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE CELL ADHESION RECEPTOR MUA-3', 249916),
(398748, 'PTHR36417', NULL, NULL, NULL, NULL, 'SELENOPROTEIN DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_1G05220)', 249917),
(398749, 'PTHR36417:SF2', NULL, NULL, NULL, NULL, 'SELENOPROTEIN DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_1G05220)', 249917),
(398750, 'PTHR40635:SF1', NULL, NULL, NULL, NULL, '', 249918),
(398751, 'PTHR40635', NULL, NULL, NULL, NULL, '', 249918),
(398752, 'PTHR47995:SF2', NULL, NULL, NULL, NULL, '', 249919),
(398753, 'PTHR47995:SF1', NULL, NULL, NULL, NULL, 'MYB DOMAIN PROTEIN 101', 249919),
(398754, 'PTHR47995:SF29', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GAMYB ISOFORM X1', 249919),
(398755, 'PTHR47995:SF18', NULL, NULL, NULL, NULL, 'MYB DOMAIN PROTEIN 81-RELATED', 249919),
(398756, 'PTHR47995:SF6', NULL, NULL, NULL, NULL, 'BNACNNG51960D PROTEIN', 249919),
(398757, 'PTHR47995', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB33-RELATED', 249919),
(398758, 'PTHR47995:SF30', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB65', 249919),
(398759, 'PTHR47995:SF31', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GAMYB-LIKE', 249919),
(398760, 'PTHR47995:SF12', NULL, NULL, NULL, NULL, 'BNAC03G26620D PROTEIN', 249919),
(398761, 'PTHR47995:SF23', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GAMYB-LIKE', 249919),
(398762, 'PTHR47995:SF24', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB28-LIKE', 249919),
(398763, 'PTHR47995:SF13', NULL, NULL, NULL, NULL, 'BNAA03G11630D PROTEIN', 249919),
(398764, 'PTHR47995:SF9', NULL, NULL, NULL, NULL, '', 249919),
(398765, 'PTHR47995:SF21', NULL, NULL, NULL, NULL, 'OS06G0679400 PROTEIN', 249919),
(398766, 'PTHR47995:SF32', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 249919);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(398767, 'PTHR47995:SF11', NULL, NULL, NULL, NULL, 'BNACNNG49390D PROTEIN', 249919),
(398768, 'PTHR47995:SF22', NULL, NULL, NULL, NULL, 'BNAA05G10900D PROTEIN', 249919),
(398769, 'PTHR47995:SF16', NULL, NULL, NULL, NULL, 'BNAA02G09340D PROTEIN', 249919),
(398770, 'PTHR47995:SF27', NULL, NULL, NULL, NULL, 'MYB DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 249919),
(398771, 'PTHR47995:SF17', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB120', 249919),
(398772, 'PTHR47995:SF14', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GAMYB-LIKE', 249919),
(398773, 'PTHR47995:SF15', NULL, NULL, NULL, NULL, '', 249919),
(398774, 'PTHR24559', NULL, NULL, NULL, NULL, 'TRANSPOSON TY3-I GAG-POL POLYPROTEIN', 249920),
(398775, 'PTHR24559:SF425', NULL, NULL, NULL, NULL, 'RT_RNASEH DOMAIN-CONTAINING PROTEIN', 249920),
(398776, 'PTHR47655:SF3', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249921),
(398777, 'PTHR47655:SF2', NULL, NULL, NULL, NULL, 'QUINIC ACID UTILIZATION ACTIVATOR', 249921),
(398778, 'PTHR47655:SF1', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249921),
(398779, 'PTHR47655', NULL, NULL, NULL, NULL, 'QUINIC ACID UTILIZATION ACTIVATOR', 249921),
(398780, 'PTHR47655:SF4', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 249921),
(398781, 'PTHR21497:SF24', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE UBR1', 249922),
(398782, 'PTHR21497:SF38', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE', 249922),
(398783, 'PTHR21497:SF49', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE', 249922),
(398784, 'PTHR21497:SF27', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE UBR1', 249922),
(398785, 'PTHR21497:SF37', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE', 249922),
(398786, 'PTHR21497:SF26', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE UBR1', 249922),
(398787, 'PTHR21497:SF39', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE UBR3', 249922),
(398788, 'PTHR21497:SF28', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE UBR2', 249922),
(398789, 'PTHR21497:SF50', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE', 249922),
(398790, 'PTHR21497:SF52', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE', 249922),
(398791, 'PTHR21497:SF30', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE', 249922),
(398792, 'PTHR21497:SF51', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE', 249922),
(398793, 'PTHR21497:SF40', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE', 249922),
(398794, 'PTHR21497', NULL, NULL, NULL, NULL, 'UBIQUITIN LIGASE E3 ALPHA-RELATED', 249922),
(398795, 'PTHR21497:SF53', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE PRT6', 249922),
(398796, 'PTHR48004', NULL, NULL, NULL, NULL, 'OS01G0149700 PROTEIN', 249923),
(398797, 'PTHR48004:SF38', NULL, NULL, NULL, NULL, 'ROP-INTERACTIVE CRIB MOTIF-CONTAINING PROTEIN 7', 249923),
(398798, 'PTHR48004:SF59', NULL, NULL, NULL, NULL, 'OS01G0515300 PROTEIN', 249923),
(398799, 'PTHR48004:SF36', NULL, NULL, NULL, NULL, 'OS06G0478600 PROTEIN', 249923),
(398800, 'PTHR48004:SF58', NULL, NULL, NULL, NULL, 'OS02G0227900 PROTEIN', 249923),
(398801, 'PTHR48004:SF79', NULL, NULL, NULL, NULL, 'OS02G0647300 PROTEIN', 249923),
(398802, 'PTHR48004:SF56', NULL, NULL, NULL, NULL, 'OS01G0162200 PROTEIN', 249923),
(398803, 'PTHR48004:SF34', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT (LRR) FAMILY PROTEIN', 249923),
(398804, 'PTHR48004:SF78', NULL, NULL, NULL, NULL, 'BNAC06G43870D PROTEIN', 249923),
(398805, 'PTHR48004:SF55', NULL, NULL, NULL, NULL, 'OS06G0627500 PROTEIN', 249923),
(398806, 'PTHR48004:SF99', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT (LRR) FAMILY PROTEIN-RELATED', 249923),
(398807, 'PTHR48004:SF77', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE FLS2', 249923),
(398808, 'PTHR48004:SF76', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 249923),
(398809, 'PTHR48004:SF98', NULL, NULL, NULL, NULL, 'OS11G0691800 PROTEIN', 249923),
(398810, 'PTHR48004:SF53', NULL, NULL, NULL, NULL, 'OS11G0173700 PROTEIN', 249923);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(398811, 'PTHR48004:SF75', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 16-RELATED', 249923),
(398812, 'PTHR48004:SF97', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249923),
(398813, 'PTHR48004:SF96', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 249923),
(398814, 'PTHR48004:SF74', NULL, NULL, NULL, NULL, 'OS02G0830700 PROTEIN', 249923),
(398815, 'PTHR48004:SF95', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 249923),
(398816, 'PTHR48004:SF73', NULL, NULL, NULL, NULL, 'OS10G0468875 PROTEIN', 249923),
(398817, 'PTHR48004:SF94', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE PEPR2', 249923),
(398818, 'PTHR48004:SF71', NULL, NULL, NULL, NULL, 'OS02G0161450 PROTEIN', 249923),
(398819, 'PTHR48004:SF93', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN ISOFORM 1', 249923),
(398820, 'PTHR48004:SF92', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN, PLANT-TYPE-RELATED', 249923),
(398821, 'PTHR48004:SF70', NULL, NULL, NULL, NULL, 'PROTEIN STRUBBELIG-RECEPTOR FAMILY 3-LIKE', 249923),
(398822, 'PTHR48004:SF91', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE EFR', 249923),
(398823, 'PTHR48004:SF90', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 249923),
(398824, 'PTHR48004:SF9', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN CLAVATA2', 249923),
(398825, 'PTHR48004:SF29', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT (LRR) FAMILY PROTEIN', 249923),
(398826, 'PTHR48004:SF48', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 249923),
(398827, 'PTHR48004:SF69', NULL, NULL, NULL, NULL, 'RECEPTOR LIKE PROTEIN 29', 249923),
(398828, 'PTHR48004:SF89', NULL, NULL, NULL, NULL, 'OS02G0615400 PROTEIN', 249923),
(398829, 'PTHR48004:SF88', NULL, NULL, NULL, NULL, 'BNAC09G17420D PROTEIN', 249923),
(398830, 'PTHR48004:SF87', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 249923),
(398831, 'PTHR48004:SF42', NULL, NULL, NULL, NULL, 'PROTEIN TOO MANY MOUTHS', 249923),
(398832, 'PTHR48004:SF86', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE EFR', 249923),
(398833, 'PTHR48004:SF63', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE EFR', 249923),
(398834, 'PTHR48004:SF85', NULL, NULL, NULL, NULL, '', 249923),
(398835, 'PTHR48004:SF84', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE EFR', 249923),
(398836, 'PTHR48004:SF40', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE GSO1', 249923),
(398837, 'PTHR48004:SF83', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 249923),
(398838, 'PTHR48004:SF82', NULL, NULL, NULL, NULL, 'OS08G0203300 PROTEIN', 249923),
(398839, 'PTHR48004:SF81', NULL, NULL, NULL, NULL, 'OS01G0149700 PROTEIN', 249923),
(398840, 'PTHR48004:SF80', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 249923),
(398841, 'PTHR48004:SF100', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 12', 249923),
(398842, 'PTHR34296:SF2', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER GUANOSINE-BINDING PROTEIN NUPN', 249924),
(398843, 'PTHR34296', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR PROTEIN MED', 249924),
(398844, 'PTHR35144:SF4', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR VIB-1', 249925),
(398845, 'PTHR35144', NULL, NULL, NULL, NULL, 'MEIOSIS-SPECIFIC TRANSCRIPTION FACTOR NDT80', 249925),
(398846, 'PTHR35144:SF2', NULL, NULL, NULL, NULL, 'MEIOSIS-SPECIFIC TRANSCRIPTION FACTOR NDT80', 249925),
(398847, 'PTHR35144:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PACG', 249925),
(398848, 'PTHR35201', NULL, NULL, NULL, NULL, 'TERPENE SYNTHASE', 249926),
(398849, 'PTHR35201:SF4', NULL, NULL, NULL, NULL, 'TERPENE SYNTHASE', 249926),
(398850, 'PTHR35201:SF3', NULL, NULL, NULL, NULL, 'TERPENE SYNTHASE', 249926),
(398851, 'PTHR35201:SF2', NULL, NULL, NULL, NULL, 'TERPENE SYNTHASE', 249926),
(398852, 'PTHR35664:SF1', NULL, NULL, NULL, NULL, 'SPERMATID-SPECIFIC MANCHETTE-RELATED PROTEIN 1', 249927),
(398853, 'PTHR35664', NULL, NULL, NULL, NULL, 'SPERMATID-SPECIFIC MANCHETTE-RELATED PROTEIN 1', 249927);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(398854, 'PTHR35567:SF11', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE (AFU_ORTHOLOGUE AFUA_2G13800)', 249928),
(398855, 'PTHR35567:SF3', NULL, NULL, NULL, NULL, '', 249928),
(398856, 'PTHR35567', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE (AFU_ORTHOLOGUE AFUA_2G13800)', 249928),
(398857, 'PTHR35567:SF1', NULL, NULL, NULL, NULL, 'CONSERVED FUNGAL PROTEIN (AFU_ORTHOLOGUE AFUA_1G14230)', 249928),
(398858, 'PTHR23335:SF20', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING TRANSCRIPTION ACTIVATOR 1', 249929),
(398859, 'PTHR23335:SF42', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING TRANSCRIPTION ACTIVATOR 1', 249929),
(398860, 'PTHR23335:SF30', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING TRANSCRIPTION ACTIVATOR 3', 249929),
(398861, 'PTHR23335:SF33', NULL, NULL, NULL, NULL, 'IQ MOTIF, EF-HAND BINDING SITE-RELATED', 249929),
(398862, 'PTHR23335:SF11', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING TRANSCRIPTION ACTIVATOR 1', 249929),
(398863, 'PTHR23335:SF44', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING TRANSCRIPTION ACTIVATOR 6', 249929),
(398864, 'PTHR23335:SF22', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING TRANSCRIPTION ACTIVATOR', 249929),
(398865, 'PTHR23335:SF21', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN', 249929),
(398866, 'PTHR23335:SF43', NULL, NULL, NULL, NULL, 'ETHYLENE-UPREGULATED PROTEIN ER1, PUTATIVE, EXPRESSED-RELATED', 249929),
(398867, 'PTHR23335:SF35', NULL, NULL, NULL, NULL, 'OS01G0923600 PROTEIN', 249929),
(398868, 'PTHR23335:SF26', NULL, NULL, NULL, NULL, 'IQ MOTIF, EF-HAND BINDING SITE-RELATED', 249929),
(398869, 'PTHR23335', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING TRANSCRIPTION ACTIVATOR  CAMTA', 249929),
(398870, 'PTHR23335:SF37', NULL, NULL, NULL, NULL, 'BNAA09G42730D PROTEIN', 249929),
(398871, 'PTHR23335:SF9', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING TRANSCRIPTION ACTIVATOR 2', 249929),
(398872, 'PTHR23335:SF14', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING TRANSCRIPTION ACTIVATOR 2', 249929),
(398873, 'PTHR23335:SF28', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 249929),
(398874, 'PTHR23335:SF17', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING TRANSCRIPTION ACTIVATOR 2', 249929),
(398875, 'PTHR23335:SF27', NULL, NULL, NULL, NULL, 'BNAC06G26850D PROTEIN', 249929),
(398876, 'PTHR23335:SF19', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING TRANSCRIPTION ACTIVATOR 4-LIKE', 249929),
(398877, 'PTHR23335:SF29', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING TRANSCRIPTION ACTIVATOR 2', 249929),
(398878, 'PTHR23335:SF0', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING TRANSCRIPTION ACTIVATOR, ISOFORM F', 249929),
(398879, 'PTHR23335:SF1', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING TRANSCRIPTION ACTIVATOR 4', 249929),
(398880, 'PTHR23335:SF3', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING TRANSCRIPTION ACTIVATOR 5', 249929),
(398881, 'PTHR20932:SF51', NULL, NULL, NULL, NULL, 'LYSM DOMAIN-CONTAINING PROTEIN', 249930),
(398882, 'PTHR20932:SF2', NULL, NULL, NULL, NULL, 'AND PUTATIVE PEPTIDOGLYCAN-BINDING DOMAIN-CONTAINING PROTEIN 1-RELATED', 249930),
(398883, 'PTHR20932:SF53', NULL, NULL, NULL, NULL, 'LYSM DOMAIN-CONTAINING PROTEIN', 249930),
(398884, 'PTHR20932:SF4', NULL, NULL, NULL, NULL, 'AND PUTATIVE PEPTIDOGLYCAN-BINDING DOMAIN-CONTAINING PROTEIN 2-RELATED', 249930),
(398885, 'PTHR20932:SF31', NULL, NULL, NULL, NULL, 'LYSM DOMAIN-CONTAINING PROTEIN', 249930),
(398886, 'PTHR20932:SF42', NULL, NULL, NULL, NULL, 'LYSM DOMAIN-CONTAINING PROTEIN-RELATED', 249930),
(398887, 'PTHR20932:SF41', NULL, NULL, NULL, NULL, 'LYSM DOMAIN-CONTAINING PROTEIN', 249930),
(398888, 'PTHR20932:SF52', NULL, NULL, NULL, NULL, 'LYSM DOMAIN CONTAINING PROTEIN, EXPRESSED', 249930),
(398889, 'PTHR20932:SF5', NULL, NULL, NULL, NULL, 'AND PUTATIVE PEPTIDOGLYCAN-BINDING DOMAIN-CONTAINING PROTEIN 3-RELATED', 249930),
(398890, 'PTHR20932', NULL, NULL, NULL, NULL, 'LYSM AND PUTATIVE PEPTIDOGLYCAN-BINDING DOMAIN-CONTAINING PROTEIN', 249930),
(398891, 'PTHR20932:SF8', NULL, NULL, NULL, NULL, 'LYSM DOMAIN CONTAINING PROTEIN, EXPRESSED', 249930),
(398892, 'PTHR20932:SF7', NULL, NULL, NULL, NULL, 'AND PUTATIVE PEPTIDOGLYCAN-BINDING DOMAIN-CONTAINING PROTEIN 4-RELATED', 249930);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(398893, 'PTHR20932:SF36', NULL, NULL, NULL, NULL, 'LD22649P', 249930),
(398894, 'PTHR20932:SF16', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 249930),
(398895, 'PTHR20932:SF44', NULL, NULL, NULL, NULL, 'OS06G0729900 PROTEIN', 249930),
(398896, 'PTHR20932:SF55', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN-BINDING LYSM DOMAIN-CONTAINING PROTEIN', 249930),
(398897, 'PTHR20932:SF54', NULL, NULL, NULL, NULL, 'LYSM DOMAIN-CONTAINING PROTEIN', 249930),
(398898, 'PTHR20932:SF13', NULL, NULL, NULL, NULL, 'LD36653P', 249930),
(398899, 'PTHR35981:SF2', NULL, NULL, NULL, NULL, 'ION TRANSPORT PEPTIDE, ISOFORM C', 249931),
(398900, 'PTHR35981', NULL, NULL, NULL, NULL, 'ION TRANSPORT PEPTIDE, ISOFORM C', 249931),
(398901, 'PTHR35981:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG26136', 249931),
(398902, 'PTHR35981:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG14491', 249931),
(398903, 'PTHR30075:SF2', NULL, NULL, NULL, NULL, 'GLYCINE--TRNA LIGASE, CHLOROPLASTIC/MITOCHONDRIAL 2', 249932),
(398904, 'PTHR30075', NULL, NULL, NULL, NULL, 'GLYCYL-TRNA SYNTHETASE', 249932),
(398905, 'PTHR42837:SF5', NULL, NULL, NULL, NULL, 'MEMBRANE METALLOPROTEASE ARASP, CHLOROPLASTIC', 249933),
(398906, 'PTHR42837', NULL, NULL, NULL, NULL, 'REGULATOR OF SIGMA-E PROTEASE RSEP', 249933),
(398907, 'PTHR42837:SF2', NULL, NULL, NULL, NULL, 'MEMBRANE METALLOPROTEASE ARASP2, CHLOROPLASTIC-RELATED', 249933),
(398908, 'PTHR43270:SF8', NULL, NULL, NULL, NULL, 'DI- AND TRIPEPTIDASE DUG2-RELATED', 249934),
(398909, 'PTHR43270:SF12', NULL, NULL, NULL, NULL, 'SUCCINYL-DIAMINOPIMELATE DESUCCINYLASE', 249934),
(398910, 'PTHR43270:SF14', NULL, NULL, NULL, NULL, 'M20_DIMER DOMAIN-CONTAINING PROTEIN', 249934),
(398911, 'PTHR43270', NULL, NULL, NULL, NULL, 'BETA-ALA-HIS DIPEPTIDASE', 249934),
(398912, 'PTHR43270:SF15', NULL, NULL, NULL, NULL, 'ZGC:114181', 249934),
(398913, 'PTHR43270:SF1', NULL, NULL, NULL, NULL, 'BETA-ALA-HIS DIPEPTIDASE', 249934),
(398914, 'PTHR43270:SF11', NULL, NULL, NULL, NULL, 'CYTOSOLIC NON-SPECIFIC DIPEPTIDASE', 249934),
(398915, 'PTHR43270:SF4', NULL, NULL, NULL, NULL, 'CARNOSINE DIPEPTIDASE 2, ISOFORM A', 249934),
(398916, 'PTHR47963:SF7', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE YFML-RELATED', 249935),
(398917, 'PTHR47963:SF6', NULL, NULL, NULL, NULL, 'DNA REPAIR HELICASE-RELATED', 249935),
(398918, 'PTHR47963:SF10', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX6/DHH1', 249935),
(398919, 'PTHR47963:SF5', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE CSHA', 249935),
(398920, 'PTHR47963:SF3', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 47, MITOCHONDRIAL', 249935),
(398921, 'PTHR47963:SF2', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DBPA', 249935),
(398922, 'PTHR47963:SF1', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE CSHB', 249935),
(398923, 'PTHR47963:SF9', NULL, NULL, NULL, NULL, 'CRISPR-ASSOCIATED ENDONUCLEASE/HELICASE CAS3', 249935),
(398924, 'PTHR47963', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 47, MITOCHONDRIAL', 249935),
(398925, 'PTHR47963:SF8', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DEAD', 249935),
(398926, 'PTHR20988', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 249936),
(398927, 'PTHR20988:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 183A-RELATED', 249936),
(398928, 'PTHR35320:SF1', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE ATP-BINDING SUBUNIT', 249937),
(398929, 'PTHR35320', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE ATP-BINDING SUBUNIT', 249937),
(398930, 'PTHR13489:SF0', NULL, NULL, NULL, NULL, 'MINI-CHROMOSOME MAINTENANCE COMPLEX-BINDING PROTEIN', 249938),
(398931, 'PTHR13489', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 249938),
(398932, 'PTHR46784:SF3', NULL, NULL, NULL, NULL, 'KILLER CELL LECTIN-LIKE RECEPTOR SUBFAMILY B MEMBER 1F', 249939),
(398933, 'PTHR46784:SF2', NULL, NULL, NULL, NULL, 'KILLER CELL LECTIN-LIKE RECEPTOR SUBFAMILY B MEMBER 1', 249939),
(398934, 'PTHR46784', NULL, NULL, NULL, NULL, 'KILLER CELL LECTIN-LIKE RECEPTOR SUBFAMILY B MEMBER 1', 249939),
(398935, 'PTHR46784:SF1', NULL, NULL, NULL, NULL, 'KILLER CELL LECTIN-LIKE RECEPTOR SUBFAMILY B MEMBER 1', 249939);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(398936, 'PTHR11673:SF52', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 5A-1', 249940),
(398937, 'PTHR11673:SF30', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 5A', 249940),
(398938, 'PTHR11673:SF53', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 5A', 249940),
(398939, 'PTHR11673:SF51', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 5A-1', 249940),
(398940, 'PTHR11673:SF34', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 5A-1', 249940),
(398941, 'PTHR11673:SF12', NULL, NULL, NULL, NULL, 'WORONIN BODY MAJOR PROTEIN', 249940),
(398942, 'PTHR11673:SF35', NULL, NULL, NULL, NULL, 'EIF-5A DOMAIN-CONTAINING PROTEIN', 249940),
(398943, 'PTHR11673:SF13', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 5A-2', 249940),
(398944, 'PTHR11673:SF32', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 5A-2', 249940),
(398945, 'PTHR11673:SF33', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 5A-4', 249940),
(398946, 'PTHR11673:SF39', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 5A-3', 249940),
(398947, 'PTHR11673:SF36', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 5A-1', 249940),
(398948, 'PTHR11673', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR 5A FAMILY MEMBER', 249940),
(398949, 'PTHR11673:SF41', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 5A', 249940),
(398950, 'PTHR11673:SF42', NULL, NULL, NULL, NULL, 'EIF-5A DOMAIN-CONTAINING PROTEIN', 249940),
(398951, 'PTHR11673:SF45', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 5A', 249940),
(398952, 'PTHR11673:SF43', NULL, NULL, NULL, NULL, 'TRANSLATION ELONGATION FACTOR IF5A-RELATED', 249940),
(398953, 'PTHR11673:SF44', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 5A-2', 249940),
(398954, 'PTHR11673:SF27', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 5A', 249940),
(398955, 'PTHR11673:SF49', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 5A', 249940),
(398956, 'PTHR11673:SF25', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 5A-1-LIKE', 249940),
(398957, 'PTHR11673:SF48', NULL, NULL, NULL, NULL, 'TRANSLATION ELONGATION FACTOR IF5A-RELATED', 249940),
(398958, 'PTHR11673:SF26', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 5A', 249940),
(398959, 'PTHR11673:SF6', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 5A', 249940),
(398960, 'PTHR11673:SF29', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 5A', 249940),
(398961, 'PTHR42893:SF4', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 42', 249941),
(398962, 'PTHR42893:SF8', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 249941),
(398963, 'PTHR42893:SF51', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 249941),
(398964, 'PTHR42893:SF9', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 46, CHLOROPLASTIC', 249941),
(398965, 'PTHR42893:SF50', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 249941),
(398966, 'PTHR42893:SF31', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 249941),
(398967, 'PTHR42893:SF52', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 249941),
(398968, 'PTHR42893:SF11', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 43', 249941),
(398969, 'PTHR42893:SF33', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 249941),
(398970, 'PTHR42893:SF32', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 249941),
(398971, 'PTHR42893:SF35', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 249941),
(398972, 'PTHR42893:SF37', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 249941),
(398973, 'PTHR42893:SF39', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 249941),
(398974, 'PTHR42893:SF16', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 249941),
(398975, 'PTHR42893:SF19', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 249941),
(398976, 'PTHR42893:SF18', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 249941),
(398977, 'PTHR42893', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 44, CHLOROPLASTIC-RELATED', 249941);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(398978, 'PTHR42893:SF42', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 249941),
(398979, 'PTHR42893:SF20', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 249941),
(398980, 'PTHR42893:SF41', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 249941),
(398981, 'PTHR42893:SF44', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 249941),
(398982, 'PTHR42893:SF21', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 249941),
(398983, 'PTHR42893:SF46', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 44, CHLOROPLASTIC', 249941),
(398984, 'PTHR42893:SF23', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 249941),
(398985, 'PTHR42893:SF45', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 45, CHLOROPLASTIC', 249941),
(398986, 'PTHR42893:SF48', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 249941),
(398987, 'PTHR42893:SF47', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 47, CHLOROPLASTIC', 249941),
(398988, 'PTHR42893:SF49', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 249941),
(398989, 'PTHR42893:SF29', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION', 249941),
(398990, 'PTHR13058:SF27', NULL, NULL, NULL, NULL, 'THREE-PRIME REPAIR EXONUCLEASE 1', 249942),
(398991, 'PTHR13058:SF26', NULL, NULL, NULL, NULL, 'OS04G0623400 PROTEIN', 249942),
(398992, 'PTHR13058:SF24', NULL, NULL, NULL, NULL, 'THREE PRIME REPAIR EXONUCLEASE 2', 249942),
(398993, 'PTHR13058:SF22', NULL, NULL, NULL, NULL, 'SI:CH1073-296I8.2-RELATED', 249942),
(398994, 'PTHR13058:SF19', NULL, NULL, NULL, NULL, 'LD40940P', 249942),
(398995, 'PTHR13058', NULL, NULL, NULL, NULL, 'THREE PRIME REPAIR EXONUCLEASE 1, 2', 249942),
(398996, 'PTHR19981:SF1', NULL, NULL, NULL, NULL, 'RHEA, ISOFORM B', 249943),
(398997, 'PTHR19981:SF33', NULL, NULL, NULL, NULL, 'FERM DOMAIN-CONTAINING PROTEIN C', 249943),
(398998, 'PTHR19981:SF35', NULL, NULL, NULL, NULL, 'FERM DOMAIN-CONTAINING PROTEIN A', 249943),
(398999, 'PTHR19981:SF34', NULL, NULL, NULL, NULL, 'TALIN-2', 249943),
(399000, 'PTHR19981:SF7', NULL, NULL, NULL, NULL, 'TALIN-1', 249943),
(399001, 'PTHR19981', NULL, NULL, NULL, NULL, 'TALIN', 249943),
(399002, 'PTHR12298:SF4', NULL, NULL, NULL, NULL, 'PROGRAMMED CELL DEATH PROTEIN 2', 249944),
(399003, 'PTHR12298:SF6', NULL, NULL, NULL, NULL, 'MYND-TYPE DOMAIN-CONTAINING PROTEIN', 249944),
(399004, 'PTHR12298', NULL, NULL, NULL, NULL, 'PCDC2  PROGRAMMED CELL DEATH PROTEIN 2 -RELATED', 249944),
(399005, 'PTHR45496:SF28', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 249945),
(399006, 'PTHR45496:SF29', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN PROTEIN', 249945),
(399007, 'PTHR45496:SF18', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 249945),
(399008, 'PTHR45496', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', 249945),
(399009, 'PTHR45496:SF19', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 249945),
(399010, 'PTHR45496:SF30', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 249945),
(399011, 'PTHR45496:SF1', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', 249945),
(399012, 'PTHR45496:SF2', NULL, NULL, NULL, NULL, 'OS10G0378450 PROTEIN', 249945),
(399013, 'PTHR45496:SF31', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 249945),
(399014, 'PTHR45496:SF32', NULL, NULL, NULL, NULL, 'PROTEIN ADMETOS', 249945),
(399015, 'PTHR45496:SF10', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', 249945),
(399016, 'PTHR45496:SF12', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 249945),
(399017, 'PTHR45496:SF23', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN-RELATED', 249945),
(399018, 'PTHR45496:SF25', NULL, NULL, NULL, NULL, 'OS07G0620200 PROTEIN', 249945),
(399019, 'PTHR45496:SF15', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN PROTEIN', 249945),
(399020, 'PTHR45496:SF9', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN PROTEIN', 249945),
(399021, 'PTHR45496:SF5', NULL, NULL, NULL, NULL, 'DNAJ DOMAIN CONTAINING PROTEIN, EXPRESSED', 249945),
(399022, 'PTHR45496:SF6', NULL, NULL, NULL, NULL, 'OS09G0463700 PROTEIN', 249945);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(399023, 'PTHR21493:SF242', NULL, NULL, NULL, NULL, 'GOT1-LIKE FAMILY PROTEIN, EXPRESSED', 249946),
(399024, 'PTHR21493:SF244', NULL, NULL, NULL, NULL, 'OS07G0593400 PROTEIN', 249946),
(399025, 'PTHR21493:SF245', NULL, NULL, NULL, NULL, 'VESICLE TRANSPORT PROTEIN GOT1A', 249946),
(399026, 'PTHR21493:SF9', NULL, NULL, NULL, NULL, 'GOLGI TRANSPORT PROTEIN 1-RELATED', 249946),
(399027, 'PTHR21493:SF250', NULL, NULL, NULL, NULL, 'GOLGI TRANSPORT 1BA', 249946),
(399028, 'PTHR21493:SF251', NULL, NULL, NULL, NULL, 'VESICLE TRANSPORT PROTEIN GOT1B-LIKE', 249946),
(399029, 'PTHR21493', NULL, NULL, NULL, NULL, 'CGI-141-RELATED/LIPASE CONTAINING PROTEIN', 249946),
(399030, 'PTHR21493:SF79', NULL, NULL, NULL, NULL, 'VESICLE TRANSPORT PROTEIN GOT1B', 249946),
(399031, 'PTHR21493:SF246', NULL, NULL, NULL, NULL, 'GOT1/SFT2-LIKE VESCICLE TRANSPORT PROTEIN FAMILY', 249946),
(399032, 'PTHR21493:SF247', NULL, NULL, NULL, NULL, 'VESICLE TRANSPORT PROTEIN GOT1', 249946),
(399033, 'PTHR21493:SF248', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN GOT1B, PUTATIVE-RELATED', 249946),
(399034, 'PTHR13527:SF0', NULL, NULL, NULL, NULL, 'SAYSVFN DOMAIN-CONTAINING PROTEIN 1', 249947),
(399035, 'PTHR13527', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 249947),
(399036, 'PTHR33121:SF15', NULL, NULL, NULL, NULL, 'BLUE LIGHT- AND TEMPERATURE-REGULATED ANTIREPRESSOR BLUF', 249948),
(399037, 'PTHR33121:SF69', NULL, NULL, NULL, NULL, 'ANTI-FLHC(2)FLHD(4) FACTOR YDIV-RELATED', 249948),
(399038, 'PTHR33121:SF56', NULL, NULL, NULL, NULL, 'SIGNALLING PROTEIN WITH EAL AND C2 DOMAINS', 249948),
(399039, 'PTHR33121:SF23', NULL, NULL, NULL, NULL, 'CYCLIC DI-GMP PHOSPHODIESTERASE PDEB', 249948),
(399040, 'PTHR33121:SF45', NULL, NULL, NULL, NULL, 'FYVE-TYPE DOMAIN-CONTAINING PROTEIN', 249948),
(399041, 'PTHR33121:SF77', NULL, NULL, NULL, NULL, 'CYCLIC DI-GMP PHOSPHODIESTERASE PDEK-RELATED', 249948),
(399042, 'PTHR33121:SF76', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL DIGUANYLATE CYCLASE/PHOSPHODIESTERASE', 249948),
(399043, 'PTHR33121:SF32', NULL, NULL, NULL, NULL, 'RNASE E SPECIFICITY FACTOR CSRD', 249948),
(399044, 'PTHR33121:SF75', NULL, NULL, NULL, NULL, 'CYCLIC DI-GMP PHOSPHODIESTERASE PDEL-RELATED', 249948),
(399045, 'PTHR33121:SF64', NULL, NULL, NULL, NULL, 'CYCLIC DI-GMP PHOSPHODIESTERASE PDEF', 249948),
(399046, 'PTHR33121:SF74', NULL, NULL, NULL, NULL, 'CYCLIC DI-GMP PHOSPHODIESTERASE PDEA-RELATED', 249948),
(399047, 'PTHR33121:SF73', NULL, NULL, NULL, NULL, 'CYCLIC DI-GMP PHOSPHODIESTERASE PDEN-RELATED', 249948),
(399048, 'PTHR33121:SF72', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL DIGUANYLATE CYCLASE WITH GAF AND PAS SENSORY DOMAINS/SIGNALLING PROTEIN WITH EAL DOMAIN', 249948),
(399049, 'PTHR33121:SF71', NULL, NULL, NULL, NULL, 'SIGNALING PROTEIN YKOW', 249948),
(399050, 'PTHR33121:SF9', NULL, NULL, NULL, NULL, 'CYCLIC DI-GMP PHOSPHODIESTERASE PDED-RELATED', 249948),
(399051, 'PTHR33121:SF60', NULL, NULL, NULL, NULL, 'CYCLIC DI-GMP PHOSPHODIESTERASE PDEC-RELATED', 249948),
(399052, 'PTHR33121:SF70', NULL, NULL, NULL, NULL, 'CYCLIC DI-GMP PHOSPHODIESTERASE PDEH', 249948),
(399053, 'PTHR33121', NULL, NULL, NULL, NULL, 'CYCLIC DI-GMP PHOSPHODIESTERASE PDEF', 249948),
(399054, 'PTHR33121:SF19', NULL, NULL, NULL, NULL, 'EAL DOMAIN-CONTAINING PROTEIN', 249948),
(399055, 'PTHR30298:SF0', NULL, NULL, NULL, NULL, 'INACTIVE TRANSPOSASE YBFQ-RELATED', 249949),
(399056, 'PTHR30298', NULL, NULL, NULL, NULL, 'H REPEAT-ASSOCIATED PREDICTED TRANSPOSASE', 249949),
(399057, 'PTHR46581:SF12', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249950),
(399058, 'PTHR46581:SF6', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249950),
(399059, 'PTHR46581:SF3', NULL, NULL, NULL, NULL, 'ARABINOSYLTRANSFERASE RRA3', 249950),
(399060, 'PTHR46581', NULL, NULL, NULL, NULL, 'ARABINOSYLTRANSFERASE RRA3', 249950),
(399061, 'PTHR46581:SF4', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249950),
(399062, 'PTHR46581:SF9', NULL, NULL, NULL, NULL, 'ARABINOSYLTRANSFERASE RRA1-RELATED', 249950),
(399063, 'PTHR46581:SF10', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249950),
(399064, 'PTHR46581:SF11', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 249950);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(399065, 'PTHR33254:SF28', NULL, NULL, NULL, NULL, '4-HYDROXY-4-METHYL-2-OXOGLUTARATE ALDOLASE', 249951),
(399066, 'PTHR33254:SF17', NULL, NULL, NULL, NULL, '4-HYDROXY-4-METHYL-2-OXOGLUTARATE ALDOLASE 1-RELATED', 249951),
(399067, 'PTHR33254:SF21', NULL, NULL, NULL, NULL, 'BNAA10G10490D PROTEIN', 249951),
(399068, 'PTHR33254:SF20', NULL, NULL, NULL, NULL, '4-HYDROXY-4-METHYL-2-OXOGLUTARATE ALDOLASE', 249951),
(399069, 'PTHR33254', NULL, NULL, NULL, NULL, '4-HYDROXY-4-METHYL-2-OXOGLUTARATE ALDOLASE 3-RELATED', 249951),
(399070, 'PTHR33254:SF4', NULL, NULL, NULL, NULL, '4-HYDROXY-4-METHYL-2-OXOGLUTARATE ALDOLASE 3-RELATED', 249951),
(399071, 'PTHR33254:SF22', NULL, NULL, NULL, NULL, '4-HYDROXY-4-METHYL-2-OXOGLUTARATE ALDOLASE', 249951),
(399072, 'PTHR33254:SF25', NULL, NULL, NULL, NULL, 'DLPA DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_4G10940)', 249951),
(399073, 'PTHR33254:SF27', NULL, NULL, NULL, NULL, '4-HYDROXY-4-METHYL-2-OXOGLUTARATE ALDOLASE', 249951),
(399074, 'PTHR33254:SF16', NULL, NULL, NULL, NULL, 'BLR3842 PROTEIN', 249951),
(399075, 'PTHR33254:SF26', NULL, NULL, NULL, NULL, '4-HYDROXY-4-METHYL-2-OXOGLUTARATE ALDOLASE', 249951),
(399076, 'PTHR31872:SF6', NULL, NULL, NULL, NULL, 'ZGC:153018', 249952),
(399077, 'PTHR31872:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 179', 249952),
(399078, 'PTHR31872:SF5', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 179', 249952),
(399079, 'PTHR31872', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 179', 249952),
(399080, 'PTHR34996:SF6', NULL, NULL, NULL, NULL, '', 249953),
(399081, 'PTHR34996:SF7', NULL, NULL, NULL, NULL, '', 249953),
(399082, 'PTHR34996:SF2', NULL, NULL, NULL, NULL, 'OS02G0193732 PROTEIN', 249953),
(399083, 'PTHR34996:SF3', NULL, NULL, NULL, NULL, 'OS06G0327400 PROTEIN', 249953),
(399084, 'PTHR34996', NULL, NULL, NULL, NULL, 'OS06G0327400 PROTEIN', 249953),
(399085, 'PTHR34996:SF5', NULL, NULL, NULL, NULL, 'OS02G0713250 PROTEIN', 249953),
(399086, 'PTHR45636', NULL, NULL, NULL, NULL, 'PAIRED BOX PROTEIN PAX-6-RELATED-RELATED', 249954),
(399087, 'PTHR45636:SF40', NULL, NULL, NULL, NULL, 'PAX (PAIRED BOX) TRANSCRIPTION FACTOR', 249954),
(399088, 'PTHR45636:SF13', NULL, NULL, NULL, NULL, 'PAIRED BOX PROTEIN PAX-9', 249954),
(399089, 'PTHR45636:SF35', NULL, NULL, NULL, NULL, 'PAIRED BOX 10', 249954),
(399090, 'PTHR45636:SF8', NULL, NULL, NULL, NULL, 'PAIRED BOX PROTEIN PAX-4', 249954),
(399091, 'PTHR45636:SF26', NULL, NULL, NULL, NULL, 'PAIRED BOX PROTEIN PAX-7', 249954),
(399092, 'PTHR45636:SF15', NULL, NULL, NULL, NULL, 'PAIRED BOX PROTEIN PAX-1', 249954),
(399093, 'PTHR45636:SF42', NULL, NULL, NULL, NULL, 'PROTEIN CBR-NPAX-1', 249954),
(399094, 'PTHR45636:SF20', NULL, NULL, NULL, NULL, 'PAIRED BOX PROTEIN PAX-5', 249954),
(399095, 'PTHR45636:SF31', NULL, NULL, NULL, NULL, 'PAX PROTEIN-RELATED', 249954),
(399096, 'PTHR45636:SF3', NULL, NULL, NULL, NULL, 'PAIRED', 249954),
(399097, 'PTHR45636:SF41', NULL, NULL, NULL, NULL, 'PAIRED BOX PROTEIN PAX-6', 249954),
(399098, 'PTHR45636:SF44', NULL, NULL, NULL, NULL, 'PAIRED BOX 6B-RELATED', 249954),
(399099, 'PTHR45636:SF6', NULL, NULL, NULL, NULL, 'PAIRED BOX PROTEIN PAX-8', 249954),
(399100, 'PTHR45636:SF21', NULL, NULL, NULL, NULL, 'PAIRED BOX PROTEIN PAX-6', 249954),
(399101, 'PTHR45636:SF43', NULL, NULL, NULL, NULL, 'PAIRED BOX POX-NEURO PROTEIN-RELATED', 249954),
(399102, 'PTHR45636:SF5', NULL, NULL, NULL, NULL, 'EYEGONE, ISOFORM A-RELATED', 249954),
(399103, 'PTHR45636:SF17', NULL, NULL, NULL, NULL, 'PAIRED BOX PROTEIN PAX-3', 249954),
(399104, 'PTHR45636:SF39', NULL, NULL, NULL, NULL, 'PAIRED DOMAIN-CONTAINING PROTEIN', 249954),
(399105, 'PTHR45636:SF27', NULL, NULL, NULL, NULL, 'PAIRED DOMAIN-CONTAINING PROTEIN', 249954),
(399106, 'PTHR45636:SF38', NULL, NULL, NULL, NULL, 'PROTEIN GOOSEBERRY-RELATED', 249954),
(399107, 'PTHR45636:SF16', NULL, NULL, NULL, NULL, 'PAIRED BOX POX-MESO PROTEIN', 249954),
(399108, 'PTHR45636:SF19', NULL, NULL, NULL, NULL, 'PAIRED BOX PROTEIN PAX-2', 249954),
(399109, 'PTHR44040', NULL, NULL, NULL, NULL, 'RETINOBLASTOMA-BINDING PROTEIN 5', 249955);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(399110, 'PTHR44040:SF1', NULL, NULL, NULL, NULL, 'RETINOBLASTOMA-BINDING PROTEIN 5', 249955),
(399111, 'PTHR46917', NULL, NULL, NULL, NULL, 'MORN REPEAT-CONTAINING PROTEIN 2', 249956),
(399112, 'PTHR46917:SF1', NULL, NULL, NULL, NULL, 'MORN REPEAT-CONTAINING PROTEIN 2', 249956),
(399113, 'PTHR47296', NULL, NULL, NULL, NULL, 'PROTEIN TIC 40, CHLOROPLASTIC', 249957),
(399114, 'PTHR47296:SF3', NULL, NULL, NULL, NULL, 'BNAC09G41260D PROTEIN', 249957),
(399115, 'PTHR47296:SF1', NULL, NULL, NULL, NULL, 'PROTEIN TIC 40, CHLOROPLASTIC', 249957),
(399116, 'PTHR43602:SF1', NULL, NULL, NULL, NULL, 'ENOYL-COA HYDRATASE DOMAIN-CONTAINING PROTEIN 3, MITOCHONDRIAL', 249958),
(399117, 'PTHR43602', NULL, NULL, NULL, NULL, '', 249958),
(399118, 'PTHR46521:SF13', NULL, NULL, NULL, NULL, 'SUCROSE-PHOSPHATASE 3B-RELATED', 249959),
(399119, 'PTHR46521:SF10', NULL, NULL, NULL, NULL, 'SUCROSE-PHOSPHATASE', 249959),
(399120, 'PTHR46521:SF11', NULL, NULL, NULL, NULL, 'SUCROSE-PHOSPHATASE', 249959),
(399121, 'PTHR46521:SF9', NULL, NULL, NULL, NULL, 'SUCROSE-PHOSPHATASE 2', 249959),
(399122, 'PTHR46521:SF14', NULL, NULL, NULL, NULL, 'SUCROSE-PHOSPHATE PHOSPHATASE', 249959),
(399123, 'PTHR46521:SF15', NULL, NULL, NULL, NULL, 'SUCROSE-PHOSPHATASE', 249959),
(399124, 'PTHR46521:SF8', NULL, NULL, NULL, NULL, 'SUCROSE-PHOSPHATASE 3A-RELATED', 249959),
(399125, 'PTHR46521:SF7', NULL, NULL, NULL, NULL, 'SUCROSE-PHOSPHATASE 1-RELATED', 249959),
(399126, 'PTHR46521:SF2', NULL, NULL, NULL, NULL, 'SUCROSE-PHOSPHATASE 3-RELATED', 249959),
(399127, 'PTHR46521', NULL, NULL, NULL, NULL, 'SUCROSE-PHOSPHATASE 2-RELATED', 249959),
(399128, 'PTHR46521:SF4', NULL, NULL, NULL, NULL, 'SUCROSE-PHOSPHATASE 2-RELATED', 249959),
(399129, 'PTHR47504', NULL, NULL, NULL, NULL, 'RIGHT ORIGIN-BINDING PROTEIN', 249960),
(399130, 'PTHR47504:SF6', NULL, NULL, NULL, NULL, 'ARAC-FAMILY TRANSCRIPTIONAL REGULATOR-RELATED', 249960),
(399131, 'PTHR47504:SF5', NULL, NULL, NULL, NULL, 'RIGHT ORIGIN-BINDING PROTEIN', 249960),
(399132, 'PTHR47504:SF4', NULL, NULL, NULL, NULL, 'MULTIPLE ANTIBIOTIC RESISTANCE PROTEIN MARA', 249960),
(399133, 'PTHR47504:SF3', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR YKGA-RELATED', 249960),
(399134, 'PTHR47504:SF2', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN SOXS', 249960),
(399135, 'PTHR13366:SF0', NULL, NULL, NULL, NULL, 'HEAT REPEAT-CONTAINING PROTEIN 6', 249961),
(399136, 'PTHR13366', NULL, NULL, NULL, NULL, 'MALARIA ANTIGEN-RELATED', 249961),
(399137, 'PTHR22954', NULL, NULL, NULL, NULL, 'RETROVIRAL PROTEASE-RELATED', 249962),
(399138, 'PTHR22954:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBR-FCE-2', 249962),
(399139, 'PTHR22954:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG08539', 249962),
(399140, 'PTHR15260', NULL, NULL, NULL, NULL, 'SARCOSPAN', 249963),
(399141, 'PTHR15260:SF1', NULL, NULL, NULL, NULL, 'SARCOSPAN', 249963),
(399142, 'PTHR38502', NULL, NULL, NULL, NULL, 'OVEREXPRESSED IN COLON CARCINOMA 1 PROTEIN', 249964),
(399143, 'PTHR38502:SF1', NULL, NULL, NULL, NULL, 'OVEREXPRESSED IN COLON CARCINOMA 1 PROTEIN', 249964),
(399144, 'PTHR35751:SF4', NULL, NULL, NULL, NULL, 'BNAA03G46330D PROTEIN', 249965),
(399145, 'PTHR35751:SF5', NULL, NULL, NULL, NULL, '', 249965),
(399146, 'PTHR35751:SF3', NULL, NULL, NULL, NULL, 'OS06G0530200 PROTEIN', 249965),
(399147, 'PTHR35751', NULL, NULL, NULL, NULL, '', 249965),
(399148, 'PTHR35751:SF1', NULL, NULL, NULL, NULL, 'BNAA02G37040D PROTEIN', 249965),
(399149, 'PTHR15241:SF318', NULL, NULL, NULL, NULL, 'BNAA06G35380D PROTEIN', 249966),
(399150, 'PTHR15241:SF319', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 249966),
(399151, 'PTHR15241:SF316', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 249966),
(399152, 'PTHR15241', NULL, NULL, NULL, NULL, 'TRANSFORMER-2-RELATED', 249966),
(399153, 'PTHR15241:SF317', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 249966),
(399154, 'PTHR15241:SF311', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN 27C', 249966),
(399155, 'PTHR15241:SF355', NULL, NULL, NULL, NULL, '28 KDA RIBONUCLEOPROTEIN, CHLOROPLASTIC', 249966);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(399156, 'PTHR15241:SF280', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 249966),
(399157, 'PTHR15241:SF281', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN 1-LIKE', 249966),
(399158, 'PTHR15241:SF361', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 249966),
(399159, 'PTHR15241:SF284', NULL, NULL, NULL, NULL, 'UBP1-ASSOCIATED PROTEIN 2C', 249966),
(399160, 'PTHR15241:SF282', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 249966),
(399161, 'PTHR15241:SF308', NULL, NULL, NULL, NULL, 'FLOWERING TIME CONTROL PROTEIN FCA ISOFORM X1', 249966),
(399162, 'PTHR15241:SF306', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 249966),
(399163, 'PTHR15241:SF309', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 249966),
(399164, 'PTHR15241:SF300', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 249966),
(399165, 'PTHR15241:SF341', NULL, NULL, NULL, NULL, '29 KDA RIBONUCLEOPROTEIN B, CHLOROPLASTIC', 249966),
(399166, 'PTHR15241:SF303', NULL, NULL, NULL, NULL, '33 KDA RIBONUCLEOPROTEIN, CHLOROPLASTIC', 249966),
(399167, 'PTHR15241:SF304', NULL, NULL, NULL, NULL, 'OS02G0268750 PROTEIN', 249966),
(399168, 'PTHR15241:SF301', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN 2, CHLOROPLASTIC', 249966),
(399169, 'PTHR15241:SF350', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 249966),
(399170, 'PTHR15241:SF351', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 249966),
(399171, 'PTHR15241:SF376', NULL, NULL, NULL, NULL, '29 KDA RIBONUCLEOPROTEIN A, CHLOROPLASTIC-LIKE', 249966),
(399172, 'PTHR15241:SF333', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 249966),
(399173, 'PTHR15241:SF135', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN', 249966),
(399174, 'PTHR15241:SF377', NULL, NULL, NULL, NULL, 'ORGANELLE RRM DOMAIN-CONTAINING PROTEIN 2, MITOCHONDRIAL-LIKE', 249966),
(399175, 'PTHR15241:SF374', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 249966),
(399176, 'PTHR15241:SF375', NULL, NULL, NULL, NULL, 'BNAA06G12790D PROTEIN', 249966),
(399177, 'PTHR15241:SF298', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 249966),
(399178, 'PTHR15241:SF337', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 249966),
(399179, 'PTHR15241:SF334', NULL, NULL, NULL, NULL, 'GLYCINE-RICH RNA-BINDING PROTEIN 4, MITOCHONDRIAL', 249966),
(399180, 'PTHR15241:SF378', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 249966),
(399181, 'PTHR15241:SF335', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 249966),
(399182, 'PTHR15241:SF379', NULL, NULL, NULL, NULL, 'UBP1-ASSOCIATED PROTEIN 2A-LIKE', 249966),
(399183, 'PTHR15241:SF380', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN', 249966),
(399184, 'PTHR15241:SF383', NULL, NULL, NULL, NULL, '', 249966),
(399185, 'PTHR15241:SF384', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN A1', 249966),
(399186, 'PTHR15241:SF381', NULL, NULL, NULL, NULL, '28 KDA RIBONUCLEOPROTEIN, CHLOROPLASTIC-LIKE', 249966),
(399187, 'PTHR15241:SF382', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 249966),
(399188, 'PTHR15241:SF327', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 249966),
(399189, 'PTHR15241:SF328', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 249966),
(399190, 'PTHR15241:SF288', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 249966),
(399191, 'PTHR15241:SF321', NULL, NULL, NULL, NULL, '31 KDA RIBONUCLEOPROTEIN, CHLOROPLASTIC', 249966),
(399192, 'PTHR15241:SF363', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 249966),
(399193, 'PTHR15241:SF364', NULL, NULL, NULL, NULL, 'AGAP003899-PA', 249966),
(399194, 'PTHR15241:SF320', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN D LIKE', 249966),
(399195, 'PTHR15241:SF325', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 249966),
(399196, 'PTHR15241:SF369', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 249966),
(399197, 'PTHR15241:SF326', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 249966);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(399198, 'PTHR15241:SF368', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 249966),
(399199, 'PTHR15241:SF292', NULL, NULL, NULL, NULL, 'GLYCINE-RICH RNA-BINDING PROTEIN 3, MITOCHONDRIAL', 249966),
(399200, 'PTHR15241:SF290', NULL, NULL, NULL, NULL, '29 KDA RIBONUCLEOPROTEIN A, CHLOROPLASTIC', 249966),
(399201, 'PTHR15241:SF372', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN RSD1-LIKE', 249966),
(399202, 'PTHR15241:SF295', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 249966),
(399203, 'PTHR15241:SF296', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN 27C', 249966),
(399204, 'PTHR15241:SF373', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 249966),
(399205, 'PTHR15241:SF370', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 249966),
(399206, 'PTHR15241:SF371', NULL, NULL, NULL, NULL, '', 249966),
(399207, 'PTHR15241:SF294', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 249966),
(399208, 'PTHR31413:SF28', NULL, NULL, NULL, NULL, 'BNAC08G40190D PROTEIN', 249967),
(399209, 'PTHR31413:SF17', NULL, NULL, NULL, NULL, 'NINJA-FAMILY PROTEIN AFP1-LIKE ISOFORM X1', 249967),
(399210, 'PTHR31413:SF16', NULL, NULL, NULL, NULL, 'TDBD DOMAIN-CONTAINING PROTEIN', 249967),
(399211, 'PTHR31413:SF27', NULL, NULL, NULL, NULL, 'TDBD DOMAIN-CONTAINING PROTEIN', 249967),
(399212, 'PTHR31413:SF13', NULL, NULL, NULL, NULL, 'NINJA-FAMILY PROTEIN AFP4', 249967),
(399213, 'PTHR31413:SF46', NULL, NULL, NULL, NULL, 'NINJA-FAMILY PROTEIN AFP1', 249967),
(399214, 'PTHR31413:SF45', NULL, NULL, NULL, NULL, 'TDBD DOMAIN-CONTAINING PROTEIN', 249967),
(399215, 'PTHR31413:SF34', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE BINDING FACTOR-ASSOCIATED REPRESSION-RELATED', 249967),
(399216, 'PTHR31413:SF23', NULL, NULL, NULL, NULL, 'TDBD DOMAIN-CONTAINING PROTEIN', 249967),
(399217, 'PTHR31413:SF12', NULL, NULL, NULL, NULL, 'AFP HOMOLOG 2', 249967),
(399218, 'PTHR31413:SF9', NULL, NULL, NULL, NULL, 'NINJA-FAMILY PROTEIN OS03G0419100', 249967),
(399219, 'PTHR31413:SF48', NULL, NULL, NULL, NULL, 'BNAA09G02630D PROTEIN', 249967),
(399220, 'PTHR31413:SF26', NULL, NULL, NULL, NULL, 'BNAC06G30430D PROTEIN', 249967),
(399221, 'PTHR31413:SF15', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSPORT FACTOR 2/RNA RECOGNITION MOTIF PROTEIN', 249967),
(399222, 'PTHR31413:SF47', NULL, NULL, NULL, NULL, 'TDBD DOMAIN-CONTAINING PROTEIN', 249967),
(399223, 'PTHR31413:SF31', NULL, NULL, NULL, NULL, 'NINJA-FAMILY PROTEIN AFP3', 249967),
(399224, 'PTHR31413:SF42', NULL, NULL, NULL, NULL, 'EAR DOMAIN-CONTAINING PROTEIN', 249967),
(399225, 'PTHR31413:SF20', NULL, NULL, NULL, NULL, 'NINJA-FAMILY PROTEIN AFP2', 249967),
(399226, 'PTHR31413:SF22', NULL, NULL, NULL, NULL, 'NINJA-FAMILY PROTEIN OS07G0602900', 249967),
(399227, 'PTHR31413:SF44', NULL, NULL, NULL, NULL, 'NINJA-FAMILY PROTEIN MODD', 249967),
(399228, 'PTHR31413:SF43', NULL, NULL, NULL, NULL, 'NINJA-FAMILY PROTEIN AFP1', 249967),
(399229, 'PTHR31413:SF32', NULL, NULL, NULL, NULL, 'TDBD DOMAIN-CONTAINING PROTEIN', 249967),
(399230, 'PTHR31413:SF21', NULL, NULL, NULL, NULL, 'NINJA-FAMILY PROTEIN AFP1-LIKE', 249967),
(399231, 'PTHR31413', NULL, NULL, NULL, NULL, 'AFP HOMOLOG 2', 249967),
(399232, 'PTHR37205:SF2', NULL, NULL, NULL, NULL, '', 249968),
(399233, 'PTHR37205:SF1', NULL, NULL, NULL, NULL, 'F23A5.30 PROTEIN', 249968),
(399234, 'PTHR37205', NULL, NULL, NULL, NULL, 'F23A5.30 PROTEIN', 249968),
(399235, 'PTHR12371', NULL, NULL, NULL, NULL, 'TRANSLOCATION ASSOCIATED MEMBRANE PROTEIN', 249969),
(399236, 'PTHR12371:SF9', NULL, NULL, NULL, NULL, 'TRANSLOCATING CHAIN-ASSOCIATED MEMBRANE PROTEIN 1-LIKE 1', 249969),
(399237, 'PTHR12371:SF11', NULL, NULL, NULL, NULL, 'TRANSLOCATING CHAIN-ASSOCIATED MEMBRANE PROTEIN', 249969),
(399238, 'PTHR12371:SF10', NULL, NULL, NULL, NULL, 'TRANSLOCATING CHAIN-ASSOCIATED MEMBRANE PROTEIN', 249969),
(399239, 'PTHR12371:SF4', NULL, NULL, NULL, NULL, 'TRANSLOCATING CHAIN-ASSOCIATED MEMBRANE PROTEIN 2', 249969),
(399240, 'PTHR12371:SF3', NULL, NULL, NULL, NULL, 'TRANSLOCATING CHAIN-ASSOCIATED MEMBRANE PROTEIN 1', 249969);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(399241, 'PTHR47811', NULL, NULL, NULL, NULL, 'TRNA PSEUDOURIDINE SYNTHASE D', 249970),
(399242, 'PTHR47811:SF1', NULL, NULL, NULL, NULL, 'TRNA PSEUDOURIDINE SYNTHASE D', 249970),
(399243, 'PTHR38701', NULL, NULL, NULL, NULL, 'CHROMOSOME 8, WHOLE GENOME SHOTGUN SEQUENCE', 249971),
(399244, 'PTHR38701:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 8, WHOLE GENOME SHOTGUN SEQUENCE', 249971),
(399245, 'PTHR23339:SF103', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR 3', 249972),
(399246, 'PTHR23339:SF113', NULL, NULL, NULL, NULL, 'PROTEIN TYROSINE PHOSPHATASE DOMAIN-CONTAINING 1B-RELATED', 249972),
(399247, 'PTHR23339:SF115', NULL, NULL, NULL, NULL, 'TYR_PHOSPHATASE_2 DOMAIN-CONTAINING PROTEIN', 249972),
(399248, 'PTHR23339:SF104', NULL, NULL, NULL, NULL, 'METAL ION-BINDING PROTEIN', 249972),
(399249, 'PTHR23339:SF118', NULL, NULL, NULL, NULL, 'TYR_PHOSPHATASE_2 DOMAIN-CONTAINING PROTEIN', 249972),
(399250, 'PTHR23339:SF117', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE CDC14C', 249972),
(399251, 'PTHR23339:SF109', NULL, NULL, NULL, NULL, 'PROTEIN TYROSINE PHOSPHATASE DOMAIN-CONTAINING PROTEIN 1', 249972),
(399252, 'PTHR23339', NULL, NULL, NULL, NULL, 'TYROSINE SPECIFIC PROTEIN PHOSPHATASE AND DUAL SPECIFICITY PROTEIN PHOSPHATASE', 249972),
(399253, 'PTHR23339:SF119', NULL, NULL, NULL, NULL, 'PROTEIN TYROSINE PHOSPHATASE TYPE IVA 3', 249972),
(399254, 'PTHR23339:SF93', NULL, NULL, NULL, NULL, 'TYR_PHOSPHATASE_2 DOMAIN-CONTAINING PROTEIN-RELATED', 249972),
(399255, 'PTHR23339:SF60', NULL, NULL, NULL, NULL, 'TYR_PHOSPHATASE_2 DOMAIN-CONTAINING PROTEIN', 249972),
(399256, 'PTHR23339:SF26', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE 23', 249972),
(399257, 'PTHR23339:SF96', NULL, NULL, NULL, NULL, 'PALADIN', 249972),
(399258, 'PTHR23339:SF74', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE CDC14B', 249972),
(399259, 'PTHR23339:SF55', NULL, NULL, NULL, NULL, 'PROTEIN TYROSINE PHOSPHATASE TYPE IVA 1', 249972),
(399260, 'PTHR23339:SF77', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE CDC14A', 249972),
(399261, 'PTHR23339:SF65', NULL, NULL, NULL, NULL, 'PROTEIN TYROSINE PHOSPHATASE TYPE IVA 2', 249972),
(399262, 'PTHR23339:SF98', NULL, NULL, NULL, NULL, 'PRL-1 PHOSPHATASE', 249972),
(399263, 'PTHR23339:SF110', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 249972),
(399264, 'PTHR23339:SF121', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE 14AA-RELATED', 249972),
(399265, 'PTHR23339:SF120', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE 14B', 249972),
(399266, 'PTHR23339:SF27', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE-PHOSPHATASE', 249972),
(399267, 'PTHR43963', NULL, NULL, NULL, NULL, 'CARBONYL REDUCTASE 1-RELATED', 249973),
(399268, 'PTHR43963:SF2', NULL, NULL, NULL, NULL, 'CARBONYL REDUCTASE [NADPH] 1', 249973),
(399269, 'PTHR43963:SF3', NULL, NULL, NULL, NULL, 'CARBONYL REDUCTASE [NADPH] 3', 249973),
(399270, 'PTHR43963:SF6', NULL, NULL, NULL, NULL, 'CHAIN DEHYDROGENASE FAMILY PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G15350)-RELATED', 249973),
(399271, 'PTHR43963:SF4', NULL, NULL, NULL, NULL, 'CARBONYL REDUCTASE 1-RELATED', 249973),
(399272, 'PTHR10889', NULL, NULL, NULL, NULL, 'DEOXYRIBOSE-PHOSPHATE ALDOLASE', 249974),
(399273, 'PTHR10889:SF1', NULL, NULL, NULL, NULL, '2-DEOXY-D-RIBOSE 5-PHOSPHATE ALDOLASE', 249974),
(399274, 'PTHR10889:SF3', NULL, NULL, NULL, NULL, 'DEOXYRIBOSE-PHOSPHATE ALDOLASE', 249974),
(399275, 'PTHR36795:SF2', NULL, NULL, NULL, NULL, 'OS01G0938400 PROTEIN', 249975),
(399276, 'PTHR36795', NULL, NULL, NULL, NULL, 'OS01G0938400 PROTEIN', 249975),
(399277, 'PTHR36795:SF3', NULL, NULL, NULL, NULL, '', 249975),
(399278, 'PTHR43202:SF1', NULL, NULL, NULL, NULL, 'NICOTINATE PHOSPHORIBOSYLTRANSFERASE', 249976),
(399279, 'PTHR43202', NULL, NULL, NULL, NULL, 'NICOTINATE-NUCLEOTIDE PYROPHOSPHORYLASE', 249976),
(399280, 'PTHR46227:SF4', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR-INTERACTING PROTEIN 2', 249977),
(399281, 'PTHR46227:SF3', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR-INTERACTING PROTEIN 1', 249977);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(399282, 'PTHR46227:SF2', NULL, NULL, NULL, NULL, 'FI03335P', 249977),
(399283, 'PTHR46227', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR-INTERACTING PROTEIN GRIP', 249977),
(399284, 'PTHR45959:SF16', NULL, NULL, NULL, NULL, 'BASIC HELIX LOOP HELIX (BHLH) DNA-BINDING FAMILY PROTEIN', 249978),
(399285, 'PTHR45959:SF39', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN-CONTAINING PROTEIN-RELATED', 249978),
(399286, 'PTHR45959:SF17', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH19', 249978),
(399287, 'PTHR45959:SF18', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH18', 249978),
(399288, 'PTHR45959:SF56', NULL, NULL, NULL, NULL, 'BASIC HELIX-LOOP-HELIX (BHLH) DNA-BINDING SUPERFAMILY PROTEIN-RELATED', 249978),
(399289, 'PTHR45959:SF34', NULL, NULL, NULL, NULL, 'BASIC HELIX LOOP HELIX (BHLH) DNA-BINDING FAMILY PROTEIN', 249978),
(399290, 'PTHR45959:SF12', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH18-LIKE', 249978),
(399291, 'PTHR45959:SF57', NULL, NULL, NULL, NULL, 'OS12G0632600 PROTEIN', 249978),
(399292, 'PTHR45959:SF35', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN-CONTAINING PROTEIN-RELATED', 249978),
(399293, 'PTHR45959:SF13', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 249978),
(399294, 'PTHR45959:SF58', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH28', 249978),
(399295, 'PTHR45959', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTION FACTOR', 249978),
(399296, 'PTHR45959:SF59', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 249978),
(399297, 'PTHR45959:SF63', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 249978),
(399298, 'PTHR45959:SF42', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 249978),
(399299, 'PTHR45959:SF20', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH18-LIKE', 249978),
(399300, 'PTHR45959:SF64', NULL, NULL, NULL, NULL, 'BASIC HELIX LOOP HELIX (BHLH) DNA-BINDING FAMILY PROTEIN', 249978),
(399301, 'PTHR45959:SF43', NULL, NULL, NULL, NULL, 'BASIC HELIX LOOP HELIX (BHLH) DNA-BINDING FAMILY PROTEIN', 249978),
(399302, 'PTHR45959:SF21', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH18-LIKE', 249978),
(399303, 'PTHR45959:SF65', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 249978),
(399304, 'PTHR45959:SF66', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 249978),
(399305, 'PTHR45959:SF44', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 249978),
(399306, 'PTHR45959:SF22', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH18-LIKE', 249978),
(399307, 'PTHR45959:SF60', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTION FACTOR', 249978),
(399308, 'PTHR45959:SF61', NULL, NULL, NULL, NULL, 'HELIX LOOP HELIX DNA-BINDING DOMAIN PROTEIN', 249978),
(399309, 'PTHR45959:SF62', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH19-LIKE', 249978),
(399310, 'PTHR45959:SF40', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN-CONTAINING PROTEIN-RELATED', 249978),
(399311, 'PTHR45959:SF27', NULL, NULL, NULL, NULL, 'HELIX LOOP HELIX DNA-BINDING DOMAIN PROTEIN', 249978),
(399312, 'PTHR45959:SF28', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH18-LIKE', 249978),
(399313, 'PTHR45959:SF67', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH28', 249978),
(399314, 'PTHR45959:SF46', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 249978),
(399315, 'PTHR45959:SF25', NULL, NULL, NULL, NULL, 'SYMBIOTIC AMMONIUM TRANSPORTER', 249978),
(399316, 'PTHR45959:SF48', NULL, NULL, NULL, NULL, 'BASIC HELIX-LOOP-HELIX (BHLH) DNA-BINDING SUPERFAMILY PROTEIN-RELATED', 249978),
(399317, 'PTHR45959:SF26', NULL, NULL, NULL, NULL, 'HELIX LOOP HELIX DNA-BINDING DOMAIN PROTEIN', 249978),
(399318, 'PTHR45959:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH18-LIKE', 249978),
(399319, 'PTHR45959:SF8', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 249978),
(399320, 'PTHR45959:SF52', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR NAI1', 249978),
(399321, 'PTHR45959:SF3', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 249978),
(399322, 'PTHR45959:SF53', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH28', 249978);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(399323, 'PTHR45959:SF10', NULL, NULL, NULL, NULL, 'HELIX LOOP HELIX DNA-BINDING DOMAIN PROTEIN', 249978),
(399324, 'PTHR45959:SF32', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 249978),
(399325, 'PTHR45959:SF55', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 249978),
(399326, 'PTHR45959:SF33', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN-CONTAINING PROTEIN-RELATED', 249978),
(399327, 'PTHR45959:SF51', NULL, NULL, NULL, NULL, 'BASIC HELIX LOOP HELIX (BHLH) DNA-BINDING FAMILY PROTEIN', 249978),
(399328, 'PTHR45959:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH25', 249978),
(399329, 'PTHR15537', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 7', 249979),
(399330, 'PTHR15537:SF2', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 7', 249979),
(399331, 'PTHR31547', NULL, NULL, NULL, NULL, 'MULTIVESICULAR BODY SUBUNIT 12B', 249980),
(399332, 'PTHR31547:SF1', NULL, NULL, NULL, NULL, 'MULTIVESICULAR BODY SUBUNIT 12B', 249980),
(399333, 'PTHR23014:SF1', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN-RELATED', 249981),
(399334, 'PTHR23014', NULL, NULL, NULL, NULL, 'F-BOX A PROTEIN', 249981),
(399335, 'PTHR13866:SF22', NULL, NULL, NULL, NULL, 'FOLLISTATIN-RELATED PROTEIN 3', 249982),
(399336, 'PTHR13866:SF21', NULL, NULL, NULL, NULL, 'TESTICAN-3', 249982),
(399337, 'PTHR13866:SF24', NULL, NULL, NULL, NULL, 'SPARC-LIKE 2', 249982),
(399338, 'PTHR13866:SF18', NULL, NULL, NULL, NULL, 'TESTICAN-2', 249982),
(399339, 'PTHR13866:SF29', NULL, NULL, NULL, NULL, 'FOLLISTATIN', 249982),
(399340, 'PTHR13866:SF26', NULL, NULL, NULL, NULL, 'SPARC', 249982),
(399341, 'PTHR13866:SF25', NULL, NULL, NULL, NULL, 'SPARC-LIKE 1', 249982),
(399342, 'PTHR13866:SF14', NULL, NULL, NULL, NULL, 'BM-40', 249982),
(399343, 'PTHR13866:SF17', NULL, NULL, NULL, NULL, 'TESTICAN-1', 249982),
(399344, 'PTHR13866:SF28', NULL, NULL, NULL, NULL, 'FOLLISTATIN', 249982),
(399345, 'PTHR13866:SF16', NULL, NULL, NULL, NULL, 'SPARC-LIKE PROTEIN 1', 249982),
(399346, 'PTHR13866:SF27', NULL, NULL, NULL, NULL, 'KAZAL-LIKE DOMAIN-CONTAINING PROTEIN', 249982),
(399347, 'PTHR13866:SF6', NULL, NULL, NULL, NULL, 'SPARC', 249982),
(399348, 'PTHR13866', NULL, NULL, NULL, NULL, 'SPARC  OSTEONECTIN', 249982),
(399349, 'PTHR39319', NULL, NULL, NULL, NULL, 'SI:DKEY-256H2.1', 249983),
(399350, 'PTHR39319:SF1', NULL, NULL, NULL, NULL, 'SI:DKEY-256H2.1', 249983),
(399351, 'PTHR14682', NULL, NULL, NULL, NULL, 'KATNB1-LIKE PROTEIN 1', 249984),
(399352, 'PTHR14682:SF1', NULL, NULL, NULL, NULL, 'KATNB1-LIKE PROTEIN 1', 249984),
(399353, 'PTHR33510:SF12', NULL, NULL, NULL, NULL, 'PROTEIN TIC 20-IV, CHLOROPLASTIC', 249985),
(399354, 'PTHR33510:SF14', NULL, NULL, NULL, NULL, 'PROTEIN TIC 20', 249985),
(399355, 'PTHR33510:SF15', NULL, NULL, NULL, NULL, 'PROTEIN TIC 20', 249985),
(399356, 'PTHR33510:SF5', NULL, NULL, NULL, NULL, 'PROTEIN TIC 20-II, CHLOROPLASTIC', 249985),
(399357, 'PTHR33510:SF9', NULL, NULL, NULL, NULL, 'HIT-TYPE ZINC FINGER FAMILY PROTEIN-RELATED', 249985),
(399358, 'PTHR33510', NULL, NULL, NULL, NULL, 'PROTEIN TIC 20-II, CHLOROPLASTIC', 249985),
(399359, 'PTHR33510:SF10', NULL, NULL, NULL, NULL, 'PROTEIN TIC 20', 249985),
(399360, 'PTHR33510:SF11', NULL, NULL, NULL, NULL, 'PROTEIN TIC 20-V, CHLOROPLASTIC', 249985),
(399361, 'PTHR23241:SF105', NULL, NULL, NULL, NULL, 'DUF4149 DOMAIN-CONTAINING PROTEIN', 249986),
(399362, 'PTHR23241:SF106', NULL, NULL, NULL, NULL, 'DUF4149 DOMAIN-CONTAINING PROTEIN', 249986),
(399363, 'PTHR23241:SF102', NULL, NULL, NULL, NULL, 'LD23009P', 249986),
(399364, 'PTHR23241', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT  PLANTS  LEA-RELATED', 249986),
(399365, 'PTHR23241:SF103', NULL, NULL, NULL, NULL, 'OS11G0673100 PROTEIN', 249986),
(399366, 'PTHR28196:SF1', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN NET1-RELATED', 249987),
(399367, 'PTHR28196', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN NET1-RELATED', 249987),
(399368, 'PTHR42736', NULL, NULL, NULL, NULL, 'PROTEIN-GLUTAMINE GAMMA-GLUTAMYLTRANSFERASE', 249988),
(399369, 'PTHR42736:SF1', NULL, NULL, NULL, NULL, 'PROTEIN-GLUTAMINE GAMMA-GLUTAMYLTRANSFERASE', 249988);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(399370, 'PTHR30185:SF12', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR MANR', 249989),
(399371, 'PTHR30185:SF15', NULL, NULL, NULL, NULL, 'CRYPTIC BETA-GLUCOSIDE BGL OPERON ANTITERMINATOR', 249989),
(399372, 'PTHR30185:SF16', NULL, NULL, NULL, NULL, 'PROTEIN GLCT', 249989),
(399373, 'PTHR30185:SF13', NULL, NULL, NULL, NULL, 'LICABCH OPERON REGULATOR-RELATED', 249989),
(399374, 'PTHR30185:SF14', NULL, NULL, NULL, NULL, 'STATIONARY PHASE-INDUCIBLE PROTEIN CSIE-RELATED', 249989),
(399375, 'PTHR30185:SF9', NULL, NULL, NULL, NULL, 'EIIA', 249989),
(399376, 'PTHR30185:SF18', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR MTLR', 249989),
(399377, 'PTHR30185', NULL, NULL, NULL, NULL, 'CRYPTIC BETA-GLUCOSIDE BGL OPERON ANTITERMINATOR', 249989),
(399378, 'PTHR22771:SF2', NULL, NULL, NULL, NULL, 'CULLIN-9', 249990),
(399379, 'PTHR22771:SF3', NULL, NULL, NULL, NULL, 'CULLIN-7', 249990),
(399380, 'PTHR22771:SF4', NULL, NULL, NULL, NULL, 'CULLIN 7', 249990),
(399381, 'PTHR22771', NULL, NULL, NULL, NULL, 'CULLIN AND GALACTOSE-BINDING DOMAIN-CONTAINING', 249990),
(399382, 'PTHR36801', NULL, NULL, NULL, NULL, 'OS06G0150200 PROTEIN', 249991),
(399383, 'PTHR36801:SF3', NULL, NULL, NULL, NULL, 'OS06G0150300 PROTEIN', 249991),
(399384, 'PTHR36801:SF2', NULL, NULL, NULL, NULL, 'OS01G0570601 PROTEIN', 249991),
(399385, 'PTHR36801:SF5', NULL, NULL, NULL, NULL, '', 249991),
(399386, 'PTHR33375:SF1', NULL, NULL, NULL, NULL, 'STAGE 0 SPORULATION PROTEIN J', 249992),
(399387, 'PTHR33375', NULL, NULL, NULL, NULL, 'CHROMOSOME-PARTITIONING PROTEIN PARB-RELATED', 249992),
(399388, 'PTHR33375:SF7', NULL, NULL, NULL, NULL, 'CHROMOSOME 2-PARTITIONING PROTEIN PARB-RELATED', 249992),
(399389, 'PTHR33375:SF8', NULL, NULL, NULL, NULL, 'NUCLEOID OCCLUSION PROTEIN', 249992),
(399390, 'PTHR10528:SF17', NULL, NULL, NULL, NULL, 'AF4/FMR2 FAMILY MEMBER LILLI', 249993),
(399391, 'PTHR10528:SF16', NULL, NULL, NULL, NULL, 'AF4/FMR2 FAMILY MEMBER 3', 249993),
(399392, 'PTHR10528', NULL, NULL, NULL, NULL, 'AF4/FMR2 FAMILY MEMBER', 249993),
(399393, 'PTHR10528:SF18', NULL, NULL, NULL, NULL, 'AF4/FMR2 FAMILY MEMBER 2', 249993),
(399394, 'PTHR10528:SF6', NULL, NULL, NULL, NULL, 'AF4/FMR2 FAMILY MEMBER 1', 249993),
(399395, 'PTHR10528:SF15', NULL, NULL, NULL, NULL, 'AF4/FMR2 FAMILY MEMBER 4', 249993),
(399396, 'PTHR16476:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAM216A', 249994),
(399397, 'PTHR16476:SF3', NULL, NULL, NULL, NULL, 'PROTEIN FAM216B', 249994),
(399398, 'PTHR16476:SF4', NULL, NULL, NULL, NULL, 'FAMILY WITH SEQUENCE SIMILARITY 216 MEMBER A', 249994),
(399399, 'PTHR16476', NULL, NULL, NULL, NULL, 'FAMILY WITH SEQUENCE SIMILARITY 216 MEMBER A', 249994),
(399400, 'PTHR14731:SF0', NULL, NULL, NULL, NULL, 'BRAIN AND ACUTE LEUKEMIA CYTOPLASMIC PROTEIN', 249995),
(399401, 'PTHR14731', NULL, NULL, NULL, NULL, 'BRAIN AND ACUTE LEUKEMIA CYTOPLASMIC PROTEIN', 249995),
(399402, 'PTHR14731:SF1', NULL, NULL, NULL, NULL, 'BAALC BINDER OF MAP3K1 AND KLF4 B', 249995),
(399403, 'PTHR41151:SF1', NULL, NULL, NULL, NULL, 'PARTNER OF BURSICON', 249996),
(399404, 'PTHR41151', NULL, NULL, NULL, NULL, 'PARTNER OF BURSICON', 249996),
(399405, 'PTHR34270:SF7', NULL, NULL, NULL, NULL, 'BNAC05G47090D PROTEIN', 249997),
(399406, 'PTHR34270:SF8', NULL, NULL, NULL, NULL, 'BNAA01G22700D PROTEIN', 249997),
(399407, 'PTHR34270:SF5', NULL, NULL, NULL, NULL, 'PROTEIN RALF-LIKE 10-RELATED', 249997),
(399408, 'PTHR34270:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 249997),
(399409, 'PTHR34270', NULL, NULL, NULL, NULL, 'PROTEIN RALF-LIKE 15-RELATED', 249997),
(399410, 'PTHR34270:SF1', NULL, NULL, NULL, NULL, 'PROTEIN RALF-LIKE 16-RELATED', 249997),
(399411, 'PTHR34270:SF15', NULL, NULL, NULL, NULL, '', 249997),
(399412, 'PTHR34270:SF14', NULL, NULL, NULL, NULL, 'RALF', 249997),
(399413, 'PTHR34270:SF13', NULL, NULL, NULL, NULL, 'BNAC07G01070D PROTEIN', 249997),
(399414, 'PTHR34270:SF12', NULL, NULL, NULL, NULL, 'PROTEIN RALF-LIKE 15-RELATED', 249997),
(399415, 'PTHR34270:SF11', NULL, NULL, NULL, NULL, '', 249997),
(399416, 'PTHR37437:SF7', NULL, NULL, NULL, NULL, 'LIPOCALIN-RELATED PROTEIN', 249998);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(399417, 'PTHR37437:SF4', NULL, NULL, NULL, NULL, 'LIPOCALIN-RELATED PROTEIN', 249998),
(399418, 'PTHR37437:SF6', NULL, NULL, NULL, NULL, 'LIPOCALIN-RELATED PROTEIN', 249998),
(399419, 'PTHR37437:SF5', NULL, NULL, NULL, NULL, 'LIPOCALIN-RELATED PROTEIN', 249998),
(399420, 'PTHR37437', NULL, NULL, NULL, NULL, 'LIPOCALIN-RELATED PROTEIN-RELATED', 249998),
(399421, 'PTHR37437:SF2', NULL, NULL, NULL, NULL, 'LIPOCALIN-RELATED PROTEIN', 249998),
(399422, 'PTHR37437:SF1', NULL, NULL, NULL, NULL, 'LIPOCALIN-RELATED PROTEIN', 249998),
(399423, 'PTHR44379:SF5', NULL, NULL, NULL, NULL, 'XANTHINE DEHYDROGENASE SUBUNIT E-RELATED', 249999),
(399424, 'PTHR44379:SF2', NULL, NULL, NULL, NULL, 'BLR6218 PROTEIN', 249999),
(399425, 'PTHR44379:SF9', NULL, NULL, NULL, NULL, 'BLR0840 PROTEIN', 249999),
(399426, 'PTHR44379:SF8', NULL, NULL, NULL, NULL, 'XANTHINE DEHYDROGENASE IRON-SULFUR-BINDING SUBUNIT XDHC-RELATED', 249999),
(399427, 'PTHR44379:SF7', NULL, NULL, NULL, NULL, 'XANTHINE DEHYDROGENASE IRON-SULFUR BINDING SUBUNIT', 249999),
(399428, 'PTHR44379', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE WITH IRON-SULFUR SUBUNIT', 249999),
(399429, 'PTHR44379:SF6', NULL, NULL, NULL, NULL, 'BLR6046 PROTEIN', 249999),
(399430, 'PTHR31760:SF0', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 250000),
(399431, 'PTHR31760', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 250000),
(399432, 'PTHR28544:SF1', NULL, NULL, NULL, NULL, 'DENN DOMAIN-CONTAINING PROTEIN 10-RELATED', 250001),
(399433, 'PTHR28544', NULL, NULL, NULL, NULL, 'PROTEIN FAM45A-RELATED', 250001),
(399434, 'PTHR46507:SF1', NULL, NULL, NULL, NULL, 'AFADIN- AND ALPHA-ACTININ-BINDING PROTEIN', 250002),
(399435, 'PTHR46507:SF2', NULL, NULL, NULL, NULL, 'SYNOVIAL SARCOMA, X BREAKPOINT 2-INTERACTING PROTEIN A-RELATED', 250002),
(399436, 'PTHR46507:SF3', NULL, NULL, NULL, NULL, 'SI:CH211-286B5.4', 250002),
(399437, 'PTHR46507:SF4', NULL, NULL, NULL, NULL, 'SSX FAMILY MEMBER 2 INTERACTING PROTEIN', 250002),
(399438, 'PTHR46507:SF5', NULL, NULL, NULL, NULL, '', 250002),
(399439, 'PTHR46507', NULL, NULL, NULL, NULL, 'AFADIN- AND ALPHA-ACTININ-BINDING PROTEIN', 250002),
(399440, 'PTHR13372', NULL, NULL, NULL, NULL, 'GEMININ', 250003),
(399441, 'PTHR13372:SF5', NULL, NULL, NULL, NULL, 'GEMININ', 250003),
(399442, 'PTHR13372:SF3', NULL, NULL, NULL, NULL, 'MULTICILIN', 250003),
(399443, 'PTHR13372:SF4', NULL, NULL, NULL, NULL, 'GEMININ', 250003),
(399444, 'PTHR13372:SF2', NULL, NULL, NULL, NULL, 'GEMININ COILED-COIL DOMAIN-CONTAINING PROTEIN 1', 250003),
(399445, 'PTHR37214', NULL, NULL, NULL, NULL, 'CYTOMEGALOVIRUS UL139 PROTEIN', 250004),
(399446, 'PTHR37214:SF2', NULL, NULL, NULL, NULL, 'CYTOMEGALOVIRUS UL139 PROTEIN', 250004),
(399447, 'PTHR47433:SF1', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 17', 250005),
(399448, 'PTHR47433', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 17', 250005),
(399449, 'PTHR10663:SF318', NULL, NULL, NULL, NULL, 'IQ MOTIF AND SEC7 DOMAIN-CONTAINING PROTEIN 3', 250006),
(399450, 'PTHR10663:SF315', NULL, NULL, NULL, NULL, 'CYTOHESIN 4A-RELATED', 250006),
(399451, 'PTHR10663:SF354', NULL, NULL, NULL, NULL, 'ARF GUANINE-NUCLEOTIDE EXCHANGE FACTOR GNOM-LIKE', 250006),
(399452, 'PTHR10663:SF353', NULL, NULL, NULL, NULL, 'ARF GUANINE-NUCLEOTIDE EXCHANGE FACTOR GNL1', 250006),
(399453, 'PTHR10663:SF397', NULL, NULL, NULL, NULL, 'PROTEIN MON2', 250006),
(399454, 'PTHR10663:SF396', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC71', 250006),
(399455, 'PTHR10663:SF351', NULL, NULL, NULL, NULL, 'SEC7 DOMAIN-CONTAINING PROTEIN', 250006),
(399456, 'PTHR10663:SF395', NULL, NULL, NULL, NULL, 'SEC7 DOMAIN CONTAINING PROTEIN', 250006),
(399457, 'PTHR10663:SF314', NULL, NULL, NULL, NULL, 'IQ MOTIF AND SEC7 DOMAIN-CONTAINING PROTEIN 2', 250006),
(399458, 'PTHR10663:SF312', NULL, NULL, NULL, NULL, 'BREFELDIN A-INHIBITED GUANINE NUCLEOTIDE-EXCHANGE PROTEIN 5', 250006),
(399459, 'PTHR10663:SF356', NULL, NULL, NULL, NULL, 'BREFELDIN A-INHIBITED GUANINE NUCLEOTIDE-EXCHANGE PROTEIN 4', 250006);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(399460, 'PTHR10663:SF355', NULL, NULL, NULL, NULL, 'ARF GUANINE-NUCLEOTIDE EXCHANGE FACTOR GNOM-LIKE', 250006),
(399461, 'PTHR10663:SF390', NULL, NULL, NULL, NULL, 'DUF1981 DOMAIN-CONTAINING PROTEIN', 250006),
(399462, 'PTHR10663', NULL, NULL, NULL, NULL, 'GUANYL-NUCLEOTIDE EXCHANGE FACTOR', 250006),
(399463, 'PTHR10663:SF350', NULL, NULL, NULL, NULL, 'ARF GUANINE-NUCLEOTIDE EXCHANGE FACTOR GNOM-LIKE', 250006),
(399464, 'PTHR10663:SF394', NULL, NULL, NULL, NULL, 'BREFELDIN A-INHIBITED GUANINE NUCLEOTIDE-EXCHANGE PROTEIN 1', 250006),
(399465, 'PTHR10663:SF393', NULL, NULL, NULL, NULL, 'IQ MOTIF AND SEC7 DOMAIN ARFGEF 2A', 250006),
(399466, 'PTHR10663:SF392', NULL, NULL, NULL, NULL, 'GUANINE-NUCLEOTIDE EXCHANGE FACTOR YEL1', 250006),
(399467, 'PTHR10663:SF391', NULL, NULL, NULL, NULL, 'SEC7 DOMAIN-CONTAINING PROTEIN', 250006),
(399468, 'PTHR10663:SF329', NULL, NULL, NULL, NULL, 'PH AND SEC7 DOMAIN-CONTAINING PROTEIN 2', 250006),
(399469, 'PTHR10663:SF328', NULL, NULL, NULL, NULL, 'MIP16918P', 250006),
(399470, 'PTHR10663:SF327', NULL, NULL, NULL, NULL, 'IQ MOTIF AND SEC7 DOMAIN-CONTAINING PROTEIN 1', 250006),
(399471, 'PTHR10663:SF365', NULL, NULL, NULL, NULL, '', 250006),
(399472, 'PTHR10663:SF321', NULL, NULL, NULL, NULL, '', 250006),
(399473, 'PTHR10663:SF320', NULL, NULL, NULL, NULL, 'CYTOHESIN-3', 250006),
(399474, 'PTHR10663:SF362', NULL, NULL, NULL, NULL, 'SEC7 DOMAIN-CONTAINING PROTEIN-RELATED', 250006),
(399475, 'PTHR10663:SF369', NULL, NULL, NULL, NULL, 'SEC7 DOMAIN-CONTAINING PROTEIN-RELATED', 250006),
(399476, 'PTHR10663:SF324', NULL, NULL, NULL, NULL, 'ARF GUANINE-NUCLEOTIDE EXCHANGE FACTOR GNOM', 250006),
(399477, 'PTHR10663:SF323', NULL, NULL, NULL, NULL, 'CYTOHESIN-4', 250006),
(399478, 'PTHR10663:SF366', NULL, NULL, NULL, NULL, 'SEC7 DOMAIN-CONTAINING PROTEIN-RELATED', 250006),
(399479, 'PTHR10663:SF124', NULL, NULL, NULL, NULL, 'BREFELDIN A-INHIBITED GUANINE NUCLEOTIDE-EXCHANGE PROTEIN 2', 250006),
(399480, 'PTHR10663:SF322', NULL, NULL, NULL, NULL, 'ARF GUANINE-NUCLEOTIDE EXCHANGE FACTOR GNL2', 250006),
(399481, 'PTHR10663:SF360', NULL, NULL, NULL, NULL, 'SEC7 DOMAIN-CONTAINING PROTEIN-RELATED', 250006),
(399482, 'PTHR10663:SF338', NULL, NULL, NULL, NULL, 'PH AND SEC7 DOMAIN-CONTAINING PROTEIN 4', 250006),
(399483, 'PTHR10663:SF337', NULL, NULL, NULL, NULL, 'PH AND SEC7 DOMAIN-CONTAINING PROTEIN 3', 250006),
(399484, 'PTHR10663:SF376', NULL, NULL, NULL, NULL, 'PH AND SEC7 DOMAIN-CONTAINING PROTEIN', 250006),
(399485, 'PTHR10663:SF375', NULL, NULL, NULL, NULL, 'LD29171P', 250006),
(399486, 'PTHR10663:SF373', NULL, NULL, NULL, NULL, 'PH AND SEC7 DOMAIN-CONTAINING PROTEIN C11E3.11C', 250006),
(399487, 'PTHR10663:SF379', NULL, NULL, NULL, NULL, 'BREFELDIN A-INHIBITED GUANINE NUCLEOTIDE-EXCHANGE PROTEIN 2', 250006),
(399488, 'PTHR10663:SF137', NULL, NULL, NULL, NULL, 'BREFELDIN A-INHIBITED GUANINE NUCLEOTIDE-EXCHANGE PROTEIN 1', 250006),
(399489, 'PTHR10663:SF334', NULL, NULL, NULL, NULL, 'PH AND SEC7 DOMAIN-CONTAINING PROTEIN 1', 250006),
(399490, 'PTHR10663:SF333', NULL, NULL, NULL, NULL, 'PROTEIN MON2 HOMOLOG', 250006),
(399491, 'PTHR10663:SF372', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 8', 250006),
(399492, 'PTHR10663:SF108', NULL, NULL, NULL, NULL, 'BREFELDIN A-INHIBITED GUANINE NUCLEOTIDE-EXCHANGE PROTEIN 1', 250006),
(399493, 'PTHR10663:SF343', NULL, NULL, NULL, NULL, 'CYTOHESIN-2', 250006),
(399494, 'PTHR10663:SF387', NULL, NULL, NULL, NULL, 'GTP EXCHANGE FACTOR FOR ARFS 1', 250006),
(399495, 'PTHR10663:SF342', NULL, NULL, NULL, NULL, 'FI21420P1', 250006),
(399496, 'PTHR10663:SF386', NULL, NULL, NULL, NULL, 'SEC7 DOMAIN-CONTAINING PROTEIN', 250006),
(399497, 'PTHR10663:SF385', NULL, NULL, NULL, NULL, 'SEC7 DOMAIN-CONTAINING PROTEIN', 250006),
(399498, 'PTHR10663:SF340', NULL, NULL, NULL, NULL, 'CYTOHESIN-1', 250006),
(399499, 'PTHR10663:SF345', NULL, NULL, NULL, NULL, 'PATTERN FORMATION PROTEIN GNOM PROTEIN', 250006),
(399500, 'PTHR10663:SF389', NULL, NULL, NULL, NULL, 'CYTOHESIN 2', 250006),
(399501, 'PTHR10663:SF344', NULL, NULL, NULL, NULL, 'BREFELDIN A-INHIBITED GUANINE NUCLEOTIDE-EXCHANGE PROTEIN 3', 250006);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(399502, 'PTHR10663:SF388', NULL, NULL, NULL, NULL, 'GOLGI-SPECIFIC BREFELDIN A-RESISTANCE GUANINE NUCLEOTIDE EXCHANGE FACTOR 1', 250006),
(399503, 'PTHR10663:SF381', NULL, NULL, NULL, NULL, 'BREFELDIN A-INHIBITED GUANINE NUCLEOTIDE-EXCHANGE PROTEIN', 250006),
(399504, 'PTHR35357:SF13', NULL, NULL, NULL, NULL, 'OS02G0537100 PROTEIN', 250007),
(399505, 'PTHR35357:SF14', NULL, NULL, NULL, NULL, 'OS01G0253200 PROTEIN', 250007),
(399506, 'PTHR35357:SF11', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 250007),
(399507, 'PTHR35357:SF12', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 250007),
(399508, 'PTHR35357:SF17', NULL, NULL, NULL, NULL, 'PECTINESTERASE INHIBITOR 12', 250007),
(399509, 'PTHR35357:SF18', NULL, NULL, NULL, NULL, 'OS01G0111000 PROTEIN', 250007),
(399510, 'PTHR35357:SF15', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR SUPERFAMILY PROTEIN', 250007),
(399511, 'PTHR35357:SF16', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 250007),
(399512, 'PTHR35357:SF7', NULL, NULL, NULL, NULL, 'PECTINESTERASE INHIBITOR 12', 250007),
(399513, 'PTHR35357:SF4', NULL, NULL, NULL, NULL, 'PECTINESTERASE INHIBITOR DOMAIN CONTAINING PROTEIN', 250007),
(399514, 'PTHR35357:SF5', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 250007),
(399515, 'PTHR35357:SF2', NULL, NULL, NULL, NULL, 'PECTINESTERASE INHIBITOR 8', 250007),
(399516, 'PTHR35357:SF20', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 250007),
(399517, 'PTHR35357:SF21', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 250007),
(399518, 'PTHR35357:SF1', NULL, NULL, NULL, NULL, 'OS05G0149000 PROTEIN', 250007),
(399519, 'PTHR35357:SF8', NULL, NULL, NULL, NULL, 'OS02G0103300 PROTEIN', 250007),
(399520, 'PTHR35357:SF9', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 250007),
(399521, 'PTHR35357:SF19', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 250007),
(399522, 'PTHR35357', NULL, NULL, NULL, NULL, 'OS02G0537100 PROTEIN', 250007),
(399523, 'PTHR35000:SF6', NULL, NULL, NULL, NULL, '', 250008),
(399524, 'PTHR35000:SF7', NULL, NULL, NULL, NULL, 'MUCIN MUC17, PUTATIVE-RELATED', 250008),
(399525, 'PTHR35000', NULL, NULL, NULL, NULL, 'MUCIN MUC17, PUTATIVE-RELATED-RELATED', 250008),
(399526, 'PTHR35000:SF1', NULL, NULL, NULL, NULL, '', 250008),
(399527, 'PTHR31779:SF3', NULL, NULL, NULL, NULL, 'PROTEIN RDR1', 250009),
(399528, 'PTHR31779', NULL, NULL, NULL, NULL, '2-NITROPROPANE DIOXYGENASE FAMILY, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G17430)-RELATED', 250009),
(399529, 'PTHR31779:SF4', NULL, NULL, NULL, NULL, '2-NITROPROPANE DIOXYGENASE FAMILY, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G17430)-RELATED', 250009),
(399530, 'PTHR31779:SF5', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 250009),
(399531, 'PTHR31779:SF6', NULL, NULL, NULL, NULL, '', 250009),
(399532, 'PTHR13295', NULL, NULL, NULL, NULL, 'GLUTAMATE CYSTEINE LIGASE REGULATORY SUBUNIT', 250010),
(399533, 'PTHR13295:SF4', NULL, NULL, NULL, NULL, 'GLUTAMATE--CYSTEINE LIGASE REGULATORY SUBUNIT', 250010),
(399534, 'PTHR24202:SF4', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MIB2-RELATED', 250011),
(399535, 'PTHR24202:SF53', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MIB1', 250011),
(399536, 'PTHR24202', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MIB2', 250011),
(399537, 'PTHR24202:SF54', NULL, NULL, NULL, NULL, '', 250011),
(399538, 'PTHR23421:SF182', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012),
(399539, 'PTHR23421:SF13', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE 2-RELATED', 250012),
(399540, 'PTHR23421:SF57', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_35 DOMAIN-CONTAINING PROTEIN', 250012),
(399541, 'PTHR23421:SF180', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012),
(399542, 'PTHR23421:SF56', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012),
(399543, 'PTHR23421:SF181', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012),
(399544, 'PTHR23421:SF59', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE-1-LIKE PROTEIN 3', 250012);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(399545, 'PTHR23421:SF140', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012),
(399546, 'PTHR23421:SF146', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE 4', 250012),
(399547, 'PTHR23421', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE RELATED', 250012),
(399548, 'PTHR23421:SF147', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012),
(399549, 'PTHR23421:SF145', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012),
(399550, 'PTHR23421:SF189', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012),
(399551, 'PTHR23421:SF51', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE 5', 250012),
(399552, 'PTHR23421:SF50', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE-1-LIKE PROTEIN', 250012),
(399553, 'PTHR23421:SF148', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012),
(399554, 'PTHR23421:SF53', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE-1-LIKE PROTEIN 2', 250012),
(399555, 'PTHR23421:SF52', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE 14', 250012),
(399556, 'PTHR23421:SF190', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE 7', 250012),
(399557, 'PTHR23421:SF88', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012),
(399558, 'PTHR23421:SF193', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012),
(399559, 'PTHR23421:SF194', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE 2', 250012),
(399560, 'PTHR23421:SF191', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012),
(399561, 'PTHR23421:SF192', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012),
(399562, 'PTHR23421:SF197', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_5G00670)-RELATED', 250012),
(399563, 'PTHR23421:SF153', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE 2', 250012),
(399564, 'PTHR23421:SF198', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012),
(399565, 'PTHR23421:SF195', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012),
(399566, 'PTHR23421:SF196', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE 6', 250012),
(399567, 'PTHR23421:SF158', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012),
(399568, 'PTHR23421:SF199', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012),
(399569, 'PTHR23421:SF160', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012),
(399570, 'PTHR23421:SF161', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012),
(399571, 'PTHR23421:SF76', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE 12', 250012),
(399572, 'PTHR23421:SF79', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE 3', 250012),
(399573, 'PTHR23421:SF120', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE 9', 250012),
(399574, 'PTHR23421:SF165', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012),
(399575, 'PTHR23421:SF163', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012),
(399576, 'PTHR23421:SF168', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012),
(399577, 'PTHR23421:SF124', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE 8', 250012),
(399578, 'PTHR23421:SF125', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE C-RELATED', 250012),
(399579, 'PTHR23421:SF166', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012),
(399580, 'PTHR23421:SF71', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012),
(399581, 'PTHR23421:SF122', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE A-RELATED', 250012),
(399582, 'PTHR23421:SF123', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012),
(399583, 'PTHR23421:SF74', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE 1', 250012),
(399584, 'PTHR23421:SF127', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012),
(399585, 'PTHR23421:SF171', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012),
(399586, 'PTHR23421:SF65', NULL, NULL, NULL, NULL, 'ACID BETA-GALACTOSIDASE', 250012),
(399587, 'PTHR23421:SF172', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012),
(399588, 'PTHR23421:SF170', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012),
(399589, 'PTHR23421:SF67', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE 10', 250012),
(399590, 'PTHR23421:SF175', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012),
(399591, 'PTHR23421:SF176', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE 13', 250012),
(399592, 'PTHR23421:SF173', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012);
INSERT INTO "PUBLIC"."MODEL" VALUES
(399593, 'PTHR23421:SF174', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE 7', 250012),
(399594, 'PTHR23421:SF130', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE 11', 250012),
(399595, 'PTHR23421:SF179', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE 16', 250012),
(399596, 'PTHR23421:SF64', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE B-RELATED', 250012),
(399597, 'PTHR23421:SF137', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE-RELATED', 250012),
(399598, 'PTHR23421:SF63', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE 12', 250012),
(399599, 'PTHR23421:SF138', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 250012),
(399600, 'PTHR15698:SF10', NULL, NULL, NULL, NULL, '', 250013),
(399601, 'PTHR15698:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG15099', 250013),
(399602, 'PTHR15698', NULL, NULL, NULL, NULL, 'PROTEIN CBG15099', 250013),
(399603, 'PTHR15698:SF9', NULL, NULL, NULL, NULL, 'PHYTANOYL-COA HYDROXYLASE-INTERACTING PROTEIN', 250013),
(399604, 'PTHR15698:SF8', NULL, NULL, NULL, NULL, 'PHYTANOYL-COA HYDROXYLASE-INTERACTING PROTEIN-LIKE', 250013),
(399605, 'PTHR34850:SF2', NULL, NULL, NULL, NULL, 'FORK-HEAD DOMAIN-CONTAINING PROTEIN', 250014),
(399606, 'PTHR34850', NULL, NULL, NULL, NULL, 'PROTEIN CBG21297', 250014),
(399607, 'PTHR47078:SF1', NULL, NULL, NULL, NULL, 'CYTOSKELETON-ASSOCIATED PROTEIN 2-LIKE', 250015),
(399608, 'PTHR47078', NULL, NULL, NULL, NULL, 'CYTOSKELETON-ASSOCIATED PROTEIN 2-LIKE', 250015),
(399609, 'PTHR31585:SF7', NULL, NULL, NULL, NULL, 'FOLATE-BIOPTERIN TRANSPORTER 4-RELATED', 250016),
(399610, 'PTHR31585:SF51', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE-RELATED', 250016),
(399611, 'PTHR31585:SF44', NULL, NULL, NULL, NULL, 'FOLATE-BIOPTERIN TRANSPORTER 6-RELATED', 250016),
(399612, 'PTHR31585:SF11', NULL, NULL, NULL, NULL, 'FOLATE-BIOPTERIN TRANSPORTER 3-RELATED', 250016),
(399613, 'PTHR31585:SF53', NULL, NULL, NULL, NULL, '', 250016),
(399614, 'PTHR31585:SF52', NULL, NULL, NULL, NULL, '', 250016),
(399615, 'PTHR31585:SF48', NULL, NULL, NULL, NULL, '', 250016),
(399616, 'PTHR31585:SF47', NULL, NULL, NULL, NULL, 'FOLATE-BIOPTERIN TRANSPORTER 8, CHLOROPLASTIC-RELATED', 250016),
(399617, 'PTHR31585:SF13', NULL, NULL, NULL, NULL, 'OSJNBA0029H02.8 PROTEIN', 250016),
(399618, 'PTHR31585:SF46', NULL, NULL, NULL, NULL, 'FOLATE-BIOPTERIN TRANSPORTER 3-RELATED', 250016),
(399619, 'PTHR31585:SF12', NULL, NULL, NULL, NULL, 'FOLATE-BIOPTERIN TRANSPORTER 9, CHLOROPLASTIC-RELATED', 250016),
(399620, 'PTHR31585:SF23', NULL, NULL, NULL, NULL, 'FOLATE-BIOPTERIN TRANSPORTER 1 CHLOROPLASTIC', 250016),
(399621, 'PTHR31585:SF45', NULL, NULL, NULL, NULL, 'FOLATE-BIOPTERIN TRANSPORTER 1, CHLOROPLASTIC-LIKE ISOFORM X1', 250016),
(399622, 'PTHR31585:SF49', NULL, NULL, NULL, NULL, 'FOLATE-BIOPTERIN TRANSPORTER 2-RELATED', 250016),
(399623, 'PTHR31585:SF0', NULL, NULL, NULL, NULL, 'FOLATE-BIOPTERIN TRANSPORTER 1, CHLOROPLASTIC', 250016),
(399624, 'PTHR31585:SF2', NULL, NULL, NULL, NULL, 'FOLATE-BIOPTERIN TRANSPORTER 7-RELATED', 250016),
(399625, 'PTHR31585:SF5', NULL, NULL, NULL, NULL, 'S4 RNA-BINDING DOMAIN-CONTAINING PROTEIN', 250016),
(399626, 'PTHR31585', NULL, NULL, NULL, NULL, 'FOLATE-BIOPTERIN TRANSPORTER 1, CHLOROPLASTIC', 250016),
(399627, 'PTHR31585:SF6', NULL, NULL, NULL, NULL, 'FOLATE-BIOPTERIN TRANSPORTER 2-RELATED', 250016),
(399628, 'PTHR11304:SF69', NULL, NULL, NULL, NULL, 'EPHRIN-A2', 250017),
(399629, 'PTHR11304:SF34', NULL, NULL, NULL, NULL, 'EPHRIN-B3', 250017),
(399630, 'PTHR11304:SF44', NULL, NULL, NULL, NULL, 'EPHRIN-4', 250017),
(399631, 'PTHR11304:SF33', NULL, NULL, NULL, NULL, 'EPHRIN-A5', 250017),
(399632, 'PTHR11304:SF43', NULL, NULL, NULL, NULL, 'EPHRIN RBD DOMAIN-CONTAINING PROTEIN', 250017),
(399633, 'PTHR11304:SF42', NULL, NULL, NULL, NULL, 'EPHRIN-A4', 250017),
(399634, 'PTHR11304:SF74', NULL, NULL, NULL, NULL, 'EPHRIN-A1A', 250017),
(399635, 'PTHR11304:SF41', NULL, NULL, NULL, NULL, 'EPHRIN RBD DOMAIN-CONTAINING PROTEIN', 250017),
(399636, 'PTHR11304:SF73', NULL, NULL, NULL, NULL, 'EPHRIN-A3A', 250017),
(399637, 'PTHR11304:SF19', NULL, NULL, NULL, NULL, 'EPHRIN-A1', 250017);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(399638, 'PTHR11304:SF29', NULL, NULL, NULL, NULL, 'EPHRIN', 250017),
(399639, 'PTHR11304:SF18', NULL, NULL, NULL, NULL, 'EPHRIN-B2', 250017),
(399640, 'PTHR11304:SF17', NULL, NULL, NULL, NULL, 'EPHRIN-B1', 250017),
(399641, 'PTHR11304', NULL, NULL, NULL, NULL, 'EPHRIN', 250017),
(399642, 'PTHR11304:SF4', NULL, NULL, NULL, NULL, 'EPHRIN-A2', 250017),
(399643, 'PTHR11304:SF5', NULL, NULL, NULL, NULL, 'EPHRIN-A3', 250017),
(399644, 'PTHR11304:SF72', NULL, NULL, NULL, NULL, 'EPHRIN RBD DOMAIN-CONTAINING PROTEIN', 250017),
(399645, 'PTHR23203:SF4', NULL, NULL, NULL, NULL, 'BASIC SALIVARY PROLINE-RICH PROTEIN 3', 250018),
(399646, 'PTHR23203:SF16', NULL, NULL, NULL, NULL, 'BASIC SALIVARY PROLINE-RICH PROTEIN 1-RELATED', 250018),
(399647, 'PTHR23203:SF17', NULL, NULL, NULL, NULL, 'RIKEN CDNA 5530400C23 GENE', 250018),
(399648, 'PTHR23203:SF18', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN BSTNI SUBFAMILY 1-RELATED', 250018),
(399649, 'PTHR23203:SF9', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 4', 250018),
(399650, 'PTHR23203:SF19', NULL, NULL, NULL, NULL, 'SALIVARY ACIDIC PROLINE-RICH PHOSPHOPROTEIN 1/2', 250018),
(399651, 'PTHR23203', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN', 250018),
(399652, 'PTHR23203:SF15', NULL, NULL, NULL, NULL, 'BASIC SALIVARY PROLINE-RICH PROTEIN 4', 250018),
(399653, 'PTHR38640', NULL, NULL, NULL, NULL, 'GEO09659P1', 250019),
(399654, 'PTHR38640:SF1', NULL, NULL, NULL, NULL, 'GEO09659P1', 250019),
(399655, 'PTHR47678:SF4', NULL, NULL, NULL, NULL, 'SHOCK PROTEIN 70 (HSP70)-INTERACTING PROTEIN, PUTATIVE-RELATED', 250020),
(399656, 'PTHR47678', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 31', 250020),
(399657, 'PTHR47678:SF2', NULL, NULL, NULL, NULL, 'ZGC:123010', 250020),
(399658, 'PTHR47678:SF1', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 31', 250020),
(399659, 'PTHR38480:SF1', NULL, NULL, NULL, NULL, 'SLR0254 PROTEIN', 250021),
(399660, 'PTHR38480', NULL, NULL, NULL, NULL, 'SLR0254 PROTEIN', 250021),
(399661, 'PTHR45715:SF6', NULL, NULL, NULL, NULL, '', 250022),
(399662, 'PTHR45715:SF7', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT E 2', 250022),
(399663, 'PTHR45715:SF8', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT E-LIKE', 250022),
(399664, 'PTHR45715:SF1', NULL, NULL, NULL, NULL, 'OS01G0222500 PROTEIN', 250022),
(399665, 'PTHR45715', NULL, NULL, NULL, NULL, 'ATPASE H+-TRANSPORTING V1 SUBUNIT E1A-RELATED', 250022),
(399666, 'PTHR45715:SF2', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT E 1', 250022),
(399667, 'PTHR45715:SF3', NULL, NULL, NULL, NULL, 'ATPASE H+-TRANSPORTING V1 SUBUNIT E1A-RELATED', 250022),
(399668, 'PTHR45715:SF15', NULL, NULL, NULL, NULL, 'SINIGRINASE', 250022),
(399669, 'PTHR45715:SF14', NULL, NULL, NULL, NULL, 'BNACNNG57990D PROTEIN', 250022),
(399670, 'PTHR45715:SF16', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT E2', 250022),
(399671, 'PTHR45715:SF11', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT E-LIKE', 250022),
(399672, 'PTHR45715:SF10', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT E1', 250022),
(399673, 'PTHR45715:SF13', NULL, NULL, NULL, NULL, '', 250022),
(399674, 'PTHR45715:SF19', NULL, NULL, NULL, NULL, 'OS05G0480700 PROTEIN', 250022),
(399675, 'PTHR45715:SF18', NULL, NULL, NULL, NULL, 'ARCHAEAL/VACUOLAR-TYPE H+-ATPASE SUBUNIT E', 250022),
(399676, 'PTHR10405', NULL, NULL, NULL, NULL, 'SPINDLIN', 250023),
(399677, 'PTHR10405:SF29', NULL, NULL, NULL, NULL, 'ZMP:0000000521', 250023),
(399678, 'PTHR10405:SF9', NULL, NULL, NULL, NULL, 'SPINDLIN-4', 250023),
(399679, 'PTHR10405:SF33', NULL, NULL, NULL, NULL, 'SPINDLIN-3', 250023),
(399680, 'PTHR10405:SF32', NULL, NULL, NULL, NULL, 'SPINDLIN-2C', 250023),
(399681, 'PTHR10405:SF13', NULL, NULL, NULL, NULL, 'SPINDLIN-2A-RELATED', 250023),
(399682, 'PTHR10405:SF15', NULL, NULL, NULL, NULL, 'SPINDLIN-1', 250023),
(399683, 'PTHR10405:SF16', NULL, NULL, NULL, NULL, '(CLONE BALB10N)-RELATED', 250023),
(399684, 'PTHR34733:SF1', NULL, NULL, NULL, NULL, '', 250024),
(399685, 'PTHR34733', NULL, NULL, NULL, NULL, '', 250024);
INSERT INTO "PUBLIC"."MODEL" VALUES
(399686, 'PTHR10127:SF815', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE NAS-9', 250025),
(399687, 'PTHR10127:SF859', NULL, NULL, NULL, NULL, 'METALLOENDOPEPTIDASE', 250025),
(399688, 'PTHR10127:SF818', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE NAS-4', 250025),
(399689, 'PTHR10127:SF819', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE NAS-26', 250025),
(399690, 'PTHR10127:SF775', NULL, NULL, NULL, NULL, 'METALLOENDOPEPTIDASE', 250025),
(399691, 'PTHR10127:SF852', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE NAS-12', 250025),
(399692, 'PTHR10127:SF810', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE NAS-38', 250025),
(399693, 'PTHR10127:SF853', NULL, NULL, NULL, NULL, 'METALLOENDOPEPTIDASE', 250025),
(399694, 'PTHR10127:SF779', NULL, NULL, NULL, NULL, 'METALLOENDOPEPTIDASE', 250025),
(399695, 'PTHR10127:SF856', NULL, NULL, NULL, NULL, 'METALLOENDOPEPTIDASE', 250025),
(399696, 'PTHR10127:SF855', NULL, NULL, NULL, NULL, 'ASTACIN-LIKE METALLOENDOPEPTIDASE', 250025),
(399697, 'PTHR10127:SF814', NULL, NULL, NULL, NULL, 'MEPRIN A SUBUNIT BETA', 250025),
(399698, 'PTHR10127:SF813', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE DPY-31', 250025),
(399699, 'PTHR10127:SF857', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE NAS-19-RELATED', 250025),
(399700, 'PTHR10127:SF850', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE NAS-29', 250025),
(399701, 'PTHR10127:SF827', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE NAS-7', 250025),
(399702, 'PTHR10127:SF826', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE NAS-25', 250025),
(399703, 'PTHR10127:SF829', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE NAS-6', 250025),
(399704, 'PTHR10127:SF828', NULL, NULL, NULL, NULL, 'METALLOENDOPEPTIDASE', 250025),
(399705, 'PTHR10127:SF786', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE NAS-20', 250025),
(399706, 'PTHR10127:SF863', NULL, NULL, NULL, NULL, 'BONE MORPHOGENETIC PROTEIN 1', 250025),
(399707, 'PTHR10127:SF862', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE NAS-27', 250025),
(399708, 'PTHR10127:SF785', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE NAS-8', 250025),
(399709, 'PTHR10127:SF788', NULL, NULL, NULL, NULL, 'METALLOENDOPEPTIDASE', 250025),
(399710, 'PTHR10127:SF820', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE NAS-31', 250025),
(399711, 'PTHR10127:SF823', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE NAS-33', 250025),
(399712, 'PTHR10127:SF866', NULL, NULL, NULL, NULL, 'TOLLOID-LIKE PROTEIN 2', 250025),
(399713, 'PTHR10127:SF825', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE NAS-23', 250025),
(399714, 'PTHR10127:SF824', NULL, NULL, NULL, NULL, 'MEPRIN A SUBUNIT ALPHA', 250025),
(399715, 'PTHR10127:SF780', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE NAS-13', 250025),
(399716, 'PTHR10127:SF861', NULL, NULL, NULL, NULL, 'DORSAL-VENTRAL PATTERNING PROTEIN TOLLOID-RELATED', 250025),
(399717, 'PTHR10127:SF860', NULL, NULL, NULL, NULL, 'TOLLOID-LIKE PROTEIN 1', 250025),
(399718, 'PTHR10127:SF838', NULL, NULL, NULL, NULL, 'METALLOENDOPEPTIDASE', 250025),
(399719, 'PTHR10127:SF839', NULL, NULL, NULL, NULL, 'HATCHING ENZYME 1.2', 250025),
(399720, 'PTHR10127:SF830', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE NAS-11', 250025),
(399721, 'PTHR10127:SF874', NULL, NULL, NULL, NULL, 'METALLOENDOPEPTIDASE', 250025),
(399722, 'PTHR10127:SF873', NULL, NULL, NULL, NULL, 'METALLOENDOPEPTIDASE', 250025),
(399723, 'PTHR10127:SF876', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE NAS-37', 250025),
(399724, 'PTHR10127:SF831', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE NAS-16-RELATED', 250025),
(399725, 'PTHR10127:SF875', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE NAS-28', 250025),
(399726, 'PTHR10127:SF798', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE NAS-1', 250025),
(399727, 'PTHR10127:SF878', NULL, NULL, NULL, NULL, 'METALLOENDOPEPTIDASE', 250025),
(399728, 'PTHR10127:SF877', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE NAS-34', 250025),
(399729, 'PTHR10127:SF833', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE NAS-32', 250025),
(399730, 'PTHR10127:SF879', NULL, NULL, NULL, NULL, 'METALLOENDOPEPTIDASE-RELATED', 250025);
INSERT INTO "PUBLIC"."MODEL" VALUES
(399731, 'PTHR10127:SF791', NULL, NULL, NULL, NULL, 'METALLOENDOPEPTIDASE', 250025),
(399732, 'PTHR10127:SF793', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE NAS-15', 250025),
(399733, 'PTHR10127:SF870', NULL, NULL, NULL, NULL, 'METALLOENDOPEPTIDASE', 250025),
(399734, 'PTHR10127', NULL, NULL, NULL, NULL, 'DISCOIDIN, CUB, EGF, LAMININ , AND ZINC METALLOPROTEASE DOMAIN CONTAINING', 250025),
(399735, 'PTHR10127:SF872', NULL, NULL, NULL, NULL, 'ASTACIN-LIKE METALLOENDOPEPTIDASE-RELATED', 250025),
(399736, 'PTHR10127:SF795', NULL, NULL, NULL, NULL, 'METALLOENDOPEPTIDASE-RELATED', 250025),
(399737, 'PTHR10127:SF794', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE NAS-22-RELATED', 250025),
(399738, 'PTHR10127:SF871', NULL, NULL, NULL, NULL, 'METALLOENDOPEPTIDASE', 250025),
(399739, 'PTHR10127:SF849', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE NAS-36', 250025),
(399740, 'PTHR10127:SF802', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE NAS-10', 250025),
(399741, 'PTHR10127:SF881', NULL, NULL, NULL, NULL, 'METALLOENDOPEPTIDASE', 250025),
(399742, 'PTHR10127:SF880', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE NAS-5', 250025),
(399743, 'PTHR10127:SF883', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE NAS-14', 250025),
(399744, 'PTHR10127:SF882', NULL, NULL, NULL, NULL, 'METALLOENDOPEPTIDASE', 250025),
(399745, 'PTHR43715:SF1', NULL, NULL, NULL, NULL, 'GDP-MANNOSE 4,6 DEHYDRATASE', 250026),
(399746, 'PTHR43715:SF4', NULL, NULL, NULL, NULL, 'GDP-MANNOSE 4,6 DEHYDRATASE 1', 250026),
(399747, 'PTHR43715:SF3', NULL, NULL, NULL, NULL, 'GDP-MANNOSE 4,6-DEHYDRATASE', 250026),
(399748, 'PTHR43715:SF6', NULL, NULL, NULL, NULL, 'GDP-MANNOSE 4,6-DEHYDRATASE', 250026),
(399749, 'PTHR43715', NULL, NULL, NULL, NULL, 'GDP-MANNOSE 4,6-DEHYDRATASE', 250026),
(399750, 'PTHR43715:SF7', NULL, NULL, NULL, NULL, 'GDP-MANNOSE 4,6-DEHYDRATASE', 250026),
(399751, 'PTHR22714', NULL, NULL, NULL, NULL, 'PROTEIN CBG02446-RELATED', 250027),
(399752, 'PTHR22714:SF2', NULL, NULL, NULL, NULL, 'LIG_CHAN-GLU_BD DOMAIN-CONTAINING PROTEIN', 250027),
(399753, 'PTHR22714:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG09521', 250027),
(399754, 'PTHR22714:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG02457', 250027),
(399755, 'PTHR22714:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG02446', 250027),
(399756, 'PTHR22714:SF7', NULL, NULL, NULL, NULL, 'PBPB DOMAIN-CONTAINING PROTEIN', 250027),
(399757, 'PTHR38567:SF1', NULL, NULL, NULL, NULL, '', 250028),
(399758, 'PTHR38567', NULL, NULL, NULL, NULL, '', 250028),
(399759, 'PTHR15217:SF3', NULL, NULL, NULL, NULL, 'FEMALE-LETHAL(2)D HOMOLOG', 250029),
(399760, 'PTHR15217', NULL, NULL, NULL, NULL, 'WILMS'' TUMOR 1-ASSOCIATING PROTEIN', 250029),
(399761, 'PTHR15217:SF4', NULL, NULL, NULL, NULL, 'BNAC06G42510D PROTEIN', 250029),
(399762, 'PTHR15217:SF5', NULL, NULL, NULL, NULL, 'PROTEIN OF 37 KDA-LIKE PROTEIN, PUTATIVE-RELATED', 250029),
(399763, 'PTHR15217:SF0', NULL, NULL, NULL, NULL, 'FEMALE-LETHAL(2)D HOMOLOG', 250029),
(399764, 'PTHR15217:SF1', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING REGULATOR WTAP', 250029),
(399765, 'PTHR34557:SF6', NULL, NULL, NULL, NULL, '', 250030),
(399766, 'PTHR34557', NULL, NULL, NULL, NULL, 'PHYTOCHROMOBILIN:FERREDOXIN OXIDOREDUCTASE, CHLOROPLASTIC', 250030),
(399767, 'PTHR34557:SF1', NULL, NULL, NULL, NULL, 'PHYTOCHROMOBILIN:FERREDOXIN OXIDOREDUCTASE, CHLOROPLASTIC', 250030),
(399768, 'PTHR34557:SF4', NULL, NULL, NULL, NULL, 'BNAA05G29200D PROTEIN', 250030),
(399769, 'PTHR33865', NULL, NULL, NULL, NULL, 'PROTEIN FAM183B', 250031),
(399770, 'PTHR33865:SF3', NULL, NULL, NULL, NULL, 'PROTEIN FAM183B', 250031),
(399771, 'PTHR33865:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM183A', 250031),
(399772, 'PTHR33865:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAM183BP', 250031),
(399773, 'PTHR34193:SF18', NULL, NULL, NULL, NULL, 'OS11G0199801 PROTEIN', 250032),
(399774, 'PTHR34193:SF1', NULL, NULL, NULL, NULL, 'OS05G0493200 PROTEIN', 250032),
(399775, 'PTHR34193:SF8', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250032),
(399776, 'PTHR34193', NULL, NULL, NULL, NULL, 'OS11G0199801 PROTEIN', 250032);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(399777, 'PTHR34193:SF10', NULL, NULL, NULL, NULL, '', 250032),
(399778, 'PTHR34193:SF13', NULL, NULL, NULL, NULL, '', 250032),
(399779, 'PTHR34193:SF17', NULL, NULL, NULL, NULL, '', 250032),
(399780, 'PTHR34193:SF16', NULL, NULL, NULL, NULL, 'BNAA06G15130D PROTEIN', 250032),
(399781, 'PTHR41534:SF1', NULL, NULL, NULL, NULL, 'BLR3401 PROTEIN', 250033),
(399782, 'PTHR41534', NULL, NULL, NULL, NULL, 'BLR3401 PROTEIN', 250033),
(399783, 'PTHR41534:SF2', NULL, NULL, NULL, NULL, '3-PHENYLPROPIONATE/CINNAMIC ACID DIOXYGENASE SUBUNIT BETA', 250033),
(399784, 'PTHR31784:SF2', NULL, NULL, NULL, NULL, 'BIOGENESIS OF LYSOSOME-RELATED ORGANELLES COMPLEX 1 SUBUNIT 5', 250034),
(399785, 'PTHR31784', NULL, NULL, NULL, NULL, 'BIOGENESIS OF LYSOSOME-RELATED ORGANELLES COMPLEX 1 SUBUNIT 5', 250034),
(399786, 'PTHR48246:SF1', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 250035),
(399787, 'PTHR48246', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 250035),
(399788, 'PTHR47737', NULL, NULL, NULL, NULL, 'GLYCINE BETAINE/PROLINE BETAINE TRANSPORT SYSTEM PERMEASE PROTEIN PROW', 250036),
(399789, 'PTHR47737:SF1', NULL, NULL, NULL, NULL, 'GLYCINE BETAINE/PROLINE BETAINE TRANSPORT SYSTEM PERMEASE PROTEIN PROW', 250036),
(399790, 'PTHR30302:SF4', NULL, NULL, NULL, NULL, 'HYDROGENASE 3 MATURATION PROTEASE', 250037),
(399791, 'PTHR30302', NULL, NULL, NULL, NULL, 'HYDROGENASE 1 MATURATION PROTEASE', 250037),
(399792, 'PTHR30302:SF5', NULL, NULL, NULL, NULL, 'SLR1876 PROTEIN', 250037),
(399793, 'PTHR30302:SF7', NULL, NULL, NULL, NULL, 'F420-NONREDUCING HYDROGENASE II', 250037),
(399794, 'PTHR30302:SF9', NULL, NULL, NULL, NULL, 'HYDROGENASE 1 MATURATION PROTEASE', 250037),
(399795, 'PTHR30302:SF1', NULL, NULL, NULL, NULL, 'HYDROGENASE 2 MATURATION PROTEASE', 250037),
(399796, 'PTHR10035:SF3', NULL, NULL, NULL, NULL, 'T-CELL RECEPTOR T3 ZETA CHAIN', 250038),
(399797, 'PTHR10035:SF2', NULL, NULL, NULL, NULL, 'T-CELL SURFACE GLYCOPROTEIN CD3 ZETA CHAIN', 250038),
(399798, 'PTHR10035', NULL, NULL, NULL, NULL, 'T-CELL SURFACE GLYCOPROTEIN CD3 ZETA CHAIN', 250038),
(399799, 'PTHR24150', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND MYND DOMAIN-CONTAINING PROTEIN 2', 250039),
(399800, 'PTHR24150:SF8', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND MYND DOMAIN-CONTAINING PROTEIN 2', 250039),
(399801, 'PTHR24150:SF13', NULL, NULL, NULL, NULL, 'CAP-GLY DOMAIN-CONTAINING PROTEIN', 250039),
(399802, 'PTHR43478', NULL, NULL, NULL, NULL, 'NA+/H+ ANTIPORTER-RELATED', 250040),
(399803, 'PTHR43478:SF3', NULL, NULL, NULL, NULL, 'LYSINE TRANSPORTER LYSW', 250040),
(399804, 'PTHR43478:SF1', NULL, NULL, NULL, NULL, 'NA_H_ANTIPORTER DOMAIN-CONTAINING PROTEIN', 250040),
(399805, 'PTHR17630:SF104', NULL, NULL, NULL, NULL, 'DLH DOMAIN-CONTAINING PROTEIN', 250041),
(399806, 'PTHR17630', NULL, NULL, NULL, NULL, 'DIENELACTONE HYDROLASE', 250041),
(399807, 'PTHR17630:SF103', NULL, NULL, NULL, NULL, 'DLH DOMAIN-CONTAINING PROTEIN', 250041),
(399808, 'PTHR17630:SF102', NULL, NULL, NULL, NULL, 'DLH DOMAIN-CONTAINING PROTEIN', 250041),
(399809, 'PTHR17630:SF92', NULL, NULL, NULL, NULL, 'ENDO-1,31,4-BETA-D-GLUCANASE-LIKE ISOFORM X1', 250041),
(399810, 'PTHR17630:SF81', NULL, NULL, NULL, NULL, 'DLH DOMAIN-CONTAINING PROTEIN', 250041),
(399811, 'PTHR17630:SF101', NULL, NULL, NULL, NULL, 'PROTEIN AIM2', 250041),
(399812, 'PTHR17630:SF80', NULL, NULL, NULL, NULL, 'DLH DOMAIN-CONTAINING PROTEIN', 250041),
(399813, 'PTHR17630:SF91', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 250041),
(399814, 'PTHR17630:SF100', NULL, NULL, NULL, NULL, 'OS05G0399100 PROTEIN', 250041),
(399815, 'PTHR17630:SF87', NULL, NULL, NULL, NULL, 'DLH DOMAIN-CONTAINING PROTEIN', 250041),
(399816, 'PTHR17630:SF97', NULL, NULL, NULL, NULL, 'DLH DOMAIN-CONTAINING PROTEIN', 250041),
(399817, 'PTHR17630:SF56', NULL, NULL, NULL, NULL, 'ENDO-1,3_1,4-BETA-D-GLUCANASE', 250041),
(399818, 'PTHR17630:SF89', NULL, NULL, NULL, NULL, 'OS05G0400200 PROTEIN', 250041),
(399819, 'PTHR17630:SF99', NULL, NULL, NULL, NULL, 'DLH DOMAIN-CONTAINING PROTEIN', 250041),
(399820, 'PTHR17630:SF44', NULL, NULL, NULL, NULL, 'DIENELACTONE HYDROLASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_4G08790)', 250041);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(399821, 'PTHR17630:SF55', NULL, NULL, NULL, NULL, 'DIENELACTONE HYDROLASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_1G01900)', 250041),
(399822, 'PTHR17630:SF82', NULL, NULL, NULL, NULL, 'ENDO-1,3-1,4-BETA-D-GLUCANASE-LIKE PROTEIN', 250041),
(399823, 'PTHR17630:SF93', NULL, NULL, NULL, NULL, 'ALPHA/BETA HYDROLASE FOLD PROTEIN-RELATED', 250041),
(399824, 'PTHR17630:SF52', NULL, NULL, NULL, NULL, 'ENDO-1,3-1,4-BETA-D-GLUCANASE-LIKE PROTEIN', 250041),
(399825, 'PTHR17630:SF85', NULL, NULL, NULL, NULL, 'DLH DOMAIN-CONTAINING PROTEIN', 250041),
(399826, 'PTHR17630:SF96', NULL, NULL, NULL, NULL, 'ENDO-1,3-1,4-BETA-D-GLUCANASE-LIKE PROTEIN', 250041),
(399827, 'PTHR17630:SF95', NULL, NULL, NULL, NULL, 'DLH DOMAIN-CONTAINING PROTEIN', 250041),
(399828, 'PTHR34105:SF4', NULL, NULL, NULL, NULL, 'RIX1 DOMAIN-CONTAINING PROTEIN', 250042),
(399829, 'PTHR34105', NULL, NULL, NULL, NULL, 'PROLINE-, GLUTAMIC ACID- AND LEUCINE-RICH PROTEIN 1', 250042),
(399830, 'PTHR34105:SF1', NULL, NULL, NULL, NULL, 'PROLINE-, GLUTAMIC ACID- AND LEUCINE-RICH PROTEIN 1', 250042),
(399831, 'PTHR35149:SF2', NULL, NULL, NULL, NULL, 'SLL5132 PROTEIN', 250043),
(399832, 'PTHR35149:SF1', NULL, NULL, NULL, NULL, 'DUF5655 DOMAIN-CONTAINING PROTEIN', 250043),
(399833, 'PTHR35149', NULL, NULL, NULL, NULL, 'SLL5132 PROTEIN', 250043),
(399834, 'PTHR24381:SF22', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 337', 250044),
(399835, 'PTHR24381:SF27', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 180', 250044),
(399836, 'PTHR24381:SF25', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 169', 250044),
(399837, 'PTHR24381:SF333', NULL, NULL, NULL, NULL, 'RIKEN CDNA 2810021J22 GENE', 250044),
(399838, 'PTHR24381:SF5', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 749', 250044),
(399839, 'PTHR24381:SF299', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 764', 250044),
(399840, 'PTHR24381:SF340', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 331', 250044),
(399841, 'PTHR24381:SF20', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 599', 250044),
(399842, 'PTHR24381:SF19', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 705G-RELATED', 250044),
(399843, 'PTHR24381:SF344', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 79', 250044),
(399844, 'PTHR24381:SF345', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 846', 250044),
(399845, 'PTHR24381:SF343', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 589', 250044),
(399846, 'PTHR24381:SF110', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 614', 250044),
(399847, 'PTHR24381:SF0', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 684', 250044),
(399848, 'PTHR24381:SF97', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 343', 250044),
(399849, 'PTHR24381:SF319', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 699', 250044),
(399850, 'PTHR24381:SF399', NULL, NULL, NULL, NULL, 'ZFP790 PROTEIN', 250044),
(399851, 'PTHR24381:SF278', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 626', 250044),
(399852, 'PTHR24381:SF311', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 440', 250044),
(399853, 'PTHR24381:SF312', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 705E-RELATED', 250044),
(399854, 'PTHR24381:SF397', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 78', 250044),
(399855, 'PTHR24381:SF155', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 763', 250044),
(399856, 'PTHR24381:SF398', NULL, NULL, NULL, NULL, 'GLASS', 250044),
(399857, 'PTHR24381:SF277', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 57 HOMOLOG', 250044),
(399858, 'PTHR24381', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 250044),
(399859, 'PTHR24381:SF284', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN CONTAINING 14', 250044),
(399860, 'PTHR24381:SF160', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 556', 250044),
(399861, 'PTHR24381:SF282', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 721', 250044),
(399862, 'PTHR24381:SF280', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 768', 250044),
(399863, 'PTHR24381:SF82', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 70', 250044),
(399864, 'PTHR24381:SF80', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 558', 250044),
(399865, 'PTHR24381:SF76', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 891', 250044);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(399866, 'PTHR24381:SF77', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 559', 250044),
(399867, 'PTHR24381:SF324', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 432', 250044),
(399868, 'PTHR24381:SF168', NULL, NULL, NULL, NULL, 'RIKEN CDNA 2610008E11 GENE-RELATED', 250044),
(399869, 'PTHR24381:SF167', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 709', 250044),
(399870, 'PTHR24381:SF297', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 785', 250044),
(399871, 'PTHR24381:SF293', NULL, NULL, NULL, NULL, 'PATERNALLY-EXPRESSED GENE 3 PROTEIN', 250044),
(399872, 'PTHR24381:SF71', NULL, NULL, NULL, NULL, 'RIKEN CDNA A430033K04 GENE', 250044),
(399873, 'PTHR24381:SF74', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 69 HOMOLOG', 250044),
(399874, 'PTHR24381:SF68', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 248', 250044),
(399875, 'PTHR24381:SF418', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 487-RELATED', 250044),
(399876, 'PTHR24381:SF416', NULL, NULL, NULL, NULL, '', 250044),
(399877, 'PTHR24381:SF417', NULL, NULL, NULL, NULL, 'AA987161 PROTEIN-RELATED', 250044),
(399878, 'PTHR24381:SF414', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 491', 250044),
(399879, 'PTHR24381:SF415', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 461', 250044),
(399880, 'PTHR24381:SF412', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 391', 250044),
(399881, 'PTHR24381:SF413', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 436', 250044),
(399882, 'PTHR24381:SF138', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 619', 250044),
(399883, 'PTHR24381:SF410', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 3', 250044),
(399884, 'PTHR24381:SF135', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 69 HOMOLOG B', 250044),
(399885, 'PTHR24381:SF411', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 510', 250044),
(399886, 'PTHR24381:SF136', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 124-RELATED', 250044),
(399887, 'PTHR24381:SF384', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 2', 250044),
(399888, 'PTHR24381:SF143', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 90 HOMOLOG', 250044),
(399889, 'PTHR24381:SF261', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 777', 250044),
(399890, 'PTHR24381:SF380', NULL, NULL, NULL, NULL, 'ZINC FINGER AND SCAN DOMAIN-CONTAINING PROTEIN 2', 250044),
(399891, 'PTHR24381:SF381', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 41 HOMOLOG', 250044),
(399892, 'PTHR24381:SF60', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 35', 250044),
(399893, 'PTHR24381:SF62', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 25', 250044),
(399894, 'PTHR24381:SF56', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 554', 250044),
(399895, 'PTHR24381:SF57', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 566', 250044),
(399896, 'PTHR24381:SF309', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 529', 250044),
(399897, 'PTHR24381:SF59', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 19', 250044),
(399898, 'PTHR24381:SF304', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 587B', 250044),
(399899, 'PTHR24381:SF269', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 398', 250044),
(399900, 'PTHR24381:SF302', NULL, NULL, NULL, NULL, 'GDNF INDUCIBLE ZINC FINGER PROTEIN 1', 250044),
(399901, 'PTHR24381:SF303', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 705A-RELATED', 250044),
(399902, 'PTHR24381:SF149', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 266', 250044),
(399903, 'PTHR24381:SF388', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 949', 250044),
(399904, 'PTHR24381:SF147', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 37 HOMOLOG', 250044),
(399905, 'PTHR24381:SF268', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 75A', 250044),
(399906, 'PTHR24381:SF265', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 266', 250044),
(399907, 'PTHR24381:SF144', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 101', 250044),
(399908, 'PTHR24381:SF386', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 669', 250044),
(399909, 'PTHR24381:SF145', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 557', 250044),
(399910, 'PTHR24381:SF153', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 778', 250044),
(399911, 'PTHR24381:SF395', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 875', 250044);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(399912, 'PTHR24381:SF154', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 550', 250044),
(399913, 'PTHR24381:SF396', NULL, NULL, NULL, NULL, 'EXPRESSED SEQUENCE AI987944-RELATED', 250044),
(399914, 'PTHR24381:SF393', NULL, NULL, NULL, NULL, 'CHROMATIN-LINKED ADAPTOR FOR MSL PROTEINS, ISOFORM B', 250044),
(399915, 'PTHR24381:SF272', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 3 HOMOLOG', 250044),
(399916, 'PTHR24381:SF394', NULL, NULL, NULL, NULL, '', 250044),
(399917, 'PTHR24381:SF391', NULL, NULL, NULL, NULL, 'RB-ASSOCIATED KRAB ZINC FINGER PROTEIN', 250044),
(399918, 'PTHR24381:SF392', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 77-LIKE', 250044),
(399919, 'PTHR24381:SF390', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN OZF', 250044),
(399920, 'PTHR24381:SF53', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 404', 250044),
(399921, 'PTHR24381:SF51', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 555', 250044),
(399922, 'PTHR24381:SF44', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 560', 250044),
(399923, 'PTHR24381:SF119', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 133', 250044),
(399924, 'PTHR24381:SF118', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 329', 250044),
(399925, 'PTHR24381:SF115', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 582', 250044),
(399926, 'PTHR24381:SF355', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 92', 250044),
(399927, 'PTHR24381:SF356', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 81-RELATED', 250044),
(399928, 'PTHR24381:SF114', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 620', 250044),
(399929, 'PTHR24381:SF111', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 80', 250044),
(399930, 'PTHR24381:SF354', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 135', 250044),
(399931, 'PTHR24381:SF360', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 567', 250044),
(399932, 'PTHR24381:SF361', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 77', 250044),
(399933, 'PTHR24381:SF409', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 641', 250044),
(399934, 'PTHR24381:SF407', NULL, NULL, NULL, NULL, 'SI:CH211-229L10.11-RELATED', 250044),
(399935, 'PTHR24381:SF408', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 425', 250044),
(399936, 'PTHR24381:SF405', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 819', 250044),
(399937, 'PTHR24381:SF406', NULL, NULL, NULL, NULL, 'SI:CH1073-224N8.1', 250044),
(399938, 'PTHR24381:SF403', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 177', 250044),
(399939, 'PTHR24381:SF404', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 737', 250044),
(399940, 'PTHR24381:SF401', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 384', 250044),
(399941, 'PTHR24381:SF368', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 41', 250044),
(399942, 'PTHR24381:SF248', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 597', 250044),
(399943, 'PTHR24381:SF402', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 961', 250044),
(399944, 'PTHR24381:SF366', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 383', 250044),
(399945, 'PTHR24381:SF124', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 10', 250044),
(399946, 'PTHR24381:SF367', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 678', 250044),
(399947, 'PTHR24381:SF400', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 517', 250044),
(399948, 'PTHR24381:SF125', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 674', 250044),
(399949, 'PTHR24381:SF122', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 157', 250044),
(399950, 'PTHR24381:SF244', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 439-RELATED', 250044),
(399951, 'PTHR24381:SF365', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 615', 250044),
(399952, 'PTHR24381:SF131', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 422, RELATED SEQUENCE 1-RELATED', 250044),
(399953, 'PTHR24381:SF373', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 132', 250044),
(399954, 'PTHR24381:SF371', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 551', 250044),
(399955, 'PTHR24381:SF30', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 596', 250044),
(399956, 'PTHR10769', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S28', 250045),
(399957, 'PTHR10769:SF3', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S28', 250045);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(399958, 'PTHR10769:SF6', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S28-1', 250045),
(399959, 'PTHR10769:SF9', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S28E-RELATED', 250045),
(399960, 'PTHR10769:SF8', NULL, NULL, NULL, NULL, '', 250045),
(399961, 'PTHR10769:SF10', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S28', 250045),
(399962, 'PTHR28656', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 153', 250046),
(399963, 'PTHR28656:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 153', 250046),
(399964, 'PTHR11530:SF11', NULL, NULL, NULL, NULL, 'D-ASPARTATE OXIDASE', 250047),
(399965, 'PTHR11530:SF13', NULL, NULL, NULL, NULL, 'D-ASPARTATE OXIDASE 2', 250047),
(399966, 'PTHR11530:SF26', NULL, NULL, NULL, NULL, 'FAD DEPENDENT OXIDOREDUCTASE SUPERFAMILY (AFU_ORTHOLOGUE AFUA_5G13940)', 250047),
(399967, 'PTHR11530:SF6', NULL, NULL, NULL, NULL, 'D-ASPARTATE OXIDASE 3', 250047),
(399968, 'PTHR11530:SF15', NULL, NULL, NULL, NULL, 'D-AMINO-ACID OXIDASE', 250047),
(399969, 'PTHR11530:SF25', NULL, NULL, NULL, NULL, 'DAO DOMAIN-CONTAINING PROTEIN', 250047),
(399970, 'PTHR11530:SF28', NULL, NULL, NULL, NULL, 'D-ASPARTATE OXIDASE 1', 250047),
(399971, 'PTHR11530:SF17', NULL, NULL, NULL, NULL, 'RE49860P', 250047),
(399972, 'PTHR11530:SF16', NULL, NULL, NULL, NULL, 'D-AMINO ACID OXIDASE (AFU_ORTHOLOGUE AFUA_5G11290)', 250047),
(399973, 'PTHR11530:SF29', NULL, NULL, NULL, NULL, 'FAD DEPENDENT OXIDOREDUCTASE SUPERFAMILY (AFU_ORTHOLOGUE AFUA_6G10230)', 250047),
(399974, 'PTHR11530', NULL, NULL, NULL, NULL, 'D-AMINO ACID OXIDASE', 250047),
(399975, 'PTHR11530:SF30', NULL, NULL, NULL, NULL, 'DAO DOMAIN-CONTAINING PROTEIN', 250047),
(399976, 'PTHR43316:SF8', NULL, NULL, NULL, NULL, 'DEHALOGENASE-LIKE HYDROLASE, PUTATIVE-RELATED', 250048),
(399977, 'PTHR43316', NULL, NULL, NULL, NULL, 'HYDROLASE, HALOACID DELAHOGENASE-RELATED', 250048),
(399978, 'PTHR43316:SF4', NULL, NULL, NULL, NULL, 'ACID DEHALOGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G05870)-RELATED', 250048),
(399979, 'PTHR43316:SF3', NULL, NULL, NULL, NULL, 'HALOACID DEHALOGENASE, TYPE II (AFU_ORTHOLOGUE AFUA_2G07750)-RELATED', 250048),
(399980, 'PTHR30474:SF13', NULL, NULL, NULL, NULL, 'STAGE V SPORULATION PROTEIN E', 250049),
(399981, 'PTHR30474:SF3', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN GLYCOSYLTRANSFERASE RODA', 250049),
(399982, 'PTHR30474:SF1', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN GLYCOSYLTRANSFERASE MRDB', 250049),
(399983, 'PTHR30474:SF2', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN GLYCOSYLTRANSFERASE FTSW-RELATED', 250049),
(399984, 'PTHR30474', NULL, NULL, NULL, NULL, 'CELL CYCLE PROTEIN', 250049),
(399985, 'PTHR12750:SF13', NULL, NULL, NULL, NULL, 'INOSITOL HEXAKISPHOSPHATE AND DIPHOSPHOINOSITOL-PENTAKISPHOSPHATE KINASE', 250050),
(399986, 'PTHR12750:SF15', NULL, NULL, NULL, NULL, 'INOSITOL HEXAKISPHOSPHATE AND DIPHOSPHOINOSITOL-PENTAKISPHOSPHATE KINASE', 250050),
(399987, 'PTHR12750:SF10', NULL, NULL, NULL, NULL, 'INOSITOL HEXAKISPHOSPHATE AND DIPHOSPHOINOSITOL-PENTAKISPHOSPHATE KINASE 2', 250050),
(399988, 'PTHR12750:SF11', NULL, NULL, NULL, NULL, 'INOSITOL HEXAKISPHOSPHATE AND DIPHOSPHOINOSITOL-PENTAKISPHOSPHATE KINASE 1', 250050),
(399989, 'PTHR12750:SF22', NULL, NULL, NULL, NULL, 'INOSITOL HEXAKISPHOSPHATE AND DIPHOSPHOINOSITOL-PENTAKISPHOSPHATE KINASE', 250050),
(399990, 'PTHR12750:SF23', NULL, NULL, NULL, NULL, 'INOSITOL HEXAKISPHOSPHATE AND DIPHOSPHOINOSITOL-PENTAKISPHOSPHATE KINASE VIP1', 250050),
(399991, 'PTHR12750', NULL, NULL, NULL, NULL, 'DIPHOSPHOINOSITOL PENTAKISPHOSPHATE KINASE', 250050),
(399992, 'PTHR12750:SF19', NULL, NULL, NULL, NULL, 'INOSITOL HEXAKISPHOSPHATE AND DIPHOSPHOINOSITOL-PENTAKISPHOSPHATE KINASE', 250050),
(399993, 'PTHR12750:SF9', NULL, NULL, NULL, NULL, 'INOSITOL HEXAKISPHOSPHATE AND DIPHOSPHOINOSITOL-PENTAKISPHOSPHATE KINASE', 250050),
(399994, 'PTHR16453', NULL, NULL, NULL, NULL, 'WD40 DOMAIN-CONTAINING PROTEIN MIO FAMILY MEMBER', 250051),
(399995, 'PTHR16453:SF9', NULL, NULL, NULL, NULL, 'GATOR COMPLEX PROTEIN MIOS', 250051),
(399996, 'PTHR16453:SF13', NULL, NULL, NULL, NULL, '', 250051);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(399997, 'PTHR15758', NULL, NULL, NULL, NULL, 'BCL-2-LIKE PROTEIN 13', 250052),
(399998, 'PTHR15758:SF2', NULL, NULL, NULL, NULL, 'BCL-2-LIKE PROTEIN 13', 250052),
(399999, 'PTHR11945:SF816', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 58', 250053),
(400000, 'PTHR11945:SF817', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL82', 250053),
(400001, 'PTHR11945:SF818', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL62', 250053),
(400002, 'PTHR11945:SF819', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 5', 250053),
(400003, 'PTHR11945:SF812', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN-RELATED', 250053),
(400004, 'PTHR11945:SF813', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 14', 250053),
(400005, 'PTHR11945:SF814', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTIONAL FACTOR HAM92', 250053),
(400006, 'PTHR11945:SF815', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR', 250053),
(400007, 'PTHR11945:SF810', NULL, NULL, NULL, NULL, 'DEVELOPMENTAL PROTEIN SEPALLATA 1-LIKE', 250053),
(400008, 'PTHR11945:SF811', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTIONAL FACTOR HAM137', 250053),
(400009, 'PTHR11945:SF809', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL80', 250053),
(400010, 'PTHR11945:SF805', NULL, NULL, NULL, NULL, 'BOX PROTEIN, PUTATIVE-RELATED', 250053),
(400011, 'PTHR11945:SF806', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400012, 'PTHR11945:SF807', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 50', 250053),
(400013, 'PTHR11945:SF808', NULL, NULL, NULL, NULL, 'SERUM RESPONSE FACTOR HOMOLOG B-LIKE', 250053),
(400014, 'PTHR11945:SF801', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 26', 250053),
(400015, 'PTHR11945:SF802', NULL, NULL, NULL, NULL, 'MADS-BOX PROTEIN AGL42', 250053),
(400016, 'PTHR11945:SF803', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TM6', 250053),
(400017, 'PTHR11945:SF804', NULL, NULL, NULL, NULL, 'MYOCYTE ENHANCER FACTOR 2D', 250053),
(400018, 'PTHR11945:SF800', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 21', 250053),
(400019, 'PTHR11945:SF485', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 17', 250053),
(400020, 'PTHR11945:SF367', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 7', 250053),
(400021, 'PTHR11945:SF481', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400022, 'PTHR11945:SF718', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR', 250053),
(400023, 'PTHR11945:SF834', NULL, NULL, NULL, NULL, '', 250053),
(400024, 'PTHR11945:SF830', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL8 HOMOLOG', 250053),
(400025, 'PTHR11945:SF831', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400026, 'PTHR11945:SF710', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400027, 'PTHR11945:SF832', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400028, 'PTHR11945:SF833', NULL, NULL, NULL, NULL, 'TRUNCATED TRANSCRIPTION FACTOR CAULIFLOWER A-LIKE ISOFORM X1', 250053),
(400029, 'PTHR11945:SF712', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400030, 'PTHR11945:SF397', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR', 250053),
(400031, 'PTHR11945:SF398', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400032, 'PTHR11945:SF152', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL12', 250053),
(400033, 'PTHR11945:SF275', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 15', 250053),
(400034, 'PTHR11945:SF396', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 32', 250053),
(400035, 'PTHR11945:SF706', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400036, 'PTHR11945:SF827', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL28', 250053),
(400037, 'PTHR11945:SF828', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL62', 250053),
(400038, 'PTHR11945:SF829', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(400039, 'PTHR11945:SF708', NULL, NULL, NULL, NULL, 'OS01G0906300 PROTEIN', 250053),
(400040, 'PTHR11945:SF709', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400041, 'PTHR11945:SF702', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE 83-RELATED', 250053),
(400042, 'PTHR11945:SF823', NULL, NULL, NULL, NULL, 'MYOCYTE ENHANCER FACTOR 2B', 250053),
(400043, 'PTHR11945:SF824', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400044, 'PTHR11945:SF704', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE 46-RELATED', 250053),
(400045, 'PTHR11945:SF825', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 1', 250053),
(400046, 'PTHR11945:SF826', NULL, NULL, NULL, NULL, 'K-BOX REGION AND MADS-BOX TRANSCRIPTION FACTOR FAMILY PROTEIN-RELATED', 250053),
(400047, 'PTHR11945:SF820', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE 51-RELATED', 250053),
(400048, 'PTHR11945:SF821', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE 57', 250053),
(400049, 'PTHR11945:SF822', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400050, 'PTHR11945:SF387', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL80', 250053),
(400051, 'PTHR11945:SF145', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400052, 'PTHR11945:SF388', NULL, NULL, NULL, NULL, 'OS08G0531900 PROTEIN', 250053),
(400053, 'PTHR11945:SF382', NULL, NULL, NULL, NULL, 'DEVELOPMENTAL PROTEIN SEPALLATA 3', 250053),
(400054, 'PTHR11945:SF383', NULL, NULL, NULL, NULL, 'MYOCYTE-SPECIFIC ENHANCER FACTOR 2B', 250053),
(400055, 'PTHR11945:SF739', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL104-RELATED', 250053),
(400056, 'PTHR11945:SF736', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, MADS-BOX-RELATED', 250053),
(400057, 'PTHR11945:SF616', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400058, 'PTHR11945:SF738', NULL, NULL, NULL, NULL, '', 250053),
(400059, 'PTHR11945:SF610', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL61', 250053),
(400060, 'PTHR11945:SF732', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 51', 250053),
(400061, 'PTHR11945:SF612', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400062, 'PTHR11945:SF733', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL29', 250053),
(400063, 'PTHR11945:SF613', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL62', 250053),
(400064, 'PTHR11945:SF730', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400065, 'PTHR11945:SF176', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400066, 'PTHR11945:SF170', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL11', 250053),
(400067, 'PTHR11945:SF728', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 29', 250053),
(400068, 'PTHR11945:SF725', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE 58-RELATED', 250053),
(400069, 'PTHR11945:SF727', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL29', 250053),
(400070, 'PTHR11945:SF721', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400071, 'PTHR11945:SF602', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400072, 'PTHR11945:SF723', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL62', 250053),
(400073, 'PTHR11945:SF162', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 34', 250053),
(400074, 'PTHR11945:SF519', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE 94', 250053),
(400075, 'PTHR11945:SF516', NULL, NULL, NULL, NULL, 'OS02G0104100 PROTEIN', 250053),
(400076, 'PTHR11945:SF758', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 30', 250053),
(400077, 'PTHR11945:SF637', NULL, NULL, NULL, NULL, 'MYOCYTE-SPECIFIC ENHANCER FACTOR 2A', 250053),
(400078, 'PTHR11945:SF759', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400079, 'PTHR11945:SF512', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400080, 'PTHR11945:SF634', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400081, 'PTHR11945:SF635', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE 79', 250053);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(400082, 'PTHR11945:SF756', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400083, 'PTHR11945:SF752', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400084, 'PTHR11945:SF629', NULL, NULL, NULL, NULL, 'OS01G0975800 PROTEIN', 250053),
(400085, 'PTHR11945:SF505', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400086, 'PTHR11945:SF747', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400087, 'PTHR11945:SF626', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400088, 'PTHR11945:SF506', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR FAMILY PROTEIN', 250053),
(400089, 'PTHR11945:SF628', NULL, NULL, NULL, NULL, 'TRUNCATED TRANSCRIPTION FACTOR CAULIFLOWER A-LIKE ISOFORM X1', 250053),
(400090, 'PTHR11945:SF621', NULL, NULL, NULL, NULL, 'DEVELOPMENTAL PROTEIN SEPALLATA 1', 250053),
(400091, 'PTHR11945:SF501', NULL, NULL, NULL, NULL, 'MADS-BOX PROTEIN AGL35', 250053),
(400092, 'PTHR11945:SF502', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL81', 250053),
(400093, 'PTHR11945:SF623', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400094, 'PTHR11945:SF740', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR', 250053),
(400095, 'PTHR11945:SF741', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 13', 250053),
(400096, 'PTHR11945:SF620', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400097, 'PTHR11945:SF416', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE 67', 250053),
(400098, 'PTHR11945:SF537', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR', 250053),
(400099, 'PTHR11945:SF779', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL61', 250053),
(400100, 'PTHR11945:SF417', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL27-RELATED', 250053),
(400101, 'PTHR11945:SF775', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400102, 'PTHR11945:SF654', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400103, 'PTHR11945:SF412', NULL, NULL, NULL, NULL, 'MADS TRANSCRIPTION FACTOR', 250053),
(400104, 'PTHR11945:SF655', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 33', 250053),
(400105, 'PTHR11945:SF776', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL23-RELATED', 250053),
(400106, 'PTHR11945:SF534', NULL, NULL, NULL, NULL, 'MYOCYTE-SPECIFIC ENHANCER FACTOR 2', 250053),
(400107, 'PTHR11945:SF535', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL29', 250053),
(400108, 'PTHR11945:SF414', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400109, 'PTHR11945:SF777', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR FAMILY PROTEIN', 250053),
(400110, 'PTHR11945:SF415', NULL, NULL, NULL, NULL, 'DEVELOPMENTAL PROTEIN SEPALLATA 2', 250053),
(400111, 'PTHR11945:SF778', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL61', 250053),
(400112, 'PTHR11945:SF771', NULL, NULL, NULL, NULL, '', 250053),
(400113, 'PTHR11945:SF772', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL62', 250053),
(400114, 'PTHR11945:SF651', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400115, 'PTHR11945:SF530', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE 91', 250053),
(400116, 'PTHR11945:SF410', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL65', 250053),
(400117, 'PTHR11945:SF652', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400118, 'PTHR11945:SF773', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL29', 250053),
(400119, 'PTHR11945:SF774', NULL, NULL, NULL, NULL, '', 250053),
(400120, 'PTHR11945:SF770', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE 33', 250053),
(400121, 'PTHR11945:SF405', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR FAMILY PROTEIN', 250053),
(400122, 'PTHR11945:SF768', NULL, NULL, NULL, NULL, 'FLORAL HOMEOTIC PROTEIN AGAMOUS', 250053),
(400123, 'PTHR11945:SF769', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL62', 250053),
(400124, 'PTHR11945:SF649', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(400125, 'PTHR11945:SF529', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400126, 'PTHR11945:SF408', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL8 HOMOLOG', 250053),
(400127, 'PTHR11945:SF522', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL6', 250053),
(400128, 'PTHR11945:SF401', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL81', 250053),
(400129, 'PTHR11945:SF764', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL62', 250053),
(400130, 'PTHR11945:SF765', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL8', 250053),
(400131, 'PTHR11945:SF645', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400132, 'PTHR11945:SF766', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL19', 250053),
(400133, 'PTHR11945:SF767', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR', 250053),
(400134, 'PTHR11945:SF404', NULL, NULL, NULL, NULL, 'MADS-BOX PROTEIN AGL24-LIKE', 250053),
(400135, 'PTHR11945:SF760', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 20', 250053),
(400136, 'PTHR11945:SF761', NULL, NULL, NULL, NULL, 'MADS TRANSCRIPTION FACTOR', 250053),
(400137, 'PTHR11945:SF640', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL62', 250053),
(400138, 'PTHR11945:SF762', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL62', 250053),
(400139, 'PTHR11945:SF763', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 22', 250053),
(400140, 'PTHR11945:SF521', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE 48-RELATED', 250053),
(400141, 'PTHR11945:SF676', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400142, 'PTHR11945:SF797', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL63-RELATED', 250053),
(400143, 'PTHR11945:SF434', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 56', 250053),
(400144, 'PTHR11945:SF556', NULL, NULL, NULL, NULL, 'MADS-BOX PROTEIN FLOWERING LOCUS C-LIKE', 250053),
(400145, 'PTHR11945:SF798', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL104', 250053),
(400146, 'PTHR11945:SF435', NULL, NULL, NULL, NULL, 'TRUNCATED TRANSCRIPTION FACTOR CAULIFLOWER A-LIKE ISOFORM X1', 250053),
(400147, 'PTHR11945:SF799', NULL, NULL, NULL, NULL, 'MADS-BOX PROTEIN AGL71', 250053),
(400148, 'PTHR11945:SF793', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE 50-RELATED', 250053),
(400149, 'PTHR11945:SF673', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400150, 'PTHR11945:SF794', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400151, 'PTHR11945:SF674', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE 39-RELATED', 250053),
(400152, 'PTHR11945:SF795', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, MADS-BOX, TRANSCRIPTION FACTOR, K-BOX-RELATED', 250053),
(400153, 'PTHR11945:SF675', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 31', 250053),
(400154, 'PTHR11945:SF796', NULL, NULL, NULL, NULL, 'MADS TRANSCRIPTION FACTOR', 250053),
(400155, 'PTHR11945:SF554', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL82', 250053),
(400156, 'PTHR11945:SF790', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400157, 'PTHR11945:SF791', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400158, 'PTHR11945:SF550', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL13', 250053),
(400159, 'PTHR11945:SF792', NULL, NULL, NULL, NULL, 'MADS-BOX PROTEIN JOINTLESS', 250053),
(400160, 'PTHR11945:SF671', NULL, NULL, NULL, NULL, 'MADS-BOX PROTEIN FLOWERING LOCUS C', 250053),
(400161, 'PTHR11945:SF427', NULL, NULL, NULL, NULL, 'TRUNCATED TRANSCRIPTION FACTOR CAULIFLOWER D-LIKE ISOFORM X1', 250053),
(400162, 'PTHR11945:SF786', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400163, 'PTHR11945:SF666', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400164, 'PTHR11945:SF787', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL30', 250053),
(400165, 'PTHR11945:SF425', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR FAMILY PROTEIN', 250053);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(400166, 'PTHR11945:SF667', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400167, 'PTHR11945:SF788', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE-34-RELATED', 250053),
(400168, 'PTHR11945:SF789', NULL, NULL, NULL, NULL, 'AGAMOUSB', 250053),
(400169, 'PTHR11945:SF661', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400170, 'PTHR11945:SF782', NULL, NULL, NULL, NULL, 'OS11G0229900 PROTEIN', 250053),
(400171, 'PTHR11945:SF420', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR', 250053),
(400172, 'PTHR11945:SF662', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL103', 250053),
(400173, 'PTHR11945:SF783', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL62', 250053),
(400174, 'PTHR11945:SF663', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL8', 250053),
(400175, 'PTHR11945:SF784', NULL, NULL, NULL, NULL, 'TYPE I MADS BOX TRANSCRIPTION FACTOR', 250053),
(400176, 'PTHR11945:SF785', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400177, 'PTHR11945:SF664', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400178, 'PTHR11945:SF780', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR FAMILY PROTEIN', 250053),
(400179, 'PTHR11945:SF781', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400180, 'PTHR11945:SF219', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE 102-RELATED', 250053),
(400181, 'PTHR11945:SF456', NULL, NULL, NULL, NULL, 'FLORAL HOMEOTIC PROTEIN APETALA 1', 250053),
(400182, 'PTHR11945:SF336', NULL, NULL, NULL, NULL, 'SERUM FACTOR RESPONSE D', 250053),
(400183, 'PTHR11945:SF579', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR-LIKE PROTEIN', 250053),
(400184, 'PTHR11945:SF459', NULL, NULL, NULL, NULL, 'MADS-BOX PROTEIN AGL72', 250053),
(400185, 'PTHR11945:SF574', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400186, 'PTHR11945:SF695', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL29', 250053),
(400187, 'PTHR11945:SF696', NULL, NULL, NULL, NULL, 'BOX PROTEIN, PUTATIVE-RELATED', 250053),
(400188, 'PTHR11945:SF455', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR FAMILY PROTEIN', 250053),
(400189, 'PTHR11945:SF570', NULL, NULL, NULL, NULL, 'OS02G0164450 PROTEIN', 250053),
(400190, 'PTHR11945:SF693', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400191, 'PTHR11945:SF567', NULL, NULL, NULL, NULL, 'K-BOX REGION AND MADS-BOX TRANSCRIPTION FACTOR FAMILY PROTEIN-RELATED', 250053),
(400192, 'PTHR11945:SF688', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400193, 'PTHR11945:SF448', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR FAMILY PROTEIN', 250053),
(400194, 'PTHR11945:SF441', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL29', 250053),
(400195, 'PTHR11945:SF684', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL3', 250053),
(400196, 'PTHR11945:SF564', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 250053),
(400197, 'PTHR11945', NULL, NULL, NULL, NULL, 'MADS BOX PROTEIN', 250053),
(400198, 'PTHR11945:SF561', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE 54-RELATED', 250053),
(400199, 'PTHR11945:SF682', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400200, 'PTHR11945:SF599', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400201, 'PTHR11945:SF478', NULL, NULL, NULL, NULL, 'ZAG1 PROTEIN', 250053),
(400202, 'PTHR11945:SF595', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400203, 'PTHR11945:SF597', NULL, NULL, NULL, NULL, 'MADS BOX PROTEIN', 250053),
(400204, 'PTHR11945:SF598', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400205, 'PTHR11945:SF472', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE 43-RELATED', 250053),
(400206, 'PTHR11945:SF594', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400207, 'PTHR11945:SF473', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR CAULIFLOWER', 250053),
(400208, 'PTHR11945:SF25', NULL, NULL, NULL, NULL, 'MYOCYTE-SPECIFIC ENHANCER FACTOR 2C', 250053);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(400209, 'PTHR11945:SF23', NULL, NULL, NULL, NULL, 'MYOCYTE-SPECIFIC ENHANCER FACTOR 2D', 250053),
(400210, 'PTHR11945:SF229', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE 55-RELATED', 250053),
(400211, 'PTHR11945:SF469', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL15', 250053),
(400212, 'PTHR11945:SF584', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 250053),
(400213, 'PTHR11945:SF581', NULL, NULL, NULL, NULL, 'MADS-BOX PROTEIN CMB1-LIKE', 250053),
(400214, 'PTHR11945:SF583', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE 96', 250053),
(400215, 'PTHR11945:SF341', NULL, NULL, NULL, NULL, 'MADS-BOX PROTEIN SOC1', 250053),
(400216, 'PTHR31894:SF0', NULL, NULL, NULL, NULL, 'UPF0461 PROTEIN C5ORF24', 250054),
(400217, 'PTHR31894', NULL, NULL, NULL, NULL, 'UPF0461 PROTEIN C5ORF24', 250054),
(400218, 'PTHR43588', NULL, NULL, NULL, NULL, 'COBALT-PRECORRIN-8 METHYLMUTASE', 250055),
(400219, 'PTHR43588:SF1', NULL, NULL, NULL, NULL, 'COBALT-PRECORRIN-8 METHYLMUTASE', 250055),
(400220, 'PTHR45807:SF2', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', 250056),
(400221, 'PTHR45807:SF1', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE JAK2', 250056),
(400222, 'PTHR45807:SF3', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE JAK3', 250056),
(400223, 'PTHR45807:SF6', NULL, NULL, NULL, NULL, 'NON-RECEPTOR TYROSINE-PROTEIN KINASE TYK2', 250056),
(400224, 'PTHR45807', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE HOPSCOTCH', 250056),
(400225, 'PTHR45807:SF5', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE JAK1', 250056),
(400226, 'PTHR45807:SF7', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE HOPSCOTCH', 250056),
(400227, 'PTHR36741:SF1', NULL, NULL, NULL, NULL, 'OS07G0100500 PROTEIN', 250057),
(400228, 'PTHR36741', NULL, NULL, NULL, NULL, 'OS07G0100500 PROTEIN', 250057),
(400229, 'PTHR36741:SF2', NULL, NULL, NULL, NULL, '', 250057),
(400230, 'PTHR46977', NULL, NULL, NULL, NULL, 'PROTEIN FREE1', 250058),
(400231, 'PTHR46977:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FREE1-LIKE ISOFORM X1', 250058),
(400232, 'PTHR46977:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FREE1', 250058),
(400233, 'PTHR46977:SF6', NULL, NULL, NULL, NULL, 'BNAA06G14240D PROTEIN', 250058),
(400234, 'PTHR46977:SF4', NULL, NULL, NULL, NULL, 'PROTEIN FREE1-LIKE', 250058),
(400235, 'PTHR46977:SF8', NULL, NULL, NULL, NULL, 'OS07G0573300 PROTEIN', 250058),
(400236, 'PTHR45660:SF87', NULL, NULL, NULL, NULL, 'OS08G0565700 PROTEIN', 250059),
(400237, 'PTHR45660:SF65', NULL, NULL, NULL, NULL, 'BNAC02G02520D PROTEIN', 250059),
(400238, 'PTHR45660:SF86', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE, H3 LYSINE-9 SPECIFIC SUVH6-LIKE', 250059),
(400239, 'PTHR45660:SF41', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE H3 LYSINE-9 SPECIFIC SUVH5', 250059),
(400240, 'PTHR45660:SF85', NULL, NULL, NULL, NULL, 'YDG/SRA DOMAIN CONTAINING PROTEIN-RELATED', 250059),
(400241, 'PTHR45660:SF9', NULL, NULL, NULL, NULL, 'OS05G0490700 PROTEIN', 250059),
(400242, 'PTHR45660:SF84', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE FAMILY MEMBER SUVH9-LIKE', 250059),
(400243, 'PTHR45660:SF62', NULL, NULL, NULL, NULL, 'BNAC04G11240D PROTEIN', 250059),
(400244, 'PTHR45660:SF24', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE, H3 LYSINE-9 SPECIFIC SUVH3-RELATED', 250059),
(400245, 'PTHR45660:SF46', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE, H3 LYSINE-9 SPECIFIC SUVH6', 250059),
(400246, 'PTHR45660:SF5', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE, H3 LYSINE-9 SPECIFIC SUVH1', 250059),
(400247, 'PTHR45660:SF89', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SUVR3', 250059),
(400248, 'PTHR45660:SF45', NULL, NULL, NULL, NULL, 'YDG DOMAIN-CONTAINING PROTEIN', 250059),
(400249, 'PTHR45660:SF23', NULL, NULL, NULL, NULL, 'YDG DOMAIN-CONTAINING PROTEIN', 250059),
(400250, 'PTHR45660:SF66', NULL, NULL, NULL, NULL, 'SET DOMAIN PROTEIN', 250059),
(400251, 'PTHR45660:SF22', NULL, NULL, NULL, NULL, 'OS04G0544100 PROTEIN', 250059),
(400252, 'PTHR45660:SF88', NULL, NULL, NULL, NULL, 'OS01G0927000 PROTEIN', 250059);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(400253, 'PTHR45660:SF3', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE FAMILY MEMBER SUVH9', 250059),
(400254, 'PTHR45660:SF1', NULL, NULL, NULL, NULL, 'OS11G0131600 PROTEIN', 250059),
(400255, 'PTHR45660:SF83', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE, H3 LYSINE-9 SPECIFIC SUVH5-LIKE ISOFORM X1', 250059),
(400256, 'PTHR45660:SF82', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN-RELATED', 250059),
(400257, 'PTHR45660:SF60', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE, H3 LYSINE-9 SPECIFIC SUVH6-LIKE ISOFORM X1', 250059),
(400258, 'PTHR45660:SF81', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE FAMILY MEMBER SUVH2', 250059),
(400259, 'PTHR45660:SF80', NULL, NULL, NULL, NULL, 'OS03G0320400 PROTEIN', 250059),
(400260, 'PTHR45660:SF29', NULL, NULL, NULL, NULL, 'SET DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_4G09180)', 250059),
(400261, 'PTHR45660:SF32', NULL, NULL, NULL, NULL, '', 250059),
(400262, 'PTHR45660:SF75', NULL, NULL, NULL, NULL, 'YDG DOMAIN-CONTAINING PROTEIN', 250059),
(400263, 'PTHR45660:SF53', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE, H3 LYSINE-9 SPECIFIC SUVH5', 250059),
(400264, 'PTHR45660:SF74', NULL, NULL, NULL, NULL, 'SRA-YDG-RELATED', 250059),
(400265, 'PTHR45660:SF73', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE, H3 LYSINE-9 SPECIFIC SUVH1', 250059),
(400266, 'PTHR45660:SF58', NULL, NULL, NULL, NULL, 'SET DOMAIN GROUP 21-RELATED', 250059),
(400267, 'PTHR45660:SF36', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE, H3 LYSINE-9 SPECIFIC SUVH1-LIKE', 250059),
(400268, 'PTHR45660:SF57', NULL, NULL, NULL, NULL, 'SRA-YDG-RELATED', 250059),
(400269, 'PTHR45660:SF13', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SETMAR', 250059),
(400270, 'PTHR45660:SF79', NULL, NULL, NULL, NULL, 'SET DOMAIN PROTEIN', 250059),
(400271, 'PTHR45660:SF35', NULL, NULL, NULL, NULL, '', 250059),
(400272, 'PTHR45660:SF12', NULL, NULL, NULL, NULL, '', 250059),
(400273, 'PTHR45660:SF11', NULL, NULL, NULL, NULL, 'OS08G0400200 PROTEIN', 250059),
(400274, 'PTHR45660:SF55', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE, H3 LYSINE-9 SPECIFIC SUVH5-LIKE', 250059),
(400275, 'PTHR45660:SF90', NULL, NULL, NULL, NULL, 'YDG DOMAIN-CONTAINING PROTEIN', 250059),
(400276, 'PTHR45660', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SETMAR', 250059),
(400277, 'PTHR45660:SF50', NULL, NULL, NULL, NULL, 'BNAA06G11990D PROTEIN', 250059),
(400278, 'PTHR45660:SF70', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE H3 LYSINE-9 SPECIFIC SUVH3', 250059),
(400279, 'PTHR45660:SF91', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE, H3 LYSINE-9 SPECIFIC SUVH4-LIKE ISOFORM X1', 250059),
(400280, 'PTHR45660:SF18', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE, H3 LYSINE-9 SPECIFIC SUVH7-RELATED', 250059),
(400281, 'PTHR45660:SF17', NULL, NULL, NULL, NULL, 'SRA-YDG, PUA-LIKE DOMAIN PROTEIN-RELATED', 250059),
(400282, 'PTHR46434:SF4', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 250060),
(400283, 'PTHR46434:SF3', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN BRASSINAZOLE INSENSITIVE PALE GREEN 2, CHLOROPLASTIC', 250060),
(400284, 'PTHR46434:SF1', NULL, NULL, NULL, NULL, 'GENETIC INTERACTOR OF PROHIBITINS 3, MITOCHONDRIAL', 250060),
(400285, 'PTHR46434', NULL, NULL, NULL, NULL, 'GENETIC INTERACTOR OF PROHIBITINS 3, MITOCHONDRIAL', 250060),
(400286, 'PTHR28165:SF2', NULL, NULL, NULL, NULL, 'MARVEL DOMAIN-CONTAINING PROTEIN', 250061),
(400287, 'PTHR28165:SF1', NULL, NULL, NULL, NULL, 'NON-CLASSICAL EXPORT PROTEIN 2-RELATED', 250061),
(400288, 'PTHR28165', NULL, NULL, NULL, NULL, 'NON-CLASSICAL EXPORT PROTEIN 2-RELATED', 250061),
(400289, 'PTHR47817', NULL, NULL, NULL, NULL, 'OS04G0686300 PROTEIN', 250062),
(400290, 'PTHR47817:SF2', NULL, NULL, NULL, NULL, 'OS04G0686300 PROTEIN', 250062),
(400291, 'PTHR47442', NULL, NULL, NULL, NULL, 'MYND-TYPE ZINC FINGER PROTEIN MUB1', 250063),
(400292, 'PTHR47442:SF1', NULL, NULL, NULL, NULL, 'MYND-TYPE ZINC FINGER PROTEIN MUB1', 250063); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(400293, 'PTHR45188', NULL, NULL, NULL, NULL, 'DNAJ PROTEIN P58IPK HOMOLOG', 250064),
(400294, 'PTHR45188:SF2', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 7', 250064),
(400295, 'PTHR47353:SF1', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE PROTEIN HCF164, CHLOROPLASTIC', 250065),
(400296, 'PTHR47353', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE PROTEIN HCF164, CHLOROPLASTIC', 250065),
(400297, 'PTHR13533:SF1', NULL, NULL, NULL, NULL, 'N-ACETYLNEURAMINATE 9-O-ACETYLTRANSFERASE', 250066),
(400298, 'PTHR13533:SF32', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 250066),
(400299, 'PTHR13533:SF31', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250066),
(400300, 'PTHR13533:SF34', NULL, NULL, NULL, NULL, '', 250066),
(400301, 'PTHR13533', NULL, NULL, NULL, NULL, 'N-ACETYLNEURAMINATE 9-O-ACETYLTRANSFERASE', 250066),
(400302, 'PTHR13533:SF45', NULL, NULL, NULL, NULL, 'CAS1_ACYLT DOMAIN-CONTAINING PROTEIN', 250066),
(400303, 'PTHR13533:SF44', NULL, NULL, NULL, NULL, 'OS01G0631100 PROTEIN', 250066),
(400304, 'PTHR13533:SF36', NULL, NULL, NULL, NULL, 'PROTEIN REDUCED WALL ACETYLATION 3-LIKE', 250066),
(400305, 'PTHR13533:SF46', NULL, NULL, NULL, NULL, 'PROTEIN REDUCED WALL ACETYLATION 3-RELATED', 250066),
(400306, 'PTHR13533:SF27', NULL, NULL, NULL, NULL, 'PROTEIN REDUCED WALL ACETYLATION 1', 250066),
(400307, 'PTHR13533:SF38', NULL, NULL, NULL, NULL, 'PMR5N DOMAIN-CONTAINING PROTEIN', 250066),
(400308, 'PTHR13533:SF16', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 14-RELATED', 250066),
(400309, 'PTHR13533:SF26', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 14', 250066),
(400310, 'PTHR13533:SF37', NULL, NULL, NULL, NULL, 'CAS1_ACYLT DOMAIN-CONTAINING PROTEIN', 250066),
(400311, 'PTHR13533:SF29', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 16', 250066),
(400312, 'PTHR13533:SF28', NULL, NULL, NULL, NULL, 'PROTEIN REDUCED WALL ACETYLATION 3', 250066),
(400313, 'PTHR40744', NULL, NULL, NULL, NULL, 'SODIUM STIBOGLUCONATE RESISTANCE PROTEIN-RELATED', 250067),
(400314, 'PTHR40744:SF1', NULL, NULL, NULL, NULL, 'SODIUM STIBOGLUCONATE RESISTANCE PROTEIN-RELATED', 250067),
(400315, 'PTHR11771:SF129', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400316, 'PTHR11771:SF54', NULL, NULL, NULL, NULL, 'LINOLEATE 9S-LIPOXYGENASE 2', 250068),
(400317, 'PTHR11771:SF127', NULL, NULL, NULL, NULL, 'LIPOXYGENASE 7, CHLOROPLASTIC', 250068),
(400318, 'PTHR11771:SF128', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400319, 'PTHR11771:SF169', NULL, NULL, NULL, NULL, 'LINOLEATE 9S-LIPOXYGENASE 5-RELATED', 250068),
(400320, 'PTHR11771:SF126', NULL, NULL, NULL, NULL, 'LINOLEATE 9S-LIPOXYGENASE 1', 250068),
(400321, 'PTHR11771:SF167', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400322, 'PTHR11771:SF165', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400323, 'PTHR11771:SF122', NULL, NULL, NULL, NULL, 'LINOLEATE 9S-LIPOXYGENASE-4', 250068),
(400324, 'PTHR11771:SF163', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400325, 'PTHR11771:SF91', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400326, 'PTHR11771:SF161', NULL, NULL, NULL, NULL, 'POLYUNSATURATED FATTY ACID LIPOXYGENASE ALOX15B', 250068),
(400327, 'PTHR11771:SF96', NULL, NULL, NULL, NULL, 'ZGC:152891', 250068),
(400328, 'PTHR11771:SF95', NULL, NULL, NULL, NULL, 'LIPOXYGENASE 4, CHLOROPLASTIC', 250068),
(400329, 'PTHR11771:SF160', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400330, 'PTHR11771:SF118', NULL, NULL, NULL, NULL, 'SEED LINOLEATE 9S-LIPOXYGENASE-3', 250068),
(400331, 'PTHR11771:SF116', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400332, 'PTHR11771:SF89', NULL, NULL, NULL, NULL, 'LIPOXYGENASE 2, CHLOROPLASTIC', 250068),
(400333, 'PTHR11771:SF158', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400334, 'PTHR11771:SF115', NULL, NULL, NULL, NULL, 'SEED LINOLEATE 9S-LIPOXYGENASE', 250068),
(400335, 'PTHR11771:SF159', NULL, NULL, NULL, NULL, '', 250068),
(400336, 'PTHR11771:SF112', NULL, NULL, NULL, NULL, 'LINOLEATE 9S-LIPOXYGENASE 5', 250068),
(400337, 'PTHR11771:SF49', NULL, NULL, NULL, NULL, 'LINOLEATE 9S-LIPOXYGENASE 3-RELATED', 250068);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(400338, 'PTHR11771:SF113', NULL, NULL, NULL, NULL, 'LIPOXYGENASE 6-RELATED', 250068),
(400339, 'PTHR11771:SF198', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400340, 'PTHR11771:SF111', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400341, 'PTHR11771:SF196', NULL, NULL, NULL, NULL, 'LINOLEATE 13S-LIPOXYGENASE 2-1 PROTEIN-RELATED', 250068),
(400342, 'PTHR11771:SF152', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400343, 'PTHR11771:SF197', NULL, NULL, NULL, NULL, 'LINOLEATE 9S-LIPOXYGENASE 5-RELATED', 250068),
(400344, 'PTHR11771:SF153', NULL, NULL, NULL, NULL, 'LIPOXYGENASE DOMAIN-CONTAINING PROTEIN', 250068),
(400345, 'PTHR11771:SF150', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400346, 'PTHR11771:SF194', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400347, 'PTHR11771:SF195', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400348, 'PTHR11771:SF192', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400349, 'PTHR11771:SF40', NULL, NULL, NULL, NULL, 'ARACHIDONATE 12-LIPOXYGENASE, 12R-TYPE', 250068),
(400350, 'PTHR11771:SF193', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400351, 'PTHR11771:SF190', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400352, 'PTHR11771:SF191', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400353, 'PTHR11771:SF5', NULL, NULL, NULL, NULL, 'POLYUNSATURATED FATTY ACID 5-LIPOXYGENASE', 250068),
(400354, 'PTHR11771:SF4', NULL, NULL, NULL, NULL, 'POLYUNSATURATED FATTY ACID LIPOXYGENASE ALOX12', 250068),
(400355, 'PTHR11771:SF107', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400356, 'PTHR11771:SF108', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400357, 'PTHR11771:SF34', NULL, NULL, NULL, NULL, 'POLYUNSATURATED FATTY ACID (12S)/(13S)-LIPOXYGENASE, EPIDERMAL-TYPE', 250068),
(400358, 'PTHR11771:SF149', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400359, 'PTHR11771:SF33', NULL, NULL, NULL, NULL, 'POLYUNSATURATED FATTY ACID LIPOXYGENASE ALOX15', 250068),
(400360, 'PTHR11771:SF101', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400361, 'PTHR11771:SF189', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400362, 'PTHR11771:SF146', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400363, 'PTHR11771:SF102', NULL, NULL, NULL, NULL, 'SEED LINOLEATE 13S-LIPOXYGENASE-1', 250068),
(400364, 'PTHR11771:SF187', NULL, NULL, NULL, NULL, 'LINOLEATE 13S-LIPOXYGENASE 2-1, RELATED PROTEIN', 250068),
(400365, 'PTHR11771:SF143', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400366, 'PTHR11771:SF100', NULL, NULL, NULL, NULL, 'LINOLEATE 9S-LIPOXYGENASE B', 250068),
(400367, 'PTHR11771:SF188', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400368, 'PTHR11771:SF142', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400369, 'PTHR11771:SF184', NULL, NULL, NULL, NULL, 'HYDROPEROXIDE ISOMERASE ALOXE3', 250068),
(400370, 'PTHR11771:SF181', NULL, NULL, NULL, NULL, 'LIPOXYGENASE 3, CHLOROPLASTIC', 250068),
(400371, 'PTHR11771', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400372, 'PTHR11771:SF182', NULL, NULL, NULL, NULL, 'LINOLEATE 13S-LIPOXYGENASE 3-1, CHLOROPLASTIC-LIKE', 250068),
(400373, 'PTHR11771:SF180', NULL, NULL, NULL, NULL, 'LIPOXYGENASE DOMAIN-CONTAINING PROTEIN', 250068),
(400374, 'PTHR11771:SF64', NULL, NULL, NULL, NULL, 'LIPOXYGENASE DOMAIN-CONTAINING PROTEIN', 250068),
(400375, 'PTHR11771:SF136', NULL, NULL, NULL, NULL, 'LIPOXYGENASE-RELATED', 250068),
(400376, 'PTHR11771:SF178', NULL, NULL, NULL, NULL, 'LINOLEATE 9S-LIPOXYGENASE A', 250068),
(400377, 'PTHR11771:SF132', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400378, 'PTHR11771:SF177', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400379, 'PTHR11771:SF133', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400380, 'PTHR11771:SF174', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400381, 'PTHR11771:SF131', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400382, 'PTHR11771:SF175', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', 250068),
(400383, 'PTHR38624:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG08397', 250069),
(400384, 'PTHR38624', NULL, NULL, NULL, NULL, 'PROTEIN CBG08397-RELATED', 250069);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(400385, 'PTHR38624:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG07579', 250069),
(400386, 'PTHR38793', NULL, NULL, NULL, NULL, 'SLATT_FUNGAL DOMAIN-CONTAINING PROTEIN-RELATED', 250070),
(400387, 'PTHR38793:SF3', NULL, NULL, NULL, NULL, 'SLATT_FUNGAL DOMAIN-CONTAINING PROTEIN', 250070),
(400388, 'PTHR38793:SF1', NULL, NULL, NULL, NULL, 'SLATT_FUNGAL DOMAIN-CONTAINING PROTEIN', 250070),
(400389, 'PTHR36753:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 250071),
(400390, 'PTHR36753:SF3', NULL, NULL, NULL, NULL, 'BNAC03G70800D PROTEIN', 250071),
(400391, 'PTHR36753', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 250071),
(400392, 'PTHR34299:SF1', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE', 250072),
(400393, 'PTHR34299', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE', 250072),
(400394, 'PTHR23353:SF28', NULL, NULL, NULL, NULL, 'CAMP-INDUCIBLE PRESPORE PROTEIN D7', 250073),
(400395, 'PTHR23353:SF29', NULL, NULL, NULL, NULL, 'SURFACE PROTEIN P12P', 250073),
(400396, 'PTHR23353:SF23', NULL, NULL, NULL, NULL, 'SWIM-TYPE DOMAIN-CONTAINING PROTEIN', 250073),
(400397, 'PTHR23353:SF34', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 24', 250073),
(400398, 'PTHR23353:SF35', NULL, NULL, NULL, NULL, 'SOC2, PUTATIVE-RELATED', 250073),
(400399, 'PTHR23353:SF25', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 24', 250073),
(400400, 'PTHR23353:SF30', NULL, NULL, NULL, NULL, '', 250073),
(400401, 'PTHR23353:SF31', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL GROUP I INTRON SPLICING FACTOR CCM1', 250073),
(400402, 'PTHR23353:SF32', NULL, NULL, NULL, NULL, 'AAC-RICH MRNA CLONE AAC4 PROTEIN-RELATED', 250073),
(400403, 'PTHR23353:SF4', NULL, NULL, NULL, NULL, 'TLDC DOMAIN-CONTAINING PROTEIN', 250073),
(400404, 'PTHR23353', NULL, NULL, NULL, NULL, 'RAB-GAP/TBC-RELATED', 250073),
(400405, 'PTHR23353:SF33', NULL, NULL, NULL, NULL, '', 250073),
(400406, 'PTHR31727:SF9', NULL, NULL, NULL, NULL, 'ACYL-[ACYL-CARRIER-PROTEIN] HYDROLASE', 250074),
(400407, 'PTHR31727:SF5', NULL, NULL, NULL, NULL, 'ACYL-[ACYL-CARRIER-PROTEIN] HYDROLASE', 250074),
(400408, 'PTHR31727:SF6', NULL, NULL, NULL, NULL, 'OLEOYL-ACYL CARRIER PROTEIN THIOESTERASE 1, CHLOROPLASTIC', 250074),
(400409, 'PTHR31727:SF16', NULL, NULL, NULL, NULL, 'OLEOYL-ACYL CARRIER PROTEIN THIOESTERASE 2, CHLOROPLASTIC', 250074),
(400410, 'PTHR31727:SF2', NULL, NULL, NULL, NULL, 'PALMITOYL-ACYL CARRIER PROTEIN THIOESTERASE, CHLOROPLASTIC', 250074),
(400411, 'PTHR31727', NULL, NULL, NULL, NULL, 'OLEOYL-ACYL CARRIER PROTEIN THIOESTERASE 1, CHLOROPLASTIC', 250074),
(400412, 'PTHR31727:SF14', NULL, NULL, NULL, NULL, 'ACYL-[ACYL-CARRIER-PROTEIN] HYDROLASE', 250074),
(400413, 'PTHR31727:SF3', NULL, NULL, NULL, NULL, 'ACYL-[ACYL-CARRIER-PROTEIN] HYDROLASE', 250074),
(400414, 'PTHR31727:SF15', NULL, NULL, NULL, NULL, 'ACYL-[ACYL-CARRIER-PROTEIN] HYDROLASE', 250074),
(400415, 'PTHR31727:SF18', NULL, NULL, NULL, NULL, 'ACYL-[ACYL-CARRIER-PROTEIN] HYDROLASE', 250074),
(400416, 'PTHR31727:SF19', NULL, NULL, NULL, NULL, 'ACYL-[ACYL-CARRIER-PROTEIN] HYDROLASE', 250074),
(400417, 'PTHR31727:SF12', NULL, NULL, NULL, NULL, 'ACYL-[ACYL-CARRIER-PROTEIN] HYDROLASE', 250074),
(400418, 'PTHR31727:SF13', NULL, NULL, NULL, NULL, 'ACYL-[ACYL-CARRIER-PROTEIN] HYDROLASE', 250074),
(400419, 'PTHR31727:SF10', NULL, NULL, NULL, NULL, 'ACYL-[ACYL-CARRIER-PROTEIN] HYDROLASE', 250074),
(400420, 'PTHR31727:SF21', NULL, NULL, NULL, NULL, 'ACYL-[ACYL-CARRIER-PROTEIN] HYDROLASE', 250074),
(400421, 'PTHR31727:SF22', NULL, NULL, NULL, NULL, 'ACYL-[ACYL-CARRIER-PROTEIN] HYDROLASE', 250074),
(400422, 'PTHR31727:SF11', NULL, NULL, NULL, NULL, 'ACYL-[ACYL-CARRIER-PROTEIN] HYDROLASE', 250074),
(400423, 'PTHR43060', NULL, NULL, NULL, NULL, '3-HYDROXYISOBUTYRATE DEHYDROGENASE-LIKE 1, MITOCHONDRIAL-RELATED', 250075),
(400424, 'PTHR43060:SF14', NULL, NULL, NULL, NULL, 'DEHYDROGENASE-LIKE PROTEIN', 250075),
(400425, 'PTHR43060:SF13', NULL, NULL, NULL, NULL, '3-HYDROXYISOBUTYRATE DEHYDROGENASE-LIKE 2, MITOCHONDRIAL-RELATED', 250075),
(400426, 'PTHR43060:SF3', NULL, NULL, NULL, NULL, '2-HYDROXY-3-OXOPROPIONATE REDUCTASE', 250075);
INSERT INTO "PUBLIC"."MODEL" VALUES
(400427, 'PTHR43060:SF17', NULL, NULL, NULL, NULL, 'L-THREONATE DEHYDROGENASE', 250075),
(400428, 'PTHR43060:SF15', NULL, NULL, NULL, NULL, '3-HYDROXYISOBUTYRATE DEHYDROGENASE-LIKE 1, MITOCHONDRIAL-RELATED', 250075),
(400429, 'PTHR14207:SF3', NULL, NULL, NULL, NULL, 'EXPERA DOMAIN-CONTAINING PROTEIN', 250076),
(400430, 'PTHR14207:SF4', NULL, NULL, NULL, NULL, 'EMOPAMIL-BINDING PROTEIN-LIKE', 250076),
(400431, 'PTHR14207:SF1', NULL, NULL, NULL, NULL, 'EMOPAMIL-BINDING PROTEIN-LIKE', 250076),
(400432, 'PTHR14207:SF2', NULL, NULL, NULL, NULL, 'EXPERA DOMAIN-CONTAINING PROTEIN', 250076),
(400433, 'PTHR14207:SF0', NULL, NULL, NULL, NULL, '3-BETA-HYDROXYSTEROID-DELTA(8),DELTA(7)-ISOMERASE', 250076),
(400434, 'PTHR14207', NULL, NULL, NULL, NULL, 'STEROL ISOMERASE', 250076),
(400435, 'PTHR14207:SF7', NULL, NULL, NULL, NULL, 'EXPERA DOMAIN-CONTAINING PROTEIN', 250076),
(400436, 'PTHR14207:SF6', NULL, NULL, NULL, NULL, '3-BETA-HYDROXYSTEROID-DELTA(8)DELTA(7)-ISOMERASE-RELATED', 250076),
(400437, 'PTHR14662:SF2', NULL, NULL, NULL, NULL, 'PARTNER AND LOCALIZER OF BRCA2', 250077),
(400438, 'PTHR14662', NULL, NULL, NULL, NULL, 'PARTNER AND LOCALIZER OF BRCA2', 250077),
(400439, 'PTHR15111', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II SUBUNIT 5-MEDIATING PROTEIN  NNX3', 250078),
(400440, 'PTHR15111:SF1', NULL, NULL, NULL, NULL, 'BNAA08G27560D PROTEIN', 250078),
(400441, 'PTHR15111:SF0', NULL, NULL, NULL, NULL, 'UNCONVENTIONAL PREFOLDIN RPB5 INTERACTOR 1', 250078),
(400442, 'PTHR33233:SF11', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 250079),
(400443, 'PTHR33233:SF12', NULL, NULL, NULL, NULL, '', 250079),
(400444, 'PTHR33233:SF14', NULL, NULL, NULL, NULL, 'ENDONUCLEASE/EXONUCLEASE/PHOSPHATASE', 250079),
(400445, 'PTHR33233:SF15', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 250079),
(400446, 'PTHR33233', NULL, NULL, NULL, NULL, 'ENDONUCLEASE/EXONUCLEASE/PHOSPHATASE', 250079),
(400447, 'PTHR33233:SF16', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 250079),
(400448, 'PTHR11211:SF3', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN MOHAWK', 250080),
(400449, 'PTHR11211:SF16', NULL, NULL, NULL, NULL, 'IROQUOIS-CLASS HOMEODOMAIN PROTEIN IRX-4', 250080),
(400450, 'PTHR11211:SF17', NULL, NULL, NULL, NULL, 'IROQUOIS-CLASS HOMEODOMAIN PROTEIN IRX-5', 250080),
(400451, 'PTHR11211:SF14', NULL, NULL, NULL, NULL, 'IROQUOIS-CLASS HOMEODOMAIN PROTEIN IRX-3', 250080),
(400452, 'PTHR11211:SF15', NULL, NULL, NULL, NULL, 'IROQUOIS-CLASS HOMEODOMAIN PROTEIN IRX-2', 250080),
(400453, 'PTHR11211:SF2', NULL, NULL, NULL, NULL, 'MIRROR, ISOFORM C', 250080),
(400454, 'PTHR11211:SF45', NULL, NULL, NULL, NULL, 'IROQUOIS HOMEOBOX 1B', 250080),
(400455, 'PTHR11211:SF13', NULL, NULL, NULL, NULL, 'IROQUOIS-CLASS HOMEODOMAIN PROTEIN IRX-1', 250080),
(400456, 'PTHR11211:SF11', NULL, NULL, NULL, NULL, 'IROQUOIS-CLASS HOMEODOMAIN PROTEIN IRX-6', 250080),
(400457, 'PTHR11211', NULL, NULL, NULL, NULL, 'IROQUOIS-CLASS HOMEODOMAIN PROTEIN IRX', 250080),
(400458, 'PTHR11211:SF41', NULL, NULL, NULL, NULL, 'IROQUOIS HOMEOBOX 7', 250080),
(400459, 'PTHR11211:SF40', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN ARAUCAN-RELATED', 250080),
(400460, 'PTHR48036:SF11', NULL, NULL, NULL, NULL, '', 250081),
(400461, 'PTHR48036:SF3', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 23-RELATED', 250081),
(400462, 'PTHR48036:SF10', NULL, NULL, NULL, NULL, 'INNER NUCLEAR MEMBRANE PROTEIN MAN1-RELATED', 250081),
(400463, 'PTHR48036:SF8', NULL, NULL, NULL, NULL, 'BNAC09G46800D PROTEIN', 250081),
(400464, 'PTHR48036:SF9', NULL, NULL, NULL, NULL, 'SPLICING FACTOR, CC1-LIKE PROTEIN-RELATED', 250081),
(400465, 'PTHR48036', NULL, NULL, NULL, NULL, 'SPLICING FACTOR (PAD-1), PUTATIVE (AFU_ORTHOLOGUE AFUA_1G15810)-RELATED', 250081),
(400466, 'PTHR48036:SF4', NULL, NULL, NULL, NULL, 'CC1-LIKE SPLICING FACTOR', 250081),
(400467, 'PTHR48036:SF5', NULL, NULL, NULL, NULL, 'SPLICING FACTOR, CC1-LIKE PROTEIN', 250081),
(400468, 'PTHR48036:SF6', NULL, NULL, NULL, NULL, 'RNA-BINDING MOTIF PROTEIN 39A-RELATED', 250081),
(400469, 'PTHR48036:SF7', NULL, NULL, NULL, NULL, 'SPLICING FACTOR CC1-LIKE', 250081);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(400470, 'PTHR15405:SF4', NULL, NULL, NULL, NULL, 'PROLINE-RICH NUCLEAR RECEPTOR COACTIVATOR 1', 250082),
(400471, 'PTHR15405:SF0', NULL, NULL, NULL, NULL, 'AAQUETZALLI, ISOFORM A', 250082),
(400472, 'PTHR15405', NULL, NULL, NULL, NULL, 'PROLINE-RICH NUCLEAR RECEPTOR COACTIVATOR', 250082),
(400473, 'PTHR15405:SF8', NULL, NULL, NULL, NULL, 'PROLINE-RICH NUCLEAR RECEPTOR COACTIVATOR 1', 250082),
(400474, 'PTHR15405:SF7', NULL, NULL, NULL, NULL, 'PROLINE-RICH NUCLEAR RECEPTOR COACTIVATOR 2', 250082),
(400475, 'PTHR15405:SF6', NULL, NULL, NULL, NULL, 'PROLINE-RICH NUCLEAR RECEPTOR COACTIVATOR 2', 250082),
(400476, 'PTHR38366:SF1', NULL, NULL, NULL, NULL, 'PROTEIN TILLER ANGLE CONTROL 1', 250083),
(400477, 'PTHR38366:SF2', NULL, NULL, NULL, NULL, '', 250083),
(400478, 'PTHR38366', NULL, NULL, NULL, NULL, 'NAD-DEPENDENT PROTEIN DEACETYLASE HST1-LIKE PROTEIN', 250083),
(400479, 'PTHR14403', NULL, NULL, NULL, NULL, 'RFAMIDE PEPTIDE GONADOTROPIN INHIBITORY HORMONE', 250084),
(400480, 'PTHR14403:SF6', NULL, NULL, NULL, NULL, 'PRO-FMRFAMIDE-RELATED NEUROPEPTIDE VF', 250084),
(400481, 'PTHR46186:SF14', NULL, NULL, NULL, NULL, 'CYSTATIN CPI-1', 250085),
(400482, 'PTHR46186:SF1', NULL, NULL, NULL, NULL, 'CYSTATIN-D', 250085),
(400483, 'PTHR46186:SF13', NULL, NULL, NULL, NULL, 'SI:BUSM1-57F23.1', 250085),
(400484, 'PTHR46186:SF2', NULL, NULL, NULL, NULL, 'CYSTATIN-RELATED', 250085),
(400485, 'PTHR46186:SF3', NULL, NULL, NULL, NULL, 'CYSTATIN-S-RELATED', 250085),
(400486, 'PTHR46186', NULL, NULL, NULL, NULL, 'CYSTATIN', 250085),
(400487, 'PTHR46186:SF4', NULL, NULL, NULL, NULL, 'CYSTATIN 10', 250085),
(400488, 'PTHR46186:SF5', NULL, NULL, NULL, NULL, 'CYSTATIN-SN', 250085),
(400489, 'PTHR46186:SF6', NULL, NULL, NULL, NULL, 'CYSTATIN-C', 250085),
(400490, 'PTHR46186:SF12', NULL, NULL, NULL, NULL, 'CYSTATIN C (AMYLOID ANGIOPATHY AND CEREBRAL HEMORRHAGE)-RELATED', 250085),
(400491, 'PTHR46186:SF10', NULL, NULL, NULL, NULL, 'CYSTATIN-C', 250085),
(400492, 'PTHR31072:SF218', NULL, NULL, NULL, NULL, 'OS02G0747400 PROTEIN', 250086),
(400493, 'PTHR31072:SF215', NULL, NULL, NULL, NULL, 'TCP DOMAIN-CONTAINING PROTEIN', 250086),
(400494, 'PTHR31072:SF216', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP8-LIKE', 250086),
(400495, 'PTHR31072:SF139', NULL, NULL, NULL, NULL, 'TCP DOMAIN-CONTAINING PROTEIN', 250086),
(400496, 'PTHR31072:SF255', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP14-RELATED', 250086),
(400497, 'PTHR31072:SF179', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP21', 250086),
(400498, 'PTHR31072:SF253', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP3', 250086),
(400499, 'PTHR31072:SF132', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP17-LIKE', 250086),
(400500, 'PTHR31072:SF254', NULL, NULL, NULL, NULL, 'TCP FAMILY TRANSCRIPTION FACTOR', 250086),
(400501, 'PTHR31072:SF210', NULL, NULL, NULL, NULL, 'TCP DOMAIN-CONTAINING PROTEIN', 250086),
(400502, 'PTHR31072:SF251', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP8', 250086),
(400503, 'PTHR31072:SF252', NULL, NULL, NULL, NULL, 'TCP DOMAIN-CONTAINING PROTEIN', 250086),
(400504, 'PTHR31072:SF131', NULL, NULL, NULL, NULL, 'TCP DOMAIN-CONTAINING PROTEIN', 250086),
(400505, 'PTHR31072:SF183', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PCF2', 250086),
(400506, 'PTHR31072:SF184', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP14', 250086),
(400507, 'PTHR31072:SF140', NULL, NULL, NULL, NULL, 'CYCLOIDEA-LIKE 2B PROTEIN', 250086),
(400508, 'PTHR31072:SF87', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TB1', 250086),
(400509, 'PTHR31072:SF228', NULL, NULL, NULL, NULL, 'TCP DOMAIN-CONTAINING PROTEIN', 250086),
(400510, 'PTHR31072:SF229', NULL, NULL, NULL, NULL, 'TCP DOMAIN-CONTAINING PROTEIN', 250086),
(400511, 'PTHR31072:SF108', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP23-LIKE', 250086),
(400512, 'PTHR31072:SF105', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PCF3', 250086),
(400513, 'PTHR31072:SF149', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP5', 250086),
(400514, 'PTHR31072:SF226', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP18', 250086);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(400515, 'PTHR31072:SF227', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP12', 250086),
(400516, 'PTHR31072:SF147', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP13', 250086),
(400517, 'PTHR31072:SF224', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP1', 250086),
(400518, 'PTHR31072:SF148', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, TCP-RELATED', 250086),
(400519, 'PTHR31072:SF225', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP4', 250086),
(400520, 'PTHR31072:SF102', NULL, NULL, NULL, NULL, 'TCP DOMAIN-CONTAINING PROTEIN', 250086),
(400521, 'PTHR31072:SF223', NULL, NULL, NULL, NULL, 'CYCLOIDEA-LIKE PROTEIN', 250086),
(400522, 'PTHR31072:SF15', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP9-LIKE', 250086),
(400523, 'PTHR31072:SF146', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, TCP-RELATED', 250086),
(400524, 'PTHR31072:SF187', NULL, NULL, NULL, NULL, '', 250086),
(400525, 'PTHR31072:SF143', NULL, NULL, NULL, NULL, 'TCP DOMAIN-CONTAINING PROTEIN', 250086),
(400526, 'PTHR31072:SF188', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP12-LIKE', 250086),
(400527, 'PTHR31072:SF100', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP22', 250086),
(400528, 'PTHR31072:SF185', NULL, NULL, NULL, NULL, 'TEOSINTE BRANCHED 1, CYCLOIDEA AND PCF TRANSCRIPTION FACTOR 5-RELATED', 250086),
(400529, 'PTHR31072:SF186', NULL, NULL, NULL, NULL, 'TCP DOMAIN-CONTAINING PROTEIN', 250086),
(400530, 'PTHR31072:SF194', NULL, NULL, NULL, NULL, 'BNAC05G51920D PROTEIN', 250086),
(400531, 'PTHR31072:SF93', NULL, NULL, NULL, NULL, 'OS07G0152000 PROTEIN', 250086),
(400532, 'PTHR31072:SF151', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, TCP-RELATED', 250086),
(400533, 'PTHR31072:SF190', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP20-LIKE', 250086),
(400534, 'PTHR31072:SF98', NULL, NULL, NULL, NULL, '', 250086),
(400535, 'PTHR31072:SF97', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP4-LIKE', 250086),
(400536, 'PTHR31072:SF91', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP11-RELATED', 250086),
(400537, 'PTHR31072:SF239', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP7', 250086),
(400538, 'PTHR31072:SF237', NULL, NULL, NULL, NULL, 'TCP DOMAIN-CONTAINING PROTEIN', 250086),
(400539, 'PTHR31072', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP4-RELATED', 250086),
(400540, 'PTHR31072:SF238', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PCF7', 250086),
(400541, 'PTHR31072:SF114', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PCF6', 250086),
(400542, 'PTHR31072:SF235', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP23-LIKE', 250086),
(400543, 'PTHR31072:SF236', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP7-LIKE', 250086),
(400544, 'PTHR31072:SF233', NULL, NULL, NULL, NULL, 'TCP DOMAIN-CONTAINING PROTEIN', 250086),
(400545, 'PTHR31072:SF234', NULL, NULL, NULL, NULL, 'OS09G0521300 PROTEIN', 250086),
(400546, 'PTHR31072:SF231', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP17', 250086),
(400547, 'PTHR31072:SF232', NULL, NULL, NULL, NULL, 'TCP FAMILY TRANSCRIPTION FACTOR-RELATED', 250086),
(400548, 'PTHR31072:SF230', NULL, NULL, NULL, NULL, 'TCP FAMILY TRANSCRIPTION FACTOR', 250086),
(400549, 'PTHR31072:SF1', NULL, NULL, NULL, NULL, 'TCP DOMAIN-CONTAINING PROTEIN', 250086),
(400550, 'PTHR31072:SF162', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP2', 250086),
(400551, 'PTHR31072:SF160', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP9', 250086),
(400552, 'PTHR31072:SF65', NULL, NULL, NULL, NULL, 'OS09G0410500 PROTEIN', 250086),
(400553, 'PTHR31072:SF4', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP20', 250086),
(400554, 'PTHR31072:SF23', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PCF8', 250086),
(400555, 'PTHR31072:SF7', NULL, NULL, NULL, NULL, 'OS02G0828566 PROTEIN', 250086),
(400556, 'PTHR31072:SF204', NULL, NULL, NULL, NULL, 'TCP DOMAIN-CONTAINING PROTEIN', 250086),
(400557, 'PTHR31072:SF248', NULL, NULL, NULL, NULL, 'OS12G0173300 PROTEIN', 250086),
(400558, 'PTHR31072:SF249', NULL, NULL, NULL, NULL, 'TCP DOMAIN-CONTAINING PROTEIN', 250086),
(400559, 'PTHR31072:SF128', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR CYCLOIDEA-LIKE', 250086);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(400560, 'PTHR31072:SF246', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, TCP-RELATED', 250086),
(400561, 'PTHR31072:SF125', NULL, NULL, NULL, NULL, 'TCP DOMAIN-CONTAINING PROTEIN', 250086),
(400562, 'PTHR31072:SF202', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP9-LIKE', 250086),
(400563, 'PTHR31072:SF126', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP24', 250086),
(400564, 'PTHR31072:SF247', NULL, NULL, NULL, NULL, 'TCP DOMAIN-CONTAINING PROTEIN', 250086),
(400565, 'PTHR31072:SF167', NULL, NULL, NULL, NULL, 'TCP DOMAIN-CONTAINING PROTEIN', 250086),
(400566, 'PTHR31072:SF123', NULL, NULL, NULL, NULL, 'TCP DOMAIN-CONTAINING PROTEIN', 250086),
(400567, 'PTHR31072:SF244', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP FAMILY-RELATED', 250086),
(400568, 'PTHR31072:SF168', NULL, NULL, NULL, NULL, 'TCP DOMAIN-CONTAINING PROTEIN', 250086),
(400569, 'PTHR31072:SF245', NULL, NULL, NULL, NULL, 'OS05G0513100 PROTEIN', 250086),
(400570, 'PTHR31072:SF242', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP19', 250086),
(400571, 'PTHR31072:SF121', NULL, NULL, NULL, NULL, 'TCP DOMAIN-CONTAINING PROTEIN', 250086),
(400572, 'PTHR31072:SF243', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PCF1-LIKE', 250086),
(400573, 'PTHR31072:SF240', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP10', 250086),
(400574, 'PTHR31072:SF120', NULL, NULL, NULL, NULL, 'OS04G0526000 PROTEIN', 250086),
(400575, 'PTHR31072:SF241', NULL, NULL, NULL, NULL, 'OS08G0432300 PROTEIN', 250086),
(400576, 'PTHR31072:SF250', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP14-LIKE', 250086),
(400577, 'PTHR31072:SF170', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP15', 250086),
(400578, 'PTHR31072:SF171', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, TCP-RELATED', 250086),
(400579, 'PTHR31072:SF31', NULL, NULL, NULL, NULL, 'OS02G0635800 PROTEIN', 250086),
(400580, 'PTHR15323:SF8', NULL, NULL, NULL, NULL, '', 250087),
(400581, 'PTHR15323', NULL, NULL, NULL, NULL, 'D123 PROTEIN', 250087),
(400582, 'PTHR15323:SF6', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE PROTEIN 123 HOMOLOG', 250087),
(400583, 'PTHR43527:SF2', NULL, NULL, NULL, NULL, '4-DIPHOSPHOCYTIDYL-2-C-METHYL-D-ERYTHRITOL KINASE, CHLOROPLASTIC', 250088),
(400584, 'PTHR43527', NULL, NULL, NULL, NULL, '4-DIPHOSPHOCYTIDYL-2-C-METHYL-D-ERYTHRITOL KINASE, CHLOROPLASTIC', 250088),
(400585, 'PTHR43527:SF1', NULL, NULL, NULL, NULL, 'L-THREONINE KINASE', 250088),
(400586, 'PTHR30178:SF3', NULL, NULL, NULL, NULL, 'SUCCINATE-ACETATE/PROTON SYMPORTER SATP', 250089),
(400587, 'PTHR30178', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YAAH', 250089),
(400588, 'PTHR35126:SF1', NULL, NULL, NULL, NULL, 'SLR0598 PROTEIN', 250090),
(400589, 'PTHR35126', NULL, NULL, NULL, NULL, 'SLR0598 PROTEIN', 250090),
(400590, 'PTHR43716:SF1', NULL, NULL, NULL, NULL, 'D-2-HYDROXYGLUTARATE DEHYDROGENASE, MITOCHONDRIAL', 250091),
(400591, 'PTHR43716:SF2', NULL, NULL, NULL, NULL, 'BLL6224 PROTEIN', 250091),
(400592, 'PTHR43716', NULL, NULL, NULL, NULL, 'D-2-HYDROXYGLUTARATE DEHYDROGENASE, MITOCHONDRIAL', 250091),
(400593, 'PTHR45650:SF70', NULL, NULL, NULL, NULL, 'GDSL-LIPASE PROTEIN', 250092),
(400594, 'PTHR45650:SF73', NULL, NULL, NULL, NULL, 'SGNH HYDROLASE-TYPE ESTERASE DOMAIN-CONTAINING PROTEIN-RELATED', 250092),
(400595, 'PTHR45650:SF79', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE 7', 250092),
(400596, 'PTHR45650:SF78', NULL, NULL, NULL, NULL, 'SGNH HYDROLASE-TYPE ESTERASE DOMAIN-CONTAINING PROTEIN-RELATED', 250092),
(400597, 'PTHR45650:SF37', NULL, NULL, NULL, NULL, 'SGNH HYDROLASE-TYPE ESTERASE SUPERFAMILY PROTEIN', 250092),
(400598, 'PTHR45650', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE-RELATED', 250092),
(400599, 'PTHR45650:SF36', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 250092),
(400600, 'PTHR45650:SF31', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 250092),
(400601, 'PTHR45650:SF75', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 250092),
(400602, 'PTHR45650:SF77', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 250092),
(400603, 'PTHR45650:SF33', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 250092);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(400604, 'PTHR45650:SF32', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 250092),
(400605, 'PTHR45650:SF76', NULL, NULL, NULL, NULL, 'SGNH HYDROLASE-TYPE ESTERASE DOMAIN-CONTAINING PROTEIN-RELATED', 250092),
(400606, 'PTHR45650:SF82', NULL, NULL, NULL, NULL, 'GDSL-LIPASE 1', 250092),
(400607, 'PTHR45650:SF81', NULL, NULL, NULL, NULL, '', 250092),
(400608, 'PTHR45650:SF40', NULL, NULL, NULL, NULL, '', 250092),
(400609, 'PTHR45650:SF84', NULL, NULL, NULL, NULL, 'LIPASE/ACYLHYDROLASE SUPERFAMILY PROTEIN, PUTATIVE-RELATED', 250092),
(400610, 'PTHR45650:SF83', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 250092),
(400611, 'PTHR45650:SF80', NULL, NULL, NULL, NULL, 'FINGER PROTEIN, PUTATIVE-RELATED', 250092),
(400612, 'PTHR45650:SF42', NULL, NULL, NULL, NULL, 'BNAA07G01300D PROTEIN', 250092),
(400613, 'PTHR45650:SF86', NULL, NULL, NULL, NULL, '', 250092),
(400614, 'PTHR45650:SF41', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 250092),
(400615, 'PTHR45650:SF85', NULL, NULL, NULL, NULL, 'LIPASE/ACYLHYDROLASE SUPERFAMILY PROTEIN, PUTATIVE-RELATED', 250092),
(400616, 'PTHR45650:SF44', NULL, NULL, NULL, NULL, 'BNAA02G27380D PROTEIN', 250092),
(400617, 'PTHR45650:SF43', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE 7-LIKE', 250092),
(400618, 'PTHR45650:SF51', NULL, NULL, NULL, NULL, 'BNAA05G17780D PROTEIN', 250092),
(400619, 'PTHR45650:SF50', NULL, NULL, NULL, NULL, 'SGNH HYDROLASE-TYPE ESTERASE DOMAIN-CONTAINING PROTEIN-RELATED', 250092),
(400620, 'PTHR45650:SF13', NULL, NULL, NULL, NULL, 'OS05G0518300 PROTEIN', 250092),
(400621, 'PTHR45650:SF57', NULL, NULL, NULL, NULL, 'BNAC09G22170D PROTEIN', 250092),
(400622, 'PTHR45650:SF56', NULL, NULL, NULL, NULL, 'SGNH HYDROLASE-TYPE ESTERASE DOMAIN-CONTAINING PROTEIN-RELATED', 250092),
(400623, 'PTHR45650:SF12', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE', 250092),
(400624, 'PTHR45650:SF59', NULL, NULL, NULL, NULL, 'BNAA02G27390D PROTEIN', 250092),
(400625, 'PTHR45650:SF14', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE 7-LIKE', 250092),
(400626, 'PTHR45650:SF58', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 250092),
(400627, 'PTHR45650:SF55', NULL, NULL, NULL, NULL, '', 250092),
(400628, 'PTHR45650:SF54', NULL, NULL, NULL, NULL, '', 250092),
(400629, 'PTHR45650:SF16', NULL, NULL, NULL, NULL, 'OS02G0732800 PROTEIN', 250092),
(400630, 'PTHR45650:SF61', NULL, NULL, NULL, NULL, 'BNAA09G17740D PROTEIN', 250092),
(400631, 'PTHR45650:SF68', NULL, NULL, NULL, NULL, '', 250092),
(400632, 'PTHR45650:SF24', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE 7-LIKE', 250092),
(400633, 'PTHR45650:SF67', NULL, NULL, NULL, NULL, 'BNAC03G59270D PROTEIN', 250092),
(400634, 'PTHR45650:SF23', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 250092),
(400635, 'PTHR45650:SF26', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 250092),
(400636, 'PTHR45650:SF25', NULL, NULL, NULL, NULL, 'BNAA08G13200D PROTEIN', 250092),
(400637, 'PTHR45650:SF20', NULL, NULL, NULL, NULL, '', 250092),
(400638, 'PTHR45650:SF63', NULL, NULL, NULL, NULL, 'BNAA07G07790D PROTEIN', 250092),
(400639, 'PTHR45650:SF22', NULL, NULL, NULL, NULL, 'OS05G0419800 PROTEIN', 250092),
(400640, 'PTHR45650:SF21', NULL, NULL, NULL, NULL, 'BNACNNG39320D PROTEIN', 250092),
(400641, 'PTHR45650:SF5', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 250092),
(400642, 'PTHR45650:SF4', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE FAMILY PROTEIN, EXPRESSED', 250092),
(400643, 'PTHR45650:SF3', NULL, NULL, NULL, NULL, 'OS01G0748500 PROTEIN', 250092),
(400644, 'PTHR45650:SF9', NULL, NULL, NULL, NULL, 'FINGER PROTEIN, PUTATIVE-RELATED', 250092),
(400645, 'PTHR45650:SF27', NULL, NULL, NULL, NULL, 'BNAANNG05710D PROTEIN', 250092),
(400646, 'PTHR45650:SF8', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 250092),
(400647, 'PTHR45650:SF7', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE', 250092),
(400648, 'PTHR45650:SF2', NULL, NULL, NULL, NULL, 'OS06G0560700 PROTEIN', 250092),
(400649, 'PTHR45650:SF1', NULL, NULL, NULL, NULL, 'OS08G0112900 PROTEIN', 250092),
(400650, 'PTHR40124:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250093);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(400651, 'PTHR40124', NULL, NULL, NULL, NULL, '', 250093),
(400652, 'PTHR47951:SF7', NULL, NULL, NULL, NULL, 'FERRUGINOL SYNTHASE-LIKE', 250094),
(400653, 'PTHR47951:SF8', NULL, NULL, NULL, NULL, 'FLAVONOID 3''-MONOOXYGENASE-LIKE', 250094),
(400654, 'PTHR47951:SF5', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 706 SUBFAMILY A POLYPEPTIDE 5', 250094),
(400655, 'PTHR47951:SF6', NULL, NULL, NULL, NULL, '', 250094),
(400656, 'PTHR47951:SF3', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 706, SUBFAMILY A, POLYPEPTIDE 3-RELATED', 250094),
(400657, 'PTHR47951:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 - LIKE PROTEIN-RELATED', 250094),
(400658, 'PTHR47951', NULL, NULL, NULL, NULL, 'OS08G0547900 PROTEIN', 250094),
(400659, 'PTHR47951:SF9', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 706, SUBFAMILY A, POLYPEPTIDE 4', 250094),
(400660, 'PTHR47454', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 224', 250095),
(400661, 'PTHR47454:SF1', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 224', 250095),
(400662, 'PTHR35102:SF5', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 250096),
(400663, 'PTHR35102:SF4', NULL, NULL, NULL, NULL, '', 250096),
(400664, 'PTHR35102:SF6', NULL, NULL, NULL, NULL, 'DUF2062 DOMAIN-CONTAINING PROTEIN', 250096),
(400665, 'PTHR35102', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE', 250096),
(400666, 'PTHR35102:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE', 250096),
(400667, 'PTHR21039:SF0', NULL, NULL, NULL, NULL, 'HISTIDINOL-PHOSPHATASE', 250097),
(400668, 'PTHR21039', NULL, NULL, NULL, NULL, 'HISTIDINOL PHOSPHATASE-RELATED', 250097),
(400669, 'PTHR37932:SF1', NULL, NULL, NULL, NULL, 'SMALL LYSINE-RICH PROTEIN 1', 250098),
(400670, 'PTHR37932', NULL, NULL, NULL, NULL, 'SMALL LYSINE-RICH PROTEIN 1', 250098),
(400671, 'PTHR42679:SF2', NULL, NULL, NULL, NULL, 'S-METHYL-5''-THIOADENOSINE PHOSPHORYLASE', 250099),
(400672, 'PTHR42679:SF3', NULL, NULL, NULL, NULL, 'S-METHYL-5''-THIOADENOSINE PHOSPHORYLASE', 250099),
(400673, 'PTHR42679:SF4', NULL, NULL, NULL, NULL, 'S-METHYL-5''-THIOADENOSINE PHOSPHORYLASE', 250099),
(400674, 'PTHR42679:SF5', NULL, NULL, NULL, NULL, 'PURINE NUCLEOSIDE PHOSPHORYLASE', 250099),
(400675, 'PTHR42679', NULL, NULL, NULL, NULL, 'S-METHYL-5''-THIOADENOSINE PHOSPHORYLASE', 250099),
(400676, 'PTHR42800:SF3', NULL, NULL, NULL, NULL, 'CHROMOSOME 9, WHOLE GENOME SHOTGUN SEQUENCE', 250100),
(400677, 'PTHR42800:SF2', NULL, NULL, NULL, NULL, 'INVERTASE 2', 250100),
(400678, 'PTHR42800:SF1', NULL, NULL, NULL, NULL, 'EXOINULINASE INUD (AFU_ORTHOLOGUE AFUA_5G00480)', 250100),
(400679, 'PTHR42800', NULL, NULL, NULL, NULL, 'EXOINULINASE INUD (AFU_ORTHOLOGUE AFUA_5G00480)', 250100),
(400680, 'PTHR46334:SF1', NULL, NULL, NULL, NULL, 'COSTARS FAMILY PROTEIN ABRACL', 250101),
(400681, 'PTHR46334:SF3', NULL, NULL, NULL, NULL, 'COSTARS FAMILY PROTEIN-LIKE', 250101),
(400682, 'PTHR46334', NULL, NULL, NULL, NULL, 'COSTARS FAMILY PROTEIN ABRACL', 250101),
(400683, 'PTHR15362:SF38', NULL, NULL, NULL, NULL, 'CDP-DIACYLGLYCEROL--INOSITOL 3-PHOSPHATIDYLTRANSFERASE', 250102),
(400684, 'PTHR15362:SF15', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLSERINE SYNTHASE 1', 250102),
(400685, 'PTHR15362:SF37', NULL, NULL, NULL, NULL, 'CDP-DIACYLGLYCEROL--SERINE O-PHOSPHATIDYLTRANSFERASE 1-LIKE', 250102),
(400686, 'PTHR15362:SF29', NULL, NULL, NULL, NULL, 'CDP-DIACYLGLYCEROL--INOSITOL 3-PHOSPHATIDYLTRANSFERASE', 250102),
(400687, 'PTHR15362', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL SYNTHASE', 250102),
(400688, 'PTHR15362:SF34', NULL, NULL, NULL, NULL, 'PHOSPHATIDYL SERINE SYNTHASE FAMILY PROTEIN-RELATED', 250102),
(400689, 'PTHR15362:SF33', NULL, NULL, NULL, NULL, 'L-SERINE-PHOSPHATIDYLETHANOLAMINE PHOSPHATIDYLTRANSFERASE', 250102),
(400690, 'PTHR15362:SF25', NULL, NULL, NULL, NULL, 'CDP-DIACYLGLYCEROL--INOSITOL 3-PHOSPHATIDYLTRANSFERASE 1', 250102),
(400691, 'PTHR15362:SF36', NULL, NULL, NULL, NULL, '', 250102),
(400692, 'PTHR15362:SF35', NULL, NULL, NULL, NULL, 'L-SERINE-PHOSPHATIDYLETHANOLAMINE PHOSPHATIDYLTRANSFERASE', 250102),
(400693, 'PTHR15362:SF13', NULL, NULL, NULL, NULL, 'SI:CH1073-145M9.1', 250102);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(400694, 'PTHR15362:SF4', NULL, NULL, NULL, NULL, 'CDP-DIACYLGLYCEROL--INOSITOL 3-PHOSPHATIDYLTRANSFERASE', 250102),
(400695, 'PTHR15362:SF7', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLSERINE SYNTHASE 2', 250102),
(400696, 'PTHR15362:SF32', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLSERINE SYNTHASE 1', 250102),
(400697, 'PTHR15362:SF20', NULL, NULL, NULL, NULL, 'CDP-DIACYLGLYCEROL--SERINE O-PHOSPHATIDYLTRANSFERASE 3', 250102),
(400698, 'PTHR10314:SF222', NULL, NULL, NULL, NULL, 'CYSTEINE SYNTHASE', 250103),
(400699, 'PTHR10314:SF244', NULL, NULL, NULL, NULL, 'CYSTEINE SYNTHASE', 250103),
(400700, 'PTHR10314:SF245', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL L-3-CYANOALANINE SYNTHASE/CYSTEINE SYNTHASE D2', 250103),
(400701, 'PTHR10314:SF102', NULL, NULL, NULL, NULL, 'CYSTEINE SYNTHASE-RELATED', 250103),
(400702, 'PTHR10314:SF201', NULL, NULL, NULL, NULL, 'CYSTEINE SYNTHASE', 250103),
(400703, 'PTHR10314:SF165', NULL, NULL, NULL, NULL, 'OS06G0149700 PROTEIN', 250103),
(400704, 'PTHR10314:SF242', NULL, NULL, NULL, NULL, 'O-ACETYLSERINE DEPENDENT CYSTATHIONINE BETA-SYNTHASE', 250103),
(400705, 'PTHR10314:SF221', NULL, NULL, NULL, NULL, 'CYSTEINE SYNTHASE', 250103),
(400706, 'PTHR10314:SF243', NULL, NULL, NULL, NULL, 'SYNTHASE B, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G03930)-RELATED', 250103),
(400707, 'PTHR10314:SF163', NULL, NULL, NULL, NULL, 'CYSTATHIONINE BETA-SYNTHASE', 250103),
(400708, 'PTHR10314:SF240', NULL, NULL, NULL, NULL, 'CYSTEINE SYNTHASE', 250103),
(400709, 'PTHR10314:SF241', NULL, NULL, NULL, NULL, 'CYSTEINE SYNTHASE 1', 250103),
(400710, 'PTHR10314:SF162', NULL, NULL, NULL, NULL, 'CYSTEINE SYNTHASE B', 250103),
(400711, 'PTHR10314:SF5', NULL, NULL, NULL, NULL, 'THREONINE SYNTHASE 1, CHLOROPLASTIC', 250103),
(400712, 'PTHR10314:SF180', NULL, NULL, NULL, NULL, 'OS06G0564400 PROTEIN', 250103),
(400713, 'PTHR10314:SF90', NULL, NULL, NULL, NULL, 'S-SULFO-L-CYSTEINE SYNTHASE (O-ACETYL-L-SERINE-DEPENDENT), CHLOROPLASTIC', 250103),
(400714, 'PTHR10314:SF71', NULL, NULL, NULL, NULL, 'CYSTEINE SYNTHASE-RELATED', 250103),
(400715, 'PTHR10314:SF208', NULL, NULL, NULL, NULL, 'CYSTEINE SYNTHASE', 250103),
(400716, 'PTHR10314:SF206', NULL, NULL, NULL, NULL, 'CYSTEINE SYNTHASE', 250103),
(400717, 'PTHR10314:SF204', NULL, NULL, NULL, NULL, 'CYSTEINE SYNTHASE 1-RELATED', 250103),
(400718, 'PTHR10314:SF205', NULL, NULL, NULL, NULL, 'CYSTEINE SYNTHASE', 250103),
(400719, 'PTHR10314:SF224', NULL, NULL, NULL, NULL, 'THREONINE SYNTHASE', 250103),
(400720, 'PTHR10314:SF225', NULL, NULL, NULL, NULL, 'THREONINE SYNTHASE', 250103),
(400721, 'PTHR10314:SF203', NULL, NULL, NULL, NULL, 'CYSTEINE SYNTHASE', 250103),
(400722, 'PTHR10314:SF178', NULL, NULL, NULL, NULL, 'O-ACETYLSERINE (THIOL) LYASE', 250103),
(400723, 'PTHR10314:SF211', NULL, NULL, NULL, NULL, 'CYSTEINE SYNTHASE 1', 250103),
(400724, 'PTHR10314:SF135', NULL, NULL, NULL, NULL, 'PALP DOMAIN-CONTAINING PROTEIN-RELATED', 250103),
(400725, 'PTHR10314:SF212', NULL, NULL, NULL, NULL, 'PALP DOMAIN-CONTAINING PROTEIN', 250103),
(400726, 'PTHR10314:SF210', NULL, NULL, NULL, NULL, 'PALP DOMAIN-CONTAINING PROTEIN', 250103),
(400727, 'PTHR10314:SF196', NULL, NULL, NULL, NULL, 'SYNTHASE, PUTATIVE-RELATED', 250103),
(400728, 'PTHR10314:SF194', NULL, NULL, NULL, NULL, 'CYSTATHIONINE BETA-SYNTHASE', 250103),
(400729, 'PTHR10314:SF173', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL L-3-CYANOALANINE SYNTHASE/CYSTEINE SYNTHASE 2, MITOCHONDRIAL', 250103),
(400730, 'PTHR10314:SF195', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL L-3-CYANOALANINE SYNTHASE/CYSTEINE SYNTHASE D1', 250103),
(400731, 'PTHR10314:SF170', NULL, NULL, NULL, NULL, 'PALP DOMAIN-CONTAINING PROTEIN', 250103),
(400732, 'PTHR10314:SF96', NULL, NULL, NULL, NULL, 'THREONINE SYNTHASE', 250103),
(400733, 'PTHR10314:SF190', NULL, NULL, NULL, NULL, 'CYSTEINE SYNTHASE, CHLOROPLASTIC/CHROMOPLASTIC', 250103),
(400734, 'PTHR10314:SF191', NULL, NULL, NULL, NULL, 'CYSTATHIONINE BETA-SYNTHASE', 250103),
(400735, 'PTHR10314:SF35', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CYSTEINE SYNTHASE-RELATED', 250103),
(400736, 'PTHR10314:SF81', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL L-3-CYANOALANINE SYNTHASE/CYSTEINE SYNTHASE', 250103);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(400737, 'PTHR10314:SF80', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL L-3-CYANOALANINE SYNTHASE/CYSTEINE SYNTHASE C1, MITOCHONDRIAL', 250103),
(400738, 'PTHR10314', NULL, NULL, NULL, NULL, 'CYSTATHIONINE BETA-SYNTHASE', 250103),
(400739, 'PTHR10314:SF219', NULL, NULL, NULL, NULL, 'CYSTEINE SYNTHASE', 250103),
(400740, 'PTHR10314:SF239', NULL, NULL, NULL, NULL, 'THREONINE SYNTHASE', 250103),
(400741, 'PTHR10314:SF217', NULL, NULL, NULL, NULL, 'THREONINE SYNTHASE', 250103),
(400742, 'PTHR10314:SF237', NULL, NULL, NULL, NULL, 'CYSTATHIONINE BETA-SYNTHASE-RELATED', 250103),
(400743, 'PTHR10314:SF216', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL CYSTATHIONINE GAMMA-LYASE/CYSTEINE SYNTHASE', 250103),
(400744, 'PTHR10314:SF238', NULL, NULL, NULL, NULL, 'THREONINE SYNTHASE 2, CHLOROPLASTIC', 250103),
(400745, 'PTHR10314:SF236', NULL, NULL, NULL, NULL, 'THREONINE SYNTHASE', 250103),
(400746, 'PTHR10759:SF19', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L34', 250104),
(400747, 'PTHR10759:SF18', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L34E SUPERFAMILY PROTEIN-RELATED', 250104),
(400748, 'PTHR10759:SF17', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L34-RELATED', 250104),
(400749, 'PTHR10759:SF16', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L34', 250104),
(400750, 'PTHR10759:SF15', NULL, NULL, NULL, NULL, '60S RIBOSOMAL L34-LIKE PROTEIN', 250104),
(400751, 'PTHR10759:SF14', NULL, NULL, NULL, NULL, '', 250104),
(400752, 'PTHR10759:SF12', NULL, NULL, NULL, NULL, 'BNAA09G02410D PROTEIN', 250104),
(400753, 'PTHR10759:SF10', NULL, NULL, NULL, NULL, 'BNAA08G19980D PROTEIN', 250104),
(400754, 'PTHR10759', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L34', 250104),
(400755, 'PTHR10759:SF20', NULL, NULL, NULL, NULL, '', 250104),
(400756, 'PTHR10759:SF7', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L34', 250104),
(400757, 'PTHR10759:SF8', NULL, NULL, NULL, NULL, 'OS08G0436800 PROTEIN', 250104),
(400758, 'PTHR10759:SF9', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L34', 250104),
(400759, 'PTHR10759:SF4', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L34, PUTATIVE-RELATED', 250104),
(400760, 'PTHR10759:SF5', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L34-1-RELATED', 250104),
(400761, 'PTHR10759:SF6', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L34', 250104),
(400762, 'PTHR10759:SF0', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L34', 250104),
(400763, 'PTHR10759:SF2', NULL, NULL, NULL, NULL, '', 250104),
(400764, 'PTHR37706', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 250105),
(400765, 'PTHR37706:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 250105),
(400766, 'PTHR47656:SF1', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN MIXL1', 250106),
(400767, 'PTHR47656', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN MIXL', 250106),
(400768, 'PTHR30303:SF4', NULL, NULL, NULL, NULL, 'HYDROGENASE EXPRESSION/FORMATION PROTEIN HYPE', 250107),
(400769, 'PTHR30303', NULL, NULL, NULL, NULL, 'HYDROGENASE ISOENZYMES FORMATION PROTEIN HYPE', 250107),
(400770, 'PTHR30303:SF0', NULL, NULL, NULL, NULL, 'CARBAMOYL DEHYDRATASE HYPE', 250107),
(400771, 'PTHR47383:SF3', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN-RELATED', 250108),
(400772, 'PTHR47383:SF2', NULL, NULL, NULL, NULL, 'OS04G0616000 PROTEIN', 250108),
(400773, 'PTHR47383:SF7', NULL, NULL, NULL, NULL, '', 250108),
(400774, 'PTHR47383:SF6', NULL, NULL, NULL, NULL, 'RECA_3 DOMAIN-CONTAINING PROTEIN', 250108),
(400775, 'PTHR47383:SF5', NULL, NULL, NULL, NULL, 'BNAANNG18970D PROTEIN', 250108),
(400776, 'PTHR47383', NULL, NULL, NULL, NULL, 'OS03G0659800 PROTEIN', 250108),
(400777, 'PTHR47383:SF4', NULL, NULL, NULL, NULL, '', 250108),
(400778, 'PTHR47383:SF9', NULL, NULL, NULL, NULL, '', 250108),
(400779, 'PTHR47383:SF8', NULL, NULL, NULL, NULL, 'OS01G0768300 PROTEIN', 250108),
(400780, 'PTHR10784:SF7', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 6', 250109),
(400781, 'PTHR10784:SF8', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 6', 250109),
(400782, 'PTHR10784:SF9', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 6', 250109);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(400783, 'PTHR10784:SF3', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 6', 250109),
(400784, 'PTHR10784', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 6', 250109),
(400785, 'PTHR10784:SF6', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 6', 250109),
(400786, 'PTHR10784:SF10', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 6', 250109),
(400787, 'PTHR10784:SF0', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 6', 250109),
(400788, 'PTHR36723:SF1', NULL, NULL, NULL, NULL, 'F22C12.19', 250110),
(400789, 'PTHR36723', NULL, NULL, NULL, NULL, 'F22C12.19', 250110),
(400790, 'PTHR33889:SF1', NULL, NULL, NULL, NULL, 'OS06G0345050 PROTEIN', 250111),
(400791, 'PTHR33889', NULL, NULL, NULL, NULL, 'OS04G0681850 PROTEIN', 250111),
(400792, 'PTHR33889:SF7', NULL, NULL, NULL, NULL, 'OS04G0681850 PROTEIN', 250111),
(400793, 'PTHR33889:SF5', NULL, NULL, NULL, NULL, 'OS07G0251050 PROTEIN', 250111),
(400794, 'PTHR33130:SF70', NULL, NULL, NULL, NULL, 'BNAA05G13790D PROTEIN', 250112),
(400795, 'PTHR33130:SF50', NULL, NULL, NULL, NULL, 'BNAA07G36930D PROTEIN', 250112),
(400796, 'PTHR33130:SF51', NULL, NULL, NULL, NULL, 'BNAC06G02220D PROTEIN', 250112),
(400797, 'PTHR33130:SF74', NULL, NULL, NULL, NULL, '', 250112),
(400798, 'PTHR33130:SF31', NULL, NULL, NULL, NULL, 'BNAA02G13750D PROTEIN', 250112),
(400799, 'PTHR33130:SF75', NULL, NULL, NULL, NULL, '', 250112),
(400800, 'PTHR33130:SF53', NULL, NULL, NULL, NULL, 'BNACNNG54010D PROTEIN', 250112),
(400801, 'PTHR33130:SF54', NULL, NULL, NULL, NULL, 'BNAA08G19370D PROTEIN', 250112),
(400802, 'PTHR33130:SF32', NULL, NULL, NULL, NULL, '', 250112),
(400803, 'PTHR33130:SF76', NULL, NULL, NULL, NULL, 'BNAANNG11350D PROTEIN', 250112),
(400804, 'PTHR33130:SF33', NULL, NULL, NULL, NULL, 'PUTATIVE (DUF1639)-RELATED', 250112),
(400805, 'PTHR33130:SF55', NULL, NULL, NULL, NULL, 'BNAA01G23580D PROTEIN', 250112),
(400806, 'PTHR33130:SF77', NULL, NULL, NULL, NULL, '', 250112),
(400807, 'PTHR33130:SF12', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250112),
(400808, 'PTHR33130:SF2', NULL, NULL, NULL, NULL, 'OS12G0284525 PROTEIN', 250112),
(400809, 'PTHR33130:SF56', NULL, NULL, NULL, NULL, 'BNAANNG11150D PROTEIN', 250112),
(400810, 'PTHR33130:SF78', NULL, NULL, NULL, NULL, 'DUF1639 FAMILY PROTEIN', 250112),
(400811, 'PTHR33130:SF79', NULL, NULL, NULL, NULL, 'BNAA01G26810D PROTEIN', 250112),
(400812, 'PTHR33130:SF35', NULL, NULL, NULL, NULL, 'DUF1639 FAMILY PROTEIN', 250112),
(400813, 'PTHR33130:SF59', NULL, NULL, NULL, NULL, 'BNACNNG34650D PROTEIN', 250112),
(400814, 'PTHR33130:SF38', NULL, NULL, NULL, NULL, 'OS05G0551500 PROTEIN', 250112),
(400815, 'PTHR33130:SF39', NULL, NULL, NULL, NULL, 'BNAC05G34980D PROTEIN', 250112),
(400816, 'PTHR33130:SF80', NULL, NULL, NULL, NULL, '', 250112),
(400817, 'PTHR33130:SF81', NULL, NULL, NULL, NULL, '', 250112),
(400818, 'PTHR33130:SF82', NULL, NULL, NULL, NULL, 'DIGESTIVE ORGAN EXPANSION FACTOR HOMOLOG', 250112),
(400819, 'PTHR33130:SF60', NULL, NULL, NULL, NULL, 'OS05G0551600 PROTEIN', 250112),
(400820, 'PTHR33130:SF83', NULL, NULL, NULL, NULL, '', 250112),
(400821, 'PTHR33130:SF62', NULL, NULL, NULL, NULL, 'BNAC01G27380D PROTEIN', 250112),
(400822, 'PTHR33130:SF84', NULL, NULL, NULL, NULL, 'DUF1639 FAMILY PROTEIN', 250112),
(400823, 'PTHR33130:SF40', NULL, NULL, NULL, NULL, 'CHROMOGRANIN (DUF1639)', 250112),
(400824, 'PTHR33130:SF63', NULL, NULL, NULL, NULL, '', 250112),
(400825, 'PTHR33130:SF41', NULL, NULL, NULL, NULL, 'NEUROFILAMENT HEAVY POLYPEPTIDE-LIKE', 250112),
(400826, 'PTHR33130:SF42', NULL, NULL, NULL, NULL, 'DUF1639 FAMILY PROTEIN', 250112),
(400827, 'PTHR33130:SF64', NULL, NULL, NULL, NULL, 'O-ACYLTRANSFERASE, PUTATIVE (DUF1639)-RELATED', 250112),
(400828, 'PTHR33130:SF43', NULL, NULL, NULL, NULL, 'OS01G0132500 PROTEIN', 250112),
(400829, 'PTHR33130:SF67', NULL, NULL, NULL, NULL, '', 250112),
(400830, 'PTHR33130:SF45', NULL, NULL, NULL, NULL, 'INTEGRATOR COMPLEX SUBUNIT 6 HOMOLOG', 250112),
(400831, 'PTHR33130:SF68', NULL, NULL, NULL, NULL, 'OS01G0688600 PROTEIN', 250112);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(400832, 'PTHR33130:SF48', NULL, NULL, NULL, NULL, 'BNAA08G03040D PROTEIN', 250112),
(400833, 'PTHR33130:SF49', NULL, NULL, NULL, NULL, 'BNACNNG55670D PROTEIN', 250112),
(400834, 'PTHR33130', NULL, NULL, NULL, NULL, 'PUTATIVE (DUF1639)-RELATED', 250112),
(400835, 'PTHR39585', NULL, NULL, NULL, NULL, 'FAD ASSEMBLY FACTOR SDHE', 250113),
(400836, 'PTHR39585:SF1', NULL, NULL, NULL, NULL, 'FAD ASSEMBLY FACTOR SDHE', 250113),
(400837, 'PTHR15948:SF0', NULL, NULL, NULL, NULL, 'GOLGI PH REGULATOR A-RELATED', 250114),
(400838, 'PTHR15948', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 89-RELATED', 250114),
(400839, 'PTHR15948:SF7', NULL, NULL, NULL, NULL, 'GPCR-TYPE G PROTEIN 2', 250114),
(400840, 'PTHR15948:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG23048', 250114),
(400841, 'PTHR42746', NULL, NULL, NULL, NULL, 'DIADENOSINE 5'',5''''''-P1,P4-TETRAPHOSPHATE PHOSPHORYLASE', 250115),
(400842, 'PTHR42746:SF2', NULL, NULL, NULL, NULL, 'DIADENOSINE 5'',5''''''-P1,P4-TETRAPHOSPHATE PHOSPHORYLASE 2-RELATED', 250115),
(400843, 'PTHR11850:SF338', NULL, NULL, NULL, NULL, 'BEL1-LIKE HOMEODOMAIN PROTEIN', 250116),
(400844, 'PTHR11850:SF339', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 250116),
(400845, 'PTHR11850:SF298', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 250116),
(400846, 'PTHR11850:SF332', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN MEIS3-LIKE 1-RELATED', 250116),
(400847, 'PTHR11850:SF135', NULL, NULL, NULL, NULL, 'BEL1-LIKE HOMEODOMAIN PROTEIN 5', 250116),
(400848, 'PTHR11850:SF330', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN KNOTTED-1-LIKE 10', 250116),
(400849, 'PTHR11850:SF256', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN KNOTTED-1-LIKE LET12 ISOFORM X1', 250116),
(400850, 'PTHR11850:SF374', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN KNOTTED-1-LIKE 4', 250116),
(400851, 'PTHR11850:SF212', NULL, NULL, NULL, NULL, 'MISCELLANEOUS ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 250116),
(400852, 'PTHR11850:SF68', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN TGIF2', 250116),
(400853, 'PTHR11850:SF255', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN KNOTTED-1-LIKE 5-RELATED', 250116),
(400854, 'PTHR11850:SF375', NULL, NULL, NULL, NULL, 'ASSOCIATED WITH HOX FAMILY PROTEIN, EXPRESSED', 250116),
(400855, 'PTHR11850:SF336', NULL, NULL, NULL, NULL, 'ELK DOMAIN, KNOX1, KNOX2, HOMEOBOX KN DOMAIN, HOMEODOMAIN-LIKE PROTEIN-RELATED', 250116),
(400856, 'PTHR11850:SF337', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN CEH-40', 250116),
(400857, 'PTHR11850:SF139', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 250116),
(400858, 'PTHR11850:SF259', NULL, NULL, NULL, NULL, 'BEL1-LIKE HOMEODOMAIN PROTEIN 11', 250116),
(400859, 'PTHR11850:SF335', NULL, NULL, NULL, NULL, 'BNAA09G31100D PROTEIN', 250116),
(400860, 'PTHR11850:SF291', NULL, NULL, NULL, NULL, 'POX DOMAIN-CONTAINING PROTEIN', 250116),
(400861, 'PTHR11850:SF372', NULL, NULL, NULL, NULL, 'POX (PLANT HOMEOBOX) FAMILY PROTEIN-RELATED', 250116),
(400862, 'PTHR11850:SF373', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN KNOTTED-1-LIKE 4', 250116),
(400863, 'PTHR11850:SF296', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 250116),
(400864, 'PTHR11850:SF370', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 250116),
(400865, 'PTHR11850:SF371', NULL, NULL, NULL, NULL, 'POX DOMAIN, HOMEOBOX KN DOMAIN-CONTAINING PROTEIN-RELATED', 250116),
(400866, 'PTHR11850:SF295', NULL, NULL, NULL, NULL, 'ACHINTYA, ISOFORM C-RELATED', 250116),
(400867, 'PTHR11850:SF108', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN EXTRADENTICLE', 250116),
(400868, 'PTHR11850:SF305', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN KNOTTED-1-LIKE 2', 250116),
(400869, 'PTHR11850:SF309', NULL, NULL, NULL, NULL, 'BEL1-LIKE HOMEODOMAIN PROTEIN 3', 250116),
(400870, 'PTHR11850:SF265', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 250116),
(400871, 'PTHR11850:SF344', NULL, NULL, NULL, NULL, 'HOMEOBOX-TRANSCRIPTION FACTOR 8', 250116),
(400872, 'PTHR11850:SF102', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 250116);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(400873, 'PTHR11850:SF267', NULL, NULL, NULL, NULL, 'BEL1-LIKE HOMEODOMAIN PROTEIN 4', 250116),
(400874, 'PTHR11850:SF266', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOMOTHORAX', 250116),
(400875, 'PTHR11850:SF347', NULL, NULL, NULL, NULL, '', 250116),
(400876, 'PTHR11850:SF302', NULL, NULL, NULL, NULL, 'POX DOMAIN, HOMEOBOX KN DOMAIN-CONTAINING PROTEIN-RELATED', 250116),
(400877, 'PTHR11850:SF224', NULL, NULL, NULL, NULL, 'BEL1-LIKE HOMEODOMAIN PROTEIN 1', 250116),
(400878, 'PTHR11850:SF105', NULL, NULL, NULL, NULL, 'ASSOCIATED WITH HOX FAMILY PROTEIN, EXPRESSED', 250116),
(400879, 'PTHR11850:SF261', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN KNOTTED-1-LIKE 5', 250116),
(400880, 'PTHR11850:SF74', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN KNOTTED-1-LIKE 7', 250116),
(400881, 'PTHR11850:SF340', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN KNOTTED-1-LIKE LET12', 250116),
(400882, 'PTHR11850:SF142', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN KNOTTED-1-LIKE 11', 250116),
(400883, 'PTHR11850:SF318', NULL, NULL, NULL, NULL, 'BEL1-LIKE HOMEODOMAIN PROTEIN 4', 250116),
(400884, 'PTHR11850:SF354', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 250116),
(400885, 'PTHR11850:SF89', NULL, NULL, NULL, NULL, 'PRE-B-CELL LEUKEMIA TRANSCRIPTION FACTOR 1', 250116),
(400886, 'PTHR11850:SF355', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN KNOTTED-1-LIKE 1', 250116),
(400887, 'PTHR11850:SF231', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN ATH1', 250116),
(400888, 'PTHR11850:SF311', NULL, NULL, NULL, NULL, 'BEL1-LIKE HOMEODOMAIN PROTEIN 7', 250116),
(400889, 'PTHR11850:SF278', NULL, NULL, NULL, NULL, 'POX DOMAIN-CONTAINING PROTEIN', 250116),
(400890, 'PTHR11850:SF234', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN KNOTTED-1-LIKE 6', 250116),
(400891, 'PTHR11850:SF47', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN MEIS2', 250116),
(400892, 'PTHR11850:SF353', NULL, NULL, NULL, NULL, 'BNACNNG20070D PROTEIN', 250116),
(400893, 'PTHR11850:SF277', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 250116),
(400894, 'PTHR11850:SF358', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN KNOTTED-1-LIKE 13', 250116),
(400895, 'PTHR11850:SF279', NULL, NULL, NULL, NULL, 'HOMEOBOX KNOTTED-LIKE PROTEIN', 250116),
(400896, 'PTHR11850:SF359', NULL, NULL, NULL, NULL, 'BEL1-TYPE HOMEODOMAIN PROTEIN', 250116),
(400897, 'PTHR11850:SF356', NULL, NULL, NULL, NULL, 'BEL1-LIKE HOMEODOMAIN PROTEIN 7', 250116),
(400898, 'PTHR11850:SF357', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 250116),
(400899, 'PTHR11850:SF313', NULL, NULL, NULL, NULL, 'POX DOMAIN, HOMEOBOX KN DOMAIN-CONTAINING PROTEIN-RELATED', 250116),
(400900, 'PTHR11850', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN TRANSCRIPTION FACTORS', 250116),
(400901, 'PTHR11850:SF80', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN PKNOX1', 250116),
(400902, 'PTHR11850:SF190', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN MEIS3', 250116),
(400903, 'PTHR11850:SF82', NULL, NULL, NULL, NULL, 'BEL1-LIKE HOMEODOMAIN PROTEIN 8-RELATED', 250116),
(400904, 'PTHR11850:SF350', NULL, NULL, NULL, NULL, 'FUSED COMPOUND LEAF 1', 250116),
(400905, 'PTHR11850:SF271', NULL, NULL, NULL, NULL, 'OS02G0226600 PROTEIN', 250116),
(400906, 'PTHR11850:SF351', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN, POX DOMAIN-CONTAINING PROTEIN-RELATED', 250116),
(400907, 'PTHR11850:SF87', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN KNOTTED-1-LIKE 7', 250116),
(400908, 'PTHR11850:SF329', NULL, NULL, NULL, NULL, 'MATING-TYPE PROTEIN ALPHA2-RELATED', 250116),
(400909, 'PTHR11850:SF327', NULL, NULL, NULL, NULL, 'BEL1-LIKE HOMEODOMAIN PROTEIN 1', 250116),
(400910, 'PTHR11850:SF208', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN KNOTTED-1-LIKE 2', 250116),
(400911, 'PTHR11850:SF365', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 250116),
(400912, 'PTHR11850:SF287', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN KNOTTED-1-LIKE 6', 250116),
(400913, 'PTHR11850:SF286', NULL, NULL, NULL, NULL, 'BEL1-LIKE HOMEODOMAIN PROTEIN 10', 250116),
(400914, 'PTHR11850:SF366', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN CEH-60', 250116),
(400915, 'PTHR11850:SF363', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 250116);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(400916, 'PTHR11850:SF57', NULL, NULL, NULL, NULL, 'BEL1-LIKE HOMEODOMAIN PROTEIN 6', 250116),
(400917, 'PTHR11850:SF364', NULL, NULL, NULL, NULL, 'ASSOCIATED WITH HOX FAMILY PROTEIN', 250116),
(400918, 'PTHR11850:SF288', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN SHOOT MERISTEMLESS', 250116),
(400919, 'PTHR11850:SF247', NULL, NULL, NULL, NULL, 'BEL1-LIKE HOMEODOMAIN PROTEIN 9', 250116),
(400920, 'PTHR11850:SF126', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN MEIS1', 250116),
(400921, 'PTHR11850:SF369', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 250116),
(400922, 'PTHR11850:SF59', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN TGIF1', 250116),
(400923, 'PTHR11850:SF246', NULL, NULL, NULL, NULL, 'PROTEIN JUBEL1, PUTATIVE, EXPRESSED-RELATED', 250116),
(400924, 'PTHR11850:SF323', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN KNOTTED-1-LIKE 3', 250116),
(400925, 'PTHR11850:SF367', NULL, NULL, NULL, NULL, 'PBX1A HOMEODOMAIN PROTEIN-RELATED', 250116),
(400926, 'PTHR11850:SF205', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN TGIF2LX-RELATED', 250116),
(400927, 'PTHR11850:SF368', NULL, NULL, NULL, NULL, 'OS01G0848400 PROTEIN', 250116),
(400928, 'PTHR11850:SF324', NULL, NULL, NULL, NULL, 'BNAA03G51900D PROTEIN', 250116),
(400929, 'PTHR11850:SF50', NULL, NULL, NULL, NULL, 'PRE-B-CELL LEUKEMIA TRANSCRIPTION FACTOR 2', 250116),
(400930, 'PTHR11850:SF96', NULL, NULL, NULL, NULL, 'ASSOCIATED WITH HOX FAMILY PROTEIN, EXPRESSED', 250116),
(400931, 'PTHR11850:SF361', NULL, NULL, NULL, NULL, 'BEL1-LIKE HOMEODOMAIN PROTEIN 2', 250116),
(400932, 'PTHR11850:SF362', NULL, NULL, NULL, NULL, 'BEL1-RELATED HOMEOTIC PROTEIN', 250116),
(400933, 'PTHR11850:SF98', NULL, NULL, NULL, NULL, 'PRE-B-CELL LEUKEMIA TRANSCRIPTION FACTOR 4', 250116),
(400934, 'PTHR11850:SF97', NULL, NULL, NULL, NULL, 'PRE-B-CELL LEUKEMIA TRANSCRIPTION FACTOR 3', 250116),
(400935, 'PTHR11850:SF53', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN PKNOX2', 250116),
(400936, 'PTHR11850:SF360', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 250116),
(400937, 'PTHR13340', NULL, NULL, NULL, NULL, 'GATA ZINC FINGER DOMAIN-CONTAINING', 250117),
(400938, 'PTHR13340:SF2', NULL, NULL, NULL, NULL, 'GATA ZINC FINGER DOMAIN-CONTAINING PROTEIN 1', 250117),
(400939, 'PTHR36708:SF1', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE SUBUNIT 6, MITOCHONDRIAL', 250118),
(400940, 'PTHR36708', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE SUBUNIT 6, MITOCHONDRIAL', 250118),
(400941, 'PTHR36708:SF2', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE SUBUNIT 6, MITOCHONDRIAL-LIKE', 250118),
(400942, 'PTHR42911:SF1', NULL, NULL, NULL, NULL, 'MODULATOR OF FTSH PROTEASE HFLC', 250119),
(400943, 'PTHR42911:SF2', NULL, NULL, NULL, NULL, 'SPFH DOMAIN PROTEIN-RELATED', 250119),
(400944, 'PTHR42911', NULL, NULL, NULL, NULL, 'MODULATOR OF FTSH PROTEASE HFLC', 250119),
(400945, 'PTHR46884:SF1', NULL, NULL, NULL, NULL, 'COLLECTRIN', 250120),
(400946, 'PTHR46884', NULL, NULL, NULL, NULL, 'COLLECTRIN', 250120),
(400947, 'PTHR15692:SF19', NULL, NULL, NULL, NULL, 'MASTERMIND-LIKE PROTEIN 1', 250121),
(400948, 'PTHR15692', NULL, NULL, NULL, NULL, 'MASTERMIND-LIKE', 250121),
(400949, 'PTHR15692:SF9', NULL, NULL, NULL, NULL, 'MASTERMIND-LIKE PROTEIN 2', 250121),
(400950, 'PTHR15692:SF20', NULL, NULL, NULL, NULL, 'MAML1 DOMAIN-CONTAINING PROTEIN', 250121),
(400951, 'PTHR15692:SF8', NULL, NULL, NULL, NULL, 'MASTERMIND-LIKE PROTEIN 3', 250121),
(400952, 'PTHR15692:SF18', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 250121),
(400953, 'PTHR20843:SF0', NULL, NULL, NULL, NULL, 'PROTEIN AVEUGLE', 250122),
(400954, 'PTHR20843:SF1', NULL, NULL, NULL, NULL, 'STERILE ALPHA MOTIF DOMAIN-CONTAINING PROTEIN 10', 250122),
(400955, 'PTHR20843', NULL, NULL, NULL, NULL, 'STERILE ALPHA MOTIF DOMAIN CONTAINING PROTEIN 10', 250122),
(400956, 'PTHR20843:SF2', NULL, NULL, NULL, NULL, 'STERILE ALPHA MOTIF DOMAIN-CONTAINING PROTEIN 12', 250122),
(400957, 'PTHR20843:SF3', NULL, NULL, NULL, NULL, 'STERILE ALPHA MOTIF DOMAIN-CONTAINING 10A', 250122),
(400958, 'PTHR13269:SF6', NULL, NULL, NULL, NULL, 'NUCLEOPORIN NDC1', 250123);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(400959, 'PTHR13269', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 250123),
(400960, 'PTHR35771:SF2', NULL, NULL, NULL, NULL, 'ELICITOR PEPTIDE 6', 250124),
(400961, 'PTHR35771:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 250124),
(400962, 'PTHR35771', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN-RELATED', 250124),
(400963, 'PTHR35771:SF4', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 250124),
(400964, 'PTHR47549', NULL, NULL, NULL, NULL, 'GOLGI APPARATUS MEMBRANE PROTEIN TVP38-RELATED', 250125),
(400965, 'PTHR47549:SF1', NULL, NULL, NULL, NULL, 'GOLGI APPARATUS MEMBRANE PROTEIN TVP38', 250125),
(400966, 'PTHR47549:SF3', NULL, NULL, NULL, NULL, 'GOLGI APPARATUS MEMBRANE PROTEIN TVP38', 250125),
(400967, 'PTHR47549:SF2', NULL, NULL, NULL, NULL, 'GOLGI APPARATUS MEMBRANE PROTEIN TVP38', 250125),
(400968, 'PTHR47018:SF4', NULL, NULL, NULL, NULL, '', 250126),
(400969, 'PTHR47018:SF3', NULL, NULL, NULL, NULL, '', 250126),
(400970, 'PTHR47018:SF2', NULL, NULL, NULL, NULL, '', 250126),
(400971, 'PTHR47018', NULL, NULL, NULL, NULL, 'CXC DOMAIN-CONTAINING PROTEIN-RELATED', 250126),
(400972, 'PTHR47018:SF1', NULL, NULL, NULL, NULL, '', 250126),
(400973, 'PTHR11890:SF18', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ACTIVATION GENE 3 PROTEIN', 250127),
(400974, 'PTHR11890:SF26', NULL, NULL, NULL, NULL, 'INTERLEUKIN-1 RECEPTOR TYPE 1', 250127),
(400975, 'PTHR11890:SF6', NULL, NULL, NULL, NULL, 'INTERLEUKIN-18 RECEPTOR 1', 250127),
(400976, 'PTHR11890:SF7', NULL, NULL, NULL, NULL, 'INTERLEUKIN-1 RECEPTOR-LIKE 1', 250127),
(400977, 'PTHR11890:SF9', NULL, NULL, NULL, NULL, 'INTERLEUKIN-1 RECEPTOR-LIKE 2', 250127),
(400978, 'PTHR11890:SF19', NULL, NULL, NULL, NULL, 'SINGLE IG IL-1-RELATED RECEPTOR', 250127),
(400979, 'PTHR11890:SF3', NULL, NULL, NULL, NULL, 'INTERLEUKIN-1 RECEPTOR TYPE 2', 250127),
(400980, 'PTHR11890:SF20', NULL, NULL, NULL, NULL, 'INTERLEUKIN-1 RECEPTOR ACCESSORY PROTEIN', 250127),
(400981, 'PTHR11890:SF10', NULL, NULL, NULL, NULL, 'X-LINKED INTERLEUKIN-1 RECEPTOR ACCESSORY PROTEIN-LIKE 2', 250127),
(400982, 'PTHR11890', NULL, NULL, NULL, NULL, 'INTERLEUKIN-1 RECEPTOR FAMILY MEMBER', 250127),
(400983, 'PTHR11890:SF44', NULL, NULL, NULL, NULL, 'X-LINKED INTERLEUKIN-1 RECEPTOR ACCESSORY PROTEIN-LIKE 2', 250127),
(400984, 'PTHR11890:SF22', NULL, NULL, NULL, NULL, 'INTERLEUKIN-1 RECEPTOR ACCESSORY PROTEIN-LIKE 1', 250127),
(400985, 'PTHR11890:SF45', NULL, NULL, NULL, NULL, 'ZMP:0000000936', 250127),
(400986, 'PTHR11890:SF23', NULL, NULL, NULL, NULL, 'INTERLEUKIN-18 RECEPTOR ACCESSORY PROTEIN', 250127),
(400987, 'PTHR23412:SF6', NULL, NULL, NULL, NULL, 'MESOTHELIN', 250128),
(400988, 'PTHR23412:SF19', NULL, NULL, NULL, NULL, 'STEREOCILIN 1', 250128),
(400989, 'PTHR23412:SF18', NULL, NULL, NULL, NULL, 'OTOANCORIN', 250128),
(400990, 'PTHR23412', NULL, NULL, NULL, NULL, 'STEREOCILIN RELATED', 250128),
(400991, 'PTHR23412:SF17', NULL, NULL, NULL, NULL, 'WW DOMAIN-CONTAINING PROTEIN', 250128),
(400992, 'PTHR23412:SF15', NULL, NULL, NULL, NULL, 'MESOTHELIN-LIKE PROTEIN', 250128),
(400993, 'PTHR23412:SF14', NULL, NULL, NULL, NULL, 'STEREOCILIN-RELATED', 250128),
(400994, 'PTHR28644', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 15', 250129),
(400995, 'PTHR28644:SF1', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 15', 250129),
(400996, 'PTHR13439:SF49', NULL, NULL, NULL, NULL, 'TLC DOMAIN-CONTAINING PROTEIN 4-B', 250130),
(400997, 'PTHR13439:SF68', NULL, NULL, NULL, NULL, 'TRAM LAG1 AND CLN8 (TLC) LIPID-SENSING DOMAIN CONTAINING PROTEIN', 250130),
(400998, 'PTHR13439:SF47', NULL, NULL, NULL, NULL, 'TLC DOMAIN-CONTAINING PROTEIN 4 C', 250130),
(400999, 'PTHR13439:SF48', NULL, NULL, NULL, NULL, 'OS05G0511000 PROTEIN', 250130),
(401000, 'PTHR13439:SF20', NULL, NULL, NULL, NULL, 'TLC DOMAIN-CONTAINING PROTEIN 3A', 250130),
(401001, 'PTHR13439:SF21', NULL, NULL, NULL, NULL, 'TLC DOMAIN-CONTAINING PROTEIN', 250130),
(401002, 'PTHR13439:SF66', NULL, NULL, NULL, NULL, 'BCDNA.GH12326', 250130),
(401003, 'PTHR13439:SF70', NULL, NULL, NULL, NULL, 'TLC DOMAIN-CONTAINING PROTEIN-RELATED', 250130);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(401004, 'PTHR13439:SF71', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250130),
(401005, 'PTHR13439:SF50', NULL, NULL, NULL, NULL, 'TLC DOMAIN-CONTAINING PROTEIN', 250130),
(401006, 'PTHR13439:SF72', NULL, NULL, NULL, NULL, 'TLC DOMAIN-CONTAINING PROTEIN', 250130),
(401007, 'PTHR13439:SF73', NULL, NULL, NULL, NULL, 'OS01G0768200 PROTEIN', 250130),
(401008, 'PTHR13439', NULL, NULL, NULL, NULL, 'CT120 PROTEIN', 250130),
(401009, 'PTHR13439:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CLN8', 250130),
(401010, 'PTHR13439:SF4', NULL, NULL, NULL, NULL, 'TLC DOMAIN-CONTAINING PROTEIN', 250130),
(401011, 'PTHR13439:SF5', NULL, NULL, NULL, NULL, 'TLC DOMAIN-CONTAINING PROTEIN 1', 250130),
(401012, 'PTHR13439:SF6', NULL, NULL, NULL, NULL, 'AAR085WP', 250130),
(401013, 'PTHR13439:SF19', NULL, NULL, NULL, NULL, 'TLC DOMAIN-CONTAINING PROTEIN', 250130),
(401014, 'PTHR13439:SF58', NULL, NULL, NULL, NULL, 'TLC DOMAIN-CONTAINING PROTEIN', 250130),
(401015, 'PTHR13439:SF15', NULL, NULL, NULL, NULL, 'CERAMIDE SYNTHASE', 250130),
(401016, 'PTHR13439:SF54', NULL, NULL, NULL, NULL, 'OS05G0485300 PROTEIN', 250130),
(401017, 'PTHR13439:SF62', NULL, NULL, NULL, NULL, 'TLC DOMAIN-CONTAINING PROTEIN', 250130),
(401018, 'PTHR13439:SF0', NULL, NULL, NULL, NULL, 'TOPOISOMERASE I DAMAGE AFFECTED PROTEIN 4', 250130),
(401019, 'PTHR13439:SF1', NULL, NULL, NULL, NULL, 'TLC DOMAIN-CONTAINING PROTEIN 4', 250130),
(401020, 'PTHR13439:SF2', NULL, NULL, NULL, NULL, 'TLC DOMAIN-CONTAINING PROTEIN 2', 250130),
(401021, 'PTHR10701:SF5', NULL, NULL, NULL, NULL, 'N-ALPHA-ACETYLTRANSFERASE 38, NATC AUXILIARY SUBUNIT', 250131),
(401022, 'PTHR10701:SF19', NULL, NULL, NULL, NULL, '', 250131),
(401023, 'PTHR10701', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN-ASSOCIATED PROTEIN B AND N', 250131),
(401024, 'PTHR10701:SF23', NULL, NULL, NULL, NULL, '', 250131),
(401025, 'PTHR10701:SF14', NULL, NULL, NULL, NULL, 'SM DOMAIN-CONTAINING PROTEIN', 250131),
(401026, 'PTHR10701:SF25', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN-ASSOCIATED PROTEIN', 250131),
(401027, 'PTHR10701:SF13', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN-ASSOCIATED PROTEIN', 250131),
(401028, 'PTHR10701:SF24', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN-ASSOCIATED PROTEIN N', 250131),
(401029, 'PTHR10701:SF0', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN-ASSOCIATED PROTEIN B', 250131),
(401030, 'PTHR10701:SF15', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN-ASSOCIATED PROTEINS B AND B''', 250131),
(401031, 'PTHR15146:SF6', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR 137BB', 250132),
(401032, 'PTHR15146:SF7', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR 137', 250132),
(401033, 'PTHR15146:SF5', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN GPR137', 250132),
(401034, 'PTHR15146:SF3', NULL, NULL, NULL, NULL, '', 250132),
(401035, 'PTHR15146:SF0', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN GPR137B', 250132),
(401036, 'PTHR15146:SF1', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN GPR137C', 250132),
(401037, 'PTHR15146', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN GPR137', 250132),
(401038, 'PTHR20913', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 20/GTPASE', 250133),
(401039, 'PTHR20913:SF10', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 20', 250133),
(401040, 'PTHR20913:SF11', NULL, NULL, NULL, NULL, 'ZGC:63863', 250133),
(401041, 'PTHR20913:SF7', NULL, NULL, NULL, NULL, 'RE60063P', 250133),
(401042, 'PTHR11652:SF70', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S23-2', 250134),
(401043, 'PTHR11652:SF50', NULL, NULL, NULL, NULL, '', 250134),
(401044, 'PTHR11652:SF52', NULL, NULL, NULL, NULL, 'S12-LIKE, 30S RIBOSOMAL PROTEIN S12 SUBFAMILY PROTEIN', 250134),
(401045, 'PTHR11652:SF63', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S23-1', 250134),
(401046, 'PTHR11652:SF64', NULL, NULL, NULL, NULL, '', 250134),
(401047, 'PTHR11652:SF53', NULL, NULL, NULL, NULL, 'BNAA03G00720D PROTEIN', 250134),
(401048, 'PTHR11652:SF65', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S23', 250134);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(401049, 'PTHR11652:SF54', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S12/S23-RELATED', 250134),
(401050, 'PTHR11652:SF44', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S23', 250134),
(401051, 'PTHR11652:SF66', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S23', 250134),
(401052, 'PTHR11652:SF55', NULL, NULL, NULL, NULL, '', 250134),
(401053, 'PTHR11652:SF56', NULL, NULL, NULL, NULL, 'BNAA02G24860D PROTEIN', 250134),
(401054, 'PTHR11652:SF46', NULL, NULL, NULL, NULL, '', 250134),
(401055, 'PTHR11652:SF68', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S12, CHLOROPLASTIC', 250134),
(401056, 'PTHR11652:SF14', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S23', 250134),
(401057, 'PTHR11652:SF69', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOMAL PROTEIN, SMALL', 250134),
(401058, 'PTHR11652:SF59', NULL, NULL, NULL, NULL, 'BNACNNG03140D PROTEIN', 250134),
(401059, 'PTHR11652:SF1', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S12, MITOCHONDRIAL', 250134),
(401060, 'PTHR11652', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S12 FAMILY MEMBER', 250134),
(401061, 'PTHR23185', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 250135),
(401062, 'PTHR23185:SF0', NULL, NULL, NULL, NULL, 'PROTEIN VIRILIZER HOMOLOG', 250135),
(401063, 'PTHR47644:SF1', NULL, NULL, NULL, NULL, '', 250136),
(401064, 'PTHR47644', NULL, NULL, NULL, NULL, 'AGAP008221-PA', 250136),
(401065, 'PTHR43369', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLGLYCINAMIDE FORMYLTRANSFERASE', 250137),
(401066, 'PTHR43369:SF2', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLGLYCINAMIDE FORMYLTRANSFERASE', 250137),
(401067, 'PTHR42823', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT A, CHLOROPLASTIC', 250138),
(401068, 'PTHR42823:SF4', NULL, NULL, NULL, NULL, 'ATPASE, F0 COMPLEX, SUBUNIT A-RELATED', 250138),
(401069, 'PTHR42823:SF3', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT A, CHLOROPLASTIC', 250138),
(401070, 'PTHR23295', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR COACTIVATOR 5-RELATED', 250139),
(401071, 'PTHR23295:SF3', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR COACTIVATOR 5', 250139),
(401072, 'PTHR23295:SF5', NULL, NULL, NULL, NULL, 'SI:CH211-216L23.2', 250139),
(401073, 'PTHR23295:SF6', NULL, NULL, NULL, NULL, 'NEOSIN, ISOFORM A', 250139),
(401074, 'PTHR21329', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL N-ACETYLGLUCOSAMINYLTRANSFERASE SUBUNIT Q-RELATED', 250140),
(401075, 'PTHR21329:SF3', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL N-ACETYLGLUCOSAMINYLTRANSFERASE SUBUNIT Q', 250140),
(401076, 'PTHR11599:SF59', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA TYPE-1', 250141),
(401077, 'PTHR11599:SF15', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE-7-1-RELATED', 250141),
(401078, 'PTHR11599:SF16', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE-2', 250141),
(401079, 'PTHR11599:SF185', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA TYPE-3', 250141),
(401080, 'PTHR11599:SF188', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE', 250141),
(401081, 'PTHR11599:SF13', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE-4', 250141),
(401082, 'PTHR11599:SF144', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA-TYPE 8', 250141),
(401083, 'PTHR11599:SF221', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE-2', 250141),
(401084, 'PTHR11599:SF14', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE-5', 250141),
(401085, 'PTHR11599:SF220', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA', 250141),
(401086, 'PTHR11599:SF143', NULL, NULL, NULL, NULL, '', 250141),
(401087, 'PTHR11599:SF223', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE 6', 250141),
(401088, 'PTHR11599:SF6', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA TYPE-2', 250141),
(401089, 'PTHR11599:SF222', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA', 250141),
(401090, 'PTHR11599:SF189', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA', 250141),
(401091, 'PTHR11599:SF225', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA TYPE-1', 250141),
(401092, 'PTHR11599:SF148', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE-4-B-RELATED', 250141),
(401093, 'PTHR11599:SF147', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE-5-A-RELATED', 250141);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(401094, 'PTHR11599:SF224', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE', 250141),
(401095, 'PTHR11599:SF51', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA TYPE-5', 250141),
(401096, 'PTHR11599:SF180', NULL, NULL, NULL, NULL, 'PROTEASOME_ALPHA_1 DOMAIN-CONTAINING PROTEIN', 250141),
(401097, 'PTHR11599:SF50', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA TYPE-9', 250141),
(401098, 'PTHR11599:SF11', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE-6', 250141),
(401099, 'PTHR11599:SF182', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE', 250141),
(401100, 'PTHR11599:SF55', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA', 250141),
(401101, 'PTHR11599:SF12', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE-1', 250141),
(401102, 'PTHR11599:SF181', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA TYPE-2-A-RELATED', 250141),
(401103, 'PTHR11599:SF53', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA TYPE-8', 250141),
(401104, 'PTHR11599:SF10', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE-3', 250141),
(401105, 'PTHR11599:SF227', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE', 250141),
(401106, 'PTHR11599:SF226', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE-2-B', 250141),
(401107, 'PTHR11599:SF149', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA', 250141),
(401108, 'PTHR11599', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA/BETA', 250141),
(401109, 'PTHR11599:SF4', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA', 250141),
(401110, 'PTHR11599:SF5', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA TYPE-4', 250141),
(401111, 'PTHR11599:SF228', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE', 250141),
(401112, 'PTHR11599:SF48', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA TYPE-11', 250141),
(401113, 'PTHR11599:SF131', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE', 250141),
(401114, 'PTHR11599:SF174', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA', 250141),
(401115, 'PTHR11599:SF210', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA', 250141),
(401116, 'PTHR11599:SF177', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA', 250141),
(401117, 'PTHR11599:SF46', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA TYPE-6', 250141),
(401118, 'PTHR11599:SF132', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE-7-A-RELATED', 250141),
(401119, 'PTHR11599:SF212', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE', 250141),
(401120, 'PTHR11599:SF179', NULL, NULL, NULL, NULL, 'BNAA02G18400D PROTEIN', 250141),
(401121, 'PTHR11599:SF134', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE', 250141),
(401122, 'PTHR11599:SF211', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE', 250141),
(401123, 'PTHR11599:SF214', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE', 250141),
(401124, 'PTHR11599:SF213', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA', 250141),
(401125, 'PTHR11599:SF40', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE-7', 250141),
(401126, 'PTHR11599:SF41', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA TYPE-10', 250141),
(401127, 'PTHR11599:SF44', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA-RELATED', 250141),
(401128, 'PTHR11599:SF170', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA', 250141),
(401129, 'PTHR11599:SF42', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA TYPE-7', 250141),
(401130, 'PTHR11599:SF172', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE', 250141),
(401131, 'PTHR11599:SF216', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA TYPE-3-B', 250141),
(401132, 'PTHR11599:SF215', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE', 250141),
(401133, 'PTHR11599:SF218', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA 1', 250141),
(401134, 'PTHR11599:SF217', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE', 250141),
(401135, 'PTHR11599:SF219', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA TYPE-7-A-RELATED', 250141),
(401136, 'PTHR11599:SF166', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA', 250141),
(401137, 'PTHR11599:SF168', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE', 250141); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(401138, 'PTHR11599:SF202', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA', 250141),
(401139, 'PTHR11599:SF169', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE', 250141),
(401140, 'PTHR11599:SF162', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE-1-A', 250141),
(401141, 'PTHR11599:SF161', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA TYPE-6-LIKE', 250141),
(401142, 'PTHR11599:SF204', NULL, NULL, NULL, NULL, 'PROTEASOME CHAIN 13', 250141),
(401143, 'PTHR11599:SF207', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE', 250141),
(401144, 'PTHR11599:SF209', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA', 250141),
(401145, 'PTHR11599:SF208', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE-7-A PROTEIN', 250141),
(401146, 'PTHR11599:SF152', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA', 250141),
(401147, 'PTHR11599:SF199', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA', 250141),
(401148, 'PTHR11599:SF110', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE', 250141),
(401149, 'PTHR11599:SF113', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE', 250141),
(401150, 'PTHR11599:SF156', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA', 250141),
(401151, 'PTHR11599:SF158', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE', 250141),
(401152, 'PTHR11599:SF62', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA TYPE-3', 250141),
(401153, 'PTHR11599:SF192', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA TYPE-3', 250141),
(401154, 'PTHR11599:SF151', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA', 250141),
(401155, 'PTHR11599:SF195', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA', 250141),
(401156, 'PTHR11599:SF150', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA', 250141),
(401157, 'PTHR11599:SF118', NULL, NULL, NULL, NULL, 'PROTEASOME_ALPHA_1 DOMAIN-CONTAINING PROTEIN', 250141),
(401158, 'PTHR37186', NULL, NULL, NULL, NULL, 'OS06G0524500 PROTEIN', 250142),
(401159, 'PTHR37186:SF1', NULL, NULL, NULL, NULL, 'OS06G0524500 PROTEIN', 250142),
(401160, 'PTHR40855', NULL, NULL, NULL, NULL, 'DIOX_N DOMAIN-CONTAINING PROTEIN', 250143),
(401161, 'PTHR40855:SF1', NULL, NULL, NULL, NULL, 'DIOX_N DOMAIN-CONTAINING PROTEIN', 250143),
(401162, 'PTHR48154', NULL, NULL, NULL, NULL, '', 250144),
(401163, 'PTHR48154:SF1', NULL, NULL, NULL, NULL, 'LATENCY-ASSOCIATED NUCLEAR ANTIGEN', 250144),
(401164, 'PTHR48237:SF1', NULL, NULL, NULL, NULL, 'SPC97/SPC98 FAMILY OF SPINDLE POLE BODY (SBP) COMPONENT', 250145),
(401165, 'PTHR48237', NULL, NULL, NULL, NULL, 'GAMMA-TUBULIN COMPLEX COMPONENT', 250145),
(401166, 'PTHR13664', NULL, NULL, NULL, NULL, 'BECLIN 1-ASSOCIATED AUTOPHAGY-RELATED KEY REGULATOR', 250146),
(401167, 'PTHR13664:SF0', NULL, NULL, NULL, NULL, 'BECLIN 1-ASSOCIATED AUTOPHAGY-RELATED KEY REGULATOR', 250146),
(401168, 'PTHR42779:SF1', NULL, NULL, NULL, NULL, 'PROTEIN YNJB', 250147),
(401169, 'PTHR42779', NULL, NULL, NULL, NULL, 'PROTEIN YNJB', 250147),
(401170, 'PTHR47735:SF5', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL, KQT-LIKE SUBFAMILY, MEMBER 5A', 250148),
(401171, 'PTHR47735:SF6', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY KQT MEMBER 1', 250148),
(401172, 'PTHR47735', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY KQT MEMBER 4', 250148),
(401173, 'PTHR47735:SF7', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY KQT MEMBER 4', 250148),
(401174, 'PTHR47735:SF8', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY KQT MEMBER 5', 250148),
(401175, 'PTHR47735:SF9', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL KQT-LIKE SUBFAMILY, INVERTEBRATE', 250148),
(401176, 'PTHR47735:SF11', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY KQT MEMBER 3', 250148),
(401177, 'PTHR47735:SF4', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY KQT MEMBER 2', 250148),
(401178, 'PTHR47735:SF10', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL KQT-LIKE SUBFAMILY MEMBER 1', 250148),
(401179, 'PTHR46777:SF14', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 10-RELATED', 250149);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(401180, 'PTHR46777:SF13', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 250149),
(401181, 'PTHR46777:SF5', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 13', 250149),
(401182, 'PTHR46777:SF16', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR HOMOBOX-WOX FAMILY-RELATED', 250149),
(401183, 'PTHR46777:SF15', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 8-LIKE', 250149),
(401184, 'PTHR46777:SF12', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 250149),
(401185, 'PTHR46777', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 13', 250149),
(401186, 'PTHR46777:SF6', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 250149),
(401187, 'PTHR28230', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 250150),
(401188, 'PTHR28230:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT PROTEIN 2', 250150),
(401189, 'PTHR33358:SF12', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN WITH A DOMAIN PROTEIN', 250151),
(401190, 'PTHR33358:SF7', NULL, NULL, NULL, NULL, '', 250151),
(401191, 'PTHR33358:SF13', NULL, NULL, NULL, NULL, '', 250151),
(401192, 'PTHR33358', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN WITH A DOMAIN PROTEIN', 250151),
(401193, 'PTHR33358:SF10', NULL, NULL, NULL, NULL, '', 250151),
(401194, 'PTHR33358:SF18', NULL, NULL, NULL, NULL, 'PLANT-LIKE PROTEIN, PUTATIVE-RELATED', 250151),
(401195, 'PTHR33358:SF16', NULL, NULL, NULL, NULL, 'PLANT-LIKE PROTEIN, PUTATIVE-RELATED', 250151),
(401196, 'PTHR33358:SF3', NULL, NULL, NULL, NULL, 'PLANT-LIKE PROTEIN, PUTATIVE-RELATED', 250151),
(401197, 'PTHR33358:SF4', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN-RELATED', 250151),
(401198, 'PTHR33358:SF17', NULL, NULL, NULL, NULL, 'PLANT-LIKE PROTEIN, PUTATIVE-RELATED', 250151),
(401199, 'PTHR33358:SF14', NULL, NULL, NULL, NULL, '', 250151),
(401200, 'PTHR40034', NULL, NULL, NULL, NULL, 'BSL5891 PROTEIN', 250152),
(401201, 'PTHR40034:SF1', NULL, NULL, NULL, NULL, 'BSL5891 PROTEIN', 250152),
(401202, 'PTHR12149:SF9', NULL, NULL, NULL, NULL, 'FRUCTOSAMINE-3-KINASE', 250153),
(401203, 'PTHR12149:SF8', NULL, NULL, NULL, NULL, 'PROTEIN-RIBULOSAMINE 3-KINASE', 250153),
(401204, 'PTHR12149', NULL, NULL, NULL, NULL, 'FRUCTOSAMINE 3 KINASE-RELATED PROTEIN', 250153),
(401205, 'PTHR12149:SF11', NULL, NULL, NULL, NULL, 'PROTEIN-RIBULOSAMINE 3-KINASE', 250153),
(401206, 'PTHR12149:SF10', NULL, NULL, NULL, NULL, 'KETOSAMINE-3-KINASE', 250153),
(401207, 'PTHR15818', NULL, NULL, NULL, NULL, 'G PATCH AND KOW-CONTAINING', 250154),
(401208, 'PTHR15818:SF3', NULL, NULL, NULL, NULL, 'G-PATCH_2 DOMAIN-CONTAINING PROTEIN', 250154),
(401209, 'PTHR15818:SF2', NULL, NULL, NULL, NULL, 'G-PATCH DOMAIN AND KOW MOTIFS-CONTAINING PROTEIN', 250154),
(401210, 'PTHR45894:SF4', NULL, NULL, NULL, NULL, 'BNAC06G04600D PROTEIN', 250155),
(401211, 'PTHR45894:SF3', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 250155),
(401212, 'PTHR45894:SF2', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN Y14B', 250155),
(401213, 'PTHR45894:SF1', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 8A', 250155),
(401214, 'PTHR45894', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 8A', 250155),
(401215, 'PTHR45894:SF7', NULL, NULL, NULL, NULL, 'BNAA05G15240D PROTEIN', 250155),
(401216, 'PTHR45894:SF5', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN', 250155),
(401217, 'PTHR12215:SF22', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 250156),
(401218, 'PTHR12215:SF23', NULL, NULL, NULL, NULL, '4''-PHOSPHOPANTETHEINYL TRANSFERASE', 250156),
(401219, 'PTHR12215:SF10', NULL, NULL, NULL, NULL, 'L-AMINOADIPATE-SEMIALDEHYDE DEHYDROGENASE-PHOSPHOPANTETHEINYL TRANSFERASE', 250156),
(401220, 'PTHR12215', NULL, NULL, NULL, NULL, 'PHOSPHOPANTETHEINE TRANSFERASE', 250156),
(401221, 'PTHR12215:SF15', NULL, NULL, NULL, NULL, '4''-PHOSPHOPANTETHEINYL TRANSFERASE SUPERFAMILY-RELATED', 250156),
(401222, 'PTHR45943', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MYCBP2', 250157),
(401223, 'PTHR45943:SF3', NULL, NULL, NULL, NULL, '', 250157),
(401224, 'PTHR45943:SF2', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 250157);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(401225, 'PTHR45943:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MYCBP2', 250157),
(401226, 'PTHR46915:SF1', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE-SPECIFIC PROTEASE 1D', 250158),
(401227, 'PTHR46915:SF10', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 250158),
(401228, 'PTHR46915:SF2', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE PROTEASE 4', 250158),
(401229, 'PTHR46915', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE PROTEASE 4-RELATED', 250158),
(401230, 'PTHR46915:SF5', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 250158),
(401231, 'PTHR46915:SF6', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASES SUPERFAMILY PROTEIN', 250158),
(401232, 'PTHR46915:SF16', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 250158),
(401233, 'PTHR46915:SF18', NULL, NULL, NULL, NULL, 'OTS1B PROTEIN', 250158),
(401234, 'PTHR46915:SF11', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE-SPECIFIC PROTEASE 1C', 250158),
(401235, 'PTHR46915:SF12', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 250158),
(401236, 'PTHR46915:SF13', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 250158),
(401237, 'PTHR46915:SF14', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE-SPECIFIC PROTEASE 1D', 250158),
(401238, 'PTHR21230:SF59', NULL, NULL, NULL, NULL, 'V-SNARE DOMAIN-CONTAINING PROTEIN', 250159),
(401239, 'PTHR21230:SF79', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 250159),
(401240, 'PTHR21230:SF35', NULL, NULL, NULL, NULL, 'PLANT SNARE 11, PUTATIVE, EXPRESSED-RELATED', 250159),
(401241, 'PTHR21230:SF77', NULL, NULL, NULL, NULL, 'QA-SNARE PROTEIN-RELATED', 250159),
(401242, 'PTHR21230:SF98', NULL, NULL, NULL, NULL, 'V-SNARE DOMAIN-CONTAINING PROTEIN', 250159),
(401243, 'PTHR21230:SF76', NULL, NULL, NULL, NULL, 'VESICLE TRANSPORT V-SNARE 11-RELATED', 250159),
(401244, 'PTHR21230:SF31', NULL, NULL, NULL, NULL, 'OS01G0560200 PROTEIN', 250159),
(401245, 'PTHR21230:SF97', NULL, NULL, NULL, NULL, '', 250159),
(401246, 'PTHR21230:SF96', NULL, NULL, NULL, NULL, 'VESICLE TRANSPORT V-SNARE, T-SNARE-RELATED', 250159),
(401247, 'PTHR21230:SF95', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 250159),
(401248, 'PTHR21230:SF94', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 250159),
(401249, 'PTHR21230:SF72', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 250159),
(401250, 'PTHR21230:SF93', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 250159),
(401251, 'PTHR21230:SF71', NULL, NULL, NULL, NULL, 'MEMBRIN', 250159),
(401252, 'PTHR21230:SF92', NULL, NULL, NULL, NULL, 'QA-SNARE PROTEIN-RELATED', 250159),
(401253, 'PTHR21230:SF70', NULL, NULL, NULL, NULL, 'VESICLE TRANSPORT V-SNARE 12', 250159),
(401254, 'PTHR21230:SF91', NULL, NULL, NULL, NULL, 'QA-SNARE PROTEIN-RELATED', 250159),
(401255, 'PTHR21230:SF90', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 250159),
(401256, 'PTHR21230:SF26', NULL, NULL, NULL, NULL, 'VESICLE TRANSPORT THROUGH INTERACTION WITH T-SNARES HOMOLOG 1A', 250159),
(401257, 'PTHR21230:SF25', NULL, NULL, NULL, NULL, 'GOLGI SNAP RECEPTOR COMPLEX MEMBER 2', 250159),
(401258, 'PTHR21230:SF67', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 250159),
(401259, 'PTHR21230:SF89', NULL, NULL, NULL, NULL, 'VESICLE TRANSPORT THROUGH INTERACTION WITH T-SNARES HOMOLOG 1B', 250159),
(401260, 'PTHR21230:SF88', NULL, NULL, NULL, NULL, '', 250159),
(401261, 'PTHR21230:SF66', NULL, NULL, NULL, NULL, 'VESICLE TRANSPORT V-SNARE 12', 250159),
(401262, 'PTHR21230:SF65', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 250159),
(401263, 'PTHR21230:SF64', NULL, NULL, NULL, NULL, 'VESICLE TRANSPORT THROUGH INTERACTION WITH T-SNARES HOMOLOG 1B', 250159),
(401264, 'PTHR21230:SF84', NULL, NULL, NULL, NULL, 'V-SNARE DOMAIN-CONTAINING PROTEIN', 250159),
(401265, 'PTHR21230:SF83', NULL, NULL, NULL, NULL, 'V-SNARE DOMAIN-CONTAINING PROTEIN', 250159);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(401266, 'PTHR21230', NULL, NULL, NULL, NULL, 'VESICLE TRANSPORT V-SNARE PROTEIN VTI1-RELATED', 250159),
(401267, 'PTHR21230:SF82', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 250159),
(401268, 'PTHR21230:SF80', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 250159),
(401269, 'PTHR21230:SF1', NULL, NULL, NULL, NULL, 'GOLGI SNAP RECEPTOR COMPLEX MEMBER 2', 250159),
(401270, 'PTHR21230:SF27', NULL, NULL, NULL, NULL, 'NOVEL PLANT SNARE 11', 250159),
(401271, 'PTHR47211:SF6', NULL, NULL, NULL, NULL, 'MYB-LIKE DOMAIN-CONTAINING PROTEIN', 250160),
(401272, 'PTHR47211:SF5', NULL, NULL, NULL, NULL, 'MYB-LIKE DOMAIN-CONTAINING PROTEIN', 250160),
(401273, 'PTHR47211:SF4', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DNA-BINDING DOMAIN PROTEIN', 250160),
(401274, 'PTHR47211', NULL, NULL, NULL, NULL, 'TRIHELIX TRANSCRIPTION FACTOR ASR3', 250160),
(401275, 'PTHR47211:SF3', NULL, NULL, NULL, NULL, 'MYB-LIKE DOMAIN-CONTAINING PROTEIN', 250160),
(401276, 'PTHR47211:SF2', NULL, NULL, NULL, NULL, 'TRIHELIX TRANSCRIPTION FACTOR ASR3', 250160),
(401277, 'PTHR42084', NULL, NULL, NULL, NULL, 'YALI0E26631P', 250161),
(401278, 'PTHR42084:SF1', NULL, NULL, NULL, NULL, 'YALI0E26631P', 250161),
(401279, 'PTHR39600:SF1', NULL, NULL, NULL, NULL, '', 250162),
(401280, 'PTHR39600', NULL, NULL, NULL, NULL, '', 250162),
(401281, 'PTHR32361:SF3', NULL, NULL, NULL, NULL, 'REDUCTASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G13750)-RELATED', 250163),
(401282, 'PTHR32361:SF28', NULL, NULL, NULL, NULL, 'FRP1P', 250163),
(401283, 'PTHR32361:SF26', NULL, NULL, NULL, NULL, 'FAD_BINDING_8 DOMAIN-CONTAINING PROTEIN-RELATED', 250163),
(401284, 'PTHR32361:SF27', NULL, NULL, NULL, NULL, 'FAD-BINDING FR-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', 250163),
(401285, 'PTHR32361:SF24', NULL, NULL, NULL, NULL, 'REDUCTASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G10820)-RELATED', 250163),
(401286, 'PTHR32361', NULL, NULL, NULL, NULL, 'FERRIC/CUPRIC REDUCTASE TRANSMEMBRANE COMPONENT', 250163),
(401287, 'PTHR32361:SF25', NULL, NULL, NULL, NULL, 'FERRIC/CUPRIC REDUCTASE TRANSMEMBRANE COMPONENT 1', 250163),
(401288, 'PTHR32361:SF12', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_1G14340)-RELATED', 250163),
(401289, 'PTHR32361:SF23', NULL, NULL, NULL, NULL, 'FERRIC-CHELATE REDUCTASE-RELATED', 250163),
(401290, 'PTHR32361:SF9', NULL, NULL, NULL, NULL, 'FERRIC REDUCTASE TRANSMEMBRANE COMPONENT 3-RELATED', 250163),
(401291, 'PTHR15555:SF0', NULL, NULL, NULL, NULL, 'ZINC FINGER HIT DOMAIN-CONTAINING PROTEIN 2', 250164),
(401292, 'PTHR15555', NULL, NULL, NULL, NULL, 'ZINC FINGER HIT DOMAIN CONTAINING PROTEIN 2  PROTEIN FON -RELATED', 250164),
(401293, 'PTHR37326:SF1', NULL, NULL, NULL, NULL, 'BLL3975 PROTEIN', 250165),
(401294, 'PTHR37326:SF2', NULL, NULL, NULL, NULL, 'SUCCINYLGLUTAMATE DESUCCINYLASE/ASPARTOACYLASE FAMILY PROTEIN', 250165),
(401295, 'PTHR37326', NULL, NULL, NULL, NULL, 'BLL3975 PROTEIN', 250165),
(401296, 'PTHR47626:SF6', NULL, NULL, NULL, NULL, 'STERILE ALPHA MOTIF (SAM) DOMAIN-CONTAINING PROTEIN', 250166),
(401297, 'PTHR47626', NULL, NULL, NULL, NULL, 'STERILE ALPHA MOTIF (SAM) DOMAIN-CONTAINING PROTEIN', 250166),
(401298, 'PTHR47626:SF4', NULL, NULL, NULL, NULL, 'SAM DOMAIN-CONTAINING PROTEIN', 250166),
(401299, 'PTHR47626:SF1', NULL, NULL, NULL, NULL, 'STERILE ALPHA MOTIF (SAM) DOMAIN-CONTAINING PROTEIN', 250166),
(401300, 'PTHR22826:SF206', NULL, NULL, NULL, NULL, 'TRIPLE FUNCTIONAL DOMAIN PROTEIN', 250167),
(401301, 'PTHR22826:SF106', NULL, NULL, NULL, NULL, 'DH DOMAIN-CONTAINING PROTEIN', 250167),
(401302, 'PTHR22826:SF117', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY G MEMBER 4B-RELATED', 250167),
(401303, 'PTHR22826:SF208', NULL, NULL, NULL, NULL, 'TRIO, ISOFORM A', 250167),
(401304, 'PTHR22826:SF207', NULL, NULL, NULL, NULL, 'MCF.2 CELL LINE-DERIVED-TRANSFORMING SEQUENCE B', 250167),
(401305, 'PTHR22826', NULL, NULL, NULL, NULL, 'RHO GUANINE EXCHANGE FACTOR-RELATED', 250167),
(401306, 'PTHR22826:SF49', NULL, NULL, NULL, NULL, 'KALIRIN', 250167);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(401307, 'PTHR22826:SF209', NULL, NULL, NULL, NULL, 'DH DOMAIN-CONTAINING PROTEIN', 250167),
(401308, 'PTHR22826:SF201', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE EXCHANGE FACTOR MCF2L2-RELATED', 250167),
(401309, 'PTHR22826:SF146', NULL, NULL, NULL, NULL, 'PROTO-ONCOGENE DBL', 250167),
(401310, 'PTHR22826:SF104', NULL, NULL, NULL, NULL, 'TRIPLE FUNCTIONAL DOMAIN PROTEIN', 250167),
(401311, 'PTHR22826:SF115', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE EXCHANGE FACTOR DBS', 250167),
(401312, 'PTHR45787:SF8', NULL, NULL, NULL, NULL, 'LIM DOMAIN ONLY 4-RELATED', 250168),
(401313, 'PTHR45787:SF13', NULL, NULL, NULL, NULL, 'LD11652P', 250168),
(401314, 'PTHR45787:SF7', NULL, NULL, NULL, NULL, 'LIM DOMAIN ONLY PROTEIN 3', 250168),
(401315, 'PTHR45787:SF1', NULL, NULL, NULL, NULL, 'RHOMBOTIN-1-LIKE PROTEIN', 250168),
(401316, 'PTHR45787:SF12', NULL, NULL, NULL, NULL, 'BEADEX, ISOFORM D', 250168),
(401317, 'PTHR45787:SF5', NULL, NULL, NULL, NULL, 'LIM DOMAIN TRANSCRIPTION FACTOR LMO4', 250168),
(401318, 'PTHR45787:SF2', NULL, NULL, NULL, NULL, 'RHOMBOTIN-1', 250168),
(401319, 'PTHR45787', NULL, NULL, NULL, NULL, 'LD11652P', 250168),
(401320, 'PTHR45787:SF3', NULL, NULL, NULL, NULL, 'RHOMBOTIN-2', 250168),
(401321, 'PTHR36350:SF4', NULL, NULL, NULL, NULL, 'BNAA05G09310D PROTEIN', 250169),
(401322, 'PTHR36350', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 250169),
(401323, 'PTHR36350:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 250169),
(401324, 'PTHR36350:SF2', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 250169),
(401325, 'PTHR36940:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG01577', 250170),
(401326, 'PTHR36940:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG20338', 250170),
(401327, 'PTHR36940', NULL, NULL, NULL, NULL, 'PROTEIN CBG20338', 250170),
(401328, 'PTHR36940:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG23643', 250170),
(401329, 'PTHR16100', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE-INTERACTING PROTEIN FAMILY MEMBER', 250171),
(401330, 'PTHR16100:SF5', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 100', 250171),
(401331, 'PTHR16100:SF4', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE-INTERACTING PROTEIN', 250171),
(401332, 'PTHR16100:SF3', NULL, NULL, NULL, NULL, '', 250171),
(401333, 'PTHR35186', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250172),
(401334, 'PTHR35186:SF4', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250172),
(401335, 'PTHR28620:SF11', NULL, NULL, NULL, NULL, 'GLUTATHIONE-DEPENDENT FORMALDEHYDE-ACTIVATING, GFA FAMILY PROTEIN', 250173),
(401336, 'PTHR28620:SF4', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN V', 250173),
(401337, 'PTHR28620:SF3', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN V-LIKE PROTEIN 1', 250173),
(401338, 'PTHR28620:SF10', NULL, NULL, NULL, NULL, 'MSS4-LIKE PROTEIN-RELATED', 250173),
(401339, 'PTHR28620:SF1', NULL, NULL, NULL, NULL, 'CENP-V/GFA DOMAIN-CONTAINING PROTEIN', 250173),
(401340, 'PTHR28620:SF9', NULL, NULL, NULL, NULL, 'CARBON-SULFUR LYASES', 250173),
(401341, 'PTHR28620:SF8', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN V-LIKE PROTEIN 2', 250173),
(401342, 'PTHR28620:SF7', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN V-LIKE PROTEIN 3', 250173),
(401343, 'PTHR28620', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN V', 250173),
(401344, 'PTHR28620:SF5', NULL, NULL, NULL, NULL, 'CENP-V/GFA DOMAIN-CONTAINING PROTEIN', 250173),
(401345, 'PTHR45832:SF10', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 250174),
(401346, 'PTHR45832:SF21', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 250174),
(401347, 'PTHR45832', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SAMKA-RELATED-RELATED', 250174),
(401348, 'PTHR45832:SF11', NULL, NULL, NULL, NULL, 'BETA-PAK', 250174),
(401349, 'PTHR45832:SF22', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SAMKA-RELATED', 250174),
(401350, 'PTHR45832:SF23', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250174),
(401351, 'PTHR45832:SF6', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250174);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(401352, 'PTHR45832:SF18', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DST1', 250174),
(401353, 'PTHR45832:SF8', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250174),
(401354, 'PTHR45832:SF9', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 250174),
(401355, 'PTHR45832:SF16', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE STE20-LIKE-RELATED', 250174),
(401356, 'PTHR45832:SF4', NULL, NULL, NULL, NULL, 'P21 PROTEIN (CDC42/RAC)-ACTIVATED KINASE 7', 250174),
(401357, 'PTHR45832:SF3', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 250174),
(401358, 'PTHR23237:SF13', NULL, NULL, NULL, NULL, '', 250175),
(401359, 'PTHR23237:SF3', NULL, NULL, NULL, NULL, '', 250175),
(401360, 'PTHR23237', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN FAMILY A MEMBER 1  SNORNP PROTEIN GAR1', 250175),
(401361, 'PTHR23237:SF11', NULL, NULL, NULL, NULL, 'H/ACA RIBONUCLEOPROTEIN COMPLEX SUBUNIT', 250175),
(401362, 'PTHR23237:SF9', NULL, NULL, NULL, NULL, 'H/ACA RIBONUCLEOPROTEIN COMPLEX SUBUNIT', 250175),
(401363, 'PTHR23237:SF12', NULL, NULL, NULL, NULL, 'H/ACA RIBONUCLEOPROTEIN COMPLEX SUBUNIT', 250175),
(401364, 'PTHR23237:SF8', NULL, NULL, NULL, NULL, '', 250175),
(401365, 'PTHR23237:SF6', NULL, NULL, NULL, NULL, 'H/ACA RIBONUCLEOPROTEIN COMPLEX SUBUNIT 1', 250175),
(401366, 'PTHR23237:SF10', NULL, NULL, NULL, NULL, 'H/ACA RIBONUCLEOPROTEIN COMPLEX SUBUNIT 1', 250175),
(401367, 'PTHR11232:SF69', NULL, NULL, NULL, NULL, 'SI:DKEY-34E4.1', 250176),
(401368, 'PTHR11232:SF36', NULL, NULL, NULL, NULL, 'PROTEIN FAM43A', 250176),
(401369, 'PTHR11232:SF47', NULL, NULL, NULL, NULL, 'PROTEIN DISABLED', 250176),
(401370, 'PTHR11232:SF79', NULL, NULL, NULL, NULL, 'PID DOMAIN-CONTAINING PROTEIN', 250176),
(401371, 'PTHR11232:SF57', NULL, NULL, NULL, NULL, 'RE46159P', 250176),
(401372, 'PTHR11232:SF68', NULL, NULL, NULL, NULL, 'NITRIC OXIDE SYNTHASE 1 (NEURONAL) ADAPTOR PROTEIN A-RELATED', 250176),
(401373, 'PTHR11232:SF35', NULL, NULL, NULL, NULL, 'LOW DENSITY LIPOPROTEIN RECEPTOR ADAPTER PROTEIN 1', 250176),
(401374, 'PTHR11232:SF45', NULL, NULL, NULL, NULL, 'GENE 7694-RELATED', 250176),
(401375, 'PTHR11232:SF78', NULL, NULL, NULL, NULL, 'PTB DOMAIN-CONTAINING ENGULFMENT ADAPTER PROTEIN 1', 250176),
(401376, 'PTHR11232:SF34', NULL, NULL, NULL, NULL, 'PROTEIN FAM43B', 250176),
(401377, 'PTHR11232:SF77', NULL, NULL, NULL, NULL, 'PTB DOMAIN-CONTAINING ADAPTER PROTEIN CED-6', 250176),
(401378, 'PTHR11232:SF65', NULL, NULL, NULL, NULL, 'SI:DKEY-19B23.8', 250176),
(401379, 'PTHR11232:SF76', NULL, NULL, NULL, NULL, 'CARBOXYL-TERMINAL PDZ LIGAND OF NEURONAL NITRIC OXIDE SYNTHASE PROTEIN', 250176),
(401380, 'PTHR11232:SF75', NULL, NULL, NULL, NULL, 'PID DOMAIN-CONTAINING PROTEIN', 250176),
(401381, 'PTHR11232:SF74', NULL, NULL, NULL, NULL, 'PTB DOMAIN-CONTAINING ADAPTER PROTEIN CED-6-LIKE PROTEIN', 250176),
(401382, 'PTHR11232:SF73', NULL, NULL, NULL, NULL, 'PID DOMAIN-CONTAINING PROTEIN', 250176),
(401383, 'PTHR11232:SF2', NULL, NULL, NULL, NULL, 'FI05246P', 250176),
(401384, 'PTHR11232:SF50', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 1', 250176),
(401385, 'PTHR11232:SF70', NULL, NULL, NULL, NULL, 'GULP PTB DOMAIN-CONTAINING ENGULFMENT ADAPTOR 1B-RELATED', 250176),
(401386, 'PTHR11232:SF18', NULL, NULL, NULL, NULL, 'JNK-INTERACTING PROTEIN 1', 250176),
(401387, 'PTHR11232:SF17', NULL, NULL, NULL, NULL, 'CAPON-LIKE PROTEIN', 250176),
(401388, 'PTHR11232', NULL, NULL, NULL, NULL, 'PHOSPHOTYROSINE INTERACTION DOMAIN-CONTAINING FAMILY MEMBER', 250176),
(401389, 'PTHR46607', NULL, NULL, NULL, NULL, 'SEC14 DOMAIN AND SPECTRIN REPEAT-CONTAINING PROTEIN 1', 250177),
(401390, 'PTHR46607:SF1', NULL, NULL, NULL, NULL, 'SEC14 DOMAIN AND SPECTRIN REPEAT-CONTAINING PROTEIN 1', 250177),
(401391, 'PTHR21428:SF11', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 7', 250178),
(401392, 'PTHR21428', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 7', 250178),
(401393, 'PTHR17575', NULL, NULL, NULL, NULL, 'UROCORTIN-2 AND 3', 250179);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(401394, 'PTHR17575:SF1', NULL, NULL, NULL, NULL, 'UROCORTIN-3', 250179),
(401395, 'PTHR17575:SF0', NULL, NULL, NULL, NULL, 'UROCORTIN-2', 250179),
(401396, 'PTHR31247', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 198 FAMILY MEMBER', 250180),
(401397, 'PTHR31247:SF8', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 198B', 250180),
(401398, 'PTHR31247:SF7', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 198', 250180),
(401399, 'PTHR31247:SF5', NULL, NULL, NULL, NULL, 'DUF4203 DOMAIN-CONTAINING PROTEIN', 250180),
(401400, 'PTHR31247:SF16', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 198-B', 250180),
(401401, 'PTHR46028:SF1', NULL, NULL, NULL, NULL, 'FAD_BINDING_3 DOMAIN-CONTAINING PROTEIN', 250181),
(401402, 'PTHR46028:SF2', NULL, NULL, NULL, NULL, 'KYNURENINE 3-MONOOXYGENASE', 250181),
(401403, 'PTHR46028:SF5', NULL, NULL, NULL, NULL, 'FAD_BINDING_3 DOMAIN-CONTAINING PROTEIN', 250181),
(401404, 'PTHR46028:SF6', NULL, NULL, NULL, NULL, 'KYNURENINE 3-MONOOXYGENASE-RELATED', 250181),
(401405, 'PTHR46028', NULL, NULL, NULL, NULL, 'KYNURENINE 3-MONOOXYGENASE', 250181),
(401406, 'PTHR46566:SF5', NULL, NULL, NULL, NULL, '1-PHOSPHOFRUCTOKINASE', 250182),
(401407, 'PTHR46566:SF2', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE ISOZYME 2', 250182),
(401408, 'PTHR46566:SF1', NULL, NULL, NULL, NULL, '1-PHOSPHOFRUCTOKINASE', 250182),
(401409, 'PTHR46566', NULL, NULL, NULL, NULL, '1-PHOSPHOFRUCTOKINASE-RELATED', 250182),
(401410, 'PTHR42197', NULL, NULL, NULL, NULL, 'TRNA (CYTIDINE(56)-2''-O)-METHYLTRANSFERASE', 250183),
(401411, 'PTHR42197:SF1', NULL, NULL, NULL, NULL, 'TRNA (CYTIDINE(56)-2''-O)-METHYLTRANSFERASE', 250183),
(401412, 'PTHR42858:SF1', NULL, NULL, NULL, NULL, 'LD15494P', 250184),
(401413, 'PTHR42858', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE', 250184),
(401414, 'PTHR15444', NULL, NULL, NULL, NULL, 'SECRETED PHOSPHOPROTEIN 24', 250185),
(401415, 'PTHR15444:SF4', NULL, NULL, NULL, NULL, 'SECRETED PHOSPHOPROTEIN 24', 250185),
(401416, 'PTHR36110:SF3', NULL, NULL, NULL, NULL, 'GLYOXALASE FAMILY PROTEIN', 250186),
(401417, 'PTHR36110:SF2', NULL, NULL, NULL, NULL, 'RING-CLEAVING DIOXYGENASE MHQE-RELATED', 250186),
(401418, 'PTHR36110:SF4', NULL, NULL, NULL, NULL, 'RING-CLEAVING DIOXYGENASE MHQA-RELATED', 250186),
(401419, 'PTHR36110', NULL, NULL, NULL, NULL, 'RING-CLEAVING DIOXYGENASE MHQE-RELATED', 250186),
(401420, 'PTHR10606:SF1', NULL, NULL, NULL, NULL, '6-PHOSPHOFRUCTO-2-KINASE 2', 250187),
(401421, 'PTHR10606:SF70', NULL, NULL, NULL, NULL, '6-PHOSPHOFRUCTO-2-KINASE', 250187),
(401422, 'PTHR10606:SF71', NULL, NULL, NULL, NULL, 'FRUCTOSE-2,6-BISPHOSPHATASE-RELATED', 250187),
(401423, 'PTHR10606:SF50', NULL, NULL, NULL, NULL, '6-BIPHOSPHATASE, PUTATIVE-RELATED', 250187),
(401424, 'PTHR10606:SF72', NULL, NULL, NULL, NULL, 'FRUCTOSE-6-PHOSPHATE-2-KINASE/FRUCTOSE-2, 6-BISPHOSPHATASE', 250187),
(401425, 'PTHR10606:SF40', NULL, NULL, NULL, NULL, '6-BIPHOSPHATASE, PUTATIVE-RELATED', 250187),
(401426, 'PTHR10606:SF41', NULL, NULL, NULL, NULL, '6-PHOSPHOFRUCTO-2-KINASE/FRUCTOSE-2,6-BISPHOSPHATASE 3', 250187),
(401427, 'PTHR10606:SF75', NULL, NULL, NULL, NULL, 'CBM20 DOMAIN-CONTAINING PROTEIN', 250187),
(401428, 'PTHR10606:SF65', NULL, NULL, NULL, NULL, '6-PHOSPHOFRUCTO-2-KINASE', 250187),
(401429, 'PTHR10606:SF32', NULL, NULL, NULL, NULL, '6-PHOSPHOFRUCTO-2-KINASE 1', 250187),
(401430, 'PTHR10606:SF76', NULL, NULL, NULL, NULL, '6-PHOSPHOFRUCTO-2-KINASE FAMILY PROTEIN, EXPRESSED', 250187),
(401431, 'PTHR10606:SF44', NULL, NULL, NULL, NULL, '6-PHOSPHOFRUCTO-2-KINASE', 250187),
(401432, 'PTHR10606:SF77', NULL, NULL, NULL, NULL, '6-PHOSPHOFRUCTO-2-KINASE C222.13C-RELATED', 250187),
(401433, 'PTHR10606:SF36', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 250187),
(401434, 'PTHR10606:SF14', NULL, NULL, NULL, NULL, '6-PHOSPHOFRUCTO-2-KINASE/FRUCTOSE-2,6-BISPHOSPHATASE 4', 250187),
(401435, 'PTHR10606:SF48', NULL, NULL, NULL, NULL, '6-PHOSPHOFRUCTO-2-KINASE/FRUCTOSE-2,6-BISPHOSPHATASE 2', 250187),
(401436, 'PTHR10606:SF15', NULL, NULL, NULL, NULL, '6-PHOSPHOFRUCTO-2-KINASE/FRUCTOSE-2,6-BISPHOSPHATASE 1', 250187);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(401437, 'PTHR10606:SF38', NULL, NULL, NULL, NULL, '6PF2K DOMAIN-CONTAINING PROTEIN', 250187),
(401438, 'PTHR10606:SF49', NULL, NULL, NULL, NULL, '6PF2K DOMAIN-CONTAINING PROTEIN', 250187),
(401439, 'PTHR10606', NULL, NULL, NULL, NULL, '6-PHOSPHOFRUCTO-2-KINASE/FRUCTOSE-2,6-BISPHOSPHATASE', 250187),
(401440, 'PTHR10606:SF39', NULL, NULL, NULL, NULL, '6-PHOSPHOFRUCTO-2-KINASE/FRUCTOSE-2,6-BISPHOSPHATASE YLR345W-RELATED', 250187),
(401441, 'PTHR43240:SF7', NULL, NULL, NULL, NULL, 'BLR7284 PROTEIN', 250188),
(401442, 'PTHR43240:SF15', NULL, NULL, NULL, NULL, '14-DIHYDROXY-2-NAPHTHOYL-COA THIOESTERASE 1', 250188),
(401443, 'PTHR43240:SF5', NULL, NULL, NULL, NULL, '1,4-DIHYDROXY-2-NAPHTHOYL-COA THIOESTERASE 1', 250188),
(401444, 'PTHR43240:SF17', NULL, NULL, NULL, NULL, '4HBT DOMAIN-CONTAINING PROTEIN', 250188),
(401445, 'PTHR43240:SF8', NULL, NULL, NULL, NULL, '4HBT DOMAIN-CONTAINING PROTEIN', 250188),
(401446, 'PTHR43240:SF9', NULL, NULL, NULL, NULL, 'PROOFREADING THIOESTERASE ENTH', 250188),
(401447, 'PTHR43240', NULL, NULL, NULL, NULL, '1,4-DIHYDROXY-2-NAPHTHOYL-COA THIOESTERASE 1', 250188),
(401448, 'PTHR43240:SF3', NULL, NULL, NULL, NULL, '4HBT DOMAIN-CONTAINING PROTEIN', 250188),
(401449, 'PTHR43240:SF1', NULL, NULL, NULL, NULL, 'BLR5584 PROTEIN', 250188),
(401450, 'PTHR43240:SF21', NULL, NULL, NULL, NULL, '4HBT DOMAIN-CONTAINING PROTEIN', 250188),
(401451, 'PTHR43240:SF10', NULL, NULL, NULL, NULL, 'BLL4964 PROTEIN', 250188),
(401452, 'PTHR43240:SF20', NULL, NULL, NULL, NULL, 'ESTERASE VNG_1336C-RELATED', 250188),
(401453, 'PTHR43240:SF22', NULL, NULL, NULL, NULL, '1,4-DIHYDROXY-2-NAPHTHOYL-COA THIOESTERASE 1-LIKE', 250188),
(401454, 'PTHR43240:SF14', NULL, NULL, NULL, NULL, '1,4-DIHYDROXY-2-NAPHTHOYL-COA THIOESTERASE 2', 250188),
(401455, 'PTHR43240:SF25', NULL, NULL, NULL, NULL, '14-DIHYDROXY-2-NAPHTHOYL-COA THIOESTERASE 1', 250188),
(401456, 'PTHR43240:SF24', NULL, NULL, NULL, NULL, 'OS05G0137700 PROTEIN', 250188),
(401457, 'PTHR10560:SF0', NULL, NULL, NULL, NULL, 'THROMBOPOIETIN', 250189),
(401458, 'PTHR10560', NULL, NULL, NULL, NULL, 'THROMBOPOIETIN', 250189),
(401459, 'PTHR14418', NULL, NULL, NULL, NULL, 'CONDENSIN COMPLEX SUBUNIT 3-RELATED', 250190),
(401460, 'PTHR14418:SF13', NULL, NULL, NULL, NULL, 'CND3 DOMAIN-CONTAINING PROTEIN', 250190),
(401461, 'PTHR14418:SF9', NULL, NULL, NULL, NULL, 'CND3 DOMAIN-CONTAINING PROTEIN', 250190),
(401462, 'PTHR14418:SF5', NULL, NULL, NULL, NULL, 'CONDENSIN COMPLEX SUBUNIT 3', 250190),
(401463, 'PTHR21255:SF51', NULL, NULL, NULL, NULL, '', 250191),
(401464, 'PTHR21255:SF63', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN TCTEX-TYPE PROTEIN 2B', 250191),
(401465, 'PTHR21255:SF41', NULL, NULL, NULL, NULL, 'LIGHT CHAIN, PUTATIVE-RELATED', 250191),
(401466, 'PTHR21255:SF64', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN TCTEX-TYPE 5', 250191),
(401467, 'PTHR21255:SF20', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN TCTEX-TYPE 3', 250191),
(401468, 'PTHR21255:SF53', NULL, NULL, NULL, NULL, '', 250191),
(401469, 'PTHR21255:SF65', NULL, NULL, NULL, NULL, '', 250191),
(401470, 'PTHR21255:SF70', NULL, NULL, NULL, NULL, 'LIGHT CHAIN, PUTATIVE-RELATED', 250191),
(401471, 'PTHR21255:SF61', NULL, NULL, NULL, NULL, 'TCTEX1 DOMAIN-CONTAINING PROTEIN 1', 250191),
(401472, 'PTHR21255:SF27', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN TCTEX-TYPE PROTEIN 2', 250191),
(401473, 'PTHR21255:SF17', NULL, NULL, NULL, NULL, 'LIGHT CHAIN, PUTATIVE-RELATED', 250191),
(401474, 'PTHR21255:SF55', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN TCTEX-TYPE 4', 250191),
(401475, 'PTHR21255:SF66', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', 250191),
(401476, 'PTHR21255:SF67', NULL, NULL, NULL, NULL, 'INNER ARM DYNEIN LIGHT CHAIN', 250191),
(401477, 'PTHR21255:SF23', NULL, NULL, NULL, NULL, '', 250191),
(401478, 'PTHR21255:SF68', NULL, NULL, NULL, NULL, '', 250191),
(401479, 'PTHR21255:SF57', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN TCTEX-TYPE 1', 250191),
(401480, 'PTHR21255', NULL, NULL, NULL, NULL, 'T-COMPLEX-ASSOCIATED-TESTIS-EXPRESSED 1/ DYNEIN LIGHT CHAIN', 250191),
(401481, 'PTHR21255:SF58', NULL, NULL, NULL, NULL, 'AGAP007597-PA', 250191);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(401482, 'PTHR21255:SF69', NULL, NULL, NULL, NULL, 'AT23443P', 250191),
(401483, 'PTHR21255:SF19', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN TCTEX-TYPE 1', 250191),
(401484, 'PTHR21255:SF7', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN TCTEX-TYPE PROTEIN 2B', 250191),
(401485, 'PTHR21255:SF4', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN TCTEX-TYPE', 250191),
(401486, 'PTHR11841:SF1', NULL, NULL, NULL, NULL, 'REELIN', 250192),
(401487, 'PTHR11841', NULL, NULL, NULL, NULL, 'REELIN', 250192),
(401488, 'PTHR38110', NULL, NULL, NULL, NULL, 'CHROMOSOME 23, WHOLE GENOME SHOTGUN SEQUENCE', 250193),
(401489, 'PTHR38110:SF4', NULL, NULL, NULL, NULL, '', 250193),
(401490, 'PTHR38110:SF3', NULL, NULL, NULL, NULL, '', 250193),
(401491, 'PTHR38110:SF1', NULL, NULL, NULL, NULL, 'USTILAGIC ACID BIOSYNTHESIS CLUSTER PROTEIN ORF2', 250193),
(401492, 'PTHR15857', NULL, NULL, NULL, NULL, 'COMM DOMAIN CONTAINING PROTEIN 2', 250194),
(401493, 'PTHR15857:SF0', NULL, NULL, NULL, NULL, 'COMM DOMAIN-CONTAINING PROTEIN 2', 250194),
(401494, 'PTHR21266:SF29', NULL, NULL, NULL, NULL, 'PROTEIN TIC 55, CHLOROPLASTIC', 250195),
(401495, 'PTHR21266:SF58', NULL, NULL, NULL, NULL, 'PHEOPHORBIDE A OXYGENASE', 250195),
(401496, 'PTHR21266:SF24', NULL, NULL, NULL, NULL, 'PHEOPHORBIDE A OXYGENASE, CHLOROPLASTIC', 250195),
(401497, 'PTHR21266:SF57', NULL, NULL, NULL, NULL, '3-CHLOROBENZOATE-3,4-DIOXYGENASE', 250195),
(401498, 'PTHR21266:SF45', NULL, NULL, NULL, NULL, 'RIESKE DOMAIN-CONTAINING PROTEIN', 250195),
(401499, 'PTHR21266:SF56', NULL, NULL, NULL, NULL, 'RIESKE DOMAIN-CONTAINING PROTEIN', 250195),
(401500, 'PTHR21266:SF55', NULL, NULL, NULL, NULL, 'CHLOROPHYLLIDE A OXYGENASE, CHLOROPLASTIC-LIKE', 250195),
(401501, 'PTHR21266:SF32', NULL, NULL, NULL, NULL, 'PROTOCHLOROPHYLLIDE-DEPENDENT TRANSLOCON COMPONENT 52, CHLOROPLASTIC', 250195),
(401502, 'PTHR21266:SF53', NULL, NULL, NULL, NULL, 'RIESKE DOMAIN-CONTAINING PROTEIN', 250195),
(401503, 'PTHR21266', NULL, NULL, NULL, NULL, 'IRON-SULFUR DOMAIN CONTAINING PROTEIN', 250195),
(401504, 'PTHR21266:SF19', NULL, NULL, NULL, NULL, 'RIESKE DOMAIN-CONTAINING PROTEIN', 250195),
(401505, 'PTHR10223:SF13', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 4', 250196),
(401506, 'PTHR10223:SF12', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 250196),
(401507, 'PTHR10223:SF2', NULL, NULL, NULL, NULL, 'F-BOX AND WD DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_6G11400)', 250196),
(401508, 'PTHR10223:SF15', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 4', 250196),
(401509, 'PTHR10223:SF14', NULL, NULL, NULL, NULL, 'PROTEASOME NON-ATPASE REGULATORY SUBUNIT, PUTATIVE-RELATED', 250196),
(401510, 'PTHR10223:SF0', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 4', 250196),
(401511, 'PTHR10223:SF6', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 4 HOMOLOG ISOFORM X1', 250196),
(401512, 'PTHR10223:SF7', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 4', 250196),
(401513, 'PTHR10223', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 4', 250196),
(401514, 'PTHR10223:SF8', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 250196),
(401515, 'PTHR10223:SF10', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 4-LIKE PROTEIN', 250196),
(401516, 'PTHR28087', NULL, NULL, NULL, NULL, 'ATPASE SYNTHESIS PROTEIN 25, MITOCHONDRIAL', 250197),
(401517, 'PTHR28087:SF1', NULL, NULL, NULL, NULL, 'ATPASE SYNTHESIS PROTEIN 25, MITOCHONDRIAL', 250197),
(401518, 'PTHR42756:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR OF EMRAB OPERON', 250198),
(401519, 'PTHR42756:SF2', NULL, NULL, NULL, NULL, 'MARR FAMILY REGULATORY PROTEIN', 250198),
(401520, 'PTHR42756', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, MARR', 250198),
(401521, 'PTHR12999:SF22', NULL, NULL, NULL, NULL, 'ZINC FINGER RAN-BINDING DOMAIN-CONTAINING PROTEIN 2', 250199),
(401522, 'PTHR12999:SF21', NULL, NULL, NULL, NULL, 'ZINC FINGER RAN-BINDING DOMAIN-CONTAINING PROTEIN 2', 250199);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(401523, 'PTHR12999:SF20', NULL, NULL, NULL, NULL, 'BNAA02G07600D PROTEIN', 250199),
(401524, 'PTHR12999:SF23', NULL, NULL, NULL, NULL, '', 250199),
(401525, 'PTHR12999', NULL, NULL, NULL, NULL, 'ZINC FINGER RAN-BINDING DOMAIN-CONTAINING PROTEIN 2 ZRANB2-RELATED', 250199),
(401526, 'PTHR12999:SF19', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 15B-LIKE', 250199),
(401527, 'PTHR12999:SF18', NULL, NULL, NULL, NULL, 'BNAA08G29860D PROTEIN', 250199),
(401528, 'PTHR12999:SF17', NULL, NULL, NULL, NULL, 'ZINC FINGER RAN-BINDING DOMAIN-CONTAINING PROTEIN 2', 250199),
(401529, 'PTHR12999:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 15B', 250199),
(401530, 'PTHR12867', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE-RELATED', 250200),
(401531, 'PTHR12867:SF9', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL UDP-N-ACETYLGLUCOSAMINE TRANSFERASE AND DEUBIQUITINASE ALG13-RELATED', 250200),
(401532, 'PTHR12867:SF7', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINYLDIPHOSPHODOLICHOL N-ACETYLGLUCOSAMINYLTRANSFERASE', 250200),
(401533, 'PTHR12867:SF8', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINYLDIPHOSPHODOLICHOL N-ACETYLGLUCOSAMINYLTRANSFERASE', 250200),
(401534, 'PTHR12867:SF6', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINYLDIPHOSPHODOLICHOL N-ACETYLGLUCOSAMINYLTRANSFERASE', 250200),
(401535, 'PTHR24361:SF759', NULL, NULL, NULL, NULL, 'MAP KINASE KINASE', 250201),
(401536, 'PTHR24361:SF836', NULL, NULL, NULL, NULL, 'NIMA-RELATED KINASE 12', 250201),
(401537, 'PTHR24361:SF837', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE C01C4.3-RELATED', 250201),
(401538, 'PTHR24361:SF816', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE 6', 250201),
(401539, 'PTHR24361:SF739', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE OSR1-LIKE', 250201),
(401540, 'PTHR24361:SF838', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 22', 250201),
(401541, 'PTHR24361:SF718', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE 9-LIKE', 250201),
(401542, 'PTHR24361:SF678', NULL, NULL, NULL, NULL, 'SPORULATION-SPECIFIC PROTEIN 1', 250201),
(401543, 'PTHR24361:SF656', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 3', 250201),
(401544, 'PTHR24361:SF711', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250201),
(401545, 'PTHR24361:SF832', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 250201),
(401546, 'PTHR24361:SF414', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 1-RELATED', 250201),
(401547, 'PTHR24361:SF613', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NEK4', 250201),
(401548, 'PTHR24361:SF735', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE 1', 250201),
(401549, 'PTHR24361:SF834', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 250201),
(401550, 'PTHR24361:SF714', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE 8', 250201),
(401551, 'PTHR24361:SF835', NULL, NULL, NULL, NULL, 'KINASE, NEK', 250201),
(401552, 'PTHR24361:SF256', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE MKCB-RELATED', 250201),
(401553, 'PTHR24361:SF433', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250201),
(401554, 'PTHR24361:SF831', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE 9', 250201),
(401555, 'PTHR24361', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED KINASE KINASE KINASE', 250201),
(401556, 'PTHR24361:SF819', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250201),
(401557, 'PTHR24361:SF826', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250201),
(401558, 'PTHR24361:SF827', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250201),
(401559, 'PTHR24361:SF707', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250201),
(401560, 'PTHR24361:SF722', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE 5', 250201),
(401561, 'PTHR24361:SF843', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250201);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(401562, 'PTHR24361:SF844', NULL, NULL, NULL, NULL, 'MITOGEN ACTIVATED PROTEIN KINASE KINASE 1.2', 250201),
(401563, 'PTHR24361:SF822', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250201),
(401564, 'PTHR24361:SF845', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 250201),
(401565, 'PTHR24361:SF823', NULL, NULL, NULL, NULL, 'OS02G0787300 PROTEIN', 250201),
(401566, 'PTHR24361:SF824', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NEK6', 250201),
(401567, 'PTHR24361:SF648', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0284251-RELATED', 250201),
(401568, 'PTHR24361:SF747', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE 10', 250201),
(401569, 'PTHR24361:SF846', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0291918-RELATED', 250201),
(401570, 'PTHR24361:SF769', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE 7-RELATED', 250201),
(401571, 'PTHR24361:SF762', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE 4', 250201),
(401572, 'PTHR24361:SF641', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 250201),
(401573, 'PTHR24361:SF785', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY MITOGEN-ACTIVATED PROTEIN KINASE KINASE 1', 250201),
(401574, 'PTHR24361:SF842', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 250201),
(401575, 'PTHR24361:SF342', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 2', 250201),
(401576, 'PTHR24361:SF486', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE MKCD-RELATED', 250201),
(401577, 'PTHR24361:SF393', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0270146-RELATED', 250201),
(401578, 'PTHR24361:SF492', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE MKCF-RELATED', 250201),
(401579, 'PTHR24361:SF829', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250201),
(401580, 'PTHR47755:SF1', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN FTSX', 250202),
(401581, 'PTHR47755', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN FTSX', 250202),
(401582, 'PTHR10978:SF19', NULL, NULL, NULL, NULL, '', 250203),
(401583, 'PTHR10978:SF5', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE CYTOCHROME B560 SUBUNIT, MITOCHONDRIAL', 250203),
(401584, 'PTHR10978', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE CYTOCHROME B560 SUBUNIT', 250203),
(401585, 'PTHR10978:SF2', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE COMPLEX SUBUNIT C', 250203),
(401586, 'PTHR10978:SF14', NULL, NULL, NULL, NULL, '', 250203),
(401587, 'PTHR10978:SF16', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE CYTOCHROME B560 SUBUNIT, MITOCHONDRIAL', 250203),
(401588, 'PTHR10978:SF15', NULL, NULL, NULL, NULL, '', 250203),
(401589, 'PTHR10978:SF18', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE SUBUNIT 3-1, MITOCHONDRIAL', 250203),
(401590, 'PTHR10978:SF17', NULL, NULL, NULL, NULL, '', 250203),
(401591, 'PTHR35347:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 175', 250204),
(401592, 'PTHR35347', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 175', 250204),
(401593, 'PTHR38106', NULL, NULL, NULL, NULL, 'RNA CHAPERONE PROQ', 250205),
(401594, 'PTHR38106:SF1', NULL, NULL, NULL, NULL, 'RNA CHAPERONE PROQ', 250205),
(401595, 'PTHR48033:SF16', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 250206),
(401596, 'PTHR48033:SF12', NULL, NULL, NULL, NULL, '(RICE GENOME ANNOTATION PROJECT) RNA RECOGNITION MOTIF FAMILY PROTEIN', 250206),
(401597, 'PTHR48033:SF15', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 250206),
(401598, 'PTHR48033:SF14', NULL, NULL, NULL, NULL, 'RNA-BINDING MOTIF 31, Y-LINKED', 250206),
(401599, 'PTHR48033:SF11', NULL, NULL, NULL, NULL, '', 250206),
(401600, 'PTHR48033:SF9', NULL, NULL, NULL, NULL, 'TAR DNA-BINDING PROTEIN 43', 250206),
(401601, 'PTHR48033:SF10', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN SQUID', 250206),
(401602, 'PTHR48033', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 250206),
(401603, 'PTHR48033:SF2', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN D-LIKE', 250206);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(401604, 'PTHR48033:SF1', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN A/B', 250206),
(401605, 'PTHR48033:SF4', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-BINDING ALPHA-BETA PLAIT DOMAIN-CONTAINING PROTEIN-RELATED', 250206),
(401606, 'PTHR48033:SF3', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN D0', 250206),
(401607, 'PTHR48033:SF6', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 250206),
(401608, 'PTHR48033:SF5', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-BINDING ALPHA-BETA PLAIT DOMAIN-CONTAINING PROTEIN-RELATED', 250206),
(401609, 'PTHR31911', NULL, NULL, NULL, NULL, 'PROTEIN FAM133', 250207),
(401610, 'PTHR31911:SF5', NULL, NULL, NULL, NULL, '', 250207),
(401611, 'PTHR31911:SF4', NULL, NULL, NULL, NULL, 'PROTEIN FAM133A', 250207),
(401612, 'PTHR31911:SF3', NULL, NULL, NULL, NULL, 'PROTEIN FAM133B', 250207),
(401613, 'PTHR31911:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAM133', 250207),
(401614, 'PTHR24086:SF18', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR SUBFAMILY 5 GROUP A MEMBER 2', 250208),
(401615, 'PTHR24086', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR SUBFAMILY 5 GROUP A', 250208),
(401616, 'PTHR24086:SF47', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 250208),
(401617, 'PTHR24086:SF25', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FTZ-F1 BETA', 250208),
(401618, 'PTHR24086:SF15', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FTZ-F1', 250208),
(401619, 'PTHR24086:SF24', NULL, NULL, NULL, NULL, 'STEROIDOGENIC FACTOR 1', 250208),
(401620, 'PTHR24086:SF43', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR DOMAIN-CONTAINING PROTEIN', 250208),
(401621, 'PTHR24086:SF44', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY-RELATED', 250208),
(401622, 'PTHR24086:SF42', NULL, NULL, NULL, NULL, 'NR5A5 PROTEIN', 250208),
(401623, 'PTHR31463:SF4', NULL, NULL, NULL, NULL, 'MACROPHAGE-EXPRESSED GENE 1 PROTEIN', 250209),
(401624, 'PTHR31463:SF5', NULL, NULL, NULL, NULL, 'MACROPHAGE-EXPRESSED GENE 1 PROTEIN', 250209),
(401625, 'PTHR31463:SF6', NULL, NULL, NULL, NULL, 'MACROPHAGE-EXPRESSED GENE 1 PROTEIN', 250209),
(401626, 'PTHR31463:SF7', NULL, NULL, NULL, NULL, 'MACROPHAGE-EXPRESSED GENE 1 PROTEIN', 250209),
(401627, 'PTHR31463', NULL, NULL, NULL, NULL, 'MACROPHAGE-EXPRESSED GENE 1 PROTEIN', 250209),
(401628, 'PTHR31463:SF1', NULL, NULL, NULL, NULL, 'EPG-6', 250209),
(401629, 'PTHR10333:SF100', NULL, NULL, NULL, NULL, 'CHROMATIN MODIFICATION-RELATED PROTEIN YNG2', 250210),
(401630, 'PTHR10333:SF94', NULL, NULL, NULL, NULL, 'PROTEIN YNG1', 250210),
(401631, 'PTHR10333:SF104', NULL, NULL, NULL, NULL, 'CHROMATIN MODIFICATION-RELATED PROTEIN PNG1', 250210),
(401632, 'PTHR10333:SF42', NULL, NULL, NULL, NULL, 'INHIBITOR OF GROWTH PROTEIN', 250210),
(401633, 'PTHR10333:SF105', NULL, NULL, NULL, NULL, 'INHIBITOR OF GROWTH PROTEIN', 250210),
(401634, 'PTHR10333:SF85', NULL, NULL, NULL, NULL, 'INHIBITOR OF GROWTH PROTEIN 1', 250210),
(401635, 'PTHR10333:SF41', NULL, NULL, NULL, NULL, 'INHIBITOR OF GROWTH PROTEIN 5', 250210),
(401636, 'PTHR10333:SF99', NULL, NULL, NULL, NULL, 'INHIBITOR OF GROWTH PROTEIN 3', 250210),
(401637, 'PTHR10333:SF103', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN ING1', 250210),
(401638, 'PTHR10333:SF79', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', 250210),
(401639, 'PTHR10333:SF89', NULL, NULL, NULL, NULL, 'INHIBITOR OF GROWTH PROTEIN', 250210),
(401640, 'PTHR10333:SF37', NULL, NULL, NULL, NULL, 'INHIBITOR OF GROWTH PROTEIN 2', 250210),
(401641, 'PTHR10333:SF106', NULL, NULL, NULL, NULL, 'INHIBITOR OF GROWTH PROTEIN 4', 250210),
(401642, 'PTHR10333', NULL, NULL, NULL, NULL, 'INHIBITOR OF GROWTH PROTEIN', 250210),
(401643, 'PTHR20902:SF0', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT 5', 250211),
(401644, 'PTHR20902:SF1', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT', 250211),
(401645, 'PTHR20902', NULL, NULL, NULL, NULL, '41-2 PROTEIN ANTIGEN-RELATED', 250211),
(401646, 'PTHR37962:SF2', NULL, NULL, NULL, NULL, 'MALE STERILE (3) 76CA', 250212);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(401647, 'PTHR37962:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG09348', 250212),
(401648, 'PTHR37962', NULL, NULL, NULL, NULL, 'MALE STERILE (3) 76CA', 250212),
(401649, 'PTHR38467:SF1', NULL, NULL, NULL, NULL, 'CONJUGATIVE TRANSFER: ASSEMBLY', 250213),
(401650, 'PTHR38467', NULL, NULL, NULL, NULL, '', 250213),
(401651, 'PTHR31742', NULL, NULL, NULL, NULL, 'RPA-INTERACTING PROTEIN RPAIN', 250214),
(401652, 'PTHR31742:SF1', NULL, NULL, NULL, NULL, 'RPA-INTERACTING PROTEIN', 250214),
(401653, 'PTHR45036:SF1', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 250215),
(401654, 'PTHR45036:SF4', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 250215),
(401655, 'PTHR45036:SF5', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE-LIKE 7A1-RELATED', 250215),
(401656, 'PTHR45036:SF6', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE-LIKE PROTEIN 7B', 250215),
(401657, 'PTHR45036', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE LIKE 7B', 250215),
(401658, 'PTHR45036:SF7', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 250215),
(401659, 'PTHR45036:SF8', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 250215),
(401660, 'PTHR31485:SF3', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE O-ARABINOSYLTRANSFERASE 1', 250216),
(401661, 'PTHR31485:SF20', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE O-ARABINOSYLTRANSFERASE 2', 250216),
(401662, 'PTHR31485:SF31', NULL, NULL, NULL, NULL, '', 250216),
(401663, 'PTHR31485:SF7', NULL, NULL, NULL, NULL, 'PEPTIDYL SERINE ALPHA-GALACTOSYLTRANSFERASE', 250216),
(401664, 'PTHR31485:SF32', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE O-ARABINOSYLTRANSFERASE 3', 250216),
(401665, 'PTHR31485:SF4', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE O-ARABINOSYLTRANSFERASE RDN1', 250216),
(401666, 'PTHR31485:SF35', NULL, NULL, NULL, NULL, '', 250216),
(401667, 'PTHR31485:SF24', NULL, NULL, NULL, NULL, 'BNAA09G04630D PROTEIN', 250216),
(401668, 'PTHR31485:SF33', NULL, NULL, NULL, NULL, 'PEPTIDYL SERINE ALPHA-GALACTOSYLTRANSFERASE', 250216),
(401669, 'PTHR31485:SF23', NULL, NULL, NULL, NULL, 'BNAC09G43590D PROTEIN', 250216),
(401670, 'PTHR31485:SF34', NULL, NULL, NULL, NULL, 'OS05G0386000 PROTEIN', 250216),
(401671, 'PTHR31485:SF17', NULL, NULL, NULL, NULL, '', 250216),
(401672, 'PTHR31485:SF27', NULL, NULL, NULL, NULL, '', 250216),
(401673, 'PTHR31485', NULL, NULL, NULL, NULL, 'PEPTIDYL SERINE ALPHA-GALACTOSYLTRANSFERASE', 250216),
(401674, 'PTHR33650:SF1', NULL, NULL, NULL, NULL, 'CHLOROPLAST ENVELOPE MEMBRANE PROTEIN', 250217),
(401675, 'PTHR33650', NULL, NULL, NULL, NULL, 'CHLOROPLAST ENVELOPE MEMBRANE PROTEIN-RELATED', 250217),
(401676, 'PTHR33650:SF2', NULL, NULL, NULL, NULL, 'CHLOROPLAST ENVELOPE MEMBRANE PROTEIN', 250217),
(401677, 'PTHR33650:SF3', NULL, NULL, NULL, NULL, 'CEMA-LIKE PROTON EXTRUSION PROTEIN-RELATED', 250217),
(401678, 'PTHR15977:SF15', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 46', 250218),
(401679, 'PTHR15977', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 46', 250218),
(401680, 'PTHR40255', NULL, NULL, NULL, NULL, 'UPF0093 MEMBRANE PROTEIN SLR1790', 250219),
(401681, 'PTHR40255:SF1', NULL, NULL, NULL, NULL, 'PROTOPORPHYRINOGEN IX OXIDASE', 250219),
(401682, 'PTHR19853', NULL, NULL, NULL, NULL, 'WD REPEAT CONTAINING PROTEIN 3  WDR3', 250220),
(401683, 'PTHR19853:SF0', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 3', 250220),
(401684, 'PTHR19853:SF1', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 31', 250220),
(401685, 'PTHR28142:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL INNER MEMBRANE I-AAA PROTEASE SUPERCOMPLEX SUBUNIT MGR3-RELATED', 250221),
(401686, 'PTHR28142', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL INNER MEMBRANE I-AAA PROTEASE SUPERCOMPLEX SUBUNIT MGR3-RELATED', 250221),
(401687, 'PTHR33540:SF2', NULL, NULL, NULL, NULL, 'TRNA THREONYLCARBAMOYLADENOSINE BIOSYNTHESIS PROTEIN TSAE', 250222),
(401688, 'PTHR33540', NULL, NULL, NULL, NULL, 'TRNA THREONYLCARBAMOYLADENOSINE BIOSYNTHESIS PROTEIN TSAE', 250222);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(401689, 'PTHR33540:SF1', NULL, NULL, NULL, NULL, 'N-ACETYLMURAMATE/N-ACETYLGLUCOSAMINE KINASE', 250222),
(401690, 'PTHR47037:SF1', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L33, MITOCHONDRIAL', 250223),
(401691, 'PTHR47037', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L33, MITOCHONDRIAL', 250223),
(401692, 'PTHR36760:SF3', NULL, NULL, NULL, NULL, '', 250224),
(401693, 'PTHR36760:SF1', NULL, NULL, NULL, NULL, 'ACIDIC LEUCINE-RICH NUCLEAR PHOSPHOPROTEIN 32 FAMILY B PROTEIN', 250224),
(401694, 'PTHR36760:SF2', NULL, NULL, NULL, NULL, '', 250224),
(401695, 'PTHR36760', NULL, NULL, NULL, NULL, 'ACIDIC LEUCINE-RICH NUCLEAR PHOSPHOPROTEIN 32 FAMILY B PROTEIN', 250224),
(401696, 'PTHR38760', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE', 250225),
(401697, 'PTHR38760:SF1', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE', 250225),
(401698, 'PTHR10747', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR COE FAMILY MEMBER', 250226),
(401699, 'PTHR10747:SF40', NULL, NULL, NULL, NULL, 'IPT/TIG DOMAIN-CONTAINING PROTEIN', 250226),
(401700, 'PTHR10747:SF39', NULL, NULL, NULL, NULL, 'IPT/TIG DOMAIN-CONTAINING PROTEIN', 250226),
(401701, 'PTHR10747:SF38', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR COLLIER', 250226),
(401702, 'PTHR10747:SF26', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR COE1', 250226),
(401703, 'PTHR10747:SF36', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR COE4', 250226),
(401704, 'PTHR10747:SF4', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR COE3', 250226),
(401705, 'PTHR10747:SF33', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR COE2', 250226),
(401706, 'PTHR42152:SF1', NULL, NULL, NULL, NULL, 'PROTEIN GDF5-AS1, MITOCHONDRIAL', 250227),
(401707, 'PTHR42152:SF2', NULL, NULL, NULL, NULL, '', 250227),
(401708, 'PTHR42152', NULL, NULL, NULL, NULL, 'PROTEIN GDF5OS, MITOCHONDRIAL', 250227),
(401709, 'PTHR34582:SF6', NULL, NULL, NULL, NULL, 'UPF0702 TRANSMEMBRANE PROTEIN YCAP', 250228),
(401710, 'PTHR34582:SF5', NULL, NULL, NULL, NULL, 'UPF0702 TRANSMEMBRANE PROTEIN YETF', 250228),
(401711, 'PTHR34582:SF7', NULL, NULL, NULL, NULL, 'UPF0702 TRANSMEMBRANE PROTEIN YDFS', 250228),
(401712, 'PTHR34582', NULL, NULL, NULL, NULL, 'UPF0702 TRANSMEMBRANE PROTEIN YCAP', 250228),
(401713, 'PTHR34582:SF2', NULL, NULL, NULL, NULL, 'UPF0702 TRANSMEMBRANE PROTEIN YDFR', 250228),
(401714, 'PTHR47212:SF8', NULL, NULL, NULL, NULL, 'DUF4378 DOMAIN-CONTAINING PROTEIN', 250229),
(401715, 'PTHR47212:SF10', NULL, NULL, NULL, NULL, 'DUF4378 DOMAIN-CONTAINING PROTEIN', 250229),
(401716, 'PTHR47212:SF11', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL N-ACETYGLUCOSAMINLYTRANSFERASE SUBUNIT P-LIKE PROTEIN', 250229),
(401717, 'PTHR47212:SF7', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL N-ACETYGLUCOSAMINLYTRANSFERASE SUBUNIT P-LIKE PROTEIN', 250229),
(401718, 'PTHR47212:SF4', NULL, NULL, NULL, NULL, 'ADHESIN-LIKE PROTEIN, PUTATIVE (DUF3741)-RELATED', 250229),
(401719, 'PTHR47212:SF14', NULL, NULL, NULL, NULL, '', 250229),
(401720, 'PTHR47212:SF15', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL N-ACETYGLUCOSAMINLYTRANSFERASE SUBUNIT P-LIKE PROTEIN', 250229),
(401721, 'PTHR47212:SF6', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL N-ACETYGLUCOSAMINLYTRANSFERASE SUBUNIT P-LIKE PROTEIN', 250229),
(401722, 'PTHR47212:SF13', NULL, NULL, NULL, NULL, '', 250229),
(401723, 'PTHR47212:SF16', NULL, NULL, NULL, NULL, 'BNAA09G12400D PROTEIN', 250229),
(401724, 'PTHR47212:SF2', NULL, NULL, NULL, NULL, 'DUF3741 FAMILY PROTEIN', 250229),
(401725, 'PTHR47212', NULL, NULL, NULL, NULL, 'ADHESIN-LIKE PROTEIN, PUTATIVE (DUF3741)-RELATED', 250229),
(401726, 'PTHR44196:SF3', NULL, NULL, NULL, NULL, 'SHORT CHAIN DEHYDROGENASE FAMILY PROTEIN', 250230),
(401727, 'PTHR44196:SF4', NULL, NULL, NULL, NULL, 'SHORT CHAIN DEHYDROGENASE', 250230),
(401728, 'PTHR44196:SF1', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE SDR FAMILY MEMBER 7B', 250230),
(401729, 'PTHR44196:SF2', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE-RELATED', 250230),
(401730, 'PTHR44196', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE SDR FAMILY MEMBER 7B', 250230),
(401731, 'PTHR31493:SF1', NULL, NULL, NULL, NULL, 'PROTEIN C19ORF12', 250231);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(401732, 'PTHR31493', NULL, NULL, NULL, NULL, 'NAZO FAMILY MEMBER', 250231),
(401733, 'PTHR43423', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER I FAMILY MEMBER 17', 250232),
(401734, 'PTHR43423:SF11', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 250232),
(401735, 'PTHR43423:SF10', NULL, NULL, NULL, NULL, 'PHOSPHATE IMPORT ATP-BINDING PROTEIN PSTB 2', 250232),
(401736, 'PTHR43423:SF12', NULL, NULL, NULL, NULL, 'IRON EXPORT ATP-BINDING PROTEIN FETA-RELATED', 250232),
(401737, 'PTHR43423:SF9', NULL, NULL, NULL, NULL, 'PHOSPHATE IMPORT ATP-BINDING PROTEIN PSTB 3', 250232),
(401738, 'PTHR43423:SF7', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 250232),
(401739, 'PTHR43423:SF3', NULL, NULL, NULL, NULL, 'PHOSPHATE IMPORT ATP-BINDING PROTEIN PSTB', 250232),
(401740, 'PTHR43423:SF1', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER I FAMILY MEMBER 17', 250232),
(401741, 'PTHR15868:SF0', NULL, NULL, NULL, NULL, 'SIMILAR TO RIKEN CDNA 6430571L13 GENE_ SIMILAR TO G20 PROTEIN', 250233),
(401742, 'PTHR15868', NULL, NULL, NULL, NULL, 'SIMILAR TO RIKEN CDNA 6430571L13 GENE, SIMILAR TO G20 PROTEIN', 250233),
(401743, 'PTHR10544:SF0', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L28', 250234),
(401744, 'PTHR10544:SF18', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L28-1-LIKE', 250234),
(401745, 'PTHR10544:SF19', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L28-1-LIKE', 250234),
(401746, 'PTHR10544:SF16', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L28E DOMAIN-CONTAINING PROTEIN', 250234),
(401747, 'PTHR10544:SF27', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L28E DOMAIN-CONTAINING PROTEIN', 250234),
(401748, 'PTHR10544', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L28', 250234),
(401749, 'PTHR10544:SF17', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L28E DOMAIN-CONTAINING PROTEIN', 250234),
(401750, 'PTHR10544:SF28', NULL, NULL, NULL, NULL, 'BNAC08G49400D PROTEIN', 250234),
(401751, 'PTHR10544:SF25', NULL, NULL, NULL, NULL, '', 250234),
(401752, 'PTHR10544:SF15', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L28E DOMAIN-CONTAINING PROTEIN', 250234),
(401753, 'PTHR10544:SF7', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L28-2', 250234),
(401754, 'PTHR10544:SF26', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L28-1', 250234),
(401755, 'PTHR10544:SF12', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L28', 250234),
(401756, 'PTHR10544:SF24', NULL, NULL, NULL, NULL, 'OS05G0541900 PROTEIN', 250234),
(401757, 'PTHR10544:SF10', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L28', 250234),
(401758, 'PTHR10544:SF20', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L28-1-LIKE', 250234),
(401759, 'PTHR30164:SF2', NULL, NULL, NULL, NULL, 'PROTEIN MTFA', 250235),
(401760, 'PTHR30164', NULL, NULL, NULL, NULL, 'MTFA PEPTIDASE', 250235),
(401761, 'PTHR31471:SF86', NULL, NULL, NULL, NULL, 'REMORIN_C DOMAIN-CONTAINING PROTEIN', 250236),
(401762, 'PTHR31471:SF63', NULL, NULL, NULL, NULL, 'REMORIN-RELATED', 250236),
(401763, 'PTHR31471:SF85', NULL, NULL, NULL, NULL, 'REMORIN-LIKE', 250236),
(401764, 'PTHR31471:SF66', NULL, NULL, NULL, NULL, 'CARBOXY-TERMINAL REGION REMORIN', 250236),
(401765, 'PTHR31471:SF88', NULL, NULL, NULL, NULL, 'OS04G0620200 PROTEIN', 250236),
(401766, 'PTHR31471:SF87', NULL, NULL, NULL, NULL, 'REMORIN 4.2', 250236),
(401767, 'PTHR31471:SF89', NULL, NULL, NULL, NULL, 'OS03G0808300 PROTEIN', 250236),
(401768, 'PTHR31471:SF47', NULL, NULL, NULL, NULL, 'REMORIN 4.1', 250236),
(401769, 'PTHR31471:SF62', NULL, NULL, NULL, NULL, 'REMORIN_C DOMAIN-CONTAINING PROTEIN', 250236),
(401770, 'PTHR31471:SF84', NULL, NULL, NULL, NULL, 'REMORIN_C DOMAIN-CONTAINING PROTEIN', 250236),
(401771, 'PTHR31471:SF40', NULL, NULL, NULL, NULL, 'OS08G0471800 PROTEIN', 250236),
(401772, 'PTHR31471:SF3', NULL, NULL, NULL, NULL, 'OS11G0616300 PROTEIN', 250236),
(401773, 'PTHR31471:SF5', NULL, NULL, NULL, NULL, 'GB|AAD39278.1', 250236),
(401774, 'PTHR31471:SF49', NULL, NULL, NULL, NULL, 'REMORIN FAMILY PROTEIN', 250236),
(401775, 'PTHR31471:SF2', NULL, NULL, NULL, NULL, 'REMORIN FAMILY PROTEIN', 250236),
(401776, 'PTHR31471:SF1', NULL, NULL, NULL, NULL, 'OS02G0116800 PROTEIN', 250236); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(401777, 'PTHR31471:SF53', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN', 250236),
(401778, 'PTHR31471:SF52', NULL, NULL, NULL, NULL, 'F12A21.28', 250236),
(401779, 'PTHR31471:SF74', NULL, NULL, NULL, NULL, 'PROTEASOME_ALPHA_1 DOMAIN-CONTAINING PROTEIN', 250236),
(401780, 'PTHR31471:SF11', NULL, NULL, NULL, NULL, 'OS07G0208600 PROTEIN', 250236),
(401781, 'PTHR31471:SF54', NULL, NULL, NULL, NULL, 'REMORIN_C DOMAIN-CONTAINING PROTEIN', 250236),
(401782, 'PTHR31471:SF79', NULL, NULL, NULL, NULL, 'REMORIN-RELATED', 250236),
(401783, 'PTHR31471:SF13', NULL, NULL, NULL, NULL, 'REMORIN FAMILY PROTEIN', 250236),
(401784, 'PTHR31471:SF58', NULL, NULL, NULL, NULL, 'REMORIN_C DOMAIN-CONTAINING PROTEIN', 250236),
(401785, 'PTHR31471:SF91', NULL, NULL, NULL, NULL, 'REMORIN FAMILY PROTEIN', 250236),
(401786, 'PTHR31471:SF90', NULL, NULL, NULL, NULL, 'OS03G0211500 PROTEIN', 250236),
(401787, 'PTHR31471:SF93', NULL, NULL, NULL, NULL, 'REMORIN-RELATED', 250236),
(401788, 'PTHR31471:SF70', NULL, NULL, NULL, NULL, 'REMORIN_C DOMAIN-CONTAINING PROTEIN', 250236),
(401789, 'PTHR31471:SF92', NULL, NULL, NULL, NULL, 'REMORIN FAMILY PROTEIN-RELATED', 250236),
(401790, 'PTHR31471:SF95', NULL, NULL, NULL, NULL, 'CHROMODOMAIN-HELICASE-DNA-BINDING PROTEIN 7-LIKE ISOFORM X1', 250236),
(401791, 'PTHR31471:SF73', NULL, NULL, NULL, NULL, 'REMORIN FAMILY PROTEIN', 250236),
(401792, 'PTHR31471:SF51', NULL, NULL, NULL, NULL, 'REMORIN FAMILY PROTEIN', 250236),
(401793, 'PTHR31471:SF72', NULL, NULL, NULL, NULL, 'REMORIN_C DOMAIN-CONTAINING PROTEIN', 250236),
(401794, 'PTHR31471:SF94', NULL, NULL, NULL, NULL, 'REMORIN-RELATED', 250236),
(401795, 'PTHR31471:SF16', NULL, NULL, NULL, NULL, 'OS02G0602000 PROTEIN', 250236),
(401796, 'PTHR31471:SF18', NULL, NULL, NULL, NULL, 'OS03G0120200 PROTEIN', 250236),
(401797, 'PTHR31471', NULL, NULL, NULL, NULL, 'OS02G0116800 PROTEIN', 250236),
(401798, 'PTHR46946:SF1', NULL, NULL, NULL, NULL, 'NEURITE EXTENSION AND MIGRATION FACTOR', 250237),
(401799, 'PTHR46946', NULL, NULL, NULL, NULL, 'NEURITE EXTENSION AND MIGRATION FACTOR', 250237),
(401800, 'PTHR35085:SF2', NULL, NULL, NULL, NULL, 'KERATINOCYTE DIFFERENTIATION FACTOR 1B', 250238),
(401801, 'PTHR35085', NULL, NULL, NULL, NULL, 'KERATINOCYTE DIFFERENTIATION FACTOR 1', 250238),
(401802, 'PTHR35085:SF1', NULL, NULL, NULL, NULL, 'KERATINOCYTE DIFFERENTIATION FACTOR 1', 250238),
(401803, 'PTHR47931', NULL, NULL, NULL, NULL, 'OS01G0228400 PROTEIN', 250239),
(401804, 'PTHR47931:SF1', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 250239),
(401805, 'PTHR47931:SF2', NULL, NULL, NULL, NULL, 'OS01G0228400 PROTEIN', 250239),
(401806, 'PTHR15245:SF39', NULL, NULL, NULL, NULL, 'SYMPLEKIN-RELATED', 250240),
(401807, 'PTHR15245:SF20', NULL, NULL, NULL, NULL, 'SYMPLEKIN', 250240),
(401808, 'PTHR15245:SF40', NULL, NULL, NULL, NULL, 'BNAA09G27860D PROTEIN', 250240),
(401809, 'PTHR15245', NULL, NULL, NULL, NULL, 'SYMPLEKIN-RELATED', 250240),
(401810, 'PTHR28208', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE PHOSPHATASE APP1', 250241),
(401811, 'PTHR28208:SF3', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE PHOSPHATASE APP1', 250241),
(401812, 'PTHR28208:SF2', NULL, NULL, NULL, NULL, 'DUF2183 DOMAIN-CONTAINING PROTEIN', 250241),
(401813, 'PTHR28208:SF1', NULL, NULL, NULL, NULL, 'FILAMENT ORGANIZATION PROTEIN APP1-LIKE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G06650)-RELATED', 250241),
(401814, 'PTHR22594:SF16', NULL, NULL, NULL, NULL, 'ASPARAGINE--TRNA LIGASE, CYTOPLASMIC', 250242),
(401815, 'PTHR22594:SF49', NULL, NULL, NULL, NULL, 'WHEP-TRS DOMAIN-CONTAINING PROTEIN', 250242),
(401816, 'PTHR22594:SF50', NULL, NULL, NULL, NULL, 'ASPARAGINE--TRNA LIGASE', 250242),
(401817, 'PTHR22594:SF51', NULL, NULL, NULL, NULL, 'TRNA-SYNT_2 DOMAIN-CONTAINING PROTEIN', 250242),
(401818, 'PTHR22594:SF53', NULL, NULL, NULL, NULL, 'ASPARAGINE--TRNA LIGASE', 250242),
(401819, 'PTHR22594', NULL, NULL, NULL, NULL, 'ASPARTYL/LYSYL-TRNA SYNTHETASE', 250242),
(401820, 'PTHR22594:SF54', NULL, NULL, NULL, NULL, 'ASPARAGINE--TRNA LIGASE, CYTOPLASMIC 1-RELATED', 250242),
(401821, 'PTHR22594:SF55', NULL, NULL, NULL, NULL, 'BNAA08G11450D PROTEIN', 250242);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(401822, 'PTHR22594:SF34', NULL, NULL, NULL, NULL, 'ASPARAGINE--TRNA LIGASE, MITOCHONDRIAL-RELATED', 250242),
(401823, 'PTHR22594:SF5', NULL, NULL, NULL, NULL, 'ASPARTATE--TRNA LIGASE, MITOCHONDRIAL', 250242),
(401824, 'PTHR22594:SF36', NULL, NULL, NULL, NULL, 'ASPARAGINE--TRNA LIGASE, CYTOPLASMIC 2', 250242),
(401825, 'PTHR22594:SF48', NULL, NULL, NULL, NULL, 'ASPARAGINYL-TRNA SYNTHETASE-RELATED PROTEIN (N-TRUNCATION)', 250242),
(401826, 'PTHR36483:SF3', NULL, NULL, NULL, NULL, '', 250243),
(401827, 'PTHR36483:SF11', NULL, NULL, NULL, NULL, '', 250243),
(401828, 'PTHR36483:SF10', NULL, NULL, NULL, NULL, 'OS01G0595001 PROTEIN', 250243),
(401829, 'PTHR36483:SF5', NULL, NULL, NULL, NULL, '', 250243),
(401830, 'PTHR36483', NULL, NULL, NULL, NULL, 'OS02G0130700 PROTEIN', 250243),
(401831, 'PTHR36483:SF1', NULL, NULL, NULL, NULL, 'OS02G0130700 PROTEIN', 250243),
(401832, 'PTHR36483:SF2', NULL, NULL, NULL, NULL, '', 250243),
(401833, 'PTHR36483:SF7', NULL, NULL, NULL, NULL, '', 250243),
(401834, 'PTHR36483:SF8', NULL, NULL, NULL, NULL, '', 250243),
(401835, 'PTHR36483:SF9', NULL, NULL, NULL, NULL, '', 250243),
(401836, 'PTHR10485:SF24', NULL, NULL, NULL, NULL, '', 250244),
(401837, 'PTHR10485:SF13', NULL, NULL, NULL, NULL, '', 250244),
(401838, 'PTHR10485:SF22', NULL, NULL, NULL, NULL, 'BNAC08G19240D PROTEIN', 250244),
(401839, 'PTHR10485:SF28', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM17-1', 250244),
(401840, 'PTHR10485:SF15', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM17-3', 250244),
(401841, 'PTHR10485:SF25', NULL, NULL, NULL, NULL, 'BNAC08G19210D PROTEIN', 250244),
(401842, 'PTHR10485:SF0', NULL, NULL, NULL, NULL, 'AT05822P-RELATED', 250244),
(401843, 'PTHR10485:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM17-A', 250244),
(401844, 'PTHR10485:SF2', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM17-B', 250244),
(401845, 'PTHR10485:SF20', NULL, NULL, NULL, NULL, '', 250244),
(401846, 'PTHR10485:SF30', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM17-2-LIKE', 250244),
(401847, 'PTHR10485', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM-17', 250244),
(401848, 'PTHR10485:SF18', NULL, NULL, NULL, NULL, '', 250244),
(401849, 'PTHR35617:SF2', NULL, NULL, NULL, NULL, 'TYR RECOMBINASE DOMAIN-CONTAINING PROTEIN', 250245),
(401850, 'PTHR35617', NULL, NULL, NULL, NULL, 'PHAGE_INTEGRASE DOMAIN-CONTAINING PROTEIN', 250245),
(401851, 'PTHR38354', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE COMPLEX-LIKE PROTEIN DTM1', 250246),
(401852, 'PTHR38354:SF2', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE COMPLEX-LIKE PROTEIN DTM1', 250246),
(401853, 'PTHR32303', NULL, NULL, NULL, NULL, 'QUINOPROTEIN ALCOHOL DEHYDROGENASE (CYTOCHROME C)', 250247),
(401854, 'PTHR32303:SF18', NULL, NULL, NULL, NULL, 'QUINONPROTEIN ALCOHOL DEHYDROGENASE', 250247),
(401855, 'PTHR32303:SF4', NULL, NULL, NULL, NULL, 'QUINOPROTEIN GLUCOSE DEHYDROGENASE', 250247),
(401856, 'PTHR32303:SF20', NULL, NULL, NULL, NULL, 'QUINOPROTEIN ETHANOL DEHYDROGENASE', 250247),
(401857, 'PTHR32303:SF21', NULL, NULL, NULL, NULL, 'POLYVINYLALCOHOL DEHYDROGENASE-LIKE PROTEIN', 250247),
(401858, 'PTHR32303:SF10', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN ASSEMBLY FACTOR BAMB', 250247),
(401859, 'PTHR46980', NULL, NULL, NULL, NULL, 'TRICALBIN-1-RELATED', 250248),
(401860, 'PTHR46980:SF1', NULL, NULL, NULL, NULL, 'TRICALBIN-3', 250248),
(401861, 'PTHR46980:SF3', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 250248),
(401862, 'PTHR46980:SF2', NULL, NULL, NULL, NULL, 'TRICALBIN-1-RELATED', 250248),
(401863, 'PTHR35996:SF1', NULL, NULL, NULL, NULL, 'OS04G0528100 PROTEIN', 250249),
(401864, 'PTHR35996:SF4', NULL, NULL, NULL, NULL, 'BNAA07G08620D PROTEIN', 250249),
(401865, 'PTHR35996', NULL, NULL, NULL, NULL, 'OSJNBA0038O10.25 PROTEIN', 250249),
(401866, 'PTHR33927:SF7', NULL, NULL, NULL, NULL, '', 250250),
(401867, 'PTHR33927:SF6', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 250250);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(401868, 'PTHR33927:SF5', NULL, NULL, NULL, NULL, 'ENZYME, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G01222)-RELATED', 250250),
(401869, 'PTHR33927', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 250250),
(401870, 'PTHR33927:SF3', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN TMPA', 250250),
(401871, 'PTHR33927:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 250250),
(401872, 'PTHR40465:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 250251),
(401873, 'PTHR40465', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 250251),
(401874, 'PTHR11723', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN INHIBITOR', 250252),
(401875, 'PTHR11723:SF5', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN INHIBITOR ID-2', 250252),
(401876, 'PTHR11723:SF6', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN INHIBITOR ID-4', 250252),
(401877, 'PTHR11723:SF4', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN INHIBITOR ID-1', 250252),
(401878, 'PTHR11723:SF16', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN INHIBITOR ID-3', 250252),
(401879, 'PTHR11723:SF17', NULL, NULL, NULL, NULL, 'PROTEIN EXTRA-MACROCHAETAE', 250252),
(401880, 'PTHR11723:SF18', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 250252),
(401881, 'PTHR33689', NULL, NULL, NULL, NULL, 'FAS-BINDING FACTOR 1', 250253),
(401882, 'PTHR33689:SF1', NULL, NULL, NULL, NULL, 'FAS-BINDING FACTOR 1', 250253),
(401883, 'PTHR34150:SF12', NULL, NULL, NULL, NULL, 'PROTEIN CBG08832', 250254),
(401884, 'PTHR34150:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG09626', 250254),
(401885, 'PTHR34150:SF11', NULL, NULL, NULL, NULL, 'PROTEIN CBR-HPO-26', 250254),
(401886, 'PTHR34150:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG10108', 250254),
(401887, 'PTHR34150:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG05036', 250254),
(401888, 'PTHR34150:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG04441', 250254),
(401889, 'PTHR34150', NULL, NULL, NULL, NULL, 'PROTEIN CBG08832-RELATED', 250254),
(401890, 'PTHR34150:SF1', NULL, NULL, NULL, NULL, 'CHITIN-BINDING TYPE-2 DOMAIN-CONTAINING PROTEIN', 250254),
(401891, 'PTHR34150:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG08398', 250254),
(401892, 'PTHR34775:SF2', NULL, NULL, NULL, NULL, 'OS01G0765500 PROTEIN', 250255),
(401893, 'PTHR34775:SF6', NULL, NULL, NULL, NULL, '', 250255),
(401894, 'PTHR34775:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 250255),
(401895, 'PTHR34775:SF8', NULL, NULL, NULL, NULL, 'BNAC05G12700D PROTEIN', 250255),
(401896, 'PTHR34775', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 250255),
(401897, 'PTHR10261:SF0', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT GAMMA-2', 250256),
(401898, 'PTHR10261:SF4', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT GAMMA-2', 250256),
(401899, 'PTHR10261:SF3', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT GAMMA-1', 250256),
(401900, 'PTHR10261:SF6', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT GAMMA', 250256),
(401901, 'PTHR10261:SF5', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT GAMMA-1', 250256),
(401902, 'PTHR10261:SF8', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT GAMMA', 250256),
(401903, 'PTHR10261:SF7', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT GAMMA', 250256),
(401904, 'PTHR10261', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT GAMMA', 250256),
(401905, 'PTHR36782:SF5', NULL, NULL, NULL, NULL, '', 250257),
(401906, 'PTHR36782:SF6', NULL, NULL, NULL, NULL, 'BNAA01G13500D PROTEIN', 250257),
(401907, 'PTHR36782', NULL, NULL, NULL, NULL, 'BNAC03G62080D PROTEIN', 250257),
(401908, 'PTHR36782:SF1', NULL, NULL, NULL, NULL, 'BNAC03G62080D PROTEIN', 250257),
(401909, 'PTHR36782:SF3', NULL, NULL, NULL, NULL, 'BNAA03G46320D PROTEIN', 250257),
(401910, 'PTHR36782:SF4', NULL, NULL, NULL, NULL, '', 250257),
(401911, 'PTHR13067:SF2', NULL, NULL, NULL, NULL, 'CASPASE-ACTIVATED DNASE', 250258),
(401912, 'PTHR13067', NULL, NULL, NULL, NULL, 'CASPASE-ACTIVATED DNASE', 250258),
(401913, 'PTHR34597:SF6', NULL, NULL, NULL, NULL, 'BLR6126 PROTEIN', 250259),
(401914, 'PTHR34597:SF1', NULL, NULL, NULL, NULL, 'HEME/HEMOPEXIN TRANSPORTER PROTEIN HUXB', 250259),
(401915, 'PTHR34597', NULL, NULL, NULL, NULL, 'SLR1661 PROTEIN', 250259);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(401916, 'PTHR34597:SF3', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE TRANSPORTER CDIB', 250259),
(401917, 'PTHR21408', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-ONLY PROTEIN', 250260),
(401918, 'PTHR21408:SF1', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-ONLY PROTEIN', 250260),
(401919, 'PTHR14588', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 10', 250261),
(401920, 'PTHR14588:SF2', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 10', 250261),
(401921, 'PTHR30305', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 250262),
(401922, 'PTHR30305:SF1', NULL, NULL, NULL, NULL, 'HPR KINASE/PHOSPHORYLASE', 250262),
(401923, 'PTHR30305:SF3', NULL, NULL, NULL, NULL, 'PROTEIN YJDM', 250262),
(401924, 'PTHR31094:SF6', NULL, NULL, NULL, NULL, 'BNAC03G72730D PROTEIN', 250263),
(401925, 'PTHR31094:SF7', NULL, NULL, NULL, NULL, 'PLANT/F3O9-12 PROTEIN', 250263),
(401926, 'PTHR31094:SF8', NULL, NULL, NULL, NULL, 'T8K14.7 PROTEIN', 250263),
(401927, 'PTHR31094', NULL, NULL, NULL, NULL, 'RIKEN CDNA 2310061I04 GENE', 250263),
(401928, 'PTHR31094:SF2', NULL, NULL, NULL, NULL, 'RIKEN CDNA 2310061I04 GENE', 250263),
(401929, 'PTHR31094:SF3', NULL, NULL, NULL, NULL, 'OS04G0613300 PROTEIN', 250263),
(401930, 'PTHR31094:SF4', NULL, NULL, NULL, NULL, '', 250263),
(401931, 'PTHR31094:SF5', NULL, NULL, NULL, NULL, '(BREAD WHEAT) HYPOTHETICAL PROTEIN', 250263),
(401932, 'PTHR21027:SF1', NULL, NULL, NULL, NULL, 'TRNA-SPLICING ENDONUCLEASE SUBUNIT SEN54', 250264),
(401933, 'PTHR21027', NULL, NULL, NULL, NULL, 'TRNA-SPLICING ENDONUCLEASE SUBUNIT SEN54', 250264),
(401934, 'PTHR42865:SF1', NULL, NULL, NULL, NULL, 'AEROBIC C4-DICARBOXYLATE TRANSPORT PROTEIN', 250265),
(401935, 'PTHR42865:SF9', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE TRANSPORT PROTEIN-RELATED', 250265),
(401936, 'PTHR42865:SF8', NULL, NULL, NULL, NULL, 'SERINE/THREONINE TRANSPORTER SSTT', 250265),
(401937, 'PTHR42865:SF7', NULL, NULL, NULL, NULL, 'PROTON/GLUTAMATE-ASPARTATE SYMPORTER', 250265),
(401938, 'PTHR42865:SF5', NULL, NULL, NULL, NULL, 'L-CYSTINE TRANSPORTER TCYP', 250265),
(401939, 'PTHR42865', NULL, NULL, NULL, NULL, 'PROTON/GLUTAMATE-ASPARTATE SYMPORTER', 250265),
(401940, 'PTHR42865:SF2', NULL, NULL, NULL, NULL, 'PROTON:GLUTAMATE SYMPORTER DAACS FAMILY', 250265),
(401941, 'PTHR36593', NULL, NULL, NULL, NULL, 'EXPORTED SERINE/THREONINE PROTEIN KINASE', 250266),
(401942, 'PTHR36593:SF1', NULL, NULL, NULL, NULL, 'HEAD-TAIL ADAPTOR, PUTATIVE FAMILY PROTEIN-RELATED', 250266),
(401943, 'PTHR32108:SF0', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT ALPHA', 250267),
(401944, 'PTHR32108', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT ALPHA', 250267),
(401945, 'PTHR32108:SF5', NULL, NULL, NULL, NULL, 'DYNACTIN SUBUNIT 1-LIKE', 250267),
(401946, 'PTHR32108:SF4', NULL, NULL, NULL, NULL, 'PLASTID-ENCODED RNA POLYMERASE SUBUNIT ALPHA', 250267),
(401947, 'PTHR48108:SF2', NULL, NULL, NULL, NULL, 'ACETOIN UTILIZATION PROTEIN ACUB', 250268),
(401948, 'PTHR48108', NULL, NULL, NULL, NULL, 'CBS DOMAIN-CONTAINING PROTEIN CBSX2, CHLOROPLASTIC', 250268),
(401949, 'PTHR48108:SF20', NULL, NULL, NULL, NULL, 'CBS DOMAIN-CONTAINING PROTEIN-RELATED', 250268),
(401950, 'PTHR48108:SF31', NULL, NULL, NULL, NULL, 'NUCLEOTIDYLTRANSFERASE DUF294-RELATED', 250268),
(401951, 'PTHR48108:SF21', NULL, NULL, NULL, NULL, 'OS09G0115500 PROTEIN', 250268),
(401952, 'PTHR48108:SF32', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR CCPN', 250268),
(401953, 'PTHR48108:SF33', NULL, NULL, NULL, NULL, 'METHYLATED PROTEIN MJ0556', 250268),
(401954, 'PTHR48108:SF23', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN WITH 2 CBS DOMAINS', 250268),
(401955, 'PTHR48108:SF9', NULL, NULL, NULL, NULL, 'CBS DOMAIN-CONTAINING PROTEIN CBSX1, CHLOROPLASTIC-LIKE ISOFORM X1', 250268),
(401956, 'PTHR48108:SF6', NULL, NULL, NULL, NULL, 'CBS DOMAIN-CONTAINING PROTEIN CBSX1, CHLOROPLASTIC', 250268),
(401957, 'PTHR48108:SF30', NULL, NULL, NULL, NULL, 'L-ASPARTATE SEMIALDEHYDE SULFURTRANSFERASE', 250268),
(401958, 'PTHR48108:SF28', NULL, NULL, NULL, NULL, '', 250268),
(401959, 'PTHR48108:SF17', NULL, NULL, NULL, NULL, 'BNAC03G77200D PROTEIN', 250268);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(401960, 'PTHR48108:SF18', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN WITH 2 CBS DOMAINS', 250268),
(401961, 'PTHR48108:SF29', NULL, NULL, NULL, NULL, '', 250268),
(401962, 'PTHR48108:SF19', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEASE', 250268),
(401963, 'PTHR48108:SF24', NULL, NULL, NULL, NULL, 'CBS DOMAIN-CONTAINING PROTEIN CBSX2, CHLOROPLASTIC', 250268),
(401964, 'PTHR48108:SF25', NULL, NULL, NULL, NULL, 'CBS DOMAIN-CONTAINING PROTEIN CBSX1, CHLOROPLASTIC-LIKE', 250268),
(401965, 'PTHR48108:SF26', NULL, NULL, NULL, NULL, 'CBS DOMAIN-CONTAINING PROTEIN DDB_G0289609', 250268),
(401966, 'PTHR48108:SF27', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, XRE FAMILY', 250268),
(401967, 'PTHR38463', NULL, NULL, NULL, NULL, 'STRESS RESPONSE PROTEIN YSNF', 250269),
(401968, 'PTHR38463:SF1', NULL, NULL, NULL, NULL, 'STRESS RESPONSE PROTEIN YSNF', 250269),
(401969, 'PTHR46683:SF1', NULL, NULL, NULL, NULL, 'OROTATE PHOSPHORIBOSYLTRANSFERASE 1-RELATED', 250270),
(401970, 'PTHR46683', NULL, NULL, NULL, NULL, 'OROTATE PHOSPHORIBOSYLTRANSFERASE 1-RELATED', 250270),
(401971, 'PTHR47031:SF10', NULL, NULL, NULL, NULL, 'SAP DOMAIN-CONTAINING PROTEIN', 250271),
(401972, 'PTHR47031', NULL, NULL, NULL, NULL, 'SAP DNA-BINDING DOMAIN-CONTAINING PROTEIN', 250271),
(401973, 'PTHR47031:SF9', NULL, NULL, NULL, NULL, 'SAP DOMAIN-CONTAINING PROTEIN-RELATED', 250271),
(401974, 'PTHR47031:SF3', NULL, NULL, NULL, NULL, 'SAP DOMAIN-CONTAINING PROTEIN', 250271),
(401975, 'PTHR47031:SF11', NULL, NULL, NULL, NULL, 'SAP DOMAIN CONTAINING PROTEIN', 250271),
(401976, 'PTHR30094:SF0', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL GLUTATHIONYLSPERMIDINE SYNTHETASE/AMIDASE-RELATED', 250272),
(401977, 'PTHR30094', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL GLUTATHIONYLSPERMIDINE SYNTHETASE/AMIDASE-RELATED', 250272),
(401978, 'PTHR30094:SF16', NULL, NULL, NULL, NULL, 'SYNTHETASE, PUTATIVE-RELATED', 250272),
(401979, 'PTHR30094:SF14', NULL, NULL, NULL, NULL, 'D-ALANYL-GLYCYL ENDOPEPTIDASE-LIKE PROTEIN', 250272),
(401980, 'PTHR30094:SF15', NULL, NULL, NULL, NULL, 'SYNTHETASE, PUTATIVE-RELATED', 250272),
(401981, 'PTHR30094:SF6', NULL, NULL, NULL, NULL, 'PEPTIDASE C51 DOMAIN-CONTAINING PROTEIN', 250272),
(401982, 'PTHR30094:SF5', NULL, NULL, NULL, NULL, 'ACID--AMINE LIGASE YJFC-RELATED', 250272),
(401983, 'PTHR16189', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 250273),
(401984, 'PTHR16189:SF13', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 250273),
(401985, 'PTHR16189:SF6', NULL, NULL, NULL, NULL, '', 250273),
(401986, 'PTHR16189:SF15', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 250273),
(401987, 'PTHR16189:SF3', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 250273),
(401988, 'PTHR16189:SF2', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 250273),
(401989, 'PTHR16189:SF5', NULL, NULL, NULL, NULL, 'AA_TRANS DOMAIN-CONTAINING PROTEIN', 250273),
(401990, 'PTHR16189:SF0', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 104', 250273),
(401991, 'PTHR47141', NULL, NULL, NULL, NULL, 'CYSTATIN-F', 250274),
(401992, 'PTHR47141:SF1', NULL, NULL, NULL, NULL, 'CYSTATIN-F', 250274),
(401993, 'PTHR36336:SF1', NULL, NULL, NULL, NULL, 'OS09G0560400 PROTEIN', 250275),
(401994, 'PTHR36336', NULL, NULL, NULL, NULL, 'OS09G0560400 PROTEIN', 250275),
(401995, 'PTHR47841:SF3', NULL, NULL, NULL, NULL, 'OS09G0492800 PROTEIN', 250276),
(401996, 'PTHR47841:SF2', NULL, NULL, NULL, NULL, 'OS07G0609800 PROTEIN', 250276),
(401997, 'PTHR47841:SF8', NULL, NULL, NULL, NULL, 'PHORBOL-ESTER/DAG-TYPE DOMAIN-CONTAINING PROTEIN', 250276),
(401998, 'PTHR47841:SF7', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN PROTEIN', 250276),
(401999, 'PTHR47841', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE THETA-LIKE-RELATED', 250276),
(402000, 'PTHR47841:SF6', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN FAMILY PROTEIN-RELATED', 250276),
(402001, 'PTHR47841:SF5', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN FAMILY PROTEIN', 250276),
(402002, 'PTHR47841:SF15', NULL, NULL, NULL, NULL, 'ZINC FINGER, PHD-TYPE, CONSERVED SITE-RELATED', 250276);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(402003, 'PTHR47841:SF9', NULL, NULL, NULL, NULL, 'PHORBOL-ESTER/DAG-TYPE DOMAIN-CONTAINING PROTEIN', 250276),
(402004, 'PTHR47841:SF14', NULL, NULL, NULL, NULL, 'PHORBOL-ESTER/DAG-TYPE DOMAIN-CONTAINING PROTEIN', 250276),
(402005, 'PTHR47841:SF13', NULL, NULL, NULL, NULL, 'BNAA03G17430D PROTEIN', 250276),
(402006, 'PTHR47841:SF11', NULL, NULL, NULL, NULL, 'C1_2 DOMAIN-CONTAINING PROTEIN', 250276),
(402007, 'PTHR47841:SF10', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE THETA-LIKE', 250276),
(402008, 'PTHR45671:SF24', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PHOSPHATE CARRIER PROTEIN 3, MITOCHONDRIAL-LIKE', 250277),
(402009, 'PTHR45671', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 25 (MITOCHONDRIAL CARRIER PHOSPHATE CARRIER), MEMBER 3, LIKE-RELATED-RELATED', 250277),
(402010, 'PTHR45671:SF25', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PHOSPHATE CARRIER PROTEIN', 250277),
(402011, 'PTHR45671:SF22', NULL, NULL, NULL, NULL, 'OS06G0210500 PROTEIN', 250277),
(402012, 'PTHR45671:SF23', NULL, NULL, NULL, NULL, 'OS09G0454600 PROTEIN', 250277),
(402013, 'PTHR45671:SF21', NULL, NULL, NULL, NULL, 'CARRIER PROTEIN-RELATED', 250277),
(402014, 'PTHR45671:SF28', NULL, NULL, NULL, NULL, 'CARRIER PROTEIN, PUTATIVE-RELATED', 250277),
(402015, 'PTHR45671:SF26', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER', 250277),
(402016, 'PTHR45671:SF13', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER PIC2, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G12080)-RELATED', 250277),
(402017, 'PTHR45671:SF14', NULL, NULL, NULL, NULL, 'PHOSPHATE CARRIER PROTEIN', 250277),
(402018, 'PTHR45671:SF12', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PHOSPHATE CARRIER PROTEIN', 250277),
(402019, 'PTHR45671:SF31', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PHOSPHATE CARRIER PROTEIN 2, MITOCHONDRIAL', 250277),
(402020, 'PTHR45671:SF32', NULL, NULL, NULL, NULL, 'PHOSPHATE CARRIER PROTEIN', 250277),
(402021, 'PTHR45671:SF10', NULL, NULL, NULL, NULL, 'PHOSPHATE CARRIER PROTEIN, MITOCHONDRIAL', 250277),
(402022, 'PTHR45671:SF2', NULL, NULL, NULL, NULL, 'PHOSPHATE CARRIER PROTEIN, MITOCHONDRIAL', 250277),
(402023, 'PTHR45671:SF17', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PHOSPHATE TRANSPORTER', 250277),
(402024, 'PTHR45671:SF3', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PHOSPHATE CARRIER PROTEIN 3 MITOCHONDRIAL', 250277),
(402025, 'PTHR45671:SF15', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 250277),
(402026, 'PTHR45671:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATE CARRIER PROTEIN, MITOCHONDRIAL', 250277),
(402027, 'PTHR45671:SF16', NULL, NULL, NULL, NULL, 'PHOSPHATE CARRIER PROTEIN-RELATED', 250277),
(402028, 'PTHR45671:SF6', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN', 250277),
(402029, 'PTHR45671:SF7', NULL, NULL, NULL, NULL, 'PHOSPHATE CARRIER PROTEIN', 250277),
(402030, 'PTHR45671:SF4', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PHOSPHATE CARRIER PROTEIN 1, MITOCHONDRIAL', 250277),
(402031, 'PTHR45671:SF5', NULL, NULL, NULL, NULL, 'PHOSPHATE CARRIER PROTEIN, MITOCHONDRIAL', 250277),
(402032, 'PTHR45671:SF8', NULL, NULL, NULL, NULL, 'PHOSPHATE CARRIER PROTEIN, MITOCHONDRIAL', 250277),
(402033, 'PTHR10584:SF168', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 250278),
(402034, 'PTHR10584:SF157', NULL, NULL, NULL, NULL, 'SULFOFRUCTOSE KINASE', 250278),
(402035, 'PTHR10584:SF167', NULL, NULL, NULL, NULL, 'PFKB DOMAIN PROTEIN', 250278),
(402036, 'PTHR10584:SF166', NULL, NULL, NULL, NULL, 'RIBOKINASE', 250278),
(402037, 'PTHR10584', NULL, NULL, NULL, NULL, 'SUGAR KINASE', 250278),
(402038, 'PTHR30419:SF8', NULL, NULL, NULL, NULL, 'NITROGEN ASSIMILATION TRANSCRIPTIONAL ACTIVATOR-RELATED', 250279),
(402039, 'PTHR30419:SF7', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR TDCA', 250279),
(402040, 'PTHR30419:SF28', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR BSDA', 250279),
(402041, 'PTHR30419:SF29', NULL, NULL, NULL, NULL, 'BLR3139 PROTEIN', 250279),
(402042, 'PTHR30419:SF24', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR CZCR', 250279),
(402043, 'PTHR30419:SF25', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR YTLI', 250279);
INSERT INTO "PUBLIC"."MODEL" VALUES
(402044, 'PTHR30419', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR YBHD', 250279),
(402045, 'PTHR30419:SF2', NULL, NULL, NULL, NULL, 'LYSR FAMILY TRANSCRIPTIONAL REGULATOR-RELATED', 250279),
(402046, 'PTHR30419:SF14', NULL, NULL, NULL, NULL, 'LYSR FAMILY TRANSCRIPTIONAL REGULATOR-RELATED', 250279),
(402047, 'PTHR30419:SF10', NULL, NULL, NULL, NULL, 'LYSR FAMILY TRANSCRIPTIONAL REGULATOR-RELATED', 250279),
(402048, 'PTHR20515:SF19', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 110', 250280),
(402049, 'PTHR20515', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN', 250280),
(402050, 'PTHR20515:SF13', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 102', 250280),
(402051, 'PTHR20515:SF1', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 130A-RELATED', 250280),
(402052, 'PTHR20515:SF0', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 103', 250280),
(402053, 'PTHR20515:SF3', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 109B-RELATED', 250280),
(402054, 'PTHR20515:SF2', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 4A', 250280),
(402055, 'PTHR20515:SF12', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 3-RELATED', 250280),
(402056, 'PTHR20515:SF17', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 133', 250280),
(402057, 'PTHR20515:SF4', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 33', 250280),
(402058, 'PTHR20515:SF18', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN', 250280),
(402059, 'PTHR20515:SF15', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 51', 250280),
(402060, 'PTHR20515:SF16', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 114', 250280),
(402061, 'PTHR18063:SF20', NULL, NULL, NULL, NULL, 'MINDY_DUB DOMAIN-CONTAINING PROTEIN', 250281),
(402062, 'PTHR18063', NULL, NULL, NULL, NULL, 'NF-E2 INDUCIBLE PROTEIN', 250281),
(402063, 'PTHR18063:SF7', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE MINDY-1', 250281),
(402064, 'PTHR18063:SF8', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE MINDY-2', 250281),
(402065, 'PTHR18063:SF6', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 250281),
(402066, 'PTHR18063:SF9', NULL, NULL, NULL, NULL, 'MINDY_DUB DOMAIN-CONTAINING PROTEIN', 250281),
(402067, 'PTHR18063:SF16', NULL, NULL, NULL, NULL, 'OS06G0723400 PROTEIN', 250281),
(402068, 'PTHR18063:SF17', NULL, NULL, NULL, NULL, 'ALANINE--TRNA LIGASE', 250281),
(402069, 'PTHR46901', NULL, NULL, NULL, NULL, 'GH04942P', 250282),
(402070, 'PTHR46901:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG04265', 250282),
(402071, 'PTHR46901:SF2', NULL, NULL, NULL, NULL, 'GH04942P', 250282),
(402072, 'PTHR37478', NULL, NULL, NULL, NULL, '', 250283),
(402073, 'PTHR37478:SF2', NULL, NULL, NULL, NULL, 'UPF0251 PROTEIN TK0562', 250283),
(402074, 'PTHR24251:SF16', NULL, NULL, NULL, NULL, 'OVOCHYMASE-2', 250284),
(402075, 'PTHR24251:SF27', NULL, NULL, NULL, NULL, 'NEUROPILIN AND TOLLOID-LIKE PROTEIN 1', 250284),
(402076, 'PTHR24251:SF38', NULL, NULL, NULL, NULL, 'CUB DOMAIN-CONTAINING PROTEIN', 250284),
(402077, 'PTHR24251:SF28', NULL, NULL, NULL, NULL, 'NEUROPILIN AND TOLLOID-LIKE, ISOFORM B', 250284),
(402078, 'PTHR24251:SF39', NULL, NULL, NULL, NULL, '', 250284),
(402079, 'PTHR24251:SF36', NULL, NULL, NULL, NULL, 'MEMBRANE FRIZZLED-RELATED PROTEIN', 250284),
(402080, 'PTHR24251:SF37', NULL, NULL, NULL, NULL, 'CUB DOMAIN-CONTAINING PROTEIN 2', 250284),
(402081, 'PTHR24251:SF26', NULL, NULL, NULL, NULL, 'NEUROPILIN AND TOLLOID-LIKE PROTEIN 2', 250284),
(402082, 'PTHR24251:SF24', NULL, NULL, NULL, NULL, 'PROCOLLAGEN C-ENDOPEPTIDASE ENHANCER 1', 250284),
(402083, 'PTHR24251:SF21', NULL, NULL, NULL, NULL, 'OVOCHYMASE-1', 250284),
(402084, 'PTHR24251:SF32', NULL, NULL, NULL, NULL, 'PROCOLLAGEN C-ENDOPEPTIDASE ENHANCER B', 250284),
(402085, 'PTHR24251:SF33', NULL, NULL, NULL, NULL, 'METALLOENDOPEPTIDASE', 250284),
(402086, 'PTHR24251', NULL, NULL, NULL, NULL, 'OVOCHYMASE-RELATED', 250284),
(402087, 'PTHR24251:SF30', NULL, NULL, NULL, NULL, 'CUB DOMAINCONTAINING PROTEIN', 250284),
(402088, 'PTHR24251:SF31', NULL, NULL, NULL, NULL, 'PROCOLLAGEN C-ENDOPEPTIDASE ENHANCER 2', 250284),
(402089, 'PTHR36143', NULL, NULL, NULL, NULL, 'OS08G0177500 PROTEIN', 250285),
(402090, 'PTHR36143:SF6', NULL, NULL, NULL, NULL, 'OS08G0177500 PROTEIN', 250285);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(402091, 'PTHR36143:SF7', NULL, NULL, NULL, NULL, 'PROTEIN STARMAKER-LIKE', 250285),
(402092, 'PTHR36143:SF4', NULL, NULL, NULL, NULL, 'OS04G0636200 PROTEIN', 250285),
(402093, 'PTHR40250', NULL, NULL, NULL, NULL, 'CHROMOSOME 11 OPEN READING FRAME 96', 250286),
(402094, 'PTHR40250:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 11 OPEN READING FRAME 96', 250286),
(402095, 'PTHR46696:SF1', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 250287),
(402096, 'PTHR46696', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 250287),
(402097, 'PTHR46696:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 130', 250287),
(402098, 'PTHR46696:SF3', NULL, NULL, NULL, NULL, 'PULCHERRIMINIC ACID SYNTHASE', 250287),
(402099, 'PTHR37525:SF1', NULL, NULL, NULL, NULL, 'UPF0175 PROTEIN SSL1255', 250288),
(402100, 'PTHR37525', NULL, NULL, NULL, NULL, '', 250288),
(402101, 'PTHR22929:SF0', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TFIIIB COMPONENT B'''' HOMOLOG', 250289),
(402102, 'PTHR22929:SF1', NULL, NULL, NULL, NULL, 'SANT DOMAIN-CONTAINING PROTEIN', 250289),
(402103, 'PTHR22929', NULL, NULL, NULL, NULL, 'RNA POLYMERASE III TRANSCRIPTION INITIATION FACTOR B', 250289),
(402104, 'PTHR12207:SF27', NULL, NULL, NULL, NULL, 'V-SET AND TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN 2B', 250290),
(402105, 'PTHR12207', NULL, NULL, NULL, NULL, 'V-SET AND TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN', 250290),
(402106, 'PTHR12207:SF31', NULL, NULL, NULL, NULL, 'V-SET AND TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN 2-LIKE PROTEIN', 250290),
(402107, 'PTHR12207:SF30', NULL, NULL, NULL, NULL, 'ZGC:91849', 250290),
(402108, 'PTHR12207:SF22', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN SUPERFAMILY MEMBER 8', 250290),
(402109, 'PTHR12207:SF21', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN SUPERFAMILY MEMBER 3', 250290),
(402110, 'PTHR12207:SF3', NULL, NULL, NULL, NULL, 'PROSTAGLANDIN F2 RECEPTOR NEGATIVE REGULATOR', 250290),
(402111, 'PTHR12207:SF23', NULL, NULL, NULL, NULL, 'V-SET AND TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN 2A', 250290),
(402112, 'PTHR12207:SF26', NULL, NULL, NULL, NULL, 'V-SET AND TRANSMEMBRANE DOMAIN-CONTAINING 4B', 250290),
(402113, 'PTHR12207:SF8', NULL, NULL, NULL, NULL, 'V-SET AND TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN 4', 250290),
(402114, 'PTHR12207:SF25', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN SUPERFAMILY MEMBER 2', 250290),
(402115, 'PTHR28020', NULL, NULL, NULL, NULL, 'YAP1-BINDING PROTEIN 1-RELATED', 250291),
(402116, 'PTHR28020:SF1', NULL, NULL, NULL, NULL, 'YAP1-BINDING PROTEIN 1-RELATED', 250291),
(402117, 'PTHR36896:SF2', NULL, NULL, NULL, NULL, 'OS01G0729500 PROTEIN', 250292),
(402118, 'PTHR36896:SF3', NULL, NULL, NULL, NULL, 'BNAC03G59480D PROTEIN', 250292),
(402119, 'PTHR36896', NULL, NULL, NULL, NULL, 'OS01G0729500 PROTEIN', 250292),
(402120, 'PTHR13467', NULL, NULL, NULL, NULL, 'CUE DOMAIN CONTAINING PROTEIN 1', 250293),
(402121, 'PTHR13467:SF3', NULL, NULL, NULL, NULL, 'CUE DOMAIN-CONTAINING PROTEIN 1', 250293),
(402122, 'PTHR15947:SF0', NULL, NULL, NULL, NULL, 'INTERLEUKIN-23 SUBUNIT ALPHA', 250294),
(402123, 'PTHR15947', NULL, NULL, NULL, NULL, 'SGRF', 250294),
(402124, 'PTHR31267:SF6', NULL, NULL, NULL, NULL, '', 250295),
(402125, 'PTHR31267:SF7', NULL, NULL, NULL, NULL, 'DENTIN SIALOPHOSPHOPROTEIN-LIKE PROTEIN', 250295),
(402126, 'PTHR31267:SF8', NULL, NULL, NULL, NULL, '', 250295),
(402127, 'PTHR31267:SF9', NULL, NULL, NULL, NULL, 'BNACNNG11530D PROTEIN', 250295),
(402128, 'PTHR31267:SF10', NULL, NULL, NULL, NULL, 'SIALOPHOSPHOPROTEIN-LIKE PROTEIN, PUTATIVE-RELATED', 250295),
(402129, 'PTHR31267:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250295),
(402130, 'PTHR31267:SF3', NULL, NULL, NULL, NULL, 'OS03G0756700 PROTEIN', 250295),
(402131, 'PTHR31267', NULL, NULL, NULL, NULL, 'DENTIN SIALOPHOSPHOPROTEIN-LIKE PROTEIN', 250295),
(402132, 'PTHR31267:SF5', NULL, NULL, NULL, NULL, '', 250295),
(402133, 'PTHR46172:SF1', NULL, NULL, NULL, NULL, 'DNA POLYMERASE EPSILON SUBUNIT 3', 250296),
(402134, 'PTHR46172', NULL, NULL, NULL, NULL, 'DNA POLYMERASE EPSILON SUBUNIT 3', 250296),
(402135, 'PTHR22951:SF70', NULL, NULL, NULL, NULL, 'CLATHRIN ASSEMBLY PROTEIN-RELATED', 250297);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(402136, 'PTHR22951:SF29', NULL, NULL, NULL, NULL, 'OS02G0803300 PROTEIN', 250297),
(402137, 'PTHR22951:SF28', NULL, NULL, NULL, NULL, 'SYNAPTOSOME-ASSOCIATED PROTEIN 91B', 250297),
(402138, 'PTHR22951:SF24', NULL, NULL, NULL, NULL, 'ENTH DOMAIN-CONTAINING PROTEIN', 250297),
(402139, 'PTHR22951:SF110', NULL, NULL, NULL, NULL, 'CLATHRIN ASSEMBLY PROTEIN', 250297),
(402140, 'PTHR22951:SF21', NULL, NULL, NULL, NULL, 'OS06G0661400 PROTEIN', 250297),
(402141, 'PTHR22951:SF23', NULL, NULL, NULL, NULL, 'OS05G0112101 PROTEIN', 250297),
(402142, 'PTHR22951:SF67', NULL, NULL, NULL, NULL, 'ENTH DOMAIN-CONTAINING PROTEIN', 250297),
(402143, 'PTHR22951:SF66', NULL, NULL, NULL, NULL, 'ENTH DOMAIN-CONTAINING PROTEIN', 250297),
(402144, 'PTHR22951:SF22', NULL, NULL, NULL, NULL, 'ENTH DOMAIN-CONTAINING PROTEIN', 250297),
(402145, 'PTHR22951:SF61', NULL, NULL, NULL, NULL, 'OS01G0694900 PROTEIN', 250297),
(402146, 'PTHR22951:SF63', NULL, NULL, NULL, NULL, 'CLATHRIN COAT ASSEMBLY PROTEIN AP180-LIKE', 250297),
(402147, 'PTHR22951:SF62', NULL, NULL, NULL, NULL, 'ASSEMBLY PLANT-LIKE PROTEIN, PUTATIVE-RELATED', 250297),
(402148, 'PTHR22951:SF5', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-BINDING CLATHRIN ASSEMBLY PROTEIN LAP', 250297),
(402149, 'PTHR22951:SF107', NULL, NULL, NULL, NULL, 'ENTH DOMAIN-CONTAINING PROTEIN', 250297),
(402150, 'PTHR22951:SF108', NULL, NULL, NULL, NULL, 'ANTH DOMAIN-CONTAINING PROTEIN', 250297),
(402151, 'PTHR22951:SF4', NULL, NULL, NULL, NULL, 'CLATHRIN COAT ASSEMBLY PROTEIN AP180', 250297),
(402152, 'PTHR22951:SF105', NULL, NULL, NULL, NULL, 'ENTH/VHS AND ANTH DOMAINS-CONTAINING PROTEIN-RELATED', 250297),
(402153, 'PTHR22951:SF106', NULL, NULL, NULL, NULL, 'CLATHRIN ASSEMBLY PROTEIN', 250297),
(402154, 'PTHR22951:SF109', NULL, NULL, NULL, NULL, 'OS05G0426100 PROTEIN', 250297),
(402155, 'PTHR22951:SF19', NULL, NULL, NULL, NULL, 'OS08G0467300 PROTEIN', 250297),
(402156, 'PTHR22951:SF57', NULL, NULL, NULL, NULL, 'CLATHRIN ASSEMBLY PLANT-LIKE PROTEIN', 250297),
(402157, 'PTHR22951:SF13', NULL, NULL, NULL, NULL, 'ASSEMBLY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 250297),
(402158, 'PTHR22951:SF16', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-BINDING CLATHRIN ASSEMBLY PROTEIN', 250297),
(402159, 'PTHR22951:SF98', NULL, NULL, NULL, NULL, 'ENTH DOMAIN-CONTAINING PROTEIN', 250297),
(402160, 'PTHR22951:SF97', NULL, NULL, NULL, NULL, 'ENTH DOMAIN-CONTAINING PROTEIN', 250297),
(402161, 'PTHR22951:SF100', NULL, NULL, NULL, NULL, 'ENTH DOMAIN-CONTAINING PROTEIN', 250297),
(402162, 'PTHR22951:SF12', NULL, NULL, NULL, NULL, 'ENTH DOMAIN-CONTAINING PROTEIN', 250297),
(402163, 'PTHR22951:SF99', NULL, NULL, NULL, NULL, 'ENTH/VHS AND ANTH DOMAINS-CONTAINING PROTEIN-RELATED', 250297),
(402164, 'PTHR22951:SF11', NULL, NULL, NULL, NULL, 'ENTH DOMAIN-CONTAINING PROTEIN', 250297),
(402165, 'PTHR22951:SF94', NULL, NULL, NULL, NULL, 'ENTH DOMAIN-CONTAINING PROTEIN', 250297),
(402166, 'PTHR22951:SF103', NULL, NULL, NULL, NULL, 'ENTH DOMAIN-CONTAINING PROTEIN', 250297),
(402167, 'PTHR22951:SF93', NULL, NULL, NULL, NULL, 'ENTH DOMAIN-CONTAINING PROTEIN', 250297),
(402168, 'PTHR22951:SF104', NULL, NULL, NULL, NULL, 'CLATHRIN ASSEMBLY PLANT-LIKE PROTEIN', 250297),
(402169, 'PTHR22951:SF101', NULL, NULL, NULL, NULL, 'ENTH DOMAIN-CONTAINING PROTEIN', 250297),
(402170, 'PTHR22951:SF96', NULL, NULL, NULL, NULL, 'BNAA02G25770D PROTEIN', 250297),
(402171, 'PTHR22951:SF95', NULL, NULL, NULL, NULL, 'ENTH DOMAIN-CONTAINING PROTEIN', 250297),
(402172, 'PTHR22951:SF102', NULL, NULL, NULL, NULL, 'ENTH DOMAIN-CONTAINING PROTEIN', 250297),
(402173, 'PTHR22951:SF90', NULL, NULL, NULL, NULL, 'ENTH DOMAIN-CONTAINING PROTEIN', 250297),
(402174, 'PTHR22951', NULL, NULL, NULL, NULL, 'CLATHRIN ASSEMBLY PROTEIN', 250297),
(402175, 'PTHR22951:SF89', NULL, NULL, NULL, NULL, 'OS05G0549000 PROTEIN', 250297),
(402176, 'PTHR22951:SF88', NULL, NULL, NULL, NULL, 'ENTH DOMAIN-CONTAINING PROTEIN', 250297),
(402177, 'PTHR22951:SF83', NULL, NULL, NULL, NULL, 'ENTH DOMAIN-CONTAINING PROTEIN', 250297),
(402178, 'PTHR22951:SF82', NULL, NULL, NULL, NULL, 'ENTH DOMAIN-CONTAINING PROTEIN', 250297);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(402179, 'PTHR22951:SF85', NULL, NULL, NULL, NULL, 'OS06G0699800 PROTEIN', 250297),
(402180, 'PTHR22951:SF84', NULL, NULL, NULL, NULL, 'ENTH DOMAIN-CONTAINING PROTEIN', 250297),
(402181, 'PTHR22951:SF81', NULL, NULL, NULL, NULL, 'CLATHRIN ASSEMBLY PROTEIN', 250297),
(402182, 'PTHR22951:SF80', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-BINDING CLATHRIN ASSEMBLY PROTEIN B', 250297),
(402183, 'PTHR22951:SF79', NULL, NULL, NULL, NULL, 'CLATHRIN ASSEMBLY PROTEIN', 250297),
(402184, 'PTHR22951:SF32', NULL, NULL, NULL, NULL, 'OS06G0175500 PROTEIN', 250297),
(402185, 'PTHR22951:SF76', NULL, NULL, NULL, NULL, 'OS09G0468150 PROTEIN', 250297),
(402186, 'PTHR22951:SF75', NULL, NULL, NULL, NULL, 'CLATHRIN COAT ASSEMBLY PROTEIN AP180', 250297),
(402187, 'PTHR22951:SF78', NULL, NULL, NULL, NULL, 'ENTH DOMAIN-CONTAINING PROTEIN', 250297),
(402188, 'PTHR22951:SF72', NULL, NULL, NULL, NULL, 'ENTH DOMAIN-CONTAINING PROTEIN', 250297),
(402189, 'PTHR22951:SF71', NULL, NULL, NULL, NULL, 'ENTH DOMAIN-CONTAINING PROTEIN', 250297),
(402190, 'PTHR22951:SF30', NULL, NULL, NULL, NULL, 'OS01G0881100 PROTEIN', 250297),
(402191, 'PTHR30108:SF17', NULL, NULL, NULL, NULL, 'FERULIC ACID DECARBOXYLASE 1', 250298),
(402192, 'PTHR30108:SF7', NULL, NULL, NULL, NULL, '3-POLYPRENYL-4-HYDROXYBENZOATE DECARBOXYLASE', 250298),
(402193, 'PTHR30108', NULL, NULL, NULL, NULL, '3-OCTAPRENYL-4-HYDROXYBENZOATE CARBOXY-LYASE-RELATED', 250298),
(402194, 'PTHR30108:SF20', NULL, NULL, NULL, NULL, 'UBID FAMILY DECARBOXYLASE', 250298),
(402195, 'PTHR37846', NULL, NULL, NULL, NULL, 'YALI0B21296P', 250299),
(402196, 'PTHR37846:SF1', NULL, NULL, NULL, NULL, 'YALI0B21296P', 250299),
(402197, 'PTHR13074', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 8', 250300),
(402198, 'PTHR13074:SF9', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 8', 250300),
(402199, 'PTHR30386:SF24', NULL, NULL, NULL, NULL, 'MANNURONAN SYNTHASE', 250301),
(402200, 'PTHR30386:SF26', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN COMB', 250301),
(402201, 'PTHR30386:SF25', NULL, NULL, NULL, NULL, 'MEMBRANE FUSION PROTEIN (MFP) FAMILY PROTEIN', 250301),
(402202, 'PTHR30386:SF17', NULL, NULL, NULL, NULL, 'ALKALINE PROTEASE SECRETION PROTEIN APRE', 250301),
(402203, 'PTHR30386', NULL, NULL, NULL, NULL, 'MEMBRANE FUSION SUBUNIT OF EMRAB-TOLC MULTIDRUG EFFLUX PUMP', 250301),
(402204, 'PTHR30386:SF19', NULL, NULL, NULL, NULL, 'MULTIDRUG EXPORT PROTEIN EMRA-RELATED', 250301),
(402205, 'PTHR30386:SF18', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YIAV-RELATED', 250301),
(402206, 'PTHR38128:SF2', NULL, NULL, NULL, NULL, 'OLIGOMERIC GOLGI COMPLEX SUBUNIT 4, PUTATIVE-RELATED', 250302),
(402207, 'PTHR38128', NULL, NULL, NULL, NULL, 'GAMETOCYTOGENESIS-IMPLICATED PROTEIN', 250302),
(402208, 'PTHR15889', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOMAL PROTEIN L37', 250303),
(402209, 'PTHR15889:SF2', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L37, MITOCHONDRIAL', 250303),
(402210, 'PTHR45418', NULL, NULL, NULL, NULL, 'CANCER/TESTIS ANTIGEN 55', 250304),
(402211, 'PTHR45418:SF4', NULL, NULL, NULL, NULL, 'CANCER/TESTIS ANTIGEN 55', 250304),
(402212, 'PTHR45418:SF3', NULL, NULL, NULL, NULL, 'CANCER/TESTIS ANTIGEN 55', 250304),
(402213, 'PTHR45418:SF2', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4933416I08 GENE', 250304),
(402214, 'PTHR45418:SF1', NULL, NULL, NULL, NULL, 'CANCER/TESTIS ANTIGEN 55', 250304),
(402215, 'PTHR30468:SF20', NULL, NULL, NULL, NULL, 'TAUD DOMAIN-CONTAINING PROTEIN-RELATED', 250305),
(402216, 'PTHR30468:SF10', NULL, NULL, NULL, NULL, 'TAUD DOMAIN-CONTAINING PROTEIN', 250305),
(402217, 'PTHR30468', NULL, NULL, NULL, NULL, 'ALPHA-KETOGLUTARATE-DEPENDENT SULFONATE DIOXYGENASE', 250305),
(402218, 'PTHR30468:SF1', NULL, NULL, NULL, NULL, 'ALPHA-KETOGLUTARATE-DEPENDENT SULFONATE DIOXYGENASE-RELATED', 250305),
(402219, 'PTHR30468:SF27', NULL, NULL, NULL, NULL, 'ALPHA-KETOGLUTARATE-DEPENDENT SULFONATE DIOXYGENASE', 250305),
(402220, 'PTHR30468:SF28', NULL, NULL, NULL, NULL, 'ALPHA-KETOGLUTARATE-DEPENDENT TAURINE DIOXYGENASE (AFU_ORTHOLOGUE AFUA_8G02210)-RELATED', 250305);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(402221, 'PTHR30468:SF29', NULL, NULL, NULL, NULL, 'FAMILY TAURINE DIOXYGENASE, PUTATIVE-RELATED', 250305),
(402222, 'PTHR30468:SF5', NULL, NULL, NULL, NULL, 'ALPHA-KETOGLUTARATE-DEPENDENT SULFATE ESTER DIOXYGENASE', 250305),
(402223, 'PTHR30468:SF9', NULL, NULL, NULL, NULL, 'ALPHA-KETOGLUTARATE-DEPENDENT TAURINE DIOXYGENASE (AFU_ORTHOLOGUE AFUA_3G01010)', 250305),
(402224, 'PTHR30468:SF30', NULL, NULL, NULL, NULL, 'ALPHA-KETOGLUTARATE-DEPENDENT TAURINE DIOXYGENASE (AFU_ORTHOLOGUE AFUA_7G06030)', 250305),
(402225, 'PTHR15708:SF14', NULL, NULL, NULL, NULL, 'MTSS I-BAR DOMAIN-CONTAINING 1', 250306),
(402226, 'PTHR15708', NULL, NULL, NULL, NULL, 'ACTIN BUNDLING/MISSING IN METASTASIS-RELATED', 250306),
(402227, 'PTHR15708:SF8', NULL, NULL, NULL, NULL, 'PROTEIN MTSS 2', 250306),
(402228, 'PTHR15708:SF15', NULL, NULL, NULL, NULL, 'IP14311P', 250306),
(402229, 'PTHR15708:SF4', NULL, NULL, NULL, NULL, 'FI21477P1-RELATED', 250306),
(402230, 'PTHR15708:SF10', NULL, NULL, NULL, NULL, 'PROTEIN MTSS 1', 250306),
(402231, 'PTHR35134:SF2', NULL, NULL, NULL, NULL, 'NUCLEOTIDASE YQFW-RELATED', 250307),
(402232, 'PTHR35134', NULL, NULL, NULL, NULL, 'NUCLEOTIDASE YQFW-RELATED', 250307),
(402233, 'PTHR13864:SF16', NULL, NULL, NULL, NULL, 'T-CELL ACUTE LYMPHOCYTIC LEUKEMIA PROTEIN 1', 250308),
(402234, 'PTHR13864:SF19', NULL, NULL, NULL, NULL, 'HELIX-LOOP-HELIX PROTEIN 2', 250308),
(402235, 'PTHR13864:SF23', NULL, NULL, NULL, NULL, 'LYL1 BASIC HELIX-LOOP-HELIX FAMILY MEMBER', 250308),
(402236, 'PTHR13864:SF15', NULL, NULL, NULL, NULL, 'HELIX LOOP HELIX PROTEIN 3B', 250308),
(402237, 'PTHR13864:SF20', NULL, NULL, NULL, NULL, 'HELIX-LOOP-HELIX PROTEIN 1', 250308),
(402238, 'PTHR13864:SF6', NULL, NULL, NULL, NULL, 'PROTEIN LYL-1', 250308),
(402239, 'PTHR13864:SF21', NULL, NULL, NULL, NULL, 'T-CELL ACUTE LYMPHOCYTIC LEUKEMIA PROTEIN 2', 250308),
(402240, 'PTHR13864:SF10', NULL, NULL, NULL, NULL, 'NESCIENT HELIX LOOP HELIX 2', 250308),
(402241, 'PTHR13864', NULL, NULL, NULL, NULL, 'T-CELL ACUTE LYMPHOCYTIC LEUKEMIA/STEM CELL LEUKEMIA-RELATED', 250308),
(402242, 'PTHR44981:SF2', NULL, NULL, NULL, NULL, 'PERICENTRIN-LIKE PROTEIN, ISOFORM F', 250309),
(402243, 'PTHR44981:SF1', NULL, NULL, NULL, NULL, 'A-KINASE ANCHOR PROTEIN 9', 250309),
(402244, 'PTHR44981:SF3', NULL, NULL, NULL, NULL, 'PERICENTRIN', 250309),
(402245, 'PTHR44981', NULL, NULL, NULL, NULL, 'PERICENTRIN-LIKE PROTEIN, ISOFORM F', 250309),
(402246, 'PTHR23041:SF79', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE COMPLEX SLX8-RFP SUBUNIT RFP2', 250310),
(402247, 'PTHR23041:SF78', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF4', 250310),
(402248, 'PTHR23041', NULL, NULL, NULL, NULL, 'RING FINGER DOMAIN-CONTAINING', 250310),
(402249, 'PTHR12113:SF12', NULL, NULL, NULL, NULL, 'DICKKOPF-RELATED PROTEIN 2', 250311),
(402250, 'PTHR12113:SF11', NULL, NULL, NULL, NULL, 'DICKKOPF-RELATED PROTEIN 1', 250311),
(402251, 'PTHR12113:SF10', NULL, NULL, NULL, NULL, 'DICKKOPF-RELATED PROTEIN 4', 250311),
(402252, 'PTHR12113', NULL, NULL, NULL, NULL, 'DICKKOPF3-LIKE 3', 250311),
(402253, 'PTHR12113:SF6', NULL, NULL, NULL, NULL, 'DICKKOPF_N DOMAIN-CONTAINING PROTEIN', 250311),
(402254, 'PTHR12113:SF31', NULL, NULL, NULL, NULL, 'DICKKOPF_N DOMAIN-CONTAINING PROTEIN', 250311),
(402255, 'PTHR12113:SF30', NULL, NULL, NULL, NULL, 'DICKKOPF_N DOMAIN-CONTAINING PROTEIN', 250311),
(402256, 'PTHR12113:SF8', NULL, NULL, NULL, NULL, 'DICKKOPF-RELATED PROTEIN 3', 250311),
(402257, 'PTHR12113:SF7', NULL, NULL, NULL, NULL, 'DICKKOPF-LIKE PROTEIN 1', 250311),
(402258, 'PTHR47894:SF1', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR VQSM', 250312),
(402259, 'PTHR47894', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR GADX', 250312),
(402260, 'PTHR47894:SF4', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR GADX', 250312),
(402261, 'PTHR31472:SF5', NULL, NULL, NULL, NULL, 'F5O8.30 PROTEIN', 250313),
(402262, 'PTHR31472:SF4', NULL, NULL, NULL, NULL, 'OS05G0100800 PROTEIN', 250313),
(402263, 'PTHR31472:SF8', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250313);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(402264, 'PTHR31472:SF18', NULL, NULL, NULL, NULL, 'BNAA04G19860D PROTEIN', 250313),
(402265, 'PTHR31472:SF28', NULL, NULL, NULL, NULL, 'BNAA07G09820D PROTEIN', 250313),
(402266, 'PTHR31472:SF17', NULL, NULL, NULL, NULL, 'XH DOMAIN-CONTAINING PROTEIN', 250313),
(402267, 'PTHR31472:SF19', NULL, NULL, NULL, NULL, 'BNAC01G36270D PROTEIN', 250313),
(402268, 'PTHR31472:SF14', NULL, NULL, NULL, NULL, 'OB-FOLD NUCLEIC ACID BINDING DOMAIN CONTAINING PROTEIN', 250313),
(402269, 'PTHR31472:SF36', NULL, NULL, NULL, NULL, 'NUCLEIC ACID-BINDING, OB-FOLD PROTEIN-RELATED', 250313),
(402270, 'PTHR31472:SF13', NULL, NULL, NULL, NULL, 'NUCLEIC ACID-BINDING, OB-FOLD-LIKE PROTEIN', 250313),
(402271, 'PTHR31472:SF35', NULL, NULL, NULL, NULL, 'F11M21.26 PROTEIN', 250313),
(402272, 'PTHR31472:SF24', NULL, NULL, NULL, NULL, 'BNAA09G03760D PROTEIN', 250313),
(402273, 'PTHR31472:SF38', NULL, NULL, NULL, NULL, 'NUCLEIC ACID-BINDING, OB-FOLD-LIKE PROTEIN', 250313),
(402274, 'PTHR31472:SF27', NULL, NULL, NULL, NULL, 'BNAA09G48050D PROTEIN', 250313),
(402275, 'PTHR31472:SF16', NULL, NULL, NULL, NULL, '', 250313),
(402276, 'PTHR31472:SF15', NULL, NULL, NULL, NULL, 'NUCLEIC ACID-BINDING, OB-FOLD-LIKE PROTEIN', 250313),
(402277, 'PTHR31472:SF37', NULL, NULL, NULL, NULL, 'NUCLEIC ACID-BINDING, OB-FOLD PROTEIN-RELATED', 250313),
(402278, 'PTHR31472:SF21', NULL, NULL, NULL, NULL, 'BNAC01G10000D PROTEIN', 250313),
(402279, 'PTHR31472:SF31', NULL, NULL, NULL, NULL, 'NUCLEIC ACID-BINDING, OB-FOLD PROTEIN-RELATED', 250313),
(402280, 'PTHR31472:SF20', NULL, NULL, NULL, NULL, '', 250313),
(402281, 'PTHR31472:SF22', NULL, NULL, NULL, NULL, 'BNAA03G49260D PROTEIN', 250313),
(402282, 'PTHR31472', NULL, NULL, NULL, NULL, 'OS05G0244600 PROTEIN', 250313),
(402283, 'PTHR31472:SF30', NULL, NULL, NULL, NULL, 'OS06G0103400 PROTEIN', 250313),
(402284, 'PTHR23044:SF25', NULL, NULL, NULL, NULL, 'EXONUCLEASE DOMAIN-CONTAINING PROTEIN', 250314),
(402285, 'PTHR23044:SF69', NULL, NULL, NULL, NULL, '3''-5'' EXORIBONUCLEASE 1-LIKE', 250314),
(402286, 'PTHR23044:SF68', NULL, NULL, NULL, NULL, 'EXONUCLEASE DOMAIN-CONTAINING PROTEIN', 250314),
(402287, 'PTHR23044:SF65', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 250314),
(402288, 'PTHR23044:SF75', NULL, NULL, NULL, NULL, 'EXONUCLEASE DOMAIN-CONTAINING PROTEIN', 250314),
(402289, 'PTHR23044:SF53', NULL, NULL, NULL, NULL, 'EXONUCLEASE DOMAIN-CONTAINING PROTEIN', 250314),
(402290, 'PTHR23044:SF4', NULL, NULL, NULL, NULL, 'CELL DEATH-RELATED NUCLEASE 4', 250314),
(402291, 'PTHR23044:SF74', NULL, NULL, NULL, NULL, 'ERI1 EXORIBONUCLEASE 3', 250314),
(402292, 'PTHR23044:SF73', NULL, NULL, NULL, NULL, 'ERI1 EXORIBONUCLEASE 2', 250314),
(402293, 'PTHR23044:SF72', NULL, NULL, NULL, NULL, '3''-5'' EXONUCLEASE ERI-1', 250314),
(402294, 'PTHR23044:SF61', NULL, NULL, NULL, NULL, '3''-5'' EXORIBONUCLEASE 1', 250314),
(402295, 'PTHR23044:SF60', NULL, NULL, NULL, NULL, 'OS01G0618000 PROTEIN', 250314),
(402296, 'PTHR23044', NULL, NULL, NULL, NULL, '3''-5'' EXONUCLEASE ERI1-RELATED', 250314),
(402297, 'PTHR47726', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT U, CHLOROPLASTIC', 250315),
(402298, 'PTHR47726:SF1', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT U, CHLOROPLASTIC', 250315),
(402299, 'PTHR37768:SF2', NULL, NULL, NULL, NULL, 'OS06G0694800 PROTEIN', 250316),
(402300, 'PTHR37768:SF3', NULL, NULL, NULL, NULL, 'BNAC09G32860D PROTEIN', 250316),
(402301, 'PTHR37768', NULL, NULL, NULL, NULL, 'OS06G0694800 PROTEIN', 250316),
(402302, 'PTHR22776', NULL, NULL, NULL, NULL, 'MARVEL-CONTAINING POTENTIAL LIPID RAFT-ASSOCIATED PROTEIN', 250317),
(402303, 'PTHR22776:SF29', NULL, NULL, NULL, NULL, 'CKLF-LIKE MARVEL TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN 4', 250317),
(402304, 'PTHR22776:SF28', NULL, NULL, NULL, NULL, 'MARVEL DOMAIN-CONTAINING PROTEIN 1', 250317),
(402305, 'PTHR22776:SF49', NULL, NULL, NULL, NULL, 'RH30783P', 250317),
(402306, 'PTHR22776:SF26', NULL, NULL, NULL, NULL, 'CKLF-LIKE MARVEL TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN 5', 250317),
(402307, 'PTHR22776:SF25', NULL, NULL, NULL, NULL, 'CKLF-LIKE MARVEL TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN 6', 250317);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(402308, 'PTHR22776:SF9', NULL, NULL, NULL, NULL, 'PLASMOLIPIN', 250317),
(402309, 'PTHR22776:SF24', NULL, NULL, NULL, NULL, 'MAL-LIKE PROTEIN', 250317),
(402310, 'PTHR22776:SF89', NULL, NULL, NULL, NULL, 'CKLF-LIKE MARVEL TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN 7', 250317),
(402311, 'PTHR22776:SF45', NULL, NULL, NULL, NULL, 'CHEMOKINE-LIKE FACTOR', 250317),
(402312, 'PTHR22776:SF88', NULL, NULL, NULL, NULL, 'MAL, T CELL DIFFERENTIATION PROTEIN B-RELATED', 250317),
(402313, 'PTHR22776:SF43', NULL, NULL, NULL, NULL, 'CKLF-LIKE MARVEL TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN 1', 250317),
(402314, 'PTHR22776:SF42', NULL, NULL, NULL, NULL, 'PROTEIN MAL2', 250317),
(402315, 'PTHR22776:SF85', NULL, NULL, NULL, NULL, 'CKLF-LIKE MARVEL TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN 2B', 250317),
(402316, 'PTHR22776:SF84', NULL, NULL, NULL, NULL, 'MARVEL DOMAIN-CONTAINING PROTEIN', 250317),
(402317, 'PTHR22776:SF93', NULL, NULL, NULL, NULL, 'MARVEL DOMAIN-CONTAINING PROTEIN', 250317),
(402318, 'PTHR22776:SF92', NULL, NULL, NULL, NULL, 'LD04844P', 250317),
(402319, 'PTHR22776:SF91', NULL, NULL, NULL, NULL, 'MARVEL DOMAIN-CONTAINING PROTEIN', 250317),
(402320, 'PTHR22776:SF4', NULL, NULL, NULL, NULL, 'PROTEOLIPID PROTEIN 2', 250317),
(402321, 'PTHR22776:SF3', NULL, NULL, NULL, NULL, 'CKLF-LIKE MARVEL TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN 3', 250317),
(402322, 'PTHR22776:SF39', NULL, NULL, NULL, NULL, 'PROTEIN SINGLES BAR', 250317),
(402323, 'PTHR22776:SF15', NULL, NULL, NULL, NULL, 'CKLF-LIKE MARVEL TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN 2', 250317),
(402324, 'PTHR22776:SF100', NULL, NULL, NULL, NULL, 'PROTEIN CBG25541', 250317),
(402325, 'PTHR22776:SF12', NULL, NULL, NULL, NULL, 'MYELIN AND LYMPHOCYTE PROTEIN', 250317),
(402326, 'PTHR22776:SF99', NULL, NULL, NULL, NULL, 'CKLF-LIKE MARVEL TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN 2A', 250317),
(402327, 'PTHR22776:SF77', NULL, NULL, NULL, NULL, 'MARVEL DOMAIN-CONTAINING PROTEIN', 250317),
(402328, 'PTHR22776:SF33', NULL, NULL, NULL, NULL, 'PROTEIN CBG22717', 250317),
(402329, 'PTHR22776:SF10', NULL, NULL, NULL, NULL, 'CKLF-LIKE MARVEL TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN 8', 250317),
(402330, 'PTHR22776:SF98', NULL, NULL, NULL, NULL, 'MARVEL DOMAIN-CONTAINING PROTEIN', 250317),
(402331, 'PTHR22776:SF97', NULL, NULL, NULL, NULL, 'RE01453P', 250317),
(402332, 'PTHR22776:SF96', NULL, NULL, NULL, NULL, 'MARVEL DOMAIN-CONTAINING PROTEIN', 250317),
(402333, 'PTHR22776:SF52', NULL, NULL, NULL, NULL, 'MARVEL DOMAIN-CONTAINING PROTEIN', 250317),
(402334, 'PTHR22776:SF95', NULL, NULL, NULL, NULL, 'MARVEL DOMAIN-CONTAINING PROTEIN', 250317),
(402335, 'PTHR22776:SF50', NULL, NULL, NULL, NULL, 'PROTEIN CBG14610', 250317),
(402336, 'PTHR22776:SF94', NULL, NULL, NULL, NULL, 'MAL, T CELL DIFFERENTIATION PROTEIN A-RELATED', 250317),
(402337, 'PTHR42839', NULL, NULL, NULL, NULL, 'ISOCHORISMATE SYNTHASE ENTC', 250318),
(402338, 'PTHR42839:SF2', NULL, NULL, NULL, NULL, 'ISOCHORISMATE SYNTHASE ENTC', 250318),
(402339, 'PTHR42839:SF1', NULL, NULL, NULL, NULL, 'ISOCHORISMATE SYNTHASE MENF', 250318),
(402340, 'PTHR43677:SF8', NULL, NULL, NULL, NULL, 'ARP PROTEIN (REF)', 250319),
(402341, 'PTHR43677', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/REDUCTASE', 250319),
(402342, 'PTHR43677:SF4', NULL, NULL, NULL, NULL, 'QUINONE OXIDOREDUCTASE-LIKE PROTEIN 2', 250319),
(402343, 'PTHR43677:SF10', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 250319),
(402344, 'PTHR43677:SF1', NULL, NULL, NULL, NULL, 'ACRYLYL-COA REDUCTASE ACUI-RELATED', 250319),
(402345, 'PTHR43677:SF3', NULL, NULL, NULL, NULL, 'PROSTAGLANDIN REDUCTASE 3', 250319),
(402346, 'PTHR43677:SF11', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 250319),
(402347, 'PTHR43677:SF12', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', 250319),
(402348, 'PTHR46879', NULL, NULL, NULL, NULL, 'SUSHI DOMAIN-CONTAINING PROTEIN 3', 250320),
(402349, 'PTHR46879:SF1', NULL, NULL, NULL, NULL, 'SUSHI DOMAIN-CONTAINING PROTEIN 3', 250320),
(402350, 'PTHR12443:SF9', NULL, NULL, NULL, NULL, 'TRANSLOCATION PROTEIN SEC62', 250321);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(402351, 'PTHR12443:SF11', NULL, NULL, NULL, NULL, 'TRANSLOCATION PROTEIN SEC62', 250321),
(402352, 'PTHR12443', NULL, NULL, NULL, NULL, 'TRANSLOCATION PROTEIN SEC62', 250321),
(402353, 'PTHR12443:SF12', NULL, NULL, NULL, NULL, 'TRANSLOCATION PROTEIN SEC62', 250321),
(402354, 'PTHR12443:SF14', NULL, NULL, NULL, NULL, 'TRANSLOCATION PROTEIN SEC62', 250321),
(402355, 'PTHR47546:SF5', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S15, CHLOROPLASTIC', 250322),
(402356, 'PTHR47546:SF3', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S15, CHLOROPLASTIC', 250322),
(402357, 'PTHR47546:SF4', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S15, CHLOROPLASTIC', 250322),
(402358, 'PTHR47546', NULL, NULL, NULL, NULL, 'S15/NS1, RNA-BINDING PROTEIN', 250322),
(402359, 'PTHR47546:SF2', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S15, CHLOROPLASTIC', 250322),
(402360, 'PTHR34364:SF13', NULL, NULL, NULL, NULL, 'BNAA05G13930D PROTEIN', 250323),
(402361, 'PTHR34364:SF12', NULL, NULL, NULL, NULL, '', 250323),
(402362, 'PTHR34364:SF9', NULL, NULL, NULL, NULL, '', 250323),
(402363, 'PTHR34364:SF8', NULL, NULL, NULL, NULL, '', 250323),
(402364, 'PTHR34364:SF14', NULL, NULL, NULL, NULL, 'BNAA09G44110D PROTEIN', 250323),
(402365, 'PTHR34364:SF7', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 250323),
(402366, 'PTHR34364:SF11', NULL, NULL, NULL, NULL, 'WAS/WASL-INTERACTING PROTEIN FAMILY MEMBER 3-LIKE', 250323),
(402367, 'PTHR34364:SF10', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 250323),
(402368, 'PTHR34364', NULL, NULL, NULL, NULL, 'WAS/WASL-INTERACTING FAMILY PROTEIN', 250323),
(402369, 'PTHR34364:SF2', NULL, NULL, NULL, NULL, 'OS01G0579800 PROTEIN', 250323),
(402370, 'PTHR34364:SF1', NULL, NULL, NULL, NULL, 'WAS/WASL-INTERACTING FAMILY PROTEIN', 250323),
(402371, 'PTHR47467:SF1', NULL, NULL, NULL, NULL, 'OS01G0867200 PROTEIN', 250324),
(402372, 'PTHR47467', NULL, NULL, NULL, NULL, 'OS01G0867200 PROTEIN', 250324),
(402373, 'PTHR13581', NULL, NULL, NULL, NULL, 'MRG-BINDING PROTEIN', 250325),
(402374, 'PTHR13581:SF5', NULL, NULL, NULL, NULL, 'MRG/MORF4L-BINDING PROTEIN', 250325),
(402375, 'PTHR13581:SF8', NULL, NULL, NULL, NULL, 'BNAA09G28940D PROTEIN', 250325),
(402376, 'PTHR13581:SF7', NULL, NULL, NULL, NULL, '', 250325),
(402377, 'PTHR35968', NULL, NULL, NULL, NULL, 'CHROMOSOME 6 C6ORF201 HOMOLOG', 250326),
(402378, 'PTHR35968:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 35 C6ORF201 HOMOLOG', 250326),
(402379, 'PTHR36408', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 250327),
(402380, 'PTHR36408:SF2', NULL, NULL, NULL, NULL, 'BNAANNG04740D PROTEIN', 250327),
(402381, 'PTHR36408:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 250327),
(402382, 'PTHR24068:SF434', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 30', 250328),
(402383, 'PTHR24068:SF159', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 T', 250328),
(402384, 'PTHR24068:SF399', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402385, 'PTHR24068:SF157', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2-21 KDA', 250328),
(402386, 'PTHR24068:SF318', NULL, NULL, NULL, NULL, 'UBIQUITIN E2 VARIANT 1D-4-RELATED', 250328),
(402387, 'PTHR24068:SF436', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402388, 'PTHR24068:SF315', NULL, NULL, NULL, NULL, 'NEDD8-CONJUGATING ENZYME UBC12', 250328),
(402389, 'PTHR24068:SF393', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 S', 250328),
(402390, 'PTHR24068:SF152', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 N', 250328),
(402391, 'PTHR24068:SF394', NULL, NULL, NULL, NULL, 'E2 UBIQUITIN-CONJUGATING ENZYME', 250328),
(402392, 'PTHR24068:SF430', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402393, 'PTHR24068:SF398', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402394, 'PTHR24068:SF153', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 W-A-RELATED', 250328),
(402395, 'PTHR24068:SF395', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 18-RELATED', 250328);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(402396, 'PTHR24068:SF44', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 D2B', 250328),
(402397, 'PTHR24068:SF43', NULL, NULL, NULL, NULL, 'UBIQUITIN/ISG15-CONJUGATING ENZYME E2 L6', 250328),
(402398, 'PTHR24068:SF41', NULL, NULL, NULL, NULL, 'AT30415P', 250328),
(402399, 'PTHR24068:SF168', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 J1', 250328),
(402400, 'PTHR24068:SF201', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402401, 'PTHR24068:SF323', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 VARIANT 1', 250328),
(402402, 'PTHR24068:SF207', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402403, 'PTHR24068:SF449', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402404, 'PTHR24068:SF441', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2-23 KDA-LIKE', 250328),
(402405, 'PTHR24068:SF321', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 4-RELATED', 250328),
(402406, 'PTHR24068:SF164', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 21-RELATED', 250328),
(402407, 'PTHR24068:SF290', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 34-LIKE', 250328),
(402408, 'PTHR24068:SF170', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 L5', 250328),
(402409, 'PTHR24068:SF291', NULL, NULL, NULL, NULL, '', 250328),
(402410, 'PTHR24068:SF33', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2Q FAMILY MEMBER 1-RELATED', 250328),
(402411, 'PTHR24068:SF36', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 D1', 250328),
(402412, 'PTHR24068:SF456', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 Q2', 250328),
(402413, 'PTHR24068:SF335', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 36', 250328),
(402414, 'PTHR24068:SF214', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402415, 'PTHR24068:SF457', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME FAMILY-RELATED', 250328),
(402416, 'PTHR24068:SF215', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 VARIANT 1A', 250328),
(402417, 'PTHR24068:SF336', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402418, 'PTHR24068:SF454', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 22', 250328),
(402419, 'PTHR24068:SF334', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402420, 'PTHR24068:SF455', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402421, 'PTHR24068:SF458', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402422, 'PTHR24068:SF459', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402423, 'PTHR24068:SF452', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2-23 KDA-LIKE', 250328),
(402424, 'PTHR24068:SF298', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402425, 'PTHR24068:SF210', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402426, 'PTHR24068:SF177', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 VARIANT 2', 250328),
(402427, 'PTHR24068:SF211', NULL, NULL, NULL, NULL, 'AKT-INTERACTING PROTEIN', 250328),
(402428, 'PTHR24068:SF453', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME FAMILY-RELATED', 250328),
(402429, 'PTHR24068:SF450', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402430, 'PTHR24068:SF451', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402431, 'PTHR24068:SF330', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 D2', 250328),
(402432, 'PTHR24068:SF24', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 D4', 250328),
(402433, 'PTHR24068:SF467', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402434, 'PTHR24068:SF500', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402435, 'PTHR24068:SF468', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402436, 'PTHR24068:SF501', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(402437, 'PTHR24068:SF465', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402438, 'PTHR24068:SF466', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402439, 'PTHR24068:SF504', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402440, 'PTHR24068:SF505', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402441, 'PTHR24068:SF502', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402442, 'PTHR24068:SF469', NULL, NULL, NULL, NULL, 'UBIQUITIN CARRIER PROTEIN', 250328),
(402443, 'PTHR24068:SF503', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402444, 'PTHR24068:SF228', NULL, NULL, NULL, NULL, 'OS01G0273100 PROTEIN', 250328),
(402445, 'PTHR24068:SF460', NULL, NULL, NULL, NULL, 'BCDNA.GH02435', 250328),
(402446, 'PTHR24068:SF342', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402447, 'PTHR24068:SF463', NULL, NULL, NULL, NULL, 'NEDD8-CONJUGATING ENZYME UBC12-LIKE-RELATED', 250328),
(402448, 'PTHR24068:SF343', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 VARIANT 1B', 250328),
(402449, 'PTHR24068:SF464', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402450, 'PTHR24068:SF461', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 10', 250328),
(402451, 'PTHR24068:SF340', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402452, 'PTHR24068:SF220', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402453, 'PTHR24068:SF462', NULL, NULL, NULL, NULL, 'FI16911P1', 250328),
(402454, 'PTHR24068:SF508', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402455, 'PTHR24068:SF509', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 10', 250328),
(402456, 'PTHR24068:SF506', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2-17 KDA', 250328),
(402457, 'PTHR24068:SF507', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 19-RELATED', 250328),
(402458, 'PTHR24068:SF357', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402459, 'PTHR24068:SF478', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME/RWD-LIKE PROTEIN-RELATED', 250328),
(402460, 'PTHR24068:SF511', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402461, 'PTHR24068:SF479', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402462, 'PTHR24068:SF512', NULL, NULL, NULL, NULL, 'OS12G0605400 PROTEIN', 250328),
(402463, 'PTHR24068:SF116', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2L 3A-RELATED', 250328),
(402464, 'PTHR24068:SF476', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 36-LIKE PROTEIN', 250328),
(402465, 'PTHR24068:SF510', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402466, 'PTHR24068:SF477', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402467, 'PTHR24068:SF515', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 36', 250328),
(402468, 'PTHR24068:SF516', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 4-LIKE ISOFORM X1', 250328),
(402469, 'PTHR24068:SF513', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 28', 250328),
(402470, 'PTHR24068:SF514', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2-23 KDA ISOFORM X1', 250328),
(402471, 'PTHR24068:SF239', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402472, 'PTHR24068:SF470', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402473, 'PTHR24068:SF471', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 22-LIKE', 250328),
(402474, 'PTHR24068:SF353', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 8', 250328),
(402475, 'PTHR24068:SF474', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 29', 250328),
(402476, 'PTHR24068:SF354', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402477, 'PTHR24068:SF475', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 16-RELATED', 250328);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(402478, 'PTHR24068:SF472', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402479, 'PTHR24068:SF473', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402480, 'PTHR24068:SF352', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME 15', 250328),
(402481, 'PTHR24068:SF517', NULL, NULL, NULL, NULL, 'PROTEIN PEROXIN-4-LIKE', 250328),
(402482, 'PTHR24068:SF489', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402483, 'PTHR24068:SF126', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402484, 'PTHR24068:SF401', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 17-RELATED', 250328),
(402485, 'PTHR24068:SF127', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 VARIANT 1C-LIKE', 250328),
(402486, 'PTHR24068:SF487', NULL, NULL, NULL, NULL, 'NEDD8-CONJUGATING ENZYME UBC12', 250328),
(402487, 'PTHR24068:SF488', NULL, NULL, NULL, NULL, 'OS10G0447100 PROTEIN', 250328),
(402488, 'PTHR24068:SF405', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402489, 'PTHR24068:SF406', NULL, NULL, NULL, NULL, 'AMINOACYLTRANSFERASE, E1 UBIQUITIN-ACTIVATING ENZYME-RELATED', 250328),
(402490, 'PTHR24068:SF128', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 H', 250328),
(402491, 'PTHR24068:SF129', NULL, NULL, NULL, NULL, 'NEDD8-CONJUGATING ENZYME UBE2F', 250328),
(402492, 'PTHR24068:SF404', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 28-LIKE', 250328),
(402493, 'PTHR24068:SF360', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 C', 250328),
(402494, 'PTHR24068:SF481', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 W', 250328),
(402495, 'PTHR24068:SF482', NULL, NULL, NULL, NULL, 'SUMO-CONJUGATING ENZYME UBC9', 250328),
(402496, 'PTHR24068:SF480', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402497, 'PTHR24068:SF485', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402498, 'PTHR24068:SF486', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 W', 250328),
(402499, 'PTHR24068:SF362', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402500, 'PTHR24068:SF483', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402501, 'PTHR24068:SF484', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402502, 'PTHR24068:SF242', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 31-RELATED', 250328),
(402503, 'PTHR24068:SF121', NULL, NULL, NULL, NULL, 'UBIQUITIN CONJUGATING ENZYME E2 B', 250328),
(402504, 'PTHR24068:SF73', NULL, NULL, NULL, NULL, 'OS02G0721200 PROTEIN', 250328),
(402505, 'PTHR24068:SF72', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2Q-LIKE PROTEIN 1', 250328),
(402506, 'PTHR24068:SF70', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 E1', 250328),
(402507, 'PTHR24068:SF74', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2D N-TERMINAL-LIKE 1-RELATED', 250328),
(402508, 'PTHR24068:SF138', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 N-LIKE-RELATED', 250328),
(402509, 'PTHR24068:SF135', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 J2', 250328),
(402510, 'PTHR24068:SF498', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402511, 'PTHR24068:SF377', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402512, 'PTHR24068:SF410', NULL, NULL, NULL, NULL, '', 250328),
(402513, 'PTHR24068:SF411', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402514, 'PTHR24068:SF499', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 12-RELATED', 250328),
(402515, 'PTHR24068:SF415', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 D3', 250328),
(402516, 'PTHR24068:SF492', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 VARIANT 1C', 250328),
(402517, 'PTHR24068:SF493', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402518, 'PTHR24068:SF490', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2-24 KDA', 250328);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(402519, 'PTHR24068:SF491', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402520, 'PTHR24068:SF496', NULL, NULL, NULL, NULL, 'PROTEIN PEROXIN-4', 250328),
(402521, 'PTHR24068:SF375', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402522, 'PTHR24068:SF497', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402523, 'PTHR24068:SF373', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402524, 'PTHR24068:SF494', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402525, 'PTHR24068:SF495', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 11', 250328),
(402526, 'PTHR24068:SF132', NULL, NULL, NULL, NULL, 'NEDD8-CONJUGATING ENZYME UBCE2M', 250328),
(402527, 'PTHR24068:SF418', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 6', 250328),
(402528, 'PTHR24068:SF63', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 E3', 250328),
(402529, 'PTHR24068:SF419', NULL, NULL, NULL, NULL, 'E2 UBIQUITIN-CONJUGATING ENZYME', 250328),
(402530, 'PTHR24068:SF67', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 L3', 250328),
(402531, 'PTHR24068:SF423', NULL, NULL, NULL, NULL, 'ENZYME, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G15570)-RELATED', 250328),
(402532, 'PTHR24068:SF424', NULL, NULL, NULL, NULL, 'OS12G0636800 PROTEIN', 250328),
(402533, 'PTHR24068:SF149', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 J2-LIKE', 250328),
(402534, 'PTHR24068:SF303', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402535, 'PTHR24068:SF267', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402536, 'PTHR24068:SF421', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME/RWD-LIKE PROTEIN-RELATED', 250328),
(402537, 'PTHR24068:SF147', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 K', 250328),
(402538, 'PTHR24068:SF306', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402539, 'PTHR24068:SF428', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 11-LIKE', 250328),
(402540, 'PTHR24068:SF304', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402541, 'PTHR24068:SF141', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402542, 'PTHR24068:SF380', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402543, 'PTHR24068:SF381', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402544, 'PTHR24068:SF144', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 C-RELATED', 250328),
(402545, 'PTHR24068:SF420', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402546, 'PTHR24068:SF387', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2E 2', 250328),
(402547, 'PTHR24068:SF384', NULL, NULL, NULL, NULL, 'E2 UBIQUITIN-CONJUGATING ENZYME', 250328),
(402548, 'PTHR24068', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2', 250328),
(402549, 'PTHR24068:SF264', NULL, NULL, NULL, NULL, 'UBC CORE DOMAIN-CONTAINING PROTEIN', 250328),
(402550, 'PTHR24068:SF385', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 18-RELATED', 250328),
(402551, 'PTHR24068:SF143', NULL, NULL, NULL, NULL, 'GEO06356P1', 250328),
(402552, 'PTHR24068:SF308', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME 28', 250328),
(402553, 'PTHR24068:SF429', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 E2', 250328),
(402554, 'PTHR24068:SF56', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 Q1', 250328),
(402555, 'PTHR43801', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-BINDING PROTEIN-RELATED', 250329),
(402556, 'PTHR43801:SF1', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-BINDING PROTEIN-RELATED', 250329),
(402557, 'PTHR35381:SF1', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 250330),
(402558, 'PTHR35381', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 250330),
(402559, 'PTHR31139', NULL, NULL, NULL, NULL, 'ECTOPIC P GRANULES PROTEIN 5 HOMOLOG', 250331),
(402560, 'PTHR31139:SF6', NULL, NULL, NULL, NULL, 'PROTEIN LIMB EXPRESSION 1 HOMOLOG', 250331);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(402561, 'PTHR31139:SF5', NULL, NULL, NULL, NULL, 'PROTEIN LIMB EXPRESSION 1 HOMOLOG', 250331),
(402562, 'PTHR31139:SF4', NULL, NULL, NULL, NULL, 'ECTOPIC P GRANULES PROTEIN 5 HOMOLOG', 250331),
(402563, 'PTHR31139:SF3', NULL, NULL, NULL, NULL, 'LIX1-LIKE PROTEIN', 250331),
(402564, 'PTHR42793:SF1', NULL, NULL, NULL, NULL, 'PEPTIDYL-LYSINE N-ACETYLTRANSFERASE PATZ', 250332),
(402565, 'PTHR42793', NULL, NULL, NULL, NULL, 'COA BINDING DOMAIN CONTAINING PROTEIN', 250332),
(402566, 'PTHR42793:SF4', NULL, NULL, NULL, NULL, 'BLL6376 PROTEIN', 250332),
(402567, 'PTHR42342', NULL, NULL, NULL, NULL, 'STATIONARY PHASE PROTEIN 5', 250333),
(402568, 'PTHR42342:SF1', NULL, NULL, NULL, NULL, 'STATIONARY PHASE PROTEIN 5', 250333),
(402569, 'PTHR12969', NULL, NULL, NULL, NULL, 'NGD5/OSM-6/IFT52', 250334),
(402570, 'PTHR12969:SF7', NULL, NULL, NULL, NULL, 'INTRAFLAGELLAR TRANSPORT PROTEIN 52 HOMOLOG', 250334),
(402571, 'PTHR34368:SF1', NULL, NULL, NULL, NULL, 'OS01G0962200 PROTEIN', 250335),
(402572, 'PTHR34368:SF2', NULL, NULL, NULL, NULL, 'ALKALINE PHYTOCERAMIDASE (APHC)', 250335),
(402573, 'PTHR34368:SF7', NULL, NULL, NULL, NULL, 'ALKALINE PHYTOCERAMIDASE (APHC)', 250335),
(402574, 'PTHR34368', NULL, NULL, NULL, NULL, 'OS01G0962200 PROTEIN', 250335),
(402575, 'PTHR23546', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN', 250336),
(402576, 'PTHR23546:SF1', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 250336),
(402577, 'PTHR15617:SF1', NULL, NULL, NULL, NULL, 'AT-HOOK DNA-BINDING MOTIF-CONTAINING PROTEIN 1', 250337),
(402578, 'PTHR15617', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 250337),
(402579, 'PTHR15175', NULL, NULL, NULL, NULL, 'NEUTROPHIL CYTOSOLIC FACTOR 2, NEUTROPHIL NADPH OXIDASE FACTOR 2', 250338),
(402580, 'PTHR15175:SF4', NULL, NULL, NULL, NULL, 'NADPH OXIDASE ACTIVATOR 1', 250338),
(402581, 'PTHR15175:SF3', NULL, NULL, NULL, NULL, 'NEUTROPHIL CYTOSOL FACTOR 2', 250338),
(402582, 'PTHR15175:SF0', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-CONTAINING PROTEIN C23A1.17', 250338),
(402583, 'PTHR33608:SF12', NULL, NULL, NULL, NULL, 'DUF58 DOMAIN-CONTAINING PROTEIN', 250339),
(402584, 'PTHR33608:SF6', NULL, NULL, NULL, NULL, 'BLL2464 PROTEIN', 250339),
(402585, 'PTHR33608:SF13', NULL, NULL, NULL, NULL, 'POSSIBLE CONSERVED MEMBRANE PROTEIN', 250339),
(402586, 'PTHR33608:SF7', NULL, NULL, NULL, NULL, 'DUF58 DOMAIN-CONTAINING PROTEIN', 250339),
(402587, 'PTHR33608', NULL, NULL, NULL, NULL, 'BLL2464 PROTEIN', 250339),
(402588, 'PTHR33608:SF3', NULL, NULL, NULL, NULL, 'SLR2013 PROTEIN', 250339),
(402589, 'PTHR43576:SF2', NULL, NULL, NULL, NULL, 'INTRACELLULAR EXO-ALPHA-L-ARABINOFURANOSIDASE 2', 250340),
(402590, 'PTHR43576:SF3', NULL, NULL, NULL, NULL, 'ALPHA-L-ARABINOFURANOSIDASE C', 250340),
(402591, 'PTHR43576', NULL, NULL, NULL, NULL, 'ALPHA-L-ARABINOFURANOSIDASE C-RELATED', 250340),
(402592, 'PTHR15240', NULL, NULL, NULL, NULL, 'CAVIN', 250341),
(402593, 'PTHR15240:SF6', NULL, NULL, NULL, NULL, 'CAVEOLAE-ASSOCIATED PROTEIN 4B', 250341),
(402594, 'PTHR15240:SF5', NULL, NULL, NULL, NULL, 'CAVEOLAE-ASSOCIATED PROTEIN 2A', 250341),
(402595, 'PTHR15240:SF4', NULL, NULL, NULL, NULL, 'CAVEOLAE-ASSOCIATED PROTEIN 4', 250341),
(402596, 'PTHR15240:SF3', NULL, NULL, NULL, NULL, 'CAVEOLAE-ASSOCIATED PROTEIN 1', 250341),
(402597, 'PTHR15240:SF2', NULL, NULL, NULL, NULL, 'CAVEOLAE-ASSOCIATED PROTEIN 3', 250341),
(402598, 'PTHR15240:SF1', NULL, NULL, NULL, NULL, 'CAVEOLAE-ASSOCIATED PROTEIN 2', 250341),
(402599, 'PTHR46845', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR I', 250342),
(402600, 'PTHR46845:SF2', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR 3', 250342),
(402601, 'PTHR46845:SF3', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR 1', 250342),
(402602, 'PTHR46845:SF1', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR I', 250342),
(402603, 'PTHR46845:SF4', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR I', 250342),
(402604, 'PTHR17388', NULL, NULL, NULL, NULL, 'SECRETOGRANIN III', 250343),
(402605, 'PTHR17388:SF2', NULL, NULL, NULL, NULL, 'SECRETOGRANIN-3', 250343),
(402606, 'PTHR31357:SF3', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS ALPHA-33', 250344);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(402607, 'PTHR31357:SF2', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS ALPHA-32', 250344),
(402608, 'PTHR31357:SF15', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS ALPHA-13', 250344),
(402609, 'PTHR31357:SF5', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS ALPHA-1-RELATED', 250344),
(402610, 'PTHR31357', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS ALPHA-10', 250344),
(402611, 'PTHR31357:SF16', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS A (ALPHA)-RELATED', 250344),
(402612, 'PTHR31357:SF4', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS ALPHA-34', 250344),
(402613, 'PTHR31357:SF17', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS A (ALPHA)', 250344),
(402614, 'PTHR31357:SF7', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS A (ALPHA)', 250344),
(402615, 'PTHR31357:SF18', NULL, NULL, NULL, NULL, 'PROTEIN CBG21509', 250344),
(402616, 'PTHR31357:SF6', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS B (BETA)', 250344),
(402617, 'PTHR31357:SF19', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS ALPHA-10', 250344),
(402618, 'PTHR31357:SF8', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS A (ALPHA)', 250344),
(402619, 'PTHR31357:SF20', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS BETA-18', 250344),
(402620, 'PTHR31357:SF11', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS ALPHA-11', 250344),
(402621, 'PTHR31357:SF13', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS ALPHA-12', 250344),
(402622, 'PTHR31357:SF14', NULL, NULL, NULL, NULL, 'PROTEIN CBG00326', 250344),
(402623, 'PTHR43600', NULL, NULL, NULL, NULL, 'COENZYME F420 HYDROGENASE, SUBUNIT ALPHA', 250345),
(402624, 'PTHR43600:SF1', NULL, NULL, NULL, NULL, 'COENZYME F420 HYDROGENASE SUBUNIT ALPHA', 250345),
(402625, 'PTHR43600:SF2', NULL, NULL, NULL, NULL, 'CYTOSOLIC NIFE-HYDROGENASE, ALPHA SUBUNIT', 250345),
(402626, 'PTHR43600:SF3', NULL, NULL, NULL, NULL, 'F420-NON-REDUCING HYDROGENASE VHU SUBUNIT A', 250345),
(402627, 'PTHR35992:SF4', NULL, NULL, NULL, NULL, '', 250346),
(402628, 'PTHR35992:SF5', NULL, NULL, NULL, NULL, 'BNAA08G31190D PROTEIN', 250346),
(402629, 'PTHR35992:SF6', NULL, NULL, NULL, NULL, '', 250346),
(402630, 'PTHR35992', NULL, NULL, NULL, NULL, 'CYTOMATRIX PROTEIN-LIKE PROTEIN', 250346),
(402631, 'PTHR35992:SF1', NULL, NULL, NULL, NULL, 'CYTOMATRIX PROTEIN-LIKE PROTEIN', 250346),
(402632, 'PTHR43044:SF1', NULL, NULL, NULL, NULL, '', 250347),
(402633, 'PTHR43044', NULL, NULL, NULL, NULL, '', 250347),
(402634, 'PTHR43044:SF2', NULL, NULL, NULL, NULL, 'POLYSULPHIDE REDUCTASE NRFD', 250347),
(402635, 'PTHR38681', NULL, NULL, NULL, NULL, 'RETROVIRUS-RELATED POL POLYPROTEIN FROM TRANSPOSON 412-LIKE PROTEIN-RELATED', 250348),
(402636, 'PTHR38681:SF1', NULL, NULL, NULL, NULL, 'RETROVIRUS-RELATED POL POLYPROTEIN FROM TRANSPOSON 412-LIKE PROTEIN', 250348),
(402637, 'PTHR38681:SF2', NULL, NULL, NULL, NULL, 'INTEGRASE_H2C2 DOMAIN-CONTAINING PROTEIN', 250348),
(402638, 'PTHR46943', NULL, NULL, NULL, NULL, 'PENTRAXIN-RELATED PROTEIN PTX3', 250349),
(402639, 'PTHR46943:SF1', NULL, NULL, NULL, NULL, 'PENTRAXIN-RELATED PROTEIN PTX3', 250349),
(402640, 'PTHR11732:SF218', NULL, NULL, NULL, NULL, 'NADPH-DEPENDENT ALDOSE REDUCTASE GRE3', 250350),
(402641, 'PTHR11732:SF459', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 250350),
(402642, 'PTHR11732:SF458', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 250350),
(402643, 'PTHR11732:SF457', NULL, NULL, NULL, NULL, 'ASCORBATE BIOSYNTHESIS-RELATED PROTEIN', 250350),
(402644, 'PTHR11732:SF456', NULL, NULL, NULL, NULL, 'ALDO/KETO REDUCTASE FAMILY OXIDOREDUCTASE', 250350),
(402645, 'PTHR11732:SF455', NULL, NULL, NULL, NULL, 'D-GALACTURONATE REDUCTASE-LIKE ISOFORM X1', 250350),
(402646, 'PTHR11732:SF211', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE FAMILY 1 MEMBER D1', 250350),
(402647, 'PTHR11732:SF453', NULL, NULL, NULL, NULL, 'NADPH-DEPENDENT CODEINONE REDUCTASE 1-2-RELATED', 250350),
(402648, 'PTHR11732:SF177', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 250350),
(402649, 'PTHR11732:SF450', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 250350);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(402650, 'PTHR11732:SF175', NULL, NULL, NULL, NULL, 'JMJC DOMAIN-CONTAINING PROTEIN', 250350),
(402651, 'PTHR11732:SF294', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE FAMILY 1 MEMBER B1', 250350),
(402652, 'PTHR11732:SF291', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 250350),
(402653, 'PTHR11732:SF290', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 250350),
(402654, 'PTHR11732:SF509', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 250350),
(402655, 'PTHR11732:SF508', NULL, NULL, NULL, NULL, 'D-XYLOSE REDUCTASE', 250350),
(402656, 'PTHR11732:SF507', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE FAMILY 1 MEMBER A1', 250350),
(402657, 'PTHR11732:SF506', NULL, NULL, NULL, NULL, 'ALDEHYDE REDUCTASE Y, ISOFORM D-RELATED', 250350),
(402658, 'PTHR11732:SF505', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 250350),
(402659, 'PTHR11732:SF504', NULL, NULL, NULL, NULL, 'GLYCEROL 2-DEHYDROGENASE (NADP(+))-RELATED', 250350),
(402660, 'PTHR11732:SF503', NULL, NULL, NULL, NULL, 'D-ARABINOSE DEHYDROGENASE [NAD(P)+] HEAVY CHAIN', 250350),
(402661, 'PTHR11732:SF469', NULL, NULL, NULL, NULL, 'NAD(P)-LINKED OXIDOREDUCTASE SUPERFAMILY PROTEIN-RELATED', 250350),
(402662, 'PTHR11732:SF502', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 250350),
(402663, 'PTHR11732:SF468', NULL, NULL, NULL, NULL, 'NADPH-DEPENDENT ALDO-KETO REDUCTASE, CHLOROPLASTIC-LIKE', 250350),
(402664, 'PTHR11732:SF500', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 250350),
(402665, 'PTHR11732:SF464', NULL, NULL, NULL, NULL, 'ALDOSE REDUCTASE-RELATED PROTEIN 2', 250350),
(402666, 'PTHR11732:SF460', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE', 250350),
(402667, 'PTHR11732:SF182', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 250350),
(402668, 'PTHR11732:SF519', NULL, NULL, NULL, NULL, 'ZGC:56622', 250350),
(402669, 'PTHR11732:SF518', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE FAMILY 1 MEMBER C4', 250350),
(402670, 'PTHR11732:SF517', NULL, NULL, NULL, NULL, 'OS05G0456300 PROTEIN', 250350),
(402671, 'PTHR11732:SF516', NULL, NULL, NULL, NULL, 'ALDO/KETO REDUCTASE FAMILY OXIDOREDUCTASE', 250350),
(402672, 'PTHR11732:SF515', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN-RELATED', 250350),
(402673, 'PTHR11732:SF514', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE', 250350),
(402674, 'PTHR11732:SF513', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 250350),
(402675, 'PTHR11732:SF479', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 250350),
(402676, 'PTHR11732:SF512', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 250350),
(402677, 'PTHR11732:SF478', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE FAMILY 4 MEMBER C9-LIKE', 250350),
(402678, 'PTHR11732:SF511', NULL, NULL, NULL, NULL, '', 250350),
(402679, 'PTHR11732:SF510', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE FAMILY 1 MEMBER C18', 250350),
(402680, 'PTHR11732:SF473', NULL, NULL, NULL, NULL, 'ASCORBATE BIOSYNTHESIS-RELATED PROTEIN', 250350),
(402681, 'PTHR11732:SF198', NULL, NULL, NULL, NULL, 'REDUCTASE (AKR), PUTATIVE (AFU_ORTHOLOGUE AFUA_5G01910)-RELATED', 250350),
(402682, 'PTHR11732:SF472', NULL, NULL, NULL, NULL, 'ASCORBATE BIOSYNTHESIS-RELATED PROTEIN', 250350),
(402683, 'PTHR11732:SF197', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE FAMILY 1 MEMBER B15', 250350),
(402684, 'PTHR11732:SF470', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 250350),
(402685, 'PTHR11732:SF409', NULL, NULL, NULL, NULL, 'NAD(P)H-DEPENDENT 6''-DEOXYCHALCONE SYNTHASE', 250350),
(402686, 'PTHR11732:SF524', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE 1B, ISOFORM C-RELATED', 250350),
(402687, 'PTHR11732:SF402', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE FAMILY 1 MEMBER A1-A', 250350),
(402688, 'PTHR11732:SF523', NULL, NULL, NULL, NULL, 'DEOXYMUGINEIC ACID SYNTHASE 1', 250350),
(402689, 'PTHR11732:SF522', NULL, NULL, NULL, NULL, 'NAD(P)-LINKED OXIDOREDUCTASE SUPERFAMILY PROTEIN', 250350);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(402690, 'PTHR11732:SF489', NULL, NULL, NULL, NULL, 'D-XYLOSE REDUCTASE', 250350),
(402691, 'PTHR11732:SF488', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE FAMILY 1 MEMBER A1-B', 250350),
(402692, 'PTHR11732:SF521', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 250350),
(402693, 'PTHR11732:SF487', NULL, NULL, NULL, NULL, 'ALDO/KETO REDUCTASE FAMILY PROTEIN', 250350),
(402694, 'PTHR11732:SF520', NULL, NULL, NULL, NULL, 'NADPH-DEPENDENT ALDO-KETO REDUCTASE, CHLOROPLASTIC', 250350),
(402695, 'PTHR11732:SF486', NULL, NULL, NULL, NULL, 'D-XYLOSE REDUCTASE', 250350),
(402696, 'PTHR11732:SF483', NULL, NULL, NULL, NULL, 'ALDO/KETO REDUCTASE/POTASSIUM CHANNEL SUBUNIT BETA-RELATED', 250350),
(402697, 'PTHR11732:SF482', NULL, NULL, NULL, NULL, 'LD24679P', 250350),
(402698, 'PTHR11732:SF480', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE FAMILY 1 MEMBER C21', 250350),
(402699, 'PTHR11732:SF419', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 250350),
(402700, 'PTHR11732:SF416', NULL, NULL, NULL, NULL, 'ALDO/KETO REDUCTASE FAMILY OXIDOREDUCTASE', 250350),
(402701, 'PTHR11732:SF414', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE FAMILY 4 MEMBER C8', 250350),
(402702, 'PTHR11732:SF411', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE [NADP(+)]-LIKE', 250350),
(402703, 'PTHR11732:SF499', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 250350),
(402704, 'PTHR11732:SF497', NULL, NULL, NULL, NULL, 'NON-FUNCTIONAL NADPH-DEPENDENT CODEINONE REDUCTASE 2-LIKE ISOFORM X1', 250350),
(402705, 'PTHR11732:SF252', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE FAMILY 4 MEMBER C9', 250350),
(402706, 'PTHR11732:SF251', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE FAMILY 4 MEMBER C9', 250350),
(402707, 'PTHR11732:SF493', NULL, NULL, NULL, NULL, 'METHYLECGONONE REDUCTASE-LIKE', 250350),
(402708, 'PTHR11732:SF372', NULL, NULL, NULL, NULL, 'OS04G0447700 PROTEIN', 250350),
(402709, 'PTHR11732:SF492', NULL, NULL, NULL, NULL, 'D-XYLOSE REDUCTASE', 250350),
(402710, 'PTHR11732:SF423', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE FAMILY 4 MEMBER C10', 250350),
(402711, 'PTHR11732:SF389', NULL, NULL, NULL, NULL, 'D-XYLOSE REDUCTASES (EUROFUNG)', 250350),
(402712, 'PTHR11732:SF421', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 250350),
(402713, 'PTHR11732:SF388', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE 2, PUTATIVE, EXPRESSED-RELATED', 250350),
(402714, 'PTHR11732:SF420', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 250350),
(402715, 'PTHR11732:SF265', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 250350),
(402716, 'PTHR11732:SF386', NULL, NULL, NULL, NULL, 'OS01G0847700 PROTEIN', 250350),
(402717, 'PTHR11732:SF385', NULL, NULL, NULL, NULL, 'ALDO/KETO REDUCTASE FAMILY-RELATED', 250350),
(402718, 'PTHR11732:SF383', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE FAMILY 1 MEMBER C15', 250350),
(402719, 'PTHR11732:SF438', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 250350),
(402720, 'PTHR11732:SF437', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 250350),
(402721, 'PTHR11732:SF435', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE FAMILY 4 MEMBER C11', 250350),
(402722, 'PTHR11732:SF434', NULL, NULL, NULL, NULL, 'ALDO/KETO REDUCTASE FAMILY OXIDOREDUCTASE', 250350),
(402723, 'PTHR11732:SF433', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE FAMILY 1, MEMBER C19', 250350),
(402724, 'PTHR11732:SF278', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE FAMILY 1 MEMBER B10', 250350),
(402725, 'PTHR11732:SF431', NULL, NULL, NULL, NULL, 'ALDO/KETO REDUCTASE FAMILY OXIDOREDUCTASE', 250350),
(402726, 'PTHR11732:SF398', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE FAMILY 1, MEMBER B1 (ALDOSE REDUCTASE), TANDEM DUPLICATE 1', 250350),
(402727, 'PTHR11732:SF430', NULL, NULL, NULL, NULL, 'ALDO/KETO REDUCTASE FAMILY OXIDOREDUCTASE', 250350),
(402728, 'PTHR11732:SF153', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE FAMILY 1 MEMBER C1-RELATED', 250350),
(402729, 'PTHR11732', NULL, NULL, NULL, NULL, 'ALDO/KETO REDUCTASE', 250350);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(402730, 'PTHR11732:SF391', NULL, NULL, NULL, NULL, '1,5-ANHYDRO-D-FRUCTOSE REDUCTASE', 250350),
(402731, 'PTHR11732:SF209', NULL, NULL, NULL, NULL, 'NAD(P)-LINKED OXIDOREDUCTASE SUPERFAMILY PROTEIN', 250350),
(402732, 'PTHR11732:SF449', NULL, NULL, NULL, NULL, 'D-XYLOSE REDUCTASE', 250350),
(402733, 'PTHR11732:SF206', NULL, NULL, NULL, NULL, 'D-XYLOSE REDUCTASE', 250350),
(402734, 'PTHR11732:SF447', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 250350),
(402735, 'PTHR11732:SF205', NULL, NULL, NULL, NULL, '3-ALPHA-HYDROXYSTEROID DEHYDROGENASE TYPE 1', 250350),
(402736, 'PTHR11732:SF445', NULL, NULL, NULL, NULL, 'OS05G0456200 PROTEIN', 250350),
(402737, 'PTHR11732:SF444', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 250350),
(402738, 'PTHR11732:SF442', NULL, NULL, NULL, NULL, 'OS04G0167800 PROTEIN', 250350),
(402739, 'PTHR11732:SF165', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE FAMILY 1 MEMBER C3', 250350),
(402740, 'PTHR11732:SF286', NULL, NULL, NULL, NULL, 'ALDO-KETO REDUCTASE A-RELATED', 250350),
(402741, 'PTHR11732:SF164', NULL, NULL, NULL, NULL, 'NAD(P)-LINKED OXIDOREDUCTASE SUPERFAMILY PROTEIN', 250350),
(402742, 'PTHR46602:SF10', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 250351),
(402743, 'PTHR46602:SF6', NULL, NULL, NULL, NULL, 'XS DOMAIN-CONTAINING PROTEIN-RELATED', 250351),
(402744, 'PTHR46602', NULL, NULL, NULL, NULL, 'PROTEIN SUPPRESSOR OF GENE SILENCING 3', 250351),
(402745, 'PTHR46602:SF11', NULL, NULL, NULL, NULL, 'ZINC FINGER-XS DOMAIN PROTEIN-RELATED', 250351),
(402746, 'PTHR46602:SF9', NULL, NULL, NULL, NULL, '', 250351),
(402747, 'PTHR46602:SF1', NULL, NULL, NULL, NULL, 'PROTEIN SUPPRESSOR OF GENE SILENCING 3', 250351),
(402748, 'PTHR46602:SF3', NULL, NULL, NULL, NULL, 'PROTEIN SUPPRESSOR OF GENE SILENCING 3-LIKE', 250351),
(402749, 'PTHR34427:SF12', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN PROTEIN', 250352),
(402750, 'PTHR34427', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN PROTEIN', 250352),
(402751, 'PTHR34427:SF13', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 250352),
(402752, 'PTHR34427:SF14', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 250352),
(402753, 'PTHR34427:SF15', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 250352),
(402754, 'PTHR34427:SF10', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 250352),
(402755, 'PTHR34427:SF5', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 250352),
(402756, 'PTHR47220', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 25', 250353),
(402757, 'PTHR47220:SF1', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 25', 250353),
(402758, 'PTHR24201:SF7', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 4 INHIBITOR D', 250354),
(402759, 'PTHR24201:SF9', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 4 INHIBITOR C', 250354),
(402760, 'PTHR24201:SF8', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 4 INHIBITOR B', 250354),
(402761, 'PTHR24201:SF11', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR 2A/B (P15, INHIBITS CDK4)', 250354),
(402762, 'PTHR24201:SF2', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 42', 250354),
(402763, 'PTHR24201:SF5', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250354),
(402764, 'PTHR24201:SF4', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR 2A', 250354),
(402765, 'PTHR24201:SF10', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250354),
(402766, 'PTHR24201:SF0', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 37', 250354),
(402767, 'PTHR24201', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250354),
(402768, 'PTHR33674:SF10', NULL, NULL, NULL, NULL, '', 250355),
(402769, 'PTHR33674:SF8', NULL, NULL, NULL, NULL, 'PEPTIDE METHIONINE SULFOXIDE REDUCTASE MRSB-RELATED', 250355),
(402770, 'PTHR33674:SF9', NULL, NULL, NULL, NULL, '', 250355),
(402771, 'PTHR33674:SF7', NULL, NULL, NULL, NULL, '', 250355),
(402772, 'PTHR33674:SF4', NULL, NULL, NULL, NULL, '', 250355);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(402773, 'PTHR33674:SF12', NULL, NULL, NULL, NULL, 'OS01G0833400 PROTEIN', 250355),
(402774, 'PTHR33674:SF5', NULL, NULL, NULL, NULL, 'METHIONINE-S-OXIDE REDUCTASE', 250355),
(402775, 'PTHR33674:SF2', NULL, NULL, NULL, NULL, 'OS05G0126800 PROTEIN', 250355),
(402776, 'PTHR33674:SF3', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 12', 250355),
(402777, 'PTHR33674', NULL, NULL, NULL, NULL, 'METHIONINE-S-OXIDE REDUCTASE', 250355),
(402778, 'PTHR12997:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG05397', 250356),
(402779, 'PTHR12997', NULL, NULL, NULL, NULL, 'TYPE I INOSITOL-1,4,5-TRISPHOSPHATE 5-PHOSPHATASE', 250356),
(402780, 'PTHR12997:SF9', NULL, NULL, NULL, NULL, 'INOSITOL-POLYPHOSPHATE 5-PHOSPHATASE', 250356),
(402781, 'PTHR12997:SF10', NULL, NULL, NULL, NULL, 'INOSITOL-POLYPHOSPHATE 5-PHOSPHATASE', 250356),
(402782, 'PTHR12997:SF2', NULL, NULL, NULL, NULL, 'INOSITOL POLYPHOSPHATE-5-PHOSPHATASE A', 250356),
(402783, 'PTHR11024:SF18', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 250357),
(402784, 'PTHR11024:SF5', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN SEC13, PUTATIVE-RELATED', 250357),
(402785, 'PTHR11024:SF2', NULL, NULL, NULL, NULL, 'PROTEIN SEC13 HOMOLOG', 250357),
(402786, 'PTHR11024:SF20', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC13 HOMOLOG B', 250357),
(402787, 'PTHR11024:SF3', NULL, NULL, NULL, NULL, 'NUCLEOPORIN SEH1', 250357),
(402788, 'PTHR11024', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN SEC13 / SEH1 FAMILY MEMBER', 250357),
(402789, 'PTHR11024:SF12', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC13 HOMOLOG A', 250357),
(402790, 'PTHR11024:SF13', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 250357),
(402791, 'PTHR11024:SF9', NULL, NULL, NULL, NULL, 'OS03G0831800 PROTEIN', 250357),
(402792, 'PTHR11024:SF15', NULL, NULL, NULL, NULL, 'SEC13-LIKE PROTEIN-RELATED', 250357),
(402793, 'PTHR45331:SF1', NULL, NULL, NULL, NULL, 'ALDEHYDE OXIDOREDUCTASE IRON-SULFUR-BINDING SUBUNIT PAOA', 250358),
(402794, 'PTHR45331', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE, IRON-SULPHUR BINDING SUBUNIT-RELATED-RELATED', 250358),
(402795, 'PTHR45331:SF2', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE WITH IRON-SULFUR SUBUNIT', 250358),
(402796, 'PTHR19277:SF160', NULL, NULL, NULL, NULL, '', 250359),
(402797, 'PTHR19277:SF1', NULL, NULL, NULL, NULL, 'NEURONAL PENTRAXIN-2', 250359),
(402798, 'PTHR19277:SF3', NULL, NULL, NULL, NULL, 'SI:DKEY-14O18.2', 250359),
(402799, 'PTHR19277:SF24', NULL, NULL, NULL, NULL, 'NEURONAL PENTRAXIN-1', 250359),
(402800, 'PTHR19277:SF122', NULL, NULL, NULL, NULL, 'PENTRAXIN-4', 250359),
(402801, 'PTHR19277:SF94', NULL, NULL, NULL, NULL, 'NEURONAL PENTRAXIN RECEPTOR', 250359),
(402802, 'PTHR19277:SF125', NULL, NULL, NULL, NULL, 'B6', 250359),
(402803, 'PTHR19277', NULL, NULL, NULL, NULL, 'PENTRAXIN', 250359),
(402804, 'PTHR19277:SF159', NULL, NULL, NULL, NULL, '', 250359),
(402805, 'PTHR36441:SF1', NULL, NULL, NULL, NULL, 'HYPOTHETICAL CYTOSOLIC PROTEIN', 250360),
(402806, 'PTHR36441', NULL, NULL, NULL, NULL, 'HYPOTHETICAL CYTOSOLIC PROTEIN', 250360),
(402807, 'PTHR12341:SF71', NULL, NULL, NULL, NULL, '', 250361),
(402808, 'PTHR12341:SF72', NULL, NULL, NULL, NULL, '5''-3'' EXORIBONUCLEASE', 250361),
(402809, 'PTHR12341:SF70', NULL, NULL, NULL, NULL, 'XRN_N DOMAIN-CONTAINING PROTEIN', 250361),
(402810, 'PTHR12341:SF69', NULL, NULL, NULL, NULL, '5''-3'' EXORIBONUCLEASE', 250361),
(402811, 'PTHR12341:SF33', NULL, NULL, NULL, NULL, 'XRN_N DOMAIN-CONTAINING PROTEIN', 250361),
(402812, 'PTHR12341:SF56', NULL, NULL, NULL, NULL, '5''-3'' EXORIBONUCLEASE', 250361),
(402813, 'PTHR12341:SF53', NULL, NULL, NULL, NULL, '5''-3'' EXORIBONUCLEASE', 250361),
(402814, 'PTHR12341:SF64', NULL, NULL, NULL, NULL, '5''-3'' EXORIBONUCLEASE 2', 250361),
(402815, 'PTHR12341:SF54', NULL, NULL, NULL, NULL, '5''-3'' EXORIBONUCLEASE', 250361),
(402816, 'PTHR12341:SF62', NULL, NULL, NULL, NULL, '5''-3'' EXORIBONUCLEASE 3-LIKE ISOFORM X1', 250361),
(402817, 'PTHR12341:SF73', NULL, NULL, NULL, NULL, 'XRN_N DOMAIN-CONTAINING PROTEIN', 250361);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(402818, 'PTHR12341:SF41', NULL, NULL, NULL, NULL, '5''-3'' EXORIBONUCLEASE 2', 250361),
(402819, 'PTHR12341:SF74', NULL, NULL, NULL, NULL, '5''-3'' EXORIBONUCLEASE 4', 250361),
(402820, 'PTHR12341:SF39', NULL, NULL, NULL, NULL, '5''-3'' EXORIBONUCLEASE', 250361),
(402821, 'PTHR12341:SF29', NULL, NULL, NULL, NULL, 'EXONUCLEASE XRNC, PUTATIVE-RELATED', 250361),
(402822, 'PTHR12341:SF7', NULL, NULL, NULL, NULL, '5''-3'' EXORIBONUCLEASE 1', 250361),
(402823, 'PTHR12341', NULL, NULL, NULL, NULL, '5''->3'' EXORIBONUCLEASE', 250361),
(402824, 'PTHR37713', NULL, NULL, NULL, NULL, 'OS05G0176600 PROTEIN', 250362),
(402825, 'PTHR37713:SF1', NULL, NULL, NULL, NULL, 'OS05G0176600 PROTEIN', 250362),
(402826, 'PTHR10827:SF90', NULL, NULL, NULL, NULL, 'PROTEIN CBG07008', 250363),
(402827, 'PTHR10827:SF91', NULL, NULL, NULL, NULL, 'RETICULOCALBIN 3, EF-HAND CALCIUM-BINDING DOMAIN', 250363),
(402828, 'PTHR10827:SF92', NULL, NULL, NULL, NULL, 'PROTEIN CBG04435', 250363),
(402829, 'PTHR10827:SF93', NULL, NULL, NULL, NULL, 'GH15296P', 250363),
(402830, 'PTHR10827:SF76', NULL, NULL, NULL, NULL, 'CALUMENIN', 250363),
(402831, 'PTHR10827:SF87', NULL, NULL, NULL, NULL, 'CALUMENIN-B', 250363),
(402832, 'PTHR10827:SF88', NULL, NULL, NULL, NULL, 'CALUMENIN', 250363),
(402833, 'PTHR10827:SF77', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF HAND FAMILY PROTEIN', 250363),
(402834, 'PTHR10827:SF45', NULL, NULL, NULL, NULL, 'CALEXCITIN-2', 250363),
(402835, 'PTHR10827:SF89', NULL, NULL, NULL, NULL, 'ION BINDING PROTEIN, PUTATIVE-RELATED', 250363),
(402836, 'PTHR10827:SF78', NULL, NULL, NULL, NULL, 'RETICULOCALBIN-2', 250363),
(402837, 'PTHR10827:SF94', NULL, NULL, NULL, NULL, 'PROTEIN CBG18984', 250363),
(402838, 'PTHR10827', NULL, NULL, NULL, NULL, 'RETICULOCALBIN', 250363),
(402839, 'PTHR10827:SF84', NULL, NULL, NULL, NULL, 'EF HAND PROTEIN', 250363),
(402840, 'PTHR10827:SF51', NULL, NULL, NULL, NULL, '45 KDA CALCIUM-BINDING PROTEIN', 250363),
(402841, 'PTHR10827:SF95', NULL, NULL, NULL, NULL, 'LD34388P', 250363),
(402842, 'PTHR10827:SF85', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN', 250363),
(402843, 'PTHR10827:SF52', NULL, NULL, NULL, NULL, 'IP16409P', 250363),
(402844, 'PTHR10827:SF96', NULL, NULL, NULL, NULL, '', 250363),
(402845, 'PTHR10827:SF75', NULL, NULL, NULL, NULL, '', 250363),
(402846, 'PTHR10827:SF86', NULL, NULL, NULL, NULL, '', 250363),
(402847, 'PTHR10827:SF53', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF HAND FAMILY PROTEIN', 250363),
(402848, 'PTHR10827:SF47', NULL, NULL, NULL, NULL, 'RETICULOCALBIN-3', 250363),
(402849, 'PTHR10827:SF17', NULL, NULL, NULL, NULL, 'RETICULOCALBIN-1', 250363),
(402850, 'PTHR28388:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 237', 250364),
(402851, 'PTHR28388', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 237', 250364),
(402852, 'PTHR16515:SF2', NULL, NULL, NULL, NULL, 'PR DOMAIN ZINC FINGER PROTEIN 4', 250365),
(402853, 'PTHR16515:SF26', NULL, NULL, NULL, NULL, 'PR DOMAIN ZINC FINGER PROTEIN 1', 250365),
(402854, 'PTHR16515:SF37', NULL, NULL, NULL, NULL, 'PR DOMAIN ZINC FINGER PROTEIN 2', 250365),
(402855, 'PTHR16515:SF48', NULL, NULL, NULL, NULL, 'PR DOMAIN-CONTAINING PROTEIN 11', 250365),
(402856, 'PTHR16515:SF47', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 833-RELATED', 250365),
(402857, 'PTHR16515:SF46', NULL, NULL, NULL, NULL, 'FINGER PROTEIN, PUTATIVE-RELATED', 250365),
(402858, 'PTHR16515:SF35', NULL, NULL, NULL, NULL, 'FEZ FAMILY ZINC FINGER PROTEIN 2', 250365),
(402859, 'PTHR16515:SF34', NULL, NULL, NULL, NULL, 'PR DOMAIN ZINC FINGER PROTEIN 15', 250365),
(402860, 'PTHR16515:SF45', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE PRDM9', 250365),
(402861, 'PTHR16515:SF23', NULL, NULL, NULL, NULL, '', 250365),
(402862, 'PTHR16515:SF19', NULL, NULL, NULL, NULL, 'PR DOMAIN ZINC FINGER PROTEIN 14', 250365),
(402863, 'PTHR16515:SF18', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 711-RELATED', 250365),
(402864, 'PTHR16515', NULL, NULL, NULL, NULL, 'PR DOMAIN ZINC FINGER PROTEIN', 250365),
(402865, 'PTHR16515:SF22', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE PRDM6-RELATED', 250365);
INSERT INTO "PUBLIC"."MODEL" VALUES
(402866, 'PTHR16515:SF21', NULL, NULL, NULL, NULL, 'PR DOMAIN ZINC FINGER PROTEIN 13', 250365),
(402867, 'PTHR16515:SF32', NULL, NULL, NULL, NULL, 'PR DOMAIN ZINC FINGER PROTEIN 5', 250365),
(402868, 'PTHR16515:SF10', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE PRDM9', 250365),
(402869, 'PTHR16515:SF20', NULL, NULL, NULL, NULL, 'PR DOMAIN ZINC FINGER PROTEIN 12', 250365),
(402870, 'PTHR16515:SF30', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 408', 250365),
(402871, 'PTHR21676', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 250366),
(402872, 'PTHR21676:SF1', NULL, NULL, NULL, NULL, 'PROTEIN STUM HOMOLOG', 250366),
(402873, 'PTHR21676:SF6', NULL, NULL, NULL, NULL, 'PROTEIN STUM', 250366),
(402874, 'PTHR31264:SF7', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', 250367),
(402875, 'PTHR31264:SF3', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 250367),
(402876, 'PTHR31264:SF19', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 250367),
(402877, 'PTHR31264:SF29', NULL, NULL, NULL, NULL, 'OS07G0554500 PROTEIN', 250367),
(402878, 'PTHR31264:SF17', NULL, NULL, NULL, NULL, 'OS04G0258900 PROTEIN', 250367),
(402879, 'PTHR31264:SF28', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 250367),
(402880, 'PTHR31264:SF16', NULL, NULL, NULL, NULL, '', 250367),
(402881, 'PTHR31264:SF15', NULL, NULL, NULL, NULL, '', 250367),
(402882, 'PTHR31264:SF23', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 250367),
(402883, 'PTHR31264:SF22', NULL, NULL, NULL, NULL, 'OS07G0555100 PROTEIN', 250367),
(402884, 'PTHR31264:SF11', NULL, NULL, NULL, NULL, '', 250367),
(402885, 'PTHR31264:SF9', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 250367),
(402886, 'PTHR31264:SF32', NULL, NULL, NULL, NULL, '', 250367),
(402887, 'PTHR31264:SF21', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 250367),
(402888, 'PTHR31264:SF10', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 250367),
(402889, 'PTHR31264:SF31', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 250367),
(402890, 'PTHR31264:SF30', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 250367),
(402891, 'PTHR31264', NULL, NULL, NULL, NULL, 'OS07G0554500 PROTEIN-RELATED', 250367),
(402892, 'PTHR37230', NULL, NULL, NULL, NULL, 'OS06G0731300 PROTEIN', 250368),
(402893, 'PTHR37230:SF1', NULL, NULL, NULL, NULL, 'OS06G0731300 PROTEIN', 250368),
(402894, 'PTHR11525:SF19', NULL, NULL, NULL, NULL, 'FARNESYL PYROPHOSPHATE SYNTHASE 1-LIKE', 250369),
(402895, 'PTHR11525:SF18', NULL, NULL, NULL, NULL, 'DIMETHYLALLYLTRANSFERASE', 250369),
(402896, 'PTHR11525:SF16', NULL, NULL, NULL, NULL, 'BNAA06G35250D PROTEIN', 250369),
(402897, 'PTHR11525:SF1', NULL, NULL, NULL, NULL, 'FARNESYL DIPHOSPHATE SYNTHASE DDB_G0268742-RELATED', 250369),
(402898, 'PTHR11525', NULL, NULL, NULL, NULL, 'FARNESYL-PYROPHOSPHATE SYNTHETASE', 250369),
(402899, 'PTHR11525:SF0', NULL, NULL, NULL, NULL, 'FARNESYL PYROPHOSPHATE SYNTHASE', 250369),
(402900, 'PTHR11525:SF11', NULL, NULL, NULL, NULL, 'FARNESYL PYROPHOSPHATE SYNTHASE', 250369),
(402901, 'PTHR11525:SF3', NULL, NULL, NULL, NULL, 'OS01G0695300 PROTEIN', 250369),
(402902, 'PTHR11525:SF15', NULL, NULL, NULL, NULL, 'FARNESYL PYROPHOSPHATE SYNTHASE 3', 250369),
(402903, 'PTHR11525:SF14', NULL, NULL, NULL, NULL, 'OS04G0657100 PROTEIN', 250369),
(402904, 'PTHR11525:SF13', NULL, NULL, NULL, NULL, 'FARNESYL PYROPHOSPHATE SYNTHASE 2-LIKE ISOFORM X1', 250369),
(402905, 'PTHR11525:SF12', NULL, NULL, NULL, NULL, 'FARNESYL PYROPHOSPHATE SYNTHASE 1-LIKE', 250369),
(402906, 'PTHR47510:SF5', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 250370),
(402907, 'PTHR47510', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 250370),
(402908, 'PTHR47510:SF4', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 250370),
(402909, 'PTHR47510:SF3', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE', 250370),
(402910, 'PTHR47510:SF8', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 250370);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(402911, 'PTHR47510:SF7', NULL, NULL, NULL, NULL, '', 250370),
(402912, 'PTHR47510:SF6', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 250370),
(402913, 'PTHR28018:SF7', NULL, NULL, NULL, NULL, 'HYPOXIA-RESPONSIVE FAMILY PROTEIN-RELATED', 250371),
(402914, 'PTHR28018:SF9', NULL, NULL, NULL, NULL, 'HIG1 DOMAIN-CONTAINING PROTEIN', 250371),
(402915, 'PTHR28018:SF3', NULL, NULL, NULL, NULL, 'RESPIRATORY SUPERCOMPLEX FACTOR 2, MITOCHONDRIAL', 250371),
(402916, 'PTHR28018:SF2', NULL, NULL, NULL, NULL, 'F18C1.18 PROTEIN-RELATED', 250371),
(402917, 'PTHR28018:SF5', NULL, NULL, NULL, NULL, 'OS02G0592400 PROTEIN', 250371),
(402918, 'PTHR28018', NULL, NULL, NULL, NULL, 'RESPIRATORY SUPERCOMPLEX FACTOR 2, MITOCHONDRIAL', 250371),
(402919, 'PTHR34127:SF1', NULL, NULL, NULL, NULL, 'OS04G0405600 PROTEIN', 250372),
(402920, 'PTHR34127:SF3', NULL, NULL, NULL, NULL, 'INITIATION FACTOR 4F SUBUNIT (DUF1350)', 250372),
(402921, 'PTHR34127', NULL, NULL, NULL, NULL, 'OS04G0405600 PROTEIN', 250372),
(402922, 'PTHR39344', NULL, NULL, NULL, NULL, 'UPF0182 PROTEIN SLL1060', 250373),
(402923, 'PTHR39344:SF1', NULL, NULL, NULL, NULL, 'UPF0182 PROTEIN SLL1060', 250373),
(402924, 'PTHR17571:SF34', NULL, NULL, NULL, NULL, 'ACROSOMAL PROTEIN SP-10', 250374),
(402925, 'PTHR17571', NULL, NULL, NULL, NULL, 'URINARY PROTEIN  RUP /ACROSOMAL PROTEIN SP-10', 250374),
(402926, 'PTHR31443:SF0', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 263', 250375),
(402927, 'PTHR31443:SF1', NULL, NULL, NULL, NULL, 'ZGC:101566', 250375),
(402928, 'PTHR31443:SF2', NULL, NULL, NULL, NULL, 'ZGC:153675', 250375),
(402929, 'PTHR31443:SF3', NULL, NULL, NULL, NULL, '', 250375),
(402930, 'PTHR31443', NULL, NULL, NULL, NULL, '', 250375),
(402931, 'PTHR37610:SF78', NULL, NULL, NULL, NULL, 'RETROTRAN_GAG_3 DOMAIN-CONTAINING PROTEIN', 250376),
(402932, 'PTHR37610:SF55', NULL, NULL, NULL, NULL, 'RETROTRAN_GAG_3 DOMAIN-CONTAINING PROTEIN', 250376),
(402933, 'PTHR37610:SF77', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 250376),
(402934, 'PTHR37610:SF75', NULL, NULL, NULL, NULL, 'RETROTRAN_GAG_3 DOMAIN-CONTAINING PROTEIN', 250376),
(402935, 'PTHR37610:SF38', NULL, NULL, NULL, NULL, 'RETROTRAN_GAG_3 DOMAIN-CONTAINING PROTEIN', 250376),
(402936, 'PTHR37610:SF58', NULL, NULL, NULL, NULL, '', 250376),
(402937, 'PTHR37610:SF79', NULL, NULL, NULL, NULL, 'COPIA-LIKE POLYPROTEIN/RETROTRANSPOSON', 250376),
(402938, 'PTHR37610:SF92', NULL, NULL, NULL, NULL, '', 250376),
(402939, 'PTHR37610:SF91', NULL, NULL, NULL, NULL, '', 250376),
(402940, 'PTHR37610:SF90', NULL, NULL, NULL, NULL, 'GAG-POLYPEPTIDE OF LTR COPIA-TYPE-RELATED', 250376),
(402941, 'PTHR37610:SF74', NULL, NULL, NULL, NULL, 'RETROTRAN_GAG_3 DOMAIN-CONTAINING PROTEIN', 250376),
(402942, 'PTHR37610:SF93', NULL, NULL, NULL, NULL, 'RETROTRAN_GAG_3 DOMAIN-CONTAINING PROTEIN', 250376),
(402943, 'PTHR37610:SF89', NULL, NULL, NULL, NULL, 'RETROTRAN_GAG_3 DOMAIN-CONTAINING PROTEIN', 250376),
(402944, 'PTHR37610:SF45', NULL, NULL, NULL, NULL, '', 250376),
(402945, 'PTHR37610:SF88', NULL, NULL, NULL, NULL, '', 250376),
(402946, 'PTHR37610:SF87', NULL, NULL, NULL, NULL, 'RETROTRAN_GAG_3 DOMAIN-CONTAINING PROTEIN', 250376),
(402947, 'PTHR37610:SF86', NULL, NULL, NULL, NULL, 'RETROTRAN_GAG_3 DOMAIN-CONTAINING PROTEIN', 250376),
(402948, 'PTHR37610:SF47', NULL, NULL, NULL, NULL, 'OS01G0909600 PROTEIN', 250376),
(402949, 'PTHR37610:SF81', NULL, NULL, NULL, NULL, 'RETROTRAN_GAG_3 DOMAIN-CONTAINING PROTEIN', 250376),
(402950, 'PTHR37610:SF80', NULL, NULL, NULL, NULL, '', 250376),
(402951, 'PTHR37610:SF6', NULL, NULL, NULL, NULL, 'RETROTRAN_GAG_3 DOMAIN-CONTAINING PROTEIN', 250376),
(402952, 'PTHR37610:SF85', NULL, NULL, NULL, NULL, '', 250376),
(402953, 'PTHR37610:SF40', NULL, NULL, NULL, NULL, 'RETROTRAN_GAG_3 DOMAIN-CONTAINING PROTEIN', 250376),
(402954, 'PTHR37610:SF84', NULL, NULL, NULL, NULL, 'DUF4219 DOMAIN-CONTAINING PROTEIN', 250376),
(402955, 'PTHR37610:SF83', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 6 REGULATORY ANKYRIN REPEAT SUBUNIT C-LIKE ISOFORM X1', 250376);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(402956, 'PTHR37610:SF82', NULL, NULL, NULL, NULL, 'FBD PROTEIN', 250376),
(402957, 'PTHR37610:SF60', NULL, NULL, NULL, NULL, 'RETROTRAN_GAG_3 DOMAIN-CONTAINING PROTEIN', 250376),
(402958, 'PTHR37610', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 250376),
(402959, 'PTHR22847:SF684', NULL, NULL, NULL, NULL, 'COMPASS-LIKE H3K4 HISTONE METHYLASE COMPONENT WDR5B', 250377),
(402960, 'PTHR22847:SF740', NULL, NULL, NULL, NULL, '', 250377),
(402961, 'PTHR22847:SF666', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 250377),
(402962, 'PTHR22847:SF722', NULL, NULL, NULL, NULL, 'SI:CH211-154O6.3', 250377),
(402963, 'PTHR22847:SF741', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE COMPLEX SCF SUBUNIT SCONB-RELATED', 250377),
(402964, 'PTHR22847:SF626', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 38', 250377),
(402965, 'PTHR22847:SF723', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE COMPLEX SCF SUBUNIT SCONB-RELATED', 250377),
(402966, 'PTHR22847:SF625', NULL, NULL, NULL, NULL, '', 250377),
(402967, 'PTHR22847:SF729', NULL, NULL, NULL, NULL, 'PREPROTEIN TRANSLOCASE SECA-LIKE PROTEIN', 250377),
(402968, 'PTHR22847:SF727', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', 250377),
(402969, 'PTHR22847:SF728', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR TUP11-RELATED', 250377),
(402970, 'PTHR22847:SF681', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN MET30', 250377),
(402971, 'PTHR22847:SF560', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 5', 250377),
(402972, 'PTHR22847:SF671', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 250377),
(402973, 'PTHR22847:SF650', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 250377),
(402974, 'PTHR22847:SF672', NULL, NULL, NULL, NULL, 'OS08G0531200 PROTEIN', 250377),
(402975, 'PTHR22847:SF677', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 250377),
(402976, 'PTHR22847:SF732', NULL, NULL, NULL, NULL, 'CHROMOSOME 19, WHOLE GENOME SHOTGUN SEQUENCE', 250377),
(402977, 'PTHR22847:SF733', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT BETA-LIKE PROTEIN', 250377),
(402978, 'PTHR22847:SF697', NULL, NULL, NULL, NULL, '', 250377),
(402979, 'PTHR22847:SF653', NULL, NULL, NULL, NULL, 'PROTEASOMAL ATPASE-ASSOCIATED FACTOR 1', 250377),
(402980, 'PTHR22847', NULL, NULL, NULL, NULL, 'WD40 REPEAT PROTEIN', 250377),
(402981, 'PTHR22847:SF730', NULL, NULL, NULL, NULL, 'FUNGAL PROTEIN', 250377),
(402982, 'PTHR22847:SF731', NULL, NULL, NULL, NULL, 'TNF RECEPTOR ASSOCIATED FACTOR 7', 250377),
(402983, 'PTHR22847:SF516', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 5B', 250377),
(402984, 'PTHR22847:SF637', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 250377),
(402985, 'PTHR22847:SF736', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 250377),
(402986, 'PTHR22847:SF737', NULL, NULL, NULL, NULL, 'LISSENCEPHALY-1 HOMOLOG', 250377),
(402987, 'PTHR22847:SF734', NULL, NULL, NULL, NULL, 'FACTOR (SPT8), PUTATIVE (AFU_ORTHOLOGUE AFUA_5G09080)-RELATED', 250377),
(402988, 'PTHR22847:SF713', NULL, NULL, NULL, NULL, '', 250377),
(402989, 'PTHR22847:SF735', NULL, NULL, NULL, NULL, 'SAGA COMPLEX SUBUNIT SPT8', 250377),
(402990, 'PTHR22847:SF738', NULL, NULL, NULL, NULL, '', 250377),
(402991, 'PTHR22847:SF739', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 250377),
(402992, 'PTHR39648', NULL, NULL, NULL, NULL, '6-HYDROXYMETHYL-7,8-DIHYDROPTERIN PYROPHOSPHOKINASE', 250378),
(402993, 'PTHR39648:SF1', NULL, NULL, NULL, NULL, '6-HYDROXYMETHYL-7,8-DIHYDROPTERIN PYROPHOSPHOKINASE', 250378),
(402994, 'PTHR43486:SF1', NULL, NULL, NULL, NULL, 'LIPID II FLIPPASE MURJ-RELATED', 250379),
(402995, 'PTHR43486', NULL, NULL, NULL, NULL, 'LIPID II FLIPPASE MURJ-RELATED', 250379),
(402996, 'PTHR12864:SF70', NULL, NULL, NULL, NULL, 'CONCANAVALIN A-LIKE LECTIN/GLUCANASE DOMAIN-CONTAINING PROTEIN-RELATED', 250380),
(402997, 'PTHR12864:SF3', NULL, NULL, NULL, NULL, 'GLUCOSE-INDUCED DEGRADATION PROTEIN 8 HOMOLOG', 250380);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(402998, 'PTHR12864:SF56', NULL, NULL, NULL, NULL, 'RAN-BINDING PROTEIN 9', 250380),
(402999, 'PTHR12864:SF67', NULL, NULL, NULL, NULL, 'PG4, EXPRESSED', 250380),
(403000, 'PTHR12864:SF55', NULL, NULL, NULL, NULL, 'SPLA/RYANODINE RECEPTOR (SPRY) DOMAIN-CONTAINING PROTEIN', 250380),
(403001, 'PTHR12864:SF77', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 250380),
(403002, 'PTHR12864:SF76', NULL, NULL, NULL, NULL, 'PROTEIN SSH4', 250380),
(403003, 'PTHR12864:SF21', NULL, NULL, NULL, NULL, 'OS01G0775600 PROTEIN', 250380),
(403004, 'PTHR12864:SF54', NULL, NULL, NULL, NULL, 'SPRY DOMAIN-CONTAINING PROTEIN 3', 250380),
(403005, 'PTHR12864:SF75', NULL, NULL, NULL, NULL, 'GLUCOSE-INDUCED DEGRADATION PROTEIN 8 HOMOLOG', 250380),
(403006, 'PTHR12864:SF64', NULL, NULL, NULL, NULL, 'SPRY DOMAIN-CONTAINING PROTEIN', 250380),
(403007, 'PTHR12864:SF74', NULL, NULL, NULL, NULL, 'BNAA01G35990D PROTEIN', 250380),
(403008, 'PTHR12864:SF73', NULL, NULL, NULL, NULL, 'RAN BINDING PROTEIN', 250380),
(403009, 'PTHR12864:SF72', NULL, NULL, NULL, NULL, 'BNAANNG02010D PROTEIN', 250380),
(403010, 'PTHR12864:SF71', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 250380),
(403011, 'PTHR12864:SF19', NULL, NULL, NULL, NULL, 'RAN-BINDING PROTEIN 10', 250380),
(403012, 'PTHR12864', NULL, NULL, NULL, NULL, 'RAN BINDING PROTEIN 9-RELATED', 250380),
(403013, 'PTHR12864:SF49', NULL, NULL, NULL, NULL, 'RAN-BINDING PROTEINS 9/10 HOMOLOG', 250380),
(403014, 'PTHR12864:SF13', NULL, NULL, NULL, NULL, 'RAN-BINDING PROTEIN IN THE MICROTUBULE-ORGANISING CENTRE PROTEIN', 250380),
(403015, 'PTHR20917:SF0', NULL, NULL, NULL, NULL, 'CALCIUM LOAD-ACTIVATED CALCIUM CHANNEL', 250381),
(403016, 'PTHR20917', NULL, NULL, NULL, NULL, 'PNAS-RELATED', 250381),
(403017, 'PTHR12560:SF62', NULL, NULL, NULL, NULL, 'CERAMIDE SYNTHASE 3A-RELATED', 250382),
(403018, 'PTHR12560:SF63', NULL, NULL, NULL, NULL, 'LAG1-LIKE LONGEVITY ASSURANCE PROTEIN-RELATED', 250382),
(403019, 'PTHR12560:SF64', NULL, NULL, NULL, NULL, 'ASC1-LIKE PROTEIN 2', 250382),
(403020, 'PTHR12560:SF21', NULL, NULL, NULL, NULL, 'CERAMIDE SYNTHASE HYL-2', 250382),
(403021, 'PTHR12560:SF65', NULL, NULL, NULL, NULL, 'LAG1 LONGEVITY ASSURANCE-LIKE PROTEIN', 250382),
(403022, 'PTHR12560:SF43', NULL, NULL, NULL, NULL, 'CERAMIDE SYNTHASE 6', 250382),
(403023, 'PTHR12560:SF66', NULL, NULL, NULL, NULL, 'TLC DOMAIN-CONTAINING PROTEIN', 250382),
(403024, 'PTHR12560:SF44', NULL, NULL, NULL, NULL, 'ASC1-LIKE PROTEIN 1', 250382),
(403025, 'PTHR12560:SF45', NULL, NULL, NULL, NULL, 'CERAMIDE SYNTHASE LOH1', 250382),
(403026, 'PTHR12560:SF67', NULL, NULL, NULL, NULL, 'TLC DOMAIN-CONTAINING PROTEIN', 250382),
(403027, 'PTHR12560:SF46', NULL, NULL, NULL, NULL, 'TRAM, LAG1 AND CLN8 (TLC) LIPID-SENSING DOMAIN CONTAINING PROTEIN', 250382),
(403028, 'PTHR12560:SF6', NULL, NULL, NULL, NULL, 'CERAMIDE SYNTHASE 4', 250382),
(403029, 'PTHR12560:SF48', NULL, NULL, NULL, NULL, 'TLC DOMAIN-CONTAINING PROTEIN', 250382),
(403030, 'PTHR12560:SF49', NULL, NULL, NULL, NULL, 'CERAMIDE SYNTHASE 1 LOH3', 250382),
(403031, 'PTHR12560:SF7', NULL, NULL, NULL, NULL, 'CERAMIDE SYNTHASE 2', 250382),
(403032, 'PTHR12560:SF8', NULL, NULL, NULL, NULL, 'CERAMIDE SYNTHASE 5', 250382),
(403033, 'PTHR12560:SF0', NULL, NULL, NULL, NULL, 'LD18904P', 250382),
(403034, 'PTHR12560', NULL, NULL, NULL, NULL, 'LONGEVITY ASSURANCE FACTOR 1  LAG1', 250382),
(403035, 'PTHR12560:SF51', NULL, NULL, NULL, NULL, 'ASC1-LIKE PROTEIN ISOFORM X1', 250382),
(403036, 'PTHR12560:SF53', NULL, NULL, NULL, NULL, 'BNAC01G43810D PROTEIN', 250382),
(403037, 'PTHR12560:SF54', NULL, NULL, NULL, NULL, 'TLC DOMAIN-CONTAINING PROTEIN', 250382),
(403038, 'PTHR12560:SF11', NULL, NULL, NULL, NULL, 'CERAMIDE SYNTHASE LAC1-RELATED', 250382),
(403039, 'PTHR12560:SF57', NULL, NULL, NULL, NULL, 'LAG1 LONGEVITY ASSURANCE HOMOLOG 3-LIKE', 250382),
(403040, 'PTHR12560:SF58', NULL, NULL, NULL, NULL, 'CERAMIDE SYNTHASE 1', 250382),
(403041, 'PTHR12560:SF38', NULL, NULL, NULL, NULL, 'ALTERNARIA STEM CANKER RESISTANCE PROTEIN 1', 250382);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(403042, 'PTHR12560:SF18', NULL, NULL, NULL, NULL, 'CERAMIDE SYNTHASE 3', 250382),
(403043, 'PTHR21268:SF2', NULL, NULL, NULL, NULL, 'COMPLEX I-15 KDA', 250383),
(403044, 'PTHR21268', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 250383),
(403045, 'PTHR23103:SF14', NULL, NULL, NULL, NULL, 'AMYLOID-LIKE PROTEIN 2', 250384),
(403046, 'PTHR23103:SF13', NULL, NULL, NULL, NULL, 'AMYLOID-LIKE PROTEIN 1', 250384),
(403047, 'PTHR23103:SF7', NULL, NULL, NULL, NULL, 'AMYLOID-BETA PRECURSOR PROTEIN', 250384),
(403048, 'PTHR23103', NULL, NULL, NULL, NULL, 'ALZHEIMER''S DISEASE BETA-AMYLOID RELATED', 250384),
(403049, 'PTHR23103:SF16', NULL, NULL, NULL, NULL, 'AMYLOID-BETA A4 PROTEIN', 250384),
(403050, 'PTHR23103:SF15', NULL, NULL, NULL, NULL, 'AMYLOID-BETA-LIKE PROTEIN', 250384),
(403051, 'PTHR35997:SF5', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 250385),
(403052, 'PTHR35997:SF13', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250385),
(403053, 'PTHR35997:SF14', NULL, NULL, NULL, NULL, 'OS09G0539700 PROTEIN', 250385),
(403054, 'PTHR35997', NULL, NULL, NULL, NULL, 'COTTON FIBER PROTEIN-RELATED', 250385),
(403055, 'PTHR35997:SF11', NULL, NULL, NULL, NULL, 'COTTON FIBER PROTEIN', 250385),
(403056, 'PTHR35997:SF9', NULL, NULL, NULL, NULL, 'BNAA02G29290D PROTEIN', 250385),
(403057, 'PTHR35997:SF12', NULL, NULL, NULL, NULL, '', 250385),
(403058, 'PTHR35997:SF7', NULL, NULL, NULL, NULL, 'BNAA04G20280D PROTEIN', 250385),
(403059, 'PTHR35997:SF10', NULL, NULL, NULL, NULL, 'BNAA07G07450D PROTEIN', 250385),
(403060, 'PTHR35997:SF6', NULL, NULL, NULL, NULL, 'COTTON FIBER PROTEIN', 250385),
(403061, 'PTHR47092', NULL, NULL, NULL, NULL, 'CAT EYE SYNDROME CRITICAL REGION PROTEIN 2', 250386),
(403062, 'PTHR47092:SF1', NULL, NULL, NULL, NULL, 'CAT EYE SYNDROME CRITICAL REGION PROTEIN 2', 250386),
(403063, 'PTHR10924:SF3', NULL, NULL, NULL, NULL, 'FELINE LEUKEMIA VIRUS SUBGROUP C RECEPTOR-RELATED PROTEIN 2', 250387),
(403064, 'PTHR10924:SF4', NULL, NULL, NULL, NULL, 'GH15861P', 250387),
(403065, 'PTHR10924', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN-RELATED', 250387),
(403066, 'PTHR10924:SF27', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 49 MEMBER 4', 250387),
(403067, 'PTHR10924:SF6', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 49 MEMBER A3', 250387),
(403068, 'PTHR10924:SF2', NULL, NULL, NULL, NULL, 'FELINE LEUKEMIA VIRUS SUBGROUP C RECEPTOR-RELATED PROTEIN 1', 250387),
(403069, 'PTHR10924:SF30', NULL, NULL, NULL, NULL, 'MEMBRANE TRANSPORTER', 250387),
(403070, 'PTHR10924:SF8', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 250387),
(403071, 'PTHR31787:SF4', NULL, NULL, NULL, NULL, 'FRIZZLED/SMOOTHENED-LIKE SANS CRD PROTEIN H', 250388),
(403072, 'PTHR31787:SF15', NULL, NULL, NULL, NULL, 'FRIZZLED AND SMOOTHENED-LIKE PROTEIN P-RELATED', 250388),
(403073, 'PTHR31787:SF14', NULL, NULL, NULL, NULL, 'FRIZZLED AND SMOOTHENED-LIKE PROTEIN N-RELATED', 250388),
(403074, 'PTHR31787:SF3', NULL, NULL, NULL, NULL, 'FRIZZLED AND SMOOTHENED-LIKE PROTEIN H', 250388),
(403075, 'PTHR31787:SF13', NULL, NULL, NULL, NULL, 'FRIZZLED AND SMOOTHENED-LIKE PROTEIN J', 250388),
(403076, 'PTHR31787:SF12', NULL, NULL, NULL, NULL, 'FRIZZLED AND SMOOTHENED-LIKE PROTEIN K', 250388),
(403077, 'PTHR31787:SF5', NULL, NULL, NULL, NULL, 'FRIZZLED/SMOOTHENED-LIKE SANS CRD PROTEIN A', 250388),
(403078, 'PTHR31787:SF11', NULL, NULL, NULL, NULL, 'FRIZZLED/SMOOTHENED-LIKE SANS CRD PROTEIN J', 250388),
(403079, 'PTHR31787:SF8', NULL, NULL, NULL, NULL, 'FRIZZLED/SMOOTHENED-LIKE SANS CRD PROTEIN B-RELATED', 250388),
(403080, 'PTHR31787:SF10', NULL, NULL, NULL, NULL, 'FRIZZLED AND SMOOTHENED-LIKE PROTEIN L-RELATED', 250388),
(403081, 'PTHR31787:SF7', NULL, NULL, NULL, NULL, 'FRIZZLED/SMOOTHENED-LIKE SANS CRD PROTEIN F-RELATED', 250388),
(403082, 'PTHR31787', NULL, NULL, NULL, NULL, 'G-PROTEIN-COUPLED RECEPTOR  GPCR  FAMILY PROTEIN', 250388),
(403083, 'PTHR31787:SF2', NULL, NULL, NULL, NULL, 'FRIZZLED AND SMOOTHENED-LIKE PROTEIN A', 250388),
(403084, 'PTHR31787:SF1', NULL, NULL, NULL, NULL, 'FRIZZLED AND SMOOTHENED-LIKE PROTEIN B-RELATED', 250388);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(403085, 'PTHR15562', NULL, NULL, NULL, NULL, 'TP53-TARGET GENE 5 PROTEIN', 250389),
(403086, 'PTHR15562:SF0', NULL, NULL, NULL, NULL, 'TP53-TARGET GENE 5 PROTEIN', 250389),
(403087, 'PTHR21011:SF1', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S6, MITOCHONDRIAL', 250390),
(403088, 'PTHR21011', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 28S RIBOSOMAL PROTEIN S6', 250390),
(403089, 'PTHR21011:SF14', NULL, NULL, NULL, NULL, 'STRUCTURAL CONSTITUENT OF RIBOSOME', 250390),
(403090, 'PTHR21011:SF16', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S6 ALPHA, CHLOROPLASTIC', 250390),
(403091, 'PTHR21011:SF15', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S6 ALPHA, CHLOROPLASTIC', 250390),
(403092, 'PTHR36462', NULL, NULL, NULL, NULL, 'CHROMOSOME 12 OPEN READING FRAME 71', 250391),
(403093, 'PTHR36462:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 12 OPEN READING FRAME 71', 250391),
(403094, 'PTHR40141', NULL, NULL, NULL, NULL, '3'',5''-CYCLIC-AMP PHOSPHODIESTERASE-RELATED', 250392),
(403095, 'PTHR40141:SF3', NULL, NULL, NULL, NULL, '3'',5''-CYCLIC-AMP PHOSPHODIESTERASE', 250392),
(403096, 'PTHR40141:SF2', NULL, NULL, NULL, NULL, '', 250392),
(403097, 'PTHR40141:SF1', NULL, NULL, NULL, NULL, '', 250392),
(403098, 'PTHR13072:SF0', NULL, NULL, NULL, NULL, 'DYNACTIN SUBUNIT 6', 250393),
(403099, 'PTHR13072', NULL, NULL, NULL, NULL, 'DYNACTIN 6', 250393),
(403100, 'PTHR24126:SF7', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 1', 250394),
(403101, 'PTHR24126', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT, PH AND SEC7 DOMAIN CONTAINING PROTEIN SECG-RELATED', 250394),
(403102, 'PTHR24126:SF3', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 2', 250394),
(403103, 'PTHR24126:SF60', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250394),
(403104, 'PTHR24126:SF61', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250394),
(403105, 'PTHR24126:SF53', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR 2D (P19, INHIBITS CDK4)', 250394),
(403106, 'PTHR24126:SF64', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 250394),
(403107, 'PTHR24126:SF42', NULL, NULL, NULL, NULL, 'PENETRATION AND ARBUSCULE MORPHOGENESIS PROTEIN', 250394),
(403108, 'PTHR24126:SF65', NULL, NULL, NULL, NULL, 'REPEAT PROTEIN, PUTATIVE-RELATED', 250394),
(403109, 'PTHR24126:SF43', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 250394),
(403110, 'PTHR24126:SF40', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 250394),
(403111, 'PTHR24126:SF62', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 10', 250394),
(403112, 'PTHR24126:SF52', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE TNNI3K', 250394),
(403113, 'PTHR24126:SF63', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250394),
(403114, 'PTHR24126:SF41', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN, CHLOROPLASTIC-LIKE', 250394),
(403115, 'PTHR24126:SF24', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 10', 250394),
(403116, 'PTHR24126:SF46', NULL, NULL, NULL, NULL, 'ANKYRIN-3', 250394),
(403117, 'PTHR24126:SF57', NULL, NULL, NULL, NULL, 'PHYTOCHROME-INTERACTING ANKYRIN-REPEAT PROTEIN 1-RELATED', 250394),
(403118, 'PTHR24126:SF14', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN-RELATED', 250394),
(403119, 'PTHR24126:SF66', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250394),
(403120, 'PTHR24126:SF45', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN 23', 250394),
(403121, 'PTHR24126:SF59', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN EMB506, CHLOROPLASTIC', 250394),
(403122, 'PTHR46161', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE KINASE', 250395),
(403123, 'PTHR46161:SF5', NULL, NULL, NULL, NULL, 'NUCLEOSIDE-DIPHOSPHATE KINASE', 250395),
(403124, 'PTHR46161:SF4', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE KINASE', 250395),
(403125, 'PTHR46161:SF3', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE KINASE DDB_G0292928-RELATED', 250395);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(403126, 'PTHR46161:SF1', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE KINASE HOMOLOG 5', 250395),
(403127, 'PTHR24177:SF367', NULL, NULL, NULL, NULL, 'ANKYRIN-REPEAT CONTAINING PROTEIN', 250396),
(403128, 'PTHR24177:SF403', NULL, NULL, NULL, NULL, 'OS11G0434850 PROTEIN', 250396),
(403129, 'PTHR24177:SF402', NULL, NULL, NULL, NULL, 'OS09G0334900 PROTEIN', 250396),
(403130, 'PTHR24177:SF405', NULL, NULL, NULL, NULL, 'OS09G0330700 PROTEIN', 250396),
(403131, 'PTHR24177:SF404', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250396),
(403132, 'PTHR24177:SF406', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250396),
(403133, 'PTHR24177:SF362', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING DOMAIN, PGG DOMAIN PROTEIN-RELATED', 250396),
(403134, 'PTHR24177:SF240', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250396),
(403135, 'PTHR24177:SF365', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN-RELATED', 250396),
(403136, 'PTHR24177:SF244', NULL, NULL, NULL, NULL, 'OS08G0401100 PROTEIN', 250396),
(403137, 'PTHR24177:SF408', NULL, NULL, NULL, NULL, 'REPEAT FAMILY PROTEIN, PUTATIVE-RELATED', 250396),
(403138, 'PTHR24177:SF258', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 250396),
(403139, 'PTHR24177:SF137', NULL, NULL, NULL, NULL, 'OS06G0291800 PROTEIN', 250396),
(403140, 'PTHR24177:SF412', NULL, NULL, NULL, NULL, 'OS06G0285941 PROTEIN', 250396),
(403141, 'PTHR24177:SF257', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250396),
(403142, 'PTHR24177:SF411', NULL, NULL, NULL, NULL, 'OS09G0331600 PROTEIN', 250396),
(403143, 'PTHR24177:SF139', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250396),
(403144, 'PTHR24177:SF413', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN, PUTATIVE-RELATED', 250396),
(403145, 'PTHR24177:SF416', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250396),
(403146, 'PTHR24177:SF415', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250396),
(403147, 'PTHR24177:SF418', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250396),
(403148, 'PTHR24177:SF417', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING DOMAIN, PGG DOMAIN PROTEIN-RELATED', 250396),
(403149, 'PTHR24177:SF252', NULL, NULL, NULL, NULL, 'PROTEIN ACCELERATED CELL DEATH 6-LIKE ISOFORM X1', 250396),
(403150, 'PTHR24177:SF373', NULL, NULL, NULL, NULL, 'PGG DOMAIN-CONTAINING PROTEIN-RELATED', 250396),
(403151, 'PTHR24177:SF375', NULL, NULL, NULL, NULL, '', 250396),
(403152, 'PTHR24177:SF377', NULL, NULL, NULL, NULL, '', 250396),
(403153, 'PTHR24177:SF380', NULL, NULL, NULL, NULL, '', 250396),
(403154, 'PTHR24177:SF419', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 250396),
(403155, 'PTHR24177:SF103', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250396),
(403156, 'PTHR24177:SF466', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250396),
(403157, 'PTHR24177:SF348', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT PROTEIN', 250396),
(403158, 'PTHR24177:SF226', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250396),
(403159, 'PTHR24177:SF105', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250396),
(403160, 'PTHR24177:SF33', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 250396),
(403161, 'PTHR24177:SF461', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250396),
(403162, 'PTHR24177:SF460', NULL, NULL, NULL, NULL, 'ANKYRIN-REPEAT CONTAINING-LIKE PROTEIN', 250396),
(403163, 'PTHR24177:SF463', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250396),
(403164, 'PTHR24177:SF187', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT PROTEIN', 250396),
(403165, 'PTHR24177:SF462', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING DOMAIN, PGG DOMAIN PROTEIN-RELATED', 250396),
(403166, 'PTHR24177:SF344', NULL, NULL, NULL, NULL, '', 250396),
(403167, 'PTHR24177:SF465', NULL, NULL, NULL, NULL, '', 250396),
(403168, 'PTHR24177:SF223', NULL, NULL, NULL, NULL, 'OS06G0293500 PROTEIN', 250396);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(403169, 'PTHR24177:SF343', NULL, NULL, NULL, NULL, 'PROTEIN ACCELERATED CELL DEATH 6-LIKE', 250396),
(403170, 'PTHR24177:SF464', NULL, NULL, NULL, NULL, '', 250396),
(403171, 'PTHR24177:SF356', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT PLANT-LIKE PROTEIN', 250396),
(403172, 'PTHR24177:SF238', NULL, NULL, NULL, NULL, '', 250396),
(403173, 'PTHR24177:SF194', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250396),
(403174, 'PTHR24177:SF45', NULL, NULL, NULL, NULL, 'OS06G0294000 PROTEIN', 250396),
(403175, 'PTHR24177:SF350', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250396),
(403176, 'PTHR24177:SF353', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN-RELATED', 250396),
(403177, 'PTHR24177:SF111', NULL, NULL, NULL, NULL, 'OS12G0283700 PROTEIN', 250396),
(403178, 'PTHR24177:SF43', NULL, NULL, NULL, NULL, 'OS06G0292100 PROTEIN', 250396),
(403179, 'PTHR24177:SF445', NULL, NULL, NULL, NULL, 'OS09G0294901 PROTEIN', 250396),
(403180, 'PTHR24177:SF444', NULL, NULL, NULL, NULL, 'PGG DOMAIN-CONTAINING PROTEIN', 250396),
(403181, 'PTHR24177:SF323', NULL, NULL, NULL, NULL, 'EMBRYOGENESIS TRANSMEMBRANE PROTEIN-LIKE', 250396),
(403182, 'PTHR24177:SF447', NULL, NULL, NULL, NULL, '', 250396),
(403183, 'PTHR24177:SF446', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING PROTEIN NPR4-LIKE', 250396),
(403184, 'PTHR24177:SF449', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 250396),
(403185, 'PTHR24177:SF448', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 250396),
(403186, 'PTHR24177:SF329', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT PROTEIN', 250396),
(403187, 'PTHR24177:SF282', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250396),
(403188, 'PTHR24177:SF441', NULL, NULL, NULL, NULL, 'PGG DOMAIN-CONTAINING PROTEIN', 250396),
(403189, 'PTHR24177:SF166', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250396),
(403190, 'PTHR24177:SF440', NULL, NULL, NULL, NULL, 'OS05G0427600 PROTEIN', 250396),
(403191, 'PTHR24177:SF443', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING DOMAIN, PGG DOMAIN PROTEIN-RELATED', 250396),
(403192, 'PTHR24177:SF288', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250396),
(403193, 'PTHR24177:SF442', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250396),
(403194, 'PTHR24177:SF292', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING PROTEIN ITN1-LIKE', 250396),
(403195, 'PTHR24177:SF456', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 250396),
(403196, 'PTHR24177:SF335', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250396),
(403197, 'PTHR24177:SF455', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING DOMAIN, PGG DOMAIN PROTEIN-RELATED', 250396),
(403198, 'PTHR24177:SF458', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT PLANT-LIKE PROTEIN', 250396),
(403199, 'PTHR24177:SF215', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250396),
(403200, 'PTHR24177:SF457', NULL, NULL, NULL, NULL, '', 250396),
(403201, 'PTHR24177:SF459', NULL, NULL, NULL, NULL, 'PGG DOMAIN-CONTAINING PROTEIN', 250396),
(403202, 'PTHR24177:SF450', NULL, NULL, NULL, NULL, '', 250396),
(403203, 'PTHR24177:SF295', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING DOMAIN, PGG DOMAIN PROTEIN-RELATED', 250396),
(403204, 'PTHR24177:SF331', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250396),
(403205, 'PTHR24177:SF452', NULL, NULL, NULL, NULL, 'OS01G0254400 PROTEIN', 250396),
(403206, 'PTHR24177:SF451', NULL, NULL, NULL, NULL, '', 250396),
(403207, 'PTHR24177:SF297', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 250396),
(403208, 'PTHR24177:SF454', NULL, NULL, NULL, NULL, 'OS07G0481600 PROTEIN', 250396),
(403209, 'PTHR24177:SF453', NULL, NULL, NULL, NULL, '', 250396),
(403210, 'PTHR24177:SF332', NULL, NULL, NULL, NULL, 'REPEAT PROTEIN, PUTATIVE-RELATED', 250396),
(403211, 'PTHR24177:SF423', NULL, NULL, NULL, NULL, 'PGG DOMAIN-CONTAINING PROTEIN-RELATED', 250396),
(403212, 'PTHR24177:SF389', NULL, NULL, NULL, NULL, '', 250396);
INSERT INTO "PUBLIC"."MODEL" VALUES
(403213, 'PTHR24177:SF147', NULL, NULL, NULL, NULL, 'OS07G0492966 PROTEIN', 250396),
(403214, 'PTHR24177:SF301', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING DOMAIN, PGG DOMAIN PROTEIN-RELATED', 250396),
(403215, 'PTHR24177:SF422', NULL, NULL, NULL, NULL, 'OS11G0182900 PROTEIN', 250396),
(403216, 'PTHR24177:SF304', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING DOMAIN, PGG DOMAIN PROTEIN-RELATED', 250396),
(403217, 'PTHR24177:SF425', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250396),
(403218, 'PTHR24177:SF424', NULL, NULL, NULL, NULL, 'PGG DOMAIN-CONTAINING PROTEIN', 250396),
(403219, 'PTHR24177:SF427', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 250396),
(403220, 'PTHR24177:SF426', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 250396),
(403221, 'PTHR24177:SF429', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250396),
(403222, 'PTHR24177:SF428', NULL, NULL, NULL, NULL, 'PGG DOMAIN-CONTAINING PROTEIN', 250396),
(403223, 'PTHR24177:SF262', NULL, NULL, NULL, NULL, 'OS11G0682000 PROTEIN', 250396),
(403224, 'PTHR24177:SF383', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING DOMAIN, PGG DOMAIN PROTEIN-RELATED', 250396),
(403225, 'PTHR24177:SF141', NULL, NULL, NULL, NULL, 'OS06G0294400 PROTEIN', 250396),
(403226, 'PTHR24177:SF386', NULL, NULL, NULL, NULL, 'OS09G0341200 PROTEIN', 250396),
(403227, 'PTHR24177:SF144', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250396),
(403228, 'PTHR24177', NULL, NULL, NULL, NULL, 'CASKIN', 250396),
(403229, 'PTHR24177:SF385', NULL, NULL, NULL, NULL, 'OS09G0329266 PROTEIN', 250396),
(403230, 'PTHR24177:SF421', NULL, NULL, NULL, NULL, 'REPEAT FAMILY PROTEIN, PUTATIVE-RELATED', 250396),
(403231, 'PTHR24177:SF267', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250396),
(403232, 'PTHR24177:SF300', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 250396),
(403233, 'PTHR24177:SF420', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING PROTEIN', 250396),
(403234, 'PTHR24177:SF387', NULL, NULL, NULL, NULL, '', 250396),
(403235, 'PTHR24177:SF434', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT PROTEIN', 250396),
(403236, 'PTHR24177:SF433', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 250396),
(403237, 'PTHR24177:SF315', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING DOMAIN, PGG DOMAIN PROTEIN-RELATED', 250396),
(403238, 'PTHR24177:SF436', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250396),
(403239, 'PTHR24177:SF435', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250396),
(403240, 'PTHR24177:SF314', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250396),
(403241, 'PTHR24177:SF317', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250396),
(403242, 'PTHR24177:SF438', NULL, NULL, NULL, NULL, 'OS07G0193200 PROTEIN', 250396),
(403243, 'PTHR24177:SF437', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT PROTEIN', 250396),
(403244, 'PTHR24177:SF439', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING DOMAIN, PGG DOMAIN PROTEIN-RELATED', 250396),
(403245, 'PTHR24177:SF395', NULL, NULL, NULL, NULL, 'OS06G0294200 PROTEIN', 250396),
(403246, 'PTHR24177:SF394', NULL, NULL, NULL, NULL, 'OS06G0297400 PROTEIN', 250396),
(403247, 'PTHR24177:SF430', NULL, NULL, NULL, NULL, 'OS06G0285900 PROTEIN', 250396),
(403248, 'PTHR24177:SF396', NULL, NULL, NULL, NULL, '', 250396),
(403249, 'PTHR24177:SF432', NULL, NULL, NULL, NULL, 'EMBRYOGENEIS TRANSMEMBRANE PROTEIN', 250396),
(403250, 'PTHR24177:SF431', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 250396),
(403251, 'PTHR35355:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM229B', 250397),
(403252, 'PTHR35355', NULL, NULL, NULL, NULL, 'PROTEIN FAM229A', 250397),
(403253, 'PTHR35355:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAM229A', 250397),
(403254, 'PTHR34535', NULL, NULL, NULL, NULL, 'HYDROGENASE MATURATION FACTOR HYPA', 250398),
(403255, 'PTHR34535:SF4', NULL, NULL, NULL, NULL, 'HYDROGENASE MATURATION FACTOR HYBF', 250398),
(403256, 'PTHR34535:SF3', NULL, NULL, NULL, NULL, 'HYDROGENASE MATURATION FACTOR HYPA', 250398);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(403257, 'PTHR37507', NULL, NULL, NULL, NULL, 'SPORULATION PROTEIN YDCC', 250399),
(403258, 'PTHR37507:SF2', NULL, NULL, NULL, NULL, 'SPORULATION PROTEIN YDCC', 250399),
(403259, 'PTHR37182', NULL, NULL, NULL, NULL, 'F24J8.11 PROTEIN', 250400),
(403260, 'PTHR37182:SF2', NULL, NULL, NULL, NULL, 'F24J8.11 PROTEIN', 250400),
(403261, 'PTHR37182:SF3', NULL, NULL, NULL, NULL, 'BNAANNG40570D PROTEIN', 250400),
(403262, 'PTHR37964:SF1', NULL, NULL, NULL, NULL, 'SUPPRESSOR', 250401),
(403263, 'PTHR37964', NULL, NULL, NULL, NULL, 'SUPPRESSOR', 250401),
(403264, 'PTHR10915:SF6', NULL, NULL, NULL, NULL, 'SYNDECAN-2', 250402),
(403265, 'PTHR10915:SF5', NULL, NULL, NULL, NULL, 'SYNDECAN-1', 250402),
(403266, 'PTHR10915:SF7', NULL, NULL, NULL, NULL, 'SYNDECAN-3', 250402),
(403267, 'PTHR10915:SF1', NULL, NULL, NULL, NULL, 'SYNDECAN', 250402),
(403268, 'PTHR10915:SF3', NULL, NULL, NULL, NULL, 'SYNDECAN-4', 250402),
(403269, 'PTHR10915', NULL, NULL, NULL, NULL, 'SYNDECAN', 250402),
(403270, 'PTHR47601:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME C-TYPE BIOGENESIS CCMH-LIKE MITOCHONDRIAL PROTEIN', 250403),
(403271, 'PTHR47601', NULL, NULL, NULL, NULL, '', 250403),
(403272, 'PTHR47601:SF3', NULL, NULL, NULL, NULL, 'CYTOCHROME C-TYPE BIOGENESIS PROTEIN', 250403),
(403273, 'PTHR36150', NULL, NULL, NULL, NULL, 'DNA GYRASE INHIBITOR YACG', 250404),
(403274, 'PTHR36150:SF1', NULL, NULL, NULL, NULL, 'DNA GYRASE INHIBITOR YACG', 250404),
(403275, 'PTHR23046:SF2', NULL, NULL, NULL, NULL, 'AIR CARBOXYLASE', 250405),
(403276, 'PTHR23046', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLAMINOIMIDAZOLE CARBOXYLASE CATALYTIC SUBUNIT', 250405),
(403277, 'PTHR21008', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 250406),
(403278, 'PTHR21008:SF0', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE SENSOR UPSTREAM OF MTORC1', 250406),
(403279, 'PTHR21008:SF1', NULL, NULL, NULL, NULL, '25S RRNA (ADENINE(2142)-N(1))-METHYLTRANSFERASE', 250406),
(403280, 'PTHR28453', NULL, NULL, NULL, NULL, 'PROTEIN SNORC', 250407),
(403281, 'PTHR28453:SF1', NULL, NULL, NULL, NULL, 'PROTEIN SNORC', 250407),
(403282, 'PTHR47017', NULL, NULL, NULL, NULL, 'ACYL-COA', 250408),
(403283, 'PTHR47017:SF1', NULL, NULL, NULL, NULL, 'ACYL-COA', 250408),
(403284, 'PTHR36492', NULL, NULL, NULL, NULL, '', 250409),
(403285, 'PTHR36492:SF2', NULL, NULL, NULL, NULL, '[ACYL-CARRIER-PROTEIN] PHOSPHODIESTERASE PPTH', 250409),
(403286, 'PTHR31834:SF11', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE HOC1-RELATED', 250410),
(403287, 'PTHR31834', NULL, NULL, NULL, NULL, 'INITIATION-SPECIFIC ALPHA-1,6-MANNOSYLTRANSFERASE', 250410),
(403288, 'PTHR31834:SF9', NULL, NULL, NULL, NULL, '', 250410),
(403289, 'PTHR31834:SF8', NULL, NULL, NULL, NULL, 'TRANSFERASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G14040)-RELATED', 250410),
(403290, 'PTHR31834:SF10', NULL, NULL, NULL, NULL, 'TRANSFERASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G02040)-RELATED', 250410),
(403291, 'PTHR31834:SF1', NULL, NULL, NULL, NULL, 'INITIATION-SPECIFIC ALPHA-1,6-MANNOSYLTRANSFERASE', 250410),
(403292, 'PTHR14537:SF0', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE III DOMAIN-CONTAINING PROTEIN 11', 250411),
(403293, 'PTHR14537', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE III DOMAIN-CONTAINING PROTEIN 11', 250411),
(403294, 'PTHR14554:SF1', NULL, NULL, NULL, NULL, 'RCG48016, ISOFORM CRA_C', 250412),
(403295, 'PTHR14554', NULL, NULL, NULL, NULL, 'GENE, 49416-RELATED', 250412),
(403296, 'PTHR34639', NULL, NULL, NULL, NULL, 'PROTEIN FLATTOP', 250413),
(403297, 'PTHR34639:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FLATTOP', 250413),
(403298, 'PTHR28598:SF1', NULL, NULL, NULL, NULL, 'STAGA COMPLEX 65 SUBUNIT GAMMA', 250414),
(403299, 'PTHR28598', NULL, NULL, NULL, NULL, 'STAGA COMPLEX 65 SUBUNIT GAMMA', 250414),
(403300, 'PTHR11220:SF59', NULL, NULL, NULL, NULL, 'HEME-BINDING PROTEIN 2-LIKE', 250415),
(403301, 'PTHR11220:SF36', NULL, NULL, NULL, NULL, 'SOUL HEME-BINDING PROTEIN-RELATED', 250415),
(403302, 'PTHR11220:SF69', NULL, NULL, NULL, NULL, 'HEME-BINDING PROTEIN 2', 250415),
(403303, 'PTHR11220:SF58', NULL, NULL, NULL, NULL, 'SOUL HEME-BINDING FAMILY PROTEIN', 250415);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(403304, 'PTHR11220:SF25', NULL, NULL, NULL, NULL, 'F3F9.4', 250415),
(403305, 'PTHR11220:SF68', NULL, NULL, NULL, NULL, 'HEME-BINDING PROTEIN SOUL5-RELATED', 250415),
(403306, 'PTHR11220:SF24', NULL, NULL, NULL, NULL, 'HEME-BINDING PROTEIN SOUL4', 250415),
(403307, 'PTHR11220:SF67', NULL, NULL, NULL, NULL, 'SOUL HEME-BINDING FAMILY PROTEIN', 250415),
(403308, 'PTHR11220:SF22', NULL, NULL, NULL, NULL, 'HEME-BINDING PROTEIN 1', 250415),
(403309, 'PTHR11220:SF66', NULL, NULL, NULL, NULL, 'BNAA07G39170D PROTEIN', 250415),
(403310, 'PTHR11220:SF54', NULL, NULL, NULL, NULL, 'OS02G0533200 PROTEIN', 250415),
(403311, 'PTHR11220:SF1', NULL, NULL, NULL, NULL, 'OS01G0235300 PROTEIN', 250415),
(403312, 'PTHR11220:SF62', NULL, NULL, NULL, NULL, 'BNAA04G21740D PROTEIN', 250415),
(403313, 'PTHR11220:SF61', NULL, NULL, NULL, NULL, 'BNAA07G39160D PROTEIN', 250415),
(403314, 'PTHR11220:SF50', NULL, NULL, NULL, NULL, 'SOUL HEME-BINDING FAMILY PROTEIN', 250415),
(403315, 'PTHR11220:SF71', NULL, NULL, NULL, NULL, '', 250415),
(403316, 'PTHR11220:SF70', NULL, NULL, NULL, NULL, 'HEME-BINDING PROTEIN 2', 250415),
(403317, 'PTHR11220:SF7', NULL, NULL, NULL, NULL, 'SOUL PROTEIN', 250415),
(403318, 'PTHR11220', NULL, NULL, NULL, NULL, 'HEME-BINDING PROTEIN-RELATED', 250415),
(403319, 'PTHR11102:SF160', NULL, NULL, NULL, NULL, 'ERAD-ASSOCIATED E3 UBIQUITIN-PROTEIN LIGASE COMPONENT HRD3', 250416),
(403320, 'PTHR11102', NULL, NULL, NULL, NULL, 'SEL-1-LIKE PROTEIN', 250416),
(403321, 'PTHR11102:SF70', NULL, NULL, NULL, NULL, 'PROTEIN SEL-1 HOMOLOG 1', 250416),
(403322, 'PTHR11102:SF159', NULL, NULL, NULL, NULL, '', 250416),
(403323, 'PTHR11102:SF148', NULL, NULL, NULL, NULL, '', 250416),
(403324, 'PTHR11102:SF147', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE-II DOMAIN-CONTAINING PROTEIN', 250416),
(403325, 'PTHR11102:SF53', NULL, NULL, NULL, NULL, 'PROTEIN SEL-1 HOMOLOG 2', 250416),
(403326, 'PTHR12645:SF0', NULL, NULL, NULL, NULL, 'FAD-LINKED SULFHYDRYL OXIDASE ALR', 250417),
(403327, 'PTHR12645', NULL, NULL, NULL, NULL, 'ALR/ERV', 250417),
(403328, 'PTHR12645:SF1', NULL, NULL, NULL, NULL, 'FAD-LINKED SULFHYDRYL OXIDASE ERV2', 250417),
(403329, 'PTHR46534:SF1', NULL, NULL, NULL, NULL, 'IGGFC_BINDING DOMAIN-CONTAINING PROTEIN', 250418),
(403330, 'PTHR46534', NULL, NULL, NULL, NULL, 'IGGFC_BINDING DOMAIN-CONTAINING PROTEIN', 250418),
(403331, 'PTHR13586:SF2', NULL, NULL, NULL, NULL, 'PROTEIN LSM14 HOMOLOG A', 250419),
(403332, 'PTHR13586:SF26', NULL, NULL, NULL, NULL, 'LSM14 DOMAIN-CONTAINING PROTEIN', 250419),
(403333, 'PTHR13586:SF16', NULL, NULL, NULL, NULL, 'PROTEIN DECAPPING 5-LIKE', 250419),
(403334, 'PTHR13586:SF24', NULL, NULL, NULL, NULL, 'BNACNNG29620D PROTEIN', 250419),
(403335, 'PTHR13586:SF25', NULL, NULL, NULL, NULL, 'LSM DOMAIN, FDF DOMAIN, FFD BOX, DFDF DOMAIN, TFG BOX-RELATED', 250419),
(403336, 'PTHR13586:SF14', NULL, NULL, NULL, NULL, 'PROTEIN DECAPPING 5-LIKE', 250419),
(403337, 'PTHR13586:SF12', NULL, NULL, NULL, NULL, 'OS01G0111200 PROTEIN', 250419),
(403338, 'PTHR13586:SF23', NULL, NULL, NULL, NULL, 'DECAPPING 5-LIKE PROTEIN-RELATED', 250419),
(403339, 'PTHR13586:SF20', NULL, NULL, NULL, NULL, 'BNAANNG26910D PROTEIN', 250419),
(403340, 'PTHR13586', NULL, NULL, NULL, NULL, 'SCD6 PROTEIN-RELATED', 250419),
(403341, 'PTHR13586:SF0', NULL, NULL, NULL, NULL, 'TRAILER HITCH, ISOFORM H', 250419),
(403342, 'PTHR13586:SF1', NULL, NULL, NULL, NULL, 'PROTEIN LSM14 HOMOLOG B', 250419),
(403343, 'PTHR36697', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE SYNTHASE', 250420),
(403344, 'PTHR36697:SF1', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE SYNTHASE', 250420),
(403345, 'PTHR44216', NULL, NULL, NULL, NULL, 'PROTEIN O-MANNOSYL-TRANSFERASE TMTC2', 250421),
(403346, 'PTHR44216:SF3', NULL, NULL, NULL, NULL, 'PROTEIN O-MANNOSYL-TRANSFERASE TMTC2', 250421),
(403347, 'PTHR44313:SF1', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 17', 250422),
(403348, 'PTHR44313', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 17', 250422),
(403349, 'PTHR31458:SF9', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE-1 NON-CATALYTIC SUBUNIT BETA', 250423);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(403350, 'PTHR31458:SF4', NULL, NULL, NULL, NULL, 'BURP DOMAIN-CONTAINING PROTEIN 14', 250423),
(403351, 'PTHR31458:SF19', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE 1 BETA-LIKE PROTEIN 3', 250423),
(403352, 'PTHR31458:SF17', NULL, NULL, NULL, NULL, 'BURP DOMAIN-CONTAINING PROTEIN', 250423),
(403353, 'PTHR31458:SF2', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE 1 BETA-LIKE PROTEIN 2', 250423),
(403354, 'PTHR31458:SF18', NULL, NULL, NULL, NULL, 'BURP DOMAIN-CONTAINING PROTEIN-RELATED', 250423),
(403355, 'PTHR31458:SF15', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE NON-CATALYTIC SUBUNIT AROGP2', 250423),
(403356, 'PTHR31458:SF16', NULL, NULL, NULL, NULL, 'BURP DOMAIN-CONTAINING PROTEIN', 250423),
(403357, 'PTHR31458:SF13', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE NON-CATALYTIC PROTEIN', 250423),
(403358, 'PTHR31458:SF14', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE NON-CATALYTIC SUBUNIT AROGP3', 250423),
(403359, 'PTHR31458:SF11', NULL, NULL, NULL, NULL, 'BURP DOMAIN-CONTAINING PROTEIN', 250423),
(403360, 'PTHR31458:SF12', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE-1 NON-CATALYTIC SUBUNIT BETA-LIKE', 250423),
(403361, 'PTHR31458:SF10', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE 1 BETA-LIKE PROTEIN 1-RELATED', 250423),
(403362, 'PTHR31458', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE 1 BETA-LIKE PROTEIN 2', 250423),
(403363, 'PTHR11871:SF34', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 55 KDA REGULATORY SUBUNIT B', 250424),
(403364, 'PTHR11871:SF35', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A 55 KDA REGULATORY SUBUNIT B ALPHA ISOFORM', 250424),
(403365, 'PTHR11871:SF10', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 55 KDA REGULATORY SUBUNIT B', 250424),
(403366, 'PTHR11871:SF39', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 55 KDA REGULATORY SUBUNIT B', 250424),
(403367, 'PTHR11871:SF36', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 55 KDA REGULATORY SUBUNIT B', 250424),
(403368, 'PTHR11871:SF37', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 55 KDA REGULATORY SUBUNIT B', 250424),
(403369, 'PTHR11871', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE PP2A REGULATORY SUBUNIT B', 250424),
(403370, 'PTHR11871:SF52', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 55 KDA REGULATORY SUBUNIT B', 250424),
(403371, 'PTHR11871:SF30', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 55 KDA REGULATORY SUBUNIT B', 250424),
(403372, 'PTHR11871:SF31', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 55 KDA REGULATORY SUBUNIT B', 250424),
(403373, 'PTHR11871:SF50', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 55 KDA REGULATORY SUBUNIT B', 250424),
(403374, 'PTHR11871:SF51', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 55 KDA REGULATORY SUBUNIT B', 250424),
(403375, 'PTHR11871:SF6', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 55 KDA REGULATORY SUBUNIT B DELTA ISOFORM', 250424),
(403376, 'PTHR11871:SF5', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 55 KDA REGULATORY SUBUNIT B GAMMA ISOFORM', 250424),
(403377, 'PTHR11871:SF8', NULL, NULL, NULL, NULL, '', 250424),
(403378, 'PTHR11871:SF2', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 55 KDA REGULATORY SUBUNIT B ALPHA ISOFORM', 250424),
(403379, 'PTHR11871:SF1', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 55 KDA REGULATORY SUBUNIT B BETA ISOFORM', 250424),
(403380, 'PTHR11871:SF0', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE PP2A 55 KDA REGULATORY SUBUNIT', 250424),
(403381, 'PTHR11871:SF46', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 55 KDA REGULATORY SUBUNIT B', 250424),
(403382, 'PTHR11871:SF44', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 55 KDA REGULATORY SUBUNIT B', 250424),
(403383, 'PTHR11871:SF49', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 55 KDA REGULATORY SUBUNIT B', 250424),
(403384, 'PTHR11871:SF28', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A 55 KDA REGULATORY SUBUNIT B ALPHA ISOFORM', 250424);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(403385, 'PTHR11871:SF47', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 55 KDA REGULATORY SUBUNIT B', 250424),
(403386, 'PTHR11871:SF48', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 55 KDA REGULATORY SUBUNIT B', 250424),
(403387, 'PTHR11871:SF40', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 55 KDA REGULATORY SUBUNIT B', 250424),
(403388, 'PTHR35601:SF2', NULL, NULL, NULL, NULL, 'MRNA INTERFERASE TOXIN RELE', 250425),
(403389, 'PTHR35601:SF1', NULL, NULL, NULL, NULL, 'TOXIN RELE', 250425),
(403390, 'PTHR35601', NULL, NULL, NULL, NULL, 'TOXIN RELE', 250425),
(403391, 'PTHR15683:SF4', NULL, NULL, NULL, NULL, 'SCAFFOLD ATTACHMENT FACTOR B2', 250426),
(403392, 'PTHR15683:SF5', NULL, NULL, NULL, NULL, 'SAFB-LIKE TRANSCRIPTION MODULATOR', 250426),
(403393, 'PTHR15683', NULL, NULL, NULL, NULL, 'SCAFFOLD ATTACHMENT FACTOR B-RELATED', 250426),
(403394, 'PTHR15683:SF10', NULL, NULL, NULL, NULL, 'SAP DOMAIN-CONTAINING PROTEIN', 250426),
(403395, 'PTHR15683:SF8', NULL, NULL, NULL, NULL, 'SCAFFOLD ATTACHMENT FACTOR B, ISOFORM B', 250426),
(403396, 'PTHR15683:SF6', NULL, NULL, NULL, NULL, 'SCAFFOLD ATTACHMENT FACTOR B1', 250426),
(403397, 'PTHR47302:SF1', NULL, NULL, NULL, NULL, 'STERILE ALPHA MOTIF DOMAIN-CONTAINING PROTEIN 3', 250427),
(403398, 'PTHR47302', NULL, NULL, NULL, NULL, 'STERILE ALPHA MOTIF DOMAIN-CONTAINING PROTEIN 3', 250427),
(403399, 'PTHR43968:SF4', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE OMEGA-2', 250428),
(403400, 'PTHR43968:SF5', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE OMEGA-1', 250428),
(403401, 'PTHR43968', NULL, NULL, NULL, NULL, '', 250428),
(403402, 'PTHR43968:SF6', NULL, NULL, NULL, NULL, 'GLUTATHIONE-DEPENDENT DEHYDROASCORBATE REDUCTASE', 250428),
(403403, 'PTHR43968:SF8', NULL, NULL, NULL, NULL, 'S-TRANSFERASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G00590)-RELATED', 250428),
(403404, 'PTHR43968:SF9', NULL, NULL, NULL, NULL, 'GST N-TERMINAL DOMAIN-CONTAINING PROTEIN', 250428),
(403405, 'PTHR43968:SF12', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE-RELATED', 250428),
(403406, 'PTHR43968:SF13', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE OMEGA-1', 250428),
(403407, 'PTHR43968:SF14', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE', 250428),
(403408, 'PTHR16565:SF3', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN C-I, ACIDIC FORM', 250429),
(403409, 'PTHR16565:SF2', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN C-I', 250429),
(403410, 'PTHR16565', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN C-I', 250429),
(403411, 'PTHR37528', NULL, NULL, NULL, NULL, 'UPF0149 PROTEIN YGFB', 250430),
(403412, 'PTHR37528:SF1', NULL, NULL, NULL, NULL, 'UPF0149 PROTEIN YGFB', 250430),
(403413, 'PTHR21515:SF9', NULL, NULL, NULL, NULL, 'CYLICIN HOMOLOGUE-RELATED', 250431),
(403414, 'PTHR21515', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', 250431),
(403415, 'PTHR21515:SF4', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', 250431),
(403416, 'PTHR21515:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG04098', 250431),
(403417, 'PTHR47956', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71B11-RELATED', 250432),
(403418, 'PTHR47956:SF79', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71B31-RELATED', 250432),
(403419, 'PTHR47956:SF1', NULL, NULL, NULL, NULL, 'OS01G0377000 PROTEIN', 250432),
(403420, 'PTHR47956:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71B10', 250432),
(403421, 'PTHR47956:SF3', NULL, NULL, NULL, NULL, 'FLAVONOID 3''-MONOOXYGENASE CYP75B4', 250432),
(403422, 'PTHR47956:SF78', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71B24-RELATED', 250432),
(403423, 'PTHR47956:SF73', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71B22', 250432),
(403424, 'PTHR47956:SF74', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A23', 250432),
(403425, 'PTHR47956:SF82', NULL, NULL, NULL, NULL, 'OS06G0642600 PROTEIN', 250432),
(403426, 'PTHR47956:SF8', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71B10', 250432),
(403427, 'PTHR47956:SF83', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 250432),
(403428, 'PTHR47956:SF9', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN, EXPRESSED', 250432);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(403429, 'PTHR47956:SF80', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71B10', 250432),
(403430, 'PTHR47956:SF81', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 71 PROTEIN', 250432),
(403431, 'PTHR47956:SF4', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A21-RELATED', 250432),
(403432, 'PTHR47956:SF5', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71B36-LIKE', 250432),
(403433, 'PTHR47956:SF6', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71B38-RELATED', 250432),
(403434, 'PTHR47956:SF7', NULL, NULL, NULL, NULL, 'OS05G0515200 PROTEIN', 250432),
(403435, 'PTHR47956:SF130', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71B23', 250432),
(403436, 'PTHR47956:SF131', NULL, NULL, NULL, NULL, 'FLAVONOID 3''-MONOOXYGENASE', 250432),
(403437, 'PTHR47956:SF132', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A27', 250432),
(403438, 'PTHR47956:SF133', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71D7', 250432),
(403439, 'PTHR47956:SF68', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 99A2', 250432),
(403440, 'PTHR47956:SF66', NULL, NULL, NULL, NULL, 'P450 71E1, PUTATIVE-RELATED', 250432),
(403441, 'PTHR47956:SF67', NULL, NULL, NULL, NULL, '', 250432),
(403442, 'PTHR47956:SF64', NULL, NULL, NULL, NULL, 'OS02G0184600 PROTEIN', 250432),
(403443, 'PTHR47956:SF65', NULL, NULL, NULL, NULL, '', 250432),
(403444, 'PTHR47956:SF62', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A8-LIKE', 250432),
(403445, 'PTHR47956:SF63', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 71 PROTEIN', 250432),
(403446, 'PTHR47956:SF71', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 71 PROTEIN', 250432),
(403447, 'PTHR47956:SF72', NULL, NULL, NULL, NULL, '', 250432),
(403448, 'PTHR47956:SF70', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71B21', 250432),
(403449, 'PTHR47956:SF123', NULL, NULL, NULL, NULL, 'OS05G0424300 PROTEIN', 250432),
(403450, 'PTHR47956:SF124', NULL, NULL, NULL, NULL, 'CYP71A12 (CYTOCHROME P450 FAMILY 71 SUBFAMILY A POLYPEPTIDE 12)', 250432),
(403451, 'PTHR47956:SF121', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 250432),
(403452, 'PTHR47956:SF122', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71D8-LIKE', 250432),
(403453, 'PTHR47956:SF58', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 250432),
(403454, 'PTHR47956:SF55', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 SUPERFAMILY PROTEIN-RELATED', 250432),
(403455, 'PTHR47956:SF53', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 71 PROTEIN', 250432),
(403456, 'PTHR47956:SF54', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71D10-LIKE', 250432),
(403457, 'PTHR47956:SF51', NULL, NULL, NULL, NULL, 'PREMNASPIRODIENE OXYGENASE-LIKE', 250432),
(403458, 'PTHR47956:SF52', NULL, NULL, NULL, NULL, 'OS01G0227700 PROTEIN', 250432),
(403459, 'PTHR47956:SF127', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71B13-RELATED', 250432),
(403460, 'PTHR47956:SF128', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A26', 250432),
(403461, 'PTHR47956:SF125', NULL, NULL, NULL, NULL, 'BNAA09G46570D PROTEIN', 250432),
(403462, 'PTHR47956:SF126', NULL, NULL, NULL, NULL, '', 250432),
(403463, 'PTHR47956:SF129', NULL, NULL, NULL, NULL, 'P450, PUTATIVE-RELATED', 250432),
(403464, 'PTHR47956:SF48', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP71K14', 250432),
(403465, 'PTHR47956:SF111', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 71 PROTEIN', 250432),
(403466, 'PTHR47956:SF49', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 83B1', 250432),
(403467, 'PTHR47956:SF46', NULL, NULL, NULL, NULL, 'PREMNASPIRODIENE OXYGENASE-LIKE', 250432),
(403468, 'PTHR47956:SF44', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 250432),
(403469, 'PTHR47956:SF45', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71B7', 250432),
(403470, 'PTHR47956:SF43', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71D9', 250432),
(403471, 'PTHR47956:SF40', NULL, NULL, NULL, NULL, 'OS02G0186900 PROTEIN', 250432),
(403472, 'PTHR47956:SF50', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL DIHYDROCAMALEXATE SYNTHASE/CAMALEXIN SYNTHASE-RELATED', 250432),
(403473, 'PTHR47956:SF117', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 71 PROTEIN', 250432),
(403474, 'PTHR47956:SF115', NULL, NULL, NULL, NULL, 'FLAVONOID 3''-MONOOXYGENASE CYP75B3', 250432);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(403475, 'PTHR47956:SF119', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71B16-RELATED', 250432),
(403476, 'PTHR47956:SF101', NULL, NULL, NULL, NULL, '', 250432),
(403477, 'PTHR47956:SF39', NULL, NULL, NULL, NULL, 'OS02G0186800 PROTEIN', 250432),
(403478, 'PTHR47956:SF102', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 250432),
(403479, 'PTHR47956:SF37', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 76C2-LIKE', 250432),
(403480, 'PTHR47956:SF38', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 99A2', 250432),
(403481, 'PTHR47956:SF35', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN, EXPRESSED', 250432),
(403482, 'PTHR47956:SF33', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71B19-RELATED', 250432),
(403483, 'PTHR47956:SF34', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71D7', 250432),
(403484, 'PTHR47956:SF30', NULL, NULL, NULL, NULL, 'OS06G0641500 PROTEIN', 250432),
(403485, 'PTHR47956:SF105', NULL, NULL, NULL, NULL, '', 250432),
(403486, 'PTHR47956:SF106', NULL, NULL, NULL, NULL, '', 250432),
(403487, 'PTHR47956:SF104', NULL, NULL, NULL, NULL, 'PREMNASPIRODIENE OXYGENASE-LIKE', 250432),
(403488, 'PTHR47956:SF109', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71D10', 250432),
(403489, 'PTHR47956:SF107', NULL, NULL, NULL, NULL, 'OS02G0184900 PROTEIN', 250432),
(403490, 'PTHR47956:SF108', NULL, NULL, NULL, NULL, '', 250432),
(403491, 'PTHR47956:SF28', NULL, NULL, NULL, NULL, '', 250432),
(403492, 'PTHR47956:SF29', NULL, NULL, NULL, NULL, 'OS02G0278400 PROTEIN', 250432),
(403493, 'PTHR47956:SF26', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 71 PROTEIN', 250432),
(403494, 'PTHR47956:SF27', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 SUPERFAMILY PROTEIN-RELATED', 250432),
(403495, 'PTHR47956:SF24', NULL, NULL, NULL, NULL, 'EUPATOLIDE SYNTHASE', 250432),
(403496, 'PTHR47956:SF25', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71D10-LIKE', 250432),
(403497, 'PTHR47956:SF22', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A12-RELATED', 250432),
(403498, 'PTHR47956:SF23', NULL, NULL, NULL, NULL, '(S)-N-METHYLCOCLAURINE 3''-HYDROXYLASE ISOZYME 1-LIKE', 250432),
(403499, 'PTHR47956:SF21', NULL, NULL, NULL, NULL, '5-EPIARISTOLOCHENE 13-DIHYDROXYLASE', 250432),
(403500, 'PTHR47956:SF19', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A28-RELATED', 250432),
(403501, 'PTHR47956:SF17', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71B4', 250432),
(403502, 'PTHR47956:SF18', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 250432),
(403503, 'PTHR47956:SF13', NULL, NULL, NULL, NULL, 'ENT-ISOKAURENE C2/C3-HYDROXYLASE', 250432),
(403504, 'PTHR47956:SF14', NULL, NULL, NULL, NULL, 'OS04G0480700 PROTEIN', 250432),
(403505, 'PTHR47956:SF99', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 250432),
(403506, 'PTHR47956:SF11', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 83A1', 250432),
(403507, 'PTHR47956:SF12', NULL, NULL, NULL, NULL, 'FLAVONOID 3''-MONOOXYGENASE', 250432),
(403508, 'PTHR47956:SF97', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71B29', 250432),
(403509, 'PTHR47956:SF10', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 71 PROTEIN', 250432),
(403510, 'PTHR47956:SF98', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 71 PROTEIN', 250432),
(403511, 'PTHR47956:SF95', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 250432),
(403512, 'PTHR47956:SF96', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71B11-RELATED', 250432),
(403513, 'PTHR47956:SF88', NULL, NULL, NULL, NULL, '', 250432),
(403514, 'PTHR47956:SF89', NULL, NULL, NULL, NULL, '', 250432),
(403515, 'PTHR47956:SF87', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 HYDROXYLASE', 250432),
(403516, 'PTHR47956:SF84', NULL, NULL, NULL, NULL, 'OS06G0497350 PROTEIN', 250432),
(403517, 'PTHR47956:SF85', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71D9-LIKE', 250432),
(403518, 'PTHR47956:SF93', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71B2', 250432),
(403519, 'PTHR22589', NULL, NULL, NULL, NULL, 'CARNITINE O-ACYLTRANSFERASE', 250433),
(403520, 'PTHR22589:SF107', NULL, NULL, NULL, NULL, 'CARN_ACYLTRANSF DOMAIN-CONTAINING PROTEIN', 250433),
(403521, 'PTHR22589:SF104', NULL, NULL, NULL, NULL, 'CARN_ACYLTRANSF DOMAIN-CONTAINING PROTEIN', 250433);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(403522, 'PTHR22589:SF105', NULL, NULL, NULL, NULL, 'CARNITINE O-PALMITOYLTRANSFERASE', 250433),
(403523, 'PTHR22589:SF60', NULL, NULL, NULL, NULL, 'O-PALMITOYLTRANSFERASE II, PUTATIVE-RELATED', 250433),
(403524, 'PTHR22589:SF74', NULL, NULL, NULL, NULL, 'CARNITINE O-PALMITOYLTRANSFERASE 1, LIVER ISOFORM', 250433),
(403525, 'PTHR22589:SF53', NULL, NULL, NULL, NULL, 'CARN_ACYLTRANSF DOMAIN-CONTAINING PROTEIN', 250433),
(403526, 'PTHR22589:SF31', NULL, NULL, NULL, NULL, 'CARNITINE O-PALMITOYLTRANSFERASE', 250433),
(403527, 'PTHR22589:SF50', NULL, NULL, NULL, NULL, 'CARNITINE O-ACETYLTRANSFERASE', 250433),
(403528, 'PTHR22589:SF51', NULL, NULL, NULL, NULL, 'CARNITINE O-PALMITOYLTRANSFERASE 2, MITOCHONDRIAL', 250433),
(403529, 'PTHR22589:SF67', NULL, NULL, NULL, NULL, 'PEROXISOMAL CARNITINE O-OCTANOYLTRANSFERASE', 250433),
(403530, 'PTHR22589:SF5', NULL, NULL, NULL, NULL, 'CARN_ACYLTRANSF DOMAIN-CONTAINING PROTEIN', 250433),
(403531, 'PTHR22589:SF55', NULL, NULL, NULL, NULL, 'CARNITINE O-PALMITOYLTRANSFERASE 1, BRAIN ISOFORM', 250433),
(403532, 'PTHR22589:SF99', NULL, NULL, NULL, NULL, 'CARN_ACYLTRANSF DOMAIN-CONTAINING PROTEIN', 250433),
(403533, 'PTHR22589:SF16', NULL, NULL, NULL, NULL, 'CARNITINE O-PALMITOYLTRANSFERASE 2, MITOCHONDRIAL', 250433),
(403534, 'PTHR22589:SF103', NULL, NULL, NULL, NULL, 'CARN_ACYLTRANSF DOMAIN-CONTAINING PROTEIN-RELATED', 250433),
(403535, 'PTHR22589:SF47', NULL, NULL, NULL, NULL, 'CARNITINE O-ACETYLTRANSFERASE B', 250433),
(403536, 'PTHR22589:SF69', NULL, NULL, NULL, NULL, 'CARNITINE O-PALMITOYLTRANSFERASE 1, MUSCLE ISOFORM', 250433),
(403537, 'PTHR22589:SF14', NULL, NULL, NULL, NULL, 'CHOLINE O-ACETYLTRANSFERASE', 250433),
(403538, 'PTHR22589:SF112', NULL, NULL, NULL, NULL, 'CARN_ACYLTRANSF DOMAIN-CONTAINING PROTEIN', 250433),
(403539, 'PTHR22589:SF48', NULL, NULL, NULL, NULL, 'CARNITINE O-ACETYLTRANSFERASE YAT2', 250433),
(403540, 'PTHR22589:SF110', NULL, NULL, NULL, NULL, 'CARN_ACYLTRANSF DOMAIN-CONTAINING PROTEIN', 250433),
(403541, 'PTHR22589:SF29', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CARNITINE O-ACETYLTRANSFERASE-RELATED', 250433),
(403542, 'PTHR15224:SF7', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] IRON-SULFUR PROTEIN 5-A-RELATED', 250434),
(403543, 'PTHR15224:SF8', NULL, NULL, NULL, NULL, 'BNAC06G18600D PROTEIN', 250434),
(403544, 'PTHR15224:SF5', NULL, NULL, NULL, NULL, 'BNAC04G00180D PROTEIN', 250434),
(403545, 'PTHR15224:SF1', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] IRON-SULFUR PROTEIN 5', 250434),
(403546, 'PTHR15224', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] IRON-SULFUR PROTEIN 5', 250434),
(403547, 'PTHR37225:SF1', NULL, NULL, NULL, NULL, 'OS04G0657900 PROTEIN', 250435),
(403548, 'PTHR37225', NULL, NULL, NULL, NULL, 'OSJNBA0011F23.3 PROTEIN', 250435),
(403549, 'PTHR18968:SF129', NULL, NULL, NULL, NULL, 'ACETOLACTATE SYNTHASE', 250436),
(403550, 'PTHR18968:SF86', NULL, NULL, NULL, NULL, 'ACETOLACTATE SYNTHASE LARGE SUBUNIT ILVX-RELATED', 250436),
(403551, 'PTHR18968', NULL, NULL, NULL, NULL, 'THIAMINE PYROPHOSPHATE ENZYMES', 250436),
(403552, 'PTHR18968:SF14', NULL, NULL, NULL, NULL, 'GLYOXYLATE CARBOLIGASE', 250436),
(403553, 'PTHR18968:SF13', NULL, NULL, NULL, NULL, 'ACETOLACTATE SYNTHASE, CHLOROPLASTIC', 250436),
(403554, 'PTHR18968:SF163', NULL, NULL, NULL, NULL, 'ACETOLACTATE SYNTHASE', 250436),
(403555, 'PTHR18968:SF161', NULL, NULL, NULL, NULL, 'ACETOLACTATE SYNTHASE', 250436),
(403556, 'PTHR18968:SF160', NULL, NULL, NULL, NULL, 'ACETOLACTATE SYNTHASE', 250436),
(403557, 'PTHR18968:SF167', NULL, NULL, NULL, NULL, 'ACETOLACTATE SYNTHASE LARGE SUBUNIT ILVB2-RELATED', 250436),
(403558, 'PTHR18968:SF166', NULL, NULL, NULL, NULL, '2-HYDROXYACYL-COA LYASE 2', 250436),
(403559, 'PTHR18968:SF133', NULL, NULL, NULL, NULL, 'BENZOYLFORMATE DECARBOXYLASE', 250436),
(403560, 'PTHR18968:SF165', NULL, NULL, NULL, NULL, 'BNAA06G33000D PROTEIN', 250436),
(403561, 'PTHR18968:SF142', NULL, NULL, NULL, NULL, 'ACETOLACTATE SYNTHASE', 250436),
(403562, 'PTHR18968:SF9', NULL, NULL, NULL, NULL, '3D-(3,5/4)-TRIHYDROXYCYCLOHEXANE-1,2-DIONE HYDROLASE', 250436); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(403563, 'PTHR18968:SF120', NULL, NULL, NULL, NULL, 'ACETOLACTATE SYNTHASE LARGE SUBUNIT', 250436),
(403564, 'PTHR18968:SF164', NULL, NULL, NULL, NULL, 'PYRUVATE DECARBOXYLASE', 250436),
(403565, 'PTHR18968:SF169', NULL, NULL, NULL, NULL, 'ACETOLACTATE SYNTHASE CATALYTIC SUBUNIT, MITOCHONDRIAL', 250436),
(403566, 'PTHR18968:SF168', NULL, NULL, NULL, NULL, 'ACETOLACTATE SYNTHASE', 250436),
(403567, 'PTHR17583', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE 3-KINASE REGULATORY SUBUNIT 4', 250437),
(403568, 'PTHR17583:SF0', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE 3-KINASE REGULATORY SUBUNIT 4', 250437),
(403569, 'PTHR34136:SF1', NULL, NULL, NULL, NULL, 'UDP-N-ACETYL-D-MANNOSAMINURONIC ACID TRANSFERASE', 250438),
(403570, 'PTHR34136', NULL, NULL, NULL, NULL, '', 250438),
(403571, 'PTHR47153', NULL, NULL, NULL, NULL, 'LACTATE UTILIZATION PROTEIN B', 250439),
(403572, 'PTHR47153:SF2', NULL, NULL, NULL, NULL, 'LACTATE UTILIZATION PROTEIN B', 250439),
(403573, 'PTHR16073:SF10', NULL, NULL, NULL, NULL, 'DEVELOPMENTAL PLURIPOTENCY-ASSOCIATED PROTEIN 2', 250440),
(403574, 'PTHR16073:SF11', NULL, NULL, NULL, NULL, '', 250440),
(403575, 'PTHR16073', NULL, NULL, NULL, NULL, 'DCR DOMAIN-CONTAINING PROTEIN', 250440),
(403576, 'PTHR16073:SF9', NULL, NULL, NULL, NULL, 'SAP DOMAIN-CONTAINING PROTEIN', 250440),
(403577, 'PTHR16073:SF8', NULL, NULL, NULL, NULL, 'DEVELOPMENTAL PLURIPOTENCY-ASSOCIATED PROTEIN 4', 250440),
(403578, 'PTHR42201', NULL, NULL, NULL, NULL, 'TAXIS PROTEIN', 250441),
(403579, 'PTHR42201:SF1', NULL, NULL, NULL, NULL, 'TAXIS PROTEIN', 250441),
(403580, 'PTHR31977:SF1', NULL, NULL, NULL, NULL, 'UPF0696 PROTEIN C11ORF68', 250442),
(403581, 'PTHR31977', NULL, NULL, NULL, NULL, 'UPF0696 PROTEIN C11ORF68', 250442),
(403582, 'PTHR15162', NULL, NULL, NULL, NULL, 'ASPARTOACYLASE', 250443),
(403583, 'PTHR15162:SF9', NULL, NULL, NULL, NULL, 'ASPARTOACYLASE', 250443),
(403584, 'PTHR15162:SF7', NULL, NULL, NULL, NULL, 'SUCCINYLGLUTAMATE DESUCCINYLASE', 250443),
(403585, 'PTHR15162:SF5', NULL, NULL, NULL, NULL, 'N-ACYL-AROMATIC-L-AMINO ACID AMIDOHYDROLASE (CARBOXYLATE-FORMING)', 250443),
(403586, 'PTHR28622:SF1', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 7', 250444),
(403587, 'PTHR28622', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 7', 250444),
(403588, 'PTHR43794:SF11', NULL, NULL, NULL, NULL, 'AMIDOHYDRO-REL DOMAIN-CONTAINING PROTEIN', 250445),
(403589, 'PTHR43794:SF5', NULL, NULL, NULL, NULL, 'CHLOROHYDROLASE FAMILY PROTEIN', 250445),
(403590, 'PTHR43794', NULL, NULL, NULL, NULL, 'AMINOHYDROLASE SSNA-RELATED', 250445),
(403591, 'PTHR31878', NULL, NULL, NULL, NULL, 'CHEMOKINE-LIKE PROTEIN TAFA-5-RELATED', 250446),
(403592, 'PTHR31878:SF0', NULL, NULL, NULL, NULL, 'CHEMOKINE-LIKE PROTEIN TAFA-5', 250446),
(403593, 'PTHR31878:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAM19A5-LIKE', 250446),
(403594, 'PTHR35792:SF1', NULL, NULL, NULL, NULL, 'SLL0268 PROTEIN', 250447),
(403595, 'PTHR35792:SF2', NULL, NULL, NULL, NULL, 'GENERAL STRESS PROTEIN', 250447),
(403596, 'PTHR35792:SF3', NULL, NULL, NULL, NULL, 'IG HYPOTHETICAL 17707', 250447),
(403597, 'PTHR35792', NULL, NULL, NULL, NULL, 'GENERAL STRESS PROTEIN', 250447),
(403598, 'PTHR43193:SF2', NULL, NULL, NULL, NULL, 'POLYFERREDOXIN PROTEIN FWDF', 250448),
(403599, 'PTHR43193', NULL, NULL, NULL, NULL, '', 250448),
(403600, 'PTHR31598', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN D', 250449),
(403601, 'PTHR31598:SF1', NULL, NULL, NULL, NULL, 'DYNEIN REGULATORY COMPLEX PROTEIN 10', 250449),
(403602, 'PTHR45277:SF2', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 250450),
(403603, 'PTHR45277:SF3', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASE-RELATED', 250450),
(403604, 'PTHR45277:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250450),
(403605, 'PTHR45277', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250450),
(403606, 'PTHR47131:SF1', NULL, NULL, NULL, NULL, 'CATION CHANNEL SPERM-ASSOCIATED PROTEIN 3', 250451),
(403607, 'PTHR47131', NULL, NULL, NULL, NULL, 'CATION CHANNEL SPERM-ASSOCIATED PROTEIN 3', 250451);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(403608, 'PTHR34398:SF1', NULL, NULL, NULL, NULL, '', 250452),
(403609, 'PTHR34398', NULL, NULL, NULL, NULL, '', 250452),
(403610, 'PTHR34398:SF2', NULL, NULL, NULL, NULL, '', 250452),
(403611, 'PTHR14222:SF1', NULL, NULL, NULL, NULL, 'CONDENSIN-2 COMPLEX SUBUNIT D3', 250453),
(403612, 'PTHR14222:SF2', NULL, NULL, NULL, NULL, 'CONDENSIN COMPLEX SUBUNIT 1', 250453),
(403613, 'PTHR14222', NULL, NULL, NULL, NULL, 'CONDENSIN', 250453),
(403614, 'PTHR38588:SF1', NULL, NULL, NULL, NULL, 'BLL0334 PROTEIN', 250454),
(403615, 'PTHR38588', NULL, NULL, NULL, NULL, 'BLL0334 PROTEIN', 250454),
(403616, 'PTHR10192:SF32', NULL, NULL, NULL, NULL, 'DOMAIN E', 250455),
(403617, 'PTHR10192:SF31', NULL, NULL, NULL, NULL, 'MOLYBDOPTERIN MOLYBDENUMTRANSFERASE', 250455),
(403618, 'PTHR10192', NULL, NULL, NULL, NULL, 'MOLYBDOPTERIN BIOSYNTHESIS PROTEIN', 250455),
(403619, 'PTHR10192:SF30', NULL, NULL, NULL, NULL, 'MOLYBDOPTERIN MOLYBDENUMTRANSFERASE', 250455),
(403620, 'PTHR10192:SF19', NULL, NULL, NULL, NULL, 'MOLYBDOPTERIN BIOSYNTHESIS PROTEIN MJ0666-RELATED', 250455),
(403621, 'PTHR10192:SF29', NULL, NULL, NULL, NULL, 'DOMAIN E', 250455),
(403622, 'PTHR10192:SF28', NULL, NULL, NULL, NULL, 'MOLYBDOPTERIN MOLYBDENUMTRANSFERASE', 250455),
(403623, 'PTHR10192:SF16', NULL, NULL, NULL, NULL, 'MOLYBDOPTERIN MOLYBDENUMTRANSFERASE', 250455),
(403624, 'PTHR10192:SF2', NULL, NULL, NULL, NULL, 'MOLYBDOPTERIN MOLYBDENUMTRANSFERASE', 250455),
(403625, 'PTHR10192:SF5', NULL, NULL, NULL, NULL, 'GEPHYRIN', 250455),
(403626, 'PTHR44103:SF1', NULL, NULL, NULL, NULL, 'PROPROTEIN CONVERTASE P', 250456),
(403627, 'PTHR44103', NULL, NULL, NULL, NULL, 'PROPROTEIN CONVERTASE P', 250456),
(403628, 'PTHR38909:SF1', NULL, NULL, NULL, NULL, 'G PROTEIN GAMMA DOMAIN-CONTAINING PROTEIN', 250457),
(403629, 'PTHR38909', NULL, NULL, NULL, NULL, 'G PROTEIN GAMMA DOMAIN-CONTAINING PROTEIN', 250457),
(403630, 'PTHR47870:SF4', NULL, NULL, NULL, NULL, 'CYTOCHROME C-TYPE BIOGENESIS PROTEIN CYCH', 250458),
(403631, 'PTHR47870:SF2', NULL, NULL, NULL, NULL, 'FORMATE-DEPENDENT NITRITE REDUCTASE COMPLEX SUBUNIT NRFF', 250458),
(403632, 'PTHR47870:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME C-TYPE BIOGENESIS PROTEIN CCMH', 250458),
(403633, 'PTHR47870', NULL, NULL, NULL, NULL, 'CYTOCHROME C-TYPE BIOGENESIS PROTEIN CCMH', 250458),
(403634, 'PTHR36810:SF1', NULL, NULL, NULL, NULL, 'LYSM DOMAIN CONTAINING PROTEIN', 250459),
(403635, 'PTHR36810', NULL, NULL, NULL, NULL, 'BNACNNG47150D PROTEIN', 250459),
(403636, 'PTHR35973:SF1', NULL, NULL, NULL, NULL, 'MAPK-INTERACTING AND SPINDLE-STABILIZING PROTEIN-LIKE', 250460),
(403637, 'PTHR35973:SF2', NULL, NULL, NULL, NULL, 'MAPK-INTERACTING AND SPINDLE-STABILIZING PROTEIN', 250460),
(403638, 'PTHR35973', NULL, NULL, NULL, NULL, 'MAPK-INTERACTING AND SPINDLE-STABILIZING PROTEIN-LIKE', 250460),
(403639, 'PTHR35010', NULL, NULL, NULL, NULL, 'BLL4672 PROTEIN-RELATED', 250461),
(403640, 'PTHR35010:SF3', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN-RELATED', 250461),
(403641, 'PTHR35010:SF2', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN-RELATED', 250461),
(403642, 'PTHR35010:SF4', NULL, NULL, NULL, NULL, 'BLL5781 PROTEIN', 250461),
(403643, 'PTHR21022:SF39', NULL, NULL, NULL, NULL, 'AROGENATE DEHYDRATASE/PREPHENATE DEHYDRATASE 6, CHLOROPLASTIC', 250462),
(403644, 'PTHR21022:SF28', NULL, NULL, NULL, NULL, 'AROGENATE DEHYDRATASE', 250462),
(403645, 'PTHR21022:SF17', NULL, NULL, NULL, NULL, 'OS10G0523700 PROTEIN', 250462),
(403646, 'PTHR21022:SF29', NULL, NULL, NULL, NULL, 'AROGENATE DEHYDRATASE', 250462),
(403647, 'PTHR21022:SF19', NULL, NULL, NULL, NULL, 'PREPHENATE DEHYDRATASE-RELATED', 250462),
(403648, 'PTHR21022', NULL, NULL, NULL, NULL, 'PREPHENATE DEHYDRATASE  P PROTEIN', 250462),
(403649, 'PTHR21022:SF40', NULL, NULL, NULL, NULL, 'OS08G0411000 PROTEIN', 250462),
(403650, 'PTHR21022:SF30', NULL, NULL, NULL, NULL, 'AROGENATE DEHYDRATASE', 250462),
(403651, 'PTHR21022:SF31', NULL, NULL, NULL, NULL, 'AROGENATE DEHYDRATASE', 250462),
(403652, 'PTHR21022:SF20', NULL, NULL, NULL, NULL, 'AROGENATE DEHYDRATASE/PREPHENATE DEHYDRATASE 1, CHLOROPLASTIC', 250462);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(403653, 'PTHR21022:SF32', NULL, NULL, NULL, NULL, 'AROGENATE DEHYDRATASE', 250462),
(403654, 'PTHR21022:SF21', NULL, NULL, NULL, NULL, 'AROGENATE DEHYDRATASE 5, CHLOROPLASTIC', 250462),
(403655, 'PTHR21022:SF33', NULL, NULL, NULL, NULL, 'AROGENATE DEHYDRATASE', 250462),
(403656, 'PTHR21022:SF12', NULL, NULL, NULL, NULL, 'AROGENATE DEHYDRATASE', 250462),
(403657, 'PTHR21022:SF35', NULL, NULL, NULL, NULL, 'AROGENATE DEHYDRATASE 3, CHLOROPLASTIC', 250462),
(403658, 'PTHR21022:SF36', NULL, NULL, NULL, NULL, 'AROGENATE DEHYDRATASE', 250462),
(403659, 'PTHR21022:SF25', NULL, NULL, NULL, NULL, 'AROGENATE DEHYDRATASE 4, CHLOROPLASTIC', 250462),
(403660, 'PTHR21022:SF26', NULL, NULL, NULL, NULL, 'AROGENATE DEHYDRATASE/PREPHENATE DEHYDRATASE 2, CHLOROPLASTIC-LIKE', 250462),
(403661, 'PTHR21022:SF38', NULL, NULL, NULL, NULL, 'AROGENATE DEHYDRATASE', 250462),
(403662, 'PTHR21022:SF27', NULL, NULL, NULL, NULL, 'AROGENATE DEHYDRATASE', 250462),
(403663, 'PTHR24136:SF18', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX PROTEIN 5', 250463),
(403664, 'PTHR24136', NULL, NULL, NULL, NULL, 'SOWAH (DROSOPHILA) HOMOLOG', 250463),
(403665, 'PTHR24136:SF45', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250463),
(403666, 'PTHR24136:SF14', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX PROTEIN 11', 250463),
(403667, 'PTHR24136:SF36', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250463),
(403668, 'PTHR24136:SF47', NULL, NULL, NULL, NULL, 'OS05G0124800 PROTEIN', 250463),
(403669, 'PTHR24136:SF15', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250463),
(403670, 'PTHR24136:SF37', NULL, NULL, NULL, NULL, 'OS01G0942900 PROTEIN', 250463),
(403671, 'PTHR24136:SF48', NULL, NULL, NULL, NULL, 'TANKYRASE-LIKE', 250463),
(403672, 'PTHR24136:SF49', NULL, NULL, NULL, NULL, 'OS05G0124600 PROTEIN', 250463),
(403673, 'PTHR24136:SF17', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX PROTEIN 9', 250463),
(403674, 'PTHR24136:SF39', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250463),
(403675, 'PTHR24136:SF50', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250463),
(403676, 'PTHR24136:SF40', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 250463),
(403677, 'PTHR24136:SF51', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250463),
(403678, 'PTHR24136:SF41', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250463),
(403679, 'PTHR24136:SF52', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX CONTAINING PROTEIN A', 250463),
(403680, 'PTHR24136:SF20', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250463),
(403681, 'PTHR24136:SF31', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX CONTAINING 13', 250463),
(403682, 'PTHR34590:SF10', NULL, NULL, NULL, NULL, 'MALECTIN_LIKE DOMAIN-CONTAINING PROTEIN', 250464),
(403683, 'PTHR34590:SF6', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE', 250464),
(403684, 'PTHR34590:SF5', NULL, NULL, NULL, NULL, 'OS04G0586500 PROTEIN', 250464),
(403685, 'PTHR34590', NULL, NULL, NULL, NULL, 'OS03G0124300 PROTEIN-RELATED', 250464),
(403686, 'PTHR34590:SF9', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 250464),
(403687, 'PTHR34590:SF14', NULL, NULL, NULL, NULL, 'MALECTIN_LIKE DOMAIN-CONTAINING PROTEIN', 250464),
(403688, 'PTHR34590:SF13', NULL, NULL, NULL, NULL, 'MALECTIN_LIKE DOMAIN-CONTAINING PROTEIN', 250464),
(403689, 'PTHR34590:SF12', NULL, NULL, NULL, NULL, 'CARBOHYDRATE-BINDING PROTEIN OF THE ER PROTEIN', 250464),
(403690, 'PTHR34590:SF11', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250464),
(403691, 'PTHR33077:SF43', NULL, NULL, NULL, NULL, 'PROTEIN TIFY 11B', 250465),
(403692, 'PTHR33077:SF87', NULL, NULL, NULL, NULL, 'TIFY DOMAIN, CO/COL/TOC1, CONSERVED SITE-RELATED', 250465),
(403693, 'PTHR33077:SF140', NULL, NULL, NULL, NULL, 'PROTEIN TIFY 10A', 250465),
(403694, 'PTHR33077:SF85', NULL, NULL, NULL, NULL, 'PROTEIN TIFY 6A', 250465),
(403695, 'PTHR33077:SF42', NULL, NULL, NULL, NULL, 'PROTEIN TIFY 4A-RELATED', 250465);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(403696, 'PTHR33077:SF141', NULL, NULL, NULL, NULL, 'TIFY DOMAIN-CONTAINING PROTEIN', 250465),
(403697, 'PTHR33077:SF47', NULL, NULL, NULL, NULL, 'PROTEIN TIFY 11D', 250465),
(403698, 'PTHR33077:SF142', NULL, NULL, NULL, NULL, 'PROTEIN TIFY 6B-LIKE ISOFORM X1', 250465),
(403699, 'PTHR33077:SF48', NULL, NULL, NULL, NULL, '', 250465),
(403700, 'PTHR33077:SF100', NULL, NULL, NULL, NULL, 'PROTEIN TIFY 10B-LIKE ISOFORM X1', 250465),
(403701, 'PTHR33077:SF46', NULL, NULL, NULL, NULL, 'TIFY DOMAIN-CONTAINING PROTEIN', 250465),
(403702, 'PTHR33077:SF102', NULL, NULL, NULL, NULL, 'PROTEIN TIFY 3-LIKE', 250465),
(403703, 'PTHR33077:SF105', NULL, NULL, NULL, NULL, 'TIFY DOMAIN-CONTAINING PROTEIN', 250465),
(403704, 'PTHR33077:SF81', NULL, NULL, NULL, NULL, 'TIFY DOMAIN-CONTAINING PROTEIN', 250465),
(403705, 'PTHR33077:SF82', NULL, NULL, NULL, NULL, 'TIFY DOMAIN, CO/COL/TOC1, CONSERVED SITE-RELATED', 250465),
(403706, 'PTHR33077:SF109', NULL, NULL, NULL, NULL, 'TIFY DOMAIN-CONTAINING PROTEIN', 250465),
(403707, 'PTHR33077:SF5', NULL, NULL, NULL, NULL, 'PROTEIN TIFY 9', 250465),
(403708, 'PTHR33077:SF8', NULL, NULL, NULL, NULL, 'PROTEIN TIFY 8', 250465),
(403709, 'PTHR33077:SF49', NULL, NULL, NULL, NULL, 'PROTEIN TIFY 9', 250465),
(403710, 'PTHR33077:SF74', NULL, NULL, NULL, NULL, 'PROTEIN JAZ7', 250465),
(403711, 'PTHR33077:SF130', NULL, NULL, NULL, NULL, 'TIFY DOMAIN-CONTAINING PROTEIN', 250465),
(403712, 'PTHR33077:SF131', NULL, NULL, NULL, NULL, 'TIFY DOMAIN-CONTAINING PROTEIN', 250465),
(403713, 'PTHR33077:SF132', NULL, NULL, NULL, NULL, 'PROTEIN TIFY 10A-LIKE', 250465),
(403714, 'PTHR33077:SF133', NULL, NULL, NULL, NULL, 'JASMONATE ZIM-DOMAIN PROTEIN', 250465),
(403715, 'PTHR33077:SF134', NULL, NULL, NULL, NULL, 'TIFY DOMAIN-CONTAINING PROTEIN', 250465),
(403716, 'PTHR33077:SF135', NULL, NULL, NULL, NULL, 'PROTEIN TIFY 10A', 250465),
(403717, 'PTHR33077:SF136', NULL, NULL, NULL, NULL, 'TIFY DOMAIN-CONTAINING PROTEIN', 250465),
(403718, 'PTHR33077:SF137', NULL, NULL, NULL, NULL, 'TIFY DOMAIN-CONTAINING PROTEIN', 250465),
(403719, 'PTHR33077:SF138', NULL, NULL, NULL, NULL, 'TIFY DOMAIN-CONTAINING PROTEIN', 250465),
(403720, 'PTHR33077:SF139', NULL, NULL, NULL, NULL, 'JASMONATE ZIM-DOMAIN PROTEIN', 250465),
(403721, 'PTHR33077:SF73', NULL, NULL, NULL, NULL, 'PROTEIN TIFY 11C', 250465),
(403722, 'PTHR33077:SF70', NULL, NULL, NULL, NULL, 'PROTEIN TIFY 5A', 250465),
(403723, 'PTHR33077', NULL, NULL, NULL, NULL, 'PROTEIN TIFY 4A-RELATED-RELATED', 250465),
(403724, 'PTHR33077:SF65', NULL, NULL, NULL, NULL, 'PROTEIN JAZ13', 250465),
(403725, 'PTHR33077:SF66', NULL, NULL, NULL, NULL, 'TIFY DOMAIN, CO/COL/TOC1, CONSERVED SITE-RELATED', 250465),
(403726, 'PTHR33077:SF64', NULL, NULL, NULL, NULL, 'TIFY DOMAIN-CONTAINING PROTEIN', 250465),
(403727, 'PTHR33077:SF121', NULL, NULL, NULL, NULL, 'TIFY10', 250465),
(403728, 'PTHR33077:SF67', NULL, NULL, NULL, NULL, 'DIVERGENT CCT MOTIF PROTEIN', 250465),
(403729, 'PTHR33077:SF123', NULL, NULL, NULL, NULL, 'TIFY DOMAIN-CONTAINING PROTEIN', 250465),
(403730, 'PTHR33077:SF68', NULL, NULL, NULL, NULL, 'PROTEIN TIFY 11B', 250465),
(403731, 'PTHR33077:SF124', NULL, NULL, NULL, NULL, 'TIFY9', 250465),
(403732, 'PTHR33077:SF125', NULL, NULL, NULL, NULL, 'PROTEIN TIFY 6A-RELATED', 250465),
(403733, 'PTHR33077:SF128', NULL, NULL, NULL, NULL, 'PROTEIN TIFY 4B-LIKE ISOFORM X1', 250465),
(403734, 'PTHR33077:SF61', NULL, NULL, NULL, NULL, 'PROTEIN TIFY 3A-RELATED', 250465),
(403735, 'PTHR33077:SF129', NULL, NULL, NULL, NULL, 'TIFY DOMAIN-CONTAINING PROTEIN', 250465),
(403736, 'PTHR33077:SF60', NULL, NULL, NULL, NULL, 'PROTEIN TIFY 4B-LIKE ISOFORM X1', 250465),
(403737, 'PTHR33077:SF54', NULL, NULL, NULL, NULL, 'PROTEIN TIFY 10B', 250465),
(403738, 'PTHR33077:SF96', NULL, NULL, NULL, NULL, 'TIFY DOMAIN-CONTAINING PROTEIN', 250465),
(403739, 'PTHR33077:SF52', NULL, NULL, NULL, NULL, 'PROTEIN TIFY 11A', 250465),
(403740, 'PTHR33077:SF53', NULL, NULL, NULL, NULL, 'JASMONATE ZIM-DOMAIN PROTEIN 10', 250465),
(403741, 'PTHR33077:SF97', NULL, NULL, NULL, NULL, 'PROTEIN TIFY 11E', 250465);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(403742, 'PTHR33077:SF15', NULL, NULL, NULL, NULL, 'TIFY DOMAIN-CONTAINING PROTEIN', 250465),
(403743, 'PTHR33077:SF59', NULL, NULL, NULL, NULL, 'PROTEIN TIFY 11A', 250465),
(403744, 'PTHR33077:SF57', NULL, NULL, NULL, NULL, 'DIVERGENT CCT MOTIF PROTEIN', 250465),
(403745, 'PTHR33077:SF90', NULL, NULL, NULL, NULL, 'PROTEIN TIFY 7', 250465),
(403746, 'PTHR33077:SF116', NULL, NULL, NULL, NULL, 'TIFY DOMAIN-CONTAINING PROTEIN', 250465),
(403747, 'PTHR33077:SF117', NULL, NULL, NULL, NULL, 'PROTEIN TIFY 10B', 250465),
(403748, 'PTHR33077:SF50', NULL, NULL, NULL, NULL, 'PROTEIN TIFY 10C', 250465),
(403749, 'PTHR33077:SF92', NULL, NULL, NULL, NULL, 'TIFY DOMAIN-CONTAINING PROTEIN', 250465),
(403750, 'PTHR33077:SF93', NULL, NULL, NULL, NULL, 'TIFY DOMAIN-CONTAINING PROTEIN', 250465),
(403751, 'PTHR33077:SF17', NULL, NULL, NULL, NULL, 'PROTEIN TIFY 5B', 250465),
(403752, 'PTHR12984:SF20', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 250466),
(403753, 'PTHR12984:SF22', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250466),
(403754, 'PTHR12984:SF17', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250466),
(403755, 'PTHR12984:SF16', NULL, NULL, NULL, NULL, 'BLACK MATCH, ISOFORM H', 250466),
(403756, 'PTHR12984:SF18', NULL, NULL, NULL, NULL, 'SCY1-LIKE PROTEIN 2', 250466),
(403757, 'PTHR12984', NULL, NULL, NULL, NULL, 'SCY1-RELATED S/T PROTEIN KINASE-LIKE', 250466),
(403758, 'PTHR12984:SF6', NULL, NULL, NULL, NULL, 'SCY1-LIKE PROTEIN 2', 250466),
(403759, 'PTHR12984:SF15', NULL, NULL, NULL, NULL, 'PROTEIN-ASSOCIATING WITH THE CARBOXYL-TERMINAL DOMAIN OF EZRIN', 250466),
(403760, 'PTHR12984:SF3', NULL, NULL, NULL, NULL, 'N-TERMINAL KINASE-LIKE PROTEIN', 250466),
(403761, 'PTHR15319', NULL, NULL, NULL, NULL, 'TATA BOX-BINDING PROTEIN ASSOCIATED FACTOR RNA POLYMERASE I SUBUNIT C', 250467),
(403762, 'PTHR15319:SF1', NULL, NULL, NULL, NULL, 'TATA BOX-BINDING PROTEIN-ASSOCIATED FACTOR RNA POLYMERASE I SUBUNIT C', 250467),
(403763, 'PTHR46155:SF1', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', 250468),
(403764, 'PTHR46155', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', 250468),
(403765, 'PTHR37207:SF1', NULL, NULL, NULL, NULL, 'OS09G0446000 PROTEIN', 250469),
(403766, 'PTHR37207:SF2', NULL, NULL, NULL, NULL, 'BNAA09G43730D PROTEIN', 250469),
(403767, 'PTHR37207', NULL, NULL, NULL, NULL, 'OS09G0446000 PROTEIN', 250469),
(403768, 'PTHR31769:SF49', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 250470),
(403769, 'PTHR31769:SF46', NULL, NULL, NULL, NULL, '', 250470),
(403770, 'PTHR31769:SF47', NULL, NULL, NULL, NULL, '', 250470),
(403771, 'PTHR31769:SF97', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 250470),
(403772, 'PTHR31769:SF53', NULL, NULL, NULL, NULL, 'OS02G0608000 PROTEIN', 250470),
(403773, 'PTHR31769:SF96', NULL, NULL, NULL, NULL, '', 250470),
(403774, 'PTHR31769:SF52', NULL, NULL, NULL, NULL, 'BNAA06G01750D PROTEIN', 250470),
(403775, 'PTHR31769:SF99', NULL, NULL, NULL, NULL, '', 250470),
(403776, 'PTHR31769:SF54', NULL, NULL, NULL, NULL, 'OS07G0545100 PROTEIN', 250470),
(403777, 'PTHR31769:SF98', NULL, NULL, NULL, NULL, '', 250470),
(403778, 'PTHR31769:SF93', NULL, NULL, NULL, NULL, '', 250470),
(403779, 'PTHR31769:SF92', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 250470),
(403780, 'PTHR31769:SF95', NULL, NULL, NULL, NULL, '', 250470),
(403781, 'PTHR31769:SF50', NULL, NULL, NULL, NULL, '', 250470),
(403782, 'PTHR31769', NULL, NULL, NULL, NULL, 'OS07G0462200 PROTEIN-RELATED', 250470),
(403783, 'PTHR31769:SF90', NULL, NULL, NULL, NULL, 'FIBER PROTEIN FB34', 250470),
(403784, 'PTHR31769:SF17', NULL, NULL, NULL, NULL, '', 250470),
(403785, 'PTHR31769:SF16', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCAN SYNTHASE COMPONENT (DUF1218)', 250470),
(403786, 'PTHR31769:SF19', NULL, NULL, NULL, NULL, '', 250470),
(403787, 'PTHR31769:SF57', NULL, NULL, NULL, NULL, '', 250470),
(403788, 'PTHR31769:SF59', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF1218)-RELATED', 250470); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(403789, 'PTHR31769:SF14', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 250470),
(403790, 'PTHR31769:SF64', NULL, NULL, NULL, NULL, 'OS04G0678200 PROTEIN', 250470),
(403791, 'PTHR31769:SF9', NULL, NULL, NULL, NULL, 'OS05G0121000 PROTEIN', 250470),
(403792, 'PTHR31769:SF63', NULL, NULL, NULL, NULL, 'AEROBIC COPROPORPHYRINOGEN-III OXIDASE (DUF1218)', 250470),
(403793, 'PTHR31769:SF65', NULL, NULL, NULL, NULL, 'PROTEIN MODIFYING WALL LIGNIN-2', 250470),
(403794, 'PTHR31769:SF7', NULL, NULL, NULL, NULL, 'OS07G0462200 PROTEIN', 250470),
(403795, 'PTHR31769:SF60', NULL, NULL, NULL, NULL, 'PROTEIN FB34, PUTATIVE, EXPRESSED-RELATED', 250470),
(403796, 'PTHR31769:SF62', NULL, NULL, NULL, NULL, '', 250470),
(403797, 'PTHR31769:SF61', NULL, NULL, NULL, NULL, '', 250470),
(403798, 'PTHR31769:SF2', NULL, NULL, NULL, NULL, 'OS01G0253400 PROTEIN', 250470),
(403799, 'PTHR31769:SF6', NULL, NULL, NULL, NULL, 'PROTEIN MODIFYING WALL LIGNIN-1', 250470),
(403800, 'PTHR31769:SF5', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250470),
(403801, 'PTHR31769:SF100', NULL, NULL, NULL, NULL, '', 250470),
(403802, 'PTHR31769:SF101', NULL, NULL, NULL, NULL, '', 250470),
(403803, 'PTHR31769:SF102', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 250470),
(403804, 'PTHR31769:SF103', NULL, NULL, NULL, NULL, 'OS05G0465400 PROTEIN', 250470),
(403805, 'PTHR31769:SF67', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF1218)-RELATED', 250470),
(403806, 'PTHR31769:SF104', NULL, NULL, NULL, NULL, 'BNAC01G19620D PROTEIN', 250470),
(403807, 'PTHR31769:SF69', NULL, NULL, NULL, NULL, '', 250470),
(403808, 'PTHR31769:SF105', NULL, NULL, NULL, NULL, '', 250470),
(403809, 'PTHR31769:SF74', NULL, NULL, NULL, NULL, 'BNAC06G05950D PROTEIN', 250470),
(403810, 'PTHR31769:SF77', NULL, NULL, NULL, NULL, '', 250470),
(403811, 'PTHR31769:SF70', NULL, NULL, NULL, NULL, '', 250470),
(403812, 'PTHR31769:SF73', NULL, NULL, NULL, NULL, '', 250470),
(403813, 'PTHR31769:SF72', NULL, NULL, NULL, NULL, '', 250470),
(403814, 'PTHR31769:SF38', NULL, NULL, NULL, NULL, 'OS05G0434600 PROTEIN', 250470),
(403815, 'PTHR31769:SF79', NULL, NULL, NULL, NULL, '', 250470),
(403816, 'PTHR31769:SF78', NULL, NULL, NULL, NULL, 'BNAC03G71930D PROTEIN', 250470),
(403817, 'PTHR31769:SF42', NULL, NULL, NULL, NULL, 'INOSITOL-DEACYLASE C, PUTATIVE (DUF1218)-RELATED', 250470),
(403818, 'PTHR31769:SF86', NULL, NULL, NULL, NULL, 'BNAA03G48600D PROTEIN', 250470),
(403819, 'PTHR31769:SF85', NULL, NULL, NULL, NULL, 'BNAC08G42060D PROTEIN', 250470),
(403820, 'PTHR31769:SF88', NULL, NULL, NULL, NULL, '', 250470),
(403821, 'PTHR31769:SF87', NULL, NULL, NULL, NULL, '', 250470),
(403822, 'PTHR31769:SF43', NULL, NULL, NULL, NULL, 'OS05G0435300 PROTEIN', 250470),
(403823, 'PTHR31769:SF82', NULL, NULL, NULL, NULL, 'BNAC03G77320D PROTEIN', 250470),
(403824, 'PTHR31769:SF81', NULL, NULL, NULL, NULL, 'BNAA01G36070D PROTEIN', 250470),
(403825, 'PTHR31769:SF84', NULL, NULL, NULL, NULL, '', 250470),
(403826, 'PTHR31769:SF80', NULL, NULL, NULL, NULL, 'BNAC09G40750D PROTEIN', 250470),
(403827, 'PTHR47775:SF1', NULL, NULL, NULL, NULL, 'BUD SITE SELECTION PROTEIN 14', 250471),
(403828, 'PTHR47775', NULL, NULL, NULL, NULL, 'BUD SITE SELECTION PROTEIN 14', 250471),
(403829, 'PTHR33053:SF9', NULL, NULL, NULL, NULL, 'AGAP000105-PA', 250472),
(403830, 'PTHR33053:SF24', NULL, NULL, NULL, NULL, '', 250472),
(403831, 'PTHR33053:SF25', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 250472),
(403832, 'PTHR33053', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 250472),
(403833, 'PTHR36898:SF1', NULL, NULL, NULL, NULL, 'OS04G0250700 PROTEIN', 250473),
(403834, 'PTHR36898', NULL, NULL, NULL, NULL, 'OSJNBB0026I12.6 PROTEIN', 250473),
(403835, 'PTHR14360', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 250474),
(403836, 'PTHR14360:SF20', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 90-LIKE PROTEIN-RELATED', 250474),
(403837, 'PTHR14360:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FMP32, MITOCHONDRIAL', 250474),
(403838, 'PTHR14360:SF16', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 90B, MITOCHONDRIAL-LIKE ISOFORM X1', 250474);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(403839, 'PTHR14360:SF26', NULL, NULL, NULL, NULL, '', 250474),
(403840, 'PTHR14360:SF15', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 90B, MITOCHONDRIAL-LIKE ISOFORM X1', 250474),
(403841, 'PTHR14360:SF14', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 90B, MITOCHONDRIAL', 250474),
(403842, 'PTHR14360:SF25', NULL, NULL, NULL, NULL, 'FMP32-LIKE PROTEIN', 250474),
(403843, 'PTHR14360:SF13', NULL, NULL, NULL, NULL, '', 250474),
(403844, 'PTHR14360:SF12', NULL, NULL, NULL, NULL, 'FUNGAL PROTEIN', 250474),
(403845, 'PTHR14360:SF23', NULL, NULL, NULL, NULL, 'BNAA01G19640D PROTEIN', 250474),
(403846, 'PTHR14360:SF11', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CALCIUM UNIPORTER REGULATOR 1', 250474),
(403847, 'PTHR14360:SF19', NULL, NULL, NULL, NULL, 'PROTEIN FMP32, MITOCHONDRIAL-LIKE', 250474),
(403848, 'PTHR14360:SF18', NULL, NULL, NULL, NULL, 'COILED-COIL 90B-LIKE PROTEIN (DUF1640)', 250474),
(403849, 'PTHR10687:SF2', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN', 250475),
(403850, 'PTHR10687:SF70', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN', 250475),
(403851, 'PTHR10687:SF91', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN 4', 250475),
(403852, 'PTHR10687:SF90', NULL, NULL, NULL, NULL, 'CHROMOSOME 8, WHOLE GENOME SHOTGUN SEQUENCE', 250475),
(403853, 'PTHR10687:SF68', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN', 250475),
(403854, 'PTHR10687:SF89', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN', 250475),
(403855, 'PTHR10687:SF88', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN', 250475),
(403856, 'PTHR10687:SF66', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN', 250475),
(403857, 'PTHR10687:SF87', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN', 250475),
(403858, 'PTHR10687:SF20', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN', 250475),
(403859, 'PTHR10687', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN  SCAMP', 250475),
(403860, 'PTHR10687:SF64', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN', 250475),
(403861, 'PTHR10687:SF86', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN', 250475),
(403862, 'PTHR10687:SF85', NULL, NULL, NULL, NULL, '', 250475),
(403863, 'PTHR10687:SF63', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN', 250475),
(403864, 'PTHR10687:SF84', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN', 250475),
(403865, 'PTHR10687:SF62', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN', 250475),
(403866, 'PTHR10687:SF83', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN', 250475),
(403867, 'PTHR10687:SF61', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN 5', 250475),
(403868, 'PTHR10687:SF6', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN 3', 250475),
(403869, 'PTHR10687:SF5', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN 5', 250475),
(403870, 'PTHR10687:SF8', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN 1', 250475),
(403871, 'PTHR10687:SF7', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN 2', 250475),
(403872, 'PTHR10687:SF47', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN 3', 250475),
(403873, 'PTHR10687:SF82', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN-RELATED', 250475),
(403874, 'PTHR10687:SF81', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN', 250475),
(403875, 'PTHR10687:SF80', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN', 250475),
(403876, 'PTHR10687:SF79', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN 5', 250475),
(403877, 'PTHR10687:SF57', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN', 250475);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(403878, 'PTHR10687:SF56', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN 2', 250475),
(403879, 'PTHR10687:SF11', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN 4', 250475),
(403880, 'PTHR10687:SF77', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN 3', 250475),
(403881, 'PTHR10687:SF76', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN 1', 250475),
(403882, 'PTHR10687:SF54', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN', 250475),
(403883, 'PTHR10687:SF75', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN 5', 250475),
(403884, 'PTHR10687:SF74', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN 1', 250475),
(403885, 'PTHR10687:SF51', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN', 250475),
(403886, 'PTHR10687:SF58', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN', 250475),
(403887, 'PTHR23162', NULL, NULL, NULL, NULL, 'OUTER DENSE FIBER OF SPERM TAILS 2', 250476),
(403888, 'PTHR23162:SF8', NULL, NULL, NULL, NULL, 'OUTER DENSE FIBER PROTEIN 2', 250476),
(403889, 'PTHR23162:SF7', NULL, NULL, NULL, NULL, 'PROTEIN BCAP', 250476),
(403890, 'PTHR23162:SF10', NULL, NULL, NULL, NULL, 'FI13205P', 250476),
(403891, 'PTHR47496', NULL, NULL, NULL, NULL, 'CD27', 250477),
(403892, 'PTHR47496:SF1', NULL, NULL, NULL, NULL, 'CD27 ANTIGEN', 250477),
(403893, 'PTHR24238:SF41', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 250478),
(403894, 'PTHR24238:SF63', NULL, NULL, NULL, NULL, 'OREXIN RECEPTOR TYPE 2-LIKE PROTEIN', 250478),
(403895, 'PTHR24238:SF71', NULL, NULL, NULL, NULL, 'TACHYKININ-LIKE PEPTIDES RECEPTOR 99D', 250478),
(403896, 'PTHR24238:SF60', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 250478),
(403897, 'PTHR24238:SF66', NULL, NULL, NULL, NULL, 'TACHYKININ-LIKE PEPTIDES RECEPTOR 86C', 250478),
(403898, 'PTHR24238:SF44', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 250478),
(403899, 'PTHR24238:SF55', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 250478),
(403900, 'PTHR24238:SF20', NULL, NULL, NULL, NULL, 'PROTEIN CBG23244', 250478),
(403901, 'PTHR24238:SF26', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 250478),
(403902, 'PTHR24238:SF69', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 165', 250478),
(403903, 'PTHR24238:SF58', NULL, NULL, NULL, NULL, 'FI22604P1', 250478),
(403904, 'PTHR24238:SF47', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 83-RELATED', 250478),
(403905, 'PTHR24238:SF46', NULL, NULL, NULL, NULL, 'CHOLECYSTOKININ-2 RECEPTOR', 250478),
(403906, 'PTHR24238', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR', 250478),
(403907, 'PTHR24238:SF57', NULL, NULL, NULL, NULL, 'CHOLECYSTOKININ-2 RECEPTOR-RELATED', 250478),
(403908, 'PTHR24238:SF70', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 250478),
(403909, 'PTHR37319', NULL, NULL, NULL, NULL, 'TRANSPOSASE', 250479),
(403910, 'PTHR37319:SF1', NULL, NULL, NULL, NULL, 'DIMER_TNP_TN5 DOMAIN-CONTAINING PROTEIN', 250479),
(403911, 'PTHR44013:SF3', NULL, NULL, NULL, NULL, 'OS09G0503100 PROTEIN', 250480),
(403912, 'PTHR44013:SF16', NULL, NULL, NULL, NULL, 'ZINC-BINDING DEHYDROGENASE FAMILY OXIDOREDUCTASE', 250480),
(403913, 'PTHR44013:SF15', NULL, NULL, NULL, NULL, 'NADPH:QUINONE REDUCTASE-RELATED', 250480),
(403914, 'PTHR44013:SF2', NULL, NULL, NULL, NULL, 'OS09G0502500 PROTEIN', 250480),
(403915, 'PTHR44013:SF14', NULL, NULL, NULL, NULL, 'QUINONE-OXIDOREDUCTASE HOMOLOG, CHLOROPLASTIC-RELATED', 250480),
(403916, 'PTHR44013:SF1', NULL, NULL, NULL, NULL, 'ZINC-TYPE ALCOHOL DEHYDROGENASE-LIKE PROTEIN C16A3.02C', 250480),
(403917, 'PTHR44013:SF13', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 250480),
(403918, 'PTHR44013:SF12', NULL, NULL, NULL, NULL, 'ZINC-TYPE ALCOHOL DEHYDROGENASE-LIKE PROTEIN C16A3.02C-RELATED', 250480),
(403919, 'PTHR44013:SF6', NULL, NULL, NULL, NULL, 'OS04G0359100 PROTEIN', 250480);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(403920, 'PTHR44013:SF11', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 250480),
(403921, 'PTHR44013:SF5', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G01290)-RELATED', 250480),
(403922, 'PTHR44013', NULL, NULL, NULL, NULL, 'ZINC-TYPE ALCOHOL DEHYDROGENASE-LIKE PROTEIN C16A3.02C', 250480),
(403923, 'PTHR21502', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN DZIP1', 250481),
(403924, 'PTHR21502:SF2', NULL, NULL, NULL, NULL, 'RILP-LIKE PROTEIN 2', 250481),
(403925, 'PTHR21502:SF10', NULL, NULL, NULL, NULL, 'RILP-LIKE PROTEIN 1', 250481),
(403926, 'PTHR21502:SF6', NULL, NULL, NULL, NULL, 'RILP-LIKE PROTEIN 1', 250481),
(403927, 'PTHR21502:SF5', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN DZIP1', 250481),
(403928, 'PTHR21502:SF4', NULL, NULL, NULL, NULL, 'RILP (RAB7-INTERACTING LYSOSOMAL PROTEIN) HOMOLOG', 250481),
(403929, 'PTHR21502:SF3', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN DZIP1', 250481),
(403930, 'PTHR21502:SF9', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 250481),
(403931, 'PTHR21502:SF8', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN DZIP1L', 250481),
(403932, 'PTHR21502:SF7', NULL, NULL, NULL, NULL, 'RAB-INTERACTING LYSOSOMAL PROTEIN', 250481),
(403933, 'PTHR34586:SF3', NULL, NULL, NULL, NULL, 'VWFD DOMAIN-CONTAINING PROTEIN', 250482),
(403934, 'PTHR34586:SF8', NULL, NULL, NULL, NULL, 'RANDOM CDNA CLONE VEG114', 250482),
(403935, 'PTHR34586', NULL, NULL, NULL, NULL, 'SPERACT/SCAVENGER RECEPTOR DOMAIN-CONTAINING PROTEIN', 250482),
(403936, 'PTHR34586:SF5', NULL, NULL, NULL, NULL, 'PRESPORE VESICLE PROTEIN', 250482),
(403937, 'PTHR11960:SF60', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR ISOFORM 4E-2', 250483),
(403938, 'PTHR11960:SF63', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR 4E, PUTATIVE-RELATED', 250483),
(403939, 'PTHR11960:SF43', NULL, NULL, NULL, NULL, 'MRNA CAP-BINDING PROTEIN', 250483),
(403940, 'PTHR11960:SF65', NULL, NULL, NULL, NULL, '', 250483),
(403941, 'PTHR11960:SF20', NULL, NULL, NULL, NULL, '', 250483),
(403942, 'PTHR11960:SF64', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4E CLASS II 2B', 250483),
(403943, 'PTHR11960:SF45', NULL, NULL, NULL, NULL, 'MRNA CAP-BINDING PROTEIN', 250483),
(403944, 'PTHR11960:SF67', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR ISOFORM 4E', 250483),
(403945, 'PTHR11960:SF44', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4E-2-RELATED', 250483),
(403946, 'PTHR11960:SF66', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4E TYPE 3', 250483),
(403947, 'PTHR11960:SF69', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4E-3', 250483),
(403948, 'PTHR11960:SF47', NULL, NULL, NULL, NULL, 'MRNA CAP-BINDING PROTEIN', 250483),
(403949, 'PTHR11960:SF68', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4E-1', 250483),
(403950, 'PTHR11960:SF46', NULL, NULL, NULL, NULL, 'MRNA CAP-BINDING PROTEIN', 250483),
(403951, 'PTHR11960:SF49', NULL, NULL, NULL, NULL, 'MRNA CAP-BINDING PROTEIN', 250483),
(403952, 'PTHR11960:SF26', NULL, NULL, NULL, NULL, '', 250483),
(403953, 'PTHR11960:SF29', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4E FAMILY MEMBER 1C', 250483),
(403954, 'PTHR11960:SF8', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4E1-RELATED', 250483),
(403955, 'PTHR11960:SF70', NULL, NULL, NULL, NULL, 'MRNA CAP-BINDING PROTEIN', 250483),
(403956, 'PTHR11960:SF50', NULL, NULL, NULL, NULL, 'MRNA CAP-BINDING PROTEIN', 250483),
(403957, 'PTHR11960:SF72', NULL, NULL, NULL, NULL, '', 250483),
(403958, 'PTHR11960:SF71', NULL, NULL, NULL, NULL, '', 250483),
(403959, 'PTHR11960:SF52', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4E FAMILY PROTEIN', 250483),
(403960, 'PTHR11960:SF51', NULL, NULL, NULL, NULL, 'MRNA CAP-BINDING PROTEIN', 250483),
(403961, 'PTHR11960:SF73', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR 4E, PUTATIVE-RELATED', 250483),
(403962, 'PTHR11960:SF34', NULL, NULL, NULL, NULL, '', 250483); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(403963, 'PTHR11960:SF11', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4E-2', 250483),
(403964, 'PTHR11960:SF14', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4E', 250483),
(403965, 'PTHR11960:SF38', NULL, NULL, NULL, NULL, '', 250483),
(403966, 'PTHR11960:SF18', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4E HOMOLOGOUS PROTEIN, ISOFORM B', 250483),
(403967, 'PTHR11960:SF39', NULL, NULL, NULL, NULL, '', 250483),
(403968, 'PTHR11960:SF17', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4E TYPE 2', 250483),
(403969, 'PTHR11960', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4E RELATED', 250483),
(403970, 'PTHR11960:SF3', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4E TYPE 1B', 250483),
(403971, 'PTHR15354:SF1', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 41', 250484),
(403972, 'PTHR15354', NULL, NULL, NULL, NULL, 'MUF1', 250484),
(403973, 'PTHR48220', NULL, NULL, NULL, NULL, '', 250485),
(403974, 'PTHR48220:SF1', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 62-RELATED', 250485),
(403975, 'PTHR44140:SF3', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 3', 250486),
(403976, 'PTHR44140:SF2', NULL, NULL, NULL, NULL, 'LD25575P', 250486),
(403977, 'PTHR44140:SF4', NULL, NULL, NULL, NULL, 'DNAJ DOMAIN (PROKARYOTIC HEAT SHOCK PROTEIN)', 250486),
(403978, 'PTHR44140:SF1', NULL, NULL, NULL, NULL, 'DNAJ (HSP40) HOMOLOG, SUBFAMILY C, MEMBER 3B', 250486),
(403979, 'PTHR44140', NULL, NULL, NULL, NULL, 'LD25575P', 250486),
(403980, 'PTHR21373', NULL, NULL, NULL, NULL, 'GLUCOSE REPRESSIBLE PROTEIN MAK10', 250487),
(403981, 'PTHR21373:SF0', NULL, NULL, NULL, NULL, 'N-ALPHA-ACETYLTRANSFERASE 35, NATC AUXILIARY SUBUNIT', 250487),
(403982, 'PTHR38449', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN TM_1690-RELATED', 250488),
(403983, 'PTHR38449:SF1', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN TM_1690-RELATED', 250488),
(403984, 'PTHR21315', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 250489),
(403985, 'PTHR21315:SF2', NULL, NULL, NULL, NULL, 'APRATAXIN AND PNK-LIKE FACTOR', 250489),
(403986, 'PTHR21315:SF3', NULL, NULL, NULL, NULL, 'POLY [ADP-RIBOSE] POLYMERASE', 250489),
(403987, 'PTHR48248:SF2', NULL, NULL, NULL, NULL, '', 250490),
(403988, 'PTHR48248:SF1', NULL, NULL, NULL, NULL, '', 250490),
(403989, 'PTHR48248:SF4', NULL, NULL, NULL, NULL, '', 250490),
(403990, 'PTHR48248:SF3', NULL, NULL, NULL, NULL, '', 250490),
(403991, 'PTHR48248:SF5', NULL, NULL, NULL, NULL, '', 250490),
(403992, 'PTHR48248', NULL, NULL, NULL, NULL, '', 250490),
(403993, 'PTHR33504', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE (UBIQUINONE) 1 BETA SUBCOMPLEX, 4', 250491),
(403994, 'PTHR33504:SF1', NULL, NULL, NULL, NULL, 'FAMILY WITH SEQUENCE SIMILARITY 90, MEMBER A1B', 250491),
(403995, 'PTHR33504:SF2', NULL, NULL, NULL, NULL, 'PROTEIN MFI', 250491),
(403996, 'PTHR14369:SF0', NULL, NULL, NULL, NULL, 'SURFEIT LOCUS PROTEIN 6', 250492),
(403997, 'PTHR14369:SF2', NULL, NULL, NULL, NULL, 'BNAA03G55250D PROTEIN', 250492),
(403998, 'PTHR14369', NULL, NULL, NULL, NULL, 'SURFEIT LOCUS PROTEIN 6', 250492),
(403999, 'PTHR40143', NULL, NULL, NULL, NULL, '', 250493),
(404000, 'PTHR40143:SF1', NULL, NULL, NULL, NULL, '', 250493),
(404001, 'PTHR40434:SF1', NULL, NULL, NULL, NULL, '', 250494),
(404002, 'PTHR40434', NULL, NULL, NULL, NULL, 'CUPIN_2 DOMAIN-CONTAINING PROTEIN', 250494),
(404003, 'PTHR11101:SF52', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER', 250495),
(404004, 'PTHR11101:SF96', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER', 250495),
(404005, 'PTHR11101:SF95', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER', 250495),
(404006, 'PTHR11101:SF61', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER', 250495),
(404007, 'PTHR11101:SF83', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT PHOSPHATE TRANSPORTER 2', 250495),
(404008, 'PTHR11101:SF94', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER', 250495),
(404009, 'PTHR11101:SF93', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER', 250495); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(404010, 'PTHR11101:SF81', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT PHOSPHATE TRANSPORTER 1-A', 250495),
(404011, 'PTHR11101:SF80', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER', 250495),
(404012, 'PTHR11101:SF16', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER', 250495),
(404013, 'PTHR11101:SF49', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER', 250495),
(404014, 'PTHR11101:SF46', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT PHOSPHATE TRANSPORTER 1', 250495),
(404015, 'PTHR11101:SF57', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER', 250495),
(404016, 'PTHR11101:SF89', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER', 250495),
(404017, 'PTHR11101:SF67', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER', 250495),
(404018, 'PTHR11101:SF55', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER', 250495),
(404019, 'PTHR11101:SF54', NULL, NULL, NULL, NULL, 'LOW-AFFINITY INORGANIC PHOSPHATE TRANSPORTER-RELATED', 250495),
(404020, 'PTHR11101:SF10', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER', 250495),
(404021, 'PTHR11101:SF65', NULL, NULL, NULL, NULL, 'LOW-AFFINITY INORGANIC PHOSPHATE TRANSPORTER 1-RELATED', 250495),
(404022, 'PTHR11101', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER', 250495),
(404023, 'PTHR11933', NULL, NULL, NULL, NULL, 'TRNA  5-METHYLAMINOMETHYL-2-THIOURIDYLATE -METHYLTRANSFERASE', 250496),
(404024, 'PTHR11933:SF6', NULL, NULL, NULL, NULL, 'THII DOMAIN-CONTAINING PROTEIN', 250496),
(404025, 'PTHR11933:SF5', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL TRNA-SPECIFIC 2-THIOURIDYLASE 1', 250496),
(404026, 'PTHR46201:SF3', NULL, NULL, NULL, NULL, 'OS01G0877500 PROTEIN', 250497),
(404027, 'PTHR46201:SF5', NULL, NULL, NULL, NULL, 'OS11G0234200 PROTEIN', 250497),
(404028, 'PTHR46201:SF10', NULL, NULL, NULL, NULL, 'PHD DOMAIN-CONTAINING PROTEIN', 250497),
(404029, 'PTHR46201:SF7', NULL, NULL, NULL, NULL, 'PHD DOMAIN-CONTAINING PROTEIN', 250497),
(404030, 'PTHR46201:SF6', NULL, NULL, NULL, NULL, 'PHD FINGER PLANT-LIKE PROTEIN', 250497),
(404031, 'PTHR46201:SF9', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN MALE MEIOCYTE DEATH 1', 250497),
(404032, 'PTHR46201:SF8', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 250497),
(404033, 'PTHR46201', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN MALE MEIOCYTE DEATH 1-RELATED', 250497),
(404034, 'PTHR46201:SF1', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN MALE STERILITY 1', 250497),
(404035, 'PTHR16716', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 7B, MITOCHONDRIAL', 250498),
(404036, 'PTHR16716:SF2', NULL, NULL, NULL, NULL, '', 250498),
(404037, 'PTHR16716:SF0', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 7B, MITOCHONDRIAL', 250498),
(404038, 'PTHR16716:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 7B2, MITOCHONDRIAL', 250498),
(404039, 'PTHR47825', NULL, NULL, NULL, NULL, 'AAA_23 DOMAIN-CONTAINING PROTEIN', 250499),
(404040, 'PTHR47825:SF1', NULL, NULL, NULL, NULL, 'AAA_23 DOMAIN-CONTAINING PROTEIN-RELATED', 250499),
(404041, 'PTHR23345:SF33', NULL, NULL, NULL, NULL, 'CROSSVEINLESS D', 250500),
(404042, 'PTHR23345:SF12', NULL, NULL, NULL, NULL, 'VITELLOGENIN-1-RELATED', 250500),
(404043, 'PTHR23345:SF36', NULL, NULL, NULL, NULL, 'APOLIPOPHORINS', 250500),
(404044, 'PTHR23345:SF15', NULL, NULL, NULL, NULL, 'PHOSVITIN-RELATED', 250500),
(404045, 'PTHR23345:SF29', NULL, NULL, NULL, NULL, 'PHOSVITIN', 250500),
(404046, 'PTHR23345', NULL, NULL, NULL, NULL, 'VITELLOGENIN-RELATED', 250500),
(404047, 'PTHR23345:SF8', NULL, NULL, NULL, NULL, 'VITELLOGENIN-3-RELATED', 250500),
(404048, 'PTHR23345:SF9', NULL, NULL, NULL, NULL, 'PHOSVITIN', 250500),
(404049, 'PTHR44813', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE-BINDING PROTEIN 1', 250501),
(404050, 'PTHR44813:SF1', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE-BINDING PROTEIN 1', 250501),
(404051, 'PTHR24188:SF29', NULL, NULL, NULL, NULL, 'GH09064P', 250502),
(404052, 'PTHR24188', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT PROTEIN', 250502),
(404053, 'PTHR10052:SF47', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L18A', 250503),
(404054, 'PTHR10052:SF49', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L18A-2', 250503);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(404055, 'PTHR10052:SF55', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L18A', 250503),
(404056, 'PTHR10052:SF44', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L18A DOMAIN-CONTAINING PROTEIN', 250503),
(404057, 'PTHR10052:SF33', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L18A', 250503),
(404058, 'PTHR10052:SF46', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L18A', 250503),
(404059, 'PTHR10052:SF1', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L18A', 250503),
(404060, 'PTHR10052:SF45', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 DOMAIN-CONTAINING PROTEIN', 250503),
(404061, 'PTHR10052', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L18A', 250503),
(404062, 'PTHR10052:SF40', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L18A', 250503),
(404063, 'PTHR10052:SF50', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L18A', 250503),
(404064, 'PTHR10052:SF42', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L18A', 250503),
(404065, 'PTHR10052:SF52', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L18A DOMAIN-CONTAINING PROTEIN', 250503),
(404066, 'PTHR31403:SF37', NULL, NULL, NULL, NULL, 'GLYCEROLIPASE A1', 250504),
(404067, 'PTHR31403:SF59', NULL, NULL, NULL, NULL, 'BNAA05G35290D PROTEIN', 250504),
(404068, 'PTHR31403:SF58', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1 EG1, CHLOROPLASTIC/MITOCHONDRIAL', 250504),
(404069, 'PTHR31403:SF57', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 250504),
(404070, 'PTHR31403:SF35', NULL, NULL, NULL, NULL, 'GALACTOLIPASE DONGLE CHLOROPLASTIC', 250504),
(404071, 'PTHR31403:SF13', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 250504),
(404072, 'PTHR31403:SF56', NULL, NULL, NULL, NULL, 'GALACTOLIPASE DONGLE, CHLOROPLASTIC', 250504),
(404073, 'PTHR31403:SF11', NULL, NULL, NULL, NULL, 'OS12G0614500 PROTEIN', 250504),
(404074, 'PTHR31403:SF54', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A(1) DAD1, CHLOROPLASTIC', 250504),
(404075, 'PTHR31403:SF53', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1-IGAMMA2, CHLOROPLASTIC-LIKE', 250504),
(404076, 'PTHR31403:SF31', NULL, NULL, NULL, NULL, 'DAD-1', 250504),
(404077, 'PTHR31403:SF39', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1-IGAMMA1 CHLOROPLASTIC', 250504),
(404078, 'PTHR31403', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1-IBETA2, CHLOROPLASTIC', 250504),
(404079, 'PTHR31403:SF63', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1-IBETA2, CHLOROPLASTIC-LIKE', 250504),
(404080, 'PTHR31403:SF62', NULL, NULL, NULL, NULL, 'ALPHA/BETA HYDROLASE FOLD PROTEIN-RELATED', 250504),
(404081, 'PTHR31403:SF47', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1-IBETA2, CHLOROPLASTIC-LIKE', 250504),
(404082, 'PTHR31403:SF46', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A(1) DAD1, CHLOROPLASTIC-LIKE', 250504),
(404083, 'PTHR31403:SF66', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN-RELATED', 250504),
(404084, 'PTHR31403:SF44', NULL, NULL, NULL, NULL, 'GALACTOLIPASE DONGLE, CHLOROPLASTIC-LIKE', 250504),
(404085, 'PTHR31403:SF43', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1-IGAMMA1, CHLOROPLASTIC', 250504),
(404086, 'PTHR31403:SF65', NULL, NULL, NULL, NULL, 'OS08G0143600 PROTEIN', 250504),
(404087, 'PTHR31403:SF64', NULL, NULL, NULL, NULL, 'CLASS 3 FAMILY PROTEIN, PUTATIVE-RELATED', 250504),
(404088, 'PTHR31403:SF8', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A(1) DAD1, CHLOROPLASTIC-LIKE', 250504),
(404089, 'PTHR31403:SF7', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1-IGAMMA3, CHLOROPLASTIC', 250504),
(404090, 'PTHR31403:SF4', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1-IALPHA2, CHLOROPLASTIC', 250504),
(404091, 'PTHR31403:SF2', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1-IBETA2, CHLOROPLASTIC', 250504),
(404092, 'PTHR31403:SF52', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 250504),
(404093, 'PTHR31403:SF51', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1-IGAMMA2, CHLOROPLASTIC', 250504),
(404094, 'PTHR31403:SF50', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1-IGAMMA1 CHLOROPLASTIC', 250504),
(404095, 'PTHR15218:SF0', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 96', 250505),
(404096, 'PTHR15218', NULL, NULL, NULL, NULL, 'MD-1, MD-2 - RELATED', 250505);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(404097, 'PTHR31808:SF9', NULL, NULL, NULL, NULL, 'F21O3.2 PROTEIN', 250506),
(404098, 'PTHR31808:SF14', NULL, NULL, NULL, NULL, '', 250506),
(404099, 'PTHR31808:SF8', NULL, NULL, NULL, NULL, 'GB|AAF02142.1', 250506),
(404100, 'PTHR31808:SF10', NULL, NULL, NULL, NULL, 'BNAANNG17260D PROTEIN', 250506),
(404101, 'PTHR31808', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250506),
(404102, 'PTHR31808:SF4', NULL, NULL, NULL, NULL, 'LIGASE, PUTATIVE (DUF760)-RELATED', 250506),
(404103, 'PTHR31808:SF11', NULL, NULL, NULL, NULL, '', 250506),
(404104, 'PTHR31808:SF2', NULL, NULL, NULL, NULL, 'OS04G0596300 PROTEIN', 250506),
(404105, 'PTHR31808:SF13', NULL, NULL, NULL, NULL, '', 250506),
(404106, 'PTHR43612:SF3', NULL, NULL, NULL, NULL, 'TRIFUNCTIONAL ENZYME SUBUNIT ALPHA, MITOCHONDRIAL', 250507),
(404107, 'PTHR43612:SF6', NULL, NULL, NULL, NULL, 'ENOYL-COA HYDRATASE', 250507),
(404108, 'PTHR43612', NULL, NULL, NULL, NULL, 'TRIFUNCTIONAL ENZYME SUBUNIT ALPHA', 250507),
(404109, 'PTHR43612:SF5', NULL, NULL, NULL, NULL, 'ENOYL-COA HYDRATASE', 250507),
(404110, 'PTHR43612:SF7', NULL, NULL, NULL, NULL, 'TRIFUNCTIONAL ENZYME SUBUNIT ALPHA, MITOCHONDRIAL', 250507),
(404111, 'PTHR45935:SF14', NULL, NULL, NULL, NULL, 'SCAN BOX DOMAIN-CONTAINING PROTEIN', 250508),
(404112, 'PTHR45935:SF25', NULL, NULL, NULL, NULL, 'SCAN BOX DOMAIN-CONTAINING PROTEIN', 250508),
(404113, 'PTHR45935:SF26', NULL, NULL, NULL, NULL, 'SCAN DOMAIN-CONTAINING PROTEIN SCAND2P-RELATED', 250508),
(404114, 'PTHR45935:SF15', NULL, NULL, NULL, NULL, 'SCAN DOMAIN-CONTAINING PROTEIN 3', 250508),
(404115, 'PTHR45935:SF27', NULL, NULL, NULL, NULL, 'SCAN BOX DOMAIN-CONTAINING PROTEIN', 250508),
(404116, 'PTHR45935:SF21', NULL, NULL, NULL, NULL, '', 250508),
(404117, 'PTHR45935:SF10', NULL, NULL, NULL, NULL, 'SCAN DOMAIN-CONTAINING 1', 250508),
(404118, 'PTHR45935', NULL, NULL, NULL, NULL, 'PROTEIN ZBED8-RELATED', 250508),
(404119, 'PTHR45935:SF22', NULL, NULL, NULL, NULL, 'ZINC FINGER AND SCAN DOMAIN-CONTAINING 18', 250508),
(404120, 'PTHR45935:SF23', NULL, NULL, NULL, NULL, 'SCAN DOMAIN-CONTAINING PROTEIN 1', 250508),
(404121, 'PTHR45935:SF24', NULL, NULL, NULL, NULL, 'SCAN BOX DOMAIN-CONTAINING PROTEIN', 250508),
(404122, 'PTHR45935:SF18', NULL, NULL, NULL, NULL, 'PROTEIN ZBED8', 250508),
(404123, 'PTHR45935:SF9', NULL, NULL, NULL, NULL, 'ZINC FINGER BED DOMAIN-CONTAINING PROTEIN 5', 250508),
(404124, 'PTHR45935:SF1', NULL, NULL, NULL, NULL, 'DUF4371 DOMAIN-CONTAINING PROTEIN', 250508),
(404125, 'PTHR45935:SF20', NULL, NULL, NULL, NULL, 'PROTEIN FAM200A', 250508),
(404126, 'PTHR45935:SF2', NULL, NULL, NULL, NULL, 'KRAB-A DOMAIN-CONTAINING PROTEIN 2', 250508),
(404127, 'PTHR45935:SF6', NULL, NULL, NULL, NULL, 'PROTEIN FAM200B', 250508),
(404128, 'PTHR30501:SF2', NULL, NULL, NULL, NULL, 'UPF0597 PROTEIN YHAM', 250509),
(404129, 'PTHR30501', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 250509),
(404130, 'PTHR48056:SF50', NULL, NULL, NULL, NULL, 'BRASSINOSTEROID LRR RECEPTOR KINASE', 250510),
(404131, 'PTHR48056:SF51', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250510),
(404132, 'PTHR48056:SF52', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250510),
(404133, 'PTHR48056:SF10', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN, PLANT-TYPE-RELATED', 250510),
(404134, 'PTHR48056:SF54', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE ERL1', 250510),
(404135, 'PTHR48056:SF55', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE EFR', 250510),
(404136, 'PTHR48056:SF56', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 250510),
(404137, 'PTHR48056', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE-RELATED', 250510),
(404138, 'PTHR48056:SF13', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250510),
(404139, 'PTHR48056:SF57', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 250510),
(404140, 'PTHR48056:SF58', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR PROTEIN KINASE MSP1-LIKE ISOFORM X1', 250510);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(404141, 'PTHR48056:SF14', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE BRI1-LIKE 2', 250510),
(404142, 'PTHR48056:SF15', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250510),
(404143, 'PTHR48056:SF59', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250510),
(404144, 'PTHR48056:SF17', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR PROTEIN KINASE EMS1', 250510),
(404145, 'PTHR48056:SF18', NULL, NULL, NULL, NULL, 'SYSTEMIN RECEPTOR SR160', 250510),
(404146, 'PTHR48056:SF60', NULL, NULL, NULL, NULL, 'STKQ', 250510),
(404147, 'PTHR48056:SF61', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250510),
(404148, 'PTHR48056:SF62', NULL, NULL, NULL, NULL, 'MDIS1-INTERACTING RECEPTOR LIKE KINASE 2-LIKE', 250510),
(404149, 'PTHR48056:SF63', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250510),
(404150, 'PTHR48056:SF20', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250510),
(404151, 'PTHR48056:SF64', NULL, NULL, NULL, NULL, 'PROMASTIGOTE SURFACE ANTIGEN PROTEIN PSA', 250510),
(404152, 'PTHR48056:SF65', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 250510),
(404153, 'PTHR48056:SF6', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE ERECTA', 250510),
(404154, 'PTHR48056:SF66', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250510),
(404155, 'PTHR48056:SF9', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250510),
(404156, 'PTHR48056:SF67', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 250510),
(404157, 'PTHR48056:SF23', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250510),
(404158, 'PTHR48056:SF2', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN KINASE-LIKE PROTEIN ZAR1', 250510),
(404159, 'PTHR48056:SF5', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE 2', 250510),
(404160, 'PTHR48056:SF4', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250510),
(404161, 'PTHR48056:SF68', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE EFR', 250510),
(404162, 'PTHR48056:SF24', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE ER2', 250510),
(404163, 'PTHR48056:SF69', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR PROTEIN KINASE EXS', 250510),
(404164, 'PTHR48056:SF25', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250510),
(404165, 'PTHR48056:SF26', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250510),
(404166, 'PTHR48056:SF28', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250510),
(404167, 'PTHR48056:SF29', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE HSL1', 250510),
(404168, 'PTHR48056:SF71', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 250510),
(404169, 'PTHR48056:SF72', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 250510),
(404170, 'PTHR48056:SF73', NULL, NULL, NULL, NULL, 'OS06G0585982 PROTEIN', 250510),
(404171, 'PTHR48056:SF74', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE 17', 250510),
(404172, 'PTHR48056:SF31', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250510),
(404173, 'PTHR48056:SF75', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE SERINE/THREONINE/TYROSINE-PROTEIN KINASE SOBIR1', 250510),
(404174, 'PTHR48056:SF76', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 250510),
(404175, 'PTHR48056:SF77', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250510),
(404176, 'PTHR48056:SF33', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250510),
(404177, 'PTHR48056:SF78', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 250510),
(404178, 'PTHR48056:SF34', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE ERL2', 250510),
(404179, 'PTHR48056:SF70', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250510);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(404180, 'PTHR48056:SF79', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250510),
(404181, 'PTHR48056:SF35', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE HSL2', 250510),
(404182, 'PTHR48056:SF36', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250510),
(404183, 'PTHR48056:SF37', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250510),
(404184, 'PTHR48056:SF38', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250510),
(404185, 'PTHR48056:SF39', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250510),
(404186, 'PTHR48056:SF40', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250510),
(404187, 'PTHR48056:SF41', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE HAIKU2', 250510),
(404188, 'PTHR48056:SF42', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250510),
(404189, 'PTHR48056:SF43', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250510),
(404190, 'PTHR48056:SF44', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN KINASE CLAVATA1', 250510),
(404191, 'PTHR48056:SF45', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250510),
(404192, 'PTHR48056:SF80', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250510),
(404193, 'PTHR48056:SF81', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT CONTAINING PROTEIN', 250510),
(404194, 'PTHR48056:SF48', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250510),
(404195, 'PTHR28272', NULL, NULL, NULL, NULL, 'RIBONUCLEASES P/MRP PROTEIN SUBUNIT POP3', 250511),
(404196, 'PTHR28272:SF1', NULL, NULL, NULL, NULL, 'RIBONUCLEASES P/MRP PROTEIN SUBUNIT POP3', 250511),
(404197, 'PTHR43730:SF5', NULL, NULL, NULL, NULL, 'BETA-MANNOSIDASE A', 250512),
(404198, 'PTHR43730:SF1', NULL, NULL, NULL, NULL, 'BETA-MANNOSIDASE', 250512),
(404199, 'PTHR43730', NULL, NULL, NULL, NULL, 'BETA-MANNOSIDASE', 250512),
(404200, 'PTHR10585:SF37', NULL, NULL, NULL, NULL, 'ER LUMEN PROTEIN-RETAINING RECEPTOR 2', 250513),
(404201, 'PTHR10585:SF77', NULL, NULL, NULL, NULL, 'BNAA07G05020D PROTEIN', 250513),
(404202, 'PTHR10585:SF33', NULL, NULL, NULL, NULL, 'ER LUMEN PROTEIN-RETAINING RECEPTOR 3', 250513),
(404203, 'PTHR10585:SF57', NULL, NULL, NULL, NULL, 'ER LUMEN PROTEIN RETAINING RECEPTOR FAMILY PROTEIN', 250513),
(404204, 'PTHR10585:SF14', NULL, NULL, NULL, NULL, 'ER LUMEN PROTEIN-RETAINING RECEPTOR', 250513),
(404205, 'PTHR10585:SF58', NULL, NULL, NULL, NULL, 'ER LUMEN PROTEIN-RETAINING RECEPTOR C28H8.4-RELATED', 250513),
(404206, 'PTHR10585:SF73', NULL, NULL, NULL, NULL, 'BNAC07G14900D PROTEIN', 250513),
(404207, 'PTHR10585:SF30', NULL, NULL, NULL, NULL, 'RETENTION RECEPTOR, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G02980)-RELATED', 250513),
(404208, 'PTHR10585:SF74', NULL, NULL, NULL, NULL, 'BNAANNG32910D PROTEIN', 250513),
(404209, 'PTHR10585:SF75', NULL, NULL, NULL, NULL, 'ER LUMEN PROTEIN-RETAINING RECEPTOR', 250513),
(404210, 'PTHR10585:SF70', NULL, NULL, NULL, NULL, 'ER LUMEN RETAINING RECEPTOR FAMILY', 250513),
(404211, 'PTHR10585:SF72', NULL, NULL, NULL, NULL, 'ER LUMEN PROTEIN RETAINING RECEPTOR-RELATED', 250513),
(404212, 'PTHR10585', NULL, NULL, NULL, NULL, 'ER LUMEN PROTEIN RETAINING RECEPTOR', 250513),
(404213, 'PTHR10585:SF26', NULL, NULL, NULL, NULL, 'ER LUMEN PROTEIN-RETAINING RECEPTOR A', 250513),
(404214, 'PTHR10585:SF29', NULL, NULL, NULL, NULL, 'ER LUMEN PROTEIN-RETAINING RECEPTOR', 250513),
(404215, 'PTHR10585:SF88', NULL, NULL, NULL, NULL, 'OS09G0534200 PROTEIN', 250513),
(404216, 'PTHR10585:SF89', NULL, NULL, NULL, NULL, 'OS08G0548200 PROTEIN', 250513),
(404217, 'PTHR10585:SF68', NULL, NULL, NULL, NULL, 'ER LUMEN PROTEIN-RETAINING RECEPTOR', 250513),
(404218, 'PTHR10585:SF63', NULL, NULL, NULL, NULL, 'ER LUMEN PROTEIN-RETAINING RECEPTOR C28H8.4-RELATED', 250513),
(404219, 'PTHR10585:SF64', NULL, NULL, NULL, NULL, 'ER LUMEN PROTEIN-RETAINING RECEPTOR C28H8.4-RELATED', 250513),
(404220, 'PTHR10585:SF65', NULL, NULL, NULL, NULL, 'ER LUMEN PROTEIN-RETAINING RECEPTOR C28H8.4-RELATED', 250513);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(404221, 'PTHR10585:SF81', NULL, NULL, NULL, NULL, '', 250513),
(404222, 'PTHR10585:SF60', NULL, NULL, NULL, NULL, 'ER LUMEN PROTEIN-RETAINING RECEPTOR ERD-2.2', 250513),
(404223, 'PTHR10585:SF82', NULL, NULL, NULL, NULL, 'BNAA09G43350D PROTEIN', 250513),
(404224, 'PTHR10585:SF61', NULL, NULL, NULL, NULL, 'ER LUMEN PROTEIN-RETAINING RECEPTOR 1', 250513),
(404225, 'PTHR10585:SF83', NULL, NULL, NULL, NULL, 'ER LUMEN PROTEIN-RETAINING RECEPTOR 2', 250513),
(404226, 'PTHR10585:SF90', NULL, NULL, NULL, NULL, 'ER LUMEN PROTEIN RETAINING RECEPTOR-RELATED', 250513),
(404227, 'PTHR19991:SF2', NULL, NULL, NULL, NULL, 'GH08893P', 250514),
(404228, 'PTHR19991:SF3', NULL, NULL, NULL, NULL, 'LETHAL (2) 01289, ISOFORM F', 250514),
(404229, 'PTHR19991', NULL, NULL, NULL, NULL, 'L 2 01289', 250514),
(404230, 'PTHR13449', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN GPR177', 250515),
(404231, 'PTHR13449:SF2', NULL, NULL, NULL, NULL, 'PROTEIN WNTLESS HOMOLOG', 250515),
(404232, 'PTHR35855', NULL, NULL, NULL, NULL, 'PROTEIN CBG11437-RELATED', 250516),
(404233, 'PTHR35855:SF2', NULL, NULL, NULL, NULL, 'SKN-1 DEPENDENT ZYGOTIC TRANSCRIPT 1 PROTEIN', 250516),
(404234, 'PTHR35855:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG11437', 250516),
(404235, 'PTHR35855:SF3', NULL, NULL, NULL, NULL, 'SKN-1 DEPENDENT ZYGOTIC TRANSCRIPT', 250516),
(404236, 'PTHR43097:SF5', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA SYNTHETASE', 250517),
(404237, 'PTHR43097:SF4', NULL, NULL, NULL, NULL, 'GLUTAMINE--TRNA LIGASE', 250517),
(404238, 'PTHR43097', NULL, NULL, NULL, NULL, 'GLUTAMINE-TRNA LIGASE', 250517),
(404239, 'PTHR43097:SF11', NULL, NULL, NULL, NULL, 'GLUTAMINYL-TRNA SYNTHETASE', 250517),
(404240, 'PTHR43097:SF12', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA SYNTHETASE', 250517),
(404241, 'PTHR43097:SF13', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA SYNTHETASE', 250517),
(404242, 'PTHR43097:SF2', NULL, NULL, NULL, NULL, 'GLUTAMINE--TRNA LIGASE', 250517),
(404243, 'PTHR43097:SF14', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA SYNTHETASE', 250517),
(404244, 'PTHR35707:SF1', NULL, NULL, NULL, NULL, 'SPC7 DOMAIN-CONTAINING PROTEIN', 250518),
(404245, 'PTHR35707', NULL, NULL, NULL, NULL, 'OS06G0608100 PROTEIN', 250518),
(404246, 'PTHR43232:SF2', NULL, NULL, NULL, NULL, 'MOLYBDENUM COFACTOR BIOSYNTHESIS PROTEIN B', 250519),
(404247, 'PTHR43232', NULL, NULL, NULL, NULL, 'MOLYBDENUM COFACTOR BIOSYNTHESIS PROTEIN B', 250519),
(404248, 'PTHR23287:SF16', NULL, NULL, NULL, NULL, 'TECTONIN BETA-PROPELLER REPEAT-CONTAINING PROTEIN 2', 250520),
(404249, 'PTHR23287', NULL, NULL, NULL, NULL, 'RUBY-EYE2-LIKE PROTEIN', 250520),
(404250, 'PTHR23287:SF18', NULL, NULL, NULL, NULL, 'HERMANSKY-PUDLAK SYNDROME 5 PROTEIN', 250520),
(404251, 'PTHR43697:SF1', NULL, NULL, NULL, NULL, 'SERINE--TRNA LIGASE', 250521),
(404252, 'PTHR43697', NULL, NULL, NULL, NULL, 'SERYL-TRNA SYNTHETASE', 250521),
(404253, 'PTHR42111', NULL, NULL, NULL, NULL, 'YALI0D23727P', 250522),
(404254, 'PTHR42111:SF1', NULL, NULL, NULL, NULL, 'YALI0D23727P', 250522),
(404255, 'PTHR24058:SF113', NULL, NULL, NULL, NULL, 'HYPOTHETICAL SER-THR PROTEIN KINASE', 250523),
(404256, 'PTHR24058:SF35', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY TYROSINE-PHOSPHORYLATION-REGULATED KINASE 3', 250523),
(404257, 'PTHR24058:SF112', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY TYROSINE-PHOSPHORYLATION-REGULATED KINASE 3 HOMOLOG-RELATED', 250523),
(404258, 'PTHR24058:SF115', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250523),
(404259, 'PTHR24058:SF53', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-INTERACTING PROTEIN KINASE 2', 250523),
(404260, 'PTHR24058:SF12', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY TYROSINE-PHOSPHORYLATION-REGULATED KINASE 1B', 250523),
(404261, 'PTHR24058:SF118', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 250523),
(404262, 'PTHR24058:SF51', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY TYROSINE-PHOSPHORYLATION-REGULATED KINASE 2', 250523),
(404263, 'PTHR24058:SF131', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 250523),
(404264, 'PTHR24058:SF130', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASES-RELATED', 250523);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(404265, 'PTHR24058:SF110', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250523),
(404266, 'PTHR24058', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN KINASE', 250523),
(404267, 'PTHR24058:SF132', NULL, NULL, NULL, NULL, 'DYRK-FAMILY KINASE POM1', 250523),
(404268, 'PTHR24058:SF17', NULL, NULL, NULL, NULL, 'HOMEODOMAIN INTERACTING PROTEIN KINASE, ISOFORM D', 250523),
(404269, 'PTHR24058:SF124', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 250523),
(404270, 'PTHR24058:SF46', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-INTERACTING PROTEIN KINASE 4', 250523),
(404271, 'PTHR24058:SF123', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250523),
(404272, 'PTHR24058:SF126', NULL, NULL, NULL, NULL, 'SI:CH211-160O17.4', 250523),
(404273, 'PTHR24058:SF103', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE-RELATED', 250523),
(404274, 'PTHR24058:SF125', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN (MAP) KINASE, ERK3/4-RELATED', 250523),
(404275, 'PTHR24058:SF43', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-INTERACTING PROTEIN KINASE 1', 250523),
(404276, 'PTHR24058:SF105', NULL, NULL, NULL, NULL, 'OS04G0602800 PROTEIN', 250523),
(404277, 'PTHR24058:SF108', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 250523),
(404278, 'PTHR24058:SF45', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-INTERACTING PROTEIN KINASE 3', 250523),
(404279, 'PTHR24058:SF129', NULL, NULL, NULL, NULL, 'DUAL-SPECIFICITY KINASE', 250523),
(404280, 'PTHR24058:SF22', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY TYROSINE-PHOSPHORYLATION-REGULATED KINASE 4', 250523),
(404281, 'PTHR24058:SF63', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 250523),
(404282, 'PTHR24058:SF120', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 250523),
(404283, 'PTHR24058:SF121', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY TYROSINE-PHOSPHORYLATION-REGULATED KINASE 1A', 250523),
(404284, 'PTHR24058:SF28', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE MINIBRAIN', 250523),
(404285, 'PTHR43410:SF1', NULL, NULL, NULL, NULL, 'NITRIC OXIDE SYNTHASE OXYGENASE', 250524),
(404286, 'PTHR43410', NULL, NULL, NULL, NULL, 'NITRIC OXIDE SYNTHASE OXYGENASE', 250524),
(404287, 'PTHR23316:SF97', NULL, NULL, NULL, NULL, '', 250525),
(404288, 'PTHR23316:SF75', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT ALPHA-B', 250525),
(404289, 'PTHR23316:SF53', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT ALPHA-6', 250525),
(404290, 'PTHR23316:SF76', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT ALPHA', 250525),
(404291, 'PTHR23316:SF98', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT ALPHA-2', 250525),
(404292, 'PTHR23316:SF10', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT ALPHA-6', 250525),
(404293, 'PTHR23316:SF95', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT ALPHA-1', 250525),
(404294, 'PTHR23316:SF96', NULL, NULL, NULL, NULL, '', 250525),
(404295, 'PTHR23316:SF58', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT ALPHA-4', 250525),
(404296, 'PTHR23316:SF55', NULL, NULL, NULL, NULL, '', 250525),
(404297, 'PTHR23316:SF11', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT ALPHA-8', 250525),
(404298, 'PTHR23316:SF77', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT ALPHA', 250525),
(404299, 'PTHR23316:SF99', NULL, NULL, NULL, NULL, '', 250525),
(404300, 'PTHR23316:SF78', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT ALPHA', 250525),
(404301, 'PTHR23316:SF12', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT ALPHA-1', 250525),
(404302, 'PTHR23316:SF82', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT ALPHA-2', 250525),
(404303, 'PTHR23316:SF80', NULL, NULL, NULL, NULL, 'ALPHA, PUTATIVE-RELATED', 250525),
(404304, 'PTHR23316:SF81', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT ALPHA', 250525),
(404305, 'PTHR23316:SF28', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT ALPHA', 250525),
(404306, 'PTHR23316', NULL, NULL, NULL, NULL, 'IMPORTIN ALPHA', 250525),
(404307, 'PTHR23316:SF64', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT ALPHA', 250525),
(404308, 'PTHR23316:SF86', NULL, NULL, NULL, NULL, '', 250525),
(404309, 'PTHR23316:SF87', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT ALPHA', 250525);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(404310, 'PTHR23316:SF62', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT ALPHA', 250525),
(404311, 'PTHR23316:SF8', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT ALPHA-7', 250525),
(404312, 'PTHR23316:SF63', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT ALPHA', 250525),
(404313, 'PTHR23316:SF85', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT ALPHA-7', 250525),
(404314, 'PTHR23316:SF6', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT ALPHA-4', 250525),
(404315, 'PTHR23316:SF69', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT ALPHA-3', 250525),
(404316, 'PTHR23316:SF7', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT ALPHA-3', 250525),
(404317, 'PTHR23316:SF66', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT ALPHA', 250525),
(404318, 'PTHR23316:SF88', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT ALPHA', 250525),
(404319, 'PTHR23316:SF89', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT ALPHA-9', 250525),
(404320, 'PTHR23316:SF100', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT ALPHA', 250525),
(404321, 'PTHR23316:SF3', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT ALPHA-5', 250525),
(404322, 'PTHR23316:SF90', NULL, NULL, NULL, NULL, 'IBB DOMAIN-CONTAINING PROTEIN', 250525),
(404323, 'PTHR23316:SF101', NULL, NULL, NULL, NULL, '', 250525),
(404324, 'PTHR23316:SF102', NULL, NULL, NULL, NULL, 'IBB DOMAIN-CONTAINING PROTEIN', 250525),
(404325, 'PTHR23316:SF71', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT ALPHA', 250525),
(404326, 'PTHR23316:SF93', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT ALPHA-2', 250525),
(404327, 'PTHR23316:SF94', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT ALPHA', 250525),
(404328, 'PTHR23316:SF91', NULL, NULL, NULL, NULL, '', 250525),
(404329, 'PTHR23316:SF92', NULL, NULL, NULL, NULL, '', 250525),
(404330, 'PTHR46433:SF1', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250526),
(404331, 'PTHR46433:SF2', NULL, NULL, NULL, NULL, '', 250526),
(404332, 'PTHR46433:SF3', NULL, NULL, NULL, NULL, 'RAB GTPASE DOMAIN-CONTAINING PROTEIN', 250526),
(404333, 'PTHR46433:SF4', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING PROTEIN', 250526),
(404334, 'PTHR46433', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN-RELATED', 250526),
(404335, 'PTHR20958:SF9', NULL, NULL, NULL, NULL, 'RE58324P', 250527),
(404336, 'PTHR20958:SF6', NULL, NULL, NULL, NULL, 'FR47 DOMAIN-CONTAINING PROTEIN-RELATED', 250527),
(404337, 'PTHR20958:SF10', NULL, NULL, NULL, NULL, 'GH05617P-RELATED', 250527),
(404338, 'PTHR20958', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 250527),
(404339, 'PTHR14388:SF21', NULL, NULL, NULL, NULL, 'PROTEIN CBG06123', 250528),
(404340, 'PTHR14388:SF3', NULL, NULL, NULL, NULL, 'HEMATOPOIETIC SH2 DOMAIN-CONTAINING PROTEIN', 250528),
(404341, 'PTHR14388:SF22', NULL, NULL, NULL, NULL, '', 250528),
(404342, 'PTHR14388:SF6', NULL, NULL, NULL, NULL, 'SH2 DOMAIN-CONTAINING PROTEIN 7', 250528),
(404343, 'PTHR14388:SF5', NULL, NULL, NULL, NULL, 'SH2 DOMAIN-CONTAINING PROTEIN 4A', 250528),
(404344, 'PTHR14388:SF7', NULL, NULL, NULL, NULL, 'SH2 DOMAIN-CONTAINING PROTEIN 4B', 250528),
(404345, 'PTHR14388:SF23', NULL, NULL, NULL, NULL, 'SI:CH73-109I22.2', 250528),
(404346, 'PTHR14388:SF9', NULL, NULL, NULL, NULL, 'SH2 DOMAIN-CONTAINING PROTEIN 2A', 250528),
(404347, 'PTHR14388:SF18', NULL, NULL, NULL, NULL, 'SOCS BOX DOMAIN-CONTAINING PROTEIN', 250528),
(404348, 'PTHR14388:SF17', NULL, NULL, NULL, NULL, 'SH2 DOMAIN-CONTAINING PROTEIN', 250528),
(404349, 'PTHR14388', NULL, NULL, NULL, NULL, 'T CELL-SPECIFIC ADAPTER PROTEIN TSAD', 250528),
(404350, 'PTHR18966:SF363', NULL, NULL, NULL, NULL, 'IONOTROPIC RECEPTOR 93A', 250529),
(404351, 'PTHR18966:SF484', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR, IONOTROPIC, N-METHYL D-ASPARTATE 2D, A', 250529),
(404352, 'PTHR18966:SF361', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR IONOTROPIC, NMDA 2C', 250529),
(404353, 'PTHR18966:SF482', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404354, 'PTHR18966:SF525', NULL, NULL, NULL, NULL, 'PBPE DOMAIN-CONTAINING PROTEIN', 250529),
(404355, 'PTHR18966:SF524', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404356, 'PTHR18966:SF403', NULL, NULL, NULL, NULL, 'IONOTROPIC RECEPTOR 8A', 250529);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(404357, 'PTHR18966:SF523', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404358, 'PTHR18966:SF401', NULL, NULL, NULL, NULL, 'PBPE DOMAIN-CONTAINING PROTEIN', 250529),
(404359, 'PTHR18966:SF522', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404360, 'PTHR18966:SF521', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404361, 'PTHR18966:SF487', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR 3.4', 250529),
(404362, 'PTHR18966:SF486', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404363, 'PTHR18966:SF485', NULL, NULL, NULL, NULL, 'IONOTROPIC GLUTAMATE RECEPTOR, METAZOA, PERIPLASMIC BINDING PROTEIN-LIKE I-RELATED', 250529),
(404364, 'PTHR18966:SF364', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR IONOTROPIC, NMDA 3B', 250529),
(404365, 'PTHR18966:SF528', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404366, 'PTHR18966:SF407', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR IONOTROPIC, NMDA 2A', 250529),
(404367, 'PTHR18966:SF405', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404368, 'PTHR18966:SF473', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR 2.2-RELATED', 250529),
(404369, 'PTHR18966:SF472', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404370, 'PTHR18966:SF351', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR IONOTROPIC, KAINATE 5', 250529),
(404371, 'PTHR18966', NULL, NULL, NULL, NULL, 'IONOTROPIC GLUTAMATE RECEPTOR', 250529),
(404372, 'PTHR18966:SF514', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404373, 'PTHR18966:SF513', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR, IONOTROPIC, AMPA 1B', 250529),
(404374, 'PTHR18966:SF512', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR 2.1-RELATED', 250529),
(404375, 'PTHR18966:SF478', NULL, NULL, NULL, NULL, 'PBPE DOMAIN-CONTAINING PROTEIN', 250529),
(404376, 'PTHR18966:SF354', NULL, NULL, NULL, NULL, '', 250529),
(404377, 'PTHR18966:SF475', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404378, 'PTHR18966:SF99', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR 2', 250529),
(404379, 'PTHR18966:SF518', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404380, 'PTHR18966:SF516', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404381, 'PTHR18966:SF583', NULL, NULL, NULL, NULL, 'RECEPTOR 2, PUTATIVE-RELATED', 250529),
(404382, 'PTHR18966:SF582', NULL, NULL, NULL, NULL, '', 250529),
(404383, 'PTHR18966:SF461', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404384, 'PTHR18966:SF581', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404385, 'PTHR18966:SF580', NULL, NULL, NULL, NULL, 'IONOTROPIC GLUTAMATE RECEPTOR, METAZOA, PERIPLASMIC BINDING PROTEIN-LIKE I-RELATED', 250529),
(404386, 'PTHR18966:SF349', NULL, NULL, NULL, NULL, 'FI04462P-RELATED', 250529),
(404387, 'PTHR18966:SF502', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR 3.1', 250529),
(404388, 'PTHR18966:SF465', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404389, 'PTHR18966:SF585', NULL, NULL, NULL, NULL, 'PBPE DOMAIN-CONTAINING PROTEIN', 250529),
(404390, 'PTHR18966:SF463', NULL, NULL, NULL, NULL, 'PBPE DOMAIN-CONTAINING PROTEIN', 250529),
(404391, 'PTHR18966:SF584', NULL, NULL, NULL, NULL, 'IONOTROPIC GLUTAMATE RECEPTOR, METAZOA, PERIPLASMIC BINDING PROTEIN-LIKE I-RELATED', 250529),
(404392, 'PTHR18966:SF100', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR 4', 250529),
(404393, 'PTHR18966:SF508', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404394, 'PTHR18966:SF109', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR IONOTROPIC, DELTA-2', 250529),
(404395, 'PTHR18966:SF108', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR IONOTROPIC, DELTA-1', 250529),
(404396, 'PTHR18966:SF229', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404397, 'PTHR18966:SF572', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404398, 'PTHR18966:SF571', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404399, 'PTHR18966:SF450', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR 2.7-RELATED', 250529),
(404400, 'PTHR18966:SF570', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404401, 'PTHR18966:SF174', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR IONOTROPIC, KAINATE 3', 250529);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(404402, 'PTHR18966:SF295', NULL, NULL, NULL, NULL, 'PBPE DOMAIN-CONTAINING PROTEIN', 250529),
(404403, 'PTHR18966:SF171', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR IONOTROPIC, KAINATE 4', 250529),
(404404, 'PTHR18966:SF458', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR 3.5', 250529),
(404405, 'PTHR18966:SF579', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404406, 'PTHR18966:SF457', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR 3.4', 250529),
(404407, 'PTHR18966:SF578', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404408, 'PTHR18966:SF456', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404409, 'PTHR18966:SF577', NULL, NULL, NULL, NULL, '', 250529),
(404410, 'PTHR18966:SF576', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404411, 'PTHR18966:SF575', NULL, NULL, NULL, NULL, 'EYE-ENRICHED KAINATE RECEPTOR, ISOFORM B-RELATED', 250529),
(404412, 'PTHR18966:SF454', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404413, 'PTHR18966:SF574', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404414, 'PTHR18966:SF453', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404415, 'PTHR18966:SF452', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404416, 'PTHR18966:SF573', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404417, 'PTHR18966:SF36', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR IONOTROPIC, KAINATE 1', 250529),
(404418, 'PTHR18966:SF38', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR IONOTROPIC, KAINATE 2', 250529),
(404419, 'PTHR18966:SF561', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR FAMILY (AMPA)', 250529),
(404420, 'PTHR18966:SF560', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 250529),
(404421, 'PTHR18966:SF569', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404422, 'PTHR18966:SF448', NULL, NULL, NULL, NULL, 'IONOTROPIC RECEPTOR NMDAR3', 250529),
(404423, 'PTHR18966:SF568', NULL, NULL, NULL, NULL, 'OS06G0188600 PROTEIN', 250529),
(404424, 'PTHR18966:SF567', NULL, NULL, NULL, NULL, 'ANF_RECEPTOR DOMAIN-CONTAINING PROTEIN', 250529),
(404425, 'PTHR18966:SF566', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404426, 'PTHR18966:SF445', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404427, 'PTHR18966:SF565', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404428, 'PTHR18966:SF564', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404429, 'PTHR18966:SF563', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404430, 'PTHR18966:SF562', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404431, 'PTHR18966:SF449', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404432, 'PTHR18966:SF394', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR FAMILY (AMPA)', 250529),
(404433, 'PTHR18966:SF151', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR 3', 250529),
(404434, 'PTHR18966:SF391', NULL, NULL, NULL, NULL, 'NMDA RECEPTOR 2, ISOFORM C', 250529),
(404435, 'PTHR18966:SF558', NULL, NULL, NULL, NULL, 'PBPE DOMAIN-CONTAINING PROTEIN', 250529),
(404436, 'PTHR18966:SF556', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR 3.6-LIKE', 250529),
(404437, 'PTHR18966:SF555', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404438, 'PTHR18966:SF434', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR 1.2-RELATED', 250529),
(404439, 'PTHR18966:SF554', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404440, 'PTHR18966:SF433', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404441, 'PTHR18966:SF553', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404442, 'PTHR18966:SF157', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR 1', 250529),
(404443, 'PTHR18966:SF432', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR 2.7', 250529),
(404444, 'PTHR18966:SF399', NULL, NULL, NULL, NULL, 'IP13856P', 250529),
(404445, 'PTHR18966:SF430', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404446, 'PTHR18966:SF397', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR IONOTROPIC, NMDA 3A', 250529),
(404447, 'PTHR18966:SF439', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404448, 'PTHR18966:SF559', NULL, NULL, NULL, NULL, 'PBPE DOMAIN-CONTAINING PROTEIN', 250529);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(404449, 'PTHR18966:SF385', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR IONOTROPIC, NMDA 2D', 250529),
(404450, 'PTHR18966:SF382', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR IONOTROPIC, NMDA 2B', 250529),
(404451, 'PTHR18966:SF426', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404452, 'PTHR18966:SF547', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404453, 'PTHR18966:SF424', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404454, 'PTHR18966:SF544', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR 2', 250529),
(404455, 'PTHR18966:SF422', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR 1-RELATED', 250529),
(404456, 'PTHR18966:SF541', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404457, 'PTHR18966:SF540', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404458, 'PTHR18966:SF429', NULL, NULL, NULL, NULL, 'PBPE DOMAIN-CONTAINING PROTEIN', 250529),
(404459, 'PTHR18966:SF549', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404460, 'PTHR18966:SF428', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR 1.1', 250529),
(404461, 'PTHR18966:SF427', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR 3.7', 250529),
(404462, 'PTHR18966:SF374', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR 2.2-LIKE', 250529),
(404463, 'PTHR18966:SF494', NULL, NULL, NULL, NULL, 'IONOTROPIC RECEPTOR 75D', 250529),
(404464, 'PTHR18966:SF373', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404465, 'PTHR18966:SF493', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404466, 'PTHR18966:SF492', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404467, 'PTHR18966:SF370', NULL, NULL, NULL, NULL, 'CLUMSY, ISOFORM B-RELATED', 250529),
(404468, 'PTHR18966:SF490', NULL, NULL, NULL, NULL, 'PBPE DOMAIN-CONTAINING PROTEIN', 250529),
(404469, 'PTHR18966:SF415', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404470, 'PTHR18966:SF535', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404471, 'PTHR18966:SF534', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404472, 'PTHR18966:SF413', NULL, NULL, NULL, NULL, 'IONOTROPIC RECEPTOR 21A', 250529),
(404473, 'PTHR18966:SF412', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR 3.6', 250529),
(404474, 'PTHR18966:SF379', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404475, 'PTHR18966:SF532', NULL, NULL, NULL, NULL, 'PBPE DOMAIN-CONTAINING PROTEIN', 250529),
(404476, 'PTHR18966:SF411', NULL, NULL, NULL, NULL, 'IONOTROPIC RECEPTOR 25A', 250529),
(404477, 'PTHR18966:SF377', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR IONOTROPIC, NMDA 1', 250529),
(404478, 'PTHR18966:SF419', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR', 250529),
(404479, 'PTHR18966:SF418', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR 2.5-RELATED', 250529),
(404480, 'PTHR18966:SF417', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR-RELATED', 250529),
(404481, 'PTHR18966:SF416', NULL, NULL, NULL, NULL, 'PBPE DOMAIN-CONTAINING PROTEIN', 250529),
(404482, 'PTHR45729:SF11', NULL, NULL, NULL, NULL, 'DOUBLE C2-LIKE DOMAINS, DELTA', 250530),
(404483, 'PTHR45729:SF1', NULL, NULL, NULL, NULL, 'DOUBLE C2-LIKE DOMAIN-CONTAINING PROTEIN ALPHA', 250530),
(404484, 'PTHR45729:SF10', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C', 250530),
(404485, 'PTHR45729:SF3', NULL, NULL, NULL, NULL, 'RABPHILIN-3A', 250530),
(404486, 'PTHR45729', NULL, NULL, NULL, NULL, 'RABPHILIN, ISOFORM A', 250530),
(404487, 'PTHR45729:SF4', NULL, NULL, NULL, NULL, 'RAB EFFECTOR NOC2', 250530),
(404488, 'PTHR45729:SF7', NULL, NULL, NULL, NULL, 'DOUBLE C2-LIKE DOMAIN-CONTAINING PROTEIN GAMMA', 250530),
(404489, 'PTHR45729:SF6', NULL, NULL, NULL, NULL, 'RABPHILIN, ISOFORM A', 250530),
(404490, 'PTHR45729:SF9', NULL, NULL, NULL, NULL, 'DOUBLE C2-LIKE DOMAIN-CONTAINING PROTEIN BETA', 250530),
(404491, 'PTHR38248:SF2', NULL, NULL, NULL, NULL, 'FUNK1 11', 250531),
(404492, 'PTHR38248', NULL, NULL, NULL, NULL, 'FUNK1 6', 250531),
(404493, 'PTHR39518', NULL, NULL, NULL, NULL, 'UPF0215 PROTEIN MJ1150', 250532),
(404494, 'PTHR39518:SF2', NULL, NULL, NULL, NULL, 'UPF0215 PROTEIN TK2033', 250532),
(404495, 'PTHR28557:SF1', NULL, NULL, NULL, NULL, 'PROTEIN SLX4IP', 250533);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(404496, 'PTHR28557', NULL, NULL, NULL, NULL, 'PROTEIN SLX4IP', 250533),
(404497, 'PTHR22814:SF327', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 250534),
(404498, 'PTHR22814:SF329', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED DOMAIN, HMA-RELATED', 250534),
(404499, 'PTHR22814', NULL, NULL, NULL, NULL, 'COPPER TRANSPORT PROTEIN ATOX1-RELATED', 250534),
(404500, 'PTHR22814:SF323', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 21-LIKE', 250534),
(404501, 'PTHR22814:SF320', NULL, NULL, NULL, NULL, 'OJ1116_C07.8 PROTEIN', 250534),
(404502, 'PTHR22814:SF287', NULL, NULL, NULL, NULL, 'COPPER TRANSPORT PROTEIN ATX1', 250534),
(404503, 'PTHR22814:SF288', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 30', 250534),
(404504, 'PTHR22814:SF289', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 250534),
(404505, 'PTHR22814:SF322', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 250534),
(404506, 'PTHR22814:SF284', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORT/DETOXIFICATION SUPERFAMILY PROTEIN', 250534),
(404507, 'PTHR22814:SF338', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 250534),
(404508, 'PTHR22814:SF339', NULL, NULL, NULL, NULL, 'CHAPERONE, PUTATIVE-RELATED', 250534),
(404509, 'PTHR22814:SF334', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED DOMAIN CONTAINING PROTEIN', 250534),
(404510, 'PTHR22814:SF335', NULL, NULL, NULL, NULL, 'FARNESYLATED PROTEIN 6-RELATED', 250534),
(404511, 'PTHR22814:SF336', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 23', 250534),
(404512, 'PTHR22814:SF138', NULL, NULL, NULL, NULL, 'OS06G0542300 PROTEIN', 250534),
(404513, 'PTHR22814:SF337', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 21-LIKE', 250534),
(404514, 'PTHR22814:SF297', NULL, NULL, NULL, NULL, 'HEAVY-METAL-ASSOCIATED DOMAIN PROTEIN', 250534),
(404515, 'PTHR22814:SF330', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 250534),
(404516, 'PTHR22814:SF293', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 22', 250534),
(404517, 'PTHR22814:SF294', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 27', 250534),
(404518, 'PTHR22814:SF295', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORT/DETOXIFICATION SUPERFAMILY PROTEIN', 250534),
(404519, 'PTHR22814:SF290', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 250534),
(404520, 'PTHR22814:SF291', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 250534),
(404521, 'PTHR22814:SF84', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 24', 250534),
(404522, 'PTHR22814:SF305', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORT/DETOXIFICATION SUPERFAMILY PROTEIN', 250534),
(404523, 'PTHR22814:SF107', NULL, NULL, NULL, NULL, 'OS01G0758000 PROTEIN', 250534),
(404524, 'PTHR22814:SF349', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 250534),
(404525, 'PTHR22814:SF306', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 45', 250534),
(404526, 'PTHR22814:SF103', NULL, NULL, NULL, NULL, 'OS08G0403300 PROTEIN', 250534),
(404527, 'PTHR22814:SF345', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORT/DETOXIFICATION SUPERFAMILY PROTEIN-RELATED', 250534),
(404528, 'PTHR22814:SF302', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 26', 250534),
(404529, 'PTHR22814:SF346', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORT/DETOXIFICATION SUPERFAMILY PROTEIN', 250534),
(404530, 'PTHR22814:SF303', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 250534),
(404531, 'PTHR22814:SF347', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 250534),
(404532, 'PTHR22814:SF304', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORT/DETOXIFICATION SUPERFAMILY PROTEIN', 250534),
(404533, 'PTHR22814:SF342', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 250534),
(404534, 'PTHR22814:SF343', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 250534),
(404535, 'PTHR22814:SF145', NULL, NULL, NULL, NULL, 'COPPER ION BINDING PROTEIN', 250534);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(404536, 'PTHR22814:SF340', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 250534),
(404537, 'PTHR22814:SF318', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 25', 250534),
(404538, 'PTHR22814:SF319', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 31', 250534),
(404539, 'PTHR22814:SF312', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 29', 250534),
(404540, 'PTHR22814:SF356', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 20', 250534),
(404541, 'PTHR22814:SF313', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORT/DETOXIFICATION SUPERFAMILY PROTEIN', 250534),
(404542, 'PTHR22814:SF357', NULL, NULL, NULL, NULL, 'CHAPERONE, PUTATIVE, EXPRESSED-RELATED', 250534),
(404543, 'PTHR22814:SF358', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 250534),
(404544, 'PTHR22814:SF315', NULL, NULL, NULL, NULL, 'OS02G0530100 PROTEIN', 250534),
(404545, 'PTHR22814:SF359', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 250534),
(404546, 'PTHR22814:SF352', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 250534),
(404547, 'PTHR22814:SF110', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 21', 250534),
(404548, 'PTHR22814:SF353', NULL, NULL, NULL, NULL, 'DOMAIN-CONTAINING PROTEIN, PUTATIVE, EXPRESSED-RELATED', 250534),
(404549, 'PTHR22814:SF310', NULL, NULL, NULL, NULL, 'COPPER TRANSPORT PROTEIN CCH', 250534),
(404550, 'PTHR22814:SF354', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 44', 250534),
(404551, 'PTHR22814:SF355', NULL, NULL, NULL, NULL, 'OS01G0927300 PROTEIN', 250534),
(404552, 'PTHR22814:SF311', NULL, NULL, NULL, NULL, 'OS04G0502000 PROTEIN', 250534),
(404553, 'PTHR22814:SF272', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 250534),
(404554, 'PTHR22814:SF350', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED DOMAIN CONTAINING PROTEIN, EXPRESSED', 250534),
(404555, 'PTHR22814:SF351', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 28', 250534),
(404556, 'PTHR16057', NULL, NULL, NULL, NULL, 'WINS1, 2 PROTEIN', 250535),
(404557, 'PTHR16057:SF1', NULL, NULL, NULL, NULL, 'PROTEIN LINES HOMOLOG 1', 250535),
(404558, 'PTHR32499:SF20', NULL, NULL, NULL, NULL, 'OS07G0160600 PROTEIN', 250536),
(404559, 'PTHR32499:SF10', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 18', 250536),
(404560, 'PTHR32499:SF11', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 16', 250536),
(404561, 'PTHR32499:SF12', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 17 ISOFORM X1', 250536),
(404562, 'PTHR32499:SF13', NULL, NULL, NULL, NULL, 'FAS1 DOMAIN-CONTAINING PROTEIN-RELATED', 250536),
(404563, 'PTHR32499:SF14', NULL, NULL, NULL, NULL, 'FAS1 DOMAIN-CONTAINING PROTEIN-RELATED', 250536),
(404564, 'PTHR32499:SF15', NULL, NULL, NULL, NULL, 'BNAA03G55350D PROTEIN', 250536),
(404565, 'PTHR32499:SF9', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 15', 250536),
(404566, 'PTHR32499:SF17', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 17', 250536),
(404567, 'PTHR32499:SF18', NULL, NULL, NULL, NULL, '', 250536),
(404568, 'PTHR32499:SF19', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 16', 250536),
(404569, 'PTHR32499:SF3', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 16', 250536),
(404570, 'PTHR32499:SF5', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 17', 250536),
(404571, 'PTHR32499', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 16', 250536),
(404572, 'PTHR15893:SF16', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L27', 250537),
(404573, 'PTHR15893:SF15', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L27-LIKE', 250537),
(404574, 'PTHR15893:SF0', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L27, MITOCHONDRIAL', 250537),
(404575, 'PTHR15893:SF13', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L27', 250537),
(404576, 'PTHR15893', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L27', 250537);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(404577, 'PTHR35365:SF29', NULL, NULL, NULL, NULL, '', 250538),
(404578, 'PTHR35365:SF18', NULL, NULL, NULL, NULL, 'PRESPORE PROTEIN DP87-RELATED', 250538),
(404579, 'PTHR35365:SF2', NULL, NULL, NULL, NULL, '', 250538),
(404580, 'PTHR35365', NULL, NULL, NULL, NULL, 'LP04239P', 250538),
(404581, 'PTHR35365:SF13', NULL, NULL, NULL, NULL, '', 250538),
(404582, 'PTHR35365:SF32', NULL, NULL, NULL, NULL, '', 250538),
(404583, 'PTHR35365:SF33', NULL, NULL, NULL, NULL, '', 250538),
(404584, 'PTHR35365:SF22', NULL, NULL, NULL, NULL, '', 250538),
(404585, 'PTHR35365:SF30', NULL, NULL, NULL, NULL, 'FLOCCULIN, PARTIAL', 250538),
(404586, 'PTHR35365:SF31', NULL, NULL, NULL, NULL, 'LP04239P', 250538),
(404587, 'PTHR23212:SF0', NULL, NULL, NULL, NULL, 'BRAIN ACID SOLUBLE PROTEIN 1', 250539),
(404588, 'PTHR23212', NULL, NULL, NULL, NULL, 'BRAIN ACID SOLUBLE PROTEIN 1', 250539),
(404589, 'PTHR44394:SF1', NULL, NULL, NULL, NULL, 'BETA-ALANINE-ACTIVATING ENZYME', 250540),
(404590, 'PTHR44394', NULL, NULL, NULL, NULL, 'BETA-ALANINE-ACTIVATING ENZYME', 250540),
(404591, 'PTHR39063', NULL, NULL, NULL, NULL, 'ORAL-FACIAL-DIGITAL SYNDROME 1 PROTEIN HOMOLOG', 250541),
(404592, 'PTHR39063:SF1', NULL, NULL, NULL, NULL, 'LISH DOMAIN-CONTAINING PROTEIN', 250541),
(404593, 'PTHR23143:SF22', NULL, NULL, NULL, NULL, 'GOLGIN SUBFAMILY A MEMBER 6-LIKE PROTEIN 7', 250542),
(404594, 'PTHR23143:SF23', NULL, NULL, NULL, NULL, 'GOLGIN SUBFAMILY A MEMBER 6-LIKE PROTEIN 1-RELATED', 250542),
(404595, 'PTHR23143:SF19', NULL, NULL, NULL, NULL, 'GOLGIN SUBFAMILY A MEMBER 6-LIKE PROTEIN 10-RELATED', 250542),
(404596, 'PTHR23143', NULL, NULL, NULL, NULL, 'TRICHOHYALIN-RELATED', 250542),
(404597, 'PTHR23143:SF26', NULL, NULL, NULL, NULL, '', 250542),
(404598, 'PTHR23143:SF28', NULL, NULL, NULL, NULL, 'GOLGIN SUBFAMILY A MEMBER 6-LIKE PROTEIN 2', 250542),
(404599, 'PTHR23143:SF29', NULL, NULL, NULL, NULL, '', 250542),
(404600, 'PTHR31866:SF5', NULL, NULL, NULL, NULL, '', 250543),
(404601, 'PTHR31866:SF4', NULL, NULL, NULL, NULL, '', 250543),
(404602, 'PTHR31866:SF3', NULL, NULL, NULL, NULL, 'CHROMOSOME X OPEN READING FRAME 49-LIKE', 250543),
(404603, 'PTHR31866', NULL, NULL, NULL, NULL, 'GENE 4779-RELATED', 250543),
(404604, 'PTHR31866:SF2', NULL, NULL, NULL, NULL, 'RIKEN CDNA 8030474K03 GENE', 250543),
(404605, 'PTHR31866:SF1', NULL, NULL, NULL, NULL, 'GENE 3858-RELATED', 250543),
(404606, 'PTHR38340', NULL, NULL, NULL, NULL, 'S-LAYER PROTEIN', 250544),
(404607, 'PTHR38340:SF1', NULL, NULL, NULL, NULL, 'S-LAYER PROTEIN', 250544),
(404608, 'PTHR47777:SF1', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN SEBOX', 250545),
(404609, 'PTHR47777', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN SEBOX', 250545),
(404610, 'PTHR45874:SF2', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-C10', 250546),
(404611, 'PTHR45874:SF1', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-A10', 250546),
(404612, 'PTHR45874:SF4', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN ABDOMINAL-B', 250546),
(404613, 'PTHR45874:SF6', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-B10A', 250546),
(404614, 'PTHR45874:SF5', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-D10', 250546),
(404615, 'PTHR45874:SF7', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN', 250546),
(404616, 'PTHR45874', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN ABDOMINAL-B', 250546),
(404617, 'PTHR22998', NULL, NULL, NULL, NULL, 'SARM1', 250547),
(404618, 'PTHR22998:SF1', NULL, NULL, NULL, NULL, 'NAD(+) HYDROLASE SARM1', 250547),
(404619, 'PTHR47989:SF51', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404620, 'PTHR47989:SF54', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404621, 'PTHR47989:SF10', NULL, NULL, NULL, NULL, '', 250548),
(404622, 'PTHR47989:SF55', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404623, 'PTHR47989:SF11', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404624, 'PTHR47989:SF12', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404625, 'PTHR47989:SF56', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(404626, 'PTHR47989:SF57', NULL, NULL, NULL, NULL, 'SERINE/THREONINE KINASE PBS1', 250548),
(404627, 'PTHR47989:SF58', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404628, 'PTHR47989:SF14', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404629, 'PTHR47989:SF59', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404630, 'PTHR47989:SF15', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404631, 'PTHR47989:SF16', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404632, 'PTHR47989:SF18', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE-LIKE PROTEIN CCR2', 250548),
(404633, 'PTHR47989:SF19', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404634, 'PTHR47989:SF60', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404635, 'PTHR47989:SF61', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404636, 'PTHR47989:SF62', NULL, NULL, NULL, NULL, 'OS05G0423500 PROTEIN', 250548),
(404637, 'PTHR47989:SF63', NULL, NULL, NULL, NULL, 'OS01G0883000 PROTEIN', 250548),
(404638, 'PTHR47989:SF20', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404639, 'PTHR47989:SF64', NULL, NULL, NULL, NULL, '', 250548),
(404640, 'PTHR47989', NULL, NULL, NULL, NULL, 'OS01G0750732 PROTEIN', 250548),
(404641, 'PTHR47989:SF65', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404642, 'PTHR47989:SF22', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE-LIKE PROTEIN CCR1', 250548),
(404643, 'PTHR47989:SF66', NULL, NULL, NULL, NULL, 'DNA HELICASE', 250548),
(404644, 'PTHR47989:SF23', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404645, 'PTHR47989:SF67', NULL, NULL, NULL, NULL, 'BNAA06G23070D PROTEIN', 250548),
(404646, 'PTHR47989:SF68', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404647, 'PTHR47989:SF24', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404648, 'PTHR47989:SF25', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404649, 'PTHR47989:SF69', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404650, 'PTHR47989:SF26', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404651, 'PTHR47989:SF27', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404652, 'PTHR47989:SF28', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404653, 'PTHR47989:SF30', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404654, 'PTHR47989:SF32', NULL, NULL, NULL, NULL, 'SALT TOLERANCE RECEPTOR-LIKE CYTOPLASMIC KINASE 1', 250548),
(404655, 'PTHR47989:SF33', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404656, 'PTHR47989:SF34', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE ALE2', 250548),
(404657, 'PTHR47989:SF35', NULL, NULL, NULL, NULL, 'NTF2 DOMAIN-CONTAINING PROTEIN', 250548),
(404658, 'PTHR47989:SF36', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404659, 'PTHR47989:SF37', NULL, NULL, NULL, NULL, 'INACTIVE PROTEIN KINASE SELMODRAFT_444075', 250548),
(404660, 'PTHR47989:SF39', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404661, 'PTHR47989:SF40', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE ALE2', 250548),
(404662, 'PTHR47989:SF1', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404663, 'PTHR47989:SF41', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404664, 'PTHR47989:SF42', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404665, 'PTHR47989:SF2', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404666, 'PTHR47989:SF43', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(404667, 'PTHR47989:SF44', NULL, NULL, NULL, NULL, 'OS01G0709500 PROTEIN', 250548),
(404668, 'PTHR47989:SF45', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404669, 'PTHR47989:SF47', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBL28-RELATED', 250548),
(404670, 'PTHR47989:SF48', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404671, 'PTHR47989:SF9', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 250548),
(404672, 'PTHR47989:SF8', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404673, 'PTHR47989:SF5', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404674, 'PTHR47989:SF4', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404675, 'PTHR47989:SF7', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250548),
(404676, 'PTHR47989:SF50', NULL, NULL, NULL, NULL, '', 250548),
(404677, 'PTHR34987', NULL, NULL, NULL, NULL, 'C, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G02880)-RELATED', 250549),
(404678, 'PTHR34987:SF2', NULL, NULL, NULL, NULL, 'B, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G05040)-RELATED', 250549),
(404679, 'PTHR34987:SF5', NULL, NULL, NULL, NULL, 'ALPHA-RHAMNOSIDASE', 250549),
(404680, 'PTHR34987:SF4', NULL, NULL, NULL, NULL, 'BAC_RHAMNOSID_C DOMAIN-CONTAINING PROTEIN-RELATED', 250549),
(404681, 'PTHR34278:SF9', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH PDZ-BINDING PROTEIN', 250550),
(404682, 'PTHR34278:SF15', NULL, NULL, NULL, NULL, 'HOP-INTERACTING PROTEIN', 250550),
(404683, 'PTHR34278:SF14', NULL, NULL, NULL, NULL, '', 250550),
(404684, 'PTHR34278:SF8', NULL, NULL, NULL, NULL, '', 250550),
(404685, 'PTHR34278:SF5', NULL, NULL, NULL, NULL, 'SITE, PUTATIVE-RELATED', 250550),
(404686, 'PTHR34278:SF11', NULL, NULL, NULL, NULL, 'OS01G0510200 PROTEIN', 250550),
(404687, 'PTHR34278:SF4', NULL, NULL, NULL, NULL, 'BNAC04G02100D PROTEIN', 250550),
(404688, 'PTHR34278:SF10', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING SITE PROTEIN-RELATED', 250550),
(404689, 'PTHR34278', NULL, NULL, NULL, NULL, 'PROTEIN THI031, PUTATIVE-RELATED', 250550),
(404690, 'PTHR34278:SF1', NULL, NULL, NULL, NULL, 'PROTEIN THI031, PUTATIVE-RELATED', 250550),
(404691, 'PTHR34278:SF12', NULL, NULL, NULL, NULL, 'EF-HAND 1, CALCIUM-BINDING SITE-RELATED', 250550),
(404692, 'PTHR37680:SF1', NULL, NULL, NULL, NULL, 'C130050O18RIK PROTEIN', 250551),
(404693, 'PTHR37680', NULL, NULL, NULL, NULL, 'C130050O18RIK PROTEIN', 250551),
(404694, 'PTHR38479:SF2', NULL, NULL, NULL, NULL, 'LMO0824 PROTEIN', 250552),
(404695, 'PTHR38479', NULL, NULL, NULL, NULL, 'LMO0824 PROTEIN', 250552),
(404696, 'PTHR45713', NULL, NULL, NULL, NULL, 'FTP DOMAIN-CONTAINING PROTEIN', 250553),
(404697, 'PTHR45713:SF6', NULL, NULL, NULL, NULL, 'FTP DOMAIN-CONTAINING PROTEIN', 250553),
(404698, 'PTHR45713:SF8', NULL, NULL, NULL, NULL, 'FTP DOMAIN-CONTAINING PROTEIN-RELATED', 250553),
(404699, 'PTHR45713:SF9', NULL, NULL, NULL, NULL, 'FTP DOMAIN-CONTAINING PROTEIN', 250553),
(404700, 'PTHR45713:SF10', NULL, NULL, NULL, NULL, 'FTP DOMAIN-CONTAINING PROTEIN', 250553),
(404701, 'PTHR38634:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG16428', 250554),
(404702, 'PTHR38634:SF2', NULL, NULL, NULL, NULL, 'CBM20 DOMAIN-CONTAINING PROTEIN', 250554),
(404703, 'PTHR38634', NULL, NULL, NULL, NULL, 'PROTEIN CBG16428', 250554),
(404704, 'PTHR34955', NULL, NULL, NULL, NULL, 'IGR MOTIF PROTEIN', 250555),
(404705, 'PTHR34955:SF2', NULL, NULL, NULL, NULL, 'IGR MOTIF PROTEIN', 250555),
(404706, 'PTHR34955:SF5', NULL, NULL, NULL, NULL, 'IGR DOMAIN-CONTAINING PROTEIN', 250555),
(404707, 'PTHR10885:SF0', NULL, NULL, NULL, NULL, 'ISOPENTENYL-DIPHOSPHATE DELTA-ISOMERASE', 250556),
(404708, 'PTHR10885:SF20', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 250556),
(404709, 'PTHR10885:SF2', NULL, NULL, NULL, NULL, 'ISOPENTENYL-DIPHOSPHATE DELTA-ISOMERASE 2', 250556),
(404710, 'PTHR10885:SF21', NULL, NULL, NULL, NULL, 'ISOPENTENYL-DIPHOSPHATE DELTA-ISOMERASE II, CHLOROPLASTIC', 250556),
(404711, 'PTHR10885', NULL, NULL, NULL, NULL, 'ISOPENTENYL-DIPHOSPHATE DELTA-ISOMERASE', 250556);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(404712, 'PTHR10885:SF1', NULL, NULL, NULL, NULL, 'ISOPENTENYL-DIPHOSPHATE DELTA-ISOMERASE 2', 250556),
(404713, 'PTHR10885:SF12', NULL, NULL, NULL, NULL, 'ISOPENTENYL PYROPHOSPHATE ISOMERASE', 250556),
(404714, 'PTHR10885:SF5', NULL, NULL, NULL, NULL, 'ISOPENTENYL-DIPHOSPHATE DELTA-ISOMERASE 1', 250556),
(404715, 'PTHR10885:SF17', NULL, NULL, NULL, NULL, 'ISOPENTENYL-DIPHOSPHATE DELTA-ISOMERASE I, CHLOROPLASTIC', 250556),
(404716, 'PTHR10885:SF18', NULL, NULL, NULL, NULL, 'ISOPENTENYL-DIPHOSPHATE DELTA-ISOMERASE', 250556),
(404717, 'PTHR10885:SF19', NULL, NULL, NULL, NULL, 'ISOPENTENYL-DIPHOSPHATE DELTA-ISOMERASE', 250556),
(404718, 'PTHR45128', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE TYPE 11', 250557),
(404719, 'PTHR45128:SF1', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE TYPE 11', 250557),
(404720, 'PTHR45128:SF2', NULL, NULL, NULL, NULL, 'METHYLTRANFER_DOM DOMAIN-CONTAINING PROTEIN', 250557),
(404721, 'PTHR16058:SF4', NULL, NULL, NULL, NULL, 'DOUBLE ZINC RIBBON AND ANKYRIN REPEAT-CONTAINING PROTEIN 1', 250558),
(404722, 'PTHR16058', NULL, NULL, NULL, NULL, 'DOUBLE ZINC RIBBON AND ANKYRIN REPEAT-CONTAINING PROTEIN 1', 250558),
(404723, 'PTHR33631:SF1', NULL, NULL, NULL, NULL, '', 250559),
(404724, 'PTHR33631:SF2', NULL, NULL, NULL, NULL, '', 250559),
(404725, 'PTHR33631', NULL, NULL, NULL, NULL, '', 250559),
(404726, 'PTHR37445:SF3', NULL, NULL, NULL, NULL, 'PHD-FINGER FAMILY PROTEIN', 250560),
(404727, 'PTHR37445', NULL, NULL, NULL, NULL, 'PROTEIN CBG24663', 250560),
(404728, 'PTHR13857:SF45', NULL, NULL, NULL, NULL, 'DNA DC-DU-EDITING ENZYME APOBEC-3F', 250561),
(404729, 'PTHR13857:SF24', NULL, NULL, NULL, NULL, 'DNA DC-DU-EDITING ENZYME APOBEC-3D', 250561),
(404730, 'PTHR13857:SF46', NULL, NULL, NULL, NULL, 'DNA DC-DU-EDITING ENZYME APOBEC-3C', 250561),
(404731, 'PTHR13857:SF47', NULL, NULL, NULL, NULL, 'CMP/DCMP-TYPE DEAMINASE DOMAIN-CONTAINING PROTEIN', 250561),
(404732, 'PTHR13857:SF26', NULL, NULL, NULL, NULL, 'C-U-EDITING ENZYME APOBEC-1', 250561),
(404733, 'PTHR13857:SF20', NULL, NULL, NULL, NULL, 'DNA DC-DU-EDITING ENZYME APOBEC-3G', 250561),
(404734, 'PTHR13857:SF42', NULL, NULL, NULL, NULL, 'DNA DC-DU-EDITING ENZYME APOBEC3-LIKE', 250561),
(404735, 'PTHR13857:SF10', NULL, NULL, NULL, NULL, 'SINGLE-STRANDED DNA CYTOSINE DEAMINASE', 250561),
(404736, 'PTHR13857:SF43', NULL, NULL, NULL, NULL, 'DNA DC-DU-EDITING ENZYME APOBEC-3H', 250561),
(404737, 'PTHR13857', NULL, NULL, NULL, NULL, 'MRNA EDITING ENZYME', 250561),
(404738, 'PTHR13857:SF4', NULL, NULL, NULL, NULL, 'C-U-EDITING ENZYME APOBEC-2', 250561),
(404739, 'PTHR13857:SF39', NULL, NULL, NULL, NULL, 'DNA DC-DU-EDITING ENZYME APOBEC-3A-RELATED', 250561),
(404740, 'PTHR30195:SF16', NULL, NULL, NULL, NULL, 'TYPE I RESTRICTION ENZYME R PROTEIN', 250562),
(404741, 'PTHR30195', NULL, NULL, NULL, NULL, 'TYPE I SITE-SPECIFIC DEOXYRIBONUCLEASE PROTEIN SUBUNIT M AND R', 250562),
(404742, 'PTHR30195:SF15', NULL, NULL, NULL, NULL, 'TYPE I RESTRICTION ENZYME HINDVIIP R PROTEIN-RELATED', 250562),
(404743, 'PTHR35819:SF3', NULL, NULL, NULL, NULL, '', 250563),
(404744, 'PTHR35819:SF4', NULL, NULL, NULL, NULL, '', 250563),
(404745, 'PTHR35819:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PIMREG', 250563),
(404746, 'PTHR35819:SF2', NULL, NULL, NULL, NULL, '', 250563),
(404747, 'PTHR35819', NULL, NULL, NULL, NULL, 'PICALM INTERACTING MITOTIC REGULATOR PIMREG', 250563),
(404748, 'PTHR10263:SF18', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE 21 KDA PROTEOLIPID SUBUNIT', 250564),
(404749, 'PTHR10263:SF9', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE PROTEOLIPID SUBUNIT', 250564),
(404750, 'PTHR10263:SF8', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT C''', 250564),
(404751, 'PTHR10263:SF5', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE 16 KDA PROTEOLIPID SUBUNIT', 250564),
(404752, 'PTHR10263:SF6', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE PROTEOLIPID SUBUNIT', 250564),
(404753, 'PTHR10263:SF72', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE 16 KDA PROTEOLIPID SUBUNIT 1', 250564),
(404754, 'PTHR10263:SF73', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE PROTEOLIPID SUBUNIT', 250564);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(404755, 'PTHR10263:SF70', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE PROTEOLIPID SUBUNIT', 250564),
(404756, 'PTHR10263:SF76', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT C''''2', 250564),
(404757, 'PTHR10263:SF55', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT C''''1-RELATED', 250564),
(404758, 'PTHR10263:SF74', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE PROTEOLIPID SUBUNIT', 250564),
(404759, 'PTHR10263:SF53', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE PROTEOLIPID SUBUNIT', 250564),
(404760, 'PTHR10263:SF75', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE PROTEOLIPID SUBUNIT', 250564),
(404761, 'PTHR10263', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE PROTEOLIPID SUBUNIT', 250564),
(404762, 'PTHR10263:SF57', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT C5', 250564),
(404763, 'PTHR10263:SF49', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT C3', 250564),
(404764, 'PTHR10263:SF61', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE 16 KDA PROTEOLIPID SUBUNIT', 250564),
(404765, 'PTHR10263:SF40', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE PROTEOLIPID SUBUNIT', 250564),
(404766, 'PTHR10263:SF60', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT C2', 250564),
(404767, 'PTHR10263:SF65', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE PROTEOLIPID SUBUNIT', 250564),
(404768, 'PTHR10263:SF64', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT C4', 250564),
(404769, 'PTHR10263:SF69', NULL, NULL, NULL, NULL, 'ATPASE, F0/V0 COMPLEX, SUBUNIT C PROTEIN-RELATED', 250564),
(404770, 'PTHR10263:SF47', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE PROTEOLIPID SUBUNIT', 250564),
(404771, 'PTHR10263:SF48', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE PROTEOLIPID SUBUNIT', 250564),
(404772, 'PTHR10263:SF68', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE 16 KDA PROTEOLIPID SUBUNIT', 250564),
(404773, 'PTHR13411:SF6', NULL, NULL, NULL, NULL, 'PLASMINOGEN RECEPTOR (KT)', 250565),
(404774, 'PTHR13411:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBR-TAG-281', 250565),
(404775, 'PTHR13411', NULL, NULL, NULL, NULL, 'PLASMINOGEN RECEPTOR (KT)', 250565),
(404776, 'PTHR36853:SF1', NULL, NULL, NULL, NULL, 'DUF3844 DOMAIN-CONTAINING PROTEIN', 250566),
(404777, 'PTHR36853', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250566),
(404778, 'PTHR35157:SF4', NULL, NULL, NULL, NULL, 'PROTEIN FAM209B', 250567),
(404779, 'PTHR35157', NULL, NULL, NULL, NULL, 'PROTEIN FAM209A', 250567),
(404780, 'PTHR35157:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAM209A', 250567),
(404781, 'PTHR32401:SF40', NULL, NULL, NULL, NULL, 'LECTIN_LEGB DOMAIN-CONTAINING PROTEIN', 250568),
(404782, 'PTHR32401:SF20', NULL, NULL, NULL, NULL, 'LECTIN_LEGB DOMAIN-CONTAINING PROTEIN', 250568),
(404783, 'PTHR32401:SF42', NULL, NULL, NULL, NULL, 'LECTIN_LEGB DOMAIN-CONTAINING PROTEIN', 250568),
(404784, 'PTHR32401:SF41', NULL, NULL, NULL, NULL, 'OS09G0336400 PROTEIN', 250568),
(404785, 'PTHR32401:SF44', NULL, NULL, NULL, NULL, 'LECTIN_LEGB DOMAIN-CONTAINING PROTEIN', 250568),
(404786, 'PTHR32401:SF22', NULL, NULL, NULL, NULL, 'LEGUME LECTIN BETA DOMAIN PROTEIN', 250568),
(404787, 'PTHR32401:SF43', NULL, NULL, NULL, NULL, 'OS04G0110100 PROTEIN', 250568),
(404788, 'PTHR32401:SF21', NULL, NULL, NULL, NULL, 'LECTIN 7', 250568),
(404789, 'PTHR32401:SF46', NULL, NULL, NULL, NULL, 'LECTIN_LEGB DOMAIN-CONTAINING PROTEIN', 250568),
(404790, 'PTHR32401:SF45', NULL, NULL, NULL, NULL, 'LECTIN', 250568),
(404791, 'PTHR32401:SF26', NULL, NULL, NULL, NULL, 'LEGUME LECTIN BETA DOMAIN PROTEIN', 250568),
(404792, 'PTHR32401:SF25', NULL, NULL, NULL, NULL, 'CONCANAVALIN A-LIKE LECTIN FAMILY PROTEIN', 250568),
(404793, 'PTHR32401:SF28', NULL, NULL, NULL, NULL, 'OS10G0129200 PROTEIN', 250568),
(404794, 'PTHR32401:SF27', NULL, NULL, NULL, NULL, 'LECTIN_LEGB DOMAIN-CONTAINING PROTEIN', 250568),
(404795, 'PTHR32401:SF31', NULL, NULL, NULL, NULL, 'LECTIN 6', 250568),
(404796, 'PTHR32401:SF30', NULL, NULL, NULL, NULL, 'LECTIN_LEGB DOMAIN-CONTAINING PROTEIN', 250568),
(404797, 'PTHR32401:SF11', NULL, NULL, NULL, NULL, 'CONCANAVALIN A-LIKE LECTIN FAMILY PROTEIN', 250568);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(404798, 'PTHR32401:SF33', NULL, NULL, NULL, NULL, 'LECTIN_LEGB DOMAIN-CONTAINING PROTEIN', 250568),
(404799, 'PTHR32401:SF32', NULL, NULL, NULL, NULL, 'LECTIN_LEGB DOMAIN-CONTAINING PROTEIN', 250568),
(404800, 'PTHR32401:SF35', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-DOMAIN CONTAINING RECEPTOR KINASE IV.2-LIKE', 250568),
(404801, 'PTHR32401:SF13', NULL, NULL, NULL, NULL, 'LECTIN_LEGB DOMAIN-CONTAINING PROTEIN', 250568),
(404802, 'PTHR32401:SF34', NULL, NULL, NULL, NULL, 'LECTIN_LEGB DOMAIN-CONTAINING PROTEIN', 250568),
(404803, 'PTHR32401:SF15', NULL, NULL, NULL, NULL, 'LECTIN_LEGB DOMAIN-CONTAINING PROTEIN', 250568),
(404804, 'PTHR32401:SF37', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 250568),
(404805, 'PTHR32401:SF14', NULL, NULL, NULL, NULL, 'LECTIN 5', 250568),
(404806, 'PTHR32401:SF36', NULL, NULL, NULL, NULL, 'OS08G0514100 PROTEIN', 250568),
(404807, 'PTHR32401:SF39', NULL, NULL, NULL, NULL, 'LECTIN-LIKE PROTEIN LEC', 250568),
(404808, 'PTHR32401:SF17', NULL, NULL, NULL, NULL, 'LEGUME LECTIN BETA DOMAIN PROTEIN', 250568),
(404809, 'PTHR32401:SF16', NULL, NULL, NULL, NULL, 'CONCANAVALIN A-LIKE LECTIN FAMILY PROTEIN', 250568),
(404810, 'PTHR32401:SF38', NULL, NULL, NULL, NULL, 'LECTIN-LIKE PROTEIN', 250568),
(404811, 'PTHR32401:SF18', NULL, NULL, NULL, NULL, 'LECTIN_LEGB DOMAIN-CONTAINING PROTEIN', 250568),
(404812, 'PTHR32401', NULL, NULL, NULL, NULL, 'CONCANAVALIN A-LIKE LECTIN FAMILY PROTEIN', 250568),
(404813, 'PTHR30031:SF19', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYKINASE (ATP)', 250569),
(404814, 'PTHR30031:SF2', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYKINASE (ATP)', 250569),
(404815, 'PTHR30031:SF27', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYKINASE (ATP)', 250569),
(404816, 'PTHR30031:SF0', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYKINASE (ATP)', 250569),
(404817, 'PTHR30031:SF26', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYKINASE (ATP)', 250569),
(404818, 'PTHR30031:SF25', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYKINASE (ATP)', 250569),
(404819, 'PTHR30031:SF24', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYKINASE (ATP) 1', 250569),
(404820, 'PTHR30031', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYKINASE  ATP', 250569),
(404821, 'PTHR30031:SF23', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYKINASE (ATP)', 250569),
(404822, 'PTHR30031:SF22', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYKINASE (ATP)', 250569),
(404823, 'PTHR30031:SF11', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYKINASE (ATP)', 250569),
(404824, 'PTHR30031:SF21', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYKINASE (ATP)', 250569),
(404825, 'PTHR43481:SF8', NULL, NULL, NULL, NULL, 'GLYCEROL-1-PHOSPHATE PHOSPHOHYDROLASE 1-RELATED', 250570),
(404826, 'PTHR43481', NULL, NULL, NULL, NULL, 'FRUCTOSE-1-PHOSPHATE PHOSPHATASE', 250570),
(404827, 'PTHR43481:SF2', NULL, NULL, NULL, NULL, '', 250570),
(404828, 'PTHR43481:SF4', NULL, NULL, NULL, NULL, '2-DEOXYGLUCOSE-6-PHOSPHATE PHOSPHATASE 1-RELATED', 250570),
(404829, 'PTHR46686:SF7', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY PROTEIN', 250571),
(404830, 'PTHR46686:SF6', NULL, NULL, NULL, NULL, 'LOW QUALITY PROTEIN: D-INOSITOL 3-PHOSPHATE GLYCOSYLTRANSFERASE-LIKE', 250571),
(404831, 'PTHR46686:SF5', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 250571),
(404832, 'PTHR46686:SF4', NULL, NULL, NULL, NULL, 'GLYCO_TRANS_4-LIKE_N DOMAIN-CONTAINING PROTEIN', 250571),
(404833, 'PTHR46686:SF2', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 250571),
(404834, 'PTHR46686', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 250571),
(404835, 'PTHR39431:SF1', NULL, NULL, NULL, NULL, 'FRPA/C-RELATED PROTEIN', 250572),
(404836, 'PTHR39431', NULL, NULL, NULL, NULL, 'FRPA/C-RELATED PROTEIN', 250572),
(404837, 'PTHR41146:SF1', NULL, NULL, NULL, NULL, 'DIURETIC HORMONE CLASS 2', 250573),
(404838, 'PTHR41146', NULL, NULL, NULL, NULL, 'DIURETIC HORMONE CLASS 2', 250573),
(404839, 'PTHR13528', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L28, MITOCHONDRIAL', 250574);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(404840, 'PTHR13528:SF2', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L28, MITOCHONDRIAL', 250574),
(404841, 'PTHR47139:SF1', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 9', 250575),
(404842, 'PTHR47139:SF4', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY, MEMBER 9A-RELATED', 250575),
(404843, 'PTHR47139', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 9', 250575),
(404844, 'PTHR47139:SF3', NULL, NULL, NULL, NULL, 'SI:CH73-361P23.3', 250575),
(404845, 'PTHR13390:SF0', NULL, NULL, NULL, NULL, 'LIPID DROPLET-ASSOCIATED HYDROLASE', 250576),
(404846, 'PTHR13390:SF2', NULL, NULL, NULL, NULL, 'BNAA05G27450D PROTEIN', 250576),
(404847, 'PTHR13390', NULL, NULL, NULL, NULL, 'LIPASE', 250576),
(404848, 'PTHR13390:SF3', NULL, NULL, NULL, NULL, 'LIPID DROPLET-ASSOCIATED HYDROLASE', 250576),
(404849, 'PTHR23111:SF35', NULL, NULL, NULL, NULL, 'OS08G0521400 PROTEIN', 250577),
(404850, 'PTHR23111:SF99', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 13D', 250577),
(404851, 'PTHR23111:SF98', NULL, NULL, NULL, NULL, 'ZINC FINGER RAN-BINDING DOMAIN-CONTAINING PROTEIN 2-LIKE ISOFORM X1', 250577),
(404852, 'PTHR23111:SF75', NULL, NULL, NULL, NULL, 'OS06G0141200 PROTEIN', 250577),
(404853, 'PTHR23111:SF97', NULL, NULL, NULL, NULL, 'ZINC FINGER (RAN-BINDING) FAMILY PROTEIN', 250577),
(404854, 'PTHR23111:SF96', NULL, NULL, NULL, NULL, 'OS01G0555100 PROTEIN', 250577),
(404855, 'PTHR23111:SF74', NULL, NULL, NULL, NULL, 'OS02G0203700 PROTEIN', 250577),
(404856, 'PTHR23111:SF30', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN VAR3, CHLOROPLASTIC', 250577),
(404857, 'PTHR23111:SF95', NULL, NULL, NULL, NULL, 'ZINC FINGER, RANBP2-TYPE-RELATED', 250577),
(404858, 'PTHR23111:SF94', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 13B', 250577),
(404859, 'PTHR23111:SF71', NULL, NULL, NULL, NULL, 'ZN-FINGER, RANBP-TYPE, CONTAINING PROTEIN', 250577),
(404860, 'PTHR23111:SF93', NULL, NULL, NULL, NULL, 'ZINC FINGER, RANBP2-TYPE-RELATED', 250577),
(404861, 'PTHR23111', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 250577),
(404862, 'PTHR23111:SF29', NULL, NULL, NULL, NULL, 'OS07G0404300 PROTEIN', 250577),
(404863, 'PTHR23111:SF28', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 13C-RELATED', 250577),
(404864, 'PTHR23111:SF69', NULL, NULL, NULL, NULL, 'OS07G0490600 PROTEIN', 250577),
(404865, 'PTHR23111:SF100', NULL, NULL, NULL, NULL, '', 250577),
(404866, 'PTHR23111:SF68', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 13C-1', 250577),
(404867, 'PTHR23111:SF24', NULL, NULL, NULL, NULL, 'OS01G0203300 PROTEIN', 250577),
(404868, 'PTHR23111:SF101', NULL, NULL, NULL, NULL, 'ZINC FINGER, RANBP2-TYPE-RELATED', 250577),
(404869, 'PTHR23111:SF23', NULL, NULL, NULL, NULL, 'RAN BP2/NZF ZINC FINGER-LIKE SUPERFAMILY PROTEIN', 250577),
(404870, 'PTHR23111:SF87', NULL, NULL, NULL, NULL, 'BNAA01G28590D PROTEIN', 250577),
(404871, 'PTHR23111:SF64', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 13A', 250577),
(404872, 'PTHR23111:SF41', NULL, NULL, NULL, NULL, 'ZINC FINGER, RANBP2-TYPE-RELATED', 250577),
(404873, 'PTHR23111:SF40', NULL, NULL, NULL, NULL, 'ASPARAGINE-RICH PROTEIN', 250577),
(404874, 'PTHR23111:SF82', NULL, NULL, NULL, NULL, 'RAN BP2/NZF ZINC FINGER-LIKE SUPERFAMILY PROTEIN', 250577),
(404875, 'PTHR23111:SF81', NULL, NULL, NULL, NULL, '', 250577),
(404876, 'PTHR23111:SF102', NULL, NULL, NULL, NULL, 'ZINC FINGER RAN-BINDING DOMAIN-CONTAINING PROTEIN 2-LIKE', 250577),
(404877, 'PTHR23111:SF103', NULL, NULL, NULL, NULL, '', 250577),
(404878, 'PTHR37864:SF1', NULL, NULL, NULL, NULL, 'SIMILAR TO AVLV472', 250578),
(404879, 'PTHR37864', NULL, NULL, NULL, NULL, 'SIMILAR TO AVLV472', 250578),
(404880, 'PTHR30218:SF0', NULL, NULL, NULL, NULL, 'POLYPHOSPHATE KINASE', 250579),
(404881, 'PTHR30218', NULL, NULL, NULL, NULL, 'POLYPHOSPHATE KINASE', 250579),
(404882, 'PTHR11202:SF19', NULL, NULL, NULL, NULL, 'SPROUTY-RELATED, EVH1 DOMAIN-CONTAINING PROTEIN 3', 250580),
(404883, 'PTHR11202:SF18', NULL, NULL, NULL, NULL, 'SPROUTY-RELATED, EVH1 DOMAIN-CONTAINING PROTEIN 1', 250580);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(404884, 'PTHR11202:SF12', NULL, NULL, NULL, NULL, 'VASODILATOR-STIMULATED PHOSPHOPROTEIN', 250580),
(404885, 'PTHR11202:SF37', NULL, NULL, NULL, NULL, 'ENA/VASP-LIKE PROTEIN', 250580),
(404886, 'PTHR11202:SF36', NULL, NULL, NULL, NULL, 'WASP-LIKE ACTIN NUCLEATION-PROMOTING FACTOR B', 250580),
(404887, 'PTHR11202:SF3', NULL, NULL, NULL, NULL, 'SPROUTY-RELATED PROTEIN WITH EVH-1 DOMAIN, ISOFORM C', 250580),
(404888, 'PTHR11202:SF4', NULL, NULL, NULL, NULL, 'ENA/VASP-LIKE PROTEIN', 250580),
(404889, 'PTHR11202', NULL, NULL, NULL, NULL, 'SPROUTY-RELATED, EVH1 DOMAIN-CONTAINING PROTEIN FAMILY MEMBER', 250580),
(404890, 'PTHR11202:SF11', NULL, NULL, NULL, NULL, 'SPROUTY-RELATED, EVH1 DOMAIN-CONTAINING PROTEIN 2', 250580),
(404891, 'PTHR11202:SF22', NULL, NULL, NULL, NULL, 'PROTEIN ENABLED', 250580),
(404892, 'PTHR11202:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ENABLED HOMOLOG', 250580),
(404893, 'PTHR37237:SF1', NULL, NULL, NULL, NULL, 'OS02G0567000 PROTEIN', 250581),
(404894, 'PTHR37237', NULL, NULL, NULL, NULL, 'OS02G0567000 PROTEIN', 250581),
(404895, 'PTHR23149:SF27', NULL, NULL, NULL, NULL, 'PIN2/TERF1-INTERACTING TELOMERASE INHIBITOR 1', 250582),
(404896, 'PTHR23149:SF26', NULL, NULL, NULL, NULL, 'PROTEIN TMA23', 250582),
(404897, 'PTHR23149:SF9', NULL, NULL, NULL, NULL, 'G PATCH DOMAIN-CONTAINING PROTEIN 4', 250582),
(404898, 'PTHR23149:SF30', NULL, NULL, NULL, NULL, 'G-PATCH DOMAIN-CONTAINING PROTEIN', 250582),
(404899, 'PTHR23149', NULL, NULL, NULL, NULL, 'G PATCH DOMAIN CONTAINING PROTEIN', 250582),
(404900, 'PTHR23149:SF32', NULL, NULL, NULL, NULL, '', 250582),
(404901, 'PTHR23149:SF31', NULL, NULL, NULL, NULL, 'PROTEIN PXR1', 250582),
(404902, 'PTHR23149:SF33', NULL, NULL, NULL, NULL, 'G-PATCH DOMAIN-CONTAINING PROTEIN', 250582),
(404903, 'PTHR15205:SF2', NULL, NULL, NULL, NULL, 'DEATH EFFECTOR DOMAIN-CONTAINING PROTEIN', 250583),
(404904, 'PTHR15205:SF1', NULL, NULL, NULL, NULL, 'DNA-BINDING DEATH EFFECTOR DOMAIN-CONTAINING PROTEIN 2', 250583),
(404905, 'PTHR15205', NULL, NULL, NULL, NULL, 'DEATH EFFECTOR DOMAIN-CONTAINING PROTEIN', 250583),
(404906, 'PTHR15205:SF0', NULL, NULL, NULL, NULL, 'DED DOMAIN-CONTAINING PROTEIN', 250583),
(404907, 'PTHR17537:SF3', NULL, NULL, NULL, NULL, 'PROTEIN TOB2', 250584),
(404908, 'PTHR17537', NULL, NULL, NULL, NULL, 'TRANSDUCER OF ERBB2  TOB', 250584),
(404909, 'PTHR17537:SF6', NULL, NULL, NULL, NULL, 'PROTEIN TOB1', 250584),
(404910, 'PTHR17537:SF5', NULL, NULL, NULL, NULL, 'TRANSDUCER OF ERBB2, ISOFORM A', 250584),
(404911, 'PTHR31521', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250585),
(404912, 'PTHR31521:SF4', NULL, NULL, NULL, NULL, 'PROTEIN NARROW LEAF 1', 250585),
(404913, 'PTHR31521:SF3', NULL, NULL, NULL, NULL, 'PEPTIDASE S1, PA CLAN-RELATED', 250585),
(404914, 'PTHR31521:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250585),
(404915, 'PTHR31521:SF5', NULL, NULL, NULL, NULL, '', 250585),
(404916, 'PTHR46693', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 15', 250586),
(404917, 'PTHR46693:SF1', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 15', 250586),
(404918, 'PTHR11693:SF36', NULL, NULL, NULL, NULL, 'ATP SYNTHASE GAMMA CHAIN 2, CHLOROPLASTIC', 250587),
(404919, 'PTHR11693:SF35', NULL, NULL, NULL, NULL, 'PEPT_C1 DOMAIN-CONTAINING PROTEIN', 250587),
(404920, 'PTHR11693:SF43', NULL, NULL, NULL, NULL, 'BNAC03G29960D PROTEIN', 250587),
(404921, 'PTHR11693:SF32', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT GAMMA', 250587),
(404922, 'PTHR11693:SF22', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT GAMMA, MITOCHONDRIAL', 250587),
(404923, 'PTHR11693:SF44', NULL, NULL, NULL, NULL, '', 250587),
(404924, 'PTHR11693:SF33', NULL, NULL, NULL, NULL, 'F0F1 ATP SYNTHASE SUBUNIT GAMMA', 250587),
(404925, 'PTHR11693:SF41', NULL, NULL, NULL, NULL, 'ATP SYNTHASE GAMMA CHAIN', 250587),
(404926, 'PTHR11693:SF42', NULL, NULL, NULL, NULL, 'ATP SYNTHASE GAMMA CHAIN 1, CHLOROPLASTIC', 250587),
(404927, 'PTHR11693:SF31', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT GAMMA, MITOCHONDRIAL', 250587),
(404928, 'PTHR11693:SF29', NULL, NULL, NULL, NULL, 'ATP SYNTHASE GAMMA CHAIN, CHLOROPLASTIC-LIKE', 250587);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(404929, 'PTHR11693:SF39', NULL, NULL, NULL, NULL, 'BNAC04G11660D PROTEIN', 250587),
(404930, 'PTHR11693', NULL, NULL, NULL, NULL, 'ATP SYNTHASE GAMMA CHAIN', 250587),
(404931, 'PTHR11693:SF28', NULL, NULL, NULL, NULL, 'POLLEN-LIKE PROTEIN, PUTATIVE-RELATED', 250587),
(404932, 'PTHR15036:SF48', NULL, NULL, NULL, NULL, 'NEUREXIN-3B', 250588),
(404933, 'PTHR15036:SF49', NULL, NULL, NULL, NULL, 'NEUREXIN-4', 250588),
(404934, 'PTHR15036:SF82', NULL, NULL, NULL, NULL, '', 250588),
(404935, 'PTHR15036:SF83', NULL, NULL, NULL, NULL, 'AGRIN', 250588),
(404936, 'PTHR15036:SF80', NULL, NULL, NULL, NULL, 'CONTACTIN-ASSOCIATED PROTEIN LIKE 5-1', 250588),
(404937, 'PTHR15036:SF81', NULL, NULL, NULL, NULL, 'LAMININ SUBUNIT ALPHA-1', 250588),
(404938, 'PTHR15036:SF86', NULL, NULL, NULL, NULL, 'AXOTACTIN, ISOFORM C', 250588),
(404939, 'PTHR15036:SF43', NULL, NULL, NULL, NULL, 'CONTACTIN-ASSOCIATED PROTEIN 1', 250588),
(404940, 'PTHR15036:SF87', NULL, NULL, NULL, NULL, '', 250588),
(404941, 'PTHR15036:SF65', NULL, NULL, NULL, NULL, 'LAMININ SUBUNIT ALPHA-2', 250588),
(404942, 'PTHR15036:SF40', NULL, NULL, NULL, NULL, 'CONTACTIN-ASSOCIATED PROTEIN-LIKE 4', 250588),
(404943, 'PTHR15036:SF84', NULL, NULL, NULL, NULL, 'CONTACTIN-ASSOCIATED PROTEIN FAMILY MEMBER 5A', 250588),
(404944, 'PTHR15036:SF85', NULL, NULL, NULL, NULL, 'SP2353, ISOFORM A', 250588),
(404945, 'PTHR15036:SF46', NULL, NULL, NULL, NULL, 'CONTACTIN-ASSOCIATED PROTEIN-LIKE 5', 250588),
(404946, 'PTHR15036:SF47', NULL, NULL, NULL, NULL, 'LAMININ SUBUNIT ALPHA-4', 250588),
(404947, 'PTHR15036:SF88', NULL, NULL, NULL, NULL, 'PIKACHURIN', 250588),
(404948, 'PTHR15036:SF67', NULL, NULL, NULL, NULL, 'LAM_G_DOMAIN DOMAIN-CONTAINING PROTEIN', 250588),
(404949, 'PTHR15036:SF89', NULL, NULL, NULL, NULL, 'NEUREXIN 1, ISOFORM F', 250588),
(404950, 'PTHR15036', NULL, NULL, NULL, NULL, 'PIKACHURIN-LIKE PROTEIN', 250588),
(404951, 'PTHR15036:SF17', NULL, NULL, NULL, NULL, 'CHONDROITIN SULFATE PROTEOGLYCAN 4', 250588),
(404952, 'PTHR15036:SF15', NULL, NULL, NULL, NULL, 'CHONDROITIN SULFATE PROTEOGLYCAN 4B', 250588),
(404953, 'PTHR15036:SF75', NULL, NULL, NULL, NULL, 'CONTACTIN-ASSOCIATED PROTEIN LIKE 5-2', 250588),
(404954, 'PTHR15036:SF76', NULL, NULL, NULL, NULL, 'CONTACTIN-ASSOCIATED PROTEIN-LIKE 4', 250588),
(404955, 'PTHR15036:SF51', NULL, NULL, NULL, NULL, 'NEUREXIN-1', 250588),
(404956, 'PTHR15036:SF52', NULL, NULL, NULL, NULL, 'NEUREXIN-2', 250588),
(404957, 'PTHR15036:SF79', NULL, NULL, NULL, NULL, 'LAM_G_DOMAIN DOMAIN-CONTAINING PROTEIN', 250588),
(404958, 'PTHR15036:SF57', NULL, NULL, NULL, NULL, 'NEUREXIN-3', 250588),
(404959, 'PTHR15036:SF36', NULL, NULL, NULL, NULL, 'CONTACTIN-ASSOCIATED PROTEIN-LIKE 3-RELATED', 250588),
(404960, 'PTHR15036:SF33', NULL, NULL, NULL, NULL, 'CONTACTIN-ASSOCIATED PROTEIN-LIKE 2', 250588),
(404961, 'PTHR15036:SF56', NULL, NULL, NULL, NULL, 'KON-TIKI, ISOFORM B', 250588),
(404962, 'PTHR15036:SF34', NULL, NULL, NULL, NULL, 'LAMININ SUBUNIT ALPHA-3', 250588),
(404963, 'PTHR24247:SF222', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE (SEROTONIN) RECEPTOR 2B, ISOFORM E', 250589),
(404964, 'PTHR24247:SF223', NULL, NULL, NULL, NULL, 'HISTAMINE H1 RECEPTOR', 250589),
(404965, 'PTHR24247:SF264', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 250589),
(404966, 'PTHR24247:SF221', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE RECEPTOR 1', 250589),
(404967, 'PTHR24247:SF182', NULL, NULL, NULL, NULL, 'MUSCARINIC ACETYLCHOLINE RECEPTOR M1', 250589),
(404968, 'PTHR24247:SF180', NULL, NULL, NULL, NULL, 'MUSCARINIC ACETYLCHOLINE RECEPTOR M4', 250589),
(404969, 'PTHR24247:SF262', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 250589),
(404970, 'PTHR24247:SF263', NULL, NULL, NULL, NULL, 'HISTAMINE H2 RECEPTOR', 250589),
(404971, 'PTHR24247:SF260', NULL, NULL, NULL, NULL, 'BETA-3 ADRENERGIC RECEPTOR', 250589),
(404972, 'PTHR24247:SF183', NULL, NULL, NULL, NULL, 'MUSCARINIC ACETYLCHOLINE RECEPTOR M3', 250589),
(404973, 'PTHR24247:SF184', NULL, NULL, NULL, NULL, 'MUSCARINIC ACETYLCHOLINE RECEPTOR GAR-1-RELATED', 250589);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(404974, 'PTHR24247:SF261', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 250589),
(404975, 'PTHR24247:SF92', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 250589),
(404976, 'PTHR24247:SF16', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE RECEPTOR 1B', 250589),
(404977, 'PTHR24247:SF17', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE RECEPTOR 1D', 250589),
(404978, 'PTHR24247:SF107', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 250589),
(404979, 'PTHR24247:SF228', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE (SEROTONIN) RECEPTOR 2A, ISOFORM B', 250589),
(404980, 'PTHR24247:SF108', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE RECEPTOR 5A', 250589),
(404981, 'PTHR24247:SF14', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE RECEPTOR 5B', 250589),
(404982, 'PTHR24247:SF211', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 250589),
(404983, 'PTHR24247:SF255', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE RECEPTOR 2A-RELATED', 250589),
(404984, 'PTHR24247:SF212', NULL, NULL, NULL, NULL, 'PARIETOPSIN', 250589),
(404985, 'PTHR24247:SF179', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE RECEPTOR 4', 250589),
(404986, 'PTHR24247:SF256', NULL, NULL, NULL, NULL, 'DOPAMINE RECEPTOR 2', 250589),
(404987, 'PTHR24247:SF253', NULL, NULL, NULL, NULL, 'GASTRIC RECEPTOR I', 250589),
(404988, 'PTHR24247:SF254', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 250589),
(404989, 'PTHR24247:SF259', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 250589),
(404990, 'PTHR24247:SF216', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 250589),
(404991, 'PTHR24247:SF257', NULL, NULL, NULL, NULL, 'OCTOPAMINE RECEPTOR OAMB', 250589),
(404992, 'PTHR24247:SF258', NULL, NULL, NULL, NULL, 'DOPAMINE RECEPTOR 4', 250589),
(404993, 'PTHR24247', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE RECEPTOR', 250589),
(404994, 'PTHR24247:SF131', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN-RELATED', 250589),
(404995, 'PTHR24247:SF172', NULL, NULL, NULL, NULL, 'TRACE AMINE-ASSOCIATED RECEPTOR 10-RELATED', 250589),
(404996, 'PTHR24247:SF217', NULL, NULL, NULL, NULL, 'D(1A) DOPAMINE RECEPTOR', 250589),
(404997, 'PTHR24247:SF88', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE RECEPTOR 7', 250589),
(404998, 'PTHR24247:SF244', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE RECEPTOR 7', 250589),
(404999, 'PTHR24247:SF205', NULL, NULL, NULL, NULL, 'D(4) DOPAMINE RECEPTOR', 250589),
(405000, 'PTHR24247:SF249', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 250589),
(405001, 'PTHR24247:SF202', NULL, NULL, NULL, NULL, 'HISTAMINE H2 RECEPTOR', 250589),
(405002, 'PTHR24247:SF241', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 250589),
(405003, 'PTHR24247:SF30', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE RECEPTOR 2A', 250589),
(405004, 'PTHR24247:SF31', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE RECEPTOR 2B', 250589),
(405005, 'PTHR24247:SF32', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE RECEPTOR 2C', 250589),
(405006, 'PTHR24247:SF208', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 250589),
(405007, 'PTHR24247:SF209', NULL, NULL, NULL, NULL, 'MUSCARINIC ACETYLCHOLINE RECEPTOR M5', 250589),
(405008, 'PTHR24247:SF207', NULL, NULL, NULL, NULL, 'MUSCARINIC ACETYLCHOLINE RECEPTOR M2', 250589),
(405009, 'PTHR24247:SF33', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE RECEPTOR 1E', 250589),
(405010, 'PTHR24247:SF34', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE RECEPTOR 1F', 250589),
(405011, 'PTHR24247:SF199', NULL, NULL, NULL, NULL, 'HISTAMINE H4 RECEPTOR', 250589),
(405012, 'PTHR24247:SF232', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE (SEROTONIN) RECEPTOR 1A B', 250589),
(405013, 'PTHR24247:SF116', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE RECEPTOR 7', 250589),
(405014, 'PTHR24247:SF238', NULL, NULL, NULL, NULL, 'DOPAMINE RECEPTOR 1', 250589),
(405015, 'PTHR24247:SF236', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE RECEPTOR 6', 250589);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(405016, 'PTHR24247:SF193', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 250589),
(405017, 'PTHR24247:SF191', NULL, NULL, NULL, NULL, 'MUSCARINIC ACETYLCHOLINE RECEPTOR, B-TYPE, ISOFORM A', 250589),
(405018, 'PTHR24247:SF194', NULL, NULL, NULL, NULL, 'HISTAMINE H3 RECEPTOR', 250589),
(405019, 'PTHR24247:SF195', NULL, NULL, NULL, NULL, 'MUSCARINIC ACETYLCHOLINE RECEPTOR DM1', 250589),
(405020, 'PTHR24247:SF20', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE RECEPTOR 1A', 250589),
(405021, 'PTHR46408:SF9', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER 10', 250590),
(405022, 'PTHR46408', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER 63', 250590),
(405023, 'PTHR46408:SF19', NULL, NULL, NULL, NULL, 'BNAA09G26320D PROTEIN', 250590),
(405024, 'PTHR46408:SF18', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR', 250590),
(405025, 'PTHR46408:SF16', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 250590),
(405026, 'PTHR46408:SF2', NULL, NULL, NULL, NULL, 'OS12G0601800 PROTEIN', 250590),
(405027, 'PTHR46408:SF4', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 250590),
(405028, 'PTHR46408:SF14', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER 25', 250590),
(405029, 'PTHR46408:SF5', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 250590),
(405030, 'PTHR46408:SF12', NULL, NULL, NULL, NULL, 'LIGHT-INDUCIBLE PROTEIN CPRF2-LIKE', 250590),
(405031, 'PTHR46408:SF7', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN OPAQUE-2', 250590),
(405032, 'PTHR46408:SF10', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER 63', 250590),
(405033, 'PTHR46408:SF8', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER 9', 250590),
(405034, 'PTHR46408:SF21', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 250590),
(405035, 'PTHR32332:SF33', NULL, NULL, NULL, NULL, '2-NITROPROPANE DIOXYGENASE-RELATED', 250591),
(405036, 'PTHR32332:SF34', NULL, NULL, NULL, NULL, '2-NITROPROPANE DIOXYGENASE FAMILY, PUTATIVE-RELATED', 250591),
(405037, 'PTHR32332:SF36', NULL, NULL, NULL, NULL, '2-NITROPROPANE DIOXYGENASE FAMILY, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G07940)-RELATED', 250591),
(405038, 'PTHR32332:SF37', NULL, NULL, NULL, NULL, 'ALDOLASE-TYPE TIM BARREL FAMILY PROTEIN', 250591),
(405039, 'PTHR32332:SF38', NULL, NULL, NULL, NULL, 'MONOOXYGENASE RV1533-RELATED', 250591),
(405040, 'PTHR32332:SF28', NULL, NULL, NULL, NULL, 'DIOXYGENASE FAMILY OXIDOREDUCTASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G09600)-RELATED', 250591),
(405041, 'PTHR32332:SF18', NULL, NULL, NULL, NULL, '2-NITROPROPANE DIOXYGENASE-RELATED', 250591),
(405042, 'PTHR32332', NULL, NULL, NULL, NULL, '2-NITROPROPANE DIOXYGENASE', 250591),
(405043, 'PTHR32332:SF31', NULL, NULL, NULL, NULL, '2-NITROPROPANE DIOXYGENASE FAMILY, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G09850)-RELATED', 250591),
(405044, 'PTHR32332:SF20', NULL, NULL, NULL, NULL, '2-NITROPROPANE DIOXYGENASE-LIKE PROTEIN', 250591),
(405045, 'PTHR40472:SF6', NULL, NULL, NULL, NULL, 'RICIN B-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 250592),
(405046, 'PTHR40472:SF7', NULL, NULL, NULL, NULL, 'PROTEIN RAPUNZEL', 250592),
(405047, 'PTHR40472', NULL, NULL, NULL, NULL, 'RICIN B-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 250592),
(405048, 'PTHR40472:SF10', NULL, NULL, NULL, NULL, 'RAPUNZEL 5', 250592),
(405049, 'PTHR40472:SF11', NULL, NULL, NULL, NULL, 'RAPUNZEL 3-RELATED', 250592),
(405050, 'PTHR40472:SF8', NULL, NULL, NULL, NULL, 'RAPUNZEL 2', 250592),
(405051, 'PTHR40472:SF9', NULL, NULL, NULL, NULL, 'RAPUNZEL 4', 250592),
(405052, 'PTHR21398:SF6', NULL, NULL, NULL, NULL, 'AGAP007094-PA', 250593),
(405053, 'PTHR21398:SF7', NULL, NULL, NULL, NULL, 'LP19941P', 250593),
(405054, 'PTHR21398:SF4', NULL, NULL, NULL, NULL, 'AGAP002980-PA', 250593),
(405055, 'PTHR21398:SF22', NULL, NULL, NULL, NULL, 'IP12060P-RELATED', 250593),
(405056, 'PTHR21398:SF11', NULL, NULL, NULL, NULL, 'HDC15381-RELATED', 250593),
(405057, 'PTHR21398:SF23', NULL, NULL, NULL, NULL, 'AGAP002978-PA', 250593),
(405058, 'PTHR21398:SF1', NULL, NULL, NULL, NULL, 'FI03705P', 250593),
(405059, 'PTHR21398:SF21', NULL, NULL, NULL, NULL, 'AGAP004005-PA', 250593);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(405060, 'PTHR21398', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 250593),
(405061, 'PTHR14604:SF3', NULL, NULL, NULL, NULL, 'SPERM-ASSOCIATED ANTIGEN 16 PROTEIN', 250594),
(405062, 'PTHR14604', NULL, NULL, NULL, NULL, 'WD40 REPEAT PF20', 250594),
(405063, 'PTHR14604:SF4', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN POF11', 250594),
(405064, 'PTHR14604:SF5', NULL, NULL, NULL, NULL, 'F-BOX/WD REPEAT-CONTAINING PROTEIN 1A', 250594),
(405065, 'PTHR14604:SF6', NULL, NULL, NULL, NULL, 'F-BOX AND WD REPEAT DOMAIN-CONTAINING 11-B', 250594),
(405066, 'PTHR13425:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG06775', 250595),
(405067, 'PTHR13425:SF9', NULL, NULL, NULL, NULL, '', 250595),
(405068, 'PTHR13425', NULL, NULL, NULL, NULL, 'HEADCASE PROTEIN', 250595),
(405069, 'PTHR13425:SF3', NULL, NULL, NULL, NULL, 'HEADCASE PROTEIN HOMOLOG', 250595),
(405070, 'PTHR47083', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 11', 250596),
(405071, 'PTHR47083:SF1', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 11', 250596),
(405072, 'PTHR45566:SF1', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR YHJB-RELATED', 250597),
(405073, 'PTHR45566:SF2', NULL, NULL, NULL, NULL, 'NARL SUBFAMILY', 250597),
(405074, 'PTHR45566', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR YHJB-RELATED', 250597),
(405075, 'PTHR22028', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 250598),
(405076, 'PTHR22028:SF4', NULL, NULL, NULL, NULL, 'PROTEIN SFI1 HOMOLOG', 250598),
(405077, 'PTHR22028:SF10', NULL, NULL, NULL, NULL, '', 250598),
(405078, 'PTHR22028:SF8', NULL, NULL, NULL, NULL, '', 250598),
(405079, 'PTHR22028:SF7', NULL, NULL, NULL, NULL, '', 250598),
(405080, 'PTHR22028:SF5', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 191', 250598),
(405081, 'PTHR22028:SF9', NULL, NULL, NULL, NULL, '', 250598),
(405082, 'PTHR15598:SF5', NULL, NULL, NULL, NULL, 'ENHANCER OF MRNA-DECAPPING PROTEIN 4', 250599),
(405083, 'PTHR15598:SF8', NULL, NULL, NULL, NULL, 'OS06G0300800 PROTEIN', 250599),
(405084, 'PTHR15598:SF7', NULL, NULL, NULL, NULL, 'ENHANCER OF MRNA-DECAPPING-LIKE PROTEIN', 250599),
(405085, 'PTHR15598:SF13', NULL, NULL, NULL, NULL, 'LOW QUALITY PROTEIN: ENHANCER OF MRNA-DECAPPING PROTEIN 4-LIKE', 250599),
(405086, 'PTHR15598:SF12', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 250599),
(405087, 'PTHR15598:SF11', NULL, NULL, NULL, NULL, 'WD40/YVTN REPEAT-LIKE-CONTAINING DOMAIN-CONTAINING PROTEIN-RELATED', 250599),
(405088, 'PTHR15598', NULL, NULL, NULL, NULL, 'ENHANCER OF MRNA-DECAPPING PROTEIN 4', 250599),
(405089, 'PTHR21052:SF1', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250600),
(405090, 'PTHR21052:SF0', NULL, NULL, NULL, NULL, 'ALPHA-KETOGLUTARATE-DEPENDENT DIOXYGENASE ALKB HOMOLOG 7, MITOCHONDRIAL', 250600),
(405091, 'PTHR21052', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS ASSOCIATED 11-RELATED', 250600),
(405092, 'PTHR19232:SF10', NULL, NULL, NULL, NULL, 'CEREBELLAR DEGENERATION-RELATED PROTEIN 2-LIKE', 250601),
(405093, 'PTHR19232:SF1', NULL, NULL, NULL, NULL, 'CEREBELLAR DEGENERATION-RELATED PROTEIN 2', 250601),
(405094, 'PTHR19232', NULL, NULL, NULL, NULL, 'CENTROCORTIN FAMILY MEMBER', 250601),
(405095, 'PTHR19232:SF7', NULL, NULL, NULL, NULL, 'CENTROCORTIN, ISOFORM A', 250601),
(405096, 'PTHR10720:SF3', NULL, NULL, NULL, NULL, 'HEME OXYGENASE', 250602),
(405097, 'PTHR10720:SF2', NULL, NULL, NULL, NULL, 'HEME OXYGENASE 2', 250602),
(405098, 'PTHR10720:SF1', NULL, NULL, NULL, NULL, 'HEME OXYGENASE 1', 250602),
(405099, 'PTHR10720', NULL, NULL, NULL, NULL, 'HEME OXYGENASE', 250602),
(405100, 'PTHR10720:SF0', NULL, NULL, NULL, NULL, 'HEME OXYGENASE', 250602),
(405101, 'PTHR36440', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_8G07350)-RELATED', 250603),
(405102, 'PTHR36440:SF1', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_8G07350)-RELATED', 250603),
(405103, 'PTHR21553:SF25', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 295 KDA', 250604),
(405104, 'PTHR21553:SF36', NULL, NULL, NULL, NULL, 'ALMS1 CENTROSOME AND BASAL BODY-ASSOCIATED PROTEIN', 250604); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(405105, 'PTHR21553:SF26', NULL, NULL, NULL, NULL, 'ALMS_MOTIF DOMAIN-CONTAINING PROTEIN', 250604),
(405106, 'PTHR21553:SF35', NULL, NULL, NULL, NULL, 'ALMS_MOTIF DOMAIN-CONTAINING PROTEIN', 250604),
(405107, 'PTHR21553:SF24', NULL, NULL, NULL, NULL, '(E2-INDEPENDENT) E3 UBIQUITIN-CONJUGATING ENZYME FATS', 250604),
(405108, 'PTHR21553:SF22', NULL, NULL, NULL, NULL, 'ALSTROM SYNDROME PROTEIN 1', 250604),
(405109, 'PTHR21553:SF33', NULL, NULL, NULL, NULL, 'CEP295 N-TERMINAL-LIKE PROTEIN', 250604),
(405110, 'PTHR21553', NULL, NULL, NULL, NULL, 'ALMS1-RELATED', 250604),
(405111, 'PTHR28229:SF1', NULL, NULL, NULL, NULL, 'TRANSLOCATION PROTEIN SEC66', 250605),
(405112, 'PTHR28229', NULL, NULL, NULL, NULL, 'TRANSLOCATION PROTEIN SEC66', 250605),
(405113, 'PTHR19378:SF1', NULL, NULL, NULL, NULL, 'HAUS-AUGMIN3 DOMAIN-CONTAINING PROTEIN', 250606),
(405114, 'PTHR19378:SF0', NULL, NULL, NULL, NULL, 'HAUS AUGMIN-LIKE COMPLEX SUBUNIT 3', 250606),
(405115, 'PTHR19378:SF3', NULL, NULL, NULL, NULL, 'HAUS-AUGMIN3 DOMAIN-CONTAINING PROTEIN', 250606),
(405116, 'PTHR19378', NULL, NULL, NULL, NULL, 'GOLGIN- RELATED', 250606),
(405117, 'PTHR19378:SF4', NULL, NULL, NULL, NULL, 'OS07G0185700 PROTEIN', 250606),
(405118, 'PTHR30387:SF2', NULL, NULL, NULL, NULL, 'MANNONATE DEHYDRATASE', 250607),
(405119, 'PTHR30387', NULL, NULL, NULL, NULL, 'MANNONATE DEHYDRATASE', 250607),
(405120, 'PTHR34804:SF2', NULL, NULL, NULL, NULL, 'OS01G0305200 PROTEIN', 250608),
(405121, 'PTHR34804:SF7', NULL, NULL, NULL, NULL, 'BNAC01G22000D PROTEIN', 250608),
(405122, 'PTHR34804:SF4', NULL, NULL, NULL, NULL, '', 250608),
(405123, 'PTHR34804:SF5', NULL, NULL, NULL, NULL, 'CAMP-REGULATED PHOSPHOPROTEIN 19-RELATED PROTEIN', 250608),
(405124, 'PTHR34804', NULL, NULL, NULL, NULL, 'CAMP-REGULATED PHOSPHOPROTEIN 19-RELATED PROTEIN', 250608),
(405125, 'PTHR46223:SF2', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SUV39H2', 250609),
(405126, 'PTHR46223:SF3', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE-RELATED', 250609),
(405127, 'PTHR46223:SF1', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SUV39H1', 250609),
(405128, 'PTHR46223', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SUV39H', 250609),
(405129, 'PTHR35122:SF1', NULL, NULL, NULL, NULL, 'OS03G0627000 PROTEIN', 250610),
(405130, 'PTHR35122:SF2', NULL, NULL, NULL, NULL, 'OS04G0598000 PROTEIN', 250610),
(405131, 'PTHR35122:SF8', NULL, NULL, NULL, NULL, '', 250610),
(405132, 'PTHR35122', NULL, NULL, NULL, NULL, 'OSJNBA0093F12.14 PROTEIN', 250610),
(405133, 'PTHR35122:SF5', NULL, NULL, NULL, NULL, 'HYDROGEN PEROXIDE-INDUCED 1', 250610),
(405134, 'PTHR35122:SF4', NULL, NULL, NULL, NULL, 'BNAA05G32390D PROTEIN', 250610),
(405135, 'PTHR35122:SF7', NULL, NULL, NULL, NULL, 'HYDROGEN PEROXIDE-INDUCED 1', 250610),
(405136, 'PTHR35122:SF6', NULL, NULL, NULL, NULL, '', 250610),
(405137, 'PTHR33987', NULL, NULL, NULL, NULL, 'CALCINEURIN-LIKE METALLO-PHOSPHOESTERASE SUPERFAMILY PROTEIN', 250611),
(405138, 'PTHR33987:SF1', NULL, NULL, NULL, NULL, 'CALCINEURIN-LIKE METALLO-PHOSPHOESTERASE SUPERFAMILY PROTEIN', 250611),
(405139, 'PTHR33987:SF2', NULL, NULL, NULL, NULL, 'ALKALINE PHOSPHATASE D', 250611),
(405140, 'PTHR34035', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 47', 250612),
(405141, 'PTHR34035:SF1', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 47', 250612),
(405142, 'PTHR47509', NULL, NULL, NULL, NULL, 'MCG1612', 250613),
(405143, 'PTHR47509:SF1', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4933402N03 GENE', 250613),
(405144, 'PTHR11705:SF89', NULL, NULL, NULL, NULL, 'PEPTIDASE_M14 DOMAIN-CONTAINING PROTEIN', 250614),
(405145, 'PTHR11705:SF49', NULL, NULL, NULL, NULL, 'SHKT DOMAIN-CONTAINING PROTEIN', 250614),
(405146, 'PTHR11705:SF119', NULL, NULL, NULL, NULL, 'OS02G0119300 PROTEIN', 250614),
(405147, 'PTHR11705:SF91', NULL, NULL, NULL, NULL, 'FI01817P-RELATED', 250614),
(405148, 'PTHR11705:SF139', NULL, NULL, NULL, NULL, 'PEPTIDASE_M14 DOMAIN-CONTAINING PROTEIN', 250614),
(405149, 'PTHR11705:SF117', NULL, NULL, NULL, NULL, 'PEPTIDASE_M14 DOMAIN-CONTAINING PROTEIN', 250614);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(405150, 'PTHR11705:SF71', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE A2', 250614),
(405151, 'PTHR11705:SF138', NULL, NULL, NULL, NULL, 'PEPTIDASE_M14 DOMAIN-CONTAINING PROTEIN', 250614),
(405152, 'PTHR11705:SF51', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE SURO-1-RELATED', 250614),
(405153, 'PTHR11705:SF136', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE A4', 250614),
(405154, 'PTHR11705:SF94', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE A1', 250614),
(405155, 'PTHR11705:SF133', NULL, NULL, NULL, NULL, 'PEPTIDASE_M14 DOMAIN-CONTAINING PROTEIN', 250614),
(405156, 'PTHR11705:SF131', NULL, NULL, NULL, NULL, 'PROTEIN CBG14938', 250614),
(405157, 'PTHR11705:SF54', NULL, NULL, NULL, NULL, 'SHKT DOMAIN-CONTAINING PROTEIN', 250614),
(405158, 'PTHR11705:SF140', NULL, NULL, NULL, NULL, 'FI02848P-RELATED', 250614),
(405159, 'PTHR11705:SF141', NULL, NULL, NULL, NULL, 'PEPTIDASE_M14 DOMAIN-CONTAINING PROTEIN', 250614),
(405160, 'PTHR11705:SF59', NULL, NULL, NULL, NULL, 'PEPTIDASE_M14 DOMAIN-CONTAINING PROTEIN', 250614),
(405161, 'PTHR11705:SF17', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE B2', 250614),
(405162, 'PTHR11705:SF16', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE A5', 250614),
(405163, 'PTHR11705:SF19', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE O', 250614),
(405164, 'PTHR11705:SF18', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE A6', 250614),
(405165, 'PTHR11705', NULL, NULL, NULL, NULL, 'PROTEASE FAMILY M14 CARBOXYPEPTIDASE A,B', 250614),
(405166, 'PTHR11705:SF60', NULL, NULL, NULL, NULL, 'FI16720P1', 250614),
(405167, 'PTHR11705:SF146', NULL, NULL, NULL, NULL, 'PEPTIDASE_M14 DOMAIN-CONTAINING PROTEIN', 250614),
(405168, 'PTHR11705:SF147', NULL, NULL, NULL, NULL, 'METALLOCARBOXYPEPTIDASE ECM14-RELATED', 250614),
(405169, 'PTHR11705:SF83', NULL, NULL, NULL, NULL, 'METALLOCARBOXYPEPTIDASE ECM14-RELATED', 250614),
(405170, 'PTHR11705:SF144', NULL, NULL, NULL, NULL, 'PEPTIDASE_M14 DOMAIN-CONTAINING PROTEIN', 250614),
(405171, 'PTHR11705:SF20', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE B', 250614),
(405172, 'PTHR11705:SF145', NULL, NULL, NULL, NULL, 'PEPTIDASE_M14 DOMAIN-CONTAINING PROTEIN', 250614),
(405173, 'PTHR11705:SF123', NULL, NULL, NULL, NULL, 'PEPTIDASE_M14 DOMAIN-CONTAINING PROTEIN-RELATED', 250614),
(405174, 'PTHR11705:SF142', NULL, NULL, NULL, NULL, 'RH39904P-RELATED', 250614),
(405175, 'PTHR11705:SF65', NULL, NULL, NULL, NULL, 'MAST CELL CARBOXYPEPTIDASE A', 250614),
(405176, 'PTHR11705:SF143', NULL, NULL, NULL, NULL, 'PEPTIDASE_M14 DOMAIN-CONTAINING PROTEIN', 250614),
(405177, 'PTHR37910:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250615),
(405178, 'PTHR37910', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250615),
(405179, 'PTHR15717:SF2', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING DOMAIN-CONTAINING PROTEIN 14', 250616),
(405180, 'PTHR15717', NULL, NULL, NULL, NULL, 'PROTEIN KIAA0494', 250616),
(405181, 'PTHR34479:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 30', 250617),
(405182, 'PTHR34479', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 30', 250617),
(405183, 'PTHR12263:SF0', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT', 250618),
(405184, 'PTHR12263:SF2', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT E 2', 250618),
(405185, 'PTHR12263:SF5', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT E 1', 250618),
(405186, 'PTHR12263:SF16', NULL, NULL, NULL, NULL, '', 250618),
(405187, 'PTHR12263:SF15', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT E1', 250618),
(405188, 'PTHR12263:SF7', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT E1', 250618),
(405189, 'PTHR12263:SF14', NULL, NULL, NULL, NULL, 'ATPASE, V0 COMPLEX, SUBUNIT E-RELATED', 250618),
(405190, 'PTHR12263', NULL, NULL, NULL, NULL, 'VACUOLAR ATP SYNTHASE SUBUNIT H', 250618),
(405191, 'PTHR33078:SF100', NULL, NULL, NULL, NULL, 'PROTEIN YCF2', 250619),
(405192, 'PTHR33078:SF107', NULL, NULL, NULL, NULL, 'PROTEIN YCF2', 250619),
(405193, 'PTHR33078:SF105', NULL, NULL, NULL, NULL, '', 250619),
(405194, 'PTHR33078:SF106', NULL, NULL, NULL, NULL, '', 250619),
(405195, 'PTHR33078:SF103', NULL, NULL, NULL, NULL, 'YCF2-LIKE PROTEIN', 250619);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(405196, 'PTHR33078:SF104', NULL, NULL, NULL, NULL, '', 250619),
(405197, 'PTHR33078:SF101', NULL, NULL, NULL, NULL, 'ATPASE, AAA-TYPE, CORE-RELATED', 250619),
(405198, 'PTHR33078:SF102', NULL, NULL, NULL, NULL, '', 250619),
(405199, 'PTHR33078:SF89', NULL, NULL, NULL, NULL, 'BNAA06G19310D PROTEIN', 250619),
(405200, 'PTHR33078:SF99', NULL, NULL, NULL, NULL, 'PROTEIN YCF2', 250619),
(405201, 'PTHR33078:SF88', NULL, NULL, NULL, NULL, 'ATPASE_AAA_CORE DOMAIN-CONTAINING PROTEIN', 250619),
(405202, 'PTHR33078:SF98', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 250619),
(405203, 'PTHR33078:SF87', NULL, NULL, NULL, NULL, 'YCF2 DOMAIN PROTEIN', 250619),
(405204, 'PTHR33078:SF97', NULL, NULL, NULL, NULL, 'YCF2-LIKE PROTEIN', 250619),
(405205, 'PTHR33078:SF96', NULL, NULL, NULL, NULL, '', 250619),
(405206, 'PTHR33078', NULL, NULL, NULL, NULL, 'PROTEIN YCF2-RELATED', 250619),
(405207, 'PTHR33078:SF51', NULL, NULL, NULL, NULL, 'BNAA06G19290D PROTEIN', 250619),
(405208, 'PTHR33078:SF95', NULL, NULL, NULL, NULL, 'PROTEIN YCF2', 250619),
(405209, 'PTHR33078:SF94', NULL, NULL, NULL, NULL, 'YCF2-LIKE PROTEIN', 250619),
(405210, 'PTHR33078:SF93', NULL, NULL, NULL, NULL, 'RNA_POL_RPB2_2 DOMAIN-CONTAINING PROTEIN', 250619),
(405211, 'PTHR33078:SF60', NULL, NULL, NULL, NULL, '', 250619),
(405212, 'PTHR33078:SF92', NULL, NULL, NULL, NULL, 'PROTEIN YCF2', 250619),
(405213, 'PTHR33078:SF91', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE SUBUNIT 5', 250619),
(405214, 'PTHR33078:SF90', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I P700 CHLOROPHYLL A APOPROTEIN', 250619),
(405215, 'PTHR43435', NULL, NULL, NULL, NULL, 'RIBULOKINASE', 250620),
(405216, 'PTHR43435:SF1', NULL, NULL, NULL, NULL, 'PROTEIN MPA43', 250620),
(405217, 'PTHR43435:SF4', NULL, NULL, NULL, NULL, 'FGGY CARBOHYDRATE KINASE DOMAIN-CONTAINING PROTEIN', 250620),
(405218, 'PTHR43435:SF8', NULL, NULL, NULL, NULL, '', 250620),
(405219, 'PTHR10925', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE 10', 250621),
(405220, 'PTHR10925:SF5', NULL, NULL, NULL, NULL, 'RNA CYTIDINE ACETYLTRANSFERASE', 250621),
(405221, 'PTHR10925:SF8', NULL, NULL, NULL, NULL, 'RNA CYTIDINE ACETYLTRANSFERASE', 250621),
(405222, 'PTHR10925:SF7', NULL, NULL, NULL, NULL, 'RNA CYTIDINE ACETYLTRANSFERASE 2', 250621),
(405223, 'PTHR34315:SF9', NULL, NULL, NULL, NULL, 'INTRADIOL_DIOXYGENAS DOMAIN-CONTAINING PROTEIN-RELATED', 250622),
(405224, 'PTHR34315', NULL, NULL, NULL, NULL, '', 250622),
(405225, 'PTHR34315:SF2', NULL, NULL, NULL, NULL, 'ANCHORED DIOXYGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G01800)-RELATED', 250622),
(405226, 'PTHR34315:SF1', NULL, NULL, NULL, NULL, 'INTRADIOL_DIOXYGENAS DOMAIN-CONTAINING PROTEIN-RELATED', 250622),
(405227, 'PTHR34315:SF4', NULL, NULL, NULL, NULL, 'INTRADIOL_DIOXYGENAS DOMAIN-CONTAINING PROTEIN', 250622),
(405228, 'PTHR36702', NULL, NULL, NULL, NULL, 'HOLLIDAY JUNCTION RESOLVASE', 250623),
(405229, 'PTHR36702:SF1', NULL, NULL, NULL, NULL, 'HOLLIDAY JUNCTION RESOLVASE', 250623),
(405230, 'PTHR38619', NULL, NULL, NULL, NULL, 'PROTEIN CBG04644', 250624),
(405231, 'PTHR38619:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG04644', 250624),
(405232, 'PTHR32170', NULL, NULL, NULL, NULL, 'PROTEASOME ACTIVATOR COMPLEX SUBUNIT 4', 250625),
(405233, 'PTHR32170:SF4', NULL, NULL, NULL, NULL, 'DUF3437 DOMAIN-CONTAINING PROTEIN', 250625),
(405234, 'PTHR32170:SF3', NULL, NULL, NULL, NULL, 'PROTEASOME ACTIVATOR COMPLEX SUBUNIT 4', 250625),
(405235, 'PTHR21687', NULL, NULL, NULL, NULL, 'PLASMALEMMA VESICLE-ASSOCIATED PROTEIN', 250626),
(405236, 'PTHR21687:SF5', NULL, NULL, NULL, NULL, 'PLASMALEMMA VESICLE-ASSOCIATED PROTEIN', 250626),
(405237, 'PTHR21687:SF6', NULL, NULL, NULL, NULL, 'PLASMALEMMA VESICLE-ASSOCIATED PROTEIN B', 250626),
(405238, 'PTHR43670:SF53', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 250627),
(405239, 'PTHR43670:SF54', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 250627),
(405240, 'PTHR43670:SF98', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 250627),
(405241, 'PTHR43670:SF99', NULL, NULL, NULL, NULL, 'INACTIVE PROTEIN RESTRICTED TEV MOVEMENT 2-LIKE', 250627);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(405242, 'PTHR43670:SF58', NULL, NULL, NULL, NULL, 'HSP20-LIKE CHAPERONES SUPERFAMILY PROTEIN', 250627),
(405243, 'PTHR43670:SF59', NULL, NULL, NULL, NULL, 'HSP20-LIKE CHAPERONES SUPERFAMILY PROTEIN', 250627),
(405244, 'PTHR43670', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 26', 250627),
(405245, 'PTHR43670:SF93', NULL, NULL, NULL, NULL, 'HSP20/ALPHA CRYSTALLIN FAMILY PROTEIN', 250627),
(405246, 'PTHR43670:SF110', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 250627),
(405247, 'PTHR43670:SF111', NULL, NULL, NULL, NULL, 'HSP20-LIKE CHAPERONE-RELATED', 250627),
(405248, 'PTHR43670:SF112', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 250627),
(405249, 'PTHR43670:SF117', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 250627),
(405250, 'PTHR43670:SF118', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 250627),
(405251, 'PTHR43670:SF119', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 250627),
(405252, 'PTHR43670:SF113', NULL, NULL, NULL, NULL, 'HSP20-LIKE CHAPERONES SUPERFAMILY PROTEIN', 250627),
(405253, 'PTHR43670:SF114', NULL, NULL, NULL, NULL, 'PROTEIN RESTRICTED TEV MOVEMENT 2', 250627),
(405254, 'PTHR43670:SF115', NULL, NULL, NULL, NULL, 'ALPHA-CRYSTALLIN DOMAIN 32.1', 250627),
(405255, 'PTHR43670:SF116', NULL, NULL, NULL, NULL, '30 KDA HEAT SHOCK PROTEIN-RELATED', 250627),
(405256, 'PTHR43670:SF64', NULL, NULL, NULL, NULL, 'HSP20-LIKE CHAPERONES SUPERFAMILY PROTEIN', 250627),
(405257, 'PTHR43670:SF20', NULL, NULL, NULL, NULL, 'HSP20/ALPHA CRYSTALLIN FAMILY PROTEIN, EXPRESSED', 250627),
(405258, 'PTHR43670:SF66', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 250627),
(405259, 'PTHR43670:SF68', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 250627),
(405260, 'PTHR43670:SF26', NULL, NULL, NULL, NULL, 'HSP20/ALPHA CRYSTALLIN FAMILY PROTEIN', 250627),
(405261, 'PTHR43670:SF7', NULL, NULL, NULL, NULL, 'HSP20/ALPHA CRYSTALLIN FAMILY PROTEIN', 250627),
(405262, 'PTHR43670:SF61', NULL, NULL, NULL, NULL, 'AA2-296-RELATED', 250627),
(405263, 'PTHR43670:SF120', NULL, NULL, NULL, NULL, '17.5 KDA CLASS I HEAT SHOCK PROTEIN-LIKE', 250627),
(405264, 'PTHR43670:SF121', NULL, NULL, NULL, NULL, 'HSP20/ALPHA CRYSTALLIN FAMILY PROTEIN', 250627),
(405265, 'PTHR43670:SF122', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 250627),
(405266, 'PTHR43670:SF28', NULL, NULL, NULL, NULL, 'HSP20-LIKE CHAPERONES SUPERFAMILY PROTEIN', 250627),
(405267, 'PTHR43670:SF76', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 250627),
(405268, 'PTHR43670:SF32', NULL, NULL, NULL, NULL, '16.6 KDA HEAT SHOCK PROTEIN-LIKE', 250627),
(405269, 'PTHR43670:SF77', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 250627),
(405270, 'PTHR43670:SF33', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 250627),
(405271, 'PTHR43670:SF34', NULL, NULL, NULL, NULL, 'HSP20-LIKE CHAPERONES SUPERFAMILY PROTEIN', 250627),
(405272, 'PTHR43670:SF78', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 250627),
(405273, 'PTHR43670:SF73', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 250627),
(405274, 'PTHR43670:SF41', NULL, NULL, NULL, NULL, 'HSP20-LIKE CHAPERONES SUPERFAMILY PROTEIN', 250627),
(405275, 'PTHR43670:SF85', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 250627),
(405276, 'PTHR43670:SF42', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 250627),
(405277, 'PTHR43670:SF88', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250627),
(405278, 'PTHR43670:SF89', NULL, NULL, NULL, NULL, 'OS03G0656000 PROTEIN', 250627),
(405279, 'PTHR43670:SF46', NULL, NULL, NULL, NULL, 'HSP20/ALPHA CRYSTALLIN FAMILY PROTEIN, EXPRESSED', 250627),
(405280, 'PTHR43670:SF47', NULL, NULL, NULL, NULL, 'HSP20/ALPHA CRYSTALLIN FAMILY PROTEIN', 250627),
(405281, 'PTHR43670:SF48', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 250627),
(405282, 'PTHR43670:SF80', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 250627),
(405283, 'PTHR43670:SF100', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 26', 250627),
(405284, 'PTHR43670:SF101', NULL, NULL, NULL, NULL, 'INACTIVE PROTEIN RESTRICTED TEV MOVEMENT 2-LIKE', 250627);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(405285, 'PTHR43670:SF106', NULL, NULL, NULL, NULL, 'PROTEIN RESTRICTED TEV MOVEMENT 2', 250627),
(405286, 'PTHR43670:SF107', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 250627),
(405287, 'PTHR43670:SF108', NULL, NULL, NULL, NULL, 'HSP20/ALPHA CRYSTALLIN FAMILY PROTEIN', 250627),
(405288, 'PTHR43670:SF109', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN 1B-LIKE', 250627),
(405289, 'PTHR43670:SF102', NULL, NULL, NULL, NULL, 'BLR4637 PROTEIN', 250627),
(405290, 'PTHR43670:SF103', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250627),
(405291, 'PTHR43670:SF104', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 250627),
(405292, 'PTHR43670:SF105', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 30', 250627),
(405293, 'PTHR15186:SF3', NULL, NULL, NULL, NULL, 'BCL2/ADENOVIRUS E1B 19 KDA PROTEIN-INTERACTING PROTEIN 3-LIKE', 250628),
(405294, 'PTHR15186', NULL, NULL, NULL, NULL, 'RE48077P', 250628),
(405295, 'PTHR15186:SF5', NULL, NULL, NULL, NULL, 'RE48077P', 250628),
(405296, 'PTHR15186:SF4', NULL, NULL, NULL, NULL, 'BCL2/ADENOVIRUS E1B 19 KDA PROTEIN-INTERACTING PROTEIN 3', 250628),
(405297, 'PTHR15186:SF9', NULL, NULL, NULL, NULL, 'ZGC:73226', 250628),
(405298, 'PTHR15186:SF10', NULL, NULL, NULL, NULL, 'BCL2-INTERACTING PROTEIN 3-LIKE B', 250628),
(405299, 'PTHR33599:SF22', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 250629),
(405300, 'PTHR33599:SF11', NULL, NULL, NULL, NULL, 'PROTEIN IDA-LIKE 5', 250629),
(405301, 'PTHR33599:SF23', NULL, NULL, NULL, NULL, '', 250629),
(405302, 'PTHR33599:SF20', NULL, NULL, NULL, NULL, 'PROTEIN IDA', 250629),
(405303, 'PTHR33599:SF9', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 250629),
(405304, 'PTHR33599:SF21', NULL, NULL, NULL, NULL, '', 250629),
(405305, 'PTHR33599:SF19', NULL, NULL, NULL, NULL, 'BNAC06G29530D PROTEIN', 250629),
(405306, 'PTHR33599:SF17', NULL, NULL, NULL, NULL, 'PROTEIN IDA-LIKE 3', 250629),
(405307, 'PTHR33599:SF15', NULL, NULL, NULL, NULL, 'PROTEIN IDA-LIKE 2', 250629),
(405308, 'PTHR33599', NULL, NULL, NULL, NULL, 'PROTEIN IDA-LIKE 5', 250629),
(405309, 'PTHR33599:SF13', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN 20', 250629),
(405310, 'PTHR33599:SF14', NULL, NULL, NULL, NULL, 'PROTEIN IDA-LIKE 4', 250629),
(405311, 'PTHR28597', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL BETA SUBUNIT-ASSOCIATED REGULATORY PROTEIN', 250630),
(405312, 'PTHR28597:SF1', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL BETA SUBUNIT-ASSOCIATED REGULATORY PROTEIN', 250630),
(405313, 'PTHR47080:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 16 OPEN READING FRAME 96', 250631),
(405314, 'PTHR47080', NULL, NULL, NULL, NULL, 'CHROMOSOME 16 OPEN READING FRAME 96', 250631),
(405315, 'PTHR24050:SF26', NULL, NULL, NULL, NULL, 'FIBULIN-5', 250632),
(405316, 'PTHR24050:SF27', NULL, NULL, NULL, NULL, 'FIBULIN-1', 250632),
(405317, 'PTHR24050:SF24', NULL, NULL, NULL, NULL, 'EPIDERMAL GROWTH FACTOR-LIKE PROTEIN 6', 250632),
(405318, 'PTHR24050:SF25', NULL, NULL, NULL, NULL, 'CD93 MOLECULE', 250632),
(405319, 'PTHR24050:SF23', NULL, NULL, NULL, NULL, 'FIBULIN-1', 250632),
(405320, 'PTHR24050:SF20', NULL, NULL, NULL, NULL, '', 250632),
(405321, 'PTHR24050', NULL, NULL, NULL, NULL, 'PA14 DOMAIN-CONTAINING PROTEIN', 250632),
(405322, 'PTHR24050:SF19', NULL, NULL, NULL, NULL, 'NEPHRONECTIN', 250632),
(405323, 'PTHR15642', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY FACTOR 3, MITOCHONDRIAL', 250633),
(405324, 'PTHR15642:SF3', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY FACTOR 3 HOMOLOG, MITOCHONDRIAL', 250633),
(405325, 'PTHR40018', NULL, NULL, NULL, NULL, '[PSI+] INDUCTION PROTEIN 2', 250634),
(405326, 'PTHR40018:SF1', NULL, NULL, NULL, NULL, '[PSI+] INDUCTION PROTEIN 2', 250634),
(405327, 'PTHR33115:SF57', NULL, NULL, NULL, NULL, 'OS07G0653900 PROTEIN', 250635),
(405328, 'PTHR33115:SF36', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 250635),
(405329, 'PTHR33115:SF58', NULL, NULL, NULL, NULL, '', 250635),
(405330, 'PTHR33115:SF37', NULL, NULL, NULL, NULL, 'OS01G0618300 PROTEIN', 250635);
INSERT INTO "PUBLIC"."MODEL" VALUES
(405331, 'PTHR33115:SF75', NULL, NULL, NULL, NULL, 'OS07G0649300 PROTEIN', 250635),
(405332, 'PTHR33115:SF76', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 250635),
(405333, 'PTHR33115:SF54', NULL, NULL, NULL, NULL, 'OS12G0284700 PROTEIN', 250635),
(405334, 'PTHR33115:SF11', NULL, NULL, NULL, NULL, 'OS07G0654700 PROTEIN', 250635),
(405335, 'PTHR33115:SF77', NULL, NULL, NULL, NULL, '', 250635),
(405336, 'PTHR33115:SF33', NULL, NULL, NULL, NULL, 'OS03G0145400 PROTEIN', 250635),
(405337, 'PTHR33115:SF56', NULL, NULL, NULL, NULL, 'OS05G0239400 PROTEIN', 250635),
(405338, 'PTHR33115:SF50', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 250635),
(405339, 'PTHR33115:SF72', NULL, NULL, NULL, NULL, '', 250635),
(405340, 'PTHR33115:SF73', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 250635),
(405341, 'PTHR33115:SF74', NULL, NULL, NULL, NULL, 'OS01G0524100 PROTEIN', 250635),
(405342, 'PTHR33115:SF70', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 250635),
(405343, 'PTHR33115:SF46', NULL, NULL, NULL, NULL, 'OS05G0141200 PROTEIN', 250635),
(405344, 'PTHR33115:SF24', NULL, NULL, NULL, NULL, 'OS01G0522400 PROTEIN', 250635),
(405345, 'PTHR33115:SF25', NULL, NULL, NULL, NULL, '', 250635),
(405346, 'PTHR33115:SF69', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 250635),
(405347, 'PTHR33115:SF48', NULL, NULL, NULL, NULL, '', 250635),
(405348, 'PTHR33115:SF43', NULL, NULL, NULL, NULL, '', 250635),
(405349, 'PTHR33115:SF22', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250635),
(405350, 'PTHR33115:SF44', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 250635),
(405351, 'PTHR33115:SF60', NULL, NULL, NULL, NULL, '', 250635),
(405352, 'PTHR33115', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 250635),
(405353, 'PTHR33115:SF61', NULL, NULL, NULL, NULL, 'HELICASE C-TERMINAL DOMAIN-CONTAINING PROTEIN', 250635),
(405354, 'PTHR33115:SF63', NULL, NULL, NULL, NULL, 'ARMADILLO-TYPE FOLD PROTEIN-RELATED', 250635),
(405355, 'PTHR33115:SF41', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250635),
(405356, 'PTHR28603', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 243', 250636),
(405357, 'PTHR28603:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 243', 250636),
(405358, 'PTHR43658:SF13', NULL, NULL, NULL, NULL, '17-BETA-HYDROXYSTEROID DEHYDROGENASE 14', 250637),
(405359, 'PTHR43658:SF10', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE, SHORT CHAIN DEHYDROGENASE/REDUCTASE FAMILY (AFU_ORTHOLOGUE AFUA_8G05590)', 250637),
(405360, 'PTHR43658', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/REDUCTASE', 250637),
(405361, 'PTHR43658:SF14', NULL, NULL, NULL, NULL, '2,4-DIENOYL-COA REDUCTASE [(3E)-ENOYL-COA-PRODUCING], MITOCHONDRIAL', 250637),
(405362, 'PTHR43658:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG11484', 250637),
(405363, 'PTHR43658:SF5', NULL, NULL, NULL, NULL, 'SI:DKEY-238O13.4', 250637),
(405364, 'PTHR43658:SF8', NULL, NULL, NULL, NULL, '3-HYDROXYACYL-COA DEHYDROGENASE TYPE-2', 250637),
(405365, 'PTHR13096', NULL, NULL, NULL, NULL, 'MINA53  MYC INDUCED NUCLEAR ANTIGEN', 250638),
(405366, 'PTHR13096:SF9', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL LYSINE-SPECIFIC DEMETHYLASE AND HISTIDYL-HYDROXYLASE', 250638),
(405367, 'PTHR13096:SF8', NULL, NULL, NULL, NULL, 'RIBOSOMAL OXYGENASE 1', 250638),
(405368, 'PTHR13096:SF7', NULL, NULL, NULL, NULL, 'RIBOSOMAL OXYGENASE 2', 250638),
(405369, 'PTHR32005', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 178B-RELATED', 250639),
(405370, 'PTHR32005:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 178A', 250639),
(405371, 'PTHR32005:SF3', NULL, NULL, NULL, NULL, 'SI:CH211-150G13.3-RELATED', 250639),
(405372, 'PTHR32005:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 178B', 250639),
(405373, 'PTHR45640:SF1', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN HSP-16.1/HSP-16.11-RELATED', 250640),
(405374, 'PTHR45640:SF9', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 12.6', 250640),
(405375, 'PTHR45640:SF6', NULL, NULL, NULL, NULL, 'HEAT-SHOCK PROTEIN 12.1', 250640),
(405376, 'PTHR45640', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN HSP-12.2-RELATED', 250640);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(405377, 'PTHR45640:SF7', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN BETA-1', 250640),
(405378, 'PTHR45640:SF4', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 250640),
(405379, 'PTHR45640:SF5', NULL, NULL, NULL, NULL, 'ALPHA-CRYSTALLIN B CHAIN', 250640),
(405380, 'PTHR45640:SF2', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN BETA-6', 250640),
(405381, 'PTHR45640:SF29', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 250640),
(405382, 'PTHR45640:SF27', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN BETA-2', 250640),
(405383, 'PTHR45640:SF26', NULL, NULL, NULL, NULL, 'RE23625P', 250640),
(405384, 'PTHR45640:SF14', NULL, NULL, NULL, NULL, 'ALPHA-CRYSTALLIN A CHAIN-RELATED', 250640),
(405385, 'PTHR45640:SF13', NULL, NULL, NULL, NULL, 'IP01061P-RELATED', 250640),
(405386, 'PTHR45640:SF24', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 250640),
(405387, 'PTHR45640:SF33', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 22-RELATED', 250640),
(405388, 'PTHR45640:SF32', NULL, NULL, NULL, NULL, 'STRESS-INDUCED PROTEIN 1', 250640),
(405389, 'PTHR45640:SF21', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN HSP-16.41-RELATED', 250640),
(405390, 'PTHR45640:SF10', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 250640),
(405391, 'PTHR45640:SF31', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN, ALPHA-CRYSTALLIN-RELATED, B6', 250640),
(405392, 'PTHR45640:SF20', NULL, NULL, NULL, NULL, 'SHSP DOMAIN-CONTAINING PROTEIN', 250640),
(405393, 'PTHR46869', NULL, NULL, NULL, NULL, 'C2H2-LIKE ZINC FINGER PROTEIN', 250641),
(405394, 'PTHR46869:SF17', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 250641),
(405395, 'PTHR46869:SF19', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 655-LIKE', 250641),
(405396, 'PTHR46869:SF14', NULL, NULL, NULL, NULL, 'ZINC FINGER, C2H2-LIKE PROTEIN-RELATED', 250641),
(405397, 'PTHR46869:SF6', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 250641),
(405398, 'PTHR46869:SF7', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZAT9-LIKE', 250641),
(405399, 'PTHR46869:SF16', NULL, NULL, NULL, NULL, 'BNAC07G12310D PROTEIN', 250641),
(405400, 'PTHR46869:SF8', NULL, NULL, NULL, NULL, 'C2H2 AND C2HC ZINC FINGERS SUPERFAMILY PROTEIN', 250641),
(405401, 'PTHR46869:SF9', NULL, NULL, NULL, NULL, 'C2H2-TYPE ZINC FINGER FAMILY PROTEIN', 250641),
(405402, 'PTHR46869:SF15', NULL, NULL, NULL, NULL, 'BNAC03G57420D PROTEIN', 250641),
(405403, 'PTHR46869:SF21', NULL, NULL, NULL, NULL, 'BNAA09G29040D PROTEIN', 250641),
(405404, 'PTHR46869:SF12', NULL, NULL, NULL, NULL, 'BNAA09G29020D PROTEIN', 250641),
(405405, 'PTHR46869:SF4', NULL, NULL, NULL, NULL, 'PETHY_ ZPT4-2', 250641),
(405406, 'PTHR46869:SF1', NULL, NULL, NULL, NULL, 'C2H2-LIKE ZINC FINGER PROTEIN', 250641),
(405407, 'PTHR10907:SF54', NULL, NULL, NULL, NULL, 'REGUCALCIN', 250642),
(405408, 'PTHR10907:SF65', NULL, NULL, NULL, NULL, 'SGL DOMAIN-CONTAINING PROTEIN', 250642),
(405409, 'PTHR10907:SF64', NULL, NULL, NULL, NULL, 'GLUCONOLACTONASE', 250642),
(405410, 'PTHR10907:SF66', NULL, NULL, NULL, NULL, 'MIP34848P1-RELATED', 250642),
(405411, 'PTHR10907:SF47', NULL, NULL, NULL, NULL, 'REGUCALCIN', 250642),
(405412, 'PTHR10907', NULL, NULL, NULL, NULL, 'REGUCALCIN', 250642),
(405413, 'PTHR36469:SF1', NULL, NULL, NULL, NULL, 'DISTAL MEMBRANE-ARM ASSEMBLY COMPLEX PROTEIN 1', 250643),
(405414, 'PTHR36469', NULL, NULL, NULL, NULL, 'DISTAL MEMBRANE-ARM ASSEMBLY COMPLEX PROTEIN 1', 250643),
(405415, 'PTHR24391:SF17', NULL, NULL, NULL, NULL, 'ZINC FINGER E-BOX-BINDING HOMEOBOX 1', 250644),
(405416, 'PTHR24391:SF28', NULL, NULL, NULL, NULL, 'ZINC FINGER E-BOX-BINDING HOMEOBOX 2-LIKE', 250644),
(405417, 'PTHR24391:SF18', NULL, NULL, NULL, NULL, 'EG:115C2.6 PROTEIN', 250644),
(405418, 'PTHR24391', NULL, NULL, NULL, NULL, 'HISTONE H4 TRANSCRIPTION FACTOR-RELATED', 250644),
(405419, 'PTHR24391:SF11', NULL, NULL, NULL, NULL, 'ZINC FINGER E-BOX-BINDING HOMEOBOX 2', 250644),
(405420, 'PTHR24391:SF26', NULL, NULL, NULL, NULL, 'HISTONE H4 TRANSCRIPTION FACTOR', 250644),
(405421, 'PTHR24391:SF15', NULL, NULL, NULL, NULL, 'ZGC:112083', 250644);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(405422, 'PTHR24391:SF27', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 1', 250644),
(405423, 'PTHR16528:SF2', NULL, NULL, NULL, NULL, 'GOLGI-ASSOCIATED PDZ AND COILED-COIL MOTIF-CONTAINING PROTEIN', 250645),
(405424, 'PTHR16528', NULL, NULL, NULL, NULL, 'GOLGI-ASSOCIATED PDZ AND COILED-COIL MOTIF-CONTAINING', 250645),
(405425, 'PTHR46992:SF5', NULL, NULL, NULL, NULL, 'GYF DOMAIN-CONTAINING PROTEIN', 250646),
(405426, 'PTHR46992:SF4', NULL, NULL, NULL, NULL, 'GYF DOMAIN-CONTAINING PROTEIN', 250646),
(405427, 'PTHR46992:SF1', NULL, NULL, NULL, NULL, 'GYF DOMAIN-CONTAINING PROTEIN', 250646),
(405428, 'PTHR46992', NULL, NULL, NULL, NULL, 'GYF DOMAIN-CONTAINING PROTEIN', 250646),
(405429, 'PTHR45658:SF118', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR', 250647),
(405430, 'PTHR45658', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR', 250647),
(405431, 'PTHR45658:SF115', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR', 250647),
(405432, 'PTHR45658:SF113', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 2', 250647),
(405433, 'PTHR45658:SF114', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 10-RELATED', 250647),
(405434, 'PTHR45658:SF89', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR', 250647),
(405435, 'PTHR45658:SF45', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR', 250647),
(405436, 'PTHR45658:SF46', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 4', 250647),
(405437, 'PTHR45658:SF48', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR', 250647),
(405438, 'PTHR45658:SF41', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 3', 250647),
(405439, 'PTHR45658:SF42', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 1', 250647),
(405440, 'PTHR45658:SF86', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR STALKY', 250647),
(405441, 'PTHR45658:SF43', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 7-LIKE', 250647),
(405442, 'PTHR45658:SF92', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 5', 250647),
(405443, 'PTHR45658:SF95', NULL, NULL, NULL, NULL, 'GATA TYPE ZINC FINGER TRANSCRIPTION FACTOR FAMILY PROTEIN', 250647),
(405444, 'PTHR45658:SF51', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 8', 250647),
(405445, 'PTHR45658:SF90', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 11-LIKE ISOFORM X1', 250647),
(405446, 'PTHR45658:SF91', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR', 250647),
(405447, 'PTHR45658:SF150', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR', 250647),
(405448, 'PTHR45658:SF128', NULL, NULL, NULL, NULL, 'GATA ZINC FINGER DOMAIN-CONTAINING PROTEIN 10-RELATED', 250647),
(405449, 'PTHR45658:SF129', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 250647),
(405450, 'PTHR45658:SF126', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 250647),
(405451, 'PTHR45658:SF127', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR', 250647),
(405452, 'PTHR45658:SF124', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR', 250647),
(405453, 'PTHR45658:SF125', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 1-LIKE', 250647),
(405454, 'PTHR45658:SF79', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 250647),
(405455, 'PTHR45658:SF37', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 250647),
(405456, 'PTHR45658:SF74', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 6', 250647),
(405457, 'PTHR45658:SF75', NULL, NULL, NULL, NULL, 'GATA ZINC FINGER DOMAIN-CONTAINING PROTEIN 9', 250647),
(405458, 'PTHR45658:SF82', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 250647),
(405459, 'PTHR45658:SF122', NULL, NULL, NULL, NULL, 'GATA ZINC FINGER DOMAIN-CONTAINING PROTEIN 6', 250647),
(405460, 'PTHR45658:SF123', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 250647),
(405461, 'PTHR45658:SF120', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 250647),
(405462, 'PTHR45658:SF121', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 250647),
(405463, 'PTHR45658:SF139', NULL, NULL, NULL, NULL, 'BNAA01G25540D PROTEIN', 250647),
(405464, 'PTHR45658:SF137', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 9', 250647);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(405465, 'PTHR45658:SF138', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR', 250647),
(405466, 'PTHR45658:SF135', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 250647),
(405467, 'PTHR45658:SF136', NULL, NULL, NULL, NULL, 'BNAC01G32490D PROTEIN', 250647),
(405468, 'PTHR45658:SF69', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR', 250647),
(405469, 'PTHR45658:SF64', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR', 250647),
(405470, 'PTHR45658:SF71', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR', 250647),
(405471, 'PTHR45658:SF133', NULL, NULL, NULL, NULL, '', 250647),
(405472, 'PTHR45658:SF134', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 10-RELATED', 250647),
(405473, 'PTHR45658:SF131', NULL, NULL, NULL, NULL, 'OS04G0539500 PROTEIN', 250647),
(405474, 'PTHR45658:SF132', NULL, NULL, NULL, NULL, 'BIOFILM REGULATOR 1', 250647),
(405475, 'PTHR45658:SF130', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 14', 250647),
(405476, 'PTHR45658:SF108', NULL, NULL, NULL, NULL, 'GATA ZINC FINGER FAMILY PROTEIN', 250647),
(405477, 'PTHR45658:SF148', NULL, NULL, NULL, NULL, 'GATA ZINC FINGER FAMILY PROTEIN, EXPRESSED', 250647),
(405478, 'PTHR45658:SF149', NULL, NULL, NULL, NULL, 'PROTEIN GAT3-RELATED', 250647),
(405479, 'PTHR45658:SF105', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 7', 250647),
(405480, 'PTHR45658:SF102', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 29', 250647),
(405481, 'PTHR45658:SF146', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 250647),
(405482, 'PTHR45658:SF18', NULL, NULL, NULL, NULL, 'PROTEIN GAT2', 250647),
(405483, 'PTHR45658:SF147', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR', 250647),
(405484, 'PTHR45658:SF103', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR FAMILY PROTEIN-RELATED', 250647),
(405485, 'PTHR45658:SF57', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 8', 250647),
(405486, 'PTHR45658:SF144', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR', 250647),
(405487, 'PTHR45658:SF145', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR', 250647),
(405488, 'PTHR45658:SF142', NULL, NULL, NULL, NULL, 'GATA TYPE ZINC FINGER TRANSCRIPTION FACTOR FAMILY PROTEIN', 250647),
(405489, 'PTHR45658:SF143', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 4-LIKE', 250647),
(405490, 'PTHR45658:SF140', NULL, NULL, NULL, NULL, '', 250647),
(405491, 'PTHR45658:SF141', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR', 250647),
(405492, 'PTHR46847', NULL, NULL, NULL, NULL, 'D-ALLOSE-BINDING PERIPLASMIC PROTEIN-RELATED', 250648),
(405493, 'PTHR46847:SF4', NULL, NULL, NULL, NULL, 'AUTOINDUCER 2-BINDING PROTEIN LSRB', 250648),
(405494, 'PTHR46847:SF2', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER SUGAR-BINDING PROTEIN', 250648),
(405495, 'PTHR46847:SF3', NULL, NULL, NULL, NULL, 'GALACTOFURANOSE-BINDING PROTEIN YTFQ', 250648),
(405496, 'PTHR46847:SF1', NULL, NULL, NULL, NULL, 'D-ALLOSE-BINDING PERIPLASMIC PROTEIN-RELATED', 250648),
(405497, 'PTHR42889:SF1', NULL, NULL, NULL, NULL, 'BLR3681 PROTEIN', 250649),
(405498, 'PTHR42889', NULL, NULL, NULL, NULL, 'BLR3681 PROTEIN', 250649),
(405499, 'PTHR34653:SF1', NULL, NULL, NULL, NULL, 'FLAGELLAR HOOK-BASAL BODY COMPLEX PROTEIN FLIE', 250650),
(405500, 'PTHR34653', NULL, NULL, NULL, NULL, '', 250650),
(405501, 'PTHR21446:SF12', NULL, NULL, NULL, NULL, 'DUF3504 DOMAIN-CONTAINING PROTEIN', 250651),
(405502, 'PTHR21446:SF6', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ANTIVIRAL-SIGNALING PROTEIN', 250651),
(405503, 'PTHR21446', NULL, NULL, NULL, NULL, 'DUF3504 DOMAIN-CONTAINING PROTEIN', 250651),
(405504, 'PTHR21446:SF3', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL TETRAMERIZATION DOMAIN CONTAINING 1', 250651),
(405505, 'PTHR36023:SF9', NULL, NULL, NULL, NULL, 'PROTEIN ORGAN SIZE RELATED 1', 250652),
(405506, 'PTHR36023:SF14', NULL, NULL, NULL, NULL, 'ARGOS HOMOLOG3', 250652),
(405507, 'PTHR36023:SF5', NULL, NULL, NULL, NULL, 'OS01G0888800 PROTEIN', 250652),
(405508, 'PTHR36023:SF16', NULL, NULL, NULL, NULL, 'PROTEIN AUXIN-REGULATED GENE INVOLVED IN ORGAN SIZE', 250652);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(405509, 'PTHR36023:SF3', NULL, NULL, NULL, NULL, 'ARGOS-LIKE PROTEIN', 250652),
(405510, 'PTHR36023:SF4', NULL, NULL, NULL, NULL, 'ARGOS4', 250652),
(405511, 'PTHR36023:SF13', NULL, NULL, NULL, NULL, 'BNAC04G03310D PROTEIN', 250652),
(405512, 'PTHR36023:SF1', NULL, NULL, NULL, NULL, 'PROTEIN AUXIN-REGULATED GENE INVOLVED IN ORGAN SIZE', 250652),
(405513, 'PTHR36023:SF2', NULL, NULL, NULL, NULL, 'OS08G0113700 PROTEIN', 250652),
(405514, 'PTHR36023', NULL, NULL, NULL, NULL, 'ARGOS-LIKE PROTEIN', 250652),
(405515, 'PTHR36023:SF12', NULL, NULL, NULL, NULL, 'ARGOS8', 250652),
(405516, 'PTHR13274:SF2', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S25, MITOCHONDRIAL', 250653),
(405517, 'PTHR13274', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOMAL PROTEIN S25', 250653),
(405518, 'PTHR47904:SF1', NULL, NULL, NULL, NULL, 'NATURAL CYTOTOXICITY TRIGGERING RECEPTOR 3', 250654),
(405519, 'PTHR47904', NULL, NULL, NULL, NULL, 'NATURAL CYTOTOXICITY TRIGGERING RECEPTOR 3', 250654),
(405520, 'PTHR47341:SF1', NULL, NULL, NULL, NULL, 'GATA-TYPE ZINC FINGER PROTEIN 1', 250655),
(405521, 'PTHR47341', NULL, NULL, NULL, NULL, 'GATA-TYPE ZINC FINGER PROTEIN 1', 250655),
(405522, 'PTHR38050', NULL, NULL, NULL, NULL, '', 250656),
(405523, 'PTHR38050:SF1', NULL, NULL, NULL, NULL, 'FERULOYL ESTERASE C', 250656),
(405524, 'PTHR38050:SF2', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 250656),
(405525, 'PTHR38050:SF3', NULL, NULL, NULL, NULL, 'FERULOYL ESTERASE D', 250656),
(405526, 'PTHR12167:SF4', NULL, NULL, NULL, NULL, 'NATRIURETIC PEPTIDE C-LIKE PROTEIN', 250657),
(405527, 'PTHR12167:SF5', NULL, NULL, NULL, NULL, 'C-TYPE NATRIURETIC PEPTIDE 1', 250657),
(405528, 'PTHR12167:SF2', NULL, NULL, NULL, NULL, 'C-TYPE NATRIURETIC PEPTIDE', 250657),
(405529, 'PTHR12167:SF6', NULL, NULL, NULL, NULL, 'SI:CH73-265D7.2', 250657),
(405530, 'PTHR12167', NULL, NULL, NULL, NULL, 'C-TYPE NATRIURETIC PEPTIDE', 250657),
(405531, 'PTHR47991:SF120', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405532, 'PTHR47991:SF87', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405533, 'PTHR47991:SF121', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405534, 'PTHR47991:SF123', NULL, NULL, NULL, NULL, 'S-NORCOCLAURINE SYNTHASE 1-LIKE', 250658),
(405535, 'PTHR47991:SF85', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405536, 'PTHR47991:SF124', NULL, NULL, NULL, NULL, 'GIBBERELLIN 3-BETA-DIOXYGENASE 3', 250658),
(405537, 'PTHR47991:SF125', NULL, NULL, NULL, NULL, 'CODEINE O-DEMETHYLASE-RELATED', 250658),
(405538, 'PTHR47991:SF83', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405539, 'PTHR47991:SF81', NULL, NULL, NULL, NULL, 'OS08G0426200 PROTEIN', 250658),
(405540, 'PTHR47991:SF80', NULL, NULL, NULL, NULL, 'PROTEIN SRG1-LIKE', 250658),
(405541, 'PTHR47991:SF129', NULL, NULL, NULL, NULL, 'ANTHOCYANIDIN SYNTHASE', 250658),
(405542, 'PTHR47991:SF79', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405543, 'PTHR47991:SF195', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405544, 'PTHR47991:SF196', NULL, NULL, NULL, NULL, 'OXOGLUTARATE/IRON-DEPENDENT DIOXYGENASE-RELATED', 250658),
(405545, 'PTHR47991:SF197', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE-DEPENDENT DIOXYGENASE 11', 250658),
(405546, 'PTHR47991:SF198', NULL, NULL, NULL, NULL, 'PROTEIN SRG1-LIKE ISOFORM X1', 250658),
(405547, 'PTHR47991:SF75', NULL, NULL, NULL, NULL, '2OG-FE(II) OXYGENASE FAMILY OXIDOREDUCTASE', 250658),
(405548, 'PTHR47991:SF199', NULL, NULL, NULL, NULL, 'OS03G0856000 PROTEIN', 250658),
(405549, 'PTHR47991:SF111', NULL, NULL, NULL, NULL, 'CODEINE O-DEMETHYLASE-LIKE', 250658),
(405550, 'PTHR47991:SF112', NULL, NULL, NULL, NULL, 'FE(II)/2-OXOGLUTARATE-DEPENDENT OXYGENASE', 250658),
(405551, 'PTHR47991:SF73', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405552, 'PTHR47991:SF113', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(405553, 'PTHR47991:SF72', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405554, 'PTHR47991:SF115', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405555, 'PTHR47991:SF71', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405556, 'PTHR47991:SF116', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 250658),
(405557, 'PTHR47991:SF190', NULL, NULL, NULL, NULL, 'GIBBERELLIN 3-BETA-DIOXYGENASE 1-LIKE', 250658),
(405558, 'PTHR47991:SF191', NULL, NULL, NULL, NULL, 'FLAVONOL SYNTHASE/FLAVANONE 3-HYDROXYLASE', 250658),
(405559, 'PTHR47991:SF192', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405560, 'PTHR47991:SF193', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405561, 'PTHR47991:SF194', NULL, NULL, NULL, NULL, 'PROTEIN DOWNY MILDEW RESISTANCE 6-LIKE', 250658),
(405562, 'PTHR47991:SF184', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405563, 'PTHR47991:SF185', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405564, 'PTHR47991:SF67', NULL, NULL, NULL, NULL, 'KAR-UP OXIDOREDUCTASE 1', 250658),
(405565, 'PTHR47991:SF66', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405566, 'PTHR47991:SF186', NULL, NULL, NULL, NULL, 'HYOSCYAMINE 6-DIOXYGENASE-LIKE', 250658),
(405567, 'PTHR47991:SF65', NULL, NULL, NULL, NULL, 'HYOSCYAMINE 6-DIOXYGENASE-LIKE ISOFORM X1', 250658),
(405568, 'PTHR47991:SF187', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405569, 'PTHR47991:SF188', NULL, NULL, NULL, NULL, 'HYOSCYAMINE 6-DIOXYGENASE-LIKE', 250658),
(405570, 'PTHR47991:SF63', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 250658),
(405571, 'PTHR47991:SF189', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 250658),
(405572, 'PTHR47991:SF102', NULL, NULL, NULL, NULL, 'OS08G0417100 PROTEIN', 250658),
(405573, 'PTHR47991:SF62', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405574, 'PTHR47991:SF103', NULL, NULL, NULL, NULL, 'PROTEIN SRG1', 250658),
(405575, 'PTHR47991:SF61', NULL, NULL, NULL, NULL, 'PROTEIN DMR6-LIKE OXYGENASE 2-LIKE', 250658),
(405576, 'PTHR47991:SF104', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405577, 'PTHR47991:SF60', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405578, 'PTHR47991:SF105', NULL, NULL, NULL, NULL, 'OS06G0176500 PROTEIN', 250658),
(405579, 'PTHR47991:SF106', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 250658),
(405580, 'PTHR47991:SF107', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405581, 'PTHR47991:SF108', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405582, 'PTHR47991:SF109', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405583, 'PTHR47991:SF180', NULL, NULL, NULL, NULL, '2OG-FE(II) OXYGENASE FAMILY OXIDOREDUCTASE', 250658),
(405584, 'PTHR47991:SF181', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405585, 'PTHR47991:SF182', NULL, NULL, NULL, NULL, '2OG-FE(II) OXYGENASE FAMILY OXIDOREDUCTASE', 250658),
(405586, 'PTHR47991:SF183', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405587, 'PTHR47991:SF173', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405588, 'PTHR47991:SF174', NULL, NULL, NULL, NULL, 'HYOSCYAMINE 6-DIOXYGENASE-RELATED', 250658),
(405589, 'PTHR47991:SF56', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405590, 'PTHR47991:SF55', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405591, 'PTHR47991:SF175', NULL, NULL, NULL, NULL, 'PROTEIN SRG1-LIKE', 250658);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(405592, 'PTHR47991:SF176', NULL, NULL, NULL, NULL, 'PROTEIN SRG1', 250658),
(405593, 'PTHR47991:SF54', NULL, NULL, NULL, NULL, 'DIOX_N DOMAIN-CONTAINING PROTEIN', 250658),
(405594, 'PTHR47991:SF53', NULL, NULL, NULL, NULL, 'FLAVONOL SYNTHASE/FLAVANONE 3-HYDROXYLASE', 250658),
(405595, 'PTHR47991:SF177', NULL, NULL, NULL, NULL, 'PROTEIN SRG1', 250658),
(405596, 'PTHR47991:SF178', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405597, 'PTHR47991:SF179', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405598, 'PTHR47991', NULL, NULL, NULL, NULL, 'OXOGLUTARATE/IRON-DEPENDENT DIOXYGENASE', 250658),
(405599, 'PTHR47991:SF170', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405600, 'PTHR47991:SF48', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405601, 'PTHR47991:SF171', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 250658),
(405602, 'PTHR47991:SF47', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405603, 'PTHR47991:SF172', NULL, NULL, NULL, NULL, 'HYOSCYAMINE 6-DIOXYGENASE-LIKE', 250658),
(405604, 'PTHR47991:SF162', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405605, 'PTHR47991:SF165', NULL, NULL, NULL, NULL, 'OS10G0558200 PROTEIN', 250658),
(405606, 'PTHR47991:SF43', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405607, 'PTHR47991:SF2', NULL, NULL, NULL, NULL, 'PROTEIN DMR6-LIKE OXYGENASE 2-LIKE', 250658),
(405608, 'PTHR47991:SF42', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405609, 'PTHR47991:SF166', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405610, 'PTHR47991:SF1', NULL, NULL, NULL, NULL, 'OS06G0178700 PROTEIN', 250658),
(405611, 'PTHR47991:SF168', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405612, 'PTHR47991:SF4', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405613, 'PTHR47991:SF3', NULL, NULL, NULL, NULL, 'PROTEIN SRG1-LIKE', 250658),
(405614, 'PTHR47991:SF6', NULL, NULL, NULL, NULL, 'OS10G0559500 PROTEIN', 250658),
(405615, 'PTHR47991:SF5', NULL, NULL, NULL, NULL, 'FLAVONOL SYNTHASE/FLAVANONE 3-HYDROXYLASE', 250658),
(405616, 'PTHR47991:SF8', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405617, 'PTHR47991:SF7', NULL, NULL, NULL, NULL, 'PROTEIN DMR6-LIKE OXYGENASE 2-LIKE', 250658),
(405618, 'PTHR47991:SF9', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE-LIKE PROTEIN', 250658),
(405619, 'PTHR47991:SF39', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405620, 'PTHR47991:SF160', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405621, 'PTHR47991:SF36', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 250658),
(405622, 'PTHR47991:SF35', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 250658),
(405623, 'PTHR47991:SF34', NULL, NULL, NULL, NULL, 'OXYGENASE FAMILY OXIDOREDUCTASE, PUTATIVE-RELATED', 250658),
(405624, 'PTHR47991:SF152', NULL, NULL, NULL, NULL, 'GIBBERELLIN 20-OXIDASE', 250658),
(405625, 'PTHR47991:SF153', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405626, 'PTHR47991:SF154', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405627, 'PTHR47991:SF31', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405628, 'PTHR47991:SF30', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405629, 'PTHR47991:SF156', NULL, NULL, NULL, NULL, 'PROTEIN DMR6-LIKE OXYGENASE 2-LIKE', 250658),
(405630, 'PTHR47991:SF157', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE-DEPENDENT DIOXYGENASE 21, CHLOROPLASTIC', 250658),
(405631, 'PTHR47991:SF28', NULL, NULL, NULL, NULL, 'BNACNNG33000D PROTEIN', 250658);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(405632, 'PTHR47991:SF27', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405633, 'PTHR47991:SF26', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405634, 'PTHR47991:SF150', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 250658),
(405635, 'PTHR47991:SF24', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405636, 'PTHR47991:SF141', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405637, 'PTHR47991:SF23', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405638, 'PTHR47991:SF142', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE/FE(II)-DEPENDENT DIOXYGENASE-RELATED', 250658),
(405639, 'PTHR47991:SF21', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405640, 'PTHR47991:SF143', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405641, 'PTHR47991:SF20', NULL, NULL, NULL, NULL, '2OG-FE(II) OXYGENASE FAMILY OXIDOREDUCTASE', 250658),
(405642, 'PTHR47991:SF147', NULL, NULL, NULL, NULL, 'CODEINE O-DEMETHYLASE-LIKE', 250658),
(405643, 'PTHR47991:SF148', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405644, 'PTHR47991:SF149', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 250658),
(405645, 'PTHR47991:SF18', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 250658),
(405646, 'PTHR47991:SF16', NULL, NULL, NULL, NULL, 'DIOX_N DOMAIN-CONTAINING PROTEIN', 250658),
(405647, 'PTHR47991:SF15', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405648, 'PTHR47991:SF12', NULL, NULL, NULL, NULL, '2OG-FE(II) OXYGENASE FAMILY OXIDOREDUCTASE', 250658),
(405649, 'PTHR47991:SF99', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405650, 'PTHR47991:SF131', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405651, 'PTHR47991:SF132', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405652, 'PTHR47991:SF98', NULL, NULL, NULL, NULL, 'OS06G0176300 PROTEIN', 250658),
(405653, 'PTHR47991:SF133', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405654, 'PTHR47991:SF97', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405655, 'PTHR47991:SF96', NULL, NULL, NULL, NULL, 'FLAVONOL SYNTHASE/FLAVANONE 3-HYDROXYLASE-LIKE', 250658),
(405656, 'PTHR47991:SF134', NULL, NULL, NULL, NULL, 'OXOGLUTARATE/IRON-DEPENDENT DIOXYGENASE-RELATED', 250658),
(405657, 'PTHR47991:SF136', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405658, 'PTHR47991:SF94', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 250658),
(405659, 'PTHR47991:SF93', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE 1', 250658),
(405660, 'PTHR47991:SF138', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405661, 'PTHR47991:SF92', NULL, NULL, NULL, NULL, 'OS03G0439500 PROTEIN', 250658),
(405662, 'PTHR47991:SF91', NULL, NULL, NULL, NULL, 'HYOSCYAMINE 6-DIOXYGENASE-LIKE', 250658),
(405663, 'PTHR47991:SF90', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250658),
(405664, 'PTHR23348:SF46', NULL, NULL, NULL, NULL, 'PERIAXIN', 250659),
(405665, 'PTHR23348:SF41', NULL, NULL, NULL, NULL, 'NEUROBLAST DIFFERENTIATION-ASSOCIATED PROTEIN AHNAK', 250659),
(405666, 'PTHR23348', NULL, NULL, NULL, NULL, 'PERIAXIN/AHNAK', 250659),
(405667, 'PTHR23348:SF42', NULL, NULL, NULL, NULL, 'PERIAXIN', 250659),
(405668, 'PTHR23348:SF16', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN', 250659),
(405669, 'PTHR23348:SF37', NULL, NULL, NULL, NULL, 'PROTEIN AHNAK2', 250659),
(405670, 'PTHR23333', NULL, NULL, NULL, NULL, 'UBX DOMAIN CONTAINING PROTEIN', 250660),
(405671, 'PTHR23333:SF43', NULL, NULL, NULL, NULL, 'PLANT UBX DOMAIN-CONTAINING PROTEIN 5-RELATED', 250660),
(405672, 'PTHR23333:SF33', NULL, NULL, NULL, NULL, 'BNACNNG13870D PROTEIN', 250660);
INSERT INTO "PUBLIC"."MODEL" VALUES
(405673, 'PTHR23333:SF44', NULL, NULL, NULL, NULL, 'BNAANNG29860D PROTEIN', 250660),
(405674, 'PTHR23333:SF45', NULL, NULL, NULL, NULL, 'PLANT UBX DOMAIN-CONTAINING PROTEIN 4-LIKE', 250660),
(405675, 'PTHR23333:SF34', NULL, NULL, NULL, NULL, 'BNAA04G13020D PROTEIN', 250660),
(405676, 'PTHR23333:SF46', NULL, NULL, NULL, NULL, 'PLANT UBX DOMAIN-CONTAINING PROTEIN 4', 250660),
(405677, 'PTHR23333:SF35', NULL, NULL, NULL, NULL, 'BNAA09G20540D PROTEIN', 250660),
(405678, 'PTHR23333:SF24', NULL, NULL, NULL, NULL, 'NSFL1 COFACTOR P47', 250660),
(405679, 'PTHR23333:SF25', NULL, NULL, NULL, NULL, 'OS06G0634600 PROTEIN', 250660),
(405680, 'PTHR23333:SF14', NULL, NULL, NULL, NULL, 'UBX DOMAIN-CONTAINING PROTEIN 2B', 250660),
(405681, 'PTHR23333:SF37', NULL, NULL, NULL, NULL, 'BNAA04G13040D PROTEIN', 250660),
(405682, 'PTHR23333:SF16', NULL, NULL, NULL, NULL, 'UBX DOMAIN-CONTAINING PROTEIN 2A', 250660),
(405683, 'PTHR23333:SF4', NULL, NULL, NULL, NULL, 'UBX DOMAIN-CONTAINING PROTEIN 11', 250660),
(405684, 'PTHR23333:SF39', NULL, NULL, NULL, NULL, 'UBX DOMAIN-CONTAINING PROTEIN', 250660),
(405685, 'PTHR23333:SF30', NULL, NULL, NULL, NULL, '', 250660),
(405686, 'PTHR23333:SF20', NULL, NULL, NULL, NULL, 'NSFL1 COFACTOR P47', 250660),
(405687, 'PTHR23001:SF27', NULL, NULL, NULL, NULL, 'EIF2B_5 DOMAIN-CONTAINING PROTEIN', 250661),
(405688, 'PTHR23001:SF17', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 5', 250661),
(405689, 'PTHR23001', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR', 250661),
(405690, 'PTHR23001:SF28', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 5-2-RELATED', 250661),
(405691, 'PTHR23001:SF39', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 5-LIKE', 250661),
(405692, 'PTHR23001:SF30', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 5-1-RELATED', 250661),
(405693, 'PTHR23001:SF21', NULL, NULL, NULL, NULL, 'EIF2B_5 DOMAIN-CONTAINING PROTEIN', 250661),
(405694, 'PTHR23001:SF22', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 5', 250661),
(405695, 'PTHR23001:SF44', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 2 BETA SUBUNIT', 250661),
(405696, 'PTHR23001:SF34', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR IF2/IF5-RELATED', 250661),
(405697, 'PTHR23001:SF45', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 2B FAMILY PROTEIN / EIF-2B FAMILY PROTEIN', 250661),
(405698, 'PTHR23001:SF24', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 2 SUBUNIT 2', 250661),
(405699, 'PTHR23001:SF46', NULL, NULL, NULL, NULL, 'W2 DOMAIN-CONTAINING PROTEIN', 250661),
(405700, 'PTHR23001:SF35', NULL, NULL, NULL, NULL, 'EIF2B_5 DOMAIN-CONTAINING PROTEIN', 250661),
(405701, 'PTHR23001:SF47', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 5', 250661),
(405702, 'PTHR23001:SF48', NULL, NULL, NULL, NULL, 'EIF2B_5 DOMAIN-CONTAINING PROTEIN', 250661),
(405703, 'PTHR23001:SF37', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 5-LIKE', 250661),
(405704, 'PTHR23001:SF3', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 2 SUBUNIT 2', 250661),
(405705, 'PTHR23001:SF7', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 5', 250661),
(405706, 'PTHR23001:SF40', NULL, NULL, NULL, NULL, 'W2 DOMAIN-CONTAINING PROTEIN', 250661),
(405707, 'PTHR36981:SF3', NULL, NULL, NULL, NULL, '', 250662),
(405708, 'PTHR36981:SF1', NULL, NULL, NULL, NULL, 'NANOR-RELATED', 250662),
(405709, 'PTHR36981', NULL, NULL, NULL, NULL, 'ZGC:195170', 250662),
(405710, 'PTHR13944:SF20', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 2', 250663),
(405711, 'PTHR13944:SF21', NULL, NULL, NULL, NULL, 'CYSTS, ISOFORM C', 250663),
(405712, 'PTHR13944:SF22', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 28', 250663),
(405713, 'PTHR13944:SF23', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 18', 250663),
(405714, 'PTHR13944', NULL, NULL, NULL, NULL, 'AGAP007712-PA', 250663);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(405715, 'PTHR13944:SF18', NULL, NULL, NULL, NULL, 'A-KINASE ANCHOR PROTEIN 13', 250663),
(405716, 'PTHR14002:SF40', NULL, NULL, NULL, NULL, 'UROMODULIN', 250664),
(405717, 'PTHR14002:SF41', NULL, NULL, NULL, NULL, 'ENDOGLIN', 250664),
(405718, 'PTHR14002:SF20', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 250664),
(405719, 'PTHR14002:SF43', NULL, NULL, NULL, NULL, 'DELETED IN MALIGNANT BRAIN TUMORS 1 PROTEIN', 250664),
(405720, 'PTHR14002:SF21', NULL, NULL, NULL, NULL, 'SI:CH211-103F14.3-RELATED', 250664),
(405721, 'PTHR14002:SF22', NULL, NULL, NULL, NULL, 'UROMODULIN-LIKE 1', 250664),
(405722, 'PTHR14002:SF44', NULL, NULL, NULL, NULL, 'ZONA PELLUCIDA-LIKE DOMAIN-CONTAINING 1B', 250664),
(405723, 'PTHR14002:SF45', NULL, NULL, NULL, NULL, 'ENDOGLIN', 250664),
(405724, 'PTHR14002:SF24', NULL, NULL, NULL, NULL, 'ZONA PELLUCIDA-LIKE DOMAIN-CONTAINING PROTEIN 1', 250664),
(405725, 'PTHR14002:SF46', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 250664),
(405726, 'PTHR14002:SF47', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 250664),
(405727, 'PTHR14002:SF27', NULL, NULL, NULL, NULL, 'CUB AND ZONA PELLUCIDA-LIKE DOMAIN-CONTAINING PROTEIN 1', 250664),
(405728, 'PTHR14002', NULL, NULL, NULL, NULL, 'ENDOGLIN/TGF-BETA RECEPTOR TYPE III', 250664),
(405729, 'PTHR14002:SF30', NULL, NULL, NULL, NULL, 'TRANSFORMING GROWTH FACTOR, BETA RECEPTOR III', 250664),
(405730, 'PTHR14002:SF31', NULL, NULL, NULL, NULL, 'ZONA PELLUCIDA-LIKE DOMAIN-CONTAINING 2', 250664),
(405731, 'PTHR14002:SF10', NULL, NULL, NULL, NULL, 'SI:CH73-261I21.5-RELATED', 250664),
(405732, 'PTHR14002:SF11', NULL, NULL, NULL, NULL, 'SI:CH211-226H7.3-RELATED', 250664),
(405733, 'PTHR14002:SF13', NULL, NULL, NULL, NULL, 'BETA-TECTORIN', 250664),
(405734, 'PTHR14002:SF14', NULL, NULL, NULL, NULL, 'SI:DKEY-103G5.3', 250664),
(405735, 'PTHR14002:SF7', NULL, NULL, NULL, NULL, 'TRANSFORMING GROWTH FACTOR BETA RECEPTOR TYPE 3', 250664),
(405736, 'PTHR14002:SF9', NULL, NULL, NULL, NULL, 'TRANSFORMING GROWTH FACTOR-BETA RECEPTOR TYPE 3-LIKE PROTEIN', 250664),
(405737, 'PTHR14002:SF16', NULL, NULL, NULL, NULL, 'PANCREATIC SECRETORY GRANULE MEMBRANE MAJOR GLYCOPROTEIN GP2', 250664),
(405738, 'PTHR14002:SF38', NULL, NULL, NULL, NULL, 'DELETED IN MALIGNANT BRAIN TUMORS 1 PROTEIN', 250664),
(405739, 'PTHR14002:SF18', NULL, NULL, NULL, NULL, 'ONCOPROTEIN-INDUCED TRANSCRIPT 3 PROTEIN', 250664),
(405740, 'PTHR14002:SF1', NULL, NULL, NULL, NULL, 'ENDOGLIN', 250664),
(405741, 'PTHR43538', NULL, NULL, NULL, NULL, 'ALPHA-IPM SYNTHASE/HOMOCITRATE SYNTHASE', 250665),
(405742, 'PTHR43538:SF1', NULL, NULL, NULL, NULL, '(R)-CITRAMALATE SYNTHASE', 250665),
(405743, 'PTHR44390', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 41 KDA', 250666),
(405744, 'PTHR44390:SF1', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 41 KDA', 250666),
(405745, 'PTHR24543', NULL, NULL, NULL, NULL, 'MULTICOPPER OXIDASE-RELATED', 250667),
(405746, 'PTHR24543:SF329', NULL, NULL, NULL, NULL, 'F5/8 TYPE C DOMAIN-CONTAINING PROTEIN', 250667),
(405747, 'PTHR24543:SF307', NULL, NULL, NULL, NULL, 'MILK FAT GLOBULE EGF AND FACTOR V/VIII DOMAIN-CONTAINING B', 250667),
(405748, 'PTHR24543:SF328', NULL, NULL, NULL, NULL, 'F5/8 TYPE C DOMAIN-CONTAINING PROTEIN', 250667),
(405749, 'PTHR24543:SF317', NULL, NULL, NULL, NULL, 'LACTADHERIN', 250667),
(405750, 'PTHR24543:SF327', NULL, NULL, NULL, NULL, '', 250667),
(405751, 'PTHR24543:SF315', NULL, NULL, NULL, NULL, 'F5/8 TYPE C DOMAIN-CONTAINING PROTEIN', 250667),
(405752, 'PTHR24543:SF326', NULL, NULL, NULL, NULL, 'METALLOENDOPEPTIDASE', 250667),
(405753, 'PTHR24543:SF325', NULL, NULL, NULL, NULL, 'EGF-LIKE REPEAT AND DISCOIDIN I-LIKE DOMAIN-CONTAINING PROTEIN 3', 250667),
(405754, 'PTHR24543:SF302', NULL, NULL, NULL, NULL, 'COAGULATION FACTOR V', 250667),
(405755, 'PTHR24543:SF320', NULL, NULL, NULL, NULL, 'COAGULATION FACTOR VIII', 250667),
(405756, 'PTHR24543:SF330', NULL, NULL, NULL, NULL, 'F5/8 TYPE C DOMAIN-CONTAINING PROTEIN', 250667),
(405757, 'PTHR24543:SF295', NULL, NULL, NULL, NULL, 'RETINOSCHISIN', 250667),
(405758, 'PTHR24543:SF291', NULL, NULL, NULL, NULL, 'SMOKE ALARM, ISOFORM D', 250667);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(405759, 'PTHR15586:SF0', NULL, NULL, NULL, NULL, 'LINKER FOR ACTIVATION OF T-CELLS FAMILY MEMBER 1', 250668),
(405760, 'PTHR15586', NULL, NULL, NULL, NULL, 'LINKER FOR ACTIVATION OF T-CELLS FAMILY MEMBER 1', 250668),
(405761, 'PTHR38326:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 11 OPEN READING FRAME 97', 250669),
(405762, 'PTHR38326', NULL, NULL, NULL, NULL, 'CHROMOSOME 11 OPEN READING FRAME 97', 250669),
(405763, 'PTHR17604', NULL, NULL, NULL, NULL, 'TRANSCRIPTION COFACTOR VESTIGIAL-LIKE PROTEIN 4', 250670),
(405764, 'PTHR17604:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION COFACTOR VESTIGIAL-LIKE PROTEIN 4', 250670),
(405765, 'PTHR17604:SF4', NULL, NULL, NULL, NULL, 'VESTIGIAL-LIKE 4 LIKE', 250670),
(405766, 'PTHR17604:SF6', NULL, NULL, NULL, NULL, 'VESTIGIAL-LIKE FAMILY MEMBER 4A', 250670),
(405767, 'PTHR34756', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE-ASSOCIATED PROTEIN 3', 250671),
(405768, 'PTHR34756:SF1', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE-ASSOCIATED PROTEIN 3', 250671),
(405769, 'PTHR12815:SF38', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE OMP85 FAMILY PROTEIN', 250672),
(405770, 'PTHR12815:SF15', NULL, NULL, NULL, NULL, 'OS11G0106200 PROTEIN', 250672),
(405771, 'PTHR12815:SF48', NULL, NULL, NULL, NULL, 'OMP85 DOMAIN-CONTAINING PROTEIN', 250672),
(405772, 'PTHR12815:SF18', NULL, NULL, NULL, NULL, 'SORTING AND ASSEMBLY MACHINERY COMPONENT 50 HOMOLOG', 250672),
(405773, 'PTHR12815:SF39', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE OMP85 FAMILY PROTEIN', 250672),
(405774, 'PTHR12815:SF45', NULL, NULL, NULL, NULL, 'OMP85 DOMAIN-CONTAINING PROTEIN', 250672),
(405775, 'PTHR12815:SF34', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE OMP85 FAMILY PROTEIN', 250672),
(405776, 'PTHR12815:SF23', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN ASSEMBLY FACTOR BAMA', 250672),
(405777, 'PTHR12815:SF47', NULL, NULL, NULL, NULL, 'TRANSLOCATION AND ASSEMBLY MODULE SUBUNIT TAMA', 250672),
(405778, 'PTHR12815:SF36', NULL, NULL, NULL, NULL, 'OS11G0116500 PROTEIN', 250672),
(405779, 'PTHR12815:SF46', NULL, NULL, NULL, NULL, '', 250672),
(405780, 'PTHR12815', NULL, NULL, NULL, NULL, 'SORTING AND ASSEMBLY MACHINERY SAMM50 PROTEIN FAMILY MEMBER', 250672),
(405781, 'PTHR12815:SF41', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE OMP85 FAMILY PROTEIN ISOFORM 1', 250672),
(405782, 'PTHR12815:SF51', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE OMP85 FAMILY PROTEIN', 250672),
(405783, 'PTHR12815:SF40', NULL, NULL, NULL, NULL, 'OUTER ENVELOPE PROTEIN 36, CHLOROPLASTIC-RELATED', 250672),
(405784, 'PTHR12815:SF32', NULL, NULL, NULL, NULL, 'OUTER ENVELOPE PROTEIN 80, CHLOROPLASTIC', 250672),
(405785, 'PTHR12815:SF42', NULL, NULL, NULL, NULL, 'OMP85 DOMAIN-CONTAINING PROTEIN', 250672),
(405786, 'PTHR12815:SF50', NULL, NULL, NULL, NULL, 'OMP85 DOMAIN-CONTAINING PROTEIN', 250672),
(405787, 'PTHR34894:SF5', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 250673),
(405788, 'PTHR34894', NULL, NULL, NULL, NULL, 'SAM-DEPENDENT METHYLTRANSFERASE RSMI, CONSERVED SITE', 250673),
(405789, 'PTHR12455', NULL, NULL, NULL, NULL, 'NUCLEOLAR COMPLEX PROTEIN 4', 250674),
(405790, 'PTHR12455:SF0', NULL, NULL, NULL, NULL, 'NUCLEOLAR COMPLEX PROTEIN 4 HOMOLOG', 250674),
(405791, 'PTHR12455:SF1', NULL, NULL, NULL, NULL, 'CBF DOMAIN-CONTAINING PROTEIN', 250674),
(405792, 'PTHR35166:SF11', NULL, NULL, NULL, NULL, 'OS05G0151550 PROTEIN', 250675),
(405793, 'PTHR35166:SF13', NULL, NULL, NULL, NULL, '', 250675),
(405794, 'PTHR35166:SF16', NULL, NULL, NULL, NULL, '', 250675),
(405795, 'PTHR35166:SF15', NULL, NULL, NULL, NULL, 'OS05G0193700 PROTEIN', 250675),
(405796, 'PTHR35166:SF18', NULL, NULL, NULL, NULL, '', 250675),
(405797, 'PTHR35166:SF6', NULL, NULL, NULL, NULL, 'PROTEIN-RELATED', 250675),
(405798, 'PTHR35166:SF17', NULL, NULL, NULL, NULL, 'OS07G0643300 PROTEIN', 250675),
(405799, 'PTHR35166', NULL, NULL, NULL, NULL, 'OS05G0193700 PROTEIN-RELATED', 250675),
(405800, 'PTHR37204:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 250676),
(405801, 'PTHR37204', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 250676),
(405802, 'PTHR30115', NULL, NULL, NULL, NULL, 'NITROGEN REGULATORY PROTEIN P-II', 250677);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(405803, 'PTHR30115:SF18', NULL, NULL, NULL, NULL, 'NITROGEN REGULATORY PROTEIN P-II', 250677),
(405804, 'PTHR30115:SF13', NULL, NULL, NULL, NULL, 'PII-LIKE PROTEIN GLNBI', 250677),
(405805, 'PTHR30115:SF11', NULL, NULL, NULL, NULL, 'NITROGEN REGULATORY PROTEIN P-II HOMOLOG', 250677),
(405806, 'PTHR30115:SF20', NULL, NULL, NULL, NULL, 'NITROGEN REGULATORY PROTEIN GLNK', 250677),
(405807, 'PTHR38483', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 250678),
(405808, 'PTHR38483:SF1', NULL, NULL, NULL, NULL, 'ION_TRANS DOMAIN-CONTAINING PROTEIN', 250678),
(405809, 'PTHR31303', NULL, NULL, NULL, NULL, 'CTP-DEPENDENT DIACYLGLYCEROL KINASE 1', 250679),
(405810, 'PTHR31303:SF1', NULL, NULL, NULL, NULL, 'CTP-DEPENDENT DIACYLGLYCEROL KINASE 1', 250679),
(405811, 'PTHR31286:SF85', NULL, NULL, NULL, NULL, 'LATE BLIGHT RESISTANCE PROTEIN', 250680),
(405812, 'PTHR31286:SF141', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN-RELATED', 250680),
(405813, 'PTHR31286:SF140', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 250680),
(405814, 'PTHR31286:SF143', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 250680),
(405815, 'PTHR31286:SF142', NULL, NULL, NULL, NULL, 'BNAA09G38560D PROTEIN', 250680),
(405816, 'PTHR31286:SF81', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 250680),
(405817, 'PTHR31286:SF145', NULL, NULL, NULL, NULL, '', 250680),
(405818, 'PTHR31286:SF47', NULL, NULL, NULL, NULL, 'OS10G0362600 PROTEIN', 250680),
(405819, 'PTHR31286:SF144', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 250680),
(405820, 'PTHR31286:SF147', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 250680),
(405821, 'PTHR31286:SF146', NULL, NULL, NULL, NULL, 'ZINC FINGER, CCHC-TYPE', 250680),
(405822, 'PTHR31286:SF149', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 250680),
(405823, 'PTHR31286:SF105', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 250680),
(405824, 'PTHR31286:SF104', NULL, NULL, NULL, NULL, 'PEROXIDASE', 250680),
(405825, 'PTHR31286', NULL, NULL, NULL, NULL, 'GLYCINE-RICH CELL WALL STRUCTURAL PROTEIN 1.8-LIKE', 250680),
(405826, 'PTHR31286:SF87', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 250680),
(405827, 'PTHR31286:SF148', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 250680),
(405828, 'PTHR31286:SF46', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 250680),
(405829, 'PTHR31286:SF119', NULL, NULL, NULL, NULL, '', 250680),
(405830, 'PTHR31286:SF150', NULL, NULL, NULL, NULL, 'ZF-CCHC_4 DOMAIN-CONTAINING PROTEIN', 250680),
(405831, 'PTHR31286:SF97', NULL, NULL, NULL, NULL, 'BNAA05G13310D PROTEIN', 250680),
(405832, 'PTHR31286:SF96', NULL, NULL, NULL, NULL, 'BNAC04G11410D PROTEIN', 250680),
(405833, 'PTHR31286:SF152', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 250680),
(405834, 'PTHR31286:SF90', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 250680),
(405835, 'PTHR31286:SF151', NULL, NULL, NULL, NULL, 'ENDONUCLEASE/EXONUCLEASE/PHOSPHATASE', 250680),
(405836, 'PTHR31286:SF93', NULL, NULL, NULL, NULL, 'BNAC09G52820D PROTEIN', 250680),
(405837, 'PTHR31286:SF154', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 250680),
(405838, 'PTHR31286:SF153', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 250680),
(405839, 'PTHR31286:SF112', NULL, NULL, NULL, NULL, 'BNAA03G60110D PROTEIN', 250680),
(405840, 'PTHR31286:SF156', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 250680),
(405841, 'PTHR31286:SF155', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN PROTEIN', 250680),
(405842, 'PTHR31286:SF158', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 250680),
(405843, 'PTHR31286:SF113', NULL, NULL, NULL, NULL, 'ZF-CCHC_4 DOMAIN-CONTAINING PROTEIN', 250680),
(405844, 'PTHR31286:SF157', NULL, NULL, NULL, NULL, 'ZF-CCHC_4 DOMAIN-CONTAINING PROTEIN', 250680),
(405845, 'PTHR31286:SF99', NULL, NULL, NULL, NULL, 'ZINC ION BINDING / NUCLEIC ACID BINDING PROTEIN', 250680),
(405846, 'PTHR31286:SF55', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 250680);
INSERT INTO "PUBLIC"."MODEL" VALUES
(405847, 'PTHR31286:SF54', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 250680),
(405848, 'PTHR31286:SF159', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 250680),
(405849, 'PTHR31286:SF57', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 250680),
(405850, 'PTHR31286:SF62', NULL, NULL, NULL, NULL, 'ZINC KNUCKLE (CCHC-TYPE) FAMILY PROTEIN', 250680),
(405851, 'PTHR31286:SF161', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 250680),
(405852, 'PTHR31286:SF160', NULL, NULL, NULL, NULL, 'BNAA07G07800D PROTEIN', 250680),
(405853, 'PTHR31286:SF63', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN-RELATED', 250680),
(405854, 'PTHR31286:SF60', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 250680),
(405855, 'PTHR31286:SF123', NULL, NULL, NULL, NULL, 'ENDONUCLEASE/EXONUCLEASE/PHOSPHATASE', 250680),
(405856, 'PTHR31286:SF125', NULL, NULL, NULL, NULL, 'BNAC01G28820D PROTEIN', 250680),
(405857, 'PTHR31286:SF127', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 250680),
(405858, 'PTHR31286:SF65', NULL, NULL, NULL, NULL, 'BNAA09G15220D PROTEIN', 250680),
(405859, 'PTHR31286:SF129', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 250680),
(405860, 'PTHR31286:SF128', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 250680),
(405861, 'PTHR31286:SF130', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 250680),
(405862, 'PTHR31286:SF132', NULL, NULL, NULL, NULL, 'BNAANNG03470D PROTEIN', 250680),
(405863, 'PTHR31286:SF131', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 250680),
(405864, 'PTHR31286:SF134', NULL, NULL, NULL, NULL, 'OS01G0559450 PROTEIN', 250680),
(405865, 'PTHR31286:SF133', NULL, NULL, NULL, NULL, 'TA11-LIKE NON-LTR RETROELEMENT PROTEIN-RELATED', 250680),
(405866, 'PTHR31286:SF39', NULL, NULL, NULL, NULL, 'OS01G0714300 PROTEIN', 250680),
(405867, 'PTHR31286:SF136', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN PROTEIN', 250680),
(405868, 'PTHR31286:SF135', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 250680),
(405869, 'PTHR31286:SF138', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 250680),
(405870, 'PTHR31286:SF137', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 250680),
(405871, 'PTHR31286:SF79', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 250680),
(405872, 'PTHR31286:SF78', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 250680),
(405873, 'PTHR31286:SF139', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN', 250680),
(405874, 'PTHR31703', NULL, NULL, NULL, NULL, 'UPF0669 PROTEIN C6ORF120', 250681),
(405875, 'PTHR31703:SF2', NULL, NULL, NULL, NULL, 'UPF0669 PROTEIN C6ORF120', 250681),
(405876, 'PTHR31435:SF10', NULL, NULL, NULL, NULL, 'BSR4717 PROTEIN', 250682),
(405877, 'PTHR31435', NULL, NULL, NULL, NULL, 'PROTEIN NATD1', 250682),
(405878, 'PTHR31435:SF9', NULL, NULL, NULL, NULL, 'PROTEIN NATD1', 250682),
(405879, 'PTHR31435:SF8', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASES (NAT) SUPERFAMILY PROTEIN', 250682),
(405880, 'PTHR38441', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN-RELATED', 250683),
(405881, 'PTHR38441:SF1', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN-RELATED', 250683),
(405882, 'PTHR37763:SF1', NULL, NULL, NULL, NULL, 'EXOSOME COMPLEX EXONUCLEASE', 250684),
(405883, 'PTHR37763', NULL, NULL, NULL, NULL, 'EXOSOME COMPLEX EXONUCLEASE', 250684),
(405884, 'PTHR47970:SF19', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIP1', 250685),
(405885, 'PTHR47970', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF11', 250685),
(405886, 'PTHR47970:SF28', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 250685),
(405887, 'PTHR47970:SF15', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 250685),
(405888, 'PTHR47970:SF26', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF11', 250685),
(405889, 'PTHR47970:SF27', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 250685),
(405890, 'PTHR47970:SF24', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 250685);
INSERT INTO "PUBLIC"."MODEL" VALUES
(405891, 'PTHR47970:SF5', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 250685),
(405892, 'PTHR47970:SF25', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 250685),
(405893, 'PTHR47970:SF14', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 250685),
(405894, 'PTHR47970:SF22', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF3C', 250685),
(405895, 'PTHR47970:SF11', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 250685),
(405896, 'PTHR47970:SF6', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING KINESIN-LIKE PROTEIN', 250685),
(405897, 'PTHR47970:SF23', NULL, NULL, NULL, NULL, '', 250685),
(405898, 'PTHR47970:SF12', NULL, NULL, NULL, NULL, 'KINESIN FAMILY MEMBER 11', 250685),
(405899, 'PTHR47970:SF9', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-5D', 250685),
(405900, 'PTHR47970:SF20', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 250685),
(405901, 'PTHR47970:SF8', NULL, NULL, NULL, NULL, 'KINESIN MOTOR DOMAIN-CONTAINING PROTEIN', 250685),
(405902, 'PTHR47970:SF21', NULL, NULL, NULL, NULL, 'METHYL-ACCEPTING CHEMOTAXIS PROTEIN', 250685),
(405903, 'PTHR47970:SF1', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-5A', 250685),
(405904, 'PTHR47970:SF2', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-5D', 250685),
(405905, 'PTHR22710', NULL, NULL, NULL, NULL, 'X-RAY RADIATION RESISTANCE ASSOCIATED PROTEIN 1  XRRA1', 250686),
(405906, 'PTHR22710:SF2', NULL, NULL, NULL, NULL, 'X-RAY RADIATION RESISTANCE-ASSOCIATED PROTEIN 1', 250686),
(405907, 'PTHR32455:SF1', NULL, NULL, NULL, NULL, 'SPERM ACROSOME-ASSOCIATED PROTEIN 9', 250687),
(405908, 'PTHR32455', NULL, NULL, NULL, NULL, 'SPERM ACROSOME-ASSOCIATED PROTEIN 9', 250687),
(405909, 'PTHR28649:SF5', NULL, NULL, NULL, NULL, 'REPRIMO, TP53-DEPENDENT G2 ARREST MEDIATOR HOMOLOG 3', 250688),
(405910, 'PTHR28649:SF3', NULL, NULL, NULL, NULL, 'REPRIMO-LIKE PROTEIN', 250688),
(405911, 'PTHR28649:SF2', NULL, NULL, NULL, NULL, 'PROTEIN REPRIMO', 250688),
(405912, 'PTHR28649:SF1', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 41', 250688),
(405913, 'PTHR28649', NULL, NULL, NULL, NULL, 'PROTEIN REPRIMO-RELATED', 250688),
(405914, 'PTHR30406:SF1', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORT SYSTEM PERMEASE PROTEIN CYSW', 250689),
(405915, 'PTHR30406', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORT SYSTEM PERMEASE PROTEIN', 250689),
(405916, 'PTHR30406:SF8', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORT SYSTEM PERMEASE PROTEIN CYST', 250689),
(405917, 'PTHR30406:SF9', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORT SYSTEM PERMEASE PROTEIN CYSW', 250689),
(405918, 'PTHR30406:SF10', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORT SYSTEM PERMEASE PROTEIN CYST', 250689),
(405919, 'PTHR11827:SF93', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 12 MEMBER 1', 250690),
(405920, 'PTHR11827:SF7', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 12 PROTEIN B0303.11', 250690),
(405921, 'PTHR11827:SF72', NULL, NULL, NULL, NULL, 'GH08340P', 250690),
(405922, 'PTHR11827:SF6', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 12 MEMBER 8', 250690),
(405923, 'PTHR11827:SF73', NULL, NULL, NULL, NULL, 'KAZACHOC, ISOFORM G', 250690),
(405924, 'PTHR11827:SF9', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 12 MEMBER 3', 250690),
(405925, 'PTHR11827:SF96', NULL, NULL, NULL, NULL, 'ZGC:153039', 250690),
(405926, 'PTHR11827:SF97', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 12 MEMBER 10, TANDEM DUPLICATE 1-RELATED', 250690),
(405927, 'PTHR11827:SF53', NULL, NULL, NULL, NULL, 'K+/CL-COTRANSPORTER', 250690),
(405928, 'PTHR11827:SF98', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 12 MEMBER 9', 250690),
(405929, 'PTHR11827:SF54', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 12 MEMBER 5', 250690),
(405930, 'PTHR11827:SF99', NULL, NULL, NULL, NULL, 'CATION-CHLORIDE COTRANSPORTER 1-LIKE ISOFORM X1', 250690),
(405931, 'PTHR11827:SF55', NULL, NULL, NULL, NULL, 'POTASSIUM/CHLORIDE COTRANSPORTER 3', 250690),
(405932, 'PTHR11827:SF66', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 12 MEMBER 6', 250690),
(405933, 'PTHR11827:SF100', NULL, NULL, NULL, NULL, 'CATION-CHLORIDE COTRANSPORTER 1', 250690);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(405934, 'PTHR11827', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 12, CATION COTRANSPORTERS', 250690),
(405935, 'PTHR11827:SF103', NULL, NULL, NULL, NULL, 'SODIUM CHLORIDE COTRANSPORTER 69, ISOFORM E', 250690),
(405936, 'PTHR11827:SF101', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 12 MEMBER 3', 250690),
(405937, 'PTHR11827:SF102', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 12 MEMBER 3 LIKE', 250690),
(405938, 'PTHR11827:SF68', NULL, NULL, NULL, NULL, 'CATION-CHLORIDE COTRANSPORTER 2', 250690),
(405939, 'PTHR11827:SF46', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 12 MEMBER 4', 250690),
(405940, 'PTHR11827:SF47', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 12 MEMBER 7', 250690),
(405941, 'PTHR11827:SF58', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 12 MEMBER 2', 250690),
(405942, 'PTHR11827:SF48', NULL, NULL, NULL, NULL, 'GH09711P', 250690),
(405943, 'PTHR46351:SF3', NULL, NULL, NULL, NULL, 'WOUND-INDUCED PROTEIN WIN2', 250691),
(405944, 'PTHR46351:SF12', NULL, NULL, NULL, NULL, 'BARWIN DOMAIN-CONTAINING PROTEIN', 250691),
(405945, 'PTHR46351:SF11', NULL, NULL, NULL, NULL, 'HEVEIN-LIKE PREPROPROTEIN', 250691),
(405946, 'PTHR46351', NULL, NULL, NULL, NULL, 'WOUND-INDUCED PROTEIN WIN2', 250691),
(405947, 'PTHR46351:SF16', NULL, NULL, NULL, NULL, 'BNAC03G33880D PROTEIN', 250691),
(405948, 'PTHR46351:SF14', NULL, NULL, NULL, NULL, 'HEVEIN-LIKE PREPROPROTEIN', 250691),
(405949, 'PTHR46351:SF19', NULL, NULL, NULL, NULL, 'CHITINASE / HEVEIN / PR-4 / WHEATWIN2', 250691),
(405950, 'PTHR46351:SF8', NULL, NULL, NULL, NULL, 'BARWIN DOMAIN-CONTAINING PROTEIN', 250691),
(405951, 'PTHR46351:SF7', NULL, NULL, NULL, NULL, 'HEVEIN-LIKE PREPROPROTEIN', 250691),
(405952, 'PTHR46351:SF18', NULL, NULL, NULL, NULL, 'WHEATWIN-2', 250691),
(405953, 'PTHR46351:SF17', NULL, NULL, NULL, NULL, 'PUTATIVE, EXPRESSED-RELATED', 250691),
(405954, 'PTHR46351:SF6', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED PROTEIN PR-4A', 250691),
(405955, 'PTHR11905:SF114', NULL, NULL, NULL, NULL, 'DISINTEGRIN AND METALLOPROTEINASE DOMAIN-CONTAINING PROTEIN 11', 250692),
(405956, 'PTHR11905:SF136', NULL, NULL, NULL, NULL, 'DISINTEGRIN AND METALLOPROTEINASE DOMAIN-CONTAINING PROTEIN 9', 250692),
(405957, 'PTHR11905:SF158', NULL, NULL, NULL, NULL, 'DISINTEGRIN AND METALLOPROTEINASE DOMAIN-CONTAINING PROTEIN 18', 250692),
(405958, 'PTHR11905:SF28', NULL, NULL, NULL, NULL, 'DISINTEGRIN AND METALLOPROTEINASE DOMAIN-CONTAINING PROTEIN 5', 250692),
(405959, 'PTHR11905:SF112', NULL, NULL, NULL, NULL, 'DISINTEGRIN AND METALLOPROTEINASE DOMAIN-CONTAINING PROTEIN 12', 250692),
(405960, 'PTHR11905:SF26', NULL, NULL, NULL, NULL, 'A DISINTEGRIN AND METALLOPEPTIDASE DOMAIN 3', 250692),
(405961, 'PTHR11905:SF232', NULL, NULL, NULL, NULL, 'DISINTEGRIN AND METALLOPROTEINASE DOMAIN-CONTAINING PROTEIN 20', 250692),
(405962, 'PTHR11905:SF231', NULL, NULL, NULL, NULL, 'ADAM METALLOPEPTIDASE DOMAIN 21', 250692),
(405963, 'PTHR11905:SF130', NULL, NULL, NULL, NULL, 'DISINTEGRIN AND METALLOPROTEINASE DOMAIN-CONTAINING PROTEIN 15', 250692),
(405964, 'PTHR11905:SF239', NULL, NULL, NULL, NULL, 'A DISINTEGRIN AND METALLOPEPTIDASE DOMAIN 26B-RELATED', 250692),
(405965, 'PTHR11905:SF118', NULL, NULL, NULL, NULL, 'DISINTEGRIN AND METALLOPROTEINASE DOMAIN-CONTAINING PROTEIN 24', 250692),
(405966, 'PTHR11905:SF238', NULL, NULL, NULL, NULL, 'PEPTIDASE M12B DOMAIN-CONTAINING PROTEIN', 250692),
(405967, 'PTHR11905:SF237', NULL, NULL, NULL, NULL, 'MIND-MELD, ISOFORM J', 250692),
(405968, 'PTHR11905:SF215', NULL, NULL, NULL, NULL, 'A DISINTEGRIN AND METALLOPEPTIDASE DOMAIN 3-LIKE', 250692),
(405969, 'PTHR11905:SF116', NULL, NULL, NULL, NULL, 'DISINTEGRIN AND METALLOPROTEINASE DOMAIN-CONTAINING PROTEIN 21', 250692),
(405970, 'PTHR11905:SF159', NULL, NULL, NULL, NULL, 'ADAM METALLOPROTEASE', 250692),
(405971, 'PTHR11905:SF13', NULL, NULL, NULL, NULL, 'DISINTEGRIN AND METALLOPROTEINASE DOMAIN-CONTAINING PROTEIN 23', 250692),
(405972, 'PTHR11905:SF34', NULL, NULL, NULL, NULL, 'DISINTEGRIN AND METALLOPROTEINASE DOMAIN-CONTAINING PROTEIN 29', 250692),
(405973, 'PTHR11905:SF32', NULL, NULL, NULL, NULL, 'DISINTEGRIN AND METALLOPROTEINASE DOMAIN-CONTAINING PROTEIN 28', 250692);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(405974, 'PTHR11905:SF246', NULL, NULL, NULL, NULL, '', 250692),
(405975, 'PTHR11905:SF125', NULL, NULL, NULL, NULL, 'ADAM DEC1', 250692),
(405976, 'PTHR11905:SF38', NULL, NULL, NULL, NULL, 'DISINTEGRIN AND METALLOPROTEINASE DOMAIN-CONTAINING PROTEIN 33', 250692),
(405977, 'PTHR11905:SF245', NULL, NULL, NULL, NULL, '', 250692),
(405978, 'PTHR11905:SF244', NULL, NULL, NULL, NULL, 'ZGC:174164', 250692),
(405979, 'PTHR11905:SF167', NULL, NULL, NULL, NULL, 'A DISINTEGRIN AND METALLOPEPTIDASE DOMAIN 4-RELATED', 250692),
(405980, 'PTHR11905:SF222', NULL, NULL, NULL, NULL, 'ADAM FAMILY OF METALLOPROTEASE ADM-A (AFU_ORTHOLOGUE AFUA_6G14420)', 250692),
(405981, 'PTHR11905:SF14', NULL, NULL, NULL, NULL, 'DISINTEGRIN AND METALLOPROTEINASE DOMAIN-CONTAINING PROTEIN 22', 250692),
(405982, 'PTHR11905:SF122', NULL, NULL, NULL, NULL, 'PROVISIONAL ORTHOLOG OF ADAM METALLOPEPTIDASE DOMAIN 9', 250692),
(405983, 'PTHR11905:SF243', NULL, NULL, NULL, NULL, 'SOL NARAE, ISOFORM C', 250692),
(405984, 'PTHR11905:SF120', NULL, NULL, NULL, NULL, 'DISINTEGRIN AND METALLOPROTEINASE DOMAIN-CONTAINING PROTEIN 1A-RELATED', 250692),
(405985, 'PTHR11905:SF19', NULL, NULL, NULL, NULL, 'DISINTEGRIN AND METALLOPROTEINASE DOMAIN-CONTAINING PROTEIN 19', 250692),
(405986, 'PTHR11905:SF240', NULL, NULL, NULL, NULL, '', 250692),
(405987, 'PTHR11905:SF140', NULL, NULL, NULL, NULL, 'A DISINTEGRIN AND METALLOPEPTIDASE DOMAIN 6-RELATED', 250692),
(405988, 'PTHR11905:SF108', NULL, NULL, NULL, NULL, 'DISINTEGRIN AND METALLOPROTEINASE DOMAIN-CONTAINING PROTEIN 2', 250692),
(405989, 'PTHR11905', NULL, NULL, NULL, NULL, 'ADAM  A DISINTEGRIN AND METALLOPROTEASE DOMAIN', 250692),
(405990, 'PTHR11905:SF248', NULL, NULL, NULL, NULL, 'DISINTEGRIN AND METALLOPROTEINASE DOMAIN-CONTAINING PROTEIN UNC-71', 250692),
(405991, 'PTHR11905:SF247', NULL, NULL, NULL, NULL, 'DISINTEGRIN DOMAIN-CONTAINING PROTEIN', 250692),
(405992, 'PTHR11905:SF148', NULL, NULL, NULL, NULL, 'DISINTEGRIN AND METALLOPROTEINASE DOMAIN-CONTAINING PROTEIN 30', 250692),
(405993, 'PTHR11905:SF20', NULL, NULL, NULL, NULL, 'DISINTEGRIN AND METALLOPROTEINASE DOMAIN-CONTAINING PROTEIN 8', 250692),
(405994, 'PTHR11905:SF24', NULL, NULL, NULL, NULL, 'DISINTEGRIN AND METALLOPROTEINASE DOMAIN-CONTAINING PROTEIN 32', 250692),
(405995, 'PTHR11905:SF21', NULL, NULL, NULL, NULL, 'DISINTEGRIN AND METALLOPROTEINASE DOMAIN-CONTAINING PROTEIN 7', 250692),
(405996, 'PTHR28080:SF5', NULL, NULL, NULL, NULL, 'PEROXISOME BIOGENESIS PROTEIN 3-2-LIKE', 250693),
(405997, 'PTHR28080:SF3', NULL, NULL, NULL, NULL, 'BNAANNG11100D PROTEIN', 250693),
(405998, 'PTHR28080:SF1', NULL, NULL, NULL, NULL, 'PEROXISOMAL BIOGENESIS FACTOR 3', 250693),
(405999, 'PTHR28080:SF2', NULL, NULL, NULL, NULL, 'PEROXISOME BIOGENESIS PROTEIN 3-1', 250693),
(406000, 'PTHR28080', NULL, NULL, NULL, NULL, 'PEROXISOMAL BIOGENESIS FACTOR 3', 250693),
(406001, 'PTHR16092:SF34', NULL, NULL, NULL, NULL, 'SYNTAXIN-BINDING PROTEIN 6 (AMISYN),-LIKE', 250694),
(406002, 'PTHR16092:SF14', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT 1', 250694),
(406003, 'PTHR16092:SF29', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250694),
(406004, 'PTHR16092', NULL, NULL, NULL, NULL, 'SEC3/SYNTAXIN-RELATED', 250694),
(406005, 'PTHR16092:SF31', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT SEC3A-LIKE', 250694),
(406006, 'PTHR16092:SF20', NULL, NULL, NULL, NULL, 'SEC3-PIP2_BIND DOMAIN-CONTAINING PROTEIN', 250694),
(406007, 'PTHR16092:SF32', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT SEC3-RELATED', 250694),
(406008, 'PTHR16092:SF33', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT 1', 250694),
(406009, 'PTHR38746', NULL, NULL, NULL, NULL, 'CBM49 DOMAIN-CONTAINING PROTEIN-RELATED', 250695),
(406010, 'PTHR38746:SF1', NULL, NULL, NULL, NULL, '', 250695),
(406011, 'PTHR38746:SF2', NULL, NULL, NULL, NULL, 'CBM49 DOMAIN-CONTAINING PROTEIN', 250695),
(406012, 'PTHR38746:SF3', NULL, NULL, NULL, NULL, '', 250695),
(406013, 'PTHR38746:SF4', NULL, NULL, NULL, NULL, 'CBM49 DOMAIN-CONTAINING PROTEIN', 250695),
(406014, 'PTHR33408:SF2', NULL, NULL, NULL, NULL, 'TNP_DDE_DOM DOMAIN-CONTAINING PROTEIN', 250696);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(406015, 'PTHR33408', NULL, NULL, NULL, NULL, 'TRANSPOSASE', 250696),
(406016, 'PTHR33408:SF4', NULL, NULL, NULL, NULL, 'TNP_DDE_DOM DOMAIN-CONTAINING PROTEIN', 250696),
(406017, 'PTHR33376:SF7', NULL, NULL, NULL, NULL, 'C4-DICARBOXYLATE-BINDING PROTEIN DCTB', 250697),
(406018, 'PTHR33376:SF5', NULL, NULL, NULL, NULL, 'SLR1962 PROTEIN', 250697),
(406019, 'PTHR33376:SF15', NULL, NULL, NULL, NULL, 'BLL6794 PROTEIN', 250697),
(406020, 'PTHR33376:SF4', NULL, NULL, NULL, NULL, 'SIALIC ACID-BINDING PERIPLASMIC PROTEIN SIAP', 250697),
(406021, 'PTHR33376:SF3', NULL, NULL, NULL, NULL, 'C4-DICARBOXYLATE-BINDING PROTEIN', 250697),
(406022, 'PTHR33376:SF17', NULL, NULL, NULL, NULL, 'DICARBOXYLATE-BINDING PERIPLASMIC PROTEIN-RELATED', 250697),
(406023, 'PTHR33376:SF2', NULL, NULL, NULL, NULL, '2,3-DIKETO-L-GULONATE-BINDING PERIPLASMIC PROTEIN YIAO', 250697),
(406024, 'PTHR33376', NULL, NULL, NULL, NULL, '', 250697),
(406025, 'PTHR34269:SF8', NULL, NULL, NULL, NULL, 'BNAA09G20800D PROTEIN', 250698),
(406026, 'PTHR34269:SF9', NULL, NULL, NULL, NULL, 'BNAANNG23550D PROTEIN', 250698),
(406027, 'PTHR34269:SF20', NULL, NULL, NULL, NULL, 'BNAA03G59030D PROTEIN', 250698),
(406028, 'PTHR34269:SF10', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 250698),
(406029, 'PTHR34269:SF11', NULL, NULL, NULL, NULL, 'B3 DOMAIN PROTEIN', 250698),
(406030, 'PTHR34269:SF16', NULL, NULL, NULL, NULL, '', 250698),
(406031, 'PTHR34269:SF17', NULL, NULL, NULL, NULL, 'B3 DOMAIN PROTEIN', 250698),
(406032, 'PTHR34269:SF18', NULL, NULL, NULL, NULL, 'BNAA05G09940D PROTEIN', 250698),
(406033, 'PTHR34269:SF19', NULL, NULL, NULL, NULL, '', 250698),
(406034, 'PTHR34269:SF2', NULL, NULL, NULL, NULL, 'BNAA05G37020D PROTEIN', 250698),
(406035, 'PTHR34269:SF3', NULL, NULL, NULL, NULL, '', 250698),
(406036, 'PTHR34269', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR B3-DOMAIN FAMILY-RELATED', 250698),
(406037, 'PTHR34269:SF14', NULL, NULL, NULL, NULL, 'BNACNNG67860D PROTEIN', 250698),
(406038, 'PTHR34269:SF5', NULL, NULL, NULL, NULL, 'BNAC02G48470D PROTEIN', 250698),
(406039, 'PTHR34269:SF15', NULL, NULL, NULL, NULL, 'TF-B3 DOMAIN-CONTAINING PROTEIN', 250698),
(406040, 'PTHR47004', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 24', 250699),
(406041, 'PTHR47004:SF1', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 24', 250699),
(406042, 'PTHR30618:SF5', NULL, NULL, NULL, NULL, 'URIDINE PERMEASE', 250700),
(406043, 'PTHR30618:SF6', NULL, NULL, NULL, NULL, 'PERMEASE-RELATED', 250700),
(406044, 'PTHR30618:SF4', NULL, NULL, NULL, NULL, '', 250700),
(406045, 'PTHR30618:SF1', NULL, NULL, NULL, NULL, '', 250700),
(406046, 'PTHR30618:SF2', NULL, NULL, NULL, NULL, 'ALLANTOIN PERMEASE-RELATED', 250700),
(406047, 'PTHR30618', NULL, NULL, NULL, NULL, 'NCS1 FAMILY PURINE/PYRIMIDINE TRANSPORTER', 250700),
(406048, 'PTHR30618:SF0', NULL, NULL, NULL, NULL, 'PURINE-URACIL PERMEASE NCS1', 250700),
(406049, 'PTHR30618:SF15', NULL, NULL, NULL, NULL, 'NICOTINAMIDE RIBOSIDE TRANSPORTER 1-RELATED', 250700),
(406050, 'PTHR30618:SF14', NULL, NULL, NULL, NULL, '', 250700),
(406051, 'PTHR42897:SF2', NULL, NULL, NULL, NULL, 'PYRUVATE SYNTHASE SUBUNIT PORB', 250701),
(406052, 'PTHR42897:SF1', NULL, NULL, NULL, NULL, '2-OXOACID OXIDOREDUCTASE (FERREDOXIN)', 250701),
(406053, 'PTHR42897', NULL, NULL, NULL, NULL, 'PYRUVATE SYNTHASE SUBUNIT PORB', 250701),
(406054, 'PTHR48135:SF1', NULL, NULL, NULL, NULL, 'KILA-N DOMAIN-CONTAINING PROTEIN', 250702),
(406055, 'PTHR48135', NULL, NULL, NULL, NULL, '', 250702),
(406056, 'PTHR46800:SF5', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 250703),
(406057, 'PTHR46800', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY-RELATED-RELATED', 250703),
(406058, 'PTHR46800:SF6', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 250703),
(406059, 'PTHR46800:SF1', NULL, NULL, NULL, NULL, 'NR LBD DOMAIN-CONTAINING PROTEIN-RELATED', 250703),
(406060, 'PTHR46800:SF2', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY-RELATED', 250703),
(406061, 'PTHR46800:SF3', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 250703);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(406062, 'PTHR46800:SF4', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY-RELATED', 250703),
(406063, 'PTHR31293:SF22', NULL, NULL, NULL, NULL, 'BNAC06G14330D PROTEIN', 250704),
(406064, 'PTHR31293:SF23', NULL, NULL, NULL, NULL, 'BNAC06G43350D PROTEIN', 250704),
(406065, 'PTHR31293:SF12', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 250704),
(406066, 'PTHR31293:SF24', NULL, NULL, NULL, NULL, 'BNAANNG15180D PROTEIN', 250704),
(406067, 'PTHR31293:SF20', NULL, NULL, NULL, NULL, 'FBD DOMAIN-CONTAINING PROTEIN', 250704),
(406068, 'PTHR31293:SF18', NULL, NULL, NULL, NULL, 'RNI-LIKE SUPERFAMILY PROTEIN', 250704),
(406069, 'PTHR31293', NULL, NULL, NULL, NULL, 'RNI-LIKE SUPERFAMILY PROTEIN', 250704),
(406070, 'PTHR31293:SF16', NULL, NULL, NULL, NULL, 'RNI-LIKE SUPERFAMILY PROTEIN', 250704),
(406071, 'PTHR17206:SF0', NULL, NULL, NULL, NULL, 'PROLACTIN-RELEASING PEPTIDE', 250705),
(406072, 'PTHR17206:SF1', NULL, NULL, NULL, NULL, 'PROLACTIN-RELEASING PEPTIDE', 250705),
(406073, 'PTHR17206', NULL, NULL, NULL, NULL, 'PROLACTIN-RELEASING PEPTIDE', 250705),
(406074, 'PTHR43401', NULL, NULL, NULL, NULL, 'L-THREONINE 3-DEHYDROGENASE', 250706),
(406075, 'PTHR43401:SF5', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE-RELATED', 250706),
(406076, 'PTHR43401:SF3', NULL, NULL, NULL, NULL, 'L-GALACTONATE-5-DEHYDROGENASE', 250706),
(406077, 'PTHR43401:SF4', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE GROES DOMAIN PROTEIN', 250706),
(406078, 'PTHR43401:SF1', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE, ZINC-CONTAINING', 250706),
(406079, 'PTHR43401:SF2', NULL, NULL, NULL, NULL, 'L-THREONINE 3-DEHYDROGENASE', 250706),
(406080, 'PTHR12329:SF32', NULL, NULL, NULL, NULL, 'OS08G0546100 PROTEIN', 250707),
(406081, 'PTHR12329:SF43', NULL, NULL, NULL, NULL, 'MOLECULAR CHAPERONE REGULATOR BAG-1, UBIQUITIN-RELATED DOMAIN PROTEIN-RELATED', 250707),
(406082, 'PTHR12329:SF10', NULL, NULL, NULL, NULL, 'BAG FAMILY MOLECULAR CHAPERONE REGULATOR 4', 250707),
(406083, 'PTHR12329:SF20', NULL, NULL, NULL, NULL, 'OS06G0126500 PROTEIN', 250707),
(406084, 'PTHR12329:SF42', NULL, NULL, NULL, NULL, 'BNAA02G11050D PROTEIN', 250707),
(406085, 'PTHR12329:SF12', NULL, NULL, NULL, NULL, 'BAG FAMILY MOLECULAR CHAPERONE REGULATOR 3', 250707),
(406086, 'PTHR12329:SF45', NULL, NULL, NULL, NULL, 'BNAC07G32520D PROTEIN', 250707),
(406087, 'PTHR12329:SF33', NULL, NULL, NULL, NULL, 'BAG FAMILY MOLECULAR CHAPERONE REGULATOR 2', 250707),
(406088, 'PTHR12329:SF11', NULL, NULL, NULL, NULL, 'BAG FAMILY MOLECULAR CHAPERONE REGULATOR 3', 250707),
(406089, 'PTHR12329:SF44', NULL, NULL, NULL, NULL, 'MOLECULAR CHAPERONE REGULATOR BAG-1, UBIQUITIN-RELATED DOMAIN PROTEIN-RELATED', 250707),
(406090, 'PTHR12329:SF47', NULL, NULL, NULL, NULL, 'BAG FAMILY MOLECULAR CHAPERONE REGULATOR 1', 250707),
(406091, 'PTHR12329:SF5', NULL, NULL, NULL, NULL, 'STARVIN, ISOFORM E', 250707),
(406092, 'PTHR12329:SF36', NULL, NULL, NULL, NULL, 'BAG FAMILY MOLECULAR CHAPERONE REGULATOR-LIKE PROTEIN', 250707),
(406093, 'PTHR12329:SF46', NULL, NULL, NULL, NULL, 'BCL-2-ASSOCIATED ATHANOGENE PROTEIN', 250707),
(406094, 'PTHR12329:SF49', NULL, NULL, NULL, NULL, 'BAG FAMILY MOLECULAR CHAPERONE REGULATOR 4-LIKE ISOFORM X1', 250707),
(406095, 'PTHR12329:SF38', NULL, NULL, NULL, NULL, 'BAG FAMILY MOLECULAR CHAPERONE REGULATOR-LIKE PROTEIN', 250707),
(406096, 'PTHR12329:SF16', NULL, NULL, NULL, NULL, 'BAG FAMILY MOLECULAR CHAPERONE REGULATOR 1', 250707),
(406097, 'PTHR12329:SF37', NULL, NULL, NULL, NULL, 'BAG FAMILY MOLECULAR CHAPERONE REGULATOR 2-LIKE', 250707),
(406098, 'PTHR12329:SF48', NULL, NULL, NULL, NULL, '', 250707),
(406099, 'PTHR12329:SF2', NULL, NULL, NULL, NULL, 'BAG FAMILY MOLECULAR CHAPERONE REGULATOR 5', 250707),
(406100, 'PTHR12329:SF17', NULL, NULL, NULL, NULL, 'OS04G0619900 PROTEIN', 250707),
(406101, 'PTHR12329', NULL, NULL, NULL, NULL, 'BCL2-ASSOCIATED ATHANOGENE', 250707),
(406102, 'PTHR12329:SF40', NULL, NULL, NULL, NULL, 'BAG FAMILY MOLECULAR CHAPERONE REGULATOR 4', 250707),
(406103, 'PTHR36400:SF1', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L35', 250708);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(406104, 'PTHR36400', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L35', 250708),
(406105, 'PTHR36400:SF2', NULL, NULL, NULL, NULL, 'BNAANNG05650D PROTEIN', 250708),
(406106, 'PTHR43521:SF7', NULL, NULL, NULL, NULL, 'DELTA-1-PYRROLINE-5-CARBOXYLATE DEHYDROGENASE 12A1, MITOCHONDRIAL', 250709),
(406107, 'PTHR43521:SF6', NULL, NULL, NULL, NULL, 'ALDEHYDE/HISTIDINOL DEHYDROGENASE-RELATED', 250709),
(406108, 'PTHR43521:SF1', NULL, NULL, NULL, NULL, 'ALPHA-AMINOADIPIC SEMIALDEHYDE DEHYDROGENASE', 250709),
(406109, 'PTHR43521:SF3', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE (NAD(+))', 250709),
(406110, 'PTHR43521:SF5', NULL, NULL, NULL, NULL, 'ALPHA-AMINOADIPIC SEMIALDEHYDE DEHYDROGENASE', 250709),
(406111, 'PTHR43521', NULL, NULL, NULL, NULL, 'ALPHA-AMINOADIPIC SEMIALDEHYDE DEHYDROGENASE', 250709),
(406112, 'PTHR45812', NULL, NULL, NULL, NULL, 'DNA POLYMERASE ZETA CATALYTIC SUBUNIT', 250710),
(406113, 'PTHR45812:SF1', NULL, NULL, NULL, NULL, 'DNA POLYMERASE ZETA CATALYTIC SUBUNIT', 250710),
(406114, 'PTHR38109:SF1', NULL, NULL, NULL, NULL, 'PROTEIN YCGL', 250711),
(406115, 'PTHR38109', NULL, NULL, NULL, NULL, 'PROTEIN YCGL', 250711),
(406116, 'PTHR40733:SF1', NULL, NULL, NULL, NULL, 'DUF1610 DOMAIN-CONTAINING PROTEIN', 250712),
(406117, 'PTHR40733', NULL, NULL, NULL, NULL, 'ZINC-RIBBON RNA-BINDING PROTEIN INVOLVED IN TRANSLATION-RELATED', 250712),
(406118, 'PTHR12654:SF29', NULL, NULL, NULL, NULL, 'NON-LYSOSOMAL GLUCOSYLCERAMIDASE', 250713),
(406119, 'PTHR12654:SF28', NULL, NULL, NULL, NULL, 'NON-LYSOSOMAL GLUCOSYLCERAMIDASE', 250713),
(406120, 'PTHR12654:SF27', NULL, NULL, NULL, NULL, 'NON-LYSOSOMAL GLUCOSYLCERAMIDASE', 250713),
(406121, 'PTHR12654:SF25', NULL, NULL, NULL, NULL, 'NON-LYSOSOMAL GLUCOSYLCERAMIDASE', 250713),
(406122, 'PTHR12654:SF24', NULL, NULL, NULL, NULL, 'NON-LYSOSOMAL GLUCOSYLCERAMIDASE', 250713),
(406123, 'PTHR12654:SF23', NULL, NULL, NULL, NULL, 'NON-LYSOSOMAL GLUCOSYLCERAMIDASE', 250713),
(406124, 'PTHR12654:SF2', NULL, NULL, NULL, NULL, 'NON-LYSOSOMAL GLUCOSYLCERAMIDASE', 250713),
(406125, 'PTHR12654:SF21', NULL, NULL, NULL, NULL, 'NON-LYSOSOMAL GLUCOSYLCERAMIDASE', 250713),
(406126, 'PTHR12654:SF20', NULL, NULL, NULL, NULL, 'NON-LYSOSOMAL GLUCOSYLCERAMIDASE', 250713),
(406127, 'PTHR12654:SF0', NULL, NULL, NULL, NULL, 'NON-LYSOSOMAL GLUCOSYLCERAMIDASE', 250713),
(406128, 'PTHR12654:SF3', NULL, NULL, NULL, NULL, 'NON-LYSOSOMAL GLUCOSYLCERAMIDASE', 250713),
(406129, 'PTHR12654:SF4', NULL, NULL, NULL, NULL, '', 250713),
(406130, 'PTHR12654', NULL, NULL, NULL, NULL, 'BILE ACID BETA-GLUCOSIDASE-RELATED', 250713),
(406131, 'PTHR36292:SF1', NULL, NULL, NULL, NULL, 'UPF0575 PROTEIN C19ORF67', 250714),
(406132, 'PTHR36292:SF2', NULL, NULL, NULL, NULL, 'ATHERIN', 250714),
(406133, 'PTHR36292', NULL, NULL, NULL, NULL, 'UPF0575 PROTEIN C19ORF67', 250714),
(406134, 'PTHR15002', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 250715),
(406135, 'PTHR15002:SF0', NULL, NULL, NULL, NULL, 'RIBOSOMAL BIOGENESIS PROTEIN LAS1L', 250715),
(406136, 'PTHR36116:SF1', NULL, NULL, NULL, NULL, 'UPF0060 MEMBRANE PROTEIN YNFA', 250716),
(406137, 'PTHR36116', NULL, NULL, NULL, NULL, 'UPF0060 MEMBRANE PROTEIN YNFA', 250716),
(406138, 'PTHR43473:SF2', NULL, NULL, NULL, NULL, 'MAGNESIUM-CHELATASE SUBUNIT CHLD, CHLOROPLASTIC', 250717),
(406139, 'PTHR43473', NULL, NULL, NULL, NULL, 'MAGNESIUM-CHELATASE SUBUNIT CHLD, CHLOROPLASTIC', 250717),
(406140, 'PTHR10359:SF18', NULL, NULL, NULL, NULL, 'ENDONUCLEASE III', 250718),
(406141, 'PTHR10359:SF19', NULL, NULL, NULL, NULL, 'DNA REPAIR GLYCOSYLASE MJ1434-RELATED', 250718),
(406142, 'PTHR10359', NULL, NULL, NULL, NULL, 'A/G-SPECIFIC ADENINE GLYCOSYLASE/ENDONUCLEASE III', 250718),
(406143, 'PTHR36846', NULL, NULL, NULL, NULL, 'PROTEIN VIAA', 250719),
(406144, 'PTHR36846:SF1', NULL, NULL, NULL, NULL, 'PROTEIN VIAA', 250719),
(406145, 'PTHR31707:SF418', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406146, 'PTHR31707:SF419', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 250720),
(406147, 'PTHR31707:SF263', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(406148, 'PTHR31707:SF385', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 47-RELATED', 250720),
(406149, 'PTHR31707:SF386', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406150, 'PTHR31707:SF420', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406151, 'PTHR31707:SF387', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 250720),
(406152, 'PTHR31707:SF266', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406153, 'PTHR31707:SF260', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 250720),
(406154, 'PTHR31707:SF382', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 28-RELATED', 250720),
(406155, 'PTHR31707:SF383', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 250720),
(406156, 'PTHR31707:SF305', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406157, 'PTHR31707:SF307', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406158, 'PTHR31707:SF388', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406159, 'PTHR31707:SF146', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406160, 'PTHR31707:SF300', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406161, 'PTHR31707:SF268', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 58-RELATED', 250720),
(406162, 'PTHR31707:SF389', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR', 250720),
(406163, 'PTHR31707:SF147', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 39-RELATED', 250720),
(406164, 'PTHR31707:SF269', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406165, 'PTHR31707:SF302', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406166, 'PTHR31707:SF149', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 17-RELATED', 250720),
(406167, 'PTHR31707:SF308', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406168, 'PTHR31707:SF309', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR', 250720),
(406169, 'PTHR31707:SF71', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406170, 'PTHR31707:SF390', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 60-RELATED', 250720),
(406171, 'PTHR31707:SF274', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406172, 'PTHR31707:SF395', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 250720),
(406173, 'PTHR31707:SF396', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406174, 'PTHR31707:SF397', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 250720),
(406175, 'PTHR31707:SF156', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 12-RELATED', 250720),
(406176, 'PTHR31707:SF398', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406177, 'PTHR31707:SF277', NULL, NULL, NULL, NULL, 'PECTINESTERASE 3', 250720),
(406178, 'PTHR31707:SF391', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 250720),
(406179, 'PTHR31707:SF392', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406180, 'PTHR31707:SF271', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 51-RELATED', 250720),
(406181, 'PTHR31707:SF272', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 24-RELATED', 250720),
(406182, 'PTHR31707:SF393', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406183, 'PTHR31707:SF151', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 20-RELATED', 250720),
(406184, 'PTHR31707:SF394', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406185, 'PTHR31707:SF152', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 6-RELATED', 250720),
(406186, 'PTHR31707:SF315', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406187, 'PTHR31707:SF399', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406188, 'PTHR31707:SF278', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 44-RELATED', 250720),
(406189, 'PTHR31707:SF157', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406190, 'PTHR31707:SF311', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406191, 'PTHR31707:SF312', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(406192, 'PTHR31707:SF313', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406193, 'PTHR31707:SF362', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406194, 'PTHR31707:SF241', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406195, 'PTHR31707:SF361', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406196, 'PTHR31707:SF403', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406197, 'PTHR31707:SF249', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406198, 'PTHR31707:SF404', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR SUPERFAMILY PROTEIN', 250720),
(406199, 'PTHR31707:SF405', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406200, 'PTHR31707:SF406', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406201, 'PTHR31707:SF367', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR SUPERFAMILY PROTEIN', 250720),
(406202, 'PTHR31707:SF400', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 61-RELATED', 250720),
(406203, 'PTHR31707:SF401', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406204, 'PTHR31707:SF247', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406205, 'PTHR31707:SF368', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406206, 'PTHR31707:SF248', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406207, 'PTHR31707:SF402', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406208, 'PTHR31707:SF58', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406209, 'PTHR31707:SF407', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406210, 'PTHR31707:SF408', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406211, 'PTHR31707:SF409', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406212, 'PTHR31707:SF131', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406213, 'PTHR31707:SF374', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406214, 'PTHR31707:SF255', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406215, 'PTHR31707:SF370', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406216, 'PTHR31707:SF250', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406217, 'PTHR31707:SF414', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 250720),
(406218, 'PTHR31707:SF415', NULL, NULL, NULL, NULL, 'PECTINESTERASE 4-RELATED', 250720),
(406219, 'PTHR31707:SF416', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 43-RELATED', 250720),
(406220, 'PTHR31707:SF417', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406221, 'PTHR31707:SF256', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406222, 'PTHR31707:SF410', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 250720),
(406223, 'PTHR31707:SF257', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406224, 'PTHR31707:SF411', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 64-RELATED', 250720),
(406225, 'PTHR31707:SF412', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 250720),
(406226, 'PTHR31707:SF258', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 250720),
(406227, 'PTHR31707:SF413', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406228, 'PTHR31707:SF259', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406229, 'PTHR31707:SF45', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 59-RELATED', 250720),
(406230, 'PTHR31707:SF3', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 3', 250720),
(406231, 'PTHR31707:SF180', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406232, 'PTHR31707:SF181', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406233, 'PTHR31707:SF8', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 34-RELATED', 250720),
(406234, 'PTHR31707:SF186', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 36-RELATED', 250720),
(406235, 'PTHR31707:SF187', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406236, 'PTHR31707:SF341', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406237, 'PTHR31707:SF220', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 35-RELATED', 250720);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(406238, 'PTHR31707:SF221', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 18-RELATED', 250720),
(406239, 'PTHR31707:SF188', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 7-RELATED', 250720),
(406240, 'PTHR31707:SF182', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406241, 'PTHR31707:SF184', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406242, 'PTHR31707:SF227', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406243, 'PTHR31707:SF349', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406244, 'PTHR31707:SF229', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 40-RELATED', 250720),
(406245, 'PTHR31707:SF224', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406246, 'PTHR31707:SF226', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406247, 'PTHR31707:SF191', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 45-RELATED', 250720),
(406248, 'PTHR31707:SF192', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406249, 'PTHR31707:SF351', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406250, 'PTHR31707:SF230', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406251, 'PTHR31707:SF197', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406252, 'PTHR31707:SF231', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 25-RELATED', 250720),
(406253, 'PTHR31707:SF198', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406254, 'PTHR31707:SF232', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406255, 'PTHR31707:SF193', NULL, NULL, NULL, NULL, 'PECTINESTERASE 2', 250720),
(406256, 'PTHR31707:SF359', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406257, 'PTHR31707:SF239', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 46-RELATED', 250720),
(406258, 'PTHR31707:SF234', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406259, 'PTHR31707:SF236', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406260, 'PTHR31707:SF28', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406261, 'PTHR31707:SF26', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406262, 'PTHR31707', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406263, 'PTHR31707:SF285', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406264, 'PTHR31707:SF164', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406265, 'PTHR31707:SF165', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406266, 'PTHR31707:SF287', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406267, 'PTHR31707:SF321', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406268, 'PTHR31707:SF167', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406269, 'PTHR31707:SF283', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406270, 'PTHR31707:SF163', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 23-RELATED', 250720),
(406271, 'PTHR31707:SF326', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406272, 'PTHR31707:SF205', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 22-RELATED', 250720),
(406273, 'PTHR31707:SF327', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 16-RELATED', 250720),
(406274, 'PTHR31707:SF329', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406275, 'PTHR31707:SF322', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406276, 'PTHR31707:SF289', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406277, 'PTHR31707:SF201', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406278, 'PTHR31707:SF169', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406279, 'PTHR31707:SF323', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406280, 'PTHR31707:SF324', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406281, 'PTHR31707:SF203', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR VGDH2-RELATED', 250720),
(406282, 'PTHR31707:SF325', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406283, 'PTHR31707:SF12', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406284, 'PTHR31707:SF11', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 54-RELATED', 250720);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(406285, 'PTHR31707:SF291', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406286, 'PTHR31707:SF330', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406287, 'PTHR31707:SF176', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406288, 'PTHR31707:SF331', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406289, 'PTHR31707:SF177', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406290, 'PTHR31707:SF211', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406291, 'PTHR31707:SF292', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406292, 'PTHR31707:SF171', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 13-RELATED', 250720),
(406293, 'PTHR31707:SF173', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 33-RELATED', 250720),
(406294, 'PTHR31707:SF218', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406295, 'PTHR31707:SF219', NULL, NULL, NULL, NULL, 'PECTINESTERASE 1-RELATED', 250720),
(406296, 'PTHR31707:SF212', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 41-RELATED', 250720),
(406297, 'PTHR31707:SF333', NULL, NULL, NULL, NULL, 'PECTINESTERASE', 250720),
(406298, 'PTHR31707:SF213', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 32-RELATED', 250720),
(406299, 'PTHR31707:SF335', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 250720),
(406300, 'PTHR31707:SF214', NULL, NULL, NULL, NULL, 'PECTINESTERASE/PECTINESTERASE INHIBITOR 21-RELATED', 250720),
(406301, 'PTHR31707:SF336', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 250720),
(406302, 'PTHR33648:SF42', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN-BINDING LYSM DOMAIN-CONTAINING PROTEIN', 250721),
(406303, 'PTHR33648:SF41', NULL, NULL, NULL, NULL, 'LYSM DOMAIN-CONTAINING PROTEIN', 250721),
(406304, 'PTHR33648:SF30', NULL, NULL, NULL, NULL, 'BNAA09G05880D PROTEIN', 250721),
(406305, 'PTHR33648:SF40', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN-BINDING LYSM DOMAIN PROTEIN', 250721),
(406306, 'PTHR33648:SF35', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN-BINDING LYSM DOMAIN PROTEIN', 250721),
(406307, 'PTHR33648:SF45', NULL, NULL, NULL, NULL, '', 250721),
(406308, 'PTHR33648:SF44', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 250721),
(406309, 'PTHR33648:SF33', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN-BINDING LYSM DOMAIN PROTEIN', 250721),
(406310, 'PTHR33648:SF43', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN-BINDING LYSM DOMAIN PROTEIN', 250721),
(406311, 'PTHR33648:SF32', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN-BINDING LYSM DOMAIN-CONTAINING PROTEIN-RELATED', 250721),
(406312, 'PTHR33648:SF39', NULL, NULL, NULL, NULL, 'EMBRYO SAC 1', 250721),
(406313, 'PTHR33648:SF38', NULL, NULL, NULL, NULL, 'LYSM DOMAIN-CONTAINING PROTEIN', 250721),
(406314, 'PTHR33648:SF26', NULL, NULL, NULL, NULL, 'LYSM DOMAIN CONTAINING PROTEIN', 250721),
(406315, 'PTHR33648:SF15', NULL, NULL, NULL, NULL, 'OS04G0572800 PROTEIN', 250721),
(406316, 'PTHR33648:SF37', NULL, NULL, NULL, NULL, 'BNAA02G33200D PROTEIN', 250721),
(406317, 'PTHR33648', NULL, NULL, NULL, NULL, 'EMBRYO SAC 1', 250721),
(406318, 'PTHR33648:SF25', NULL, NULL, NULL, NULL, 'LYSM DOMAIN-CONTAINING PROTEIN', 250721),
(406319, 'PTHR36569:SF5', NULL, NULL, NULL, NULL, 'CONIDIATION-SPECIFIC PROTEIN 10 (EUROFUNG)', 250722),
(406320, 'PTHR36569:SF4', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 250722),
(406321, 'PTHR36569', NULL, NULL, NULL, NULL, '', 250722),
(406322, 'PTHR46759', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 72', 250723),
(406323, 'PTHR46759:SF1', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 72', 250723),
(406324, 'PTHR20003:SF4', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN', 250724),
(406325, 'PTHR20003:SF7', NULL, NULL, NULL, NULL, '', 250724),
(406326, 'PTHR20003', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN-RELATED', 250724),
(406327, 'PTHR37709', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250725),
(406328, 'PTHR37709:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250725),
(406329, 'PTHR21096:SF5', NULL, NULL, NULL, NULL, '', 250726),
(406330, 'PTHR21096:SF4', NULL, NULL, NULL, NULL, 'BNAA04G25360D PROTEIN', 250726);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(406331, 'PTHR21096:SF3', NULL, NULL, NULL, NULL, 'FAM136A-LIKE PROTEIN (DUF842)', 250726),
(406332, 'PTHR21096', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 250726),
(406333, 'PTHR21096:SF0', NULL, NULL, NULL, NULL, 'PROTEIN FAM136A', 250726),
(406334, 'PTHR23026:SF117', NULL, NULL, NULL, NULL, 'NITROREDUCTASE-RELATED', 250727),
(406335, 'PTHR23026:SF125', NULL, NULL, NULL, NULL, 'OXYGEN-INSENSITIVE NAD(P)H NITROREDUCTASE', 250727),
(406336, 'PTHR23026:SF90', NULL, NULL, NULL, NULL, 'IODOTYROSINE DEIODINASE 1', 250727),
(406337, 'PTHR23026:SF124', NULL, NULL, NULL, NULL, 'NITROREDUCTASE FD-NR2', 250727),
(406338, 'PTHR23026:SF123', NULL, NULL, NULL, NULL, 'NAD(P)H NITROREDUCTASE RV3131-RELATED', 250727),
(406339, 'PTHR23026:SF100', NULL, NULL, NULL, NULL, 'NITROREDUCTASE', 250727),
(406340, 'PTHR23026:SF121', NULL, NULL, NULL, NULL, 'REDUCTASE-RELATED', 250727),
(406341, 'PTHR23026', NULL, NULL, NULL, NULL, 'NADPH NITROREDUCTASE', 250727),
(406342, 'PTHR35125:SF4', NULL, NULL, NULL, NULL, 'PROTEIN PATRONUS 1', 250728),
(406343, 'PTHR35125:SF3', NULL, NULL, NULL, NULL, 'BNAA01G29530D PROTEIN', 250728),
(406344, 'PTHR35125:SF2', NULL, NULL, NULL, NULL, 'NEURON NAVIGATOR 1-LIKE', 250728),
(406345, 'PTHR35125:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PATRONUS 2', 250728),
(406346, 'PTHR35125', NULL, NULL, NULL, NULL, 'NEURON NAVIGATOR 1-LIKE-RELATED', 250728),
(406347, 'PTHR12011:SF450', NULL, NULL, NULL, NULL, '', 250729),
(406348, 'PTHR12011:SF454', NULL, NULL, NULL, NULL, '', 250729),
(406349, 'PTHR12011:SF277', NULL, NULL, NULL, NULL, 'ADHESION G-PROTEIN COUPLED RECEPTOR G4', 250729),
(406350, 'PTHR12011:SF455', NULL, NULL, NULL, NULL, 'ADHESION G PROTEIN-COUPLED RECEPTOR E3', 250729),
(406351, 'PTHR12011:SF433', NULL, NULL, NULL, NULL, 'ADHESION G PROTEIN-COUPLED RECEPTOR E4P-RELATED', 250729),
(406352, 'PTHR12011:SF216', NULL, NULL, NULL, NULL, 'ADHESION G-PROTEIN COUPLED RECEPTOR D1', 250729),
(406353, 'PTHR12011:SF435', NULL, NULL, NULL, NULL, 'ADHESION G PROTEIN-COUPLED RECEPTOR G1', 250729),
(406354, 'PTHR12011:SF437', NULL, NULL, NULL, NULL, 'FI21270P1-RELATED', 250729),
(406355, 'PTHR12011:SF318', NULL, NULL, NULL, NULL, 'ADHESION G-PROTEIN COUPLED RECEPTOR G1', 250729),
(406356, 'PTHR12011:SF60', NULL, NULL, NULL, NULL, 'ADHESION G PROTEIN-COUPLED RECEPTOR L3', 250729),
(406357, 'PTHR12011:SF61', NULL, NULL, NULL, NULL, 'ADHESION G PROTEIN-COUPLED RECEPTOR L2', 250729),
(406358, 'PTHR12011:SF40', NULL, NULL, NULL, NULL, 'ADHESION G PROTEIN-COUPLED RECEPTOR B3', 250729),
(406359, 'PTHR12011:SF62', NULL, NULL, NULL, NULL, 'ADHESION G PROTEIN-COUPLED RECEPTOR L1', 250729),
(406360, 'PTHR12011:SF41', NULL, NULL, NULL, NULL, 'ADHESION G PROTEIN-COUPLED RECEPTOR B2', 250729),
(406361, 'PTHR12011:SF59', NULL, NULL, NULL, NULL, 'ADHESION G PROTEIN-COUPLED RECEPTOR L4', 250729),
(406362, 'PTHR12011:SF39', NULL, NULL, NULL, NULL, 'ADHESION G PROTEIN-COUPLED RECEPTOR B1', 250729),
(406363, 'PTHR12011:SF285', NULL, NULL, NULL, NULL, 'ADHESION G PROTEIN-COUPLED RECEPTOR G3', 250729),
(406364, 'PTHR12011:SF264', NULL, NULL, NULL, NULL, 'ADHESION G-PROTEIN COUPLED RECEPTOR G2', 250729),
(406365, 'PTHR12011:SF465', NULL, NULL, NULL, NULL, 'GPS DOMAIN-CONTAINING PROTEIN', 250729),
(406366, 'PTHR12011:SF467', NULL, NULL, NULL, NULL, 'LATROPHILIN-LIKE PROTEIN 1', 250729),
(406367, 'PTHR12011:SF466', NULL, NULL, NULL, NULL, '', 250729),
(406368, 'PTHR12011:SF348', NULL, NULL, NULL, NULL, 'ADHESION G PROTEIN-COUPLED RECEPTOR E5', 250729),
(406369, 'PTHR12011:SF326', NULL, NULL, NULL, NULL, 'ADHESION G-PROTEIN COUPLED RECEPTOR G5', 250729),
(406370, 'PTHR12011:SF468', NULL, NULL, NULL, NULL, 'ADHESION G PROTEIN-COUPLED RECEPTOR G4A', 250729),
(406371, 'PTHR12011:SF347', NULL, NULL, NULL, NULL, 'LATROPHILIN CIRL', 250729),
(406372, 'PTHR12011:SF449', NULL, NULL, NULL, NULL, 'ADHESION G PROTEIN-COUPLED RECEPTOR E1', 250729),
(406373, 'PTHR12011:SF328', NULL, NULL, NULL, NULL, 'ADHESION G PROTEIN-COUPLED RECEPTOR E2', 250729),
(406374, 'PTHR12011:SF305', NULL, NULL, NULL, NULL, 'ADHESION G-PROTEIN COUPLED RECEPTOR G7', 250729);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(406375, 'PTHR12011:SF290', NULL, NULL, NULL, NULL, 'ADHESION G-PROTEIN COUPLED RECEPTOR G6', 250729),
(406376, 'PTHR12011', NULL, NULL, NULL, NULL, 'ADHESION G-PROTEIN COUPLED RECEPTOR', 250729),
(406377, 'PTHR12011:SF58', NULL, NULL, NULL, NULL, 'ADHESION G-PROTEIN COUPLED RECEPTOR D2', 250729),
(406378, 'PTHR22780:SF37', NULL, NULL, NULL, NULL, 'AP-2 COMPLEX SUBUNIT ALPHA', 250730),
(406379, 'PTHR22780:SF26', NULL, NULL, NULL, NULL, 'AP-1 COMPLEX SUBUNIT GAMMA-1', 250730),
(406380, 'PTHR22780:SF29', NULL, NULL, NULL, NULL, 'AP-1 COMPLEX SUBUNIT GAMMA', 250730),
(406381, 'PTHR22780', NULL, NULL, NULL, NULL, 'ADAPTIN, ALPHA/GAMMA/EPSILON', 250730),
(406382, 'PTHR22780:SF28', NULL, NULL, NULL, NULL, 'AP-1 COMPLEX SUBUNIT GAMMA-LIKE 2', 250730),
(406383, 'PTHR22780:SF41', NULL, NULL, NULL, NULL, 'AP-2 COMPLEX SUBUNIT ALPHA', 250730),
(406384, 'PTHR22780:SF30', NULL, NULL, NULL, NULL, 'AP-2 COMPLEX SUBUNIT ALPHA-2', 250730),
(406385, 'PTHR22780:SF43', NULL, NULL, NULL, NULL, 'AP-2 COMPLEX SUBUNIT ALPHA', 250730),
(406386, 'PTHR22780:SF32', NULL, NULL, NULL, NULL, 'AP-1 COMPLEX SUBUNIT GAMMA', 250730),
(406387, 'PTHR22780:SF42', NULL, NULL, NULL, NULL, 'AP-1 COMPLEX SUBUNIT GAMMA', 250730),
(406388, 'PTHR22780:SF31', NULL, NULL, NULL, NULL, 'AP-1 COMPLEX SUBUNIT GAMMA', 250730),
(406389, 'PTHR22780:SF45', NULL, NULL, NULL, NULL, 'AP-1 COMPLEX SUBUNIT GAMMA', 250730),
(406390, 'PTHR22780:SF33', NULL, NULL, NULL, NULL, 'AP-2 COMPLEX SUBUNIT ALPHA-1', 250730),
(406391, 'PTHR22780:SF44', NULL, NULL, NULL, NULL, 'ADAPTIN N TERMINAL REGION FAMILY PROTEIN', 250730),
(406392, 'PTHR22780:SF25', NULL, NULL, NULL, NULL, 'AP-1 COMPLEX SUBUNIT GAMMA', 250730),
(406393, 'PTHR22780:SF36', NULL, NULL, NULL, NULL, 'AP-1 COMPLEX SUBUNIT GAMMA-1', 250730),
(406394, 'PTHR22780:SF13', NULL, NULL, NULL, NULL, 'AP-4 COMPLEX SUBUNIT EPSILON-1', 250730),
(406395, 'PTHR22780:SF5', NULL, NULL, NULL, NULL, 'AP-1 COMPLEX SUBUNIT GAMMA', 250730),
(406396, 'PTHR22780:SF4', NULL, NULL, NULL, NULL, 'AP-2 COMPLEX SUBUNIT ALPHA', 250730),
(406397, 'PTHR46522:SF3', NULL, NULL, NULL, NULL, 'INACTIVE CYTIDINE MONOPHOSPHATE-N-ACETYLNEURAMINIC ACID HYDROXYLASE', 250731),
(406398, 'PTHR46522:SF2', NULL, NULL, NULL, NULL, 'CYTIDINE MONOPHOSPHATE-N-ACETYLNEURAMINIC ACID HYDROXYLASE', 250731),
(406399, 'PTHR46522:SF1', NULL, NULL, NULL, NULL, 'CYTIDINE MONOPHOSPHATE-N-ACETYLNEURAMINIC ACID HYDROXYLASE', 250731),
(406400, 'PTHR46522', NULL, NULL, NULL, NULL, 'CYTIDINE MONOPHOSPHATE-N-ACETYLNEURAMINIC ACID HYDROXYLASE', 250731),
(406401, 'PTHR13677', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 250732),
(406402, 'PTHR13677:SF2', NULL, NULL, NULL, NULL, 'PROTEIN DENND6B', 250732),
(406403, 'PTHR13677:SF1', NULL, NULL, NULL, NULL, 'PROTEIN DENND6A', 250732),
(406404, 'PTHR13677:SF0', NULL, NULL, NULL, NULL, 'LD41638P', 250732),
(406405, 'PTHR45980:SF7', NULL, NULL, NULL, NULL, 'PROTEASE DO-LIKE 11, MITOCHONDRIAL-RELATED', 250733),
(406406, 'PTHR45980:SF9', NULL, NULL, NULL, NULL, 'PROTEASE DO-LIKE 10, MITOCHONDRIAL-RELATED', 250733),
(406407, 'PTHR45980:SF6', NULL, NULL, NULL, NULL, 'PROTEASE DO-LIKE 2, CHLOROPLASTIC', 250733),
(406408, 'PTHR45980:SF19', NULL, NULL, NULL, NULL, 'PDZ_3 DOMAIN-CONTAINING PROTEIN', 250733),
(406409, 'PTHR45980:SF18', NULL, NULL, NULL, NULL, 'PROTEASE DO-LIKE 9', 250733),
(406410, 'PTHR45980:SF17', NULL, NULL, NULL, NULL, 'PDZ_3 DOMAIN-CONTAINING PROTEIN', 250733),
(406411, 'PTHR45980:SF16', NULL, NULL, NULL, NULL, 'PDZ_3 DOMAIN-CONTAINING PROTEIN', 250733),
(406412, 'PTHR45980', NULL, NULL, NULL, NULL, '', 250733),
(406413, 'PTHR45980:SF11', NULL, NULL, NULL, NULL, 'HRTA/DEGP PROTEASE', 250733),
(406414, 'PTHR45980:SF10', NULL, NULL, NULL, NULL, 'PROTEASE DO-LIKE 3, MITOCHONDRIAL-RELATED', 250733),
(406415, 'PTHR45980:SF21', NULL, NULL, NULL, NULL, 'PROTEASE DO-LIKE 2, CHLOROPLASTIC ISOFORM X1', 250733),
(406416, 'PTHR45980:SF20', NULL, NULL, NULL, NULL, 'OS06G0234100 PROTEIN', 250733),
(406417, 'PTHR45980:SF14', NULL, NULL, NULL, NULL, 'DEGP PROTEASE 9-RELATED', 250733),
(406418, 'PTHR46789', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN R1', 250734); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(406419, 'PTHR46789:SF2', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN R2', 250734),
(406420, 'PTHR46789:SF1', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN R1', 250734),
(406421, 'PTHR46811', NULL, NULL, NULL, NULL, 'COILED-COIL-HELIX-COILED-COIL-HELIX DOMAIN-CONTAINING PROTEIN 7', 250735),
(406422, 'PTHR46811:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL-HELIX-COILED-COIL-HELIX DOMAIN-CONTAINING PROTEIN 7', 250735),
(406423, 'PTHR12019:SF24', NULL, NULL, NULL, NULL, 'LAMINA-ASSOCIATED POLYPEPTIDE 2, ISOFORM ALPHA', 250736),
(406424, 'PTHR12019:SF5', NULL, NULL, NULL, NULL, 'EMERIN (EMERY-DREIFUSS MUSCULAR DYSTROPHY)-RELATED', 250736),
(406425, 'PTHR12019:SF13', NULL, NULL, NULL, NULL, 'THYMOPOIETIN B', 250736),
(406426, 'PTHR12019:SF12', NULL, NULL, NULL, NULL, 'LEM DOMAIN-CONTAINING PROTEIN 1', 250736),
(406427, 'PTHR12019:SF23', NULL, NULL, NULL, NULL, 'LAMINA-ASSOCIATED POLYPEPTIDE 2, ISOFORM BETA', 250736),
(406428, 'PTHR12019:SF22', NULL, NULL, NULL, NULL, 'ZGC:92287', 250736),
(406429, 'PTHR12019:SF21', NULL, NULL, NULL, NULL, 'THYMOPOIETIN A', 250736),
(406430, 'PTHR12019', NULL, NULL, NULL, NULL, 'LAMINA-ASSOCIATED POLYPEPTIDE  THYMOPOIETIN', 250736),
(406431, 'PTHR12019:SF9', NULL, NULL, NULL, NULL, 'EMERIN HOMOLOG 1', 250736),
(406432, 'PTHR46369:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CELLULOSE SYNTHASE INTERACTIVE 2', 250737),
(406433, 'PTHR46369:SF3', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE-INTERACTIVE PROTEIN', 250737),
(406434, 'PTHR46369:SF5', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 250737),
(406435, 'PTHR46369:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CELLULOSE SYNTHASE INTERACTIVE 1', 250737),
(406436, 'PTHR46369:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CELLULOSE SYNTHASE INTERACTIVE 3', 250737),
(406437, 'PTHR46369:SF8', NULL, NULL, NULL, NULL, 'ARMADILLO/BETA-CATENIN-LIKE REPEAT PROTEIN-RELATED', 250737),
(406438, 'PTHR46369:SF9', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 250737),
(406439, 'PTHR46369', NULL, NULL, NULL, NULL, 'PROTEIN CELLULOSE SYNTHASE INTERACTIVE 1', 250737),
(406440, 'PTHR38097:SF1', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN H-NS', 250738),
(406441, 'PTHR38097', NULL, NULL, NULL, NULL, '', 250738),
(406442, 'PTHR38097:SF2', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN STPA', 250738),
(406443, 'PTHR24320:SF242', NULL, NULL, NULL, NULL, '', 250739),
(406444, 'PTHR24320:SF200', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE SDR FAMILY MEMBER FEY', 250739),
(406445, 'PTHR24320:SF202', NULL, NULL, NULL, NULL, 'OS10G0548000 PROTEIN', 250739),
(406446, 'PTHR24320:SF209', NULL, NULL, NULL, NULL, 'RETINOL DEHYDROGENASE 12-LIKE', 250739),
(406447, 'PTHR24320:SF272', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 250739),
(406448, 'PTHR24320:SF194', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD PROTEIN', 250739),
(406449, 'PTHR24320:SF271', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE TIC 32, CHLOROPLASTIC-LIKE', 250739),
(406450, 'PTHR24320:SF274', NULL, NULL, NULL, NULL, 'CHAIN DEHYDROGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G00440)-RELATED', 250739),
(406451, 'PTHR24320:SF230', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN-RELATED', 250739),
(406452, 'PTHR24320:SF273', NULL, NULL, NULL, NULL, 'BNAANNG39870D PROTEIN', 250739),
(406453, 'PTHR24320:SF152', NULL, NULL, NULL, NULL, '', 250739),
(406454, 'PTHR24320:SF232', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE', 250739),
(406455, 'PTHR24320:SF276', NULL, NULL, NULL, NULL, '', 250739),
(406456, 'PTHR24320:SF199', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_2G15915)', 250739),
(406457, 'PTHR24320:SF154', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE, SHORT-CHAIN DEHYDROGENASE/REDUCTASE FAMILY (AFU_ORTHOLOGUE AFUA_2G04560)', 250739),
(406458, 'PTHR24320:SF198', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 250739),
(406459, 'PTHR24320:SF275', NULL, NULL, NULL, NULL, 'RETINOL DEHYDROGENASE 12', 250739),
(406460, 'PTHR24320:SF278', NULL, NULL, NULL, NULL, 'BNAA02G10470D PROTEIN', 250739);
INSERT INTO "PUBLIC"."MODEL" VALUES
(406461, 'PTHR24320:SF156', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN 3-OXOACYL-COA REDUCTASE-RELATED', 250739),
(406462, 'PTHR24320:SF277', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE TIC 32, CHLOROPLASTIC-LIKE', 250739),
(406463, 'PTHR24320:SF236', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/REDUCTASE PKFC', 250739),
(406464, 'PTHR24320:SF279', NULL, NULL, NULL, NULL, 'WW DOMAIN-CONTAINING OXIDOREDUCTASE-LIKE PROTEIN', 250739),
(406465, 'PTHR24320:SF235', NULL, NULL, NULL, NULL, 'BNAA03G48800D PROTEIN', 250739),
(406466, 'PTHR24320:SF114', NULL, NULL, NULL, NULL, 'OS03G0115700 PROTEIN', 250739),
(406467, 'PTHR24320:SF238', NULL, NULL, NULL, NULL, 'GLUCOSE/RIBITOL DEHYDROGENASE-RELATED', 250739),
(406468, 'PTHR24320:SF237', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PYRUVATE CARRIER', 250739),
(406469, 'PTHR24320', NULL, NULL, NULL, NULL, 'RETINOL DEHYDROGENASE', 250739),
(406470, 'PTHR24320:SF79', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE-RELATED', 250739),
(406471, 'PTHR24320:SF33', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE BLI-4, MITOCHONDRIAL-RELATED', 250739),
(406472, 'PTHR24320:SF280', NULL, NULL, NULL, NULL, '', 250739),
(406473, 'PTHR24320:SF261', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE TIC 32, CHLOROPLASTIC-LIKE', 250739),
(406474, 'PTHR24320:SF260', NULL, NULL, NULL, NULL, 'OS11G0181800 PROTEIN', 250739),
(406475, 'PTHR24320:SF263', NULL, NULL, NULL, NULL, 'GLUCOSE/RIBITOL DEHYDROGENASE-RELATED', 250739),
(406476, 'PTHR24320:SF185', NULL, NULL, NULL, NULL, 'BNACNNG10380D PROTEIN', 250739),
(406477, 'PTHR24320:SF262', NULL, NULL, NULL, NULL, 'DEHYDROGENASE', 250739),
(406478, 'PTHR24320:SF265', NULL, NULL, NULL, NULL, 'LP06328P-RELATED', 250739),
(406479, 'PTHR24320:SF264', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE SDR FAMILY MEMBER ON CHROMOSOME X', 250739),
(406480, 'PTHR24320:SF220', NULL, NULL, NULL, NULL, 'BNAC03G71290D PROTEIN', 250739),
(406481, 'PTHR24320:SF187', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE-RELATED', 250739),
(406482, 'PTHR24320:SF143', NULL, NULL, NULL, NULL, '', 250739),
(406483, 'PTHR24320:SF267', NULL, NULL, NULL, NULL, 'DEHYDROGENASES, SHORT CHAIN', 250739),
(406484, 'PTHR24320:SF222', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE', 250739),
(406485, 'PTHR24320:SF266', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN ISOFORM 1', 250739),
(406486, 'PTHR24320:SF189', NULL, NULL, NULL, NULL, 'RETINOL DEHYDROGENASE 14', 250739),
(406487, 'PTHR24320:SF148', NULL, NULL, NULL, NULL, 'RETINOL DEHYDROGENASE 12-RELATED', 250739),
(406488, 'PTHR24320:SF269', NULL, NULL, NULL, NULL, 'WW DOMAIN-CONTAINING OXIDOREDUCTASE', 250739),
(406489, 'PTHR24320:SF268', NULL, NULL, NULL, NULL, 'DEHYDROGENASES, SHORT CHAIN', 250739),
(406490, 'PTHR24320:SF227', NULL, NULL, NULL, NULL, 'CARBONYL REDUCTASE, ISOFORM A', 250739),
(406491, 'PTHR24320:SF226', NULL, NULL, NULL, NULL, 'ZGC:64106', 250739),
(406492, 'PTHR24320:SF108', NULL, NULL, NULL, NULL, 'RETINOL DEHYDROGENASE 11', 250739),
(406493, 'PTHR24320:SF229', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN-RELATED', 250739),
(406494, 'PTHR24320:SF228', NULL, NULL, NULL, NULL, 'BNAANNG32000D PROTEIN', 250739),
(406495, 'PTHR24320:SF270', NULL, NULL, NULL, NULL, 'OS06G0129100 PROTEIN', 250739),
(406496, 'PTHR24320:SF250', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN-RELATED', 250739),
(406497, 'PTHR24320:SF252', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE FAMILY PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G08550)-RELATED', 250739),
(406498, 'PTHR24320:SF251', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 250739),
(406499, 'PTHR24320:SF210', NULL, NULL, NULL, NULL, 'BNAC09G12090D PROTEIN', 250739),
(406500, 'PTHR24320:SF253', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 250739),
(406501, 'PTHR24320:SF176', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE TIC 32, CHLOROPLASTIC-LIKE', 250739),
(406502, 'PTHR24320:SF179', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD PROTEIN', 250739);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(406503, 'PTHR24320:SF212', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE TIC 32 A, CHLOROPLASTIC', 250739),
(406504, 'PTHR24320:SF256', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 250739),
(406505, 'PTHR24320:SF211', NULL, NULL, NULL, NULL, 'OS04G0291100 PROTEIN', 250739),
(406506, 'PTHR24320:SF258', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE TIC 32 CHLOROPLASTIC', 250739),
(406507, 'PTHR24320:SF214', NULL, NULL, NULL, NULL, 'GLUCOSE/RIBITOL DEHYDROGENASE-RELATED', 250739),
(406508, 'PTHR24320:SF213', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 250739),
(406509, 'PTHR24320:SF218', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE-RELATED', 250739),
(406510, 'PTHR24320:SF219', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/REDUCTASE SDR-RELATED', 250739),
(406511, 'PTHR24320:SF182', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', 250739),
(406512, 'PTHR24320:SF95', NULL, NULL, NULL, NULL, 'PROTEIN CBG13117', 250739),
(406513, 'PTHR48052:SF69', NULL, NULL, NULL, NULL, 'OS06G0186300 PROTEIN', 250740),
(406514, 'PTHR48052:SF47', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE FAMILY PROTEIN-RELATED', 250740),
(406515, 'PTHR48052:SF68', NULL, NULL, NULL, NULL, 'RECEPTOR LIKE PROTEIN 21-RELATED', 250740),
(406516, 'PTHR48052:SF24', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE TDR', 250740),
(406517, 'PTHR48052:SF27', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE', 250740),
(406518, 'PTHR48052:SF65', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE IRK-RELATED', 250740),
(406519, 'PTHR48052:SF42', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250740),
(406520, 'PTHR48052:SF64', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250740),
(406521, 'PTHR48052:SF23', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 250740),
(406522, 'PTHR48052:SF67', NULL, NULL, NULL, NULL, 'SYSTEMIN RECEPTOR SR160-LIKE', 250740),
(406523, 'PTHR48052:SF22', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN KINASE CLAVATA1', 250740),
(406524, 'PTHR48052:SF66', NULL, NULL, NULL, NULL, 'OS02G0610000 PROTEIN', 250740),
(406525, 'PTHR48052:SF1', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250740),
(406526, 'PTHR48052:SF29', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250740),
(406527, 'PTHR48052:SF28', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE PXL1', 250740),
(406528, 'PTHR48052', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', 250740),
(406529, 'PTHR48052:SF61', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 250740),
(406530, 'PTHR48052:SF60', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250740),
(406531, 'PTHR48052:SF41', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE 7', 250740),
(406532, 'PTHR48052:SF63', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250740),
(406533, 'PTHR48052:SF40', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250740),
(406534, 'PTHR48052:SF62', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE BRI1-LIKE 2', 250740),
(406535, 'PTHR48052:SF58', NULL, NULL, NULL, NULL, 'MDIS1-INTERACTING RECEPTOR LIKE KINASE 2-LIKE', 250740),
(406536, 'PTHR48052:SF36', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE FAMILY PROTEIN-RELATED', 250740),
(406537, 'PTHR48052:SF35', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250740),
(406538, 'PTHR48052:SF38', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250740),
(406539, 'PTHR48052:SF16', NULL, NULL, NULL, NULL, 'MDIS1-INTERACTING RECEPTOR LIKE KINASE 1', 250740),
(406540, 'PTHR48052:SF15', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250740),
(406541, 'PTHR48052:SF59', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE FLS2', 250740);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(406542, 'PTHR48052:SF32', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN, PLANT-TYPE-RELATED', 250740),
(406543, 'PTHR48052:SF76', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250740),
(406544, 'PTHR48052:SF75', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE FLS2', 250740),
(406545, 'PTHR48052:SF56', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250740),
(406546, 'PTHR48052:SF12', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 250740),
(406547, 'PTHR48052:SF33', NULL, NULL, NULL, NULL, 'OS01G0623000 PROTEIN', 250740),
(406548, 'PTHR48052:SF39', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE BAM3', 250740),
(406549, 'PTHR48052:SF8', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE BRI1-LIKE 3', 250740),
(406550, 'PTHR48052:SF2', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE-RELATED', 250740),
(406551, 'PTHR48052:SF5', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 250740),
(406552, 'PTHR48052:SF72', NULL, NULL, NULL, NULL, 'OS12G0273900 PROTEIN', 250740),
(406553, 'PTHR48052:SF50', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE FAMILY PROTEIN', 250740),
(406554, 'PTHR48052:SF71', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250740),
(406555, 'PTHR48052:SF74', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 250740),
(406556, 'PTHR48052:SF52', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250740),
(406557, 'PTHR48052:SF30', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250740),
(406558, 'PTHR48052:SF73', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE HSL1 ISOFORM X1', 250740),
(406559, 'PTHR48052:SF70', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINE RECEPTOR 1-LIKE', 250740),
(406560, 'PTHR36066:SF20', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SAC51-LIKE', 250741),
(406561, 'PTHR36066:SF9', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH143', 250741),
(406562, 'PTHR36066:SF10', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH145-LIKE ISOFORM X1', 250741),
(406563, 'PTHR36066:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SAC51', 250741),
(406564, 'PTHR36066:SF11', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH144', 250741),
(406565, 'PTHR36066:SF6', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 250741),
(406566, 'PTHR36066', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH145', 250741),
(406567, 'PTHR36066:SF18', NULL, NULL, NULL, NULL, 'HELIX-LOOP-HELIX DNA-BINDING DOMAIN CONTAINING PROTEIN, EXPRESSED', 250741),
(406568, 'PTHR36066:SF19', NULL, NULL, NULL, NULL, 'OS01G0626900 PROTEIN', 250741),
(406569, 'PTHR36066:SF13', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 250741),
(406570, 'PTHR36066:SF15', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 250741),
(406571, 'PTHR36066:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH145', 250741),
(406572, 'PTHR39964:SF2', NULL, NULL, NULL, NULL, 'UPF0292 PROTEIN TK1411', 250742),
(406573, 'PTHR39964', NULL, NULL, NULL, NULL, 'UPF0292 PROTEIN TK1411', 250742),
(406574, 'PTHR36945:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN C02F5.12-RELATED', 250743),
(406575, 'PTHR36945:SF2', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', 250743),
(406576, 'PTHR36945', NULL, NULL, NULL, NULL, 'HIGH INCIDENCE OF MALES (INCREASED X CHROMOSOME LOSS)-RELATED-RELATED', 250743),
(406577, 'PTHR47264:SF3', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN', 250744),
(406578, 'PTHR47264:SF2', NULL, NULL, NULL, NULL, 'PLANT SYNAPTOTAGMIN', 250744),
(406579, 'PTHR47264', NULL, NULL, NULL, NULL, 'OS01G0128800 PROTEIN', 250744),
(406580, 'PTHR13085', NULL, NULL, NULL, NULL, 'MICROSOMAL SIGNAL PEPTIDASE 25 KDA SUBUNIT', 250745),
(406581, 'PTHR13085:SF3', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE COMPLEX SUBUNIT 2', 250745),
(406582, 'PTHR13085:SF0', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE COMPLEX SUBUNIT 2', 250745);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(406583, 'PTHR13085:SF4', NULL, NULL, NULL, NULL, 'MICROSOMAL SIGNAL PEPTIDASE 25 KDA SUBUNIT', 250745),
(406584, 'PTHR46443:SF1', NULL, NULL, NULL, NULL, 'OS01G0719000 PROTEIN', 250746),
(406585, 'PTHR46443:SF7', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250746),
(406586, 'PTHR46443:SF6', NULL, NULL, NULL, NULL, 'OS07G0175300 PROTEIN', 250746),
(406587, 'PTHR46443:SF9', NULL, NULL, NULL, NULL, 'PROTEIN MARD1', 250746),
(406588, 'PTHR46443', NULL, NULL, NULL, NULL, 'FCS-LIKE ZINC FINGER 8', 250746),
(406589, 'PTHR46443:SF8', NULL, NULL, NULL, NULL, '', 250746),
(406590, 'PTHR46443:SF3', NULL, NULL, NULL, NULL, 'PROTEIN MARD1', 250746),
(406591, 'PTHR46443:SF18', NULL, NULL, NULL, NULL, 'BNAC03G42890D PROTEIN', 250746),
(406592, 'PTHR46443:SF5', NULL, NULL, NULL, NULL, 'OS01G0593200 PROTEIN', 250746),
(406593, 'PTHR46443:SF17', NULL, NULL, NULL, NULL, 'BNAA09G55700D PROTEIN', 250746),
(406594, 'PTHR46443:SF16', NULL, NULL, NULL, NULL, 'BNAA01G24630D PROTEIN', 250746),
(406595, 'PTHR46443:SF15', NULL, NULL, NULL, NULL, 'FLZ-TYPE DOMAIN-CONTAINING PROTEIN', 250746),
(406596, 'PTHR46443:SF14', NULL, NULL, NULL, NULL, 'FLZ-TYPE DOMAIN-CONTAINING PROTEIN', 250746),
(406597, 'PTHR46443:SF22', NULL, NULL, NULL, NULL, 'ZF-FLZ DOMAIN-CONTAINING PROTEIN-RELATED', 250746),
(406598, 'PTHR46443:SF21', NULL, NULL, NULL, NULL, 'FCS-LIKE ZINC FINGER 8', 250746),
(406599, 'PTHR21579', NULL, NULL, NULL, NULL, 'PROTEIN TINCAR', 250747),
(406600, 'PTHR21579:SF20', NULL, NULL, NULL, NULL, 'PROTEIN TINCAR', 250747),
(406601, 'PTHR21579:SF16', NULL, NULL, NULL, NULL, 'MUCIN RELATED 82C', 250747),
(406602, 'PTHR30173:SF43', NULL, NULL, NULL, NULL, 'ECF RNA POLYMERASE SIGMA FACTOR SIGI-RELATED', 250748),
(406603, 'PTHR30173:SF36', NULL, NULL, NULL, NULL, 'ECF-FAMILY RNA POLYMERASE SIGMA FACTOR-RELATED', 250748),
(406604, 'PTHR30173', NULL, NULL, NULL, NULL, 'SIGMA 19 FACTOR', 250748),
(406605, 'PTHR12493', NULL, NULL, NULL, NULL, 'CUE DOMAIN CONTAINING 2', 250749),
(406606, 'PTHR12493:SF0', NULL, NULL, NULL, NULL, 'CUE DOMAIN-CONTAINING PROTEIN 2', 250749),
(406607, 'PTHR47396:SF1', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT HELICASE IRC3-RELATED', 250750),
(406608, 'PTHR47396', NULL, NULL, NULL, NULL, 'TYPE I RESTRICTION ENZYME ECOKI R PROTEIN', 250750),
(406609, 'PTHR47396:SF2', NULL, NULL, NULL, NULL, '', 250750),
(406610, 'PTHR33867', NULL, NULL, NULL, NULL, 'RIBOSOME MATURATION FACTOR RIMP', 250751),
(406611, 'PTHR33867:SF1', NULL, NULL, NULL, NULL, 'RIBOSOME MATURATION FACTOR RIMP', 250751),
(406612, 'PTHR24418:SF437', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', 250752),
(406613, 'PTHR24418:SF438', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE ABL1', 250752),
(406614, 'PTHR24418:SF435', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', 250752),
(406615, 'PTHR24418:SF433', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', 250752),
(406616, 'PTHR24418:SF398', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', 250752),
(406617, 'PTHR24418:SF399', NULL, NULL, NULL, NULL, 'MEGAKARYOCYTE-ASSOCIATED TYROSINE-PROTEIN KINASE', 250752),
(406618, 'PTHR24418:SF432', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE FYNA', 250752),
(406619, 'PTHR24418:SF439', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', 250752),
(406620, 'PTHR24418:SF191', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', 250752),
(406621, 'PTHR24418:SF231', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE SYK', 250752),
(406622, 'PTHR24418:SF199', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', 250752),
(406623, 'PTHR24418:SF394', NULL, NULL, NULL, NULL, 'PROTEIN NIPI-4', 250752),
(406624, 'PTHR24418:SF23', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE SRMS', 250752),
(406625, 'PTHR24418:SF197', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE FES/FPS', 250752),
(406626, 'PTHR24418:SF230', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', 250752),
(406627, 'PTHR24418:SF272', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', 250752),
(406628, 'PTHR24418:SF390', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', 250752),
(406629, 'PTHR24418:SF228', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', 250752);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(406630, 'PTHR24418:SF424', NULL, NULL, NULL, NULL, 'SI:CH211-167J9.5', 250752),
(406631, 'PTHR24418:SF227', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE FER', 250752),
(406632, 'PTHR24418:SF425', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', 250752),
(406633, 'PTHR24418:SF61', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE ITK/TSK', 250752),
(406634, 'PTHR24418:SF224', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE FGR', 250752),
(406635, 'PTHR24418:SF389', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', 250752),
(406636, 'PTHR24418:SF269', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE STYK1', 250752),
(406637, 'PTHR24418:SF222', NULL, NULL, NULL, NULL, 'SPERMATOCYTE PROTEIN SPE-8', 250752),
(406638, 'PTHR24418:SF421', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', 250752),
(406639, 'PTHR24418:SF429', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', 250752),
(406640, 'PTHR24418:SF385', NULL, NULL, NULL, NULL, 'NON-SPECIFIC PROTEIN-TYROSINE KINASE', 250752),
(406641, 'PTHR24418:SF221', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', 250752),
(406642, 'PTHR24418:SF53', NULL, NULL, NULL, NULL, 'PROTO-ONCOGENE TYROSINE-PROTEIN KINASE SRC', 250752),
(406643, 'PTHR24418:SF265', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE KINASE 6', 250752),
(406644, 'PTHR24418:SF384', NULL, NULL, NULL, NULL, 'NON-SPECIFIC PROTEIN-TYROSINE KINASE', 250752),
(406645, 'PTHR24418:SF263', NULL, NULL, NULL, NULL, 'NON-RECEPTOR TYROSINE-PROTEIN KINASE TNK1', 250752),
(406646, 'PTHR24418:SF181', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE BLK', 250752),
(406647, 'PTHR24418:SF90', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE YES', 250752),
(406648, 'PTHR24418:SF92', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE BTK', 250752),
(406649, 'PTHR24418:SF91', NULL, NULL, NULL, NULL, 'CYTOPLASMIC TYROSINE-PROTEIN KINASE BMX', 250752),
(406650, 'PTHR24418:SF94', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE KINASE 2-BETA', 250752),
(406651, 'PTHR24418:SF455', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', 250752),
(406652, 'PTHR24418:SF379', NULL, NULL, NULL, NULL, 'ACTIVATED CDC42 KINASE 1', 250752),
(406653, 'PTHR24418:SF456', NULL, NULL, NULL, NULL, '', 250752),
(406654, 'PTHR24418:SF453', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', 250752),
(406655, 'PTHR24418', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', 250752),
(406656, 'PTHR24418:SF454', NULL, NULL, NULL, NULL, 'SERINE/THREONINE/TYROSINE KINASE 1B', 250752),
(406657, 'PTHR24418:SF219', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE TEC', 250752),
(406658, 'PTHR24418:SF418', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE FER', 250752),
(406659, 'PTHR24418:SF87', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE ABL2', 250752),
(406660, 'PTHR24418:SF451', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250752),
(406661, 'PTHR24418:SF374', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 250752),
(406662, 'PTHR24418:SF452', NULL, NULL, NULL, NULL, 'AFFINITY NERVE GROWTH FACTOR RECEPTOR, PUTATIVE-RELATED', 250752),
(406663, 'PTHR24418:SF42', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE LYN', 250752),
(406664, 'PTHR24418:SF372', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE SHARK', 250752),
(406665, 'PTHR24418:SF251', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', 250752),
(406666, 'PTHR24418:SF44', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE FYN', 250752),
(406667, 'PTHR24418:SF373', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE FRK', 250752),
(406668, 'PTHR24418:SF450', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE CSK-1', 250752),
(406669, 'PTHR24418:SF370', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', 250752),
(406670, 'PTHR24418:SF294', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE BTK29A', 250752),
(406671, 'PTHR24418:SF448', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE WSCK-RELATED', 250752),
(406672, 'PTHR24418:SF449', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', 250752),
(406673, 'PTHR24418:SF369', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE ZAP-70', 250752);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(406674, 'PTHR24418:SF446', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', 250752),
(406675, 'PTHR24418:SF403', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', 250752),
(406676, 'PTHR24418:SF205', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', 250752),
(406677, 'PTHR24418:SF447', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE SRC64B', 250752),
(406678, 'PTHR24418:SF367', NULL, NULL, NULL, NULL, 'INACTIVE TYROSINE-PROTEIN KINASE KIN-32', 250752),
(406679, 'PTHR24418:SF444', NULL, NULL, NULL, NULL, 'ACTIVATED CDC42 KINASE-LIKE', 250752),
(406680, 'PTHR24418:SF247', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE TXK', 250752),
(406681, 'PTHR24418:SF445', NULL, NULL, NULL, NULL, 'TXK TYROSINE KINASE', 250752),
(406682, 'PTHR24418:SF442', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', 250752),
(406683, 'PTHR24418:SF443', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE FYN', 250752),
(406684, 'PTHR24418:SF245', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE HCK', 250752),
(406685, 'PTHR24418:SF289', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', 250752),
(406686, 'PTHR24418:SF407', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE CSK', 250752),
(406687, 'PTHR24418:SF39', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE LCK', 250752),
(406688, 'PTHR24418:SF440', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', 250752),
(406689, 'PTHR24418:SF441', NULL, NULL, NULL, NULL, 'HOPSCOTCH', 250752),
(406690, 'PTHR24418:SF78', NULL, NULL, NULL, NULL, 'FOCAL ADHESION KINASE 1', 250752),
(406691, 'PTHR24418:SF162', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE ABL', 250752),
(406692, 'PTHR11783:SF312', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406693, 'PTHR11783:SF279', NULL, NULL, NULL, NULL, 'MIP25022P1', 250753),
(406694, 'PTHR11783:SF44', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE 1C4', 250753),
(406695, 'PTHR11783:SF278', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406696, 'PTHR11783:SF311', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406697, 'PTHR11783:SF43', NULL, NULL, NULL, NULL, 'AMINE SULFOTRANSFERASE-RELATED', 250753),
(406698, 'PTHR11783:SF156', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE 1A1', 250753),
(406699, 'PTHR11783:SF310', NULL, NULL, NULL, NULL, 'CYTOSOLIC SULFOTRANSFERASE 1-RELATED', 250753),
(406700, 'PTHR11783:SF277', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406701, 'PTHR11783:SF316', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406702, 'PTHR11783:SF48', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE 1 FAMILY MEMBER D1', 250753),
(406703, 'PTHR11783:SF315', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406704, 'PTHR11783:SF314', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406705, 'PTHR11783:SF313', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406706, 'PTHR11783:SF271', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406707, 'PTHR11783:SF270', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406708, 'PTHR11783:SF275', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406709, 'PTHR11783:SF274', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE 4, ISOFORM A', 250753),
(406710, 'PTHR11783:SF272', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406711, 'PTHR11783:SF319', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406712, 'PTHR11783:SF318', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406713, 'PTHR11783:SF317', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406714, 'PTHR11783:SF55', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE 6B1', 250753),
(406715, 'PTHR11783:SF267', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406716, 'PTHR11783:SF266', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406717, 'PTHR11783:SF265', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406718, 'PTHR11783:SF305', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406719, 'PTHR11783:SF304', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406720, 'PTHR11783:SF303', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406721, 'PTHR11783:SF269', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(406722, 'PTHR11783:SF260', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406723, 'PTHR11783:SF264', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406724, 'PTHR11783:SF53', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE 1E1', 250753),
(406725, 'PTHR11783:SF262', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406726, 'PTHR11783:SF309', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406727, 'PTHR11783:SF308', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE 1A3-RELATED', 250753),
(406728, 'PTHR11783:SF307', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406729, 'PTHR11783:SF306', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406730, 'PTHR11783:SF256', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406731, 'PTHR11783:SF255', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406732, 'PTHR11783:SF258', NULL, NULL, NULL, NULL, 'CYTOSOLIC SULFOTRANSFERASE 1', 250753),
(406733, 'PTHR11783:SF253', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406734, 'PTHR11783:SF252', NULL, NULL, NULL, NULL, 'CYTOSOLIC SULFOTRANSFERASE 17', 250753),
(406735, 'PTHR11783:SF250', NULL, NULL, NULL, NULL, 'CYTOSOLIC SULFOTRANSFERASE 11', 250753),
(406736, 'PTHR11783:SF246', NULL, NULL, NULL, NULL, 'CYTOSOLIC SULFOTRANSFERASE 16', 250753),
(406737, 'PTHR11783:SF243', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406738, 'PTHR11783:SF249', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406739, 'PTHR11783:SF248', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406740, 'PTHR11783:SF247', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406741, 'PTHR11783:SF38', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406742, 'PTHR11783:SF242', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406743, 'PTHR11783:SF241', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406744, 'PTHR11783:SF240', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406745, 'PTHR11783:SF233', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406746, 'PTHR11783:SF238', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406747, 'PTHR11783:SF237', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406748, 'PTHR11783:SF194', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406749, 'PTHR11783:SF193', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406750, 'PTHR11783:SF192', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406751, 'PTHR11783:SF198', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406752, 'PTHR11783:SF197', NULL, NULL, NULL, NULL, 'CYTOSOLIC SULFOTRANSFERASE 10-RELATED', 250753),
(406753, 'PTHR11783:SF230', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406754, 'PTHR11783:SF222', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406755, 'PTHR11783:SF189', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406756, 'PTHR11783:SF100', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE SSU-1', 250753),
(406757, 'PTHR11783:SF228', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406758, 'PTHR11783:SF107', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406759, 'PTHR11783:SF14', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE FAMILY CYTOSOLIC 1B MEMBER 1', 250753),
(406760, 'PTHR11783:SF105', NULL, NULL, NULL, NULL, 'CYTOSOLIC SULFOTRANSFERASE 14-RELATED', 250753),
(406761, 'PTHR11783:SF225', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406762, 'PTHR11783:SF182', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406763, 'PTHR11783:SF180', NULL, NULL, NULL, NULL, 'GH11818P-RELATED', 250753),
(406764, 'PTHR11783:SF187', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406765, 'PTHR11783:SF185', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406766, 'PTHR11783:SF190', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406767, 'PTHR11783', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE  SULT', 250753),
(406768, 'PTHR11783:SF229', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406769, 'PTHR11783:SF213', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406770, 'PTHR11783:SF212', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(406771, 'PTHR11783:SF179', NULL, NULL, NULL, NULL, 'CYTOSOLIC SULFOTRANSFERASE 4-RELATED', 250753),
(406772, 'PTHR11783:SF178', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406773, 'PTHR11783:SF298', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406774, 'PTHR11783:SF172', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406775, 'PTHR11783:SF293', NULL, NULL, NULL, NULL, 'CYTOSOLIC SULFOTRANSFERASE 7', 250753),
(406776, 'PTHR11783:SF170', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406777, 'PTHR11783:SF64', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406778, 'PTHR11783:SF295', NULL, NULL, NULL, NULL, 'CYTOSOLIC SULFOTRANSFERASE 12-RELATED', 250753),
(406779, 'PTHR11783:SF294', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406780, 'PTHR11783:SF173', NULL, NULL, NULL, NULL, 'CYTOSOLIC SULFOTRANSFERASE 3', 250753),
(406781, 'PTHR11783:SF219', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406782, 'PTHR11783:SF218', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406783, 'PTHR11783:SF202', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406784, 'PTHR11783:SF323', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406785, 'PTHR11783:SF77', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE 1C3', 250753),
(406786, 'PTHR11783:SF322', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406787, 'PTHR11783:SF201', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406788, 'PTHR11783:SF288', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406789, 'PTHR11783:SF79', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406790, 'PTHR11783:SF321', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE 4A1', 250753),
(406791, 'PTHR11783:SF320', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406792, 'PTHR11783:SF166', NULL, NULL, NULL, NULL, 'CYTOSOLIC SULFOTRANSFERASE 18', 250753),
(406793, 'PTHR11783:SF204', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406794, 'PTHR11783:SF203', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406795, 'PTHR11783:SF324', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE 1A2', 250753),
(406796, 'PTHR11783:SF9', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE 2B1', 250753),
(406797, 'PTHR11783:SF282', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406798, 'PTHR11783:SF281', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406799, 'PTHR11783:SF280', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406800, 'PTHR11783:SF165', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406801, 'PTHR11783:SF73', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE 1C2', 250753),
(406802, 'PTHR11783:SF283', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406803, 'PTHR11783:SF8', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE 2A1', 250753),
(406804, 'PTHR11783:SF209', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406805, 'PTHR11783:SF208', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406806, 'PTHR11783:SF207', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 250753),
(406807, 'PTHR47043', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE TRANSFERASE SUBUNIT ALG13', 250754),
(406808, 'PTHR47043:SF2', NULL, NULL, NULL, NULL, 'GLYCO_TRAN_28_C DOMAIN-CONTAINING PROTEIN', 250754),
(406809, 'PTHR47043:SF1', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE TRANSFERASE SUBUNIT ALG13', 250754),
(406810, 'PTHR39651', NULL, NULL, NULL, NULL, 'HOLLIDAY JUNCTION RESOLVASE HJC', 250755),
(406811, 'PTHR39651:SF1', NULL, NULL, NULL, NULL, 'HOLLIDAY JUNCTION RESOLVASE HJC', 250755),
(406812, 'PTHR47422', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK N-TERMINAL DOMAIN-CONTAINING PROTEIN', 250756),
(406813, 'PTHR47422:SF1', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK N-TERMINAL DOMAIN-CONTAINING PROTEIN', 250756),
(406814, 'PTHR11246:SF24', NULL, NULL, NULL, NULL, 'BNACNNG15970D PROTEIN', 250757),
(406815, 'PTHR11246:SF23', NULL, NULL, NULL, NULL, 'BNAC06G13700D PROTEIN', 250757),
(406816, 'PTHR11246:SF5', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR SYF1', 250757),
(406817, 'PTHR11246:SF3', NULL, NULL, NULL, NULL, 'CROOKED NECK-LIKE PROTEIN 1', 250757);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(406818, 'PTHR11246:SF25', NULL, NULL, NULL, NULL, 'BNAA02G34100D PROTEIN', 250757),
(406819, 'PTHR11246:SF28', NULL, NULL, NULL, NULL, 'CROOKED NECK PROTEIN', 250757),
(406820, 'PTHR11246:SF27', NULL, NULL, NULL, NULL, 'BNAC03G66550D PROTEIN', 250757),
(406821, 'PTHR11246:SF1', NULL, NULL, NULL, NULL, 'PRE-MRNA-PROCESSING FACTOR 6', 250757),
(406822, 'PTHR11246:SF19', NULL, NULL, NULL, NULL, 'OS06G0235800 PROTEIN', 250757),
(406823, 'PTHR11246:SF31', NULL, NULL, NULL, NULL, 'NECK PROTEIN, PUTATIVE, EXPRESSED-RELATED', 250757),
(406824, 'PTHR11246:SF20', NULL, NULL, NULL, NULL, 'TPR-CONTAINING PROTEIN DDB_G0280363', 250757),
(406825, 'PTHR11246:SF30', NULL, NULL, NULL, NULL, '', 250757),
(406826, 'PTHR11246', NULL, NULL, NULL, NULL, 'PRE-MRNA SPLICING FACTOR', 250757),
(406827, 'PTHR34188:SF11', NULL, NULL, NULL, NULL, '', 250758),
(406828, 'PTHR34188:SF22', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 250758),
(406829, 'PTHR34188:SF21', NULL, NULL, NULL, NULL, '', 250758),
(406830, 'PTHR34188:SF20', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 250758),
(406831, 'PTHR34188:SF14', NULL, NULL, NULL, NULL, '', 250758),
(406832, 'PTHR34188:SF8', NULL, NULL, NULL, NULL, 'T6A9.7 PROTEIN', 250758),
(406833, 'PTHR34188:SF3', NULL, NULL, NULL, NULL, 'OS05G0131900 PROTEIN', 250758),
(406834, 'PTHR34188:SF5', NULL, NULL, NULL, NULL, 'OS01G0299500 PROTEIN', 250758),
(406835, 'PTHR34188:SF19', NULL, NULL, NULL, NULL, '', 250758),
(406836, 'PTHR34188', NULL, NULL, NULL, NULL, 'OS01G0299500 PROTEIN', 250758),
(406837, 'PTHR34188:SF18', NULL, NULL, NULL, NULL, '', 250758),
(406838, 'PTHR34188:SF17', NULL, NULL, NULL, NULL, 'BNAANNG29080D PROTEIN', 250758),
(406839, 'PTHR34188:SF16', NULL, NULL, NULL, NULL, '', 250758),
(406840, 'PTHR10910:SF103', NULL, NULL, NULL, NULL, 'ADENOSINE DEAMINASE DOMAIN-CONTAINING PROTEIN 1', 250759),
(406841, 'PTHR10910:SF62', NULL, NULL, NULL, NULL, 'TRNA-SPECIFIC ADENOSINE DEAMINASE TAD1', 250759),
(406842, 'PTHR10910:SF17', NULL, NULL, NULL, NULL, 'DOUBLE-STRANDED RNA-SPECIFIC EDITASE B2', 250759),
(406843, 'PTHR10910:SF106', NULL, NULL, NULL, NULL, 'ADENOSINE DEAMINASE DOMAIN-CONTAINING PROTEIN 2', 250759),
(406844, 'PTHR10910:SF107', NULL, NULL, NULL, NULL, 'DOUBLE-STRANDED RNA-SPECIFIC ADENOSINE DEAMINASE', 250759),
(406845, 'PTHR10910', NULL, NULL, NULL, NULL, 'EUKARYOTE SPECIFIC DSRNA BINDING PROTEIN', 250759),
(406846, 'PTHR10910:SF58', NULL, NULL, NULL, NULL, 'DOUBLE-STRANDED RNA-SPECIFIC EDITASE 1', 250759),
(406847, 'PTHR10910:SF140', NULL, NULL, NULL, NULL, 'AT07585P-RELATED', 250759),
(406848, 'PTHR10910:SF144', NULL, NULL, NULL, NULL, 'A TO I EDITASE DOMAIN-CONTAINING PROTEIN-RELATED', 250759),
(406849, 'PTHR47754:SF3', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN', 250760),
(406850, 'PTHR47754:SF2', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN', 250760),
(406851, 'PTHR47754:SF1', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN', 250760),
(406852, 'PTHR47754', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS X-RELATED', 250760),
(406853, 'PTHR24109', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 31', 250761),
(406854, 'PTHR24109:SF3', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 31', 250761),
(406855, 'PTHR43762:SF5', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 250762),
(406856, 'PTHR43762:SF1', NULL, NULL, NULL, NULL, 'D-ARABINONO-1,4-LACTONE OXIDASE', 250762),
(406857, 'PTHR43762', NULL, NULL, NULL, NULL, 'L-GULONOLACTONE OXIDASE', 250762),
(406858, 'PTHR43762:SF8', NULL, NULL, NULL, NULL, 'L-GULONOLACTONE OXIDASE', 250762),
(406859, 'PTHR43762:SF7', NULL, NULL, NULL, NULL, 'FAD-BINDING PCMH-TYPE DOMAIN-CONTAINING PROTEIN', 250762),
(406860, 'PTHR28532:SF2', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 250763),
(406861, 'PTHR28532:SF1', NULL, NULL, NULL, NULL, 'LTO1 MATURATION FACTOR OF ABCE1', 250763),
(406862, 'PTHR28532', NULL, NULL, NULL, NULL, 'GEO13458P1', 250763),
(406863, 'PTHR11473:SF15', NULL, NULL, NULL, NULL, 'TYROSINE 3-MONOOXYGENASE', 250764);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(406864, 'PTHR11473:SF24', NULL, NULL, NULL, NULL, 'PHENYLALANINE-4-HYDROXYLASE', 250764),
(406865, 'PTHR11473:SF23', NULL, NULL, NULL, NULL, 'TRYPTOPHAN 5-HYDROXYLASE 1', 250764),
(406866, 'PTHR11473:SF19', NULL, NULL, NULL, NULL, 'BH4_AAA_HYDROXYL_2 DOMAIN-CONTAINING PROTEIN', 250764),
(406867, 'PTHR11473:SF18', NULL, NULL, NULL, NULL, 'TYROSINE 3-MONOOXYGENASE', 250764),
(406868, 'PTHR11473:SF39', NULL, NULL, NULL, NULL, 'TYROSINE 3-HYDROXYLASE', 250764),
(406869, 'PTHR11473:SF38', NULL, NULL, NULL, NULL, 'TYROSINE HYDROXYLASE 2', 250764),
(406870, 'PTHR11473', NULL, NULL, NULL, NULL, 'AROMATIC AMINO ACID HYDROXYLASE', 250764),
(406871, 'PTHR11473:SF16', NULL, NULL, NULL, NULL, 'TRYPTOPHAN 5-HYDROXYLASE 2', 250764),
(406872, 'PTHR34220:SF9', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE DOMAIN-CONTAINING PROTEIN', 250765),
(406873, 'PTHR34220:SF7', NULL, NULL, NULL, NULL, 'SENSOR HISTIDINE KINASE YPDA', 250765),
(406874, 'PTHR34220:SF10', NULL, NULL, NULL, NULL, 'SENSOR HISTIDINE KINASE BTSS', 250765),
(406875, 'PTHR34220', NULL, NULL, NULL, NULL, 'SENSOR HISTIDINE KINASE YPDA', 250765),
(406876, 'PTHR12933:SF0', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RNA-ASSOCIATED PROTEIN 25 HOMOLOG', 250766),
(406877, 'PTHR12933', NULL, NULL, NULL, NULL, 'ORF PROTEIN-RELATED', 250766),
(406878, 'PTHR34936:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250767),
(406879, 'PTHR34936:SF6', NULL, NULL, NULL, NULL, 'OS03G0669600 PROTEIN', 250767),
(406880, 'PTHR34936:SF7', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 250767),
(406881, 'PTHR34936', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250767),
(406882, 'PTHR34936:SF8', NULL, NULL, NULL, NULL, '', 250767),
(406883, 'PTHR34936:SF9', NULL, NULL, NULL, NULL, 'BNACNNG19990D PROTEIN', 250767),
(406884, 'PTHR34936:SF11', NULL, NULL, NULL, NULL, '', 250767),
(406885, 'PTHR10760:SF16', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 250768),
(406886, 'PTHR10760:SF14', NULL, NULL, NULL, NULL, 'TORSIN-1B', 250768),
(406887, 'PTHR10760:SF15', NULL, NULL, NULL, NULL, 'TORSIN-1A', 250768),
(406888, 'PTHR10760:SF3', NULL, NULL, NULL, NULL, 'TORSIN-3A', 250768),
(406889, 'PTHR10760', NULL, NULL, NULL, NULL, 'TORSIN', 250768),
(406890, 'PTHR10760:SF4', NULL, NULL, NULL, NULL, 'TORSIN-2A', 250768),
(406891, 'PTHR10760:SF1', NULL, NULL, NULL, NULL, 'TORSIN-4A', 250768),
(406892, 'PTHR10760:SF2', NULL, NULL, NULL, NULL, 'LD13476P-RELATED', 250768),
(406893, 'PTHR31079:SF48', NULL, NULL, NULL, NULL, 'OS02G0594800 PROTEIN', 250769),
(406894, 'PTHR31079:SF37', NULL, NULL, NULL, NULL, 'BNAA07G37110D PROTEIN', 250769),
(406895, 'PTHR31079:SF25', NULL, NULL, NULL, NULL, 'NAC DOMAIN CONTAINING PROTEIN 44', 250769),
(406896, 'PTHR31079:SF35', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 250769),
(406897, 'PTHR31079:SF46', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 73', 250769),
(406898, 'PTHR31079:SF23', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 8', 250769),
(406899, 'PTHR31079:SF45', NULL, NULL, NULL, NULL, 'NAC TRANSCRIPTION FACTOR-LIKE PROTEIN', 250769),
(406900, 'PTHR31079:SF7', NULL, NULL, NULL, NULL, 'OS05G0563000 PROTEIN', 250769),
(406901, 'PTHR31079:SF39', NULL, NULL, NULL, NULL, 'NAC DOMAIN CONTAINING PROTEIN 99', 250769),
(406902, 'PTHR31079:SF27', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 250769),
(406903, 'PTHR31079:SF9', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF GAMMA RESPONSE 1', 250769),
(406904, 'PTHR31079:SF38', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 250769),
(406905, 'PTHR31079:SF49', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 250769),
(406906, 'PTHR31079:SF40', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 250769),
(406907, 'PTHR31079:SF51', NULL, NULL, NULL, NULL, 'OS06G0560300 PROTEIN', 250769),
(406908, 'PTHR31079:SF50', NULL, NULL, NULL, NULL, 'NAC DOMAIN CONTAINING PROTEIN 75-RELATED', 250769),
(406909, 'PTHR31079:SF43', NULL, NULL, NULL, NULL, 'NAC TRANSCRIPTION FACTOR-LIKE PROTEIN', 250769),
(406910, 'PTHR31079:SF32', NULL, NULL, NULL, NULL, 'OS05G0194500 PROTEIN', 250769);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(406911, 'PTHR31079:SF31', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 75', 250769),
(406912, 'PTHR31079:SF20', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 10', 250769),
(406913, 'PTHR31079:SF2', NULL, NULL, NULL, NULL, 'NAC DOMAIN CONTAINING PROTEIN 44-RELATED', 250769),
(406914, 'PTHR31079', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 73', 250769),
(406915, 'PTHR11267:SF114', NULL, NULL, NULL, NULL, 'T-BOX TRANSCRIPTION FACTOR TBX19', 250770),
(406916, 'PTHR11267:SF116', NULL, NULL, NULL, NULL, 'T-BOX TRANSCRIPTION FACTOR TBX22', 250770),
(406917, 'PTHR11267:SF88', NULL, NULL, NULL, NULL, 'T-BOX BRAIN PROTEIN 1', 250770),
(406918, 'PTHR11267:SF28', NULL, NULL, NULL, NULL, 'T-BOX TRANSCRIPTION FACTOR TBX5', 250770),
(406919, 'PTHR11267:SF29', NULL, NULL, NULL, NULL, 'T-BOX TRANSCRIPTION FACTOR TBX4', 250770),
(406920, 'PTHR11267:SF82', NULL, NULL, NULL, NULL, 'T-BOX TRANSCRIPTION FACTOR TBX2', 250770),
(406921, 'PTHR11267:SF194', NULL, NULL, NULL, NULL, 'MAX DIMERIZATION PROTEIN MGA A', 250770),
(406922, 'PTHR11267:SF83', NULL, NULL, NULL, NULL, 'T-BOX TRANSCRIPTION FACTOR T', 250770),
(406923, 'PTHR11267:SF190', NULL, NULL, NULL, NULL, 'T-BOX TRANSCRIPTION FACTOR TBX20', 250770),
(406924, 'PTHR11267:SF20', NULL, NULL, NULL, NULL, 'T-BOX TRANSCRIPTION FACTOR TBX18', 250770),
(406925, 'PTHR11267:SF191', NULL, NULL, NULL, NULL, 'OPTOMOTOR-BLIND-RELATED-GENE-1, ISOFORM A', 250770),
(406926, 'PTHR11267:SF170', NULL, NULL, NULL, NULL, 'T-BOX PROTEIN 33-RELATED', 250770),
(406927, 'PTHR11267:SF192', NULL, NULL, NULL, NULL, 'T-BOX TRANSCRIPTION FACTOR TBX-9', 250770),
(406928, 'PTHR11267:SF193', NULL, NULL, NULL, NULL, 'T BOX FAMILY', 250770),
(406929, 'PTHR11267:SF125', NULL, NULL, NULL, NULL, 'T-BOX TRANSCRIPTION FACTOR TBX21', 250770),
(406930, 'PTHR11267:SF169', NULL, NULL, NULL, NULL, 'T-BOX TRANSCRIPTION FACTOR T-A', 250770),
(406931, 'PTHR11267:SF13', NULL, NULL, NULL, NULL, 'EOMESODERMIN HOMOLOG', 250770),
(406932, 'PTHR11267:SF104', NULL, NULL, NULL, NULL, 'T-BOX TRANSCRIPTION FACTOR TBX1', 250770),
(406933, 'PTHR11267:SF106', NULL, NULL, NULL, NULL, 'T-RELATED PROTEIN', 250770),
(406934, 'PTHR11267:SF165', NULL, NULL, NULL, NULL, 'T-BOX PROTEIN 35-RELATED', 250770),
(406935, 'PTHR11267:SF100', NULL, NULL, NULL, NULL, 'T-BOX TRANSCRIPTION FACTOR TBX6', 250770),
(406936, 'PTHR11267:SF189', NULL, NULL, NULL, NULL, 'T-BOX PROTEIN 37-RELATED', 250770),
(406937, 'PTHR11267:SF59', NULL, NULL, NULL, NULL, 'T-BOX PROTEIN 11-RELATED', 250770),
(406938, 'PTHR11267:SF102', NULL, NULL, NULL, NULL, 'T-BOX TRANSCRIPTION FACTOR TBX10', 250770),
(406939, 'PTHR11267:SF91', NULL, NULL, NULL, NULL, 'T-BOX TRANSCRIPTION FACTOR TBX3', 250770),
(406940, 'PTHR11267:SF98', NULL, NULL, NULL, NULL, 'T-BOX TRANSCRIPTION FACTOR TBX15', 250770),
(406941, 'PTHR11267:SF32', NULL, NULL, NULL, NULL, 'MAX GENE-ASSOCIATED PROTEIN', 250770),
(406942, 'PTHR11267:SF51', NULL, NULL, NULL, NULL, 'DORSOCROSS1, ISOFORM A-RELATED', 250770),
(406943, 'PTHR11267:SF181', NULL, NULL, NULL, NULL, 'T-BOX TRANSCRIPTION FACTOR 16', 250770),
(406944, 'PTHR11267', NULL, NULL, NULL, NULL, 'T-BOX PROTEIN-RELATED', 250770),
(406945, 'PTHR11267:SF129', NULL, NULL, NULL, NULL, 'LP04777P-RELATED', 250770),
(406946, 'PTHR37766:SF1', NULL, NULL, NULL, NULL, 'OS01G0897100 PROTEIN', 250771),
(406947, 'PTHR37766', NULL, NULL, NULL, NULL, 'OS01G0897100 PROTEIN', 250771),
(406948, 'PTHR12276:SF91', NULL, NULL, NULL, NULL, 'CLATHRIN INTERACTOR EPSIN 2-RELATED', 250772),
(406949, 'PTHR12276:SF5', NULL, NULL, NULL, NULL, 'EPSIN-5', 250772),
(406950, 'PTHR12276:SF50', NULL, NULL, NULL, NULL, 'EPSIN-2', 250772),
(406951, 'PTHR12276:SF95', NULL, NULL, NULL, NULL, 'ENTH/VHS FAMILY PROTEIN', 250772),
(406952, 'PTHR12276:SF54', NULL, NULL, NULL, NULL, 'MYCBP-ASSOCIATED PROTEIN', 250772),
(406953, 'PTHR12276:SF99', NULL, NULL, NULL, NULL, 'EPSIN-2-LIKE', 250772),
(406954, 'PTHR12276:SF57', NULL, NULL, NULL, NULL, 'ENTH DOMAIN-CONTAINING PROTEIN 1', 250772),
(406955, 'PTHR12276:SF16', NULL, NULL, NULL, NULL, 'EPSIN-3', 250772);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(406956, 'PTHR12276:SF110', NULL, NULL, NULL, NULL, 'EPSIN-1-RELATED', 250772),
(406957, 'PTHR12276:SF111', NULL, NULL, NULL, NULL, 'CLATHRIN INTERACTOR EPSIN 1-LIKE ISOFORM X1', 250772),
(406958, 'PTHR12276:SF112', NULL, NULL, NULL, NULL, 'EPSIN 3A-RELATED', 250772),
(406959, 'PTHR12276:SF113', NULL, NULL, NULL, NULL, 'ENTH/VHS FAMILY PROTEIN', 250772),
(406960, 'PTHR12276:SF114', NULL, NULL, NULL, NULL, 'ENTH DOMAIN-CONTAINING PROTEIN', 250772),
(406961, 'PTHR12276:SF115', NULL, NULL, NULL, NULL, 'FI19443P1', 250772),
(406962, 'PTHR12276:SF116', NULL, NULL, NULL, NULL, 'ENTH/VHS FAMILY PROTEIN', 250772),
(406963, 'PTHR12276:SF117', NULL, NULL, NULL, NULL, 'ENTH DOMAIN-CONTAINING PROTEIN', 250772),
(406964, 'PTHR12276:SF118', NULL, NULL, NULL, NULL, 'ENTH/VHS FAMILY PROTEIN-RELATED', 250772),
(406965, 'PTHR12276:SF119', NULL, NULL, NULL, NULL, 'EPSIN-4', 250772),
(406966, 'PTHR12276:SF86', NULL, NULL, NULL, NULL, 'CLATHRIN INTERACTOR EPSIN 3-LIKE ISOFORM X1', 250772),
(406967, 'PTHR12276:SF87', NULL, NULL, NULL, NULL, 'OS01G0738600 PROTEIN', 250772),
(406968, 'PTHR12276:SF45', NULL, NULL, NULL, NULL, 'CLATHRIN INTERACTOR 1', 250772),
(406969, 'PTHR12276:SF48', NULL, NULL, NULL, NULL, 'EPSIN-1', 250772),
(406970, 'PTHR12276:SF102', NULL, NULL, NULL, NULL, 'BNAC04G48710D PROTEIN', 250772),
(406971, 'PTHR12276:SF103', NULL, NULL, NULL, NULL, 'ZGC:194578', 250772),
(406972, 'PTHR12276:SF109', NULL, NULL, NULL, NULL, 'BNAC04G48700D PROTEIN', 250772),
(406973, 'PTHR12276', NULL, NULL, NULL, NULL, 'EPSIN/ENT-RELATED', 250772),
(406974, 'PTHR46691:SF8', NULL, NULL, NULL, NULL, 'BNAC05G02890D PROTEIN', 250773),
(406975, 'PTHR46691:SF7', NULL, NULL, NULL, NULL, 'BNAC04G29240D PROTEIN', 250773),
(406976, 'PTHR46691:SF9', NULL, NULL, NULL, NULL, 'BNAC06G07470D PROTEIN', 250773),
(406977, 'PTHR46691:SF12', NULL, NULL, NULL, NULL, 'BNAA05G25980D PROTEIN', 250773),
(406978, 'PTHR46691', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP B PROTEIN 9', 250773),
(406979, 'PTHR46691:SF11', NULL, NULL, NULL, NULL, 'BNAA08G28100D PROTEIN', 250773),
(406980, 'PTHR46691:SF10', NULL, NULL, NULL, NULL, 'BNAA05G13650D PROTEIN', 250773),
(406981, 'PTHR46691:SF3', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP B PROTEIN 15', 250773),
(406982, 'PTHR46691:SF6', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP B PROTEIN 10-RELATED', 250773),
(406983, 'PTHR46691:SF5', NULL, NULL, NULL, NULL, 'HMG (HIGH MOBILITY GROUP) BOX PROTEIN', 250773),
(406984, 'PTHR46691:SF1', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 2', 250773),
(406985, 'PTHR44542:SF19', NULL, NULL, NULL, NULL, 'OS04G0249600 PROTEIN', 250774),
(406986, 'PTHR44542:SF7', NULL, NULL, NULL, NULL, 'OS02G0157600 PROTEIN', 250774),
(406987, 'PTHR44542:SF5', NULL, NULL, NULL, NULL, 'OS12G0428000 PROTEIN', 250774),
(406988, 'PTHR44542:SF14', NULL, NULL, NULL, NULL, 'PROTEIN HIGH ARSENIC CONTENT 1, MITOCHONDRIAL-RELATED', 250774),
(406989, 'PTHR44542:SF23', NULL, NULL, NULL, NULL, 'RHODANESE-LIKE DOMAIN-CONTAINING PROTEIN 17', 250774),
(406990, 'PTHR44542:SF12', NULL, NULL, NULL, NULL, 'THIOSULFATE SULFURTRANSFERASE 18', 250774),
(406991, 'PTHR44542:SF8', NULL, NULL, NULL, NULL, 'RHODANESE DOMAIN-CONTAINING PROTEIN', 250774),
(406992, 'PTHR44542:SF22', NULL, NULL, NULL, NULL, 'RHODANESE DOMAIN-CONTAINING PROTEIN', 250774),
(406993, 'PTHR44542:SF9', NULL, NULL, NULL, NULL, 'RHODANESE DOMAIN-CONTAINING PROTEIN', 250774),
(406994, 'PTHR44542', NULL, NULL, NULL, NULL, 'THIOSULFATE SULFURTRANSFERASE 18', 250774),
(406995, 'PTHR44542:SF17', NULL, NULL, NULL, NULL, 'RHODANESE DOMAIN-CONTAINING PROTEIN', 250774),
(406996, 'PTHR44542:SF15', NULL, NULL, NULL, NULL, 'RHODANESE/CELL CYCLE CONTROL PHOSPHATASE SUPERFAMILY PROTEIN-RELATED', 250774),
(406997, 'PTHR10994:SF62', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN B8', 250775),
(406998, 'PTHR10994:SF85', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN B9', 250775),
(406999, 'PTHR10994:SF138', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407000, 'PTHR10994:SF139', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN B2', 250775);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(407001, 'PTHR10994:SF67', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN B16', 250775),
(407002, 'PTHR10994:SF65', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN B12', 250775),
(407003, 'PTHR10994:SF190', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407004, 'PTHR10994:SF191', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407005, 'PTHR10994:SF151', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407006, 'PTHR10994:SF170', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407007, 'PTHR10994:SF192', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN B5', 250775),
(407008, 'PTHR10994:SF193', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407009, 'PTHR10994:SF154', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN B11', 250775),
(407010, 'PTHR10994:SF132', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407011, 'PTHR10994:SF176', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407012, 'PTHR10994:SF177', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407013, 'PTHR10994:SF155', NULL, NULL, NULL, NULL, 'RETICULON DOMAIN-CONTAINING PROTEIN', 250775),
(407014, 'PTHR10994:SF174', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407015, 'PTHR10994:SF152', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407016, 'PTHR10994:SF131', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407017, 'PTHR10994:SF136', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407018, 'PTHR10994:SF157', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN B14', 250775),
(407019, 'PTHR10994:SF179', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407020, 'PTHR10994:SF73', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407021, 'PTHR10994:SF93', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407022, 'PTHR10994:SF183', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407023, 'PTHR10994:SF140', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407024, 'PTHR10994:SF184', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407025, 'PTHR10994:SF181', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN B7', 250775),
(407026, 'PTHR10994:SF160', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407027, 'PTHR10994:SF187', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407028, 'PTHR10994:SF165', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407029, 'PTHR10994:SF143', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN B1', 250775),
(407030, 'PTHR10994:SF144', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407031, 'PTHR10994:SF188', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407032, 'PTHR10994:SF141', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN B10', 250775),
(407033, 'PTHR10994:SF185', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407034, 'PTHR10994:SF186', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407035, 'PTHR10994:SF164', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407036, 'PTHR10994', NULL, NULL, NULL, NULL, 'RETICULON', 250775),
(407037, 'PTHR10994:SF142', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407038, 'PTHR10994:SF147', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN B6', 250775),
(407039, 'PTHR10994:SF148', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407040, 'PTHR10994:SF145', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN B13', 250775),
(407041, 'PTHR10994:SF189', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407042, 'PTHR10994:SF167', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407043, 'PTHR10994:SF146', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', 250775),
(407044, 'PTHR10994:SF168', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN B15', 250775),
(407045, 'PTHR47074:SF63', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 250776),
(407046, 'PTHR47074:SF64', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 250776),
(407047, 'PTHR47074:SF42', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 250776);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(407048, 'PTHR47074:SF61', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 250776),
(407049, 'PTHR47074:SF62', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 250776),
(407050, 'PTHR47074:SF60', NULL, NULL, NULL, NULL, 'GB|AAF30348.1-RELATED', 250776),
(407051, 'PTHR47074:SF49', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDYL TRANSFERASE, RIBONUCLEASE H-LIKE SUPERFAMILY PROTEIN-RELATED', 250776),
(407052, 'PTHR47074:SF47', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 250776),
(407053, 'PTHR47074:SF48', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDYL TRANSFERASE, RIBONUCLEASE H-LIKE SUPERFAMILY PROTEIN', 250776),
(407054, 'PTHR47074:SF43', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 250776),
(407055, 'PTHR47074:SF65', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 250776),
(407056, 'PTHR47074:SF21', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 250776),
(407057, 'PTHR47074:SF66', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 250776),
(407058, 'PTHR47074:SF30', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 250776),
(407059, 'PTHR47074:SF52', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 250776),
(407060, 'PTHR47074:SF31', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 250776),
(407061, 'PTHR47074:SF53', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE-LIKE PROTEIN', 250776),
(407062, 'PTHR47074:SF50', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H-LIKE', 250776),
(407063, 'PTHR47074:SF51', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 250776),
(407064, 'PTHR47074:SF39', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 250776),
(407065, 'PTHR47074:SF58', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 250776),
(407066, 'PTHR47074:SF59', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 250776),
(407067, 'PTHR47074:SF15', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 250776),
(407068, 'PTHR47074:SF56', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 250776),
(407069, 'PTHR47074:SF57', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 250776),
(407070, 'PTHR47074', NULL, NULL, NULL, NULL, 'BNAC02G40300D PROTEIN', 250776),
(407071, 'PTHR47074:SF54', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 250776),
(407072, 'PTHR47074:SF11', NULL, NULL, NULL, NULL, 'OS07G0513450 PROTEIN', 250776),
(407073, 'PTHR47074:SF55', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 250776),
(407074, 'PTHR17901:SF14', NULL, NULL, NULL, NULL, 'MAGNESIUM-DEPENDENT PHOSPHATASE 1', 250777),
(407075, 'PTHR17901:SF23', NULL, NULL, NULL, NULL, 'MAGNESIUM-DEPENDENT PHOSPHATASE 1-LIKE', 250777),
(407076, 'PTHR17901', NULL, NULL, NULL, NULL, 'MAGNESIUM-DEPENDENT PHOSPHATASE 1 MDP1', 250777),
(407077, 'PTHR17901:SF22', NULL, NULL, NULL, NULL, 'MAGNESIUM-DEPENDENT PHOSPHATASE 1-LIKE', 250777),
(407078, 'PTHR17901:SF21', NULL, NULL, NULL, NULL, 'MAGNESIUM-DEPENDENT PHOSPHATASE-LIKE PROTEIN', 250777),
(407079, 'PTHR12483:SF125', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER', 250778),
(407080, 'PTHR12483:SF85', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER', 250778),
(407081, 'PTHR12483:SF42', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER 4', 250778),
(407082, 'PTHR12483:SF124', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER', 250778),
(407083, 'PTHR12483:SF102', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER', 250778),
(407084, 'PTHR12483:SF123', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER', 250778),
(407085, 'PTHR12483:SF83', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER', 250778),
(407086, 'PTHR12483:SF122', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER', 250778),
(407087, 'PTHR12483:SF121', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER 1', 250778),
(407088, 'PTHR12483:SF120', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER', 250778),
(407089, 'PTHR12483:SF24', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER 2-RELATED', 250778),
(407090, 'PTHR12483:SF43', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER', 250778),
(407091, 'PTHR12483:SF22', NULL, NULL, NULL, NULL, 'HIGH AFFINITY COPPER UPTAKE PROTEIN 1', 250778);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(407092, 'PTHR12483:SF109', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER', 250778),
(407093, 'PTHR12483:SF81', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER 3', 250778),
(407094, 'PTHR12483:SF8', NULL, NULL, NULL, NULL, 'LOW AFFINITY COPPER UPTAKE PROTEIN 2-RELATED', 250778),
(407095, 'PTHR12483:SF106', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER', 250778),
(407096, 'PTHR12483:SF80', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER', 250778),
(407097, 'PTHR12483:SF126', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER', 250778),
(407098, 'PTHR12483:SF49', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER', 250778),
(407099, 'PTHR12483:SF27', NULL, NULL, NULL, NULL, 'COPPER TRANSPORT PROTEIN CTR1', 250778),
(407100, 'PTHR12483', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 31  COPPER TRANSPORTERS', 250778),
(407101, 'PTHR12483:SF30', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER', 250778),
(407102, 'PTHR12483:SF113', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER', 250778),
(407103, 'PTHR12483:SF31', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER', 250778),
(407104, 'PTHR12483:SF94', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER 4', 250778),
(407105, 'PTHR12483:SF112', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER', 250778),
(407106, 'PTHR12483:SF111', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER', 250778),
(407107, 'PTHR12483:SF73', NULL, NULL, NULL, NULL, 'COPPER TRANSPORT PROTEIN CTR3', 250778),
(407108, 'PTHR12483:SF95', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER', 250778),
(407109, 'PTHR12483:SF110', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER', 250778),
(407110, 'PTHR12483:SF79', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER', 250778),
(407111, 'PTHR12483:SF98', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER', 250778),
(407112, 'PTHR12483:SF99', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER', 250778),
(407113, 'PTHR12483:SF119', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER-RELATED', 250778),
(407114, 'PTHR12483:SF92', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER', 250778),
(407115, 'PTHR12483:SF117', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER 3', 250778),
(407116, 'PTHR12483:SF115', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER', 250778),
(407117, 'PTHR12483:SF91', NULL, NULL, NULL, NULL, 'COPPER TRANSPORTER', 250778),
(407118, 'PTHR31509:SF60', NULL, NULL, NULL, NULL, 'DUF241 DOMAIN PROTEIN', 250779),
(407119, 'PTHR31509:SF125', NULL, NULL, NULL, NULL, '', 250779),
(407120, 'PTHR31509:SF126', NULL, NULL, NULL, NULL, 'BNAA09G00020D PROTEIN', 250779),
(407121, 'PTHR31509:SF62', NULL, NULL, NULL, NULL, 'DUF241 DOMAIN PROTEIN', 250779),
(407122, 'PTHR31509:SF128', NULL, NULL, NULL, NULL, '', 250779),
(407123, 'PTHR31509:SF129', NULL, NULL, NULL, NULL, 'BNAA08G21000D PROTEIN', 250779),
(407124, 'PTHR31509:SF68', NULL, NULL, NULL, NULL, 'PROTEIN ROH1', 250779),
(407125, 'PTHR31509:SF67', NULL, NULL, NULL, NULL, 'OSJNBB0004A17.21 PROTEIN', 250779),
(407126, 'PTHR31509:SF69', NULL, NULL, NULL, NULL, 'BPS1-LIKE PROTEIN', 250779),
(407127, 'PTHR31509:SF120', NULL, NULL, NULL, NULL, 'DUF241 DOMAIN PROTEIN', 250779),
(407128, 'PTHR31509:SF20', NULL, NULL, NULL, NULL, 'PROTEIN BPS1, CHLOROPLASTIC-LIKE', 250779),
(407129, 'PTHR31509:SF64', NULL, NULL, NULL, NULL, 'PLANT/PROTEIN (DUF793)', 250779),
(407130, 'PTHR31509:SF121', NULL, NULL, NULL, NULL, '', 250779),
(407131, 'PTHR31509:SF122', NULL, NULL, NULL, NULL, 'BNAA09G00040D PROTEIN', 250779),
(407132, 'PTHR31509:SF65', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR 3 SUBUNIT A, PUTATIVE-RELATED', 250779),
(407133, 'PTHR31509:SF123', NULL, NULL, NULL, NULL, 'PROTEIN BPS1, CHLOROPLASTIC-LIKE', 250779),
(407134, 'PTHR31509:SF93', NULL, NULL, NULL, NULL, 'BNAA03G46010D PROTEIN', 250779),
(407135, 'PTHR31509:SF135', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR 3 SUBUNIT A, PUTATIVE-RELATED', 250779),
(407136, 'PTHR31509:SF92', NULL, NULL, NULL, NULL, '', 250779),
(407137, 'PTHR31509:SF51', NULL, NULL, NULL, NULL, '', 250779),
(407138, 'PTHR31509:SF50', NULL, NULL, NULL, NULL, '', 250779),
(407139, 'PTHR31509:SF94', NULL, NULL, NULL, NULL, '', 250779),
(407140, 'PTHR31509:SF91', NULL, NULL, NULL, NULL, 'BNAC03G65380D PROTEIN', 250779);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(407141, 'PTHR31509:SF13', NULL, NULL, NULL, NULL, 'PROTEIN BPS1, CHLOROPLASTIC-LIKE', 250779),
(407142, 'PTHR31509:SF56', NULL, NULL, NULL, NULL, '', 250779),
(407143, 'PTHR31509:SF59', NULL, NULL, NULL, NULL, 'PROTEIN BPS1, CHLOROPLASTIC', 250779),
(407144, 'PTHR31509:SF130', NULL, NULL, NULL, NULL, '', 250779),
(407145, 'PTHR31509:SF97', NULL, NULL, NULL, NULL, 'BNAA07G03190D PROTEIN', 250779),
(407146, 'PTHR31509:SF52', NULL, NULL, NULL, NULL, '', 250779),
(407147, 'PTHR31509:SF11', NULL, NULL, NULL, NULL, 'PLANT/F1M20-13 PROTEIN', 250779),
(407148, 'PTHR31509:SF134', NULL, NULL, NULL, NULL, '', 250779),
(407149, 'PTHR31509', NULL, NULL, NULL, NULL, 'BPS1-LIKE PROTEIN', 250779),
(407150, 'PTHR31509:SF102', NULL, NULL, NULL, NULL, 'BYPASS RELATED PROTEIN-RELATED', 250779),
(407151, 'PTHR31509:SF146', NULL, NULL, NULL, NULL, 'OS08G0104800 PROTEIN', 250779),
(407152, 'PTHR31509:SF81', NULL, NULL, NULL, NULL, 'PLANT/F1M20-13 PROTEIN', 250779),
(407153, 'PTHR31509:SF147', NULL, NULL, NULL, NULL, '', 250779),
(407154, 'PTHR31509:SF103', NULL, NULL, NULL, NULL, 'CARRIER PROTEIN (DUF241)', 250779),
(407155, 'PTHR31509:SF148', NULL, NULL, NULL, NULL, 'BNAC04G04750D PROTEIN', 250779),
(407156, 'PTHR31509:SF83', NULL, NULL, NULL, NULL, '', 250779),
(407157, 'PTHR31509:SF149', NULL, NULL, NULL, NULL, '', 250779),
(407158, 'PTHR31509:SF106', NULL, NULL, NULL, NULL, '', 250779),
(407159, 'PTHR31509:SF107', NULL, NULL, NULL, NULL, '', 250779),
(407160, 'PTHR31509:SF80', NULL, NULL, NULL, NULL, 'PUTATIVE (DUF793)-RELATED', 250779),
(407161, 'PTHR31509:SF140', NULL, NULL, NULL, NULL, '', 250779),
(407162, 'PTHR31509:SF141', NULL, NULL, NULL, NULL, '', 250779),
(407163, 'PTHR31509:SF142', NULL, NULL, NULL, NULL, '', 250779),
(407164, 'PTHR31509:SF42', NULL, NULL, NULL, NULL, 'BPS1-LIKE PROTEIN', 250779),
(407165, 'PTHR31509:SF143', NULL, NULL, NULL, NULL, 'DUF241 DOMAIN PROTEIN', 250779),
(407166, 'PTHR31509:SF88', NULL, NULL, NULL, NULL, '', 250779),
(407167, 'PTHR31509:SF100', NULL, NULL, NULL, NULL, 'DUF241 DOMAIN PROTEIN', 250779),
(407168, 'PTHR31509:SF144', NULL, NULL, NULL, NULL, '', 250779),
(407169, 'PTHR31509:SF87', NULL, NULL, NULL, NULL, '', 250779),
(407170, 'PTHR31509:SF101', NULL, NULL, NULL, NULL, 'BNAC03G61000D PROTEIN', 250779),
(407171, 'PTHR31509:SF145', NULL, NULL, NULL, NULL, 'DUF241 DOMAIN PROTEIN', 250779),
(407172, 'PTHR31509:SF113', NULL, NULL, NULL, NULL, '', 250779),
(407173, 'PTHR31509:SF114', NULL, NULL, NULL, NULL, '', 250779),
(407174, 'PTHR31509:SF73', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (DUF241)-RELATED', 250779),
(407175, 'PTHR31509:SF72', NULL, NULL, NULL, NULL, 'BPS1-LIKE PROTEIN', 250779),
(407176, 'PTHR31509:SF116', NULL, NULL, NULL, NULL, '', 250779),
(407177, 'PTHR31509:SF117', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250779),
(407178, 'PTHR31509:SF119', NULL, NULL, NULL, NULL, 'BNAA06G12890D PROTEIN', 250779),
(407179, 'PTHR31509:SF0', NULL, NULL, NULL, NULL, 'OS04G0688000 PROTEIN', 250779),
(407180, 'PTHR31509:SF150', NULL, NULL, NULL, NULL, 'DUF793 FAMILY PROTEIN', 250779),
(407181, 'PTHR31509:SF3', NULL, NULL, NULL, NULL, 'BPS1-LIKE PROTEIN', 250779),
(407182, 'PTHR31509:SF151', NULL, NULL, NULL, NULL, '', 250779),
(407183, 'PTHR31509:SF4', NULL, NULL, NULL, NULL, 'OS12G0164600 PROTEIN', 250779),
(407184, 'PTHR31509:SF152', NULL, NULL, NULL, NULL, '', 250779),
(407185, 'PTHR31509:SF153', NULL, NULL, NULL, NULL, '', 250779),
(407186, 'PTHR31509:SF75', NULL, NULL, NULL, NULL, 'PLANT/F1M20-13 PROTEIN', 250779),
(407187, 'PTHR31509:SF110', NULL, NULL, NULL, NULL, 'BNAA09G00030D PROTEIN', 250779),
(407188, 'PTHR31509:SF154', NULL, NULL, NULL, NULL, '', 250779),
(407189, 'PTHR31509:SF111', NULL, NULL, NULL, NULL, 'BNAC03G65190D PROTEIN', 250779),
(407190, 'PTHR31509:SF8', NULL, NULL, NULL, NULL, 'OS02G0552200 PROTEIN', 250779),
(407191, 'PTHR31509:SF76', NULL, NULL, NULL, NULL, '', 250779),
(407192, 'PTHR31509:SF112', NULL, NULL, NULL, NULL, 'BNAA07G03180D PROTEIN', 250779),
(407193, 'PTHR45136:SF2', NULL, NULL, NULL, NULL, '', 250780),
(407194, 'PTHR45136', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 250780);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(407195, 'PTHR46362', NULL, NULL, NULL, NULL, 'GEM-ASSOCIATED PROTEIN 5', 250781),
(407196, 'PTHR46362:SF1', NULL, NULL, NULL, NULL, 'GEM-ASSOCIATED PROTEIN 5', 250781),
(407197, 'PTHR28546:SF3', NULL, NULL, NULL, NULL, 'NEURONAL VESICLE TRAFFICKING-ASSOCIATED PROTEIN 1', 250782),
(407198, 'PTHR28546:SF2', NULL, NULL, NULL, NULL, 'NEURONAL VESICLE TRAFFICKING-ASSOCIATED PROTEIN 2', 250782),
(407199, 'PTHR28546:SF1', NULL, NULL, NULL, NULL, 'NEURON-SPECIFIC VESICULAR PROTEIN CALCYON', 250782),
(407200, 'PTHR28546', NULL, NULL, NULL, NULL, 'NEURONAL VESICLE TRAFFICKING-ASSOCIATED PROTEIN 2-RELATED', 250782),
(407201, 'PTHR11825', NULL, NULL, NULL, NULL, 'SUBGROUP IIII AMINOTRANSFERASE', 250783),
(407202, 'PTHR11825:SF70', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN-AMINO-ACID AMINOTRANSFERASE, CYTOSOLIC', 250783),
(407203, 'PTHR11825:SF39', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN-AMINO-ACID AMINOTRANSFERASE, MITOCHONDRIAL', 250783),
(407204, 'PTHR11825:SF28', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN-AMINO-ACID AMINOTRANSFERASE', 250783),
(407205, 'PTHR11825:SF69', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN-AMINO-ACID AMINOTRANSFERASE', 250783),
(407206, 'PTHR11825:SF44', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN-AMINO-ACID AMINOTRANSFERASE', 250783),
(407207, 'PTHR28673', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 108', 250784),
(407208, 'PTHR28673:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 108', 250784),
(407209, 'PTHR42024:SF1', NULL, NULL, NULL, NULL, '', 250785),
(407210, 'PTHR42024', NULL, NULL, NULL, NULL, '', 250785),
(407211, 'PTHR31462:SF5', NULL, NULL, NULL, NULL, 'ENDOSOMAL/LYSOSOMAL POTASSIUM CHANNEL TMEM175', 250786),
(407212, 'PTHR31462', NULL, NULL, NULL, NULL, 'ENDOSOMAL/LYSOSOMAL POTASSIUM CHANNEL TMEM175', 250786),
(407213, 'PTHR13112:SF0', NULL, NULL, NULL, NULL, 'FI21285P1', 250787),
(407214, 'PTHR13112:SF2', NULL, NULL, NULL, NULL, 'REGULATOR OF NONSENSE TRANSCRIPTS 3A', 250787),
(407215, 'PTHR13112:SF1', NULL, NULL, NULL, NULL, 'REGULATOR OF NONSENSE TRANSCRIPTS 3B', 250787),
(407216, 'PTHR13112:SF15', NULL, NULL, NULL, NULL, 'REGULATOR OF NONSENSE TRANSCRIPTS UPF3-LIKE', 250787),
(407217, 'PTHR13112:SF13', NULL, NULL, NULL, NULL, 'SMG4_UPF3 DOMAIN-CONTAINING PROTEIN', 250787),
(407218, 'PTHR13112:SF12', NULL, NULL, NULL, NULL, 'SMG-4/UPF3 FAMILY PROTEIN-RELATED', 250787),
(407219, 'PTHR13112:SF7', NULL, NULL, NULL, NULL, 'SMG4_UPF3 DOMAIN-CONTAINING PROTEIN', 250787),
(407220, 'PTHR13112:SF9', NULL, NULL, NULL, NULL, 'SMG4_UPF3 DOMAIN-CONTAINING PROTEIN', 250787),
(407221, 'PTHR13112:SF5', NULL, NULL, NULL, NULL, 'SMG4_UPF3 DOMAIN-CONTAINING PROTEIN', 250787),
(407222, 'PTHR13112', NULL, NULL, NULL, NULL, 'UPF3 REGULATOR OF NONSENSE TRANSCRIPTS-LIKE PROTEIN', 250787),
(407223, 'PTHR13779', NULL, NULL, NULL, NULL, 'WERNER HELICASE-INTERACTING PROTEIN 1 FAMILY MEMBER', 250788),
(407224, 'PTHR13779:SF7', NULL, NULL, NULL, NULL, 'ATPASE WRNIP1', 250788),
(407225, 'PTHR33320:SF4', NULL, NULL, NULL, NULL, 'OS08G0230600 PROTEIN', 250789),
(407226, 'PTHR33320:SF2', NULL, NULL, NULL, NULL, 'OS07G0564200 PROTEIN', 250789),
(407227, 'PTHR33320:SF17', NULL, NULL, NULL, NULL, '', 250789),
(407228, 'PTHR33320:SF28', NULL, NULL, NULL, NULL, 'METHIONYL-TRNA SYNTHETASE', 250789),
(407229, 'PTHR33320:SF19', NULL, NULL, NULL, NULL, 'BNAA06G01810D PROTEIN', 250789),
(407230, 'PTHR33320:SF24', NULL, NULL, NULL, NULL, 'BNAA03G49870D PROTEIN', 250789),
(407231, 'PTHR33320:SF13', NULL, NULL, NULL, NULL, '', 250789),
(407232, 'PTHR33320:SF15', NULL, NULL, NULL, NULL, '', 250789),
(407233, 'PTHR33320:SF27', NULL, NULL, NULL, NULL, 'BNAA01G07090D PROTEIN', 250789),
(407234, 'PTHR33320:SF31', NULL, NULL, NULL, NULL, '', 250789),
(407235, 'PTHR33320:SF32', NULL, NULL, NULL, NULL, 'METHIONYL-TRNA SYNTHETASE', 250789),
(407236, 'PTHR33320:SF11', NULL, NULL, NULL, NULL, '', 250789),
(407237, 'PTHR33320:SF33', NULL, NULL, NULL, NULL, 'METHIONYL-TRNA SYNTHETASE', 250789),
(407238, 'PTHR33320:SF12', NULL, NULL, NULL, NULL, 'BNACNNG72440D PROTEIN', 250789),
(407239, 'PTHR33320:SF34', NULL, NULL, NULL, NULL, '', 250789);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(407240, 'PTHR33320', NULL, NULL, NULL, NULL, 'METHIONYL-TRNA SYNTHETASE', 250789),
(407241, 'PTHR33320:SF30', NULL, NULL, NULL, NULL, 'OS04G0606200 PROTEIN', 250789),
(407242, 'PTHR31245:SF34', NULL, NULL, NULL, NULL, 'UBA-LIKE PROTEIN-RELATED', 250790),
(407243, 'PTHR31245:SF22', NULL, NULL, NULL, NULL, 'CUE DOMAIN-CONTAINING PROTEIN', 250790),
(407244, 'PTHR31245:SF1', NULL, NULL, NULL, NULL, 'UBIQUITIN SYSTEM COMPONENT CUE PROTEIN', 250790),
(407245, 'PTHR31245:SF20', NULL, NULL, NULL, NULL, 'F18B13.13 PROTEIN', 250790),
(407246, 'PTHR31245:SF31', NULL, NULL, NULL, NULL, 'OS02G0184500 PROTEIN', 250790),
(407247, 'PTHR31245:SF30', NULL, NULL, NULL, NULL, 'CUE DOMAIN-CONTAINING PROTEIN', 250790),
(407248, 'PTHR31245:SF2', NULL, NULL, NULL, NULL, 'OS06G0642650 PROTEIN', 250790),
(407249, 'PTHR31245:SF3', NULL, NULL, NULL, NULL, 'OS08G0313600 PROTEIN', 250790),
(407250, 'PTHR31245:SF19', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 250790),
(407251, 'PTHR31245:SF18', NULL, NULL, NULL, NULL, 'CUE DOMAIN-CONTAINING PROTEIN', 250790),
(407252, 'PTHR31245:SF29', NULL, NULL, NULL, NULL, 'BNAC05G11050D PROTEIN', 250790),
(407253, 'PTHR31245:SF28', NULL, NULL, NULL, NULL, 'OS01G0610000 PROTEIN', 250790),
(407254, 'PTHR31245:SF16', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 6-DEHYDROGENASE', 250790),
(407255, 'PTHR31245:SF27', NULL, NULL, NULL, NULL, 'CUE DOMAIN-CONTAINING PROTEIN', 250790),
(407256, 'PTHR31245:SF37', NULL, NULL, NULL, NULL, 'OS09G0119100 PROTEIN', 250790),
(407257, 'PTHR31245:SF36', NULL, NULL, NULL, NULL, '', 250790),
(407258, 'PTHR31245:SF24', NULL, NULL, NULL, NULL, 'UBIQUITIN SYSTEM COMPONENT CUE PROTEIN', 250790),
(407259, 'PTHR31245:SF35', NULL, NULL, NULL, NULL, 'CUE DOMAIN-CONTAINING PROTEIN', 250790),
(407260, 'PTHR31245', NULL, NULL, NULL, NULL, 'UBIQUITIN SYSTEM COMPONENT CUE PROTEIN', 250790),
(407261, 'PTHR30143', NULL, NULL, NULL, NULL, 'ACID HYDRATASE', 250791),
(407262, 'PTHR30143:SF0', NULL, NULL, NULL, NULL, '2-KETO-4-PENTENOATE HYDRATASE', 250791),
(407263, 'PTHR35828:SF3', NULL, NULL, NULL, NULL, 'OS11G0201480 PROTEIN', 250792),
(407264, 'PTHR35828:SF40', NULL, NULL, NULL, NULL, '', 250792),
(407265, 'PTHR35828:SF21', NULL, NULL, NULL, NULL, 'OS08G0203800 PROTEIN', 250792),
(407266, 'PTHR35828:SF22', NULL, NULL, NULL, NULL, 'OS10G0103633 PROTEIN', 250792),
(407267, 'PTHR35828:SF33', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 250792),
(407268, 'PTHR35828:SF30', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 250792),
(407269, 'PTHR35828:SF41', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 250792),
(407270, 'PTHR35828:SF20', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 250792),
(407271, 'PTHR35828:SF25', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 250792),
(407272, 'PTHR35828:SF15', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 250792),
(407273, 'PTHR35828:SF23', NULL, NULL, NULL, NULL, '', 250792),
(407274, 'PTHR35828:SF34', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 250792),
(407275, 'PTHR35828:SF12', NULL, NULL, NULL, NULL, 'OS01G0322500 PROTEIN', 250792),
(407276, 'PTHR35828:SF24', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 250792),
(407277, 'PTHR35828:SF13', NULL, NULL, NULL, NULL, 'OS01G0152100 PROTEIN', 250792),
(407278, 'PTHR35828:SF18', NULL, NULL, NULL, NULL, 'OS03G0703800 PROTEIN', 250792),
(407279, 'PTHR35828', NULL, NULL, NULL, NULL, 'OS08G0203800 PROTEIN-RELATED', 250792),
(407280, 'PTHR35828:SF38', NULL, NULL, NULL, NULL, '', 250792),
(407281, 'PTHR35828:SF16', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 250792),
(407282, 'PTHR35828:SF27', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 250792),
(407283, 'PTHR35828:SF28', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN', 250792),
(407284, 'PTHR23320', NULL, NULL, NULL, NULL, 'MEMBRANE-SPANNING 4-DOMAINS SUBFAMILY A  MS4A -RELATED', 250793),
(407285, 'PTHR23320:SF167', NULL, NULL, NULL, NULL, 'MEMBRANE-SPANNING 4-DOMAINS SUBFAMILY A MEMBER 14', 250793);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(407286, 'PTHR23320:SF166', NULL, NULL, NULL, NULL, 'MEMBRANE-SPANNING 4-DOMAINS SUBFAMILY A MEMBER 4A', 250793),
(407287, 'PTHR23320:SF121', NULL, NULL, NULL, NULL, 'MEMBRANE-SPANNING 4-DOMAINS, SUBFAMILY A, MEMBER 19', 250793),
(407288, 'PTHR23320:SF143', NULL, NULL, NULL, NULL, 'SI:CH211-212K18.8-RELATED', 250793),
(407289, 'PTHR23320:SF165', NULL, NULL, NULL, NULL, 'PROTEIN CBG27997', 250793),
(407290, 'PTHR23320:SF164', NULL, NULL, NULL, NULL, 'MEMBRANE-SPANNING 4-DOMAINS, SUBFAMILY A, MEMBER 20', 250793),
(407291, 'PTHR23320:SF142', NULL, NULL, NULL, NULL, 'PROTEIN CBG13276', 250793),
(407292, 'PTHR23320:SF120', NULL, NULL, NULL, NULL, 'MEMBRANE-SPANNING 4-DOMAINS SUBFAMILY A MEMBER 6C', 250793),
(407293, 'PTHR23320:SF163', NULL, NULL, NULL, NULL, '', 250793),
(407294, 'PTHR23320:SF162', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250793),
(407295, 'PTHR23320:SF161', NULL, NULL, NULL, NULL, '', 250793),
(407296, 'PTHR23320:SF160', NULL, NULL, NULL, NULL, '', 250793),
(407297, 'PTHR23320:SF66', NULL, NULL, NULL, NULL, 'HIGH AFFINITY IMMUNOGLOBULIN EPSILON RECEPTOR SUBUNIT BETA', 250793),
(407298, 'PTHR23320:SF129', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 176', 250793),
(407299, 'PTHR23320:SF42', NULL, NULL, NULL, NULL, 'MEMBRANE-SPANNING 4-DOMAINS SUBFAMILY A MEMBER 13', 250793),
(407300, 'PTHR23320:SF128', NULL, NULL, NULL, NULL, 'MEMBRANE-SPANNING 4-DOMAINS, SUBFAMILY A, MEMBER 17A.1-RELATED', 250793),
(407301, 'PTHR23320:SF149', NULL, NULL, NULL, NULL, 'MEMBRANE-SPANNING 4-DOMAINS SUBFAMILY A MEMBER 3-LIKE', 250793),
(407302, 'PTHR23320:SF148', NULL, NULL, NULL, NULL, 'MEMBRANE-SPANNING 4-DOMAINS SUBFAMILY A MEMBER 4A-LIKE', 250793),
(407303, 'PTHR23320:SF125', NULL, NULL, NULL, NULL, 'SI:DKEY-7J14.5-RELATED', 250793),
(407304, 'PTHR23320:SF168', NULL, NULL, NULL, NULL, '', 250793),
(407305, 'PTHR23320:SF146', NULL, NULL, NULL, NULL, 'MEMBRANE-SPANNING 4-DOMAINS SUBFAMILY A MEMBER 6D', 250793),
(407306, 'PTHR23320:SF133', NULL, NULL, NULL, NULL, 'SI:CH211-269K10.5', 250793),
(407307, 'PTHR23320:SF155', NULL, NULL, NULL, NULL, 'MEMBRANE-SPANNING 4-DOMAINS SUBFAMILY A MEMBER 8', 250793),
(407308, 'PTHR23320:SF8', NULL, NULL, NULL, NULL, 'MEMBRANE-SPANNING 4-DOMAINS SUBFAMILY A MEMBER 7', 250793),
(407309, 'PTHR23320:SF153', NULL, NULL, NULL, NULL, 'MEMBRANE-SPANNING 4-DOMAINS SUBFAMILY A MEMBER 6E', 250793),
(407310, 'PTHR23320:SF95', NULL, NULL, NULL, NULL, '', 250793),
(407311, 'PTHR23320:SF152', NULL, NULL, NULL, NULL, '', 250793),
(407312, 'PTHR23320:SF130', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 212', 250793),
(407313, 'PTHR23320:SF5', NULL, NULL, NULL, NULL, 'MEMBRANE-SPANNING 4-DOMAINS SUBFAMILY A MEMBER 10', 250793),
(407314, 'PTHR23320:SF51', NULL, NULL, NULL, NULL, 'MEMBRANE-SPANNING 4-DOMAINS SUBFAMILY A MEMBER 15', 250793),
(407315, 'PTHR23320:SF72', NULL, NULL, NULL, NULL, 'MEMBRANE-SPANNING 4-DOMAINS SUBFAMILY A MEMBER 12', 250793),
(407316, 'PTHR23320:SF151', NULL, NULL, NULL, NULL, 'MEMBRANE-SPANNING 4-DOMAINS SUBFAMILY A MEMBER 3-LIKE', 250793),
(407317, 'PTHR23320:SF150', NULL, NULL, NULL, NULL, 'MEMBRANE-SPANNING 4-DOMAINS SUBFAMILY A MEMBER 6B', 250793),
(407318, 'PTHR23320:SF10', NULL, NULL, NULL, NULL, 'MEMBRANE-SPANNING 4-DOMAINS SUBFAMILY A MEMBER 14', 250793),
(407319, 'PTHR23320:SF54', NULL, NULL, NULL, NULL, 'MEMBRANE-SPANNING 4-DOMAINS SUBFAMILY A MEMBER 5', 250793),
(407320, 'PTHR23320:SF74', NULL, NULL, NULL, NULL, 'MEMBRANE-SPANNING 4-DOMAINS SUBFAMILY A MEMBER 3', 250793),
(407321, 'PTHR23320:SF96', NULL, NULL, NULL, NULL, 'CHANDRA PROTEIN-RELATED', 250793),
(407322, 'PTHR23320:SF37', NULL, NULL, NULL, NULL, 'MEMBRANE-SPANNING 4-DOMAINS SUBFAMILY A MEMBER 18', 250793),
(407323, 'PTHR23320:SF159', NULL, NULL, NULL, NULL, '', 250793),
(407324, 'PTHR23320:SF158', NULL, NULL, NULL, NULL, 'ZGC:113425', 250793),
(407325, 'PTHR23320:SF79', NULL, NULL, NULL, NULL, 'B-LYMPHOCYTE ANTIGEN CD20', 250793),
(407326, 'PTHR23320:SF157', NULL, NULL, NULL, NULL, 'SI:CH1073-291C23.2', 250793),
(407327, 'PTHR23320:SF135', NULL, NULL, NULL, NULL, 'MEMBRANE-SPANNING 4-DOMAINS SUBFAMILY A MEMBER 6A', 250793);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(407328, 'PTHR46945:SF3', NULL, NULL, NULL, NULL, 'CYSTATIN E2', 250794),
(407329, 'PTHR46945:SF4', NULL, NULL, NULL, NULL, 'CYSTATIN-9', 250794),
(407330, 'PTHR46945', NULL, NULL, NULL, NULL, 'CYSTATIN-9-LIKE', 250794),
(407331, 'PTHR46945:SF1', NULL, NULL, NULL, NULL, 'CYSTATIN-9-LIKE', 250794),
(407332, 'PTHR46945:SF2', NULL, NULL, NULL, NULL, 'CYSTATIN-9-LIKE PROTEIN CST9LP1-RELATED', 250794),
(407333, 'PTHR37738', NULL, NULL, NULL, NULL, 'OS03G0209700 PROTEIN', 250795),
(407334, 'PTHR37738:SF1', NULL, NULL, NULL, NULL, 'OS03G0209700 PROTEIN', 250795),
(407335, 'PTHR30265:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ANTITERMINATION PROTEIN RFAH', 250796),
(407336, 'PTHR30265:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION/ANTITERMINATION PROTEIN NUSG', 250796),
(407337, 'PTHR30265:SF4', NULL, NULL, NULL, NULL, 'KOW MOTIF FAMILY PROTEIN, EXPRESSED', 250796),
(407338, 'PTHR30265', NULL, NULL, NULL, NULL, 'RHO-INTERACTING TRANSCRIPTION TERMINATION FACTOR NUSG', 250796),
(407339, 'PTHR31399:SF0', NULL, NULL, NULL, NULL, 'DNA-DIRECTED PRIMASE/POLYMERASE PROTEIN', 250797),
(407340, 'PTHR31399', NULL, NULL, NULL, NULL, 'DNA-DIRECTED PRIMASE / POLYMERASE PROTEIN', 250797),
(407341, 'PTHR18896:SF67', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407342, 'PTHR18896:SF65', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D BETA 1', 250798),
(407343, 'PTHR18896:SF188', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407344, 'PTHR18896:SF189', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407345, 'PTHR18896:SF186', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407346, 'PTHR18896:SF187', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D ALPHA 1', 250798),
(407347, 'PTHR18896:SF140', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407348, 'PTHR18896:SF61', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407349, 'PTHR18896:SF60', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407350, 'PTHR18896:SF148', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D BETA 2', 250798),
(407351, 'PTHR18896:SF193', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407352, 'PTHR18896:SF194', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407353, 'PTHR18896:SF191', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407354, 'PTHR18896:SF192', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407355, 'PTHR18896:SF190', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407356, 'PTHR18896:SF76', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE', 250798),
(407357, 'PTHR18896:SF156', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407358, 'PTHR18896:SF153', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407359, 'PTHR18896:SF197', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE', 250798),
(407360, 'PTHR18896:SF195', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D C', 250798),
(407361, 'PTHR18896:SF73', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407362, 'PTHR18896:SF196', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407363, 'PTHR18896:SF70', NULL, NULL, NULL, NULL, 'OS02G0120200 PROTEIN', 250798),
(407364, 'PTHR18896:SF115', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D ALPHA 3', 250798),
(407365, 'PTHR18896:SF160', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407366, 'PTHR18896:SF161', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407367, 'PTHR18896:SF168', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407368, 'PTHR18896', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407369, 'PTHR18896:SF124', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407370, 'PTHR18896:SF169', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407371, 'PTHR18896:SF166', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407372, 'PTHR18896:SF164', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407373, 'PTHR18896:SF121', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D2', 250798),
(407374, 'PTHR18896:SF86', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D DELTA', 250798),
(407375, 'PTHR18896:SF162', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407376, 'PTHR18896:SF163', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(407377, 'PTHR18896:SF128', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE', 250798),
(407378, 'PTHR18896:SF129', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407379, 'PTHR18896:SF171', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407380, 'PTHR18896:SF172', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407381, 'PTHR18896:SF135', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407382, 'PTHR18896:SF57', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D1', 250798),
(407383, 'PTHR18896:SF133', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D ZETA 2', 250798),
(407384, 'PTHR18896:SF177', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D ALPHA 2', 250798),
(407385, 'PTHR18896:SF134', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407386, 'PTHR18896:SF175', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407387, 'PTHR18896:SF176', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407388, 'PTHR18896:SF130', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D GAMMA 1-RELATED', 250798),
(407389, 'PTHR18896:SF137', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D ALPHA 4', 250798),
(407390, 'PTHR18896:SF138', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407391, 'PTHR18896:SF182', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D A', 250798),
(407392, 'PTHR18896:SF180', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407393, 'PTHR18896:SF181', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', 250798),
(407394, 'PTHR18896:SF59', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D ALPHA 2', 250798),
(407395, 'PTHR46111:SF2', NULL, NULL, NULL, NULL, 'SAM-DEPENDENT METHYLTRANSFERASE', 250799),
(407396, 'PTHR46111:SF1', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA SMALL SUBUNIT METHYLTRANSFERASE I', 250799),
(407397, 'PTHR46111', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA SMALL SUBUNIT METHYLTRANSFERASE I', 250799),
(407398, 'PTHR39455:SF1', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN ZAPD', 250800),
(407399, 'PTHR39455', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN ZAPD', 250800),
(407400, 'PTHR33728:SF13', NULL, NULL, NULL, NULL, 'CTTNBP 2 AMINO-TERMINAL-LIKE PROTEIN', 250801),
(407401, 'PTHR33728:SF16', NULL, NULL, NULL, NULL, 'BNAA08G25440D PROTEIN', 250801),
(407402, 'PTHR33728:SF18', NULL, NULL, NULL, NULL, '', 250801),
(407403, 'PTHR33728:SF19', NULL, NULL, NULL, NULL, '', 250801),
(407404, 'PTHR33728:SF20', NULL, NULL, NULL, NULL, '', 250801),
(407405, 'PTHR33728:SF10', NULL, NULL, NULL, NULL, '', 250801),
(407406, 'PTHR33728:SF7', NULL, NULL, NULL, NULL, 'OS05G0426800 PROTEIN', 250801),
(407407, 'PTHR33728', NULL, NULL, NULL, NULL, 'CTTNBP 2 AMINO-TERMINAL-LIKE PROTEIN', 250801),
(407408, 'PTHR33728:SF21', NULL, NULL, NULL, NULL, '', 250801),
(407409, 'PTHR33728:SF11', NULL, NULL, NULL, NULL, 'BNAA01G35980D PROTEIN', 250801),
(407410, 'PTHR33728:SF12', NULL, NULL, NULL, NULL, 'BNAC08G13880D PROTEIN', 250801),
(407411, 'PTHR33728:SF3', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN', 250801),
(407412, 'PTHR33728:SF5', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 250801),
(407413, 'PTHR38543:SF1', NULL, NULL, NULL, NULL, 'OS04G0465800 PROTEIN', 250802),
(407414, 'PTHR38543', NULL, NULL, NULL, NULL, 'OS04G0465800 PROTEIN', 250802),
(407415, 'PTHR23121:SF26', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY DOMAIN-CONTAINING 4B4', 250803),
(407416, 'PTHR23121:SF17', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT GLUCOSE TRANSPORTER 1A', 250803),
(407417, 'PTHR23121:SF11', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY DOMAIN-CONTAINING 4B5', 250803),
(407418, 'PTHR23121', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT GLUCOSE TRANSPORTER 1', 250803),
(407419, 'PTHR23121:SF9', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT GLUCOSE TRANSPORTER 1', 250803),
(407420, 'PTHR23121:SF10', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY DOMAIN-CONTAINING PROTEIN 4A', 250803),
(407421, 'PTHR22420:SF4', NULL, NULL, NULL, NULL, '', 250804),
(407422, 'PTHR22420:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM81A', 250804),
(407423, 'PTHR22420', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 250804),
(407424, 'PTHR22420:SF5', NULL, NULL, NULL, NULL, 'PROTEIN FAM81B', 250804);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(407425, 'PTHR48191:SF2', NULL, NULL, NULL, NULL, 'PROTEIN HHL1, CHLOROPLASTIC', 250805),
(407426, 'PTHR48191', NULL, NULL, NULL, NULL, 'PROTEIN HHL1 CHLOROPLASTIC', 250805),
(407427, 'PTHR11801:SF19', NULL, NULL, NULL, NULL, 'SIGNAL TRANSDUCER AND ACTIVATOR OF TRANSCRIPTION 4', 250806),
(407428, 'PTHR11801:SF18', NULL, NULL, NULL, NULL, 'SIGNAL TRANSDUCER AND ACTIVATOR OF TRANSCRIPTION 1-ALPHA/BETA', 250806),
(407429, 'PTHR11801:SF39', NULL, NULL, NULL, NULL, 'SIGNAL TRANSDUCER AND ACTIVATOR OF TRANSCRIPTION 5B', 250806),
(407430, 'PTHR11801:SF49', NULL, NULL, NULL, NULL, 'SIGNAL TRANSDUCER AND ACTIVATOR OF TRANSCRIPTION B', 250806),
(407431, 'PTHR11801:SF48', NULL, NULL, NULL, NULL, 'SIGNAL TRANSDUCER AND ACTIVATOR OF TRANSCRIPTION 6', 250806),
(407432, 'PTHR11801:SF47', NULL, NULL, NULL, NULL, 'SIGNAL TRANSDUCER AND ACTIVATOR OF TRANSCRIPTION 5A', 250806),
(407433, 'PTHR11801:SF68', NULL, NULL, NULL, NULL, 'PROTEIN CBG06214', 250806),
(407434, 'PTHR11801:SF2', NULL, NULL, NULL, NULL, 'SIGNAL TRANSDUCER AND ACTIVATOR OF TRANSCRIPTION 3', 250806),
(407435, 'PTHR11801:SF67', NULL, NULL, NULL, NULL, '', 250806),
(407436, 'PTHR11801:SF66', NULL, NULL, NULL, NULL, 'SIGNAL TRANSDUCER AND ACTIVATOR OF TRANSCRIPTION', 250806),
(407437, 'PTHR11801:SF65', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', 250806),
(407438, 'PTHR11801:SF43', NULL, NULL, NULL, NULL, 'SIGNAL TRANSDUCER AND TRANSCRIPTION ACTIVATOR', 250806),
(407439, 'PTHR11801:SF41', NULL, NULL, NULL, NULL, 'SIGNAL TRANSDUCER AND ACTIVATOR OF TRANSCRIPTION 2', 250806),
(407440, 'PTHR11801:SF50', NULL, NULL, NULL, NULL, 'SIGNAL TRANSDUCER AND ACTIVATOR OF TRANSCRIPTION C', 250806),
(407441, 'PTHR11801', NULL, NULL, NULL, NULL, 'SIGNAL TRANSDUCER AND ACTIVATOR OF TRANSCRIPTION', 250806),
(407442, 'PTHR46987:SF5', NULL, NULL, NULL, NULL, 'R-SPONDIN-1', 250807),
(407443, 'PTHR46987', NULL, NULL, NULL, NULL, 'NEUROHYPOPHYSIAL HORMONES, N-TERMINAL DOMAIN CONTAINING PROTEIN', 250807),
(407444, 'PTHR46987:SF6', NULL, NULL, NULL, NULL, 'R-SPONDIN-4', 250807),
(407445, 'PTHR46987:SF7', NULL, NULL, NULL, NULL, 'NEUROHYPOPHYSIAL HORMONES, N-TERMINAL DOMAIN CONTAINING PROTEIN', 250807),
(407446, 'PTHR46987:SF1', NULL, NULL, NULL, NULL, 'R-SPONDIN-3', 250807),
(407447, 'PTHR46987:SF4', NULL, NULL, NULL, NULL, 'R-SPONDIN-2', 250807),
(407448, 'PTHR43525', NULL, NULL, NULL, NULL, 'PROTEIN MALY', 250808),
(407449, 'PTHR43525:SF1', NULL, NULL, NULL, NULL, 'PROTEIN MALY', 250808),
(407450, 'PTHR43525:SF2', NULL, NULL, NULL, NULL, 'CYSTATHIONINE BETA-LYASE-RELATED', 250808),
(407451, 'PTHR34678:SF4', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN 5 ALPHA, CHLOROPLASTIC-LIKE', 250809),
(407452, 'PTHR34678:SF3', NULL, NULL, NULL, NULL, 'BNAC04G24780D PROTEIN', 250809),
(407453, 'PTHR34678:SF2', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN 5 GAMMA, CHLOROPLASTIC', 250809),
(407454, 'PTHR34678', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN 5, CHLOROPLASTIC', 250809),
(407455, 'PTHR34678:SF1', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN 5, CHLOROPLASTIC', 250809),
(407456, 'PTHR33594', NULL, NULL, NULL, NULL, 'SUPERFAMILY HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G03035)-RELATED', 250810),
(407457, 'PTHR33594:SF1', NULL, NULL, NULL, NULL, 'HD DOMAIN-CONTAINING PROTEIN', 250810),
(407458, 'PTHR40087', NULL, NULL, NULL, NULL, 'PHENOLIC ACID DECARBOXYLASE PADC', 250811),
(407459, 'PTHR40087:SF1', NULL, NULL, NULL, NULL, 'PHENOLIC ACID DECARBOXYLASE PADC', 250811),
(407460, 'PTHR10570:SF5', NULL, NULL, NULL, NULL, 'T-CELL SURFACE GLYCOPROTEIN CD3 DELTA CHAIN', 250812),
(407461, 'PTHR10570:SF9', NULL, NULL, NULL, NULL, 'T-CELL SURFACE GLYCOPROTEIN CD3 EPSILON CHAIN', 250812),
(407462, 'PTHR10570:SF8', NULL, NULL, NULL, NULL, 'T-CELL SURFACE GLYCOPROTEIN CD3 GAMMA CHAIN', 250812),
(407463, 'PTHR10570', NULL, NULL, NULL, NULL, 'T-CELL SURFACE GLYCOPROTEIN CD3 GAMMA CHAIN / DELTA CHAIN', 250812),
(407464, 'PTHR48142', NULL, NULL, NULL, NULL, 'PIGMENTOSA GTPASE REGULATOR-LIKE PROTEIN, PUTATIVE-RELATED', 250813),
(407465, 'PTHR48142:SF1', NULL, NULL, NULL, NULL, 'MULE DOMAIN-CONTAINING PROTEIN', 250813);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(407466, 'PTHR18847:SF0', NULL, NULL, NULL, NULL, 'NUCLEAR CAP-BINDING PROTEIN SUBUNIT 2', 250814),
(407467, 'PTHR18847:SF6', NULL, NULL, NULL, NULL, 'NUCLEAR CAP-BINDING PROTEIN SUBUNIT 2', 250814),
(407468, 'PTHR18847:SF5', NULL, NULL, NULL, NULL, 'NUCLEAR CAP-BINDING PROTEIN SUBUNIT 2-LIKE', 250814),
(407469, 'PTHR18847:SF4', NULL, NULL, NULL, NULL, 'NUCLEAR CAP-BINDING PROTEIN SUBUNIT 2', 250814),
(407470, 'PTHR18847', NULL, NULL, NULL, NULL, '20 KD NUCLEAR CAP BINDING PROTEIN', 250814),
(407471, 'PTHR40727', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REGULATOR, ENCODED NEXT TO RECA SUPERFAMILY ATPASE-RELATED', 250815),
(407472, 'PTHR40727:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REGULATOR, ENCODED NEXT TO RECA SUPERFAMILY ATPASE-RELATED', 250815),
(407473, 'PTHR10278:SF0', NULL, NULL, NULL, NULL, 'CORTICOTROPIN-RELEASING FACTOR-BINDING PROTEIN', 250816),
(407474, 'PTHR10278', NULL, NULL, NULL, NULL, 'CORTICOTROPIN-RELEASING FACTOR-BINDING PROTEIN', 250816),
(407475, 'PTHR35503', NULL, NULL, NULL, NULL, 'OSJNBA0006M15.15 PROTEIN', 250817),
(407476, 'PTHR35503:SF3', NULL, NULL, NULL, NULL, 'OS07G0624150 PROTEIN', 250817),
(407477, 'PTHR35503:SF4', NULL, NULL, NULL, NULL, '', 250817),
(407478, 'PTHR35503:SF2', NULL, NULL, NULL, NULL, 'OS04G0455700 PROTEIN', 250817),
(407479, 'PTHR36744:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME OXIDASE ASSEMBLY PROTEIN', 250818),
(407480, 'PTHR36744', NULL, NULL, NULL, NULL, 'CYTOCHROME OXIDASE ASSEMBLY PROTEIN', 250818),
(407481, 'PTHR36744:SF3', NULL, NULL, NULL, NULL, '', 250818),
(407482, 'PTHR47716', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 4', 250819),
(407483, 'PTHR47716:SF3', NULL, NULL, NULL, NULL, 'BNAA05G18600D PROTEIN', 250819),
(407484, 'PTHR47716:SF1', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 4', 250819),
(407485, 'PTHR46475:SF12', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN NPR4', 250820),
(407486, 'PTHR46475:SF9', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN NPR3-LIKE ISOFORM X1', 250820),
(407487, 'PTHR46475:SF13', NULL, NULL, NULL, NULL, 'BNAA02G23720D PROTEIN', 250820),
(407488, 'PTHR46475:SF14', NULL, NULL, NULL, NULL, 'BNAA08G14450D PROTEIN', 250820),
(407489, 'PTHR46475:SF7', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN, PUTATIVE-RELATED', 250820),
(407490, 'PTHR46475:SF4', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN AND ANKYRIN REPEAT-CONTAINING PROTEIN NPR3', 250820),
(407491, 'PTHR46475:SF10', NULL, NULL, NULL, NULL, 'NPR1-LIKE PROTEIN 3-RELATED', 250820),
(407492, 'PTHR46475:SF11', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN NPR1', 250820),
(407493, 'PTHR46475:SF2', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN NPR3', 250820),
(407494, 'PTHR46475:SF1', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN NPR2', 250820),
(407495, 'PTHR46475', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN NPR3', 250820),
(407496, 'PTHR35162:SF9', NULL, NULL, NULL, NULL, 'OS02G0176600 PROTEIN', 250821),
(407497, 'PTHR35162:SF11', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT PROTEIN KINASE INHIBITOR EL2', 250821),
(407498, 'PTHR35162', NULL, NULL, NULL, NULL, 'OS08G0516600 PROTEIN', 250821),
(407499, 'PTHR35162:SF1', NULL, NULL, NULL, NULL, 'OS08G0516600 PROTEIN', 250821),
(407500, 'PTHR35162:SF2', NULL, NULL, NULL, NULL, 'OS09G0499300 PROTEIN', 250821),
(407501, 'PTHR35162:SF10', NULL, NULL, NULL, NULL, 'OS06G0659800 PROTEIN', 250821),
(407502, 'PTHR35162:SF6', NULL, NULL, NULL, NULL, '', 250821),
(407503, 'PTHR36040', NULL, NULL, NULL, NULL, 'OS04G0188500 PROTEIN', 250822),
(407504, 'PTHR36040:SF6', NULL, NULL, NULL, NULL, '', 250822),
(407505, 'PTHR36040:SF3', NULL, NULL, NULL, NULL, 'OS04G0188500 PROTEIN', 250822),
(407506, 'PTHR36040:SF5', NULL, NULL, NULL, NULL, 'BNAC01G24170D PROTEIN', 250822),
(407507, 'PTHR36040:SF4', NULL, NULL, NULL, NULL, '', 250822),
(407508, 'PTHR34556', NULL, NULL, NULL, NULL, '', 250823),
(407509, 'PTHR34556:SF2', NULL, NULL, NULL, NULL, 'PROTEIN TAB2 HOMOLOG, CHLOROPLASTIC', 250823),
(407510, 'PTHR46846', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS W-RELATED', 250824),
(407511, 'PTHR46846:SF2', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 250824);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(407512, 'PTHR46846:SF3', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN-RELATED', 250824),
(407513, 'PTHR46862:SF2', NULL, NULL, NULL, NULL, 'OS02G0611400 PROTEIN', 250825),
(407514, 'PTHR46862:SF4', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN CRP1, CHLOROPLASTIC-LIKE ISOFORM X1', 250825),
(407515, 'PTHR46862:SF3', NULL, NULL, NULL, NULL, 'OS07G0661900 PROTEIN', 250825),
(407516, 'PTHR46862', NULL, NULL, NULL, NULL, 'OS07G0661900 PROTEIN', 250825),
(407517, 'PTHR35885:SF1', NULL, NULL, NULL, NULL, '', 250826),
(407518, 'PTHR35885:SF2', NULL, NULL, NULL, NULL, '', 250826),
(407519, 'PTHR35885:SF3', NULL, NULL, NULL, NULL, '', 250826),
(407520, 'PTHR35885', NULL, NULL, NULL, NULL, '', 250826),
(407521, 'PTHR33513:SF2', NULL, NULL, NULL, NULL, '', 250827),
(407522, 'PTHR33513:SF47', NULL, NULL, NULL, NULL, '', 250827),
(407523, 'PTHR33513:SF46', NULL, NULL, NULL, NULL, 'GB|AAF04428.1', 250827),
(407524, 'PTHR33513:SF45', NULL, NULL, NULL, NULL, 'CYTOPLASMIC TRNA 2-THIOLATION PROTEIN 1', 250827),
(407525, 'PTHR33513', NULL, NULL, NULL, NULL, 'OS06G0523300 PROTEIN', 250827),
(407526, 'PTHR33513:SF44', NULL, NULL, NULL, NULL, '', 250827),
(407527, 'PTHR33513:SF4', NULL, NULL, NULL, NULL, 'OS01G0221400 PROTEIN', 250827),
(407528, 'PTHR33513:SF43', NULL, NULL, NULL, NULL, 'OS06G0523300 PROTEIN', 250827),
(407529, 'PTHR33513:SF21', NULL, NULL, NULL, NULL, 'BNAC03G71690D PROTEIN', 250827),
(407530, 'PTHR33513:SF42', NULL, NULL, NULL, NULL, '', 250827),
(407531, 'PTHR33513:SF30', NULL, NULL, NULL, NULL, 'BNAA10G09800D PROTEIN', 250827),
(407532, 'PTHR33513:SF41', NULL, NULL, NULL, NULL, '', 250827),
(407533, 'PTHR33513:SF40', NULL, NULL, NULL, NULL, '', 250827),
(407534, 'PTHR33513:SF19', NULL, NULL, NULL, NULL, 'OS02G0258800 PROTEIN', 250827),
(407535, 'PTHR33513:SF39', NULL, NULL, NULL, NULL, '', 250827),
(407536, 'PTHR33513:SF38', NULL, NULL, NULL, NULL, '', 250827),
(407537, 'PTHR33513:SF48', NULL, NULL, NULL, NULL, 'CYTOPLASMIC TRNA 2-THIOLATION PROTEIN', 250827),
(407538, 'PTHR46493', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP3', 250828),
(407539, 'PTHR46493:SF1', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP3', 250828),
(407540, 'PTHR46874:SF1', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 6', 250829),
(407541, 'PTHR46874', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 6', 250829),
(407542, 'PTHR16839', NULL, NULL, NULL, NULL, 'GALANIN', 250830),
(407543, 'PTHR16839:SF1', NULL, NULL, NULL, NULL, 'GALANIN PEPTIDES', 250830),
(407544, 'PTHR46894:SF1', NULL, NULL, NULL, NULL, 'TSC22 DOMAIN FAMILY PROTEIN 2', 250831),
(407545, 'PTHR46894', NULL, NULL, NULL, NULL, 'TSC22 DOMAIN FAMILY PROTEIN 2', 250831),
(407546, 'PTHR34702', NULL, NULL, NULL, NULL, 'NA(+)/H(+) ANTIPORTER SUBUNIT F1', 250832),
(407547, 'PTHR34702:SF1', NULL, NULL, NULL, NULL, 'NA(+)/H(+) ANTIPORTER SUBUNIT F', 250832),
(407548, 'PTHR39944:SF1', NULL, NULL, NULL, NULL, 'CALDESMON-RELATED PROTEIN', 250833),
(407549, 'PTHR39944', NULL, NULL, NULL, NULL, '', 250833),
(407550, 'PTHR39944:SF3', NULL, NULL, NULL, NULL, 'CLASSICAL ARABINOGALACTAN PROTEIN 9-LIKE', 250833),
(407551, 'PTHR28399', NULL, NULL, NULL, NULL, 'BARTTIN', 250834),
(407552, 'PTHR28399:SF1', NULL, NULL, NULL, NULL, 'BARTTIN', 250834),
(407553, 'PTHR36055', NULL, NULL, NULL, NULL, 'C2H2-LIKE ZINC FINGER PROTEIN', 250835),
(407554, 'PTHR36055:SF1', NULL, NULL, NULL, NULL, 'C2H2-LIKE ZINC FINGER PROTEIN', 250835),
(407555, 'PTHR36055:SF4', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN, PUTATIVE-RELATED', 250835),
(407556, 'PTHR36055:SF5', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 250835),
(407557, 'PTHR30038:SF5', NULL, NULL, NULL, NULL, 'ALDEHYDE FERREDOXIN OXIDOREDUCTASE', 250836),
(407558, 'PTHR30038', NULL, NULL, NULL, NULL, 'ALDEHYDE FERREDOXIN OXIDOREDUCTASE', 250836),
(407559, 'PTHR30038:SF9', NULL, NULL, NULL, NULL, 'ALDEHYDE FERREDOXIN OXIDOREDUCTASE', 250836),
(407560, 'PTHR30038:SF7', NULL, NULL, NULL, NULL, 'TUNGSTEN-CONTAINING GLYCERALDEHYDE-3-PHOSPHATE:FERREDOXIN OXIDOREDUCTASE', 250836);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(407561, 'PTHR30038:SF8', NULL, NULL, NULL, NULL, 'ALDEHYDE FERREDOXIN OXIDOREDUCTASE', 250836),
(407562, 'PTHR30038:SF0', NULL, NULL, NULL, NULL, 'TUNGSTEN-CONTAINING ALDEHYDE FERREDOXIN OXIDOREDUCTASE', 250836),
(407563, 'PTHR23423', NULL, NULL, NULL, NULL, 'ORGANIC SOLUTE TRANSPORTER-RELATED', 250837),
(407564, 'PTHR23423:SF91', NULL, NULL, NULL, NULL, '', 250837),
(407565, 'PTHR23423:SF90', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 184 HOMOLOG DDB_G0284525', 250837),
(407566, 'PTHR23423:SF82', NULL, NULL, NULL, NULL, 'BNAA06G39430D PROTEIN', 250837),
(407567, 'PTHR23423:SF88', NULL, NULL, NULL, NULL, 'PROTEIN LAZ1 HOMOLOG 2', 250837),
(407568, 'PTHR23423:SF21', NULL, NULL, NULL, NULL, 'ORGANIC SOLUTE TRANSPORTER ALPHA-LIKE PROTEIN 3', 250837),
(407569, 'PTHR23423:SF65', NULL, NULL, NULL, NULL, 'SI:DKEY-16N15.6', 250837),
(407570, 'PTHR23423:SF87', NULL, NULL, NULL, NULL, 'ORGANIC SOLUTE TRANSPORTER SUBUNIT ALPHA-RELATED', 250837),
(407571, 'PTHR23423:SF86', NULL, NULL, NULL, NULL, 'OS02G0670000 PROTEIN', 250837),
(407572, 'PTHR23423:SF64', NULL, NULL, NULL, NULL, 'OS04G0563100 PROTEIN', 250837),
(407573, 'PTHR23423:SF63', NULL, NULL, NULL, NULL, 'DUF300 FAMILY PROTEIN', 250837),
(407574, 'PTHR23423:SF69', NULL, NULL, NULL, NULL, 'BNAA05G31380D PROTEIN', 250837),
(407575, 'PTHR23423:SF89', NULL, NULL, NULL, NULL, '', 250837),
(407576, 'PTHR23423:SF28', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 184B', 250837),
(407577, 'PTHR23423:SF27', NULL, NULL, NULL, NULL, 'PROTEIN LAZ1 HOMOLOG 1', 250837),
(407578, 'PTHR23423:SF80', NULL, NULL, NULL, NULL, 'ORGANIC SOLUTE TRANSPORTER SUBUNIT ALPHA', 250837),
(407579, 'PTHR23423:SF73', NULL, NULL, NULL, NULL, 'PROTEIN LAZ1-LIKE ISOFORM X1', 250837),
(407580, 'PTHR23423:SF95', NULL, NULL, NULL, NULL, 'ORGANIC SOLUTE TRANSPORTER OSTALPHA PROTEIN (DUF300)', 250837),
(407581, 'PTHR23423:SF94', NULL, NULL, NULL, NULL, 'PROTEIN LAZ1 ISOFORM X1', 250837),
(407582, 'PTHR23423:SF93', NULL, NULL, NULL, NULL, 'OS07G0244300 PROTEIN', 250837),
(407583, 'PTHR23423:SF92', NULL, NULL, NULL, NULL, '', 250837),
(407584, 'PTHR23423:SF77', NULL, NULL, NULL, NULL, 'PROTEIN LAZ1', 250837),
(407585, 'PTHR23423:SF11', NULL, NULL, NULL, NULL, 'ORGANIC SOLUTE TRANSPORTER SUBUNIT ALPHA', 250837),
(407586, 'PTHR23423:SF76', NULL, NULL, NULL, NULL, 'ORGANIC SOLUTE TRANSPORTER ALPHA-LIKE PROTEIN 2', 250837),
(407587, 'PTHR23423:SF10', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 184C', 250837),
(407588, 'PTHR23423:SF15', NULL, NULL, NULL, NULL, 'ORGANIC SOLUTE TRANSPORTER OSTALPHA PROTEIN (DUF300)', 250837),
(407589, 'PTHR23423:SF59', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 184A', 250837),
(407590, 'PTHR23423:SF14', NULL, NULL, NULL, NULL, 'ORGANIC SOLUTE TRANSPORTER ALPHA-LIKE PROTEIN 1', 250837),
(407591, 'PTHR23423:SF34', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G07250)-RELATED', 250837),
(407592, 'PTHR23423:SF78', NULL, NULL, NULL, NULL, 'ORGANIC SOLUTE TRANSPORTER SUBUNIT ALPHA-RELATED', 250837),
(407593, 'PTHR23423:SF19', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 184E', 250837),
(407594, 'PTHR23423:SF18', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 184 HOMOLOG DDB_G0279555', 250837),
(407595, 'PTHR23423:SF17', NULL, NULL, NULL, NULL, 'IP17403P', 250837),
(407596, 'PTHR12916', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE POLYPEPTIDE VIC-2', 250838),
(407597, 'PTHR12916:SF8', NULL, NULL, NULL, NULL, 'NOTCH RECEPTOR 2-RELATED', 250838),
(407598, 'PTHR12916:SF7', NULL, NULL, NULL, NULL, '', 250838),
(407599, 'PTHR12916:SF4', NULL, NULL, NULL, NULL, 'NEUROGENIC LOCUS NOTCH HOMOLOG PROTEIN 1', 250838),
(407600, 'PTHR12383:SF30', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL INNER MEMBRANE PROTEASE SUBUNIT 1-LIKE', 250839),
(407601, 'PTHR12383', NULL, NULL, NULL, NULL, 'PROTEASE FAMILY S26 MITOCHONDRIAL INNER MEMBRANE PROTEASE-RELATED', 250839),
(407602, 'PTHR12383:SF32', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL INNER MEMBRANE PROTEASE SUBUNIT', 250839),
(407603, 'PTHR12383:SF34', NULL, NULL, NULL, NULL, 'PEPTIDASE S24/S26A/S26B/S26C FAMILY PROTEIN-RELATED', 250839);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(407604, 'PTHR12383:SF33', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL INNER MEMBRANE PROTEASE SUBUNIT 1', 250839),
(407605, 'PTHR12383:SF36', NULL, NULL, NULL, NULL, 'PEPTIDASE S24/S26A/S26B/S26C FAMILY PROTEIN', 250839),
(407606, 'PTHR12383:SF16', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL INNER MEMBRANE PROTEASE SUBUNIT 1', 250839),
(407607, 'PTHR47688:SF1', NULL, NULL, NULL, NULL, 'NLR FAMILY CARD DOMAIN-CONTAINING PROTEIN 4', 250840),
(407608, 'PTHR47688', NULL, NULL, NULL, NULL, 'NLR FAMILY CARD DOMAIN-CONTAINING PROTEIN 4', 250840),
(407609, 'PTHR13450', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 39S RIBOSOMAL PROTEIN L42', 250841),
(407610, 'PTHR13450:SF4', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L42, MITOCHONDRIAL', 250841),
(407611, 'PTHR31751:SF33', NULL, NULL, NULL, NULL, '', 250842),
(407612, 'PTHR31751:SF7', NULL, NULL, NULL, NULL, 'SI:CH211-108C17.2-RELATED', 250842),
(407613, 'PTHR31751', NULL, NULL, NULL, NULL, 'SI:CH211-108C17.2-RELATED-RELATED', 250842),
(407614, 'PTHR46852:SF4', NULL, NULL, NULL, NULL, 'ALKALINE CERAMIDASE 3-LIKE ISOFORM X1', 250843),
(407615, 'PTHR46852:SF5', NULL, NULL, NULL, NULL, 'ALKALINE CERAMIDASE', 250843),
(407616, 'PTHR46852:SF6', NULL, NULL, NULL, NULL, 'CERAMIDASE-RELATED', 250843),
(407617, 'PTHR46852', NULL, NULL, NULL, NULL, 'ALKALINE CERAMIDASE', 250843),
(407618, 'PTHR46852:SF1', NULL, NULL, NULL, NULL, 'ALKALINE PHYTOCERAMIDASE FAMILY PROTEIN, EXPRESSED', 250843),
(407619, 'PTHR46852:SF3', NULL, NULL, NULL, NULL, 'ALKALINE PHYTOCERAMIDASE', 250843),
(407620, 'PTHR16877', NULL, NULL, NULL, NULL, 'HEPCIDIN', 250844),
(407621, 'PTHR16877:SF0', NULL, NULL, NULL, NULL, 'HEPCIDIN', 250844),
(407622, 'PTHR46267', NULL, NULL, NULL, NULL, 'SINGLE MYB HISTONE 4', 250845),
(407623, 'PTHR46267:SF28', NULL, NULL, NULL, NULL, 'MYB-LIKE DNA BINDING DOMAIN CONTAINING PROTEIN', 250845),
(407624, 'PTHR46267:SF19', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 250845),
(407625, 'PTHR46267:SF25', NULL, NULL, NULL, NULL, 'SINGLE MYB HISTONE 5', 250845),
(407626, 'PTHR46267:SF14', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 250845),
(407627, 'PTHR46267:SF13', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 250845),
(407628, 'PTHR46267:SF5', NULL, NULL, NULL, NULL, 'MYB-LIKE DNA-BINDING DOMAIN PROTEIN', 250845),
(407629, 'PTHR46267:SF24', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 250845),
(407630, 'PTHR46267:SF27', NULL, NULL, NULL, NULL, 'TELOMERE REPEAT-BINDING FACTOR 2', 250845),
(407631, 'PTHR46267:SF2', NULL, NULL, NULL, NULL, 'SINGLE MYB HISTONE 1', 250845),
(407632, 'PTHR46267:SF3', NULL, NULL, NULL, NULL, 'TELOMERE REPEAT-BINDING FACTOR 4-RELATED', 250845),
(407633, 'PTHR46267:SF15', NULL, NULL, NULL, NULL, 'SINGLE MYB HISTONE 4', 250845),
(407634, 'PTHR46267:SF26', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 250845),
(407635, 'PTHR46267:SF10', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 250845),
(407636, 'PTHR46267:SF8', NULL, NULL, NULL, NULL, 'TELOMERE REPEAT-BINDING FACTOR 1', 250845),
(407637, 'PTHR46267:SF23', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 250845),
(407638, 'PTHR46267:SF11', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 250845),
(407639, 'PTHR46267:SF22', NULL, NULL, NULL, NULL, 'H15 DOMAIN-CONTAINING PROTEIN', 250845),
(407640, 'PTHR46267:SF7', NULL, NULL, NULL, NULL, 'TELOMERE REPEAT-BINDING FACTOR 3', 250845),
(407641, 'PTHR31937', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 163', 250846),
(407642, 'PTHR31937:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 163', 250846),
(407643, 'PTHR44749', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF RPS4-RLD 1', 250847),
(407644, 'PTHR44749:SF1', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF RPS4-RLD 1', 250847),
(407645, 'PTHR14568:SF10', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 6 SUPERFAMILY MEMBER 1', 250848),
(407646, 'PTHR14568', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE SUPERFAMILY 6 MEMBER 1/2', 250848),
(407647, 'PTHR14568:SF12', NULL, NULL, NULL, NULL, 'ZGC:85843', 250848),
(407648, 'PTHR14568:SF9', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 6 SUPERFAMILY MEMBER 2', 250848);
INSERT INTO "PUBLIC"."MODEL" VALUES
(407649, 'PTHR14568:SF8', NULL, NULL, NULL, NULL, 'EXPERA DOMAIN-CONTAINING PROTEIN', 250848),
(407650, 'PTHR46018:SF7', NULL, NULL, NULL, NULL, 'RIBONUCLEASE Z', 250849),
(407651, 'PTHR46018:SF2', NULL, NULL, NULL, NULL, 'ZINC PHOSPHODIESTERASE ELAC PROTEIN 1', 250849),
(407652, 'PTHR46018:SF3', NULL, NULL, NULL, NULL, 'ARYLSULFATASE', 250849),
(407653, 'PTHR46018:SF4', NULL, NULL, NULL, NULL, 'METALLO-HYDROLASE YHFI-RELATED', 250849),
(407654, 'PTHR46018', NULL, NULL, NULL, NULL, 'ZINC PHOSPHODIESTERASE ELAC PROTEIN 1', 250849),
(407655, 'PTHR31190:SF417', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407656, 'PTHR31190:SF416', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407657, 'PTHR31190:SF419', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407658, 'PTHR31190:SF418', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407659, 'PTHR31190:SF376', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR RAP2-12', 250850),
(407660, 'PTHR31190:SF134', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF098', 250850),
(407661, 'PTHR31190:SF411', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407662, 'PTHR31190:SF257', NULL, NULL, NULL, NULL, 'DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 250850),
(407663, 'PTHR31190:SF378', NULL, NULL, NULL, NULL, 'AP2/EREBP TRANSCRIPTION FACTOR SUPERFAMILY PROTEIN-RELATED', 250850),
(407664, 'PTHR31190:SF410', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF098-LIKE', 250850),
(407665, 'PTHR31190:SF256', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407666, 'PTHR31190:SF377', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 1B', 250850),
(407667, 'PTHR31190:SF413', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF118-LIKE PROTEIN', 250850),
(407668, 'PTHR31190:SF259', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 1B-LIKE', 250850),
(407669, 'PTHR31190:SF412', NULL, NULL, NULL, NULL, 'DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 250850),
(407670, 'PTHR31190:SF258', NULL, NULL, NULL, NULL, 'OS04G0257500 PROTEIN', 250850),
(407671, 'PTHR31190:SF415', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 1A', 250850),
(407672, 'PTHR31190:SF414', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407673, 'PTHR31190:SF96', NULL, NULL, NULL, NULL, 'ETHYLENE RESPONSE FACTOR 2', 250850),
(407674, 'PTHR31190:SF91', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF096-LIKE', 250850),
(407675, 'PTHR31190:SF385', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF113', 250850),
(407676, 'PTHR31190:SF264', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF073', 250850),
(407677, 'PTHR31190:SF384', NULL, NULL, NULL, NULL, 'DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 250850),
(407678, 'PTHR31190:SF142', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR RAP2-3', 250850),
(407679, 'PTHR31190:SF428', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 13-LIKE', 250850),
(407680, 'PTHR31190:SF306', NULL, NULL, NULL, NULL, 'AP2-DOMAIN DNA-BINDING PROTEIN', 250850),
(407681, 'PTHR31190:SF427', NULL, NULL, NULL, NULL, 'OS09G0571700 PROTEIN', 250850),
(407682, 'PTHR31190:SF429', NULL, NULL, NULL, NULL, 'DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 250850),
(407683, 'PTHR31190:SF420', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407684, 'PTHR31190:SF266', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407685, 'PTHR31190:SF144', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407686, 'PTHR31190:SF301', NULL, NULL, NULL, NULL, 'DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 250850),
(407687, 'PTHR31190:SF268', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407688, 'PTHR31190:SF389', NULL, NULL, NULL, NULL, 'ETHYLENE RESPONSIVE TRANSCRIPTION FACTOR 1A', 250850);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(407689, 'PTHR31190:SF422', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF094', 250850),
(407690, 'PTHR31190:SF421', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF110', 250850),
(407691, 'PTHR31190:SF146', NULL, NULL, NULL, NULL, 'OS02G0654700 PROTEIN', 250850),
(407692, 'PTHR31190:SF267', NULL, NULL, NULL, NULL, 'DNA-BINDING DOMAIN PROTEIN', 250850),
(407693, 'PTHR31190:SF424', NULL, NULL, NULL, NULL, 'EREB-LIKE PROTEIN', 250850),
(407694, 'PTHR31190:SF269', NULL, NULL, NULL, NULL, 'AP2-EREBP TRANSCRIPTION FACTOR', 250850),
(407695, 'PTHR31190:SF423', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407696, 'PTHR31190:SF426', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407697, 'PTHR31190:SF305', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407698, 'PTHR31190:SF425', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR RAP2-2', 250850),
(407699, 'PTHR31190:SF271', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407700, 'PTHR31190:SF270', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF071', 250850),
(407701, 'PTHR31190:SF273', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407702, 'PTHR31190:SF396', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407703, 'PTHR31190:SF274', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 13', 250850),
(407704, 'PTHR31190:SF395', NULL, NULL, NULL, NULL, 'ETHYLENE RESPONSE FACTOR', 250850),
(407705, 'PTHR31190', NULL, NULL, NULL, NULL, 'DNA-BINDING DOMAIN', 250850),
(407706, 'PTHR31190:SF353', NULL, NULL, NULL, NULL, 'DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 250850),
(407707, 'PTHR31190:SF235', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 1-RELATED', 250850),
(407708, 'PTHR31190:SF355', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407709, 'PTHR31190:SF358', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ABR1', 250850),
(407710, 'PTHR31190:SF115', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR RAP2-2', 250850),
(407711, 'PTHR31190:SF357', NULL, NULL, NULL, NULL, 'AP2 DOMAIN CLASS TRANSCRIPTION FACTOR', 250850),
(407712, 'PTHR31190:SF118', NULL, NULL, NULL, NULL, 'OS07G0410300 PROTEIN', 250850),
(407713, 'PTHR31190:SF239', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407714, 'PTHR31190:SF238', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407715, 'PTHR31190:SF72', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 15', 250850),
(407716, 'PTHR31190:SF363', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN PROTEIN', 250850),
(407717, 'PTHR31190:SF362', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF118-LIKE', 250850),
(407718, 'PTHR31190:SF406', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR CRF1', 250850),
(407719, 'PTHR31190:SF405', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF113-LIKE', 250850),
(407720, 'PTHR31190:SF408', NULL, NULL, NULL, NULL, 'DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 250850),
(407721, 'PTHR31190:SF407', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407722, 'PTHR31190:SF409', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 2', 250850),
(407723, 'PTHR31190:SF122', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 15-LIKE', 250850),
(407724, 'PTHR31190:SF364', NULL, NULL, NULL, NULL, 'OS09G0309700 PROTEIN', 250850),
(407725, 'PTHR31190:SF125', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407726, 'PTHR31190:SF400', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 1B-LIKE', 250850),
(407727, 'PTHR31190:SF367', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 1B', 250850),
(407728, 'PTHR31190:SF124', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407729, 'PTHR31190:SF402', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(407730, 'PTHR31190:SF401', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF114-LIKE', 250850),
(407731, 'PTHR31190:SF404', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 1', 250850),
(407732, 'PTHR31190:SF129', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 1-LIKE', 250850),
(407733, 'PTHR31190:SF403', NULL, NULL, NULL, NULL, 'AP26', 250850),
(407734, 'PTHR31190:SF89', NULL, NULL, NULL, NULL, 'OS07G0410700 PROTEIN', 250850),
(407735, 'PTHR31190:SF250', NULL, NULL, NULL, NULL, 'DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 250850),
(407736, 'PTHR31190:SF132', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 1B', 250850),
(407737, 'PTHR31190:SF374', NULL, NULL, NULL, NULL, 'AP2 DOMAIN CONTAINING PROTEIN, EXPRESSED', 250850),
(407738, 'PTHR31190:SF218', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407739, 'PTHR31190:SF453', NULL, NULL, NULL, NULL, 'ETHYLENE RESPONSIVE ELEMENT BINDING FACTOR 1-RELATED', 250850),
(407740, 'PTHR31190:SF299', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF096', 250850),
(407741, 'PTHR31190:SF177', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 250850),
(407742, 'PTHR31190:SF452', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407743, 'PTHR31190:SF455', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407744, 'PTHR31190:SF454', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR RAP2-12-LIKE', 250850),
(407745, 'PTHR31190:SF212', NULL, NULL, NULL, NULL, 'DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 250850),
(407746, 'PTHR31190:SF457', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407747, 'PTHR31190:SF215', NULL, NULL, NULL, NULL, 'DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 250850),
(407748, 'PTHR31190:SF336', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407749, 'PTHR31190:SF456', NULL, NULL, NULL, NULL, 'AP2 DOMAIN CLASS TRANSCRIPTION FACTOR', 250850),
(407750, 'PTHR31190:SF338', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 1B', 250850),
(407751, 'PTHR31190:SF459', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ABR1-LIKE ISOFORM X1', 250850),
(407752, 'PTHR31190:SF217', NULL, NULL, NULL, NULL, 'DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 250850),
(407753, 'PTHR31190:SF458', NULL, NULL, NULL, NULL, 'DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 250850),
(407754, 'PTHR31190:SF337', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407755, 'PTHR31190:SF181', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407756, 'PTHR31190:SF185', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR RAP2-2', 250850),
(407757, 'PTHR31190:SF460', NULL, NULL, NULL, NULL, 'AP2 DOMAIN CONTAINING PROTEIN, EXPRESSED', 250850),
(407758, 'PTHR31190:SF220', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407759, 'PTHR31190:SF462', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF112', 250850),
(407760, 'PTHR31190:SF461', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 1', 250850),
(407761, 'PTHR31190:SF101', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407762, 'PTHR31190:SF222', NULL, NULL, NULL, NULL, 'OSJNBA0065H10.2 PROTEIN', 250850),
(407763, 'PTHR31190:SF343', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407764, 'PTHR31190:SF221', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407765, 'PTHR31190:SF223', NULL, NULL, NULL, NULL, 'DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 250850),
(407766, 'PTHR31190:SF102', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407767, 'PTHR31190:SF226', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407768, 'PTHR31190:SF105', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 1B-LIKE', 250850),
(407769, 'PTHR31190:SF349', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF115', 250850);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(407770, 'PTHR31190:SF194', NULL, NULL, NULL, NULL, 'AP2 DOMAIN CONTAINING PROTEIN', 250850),
(407771, 'PTHR31190:SF193', NULL, NULL, NULL, NULL, 'AP2 DOMAIN CLASS TRANSCRIPTION FACTOR', 250850),
(407772, 'PTHR31190:SF350', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407773, 'PTHR31190:SF110', NULL, NULL, NULL, NULL, 'OS07G0227600 PROTEIN', 250850),
(407774, 'PTHR31190:SF352', NULL, NULL, NULL, NULL, 'AP2 DOMAIN CLASS TRANSCRIPTION FACTOR', 250850),
(407775, 'PTHR31190:SF230', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF098-LIKE', 250850),
(407776, 'PTHR31190:SF439', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF105', 250850),
(407777, 'PTHR31190:SF317', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407778, 'PTHR31190:SF438', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF098-LIKE', 250850),
(407779, 'PTHR31190:SF319', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407780, 'PTHR31190:SF431', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF095', 250850),
(407781, 'PTHR31190:SF277', NULL, NULL, NULL, NULL, 'DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 250850),
(407782, 'PTHR31190:SF276', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407783, 'PTHR31190:SF155', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407784, 'PTHR31190:SF430', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407785, 'PTHR31190:SF433', NULL, NULL, NULL, NULL, 'DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 250850),
(407786, 'PTHR31190:SF432', NULL, NULL, NULL, NULL, 'AP2 DOMAIN CLASS TRANSCRIPTION FACTOR', 250850),
(407787, 'PTHR31190:SF435', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR RAP2-12-LIKE', 250850),
(407788, 'PTHR31190:SF314', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 1B-LIKE', 250850),
(407789, 'PTHR31190:SF434', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN PROTEIN', 250850),
(407790, 'PTHR31190:SF437', NULL, NULL, NULL, NULL, 'OS01G0313300 PROTEIN', 250850),
(407791, 'PTHR31190:SF316', NULL, NULL, NULL, NULL, 'DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 250850),
(407792, 'PTHR31190:SF34', NULL, NULL, NULL, NULL, 'OS09G0572000 PROTEIN', 250850),
(407793, 'PTHR31190:SF436', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407794, 'PTHR31190:SF282', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407795, 'PTHR31190:SF281', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407796, 'PTHR31190:SF160', NULL, NULL, NULL, NULL, 'OSJNBA0042L16.9 PROTEIN', 250850),
(407797, 'PTHR31190:SF284', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407798, 'PTHR31190:SF163', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407799, 'PTHR31190:SF286', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407800, 'PTHR31190:SF440', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407801, 'PTHR31190:SF329', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 1B', 250850),
(407802, 'PTHR31190:SF449', NULL, NULL, NULL, NULL, 'ETHYLENE RESPONSE FACTOR', 250850),
(407803, 'PTHR31190:SF442', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407804, 'PTHR31190:SF167', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF112', 250850),
(407805, 'PTHR31190:SF200', NULL, NULL, NULL, NULL, 'AP2/EREBP TRANSCRIPTION FACTOR SUPERFAMILY PROTEIN-RELATED', 250850),
(407806, 'PTHR31190:SF288', NULL, NULL, NULL, NULL, 'OS05G0316800 PROTEIN', 250850),
(407807, 'PTHR31190:SF321', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407808, 'PTHR31190:SF287', NULL, NULL, NULL, NULL, 'DEVELOPMENT RELATED ERF PROTEIN', 250850),
(407809, 'PTHR31190:SF441', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF114', 250850),
(407810, 'PTHR31190:SF444', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(407811, 'PTHR31190:SF443', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 1', 250850),
(407812, 'PTHR31190:SF322', NULL, NULL, NULL, NULL, 'AP2 DOMAIN CONTAINING PROTEIN, EXPRESSED', 250850),
(407813, 'PTHR31190:SF446', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 1-LIKE', 250850),
(407814, 'PTHR31190:SF325', NULL, NULL, NULL, NULL, 'AP2-EREBP TRANSCRIPTION FACTOR', 250850),
(407815, 'PTHR31190:SF44', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR 1', 250850),
(407816, 'PTHR31190:SF324', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ABR1', 250850),
(407817, 'PTHR31190:SF445', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR RAP2-6', 250850),
(407818, 'PTHR31190:SF448', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF096-LIKE', 250850),
(407819, 'PTHR31190:SF447', NULL, NULL, NULL, NULL, 'ETHYLENE RESPONSE FACTOR 163', 250850),
(407820, 'PTHR31190:SF326', NULL, NULL, NULL, NULL, 'AP2-EREBP TRANSCRIPTION FACTOR', 250850),
(407821, 'PTHR31190:SF290', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407822, 'PTHR31190:SF172', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407823, 'PTHR31190:SF171', NULL, NULL, NULL, NULL, 'OS02G0764700 PROTEIN', 250850),
(407824, 'PTHR31190:SF295', NULL, NULL, NULL, NULL, 'DNA BINDING PROTEIN', 250850),
(407825, 'PTHR31190:SF174', NULL, NULL, NULL, NULL, 'ETHYLENE RESPONSE FACTOR', 250850),
(407826, 'PTHR31190:SF173', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED GENES TRANSCRIPTIONAL ACTIVATOR PTI5', 250850),
(407827, 'PTHR31190:SF451', NULL, NULL, NULL, NULL, 'AP2 DOMAIN CLASS TRANSCRIPTION FACTOR', 250850),
(407828, 'PTHR31190:SF450', NULL, NULL, NULL, NULL, 'OS09G0457900 PROTEIN', 250850),
(407829, 'PTHR31190:SF296', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 250850),
(407830, 'PTHR45786:SF7', NULL, NULL, NULL, NULL, 'OS12G0539700 PROTEIN', 250851),
(407831, 'PTHR45786', NULL, NULL, NULL, NULL, 'DNA BINDING PROTEIN-LIKE', 250851),
(407832, 'PTHR45786:SF66', NULL, NULL, NULL, NULL, 'REPA_OB_2 DOMAIN-CONTAINING PROTEIN', 250851),
(407833, 'PTHR45786:SF41', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 250851),
(407834, 'PTHR45786:SF63', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 250851),
(407835, 'PTHR45786:SF52', NULL, NULL, NULL, NULL, 'OS08G0300100 PROTEIN', 250851),
(407836, 'PTHR45786:SF20', NULL, NULL, NULL, NULL, 'HELITRON_LIKE_N DOMAIN-CONTAINING PROTEIN', 250851),
(407837, 'PTHR45786:SF72', NULL, NULL, NULL, NULL, 'HELITRON_LIKE_N DOMAIN-CONTAINING PROTEIN', 250851),
(407838, 'PTHR45786:SF73', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 250851),
(407839, 'PTHR45786:SF70', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 250851),
(407840, 'PTHR45786:SF71', NULL, NULL, NULL, NULL, 'HELITRON_LIKE_N DOMAIN-CONTAINING PROTEIN', 250851),
(407841, 'PTHR45786:SF18', NULL, NULL, NULL, NULL, 'BNAA08G29330D PROTEIN', 250851),
(407842, 'PTHR45786:SF49', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 250851),
(407843, 'PTHR45786:SF17', NULL, NULL, NULL, NULL, 'BNAA07G10120D PROTEIN', 250851),
(407844, 'PTHR45786:SF28', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 250851),
(407845, 'PTHR45786:SF25', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 250851),
(407846, 'PTHR45786:SF69', NULL, NULL, NULL, NULL, 'BNACNNG64570D PROTEIN', 250851),
(407847, 'PTHR45786:SF26', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 250851),
(407848, 'PTHR45786:SF45', NULL, NULL, NULL, NULL, 'REP_FAC-A_C DOMAIN-CONTAINING PROTEIN', 250851),
(407849, 'PTHR45786:SF67', NULL, NULL, NULL, NULL, 'BNAA01G24720D PROTEIN', 250851),
(407850, 'PTHR45786:SF68', NULL, NULL, NULL, NULL, 'OS02G0701800 PROTEIN', 250851),
(407851, 'PTHR45786:SF24', NULL, NULL, NULL, NULL, 'HELITRON_LIKE_N DOMAIN-CONTAINING PROTEIN', 250851),
(407852, 'PTHR46867', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM9-2', 250852); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(407853, 'PTHR46867:SF4', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM9-2', 250852),
(407854, 'PTHR46867:SF5', NULL, NULL, NULL, NULL, 'BNAA09G16830D PROTEIN', 250852),
(407855, 'PTHR46867:SF6', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM9-2-LIKE', 250852),
(407856, 'PTHR46867:SF7', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM9-2-LIKE', 250852),
(407857, 'PTHR46867:SF8', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM9-2-LIKE', 250852),
(407858, 'PTHR46867:SF3', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM9-1', 250852),
(407859, 'PTHR47566:SF1', NULL, NULL, NULL, NULL, 'PROTEIN NUD1', 250853),
(407860, 'PTHR47566', NULL, NULL, NULL, NULL, '', 250853),
(407861, 'PTHR21567', NULL, NULL, NULL, NULL, 'CLASP', 250854),
(407862, 'PTHR21567:SF60', NULL, NULL, NULL, NULL, 'CLASP_N DOMAIN-CONTAINING PROTEIN', 250854),
(407863, 'PTHR21567:SF9', NULL, NULL, NULL, NULL, 'CLIP-ASSOCIATING PROTEIN', 250854),
(407864, 'PTHR21567:SF6', NULL, NULL, NULL, NULL, 'TOG ARRAY REGULATOR OF AXONEMAL MICROTUBULES PROTEIN 1', 250854),
(407865, 'PTHR21567:SF69', NULL, NULL, NULL, NULL, 'TOG DOMAIN-CONTAINING PROTEIN', 250854),
(407866, 'PTHR21567:SF68', NULL, NULL, NULL, NULL, 'CLIP-ASSOCIATED PROTEIN', 250854),
(407867, 'PTHR21567:SF56', NULL, NULL, NULL, NULL, 'PROTEIN CLASP-1', 250854),
(407868, 'PTHR21567:SF34', NULL, NULL, NULL, NULL, 'PROTEIN CLASP-3', 250854),
(407869, 'PTHR21567:SF65', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 250854),
(407870, 'PTHR21567:SF87', NULL, NULL, NULL, NULL, 'CRESCERIN-LIKE PROTEIN CHE-12', 250854),
(407871, 'PTHR21567:SF64', NULL, NULL, NULL, NULL, 'OS02G0816300 PROTEIN', 250854),
(407872, 'PTHR21567:SF86', NULL, NULL, NULL, NULL, 'CLIP-ASSOCIATED PROTEIN-LIKE ISOFORM X1', 250854),
(407873, 'PTHR21567:SF42', NULL, NULL, NULL, NULL, 'TOG ARRAY REGULATOR OF AXONEMAL MICROTUBULES PROTEIN 2', 250854),
(407874, 'PTHR21567:SF74', NULL, NULL, NULL, NULL, 'CLIP-ASSOCIATED PROTEIN-LIKE ISOFORM X1', 250854),
(407875, 'PTHR21567:SF30', NULL, NULL, NULL, NULL, 'CLIP-ASSOCIATING PROTEIN 2', 250854),
(407876, 'PTHR21567:SF62', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 250854),
(407877, 'PTHR21567:SF28', NULL, NULL, NULL, NULL, 'CLIP-ASSOCIATING PROTEIN 1', 250854),
(407878, 'PTHR47734:SF1', NULL, NULL, NULL, NULL, 'T-CELL IMMUNORECEPTOR WITH IG AND ITIM DOMAINS', 250855),
(407879, 'PTHR47734', NULL, NULL, NULL, NULL, 'T-CELL IMMUNORECEPTOR WITH IG AND ITIM DOMAINS PROTEIN, TIGIT', 250855),
(407880, 'PTHR21072', NULL, NULL, NULL, NULL, 'GPI TRANSAMIDASE COMPONENT PIG-S', 250856),
(407881, 'PTHR21072:SF13', NULL, NULL, NULL, NULL, 'GPI TRANSAMIDASE COMPONENT PIG-S', 250856),
(407882, 'PTHR37321:SF1', NULL, NULL, NULL, NULL, 'EXPORTED PROTEIN-RELATED', 250857),
(407883, 'PTHR37321', NULL, NULL, NULL, NULL, 'EXPORTED PROTEIN-RELATED', 250857),
(407884, 'PTHR43082', NULL, NULL, NULL, NULL, 'FERREDOXIN-LIKE', 250858),
(407885, 'PTHR43082:SF1', NULL, NULL, NULL, NULL, 'FERREDOXIN-LIKE PROTEIN FIXX-RELATED', 250858),
(407886, 'PTHR43082:SF3', NULL, NULL, NULL, NULL, 'FERREDOXIN-LIKE PROTEIN YDIT', 250858),
(407887, 'PTHR10145:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR SPT6', 250859),
(407888, 'PTHR10145:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR SPT6', 250859),
(407889, 'PTHR10145', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR SPT6', 250859),
(407890, 'PTHR10145:SF8', NULL, NULL, NULL, NULL, 'POLYRIBONUCLEOTIDE NUCLEOTIDYLTRANSFERASE-RELATED', 250859),
(407891, 'PTHR43046:SF11', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 250860),
(407892, 'PTHR43046:SF12', NULL, NULL, NULL, NULL, 'GDP-MANNOSE MANNOSYL HYDROLASE', 250860),
(407893, 'PTHR43046:SF13', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 250860),
(407894, 'PTHR43046:SF14', NULL, NULL, NULL, NULL, 'MUTT/NUDIX FAMILY PROTEIN', 250860),
(407895, 'PTHR43046:SF2', NULL, NULL, NULL, NULL, 'ADP-RIBOSE PYROPHOSPHATASE YJHB-RELATED', 250860);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(407896, 'PTHR43046', NULL, NULL, NULL, NULL, 'GDP-MANNOSE MANNOSYL HYDROLASE', 250860),
(407897, 'PTHR43046:SF5', NULL, NULL, NULL, NULL, 'CONSERVED MEMBRANE PROTEIN-RELATED', 250860),
(407898, 'PTHR48137:SF2', NULL, NULL, NULL, NULL, '', 250861),
(407899, 'PTHR48137:SF3', NULL, NULL, NULL, NULL, 'PEPTIDE UPSTREAM OPEN READING FRAME 5', 250861),
(407900, 'PTHR48137:SF4', NULL, NULL, NULL, NULL, '', 250861),
(407901, 'PTHR48137:SF6', NULL, NULL, NULL, NULL, 'BNAA07G01900D PROTEIN', 250861),
(407902, 'PTHR48137', NULL, NULL, NULL, NULL, '', 250861),
(407903, 'PTHR19856', NULL, NULL, NULL, NULL, 'WD-REPEATCONTAINING PROTEIN  WDR1', 250862),
(407904, 'PTHR19856:SF1', NULL, NULL, NULL, NULL, 'ACTIN-INTERACTING PROTEIN 1', 250862),
(407905, 'PTHR19856:SF0', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 1', 250862),
(407906, 'PTHR19856:SF5', NULL, NULL, NULL, NULL, 'ACTIN-INTERACTING PROTEIN 1-1', 250862),
(407907, 'PTHR19856:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR WD40-LIKE FAMILY-RELATED', 250862),
(407908, 'PTHR26391', NULL, NULL, NULL, NULL, 'INACTIVE TYROSINE-PROTEIN KINASE 7', 250863),
(407909, 'PTHR26391:SF18', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 250863),
(407910, 'PTHR26391:SF19', NULL, NULL, NULL, NULL, 'PROTEIN KINASE RECEPTOR TIE-1, PUTATIVE-RELATED', 250863),
(407911, 'PTHR46708:SF8', NULL, NULL, NULL, NULL, 'FIBRONECTIN', 250864),
(407912, 'PTHR46708:SF9', NULL, NULL, NULL, NULL, '', 250864),
(407913, 'PTHR46708:SF6', NULL, NULL, NULL, NULL, 'TENASCIN-R', 250864),
(407914, 'PTHR46708:SF7', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR A DOMAIN-CONTAINING PROTEIN 1-LIKE', 250864),
(407915, 'PTHR46708', NULL, NULL, NULL, NULL, 'TENASCIN', 250864),
(407916, 'PTHR46708:SF1', NULL, NULL, NULL, NULL, 'TENASCIN', 250864),
(407917, 'PTHR46708:SF4', NULL, NULL, NULL, NULL, 'FIBRONECTIN', 250864),
(407918, 'PTHR46708:SF5', NULL, NULL, NULL, NULL, 'TENASCIN N', 250864),
(407919, 'PTHR46708:SF2', NULL, NULL, NULL, NULL, 'SUBSTRATE-ADHESION MOLECULE', 250864),
(407920, 'PTHR46708:SF3', NULL, NULL, NULL, NULL, 'TENASCIN-X', 250864),
(407921, 'PTHR24340:SF100', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN CEH-22', 250865),
(407922, 'PTHR24340:SF70', NULL, NULL, NULL, NULL, 'NK7.1, ISOFORM A', 250865),
(407923, 'PTHR24340:SF104', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 250865),
(407924, 'PTHR24340:SF103', NULL, NULL, NULL, NULL, 'NK6 HOMEOBOX 1', 250865),
(407925, 'PTHR24340:SF102', NULL, NULL, NULL, NULL, 'NK HOMEOBOX 4', 250865),
(407926, 'PTHR24340:SF101', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 250865),
(407927, 'PTHR24340:SF31', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN NKX-6.1', 250865),
(407928, 'PTHR24340:SF32', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN NKX-2.3', 250865),
(407929, 'PTHR24340:SF98', NULL, NULL, NULL, NULL, 'NK3 HOMEOBOX 1', 250865),
(407930, 'PTHR24340:SF33', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN NKX-2.1', 250865),
(407931, 'PTHR24340:SF106', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN PNX', 250865),
(407932, 'PTHR24340:SF105', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN CEH-7', 250865),
(407933, 'PTHR24340:SF34', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN NKX-3.2', 250865),
(407934, 'PTHR24340:SF72', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN NKX-2.6', 250865),
(407935, 'PTHR24340:SF73', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN BAGPIPE', 250865),
(407936, 'PTHR24340:SF17', NULL, NULL, NULL, NULL, 'NK1 TRANSCRIPTION FACTOR-RELATED PROTEIN 2', 250865),
(407937, 'PTHR24340', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN NKX', 250865),
(407938, 'PTHR24340:SF35', NULL, NULL, NULL, NULL, 'HGTX, ISOFORM C', 250865),
(407939, 'PTHR24340:SF37', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN SLOU-RELATED', 250865),
(407940, 'PTHR24340:SF38', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN NKX-3.1', 250865),
(407941, 'PTHR24340:SF80', NULL, NULL, NULL, NULL, 'H6 FAMILY HOMEOBOX 3', 250865),
(407942, 'PTHR24340:SF81', NULL, NULL, NULL, NULL, 'H6 FAMILY HOMEOBOX 3B', 250865),
(407943, 'PTHR24340:SF20', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN NKX-6.3', 250865);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(407944, 'PTHR24340:SF21', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN NKX-6.2', 250865),
(407945, 'PTHR24340:SF82', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN VND', 250865),
(407946, 'PTHR24340:SF40', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN NKX-2.4', 250865),
(407947, 'PTHR24340:SF41', NULL, NULL, NULL, NULL, 'MUSCLE-SPECIFIC HOMEOBOX PROTEIN TINMAN-RELATED', 250865),
(407948, 'PTHR24340:SF28', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN NKX-2.5', 250865),
(407949, 'PTHR24340:SF24', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN NKX-2.2', 250865),
(407950, 'PTHR24340:SF26', NULL, NULL, NULL, NULL, 'NK1 TRANSCRIPTION FACTOR-RELATED PROTEIN 1', 250865),
(407951, 'PTHR24340:SF27', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN NKX-2.8', 250865),
(407952, 'PTHR47337:SF1', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 250866),
(407953, 'PTHR47337', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 250866),
(407954, 'PTHR42987:SF4', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDE PEPTIDASE SPPA-RELATED', 250867),
(407955, 'PTHR42987:SF1', NULL, NULL, NULL, NULL, 'PROTEASE SOHB-RELATED', 250867),
(407956, 'PTHR42987', NULL, NULL, NULL, NULL, 'PEPTIDASE S49', 250867),
(407957, 'PTHR42987:SF5', NULL, NULL, NULL, NULL, 'PROTEASE', 250867),
(407958, 'PTHR43717', NULL, NULL, NULL, NULL, 'ANAEROBIC NITRIC OXIDE REDUCTASE FLAVORUBREDOXIN', 250868),
(407959, 'PTHR43717:SF1', NULL, NULL, NULL, NULL, 'ANAEROBIC NITRIC OXIDE REDUCTASE FLAVORUBREDOXIN', 250868),
(407960, 'PTHR38421:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN USGS', 250869),
(407961, 'PTHR38421', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN USGS', 250869),
(407962, 'PTHR35870:SF6', NULL, NULL, NULL, NULL, 'MGS207 PROTEIN', 250870),
(407963, 'PTHR35870:SF1', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G03330)-RELATED', 250870),
(407964, 'PTHR35870', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G03330)-RELATED', 250870),
(407965, 'PTHR35175:SF2', NULL, NULL, NULL, NULL, 'BSL3737 PROTEIN', 250871),
(407966, 'PTHR35175:SF1', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE-RELATED', 250871),
(407967, 'PTHR35175', NULL, NULL, NULL, NULL, '', 250871),
(407968, 'PTHR37613:SF5', NULL, NULL, NULL, NULL, '', 250872),
(407969, 'PTHR37613:SF4', NULL, NULL, NULL, NULL, 'DUF4378 DOMAIN PROTEIN', 250872),
(407970, 'PTHR37613:SF3', NULL, NULL, NULL, NULL, 'DUF4378 DOMAIN-CONTAINING PROTEIN', 250872),
(407971, 'PTHR37613', NULL, NULL, NULL, NULL, 'DUF4378 DOMAIN PROTEIN', 250872),
(407972, 'PTHR35247:SF1', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 43', 250873),
(407973, 'PTHR35247', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 43', 250873),
(407974, 'PTHR46012', NULL, NULL, NULL, NULL, 'IP22168P', 250874),
(407975, 'PTHR46012:SF3', NULL, NULL, NULL, NULL, 'GLUCOSIDE XYLOSYLTRANSFERASE 1', 250874),
(407976, 'PTHR46012:SF2', NULL, NULL, NULL, NULL, 'IP22168P', 250874),
(407977, 'PTHR46012:SF1', NULL, NULL, NULL, NULL, 'GLUCOSIDE XYLOSYLTRANSFERASE 2', 250874),
(407978, 'PTHR47143:SF1', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL CATION CHANNEL PROTEIN PAINLESS', 250875),
(407979, 'PTHR47143', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL CATION CHANNEL PROTEIN PAINLESS', 250875),
(407980, 'PTHR47143:SF2', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 250875),
(407981, 'PTHR14477:SF1', NULL, NULL, NULL, NULL, 'CUB DOMAIN-CONTAINING PROTEIN 1', 250876),
(407982, 'PTHR14477', NULL, NULL, NULL, NULL, 'CUB DOMAIN-CONTAINING PROTEIN 1', 250876),
(407983, 'PTHR46887:SF1', NULL, NULL, NULL, NULL, 'TANDEM C2 DOMAINS NUCLEAR PROTEIN', 250877),
(407984, 'PTHR46887', NULL, NULL, NULL, NULL, 'TANDEM C2 DOMAINS NUCLEAR PROTEIN', 250877),
(407985, 'PTHR10250:SF23', NULL, NULL, NULL, NULL, 'BNAC02G45560D PROTEIN', 250878),
(407986, 'PTHR10250:SF13', NULL, NULL, NULL, NULL, 'MICROSOMAL GLUTATHIONE S-TRANSFERASE 2', 250878),
(407987, 'PTHR10250:SF22', NULL, NULL, NULL, NULL, 'MICROSOMAL GLUTATHIONE S-TRANSFERASE', 250878),
(407988, 'PTHR10250:SF4', NULL, NULL, NULL, NULL, 'LEUKOTRIENE C4 SYNTHASE', 250878);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(407989, 'PTHR10250:SF19', NULL, NULL, NULL, NULL, 'MICROSOMAL GLUTATHIONE S-TRANSFERASE 3B', 250878),
(407990, 'PTHR10250:SF2', NULL, NULL, NULL, NULL, 'ARACHIDONATE 5-LIPOXYGENASE-ACTIVATING PROTEIN', 250878),
(407991, 'PTHR10250', NULL, NULL, NULL, NULL, 'MICROSOMAL GLUTATHIONE S-TRANSFERASE', 250878),
(407992, 'PTHR10250:SF15', NULL, NULL, NULL, NULL, 'MICROSOMAL GLUTATHIONE S-TRANSFERASE-RELATED', 250878),
(407993, 'PTHR10250:SF26', NULL, NULL, NULL, NULL, 'MICROSOMAL GLUTATHIONE S-TRANSFERASE 3', 250878),
(407994, 'PTHR36918:SF1', NULL, NULL, NULL, NULL, 'PROTEIN-EXPORT PROTEIN SECB', 250879),
(407995, 'PTHR36918', NULL, NULL, NULL, NULL, '', 250879),
(407996, 'PTHR34380:SF2', NULL, NULL, NULL, NULL, 'OS01G0656900 PROTEIN', 250880),
(407997, 'PTHR34380:SF1', NULL, NULL, NULL, NULL, 'BNAA03G12380D PROTEIN', 250880),
(407998, 'PTHR34380:SF3', NULL, NULL, NULL, NULL, '', 250880),
(407999, 'PTHR34380:SF6', NULL, NULL, NULL, NULL, '', 250880),
(408000, 'PTHR34380:SF5', NULL, NULL, NULL, NULL, '', 250880),
(408001, 'PTHR34380', NULL, NULL, NULL, NULL, 'BNAA03G12380D PROTEIN', 250880),
(408002, 'PTHR34380:SF8', NULL, NULL, NULL, NULL, '', 250880),
(408003, 'PTHR41244', NULL, NULL, NULL, NULL, 'RHAMNAN SYNTHESIS F', 250881),
(408004, 'PTHR41244:SF1', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 250881),
(408005, 'PTHR22802:SF261', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 10 MEMBER A-RELATED', 250882),
(408006, 'PTHR22802:SF383', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 250882),
(408007, 'PTHR22802:SF11', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 4 MEMBER D', 250882),
(408008, 'PTHR22802:SF14', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 4 MEMBER K', 250882),
(408009, 'PTHR22802:SF428', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN 87-RELATED', 250882),
(408010, 'PTHR22802:SF426', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 4 MEMBER A', 250882),
(408011, 'PTHR22802:SF269', NULL, NULL, NULL, NULL, 'CD209 ANTIGEN-LIKE PROTEIN D', 250882),
(408012, 'PTHR22802:SF346', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 250882),
(408013, 'PTHR22802:SF423', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 4 MEMBER C', 250882),
(408014, 'PTHR22802:SF421', NULL, NULL, NULL, NULL, 'MIP03875P', 250882),
(408015, 'PTHR22802:SF422', NULL, NULL, NULL, NULL, 'AGAP002625-PB', 250882),
(408016, 'PTHR22802:SF345', NULL, NULL, NULL, NULL, 'ASIALOGLYCOPROTEIN RECEPTOR-LIKE 1', 250882),
(408017, 'PTHR22802:SF342', NULL, NULL, NULL, NULL, 'NOVEL PROTEIN WITH A LECTIN C-TYPE DOMAIN', 250882),
(408018, 'PTHR22802:SF221', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN', 250882),
(408019, 'PTHR22802:SF450', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 250882),
(408020, 'PTHR22802:SF451', NULL, NULL, NULL, NULL, 'ASIALOGLYCOPROTEIN RECEPTOR-LIKE 2-RELATED', 250882),
(408021, 'PTHR22802:SF418', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 250882),
(408022, 'PTHR22802:SF416', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 10 MEMBER A', 250882),
(408023, 'PTHR22802:SF414', NULL, NULL, NULL, NULL, 'ANTIGEN PRESENTING CELL LECTIN-LIKE RECEPTOR A1-RELATED', 250882),
(408024, 'PTHR22802:SF379', NULL, NULL, NULL, NULL, 'RCG58956-LIKE', 250882),
(408025, 'PTHR22802:SF377', NULL, NULL, NULL, NULL, 'CD209 ANTIGEN-LIKE PROTEIN 2', 250882),
(408026, 'PTHR22802:SF452', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN-RELATED', 250882),
(408027, 'PTHR22802:SF453', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 250882),
(408028, 'PTHR22802:SF440', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 7 MEMBER A-LIKE', 250882),
(408029, 'PTHR22802:SF240', NULL, NULL, NULL, NULL, 'ASIALOGLYCOPROTEIN RECEPTOR 1', 250882),
(408030, 'PTHR22802:SF449', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 250882),
(408031, 'PTHR22802:SF447', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 250882),
(408032, 'PTHR22802:SF249', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 6 MEMBER A', 250882);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(408033, 'PTHR22802:SF448', NULL, NULL, NULL, NULL, 'CD209F ANTIGEN-RELATED', 250882),
(408034, 'PTHR22802:SF404', NULL, NULL, NULL, NULL, 'SI:DKEY-9I23.4-RELATED', 250882),
(408035, 'PTHR22802:SF445', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 17, MEMBER A', 250882),
(408036, 'PTHR22802:SF368', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN-RELATED', 250882),
(408037, 'PTHR22802:SF402', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 4 MEMBER E', 250882),
(408038, 'PTHR22802:SF325', NULL, NULL, NULL, NULL, 'LOW AFFINITY IMMUNOGLOBULIN EPSILON FC RECEPTOR', 250882),
(408039, 'PTHR22802:SF446', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 250882),
(408040, 'PTHR22802:SF245', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 4 MEMBER G', 250882),
(408041, 'PTHR22802:SF443', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 250882),
(408042, 'PTHR22802:SF444', NULL, NULL, NULL, NULL, 'SI:CH211-125E6.12 PROTEIN-RELATED', 250882),
(408043, 'PTHR22802:SF246', NULL, NULL, NULL, NULL, 'CD209 ANTIGEN-LIKE PROTEIN C', 250882),
(408044, 'PTHR22802:SF441', NULL, NULL, NULL, NULL, 'CD209 ANTIGEN-LIKE PROTEIN A', 250882),
(408045, 'PTHR22802:SF442', NULL, NULL, NULL, NULL, 'REGENERATING FAMILY MEMBER 4', 250882),
(408046, 'PTHR22802:SF197', NULL, NULL, NULL, NULL, 'CD209 ANTIGEN', 250882),
(408047, 'PTHR22802:SF351', NULL, NULL, NULL, NULL, 'IMMUNE-RELATED LECTIN-LIKE RECEPTOR 1-RELATED', 250882),
(408048, 'PTHR22802:SF396', NULL, NULL, NULL, NULL, 'RH54371P', 250882),
(408049, 'PTHR22802:SF394', NULL, NULL, NULL, NULL, 'COLLECTIN-12', 250882),
(408050, 'PTHR22802:SF194', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 250882),
(408051, 'PTHR22802', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN SUPERFAMILY MEMBER', 250882),
(408052, 'PTHR22802:SF438', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 4 MEMBER M', 250882),
(408053, 'PTHR22802:SF439', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN-RELATED', 250882),
(408054, 'PTHR22802:SF238', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 4 MEMBER F', 250882),
(408055, 'PTHR22802:SF434', NULL, NULL, NULL, NULL, 'ANTIGEN PRESENTING CELL LECTIN-LIKE RECEPTOR A2-RELATED', 250882),
(408056, 'PTHR22802:SF237', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN 91', 250882),
(408057, 'PTHR22802:SF278', NULL, NULL, NULL, NULL, 'CD209 ANTIGEN-LIKE PROTEIN B', 250882),
(408058, 'PTHR22802:SF433', NULL, NULL, NULL, NULL, 'ASIALOGLYCOPROTEIN RECEPTOR 2', 250882),
(408059, 'PTHR22802:SF431', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN', 250882),
(408060, 'PTHR32039', NULL, NULL, NULL, NULL, 'MAGNESIUM-CHELATASE SUBUNIT CHLI', 250883),
(408061, 'PTHR32039:SF7', NULL, NULL, NULL, NULL, 'COMPETENCE PROTEIN COMM', 250883),
(408062, 'PTHR32039:SF9', NULL, NULL, NULL, NULL, 'MAGNESIUM-CHELATASE SUBUNIT CHLI-2, CHLOROPLASTIC', 250883),
(408063, 'PTHR32039:SF17', NULL, NULL, NULL, NULL, 'MG-PROTOPORPHYRIN IX CHELATASE', 250883),
(408064, 'PTHR32039:SF18', NULL, NULL, NULL, NULL, 'MAGNESIUM-CHELATASE SUBUNIT CHLI-1, CHLOROPLASTIC', 250883),
(408065, 'PTHR35293:SF9', NULL, NULL, NULL, NULL, 'EGG CELL-SECRETED PROTEIN 1.5', 250884),
(408066, 'PTHR35293', NULL, NULL, NULL, NULL, 'EGG CELL-SECRETED PROTEIN 1.5', 250884),
(408067, 'PTHR35293:SF4', NULL, NULL, NULL, NULL, 'PROLAMIN_LIKE DOMAIN-CONTAINING PROTEIN', 250884),
(408068, 'PTHR35293:SF1', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE, EXPRESSED-RELATED', 250884),
(408069, 'PTHR35293:SF10', NULL, NULL, NULL, NULL, 'EGG CELL-SECRETED PROTEIN 1.2-RELATED', 250884),
(408070, 'PTHR22601:SF9', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORTER 2', 250885),
(408071, 'PTHR22601:SF90', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORTER 4', 250885),
(408072, 'PTHR22601:SF93', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORTER, OPT SUPERFAMILY-RELATED', 250885),
(408073, 'PTHR22601:SF4', NULL, NULL, NULL, NULL, 'PEPTIDE TRANSPORTER MTD1, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G00910)-RELATED', 250885),
(408074, 'PTHR22601:SF50', NULL, NULL, NULL, NULL, 'SMALL OLIGOPEPTIDE TRANSPORTER, OPT FAMILY (AFU_ORTHOLOGUE AFUA_6G10220)', 250885);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(408075, 'PTHR22601:SF94', NULL, NULL, NULL, NULL, '', 250885),
(408076, 'PTHR22601:SF91', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE-RELATED', 250885),
(408077, 'PTHR22601:SF92', NULL, NULL, NULL, NULL, 'OS01G0630200 PROTEIN', 250885),
(408078, 'PTHR22601:SF70', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORTER OPT FAMILY', 250885),
(408079, 'PTHR22601:SF86', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORTER 2-LIKE', 250885),
(408080, 'PTHR22601:SF0', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORTER 7', 250885),
(408081, 'PTHR22601:SF64', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORTER 4-LIKE', 250885),
(408082, 'PTHR22601:SF87', NULL, NULL, NULL, NULL, '', 250885),
(408083, 'PTHR22601:SF65', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORTER 9', 250885),
(408084, 'PTHR22601:SF62', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORTER 1', 250885),
(408085, 'PTHR22601:SF85', NULL, NULL, NULL, NULL, '', 250885),
(408086, 'PTHR22601:SF47', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORTER 3', 250885),
(408087, 'PTHR22601:SF25', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORTER', 250885),
(408088, 'PTHR22601:SF69', NULL, NULL, NULL, NULL, 'OS08G0492000 PROTEIN', 250885),
(408089, 'PTHR22601:SF22', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORTER 6', 250885),
(408090, 'PTHR22601:SF88', NULL, NULL, NULL, NULL, 'OS08G0320200 PROTEIN', 250885),
(408091, 'PTHR22601:SF23', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORTER 2', 250885),
(408092, 'PTHR22601:SF67', NULL, NULL, NULL, NULL, '', 250885),
(408093, 'PTHR22601', NULL, NULL, NULL, NULL, 'ISP4 LIKE PROTEIN', 250885),
(408094, 'PTHR22601:SF82', NULL, NULL, NULL, NULL, 'BNAC03G15000D PROTEIN', 250885),
(408095, 'PTHR22601:SF61', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORTER 5', 250885),
(408096, 'PTHR22601:SF83', NULL, NULL, NULL, NULL, 'SEXUAL DIFFERENTIATION PROCESS PROTEIN ISP4', 250885),
(408097, 'PTHR22601:SF80', NULL, NULL, NULL, NULL, 'OPT FAMILY SMALL OLIGOPEPTIDE TRANSPORTER', 250885),
(408098, 'PTHR22601:SF81', NULL, NULL, NULL, NULL, 'BNAA02G21950D PROTEIN', 250885),
(408099, 'PTHR22601:SF59', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORTER OPT FAMILY PROTEIN', 250885),
(408100, 'PTHR22601:SF97', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G03140)-RELATED', 250885),
(408101, 'PTHR22601:SF53', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORTER 8', 250885),
(408102, 'PTHR22601:SF76', NULL, NULL, NULL, NULL, 'BNACNNG55940D PROTEIN', 250885),
(408103, 'PTHR22601:SF98', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORTER 1', 250885),
(408104, 'PTHR22601:SF95', NULL, NULL, NULL, NULL, '', 250885),
(408105, 'PTHR22601:SF73', NULL, NULL, NULL, NULL, 'BNAA03G12220D PROTEIN', 250885),
(408106, 'PTHR22601:SF96', NULL, NULL, NULL, NULL, '', 250885),
(408107, 'PTHR22601:SF79', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORTER OPT', 250885),
(408108, 'PTHR22601:SF13', NULL, NULL, NULL, NULL, 'OS04G0594800 PROTEIN', 250885),
(408109, 'PTHR22601:SF14', NULL, NULL, NULL, NULL, 'OS06G0127700 PROTEIN', 250885),
(408110, 'PTHR22601:SF11', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORTER 4', 250885),
(408111, 'PTHR22601:SF12', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORTER 7-LIKE', 250885),
(408112, 'PTHR22601:SF78', NULL, NULL, NULL, NULL, 'LOW QUALITY PROTEIN: OLIGOPEPTIDE TRANSPORTER 4-LIKE', 250885),
(408113, 'PTHR36197', NULL, NULL, NULL, NULL, '', 250886),
(408114, 'PTHR36197:SF2', NULL, NULL, NULL, NULL, '', 250886),
(408115, 'PTHR20946', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 250887),
(408116, 'PTHR20946:SF0', NULL, NULL, NULL, NULL, 'DUF3342 DOMAIN-CONTAINING PROTEIN', 250887),
(408117, 'PTHR43156:SF2', NULL, NULL, NULL, NULL, 'PHOSPHOSERINE PHOSPHATASE RSBU', 250888),
(408118, 'PTHR43156:SF13', NULL, NULL, NULL, NULL, 'PHOSPHOSERINE PHOSPHATASE RSBP', 250888),
(408119, 'PTHR43156:SF12', NULL, NULL, NULL, NULL, 'STAGE II SPORULATION PROTEIN E', 250888),
(408120, 'PTHR43156', NULL, NULL, NULL, NULL, 'STAGE II SPORULATION PROTEIN E-RELATED', 250888),
(408121, 'PTHR43156:SF9', NULL, NULL, NULL, NULL, 'HAMP DOMAIN-CONTAINING PROTEIN', 250888);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(408122, 'PTHR46020:SF12', NULL, NULL, NULL, NULL, 'BNAANNG22470D PROTEIN', 250889),
(408123, 'PTHR46020:SF24', NULL, NULL, NULL, NULL, '', 250889),
(408124, 'PTHR46020:SF14', NULL, NULL, NULL, NULL, '', 250889),
(408125, 'PTHR46020:SF25', NULL, NULL, NULL, NULL, 'BNAA09G15670D PROTEIN', 250889),
(408126, 'PTHR46020:SF26', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE', 250889),
(408127, 'PTHR46020:SF15', NULL, NULL, NULL, NULL, '', 250889),
(408128, 'PTHR46020:SF16', NULL, NULL, NULL, NULL, '', 250889),
(408129, 'PTHR46020:SF29', NULL, NULL, NULL, NULL, '', 250889),
(408130, 'PTHR46020:SF18', NULL, NULL, NULL, NULL, 'BNAA09G16180D PROTEIN', 250889),
(408131, 'PTHR46020', NULL, NULL, NULL, NULL, 'OSJNBB0059K02.9 PROTEIN', 250889),
(408132, 'PTHR46020:SF30', NULL, NULL, NULL, NULL, 'ESTERASE/LIPASE PLANT-LIKE PROTEIN, PUTATIVE-RELATED', 250889),
(408133, 'PTHR46020:SF4', NULL, NULL, NULL, NULL, 'OS04G0650200 PROTEIN', 250889),
(408134, 'PTHR46020:SF31', NULL, NULL, NULL, NULL, '', 250889),
(408135, 'PTHR46020:SF5', NULL, NULL, NULL, NULL, '', 250889),
(408136, 'PTHR46020:SF21', NULL, NULL, NULL, NULL, 'BNAC02G03010D PROTEIN', 250889),
(408137, 'PTHR46020:SF32', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 250889),
(408138, 'PTHR46020:SF33', NULL, NULL, NULL, NULL, '', 250889),
(408139, 'PTHR31761:SF1', NULL, NULL, NULL, NULL, 'GROWTH ARREST AND DNA DAMAGE-INDUCIBLE PROTEINS-INTERACTING PROTEIN 1', 250890),
(408140, 'PTHR31761', NULL, NULL, NULL, NULL, 'GROWTH ARREST AND DNA DAMAGE-INDUCIBLE PROTEINS-INTERACTING PROTEIN 1 GADD45GIP1', 250890),
(408141, 'PTHR46994:SF3', NULL, NULL, NULL, NULL, 'NUCLEOSIDE PHOSPHORYLASE-RELATED', 250891),
(408142, 'PTHR46994:SF1', NULL, NULL, NULL, NULL, '5''-METHYLTHIOADENOSINE NUCLEOSIDASE', 250891),
(408143, 'PTHR46994:SF2', NULL, NULL, NULL, NULL, '5''-METHYLTHIOADENOSINE/S-ADENOSYLHOMOCYSTEINE NUCLEOSIDASE', 250891),
(408144, 'PTHR46994', NULL, NULL, NULL, NULL, '5''-METHYLTHIOADENOSINE/S-ADENOSYLHOMOCYSTEINE NUCLEOSIDASE 1', 250891),
(408145, 'PTHR23270:SF11', NULL, NULL, NULL, NULL, '', 250892),
(408146, 'PTHR23270:SF10', NULL, NULL, NULL, NULL, 'PROTEIN RRP5 HOMOLOG', 250892),
(408147, 'PTHR23270', NULL, NULL, NULL, NULL, 'PROGRAMMED CELL DEATH PROTEIN 11  PRE-RRNA PROCESSING PROTEIN RRP5', 250892),
(408148, 'PTHR31301:SF189', NULL, NULL, NULL, NULL, 'LATERAL ORGAN BOUNDARIES (LOB) DOMAIN PROTEIN', 250893),
(408149, 'PTHR31301:SF101', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 250893),
(408150, 'PTHR31301:SF188', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 250893),
(408151, 'PTHR31301:SF144', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 250893),
(408152, 'PTHR31301:SF103', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 5-RELATED', 250893),
(408153, 'PTHR31301:SF185', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN-RELATED', 250893),
(408154, 'PTHR31301:SF184', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 250893),
(408155, 'PTHR31301:SF140', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN-RELATED', 250893),
(408156, 'PTHR31301:SF187', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 250893),
(408157, 'PTHR31301:SF186', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 250893),
(408158, 'PTHR31301:SF181', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 250893),
(408159, 'PTHR31301:SF180', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 250893),
(408160, 'PTHR31301:SF183', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN-RELATED', 250893),
(408161, 'PTHR31301:SF182', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 250893),
(408162, 'PTHR31301:SF76', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 6-LIKE', 250893),
(408163, 'PTHR31301:SF77', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 1-LIKE', 250893),
(408164, 'PTHR31301:SF78', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 13', 250893),
(408165, 'PTHR31301:SF105', NULL, NULL, NULL, NULL, 'LOB DOMAIN PROTEIN', 250893),
(408166, 'PTHR31301:SF148', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 250893);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(408167, 'PTHR31301:SF104', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 1-LIKE', 250893),
(408168, 'PTHR31301:SF74', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 24-LIKE', 250893),
(408169, 'PTHR31301:SF107', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 25-LIKE', 250893),
(408170, 'PTHR31301:SF75', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 7', 250893),
(408171, 'PTHR31301:SF106', NULL, NULL, NULL, NULL, 'PROTEIN LATERAL ORGAN BOUNDARIES-LIKE', 250893),
(408172, 'PTHR31301:SF112', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 22-LIKE', 250893),
(408173, 'PTHR31301:SF158', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 250893),
(408174, 'PTHR31301:SF157', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 250893),
(408175, 'PTHR31301:SF196', NULL, NULL, NULL, NULL, 'OS01G0825000 PROTEIN', 250893),
(408176, 'PTHR31301:SF152', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 250893),
(408177, 'PTHR31301:SF195', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 12', 250893),
(408178, 'PTHR31301:SF198', NULL, NULL, NULL, NULL, 'LATERAL ORGAN BOUNDARIES (LOB) DOMAIN PROTEIN', 250893),
(408179, 'PTHR31301:SF153', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 250893),
(408180, 'PTHR31301:SF197', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 250893),
(408181, 'PTHR31301:SF192', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 250893),
(408182, 'PTHR31301:SF191', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 250893),
(408183, 'PTHR31301:SF150', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 250893),
(408184, 'PTHR31301:SF194', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 250893),
(408185, 'PTHR31301:SF193', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 27', 250893),
(408186, 'PTHR31301:SF190', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 22', 250893),
(408187, 'PTHR31301:SF26', NULL, NULL, NULL, NULL, 'OS05G0417000 PROTEIN', 250893),
(408188, 'PTHR31301:SF21', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 27-RELATED', 250893),
(408189, 'PTHR31301:SF67', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 22', 250893),
(408190, 'PTHR31301:SF68', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 32-RELATED', 250893),
(408191, 'PTHR31301:SF24', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 21', 250893),
(408192, 'PTHR31301:SF116', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 250893),
(408193, 'PTHR31301:SF159', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 23', 250893),
(408194, 'PTHR31301:SF115', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 10', 250893),
(408195, 'PTHR31301:SF123', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 250893),
(408196, 'PTHR31301:SF167', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 4', 250893),
(408197, 'PTHR31301:SF122', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 11', 250893),
(408198, 'PTHR31301:SF166', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 250893),
(408199, 'PTHR31301:SF125', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 250893),
(408200, 'PTHR31301:SF169', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 27', 250893),
(408201, 'PTHR31301:SF163', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 250893),
(408202, 'PTHR31301:SF165', NULL, NULL, NULL, NULL, 'LOB DOMAIN PROTEIN', 250893),
(408203, 'PTHR31301:SF121', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 250893),
(408204, 'PTHR31301:SF120', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 23-RELATED', 250893),
(408205, 'PTHR31301:SF161', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 250893),
(408206, 'PTHR31301', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 4-RELATED', 250893),
(408207, 'PTHR31301:SF19', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 2', 250893),
(408208, 'PTHR31301:SF14', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 1', 250893),
(408209, 'PTHR31301:SF58', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 3', 250893);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(408210, 'PTHR31301:SF15', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 12-LIKE', 250893),
(408211, 'PTHR31301:SF12', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 25', 250893),
(408212, 'PTHR31301:SF95', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 3-LIKE', 250893),
(408213, 'PTHR31301:SF128', NULL, NULL, NULL, NULL, 'STRUCTURE-SPECIFIC ENDONUCLEASE SUBUNIT SLX1 HOMOLOG', 250893),
(408214, 'PTHR31301:SF178', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 36-LIKE', 250893),
(408215, 'PTHR31301:SF133', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 250893),
(408216, 'PTHR31301:SF91', NULL, NULL, NULL, NULL, 'PROTEIN LATERAL ORGAN BOUNDARIES', 250893),
(408217, 'PTHR31301:SF92', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 6', 250893),
(408218, 'PTHR31301:SF179', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 12-LIKE', 250893),
(408219, 'PTHR31301:SF130', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 27-LIKE', 250893),
(408220, 'PTHR31301:SF176', NULL, NULL, NULL, NULL, 'LATERAL ORGAN BOUNDARIES (LOB) DOMAIN PROTEIN', 250893),
(408221, 'PTHR31301:SF132', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 27-LIKE', 250893),
(408222, 'PTHR31301:SF131', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 28', 250893),
(408223, 'PTHR31301:SF170', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN 1, PUTATIVE, EXPRESSED-RELATED', 250893),
(408224, 'PTHR31301:SF87', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 15', 250893),
(408225, 'PTHR31301:SF89', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 1-LIKE', 250893),
(408226, 'PTHR31301:SF83', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 26-RELATED', 250893),
(408227, 'PTHR31301:SF138', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 250893),
(408228, 'PTHR31301:SF84', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN 12, PUTATIVE, EXPRESSED-RELATED', 250893),
(408229, 'PTHR31301:SF137', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 250893),
(408230, 'PTHR22959:SF0', NULL, NULL, NULL, NULL, 'PARTNER OF Y14 AND MAGO', 250894),
(408231, 'PTHR22959:SF1', NULL, NULL, NULL, NULL, 'MAGO-BIND DOMAIN-CONTAINING PROTEIN', 250894),
(408232, 'PTHR22959', NULL, NULL, NULL, NULL, 'PYM PROTEIN', 250894),
(408233, 'PTHR44137:SF51', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 250895),
(408234, 'PTHR44137:SF52', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK N-TERMINAL DOMAIN-CONTAINING PROTEIN', 250895),
(408235, 'PTHR44137:SF31', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 250895),
(408236, 'PTHR44137:SF53', NULL, NULL, NULL, NULL, 'DNAJ DOMAIN CONTAINING PROTEIN, EXPRESSED', 250895),
(408237, 'PTHR44137:SF32', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK AMINO-TERMINAL DOMAIN PROTEIN', 250895),
(408238, 'PTHR44137:SF10', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 250895),
(408239, 'PTHR44137:SF54', NULL, NULL, NULL, NULL, 'DNAJ DOMAIN-CONTAINING PROTEIN-RELATED', 250895),
(408240, 'PTHR44137:SF55', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK N-TERMINAL DOMAIN-CONTAINING PROTEIN', 250895),
(408241, 'PTHR44137:SF34', NULL, NULL, NULL, NULL, 'DNAJ DOMAIN-CONTAINING PROTEIN-RELATED', 250895),
(408242, 'PTHR44137:SF56', NULL, NULL, NULL, NULL, 'OS10G0188200 PROTEIN', 250895),
(408243, 'PTHR44137:SF13', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', 250895),
(408244, 'PTHR44137:SF57', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN PROTEIN', 250895),
(408245, 'PTHR44137:SF35', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK N-TERMINAL DOMAIN-CONTAINING PROTEIN-RELATED', 250895),
(408246, 'PTHR44137:SF58', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 250895),
(408247, 'PTHR44137:SF36', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 250895),
(408248, 'PTHR44137:SF59', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 250895),
(408249, 'PTHR44137:SF37', NULL, NULL, NULL, NULL, 'DNAJ DOMAIN-CONTAINING PROTEIN-RELATED', 250895),
(408250, 'PTHR44137:SF16', NULL, NULL, NULL, NULL, 'OS03G0837400 PROTEIN', 250895);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(408251, 'PTHR44137:SF39', NULL, NULL, NULL, NULL, 'MOLECULAR CHAPERONE HSP40/DNAJ FAMILY PROTEIN', 250895),
(408252, 'PTHR44137:SF60', NULL, NULL, NULL, NULL, 'OS02G0510000 PROTEIN', 250895),
(408253, 'PTHR44137:SF9', NULL, NULL, NULL, NULL, 'OS01G0923800 PROTEIN', 250895),
(408254, 'PTHR44137:SF61', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 250895),
(408255, 'PTHR44137:SF7', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 250895),
(408256, 'PTHR44137:SF20', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 250895),
(408257, 'PTHR44137:SF23', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', 250895),
(408258, 'PTHR44137:SF24', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK N-TERMINAL DOMAIN-CONTAINING PROTEIN', 250895),
(408259, 'PTHR44137:SF25', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 250895),
(408260, 'PTHR44137:SF27', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 250895),
(408261, 'PTHR44137', NULL, NULL, NULL, NULL, 'BNAC03G44070D PROTEIN', 250895),
(408262, 'PTHR44137:SF3', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK N-TERMINAL DOMAIN-CONTAINING PROTEIN', 250895),
(408263, 'PTHR31118:SF31', NULL, NULL, NULL, NULL, '', 250896),
(408264, 'PTHR31118:SF20', NULL, NULL, NULL, NULL, '', 250896),
(408265, 'PTHR31118:SF12', NULL, NULL, NULL, NULL, 'CYCLASE-LIKE PROTEIN 2', 250896),
(408266, 'PTHR31118:SF21', NULL, NULL, NULL, NULL, 'KYNURENINE FORMAMIDASE-LIKE ISOFORM X1', 250896),
(408267, 'PTHR31118:SF32', NULL, NULL, NULL, NULL, 'KYNURENINE FORMAMIDASE', 250896),
(408268, 'PTHR31118:SF27', NULL, NULL, NULL, NULL, 'CYCLASE-LIKE PROTEIN 1', 250896),
(408269, 'PTHR31118:SF16', NULL, NULL, NULL, NULL, 'CYCLASE-LIKE PROTEIN 1-RELATED', 250896),
(408270, 'PTHR31118:SF28', NULL, NULL, NULL, NULL, 'KYNURENINE FORMAMIDASE-RELATED', 250896),
(408271, 'PTHR31118:SF17', NULL, NULL, NULL, NULL, 'CYCLASE-LIKE PROTEIN 4', 250896),
(408272, 'PTHR31118', NULL, NULL, NULL, NULL, 'CYCLASE-LIKE PROTEIN 2', 250896),
(408273, 'PTHR31118:SF25', NULL, NULL, NULL, NULL, 'BNAC09G51580D PROTEIN', 250896),
(408274, 'PTHR31118:SF26', NULL, NULL, NULL, NULL, '', 250896),
(408275, 'PTHR31118:SF18', NULL, NULL, NULL, NULL, 'KYNURENINE FORMAMIDASE-LIKE ISOFORM X1', 250896),
(408276, 'PTHR31118:SF19', NULL, NULL, NULL, NULL, 'KYNURENINE FORMAMIDASE-LIKE PROTEIN', 250896),
(408277, 'PTHR46053:SF2', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 250897),
(408278, 'PTHR46053:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MARCHF11', 250897),
(408279, 'PTHR46053:SF4', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MARCHF9', 250897),
(408280, 'PTHR46053:SF3', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MARCHF4', 250897),
(408281, 'PTHR46053', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MARCH4-LIKE', 250897),
(408282, 'PTHR42968:SF9', NULL, NULL, NULL, NULL, 'WD REPEAT DOMAIN 87', 250898),
(408283, 'PTHR42968', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING', 250898),
(408284, 'PTHR42968:SF38', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 87', 250898),
(408285, 'PTHR42968:SF28', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 250898),
(408286, 'PTHR21563:SF3', NULL, NULL, NULL, NULL, 'ZINC FINGER C3H1 DOMAIN-CONTAINING PROTEIN', 250899),
(408287, 'PTHR21563', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 250899),
(408288, 'PTHR44888', NULL, NULL, NULL, NULL, 'HEPACAM FAMILY MEMBER 2-RELATED', 250900),
(408289, 'PTHR44888:SF2', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 250900),
(408290, 'PTHR44888:SF1', NULL, NULL, NULL, NULL, 'HEPACAM FAMILY MEMBER 2', 250900),
(408291, 'PTHR31132:SF22', NULL, NULL, NULL, NULL, 'DUF4057 DOMAIN-CONTAINING PROTEIN', 250901),
(408292, 'PTHR31132:SF5', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250901),
(408293, 'PTHR31132:SF21', NULL, NULL, NULL, NULL, 'DUF4057 DOMAIN-CONTAINING PROTEIN', 250901),
(408294, 'PTHR31132:SF13', NULL, NULL, NULL, NULL, 'N-LYSINE METHYLTRANSFERASE', 250901),
(408295, 'PTHR31132:SF24', NULL, NULL, NULL, NULL, 'DUF4057 DOMAIN-CONTAINING PROTEIN', 250901);
INSERT INTO "PUBLIC"."MODEL" VALUES
(408296, 'PTHR31132:SF23', NULL, NULL, NULL, NULL, 'OS02G0574600 PROTEIN', 250901),
(408297, 'PTHR31132:SF12', NULL, NULL, NULL, NULL, 'OS07G0623600 PROTEIN', 250901),
(408298, 'PTHR31132:SF2', NULL, NULL, NULL, NULL, 'HEMATOLOGICAL/NEUROLOGICAL-LIKE PROTEIN', 250901),
(408299, 'PTHR31132:SF15', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250901),
(408300, 'PTHR31132:SF14', NULL, NULL, NULL, NULL, 'DUF4057 DOMAIN-CONTAINING PROTEIN', 250901),
(408301, 'PTHR31132:SF17', NULL, NULL, NULL, NULL, 'BNAANNG04510D PROTEIN', 250901),
(408302, 'PTHR31132:SF19', NULL, NULL, NULL, NULL, 'DUF4057 DOMAIN-CONTAINING PROTEIN', 250901),
(408303, 'PTHR31132', NULL, NULL, NULL, NULL, 'N-LYSINE METHYLTRANSFERASE', 250901),
(408304, 'PTHR33546:SF1', NULL, NULL, NULL, NULL, 'LARGE, MULTIFUNCTIONAL SECRETED PROTEIN-RELATED', 250902),
(408305, 'PTHR33546', NULL, NULL, NULL, NULL, 'LARGE, MULTIFUNCTIONAL SECRETED PROTEIN-RELATED', 250902),
(408306, 'PTHR35675:SF1', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC100362216', 250903),
(408307, 'PTHR35675', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC100362216', 250903),
(408308, 'PTHR28234', NULL, NULL, NULL, NULL, 'NUCLEAR CONTROL OF ATPASE PROTEIN 2', 250904),
(408309, 'PTHR28234:SF1', NULL, NULL, NULL, NULL, 'NUCLEAR CONTROL OF ATPASE PROTEIN 2', 250904),
(408310, 'PTHR12827', NULL, NULL, NULL, NULL, 'MEIOTIC CHECKPOINT REGULATOR TSG24 FAMILY MEMBER', 250905),
(408311, 'PTHR12827:SF5', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT 1', 250905),
(408312, 'PTHR12827:SF3', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT 1', 250905),
(408313, 'PTHR33091:SF110', NULL, NULL, NULL, NULL, 'GLU S.GRISEUS PROTEASE INHIBITOR-LIKE', 250906),
(408314, 'PTHR33091:SF112', NULL, NULL, NULL, NULL, '', 250906),
(408315, 'PTHR33091:SF29', NULL, NULL, NULL, NULL, 'SUBTILISIN INHIBITOR 1', 250906),
(408316, 'PTHR33091:SF111', NULL, NULL, NULL, NULL, 'PROTEINASE INHIBITOR', 250906),
(408317, 'PTHR33091:SF66', NULL, NULL, NULL, NULL, 'SUBTILISIN INHIBITOR 1', 250906),
(408318, 'PTHR33091:SF65', NULL, NULL, NULL, NULL, 'WOUND-INDUCED PROTEINASE INHIBITOR 1', 250906),
(408319, 'PTHR33091:SF69', NULL, NULL, NULL, NULL, '', 250906),
(408320, 'PTHR33091:SF60', NULL, NULL, NULL, NULL, '', 250906),
(408321, 'PTHR33091:SF107', NULL, NULL, NULL, NULL, 'TYPE I SERINE PROTEASE INHIBITOR', 250906),
(408322, 'PTHR33091:SF106', NULL, NULL, NULL, NULL, '', 250906),
(408323, 'PTHR33091:SF109', NULL, NULL, NULL, NULL, 'GLU S.GRISEUS PROTEASE INHIBITOR-RELATED', 250906),
(408324, 'PTHR33091:SF108', NULL, NULL, NULL, NULL, 'OS01G0615100 PROTEIN', 250906),
(408325, 'PTHR33091:SF103', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR, POTATO INHIBITOR I-TYPE FAMILY PROTEIN', 250906),
(408326, 'PTHR33091:SF104', NULL, NULL, NULL, NULL, '', 250906),
(408327, 'PTHR33091:SF101', NULL, NULL, NULL, NULL, 'INHIBITOR OF TRYPSIN AND HAGEMAN FACTOR-LIKE PROTEIN', 250906),
(408328, 'PTHR33091:SF100', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE', 250906),
(408329, 'PTHR33091:SF53', NULL, NULL, NULL, NULL, 'OS08G0441300 PROTEIN', 250906),
(408330, 'PTHR33091:SF55', NULL, NULL, NULL, NULL, 'SUBTILISIN-CHYMOTRYPSIN INHIBITOR WSCI', 250906),
(408331, 'PTHR33091:SF99', NULL, NULL, NULL, NULL, 'INHIBITOR OF TRYPSIN/HAGEMAN FACTOR-LIKE PROTEIN-RELATED', 250906),
(408332, 'PTHR33091:SF98', NULL, NULL, NULL, NULL, '', 250906),
(408333, 'PTHR33091:SF54', NULL, NULL, NULL, NULL, '', 250906),
(408334, 'PTHR33091:SF12', NULL, NULL, NULL, NULL, 'OS02G0124200 PROTEIN', 250906),
(408335, 'PTHR33091:SF3', NULL, NULL, NULL, NULL, 'OS02G0123900 PROTEIN', 250906),
(408336, 'PTHR33091:SF91', NULL, NULL, NULL, NULL, 'BNAC03G21710D PROTEIN', 250906),
(408337, 'PTHR33091:SF90', NULL, NULL, NULL, NULL, '', 250906),
(408338, 'PTHR33091:SF7', NULL, NULL, NULL, NULL, 'INHIBITOR I FAMILY PROTEIN', 250906),
(408339, 'PTHR33091:SF93', NULL, NULL, NULL, NULL, '', 250906),
(408340, 'PTHR33091:SF92', NULL, NULL, NULL, NULL, 'OS02G0124300 PROTEIN', 250906),
(408341, 'PTHR33091:SF95', NULL, NULL, NULL, NULL, '(BREAD WHEAT) HYPOTHETICAL PROTEIN', 250906);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(408342, 'PTHR33091:SF51', NULL, NULL, NULL, NULL, 'SUBTILISIN-CHYMOTRYPSIN INHIBITOR CI-1C', 250906),
(408343, 'PTHR33091:SF94', NULL, NULL, NULL, NULL, 'PROTEASE INHIBITOR PROTEIN', 250906),
(408344, 'PTHR33091:SF50', NULL, NULL, NULL, NULL, 'OS06G0319900 PROTEIN', 250906),
(408345, 'PTHR33091', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE, EXPRESSED-RELATED', 250906),
(408346, 'PTHR33091:SF86', NULL, NULL, NULL, NULL, '', 250906),
(408347, 'PTHR33091:SF44', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR POTATO INHIBITOR I-TYPE FAMILY PROTEIN', 250906),
(408348, 'PTHR33091:SF87', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR, POTATO INHIBITOR I-TYPE FAMILY PROTEIN', 250906),
(408349, 'PTHR33091:SF46', NULL, NULL, NULL, NULL, 'SUBTILISIN-CHYMOTRYPSIN INHIBITOR CI-1B', 250906),
(408350, 'PTHR33091:SF89', NULL, NULL, NULL, NULL, 'PROTEINASE INHIBITOR 1', 250906),
(408351, 'PTHR33091:SF80', NULL, NULL, NULL, NULL, '', 250906),
(408352, 'PTHR33091:SF81', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR, POTATO INHIBITOR I-TYPE FAMILY PROTEIN', 250906),
(408353, 'PTHR33091:SF84', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE PROTEINASE INHIBITOR 1', 250906),
(408354, 'PTHR33091:SF83', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR, POTATO INHIBITOR I-TYPE FAMILY PROTEIN-RELATED', 250906),
(408355, 'PTHR33091:SF38', NULL, NULL, NULL, NULL, 'OS12G0437800 PROTEIN', 250906),
(408356, 'PTHR33091:SF33', NULL, NULL, NULL, NULL, '', 250906),
(408357, 'PTHR33091:SF76', NULL, NULL, NULL, NULL, '', 250906),
(408358, 'PTHR33091:SF32', NULL, NULL, NULL, NULL, '', 250906),
(408359, 'PTHR33091:SF79', NULL, NULL, NULL, NULL, '', 250906),
(408360, 'PTHR33091:SF78', NULL, NULL, NULL, NULL, '', 250906),
(408361, 'PTHR33091:SF37', NULL, NULL, NULL, NULL, 'SUBTILISIN-CHYMOTRYPSIN INHIBITOR CI-1B', 250906),
(408362, 'PTHR33091:SF71', NULL, NULL, NULL, NULL, '', 250906),
(408363, 'PTHR33091:SF70', NULL, NULL, NULL, NULL, '', 250906),
(408364, 'PTHR33091:SF73', NULL, NULL, NULL, NULL, 'INHIBITOR OF TRYPSIN AND HAGEMAN FACTOR-LIKE', 250906),
(408365, 'PTHR34210:SF4', NULL, NULL, NULL, NULL, '', 250907),
(408366, 'PTHR34210:SF3', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 250907),
(408367, 'PTHR34210', NULL, NULL, NULL, NULL, 'OS01G0252900 PROTEIN', 250907),
(408368, 'PTHR34210:SF1', NULL, NULL, NULL, NULL, '', 250907),
(408369, 'PTHR47185:SF2', NULL, NULL, NULL, NULL, 'FUNGAL PROTEIN', 250908),
(408370, 'PTHR47185:SF1', NULL, NULL, NULL, NULL, 'PX DOMAIN-CONTAINING PROTEIN YPR097W', 250908),
(408371, 'PTHR47185', NULL, NULL, NULL, NULL, 'PX DOMAIN-CONTAINING PROTEIN YPR097W', 250908),
(408372, 'PTHR34613:SF1', NULL, NULL, NULL, NULL, 'SLL6017 PROTEIN', 250909),
(408373, 'PTHR34613', NULL, NULL, NULL, NULL, 'SLL0800 PROTEIN', 250909),
(408374, 'PTHR32546:SF25', NULL, NULL, NULL, NULL, 'MIP05539P', 250910),
(408375, 'PTHR32546', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 158-RELATED', 250910),
(408376, 'PTHR32546:SF26', NULL, NULL, NULL, NULL, 'SMOG, ISOFORM D', 250910),
(408377, 'PTHR32546:SF11', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 158-RELATED', 250910),
(408378, 'PTHR32546:SF7', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 179-RELATED', 250910),
(408379, 'PTHR32546:SF16', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR CG31760-RELATED', 250910),
(408380, 'PTHR32546:SF27', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR 158B', 250910),
(408381, 'PTHR32546:SF29', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F3_4 DOMAIN-CONTAINING PROTEIN', 250910),
(408382, 'PTHR15497:SF3', NULL, NULL, NULL, NULL, '3-HYDROXYANTHRANILATE 3,4-DIOXYGENASE 2', 250911),
(408383, 'PTHR15497:SF1', NULL, NULL, NULL, NULL, '3-HYDROXYANTHRANILATE 3,4-DIOXYGENASE', 250911),
(408384, 'PTHR15497', NULL, NULL, NULL, NULL, '3-HYDROXYANTHRANILATE 3,4-DIOXYGENASE', 250911),
(408385, 'PTHR11418', NULL, NULL, NULL, NULL, 'GLUCAGON', 250912),
(408386, 'PTHR11418:SF0', NULL, NULL, NULL, NULL, 'PRO-GLUCAGON', 250912),
(408387, 'PTHR43380:SF4', NULL, NULL, NULL, NULL, '2-OXOISOVALERATE DEHYDROGENASE SUBUNIT ALPHA 1, MITOCHONDRIAL-LIKE', 250913);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(408388, 'PTHR43380:SF5', NULL, NULL, NULL, NULL, '2-OXOISOVALERATE DEHYDROGENASE SUBUNIT ALPHA 1, MITOCHONDRIAL-LIKE ISOFORM X1', 250913),
(408389, 'PTHR43380:SF11', NULL, NULL, NULL, NULL, '2-OXOISOVALERATE DEHYDROGENASE SUBUNIT ALPHA 2, MITOCHONDRIAL', 250913),
(408390, 'PTHR43380:SF10', NULL, NULL, NULL, NULL, 'E1_DH DOMAIN-CONTAINING PROTEIN', 250913),
(408391, 'PTHR43380', NULL, NULL, NULL, NULL, '2-OXOISOVALERATE DEHYDROGENASE SUBUNIT ALPHA, MITOCHONDRIAL', 250913),
(408392, 'PTHR43380:SF1', NULL, NULL, NULL, NULL, '2-OXOISOVALERATE DEHYDROGENASE SUBUNIT ALPHA, MITOCHONDRIAL', 250913),
(408393, 'PTHR43380:SF12', NULL, NULL, NULL, NULL, '2-OXOISOVALERATE DEHYDROGENASE SUBUNIT ALPHA 1, MITOCHONDRIAL-LIKE', 250913),
(408394, 'PTHR30447', NULL, NULL, NULL, NULL, 'FRUCTOSE-1,6-BISPHOSPHATASE CLASS 2', 250914),
(408395, 'PTHR30447:SF0', NULL, NULL, NULL, NULL, 'FRUCTOSE-1,6-BISPHOSPHATASE 1 CLASS 2-RELATED', 250914),
(408396, 'PTHR33882:SF19', NULL, NULL, NULL, NULL, 'AVRRPT-CLEAVAGE DOMAIN-CONTAINING PROTEIN', 250915),
(408397, 'PTHR33882:SF9', NULL, NULL, NULL, NULL, 'PROTEIN 4 (RIN4) FAMILY PROTEIN, PUTATIVE-RELATED', 250915),
(408398, 'PTHR33882:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250915),
(408399, 'PTHR33882:SF20', NULL, NULL, NULL, NULL, 'AVRRPT-CLEAVAGE DOMAIN-CONTAINING PROTEIN', 250915),
(408400, 'PTHR33882:SF6', NULL, NULL, NULL, NULL, 'OS11G0603100 PROTEIN', 250915),
(408401, 'PTHR33882:SF5', NULL, NULL, NULL, NULL, 'BNAA06G23800D PROTEIN', 250915),
(408402, 'PTHR33882:SF11', NULL, NULL, NULL, NULL, 'RPM1-INTERACTING PROTEIN 4 (RIN4) FAMILY PROTEIN', 250915),
(408403, 'PTHR33882:SF22', NULL, NULL, NULL, NULL, 'AVRRPT-CLEAVAGE DOMAIN-CONTAINING PROTEIN', 250915),
(408404, 'PTHR33882:SF10', NULL, NULL, NULL, NULL, 'RPM1-INTERACTING PROTEIN 4 (RIN4) FAMILY PROTEIN', 250915),
(408405, 'PTHR33882:SF21', NULL, NULL, NULL, NULL, 'BNAC02G00600D PROTEIN', 250915),
(408406, 'PTHR33882:SF13', NULL, NULL, NULL, NULL, 'BNAA09G07030D PROTEIN', 250915),
(408407, 'PTHR33882:SF23', NULL, NULL, NULL, NULL, '', 250915),
(408408, 'PTHR33882:SF15', NULL, NULL, NULL, NULL, '', 250915),
(408409, 'PTHR33882', NULL, NULL, NULL, NULL, 'PATHOGENIC TYPE III EFFECTOR AVIRULENCE FACTOR AVR AVRRPT-CLEAVAGE: CLEAVAGE SITE PROTEIN', 250915),
(408410, 'PTHR33882:SF16', NULL, NULL, NULL, NULL, 'AVRRPT-CLEAVAGE DOMAIN-CONTAINING PROTEIN', 250915),
(408411, 'PTHR46385:SF3', NULL, NULL, NULL, NULL, 'PAIRED MESODERM HOMEOBOX PROTEIN 2', 250916),
(408412, 'PTHR46385', NULL, NULL, NULL, NULL, 'PAIRED MESODERM HOMEOBOX PROTEIN 1-RELATED', 250916),
(408413, 'PTHR46385:SF1', NULL, NULL, NULL, NULL, 'PAIRED MESODERM HOMEOBOX PROTEIN 1', 250916),
(408414, 'PTHR15440', NULL, NULL, NULL, NULL, 'XRP2 PROTEIN', 250917),
(408415, 'PTHR15440:SF0', NULL, NULL, NULL, NULL, 'PROTEIN XRP2', 250917),
(408416, 'PTHR11799:SF7', NULL, NULL, NULL, NULL, 'PON (PARAOXONASE) AND MEC-6 LIKE-RELATED', 250918),
(408417, 'PTHR11799', NULL, NULL, NULL, NULL, 'PARAOXONASE', 250918),
(408418, 'PTHR11799:SF16', NULL, NULL, NULL, NULL, 'SERUM PARAOXONASE/ARYLESTERASE 1', 250918),
(408419, 'PTHR11799:SF28', NULL, NULL, NULL, NULL, 'MECHANOSENSORY ABNORMALITY PROTEIN 6', 250918),
(408420, 'PTHR11799:SF17', NULL, NULL, NULL, NULL, 'SERUM PARAOXONASE/ARYLESTERASE 2', 250918),
(408421, 'PTHR11799:SF29', NULL, NULL, NULL, NULL, 'SERUM PARAOXONASE/ARYLESTERASE', 250918),
(408422, 'PTHR11799:SF12', NULL, NULL, NULL, NULL, 'PARAOXONASE-RELATED', 250918),
(408423, 'PTHR11799:SF14', NULL, NULL, NULL, NULL, 'SERUM PARAOXONASE/LACTONASE 3', 250918),
(408424, 'PTHR11799:SF1', NULL, NULL, NULL, NULL, 'PON (PARAOXONASE) AND MEC-6 LIKE', 250918),
(408425, 'PTHR11799:SF20', NULL, NULL, NULL, NULL, '', 250918),
(408426, 'PTHR22942', NULL, NULL, NULL, NULL, 'RECA/RAD51/RADA DNA STRAND-PAIRING FAMILY MEMBER', 250919),
(408427, 'PTHR22942:SF39', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RAD51 HOMOLOG 1', 250919),
(408428, 'PTHR22942:SF66', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RAD57', 250919),
(408429, 'PTHR22942:SF67', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RAD51 HOMOLOG A', 250919); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(408430, 'PTHR22942:SF68', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RAD51 HOMOLOG B', 250919),
(408431, 'PTHR22942:SF47', NULL, NULL, NULL, NULL, 'DNA REPAIR AND RECOMBINATION PROTEIN RADB', 250919),
(408432, 'PTHR22942:SF30', NULL, NULL, NULL, NULL, 'MEIOTIC RECOMBINATION PROTEIN DMC1/LIM15 HOMOLOG', 250919),
(408433, 'PTHR22942:SF64', NULL, NULL, NULL, NULL, 'MEIOTIC RECOMBINATION PROTEIN DMC1-LIKE PROTEIN', 250919),
(408434, 'PTHR22942:SF65', NULL, NULL, NULL, NULL, '', 250919),
(408435, 'PTHR12702:SF7', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT', 250920),
(408436, 'PTHR12702:SF3', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT 6B', 250920),
(408437, 'PTHR12702', NULL, NULL, NULL, NULL, 'SEC15', 250920),
(408438, 'PTHR12702:SF6', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT', 250920),
(408439, 'PTHR12702:SF0', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT 6', 250920),
(408440, 'PTHR12702:SF1', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT SEC15B', 250920),
(408441, 'PTHR12702:SF2', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT 6', 250920),
(408442, 'PTHR48250', NULL, NULL, NULL, NULL, 'CUTINASE 2-RELATED', 250921),
(408443, 'PTHR48250:SF3', NULL, NULL, NULL, NULL, 'CUTINASE 2-RELATED', 250921),
(408444, 'PTHR48250:SF2', NULL, NULL, NULL, NULL, 'CUTINASE', 250921),
(408445, 'PTHR48250:SF1', NULL, NULL, NULL, NULL, 'CUTINASE', 250921),
(408446, 'PTHR46556:SF1', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY M MEMBER 2', 250922),
(408447, 'PTHR46556', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY M MEMBER 2', 250922),
(408448, 'PTHR16135:SF2', NULL, NULL, NULL, NULL, 'SHIFTLESS ANTIVIRAL INHIBITOR OF RIBOSOMAL FRAMESHIFTING PROTEIN', 250923),
(408449, 'PTHR16135', NULL, NULL, NULL, NULL, 'REPRESSOR OF YIELD OF DENV PROTEIN', 250923),
(408450, 'PTHR21328:SF23', NULL, NULL, NULL, NULL, 'PROTEIN MONO-ADP-RIBOSYLTRANSFERASE PARP6', 250924),
(408451, 'PTHR21328:SF28', NULL, NULL, NULL, NULL, 'PROTEIN WITH UBIQUITIN CONJUGATING ENZYME DOMAIN', 250924),
(408452, 'PTHR21328:SF27', NULL, NULL, NULL, NULL, 'POLY [ADP-RIBOSE] POLYMERASE', 250924),
(408453, 'PTHR21328', NULL, NULL, NULL, NULL, 'POLY  ADP-RIBOSE  POLYMERASE FAMILY, MEMBER  PARP', 250924),
(408454, 'PTHR21328:SF2', NULL, NULL, NULL, NULL, 'PROTEIN MONO-ADP-RIBOSYLTRANSFERASE PARP16', 250924),
(408455, 'PTHR21328:SF3', NULL, NULL, NULL, NULL, 'PROTEIN MONO-ADP-RIBOSYLTRANSFERASE PARP8', 250924),
(408456, 'PTHR20992:SF12', NULL, NULL, NULL, NULL, 'IP07646P', 250925),
(408457, 'PTHR20992', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 250925),
(408458, 'PTHR20992:SF9', NULL, NULL, NULL, NULL, 'AT15442P-RELATED', 250925),
(408459, 'PTHR36245:SF1', NULL, NULL, NULL, NULL, 'BNAC05G47150D PROTEIN', 250926),
(408460, 'PTHR36245:SF3', NULL, NULL, NULL, NULL, 'BNAC01G39970D PROTEIN', 250926),
(408461, 'PTHR36245', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN DOT1-LIKE', 250926),
(408462, 'PTHR36245:SF4', NULL, NULL, NULL, NULL, 'BNAC08G45150D PROTEIN', 250926),
(408463, 'PTHR36245:SF5', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN DOT1-LIKE', 250926),
(408464, 'PTHR36245:SF6', NULL, NULL, NULL, NULL, '', 250926),
(408465, 'PTHR45168:SF1', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY B MEMBER 2', 250927),
(408466, 'PTHR45168', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY B MEMBER 2', 250927),
(408467, 'PTHR36383', NULL, NULL, NULL, NULL, 'OS09G0529350 PROTEIN', 250928),
(408468, 'PTHR36383:SF1', NULL, NULL, NULL, NULL, 'OS09G0529350 PROTEIN', 250928),
(408469, 'PTHR34832', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN W', 250929),
(408470, 'PTHR34832:SF1', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN W', 250929),
(408471, 'PTHR22590', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 250930),
(408472, 'PTHR22590:SF2', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN N', 250930),
(408473, 'PTHR22590:SF5', NULL, NULL, NULL, NULL, 'IQ CALMODULIN-BINDING MOTIF-CONTAINING PROTEIN', 250930),
(408474, 'PTHR22590:SF4', NULL, NULL, NULL, NULL, 'ABNORMAL SPINDLE-LIKE MICROCEPHALY-ASSOCIATED PROTEIN', 250930);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(408475, 'PTHR22590:SF3', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN E', 250930),
(408476, 'PTHR46177', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 250931),
(408477, 'PTHR46177:SF1', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 250931),
(408478, 'PTHR42264:SF4', NULL, NULL, NULL, NULL, '', 250932),
(408479, 'PTHR42264:SF3', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN-RELATED', 250932),
(408480, 'PTHR42264', NULL, NULL, NULL, NULL, 'EPHRIN_REC_LIKE DOMAIN-CONTAINING PROTEIN', 250932),
(408481, 'PTHR43511:SF2', NULL, NULL, NULL, NULL, 'UTP--GLUCOSE-1-PHOSPHATE URIDYLYLTRANSFERASE', 250933),
(408482, 'PTHR43511', NULL, NULL, NULL, NULL, '', 250933),
(408483, 'PTHR43511:SF1', NULL, NULL, NULL, NULL, 'UTP--GLUCOSE-1-PHOSPHATE URIDYLYLTRANSFERASE', 250933),
(408484, 'PTHR43511:SF4', NULL, NULL, NULL, NULL, 'UTP--GLUCOSE-1-PHOSPHATE URIDYLYLTRANSFERASE', 250933),
(408485, 'PTHR43511:SF3', NULL, NULL, NULL, NULL, 'UTP--GLUCOSE-1-PHOSPHATE URIDYLYLTRANSFERASE 1', 250933),
(408486, 'PTHR43511:SF9', NULL, NULL, NULL, NULL, 'UTP-GLUCOSE-1-PHOSPHATE URIDYLYLTRANSFERASE', 250933),
(408487, 'PTHR43511:SF6', NULL, NULL, NULL, NULL, 'UTP--GLUCOSE-1-PHOSPHATE URIDYLYLTRANSFERASE-RELATED', 250933),
(408488, 'PTHR43511:SF8', NULL, NULL, NULL, NULL, 'UTP--GLUCOSE-1-PHOSPHATE URIDYLYLTRANSFERASE', 250933),
(408489, 'PTHR43511:SF7', NULL, NULL, NULL, NULL, 'UTP--GLUCOSE-1-PHOSPHATE URIDYLYLTRANSFERASE 1', 250933),
(408490, 'PTHR31175:SF111', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR68-LIKE', 250934),
(408491, 'PTHR31175:SF110', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY-RELATED', 250934),
(408492, 'PTHR31175:SF113', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE-RELATED', 250934),
(408493, 'PTHR31175:SF112', NULL, NULL, NULL, NULL, 'SAUR55-AUXIN-RESPONSIVE SAUR FAMILY MEMBER', 250934),
(408494, 'PTHR31175:SF114', NULL, NULL, NULL, NULL, '', 250934),
(408495, 'PTHR31175:SF65', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR66-LIKE', 250934),
(408496, 'PTHR31175:SF24', NULL, NULL, NULL, NULL, 'OS09G0545500 PROTEIN', 250934),
(408497, 'PTHR31175:SF26', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR36', 250934),
(408498, 'PTHR31175:SF61', NULL, NULL, NULL, NULL, 'SMALL AUXIN-UP RNA-RELATED', 250934),
(408499, 'PTHR31175:SF62', NULL, NULL, NULL, NULL, 'SMALL AUXIN-UP RNA-RELATED', 250934),
(408500, 'PTHR31175:SF63', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR68-LIKE ISOFORM X1', 250934),
(408501, 'PTHR31175:SF31', NULL, NULL, NULL, NULL, 'AUXIN INDUCED PROTEIN', 250934),
(408502, 'PTHR31175:SF34', NULL, NULL, NULL, NULL, '', 250934),
(408503, 'PTHR31175:SF79', NULL, NULL, NULL, NULL, '', 250934),
(408504, 'PTHR31175:SF38', NULL, NULL, NULL, NULL, '', 250934),
(408505, 'PTHR31175', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE FAMILY PROTEIN', 250934),
(408506, 'PTHR31175:SF70', NULL, NULL, NULL, NULL, 'OS09G0546700 PROTEIN', 250934),
(408507, 'PTHR31175:SF72', NULL, NULL, NULL, NULL, 'OS09G0547100 PROTEIN', 250934),
(408508, 'PTHR31175:SF42', NULL, NULL, NULL, NULL, '', 250934),
(408509, 'PTHR31175:SF86', NULL, NULL, NULL, NULL, '', 250934),
(408510, 'PTHR31175:SF87', NULL, NULL, NULL, NULL, 'BNAA09G26840D PROTEIN', 250934),
(408511, 'PTHR31175:SF47', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR67-LIKE', 250934),
(408512, 'PTHR31175:SF49', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR66-LIKE', 250934),
(408513, 'PTHR31175:SF80', NULL, NULL, NULL, NULL, 'BNAC03G59180D PROTEIN', 250934),
(408514, 'PTHR31175:SF82', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR65', 250934),
(408515, 'PTHR31175:SF40', NULL, NULL, NULL, NULL, '', 250934),
(408516, 'PTHR31175:SF41', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR68-LIKE', 250934),
(408517, 'PTHR31175:SF100', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR66-LIKE', 250934),
(408518, 'PTHR31175:SF106', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR68-LIKE', 250934),
(408519, 'PTHR31175:SF105', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR61', 250934);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(408520, 'PTHR31175:SF108', NULL, NULL, NULL, NULL, '', 250934),
(408521, 'PTHR31175:SF107', NULL, NULL, NULL, NULL, '', 250934),
(408522, 'PTHR31175:SF102', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED SAUR', 250934),
(408523, 'PTHR31175:SF101', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE-RELATED', 250934),
(408524, 'PTHR31175:SF104', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE FAMILY PROTEIN', 250934),
(408525, 'PTHR31175:SF103', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR67-LIKE', 250934),
(408526, 'PTHR31175:SF53', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR68-LIKE', 250934),
(408527, 'PTHR31175:SF97', NULL, NULL, NULL, NULL, 'OS09G0546900 PROTEIN', 250934),
(408528, 'PTHR31175:SF98', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR67-LIKE', 250934),
(408529, 'PTHR31175:SF99', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR61-RELATED', 250934),
(408530, 'PTHR31175:SF57', NULL, NULL, NULL, NULL, 'BNAA09G26800D PROTEIN', 250934),
(408531, 'PTHR31175:SF109', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR68-LIKE', 250934),
(408532, 'PTHR31175:SF59', NULL, NULL, NULL, NULL, 'BNAC03G59190D PROTEIN', 250934),
(408533, 'PTHR31175:SF90', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED SAUR', 250934),
(408534, 'PTHR31175:SF91', NULL, NULL, NULL, NULL, '', 250934),
(408535, 'PTHR31175:SF93', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN SAUR65-LIKE', 250934),
(408536, 'PTHR31175:SF94', NULL, NULL, NULL, NULL, 'OS09G0547000 PROTEIN', 250934),
(408537, 'PTHR31175:SF50', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN FAMILY, PUTATIVE-RELATED', 250934),
(408538, 'PTHR31175:SF51', NULL, NULL, NULL, NULL, 'OS08G0550700 PROTEIN', 250934),
(408539, 'PTHR31175:SF95', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED SAUR', 250934),
(408540, 'PTHR31175:SF96', NULL, NULL, NULL, NULL, '', 250934),
(408541, 'PTHR13120', NULL, NULL, NULL, NULL, 'PHD FINGER-LIKE DOMAIN-CONTAINING PROTEIN 5A', 250935),
(408542, 'PTHR13120:SF7', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR INI1', 250935),
(408543, 'PTHR13120:SF8', NULL, NULL, NULL, NULL, 'PHF5-LIKE PROTEIN', 250935),
(408544, 'PTHR13120:SF5', NULL, NULL, NULL, NULL, 'BNAC03G71910D PROTEIN', 250935),
(408545, 'PTHR13120:SF4', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR INI1', 250935),
(408546, 'PTHR13120:SF0', NULL, NULL, NULL, NULL, 'PHD FINGER-LIKE DOMAIN-CONTAINING PROTEIN 5A', 250935),
(408547, 'PTHR47672:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SNT2', 250936),
(408548, 'PTHR47672', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SNT2', 250936),
(408549, 'PTHR11751:SF29', NULL, NULL, NULL, NULL, 'AT04676P', 250937),
(408550, 'PTHR11751:SF308', NULL, NULL, NULL, NULL, 'ALANINE AMINOTRANSFERASE 1', 250937),
(408551, 'PTHR11751:SF409', NULL, NULL, NULL, NULL, 'OS10G0390600 PROTEIN', 250937),
(408552, 'PTHR11751:SF476', NULL, NULL, NULL, NULL, 'AMINOTRAN_1_2 DOMAIN-CONTAINING PROTEIN', 250937),
(408553, 'PTHR11751:SF311', NULL, NULL, NULL, NULL, 'ALANINE AMINOTRANSFERASE 2', 250937),
(408554, 'PTHR11751:SF475', NULL, NULL, NULL, NULL, 'AMINOTRAN_1_2 DOMAIN-CONTAINING PROTEIN', 250937),
(408555, 'PTHR11751:SF474', NULL, NULL, NULL, NULL, 'BNAA08G20540D PROTEIN', 250937),
(408556, 'PTHR11751:SF440', NULL, NULL, NULL, NULL, 'OS09G0433900 PROTEIN', 250937),
(408557, 'PTHR11751:SF473', NULL, NULL, NULL, NULL, 'AMINOTRAN_1_2 DOMAIN-CONTAINING PROTEIN', 250937),
(408558, 'PTHR11751:SF469', NULL, NULL, NULL, NULL, 'AMINOTRAN_1_2 DOMAIN-CONTAINING PROTEIN', 250937),
(408559, 'PTHR11751:SF468', NULL, NULL, NULL, NULL, 'ALANINE AMINOTRANSFERASE 2-LIKE', 250937),
(408560, 'PTHR11751:SF479', NULL, NULL, NULL, NULL, 'ALANINE AMINOTRANSFERASE 2 MITOCHONDRIAL', 250937),
(408561, 'PTHR11751:SF478', NULL, NULL, NULL, NULL, 'BNAA09G31220D PROTEIN', 250937),
(408562, 'PTHR11751:SF477', NULL, NULL, NULL, NULL, 'BNAC05G13450D PROTEIN', 250937),
(408563, 'PTHR11751', NULL, NULL, NULL, NULL, 'ALANINE AMINOTRANSFERASE', 250937),
(408564, 'PTHR11751:SF472', NULL, NULL, NULL, NULL, 'GLUTAMATE--GLYOXYLATE AMINOTRANSFERASE 1', 250937);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(408565, 'PTHR11751:SF373', NULL, NULL, NULL, NULL, 'GLUTAMATE--GLYOXYLATE AMINOTRANSFERASE 2', 250937),
(408566, 'PTHR11751:SF471', NULL, NULL, NULL, NULL, 'AMINOTRAN_1_2 DOMAIN-CONTAINING PROTEIN', 250937),
(408567, 'PTHR20994:SF0', NULL, NULL, NULL, NULL, 'ER MEMBRANE PROTEIN COMPLEX SUBUNIT 6', 250938),
(408568, 'PTHR20994', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 250938),
(408569, 'PTHR20994:SF1', NULL, NULL, NULL, NULL, 'ER MEMBRANE PROTEIN COMPLEX SUBUNIT 6', 250938),
(408570, 'PTHR31949:SF19', NULL, NULL, NULL, NULL, 'GPI-ANCHORED PROTEIN', 250939),
(408571, 'PTHR31949:SF28', NULL, NULL, NULL, NULL, 'BNAA09G27720D PROTEIN', 250939),
(408572, 'PTHR31949:SF16', NULL, NULL, NULL, NULL, 'OS09G0518600 PROTEIN', 250939),
(408573, 'PTHR31949', NULL, NULL, NULL, NULL, 'GASTRIC MUCIN-LIKE PROTEIN', 250939),
(408574, 'PTHR31949:SF5', NULL, NULL, NULL, NULL, 'OS05G0480600 PROTEIN', 250939),
(408575, 'PTHR31949:SF6', NULL, NULL, NULL, NULL, '', 250939),
(408576, 'PTHR31949:SF3', NULL, NULL, NULL, NULL, 'RUN/FYVE DOMAIN PROTEIN', 250939),
(408577, 'PTHR31949:SF2', NULL, NULL, NULL, NULL, 'OS01G0819000 PROTEIN', 250939),
(408578, 'PTHR31949:SF32', NULL, NULL, NULL, NULL, 'MUCIN-5B-LIKE', 250939),
(408579, 'PTHR31949:SF21', NULL, NULL, NULL, NULL, 'OS05G0316300 PROTEIN', 250939),
(408580, 'PTHR31949:SF20', NULL, NULL, NULL, NULL, 'OS01G0141900 PROTEIN', 250939),
(408581, 'PTHR31949:SF31', NULL, NULL, NULL, NULL, 'BNAC03G72310D PROTEIN', 250939),
(408582, 'PTHR31949:SF30', NULL, NULL, NULL, NULL, 'BNAA05G29320D PROTEIN', 250939),
(408583, 'PTHR31949:SF15', NULL, NULL, NULL, NULL, 'ENDOCHITINASE A-LIKE', 250939),
(408584, 'PTHR31949:SF36', NULL, NULL, NULL, NULL, 'OS08G0543000 PROTEIN', 250939),
(408585, 'PTHR31949:SF35', NULL, NULL, NULL, NULL, '', 250939),
(408586, 'PTHR31949:SF13', NULL, NULL, NULL, NULL, 'MUCIN-5AC-LIKE PROTEIN', 250939),
(408587, 'PTHR31949:SF24', NULL, NULL, NULL, NULL, 'PROLINE-RICH FAMILY PROTEIN-RELATED', 250939),
(408588, 'PTHR31949:SF12', NULL, NULL, NULL, NULL, 'BNAC01G39250D PROTEIN', 250939),
(408589, 'PTHR31949:SF34', NULL, NULL, NULL, NULL, 'PROLINE-RICH FAMILY PROTEIN', 250939),
(408590, 'PTHR40279:SF3', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE CT_610-RELATED', 250940),
(408591, 'PTHR40279', NULL, NULL, NULL, NULL, 'PQQC-LIKE PROTEIN', 250940),
(408592, 'PTHR37079:SF5', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE ATM-LIKE ISOFORM X1', 250941),
(408593, 'PTHR37079', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE ATM', 250941),
(408594, 'PTHR37079:SF4', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE ATM', 250941),
(408595, 'PTHR47652:SF3', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM44', 250942),
(408596, 'PTHR47652:SF6', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN (LEA) FAMILY PROTEIN', 250942),
(408597, 'PTHR47652:SF7', NULL, NULL, NULL, NULL, 'DUF4149 DOMAIN-CONTAINING PROTEIN', 250942),
(408598, 'PTHR47652', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM44', 250942),
(408599, 'PTHR43561:SF1', NULL, NULL, NULL, NULL, 'HYDROXY-ACYL-COA DEHYDROGENASE', 250943),
(408600, 'PTHR43561', NULL, NULL, NULL, NULL, '', 250943),
(408601, 'PTHR43561:SF3', NULL, NULL, NULL, NULL, 'HYDROXYACYL-COENZYME A DEHYDROGENASE, MITOCHONDRIAL', 250943),
(408602, 'PTHR43561:SF2', NULL, NULL, NULL, NULL, '3-HYDROXYACYL-COA DEHYDROGENASE F54C8.1-RELATED', 250943),
(408603, 'PTHR22740:SF3', NULL, NULL, NULL, NULL, 'PROTEIN KRBA1', 250944),
(408604, 'PTHR22740', NULL, NULL, NULL, NULL, 'PROTEIN KRBA1', 250944),
(408605, 'PTHR43142:SF11', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 250945),
(408606, 'PTHR43142:SF12', NULL, NULL, NULL, NULL, 'COESTERASE DOMAIN-CONTAINING PROTEIN-RELATED', 250945),
(408607, 'PTHR43142:SF1', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 250945),
(408608, 'PTHR43142:SF3', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_3G09070)-RELATED', 250945),
(408609, 'PTHR43142:SF4', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 250945);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(408610, 'PTHR43142', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 250945),
(408611, 'PTHR43142:SF5', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 250945),
(408612, 'PTHR43142:SF6', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_7G01710)-RELATED', 250945),
(408613, 'PTHR43142:SF8', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 250945),
(408614, 'PTHR15075', NULL, NULL, NULL, NULL, 'ALPHA-MANNOSIDE BETA-1,6-N-ACETYLGLUCOSAMINYLTRANSFERASE', 250946),
(408615, 'PTHR15075:SF2', NULL, NULL, NULL, NULL, 'ALPHA-1,6-MANNOSYLGLYCOPROTEIN 6-BETA-N-ACETYLGLUCOSAMINYLTRANSFERASE', 250946),
(408616, 'PTHR15075:SF5', NULL, NULL, NULL, NULL, 'ALPHA-1,6-MANNOSYLGLYCOPROTEIN 6-BETA-N-ACETYLGLUCOSAMINYLTRANSFERASE A', 250946),
(408617, 'PTHR15075:SF6', NULL, NULL, NULL, NULL, 'ALPHA-1,6-MANNOSYLGLYCOPROTEIN 6-BETA-N-ACETYLGLUCOSAMINYLTRANSFERASE B', 250946),
(408618, 'PTHR15075:SF7', NULL, NULL, NULL, NULL, 'ALPHA-1,6-MANNOSYL-GLYCOPROTEIN 6-BETA-N-ACETYLGLUCOSAMINYLTRANSFERASE', 250946),
(408619, 'PTHR34451:SF10', NULL, NULL, NULL, NULL, 'BNAA08G26340D PROTEIN', 250947),
(408620, 'PTHR34451:SF12', NULL, NULL, NULL, NULL, 'ZINC FINGER, FYVE/PHD-TYPE-RELATED', 250947),
(408621, 'PTHR34451:SF11', NULL, NULL, NULL, NULL, 'BNAA08G26330D PROTEIN', 250947),
(408622, 'PTHR34451:SF14', NULL, NULL, NULL, NULL, 'DNA BINDING PROTEIN', 250947),
(408623, 'PTHR34451:SF13', NULL, NULL, NULL, NULL, 'BNAANNG25860D PROTEIN', 250947),
(408624, 'PTHR34451:SF16', NULL, NULL, NULL, NULL, '', 250947),
(408625, 'PTHR34451:SF15', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN', 250947),
(408626, 'PTHR34451', NULL, NULL, NULL, NULL, 'PHD FINGER FAMILY PROTEIN', 250947),
(408627, 'PTHR34451:SF17', NULL, NULL, NULL, NULL, 'OS05G0277200 PROTEIN', 250947),
(408628, 'PTHR34451:SF7', NULL, NULL, NULL, NULL, 'PHD FINGER FAMILY PROTEIN', 250947),
(408629, 'PTHR34451:SF6', NULL, NULL, NULL, NULL, 'DNA BINDING PROTEIN', 250947),
(408630, 'PTHR11059', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RECN', 250948),
(408631, 'PTHR11059:SF0', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RECN', 250948),
(408632, 'PTHR46570', NULL, NULL, NULL, NULL, 'TUBULIN--TYROSINE LIGASE', 250949),
(408633, 'PTHR46570:SF1', NULL, NULL, NULL, NULL, 'TUBULIN--TYROSINE LIGASE', 250949),
(408634, 'PTHR35272:SF3', NULL, NULL, NULL, NULL, 'THIOL:DISULFIDE INTERCHANGE PROTEIN DSBC', 250950),
(408635, 'PTHR35272:SF5', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE_FOLD DOMAIN-CONTAINING PROTEIN', 250950),
(408636, 'PTHR35272', NULL, NULL, NULL, NULL, 'THIOL:DISULFIDE INTERCHANGE PROTEIN DSBC-RELATED', 250950),
(408637, 'PTHR35272:SF4', NULL, NULL, NULL, NULL, 'THIOL:DISULFIDE INTERCHANGE PROTEIN DSBG', 250950),
(408638, 'PTHR38329', NULL, NULL, NULL, NULL, 'CECROPIN-A1-RELATED', 250951),
(408639, 'PTHR38329:SF1', NULL, NULL, NULL, NULL, 'CECROPIN-A1-RELATED', 250951),
(408640, 'PTHR11702:SF44', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN OBGC, CHLOROPLASTIC', 250952),
(408641, 'PTHR11702:SF31', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOME-ASSOCIATED GTPASE 2', 250952),
(408642, 'PTHR11702:SF42', NULL, NULL, NULL, NULL, 'BNAA08G29050D PROTEIN', 250952),
(408643, 'PTHR11702:SF43', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN 10', 250952),
(408644, 'PTHR11702', NULL, NULL, NULL, NULL, 'DEVELOPMENTALLY REGULATED GTP-BINDING PROTEIN-RELATED', 250952),
(408645, 'PTHR11702:SF39', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN OBGC2-RELATED', 250952),
(408646, 'PTHR31893:SF2', NULL, NULL, NULL, NULL, 'SI:DKEY-13P1.4', 250953),
(408647, 'PTHR31893:SF5', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 151 HOMOLOG', 250953),
(408648, 'PTHR31893:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 151B', 250953),
(408649, 'PTHR31893:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 151A', 250953),
(408650, 'PTHR31893', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 151 HOMOLOG', 250953),
(408651, 'PTHR36135:SF1', NULL, NULL, NULL, NULL, 'FIBROUS SHEATH CABYR-BINDING PROTEIN', 250954),
(408652, 'PTHR36135', NULL, NULL, NULL, NULL, 'FIBROUS SHEATH CABYR-BINDING PROTEIN', 250954);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(408653, 'PTHR46375:SF4', NULL, NULL, NULL, NULL, 'KELCH-LIKE FAMILY, MEMBER 42', 250955),
(408654, 'PTHR46375', NULL, NULL, NULL, NULL, 'KELCH REPEAT AND BTB DOMAIN-CONTAINING PROTEIN 13-RELATED', 250955),
(408655, 'PTHR46375:SF3', NULL, NULL, NULL, NULL, 'KELCH REPEAT AND BTB DOMAIN-CONTAINING PROTEIN 13', 250955),
(408656, 'PTHR36503:SF1', NULL, NULL, NULL, NULL, 'BLR2520 PROTEIN', 250956),
(408657, 'PTHR36503', NULL, NULL, NULL, NULL, 'BLR2520 PROTEIN', 250956),
(408658, 'PTHR36503:SF3', NULL, NULL, NULL, NULL, 'BLR0126 PROTEIN', 250956),
(408659, 'PTHR36503:SF2', NULL, NULL, NULL, NULL, 'BLR2408 PROTEIN', 250956),
(408660, 'PTHR11292', NULL, NULL, NULL, NULL, 'T-CELL SURFACE GLYCOPROTEIN CD8 BETA CHAIN', 250957),
(408661, 'PTHR11292:SF7', NULL, NULL, NULL, NULL, 'T-CELL SURFACE GLYCOPROTEIN CD8 BETA CHAIN-RELATED', 250957),
(408662, 'PTHR30043:SF1', NULL, NULL, NULL, NULL, 'PHOSPHONATES-BINDING PERIPLASMIC PROTEIN', 250958),
(408663, 'PTHR30043', NULL, NULL, NULL, NULL, 'PHOSPHONATES TRANSPORT SYSTEM PERMEASE PROTEIN', 250958),
(408664, 'PTHR30043:SF7', NULL, NULL, NULL, NULL, 'CRYPTIC PHOSPHONATE TRANSPORT SYSTEM PERMEASE PROTEIN PHNE1-RELATED', 250958),
(408665, 'PTHR30043:SF8', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, PERMEASE PROTEIN CC0363, PUTATIVE-RELATED', 250958),
(408666, 'PTHR39583', NULL, NULL, NULL, NULL, 'TYPE II SECRETION SYSTEM PROTEIN J-RELATED', 250959),
(408667, 'PTHR39583:SF2', NULL, NULL, NULL, NULL, 'TYPE II SECRETION SYSTEM PROTEIN J', 250959),
(408668, 'PTHR39583:SF3', NULL, NULL, NULL, NULL, 'PREPILIN PEPTIDASE-DEPENDENT PROTEIN B', 250959),
(408669, 'PTHR21362', NULL, NULL, NULL, NULL, 'ACROSIN-BINDING PROTEIN', 250960),
(408670, 'PTHR21362:SF1', NULL, NULL, NULL, NULL, 'ACROSIN-BINDING PROTEIN', 250960),
(408671, 'PTHR34914', NULL, NULL, NULL, NULL, 'LYMPHOCYTE EXPANSION MOLECULE', 250961),
(408672, 'PTHR34914:SF1', NULL, NULL, NULL, NULL, 'LYMPHOCYTE EXPANSION MOLECULE', 250961),
(408673, 'PTHR10218:SF291', NULL, NULL, NULL, NULL, 'OS06G0111400 PROTEIN', 250962),
(408674, 'PTHR10218:SF130', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT ALPHA-12', 250962),
(408675, 'PTHR10218:SF334', NULL, NULL, NULL, NULL, 'EXTRA-LARGE GUANINE NUCLEOTIDE-BINDING PROTEIN 3', 250962),
(408676, 'PTHR10218:SF213', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT ALPHA-14', 250962),
(408677, 'PTHR10218:SF212', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN G(S) SUBUNIT ALPHA XL', 250962),
(408678, 'PTHR10218:SF331', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN (G PROTEIN), ALPHA-ACTIVATING ACTIVITY POLYPEPTIDE O, B', 250962),
(408679, 'PTHR10218:SF210', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN ALPHA-13 SUBUNIT', 250962),
(408680, 'PTHR10218:SF338', NULL, NULL, NULL, NULL, 'BNAA03G52790D PROTEIN', 250962),
(408681, 'PTHR10218:SF217', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT ALPHA-15', 250962),
(408682, 'PTHR10218:SF337', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN ALPHA SUBUNIT, GNA', 250962),
(408683, 'PTHR10218:SF215', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN ALPHA-17 SUBUNIT', 250962),
(408684, 'PTHR10218:SF336', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN ALPHA-3 SUBUNIT', 250962),
(408685, 'PTHR10218:SF335', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN (G PROTEIN), ALPHA-ACTIVATING ACTIVITY POLYPEPTIDE O, A', 250962),
(408686, 'PTHR10218:SF242', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN ALPHA-1 SUBUNIT', 250962),
(408687, 'PTHR10218:SF323', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN ALPHA-15 SUBUNIT', 250962),
(408688, 'PTHR10218', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN ALPHA SUBUNIT', 250962),
(408689, 'PTHR10218:SF245', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN ALPHA-2 SUBUNIT-RELATED', 250962),
(408690, 'PTHR10218:SF200', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN ALPHA-12 SUBUNIT', 250962),
(408691, 'PTHR10218:SF321', NULL, NULL, NULL, NULL, 'EXTRA-LARGE GUANINE NUCLEOTIDE-BINDING PROTEIN 2', 250962);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(408692, 'PTHR10218:SF243', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN ALPHA-7 SUBUNIT', 250962),
(408693, 'PTHR10218:SF248', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN-LIKE ALPHA-11 SUBUNIT', 250962),
(408694, 'PTHR10218:SF324', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN ALPHA-6 SUBUNIT-RELATED', 250962),
(408695, 'PTHR10218:SF247', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN ALPHA-6 SUBUNIT', 250962),
(408696, 'PTHR10218:SF329', NULL, NULL, NULL, NULL, 'SD21019P', 250962),
(408697, 'PTHR10218:SF208', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN ALPHA-14 SUBUNIT', 250962),
(408698, 'PTHR10218:SF328', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT ALPHA-11', 250962),
(408699, 'PTHR10218:SF73', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN G(I) SUBUNIT ALPHA-2', 250962),
(408700, 'PTHR10218:SF194', NULL, NULL, NULL, NULL, 'G PROTEIN, ALPHA SUBUNIT', 250962),
(408701, 'PTHR10218:SF193', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN ALPHA-8 SUBUNIT', 250962),
(408702, 'PTHR10218:SF231', NULL, NULL, NULL, NULL, 'G PROTEIN ALPHA I SUBUNIT-LIKE PROTEIN', 250962),
(408703, 'PTHR10218:SF352', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN ALPHA-5 SUBUNIT', 250962),
(408704, 'PTHR10218:SF351', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN ALPHA-2 SUBUNIT', 250962),
(408705, 'PTHR10218:SF230', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN G(I) SUBUNIT ALPHA-3', 250962),
(408706, 'PTHR10218:SF350', NULL, NULL, NULL, NULL, 'BNAC05G24110D PROTEIN', 250962),
(408707, 'PTHR10218:SF196', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN ALPHA-8 SUBUNIT-RELATED', 250962),
(408708, 'PTHR10218:SF356', NULL, NULL, NULL, NULL, '', 250962),
(408709, 'PTHR10218:SF355', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN G(O) SUBUNIT ALPHA', 250962),
(408710, 'PTHR10218:SF354', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN (G PROTEIN), ALPHA 15 (GQ CLASS), TANDEM DUPLICATE 4', 250962),
(408711, 'PTHR10218:SF233', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN G(OLF) SUBUNIT ALPHA', 250962),
(408712, 'PTHR10218:SF232', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN ALPHA-1 SUBUNIT', 250962),
(408713, 'PTHR10218:SF199', NULL, NULL, NULL, NULL, 'DEVELOPMENTAL PROTEIN DG1120', 250962),
(408714, 'PTHR10218:SF353', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN ALPHA-11 SUBUNIT', 250962),
(408715, 'PTHR10218:SF316', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN G(Q) SUBUNIT ALPHA', 250962),
(408716, 'PTHR10218:SF359', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN G(I) SUBUNIT ALPHA-1', 250962),
(408717, 'PTHR10218:SF315', NULL, NULL, NULL, NULL, '', 250962),
(408718, 'PTHR10218:SF358', NULL, NULL, NULL, NULL, 'EXTRA-LARGE GUANINE NUCLEOTIDE-BINDING PROTEIN 1', 250962),
(408719, 'PTHR10218:SF116', NULL, NULL, NULL, NULL, 'G PROTEIN, ALPHA SUBUNIT', 250962),
(408720, 'PTHR10218:SF357', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN G(S) SUBUNIT ALPHA', 250962),
(408721, 'PTHR10218:SF68', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN G(T) SUBUNIT ALPHA-2', 250962),
(408722, 'PTHR10218:SF67', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN G(T) SUBUNIT ALPHA-1', 250962),
(408723, 'PTHR10218:SF66', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN G(T) SUBUNIT ALPHA-3', 250962),
(408724, 'PTHR10218:SF317', NULL, NULL, NULL, NULL, 'EXTRA-LARGE GUANINE NUCLEOTIDE-BINDING PROTEIN 3-LIKE', 250962),
(408725, 'PTHR10218:SF65', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN G(Z) SUBUNIT ALPHA', 250962),
(408726, 'PTHR10218:SF85', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT ALPHA-13', 250962),
(408727, 'PTHR10218:SF180', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN ALPHA-4 SUBUNIT-RELATED', 250962),
(408728, 'PTHR10218:SF301', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN ALPHA-9 SUBUNIT', 250962);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(408729, 'PTHR10218:SF343', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN ALPHA-2 SUBUNIT', 250962),
(408730, 'PTHR10218:SF222', NULL, NULL, NULL, NULL, 'EXTRA-LARGE GUANINE NUCLEOTIDE-BINDING PROTEIN 1', 250962),
(408731, 'PTHR10218:SF188', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN ALPHA-7 SUBUNIT', 250962),
(408732, 'PTHR10218:SF349', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN ALPHA-4 SUBUNIT', 250962),
(408733, 'PTHR10218:SF348', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN G(S) SUBUNIT ALPHA ISOFORMS XLAS', 250962),
(408734, 'PTHR10218:SF227', NULL, NULL, NULL, NULL, 'G PROTEIN ALPHA I SUBUNIT', 250962),
(408735, 'PTHR10218:SF347', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN (G PROTEIN), ALPHA-INHIBITING ACTIVITY POLYPEPTIDE A', 250962),
(408736, 'PTHR10218:SF225', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN ALPHA-10 SUBUNIT', 250962),
(408737, 'PTHR10218:SF302', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT ALPHA HOMOLOG', 250962),
(408738, 'PTHR10218:SF308', NULL, NULL, NULL, NULL, 'EXTRA-LARGE GTP-BINDING PROTEIN', 250962),
(408739, 'PTHR15507:SF18', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN RLF', 250963),
(408740, 'PTHR15507:SF16', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 654', 250963),
(408741, 'PTHR15507:SF17', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 250963),
(408742, 'PTHR15507', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN RLF', 250963),
(408743, 'PTHR15507:SF14', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 292', 250963),
(408744, 'PTHR43806:SF11', NULL, NULL, NULL, NULL, 'CEREVISIN-RELATED', 250964),
(408745, 'PTHR43806:SF34', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT5.4', 250964),
(408746, 'PTHR43806:SF57', NULL, NULL, NULL, NULL, 'SUBTILASE-TYPE PROTEINASE PSP3', 250964),
(408747, 'PTHR43806:SF13', NULL, NULL, NULL, NULL, 'SUBTILASE-TYPE PROTEINASE RRT12', 250964),
(408748, 'PTHR43806:SF35', NULL, NULL, NULL, NULL, 'SERINE PROTEINASE 1, PUTATIVE-RELATED', 250964),
(408749, 'PTHR43806:SF14', NULL, NULL, NULL, NULL, 'TRIPEPTIDYL-PEPTIDASE 2', 250964),
(408750, 'PTHR43806:SF58', NULL, NULL, NULL, NULL, 'ALKALINE PROTEASE 1-RELATED', 250964),
(408751, 'PTHR43806:SF40', NULL, NULL, NULL, NULL, 'BNAC02G33520D PROTEIN', 250964),
(408752, 'PTHR43806:SF62', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT6.1', 250964),
(408753, 'PTHR43806:SF63', NULL, NULL, NULL, NULL, 'PEPTIDASE_S8 DOMAIN-CONTAINING PROTEIN', 250964),
(408754, 'PTHR43806:SF41', NULL, NULL, NULL, NULL, 'PEPTIDASE_S8 DOMAIN-CONTAINING PROTEIN', 250964),
(408755, 'PTHR43806:SF64', NULL, NULL, NULL, NULL, '', 250964),
(408756, 'PTHR43806:SF42', NULL, NULL, NULL, NULL, 'TRIPEPTIDYL-PEPTIDASE II', 250964),
(408757, 'PTHR43806:SF65', NULL, NULL, NULL, NULL, 'SERINE PROTEASE APRX', 250964),
(408758, 'PTHR43806:SF60', NULL, NULL, NULL, NULL, 'PROPROTEIN CONVERTASE SUBTILISIN/KEXIN TYPE 9', 250964),
(408759, 'PTHR43806:SF7', NULL, NULL, NULL, NULL, 'MEMBRANE-BOUND TRANSCRIPTION FACTOR SITE-1 PROTEASE', 250964),
(408760, 'PTHR43806:SF50', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT3.1-RELATED', 250964),
(408761, 'PTHR43806:SF61', NULL, NULL, NULL, NULL, 'PEPTIDASE_S8 DOMAIN-CONTAINING PROTEIN', 250964),
(408762, 'PTHR43806', NULL, NULL, NULL, NULL, 'PEPTIDASE S8', 250964),
(408763, 'PTHR43806:SF59', NULL, NULL, NULL, NULL, 'EXTRACELLULAR PROTEASE', 250964),
(408764, 'PTHR43806:SF38', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT5.4', 250964),
(408765, 'PTHR43806:SF39', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT1.9', 250964),
(408766, 'PTHR35811:SF1', NULL, NULL, NULL, NULL, 'HTH OST-TYPE DOMAIN-CONTAINING PROTEIN', 250965),
(408767, 'PTHR35811', NULL, NULL, NULL, NULL, 'SLR1870 PROTEIN', 250965),
(408768, 'PTHR12646', NULL, NULL, NULL, NULL, 'NOT56 - RELATED', 250966),
(408769, 'PTHR12646:SF1', NULL, NULL, NULL, NULL, '', 250966),
(408770, 'PTHR12646:SF0', NULL, NULL, NULL, NULL, 'DOL-P-MAN:MAN(5)GLCNAC(2)-PP-DOL ALPHA-1,3-MANNOSYLTRANSFERASE', 250966);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(408771, 'PTHR34289:SF1', NULL, NULL, NULL, NULL, 'OS06G0107100 PROTEIN', 250967),
(408772, 'PTHR34289:SF3', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF819)-RELATED', 250967),
(408773, 'PTHR34289:SF5', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN (DUF819)', 250967),
(408774, 'PTHR34289:SF8', NULL, NULL, NULL, NULL, '', 250967),
(408775, 'PTHR34289:SF7', NULL, NULL, NULL, NULL, '', 250967),
(408776, 'PTHR34289', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF819)-RELATED', 250967),
(408777, 'PTHR34847', NULL, NULL, NULL, NULL, 'NODULATION PROTEIN U', 250968),
(408778, 'PTHR34847:SF1', NULL, NULL, NULL, NULL, 'NODULATION PROTEIN U', 250968),
(408779, 'PTHR28375:SF1', NULL, NULL, NULL, NULL, 'PROTEIN HINDERIN', 250969),
(408780, 'PTHR28375', NULL, NULL, NULL, NULL, 'PROTEIN HINDERIN', 250969),
(408781, 'PTHR47709', NULL, NULL, NULL, NULL, 'SHORT TRANSMEMBRANE MITOCHONDRIAL PROTEIN 1', 250970),
(408782, 'PTHR47709:SF2', NULL, NULL, NULL, NULL, 'SHORT TRANSMEMBRANE MITOCHONDRIAL PROTEIN 1', 250970),
(408783, 'PTHR46390:SF1', NULL, NULL, NULL, NULL, 'MANNOSE-1-PHOSPHATE GUANYLYLTRANSFERASE', 250971),
(408784, 'PTHR46390', NULL, NULL, NULL, NULL, 'MANNOSE-1-PHOSPHATE GUANYLYLTRANSFERASE', 250971),
(408785, 'PTHR43117', NULL, NULL, NULL, NULL, 'OSMOPROTECTANT IMPORT ATP-BINDING PROTEIN OSMV', 250972),
(408786, 'PTHR43117:SF3', NULL, NULL, NULL, NULL, 'GLYCINE BETAINE/CARNITINE/CHOLINE TRANSPORT ATP-BINDING PROTEIN OPUCA', 250972),
(408787, 'PTHR43117:SF4', NULL, NULL, NULL, NULL, 'OSMOPROTECTANT IMPORT ATP-BINDING PROTEIN OSMV', 250972),
(408788, 'PTHR43117:SF5', NULL, NULL, NULL, NULL, 'GLYCINE BETAINE UPTAKE SYSTEM ATP-BINDING PROTEIN YEHX', 250972),
(408789, 'PTHR22811:SF171', NULL, NULL, NULL, NULL, 'GOLD DOMAIN-CONTAINING PROTEIN', 250973),
(408790, 'PTHR22811', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN', 250973),
(408791, 'PTHR22811:SF130', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN P24DELTA3-LIKE', 250973),
(408792, 'PTHR22811:SF174', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN P24BETA2-LIKE', 250973),
(408793, 'PTHR22811:SF173', NULL, NULL, NULL, NULL, 'COAT PROTEIN, PUTATIVE-RELATED', 250973),
(408794, 'PTHR22811:SF132', NULL, NULL, NULL, NULL, 'EMP24/GP25L/P24 FAMILY/GOLD FAMILY PROTEIN-RELATED', 250973),
(408795, 'PTHR22811:SF175', NULL, NULL, NULL, NULL, 'EMP24/GP25L/P24 FAMILY/GOLD FAMILY PROTEIN-RELATED', 250973),
(408796, 'PTHR22811:SF68', NULL, NULL, NULL, NULL, 'OS02G0768200 PROTEIN', 250973),
(408797, 'PTHR22811:SF178', NULL, NULL, NULL, NULL, 'GOLD DOMAIN-CONTAINING PROTEIN', 250973),
(408798, 'PTHR22811:SF133', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN P24DELTA10', 250973),
(408799, 'PTHR22811:SF177', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN 2', 250973),
(408800, 'PTHR22811:SF135', NULL, NULL, NULL, NULL, 'GOLD DOMAIN-CONTAINING PROTEIN', 250973),
(408801, 'PTHR22811:SF179', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN 10', 250973),
(408802, 'PTHR22811:SF138', NULL, NULL, NULL, NULL, 'GOLD DOMAIN-CONTAINING PROTEIN', 250973),
(408803, 'PTHR22811:SF73', NULL, NULL, NULL, NULL, 'OS09G0453200 PROTEIN', 250973),
(408804, 'PTHR22811:SF139', NULL, NULL, NULL, NULL, 'EMP24/GP25L/P24 FAMILY/GOLD PROTEIN', 250973),
(408805, 'PTHR22811:SF72', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN P24DELTA9', 250973),
(408806, 'PTHR22811:SF77', NULL, NULL, NULL, NULL, 'GOLD DOMAIN-CONTAINING PROTEIN', 250973),
(408807, 'PTHR22811:SF161', NULL, NULL, NULL, NULL, 'GOLD DOMAIN-CONTAINING PROTEIN', 250973),
(408808, 'PTHR22811:SF163', NULL, NULL, NULL, NULL, 'TMP21-RELATED PROTEIN-RELATED', 250973),
(408809, 'PTHR22811:SF31', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN P24BETA3', 250973),
(408810, 'PTHR22811:SF74', NULL, NULL, NULL, NULL, 'GOLD DOMAIN-CONTAINING PROTEIN', 250973),
(408811, 'PTHR22811:SF165', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN P24DELTA7', 250973);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(408812, 'PTHR22811:SF37', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN 9', 250973),
(408813, 'PTHR22811:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN 11', 250973),
(408814, 'PTHR22811:SF164', NULL, NULL, NULL, NULL, 'GOLD DOMAIN-CONTAINING PROTEIN', 250973),
(408815, 'PTHR22811:SF167', NULL, NULL, NULL, NULL, 'TMP21-RELATED PROTEIN-RELATED', 250973),
(408816, 'PTHR22811:SF200', NULL, NULL, NULL, NULL, 'TMP21-RELATED PROTEIN-RELATED', 250973),
(408817, 'PTHR22811:SF123', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN P24BETA2-LIKE ISOFORM X1', 250973),
(408818, 'PTHR22811:SF166', NULL, NULL, NULL, NULL, 'GOLD DOMAIN-CONTAINING PROTEIN', 250973),
(408819, 'PTHR22811:SF38', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN 4', 250973),
(408820, 'PTHR22811:SF209', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN P24DELTA9-LIKE', 250973),
(408821, 'PTHR22811:SF169', NULL, NULL, NULL, NULL, 'GOLD DOMAIN-CONTAINING PROTEIN', 250973),
(408822, 'PTHR22811:SF202', NULL, NULL, NULL, NULL, 'GOLD DOMAIN-CONTAINING PROTEIN', 250973),
(408823, 'PTHR22811:SF80', NULL, NULL, NULL, NULL, 'PROTEIN ERP2-RELATED', 250973),
(408824, 'PTHR22811:SF201', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN P24DELTA9-LIKE', 250973),
(408825, 'PTHR22811:SF168', NULL, NULL, NULL, NULL, 'GOLD DOMAIN-CONTAINING PROTEIN', 250973),
(408826, 'PTHR22811:SF127', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN P24DELTA5', 250973),
(408827, 'PTHR22811:SF204', NULL, NULL, NULL, NULL, 'EMP24/GP25L/P24 FAMILY/GOLD FAMILY PROTEIN-RELATED', 250973),
(408828, 'PTHR22811:SF126', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN P24DELTA3-LIKE', 250973),
(408829, 'PTHR22811:SF203', NULL, NULL, NULL, NULL, 'EMP24 DOMAIN-CONTAINING PROTEIN, PUTATIVE-RELATED', 250973),
(408830, 'PTHR22811:SF206', NULL, NULL, NULL, NULL, 'EMP24/GP25L/P24 FAMILY PROTEIN', 250973),
(408831, 'PTHR22811:SF129', NULL, NULL, NULL, NULL, 'OS07G0632700 PROTEIN', 250973),
(408832, 'PTHR22811:SF40', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN 1', 250973),
(408833, 'PTHR22811:SF205', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN P24BETA3-LIKE', 250973),
(408834, 'PTHR22811:SF128', NULL, NULL, NULL, NULL, 'GOLD DOMAIN-CONTAINING PROTEIN', 250973),
(408835, 'PTHR22811:SF208', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN P24DELTA11', 250973),
(408836, 'PTHR22811:SF207', NULL, NULL, NULL, NULL, 'GOLD DOMAIN-CONTAINING PROTEIN', 250973),
(408837, 'PTHR22811:SF43', NULL, NULL, NULL, NULL, 'GOLD DOMAIN-CONTAINING PROTEIN', 250973),
(408838, 'PTHR22811:SF196', NULL, NULL, NULL, NULL, 'GOLD DOMAIN-CONTAINING PROTEIN', 250973),
(408839, 'PTHR22811:SF151', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN A', 250973),
(408840, 'PTHR22811:SF195', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN P24BETA3-LIKE', 250973),
(408841, 'PTHR22811:SF41', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN 5', 250973),
(408842, 'PTHR22811:SF154', NULL, NULL, NULL, NULL, 'GOLD DOMAIN-CONTAINING PROTEIN', 250973),
(408843, 'PTHR22811:SF198', NULL, NULL, NULL, NULL, 'EMP24/GP25L/P24 FAMILY/GOLD FAMILY PROTEIN-RELATED', 250973),
(408844, 'PTHR22811:SF153', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN P24DELTA3', 250973),
(408845, 'PTHR22811:SF46', NULL, NULL, NULL, NULL, 'PROTEIN ERP3', 250973),
(408846, 'PTHR22811:SF156', NULL, NULL, NULL, NULL, 'GOLD DOMAIN-CONTAINING PROTEIN', 250973),
(408847, 'PTHR22811:SF45', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN 6', 250973),
(408848, 'PTHR22811:SF155', NULL, NULL, NULL, NULL, 'GOLD DOMAIN-CONTAINING PROTEIN', 250973),
(408849, 'PTHR22811:SF190', NULL, NULL, NULL, NULL, 'GOLD DOMAIN-CONTAINING PROTEIN', 250973),
(408850, 'PTHR22811:SF192', NULL, NULL, NULL, NULL, 'GOLD DOMAIN-CONTAINING PROTEIN', 250973);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(408851, 'PTHR22811:SF158', NULL, NULL, NULL, NULL, 'GOLD DOMAIN-CONTAINING PROTEIN', 250973),
(408852, 'PTHR22811:SF159', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN P24DELTA4', 250973),
(408853, 'PTHR22811:SF118', NULL, NULL, NULL, NULL, 'PROTEIN ERP1-RELATED', 250973),
(408854, 'PTHR22811:SF50', NULL, NULL, NULL, NULL, 'RE49489P', 250973),
(408855, 'PTHR22811:SF117', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN 7', 250973),
(408856, 'PTHR22811:SF119', NULL, NULL, NULL, NULL, 'GOLD DOMAIN-CONTAINING PROTEIN', 250973),
(408857, 'PTHR22811:SF183', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN 10', 250973),
(408858, 'PTHR22811:SF182', NULL, NULL, NULL, NULL, 'GOLD DOMAIN-CONTAINING PROTEIN', 250973),
(408859, 'PTHR22811:SF185', NULL, NULL, NULL, NULL, 'VESICLE MEMBRANE PROTEIN ERV25, PUTATIVE-RELATED', 250973),
(408860, 'PTHR22811:SF140', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN P24BETA2', 250973),
(408861, 'PTHR22811:SF184', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN 10', 250973),
(408862, 'PTHR22811:SF187', NULL, NULL, NULL, NULL, 'GOLD DOMAIN-CONTAINING PROTEIN', 250973),
(408863, 'PTHR22811:SF143', NULL, NULL, NULL, NULL, 'EMP24/GP25L/P24 FAMILY/GOLD PROTEIN', 250973),
(408864, 'PTHR22811:SF59', NULL, NULL, NULL, NULL, 'GOLD DOMAIN-CONTAINING PROTEIN-RELATED', 250973),
(408865, 'PTHR22811:SF14', NULL, NULL, NULL, NULL, 'LP01981P-RELATED', 250973),
(408866, 'PTHR22811:SF142', NULL, NULL, NULL, NULL, 'EMP24/GP25L/P24', 250973),
(408867, 'PTHR22811:SF57', NULL, NULL, NULL, NULL, 'GOLD DOMAIN-CONTAINING PROTEIN', 250973),
(408868, 'PTHR22811:SF145', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN P24DELTA7-LIKE', 250973),
(408869, 'PTHR22811:SF144', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN P24DELTA6', 250973),
(408870, 'PTHR22811:SF188', NULL, NULL, NULL, NULL, 'GOLD DOMAIN-CONTAINING PROTEIN', 250973),
(408871, 'PTHR22811:SF149', NULL, NULL, NULL, NULL, 'EMP24/GP25L/P24 FAMILY PROTEIN', 250973),
(408872, 'PTHR22811:SF60', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN 3', 250973),
(408873, 'PTHR10209:SF460', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408874, 'PTHR10209:SF502', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408875, 'PTHR10209:SF744', NULL, NULL, NULL, NULL, 'FLAVANONE 3-DIOXYGENASE-RELATED', 250974),
(408876, 'PTHR10209:SF749', NULL, NULL, NULL, NULL, '2-OXOACID DEPENDENT DIOXYGENASE-RELATED', 250974),
(408877, 'PTHR10209:SF628', NULL, NULL, NULL, NULL, 'DIOX_N DOMAIN-CONTAINING PROTEIN', 250974),
(408878, 'PTHR10209:SF860', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE HOMOLOG', 250974),
(408879, 'PTHR10209:SF861', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408880, 'PTHR10209:SF741', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408881, 'PTHR10209:SF862', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408882, 'PTHR10209:SF863', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408883, 'PTHR10209:SF742', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE HOMOLOG 4-RELATED', 250974),
(408884, 'PTHR10209:SF864', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408885, 'PTHR10209:SF743', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408886, 'PTHR10209:SF172', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408887, 'PTHR10209:SF690', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408888, 'PTHR10209:SF579', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408889, 'PTHR10209:SF854', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408890, 'PTHR10209:SF458', NULL, NULL, NULL, NULL, 'DIOX_N DOMAIN-CONTAINING PROTEIN', 250974);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(408891, 'PTHR10209:SF855', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408892, 'PTHR10209:SF734', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408893, 'PTHR10209:SF856', NULL, NULL, NULL, NULL, 'GIBBERELLIN-44 DIOXYGENASE-RELATED', 250974),
(408894, 'PTHR10209:SF857', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408895, 'PTHR10209:SF858', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE-DEPENDENT DIOXYGENASE 19', 250974),
(408896, 'PTHR10209:SF737', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408897, 'PTHR10209:SF738', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408898, 'PTHR10209:SF859', NULL, NULL, NULL, NULL, 'CME8 PROTEIN', 250974),
(408899, 'PTHR10209:SF739', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408900, 'PTHR10209:SF450', NULL, NULL, NULL, NULL, 'AMINOCYCLOPROPANECARBOXYLATE OXIDASE', 250974),
(408901, 'PTHR10209:SF695', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE-DEPENDENT DIOXYGENASE', 250974),
(408902, 'PTHR10209:SF850', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 250974),
(408903, 'PTHR10209:SF730', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE HOMOLOG', 250974),
(408904, 'PTHR10209:SF851', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408905, 'PTHR10209:SF731', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408906, 'PTHR10209:SF698', NULL, NULL, NULL, NULL, 'PROTEIN DMR6-LIKE OXYGENASE 1', 250974),
(408907, 'PTHR10209:SF852', NULL, NULL, NULL, NULL, 'BNAA01G36310D PROTEIN', 250974),
(408908, 'PTHR10209:SF853', NULL, NULL, NULL, NULL, '2-OXOACID DEPENDENT DIOXYGENASE-RELATED', 250974),
(408909, 'PTHR10209:SF732', NULL, NULL, NULL, NULL, 'FLAVONOL SYNTHASE/FLAVANONE 3-HYDROXYLASE-LIKE', 250974),
(408910, 'PTHR10209:SF524', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE HOMOLOG', 250974),
(408911, 'PTHR10209:SF801', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE HOMOLOG 1-LIKE', 250974),
(408912, 'PTHR10209', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE, 2OG-FE II  OXYGENASE FAMILY PROTEIN', 250974),
(408913, 'PTHR10209:SF804', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN-RELATED', 250974),
(408914, 'PTHR10209:SF805', NULL, NULL, NULL, NULL, 'PROTEIN DMR6-LIKE OXYGENASE 2-LIKE', 250974),
(408915, 'PTHR10209:SF760', NULL, NULL, NULL, NULL, 'BNAC03G40750D PROTEIN', 250974),
(408916, 'PTHR10209:SF243', NULL, NULL, NULL, NULL, 'FERULOYL COA ORTHO-HYDROXYLASE 1-RELATED', 250974),
(408917, 'PTHR10209:SF123', NULL, NULL, NULL, NULL, '2OG-FE(II) OXYGENASE FAMILY OXIDOREDUCTASE', 250974),
(408918, 'PTHR10209:SF762', NULL, NULL, NULL, NULL, 'PROTEIN DOWNY MILDEW RESISTANCE 6', 250974),
(408919, 'PTHR10209:SF765', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN-RELATED', 250974),
(408920, 'PTHR10209:SF590', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 250974),
(408921, 'PTHR10209:SF591', NULL, NULL, NULL, NULL, '2OG-FE(II) OXYGENASE FAMILY OXIDOREDUCTASE', 250974),
(408922, 'PTHR10209:SF755', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408923, 'PTHR10209:SF513', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408924, 'PTHR10209:SF757', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 250974),
(408925, 'PTHR10209:SF759', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408926, 'PTHR10209:SF518', NULL, NULL, NULL, NULL, 'PROTEIN DOWNY MILDEW RESISTANCE 6', 250974),
(408927, 'PTHR10209:SF230', NULL, NULL, NULL, NULL, 'SCOPOLETIN 8-HYDROXYLASE', 250974),
(408928, 'PTHR10209:SF473', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE HOMOLOG 10-RELATED', 250974);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(408929, 'PTHR10209:SF751', NULL, NULL, NULL, NULL, 'OS06G0255100 PROTEIN', 250974),
(408930, 'PTHR10209:SF753', NULL, NULL, NULL, NULL, 'FERULOYL COA ORTHO-HYDROXYLASE 2-LIKE', 250974),
(408931, 'PTHR10209:SF754', NULL, NULL, NULL, NULL, 'ISOPENICILLIN N SYNTHASE-LIKE PROTEIN-RELATED', 250974),
(408932, 'PTHR10209:SF818', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408933, 'PTHR10209:SF819', NULL, NULL, NULL, NULL, 'DESACETOXYVINDOLINE 4-HYDROXYLASE', 250974),
(408934, 'PTHR10209:SF546', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE HOMOLOG 4-LIKE', 250974),
(408935, 'PTHR10209:SF789', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408936, 'PTHR10209:SF822', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE', 250974),
(408937, 'PTHR10209:SF428', NULL, NULL, NULL, NULL, 'OS04G0182200 PROTEIN', 250974),
(408938, 'PTHR10209:SF825', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 250974),
(408939, 'PTHR10209:SF429', NULL, NULL, NULL, NULL, 'DEACETOXYVINDOLINE 4-HYDROXYLASE-LIKE', 250974),
(408940, 'PTHR10209:SF826', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE HOMOLOG 1-LIKE', 250974),
(408941, 'PTHR10209:SF705', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE HOMOLOG 8', 250974),
(408942, 'PTHR10209:SF827', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 250974),
(408943, 'PTHR10209:SF828', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408944, 'PTHR10209:SF781', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE HOMOLOG', 250974),
(408945, 'PTHR10209:SF782', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408946, 'PTHR10209:SF662', NULL, NULL, NULL, NULL, 'OS01G0536400 PROTEIN', 250974),
(408947, 'PTHR10209:SF145', NULL, NULL, NULL, NULL, 'DIBOA-GLUCOSIDE DIOXYGENASE BX6', 250974),
(408948, 'PTHR10209:SF784', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE HOMOLOG 3', 250974),
(408949, 'PTHR10209:SF542', NULL, NULL, NULL, NULL, 'FERULOYL COA ORTHO-HYDROXYLASE 2-LIKE', 250974),
(408950, 'PTHR10209:SF786', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408951, 'PTHR10209:SF787', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE HOMOLOG 1', 250974),
(408952, 'PTHR10209:SF820', NULL, NULL, NULL, NULL, 'FERULOYL COA ORTHO-HYDROXYLASE 2-LIKE', 250974),
(408953, 'PTHR10209:SF492', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408954, 'PTHR10209:SF251', NULL, NULL, NULL, NULL, 'PROTEIN DMR6-LIKE OXYGENASE 2', 250974),
(408955, 'PTHR10209:SF810', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408956, 'PTHR10209:SF535', NULL, NULL, NULL, NULL, 'FLAVONOL SYNTHASE/FLAVANONE 3-HYDROXYLASE-LIKE ISOFORM X1', 250974),
(408957, 'PTHR10209:SF811', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 250974),
(408958, 'PTHR10209:SF812', NULL, NULL, NULL, NULL, '2OG-FE(II) OXYGENASE FAMILY, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G14880)-RELATED', 250974),
(408959, 'PTHR10209:SF813', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 250974),
(408960, 'PTHR10209:SF770', NULL, NULL, NULL, NULL, 'FERULOYL COA ORTHO-HYDROXYLASE 1-LIKE', 250974),
(408961, 'PTHR10209:SF771', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE HOMOLOG 1-LIKE', 250974),
(408962, 'PTHR10209:SF772', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408963, 'PTHR10209:SF773', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408964, 'PTHR10209:SF775', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN-RELATED', 250974),
(408965, 'PTHR10209:SF534', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(408966, 'PTHR10209:SF776', NULL, NULL, NULL, NULL, '2OG-FE(II) OXYGENASE FAMILY OXIDOREDUCTASE', 250974),
(408967, 'PTHR10209:SF722', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408968, 'PTHR10209:SF843', NULL, NULL, NULL, NULL, 'FLAVONOL SYNTHASE/FLAVANONE 3-HYDROXYLASE', 250974),
(408969, 'PTHR10209:SF448', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408970, 'PTHR10209:SF844', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE-DEPENDENT DIOXYGENASE', 250974),
(408971, 'PTHR10209:SF845', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE HOMOLOG 1-LIKE', 250974),
(408972, 'PTHR10209:SF846', NULL, NULL, NULL, NULL, 'OXYGENASE FAMILY OXIDOREDUCTASE, PUTATIVE-RELATED', 250974),
(408973, 'PTHR10209:SF847', NULL, NULL, NULL, NULL, 'SI:DKEY-10O6.2', 250974),
(408974, 'PTHR10209:SF726', NULL, NULL, NULL, NULL, 'OS07G0169600 PROTEIN', 250974),
(408975, 'PTHR10209:SF848', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408976, 'PTHR10209:SF728', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408977, 'PTHR10209:SF849', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE HOMOLOG 1-LIKE', 250974),
(408978, 'PTHR10209:SF729', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408979, 'PTHR10209:SF608', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408980, 'PTHR10209:SF840', NULL, NULL, NULL, NULL, 'OS03G0860600 PROTEIN', 250974),
(408981, 'PTHR10209:SF720', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408982, 'PTHR10209:SF841', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE HOMOLOG 1-LIKE', 250974),
(408983, 'PTHR10209:SF842', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE HOMOLOG 1-LIKE', 250974),
(408984, 'PTHR10209:SF829', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408985, 'PTHR10209:SF832', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408986, 'PTHR10209:SF711', NULL, NULL, NULL, NULL, 'DIOXYGENASE, PUTATIVE-RELATED', 250974),
(408987, 'PTHR10209:SF712', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE HOMOLOG 6', 250974),
(408988, 'PTHR10209:SF833', NULL, NULL, NULL, NULL, 'GIBBERELLIN 2-BETA-DIOXYGENASE', 250974),
(408989, 'PTHR10209:SF834', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408990, 'PTHR10209:SF714', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408991, 'PTHR10209:SF835', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408992, 'PTHR10209:SF836', NULL, NULL, NULL, NULL, '2OG-FE(II) OXYGENASE FAMILY OXIDOREDUCTASE', 250974),
(408993, 'PTHR10209:SF837', NULL, NULL, NULL, NULL, 'OXOGLUTARATE/IRON-DEPENDENT DIOXYGENASE-RELATED', 250974),
(408994, 'PTHR10209:SF838', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE HOMOLOG 12', 250974),
(408995, 'PTHR10209:SF839', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(408996, 'PTHR10209:SF791', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE HOMOLOG 2', 250974),
(408997, 'PTHR10209:SF792', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE HOMOLOG', 250974),
(408998, 'PTHR10209:SF672', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE-DEPENDENT DIOXYGENASE', 250974),
(408999, 'PTHR10209:SF793', NULL, NULL, NULL, NULL, '2-OXOACID DEPENDENT DIOXYGENASE-RELATED', 250974),
(409000, 'PTHR10209:SF794', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 250974),
(409001, 'PTHR10209:SF432', NULL, NULL, NULL, NULL, 'DIOX_N DOMAIN-CONTAINING PROTEIN', 250974),
(409002, 'PTHR10209:SF553', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 250974),
(409003, 'PTHR10209:SF830', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', 250974);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(409004, 'PTHR10209:SF797', NULL, NULL, NULL, NULL, 'OXIDASE, PUTATIVE-RELATED', 250974),
(409005, 'PTHR10209:SF434', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE HOMOLOG 11', 250974),
(409006, 'PTHR10209:SF831', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE OXIDASE HOMOLOG 1-LIKE', 250974),
(409007, 'PTHR31854', NULL, NULL, NULL, NULL, 'TUBULIN POLYGLUTAMYLASE COMPLEX SUBUNIT 2', 250975),
(409008, 'PTHR31854:SF2', NULL, NULL, NULL, NULL, 'TUBULIN POLYGLUTAMYLASE COMPLEX SUBUNIT 2', 250975),
(409009, 'PTHR12350:SF5', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 250976),
(409010, 'PTHR12350', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE-RELATED', 250976),
(409011, 'PTHR12350:SF21', NULL, NULL, NULL, NULL, '', 250976),
(409012, 'PTHR12350:SF18', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 250976),
(409013, 'PTHR12350:SF19', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 250976),
(409014, 'PTHR11200:SF145', NULL, NULL, NULL, NULL, 'TYPE II INOSITOL POLYPHOSPHATE 5-PHOSPHATASE 15', 250977),
(409015, 'PTHR11200:SF268', NULL, NULL, NULL, NULL, 'TYPE II INOSITOL POLYPHOSPHATE 5-PHOSPHATASE 14', 250977),
(409016, 'PTHR11200:SF127', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4,5-BISPHOSPHATE 5-PHOSPHATASE A', 250977),
(409017, 'PTHR11200:SF269', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4,5-BISPHOSPHATE 5-PHOSPHATASE INP51', 250977),
(409018, 'PTHR11200:SF148', NULL, NULL, NULL, NULL, 'SYNAPTOJANIN-2', 250977),
(409019, 'PTHR11200:SF280', NULL, NULL, NULL, NULL, 'TYPE I INOSITOL POLYPHOSPHATE 5-PHOSPHATASE 12-LIKE ISOFORM X1', 250977),
(409020, 'PTHR11200:SF281', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4,5-BISPHOSPHATE 5-PHOSPHATASE INP54', 250977),
(409021, 'PTHR11200:SF240', NULL, NULL, NULL, NULL, 'INOSITOL POLYPHOSPHATE 5-PHOSPHATASE C9G1.10C-RELATED', 250977),
(409022, 'PTHR11200:SF284', NULL, NULL, NULL, NULL, 'LD06095P', 250977),
(409023, 'PTHR11200:SF185', NULL, NULL, NULL, NULL, 'TYPE II INOSITOL POLYPHOSPHATE 5-PHOSPHATASE 15', 250977),
(409024, 'PTHR11200:SF163', NULL, NULL, NULL, NULL, 'TYPE II INOSITOL 1,4,5-TRISPHOSPHATE 5-PHOSPHATASE', 250977),
(409025, 'PTHR11200:SF283', NULL, NULL, NULL, NULL, 'IPPC DOMAIN-CONTAINING PROTEIN', 250977),
(409026, 'PTHR11200:SF261', NULL, NULL, NULL, NULL, 'TYPE I INOSITOL POLYPHOSPHATE 5-PHOSPHATASE 12', 250977),
(409027, 'PTHR11200:SF286', NULL, NULL, NULL, NULL, '5-PHOSPHATASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G07600)-RELATED', 250977),
(409028, 'PTHR11200:SF263', NULL, NULL, NULL, NULL, 'INOSITOL 5-PHOSPHATASE', 250977),
(409029, 'PTHR11200:SF277', NULL, NULL, NULL, NULL, 'IPPC DOMAIN-CONTAINING PROTEIN', 250977),
(409030, 'PTHR11200:SF298', NULL, NULL, NULL, NULL, 'INOSITOL-POLYPHOSPHATE 5-PHOSPHATASE', 250977),
(409031, 'PTHR11200:SF276', NULL, NULL, NULL, NULL, 'BREVIS PLANT1', 250977),
(409032, 'PTHR11200:SF279', NULL, NULL, NULL, NULL, 'IPPC DOMAIN-CONTAINING PROTEIN', 250977),
(409033, 'PTHR11200:SF158', NULL, NULL, NULL, NULL, 'SYNAPTOJANIN-1', 250977),
(409034, 'PTHR11200:SF257', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE 5-PHOSPHATASE', 250977),
(409035, 'PTHR11200:SF117', NULL, NULL, NULL, NULL, 'INOSITOL POLYPHOSPHATE 5-PHOSPHATASE K', 250977),
(409036, 'PTHR11200:SF291', NULL, NULL, NULL, NULL, 'INOSITOL 5-PHOSPHATASE', 250977),
(409037, 'PTHR11200', NULL, NULL, NULL, NULL, 'INOSITOL 5-PHOSPHATASE', 250977),
(409038, 'PTHR11200:SF293', NULL, NULL, NULL, NULL, 'INOSITOL-POLYPHOSPHATE 5-PHOSPHATASE', 250977),
(409039, 'PTHR11200:SF292', NULL, NULL, NULL, NULL, 'PHOSPHATASE, PUTATIVE-RELATED', 250977),
(409040, 'PTHR11200:SF295', NULL, NULL, NULL, NULL, 'INOSITOL POLYPHOSPHATE 5-PHOSPHATASE', 250977),
(409041, 'PTHR11200:SF272', NULL, NULL, NULL, NULL, 'TYPE I INOSITOL POLYPHOSPHATE 5-PHOSPHATASE 13', 250977),
(409042, 'PTHR11200:SF294', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE 5-PHOSPHATASE', 250977),
(409043, 'PTHR11200:SF275', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE 5-PHOSPHATASE', 250977),
(409044, 'PTHR11200:SF297', NULL, NULL, NULL, NULL, 'IPPC DOMAIN-CONTAINING PROTEIN', 250977);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(409045, 'PTHR11200:SF176', NULL, NULL, NULL, NULL, 'INOSITOL POLYPHOSPHATE 5-PHOSPHATASE OCRL', 250977),
(409046, 'PTHR11200:SF274', NULL, NULL, NULL, NULL, 'LOW QUALITY PROTEIN: TYPE I INOSITOL POLYPHOSPHATE 5-PHOSPHATASE 12-LIKE', 250977),
(409047, 'PTHR11200:SF296', NULL, NULL, NULL, NULL, 'INOSITOL-1,4,5-TRISPHOSPHATE 5-PHOSPHATASE 2', 250977),
(409048, 'PTHR31686', NULL, NULL, NULL, NULL, '', 250978),
(409049, 'PTHR31686:SF1', NULL, NULL, NULL, NULL, 'SULFITE EFFLUX PUMP SSU1', 250978),
(409050, 'PTHR31686:SF2', NULL, NULL, NULL, NULL, 'C4-DICARBOXYLATE TRANSPORTER/MALIC ACID TRANSPORT PROTEIN', 250978),
(409051, 'PTHR31686:SF3', NULL, NULL, NULL, NULL, 'ACID TRANSPORT PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G09410)-RELATED', 250978),
(409052, 'PTHR14359:SF28', NULL, NULL, NULL, NULL, 'BNAA01G27100D PROTEIN', 250979),
(409053, 'PTHR14359:SF17', NULL, NULL, NULL, NULL, 'PHOSPHOPANTOTHENOYLCYSTEINE DECARBOXYLASE SUBUNIT SIS2-RELATED', 250979),
(409054, 'PTHR14359:SF29', NULL, NULL, NULL, NULL, 'PHOSPHOPANTOTHENOYLCYSTEINE DECARBOXYLASE-LIKE', 250979),
(409055, 'PTHR14359:SF19', NULL, NULL, NULL, NULL, 'FLAVOPROTEIN', 250979),
(409056, 'PTHR14359:SF23', NULL, NULL, NULL, NULL, '', 250979),
(409057, 'PTHR14359:SF26', NULL, NULL, NULL, NULL, 'PHOSPHOPANTOTHENOYLCYSTEINE DECARBOXYLASE-RELATED', 250979),
(409058, 'PTHR14359:SF6', NULL, NULL, NULL, NULL, 'PHOSPHOPANTOTHENOYLCYSTEINE DECARBOXYLASE', 250979),
(409059, 'PTHR14359', NULL, NULL, NULL, NULL, 'HOMO-OLIGOMERIC FLAVIN CONTAINING CYS DECARBOXYLASE FAMILY', 250979),
(409060, 'PTHR14359:SF21', NULL, NULL, NULL, NULL, 'FLAVOPROTEIN DOMAIN-CONTAINING PROTEIN', 250979),
(409061, 'PTHR10134:SF43', NULL, NULL, NULL, NULL, 'CYTOCHROME BC1 COMPLEX RIESKE IRON-SULFUR SUBUNIT', 250980),
(409062, 'PTHR10134:SF42', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT RIESKE, MITOCHONDRIAL', 250980),
(409063, 'PTHR10134:SF20', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT RIESKE, MITOCHONDRIAL-RELATED', 250980),
(409064, 'PTHR10134:SF41', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT RIESKE-4, MITOCHONDRIAL-LIKE', 250980),
(409065, 'PTHR10134:SF40', NULL, NULL, NULL, NULL, 'QUINOL--CYTOCHROME-C REDUCTASE', 250980),
(409066, 'PTHR10134', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT RIESKE, MITOCHONDRIAL', 250980),
(409067, 'PTHR10134:SF46', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT RIESKE, MITOCHONDRIAL', 250980),
(409068, 'PTHR10134:SF45', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT RIESKE, MITOCHONDRIAL', 250980),
(409069, 'PTHR10134:SF33', NULL, NULL, NULL, NULL, 'RIESKE IRON-SULFUR PROTEIN, CYTOCHROME B6-F COMPLEX FE-S SUBUNIT-RELATED', 250980),
(409070, 'PTHR10134:SF44', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT RIESKE, MITOCHONDRIAL', 250980),
(409071, 'PTHR10134:SF38', NULL, NULL, NULL, NULL, 'PLASTOQUINOL--PLASTOCYANIN REDUCTASE', 250980),
(409072, 'PTHR12370', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE B-RELATED', 250981),
(409073, 'PTHR12370:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE B-LIKE 1', 250981),
(409074, 'PTHR12370:SF26', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE B-LIKE PROTEIN A', 250981),
(409075, 'PTHR12370:SF3', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE B-LIKE 2-RELATED', 250981),
(409076, 'PTHR12370:SF2', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE B-LIKE PROTEIN F', 250981),
(409077, 'PTHR12370:SF4', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE B-LIKE PROTEIN B-RELATED', 250981),
(409078, 'PTHR12370:SF24', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE B-LIKE', 250981),
(409079, 'PTHR12370:SF7', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE B-LIKE 2-RELATED', 250981),
(409080, 'PTHR12370:SF25', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE B-LIKE PROTEIN G', 250981),
(409081, 'PTHR12370:SF8', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE B-LIKE 3-RELATED', 250981),
(409082, 'PTHR12370:SF21', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE B-LIKE PROTEIN E', 250981),
(409083, 'PTHR15294:SF3', NULL, NULL, NULL, NULL, 'SUMO-SPECIFIC ISOPEPTIDASE USPL1', 250982),
(409084, 'PTHR15294', NULL, NULL, NULL, NULL, 'RETINOVIN-RELATED', 250982);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(409085, 'PTHR22045:SF6', NULL, NULL, NULL, NULL, 'PROLINE AND SERINE-RICH PROTEIN 3', 250983),
(409086, 'PTHR22045', NULL, NULL, NULL, NULL, 'PROLINE AND SERINE-RICH PROTEIN 3', 250983),
(409087, 'PTHR13408', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE III', 250984),
(409088, 'PTHR13408:SF7', NULL, NULL, NULL, NULL, '', 250984),
(409089, 'PTHR13408:SF6', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE III SUBUNIT RPC4-LIKE ISOFORM X1', 250984),
(409090, 'PTHR13408:SF5', NULL, NULL, NULL, NULL, 'POLYMERASE (RNA) III (DNA DIRECTED) POLYPEPTIDE D', 250984),
(409091, 'PTHR13408:SF11', NULL, NULL, NULL, NULL, 'RNA POLYMERASE III RPC4-RELATED', 250984),
(409092, 'PTHR13408:SF4', NULL, NULL, NULL, NULL, 'RNA POLYMERASE III RPC4', 250984),
(409093, 'PTHR13408:SF10', NULL, NULL, NULL, NULL, '', 250984),
(409094, 'PTHR13408:SF13', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE III SUBUNIT RPC4-LIKE ISOFORM X1', 250984),
(409095, 'PTHR13408:SF1', NULL, NULL, NULL, NULL, 'ZGC:171971', 250984),
(409096, 'PTHR13408:SF12', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE III SUBUNIT RPC4-RELATED', 250984),
(409097, 'PTHR13408:SF0', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE III SUBUNIT RPC4', 250984),
(409098, 'PTHR13408:SF9', NULL, NULL, NULL, NULL, '', 250984),
(409099, 'PTHR12087:SF0', NULL, NULL, NULL, NULL, 'ORIGIN RECOGNITION COMPLEX SUBUNIT 4', 250985),
(409100, 'PTHR12087', NULL, NULL, NULL, NULL, 'ORIGIN RECOGNITION COMPLEX SUBUNIT 4', 250985),
(409101, 'PTHR10972:SF46', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN-RELATED PROTEIN 11', 250986),
(409102, 'PTHR10972:SF47', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN-RELATED PROTEIN 10', 250986),
(409103, 'PTHR10972:SF171', NULL, NULL, NULL, NULL, 'OSBP(OXYSTEROL-BINDING PROTEIN)-RELATED PROTEIN 1C', 250986),
(409104, 'PTHR10972:SF170', NULL, NULL, NULL, NULL, 'OSBP(OXYSTEROL-BINDING PROTEIN)-RELATED PROTEIN 4C', 250986),
(409105, 'PTHR10972:SF210', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN HOMOLOG C354.07C', 250986),
(409106, 'PTHR10972:SF87', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN 10', 250986),
(409107, 'PTHR10972:SF88', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN-RELATED PROTEIN 2B', 250986),
(409108, 'PTHR10972:SF175', NULL, NULL, NULL, NULL, 'BNAANNG16330D PROTEIN', 250986),
(409109, 'PTHR10972:SF174', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 250986),
(409110, 'PTHR10972:SF136', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN 8', 250986),
(409111, 'PTHR10972:SF211', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN-RELATED PROTEIN 2A', 250986),
(409112, 'PTHR10972:SF85', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN-RELATED PROTEIN 7', 250986),
(409113, 'PTHR10972:SF92', NULL, NULL, NULL, NULL, 'OXYSTEROL BINDING PROTEIN', 250986),
(409114, 'PTHR10972:SF166', NULL, NULL, NULL, NULL, 'OSBP(OXYSTEROL-BINDING PROTEIN)-RELATED PROTEIN 4C', 250986),
(409115, 'PTHR10972:SF76', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN-RELATED PROTEIN 6', 250986),
(409116, 'PTHR10972:SF165', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN-RELATED PROTEIN 3A', 250986),
(409117, 'PTHR10972:SF164', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN-RELATED PROTEIN 3B', 250986),
(409118, 'PTHR10972:SF78', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN 1-RELATED', 250986),
(409119, 'PTHR10972:SF163', NULL, NULL, NULL, NULL, 'OSBP(OXYSTEROL-BINDING PROTEIN)-RELATED PROTEIN 1C', 250986),
(409120, 'PTHR10972:SF203', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN HOMOLOG 3', 250986),
(409121, 'PTHR10972:SF202', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN 11', 250986),
(409122, 'PTHR10972:SF168', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 250986),
(409123, 'PTHR10972:SF167', NULL, NULL, NULL, NULL, 'OSBP(OXYSTEROL-BINDING PROTEIN)-RELATED PROTEIN 4C', 250986),
(409124, 'PTHR10972:SF200', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN-RELATED PROTEIN 9', 250986),
(409125, 'PTHR10972:SF207', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN-RELATED PROTEIN 8', 250986);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(409126, 'PTHR10972:SF206', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN 1', 250986),
(409127, 'PTHR10972:SF205', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN 1', 250986),
(409128, 'PTHR10972:SF204', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN-RELATED PROTEIN 4C', 250986),
(409129, 'PTHR10972:SF209', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN', 250986),
(409130, 'PTHR10972:SF208', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN-RELATED PROTEIN 1C-LIKE ISOFORM X1', 250986),
(409131, 'PTHR10972', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN-RELATED', 250986),
(409132, 'PTHR10972:SF191', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN, PH DOMAIN-LIKE PROTEIN-RELATED', 250986),
(409133, 'PTHR10972:SF194', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN 2', 250986),
(409134, 'PTHR10972:SF150', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN', 250986),
(409135, 'PTHR10972:SF193', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY (PH) DOMAIN SUPERFAMILY PROTEIN', 250986),
(409136, 'PTHR10972:SF192', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN-RELATED PROTEIN 1B-LIKE', 250986),
(409137, 'PTHR10972:SF199', NULL, NULL, NULL, NULL, 'BNAC03G36060D PROTEIN', 250986),
(409138, 'PTHR10972:SF155', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN-RELATED PROTEIN 2A', 250986),
(409139, 'PTHR10972:SF153', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN-RELATED PROTEIN 2', 250986),
(409140, 'PTHR10972:SF197', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN 6', 250986),
(409141, 'PTHR10972:SF152', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN 7', 250986),
(409142, 'PTHR10972:SF67', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN-RELATED PROTEIN 1D', 250986),
(409143, 'PTHR10972:SF70', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN', 250986),
(409144, 'PTHR10972:SF180', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING FAMILY PROTEIN-RELATED', 250986),
(409145, 'PTHR10972:SF184', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN HOMOLOG 4-RELATED', 250986),
(409146, 'PTHR10972:SF15', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN-RELATED PROTEIN 3', 250986),
(409147, 'PTHR10972:SF53', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN-RELATED PROTEIN 1', 250986),
(409148, 'PTHR10972:SF186', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN-RELATED PROTEIN 1B-LIKE ISOFORM X1', 250986),
(409149, 'PTHR10972:SF141', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN', 250986),
(409150, 'PTHR10972:SF148', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN 9', 250986),
(409151, 'PTHR10972:SF102', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN-RELATED PROTEIN 5', 250986),
(409152, 'PTHR10972:SF146', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN', 250986),
(409153, 'PTHR10972:SF96', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN-RELATED PROTEIN 1A-RELATED', 250986),
(409154, 'PTHR10972:SF109', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN 12', 250986),
(409155, 'PTHR33203:SF36', NULL, NULL, NULL, NULL, 'OLEOSIN', 250987),
(409156, 'PTHR33203:SF57', NULL, NULL, NULL, NULL, 'OLEOSIN', 250987),
(409157, 'PTHR33203:SF35', NULL, NULL, NULL, NULL, 'OLEOSIN 14.9 KDA', 250987),
(409158, 'PTHR33203:SF37', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN / OLEOSIN', 250987),
(409159, 'PTHR33203:SF59', NULL, NULL, NULL, NULL, 'OLEOSIN', 250987),
(409160, 'PTHR33203:SF32', NULL, NULL, NULL, NULL, 'OLEOSIN 21.2 KDA', 250987),
(409161, 'PTHR33203:SF54', NULL, NULL, NULL, NULL, 'OLEOSIN', 250987),
(409162, 'PTHR33203:SF31', NULL, NULL, NULL, NULL, 'OLEOSIN', 250987),
(409163, 'PTHR33203:SF53', NULL, NULL, NULL, NULL, 'OLEOSIN', 250987),
(409164, 'PTHR33203:SF56', NULL, NULL, NULL, NULL, 'OS06G0473800 PROTEIN', 250987),
(409165, 'PTHR33203:SF55', NULL, NULL, NULL, NULL, 'OLEOSIN', 250987),
(409166, 'PTHR33203:SF52', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN-RELATED', 250987),
(409167, 'PTHR33203:SF51', NULL, NULL, NULL, NULL, 'BNAA01G26680D PROTEIN', 250987),
(409168, 'PTHR33203:SF2', NULL, NULL, NULL, NULL, 'OS01G0643900 PROTEIN', 250987),
(409169, 'PTHR33203:SF4', NULL, NULL, NULL, NULL, 'F27J15.22', 250987);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(409170, 'PTHR33203:SF1', NULL, NULL, NULL, NULL, 'OLEOSIN', 250987),
(409171, 'PTHR33203', NULL, NULL, NULL, NULL, 'OLEOSIN', 250987),
(409172, 'PTHR33203:SF29', NULL, NULL, NULL, NULL, 'OLEOSIN FAMILY PROTEIN', 250987),
(409173, 'PTHR33203:SF28', NULL, NULL, NULL, NULL, 'OLEOSIN FAMILY PROTEIN', 250987),
(409174, 'PTHR33203:SF47', NULL, NULL, NULL, NULL, 'BNAA09G02110D PROTEIN', 250987),
(409175, 'PTHR33203:SF25', NULL, NULL, NULL, NULL, 'OLEOSIN 18.5 KDA', 250987),
(409176, 'PTHR33203:SF46', NULL, NULL, NULL, NULL, 'OLEOSIN', 250987),
(409177, 'PTHR33203:SF24', NULL, NULL, NULL, NULL, 'OLEOSIN', 250987),
(409178, 'PTHR33203:SF49', NULL, NULL, NULL, NULL, 'OLEOSIN GRP-17', 250987),
(409179, 'PTHR33203:SF26', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN-RELATED', 250987),
(409180, 'PTHR33203:SF21', NULL, NULL, NULL, NULL, 'OLEOSIN 1-LIKE', 250987),
(409181, 'PTHR33203:SF43', NULL, NULL, NULL, NULL, 'OLEOSIN', 250987),
(409182, 'PTHR33203:SF42', NULL, NULL, NULL, NULL, 'BNAC02G01560D PROTEIN', 250987),
(409183, 'PTHR33203:SF45', NULL, NULL, NULL, NULL, 'OLEOSIN', 250987),
(409184, 'PTHR33203:SF23', NULL, NULL, NULL, NULL, 'OLEOSIN', 250987),
(409185, 'PTHR33203:SF22', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN 20-RELATED', 250987),
(409186, 'PTHR33203:SF44', NULL, NULL, NULL, NULL, 'OLEOSIN 20.3 KDA', 250987),
(409187, 'PTHR33203:SF61', NULL, NULL, NULL, NULL, 'OLEOSIN 5', 250987),
(409188, 'PTHR33203:SF63', NULL, NULL, NULL, NULL, 'OLEOSIN 18.2 KDA', 250987),
(409189, 'PTHR33203:SF41', NULL, NULL, NULL, NULL, 'OLEOSIN', 250987),
(409190, 'PTHR15811', NULL, NULL, NULL, NULL, 'MTH938 DOMAIN-CONTAINING PROTEIN', 250988),
(409191, 'PTHR15811:SF5', NULL, NULL, NULL, NULL, 'MTH938 DOMAIN-CONTAINING PROTEIN', 250988),
(409192, 'PTHR32319', NULL, NULL, NULL, NULL, 'BACTERIAL HEMOLYSIN-LIKE PROTEIN', 250989),
(409193, 'PTHR32319:SF0', NULL, NULL, NULL, NULL, 'BACTERIAL HEMOLYSIN-LIKE PROTEIN', 250989),
(409194, 'PTHR32319:SF5', NULL, NULL, NULL, NULL, 'S4 RNA-BINDING DOMAIN-CONTAINING PROTEIN', 250989),
(409195, 'PTHR42964:SF1', NULL, NULL, NULL, NULL, 'POLYKETIDE BIOSYNTHESIS ENOYL-COA HYDRATASE PKSH-RELATED', 250990),
(409196, 'PTHR42964', NULL, NULL, NULL, NULL, 'ENOYL-COA HYDRATASE', 250990),
(409197, 'PTHR35104:SF13', NULL, NULL, NULL, NULL, 'OS07G0573200 PROTEIN', 250991),
(409198, 'PTHR35104:SF14', NULL, NULL, NULL, NULL, 'BNAANNG27570D PROTEIN', 250991),
(409199, 'PTHR35104:SF11', NULL, NULL, NULL, NULL, 'BNAA03G47950D PROTEIN', 250991),
(409200, 'PTHR35104:SF12', NULL, NULL, NULL, NULL, 'BNAC03G13420D PROTEIN', 250991),
(409201, 'PTHR35104:SF17', NULL, NULL, NULL, NULL, 'BNAC06G41640D PROTEIN', 250991),
(409202, 'PTHR35104:SF15', NULL, NULL, NULL, NULL, '', 250991),
(409203, 'PTHR35104:SF9', NULL, NULL, NULL, NULL, 'BNAC03G70500D PROTEIN', 250991),
(409204, 'PTHR35104:SF6', NULL, NULL, NULL, NULL, 'OS03G0807000 PROTEIN', 250991),
(409205, 'PTHR35104:SF19', NULL, NULL, NULL, NULL, 'BNAA05G25800D PROTEIN', 250991),
(409206, 'PTHR35104', NULL, NULL, NULL, NULL, 'OS03G0807000 PROTEIN', 250991),
(409207, 'PTHR48166', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250992),
(409208, 'PTHR48166:SF1', NULL, NULL, NULL, NULL, 'OSJNBA0031O09.02', 250992),
(409209, 'PTHR48166:SF3', NULL, NULL, NULL, NULL, '', 250992),
(409210, 'PTHR48166:SF4', NULL, NULL, NULL, NULL, 'OS03G0142900 PROTEIN', 250992),
(409211, 'PTHR34575:SF6', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 250993),
(409212, 'PTHR34575:SF5', NULL, NULL, NULL, NULL, 'OS02G0773500 PROTEIN', 250993),
(409213, 'PTHR34575:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PAM68, CHLOROPLASTIC', 250993),
(409214, 'PTHR34575', NULL, NULL, NULL, NULL, 'PROTEIN PAM68, CHLOROPLASTIC', 250993),
(409215, 'PTHR38663', NULL, NULL, NULL, NULL, '', 250994),
(409216, 'PTHR38663:SF1', NULL, NULL, NULL, NULL, 'L-ORNITHINE N(5)-MONOOXYGENASE', 250994),
(409217, 'PTHR21495:SF208', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409218, 'PTHR21495:SF160', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409219, 'PTHR21495:SF161', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN 1-RELATED', 250995);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(409220, 'PTHR21495:SF162', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409221, 'PTHR21495:SF240', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409222, 'PTHR21495:SF78', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409223, 'PTHR21495:SF163', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN 15', 250995),
(409224, 'PTHR21495:SF164', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409225, 'PTHR21495:SF241', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409226, 'PTHR21495:SF242', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409227, 'PTHR21495:SF243', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409228, 'PTHR21495:SF166', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409229, 'PTHR21495:SF244', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409230, 'PTHR21495:SF200', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409231, 'PTHR21495:SF167', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409232, 'PTHR21495:SF245', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409233, 'PTHR21495:SF169', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409234, 'PTHR21495:SF246', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409235, 'PTHR21495:SF247', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409236, 'PTHR21495:SF203', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409237, 'PTHR21495:SF204', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409238, 'PTHR21495:SF248', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409239, 'PTHR21495:SF249', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN 17-RELATED', 250995),
(409240, 'PTHR21495:SF206', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409241, 'PTHR21495', NULL, NULL, NULL, NULL, 'NUCLEOPORIN-RELATED', 250995),
(409242, 'PTHR21495:SF192', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409243, 'PTHR21495:SF193', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409244, 'PTHR21495:SF194', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409245, 'PTHR21495:SF195', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409246, 'PTHR21495:SF196', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409247, 'PTHR21495:SF152', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409248, 'PTHR21495:SF230', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409249, 'PTHR21495:SF197', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409250, 'PTHR21495:SF198', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409251, 'PTHR21495:SF231', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN 19', 250995),
(409252, 'PTHR21495:SF155', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409253, 'PTHR21495:SF156', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409254, 'PTHR21495:SF233', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409255, 'PTHR21495:SF234', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409256, 'PTHR21495:SF235', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409257, 'PTHR21495:SF158', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409258, 'PTHR21495:SF236', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409259, 'PTHR21495:SF237', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409260, 'PTHR21495:SF238', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409261, 'PTHR21495:SF239', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409262, 'PTHR21495:SF181', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409263, 'PTHR21495:SF182', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN 4', 250995),
(409264, 'PTHR21495:SF140', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409265, 'PTHR21495:SF185', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409266, 'PTHR21495:SF142', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409267, 'PTHR21495:SF186', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409268, 'PTHR21495:SF54', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409269, 'PTHR21495:SF143', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(409270, 'PTHR21495:SF187', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409271, 'PTHR21495:SF220', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409272, 'PTHR21495:SF188', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409273, 'PTHR21495:SF145', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN 22-RELATED', 250995),
(409274, 'PTHR21495:SF52', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409275, 'PTHR21495:SF189', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409276, 'PTHR21495:SF222', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409277, 'PTHR21495:SF223', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409278, 'PTHR21495:SF224', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409279, 'PTHR21495:SF50', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409280, 'PTHR21495:SF226', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409281, 'PTHR21495:SF149', NULL, NULL, NULL, NULL, 'PTEROCARPAN SYNTHASE 1', 250995),
(409282, 'PTHR21495:SF219', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409283, 'PTHR21495:SF170', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN 20', 250995),
(409284, 'PTHR21495:SF171', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409285, 'PTHR21495:SF47', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409286, 'PTHR21495:SF250', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409287, 'PTHR21495:SF174', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409288, 'PTHR21495:SF89', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409289, 'PTHR21495:SF251', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409290, 'PTHR21495:SF252', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409291, 'PTHR21495:SF175', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409292, 'PTHR21495:SF253', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409293, 'PTHR21495:SF176', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409294, 'PTHR21495:SF210', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409295, 'PTHR21495:SF177', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409296, 'PTHR21495:SF254', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409297, 'PTHR21495:SF255', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409298, 'PTHR21495:SF211', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409299, 'PTHR21495:SF85', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409300, 'PTHR21495:SF212', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409301, 'PTHR21495:SF179', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409302, 'PTHR21495:SF213', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409303, 'PTHR21495:SF215', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409304, 'PTHR21495:SF80', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN 23', 250995),
(409305, 'PTHR21495:SF216', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409306, 'PTHR21495:SF217', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 250995),
(409307, 'PTHR21495:SF218', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN 7', 250995),
(409308, 'PTHR12195:SF3', NULL, NULL, NULL, NULL, 'CYTOPLASMIC FMR1-INTERACTING PROTEIN 2', 250996),
(409309, 'PTHR12195:SF4', NULL, NULL, NULL, NULL, 'CYTOPLASMIC FMR1-INTERACTING PROTEIN 1', 250996),
(409310, 'PTHR12195', NULL, NULL, NULL, NULL, 'CYTOPLASMIC FMR1-INTERACTING PROTEIN-RELATED', 250996),
(409311, 'PTHR12195:SF0', NULL, NULL, NULL, NULL, 'CYTOPLASMIC FMR1-INTERACTING PROTEIN', 250996),
(409312, 'PTHR43392:SF2', NULL, NULL, NULL, NULL, 'AAA-TYPE ATPASE FAMILY PROTEIN / ANKYRIN REPEAT FAMILY PROTEIN', 250997),
(409313, 'PTHR43392:SF5', NULL, NULL, NULL, NULL, '', 250997),
(409314, 'PTHR43392', NULL, NULL, NULL, NULL, 'AAA-TYPE ATPASE FAMILY PROTEIN / ANKYRIN REPEAT FAMILY PROTEIN', 250997),
(409315, 'PTHR43392:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CFXQ HOMOLOG', 250997),
(409316, 'PTHR45176', NULL, NULL, NULL, NULL, 'TRANSDUCIN FAMILY PROTEIN / WD-40 REPEAT FAMILY PROTEIN-RELATED', 250998),
(409317, 'PTHR45176:SF1', NULL, NULL, NULL, NULL, 'TRANSDUCIN FAMILY PROTEIN / WD-40 REPEAT FAMILY PROTEIN-RELATED', 250998);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(409318, 'PTHR46225:SF3', NULL, NULL, NULL, NULL, 'OS09G0323100 PROTEIN', 250999),
(409319, 'PTHR46225:SF2', NULL, NULL, NULL, NULL, 'C3H4 TYPE ZINC FINGER PROTEIN', 250999),
(409320, 'PTHR46225:SF1', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 250999),
(409321, 'PTHR46225:SF7', NULL, NULL, NULL, NULL, 'SUPERFAMILY PROTEIN, PUTATIVE-RELATED', 250999),
(409322, 'PTHR46225:SF6', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 250999),
(409323, 'PTHR46225:SF19', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 250999),
(409324, 'PTHR46225', NULL, NULL, NULL, NULL, 'C3H4 TYPE ZINC FINGER PROTEIN', 250999),
(409325, 'PTHR46225:SF13', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE-RELATED', 250999),
(409326, 'PTHR46225:SF24', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C2H2 FAMILY-RELATED', 250999),
(409327, 'PTHR46225:SF14', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING-CH-TYPE, ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 250999),
(409328, 'PTHR46225:SF25', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN-RELATED', 250999),
(409329, 'PTHR46225:SF23', NULL, NULL, NULL, NULL, 'OS05G0179000 PROTEIN', 250999),
(409330, 'PTHR46225:SF18', NULL, NULL, NULL, NULL, 'BNAA09G56630D PROTEIN', 250999),
(409331, 'PTHR46225:SF16', NULL, NULL, NULL, NULL, 'BNAA10G10110D PROTEIN', 250999),
(409332, 'PTHR46225:SF9', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 250999),
(409333, 'PTHR46225:SF8', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 250999),
(409334, 'PTHR35502:SF2', NULL, NULL, NULL, NULL, 'PROTEIN MICROTUBULE BINDING PROTEIN 2C', 251000),
(409335, 'PTHR35502:SF3', NULL, NULL, NULL, NULL, 'BNAANNG06260D PROTEIN', 251000),
(409336, 'PTHR35502', NULL, NULL, NULL, NULL, 'PROTEIN MICROTUBULE BINDING PROTEIN 2C', 251000),
(409337, 'PTHR35502:SF1', NULL, NULL, NULL, NULL, 'OS09G0476000 PROTEIN', 251000),
(409338, 'PTHR39408', NULL, NULL, NULL, NULL, 'MUCIN-21', 251001),
(409339, 'PTHR39408:SF3', NULL, NULL, NULL, NULL, 'MUCIN-21', 251001),
(409340, 'PTHR39329:SF1', NULL, NULL, NULL, NULL, 'ETHANOLAMINE AMMONIA-LYASE LARGE SUBUNIT', 251002),
(409341, 'PTHR39329', NULL, NULL, NULL, NULL, 'ETHANOLAMINE AMMONIA-LYASE HEAVY CHAIN', 251002),
(409342, 'PTHR14396', NULL, NULL, NULL, NULL, 'CLASPIN', 251003),
(409343, 'PTHR14396:SF10', NULL, NULL, NULL, NULL, 'CLASPIN', 251003),
(409344, 'PTHR16219', NULL, NULL, NULL, NULL, 'AUGMIN SUBUNIT 4 FAMILY MEMBER', 251004),
(409345, 'PTHR16219:SF1', NULL, NULL, NULL, NULL, 'HAUS AUGMIN-LIKE COMPLEX SUBUNIT 4', 251004),
(409346, 'PTHR16219:SF2', NULL, NULL, NULL, NULL, 'BNAA06G02620D PROTEIN', 251004),
(409347, 'PTHR13384:SF16', NULL, NULL, NULL, NULL, 'GROWTH REGULATION PROTEIN', 251005),
(409348, 'PTHR13384', NULL, NULL, NULL, NULL, 'G PATCH DOMAIN-CONTAINING PROTEIN 1', 251005),
(409349, 'PTHR13384:SF19', NULL, NULL, NULL, NULL, 'G PATCH DOMAIN-CONTAINING PROTEIN 1', 251005),
(409350, 'PTHR13384:SF21', NULL, NULL, NULL, NULL, 'SURP MOTIF DOMAIN-CONTAINING PROTEIN', 251005),
(409351, 'PTHR45763:SF25', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 251006),
(409352, 'PTHR45763:SF68', NULL, NULL, NULL, NULL, 'HYDROLASE, ALPHA/BETA FOLD FAMILY PROTEIN, EXPRESSED', 251006),
(409353, 'PTHR45763:SF46', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251006),
(409354, 'PTHR45763:SF24', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 251006),
(409355, 'PTHR45763:SF45', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 251006),
(409356, 'PTHR45763:SF67', NULL, NULL, NULL, NULL, 'ALPHA/BETA HYDROLASE FOLD PROTEIN-RELATED', 251006),
(409357, 'PTHR45763:SF23', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251006),
(409358, 'PTHR45763:SF22', NULL, NULL, NULL, NULL, 'ALPHA/BETA HYDROLASE FAMILY PROTEIN', 251006),
(409359, 'PTHR45763:SF66', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251006),
(409360, 'PTHR45763:SF44', NULL, NULL, NULL, NULL, 'BNAA08G27060D PROTEIN', 251006),
(409361, 'PTHR45763:SF28', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 251006);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(409362, 'PTHR45763:SF49', NULL, NULL, NULL, NULL, 'OS01G0859200 PROTEIN', 251006),
(409363, 'PTHR45763:SF48', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN-RELATED', 251006),
(409364, 'PTHR45763:SF26', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251006),
(409365, 'PTHR45763:SF61', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251006),
(409366, 'PTHR45763:SF60', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251006),
(409367, 'PTHR45763:SF65', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251006),
(409368, 'PTHR45763:SF21', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 251006),
(409369, 'PTHR45763:SF43', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251006),
(409370, 'PTHR45763:SF42', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 251006),
(409371, 'PTHR45763:SF64', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251006),
(409372, 'PTHR45763:SF63', NULL, NULL, NULL, NULL, 'ALPHA/BETA FOLD FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 251006),
(409373, 'PTHR45763:SF40', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251006),
(409374, 'PTHR45763:SF62', NULL, NULL, NULL, NULL, 'OS02G0532300 PROTEIN', 251006),
(409375, 'PTHR45763:SF36', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251006),
(409376, 'PTHR45763:SF14', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 251006),
(409377, 'PTHR45763:SF13', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251006),
(409378, 'PTHR45763:SF34', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251006),
(409379, 'PTHR45763:SF18', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251006),
(409380, 'PTHR45763:SF38', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251006),
(409381, 'PTHR45763:SF59', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 251006),
(409382, 'PTHR45763:SF15', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 251006),
(409383, 'PTHR45763', NULL, NULL, NULL, NULL, 'HYDROLASE, ALPHA/BETA FOLD FAMILY PROTEIN, EXPRESSED-RELATED', 251006),
(409384, 'PTHR45763:SF54', NULL, NULL, NULL, NULL, 'HYDROLASE, ALPHA/BETA FOLD FAMILY PROTEIN, EXPRESSED', 251006),
(409385, 'PTHR45763:SF31', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 251006),
(409386, 'PTHR45763:SF51', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 251006),
(409387, 'PTHR45763:SF7', NULL, NULL, NULL, NULL, 'ALPHA/BETA FOLD FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 251006),
(409388, 'PTHR45763:SF8', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 251006),
(409389, 'PTHR45763:SF19', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 251006),
(409390, 'PTHR10732:SF21', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S17', 251007),
(409391, 'PTHR10732:SF10', NULL, NULL, NULL, NULL, '', 251007),
(409392, 'PTHR10732:SF7', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S17-1-RELATED', 251007),
(409393, 'PTHR10732:SF23', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S17', 251007),
(409394, 'PTHR10732:SF22', NULL, NULL, NULL, NULL, 'BNAA03G01450D PROTEIN', 251007),
(409395, 'PTHR10732', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S17', 251007),
(409396, 'PTHR10732:SF9', NULL, NULL, NULL, NULL, '', 251007),
(409397, 'PTHR10732:SF14', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S17', 251007),
(409398, 'PTHR10732:SF16', NULL, NULL, NULL, NULL, 'BNAA04G26860D PROTEIN', 251007),
(409399, 'PTHR10732:SF18', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S17-LIKE', 251007),
(409400, 'PTHR10732:SF0', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S17', 251007),
(409401, 'PTHR31333:SF4', NULL, NULL, NULL, NULL, 'PWWP DOMAIN-CONTAINING DNA REPAIR FACTOR 3A', 251008),
(409402, 'PTHR31333:SF3', NULL, NULL, NULL, NULL, 'PWWP DOMAIN-CONTAINING DNA REPAIR FACTOR 3B', 251008);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(409403, 'PTHR31333:SF2', NULL, NULL, NULL, NULL, 'PWWP DOMAIN-CONTAINING 4', 251008),
(409404, 'PTHR31333', NULL, NULL, NULL, NULL, 'PWWP DOMAIN-CONTAINING DNA REPAIR FACTOR 3 FAMILY MEMBER', 251008),
(409405, 'PTHR31333:SF6', NULL, NULL, NULL, NULL, 'SI:DKEY-57K2.7', 251008),
(409406, 'PTHR30565:SF9', NULL, NULL, NULL, NULL, 'PROTEIN YCIF', 251009),
(409407, 'PTHR30565', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 251009),
(409408, 'PTHR35001:SF3', NULL, NULL, NULL, NULL, 'COLLAGEN IV NC1 DOMAIN-CONTAINING PROTEIN', 251010),
(409409, 'PTHR35001:SF1', NULL, NULL, NULL, NULL, '', 251010),
(409410, 'PTHR35001', NULL, NULL, NULL, NULL, 'COLLAGEN IV NC1 DOMAIN-CONTAINING PROTEIN', 251010),
(409411, 'PTHR21677', NULL, NULL, NULL, NULL, 'CRAMPED PROTEIN', 251011),
(409412, 'PTHR21677:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CRAMPED-LIKE', 251011),
(409413, 'PTHR21677:SF5', NULL, NULL, NULL, NULL, 'OS07G0634100 PROTEIN', 251011),
(409414, 'PTHR21677:SF4', NULL, NULL, NULL, NULL, 'TSL-KINASE INTERACTING-LIKE PROTEIN', 251011),
(409415, 'PTHR21677:SF7', NULL, NULL, NULL, NULL, 'MYB DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 251011),
(409416, 'PTHR21677:SF6', NULL, NULL, NULL, NULL, '', 251011),
(409417, 'PTHR47363', NULL, NULL, NULL, NULL, 'GLUCOKINASE', 251012),
(409418, 'PTHR47363:SF1', NULL, NULL, NULL, NULL, 'GLUCOKINASE', 251012),
(409419, 'PTHR36728:SF2', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT O, CHLOROPLASTIC', 251013),
(409420, 'PTHR36728', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT O, CHLOROPLASTIC', 251013),
(409421, 'PTHR31758', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN YLR108C', 251014),
(409422, 'PTHR31758:SF2', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN YLR108C', 251014),
(409423, 'PTHR31503:SF18', NULL, NULL, NULL, NULL, 'CA(2+)/H(+) EXCHANGER, PUTATIVE (EUROFUNG)-RELATED', 251015),
(409424, 'PTHR31503:SF54', NULL, NULL, NULL, NULL, 'VACUOLAR CATION/PROTON EXCHANGER', 251015),
(409425, 'PTHR31503:SF10', NULL, NULL, NULL, NULL, 'CATION/H+ EXCHANGER PROTEIN 1-RELATED', 251015),
(409426, 'PTHR31503:SF76', NULL, NULL, NULL, NULL, 'VACUOLAR CATION/PROTON EXCHANGER', 251015),
(409427, 'PTHR31503:SF55', NULL, NULL, NULL, NULL, 'BNAA05G14600D PROTEIN', 251015),
(409428, 'PTHR31503:SF78', NULL, NULL, NULL, NULL, 'CALMODULIN', 251015),
(409429, 'PTHR31503:SF79', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF-HAND PROTEIN', 251015),
(409430, 'PTHR31503:SF58', NULL, NULL, NULL, NULL, 'VACUOLAR CATION/PROTON EXCHANGER', 251015),
(409431, 'PTHR31503:SF14', NULL, NULL, NULL, NULL, 'VACUOLAR CALCIUM ION TRANSPORTER', 251015),
(409432, 'PTHR31503:SF36', NULL, NULL, NULL, NULL, 'SODIUM/CALCIUM EXCHANGER NCL', 251015),
(409433, 'PTHR31503:SF37', NULL, NULL, NULL, NULL, 'VACUOLAR CATION/PROTON EXCHANGER 1B', 251015),
(409434, 'PTHR31503:SF59', NULL, NULL, NULL, NULL, 'VACUOLAR CATION/PROTON EXCHANGER', 251015),
(409435, 'PTHR31503:SF80', NULL, NULL, NULL, NULL, 'SODIUM/CALCIUM EXCHANGER NCL2-LIKE', 251015),
(409436, 'PTHR31503:SF81', NULL, NULL, NULL, NULL, '', 251015),
(409437, 'PTHR31503:SF82', NULL, NULL, NULL, NULL, 'BNAC03G69500D PROTEIN', 251015),
(409438, 'PTHR31503:SF83', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN PAIR-RELATED', 251015),
(409439, 'PTHR31503', NULL, NULL, NULL, NULL, 'VACUOLAR CALCIUM ION TRANSPORTER', 251015),
(409440, 'PTHR31503:SF84', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF-HAND FAMILY PROTEIN', 251015),
(409441, 'PTHR31503:SF85', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF-HAND FAMILY PROTEIN', 251015),
(409442, 'PTHR31503:SF86', NULL, NULL, NULL, NULL, 'VACUOLAR CATION/PROTON EXCHANGER', 251015),
(409443, 'PTHR31503:SF42', NULL, NULL, NULL, NULL, 'VACUOLAR CATION/PROTON EXCHANGER', 251015),
(409444, 'PTHR31503:SF20', NULL, NULL, NULL, NULL, 'CA(2+)/H(+) EXCHANGER, PUTATIVE (EUROFUNG)-RELATED', 251015),
(409445, 'PTHR31503:SF1', NULL, NULL, NULL, NULL, 'VACUOLAR CATION/PROTON EXCHANGER 3', 251015),
(409446, 'PTHR31503:SF43', NULL, NULL, NULL, NULL, 'VACUOLAR CATION/PROTON EXCHANGER 1', 251015);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(409447, 'PTHR31503:SF87', NULL, NULL, NULL, NULL, 'SODIUM/CALCIUM EXCHANGER MEMBRANE REGION, EF-HAND DOMAIN PAIR-RELATED', 251015),
(409448, 'PTHR31503:SF66', NULL, NULL, NULL, NULL, 'VACUOLAR CATION/PROTON EXCHANGER', 251015),
(409449, 'PTHR31503:SF22', NULL, NULL, NULL, NULL, 'VACUOLAR CALCIUM ION TRANSPORTER', 251015),
(409450, 'PTHR31503:SF88', NULL, NULL, NULL, NULL, 'VACUOLAR CATION/PROTON EXCHANGER', 251015),
(409451, 'PTHR31503:SF89', NULL, NULL, NULL, NULL, 'P20SH148J07', 251015),
(409452, 'PTHR31503:SF45', NULL, NULL, NULL, NULL, 'SODIUM/CALCIUM EXCHANGER NCL-LIKE', 251015),
(409453, 'PTHR31503:SF68', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF-HAND FAMILY PROTEIN-RELATED', 251015),
(409454, 'PTHR31503:SF46', NULL, NULL, NULL, NULL, 'SODIUM/CALCIUM EXCHANGER FAMILY PROTEIN', 251015),
(409455, 'PTHR31503:SF69', NULL, NULL, NULL, NULL, 'VACUOLAR CATION/PROTON EXCHANGER', 251015),
(409456, 'PTHR31503:SF48', NULL, NULL, NULL, NULL, 'VACUOLAR CATION/PROTON EXCHANGER 2', 251015),
(409457, 'PTHR31503:SF49', NULL, NULL, NULL, NULL, 'VACUOLAR CATION/PROTON EXCHANGER', 251015),
(409458, 'PTHR31503:SF90', NULL, NULL, NULL, NULL, 'VACUOLAR CATION/PROTON EXCHANGER 5-RELATED', 251015),
(409459, 'PTHR31503:SF91', NULL, NULL, NULL, NULL, 'SODIUM/CALCIUM EXCHANGER MEMBRANE REGION, EF-HAND DOMAIN PAIR-RELATED', 251015),
(409460, 'PTHR31503:SF92', NULL, NULL, NULL, NULL, 'SODIUM/CALCIUM EXCHANGER MEMBRANE REGION, EF-HAND DOMAIN PAIR-RELATED', 251015),
(409461, 'PTHR31503:SF93', NULL, NULL, NULL, NULL, '', 251015),
(409462, 'PTHR31503:SF94', NULL, NULL, NULL, NULL, 'VACUOLAR CATION/PROTON EXCHANGER', 251015),
(409463, 'PTHR31503:SF95', NULL, NULL, NULL, NULL, 'VACUOLAR CATION/PROTON EXCHANGER', 251015),
(409464, 'PTHR31503:SF73', NULL, NULL, NULL, NULL, 'SODIUM/CALCIUM EXCHANGER MEMBRANE REGION, EF-HAND DOMAIN PAIR-RELATED', 251015),
(409465, 'PTHR31503:SF51', NULL, NULL, NULL, NULL, 'VACUOLAR CATION/PROTON EXCHANGER 4', 251015),
(409466, 'PTHR31503:SF74', NULL, NULL, NULL, NULL, '', 251015),
(409467, 'PTHR31503:SF96', NULL, NULL, NULL, NULL, 'VACUOLAR CATION/PROTON EXCHANGER 1C', 251015),
(409468, 'PTHR31503:SF52', NULL, NULL, NULL, NULL, 'SODIUM/CALCIUM EXCHANGER NCL1', 251015),
(409469, 'PTHR31503:SF53', NULL, NULL, NULL, NULL, 'VACUOLAR CATION/PROTON EXCHANGER 3', 251015),
(409470, 'PTHR42830:SF2', NULL, NULL, NULL, NULL, 'OSMC/OHR FAMILY PROTEIN', 251016),
(409471, 'PTHR42830:SF1', NULL, NULL, NULL, NULL, 'OSMOTICALLY INDUCIBLE FAMILY PROTEIN', 251016),
(409472, 'PTHR42830', NULL, NULL, NULL, NULL, 'OSMOTICALLY INDUCIBLE FAMILY PROTEIN', 251016),
(409473, 'PTHR13809:SF14', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN G(I)/G(S)/G(O) SUBUNIT GAMMA-14-RELATED', 251017),
(409474, 'PTHR13809:SF25', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN G(I)/G(S)/G(O) SUBUNIT GAMMA-2', 251017),
(409475, 'PTHR13809:SF11', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN G(I)/G(S)/G(O) SUBUNIT GAMMA-3', 251017),
(409476, 'PTHR13809:SF53', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT GAMMA', 251017),
(409477, 'PTHR13809:SF54', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT GAMMA', 251017),
(409478, 'PTHR13809:SF21', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN G(I)/G(S)/G(O) SUBUNIT GAMMA-4', 251017),
(409479, 'PTHR13809:SF51', NULL, NULL, NULL, NULL, 'G PROTEIN SUBUNIT GAMMA 5', 251017),
(409480, 'PTHR13809:SF52', NULL, NULL, NULL, NULL, '', 251017),
(409481, 'PTHR13809:SF50', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT GAMMA', 251017),
(409482, 'PTHR13809', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN GAMMA SUBUNIT', 251017),
(409483, 'PTHR13809:SF8', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN G(I)/G(S)/G(O) SUBUNIT GAMMA-7', 251017),
(409484, 'PTHR13809:SF9', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN G(I)/G(S)/G(O) SUBUNIT GAMMA-12', 251017),
(409485, 'PTHR13809:SF6', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN G(I)/G(S)/G(O) SUBUNIT GAMMA-10', 251017);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(409486, 'PTHR13809:SF5', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN G(I)/G(S)/G(O) SUBUNIT GAMMA-5', 251017),
(409487, 'PTHR13809:SF19', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN G(I)/G(S)/G(O) SUBUNIT GAMMA-8', 251017),
(409488, 'PTHR13809:SF1', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN G(I)/G(S)/G(O) SUBUNIT GAMMA-11', 251017),
(409489, 'PTHR13809:SF28', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN G(I)/G(S)/G(O) SUBUNIT GAMMA-T2', 251017),
(409490, 'PTHR13809:SF26', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN G(T) SUBUNIT GAMMA-T1', 251017),
(409491, 'PTHR13809:SF48', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT GAMMA-RELATED', 251017),
(409492, 'PTHR13809:SF27', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT GAMMA', 251017),
(409493, 'PTHR16294:SF4', NULL, NULL, NULL, NULL, 'DYSBINDIN DOMAIN-CONTAINING PROTEIN 1', 251018),
(409494, 'PTHR16294:SF6', NULL, NULL, NULL, NULL, '', 251018),
(409495, 'PTHR16294:SF5', NULL, NULL, NULL, NULL, 'DYSBINDIN', 251018),
(409496, 'PTHR16294', NULL, NULL, NULL, NULL, 'DYSTROBREVIN BINDING PROTEIN 1  DYSBINDIN', 251018),
(409497, 'PTHR16294:SF7', NULL, NULL, NULL, NULL, 'DYSBINDIN DOMAIN-CONTAINING PROTEIN 2', 251018),
(409498, 'PTHR12668:SF48', NULL, NULL, NULL, NULL, 'PROTEIN FATTY ACID EXPORT 1, CHLOROPLASTIC', 251019),
(409499, 'PTHR12668:SF15', NULL, NULL, NULL, NULL, 'UPF0136 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_1G03720)', 251019),
(409500, 'PTHR12668:SF37', NULL, NULL, NULL, NULL, 'PROTEIN FATTY ACID EXPORT 2, CHLOROPLASTIC', 251019),
(409501, 'PTHR12668:SF16', NULL, NULL, NULL, NULL, 'OS04G0470300 PROTEIN', 251019),
(409502, 'PTHR12668:SF49', NULL, NULL, NULL, NULL, 'BNAC06G41000D PROTEIN', 251019),
(409503, 'PTHR12668:SF38', NULL, NULL, NULL, NULL, 'PROTEIN FATTY ACID EXPORT 4, CHLOROPLASTIC', 251019),
(409504, 'PTHR12668:SF41', NULL, NULL, NULL, NULL, 'PROTEIN FATTY ACID EXPORT 5-LIKE', 251019),
(409505, 'PTHR12668:SF52', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 14 HOMOLOG', 251019),
(409506, 'PTHR12668:SF20', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 14B', 251019),
(409507, 'PTHR12668:SF53', NULL, NULL, NULL, NULL, 'TMEM14 PROTEIN HOMOLOG YJR085C', 251019),
(409508, 'PTHR12668:SF54', NULL, NULL, NULL, NULL, '', 251019),
(409509, 'PTHR12668:SF43', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 14 HOMOLOG', 251019),
(409510, 'PTHR12668:SF11', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 14A', 251019),
(409511, 'PTHR12668:SF55', NULL, NULL, NULL, NULL, 'PROTEIN FATTY ACID EXPORT 1, CHLOROPLASTIC-LIKE', 251019),
(409512, 'PTHR12668:SF45', NULL, NULL, NULL, NULL, '', 251019),
(409513, 'PTHR12668:SF34', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 14DP', 251019),
(409514, 'PTHR12668:SF47', NULL, NULL, NULL, NULL, 'PROTEIN FATTY ACID EXPORT 7', 251019),
(409515, 'PTHR12668', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 14, 15', 251019),
(409516, 'PTHR12668:SF5', NULL, NULL, NULL, NULL, 'PROTEIN FATTY ACID EXPORT 5-RELATED', 251019),
(409517, 'PTHR12668:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 14C-RELATED', 251019),
(409518, 'PTHR12753:SF1', NULL, NULL, NULL, NULL, 'N-TERMINAL XAA-PRO-LYS N-METHYLTRANSFERASE 1', 251020),
(409519, 'PTHR12753:SF2', NULL, NULL, NULL, NULL, 'ALPHA N-TERMINAL PROTEIN METHYLTRANSFERASE 1B', 251020),
(409520, 'PTHR12753:SF0', NULL, NULL, NULL, NULL, 'ALPHA N-TERMINAL PROTEIN METHYLTRANSFERASE 1', 251020),
(409521, 'PTHR12753:SF3', NULL, NULL, NULL, NULL, 'METHYLTRANSF_12 DOMAIN-CONTAINING PROTEIN', 251020),
(409522, 'PTHR12753:SF4', NULL, NULL, NULL, NULL, 'BNACNNG52650D PROTEIN', 251020),
(409523, 'PTHR12753', NULL, NULL, NULL, NULL, 'AD-003 - RELATED', 251020),
(409524, 'PTHR47986:SF11', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251021),
(409525, 'PTHR47986:SF10', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE TMK4', 251021),
(409526, 'PTHR47986:SF24', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251021),
(409527, 'PTHR47986:SF13', NULL, NULL, NULL, NULL, 'OS04G0685900 PROTEIN', 251021);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(409528, 'PTHR47986:SF12', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251021),
(409529, 'PTHR47986:SF23', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN KINASE TMK1-LIKE', 251021),
(409530, 'PTHR47986:SF1', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN KINASE TMK1-RELATED', 251021),
(409531, 'PTHR47986:SF26', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE', 251021),
(409532, 'PTHR47986:SF15', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE TMK4', 251021),
(409533, 'PTHR47986:SF25', NULL, NULL, NULL, NULL, 'BNAA05G11400D PROTEIN', 251021),
(409534, 'PTHR47986:SF14', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN, PLANT-TYPE-RELATED', 251021),
(409535, 'PTHR47986:SF6', NULL, NULL, NULL, NULL, 'TRANSFERASE, PROTEIN KINASE RLK-PELLE-LRR-IX FAMILY-RELATED', 251021),
(409536, 'PTHR47986', NULL, NULL, NULL, NULL, 'OSJNBA0070M12.3 PROTEIN', 251021),
(409537, 'PTHR47986:SF28', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251021),
(409538, 'PTHR47986:SF17', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251021),
(409539, 'PTHR47986:SF5', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE TMK3', 251021),
(409540, 'PTHR47986:SF27', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE', 251021),
(409541, 'PTHR47986:SF4', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251021),
(409542, 'PTHR47986:SF18', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE TMK3', 251021),
(409543, 'PTHR47986:SF3', NULL, NULL, NULL, NULL, 'PROTEIN KINASE', 251021),
(409544, 'PTHR47986:SF9', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE TMK4', 251021),
(409545, 'PTHR47986:SF8', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251021),
(409546, 'PTHR45846', NULL, NULL, NULL, NULL, 'TRNA-DIHYDROURIDINE(47) SYNTHASE [NAD(P)(+)]-LIKE', 251022),
(409547, 'PTHR45846:SF1', NULL, NULL, NULL, NULL, 'TRNA-DIHYDROURIDINE(47) SYNTHASE [NAD(P)(+)]-LIKE', 251022),
(409548, 'PTHR47300:SF1', NULL, NULL, NULL, NULL, 'PROTEIN KASH5', 251023),
(409549, 'PTHR47300', NULL, NULL, NULL, NULL, 'PROTEIN KASH5', 251023),
(409550, 'PTHR37317:SF6', NULL, NULL, NULL, NULL, '', 251024),
(409551, 'PTHR37317:SF5', NULL, NULL, NULL, NULL, 'DUF4379 DOMAIN-CONTAINING PROTEIN', 251024),
(409552, 'PTHR37317', NULL, NULL, NULL, NULL, 'BLR8090 PROTEIN', 251024),
(409553, 'PTHR37317:SF1', NULL, NULL, NULL, NULL, 'DUF4379 DOMAIN-CONTAINING PROTEIN', 251024),
(409554, 'PTHR31075:SF3', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 85 KDA', 251025),
(409555, 'PTHR31075:SF4', NULL, NULL, NULL, NULL, '', 251025),
(409556, 'PTHR31075', NULL, NULL, NULL, NULL, '', 251025),
(409557, 'PTHR31075:SF2', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 85 KDA-LIKE', 251025),
(409558, 'PTHR48040:SF7', NULL, NULL, NULL, NULL, 'PLEIOTROPIC DRUG RESISTANCE PROTEIN 2', 251026),
(409559, 'PTHR48040:SF4', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE TRANSPORTER', 251026),
(409560, 'PTHR48040:SF6', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER', 251026),
(409561, 'PTHR48040:SF40', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 39-LIKE', 251026),
(409562, 'PTHR48040:SF24', NULL, NULL, NULL, NULL, 'PLEIOTROPIC DRUG RESISTANCE PROTEIN 1', 251026),
(409563, 'PTHR48040:SF23', NULL, NULL, NULL, NULL, 'PLEIOTROPIC DRUG RESISTANCE PROTEIN 3-LIKE', 251026),
(409564, 'PTHR48040:SF26', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE TRANSPORTER', 251026),
(409565, 'PTHR48040:SF42', NULL, NULL, NULL, NULL, 'PLEIOTROPIC DRUG RESISTANCE PROTEIN 2-LIKE ISOFORM X1', 251026),
(409566, 'PTHR48040:SF20', NULL, NULL, NULL, NULL, 'PLEIOTROPIC DRUG RESISTANCE PROTEIN 1-LIKE ISOFORM X1', 251026),
(409567, 'PTHR48040:SF41', NULL, NULL, NULL, NULL, '', 251026),
(409568, 'PTHR48040:SF22', NULL, NULL, NULL, NULL, 'DRUG RESISTANCE TRANSPORTER-LIKE ABC DOMAIN PROTEIN', 251026),
(409569, 'PTHR48040:SF44', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE TRANSPORTER', 251026),
(409570, 'PTHR48040:SF43', NULL, NULL, NULL, NULL, '', 251026),
(409571, 'PTHR48040:SF28', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 42-LIKE', 251026);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(409572, 'PTHR48040:SF27', NULL, NULL, NULL, NULL, 'PLEIOTROPIC DRUG RESISTANCE PROTEIN 1', 251026),
(409573, 'PTHR48040:SF29', NULL, NULL, NULL, NULL, 'PLEIOTROPIC DRUG RESISTANCE PROTEIN 1-LIKE', 251026),
(409574, 'PTHR48040:SF35', NULL, NULL, NULL, NULL, 'PLEIOTROPIC DRUG RESISTANCE PROTEIN 2-LIKE ISOFORM X1', 251026),
(409575, 'PTHR48040:SF13', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 251026),
(409576, 'PTHR48040', NULL, NULL, NULL, NULL, 'PLEIOTROPIC DRUG RESISTANCE PROTEIN 1-LIKE ISOFORM X1', 251026),
(409577, 'PTHR48040:SF12', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 32', 251026),
(409578, 'PTHR48040:SF37', NULL, NULL, NULL, NULL, 'PLEIOTROPIC DRUG RESISTANCE PROTEIN 1', 251026),
(409579, 'PTHR48040:SF14', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 251026),
(409580, 'PTHR48040:SF33', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 39-LIKE', 251026),
(409581, 'PTHR48040:SF10', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 251026),
(409582, 'PTHR48040:SF32', NULL, NULL, NULL, NULL, 'PLEIOTROPIC DRUG RESISTANCE PROTEIN 1', 251026),
(409583, 'PTHR48040:SF39', NULL, NULL, NULL, NULL, '', 251026),
(409584, 'PTHR48040:SF38', NULL, NULL, NULL, NULL, 'PLEIOTROPIC DRUG RESISTANCE PROTEIN 2-LIKE', 251026),
(409585, 'PTHR48040:SF19', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 251026),
(409586, 'PTHR48040:SF18', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 251026),
(409587, 'PTHR42727:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORT SYSTEM PERMEASE-RELATED', 251027),
(409588, 'PTHR42727', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORT SYSTEM PERMEASE PROTEIN', 251027),
(409589, 'PTHR24171', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 39-RELATED', 251028),
(409590, 'PTHR24171:SF8', NULL, NULL, NULL, NULL, 'BRCA1-ASSOCIATED RING DOMAIN PROTEIN 1', 251028),
(409591, 'PTHR43083', NULL, NULL, NULL, NULL, 'MANNAN POLYMERASE II', 251029),
(409592, 'PTHR43083:SF4', NULL, NULL, NULL, NULL, 'N-GLYCOSYL-TRANSFERASE (AFU_ORTHOLOGUE AFUA_4G06870)', 251029),
(409593, 'PTHR43083:SF5', NULL, NULL, NULL, NULL, 'MANNAN POLYMERASE I COMPLEX VAN1 SUBUNIT', 251029),
(409594, 'PTHR43083:SF6', NULL, NULL, NULL, NULL, 'MANNAN POLYMERASE COMPLEXES SUBUNIT MNN9', 251029),
(409595, 'PTHR43083:SF2', NULL, NULL, NULL, NULL, 'MANNAN POLYMERASE II COMPLEX ANP1 SUBUNIT', 251029),
(409596, 'PTHR46840:SF1', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING PROTEIN 1', 251030),
(409597, 'PTHR46840', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING PROTEIN 1', 251030),
(409598, 'PTHR47305:SF1', NULL, NULL, NULL, NULL, 'BEN DOMAIN-CONTAINING PROTEIN 2', 251031),
(409599, 'PTHR47305', NULL, NULL, NULL, NULL, 'BEN DOMAIN-CONTAINING PROTEIN 2', 251031),
(409600, 'PTHR23214:SF1', NULL, NULL, NULL, NULL, 'NEUROFILAMENT HEAVY POLYPEPTIDE', 251032),
(409601, 'PTHR23214', NULL, NULL, NULL, NULL, 'NEUROFILAMENT TRIPLET H PROTEIN', 251032),
(409602, 'PTHR15087', NULL, NULL, NULL, NULL, 'PROTEIN NPAT', 251033),
(409603, 'PTHR15087:SF14', NULL, NULL, NULL, NULL, 'PROTEIN NPAT', 251033),
(409604, 'PTHR15348:SF20', NULL, NULL, NULL, NULL, 'BNAC07G15070D PROTEIN', 251034),
(409605, 'PTHR15348:SF30', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN 3B (BRIGHT-LIKE)', 251034),
(409606, 'PTHR15348:SF17', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 5', 251034),
(409607, 'PTHR15348:SF18', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 6', 251034),
(409608, 'PTHR15348:SF29', NULL, NULL, NULL, NULL, 'BNAC07G06470D PROTEIN', 251034),
(409609, 'PTHR15348:SF22', NULL, NULL, NULL, NULL, 'ARID DOMAIN-CONTAINING PROTEIN', 251034),
(409610, 'PTHR15348:SF23', NULL, NULL, NULL, NULL, 'BNAA06G14770D PROTEIN', 251034),
(409611, 'PTHR15348:SF19', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 6-LIKE', 251034),
(409612, 'PTHR15348:SF4', NULL, NULL, NULL, NULL, 'OS02G0714300 PROTEIN', 251034),
(409613, 'PTHR15348', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN  ARID DOMAIN- CONTAINING PROTEIN   DEAD RINGER PROTEIN   B-CELL REGULATOR OF IGH TRANSCRIPTION   BRIGHT', 251034);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(409614, 'PTHR15348:SF2', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 3C', 251034),
(409615, 'PTHR15348:SF3', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 3B', 251034),
(409616, 'PTHR15348:SF0', NULL, NULL, NULL, NULL, 'PROTEIN DEAD RINGER', 251034),
(409617, 'PTHR15348:SF1', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 3A', 251034),
(409618, 'PTHR23516:SF17', NULL, NULL, NULL, NULL, 'MOLYBDATE-ANION TRANSPORTER-LIKE', 251035),
(409619, 'PTHR23516:SF18', NULL, NULL, NULL, NULL, 'MOLYBDATE-ANION TRANSPORTER-LIKE', 251035),
(409620, 'PTHR23516:SF1', NULL, NULL, NULL, NULL, 'MOLYBDATE-ANION TRANSPORTER', 251035),
(409621, 'PTHR23516:SF19', NULL, NULL, NULL, NULL, 'MOLYBDATE-ANION TRANSPORTER', 251035),
(409622, 'PTHR23516', NULL, NULL, NULL, NULL, 'SAM (S-ADENOSYL METHIONINE) TRANSPORTER', 251035),
(409623, 'PTHR23516:SF25', NULL, NULL, NULL, NULL, 'DUF791 DOMAIN PROTEIN', 251035),
(409624, 'PTHR23516:SF2', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN', 251035),
(409625, 'PTHR23516:SF16', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN-RELATED', 251035),
(409626, 'PTHR23516:SF21', NULL, NULL, NULL, NULL, 'BNAANNG13840D PROTEIN', 251035),
(409627, 'PTHR23516:SF23', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY DOMAIN-CONTAINING PROTEIN 5', 251035),
(409628, 'PTHR47964:SF2', NULL, NULL, NULL, NULL, '', 251036),
(409629, 'PTHR47964:SF1', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE HOMOLOG RECG, CHLOROPLASTIC', 251036),
(409630, 'PTHR47964', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE HOMOLOG RECG, CHLOROPLASTIC', 251036),
(409631, 'PTHR11440:SF47', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A2 GROUP XV', 251037),
(409632, 'PTHR11440:SF101', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID:DIACYLGLYCEROL ACYLTRANSFERASE 1', 251037),
(409633, 'PTHR11440:SF100', NULL, NULL, NULL, NULL, 'BNAA09G50730D PROTEIN', 251037),
(409634, 'PTHR11440:SF98', NULL, NULL, NULL, NULL, 'YALI0E08206P', 251037),
(409635, 'PTHR11440:SF87', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID:DIACYLGLYCEROL ACYLTRANSFERASE 2-RELATED', 251037),
(409636, 'PTHR11440:SF99', NULL, NULL, NULL, NULL, 'CHROMOSOME 9, WHOLE GENOME SHOTGUN SEQUENCE', 251037),
(409637, 'PTHR11440:SF52', NULL, NULL, NULL, NULL, 'OS02G0589700 PROTEIN', 251037),
(409638, 'PTHR11440:SF96', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID:DIACYLGLYCEROL ACYLTRANSFERASE 1-LIKE', 251037),
(409639, 'PTHR11440:SF97', NULL, NULL, NULL, NULL, 'BCDNA.GH02384', 251037),
(409640, 'PTHR11440:SF53', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A(1) LCAT3', 251037),
(409641, 'PTHR11440:SF50', NULL, NULL, NULL, NULL, 'LECITHIN:CHOLESTEROL ACYLTRANSFERASE FAMILY PROTEIN, EXPRESSED', 251037),
(409642, 'PTHR11440:SF83', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID:DIACYLGLYCEROL ACYLTRANSFERASE 2-RELATED', 251037),
(409643, 'PTHR11440:SF51', NULL, NULL, NULL, NULL, 'LECITHIN-CHOLESTEROL ACYLTRANSFERASE-LIKE 1', 251037),
(409644, 'PTHR11440:SF84', NULL, NULL, NULL, NULL, '', 251037),
(409645, 'PTHR11440:SF7', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID--STEROL O-ACYLTRANSFERASE', 251037),
(409646, 'PTHR11440:SF82', NULL, NULL, NULL, NULL, '', 251037),
(409647, 'PTHR11440:SF90', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID:DIACYLGLYCEROL ACYLTRANSFERASE-RELATED', 251037),
(409648, 'PTHR11440:SF91', NULL, NULL, NULL, NULL, 'LECITHIN-CHOLESTEROL ACYLTRANSFERASE-LIKE 1', 251037),
(409649, 'PTHR11440:SF103', NULL, NULL, NULL, NULL, 'LECITHIN-CHOLESTEROL ACYLTRANSFERASE-LIKE 4', 251037),
(409650, 'PTHR11440:SF102', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID:DIACYLGLYCEROL ACYLTRANSFERASE 1-LIKE', 251037),
(409651, 'PTHR11440:SF18', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLCHOLINE-STEROL ACYLTRANSFERASE', 251037),
(409652, 'PTHR11440', NULL, NULL, NULL, NULL, 'LECITHIN-CHOLESTEROL ACYLTRANSFERASE-RELATED', 251037),
(409653, 'PTHR21090', NULL, NULL, NULL, NULL, 'AROM/DEHYDROQUINATE SYNTHASE', 251038),
(409654, 'PTHR21090:SF30', NULL, NULL, NULL, NULL, '3-PHOSPHOSHIKIMATE 1-CARBOXYVINYLTRANSFERASE', 251038),
(409655, 'PTHR21090:SF31', NULL, NULL, NULL, NULL, '3-PHOSPHOSHIKIMATE 1-CARBOXYVINYLTRANSFERASE', 251038);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(409656, 'PTHR21090:SF5', NULL, NULL, NULL, NULL, 'PENTAFUNCTIONAL AROM POLYPEPTIDE', 251038),
(409657, 'PTHR21090:SF27', NULL, NULL, NULL, NULL, 'QUINATE REPRESSOR PROTEIN', 251038),
(409658, 'PTHR21090:SF17', NULL, NULL, NULL, NULL, 'QUINATE REPRESSOR PROTEIN', 251038),
(409659, 'PTHR40240', NULL, NULL, NULL, NULL, 'PLEXUS, ISOFORM A', 251039),
(409660, 'PTHR40240:SF1', NULL, NULL, NULL, NULL, 'PLEXUS, ISOFORM A', 251039),
(409661, 'PTHR10782:SF70', NULL, NULL, NULL, NULL, '', 251040),
(409662, 'PTHR10782:SF93', NULL, NULL, NULL, NULL, 'E3 SUMO-PROTEIN LIGASE SIZ1-LIKE', 251040),
(409663, 'PTHR10782:SF94', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF VARIEGATION 2-10, ISOFORM I', 251040),
(409664, 'PTHR10782:SF95', NULL, NULL, NULL, NULL, 'SAP DOMAIN-CONTAINING PROTEIN-RELATED', 251040),
(409665, 'PTHR10782:SF96', NULL, NULL, NULL, NULL, 'SP-RING-TYPE DOMAIN-CONTAINING PROTEIN', 251040),
(409666, 'PTHR10782:SF97', NULL, NULL, NULL, NULL, 'E4 SUMO-PROTEIN LIGASE PIAL2', 251040),
(409667, 'PTHR10782:SF98', NULL, NULL, NULL, NULL, 'E3 SUMO-PROTEIN LIGASE SIZ1-LIKE', 251040),
(409668, 'PTHR10782:SF10', NULL, NULL, NULL, NULL, 'E3 SUMO-PROTEIN LIGASE PIAS3', 251040),
(409669, 'PTHR10782:SF76', NULL, NULL, NULL, NULL, '', 251040),
(409670, 'PTHR10782', NULL, NULL, NULL, NULL, 'ZINC FINGER MIZ DOMAIN-CONTAINING PROTEIN', 251040),
(409671, 'PTHR10782:SF11', NULL, NULL, NULL, NULL, 'E3 SUMO-PROTEIN LIGASE PIAS1', 251040),
(409672, 'PTHR10782:SF78', NULL, NULL, NULL, NULL, 'SP-RING-TYPE DOMAIN-CONTAINING PROTEIN', 251040),
(409673, 'PTHR10782:SF12', NULL, NULL, NULL, NULL, 'E3 SUMO-PROTEIN LIGASE PIAS2', 251040),
(409674, 'PTHR10782:SF79', NULL, NULL, NULL, NULL, 'SP-RING-TYPE DOMAIN-CONTAINING PROTEIN', 251040),
(409675, 'PTHR10782:SF38', NULL, NULL, NULL, NULL, 'ZINC FINGER MIZ DOMAIN-CONTAINING PROTEIN 2', 251040),
(409676, 'PTHR10782:SF4', NULL, NULL, NULL, NULL, 'TONALLI, ISOFORM E', 251040),
(409677, 'PTHR10782:SF7', NULL, NULL, NULL, NULL, 'ZINC FINGER MIZ DOMAIN-CONTAINING PROTEIN 1', 251040),
(409678, 'PTHR10782:SF80', NULL, NULL, NULL, NULL, 'ZINC FINGER, PHD-TYPE-RELATED', 251040),
(409679, 'PTHR10782:SF82', NULL, NULL, NULL, NULL, 'ZINC FINGER, MIZ-TYPE, ZINC FINGER, RING/FYVE/PHD-TYPE, E3 SUMO PROTEIN LIGASE-RELATED', 251040),
(409680, 'PTHR10782:SF83', NULL, NULL, NULL, NULL, 'BNAA06G38840D PROTEIN', 251040),
(409681, 'PTHR10782:SF85', NULL, NULL, NULL, NULL, 'BNAA10G13230D PROTEIN', 251040),
(409682, 'PTHR10782:SF42', NULL, NULL, NULL, NULL, 'E3 SUMO-PROTEIN LIGASE SIZ2', 251040),
(409683, 'PTHR10782:SF9', NULL, NULL, NULL, NULL, 'E3 SUMO-PROTEIN LIGASE PIAS4', 251040),
(409684, 'PTHR10782:SF68', NULL, NULL, NULL, NULL, 'E4 SUMO-PROTEIN LIGASE PIAL1', 251040),
(409685, 'PTHR10782:SF69', NULL, NULL, NULL, NULL, 'E4 SUMO-PROTEIN LIGASE PIAL2-LIKE ISOFORM X1', 251040),
(409686, 'PTHR19444:SF13', NULL, NULL, NULL, NULL, 'PROTEIN UNC-93 HOMOLOG A', 251041),
(409687, 'PTHR19444:SF53', NULL, NULL, NULL, NULL, '', 251041),
(409688, 'PTHR19444:SF52', NULL, NULL, NULL, NULL, '', 251041),
(409689, 'PTHR19444:SF11', NULL, NULL, NULL, NULL, '', 251041),
(409690, 'PTHR19444', NULL, NULL, NULL, NULL, 'UNC-93 RELATED', 251041),
(409691, 'PTHR19444:SF50', NULL, NULL, NULL, NULL, '', 251041),
(409692, 'PTHR15830:SF10', NULL, NULL, NULL, NULL, 'TELOMERE LENGTH REGULATION PROTEIN TEL2 HOMOLOG', 251042),
(409693, 'PTHR15830', NULL, NULL, NULL, NULL, 'TELOMERE LENGTH REGULATION PROTEIN TEL2 FAMILY MEMBER', 251042),
(409694, 'PTHR31174:SF40', NULL, NULL, NULL, NULL, 'EMBRYOGENESIS ABUNDANT PROTEIN D-34, PUTATIVE-RELATED', 251043),
(409695, 'PTHR31174:SF34', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN 47', 251043),
(409696, 'PTHR31174:SF24', NULL, NULL, NULL, NULL, 'SMP DOMAIN-CONTAINING PROTEIN', 251043),
(409697, 'PTHR31174:SF25', NULL, NULL, NULL, NULL, 'SMP DOMAIN-CONTAINING PROTEIN', 251043),
(409698, 'PTHR31174:SF36', NULL, NULL, NULL, NULL, 'BNAA03G12360D PROTEIN', 251043),
(409699, 'PTHR31174:SF15', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN D-34-LIKE', 251043),
(409700, 'PTHR31174:SF31', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN 3', 251043);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(409701, 'PTHR31174:SF20', NULL, NULL, NULL, NULL, 'OS06G0341300 PROTEIN', 251043),
(409702, 'PTHR31174:SF21', NULL, NULL, NULL, NULL, 'OS12G0626500 PROTEIN', 251043),
(409703, 'PTHR31174:SF33', NULL, NULL, NULL, NULL, 'BNAC03G42830D PROTEIN', 251043),
(409704, 'PTHR31174:SF27', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN 49-RELATED', 251043),
(409705, 'PTHR31174:SF17', NULL, NULL, NULL, NULL, 'OS03G0747400 PROTEIN', 251043),
(409706, 'PTHR31174:SF29', NULL, NULL, NULL, NULL, 'BNAA09G03580D PROTEIN', 251043),
(409707, 'PTHR31174:SF7', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN 31-RELATED', 251043),
(409708, 'PTHR31174', NULL, NULL, NULL, NULL, 'SEED MATURATION FAMILY PROTEIN', 251043),
(409709, 'PTHR31174:SF4', NULL, NULL, NULL, NULL, 'OS03G0747500 PROTEIN', 251043),
(409710, 'PTHR34989', NULL, NULL, NULL, NULL, 'PROTEIN HDED', 251044),
(409711, 'PTHR34989:SF2', NULL, NULL, NULL, NULL, '', 251044),
(409712, 'PTHR34989:SF1', NULL, NULL, NULL, NULL, 'PROTEIN HDED', 251044),
(409713, 'PTHR10627:SF80', NULL, NULL, NULL, NULL, 'SAM DOMAIN-CONTAINING PROTEIN', 251045),
(409714, 'PTHR10627:SF72', NULL, NULL, NULL, NULL, 'STERILE ALPHA MOTIF/POINTED DOMAIN-CONTAINING PROTEIN-RELATED', 251045),
(409715, 'PTHR10627:SF81', NULL, NULL, NULL, NULL, 'BNAC03G35130D PROTEIN', 251045),
(409716, 'PTHR10627:SF70', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SAM DOMAIN-CONTAINING PROTEIN 6', 251045),
(409717, 'PTHR10627:SF71', NULL, NULL, NULL, NULL, 'DEFECTIVE IN GERM LINE DEVELOPMENT PROTEIN 3', 251045),
(409718, 'PTHR10627:SF65', NULL, NULL, NULL, NULL, 'SAM DOMAIN-CONTAINING PROTEIN', 251045),
(409719, 'PTHR10627:SF76', NULL, NULL, NULL, NULL, 'KH DOMAIN-CONTAINING PROTEIN YLL032C', 251045),
(409720, 'PTHR10627:SF77', NULL, NULL, NULL, NULL, 'OS08G0526500 PROTEIN', 251045),
(409721, 'PTHR10627:SF74', NULL, NULL, NULL, NULL, 'SAM DOMAIN-CONTAINING PROTEIN', 251045),
(409722, 'PTHR10627:SF63', NULL, NULL, NULL, NULL, 'SAM DOMAIN FAMILY PROTEIN', 251045),
(409723, 'PTHR10627:SF31', NULL, NULL, NULL, NULL, 'DODECA-SATELLITE-BINDING PROTEIN 1, ISOFORM A', 251045),
(409724, 'PTHR10627:SF75', NULL, NULL, NULL, NULL, 'OS04G0465000 PROTEIN', 251045),
(409725, 'PTHR10627:SF69', NULL, NULL, NULL, NULL, 'PROTEIN BICAUDAL C', 251045),
(409726, 'PTHR10627:SF59', NULL, NULL, NULL, NULL, 'BICAUDAL C HOMOLOG 2', 251045),
(409727, 'PTHR10627:SF34', NULL, NULL, NULL, NULL, 'VIGILIN', 251045),
(409728, 'PTHR10627:SF78', NULL, NULL, NULL, NULL, 'PROTEIN BICAUDAL C HOMOLOG 1', 251045),
(409729, 'PTHR10627:SF67', NULL, NULL, NULL, NULL, 'HIGH DENSITY LIPOPROTEIN-BINDING PROTEIN B', 251045),
(409730, 'PTHR10627', NULL, NULL, NULL, NULL, 'SCP160', 251045),
(409731, 'PTHR10627:SF35', NULL, NULL, NULL, NULL, 'GENE 382-RELATED', 251045),
(409732, 'PTHR10627:SF68', NULL, NULL, NULL, NULL, 'F26K24.15 PROTEIN-RELATED', 251045),
(409733, 'PTHR10627:SF79', NULL, NULL, NULL, NULL, 'STERILE ALPHA MOTIF DOMAIN-CONTAINING PROTEIN', 251045),
(409734, 'PTHR35809', NULL, NULL, NULL, NULL, 'ARCHAETIDYLSERINE DECARBOXYLASE PROENZYME-RELATED', 251046),
(409735, 'PTHR35809:SF1', NULL, NULL, NULL, NULL, 'ARCHAETIDYLSERINE DECARBOXYLASE PROENZYME-RELATED', 251046),
(409736, 'PTHR46557:SF1', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 10', 251047),
(409737, 'PTHR46557', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 10-RELATED', 251047),
(409738, 'PTHR31730:SF3', NULL, NULL, NULL, NULL, 'OS04G0433600 PROTEIN', 251048),
(409739, 'PTHR31730:SF2', NULL, NULL, NULL, NULL, 'PROTEIN PSK SIMULATOR 3', 251048),
(409740, 'PTHR31730', NULL, NULL, NULL, NULL, 'OS01G0873900 PROTEIN', 251048),
(409741, 'PTHR31730:SF18', NULL, NULL, NULL, NULL, 'PROTEIN PSK SIMULATOR 2', 251048),
(409742, 'PTHR31730:SF29', NULL, NULL, NULL, NULL, '', 251048),
(409743, 'PTHR31730:SF19', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251048),
(409744, 'PTHR31730:SF25', NULL, NULL, NULL, NULL, 'OSJNBA0088K19.7-LIKE PROTEIN', 251048),
(409745, 'PTHR31730:SF36', NULL, NULL, NULL, NULL, 'BNAC09G47350D PROTEIN', 251048);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(409746, 'PTHR31730:SF37', NULL, NULL, NULL, NULL, 'OS06G0716000 PROTEIN', 251048),
(409747, 'PTHR31730:SF26', NULL, NULL, NULL, NULL, 'DUF668 FAMILY PROTEIN', 251048),
(409748, 'PTHR31730:SF34', NULL, NULL, NULL, NULL, '', 251048),
(409749, 'PTHR31730:SF35', NULL, NULL, NULL, NULL, '', 251048),
(409750, 'PTHR31730:SF32', NULL, NULL, NULL, NULL, 'PROTEIN PSK SIMULATOR 1', 251048),
(409751, 'PTHR31730:SF31', NULL, NULL, NULL, NULL, '', 251048),
(409752, 'PTHR31730:SF20', NULL, NULL, NULL, NULL, 'DUF668 FAMILY PROTEIN', 251048),
(409753, 'PTHR34222:SF76', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 251049),
(409754, 'PTHR34222:SF31', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RLK (RECEPTOR-LIKE PROTEIN KINASE) 8', 251049),
(409755, 'PTHR34222:SF75', NULL, NULL, NULL, NULL, 'GAG-POLYPEPTIDE OF LTR COPIA-TYPE-RELATED', 251049),
(409756, 'PTHR34222:SF78', NULL, NULL, NULL, NULL, '', 251049),
(409757, 'PTHR34222:SF77', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 251049),
(409758, 'PTHR34222:SF33', NULL, NULL, NULL, NULL, '', 251049),
(409759, 'PTHR34222:SF79', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 251049),
(409760, 'PTHR34222:SF37', NULL, NULL, NULL, NULL, 'RETROTRANS_GAG DOMAIN-CONTAINING PROTEIN', 251049),
(409761, 'PTHR34222:SF70', NULL, NULL, NULL, NULL, '', 251049),
(409762, 'PTHR34222:SF72', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 251049),
(409763, 'PTHR34222:SF71', NULL, NULL, NULL, NULL, '', 251049),
(409764, 'PTHR34222:SF74', NULL, NULL, NULL, NULL, 'RRNA 2''-O-METHYLTRANSFERASE FIBRILLARIN-LIKE ISOFORM X1', 251049),
(409765, 'PTHR34222:SF73', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 251049),
(409766, 'PTHR34222:SF43', NULL, NULL, NULL, NULL, 'GAG-POLYPEPTIDE OF LTR COPIA-TYPE-RELATED', 251049),
(409767, 'PTHR34222:SF64', NULL, NULL, NULL, NULL, 'INTEGRASE CORE DOMAIN CONTAINING PROTEIN', 251049),
(409768, 'PTHR34222:SF86', NULL, NULL, NULL, NULL, '', 251049),
(409769, 'PTHR34222:SF47', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 251049),
(409770, 'PTHR34222:SF69', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 251049),
(409771, 'PTHR34222:SF25', NULL, NULL, NULL, NULL, '', 251049),
(409772, 'PTHR34222:SF81', NULL, NULL, NULL, NULL, '', 251049),
(409773, 'PTHR34222:SF80', NULL, NULL, NULL, NULL, '', 251049),
(409774, 'PTHR34222:SF83', NULL, NULL, NULL, NULL, 'GAG-POL POLYPROTEIN', 251049),
(409775, 'PTHR34222:SF82', NULL, NULL, NULL, NULL, 'RETROTRAN_GAG_3 DOMAIN-CONTAINING PROTEIN', 251049),
(409776, 'PTHR34222:SF85', NULL, NULL, NULL, NULL, '', 251049),
(409777, 'PTHR34222:SF40', NULL, NULL, NULL, NULL, '', 251049),
(409778, 'PTHR34222:SF62', NULL, NULL, NULL, NULL, 'INTEGRASE CORE DOMAIN CONTAINING PROTEIN', 251049),
(409779, 'PTHR34222:SF84', NULL, NULL, NULL, NULL, 'RETROTRANS_GAG DOMAIN-CONTAINING PROTEIN', 251049),
(409780, 'PTHR34222:SF28', NULL, NULL, NULL, NULL, 'MYB-LIKE DOMAIN-CONTAINING PROTEIN', 251049),
(409781, 'PTHR34222', NULL, NULL, NULL, NULL, 'GAG_PRE-INTEGRS DOMAIN-CONTAINING PROTEIN', 251049),
(409782, 'PTHR13578:SF11', NULL, NULL, NULL, NULL, 'POLYCOMB GROUP PROTEIN ASXL2-RELATED', 251050),
(409783, 'PTHR13578:SF20', NULL, NULL, NULL, NULL, 'POLYCOMB PROTEIN ASX', 251050),
(409784, 'PTHR13578', NULL, NULL, NULL, NULL, 'ADDITIONAL SEX COMBS LIKE PROTEIN  ASXL', 251050),
(409785, 'PTHR13578:SF18', NULL, NULL, NULL, NULL, 'POLYCOMB GROUP PROTEIN ASXL3-RELATED', 251050),
(409786, 'PTHR13578:SF19', NULL, NULL, NULL, NULL, 'POLYCOMB GROUP PROTEIN ASXL1', 251050),
(409787, 'PTHR37999:SF2', NULL, NULL, NULL, NULL, 'MUCIN-17', 251051),
(409788, 'PTHR37999', NULL, NULL, NULL, NULL, 'MUCIN-17', 251051),
(409789, 'PTHR13833:SF78', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', 251052),
(409790, 'PTHR13833:SF57', NULL, NULL, NULL, NULL, 'NHL DOMAIN-CONTAINING PROTEIN', 251052),
(409791, 'PTHR13833:SF79', NULL, NULL, NULL, NULL, 'OS06G0269300 PROTEIN', 251052),
(409792, 'PTHR13833:SF83', NULL, NULL, NULL, NULL, 'NHL REPEAT PROTEIN', 251052);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(409793, 'PTHR13833', NULL, NULL, NULL, NULL, '', 251052),
(409794, 'PTHR13833:SF73', NULL, NULL, NULL, NULL, 'NHL DOMAIN-CONTAINING PROTEIN', 251052),
(409795, 'PTHR13833:SF80', NULL, NULL, NULL, NULL, 'BNAC05G19030D PROTEIN', 251052),
(409796, 'PTHR13833:SF71', NULL, NULL, NULL, NULL, 'NHL DOMAIN-CONTAINING PROTEIN', 251052),
(409797, 'PTHR13833:SF82', NULL, NULL, NULL, NULL, 'BNAA07G28750D PROTEIN', 251052),
(409798, 'PTHR30365:SF0', NULL, NULL, NULL, NULL, 'CYTOCHROME BD-I UBIQUINOL OXIDASE SUBUNIT 1', 251053),
(409799, 'PTHR30365:SF3', NULL, NULL, NULL, NULL, 'CYTOCHROME BD MENAQUINOL OXIDASE SUBUNIT I-RELATED', 251053),
(409800, 'PTHR30365:SF7', NULL, NULL, NULL, NULL, 'CYTOCHROME BD-II UBIQUINOL OXIDASE SUBUNIT 1', 251053),
(409801, 'PTHR30365:SF14', NULL, NULL, NULL, NULL, 'CYTOCHROME BD2 SUBUNIT I', 251053),
(409802, 'PTHR30365', NULL, NULL, NULL, NULL, 'CYTOCHROME D UBIQUINOL OXIDASE', 251053),
(409803, 'PTHR23357:SF1', NULL, NULL, NULL, NULL, 'RENALASE', 251054),
(409804, 'PTHR23357', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 251054),
(409805, 'PTHR12122:SF4', NULL, NULL, NULL, NULL, 'RETINAL ROD RHODOPSIN-SENSITIVE CGMP 3'',5''-CYCLIC PHOSPHODIESTERASE SUBUNIT GAMMA', 251055),
(409806, 'PTHR12122:SF5', NULL, NULL, NULL, NULL, 'RETINAL CONE RHODOPSIN-SENSITIVE CGMP 3'',5''-CYCLIC PHOSPHODIESTERASE SUBUNIT GAMMA', 251055),
(409807, 'PTHR12122:SF8', NULL, NULL, NULL, NULL, 'RHODOPSIN-SENSITIVE CGMP 3'',5''-CYCLIC PHOSPHODIESTERASE SUBUNIT GAMMA', 251055),
(409808, 'PTHR12122:SF9', NULL, NULL, NULL, NULL, '3'',5''-CYCLIC-GMP PHOSPHODIESTERASE', 251055),
(409809, 'PTHR12122', NULL, NULL, NULL, NULL, 'RETINAL CONE RHODOPSIN-SENSITIVE CGMP 3'',5''-CYCLIC PHOSPHODIESTERASE GAMMA-SUBUNIT-RELATED', 251055),
(409810, 'PTHR33739:SF14', NULL, NULL, NULL, NULL, '', 251056),
(409811, 'PTHR33739', NULL, NULL, NULL, NULL, 'OS07G0681500 PROTEIN', 251056),
(409812, 'PTHR33739:SF7', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 33B', 251056),
(409813, 'PTHR33739:SF5', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 33A', 251056),
(409814, 'PTHR33739:SF3', NULL, NULL, NULL, NULL, 'OS07G0681500 PROTEIN', 251056),
(409815, 'PTHR33739:SF12', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 33A', 251056),
(409816, 'PTHR33739:SF11', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 33A-LIKE', 251056),
(409817, 'PTHR33739:SF10', NULL, NULL, NULL, NULL, 'OS05G0312000 PROTEIN', 251056),
(409818, 'PTHR14387:SF7', NULL, NULL, NULL, NULL, 'THYROID ADENOMA-ASSOCIATED PROTEIN', 251057),
(409819, 'PTHR14387', NULL, NULL, NULL, NULL, 'THADA/DEATH RECEPTOR INTERACTING PROTEIN', 251057),
(409820, 'PTHR14387:SF0', NULL, NULL, NULL, NULL, 'DUF2428 DOMAIN-CONTAINING PROTEIN', 251057),
(409821, 'PTHR38370', NULL, NULL, NULL, NULL, 'BETA-1,4-XYLOSIDASE', 251058),
(409822, 'PTHR38370:SF1', NULL, NULL, NULL, NULL, 'BETA-1,4-XYLOSIDASE', 251058),
(409823, 'PTHR38370:SF3', NULL, NULL, NULL, NULL, 'BNAA01G26000D PROTEIN', 251058),
(409824, 'PTHR38370:SF2', NULL, NULL, NULL, NULL, '', 251058),
(409825, 'PTHR46002:SF5', NULL, NULL, NULL, NULL, 'EG:114D9.1 PROTEIN-RELATED', 251059),
(409826, 'PTHR46002:SF6', NULL, NULL, NULL, NULL, 'CALCINEURIN B HOMOLOGOUS PROTEIN 2', 251059),
(409827, 'PTHR46002:SF7', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 251059),
(409828, 'PTHR46002', NULL, NULL, NULL, NULL, 'EG:114D9.1 PROTEIN-RELATED', 251059),
(409829, 'PTHR46002:SF1', NULL, NULL, NULL, NULL, 'CALCINEURIN B HOMOLOGOUS PROTEIN 1', 251059),
(409830, 'PTHR46002:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBR-PBO-1', 251059),
(409831, 'PTHR40326:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG10816', 251060),
(409832, 'PTHR40326:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG13869', 251060),
(409833, 'PTHR40326', NULL, NULL, NULL, NULL, 'PROTEIN CBG10816', 251060),
(409834, 'PTHR12137:SF15', NULL, NULL, NULL, NULL, 'CARBOHYDRATE SULFOTRANSFERASE', 251061),
(409835, 'PTHR12137:SF7', NULL, NULL, NULL, NULL, 'CARBOHYDRATE SULFOTRANSFERASE 8', 251061);
INSERT INTO "PUBLIC"."MODEL" VALUES
(409836, 'PTHR12137:SF2', NULL, NULL, NULL, NULL, 'CARBOHYDRATE SULFOTRANSFERASE 10', 251061),
(409837, 'PTHR12137:SF60', NULL, NULL, NULL, NULL, 'CARBOHYDRATE SULFOTRANSFERASE 13', 251061),
(409838, 'PTHR12137', NULL, NULL, NULL, NULL, 'CARBOHYDRATE SULFOTRANSFERASE', 251061),
(409839, 'PTHR12137:SF6', NULL, NULL, NULL, NULL, 'CARBOHYDRATE SULFOTRANSFERASE 9', 251061),
(409840, 'PTHR12137:SF33', NULL, NULL, NULL, NULL, 'CARBOHYDRATE SULFOTRANSFERASE 14', 251061),
(409841, 'PTHR12137:SF32', NULL, NULL, NULL, NULL, 'CARBOHYDRATE SULFOTRANSFERASE 11', 251061),
(409842, 'PTHR12137:SF54', NULL, NULL, NULL, NULL, 'CARBOHYDRATE SULFOTRANSFERASE', 251061),
(409843, 'PTHR12137:SF4', NULL, NULL, NULL, NULL, 'CARBOHYDRATE SULFOTRANSFERASE 12', 251061),
(409844, 'PTHR12137:SF30', NULL, NULL, NULL, NULL, 'CARBOHYDRATE SULFOTRANSFERASE', 251061),
(409845, 'PTHR12137:SF63', NULL, NULL, NULL, NULL, 'CARBOHYDRATE SULFOTRANSFERASE', 251061),
(409846, 'PTHR38025:SF1', NULL, NULL, NULL, NULL, 'TRP OPERON REPRESSOR', 251062),
(409847, 'PTHR38025', NULL, NULL, NULL, NULL, 'TRP OPERON REPRESSOR', 251062),
(409848, 'PTHR40688:SF2', NULL, NULL, NULL, NULL, 'RHH_1 DOMAIN-CONTAINING PROTEIN', 251063),
(409849, 'PTHR40688', NULL, NULL, NULL, NULL, '', 251063),
(409850, 'PTHR46332:SF5', NULL, NULL, NULL, NULL, 'ASP_ARG_HYDROX DOMAIN-CONTAINING PROTEIN', 251064),
(409851, 'PTHR46332:SF4', NULL, NULL, NULL, NULL, 'ASPARTATE BETA-HYDROXYLASE DOMAIN-CONTAINING 1', 251064),
(409852, 'PTHR46332:SF3', NULL, NULL, NULL, NULL, 'ASPARTATE BETA-HYDROXYLASE DOMAIN-CONTAINING PROTEIN 2', 251064),
(409853, 'PTHR46332', NULL, NULL, NULL, NULL, 'ASPARTATE BETA-HYDROXYLASE DOMAIN-CONTAINING PROTEIN 2', 251064),
(409854, 'PTHR46332:SF2', NULL, NULL, NULL, NULL, 'ASPARTATE BETA-HYDROXYLASE DOMAIN-CONTAINING PROTEIN 2', 251064),
(409855, 'PTHR46332:SF1', NULL, NULL, NULL, NULL, 'ASPARTATE BETA-HYDROXYLASE DOMAIN-CONTAINING PROTEIN 1', 251064),
(409856, 'PTHR23424:SF23', NULL, NULL, NULL, NULL, 'PROTEIN SAAL1', 251065),
(409857, 'PTHR23424', NULL, NULL, NULL, NULL, 'SERUM AMYLOID A', 251065),
(409858, 'PTHR23424:SF28', NULL, NULL, NULL, NULL, 'SERUM AMYLOID A PROTEIN', 251065),
(409859, 'PTHR47180:SF1', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-BINDING PROTEIN GGA1-RELATED', 251066),
(409860, 'PTHR47180:SF2', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-BINDING PROTEIN C1F3.05-RELATED', 251066),
(409861, 'PTHR47180', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-BINDING PROTEIN GGA1-RELATED', 251066),
(409862, 'PTHR38394', NULL, NULL, NULL, NULL, 'NEUROFILAMENT LIGHT PROTEIN', 251067),
(409863, 'PTHR38394:SF1', NULL, NULL, NULL, NULL, 'NEUROFILAMENT LIGHT PROTEIN', 251067),
(409864, 'PTHR23079:SF33', NULL, NULL, NULL, NULL, 'RNA-DEPENDENT RNA POLYMERASE', 251068),
(409865, 'PTHR23079:SF55', NULL, NULL, NULL, NULL, 'RNA-DIRECTED RNA POLYMERASE', 251068),
(409866, 'PTHR23079:SF45', NULL, NULL, NULL, NULL, 'RNA-DIRECTED RNA POLYMERASE', 251068),
(409867, 'PTHR23079:SF56', NULL, NULL, NULL, NULL, 'RNA-DEPENDENT RNA POLYMERASE 3-RELATED', 251068),
(409868, 'PTHR23079:SF34', NULL, NULL, NULL, NULL, 'RNA-DEPENDENT RNA POLYMERASE', 251068),
(409869, 'PTHR23079:SF42', NULL, NULL, NULL, NULL, 'RNA-DEPENDENT RNA POLYMERASE', 251068),
(409870, 'PTHR23079:SF53', NULL, NULL, NULL, NULL, 'RNA-DIRECTED RNA POLYMERASE', 251068),
(409871, 'PTHR23079:SF54', NULL, NULL, NULL, NULL, 'RNA-DIRECTED RNA POLYMERASE', 251068),
(409872, 'PTHR23079:SF48', NULL, NULL, NULL, NULL, 'RNA-DEPENDENT RNA POLYMERASE', 251068),
(409873, 'PTHR23079:SF37', NULL, NULL, NULL, NULL, 'RNA-DEPENDENT RNA POLYMERASE', 251068),
(409874, 'PTHR23079:SF49', NULL, NULL, NULL, NULL, 'RNA-DIRECTED RNA POLYMERASE', 251068),
(409875, 'PTHR23079:SF38', NULL, NULL, NULL, NULL, 'RNA-DEPENDENT RNA POLYMERASE', 251068),
(409876, 'PTHR23079:SF27', NULL, NULL, NULL, NULL, 'RNA-DEPENDENT RNA POLYMERASE', 251068),
(409877, 'PTHR23079:SF24', NULL, NULL, NULL, NULL, 'RNA-DEPENDENT RNA POLYMERASE', 251068),
(409878, 'PTHR23079:SF14', NULL, NULL, NULL, NULL, 'RNA-DEPENDENT RNA POLYMERASE', 251068);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(409879, 'PTHR23079', NULL, NULL, NULL, NULL, 'RNA-DEPENDENT RNA POLYMERASE', 251068),
(409880, 'PTHR23079:SF51', NULL, NULL, NULL, NULL, 'RNA-DEPENDENT RNA POLYMERASE', 251068),
(409881, 'PTHR23079:SF52', NULL, NULL, NULL, NULL, 'RNA-DEPENDENT RNA POLYMERASE', 251068),
(409882, 'PTHR23079:SF50', NULL, NULL, NULL, NULL, 'RNA-DEPENDENT RNA POLYMERASE', 251068),
(409883, 'PTHR23079:SF1', NULL, NULL, NULL, NULL, 'RNA-DEPENDENT RNA POLYMERASE 1', 251068),
(409884, 'PTHR23079:SF5', NULL, NULL, NULL, NULL, 'RNA-DEPENDENT RNA POLYMERASE 2', 251068),
(409885, 'PTHR23079:SF17', NULL, NULL, NULL, NULL, 'RNA-DEPENDENT RNA POLYMERASE', 251068),
(409886, 'PTHR23079:SF18', NULL, NULL, NULL, NULL, 'RNA-DEPENDENT RNA POLYMERASE 6', 251068),
(409887, 'PTHR45900:SF8', NULL, NULL, NULL, NULL, 'BNAA09G44130D PROTEIN', 251069),
(409888, 'PTHR45900', NULL, NULL, NULL, NULL, 'RECA', 251069),
(409889, 'PTHR45900:SF4', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RECA HOMOLOG 2, MITOCHONDRIAL', 251069),
(409890, 'PTHR45900:SF6', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RECA HOMOLOG 3, MITOCHONDRIAL-RELATED', 251069),
(409891, 'PTHR45900:SF11', NULL, NULL, NULL, NULL, 'OS11G0302700 PROTEIN', 251069),
(409892, 'PTHR45900:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL DNA REPAIR PROTEIN RECA HOMOLOG-RELATED', 251069),
(409893, 'PTHR45900:SF13', NULL, NULL, NULL, NULL, 'REPAIR PROTEIN RECA, PUTATIVE-RELATED', 251069),
(409894, 'PTHR45900:SF12', NULL, NULL, NULL, NULL, 'REPAIR PROTEIN RECA, PUTATIVE-RELATED', 251069),
(409895, 'PTHR38226:SF3', NULL, NULL, NULL, NULL, '', 251070),
(409896, 'PTHR38226:SF2', NULL, NULL, NULL, NULL, '', 251070),
(409897, 'PTHR38226', NULL, NULL, NULL, NULL, '', 251070),
(409898, 'PTHR47108', NULL, NULL, NULL, NULL, '5-AMINO-6-(5-PHOSPHO-D-RIBITYLAMINO)URACIL PHOSPHATASE, CHLOROPLASTIC', 251071),
(409899, 'PTHR47108:SF3', NULL, NULL, NULL, NULL, 'BETA-PHOSPHOGLUCOMUTASE-LIKE ISOFORM X1', 251071),
(409900, 'PTHR47108:SF1', NULL, NULL, NULL, NULL, '5-AMINO-6-(5-PHOSPHO-D-RIBITYLAMINO)URACIL PHOSPHATASE, CHLOROPLASTIC', 251071),
(409901, 'PTHR47108:SF2', NULL, NULL, NULL, NULL, 'OS04G0557000 PROTEIN', 251071),
(409902, 'PTHR13173', NULL, NULL, NULL, NULL, 'WW DOMAIN BINDING PROTEIN 4', 251072),
(409903, 'PTHR13173:SF10', NULL, NULL, NULL, NULL, 'WW DOMAIN-BINDING PROTEIN 4', 251072),
(409904, 'PTHR24393:SF120', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 599', 251073),
(409905, 'PTHR24393:SF92', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 358', 251073),
(409906, 'PTHR24393:SF91', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 76', 251073),
(409907, 'PTHR24393:SF94', NULL, NULL, NULL, NULL, 'ICHOR', 251073),
(409908, 'PTHR24393:SF50', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN CONTAINING 41', 251073),
(409909, 'PTHR24393:SF54', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 580', 251073),
(409910, 'PTHR24393:SF97', NULL, NULL, NULL, NULL, 'LD33878P', 251073),
(409911, 'PTHR24393:SF56', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 784', 251073),
(409912, 'PTHR24393:SF15', NULL, NULL, NULL, NULL, 'IP01243P-RELATED', 251073),
(409913, 'PTHR24393:SF18', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 652', 251073),
(409914, 'PTHR24393:SF114', NULL, NULL, NULL, NULL, 'AGAP001083-PB', 251073),
(409915, 'PTHR24393:SF115', NULL, NULL, NULL, NULL, 'SI:CH73-138E16.6-RELATED', 251073),
(409916, 'PTHR24393:SF116', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 132', 251073),
(409917, 'PTHR24393:SF117', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 597', 251073),
(409918, 'PTHR24393:SF110', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 410', 251073),
(409919, 'PTHR24393:SF113', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 623', 251073),
(409920, 'PTHR24393:SF60', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 16', 251073),
(409921, 'PTHR24393:SF62', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 729', 251073),
(409922, 'PTHR24393:SF65', NULL, NULL, NULL, NULL, 'RCG39624', 251073),
(409923, 'PTHR24393:SF69', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE MECOM', 251073),
(409924, 'PTHR24393:SF107', NULL, NULL, NULL, NULL, 'PR DOMAIN ZINC FINGER PROTEIN 15', 251073);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(409925, 'PTHR24393:SF108', NULL, NULL, NULL, NULL, '', 251073),
(409926, 'PTHR24393:SF106', NULL, NULL, NULL, NULL, 'ZINC FINGER AND SCAN DOMAIN-CONTAINING PROTEIN 2', 251073),
(409927, 'PTHR24393:SF100', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 345-RELATED', 251073),
(409928, 'PTHR24393:SF5', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE PRDM16', 251073),
(409929, 'PTHR24393:SF71', NULL, NULL, NULL, NULL, 'FI17950P1', 251073),
(409930, 'PTHR24393:SF31', NULL, NULL, NULL, NULL, '', 251073),
(409931, 'PTHR24393:SF34', NULL, NULL, NULL, NULL, 'WU:FE05A04', 251073),
(409932, 'PTHR24393:SF36', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 683', 251073),
(409933, 'PTHR24393:SF39', NULL, NULL, NULL, NULL, 'SI:CH211-166G5.4', 251073),
(409934, 'PTHR24393:SF136', NULL, NULL, NULL, NULL, 'IP01201P-RELATED', 251073),
(409935, 'PTHR24393:SF132', NULL, NULL, NULL, NULL, 'RB ASSOCIATED KRAB ZINC FINGER', 251073),
(409936, 'PTHR24393:SF133', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 251073),
(409937, 'PTHR24393:SF134', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 628', 251073),
(409938, 'PTHR24393:SF135', NULL, NULL, NULL, NULL, 'FEZ FAMILY ZINC FINGER PROTEIN ERM', 251073),
(409939, 'PTHR24393:SF130', NULL, NULL, NULL, NULL, 'ENDOTHELIAL ZINC FINGER PROTEIN INDUCED BY TUMOR NECROSIS FACTOR ALPHA', 251073),
(409940, 'PTHR24393:SF131', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 732', 251073),
(409941, 'PTHR24393:SF82', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 775', 251073),
(409942, 'PTHR24393:SF85', NULL, NULL, NULL, NULL, 'FI01120P', 251073),
(409943, 'PTHR24393:SF43', NULL, NULL, NULL, NULL, 'PLAG1-LIKE ZINC FINGER 2', 251073),
(409944, 'PTHR24393:SF88', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 485', 251073),
(409945, 'PTHR24393', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 251073),
(409946, 'PTHR24393:SF129', NULL, NULL, NULL, NULL, 'GDNF-INDUCIBLE ZINC FINGER PROTEIN 1', 251073),
(409947, 'PTHR24393:SF49', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN GFI-1B', 251073),
(409948, 'PTHR24393:SF125', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 113', 251073),
(409949, 'PTHR24393:SF126', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 568', 251073),
(409950, 'PTHR24393:SF127', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR (AZF1), PUTATIVE (AFU_ORTHOLOGUE AFUA_6G05160)-RELATED', 251073),
(409951, 'PTHR24393:SF128', NULL, NULL, NULL, NULL, 'SI:DKEY-7I4.15', 251073),
(409952, 'PTHR24393:SF121', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 16', 251073),
(409953, 'PTHR24393:SF122', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 691', 251073),
(409954, 'PTHR24393:SF123', NULL, NULL, NULL, NULL, 'KRUEPPEL HOMOLOG 1-LIKE PROTEIN', 251073),
(409955, 'PTHR24393:SF124', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN EGL-43', 251073),
(409956, 'PTHR32008', NULL, NULL, NULL, NULL, 'MATURIN', 251074),
(409957, 'PTHR32008:SF2', NULL, NULL, NULL, NULL, 'MATURIN', 251074),
(409958, 'PTHR39466', NULL, NULL, NULL, NULL, 'RGS DOMAIN-CONTAINING PROTEIN', 251075),
(409959, 'PTHR39466:SF1', NULL, NULL, NULL, NULL, 'RGS DOMAIN-CONTAINING PROTEIN', 251075),
(409960, 'PTHR12271', NULL, NULL, NULL, NULL, 'POLY A  POLYMERASE CID  PAP -RELATED', 251076),
(409961, 'PTHR12271:SF33', NULL, NULL, NULL, NULL, 'POLY(A) RNA POLYMERASE, MITOCHONDRIAL', 251076),
(409962, 'PTHR12271:SF99', NULL, NULL, NULL, NULL, 'PAP-ASSOCIATED DOMAIN-CONTAINING PROTEIN', 251076),
(409963, 'PTHR12271:SF12', NULL, NULL, NULL, NULL, 'NTP_TRANSF_2 DOMAIN-CONTAINING PROTEIN', 251076),
(409964, 'PTHR12271:SF34', NULL, NULL, NULL, NULL, 'TERMINAL URIDYLYLTRANSFERASE 7', 251076),
(409965, 'PTHR12271:SF36', NULL, NULL, NULL, NULL, 'PAP-ASSOCIATED DOMAIN-CONTAINING PROTEIN', 251076),
(409966, 'PTHR12271:SF39', NULL, NULL, NULL, NULL, 'PROTEIN CBG00955', 251076),
(409967, 'PTHR12271:SF133', NULL, NULL, NULL, NULL, 'POLY(A) RNA POLYMERASE, MITOCHONDRIAL', 251076),
(409968, 'PTHR12271:SF111', NULL, NULL, NULL, NULL, 'TERMINAL URIDYLYLTRANSFERASE TAILOR', 251076),
(409969, 'PTHR12271:SF132', NULL, NULL, NULL, NULL, 'PAP-ASSOCIATED DOMAIN-CONTAINING PROTEIN', 251076);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(409970, 'PTHR12271:SF135', NULL, NULL, NULL, NULL, 'CAFFEINE-INDUCED PROTEIN 16', 251076),
(409971, 'PTHR12271:SF113', NULL, NULL, NULL, NULL, 'POLY(A) RNA POLYMERASE CID11', 251076),
(409972, 'PTHR12271:SF134', NULL, NULL, NULL, NULL, 'NUCLEOTIDYLTRANSFERASE FAMILY PROTEIN', 251076),
(409973, 'PTHR12271:SF50', NULL, NULL, NULL, NULL, 'RNA EDITING 3'' TERMINAL URIDYLYL TRANSFERASE 2', 251076),
(409974, 'PTHR12271:SF137', NULL, NULL, NULL, NULL, 'U6 SNRNA-SPECIFIC TERMINAL URIDYLYLTRANSFERASE', 251076),
(409975, 'PTHR12271:SF114', NULL, NULL, NULL, NULL, 'OS09G0570600 PROTEIN', 251076),
(409976, 'PTHR12271:SF136', NULL, NULL, NULL, NULL, 'POLYMERASE BETA NUCLEOTIDYLTRANSFERASE', 251076),
(409977, 'PTHR12271:SF53', NULL, NULL, NULL, NULL, 'UTP:RNA URIDYLYLTRANSFERASE 1', 251076),
(409978, 'PTHR12271:SF117', NULL, NULL, NULL, NULL, 'PAP-ASSOCIATED DOMAIN-CONTAINING PROTEIN', 251076),
(409979, 'PTHR12271:SF97', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL EDITOSOME-LIKE COMPLEX ASSOCIATED TUTASE', 251076),
(409980, 'PTHR12271:SF98', NULL, NULL, NULL, NULL, 'RNA EDITING 3'' TERMINAL URIDYLYL TRANSFERASE 1', 251076),
(409981, 'PTHR12271:SF118', NULL, NULL, NULL, NULL, 'PAP-ASSOCIATED DOMAIN-CONTAINING PROTEIN', 251076),
(409982, 'PTHR12271:SF66', NULL, NULL, NULL, NULL, 'GH05885P', 251076),
(409983, 'PTHR12271:SF49', NULL, NULL, NULL, NULL, 'TERMINAL URIDYLYLTRANSFERASE 4', 251076),
(409984, 'PTHR12271:SF131', NULL, NULL, NULL, NULL, 'POLY(A) RNA POLYMERASE CID13', 251076),
(409985, 'PTHR12271:SF123', NULL, NULL, NULL, NULL, 'PROTEIN HESO1', 251076),
(409986, 'PTHR12271:SF40', NULL, NULL, NULL, NULL, 'POLY(A) RNA POLYMERASE GLD2', 251076),
(409987, 'PTHR12271:SF125', NULL, NULL, NULL, NULL, 'PROTEIN HESO1-LIKE ISOFORM X1', 251076),
(409988, 'PTHR12271:SF41', NULL, NULL, NULL, NULL, 'TERMINAL URIDYLYLTRANSFERASE 4', 251076),
(409989, 'PTHR12271:SF128', NULL, NULL, NULL, NULL, 'NTP_TRANSF_2 DOMAIN-CONTAINING PROTEIN', 251076),
(409990, 'PTHR12271:SF127', NULL, NULL, NULL, NULL, 'SPECKLE TARGETED PIP5K1A-REGULATED POLY(A) POLYMERASE', 251076),
(409991, 'PTHR12271:SF107', NULL, NULL, NULL, NULL, 'PROTEIN HESO1', 251076),
(409992, 'PTHR12271:SF129', NULL, NULL, NULL, NULL, 'PAP-ASSOCIATED DOMAIN-CONTAINING PROTEIN', 251076),
(409993, 'PTHR28541', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 15', 251077),
(409994, 'PTHR28541:SF1', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 15', 251077),
(409995, 'PTHR31731:SF152', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 251078),
(409996, 'PTHR31731:SF150', NULL, NULL, NULL, NULL, 'LIPID TRANSFER PROTEIN', 251078),
(409997, 'PTHR31731:SF151', NULL, NULL, NULL, NULL, 'OS12G0473900 PROTEIN', 251078),
(409998, 'PTHR31731:SF156', NULL, NULL, NULL, NULL, 'EXTENSIN-LIKE PROTEIN', 251078),
(409999, 'PTHR31731:SF112', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 251078),
(410000, 'PTHR31731:SF157', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 251078),
(410001, 'PTHR31731:SF113', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 251078),
(410002, 'PTHR31731:SF81', NULL, NULL, NULL, NULL, '14 KDA PROLINE-RICH PROTEIN DC2.15-LIKE', 251078),
(410003, 'PTHR31731:SF154', NULL, NULL, NULL, NULL, 'OS10G0551700 PROTEIN', 251078),
(410004, 'PTHR31731:SF110', NULL, NULL, NULL, NULL, 'CELL WALL-PLASMA MEMBRANE LINKER PROTEIN', 251078),
(410005, 'PTHR31731:SF111', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 251078),
(410006, 'PTHR31731:SF155', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 251078),
(410007, 'PTHR31731:SF80', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 251078),
(410008, 'PTHR31731:SF76', NULL, NULL, NULL, NULL, 'AIR1A-LIKE PROTEIN', 251078),
(410009, 'PTHR31731:SF158', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', 251078),
(410010, 'PTHR31731:SF159', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 251078),
(410011, 'PTHR31731:SF79', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', 251078);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(410012, 'PTHR31731:SF77', NULL, NULL, NULL, NULL, 'LIPID TRANSFER PROTEIN EARLI 1-RELATED', 251078),
(410013, 'PTHR31731:SF119', NULL, NULL, NULL, NULL, 'CELL DELINEATING PROTEIN, PUTATIVE, EXPRESSED-RELATED', 251078),
(410014, 'PTHR31731:SF160', NULL, NULL, NULL, NULL, 'HYDROPHOB_SEED DOMAIN-CONTAINING PROTEIN', 251078),
(410015, 'PTHR31731:SF163', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 251078),
(410016, 'PTHR31731:SF8', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', 251078),
(410017, 'PTHR31731:SF164', NULL, NULL, NULL, NULL, 'OS04G0554800 PROTEIN', 251078),
(410018, 'PTHR31731:SF161', NULL, NULL, NULL, NULL, 'LIPID TRANSFER PROTEIN', 251078),
(410019, 'PTHR31731:SF162', NULL, NULL, NULL, NULL, 'REPETITIVE PROLINE-RICH CELL WALL PROTEIN 1-LIKE', 251078),
(410020, 'PTHR31731:SF123', NULL, NULL, NULL, NULL, 'LIPID-BINDING PROTEIN AIR1-RELATED', 251078),
(410021, 'PTHR31731:SF167', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 251078),
(410022, 'PTHR31731:SF72', NULL, NULL, NULL, NULL, 'CORTICAL CELL-DELINEATING PROTEIN', 251078),
(410023, 'PTHR31731:SF124', NULL, NULL, NULL, NULL, 'HYDROPHOB_SEED DOMAIN-CONTAINING PROTEIN', 251078),
(410024, 'PTHR31731:SF168', NULL, NULL, NULL, NULL, 'HYDROPHOB_SEED DOMAIN-CONTAINING PROTEIN', 251078),
(410025, 'PTHR31731:SF70', NULL, NULL, NULL, NULL, '14 KDA PROLINE-RICH PROTEIN DC2.15-LIKE ISOFORM X1', 251078),
(410026, 'PTHR31731:SF165', NULL, NULL, NULL, NULL, 'LIPID TRANSFER PROTEIN', 251078),
(410027, 'PTHR31731:SF166', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 251078),
(410028, 'PTHR31731:SF122', NULL, NULL, NULL, NULL, 'HYDROPHOB_SEED DOMAIN-CONTAINING PROTEIN', 251078),
(410029, 'PTHR31731', NULL, NULL, NULL, NULL, '', 251078),
(410030, 'PTHR31731:SF1', NULL, NULL, NULL, NULL, 'OS06G0643500 PROTEIN', 251078),
(410031, 'PTHR31731:SF128', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 251078),
(410032, 'PTHR31731:SF20', NULL, NULL, NULL, NULL, '36.4 KDA PROLINE-RICH PROTEIN', 251078),
(410033, 'PTHR31731:SF169', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 251078),
(410034, 'PTHR31731:SF125', NULL, NULL, NULL, NULL, 'CORTICAL CELL-DELINEATING PROTEIN', 251078),
(410035, 'PTHR31731:SF62', NULL, NULL, NULL, NULL, 'OS04G0612500 PROTEIN', 251078),
(410036, 'PTHR31731:SF126', NULL, NULL, NULL, NULL, 'HYDROPHOBIC SEED PROTEIN', 251078),
(410037, 'PTHR31731:SF68', NULL, NULL, NULL, NULL, 'HYDROPHOB_SEED DOMAIN-CONTAINING PROTEIN', 251078),
(410038, 'PTHR31731:SF24', NULL, NULL, NULL, NULL, 'OS02G0662100 PROTEIN', 251078),
(410039, 'PTHR31731:SF67', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN-RELATED', 251078),
(410040, 'PTHR31731:SF66', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 251078),
(410041, 'PTHR31731:SF28', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 251078),
(410042, 'PTHR31731:SF131', NULL, NULL, NULL, NULL, 'OS10G0178000 PROTEIN', 251078),
(410043, 'PTHR31731:SF134', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 251078),
(410044, 'PTHR31731:SF135', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', 251078),
(410045, 'PTHR31731:SF97', NULL, NULL, NULL, NULL, '14 KDA PROLINE-RICH PROTEIN DC2.15-LIKE', 251078),
(410046, 'PTHR31731:SF139', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 251078),
(410047, 'PTHR31731:SF136', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 251078),
(410048, 'PTHR31731:SF137', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 251078),
(410049, 'PTHR31731:SF12', NULL, NULL, NULL, NULL, 'OS03G0718800 PROTEIN', 251078),
(410050, 'PTHR31731:SF99', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 251078),
(410051, 'PTHR31731:SF11', NULL, NULL, NULL, NULL, 'OS06G0104800 PROTEIN', 251078),
(410052, 'PTHR31731:SF18', NULL, NULL, NULL, NULL, 'CELL DELINEATING PROTEIN, PUTATIVE, EXPRESSED-RELATED', 251078);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(410053, 'PTHR31731:SF17', NULL, NULL, NULL, NULL, 'CORTICAL CELL-DELINEATING PROTEIN', 251078),
(410054, 'PTHR31731:SF16', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', 251078),
(410055, 'PTHR31731:SF19', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', 251078),
(410056, 'PTHR31731:SF141', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', 251078),
(410057, 'PTHR31731:SF142', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 251078),
(410058, 'PTHR31731:SF93', NULL, NULL, NULL, NULL, 'HYDROPHOB_SEED DOMAIN-CONTAINING PROTEIN', 251078),
(410059, 'PTHR31731:SF102', NULL, NULL, NULL, NULL, 'HYDROPHOB_SEED DOMAIN-CONTAINING PROTEIN', 251078),
(410060, 'PTHR31731:SF143', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN-RELATED', 251078),
(410061, 'PTHR31731:SF91', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 251078),
(410062, 'PTHR31731:SF144', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 251078),
(410063, 'PTHR31731:SF87', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 251078),
(410064, 'PTHR31731:SF149', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 251078),
(410065, 'PTHR31731:SF106', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 251078),
(410066, 'PTHR31731:SF109', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 251078),
(410067, 'PTHR31731:SF107', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 251078),
(410068, 'PTHR31731:SF49', NULL, NULL, NULL, NULL, 'HYDROPHOB_SEED DOMAIN-CONTAINING PROTEIN', 251078),
(410069, 'PTHR34984:SF1', NULL, NULL, NULL, NULL, 'CARBON STORAGE REGULATOR', 251079),
(410070, 'PTHR34984', NULL, NULL, NULL, NULL, 'CARBON STORAGE REGULATOR', 251079),
(410071, 'PTHR10497:SF9', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L27', 251080),
(410072, 'PTHR10497:SF8', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L27', 251080),
(410073, 'PTHR10497:SF14', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L27', 251080),
(410074, 'PTHR10497:SF13', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L27', 251080),
(410075, 'PTHR10497:SF12', NULL, NULL, NULL, NULL, '', 251080),
(410076, 'PTHR10497:SF11', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L27', 251080),
(410077, 'PTHR10497:SF16', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L27', 251080),
(410078, 'PTHR10497:SF15', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L27', 251080),
(410079, 'PTHR10497', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L27', 251080),
(410080, 'PTHR10497:SF0', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L27', 251080),
(410081, 'PTHR10497:SF5', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L27', 251080),
(410082, 'PTHR10497:SF21', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L27', 251080),
(410083, 'PTHR10497:SF20', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L27', 251080),
(410084, 'PTHR10497:SF6', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L27', 251080),
(410085, 'PTHR48069:SF5', NULL, NULL, NULL, NULL, 'DIHYDROFOLATE REDUCTASE', 251081),
(410086, 'PTHR48069:SF6', NULL, NULL, NULL, NULL, 'DIHYDROFOLATE REDUCTASE', 251081),
(410087, 'PTHR48069:SF1', NULL, NULL, NULL, NULL, 'DIHYDROFOLATE REDUCTASE 2, MITOCHONDRIAL', 251081),
(410088, 'PTHR48069', NULL, NULL, NULL, NULL, 'DIHYDROFOLATE REDUCTASE', 251081),
(410089, 'PTHR48069:SF3', NULL, NULL, NULL, NULL, 'DIHYDROFOLATE REDUCTASE', 251081),
(410090, 'PTHR23184', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 14', 251082),
(410091, 'PTHR23184:SF9', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 14', 251082),
(410092, 'PTHR46073:SF9', NULL, NULL, NULL, NULL, 'GLYCO_18 DOMAIN-CONTAINING PROTEIN', 251083),
(410093, 'PTHR46073', NULL, NULL, NULL, NULL, 'CHITINASE', 251083),
(410094, 'PTHR46073:SF4', NULL, NULL, NULL, NULL, 'CHITINASE', 251083),
(410095, 'PTHR46073:SF1', NULL, NULL, NULL, NULL, 'GLYCO_18 DOMAIN-CONTAINING PROTEIN-RELATED', 251083);
INSERT INTO "PUBLIC"."MODEL" VALUES
(410096, 'PTHR46073:SF11', NULL, NULL, NULL, NULL, 'CHITINASE-LIKE-RELATED', 251083),
(410097, 'PTHR46073:SF7', NULL, NULL, NULL, NULL, 'GLYCO_18 DOMAIN-CONTAINING PROTEIN', 251083),
(410098, 'PTHR46073:SF10', NULL, NULL, NULL, NULL, 'LYSM DOMAIN (PEPTIDOGLYCAN BINDING) PROTEIN', 251083),
(410099, 'PTHR46073:SF8', NULL, NULL, NULL, NULL, 'GLYCO_18 DOMAIN-CONTAINING PROTEIN', 251083),
(410100, 'PTHR46073:SF12', NULL, NULL, NULL, NULL, 'GLYCO_18 DOMAIN-CONTAINING PROTEIN', 251083),
(410101, 'PTHR46073:SF6', NULL, NULL, NULL, NULL, 'GLYCO_18 DOMAIN-CONTAINING PROTEIN', 251083),
(410102, 'PTHR46135:SF3', NULL, NULL, NULL, NULL, 'NME/NM23 FAMILY MEMBER 8', 251084),
(410103, 'PTHR46135:SF2', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN 3', 251084),
(410104, 'PTHR46135', NULL, NULL, NULL, NULL, 'NME/NM23 FAMILY MEMBER 8', 251084),
(410105, 'PTHR46135:SF1', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN 6', 251084),
(410106, 'PTHR10971:SF33', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 251085),
(410107, 'PTHR10971:SF11', NULL, NULL, NULL, NULL, 'MRNA EXPORT FACTOR', 251085),
(410108, 'PTHR10971:SF32', NULL, NULL, NULL, NULL, 'MITOTIC CHECKPOINT PROTEIN BUB3.2', 251085),
(410109, 'PTHR10971:SF31', NULL, NULL, NULL, NULL, 'MITOTIC CHECKPOINT PROTEIN BUB3', 251085),
(410110, 'PTHR10971:SF30', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 251085),
(410111, 'PTHR10971:SF29', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 251085),
(410112, 'PTHR10971:SF2', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL ASSEMBLY FACTOR 10', 251085),
(410113, 'PTHR10971:SF17', NULL, NULL, NULL, NULL, 'MITOTIC CHECKPOINT PROTEIN BUB3.3', 251085),
(410114, 'PTHR10971', NULL, NULL, NULL, NULL, 'MRNA EXPORT FACTOR AND BUB3', 251085),
(410115, 'PTHR10971:SF16', NULL, NULL, NULL, NULL, 'OS01G0635400 PROTEIN', 251085),
(410116, 'PTHR10971:SF27', NULL, NULL, NULL, NULL, 'PLANT POLY(A)+ RNA EXPORT PROTEIN', 251085),
(410117, 'PTHR10971:SF5', NULL, NULL, NULL, NULL, 'MITOTIC CHECKPOINT PROTEIN BUB3', 251085),
(410118, 'PTHR10971:SF34', NULL, NULL, NULL, NULL, 'MRNA EXPORT FACTOR-RELATED', 251085),
(410119, 'PTHR39165', NULL, NULL, NULL, NULL, 'IG HYPOTHETICAL 17883', 251086),
(410120, 'PTHR39165:SF1', NULL, NULL, NULL, NULL, 'IG HYPOTHETICAL 17883', 251086),
(410121, 'PTHR46657', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 128 KDA', 251087),
(410122, 'PTHR46657:SF1', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 128 KDA', 251087),
(410123, 'PTHR13417:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF146', 251088),
(410124, 'PTHR13417', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 251088),
(410125, 'PTHR13417:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG14663', 251088),
(410126, 'PTHR13417:SF8', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE', 251088),
(410127, 'PTHR12299:SF55', NULL, NULL, NULL, NULL, 'HABP4_PAI-RBP1 DOMAIN-CONTAINING PROTEIN', 251089),
(410128, 'PTHR12299:SF54', NULL, NULL, NULL, NULL, 'HABP4_PAI-RBP1 DOMAIN-CONTAINING PROTEIN', 251089),
(410129, 'PTHR12299:SF59', NULL, NULL, NULL, NULL, 'HABP4_PAI-RBP1 DOMAIN-CONTAINING PROTEIN', 251089),
(410130, 'PTHR12299:SF57', NULL, NULL, NULL, NULL, 'PLASMINOGEN ACTIVATOR INHIBITOR 1 RNA-BINDING PROTEIN-LIKE ISOFORM X1', 251089),
(410131, 'PTHR12299:SF70', NULL, NULL, NULL, NULL, 'PLASMINOGEN ACTIVATOR INHIBITOR 1 RNA-BINDING PROTEIN-LIKE', 251089),
(410132, 'PTHR12299:SF74', NULL, NULL, NULL, NULL, 'HYALURONAN/MRNA-BINDING PROTEIN, STM1-RELATED', 251089),
(410133, 'PTHR12299:SF30', NULL, NULL, NULL, NULL, 'INTRACELLULAR HYALURONAN-BINDING PROTEIN 4', 251089),
(410134, 'PTHR12299:SF51', NULL, NULL, NULL, NULL, 'HABP4_PAI-RBP1 DOMAIN-CONTAINING PROTEIN', 251089),
(410135, 'PTHR12299:SF73', NULL, NULL, NULL, NULL, 'RGG REPEATS NUCLEAR RNA BINDING PROTEIN A', 251089),
(410136, 'PTHR12299:SF50', NULL, NULL, NULL, NULL, 'RGG REPEATS NUCLEAR RNA BINDING PROTEIN B', 251089),
(410137, 'PTHR12299:SF72', NULL, NULL, NULL, NULL, 'HABP4_PAI-RBP1 DOMAIN-CONTAINING PROTEIN', 251089);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(410138, 'PTHR12299:SF71', NULL, NULL, NULL, NULL, 'HABP4_PAI-RBP1 DOMAIN-CONTAINING PROTEIN', 251089),
(410139, 'PTHR12299:SF17', NULL, NULL, NULL, NULL, 'AT19571P-RELATED', 251089),
(410140, 'PTHR12299:SF45', NULL, NULL, NULL, NULL, '', 251089),
(410141, 'PTHR12299:SF67', NULL, NULL, NULL, NULL, 'HYALURONAN/MRNA-BINDING PROTEIN-RELATED', 251089),
(410142, 'PTHR12299:SF66', NULL, NULL, NULL, NULL, 'PLASMINOGEN ACTIVATOR INHIBITOR 1 RNA-BINDING PROTEIN-LIKE ISOFORM X1', 251089),
(410143, 'PTHR12299:SF69', NULL, NULL, NULL, NULL, 'NUCLEAR RNA-BINDING-LIKE PROTEIN', 251089),
(410144, 'PTHR12299:SF46', NULL, NULL, NULL, NULL, 'HYALURONAN / MRNA BINDING FAMILY', 251089),
(410145, 'PTHR12299:SF68', NULL, NULL, NULL, NULL, 'OS01G0721900 PROTEIN', 251089),
(410146, 'PTHR12299:SF63', NULL, NULL, NULL, NULL, 'HABP4_PAI-RBP1 DOMAIN-CONTAINING PROTEIN', 251089),
(410147, 'PTHR12299:SF62', NULL, NULL, NULL, NULL, 'ASPARTATE, GLYCINE, LYSINE AND SERINE-RICH PROTEIN-LIKE', 251089),
(410148, 'PTHR12299:SF61', NULL, NULL, NULL, NULL, 'HABP4_PAI-RBP1 DOMAIN-CONTAINING PROTEIN', 251089),
(410149, 'PTHR12299:SF60', NULL, NULL, NULL, NULL, 'HABP4_PAI-RBP1 DOMAIN-CONTAINING PROTEIN', 251089),
(410150, 'PTHR12299:SF29', NULL, NULL, NULL, NULL, 'PLASMINOGEN ACTIVATOR INHIBITOR 1 RNA-BINDING PROTEIN', 251089),
(410151, 'PTHR12299', NULL, NULL, NULL, NULL, 'HYALURONIC ACID-BINDING PROTEIN 4', 251089),
(410152, 'PTHR12858', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS PROTEIN', 251090),
(410153, 'PTHR12858:SF5', NULL, NULL, NULL, NULL, 'BMS1-TYPE G DOMAIN-CONTAINING PROTEIN', 251090),
(410154, 'PTHR12858:SF3', NULL, NULL, NULL, NULL, 'BNAA05G35890D PROTEIN', 251090),
(410155, 'PTHR12858:SF2', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS PROTEIN BMS1 HOMOLOG', 251090),
(410156, 'PTHR12858:SF1', NULL, NULL, NULL, NULL, 'PRE-RRNA-PROCESSING PROTEIN TSR1 HOMOLOG', 251090),
(410157, 'PTHR34115:SF6', NULL, NULL, NULL, NULL, 'RPB1A', 251091),
(410158, 'PTHR34115:SF5', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 251091),
(410159, 'PTHR34115:SF7', NULL, NULL, NULL, NULL, '', 251091),
(410160, 'PTHR34115:SF13', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 251091),
(410161, 'PTHR34115:SF14', NULL, NULL, NULL, NULL, '', 251091),
(410162, 'PTHR34115:SF15', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 251091),
(410163, 'PTHR34115', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 251091),
(410164, 'PTHR35579:SF3', NULL, NULL, NULL, NULL, 'CRISPR SYSTEM CMS ENDORIBONUCLEASE CSM3', 251092),
(410165, 'PTHR35579:SF5', NULL, NULL, NULL, NULL, '', 251092),
(410166, 'PTHR35579', NULL, NULL, NULL, NULL, 'CRISPR SYSTEM CMS ENDORIBONUCLEASE CSM3', 251092),
(410167, 'PTHR36000', NULL, NULL, NULL, NULL, 'DEFECTIVE 1273 PROTEIN, PUTATIVE-RELATED', 251093),
(410168, 'PTHR36000:SF2', NULL, NULL, NULL, NULL, 'DEFECTIVE 1273 PROTEIN, PUTATIVE-RELATED', 251093),
(410169, 'PTHR36000:SF3', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 251093),
(410170, 'PTHR36299:SF1', NULL, NULL, NULL, NULL, 'DUF4773 DOMAIN-CONTAINING PROTEIN-RELATED', 251094),
(410171, 'PTHR36299:SF3', NULL, NULL, NULL, NULL, 'FI03431P', 251094),
(410172, 'PTHR36299:SF2', NULL, NULL, NULL, NULL, 'DUF4773 DOMAIN-CONTAINING PROTEIN', 251094),
(410173, 'PTHR36299', NULL, NULL, NULL, NULL, 'AGAP008005-PA', 251094),
(410174, 'PTHR33119', NULL, NULL, NULL, NULL, 'IFI3P', 251095),
(410175, 'PTHR33119:SF1', NULL, NULL, NULL, NULL, 'IFI3P', 251095),
(410176, 'PTHR33698:SF1', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSPORT FACTOR 2 (NTF2) FAMILY PROTEIN', 251096),
(410177, 'PTHR33698:SF3', NULL, NULL, NULL, NULL, 'OS09G0266000 PROTEIN', 251096),
(410178, 'PTHR33698:SF5', NULL, NULL, NULL, NULL, 'NTF2-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 251096),
(410179, 'PTHR33698:SF6', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 251096),
(410180, 'PTHR33698:SF7', NULL, NULL, NULL, NULL, '', 251096),
(410181, 'PTHR33698', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSPORT FACTOR 2 (NTF2)-LIKE PROTEIN', 251096),
(410182, 'PTHR33577:SF1', NULL, NULL, NULL, NULL, 'HEME_HALOPEROXIDASE DOMAIN-CONTAINING PROTEIN', 251097);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(410183, 'PTHR33577:SF9', NULL, NULL, NULL, NULL, 'STERIGMATOCYSTIN BIOSYNTHESIS PEROXIDASE STCC-RELATED', 251097),
(410184, 'PTHR33577:SF15', NULL, NULL, NULL, NULL, 'HEME_HALOPEROXIDASE DOMAIN-CONTAINING PROTEIN', 251097),
(410185, 'PTHR33577:SF16', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 251097),
(410186, 'PTHR33577:SF7', NULL, NULL, NULL, NULL, 'HEME_HALOPEROXIDASE DOMAIN-CONTAINING PROTEIN', 251097),
(410187, 'PTHR33577', NULL, NULL, NULL, NULL, 'STERIGMATOCYSTIN BIOSYNTHESIS PEROXIDASE STCC-RELATED', 251097),
(410188, 'PTHR33577:SF18', NULL, NULL, NULL, NULL, 'HEME_HALOPEROXIDASE DOMAIN-CONTAINING PROTEIN', 251097),
(410189, 'PTHR33577:SF19', NULL, NULL, NULL, NULL, 'HEME_HALOPEROXIDASE DOMAIN-CONTAINING PROTEIN-RELATED', 251097),
(410190, 'PTHR11099:SF0', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 35', 251098),
(410191, 'PTHR11099:SF4', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 35A-LIKE', 251098),
(410192, 'PTHR11099:SF6', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 35B', 251098),
(410193, 'PTHR11099', NULL, NULL, NULL, NULL, 'VACUOLAR SORTING PROTEIN 35', 251098),
(410194, 'PTHR11099:SF5', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 35C', 251098),
(410195, 'PTHR43248', NULL, NULL, NULL, NULL, '2-SUCCINYL-6-HYDROXY-2,4-CYCLOHEXADIENE-1-CARBOXYLATE SYNTHASE', 251099),
(410196, 'PTHR43248:SF27', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251099),
(410197, 'PTHR43248:SF28', NULL, NULL, NULL, NULL, 'HALOALKANE DEHALOGENASE', 251099),
(410198, 'PTHR43248:SF29', NULL, NULL, NULL, NULL, 'TRIPEPTIDYL AMINOPEPTIDASE', 251099),
(410199, 'PTHR43248:SF3', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 251099),
(410200, 'PTHR43248:SF2', NULL, NULL, NULL, NULL, 'PROLYL AMINOPEPTIDASE-RELATED', 251099),
(410201, 'PTHR43248:SF30', NULL, NULL, NULL, NULL, '', 251099),
(410202, 'PTHR43248:SF31', NULL, NULL, NULL, NULL, '2-SUCCINYL-6-HYDROXY-2,4-CYCLOHEXADIENE-1-CARBOXYLATE SYNTHASE', 251099),
(410203, 'PTHR43248:SF32', NULL, NULL, NULL, NULL, 'PROLINE IMINOPEPTIDASE', 251099),
(410204, 'PTHR43248:SF22', NULL, NULL, NULL, NULL, '', 251099),
(410205, 'PTHR43248:SF12', NULL, NULL, NULL, NULL, 'EPOXIDE HYDROLASE SRDG', 251099),
(410206, 'PTHR43248:SF25', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN-RELATED', 251099),
(410207, 'PTHR43248:SF14', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 251099),
(410208, 'PTHR21013:SF10', NULL, NULL, NULL, NULL, 'ATP SYNTHASE MITOCHONDRIAL F1 COMPLEX ASSEMBLY FACTOR 2', 251100),
(410209, 'PTHR21013', NULL, NULL, NULL, NULL, 'ATP SYNTHASE MITOCHONDRIAL F1 COMPLEX ASSEMBLY FACTOR 2/ATP12 PROTEIN, MITOCHONDRIAL PRECURSOR', 251100),
(410210, 'PTHR43172', NULL, NULL, NULL, NULL, 'ADENYLOSUCCINATE LYASE', 251101),
(410211, 'PTHR43172:SF2', NULL, NULL, NULL, NULL, 'ADSL_C DOMAIN-CONTAINING PROTEIN', 251101),
(410212, 'PTHR43172:SF1', NULL, NULL, NULL, NULL, 'ADENYLOSUCCINATE LYASE', 251101),
(410213, 'PTHR47409', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN PROPHET OF PIT-1', 251102),
(410214, 'PTHR47409:SF1', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN PROPHET OF PIT-1', 251102),
(410215, 'PTHR46042', NULL, NULL, NULL, NULL, 'DIPHTHINE METHYLTRANSFERASE', 251103),
(410216, 'PTHR46042:SF1', NULL, NULL, NULL, NULL, 'DIPHTHINE METHYLTRANSFERASE', 251103),
(410217, 'PTHR12156:SF5', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN UNC-104', 251104),
(410218, 'PTHR12156:SF30', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY-LIKE DOMAIN, FAMILY B, MEMBER 2A', 251104),
(410219, 'PTHR12156:SF22', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY-LIKE DOMAIN FAMILY B MEMBER 3', 251104),
(410220, 'PTHR12156:SF23', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY-LIKE DOMAIN FAMILY B MEMBER 1', 251104),
(410221, 'PTHR12156:SF31', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY-LIKE DOMAIN, FAMILY B, MEMBER 1A', 251104),
(410222, 'PTHR12156:SF21', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY-LIKE DOMAIN FAMILY B MEMBER 2', 251104);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(410223, 'PTHR12156', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY-LIKE DOMAIN, FAMILY B, MEMBER 3', 251104),
(410224, 'PTHR43179:SF9', NULL, NULL, NULL, NULL, 'GALACTOFURANOSYLTRANSFERASE GLFT2', 251105),
(410225, 'PTHR43179:SF7', NULL, NULL, NULL, NULL, 'RHAMNOSYLTRANSFERASE WBBL', 251105),
(410226, 'PTHR43179:SF1', NULL, NULL, NULL, NULL, 'RHAMNOSYL TRANSFERASE', 251105),
(410227, 'PTHR43179:SF10', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE', 251105),
(410228, 'PTHR43179:SF11', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE', 251105),
(410229, 'PTHR43179', NULL, NULL, NULL, NULL, 'RHAMNOSYLTRANSFERASE WBBL', 251105),
(410230, 'PTHR36690', NULL, NULL, NULL, NULL, 'PROTEIN FAM237A', 251106),
(410231, 'PTHR36690:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM237A', 251106),
(410232, 'PTHR36690:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAM237B', 251106),
(410233, 'PTHR40261', NULL, NULL, NULL, NULL, '', 251107),
(410234, 'PTHR40261:SF1', NULL, NULL, NULL, NULL, 'RIESKE DOMAIN-CONTAINING PROTEIN', 251107),
(410235, 'PTHR15135:SF7', NULL, NULL, NULL, NULL, 'STAC-LIKE, ISOFORM J', 251108),
(410236, 'PTHR15135:SF5', NULL, NULL, NULL, NULL, 'SH3 AND CYSTEINE-RICH DOMAIN-CONTAINING PROTEIN 2', 251108),
(410237, 'PTHR15135:SF3', NULL, NULL, NULL, NULL, 'SH3 AND CYSTEINE-RICH DOMAIN-CONTAINING PROTEIN', 251108),
(410238, 'PTHR15135:SF2', NULL, NULL, NULL, NULL, 'SH3 AND CYSTEINE-RICH DOMAIN-CONTAINING PROTEIN 3', 251108),
(410239, 'PTHR15135', NULL, NULL, NULL, NULL, 'STAC', 251108),
(410240, 'PTHR33372:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CHAPERONE-LIKE PROTEIN OF POR1, CHLOROPLASTIC', 251109),
(410241, 'PTHR33372:SF14', NULL, NULL, NULL, NULL, '', 251109),
(410242, 'PTHR33372:SF11', NULL, NULL, NULL, NULL, 'DNAJ (DUF3353)', 251109),
(410243, 'PTHR33372:SF10', NULL, NULL, NULL, NULL, 'PROTEIN CHAPERONE-LIKE PROTEIN OF POR1, CHLOROPLASTIC-LIKE', 251109),
(410244, 'PTHR33372', NULL, NULL, NULL, NULL, '', 251109),
(410245, 'PTHR33372:SF9', NULL, NULL, NULL, NULL, 'DNAJ DOMAIN CONTAINING PROTEIN, EXPRESSED', 251109),
(410246, 'PTHR33372:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CHAPERONE-LIKE PROTEIN OF POR1 CHLOROPLASTIC', 251109),
(410247, 'PTHR33372:SF5', NULL, NULL, NULL, NULL, 'CHLOROPLAST J-LIKE DOMAIN 1', 251109),
(410248, 'PTHR43155:SF8', NULL, NULL, NULL, NULL, 'HD-GYP DOMAIN-CONTAINING PROTEIN', 251110),
(410249, 'PTHR43155:SF2', NULL, NULL, NULL, NULL, 'CYCLIC DI-GMP PHOSPHODIESTERASE PA4108', 251110),
(410250, 'PTHR43155:SF1', NULL, NULL, NULL, NULL, '3''3''-CGAMP-SPECIFIC PHOSPHODIESTERASE 1', 251110),
(410251, 'PTHR43155', NULL, NULL, NULL, NULL, 'CYCLIC DI-GMP PHOSPHODIESTERASE PA4108-RELATED', 251110),
(410252, 'PTHR36688', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 251111),
(410253, 'PTHR36688:SF1', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 251111),
(410254, 'PTHR37471:SF1', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251112),
(410255, 'PTHR37471', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', 251112),
(410256, 'PTHR32179:SF3', NULL, NULL, NULL, NULL, 'NICOTINATE-NUCLEOTIDE PYROPHOSPHORYLASE [CARBOXYLATING]', 251113),
(410257, 'PTHR32179:SF4', NULL, NULL, NULL, NULL, 'PYROPHOSPHORYLASE MODD-RELATED', 251113),
(410258, 'PTHR32179', NULL, NULL, NULL, NULL, 'NICOTINATE-NUCLEOTIDE PYROPHOSPHORYLASE [CARBOXYLATING]', 251113),
(410259, 'PTHR12924', NULL, NULL, NULL, NULL, 'TRANSLOCON-ASSOCIATED PROTEIN, ALPHA SUBUNIT', 251114),
(410260, 'PTHR12924:SF6', NULL, NULL, NULL, NULL, 'SIGNAL SEQUENCE RECEPTOR SUBUNIT ALPHA', 251114),
(410261, 'PTHR12924:SF3', NULL, NULL, NULL, NULL, 'SIGNAL SEQUENCE RECEPTOR SUBUNIT ALPHA', 251114),
(410262, 'PTHR12924:SF4', NULL, NULL, NULL, NULL, 'SIGNAL SEQUENCE RECEPTOR SUBUNIT ALPHA', 251114),
(410263, 'PTHR12924:SF1', NULL, NULL, NULL, NULL, 'SIGNAL SEQUENCE RECEPTOR SUBUNIT ALPHA', 251114),
(410264, 'PTHR12924:SF2', NULL, NULL, NULL, NULL, 'SIGNAL SEQUENCE RECEPTOR SUBUNIT ALPHA', 251114),
(410265, 'PTHR12924:SF0', NULL, NULL, NULL, NULL, 'TRANSLOCON-ASSOCIATED PROTEIN SUBUNIT ALPHA', 251114);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(410266, 'PTHR38546', NULL, NULL, NULL, NULL, 'DNA BINDING PROTEIN', 251115),
(410267, 'PTHR38546:SF3', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 251115),
(410268, 'PTHR38546:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR ILI2', 251115),
(410269, 'PTHR38546:SF5', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 251115),
(410270, 'PTHR28285:SF2', NULL, NULL, NULL, NULL, 'PROTEIN BIG1', 251116),
(410271, 'PTHR28285', NULL, NULL, NULL, NULL, 'PROTEIN BIG1', 251116),
(410272, 'PTHR28285:SF1', NULL, NULL, NULL, NULL, 'PROTEIN BIG1', 251116),
(410273, 'PTHR12185:SF14', NULL, NULL, NULL, NULL, 'CHOLESTEROL UPTAKE PROTEIN 1', 251117),
(410274, 'PTHR12185:SF15', NULL, NULL, NULL, NULL, 'SID1 TRANSMEMBRANE FAMILY MEMBER 1', 251117),
(410275, 'PTHR12185', NULL, NULL, NULL, NULL, 'SID1 TRANSMEMBRANE FAMILY MEMEBER', 251117),
(410276, 'PTHR12185:SF16', NULL, NULL, NULL, NULL, 'SID1 TRANSMEMBRANE FAMILY MEMBER 2', 251117),
(410277, 'PTHR12185:SF1', NULL, NULL, NULL, NULL, 'SYSTEMIC RNA INTERFERENCE DEFECTIVE PROTEIN 1', 251117),
(410278, 'PTHR12185:SF18', NULL, NULL, NULL, NULL, 'PROTEIN CBG15988', 251117),
(410279, 'PTHR36294', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 139', 251118),
(410280, 'PTHR36294:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 139', 251118),
(410281, 'PTHR43207:SF9', NULL, NULL, NULL, NULL, 'AROGENATE DEHYDROGENASE 2, CHLOROPLASTIC-LIKE', 251119),
(410282, 'PTHR43207', NULL, NULL, NULL, NULL, 'AROGENATE DEHYDROGENASE-RELATED', 251119),
(410283, 'PTHR43207:SF3', NULL, NULL, NULL, NULL, 'AROGENATE DEHYDROGENASE 1, CHLOROPLASTIC-LIKE', 251119),
(410284, 'PTHR43207:SF4', NULL, NULL, NULL, NULL, 'AROGENATE DEHYDROGENASE 2, CHLOROPLASTIC', 251119),
(410285, 'PTHR43207:SF1', NULL, NULL, NULL, NULL, 'OS06G0709000 PROTEIN', 251119),
(410286, 'PTHR43207:SF11', NULL, NULL, NULL, NULL, 'PREPHENATE DEHYDROGENASE', 251119),
(410287, 'PTHR43207:SF8', NULL, NULL, NULL, NULL, 'AROGENATE DEHYDROGENASE 1, CHLOROPLASTIC', 251119),
(410288, 'PTHR43207:SF6', NULL, NULL, NULL, NULL, 'OS06G0542200 PROTEIN', 251119),
(410289, 'PTHR15157:SF19', NULL, NULL, NULL, NULL, 'HAD-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 251120),
(410290, 'PTHR15157:SF12', NULL, NULL, NULL, NULL, '', 251120),
(410291, 'PTHR15157:SF5', NULL, NULL, NULL, NULL, 'UV RADIATION RESISTANCE-ASSOCIATED GENE PROTEIN', 251120),
(410292, 'PTHR15157:SF22', NULL, NULL, NULL, NULL, '', 251120),
(410293, 'PTHR15157:SF25', NULL, NULL, NULL, NULL, 'OS07G0418000 PROTEIN', 251120),
(410294, 'PTHR15157:SF24', NULL, NULL, NULL, NULL, 'OS06G0715000 PROTEIN', 251120),
(410295, 'PTHR15157:SF13', NULL, NULL, NULL, NULL, 'YALI0E30921P', 251120),
(410296, 'PTHR15157:SF21', NULL, NULL, NULL, NULL, '', 251120),
(410297, 'PTHR15157', NULL, NULL, NULL, NULL, 'UV RADIATION RESISTANCE-ASSOCIATED GENE PROTEIN', 251120),
(410298, 'PTHR42895:SF2', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER PROTEIN-RELATED', 251121),
(410299, 'PTHR42895:SF1', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER PROTEIN', 251121),
(410300, 'PTHR42895', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER-BINDING PROTEIN-RELATED', 251121),
(410301, 'PTHR11178:SF50', NULL, NULL, NULL, NULL, 'BNAC03G27550D PROTEIN', 251122),
(410302, 'PTHR11178:SF40', NULL, NULL, NULL, NULL, '', 251122),
(410303, 'PTHR11178:SF51', NULL, NULL, NULL, NULL, 'FE/S BIOGENESIS PROTEIN NFUA', 251122),
(410304, 'PTHR11178:SF52', NULL, NULL, NULL, NULL, 'PROTEIN 5, PUTATIVE-RELATED', 251122),
(410305, 'PTHR11178:SF25', NULL, NULL, NULL, NULL, 'NIFU-LIKE PROTEIN 3, CHLOROPLASTIC', 251122),
(410306, 'PTHR11178:SF15', NULL, NULL, NULL, NULL, 'NIFU-LIKE PROTEIN 1, CHLOROPLASTIC', 251122),
(410307, 'PTHR11178:SF49', NULL, NULL, NULL, NULL, 'PROTEIN 5, PUTATIVE-RELATED', 251122),
(410308, 'PTHR11178:SF39', NULL, NULL, NULL, NULL, 'NIFU-LIKE PROTEIN 2, CHLOROPLASTIC', 251122),
(410309, 'PTHR11178:SF1', NULL, NULL, NULL, NULL, 'NFU1 IRON-SULFUR CLUSTER SCAFFOLD HOMOLOG, MITOCHONDRIAL', 251122),
(410310, 'PTHR11178:SF43', NULL, NULL, NULL, NULL, 'NIFU-LIKE PROTEIN 5, MITOCHONDRIAL', 251122),
(410311, 'PTHR11178:SF45', NULL, NULL, NULL, NULL, 'NFU1 IRON-SULFUR CLUSTER SCAFFOLD HOMOLOG, MITOCHONDRIAL', 251122);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(410312, 'PTHR11178:SF46', NULL, NULL, NULL, NULL, 'NFU1 IRON-SULFUR CLUSTER SCAFFOLD HOMOLOG, MITOCHONDRIAL', 251122),
(410313, 'PTHR11178', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER SCAFFOLD PROTEIN NFU-RELATED', 251122),
(410314, 'PTHR40052:SF2', NULL, NULL, NULL, NULL, 'UPF0403 PROTEIN YPHP', 251123),
(410315, 'PTHR40052', NULL, NULL, NULL, NULL, 'UPF0403 PROTEIN YQIW-RELATED', 251123),
(410316, 'PTHR40052:SF1', NULL, NULL, NULL, NULL, 'UPF0403 PROTEIN YQIW', 251123),
(410317, 'PTHR13831:SF5', NULL, NULL, NULL, NULL, 'PROTEIN HIRA', 251124),
(410318, 'PTHR13831:SF6', NULL, NULL, NULL, NULL, 'HISTONE TRANSCRIPTION REGULATOR SLM9', 251124),
(410319, 'PTHR13831:SF0', NULL, NULL, NULL, NULL, 'PROTEIN HIRA', 251124),
(410320, 'PTHR13831:SF1', NULL, NULL, NULL, NULL, 'PROTEIN HIR2', 251124),
(410321, 'PTHR13831', NULL, NULL, NULL, NULL, 'MEMBER OF THE HIR1 FAMILY OF WD-REPEAT PROTEINS', 251124),
(410322, 'PTHR47465:SF3', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN EHOX-RELATED', 251125),
(410323, 'PTHR47465:SF4', NULL, NULL, NULL, NULL, 'REPRODUCTIVE HOMEOBOX 3A-RELATED', 251125),
(410324, 'PTHR47465:SF5', NULL, NULL, NULL, NULL, 'REPRODUCTIVE HOMEOBOX 8', 251125),
(410325, 'PTHR47465:SF6', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN RHOX5', 251125),
(410326, 'PTHR47465', NULL, NULL, NULL, NULL, 'MCG113260-RELATED-RELATED', 251125),
(410327, 'PTHR47465:SF1', NULL, NULL, NULL, NULL, 'REPRODUCTIVE HOMEOBOX 1-RELATED', 251125),
(410328, 'PTHR47465:SF2', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN GPBOX-RELATED', 251125),
(410329, 'PTHR15117:SF5', NULL, NULL, NULL, NULL, 'ATAXIN-7-LIKE PROTEIN 2', 251126),
(410330, 'PTHR15117:SF24', NULL, NULL, NULL, NULL, 'SCA7 DOMAIN-CONTAINING PROTEIN', 251126),
(410331, 'PTHR15117:SF2', NULL, NULL, NULL, NULL, 'ATAXIN-7', 251126),
(410332, 'PTHR15117', NULL, NULL, NULL, NULL, 'ATAXIN 7 RELATED', 251126),
(410333, 'PTHR15117:SF9', NULL, NULL, NULL, NULL, 'ATAXIN-7-LIKE PROTEIN 1', 251126),
(410334, 'PTHR47248:SF8', NULL, NULL, NULL, NULL, 'BPTI/KUNITZ INHIBITOR DOMAIN-CONTAINING PROTEIN-RELATED', 251127),
(410335, 'PTHR47248:SF1', NULL, NULL, NULL, NULL, 'BPTI/KUNITZ INHIBITOR DOMAIN-CONTAINING PROTEIN', 251127),
(410336, 'PTHR47248:SF2', NULL, NULL, NULL, NULL, 'BPTI/KUNITZ INHIBITOR DOMAIN-CONTAINING PROTEIN', 251127),
(410337, 'PTHR47248:SF3', NULL, NULL, NULL, NULL, 'BPTI/KUNITZ INHIBITOR DOMAIN-CONTAINING PROTEIN', 251127),
(410338, 'PTHR47248:SF4', NULL, NULL, NULL, NULL, 'BPTI/KUNITZ INHIBITOR DOMAIN-CONTAINING PROTEIN', 251127),
(410339, 'PTHR47248', NULL, NULL, NULL, NULL, 'PROTEIN CBG06772', 251127),
(410340, 'PTHR47248:SF5', NULL, NULL, NULL, NULL, 'BPTI/KUNITZ INHIBITOR DOMAIN-CONTAINING PROTEIN', 251127),
(410341, 'PTHR47248:SF6', NULL, NULL, NULL, NULL, 'BPTI/KUNITZ INHIBITOR DOMAIN-CONTAINING PROTEIN', 251127),
(410342, 'PTHR47248:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG19214', 251127),
(410343, 'PTHR34536:SF14', NULL, NULL, NULL, NULL, 'BNAA10G28360D PROTEIN', 251128),
(410344, 'PTHR34536', NULL, NULL, NULL, NULL, 'DENTIN SIALOPHOSPHOPROTEIN-LIKE PROTEIN', 251128),
(410345, 'PTHR34536:SF12', NULL, NULL, NULL, NULL, '', 251128),
(410346, 'PTHR34536:SF6', NULL, NULL, NULL, NULL, 'DENTIN SIALOPHOSPHOPROTEIN-LIKE PROTEIN', 251128),
(410347, 'PTHR34536:SF4', NULL, NULL, NULL, NULL, 'BNAC09G43500D PROTEIN', 251128),
(410348, 'PTHR34536:SF17', NULL, NULL, NULL, NULL, 'BNAA10G28350D PROTEIN', 251128),
(410349, 'PTHR34536:SF8', NULL, NULL, NULL, NULL, '', 251128),
(410350, 'PTHR34536:SF15', NULL, NULL, NULL, NULL, '', 251128),
(410351, 'PTHR34536:SF16', NULL, NULL, NULL, NULL, '', 251128),
(410352, 'PTHR12826', NULL, NULL, NULL, NULL, 'RIBONUCLEASE Y', 251129),
(410353, 'PTHR12826:SF13', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN PNO1', 251129),
(410354, 'PTHR12826:SF15', NULL, NULL, NULL, NULL, 'RIBONUCLEASE Y', 251129),
(410355, 'PTHR12826:SF16', NULL, NULL, NULL, NULL, 'KH DOMAIN-CONTAINING PROTEIN', 251129),
(410356, 'PTHR10996:SF119', NULL, NULL, NULL, NULL, 'FI03731P-RELATED', 251130),
(410357, 'PTHR10996:SF239', NULL, NULL, NULL, NULL, '2-HACID_DH_C DOMAIN-CONTAINING PROTEIN', 251130); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(410358, 'PTHR10996:SF216', NULL, NULL, NULL, NULL, 'GLYOXYLATE/HYDROXYPYRUVATE REDUCTASE HPR3', 251130),
(410359, 'PTHR10996:SF259', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 251130),
(410360, 'PTHR10996:SF237', NULL, NULL, NULL, NULL, 'GLYOXYLATE/HYDROXYPYRUVATE REDUCTASE HPR3-LIKE', 251130),
(410361, 'PTHR10996:SF236', NULL, NULL, NULL, NULL, '', 251130),
(410362, 'PTHR10996:SF137', NULL, NULL, NULL, NULL, 'GLYOXYLATE REDUCTASE/HYDROXYPYRUVATE REDUCTASE', 251130),
(410363, 'PTHR10996:SF158', NULL, NULL, NULL, NULL, 'OS04G0107300 PROTEIN', 251130),
(410364, 'PTHR10996:SF114', NULL, NULL, NULL, NULL, 'GLYOXYLATE/HYDROXYPYRUVATE REDUCTASE A', 251130),
(410365, 'PTHR10996:SF257', NULL, NULL, NULL, NULL, 'ZGC:136493', 251130),
(410366, 'PTHR10996:SF279', NULL, NULL, NULL, NULL, '2-HYDROXYACID DEHYDROGENASE YPL113C-RELATED', 251130),
(410367, 'PTHR10996:SF235', NULL, NULL, NULL, NULL, 'D-GLYCERATE DEHYDROGENASE/HYDROXYPYRUVATE REDUCTASE', 251130),
(410368, 'PTHR10996:SF179', NULL, NULL, NULL, NULL, 'D-ISOMER SPECIFIC 2-HYDROXYACID DEHYDROGENASE FAMILY PROTEIN-RELATED', 251130),
(410369, 'PTHR10996:SF234', NULL, NULL, NULL, NULL, 'GLYOXYLATE/HYDROXYPYRUVATE REDUCTASE HPR3', 251130),
(410370, 'PTHR10996:SF278', NULL, NULL, NULL, NULL, 'D-ISOMER SPECIFIC 2-HYDROXYACID DEHYDROGENASE DOMAIN PROTEIN', 251130),
(410371, 'PTHR10996:SF178', NULL, NULL, NULL, NULL, 'GLYOXYLATE REDUCTASE 1', 251130),
(410372, 'PTHR10996:SF277', NULL, NULL, NULL, NULL, 'C-TERMINAL-BINDING PROTEIN-LIKE PROTEIN', 251130),
(410373, 'PTHR10996:SF255', NULL, NULL, NULL, NULL, 'D-ISOMER SPECIFIC 2-HYDROXYACID DEHYDROGENASE FAMILY PROTEIN', 251130),
(410374, 'PTHR10996:SF233', NULL, NULL, NULL, NULL, 'HYDROXYPHENYLPYRUVATE REDUCTASE-LIKE', 251130),
(410375, 'PTHR10996:SF254', NULL, NULL, NULL, NULL, 'D-ISOMER SPECIFIC 2-HYDROXYACID DEHYDROGENASE, CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 251130),
(410376, 'PTHR10996:SF276', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE-RELATED', 251130),
(410377, 'PTHR10996:SF275', NULL, NULL, NULL, NULL, 'DEHYDROGENASE-RELATED', 251130),
(410378, 'PTHR10996:SF230', NULL, NULL, NULL, NULL, 'GLYOXYLATE REDUCTASE/HYDROXYPYRUVATE REDUCTASE B', 251130),
(410379, 'PTHR10996:SF274', NULL, NULL, NULL, NULL, '2-HYDROXYACID DEHYDROGENASE YGL185C-RELATED', 251130),
(410380, 'PTHR10996:SF273', NULL, NULL, NULL, NULL, 'GLYOXYLATE REDUCTASE', 251130),
(410381, 'PTHR10996:SF272', NULL, NULL, NULL, NULL, 'GLYOXYLATE/HYDROXYPYRUVATE REDUCTASE HPR3', 251130),
(410382, 'PTHR10996:SF270', NULL, NULL, NULL, NULL, 'GLYOXYLATE/HYDROXYPYRUVATE REDUCTASE HPR3-LIKE', 251130),
(410383, 'PTHR10996:SF129', NULL, NULL, NULL, NULL, '2-HYDROXYACID DEHYDROGENASE C1773.17C-RELATED', 251130),
(410384, 'PTHR10996:SF249', NULL, NULL, NULL, NULL, 'BNAA09G47050D PROTEIN', 251130),
(410385, 'PTHR10996:SF248', NULL, NULL, NULL, NULL, 'GLYOXYLATE/HYDROXYPYRUVATE REDUCTASE HPR3-LIKE ISOFORM X1', 251130),
(410386, 'PTHR10996:SF149', NULL, NULL, NULL, NULL, '', 251130),
(410387, 'PTHR10996:SF226', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 251130),
(410388, 'PTHR10996:SF269', NULL, NULL, NULL, NULL, 'HYPOTHETICAL D-ISOMER SPECIFIC 2-HYDROXYACID DEHYDROGENASE (EUROFUNG)', 251130),
(410389, 'PTHR10996:SF225', NULL, NULL, NULL, NULL, 'HYDROXYPHENYLPYRUVATE REDUCTASE-LIKE', 251130),
(410390, 'PTHR10996:SF246', NULL, NULL, NULL, NULL, 'GLYOXYLATE/HYDROXYPYRUVATE REDUCTASE HPR3', 251130),
(410391, 'PTHR10996:SF268', NULL, NULL, NULL, NULL, 'GLYOXYLATE/HYDROXYPYRUVATE REDUCTASE HPR3', 251130),
(410392, 'PTHR10996:SF264', NULL, NULL, NULL, NULL, 'HYPOTHETICAL D-ISOMER SPECIFIC 2-HYDROXYACID DEHYDROGENASE (EUROFUNG)', 251130),
(410393, 'PTHR10996', NULL, NULL, NULL, NULL, '2-HYDROXYACID DEHYDROGENASE-RELATED', 251130),
(410394, 'PTHR10996:SF262', NULL, NULL, NULL, NULL, 'HYDROXYPHENYLPYRUVATE REDUCTASE-LIKE', 251130),
(410395, 'PTHR10996:SF261', NULL, NULL, NULL, NULL, '2-HACID_DH_C DOMAIN-CONTAINING PROTEIN', 251130),
(410396, 'PTHR10996:SF282', NULL, NULL, NULL, NULL, 'D-3-PHOSPHOGLYCERATE DEHYDROGENASE 1-RELATED', 251130);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(410397, 'PTHR10996:SF281', NULL, NULL, NULL, NULL, '2-HACID_DH_C DOMAIN-CONTAINING PROTEIN-RELATED', 251130),
(410398, 'PTHR10996:SF280', NULL, NULL, NULL, NULL, 'GOR1 GLYOXYLATE REDUCTASE-RELATED', 251130),
(410399, 'PTHR13502:SF3', NULL, NULL, NULL, NULL, 'CDC42 SMALL EFFECTOR PROTEIN 1', 251131),
(410400, 'PTHR13502:SF4', NULL, NULL, NULL, NULL, 'CDC42 SMALL EFFECTOR PROTEIN 2', 251131),
(410401, 'PTHR13502:SF7', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN', 251131),
(410402, 'PTHR13502:SF6', NULL, NULL, NULL, NULL, 'CDC42 SMALL EFFECTOR PROTEIN HOMOLOG', 251131),
(410403, 'PTHR13502:SF9', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN', 251131),
(410404, 'PTHR13502', NULL, NULL, NULL, NULL, 'CDC42 SMALL EFFECTOR PROTEIN HOMOLOG', 251131),
(410405, 'PTHR20914:SF12', NULL, NULL, NULL, NULL, 'LY6/PLAUR DOMAIN-CONTAINING 9', 251132),
(410406, 'PTHR20914:SF24', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 6 FAMILY MEMBER M2-RELATED', 251132),
(410407, 'PTHR20914:SF2', NULL, NULL, NULL, NULL, 'LY6/PLAUR DOMAIN-CONTAINING PROTEIN 8', 251132),
(410408, 'PTHR20914:SF16', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1810065E05 GENE', 251132),
(410409, 'PTHR20914:SF8', NULL, NULL, NULL, NULL, 'GENE 12253-RELATED', 251132),
(410410, 'PTHR20914:SF25', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A2 INHIBITOR AND LY6/PLAUR DOMAIN-CONTAINING PROTEIN', 251132),
(410411, 'PTHR20914', NULL, NULL, NULL, NULL, 'LY6/PLAUR DOMAIN-CONTAINING PROTEIN 8', 251132),
(410412, 'PTHR20914:SF6', NULL, NULL, NULL, NULL, 'EP1', 251132),
(410413, 'PTHR20914:SF26', NULL, NULL, NULL, NULL, 'UPAR/LY6 DOMAIN-CONTAINING PROTEIN', 251132),
(410414, 'PTHR20914:SF9', NULL, NULL, NULL, NULL, 'COILED, ISOFORM A', 251132),
(410415, 'PTHR35998:SF2', NULL, NULL, NULL, NULL, 'ENVELOPE GLYCOPROTEIN', 251133),
(410416, 'PTHR35998:SF1', NULL, NULL, NULL, NULL, '', 251133),
(410417, 'PTHR35998:SF3', NULL, NULL, NULL, NULL, '', 251133),
(410418, 'PTHR35998', NULL, NULL, NULL, NULL, 'OS02G0127900 PROTEIN', 251133),
(410419, 'PTHR32194:SF7', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT PROTEASE SUBUNIT HSLV', 251134),
(410420, 'PTHR32194', NULL, NULL, NULL, NULL, 'METALLOPROTEASE TLDD', 251134),
(410421, 'PTHR32194:SF6', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA', 251134),
(410422, 'PTHR32194:SF5', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA', 251134),
(410423, 'PTHR32194:SF4', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA TYPE-7', 251134),
(410424, 'PTHR32194:SF3', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA', 251134),
(410425, 'PTHR32194:SF2', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA TYPE-1', 251134),
(410426, 'PTHR32194:SF1', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT BETA', 251134),
(410427, 'PTHR32194:SF0', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT PROTEASE SUBUNIT HSLV', 251134),
(410428, 'PTHR43365:SF1', NULL, NULL, NULL, NULL, 'STEROID 3-KETOACYL-COA THIOLASE FADA6', 251135),
(410429, 'PTHR43365', NULL, NULL, NULL, NULL, 'BLR7806 PROTEIN', 251135),
(410430, 'PTHR12366:SF33', NULL, NULL, NULL, NULL, 'ASPARTYL/ASPARAGINYL BETA-HYDROXYLASE', 251136),
(410431, 'PTHR12366:SF32', NULL, NULL, NULL, NULL, 'ASP-B-HYDRO_N DOMAIN-CONTAINING PROTEIN', 251136),
(410432, 'PTHR12366', NULL, NULL, NULL, NULL, 'ASPARTYL/ASPARAGINYL BETA-HYDROXYLASE', 251136),
(410433, 'PTHR12366:SF29', NULL, NULL, NULL, NULL, 'ASPARTYL BETA-HYDROXYLASE, ISOFORM L', 251136),
(410434, 'PTHR24246:SF51', NULL, NULL, NULL, NULL, 'GPCR THERMAL RECEPTOR', 251137),
(410435, 'PTHR24246:SF52', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251137),
(410436, 'PTHR24246:SF31', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED BILE ACID RECEPTOR 1', 251137),
(410437, 'PTHR24246:SF21', NULL, NULL, NULL, NULL, 'ADENOSINE RECEPTOR A2C', 251137),
(410438, 'PTHR24246', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR AND ADENOSINE RECEPTOR', 251137),
(410439, 'PTHR24246:SF54', NULL, NULL, NULL, NULL, 'ADENOSINE A4 RECEPTOR A-RELATED', 251137),
(410440, 'PTHR24246:SF47', NULL, NULL, NULL, NULL, 'ADENOSINE RECEPTOR A2A', 251137),
(410441, 'PTHR24246:SF48', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR 88', 251137);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(410442, 'PTHR24246:SF27', NULL, NULL, NULL, NULL, 'ADENOSINE RECEPTOR, ISOFORM A', 251137),
(410443, 'PTHR24246:SF49', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR K01A12.3-RELATED', 251137),
(410444, 'PTHR24246:SF18', NULL, NULL, NULL, NULL, 'ADENOSINE RECEPTOR A2B', 251137),
(410445, 'PTHR24246:SF2', NULL, NULL, NULL, NULL, 'ADENOSINE RECEPTOR A3', 251137),
(410446, 'PTHR24246:SF1', NULL, NULL, NULL, NULL, 'ADENOSINE RECEPTOR A1', 251137),
(410447, 'PTHR36857', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 25', 251138),
(410448, 'PTHR36857:SF1', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 25', 251138),
(410449, 'PTHR31018:SF10', NULL, NULL, NULL, NULL, 'CELL WALL MANNOPROTEIN PST1-RELATED', 251139),
(410450, 'PTHR31018', NULL, NULL, NULL, NULL, 'SPORULATION-SPECIFIC PROTEIN-RELATED', 251139),
(410451, 'PTHR31018:SF3', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN-TYROSINE KINASE', 251139),
(410452, 'PTHR46536', NULL, NULL, NULL, NULL, 'ARL14 EFFECTOR PROTEIN', 251140),
(410453, 'PTHR46536:SF1', NULL, NULL, NULL, NULL, 'ARL14 EFFECTOR PROTEIN', 251140),
(410454, 'PTHR41158:SF2', NULL, NULL, NULL, NULL, 'AGAP010294-PA', 251141),
(410455, 'PTHR41158', NULL, NULL, NULL, NULL, 'AGAP010294-PA', 251141),
(410456, 'PTHR45695:SF1', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 151', 251142),
(410457, 'PTHR45695:SF19', NULL, NULL, NULL, NULL, 'GALANIN-LIKE G-PROTEIN COUPLED RECEPTOR NPR-9', 251142),
(410458, 'PTHR45695:SF17', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251142),
(410459, 'PTHR45695:SF18', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE CCHAMIDE-1 RECEPTOR', 251142),
(410460, 'PTHR45695:SF15', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR 15-LIKE', 251142),
(410461, 'PTHR45695:SF6', NULL, NULL, NULL, NULL, 'BOMBESIN RECEPTOR SUBTYPE-3', 251142),
(410462, 'PTHR45695:SF16', NULL, NULL, NULL, NULL, 'LEUCOKININ RECEPTOR', 251142),
(410463, 'PTHR45695:SF7', NULL, NULL, NULL, NULL, 'GASTRIN-RELEASING PEPTIDE RECEPTOR', 251142),
(410464, 'PTHR45695:SF8', NULL, NULL, NULL, NULL, 'NEUROMEDIN-B RECEPTOR', 251142),
(410465, 'PTHR45695', NULL, NULL, NULL, NULL, 'LEUCOKININ RECEPTOR-RELATED', 251142),
(410466, 'PTHR45695:SF9', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE CCHAMIDE-2 RECEPTOR', 251142),
(410467, 'PTHR43712', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_4G14580)-RELATED', 251143),
(410468, 'PTHR43712:SF19', NULL, NULL, NULL, NULL, 'DUAL O-METHYLTRANSFERASE/FAD-DEPENDENT MONOOXYGENASE ELCB', 251143),
(410469, 'PTHR43712:SF17', NULL, NULL, NULL, NULL, 'O-METHYLTRANSFERASE', 251143),
(410470, 'PTHR43712:SF18', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_4G14240)-RELATED', 251143),
(410471, 'PTHR43712:SF15', NULL, NULL, NULL, NULL, 'MONODICTYPHENONE CLUSTER TRANSCRIPTIONAL COACTIVATOR MDPA', 251143),
(410472, 'PTHR43712:SF1', NULL, NULL, NULL, NULL, 'HYPOTHETICAL O-METHYLTRANSFERASE (EUROFUNG)-RELATED', 251143),
(410473, 'PTHR43712:SF16', NULL, NULL, NULL, NULL, 'O-METHYLTRANSFERASE ELCB', 251143),
(410474, 'PTHR43712:SF11', NULL, NULL, NULL, NULL, 'METHYLTRANSF_2 DOMAIN-CONTAINING PROTEIN-RELATED', 251143),
(410475, 'PTHR43712:SF12', NULL, NULL, NULL, NULL, 'METHYLTRANSF_2 DOMAIN-CONTAINING PROTEIN', 251143),
(410476, 'PTHR43712:SF8', NULL, NULL, NULL, NULL, 'O-METHYLTRANSFERASE AF390-400', 251143),
(410477, 'PTHR43712:SF5', NULL, NULL, NULL, NULL, 'METHYLTRANSF_2 DOMAIN-CONTAINING PROTEIN-RELATED', 251143),
(410478, 'PTHR43712:SF4', NULL, NULL, NULL, NULL, 'METHYLTRANSF_2 DOMAIN-CONTAINING PROTEIN', 251143),
(410479, 'PTHR43712:SF2', NULL, NULL, NULL, NULL, 'O-METHYLTRANSFERASE CICE', 251143),
(410480, 'PTHR11654:SF59', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 2.10', 251144),
(410481, 'PTHR11654:SF341', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 1.2', 251144),
(410482, 'PTHR11654:SF462', NULL, NULL, NULL, NULL, 'DIPEPTIDE AND TRIPEPTIDE PERMEASE C', 251144),
(410483, 'PTHR11654:SF584', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN-RELATED', 251144),
(410484, 'PTHR11654:SF461', NULL, NULL, NULL, NULL, 'BNACNNG27190D PROTEIN', 251144);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(410485, 'PTHR11654:SF582', NULL, NULL, NULL, NULL, 'PEPTIDE/NITRATE TRANSPORTER', 251144),
(410486, 'PTHR11654:SF345', NULL, NULL, NULL, NULL, 'PEPTIDE/NITRATE TRANSPORTER', 251144),
(410487, 'PTHR11654:SF587', NULL, NULL, NULL, NULL, 'PROTON-DEPENDENT OLIGOPEPTIDE TRANSPORTER FAMILY-RELATED', 251144),
(410488, 'PTHR11654:SF588', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 7.3-LIKE', 251144),
(410489, 'PTHR11654:SF467', NULL, NULL, NULL, NULL, 'BNAANNG24930D PROTEIN', 251144),
(410490, 'PTHR11654:SF464', NULL, NULL, NULL, NULL, 'BNACNNG48110D PROTEIN', 251144),
(410491, 'PTHR11654:SF344', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 5.4', 251144),
(410492, 'PTHR11654:SF102', NULL, NULL, NULL, NULL, 'DIPEPTIDE AND TRIPEPTIDE PERMEASE B', 251144),
(410493, 'PTHR11654:SF580', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 5.4-LIKE ISOFORM X1', 251144),
(410494, 'PTHR11654:SF107', NULL, NULL, NULL, NULL, 'OS10G0109900 PROTEIN', 251144),
(410495, 'PTHR11654:SF349', NULL, NULL, NULL, NULL, 'PEPTIDE/NITRATE TRANSPORTER', 251144),
(410496, 'PTHR11654:SF108', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 5.10', 251144),
(410497, 'PTHR11654:SF589', NULL, NULL, NULL, NULL, 'OS03G0687000 PROTEIN', 251144),
(410498, 'PTHR11654:SF469', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 5.3', 251144),
(410499, 'PTHR11654:SF109', NULL, NULL, NULL, NULL, 'OS04G0491350 PROTEIN', 251144),
(410500, 'PTHR11654:SF330', NULL, NULL, NULL, NULL, '', 251144),
(410501, 'PTHR11654:SF451', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 6.4', 251144),
(410502, 'PTHR11654:SF452', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 8.5', 251144),
(410503, 'PTHR11654:SF331', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 7.1', 251144),
(410504, 'PTHR11654:SF570', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 2.11', 251144),
(410505, 'PTHR11654:SF450', NULL, NULL, NULL, NULL, '', 251144),
(410506, 'PTHR11654:SF571', NULL, NULL, NULL, NULL, 'NITRATE TRANSPORTER', 251144),
(410507, 'PTHR11654:SF576', NULL, NULL, NULL, NULL, 'PEPTIDE/NITRATE TRANSPORTER', 251144),
(410508, 'PTHR11654:SF455', NULL, NULL, NULL, NULL, '', 251144),
(410509, 'PTHR11654:SF577', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE-RELATED', 251144),
(410510, 'PTHR11654:SF335', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 1.3', 251144),
(410511, 'PTHR11654:SF453', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 5.2', 251144),
(410512, 'PTHR11654:SF332', NULL, NULL, NULL, NULL, 'OS07G0100600 PROTEIN', 251144),
(410513, 'PTHR11654:SF333', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 7.2', 251144),
(410514, 'PTHR11654:SF454', NULL, NULL, NULL, NULL, 'BNAA03G57770D PROTEIN', 251144),
(410515, 'PTHR11654:SF575', NULL, NULL, NULL, NULL, '', 251144),
(410516, 'PTHR11654:SF338', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 2.14-RELATED', 251144),
(410517, 'PTHR11654:SF459', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 5.6', 251144),
(410518, 'PTHR11654:SF339', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 4.1', 251144),
(410519, 'PTHR11654:SF336', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 4.2', 251144),
(410520, 'PTHR11654:SF578', NULL, NULL, NULL, NULL, 'OS10G0370700 PROTEIN', 251144),
(410521, 'PTHR11654:SF457', NULL, NULL, NULL, NULL, 'BNAA09G06180D PROTEIN', 251144),
(410522, 'PTHR11654:SF337', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 8.3', 251144),
(410523, 'PTHR11654:SF562', NULL, NULL, NULL, NULL, '', 251144),
(410524, 'PTHR11654:SF320', NULL, NULL, NULL, NULL, '', 251144),
(410525, 'PTHR11654:SF441', NULL, NULL, NULL, NULL, 'OS07G0603800 PROTEIN', 251144),
(410526, 'PTHR11654:SF560', NULL, NULL, NULL, NULL, 'PEPTIDE TRANSPORTER PTR2', 251144),
(410527, 'PTHR11654:SF565', NULL, NULL, NULL, NULL, 'PROTON-DEPENDENT OLIGOPEPTIDE TRANSPORTER FAMILY-RELATED', 251144),
(410528, 'PTHR11654:SF444', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 8.4', 251144),
(410529, 'PTHR11654:SF324', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 5.6-LIKE', 251144),
(410530, 'PTHR11654:SF445', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 2.12', 251144);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(410531, 'PTHR11654:SF563', NULL, NULL, NULL, NULL, 'BNAA06G34380D PROTEIN', 251144),
(410532, 'PTHR11654:SF321', NULL, NULL, NULL, NULL, '', 251144),
(410533, 'PTHR11654:SF442', NULL, NULL, NULL, NULL, '', 251144),
(410534, 'PTHR11654:SF322', NULL, NULL, NULL, NULL, 'OS10G0579600 PROTEIN', 251144),
(410535, 'PTHR11654:SF564', NULL, NULL, NULL, NULL, 'OS04G0491200 PROTEIN', 251144),
(410536, 'PTHR11654:SF448', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 4.4', 251144),
(410537, 'PTHR11654:SF569', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 4.5', 251144),
(410538, 'PTHR11654:SF327', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 2.1-RELATED', 251144),
(410539, 'PTHR11654:SF449', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 4.5-LIKE', 251144),
(410540, 'PTHR11654:SF328', NULL, NULL, NULL, NULL, '', 251144),
(410541, 'PTHR11654:SF325', NULL, NULL, NULL, NULL, 'PEPTIDE/NITRATE TRANSPORTER', 251144),
(410542, 'PTHR11654:SF326', NULL, NULL, NULL, NULL, 'NITRATE TRANSPORTER 1', 251144),
(410543, 'PTHR11654:SF568', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 4.5-LIKE', 251144),
(410544, 'PTHR11654:SF447', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 7.3-LIKE ISOFORM X1', 251144),
(410545, 'PTHR11654:SF551', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 4.3', 251144),
(410546, 'PTHR11654:SF313', NULL, NULL, NULL, NULL, 'PEPTIDE TRANSPORTER PTR2', 251144),
(410547, 'PTHR11654:SF434', NULL, NULL, NULL, NULL, 'PEPTIDE/NITRATE TRANSPORTER', 251144),
(410548, 'PTHR11654:SF552', NULL, NULL, NULL, NULL, 'OS04G0491500 PROTEIN', 251144),
(410549, 'PTHR11654:SF553', NULL, NULL, NULL, NULL, 'BNAA02G24280D PROTEIN', 251144),
(410550, 'PTHR11654:SF311', NULL, NULL, NULL, NULL, 'MFS PEPTIDE TRANSPORTER, PUTAITVE (AFU_ORTHOLOGUE AFUA_1G12240)', 251144),
(410551, 'PTHR11654:SF432', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 6.2-LIKE', 251144),
(410552, 'PTHR11654:SF20', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 2.13', 251144),
(410553, 'PTHR11654:SF21', NULL, NULL, NULL, NULL, 'OS12G0231000 PROTEIN', 251144),
(410554, 'PTHR11654:SF558', NULL, NULL, NULL, NULL, 'LATD/NIP', 251144),
(410555, 'PTHR11654:SF437', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 5.12', 251144),
(410556, 'PTHR11654:SF317', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 6.3-LIKE', 251144),
(410557, 'PTHR11654:SF438', NULL, NULL, NULL, NULL, 'OS03G0235700 PROTEIN', 251144),
(410558, 'PTHR11654:SF559', NULL, NULL, NULL, NULL, 'BNAA07G28390D PROTEIN', 251144),
(410559, 'PTHR11654:SF435', NULL, NULL, NULL, NULL, 'OS03G0138700 PROTEIN', 251144),
(410560, 'PTHR11654:SF556', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 8.3', 251144),
(410561, 'PTHR11654:SF439', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 2.10-LIKE', 251144),
(410562, 'PTHR11654:SF385', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 5.16', 251144),
(410563, 'PTHR11654:SF143', NULL, NULL, NULL, NULL, 'OS06G0706100 PROTEIN', 251144),
(410564, 'PTHR11654:SF386', NULL, NULL, NULL, NULL, 'PEPTIDE TRANSPORTER', 251144),
(410565, 'PTHR11654:SF383', NULL, NULL, NULL, NULL, 'OS11G0284300 PROTEIN', 251144),
(410566, 'PTHR11654:SF384', NULL, NULL, NULL, NULL, 'PEPTIDE/NITRATE TRANSPORTER', 251144),
(410567, 'PTHR11654:SF142', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE, EXPRESSED-RELATED', 251144),
(410568, 'PTHR11654:SF389', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 5.6-LIKE', 251144),
(410569, 'PTHR11654:SF381', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 2.6-RELATED', 251144),
(410570, 'PTHR11654:SF380', NULL, NULL, NULL, NULL, '', 251144),
(410571, 'PTHR11654:SF495', NULL, NULL, NULL, NULL, 'PROTON-DEPENDENT OLIGOPEPTIDE TRANSPORTER FAMILY-RELATED', 251144),
(410572, 'PTHR11654:SF496', NULL, NULL, NULL, NULL, '', 251144),
(410573, 'PTHR11654:SF375', NULL, NULL, NULL, NULL, '', 251144),
(410574, 'PTHR11654:SF372', NULL, NULL, NULL, NULL, '', 251144),
(410575, 'PTHR11654:SF131', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 4.5-LIKE ISOFORM X1', 251144),
(410576, 'PTHR11654:SF494', NULL, NULL, NULL, NULL, '', 251144);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(410577, 'PTHR11654:SF373', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 6.4-LIKE', 251144),
(410578, 'PTHR11654:SF499', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 6.3-LIKE ISOFORM X2', 251144),
(410579, 'PTHR11654:SF497', NULL, NULL, NULL, NULL, '4HBT DOMAIN-CONTAINING PROTEIN', 251144),
(410580, 'PTHR11654:SF377', NULL, NULL, NULL, NULL, '', 251144),
(410581, 'PTHR11654:SF498', NULL, NULL, NULL, NULL, 'LATD/NIP', 251144),
(410582, 'PTHR11654:SF491', NULL, NULL, NULL, NULL, 'PROTON-DEPENDENT OLIGOPEPTIDE TRANSPORTER FAMILY-RELATED', 251144),
(410583, 'PTHR11654:SF492', NULL, NULL, NULL, NULL, 'BNAC07G13630D PROTEIN', 251144),
(410584, 'PTHR11654:SF371', NULL, NULL, NULL, NULL, '', 251144),
(410585, 'PTHR11654:SF139', NULL, NULL, NULL, NULL, 'OS04G0597501 PROTEIN', 251144),
(410586, 'PTHR11654:SF484', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 2.7-LIKE', 251144),
(410587, 'PTHR11654:SF364', NULL, NULL, NULL, NULL, 'OS11G0282800 PROTEIN', 251144),
(410588, 'PTHR11654:SF362', NULL, NULL, NULL, NULL, '', 251144),
(410589, 'PTHR11654:SF483', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 5.10', 251144),
(410590, 'PTHR11654:SF368', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 2.13', 251144),
(410591, 'PTHR11654:SF486', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 2.9', 251144),
(410592, 'PTHR11654:SF365', NULL, NULL, NULL, NULL, 'PEPTIDE/NITRATE TRANSPORTER', 251144),
(410593, 'PTHR11654:SF487', NULL, NULL, NULL, NULL, 'BNAA09G06190D PROTEIN', 251144),
(410594, 'PTHR11654:SF481', NULL, NULL, NULL, NULL, 'BNAA08G19510D PROTEIN', 251144),
(410595, 'PTHR11654:SF369', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 1.1', 251144),
(410596, 'PTHR11654:SF473', NULL, NULL, NULL, NULL, 'PEPTIDE/NITRATE TRANSPORTER', 251144),
(410597, 'PTHR11654:SF352', NULL, NULL, NULL, NULL, 'PEPTIDE/NITRATE TRANSPORTER PLANT', 251144),
(410598, 'PTHR11654:SF110', NULL, NULL, NULL, NULL, 'PEPTIDE/NITRATE TRANSPORTER', 251144),
(410599, 'PTHR11654:SF353', NULL, NULL, NULL, NULL, 'PEPTIDE/NITRATE TRANSPORTER PLANT-LIKE PROTEIN', 251144),
(410600, 'PTHR11654:SF474', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 5.11', 251144),
(410601, 'PTHR11654:SF592', NULL, NULL, NULL, NULL, 'OS10G0112500 PROTEIN', 251144),
(410602, 'PTHR11654:SF350', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 4.5-LIKE', 251144),
(410603, 'PTHR11654:SF472', NULL, NULL, NULL, NULL, 'BNAA09G56930D PROTEIN', 251144),
(410604, 'PTHR11654:SF593', NULL, NULL, NULL, NULL, 'LEOPT1', 251144),
(410605, 'PTHR11654:SF114', NULL, NULL, NULL, NULL, 'OSJNBA0064D20.8 PROTEIN', 251144),
(410606, 'PTHR11654:SF598', NULL, NULL, NULL, NULL, '', 251144),
(410607, 'PTHR11654:SF115', NULL, NULL, NULL, NULL, 'OS10G0469900 PROTEIN', 251144),
(410608, 'PTHR11654:SF599', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 5.7-LIKE', 251144),
(410609, 'PTHR11654:SF478', NULL, NULL, NULL, NULL, 'PROTON-DEPENDENT OLIGOPEPTIDE TRANSPORTER FAMILY-RELATED', 251144),
(410610, 'PTHR11654:SF112', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 6.1', 251144),
(410611, 'PTHR11654:SF354', NULL, NULL, NULL, NULL, '', 251144),
(410612, 'PTHR11654:SF596', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 8.2', 251144),
(410613, 'PTHR11654:SF590', NULL, NULL, NULL, NULL, '', 251144),
(410614, 'PTHR11654:SF591', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 5.13-RELATED', 251144),
(410615, 'PTHR11654:SF470', NULL, NULL, NULL, NULL, 'BNAC04G01330D PROTEIN', 251144),
(410616, 'PTHR11654:SF119', NULL, NULL, NULL, NULL, 'DIPEPTIDE PERMEASE D', 251144),
(410617, 'PTHR11654:SF479', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN-RELATED', 251144),
(410618, 'PTHR11654:SF359', NULL, NULL, NULL, NULL, '', 251144),
(410619, 'PTHR11654:SF188', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 3.1', 251144),
(410620, 'PTHR11654:SF620', NULL, NULL, NULL, NULL, '', 251144),
(410621, 'PTHR11654:SF500', NULL, NULL, NULL, NULL, 'BNAC04G26790D PROTEIN', 251144),
(410622, 'PTHR11654:SF621', NULL, NULL, NULL, NULL, 'PROTON-DEPENDENT OLIGOPEPTIDE TRANSPORTER FAMILY-RELATED', 251144);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(410623, 'PTHR11654:SF189', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PEPTIDE TRANSPORTER (EUROFUNG)', 251144),
(410624, 'PTHR11654:SF183', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 15 MEMBER 1A', 251144),
(410625, 'PTHR11654:SF184', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 4.7', 251144),
(410626, 'PTHR11654:SF181', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 2.8', 251144),
(410627, 'PTHR11654:SF509', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 15 MEMBER 4', 251144),
(410628, 'PTHR11654:SF624', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 8.1', 251144),
(410629, 'PTHR11654:SF504', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 5.6-LIKE', 251144),
(410630, 'PTHR11654:SF625', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 1.2', 251144),
(410631, 'PTHR11654:SF622', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 5.7', 251144),
(410632, 'PTHR11654:SF501', NULL, NULL, NULL, NULL, 'PEPTIDE TRANSPORTER', 251144),
(410633, 'PTHR11654:SF623', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 4.2', 251144),
(410634, 'PTHR11654:SF502', NULL, NULL, NULL, NULL, 'PEPTIDE TRANSPORTER', 251144),
(410635, 'PTHR11654:SF628', NULL, NULL, NULL, NULL, 'PEPTIDE/NITRATE TRANSPORTER PLANT', 251144),
(410636, 'PTHR11654:SF507', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 6.3', 251144),
(410637, 'PTHR11654:SF629', NULL, NULL, NULL, NULL, 'BNAA03G19060D PROTEIN', 251144),
(410638, 'PTHR11654:SF508', NULL, NULL, NULL, NULL, '', 251144),
(410639, 'PTHR11654:SF626', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 1.2-LIKE', 251144),
(410640, 'PTHR11654:SF627', NULL, NULL, NULL, NULL, 'PEPTIDE/NITRATE TRANSPORTER', 251144),
(410641, 'PTHR11654:SF506', NULL, NULL, NULL, NULL, '', 251144),
(410642, 'PTHR11654:SF297', NULL, NULL, NULL, NULL, 'PROTON-DEPENDENT OLIGOPEPTIDE TRANSPORT FAMILY PROTEIN', 251144),
(410643, 'PTHR11654:SF176', NULL, NULL, NULL, NULL, 'OS04G0597600 PROTEIN', 251144),
(410644, 'PTHR11654:SF175', NULL, NULL, NULL, NULL, 'OS10G0111700 PROTEIN', 251144),
(410645, 'PTHR11654:SF610', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN-RELATED', 251144),
(410646, 'PTHR11654:SF172', NULL, NULL, NULL, NULL, 'OS08G0527700 PROTEIN', 251144),
(410647, 'PTHR11654:SF293', NULL, NULL, NULL, NULL, 'PEPTIDE/NITRATE TRANSPORTER PLANT', 251144),
(410648, 'PTHR11654:SF619', NULL, NULL, NULL, NULL, 'BNACNNG65650D PROTEIN', 251144),
(410649, 'PTHR11654:SF613', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 5.8', 251144),
(410650, 'PTHR11654:SF614', NULL, NULL, NULL, NULL, '', 251144),
(410651, 'PTHR11654:SF611', NULL, NULL, NULL, NULL, 'LATD/NIP', 251144),
(410652, 'PTHR11654:SF612', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 6.3', 251144),
(410653, 'PTHR11654:SF617', NULL, NULL, NULL, NULL, 'PEPTIDE TRANSPORTER', 251144),
(410654, 'PTHR11654:SF618', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 8.3', 251144),
(410655, 'PTHR11654:SF615', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 4.6-LIKE', 251144),
(410656, 'PTHR11654:SF616', NULL, NULL, NULL, NULL, 'BNAA01G26960D PROTEIN', 251144),
(410657, 'PTHR11654:SF163', NULL, NULL, NULL, NULL, 'OS02G0699000 PROTEIN', 251144),
(410658, 'PTHR11654:SF164', NULL, NULL, NULL, NULL, 'OS01G0871900 PROTEIN', 251144),
(410659, 'PTHR11654:SF167', NULL, NULL, NULL, NULL, 'OS10G0579800 PROTEIN', 251144),
(410660, 'PTHR11654:SF168', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 3.1', 251144),
(410661, 'PTHR11654:SF289', NULL, NULL, NULL, NULL, 'PEPTIDE TRANSPORTER 3', 251144),
(410662, 'PTHR11654:SF608', NULL, NULL, NULL, NULL, 'PTR2P', 251144),
(410663, 'PTHR11654:SF609', NULL, NULL, NULL, NULL, 'PEPTIDE TRANSPORTER 2-RELATED', 251144),
(410664, 'PTHR11654:SF602', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251144),
(410665, 'PTHR11654:SF603', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 15 MEMBER 2', 251144),
(410666, 'PTHR11654:SF600', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 5.10', 251144),
(410667, 'PTHR11654', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORTER-RELATED', 251144),
(410668, 'PTHR11654:SF601', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 4.2', 251144);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(410669, 'PTHR11654:SF606', NULL, NULL, NULL, NULL, 'PEPTIDE TRANSPORTER', 251144),
(410670, 'PTHR11654:SF607', NULL, NULL, NULL, NULL, '', 251144),
(410671, 'PTHR11654:SF604', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 2.7-LIKE', 251144),
(410672, 'PTHR11654:SF605', NULL, NULL, NULL, NULL, 'PEPTIDE TRANSPORTER', 251144),
(410673, 'PTHR11654:SF396', NULL, NULL, NULL, NULL, '', 251144),
(410674, 'PTHR11654:SF397', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 5.15', 251144),
(410675, 'PTHR11654:SF155', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 5.1', 251144),
(410676, 'PTHR11654:SF152', NULL, NULL, NULL, NULL, '', 251144),
(410677, 'PTHR11654:SF395', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 2.7-LIKE', 251144),
(410678, 'PTHR11654:SF156', NULL, NULL, NULL, NULL, 'OS04G0660900 PROTEIN', 251144),
(410679, 'PTHR11654:SF399', NULL, NULL, NULL, NULL, '', 251144),
(410680, 'PTHR11654:SF150', NULL, NULL, NULL, NULL, 'OS01G0761400 PROTEIN', 251144),
(410681, 'PTHR11654:SF393', NULL, NULL, NULL, NULL, 'NITRITE TRANSPORTER', 251144),
(410682, 'PTHR11654:SF151', NULL, NULL, NULL, NULL, 'OS01G0871500 PROTEIN', 251144),
(410683, 'PTHR11654:SF540', NULL, NULL, NULL, NULL, 'BNAA09G47380D PROTEIN', 251144),
(410684, 'PTHR11654:SF422', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 5.5', 251144),
(410685, 'PTHR11654:SF543', NULL, NULL, NULL, NULL, 'BNAA09G17780D PROTEIN', 251144),
(410686, 'PTHR11654:SF544', NULL, NULL, NULL, NULL, 'BNAA07G24560D PROTEIN', 251144),
(410687, 'PTHR11654:SF423', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 1.2-LIKE', 251144),
(410688, 'PTHR11654:SF421', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 3.1', 251144),
(410689, 'PTHR11654:SF542', NULL, NULL, NULL, NULL, 'BNAC02G42280D PROTEIN', 251144),
(410690, 'PTHR11654:SF95', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 15 MEMBER 3', 251144),
(410691, 'PTHR11654:SF94', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 5.10', 251144),
(410692, 'PTHR11654:SF99', NULL, NULL, NULL, NULL, 'DIPEPTIDE AND TRIPEPTIDE PERMEASE A', 251144),
(410693, 'PTHR11654:SF98', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 4.6', 251144),
(410694, 'PTHR11654:SF547', NULL, NULL, NULL, NULL, '', 251144),
(410695, 'PTHR11654:SF427', NULL, NULL, NULL, NULL, 'PEPTIDE/NITRATE TRANSPORTER', 251144),
(410696, 'PTHR11654:SF548', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE-RELATED', 251144),
(410697, 'PTHR11654:SF545', NULL, NULL, NULL, NULL, 'BNAANNG11510D PROTEIN', 251144),
(410698, 'PTHR11654:SF546', NULL, NULL, NULL, NULL, 'BNAA05G35790D PROTEIN', 251144),
(410699, 'PTHR11654:SF425', NULL, NULL, NULL, NULL, 'POT FAMILY PROTEIN', 251144),
(410700, 'PTHR11654:SF304', NULL, NULL, NULL, NULL, 'OS01G0902800 PROTEIN', 251144),
(410701, 'PTHR11654:SF307', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 2.11-LIKE', 251144),
(410702, 'PTHR11654:SF428', NULL, NULL, NULL, NULL, 'PEPTIDE TRANSPORTER', 251144),
(410703, 'PTHR11654:SF429', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 2.4-LIKE', 251144),
(410704, 'PTHR11654:SF411', NULL, NULL, NULL, NULL, '', 251144),
(410705, 'PTHR11654:SF533', NULL, NULL, NULL, NULL, 'PROTON-DEPENDENT OLIGOPEPTIDE TRANSPORTER FAMILY-RELATED', 251144),
(410706, 'PTHR11654:SF530', NULL, NULL, NULL, NULL, 'OS05G0430900 PROTEIN', 251144),
(410707, 'PTHR11654:SF531', NULL, NULL, NULL, NULL, 'PEPTIDE/NITRATE TRANSPORTER', 251144),
(410708, 'PTHR11654:SF85', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 6.2', 251144),
(410709, 'PTHR11654:SF82', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 5.9', 251144),
(410710, 'PTHR11654:SF89', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 15 MEMBER 1', 251144),
(410711, 'PTHR11654:SF86', NULL, NULL, NULL, NULL, '', 251144),
(410712, 'PTHR11654:SF91', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 15 MEMBER 5', 251144),
(410713, 'PTHR11654:SF90', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 7.3', 251144),
(410714, 'PTHR11654:SF415', NULL, NULL, NULL, NULL, 'OS11G0426100 PROTEIN', 251144),
(410715, 'PTHR11654:SF536', NULL, NULL, NULL, NULL, 'BNAA06G13070D PROTEIN', 251144);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(410716, 'PTHR11654:SF537', NULL, NULL, NULL, NULL, 'BNAA06G16980D PROTEIN', 251144),
(410717, 'PTHR11654:SF416', NULL, NULL, NULL, NULL, 'BNACNNG33920D PROTEIN', 251144),
(410718, 'PTHR11654:SF413', NULL, NULL, NULL, NULL, 'OS05G0411100 PROTEIN', 251144),
(410719, 'PTHR11654:SF414', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 3.1-LIKE', 251144),
(410720, 'PTHR11654:SF539', NULL, NULL, NULL, NULL, 'POT FAMILY PROTEIN', 251144),
(410721, 'PTHR11654:SF418', NULL, NULL, NULL, NULL, '', 251144),
(410722, 'PTHR11654:SF79', NULL, NULL, NULL, NULL, 'OS03G0823500 PROTEIN', 251144),
(410723, 'PTHR11654:SF400', NULL, NULL, NULL, NULL, '', 251144),
(410724, 'PTHR11654:SF401', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 6.2-LIKE ISOFORM X1', 251144),
(410725, 'PTHR11654:SF522', NULL, NULL, NULL, NULL, 'PROTON-DEPENDENT OLIGOPEPTIDE TRANSPORTER FAMILY-RELATED', 251144),
(410726, 'PTHR11654:SF73', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 5.2-LIKE', 251144),
(410727, 'PTHR11654:SF77', NULL, NULL, NULL, NULL, '', 251144),
(410728, 'PTHR11654:SF80', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 15 MEMBER 4', 251144),
(410729, 'PTHR11654:SF525', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 2.8-LIKE', 251144),
(410730, 'PTHR11654:SF526', NULL, NULL, NULL, NULL, 'PROTON-DEPENDENT OLIGOPEPTIDE TRANSPORTER FAMILY-RELATED', 251144),
(410731, 'PTHR11654:SF524', NULL, NULL, NULL, NULL, 'PROTON-DEPENDENT OLIGOPEPTIDE TRANSPORTER FAMILY-RELATED', 251144),
(410732, 'PTHR11654:SF403', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 2.7-LIKE', 251144),
(410733, 'PTHR11654:SF408', NULL, NULL, NULL, NULL, '', 251144),
(410734, 'PTHR11654:SF409', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 4.5-LIKE', 251144),
(410735, 'PTHR11654:SF527', NULL, NULL, NULL, NULL, 'BNAA09G54940D PROTEIN', 251144),
(410736, 'PTHR11654:SF407', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 8.1-LIKE', 251144),
(410737, 'PTHR11654:SF528', NULL, NULL, NULL, NULL, 'BNAC01G35410D PROTEIN', 251144),
(410738, 'PTHR11654:SF198', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 4.4', 251144),
(410739, 'PTHR11654:SF196', NULL, NULL, NULL, NULL, 'OS05G0410900 PROTEIN', 251144),
(410740, 'PTHR11654:SF511', NULL, NULL, NULL, NULL, 'BNACNNG15890D PROTEIN', 251144),
(410741, 'PTHR11654:SF630', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 1.2-LIKE', 251144),
(410742, 'PTHR11654:SF191', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE-RELATED', 251144),
(410743, 'PTHR11654:SF64', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 8.3', 251144),
(410744, 'PTHR11654:SF192', NULL, NULL, NULL, NULL, 'PEPTIDE TRANSPORTER FAMILY 1', 251144),
(410745, 'PTHR11654:SF514', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 2.7-LIKE', 251144),
(410746, 'PTHR11654:SF515', NULL, NULL, NULL, NULL, 'BNACNNG04550D PROTEIN', 251144),
(410747, 'PTHR11654:SF513', NULL, NULL, NULL, NULL, 'PROTEIN NRT1/ PTR FAMILY 8.1-LIKE', 251144),
(410748, 'PTHR11654:SF518', NULL, NULL, NULL, NULL, 'NITRATE TRANSPORTER', 251144),
(410749, 'PTHR11654:SF519', NULL, NULL, NULL, NULL, '', 251144),
(410750, 'PTHR11654:SF517', NULL, NULL, NULL, NULL, 'BNACNNG61860D PROTEIN', 251144),
(410751, 'PTHR36527', NULL, NULL, NULL, NULL, 'OS01G0282866 PROTEIN', 251145),
(410752, 'PTHR36527:SF3', NULL, NULL, NULL, NULL, 'OS01G0282866 PROTEIN', 251145),
(410753, 'PTHR21324:SF9', NULL, NULL, NULL, NULL, 'ZGC:154058', 251146),
(410754, 'PTHR21324', NULL, NULL, NULL, NULL, 'FASTING-INDUCIBLE INTEGRAL MEMBRANE PROTEIN TM6P1-RELATED', 251146),
(410755, 'PTHR21324:SF15', NULL, NULL, NULL, NULL, '', 251146),
(410756, 'PTHR21324:SF6', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 150A', 251146),
(410757, 'PTHR21324:SF7', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 150C', 251146),
(410758, 'PTHR21324:SF16', NULL, NULL, NULL, NULL, '', 251146),
(410759, 'PTHR21324:SF11', NULL, NULL, NULL, NULL, 'DNA DAMAGE-REGULATED AUTOPHAGY MODULATOR PROTEIN 1', 251146),
(410760, 'PTHR21324:SF10', NULL, NULL, NULL, NULL, 'DNA DAMAGE-REGULATED AUTOPHAGY MODULATOR PROTEIN 2', 251146),
(410761, 'PTHR21324:SF2', NULL, NULL, NULL, NULL, 'EG:22E5.9 PROTEIN', 251146);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(410762, 'PTHR21324:SF13', NULL, NULL, NULL, NULL, 'SI:DKEY-228D14.5', 251146),
(410763, 'PTHR21324:SF3', NULL, NULL, NULL, NULL, 'MODULATOR OF MACROAUTOPHAGY TMEM150B', 251146),
(410764, 'PTHR44019:SF2', NULL, NULL, NULL, NULL, 'POC1 CENTRIOLAR PROTEIN HOMOLOG A', 251147),
(410765, 'PTHR44019:SF1', NULL, NULL, NULL, NULL, 'POC1 CENTRIOLAR PROTEIN HOMOLOG B', 251147),
(410766, 'PTHR44019', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 55', 251147),
(410767, 'PTHR44019:SF17', NULL, NULL, NULL, NULL, 'F-BOX/WD REPEAT-CONTAINING PROTEIN 12', 251147),
(410768, 'PTHR44019:SF23', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 251147),
(410769, 'PTHR44019:SF8', NULL, NULL, NULL, NULL, 'POC1 CENTRIOLAR PROTEIN HOMOLOG', 251147),
(410770, 'PTHR44019:SF20', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 55', 251147),
(410771, 'PTHR44019:SF11', NULL, NULL, NULL, NULL, 'F-BOX/WD REPEAT-CONTAINING PROTEIN 8', 251147),
(410772, 'PTHR47669', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL TRANSFER PROTEIN SFH5', 251148),
(410773, 'PTHR47669:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL TRANSFER PROTEIN SFH5', 251148),
(410774, 'PTHR45970:SF1', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-C9', 251149),
(410775, 'PTHR45970', NULL, NULL, NULL, NULL, 'AGAP004664-PA', 251149),
(410776, 'PTHR45970:SF5', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-B9', 251149),
(410777, 'PTHR45970:SF4', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-D9', 251149),
(410778, 'PTHR45970:SF3', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-A9', 251149),
(410779, 'PTHR45970:SF2', NULL, NULL, NULL, NULL, 'AGAP004664-PA', 251149),
(410780, 'PTHR34602', NULL, NULL, NULL, NULL, 'NEMATODE SPECIFIC PEPTIDE FAMILY, GROUP E-RELATED', 251150),
(410781, 'PTHR34602:SF1', NULL, NULL, NULL, NULL, 'NEMATODE SPECIFIC PEPTIDE FAMILY, GROUP E', 251150),
(410782, 'PTHR34602:SF2', NULL, NULL, NULL, NULL, 'NEMATODE SPECIFIC PEPTIDE FAMILY, GROUP E', 251150),
(410783, 'PTHR31595:SF57', NULL, NULL, NULL, NULL, 'OS04G0481900 PROTEIN', 251151),
(410784, 'PTHR31595:SF35', NULL, NULL, NULL, NULL, 'OSJNBA0009K15.16 PROTEIN', 251151),
(410785, 'PTHR31595:SF36', NULL, NULL, NULL, NULL, 'LONG-CHAIN-ALCOHOL O-FATTY-ACYLTRANSFERASE 2-RELATED', 251151),
(410786, 'PTHR31595:SF11', NULL, NULL, NULL, NULL, 'MBOAT_2 DOMAIN-CONTAINING PROTEIN', 251151),
(410787, 'PTHR31595:SF33', NULL, NULL, NULL, NULL, 'OS02G0468100 PROTEIN', 251151),
(410788, 'PTHR31595:SF39', NULL, NULL, NULL, NULL, 'LONG-CHAIN-ALCOHOL O-FATTY-ACYLTRANSFERASE 5-RELATED', 251151),
(410789, 'PTHR31595:SF38', NULL, NULL, NULL, NULL, 'MBOAT (MEMBRANE BOUND O-ACYL TRANSFERASE) FAMILY PROTEIN', 251151),
(410790, 'PTHR31595:SF71', NULL, NULL, NULL, NULL, 'LONG-CHAIN-ALCOHOL O-FATTY-ACYLTRANSFERASE 5-RELATED', 251151),
(410791, 'PTHR31595:SF72', NULL, NULL, NULL, NULL, 'ACYL-COA--STEROL O-ACYLTRANSFERASE 1-LIKE', 251151),
(410792, 'PTHR31595:SF50', NULL, NULL, NULL, NULL, 'MBOAT_2 DOMAIN-CONTAINING PROTEIN', 251151),
(410793, 'PTHR31595:SF70', NULL, NULL, NULL, NULL, 'LONG-CHAIN-ALCOHOL O-FATTY-ACYLTRANSFERASE 3-RELATED', 251151),
(410794, 'PTHR31595:SF53', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE SIRH', 251151),
(410795, 'PTHR31595:SF31', NULL, NULL, NULL, NULL, 'LONG-CHAIN-ALCOHOL O-FATTY-ACYLTRANSFERASE 7-RELATED', 251151),
(410796, 'PTHR31595:SF75', NULL, NULL, NULL, NULL, 'MBOAT_2 DOMAIN-CONTAINING PROTEIN', 251151),
(410797, 'PTHR31595:SF54', NULL, NULL, NULL, NULL, 'OS07G0540000 PROTEIN', 251151),
(410798, 'PTHR31595:SF73', NULL, NULL, NULL, NULL, 'OS02G0454500 PROTEIN', 251151),
(410799, 'PTHR31595:SF51', NULL, NULL, NULL, NULL, 'MBOAT_2 DOMAIN-CONTAINING PROTEIN', 251151),
(410800, 'PTHR31595:SF52', NULL, NULL, NULL, NULL, 'MBOAT (MEMBRANE BOUND O-ACYL TRANSFERASE) FAMILY PROTEIN-RELATED', 251151),
(410801, 'PTHR31595:SF74', NULL, NULL, NULL, NULL, 'ACYL-COA STEROL ACYL TRANSFERASE 1-RELATED', 251151),
(410802, 'PTHR31595:SF46', NULL, NULL, NULL, NULL, 'ACYL-COA--STEROL O-ACYLTRANSFERASE 1', 251151),
(410803, 'PTHR31595:SF68', NULL, NULL, NULL, NULL, 'ACYL-COA--STEROL O-ACYLTRANSFERASE 1-LIKE', 251151);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(410804, 'PTHR31595:SF69', NULL, NULL, NULL, NULL, 'MBOAT_2 DOMAIN-CONTAINING PROTEIN', 251151),
(410805, 'PTHR31595:SF47', NULL, NULL, NULL, NULL, 'MBOAT_2 DOMAIN-CONTAINING PROTEIN', 251151),
(410806, 'PTHR31595:SF67', NULL, NULL, NULL, NULL, 'MBOAT_2 DOMAIN-CONTAINING PROTEIN', 251151),
(410807, 'PTHR31595:SF45', NULL, NULL, NULL, NULL, 'LONG-CHAIN-ALCOHOL O-FATTY-ACYLTRANSFERASE 1-RELATED', 251151),
(410808, 'PTHR31595:SF48', NULL, NULL, NULL, NULL, 'WAX SYNTHASE-RELATED', 251151),
(410809, 'PTHR31595:SF27', NULL, NULL, NULL, NULL, 'MBOAT_2 DOMAIN-CONTAINING PROTEIN-RELATED', 251151),
(410810, 'PTHR31595:SF49', NULL, NULL, NULL, NULL, 'MBOAT_2 DOMAIN-CONTAINING PROTEIN', 251151),
(410811, 'PTHR31595:SF60', NULL, NULL, NULL, NULL, 'BIOSYNTHESIS PROTEIN (TRI7), PUTATIVE (AFU_ORTHOLOGUE AFUA_8G05970)-RELATED', 251151),
(410812, 'PTHR31595:SF40', NULL, NULL, NULL, NULL, 'MBOAT_2 DOMAIN-CONTAINING PROTEIN', 251151),
(410813, 'PTHR31595:SF41', NULL, NULL, NULL, NULL, 'LONG-CHAIN-ALCOHOL O-FATTY-ACYLTRANSFERASE 10-RELATED', 251151),
(410814, 'PTHR31595:SF9', NULL, NULL, NULL, NULL, 'OS01G0651500 PROTEIN', 251151),
(410815, 'PTHR31595', NULL, NULL, NULL, NULL, 'LONG-CHAIN-ALCOHOL O-FATTY-ACYLTRANSFERASE 3-RELATED', 251151),
(410816, 'PTHR13254:SF2', NULL, NULL, NULL, NULL, 'GOLGIN SUBFAMILY A MEMBER 7B', 251152),
(410817, 'PTHR13254', NULL, NULL, NULL, NULL, 'GOLGI AUTOANTIGEN, GOLGIN SUBFAMILY A, 7', 251152),
(410818, 'PTHR13254:SF0', NULL, NULL, NULL, NULL, 'ERF4 DOMAIN-CONTAINING PROTEIN', 251152),
(410819, 'PTHR13254:SF1', NULL, NULL, NULL, NULL, 'GOLGIN SUBFAMILY A MEMBER 7', 251152),
(410820, 'PTHR22702', NULL, NULL, NULL, NULL, 'PROTEASE-ASSOCIATED DOMAIN-CONTAINING PROTEIN', 251153),
(410821, 'PTHR22702:SF1', NULL, NULL, NULL, NULL, 'PROTEASE-ASSOCIATED DOMAIN-CONTAINING PROTEIN 1', 251153),
(410822, 'PTHR22702:SF2', NULL, NULL, NULL, NULL, '', 251153),
(410823, 'PTHR22702:SF3', NULL, NULL, NULL, NULL, 'PROTEASE-ASSOCIATED DOMAIN-CONTAINING PROTEIN 1', 251153),
(410824, 'PTHR37484:SF1', NULL, NULL, NULL, NULL, 'ROD SHAPE-DETERMINING PROTEIN MRED', 251154),
(410825, 'PTHR37484', NULL, NULL, NULL, NULL, 'ROD SHAPE-DETERMINING PROTEIN MRED', 251154),
(410826, 'PTHR22834', NULL, NULL, NULL, NULL, 'NUCLEAR FUSION PROTEIN FUS2', 251155),
(410827, 'PTHR22834:SF19', NULL, NULL, NULL, NULL, 'DYNAMIN-BINDING PROTEIN', 251155),
(410828, 'PTHR22834:SF17', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 38', 251155),
(410829, 'PTHR22834:SF9', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 37', 251155),
(410830, 'PTHR22834:SF20', NULL, NULL, NULL, NULL, 'NUCLEAR FUSION PROTEIN FUS2', 251155),
(410831, 'PTHR22834:SF21', NULL, NULL, NULL, NULL, 'GUANYL NUCLEOTIDE EXCHANGE FACTOR, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G11890)-RELATED', 251155),
(410832, 'PTHR14131', NULL, NULL, NULL, NULL, 'ANOSMIN', 251156),
(410833, 'PTHR14131:SF6', NULL, NULL, NULL, NULL, 'ANOSMIN 1A', 251156),
(410834, 'PTHR14131:SF5', NULL, NULL, NULL, NULL, 'ANOSMIN-1', 251156),
(410835, 'PTHR14131:SF8', NULL, NULL, NULL, NULL, 'ADHESION MOLECULE, PUTATIVE-RELATED', 251156),
(410836, 'PTHR14131:SF7', NULL, NULL, NULL, NULL, 'ANOSMIN 1B', 251156),
(410837, 'PTHR46191', NULL, NULL, NULL, NULL, '', 251157),
(410838, 'PTHR46191:SF2', NULL, NULL, NULL, NULL, 'HALOACID DEHALOGENASE-LIKE HYDROLASE DOMAIN-CONTAINING PROTEIN 3', 251157),
(410839, 'PTHR33346:SF44', NULL, NULL, NULL, NULL, 'DEHYDRIN RAB25', 251158),
(410840, 'PTHR33346:SF22', NULL, NULL, NULL, NULL, 'ABSCISIC ACID AND ENVIRONMENTAL STRESS-INDUCIBLE PROTEIN TAS14', 251158),
(410841, 'PTHR33346:SF45', NULL, NULL, NULL, NULL, 'DEHYDRIN FAMILY PROTEIN EXPRESSED', 251158),
(410842, 'PTHR33346:SF42', NULL, NULL, NULL, NULL, 'DEHYDRIN RAB18', 251158),
(410843, 'PTHR33346:SF20', NULL, NULL, NULL, NULL, '', 251158),
(410844, 'PTHR33346:SF41', NULL, NULL, NULL, NULL, 'BNAC02G45160D PROTEIN', 251158),
(410845, 'PTHR33346:SF48', NULL, NULL, NULL, NULL, 'PHOSPHOPROTEIN ECPP44-LIKE', 251158),
(410846, 'PTHR33346:SF2', NULL, NULL, NULL, NULL, 'DEHYDRIN ERD14', 251158);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(410847, 'PTHR33346:SF27', NULL, NULL, NULL, NULL, 'DEHYDRIN', 251158),
(410848, 'PTHR33346:SF49', NULL, NULL, NULL, NULL, '', 251158),
(410849, 'PTHR33346:SF5', NULL, NULL, NULL, NULL, 'DEHYDRIN LEA-RELATED', 251158),
(410850, 'PTHR33346:SF47', NULL, NULL, NULL, NULL, 'DEHYDRIN XERO 1', 251158),
(410851, 'PTHR33346', NULL, NULL, NULL, NULL, 'DEHYDRIN XERO 2-RELATED', 251158),
(410852, 'PTHR33346:SF33', NULL, NULL, NULL, NULL, 'DEHYDRIN RAB15', 251158),
(410853, 'PTHR33346:SF11', NULL, NULL, NULL, NULL, 'DEHYDRIN COR47-RELATED', 251158),
(410854, 'PTHR33346:SF34', NULL, NULL, NULL, NULL, 'BNAC07G15380D PROTEIN', 251158),
(410855, 'PTHR33346:SF31', NULL, NULL, NULL, NULL, 'DEHYDRIN COR47-LIKE', 251158),
(410856, 'PTHR33346:SF51', NULL, NULL, NULL, NULL, 'ABSCISIC ACID AND ENVIRONMENTAL STRESS-INDUCIBLE PROTEIN TAS14-LIKE', 251158),
(410857, 'PTHR33346:SF50', NULL, NULL, NULL, NULL, 'DEHYDRIN 7', 251158),
(410858, 'PTHR33346:SF39', NULL, NULL, NULL, NULL, '', 251158),
(410859, 'PTHR33346:SF15', NULL, NULL, NULL, NULL, 'BNACNNG20790D PROTEIN', 251158),
(410860, 'PTHR33346:SF37', NULL, NULL, NULL, NULL, 'WATER STRESS-INDUCIBLE PROTEIN RAB21', 251158),
(410861, 'PTHR33346:SF38', NULL, NULL, NULL, NULL, 'COLD-ACCLIMATION SPECIFIC PROTEIN 31', 251158),
(410862, 'PTHR33346:SF16', NULL, NULL, NULL, NULL, 'DEHYDRIN FAMILY PROTEIN', 251158),
(410863, 'PTHR33346:SF14', NULL, NULL, NULL, NULL, 'DEHYDRIN XERO 2', 251158),
(410864, 'PTHR36481:SF4', NULL, NULL, NULL, NULL, '', 251159),
(410865, 'PTHR36481:SF3', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251159),
(410866, 'PTHR36481:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251159),
(410867, 'PTHR36481:SF1', NULL, NULL, NULL, NULL, 'OS09G0535400 PROTEIN', 251159),
(410868, 'PTHR36481', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251159),
(410869, 'PTHR47320:SF1', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL URIDYLYLTRANSFERASE/URIDYLYL-REMOVING ENZYME', 251160),
(410870, 'PTHR47320', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL URIDYLYLTRANSFERASE/URIDYLYL-REMOVING ENZYME', 251160),
(410871, 'PTHR39966', NULL, NULL, NULL, NULL, 'BLL2471 PROTEIN-RELATED', 251161),
(410872, 'PTHR39966:SF3', NULL, NULL, NULL, NULL, 'HYPOTHETICAL CYTOSOLIC PROTEIN', 251161),
(410873, 'PTHR39966:SF1', NULL, NULL, NULL, NULL, 'HEMERYTHRIN DOMAIN-CONTAINING PROTEIN', 251161),
(410874, 'PTHR21275:SF1', NULL, NULL, NULL, NULL, 'RWD DOMAIN-CONTAINING PROTEIN 4', 251162),
(410875, 'PTHR21275', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 251162),
(410876, 'PTHR43436', NULL, NULL, NULL, NULL, 'ARAC-FAMILY TRANSCRIPTIONAL REGULATOR', 251163),
(410877, 'PTHR43436:SF2', NULL, NULL, NULL, NULL, 'ARAC/XYLS FAMILY TRANSCRIPTIONAL REGULATOR-RELATED', 251163),
(410878, 'PTHR43436:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 251163),
(410879, 'PTHR43847:SF1', NULL, NULL, NULL, NULL, 'BLL3993 PROTEIN', 251164),
(410880, 'PTHR43847', NULL, NULL, NULL, NULL, 'BLL3993 PROTEIN', 251164),
(410881, 'PTHR39068', NULL, NULL, NULL, NULL, 'LARVAL/PUPAL CUTICLE PROTEIN H1C-LIKE PROTEIN-RELATED', 251165),
(410882, 'PTHR39068:SF2', NULL, NULL, NULL, NULL, 'MIP24391P', 251165),
(410883, 'PTHR39068:SF5', NULL, NULL, NULL, NULL, 'PUPAL CUTICLE PROTEIN C1B-LIKE PROTEIN', 251165),
(410884, 'PTHR39068:SF4', NULL, NULL, NULL, NULL, 'AGAP000382-PA', 251165),
(410885, 'PTHR31986', NULL, NULL, NULL, NULL, 'REGULATOR OF DRUG SENSITIVITY 2', 251166),
(410886, 'PTHR31986:SF7', NULL, NULL, NULL, NULL, 'REGULATOR OF DRUG SENSITIVITY 2', 251166),
(410887, 'PTHR28153', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 251167),
(410888, 'PTHR28153:SF1', NULL, NULL, NULL, NULL, 'DUF4484 DOMAIN-CONTAINING PROTEIN', 251167),
(410889, 'PTHR16165:SF28', NULL, NULL, NULL, NULL, '', 251168),
(410890, 'PTHR16165:SF9', NULL, NULL, NULL, NULL, 'NXPE FAMILY MEMBER 3', 251168),
(410891, 'PTHR16165', NULL, NULL, NULL, NULL, 'NXPE FAMILY MEMBER', 251168),
(410892, 'PTHR16165:SF27', NULL, NULL, NULL, NULL, 'NXPE FAMILY MEMBER 4', 251168),
(410893, 'PTHR16165:SF23', NULL, NULL, NULL, NULL, 'NEUREXOPHILIN AND PC-ESTERASE DOMAIN FAMILY, MEMBER 5', 251168);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(410894, 'PTHR16165:SF3', NULL, NULL, NULL, NULL, 'NXPE FAMILY MEMBER 1', 251168),
(410895, 'PTHR16165:SF10', NULL, NULL, NULL, NULL, 'NXPE FAMILY MEMBER 2', 251168),
(410896, 'PTHR16165:SF5', NULL, NULL, NULL, NULL, 'F5/8 TYPE C DOMAIN-CONTAINING PROTEIN', 251168),
(410897, 'PTHR47024:SF1', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 251169),
(410898, 'PTHR47024:SF3', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 251169),
(410899, 'PTHR47024:SF2', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', 251169),
(410900, 'PTHR47024', NULL, NULL, NULL, NULL, 'BIOFILM ABSENT ON HEAD (AFTER YERSINIA EXPOSURE)-RELATED', 251169),
(410901, 'PTHR12787', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 251170),
(410902, 'PTHR12787:SF0', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA-PROCESSING PROTEIN 8', 251170),
(410903, 'PTHR40628:SF1', NULL, NULL, NULL, NULL, '', 251171),
(410904, 'PTHR40628', NULL, NULL, NULL, NULL, '', 251171),
(410905, 'PTHR23403:SF12', NULL, NULL, NULL, NULL, 'TREHALASE', 251172),
(410906, 'PTHR23403:SF24', NULL, NULL, NULL, NULL, 'TREHALASE', 251172),
(410907, 'PTHR23403', NULL, NULL, NULL, NULL, 'TREHALASE', 251172),
(410908, 'PTHR23403:SF6', NULL, NULL, NULL, NULL, 'CYTOSOLIC NEUTRAL TREHALASE-RELATED', 251172),
(410909, 'PTHR23403:SF5', NULL, NULL, NULL, NULL, 'TREHALASE', 251172),
(410910, 'PTHR23403:SF8', NULL, NULL, NULL, NULL, 'CYTOPLASMIC TREHALASE', 251172),
(410911, 'PTHR23403:SF1', NULL, NULL, NULL, NULL, 'TREHALASE', 251172),
(410912, 'PTHR23403:SF3', NULL, NULL, NULL, NULL, 'TREHALASE', 251172),
(410913, 'PTHR23403:SF25', NULL, NULL, NULL, NULL, 'TREHALASE', 251172),
(410914, 'PTHR42673:SF1', NULL, NULL, NULL, NULL, 'MALEYLACETOACETATE ISOMERASE', 251173),
(410915, 'PTHR42673', NULL, NULL, NULL, NULL, 'MALEYLACETOACETATE ISOMERASE', 251173),
(410916, 'PTHR42673:SF21', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE YFCF', 251173),
(410917, 'PTHR42673:SF5', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE', 251173),
(410918, 'PTHR42673:SF20', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 251173),
(410919, 'PTHR42673:SF4', NULL, NULL, NULL, NULL, 'MALEYLACETOACETATE ISOMERASE', 251173),
(410920, 'PTHR42673:SF13', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 251173),
(410921, 'PTHR42673:SF12', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE-RELATED', 251173),
(410922, 'PTHR42673:SF19', NULL, NULL, NULL, NULL, '', 251173),
(410923, 'PTHR42673:SF18', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE', 251173),
(410924, 'PTHR42673:SF17', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 251173),
(410925, 'PTHR42673:SF16', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 251173),
(410926, 'PTHR42673:SF9', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 251173),
(410927, 'PTHR42673:SF7', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE', 251173),
(410928, 'PTHR33780:SF17', NULL, NULL, NULL, NULL, '', 251174),
(410929, 'PTHR33780:SF18', NULL, NULL, NULL, NULL, '', 251174),
(410930, 'PTHR33780:SF15', NULL, NULL, NULL, NULL, 'BNAA07G37710D PROTEIN', 251174),
(410931, 'PTHR33780:SF16', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 251174),
(410932, 'PTHR33780:SF11', NULL, NULL, NULL, NULL, 'VALINE-TRNA LIGASE', 251174),
(410933, 'PTHR33780', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251174),
(410934, 'PTHR33780:SF10', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 251174),
(410935, 'PTHR33780:SF2', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 251174),
(410936, 'PTHR33780:SF3', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251174),
(410937, 'PTHR31840', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 97', 251175),
(410938, 'PTHR31840:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 97', 251175),
(410939, 'PTHR40266:SF2', NULL, NULL, NULL, NULL, 'TOXIN HIGB-1', 251176),
(410940, 'PTHR40266', NULL, NULL, NULL, NULL, 'TOXIN HIGB-1', 251176),
(410941, 'PTHR46069', NULL, NULL, NULL, NULL, 'TUBULIN TYROSINE LIGASE', 251177),
(410942, 'PTHR46069:SF1', NULL, NULL, NULL, NULL, 'LIGASE, PUTATIVE-RELATED', 251177);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(410943, 'PTHR15139:SF0', NULL, NULL, NULL, NULL, 'TUBULIN-SPECIFIC CHAPERONE C', 251178),
(410944, 'PTHR15139', NULL, NULL, NULL, NULL, 'TUBULIN FOLDING COFACTOR C', 251178),
(410945, 'PTHR35269:SF1', NULL, NULL, NULL, NULL, 'SMALL VCP/P97-INTERACTING PROTEIN', 251179),
(410946, 'PTHR35269', NULL, NULL, NULL, NULL, 'SMALL VCP/P97-INTERACTING PROTEIN', 251179),
(410947, 'PTHR43102:SF2', NULL, NULL, NULL, NULL, 'GAF DOMAIN-CONTAINING PROTEIN', 251180),
(410948, 'PTHR43102', NULL, NULL, NULL, NULL, 'SLR1143 PROTEIN', 251180),
(410949, 'PTHR11485:SF49', NULL, NULL, NULL, NULL, 'OTOLITH MATRIX PROTEIN 1', 251181),
(410950, 'PTHR11485:SF48', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE RECEPTOR SUBUNIT BETA', 251181),
(410951, 'PTHR11485:SF57', NULL, NULL, NULL, NULL, 'TRANSFERRIN', 251181),
(410952, 'PTHR11485:SF34', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE RECEPTOR SUBUNIT BETA', 251181),
(410953, 'PTHR11485:SF56', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE RECEPTOR SUBUNIT BETA', 251181),
(410954, 'PTHR11485:SF55', NULL, NULL, NULL, NULL, 'LACTOTRANSFERRIN', 251181),
(410955, 'PTHR11485:SF21', NULL, NULL, NULL, NULL, 'MELANOTRANSFERRIN', 251181),
(410956, 'PTHR11485:SF54', NULL, NULL, NULL, NULL, 'TRANSFERRIN', 251181),
(410957, 'PTHR11485:SF20', NULL, NULL, NULL, NULL, 'INHIBITOR OF CARBONIC ANHYDRASE', 251181),
(410958, 'PTHR11485:SF31', NULL, NULL, NULL, NULL, 'SEROTRANSFERRIN', 251181),
(410959, 'PTHR11485:SF50', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE RECEPTOR SUBUNIT BETA', 251181),
(410960, 'PTHR11485', NULL, NULL, NULL, NULL, 'TRANSFERRIN', 251181),
(410961, 'PTHR11485:SF29', NULL, NULL, NULL, NULL, 'LD22449P', 251181),
(410962, 'PTHR11485:SF28', NULL, NULL, NULL, NULL, 'OVOTRANSFERRIN', 251181),
(410963, 'PTHR22898:SF14', NULL, NULL, NULL, NULL, 'PROTEIN CBG04865', 251182),
(410964, 'PTHR22898:SF3', NULL, NULL, NULL, NULL, 'GALACTOSIDE 2-ALPHA-L-FUCOSYLTRANSFERASE SVH-11-RELATED', 251182),
(410965, 'PTHR22898:SF2', NULL, NULL, NULL, NULL, 'GALACTOSIDE 2-ALPHA-L-FUCOSYLTRANSFERASE', 251182),
(410966, 'PTHR22898', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED GLYCOSOL TRANSFERASE-RELATED', 251182),
(410967, 'PTHR22898:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG15832', 251182),
(410968, 'PTHR22898:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG02648', 251182),
(410969, 'PTHR22898:SF4', NULL, NULL, NULL, NULL, 'GALACTOSIDE 2-ALPHA-L-FUCOSYLTRANSFERASE', 251182),
(410970, 'PTHR43726:SF1', NULL, NULL, NULL, NULL, '[FEFE] HYDROGENASE MATURASE SUBUNIT HYDE', 251183),
(410971, 'PTHR43726', NULL, NULL, NULL, NULL, '3-METHYLORNITHINE SYNTHASE', 251183),
(410972, 'PTHR43613:SF1', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, ATP-BINDING PROTEIN', 251184),
(410973, 'PTHR43613', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, ATP-BINDING PROTEIN', 251184),
(410974, 'PTHR37535:SF4', NULL, NULL, NULL, NULL, 'FLUG DOMAIN PROTEIN', 251185),
(410975, 'PTHR37535:SF3', NULL, NULL, NULL, NULL, '', 251185),
(410976, 'PTHR37535:SF2', NULL, NULL, NULL, NULL, 'FINGER DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G09300)-RELATED', 251185),
(410977, 'PTHR37535', NULL, NULL, NULL, NULL, 'FLUG DOMAIN PROTEIN', 251185),
(410978, 'PTHR31592:SF5', NULL, NULL, NULL, NULL, '', 251186),
(410979, 'PTHR31592:SF4', NULL, NULL, NULL, NULL, 'TMEM192 FAMILY PROTEIN', 251186),
(410980, 'PTHR31592', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 192', 251186),
(410981, 'PTHR31592:SF2', NULL, NULL, NULL, NULL, '', 251186),
(410982, 'PTHR31592:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 192', 251186),
(410983, 'PTHR34710:SF19', NULL, NULL, NULL, NULL, 'OS04G0576700 PROTEIN', 251187),
(410984, 'PTHR34710:SF18', NULL, NULL, NULL, NULL, 'OS05G0522700 PROTEIN', 251187),
(410985, 'PTHR34710:SF17', NULL, NULL, NULL, NULL, '', 251187),
(410986, 'PTHR34710:SF16', NULL, NULL, NULL, NULL, '', 251187),
(410987, 'PTHR34710:SF15', NULL, NULL, NULL, NULL, 'OS03G0834100 PROTEIN', 251187),
(410988, 'PTHR34710:SF13', NULL, NULL, NULL, NULL, '', 251187),
(410989, 'PTHR34710:SF12', NULL, NULL, NULL, NULL, '', 251187);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(410990, 'PTHR34710:SF6', NULL, NULL, NULL, NULL, 'OS05G0545900 PROTEIN', 251187),
(410991, 'PTHR34710:SF8', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 251187),
(410992, 'PTHR34710:SF10', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251187),
(410993, 'PTHR34710:SF20', NULL, NULL, NULL, NULL, 'OS01G0534200 PROTEIN', 251187),
(410994, 'PTHR34710', NULL, NULL, NULL, NULL, 'OS03G0834100 PROTEIN', 251187),
(410995, 'PTHR43678', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_2G00640)-RELATED', 251188),
(410996, 'PTHR43678:SF1', NULL, NULL, NULL, NULL, 'BETA-N-ACETYLHEXOSAMINIDASE', 251188),
(410997, 'PTHR35585:SF1', NULL, NULL, NULL, NULL, 'HHE DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_4G00730)', 251189),
(410998, 'PTHR35585', NULL, NULL, NULL, NULL, 'HHE DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_4G00730)', 251189),
(410999, 'PTHR35585:SF3', NULL, NULL, NULL, NULL, 'HEMERYTHRIN DOMAIN-CONTAINING PROTEIN', 251189),
(411000, 'PTHR31600', NULL, NULL, NULL, NULL, 'TINY MACROCYSTS PROTEIN B-RELATED', 251190),
(411001, 'PTHR31600:SF2', NULL, NULL, NULL, NULL, 'TINY MACROCYSTS PROTEIN B-RELATED', 251190),
(411002, 'PTHR28060', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT J, MITOCHONDRIAL', 251191),
(411003, 'PTHR28060:SF1', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT J, MITOCHONDRIAL', 251191),
(411004, 'PTHR33906:SF1', NULL, NULL, NULL, NULL, 'INTRAFLAGELLAR TRANSPORT PROTEIN 25 HOMOLOG', 251192),
(411005, 'PTHR33906', NULL, NULL, NULL, NULL, 'INTRAFLAGELLAR TRANSPORT PROTEIN 25 HOMOLOG', 251192),
(411006, 'PTHR36020:SF2', NULL, NULL, NULL, NULL, 'BNAC04G02800D PROTEIN', 251193),
(411007, 'PTHR36020:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 251193),
(411008, 'PTHR36020', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 251193),
(411009, 'PTHR24235:SF20', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE Y RECEPTOR TYPE 2', 251194),
(411010, 'PTHR24235:SF30', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE F RECEPTOR', 251194),
(411011, 'PTHR24235:SF9', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251194),
(411012, 'PTHR24235:SF15', NULL, NULL, NULL, NULL, 'PROLACTIN-RELEASING PEPTIDE RECEPTOR-LIKE PROTEIN 4', 251194),
(411013, 'PTHR24235', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE Y RECEPTOR', 251194),
(411014, 'PTHR24235:SF25', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE Y RECEPTOR TYPE 4-RELATED', 251194),
(411015, 'PTHR24235:SF14', NULL, NULL, NULL, NULL, 'PROLACTIN-RELEASING PEPTIDE RECEPTOR-LIKE PROTEIN', 251194),
(411016, 'PTHR24235:SF17', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE Y /PEPTIDE YY RECEPTOR YB-RELATED', 251194),
(411017, 'PTHR24235:SF27', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251194),
(411018, 'PTHR24235:SF16', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE Y RECEPTOR TYPE 6-RELATED', 251194),
(411019, 'PTHR24235:SF22', NULL, NULL, NULL, NULL, 'NPY-Y2 RECEPTOR', 251194),
(411020, 'PTHR24235:SF11', NULL, NULL, NULL, NULL, 'PROLACTIN-RELEASING PEPTIDE RECEPTOR', 251194),
(411021, 'PTHR24235:SF10', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE Y RECEPTOR TYPE 5', 251194),
(411022, 'PTHR24235:SF21', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251194),
(411023, 'PTHR24235:SF24', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE Y RECEPTOR TYPE 1', 251194),
(411024, 'PTHR24235:SF13', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251194),
(411025, 'PTHR24235:SF12', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251194),
(411026, 'PTHR24235:SF23', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251194),
(411027, 'PTHR24235:SF19', NULL, NULL, NULL, NULL, 'PROLACTIN RELEASING PEPTIDE RECEPTOR-LIKE PROTEIN', 251194),
(411028, 'PTHR24235:SF29', NULL, NULL, NULL, NULL, 'GH23382P', 251194),
(411029, 'PTHR24235:SF18', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251194),
(411030, 'PTHR24235:SF1', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251194),
(411031, 'PTHR24235:SF2', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251194);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(411032, 'PTHR24235:SF3', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR NPR-8-RELATED', 251194),
(411033, 'PTHR13948:SF37', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 251195),
(411034, 'PTHR13948:SF38', NULL, NULL, NULL, NULL, 'D111/G-PATCH DOMAIN-CONTAINING PROTEIN', 251195),
(411035, 'PTHR13948', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN', 251195),
(411036, 'PTHR13948:SF22', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 6', 251195),
(411037, 'PTHR13948:SF3', NULL, NULL, NULL, NULL, 'FI21118P1', 251195),
(411038, 'PTHR13948:SF21', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 5', 251195),
(411039, 'PTHR13948:SF4', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 10', 251195),
(411040, 'PTHR23188:SF12', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II-ASSOCIATED FACTOR 1 HOMOLOG', 251196),
(411041, 'PTHR23188:SF15', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II ASSOCIATED FACTOR PAF1-RELATED', 251196),
(411042, 'PTHR23188', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II-ASSOCIATED FACTOR 1 HOMOLOG', 251196),
(411043, 'PTHR34786:SF1', NULL, NULL, NULL, NULL, 'OS09G0504900 PROTEIN', 251197),
(411044, 'PTHR34786:SF2', NULL, NULL, NULL, NULL, 'BNAA05G15570D PROTEIN', 251197),
(411045, 'PTHR34786', NULL, NULL, NULL, NULL, 'OS09G0504900 PROTEIN', 251197),
(411046, 'PTHR35789', NULL, NULL, NULL, NULL, 'SPORE GERMINATION PROTEIN B3', 251198),
(411047, 'PTHR35789:SF1', NULL, NULL, NULL, NULL, 'SPORE GERMINATION PROTEIN B3', 251198),
(411048, 'PTHR35812', NULL, NULL, NULL, NULL, 'LIPOPROTEIN', 251199),
(411049, 'PTHR35812:SF1', NULL, NULL, NULL, NULL, 'LIPOPROTEIN', 251199),
(411050, 'PTHR34857', NULL, NULL, NULL, NULL, 'SLL0384 PROTEIN', 251200),
(411051, 'PTHR34857:SF2', NULL, NULL, NULL, NULL, 'SLL0384 PROTEIN', 251200),
(411052, 'PTHR34857:SF4', NULL, NULL, NULL, NULL, 'COBALT TRANSPORT PROTEIN', 251200),
(411053, 'PTHR11929:SF240', NULL, NULL, NULL, NULL, 'PROTEIN CBG13289', 251201),
(411054, 'PTHR11929:SF145', NULL, NULL, NULL, NULL, 'ALPHA 1,3 FUCOSYLTRANSFERASE-RELATED', 251201),
(411055, 'PTHR11929:SF241', NULL, NULL, NULL, NULL, 'ALPHA-(1,3)-FUCOSYLTRANSFERASE FUT-3', 251201),
(411056, 'PTHR11929:SF165', NULL, NULL, NULL, NULL, '3-GALACTOSYL-N-ACETYLGLUCOSAMINIDE 4-ALPHA-L-FUCOSYLTRANSFERASE FUT3', 251201),
(411057, 'PTHR11929:SF220', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE-LIKE PROTEIN-RELATED', 251201),
(411058, 'PTHR11929:SF226', NULL, NULL, NULL, NULL, 'PHA-1 PROTEIN', 251201),
(411059, 'PTHR11929:SF227', NULL, NULL, NULL, NULL, '4-GALACTOSYL-N-ACETYLGLUCOSAMINIDE 3-ALPHA-L-FUCOSYLTRANSFERASE FUT6', 251201),
(411060, 'PTHR11929:SF194', NULL, NULL, NULL, NULL, 'ALPHA-(1,3)-FUCOSYLTRANSFERASE 10', 251201),
(411061, 'PTHR11929:SF232', NULL, NULL, NULL, NULL, 'ALPHA-(1,3)-FUCOSYLTRANSFERASE FUT-1', 251201),
(411062, 'PTHR11929:SF233', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 251201),
(411063, 'PTHR11929:SF198', NULL, NULL, NULL, NULL, 'ALPHA-(1,3)-FUCOSYLTRANSFERASE 11', 251201),
(411064, 'PTHR11929:SF132', NULL, NULL, NULL, NULL, 'ALPHA-(1,3)-FUCOSYLTRANSFERASE 4', 251201),
(411065, 'PTHR11929:SF231', NULL, NULL, NULL, NULL, '', 251201),
(411066, 'PTHR11929:SF236', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE FAMILY 10-RELATED', 251201),
(411067, 'PTHR11929:SF237', NULL, NULL, NULL, NULL, '', 251201),
(411068, 'PTHR11929:SF234', NULL, NULL, NULL, NULL, 'WD REPEAT DOMAIN 77', 251201),
(411069, 'PTHR11929:SF213', NULL, NULL, NULL, NULL, 'BNAC06G02690D PROTEIN', 251201),
(411070, 'PTHR11929:SF235', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN 3-ALPHA-L-FUCOSYLTRANSFERASE A', 251201),
(411071, 'PTHR11929:SF218', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN 3-ALPHA-L-FUCOSYLTRANSFERASE A', 251201),
(411072, 'PTHR11929:SF238', NULL, NULL, NULL, NULL, 'ALPHA-(1,3)-FUCOSYLTRANSFERASE FUT-6', 251201),
(411073, 'PTHR11929', NULL, NULL, NULL, NULL, 'ALPHA- 1,3 -FUCOSYLTRANSFERASE', 251201),
(411074, 'PTHR11929:SF239', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN 3-ALPHA-L-FUCOSYLTRANSFERASE A-LIKE PROTEIN', 251201),
(411075, 'PTHR11929:SF11', NULL, NULL, NULL, NULL, '4-GALACTOSYL-N-ACETYLGLUCOSAMINIDE 3-ALPHA-L-FUCOSYLTRANSFERASE FUT5', 251201);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(411076, 'PTHR11929:SF10', NULL, NULL, NULL, NULL, '4-GALACTOSYL-N-ACETYLGLUCOSAMINIDE 3-ALPHA-L-FUCOSYLTRANSFERASE 9', 251201),
(411077, 'PTHR11929:SF12', NULL, NULL, NULL, NULL, 'ALPHA-(1,3)-FUCOSYLTRANSFERASE 7', 251201),
(411078, 'PTHR47306', NULL, NULL, NULL, NULL, 'SI:CH211-178J18.4-RELATED', 251202),
(411079, 'PTHR47306:SF1', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN-RELATED', 251202),
(411080, 'PTHR42764:SF2', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, ATP-BINDING PROTEIN', 251203),
(411081, 'PTHR42764:SF1', NULL, NULL, NULL, NULL, 'PHOSPHONATES UTILIZATION ATP-BINDING PROTEIN PHNK-RELATED', 251203),
(411082, 'PTHR42764', NULL, NULL, NULL, NULL, 'PHOSPHONATES UTILIZATION ATP-BINDING PROTEIN PHNK-RELATED', 251203),
(411083, 'PTHR10088:SF5', NULL, NULL, NULL, NULL, 'N-ACETYLMURAMIC ACID 6-PHOSPHATE ETHERASE', 251204),
(411084, 'PTHR10088:SF4', NULL, NULL, NULL, NULL, 'GLUCOKINASE REGULATORY PROTEIN', 251204),
(411085, 'PTHR10088', NULL, NULL, NULL, NULL, 'GLUCOKINASE REGULATORY PROTEIN', 251204),
(411086, 'PTHR47556:SF1', NULL, NULL, NULL, NULL, 'SEC14P-LIKE PHOSPHATIDYLINOSITOL TRANSFER FAMILY PROTEIN', 251205),
(411087, 'PTHR47556', NULL, NULL, NULL, NULL, 'SEC14P-LIKE PHOSPHATIDYLINOSITOL TRANSFER FAMILY PROTEIN', 251205),
(411088, 'PTHR46886:SF1', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR II', 251206),
(411089, 'PTHR46886', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR II', 251206),
(411090, 'PTHR42928', NULL, NULL, NULL, NULL, 'TRICARBOXYLATE-BINDING PROTEIN', 251207),
(411091, 'PTHR42928:SF3', NULL, NULL, NULL, NULL, 'TRICARBOXYLIC TRANSPORT PROTEIN', 251207),
(411092, 'PTHR42928:SF5', NULL, NULL, NULL, NULL, 'UPF0065 PROTEIN YFLP', 251207),
(411093, 'PTHR42928:SF1', NULL, NULL, NULL, NULL, 'BLR4371 PROTEIN', 251207),
(411094, 'PTHR31733', NULL, NULL, NULL, NULL, 'RIBONUCLEASE KAPPA', 251208),
(411095, 'PTHR31733:SF1', NULL, NULL, NULL, NULL, 'RIBONUCLEASE KAPPA', 251208),
(411096, 'PTHR31733:SF3', NULL, NULL, NULL, NULL, '', 251208),
(411097, 'PTHR31733:SF10', NULL, NULL, NULL, NULL, 'RIBONUCLEASE KAPPA-B', 251208),
(411098, 'PTHR31733:SF12', NULL, NULL, NULL, NULL, 'PQN-22', 251208),
(411099, 'PTHR31733:SF11', NULL, NULL, NULL, NULL, 'RIBONUCLEASE KAPPA-A', 251208),
(411100, 'PTHR24133:SF48', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX-CONTAINING 3', 251209),
(411101, 'PTHR24133:SF38', NULL, NULL, NULL, NULL, 'ANKYRIN-1', 251209),
(411102, 'PTHR24133:SF16', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 9', 251209),
(411103, 'PTHR24133', NULL, NULL, NULL, NULL, 'ANKYRIN DOMAIN-CONTAINING', 251209),
(411104, 'PTHR24133:SF42', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 251209),
(411105, 'PTHR24133:SF53', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX CONTAINING 16', 251209),
(411106, 'PTHR24133:SF54', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT PROTEIN-RELATED', 251209),
(411107, 'PTHR24133:SF51', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX-CONTAINING 4', 251209),
(411108, 'PTHR24133:SF40', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN-RELATED', 251209),
(411109, 'PTHR24133:SF52', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 251209),
(411110, 'PTHR24133:SF36', NULL, NULL, NULL, NULL, 'ANKYRIN-2', 251209),
(411111, 'PTHR24133:SF14', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 251209),
(411112, 'PTHR24133:SF33', NULL, NULL, NULL, NULL, 'ANKYRIN, ISOFORM B', 251209),
(411113, 'PTHR24133:SF34', NULL, NULL, NULL, NULL, 'ANKYRIN-3', 251209),
(411114, 'PTHR33144:SF28', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RESISTANCE PROTEIN', 251210),
(411115, 'PTHR33144:SF39', NULL, NULL, NULL, NULL, 'UBIQUITIN', 251210),
(411116, 'PTHR33144:SF33', NULL, NULL, NULL, NULL, 'OS04G0125975 PROTEIN', 251210),
(411117, 'PTHR33144:SF44', NULL, NULL, NULL, NULL, '', 251210),
(411118, 'PTHR33144:SF45', NULL, NULL, NULL, NULL, 'OS03G0714750 PROTEIN', 251210),
(411119, 'PTHR33144:SF34', NULL, NULL, NULL, NULL, 'TRANSPOSASE, PTTA/EN/SPM, PLANT-RELATED', 251210);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(411120, 'PTHR33144:SF42', NULL, NULL, NULL, NULL, 'OS07G0464050 PROTEIN', 251210),
(411121, 'PTHR33144:SF32', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE TY1/COPIA-TYPE DOMAIN-CONTAINING PROTEIN', 251210),
(411122, 'PTHR33144:SF10', NULL, NULL, NULL, NULL, 'OS04G0609900 PROTEIN', 251210),
(411123, 'PTHR33144:SF43', NULL, NULL, NULL, NULL, '', 251210),
(411124, 'PTHR33144:SF37', NULL, NULL, NULL, NULL, '', 251210),
(411125, 'PTHR33144:SF16', NULL, NULL, NULL, NULL, 'PLANT TRANSPOSASE (PTTA/EN/SPM FAMILY)', 251210),
(411126, 'PTHR33144:SF38', NULL, NULL, NULL, NULL, '', 251210),
(411127, 'PTHR33144:SF8', NULL, NULL, NULL, NULL, 'OS02G0129000 PROTEIN', 251210),
(411128, 'PTHR33144:SF35', NULL, NULL, NULL, NULL, 'DUF4218 DOMAIN-CONTAINING PROTEIN', 251210),
(411129, 'PTHR33144:SF36', NULL, NULL, NULL, NULL, 'TRANSPOSASE, PTTA/EN/SPM, PLANT, TRANSPOSASE, TNP1/EN/SPM-LIKE PROTEIN-RELATED', 251210),
(411130, 'PTHR33144:SF25', NULL, NULL, NULL, NULL, 'DUF4218 DOMAIN-CONTAINING PROTEIN', 251210),
(411131, 'PTHR33144', NULL, NULL, NULL, NULL, 'OS10G0409366 PROTEIN-RELATED', 251210),
(411132, 'PTHR33144:SF40', NULL, NULL, NULL, NULL, 'TRANSPOS_ASSOC DOMAIN-CONTAINING PROTEIN', 251210),
(411133, 'PTHR33144:SF41', NULL, NULL, NULL, NULL, 'TRANSPOSASE_23 DOMAIN-CONTAINING PROTEIN', 251210),
(411134, 'PTHR35982:SF1', NULL, NULL, NULL, NULL, 'ARF-GAP DOMAIN-CONTAINING PROTEIN', 251211),
(411135, 'PTHR35982', NULL, NULL, NULL, NULL, 'AGAP005361-PA', 251211),
(411136, 'PTHR46017:SF1', NULL, NULL, NULL, NULL, 'ALPHA-MANNOSIDASE 2C1', 251212),
(411137, 'PTHR46017:SF2', NULL, NULL, NULL, NULL, 'MANNOSYLGLYCERATE HYDROLASE', 251212),
(411138, 'PTHR46017', NULL, NULL, NULL, NULL, 'ALPHA-MANNOSIDASE 2C1', 251212),
(411139, 'PTHR36162:SF18', NULL, NULL, NULL, NULL, '', 251213),
(411140, 'PTHR36162', NULL, NULL, NULL, NULL, '', 251213),
(411141, 'PTHR36162:SF12', NULL, NULL, NULL, NULL, '', 251213),
(411142, 'PTHR36162:SF13', NULL, NULL, NULL, NULL, '', 251213),
(411143, 'PTHR36162:SF16', NULL, NULL, NULL, NULL, '', 251213),
(411144, 'PTHR36162:SF17', NULL, NULL, NULL, NULL, '', 251213),
(411145, 'PTHR45633', NULL, NULL, NULL, NULL, '60 KDA HEAT SHOCK PROTEIN, MITOCHONDRIAL', 251214),
(411146, 'PTHR45633:SF23', NULL, NULL, NULL, NULL, 'CHAPERONIN 60 SUBUNIT BETA 3, CHLOROPLASTIC', 251214),
(411147, 'PTHR45633:SF45', NULL, NULL, NULL, NULL, 'BNAA03G48200D PROTEIN', 251214),
(411148, 'PTHR45633:SF21', NULL, NULL, NULL, NULL, '60 KDA CHAPERONIN BETA SUBUNIT', 251214),
(411149, 'PTHR45633:SF20', NULL, NULL, NULL, NULL, 'CHAPERONIN 60 SUBUNIT BETA 1, CHLOROPLASTIC', 251214),
(411150, 'PTHR45633:SF42', NULL, NULL, NULL, NULL, 'BNAA05G25830D PROTEIN', 251214),
(411151, 'PTHR45633:SF41', NULL, NULL, NULL, NULL, '60 KDA CHAPERONIN 2', 251214),
(411152, 'PTHR45633:SF40', NULL, NULL, NULL, NULL, 'CHAPERONIN CPN60-2, MITOCHONDRIAL-LIKE', 251214),
(411153, 'PTHR45633:SF29', NULL, NULL, NULL, NULL, 'CHAPERONIN CPN60-2, MITOCHONDRIAL-LIKE', 251214),
(411154, 'PTHR45633:SF28', NULL, NULL, NULL, NULL, '', 251214),
(411155, 'PTHR45633:SF27', NULL, NULL, NULL, NULL, 'CHAPERONIN CPN60-2, MITOCHONDRIAL-LIKE ISOFORM X1', 251214),
(411156, 'PTHR45633:SF48', NULL, NULL, NULL, NULL, 'BNAA04G16190D PROTEIN', 251214),
(411157, 'PTHR45633:SF25', NULL, NULL, NULL, NULL, 'OS06G0114000 PROTEIN', 251214),
(411158, 'PTHR45633:SF47', NULL, NULL, NULL, NULL, 'CH60, PUTATIVE-RELATED', 251214),
(411159, 'PTHR45633:SF24', NULL, NULL, NULL, NULL, '', 251214),
(411160, 'PTHR45633:SF46', NULL, NULL, NULL, NULL, 'RUBISCO LARGE SUBUNIT-BINDING PROTEIN SUBUNIT ALPHA PROTEIN-RELATED', 251214),
(411161, 'PTHR45633:SF8', NULL, NULL, NULL, NULL, 'CHAPERONIN 60 SUBUNIT BETA 2, CHLOROPLASTIC', 251214),
(411162, 'PTHR45633:SF7', NULL, NULL, NULL, NULL, 'CHAPERONIN 60 SUBUNIT BETA 4, CHLOROPLASTIC', 251214),
(411163, 'PTHR45633:SF12', NULL, NULL, NULL, NULL, 'HSP60, MITOCHONDRIAL, PUTATIVE-RELATED', 251214),
(411164, 'PTHR45633:SF34', NULL, NULL, NULL, NULL, 'CHAPERONIN CPN60/TCP-1 FAMILY-RELATED', 251214),
(411165, 'PTHR45633:SF33', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CHAPERONE TCM62', 251214);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(411166, 'PTHR45633:SF10', NULL, NULL, NULL, NULL, 'HSP60, MITOCHONDRIAL, PUTATIVE-RELATED', 251214),
(411167, 'PTHR45633:SF32', NULL, NULL, NULL, NULL, 'CHAPERONIN CPN60-LIKE 1, MITOCHONDRIAL', 251214),
(411168, 'PTHR45633:SF31', NULL, NULL, NULL, NULL, 'RUBISCO LARGE SUBUNIT-BINDING PROTEIN SUBUNIT ALPHA-LIKE', 251214),
(411169, 'PTHR45633:SF30', NULL, NULL, NULL, NULL, 'CHAPERONIN', 251214),
(411170, 'PTHR45633:SF3', NULL, NULL, NULL, NULL, '60 KDA HEAT SHOCK PROTEIN, MITOCHONDRIAL', 251214),
(411171, 'PTHR45633:SF19', NULL, NULL, NULL, NULL, '60 KDA CHAPERONIN', 251214),
(411172, 'PTHR45633:SF18', NULL, NULL, NULL, NULL, 'CHAPERONIN 60 SUBUNIT ALPHA 1, CHLOROPLASTIC', 251214),
(411173, 'PTHR45633:SF17', NULL, NULL, NULL, NULL, '60 KDA HEAT SHOCK PROTEIN, MITOCHONDRIAL', 251214),
(411174, 'PTHR45633:SF38', NULL, NULL, NULL, NULL, 'BNACNNG52030D PROTEIN', 251214),
(411175, 'PTHR45633:SF16', NULL, NULL, NULL, NULL, 'CHAPERONIN CPN60-LIKE 2, MITOCHONDRIAL', 251214),
(411176, 'PTHR45633:SF37', NULL, NULL, NULL, NULL, 'BNAC06G41650D PROTEIN', 251214),
(411177, 'PTHR45633:SF15', NULL, NULL, NULL, NULL, '60 KDA CHAPERONIN ALPHA SUBUNIT', 251214),
(411178, 'PTHR45633:SF14', NULL, NULL, NULL, NULL, '60 KDA CHAPERONIN', 251214),
(411179, 'PTHR45633:SF13', NULL, NULL, NULL, NULL, 'CHAPERONIN 60 SUBUNIT ALPHA 2, CHLOROPLASTIC', 251214),
(411180, 'PTHR10462:SF29', NULL, NULL, NULL, NULL, 'HISTO-BLOOD GROUP ABO SYSTEM TRANSFERASE', 251215),
(411181, 'PTHR10462:SF50', NULL, NULL, NULL, NULL, 'HISTO-BLOOD GROUP ABO SYSTEM TRANSFERASE-RELATED', 251215),
(411182, 'PTHR10462:SF51', NULL, NULL, NULL, NULL, 'GLOBOSIDE ALPHA-1,3-N-ACETYLGALACTOSAMINYLTRANSFERASE 1-LIKE', 251215),
(411183, 'PTHR10462:SF33', NULL, NULL, NULL, NULL, 'ALPHA-1,3-GALACTOSYLTRANSFERASE 2', 251215),
(411184, 'PTHR10462:SF23', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4930402F06 GENE', 251215),
(411185, 'PTHR10462:SF46', NULL, NULL, NULL, NULL, 'N-ACETYLLACTOSAMINIDE ALPHA-1,3-GALACTOSYLTRANSFERASE-LIKE 1', 251215),
(411186, 'PTHR10462:SF47', NULL, NULL, NULL, NULL, '', 251215),
(411187, 'PTHR10462:SF26', NULL, NULL, NULL, NULL, 'N-ACETYLLACTOSAMINIDE ALPHA-1,3-GALACTOSYLTRANSFERASE', 251215),
(411188, 'PTHR10462:SF27', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE 6 DOMAIN-CONTAINING PROTEIN 1-RELATED', 251215),
(411189, 'PTHR10462:SF49', NULL, NULL, NULL, NULL, 'GLOBOSIDE ALPHA-1,3-N-ACETYLGALACTOSAMINYLTRANSFERASE 1', 251215),
(411190, 'PTHR10462', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE-RELATED', 251215),
(411191, 'PTHR42922:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORT SYSTEM PERMEASE PROTEIN PSTA', 251216),
(411192, 'PTHR42922', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORT SYSTEM PERMEASE PROTEIN PSTA', 251216),
(411193, 'PTHR42850', NULL, NULL, NULL, NULL, 'METALLOPHOSPHOESTERASE', 251217),
(411194, 'PTHR42850:SF8', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2', 251217),
(411195, 'PTHR42850:SF7', NULL, NULL, NULL, NULL, 'BIS(5''-NUCLEOSYL)-TETRAPHOSPHATASE PRPE [ASYMMETRICAL]', 251217),
(411196, 'PTHR42850:SF11', NULL, NULL, NULL, NULL, 'BIS(5''-NUCLEOSYL)-TETRAPHOSPHATASE [SYMMETRICAL]', 251217),
(411197, 'PTHR42850:SF12', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE, PUTATIVE-RELATED', 251217),
(411198, 'PTHR42850:SF4', NULL, NULL, NULL, NULL, 'METALLOPHOSPHOESTERASE YNL217W-RELATED', 251217),
(411199, 'PTHR42850:SF10', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 1', 251217),
(411200, 'PTHR42850:SF2', NULL, NULL, NULL, NULL, 'BLL5683 PROTEIN', 251217),
(411201, 'PTHR23136:SF10', NULL, NULL, NULL, NULL, '', 251218),
(411202, 'PTHR23136:SF7', NULL, NULL, NULL, NULL, 'TAX1-BINDING PROTEIN 3', 251218),
(411203, 'PTHR23136:SF9', NULL, NULL, NULL, NULL, 'GEO05053P1', 251218),
(411204, 'PTHR23136:SF8', NULL, NULL, NULL, NULL, 'ST6 N-ACETYLGALACTOSAMINIDE ALPHA-2,6-SIALYLTRANSFERASE 3', 251218),
(411205, 'PTHR23136:SF11', NULL, NULL, NULL, NULL, 'ST6 N-ACETYLGALACTOSAMINIDE ALPHA-2,6-SIALYLTRANSFERASE 5', 251218),
(411206, 'PTHR23136:SF12', NULL, NULL, NULL, NULL, 'ALPHA-2,6-SIALYLTRANSFERASE', 251218); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(411207, 'PTHR23136', NULL, NULL, NULL, NULL, 'TAX1-BINDING PROTEIN 3-RELATED', 251218),
(411208, 'PTHR23136:SF13', NULL, NULL, NULL, NULL, '', 251218),
(411209, 'PTHR24234:SF8', NULL, NULL, NULL, NULL, 'ZGC:171579', 251219),
(411210, 'PTHR24234:SF9', NULL, NULL, NULL, NULL, 'SI:DKEY-165A24.9', 251219),
(411211, 'PTHR24234:SF10', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 4', 251219),
(411212, 'PTHR24234:SF6', NULL, NULL, NULL, NULL, 'LYSOPHOSPHATIDIC ACID RECEPTOR 5', 251219),
(411213, 'PTHR24234:SF11', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR 65', 251219),
(411214, 'PTHR24234:SF7', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 132-RELATED', 251219),
(411215, 'PTHR24234:SF5', NULL, NULL, NULL, NULL, 'OVARIAN CANCER G-PROTEIN COUPLED RECEPTOR 1', 251219),
(411216, 'PTHR24234', NULL, NULL, NULL, NULL, 'LYSOPHOSPHATIDIC ACID RECEPTOR 5/SPHINGOSYLPHOSPHORYLCHOLINE RECEPTOR', 251219),
(411217, 'PTHR33101:SF60', NULL, NULL, NULL, NULL, 'PRONE DOMAIN-CONTAINING PROTEIN-RELATED', 251220),
(411218, 'PTHR33101:SF63', NULL, NULL, NULL, NULL, 'ROP GUANINE NUCLEOTIDE EXCHANGE FACTOR 13', 251220),
(411219, 'PTHR33101:SF41', NULL, NULL, NULL, NULL, 'ROP GUANINE NUCLEOTIDE EXCHANGE FACTOR 7-LIKE', 251220),
(411220, 'PTHR33101:SF42', NULL, NULL, NULL, NULL, 'PRONE DOMAIN-CONTAINING PROTEIN', 251220),
(411221, 'PTHR33101:SF62', NULL, NULL, NULL, NULL, 'OS02G0272300 PROTEIN', 251220),
(411222, 'PTHR33101:SF45', NULL, NULL, NULL, NULL, 'ROP GUANINE NUCLEOTIDE EXCHANGE FACTOR 11', 251220),
(411223, 'PTHR33101:SF67', NULL, NULL, NULL, NULL, 'PRONE DOMAIN-CONTAINING PROTEIN', 251220),
(411224, 'PTHR33101:SF46', NULL, NULL, NULL, NULL, 'RHO GUANYL-NUCLEOTIDE EXCHANGE FACTOR', 251220),
(411225, 'PTHR33101:SF68', NULL, NULL, NULL, NULL, 'RHO GUANYL-NUCLEOTIDE EXCHANGE FACTOR 4-RELATED', 251220),
(411226, 'PTHR33101:SF65', NULL, NULL, NULL, NULL, 'ROP GUANINE NUCLEOTIDE EXCHANGE FACTOR 10', 251220),
(411227, 'PTHR33101:SF43', NULL, NULL, NULL, NULL, 'ROP GUANINE NUCLEOTIDE EXCHANGE FACTOR 6', 251220),
(411228, 'PTHR33101:SF66', NULL, NULL, NULL, NULL, 'PRONE DOMAIN-CONTAINING PROTEIN-RELATED', 251220),
(411229, 'PTHR33101:SF49', NULL, NULL, NULL, NULL, 'ROP GUANINE NUCLEOTIDE EXCHANGE FACTOR 12-LIKE', 251220),
(411230, 'PTHR33101:SF28', NULL, NULL, NULL, NULL, 'OS05G0560100 PROTEIN', 251220),
(411231, 'PTHR33101:SF69', NULL, NULL, NULL, NULL, 'PRONE DOMAIN-CONTAINING PROTEIN-RELATED', 251220),
(411232, 'PTHR33101:SF47', NULL, NULL, NULL, NULL, 'ROP GUANINE NUCLEOTIDE EXCHANGE FACTOR 2-RELATED', 251220),
(411233, 'PTHR33101:SF26', NULL, NULL, NULL, NULL, 'OS01G0760300 PROTEIN', 251220),
(411234, 'PTHR33101:SF1', NULL, NULL, NULL, NULL, 'ROP GUANINE NUCLEOTIDE EXCHANGE FACTOR 5', 251220),
(411235, 'PTHR33101:SF2', NULL, NULL, NULL, NULL, 'ROP GUANINE NUCLEOTIDE EXCHANGE FACTOR 14', 251220),
(411236, 'PTHR33101:SF5', NULL, NULL, NULL, NULL, 'OS07G0481100 PROTEIN', 251220),
(411237, 'PTHR33101:SF6', NULL, NULL, NULL, NULL, 'ROP GUANINE NUCLEOTIDE EXCHANGE FACTOR 1', 251220),
(411238, 'PTHR33101', NULL, NULL, NULL, NULL, 'ROP GUANINE NUCLEOTIDE EXCHANGE FACTOR 1', 251220),
(411239, 'PTHR33101:SF70', NULL, NULL, NULL, NULL, 'ROP GUANINE NUCLEOTIDE EXCHANGE FACTOR 12-LIKE', 251220),
(411240, 'PTHR33101:SF52', NULL, NULL, NULL, NULL, 'PRONE DOMAIN-CONTAINING PROTEIN', 251220),
(411241, 'PTHR33101:SF74', NULL, NULL, NULL, NULL, 'OS05G0454200 PROTEIN', 251220),
(411242, 'PTHR33101:SF30', NULL, NULL, NULL, NULL, 'ROP GUANINE NUCLEOTIDE EXCHANGE FACTOR 2', 251220),
(411243, 'PTHR33101:SF75', NULL, NULL, NULL, NULL, 'PRONE DOMAIN-CONTAINING PROTEIN', 251220),
(411244, 'PTHR33101:SF53', NULL, NULL, NULL, NULL, 'PRONE DOMAIN-CONTAINING PROTEIN-RELATED', 251220),
(411245, 'PTHR33101:SF50', NULL, NULL, NULL, NULL, 'ROP GUANINE NUCLEOTIDE EXCHANGE FACTOR 1-LIKE', 251220),
(411246, 'PTHR33101:SF51', NULL, NULL, NULL, NULL, 'PRONE DOMAIN-CONTAINING PROTEIN', 251220),
(411247, 'PTHR33101:SF34', NULL, NULL, NULL, NULL, 'PRONE DOMAIN-CONTAINING PROTEIN-RELATED', 251220),
(411248, 'PTHR33101:SF56', NULL, NULL, NULL, NULL, 'PRONE DOMAIN-CONTAINING PROTEIN', 251220);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(411249, 'PTHR33101:SF57', NULL, NULL, NULL, NULL, 'PRONE DOMAIN-CONTAINING PROTEIN-RELATED', 251220),
(411250, 'PTHR33101:SF35', NULL, NULL, NULL, NULL, 'ROP GUANINE NUCLEOTIDE EXCHANGE FACTOR 4', 251220),
(411251, 'PTHR33101:SF76', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 8-LIKE', 251220),
(411252, 'PTHR33101:SF10', NULL, NULL, NULL, NULL, 'ROP GUANINE NUCLEOTIDE EXCHANGE FACTOR 12', 251220),
(411253, 'PTHR33101:SF54', NULL, NULL, NULL, NULL, 'ROP GUANINE NUCLEOTIDE EXCHANGE FACTOR 14-LIKE', 251220),
(411254, 'PTHR33101:SF55', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 8-RELATED', 251220),
(411255, 'PTHR33101:SF77', NULL, NULL, NULL, NULL, 'PRONE DOMAIN-CONTAINING PROTEIN-RELATED', 251220),
(411256, 'PTHR33101:SF38', NULL, NULL, NULL, NULL, 'PRONE DOMAIN-CONTAINING PROTEIN-RELATED', 251220),
(411257, 'PTHR33101:SF14', NULL, NULL, NULL, NULL, 'ROP GUANINE NUCLEOTIDE EXCHANGE FACTOR 7', 251220),
(411258, 'PTHR33101:SF58', NULL, NULL, NULL, NULL, 'PRONE DOMAIN-CONTAINING PROTEIN', 251220),
(411259, 'PTHR33101:SF59', NULL, NULL, NULL, NULL, 'PRONE DOMAIN-CONTAINING PROTEIN-RELATED', 251220),
(411260, 'PTHR33101:SF37', NULL, NULL, NULL, NULL, 'ROP GUANINE NUCLEOTIDE EXCHANGE FACTOR 12-LIKE', 251220),
(411261, 'PTHR42059:SF1', NULL, NULL, NULL, NULL, '', 251221),
(411262, 'PTHR42059', NULL, NULL, NULL, NULL, '', 251221),
(411263, 'PTHR38360:SF1', NULL, NULL, NULL, NULL, 'PLANT/F12P19-7 PROTEIN', 251222),
(411264, 'PTHR38360', NULL, NULL, NULL, NULL, 'OS03G0120000 PROTEIN', 251222),
(411265, 'PTHR36409:SF2', NULL, NULL, NULL, NULL, 'BNAA09G07940D PROTEIN', 251223),
(411266, 'PTHR36409:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251223),
(411267, 'PTHR36409', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251223),
(411268, 'PTHR30531', NULL, NULL, NULL, NULL, 'FLAGELLAR BIOSYNTHETIC PROTEIN FLHB', 251224),
(411269, 'PTHR30531:SF14', NULL, NULL, NULL, NULL, 'SURFACE PRESENTATION OF ANTIGENS PROTEIN SPAS', 251224),
(411270, 'PTHR30531:SF12', NULL, NULL, NULL, NULL, 'FLAGELLAR BIOSYNTHETIC PROTEIN FLHB', 251224),
(411271, 'PTHR30531:SF6', NULL, NULL, NULL, NULL, 'SECRETION SYSTEM APPARATUS PROTEIN SSAU', 251224),
(411272, 'PTHR10556:SF28', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN ENOYL-COA REDUCTASE', 251225),
(411273, 'PTHR10556:SF48', NULL, NULL, NULL, NULL, 'STEROID 5-ALPHA-REDUCTASE DET2-LIKE', 251225),
(411274, 'PTHR10556:SF37', NULL, NULL, NULL, NULL, '3-OXO-5-ALPHA-STEROID 4-DEHYDROGENASE 2', 251225),
(411275, 'PTHR10556:SF27', NULL, NULL, NULL, NULL, 'TRANS-2,3-ENOYL-COA REDUCTASE-LIKE', 251225),
(411276, 'PTHR10556:SF57', NULL, NULL, NULL, NULL, '3-OXO-5-ALPHA-STEROID 4-DEHYDROGENASE 1', 251225),
(411277, 'PTHR10556:SF35', NULL, NULL, NULL, NULL, '3-OXO-5-ALPHA-STEROID 4-DEHYDROGENASE FAMILY PROTEIN', 251225),
(411278, 'PTHR10556:SF58', NULL, NULL, NULL, NULL, 'S5A_REDUCTASE DOMAIN-CONTAINING PROTEIN', 251225),
(411279, 'PTHR10556:SF55', NULL, NULL, NULL, NULL, '3-OXO-5-ALPHA-STEROID 4-DEHYDROGENASE-RELATED', 251225),
(411280, 'PTHR10556:SF34', NULL, NULL, NULL, NULL, '3-OXO-5-ALPHA-STEROID 4-DEHYDROGENASE', 251225),
(411281, 'PTHR10556:SF53', NULL, NULL, NULL, NULL, 'STEROID 5-ALPHA-REDUCTASE DET2', 251225),
(411282, 'PTHR10556:SF31', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN ENOYL-COA REDUCTASE', 251225),
(411283, 'PTHR10556:SF54', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN ENOYL-COA REDUCTASE-LIKE', 251225),
(411284, 'PTHR10556:SF43', NULL, NULL, NULL, NULL, 'STEROID 5-ALPHA-REDUCTASE DET2', 251225),
(411285, 'PTHR10556:SF51', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN ENOYL-COA REDUCTASE-LIKE', 251225),
(411286, 'PTHR10556:SF52', NULL, NULL, NULL, NULL, 'S5A_REDUCTASE DOMAIN-CONTAINING PROTEIN', 251225),
(411287, 'PTHR10556:SF50', NULL, NULL, NULL, NULL, '3-OXO-5-ALPHA-STEROID 4-DEHYDROGENASE FAMILY PROTEIN', 251225),
(411288, 'PTHR10556', NULL, NULL, NULL, NULL, '3-OXO-5-ALPHA-STEROID 4-DEHYDROGENASE', 251225),
(411289, 'PTHR42699:SF1', NULL, NULL, NULL, NULL, 'CYSTATHIONINE GAMMA-SYNTHASE-RELATED', 251226),
(411290, 'PTHR42699', NULL, NULL, NULL, NULL, '', 251226);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(411291, 'PTHR40012', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 29', 251227),
(411292, 'PTHR40012:SF1', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 29', 251227),
(411293, 'PTHR11133:SF23', NULL, NULL, NULL, NULL, 'SACCHAROPINE DEHYDROGENASE [NAD(+), L-LYSINE-FORMING]', 251228),
(411294, 'PTHR11133:SF22', NULL, NULL, NULL, NULL, 'LYSINE KETOGLUTARATE REDUCTASE', 251228),
(411295, 'PTHR11133:SF25', NULL, NULL, NULL, NULL, 'ALPHA-AMINOADIPIC SEMIALDEHYDE SYNTHASE, MITOCHONDRIAL', 251228),
(411296, 'PTHR11133', NULL, NULL, NULL, NULL, 'SACCHAROPINE DEHYDROGENASE', 251228),
(411297, 'PTHR37320', NULL, NULL, NULL, NULL, 'AG-1 BLOOD STAGE MEMBRANE PROTEIN HOMOLOGUE', 251229),
(411298, 'PTHR37320:SF1', NULL, NULL, NULL, NULL, 'AG-1 BLOOD STAGE MEMBRANE PROTEIN HOMOLOGUE', 251229),
(411299, 'PTHR12733:SF6', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT B', 251230),
(411300, 'PTHR12733', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ATP SYNTHASE B CHAIN', 251230),
(411301, 'PTHR12733:SF3', NULL, NULL, NULL, NULL, 'ATP SYNTHASE F(0) COMPLEX SUBUNIT B1, MITOCHONDRIAL', 251230),
(411302, 'PTHR46173:SF1', NULL, NULL, NULL, NULL, 'CCA TRNA NUCLEOTIDYLTRANSFERASE 1, MITOCHONDRIAL', 251231),
(411303, 'PTHR46173', NULL, NULL, NULL, NULL, 'CCA TRNA NUCLEOTIDYLTRANSFERASE 1, MITOCHONDRIAL', 251231),
(411304, 'PTHR37494', NULL, NULL, NULL, NULL, 'HEMAGGLUTININ', 251232),
(411305, 'PTHR37494:SF1', NULL, NULL, NULL, NULL, 'HEMAGGLUTININ', 251232),
(411306, 'PTHR21331:SF2', NULL, NULL, NULL, NULL, 'BRCA1-ASSOCIATED ATM ACTIVATOR 1', 251233),
(411307, 'PTHR21331', NULL, NULL, NULL, NULL, 'BRCA1-ASSOCIATED ATM ACTIVATOR 1', 251233),
(411308, 'PTHR31474:SF10', NULL, NULL, NULL, NULL, 'HR-LIKE LESION-INDUCING PROTEIN-LIKE PROTEIN', 251234),
(411309, 'PTHR31474:SF9', NULL, NULL, NULL, NULL, 'HR-LIKE LESION-INDUCING PROTEIN', 251234),
(411310, 'PTHR31474:SF19', NULL, NULL, NULL, NULL, 'BNAA08G27830D PROTEIN', 251234),
(411311, 'PTHR31474:SF18', NULL, NULL, NULL, NULL, 'BNAA09G16540D PROTEIN', 251234),
(411312, 'PTHR31474:SF17', NULL, NULL, NULL, NULL, 'BNAC03G74500D PROTEIN', 251234),
(411313, 'PTHR31474:SF5', NULL, NULL, NULL, NULL, 'OS04G0181100 PROTEIN', 251234),
(411314, 'PTHR31474:SF16', NULL, NULL, NULL, NULL, 'BNACNNG17310D PROTEIN', 251234),
(411315, 'PTHR31474:SF4', NULL, NULL, NULL, NULL, 'HR-LIKE LESION-INDUCING PROTEIN', 251234),
(411316, 'PTHR31474', NULL, NULL, NULL, NULL, 'HR-LIKE LESION-INDUCER', 251234),
(411317, 'PTHR31474:SF13', NULL, NULL, NULL, NULL, 'NICOTIANA TABACUM ORF', 251234),
(411318, 'PTHR31474:SF12', NULL, NULL, NULL, NULL, 'HR-LIKE LESION-INDUCING PROTEIN', 251234),
(411319, 'PTHR31474:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251234),
(411320, 'PTHR43480', NULL, NULL, NULL, NULL, 'ACYL-[ACYL-CARRIER-PROTEIN]--UDP-N-ACETYLGLUCOSAMINE O-ACYLTRANSFERASE', 251235),
(411321, 'PTHR43480:SF1', NULL, NULL, NULL, NULL, 'ACYL-[ACYL-CARRIER-PROTEIN]--UDP-N-ACETYLGLUCOSAMINE O-ACYLTRANSFERASE, MITOCHONDRIAL-RELATED', 251235),
(411322, 'PTHR16244', NULL, NULL, NULL, NULL, 'CEROID-LIPOFUSCINOSIS NEURONAL PROTEIN 6', 251236),
(411323, 'PTHR16244:SF2', NULL, NULL, NULL, NULL, 'CEROID-LIPOFUSCINOSIS NEURONAL PROTEIN 6', 251236),
(411324, 'PTHR16450:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG12045', 251237),
(411325, 'PTHR16450', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 186', 251237),
(411326, 'PTHR23204:SF14', NULL, NULL, NULL, NULL, 'OS04G0467300 PROTEIN', 251238),
(411327, 'PTHR23204:SF13', NULL, NULL, NULL, NULL, 'OS09G0476100 PROTEIN', 251238),
(411328, 'PTHR23204:SF15', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 251238),
(411329, 'PTHR23204:SF8', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 251238),
(411330, 'PTHR23204:SF7', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 251238),
(411331, 'PTHR23204:SF3', NULL, NULL, NULL, NULL, 'CLEAVAGE AND POLYADENYLATION SPECIFICITY FACTOR SUBUNIT 6', 251238),
(411332, 'PTHR23204:SF2', NULL, NULL, NULL, NULL, 'CLEAVAGE AND POLYADENYLATION SPECIFICITY FACTOR SUBUNIT 7', 251238);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(411333, 'PTHR23204:SF10', NULL, NULL, NULL, NULL, 'CLEAVAGE AND POLYADENYLATION SPECIFICITY FACTOR SUBUNIT 6', 251238),
(411334, 'PTHR23204', NULL, NULL, NULL, NULL, 'CLEAVAGE AND POLYADENYLATION SPECIFIC FACTOR', 251238),
(411335, 'PTHR23204:SF12', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 251238),
(411336, 'PTHR40453:SF1', NULL, NULL, NULL, NULL, 'PROTEIN YOEF', 251239),
(411337, 'PTHR40453', NULL, NULL, NULL, NULL, 'PROTEIN YOEF', 251239),
(411338, 'PTHR40453:SF2', NULL, NULL, NULL, NULL, 'ACETATE KINASE EUTP-RELATED', 251239),
(411339, 'PTHR46762:SF1', NULL, NULL, NULL, NULL, 'NUCLEOREDOXIN-LIKE PROTEIN 2', 251240),
(411340, 'PTHR46762', NULL, NULL, NULL, NULL, 'NUCLEOREDOXIN-LIKE PROTEIN 2', 251240),
(411341, 'PTHR31340:SF5', NULL, NULL, NULL, NULL, 'AGAP010576-PA', 251241),
(411342, 'PTHR31340:SF3', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL GENOME MAINTENANCE EXONUCLEASE 1', 251241),
(411343, 'PTHR31340', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL GENOME MAINTENANCE EXONUCLEASE 1', 251241),
(411344, 'PTHR41313:SF1', NULL, NULL, NULL, NULL, 'N6_MTASE DOMAIN-CONTAINING PROTEIN', 251242),
(411345, 'PTHR41313', NULL, NULL, NULL, NULL, 'ADENINE-SPECIFIC METHYLTRANSFERASE', 251242),
(411346, 'PTHR21539:SF7', NULL, NULL, NULL, NULL, 'SGF29 C-TERMINAL DOMAIN-CONTAINING PROTEIN', 251243),
(411347, 'PTHR21539', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 251243),
(411348, 'PTHR21539:SF0', NULL, NULL, NULL, NULL, 'SAGA-ASSOCIATED FACTOR 29', 251243),
(411349, 'PTHR33681:SF4', NULL, NULL, NULL, NULL, 'OS12G0171100 PROTEIN', 251244),
(411350, 'PTHR33681:SF17', NULL, NULL, NULL, NULL, 'CITRATE-BINDING PROTEIN-RELATED', 251244),
(411351, 'PTHR33681:SF18', NULL, NULL, NULL, NULL, 'CONCANAVALIN A-LIKE LECTIN/GLUCANASE DOMAIN-CONTAINING PROTEIN-RELATED', 251244),
(411352, 'PTHR33681:SF15', NULL, NULL, NULL, NULL, 'ALGINATE_LYASE2 DOMAIN-CONTAINING PROTEIN', 251244),
(411353, 'PTHR33681:SF16', NULL, NULL, NULL, NULL, 'OS12G0165400 PROTEIN', 251244),
(411354, 'PTHR33681:SF8', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE-RELATED', 251244),
(411355, 'PTHR33681:SF9', NULL, NULL, NULL, NULL, 'ALGINATE_LYASE2 DOMAIN-CONTAINING PROTEIN', 251244),
(411356, 'PTHR33681:SF20', NULL, NULL, NULL, NULL, 'ALGINATE_LYASE2 DOMAIN-CONTAINING PROTEIN', 251244),
(411357, 'PTHR33681:SF10', NULL, NULL, NULL, NULL, 'ALGINATE_LYASE2 DOMAIN-CONTAINING PROTEIN', 251244),
(411358, 'PTHR33681:SF21', NULL, NULL, NULL, NULL, 'ALGINATE_LYASE2 DOMAIN-CONTAINING PROTEIN', 251244),
(411359, 'PTHR33681:SF13', NULL, NULL, NULL, NULL, 'ALGINATE_LYASE2 DOMAIN-CONTAINING PROTEIN', 251244),
(411360, 'PTHR33681:SF11', NULL, NULL, NULL, NULL, 'ALGINATE LYASE', 251244),
(411361, 'PTHR33681:SF22', NULL, NULL, NULL, NULL, 'ALGINATE_LYASE2 DOMAIN-CONTAINING PROTEIN', 251244),
(411362, 'PTHR33681:SF23', NULL, NULL, NULL, NULL, 'ALGINATE_LYASE2 DOMAIN-CONTAINING PROTEIN', 251244),
(411363, 'PTHR33681', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE, EXPRESSED-RELATED', 251244),
(411364, 'PTHR45913:SF5', NULL, NULL, NULL, NULL, 'TRANSPOSASE', 251245),
(411365, 'PTHR45913', NULL, NULL, NULL, NULL, 'EPM2A-INTERACTING PROTEIN 1', 251245),
(411366, 'PTHR45913:SF18', NULL, NULL, NULL, NULL, '', 251245),
(411367, 'PTHR45913:SF16', NULL, NULL, NULL, NULL, '', 251245),
(411368, 'PTHR45913:SF17', NULL, NULL, NULL, NULL, 'ZF-C2H2_12 DOMAIN-CONTAINING PROTEIN', 251245),
(411369, 'PTHR45913:SF14', NULL, NULL, NULL, NULL, 'DIMER_TNP_HAT DOMAIN-CONTAINING PROTEIN', 251245),
(411370, 'PTHR45913:SF15', NULL, NULL, NULL, NULL, 'DUF4371 DOMAIN-CONTAINING PROTEIN', 251245),
(411371, 'PTHR45913:SF9', NULL, NULL, NULL, NULL, 'ZF-C2H2_12 DOMAIN-CONTAINING PROTEIN', 251245),
(411372, 'PTHR45913:SF10', NULL, NULL, NULL, NULL, 'DUF4371 DOMAIN-CONTAINING PROTEIN', 251245),
(411373, 'PTHR45913:SF11', NULL, NULL, NULL, NULL, 'EPM2A-INTERACTING PROTEIN 1', 251245),
(411374, 'PTHR42659:SF5', NULL, NULL, NULL, NULL, 'ALDEHYDE OXIDOREDUCTASE FAD-BINDING SUBUNIT PAOB', 251246),
(411375, 'PTHR42659:SF1', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE', 251246),
(411376, 'PTHR42659:SF2', NULL, NULL, NULL, NULL, 'XANTHINE DEHYDROGENASE SUBUNIT C-RELATED', 251246);
INSERT INTO "PUBLIC"."MODEL" VALUES
(411377, 'PTHR42659', NULL, NULL, NULL, NULL, 'XANTHINE DEHYDROGENASE SUBUNIT C-RELATED', 251246),
(411378, 'PTHR42659:SF9', NULL, NULL, NULL, NULL, 'XANTHINE DEHYDROGENASE FAD-BINDING SUBUNIT XDHB-RELATED', 251246),
(411379, 'PTHR31648', NULL, NULL, NULL, NULL, '', 251247),
(411380, 'PTHR31648:SF4', NULL, NULL, NULL, NULL, '', 251247),
(411381, 'PTHR31648:SF3', NULL, NULL, NULL, NULL, '', 251247),
(411382, 'PTHR31648:SF2', NULL, NULL, NULL, NULL, '', 251247),
(411383, 'PTHR15454:SF26', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 61', 251248),
(411384, 'PTHR15454:SF37', NULL, NULL, NULL, NULL, 'OUTER ARM DYNEIN LIGHT CHAIN 1 PROTEIN', 251248),
(411385, 'PTHR15454:SF38', NULL, NULL, NULL, NULL, 'OUTER ARM DYNEIN LIGHT CHAIN 1 PROTEIN', 251248),
(411386, 'PTHR15454:SF19', NULL, NULL, NULL, NULL, '', 251248),
(411387, 'PTHR15454:SF43', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT FAMILY PROTEIN, EXPRESSED', 251248),
(411388, 'PTHR15454:SF7', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL LIGHT CHAIN 1', 251248),
(411389, 'PTHR15454:SF35', NULL, NULL, NULL, NULL, 'NISCHARIN', 251248),
(411390, 'PTHR15454:SF68', NULL, NULL, NULL, NULL, '', 251248),
(411391, 'PTHR15454:SF47', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 23', 251248),
(411392, 'PTHR15454:SF69', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 11-INTERACTING PROTEIN', 251248),
(411393, 'PTHR15454:SF33', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL LIGHT CHAIN 1', 251248),
(411394, 'PTHR15454:SF66', NULL, NULL, NULL, NULL, '', 251248),
(411395, 'PTHR15454:SF56', NULL, NULL, NULL, NULL, 'LRRCAP DOMAIN-CONTAINING PROTEIN', 251248),
(411396, 'PTHR15454:SF34', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND COILED-COIL DOMAIN-CONTAINING PROTEIN 1', 251248),
(411397, 'PTHR15454:SF67', NULL, NULL, NULL, NULL, '', 251248),
(411398, 'PTHR15454:SF60', NULL, NULL, NULL, NULL, 'BNAC03G30240D PROTEIN', 251248),
(411399, 'PTHR15454', NULL, NULL, NULL, NULL, 'NISCHARIN RELATED', 251248),
(411400, 'PTHR15454:SF70', NULL, NULL, NULL, NULL, '', 251248),
(411401, 'PTHR36713', NULL, NULL, NULL, NULL, 'OS09G0344700 PROTEIN', 251249),
(411402, 'PTHR36713:SF1', NULL, NULL, NULL, NULL, 'OS09G0344700 PROTEIN', 251249),
(411403, 'PTHR30435:SF2', NULL, NULL, NULL, NULL, 'FLAGELLAR BASAL-BODY ROD PROTEIN FLGC', 251250),
(411404, 'PTHR30435', NULL, NULL, NULL, NULL, 'FLAGELLAR PROTEIN', 251250),
(411405, 'PTHR30435:SF19', NULL, NULL, NULL, NULL, 'FLAGELLAR BASAL-BODY ROD PROTEIN FLGG', 251250),
(411406, 'PTHR30435:SF18', NULL, NULL, NULL, NULL, 'FLAGELLAR BASAL-BODY ROD PROTEIN FLGF', 251250),
(411407, 'PTHR30435:SF29', NULL, NULL, NULL, NULL, 'FLAGELLAR BASAL-BODY ROD PROTEIN FLGC', 251250),
(411408, 'PTHR30435:SF15', NULL, NULL, NULL, NULL, 'BASAL-BODY ROD MODIFICATION PROTEIN FLGD', 251250),
(411409, 'PTHR30435:SF12', NULL, NULL, NULL, NULL, 'FLAGELLAR BASAL BODY ROD PROTEIN FLGB', 251250),
(411410, 'PTHR30435:SF34', NULL, NULL, NULL, NULL, 'BASAL-BODY ROD MODIFICATION PROTEIN FLGD', 251250),
(411411, 'PTHR30435:SF33', NULL, NULL, NULL, NULL, 'FLAGELLAR BASAL-BODY ROD PROTEIN', 251250),
(411412, 'PTHR30435:SF1', NULL, NULL, NULL, NULL, 'FLAGELLAR HOOK PROTEIN FLGE', 251250),
(411413, 'PTHR30435:SF31', NULL, NULL, NULL, NULL, 'FLAGELLAR BASAL BODY PROTEIN', 251250),
(411414, 'PTHR15561', NULL, NULL, NULL, NULL, 'CALCITONIN GENE-RELATED PEPTIDE-RECEPTOR COMPONENT PROTEIN', 251251),
(411415, 'PTHR15561:SF1', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE III SUBUNIT RPC9', 251251),
(411416, 'PTHR15561:SF0', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE III SUBUNIT RPC9', 251251),
(411417, 'PTHR43831', NULL, NULL, NULL, NULL, 'ISOBUTYRYL-COA DEHYDROGENASE', 251252),
(411418, 'PTHR43831:SF1', NULL, NULL, NULL, NULL, 'ISOBUTYRYL-COA DEHYDROGENASE, MITOCHONDRIAL', 251252),
(411419, 'PTHR42697:SF1', NULL, NULL, NULL, NULL, 'ENDONUCLEASE 8', 251253),
(411420, 'PTHR42697:SF3', NULL, NULL, NULL, NULL, 'ENDONUCLEASE 8 1', 251253),
(411421, 'PTHR42697', NULL, NULL, NULL, NULL, 'ENDONUCLEASE 8', 251253),
(411422, 'PTHR42880', NULL, NULL, NULL, NULL, 'HOMOCITRATE SYNTHASE', 251254);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(411423, 'PTHR42880:SF1', NULL, NULL, NULL, NULL, 'HOMOCITRATE SYNTHASE', 251254),
(411424, 'PTHR42880:SF2', NULL, NULL, NULL, NULL, '(R)-CITRAMALATE SYNTHASE CIMA', 251254),
(411425, 'PTHR22619:SF0', NULL, NULL, NULL, NULL, 'ZINC FINGER SWIM DOMAIN-CONTAINING PROTEIN 6-LIKE PROTEIN', 251255),
(411426, 'PTHR22619', NULL, NULL, NULL, NULL, 'ZINC FINGER SWIM DOMAIN CONTAINING PROTEIN 4, 5, 6', 251255),
(411427, 'PTHR22619:SF3', NULL, NULL, NULL, NULL, 'ZINC FINGER SWIM DOMAIN-CONTAINING PROTEIN 6', 251255),
(411428, 'PTHR22619:SF4', NULL, NULL, NULL, NULL, 'ZINC FINGER SWIM DOMAIN-CONTAINING PROTEIN 4', 251255),
(411429, 'PTHR22619:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER SWIM DOMAIN-CONTAINING PROTEIN 8', 251255),
(411430, 'PTHR22619:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER SWIM DOMAIN-CONTAINING PROTEIN 5', 251255),
(411431, 'PTHR22745', NULL, NULL, NULL, NULL, 'PROTHYMOSIN ALPHA', 251256),
(411432, 'PTHR22745:SF7', NULL, NULL, NULL, NULL, 'SI:CH211-222L21.1', 251256),
(411433, 'PTHR22745:SF3', NULL, NULL, NULL, NULL, 'PARATHYMOSIN', 251256),
(411434, 'PTHR22745:SF11', NULL, NULL, NULL, NULL, 'PROTHYMOSIN ALPHA', 251256),
(411435, 'PTHR22745:SF0', NULL, NULL, NULL, NULL, 'PROTHYMOSIN ALPHA', 251256),
(411436, 'PTHR22745:SF13', NULL, NULL, NULL, NULL, 'PROTHYMOSIN ALPHA-B', 251256),
(411437, 'PTHR41271:SF1', NULL, NULL, NULL, NULL, 'DUF402 DOMAIN-CONTAINING PROTEIN', 251257),
(411438, 'PTHR41271', NULL, NULL, NULL, NULL, 'DUF402 DOMAIN-CONTAINING PROTEIN', 251257),
(411439, 'PTHR46941:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 126', 251258),
(411440, 'PTHR46941', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 126', 251258),
(411441, 'PTHR39185', NULL, NULL, NULL, NULL, 'SWARMING MOTILITY PROTEIN SWRD', 251259),
(411442, 'PTHR39185:SF1', NULL, NULL, NULL, NULL, 'SWARMING MOTILITY PROTEIN SWRD', 251259),
(411443, 'PTHR15718', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 251260),
(411444, 'PTHR15718:SF3', NULL, NULL, NULL, NULL, 'GRIN_C DOMAIN-CONTAINING PROTEIN', 251260),
(411445, 'PTHR15718:SF6', NULL, NULL, NULL, NULL, 'G PROTEIN-REGULATED INDUCER OF NEURITE OUTGROWTH 3', 251260),
(411446, 'PTHR15718:SF5', NULL, NULL, NULL, NULL, 'G PROTEIN-REGULATED INDUCER OF NEURITE OUTGROWTH 2', 251260),
(411447, 'PTHR15718:SF7', NULL, NULL, NULL, NULL, 'G PROTEIN-REGULATED INDUCER OF NEURITE OUTGROWTH 1', 251260),
(411448, 'PTHR34581', NULL, NULL, NULL, NULL, 'PTS SYSTEM N,N''-DIACETYLCHITOBIOSE-SPECIFIC EIIB COMPONENT', 251261),
(411449, 'PTHR34581:SF2', NULL, NULL, NULL, NULL, 'PTS SYSTEM N,N''-DIACETYLCHITOBIOSE-SPECIFIC EIIB COMPONENT', 251261),
(411450, 'PTHR26392', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 7-RELATED', 251262),
(411451, 'PTHR26392:SF92', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251262),
(411452, 'PTHR41248:SF1', NULL, NULL, NULL, NULL, 'NORD PROTEIN', 251263),
(411453, 'PTHR41248', NULL, NULL, NULL, NULL, 'NORD PROTEIN', 251263),
(411454, 'PTHR34399:SF3', NULL, NULL, NULL, NULL, 'AVIDIN-RELATED', 251264),
(411455, 'PTHR34399', NULL, NULL, NULL, NULL, 'AVIDIN-RELATED', 251264),
(411456, 'PTHR32523', NULL, NULL, NULL, NULL, 'PHYTOL KINASE 1, CHLOROPLASTIC', 251265),
(411457, 'PTHR32523:SF15', NULL, NULL, NULL, NULL, 'BNAC09G50600D PROTEIN', 251265),
(411458, 'PTHR32523:SF7', NULL, NULL, NULL, NULL, 'FARNESOL KINASE, CHLOROPLASTIC', 251265),
(411459, 'PTHR32523:SF8', NULL, NULL, NULL, NULL, 'PHYTOL KINASE 1, CHLOROPLASTIC', 251265),
(411460, 'PTHR32523:SF9', NULL, NULL, NULL, NULL, 'OS12G0105500 PROTEIN', 251265),
(411461, 'PTHR32523:SF14', NULL, NULL, NULL, NULL, 'PHYTOL KINASE 2 PROTEIN-RELATED', 251265),
(411462, 'PTHR32523:SF13', NULL, NULL, NULL, NULL, 'BNAA03G56250D PROTEIN', 251265),
(411463, 'PTHR23137:SF24', NULL, NULL, NULL, NULL, 'VESICLE TRANSPORT PROTEIN SFT2A', 251266),
(411464, 'PTHR23137:SF26', NULL, NULL, NULL, NULL, 'VESICLE TRANSPORT PROTEIN', 251266),
(411465, 'PTHR23137:SF37', NULL, NULL, NULL, NULL, 'VESICLE TRANSPORT PROTEIN', 251266),
(411466, 'PTHR23137:SF2', NULL, NULL, NULL, NULL, 'VESICLE TRANSPORT PROTEIN', 251266);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(411467, 'PTHR23137:SF1', NULL, NULL, NULL, NULL, 'VESICLE TRANSPORT PROTEIN SFT2B', 251266),
(411468, 'PTHR23137:SF36', NULL, NULL, NULL, NULL, 'VESICLE TRANSPORT PROTEIN SFT2C', 251266),
(411469, 'PTHR23137:SF39', NULL, NULL, NULL, NULL, 'VESICLE TRANSPORT PROTEIN', 251266),
(411470, 'PTHR23137:SF38', NULL, NULL, NULL, NULL, 'VESICLE TRANSPORT PROTEIN', 251266),
(411471, 'PTHR23137:SF6', NULL, NULL, NULL, NULL, 'VESICLE TRANSPORT PROTEIN', 251266),
(411472, 'PTHR23137:SF29', NULL, NULL, NULL, NULL, 'VESICLE TRANSPORT PROTEIN', 251266),
(411473, 'PTHR23137:SF40', NULL, NULL, NULL, NULL, 'VESICLE TRANSPORT PROTEIN', 251266),
(411474, 'PTHR23137', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 251266),
(411475, 'PTHR23137:SF33', NULL, NULL, NULL, NULL, 'VESICLE TRANSPORT PROTEIN', 251266),
(411476, 'PTHR23137:SF32', NULL, NULL, NULL, NULL, 'VESICLE TRANSPORT PROTEIN', 251266),
(411477, 'PTHR15463', NULL, NULL, NULL, NULL, 'AP1 GAMMA SUBUNIT BINDING PROTEIN 1', 251267),
(411478, 'PTHR15463:SF2', NULL, NULL, NULL, NULL, 'SYNERGIN GAMMA', 251267),
(411479, 'PTHR10680:SF37', NULL, NULL, NULL, NULL, 'PEPTIDYL-ALPHA-HYDROXYGLYCINE ALPHA-AMIDATING LYASE 2', 251268),
(411480, 'PTHR10680:SF28', NULL, NULL, NULL, NULL, 'DED DOMAIN-CONTAINING PROTEIN', 251268),
(411481, 'PTHR10680:SF14', NULL, NULL, NULL, NULL, 'PEPTIDYL-GLYCINE ALPHA-AMIDATING MONOOXYGENASE', 251268),
(411482, 'PTHR10680:SF36', NULL, NULL, NULL, NULL, 'PEPTIDYL-ALPHA-HYDROXYGLYCINE ALPHA-AMIDATING LYASE PGAL-1-RELATED', 251268),
(411483, 'PTHR10680', NULL, NULL, NULL, NULL, 'PEPTIDYL-GLYCINE ALPHA-AMIDATING MONOOXYGENASE', 251268),
(411484, 'PTHR10680:SF31', NULL, NULL, NULL, NULL, 'PEPTIDYL-ALPHA-HYDROXYGLYCINE ALPHA-AMIDATING LYASE 1', 251268),
(411485, 'PTHR38121', NULL, NULL, NULL, NULL, 'GH16 DOMAIN-CONTAINING PROTEIN', 251269),
(411486, 'PTHR38121:SF2', NULL, NULL, NULL, NULL, 'GH16 DOMAIN-CONTAINING PROTEIN', 251269),
(411487, 'PTHR38121:SF4', NULL, NULL, NULL, NULL, 'GH16 DOMAIN-CONTAINING PROTEIN-RELATED', 251269),
(411488, 'PTHR34544:SF1', NULL, NULL, NULL, NULL, 'OS04G0438300 PROTEIN', 251270),
(411489, 'PTHR34544', NULL, NULL, NULL, NULL, 'OSJNBA0006B20.18 PROTEIN', 251270),
(411490, 'PTHR34544:SF3', NULL, NULL, NULL, NULL, 'OS07G0155200 PROTEIN', 251270),
(411491, 'PTHR16133:SF0', NULL, NULL, NULL, NULL, 'ZINC/IRON REGULATED TRANSPORTER-RELATED PROTEIN 102B, ISOFORM E', 251271),
(411492, 'PTHR16133', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 39  ZINC TRANSPORTER , MEMBER 9-RELATED', 251271),
(411493, 'PTHR16133:SF4', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER ZIP9-B', 251271),
(411494, 'PTHR16133:SF5', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER ZIP9', 251271),
(411495, 'PTHR43792:SF8', NULL, NULL, NULL, NULL, '[RIBOSOMAL PROTEIN S5]-ALANINE N-ACETYLTRANSFERASE', 251272),
(411496, 'PTHR43792:SF9', NULL, NULL, NULL, NULL, 'RIBOSOMAL-PROTEIN-ALANINE ACETYLTRANSFERASE', 251272),
(411497, 'PTHR43792:SF5', NULL, NULL, NULL, NULL, 'RIBOSOMAL-PROTEIN-ALANINE ACETYLTRANSFERASE', 251272),
(411498, 'PTHR43792:SF10', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 251272),
(411499, 'PTHR43792:SF1', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 251272),
(411500, 'PTHR43792', NULL, NULL, NULL, NULL, 'GNAT FAMILY, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G00765)-RELATED-RELATED', 251272),
(411501, 'PTHR43792:SF13', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE-RELATED', 251272),
(411502, 'PTHR43792:SF14', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 251272),
(411503, 'PTHR14453:SF70', NULL, NULL, NULL, NULL, 'PROTEIN MONO-ADP-RIBOSYLTRANSFERASE PARP9', 251273),
(411504, 'PTHR14453:SF94', NULL, NULL, NULL, NULL, 'PROTEIN MONO-ADP-RIBOSYLTRANSFERASE PARP10', 251273),
(411505, 'PTHR14453:SF88', NULL, NULL, NULL, NULL, 'POLY [ADP-RIBOSE] POLYMERASE', 251273),
(411506, 'PTHR14453:SF99', NULL, NULL, NULL, NULL, 'PROTEIN MONO-ADP-RIBOSYLTRANSFERASE PARP15', 251273),
(411507, 'PTHR14453:SF89', NULL, NULL, NULL, NULL, 'PROTEIN MONO-ADP-RIBOSYLTRANSFERASE PARP14', 251273),
(411508, 'PTHR14453:SF67', NULL, NULL, NULL, NULL, 'POLY [ADP-RIBOSE] POLYMERASE', 251273);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(411509, 'PTHR14453', NULL, NULL, NULL, NULL, 'PARP/ZINC FINGER CCCH TYPE DOMAIN CONTAINING PROTEIN', 251273),
(411510, 'PTHR46059:SF2', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDE ALPHA-2,6-SIALYLTRANSFERASE 1', 251274),
(411511, 'PTHR46059:SF1', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDE ALPHA-2,6-SIALYLTRANSFERASE', 251274),
(411512, 'PTHR46059', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDE ALPHA-2,6-SIALYLTRANSFERASE', 251274),
(411513, 'PTHR46059:SF4', NULL, NULL, NULL, NULL, 'ST6 BETA-GALACTOSAMIDE ALPHA-2,6-SIALYLTRANFERASE 1', 251274),
(411514, 'PTHR46059:SF3', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDE ALPHA-2,6-SIALYLTRANSFERASE 2', 251274),
(411515, 'PTHR36330', NULL, NULL, NULL, NULL, 'LIPASE/LIPOOXYGENASE, PLAT/LH2 FAMILY PROTEIN', 251275),
(411516, 'PTHR36330:SF2', NULL, NULL, NULL, NULL, 'LIPASE/LIPOOXYGENASE, PLAT/LH2 FAMILY PROTEIN', 251275),
(411517, 'PTHR19446', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASES', 251276),
(411518, 'PTHR19446:SF467', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 251276),
(411519, 'PTHR19446:SF435', NULL, NULL, NULL, NULL, 'LINE-1 RETROTRANSPOSABLE ELEMENT ORF2 PROTEIN', 251276),
(411520, 'PTHR19446:SF468', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 251276),
(411521, 'PTHR19446:SF469', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 251276),
(411522, 'PTHR19446:SF458', NULL, NULL, NULL, NULL, 'LRRG00124', 251276),
(411523, 'PTHR19446:SF415', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE-RELATED PROTEIN', 251276),
(411524, 'PTHR19446:SF470', NULL, NULL, NULL, NULL, 'SI:DKEYP-88H4.2', 251276),
(411525, 'PTHR19446:SF471', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 251276),
(411526, 'PTHR19446:SF472', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 251276),
(411527, 'PTHR19446:SF473', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 251276),
(411528, 'PTHR19446:SF474', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 251276),
(411529, 'PTHR19446:SF431', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 251276),
(411530, 'PTHR21366:SF30', NULL, NULL, NULL, NULL, 'BLL2330 PROTEIN', 251277),
(411531, 'PTHR21366:SF31', NULL, NULL, NULL, NULL, 'METALLOTHIOL TRANSFERASE FOSB', 251277),
(411532, 'PTHR21366:SF32', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 251277),
(411533, 'PTHR21366:SF22', NULL, NULL, NULL, NULL, 'VOC DOMAIN-CONTAINING PROTEIN', 251277),
(411534, 'PTHR21366:SF14', NULL, NULL, NULL, NULL, 'GLYOXALASE DOMAIN-CONTAINING PROTEIN 5', 251277),
(411535, 'PTHR21366:SF25', NULL, NULL, NULL, NULL, 'VOC DOMAIN-CONTAINING PROTEIN', 251277),
(411536, 'PTHR21366:SF27', NULL, NULL, NULL, NULL, 'GLYOXALASE-LIKE_DOM DOMAIN-CONTAINING PROTEIN', 251277),
(411537, 'PTHR21366', NULL, NULL, NULL, NULL, 'GLYOXALASE FAMILY PROTEIN', 251277),
(411538, 'PTHR21366:SF19', NULL, NULL, NULL, NULL, 'METAPYROCATECHASE', 251277),
(411539, 'PTHR16171:SF7', NULL, NULL, NULL, NULL, 'DNA EXCISION REPAIR PROTEIN ERCC-5', 251278),
(411540, 'PTHR16171', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN COMPLEMENTING XP-G CELLS-RELATED', 251278),
(411541, 'PTHR16171:SF10', NULL, NULL, NULL, NULL, 'BASIC IMMUNOGLOBULIN-LIKE VARIABLE MOTIF-CONTAINING PROTEIN', 251278),
(411542, 'PTHR24112:SF38', NULL, NULL, NULL, NULL, '', 251279),
(411543, 'PTHR24112:SF39', NULL, NULL, NULL, NULL, 'F-ACTIN-UNCAPPING PROTEIN LRRC16A', 251279),
(411544, 'PTHR24112:SF28', NULL, NULL, NULL, NULL, '', 251279),
(411545, 'PTHR24112:SF29', NULL, NULL, NULL, NULL, '', 251279),
(411546, 'PTHR24112', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT, ISOFORM F-RELATED', 251279),
(411547, 'PTHR24112:SF64', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT FAMILY PROTEIN', 251279),
(411548, 'PTHR24112:SF65', NULL, NULL, NULL, NULL, 'PROTEIN CARMIL', 251279),
(411549, 'PTHR24112:SF32', NULL, NULL, NULL, NULL, 'CAPPING PROTEIN, ARP2/3 AND MYOSIN-I LINKER PROTEIN 2', 251279),
(411550, 'PTHR24112:SF43', NULL, NULL, NULL, NULL, 'CAPPING PROTEIN, ARP2/3 AND MYOSIN-I LINKER PROTEIN 3', 251279); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(411551, 'PTHR24112:SF66', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT, ISOFORM F', 251279),
(411552, 'PTHR24112:SF44', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN', 251279),
(411553, 'PTHR24112:SF34', NULL, NULL, NULL, NULL, '', 251279),
(411554, 'PTHR24112:SF9', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 37', 251279),
(411555, 'PTHR24112:SF37', NULL, NULL, NULL, NULL, '', 251279),
(411556, 'PTHR24112:SF50', NULL, NULL, NULL, NULL, 'RIBONUCLEASE INHIBITOR', 251279),
(411557, 'PTHR24112:SF40', NULL, NULL, NULL, NULL, '', 251279),
(411558, 'PTHR24112:SF51', NULL, NULL, NULL, NULL, 'DEVELOPMENTAL GENE PRODUCT DG1112', 251279),
(411559, 'PTHR17695', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 251280),
(411560, 'PTHR17695:SF11', NULL, NULL, NULL, NULL, 'SMALL SUBUNIT PROCESSOME COMPONENT 20 HOMOLOG', 251280),
(411561, 'PTHR14317:SF0', NULL, NULL, NULL, NULL, 'PROTAMINE-3', 251281),
(411562, 'PTHR14317', NULL, NULL, NULL, NULL, 'SPERM PROTAMINE P3', 251281),
(411563, 'PTHR36809', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 251282),
(411564, 'PTHR36809:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 251282),
(411565, 'PTHR43403:SF1', NULL, NULL, NULL, NULL, 'NAD-SPECIFIC GLUTAMATE DEHYDROGENASE', 251283),
(411566, 'PTHR43403', NULL, NULL, NULL, NULL, 'NAD-SPECIFIC GLUTAMATE DEHYDROGENASE', 251283),
(411567, 'PTHR43756:SF5', NULL, NULL, NULL, NULL, 'CHOLINE MONOOXYGENASE, CHLOROPLASTIC', 251284),
(411568, 'PTHR43756:SF3', NULL, NULL, NULL, NULL, 'RING_HYDROXYL_A DOMAIN-CONTAINING PROTEIN', 251284),
(411569, 'PTHR43756', NULL, NULL, NULL, NULL, 'CHOLINE MONOOXYGENASE, CHLOROPLASTIC', 251284),
(411570, 'PTHR43756:SF6', NULL, NULL, NULL, NULL, 'CLUSTER-BINDING PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G03920)-RELATED', 251284),
(411571, 'PTHR43756:SF1', NULL, NULL, NULL, NULL, '3-PHENYLPROPIONATE/CINNAMIC ACID DIOXYGENASE SUBUNIT ALPHA', 251284),
(411572, 'PTHR36798:SF2', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN 6, CHLOROPLASTIC', 251285),
(411573, 'PTHR36798:SF3', NULL, NULL, NULL, NULL, 'BNAA10G16930D PROTEIN', 251285),
(411574, 'PTHR36798', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN 6, CHLOROPLASTIC', 251285),
(411575, 'PTHR39104:SF1', NULL, NULL, NULL, NULL, 'AMINO ACID-LIGASE', 251286),
(411576, 'PTHR39104:SF2', NULL, NULL, NULL, NULL, '', 251286),
(411577, 'PTHR39104', NULL, NULL, NULL, NULL, 'AMINO ACID-LIGASE', 251286),
(411578, 'PTHR30251:SF1', NULL, NULL, NULL, NULL, 'FIMBRIAL CHAPARONE', 251287),
(411579, 'PTHR30251:SF0', NULL, NULL, NULL, NULL, 'FIMBRIAL CHAPERONE PROTEIN ELFD-RELATED', 251287),
(411580, 'PTHR30251:SF7', NULL, NULL, NULL, NULL, 'FIMBRIAE CHAPARONE-RELATED', 251287),
(411581, 'PTHR30251:SF6', NULL, NULL, NULL, NULL, 'FIMBRIAL CHAPERONE YFCS-RELATED', 251287),
(411582, 'PTHR30251:SF9', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN CAF1M', 251287),
(411583, 'PTHR30251:SF3', NULL, NULL, NULL, NULL, 'FIMBRIAL CHAPARONE PROTEIN-RELATED', 251287),
(411584, 'PTHR30251:SF2', NULL, NULL, NULL, NULL, 'FIMBRIAL CHAPERONE YADV-RELATED', 251287),
(411585, 'PTHR30251:SF5', NULL, NULL, NULL, NULL, 'FIMBRIAL CHAPARONE PROTEIN-RELATED', 251287),
(411586, 'PTHR30251:SF4', NULL, NULL, NULL, NULL, 'SLR1668 PROTEIN', 251287),
(411587, 'PTHR30251:SF25', NULL, NULL, NULL, NULL, 'FIMBRIAE CHAPARONE-RELATED', 251287),
(411588, 'PTHR30251', NULL, NULL, NULL, NULL, 'PILUS ASSEMBLY CHAPERONE', 251287),
(411589, 'PTHR30251:SF10', NULL, NULL, NULL, NULL, 'FIMBRIAL CHAPERONE YEHC-RELATED', 251287),
(411590, 'PTHR30251:SF11', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN FIMC-RELATED', 251287),
(411591, 'PTHR14413:SF16', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L17, MITOCHONDRIAL', 251288),
(411592, 'PTHR14413', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L17', 251288),
(411593, 'PTHR14413:SF24', NULL, NULL, NULL, NULL, 'BNAUNNG03100D PROTEIN', 251288),
(411594, 'PTHR14413:SF23', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L17, CHLOROPLASTIC', 251288),
(411595, 'PTHR14413:SF22', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L17', 251288);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(411596, 'PTHR36516:SF6', NULL, NULL, NULL, NULL, 'DOMON DOMAIN-CONTAINING PROTEIN', 251289),
(411597, 'PTHR36516', NULL, NULL, NULL, NULL, 'PROTEIN CBG04168-RELATED', 251289),
(411598, 'PTHR36516:SF4', NULL, NULL, NULL, NULL, 'DOMON DOMAIN-CONTAINING PROTEIN Y73F4A.1', 251289),
(411599, 'PTHR36516:SF5', NULL, NULL, NULL, NULL, 'CHONDROITIN PROTEOGLYCAN', 251289),
(411600, 'PTHR36516:SF2', NULL, NULL, NULL, NULL, 'DOMON DOMAIN-CONTAINING PROTEIN', 251289),
(411601, 'PTHR36516:SF3', NULL, NULL, NULL, NULL, 'DOMON DOMAIN-CONTAINING PROTEIN Y73F4A.2', 251289),
(411602, 'PTHR36516:SF1', NULL, NULL, NULL, NULL, 'DOMON DOMAIN-CONTAINING PROTEIN', 251289),
(411603, 'PTHR46326:SF8', NULL, NULL, NULL, NULL, 'C2H2-LIKE ZINC FINGER PROTEIN', 251290),
(411604, 'PTHR46326:SF7', NULL, NULL, NULL, NULL, 'CYS2/HIS2 ZINC-FINGER TRANSCRIPTION FACTOR', 251290),
(411605, 'PTHR46326', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZAT1-RELATED', 251290),
(411606, 'PTHR46326:SF6', NULL, NULL, NULL, NULL, 'OS02G0659500 PROTEIN', 251290),
(411607, 'PTHR46326:SF5', NULL, NULL, NULL, NULL, 'OS04G0552700 PROTEIN', 251290),
(411608, 'PTHR46326:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZAT1-RELATED', 251290),
(411609, 'PTHR46326:SF1', NULL, NULL, NULL, NULL, 'OS03G0425900 PROTEIN', 251290),
(411610, 'PTHR46326:SF21', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZAT9', 251290),
(411611, 'PTHR46326:SF10', NULL, NULL, NULL, NULL, 'C2H2 AND C2HC ZINC FINGER PROTEIN', 251290),
(411612, 'PTHR46326:SF11', NULL, NULL, NULL, NULL, 'OS07G0598800 PROTEIN', 251290),
(411613, 'PTHR46326:SF23', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN, PUTATIVE-RELATED', 251290),
(411614, 'PTHR46326:SF24', NULL, NULL, NULL, NULL, 'BNACNNG73530D PROTEIN', 251290),
(411615, 'PTHR46326:SF14', NULL, NULL, NULL, NULL, 'BNAA08G30310D PROTEIN', 251290),
(411616, 'PTHR46326:SF16', NULL, NULL, NULL, NULL, 'BNAANNG06980D PROTEIN', 251290),
(411617, 'PTHR46326:SF17', NULL, NULL, NULL, NULL, 'BNAC01G19850D PROTEIN', 251290),
(411618, 'PTHR46326:SF18', NULL, NULL, NULL, NULL, 'BNAC04G22120D PROTEIN', 251290),
(411619, 'PTHR46326:SF19', NULL, NULL, NULL, NULL, 'C2H2-LIKE ZINC FINGER PROTEIN', 251290),
(411620, 'PTHR34927', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN K', 251291),
(411621, 'PTHR34927:SF1', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN K', 251291),
(411622, 'PTHR16184', NULL, NULL, NULL, NULL, 'ELONGATOR COMPLEX PROTEIN 6', 251292),
(411623, 'PTHR16184:SF6', NULL, NULL, NULL, NULL, 'ELONGATOR COMPLEX PROTEIN 6', 251292),
(411624, 'PTHR47772', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 200', 251293),
(411625, 'PTHR47772:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 200', 251293),
(411626, 'PTHR47772:SF3', NULL, NULL, NULL, NULL, 'RB-ASSOCIATED KRAB ZINC FINGER', 251293),
(411627, 'PTHR47772:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 436', 251293),
(411628, 'PTHR42808', NULL, NULL, NULL, NULL, 'HYDROXYSTEROID DEHYDROGENASE-LIKE PROTEIN 2', 251294),
(411629, 'PTHR42808:SF1', NULL, NULL, NULL, NULL, 'DEHYDROGENASES, SHORT CHAIN', 251294),
(411630, 'PTHR42808:SF3', NULL, NULL, NULL, NULL, 'HYDROXYSTEROID DEHYDROGENASE-LIKE PROTEIN 2', 251294),
(411631, 'PTHR42808:SF4', NULL, NULL, NULL, NULL, 'SHORT CHAIN DEHYDROGENASE', 251294),
(411632, 'PTHR47738', NULL, NULL, NULL, NULL, 'PTS SYSTEM FRUCTOSE-LIKE EIIA COMPONENT-RELATED', 251295),
(411633, 'PTHR47738:SF1', NULL, NULL, NULL, NULL, 'NITROGEN REGULATORY PROTEIN-RELATED', 251295),
(411634, 'PTHR47738:SF4', NULL, NULL, NULL, NULL, 'PTS SYSTEM GALACTITOL-SPECIFIC EIIA COMPONENT', 251295),
(411635, 'PTHR47738:SF2', NULL, NULL, NULL, NULL, 'PTS SYSTEM, IIA COMPONENT', 251295),
(411636, 'PTHR47738:SF3', NULL, NULL, NULL, NULL, 'PHOSPHOTRANSFERASE SYSTEM MANNITOL/FRUCTOSE-SPECIFIC IIA DOMAIN CONTAINING PROTEIN-RELATED', 251295),
(411637, 'PTHR39477', NULL, NULL, NULL, NULL, 'CHROMOSOME 8, WHOLE GENOME SHOTGUN SEQUENCE', 251296),
(411638, 'PTHR39477:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 8, WHOLE GENOME SHOTGUN SEQUENCE', 251296),
(411639, 'PTHR12817:SF3', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT 6B', 251297);
INSERT INTO "PUBLIC"."MODEL" VALUES
(411640, 'PTHR12817:SF2', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT 6A', 251297),
(411641, 'PTHR12817', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT 6B', 251297),
(411642, 'PTHR12817:SF0', NULL, NULL, NULL, NULL, 'GEO08327P1', 251297),
(411643, 'PTHR12817:SF7', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX 6B-LIKE', 251297),
(411644, 'PTHR12817:SF6', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT 6A-RELATED', 251297),
(411645, 'PTHR44102:SF4', NULL, NULL, NULL, NULL, 'PROTEIN NPGR1', 251298),
(411646, 'PTHR44102:SF10', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 251298),
(411647, 'PTHR44102:SF5', NULL, NULL, NULL, NULL, 'PROTEIN NPG1', 251298),
(411648, 'PTHR44102:SF3', NULL, NULL, NULL, NULL, 'PROTEIN MPCBP, PUTATIVE, EXPRESSED-RELATED', 251298),
(411649, 'PTHR44102:SF1', NULL, NULL, NULL, NULL, 'OS10G0471400 PROTEIN', 251298),
(411650, 'PTHR44102:SF16', NULL, NULL, NULL, NULL, 'BNAC03G24000D PROTEIN', 251298),
(411651, 'PTHR44102:SF15', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 7A-LIKE ISOFORM X1', 251298),
(411652, 'PTHR44102:SF17', NULL, NULL, NULL, NULL, '43KDA POSTSYNAPTIC PROTEIN-RELATED', 251298),
(411653, 'PTHR44102:SF12', NULL, NULL, NULL, NULL, 'PROTEIN NPGR2', 251298),
(411654, 'PTHR44102', NULL, NULL, NULL, NULL, 'PROTEIN NPG1', 251298),
(411655, 'PTHR44102:SF11', NULL, NULL, NULL, NULL, 'BNAA06G19640D PROTEIN', 251298),
(411656, 'PTHR44102:SF14', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN-CONTAINING PROTEIN-RELATED', 251298),
(411657, 'PTHR44102:SF13', NULL, NULL, NULL, NULL, 'BNAA08G13640D PROTEIN', 251298),
(411658, 'PTHR44102:SF19', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN', 251298),
(411659, 'PTHR44102:SF8', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN-CONTAINING PROTEIN-RELATED', 251298),
(411660, 'PTHR34823', NULL, NULL, NULL, NULL, 'GLCNAC-BINDING PROTEIN A', 251299),
(411661, 'PTHR34823:SF1', NULL, NULL, NULL, NULL, 'CHITIN-BINDING TYPE-4 DOMAIN-CONTAINING PROTEIN', 251299),
(411662, 'PTHR11875:SF29', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC Y-ENCODED-LIKE PROTEIN 6', 251300),
(411663, 'PTHR11875:SF49', NULL, NULL, NULL, NULL, 'PROTEIN SET', 251300),
(411664, 'PTHR11875:SF48', NULL, NULL, NULL, NULL, 'ASSEMBLY PROTEIN, PUTATIVE-RELATED', 251300),
(411665, 'PTHR11875:SF67', NULL, NULL, NULL, NULL, 'PROTEIN SET', 251300),
(411666, 'PTHR11875:SF117', NULL, NULL, NULL, NULL, 'NUCLEOSOME ASSEMBLY PROTEIN', 251300),
(411667, 'PTHR11875:SF138', NULL, NULL, NULL, NULL, 'NUCLEOSOME ASSEMBLY PROTEIN 14-LIKE ISOFORM X1', 251300),
(411668, 'PTHR11875:SF115', NULL, NULL, NULL, NULL, '', 251300),
(411669, 'PTHR11875:SF159', NULL, NULL, NULL, NULL, 'NUCLEOSOME ASSEMBLY PROTEIN C2D10.11C-RELATED', 251300),
(411670, 'PTHR11875:SF64', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC Y-ENCODED-LIKE PROTEIN 1', 251300),
(411671, 'PTHR11875:SF119', NULL, NULL, NULL, NULL, '', 251300),
(411672, 'PTHR11875:SF70', NULL, NULL, NULL, NULL, 'NAP1L1 PROTEIN', 251300),
(411673, 'PTHR11875:SF132', NULL, NULL, NULL, NULL, 'NUCLEOSOME ASSEMBLY PROTEIN 1 4', 251300),
(411674, 'PTHR11875:SF154', NULL, NULL, NULL, NULL, 'NUCLEOSOME ASSEMBLY PROTEIN (NAP)-RELATED', 251300),
(411675, 'PTHR11875:SF153', NULL, NULL, NULL, NULL, 'NUCLEOSOME ASSEMBLY PROTEIN 1 4', 251300),
(411676, 'PTHR11875:SF151', NULL, NULL, NULL, NULL, 'NUCLEOSOME ASSEMBLY PROTEIN', 251300),
(411677, 'PTHR11875:SF158', NULL, NULL, NULL, NULL, 'SET PROTEIN, PHOSPATASE 2A INHIBITOR', 251300),
(411678, 'PTHR11875', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC Y-ENCODED PROTEIN', 251300),
(411679, 'PTHR11875:SF157', NULL, NULL, NULL, NULL, '', 251300),
(411680, 'PTHR11875:SF112', NULL, NULL, NULL, NULL, '', 251300),
(411681, 'PTHR11875:SF134', NULL, NULL, NULL, NULL, 'SET PROTEIN, PHOSPATASE 2A INHIBITOR', 251300),
(411682, 'PTHR11875:SF156', NULL, NULL, NULL, NULL, 'LRRGT00073-RELATED', 251300),
(411683, 'PTHR11875:SF155', NULL, NULL, NULL, NULL, '', 251300),
(411684, 'PTHR11875:SF38', NULL, NULL, NULL, NULL, 'NUCLEOSOME ASSEMBLY PROTEIN 1-LIKE 3', 251300);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(411685, 'PTHR11875:SF36', NULL, NULL, NULL, NULL, 'NUCLEOSOME ASSEMBLY PROTEIN 1-LIKE 2', 251300),
(411686, 'PTHR11875:SF12', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC Y-ENCODED PROTEIN 1-RELATED', 251300),
(411687, 'PTHR11875:SF129', NULL, NULL, NULL, NULL, 'BNAA09G52940D PROTEIN', 251300),
(411688, 'PTHR11875:SF127', NULL, NULL, NULL, NULL, 'SET PROTEIN, PHOSPATASE 2A INHIBITOR', 251300),
(411689, 'PTHR11875:SF105', NULL, NULL, NULL, NULL, 'PROTEIN SETSIP', 251300),
(411690, 'PTHR11875:SF33', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC Y-ENCODED-LIKE PROTEIN 4', 251300),
(411691, 'PTHR11875:SF30', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC Y-ENCODED-LIKE PROTEIN 5', 251300),
(411692, 'PTHR11875:SF75', NULL, NULL, NULL, NULL, 'NUCLEOSOME ASSEMBLY PROTEIN 1-LIKE 4', 251300),
(411693, 'PTHR11875:SF72', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC Y-ENCODED-LIKE PROTEIN 2', 251300),
(411694, 'PTHR11875:SF109', NULL, NULL, NULL, NULL, 'NUCLEOSOME ASSEMBLY PROTEIN 1 2', 251300),
(411695, 'PTHR11875:SF108', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC Y-ENCODED-LIKE PROTEIN 3-RELATED', 251300),
(411696, 'PTHR11875:SF142', NULL, NULL, NULL, NULL, 'NUCLEOSOME ASSEMBLY PROTEIN 1_3', 251300),
(411697, 'PTHR11875:SF162', NULL, NULL, NULL, NULL, 'NUCLEOSOME ASSEMBLY PROTEIN 1_4', 251300),
(411698, 'PTHR11875:SF125', NULL, NULL, NULL, NULL, 'BNAA09G44140D PROTEIN', 251300),
(411699, 'PTHR11875:SF5', NULL, NULL, NULL, NULL, 'PROTEIN SET HOMOLOG', 251300),
(411700, 'PTHR11875:SF123', NULL, NULL, NULL, NULL, 'BNAA06G12980D PROTEIN', 251300),
(411701, 'PTHR11875:SF145', NULL, NULL, NULL, NULL, 'NUCLEOSOME ASSEMBLY PROTEIN 1-LIKE 1', 251300),
(411702, 'PTHR11875:SF7', NULL, NULL, NULL, NULL, 'AT14585P-RELATED', 251300),
(411703, 'PTHR11875:SF144', NULL, NULL, NULL, NULL, '', 251300),
(411704, 'PTHR11875:SF122', NULL, NULL, NULL, NULL, 'NAP1-RELATED PROTEIN 1', 251300),
(411705, 'PTHR11875:SF161', NULL, NULL, NULL, NULL, 'NUCLEOSOME ASSEMBLY PROTEIN 1_2', 251300),
(411706, 'PTHR11875:SF160', NULL, NULL, NULL, NULL, 'NAP1-RELATED PROTEIN 1-RELATED', 251300),
(411707, 'PTHR11575:SF46', NULL, NULL, NULL, NULL, 'PROTEIN USHA', 251301),
(411708, 'PTHR11575:SF24', NULL, NULL, NULL, NULL, '5''-NUCLEOTIDASE', 251301),
(411709, 'PTHR11575:SF22', NULL, NULL, NULL, NULL, 'METALLOPHOS DOMAIN-CONTAINING PROTEIN', 251301),
(411710, 'PTHR11575:SF23', NULL, NULL, NULL, NULL, '5-NUCLEOTIDASE FAMILY PROTEIN', 251301),
(411711, 'PTHR11575:SF48', NULL, NULL, NULL, NULL, '5'' NUCLEOTIDASE, ECTO-LIKE', 251301),
(411712, 'PTHR11575:SF49', NULL, NULL, NULL, NULL, 'PHOSPHOPROTEIN PHOSPHATASE', 251301),
(411713, 'PTHR11575:SF50', NULL, NULL, NULL, NULL, '5''-NUCLEOTIDASE', 251301),
(411714, 'PTHR11575:SF42', NULL, NULL, NULL, NULL, 'SULFUR OXIDATION PROTEIN SOXB', 251301),
(411715, 'PTHR11575:SF32', NULL, NULL, NULL, NULL, 'APYRASE-LIKE PROTEIN', 251301),
(411716, 'PTHR11575:SF43', NULL, NULL, NULL, NULL, 'SER/THR PROTEIN PHOSPHATASE FAMILY (AFU_ORTHOLOGUE AFUA_3G04160)', 251301),
(411717, 'PTHR11575:SF41', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_1G01160)-RELATED', 251301),
(411718, 'PTHR11575', NULL, NULL, NULL, NULL, '5''-NUCLEOTIDASE-RELATED', 251301),
(411719, 'PTHR11575:SF6', NULL, NULL, NULL, NULL, '2'',3''-CYCLIC-NUCLEOTIDE 2''-PHOSPHODIESTERASE/3''-NUCLEOTIDASE', 251301),
(411720, 'PTHR43507:SF12', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE CHAIN 4, CHLOROPLASTIC', 251302),
(411721, 'PTHR43507', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE CHAIN 4', 251302),
(411722, 'PTHR43507:SF19', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE CHAIN 4', 251302),
(411723, 'PTHR43507:SF4', NULL, NULL, NULL, NULL, 'PROTON-TRANSLOCATING NADH-QUINONE OXIDOREDUCTASE, CHAIN M', 251302),
(411724, 'PTHR43507:SF18', NULL, NULL, NULL, NULL, '4FE-4S FERREDOXIN-TYPE DOMAIN-CONTAINING PROTEIN', 251302),
(411725, 'PTHR43507:SF16', NULL, NULL, NULL, NULL, 'NADH-QUINONE OXIDOREDUCTASE SUBUNIT M', 251302),
(411726, 'PTHR43507:SF1', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE CHAIN 4', 251302),
(411727, 'PTHR15341', NULL, NULL, NULL, NULL, 'SUN-COR STEROID HORMONE RECEPTOR CO-REPRESSOR', 251303);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(411728, 'PTHR15341:SF3', NULL, NULL, NULL, NULL, 'NUCLEAR NUCLEIC ACID-BINDING PROTEIN C1D', 251303),
(411729, 'PTHR15341:SF5', NULL, NULL, NULL, NULL, 'NUCLEAR NUCLEIC ACID-BINDING PROTEIN C1D', 251303),
(411730, 'PTHR31580:SF6', NULL, NULL, NULL, NULL, 'OS02G0614600 PROTEIN', 251304),
(411731, 'PTHR31580:SF7', NULL, NULL, NULL, NULL, 'OS04G0505000 PROTEIN', 251304),
(411732, 'PTHR31580:SF4', NULL, NULL, NULL, NULL, 'FILAMENT-LIKE PLANT PROTEIN 6', 251304),
(411733, 'PTHR31580:SF5', NULL, NULL, NULL, NULL, 'FILAMENT-LIKE PLANT PROTEIN 1-RELATED', 251304),
(411734, 'PTHR31580:SF8', NULL, NULL, NULL, NULL, 'FILAMENT-LIKE PROTEIN (DUF869)', 251304),
(411735, 'PTHR31580:SF29', NULL, NULL, NULL, NULL, 'FILAMENT-LIKE PLANT PROTEIN', 251304),
(411736, 'PTHR31580:SF28', NULL, NULL, NULL, NULL, 'FILAMENT-LIKE PLANT PROTEIN', 251304),
(411737, 'PTHR31580:SF49', NULL, NULL, NULL, NULL, 'FILAMENT-LIKE PLANT PROTEIN 3', 251304),
(411738, 'PTHR31580:SF26', NULL, NULL, NULL, NULL, 'FILAMENT-LIKE PLANT PROTEIN 5', 251304),
(411739, 'PTHR31580:SF48', NULL, NULL, NULL, NULL, '', 251304),
(411740, 'PTHR31580:SF43', NULL, NULL, NULL, NULL, 'FILAMENT-LIKE PLANT PROTEIN 4', 251304),
(411741, 'PTHR31580:SF41', NULL, NULL, NULL, NULL, 'FILAMENT-LIKE PLANT PROTEIN 3', 251304),
(411742, 'PTHR31580:SF40', NULL, NULL, NULL, NULL, '', 251304),
(411743, 'PTHR31580:SF47', NULL, NULL, NULL, NULL, 'BNAC08G19200D PROTEIN', 251304),
(411744, 'PTHR31580:SF46', NULL, NULL, NULL, NULL, 'FILAMENT-LIKE PLANT PROTEIN-RELATED', 251304),
(411745, 'PTHR31580:SF45', NULL, NULL, NULL, NULL, 'FILAMENT-LIKE PLANT PROTEIN-RELATED', 251304),
(411746, 'PTHR31580:SF22', NULL, NULL, NULL, NULL, 'FILAMENT-LIKE PLANT PROTEIN 7', 251304),
(411747, 'PTHR31580:SF44', NULL, NULL, NULL, NULL, 'OS12G0169100 PROTEIN', 251304),
(411748, 'PTHR31580', NULL, NULL, NULL, NULL, 'FILAMENT-LIKE PLANT PROTEIN 4', 251304),
(411749, 'PTHR31580:SF39', NULL, NULL, NULL, NULL, 'FILAMENT-LIKE PLANT PROTEIN-RELATED', 251304),
(411750, 'PTHR31580:SF38', NULL, NULL, NULL, NULL, 'FILAMENT-PLANT-LIKE PROTEIN', 251304),
(411751, 'PTHR31580:SF19', NULL, NULL, NULL, NULL, 'FILAMENT-PLANT-LIKE PROTEIN', 251304),
(411752, 'PTHR31580:SF31', NULL, NULL, NULL, NULL, 'FILAMENT-LIKE PLANT PROTEIN', 251304),
(411753, 'PTHR31580:SF30', NULL, NULL, NULL, NULL, 'FILAMENT-LIKE PLANT PROTEIN 5', 251304),
(411754, 'PTHR31580:SF35', NULL, NULL, NULL, NULL, 'FILAMENT-LIKE PLANT PROTEIN-RELATED', 251304),
(411755, 'PTHR31580:SF34', NULL, NULL, NULL, NULL, 'BNACNNG56680D PROTEIN', 251304),
(411756, 'PTHR31580:SF11', NULL, NULL, NULL, NULL, 'OS07G0506600 PROTEIN', 251304),
(411757, 'PTHR15491:SF12', NULL, NULL, NULL, NULL, 'CDKN1A-INTERACTING ZINC FINGER PROTEIN 1B', 251305),
(411758, 'PTHR15491:SF13', NULL, NULL, NULL, NULL, 'CDKN1A-INTERACTING ZINC FINGER PROTEIN 1A', 251305),
(411759, 'PTHR15491:SF9', NULL, NULL, NULL, NULL, 'CIP1-INTERACTING ZINC FINGER PROTEIN', 251305),
(411760, 'PTHR15491', NULL, NULL, NULL, NULL, '', 251305),
(411761, 'PTHR15491:SF16', NULL, NULL, NULL, NULL, 'MATRIN-TYPE DOMAIN-CONTAINING PROTEIN', 251305),
(411762, 'PTHR15491:SF17', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ON ECDYSONE PUFFS', 251305),
(411763, 'PTHR38049:SF1', NULL, NULL, NULL, NULL, '', 251306),
(411764, 'PTHR38049:SF2', NULL, NULL, NULL, NULL, '', 251306),
(411765, 'PTHR38049', NULL, NULL, NULL, NULL, '', 251306),
(411766, 'PTHR20959:SF1', NULL, NULL, NULL, NULL, 'TRANSPORT AND GOLGI ORGANIZATION PROTEIN 6 HOMOLOG', 251307),
(411767, 'PTHR20959', NULL, NULL, NULL, NULL, 'TRANSPORT AND GOLGI ORGANIZATION PROTEIN 6 FAMILY MEMBER', 251307),
(411768, 'PTHR42095', NULL, NULL, NULL, NULL, 'YALI0C12166P', 251308),
(411769, 'PTHR42095:SF1', NULL, NULL, NULL, NULL, 'YALI0C12166P', 251308),
(411770, 'PTHR24328:SF7', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 251309),
(411771, 'PTHR24328:SF8', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN MOX-1', 251309),
(411772, 'PTHR24328', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN MOX', 251309),
(411773, 'PTHR24328:SF1', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN MOX-2', 251309);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(411774, 'PTHR12059:SF8', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L23', 251310),
(411775, 'PTHR12059', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L23-RELATED', 251310),
(411776, 'PTHR12059:SF7', NULL, NULL, NULL, NULL, 'BNAC07G51330D PROTEIN', 251310),
(411777, 'PTHR12059:SF5', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L23, MITOCHONDRIAL', 251310),
(411778, 'PTHR33194', NULL, NULL, NULL, NULL, 'ZINC KNUCKLE DOMAINCONTAINING PROTEIN', 251311),
(411779, 'PTHR33194:SF4', NULL, NULL, NULL, NULL, 'RETROTRANS_GAG DOMAIN-CONTAINING PROTEIN', 251311),
(411780, 'PTHR35861:SF1', NULL, NULL, NULL, NULL, 'FELS-2 PROPHAGE PROTEIN', 251312),
(411781, 'PTHR35861', NULL, NULL, NULL, NULL, '', 251312),
(411782, 'PTHR35861:SF2', NULL, NULL, NULL, NULL, 'FELS-2 PROPHAGE PROTEIN', 251312),
(411783, 'PTHR23547', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY DOMAIN, GENERAL SUBSTRATE TRANSPORTER', 251313),
(411784, 'PTHR23547:SF1', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY MFS_1', 251313),
(411785, 'PTHR36309', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 251314),
(411786, 'PTHR36309:SF1', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 251314),
(411787, 'PTHR36309:SF5', NULL, NULL, NULL, NULL, 'RNA-BINDING REGION RNP-1 (RNA RECOGNITION MOTIF)', 251314),
(411788, 'PTHR36309:SF3', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 251314),
(411789, 'PTHR36309:SF6', NULL, NULL, NULL, NULL, 'OS02G0669700 PROTEIN', 251314),
(411790, 'PTHR42307', NULL, NULL, NULL, NULL, 'PUP DEAMIDASE/DEPUPYLASE', 251315),
(411791, 'PTHR42307:SF3', NULL, NULL, NULL, NULL, 'PUP--PROTEIN LIGASE', 251315),
(411792, 'PTHR42307:SF2', NULL, NULL, NULL, NULL, 'PUP DEAMIDASE/DEPUPYLASE', 251315),
(411793, 'PTHR33602', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN RECX FAMILY PROTEIN', 251316),
(411794, 'PTHR33602:SF1', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN RECX FAMILY PROTEIN', 251316),
(411795, 'PTHR46702', NULL, NULL, NULL, NULL, 'DNA LIGASE (DUF1666)-RELATED', 251317),
(411796, 'PTHR46702:SF8', NULL, NULL, NULL, NULL, 'DUF1666 FAMILY PROTEIN', 251317),
(411797, 'PTHR46702:SF6', NULL, NULL, NULL, NULL, 'BNAC03G41500D PROTEIN', 251317),
(411798, 'PTHR46702:SF2', NULL, NULL, NULL, NULL, 'DNA LIGASE (DUF1666)', 251317),
(411799, 'PTHR46702:SF1', NULL, NULL, NULL, NULL, 'DUF1666 FAMILY PROTEIN (DUF1666)', 251317),
(411800, 'PTHR10871:SF4', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE 6 SUBUNIT B', 251318),
(411801, 'PTHR10871:SF1', NULL, NULL, NULL, NULL, '37S RIBOSOMAL PROTEIN SWS2, MITOCHONDRIAL', 251318),
(411802, 'PTHR10871:SF3', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S18', 251318),
(411803, 'PTHR10871:SF42', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S18', 251318),
(411804, 'PTHR10871:SF21', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S18', 251318),
(411805, 'PTHR10871:SF32', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S18', 251318),
(411806, 'PTHR10871:SF43', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S18-LIKE', 251318),
(411807, 'PTHR10871:SF28', NULL, NULL, NULL, NULL, 'SMALL RIBOSOMAL SUBUNIT PROTEIN S13, MITOCHONDRIAL', 251318),
(411808, 'PTHR10871:SF39', NULL, NULL, NULL, NULL, '', 251318),
(411809, 'PTHR10871', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S13/40S RIBOSOMAL PROTEIN S18', 251318),
(411810, 'PTHR10871:SF37', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S18-LIKE', 251318),
(411811, 'PTHR10871:SF38', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L3', 251318),
(411812, 'PTHR10871:SF46', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S18', 251318),
(411813, 'PTHR10871:SF8', NULL, NULL, NULL, NULL, 'OS12G0424300 PROTEIN', 251318),
(411814, 'PTHR10871:SF47', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S13-RELATED', 251318),
(411815, 'PTHR10871:SF44', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S18', 251318),
(411816, 'PTHR10871:SF33', NULL, NULL, NULL, NULL, 'BNAC06G07900D PROTEIN', 251318),
(411817, 'PTHR10871:SF45', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S18', 251318),
(411818, 'PTHR11043:SF30', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT ZETA', 251319);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(411819, 'PTHR11043:SF20', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT ZETA', 251319),
(411820, 'PTHR11043:SF31', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT ZETA-2', 251319),
(411821, 'PTHR11043:SF22', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT ZETA', 251319),
(411822, 'PTHR11043:SF25', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT ZETA-2', 251319),
(411823, 'PTHR11043:SF4', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT ZETA-2', 251319),
(411824, 'PTHR11043:SF8', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT ZETA', 251319),
(411825, 'PTHR11043:SF26', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT ZETA-3', 251319),
(411826, 'PTHR11043:SF28', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT ZETA', 251319),
(411827, 'PTHR11043:SF17', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT ZETA-3', 251319),
(411828, 'PTHR11043:SF18', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT ZETA', 251319),
(411829, 'PTHR11043:SF29', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT ZETA', 251319),
(411830, 'PTHR11043:SF19', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT ZETA', 251319),
(411831, 'PTHR11043:SF1', NULL, NULL, NULL, NULL, 'TSET COMPLEX MEMBER TSTD', 251319),
(411832, 'PTHR11043:SF0', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT ZETA', 251319),
(411833, 'PTHR11043', NULL, NULL, NULL, NULL, 'ZETA-COAT PROTEIN', 251319),
(411834, 'PTHR11043:SF3', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT ZETA-A-RELATED', 251319),
(411835, 'PTHR11043:SF2', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT ZETA-1', 251319),
(411836, 'PTHR32119', NULL, NULL, NULL, NULL, 'OROTIDINE 5''-PHOSPHATE DECARBOXYLASE', 251320),
(411837, 'PTHR32119:SF2', NULL, NULL, NULL, NULL, 'OROTIDINE 5''-PHOSPHATE DECARBOXYLASE', 251320),
(411838, 'PTHR14195', NULL, NULL, NULL, NULL, 'G PATCH DOMAIN CONTAINING PROTEIN 2', 251321),
(411839, 'PTHR14195:SF4', NULL, NULL, NULL, NULL, 'G PATCH DOMAIN-CONTAINING PROTEIN 2', 251321),
(411840, 'PTHR14195:SF3', NULL, NULL, NULL, NULL, 'G PATCH DOMAIN-CONTAINING PROTEIN 2-LIKE', 251321),
(411841, 'PTHR14195:SF2', NULL, NULL, NULL, NULL, 'GH10944P', 251321),
(411842, 'PTHR28216:SF1', NULL, NULL, NULL, NULL, 'DASH COMPLEX SUBUNIT DUO1', 251322),
(411843, 'PTHR28216', NULL, NULL, NULL, NULL, 'DASH COMPLEX SUBUNIT DUO1', 251322),
(411844, 'PTHR47521:SF16', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS E (EPSILON)', 251323),
(411845, 'PTHR47521:SF12', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS E (EPSILON)', 251323),
(411846, 'PTHR47521:SF8', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR F27E5.5-RELATED', 251323),
(411847, 'PTHR47521:SF9', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 HEME-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 251323),
(411848, 'PTHR47521', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS E (EPSILON)-RELATED', 251323),
(411849, 'PTHR47521:SF7', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS EPSILON-6', 251323),
(411850, 'PTHR47521:SF5', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS E (EPSILON)-RELATED', 251323),
(411851, 'PTHR47521:SF18', NULL, NULL, NULL, NULL, 'PROTEIN CBG01451', 251323),
(411852, 'PTHR47521:SF17', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS E (EPSILON)', 251323),
(411853, 'PTHR43173', NULL, NULL, NULL, NULL, 'ABC1 FAMILY PROTEIN', 251324),
(411854, 'PTHR43173:SF20', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251324),
(411855, 'PTHR43173:SF42', NULL, NULL, NULL, NULL, 'ABC1 DOMAIN-CONTAINING PROTEIN', 251324),
(411856, 'PTHR43173:SF3', NULL, NULL, NULL, NULL, 'ABC1 FAMILY PROTEIN', 251324),
(411857, 'PTHR43173:SF41', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE ABKB-RELATED', 251324),
(411858, 'PTHR43173:SF33', NULL, NULL, NULL, NULL, 'ASCUS WALL ENDO-1,3-ALPHA-GLUCANASE-RELATED', 251324),
(411859, 'PTHR43173:SF22', NULL, NULL, NULL, NULL, 'ABC1 DOMAIN-CONTAINING PROTEIN', 251324),
(411860, 'PTHR43173:SF21', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE FAMILY 71 PROTEIN', 251324),
(411861, 'PTHR43173:SF32', NULL, NULL, NULL, NULL, '', 251324),
(411862, 'PTHR43173:SF10', NULL, NULL, NULL, NULL, 'ALPHA 1,3 GLUCANASE, GH71 FAMILY (EUROFUNG)-RELATED', 251324),
(411863, 'PTHR43173:SF24', NULL, NULL, NULL, NULL, 'ABC1 DOMAIN-CONTAINING PROTEIN', 251324); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(411864, 'PTHR43173:SF12', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 251324),
(411865, 'PTHR43173:SF34', NULL, NULL, NULL, NULL, 'ABC1 DOMAIN-CONTAINING PROTEIN', 251324),
(411866, 'PTHR43173:SF23', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251324),
(411867, 'PTHR43173:SF37', NULL, NULL, NULL, NULL, 'ABC1 FAMILY PROTEIN C10F6.14C', 251324),
(411868, 'PTHR43173:SF36', NULL, NULL, NULL, NULL, 'ALPHA 1,3 GLUCANASE GH71 (EUROFUNG)-RELATED', 251324),
(411869, 'PTHR43173:SF25', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251324),
(411870, 'PTHR43173:SF39', NULL, NULL, NULL, NULL, 'ABC1 DOMAIN-CONTAINING PROTEIN', 251324),
(411871, 'PTHR43173:SF28', NULL, NULL, NULL, NULL, 'AARF DOMAIN-CONTAINING KINASE 5', 251324),
(411872, 'PTHR43173:SF16', NULL, NULL, NULL, NULL, 'ALPHA 1,3 GLUCANASE, GH71 FAMILY (EUROFUNG)-RELATED', 251324),
(411873, 'PTHR43173:SF38', NULL, NULL, NULL, NULL, '', 251324),
(411874, 'PTHR43173:SF19', NULL, NULL, NULL, NULL, 'AARF DOMAIN-CONTAINING PROTEIN KINASE 1', 251324),
(411875, 'PTHR42852:SF4', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE PROTEIN HI_1115', 251325),
(411876, 'PTHR42852:SF12', NULL, NULL, NULL, NULL, 'THIOL-DISULFIDE OXIDOREDUCTASE YKUV', 251325),
(411877, 'PTHR42852:SF6', NULL, NULL, NULL, NULL, 'THIOL:DISULFIDE INTERCHANGE PROTEIN DSBE', 251325),
(411878, 'PTHR42852:SF13', NULL, NULL, NULL, NULL, 'PROTEIN DIPZ', 251325),
(411879, 'PTHR42852:SF10', NULL, NULL, NULL, NULL, 'BACTERIOFERRITIN COMIGRATORY PROTEIN', 251325),
(411880, 'PTHR42852:SF1', NULL, NULL, NULL, NULL, 'SPORULATION THIOL-DISULFIDE OXIDOREDUCTASE A', 251325),
(411881, 'PTHR42852:SF16', NULL, NULL, NULL, NULL, 'THIOL:DISULFIDE INTERCHANGE PROTEIN TLPA', 251325),
(411882, 'PTHR42852', NULL, NULL, NULL, NULL, 'THIOL:DISULFIDE INTERCHANGE PROTEIN DSBE', 251325),
(411883, 'PTHR37202:SF2', NULL, NULL, NULL, NULL, '', 251326),
(411884, 'PTHR37202:SF1', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT PROTEIN', 251326),
(411885, 'PTHR37202', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT PROTEIN', 251326),
(411886, 'PTHR28678:SF1', NULL, NULL, NULL, NULL, 'CODANIN-1', 251327),
(411887, 'PTHR28678', NULL, NULL, NULL, NULL, 'CODANIN-1', 251327),
(411888, 'PTHR13396:SF3', NULL, NULL, NULL, NULL, 'NEDD4 FAMILY-INTERACTING PROTEIN 1', 251328),
(411889, 'PTHR13396:SF4', NULL, NULL, NULL, NULL, 'NEDD4 FAMILY-INTERACTING PROTEIN 2', 251328),
(411890, 'PTHR13396:SF5', NULL, NULL, NULL, NULL, 'NEDD4 FAMILY INTERACTING PROTEIN', 251328),
(411891, 'PTHR13396', NULL, NULL, NULL, NULL, 'NEDD4 FAMILY INTERACTING PROTEIN 1/2', 251328),
(411892, 'PTHR46098', NULL, NULL, NULL, NULL, 'TRNA (CYTOSINE(38)-C(5))-METHYLTRANSFERASE', 251329),
(411893, 'PTHR46098:SF1', NULL, NULL, NULL, NULL, 'TRNA (CYTOSINE(38)-C(5))-METHYLTRANSFERASE', 251329),
(411894, 'PTHR33324:SF2', NULL, NULL, NULL, NULL, 'HTH CENPB-TYPE DOMAIN-CONTAINING PROTEIN', 251330),
(411895, 'PTHR33324', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251330),
(411896, 'PTHR44259:SF71', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 251331),
(411897, 'PTHR44259:SF68', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 251331),
(411898, 'PTHR44259:SF4', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251331),
(411899, 'PTHR44259:SF67', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251331),
(411900, 'PTHR44259:SF23', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', 251331),
(411901, 'PTHR44259:SF22', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251331),
(411902, 'PTHR44259:SF66', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251331),
(411903, 'PTHR44259:SF1', NULL, NULL, NULL, NULL, 'OS06G0659700 PROTEIN', 251331),
(411904, 'PTHR44259:SF65', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 251331),
(411905, 'PTHR44259:SF62', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 251331),
(411906, 'PTHR44259:SF61', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE', 251331),
(411907, 'PTHR44259:SF29', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251331);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(411908, 'PTHR44259:SF28', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251331),
(411909, 'PTHR44259:SF27', NULL, NULL, NULL, NULL, '', 251331),
(411910, 'PTHR44259:SF26', NULL, NULL, NULL, NULL, 'F-BOX FAMILY PROTEIN-LIKE PROTEIN', 251331),
(411911, 'PTHR44259:SF25', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251331),
(411912, 'PTHR44259:SF69', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251331),
(411913, 'PTHR44259:SF81', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 251331),
(411914, 'PTHR44259:SF80', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 251331),
(411915, 'PTHR44259:SF101', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 251331),
(411916, 'PTHR44259:SF100', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE', 251331),
(411917, 'PTHR44259:SF103', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN', 251331),
(411918, 'PTHR44259:SF102', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 251331),
(411919, 'PTHR44259:SF79', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN-RELATED', 251331),
(411920, 'PTHR44259:SF105', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 251331),
(411921, 'PTHR44259:SF104', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN (DUF295)-RELATED', 251331),
(411922, 'PTHR44259:SF34', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 251331),
(411923, 'PTHR44259:SF77', NULL, NULL, NULL, NULL, 'OS04G0563401 PROTEIN', 251331),
(411924, 'PTHR44259:SF106', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 251331),
(411925, 'PTHR44259:SF76', NULL, NULL, NULL, NULL, 'OS04G0627800 PROTEIN', 251331),
(411926, 'PTHR44259:SF32', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 251331),
(411927, 'PTHR44259:SF31', NULL, NULL, NULL, NULL, 'F-BOX FAMILY PROTEIN', 251331),
(411928, 'PTHR44259:SF30', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN', 251331),
(411929, 'PTHR44259:SF74', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251331),
(411930, 'PTHR44259:SF73', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN (DUF295)', 251331),
(411931, 'PTHR44259:SF38', NULL, NULL, NULL, NULL, 'OS08G0164100 PROTEIN', 251331),
(411932, 'PTHR44259:SF37', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 251331),
(411933, 'PTHR44259:SF93', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF295)-RELATED', 251331),
(411934, 'PTHR44259:SF92', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF295)-RELATED', 251331),
(411935, 'PTHR44259:SF91', NULL, NULL, NULL, NULL, 'OS01G0183800 PROTEIN', 251331),
(411936, 'PTHR44259:SF90', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 251331),
(411937, 'PTHR44259:SF89', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN-RELATED', 251331),
(411938, 'PTHR44259:SF88', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN', 251331),
(411939, 'PTHR44259:SF87', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251331),
(411940, 'PTHR44259:SF43', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 251331),
(411941, 'PTHR44259:SF83', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN', 251331),
(411942, 'PTHR44259', NULL, NULL, NULL, NULL, 'OS07G0183000 PROTEIN-RELATED', 251331),
(411943, 'PTHR44259:SF57', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 251331),
(411944, 'PTHR44259:SF99', NULL, NULL, NULL, NULL, 'OS01G0942200 PROTEIN', 251331),
(411945, 'PTHR44259:SF98', NULL, NULL, NULL, NULL, 'BNAC04G11310D PROTEIN', 251331),
(411946, 'PTHR44259:SF97', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 251331),
(411947, 'PTHR44259:SF96', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SKIP23-LIKE', 251331),
(411948, 'PTHR44259:SF52', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE', 251331),
(411949, 'PTHR44259:SF95', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 251331),
(411950, 'PTHR44259:SF94', NULL, NULL, NULL, NULL, 'OS06G0707300 PROTEIN', 251331),
(411951, 'PTHR44259:SF17', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SKIP23-LIKE', 251331);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(411952, 'PTHR44259:SF16', NULL, NULL, NULL, NULL, 'OS01G0327900 PROTEIN', 251331),
(411953, 'PTHR44259:SF59', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', 251331),
(411954, 'PTHR44259:SF15', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN KIB2-RELATED', 251331),
(411955, 'PTHR44259:SF14', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251331),
(411956, 'PTHR28314:SF1', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 29', 251332),
(411957, 'PTHR28314', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 29', 251332),
(411958, 'PTHR41339', NULL, NULL, NULL, NULL, 'LIPL48', 251333),
(411959, 'PTHR41339:SF1', NULL, NULL, NULL, NULL, 'LIPL48', 251333),
(411960, 'PTHR21342:SF0', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL NMN ADENYLYLTRANSFERASE/NUDIX HYDROLASE', 251334),
(411961, 'PTHR21342:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOPANTETHEINE ADENYLYLTRANSFERASE', 251334),
(411962, 'PTHR21342', NULL, NULL, NULL, NULL, 'PHOSPHOPANTETHEINE ADENYLYLTRANSFERASE', 251334),
(411963, 'PTHR36075:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251335),
(411964, 'PTHR36075:SF1', NULL, NULL, NULL, NULL, 'BNAA10G09820D PROTEIN', 251335),
(411965, 'PTHR36075', NULL, NULL, NULL, NULL, 'BNAA10G09820D PROTEIN', 251335),
(411966, 'PTHR46500:SF1', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 221', 251336),
(411967, 'PTHR46500', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 221', 251336),
(411968, 'PTHR44340:SF1', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 10', 251337),
(411969, 'PTHR44340', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 10', 251337),
(411970, 'PTHR31792:SF10', NULL, NULL, NULL, NULL, 'VACUOLAR ATPASE ASSEMBLY INTEGRAL MEMBRANE PROTEIN VMA21 HOMOLOG', 251338),
(411971, 'PTHR31792:SF8', NULL, NULL, NULL, NULL, 'VACUOLAR ATPASE ASSEMBLY INTEGRAL MEMBRANE PROTEIN VMA21 HOMOLOG', 251338),
(411972, 'PTHR31792:SF6', NULL, NULL, NULL, NULL, 'VACUOLAR ATPASE ASSEMBLY INTEGRAL MEMBRANE PROTEIN VMA21 HOMOLOG', 251338),
(411973, 'PTHR31792:SF4', NULL, NULL, NULL, NULL, 'VACUOLAR ATPASE ASSEMBLY INTEGRAL MEMBRANE PROTEIN VMA21 HOMOLOG', 251338),
(411974, 'PTHR31792:SF3', NULL, NULL, NULL, NULL, 'VACUOLAR ATPASE ASSEMBLY INTEGRAL MEMBRANE PROTEIN VMA21', 251338),
(411975, 'PTHR31792', NULL, NULL, NULL, NULL, 'VACUOLAR ATPASE ASSEMBLY INTEGRAL MEMBRANE PROTEIN VMA21', 251338),
(411976, 'PTHR13547:SF7', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P', 251339),
(411977, 'PTHR13547', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 251339),
(411978, 'PTHR13547:SF18', NULL, NULL, NULL, NULL, '', 251339),
(411979, 'PTHR13547:SF19', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P', 251339),
(411980, 'PTHR13547:SF20', NULL, NULL, NULL, NULL, 'PROTEINACEOUS RNASE P 3', 251339),
(411981, 'PTHR13547:SF13', NULL, NULL, NULL, NULL, 'PROTEINACEOUS RNASE P 2', 251339),
(411982, 'PTHR13547:SF10', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 251339),
(411983, 'PTHR13547:SF21', NULL, NULL, NULL, NULL, 'PRORP DOMAIN-CONTAINING PROTEIN', 251339),
(411984, 'PTHR13547:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBONUCLEASE P CATALYTIC SUBUNIT', 251339),
(411985, 'PTHR22611', NULL, NULL, NULL, NULL, 'PROTEIN NAKED CUTICLE', 251340),
(411986, 'PTHR22611:SF2', NULL, NULL, NULL, NULL, 'PROTEIN NAKED CUTICLE HOMOLOG 1', 251340),
(411987, 'PTHR22611:SF1', NULL, NULL, NULL, NULL, 'PROTEIN NAKED CUTICLE HOMOLOG 2', 251340),
(411988, 'PTHR22611:SF9', NULL, NULL, NULL, NULL, 'PROTEIN NAKED CUTICLE', 251340),
(411989, 'PTHR31791:SF65', NULL, NULL, NULL, NULL, 'FRIGIDA-LIKE PROTEIN', 251341),
(411990, 'PTHR31791:SF64', NULL, NULL, NULL, NULL, 'FRIGIDA-LIKE PROTEIN', 251341),
(411991, 'PTHR31791:SF45', NULL, NULL, NULL, NULL, 'FRIGIDA-LIKE PROTEIN', 251341),
(411992, 'PTHR31791:SF67', NULL, NULL, NULL, NULL, 'OS03G0587600 PROTEIN', 251341),
(411993, 'PTHR31791:SF44', NULL, NULL, NULL, NULL, 'FRIGIDA-LIKE PROTEIN', 251341),
(411994, 'PTHR31791:SF66', NULL, NULL, NULL, NULL, 'FRIGIDA-LIKE PROTEIN', 251341),
(411995, 'PTHR31791:SF47', NULL, NULL, NULL, NULL, 'INACTIVE FRIGIDA-LIKE PROTEIN 2', 251341);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(411996, 'PTHR31791:SF68', NULL, NULL, NULL, NULL, 'FRIGIDA-LIKE PROTEIN', 251341),
(411997, 'PTHR31791:SF49', NULL, NULL, NULL, NULL, 'INACTIVE PROTEIN FRIGIDA', 251341),
(411998, 'PTHR31791:SF61', NULL, NULL, NULL, NULL, 'BNAA09G03630D PROTEIN', 251341),
(411999, 'PTHR31791:SF60', NULL, NULL, NULL, NULL, 'FRIGIDA-LIKE PROTEIN 5', 251341),
(412000, 'PTHR31791:SF63', NULL, NULL, NULL, NULL, 'FRIGIDA-LIKE PROTEIN', 251341),
(412001, 'PTHR31791:SF41', NULL, NULL, NULL, NULL, 'FRIGIDA-LIKE PROTEIN', 251341),
(412002, 'PTHR31791:SF10', NULL, NULL, NULL, NULL, 'FRIGIDA-LIKE PROTEIN', 251341),
(412003, 'PTHR31791:SF32', NULL, NULL, NULL, NULL, 'FRIGIDA-LIKE PROTEIN', 251341),
(412004, 'PTHR31791:SF76', NULL, NULL, NULL, NULL, 'BNAANNG09750D PROTEIN', 251341),
(412005, 'PTHR31791:SF2', NULL, NULL, NULL, NULL, 'FRIGIDA-LIKE PROTEIN 4A-RELATED', 251341),
(412006, 'PTHR31791:SF75', NULL, NULL, NULL, NULL, 'FRIGIDA-LIKE PROTEIN', 251341),
(412007, 'PTHR31791:SF34', NULL, NULL, NULL, NULL, 'FRIGIDA-LIKE PROTEIN', 251341),
(412008, 'PTHR31791:SF4', NULL, NULL, NULL, NULL, 'FRIGIDA-LIKE PROTEIN 3-RELATED', 251341),
(412009, 'PTHR31791:SF33', NULL, NULL, NULL, NULL, '', 251341),
(412010, 'PTHR31791:SF77', NULL, NULL, NULL, NULL, 'PROTEIN ZIP4 HOMOLOG', 251341),
(412011, 'PTHR31791:SF57', NULL, NULL, NULL, NULL, 'FRIGIDA-LIKE PROTEIN', 251341),
(412012, 'PTHR31791:SF9', NULL, NULL, NULL, NULL, 'FRIGIDA-LIKE PROTEIN', 251341),
(412013, 'PTHR31791:SF38', NULL, NULL, NULL, NULL, 'FRIGIDA-LIKE PROTEIN', 251341),
(412014, 'PTHR31791:SF37', NULL, NULL, NULL, NULL, 'A_TM021B04.7 PROTEIN', 251341),
(412015, 'PTHR31791', NULL, NULL, NULL, NULL, 'FRIGIDA-LIKE PROTEIN 3-RELATED', 251341),
(412016, 'PTHR31791:SF70', NULL, NULL, NULL, NULL, 'FRIGIDA-LIKE PROTEIN', 251341),
(412017, 'PTHR31791:SF72', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN DDB_G0290503-RELATED', 251341),
(412018, 'PTHR31791:SF71', NULL, NULL, NULL, NULL, 'FRIGIDA-LIKE PROTEIN', 251341),
(412019, 'PTHR31791:SF74', NULL, NULL, NULL, NULL, 'FRIGIDA-LIKE PROTEIN 1', 251341),
(412020, 'PTHR31791:SF51', NULL, NULL, NULL, NULL, 'FRIGIDA-LIKE PROTEIN', 251341),
(412021, 'PTHR31791:SF73', NULL, NULL, NULL, NULL, 'FRIGIDA-LIKE PROTEIN', 251341),
(412022, 'PTHR35517', NULL, NULL, NULL, NULL, 'PROTEIN ARGININE N-METHYLTRANSFERASE SFM1', 251342),
(412023, 'PTHR35517:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ARGININE N-METHYLTRANSFERASE SFM1', 251342),
(412024, 'PTHR42146', NULL, NULL, NULL, NULL, '3'',5''-CYCLIC-NUCLEOTIDE PHOSPHODIESTERASE', 251343),
(412025, 'PTHR42146:SF1', NULL, NULL, NULL, NULL, 'OLIGORIBONUCLEASE NRNB', 251343),
(412026, 'PTHR48258:SF1', NULL, NULL, NULL, NULL, 'DUF4218 DOMAIN-CONTAINING PROTEIN', 251344),
(412027, 'PTHR48258', NULL, NULL, NULL, NULL, 'DUF4218 DOMAIN-CONTAINING PROTEIN-RELATED', 251344),
(412028, 'PTHR48258:SF2', NULL, NULL, NULL, NULL, 'OS01G0348150 PROTEIN', 251344),
(412029, 'PTHR40201:SF1', NULL, NULL, NULL, NULL, 'OSMIOPHILIC BODY PROTEIN G377', 251345),
(412030, 'PTHR40201', NULL, NULL, NULL, NULL, 'OSMIOPHILIC BODY PROTEIN', 251345),
(412031, 'PTHR28647:SF2', NULL, NULL, NULL, NULL, 'UNIQUE CARTILAGE MATRIX-ASSOCIATED PROTEIN', 251346),
(412032, 'PTHR28647', NULL, NULL, NULL, NULL, 'UNIQUE CARTILAGE MATRIX-ASSOCIATED PROTEIN', 251346),
(412033, 'PTHR23089:SF49', NULL, NULL, NULL, NULL, 'BLR5135 PROTEIN', 251347),
(412034, 'PTHR23089:SF18', NULL, NULL, NULL, NULL, 'HISTIDINE TRIAD NUCLEOTIDE-BINDING PROTEIN 2, MITOCHONDRIAL', 251347),
(412035, 'PTHR23089:SF40', NULL, NULL, NULL, NULL, 'ADENYLYLSULFATASE HINT1', 251347),
(412036, 'PTHR23089:SF41', NULL, NULL, NULL, NULL, 'HIT DOMAIN-CONTAINING PROTEIN', 251347),
(412037, 'PTHR23089', NULL, NULL, NULL, NULL, 'HISTIDINE TRIAD  HIT  PROTEIN', 251347),
(412038, 'PTHR23089:SF33', NULL, NULL, NULL, NULL, 'HISTIDINE TRIAD NUCLEOTIDE-BINDING PROTEIN 1', 251347),
(412039, 'PTHR23089:SF45', NULL, NULL, NULL, NULL, 'HISTIDINE TRIAD NUCLEOTIDE-BINDING PROTEIN 1', 251347),
(412040, 'PTHR23089:SF46', NULL, NULL, NULL, NULL, 'ADENYLYLSULFATASE HINT1', 251347),
(412041, 'PTHR23089:SF47', NULL, NULL, NULL, NULL, 'HIT DOMAIN-CONTAINING PROTEIN', 251347);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(412042, 'PTHR23089:SF48', NULL, NULL, NULL, NULL, 'HIT DOMAIN-CONTAINING PROTEIN', 251347),
(412043, 'PTHR13019:SF17', NULL, NULL, NULL, NULL, 'GOLGI APPARATUS MEMBRANE PROTEIN TVP23', 251348),
(412044, 'PTHR13019:SF26', NULL, NULL, NULL, NULL, 'GOLGI APPARATUS MEMBRANE PROTEIN TVP23', 251348),
(412045, 'PTHR13019:SF7', NULL, NULL, NULL, NULL, 'GOLGI APPARATUS MEMBRANE PROTEIN TVP23', 251348),
(412046, 'PTHR13019:SF25', NULL, NULL, NULL, NULL, 'GOLGI APPARATUS MEMBRANE PROTEIN TVP23 HOMOLOG', 251348),
(412047, 'PTHR13019', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 251348),
(412048, 'PTHR13019:SF9', NULL, NULL, NULL, NULL, 'GOLGI APPARATUS MEMBRANE PROTEIN TVP23 HOMOLOG B', 251348),
(412049, 'PTHR13019:SF18', NULL, NULL, NULL, NULL, 'GOLGI APPARATUS MEMBRANE PROTEIN TVP23 HOMOLOG A', 251348),
(412050, 'PTHR13019:SF23', NULL, NULL, NULL, NULL, 'GOLGI APPARATUS MEMBRANE PROTEIN TVP23 HOMOLOG C', 251348),
(412051, 'PTHR13019:SF22', NULL, NULL, NULL, NULL, 'GOLGI APPARATUS MEMBRANE PROTEIN TVP23', 251348),
(412052, 'PTHR13019:SF21', NULL, NULL, NULL, NULL, 'GOLGI APPARATUS MEMBRANE PROTEIN TVP23', 251348),
(412053, 'PTHR46239', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RAD51 HOMOLOG 3 RAD51C', 251349),
(412054, 'PTHR46239:SF1', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RAD51 HOMOLOG 3', 251349),
(412055, 'PTHR39609:SF2', NULL, NULL, NULL, NULL, '', 251350),
(412056, 'PTHR39609', NULL, NULL, NULL, NULL, 'RFEG-RELATED', 251350),
(412057, 'PTHR39609:SF1', NULL, NULL, NULL, NULL, 'RFEG', 251350),
(412058, 'PTHR12751:SF7', NULL, NULL, NULL, NULL, 'PHOSPHATASE AND ACTIN REGULATOR 3', 251351),
(412059, 'PTHR12751:SF19', NULL, NULL, NULL, NULL, 'PHOSPHATASE AND ACTIN REGULATOR', 251351),
(412060, 'PTHR12751:SF18', NULL, NULL, NULL, NULL, 'PROTEIN AFR1-RELATED', 251351),
(412061, 'PTHR12751:SF5', NULL, NULL, NULL, NULL, 'PHOSPHATASE AND ACTIN REGULATOR 2', 251351),
(412062, 'PTHR12751:SF6', NULL, NULL, NULL, NULL, 'PHOSPHATASE AND ACTIN REGULATOR 1', 251351),
(412063, 'PTHR12751:SF4', NULL, NULL, NULL, NULL, 'PHOSPHATASE AND ACTIN REGULATOR 4', 251351),
(412064, 'PTHR12751', NULL, NULL, NULL, NULL, 'PHOSPHATASE AND ACTIN REGULATOR  PHACTR', 251351),
(412065, 'PTHR42717', NULL, NULL, NULL, NULL, 'DIHYDROOROTASE-RELATED', 251352),
(412066, 'PTHR42717:SF1', NULL, NULL, NULL, NULL, 'DIHYDROOROTASE-RELATED', 251352),
(412067, 'PTHR14273', NULL, NULL, NULL, NULL, 'LYR MOTIF-CONTAINING PROTEIN 1', 251353),
(412068, 'PTHR14273:SF0', NULL, NULL, NULL, NULL, 'LYR MOTIF-CONTAINING PROTEIN 1', 251353),
(412069, 'PTHR47001', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH121', 251354),
(412070, 'PTHR47001:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH11', 251354),
(412071, 'PTHR47001:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH121', 251354),
(412072, 'PTHR19957:SF349', NULL, NULL, NULL, NULL, 'SYNTAXIN OF PLANTS 122 PROTEIN', 251355),
(412073, 'PTHR19957:SF228', NULL, NULL, NULL, NULL, 'SYNTAXIN-31', 251355),
(412074, 'PTHR19957:SF90', NULL, NULL, NULL, NULL, 'SYNTAXIN-7', 251355),
(412075, 'PTHR19957:SF80', NULL, NULL, NULL, NULL, 'SYNTAXIN-121', 251355),
(412076, 'PTHR19957:SF340', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 251355),
(412077, 'PTHR19957:SF83', NULL, NULL, NULL, NULL, 'SYNTAXIN-16', 251355),
(412078, 'PTHR19957:SF84', NULL, NULL, NULL, NULL, 'SYNTAXIN-1A', 251355),
(412079, 'PTHR19957:SF104', NULL, NULL, NULL, NULL, 'SYNTAXIN-6', 251355),
(412080, 'PTHR19957:SF88', NULL, NULL, NULL, NULL, 'SYNTAXIN-12', 251355),
(412081, 'PTHR19957:SF224', NULL, NULL, NULL, NULL, 'HL02043P', 251355),
(412082, 'PTHR19957:SF345', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 251355),
(412083, 'PTHR19957:SF106', NULL, NULL, NULL, NULL, 'SYNTAXIN-10', 251355),
(412084, 'PTHR19957:SF342', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 251355),
(412085, 'PTHR19957:SF223', NULL, NULL, NULL, NULL, 'ZGC:165520', 251355),
(412086, 'PTHR19957:SF19', NULL, NULL, NULL, NULL, 'SYNTAXIN-4', 251355);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(412087, 'PTHR19957:SF339', NULL, NULL, NULL, NULL, 'SYNTAXIN-22', 251355),
(412088, 'PTHR19957:SF338', NULL, NULL, NULL, NULL, 'SYNTAXIN-51-RELATED', 251355),
(412089, 'PTHR19957:SF91', NULL, NULL, NULL, NULL, 'SYNTAXIN-112', 251355),
(412090, 'PTHR19957:SF296', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 251355),
(412091, 'PTHR19957:SF295', NULL, NULL, NULL, NULL, 'SYNTAXIN VAM3', 251355),
(412092, 'PTHR19957:SF97', NULL, NULL, NULL, NULL, 'SYNTAXIN-4', 251355),
(412093, 'PTHR19957:SF334', NULL, NULL, NULL, NULL, 'SYNTAXIN-1B', 251355),
(412094, 'PTHR19957:SF337', NULL, NULL, NULL, NULL, 'SYNTAXIN-41-RELATED', 251355),
(412095, 'PTHR19957:SF216', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 251355),
(412096, 'PTHR19957:SF331', NULL, NULL, NULL, NULL, 'SYNTAXIN-51-LIKE', 251355),
(412097, 'PTHR19957:SF212', NULL, NULL, NULL, NULL, 'T-SNARE DOMAIN-CONTAINING PROTEIN 1', 251355),
(412098, 'PTHR19957:SF409', NULL, NULL, NULL, NULL, 'SYNTAXIN-RELATED PROTEIN NT-SYR1', 251355),
(412099, 'PTHR19957:SF408', NULL, NULL, NULL, NULL, 'SYNTAXIN-3-RELATED', 251355),
(412100, 'PTHR19957:SF405', NULL, NULL, NULL, NULL, 'SYNTAXIN 6', 251355),
(412101, 'PTHR19957:SF404', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 251355),
(412102, 'PTHR19957:SF407', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 251355),
(412103, 'PTHR19957:SF406', NULL, NULL, NULL, NULL, 'T-SNARE-RELATED', 251355),
(412104, 'PTHR19957:SF3', NULL, NULL, NULL, NULL, 'SYNTAXIN-5', 251355),
(412105, 'PTHR19957:SF368', NULL, NULL, NULL, NULL, 'SYNTAXIN-22-LIKE', 251355),
(412106, 'PTHR19957:SF401', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 251355),
(412107, 'PTHR19957:SF400', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 251355),
(412108, 'PTHR19957:SF403', NULL, NULL, NULL, NULL, 'OS02G0209900 PROTEIN', 251355),
(412109, 'PTHR19957:SF402', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 251355),
(412110, 'PTHR19957:SF124', NULL, NULL, NULL, NULL, 'SYNTAXIN-71', 251355),
(412111, 'PTHR19957:SF244', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 251355),
(412112, 'PTHR19957:SF123', NULL, NULL, NULL, NULL, 'SYNTAXIN-112', 251355),
(412113, 'PTHR19957:SF230', NULL, NULL, NULL, NULL, 'OS03G0121450 PROTEIN', 251355),
(412114, 'PTHR19957:SF351', NULL, NULL, NULL, NULL, 'SYNTAXIN OF PLANTS 32-RELATED', 251355),
(412115, 'PTHR19957:SF350', NULL, NULL, NULL, NULL, 'SYNTAXIN OF PLANTS 21-RELATED', 251355),
(412116, 'PTHR19957:SF72', NULL, NULL, NULL, NULL, 'SYNTAXIN-3-LIKE', 251355),
(412117, 'PTHR19957:SF78', NULL, NULL, NULL, NULL, 'SYNTAXIN-7B-RELATED', 251355),
(412118, 'PTHR19957:SF113', NULL, NULL, NULL, NULL, 'SYNTAXIN-2-RELATED', 251355),
(412119, 'PTHR19957:SF307', NULL, NULL, NULL, NULL, 'SYNTAXIN-1A', 251355),
(412120, 'PTHR19957:SF382', NULL, NULL, NULL, NULL, 'SNARE, PUTATIVE-RELATED', 251355),
(412121, 'PTHR19957:SF381', NULL, NULL, NULL, NULL, 'SYNTAXIN OF PLANTS 122 PROTEIN', 251355),
(412122, 'PTHR19957:SF384', NULL, NULL, NULL, NULL, 'T-SNARE-RELATED', 251355),
(412123, 'PTHR19957:SF263', NULL, NULL, NULL, NULL, 'SYNTAXIN-72', 251355),
(412124, 'PTHR19957:SF383', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 251355),
(412125, 'PTHR19957:SF380', NULL, NULL, NULL, NULL, 'SYNTAXIN FAMILY PROTEIN', 251355),
(412126, 'PTHR19957:SF269', NULL, NULL, NULL, NULL, 'SYNTAXIN-122', 251355),
(412127, 'PTHR19957:SF389', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 251355),
(412128, 'PTHR19957:SF303', NULL, NULL, NULL, NULL, 'SYNTAXIN-132-LIKE', 251355),
(412129, 'PTHR19957:SF386', NULL, NULL, NULL, NULL, 'SYNTAXIN PROTEIN', 251355),
(412130, 'PTHR19957:SF264', NULL, NULL, NULL, NULL, 'SYNTAXIN-73', 251355),
(412131, 'PTHR19957:SF385', NULL, NULL, NULL, NULL, 'SYNTAXIN 10', 251355),
(412132, 'PTHR19957:SF388', NULL, NULL, NULL, NULL, 'SYNTAXIN-LIKE PROTEIN FSV1', 251355);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(412133, 'PTHR19957:SF300', NULL, NULL, NULL, NULL, 'T-SNARE-RELATED', 251355),
(412134, 'PTHR19957:SF267', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 251355),
(412135, 'PTHR19957:SF387', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 251355),
(412136, 'PTHR19957:SF266', NULL, NULL, NULL, NULL, 'OS12G0192300 PROTEIN', 251355),
(412137, 'PTHR19957:SF251', NULL, NULL, NULL, NULL, 'SYNTAXIN-RELATED PROTEIN KNOLLE', 251355),
(412138, 'PTHR19957:SF379', NULL, NULL, NULL, NULL, 'OS11G0168100 PROTEIN', 251355),
(412139, 'PTHR19957:SF136', NULL, NULL, NULL, NULL, 'NOVEL PROTEIN (ZGC:77855)-RELATED', 251355),
(412140, 'PTHR19957:SF378', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 251355),
(412141, 'PTHR19957:SF257', NULL, NULL, NULL, NULL, 'SNARE COMPLEX SUBUNIT VAM7 (EUROFUNG)-RELATED', 251355),
(412142, 'PTHR19957:SF139', NULL, NULL, NULL, NULL, 'SYNTAXIN-17', 251355),
(412143, 'PTHR19957:SF135', NULL, NULL, NULL, NULL, 'OS02G0702800 PROTEIN', 251355),
(412144, 'PTHR19957:SF377', NULL, NULL, NULL, NULL, 'SYNTAXIN-124-LIKE', 251355),
(412145, 'PTHR19957:SF327', NULL, NULL, NULL, NULL, 'SYNTAXIN-124-LIKE', 251355),
(412146, 'PTHR19957:SF282', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 251355),
(412147, 'PTHR19957:SF285', NULL, NULL, NULL, NULL, 'SYNTAXIN-8', 251355),
(412148, 'PTHR19957:SF324', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 251355),
(412149, 'PTHR19957:SF323', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 251355),
(412150, 'PTHR19957:SF287', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 251355),
(412151, 'PTHR19957:SF286', NULL, NULL, NULL, NULL, 'SYNN DOMAIN-CONTAINING PROTEIN', 251355),
(412152, 'PTHR19957:SF29', NULL, NULL, NULL, NULL, 'SYNTAXIN-19', 251355),
(412153, 'PTHR19957', NULL, NULL, NULL, NULL, 'SYNTAXIN', 251355),
(412154, 'PTHR19957:SF319', NULL, NULL, NULL, NULL, 'SYNTAXIN-131-RELATED', 251355),
(412155, 'PTHR19957:SF393', NULL, NULL, NULL, NULL, 'OS08G0277900 PROTEIN', 251355),
(412156, 'PTHR19957:SF392', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 251355),
(412157, 'PTHR19957:SF395', NULL, NULL, NULL, NULL, 'SYNTAXIN-123', 251355),
(412158, 'PTHR19957:SF394', NULL, NULL, NULL, NULL, 'SYNTAXIN 13', 251355),
(412159, 'PTHR19957:SF30', NULL, NULL, NULL, NULL, 'SYNTAXIN-11', 251355),
(412160, 'PTHR19957:SF391', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 251355),
(412161, 'PTHR19957:SF390', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 251355),
(412162, 'PTHR19957:SF313', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 251355),
(412163, 'PTHR19957:SF34', NULL, NULL, NULL, NULL, 'SYNTAXIN-3', 251355),
(412164, 'PTHR19957:SF279', NULL, NULL, NULL, NULL, 'SYNTAXIN-52-LIKE', 251355),
(412165, 'PTHR19957:SF314', NULL, NULL, NULL, NULL, 'SYNTAXIN-124-RELATED', 251355),
(412166, 'PTHR19957:SF36', NULL, NULL, NULL, NULL, 'SYNTAXIN-2', 251355),
(412167, 'PTHR19957:SF397', NULL, NULL, NULL, NULL, 'SYNTAXIN-42', 251355),
(412168, 'PTHR19957:SF396', NULL, NULL, NULL, NULL, 'SYNTAXIN OF PLANTS 43-RELATED', 251355),
(412169, 'PTHR19957:SF38', NULL, NULL, NULL, NULL, 'LD23667P', 251355),
(412170, 'PTHR19957:SF278', NULL, NULL, NULL, NULL, 'SYNTAXIN-22-LIKE', 251355),
(412171, 'PTHR19957:SF399', NULL, NULL, NULL, NULL, 'SYNTAXIN-132', 251355),
(412172, 'PTHR19957:SF311', NULL, NULL, NULL, NULL, 'BNAC05G30860D PROTEIN', 251355),
(412173, 'PTHR19957:SF398', NULL, NULL, NULL, NULL, 'SYNTAXIN-23-RELATED', 251355),
(412174, 'PTHR19957:SF277', NULL, NULL, NULL, NULL, 'OS06G0168500 PROTEIN', 251355),
(412175, 'PTHR19957:SF310', NULL, NULL, NULL, NULL, 'SYNTAXIN-4-RELATED', 251355),
(412176, 'PTHR10108:SF1080', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412177, 'PTHR10108:SF984', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE PMT21-RELATED', 251356);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(412178, 'PTHR10108:SF1083', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE PMT4-RELATED', 251356),
(412179, 'PTHR10108:SF1082', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412180, 'PTHR10108:SF1162', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412181, 'PTHR10108:SF1085', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412182, 'PTHR10108:SF1084', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412183, 'PTHR10108:SF1161', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412184, 'PTHR10108:SF1120', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE PMT8-RELATED', 251356),
(412185, 'PTHR10108:SF1164', NULL, NULL, NULL, NULL, 'OS01G0883900 PROTEIN', 251356),
(412186, 'PTHR10108:SF1163', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412187, 'PTHR10108', NULL, NULL, NULL, NULL, 'SAM-DEPENDENT METHYLTRANSFERASE', 251356),
(412188, 'PTHR10108:SF1111', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412189, 'PTHR10108:SF1154', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412190, 'PTHR10108:SF1077', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE PMT27-RELATED', 251356),
(412191, 'PTHR10108:SF37', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE PMT6-RELATED', 251356),
(412192, 'PTHR10108:SF1110', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412193, 'PTHR10108:SF1113', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412194, 'PTHR10108:SF1157', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412195, 'PTHR10108:SF1156', NULL, NULL, NULL, NULL, 'BNAA06G23180D PROTEIN', 251356),
(412196, 'PTHR10108:SF1112', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412197, 'PTHR10108:SF1159', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412198, 'PTHR10108:SF1115', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412199, 'PTHR10108:SF1158', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412200, 'PTHR10108:SF1117', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412201, 'PTHR10108:SF1119', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE PMT2-RELATED', 251356),
(412202, 'PTHR10108:SF979', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE PMT11-RELATED', 251356),
(412203, 'PTHR10108:SF899', NULL, NULL, NULL, NULL, 'PECTIN METHYLTRANSFERASE QUA2-RELATED', 251356),
(412204, 'PTHR10108:SF1072', NULL, NULL, NULL, NULL, 'PMT16, PUTATIVE-RELATED', 251356),
(412205, 'PTHR10108:SF1151', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412206, 'PTHR10108:SF1150', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412207, 'PTHR10108:SF1153', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412208, 'PTHR10108:SF1152', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE PMT1-RELATED', 251356),
(412209, 'PTHR10108:SF1144', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE PMT10-RELATED', 251356),
(412210, 'PTHR10108:SF1069', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE PMT17-RELATED', 251356),
(412211, 'PTHR10108:SF1102', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE PMT28-RELATED', 251356),
(412212, 'PTHR10108:SF1101', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412213, 'PTHR10108:SF1145', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412214, 'PTHR10108:SF1104', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE PMT14-RELATED', 251356),
(412215, 'PTHR10108:SF1148', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE PMT23-RELATED', 251356),
(412216, 'PTHR10108:SF1103', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE PMT9-RELATED', 251356),
(412217, 'PTHR10108:SF1106', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE PMT26-RELATED', 251356),
(412218, 'PTHR10108:SF1149', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412219, 'PTHR10108:SF1105', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412220, 'PTHR10108:SF1108', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412221, 'PTHR10108:SF1107', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412222, 'PTHR10108:SF1109', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE PMT20-RELATED', 251356),
(412223, 'PTHR10108:SF968', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE PMT19-RELATED', 251356);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(412224, 'PTHR10108:SF1061', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412225, 'PTHR10108:SF887', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE PMT22-RELATED', 251356),
(412226, 'PTHR10108:SF1142', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412227, 'PTHR10108:SF763', NULL, NULL, NULL, NULL, 'PECTIN METHYLTRANSFERASE QUA3-RELATED', 251356),
(412228, 'PTHR10108:SF1141', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE PMT24-RELATED', 251356),
(412229, 'PTHR10108:SF1064', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412230, 'PTHR10108:SF1133', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412231, 'PTHR10108:SF1132', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412232, 'PTHR10108:SF1135', NULL, NULL, NULL, NULL, 'BNAA09G26820D PROTEIN', 251356),
(412233, 'PTHR10108:SF1058', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE PMT18-RELATED', 251356),
(412234, 'PTHR10108:SF1136', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412235, 'PTHR10108:SF1059', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE PMT15-RELATED', 251356),
(412236, 'PTHR10108:SF1139', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412237, 'PTHR10108:SF1138', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412238, 'PTHR10108:SF1092', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412239, 'PTHR10108:SF1091', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE PMT12-RELATED', 251356),
(412240, 'PTHR10108:SF1170', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412241, 'PTHR10108:SF1096', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE PMT16-RELATED', 251356),
(412242, 'PTHR10108:SF1095', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE, EXPRESSED-RELATED', 251356),
(412243, 'PTHR10108:SF1051', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412244, 'PTHR10108:SF1098', NULL, NULL, NULL, NULL, 'PMT26-LIKE PROTEIN, PUTATIVE-RELATED', 251356),
(412245, 'PTHR10108:SF1130', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE PMT26-RELATED', 251356),
(412246, 'PTHR10108:SF1166', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412247, 'PTHR10108:SF1089', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412248, 'PTHR10108:SF1088', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412249, 'PTHR10108:SF1121', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412250, 'PTHR10108:SF1165', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412251, 'PTHR10108:SF1168', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE PMT7-RELATED', 251356),
(412252, 'PTHR10108:SF1167', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE PMT25-RELATED', 251356),
(412253, 'PTHR10108:SF1123', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412254, 'PTHR10108:SF1049', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412255, 'PTHR10108:SF1126', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412256, 'PTHR10108:SF1169', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412257, 'PTHR10108:SF1128', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412258, 'PTHR10108:SF1129', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 251356),
(412259, 'PTHR31398:SF1', NULL, NULL, NULL, NULL, '', 251357),
(412260, 'PTHR31398:SF0', NULL, NULL, NULL, NULL, 'MEIOTIC NUCLEAR DIVISION PROTEIN 1 HOMOLOG', 251357),
(412261, 'PTHR31398', NULL, NULL, NULL, NULL, 'MEIOTIC NUCLEAR DIVISION PROTEIN 1 HOMOLOG', 251357),
(412262, 'PTHR21250:SF0', NULL, NULL, NULL, NULL, 'PRE-RRNA-PROCESSING PROTEIN TSR2 HOMOLOG', 251358),
(412263, 'PTHR21250', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 251358),
(412264, 'PTHR21250:SF6', NULL, NULL, NULL, NULL, 'PRE-RRNA-PROCESSING PROTEIN TSR2', 251358),
(412265, 'PTHR38088', NULL, NULL, NULL, NULL, 'UCP029143 FAMILY PROTEIN', 251359),
(412266, 'PTHR38088:SF2', NULL, NULL, NULL, NULL, 'UCP029143 FAMILY PROTEIN', 251359),
(412267, 'PTHR30337:SF7', NULL, NULL, NULL, NULL, 'PHOSPHOESTERASE', 251360),
(412268, 'PTHR30337', NULL, NULL, NULL, NULL, 'COMPONENT OF ATP-DEPENDENT DSDNA EXONUCLEASE', 251360),
(412269, 'PTHR30337:SF0', NULL, NULL, NULL, NULL, 'NUCLEASE SBCCD SUBUNIT D', 251360);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(412270, 'PTHR34596', NULL, NULL, NULL, NULL, 'CHITOPORIN', 251361),
(412271, 'PTHR34596:SF2', NULL, NULL, NULL, NULL, 'CHITOPORIN', 251361),
(412272, 'PTHR45815', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE A6', 251362),
(412273, 'PTHR45815:SF2', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE', 251362),
(412274, 'PTHR45815:SF3', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE A6', 251362),
(412275, 'PTHR45815:SF6', NULL, NULL, NULL, NULL, 'YALI0E02420P', 251362),
(412276, 'PTHR45815:SF7', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE LIKE 2-2', 251362),
(412277, 'PTHR45815:SF5', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 251362),
(412278, 'PTHR34477:SF5', NULL, NULL, NULL, NULL, 'BSL5627 PROTEIN', 251363),
(412279, 'PTHR34477:SF1', NULL, NULL, NULL, NULL, 'UPF0213 PROTEIN YHBQ', 251363),
(412280, 'PTHR34477', NULL, NULL, NULL, NULL, 'UPF0213 PROTEIN YHBQ', 251363),
(412281, 'PTHR47810:SF5', NULL, NULL, NULL, NULL, 'LIGASE, PUTATIVE-RELATED', 251364),
(412282, 'PTHR47810:SF3', NULL, NULL, NULL, NULL, 'LIGASE, PUTATIVE-RELATED', 251364),
(412283, 'PTHR47810:SF1', NULL, NULL, NULL, NULL, 'DNA LIGASE B', 251364),
(412284, 'PTHR47810', NULL, NULL, NULL, NULL, 'DNA LIGASE', 251364),
(412285, 'PTHR13073', NULL, NULL, NULL, NULL, 'BLOC-1 COMPLEX SUBUNIT 1', 251365),
(412286, 'PTHR13073:SF0', NULL, NULL, NULL, NULL, 'BIOGENESIS OF LYSOSOME-RELATED ORGANELLES COMPLEX 1 SUBUNIT 1', 251365),
(412287, 'PTHR23312:SF8', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING PROTEIN 5', 251366),
(412288, 'PTHR23312', NULL, NULL, NULL, NULL, 'ARMC5  ARMADILLO REPEAT-CONTAINING -RELATED', 251366),
(412289, 'PTHR33675:SF10', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR FAMILY 2 GROUP C PROTEIN', 251367),
(412290, 'PTHR33675:SF7', NULL, NULL, NULL, NULL, 'HOLOCARBOXYLASE SYNTHETASE', 251367),
(412291, 'PTHR33675:SF8', NULL, NULL, NULL, NULL, '', 251367),
(412292, 'PTHR33675:SF9', NULL, NULL, NULL, NULL, '', 251367),
(412293, 'PTHR33675:SF4', NULL, NULL, NULL, NULL, '', 251367),
(412294, 'PTHR33675:SF5', NULL, NULL, NULL, NULL, 'OS09G0360400 PROTEIN', 251367),
(412295, 'PTHR33675:SF6', NULL, NULL, NULL, NULL, 'OS01G0182500 PROTEIN', 251367),
(412296, 'PTHR33675', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR FAMILY 2 GROUP C PROTEIN', 251367),
(412297, 'PTHR33675:SF1', NULL, NULL, NULL, NULL, 'HOLOCARBOXYLASE SYNTHETASE', 251367),
(412298, 'PTHR31749:SF3', NULL, NULL, NULL, NULL, 'KINETOCHORE-ASSOCIATED PROTEIN NSL1 HOMOLOG', 251368),
(412299, 'PTHR31749', NULL, NULL, NULL, NULL, 'KINETOCHORE-ASSOCIATED PROTEIN NSL1 HOMOLOG', 251368),
(412300, 'PTHR30293:SF0', NULL, NULL, NULL, NULL, 'NITROGEN ASSIMILATION REGULATORY PROTEIN NAC', 251369),
(412301, 'PTHR30293:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR PROTEIN NHAR', 251369),
(412302, 'PTHR30293', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN NAC-RELATED', 251369),
(412303, 'PTHR34659:SF12', NULL, NULL, NULL, NULL, 'SERINE-RICH REPEAT PROTEIN', 251370),
(412304, 'PTHR34659:SF6', NULL, NULL, NULL, NULL, 'MUCIN-RELATED', 251370),
(412305, 'PTHR34659', NULL, NULL, NULL, NULL, 'BNAA05G11610D PROTEIN', 251370),
(412306, 'PTHR34659:SF10', NULL, NULL, NULL, NULL, 'BNAA04G28730D PROTEIN', 251370),
(412307, 'PTHR34659:SF8', NULL, NULL, NULL, NULL, 'BNAA05G11610D PROTEIN', 251370),
(412308, 'PTHR34659:SF4', NULL, NULL, NULL, NULL, '', 251370),
(412309, 'PTHR34659:SF14', NULL, NULL, NULL, NULL, '', 251370),
(412310, 'PTHR34659:SF5', NULL, NULL, NULL, NULL, '', 251370),
(412311, 'PTHR34659:SF13', NULL, NULL, NULL, NULL, '', 251370),
(412312, 'PTHR34659:SF1', NULL, NULL, NULL, NULL, 'PROTEIN EGT2', 251370),
(412313, 'PTHR13161:SF15', NULL, NULL, NULL, NULL, 'SPLICING FACTOR, SUPPRESSOR OF WHITE-APRICOT HOMOLOG', 251371),
(412314, 'PTHR13161', NULL, NULL, NULL, NULL, 'SPLICING FACTOR  SUPPRESSOR OF WHITE APRICOT', 251371),
(412315, 'PTHR13161:SF4', NULL, NULL, NULL, NULL, 'CLK4-ASSOCIATING SERINE/ARGININE RICH PROTEIN', 251371),
(412316, 'PTHR33712', NULL, NULL, NULL, NULL, 'LIGHT-INDEPENDENT PROTOCHLOROPHYLLIDE REDUCTASE SUBUNIT B', 251372);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(412317, 'PTHR33712:SF7', NULL, NULL, NULL, NULL, 'LIGHT-INDEPENDENT PROTOCHLOROPHYLLIDE REDUCTASE SUBUNIT B', 251372),
(412318, 'PTHR11009:SF28', NULL, NULL, NULL, NULL, 'DERLIN-2.1', 251373),
(412319, 'PTHR11009:SF29', NULL, NULL, NULL, NULL, 'DERLIN', 251373),
(412320, 'PTHR11009:SF4', NULL, NULL, NULL, NULL, 'DERLIN-3', 251373),
(412321, 'PTHR11009:SF5', NULL, NULL, NULL, NULL, 'DERLIN-2', 251373),
(412322, 'PTHR11009:SF36', NULL, NULL, NULL, NULL, 'DERLIN', 251373),
(412323, 'PTHR11009:SF25', NULL, NULL, NULL, NULL, 'RHOMBOID-LIKE PROTEIN 15', 251373),
(412324, 'PTHR11009:SF14', NULL, NULL, NULL, NULL, 'DERLIN-2 HOMOLOG-RELATED', 251373),
(412325, 'PTHR11009:SF37', NULL, NULL, NULL, NULL, 'DERLIN', 251373),
(412326, 'PTHR11009:SF26', NULL, NULL, NULL, NULL, 'DERLIN', 251373),
(412327, 'PTHR11009:SF27', NULL, NULL, NULL, NULL, 'DERLIN', 251373),
(412328, 'PTHR11009:SF31', NULL, NULL, NULL, NULL, 'RHOMBOID DOMAIN-CONTAINING PROTEIN 2', 251373),
(412329, 'PTHR11009:SF32', NULL, NULL, NULL, NULL, 'DERLIN', 251373),
(412330, 'PTHR11009:SF33', NULL, NULL, NULL, NULL, 'DERLIN-2.1', 251373),
(412331, 'PTHR11009:SF34', NULL, NULL, NULL, NULL, 'DERLIN', 251373),
(412332, 'PTHR11009:SF30', NULL, NULL, NULL, NULL, 'DERLIN', 251373),
(412333, 'PTHR11009:SF0', NULL, NULL, NULL, NULL, 'DERLIN-2.2', 251373),
(412334, 'PTHR11009:SF1', NULL, NULL, NULL, NULL, 'DERLIN-1', 251373),
(412335, 'PTHR11009', NULL, NULL, NULL, NULL, 'DER1-LIKE PROTEIN, DERLIN', 251373),
(412336, 'PTHR13250', NULL, NULL, NULL, NULL, 'TF-1 CELL APOPTOSIS RELATED PROTEIN-15', 251374),
(412337, 'PTHR13250:SF1', NULL, NULL, NULL, NULL, 'PROGRAMMED CELL DEATH PROTEIN 10', 251374),
(412338, 'PTHR33450:SF37', NULL, NULL, NULL, NULL, '', 251375),
(412339, 'PTHR33450:SF2', NULL, NULL, NULL, NULL, 'OS02G0505500 PROTEIN', 251375),
(412340, 'PTHR33450:SF38', NULL, NULL, NULL, NULL, 'BNACNNG71050D PROTEIN', 251375),
(412341, 'PTHR33450:SF1', NULL, NULL, NULL, NULL, 'OS08G0539200 PROTEIN', 251375),
(412342, 'PTHR33450:SF28', NULL, NULL, NULL, NULL, '', 251375),
(412343, 'PTHR33450:SF39', NULL, NULL, NULL, NULL, 'OS09G0279200 PROTEIN', 251375),
(412344, 'PTHR33450:SF29', NULL, NULL, NULL, NULL, 'BNAC07G49270D PROTEIN', 251375),
(412345, 'PTHR33450:SF6', NULL, NULL, NULL, NULL, 'OS09G0511200 PROTEIN', 251375),
(412346, 'PTHR33450:SF4', NULL, NULL, NULL, NULL, 'DUF761 DOMAIN PROTEIN', 251375),
(412347, 'PTHR33450:SF40', NULL, NULL, NULL, NULL, '', 251375),
(412348, 'PTHR33450:SF31', NULL, NULL, NULL, NULL, 'EMB|CAB67623.1', 251375),
(412349, 'PTHR33450:SF20', NULL, NULL, NULL, NULL, 'BNAC04G23890D PROTEIN', 251375),
(412350, 'PTHR33450:SF32', NULL, NULL, NULL, NULL, 'BNAA09G02830D PROTEIN', 251375),
(412351, 'PTHR33450', NULL, NULL, NULL, NULL, 'EMB|CAB67623.1-RELATED', 251375),
(412352, 'PTHR33450:SF22', NULL, NULL, NULL, NULL, '', 251375),
(412353, 'PTHR33450:SF23', NULL, NULL, NULL, NULL, '', 251375),
(412354, 'PTHR33450:SF12', NULL, NULL, NULL, NULL, 'COTTON FIBER PROTEIN', 251375),
(412355, 'PTHR33450:SF24', NULL, NULL, NULL, NULL, 'COTTON FIBER PROTEIN', 251375),
(412356, 'PTHR33450:SF14', NULL, NULL, NULL, NULL, '', 251375),
(412357, 'PTHR33450:SF36', NULL, NULL, NULL, NULL, '', 251375),
(412358, 'PTHR43269', NULL, NULL, NULL, NULL, 'SODIUM/PROTON ANTIPORTER 1-RELATED', 251376),
(412359, 'PTHR43269:SF3', NULL, NULL, NULL, NULL, 'CITMHS DOMAIN-CONTAINING PROTEIN', 251376),
(412360, 'PTHR43269:SF2', NULL, NULL, NULL, NULL, 'SODIUM/PROTON ANTIPORTER 1-RELATED', 251376),
(412361, 'PTHR47595:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER AND SCAN DOMAIN CONTAINING 29', 251377),
(412362, 'PTHR47595', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN 14', 251377),
(412363, 'PTHR12428:SF14', NULL, NULL, NULL, NULL, 'ALBINO3-LIKE PROTEIN 1, CHLOROPLASTIC', 251378),
(412364, 'PTHR12428:SF47', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN ALBINO3, CHLOROPLASTIC', 251378),
(412365, 'PTHR12428:SF13', NULL, NULL, NULL, NULL, '', 251378),
(412366, 'PTHR12428:SF49', NULL, NULL, NULL, NULL, 'OXAA/YIDC-LIKE MEMBRANE INSERTION PROTEIN', 251378),
(412367, 'PTHR12428:SF48', NULL, NULL, NULL, NULL, 'BNAA09G28180D PROTEIN', 251378);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(412368, 'PTHR12428:SF54', NULL, NULL, NULL, NULL, 'BNAA10G27850D PROTEIN', 251378),
(412369, 'PTHR12428:SF65', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY PROTEIN COX18, MITOCHONDRIAL', 251378),
(412370, 'PTHR12428:SF64', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL INNER MEMBRANE PROTEIN OXA1-LIKE', 251378),
(412371, 'PTHR12428:SF34', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL INNER MEMBRANE PROTEIN OXA1', 251378),
(412372, 'PTHR12428:SF66', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL INNER MEMBRANE PROTEIN OXA1L', 251378),
(412373, 'PTHR12428:SF61', NULL, NULL, NULL, NULL, 'ALBINO3-LIKE PROTEIN 2, CHLOROPLASTIC', 251378),
(412374, 'PTHR12428:SF60', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL INNER MEMBRANE PROTEIN OXA1-LIKE', 251378),
(412375, 'PTHR12428:SF41', NULL, NULL, NULL, NULL, 'OS03G0116000 PROTEIN', 251378),
(412376, 'PTHR12428:SF63', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL INNER MEMBRANE PROTEIN OXA1-2', 251378),
(412377, 'PTHR12428:SF62', NULL, NULL, NULL, NULL, '', 251378),
(412378, 'PTHR12428', NULL, NULL, NULL, NULL, 'OXA1', 251378),
(412379, 'PTHR13559', NULL, NULL, NULL, NULL, 'INTRACELLULAR TRAFFIC PROTEIN-RELATED', 251379),
(412380, 'PTHR13559:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FUZZY HOMOLOG', 251379),
(412381, 'PTHR21560', NULL, NULL, NULL, NULL, 'VERY KIND PROTEIN', 251380),
(412382, 'PTHR21560:SF0', NULL, NULL, NULL, NULL, 'KINASE NON-CATALYTIC C-LOBE DOMAIN-CONTAINING PROTEIN 1', 251380),
(412383, 'PTHR46019:SF7', NULL, NULL, NULL, NULL, 'BPI FOLD-CONTAINING FAMILY B, MEMBER 5', 251381),
(412384, 'PTHR46019', NULL, NULL, NULL, NULL, 'BPI FOLD-CONTAINING FAMILY B MEMBER 4-RELATED', 251381),
(412385, 'PTHR46019:SF8', NULL, NULL, NULL, NULL, 'BPI FOLD-CONTAINING FAMILY A, MEMBER 6', 251381),
(412386, 'PTHR46019:SF5', NULL, NULL, NULL, NULL, 'BPI FOLD-CONTAINING FAMILY B MEMBER 3', 251381),
(412387, 'PTHR46019:SF4', NULL, NULL, NULL, NULL, 'BPI FOLD-CONTAINING FAMILY B MEMBER 4', 251381),
(412388, 'PTHR46019:SF1', NULL, NULL, NULL, NULL, 'BPI FOLD-CONTAINING FAMILY B MEMBER 2', 251381),
(412389, 'PTHR46019:SF2', NULL, NULL, NULL, NULL, 'BPI FOLD-CONTAINING FAMILY B MEMBER 6', 251381),
(412390, 'PTHR42809:SF3', NULL, NULL, NULL, NULL, 'FLAVODOXIN 2', 251382),
(412391, 'PTHR42809', NULL, NULL, NULL, NULL, 'FLAVODOXIN 2', 251382),
(412392, 'PTHR42809:SF1', NULL, NULL, NULL, NULL, 'FLAVODOXIN 1', 251382),
(412393, 'PTHR38831:SF2', NULL, NULL, NULL, NULL, 'TYPE II SECRETION SYSTEM PROTEIN K', 251383),
(412394, 'PTHR38831:SF1', NULL, NULL, NULL, NULL, 'TYPE II SECRETION SYSTEM PROTEIN K-RELATED', 251383),
(412395, 'PTHR38831', NULL, NULL, NULL, NULL, 'TYPE II SECRETION SYSTEM PROTEIN K', 251383),
(412396, 'PTHR34800', NULL, NULL, NULL, NULL, 'TETRAPYRROLE-BINDING PROTEIN, CHLOROPLASTIC', 251384),
(412397, 'PTHR34800:SF1', NULL, NULL, NULL, NULL, 'TETRAPYRROLE-BINDING PROTEIN, CHLOROPLASTIC', 251384),
(412398, 'PTHR47650:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 22', 251385),
(412399, 'PTHR47650', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 22', 251385),
(412400, 'PTHR11659', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA GLN  AMIDOTRANSFERASE SUBUNIT B  MITOCHONDRIAL AND PROKARYOTIC  PET112-RELATED', 251386),
(412401, 'PTHR11659:SF3', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA(GLN) AMIDOTRANSFERASE SUBUNIT B, CHLOROPLASTIC/MITOCHONDRIAL', 251386),
(412402, 'PTHR11659:SF2', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA(GLN) AMIDOTRANSFERASE SUBUNIT E', 251386),
(412403, 'PTHR11659:SF0', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA(GLN) AMIDOTRANSFERASE SUBUNIT B, MITOCHONDRIAL', 251386),
(412404, 'PTHR40469', NULL, NULL, NULL, NULL, 'SECRETED GLYCOSYL HYDROLASE', 251387),
(412405, 'PTHR40469:SF2', NULL, NULL, NULL, NULL, 'PROTEIN WITH GLUCOSE DEHYDROGENASE', 251387),
(412406, 'PTHR41335', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 251388),
(412407, 'PTHR41335:SF1', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 251388),
(412408, 'PTHR12784:SF18', NULL, NULL, NULL, NULL, 'NEURON NAVIGATOR 3', 251389),
(412409, 'PTHR12784', NULL, NULL, NULL, NULL, 'STEERIN', 251389);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(412410, 'PTHR12784:SF6', NULL, NULL, NULL, NULL, 'NEURON NAVIGATOR 2', 251389),
(412411, 'PTHR12784:SF28', NULL, NULL, NULL, NULL, 'PROTEIN SICKIE', 251389),
(412412, 'PTHR12784:SF3', NULL, NULL, NULL, NULL, 'NEURON NAVIGATOR 1', 251389),
(412413, 'PTHR15452', NULL, NULL, NULL, NULL, 'LEUKOCYTE-SPECIFIC TRANSCRIPT 1 PROTEIN', 251390),
(412414, 'PTHR15452:SF5', NULL, NULL, NULL, NULL, 'LEUKOCYTE-SPECIFIC TRANSCRIPT 1 PROTEIN', 251390),
(412415, 'PTHR11805:SF1', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH PDZ-BINDING PROTEIN', 251391),
(412416, 'PTHR11805', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH PDZ-BINDING PROTEIN', 251391),
(412417, 'PTHR14042:SF22', NULL, NULL, NULL, NULL, 'PROTEIN DOPEY-1', 251392),
(412418, 'PTHR14042:SF23', NULL, NULL, NULL, NULL, 'PROTEIN DOPEY-2', 251392),
(412419, 'PTHR14042:SF24', NULL, NULL, NULL, NULL, 'PROTEIN DOPEY-1 HOMOLOG', 251392),
(412420, 'PTHR14042', NULL, NULL, NULL, NULL, 'DOPEY-RELATED', 251392),
(412421, 'PTHR37612:SF19', NULL, NULL, NULL, NULL, 'FIBROIN HEAVY CHAIN FIB-H LIKE PROTEIN', 251393),
(412422, 'PTHR37612:SF6', NULL, NULL, NULL, NULL, 'GLYCINE-RICH CELL WALL STRUCTURAL PROTEIN 1-LIKE', 251393),
(412423, 'PTHR37612:SF21', NULL, NULL, NULL, NULL, 'GLYCINE-RICH CELL WALL STRUCTURAL PROTEIN 1-RELATED', 251393),
(412424, 'PTHR37612:SF10', NULL, NULL, NULL, NULL, 'GLYCINE-RICH CELL WALL STRUCTURAL PROTEIN 2-LIKE', 251393),
(412425, 'PTHR37612:SF20', NULL, NULL, NULL, NULL, 'PER-HEXAMER REPEAT PROTEIN 5-RELATED', 251393),
(412426, 'PTHR37612:SF16', NULL, NULL, NULL, NULL, 'OS09G0425200 PROTEIN', 251393),
(412427, 'PTHR37612:SF15', NULL, NULL, NULL, NULL, 'GLYCINE-RICH CELL WALL STRUCTURAL PROTEIN 2-LIKE', 251393),
(412428, 'PTHR37612:SF18', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN DOT1-LIKE', 251393),
(412429, 'PTHR37612:SF17', NULL, NULL, NULL, NULL, 'LYSOZYME D', 251393),
(412430, 'PTHR37612:SF12', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN', 251393),
(412431, 'PTHR37612:SF11', NULL, NULL, NULL, NULL, 'GLYCINE-RICH CELL WALL STRUCTURAL PROTEIN-LIKE', 251393),
(412432, 'PTHR37612', NULL, NULL, NULL, NULL, 'FIBROIN HEAVY CHAIN FIB-H LIKE PROTEIN', 251393),
(412433, 'PTHR37612:SF14', NULL, NULL, NULL, NULL, 'GLYCINE-RICH CELL WALL STRUCTURAL PROTEIN 2-LIKE', 251393),
(412434, 'PTHR37612:SF13', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 251393),
(412435, 'PTHR47978:SF55', NULL, NULL, NULL, NULL, '', 251394),
(412436, 'PTHR47978:SF11', NULL, NULL, NULL, NULL, 'RAB FAMILY GTPASE', 251394),
(412437, 'PTHR47978:SF33', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN-RELATED', 251394),
(412438, 'PTHR47978:SF12', NULL, NULL, NULL, NULL, 'OS03G0843100 PROTEIN', 251394),
(412439, 'PTHR47978:SF34', NULL, NULL, NULL, NULL, 'SMALL GTPASE SUPERFAMILY, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 251394),
(412440, 'PTHR47978:SF56', NULL, NULL, NULL, NULL, 'SMALL GTPASE SUPERFAMILY, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 251394),
(412441, 'PTHR47978:SF35', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA4C', 251394),
(412442, 'PTHR47978:SF57', NULL, NULL, NULL, NULL, 'RAB33B, MEMBER RAS ONCOGENE FAMILY A', 251394),
(412443, 'PTHR47978:SF58', NULL, NULL, NULL, NULL, 'OS09G0527600 PROTEIN', 251394),
(412444, 'PTHR47978', NULL, NULL, NULL, NULL, '', 251394),
(412445, 'PTHR47978:SF14', NULL, NULL, NULL, NULL, 'SGP1 MONOMERIC G-PROTEIN', 251394),
(412446, 'PTHR47978:SF51', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 251394),
(412447, 'PTHR47978:SF52', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-21', 251394),
(412448, 'PTHR47978:SF3', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA4D-LIKE', 251394),
(412449, 'PTHR47978:SF30', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-33A', 251394),
(412450, 'PTHR47978:SF53', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA2A', 251394),
(412451, 'PTHR47978:SF31', NULL, NULL, NULL, NULL, 'BNAC03G42260D PROTEIN', 251394),
(412452, 'PTHR47978:SF54', NULL, NULL, NULL, NULL, 'RAB43, MEMBER RAS ONCOGENE FAMILY', 251394),
(412453, 'PTHR47978:SF10', NULL, NULL, NULL, NULL, 'RAB FAMILY GTPASE', 251394);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(412454, 'PTHR47978:SF19', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA2C', 251394),
(412455, 'PTHR47978:SF37', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA4A', 251394),
(412456, 'PTHR47978:SF15', NULL, NULL, NULL, NULL, 'RAB GTPASE-LIKE PROTEIN A1D', 251394),
(412457, 'PTHR47978:SF38', NULL, NULL, NULL, NULL, 'OS01G0848700 PROTEIN', 251394),
(412458, 'PTHR47978:SF16', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA3', 251394),
(412459, 'PTHR47978:SF39', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN, PUTATIVE-RELATED', 251394),
(412460, 'PTHR47978:SF4', NULL, NULL, NULL, NULL, 'ZGC:101559', 251394),
(412461, 'PTHR47978:SF8', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB11D-LIKE', 251394),
(412462, 'PTHR47978:SF9', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA4B-RELATED', 251394),
(412463, 'PTHR47978:SF44', NULL, NULL, NULL, NULL, 'SEPTUM-PROMOTING GTP-BINDING PROTEIN 1-LIKE', 251394),
(412464, 'PTHR47978:SF22', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA2B', 251394),
(412465, 'PTHR47978:SF45', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB2BV', 251394),
(412466, 'PTHR47978:SF24', NULL, NULL, NULL, NULL, 'PROTEIN TEM1', 251394),
(412467, 'PTHR47978:SF46', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB11C-LIKE', 251394),
(412468, 'PTHR47978:SF25', NULL, NULL, NULL, NULL, 'OS03G0823700 PROTEIN', 251394),
(412469, 'PTHR47978:SF47', NULL, NULL, NULL, NULL, 'RAB FAMILY GTPASE', 251394),
(412470, 'PTHR47978:SF40', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-37', 251394),
(412471, 'PTHR47978:SF41', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA4D', 251394),
(412472, 'PTHR47978:SF20', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABA2A', 251394),
(412473, 'PTHR47978:SF21', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-26', 251394),
(412474, 'PTHR47978:SF43', NULL, NULL, NULL, NULL, 'SMALL GTPASE FAMILY RAB PROTEIN', 251394),
(412475, 'PTHR47978:SF26', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-33B', 251394),
(412476, 'PTHR47978:SF48', NULL, NULL, NULL, NULL, '', 251394),
(412477, 'PTHR47978:SF49', NULL, NULL, NULL, NULL, 'BNAA05G26830D PROTEIN', 251394),
(412478, 'PTHR47978:SF28', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RGP2', 251394),
(412479, 'PTHR47978:SF29', NULL, NULL, NULL, NULL, 'MONOMERIC G-PROTEIN', 251394),
(412480, 'PTHR47978:SF50', NULL, NULL, NULL, NULL, 'SEPTUM-PROMOTING GTP-BINDING PROTEIN 1-LIKE', 251394),
(412481, 'PTHR37359:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 253', 251395),
(412482, 'PTHR37359', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 253', 251395),
(412483, 'PTHR22981:SF80', NULL, NULL, NULL, NULL, 'BLR4309 PROTEIN', 251396),
(412484, 'PTHR22981:SF81', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE-RELATED', 251396),
(412485, 'PTHR22981:SF7', NULL, NULL, NULL, NULL, '3-HYDROXYISOBUTYRATE DEHYDROGENASE, MITOCHONDRIAL', 251396),
(412486, 'PTHR22981', NULL, NULL, NULL, NULL, '3-HYDROXYISOBUTYRATE DEHYDROGENASE-RELATED', 251396),
(412487, 'PTHR46438', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 251397),
(412488, 'PTHR46438:SF8', NULL, NULL, NULL, NULL, 'PHEOPHYTINASE, CHLOROPLASTIC-LIKE ISOFORM X1', 251397),
(412489, 'PTHR46438:SF9', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251397),
(412490, 'PTHR46438:SF12', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 251397),
(412491, 'PTHR46438:SF11', NULL, NULL, NULL, NULL, 'LIPASE-RELATED', 251397),
(412492, 'PTHR46438:SF7', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 251397),
(412493, 'PTHR46438:SF2', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 251397),
(412494, 'PTHR35694:SF1', NULL, NULL, NULL, NULL, 'DENEDDYLASE', 251398),
(412495, 'PTHR35694', NULL, NULL, NULL, NULL, 'DENEDDYLASE', 251398),
(412496, 'PTHR23294:SF57', NULL, NULL, NULL, NULL, 'CINA DOMAIN-CONTAINING PROTEIN', 251399),
(412497, 'PTHR23294:SF13', NULL, NULL, NULL, NULL, 'PLUGGED EXCRETORY PORE', 251399),
(412498, 'PTHR23294:SF56', NULL, NULL, NULL, NULL, '', 251399),
(412499, 'PTHR23294:SF12', NULL, NULL, NULL, NULL, 'PROTEIN CBG22453', 251399);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(412500, 'PTHR23294:SF15', NULL, NULL, NULL, NULL, 'PROTEIN CBG04461', 251399),
(412501, 'PTHR23294:SF59', NULL, NULL, NULL, NULL, 'UNC93-LIKE PROTEIN C922.05C', 251399),
(412502, 'PTHR23294:SF58', NULL, NULL, NULL, NULL, '', 251399),
(412503, 'PTHR23294:SF17', NULL, NULL, NULL, NULL, '', 251399),
(412504, 'PTHR23294:SF16', NULL, NULL, NULL, NULL, 'PROTEIN CBG01362', 251399),
(412505, 'PTHR23294:SF19', NULL, NULL, NULL, NULL, 'DUF895 DOMAIN MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_3G15000)', 251399),
(412506, 'PTHR23294:SF18', NULL, NULL, NULL, NULL, 'TRYPSIN', 251399),
(412507, 'PTHR23294', NULL, NULL, NULL, NULL, 'ET TRANSLATION PRODUCT-RELATED', 251399),
(412508, 'PTHR23294:SF50', NULL, NULL, NULL, NULL, 'PROTEIN CBG01375', 251399),
(412509, 'PTHR23294:SF53', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN', 251399),
(412510, 'PTHR23294:SF30', NULL, NULL, NULL, NULL, 'PROTEIN CBG24830', 251399),
(412511, 'PTHR23294:SF55', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G17480)-RELATED', 251399),
(412512, 'PTHR23294:SF10', NULL, NULL, NULL, NULL, 'PROTEIN CBG20324', 251399),
(412513, 'PTHR23294:SF54', NULL, NULL, NULL, NULL, 'DUF895 DOMAIN MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_8G04110)', 251399),
(412514, 'PTHR23294:SF1', NULL, NULL, NULL, NULL, '', 251399),
(412515, 'PTHR23294:SF0', NULL, NULL, NULL, NULL, 'UNC93-LIKE PROTEIN MFSD11', 251399),
(412516, 'PTHR23294:SF28', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY DOMAIN-CONTAINING 11', 251399),
(412517, 'PTHR23294:SF5', NULL, NULL, NULL, NULL, '', 251399),
(412518, 'PTHR23294:SF6', NULL, NULL, NULL, NULL, '', 251399),
(412519, 'PTHR23294:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG11284', 251399),
(412520, 'PTHR23294:SF4', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251399),
(412521, 'PTHR23294:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG21964', 251399),
(412522, 'PTHR23294:SF60', NULL, NULL, NULL, NULL, 'PROTEIN CBG01365', 251399),
(412523, 'PTHR23294:SF20', NULL, NULL, NULL, NULL, 'PROTEIN CBG07602', 251399),
(412524, 'PTHR23294:SF21', NULL, NULL, NULL, NULL, 'PROTEIN CBG15077', 251399),
(412525, 'PTHR13498:SF3', NULL, NULL, NULL, NULL, 'SPERM-ASSOCIATED ANTIGEN 7', 251400),
(412526, 'PTHR13498', NULL, NULL, NULL, NULL, 'SPERM ASSOCIATED ANTIGEN 7', 251400),
(412527, 'PTHR33974:SF2', NULL, NULL, NULL, NULL, 'VASCULAR-RELATED UNKNOWN PROTEIN 1', 251401),
(412528, 'PTHR33974:SF23', NULL, NULL, NULL, NULL, 'OS04G0627300 PROTEIN', 251401),
(412529, 'PTHR33974:SF24', NULL, NULL, NULL, NULL, '', 251401),
(412530, 'PTHR33974', NULL, NULL, NULL, NULL, 'VASCULAR-RELATED UNKNOWN PROTEIN 1-RELATED', 251401),
(412531, 'PTHR33974:SF11', NULL, NULL, NULL, NULL, 'BNAANNG18100D PROTEIN', 251401),
(412532, 'PTHR33974:SF6', NULL, NULL, NULL, NULL, 'VASCULAR-RELATED UNKNOWN PROTEIN 2', 251401),
(412533, 'PTHR33974:SF18', NULL, NULL, NULL, NULL, '', 251401),
(412534, 'PTHR33974:SF19', NULL, NULL, NULL, NULL, '', 251401),
(412535, 'PTHR33974:SF16', NULL, NULL, NULL, NULL, 'BNAA01G24920D PROTEIN', 251401),
(412536, 'PTHR33974:SF9', NULL, NULL, NULL, NULL, 'VASCULAR-RELATED UNKNOWN PROTEIN 3', 251401),
(412537, 'PTHR33974:SF17', NULL, NULL, NULL, NULL, 'BNAA05G20370D PROTEIN', 251401),
(412538, 'PTHR33974:SF25', NULL, NULL, NULL, NULL, 'SMALL PHOSPHATASE-LIKE PROTEIN 2, PUTATIVE-RELATED', 251401),
(412539, 'PTHR33974:SF14', NULL, NULL, NULL, NULL, 'BNACNNG72160D PROTEIN', 251401),
(412540, 'PTHR33974:SF15', NULL, NULL, NULL, NULL, '', 251401),
(412541, 'PTHR33974:SF26', NULL, NULL, NULL, NULL, 'VASCULAR-RELATED UNKNOWN PROTEIN 4', 251401),
(412542, 'PTHR37431:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG02014', 251402),
(412543, 'PTHR37431:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG06927', 251402),
(412544, 'PTHR37431:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG06905', 251402),
(412545, 'PTHR37431:SF6', NULL, NULL, NULL, NULL, 'PARTNER OF Y14 AND MAGO', 251402),
(412546, 'PTHR37431:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG14192', 251402),
(412547, 'PTHR37431', NULL, NULL, NULL, NULL, 'PROTEIN CBG06927', 251402),
(412548, 'PTHR47103:SF4', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN', 251403);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(412549, 'PTHR47103', NULL, NULL, NULL, NULL, '', 251403),
(412550, 'PTHR47103:SF5', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN GIS2-LIKE', 251403),
(412551, 'PTHR47103:SF6', NULL, NULL, NULL, NULL, 'OS10G0545300 PROTEIN', 251403),
(412552, 'PTHR24243:SF9', NULL, NULL, NULL, NULL, 'NEUROTENSIN RECEPTOR TYPE 1', 251404),
(412553, 'PTHR24243:SF7', NULL, NULL, NULL, NULL, 'GROWTH HORMONE SECRETAGOGUE RECEPTOR TYPE 1', 251404),
(412554, 'PTHR24243:SF3', NULL, NULL, NULL, NULL, 'MOTILIN RECEPTOR', 251404),
(412555, 'PTHR24243:SF10', NULL, NULL, NULL, NULL, 'NEUROTENSIN RECEPTOR TYPE 2', 251404),
(412556, 'PTHR24243:SF45', NULL, NULL, NULL, NULL, 'GASTRIN/CHOLECYSTOKININ TYPE B RECEPTOR', 251404),
(412557, 'PTHR24243', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR', 251404),
(412558, 'PTHR24243:SF14', NULL, NULL, NULL, NULL, 'NEUROMEDIN-U RECEPTOR 2', 251404),
(412559, 'PTHR24243:SF230', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251404),
(412560, 'PTHR24243:SF221', NULL, NULL, NULL, NULL, 'PYROKININ-1 RECEPTOR', 251404),
(412561, 'PTHR24243:SF232', NULL, NULL, NULL, NULL, 'PYROKININ 2 RECEPTOR 1-RELATED', 251404),
(412562, 'PTHR24243:SF231', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251404),
(412563, 'PTHR24243:SF224', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 19-RELATED', 251404),
(412564, 'PTHR24243:SF213', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251404),
(412565, 'PTHR24243:SF205', NULL, NULL, NULL, NULL, 'NEUROMEDIN U RECEPTOR 3', 251404),
(412566, 'PTHR24243:SF227', NULL, NULL, NULL, NULL, 'MOTILIN RECEPTOR', 251404),
(412567, 'PTHR24243:SF226', NULL, NULL, NULL, NULL, 'THYROLIBERIN RECEPTOR', 251404),
(412568, 'PTHR24243:SF207', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251404),
(412569, 'PTHR24243:SF229', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE Y RECEPTOR-LIKE PROTEIN', 251404),
(412570, 'PTHR24243:SF107', NULL, NULL, NULL, NULL, 'NEUROPEPTIDES CAPA RECEPTOR', 251404),
(412571, 'PTHR24243:SF228', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251404),
(412572, 'PTHR24243:SF109', NULL, NULL, NULL, NULL, 'NEUROMEDIN-U RECEPTOR 1', 251404),
(412573, 'PTHR24243:SF208', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251404),
(412574, 'PTHR42896:SF3', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE, EXPRESSED-RELATED', 251405),
(412575, 'PTHR42896:SF2', NULL, NULL, NULL, NULL, 'CBBY-LIKE PROTEIN', 251405),
(412576, 'PTHR42896:SF5', NULL, NULL, NULL, NULL, 'BNAA06G18890D PROTEIN', 251405),
(412577, 'PTHR42896:SF4', NULL, NULL, NULL, NULL, 'OS08G0485900 PROTEIN', 251405),
(412578, 'PTHR42896', NULL, NULL, NULL, NULL, 'XYLULOSE-1,5-BISPHOSPHATE (XUBP) PHOSPHATASE', 251405),
(412579, 'PTHR31259', NULL, NULL, NULL, NULL, 'ENDOSOME-ASSOCIATED TRAFFICKING REGULATOR 1', 251406),
(412580, 'PTHR31259:SF6', NULL, NULL, NULL, NULL, 'ENDOSOME-ASSOCIATED-TRAFFICKING REGULATOR 1', 251406),
(412581, 'PTHR31259:SF5', NULL, NULL, NULL, NULL, 'ENDOSOME-ASSOCIATED-TRAFFICKING REGULATOR 1', 251406),
(412582, 'PTHR31259:SF4', NULL, NULL, NULL, NULL, 'ENDOSOME-ASSOCIATED-TRAFFICKING REGULATOR 1', 251406),
(412583, 'PTHR31259:SF3', NULL, NULL, NULL, NULL, 'ENDOSOME-ASSOCIATED-TRAFFICKING REGULATOR 1', 251406),
(412584, 'PTHR37836', NULL, NULL, NULL, NULL, 'LMO1036 PROTEIN', 251407),
(412585, 'PTHR37836:SF2', NULL, NULL, NULL, NULL, 'LMO1036 PROTEIN', 251407),
(412586, 'PTHR40053:SF1', NULL, NULL, NULL, NULL, 'SPORULATION-CONTROL PROTEIN SPO0M', 251408),
(412587, 'PTHR40053', NULL, NULL, NULL, NULL, 'SPORULATION-CONTROL PROTEIN SPO0M', 251408),
(412588, 'PTHR30237:SF2', NULL, NULL, NULL, NULL, 'MUREIN TETRAPEPTIDE CARBOXYPEPTIDASE', 251409),
(412589, 'PTHR30237:SF4', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE-RELATED', 251409),
(412590, 'PTHR30237', NULL, NULL, NULL, NULL, 'MURAMOYLTETRAPEPTIDE CARBOXYPEPTIDASE', 251409),
(412591, 'PTHR30237:SF5', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE YOCD-RELATED', 251409),
(412592, 'PTHR11183:SF43', NULL, NULL, NULL, NULL, '', 251410);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(412593, 'PTHR11183:SF150', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 251410),
(412594, 'PTHR11183:SF44', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE:XYLAN ALPHA-GLUCURONOSYLTRANSFERASE 2', 251410),
(412595, 'PTHR11183:SF152', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE:XYLAN ALPHA-GLUCURONOSYLTRANSFERASE 1', 251410),
(412596, 'PTHR11183:SF151', NULL, NULL, NULL, NULL, 'PROTEIN CBG07620', 251410),
(412597, 'PTHR11183:SF100', NULL, NULL, NULL, NULL, 'GLYCOGENIN, ISOFORM E', 251410),
(412598, 'PTHR11183:SF147', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 251410),
(412599, 'PTHR11183:SF103', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 251410),
(412600, 'PTHR11183:SF102', NULL, NULL, NULL, NULL, 'GALACTINOL SYNTHASE 5-RELATED', 251410),
(412601, 'PTHR11183:SF105', NULL, NULL, NULL, NULL, 'GALACTINOL SYNTHASE 3', 251410),
(412602, 'PTHR11183:SF148', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 251410),
(412603, 'PTHR11183:SF106', NULL, NULL, NULL, NULL, 'GALACTINOL SYNTHASE 4', 251410),
(412604, 'PTHR11183:SF109', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 251410),
(412605, 'PTHR11183:SF98', NULL, NULL, NULL, NULL, 'OS02G0624400 PROTEIN', 251410),
(412606, 'PTHR11183:SF161', NULL, NULL, NULL, NULL, 'GALACTINOL SYNTHASE 1', 251410),
(412607, 'PTHR11183:SF163', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 251410),
(412608, 'PTHR11183:SF110', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE:XYLAN ALPHA-GLUCURONOSYLTRANSFERASE 5-RELATED', 251410),
(412609, 'PTHR11183:SF154', NULL, NULL, NULL, NULL, 'GLYCOGENIN LIKE', 251410),
(412610, 'PTHR11183:SF153', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 251410),
(412611, 'PTHR11183:SF156', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 251410),
(412612, 'PTHR11183:SF56', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE:XYLAN ALPHA-GLUCURONOSYLTRANSFERASE 3-RELATED', 251410),
(412613, 'PTHR11183:SF114', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE PGSIP8-RELATED', 251410),
(412614, 'PTHR11183:SF158', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 251410),
(412615, 'PTHR11183:SF157', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE PGSIP7-RELATED', 251410),
(412616, 'PTHR11183:SF113', NULL, NULL, NULL, NULL, 'TRANSFERASE FAMILY 8 FAMILY, PUTATIVE-RELATED', 251410),
(412617, 'PTHR11183:SF115', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 251410),
(412618, 'PTHR11183:SF118', NULL, NULL, NULL, NULL, 'GALACTINOL SYNTHASE 1', 251410),
(412619, 'PTHR11183', NULL, NULL, NULL, NULL, 'GLYCOGENIN SUBFAMILY MEMBER', 251410),
(412620, 'PTHR11183:SF60', NULL, NULL, NULL, NULL, 'GLYCOGENIN GLUCOSYLTRANSFERASE', 251410),
(412621, 'PTHR11183:SF130', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 251410),
(412622, 'PTHR11183:SF174', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 251410),
(412623, 'PTHR11183:SF63', NULL, NULL, NULL, NULL, '', 251410),
(412624, 'PTHR11183:SF173', NULL, NULL, NULL, NULL, 'ACETYLGLUCOSAMINYLTRANSFERASE', 251410),
(412625, 'PTHR11183:SF121', NULL, NULL, NULL, NULL, 'GLUCOSE N-ACETYLTRANSFERASE 1', 251410),
(412626, 'PTHR11183:SF164', NULL, NULL, NULL, NULL, 'GLYCOGENIN-1', 251410),
(412627, 'PTHR11183:SF167', NULL, NULL, NULL, NULL, 'GLYCOGENIN-2', 251410),
(412628, 'PTHR11183:SF125', NULL, NULL, NULL, NULL, '', 251410),
(412629, 'PTHR11183:SF169', NULL, NULL, NULL, NULL, '', 251410),
(412630, 'PTHR11183:SF128', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE PGSIP8-RELATED', 251410),
(412631, 'PTHR11183:SF181', NULL, NULL, NULL, NULL, 'GALACTINOL SYNTHASE 7', 251410),
(412632, 'PTHR11183:SF180', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 251410),
(412633, 'PTHR11183:SF183', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 251410),
(412634, 'PTHR11183:SF182', NULL, NULL, NULL, NULL, 'GALACTINOL SYNTHASE 2', 251410),
(412635, 'PTHR11183:SF140', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 251410),
(412636, 'PTHR11183:SF184', NULL, NULL, NULL, NULL, 'GALACTINOL SYNTHASE 10', 251410),
(412637, 'PTHR11183:SF132', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 251410),
(412638, 'PTHR11183:SF176', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 251410),
(412639, 'PTHR11183:SF175', NULL, NULL, NULL, NULL, 'GLUCURONOSYLTRANSFERASE PGSIP8', 251410); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(412640, 'PTHR11183:SF178', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 251410),
(412641, 'PTHR11183:SF177', NULL, NULL, NULL, NULL, 'UDP-GLUCURONATE:XYLAN ALPHA-GLUCURONOSYLTRANSFERASE 4-RELATED', 251410),
(412642, 'PTHR11183:SF136', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 251410),
(412643, 'PTHR11183:SF179', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 251410),
(412644, 'PTHR11183:SF137', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 251410),
(412645, 'PTHR11183:SF139', NULL, NULL, NULL, NULL, 'GALACTINOL SYNTHASE 2', 251410),
(412646, 'PTHR13382', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ATP SYNTHASE COUPLING FACTOR B', 251411),
(412647, 'PTHR13382:SF55', NULL, NULL, NULL, NULL, 'F-BOX AND LEUCINE-RICH REPEAT PROTEIN 17', 251411),
(412648, 'PTHR13382:SF33', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251411),
(412649, 'PTHR13382:SF56', NULL, NULL, NULL, NULL, 'BNAC06G40380D PROTEIN', 251411),
(412650, 'PTHR13382:SF13', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251411),
(412651, 'PTHR13382:SF35', NULL, NULL, NULL, NULL, 'AT02704P', 251411),
(412652, 'PTHR13382:SF57', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT/RNI-LIKE SUPERFAMILY PROTEIN', 251411),
(412653, 'PTHR13382:SF36', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251411),
(412654, 'PTHR13382:SF37', NULL, NULL, NULL, NULL, 'ANTAGONIST OF MITOTIC EXIT NETWORK PROTEIN 1', 251411),
(412655, 'PTHR13382:SF15', NULL, NULL, NULL, NULL, 'BNAA06G34760D PROTEIN', 251411),
(412656, 'PTHR13382:SF38', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT PROTEINS', 251411),
(412657, 'PTHR13382:SF16', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SKIP28', 251411),
(412658, 'PTHR13382:SF17', NULL, NULL, NULL, NULL, 'BNAA02G27750D PROTEIN', 251411),
(412659, 'PTHR13382:SF39', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-CONTAINING PROTEIN-RELATED', 251411),
(412660, 'PTHR13382:SF50', NULL, NULL, NULL, NULL, 'F-BOX AND LEUCINE-RICH REPEAT PROTEIN 13', 251411),
(412661, 'PTHR13382:SF51', NULL, NULL, NULL, NULL, 'TOLL-LIKE RECEPTOR 3', 251411),
(412662, 'PTHR13382:SF7', NULL, NULL, NULL, NULL, 'SCF E3 UBIQUITIN LIGASE COMPLEX F-BOX PROTEIN POF2', 251411),
(412663, 'PTHR13382:SF30', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 4-LIKE', 251411),
(412664, 'PTHR13382:SF52', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251411),
(412665, 'PTHR13382:SF31', NULL, NULL, NULL, NULL, 'BNAA06G33190D PROTEIN', 251411),
(412666, 'PTHR13382:SF53', NULL, NULL, NULL, NULL, 'OS02G0798800 PROTEIN', 251411),
(412667, 'PTHR13382:SF54', NULL, NULL, NULL, NULL, 'F-BOX AND LEUCINE-RICH REPEAT PROTEIN 16', 251411),
(412668, 'PTHR13382:SF10', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT S, MITOCHONDRIAL', 251411),
(412669, 'PTHR13382:SF22', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SKIP14', 251411),
(412670, 'PTHR13382:SF44', NULL, NULL, NULL, NULL, '', 251411),
(412671, 'PTHR13382:SF45', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 17', 251411),
(412672, 'PTHR13382:SF23', NULL, NULL, NULL, NULL, 'BNAA02G29160D PROTEIN', 251411),
(412673, 'PTHR13382:SF46', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT INHIBITOR RESPONSE 1-LIKE', 251411),
(412674, 'PTHR13382:SF47', NULL, NULL, NULL, NULL, 'F-BOX FAMILY PROTEIN', 251411),
(412675, 'PTHR13382:SF25', NULL, NULL, NULL, NULL, 'F-BOX/RNI-LIKE SUPERFAMILY PROTEIN', 251411),
(412676, 'PTHR13382:SF48', NULL, NULL, NULL, NULL, 'MIP30824P1', 251411),
(412677, 'PTHR13382:SF49', NULL, NULL, NULL, NULL, 'FI18408P1', 251411),
(412678, 'PTHR13382:SF27', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SKIP14', 251411),
(412679, 'PTHR13382:SF40', NULL, NULL, NULL, NULL, 'F-BOX/LRR-REPEAT PROTEIN 2', 251411),
(412680, 'PTHR13382:SF41', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251411),
(412681, 'PTHR13382:SF20', NULL, NULL, NULL, NULL, 'F-BOX FAMILY PROTEIN', 251411),
(412682, 'PTHR13382:SF42', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251411),
(412683, 'PTHR13382:SF43', NULL, NULL, NULL, NULL, 'RNI-LIKE SUPERFAMILY PROTEIN-RELATED', 251411),
(412684, 'PTHR13382:SF21', NULL, NULL, NULL, NULL, 'OS12G0601000 PROTEIN', 251411);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(412685, 'PTHR43727:SF1', NULL, NULL, NULL, NULL, 'CARBOXYNORSPERMIDINE/CARBOXYSPERMIDINE DECARBOXYLASE', 251412),
(412686, 'PTHR43727:SF2', NULL, NULL, NULL, NULL, 'DIAMINOPIMELATE DECARBOXYLASE 1, CHLOROPLASTIC-RELATED', 251412),
(412687, 'PTHR43727:SF3', NULL, NULL, NULL, NULL, 'DECARBOXYLASE-RELATED', 251412),
(412688, 'PTHR43727', NULL, NULL, NULL, NULL, 'DIAMINOPIMELATE DECARBOXYLASE', 251412),
(412689, 'PTHR43644:SF1', NULL, NULL, NULL, NULL, 'NAD(P)H-FLAVIN REDUCTASE', 251413),
(412690, 'PTHR43644', NULL, NULL, NULL, NULL, 'NA(+)-TRANSLOCATING NADH-QUINONE REDUCTASE SUBUNIT', 251413),
(412691, 'PTHR48147:SF4', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 251414),
(412692, 'PTHR48147:SF3', NULL, NULL, NULL, NULL, 'MYELIN TRANSCRIPTION FACTOR 1-LIKE PROTEIN', 251414),
(412693, 'PTHR48147:SF5', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 251414),
(412694, 'PTHR48147', NULL, NULL, NULL, NULL, 'PROTEIN CBG23787', 251414),
(412695, 'PTHR35905', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 251415),
(412696, 'PTHR35905:SF1', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 251415),
(412697, 'PTHR15728', NULL, NULL, NULL, NULL, 'DEADENYLATION COMPLEX CATALYTIC SUBUNIT PAN2', 251416),
(412698, 'PTHR15728:SF0', NULL, NULL, NULL, NULL, 'PAN2-PAN3 DEADENYLATION COMPLEX CATALYTIC SUBUNIT PAN2', 251416),
(412699, 'PTHR46005:SF4', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 190', 251417),
(412700, 'PTHR46005', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 190', 251417),
(412701, 'PTHR46005:SF1', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 35', 251417),
(412702, 'PTHR46005:SF2', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 5', 251417),
(412703, 'PTHR37577:SF5', NULL, NULL, NULL, NULL, '', 251418),
(412704, 'PTHR37577:SF4', NULL, NULL, NULL, NULL, '', 251418),
(412705, 'PTHR37577', NULL, NULL, NULL, NULL, '', 251418),
(412706, 'PTHR37577:SF1', NULL, NULL, NULL, NULL, '', 251418),
(412707, 'PTHR33609:SF5', NULL, NULL, NULL, NULL, 'LOW CALCIUM RESPONSE LOCUS PROTEIN S', 251419),
(412708, 'PTHR33609', NULL, NULL, NULL, NULL, 'LOW CALCIUM RESPONSE LOCUS PROTEIN S', 251419),
(412709, 'PTHR33609:SF1', NULL, NULL, NULL, NULL, 'TRANSPOSASE-RELATED', 251419),
(412710, 'PTHR46112:SF2', NULL, NULL, NULL, NULL, 'XAA-PRO AMINOPEPTIDASE P-RELATED', 251420),
(412711, 'PTHR46112:SF8', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PEPTIDASE PEPQ-RELATED', 251420),
(412712, 'PTHR46112', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE', 251420),
(412713, 'PTHR46112:SF9', NULL, NULL, NULL, NULL, 'XAA-PRO AMINOPEPTIDASE', 251420),
(412714, 'PTHR46112:SF3', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE YPDF', 251420),
(412715, 'PTHR46112:SF10', NULL, NULL, NULL, NULL, 'DIPEPTIDASE YKVY-RELATED', 251420),
(412716, 'PTHR13524:SF2', NULL, NULL, NULL, NULL, 'MYOTUBULARIN-RELATED PROTEIN 14', 251421),
(412717, 'PTHR13524:SF3', NULL, NULL, NULL, NULL, '', 251421),
(412718, 'PTHR13524', NULL, NULL, NULL, NULL, 'MYOTUBULARIN-RELATED', 251421),
(412719, 'PTHR36939', NULL, NULL, NULL, NULL, 'PROTEIN CBG03389', 251422),
(412720, 'PTHR36939:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG03389', 251422),
(412721, 'PTHR36939:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG01464', 251422),
(412722, 'PTHR36939:SF1', NULL, NULL, NULL, NULL, 'DOWNSTREAM OF DAF-NINETEEN', 251422),
(412723, 'PTHR36404:SF1', NULL, NULL, NULL, NULL, 'EMBRYO DEFECTIVE 2737', 251423),
(412724, 'PTHR36404', NULL, NULL, NULL, NULL, 'EMBRYO DEFECTIVE 2737', 251423),
(412725, 'PTHR12433:SF12', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 25', 251424),
(412726, 'PTHR12433:SF11', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 25', 251424),
(412727, 'PTHR12433:SF18', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 25', 251424),
(412728, 'PTHR12433:SF3', NULL, NULL, NULL, NULL, 'PROSTATE TUMOR-OVEREXPRESSED GENE 1 PROTEIN', 251424),
(412729, 'PTHR12433', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 25', 251424);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(412730, 'PTHR12433:SF19', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 25', 251424),
(412731, 'PTHR12433:SF10', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 25', 251424),
(412732, 'PTHR16079', NULL, NULL, NULL, NULL, 'UBIQUITIN LIGASE PROTEIN CHFR', 251425),
(412733, 'PTHR16079:SF4', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE CHFR', 251425),
(412734, 'PTHR13334', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 28S RIBOSOMAL PROTEIN S10', 251426),
(412735, 'PTHR13334:SF4', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S10, MITOCHONDRIAL', 251426),
(412736, 'PTHR21114:SF0', NULL, NULL, NULL, NULL, 'INTERLEUKIN-33', 251427),
(412737, 'PTHR21114', NULL, NULL, NULL, NULL, 'DVS27 PROTEIN', 251427),
(412738, 'PTHR42751', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER FAMILY/TRKA DOMAIN PROTEIN', 251428),
(412739, 'PTHR42751:SF1', NULL, NULL, NULL, NULL, 'CATION/PROTON ANTIPORTER YBAL-RELATED', 251428),
(412740, 'PTHR42751:SF4', NULL, NULL, NULL, NULL, 'K(+)/H(+) ANTIPORTER SUBUNIT KHTU', 251428),
(412741, 'PTHR42751:SF3', NULL, NULL, NULL, NULL, 'NA(+)/H(+) ANTIPORTER', 251428),
(412742, 'PTHR42751:SF6', NULL, NULL, NULL, NULL, 'CONSERVED INTEGRAL MEMBRANE TRANSPORT PROTEIN-RELATED', 251428),
(412743, 'PTHR16441:SF9', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 93', 251429),
(412744, 'PTHR16441', NULL, NULL, NULL, NULL, 'FIDIPIDINE', 251429),
(412745, 'PTHR16441:SF8', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 93', 251429),
(412746, 'PTHR16441:SF0', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 93', 251429),
(412747, 'PTHR33649:SF19', NULL, NULL, NULL, NULL, 'PAR1-RELATED', 251430),
(412748, 'PTHR33649:SF9', NULL, NULL, NULL, NULL, '', 251430),
(412749, 'PTHR33649:SF11', NULL, NULL, NULL, NULL, 'NTEIG-E80 PROTEIN', 251430),
(412750, 'PTHR33649:SF12', NULL, NULL, NULL, NULL, 'NTEIG-E80 PROTEIN', 251430),
(412751, 'PTHR33649:SF4', NULL, NULL, NULL, NULL, 'PAR1 PROTEIN', 251430),
(412752, 'PTHR33649:SF13', NULL, NULL, NULL, NULL, 'PAR1 PROTEIN', 251430),
(412753, 'PTHR33649:SF14', NULL, NULL, NULL, NULL, 'PAR1-RELATED', 251430),
(412754, 'PTHR33649:SF2', NULL, NULL, NULL, NULL, 'PAR1 PROTEIN', 251430),
(412755, 'PTHR33649:SF16', NULL, NULL, NULL, NULL, '', 251430),
(412756, 'PTHR33649:SF17', NULL, NULL, NULL, NULL, 'NTEIG-E80 PROTEIN', 251430),
(412757, 'PTHR33649:SF18', NULL, NULL, NULL, NULL, 'BNAC04G26600D PROTEIN', 251430),
(412758, 'PTHR33649:SF20', NULL, NULL, NULL, NULL, 'BNAC08G48820D PROTEIN', 251430),
(412759, 'PTHR33649', NULL, NULL, NULL, NULL, 'PAR1 PROTEIN', 251430),
(412760, 'PTHR33649:SF21', NULL, NULL, NULL, NULL, 'PAR-1B PROTEIN', 251430),
(412761, 'PTHR47019:SF1', NULL, NULL, NULL, NULL, 'LIPID II FLIPPASE MURJ', 251431),
(412762, 'PTHR47019', NULL, NULL, NULL, NULL, 'LIPID II FLIPPASE MURJ', 251431),
(412763, 'PTHR22617:SF43', NULL, NULL, NULL, NULL, 'PROTEIN PILI', 251432),
(412764, 'PTHR22617:SF44', NULL, NULL, NULL, NULL, 'PURINE-BINDING CHEMOTAXIS PROTEIN-RELATED', 251432),
(412765, 'PTHR22617:SF41', NULL, NULL, NULL, NULL, 'CHEMOTAXIS SIGNAL TRANSDUCTION SYSTEM ADAPTOR PROTEIN CHEW', 251432),
(412766, 'PTHR22617', NULL, NULL, NULL, NULL, 'CHEMOTAXIS SENSOR HISTIDINE KINASE-RELATED', 251432),
(412767, 'PTHR22617:SF23', NULL, NULL, NULL, NULL, 'CHEMOTAXIS PROTEIN CHEW', 251432),
(412768, 'PTHR13143:SF6', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 19, MITOCHONDRIAL', 251433),
(412769, 'PTHR13143', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 19', 251433),
(412770, 'PTHR13316:SF0', NULL, NULL, NULL, NULL, 'ZINC FINGER CCHC DOMAIN-CONTAINING PROTEIN 8', 251434),
(412771, 'PTHR13316', NULL, NULL, NULL, NULL, 'ZINC FINGER, CCHC DOMAIN CONTAINING 8', 251434),
(412772, 'PTHR13316:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG09981', 251434),
(412773, 'PTHR13316:SF9', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 251434),
(412774, 'PTHR10802:SF8', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM40-1', 251435);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(412775, 'PTHR10802', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM40', 251435),
(412776, 'PTHR10802:SF9', NULL, NULL, NULL, NULL, '', 251435),
(412777, 'PTHR10802:SF0', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM40B', 251435),
(412778, 'PTHR10802:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM40 HOMOLOG', 251435),
(412779, 'PTHR10802:SF2', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM40 HOMOLOG 1-RELATED', 251435),
(412780, 'PTHR10802:SF3', NULL, NULL, NULL, NULL, 'IP11229P', 251435),
(412781, 'PTHR10802:SF4', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM40-1', 251435),
(412782, 'PTHR10802:SF5', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM40-2-RELATED', 251435),
(412783, 'PTHR10802:SF6', NULL, NULL, NULL, NULL, '', 251435),
(412784, 'PTHR10802:SF7', NULL, NULL, NULL, NULL, 'BNAC05G32550D PROTEIN', 251435),
(412785, 'PTHR42077', NULL, NULL, NULL, NULL, 'YALI0F30239P', 251436),
(412786, 'PTHR42077:SF1', NULL, NULL, NULL, NULL, 'YALI0F30239P', 251436),
(412787, 'PTHR12752:SF4', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY A MEMBER 7', 251437),
(412788, 'PTHR12752:SF10', NULL, NULL, NULL, NULL, 'SI:CH211-234P6.5', 251437),
(412789, 'PTHR12752:SF5', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY A MEMBER 6', 251437),
(412790, 'PTHR12752:SF7', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY A MEMBER 4', 251437),
(412791, 'PTHR12752:SF2', NULL, NULL, NULL, NULL, 'PDZ AND PLECKSTRIN HOMOLOGY DOMAINS 1', 251437),
(412792, 'PTHR12752:SF3', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY A MEMBER 5', 251437),
(412793, 'PTHR12752', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITOL 3-PHOSPHATE-BINDING PROTEIN', 251437),
(412794, 'PTHR12752:SF9', NULL, NULL, NULL, NULL, 'KRAMER, ISOFORM I', 251437),
(412795, 'PTHR12752:SF12', NULL, NULL, NULL, NULL, '', 251437),
(412796, 'PTHR31158', NULL, NULL, NULL, NULL, 'DUAL OXIDASE 2', 251438),
(412797, 'PTHR31158:SF3', NULL, NULL, NULL, NULL, 'DUAL OXIDASE MATURATION FACTOR 1', 251438),
(412798, 'PTHR31158:SF2', NULL, NULL, NULL, NULL, 'DUAL OXIDASE MATURATION FACTOR 2', 251438),
(412799, 'PTHR31158:SF10', NULL, NULL, NULL, NULL, 'LD27791P', 251438),
(412800, 'PTHR31158:SF1', NULL, NULL, NULL, NULL, 'DUAL OXIDASE 2', 251438),
(412801, 'PTHR12951:SF1', NULL, NULL, NULL, NULL, 'PROTEIN UNC-119 HOMOLOG', 251439),
(412802, 'PTHR12951:SF5', NULL, NULL, NULL, NULL, 'PROTEIN UNC-119 HOMOLOG A', 251439),
(412803, 'PTHR12951:SF6', NULL, NULL, NULL, NULL, 'GMP_PDE_DELTA DOMAIN-CONTAINING PROTEIN-RELATED', 251439),
(412804, 'PTHR12951:SF3', NULL, NULL, NULL, NULL, 'PROTEIN UNC-119 HOMOLOG B', 251439),
(412805, 'PTHR12951', NULL, NULL, NULL, NULL, 'RETINAL PROTEIN 4', 251439),
(412806, 'PTHR22791:SF26', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 251440),
(412807, 'PTHR22791:SF27', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 251440),
(412808, 'PTHR22791:SF28', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF186', 251440),
(412809, 'PTHR22791:SF17', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 251440),
(412810, 'PTHR22791:SF29', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 251440),
(412811, 'PTHR22791', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 251440),
(412812, 'PTHR22791:SF3', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 208', 251440),
(412813, 'PTHR22791:SF1', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 225', 251440),
(412814, 'PTHR22791:SF22', NULL, NULL, NULL, NULL, 'SI:CH73-335L21.2', 251440),
(412815, 'PTHR22791:SF23', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 251440),
(412816, 'PTHR22791:SF9', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 183', 251440),
(412817, 'PTHR22791:SF14', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 227', 251440),
(412818, 'PTHR22791:SF6', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 251440),
(412819, 'PTHR22791:SF7', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF183', 251440);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(412820, 'PTHR22791:SF4', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 223', 251440),
(412821, 'PTHR14159:SF3', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1', 251441),
(412822, 'PTHR14159', NULL, NULL, NULL, NULL, 'ATAXIN-3-RELATED', 251441),
(412823, 'PTHR14159:SF0', NULL, NULL, NULL, NULL, 'ATAXIN-3-RELATED', 251441),
(412824, 'PTHR47432:SF1', NULL, NULL, NULL, NULL, 'CELL WALL ASSEMBLY REGULATOR SMI1', 251442),
(412825, 'PTHR47432', NULL, NULL, NULL, NULL, 'CELL WALL ASSEMBLY REGULATOR SMI1', 251442),
(412826, 'PTHR30097:SF15', NULL, NULL, NULL, NULL, 'CATION EFFLUX SYSTEM PROTEIN CUSB', 251443),
(412827, 'PTHR30097', NULL, NULL, NULL, NULL, 'CATION EFFLUX SYSTEM PROTEIN CUSB', 251443),
(412828, 'PTHR30097:SF4', NULL, NULL, NULL, NULL, 'SLR6042 PROTEIN', 251443),
(412829, 'PTHR20953', NULL, NULL, NULL, NULL, 'KINASE-RELATED', 251444),
(412830, 'PTHR20953:SF3', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN', 251444),
(412831, 'PTHR20953:SF13', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251444),
(412832, 'PTHR20953:SF14', NULL, NULL, NULL, NULL, 'PROTEIN SEEDLING PLASTID DEVELOPMENT 1', 251444),
(412833, 'PTHR30266:SF2', NULL, NULL, NULL, NULL, 'LARGE-CONDUCTANCE MECHANOSENSITIVE CHANNEL', 251445),
(412834, 'PTHR30266', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE CHANNEL MSCL', 251445),
(412835, 'PTHR36716', NULL, NULL, NULL, NULL, 'F3H9.20 PROTEIN', 251446),
(412836, 'PTHR36716:SF2', NULL, NULL, NULL, NULL, 'F3H9.20 PROTEIN', 251446),
(412837, 'PTHR39418:SF1', NULL, NULL, NULL, NULL, 'DEHYDROGENASE-RELATED', 251447),
(412838, 'PTHR39418', NULL, NULL, NULL, NULL, 'DEHYDROGENASE-RELATED', 251447),
(412839, 'PTHR45589:SF1', NULL, NULL, NULL, NULL, 'WD REPEAT DOMAIN 62, ISOFORM G', 251448),
(412840, 'PTHR45589:SF4', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE BINDING PROTEIN 1', 251448),
(412841, 'PTHR45589:SF5', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE BINDING PROTEIN 1', 251448),
(412842, 'PTHR45589:SF2', NULL, NULL, NULL, NULL, 'WD REPEAT DOMAIN 62', 251448),
(412843, 'PTHR45589', NULL, NULL, NULL, NULL, 'WD REPEAT DOMAIN 62, ISOFORM G', 251448),
(412844, 'PTHR45589:SF3', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 62', 251448),
(412845, 'PTHR28676:SF2', NULL, NULL, NULL, NULL, 'ALK AND LTK LIGAND 2', 251449),
(412846, 'PTHR28676:SF1', NULL, NULL, NULL, NULL, 'ALK AND LTK LIGAND 1', 251449),
(412847, 'PTHR28676', NULL, NULL, NULL, NULL, 'ALK AND LTK LIGAND 2-RELATED', 251449),
(412848, 'PTHR31336', NULL, NULL, NULL, NULL, 'LIN37 HOMOLOG', 251450),
(412849, 'PTHR31336:SF3', NULL, NULL, NULL, NULL, 'PROTEIN LIN-37 HOMOLOG', 251450),
(412850, 'PTHR11176:SF29', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN A3', 251451),
(412851, 'PTHR11176:SF49', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN ARP1 ISOFORM X1-RELATED', 251451),
(412852, 'PTHR11176:SF28', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 251451),
(412853, 'PTHR11176:SF21', NULL, NULL, NULL, NULL, 'OS01G0958500 PROTEIN', 251451),
(412854, 'PTHR11176:SF22', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 251451),
(412855, 'PTHR11176:SF44', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 251451),
(412856, 'PTHR11176:SF41', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 251451),
(412857, 'PTHR11176:SF47', NULL, NULL, NULL, NULL, 'BNAC02G44770D PROTEIN', 251451),
(412858, 'PTHR11176:SF48', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 1', 251451),
(412859, 'PTHR11176:SF26', NULL, NULL, NULL, NULL, 'OS06G0622900 PROTEIN', 251451),
(412860, 'PTHR11176:SF23', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 251451),
(412861, 'PTHR11176:SF45', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 38-LIKE', 251451),
(412862, 'PTHR11176:SF46', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 251451),
(412863, 'PTHR11176', NULL, NULL, NULL, NULL, 'BOULE-RELATED', 251451),
(412864, 'PTHR11176:SF4', NULL, NULL, NULL, NULL, 'DELETED IN AZOOSPERMIA-LIKE', 251451),
(412865, 'PTHR11176:SF8', NULL, NULL, NULL, NULL, 'DELETED IN AZOOSPERMIA PROTEIN 1-RELATED', 251451);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(412866, 'PTHR11176:SF16', NULL, NULL, NULL, NULL, 'OS01G0876800 PROTEIN', 251451),
(412867, 'PTHR11176:SF39', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 251451),
(412868, 'PTHR11176:SF54', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN ARP1-RELATED', 251451),
(412869, 'PTHR11176:SF10', NULL, NULL, NULL, NULL, 'PROTEIN BOULE-LIKE', 251451),
(412870, 'PTHR11176:SF55', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIF) FAMILY PROTEIN', 251451),
(412871, 'PTHR11176:SF30', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 251451),
(412872, 'PTHR11176:SF52', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 251451),
(412873, 'PTHR11176:SF53', NULL, NULL, NULL, NULL, 'BNAA09G30280D PROTEIN', 251451),
(412874, 'PTHR11176:SF56', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 251451),
(412875, 'PTHR11176:SF34', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 251451),
(412876, 'PTHR11176:SF57', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 251451),
(412877, 'PTHR11176:SF13', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 251451),
(412878, 'PTHR11176:SF35', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 251451),
(412879, 'PTHR11176:SF50', NULL, NULL, NULL, NULL, 'PROTEIN BOULE', 251451),
(412880, 'PTHR11176:SF51', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 251451),
(412881, 'PTHR10064:SF12', NULL, NULL, NULL, NULL, '', 251452),
(412882, 'PTHR10064:SF23', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L22-3', 251452),
(412883, 'PTHR10064:SF34', NULL, NULL, NULL, NULL, '', 251452),
(412884, 'PTHR10064:SF33', NULL, NULL, NULL, NULL, '', 251452),
(412885, 'PTHR10064:SF2', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L22', 251452),
(412886, 'PTHR10064:SF1', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L22-LIKE 1', 251452),
(412887, 'PTHR10064:SF14', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L22-3-LIKE', 251452),
(412888, 'PTHR10064:SF13', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L22, PUTATIVE-RELATED', 251452),
(412889, 'PTHR10064:SF24', NULL, NULL, NULL, NULL, 'BNAA02G37000D PROTEIN', 251452),
(412890, 'PTHR10064:SF0', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L22-RELATED', 251452),
(412891, 'PTHR10064:SF30', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L22-2', 251452),
(412892, 'PTHR10064:SF21', NULL, NULL, NULL, NULL, '', 251452),
(412893, 'PTHR10064:SF32', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L22-2', 251452),
(412894, 'PTHR10064:SF31', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L22-A-RELATED', 251452),
(412895, 'PTHR10064:SF20', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L22-1-RELATED', 251452),
(412896, 'PTHR10064:SF16', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L22-2', 251452),
(412897, 'PTHR10064:SF15', NULL, NULL, NULL, NULL, '', 251452),
(412898, 'PTHR10064:SF29', NULL, NULL, NULL, NULL, 'BNAC03G70980D PROTEIN', 251452),
(412899, 'PTHR10064:SF18', NULL, NULL, NULL, NULL, '', 251452),
(412900, 'PTHR10064:SF17', NULL, NULL, NULL, NULL, '', 251452),
(412901, 'PTHR10064', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L22', 251452),
(412902, 'PTHR47924:SF236', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(412903, 'PTHR47924:SF115', NULL, NULL, NULL, NULL, 'THYMIDINE KINASE', 251453),
(412904, 'PTHR47924:SF116', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412905, 'PTHR47924:SF237', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(412906, 'PTHR47924:SF234', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN, MITOCHONDRIAL', 251453),
(412907, 'PTHR47924:SF113', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(412908, 'PTHR47924:SF114', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412909, 'PTHR47924:SF235', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(412910, 'PTHR47924:SF119', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(412911, 'PTHR47924:SF117', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(412912, 'PTHR47924:SF238', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412913, 'PTHR47924:SF239', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412914, 'PTHR47924:SF118', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN-RELATED', 251453),
(412915, 'PTHR47924:SF232', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(412916, 'PTHR47924:SF111', NULL, NULL, NULL, NULL, '', 251453),
(412917, 'PTHR47924:SF112', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412918, 'PTHR47924:SF233', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412919, 'PTHR47924:SF230', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 251453),
(412920, 'PTHR47924:SF231', NULL, NULL, NULL, NULL, 'OS01G0197450 PROTEIN', 251453),
(412921, 'PTHR47924:SF110', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412922, 'PTHR47924:SF225', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN-RELATED', 251453),
(412923, 'PTHR47924:SF104', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412924, 'PTHR47924:SF105', NULL, NULL, NULL, NULL, '', 251453),
(412925, 'PTHR47924:SF226', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(412926, 'PTHR47924:SF102', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412927, 'PTHR47924:SF223', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412928, 'PTHR47924:SF103', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 251453),
(412929, 'PTHR47924:SF224', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(412930, 'PTHR47924:SF108', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(412931, 'PTHR47924:SF229', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412932, 'PTHR47924:SF109', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412933, 'PTHR47924:SF106', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412934, 'PTHR47924:SF227', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412935, 'PTHR47924:SF228', NULL, NULL, NULL, NULL, '', 251453),
(412936, 'PTHR47924:SF107', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412937, 'PTHR47924:SF100', NULL, NULL, NULL, NULL, 'OS01G0914600 PROTEIN', 251453),
(412938, 'PTHR47924:SF221', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412939, 'PTHR47924:SF101', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(412940, 'PTHR47924:SF222', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412941, 'PTHR47924:SF220', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 251453),
(412942, 'PTHR47924:SF214', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412943, 'PTHR47924:SF215', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(412944, 'PTHR47924:SF212', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412945, 'PTHR47924:SF213', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(412946, 'PTHR47924:SF218', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412947, 'PTHR47924:SF219', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412948, 'PTHR47924:SF216', NULL, NULL, NULL, NULL, 'OS04G0401200 PROTEIN', 251453),
(412949, 'PTHR47924:SF217', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412950, 'PTHR47924:SF210', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412951, 'PTHR47924:SF211', NULL, NULL, NULL, NULL, '', 251453);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(412952, 'PTHR47924:SF209', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 251453),
(412953, 'PTHR47924:SF203', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT PROTEIN-RELATED', 251453),
(412954, 'PTHR47924:SF204', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 251453),
(412955, 'PTHR47924:SF201', NULL, NULL, NULL, NULL, '', 251453),
(412956, 'PTHR47924:SF202', NULL, NULL, NULL, NULL, '', 251453),
(412957, 'PTHR47924:SF207', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 251453),
(412958, 'PTHR47924:SF208', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412959, 'PTHR47924:SF205', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 251453),
(412960, 'PTHR47924:SF206', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412961, 'PTHR47924:SF200', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412962, 'PTHR47924:SF21', NULL, NULL, NULL, NULL, 'BNAC05G02870D PROTEIN', 251453),
(412963, 'PTHR47924:SF25', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(412964, 'PTHR47924:SF26', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412965, 'PTHR47924:SF24', NULL, NULL, NULL, NULL, 'BNAA04G21340D PROTEIN', 251453),
(412966, 'PTHR47924:SF32', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412967, 'PTHR47924:SF33', NULL, NULL, NULL, NULL, '', 251453),
(412968, 'PTHR47924:SF31', NULL, NULL, NULL, NULL, '', 251453),
(412969, 'PTHR47924:SF35', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412970, 'PTHR47924:SF38', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412971, 'PTHR47924:SF39', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(412972, 'PTHR47924:SF10', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412973, 'PTHR47924:SF14', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412974, 'PTHR47924:SF13', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412975, 'PTHR47924:SF18', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL', 251453),
(412976, 'PTHR47924:SF19', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 251453),
(412977, 'PTHR47924:SF17', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(412978, 'PTHR47924:SF72', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT PROTEIN PPR868-14', 251453),
(412979, 'PTHR47924:SF73', NULL, NULL, NULL, NULL, 'BNAA03G51270D PROTEIN', 251453),
(412980, 'PTHR47924:SF70', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN ELI1, CHLOROPLASTIC', 251453),
(412981, 'PTHR47924:SF71', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412982, 'PTHR47924:SF195', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412983, 'PTHR47924:SF196', NULL, NULL, NULL, NULL, 'OS02G0730900 PROTEIN', 251453),
(412984, 'PTHR47924:SF66', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412985, 'PTHR47924:SF193', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412986, 'PTHR47924:SF194', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(412987, 'PTHR47924:SF199', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412988, 'PTHR47924:SF69', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412989, 'PTHR47924:SF197', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 251453),
(412990, 'PTHR47924:SF67', NULL, NULL, NULL, NULL, '', 251453),
(412991, 'PTHR47924:SF198', NULL, NULL, NULL, NULL, '', 251453),
(412992, 'PTHR47924:SF68', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412993, 'PTHR47924:SF191', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412994, 'PTHR47924:SF192', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 251453); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(412995, 'PTHR47924:SF190', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412996, 'PTHR47924:SF80', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412997, 'PTHR47924:SF83', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN MITOCHONDRIAL', 251453),
(412998, 'PTHR47924:SF84', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(412999, 'PTHR47924:SF81', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(413000, 'PTHR47924:SF82', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413001, 'PTHR47924:SF76', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL', 251453),
(413002, 'PTHR47924:SF184', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413003, 'PTHR47924:SF77', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413004, 'PTHR47924:SF185', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(413005, 'PTHR47924:SF182', NULL, NULL, NULL, NULL, 'OS03G0271300 PROTEIN', 251453),
(413006, 'PTHR47924:SF74', NULL, NULL, NULL, NULL, 'BNAA07G12570D PROTEIN', 251453),
(413007, 'PTHR47924:SF75', NULL, NULL, NULL, NULL, '', 251453),
(413008, 'PTHR47924:SF183', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413009, 'PTHR47924:SF188', NULL, NULL, NULL, NULL, '', 251453),
(413010, 'PTHR47924:SF189', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN MITOCHONDRIAL', 251453),
(413011, 'PTHR47924:SF78', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(413012, 'PTHR47924:SF186', NULL, NULL, NULL, NULL, 'BNAA07G12550D PROTEIN', 251453),
(413013, 'PTHR47924:SF187', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL', 251453),
(413014, 'PTHR47924:SF79', NULL, NULL, NULL, NULL, '', 251453),
(413015, 'PTHR47924:SF180', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413016, 'PTHR47924:SF181', NULL, NULL, NULL, NULL, 'BNAC05G47060D PROTEIN', 251453),
(413017, 'PTHR47924:SF179', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413018, 'PTHR47924:SF294', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(413019, 'PTHR47924:SF173', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(413020, 'PTHR47924:SF43', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(413021, 'PTHR47924:SF295', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN MITOCHONDRIAL', 251453),
(413022, 'PTHR47924:SF44', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(413023, 'PTHR47924:SF174', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(413024, 'PTHR47924:SF171', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(413025, 'PTHR47924:SF292', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(413026, 'PTHR47924:SF293', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413027, 'PTHR47924:SF42', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413028, 'PTHR47924:SF172', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413029, 'PTHR47924:SF177', NULL, NULL, NULL, NULL, 'BNAA01G28440D PROTEIN', 251453),
(413030, 'PTHR47924:SF47', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413031, 'PTHR47924:SF178', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413032, 'PTHR47924:SF48', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413033, 'PTHR47924:SF175', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(413034, 'PTHR47924:SF176', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(413035, 'PTHR47924:SF49', NULL, NULL, NULL, NULL, 'PPR MOTIF PROTEIN', 251453);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(413036, 'PTHR47924:SF290', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN MITOCHONDRIAL', 251453),
(413037, 'PTHR47924:SF170', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(413038, 'PTHR47924:SF291', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413039, 'PTHR47924', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(413040, 'PTHR47924:SF168', NULL, NULL, NULL, NULL, 'BINDING PROTEIN', 251453),
(413041, 'PTHR47924:SF289', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413042, 'PTHR47924:SF169', NULL, NULL, NULL, NULL, 'BNAC04G55710D PROTEIN', 251453),
(413043, 'PTHR47924:SF62', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413044, 'PTHR47924:SF162', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN, MITOCHONDRIAL', 251453),
(413045, 'PTHR47924:SF283', NULL, NULL, NULL, NULL, '', 251453),
(413046, 'PTHR47924:SF163', NULL, NULL, NULL, NULL, '', 251453),
(413047, 'PTHR47924:SF284', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413048, 'PTHR47924:SF281', NULL, NULL, NULL, NULL, 'BNAC09G40000D PROTEIN', 251453),
(413049, 'PTHR47924:SF160', NULL, NULL, NULL, NULL, '', 251453),
(413050, 'PTHR47924:SF161', NULL, NULL, NULL, NULL, 'OS01G0589900 PROTEIN', 251453),
(413051, 'PTHR47924:SF282', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 251453),
(413052, 'PTHR47924:SF166', NULL, NULL, NULL, NULL, 'OS08G0131000 PROTEIN', 251453),
(413053, 'PTHR47924:SF58', NULL, NULL, NULL, NULL, '', 251453),
(413054, 'PTHR47924:SF287', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413055, 'PTHR47924:SF288', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413056, 'PTHR47924:SF167', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413057, 'PTHR47924:SF164', NULL, NULL, NULL, NULL, 'OS05G0212100 PROTEIN', 251453),
(413058, 'PTHR47924:SF285', NULL, NULL, NULL, NULL, 'OS08G0138600 PROTEIN', 251453),
(413059, 'PTHR47924:SF165', NULL, NULL, NULL, NULL, 'BNAC04G04720D PROTEIN', 251453),
(413060, 'PTHR47924:SF286', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413061, 'PTHR47924:SF280', NULL, NULL, NULL, NULL, '', 251453),
(413062, 'PTHR47924:SF159', NULL, NULL, NULL, NULL, 'OS07G0260000 PROTEIN', 251453),
(413063, 'PTHR47924:SF278', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 251453),
(413064, 'PTHR47924:SF157', NULL, NULL, NULL, NULL, '', 251453),
(413065, 'PTHR47924:SF158', NULL, NULL, NULL, NULL, 'OS04G0628200 PROTEIN', 251453),
(413066, 'PTHR47924:SF279', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413067, 'PTHR47924:SF151', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(413068, 'PTHR47924:SF272', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 251453),
(413069, 'PTHR47924:SF273', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413070, 'PTHR47924:SF152', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(413071, 'PTHR47924:SF270', NULL, NULL, NULL, NULL, 'OS05G0370000 PROTEIN', 251453),
(413072, 'PTHR47924:SF150', NULL, NULL, NULL, NULL, '', 251453),
(413073, 'PTHR47924:SF271', NULL, NULL, NULL, NULL, '', 251453),
(413074, 'PTHR47924:SF155', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413075, 'PTHR47924:SF276', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413076, 'PTHR47924:SF156', NULL, NULL, NULL, NULL, 'BNAC03G61110D PROTEIN', 251453),
(413077, 'PTHR47924:SF277', NULL, NULL, NULL, NULL, 'OS11G0587100 PROTEIN', 251453),
(413078, 'PTHR47924:SF153', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413079, 'PTHR47924:SF274', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(413080, 'PTHR47924:SF154', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(413081, 'PTHR47924:SF275', NULL, NULL, NULL, NULL, 'OS09G0407800 PROTEIN', 251453),
(413082, 'PTHR47924:SF269', NULL, NULL, NULL, NULL, '', 251453),
(413083, 'PTHR47924:SF148', NULL, NULL, NULL, NULL, '', 251453),
(413084, 'PTHR47924:SF149', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 251453),
(413085, 'PTHR47924:SF267', NULL, NULL, NULL, NULL, '', 251453),
(413086, 'PTHR47924:SF146', NULL, NULL, NULL, NULL, 'BNAC04G31400D PROTEIN', 251453),
(413087, 'PTHR47924:SF147', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 251453),
(413088, 'PTHR47924:SF268', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413089, 'PTHR47924:SF261', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413090, 'PTHR47924:SF140', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413091, 'PTHR47924:SF262', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413092, 'PTHR47924:SF141', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413093, 'PTHR47924:SF260', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413094, 'PTHR47924:SF265', NULL, NULL, NULL, NULL, 'BNAA06G32750D PROTEIN', 251453),
(413095, 'PTHR47924:SF144', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413096, 'PTHR47924:SF145', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413097, 'PTHR47924:SF266', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(413098, 'PTHR47924:SF142', NULL, NULL, NULL, NULL, '', 251453),
(413099, 'PTHR47924:SF263', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413100, 'PTHR47924:SF143', NULL, NULL, NULL, NULL, 'SAM (AND SOME OTHER NUCLEOTIDE) BINDING MOTIF_ METHYLTRANSFERASE SMALL', 251453),
(413101, 'PTHR47924:SF264', NULL, NULL, NULL, NULL, 'BNAA07G12600D PROTEIN', 251453),
(413102, 'PTHR47924:SF8', NULL, NULL, NULL, NULL, 'BNACNNG53370D PROTEIN', 251453),
(413103, 'PTHR47924:SF7', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN, MITOCHONDRIAL', 251453),
(413104, 'PTHR47924:SF9', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(413105, 'PTHR47924:SF137', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413106, 'PTHR47924:SF258', NULL, NULL, NULL, NULL, '', 251453),
(413107, 'PTHR47924:SF90', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 251453),
(413108, 'PTHR47924:SF259', NULL, NULL, NULL, NULL, '', 251453),
(413109, 'PTHR47924:SF91', NULL, NULL, NULL, NULL, '', 251453),
(413110, 'PTHR47924:SF138', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 251453),
(413111, 'PTHR47924:SF256', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413112, 'PTHR47924:SF135', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413113, 'PTHR47924:SF136', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN-RELATED', 251453),
(413114, 'PTHR47924:SF257', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413115, 'PTHR47924:SF94', NULL, NULL, NULL, NULL, '', 251453),
(413116, 'PTHR47924:SF95', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE (PPR) REPEAT PROTEIN', 251453),
(413117, 'PTHR47924:SF139', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT PROTEIN PPR986-12', 251453),
(413118, 'PTHR47924:SF92', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413119, 'PTHR47924:SF93', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413120, 'PTHR47924:SF250', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT PROTEIN', 251453),
(413121, 'PTHR47924:SF87', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413122, 'PTHR47924:SF130', NULL, NULL, NULL, NULL, 'OS12G0163600 PROTEIN', 251453);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(413123, 'PTHR47924:SF88', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(413124, 'PTHR47924:SF251', NULL, NULL, NULL, NULL, '', 251453),
(413125, 'PTHR47924:SF85', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413126, 'PTHR47924:SF86', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413127, 'PTHR47924:SF133', NULL, NULL, NULL, NULL, '', 251453),
(413128, 'PTHR47924:SF254', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(413129, 'PTHR47924:SF255', NULL, NULL, NULL, NULL, '', 251453),
(413130, 'PTHR47924:SF134', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(413131, 'PTHR47924:SF89', NULL, NULL, NULL, NULL, 'BNAC09G38830D PROTEIN', 251453),
(413132, 'PTHR47924:SF131', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN INTERACTION DOMAIN CONTAINING PROTEIN', 251453),
(413133, 'PTHR47924:SF252', NULL, NULL, NULL, NULL, '', 251453),
(413134, 'PTHR47924:SF132', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413135, 'PTHR47924:SF253', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE (PPR) REPEAT PROTEIN', 251453),
(413136, 'PTHR47924:SF126', NULL, NULL, NULL, NULL, 'OS07G0635800 PROTEIN', 251453),
(413137, 'PTHR47924:SF247', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413138, 'PTHR47924:SF248', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413139, 'PTHR47924:SF127', NULL, NULL, NULL, NULL, 'OS03G0283500 PROTEIN', 251453),
(413140, 'PTHR47924:SF245', NULL, NULL, NULL, NULL, 'OS05G0271900 PROTEIN', 251453),
(413141, 'PTHR47924:SF124', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413142, 'PTHR47924:SF246', NULL, NULL, NULL, NULL, '', 251453),
(413143, 'PTHR47924:SF125', NULL, NULL, NULL, NULL, 'OS09G0412900 PROTEIN', 251453),
(413144, 'PTHR47924:SF249', NULL, NULL, NULL, NULL, 'OS01G0839400 PROTEIN', 251453),
(413145, 'PTHR47924:SF128', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413146, 'PTHR47924:SF129', NULL, NULL, NULL, NULL, 'BNAA05G36050D PROTEIN', 251453),
(413147, 'PTHR47924:SF98', NULL, NULL, NULL, NULL, 'SM DOMAIN-CONTAINING PROTEIN', 251453),
(413148, 'PTHR47924:SF99', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(413149, 'PTHR47924:SF240', NULL, NULL, NULL, NULL, 'OS12G0233200 PROTEIN', 251453),
(413150, 'PTHR47924:SF96', NULL, NULL, NULL, NULL, '', 251453),
(413151, 'PTHR47924:SF97', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE', 251453),
(413152, 'PTHR47924:SF243', NULL, NULL, NULL, NULL, 'OS01G0814300 PROTEIN', 251453),
(413153, 'PTHR47924:SF122', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413154, 'PTHR47924:SF123', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', 251453),
(413155, 'PTHR47924:SF244', NULL, NULL, NULL, NULL, '', 251453),
(413156, 'PTHR47924:SF241', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 251453),
(413157, 'PTHR47924:SF120', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL', 251453),
(413158, 'PTHR47924:SF242', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 251453),
(413159, 'PTHR47924:SF121', NULL, NULL, NULL, NULL, '', 251453),
(413160, 'PTHR42977:SF3', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251454),
(413161, 'PTHR42977:SF1', NULL, NULL, NULL, NULL, 'BLR6576 PROTEIN', 251454),
(413162, 'PTHR42977', NULL, NULL, NULL, NULL, 'HYDROLASE-RELATED', 251454),
(413163, 'PTHR36390', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN-LIKE PROTEIN', 251455),
(413164, 'PTHR36390:SF1', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN-LIKE PROTEIN', 251455),
(413165, 'PTHR11328:SF49', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY DOMAIN-CONTAINING PROTEIN 12-LIKE PROTEIN', 251456),
(413166, 'PTHR11328:SF48', NULL, NULL, NULL, NULL, 'BNAC04G49540D PROTEIN', 251456),
(413167, 'PTHR11328:SF36', NULL, NULL, NULL, NULL, 'MELIBIOSE CARRIER PROTEIN', 251456);
INSERT INTO "PUBLIC"."MODEL" VALUES
(413168, 'PTHR11328:SF47', NULL, NULL, NULL, NULL, '', 251456),
(413169, 'PTHR11328:SF24', NULL, NULL, NULL, NULL, 'INNER MEMBRANE SYMPORTER YICJ-RELATED', 251456),
(413170, 'PTHR11328:SF46', NULL, NULL, NULL, NULL, 'LACTOSE PERMEASE', 251456),
(413171, 'PTHR11328:SF34', NULL, NULL, NULL, NULL, 'PERMEASE, PUTATIVE, EXPRESSED-RELATED', 251456),
(413172, 'PTHR11328:SF45', NULL, NULL, NULL, NULL, 'BNAC04G22460D PROTEIN', 251456),
(413173, 'PTHR11328:SF44', NULL, NULL, NULL, NULL, 'ZGC:171501', 251456),
(413174, 'PTHR11328:SF43', NULL, NULL, NULL, NULL, 'SULFOQUINOVOSE IMPORTER-RELATED', 251456),
(413175, 'PTHR11328:SF31', NULL, NULL, NULL, NULL, 'SI:CH211-224L10.4', 251456),
(413176, 'PTHR11328:SF29', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT LYSOPHOSPHATIDYLCHOLINE SYMPORTER 1', 251456),
(413177, 'PTHR11328:SF39', NULL, NULL, NULL, NULL, '2,3-DIHYDROXYPROPANE-1-SULFONATE EXPORTER-RELATED', 251456),
(413178, 'PTHR11328:SF28', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY DOMAIN-CONTAINING PROTEIN 12', 251456),
(413179, 'PTHR11328', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY DOMAIN-CONTAINING PROTEIN', 251456),
(413180, 'PTHR11328:SF30', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY DOMAIN-CONTAINING PROTEIN 2B', 251456),
(413181, 'PTHR35884:SF1', NULL, NULL, NULL, NULL, 'BB_PF DOMAIN-CONTAINING PROTEIN-RELATED', 251457),
(413182, 'PTHR35884', NULL, NULL, NULL, NULL, 'SMALL AGGREGATE FORMATION PROTEIN', 251457),
(413183, 'PTHR45901:SF4', NULL, NULL, NULL, NULL, '', 251458),
(413184, 'PTHR45901', NULL, NULL, NULL, NULL, 'PROTEIN CBG12474', 251458),
(413185, 'PTHR45901:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG12474', 251458),
(413186, 'PTHR45901:SF6', NULL, NULL, NULL, NULL, 'LIPOXYGENASE HOMOLOGY DOMAIN-CONTAINING PROTEIN 1', 251458),
(413187, 'PTHR32423', NULL, NULL, NULL, NULL, 'SAP DOMAIN-CONTAINING PROTEIN-RELATED', 251459),
(413188, 'PTHR32423:SF65', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251459),
(413189, 'PTHR32423:SF24', NULL, NULL, NULL, NULL, 'SAP DOMAIN-CONTAINING PROTEIN', 251459),
(413190, 'PTHR10484:SF180', NULL, NULL, NULL, NULL, 'HISTONE H4-LIKE PROTEIN TYPE G', 251460),
(413191, 'PTHR10484:SF191', NULL, NULL, NULL, NULL, 'HISTONE H4', 251460),
(413192, 'PTHR10484:SF190', NULL, NULL, NULL, NULL, 'HISTONE H4', 251460),
(413193, 'PTHR10484:SF189', NULL, NULL, NULL, NULL, 'HISTONE H4 TYPE VIII', 251460),
(413194, 'PTHR10484:SF0', NULL, NULL, NULL, NULL, 'HISTONE H4', 251460),
(413195, 'PTHR10484:SF81', NULL, NULL, NULL, NULL, 'HISTONE H4.1', 251460),
(413196, 'PTHR10484:SF195', NULL, NULL, NULL, NULL, 'HISTONE H4', 251460),
(413197, 'PTHR10484:SF162', NULL, NULL, NULL, NULL, 'HISTONE H4', 251460),
(413198, 'PTHR10484:SF183', NULL, NULL, NULL, NULL, 'HISTONE H4', 251460),
(413199, 'PTHR10484:SF194', NULL, NULL, NULL, NULL, 'HISTONE H4', 251460),
(413200, 'PTHR10484:SF188', NULL, NULL, NULL, NULL, 'HISTONE H4', 251460),
(413201, 'PTHR10484:SF198', NULL, NULL, NULL, NULL, 'CENP-T_C DOMAIN-CONTAINING PROTEIN', 251460),
(413202, 'PTHR10484:SF187', NULL, NULL, NULL, NULL, 'HISTONE H4', 251460),
(413203, 'PTHR10484:SF197', NULL, NULL, NULL, NULL, 'HISTONE H4', 251460),
(413204, 'PTHR10484:SF186', NULL, NULL, NULL, NULL, 'HISTONE H4', 251460),
(413205, 'PTHR10484', NULL, NULL, NULL, NULL, 'HISTONE H4', 251460),
(413206, 'PTHR10484:SF174', NULL, NULL, NULL, NULL, 'HISTONE H4', 251460),
(413207, 'PTHR10484:SF185', NULL, NULL, NULL, NULL, 'HISTONE H4', 251460),
(413208, 'PTHR10484:SF196', NULL, NULL, NULL, NULL, 'HISTONE H4', 251460),
(413209, 'PTHR14191:SF3', NULL, NULL, NULL, NULL, 'NA(+)/H(+) EXCHANGE REGULATORY COFACTOR-LIKE PROTEIN NRFL-1', 251461),
(413210, 'PTHR14191:SF4', NULL, NULL, NULL, NULL, 'NA(+)/H(+) EXCHANGE REGULATORY COFACTOR NHE-RF2', 251461),
(413211, 'PTHR14191:SF27', NULL, NULL, NULL, NULL, 'MICROTUBULE ASSOCIATED SERINE/THREONINE KINASE FAMILY MEMBER 4', 251461),
(413212, 'PTHR14191', NULL, NULL, NULL, NULL, 'PDZ DOMAIN CONTAINING PROTEIN', 251461),
(413213, 'PTHR14191:SF28', NULL, NULL, NULL, NULL, 'GH04176P-RELATED', 251461),
(413214, 'PTHR14191:SF7', NULL, NULL, NULL, NULL, 'NA(+)/H(+) EXCHANGE REGULATORY COFACTOR NHE-RF1', 251461);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(413215, 'PTHR14191:SF6', NULL, NULL, NULL, NULL, 'NA(+)/H(+) EXCHANGE REGULATORY COFACTOR NHE-RF3-RELATED', 251461),
(413216, 'PTHR14191:SF20', NULL, NULL, NULL, NULL, 'NA(+)/H(+) EXCHANGE REGULATORY COFACTOR NHE-RF4', 251461),
(413217, 'PTHR11638:SF170', NULL, NULL, NULL, NULL, '', 251462),
(413218, 'PTHR11638:SF151', NULL, NULL, NULL, NULL, '', 251462),
(413219, 'PTHR11638:SF174', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 251462),
(413220, 'PTHR11638:SF86', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN CLPB4, MITOCHONDRIAL', 251462),
(413221, 'PTHR11638:SF175', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE, ATP-BINDING SUBUNIT CLPC', 251462),
(413222, 'PTHR11638', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE', 251462),
(413223, 'PTHR11638:SF176', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 78, MITOCHONDRIAL', 251462),
(413224, 'PTHR11638:SF154', NULL, NULL, NULL, NULL, '', 251462),
(413225, 'PTHR11638:SF177', NULL, NULL, NULL, NULL, 'CLP PROTEASE SUBUNIT, HEAT SHOCK PROTEIN 78 (HSP78), PUTATIVE-RELATED', 251462),
(413226, 'PTHR11638:SF111', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE ATP-BINDING SUBUNIT CLPA', 251462),
(413227, 'PTHR11638:SF155', NULL, NULL, NULL, NULL, 'CLP PROTEASE ATP-BINDING SUBUNIT', 251462),
(413228, 'PTHR11638:SF178', NULL, NULL, NULL, NULL, '', 251462),
(413229, 'PTHR11638:SF157', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 251462),
(413230, 'PTHR11638:SF179', NULL, NULL, NULL, NULL, 'CLPB_D2-SMALL DOMAIN-CONTAINING PROTEIN', 251462),
(413231, 'PTHR11638:SF159', NULL, NULL, NULL, NULL, '', 251462),
(413232, 'PTHR11638:SF18', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 104', 251462),
(413233, 'PTHR11638:SF180', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE ATP-BINDING SUBUNIT CLPA HOMOLOG CD4B, CHLOROPLASTIC', 251462),
(413234, 'PTHR11638:SF181', NULL, NULL, NULL, NULL, 'ATPASE SUBUNIT OF ATP-DEPENDENT PROTEASE-RELATED', 251462),
(413235, 'PTHR11638:SF182', NULL, NULL, NULL, NULL, 'CLP ATPASE', 251462),
(413236, 'PTHR11638:SF93', NULL, NULL, NULL, NULL, 'CASEINOLYTIC PEPTIDASE B PROTEIN HOMOLOG', 251462),
(413237, 'PTHR11638:SF183', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN CLPB1', 251462),
(413238, 'PTHR11638:SF184', NULL, NULL, NULL, NULL, 'ATPASE WITH CHAPERONE ACTIVITY-RELATED', 251462),
(413239, 'PTHR11638:SF185', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE ATP-BINDING SUBUNIT', 251462),
(413240, 'PTHR11638:SF186', NULL, NULL, NULL, NULL, 'BNAC09G42450D PROTEIN', 251462),
(413241, 'PTHR11638:SF89', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 251462),
(413242, 'PTHR11638:SF187', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN CLPB3', 251462),
(413243, 'PTHR11638:SF166', NULL, NULL, NULL, NULL, 'BNAA04G28110D PROTEIN', 251462),
(413244, 'PTHR11638:SF188', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE ATP-BINDING SUBUNIT CLPL', 251462),
(413245, 'PTHR11638:SF145', NULL, NULL, NULL, NULL, 'CLPA/B PROTEASE ATP BINDING SUBUNIT-RELATED', 251462),
(413246, 'PTHR11638:SF189', NULL, NULL, NULL, NULL, '', 251462),
(413247, 'PTHR35179:SF3', NULL, NULL, NULL, NULL, '', 251463),
(413248, 'PTHR35179:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG02620', 251463),
(413249, 'PTHR35179:SF1', NULL, NULL, NULL, NULL, '', 251463),
(413250, 'PTHR35179', NULL, NULL, NULL, NULL, 'PROTEIN CBG02620', 251463),
(413251, 'PTHR40142', NULL, NULL, NULL, NULL, 'BPI FOLD-CONTAINING FAMILY B, MEMBER 9B-RELATED', 251464),
(413252, 'PTHR40142:SF1', NULL, NULL, NULL, NULL, 'BPI FOLD-CONTAINING FAMILY B, MEMBER 9B-RELATED', 251464),
(413253, 'PTHR15989', NULL, NULL, NULL, NULL, 'VEZATIN', 251465),
(413254, 'PTHR15989:SF5', NULL, NULL, NULL, NULL, 'VEZATIN', 251465),
(413255, 'PTHR43092:SF4', NULL, NULL, NULL, NULL, 'AMINOTRAN_5 DOMAIN-CONTAINING PROTEIN', 251466),
(413256, 'PTHR43092:SF2', NULL, NULL, NULL, NULL, 'HERCYNYLCYSTEINE SULFOXIDE LYASE', 251466),
(413257, 'PTHR43092:SF7', NULL, NULL, NULL, NULL, 'L-CYSTEINE DESULFHYDRASE', 251466),
(413258, 'PTHR43092', NULL, NULL, NULL, NULL, 'L-CYSTEINE DESULFHYDRASE', 251466),
(413259, 'PTHR43092:SF8', NULL, NULL, NULL, NULL, 'ISOPENICILLIN N EPIMERASE-LIKE PROTEIN', 251466);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(413260, 'PTHR43092:SF5', NULL, NULL, NULL, NULL, 'L-CYSTEINE DESULFHYDRASE 2-RELATED', 251466),
(413261, 'PTHR43092:SF6', NULL, NULL, NULL, NULL, 'BLR1280 PROTEIN', 251466),
(413262, 'PTHR47489:SF2', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASES (NAT) SUPERFAMILY PROTEIN', 251467),
(413263, 'PTHR47489', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASES (NAT) SUPERFAMILY PROTEIN', 251467),
(413264, 'PTHR31489', NULL, NULL, NULL, NULL, 'LIN52 FAMILY MEMBER', 251468),
(413265, 'PTHR31489:SF2', NULL, NULL, NULL, NULL, 'PROTEIN LIN-52 HOMOLOG', 251468),
(413266, 'PTHR15608', NULL, NULL, NULL, NULL, 'SPLICING FACTOR U2AF-ASSOCIATED PROTEIN 2', 251469),
(413267, 'PTHR15608:SF0', NULL, NULL, NULL, NULL, 'HIV TAT-SPECIFIC FACTOR 1', 251469),
(413268, 'PTHR35762:SF9', NULL, NULL, NULL, NULL, 'OS01G0924200 PROTEIN', 251470),
(413269, 'PTHR35762:SF8', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 251470),
(413270, 'PTHR35762:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 251470),
(413271, 'PTHR35762:SF5', NULL, NULL, NULL, NULL, 'DUF4408 DOMAIN-CONTAINING PROTEIN', 251470),
(413272, 'PTHR35762', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 251470),
(413273, 'PTHR43212:SF2', NULL, NULL, NULL, NULL, 'PIRIN-LIKE PROTEIN YHAK', 251471),
(413274, 'PTHR43212:SF3', NULL, NULL, NULL, NULL, 'QUERCETIN 2,3-DIOXYGENASE', 251471),
(413275, 'PTHR43212', NULL, NULL, NULL, NULL, 'QUERCETIN 2,3-DIOXYGENASE', 251471),
(413276, 'PTHR15137:SF9', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 2', 251472),
(413277, 'PTHR15137', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID', 251472),
(413278, 'PTHR32020:SF6', NULL, NULL, NULL, NULL, 'LIN-8 DOMAIN CONTAINING', 251473),
(413279, 'PTHR32020:SF4', NULL, NULL, NULL, NULL, 'LIN-8 DOMAIN CONTAINING-RELATED', 251473),
(413280, 'PTHR32020', NULL, NULL, NULL, NULL, 'LIN-8 DOMAIN CONTAINING-RELATED', 251473),
(413281, 'PTHR32020:SF3', NULL, NULL, NULL, NULL, 'LIN-8 DOMAIN CONTAINING', 251473),
(413282, 'PTHR36204:SF1', NULL, NULL, NULL, NULL, 'N-ACETYLMANNOSAMINE-6-PHOSPHATE 2-EPIMERASE-RELATED', 251474),
(413283, 'PTHR36204', NULL, NULL, NULL, NULL, 'N-ACETYLMANNOSAMINE-6-PHOSPHATE 2-EPIMERASE-RELATED', 251474),
(413284, 'PTHR43837', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S12 METHYLTHIOTRANSFERASE RIMO', 251475),
(413285, 'PTHR43837:SF1', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S12 METHYLTHIOTRANSFERASE RIMO', 251475),
(413286, 'PTHR47002:SF7', NULL, NULL, NULL, NULL, 'AQUAPORIN, MIP FAMILY, PIP SUBFAMILY', 251476),
(413287, 'PTHR47002:SF6', NULL, NULL, NULL, NULL, 'MAJOR INTRINSIC PROTEIN (MIP) FAMILY TRANSPORTER', 251476),
(413288, 'PTHR47002:SF5', NULL, NULL, NULL, NULL, 'AQUAPORIN-LIKE', 251476),
(413289, 'PTHR47002:SF4', NULL, NULL, NULL, NULL, 'AQUAPORIN AQPAN.G-LIKE', 251476),
(413290, 'PTHR47002', NULL, NULL, NULL, NULL, 'AQUAPORIN-LIKE', 251476),
(413291, 'PTHR47002:SF2', NULL, NULL, NULL, NULL, 'AQUAPORIN-LIKE', 251476),
(413292, 'PTHR13123:SF8', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 25', 251477),
(413293, 'PTHR13123:SF7', NULL, NULL, NULL, NULL, 'LD30288P', 251477),
(413294, 'PTHR13123:SF6', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 32', 251477),
(413295, 'PTHR13123', NULL, NULL, NULL, NULL, 'LD30288P', 251477),
(413296, 'PTHR12136:SF64', NULL, NULL, NULL, NULL, 'OS02G0102800 PROTEIN', 251478),
(413297, 'PTHR12136:SF41', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY (PH) AND LIPID-BINDING START DOMAINS-CONTAINING PROTEIN', 251478),
(413298, 'PTHR12136:SF93', NULL, NULL, NULL, NULL, 'ENHANCED DISEASE RESISTANCE-LIKE PROTEIN (DUF1336)', 251478),
(413299, 'PTHR12136:SF91', NULL, NULL, NULL, NULL, 'DUF1336 DOMAIN-CONTAINING PROTEIN', 251478),
(413300, 'PTHR12136:SF92', NULL, NULL, NULL, NULL, 'PROTEIN ENHANCED DISEASE RESISTANCE 2', 251478),
(413301, 'PTHR12136:SF106', NULL, NULL, NULL, NULL, 'PROTEIN ENHANCED DISEASE RESISTANCE 2-LIKE', 251478),
(413302, 'PTHR12136:SF117', NULL, NULL, NULL, NULL, 'DUF1336 DOMAIN-CONTAINING PROTEIN', 251478),
(413303, 'PTHR12136:SF105', NULL, NULL, NULL, NULL, 'PROTEIN ENHANCED DISEASE RESISTANCE 2', 251478); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(413304, 'PTHR12136:SF116', NULL, NULL, NULL, NULL, 'BNAA04G27680D PROTEIN', 251478),
(413305, 'PTHR12136:SF115', NULL, NULL, NULL, NULL, 'PROTEIN ENHANCED DISEASE RESISTANCE 2-LIKE', 251478),
(413306, 'PTHR12136:SF104', NULL, NULL, NULL, NULL, 'PLECKSTRIN-LIKE (PH) AND LIPID-BINDING START DOMAIN PROTEIN', 251478),
(413307, 'PTHR12136:SF103', NULL, NULL, NULL, NULL, 'PLECKSTRIN-LIKE (PH) AND LIPID-BINDING START DOMAIN PROTEIN', 251478),
(413308, 'PTHR12136:SF114', NULL, NULL, NULL, NULL, 'START DOMAIN, PH DOMAIN-LIKE, START-LIKE DOMAIN PROTEIN-RELATED', 251478),
(413309, 'PTHR12136:SF113', NULL, NULL, NULL, NULL, 'BNAC06G15410D PROTEIN', 251478),
(413310, 'PTHR12136:SF47', NULL, NULL, NULL, NULL, 'ENHANCED DISEASE RESISTANCE PROTEIN (DUF1336)', 251478),
(413311, 'PTHR12136:SF101', NULL, NULL, NULL, NULL, 'ENHANCED DISEASE RESISTANCE-LIKE PROTEIN (DUF1336)', 251478),
(413312, 'PTHR12136:SF99', NULL, NULL, NULL, NULL, 'PROTEIN ENHANCED DISEASE RESISTANCE 2-LIKE', 251478),
(413313, 'PTHR12136:SF100', NULL, NULL, NULL, NULL, 'PROTEIN ENHANCED DISEASE RESISTANCE 2-LIKE', 251478),
(413314, 'PTHR12136:SF111', NULL, NULL, NULL, NULL, 'PROTEIN ENHANCED DISEASE RESISTANCE 2', 251478),
(413315, 'PTHR12136:SF110', NULL, NULL, NULL, NULL, 'DUF1336 DOMAIN-CONTAINING PROTEIN', 251478),
(413316, 'PTHR12136:SF108', NULL, NULL, NULL, NULL, 'DUF1336 DOMAIN-CONTAINING PROTEIN', 251478),
(413317, 'PTHR12136:SF107', NULL, NULL, NULL, NULL, 'START DOMAIN, PH DOMAIN-LIKE, START-LIKE DOMAIN PROTEIN-RELATED', 251478),
(413318, 'PTHR12136:SF118', NULL, NULL, NULL, NULL, 'PROTEIN ENHANCED DISEASE RESISTANCE 2-LIKE', 251478),
(413319, 'PTHR12136', NULL, NULL, NULL, NULL, 'ENHANCED DISEASE RESISTANCE-RELATED', 251478),
(413320, 'PTHR28672', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT 13', 251479),
(413321, 'PTHR28672:SF1', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT 13', 251479),
(413322, 'PTHR43452:SF1', NULL, NULL, NULL, NULL, 'PYRUVATE DECARBOXYLASE', 251480),
(413323, 'PTHR43452:SF3', NULL, NULL, NULL, NULL, 'TRANSAMINATED AMINO ACID DECARBOXYLASE', 251480),
(413324, 'PTHR43452:SF20', NULL, NULL, NULL, NULL, 'PYRUVATE DECARBOXYLASE 2', 251480),
(413325, 'PTHR43452:SF31', NULL, NULL, NULL, NULL, 'PYRUVATE DECARBOXYLASE', 251480),
(413326, 'PTHR43452:SF5', NULL, NULL, NULL, NULL, 'PYRUVATE DECARBOXYLASE 3', 251480),
(413327, 'PTHR43452:SF30', NULL, NULL, NULL, NULL, 'PYRUVATE DECARBOXYLASE ISOZYME 1-RELATED', 251480),
(413328, 'PTHR43452:SF6', NULL, NULL, NULL, NULL, 'PYRUVATE DECARBOXYLASE C186.09-RELATED', 251480),
(413329, 'PTHR43452:SF7', NULL, NULL, NULL, NULL, 'PYRUVATE DECARBOXYLASE 1', 251480),
(413330, 'PTHR43452:SF35', NULL, NULL, NULL, NULL, 'PYRUVATE DECARBOXYLASE', 251480),
(413331, 'PTHR43452:SF34', NULL, NULL, NULL, NULL, 'PYRUVATE DECARBOXYLASE', 251480),
(413332, 'PTHR43452:SF22', NULL, NULL, NULL, NULL, 'PYRUVATE DECARBOXYLASE', 251480),
(413333, 'PTHR43452:SF33', NULL, NULL, NULL, NULL, 'PYRUVATE DECARBOXYLASE', 251480),
(413334, 'PTHR43452:SF11', NULL, NULL, NULL, NULL, 'PYRUVATE DECARBOXYLASE', 251480),
(413335, 'PTHR43452:SF21', NULL, NULL, NULL, NULL, 'PYRUVATE DECARBOXYLASE', 251480),
(413336, 'PTHR43452', NULL, NULL, NULL, NULL, 'PYRUVATE DECARBOXYLASE', 251480),
(413337, 'PTHR43452:SF17', NULL, NULL, NULL, NULL, 'PYRUVATE DECARBOXYLASE', 251480),
(413338, 'PTHR43452:SF38', NULL, NULL, NULL, NULL, 'PYRUVATE DECARBOXYLASE 3-RELATED', 251480),
(413339, 'PTHR43452:SF37', NULL, NULL, NULL, NULL, 'PYRUVATE DECARBOXYLASE', 251480),
(413340, 'PTHR43452:SF36', NULL, NULL, NULL, NULL, 'PYRUVATE DECARBOXYLASE C3G9.11C-RELATED', 251480),
(413341, 'PTHR43452:SF25', NULL, NULL, NULL, NULL, 'PYRUVATE DECARBOXYLASE', 251480),
(413342, 'PTHR43452:SF29', NULL, NULL, NULL, NULL, 'PYRUVATE DECARBOXYLASE', 251480),
(413343, 'PTHR43452:SF18', NULL, NULL, NULL, NULL, 'PYRUVATE DECARBOXYLASE 1', 251480),
(413344, 'PTHR12737', NULL, NULL, NULL, NULL, 'DIMETHYLARGININE DIMETHYLAMINOHYDROLASE', 251481),
(413345, 'PTHR12737:SF9', NULL, NULL, NULL, NULL, 'DIMETHYLARGININASE', 251481),
(413346, 'PTHR12737:SF16', NULL, NULL, NULL, NULL, 'N(G),N(G)-DIMETHYLARGININE DIMETHYLAMINOHYDROLASE 2', 251481);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(413347, 'PTHR12737:SF17', NULL, NULL, NULL, NULL, 'N(G),N(G)-DIMETHYLARGININE DIMETHYLAMINOHYDROLASE 1', 251481),
(413348, 'PTHR34203:SF15', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE, FKBM FAMILY PROTEIN', 251482),
(413349, 'PTHR34203:SF13', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251482),
(413350, 'PTHR34203', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE, FKBM FAMILY PROTEIN', 251482),
(413351, 'PTHR13190:SF20', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 2 HOMOLOG B', 251483),
(413352, 'PTHR13190:SF1', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED 2, ISOFORM A', 251483),
(413353, 'PTHR13190:SF23', NULL, NULL, NULL, NULL, '', 251483),
(413354, 'PTHR13190', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED 2, ISOFORM A', 251483),
(413355, 'PTHR13190:SF22', NULL, NULL, NULL, NULL, '', 251483),
(413356, 'PTHR13190:SF21', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 2 HOMOLOG A', 251483),
(413357, 'PTHR12651', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 9', 251484),
(413358, 'PTHR12651:SF1', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 9', 251484),
(413359, 'PTHR43306:SF1', NULL, NULL, NULL, NULL, '7,8-DIHYDRO-6-HYDROXYMETHYLPTERIN DIMETHYLTRANSFERASE', 251485),
(413360, 'PTHR43306', NULL, NULL, NULL, NULL, '7,8-DIHYDRO-6-HYDROXYMETHYLPTERIN DIMETHYLTRANSFERASE', 251485),
(413361, 'PTHR30587', NULL, NULL, NULL, NULL, 'FLAGELLAR BIOSYNTHETIC PROTEIN FLIP', 251486),
(413362, 'PTHR30587:SF3', NULL, NULL, NULL, NULL, 'VIRULENCE PROTEIN YSCR', 251486),
(413363, 'PTHR30587:SF2', NULL, NULL, NULL, NULL, 'SURFACE PRESENTATION OF ANTIGENS PROTEIN SPAP', 251486),
(413364, 'PTHR30587:SF0', NULL, NULL, NULL, NULL, 'FLAGELLAR BIOSYNTHETIC PROTEIN FLIP', 251486),
(413365, 'PTHR31845:SF19', NULL, NULL, NULL, NULL, 'CHROMOSOME 12, WHOLE GENOME SHOTGUN SEQUENCE', 251487),
(413366, 'PTHR31845:SF17', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PBCR-RELATED', 251487),
(413367, 'PTHR31845:SF18', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 251487),
(413368, 'PTHR31845:SF27', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 251487),
(413369, 'PTHR31845:SF35', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G00410)-RELATED', 251487),
(413370, 'PTHR31845:SF36', NULL, NULL, NULL, NULL, 'DUF1671 DOMAIN-CONTAINING PROTEIN', 251487),
(413371, 'PTHR31845:SF33', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 251487),
(413372, 'PTHR31845:SF34', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 251487),
(413373, 'PTHR31845:SF21', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN LEU3', 251487),
(413374, 'PTHR31845:SF10', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 251487),
(413375, 'PTHR31845:SF32', NULL, NULL, NULL, NULL, 'MISCELLANEOUS ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 251487),
(413376, 'PTHR31845', NULL, NULL, NULL, NULL, 'FINGER DOMAIN PROTEIN, PUTATIVE-RELATED', 251487),
(413377, 'PTHR31845:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SEF1-RELATED', 251487),
(413378, 'PTHR47889', NULL, NULL, NULL, NULL, 'SPERMATOGENIC LEUCINE ZIPPER PROTEIN 1', 251488),
(413379, 'PTHR47889:SF1', NULL, NULL, NULL, NULL, 'SPERMATOGENIC LEUCINE ZIPPER PROTEIN 1', 251488),
(413380, 'PTHR47195', NULL, NULL, NULL, NULL, 'KELCH REPEAT AND BTB DOMAIN-CONTAINING PROTEIN 4', 251489),
(413381, 'PTHR47195:SF1', NULL, NULL, NULL, NULL, 'KELCH REPEAT AND BTB DOMAIN-CONTAINING PROTEIN 4', 251489),
(413382, 'PTHR42902:SF4', NULL, NULL, NULL, NULL, 'MALATE SYNTHASE', 251490),
(413383, 'PTHR42902', NULL, NULL, NULL, NULL, 'MALATE SYNTHASE', 251490),
(413384, 'PTHR42902:SF2', NULL, NULL, NULL, NULL, 'MALATE SYNTHASE', 251490),
(413385, 'PTHR42902:SF3', NULL, NULL, NULL, NULL, 'MALATE SYNTHASE', 251490),
(413386, 'PTHR42902:SF1', NULL, NULL, NULL, NULL, 'MALATE SYNTHASE 1-RELATED', 251490),
(413387, 'PTHR47971:SF19', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 251491),
(413388, 'PTHR47971:SF1', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 251491);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(413389, 'PTHR47971:SF18', NULL, NULL, NULL, NULL, 'KINESIN KIF4-LIKE PROTEIN, PUTATIVE-RELATED', 251491),
(413390, 'PTHR47971:SF16', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 251491),
(413391, 'PTHR47971', NULL, NULL, NULL, NULL, 'KINESIN-RELATED PROTEIN 6', 251491),
(413392, 'PTHR47971:SF9', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-13B', 251491),
(413393, 'PTHR47971:SF8', NULL, NULL, NULL, NULL, 'KINESIN-RELATED PROTEIN 6', 251491),
(413394, 'PTHR47971:SF6', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 251491),
(413395, 'PTHR47971:SF5', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 251491),
(413396, 'PTHR47971:SF4', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 251491),
(413397, 'PTHR47971:SF11', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 251491),
(413398, 'PTHR47971:SF22', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 251491),
(413399, 'PTHR47971:SF21', NULL, NULL, NULL, NULL, 'CXC DOMAIN-CONTAINING PROTEIN', 251491),
(413400, 'PTHR47971:SF10', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN', 251491),
(413401, 'PTHR47971:SF20', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF24', 251491),
(413402, 'PTHR47971:SF15', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-13B', 251491),
(413403, 'PTHR47971:SF23', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-13A', 251491),
(413404, 'PTHR31646:SF1', NULL, NULL, NULL, NULL, 'ALPHA-1,2-MANNOSYLTRANSFERASE MNN2-RELATED', 251492),
(413405, 'PTHR31646', NULL, NULL, NULL, NULL, 'ALPHA-1,2-MANNOSYLTRANSFERASE MNN2', 251492),
(413406, 'PTHR31646:SF5', NULL, NULL, NULL, NULL, '(MNN2), PUTATIVE (AFU_ORTHOLOGUE AFUA_6G04450)-RELATED', 251492),
(413407, 'PTHR38008:SF1', NULL, NULL, NULL, NULL, 'LIPOPROTEIN-RELATED', 251493),
(413408, 'PTHR38008:SF2', NULL, NULL, NULL, NULL, 'HEMOLYSIN-RELATED', 251493),
(413409, 'PTHR38008', NULL, NULL, NULL, NULL, 'HEMOLYSIN-RELATED', 251493),
(413410, 'PTHR36453:SF1', NULL, NULL, NULL, NULL, 'BETA_HELIX DOMAIN-CONTAINING PROTEIN', 251494),
(413411, 'PTHR36453', NULL, NULL, NULL, NULL, 'SECRETED PROTEIN-RELATED', 251494),
(413412, 'PTHR13492', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 37', 251495),
(413413, 'PTHR13492:SF2', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 37', 251495),
(413414, 'PTHR33331', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 162', 251496),
(413415, 'PTHR33331:SF13', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 162', 251496),
(413416, 'PTHR34583:SF3', NULL, NULL, NULL, NULL, 'MULTISUBUNIT SODIUM/HYDROGEN ANTIPORTER, MNHC SUBUNIT', 251497),
(413417, 'PTHR34583:SF2', NULL, NULL, NULL, NULL, 'ANTIPORTER SUBUNIT MNHC2-RELATED', 251497),
(413418, 'PTHR34583', NULL, NULL, NULL, NULL, 'ANTIPORTER SUBUNIT MNHC2-RELATED', 251497),
(413419, 'PTHR36582', NULL, NULL, NULL, NULL, 'ANTITOXIN PARD', 251498),
(413420, 'PTHR36582:SF2', NULL, NULL, NULL, NULL, 'ANTITOXIN PARD', 251498),
(413421, 'PTHR23210:SF22', NULL, NULL, NULL, NULL, 'ACTIVATING TRANSCRIPTION FACTOR 7-INTERACTING PROTEIN 1', 251499),
(413422, 'PTHR23210:SF26', NULL, NULL, NULL, NULL, 'ACTIVATING TRANSCRIPTION FACTOR 7-INTERACTING PROTEIN 1', 251499),
(413423, 'PTHR23210:SF23', NULL, NULL, NULL, NULL, 'ACTIVATING TRANSCRIPTION FACTOR 7-INTERACTING PROTEIN 2', 251499),
(413424, 'PTHR23210', NULL, NULL, NULL, NULL, 'ACTIVATING TRANSCRIPTION FACTOR 7 INTERACTING PROTEIN', 251499),
(413425, 'PTHR28256', NULL, NULL, NULL, NULL, 'RIBONUCLEASES P/MRP PROTEIN SUBUNIT POP7', 251500),
(413426, 'PTHR28256:SF1', NULL, NULL, NULL, NULL, 'RIBONUCLEASES P/MRP PROTEIN SUBUNIT POP7', 251500),
(413427, 'PTHR14487:SF3', NULL, NULL, NULL, NULL, 'ADRENOCORTICAL DYSPLASIA PROTEIN HOMOLOG', 251501),
(413428, 'PTHR14487', NULL, NULL, NULL, NULL, 'ADRENOCORTICAL DYSPLASIA PROTEIN ACD', 251501),
(413429, 'PTHR46956', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE KINASE 6', 251502),
(413430, 'PTHR46956:SF1', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE KINASE 6', 251502),
(413431, 'PTHR10797:SF60', NULL, NULL, NULL, NULL, 'POLY(A)-SPECIFIC RIBONUCLEASE', 251503),
(413432, 'PTHR10797:SF1', NULL, NULL, NULL, NULL, 'CCR4-NOT TRANSCRIPTION COMPLEX SUBUNIT 8', 251503);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(413433, 'PTHR10797:SF0', NULL, NULL, NULL, NULL, 'CCR4-NOT TRANSCRIPTION COMPLEX SUBUNIT 7', 251503),
(413434, 'PTHR10797:SF38', NULL, NULL, NULL, NULL, 'POLY(A)-SPECIFIC RIBONUCLEASE', 251503),
(413435, 'PTHR10797:SF6', NULL, NULL, NULL, NULL, 'CAF1 FAMILY RIBONUCLEASE CONTAINING PROTEIN', 251503),
(413436, 'PTHR10797:SF7', NULL, NULL, NULL, NULL, 'POLY(A)-SPECIFIC RIBONUCLEASE', 251503),
(413437, 'PTHR10797:SF58', NULL, NULL, NULL, NULL, '', 251503),
(413438, 'PTHR10797:SF36', NULL, NULL, NULL, NULL, 'OS10G0421700 PROTEIN', 251503),
(413439, 'PTHR10797:SF37', NULL, NULL, NULL, NULL, 'POLY(A)-SPECIFIC RIBONUCLEASE', 251503),
(413440, 'PTHR10797:SF59', NULL, NULL, NULL, NULL, 'POLY(A)-SPECIFIC RIBONUCLEASE', 251503),
(413441, 'PTHR10797:SF56', NULL, NULL, NULL, NULL, 'CCR4-ASSOCIATED FACTOR 1 HOMOLOG 1-RELATED', 251503),
(413442, 'PTHR10797:SF78', NULL, NULL, NULL, NULL, 'POLY(A)-SPECIFIC RIBONUCLEASE', 251503),
(413443, 'PTHR10797:SF13', NULL, NULL, NULL, NULL, 'POLY(A)-SPECIFIC RIBONUCLEASE', 251503),
(413444, 'PTHR10797:SF35', NULL, NULL, NULL, NULL, 'CCR4-ASSOCIATED FACTOR 1 HOMOLOG 9-RELATED', 251503),
(413445, 'PTHR10797:SF57', NULL, NULL, NULL, NULL, 'CCR4-ASSOCIATED FACTOR 1 HOMOLOG 3-RELATED', 251503),
(413446, 'PTHR10797:SF76', NULL, NULL, NULL, NULL, 'CCR4-NOT TRANSCRIPTION COMPLEX SUBUNIT 7', 251503),
(413447, 'PTHR10797:SF10', NULL, NULL, NULL, NULL, 'POLY(A)-SPECIFIC RIBONUCLEASE', 251503),
(413448, 'PTHR10797:SF55', NULL, NULL, NULL, NULL, 'CCR4-ASSOCIATED FACTOR 1 HOMOLOG 2-RELATED', 251503),
(413449, 'PTHR10797:SF77', NULL, NULL, NULL, NULL, 'POLY(A)-SPECIFIC RIBONUCLEASE', 251503),
(413450, 'PTHR10797:SF74', NULL, NULL, NULL, NULL, 'POLY(A)-SPECIFIC RIBONUCLEASE', 251503),
(413451, 'PTHR10797:SF52', NULL, NULL, NULL, NULL, 'POLY(A)-SPECIFIC RIBONUCLEASE', 251503),
(413452, 'PTHR10797:SF75', NULL, NULL, NULL, NULL, 'POLY(A)-SPECIFIC RIBONUCLEASE', 251503),
(413453, 'PTHR10797:SF50', NULL, NULL, NULL, NULL, 'POLY(A)-SPECIFIC RIBONUCLEASE', 251503),
(413454, 'PTHR10797:SF73', NULL, NULL, NULL, NULL, 'POLY(A)-SPECIFIC RIBONUCLEASE', 251503),
(413455, 'PTHR10797:SF70', NULL, NULL, NULL, NULL, 'RIBONUCLEASE CAF1, RIBONUCLEASE H-LIKE DOMAIN PROTEIN-RELATED', 251503),
(413456, 'PTHR10797:SF71', NULL, NULL, NULL, NULL, 'POLY(A)-SPECIFIC RIBONUCLEASE', 251503),
(413457, 'PTHR10797', NULL, NULL, NULL, NULL, 'CCR4-NOT TRANSCRIPTION COMPLEX SUBUNIT', 251503),
(413458, 'PTHR10797:SF47', NULL, NULL, NULL, NULL, 'POLY(A)-SPECIFIC RIBONUCLEASE', 251503),
(413459, 'PTHR10797:SF48', NULL, NULL, NULL, NULL, 'CCR4-ASSOCIATED FACTOR 1 HOMOLOG 11-RELATED', 251503),
(413460, 'PTHR10797:SF68', NULL, NULL, NULL, NULL, 'CCR4-ASSOCIATED FACTOR 1 HOMOLOG 10-RELATED', 251503),
(413461, 'PTHR10797:SF65', NULL, NULL, NULL, NULL, 'POLY(A)-SPECIFIC RIBONUCLEASE', 251503),
(413462, 'PTHR10797:SF43', NULL, NULL, NULL, NULL, 'POLY(A)-SPECIFIC RIBONUCLEASE', 251503),
(413463, 'PTHR10797:SF66', NULL, NULL, NULL, NULL, 'POLY(A)-SPECIFIC RIBONUCLEASE', 251503),
(413464, 'PTHR10797:SF63', NULL, NULL, NULL, NULL, 'POLY(A)-SPECIFIC RIBONUCLEASE', 251503),
(413465, 'PTHR10797:SF42', NULL, NULL, NULL, NULL, 'POLY(A)-SPECIFIC RIBONUCLEASE', 251503),
(413466, 'PTHR10797:SF62', NULL, NULL, NULL, NULL, 'POLY(A)-SPECIFIC RIBONUCLEASE', 251503),
(413467, 'PTHR36944:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG02791', 251504),
(413468, 'PTHR36944:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG19295', 251504),
(413469, 'PTHR36944:SF4', NULL, NULL, NULL, NULL, 'CPG4 DOMAIN-CONTAINING PROTEIN', 251504),
(413470, 'PTHR36944', NULL, NULL, NULL, NULL, 'PROTEIN CBG02791-RELATED', 251504),
(413471, 'PTHR36944:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG10961', 251504),
(413472, 'PTHR31967:SF16', NULL, NULL, NULL, NULL, 'GROUND-LIKE DOMAIN-CONTAINING PROTEIN', 251505),
(413473, 'PTHR31967:SF19', NULL, NULL, NULL, NULL, 'GROUND-LIKE DOMAIN-CONTAINING PROTEIN', 251505),
(413474, 'PTHR31967:SF18', NULL, NULL, NULL, NULL, 'GROUNDHOG (HEDGEHOG-LIKE FAMILY)', 251505),
(413475, 'PTHR31967:SF23', NULL, NULL, NULL, NULL, 'GROUND-LIKE DOMAIN-CONTAINING PROTEIN', 251505);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(413476, 'PTHR31967:SF12', NULL, NULL, NULL, NULL, 'NUCLEOTID_TRANS DOMAIN-CONTAINING PROTEIN', 251505),
(413477, 'PTHR31967:SF9', NULL, NULL, NULL, NULL, 'NUCLEOTID_TRANS DOMAIN-CONTAINING PROTEIN', 251505),
(413478, 'PTHR31967:SF14', NULL, NULL, NULL, NULL, 'GROUND-LIKE DOMAIN-CONTAINING PROTEIN', 251505),
(413479, 'PTHR31967:SF4', NULL, NULL, NULL, NULL, 'NUCLEOTID_TRANS DOMAIN-CONTAINING PROTEIN', 251505),
(413480, 'PTHR31967:SF5', NULL, NULL, NULL, NULL, 'NUCLEOTID_TRANS DOMAIN-CONTAINING PROTEIN', 251505),
(413481, 'PTHR31967', NULL, NULL, NULL, NULL, 'GROUNDHOG (HEDGEHOG-LIKE FAMILY)-RELATED', 251505),
(413482, 'PTHR31967:SF20', NULL, NULL, NULL, NULL, 'GROUND-LIKE DOMAIN-CONTAINING PROTEIN', 251505),
(413483, 'PTHR31967:SF11', NULL, NULL, NULL, NULL, 'NUCLEOTID_TRANS DOMAIN-CONTAINING PROTEIN', 251505),
(413484, 'PTHR31967:SF21', NULL, NULL, NULL, NULL, 'GROUND-LIKE DOMAIN-CONTAINING PROTEIN', 251505),
(413485, 'PTHR31967:SF10', NULL, NULL, NULL, NULL, 'NUCLEOTID_TRANS DOMAIN-CONTAINING PROTEIN', 251505),
(413486, 'PTHR43903:SF12', NULL, NULL, NULL, NULL, 'COESTERASE DOMAIN-CONTAINING PROTEIN', 251506),
(413487, 'PTHR43903:SF23', NULL, NULL, NULL, NULL, 'NEUROLIGIN 1, ISOFORM D', 251506),
(413488, 'PTHR43903:SF21', NULL, NULL, NULL, NULL, 'NEUROLIGIN 3, ISOFORM B', 251506),
(413489, 'PTHR43903:SF10', NULL, NULL, NULL, NULL, 'NEUROLIGIN-4, Y-LINKED', 251506),
(413490, 'PTHR43903', NULL, NULL, NULL, NULL, 'NEUROLIGIN', 251506),
(413491, 'PTHR43903:SF9', NULL, NULL, NULL, NULL, 'NEUROLIGIN 4, ISOFORM F', 251506),
(413492, 'PTHR43903:SF8', NULL, NULL, NULL, NULL, 'NEUROLIGIN 2B', 251506),
(413493, 'PTHR43903:SF3', NULL, NULL, NULL, NULL, 'NEUROLIGIN-2', 251506),
(413494, 'PTHR43903:SF2', NULL, NULL, NULL, NULL, 'NEUROLIGIN-1', 251506),
(413495, 'PTHR43903:SF4', NULL, NULL, NULL, NULL, 'NEUROLIGIN-3', 251506),
(413496, 'PTHR43903:SF26', NULL, NULL, NULL, NULL, 'FI18641P1', 251506),
(413497, 'PTHR43903:SF15', NULL, NULL, NULL, NULL, 'FI21425P1', 251506),
(413498, 'PTHR43903:SF25', NULL, NULL, NULL, NULL, 'NEUROLIGIN-4, X-LINKED', 251506),
(413499, 'PTHR43903:SF1', NULL, NULL, NULL, NULL, 'BILE SALT-ACTIVATED LIPASE', 251506),
(413500, 'PTHR43903:SF24', NULL, NULL, NULL, NULL, 'NEUROLIGIN-LIKE PROTEIN GLIT-1', 251506),
(413501, 'PTHR43903:SF13', NULL, NULL, NULL, NULL, 'ACETYLCHOLINESTERASE-LIKE PROTEIN', 251506),
(413502, 'PTHR44733', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 22', 251507),
(413503, 'PTHR44733:SF1', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 22', 251507),
(413504, 'PTHR38439', NULL, NULL, NULL, NULL, 'AURACYANIN-B', 251508),
(413505, 'PTHR38439:SF2', NULL, NULL, NULL, NULL, 'AZURIN', 251508),
(413506, 'PTHR38439:SF3', NULL, NULL, NULL, NULL, 'AURACYANIN-B', 251508),
(413507, 'PTHR43979:SF1', NULL, NULL, NULL, NULL, 'PRE-MRNA-PROCESSING FACTOR 17', 251509),
(413508, 'PTHR43979', NULL, NULL, NULL, NULL, 'PRE-MRNA-PROCESSING FACTOR 17', 251509),
(413509, 'PTHR10540:SF12', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 7', 251510),
(413510, 'PTHR10540:SF6', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT F', 251510),
(413511, 'PTHR10540:SF23', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT F', 251510),
(413512, 'PTHR10540:SF7', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 7', 251510),
(413513, 'PTHR10540:SF22', NULL, NULL, NULL, NULL, 'MPN DOMAIN-CONTAINING PROTEIN', 251510),
(413514, 'PTHR10540:SF21', NULL, NULL, NULL, NULL, 'MPN DOMAIN-CONTAINING PROTEIN', 251510),
(413515, 'PTHR10540:SF32', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 7 HOMOLOG A', 251510),
(413516, 'PTHR10540:SF10', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT F', 251510),
(413517, 'PTHR10540:SF8', NULL, NULL, NULL, NULL, 'COP9 SIGNALOSOME COMPLEX SUBUNIT 6', 251510),
(413518, 'PTHR10540:SF16', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT F', 251510),
(413519, 'PTHR10540:SF15', NULL, NULL, NULL, NULL, 'MPN DOMAIN-CONTAINING PROTEIN', 251510);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(413520, 'PTHR10540:SF14', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT F', 251510),
(413521, 'PTHR10540:SF31', NULL, NULL, NULL, NULL, 'COP9 SIGNALOSOME COMPLEX SUBUNIT 6', 251510),
(413522, 'PTHR10540:SF30', NULL, NULL, NULL, NULL, '26S PROTEASOME REGULATORY PARTICLE NON-ATPASE SUBUNIT 8', 251510),
(413523, 'PTHR10540', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT F-RELATED', 251510),
(413524, 'PTHR10540:SF29', NULL, NULL, NULL, NULL, 'COP9 SIGNALOSOME COMPLEX SUBUNIT 6', 251510),
(413525, 'PTHR10540:SF18', NULL, NULL, NULL, NULL, 'COP9 SIGNALOSOME COMPLEX SUBUNIT 6B', 251510),
(413526, 'PTHR15506', NULL, NULL, NULL, NULL, 'DOPPEL PRION', 251511),
(413527, 'PTHR15506:SF3', NULL, NULL, NULL, NULL, 'MAJOR PRION PROTEIN', 251511),
(413528, 'PTHR15506:SF2', NULL, NULL, NULL, NULL, 'MAJOR PRION PROTEIN', 251511),
(413529, 'PTHR15506:SF0', NULL, NULL, NULL, NULL, 'PRION-LIKE PROTEIN DOPPEL', 251511),
(413530, 'PTHR33207:SF43', NULL, NULL, NULL, NULL, 'TOPLESS-RELATED PROTEIN 2', 251512),
(413531, 'PTHR33207:SF87', NULL, NULL, NULL, NULL, 'OS01G0509900 PROTEIN', 251512),
(413532, 'PTHR33207:SF42', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251512),
(413533, 'PTHR33207:SF45', NULL, NULL, NULL, NULL, '', 251512),
(413534, 'PTHR33207:SF89', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251512),
(413535, 'PTHR33207:SF88', NULL, NULL, NULL, NULL, '', 251512),
(413536, 'PTHR33207:SF49', NULL, NULL, NULL, NULL, 'OS10G0183300 PROTEIN', 251512),
(413537, 'PTHR33207:SF100', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN', 251512),
(413538, 'PTHR33207:SF104', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN', 251512),
(413539, 'PTHR33207:SF103', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251512),
(413540, 'PTHR33207:SF107', NULL, NULL, NULL, NULL, 'OS02G0294100 PROTEIN', 251512),
(413541, 'PTHR33207:SF90', NULL, NULL, NULL, NULL, '', 251512),
(413542, 'PTHR33207:SF109', NULL, NULL, NULL, NULL, '', 251512),
(413543, 'PTHR33207:SF91', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251512),
(413544, 'PTHR33207:SF50', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251512),
(413545, 'PTHR33207:SF94', NULL, NULL, NULL, NULL, 'OS09G0341600 PROTEIN', 251512),
(413546, 'PTHR33207:SF95', NULL, NULL, NULL, NULL, 'OS07G0554900 PROTEIN', 251512),
(413547, 'PTHR33207:SF32', NULL, NULL, NULL, NULL, 'OS01G0165800 PROTEIN', 251512),
(413548, 'PTHR33207:SF75', NULL, NULL, NULL, NULL, '', 251512),
(413549, 'PTHR33207:SF78', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251512),
(413550, 'PTHR33207:SF77', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251512),
(413551, 'PTHR33207:SF38', NULL, NULL, NULL, NULL, 'OS09G0260300 PROTEIN', 251512),
(413552, 'PTHR33207:SF111', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251512),
(413553, 'PTHR33207:SF110', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251512),
(413554, 'PTHR33207:SF113', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251512),
(413555, 'PTHR33207:SF112', NULL, NULL, NULL, NULL, '', 251512),
(413556, 'PTHR33207:SF115', NULL, NULL, NULL, NULL, '', 251512),
(413557, 'PTHR33207:SF114', NULL, NULL, NULL, NULL, 'OS04G0324600 PROTEIN', 251512),
(413558, 'PTHR33207:SF117', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251512),
(413559, 'PTHR33207:SF116', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251512),
(413560, 'PTHR33207:SF119', NULL, NULL, NULL, NULL, 'OS04G0349550 PROTEIN', 251512),
(413561, 'PTHR33207:SF118', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251512),
(413562, 'PTHR33207:SF80', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251512),
(413563, 'PTHR33207:SF83', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251512),
(413564, 'PTHR33207:SF82', NULL, NULL, NULL, NULL, '', 251512),
(413565, 'PTHR33207:SF85', NULL, NULL, NULL, NULL, '', 251512),
(413566, 'PTHR33207:SF40', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 251512);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(413567, 'PTHR33207:SF84', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251512),
(413568, 'PTHR33207:SF21', NULL, NULL, NULL, NULL, 'OS07G0517700 PROTEIN', 251512),
(413569, 'PTHR33207:SF65', NULL, NULL, NULL, NULL, '', 251512),
(413570, 'PTHR33207:SF64', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251512),
(413571, 'PTHR33207:SF69', NULL, NULL, NULL, NULL, 'OS09G0241550 PROTEIN', 251512),
(413572, 'PTHR33207:SF24', NULL, NULL, NULL, NULL, '', 251512),
(413573, 'PTHR33207:SF2', NULL, NULL, NULL, NULL, 'OS09G0324200 PROTEIN', 251512),
(413574, 'PTHR33207:SF29', NULL, NULL, NULL, NULL, 'OS02G0288925 PROTEIN', 251512),
(413575, 'PTHR33207:SF28', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN', 251512),
(413576, 'PTHR33207:SF120', NULL, NULL, NULL, NULL, 'BED-TYPE DOMAIN-CONTAINING PROTEIN', 251512),
(413577, 'PTHR33207', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN-RELATED', 251512),
(413578, 'PTHR33207:SF71', NULL, NULL, NULL, NULL, 'OSJNBA0087H01.6-LIKE PROTEIN', 251512),
(413579, 'PTHR33207:SF74', NULL, NULL, NULL, NULL, '', 251512),
(413580, 'PTHR33207:SF30', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251512),
(413581, 'PTHR33207:SF73', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251512),
(413582, 'PTHR33207:SF54', NULL, NULL, NULL, NULL, 'OS05G0147800 PROTEIN', 251512),
(413583, 'PTHR33207:SF97', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251512),
(413584, 'PTHR33207:SF56', NULL, NULL, NULL, NULL, '', 251512),
(413585, 'PTHR33207:SF99', NULL, NULL, NULL, NULL, 'OS09G0324300 PROTEIN', 251512),
(413586, 'PTHR33207:SF58', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251512),
(413587, 'PTHR33207:SF57', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251512),
(413588, 'PTHR33207:SF60', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251512),
(413589, 'PTHR33207:SF62', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 251512),
(413590, 'PTHR23037:SF32', NULL, NULL, NULL, NULL, 'INTERLEUKIN-4 RECEPTOR SUBUNIT ALPHA', 251513),
(413591, 'PTHR23037:SF31', NULL, NULL, NULL, NULL, 'THROMBOPOIETIN RECEPTOR', 251513),
(413592, 'PTHR23037:SF30', NULL, NULL, NULL, NULL, 'INTERLEUKIN-2 RECEPTOR SUBUNIT BETA', 251513),
(413593, 'PTHR23037:SF40', NULL, NULL, NULL, NULL, 'INTERLEUKIN 2 RECEPTOR GAMMA COMMON.B', 251513),
(413594, 'PTHR23037:SF29', NULL, NULL, NULL, NULL, 'INTERLEUKIN-9 RECEPTOR', 251513),
(413595, 'PTHR23037:SF28', NULL, NULL, NULL, NULL, 'ERYTHROPOIETIN RECEPTOR', 251513),
(413596, 'PTHR23037:SF39', NULL, NULL, NULL, NULL, 'IL2RB_N1 DOMAIN-CONTAINING PROTEIN', 251513),
(413597, 'PTHR23037:SF27', NULL, NULL, NULL, NULL, 'INTERLEUKIN-7 RECEPTOR SUBUNIT ALPHA', 251513),
(413598, 'PTHR23037:SF38', NULL, NULL, NULL, NULL, 'GRANULOCYTE COLONY-STIMULATING FACTOR RECEPTOR', 251513),
(413599, 'PTHR23037:SF37', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE-III DOMAIN-CONTAINING PROTEIN', 251513),
(413600, 'PTHR23037:SF36', NULL, NULL, NULL, NULL, 'INTERLEUKIN 21 RECEPTOR, TANDEM DUPLICATE 1', 251513),
(413601, 'PTHR23037:SF7', NULL, NULL, NULL, NULL, 'INTERLEUKIN-21 RECEPTOR', 251513),
(413602, 'PTHR23037:SF35', NULL, NULL, NULL, NULL, '', 251513),
(413603, 'PTHR23037', NULL, NULL, NULL, NULL, 'CYTOKINE RECEPTOR', 251513),
(413604, 'PTHR23037:SF34', NULL, NULL, NULL, NULL, 'MPL PROTO-ONCOGENE, THROMBOPOIETIN RECEPTOR', 251513),
(413605, 'PTHR23037:SF22', NULL, NULL, NULL, NULL, 'CYTOKINE RECEPTOR COMMON SUBUNIT BETA', 251513),
(413606, 'PTHR23037:SF33', NULL, NULL, NULL, NULL, 'INTERLEUKIN-12 SUBUNIT BETA', 251513),
(413607, 'PTHR15123:SF5', NULL, NULL, NULL, NULL, 'SECRETED AND TRANSMEMBRANE PROTEIN 1', 251514),
(413608, 'PTHR15123:SF6', NULL, NULL, NULL, NULL, 'SECRETED AND TRANSMEMBRANE PROTEIN 1A', 251514),
(413609, 'PTHR15123', NULL, NULL, NULL, NULL, 'SECRETED AND TRANSMEMBRANE PROTEIN 1', 251514),
(413610, 'PTHR35632:SF1', NULL, NULL, NULL, NULL, 'MAJOR POLLEN ALLERGEN OLE E 6-LIKE', 251515),
(413611, 'PTHR35632:SF11', NULL, NULL, NULL, NULL, 'ANTI-PCD PROTEIN-RELATED', 251515);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(413612, 'PTHR35632:SF3', NULL, NULL, NULL, NULL, 'ANTI-PCD PROTEIN', 251515),
(413613, 'PTHR35632:SF2', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH PROTEIN', 251515),
(413614, 'PTHR35632:SF4', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH PROTEIN', 251515),
(413615, 'PTHR35632:SF7', NULL, NULL, NULL, NULL, '', 251515),
(413616, 'PTHR35632:SF6', NULL, NULL, NULL, NULL, 'ANTI-PCD PROTEIN', 251515),
(413617, 'PTHR35632:SF9', NULL, NULL, NULL, NULL, '', 251515),
(413618, 'PTHR35632:SF10', NULL, NULL, NULL, NULL, 'ANTI-PCD PROTEIN', 251515),
(413619, 'PTHR35632', NULL, NULL, NULL, NULL, 'MAJOR POLLEN ALLERGEN OLE E 6-LIKE', 251515),
(413620, 'PTHR43657', NULL, NULL, NULL, NULL, 'TRYPTOPHAN RNA-BINDING ATTENUATOR PROTEIN-LIKE PROTEIN', 251516),
(413621, 'PTHR43657:SF1', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN 24, MITOCHONDRIAL', 251516),
(413622, 'PTHR43657:SF3', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN 24, MITOCHONDRIAL', 251516),
(413623, 'PTHR43657:SF2', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN 24, MITOCHONDRIAL', 251516),
(413624, 'PTHR14791', NULL, NULL, NULL, NULL, 'BOMB/KIRA PROTEINS', 251517),
(413625, 'PTHR14791:SF48', NULL, NULL, NULL, NULL, 'BNAC03G58250D PROTEIN', 251517),
(413626, 'PTHR14791:SF26', NULL, NULL, NULL, NULL, 'PROTEIN WWC2', 251517),
(413627, 'PTHR14791:SF47', NULL, NULL, NULL, NULL, 'BNAA07G10590D PROTEIN', 251517),
(413628, 'PTHR14791:SF25', NULL, NULL, NULL, NULL, 'PROTEIN WWC3', 251517),
(413629, 'PTHR14791:SF46', NULL, NULL, NULL, NULL, 'BNAA02G18820D PROTEIN', 251517),
(413630, 'PTHR14791:SF45', NULL, NULL, NULL, NULL, 'BNACNNG51740D PROTEIN', 251517),
(413631, 'PTHR14791:SF23', NULL, NULL, NULL, NULL, 'AGAP006574-PA', 251517),
(413632, 'PTHR14791:SF29', NULL, NULL, NULL, NULL, 'PROTEIN KIBRA', 251517),
(413633, 'PTHR14791:SF39', NULL, NULL, NULL, NULL, 'WW DOMAIN-CONTAINING PROTEIN', 251517),
(413634, 'PTHR14791:SF44', NULL, NULL, NULL, NULL, 'BNACNNG56470D PROTEIN', 251517),
(413635, 'PTHR14791:SF22', NULL, NULL, NULL, NULL, 'PROTEIN KIBRA', 251517),
(413636, 'PTHR14791:SF43', NULL, NULL, NULL, NULL, 'BNAA04G19570D PROTEIN', 251517),
(413637, 'PTHR14791:SF54', NULL, NULL, NULL, NULL, 'WW DOMAIN CONTAINING PROTEIN', 251517),
(413638, 'PTHR14791:SF42', NULL, NULL, NULL, NULL, 'F16L1.2 PROTEIN', 251517),
(413639, 'PTHR14791:SF53', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE', 251517),
(413640, 'PTHR14791:SF52', NULL, NULL, NULL, NULL, 'BNAA05G10070D PROTEIN', 251517),
(413641, 'PTHR15305:SF0', NULL, NULL, NULL, NULL, 'MELANOMA ANTIGEN RECOGNIZED BY T-CELLS 1', 251518),
(413642, 'PTHR15305', NULL, NULL, NULL, NULL, 'MELANOMA ANTIGEN RECOGNIZED BY T-CELLS 1', 251518),
(413643, 'PTHR13601', NULL, NULL, NULL, NULL, 'GAMETOGENETIN-BINDING PROTEIN 2', 251519),
(413644, 'PTHR13601:SF2', NULL, NULL, NULL, NULL, 'GAMETOGENETIN-BINDING PROTEIN 2', 251519),
(413645, 'PTHR46156:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 3', 251520),
(413646, 'PTHR46156:SF3', NULL, NULL, NULL, NULL, 'BNAC08G19850D PROTEIN', 251520),
(413647, 'PTHR46156', NULL, NULL, NULL, NULL, 'CCCH ZINGC FINGER', 251520),
(413648, 'PTHR36839', NULL, NULL, NULL, NULL, 'METALLO-BETA-LACTAMASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_5G12770)', 251521),
(413649, 'PTHR36839:SF1', NULL, NULL, NULL, NULL, 'METALLO-BETA-LACTAMASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_5G12770)', 251521),
(413650, 'PTHR30070', NULL, NULL, NULL, NULL, 'HEME EXPORTER PROTEIN B', 251522),
(413651, 'PTHR30070:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME C BIOGENESIS B', 251522),
(413652, 'PTHR30070:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME C BIOGENESIS B-RELATED', 251522),
(413653, 'PTHR21527:SF10', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP35', 251523),
(413654, 'PTHR21527', NULL, NULL, NULL, NULL, 'NUCLEOPORIN NUP35', 251523),
(413655, 'PTHR21527:SF6', NULL, NULL, NULL, NULL, 'NUCLEOPORIN NUP35', 251523),
(413656, 'PTHR21527:SF14', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP35', 251523),
(413657, 'PTHR11691:SF8', NULL, NULL, NULL, NULL, 'INTERFERON EPSILON', 251524);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(413658, 'PTHR11691:SF71', NULL, NULL, NULL, NULL, 'INTERFERON ALPHA-16', 251524),
(413659, 'PTHR11691:SF60', NULL, NULL, NULL, NULL, 'INTERFERON ALPHA-5', 251524),
(413660, 'PTHR11691:SF6', NULL, NULL, NULL, NULL, 'INTERFERON KAPPA', 251524),
(413661, 'PTHR11691:SF70', NULL, NULL, NULL, NULL, 'INTERFERON ALPHA-2', 251524),
(413662, 'PTHR11691:SF66', NULL, NULL, NULL, NULL, 'INTERFERON ALPHA-10-RELATED', 251524),
(413663, 'PTHR11691:SF57', NULL, NULL, NULL, NULL, 'INTERFERON ALPHA-21', 251524),
(413664, 'PTHR11691:SF67', NULL, NULL, NULL, NULL, 'INTERFERON ALPHA-14', 251524),
(413665, 'PTHR11691:SF62', NULL, NULL, NULL, NULL, 'INTERFERON PHI 2-RELATED', 251524),
(413666, 'PTHR11691:SF72', NULL, NULL, NULL, NULL, 'INTERFERON BETA', 251524),
(413667, 'PTHR11691:SF61', NULL, NULL, NULL, NULL, 'INTERFERON 1GA2', 251524),
(413668, 'PTHR11691:SF64', NULL, NULL, NULL, NULL, 'INTERFERON ALPHA-1/13', 251524),
(413669, 'PTHR11691:SF37', NULL, NULL, NULL, NULL, 'INTERFERON OMEGA-1', 251524),
(413670, 'PTHR11691:SF36', NULL, NULL, NULL, NULL, 'INTERFERON ALPHA-2-LIKE', 251524),
(413671, 'PTHR11691:SF69', NULL, NULL, NULL, NULL, 'INTERFERON ALPHA-7', 251524),
(413672, 'PTHR11691:SF28', NULL, NULL, NULL, NULL, 'INTERFERON ALPHA-8', 251524),
(413673, 'PTHR11691:SF27', NULL, NULL, NULL, NULL, 'INTERFERON ALPHA-6', 251524),
(413674, 'PTHR11691', NULL, NULL, NULL, NULL, 'TYPE I INTERFERON', 251524),
(413675, 'PTHR47334:SF3', NULL, NULL, NULL, NULL, 'PWI DOMAIN-CONTAINING PROTEIN', 251525),
(413676, 'PTHR47334:SF2', NULL, NULL, NULL, NULL, 'SPLICING FACTOR PWI DOMAIN-CONTAINING PROTEIN / RNA RECOGNITION MOTIF (RRM)-CONTAINING PROTEIN', 251525),
(413677, 'PTHR47334', NULL, NULL, NULL, NULL, 'SPLICING FACTOR PWI DOMAIN-CONTAINING PROTEIN / RNA RECOGNITION MOTIF (RRM)-CONTAINING PROTEIN', 251525),
(413678, 'PTHR42060:SF3', NULL, NULL, NULL, NULL, '', 251526),
(413679, 'PTHR42060:SF1', NULL, NULL, NULL, NULL, '', 251526),
(413680, 'PTHR42060', NULL, NULL, NULL, NULL, '', 251526),
(413681, 'PTHR47887:SF1', NULL, NULL, NULL, NULL, 'CYSTATIN-LIKE 1', 251527),
(413682, 'PTHR47887', NULL, NULL, NULL, NULL, 'CYSTATIN-LIKE 1', 251527),
(413683, 'PTHR14650:SF1', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE AND IRON-DEPENDENT OXYGENASE DOMAIN-CONTAINING PROTEIN 3', 251528),
(413684, 'PTHR14650', NULL, NULL, NULL, NULL, 'PROLYL HYDROXYLASE-RELATED', 251528),
(413685, 'PTHR31460:SF5', NULL, NULL, NULL, NULL, 'SGL DOMAIN-CONTAINING PROTEIN', 251529),
(413686, 'PTHR31460:SF6', NULL, NULL, NULL, NULL, 'NHL DOMAIN PROTEIN', 251529),
(413687, 'PTHR31460:SF3', NULL, NULL, NULL, NULL, 'MESOCENTIN', 251529),
(413688, 'PTHR31460', NULL, NULL, NULL, NULL, '', 251529),
(413689, 'PTHR31460:SF0', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT PHOSPHOTRIESTERASE SUPERFAMILY PROTEIN-RELATED', 251529),
(413690, 'PTHR10277:SF48', NULL, NULL, NULL, NULL, 'HOMOCITRATE SYNTHASE, CYTOSOLIC ISOZYME-RELATED', 251530),
(413691, 'PTHR10277:SF67', NULL, NULL, NULL, NULL, 'PYRUVATE CARBOXYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 251530),
(413692, 'PTHR10277:SF68', NULL, NULL, NULL, NULL, 'PYRUVATE CARBOXYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 251530),
(413693, 'PTHR10277:SF57', NULL, NULL, NULL, NULL, '(R)-CITRAMALATE SYNTHASE CIMA', 251530),
(413694, 'PTHR10277:SF69', NULL, NULL, NULL, NULL, 'PYRUVATE CARBOXYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 251530),
(413695, 'PTHR10277:SF73', NULL, NULL, NULL, NULL, 'PYRUVATE CARBOXYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 251530),
(413696, 'PTHR10277:SF74', NULL, NULL, NULL, NULL, '2-ISOPROPYLMALATE SYNTHASE-RELATED', 251530),
(413697, 'PTHR10277:SF63', NULL, NULL, NULL, NULL, 'HOMOCITRATE SYNTHASE', 251530),
(413698, 'PTHR10277:SF64', NULL, NULL, NULL, NULL, '2-ISOPROPYLMALATE SYNTHASE', 251530),
(413699, 'PTHR10277:SF9', NULL, NULL, NULL, NULL, '2-ISOPROPYLMALATE SYNTHASE 1, CHLOROPLASTIC-RELATED', 251530),
(413700, 'PTHR10277:SF76', NULL, NULL, NULL, NULL, '2-ISOPROPYLMALATE SYNTHASE', 251530),
(413701, 'PTHR10277:SF70', NULL, NULL, NULL, NULL, 'ALDOLASE-TYPE TIM BARREL-RELATED', 251530),
(413702, 'PTHR10277:SF60', NULL, NULL, NULL, NULL, 'METHYLTHIOALKYLMALATE SYNTHASE 1, CHLOROPLASTIC-RELATED', 251530);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(413703, 'PTHR10277:SF72', NULL, NULL, NULL, NULL, '2-ISOPROPYLMALATE SYNTHASE B-LIKE', 251530),
(413704, 'PTHR10277', NULL, NULL, NULL, NULL, 'HOMOCITRATE SYNTHASE-RELATED', 251530),
(413705, 'PTHR33104:SF2', NULL, NULL, NULL, NULL, 'SI:DKEY-29D5.2', 251531),
(413706, 'PTHR33104', NULL, NULL, NULL, NULL, 'SI:DKEY-29D5.2', 251531),
(413707, 'PTHR12632:SF58', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413708, 'PTHR12632:SF36', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413709, 'PTHR12632:SF59', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413710, 'PTHR12632:SF6', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT ALPHA', 251532),
(413711, 'PTHR12632:SF17', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413712, 'PTHR12632:SF92', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413713, 'PTHR12632:SF93', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413714, 'PTHR12632:SF94', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413715, 'PTHR12632:SF50', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413716, 'PTHR12632:SF73', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413717, 'PTHR12632:SF95', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT A-7', 251532),
(413718, 'PTHR12632:SF51', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413719, 'PTHR12632:SF96', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT A-10', 251532),
(413720, 'PTHR12632:SF75', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413721, 'PTHR12632:SF97', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT A-1', 251532),
(413722, 'PTHR12632:SF98', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413723, 'PTHR12632:SF54', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT A-4', 251532),
(413724, 'PTHR12632:SF77', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413725, 'PTHR12632:SF99', NULL, NULL, NULL, NULL, '', 251532),
(413726, 'PTHR12632:SF90', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413727, 'PTHR12632:SF91', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413728, 'PTHR12632:SF102', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413729, 'PTHR12632:SF103', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413730, 'PTHR12632:SF104', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT A-3-RELATED', 251532),
(413731, 'PTHR12632:SF100', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT A-9', 251532),
(413732, 'PTHR12632:SF101', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413733, 'PTHR12632:SF67', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT A-5-RELATED', 251532),
(413734, 'PTHR12632:SF89', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413735, 'PTHR12632:SF46', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT A-2', 251532),
(413736, 'PTHR12632:SF69', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413737, 'PTHR12632:SF48', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413738, 'PTHR12632:SF27', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413739, 'PTHR12632:SF82', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413740, 'PTHR12632:SF61', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413741, 'PTHR12632:SF83', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413742, 'PTHR12632:SF40', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413743, 'PTHR12632:SF84', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(413744, 'PTHR12632', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR NF-Y ALPHA-RELATED', 251532),
(413745, 'PTHR12632:SF85', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413746, 'PTHR12632:SF41', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413747, 'PTHR12632:SF86', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413748, 'PTHR12632:SF87', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413749, 'PTHR12632:SF66', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413750, 'PTHR12632:SF88', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT', 251532),
(413751, 'PTHR47323:SF1', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251533),
(413752, 'PTHR47323:SF8', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 251533),
(413753, 'PTHR47323', NULL, NULL, NULL, NULL, 'FMRFAMIDE PEPTIDE RECEPTOR FAMILY-RELATED', 251533),
(413754, 'PTHR47323:SF6', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251533),
(413755, 'PTHR47323:SF7', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251533),
(413756, 'PTHR47323:SF4', NULL, NULL, NULL, NULL, 'FLP-2 RECEPTOR', 251533),
(413757, 'PTHR47323:SF5', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251533),
(413758, 'PTHR47323:SF2', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251533),
(413759, 'PTHR47323:SF3', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251533),
(413760, 'PTHR13939', NULL, NULL, NULL, NULL, 'NICOTINAMIDE-NUCLEOTIDE AMIDOHYDROLASE PNCC', 251534),
(413761, 'PTHR13939:SF0', NULL, NULL, NULL, NULL, 'PROTEIN YDEJ', 251534),
(413762, 'PTHR13939:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CINA, PUTATIVE-RELATED', 251534),
(413763, 'PTHR13939:SF8', NULL, NULL, NULL, NULL, 'NICOTINAMIDE-NUCLEOTIDE AMIDOHYDROLASE PNCC', 251534),
(413764, 'PTHR13939:SF6', NULL, NULL, NULL, NULL, 'NMN AMIDOHYDROLASE-LIKE PROTEIN YFAY', 251534),
(413765, 'PTHR45986', NULL, NULL, NULL, NULL, 'ZINC FINGER MATRIN-TYPE PROTEIN 2', 251535),
(413766, 'PTHR45986:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER MATRIN-TYPE PROTEIN 2', 251535),
(413767, 'PTHR37302:SF2', NULL, NULL, NULL, NULL, 'PROTEIN DINB', 251536),
(413768, 'PTHR37302', NULL, NULL, NULL, NULL, 'SLR1116 PROTEIN', 251536),
(413769, 'PTHR37302:SF1', NULL, NULL, NULL, NULL, 'SLR1116 PROTEIN', 251536),
(413770, 'PTHR48029:SF1', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 8', 251537),
(413771, 'PTHR48029:SF3', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 251537),
(413772, 'PTHR48029:SF2', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 8', 251537),
(413773, 'PTHR48029:SF7', NULL, NULL, NULL, NULL, 'OS08G0139000 PROTEIN', 251537),
(413774, 'PTHR48029:SF6', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 251537),
(413775, 'PTHR48029', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 8', 251537),
(413776, 'PTHR34389:SF2', NULL, NULL, NULL, NULL, 'L-RHAMNOSE MUTAROTASE', 251538),
(413777, 'PTHR34389', NULL, NULL, NULL, NULL, 'L-RHAMNOSE MUTAROTASE', 251538),
(413778, 'PTHR31582:SF1', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS ALPHA-28-RELATED', 251539),
(413779, 'PTHR31582', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS A (ALPHA)-RELATED-RELATED', 251539),
(413780, 'PTHR31582:SF2', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN-RELATED', 251539),
(413781, 'PTHR47871:SF2', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 8', 251540),
(413782, 'PTHR47871', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 8', 251540),
(413783, 'PTHR16230', NULL, NULL, NULL, NULL, 'CAPPUCCINO', 251541),
(413784, 'PTHR16230:SF5', NULL, NULL, NULL, NULL, 'BREAST CARCINOMA-AMPLIFIED SEQUENCE 4', 251541),
(413785, 'PTHR16230:SF3', NULL, NULL, NULL, NULL, 'BIOGENESIS OF LYSOSOMAL ORGANELLES COMPLEX-1, SUBUNIT 4, CAPPUCCINO', 251541),
(413786, 'PTHR16230:SF4', NULL, NULL, NULL, NULL, 'BIOGENESIS OF LYSOSOME-RELATED ORGANELLES COMPLEX 1 SUBUNIT 4', 251541);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(413787, 'PTHR30273:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FECR', 251542),
(413788, 'PTHR30273', NULL, NULL, NULL, NULL, 'PERIPLASMIC SIGNAL SENSOR AND SIGMA FACTOR ACTIVATOR FECR-RELATED', 251542),
(413789, 'PTHR46680', NULL, NULL, NULL, NULL, 'NF-KAPPA-B INHIBITOR ALPHA', 251543),
(413790, 'PTHR46680:SF1', NULL, NULL, NULL, NULL, 'NF-KAPPA-B INHIBITOR ALPHA', 251543),
(413791, 'PTHR46680:SF2', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 251543),
(413792, 'PTHR46680:SF3', NULL, NULL, NULL, NULL, 'NF-KAPPA-B INHIBITOR CACTUS', 251543),
(413793, 'PTHR46680:SF4', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 251543),
(413794, 'PTHR47036:SF1', NULL, NULL, NULL, NULL, 'COBALT-FACTOR III C(17)-METHYLTRANSFERASE-RELATED', 251544),
(413795, 'PTHR47036', NULL, NULL, NULL, NULL, 'COBALT-FACTOR III C(17)-METHYLTRANSFERASE-RELATED', 251544),
(413796, 'PTHR46418:SF1', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN-RELATED', 251545),
(413797, 'PTHR46418', NULL, NULL, NULL, NULL, 'SRBC-64-RELATED-RELATED', 251545),
(413798, 'PTHR46418:SF2', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS BC (CLASS B-LIKE)', 251545),
(413799, 'PTHR47861:SF3', NULL, NULL, NULL, NULL, 'FKBP-TYPE PEPTIDYL-PROLYL CIS-TRANS ISOMERASE SLYD', 251546),
(413800, 'PTHR47861:SF4', NULL, NULL, NULL, NULL, 'FKBP-TYPE 16 KDA PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 251546),
(413801, 'PTHR47861', NULL, NULL, NULL, NULL, 'FKBP-TYPE PEPTIDYL-PROLYL CIS-TRANS ISOMERASE SLYD', 251546),
(413802, 'PTHR47861:SF2', NULL, NULL, NULL, NULL, 'LONG-TYPE PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', 251546),
(413803, 'PTHR13114', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 17', 251547),
(413804, 'PTHR13114:SF8', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 17', 251547),
(413805, 'PTHR13114:SF7', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 17', 251547),
(413806, 'PTHR20648:SF8', NULL, NULL, NULL, NULL, 'ELONGIN-C', 251548),
(413807, 'PTHR20648:SF11', NULL, NULL, NULL, NULL, 'ELONGIN-C', 251548),
(413808, 'PTHR20648', NULL, NULL, NULL, NULL, 'ELONGIN-C', 251548),
(413809, 'PTHR20648:SF0', NULL, NULL, NULL, NULL, 'ELONGIN-C', 251548),
(413810, 'PTHR20648:SF1', NULL, NULL, NULL, NULL, 'ELONGIN-C', 251548),
(413811, 'PTHR20648:SF12', NULL, NULL, NULL, NULL, 'ELONGIN-C', 251548),
(413812, 'PTHR14966:SF0', NULL, NULL, NULL, NULL, 'Z-DNA-BINDING PROTEIN 1', 251549),
(413813, 'PTHR14966', NULL, NULL, NULL, NULL, 'Z-DNA-BINDING PROTEIN 1', 251549),
(413814, 'PTHR38786:SF1', NULL, NULL, NULL, NULL, 'FLAGELLAR FLIJ PROTEIN', 251550),
(413815, 'PTHR38786', NULL, NULL, NULL, NULL, 'FLAGELLAR FLIJ PROTEIN', 251550),
(413816, 'PTHR44653', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 1', 251551),
(413817, 'PTHR44653:SF2', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 1', 251551),
(413818, 'PTHR33487:SF1', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 54', 251552),
(413819, 'PTHR33487', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 54', 251552),
(413820, 'PTHR31273:SF0', NULL, NULL, NULL, NULL, 'PHOSPHOKETOLASE-RELATED', 251553),
(413821, 'PTHR31273:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOKETOLASE-RELATED', 251553),
(413822, 'PTHR31273:SF2', NULL, NULL, NULL, NULL, 'SLL0529 PROTEIN', 251553),
(413823, 'PTHR31273', NULL, NULL, NULL, NULL, 'PHOSPHOKETOLASE-RELATED', 251553),
(413824, 'PTHR36751:SF5', NULL, NULL, NULL, NULL, 'BNAC03G34890D PROTEIN', 251554),
(413825, 'PTHR36751', NULL, NULL, NULL, NULL, 'F3E22.8 PROTEIN', 251554),
(413826, 'PTHR36751:SF1', NULL, NULL, NULL, NULL, 'F3E22.8 PROTEIN', 251554),
(413827, 'PTHR36751:SF2', NULL, NULL, NULL, NULL, 'BNAA05G30640D PROTEIN', 251554),
(413828, 'PTHR47446:SF2', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 251555),
(413829, 'PTHR47446:SF3', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 251555),
(413830, 'PTHR47446:SF4', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 251555);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(413831, 'PTHR47446', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 251555),
(413832, 'PTHR47439', NULL, NULL, NULL, NULL, 'LOW MOLECULAR WEIGHT PHOSPHOTYROSINE PROTEIN PHOSPHATASE-RELATED', 251556),
(413833, 'PTHR47439:SF1', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE', 251556),
(413834, 'PTHR22796:SF6', NULL, NULL, NULL, NULL, 'SI:DKEY-217F16.1-RELATED', 251557),
(413835, 'PTHR22796:SF13', NULL, NULL, NULL, NULL, 'UP-REGULATOR OF CELL PROLIFERATION', 251557),
(413836, 'PTHR22796:SF1', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 251557),
(413837, 'PTHR22796:SF7', NULL, NULL, NULL, NULL, 'SI:DKEY-202L22.6', 251557),
(413838, 'PTHR22796', NULL, NULL, NULL, NULL, 'URG4-RELATED', 251557),
(413839, 'PTHR11811:SF68', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONATE DEHYDROGENASE, DECARBOXYLATING', 251558),
(413840, 'PTHR11811:SF67', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONATE DEHYDROGENASE YQEC-RELATED', 251558),
(413841, 'PTHR11811:SF56', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONATE DEHYDROGENASE, DECARBOXYLATING', 251558),
(413842, 'PTHR11811:SF48', NULL, NULL, NULL, NULL, 'PHOSPHOGLUCONATE DEHYDROGENASE (NADP(+)-DEPENDENT, DECARBOXYLATING)', 251558),
(413843, 'PTHR11811:SF25', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONATE DEHYDROGENASE, DECARBOXYLATING', 251558),
(413844, 'PTHR11811:SF63', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONATE DEHYDROGENASE, DECARBOXYLATING 2', 251558),
(413845, 'PTHR11811:SF66', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONATE DEHYDROGENASE, DECARBOXYLATING 3, CHLOROPLASTIC', 251558),
(413846, 'PTHR11811:SF55', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONATE DEHYDROGENASE, DECARBOXYLATING 1, CHLOROPLASTIC', 251558),
(413847, 'PTHR11811', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONATE DEHYDROGENASE', 251558),
(413848, 'PTHR11811:SF62', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONATE DEHYDROGENASE, DECARBOXYLATING', 251558),
(413849, 'PTHR11811:SF50', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONATE DEHYDROGENASE, DECARBOXYLATING', 251558),
(413850, 'PTHR44826:SF11', NULL, NULL, NULL, NULL, '', 251559),
(413851, 'PTHR44826:SF8', NULL, NULL, NULL, NULL, '', 251559),
(413852, 'PTHR44826', NULL, NULL, NULL, NULL, 'SPORE COAT PROTEIN SP85', 251559),
(413853, 'PTHR44826:SF9', NULL, NULL, NULL, NULL, '', 251559),
(413854, 'PTHR44826:SF3', NULL, NULL, NULL, NULL, 'SPORE COAT PROTEIN SP85', 251559),
(413855, 'PTHR44826:SF5', NULL, NULL, NULL, NULL, '', 251559),
(413856, 'PTHR44826:SF13', NULL, NULL, NULL, NULL, 'SI:DKEY-235D18.5', 251559),
(413857, 'PTHR44826:SF12', NULL, NULL, NULL, NULL, '', 251559),
(413858, 'PTHR13315:SF1', NULL, NULL, NULL, NULL, 'PROTEIN TED1', 251560),
(413859, 'PTHR13315:SF0', NULL, NULL, NULL, NULL, 'METALLOPHOSPHOESTERASE 1', 251560),
(413860, 'PTHR13315:SF4', NULL, NULL, NULL, NULL, 'METALLOPHOSPHOESTERASE, ISOFORM E', 251560),
(413861, 'PTHR13315', NULL, NULL, NULL, NULL, 'METALLO PHOSPHOESTERASE RELATED', 251560),
(413862, 'PTHR43687', NULL, NULL, NULL, NULL, 'ADENYLYLSULFATE REDUCTASE, BETA SUBUNIT', 251561),
(413863, 'PTHR43687:SF2', NULL, NULL, NULL, NULL, 'FERREDOXIN 3', 251561),
(413864, 'PTHR43687:SF1', NULL, NULL, NULL, NULL, 'L-ASPARTATE SEMIALDEHYDE SULFURTRANSFERASE IRON-SULFUR SUBUNIT', 251561),
(413865, 'PTHR43687:SF4', NULL, NULL, NULL, NULL, 'BLR5484 PROTEIN', 251561),
(413866, 'PTHR43687:SF3', NULL, NULL, NULL, NULL, '', 251561),
(413867, 'PTHR22467:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PBMUCL2', 251562),
(413868, 'PTHR22467:SF3', NULL, NULL, NULL, NULL, 'EZH INHIBITORY PROTEIN', 251562),
(413869, 'PTHR22467', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 251562),
(413870, 'PTHR15751:SF14', NULL, NULL, NULL, NULL, 'HUNTINGTIN-ASSOCIATED PROTEIN 1', 251563),
(413871, 'PTHR15751:SF13', NULL, NULL, NULL, NULL, 'TRAFFICKING KINESIN-BINDING PROTEIN 2', 251563),
(413872, 'PTHR15751:SF12', NULL, NULL, NULL, NULL, 'TRAFFICKING KINESIN-BINDING PROTEIN MILT', 251563),
(413873, 'PTHR15751:SF11', NULL, NULL, NULL, NULL, 'TRAFFICKING KINESIN-BINDING PROTEIN 1', 251563),
(413874, 'PTHR15751', NULL, NULL, NULL, NULL, 'TRAFFICKING KINESIN-BINDING PROTEIN', 251563);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(413875, 'PTHR15751:SF15', NULL, NULL, NULL, NULL, '', 251563),
(413876, 'PTHR21041:SF2', NULL, NULL, NULL, NULL, 'DENDRITIC CELL-SPECIFIC TRANSMEMBRANE PROTEIN', 251564),
(413877, 'PTHR21041:SF3', NULL, NULL, NULL, NULL, 'OSTEOCLAST STIMULATORY TRANSMEMBRANE PROTEIN', 251564),
(413878, 'PTHR21041:SF6', NULL, NULL, NULL, NULL, 'DC-STAMP DOMAIN-CONTAINING PROTEIN 2', 251564),
(413879, 'PTHR21041', NULL, NULL, NULL, NULL, 'DENDRITIC CELL-SPECIFIC TRANSMEMBRANE PROTEIN', 251564),
(413880, 'PTHR21041:SF17', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE DCST1', 251564),
(413881, 'PTHR21041:SF9', NULL, NULL, NULL, NULL, 'DC_STAMP DOMAIN-CONTAINING PROTEIN', 251564),
(413882, 'PTHR21041:SF19', NULL, NULL, NULL, NULL, 'DC_STAMP DOMAIN-CONTAINING PROTEIN', 251564),
(413883, 'PTHR31611:SF0', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY NICKEL TRANSPORT PROTEIN NIC1', 251565),
(413884, 'PTHR31611', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY NICKEL TRANSPORT PROTEIN NIC1', 251565),
(413885, 'PTHR13229:SF11', NULL, NULL, NULL, NULL, 'PROTEIN KISH', 251566),
(413886, 'PTHR13229', NULL, NULL, NULL, NULL, 'PROTEIN KISH-A', 251566),
(413887, 'PTHR13229:SF2', NULL, NULL, NULL, NULL, 'PROTEIN KISH-A', 251566),
(413888, 'PTHR13229:SF15', NULL, NULL, NULL, NULL, 'PROTEIN KISH', 251566),
(413889, 'PTHR13229:SF18', NULL, NULL, NULL, NULL, 'PROTEIN KISH', 251566),
(413890, 'PTHR47760', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR B0563.6-LIKE PROTEIN-RELATED', 251567),
(413891, 'PTHR47760:SF1', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251567),
(413892, 'PTHR47760:SF2', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR B0563.6-RELATED', 251567),
(413893, 'PTHR47760:SF3', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR AH9.1-RELATED', 251567),
(413894, 'PTHR47760:SF4', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251567),
(413895, 'PTHR12994:SF18', NULL, NULL, NULL, NULL, 'SECERNIN-3', 251568),
(413896, 'PTHR12994:SF17', NULL, NULL, NULL, NULL, 'LD30995P', 251568),
(413897, 'PTHR12994:SF16', NULL, NULL, NULL, NULL, 'SECERNIN-2', 251568),
(413898, 'PTHR12994:SF7', NULL, NULL, NULL, NULL, 'SECERNIN-1', 251568),
(413899, 'PTHR12994', NULL, NULL, NULL, NULL, 'SECERNIN', 251568),
(413900, 'PTHR34472:SF1', NULL, NULL, NULL, NULL, 'SULFUR CARRIER PROTEIN THIS', 251569),
(413901, 'PTHR34472', NULL, NULL, NULL, NULL, 'SULFUR CARRIER PROTEIN THIS', 251569),
(413902, 'PTHR37271', NULL, NULL, NULL, NULL, 'KARYOGAMY PROTEIN KAR9', 251570),
(413903, 'PTHR37271:SF1', NULL, NULL, NULL, NULL, 'KARYOGAMY PROTEIN KAR9', 251570),
(413904, 'PTHR44207', NULL, NULL, NULL, NULL, 'SURFACE ANTIGEN BSPA-LIKE-RELATED', 251571),
(413905, 'PTHR44207:SF1', NULL, NULL, NULL, NULL, 'SURFACE ANTIGEN BSPA-LIKE', 251571),
(413906, 'PTHR44207:SF2', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 251571),
(413907, 'PTHR37018:SF1', NULL, NULL, NULL, NULL, 'CULTURE SPECIFIC PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G00130)-RELATED', 251572),
(413908, 'PTHR37018', NULL, NULL, NULL, NULL, 'CULTURE SPECIFIC PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G00130)-RELATED', 251572),
(413909, 'PTHR13325', NULL, NULL, NULL, NULL, 'PROTEASE M50 MEMBRANE-BOUND TRANSCRIPTION FACTOR SITE 2 PROTEASE', 251573),
(413910, 'PTHR13325:SF3', NULL, NULL, NULL, NULL, 'MEMBRANE-BOUND TRANSCRIPTION FACTOR SITE-2 PROTEASE', 251573),
(413911, 'PTHR46598:SF3', NULL, NULL, NULL, NULL, 'OS07G0495300 PROTEIN', 251574),
(413912, 'PTHR46598:SF4', NULL, NULL, NULL, NULL, 'BNAA02G14210D PROTEIN', 251574),
(413913, 'PTHR46598:SF1', NULL, NULL, NULL, NULL, 'OS10G0422566 PROTEIN', 251574),
(413914, 'PTHR46598:SF2', NULL, NULL, NULL, NULL, 'OS01G0788900 PROTEIN', 251574),
(413915, 'PTHR46598:SF5', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN, CHLOROPLASTIC', 251574),
(413916, 'PTHR46598', NULL, NULL, NULL, NULL, 'BNAC05G43320D PROTEIN', 251574),
(413917, 'PTHR33913', NULL, NULL, NULL, NULL, 'ALEURONE LAYER MORPHOGENESIS PROTEIN', 251575),
(413918, 'PTHR33913:SF5', NULL, NULL, NULL, NULL, '', 251575);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(413919, 'PTHR33913:SF4', NULL, NULL, NULL, NULL, '', 251575),
(413920, 'PTHR33913:SF1', NULL, NULL, NULL, NULL, 'ALEURONE LAYER MORPHOGENESIS PROTEIN', 251575),
(413921, 'PTHR33913:SF3', NULL, NULL, NULL, NULL, 'ALEURONE LAYER MORPHOGENESIS PROTEIN', 251575),
(413922, 'PTHR15357:SF1', NULL, NULL, NULL, NULL, 'OLFACTORY MARKER PROTEIN A', 251576),
(413923, 'PTHR15357:SF0', NULL, NULL, NULL, NULL, 'OLFACTORY MARKER PROTEIN', 251576),
(413924, 'PTHR15357', NULL, NULL, NULL, NULL, 'OLFACTORY MARKER PROTEIN', 251576),
(413925, 'PTHR11143:SF11', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L26', 251577),
(413926, 'PTHR11143:SF7', NULL, NULL, NULL, NULL, 'KOW DOMAIN-CONTAINING PROTEIN', 251577),
(413927, 'PTHR11143:SF10', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L26-LIKE 1', 251577),
(413928, 'PTHR11143:SF15', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L26-1-LIKE', 251577),
(413929, 'PTHR11143:SF17', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L26-1-RELATED', 251577),
(413930, 'PTHR11143:SF16', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L26-1', 251577),
(413931, 'PTHR11143:SF19', NULL, NULL, NULL, NULL, 'KOW DOMAIN-CONTAINING PROTEIN', 251577),
(413932, 'PTHR11143:SF18', NULL, NULL, NULL, NULL, 'KOW DOMAIN-CONTAINING PROTEIN', 251577),
(413933, 'PTHR11143', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L26 FAMILY MEMBER', 251577),
(413934, 'PTHR46324:SF20', NULL, NULL, NULL, NULL, 'BZIP PROTEIN', 251578),
(413935, 'PTHR46324:SF21', NULL, NULL, NULL, NULL, 'BASIC LEUCINE-ZIPPER 58', 251578),
(413936, 'PTHR46324:SF40', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR', 251578),
(413937, 'PTHR46324:SF41', NULL, NULL, NULL, NULL, 'OCS ELEMENT-BINDING FACTOR 1', 251578),
(413938, 'PTHR46324:SF39', NULL, NULL, NULL, NULL, 'BASIC LEUCINE-ZIPPER 58', 251578),
(413939, 'PTHR46324:SF3', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER 43-RELATED', 251578),
(413940, 'PTHR46324:SF18', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 251578),
(413941, 'PTHR46324:SF37', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 251578),
(413942, 'PTHR46324:SF1', NULL, NULL, NULL, NULL, 'BASIC LEUCINE-ZIPPER 58', 251578),
(413943, 'PTHR46324:SF15', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 251578),
(413944, 'PTHR46324:SF26', NULL, NULL, NULL, NULL, 'BZIP PROTEIN (ATBZIP48)', 251578),
(413945, 'PTHR46324:SF16', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 251578),
(413946, 'PTHR46324:SF38', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER 43-LIKE', 251578),
(413947, 'PTHR46324', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER 43-RELATED', 251578),
(413948, 'PTHR46324:SF7', NULL, NULL, NULL, NULL, 'BASIC LEUCINE-ZIPPER 70-RELATED', 251578),
(413949, 'PTHR46324:SF13', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER 8', 251578),
(413950, 'PTHR46324:SF14', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER 43-LIKE', 251578),
(413951, 'PTHR46324:SF25', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 251578),
(413952, 'PTHR46324:SF36', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 251578),
(413953, 'PTHR46324:SF22', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 251578),
(413954, 'PTHR46324:SF23', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 251578),
(413955, 'PTHR46324:SF34', NULL, NULL, NULL, NULL, 'BASIC-LEUCINE ZIPPER DOMAIN-CONTAINING PROTEIN-RELATED', 251578),
(413956, 'PTHR46324:SF8', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR SUPERFAMILY PROTEIN-RELATED', 251578),
(413957, 'PTHR46324:SF19', NULL, NULL, NULL, NULL, 'BASIC-LEUCINE ZIPPER DOMAIN-CONTAINING PROTEIN-RELATED', 251578),
(413958, 'PTHR39469:SF1', NULL, NULL, NULL, NULL, 'DUF4203 DOMAIN-CONTAINING PROTEIN', 251579),
(413959, 'PTHR39469', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 251579),
(413960, 'PTHR46321', NULL, NULL, NULL, NULL, 'KIF1-BINDING PROTEIN', 251580),
(413961, 'PTHR46321:SF1', NULL, NULL, NULL, NULL, 'KIF-BINDING PROTEIN', 251580),
(413962, 'PTHR38600:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 251581);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(413963, 'PTHR38600:SF2', NULL, NULL, NULL, NULL, 'SLL0088 PROTEIN', 251581),
(413964, 'PTHR38600', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 251581),
(413965, 'PTHR14467:SF0', NULL, NULL, NULL, NULL, 'PROTEIN ARV1', 251582),
(413966, 'PTHR14467', NULL, NULL, NULL, NULL, 'ARV1', 251582),
(413967, 'PTHR14467:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ARV 2', 251582),
(413968, 'PTHR46591', NULL, NULL, NULL, NULL, 'ZINC FINGER FYVE DOMAIN-CONTAINING PROTEIN 26', 251583),
(413969, 'PTHR46591:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER FYVE DOMAIN-CONTAINING PROTEIN 26', 251583),
(413970, 'PTHR33741:SF1', NULL, NULL, NULL, NULL, 'HPP FAMILY PROTEIN, EXPRESSED', 251584),
(413971, 'PTHR33741', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN DDB_G0269096-RELATED', 251584),
(413972, 'PTHR33741:SF5', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN DDB_G0269096-RELATED', 251584),
(413973, 'PTHR33741:SF4', NULL, NULL, NULL, NULL, 'BNAANNG16770D PROTEIN', 251584),
(413974, 'PTHR33741:SF3', NULL, NULL, NULL, NULL, 'BNAA06G16970D PROTEIN', 251584),
(413975, 'PTHR22958:SF1', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHOCHOLINE PHOSPHODIESTERASE GPCPD1', 251585),
(413976, 'PTHR22958:SF42', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHOCHOLINE PHOSPHODIESTERASE GPCPD1 HOMOLOG 2-RELATED', 251585),
(413977, 'PTHR22958:SF31', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE', 251585),
(413978, 'PTHR22958', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHORYL DIESTER PHOSPHODIESTERASE', 251585),
(413979, 'PTHR22958:SF29', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE GDPD2', 251585),
(413980, 'PTHR22958:SF39', NULL, NULL, NULL, NULL, '', 251585),
(413981, 'PTHR22958:SF27', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE', 251585),
(413982, 'PTHR22958:SF37', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE', 251585),
(413983, 'PTHR22958:SF36', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE', 251585),
(413984, 'PTHR22958:SF25', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE', 251585),
(413985, 'PTHR22958:SF34', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE GDPD3', 251585),
(413986, 'PTHR22958:SF23', NULL, NULL, NULL, NULL, 'DEPENDENT KINASE INHIBITOR PHO81, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G06020)-RELATED', 251585),
(413987, 'PTHR31418:SF19', NULL, NULL, NULL, NULL, 'FATTY ACID/RETINOL BINDING PROTEIN-RELATED', 251586),
(413988, 'PTHR31418:SF4', NULL, NULL, NULL, NULL, 'FATTY ACID/RETINOL BINDING PROTEIN', 251586),
(413989, 'PTHR31418:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG06286', 251586),
(413990, 'PTHR31418:SF2', NULL, NULL, NULL, NULL, 'FATTY ACID/RETINOL BINDING PROTEIN', 251586),
(413991, 'PTHR31418', NULL, NULL, NULL, NULL, 'FATTY-ACID AND RETINOL-BINDING PROTEIN 1', 251586),
(413992, 'PTHR31418:SF3', NULL, NULL, NULL, NULL, 'FATTY ACID/RETINOL BINDING PROTEIN', 251586),
(413993, 'PTHR31418:SF20', NULL, NULL, NULL, NULL, 'PERMEABLE EGGSHELL', 251586),
(413994, 'PTHR31418:SF6', NULL, NULL, NULL, NULL, 'FATTY ACID/RETINOL BINDING PROTEIN', 251586),
(413995, 'PTHR31418:SF7', NULL, NULL, NULL, NULL, 'FATTY-ACID AND RETINOL-BINDING PROTEIN 1', 251586),
(413996, 'PTHR24359:SF33', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE-44', 251587),
(413997, 'PTHR24359:SF34', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251587),
(413998, 'PTHR24359:SF31', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251587),
(413999, 'PTHR24359:SF1', NULL, NULL, NULL, NULL, 'INHIBITOR OF NUCLEAR FACTOR KAPPA-B KINASE EPSILON SUBUNIT HOMOLOG 1-RELATED', 251587),
(414000, 'PTHR24359:SF0', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SBK1', 251587),
(414001, 'PTHR24359:SF19', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SBK1', 251587),
(414002, 'PTHR24359', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SBK1', 251587),
(414003, 'PTHR24359:SF26', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE MENG-PO', 251587),
(414004, 'PTHR24359:SF35', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251587);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(414005, 'PTHR24359:SF36', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SBK1', 251587),
(414006, 'PTHR18837', NULL, NULL, NULL, NULL, 'STROMAL CELL-DERIVED FACTOR 1', 251588),
(414007, 'PTHR18837:SF3', NULL, NULL, NULL, NULL, 'STROMAL CELL-DERIVED FACTOR 1', 251588),
(414008, 'PTHR41282', NULL, NULL, NULL, NULL, 'CONSERVED TRANSMEMBRANE PROTEIN-RELATED', 251589),
(414009, 'PTHR41282:SF1', NULL, NULL, NULL, NULL, 'CONSERVED TRANSMEMBRANE PROTEIN-RELATED', 251589),
(414010, 'PTHR33734', NULL, NULL, NULL, NULL, 'LYSM DOMAIN-CONTAINING GPI-ANCHORED PROTEIN 2', 251590),
(414011, 'PTHR33734:SF18', NULL, NULL, NULL, NULL, 'OS02G0769200 PROTEIN', 251590),
(414012, 'PTHR33734:SF29', NULL, NULL, NULL, NULL, 'LYSM DOMAIN-CONTAINING GPI-ANCHORED PROTEIN LYP4', 251590),
(414013, 'PTHR33734:SF28', NULL, NULL, NULL, NULL, 'LYSM DOMAIN-CONTAINING GPI-ANCHORED PROTEIN 1-LIKE', 251590),
(414014, 'PTHR33734:SF16', NULL, NULL, NULL, NULL, 'LYSM DOMAIN-CONTAINING GPI-ANCHORED PROTEIN 3', 251590),
(414015, 'PTHR33734:SF27', NULL, NULL, NULL, NULL, 'D-GAMMA-GLUTAMYL-MESO-DIAMINOPIMELIC ACID ENDOPEPTIDASE CWLS', 251590),
(414016, 'PTHR33734:SF22', NULL, NULL, NULL, NULL, 'MEMBRANE-BOUND LYTIC MUREIN TRANSGLYCOSYLASE D', 251590),
(414017, 'PTHR33734:SF11', NULL, NULL, NULL, NULL, 'LYSM DOMAIN-CONTAINING GPI-ANCHORED PROTEIN 2', 251590),
(414018, 'PTHR33734:SF33', NULL, NULL, NULL, NULL, 'LYSM DOMAIN-CONTAINING PROTEIN', 251590),
(414019, 'PTHR33734:SF32', NULL, NULL, NULL, NULL, 'BNAC08G20000D PROTEIN', 251590),
(414020, 'PTHR33734:SF6', NULL, NULL, NULL, NULL, 'OS02G0681632 PROTEIN', 251590),
(414021, 'PTHR33734:SF31', NULL, NULL, NULL, NULL, 'CHITIN ELICITOR-BINDING PROTEIN', 251590),
(414022, 'PTHR33734:SF30', NULL, NULL, NULL, NULL, 'BNAA07G03170D PROTEIN', 251590),
(414023, 'PTHR33734:SF26', NULL, NULL, NULL, NULL, 'LYSM DOMAIN-CONTAINING PROTEIN', 251590),
(414024, 'PTHR33734:SF36', NULL, NULL, NULL, NULL, 'STAGE VI SPORULATION PROTEIN D', 251590),
(414025, 'PTHR33734:SF35', NULL, NULL, NULL, NULL, 'LYSM DOMAIN-CONTAINING GPI-ANCHORED PROTEIN 1', 251590),
(414026, 'PTHR33734:SF34', NULL, NULL, NULL, NULL, 'SPOIVD-ASSOCIATED FACTOR A', 251590),
(414027, 'PTHR35868', NULL, NULL, NULL, NULL, '', 251591),
(414028, 'PTHR35868:SF1', NULL, NULL, NULL, NULL, '', 251591),
(414029, 'PTHR35868:SF3', NULL, NULL, NULL, NULL, '', 251591),
(414030, 'PTHR35868:SF4', NULL, NULL, NULL, NULL, 'YALI0F05654P', 251591),
(414031, 'PTHR47748', NULL, NULL, NULL, NULL, 'TACHYLECTIN DOMAIN-CONTAINING PROTEIN', 251592),
(414032, 'PTHR47748:SF1', NULL, NULL, NULL, NULL, 'TACHYLECTIN DOMAIN-CONTAINING PROTEIN', 251592),
(414033, 'PTHR45905', NULL, NULL, NULL, NULL, 'GOLGI-LOCALIZED, GAMMA-ADAPTIN EAR CONTAINING, ARF BINDING PROTEIN', 251593),
(414034, 'PTHR45905:SF1', NULL, NULL, NULL, NULL, 'GOLGI-LOCALIZED, GAMMA-ADAPTIN EAR CONTAINING, ARF BINDING PROTEIN', 251593),
(414035, 'PTHR45905:SF5', NULL, NULL, NULL, NULL, 'GOLGI-ASSOCIATED, GAMMA ADAPTIN EAR-CONTAINING, ARF-BINDING PROTEIN 3B', 251593),
(414036, 'PTHR45905:SF4', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-BINDING PROTEIN GGA1', 251593),
(414037, 'PTHR45905:SF3', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-BINDING PROTEIN GGA3', 251593),
(414038, 'PTHR45905:SF2', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-BINDING PROTEIN GGA2', 251593),
(414039, 'PTHR36542:SF6', NULL, NULL, NULL, NULL, 'GIG2-LIKE PROTEIN DREP', 251594),
(414040, 'PTHR36542:SF7', NULL, NULL, NULL, NULL, 'GIG2-LIKE PROTEIN DREO', 251594),
(414041, 'PTHR36542:SF8', NULL, NULL, NULL, NULL, 'GIG2-LIKE PROTEIN DREN', 251594),
(414042, 'PTHR36542', NULL, NULL, NULL, NULL, 'GIG2-LIKE PROTEIN DRED-RELATED', 251594),
(414043, 'PTHR36542:SF2', NULL, NULL, NULL, NULL, 'GIG2-LIKE PROTEIN DRED-RELATED', 251594),
(414044, 'PTHR33210:SF18', NULL, NULL, NULL, NULL, 'PROTODERMAL FACTOR 1', 251595),
(414045, 'PTHR33210:SF19', NULL, NULL, NULL, NULL, 'BNAA09G08790D PROTEIN', 251595),
(414046, 'PTHR33210:SF4', NULL, NULL, NULL, NULL, 'OS06G0553200 PROTEIN', 251595),
(414047, 'PTHR33210:SF25', NULL, NULL, NULL, NULL, 'PROTODERMAL FACTOR 1-LIKE', 251595);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(414048, 'PTHR33210:SF14', NULL, NULL, NULL, NULL, 'MEIOSIS 5', 251595),
(414049, 'PTHR33210:SF24', NULL, NULL, NULL, NULL, 'POLLEN OLE E 1 ALLERGEN AND EXTENSIN FAMILY PROTEIN', 251595),
(414050, 'PTHR33210', NULL, NULL, NULL, NULL, 'PROTODERMAL FACTOR 1', 251595),
(414051, 'PTHR33210:SF13', NULL, NULL, NULL, NULL, 'PROTODERMAL FACTOR 1', 251595),
(414052, 'PTHR33210:SF27', NULL, NULL, NULL, NULL, 'OS10G0132400 PROTEIN', 251595),
(414053, 'PTHR33210:SF16', NULL, NULL, NULL, NULL, 'OS04G0517000 PROTEIN', 251595),
(414054, 'PTHR33210:SF26', NULL, NULL, NULL, NULL, 'OS01G0726700 PROTEIN', 251595),
(414055, 'PTHR33210:SF21', NULL, NULL, NULL, NULL, 'PROTODERMAL FACTOR 1-LIKE', 251595),
(414056, 'PTHR33210:SF23', NULL, NULL, NULL, NULL, '', 251595),
(414057, 'PTHR33210:SF22', NULL, NULL, NULL, NULL, 'BNAC04G52630D PROTEIN', 251595),
(414058, 'PTHR33511:SF29', NULL, NULL, NULL, NULL, 'BNAUNNG01380D PROTEIN', 251596),
(414059, 'PTHR33511:SF39', NULL, NULL, NULL, NULL, 'BNAA09G04130D PROTEIN', 251596),
(414060, 'PTHR33511:SF19', NULL, NULL, NULL, NULL, 'OS01G0288800 PROTEIN', 251596),
(414061, 'PTHR33511:SF25', NULL, NULL, NULL, NULL, 'BNAC03G34390D PROTEIN', 251596),
(414062, 'PTHR33511:SF24', NULL, NULL, NULL, NULL, 'OS04G0466000 PROTEIN', 251596),
(414063, 'PTHR33511:SF35', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S12', 251596),
(414064, 'PTHR33511:SF27', NULL, NULL, NULL, NULL, 'BNAA05G31450D PROTEIN', 251596),
(414065, 'PTHR33511:SF38', NULL, NULL, NULL, NULL, '', 251596),
(414066, 'PTHR33511:SF26', NULL, NULL, NULL, NULL, 'BNAANNG02940D PROTEIN', 251596),
(414067, 'PTHR33511:SF15', NULL, NULL, NULL, NULL, 'OS02G0192001 PROTEIN', 251596),
(414068, 'PTHR33511:SF37', NULL, NULL, NULL, NULL, '', 251596),
(414069, 'PTHR33511:SF21', NULL, NULL, NULL, NULL, 'OS06G0632400 PROTEIN', 251596),
(414070, 'PTHR33511:SF42', NULL, NULL, NULL, NULL, 'OS02G0581200 PROTEIN', 251596),
(414071, 'PTHR33511:SF20', NULL, NULL, NULL, NULL, 'DUF761 DOMAIN PROTEIN', 251596),
(414072, 'PTHR33511:SF34', NULL, NULL, NULL, NULL, '', 251596),
(414073, 'PTHR33511:SF33', NULL, NULL, NULL, NULL, '', 251596),
(414074, 'PTHR33511:SF41', NULL, NULL, NULL, NULL, '', 251596),
(414075, 'PTHR33511:SF30', NULL, NULL, NULL, NULL, 'BNAA01G22620D PROTEIN', 251596),
(414076, 'PTHR33511:SF40', NULL, NULL, NULL, NULL, '', 251596),
(414077, 'PTHR33511', NULL, NULL, NULL, NULL, 'OS06G0632400 PROTEIN', 251596),
(414078, 'PTHR15046:SF1', NULL, NULL, NULL, NULL, 'BETA-1,4 N-ACETYLGALACTOSAMINYLTRANSFERASE 1', 251597),
(414079, 'PTHR15046:SF2', NULL, NULL, NULL, NULL, 'BETA-1,4 N-ACETYLGALACTOSAMINYLTRANSFERASE 2', 251597),
(414080, 'PTHR15046:SF3', NULL, NULL, NULL, NULL, 'GLYCO_TRANS_2-LIKE DOMAIN-CONTAINING PROTEIN', 251597),
(414081, 'PTHR15046', NULL, NULL, NULL, NULL, 'GLYCO_TRANS_2-LIKE DOMAIN-CONTAINING PROTEIN', 251597),
(414082, 'PTHR24110:SF3', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 78 KDA', 251598),
(414083, 'PTHR24110', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 78 KDA', 251598),
(414084, 'PTHR14435:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 106', 251599),
(414085, 'PTHR14435', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 106', 251599),
(414086, 'PTHR35526:SF8', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 251600),
(414087, 'PTHR35526', NULL, NULL, NULL, NULL, 'ANTI-SIGMA-F FACTOR RSBW-RELATED', 251600),
(414088, 'PTHR35526:SF6', NULL, NULL, NULL, NULL, 'SLR1861 PROTEIN', 251600),
(414089, 'PTHR35526:SF7', NULL, NULL, NULL, NULL, 'ANTI-SIGMA F FACTOR', 251600),
(414090, 'PTHR35526:SF3', NULL, NULL, NULL, NULL, 'STAS DOMAIN-CONTAINING PROTEIN', 251600),
(414091, 'PTHR35526:SF1', NULL, NULL, NULL, NULL, 'SERINE-PROTEIN KINASE RSBW', 251600),
(414092, 'PTHR31134:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 128', 251601),
(414093, 'PTHR31134', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 128', 251601),
(414094, 'PTHR47654:SF5', NULL, NULL, NULL, NULL, '', 251602),
(414095, 'PTHR47654:SF1', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 251602),
(414096, 'PTHR47654', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 251602);
INSERT INTO "PUBLIC"."MODEL" VALUES
(414097, 'PTHR47654:SF4', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 251602),
(414098, 'PTHR47654:SF3', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 251602),
(414099, 'PTHR22984:SF29', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PIM-1', 251603),
(414100, 'PTHR22984:SF26', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PIM-3', 251603),
(414101, 'PTHR22984:SF24', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE', 251603),
(414102, 'PTHR22984:SF25', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251603),
(414103, 'PTHR22984:SF11', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE-RELATED', 251603),
(414104, 'PTHR22984:SF23', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PIM-2', 251603),
(414105, 'PTHR22984:SF10', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PIM-2', 251603),
(414106, 'PTHR22984', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PIM', 251603),
(414107, 'PTHR22984:SF30', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE', 251603),
(414108, 'PTHR46750:SF1', NULL, NULL, NULL, NULL, 'KUNITZ-TYPE PROTEASE INHIBITOR 1', 251604),
(414109, 'PTHR46750:SF2', NULL, NULL, NULL, NULL, 'MANSC DOMAIN-CONTAINING PROTEIN 4', 251604),
(414110, 'PTHR46750', NULL, NULL, NULL, NULL, 'KUNITZ-TYPE PROTEASE INHIBITOR 1', 251604),
(414111, 'PTHR47512:SF6', NULL, NULL, NULL, NULL, 'CHALCONE-FLAVANONE ISOMERASE FAMILY PROTEIN', 251605),
(414112, 'PTHR47512:SF5', NULL, NULL, NULL, NULL, '', 251605),
(414113, 'PTHR47512:SF3', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251605),
(414114, 'PTHR47512:SF2', NULL, NULL, NULL, NULL, 'ISOMERASE FAMILY PROTEIN, PUTATIVE-RELATED', 251605),
(414115, 'PTHR47512', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251605),
(414116, 'PTHR31449', NULL, NULL, NULL, NULL, 'UPF0598 PROTEIN C8ORF82', 251606),
(414117, 'PTHR31449:SF3', NULL, NULL, NULL, NULL, 'UPF0598 PROTEIN C8ORF82', 251606),
(414118, 'PTHR47617', NULL, NULL, NULL, NULL, 'G-PROTEIN SIGNALING MODULATOR 3', 251607),
(414119, 'PTHR47617:SF1', NULL, NULL, NULL, NULL, 'G-PROTEIN-SIGNALING MODULATOR 3', 251607),
(414120, 'PTHR35794', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN DIVIVA', 251608),
(414121, 'PTHR35794:SF1', NULL, NULL, NULL, NULL, 'CELL CYCLE PROTEIN GPSB', 251608),
(414122, 'PTHR35794:SF2', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN DIVIVA', 251608),
(414123, 'PTHR37975:SF3', NULL, NULL, NULL, NULL, 'FLYWCH-TYPE DOMAIN-CONTAINING PROTEIN', 251609),
(414124, 'PTHR37975:SF2', NULL, NULL, NULL, NULL, 'FLYWCH-TYPE DOMAIN-CONTAINING PROTEIN', 251609),
(414125, 'PTHR37975:SF4', NULL, NULL, NULL, NULL, 'FLYWCH-TYPE DOMAIN-CONTAINING PROTEIN', 251609),
(414126, 'PTHR37975', NULL, NULL, NULL, NULL, 'FLYWCH ZINC FINGER TRANSCRIPTION FACTOR HOMOLOG', 251609),
(414127, 'PTHR39190:SF1', NULL, NULL, NULL, NULL, 'FLAGELLAR ASSEMBLY FACTOR FLIW', 251610),
(414128, 'PTHR39190', NULL, NULL, NULL, NULL, 'FLAGELLAR ASSEMBLY FACTOR FLIW', 251610),
(414129, 'PTHR15970:SF7', NULL, NULL, NULL, NULL, 'ELL-ASSOCIATED FACTOR 2', 251611),
(414130, 'PTHR15970:SF8', NULL, NULL, NULL, NULL, 'ELL-ASSOCIATED FACTOR 1', 251611),
(414131, 'PTHR15970:SF13', NULL, NULL, NULL, NULL, 'EAF DOMAIN-CONTAINING PROTEIN', 251611),
(414132, 'PTHR15970', NULL, NULL, NULL, NULL, 'ELL-ASSOCIATED FACTOR EAF', 251611),
(414133, 'PTHR15970:SF2', NULL, NULL, NULL, NULL, 'ELL-ASSOCIATED FACTOR EAF', 251611),
(414134, 'PTHR33904:SF1', NULL, NULL, NULL, NULL, 'ESSENTIAL MCU REGULATOR, MITOCHONDRIAL', 251612),
(414135, 'PTHR33904', NULL, NULL, NULL, NULL, 'ESSENTIAL MCU REGULATOR, MITOCHONDRIAL', 251612),
(414136, 'PTHR45722', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L35', 251613),
(414137, 'PTHR45722:SF9', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L35', 251613),
(414138, 'PTHR45722:SF5', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L35', 251613),
(414139, 'PTHR45722:SF6', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L35-2', 251613),
(414140, 'PTHR45722:SF19', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L35-LIKE', 251613);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(414141, 'PTHR45722:SF29', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L35', 251613),
(414142, 'PTHR45722:SF2', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L35', 251613),
(414143, 'PTHR45722:SF15', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L35-LIKE', 251613),
(414144, 'PTHR45722:SF17', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L35-1-RELATED', 251613),
(414145, 'PTHR45722:SF28', NULL, NULL, NULL, NULL, '60S RIBOSOMAL L35-LIKE PROTEIN', 251613),
(414146, 'PTHR45722:SF27', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L35-LIKE', 251613),
(414147, 'PTHR45722:SF13', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L35', 251613),
(414148, 'PTHR45722:SF12', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L35', 251613),
(414149, 'PTHR46294', NULL, NULL, NULL, NULL, 'SEGMENTATION PROTEIN EVEN-SKIPPED', 251614),
(414150, 'PTHR46294:SF4', NULL, NULL, NULL, NULL, 'SEGMENTATION PROTEIN EVEN-SKIPPED', 251614),
(414151, 'PTHR46294:SF3', NULL, NULL, NULL, NULL, 'EVEN-SKIPPED-LIKE1', 251614),
(414152, 'PTHR46294:SF2', NULL, NULL, NULL, NULL, 'HOMEOBOX EVEN-SKIPPED HOMOLOG PROTEIN 1', 251614),
(414153, 'PTHR46294:SF1', NULL, NULL, NULL, NULL, 'HOMEOBOX EVEN-SKIPPED HOMOLOG PROTEIN 2', 251614),
(414154, 'PTHR24047:SF29', NULL, NULL, NULL, NULL, 'EATER-RELATED', 251615),
(414155, 'PTHR24047:SF31', NULL, NULL, NULL, NULL, 'NIMROD C2, ISOFORM B', 251615),
(414156, 'PTHR24047:SF32', NULL, NULL, NULL, NULL, 'FI01909P-RELATED', 251615),
(414157, 'PTHR24047', NULL, NULL, NULL, NULL, 'FI01909P-RELATED', 251615),
(414158, 'PTHR30289', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN YBCL-RELATED', 251616),
(414159, 'PTHR30289:SF8', NULL, NULL, NULL, NULL, 'YHYH DOMAIN-CONTAINING PROTEIN', 251616),
(414160, 'PTHR30289:SF13', NULL, NULL, NULL, NULL, '', 251616),
(414161, 'PTHR30289:SF1', NULL, NULL, NULL, NULL, 'PEBP (PHOSPHATIDYLETHANOLAMINE-BINDING PROTEIN) FAMILY PROTEIN', 251616),
(414162, 'PTHR30289:SF12', NULL, NULL, NULL, NULL, 'UPF0098 PROTEIN YBHB', 251616),
(414163, 'PTHR43820', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY BRANCHED-CHAIN AMINO ACID TRANSPORT ATP-BINDING PROTEIN LIVF', 251617),
(414164, 'PTHR43820:SF8', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER SUBSTRATE-BINDING PROTEIN', 251617),
(414165, 'PTHR43820:SF6', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN', 251617),
(414166, 'PTHR43820:SF7', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN AMINO ACID TRANSPORT ATP-BINDING PROTEIN LIVF-RELATED', 251617),
(414167, 'PTHR43820:SF4', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY BRANCHED-CHAIN AMINO ACID TRANSPORT ATP-BINDING PROTEIN LIVF', 251617),
(414168, 'PTHR43820:SF5', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY BRANCHED-CHAIN AMINO ACID TRANSPORT ATP-BINDING PROTEIN', 251617),
(414169, 'PTHR43820:SF2', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN', 251617),
(414170, 'PTHR43820:SF3', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY BRANCHED-CHAIN AMINO ACID TRANSPORT ATP-BINDING PROTEIN BRAG', 251617),
(414171, 'PTHR11060', NULL, NULL, NULL, NULL, 'PROTEIN MEMO1', 251618),
(414172, 'PTHR11060:SF0', NULL, NULL, NULL, NULL, 'PROTEIN MEMO1', 251618),
(414173, 'PTHR11060:SF1', NULL, NULL, NULL, NULL, 'PROTEIN MEMO1', 251618),
(414174, 'PTHR11060:SF2', NULL, NULL, NULL, NULL, 'MEDIATOR OF ERBB2-DRIVEN CELL MOTILITY 1', 251618),
(414175, 'PTHR11060:SF3', NULL, NULL, NULL, NULL, 'BNAA09G41020D PROTEIN', 251618),
(414176, 'PTHR40626:SF31', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR/REPRESSOR MOT3', 251619),
(414177, 'PTHR40626:SF30', NULL, NULL, NULL, NULL, 'FINGER DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G13600)-RELATED', 251619),
(414178, 'PTHR40626:SF11', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN YGR067C', 251619),
(414179, 'PTHR40626:SF33', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN YPR022C', 251619),
(414180, 'PTHR40626:SF22', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR (AMDA), PUTATIVE-RELATED', 251619),
(414181, 'PTHR40626:SF10', NULL, NULL, NULL, NULL, 'FINGER DOMAIN PROTEIN, PUTATIVE-RELATED', 251619),
(414182, 'PTHR40626:SF32', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN RST2', 251619);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(414183, 'PTHR40626:SF13', NULL, NULL, NULL, NULL, 'RESPIRATION FACTOR 2-RELATED', 251619),
(414184, 'PTHR40626:SF12', NULL, NULL, NULL, NULL, 'RFEC', 251619),
(414185, 'PTHR40626:SF23', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR WITH C2H2 AND ZN(2)-CYS(6) DNA BINDING DOMAIN (EUROFUNG)-RELATED', 251619),
(414186, 'PTHR40626:SF8', NULL, NULL, NULL, NULL, 'C2H2 FINGER DOMAIN TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 251619),
(414187, 'PTHR40626:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G04110)-RELATED', 251619),
(414188, 'PTHR40626', NULL, NULL, NULL, NULL, 'MIP31509P', 251619),
(414189, 'PTHR40626:SF14', NULL, NULL, NULL, NULL, 'C2H2 TYPE ZINC FINGER DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_1G02360)', 251619),
(414190, 'PTHR40626:SF25', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G02070)-RELATED', 251619),
(414191, 'PTHR40626:SF28', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN ADR1', 251619),
(414192, 'PTHR40626:SF18', NULL, NULL, NULL, NULL, 'NICOTINATE CATABOLISM CLUSTER-SPECIFIC TRANSCRIPTION FACTOR', 251619),
(414193, 'PTHR40626:SF29', NULL, NULL, NULL, NULL, 'FUNGAL_TRANS DOMAIN-CONTAINING PROTEIN', 251619),
(414194, 'PTHR40626:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR WITH C2H2 AND ZN(2)-CYS(6) DNA BINDING DOMAIN (EUROFUNG)-RELATED', 251619),
(414195, 'PTHR40626:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR WITH C2H2 AND ZN(2)-CYS(6) DNA BINDING DOMAIN (EUROFUNG)-RELATED', 251619),
(414196, 'PTHR13255:SF0', NULL, NULL, NULL, NULL, 'ATAXIN-10', 251620),
(414197, 'PTHR13255', NULL, NULL, NULL, NULL, 'ATAXIN-10', 251620),
(414198, 'PTHR47586', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 251621),
(414199, 'PTHR47586:SF1', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', 251621),
(414200, 'PTHR14221:SF41', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN', 251622),
(414201, 'PTHR14221:SF63', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 44-LIKE', 251622),
(414202, 'PTHR14221:SF42', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN', 251622),
(414203, 'PTHR14221:SF64', NULL, NULL, NULL, NULL, 'SIMILARITY TO UNKNOWN PROTEIN', 251622),
(414204, 'PTHR14221:SF62', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN-RELATED', 251622),
(414205, 'PTHR14221:SF40', NULL, NULL, NULL, NULL, 'SIMILARITY TO UNKNOWN PROTEIN', 251622),
(414206, 'PTHR14221:SF45', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN-RELATED', 251622),
(414207, 'PTHR14221:SF67', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 44-LIKE', 251622),
(414208, 'PTHR14221:SF46', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR WD40-LIKE FAMILY-RELATED', 251622),
(414209, 'PTHR14221:SF65', NULL, NULL, NULL, NULL, 'WDR44 FAMILY WD REPEAT PROTEIN', 251622),
(414210, 'PTHR14221:SF43', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 44-LIKE', 251622),
(414211, 'PTHR14221:SF66', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN', 251622),
(414212, 'PTHR14221:SF44', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 251622),
(414213, 'PTHR14221:SF28', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 44-LIKE', 251622),
(414214, 'PTHR14221:SF47', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN-RELATED', 251622),
(414215, 'PTHR14221:SF48', NULL, NULL, NULL, NULL, 'APOPTOTIC PROTEASE-ACTIVATING FACTOR 1-RELATED', 251622),
(414216, 'PTHR14221', NULL, NULL, NULL, NULL, 'WD REPEAT DOMAIN 44', 251622),
(414217, 'PTHR14221:SF0', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 44', 251622),
(414218, 'PTHR14221:SF52', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 251622),
(414219, 'PTHR14221:SF31', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN', 251622),
(414220, 'PTHR14221:SF51', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN-RELATED', 251622),
(414221, 'PTHR14221:SF5', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN', 251622);
INSERT INTO "PUBLIC"."MODEL" VALUES
(414222, 'PTHR14221:SF34', NULL, NULL, NULL, NULL, 'OS04G0568400 PROTEIN', 251622),
(414223, 'PTHR14221:SF56', NULL, NULL, NULL, NULL, 'BNAC02G03540D PROTEIN', 251622),
(414224, 'PTHR14221:SF57', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN', 251622),
(414225, 'PTHR14221:SF35', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN', 251622),
(414226, 'PTHR14221:SF11', NULL, NULL, NULL, NULL, 'OS04G0678300 PROTEIN', 251622),
(414227, 'PTHR14221:SF58', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 251622),
(414228, 'PTHR14221:SF36', NULL, NULL, NULL, NULL, 'SIMILARITY TO WD-CONTAINING PROTEIN', 251622),
(414229, 'PTHR14221:SF59', NULL, NULL, NULL, NULL, 'BNAA03G11960D PROTEIN', 251622),
(414230, 'PTHR14221:SF37', NULL, NULL, NULL, NULL, 'SIGNAL TRANSDUCER', 251622),
(414231, 'PTHR21481:SF5', NULL, NULL, NULL, NULL, 'FPL DOMAIN-CONTAINING PROTEIN', 251623),
(414232, 'PTHR21481:SF4', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPARENT TESTA 9', 251623),
(414233, 'PTHR21481', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 251623),
(414234, 'PTHR21481:SF0', NULL, NULL, NULL, NULL, 'PROTEIN CLEC16A', 251623),
(414235, 'PTHR36346:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251624),
(414236, 'PTHR36346:SF3', NULL, NULL, NULL, NULL, 'BNACNNG66800D PROTEIN', 251624),
(414237, 'PTHR36346:SF4', NULL, NULL, NULL, NULL, '', 251624),
(414238, 'PTHR36346', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251624),
(414239, 'PTHR36490:SF1', NULL, NULL, NULL, NULL, 'STRESS ENHANCED PROTEIN 2, CHLOROPLASTIC', 251625),
(414240, 'PTHR36490', NULL, NULL, NULL, NULL, 'STRESS ENHANCED PROTEIN 2, CHLOROPLASTIC', 251625),
(414241, 'PTHR38693', NULL, NULL, NULL, NULL, 'UBIQUINONE BIOSYNTHESIS PROTEIN UBIJ', 251626),
(414242, 'PTHR38693:SF1', NULL, NULL, NULL, NULL, 'UBIQUINONE BIOSYNTHESIS ACCESSORY FACTOR UBIJ', 251626),
(414243, 'PTHR22855', NULL, NULL, NULL, NULL, 'ACETYL, PROPIONYL, PYRUVATE, AND GLUTACONYL CARBOXYLASE-RELATED', 251627),
(414244, 'PTHR22855:SF47', NULL, NULL, NULL, NULL, 'SI:CH211-198N5.11', 251627),
(414245, 'PTHR22855:SF13', NULL, NULL, NULL, NULL, 'METHYLCROTONOYL-COA CARBOXYLASE BETA CHAIN, MITOCHONDRIAL', 251627),
(414246, 'PTHR22855:SF46', NULL, NULL, NULL, NULL, 'BIOTIN-DEPENDENT ACYL-COENZYME A CARBOXYLASE BETA2 SUBUNIT-RELATED', 251627),
(414247, 'PTHR22855:SF45', NULL, NULL, NULL, NULL, 'BNAC03G77160D PROTEIN', 251627),
(414248, 'PTHR12892:SF16', NULL, NULL, NULL, NULL, 'PROTEIN CBG00645', 251628),
(414249, 'PTHR12892:SF17', NULL, NULL, NULL, NULL, 'POST-GPI ATTACHMENT TO PROTEINS FACTOR 2-LIKE', 251628),
(414250, 'PTHR12892:SF19', NULL, NULL, NULL, NULL, 'POST-GPI ATTACHMENT TO PROTEINS FACTOR 2', 251628),
(414251, 'PTHR12892:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG15066', 251628),
(414252, 'PTHR12892:SF20', NULL, NULL, NULL, NULL, 'PROTEIN CBG12134', 251628),
(414253, 'PTHR12892:SF21', NULL, NULL, NULL, NULL, 'POST-GPI ATTACHMENT TO PROTEINS FACTOR 2', 251628),
(414254, 'PTHR12892:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG16685', 251628),
(414255, 'PTHR12892:SF11', NULL, NULL, NULL, NULL, 'POST-GPI ATTACHMENT TO PROTEINS FACTOR 2', 251628),
(414256, 'PTHR12892:SF12', NULL, NULL, NULL, NULL, 'PROTEIN CBG26903', 251628),
(414257, 'PTHR12892:SF14', NULL, NULL, NULL, NULL, 'PROTEIN CBG01704', 251628),
(414258, 'PTHR12892', NULL, NULL, NULL, NULL, 'FGF RECEPTOR ACTIVATING PROTEIN 1', 251628),
(414259, 'PTHR12892:SF15', NULL, NULL, NULL, NULL, 'PROTEIN CBG02772', 251628),
(414260, 'PTHR12153:SF18', NULL, NULL, NULL, NULL, 'SELENOPROTEIN O', 251629),
(414261, 'PTHR12153:SF15', NULL, NULL, NULL, NULL, 'PROTEIN ADENYLYLTRANSFERASE SELO, MITOCHONDRIAL', 251629),
(414262, 'PTHR12153', NULL, NULL, NULL, NULL, 'SELENOPROTEIN O', 251629),
(414263, 'PTHR32440:SF30', NULL, NULL, NULL, NULL, 'PHOSPHOSERINE PHOSPHATASE', 251630),
(414264, 'PTHR32440:SF25', NULL, NULL, NULL, NULL, 'INACTIVE PURPLE ACID PHOSPHATASE 14-RELATED', 251630),
(414265, 'PTHR32440:SF24', NULL, NULL, NULL, NULL, 'METALLOPHOS DOMAIN-CONTAINING PROTEIN', 251630),
(414266, 'PTHR32440:SF27', NULL, NULL, NULL, NULL, 'METALLOPHOS DOMAIN-CONTAINING PROTEIN', 251630);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(414267, 'PTHR32440:SF31', NULL, NULL, NULL, NULL, 'PHOSPHOESTERASE, METALLO-DEPENDENT PHOSPHATASE-LIKE PROTEIN-RELATED', 251630),
(414268, 'PTHR32440:SF23', NULL, NULL, NULL, NULL, 'METALLOPHOS DOMAIN-CONTAINING PROTEIN', 251630),
(414269, 'PTHR32440:SF11', NULL, NULL, NULL, NULL, 'METALLOPHOS DOMAIN-CONTAINING PROTEIN', 251630),
(414270, 'PTHR32440:SF28', NULL, NULL, NULL, NULL, 'METALLOPHOS DOMAIN-CONTAINING PROTEIN', 251630),
(414271, 'PTHR32440:SF0', NULL, NULL, NULL, NULL, 'PHOSPHATASE DCR2-RELATED', 251630),
(414272, 'PTHR32440:SF3', NULL, NULL, NULL, NULL, 'METALLOPHOS DOMAIN-CONTAINING PROTEIN', 251630),
(414273, 'PTHR32440:SF2', NULL, NULL, NULL, NULL, 'INACTIVE PURPLE ACID PHOSPHATASE 28-RELATED', 251630),
(414274, 'PTHR32440', NULL, NULL, NULL, NULL, 'PHOSPHATASE DCR2-RELATED-RELATED', 251630),
(414275, 'PTHR32440:SF8', NULL, NULL, NULL, NULL, 'METALLOPHOS DOMAIN-CONTAINING PROTEIN', 251630),
(414276, 'PTHR38753:SF1', NULL, NULL, NULL, NULL, 'SLR1441 PROTEIN', 251631),
(414277, 'PTHR38753', NULL, NULL, NULL, NULL, 'SLR1441 PROTEIN', 251631),
(414278, 'PTHR11528:SF107', NULL, NULL, NULL, NULL, 'HATPASE_C DOMAIN-CONTAINING PROTEIN', 251632),
(414279, 'PTHR11528:SF123', NULL, NULL, NULL, NULL, 'BNAA02G35440D PROTEIN', 251632),
(414280, 'PTHR11528:SF124', NULL, NULL, NULL, NULL, 'HATPASE_C DOMAIN-CONTAINING PROTEIN', 251632),
(414281, 'PTHR11528:SF102', NULL, NULL, NULL, NULL, 'BNAA10G28410D PROTEIN', 251632),
(414282, 'PTHR11528:SF44', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 75 KDA, MITOCHONDRIAL-RELATED', 251632),
(414283, 'PTHR11528:SF100', NULL, NULL, NULL, NULL, '', 251632),
(414284, 'PTHR11528:SF122', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN HSP 90-ALPHA 1', 251632),
(414285, 'PTHR11528:SF127', NULL, NULL, NULL, NULL, 'BIOSYNTHETIC PROTEIN, PUTATIVE-RELATED', 251632),
(414286, 'PTHR11528:SF106', NULL, NULL, NULL, NULL, 'BNAA05G29880D PROTEIN', 251632),
(414287, 'PTHR11528:SF128', NULL, NULL, NULL, NULL, 'HATPASE_C DOMAIN-CONTAINING PROTEIN', 251632),
(414288, 'PTHR11528:SF125', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN HSP 90-ALPHA A4-RELATED', 251632),
(414289, 'PTHR11528:SF26', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN (HSP90-FAMILY)-RELATED', 251632),
(414290, 'PTHR11528:SF103', NULL, NULL, NULL, NULL, 'BNAA08G14800D PROTEIN', 251632),
(414291, 'PTHR11528:SF97', NULL, NULL, NULL, NULL, 'ENDOPLASMIN', 251632),
(414292, 'PTHR11528:SF120', NULL, NULL, NULL, NULL, 'HEAT SHOCK COGNATE PROTEIN 80', 251632),
(414293, 'PTHR11528:SF54', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 90-5, CHLOROPLASTIC', 251632),
(414294, 'PTHR11528:SF95', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 90-2', 251632),
(414295, 'PTHR11528:SF96', NULL, NULL, NULL, NULL, 'ENDOPLASMIN', 251632),
(414296, 'PTHR11528:SF134', NULL, NULL, NULL, NULL, 'BNAA06G33590D PROTEIN', 251632),
(414297, 'PTHR11528:SF79', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN HSP 90-BETA', 251632),
(414298, 'PTHR11528:SF135', NULL, NULL, NULL, NULL, 'OS08G0487800 PROTEIN', 251632),
(414299, 'PTHR11528:SF132', NULL, NULL, NULL, NULL, 'HEAT SHOCK COGNATE PROTEIN 80-LIKE', 251632),
(414300, 'PTHR11528:SF99', NULL, NULL, NULL, NULL, 'HATPASE_C DOMAIN-CONTAINING PROTEIN', 251632),
(414301, 'PTHR11528:SF133', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 90-2-RELATED', 251632),
(414302, 'PTHR11528:SF34', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 83', 251632),
(414303, 'PTHR11528:SF78', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN HSP 90-BETA 2-RELATED', 251632),
(414304, 'PTHR11528:SF138', NULL, NULL, NULL, NULL, 'HEAT SHOCK COGNATE PROTEIN 80', 251632),
(414305, 'PTHR11528:SF136', NULL, NULL, NULL, NULL, '', 251632),
(414306, 'PTHR11528:SF137', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 81-3', 251632),
(414307, 'PTHR11528', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 90 FAMILY MEMBER', 251632),
(414308, 'PTHR11528:SF81', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN HSP 90-BETA-3-RELATED', 251632),
(414309, 'PTHR11528:SF130', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 90-1', 251632),
(414310, 'PTHR11528:SF131', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN HSP 90-ALPHA A2', 251632);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(414311, 'PTHR11528:SF87', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN HSP 90-ALPHA', 251632),
(414312, 'PTHR11528:SF41', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 90-6, MITOCHONDRIAL', 251632),
(414313, 'PTHR21396', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L43', 251633),
(414314, 'PTHR21396:SF2', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L43, MITOCHONDRIAL', 251633),
(414315, 'PTHR36293', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 213', 251634),
(414316, 'PTHR36293:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 213', 251634),
(414317, 'PTHR33252:SF2', NULL, NULL, NULL, NULL, 'THIRD ORF IN TRANSPOSON ISC1160', 251635),
(414318, 'PTHR33252', NULL, NULL, NULL, NULL, 'THIRD ORF IN TRANSPOSON ISC1160', 251635),
(414319, 'PTHR33021:SF508', NULL, NULL, NULL, NULL, 'OS06G0218600 PROTEIN', 251636),
(414320, 'PTHR33021:SF507', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414321, 'PTHR33021:SF509', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414322, 'PTHR33021:SF193', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414323, 'PTHR33021:SF463', NULL, NULL, NULL, NULL, 'OS03G0709100 PROTEIN', 251636),
(414324, 'PTHR33021:SF341', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414325, 'PTHR33021:SF464', NULL, NULL, NULL, NULL, 'PLANTACYANIN', 251636),
(414326, 'PTHR33021:SF189', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414327, 'PTHR33021:SF343', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414328, 'PTHR33021:SF183', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414329, 'PTHR33021:SF186', NULL, NULL, NULL, NULL, 'EARLY NODULIN-LIKE PROTEIN 9', 251636),
(414330, 'PTHR33021:SF185', NULL, NULL, NULL, NULL, 'EARLY NODULIN-LIKE PROTEIN 3-RELATED', 251636),
(414331, 'PTHR33021:SF460', NULL, NULL, NULL, NULL, 'OS02G0725500 PROTEIN', 251636),
(414332, 'PTHR33021:SF504', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414333, 'PTHR33021:SF503', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414334, 'PTHR33021:SF506', NULL, NULL, NULL, NULL, 'MAVICYANIN-LIKE', 251636),
(414335, 'PTHR33021:SF505', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414336, 'PTHR33021', NULL, NULL, NULL, NULL, 'BLUE COPPER PROTEIN', 251636),
(414337, 'PTHR33021:SF346', NULL, NULL, NULL, NULL, 'OS03G0791300 PROTEIN', 251636),
(414338, 'PTHR33021:SF500', NULL, NULL, NULL, NULL, 'CUPREDOXIN SUPERFAMILY PROTEIN', 251636),
(414339, 'PTHR33021:SF466', NULL, NULL, NULL, NULL, 'OS08G0138100 PROTEIN', 251636),
(414340, 'PTHR33021:SF224', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414341, 'PTHR33021:SF502', NULL, NULL, NULL, NULL, 'OSJNBA0079A21.6 PROTEIN', 251636),
(414342, 'PTHR33021:SF469', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414343, 'PTHR33021:SF26', NULL, NULL, NULL, NULL, 'BASIC BLUE PROTEIN', 251636),
(414344, 'PTHR33021:SF226', NULL, NULL, NULL, NULL, 'OS11G0491500 PROTEIN', 251636),
(414345, 'PTHR33021:SF501', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414346, 'PTHR33021:SF13', NULL, NULL, NULL, NULL, 'OS09G0557900 PROTEIN', 251636),
(414347, 'PTHR33021:SF14', NULL, NULL, NULL, NULL, 'OS01G0272700 PROTEIN', 251636),
(414348, 'PTHR33021:SF519', NULL, NULL, NULL, NULL, 'EARLY NODULIN-LIKE PROTEIN 10', 251636),
(414349, 'PTHR33021:SF518', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414350, 'PTHR33021:SF474', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414351, 'PTHR33021:SF231', NULL, NULL, NULL, NULL, 'LAMIN-LIKE PROTEIN', 251636),
(414352, 'PTHR33021:SF473', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414353, 'PTHR33021:SF198', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414354, 'PTHR33021:SF355', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(414355, 'PTHR33021:SF234', NULL, NULL, NULL, NULL, 'EARLY NODULIN-LIKE PROTEIN 7', 251636),
(414356, 'PTHR33021:SF354', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414357, 'PTHR33021:SF470', NULL, NULL, NULL, NULL, 'BASIC BLUE PROTEIN', 251636),
(414358, 'PTHR33021:SF197', NULL, NULL, NULL, NULL, 'EARLY NODULIN-LIKE PROTEIN 3', 251636),
(414359, 'PTHR33021:SF351', NULL, NULL, NULL, NULL, 'BNAA03G49200D PROTEIN', 251636),
(414360, 'PTHR33021:SF196', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414361, 'PTHR33021:SF350', NULL, NULL, NULL, NULL, 'UCLACYANIN-2', 251636),
(414362, 'PTHR33021:SF515', NULL, NULL, NULL, NULL, 'BASIC BLUE-LIKE PROTEIN', 251636),
(414363, 'PTHR33021:SF514', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414364, 'PTHR33021:SF517', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414365, 'PTHR33021:SF516', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414366, 'PTHR33021:SF511', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414367, 'PTHR33021:SF478', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414368, 'PTHR33021:SF235', NULL, NULL, NULL, NULL, 'COPPER ION BINDING / ELECTRON CARRIER PROTEIN-RELATED', 251636),
(414369, 'PTHR33021:SF510', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414370, 'PTHR33021:SF356', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414371, 'PTHR33021:SF477', NULL, NULL, NULL, NULL, 'BNAA04G18680D PROTEIN', 251636),
(414372, 'PTHR33021:SF513', NULL, NULL, NULL, NULL, 'PUTATIVE, EXPRESSED-RELATED', 251636),
(414373, 'PTHR33021:SF479', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414374, 'PTHR33021:SF512', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414375, 'PTHR33021:SF171', NULL, NULL, NULL, NULL, 'BLUE COPPER-BINDING PROTEIN-LIKE', 251636),
(414376, 'PTHR33021:SF292', NULL, NULL, NULL, NULL, 'BNAA07G38560D PROTEIN', 251636),
(414377, 'PTHR33021:SF170', NULL, NULL, NULL, NULL, 'OS06G0286228 PROTEIN', 251636),
(414378, 'PTHR33021:SF441', NULL, NULL, NULL, NULL, 'OS03G0791366 PROTEIN', 251636),
(414379, 'PTHR33021:SF443', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414380, 'PTHR33021:SF289', NULL, NULL, NULL, NULL, 'EARLY NODULIN-LIKE PROTEIN 5-RELATED', 251636),
(414381, 'PTHR33021:SF288', NULL, NULL, NULL, NULL, 'OS03G0648500 PROTEIN', 251636),
(414382, 'PTHR33021:SF321', NULL, NULL, NULL, NULL, 'BNAC05G01220D PROTEIN', 251636),
(414383, 'PTHR33021:SF442', NULL, NULL, NULL, NULL, 'BNAA04G17290D PROTEIN', 251636),
(414384, 'PTHR33021:SF285', NULL, NULL, NULL, NULL, 'BNAA02G22370D PROTEIN', 251636),
(414385, 'PTHR33021:SF449', NULL, NULL, NULL, NULL, 'EARLY NODULIN-LIKE PROTEIN 2', 251636),
(414386, 'PTHR33021:SF207', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414387, 'PTHR33021:SF206', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414388, 'PTHR33021:SF208', NULL, NULL, NULL, NULL, 'OS06G0266400 PROTEIN', 251636),
(414389, 'PTHR33021:SF324', NULL, NULL, NULL, NULL, 'BNAC05G48580D PROTEIN', 251636),
(414390, 'PTHR33021:SF205', NULL, NULL, NULL, NULL, 'PLASTOCYANIN-LIKE DOMAIN PROTEIN', 251636),
(414391, 'PTHR33021:SF325', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414392, 'PTHR33021:SF70', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414393, 'PTHR33021:SF297', NULL, NULL, NULL, NULL, 'BNAC05G32310D PROTEIN', 251636),
(414394, 'PTHR33021:SF179', NULL, NULL, NULL, NULL, 'OS06G0721800 PROTEIN', 251636),
(414395, 'PTHR33021:SF454', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414396, 'PTHR33021:SF333', NULL, NULL, NULL, NULL, 'BNAA09G38360D PROTEIN', 251636),
(414397, 'PTHR33021:SF211', NULL, NULL, NULL, NULL, 'BLUE COPPER PROTEIN-LIKE', 251636),
(414398, 'PTHR33021:SF332', NULL, NULL, NULL, NULL, 'BNAC03G17230D PROTEIN', 251636); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(414399, 'PTHR33021:SF218', NULL, NULL, NULL, NULL, 'CUPREDOXIN SUPERFAMILY PROTEIN', 251636),
(414400, 'PTHR33021:SF339', NULL, NULL, NULL, NULL, 'OS07G0570600 PROTEIN', 251636),
(414401, 'PTHR33021:SF459', NULL, NULL, NULL, NULL, 'OS12G0150500 PROTEIN', 251636),
(414402, 'PTHR33021:SF214', NULL, NULL, NULL, NULL, 'BLUE COPPER PROTEIN', 251636),
(414403, 'PTHR33021:SF335', NULL, NULL, NULL, NULL, 'BNAC04G54350D PROTEIN', 251636),
(414404, 'PTHR33021:SF213', NULL, NULL, NULL, NULL, 'OS12G0454600 PROTEIN', 251636),
(414405, 'PTHR33021:SF334', NULL, NULL, NULL, NULL, 'BNAC01G20120D PROTEIN', 251636),
(414406, 'PTHR33021:SF458', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414407, 'PTHR33021:SF216', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414408, 'PTHR33021:SF309', NULL, NULL, NULL, NULL, 'BNAA03G51730D PROTEIN', 251636),
(414409, 'PTHR33021:SF270', NULL, NULL, NULL, NULL, 'PLASTOCYANIN-LIKE DOMAIN PROTEIN', 251636),
(414410, 'PTHR33021:SF390', NULL, NULL, NULL, NULL, 'OS09G0572700 PROTEIN', 251636),
(414411, 'PTHR33021:SF386', NULL, NULL, NULL, NULL, 'BNAA02G04760D PROTEIN', 251636),
(414412, 'PTHR33021:SF540', NULL, NULL, NULL, NULL, 'EARLY NODULIN-LIKE PROTEIN 12', 251636),
(414413, 'PTHR33021:SF385', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414414, 'PTHR33021:SF264', NULL, NULL, NULL, NULL, 'OS05G0570900 PROTEIN', 251636),
(414415, 'PTHR33021:SF267', NULL, NULL, NULL, NULL, 'OS07G0112700 PROTEIN', 251636),
(414416, 'PTHR33021:SF266', NULL, NULL, NULL, NULL, 'MAVICYANIN-LIKE', 251636),
(414417, 'PTHR33021:SF541', NULL, NULL, NULL, NULL, 'BNAA07G36670D PROTEIN', 251636),
(414418, 'PTHR33021:SF387', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414419, 'PTHR33021:SF420', NULL, NULL, NULL, NULL, 'EARLY NODULIN-LIKE PROTEIN 1', 251636),
(414420, 'PTHR33021:SF382', NULL, NULL, NULL, NULL, 'CUPREDOXIN SUPERFAMILY PROTEIN', 251636),
(414421, 'PTHR33021:SF261', NULL, NULL, NULL, NULL, 'OS02G0256800 PROTEIN', 251636),
(414422, 'PTHR33021:SF381', NULL, NULL, NULL, NULL, 'BNAC03G47040D PROTEIN', 251636),
(414423, 'PTHR33021:SF263', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414424, 'PTHR33021:SF262', NULL, NULL, NULL, NULL, 'EARLY NODULIN-LIKE PROTEIN 20', 251636),
(414425, 'PTHR33021:SF306', NULL, NULL, NULL, NULL, 'BLUE COPPER PROTEIN-LIKE', 251636),
(414426, 'PTHR33021:SF428', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414427, 'PTHR33021:SF423', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414428, 'PTHR33021:SF269', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414429, 'PTHR33021:SF301', NULL, NULL, NULL, NULL, 'OS02G0758800 PROTEIN', 251636),
(414430, 'PTHR33021:SF304', NULL, NULL, NULL, NULL, 'BNAANNG37940D PROTEIN', 251636),
(414431, 'PTHR33021:SF425', NULL, NULL, NULL, NULL, 'PUTATIVE, EXPRESSED-RELATED', 251636),
(414432, 'PTHR33021:SF424', NULL, NULL, NULL, NULL, 'BASIC BLUE PROTEIN', 251636),
(414433, 'PTHR33021:SF280', NULL, NULL, NULL, NULL, 'BNAA04G14040D PROTEIN', 251636),
(414434, 'PTHR33021:SF397', NULL, NULL, NULL, NULL, 'OS08G0137400 PROTEIN', 251636),
(414435, 'PTHR33021:SF396', NULL, NULL, NULL, NULL, 'BNAA06G32330D PROTEIN', 251636),
(414436, 'PTHR33021:SF399', NULL, NULL, NULL, NULL, 'BNAC06G04180D PROTEIN', 251636),
(414437, 'PTHR33021:SF431', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414438, 'PTHR33021:SF152', NULL, NULL, NULL, NULL, 'OS04G0545600 PROTEIN', 251636),
(414439, 'PTHR33021:SF273', NULL, NULL, NULL, NULL, 'OS04G0629200 PROTEIN', 251636),
(414440, 'PTHR33021:SF438', NULL, NULL, NULL, NULL, 'BNAA09G30630D PROTEIN', 251636),
(414441, 'PTHR33021:SF317', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414442, 'PTHR33021:SF316', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414443, 'PTHR33021:SF439', NULL, NULL, NULL, NULL, 'OS09G0469300 PROTEIN', 251636);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(414444, 'PTHR33021:SF434', NULL, NULL, NULL, NULL, 'CUPREDOXIN SUPERFAMILY PROTEIN-RELATED', 251636),
(414445, 'PTHR33021:SF312', NULL, NULL, NULL, NULL, 'BNAC06G01720D PROTEIN', 251636),
(414446, 'PTHR33021:SF433', NULL, NULL, NULL, NULL, 'PLASTOCYANIN-LIKE DOMAIN PROTEIN', 251636),
(414447, 'PTHR33021:SF59', NULL, NULL, NULL, NULL, 'OS02G0162200 PROTEIN', 251636),
(414448, 'PTHR33021:SF435', NULL, NULL, NULL, NULL, 'EARLY NODULIN-LIKE PROTEIN 1', 251636),
(414449, 'PTHR33021:SF44', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414450, 'PTHR33021:SF529', NULL, NULL, NULL, NULL, 'OS03G0807500 PROTEIN', 251636),
(414451, 'PTHR33021:SF408', NULL, NULL, NULL, NULL, 'BLUE COPPER PROTEIN 1B', 251636),
(414452, 'PTHR33021:SF490', NULL, NULL, NULL, NULL, 'PLASTOCYANIN-LIKE DOMAIN PROTEIN', 251636),
(414453, 'PTHR33021:SF485', NULL, NULL, NULL, NULL, 'BNAA02G13430D PROTEIN', 251636),
(414454, 'PTHR33021:SF484', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414455, 'PTHR33021:SF363', NULL, NULL, NULL, NULL, 'EARLY NODULIN 20', 251636),
(414456, 'PTHR33021:SF487', NULL, NULL, NULL, NULL, 'BLUE COPPER BINDING PROTEIN', 251636),
(414457, 'PTHR33021:SF245', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414458, 'PTHR33021:SF366', NULL, NULL, NULL, NULL, 'EARLY NODULIN-LIKE PROTEIN 15', 251636),
(414459, 'PTHR33021:SF520', NULL, NULL, NULL, NULL, 'OS11G0428800 PROTEIN', 251636),
(414460, 'PTHR33021:SF486', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414461, 'PTHR33021:SF9', NULL, NULL, NULL, NULL, 'PUTATIVE, EXPRESSED-RELATED', 251636),
(414462, 'PTHR33021:SF481', NULL, NULL, NULL, NULL, 'BLUE COPPER PROTEIN-LIKE', 251636),
(414463, 'PTHR33021:SF6', NULL, NULL, NULL, NULL, 'EARLY NODULIN-LIKE PROTEIN 18', 251636),
(414464, 'PTHR33021:SF7', NULL, NULL, NULL, NULL, 'OS07G0542900 PROTEIN', 251636),
(414465, 'PTHR33021:SF483', NULL, NULL, NULL, NULL, 'PLASTOCYANIN-LIKE DOMAIN PROTEIN', 251636),
(414466, 'PTHR33021:SF482', NULL, NULL, NULL, NULL, 'EARLY NODULIN-LIKE PROTEIN', 251636),
(414467, 'PTHR33021:SF361', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414468, 'PTHR33021:SF526', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414469, 'PTHR33021:SF525', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414470, 'PTHR33021:SF528', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414471, 'PTHR33021:SF527', NULL, NULL, NULL, NULL, 'BNAC03G71950D PROTEIN', 251636),
(414472, 'PTHR33021:SF368', NULL, NULL, NULL, NULL, 'PEELING CUPREDOXIN, PUTATIVE-RELATED', 251636),
(414473, 'PTHR33021:SF522', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414474, 'PTHR33021:SF489', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414475, 'PTHR33021:SF521', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414476, 'PTHR33021:SF367', NULL, NULL, NULL, NULL, 'BNAC03G14800D PROTEIN', 251636),
(414477, 'PTHR33021:SF488', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414478, 'PTHR33021:SF524', NULL, NULL, NULL, NULL, 'BLUE COPPER PROTEIN-LIKE', 251636),
(414479, 'PTHR33021:SF523', NULL, NULL, NULL, NULL, 'BNAA06G13180D PROTEIN', 251636),
(414480, 'PTHR33021:SF402', NULL, NULL, NULL, NULL, 'BNAC01G20930D PROTEIN', 251636),
(414481, 'PTHR33021:SF49', NULL, NULL, NULL, NULL, 'EARLY NODULIN-LIKE PROTEIN 21', 251636),
(414482, 'PTHR33021:SF31', NULL, NULL, NULL, NULL, 'OS02G0720100 PROTEIN', 251636),
(414483, 'PTHR33021:SF496', NULL, NULL, NULL, NULL, 'BLUE COPPER PROTEIN', 251636),
(414484, 'PTHR33021:SF375', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414485, 'PTHR33021:SF495', NULL, NULL, NULL, NULL, 'EARLY NODULIN-LIKE PROTEIN 1', 251636),
(414486, 'PTHR33021:SF253', NULL, NULL, NULL, NULL, 'OS06G0681200 PROTEIN', 251636),
(414487, 'PTHR33021:SF531', NULL, NULL, NULL, NULL, 'EARLY NODULIN-LIKE PROTEIN 11', 251636);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(414488, 'PTHR33021:SF498', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414489, 'PTHR33021:SF256', NULL, NULL, NULL, NULL, 'OS09G0541100 PROTEIN', 251636),
(414490, 'PTHR33021:SF377', NULL, NULL, NULL, NULL, 'OS02G0731400 PROTEIN', 251636),
(414491, 'PTHR33021:SF497', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414492, 'PTHR33021:SF530', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414493, 'PTHR33021:SF376', NULL, NULL, NULL, NULL, 'OS01G0788700 PROTEIN', 251636),
(414494, 'PTHR33021:SF492', NULL, NULL, NULL, NULL, 'UCLACYANIN 1', 251636),
(414495, 'PTHR33021:SF491', NULL, NULL, NULL, NULL, 'BNAC09G42260D PROTEIN', 251636),
(414496, 'PTHR33021:SF373', NULL, NULL, NULL, NULL, 'BNAA04G28720D PROTEIN', 251636),
(414497, 'PTHR33021:SF494', NULL, NULL, NULL, NULL, 'NTEIG-A1 PROTEIN', 251636),
(414498, 'PTHR33021:SF493', NULL, NULL, NULL, NULL, 'BNAC01G15380D PROTEIN', 251636),
(414499, 'PTHR33021:SF537', NULL, NULL, NULL, NULL, 'UCLACYANIN 2', 251636),
(414500, 'PTHR33021:SF536', NULL, NULL, NULL, NULL, 'BNAA08G26900D PROTEIN', 251636),
(414501, 'PTHR33021:SF418', NULL, NULL, NULL, NULL, 'BNAA02G10060D PROTEIN', 251636),
(414502, 'PTHR33021:SF539', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414503, 'PTHR33021:SF538', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414504, 'PTHR33021:SF417', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414505, 'PTHR33021:SF533', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414506, 'PTHR33021:SF499', NULL, NULL, NULL, NULL, 'OS07G0105000 PROTEIN', 251636),
(414507, 'PTHR33021:SF532', NULL, NULL, NULL, NULL, 'NTEPC', 251636),
(414508, 'PTHR33021:SF414', NULL, NULL, NULL, NULL, 'PHYTOCYANIN DOMAIN-CONTAINING PROTEIN', 251636),
(414509, 'PTHR33021:SF535', NULL, NULL, NULL, NULL, 'MUCIN-2-LIKE', 251636),
(414510, 'PTHR33021:SF534', NULL, NULL, NULL, NULL, 'BNACNNG29090D PROTEIN', 251636),
(414511, 'PTHR10583:SF4', NULL, NULL, NULL, NULL, 'SECRETOGRANIN-1', 251637),
(414512, 'PTHR10583:SF1', NULL, NULL, NULL, NULL, 'CHROMOGRANIN-A', 251637),
(414513, 'PTHR10583', NULL, NULL, NULL, NULL, 'CHROMOGRANIN', 251637),
(414514, 'PTHR43355:SF2', NULL, NULL, NULL, NULL, 'FLAVIN REDUCTASE (NADPH)', 251638),
(414515, 'PTHR43355:SF7', NULL, NULL, NULL, NULL, 'NAD(P)-BD_DOM DOMAIN-CONTAINING PROTEIN', 251638),
(414516, 'PTHR43355', NULL, NULL, NULL, NULL, 'FLAVIN REDUCTASE (NADPH)', 251638),
(414517, 'PTHR39231', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE COMPLEX SUBUNIT SAP25', 251639),
(414518, 'PTHR39231:SF4', NULL, NULL, NULL, NULL, '', 251639),
(414519, 'PTHR39231:SF1', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE COMPLEX SUBUNIT SAP25', 251639),
(414520, 'PTHR15272:SF0', NULL, NULL, NULL, NULL, 'CHROMATIN ASSEMBLY FACTOR 1 SUBUNIT A', 251640),
(414521, 'PTHR15272', NULL, NULL, NULL, NULL, 'CHROMATIN ASSEMBLY FACTOR 1 SUBUNIT A  CAF-1 SUBUNIT A', 251640),
(414522, 'PTHR15272:SF6', NULL, NULL, NULL, NULL, '', 251640),
(414523, 'PTHR15272:SF7', NULL, NULL, NULL, NULL, 'OS07G0273301 PROTEIN', 251640),
(414524, 'PTHR39217', NULL, NULL, NULL, NULL, '', 251641),
(414525, 'PTHR39217:SF1', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', 251641),
(414526, 'PTHR34873:SF3', NULL, NULL, NULL, NULL, 'SSR1766 PROTEIN', 251642),
(414527, 'PTHR34873', NULL, NULL, NULL, NULL, 'SSR1766 PROTEIN', 251642),
(414528, 'PTHR31739:SF31', NULL, NULL, NULL, NULL, 'ENT-COPALYL DIPHOSPHATE SYNTHASE 1, CHLOROPLASTIC', 251643),
(414529, 'PTHR31739:SF40', NULL, NULL, NULL, NULL, '', 251643),
(414530, 'PTHR31739:SF30', NULL, NULL, NULL, NULL, 'COPAL-8-OL DIPHOSPHATE HYDRATASE, CHLOROPLASTIC', 251643),
(414531, 'PTHR31739:SF46', NULL, NULL, NULL, NULL, 'COPALYL DIPHOSPHATE SYNTHASE3', 251643),
(414532, 'PTHR31739:SF35', NULL, NULL, NULL, NULL, 'COPALYL DIPHOSPHATE SYNTHASE', 251643),
(414533, 'PTHR31739:SF25', NULL, NULL, NULL, NULL, '(E,E)-GERANYLLINALOOL SYNTHASE', 251643),
(414534, 'PTHR31739:SF33', NULL, NULL, NULL, NULL, 'CIS-ABIENOL SYNTHASE, CHLOROPLASTIC', 251643);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(414535, 'PTHR31739:SF22', NULL, NULL, NULL, NULL, '9-BETA-PIMARA-7,15-DIENE SYNTHASE, CHLOROPLASTIC', 251643),
(414536, 'PTHR31739:SF44', NULL, NULL, NULL, NULL, 'TERPENE_SYNTH DOMAIN-CONTAINING PROTEIN', 251643),
(414537, 'PTHR31739:SF45', NULL, NULL, NULL, NULL, 'ENT-COPALYL DIPHOSPHATE SYNTHASE AN1, CHLOROPLASTIC', 251643),
(414538, 'PTHR31739:SF34', NULL, NULL, NULL, NULL, 'SYNTHASE B, CHLOROPLAST, PUTATIVE-RELATED', 251643),
(414539, 'PTHR31739:SF23', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 251643),
(414540, 'PTHR31739', NULL, NULL, NULL, NULL, 'ENT-COPALYL DIPHOSPHATE SYNTHASE, CHLOROPLASTIC', 251643),
(414541, 'PTHR31739:SF4', NULL, NULL, NULL, NULL, 'ENT-COPALYL DIPHOSPHATE SYNTHASE, CHLOROPLASTIC', 251643),
(414542, 'PTHR31739:SF17', NULL, NULL, NULL, NULL, 'ENT-SANDARACOPIMARA-8(14),15-DIENE SYNTHASE, CHLOROPLASTIC', 251643),
(414543, 'PTHR31739:SF29', NULL, NULL, NULL, NULL, '(E,E)-GERANYLLINALOOL SYNTHASE-LIKE', 251643),
(414544, 'PTHR31739:SF18', NULL, NULL, NULL, NULL, 'TERPENE SYNTHASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_5G15060)', 251643),
(414545, 'PTHR31739:SF3', NULL, NULL, NULL, NULL, 'ENT-KAUR-16-ENE SYNTHASE, CHLOROPLASTIC', 251643),
(414546, 'PTHR31739:SF37', NULL, NULL, NULL, NULL, 'BNAC03G30630D PROTEIN', 251643),
(414547, 'PTHR31739:SF16', NULL, NULL, NULL, NULL, 'ENT-KAURENE SYNTHASE-LIKE 3', 251643),
(414548, 'PTHR31739:SF27', NULL, NULL, NULL, NULL, 'COPALYLDIPHOSPHATE SYNTHASE', 251643),
(414549, 'PTHR31739:SF38', NULL, NULL, NULL, NULL, 'BNAA03G60000D PROTEIN', 251643),
(414550, 'PTHR33702:SF30', NULL, NULL, NULL, NULL, 'OS05G0576600 PROTEIN', 251644),
(414551, 'PTHR33702', NULL, NULL, NULL, NULL, 'BNAA09G40010D PROTEIN', 251644),
(414552, 'PTHR33702:SF19', NULL, NULL, NULL, NULL, 'BINDING PROTEIN', 251644),
(414553, 'PTHR33702:SF28', NULL, NULL, NULL, NULL, '', 251644),
(414554, 'PTHR33702:SF29', NULL, NULL, NULL, NULL, 'BNAA09G40010D PROTEIN', 251644),
(414555, 'PTHR33702:SF26', NULL, NULL, NULL, NULL, '', 251644),
(414556, 'PTHR33702:SF16', NULL, NULL, NULL, NULL, '', 251644),
(414557, 'PTHR33702:SF27', NULL, NULL, NULL, NULL, 'BINDING PROTEIN', 251644),
(414558, 'PTHR33702:SF24', NULL, NULL, NULL, NULL, 'BNAA04G27010D PROTEIN', 251644),
(414559, 'PTHR33702:SF25', NULL, NULL, NULL, NULL, 'OS05G0575200 PROTEIN', 251644),
(414560, 'PTHR33702:SF22', NULL, NULL, NULL, NULL, '', 251644),
(414561, 'PTHR33702:SF4', NULL, NULL, NULL, NULL, 'OS01G0644900 PROTEIN', 251644),
(414562, 'PTHR33702:SF5', NULL, NULL, NULL, NULL, 'OS01G0308600 PROTEIN', 251644),
(414563, 'PTHR33702:SF31', NULL, NULL, NULL, NULL, '', 251644),
(414564, 'PTHR33702:SF2', NULL, NULL, NULL, NULL, '', 251644),
(414565, 'PTHR33702:SF20', NULL, NULL, NULL, NULL, '', 251644),
(414566, 'PTHR43624:SF2', NULL, NULL, NULL, NULL, 'ELECTRON TRANSFER FLAVOPROTEIN-QUINONE OXIDOREDUCTASE YDIS-RELATED', 251645),
(414567, 'PTHR43624', NULL, NULL, NULL, NULL, 'ELECTRON TRANSFER FLAVOPROTEIN-QUINONE OXIDOREDUCTASE YDIS-RELATED', 251645),
(414568, 'PTHR43624:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FIXC', 251645),
(414569, 'PTHR38006:SF1', NULL, NULL, NULL, NULL, 'MEIOSIS-SPECIFIC KINETOCHORE PROTEIN', 251646),
(414570, 'PTHR38006', NULL, NULL, NULL, NULL, 'MEIOSIS-SPECIFIC KINETOCHORE PROTEIN', 251646),
(414571, 'PTHR31552:SF9', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS V', 251647),
(414572, 'PTHR31552:SF30', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA', 251647),
(414573, 'PTHR31552:SF8', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA', 251647),
(414574, 'PTHR31552:SF31', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA', 251647),
(414575, 'PTHR31552:SF14', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA-33', 251647),
(414576, 'PTHR31552:SF26', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA-31', 251647),
(414577, 'PTHR31552:SF13', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA', 251647),
(414578, 'PTHR31552:SF3', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA', 251647),
(414579, 'PTHR31552:SF24', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA', 251647);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(414580, 'PTHR31552:SF29', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA', 251647),
(414581, 'PTHR31552', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA', 251647),
(414582, 'PTHR31552:SF28', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA', 251647),
(414583, 'PTHR33384:SF49', NULL, NULL, NULL, NULL, '', 251648),
(414584, 'PTHR33384:SF27', NULL, NULL, NULL, NULL, '', 251648),
(414585, 'PTHR33384:SF37', NULL, NULL, NULL, NULL, 'BNAC06G30070D PROTEIN', 251648),
(414586, 'PTHR33384:SF26', NULL, NULL, NULL, NULL, 'BNAA08G24300D PROTEIN', 251648),
(414587, 'PTHR33384:SF48', NULL, NULL, NULL, NULL, 'BNAA07G24630D PROTEIN', 251648),
(414588, 'PTHR33384:SF29', NULL, NULL, NULL, NULL, 'BNAA01G32890D PROTEIN', 251648),
(414589, 'PTHR33384:SF17', NULL, NULL, NULL, NULL, 'BNAC07G32200D PROTEIN', 251648),
(414590, 'PTHR33384:SF50', NULL, NULL, NULL, NULL, 'BNAC09G41700D PROTEIN', 251648),
(414591, 'PTHR33384:SF45', NULL, NULL, NULL, NULL, '', 251648),
(414592, 'PTHR33384:SF34', NULL, NULL, NULL, NULL, 'BNACNNG56630D PROTEIN', 251648),
(414593, 'PTHR33384:SF23', NULL, NULL, NULL, NULL, '', 251648),
(414594, 'PTHR33384:SF22', NULL, NULL, NULL, NULL, '', 251648),
(414595, 'PTHR33384:SF44', NULL, NULL, NULL, NULL, '', 251648),
(414596, 'PTHR33384:SF36', NULL, NULL, NULL, NULL, '', 251648),
(414597, 'PTHR33384:SF47', NULL, NULL, NULL, NULL, 'OS01G0930200 PROTEIN', 251648),
(414598, 'PTHR33384:SF25', NULL, NULL, NULL, NULL, 'OS06G0661766 PROTEIN', 251648),
(414599, 'PTHR33384', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251648),
(414600, 'PTHR33384:SF35', NULL, NULL, NULL, NULL, 'BNAC05G08780D PROTEIN', 251648),
(414601, 'PTHR33384:SF46', NULL, NULL, NULL, NULL, 'BNAA05G33450D PROTEIN', 251648),
(414602, 'PTHR33384:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251648),
(414603, 'PTHR33384:SF40', NULL, NULL, NULL, NULL, '', 251648),
(414604, 'PTHR33384:SF31', NULL, NULL, NULL, NULL, 'BNAC08G40360D PROTEIN', 251648),
(414605, 'PTHR33384:SF20', NULL, NULL, NULL, NULL, '', 251648),
(414606, 'PTHR33384:SF42', NULL, NULL, NULL, NULL, 'BNAC02G06400D PROTEIN', 251648),
(414607, 'PTHR42818', NULL, NULL, NULL, NULL, 'SULFOPYRUVATE DECARBOXYLASE SUBUNIT ALPHA', 251649),
(414608, 'PTHR42818:SF1', NULL, NULL, NULL, NULL, 'SULFOPYRUVATE DECARBOXYLASE', 251649),
(414609, 'PTHR45878', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN WIP2', 251650),
(414610, 'PTHR45878:SF50', NULL, NULL, NULL, NULL, 'TRANSPARENT TESTA 1 PROTEIN', 251650),
(414611, 'PTHR45878:SF49', NULL, NULL, NULL, NULL, 'ZINC FINGER C2H2-TYPE/INTEGRASE DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 251650),
(414612, 'PTHR45878:SF28', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 251650),
(414613, 'PTHR45878:SF21', NULL, NULL, NULL, NULL, 'TESTA 1 PROTEIN, PUTATIVE-RELATED', 251650),
(414614, 'PTHR45878:SF43', NULL, NULL, NULL, NULL, 'WIP DOMAIN PROTEIN 3-RELATED', 251650),
(414615, 'PTHR45878:SF22', NULL, NULL, NULL, NULL, 'ZINC FINGER C2H2-TYPE/INTEGRASE DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 251650),
(414616, 'PTHR45878:SF44', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 251650),
(414617, 'PTHR45878:SF20', NULL, NULL, NULL, NULL, 'BNAA06G02430D PROTEIN', 251650),
(414618, 'PTHR45878:SF47', NULL, NULL, NULL, NULL, 'BNAC06G42710D PROTEIN', 251650),
(414619, 'PTHR45878:SF48', NULL, NULL, NULL, NULL, 'OS05G0444200 PROTEIN', 251650),
(414620, 'PTHR45878:SF23', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN WIP3', 251650),
(414621, 'PTHR45878:SF45', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN WIP6', 251650),
(414622, 'PTHR45878:SF24', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN WIP3-LIKE', 251650),
(414623, 'PTHR45878:SF46', NULL, NULL, NULL, NULL, 'ZINC FINGER C2H2-TYPE/INTEGRASE DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 251650),
(414624, 'PTHR45878:SF40', NULL, NULL, NULL, NULL, 'ZINC FINGER, C2H2-LIKE PROTEIN-RELATED', 251650),
(414625, 'PTHR45878:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN WIP2', 251650),
(414626, 'PTHR45878:SF4', NULL, NULL, NULL, NULL, 'OS01G0859100 PROTEIN', 251650);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(414627, 'PTHR45878:SF16', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN WIP6-LIKE', 251650),
(414628, 'PTHR45878:SF17', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPARENT TESTA 1', 251650),
(414629, 'PTHR45878:SF7', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN WIP2-LIKE', 251650),
(414630, 'PTHR45878:SF32', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN WIP5', 251650),
(414631, 'PTHR45878:SF11', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPARENT TESTA 1-LIKE', 251650),
(414632, 'PTHR45878:SF30', NULL, NULL, NULL, NULL, 'OS08G0504000 PROTEIN', 251650),
(414633, 'PTHR45878:SF36', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 251650),
(414634, 'PTHR45878:SF15', NULL, NULL, NULL, NULL, 'OS09G0307400 PROTEIN', 251650),
(414635, 'PTHR45878:SF12', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN WIP4', 251650),
(414636, 'PTHR45878:SF35', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN WIP6', 251650),
(414637, 'PTHR45754:SF1', NULL, NULL, NULL, NULL, 'METHYLENETETRAHYDROFOLATE REDUCTASE 1', 251651),
(414638, 'PTHR45754:SF3', NULL, NULL, NULL, NULL, 'METHYLENETETRAHYDROFOLATE REDUCTASE', 251651),
(414639, 'PTHR45754:SF5', NULL, NULL, NULL, NULL, 'METHYLENETETRAHYDROFOLATE REDUCTASE', 251651),
(414640, 'PTHR45754:SF4', NULL, NULL, NULL, NULL, 'METHYLENETETRAHYDROFOLATE REDUCTASE 1', 251651),
(414641, 'PTHR45754:SF7', NULL, NULL, NULL, NULL, 'METHYLENETETRAHYDROFOLATE REDUCTASE', 251651),
(414642, 'PTHR45754', NULL, NULL, NULL, NULL, 'METHYLENETETRAHYDROFOLATE REDUCTASE', 251651),
(414643, 'PTHR43617:SF29', NULL, NULL, NULL, NULL, 'FAMILY ACETYLTRANSFERASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G14730)-RELATED', 251652),
(414644, 'PTHR43617:SF28', NULL, NULL, NULL, NULL, 'SLR1501 PROTEIN', 251652),
(414645, 'PTHR43617:SF17', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 251652),
(414646, 'PTHR43617:SF2', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE PA2271', 251652),
(414647, 'PTHR43617', NULL, NULL, NULL, NULL, 'L-AMINO ACID N-ACETYLTRANSFERASE', 251652),
(414648, 'PTHR43617:SF32', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE, GNAT FAMILY PROTEIN', 251652),
(414649, 'PTHR43617:SF20', NULL, NULL, NULL, NULL, 'GCN5-RELATED N-ACETYLTRANSFERASE', 251652),
(414650, 'PTHR43617:SF31', NULL, NULL, NULL, NULL, 'MYCOTHIOL ACETYLTRANSFERASE', 251652),
(414651, 'PTHR43617:SF33', NULL, NULL, NULL, NULL, 'SPORE COAT POLYSACCHARIDE BIOSYNTHESIS PROTEIN SPSD', 251652),
(414652, 'PTHR43617:SF22', NULL, NULL, NULL, NULL, 'L-AMINO ACID N-ACETYLTRANSFERASE AAAT', 251652),
(414653, 'PTHR43617:SF9', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 251652),
(414654, 'PTHR43617:SF30', NULL, NULL, NULL, NULL, 'BLR0547 PROTEIN', 251652),
(414655, 'PTHR46767', NULL, NULL, NULL, NULL, 'LIM DOMAIN ONLY PROTEIN 7', 251653),
(414656, 'PTHR46767:SF2', NULL, NULL, NULL, NULL, 'LIM DOMAIN 7B', 251653),
(414657, 'PTHR46767:SF1', NULL, NULL, NULL, NULL, 'LIM DOMAIN ONLY PROTEIN 7', 251653),
(414658, 'PTHR12141:SF3', NULL, NULL, NULL, NULL, 'ARFAPTIN-2', 251654),
(414659, 'PTHR12141', NULL, NULL, NULL, NULL, 'ARFAPTIN-RELATED', 251654),
(414660, 'PTHR12141:SF4', NULL, NULL, NULL, NULL, 'ARFAPTIN-1', 251654),
(414661, 'PTHR12141:SF5', NULL, NULL, NULL, NULL, 'ARFAPTIN', 251654),
(414662, 'PTHR12141:SF1', NULL, NULL, NULL, NULL, 'PRKCA-BINDING PROTEIN', 251654),
(414663, 'PTHR42947:SF1', NULL, NULL, NULL, NULL, 'COB--COM HETERODISULFIDE REDUCTASE SUBUNIT B 1', 251655),
(414664, 'PTHR42947', NULL, NULL, NULL, NULL, 'COB--COM HETERODISULFIDE REDUCTASE SUBUNIT B 1', 251655),
(414665, 'PTHR42941', NULL, NULL, NULL, NULL, 'SLL1037 PROTEIN', 251656),
(414666, 'PTHR42941:SF1', NULL, NULL, NULL, NULL, 'SLL1037 PROTEIN', 251656),
(414667, 'PTHR38785:SF1', NULL, NULL, NULL, NULL, 'HOMOLOG OF VIRK', 251657),
(414668, 'PTHR38785', NULL, NULL, NULL, NULL, 'HOMOLOG OF VIRK', 251657),
(414669, 'PTHR11042:SF173', NULL, NULL, NULL, NULL, 'SI:CH211-63O20.7', 251658),
(414670, 'PTHR11042:SF178', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 2-ALPHA KINASE 1', 251658),
(414671, 'PTHR11042:SF177', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DDB_G0291842-RELATED', 251658);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(414672, 'PTHR11042:SF155', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251658),
(414673, 'PTHR11042:SF136', NULL, NULL, NULL, NULL, 'EIF-2-ALPHA KINASE GCN2', 251658),
(414674, 'PTHR11042:SF158', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 251658),
(414675, 'PTHR11042:SF179', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 2-ALPHA KINASE 1', 251658),
(414676, 'PTHR11042:SF138', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE IKS1-RELATED', 251658),
(414677, 'PTHR11042:SF85', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE IFKC-RELATED', 251658),
(414678, 'PTHR11042:SF181', NULL, NULL, NULL, NULL, 'OS02G0722250 PROTEIN', 251658),
(414679, 'PTHR11042:SF180', NULL, NULL, NULL, NULL, 'MITOSIS INHIBITOR PROTEIN KINASE MIK1', 251658),
(414680, 'PTHR11042:SF183', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED TYROSINE- AND THREONINE-SPECIFIC CDC2-INHIBITORY KINASE', 251658),
(414681, 'PTHR11042:SF182', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251658),
(414682, 'PTHR11042:SF160', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 2-ALPHA KINASE 1', 251658),
(414683, 'PTHR11042:SF163', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED, DOUBLE-STRANDED RNA-ACTIVATED PROTEIN KINASE', 251658),
(414684, 'PTHR11042:SF185', NULL, NULL, NULL, NULL, 'WEE1-LIKE PROTEIN KINASE', 251658),
(414685, 'PTHR11042:SF184', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251658),
(414686, 'PTHR11042:SF162', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0269628-RELATED', 251658),
(414687, 'PTHR11042:SF59', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 35', 251658),
(414688, 'PTHR11042:SF165', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251658),
(414689, 'PTHR11042:SF187', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 2-ALPHA KINASE 2', 251658),
(414690, 'PTHR11042:SF186', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 251658),
(414691, 'PTHR11042:SF58', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PDIK1L', 251658),
(414692, 'PTHR11042:SF188', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE IFKA-RELATED', 251658),
(414693, 'PTHR11042:SF166', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 2-ALPHA KINASE 3', 251658),
(414694, 'PTHR11042:SF169', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251658),
(414695, 'PTHR11042:SF91', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 2-ALPHA KINASE 2-RELATED', 251658),
(414696, 'PTHR11042:SF75', NULL, NULL, NULL, NULL, 'WEE1-LIKE PROTEIN KINASE 2', 251658),
(414697, 'PTHR11042:SF72', NULL, NULL, NULL, NULL, 'WEE1-LIKE PROTEIN KINASE', 251658),
(414698, 'PTHR11042', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 2-ALPHA KINASE  EIF2-ALPHA KINASE -RELATED', 251658),
(414699, 'PTHR43221:SF3', NULL, NULL, NULL, NULL, 'SLL1280 PROTEIN', 251659),
(414700, 'PTHR43221:SF2', NULL, NULL, NULL, NULL, 'PROTEASE HTPX HOMOLOG', 251659),
(414701, 'PTHR43221:SF1', NULL, NULL, NULL, NULL, 'PROTEASE HTPX', 251659),
(414702, 'PTHR43221', NULL, NULL, NULL, NULL, 'PROTEASE HTPX', 251659),
(414703, 'PTHR34542:SF7', NULL, NULL, NULL, NULL, 'BNAA02G13830D PROTEIN', 251660),
(414704, 'PTHR34542:SF8', NULL, NULL, NULL, NULL, 'BNAA07G24650D PROTEIN', 251660),
(414705, 'PTHR34542:SF5', NULL, NULL, NULL, NULL, '', 251660),
(414706, 'PTHR34542:SF6', NULL, NULL, NULL, NULL, '50S RIBOSOMAL-LIKE PROTEIN', 251660),
(414707, 'PTHR34542:SF4', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN-LIKE PROTEIN', 251660),
(414708, 'PTHR34542:SF1', NULL, NULL, NULL, NULL, 'OS08G0359900 PROTEIN', 251660),
(414709, 'PTHR34542', NULL, NULL, NULL, NULL, 'OS08G0359900 PROTEIN', 251660),
(414710, 'PTHR34542:SF2', NULL, NULL, NULL, NULL, 'OS01G0136300 PROTEIN', 251660),
(414711, 'PTHR13351:SF5', NULL, NULL, NULL, NULL, 'RENIN RECEPTOR', 251661),
(414712, 'PTHR13351', NULL, NULL, NULL, NULL, 'RENIN RECEPTOR', 251661),
(414713, 'PTHR13351:SF1', NULL, NULL, NULL, NULL, 'RENIN RECEPTOR', 251661);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(414714, 'PTHR13351:SF6', NULL, NULL, NULL, NULL, 'ATPASE H(+)-TRANSPORTING LYSOSOMAL ACCESSORY PROTEIN 2', 251661),
(414715, 'PTHR13351:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG11220', 251661),
(414716, 'PTHR46798:SF14', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 251662),
(414717, 'PTHR46798:SF15', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 251662),
(414718, 'PTHR46798:SF12', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 251662),
(414719, 'PTHR46798:SF13', NULL, NULL, NULL, NULL, 'OS01G0350900 PROTEIN', 251662),
(414720, 'PTHR46798:SF18', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 251662),
(414721, 'PTHR46798:SF16', NULL, NULL, NULL, NULL, 'BNAA05G31680D PROTEIN', 251662),
(414722, 'PTHR46798:SF7', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 251662),
(414723, 'PTHR46798:SF17', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 251662),
(414724, 'PTHR46798:SF5', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RFI2', 251662),
(414725, 'PTHR46798:SF3', NULL, NULL, NULL, NULL, 'RING FINGER FAMILY PROTEIN-RELATED', 251662),
(414726, 'PTHR46798', NULL, NULL, NULL, NULL, 'OS09G0511500 PROTEIN', 251662),
(414727, 'PTHR40114:SF1', NULL, NULL, NULL, NULL, 'SLR0698 PROTEIN', 251663),
(414728, 'PTHR40114', NULL, NULL, NULL, NULL, 'SLR0698 PROTEIN', 251663),
(414729, 'PTHR34358:SF15', NULL, NULL, NULL, NULL, 'CYCLIN DOMAIN-CONTAINING PROTEIN', 251664),
(414730, 'PTHR34358:SF9', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER', 251664),
(414731, 'PTHR34358:SF13', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE ISOFORM 1-RELATED', 251664),
(414732, 'PTHR34358:SF7', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 251664),
(414733, 'PTHR34358:SF14', NULL, NULL, NULL, NULL, '', 251664),
(414734, 'PTHR34358:SF11', NULL, NULL, NULL, NULL, '', 251664),
(414735, 'PTHR34358:SF5', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (DUF1195)-RELATED', 251664),
(414736, 'PTHR34358:SF4', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER', 251664),
(414737, 'PTHR34358', NULL, NULL, NULL, NULL, 'OS03G0411600 PROTEIN', 251664),
(414738, 'PTHR34358:SF3', NULL, NULL, NULL, NULL, 'OS07G0607500 PROTEIN', 251664),
(414739, 'PTHR34358:SF2', NULL, NULL, NULL, NULL, 'OS03G0411600 PROTEIN', 251664),
(414740, 'PTHR31553:SF3', NULL, NULL, NULL, NULL, 'NF-KAPPA-B ESSENTIAL MODULATOR', 251665),
(414741, 'PTHR31553:SF2', NULL, NULL, NULL, NULL, 'OPTINEURIN', 251665),
(414742, 'PTHR31553:SF4', NULL, NULL, NULL, NULL, 'CCHC NOA-TYPE DOMAIN-CONTAINING PROTEIN', 251665),
(414743, 'PTHR31553', NULL, NULL, NULL, NULL, 'NF-KAPPA-B ESSENTIAL MODULATOR', 251665),
(414744, 'PTHR31553:SF1', NULL, NULL, NULL, NULL, 'NF-KAPPA-B ESSENTIAL MODULATOR', 251665),
(414745, 'PTHR24186:SF2', NULL, NULL, NULL, NULL, 'OS02G0735700 PROTEIN', 251666),
(414746, 'PTHR24186:SF18', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 251666),
(414747, 'PTHR24186:SF39', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 251666),
(414748, 'PTHR24186:SF17', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 251666),
(414749, 'PTHR24186:SF5', NULL, NULL, NULL, NULL, 'ANKYRIN-LIKE PROTEIN', 251666),
(414750, 'PTHR24186:SF16', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 251666),
(414751, 'PTHR24186:SF38', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 251666),
(414752, 'PTHR24186:SF37', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING PROTEIN ITN1-LIKE', 251666),
(414753, 'PTHR24186:SF36', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 251666),
(414754, 'PTHR24186:SF13', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT PLANT-LIKE PROTEIN', 251666),
(414755, 'PTHR24186:SF8', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 251666),
(414756, 'PTHR24186', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT', 251666),
(414757, 'PTHR24186:SF51', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 251666),
(414758, 'PTHR24186:SF50', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 251666);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(414759, 'PTHR24186:SF29', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING DOMAIN, PGG DOMAIN PROTEIN-RELATED', 251666),
(414760, 'PTHR24186:SF49', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 251666),
(414761, 'PTHR24186:SF48', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING PROTEIN ITN1', 251666),
(414762, 'PTHR24186:SF26', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 251666),
(414763, 'PTHR24186:SF47', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 251666),
(414764, 'PTHR24186:SF46', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 251666),
(414765, 'PTHR24186:SF45', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 251666),
(414766, 'PTHR24186:SF23', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 251666),
(414767, 'PTHR24186:SF44', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING DOMAIN, PGG DOMAIN PROTEIN-RELATED', 251666),
(414768, 'PTHR24186:SF22', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 251666),
(414769, 'PTHR24186:SF43', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 251666),
(414770, 'PTHR24186:SF21', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 251666),
(414771, 'PTHR24186:SF42', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING PROTEIN NPR4', 251666),
(414772, 'PTHR24186:SF41', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 251666),
(414773, 'PTHR24186:SF40', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 251666),
(414774, 'PTHR12868:SF0', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 BETA SUBCOMPLEX SUBUNIT 9', 251667),
(414775, 'PTHR12868:SF1', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 BETA SUBCOMPLEX SUBUNIT 9', 251667),
(414776, 'PTHR12868', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE B22 SUBUNIT', 251667),
(414777, 'PTHR12868:SF2', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 BETA SUBCOMPLEX SUBUNIT 9', 251667),
(414778, 'PTHR35304:SF6', NULL, NULL, NULL, NULL, 'AN ARABIDOPSIS THIALIANA CHROMOSOME BAC GENOMIC SEQUENCE', 251668),
(414779, 'PTHR35304:SF2', NULL, NULL, NULL, NULL, 'BNAANNG36440D PROTEIN', 251668),
(414780, 'PTHR35304:SF10', NULL, NULL, NULL, NULL, '', 251668),
(414781, 'PTHR35304:SF3', NULL, NULL, NULL, NULL, '', 251668),
(414782, 'PTHR35304:SF11', NULL, NULL, NULL, NULL, 'BNAA03G00580D PROTEIN', 251668),
(414783, 'PTHR35304:SF12', NULL, NULL, NULL, NULL, 'AN ARABIDOPSIS THIALIANA CHROMOSOME BAC GENOMIC SEQUENCE', 251668),
(414784, 'PTHR35304', NULL, NULL, NULL, NULL, 'OS05G0120300 PROTEIN-RELATED', 251668),
(414785, 'PTHR35304:SF1', NULL, NULL, NULL, NULL, 'OS05G0120300 PROTEIN', 251668),
(414786, 'PTHR12260', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 251669),
(414787, 'PTHR12260:SF6', NULL, NULL, NULL, NULL, 'DAMAGE-CONTROL PHOSPHATASE ARMT1', 251669),
(414788, 'PTHR12260:SF4', NULL, NULL, NULL, NULL, 'SUGAR PHOSPHATE PHOSPHATASE', 251669),
(414789, 'PTHR43832', NULL, NULL, NULL, NULL, '', 251670),
(414790, 'PTHR43832:SF3', NULL, NULL, NULL, NULL, 'METHYLTRANSF_25 DOMAIN-CONTAINING PROTEIN', 251670),
(414791, 'PTHR43832:SF1', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 251670),
(414792, 'PTHR31087:SF96', NULL, NULL, NULL, NULL, 'BNAANNG22520D PROTEIN', 251671),
(414793, 'PTHR31087:SF119', NULL, NULL, NULL, NULL, 'TUBBY C-TERMINAL-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 251671),
(414794, 'PTHR31087:SF95', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251671),
(414795, 'PTHR31087:SF94', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251671),
(414796, 'PTHR31087:SF117', NULL, NULL, NULL, NULL, 'BNAANNG09500D PROTEIN', 251671),
(414797, 'PTHR31087:SF50', NULL, NULL, NULL, NULL, 'LURP-ONE-LIKE PROTEIN', 251671),
(414798, 'PTHR31087:SF93', NULL, NULL, NULL, NULL, 'PROTEIN LURP-ONE-RELATED 2', 251671),
(414799, 'PTHR31087:SF116', NULL, NULL, NULL, NULL, 'BNAC06G15790D PROTEIN', 251671),
(414800, 'PTHR31087:SF115', NULL, NULL, NULL, NULL, 'PROTEIN LURP-ONE-RELATED 15', 251671);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(414801, 'PTHR31087:SF92', NULL, NULL, NULL, NULL, 'PROTEIN LURP-ONE-RELATED 12', 251671),
(414802, 'PTHR31087:SF91', NULL, NULL, NULL, NULL, 'PROTEIN LURP-ONE-RELATED 10-LIKE', 251671),
(414803, 'PTHR31087:SF113', NULL, NULL, NULL, NULL, 'BNAA03G17960D PROTEIN', 251671),
(414804, 'PTHR31087:SF112', NULL, NULL, NULL, NULL, 'PROTEIN LURP-ONE-RELATED 15', 251671),
(414805, 'PTHR31087:SF155', NULL, NULL, NULL, NULL, 'PROTEIN LURP-ONE-RELATED 10', 251671),
(414806, 'PTHR31087:SF111', NULL, NULL, NULL, NULL, 'BNAA06G00660D PROTEIN', 251671),
(414807, 'PTHR31087:SF154', NULL, NULL, NULL, NULL, '', 251671),
(414808, 'PTHR31087:SF110', NULL, NULL, NULL, NULL, 'BNAC06G06630D PROTEIN', 251671),
(414809, 'PTHR31087:SF59', NULL, NULL, NULL, NULL, 'PROTEIN LURP-ONE-RELATED 4', 251671),
(414810, 'PTHR31087:SF14', NULL, NULL, NULL, NULL, 'PROTEIN LURP-ONE-RELATED 17', 251671),
(414811, 'PTHR31087:SF58', NULL, NULL, NULL, NULL, 'PROTEIN LURP-ONE-RELATED 1-RELATED', 251671),
(414812, 'PTHR31087:SF153', NULL, NULL, NULL, NULL, 'PROTEIN LURP-ONE-RELATED 11', 251671),
(414813, 'PTHR31087:SF152', NULL, NULL, NULL, NULL, 'PROTEIN LURP-ONE-RELATED 13', 251671),
(414814, 'PTHR31087:SF57', NULL, NULL, NULL, NULL, '', 251671),
(414815, 'PTHR31087:SF151', NULL, NULL, NULL, NULL, 'PROTEIN LURP-ONE-RELATED 2', 251671),
(414816, 'PTHR31087:SF56', NULL, NULL, NULL, NULL, '', 251671),
(414817, 'PTHR31087:SF150', NULL, NULL, NULL, NULL, 'PROTEIN LURP-ONE-RELATED 16', 251671),
(414818, 'PTHR31087:SF98', NULL, NULL, NULL, NULL, 'GTP BINDING PROTEIN', 251671),
(414819, 'PTHR31087:SF17', NULL, NULL, NULL, NULL, 'PROTEIN LURP-ONE-RELATED 14-RELATED', 251671),
(414820, 'PTHR31087', NULL, NULL, NULL, NULL, '', 251671),
(414821, 'PTHR31087:SF108', NULL, NULL, NULL, NULL, 'TUBBY C-TERMINAL-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 251671),
(414822, 'PTHR31087:SF107', NULL, NULL, NULL, NULL, '', 251671),
(414823, 'PTHR31087:SF106', NULL, NULL, NULL, NULL, 'BNAA03G57510D PROTEIN', 251671),
(414824, 'PTHR31087:SF61', NULL, NULL, NULL, NULL, 'GTP BINDING PROTEIN', 251671),
(414825, 'PTHR31087:SF149', NULL, NULL, NULL, NULL, 'BNAA05G34820D PROTEIN', 251671),
(414826, 'PTHR31087:SF8', NULL, NULL, NULL, NULL, 'OS05G0510100 PROTEIN', 251671),
(414827, 'PTHR31087:SF60', NULL, NULL, NULL, NULL, 'PROTEIN LURP-ONE-RELATED 5', 251671),
(414828, 'PTHR31087:SF148', NULL, NULL, NULL, NULL, 'PROTEIN LURP-ONE-RELATED 8', 251671),
(414829, 'PTHR31087:SF104', NULL, NULL, NULL, NULL, 'BNAA01G37110D PROTEIN', 251671),
(414830, 'PTHR31087:SF3', NULL, NULL, NULL, NULL, 'PROTEIN LURP-ONE-RELATED 6', 251671),
(414831, 'PTHR31087:SF103', NULL, NULL, NULL, NULL, 'BNAC04G55550D PROTEIN', 251671),
(414832, 'PTHR31087:SF147', NULL, NULL, NULL, NULL, 'TUBBY-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 251671),
(414833, 'PTHR31087:SF146', NULL, NULL, NULL, NULL, 'PROTEIN LURP-ONE-RELATED 2', 251671),
(414834, 'PTHR31087:SF102', NULL, NULL, NULL, NULL, 'GTP BINDING PROTEIN', 251671),
(414835, 'PTHR31087:SF145', NULL, NULL, NULL, NULL, 'OS01G0931600 PROTEIN', 251671),
(414836, 'PTHR31087:SF100', NULL, NULL, NULL, NULL, 'BNAC08G49520D PROTEIN', 251671),
(414837, 'PTHR31087:SF144', NULL, NULL, NULL, NULL, 'TUBBY C-TERMINAL-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 251671),
(414838, 'PTHR31087:SF143', NULL, NULL, NULL, NULL, 'PROTEIN LURP-ONE-RELATED 14-LIKE', 251671),
(414839, 'PTHR31087:SF25', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR 2B FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 251671),
(414840, 'PTHR31087:SF69', NULL, NULL, NULL, NULL, 'PROTEIN LURP-ONE-RELATED 8', 251671),
(414841, 'PTHR31087:SF142', NULL, NULL, NULL, NULL, 'OS07G0672600 PROTEIN', 251671),
(414842, 'PTHR31087:SF24', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251671),
(414843, 'PTHR31087:SF141', NULL, NULL, NULL, NULL, '', 251671),
(414844, 'PTHR31087:SF140', NULL, NULL, NULL, NULL, 'TUBBY C-TERMINAL-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 251671),
(414845, 'PTHR31087:SF22', NULL, NULL, NULL, NULL, 'PROTEIN LURP-ONE-RELATED 8', 251671),
(414846, 'PTHR31087:SF65', NULL, NULL, NULL, NULL, 'PROTEIN LURP-ONE-RELATED 2', 251671); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(414847, 'PTHR31087:SF73', NULL, NULL, NULL, NULL, '', 251671),
(414848, 'PTHR31087:SF139', NULL, NULL, NULL, NULL, 'PROTEIN LURP-ONE-RELATED 10-LIKE', 251671),
(414849, 'PTHR31087:SF138', NULL, NULL, NULL, NULL, 'TUBBY C-TERMINAL-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 251671),
(414850, 'PTHR31087:SF133', NULL, NULL, NULL, NULL, 'TUBBY C-TERMINAL-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 251671),
(414851, 'PTHR31087:SF132', NULL, NULL, NULL, NULL, 'PROTEIN LURP-ONE-RELATED 14', 251671),
(414852, 'PTHR31087:SF131', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR 2B FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 251671),
(414853, 'PTHR31087:SF79', NULL, NULL, NULL, NULL, 'OS01G0817650 PROTEIN', 251671),
(414854, 'PTHR31087:SF77', NULL, NULL, NULL, NULL, 'OS05G0311500 PROTEIN', 251671),
(414855, 'PTHR31087:SF75', NULL, NULL, NULL, NULL, 'GTP BINDING PROTEIN', 251671),
(414856, 'PTHR31087:SF85', NULL, NULL, NULL, NULL, 'PROTEIN LURP-ONE-RELATED 7', 251671),
(414857, 'PTHR31087:SF129', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251671),
(414858, 'PTHR31087:SF128', NULL, NULL, NULL, NULL, 'PROTEIN LURP-ONE-RELATED 2', 251671),
(414859, 'PTHR31087:SF127', NULL, NULL, NULL, NULL, 'TUBBY C-TERMINAL-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 251671),
(414860, 'PTHR31087:SF126', NULL, NULL, NULL, NULL, 'BNAC03G72170D PROTEIN', 251671),
(414861, 'PTHR31087:SF81', NULL, NULL, NULL, NULL, 'LURP-ONE-LIKE PROTEIN-RELATED', 251671),
(414862, 'PTHR31087:SF125', NULL, NULL, NULL, NULL, 'PROTEIN LURP-ONE-RELATED 8-LIKE', 251671),
(414863, 'PTHR31087:SF122', NULL, NULL, NULL, NULL, 'TUBBY C-TERMINAL-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 251671),
(414864, 'PTHR31087:SF120', NULL, NULL, NULL, NULL, 'PROTEIN LURP-ONE-RELATED 10-LIKE', 251671),
(414865, 'PTHR31087:SF89', NULL, NULL, NULL, NULL, 'PROTEIN LURP-ONE-RELATED 12-LIKE ISOFORM X1', 251671),
(414866, 'PTHR31087:SF87', NULL, NULL, NULL, NULL, 'PROTEIN LURP1', 251671),
(414867, 'PTHR12740:SF4', NULL, NULL, NULL, NULL, 'JNK1/MAPK8-ASSOCIATED MEMBRANE PROTEIN', 251672),
(414868, 'PTHR12740:SF3', NULL, NULL, NULL, NULL, 'JNK1/MAPK8-ASSOCIATED MEMBRANE PROTEIN', 251672),
(414869, 'PTHR12740:SF2', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4931417E11 GENE', 251672),
(414870, 'PTHR12740', NULL, NULL, NULL, NULL, 'JNK1/MAPK8-ASSOCIATED MEMBRANE PROTEIN', 251672),
(414871, 'PTHR47041:SF2', NULL, NULL, NULL, NULL, 'SEC14 CYTOSOLIC FACTOR FAMILY PROTEIN / PHOSPHOGLYCERIDE TRANSFER FAMILY PROTEIN', 251673),
(414872, 'PTHR47041:SF6', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL/PHOSPHATIDYLCHOLINE TRANSFER PROTEIN SFH12-LIKE', 251673),
(414873, 'PTHR47041', NULL, NULL, NULL, NULL, 'SEC14 CYTOSOLIC FACTOR FAMILY PROTEIN / PHOSPHOGLYCERIDE TRANSFER FAMILY PROTEIN', 251673),
(414874, 'PTHR47041:SF5', NULL, NULL, NULL, NULL, 'SEC14 CYTOSOLIC FACTOR FAMILY PROTEIN', 251673),
(414875, 'PTHR23194:SF16', NULL, NULL, NULL, NULL, 'PROTEIN PYGOPUS', 251674),
(414876, 'PTHR23194:SF17', NULL, NULL, NULL, NULL, 'PROTEIN BCL9 HOMOLOG', 251674),
(414877, 'PTHR23194', NULL, NULL, NULL, NULL, 'PYGOPUS', 251674),
(414878, 'PTHR23194:SF7', NULL, NULL, NULL, NULL, 'PYGOPUS HOMOLOG 2', 251674),
(414879, 'PTHR23194:SF3', NULL, NULL, NULL, NULL, 'PYGOPUS HOMOLOG 1', 251674),
(414880, 'PTHR21119', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 251675),
(414881, 'PTHR21119:SF5', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 251675),
(414882, 'PTHR21119:SF8', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID TRANSFER PROTEIN C2CD2L', 251675),
(414883, 'PTHR21119:SF7', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN 2', 251675),
(414884, 'PTHR45282', NULL, NULL, NULL, NULL, 'OS03G0858400 PROTEIN', 251676),
(414885, 'PTHR45282:SF2', NULL, NULL, NULL, NULL, 'OS03G0858400 PROTEIN', 251676),
(414886, 'PTHR13117:SF5', NULL, NULL, NULL, NULL, 'PROTEIN RFT1 HOMOLOG', 251677),
(414887, 'PTHR13117', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM MULTISPAN TRANSMEMBRANE PROTEIN-RELATED', 251677),
(414888, 'PTHR24410:SF39', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN-RELATED', 251678),
(414889, 'PTHR24410:SF18', NULL, NULL, NULL, NULL, 'BTB DOMAIN CONTAINING 1', 251678);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(414890, 'PTHR24410', NULL, NULL, NULL, NULL, 'HL07962P-RELATED', 251678),
(414891, 'PTHR24410:SF40', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 251678),
(414892, 'PTHR24410:SF41', NULL, NULL, NULL, NULL, 'HL07962P', 251678),
(414893, 'PTHR24410:SF44', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 251678),
(414894, 'PTHR24410:SF33', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 251678),
(414895, 'PTHR24410:SF12', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN 17', 251678),
(414896, 'PTHR24410:SF45', NULL, NULL, NULL, NULL, 'TRISHANKU', 251678),
(414897, 'PTHR24410:SF34', NULL, NULL, NULL, NULL, 'LD40565P', 251678),
(414898, 'PTHR24410:SF23', NULL, NULL, NULL, NULL, 'SERINE-ENRICHED PROTEIN', 251678),
(414899, 'PTHR24410:SF31', NULL, NULL, NULL, NULL, 'BTB (POZ) DOMAIN-CONTAINING 17A', 251678),
(414900, 'PTHR24410:SF5', NULL, NULL, NULL, NULL, 'ECTODERM-NEURAL CORTEX PROTEIN 1', 251678),
(414901, 'PTHR24410:SF20', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 251678),
(414902, 'PTHR24410:SF10', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 25', 251678),
(414903, 'PTHR24410:SF43', NULL, NULL, NULL, NULL, 'BACK DOMAIN-CONTAINING PROTEIN', 251678),
(414904, 'PTHR24410:SF21', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 251678),
(414905, 'PTHR24410:SF26', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 251678),
(414906, 'PTHR24410:SF16', NULL, NULL, NULL, NULL, 'GALECTIN-3-BINDING PROTEIN', 251678),
(414907, 'PTHR24410:SF27', NULL, NULL, NULL, NULL, 'BTB DOMAIN CONTAINING 3', 251678),
(414908, 'PTHR24410:SF24', NULL, NULL, NULL, NULL, 'BTB DOMAIN CONTAINING 6', 251678),
(414909, 'PTHR24410:SF36', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 251678),
(414910, 'PTHR24410:SF8', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 251678),
(414911, 'PTHR31164:SF1', NULL, NULL, NULL, NULL, 'RAD52 MOTIF-CONTAINING PROTEIN 1', 251679),
(414912, 'PTHR31164', NULL, NULL, NULL, NULL, 'RAD52 MOTIF-CONTAINING PROTEIN 1', 251679),
(414913, 'PTHR47172:SF6', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 251680),
(414914, 'PTHR47172:SF9', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 251680),
(414915, 'PTHR47172:SF17', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 251680),
(414916, 'PTHR47172:SF28', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251680),
(414917, 'PTHR47172:SF29', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 15-LIKE', 251680),
(414918, 'PTHR47172:SF18', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 16', 251680),
(414919, 'PTHR47172:SF26', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 251680),
(414920, 'PTHR47172:SF16', NULL, NULL, NULL, NULL, 'GATA TYPE ZINC FINGER TRANSCRIPTION FACTOR FAMILY PROTEIN', 251680),
(414921, 'PTHR47172:SF27', NULL, NULL, NULL, NULL, 'ZINC FINGER, NHR/GATA-TYPE-RELATED', 251680),
(414922, 'PTHR47172:SF13', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 15-LIKE', 251680),
(414923, 'PTHR47172:SF24', NULL, NULL, NULL, NULL, 'OS01G0976800 PROTEIN', 251680),
(414924, 'PTHR47172:SF14', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 251680),
(414925, 'PTHR47172:SF11', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 17', 251680),
(414926, 'PTHR47172:SF23', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 16', 251680),
(414927, 'PTHR47172:SF21', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 17-LIKE', 251680),
(414928, 'PTHR47172', NULL, NULL, NULL, NULL, 'OS01G0976800 PROTEIN', 251680),
(414929, 'PTHR47172:SF1', NULL, NULL, NULL, NULL, 'GATA ZINC FINGER DOMAIN-CONTAINING PROTEIN 14-RELATED', 251680),
(414930, 'PTHR46485:SF1', NULL, NULL, NULL, NULL, 'LIM DOMAIN KINASE 2', 251681),
(414931, 'PTHR46485:SF2', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251681),
(414932, 'PTHR46485:SF3', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY TESTIS-SPECIFIC PROTEIN KINASE 1', 251681),
(414933, 'PTHR46485', NULL, NULL, NULL, NULL, 'LIM DOMAIN KINASE 1', 251681),
(414934, 'PTHR46485:SF4', NULL, NULL, NULL, NULL, 'LIM DOMAIN KINASE 1', 251681);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(414935, 'PTHR46485:SF5', NULL, NULL, NULL, NULL, 'CENTER DIVIDER, ISOFORM A', 251681),
(414936, 'PTHR46485:SF6', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY TESTIS-SPECIFIC PROTEIN KINASE 2', 251681),
(414937, 'PTHR46485:SF7', NULL, NULL, NULL, NULL, 'LIM DOMAIN KINASE 1', 251681),
(414938, 'PTHR20879:SF1', NULL, NULL, NULL, NULL, 'INTERLEUKIN-27 SUBUNIT ALPHA', 251682),
(414939, 'PTHR20879', NULL, NULL, NULL, NULL, 'INTERLEUKIN-27 SUBUNIT ALPHA', 251682),
(414940, 'PTHR10758', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 3/COP9 SIGNALOSOME COMPLEX SUBUNIT 3', 251683),
(414941, 'PTHR10758:SF19', NULL, NULL, NULL, NULL, 'PCI DOMAIN-CONTAINING PROTEIN', 251683),
(414942, 'PTHR10758:SF10', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 3-RELATED', 251683),
(414943, 'PTHR10758:SF14', NULL, NULL, NULL, NULL, 'COP9 SIGNALOSOME COMPLEX SUBUNIT 3-LIKE ISOFORM X1', 251683),
(414944, 'PTHR10758:SF17', NULL, NULL, NULL, NULL, 'OS08G0550100 PROTEIN', 251683),
(414945, 'PTHR10758:SF2', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 3', 251683),
(414946, 'PTHR10758:SF18', NULL, NULL, NULL, NULL, 'PROTEASOME COMPONENT (PCI) DOMAIN-CONTAINING PROTEIN-RELATED', 251683),
(414947, 'PTHR10758:SF1', NULL, NULL, NULL, NULL, 'COP9 SIGNALOSOME COMPLEX SUBUNIT 3', 251683),
(414948, 'PTHR34587:SF1', NULL, NULL, NULL, NULL, '', 251684),
(414949, 'PTHR34587:SF2', NULL, NULL, NULL, NULL, '', 251684),
(414950, 'PTHR34587', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', 251684),
(414951, 'PTHR30201', NULL, NULL, NULL, NULL, 'TRIPHOSPHORIBOSYL-DEPHOSPHO-COA SYNTHASE', 251685),
(414952, 'PTHR30201:SF2', NULL, NULL, NULL, NULL, '2-(5''''-TRIPHOSPHORIBOSYL)-3''-DEPHOSPHOCOENZYME-A SYNTHASE', 251685),
(414953, 'PTHR11847', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L15', 251686),
(414954, 'PTHR11847:SF27', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L15', 251686),
(414955, 'PTHR11847:SF26', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L15', 251686),
(414956, 'PTHR11847:SF22', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L15-1-RELATED', 251686),
(414957, 'PTHR11847:SF25', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L15', 251686),
(414958, 'PTHR11847:SF4', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L15', 251686),
(414959, 'PTHR11847:SF24', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L15', 251686),
(414960, 'PTHR11847:SF21', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L15', 251686),
(414961, 'PTHR11847:SF20', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L15', 251686),
(414962, 'PTHR13047:SF1', NULL, NULL, NULL, NULL, 'PRE-MRNA CLEAVAGE FACTOR IM 25 KDA SUBUNIT 1', 251687),
(414963, 'PTHR13047:SF0', NULL, NULL, NULL, NULL, 'CLEAVAGE AND POLYADENYLATION SPECIFICITY FACTOR SUBUNIT 5', 251687),
(414964, 'PTHR13047:SF5', NULL, NULL, NULL, NULL, 'PRE-MRNA CLEAVAGE FACTOR IM 25 KDA SUBUNIT', 251687),
(414965, 'PTHR13047:SF2', NULL, NULL, NULL, NULL, 'PRE-MRNA CLEAVAGE FACTOR IM 25 KDA SUBUNIT 2-LIKE', 251687),
(414966, 'PTHR13047:SF8', NULL, NULL, NULL, NULL, 'PRE-MRNA CLEAVAGE FACTOR IM 25 KDA SUBUNIT', 251687),
(414967, 'PTHR13047:SF7', NULL, NULL, NULL, NULL, 'PRE-MRNA CLEAVAGE FACTOR IM 25 KDA SUBUNIT', 251687),
(414968, 'PTHR13047', NULL, NULL, NULL, NULL, 'PRE-MRNA CLEAVAGE FACTOR IM, 25KD SUBUNIT', 251687),
(414969, 'PTHR13047:SF6', NULL, NULL, NULL, NULL, 'PRE-MRNA CLEAVAGE FACTOR IM 25 KDA SUBUNIT', 251687),
(414970, 'PTHR43736', NULL, NULL, NULL, NULL, 'ADP-RIBOSE PYROPHOSPHATASE', 251688),
(414971, 'PTHR43736:SF1', NULL, NULL, NULL, NULL, 'ADP-RIBOSE PYROPHOSPHATASE', 251688),
(414972, 'PTHR43736:SF2', NULL, NULL, NULL, NULL, 'MUTT/NUDIX FAMILY PROTEIN', 251688),
(414973, 'PTHR43736:SF4', NULL, NULL, NULL, NULL, 'DIHYDRONEOPTERIN TRIPHOSPHATE DIPHOSPHATASE', 251688),
(414974, 'PTHR37423:SF2', NULL, NULL, NULL, NULL, 'CELL DIVISION COORDINATOR CPOB-RELATED', 251689),
(414975, 'PTHR37423:SF3', NULL, NULL, NULL, NULL, 'MEMBRANE-BOUND LYTIC MUREIN TRANSGLYCOSYLASE C', 251689),
(414976, 'PTHR37423:SF4', NULL, NULL, NULL, NULL, 'ENDO-TYPE MEMBRANE-BOUND LYTIC MUREIN TRANSGLYCOSYLASE A', 251689);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(414977, 'PTHR37423', NULL, NULL, NULL, NULL, 'SOLUBLE LYTIC MUREIN TRANSGLYCOSYLASE-RELATED', 251689),
(414978, 'PTHR37423:SF1', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN ASSEMBLY FACTOR BAMD', 251689),
(414979, 'PTHR43512', NULL, NULL, NULL, NULL, 'TRANSLATION FACTOR GUF1-RELATED', 251690),
(414980, 'PTHR43512:SF7', NULL, NULL, NULL, NULL, 'TRANSLATION FACTOR GUF1, MITOCHONDRIAL', 251690),
(414981, 'PTHR43512:SF4', NULL, NULL, NULL, NULL, 'TRANSLATION FACTOR GUF1 HOMOLOG, CHLOROPLASTIC', 251690),
(414982, 'PTHR22455', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 251691),
(414983, 'PTHR22455:SF10', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 91', 251691),
(414984, 'PTHR11857', NULL, NULL, NULL, NULL, 'ODORANT BINDING PROTEIN-RELATED', 251692),
(414985, 'PTHR11857:SF42', NULL, NULL, NULL, NULL, 'GENERAL ODORANT-BINDING PROTEIN 19D-RELATED', 251692),
(414986, 'PTHR11857:SF46', NULL, NULL, NULL, NULL, 'GENERAL ODORANT-BINDING PROTEIN 99A-RELATED', 251692),
(414987, 'PTHR11857:SF45', NULL, NULL, NULL, NULL, 'GENERAL ODORANT-BINDING PROTEIN 83A-RELATED', 251692),
(414988, 'PTHR11857:SF4', NULL, NULL, NULL, NULL, 'GENERAL ODORANT-BINDING PROTEIN 69A', 251692),
(414989, 'PTHR11857:SF43', NULL, NULL, NULL, NULL, 'GEO07291P1-RELATED', 251692),
(414990, 'PTHR11857:SF48', NULL, NULL, NULL, NULL, 'GENERAL ODORANT-BINDING PROTEIN 57C-RELATED', 251692),
(414991, 'PTHR24111:SF0', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 34', 251693),
(414992, 'PTHR24111:SF1', NULL, NULL, NULL, NULL, '', 251693),
(414993, 'PTHR24111:SF3', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 73', 251693),
(414994, 'PTHR24111', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 34', 251693),
(414995, 'PTHR10132:SF16', NULL, NULL, NULL, NULL, 'ALPHA-SARCOGLYCAN', 251694),
(414996, 'PTHR10132:SF14', NULL, NULL, NULL, NULL, 'SARCOGLYCAN ALPHA, ISOFORM C', 251694),
(414997, 'PTHR10132:SF17', NULL, NULL, NULL, NULL, 'EPSILON-SARCOGLYCAN', 251694),
(414998, 'PTHR10132', NULL, NULL, NULL, NULL, 'ALPHA-/EPSILON-SARCOGLYCAN FAMILY MEMBER', 251694),
(414999, 'PTHR15604', NULL, NULL, NULL, NULL, 'SIGNALING THRESHOLD-REGULATING TRANSMEMBRANE ADAPTER 1', 251695),
(415000, 'PTHR15604:SF0', NULL, NULL, NULL, NULL, 'SIGNALING THRESHOLD-REGULATING TRANSMEMBRANE ADAPTER 1', 251695),
(415001, 'PTHR36393:SF1', NULL, NULL, NULL, NULL, 'SULFATE ADENYLYLTRANSFERASE SUBUNIT', 251696),
(415002, 'PTHR36393', NULL, NULL, NULL, NULL, 'SULFATE ADENYLYLTRANSFERASE SUBUNIT', 251696),
(415003, 'PTHR42824', NULL, NULL, NULL, NULL, 'GLUTAMINE AMIDOTRANSFERASE', 251697),
(415004, 'PTHR42824:SF1', NULL, NULL, NULL, NULL, 'GLUTAMINE AMIDOTRANSFERASE YAFJ-RELATED', 251697),
(415005, 'PTHR31404', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL GENOME MAINTENANCE PROTEIN MGM101', 251698),
(415006, 'PTHR31404:SF0', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL GENOME MAINTENANCE PROTEIN MGM101', 251698),
(415007, 'PTHR47129:SF1', NULL, NULL, NULL, NULL, 'NMRA DOMAIN-CONTAINING PROTEIN', 251699),
(415008, 'PTHR47129', NULL, NULL, NULL, NULL, 'QUINONE OXIDOREDUCTASE 2', 251699),
(415009, 'PTHR33958', NULL, NULL, NULL, NULL, 'PROTEIN C8ORF37', 251700),
(415010, 'PTHR33958:SF1', NULL, NULL, NULL, NULL, 'PROTEIN C8ORF37', 251700),
(415011, 'PTHR46955', NULL, NULL, NULL, NULL, 'PROTEIN CBG01349-RELATED', 251701),
(415012, 'PTHR46955:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG18983', 251701),
(415013, 'PTHR46955:SF4', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251701),
(415014, 'PTHR46955:SF1', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251701),
(415015, 'PTHR46955:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG01349', 251701),
(415016, 'PTHR46955:SF2', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251701),
(415017, 'PTHR11576:SF18', NULL, NULL, NULL, NULL, 'ZONA PELLUCIDA PROTEIN C', 251702),
(415018, 'PTHR11576:SF16', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 251702),
(415019, 'PTHR11576:SF15', NULL, NULL, NULL, NULL, 'ZONA PELLUCIDA GLYCOPROTEIN 3C-RELATED', 251702);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(415020, 'PTHR11576:SF14', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 251702),
(415021, 'PTHR11576:SF13', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 251702),
(415022, 'PTHR11576:SF23', NULL, NULL, NULL, NULL, 'ZONA PELLUCIDA SPERM-BINDING PROTEIN 3', 251702),
(415023, 'PTHR11576:SF22', NULL, NULL, NULL, NULL, 'ONCOPROTEIN INDUCED TRANSCRIPT 3', 251702),
(415024, 'PTHR11576:SF21', NULL, NULL, NULL, NULL, 'ZONA PELLUCIDA GLYCOPROTEIN 3D TANDEM DUPLICATE 1', 251702),
(415025, 'PTHR11576:SF2', NULL, NULL, NULL, NULL, 'ZONA PELLUCIDA SPERM-BINDING PROTEIN 3', 251702),
(415026, 'PTHR11576', NULL, NULL, NULL, NULL, 'ZONA PELLUCIDA SPERM-BINDING PROTEIN 3', 251702),
(415027, 'PTHR11576:SF3', NULL, NULL, NULL, NULL, 'NOVEL PROTEIN WITH A ZONA PELLUCIDA-LIKE DOMAIN-RELATED', 251702),
(415028, 'PTHR43289:SF32', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PKAA', 251703),
(415029, 'PTHR43289:SF33', NULL, NULL, NULL, NULL, 'SERINE/THREONINE KINASE 31', 251703),
(415030, 'PTHR43289:SF6', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NEKL-3', 251703),
(415031, 'PTHR43289:SF30', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 251703),
(415032, 'PTHR43289:SF31', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN (AFU_ORTHOLOGUE AFUA_2G11730)', 251703),
(415033, 'PTHR43289:SF2', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NEK7', 251703),
(415034, 'PTHR43289:SF14', NULL, NULL, NULL, NULL, 'LYMPHOKINE-ACTIVATED KILLER T-CELL-ORIGINATED PROTEIN KINASE', 251703),
(415035, 'PTHR43289', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 20-RELATED', 251703),
(415036, 'PTHR43289:SF13', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 20-RELATED', 251703),
(415037, 'PTHR23234:SF6', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 655', 251704),
(415038, 'PTHR23234:SF5', NULL, NULL, NULL, NULL, 'RIKEN CDNA 9030624G23 GENE-RELATED', 251704),
(415039, 'PTHR23234:SF7', NULL, NULL, NULL, NULL, 'GENE 14408-RELATED', 251704),
(415040, 'PTHR23234:SF1', NULL, NULL, NULL, NULL, 'RIKEN CDNA 6720489N17 GENE', 251704),
(415041, 'PTHR23234', NULL, NULL, NULL, NULL, 'ZNF44 PROTEIN', 251704),
(415042, 'PTHR23234:SF3', NULL, NULL, NULL, NULL, 'RIKEN CDNA 3300002I08 GENE-RELATED', 251704),
(415043, 'PTHR46352:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN STAR3', 251705),
(415044, 'PTHR46352:SF13', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 251705),
(415045, 'PTHR46352:SF1', NULL, NULL, NULL, NULL, 'PROTEIN SENSITIVE TO PROTON RHIZOTOXICITY 1', 251705),
(415046, 'PTHR46352:SF12', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 251705),
(415047, 'PTHR46352:SF10', NULL, NULL, NULL, NULL, 'PROTEIN SENSITIVE TO PROTON RHIZOTOXICITY 1-LIKE', 251705),
(415048, 'PTHR46352', NULL, NULL, NULL, NULL, 'PROTEIN SENSITIVE TO PROTON RHIZOTOXICITY 1', 251705),
(415049, 'PTHR46352:SF18', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 251705),
(415050, 'PTHR46352:SF5', NULL, NULL, NULL, NULL, 'OS03G0838800 PROTEIN', 251705),
(415051, 'PTHR46352:SF8', NULL, NULL, NULL, NULL, 'PROTEIN SENSITIVE TO PROTON RHIZOTOXICITY 2', 251705),
(415052, 'PTHR46352:SF14', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 251705),
(415053, 'PTHR46352:SF7', NULL, NULL, NULL, NULL, 'OS02G0572900 PROTEIN', 251705),
(415054, 'PTHR42724:SF1', NULL, NULL, NULL, NULL, 'TETRAACYLDISACCHARIDE 4''-KINASE, MITOCHONDRIAL-RELATED', 251706),
(415055, 'PTHR42724', NULL, NULL, NULL, NULL, 'TETRAACYLDISACCHARIDE 4''-KINASE', 251706),
(415056, 'PTHR43389:SF23', NULL, NULL, NULL, NULL, 'VACUOLAR PROTON PUMP SUBUNIT B', 251707),
(415057, 'PTHR43389:SF22', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT B1-RELATED', 251707),
(415058, 'PTHR43389:SF20', NULL, NULL, NULL, NULL, 'VACUOLAR PROTON PUMP SUBUNIT B', 251707),
(415059, 'PTHR43389:SF1', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT B, KIDNEY ISOFORM', 251707),
(415060, 'PTHR43389:SF19', NULL, NULL, NULL, NULL, 'VACUOLAR PROTON PUMP SUBUNIT B', 251707);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(415061, 'PTHR43389:SF18', NULL, NULL, NULL, NULL, 'VACUOLAR PROTON PUMP SUBUNIT B', 251707),
(415062, 'PTHR43389:SF28', NULL, NULL, NULL, NULL, 'VACUOLAR PROTON PUMP SUBUNIT B', 251707),
(415063, 'PTHR43389:SF5', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT B, BRAIN ISOFORM', 251707),
(415064, 'PTHR43389:SF27', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT B2', 251707),
(415065, 'PTHR43389:SF4', NULL, NULL, NULL, NULL, 'ATP-SYNT_AB DOMAIN-CONTAINING PROTEIN-RELATED', 251707),
(415066, 'PTHR43389:SF26', NULL, NULL, NULL, NULL, 'VACUOLAR PROTON PUMP SUBUNIT B', 251707),
(415067, 'PTHR43389:SF25', NULL, NULL, NULL, NULL, 'VACUOLAR PROTON PUMP SUBUNIT B', 251707),
(415068, 'PTHR43389:SF2', NULL, NULL, NULL, NULL, 'VACUOLAR PROTON PUMP SUBUNIT B', 251707),
(415069, 'PTHR43389:SF24', NULL, NULL, NULL, NULL, 'VACUOLAR PROTON PUMP SUBUNIT B', 251707),
(415070, 'PTHR43389', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT B', 251707),
(415071, 'PTHR47085', NULL, NULL, NULL, NULL, 'ZINC FINGER MYND DOMAIN-CONTAINING PROTEIN 15', 251708),
(415072, 'PTHR47085:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER MYND DOMAIN-CONTAINING PROTEIN 15', 251708),
(415073, 'PTHR15364', NULL, NULL, NULL, NULL, '2''-DEOXYNUCLEOSIDE 5''-PHOSPHATE N-HYDROLASE 1', 251709),
(415074, 'PTHR15364:SF0', NULL, NULL, NULL, NULL, '2''-DEOXYNUCLEOSIDE 5''-PHOSPHATE N-HYDROLASE 1', 251709),
(415075, 'PTHR47199:SF2', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II STABILITY/ASSEMBLY FACTOR HCF136, CHLOROPLASTIC', 251710),
(415076, 'PTHR47199', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II STABILITY/ASSEMBLY FACTOR HCF136, CHLOROPLASTIC', 251710),
(415077, 'PTHR31362:SF0', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE STELLO1-RELATED', 251711),
(415078, 'PTHR31362:SF13', NULL, NULL, NULL, NULL, '', 251711),
(415079, 'PTHR31362', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE STELLO1-RELATED', 251711),
(415080, 'PTHR31362:SF14', NULL, NULL, NULL, NULL, '', 251711),
(415081, 'PTHR31362:SF11', NULL, NULL, NULL, NULL, '', 251711),
(415082, 'PTHR31362:SF12', NULL, NULL, NULL, NULL, 'BNAC04G02130D PROTEIN', 251711),
(415083, 'PTHR31362:SF9', NULL, NULL, NULL, NULL, '', 251711),
(415084, 'PTHR13184', NULL, NULL, NULL, NULL, '37S RIBOSOMAL PROTEIN S22', 251712),
(415085, 'PTHR13184:SF5', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE LIKE', 251712),
(415086, 'PTHR42198', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN', 251713),
(415087, 'PTHR42198:SF1', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN', 251713),
(415088, 'PTHR45681:SF4', NULL, NULL, NULL, NULL, 'PKS_AT DOMAIN-CONTAINING PROTEIN-RELATED', 251714),
(415089, 'PTHR45681:SF2', NULL, NULL, NULL, NULL, 'POLIKETIDE SYNTHASE 37', 251714),
(415090, 'PTHR45681:SF1', NULL, NULL, NULL, NULL, 'POLYKETIDE SYNTHASE 2-RELATED', 251714),
(415091, 'PTHR45681', NULL, NULL, NULL, NULL, 'POLYKETIDE SYNTHASE 44-RELATED', 251714),
(415092, 'PTHR45681:SF6', NULL, NULL, NULL, NULL, 'CARRIER DOMAIN-CONTAINING PROTEIN', 251714),
(415093, 'PTHR45681:SF5', NULL, NULL, NULL, NULL, 'POLYKETIDE SYNTHASE 27-RELATED', 251714),
(415094, 'PTHR12945:SF0', NULL, NULL, NULL, NULL, 'TRNA (ADENINE(58)-N(1))-METHYLTRANSFERASE NON-CATALYTIC SUBUNIT TRM6', 251715),
(415095, 'PTHR12945:SF1', NULL, NULL, NULL, NULL, 'TRNA (ADENINE(58)-N(1))-METHYLTRANSFERASE NON-CATALYTIC SUBUNIT TRM6', 251715),
(415096, 'PTHR12945', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR EIF3-RELATED', 251715),
(415097, 'PTHR12945:SF2', NULL, NULL, NULL, NULL, 'TRNA (ADENINE(58)-N(1))-METHYLTRANSFERASE NON-CATALYTIC SUBUNIT TRM6', 251715),
(415098, 'PTHR31671:SF2', NULL, NULL, NULL, NULL, 'TUMOR PROTEIN P53-INDUCIBLE NUCLEAR PROTEIN 2', 251716),
(415099, 'PTHR31671:SF4', NULL, NULL, NULL, NULL, 'SI:CH211-260E23.9', 251716),
(415100, 'PTHR31671:SF3', NULL, NULL, NULL, NULL, 'DIABETES AND OBESITY REGULATED, ISOFORM G', 251716),
(415101, 'PTHR31671', NULL, NULL, NULL, NULL, 'DIABETES AND OBESITY REGULATED, ISOFORM G', 251716),
(415102, 'PTHR31671:SF0', NULL, NULL, NULL, NULL, 'TUMOR PROTEIN P53-INDUCIBLE NUCLEAR PROTEIN 1', 251716),
(415103, 'PTHR42052', NULL, NULL, NULL, NULL, 'ABM DOMAIN-CONTAINING PROTEIN', 251717);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(415104, 'PTHR42052:SF1', NULL, NULL, NULL, NULL, 'ABM DOMAIN-CONTAINING PROTEIN', 251717),
(415105, 'PTHR41775:SF1', NULL, NULL, NULL, NULL, 'PEPTIDASE_M6 DOMAIN-CONTAINING PROTEIN', 251718),
(415106, 'PTHR41775', NULL, NULL, NULL, NULL, 'SECRETED PROTEIN-RELATED', 251718),
(415107, 'PTHR47062', NULL, NULL, NULL, NULL, '', 251719),
(415108, 'PTHR47062:SF1', NULL, NULL, NULL, NULL, 'SMALL HEAT SHOCK PROTEIN IBPA', 251719),
(415109, 'PTHR47062:SF2', NULL, NULL, NULL, NULL, 'SMALL HEAT SHOCK PROTEIN IBPB', 251719),
(415110, 'PTHR28626:SF6', NULL, NULL, NULL, NULL, 'PROTEIN SENSITIVITY TO RED LIGHT REDUCED', 251720),
(415111, 'PTHR28626:SF5', NULL, NULL, NULL, NULL, 'SRR1 DOMAIN-CONTAINING PROTEIN', 251720),
(415112, 'PTHR28626:SF4', NULL, NULL, NULL, NULL, 'PROTEIN SENSITIVITY TO RED LIGHT REDUCED 1-LIKE', 251720),
(415113, 'PTHR28626:SF3', NULL, NULL, NULL, NULL, 'SRR1-LIKE PROTEIN', 251720),
(415114, 'PTHR28626', NULL, NULL, NULL, NULL, 'SRR1-LIKE PROTEIN', 251720),
(415115, 'PTHR28626:SF7', NULL, NULL, NULL, NULL, 'OS04G0588900 PROTEIN', 251720),
(415116, 'PTHR42988', NULL, NULL, NULL, NULL, 'PHOSPHOHYDROLASE', 251721),
(415117, 'PTHR42988:SF2', NULL, NULL, NULL, NULL, '3'',5''-CYCLIC ADENOSINE MONOPHOSPHATE PHOSPHODIESTERASE CPDA', 251721),
(415118, 'PTHR37256:SF1', NULL, NULL, NULL, NULL, 'E1A-BINDING PROTEIN P400-LIKE', 251722),
(415119, 'PTHR37256:SF3', NULL, NULL, NULL, NULL, 'FORMIN-F-LIKE', 251722),
(415120, 'PTHR37256', NULL, NULL, NULL, NULL, 'E1A-BINDING PROTEIN P400-LIKE', 251722),
(415121, 'PTHR37256:SF4', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 251722),
(415122, 'PTHR37256:SF6', NULL, NULL, NULL, NULL, '', 251722),
(415123, 'PTHR37256:SF7', NULL, NULL, NULL, NULL, 'BNAC09G36610D PROTEIN', 251722),
(415124, 'PTHR12266:SF17', NULL, NULL, NULL, NULL, 'CATION/CALCIUM EXCHANGER 4', 251723),
(415125, 'PTHR12266:SF18', NULL, NULL, NULL, NULL, 'CATION/CALCIUM EXCHANGER 2', 251723),
(415126, 'PTHR12266:SF22', NULL, NULL, NULL, NULL, 'SODIUM/CALCIUM EXCHANGER MEMBRANE REGION-RELATED', 251723),
(415127, 'PTHR12266:SF33', NULL, NULL, NULL, NULL, 'CATION/CALCIUM EXCHANGER 5', 251723),
(415128, 'PTHR12266:SF34', NULL, NULL, NULL, NULL, 'SODIUM/CALCIUM EXCHANGER MEMBRANE REGION-RELATED', 251723),
(415129, 'PTHR12266:SF31', NULL, NULL, NULL, NULL, 'CATION/CALCIUM EXCHANGER 1-LIKE', 251723),
(415130, 'PTHR12266:SF21', NULL, NULL, NULL, NULL, 'CATION/CALCIUM EXCHANGER 3', 251723),
(415131, 'PTHR12266:SF32', NULL, NULL, NULL, NULL, 'K-EXCHANGER-LIKE PROTEIN', 251723),
(415132, 'PTHR12266:SF26', NULL, NULL, NULL, NULL, 'CATION/CALCIUM EXCHANGER 3-LIKE', 251723),
(415133, 'PTHR12266:SF35', NULL, NULL, NULL, NULL, 'CATION CALCIUM EXCHANGER', 251723),
(415134, 'PTHR12266:SF24', NULL, NULL, NULL, NULL, 'CATION/CALCIUM EXCHANGER 1', 251723),
(415135, 'PTHR12266:SF13', NULL, NULL, NULL, NULL, 'PUTATIVE, EXPRESSED-RELATED', 251723),
(415136, 'PTHR12266:SF25', NULL, NULL, NULL, NULL, 'SODIUM/CALCIUM EXCHANGER 6-RELATED', 251723),
(415137, 'PTHR12266:SF0', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SODIUM/CALCIUM EXCHANGER PROTEIN', 251723),
(415138, 'PTHR12266:SF30', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SODIUM/CALCIUM EXCHANGER PROTEIN-RELATED', 251723),
(415139, 'PTHR12266:SF1', NULL, NULL, NULL, NULL, 'NA/CA EXCHANGERS', 251723),
(415140, 'PTHR12266', NULL, NULL, NULL, NULL, 'NA+/CA2+ K+ INDEPENDENT EXCHANGER', 251723),
(415141, 'PTHR33744:SF1', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', 251724),
(415142, 'PTHR33744', NULL, NULL, NULL, NULL, 'CARBOHYDRATE DIACID REGULATOR', 251724),
(415143, 'PTHR33744:SF12', NULL, NULL, NULL, NULL, 'HTH_30 DOMAIN-CONTAINING PROTEIN', 251724),
(415144, 'PTHR33744:SF15', NULL, NULL, NULL, NULL, 'CARBOHYDRATE DIACID REGULATOR', 251724),
(415145, 'PTHR33744:SF7', NULL, NULL, NULL, NULL, '', 251724),
(415146, 'PTHR36067:SF5', NULL, NULL, NULL, NULL, '80A08_3', 251725),
(415147, 'PTHR36067', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251725),
(415148, 'PTHR36067:SF2', NULL, NULL, NULL, NULL, 'BNAC03G49100D PROTEIN', 251725),
(415149, 'PTHR36067:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251725);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(415150, 'PTHR36067:SF3', NULL, NULL, NULL, NULL, 'BNAA09G07110D PROTEIN', 251725),
(415151, 'PTHR46673:SF1', NULL, NULL, NULL, NULL, '4F2 CELL-SURFACE ANTIGEN HEAVY CHAIN', 251726),
(415152, 'PTHR46673:SF2', NULL, NULL, NULL, NULL, 'SI:DKEY-202G17.3', 251726),
(415153, 'PTHR46673:SF3', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 3 MEMBER 2A-RELATED', 251726),
(415154, 'PTHR46673', NULL, NULL, NULL, NULL, '4F2 CELL-SURFACE ANTIGEN HEAVY CHAIN', 251726),
(415155, 'PTHR34754', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 60', 251727),
(415156, 'PTHR34754:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 60', 251727),
(415157, 'PTHR13152', NULL, NULL, NULL, NULL, 'TFIIH, POLYPEPTIDE 4', 251728),
(415158, 'PTHR13152:SF0', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR IIH SUBUNIT 4', 251728),
(415159, 'PTHR37367', NULL, NULL, NULL, NULL, 'CHROMOSOME 4 OPEN READING FRAME 3', 251729),
(415160, 'PTHR37367:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 4 OPEN READING FRAME 3', 251729),
(415161, 'PTHR22923:SF50', NULL, NULL, NULL, NULL, 'CEREBELLIN-2', 251730),
(415162, 'PTHR22923:SF114', NULL, NULL, NULL, NULL, 'SI:CH73-180N10.1', 251730),
(415163, 'PTHR22923:SF113', NULL, NULL, NULL, NULL, 'C1Q DOMAIN-CONTAINING PROTEIN', 251730),
(415164, 'PTHR22923:SF96', NULL, NULL, NULL, NULL, 'COMPLEMENT C1Q-LIKE PROTEIN 3', 251730),
(415165, 'PTHR22923:SF112', NULL, NULL, NULL, NULL, 'C1Q DOMAIN-CONTAINING PROTEIN', 251730),
(415166, 'PTHR22923:SF52', NULL, NULL, NULL, NULL, 'SI:DKEYP-74B6.2', 251730),
(415167, 'PTHR22923:SF97', NULL, NULL, NULL, NULL, 'C1Q AND TNF-RELATED 4', 251730),
(415168, 'PTHR22923:SF111', NULL, NULL, NULL, NULL, 'C1Q AND TNF-RELATED 6B', 251730),
(415169, 'PTHR22923:SF70', NULL, NULL, NULL, NULL, 'COMPLEMENT C1Q TUMOR NECROSIS FACTOR-RELATED PROTEIN 6', 251730),
(415170, 'PTHR22923:SF93', NULL, NULL, NULL, NULL, 'SI:DKEY-5N18.1', 251730),
(415171, 'PTHR22923:SF69', NULL, NULL, NULL, NULL, 'COMPLEMENT C1Q-LIKE PROTEIN 2', 251730),
(415172, 'PTHR22923:SF110', NULL, NULL, NULL, NULL, 'CEREBELLIN 7', 251730),
(415173, 'PTHR22923:SF87', NULL, NULL, NULL, NULL, 'SI:CH211-219A15.3', 251730),
(415174, 'PTHR22923:SF89', NULL, NULL, NULL, NULL, 'CEREBELLIN 18', 251730),
(415175, 'PTHR22923:SF67', NULL, NULL, NULL, NULL, 'COMPLEMENT C1Q-LIKE PROTEIN 4', 251730),
(415176, 'PTHR22923:SF5', NULL, NULL, NULL, NULL, 'CEREBELLIN-1', 251730),
(415177, 'PTHR22923:SF2', NULL, NULL, NULL, NULL, 'CEREBELLIN-3', 251730),
(415178, 'PTHR22923:SF3', NULL, NULL, NULL, NULL, 'CEREBELLIN-4', 251730),
(415179, 'PTHR22923', NULL, NULL, NULL, NULL, 'CEREBELLIN-RELATED', 251730),
(415180, 'PTHR22923:SF103', NULL, NULL, NULL, NULL, 'CEREBELLIN 20-RELATED', 251730),
(415181, 'PTHR22923:SF61', NULL, NULL, NULL, NULL, 'COMPLEMENT C1Q TUMOR NECROSIS FACTOR-RELATED PROTEIN 8', 251730),
(415182, 'PTHR22923:SF62', NULL, NULL, NULL, NULL, 'COMPLEMENT C1Q TUMOR NECROSIS FACTOR-RELATED PROTEIN 3', 251730),
(415183, 'PTHR22923:SF84', NULL, NULL, NULL, NULL, 'CEREBELLIN 12', 251730),
(415184, 'PTHR22923:SF102', NULL, NULL, NULL, NULL, 'CEREBELLIN 10-RELATED', 251730),
(415185, 'PTHR22923:SF63', NULL, NULL, NULL, NULL, 'COMPLEMENT C1Q TUMOR NECROSIS FACTOR-RELATED PROTEIN 1', 251730),
(415186, 'PTHR22923:SF64', NULL, NULL, NULL, NULL, 'C1Q-RELATED FACTOR', 251730),
(415187, 'PTHR22923:SF107', NULL, NULL, NULL, NULL, 'COMPLEMENT C1Q TUMOR NECROSIS FACTOR-RELATED PROTEIN 4', 251730),
(415188, 'PTHR22923:SF82', NULL, NULL, NULL, NULL, 'C1Q DOMAIN-CONTAINING PROTEIN', 251730),
(415189, 'PTHR22923:SF99', NULL, NULL, NULL, NULL, 'C1Q DOMAIN-CONTAINING PROTEIN-RELATED', 251730),
(415190, 'PTHR13947:SF53', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE 8B-RELATED', 251731),
(415191, 'PTHR13947:SF42', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE 8', 251731),
(415192, 'PTHR13947:SF52', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE 14', 251731),
(415193, 'PTHR13947:SF51', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE 14', 251731),
(415194, 'PTHR13947', NULL, NULL, NULL, NULL, 'GNAT FAMILY N-ACETYLTRANSFERASE', 251731);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(415195, 'PTHR13947:SF50', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE, GNAT FAMILY FAMILY', 251731),
(415196, 'PTHR13947:SF37', NULL, NULL, NULL, NULL, 'LD18367P', 251731),
(415197, 'PTHR13947:SF48', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE 8-RELATED', 251731),
(415198, 'PTHR13947:SF2', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE FAMILY 8 MEMBER 3-RELATED', 251731),
(415199, 'PTHR13947:SF36', NULL, NULL, NULL, NULL, 'SI:CH211-81N22.1', 251731),
(415200, 'PTHR13947:SF11', NULL, NULL, NULL, NULL, 'N-ACETYLASPARTATE SYNTHETASE', 251731),
(415201, 'PTHR13947:SF6', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE 8 (GCN5-RELATED) FAMILY MEMBER 4-RELATED', 251731),
(415202, 'PTHR33981:SF16', NULL, NULL, NULL, NULL, 'FYD', 251732),
(415203, 'PTHR33981:SF17', NULL, NULL, NULL, NULL, 'HSP20-LIKE CHAPERONE SUPERFAMILY PROTEIN', 251732),
(415204, 'PTHR33981:SF15', NULL, NULL, NULL, NULL, 'HSP20-LIKE CHAPERONES SUPERFAMILY PROTEIN', 251732),
(415205, 'PTHR33981:SF12', NULL, NULL, NULL, NULL, 'SLT1 PROTEIN', 251732),
(415206, 'PTHR33981:SF10', NULL, NULL, NULL, NULL, 'HSP20-LIKE CHAPERONES SUPERFAMILY PROTEIN ISOFORM 1', 251732),
(415207, 'PTHR33981:SF20', NULL, NULL, NULL, NULL, '', 251732),
(415208, 'PTHR33981:SF3', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251732),
(415209, 'PTHR33981', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251732),
(415210, 'PTHR33981:SF18', NULL, NULL, NULL, NULL, 'OS01G0840200 PROTEIN', 251732),
(415211, 'PTHR33981:SF19', NULL, NULL, NULL, NULL, 'BNAA04G21580D PROTEIN', 251732),
(415212, 'PTHR15056', NULL, NULL, NULL, NULL, 'ACTIVATOR OF APOPTOSIS HARAKIRI', 251733),
(415213, 'PTHR15056:SF0', NULL, NULL, NULL, NULL, 'ACTIVATOR OF APOPTOSIS HARAKIRI', 251733),
(415214, 'PTHR30482:SF4', NULL, NULL, NULL, NULL, 'SLR1201 PROTEIN', 251734),
(415215, 'PTHR30482:SF5', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN', 251734),
(415216, 'PTHR30482:SF10', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY BRANCHED-CHAIN AMINO ACID TRANSPORT SYSTEM PERMEASE PROTEIN LIVM', 251734),
(415217, 'PTHR30482:SF1', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN AMINO ACID TRANSPORT PERMEASE PROTEIN LIVM-RELATED', 251734),
(415218, 'PTHR30482', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY BRANCHED-CHAIN AMINO ACID TRANSPORT SYSTEM PERMEASE', 251734),
(415219, 'PTHR30482:SF19', NULL, NULL, NULL, NULL, 'AMINO ACID ABC TRANSPORTER PERMEASE PROTEIN', 251734),
(415220, 'PTHR30482:SF18', NULL, NULL, NULL, NULL, 'BRANCHED AMINO ACID TRANSPORT SYSTEM PERMEASE-RELATED', 251734),
(415221, 'PTHR30482:SF17', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN', 251734),
(415222, 'PTHR34696:SF1', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLFORMYLGLYCINAMIDINE SYNTHASE SUBUNIT PURS', 251735),
(415223, 'PTHR34696', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLFORMYLGLYCINAMIDINE SYNTHASE SUBUNIT PURS', 251735),
(415224, 'PTHR47646:SF1', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN MAGIX', 251736),
(415225, 'PTHR47646', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN MAGIX', 251736),
(415226, 'PTHR43999:SF10', NULL, NULL, NULL, NULL, 'DNAJ DOMAIN, MYB-LIKE DNA-BINDING DOMAIN PROTEIN-RELATED', 251737),
(415227, 'PTHR43999', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 2', 251737),
(415228, 'PTHR43999:SF11', NULL, NULL, NULL, NULL, 'DNAJ AND MYB-LIKE DNA-BINDING DOMAIN-CONTAINING PROTEIN', 251737),
(415229, 'PTHR43999:SF5', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 251737),
(415230, 'PTHR43999:SF2', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 251737),
(415231, 'PTHR43999:SF1', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 2', 251737),
(415232, 'PTHR43999:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MAMYB', 251737),
(415233, 'PTHR24089:SF292', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ADENINE NUCLEOTIDE TRANSPORTER BTL3-RELATED', 251738),
(415234, 'PTHR24089:SF0', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CARRIER PROTEIN COAC2', 251738),
(415235, 'PTHR24089:SF681', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ADENINE NUCLEOTIDE TRANSPORTER BTL1-RELATED', 251738),
(415236, 'PTHR24089:SF680', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ADENINE NUCLEOTIDE TRANSPORTER BTL3 ISOFORM X1-RELATED', 251738);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(415237, 'PTHR24089:SF685', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CARRIER PROTEIN-RELATED', 251738),
(415238, 'PTHR24089:SF761', NULL, NULL, NULL, NULL, 'SUBSTRATE CARRIER FAMILY PROTEIN', 251738),
(415239, 'PTHR24089:SF442', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN A', 251738),
(415240, 'PTHR24089:SF243', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 25, MEMBER 54', 251738),
(415241, 'PTHR24089:SF760', NULL, NULL, NULL, NULL, '', 251738),
(415242, 'PTHR24089:SF688', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ADENINE NUCLEOTIDE TRANSPORTER BTL1-RELATED', 251738),
(415243, 'PTHR24089:SF402', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN V', 251738),
(415244, 'PTHR24089:SF720', NULL, NULL, NULL, NULL, 'BNAA05G18840D PROTEIN', 251738),
(415245, 'PTHR24089:SF687', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CARRIER LIKE PROTEIN', 251738),
(415246, 'PTHR24089:SF246', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 25 MEMBER 43', 251738),
(415247, 'PTHR24089:SF726', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING MITOCHONDRIAL CARRIER PROTEIN SCAMC-2-B', 251738),
(415248, 'PTHR24089:SF724', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN B', 251738),
(415249, 'PTHR24089:SF723', NULL, NULL, NULL, NULL, 'SUBSTRATE CARRIER PROTEIN-RELATED', 251738),
(415250, 'PTHR24089:SF718', NULL, NULL, NULL, NULL, 'BNAA02G34490D PROTEIN', 251738),
(415251, 'PTHR24089:SF281', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE TRANSPORTER BT1, CHLOROPLASTIC/AMYLOPLASTIC/MITOCHONDRIAL', 251738),
(415252, 'PTHR24089', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 25', 251738),
(415253, 'PTHR24089:SF196', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING MITOCHONDRIAL CARRIER PROTEIN SCAMC-3', 251738),
(415254, 'PTHR24089:SF751', NULL, NULL, NULL, NULL, 'GRAVE DISEASE CARRIER PROTEIN', 251738),
(415255, 'PTHR24089:SF750', NULL, NULL, NULL, NULL, 'ADP/ATP CARRIER PROTEIN', 251738),
(415256, 'PTHR24089:SF671', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 25 MEMBER 24,-LIKE', 251738),
(415257, 'PTHR24089:SF711', NULL, NULL, NULL, NULL, 'FI05451P', 251738),
(415258, 'PTHR24089:SF755', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CARRIER PROTEIN-RELATED', 251738),
(415259, 'PTHR24089:SF677', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN P-LIKE', 251738),
(415260, 'PTHR24089:SF754', NULL, NULL, NULL, NULL, 'OS09G0497000 PROTEIN', 251738),
(415261, 'PTHR24089:SF358', NULL, NULL, NULL, NULL, 'OS06G0602700 PROTEIN', 251738),
(415262, 'PTHR24089:SF753', NULL, NULL, NULL, NULL, '', 251738),
(415263, 'PTHR24089:SF676', NULL, NULL, NULL, NULL, 'ENVELOPE ADP,ATP CARRIER PROTEIN, CHLOROPLASTIC-RELATED', 251738),
(415264, 'PTHR24089:SF752', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT MITOCHONDRIAL ATP-MAGNESIUM/PHOSPHATE CARRIER PROTEIN 1', 251738),
(415265, 'PTHR24089:SF759', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN', 251738),
(415266, 'PTHR24089:SF758', NULL, NULL, NULL, NULL, '', 251738),
(415267, 'PTHR24089:SF757', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN', 251738),
(415268, 'PTHR24089:SF756', NULL, NULL, NULL, NULL, '', 251738),
(415269, 'PTHR24089:SF708', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 25 MEMBER 23B', 251738),
(415270, 'PTHR24089:SF707', NULL, NULL, NULL, NULL, 'BNAA09G40900D PROTEIN', 251738),
(415271, 'PTHR24089:SF705', NULL, NULL, NULL, NULL, 'GRAVES DISEASE CARRIER PROTEIN', 251738),
(415272, 'PTHR24089:SF749', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN', 251738),
(415273, 'PTHR24089:SF59', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL THIAMINE PYROPHOSPHATE CARRIER', 251738),
(415274, 'PTHR24089:SF262', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING MITOCHONDRIAL CARRIER PROTEIN SCAMC-1', 251738),
(415275, 'PTHR24089:SF740', NULL, NULL, NULL, NULL, 'OS06G0604500 PROTEIN', 251738),
(415276, 'PTHR24089:SF463', NULL, NULL, NULL, NULL, 'OS01G0708900 PROTEIN', 251738),
(415277, 'PTHR24089:SF348', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE TRANSPORTER BT1, CHLOROPLASTIC/MITOCHONDRIAL', 251738);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(415278, 'PTHR24089:SF700', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT MITOCHONDRIAL ATP-MAGNESIUM/PHOSPHATE CARRIER PROTEIN 3', 251738),
(415279, 'PTHR24089:SF744', NULL, NULL, NULL, NULL, 'OS05G0585900 PROTEIN', 251738),
(415280, 'PTHR24089:SF57', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING MITOCHONDRIAL CARRIER PROTEIN SCAMC-2', 251738),
(415281, 'PTHR24089:SF741', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ADENINE NUCLEOTIDE TRANSPORTER ADNT1-LIKE', 251738),
(415282, 'PTHR24089:SF748', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ADENINE NUCLEOTIDE TRANSPORTER ADNT1-LIKE', 251738),
(415283, 'PTHR24089:SF747', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN', 251738),
(415284, 'PTHR24089:SF746', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN B-LIKE ISOFORM X1', 251738),
(415285, 'PTHR24089:SF701', NULL, NULL, NULL, NULL, 'BNAA03G17470D PROTEIN', 251738),
(415286, 'PTHR24089:SF745', NULL, NULL, NULL, NULL, '', 251738),
(415287, 'PTHR24089:SF738', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN', 251738),
(415288, 'PTHR24089:SF182', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CARRIER PROTEIN-RELATED', 251738),
(415289, 'PTHR24089:SF181', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CARRIER PROTEIN SCAMC-3L', 251738),
(415290, 'PTHR24089:SF690', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ADENINE NUCLEOTIDE TRANSPORTER ADNT1-LIKE', 251738),
(415291, 'PTHR24089:SF332', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING MITOCHONDRIAL CARRIER PROTEIN SCAMC-2-A', 251738),
(415292, 'PTHR24089:SF693', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN', 251738),
(415293, 'PTHR24089:SF699', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CARRIER PROTEIN-RELATED', 251738),
(415294, 'PTHR24089:SF698', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ADENINE NUCLEOTIDE TRANSPORTER ADNT1', 251738),
(415295, 'PTHR24089:SF697', NULL, NULL, NULL, NULL, 'THYLAKOID ADP,ATP CARRIER PROTEIN, CHLOROPLASTIC', 251738),
(415296, 'PTHR24089:SF737', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ADENINE NUCLEOTIDE TRANSPORTER BTL2-RELATED', 251738),
(415297, 'PTHR24089:SF736', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL COENZYME A TRANSPORTER SLC25A42', 251738),
(415298, 'PTHR11079:SF190', NULL, NULL, NULL, NULL, 'CYTOSINE DEAMINASE', 251739),
(415299, 'PTHR11079:SF181', NULL, NULL, NULL, NULL, 'CMP/DCMP-TYPE DEAMINASE DOMAIN-CONTAINING PROTEIN', 251739),
(415300, 'PTHR11079:SF192', NULL, NULL, NULL, NULL, 'CYTIDINE/DEOXYCYTIDYLATE DEAMINASE', 251739),
(415301, 'PTHR11079:SF193', NULL, NULL, NULL, NULL, 'GUANINE DEAMINASE-LIKE ISOFORM X1', 251739),
(415302, 'PTHR11079:SF171', NULL, NULL, NULL, NULL, 'CMP/DCMP-TYPE DEAMINASE DOMAIN-CONTAINING PROTEIN', 251739),
(415303, 'PTHR11079:SF161', NULL, NULL, NULL, NULL, 'CMP/DCMP-TYPE DEAMINASE DOMAIN-CONTAINING PROTEIN', 251739),
(415304, 'PTHR11079:SF172', NULL, NULL, NULL, NULL, 'CMP/DCMP-TYPE DEAMINASE DOMAIN-CONTAINING PROTEIN', 251739),
(415305, 'PTHR11079:SF194', NULL, NULL, NULL, NULL, 'CYTIDINE DEAMINASE', 251739),
(415306, 'PTHR11079:SF195', NULL, NULL, NULL, NULL, 'DEAMINASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G13200)-RELATED', 251739),
(415307, 'PTHR11079:SF162', NULL, NULL, NULL, NULL, 'RIBOFLAVIN BIOSYNTHESIS PROTEIN PYRD, CHLOROPLASTIC', 251739),
(415308, 'PTHR11079:SF173', NULL, NULL, NULL, NULL, 'CMP/DCMP-TYPE DEAMINASE DOMAIN-CONTAINING PROTEIN', 251739),
(415309, 'PTHR11079:SF185', NULL, NULL, NULL, NULL, 'CMP/DCMP-TYPE DEAMINASE DOMAIN-CONTAINING PROTEIN', 251739),
(415310, 'PTHR11079:SF163', NULL, NULL, NULL, NULL, 'CYTIDINE/DEOXYCYTIDYLATE DEAMINASE FAMILY PROTEIN', 251739),
(415311, 'PTHR11079:SF152', NULL, NULL, NULL, NULL, 'CMP/DCMP-TYPE DEAMINASE DOMAIN-CONTAINING PROTEIN', 251739),
(415312, 'PTHR11079:SF186', NULL, NULL, NULL, NULL, 'DEAMINASE, PUTATIVE, EXPRESSED-RELATED', 251739),
(415313, 'PTHR11079', NULL, NULL, NULL, NULL, 'CYTOSINE DEAMINASE FAMILY MEMBER', 251739),
(415314, 'PTHR11079:SF178', NULL, NULL, NULL, NULL, 'CMP/DCMP-TYPE DEAMINASE DOMAIN-CONTAINING PROTEIN', 251739),
(415315, 'PTHR11079:SF156', NULL, NULL, NULL, NULL, 'INACTIVE TRNA-SPECIFIC ADENOSINE DEAMINASE-LIKE PROTEIN 3-RELATED', 251739);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(415316, 'PTHR11079:SF179', NULL, NULL, NULL, NULL, 'TRNA(ADENINE(34)) DEAMINASE, CHLOROPLASTIC', 251739),
(415317, 'PTHR11079:SF168', NULL, NULL, NULL, NULL, 'RIBOFLAVIN BIOSYNTHESIS PROTEIN PYRR, CHLOROPLASTIC', 251739),
(415318, 'PTHR11079:SF149', NULL, NULL, NULL, NULL, 'TRNA-SPECIFIC ADENOSINE DEAMINASE 2', 251739),
(415319, 'PTHR37694', NULL, NULL, NULL, NULL, 'SLR8022 PROTEIN', 251740),
(415320, 'PTHR37694:SF1', NULL, NULL, NULL, NULL, 'SLR8022 PROTEIN', 251740),
(415321, 'PTHR48129:SF1', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L37A', 251741),
(415322, 'PTHR48129', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L37A', 251741),
(415323, 'PTHR43772:SF4', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY PROTEIN 64 PROTEIN C5-LIKE', 251742),
(415324, 'PTHR43772:SF5', NULL, NULL, NULL, NULL, 'BETA-1,4-XYLOSIDASE (EUROFUNG)', 251742),
(415325, 'PTHR43772', NULL, NULL, NULL, NULL, 'ENDO-1,4-BETA-XYLANASE', 251742),
(415326, 'PTHR43772:SF2', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_2G04480)-RELATED', 251742),
(415327, 'PTHR39596', NULL, NULL, NULL, NULL, '', 251743),
(415328, 'PTHR39596:SF3', NULL, NULL, NULL, NULL, 'HET DOMAIN-CONTAINING PROTEIN', 251743),
(415329, 'PTHR39596:SF4', NULL, NULL, NULL, NULL, 'HET DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_3G03140)', 251743),
(415330, 'PTHR39596:SF2', NULL, NULL, NULL, NULL, 'HET DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_1G17550)-RELATED', 251743),
(415331, 'PTHR20973', NULL, NULL, NULL, NULL, 'NON-SMC ELEMENT 1-RELATED', 251744),
(415332, 'PTHR20973:SF2', NULL, NULL, NULL, NULL, 'NON-STRUCTURAL MAINTENANCE OF CHROMOSOMES ELEMENT 1 HOMOLOG', 251744),
(415333, 'PTHR20973:SF0', NULL, NULL, NULL, NULL, 'NON-STRUCTURAL MAINTENANCE OF CHROMOSOMES ELEMENT 1 HOMOLOG', 251744),
(415334, 'PTHR20973:SF1', NULL, NULL, NULL, NULL, 'NON-STRUCTURAL MAINTENANCE OF CHROMOSOMES ELEMENT 1 HOMOLOG', 251744),
(415335, 'PTHR47148:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY FACTOR 1 HOMOLOG', 251745),
(415336, 'PTHR47148', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY FACTOR 1 HOMOLOG', 251745),
(415337, 'PTHR40735', NULL, NULL, NULL, NULL, 'RNA-EDITING COMPLEX PROTEIN MP42-RELATED', 251746),
(415338, 'PTHR40735:SF2', NULL, NULL, NULL, NULL, 'RNA-EDITING COMPLEX PROTEIN MP81', 251746),
(415339, 'PTHR40735:SF3', NULL, NULL, NULL, NULL, 'RNA-EDITING COMPLEX PROTEIN MP42', 251746),
(415340, 'PTHR40735:SF4', NULL, NULL, NULL, NULL, 'RNA EDITING COMPLEX PROTEIN MP63', 251746),
(415341, 'PTHR43329:SF15', NULL, NULL, NULL, NULL, 'HALOALKANE DEHALOGENASE', 251747),
(415342, 'PTHR43329:SF59', NULL, NULL, NULL, NULL, 'EPOXIDE HYDROLASE 2', 251747),
(415343, 'PTHR43329:SF111', NULL, NULL, NULL, NULL, 'EPOXIDE HYDROLASE-RELATED', 251747),
(415344, 'PTHR43329:SF154', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251747),
(415345, 'PTHR43329:SF113', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251747),
(415346, 'PTHR43329:SF112', NULL, NULL, NULL, NULL, 'HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G08810)-RELATED', 251747),
(415347, 'PTHR43329:SF6', NULL, NULL, NULL, NULL, 'EPOXIDE HYDROLASE-LIKE PROTEIN', 251747),
(415348, 'PTHR43329:SF4', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL EPOXIDE HYDROLASE 2', 251747),
(415349, 'PTHR43329:SF2', NULL, NULL, NULL, NULL, 'EPOXIDE HYDROLASE 4', 251747),
(415350, 'PTHR43329:SF151', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL EPOXIDE HYDROLASE 2-LIKE', 251747),
(415351, 'PTHR43329:SF3', NULL, NULL, NULL, NULL, 'HYDROLASE, PUTATIVE, EXPRESSED-RELATED', 251747),
(415352, 'PTHR43329:SF150', NULL, NULL, NULL, NULL, 'SLL1305 PROTEIN', 251747),
(415353, 'PTHR43329:SF153', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251747),
(415354, 'PTHR43329:SF1', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251747),
(415355, 'PTHR43329:SF152', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251747),
(415356, 'PTHR43329:SF65', NULL, NULL, NULL, NULL, 'EPOXIDE HYDROLASE', 251747),
(415357, 'PTHR43329:SF8', NULL, NULL, NULL, NULL, 'HYDROLASE, ALPHA/BETA FOLD FAMILY PROTEIN, EXPRESSED', 251747);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(415358, 'PTHR43329:SF107', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL EPOXIDE HYDROLASE 2', 251747),
(415359, 'PTHR43329:SF69', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251747),
(415360, 'PTHR43329:SF28', NULL, NULL, NULL, NULL, 'HYDROLASE, PUTATIVE, EXPRESSED-RELATED', 251747),
(415361, 'PTHR43329:SF144', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 251747),
(415362, 'PTHR43329:SF143', NULL, NULL, NULL, NULL, 'EPOXIDE HYDROLASE-RELATED', 251747),
(415363, 'PTHR43329:SF146', NULL, NULL, NULL, NULL, 'EPOXIDE HYDROLASE', 251747),
(415364, 'PTHR43329:SF145', NULL, NULL, NULL, NULL, 'EPOXIDE HYDROLASE-RELATED', 251747),
(415365, 'PTHR43329:SF148', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251747),
(415366, 'PTHR43329:SF147', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL EPOXIDE HYDROLASE 2-LIKE', 251747),
(415367, 'PTHR43329:SF106', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251747),
(415368, 'PTHR43329:SF149', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251747),
(415369, 'PTHR43329:SF140', NULL, NULL, NULL, NULL, 'SOLUBLE EPOXIDE HYDROLASE', 251747),
(415370, 'PTHR43329:SF142', NULL, NULL, NULL, NULL, 'EPOXIDE HYDROLASE-RELATED', 251747),
(415371, 'PTHR43329:SF141', NULL, NULL, NULL, NULL, 'EPOXIDE HYDROLASE 1', 251747),
(415372, 'PTHR43329:SF71', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL EPOXIDE HYDROLASE 2-LIKE', 251747),
(415373, 'PTHR43329:SF74', NULL, NULL, NULL, NULL, 'OS01G0919700 PROTEIN', 251747),
(415374, 'PTHR43329:SF73', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL EPOXIDE HYDROLASE 2-LIKE', 251747),
(415375, 'PTHR43329:SF133', NULL, NULL, NULL, NULL, 'OS05G0273800 PROTEIN', 251747),
(415376, 'PTHR43329:SF132', NULL, NULL, NULL, NULL, 'EPOXIDE HYDROLASE-RELATED', 251747),
(415377, 'PTHR43329:SF135', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 251747),
(415378, 'PTHR43329:SF134', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN-RELATED', 251747),
(415379, 'PTHR43329:SF137', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251747),
(415380, 'PTHR43329:SF136', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL EPOXIDE HYDROLASE 2-LIKE', 251747),
(415381, 'PTHR43329:SF139', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL EPOXIDE HYDROLASE 2-LIKE', 251747),
(415382, 'PTHR43329:SF138', NULL, NULL, NULL, NULL, 'EPOXIDE HYDROLASE EPHC (EPOXIDE HYDRATASE)-RELATED', 251747),
(415383, 'PTHR43329:SF131', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251747),
(415384, 'PTHR43329:SF130', NULL, NULL, NULL, NULL, 'EPOXIDE HYDROLASE', 251747),
(415385, 'PTHR43329:SF81', NULL, NULL, NULL, NULL, 'SERINE HYDROLASE-LIKE PROTEIN-RELATED', 251747),
(415386, 'PTHR43329:SF82', NULL, NULL, NULL, NULL, 'ATSEH-RELATED', 251747),
(415387, 'PTHR43329:SF43', NULL, NULL, NULL, NULL, 'HYDROLASE, PUTATIVE-RELATED', 251747),
(415388, 'PTHR43329:SF86', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251747),
(415389, 'PTHR43329:SF129', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL EPOXIDE HYDROLASE 2-LIKE', 251747),
(415390, 'PTHR43329:SF46', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN-RELATED', 251747),
(415391, 'PTHR43329', NULL, NULL, NULL, NULL, 'EPOXIDE HYDROLASE', 251747),
(415392, 'PTHR43329:SF122', NULL, NULL, NULL, NULL, 'PROLINE IMINOPEPTIDASE', 251747),
(415393, 'PTHR43329:SF126', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251747),
(415394, 'PTHR43329:SF125', NULL, NULL, NULL, NULL, 'HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G05590)-RELATED', 251747),
(415395, 'PTHR43329:SF92', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL EPOXIDE HYDROLASE 2-LIKE', 251747),
(415396, 'PTHR43329:SF50', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL EPOXIDE HYDROLASE 2-LIKE', 251747),
(415397, 'PTHR43329:SF93', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL EPOXIDE HYDROLASE 2-LIKE', 251747),
(415398, 'PTHR43329:SF96', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251747),
(415399, 'PTHR43329:SF95', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 251747);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(415400, 'PTHR43329:SF10', NULL, NULL, NULL, NULL, 'EPOXIDE HYDROLASE 3', 251747),
(415401, 'PTHR43329:SF97', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 251747),
(415402, 'PTHR47868:SF3', NULL, NULL, NULL, NULL, 'TPR_MALT DOMAIN-CONTAINING PROTEIN', 251748),
(415403, 'PTHR47868:SF2', NULL, NULL, NULL, NULL, 'OS05G0457700 PROTEIN', 251748),
(415404, 'PTHR47868', NULL, NULL, NULL, NULL, 'OS05G0457700 PROTEIN', 251748),
(415405, 'PTHR35701', NULL, NULL, NULL, NULL, 'OS11G0148400 PROTEIN', 251749),
(415406, 'PTHR35701:SF1', NULL, NULL, NULL, NULL, 'OS11G0148400 PROTEIN', 251749),
(415407, 'PTHR43249', NULL, NULL, NULL, NULL, 'UDP-N-ACETYL-2-AMINO-2-DEOXY-D-GLUCURONATE OXIDASE', 251750),
(415408, 'PTHR43249:SF1', NULL, NULL, NULL, NULL, 'D-GLUCOSIDE 3-DEHYDROGENASE', 251750),
(415409, 'PTHR31407:SF41', NULL, NULL, NULL, NULL, 'PSBP DOMAIN-CONTAINING PROTEIN', 251751),
(415410, 'PTHR31407:SF44', NULL, NULL, NULL, NULL, 'PSBP DOMAIN-CONTAINING PROTEIN', 251751),
(415411, 'PTHR31407:SF45', NULL, NULL, NULL, NULL, 'PSBP DOMAIN-CONTAINING PROTEIN', 251751),
(415412, 'PTHR31407:SF20', NULL, NULL, NULL, NULL, 'THYLAKOID LUMENAL 19 KDA PROTEIN, CHLOROPLASTIC', 251751),
(415413, 'PTHR31407:SF7', NULL, NULL, NULL, NULL, 'PSBP DOMAIN-CONTAINING PROTEIN 5, CHLOROPLASTIC', 251751),
(415414, 'PTHR31407:SF6', NULL, NULL, NULL, NULL, 'OXYGEN-EVOLVING ENHANCER PROTEIN 2-1, CHLOROPLASTIC', 251751),
(415415, 'PTHR31407:SF10', NULL, NULL, NULL, NULL, 'PHOTOSYNTHETIC NDH SUBUNIT OF LUMENAL LOCATION 1, CHLOROPLASTIC', 251751),
(415416, 'PTHR31407:SF5', NULL, NULL, NULL, NULL, 'PLASTID TRANSCRIPTIONALLY ACTIVE 3', 251751),
(415417, 'PTHR31407:SF4', NULL, NULL, NULL, NULL, 'PSBP-LIKE PROTEIN 1, CHLOROPLASTIC', 251751),
(415418, 'PTHR31407:SF3', NULL, NULL, NULL, NULL, 'PSBP DOMAIN-CONTAINING PROTEIN 2, CHLOROPLASTIC', 251751),
(415419, 'PTHR31407', NULL, NULL, NULL, NULL, '', 251751),
(415420, 'PTHR31407:SF15', NULL, NULL, NULL, NULL, 'PSBP DOMAIN-CONTAINING PROTEIN 1, CHLOROPLASTIC', 251751),
(415421, 'PTHR31407:SF16', NULL, NULL, NULL, NULL, 'PSBP DOMAIN-CONTAINING PROTEIN 7, CHLOROPLASTIC', 251751),
(415422, 'PTHR31407:SF38', NULL, NULL, NULL, NULL, 'PSBP DOMAIN-CONTAINING PROTEIN 4, CHLOROPLASTIC', 251751),
(415423, 'PTHR31407:SF46', NULL, NULL, NULL, NULL, '23 KDA SUBUNIT OF OXYGEN EVOLVING SYSTEM OF PHOTOSYSTEM II', 251751),
(415424, 'PTHR31407:SF47', NULL, NULL, NULL, NULL, 'PSBP DOMAIN-CONTAINING PROTEIN', 251751),
(415425, 'PTHR31407:SF39', NULL, NULL, NULL, NULL, 'PSBP DOMAIN-CONTAINING PROTEIN', 251751),
(415426, 'PTHR31407:SF17', NULL, NULL, NULL, NULL, 'PSBP DOMAIN-CONTAINING PROTEIN 3, CHLOROPLASTIC', 251751),
(415427, 'PTHR31407:SF18', NULL, NULL, NULL, NULL, 'PSBP DOMAIN-CONTAINING PROTEIN 6, CHLOROPLASTIC', 251751),
(415428, 'PTHR11911:SF85', NULL, NULL, NULL, NULL, 'INOSINE-5''-MONOPHOSPHATE DEHYDROGENASE-RELATED', 251752),
(415429, 'PTHR11911:SF74', NULL, NULL, NULL, NULL, 'INOSINE-5''-MONOPHOSPHATE DEHYDROGENASE 1', 251752),
(415430, 'PTHR11911:SF129', NULL, NULL, NULL, NULL, 'INOSINE-5''-MONOPHOSPHATE DEHYDROGENASE 1B', 251752),
(415431, 'PTHR11911:SF128', NULL, NULL, NULL, NULL, 'CBS DOMAIN-CONTAINING PROTEIN', 251752),
(415432, 'PTHR11911:SF127', NULL, NULL, NULL, NULL, 'IMPDH DOMAIN-CONTAINING PROTEIN', 251752),
(415433, 'PTHR11911:SF126', NULL, NULL, NULL, NULL, 'INOSINE-5''-MONOPHOSPHATE DEHYDROGENASE', 251752),
(415434, 'PTHR11911:SF125', NULL, NULL, NULL, NULL, 'INOSINE-5''-MONOPHOSPHATE DEHYDROGENASE', 251752),
(415435, 'PTHR11911:SF124', NULL, NULL, NULL, NULL, 'INOSINE-5''-MONOPHOSPHATE DEHYDROGENASE 1', 251752),
(415436, 'PTHR11911:SF123', NULL, NULL, NULL, NULL, 'INOSINE-5''-MONOPHOSPHATE DEHYDROGENASE', 251752),
(415437, 'PTHR11911:SF111', NULL, NULL, NULL, NULL, 'INOSINE-5''-MONOPHOSPHATE DEHYDROGENASE', 251752),
(415438, 'PTHR11911:SF122', NULL, NULL, NULL, NULL, 'GMP REDUCTASE', 251752),
(415439, 'PTHR11911:SF121', NULL, NULL, NULL, NULL, 'INOSINE-5''-MONOPHOSPHATE DEHYDROGENASE 2', 251752),
(415440, 'PTHR11911', NULL, NULL, NULL, NULL, 'INOSINE-5-MONOPHOSPHATE DEHYDROGENASE RELATED', 251752);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(415441, 'PTHR43182:SF1', NULL, NULL, NULL, NULL, 'COBALT-PRECORRIN-7 C(5)-METHYLTRANSFERASE', 251753),
(415442, 'PTHR43182', NULL, NULL, NULL, NULL, 'COBALT-PRECORRIN-6B C(15)-METHYLTRANSFERASE (DECARBOXYLATING)', 251753),
(415443, 'PTHR47958:SF90', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX5-RELATED', 251754),
(415444, 'PTHR47958', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DBP3', 251754),
(415445, 'PTHR47958:SF91', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DBP2-LIKE', 251754),
(415446, 'PTHR47958:SF92', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 14', 251754),
(415447, 'PTHR47958:SF93', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX19B', 251754),
(415448, 'PTHR47958:SF169', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 15-RELATED', 251754),
(415449, 'PTHR47958:SF168', NULL, NULL, NULL, NULL, 'ATP DEPENDENT RNA HELICASE-RELATED', 251754),
(415450, 'PTHR47958:SF95', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 58, CHLOROPLASTIC', 251754),
(415451, 'PTHR47958:SF96', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX23-RELATED', 251754),
(415452, 'PTHR47958:SF167', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX4', 251754),
(415453, 'PTHR47958:SF166', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 11-LIKE', 251754),
(415454, 'PTHR47958:SF87', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE PL10-RELATED', 251754),
(415455, 'PTHR47958:SF165', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 37', 251754),
(415456, 'PTHR47958:SF88', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX50', 251754),
(415457, 'PTHR47958:SF164', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 52A', 251754),
(415458, 'PTHR47958:SF163', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX19A', 251754),
(415459, 'PTHR47958:SF89', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX20-RELATED', 251754),
(415460, 'PTHR47958:SF162', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 56 ISOFORM X1', 251754),
(415461, 'PTHR47958:SF161', NULL, NULL, NULL, NULL, 'INITIATION FACTOR 4A-LIKE PROTEIN', 251754),
(415462, 'PTHR47958:SF160', NULL, NULL, NULL, NULL, 'EUKARYOTIC INITIATION FACTOR 4A-14', 251754),
(415463, 'PTHR47958:SF159', NULL, NULL, NULL, NULL, '', 251754),
(415464, 'PTHR47958:SF158', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE-LIKE PROTEIN', 251754),
(415465, 'PTHR47958:SF157', NULL, NULL, NULL, NULL, 'RNA HELICASE', 251754),
(415466, 'PTHR47958:SF156', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 37-LIKE ISOFORM X1', 251754),
(415467, 'PTHR47958:SF17', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX43-RELATED', 251754),
(415468, 'PTHR47958:SF18', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX3Y', 251754),
(415469, 'PTHR47958:SF155', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 37-LIKE', 251754),
(415470, 'PTHR47958:SF154', NULL, NULL, NULL, NULL, '', 251754),
(415471, 'PTHR47958:SF10', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX39A', 251754),
(415472, 'PTHR47958:SF99', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 53-LIKE', 251754),
(415473, 'PTHR47958:SF11', NULL, NULL, NULL, NULL, 'RNA HELICASE', 251754),
(415474, 'PTHR47958:SF153', NULL, NULL, NULL, NULL, 'DEAD/H RNA HELICASE, PUTATIVE-RELATED', 251754),
(415475, 'PTHR47958:SF152', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 52C', 251754),
(415476, 'PTHR47958:SF13', NULL, NULL, NULL, NULL, 'RNA HELICASE', 251754),
(415477, 'PTHR47958:SF151', NULL, NULL, NULL, NULL, 'BOX FAMILY HELICASE, PUTATIVE-RELATED', 251754),
(415478, 'PTHR47958:SF150', NULL, NULL, NULL, NULL, 'RNA HELICASE', 251754),
(415479, 'PTHR47958:SF14', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE-LIKE PROTEIN DB10 ISOFORM X1', 251754),
(415480, 'PTHR47958:SF106', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 251754),
(415481, 'PTHR47958:SF70', NULL, NULL, NULL, NULL, 'RNA HELICASE', 251754),
(415482, 'PTHR47958:SF71', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX5-RELATED', 251754);
INSERT INTO "PUBLIC"."MODEL" VALUES
(415483, 'PTHR47958:SF104', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE WM6', 251754),
(415484, 'PTHR47958:SF103', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX41-RELATED', 251754),
(415485, 'PTHR47958:SF72', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX3Y', 251754),
(415486, 'PTHR47958:SF73', NULL, NULL, NULL, NULL, 'RNA HELICASE', 251754),
(415487, 'PTHR47958:SF109', NULL, NULL, NULL, NULL, 'NUCLEOLAR RNA HELICASE 2', 251754),
(415488, 'PTHR47958:SF100', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 34', 251754),
(415489, 'PTHR47958:SF65', NULL, NULL, NULL, NULL, 'EUKARYOTIC INITIATION FACTOR 4A-8', 251754),
(415490, 'PTHR47958:SF69', NULL, NULL, NULL, NULL, 'EUKARYOTIC INITIATION FACTOR 4A-2', 251754),
(415491, 'PTHR47958:SF80', NULL, NULL, NULL, NULL, 'HELICASE ATP-BINDING DOMAIN-CONTAINING PROTEIN', 251754),
(415492, 'PTHR47958:SF82', NULL, NULL, NULL, NULL, 'BNAA08G07020D PROTEIN', 251754),
(415493, 'PTHR47958:SF85', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 37-LIKE', 251754),
(415494, 'PTHR47958:SF1', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR EIF-4A', 251754),
(415495, 'PTHR47958:SF2', NULL, NULL, NULL, NULL, 'DEAD BOX RNA HELICASE-PL10B', 251754),
(415496, 'PTHR47958:SF3', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX3X', 251754),
(415497, 'PTHR47958:SF4', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX3X', 251754),
(415498, 'PTHR47958:SF5', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 14', 251754),
(415499, 'PTHR47958:SF6', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 53', 251754),
(415500, 'PTHR47958:SF7', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 56', 251754),
(415501, 'PTHR47958:SF8', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DBP3 ISOFORM X1', 251754),
(415502, 'PTHR47958:SF75', NULL, NULL, NULL, NULL, 'RNA HELICASE', 251754),
(415503, 'PTHR47958:SF76', NULL, NULL, NULL, NULL, 'DEAD BOX RNA HELICASE FAMILY PROTEIN-RELATED', 251754),
(415504, 'PTHR47958:SF79', NULL, NULL, NULL, NULL, 'RNA HELICASE', 251754),
(415505, 'PTHR47958:SF170', NULL, NULL, NULL, NULL, 'DDX42, SF3B125', 251754),
(415506, 'PTHR47958:SF129', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 56', 251754),
(415507, 'PTHR47958:SF128', NULL, NULL, NULL, NULL, 'EUKARYOTIC INITIATION FACTOR 4A-15-LIKE', 251754),
(415508, 'PTHR47958:SF50', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX53-RELATED', 251754),
(415509, 'PTHR47958:SF124', NULL, NULL, NULL, NULL, 'SPLICEOSOME RNA HELICASE DDX39B', 251754),
(415510, 'PTHR47958:SF123', NULL, NULL, NULL, NULL, 'RNA HELICASE', 251754),
(415511, 'PTHR47958:SF52', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 46', 251754),
(415512, 'PTHR47958:SF122', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE CG14443-RELATED', 251754),
(415513, 'PTHR47958:SF43', NULL, NULL, NULL, NULL, '', 251754),
(415514, 'PTHR47958:SF120', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 52', 251754),
(415515, 'PTHR47958:SF46', NULL, NULL, NULL, NULL, 'DEAD BOX ATP-DEPENDENT RNA HELICASE', 251754),
(415516, 'PTHR47958:SF48', NULL, NULL, NULL, NULL, 'DNA HELICASE, ATP-DEPENDENT, RECQ TYPE, BACTERIAL-RELATED', 251754),
(415517, 'PTHR47958:SF119', NULL, NULL, NULL, NULL, 'BNAC03G41130D PROTEIN', 251754),
(415518, 'PTHR47958:SF118', NULL, NULL, NULL, NULL, 'BNAC04G43400D PROTEIN', 251754),
(415519, 'PTHR47958:SF117', NULL, NULL, NULL, NULL, 'EUKARYOTIC INITIATION FACTOR 4A-15', 251754),
(415520, 'PTHR47958:SF60', NULL, NULL, NULL, NULL, 'DEAD/H RNA HELICASE HEL64, PUTATIVE-RELATED', 251754),
(415521, 'PTHR47958:SF63', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 22', 251754),
(415522, 'PTHR47958:SF112', NULL, NULL, NULL, NULL, 'RNA HELICASE', 251754),
(415523, 'PTHR47958:SF53', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 37', 251754),
(415524, 'PTHR47958:SF54', NULL, NULL, NULL, NULL, 'RNA HELICASE', 251754),
(415525, 'PTHR47958:SF56', NULL, NULL, NULL, NULL, 'RNA HELICASE', 251754);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(415526, 'PTHR47958:SF57', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX1', 251754),
(415527, 'PTHR47958:SF59', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 20', 251754),
(415528, 'PTHR47958:SF149', NULL, NULL, NULL, NULL, 'HELICASE ATP-BINDING DOMAIN-CONTAINING PROTEIN', 251754),
(415529, 'PTHR47958:SF148', NULL, NULL, NULL, NULL, 'RNA HELICASE, ATP-DEPENDENT DEAH BOX, HRPB-TYPE-RELATED', 251754),
(415530, 'PTHR47958:SF147', NULL, NULL, NULL, NULL, 'MUTATOR', 251754),
(415531, 'PTHR47958:SF146', NULL, NULL, NULL, NULL, 'EUKARYOTIC INITIATION FACTOR 4A-15', 251754),
(415532, 'PTHR47958:SF145', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 11', 251754),
(415533, 'PTHR47958:SF30', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX59-RELATED', 251754),
(415534, 'PTHR47958:SF144', NULL, NULL, NULL, NULL, '', 251754),
(415535, 'PTHR47958:SF143', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX4-RELATED', 251754),
(415536, 'PTHR47958:SF21', NULL, NULL, NULL, NULL, 'BNAA01G25900D PROTEIN', 251754),
(415537, 'PTHR47958:SF142', NULL, NULL, NULL, NULL, 'RNA HELICASE', 251754),
(415538, 'PTHR47958:SF140', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX17-RELATED', 251754),
(415539, 'PTHR47958:SF24', NULL, NULL, NULL, NULL, 'RNA HELICASE', 251754),
(415540, 'PTHR47958:SF26', NULL, NULL, NULL, NULL, 'EUKARYOTIC INITIATION FACTOR 4A-III', 251754),
(415541, 'PTHR47958:SF27', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 57', 251754),
(415542, 'PTHR47958:SF136', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 37-LIKE', 251754),
(415543, 'PTHR47958:SF40', NULL, NULL, NULL, NULL, 'DEAD/H RNA HELICASE, PUTATIVE-RELATED', 251754),
(415544, 'PTHR47958:SF135', NULL, NULL, NULL, NULL, 'HELICASE CAS3, CRISPR-ASSOCIATED, CORE-RELATED', 251754),
(415545, 'PTHR47958:SF134', NULL, NULL, NULL, NULL, 'RNA HELICASE', 251754),
(415546, 'PTHR47958:SF31', NULL, NULL, NULL, NULL, 'RNA HELICASE', 251754),
(415547, 'PTHR47958:SF32', NULL, NULL, NULL, NULL, 'RNA HELICASE', 251754),
(415548, 'PTHR47958:SF132', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE RDE-12', 251754),
(415549, 'PTHR47958:SF33', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX25', 251754),
(415550, 'PTHR47958:SF34', NULL, NULL, NULL, NULL, 'EUKARYOTIC INITIATION FACTOR 4A-II', 251754),
(415551, 'PTHR47958:SF35', NULL, NULL, NULL, NULL, 'LOW QUALITY PROTEIN: DEAD-BOX ATP-DEPENDENT RNA HELICASE 42-LIKE', 251754),
(415552, 'PTHR36895', NULL, NULL, NULL, NULL, '', 251755),
(415553, 'PTHR36895:SF1', NULL, NULL, NULL, NULL, 'YCF23 PROTEIN', 251755),
(415554, 'PTHR35801', NULL, NULL, NULL, NULL, 'PHOSPHOSERINE PHOSPHATASE RSBX', 251756),
(415555, 'PTHR35801:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOSERINE PHOSPHATASE RSBX', 251756),
(415556, 'PTHR21115', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 251757),
(415557, 'PTHR21115:SF0', NULL, NULL, NULL, NULL, 'GH06117P-RELATED', 251757),
(415558, 'PTHR45848', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE 12 FAMILY MEMBER', 251758),
(415559, 'PTHR45848:SF6', NULL, NULL, NULL, NULL, 'OS02G0251700 PROTEIN', 251758),
(415560, 'PTHR45848:SF5', NULL, NULL, NULL, NULL, '', 251758),
(415561, 'PTHR45848:SF4', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE 12', 251758),
(415562, 'PTHR33484:SF9', NULL, NULL, NULL, NULL, 'BNAC01G22150D PROTEIN', 251759),
(415563, 'PTHR33484:SF7', NULL, NULL, NULL, NULL, '', 251759),
(415564, 'PTHR33484:SF6', NULL, NULL, NULL, NULL, 'BNAANNG21520D PROTEIN', 251759),
(415565, 'PTHR33484:SF3', NULL, NULL, NULL, NULL, '', 251759),
(415566, 'PTHR33484:SF4', NULL, NULL, NULL, NULL, '', 251759),
(415567, 'PTHR33484', NULL, NULL, NULL, NULL, 'BNAC07G33360D PROTEIN', 251759),
(415568, 'PTHR33484:SF12', NULL, NULL, NULL, NULL, 'BNAC07G33360D PROTEIN', 251759),
(415569, 'PTHR33484:SF11', NULL, NULL, NULL, NULL, '', 251759),
(415570, 'PTHR22656', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 251760),
(415571, 'PTHR22656:SF1', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING DOMAIN-CONTAINING PROTEIN 13', 251760);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(415572, 'PTHR28663', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 173', 251761),
(415573, 'PTHR28663:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 173', 251761),
(415574, 'PTHR37745:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251762),
(415575, 'PTHR37745:SF2', NULL, NULL, NULL, NULL, 'BNACNNG65030D PROTEIN', 251762),
(415576, 'PTHR37745', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251762),
(415577, 'PTHR32073', NULL, NULL, NULL, NULL, 'GH11358P', 251763),
(415578, 'PTHR32073:SF7', NULL, NULL, NULL, NULL, 'GH11358P', 251763),
(415579, 'PTHR32073:SF6', NULL, NULL, NULL, NULL, 'DIVERGENT PROTEIN KINASE DOMAIN 2A', 251763),
(415580, 'PTHR32073:SF9', NULL, NULL, NULL, NULL, 'PIP49_C DOMAIN-CONTAINING PROTEIN', 251763),
(415581, 'PTHR32073:SF8', NULL, NULL, NULL, NULL, 'DIVERGENT PROTEIN KINASE DOMAIN 2B', 251763),
(415582, 'PTHR12760:SF0', NULL, NULL, NULL, NULL, 'ER MEMBRANE PROTEIN COMPLEX SUBUNIT 2', 251764),
(415583, 'PTHR12760:SF1', NULL, NULL, NULL, NULL, 'ER MEMBRANE PROTEIN COMPLEX SUBUNIT 2', 251764),
(415584, 'PTHR12760', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN', 251764),
(415585, 'PTHR11165:SF170', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN', 251765),
(415586, 'PTHR11165:SF127', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN', 251765),
(415587, 'PTHR11165:SF126', NULL, NULL, NULL, NULL, 'SLF-INTERACTING SKP1', 251765),
(415588, 'PTHR11165:SF169', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN', 251765),
(415589, 'PTHR11165:SF125', NULL, NULL, NULL, NULL, 'OS12G0595600 PROTEIN', 251765),
(415590, 'PTHR11165:SF24', NULL, NULL, NULL, NULL, 'S-PHASE KINASE-ASSOCIATED PROTEIN 1', 251765),
(415591, 'PTHR11165:SF128', NULL, NULL, NULL, NULL, 'SKP1 DOMAIN-CONTAINING PROTEIN', 251765),
(415592, 'PTHR11165:SF60', NULL, NULL, NULL, NULL, 'SKP1 DOMAIN-CONTAINING PROTEIN', 251765),
(415593, 'PTHR11165:SF166', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN', 251765),
(415594, 'PTHR11165:SF122', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN', 251765),
(415595, 'PTHR11165:SF121', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN', 251765),
(415596, 'PTHR11165:SF165', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN 13', 251765),
(415597, 'PTHR11165:SF120', NULL, NULL, NULL, NULL, 'S-PHASE KINASE-ASSOCIATED PROTEIN 1', 251765),
(415598, 'PTHR11165:SF181', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN 5', 251765),
(415599, 'PTHR11165:SF180', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN', 251765),
(415600, 'PTHR11165:SF138', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN', 251765),
(415601, 'PTHR11165:SF135', NULL, NULL, NULL, NULL, 'BNAANNG29490D PROTEIN', 251765),
(415602, 'PTHR11165:SF179', NULL, NULL, NULL, NULL, '', 251765),
(415603, 'PTHR11165:SF139', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN', 251765),
(415604, 'PTHR11165:SF130', NULL, NULL, NULL, NULL, 'SKP1', 251765),
(415605, 'PTHR11165:SF174', NULL, NULL, NULL, NULL, 'SKP1 DOMAIN-CONTAINING PROTEIN', 251765),
(415606, 'PTHR11165:SF173', NULL, NULL, NULL, NULL, 'PROTEIN CBG03271', 251765),
(415607, 'PTHR11165:SF178', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN', 251765),
(415608, 'PTHR11165:SF134', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN', 251765),
(415609, 'PTHR11165:SF133', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN', 251765),
(415610, 'PTHR11165:SF177', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN 21', 251765),
(415611, 'PTHR11165:SF176', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN 3-RELATED', 251765),
(415612, 'PTHR11165:SF175', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN', 251765),
(415613, 'PTHR11165:SF105', NULL, NULL, NULL, NULL, 'S-PHASE KINASE-ASSOCIATED PROTEIN 1', 251765),
(415614, 'PTHR11165:SF147', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN', 251765),
(415615, 'PTHR11165:SF102', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN 21', 251765),
(415616, 'PTHR11165:SF141', NULL, NULL, NULL, NULL, 'BNACNNG20980D PROTEIN', 251765),
(415617, 'PTHR11165:SF185', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN 14-RELATED', 251765),
(415618, 'PTHR11165:SF140', NULL, NULL, NULL, NULL, 'OS03G0107000 PROTEIN', 251765),
(415619, 'PTHR11165:SF184', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN', 251765);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(415620, 'PTHR11165:SF183', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN 1A', 251765),
(415621, 'PTHR11165:SF182', NULL, NULL, NULL, NULL, 'OSJNBA0093O08.6-LIKE PROTEIN', 251765),
(415622, 'PTHR11165:SF144', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN', 251765),
(415623, 'PTHR11165:SF100', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN', 251765),
(415624, 'PTHR11165:SF188', NULL, NULL, NULL, NULL, '', 251765),
(415625, 'PTHR11165:SF187', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN 1A', 251765),
(415626, 'PTHR11165:SF186', NULL, NULL, NULL, NULL, 'SKP1_POZ DOMAIN-CONTAINING PROTEIN', 251765),
(415627, 'PTHR11165:SF116', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN 20', 251765),
(415628, 'PTHR11165:SF115', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN', 251765),
(415629, 'PTHR11165:SF158', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN', 251765),
(415630, 'PTHR11165:SF157', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN', 251765),
(415631, 'PTHR11165:SF113', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN 21', 251765),
(415632, 'PTHR11165:SF56', NULL, NULL, NULL, NULL, '', 251765),
(415633, 'PTHR11165:SF55', NULL, NULL, NULL, NULL, 'SKP1_POZ DOMAIN-CONTAINING PROTEIN', 251765),
(415634, 'PTHR11165:SF54', NULL, NULL, NULL, NULL, 'SKP1-RELATED PROTEIN', 251765),
(415635, 'PTHR11165:SF119', NULL, NULL, NULL, NULL, 'SKP1_POZ DOMAIN-CONTAINING PROTEIN', 251765),
(415636, 'PTHR11165:SF98', NULL, NULL, NULL, NULL, 'SKP1_POZ DOMAIN-CONTAINING PROTEIN', 251765),
(415637, 'PTHR11165:SF97', NULL, NULL, NULL, NULL, 'LIGASE, PUTATIVE-RELATED', 251765),
(415638, 'PTHR11165:SF53', NULL, NULL, NULL, NULL, 'SKP1-RELATED PROTEIN', 251765),
(415639, 'PTHR11165:SF117', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN', 251765),
(415640, 'PTHR11165:SF52', NULL, NULL, NULL, NULL, 'SKP1-RELATED PROTEIN', 251765),
(415641, 'PTHR11165:SF152', NULL, NULL, NULL, NULL, 'OS10G0438100 PROTEIN', 251765),
(415642, 'PTHR11165:SF50', NULL, NULL, NULL, NULL, 'SKP1-RELATED PROTEIN', 251765),
(415643, 'PTHR11165:SF150', NULL, NULL, NULL, NULL, 'SKP1-RELATED PROTEIN', 251765),
(415644, 'PTHR11165:SF92', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN 1', 251765),
(415645, 'PTHR11165:SF156', NULL, NULL, NULL, NULL, 'SKP1 DOMAIN-CONTAINING PROTEIN', 251765),
(415646, 'PTHR11165:SF111', NULL, NULL, NULL, NULL, 'SCF UBIQUITIN LIGASE, SKP1 COMPONENT', 251765),
(415647, 'PTHR11165:SF155', NULL, NULL, NULL, NULL, 'SKP1-LIKE PROTEIN', 251765),
(415648, 'PTHR11165', NULL, NULL, NULL, NULL, 'SKP1', 251765),
(415649, 'PTHR33397', NULL, NULL, NULL, NULL, 'UPF0331 PROTEIN YUTE', 251766),
(415650, 'PTHR33397:SF5', NULL, NULL, NULL, NULL, 'RNASE YUTE-RELATED', 251766),
(415651, 'PTHR33397:SF3', NULL, NULL, NULL, NULL, 'MRNA NUCLEASE HEPT', 251766),
(415652, 'PTHR12245:SF11', NULL, NULL, NULL, NULL, 'PROTEIN GUSTAVUS', 251767),
(415653, 'PTHR12245:SF12', NULL, NULL, NULL, NULL, 'SPRY DOMAIN-CONTAINING SOCS BOX PROTEIN 3', 251767),
(415654, 'PTHR12245:SF13', NULL, NULL, NULL, NULL, 'B30.2/SPRY DOMAIN-CONTAINING PROTEIN', 251767),
(415655, 'PTHR12245:SF15', NULL, NULL, NULL, NULL, 'SI:CH1073-228J22.2', 251767),
(415656, 'PTHR12245:SF16', NULL, NULL, NULL, NULL, 'SI:DKEY-23N7.10', 251767),
(415657, 'PTHR12245:SF3', NULL, NULL, NULL, NULL, 'SPRY DOMAIN-CONTAINING SOCS BOX PROTEIN 4', 251767),
(415658, 'PTHR12245', NULL, NULL, NULL, NULL, 'SPRY DOMAIN CONTAINING SOCS BOX PROTEIN', 251767),
(415659, 'PTHR12245:SF2', NULL, NULL, NULL, NULL, 'SPRY DOMAIN-CONTAINING SOCS BOX PROTEIN 2', 251767),
(415660, 'PTHR12245:SF7', NULL, NULL, NULL, NULL, 'F-BOX/SPRY DOMAIN-CONTAINING PROTEIN 1', 251767),
(415661, 'PTHR12245:SF8', NULL, NULL, NULL, NULL, 'SPRY DOMAIN-CONTAINING SOCS BOX PROTEIN 1', 251767),
(415662, 'PTHR12245:SF5', NULL, NULL, NULL, NULL, 'SPRY DOMAIN-CONTAINING SOCS BOX PROTEIN 3', 251767),
(415663, 'PTHR46670:SF3', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 251768),
(415664, 'PTHR46670:SF2', NULL, NULL, NULL, NULL, '', 251768),
(415665, 'PTHR46670', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 251768),
(415666, 'PTHR47632:SF5', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251769);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(415667, 'PTHR47632:SF4', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251769),
(415668, 'PTHR47632:SF3', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251769),
(415669, 'PTHR47632:SF2', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR FRPR-1-RELATED', 251769),
(415670, 'PTHR47632:SF1', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251769),
(415671, 'PTHR47632', NULL, NULL, NULL, NULL, 'FMRFAMIDE PEPTIDE RECEPTOR FAMILY-RELATED', 251769),
(415672, 'PTHR21818:SF0', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA GROUP I PROTEIN', 251770),
(415673, 'PTHR21818', NULL, NULL, NULL, NULL, 'BC025462 PROTEIN', 251770),
(415674, 'PTHR20940', NULL, NULL, NULL, NULL, 'TETRA THYMOSIN', 251771),
(415675, 'PTHR20940:SF1', NULL, NULL, NULL, NULL, 'CIBOULOT, ISOFORM A', 251771),
(415676, 'PTHR43567', NULL, NULL, NULL, NULL, 'FLAVOREDOXIN-RELATED-RELATED', 251772),
(415677, 'PTHR43567:SF1', NULL, NULL, NULL, NULL, 'FLAVOREDOXIN-RELATED', 251772),
(415678, 'PTHR43567:SF5', NULL, NULL, NULL, NULL, 'FLAVIN_REDUCT DOMAIN-CONTAINING PROTEIN', 251772),
(415679, 'PTHR30073:SF5', NULL, NULL, NULL, NULL, 'ASPARTATE--AMMONIA LIGASE', 251773),
(415680, 'PTHR30073', NULL, NULL, NULL, NULL, 'ASPARTATE--AMMONIA LIGASE', 251773),
(415681, 'PTHR34829:SF1', NULL, NULL, NULL, NULL, 'SECRETOGLOBIN FAMILY 3A MEMBER 1', 251774),
(415682, 'PTHR34829:SF2', NULL, NULL, NULL, NULL, 'SECRETOGLOBIN FAMILY 3A MEMBER 2', 251774),
(415683, 'PTHR34829', NULL, NULL, NULL, NULL, 'SECRETOGLOBIN FAMILY 3A MEMBER 2', 251774),
(415684, 'PTHR33925', NULL, NULL, NULL, NULL, 'PLASTID DIVISION PROTEIN CDP1, CHLOROPLASTIC-RELATED', 251775),
(415685, 'PTHR33925:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ACCUMULATION AND REPLICATION OF CHLOROPLASTS 6, CHLOROPLASTIC', 251775),
(415686, 'PTHR33925:SF2', NULL, NULL, NULL, NULL, 'PLASTID DIVISION PROTEIN CDP1, CHLOROPLASTIC', 251775),
(415687, 'PTHR13046:SF0', NULL, NULL, NULL, NULL, 'CAAX PRENYL PROTEASE 2', 251776),
(415688, 'PTHR13046', NULL, NULL, NULL, NULL, 'PROTEASE U48 CAAX PRENYL PROTEASE RCE1', 251776),
(415689, 'PTHR35322', NULL, NULL, NULL, NULL, 'PROTEIN CPR-5', 251777),
(415690, 'PTHR35322:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CPR-5', 251777),
(415691, 'PTHR35322:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CPR-5', 251777),
(415692, 'PTHR35322:SF4', NULL, NULL, NULL, NULL, 'BNACNNG07400D PROTEIN', 251777),
(415693, 'PTHR15593', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 3-KINASE REGULATORY SUBUNIT', 251778),
(415694, 'PTHR15593:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE 3-KINASE REGULATORY SUBUNIT 6', 251778),
(415695, 'PTHR15593:SF3', NULL, NULL, NULL, NULL, 'PROTEIN DDB_G0292252-RELATED', 251778),
(415696, 'PTHR15593:SF2', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE 3-KINASE REGULATORY SUBUNIT 5', 251778),
(415697, 'PTHR33738:SF21', NULL, NULL, NULL, NULL, 'TPRXL', 251779),
(415698, 'PTHR33738:SF1', NULL, NULL, NULL, NULL, 'PLANT/T7H20-70 PROTEIN', 251779),
(415699, 'PTHR33738:SF20', NULL, NULL, NULL, NULL, 'BNACNNG03760D PROTEIN', 251779),
(415700, 'PTHR33738', NULL, NULL, NULL, NULL, 'EMB|CAB82975.1', 251779),
(415701, 'PTHR33738:SF4', NULL, NULL, NULL, NULL, 'OS01G0848900 PROTEIN', 251779),
(415702, 'PTHR33738:SF8', NULL, NULL, NULL, NULL, 'BNACNNG26020D PROTEIN', 251779),
(415703, 'PTHR33738:SF16', NULL, NULL, NULL, NULL, 'CELL WALL RBR3-LIKE PROTEIN', 251779),
(415704, 'PTHR33738:SF17', NULL, NULL, NULL, NULL, '', 251779),
(415705, 'PTHR33738:SF15', NULL, NULL, NULL, NULL, 'BNAA02G07210D PROTEIN', 251779),
(415706, 'PTHR33738:SF23', NULL, NULL, NULL, NULL, 'PLANT/PROTEIN', 251779),
(415707, 'PTHR33738:SF24', NULL, NULL, NULL, NULL, 'EMB|CAB82975.1', 251779),
(415708, 'PTHR23251', NULL, NULL, NULL, NULL, 'LYSINE-RICH CEACAM1 CO-ISOLATED PROTEIN  LYRIC PROTEIN', 251780),
(415709, 'PTHR23251:SF0', NULL, NULL, NULL, NULL, 'PROTEIN LYRIC', 251780),
(415710, 'PTHR23251:SF1', NULL, NULL, NULL, NULL, 'MEF2-ACTIVATING MOTIF AND SAP DOMAIN-CONTAINING TRANSCRIPTIONAL REGULATOR', 251780),
(415711, 'PTHR46939', NULL, NULL, NULL, NULL, 'ZINC FINGER CCHC DOMAIN-CONTAINING PROTEIN 2', 251781);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(415712, 'PTHR46939:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER CCHC DOMAIN-CONTAINING PROTEIN 2', 251781),
(415713, 'PTHR37463', NULL, NULL, NULL, NULL, 'GSL3115 PROTEIN', 251782),
(415714, 'PTHR37463:SF1', NULL, NULL, NULL, NULL, 'GSL3115 PROTEIN', 251782),
(415715, 'PTHR37463:SF5', NULL, NULL, NULL, NULL, '', 251782),
(415716, 'PTHR15909:SF0', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L35, MITOCHONDRIAL', 251783),
(415717, 'PTHR15909', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L35, MITOCHONDRIAL', 251783),
(415718, 'PTHR33087:SF38', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 251784),
(415719, 'PTHR33087:SF39', NULL, NULL, NULL, NULL, 'OS09G0536166 PROTEIN', 251784),
(415720, 'PTHR33087:SF40', NULL, NULL, NULL, NULL, 'OS10G0159532 PROTEIN', 251784),
(415721, 'PTHR33087:SF41', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 251784),
(415722, 'PTHR33087:SF31', NULL, NULL, NULL, NULL, 'BED-TYPE DOMAIN-CONTAINING PROTEIN', 251784),
(415723, 'PTHR33087:SF42', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 251784),
(415724, 'PTHR33087', NULL, NULL, NULL, NULL, 'OS07G0539200 PROTEIN', 251784),
(415725, 'PTHR33087:SF21', NULL, NULL, NULL, NULL, 'OS09G0322700 PROTEIN', 251784),
(415726, 'PTHR33087:SF43', NULL, NULL, NULL, NULL, 'OS06G0482850 PROTEIN', 251784),
(415727, 'PTHR33087:SF33', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 251784),
(415728, 'PTHR33087:SF44', NULL, NULL, NULL, NULL, '', 251784),
(415729, 'PTHR33087:SF45', NULL, NULL, NULL, NULL, 'OS10G0201901 PROTEIN', 251784),
(415730, 'PTHR12977', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF VARIEGATION 4-20-RELATED', 251785),
(415731, 'PTHR12977:SF4', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SUV4-20', 251785),
(415732, 'PTHR12977:SF13', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE KMT5B', 251785),
(415733, 'PTHR12977:SF12', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE KMT5B', 251785),
(415734, 'PTHR12977:SF14', NULL, NULL, NULL, NULL, '[HISTONE H4]-N-METHYL-L-LYSINE20 N-METHYLTRANSFERASE KMT5B', 251785),
(415735, 'PTHR12977:SF11', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE KMT5C', 251785),
(415736, 'PTHR47875:SF1', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP28, CHLOROPLASTIC', 251786),
(415737, 'PTHR47875', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP28, CHLOROPLASTIC', 251786),
(415738, 'PTHR42844:SF8', NULL, NULL, NULL, NULL, '7,8-DIHYDRONEOPTERIN ALDOLASE', 251787),
(415739, 'PTHR42844:SF7', NULL, NULL, NULL, NULL, 'FOLB DOMAIN-CONTAINING PROTEIN', 251787),
(415740, 'PTHR42844:SF6', NULL, NULL, NULL, NULL, '7,8-DIHYDRONEOPTERIN ALDOLASE', 251787),
(415741, 'PTHR42844:SF1', NULL, NULL, NULL, NULL, 'DIHYDRONEOPTERIN ALDOLASE 1-RELATED', 251787),
(415742, 'PTHR42844', NULL, NULL, NULL, NULL, 'DIHYDRONEOPTERIN ALDOLASE 1-RELATED', 251787),
(415743, 'PTHR42844:SF9', NULL, NULL, NULL, NULL, '7,8-DIHYDRONEOPTERIN ALDOLASE', 251787),
(415744, 'PTHR36750:SF1', NULL, NULL, NULL, NULL, 'SEC-C MOTIF PROTEIN', 251788),
(415745, 'PTHR36750', NULL, NULL, NULL, NULL, 'SEC-C MOTIF PROTEIN', 251788),
(415746, 'PTHR22192:SF17', NULL, NULL, NULL, NULL, 'SPERIOLIN_C DOMAIN-CONTAINING PROTEIN', 251789),
(415747, 'PTHR22192:SF16', NULL, NULL, NULL, NULL, 'SPERIOLIN', 251789),
(415748, 'PTHR22192', NULL, NULL, NULL, NULL, 'SPERIOLIN', 251789),
(415749, 'PTHR22192:SF1', NULL, NULL, NULL, NULL, 'SPERIOLIN-LIKE PROTEIN', 251789),
(415750, 'PTHR12056:SF3', NULL, NULL, NULL, NULL, 'BNAA06G00770D PROTEIN', 251790),
(415751, 'PTHR12056:SF2', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASES I, II, AND III SUBUNIT RPABC4', 251790),
(415752, 'PTHR12056', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASES I, II, AND III', 251790),
(415753, 'PTHR15565:SF1', NULL, NULL, NULL, NULL, '', 251791),
(415754, 'PTHR15565:SF2', NULL, NULL, NULL, NULL, 'BNAA09G05660D PROTEIN', 251791),
(415755, 'PTHR15565:SF0', NULL, NULL, NULL, NULL, 'PROTEIN AATF', 251791),
(415756, 'PTHR15565', NULL, NULL, NULL, NULL, 'AATF PROTEIN  APOPTOSIS ANTAGONIZING TRANSCRIPTION FACTOR', 251791);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(415757, 'PTHR31637:SF11', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE (2,3-DIPHOSPHOGLYCERATE-INDEPENDENT)', 251792),
(415758, 'PTHR31637:SF10', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE (2,3-DIPHOSPHOGLYCERATE-INDEPENDENT)', 251792),
(415759, 'PTHR31637:SF7', NULL, NULL, NULL, NULL, '2,3-BISPHOSPHOGLYCERATE-INDEPENDENT PHOSPHOGLYCERATE MUTASE 1', 251792),
(415760, 'PTHR31637', NULL, NULL, NULL, NULL, '2,3-BISPHOSPHOGLYCERATE-INDEPENDENT PHOSPHOGLYCERATE MUTASE', 251792),
(415761, 'PTHR31637:SF0', NULL, NULL, NULL, NULL, '2,3-BISPHOSPHOGLYCERATE-INDEPENDENT PHOSPHOGLYCERATE MUTASE', 251792),
(415762, 'PTHR31637:SF13', NULL, NULL, NULL, NULL, '2,3-BISPHOSPHOGLYCERATE-INDEPENDENT PHOSPHOGLYCERATE MUTASE 2-RELATED', 251792),
(415763, 'PTHR31637:SF12', NULL, NULL, NULL, NULL, '', 251792),
(415764, 'PTHR13032:SF6', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM21', 251793),
(415765, 'PTHR13032:SF7', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM21', 251793),
(415766, 'PTHR13032', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM21', 251793),
(415767, 'PTHR15021', NULL, NULL, NULL, NULL, 'DISCONNECTED-RELATED', 251794),
(415768, 'PTHR15021:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN BASONUCLIN-2', 251794),
(415769, 'PTHR15021:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN BASONUCLIN-1', 251794),
(415770, 'PTHR15021:SF0', NULL, NULL, NULL, NULL, 'DISCO-RELATED, ISOFORM A-RELATED', 251794),
(415771, 'PTHR42718:SF9', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY MULTIDRUG TRANSPORTER MFSC', 251795),
(415772, 'PTHR42718:SF39', NULL, NULL, NULL, NULL, 'ACTINORHODIN TRANSPORTER-RELATED', 251795),
(415773, 'PTHR42718:SF27', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE-RELATED', 251795),
(415774, 'PTHR42718:SF1', NULL, NULL, NULL, NULL, 'LOW AFFINITY AMMONIUM TRANSPORTER', 251795),
(415775, 'PTHR42718:SF40', NULL, NULL, NULL, NULL, 'METHYLENOMYCIN A RESISTANCE PROTEIN', 251795),
(415776, 'PTHR42718', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY MULTIDRUG TRANSPORTER MFSC', 251795),
(415777, 'PTHR42718:SF14', NULL, NULL, NULL, NULL, 'AMINOTRIAZOLE RESISTANCE PROTEIN', 251795),
(415778, 'PTHR42718:SF36', NULL, NULL, NULL, NULL, 'MULTIDRUG TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G13820)-RELATED', 251795),
(415779, 'PTHR42718:SF24', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 251795),
(415780, 'PTHR42718:SF46', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY (MFS) TRANSPORTER-RELATED', 251795),
(415781, 'PTHR42718:SF35', NULL, NULL, NULL, NULL, 'BLL0718 PROTEIN', 251795),
(415782, 'PTHR42718:SF23', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 251795),
(415783, 'PTHR42718:SF45', NULL, NULL, NULL, NULL, 'DRUG EFFLUX PUMP JEFA', 251795),
(415784, 'PTHR42718:SF11', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 251795),
(415785, 'PTHR42718:SF44', NULL, NULL, NULL, NULL, 'METHYL VIOLOGEN RESISTANCE PROTEIN SMVA', 251795),
(415786, 'PTHR42718:SF10', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G06760)-RELATED', 251795),
(415787, 'PTHR42718:SF43', NULL, NULL, NULL, NULL, 'LINCOMYCIN RESISTANCE PROTEIN LMRB', 251795),
(415788, 'PTHR42718:SF42', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE EFFLUX PROTEIN-RELATED', 251795),
(415789, 'PTHR42718:SF41', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 251795),
(415790, 'PTHR46663:SF4', NULL, NULL, NULL, NULL, 'DIGUANYLATE CYCLASE DGCT-RELATED', 251796),
(415791, 'PTHR46663:SF3', NULL, NULL, NULL, NULL, 'SLL0267 PROTEIN', 251796),
(415792, 'PTHR46663:SF2', NULL, NULL, NULL, NULL, 'GGDEF DOMAIN-CONTAINING PROTEIN', 251796),
(415793, 'PTHR46663', NULL, NULL, NULL, NULL, 'DIGUANYLATE CYCLASE DGCT-RELATED', 251796),
(415794, 'PTHR32074', NULL, NULL, NULL, NULL, 'RNA DEMETHYLASE ALKBH5', 251797),
(415795, 'PTHR32074:SF2', NULL, NULL, NULL, NULL, 'RNA DEMETHYLASE ALKBH5', 251797),
(415796, 'PTHR42199', NULL, NULL, NULL, NULL, 'UPF0212 PROTEIN MJ0068', 251798);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(415797, 'PTHR42199:SF1', NULL, NULL, NULL, NULL, 'UPF0212 PROTEIN TK1194', 251798),
(415798, 'PTHR22677', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 60', 251799),
(415799, 'PTHR22677:SF3', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 60', 251799),
(415800, 'PTHR22677:SF4', NULL, NULL, NULL, NULL, 'TANKYRASE-LIKE PROTEIN', 251799),
(415801, 'PTHR22677:SF5', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 251799),
(415802, 'PTHR33478:SF1', NULL, NULL, NULL, NULL, 'EXTRACELLULAR METALLOPROTEINASE MEP', 251800),
(415803, 'PTHR33478', NULL, NULL, NULL, NULL, 'EXTRACELLULAR METALLOPROTEINASE MEP', 251800),
(415804, 'PTHR24366:SF115', NULL, NULL, NULL, NULL, 'LD10349P', 251801),
(415805, 'PTHR24366:SF159', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT CONTAINING 19', 251801),
(415806, 'PTHR24366:SF158', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT CONTAINING 15', 251801),
(415807, 'PTHR24366:SF35', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEATS AND TRANSMEMBRANE DOMAINS 1', 251801),
(415808, 'PTHR24366:SF157', NULL, NULL, NULL, NULL, 'LRRNT DOMAIN-CONTAINING PROTEIN', 251801),
(415809, 'PTHR24366:SF156', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 66', 251801),
(415810, 'PTHR24366:SF37', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT, IG-LIKE AND TRANSMEMBRANE DOMAINS 1', 251801),
(415811, 'PTHR24366:SF112', NULL, NULL, NULL, NULL, 'VASORIN B', 251801),
(415812, 'PTHR24366:SF75', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEATS AND IMMUNOGLOBULIN LIKE DOMAINS 1', 251801),
(415813, 'PTHR24366:SF151', NULL, NULL, NULL, NULL, 'KEKKON4-RELATED', 251801),
(415814, 'PTHR24366:SF150', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT TRANSMEMBRANE NEURONAL 3', 251801),
(415815, 'PTHR24366:SF73', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT NEURONAL 3A', 251801),
(415816, 'PTHR24366:SF155', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 251801),
(415817, 'PTHR24366:SF154', NULL, NULL, NULL, NULL, 'NYCTALOPIN', 251801),
(415818, 'PTHR24366:SF70', NULL, NULL, NULL, NULL, 'RETICULON 4 RECEPTOR', 251801),
(415819, 'PTHR24366:SF153', NULL, NULL, NULL, NULL, 'ELRR (EXTRACELLULAR LEUCINE-RICH REPEAT) ONLY', 251801),
(415820, 'PTHR24366:SF152', NULL, NULL, NULL, NULL, 'RE50361P-RELATED', 251801),
(415821, 'PTHR24366:SF39', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT, IG-LIKE AND TRANSMEMBRANE DOMAINS 2', 251801),
(415822, 'PTHR24366:SF124', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND FIBRONECTIN TYPE III DOMAIN-CONTAINING PROTEIN 1-LIKE PROTEIN', 251801),
(415823, 'PTHR24366:SF123', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT CONTAINING 17', 251801),
(415824, 'PTHR24366:SF65', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEATS AND IMMUNOGLOBULIN LIKE DOMAINS 3', 251801),
(415825, 'PTHR24366:SF64', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEATS AND IMMUNOGLOBULIN LIKE DOMAINS 2', 251801),
(415826, 'PTHR24366:SF129', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING 24', 251801),
(415827, 'PTHR24366:SF127', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT NEURONAL PROTEIN 1-LIKE', 251801),
(415828, 'PTHR24366:SF61', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT CONTAINING 52', 251801),
(415829, 'PTHR24366:SF60', NULL, NULL, NULL, NULL, 'WNT-ACTIVATED INHIBITORY FACTOR 2', 251801),
(415830, 'PTHR24366:SF120', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT TRANSMEMBRANE NEURONAL 4', 251801),
(415831, 'PTHR24366', NULL, NULL, NULL, NULL, 'IG(IMMUNOGLOBULIN) AND LRR(LEUCINE RICH REPEAT) DOMAINS', 251801),
(415832, 'PTHR24366:SF29', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT AND FIBRONECTIN TYPE III DOMAIN CONTAINING 5', 251801),
(415833, 'PTHR24366:SF14', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN SUPERFAMILY CONTAINING LEUCINE-RICH REPEAT PROTEIN', 251801),
(415834, 'PTHR24366:SF137', NULL, NULL, NULL, NULL, 'SI:DKEY-28O19.1', 251801),
(415835, 'PTHR24366:SF13', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT NEURONAL PROTEIN 4', 251801),
(415836, 'PTHR24366:SF57', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT, IG-LIKE AND TRANSMEMBRANE DOMAINS 3', 251801);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(415837, 'PTHR24366:SF136', NULL, NULL, NULL, NULL, 'KEKKON 1, ISOFORM B', 251801),
(415838, 'PTHR24366:SF15', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN SUPERFAMILY CONTAINING LEUCINE-RICH REPEAT PROTEIN 2', 251801),
(415839, 'PTHR24366:SF134', NULL, NULL, NULL, NULL, 'CHONDROADHERIN LIKE', 251801),
(415840, 'PTHR24366:SF54', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN SUPERFAMILY, MEMBER 10', 251801),
(415841, 'PTHR24366:SF97', NULL, NULL, NULL, NULL, 'LRRCT DOMAIN-CONTAINING PROTEIN', 251801),
(415842, 'PTHR24366:SF53', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT AND FIBRONECTIN TYPE III DOMAIN CONTAINING 1', 251801),
(415843, 'PTHR24366:SF99', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT AND FIBRONECTIN TYPE III DOMAIN CONTAINING 3', 251801),
(415844, 'PTHR24366:SF96', NULL, NULL, NULL, NULL, 'GH22922P-RELATED', 251801),
(415845, 'PTHR24366:SF51', NULL, NULL, NULL, NULL, 'MATRIX-REMODELLING-ASSOCIATED 5A', 251801),
(415846, 'PTHR24366:SF92', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT NEURONAL 2', 251801),
(415847, 'PTHR24366:SF46', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT NEURONAL 1', 251801),
(415848, 'PTHR24366:SF48', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT AND FIBRONECTIN TYPE III DOMAIN CONTAINING 2', 251801),
(415849, 'PTHR24366:SF87', NULL, NULL, NULL, NULL, 'KEKKON 6, ISOFORM B', 251801),
(415850, 'PTHR24366:SF140', NULL, NULL, NULL, NULL, 'IP22191P', 251801),
(415851, 'PTHR24366:SF41', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE-III DOMAIN-CONTAINING PROTEIN', 251801),
(415852, 'PTHR24366:SF84', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT AND FIBRONECTIN TYPE III DOMAIN CONTAINING 4', 251801),
(415853, 'PTHR24366:SF80', NULL, NULL, NULL, NULL, 'LD30178P', 251801),
(415854, 'PTHR24411:SF8', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR ERYTHROID 2-RELATED FACTOR 3', 251802),
(415855, 'PTHR24411:SF31', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM MEMBRANE SENSOR NFE2L1', 251802),
(415856, 'PTHR24411:SF3', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR ERYTHROID 2-RELATED FACTOR 2', 251802),
(415857, 'PTHR24411', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR ERYTHROID 2-RELATED FACTOR', 251802),
(415858, 'PTHR24411:SF26', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR NF-E2 45 KDA SUBUNIT', 251802),
(415859, 'PTHR24411:SF57', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 251802),
(415860, 'PTHR24411:SF55', NULL, NULL, NULL, NULL, 'SEGMENTATION PROTEIN CAP''N''COLLAR', 251802),
(415861, 'PTHR42734:SF9', NULL, NULL, NULL, NULL, 'ZINC IMPORT ATP-BINDING PROTEIN ZNUC', 251803),
(415862, 'PTHR42734:SF16', NULL, NULL, NULL, NULL, 'ABC-TYPE TUNGSTATE UPTAKE SYSTEM ATPASE COMPONET TUPC', 251803),
(415863, 'PTHR42734:SF17', NULL, NULL, NULL, NULL, 'VITAMIN B12 IMPORT ATP-BINDING PROTEIN BTUD', 251803),
(415864, 'PTHR42734:SF5', NULL, NULL, NULL, NULL, 'IRON TRANSPORT SYSTEM ATP-BINDING PROTEIN HI_0361-RELATED', 251803),
(415865, 'PTHR42734:SF6', NULL, NULL, NULL, NULL, 'MOLYBDATE IMPORT ATP-BINDING PROTEIN MOLC', 251803),
(415866, 'PTHR42734:SF7', NULL, NULL, NULL, NULL, 'ATP-BINDING COMPONENT OF ABC TRANSPORTER-RELATED', 251803),
(415867, 'PTHR42734', NULL, NULL, NULL, NULL, 'METAL TRANSPORT SYSTEM ATP-BINDING PROTEIN TM_0124-RELATED', 251803),
(415868, 'PTHR42734:SF4', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY ZINC UPTAKE SYSTEM ATP-BINDING PROTEIN ZNUC', 251803),
(415869, 'PTHR31717:SF60', NULL, NULL, NULL, NULL, 'B-BOX TYPE ZINC FINGER FAMILY PROTEIN', 251804),
(415870, 'PTHR31717:SF101', NULL, NULL, NULL, NULL, 'CCT DOMAIN-CONTAINING PROTEIN', 251804),
(415871, 'PTHR31717:SF140', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CONSTANS-LIKE 10', 251804),
(415872, 'PTHR31717:SF142', NULL, NULL, NULL, NULL, 'B-BOX DOMAIN PROTEIN 30-RELATED', 251804),
(415873, 'PTHR31717:SF141', NULL, NULL, NULL, NULL, 'B-BOX TYPE ZINC FINGER FAMILY PROTEIN-RELATED', 251804),
(415874, 'PTHR31717:SF108', NULL, NULL, NULL, NULL, 'B BOX-TYPE DOMAIN-CONTAINING PROTEIN', 251804),
(415875, 'PTHR31717:SF107', NULL, NULL, NULL, NULL, 'BNAC03G58230D PROTEIN', 251804),
(415876, 'PTHR31717:SF69', NULL, NULL, NULL, NULL, 'BNACNNG51750D PROTEIN', 251804);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(415877, 'PTHR31717:SF103', NULL, NULL, NULL, NULL, 'B-BOX-TYPE ZINC FINGER, CCT DOMAIN PROTEIN-RELATED', 251804),
(415878, 'PTHR31717:SF65', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CONSTANS-LIKE 14-LIKE', 251804),
(415879, 'PTHR31717:SF105', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CONSTANS-LIKE 10-LIKE', 251804),
(415880, 'PTHR31717:SF48', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CONSTANS-LIKE 4-LIKE', 251804),
(415881, 'PTHR31717:SF133', NULL, NULL, NULL, NULL, 'CCT MOTIF FAMILY PROTEIN', 251804),
(415882, 'PTHR31717:SF132', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CONSTANS-LIKE 1-LIKE', 251804),
(415883, 'PTHR31717:SF135', NULL, NULL, NULL, NULL, 'CCT MOTIF FAMILY PROTEIN-RELATED', 251804),
(415884, 'PTHR31717:SF134', NULL, NULL, NULL, NULL, 'OS06G0298200 PROTEIN', 251804),
(415885, 'PTHR31717:SF131', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CONSTANS-LIKE 9', 251804),
(415886, 'PTHR31717:SF130', NULL, NULL, NULL, NULL, 'OS06G0103000 PROTEIN', 251804),
(415887, 'PTHR31717:SF55', NULL, NULL, NULL, NULL, 'BNAANNG16270D PROTEIN', 251804),
(415888, 'PTHR31717:SF56', NULL, NULL, NULL, NULL, 'ACTIVATOR OF SPOMIN::LUC2', 251804),
(415889, 'PTHR31717:SF57', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CONSTANS-LIKE', 251804),
(415890, 'PTHR31717:SF58', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CONSTANS-LIKE 13', 251804),
(415891, 'PTHR31717:SF137', NULL, NULL, NULL, NULL, 'B BOX-TYPE DOMAIN-CONTAINING PROTEIN', 251804),
(415892, 'PTHR31717:SF51', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CONSTANS-LIKE 11-RELATED', 251804),
(415893, 'PTHR31717:SF136', NULL, NULL, NULL, NULL, 'CCT DOMAIN-CONTAINING PROTEIN-RELATED', 251804),
(415894, 'PTHR31717:SF53', NULL, NULL, NULL, NULL, 'BNAA07G24720D PROTEIN', 251804),
(415895, 'PTHR31717:SF139', NULL, NULL, NULL, NULL, 'CCT DOMAIN-CONTAINING PROTEIN', 251804),
(415896, 'PTHR31717:SF138', NULL, NULL, NULL, NULL, 'CONSTANS-LIKE PROTEIN DAYS TO HEADING ON CHROMOSOME 2', 251804),
(415897, 'PTHR31717:SF10', NULL, NULL, NULL, NULL, 'CCT MOTIF FAMILY PROTEIN, EXPRESSED', 251804),
(415898, 'PTHR31717:SF54', NULL, NULL, NULL, NULL, 'B-BOX ZINC FINGER FAMILY PROTEIN', 251804),
(415899, 'PTHR31717:SF98', NULL, NULL, NULL, NULL, 'CCT MOTIF FAMILY PROTEIN', 251804),
(415900, 'PTHR31717:SF80', NULL, NULL, NULL, NULL, 'BNAC01G39760D PROTEIN', 251804),
(415901, 'PTHR31717:SF122', NULL, NULL, NULL, NULL, 'OS07G0667300 PROTEIN', 251804),
(415902, 'PTHR31717:SF81', NULL, NULL, NULL, NULL, 'OS06G0661200 PROTEIN', 251804),
(415903, 'PTHR31717:SF82', NULL, NULL, NULL, NULL, 'CCT DOMAIN-CONTAINING PROTEIN', 251804),
(415904, 'PTHR31717:SF123', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN 2-LIKE ISOFORM X1', 251804),
(415905, 'PTHR31717:SF88', NULL, NULL, NULL, NULL, 'B BOX-TYPE DOMAIN-CONTAINING PROTEIN', 251804),
(415906, 'PTHR31717:SF45', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CONSTANS-LIKE 14-RELATED', 251804),
(415907, 'PTHR31717:SF129', NULL, NULL, NULL, NULL, 'OS02G0176000 PROTEIN', 251804),
(415908, 'PTHR31717:SF46', NULL, NULL, NULL, NULL, 'CCT MOTIF FAMILY PROTEIN-RELATED', 251804),
(415909, 'PTHR31717:SF126', NULL, NULL, NULL, NULL, 'CONSTANS-LIKE 9-RELATED', 251804),
(415910, 'PTHR31717:SF40', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CONSTANS-LIKE 10', 251804),
(415911, 'PTHR31717:SF85', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CONSTANS-LIKE 9-LIKE', 251804),
(415912, 'PTHR31717:SF128', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CONSTANS-LIKE 9-LIKE', 251804),
(415913, 'PTHR31717:SF127', NULL, NULL, NULL, NULL, 'B-BOX ZINC FINGER PROTEIN 23-LIKE', 251804),
(415914, 'PTHR31717', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CONSTANS-LIKE 10', 251804),
(415915, 'PTHR31717:SF110', NULL, NULL, NULL, NULL, 'CCT DOMAIN-CONTAINING PROTEIN-RELATED', 251804),
(415916, 'PTHR31717:SF2', NULL, NULL, NULL, NULL, 'CCT MOTIF FAMILY PROTEIN', 251804),
(415917, 'PTHR31717:SF113', NULL, NULL, NULL, NULL, 'CCT DOMAIN-CONTAINING PROTEIN', 251804),
(415918, 'PTHR31717:SF71', NULL, NULL, NULL, NULL, 'B-BOX-TYPE ZINC FINGER-RELATED', 251804),
(415919, 'PTHR31717:SF112', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CONSTANS-LIKE 12-LIKE', 251804);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(415920, 'PTHR31717:SF9', NULL, NULL, NULL, NULL, 'CCT MOTIF FAMILY PROTEIN', 251804),
(415921, 'PTHR31717:SF79', NULL, NULL, NULL, NULL, 'BNAC03G35440D PROTEIN', 251804),
(415922, 'PTHR31717:SF115', NULL, NULL, NULL, NULL, 'B-BOX ZINC FINGER PROTEIN 32', 251804),
(415923, 'PTHR31717:SF114', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CONSTANS-LIKE 12', 251804),
(415924, 'PTHR31717:SF74', NULL, NULL, NULL, NULL, 'B BOX-TYPE DOMAIN-CONTAINING PROTEIN', 251804),
(415925, 'PTHR31717:SF75', NULL, NULL, NULL, NULL, 'CCT DOMAIN-CONTAINING PROTEIN', 251804),
(415926, 'PTHR31717:SF116', NULL, NULL, NULL, NULL, 'B-BOX TYPE ZINC FINGER PROTEIN', 251804),
(415927, 'PTHR31717:SF76', NULL, NULL, NULL, NULL, 'B-BOX-TYPE ZINC FINGER-RELATED', 251804),
(415928, 'PTHR23082', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIIC  TFIIIC , POLYPEPTIDE 3-RELATED', 251805),
(415929, 'PTHR23082:SF0', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR 3C POLYPEPTIDE 3', 251805),
(415930, 'PTHR47399', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 121B', 251806),
(415931, 'PTHR47399:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 121B', 251806),
(415932, 'PTHR47461:SF1', NULL, NULL, NULL, NULL, 'PHYTOLONGIN PHYL1.2', 251807),
(415933, 'PTHR47461:SF6', NULL, NULL, NULL, NULL, 'LONGIN DOMAIN-CONTAINING PROTEIN', 251807),
(415934, 'PTHR47461', NULL, NULL, NULL, NULL, 'PHYTOLONGIN PHYL1.2', 251807),
(415935, 'PTHR47461:SF5', NULL, NULL, NULL, NULL, 'PHYTOLONGIN PHYL1.1', 251807),
(415936, 'PTHR47461:SF4', NULL, NULL, NULL, NULL, 'PHYTOLONGIN PHYL2.1', 251807),
(415937, 'PTHR47461:SF3', NULL, NULL, NULL, NULL, 'PHYTOLONGIN PHYL2.2', 251807),
(415938, 'PTHR47461:SF8', NULL, NULL, NULL, NULL, 'OS01G0236000 PROTEIN', 251807),
(415939, 'PTHR47461:SF7', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 251807),
(415940, 'PTHR13099:SF0', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 SUBUNIT C2-RELATED', 251808),
(415941, 'PTHR13099', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE SUBUNIT B14.5B', 251808),
(415942, 'PTHR32071:SF81', NULL, NULL, NULL, NULL, 'PROPIONATE CATABOLISM OPERON REGULATORY PROTEIN', 251809),
(415943, 'PTHR32071:SF86', NULL, NULL, NULL, NULL, 'TWO COMPONENT SIGNAL TRANSDUCTION SYSTEM SIGMA54-DEPENDENT RESPONSE REGULATOR FIS FAMILY', 251809),
(415944, 'PTHR32071:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN TYRR', 251809),
(415945, 'PTHR32071:SF21', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN FLGR', 251809),
(415946, 'PTHR32071:SF113', NULL, NULL, NULL, NULL, 'SASR', 251809),
(415947, 'PTHR32071:SF112', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN-RELATED', 251809),
(415948, 'PTHR32071:SF115', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR', 251809),
(415949, 'PTHR32071:SF114', NULL, NULL, NULL, NULL, 'DNA-BINDING TRANSCRIPTIONAL ACTIVATOR HYFR-RELATED', 251809),
(415950, 'PTHR32071:SF117', NULL, NULL, NULL, NULL, 'PTS-DEPENDENT DIHYDROXYACETONE KINASE OPERON REGULATORY PROTEIN-RELATED', 251809),
(415951, 'PTHR32071:SF116', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN GLRR', 251809),
(415952, 'PTHR32071:SF118', NULL, NULL, NULL, NULL, 'SIGMA L-DEPENDENT TRANSCRIPTIONAL REGULATOR YPLP-RELATED', 251809),
(415953, 'PTHR32071:SF29', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE TRANSPORT SYSTEM TRANSCRIPTIONAL REGULATORY PROTEIN PGTA', 251809),
(415954, 'PTHR32071:SF91', NULL, NULL, NULL, NULL, 'TUNGSTATE-RESPONSIVE TWO COMPONENT SIGMA54-DEPENDENT SIGNAL TRANSDUCTION SYSTEM RESPONSE REGULATOR FIS FAMILY', 251809),
(415955, 'PTHR32071:SF95', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN ZRAR', 251809),
(415956, 'PTHR32071', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 251809),
(415957, 'PTHR32071:SF74', NULL, NULL, NULL, NULL, 'ARGININE UTILIZATION REGULATORY PROTEIN ROCR', 251809),
(415958, 'PTHR32071:SF90', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN LEVR', 251809),
(415959, 'PTHR32071:SF100', NULL, NULL, NULL, NULL, 'RESPONSE REGULATOR PROTEIN PILR', 251809);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(415960, 'PTHR32071:SF101', NULL, NULL, NULL, NULL, 'ACETOIN DEHYDROGENASE OPERON TRANSCRIPTIONAL ACTIVATOR ACOR', 251809),
(415961, 'PTHR32071:SF77', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 251809),
(415962, 'PTHR32071:SF99', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 251809),
(415963, 'PTHR32071:SF13', NULL, NULL, NULL, NULL, 'RESPONSE REGULATOR HSFA', 251809),
(415964, 'PTHR32071:SF35', NULL, NULL, NULL, NULL, 'ANAEROBIC NITRIC OXIDE REDUCTASE TRANSCRIPTION REGULATOR NORR', 251809),
(415965, 'PTHR32071:SF57', NULL, NULL, NULL, NULL, 'SIGMA L-DEPENDENT TRANSCRIPTIONAL REGULATOR YQIR-RELATED', 251809),
(415966, 'PTHR32071:SF14', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN RTCR', 251809),
(415967, 'PTHR32071:SF15', NULL, NULL, NULL, NULL, 'DNA-BINDING TRANSCRIPTIONAL REGULATOR NTRC', 251809),
(415968, 'PTHR32071:SF38', NULL, NULL, NULL, NULL, 'PSP OPERON TRANSCRIPTIONAL ACTIVATOR', 251809),
(415969, 'PTHR32071:SF17', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR', 251809),
(415970, 'PTHR12786:SF9', NULL, NULL, NULL, NULL, 'MATRIN-TYPE DOMAIN-CONTAINING PROTEIN', 251810),
(415971, 'PTHR12786:SF7', NULL, NULL, NULL, NULL, 'DUF3449 DOMAIN-CONTAINING PROTEIN', 251810),
(415972, 'PTHR12786:SF2', NULL, NULL, NULL, NULL, 'SPLICING FACTOR 3A SUBUNIT 3', 251810),
(415973, 'PTHR12786:SF1', NULL, NULL, NULL, NULL, 'REPLICATION STRESS RESPONSE REGULATOR SDE2', 251810),
(415974, 'PTHR12786', NULL, NULL, NULL, NULL, 'SPLICING FACTOR SF3A-RELATED', 251810),
(415975, 'PTHR12786:SF4', NULL, NULL, NULL, NULL, '', 251810),
(415976, 'PTHR12786:SF3', NULL, NULL, NULL, NULL, 'SPLICING FACTOR 3A SUBUNIT 3', 251810),
(415977, 'PTHR30465:SF93', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORT SYSTEM PERMEASE PROTEIN OPPB', 251811),
(415978, 'PTHR30465:SF95', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE ABC TRANSPORTER, PERMEASE PROTEIN', 251811),
(415979, 'PTHR30465', NULL, NULL, NULL, NULL, 'INNER MEMBRANE ABC TRANSPORTER', 251811),
(415980, 'PTHR30465:SF94', NULL, NULL, NULL, NULL, 'NICKEL IMPORT SYSTEM PERMEASE PROTEIN NIKB', 251811),
(415981, 'PTHR30465:SF31', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE ABC TRANSPORTER, PERMEASE PROTEIN', 251811),
(415982, 'PTHR30465:SF74', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORT SYSTEM PERMEASE PROTEIN OPPB', 251811),
(415983, 'PTHR30465:SF96', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER-RELATED', 251811),
(415984, 'PTHR30465:SF0', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORT SYSTEM PERMEASE PROTEIN APPB', 251811),
(415985, 'PTHR30465:SF55', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE ABC TRANSPORTER, PERMEASE PROTEIN', 251811),
(415986, 'PTHR30465:SF44', NULL, NULL, NULL, NULL, 'ABC-TYPE DIPEPTIDE/OLIGOPEPTIDE TRANSPORT SYSTEM, PERMEASE COMPONENT', 251811),
(415987, 'PTHR30465:SF66', NULL, NULL, NULL, NULL, 'INNER MEMBRANE ABC TRANSPORTER PERMEASE PROTEIN YEJB', 251811),
(415988, 'PTHR30465:SF43', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE ABC TRANSPORTER, PERMEASE PROTEIN', 251811),
(415989, 'PTHR30465:SF45', NULL, NULL, NULL, NULL, 'BINDING-PROTEIN-DEPENDENT TRANSPORT SYSTEMS INNER MEMBRANE COMPONENT', 251811),
(415990, 'PTHR30465:SF26', NULL, NULL, NULL, NULL, 'ABC-TYPE DIPEPTIDE/OLIGOPEPTIDE TRANSPORT SYSTEM, PERMEASE COMPONENT', 251811),
(415991, 'PTHR15261:SF6', NULL, NULL, NULL, NULL, 'THROMBOSPONDIN-TYPE LAMININ G DOMAIN AND EAR REPEATS A', 251812),
(415992, 'PTHR15261:SF5', NULL, NULL, NULL, NULL, 'THROMBOSPONDIN-TYPE LAMININ G DOMAIN AND EAR REPEATS B', 251812),
(415993, 'PTHR15261:SF4', NULL, NULL, NULL, NULL, 'THROMBOSPONDIN-TYPE LAMININ G DOMAIN AND EAR REPEAT-CONTAINING PROTEIN', 251812),
(415994, 'PTHR15261', NULL, NULL, NULL, NULL, 'THROMBOSPONDIN-TYPE LAMININ G DOMAIN AND EAR REPEAT-CONTAINING', 251812),
(415995, 'PTHR38085', NULL, NULL, NULL, NULL, '', 251813),
(415996, 'PTHR38085:SF1', NULL, NULL, NULL, NULL, '', 251813),
(415997, 'PTHR10555:SF129', NULL, NULL, NULL, NULL, 'SORTING NEXIN-1', 251814),
(415998, 'PTHR10555:SF171', NULL, NULL, NULL, NULL, 'SORTING NEXIN 1B', 251814),
(415999, 'PTHR10555', NULL, NULL, NULL, NULL, 'SORTING NEXIN', 251814);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(416000, 'PTHR10555:SF170', NULL, NULL, NULL, NULL, 'FI18122P1', 251814),
(416001, 'PTHR10555:SF31', NULL, NULL, NULL, NULL, 'SORTING NEXIN-2', 251814),
(416002, 'PTHR36847', NULL, NULL, NULL, NULL, '', 251815),
(416003, 'PTHR36847:SF1', NULL, NULL, NULL, NULL, '', 251815),
(416004, 'PTHR47352:SF2', NULL, NULL, NULL, NULL, 'TRANSLATION RELEASE FACTOR', 251816),
(416005, 'PTHR47352', NULL, NULL, NULL, NULL, 'CLASS I PEPTIDE CHAIN RELEASE FACTOR', 251816),
(416006, 'PTHR47352:SF1', NULL, NULL, NULL, NULL, 'CLASS I PEPTIDE CHAIN RELEASE FACTOR', 251816),
(416007, 'PTHR23115:SF289', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-ALPHA 1-RELATED', 251817),
(416008, 'PTHR23115:SF125', NULL, NULL, NULL, NULL, 'EUKARYOTIC PEPTIDE CHAIN RELEASE FACTOR GTP-BINDING SUBUNIT ERF3A', 251817),
(416009, 'PTHR23115:SF224', NULL, NULL, NULL, NULL, 'TRANSLATION ELONGATION FACTOR ALPHA', 251817),
(416010, 'PTHR23115:SF285', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-ALPHA', 251817),
(416011, 'PTHR23115:SF286', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-ALPHA', 251817),
(416012, 'PTHR23115:SF242', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-ALPHA', 251817),
(416013, 'PTHR23115:SF264', NULL, NULL, NULL, NULL, 'TR-TYPE G DOMAIN-CONTAINING PROTEIN', 251817),
(416014, 'PTHR23115:SF188', NULL, NULL, NULL, NULL, 'HBS1-LIKE PROTEIN', 251817),
(416015, 'PTHR23115:SF287', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-ALPHA 1', 251817),
(416016, 'PTHR23115:SF243', NULL, NULL, NULL, NULL, 'TR-TYPE G DOMAIN-CONTAINING PROTEIN', 251817),
(416017, 'PTHR23115:SF244', NULL, NULL, NULL, NULL, 'OS04G0677800 PROTEIN', 251817),
(416018, 'PTHR23115:SF288', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1 ALPHA-LIKE PROTEIN', 251817),
(416019, 'PTHR23115:SF222', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-ALPHA 1-RELATED', 251817),
(416020, 'PTHR23115:SF280', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-ALPHA', 251817),
(416021, 'PTHR23115:SF249', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-ALPHA', 251817),
(416022, 'PTHR23115:SF228', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-ALPHA 2', 251817),
(416023, 'PTHR23115:SF257', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-ALPHA', 251817),
(416024, 'PTHR23115:SF279', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-ALPHA-LIKE PROTEIN', 251817),
(416025, 'PTHR23115:SF236', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-ALPHA 1', 251817),
(416026, 'PTHR23115:SF296', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-ALPHA', 251817),
(416027, 'PTHR23115:SF274', NULL, NULL, NULL, NULL, 'TR-TYPE G DOMAIN-CONTAINING PROTEIN', 251817),
(416028, 'PTHR23115:SF297', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-ALPHA', 251817),
(416029, 'PTHR23115:SF298', NULL, NULL, NULL, NULL, 'HBS1-LIKE PROTEIN ISOFORM X1', 251817),
(416030, 'PTHR23115:SF254', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-ALPHA', 251817),
(416031, 'PTHR23115:SF292', NULL, NULL, NULL, NULL, 'TRANSLATION ELONGATION/INITIATION FACTOR FAMILY PROTEIN-RELATED', 251817),
(416032, 'PTHR23115:SF271', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-ALPHA', 251817),
(416033, 'PTHR23115:SF293', NULL, NULL, NULL, NULL, 'EUKARYOTIC PEPTIDE CHAIN RELEASE FACTOR GTP-BINDING SUBUNIT', 251817),
(416034, 'PTHR23115:SF294', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-ALPHA', 251817),
(416035, 'PTHR23115:SF295', NULL, NULL, NULL, NULL, 'FACTOR 1-ALPHA, PUTATIVE-RELATED', 251817),
(416036, 'PTHR23115:SF273', NULL, NULL, NULL, NULL, 'BNAA06G12300D PROTEIN', 251817),
(416037, 'PTHR23115', NULL, NULL, NULL, NULL, 'TRANSLATION FACTOR', 251817),
(416038, 'PTHR23115:SF290', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-ALPHA', 251817),
(416039, 'PTHR23115:SF191', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-ALPHA', 251817),
(416040, 'PTHR23115:SF291', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-ALPHA', 251817),
(416041, 'PTHR23115:SF170', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-ALPHA 2', 251817),
(416042, 'PTHR23115:SF36', NULL, NULL, NULL, NULL, 'TR-TYPE G DOMAIN-CONTAINING PROTEIN', 251817),
(416043, 'PTHR23115:SF119', NULL, NULL, NULL, NULL, 'EUKARYOTIC PEPTIDE CHAIN RELEASE FACTOR GTP-BINDING SUBUNIT ERF3B', 251817); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(416044, 'PTHR34595:SF7', NULL, NULL, NULL, NULL, 'BLR5612 PROTEIN', 251818),
(416045, 'PTHR34595', NULL, NULL, NULL, NULL, 'BLR5612 PROTEIN', 251818),
(416046, 'PTHR34595:SF2', NULL, NULL, NULL, NULL, 'SLL1039 PROTEIN', 251818),
(416047, 'PTHR31006', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 251819),
(416048, 'PTHR31006:SF0', NULL, NULL, NULL, NULL, 'FBA_2 DOMAIN-CONTAINING PROTEIN', 251819),
(416049, 'PTHR31006:SF15', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251819),
(416050, 'PTHR31006:SF17', NULL, NULL, NULL, NULL, 'PROTEIN CBG22139', 251819),
(416051, 'PTHR31006:SF3', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251819),
(416052, 'PTHR31006:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG06600', 251819),
(416053, 'PTHR31006:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG09232', 251819),
(416054, 'PTHR31006:SF18', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251819),
(416055, 'PTHR31006:SF8', NULL, NULL, NULL, NULL, 'F-BOX C PROTEIN', 251819),
(416056, 'PTHR31006:SF9', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 251819),
(416057, 'PTHR39176', NULL, NULL, NULL, NULL, 'PERIPLASMIC PROTEIN-RELATED', 251820),
(416058, 'PTHR39176:SF1', NULL, NULL, NULL, NULL, 'PERIPLASMIC PROTEIN-RELATED', 251820),
(416059, 'PTHR40082', NULL, NULL, NULL, NULL, 'BLR5956 PROTEIN', 251821),
(416060, 'PTHR40082:SF1', NULL, NULL, NULL, NULL, 'BLR5956 PROTEIN', 251821),
(416061, 'PTHR11019', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR NIMR', 251822),
(416062, 'PTHR11019:SF199', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR NIMR', 251822),
(416063, 'PTHR11019:SF159', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', 251822),
(416064, 'PTHR11019:SF190', NULL, NULL, NULL, NULL, 'ARAC-FAMILY REGULATORY PROTEIN-RELATED', 251822),
(416065, 'PTHR45521:SF4', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 251823),
(416066, 'PTHR45521', NULL, NULL, NULL, NULL, 'TSET COMPLEX MEMBER TSTF', 251823),
(416067, 'PTHR45521:SF2', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN', 251823),
(416068, 'PTHR14165:SF7', NULL, NULL, NULL, NULL, '', 251824),
(416069, 'PTHR14165', NULL, NULL, NULL, NULL, 'MAJOR VAULT PROTEIN', 251824),
(416070, 'PTHR14165:SF12', NULL, NULL, NULL, NULL, 'VAULT PROTEIN, PUTATIVE-RELATED', 251824),
(416071, 'PTHR14165:SF11', NULL, NULL, NULL, NULL, 'MAJOR VAULT PROTEIN BETA', 251824),
(416072, 'PTHR14165:SF3', NULL, NULL, NULL, NULL, 'MAJOR VAULT PROTEIN', 251824),
(416073, 'PTHR14165:SF13', NULL, NULL, NULL, NULL, 'VAULT PROTEIN, PUTATIVE-RELATED', 251824),
(416074, 'PTHR14165:SF16', NULL, NULL, NULL, NULL, 'MAJOR VAULT PROTEIN', 251824),
(416075, 'PTHR47200', NULL, NULL, NULL, NULL, 'THYLAKOID LUMENAL 15 KDA PROTEIN 1, CHLOROPLASTIC', 251825),
(416076, 'PTHR47200:SF2', NULL, NULL, NULL, NULL, 'THYLAKOID LUMENAL 15 KDA PROTEIN 1, CHLOROPLASTIC', 251825),
(416077, 'PTHR39948:SF1', NULL, NULL, NULL, NULL, 'GEO11419P1', 251826),
(416078, 'PTHR39948', NULL, NULL, NULL, NULL, 'GEO11419P1', 251826),
(416079, 'PTHR46931:SF12', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN', 251827),
(416080, 'PTHR46931:SF6', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN RIC4', 251827),
(416081, 'PTHR46931:SF18', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN-RELATED', 251827),
(416082, 'PTHR46931:SF17', NULL, NULL, NULL, NULL, 'OS03G0847900 PROTEIN', 251827),
(416083, 'PTHR46931:SF14', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN RIC2', 251827),
(416084, 'PTHR46931:SF5', NULL, NULL, NULL, NULL, 'OS11G0472600 PROTEIN', 251827),
(416085, 'PTHR46931:SF13', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN RIC4-LIKE', 251827),
(416086, 'PTHR46931', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN RIC2', 251827),
(416087, 'PTHR46931:SF16', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN-RELATED', 251827),
(416088, 'PTHR46931:SF15', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN RIC4-LIKE', 251827),
(416089, 'PTHR47164', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS W-RELATED', 251828);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(416090, 'PTHR47164:SF2', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251828),
(416091, 'PTHR47164:SF1', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN-RELATED', 251828),
(416092, 'PTHR41814:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251829),
(416093, 'PTHR41814', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251829),
(416094, 'PTHR22974:SF25', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251830),
(416095, 'PTHR22974', NULL, NULL, NULL, NULL, 'MIXED LINEAGE PROTEIN KINASE', 251830),
(416096, 'PTHR22974:SF28', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251830),
(416097, 'PTHR22974:SF29', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251830),
(416098, 'PTHR22974:SF20', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE TOUSLED-LIKE 2', 251830),
(416099, 'PTHR22974:SF31', NULL, NULL, NULL, NULL, '', 251830),
(416100, 'PTHR22974:SF32', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE TOUSLED-LIKE 1-B', 251830),
(416101, 'PTHR22974:SF21', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN KINASE TTK', 251830),
(416102, 'PTHR22974:SF33', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE TTK FAMILY-RELATED', 251830),
(416103, 'PTHR22974:SF22', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE TOUSLED-LIKE 1', 251830),
(416104, 'PTHR22974:SF23', NULL, NULL, NULL, NULL, 'TOUSLED-LIKE KINASE, ISOFORM G', 251830),
(416105, 'PTHR16275', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 40', 251831),
(416106, 'PTHR16275:SF8', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 40', 251831),
(416107, 'PTHR28610:SF1', NULL, NULL, NULL, NULL, 'DRAXIN', 251832),
(416108, 'PTHR28610', NULL, NULL, NULL, NULL, 'DRAXIN', 251832),
(416109, 'PTHR48234:SF1', NULL, NULL, NULL, NULL, 'GH09231P-RELATED', 251833),
(416110, 'PTHR48234', NULL, NULL, NULL, NULL, 'GH09231P', 251833),
(416111, 'PTHR34031', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 162 KDA', 251834),
(416112, 'PTHR34031:SF1', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 162 KDA', 251834),
(416113, 'PTHR34500', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251835),
(416114, 'PTHR34500:SF1', NULL, NULL, NULL, NULL, 'DDE TNP4 DOMAIN-CONTAINING PROTEIN', 251835),
(416115, 'PTHR45641:SF18', NULL, NULL, NULL, NULL, '', 251836),
(416116, 'PTHR45641:SF13', NULL, NULL, NULL, NULL, 'TPR DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_3G01710)', 251836),
(416117, 'PTHR45641:SF10', NULL, NULL, NULL, NULL, 'NEPHROCYSTIN-3', 251836),
(416118, 'PTHR45641:SF1', NULL, NULL, NULL, NULL, 'LIPA AND NB-ARC DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_3G14650)', 251836),
(416119, 'PTHR45641:SF17', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 251836),
(416120, 'PTHR45641', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN (AFU_ORTHOLOGUE AFUA_6G03870)', 251836),
(416121, 'PTHR45641:SF16', NULL, NULL, NULL, NULL, '', 251836),
(416122, 'PTHR45641:SF14', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN (AFU_ORTHOLOGUE AFUA_6G03870)', 251836),
(416123, 'PTHR16356:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AND COILED-COIL DOMAIN-CONTAINING PROTEIN 6', 251837),
(416124, 'PTHR16356', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AND COILED-COIL DOMAIN-CONTAINING PROTEIN 6 TMCO6', 251837),
(416125, 'PTHR33701:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR ATRX', 251838),
(416126, 'PTHR33701', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 251838),
(416127, 'PTHR33701:SF7', NULL, NULL, NULL, NULL, 'OS05G0446500 PROTEIN', 251838),
(416128, 'PTHR33701:SF11', NULL, NULL, NULL, NULL, '', 251838),
(416129, 'PTHR33701:SF10', NULL, NULL, NULL, NULL, 'CLASPIN-LIKE', 251838),
(416130, 'PTHR33701:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 251838),
(416131, 'PTHR45778', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE-RELATED', 251839),
(416132, 'PTHR45778:SF29', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 251839),
(416133, 'PTHR45778:SF41', NULL, NULL, NULL, NULL, 'METALLOPHOS DOMAIN-CONTAINING PROTEIN', 251839);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(416134, 'PTHR45778:SF40', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 251839),
(416135, 'PTHR45778:SF43', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 251839),
(416136, 'PTHR45778:SF42', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 251839),
(416137, 'PTHR45778:SF23', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 251839),
(416138, 'PTHR45778:SF44', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 251839),
(416139, 'PTHR45778:SF22', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 251839),
(416140, 'PTHR45778:SF24', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 251839),
(416141, 'PTHR45778:SF7', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 251839),
(416142, 'PTHR45778:SF6', NULL, NULL, NULL, NULL, 'INACTIVE PURPLE ACID PHOSPHATASE 24-RELATED', 251839),
(416143, 'PTHR45778:SF5', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 251839),
(416144, 'PTHR45778:SF9', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 251839),
(416145, 'PTHR45778:SF8', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 251839),
(416146, 'PTHR45778:SF38', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 251839),
(416147, 'PTHR45778:SF16', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 251839),
(416148, 'PTHR45778:SF37', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 251839),
(416149, 'PTHR45778:SF39', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 251839),
(416150, 'PTHR45778:SF3', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 251839),
(416151, 'PTHR45778:SF32', NULL, NULL, NULL, NULL, 'INACTIVE PURPLE ACID PHOSPHATASE 1-RELATED', 251839),
(416152, 'PTHR45778:SF10', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 251839),
(416153, 'PTHR45778:SF12', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 251839),
(416154, 'PTHR45778:SF34', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 251839),
(416155, 'PTHR45778:SF11', NULL, NULL, NULL, NULL, 'INACTIVE PURPLE ACID PHOSPHATASE 9-RELATED', 251839),
(416156, 'PTHR45778:SF33', NULL, NULL, NULL, NULL, '', 251839),
(416157, 'PTHR45778:SF36', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 251839),
(416158, 'PTHR45778:SF35', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', 251839),
(416159, 'PTHR31236:SF3', NULL, NULL, NULL, NULL, 'BURP DOMAIN-CONTAINING PROTEIN 15', 251840),
(416160, 'PTHR31236:SF2', NULL, NULL, NULL, NULL, 'BURP DOMAIN PROTEIN RD22', 251840),
(416161, 'PTHR31236:SF46', NULL, NULL, NULL, NULL, 'BURP DOMAIN-CONTAINING PROTEIN-RELATED', 251840),
(416162, 'PTHR31236:SF7', NULL, NULL, NULL, NULL, 'BURP DOMAIN-CONTAINING PROTEIN 10', 251840),
(416163, 'PTHR31236:SF68', NULL, NULL, NULL, NULL, 'BURP DOMAIN-CONTAINING PROTEIN', 251840),
(416164, 'PTHR31236:SF24', NULL, NULL, NULL, NULL, 'BURP DOMAIN PROTEIN RD22', 251840),
(416165, 'PTHR31236:SF47', NULL, NULL, NULL, NULL, 'BURP DOMAIN-CONTAINING PROTEIN', 251840),
(416166, 'PTHR31236:SF66', NULL, NULL, NULL, NULL, 'BURP DOMAIN-CONTAINING PROTEIN', 251840),
(416167, 'PTHR31236:SF67', NULL, NULL, NULL, NULL, 'BURP DOMAIN-CONTAINING PROTEIN-RELATED', 251840),
(416168, 'PTHR31236:SF45', NULL, NULL, NULL, NULL, 'BURP DOMAIN-CONTAINING PROTEIN', 251840),
(416169, 'PTHR31236:SF64', NULL, NULL, NULL, NULL, 'BURP DOMAIN PROTEIN RD22-LIKE', 251840),
(416170, 'PTHR31236:SF42', NULL, NULL, NULL, NULL, 'BURP DOMAIN-CONTAINING PROTEIN', 251840),
(416171, 'PTHR31236:SF21', NULL, NULL, NULL, NULL, 'BURP DOMAIN-CONTAINING PROTEIN 11', 251840),
(416172, 'PTHR31236:SF62', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE PROTEIN RD22', 251840),
(416173, 'PTHR31236:SF41', NULL, NULL, NULL, NULL, 'BURP DOMAIN PROTEIN USPL1', 251840),
(416174, 'PTHR31236:SF63', NULL, NULL, NULL, NULL, 'BURP DOMAIN-CONTAINING PROTEIN BNM2A', 251840),
(416175, 'PTHR31236:SF28', NULL, NULL, NULL, NULL, 'BURP DOMAIN-CONTAINING PROTEIN', 251840),
(416176, 'PTHR31236:SF26', NULL, NULL, NULL, NULL, 'BURP DOMAIN PROTEIN RD22-LIKE', 251840),
(416177, 'PTHR31236:SF27', NULL, NULL, NULL, NULL, 'BURP DOMAIN-CONTAINING PROTEIN 4', 251840),
(416178, 'PTHR31236:SF49', NULL, NULL, NULL, NULL, 'BURP DOMAIN-CONTAINING PROTEIN', 251840);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(416179, 'PTHR31236:SF60', NULL, NULL, NULL, NULL, 'BURP DOMAIN-CONTAINING PROTEIN', 251840),
(416180, 'PTHR31236:SF35', NULL, NULL, NULL, NULL, 'ABUNDANT PROTEIN, PUTATIVE-RELATED', 251840),
(416181, 'PTHR31236', NULL, NULL, NULL, NULL, 'BURP DOMAIN PROTEIN USPL1-LIKE', 251840),
(416182, 'PTHR31236:SF36', NULL, NULL, NULL, NULL, 'BURP DOMAIN-CONTAINING PROTEIN', 251840),
(416183, 'PTHR31236:SF58', NULL, NULL, NULL, NULL, 'BURP DOMAIN-CONTAINING PROTEIN 13-LIKE', 251840),
(416184, 'PTHR31236:SF55', NULL, NULL, NULL, NULL, 'BURP DOMAIN-CONTAINING PROTEIN 5-LIKE', 251840),
(416185, 'PTHR31236:SF56', NULL, NULL, NULL, NULL, 'BURP DOMAIN-CONTAINING PROTEIN', 251840),
(416186, 'PTHR31236:SF31', NULL, NULL, NULL, NULL, 'BURP DOMAIN-CONTAINING PROTEIN 7', 251840),
(416187, 'PTHR31236:SF32', NULL, NULL, NULL, NULL, 'BURP DOMAIN-CONTAINING PROTEIN', 251840),
(416188, 'PTHR31236:SF54', NULL, NULL, NULL, NULL, 'BURP DOMAIN-CONTAINING PROTEIN 5-LIKE', 251840),
(416189, 'PTHR31236:SF10', NULL, NULL, NULL, NULL, 'BURP DOMAIN-CONTAINING PROTEIN 13', 251840),
(416190, 'PTHR31236:SF51', NULL, NULL, NULL, NULL, 'BURP DOMAIN-CONTAINING PROTEIN', 251840),
(416191, 'PTHR31236:SF39', NULL, NULL, NULL, NULL, 'EMBRYONIC ABUNDANT-LIKE PROTEIN', 251840),
(416192, 'PTHR31236:SF37', NULL, NULL, NULL, NULL, 'BURP DOMAIN-CONTAINING PROTEIN 5-LIKE', 251840),
(416193, 'PTHR31236:SF59', NULL, NULL, NULL, NULL, 'BURP DOMAIN PROTEIN', 251840),
(416194, 'PTHR31236:SF38', NULL, NULL, NULL, NULL, 'BURP DOMAIN-CONTAINING PROTEIN', 251840),
(416195, 'PTHR28653:SF1', NULL, NULL, NULL, NULL, 'ATPASE SWSAP1', 251841),
(416196, 'PTHR28653', NULL, NULL, NULL, NULL, '', 251841),
(416197, 'PTHR33755:SF5', NULL, NULL, NULL, NULL, 'TOXIN-ANTITOXIN SYSTEM TOXIN RELE FAMILY', 251842),
(416198, 'PTHR33755:SF6', NULL, NULL, NULL, NULL, 'TOXIN PARE1', 251842),
(416199, 'PTHR33755', NULL, NULL, NULL, NULL, 'TOXIN PARE1-RELATED', 251842),
(416200, 'PTHR33755:SF7', NULL, NULL, NULL, NULL, 'TOXIN MODULE OF TOXIN-ANTITOXIN SYSTEM RELE/STBE FAMILY', 251842),
(416201, 'PTHR33755:SF8', NULL, NULL, NULL, NULL, 'TOXIN PARE2', 251842),
(416202, 'PTHR33755:SF3', NULL, NULL, NULL, NULL, 'TOXIN', 251842),
(416203, 'PTHR43095:SF6', NULL, NULL, NULL, NULL, 'XYLULOSE KINASE', 251843),
(416204, 'PTHR43095', NULL, NULL, NULL, NULL, 'SUGAR KINASE', 251843),
(416205, 'PTHR43095:SF3', NULL, NULL, NULL, NULL, 'L-XYLULOSE/3-KETO-L-GULONATE KINASE', 251843),
(416206, 'PTHR43095:SF2', NULL, NULL, NULL, NULL, 'GLUCONOKINASE', 251843),
(416207, 'PTHR43095:SF5', NULL, NULL, NULL, NULL, 'XYLULOSE KINASE', 251843),
(416208, 'PTHR43095:SF1', NULL, NULL, NULL, NULL, 'AUTOINDUCER-2 KINASE', 251843),
(416209, 'PTHR12604', NULL, NULL, NULL, NULL, 'KU AUTOANTIGEN DNA HELICASE', 251844),
(416210, 'PTHR12604:SF4', NULL, NULL, NULL, NULL, 'X-RAY REPAIR CROSS-COMPLEMENTING PROTEIN 5', 251844),
(416211, 'PTHR12604:SF5', NULL, NULL, NULL, NULL, 'X-RAY REPAIR CROSS-COMPLEMENTING PROTEIN 6', 251844),
(416212, 'PTHR12604:SF2', NULL, NULL, NULL, NULL, 'X-RAY REPAIR CROSS-COMPLEMENTING PROTEIN 6', 251844),
(416213, 'PTHR12604:SF8', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE 2 SUBUNIT 1', 251844),
(416214, 'PTHR12604:SF7', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE 2 SUBUNIT 1', 251844),
(416215, 'PTHR38776:SF1', NULL, NULL, NULL, NULL, 'MLTA-INTERACTING PROTEIN-RELATED', 251845),
(416216, 'PTHR38776', NULL, NULL, NULL, NULL, 'MLTA-INTERACTING PROTEIN-RELATED', 251845),
(416217, 'PTHR34875:SF6', NULL, NULL, NULL, NULL, 'UPF0237 PROTEIN MJ1558', 251846),
(416218, 'PTHR34875', NULL, NULL, NULL, NULL, 'UPF0237 PROTEIN MJ1558', 251846),
(416219, 'PTHR34875:SF5', NULL, NULL, NULL, NULL, 'GLYCINE CLEAVAGE SYSTEM TRANSCRIPTIONAL REPRESSOR', 251846),
(416220, 'PTHR40446:SF2', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINE-1-PHOSPHODIESTER ALPHA-N-ACETYLGLUCOSAMINIDASE', 251847),
(416221, 'PTHR40446', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINE-1-PHOSPHODIESTER ALPHA-N-ACETYLGLUCOSAMINIDASE', 251847),
(416222, 'PTHR46071:SF1', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND BTB/POZ DOMAIN-CONTAINING PROTEIN BTBD11', 251848);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(416223, 'PTHR46071:SF2', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND BTB/POZ DOMAIN-CONTAINING PROTEIN 2-LIKE PROTEIN', 251848),
(416224, 'PTHR46071', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND BTB/POZ DOMAIN-CONTAINING', 251848),
(416225, 'PTHR46071:SF3', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND BTB/POZ DOMAIN-CONTAINING PROTEIN 2', 251848),
(416226, 'PTHR46071:SF4', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND BTB/POZ DOMAIN-CONTAINING PROTEIN BTBD11-A', 251848),
(416227, 'PTHR10683:SF40', NULL, NULL, NULL, NULL, 'FRUCTOSE-6-PHOSPHATE ALDOLASE 1-RELATED', 251849),
(416228, 'PTHR10683:SF41', NULL, NULL, NULL, NULL, 'TRANSALDOLASE', 251849),
(416229, 'PTHR10683:SF31', NULL, NULL, NULL, NULL, 'TRANSALDOLASE', 251849),
(416230, 'PTHR10683:SF18', NULL, NULL, NULL, NULL, 'TRANSALDOLASE', 251849),
(416231, 'PTHR10683:SF36', NULL, NULL, NULL, NULL, 'TRANSALDOLASE', 251849),
(416232, 'PTHR10683', NULL, NULL, NULL, NULL, 'TRANSALDOLASE', 251849),
(416233, 'PTHR10683:SF16', NULL, NULL, NULL, NULL, 'TRANSALDOLASE A', 251849),
(416234, 'PTHR10683:SF39', NULL, NULL, NULL, NULL, 'CHROMOSOME 23, WHOLE GENOME SHOTGUN SEQUENCE', 251849),
(416235, 'PTHR10683:SF28', NULL, NULL, NULL, NULL, 'TRANSALDOLASE C', 251849),
(416236, 'PTHR10683:SF33', NULL, NULL, NULL, NULL, 'TRANSALDOLASE', 251849),
(416237, 'PTHR10683:SF34', NULL, NULL, NULL, NULL, 'TRANSALDOLASE', 251849),
(416238, 'PTHR46453:SF4', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN 24', 251850),
(416239, 'PTHR46453:SF3', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C-BINDING PROTEIN 1', 251850),
(416240, 'PTHR46453:SF5', NULL, NULL, NULL, NULL, 'ZINC FINGER, MYND-TYPE-CONTAINING 8', 251850),
(416241, 'PTHR46453', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C-BINDING PROTEIN 1', 251850),
(416242, 'PTHR46453:SF1', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C-BINDING PROTEIN 1,-LIKE', 251850),
(416243, 'PTHR35174', NULL, NULL, NULL, NULL, 'BLL7171 PROTEIN-RELATED', 251851),
(416244, 'PTHR35174:SF1', NULL, NULL, NULL, NULL, 'BLL0086 PROTEIN', 251851),
(416245, 'PTHR35174:SF4', NULL, NULL, NULL, NULL, 'BLL7163 PROTEIN', 251851),
(416246, 'PTHR35174:SF3', NULL, NULL, NULL, NULL, 'BLL7171 PROTEIN', 251851),
(416247, 'PTHR20338:SF6', NULL, NULL, NULL, NULL, 'OVARIES ABSENT, ISOFORM A', 251852),
(416248, 'PTHR20338', NULL, NULL, NULL, NULL, 'NUCLEAR RESPIRATORY FACTOR 1', 251852),
(416249, 'PTHR20338:SF7', NULL, NULL, NULL, NULL, 'MISEXPRESSION SUPPRESSOR OF RAS 3, ISOFORM B', 251852),
(416250, 'PTHR20338:SF8', NULL, NULL, NULL, NULL, 'NUCLEAR RESPIRATORY FACTOR 1', 251852),
(416251, 'PTHR47907', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251853),
(416252, 'PTHR47907:SF2', NULL, NULL, NULL, NULL, 'AP2 ASSOCIATED KINASE 1', 251853),
(416253, 'PTHR47907:SF3', NULL, NULL, NULL, NULL, 'AP2-ASSOCIATED PROTEIN KINASE 1', 251853),
(416254, 'PTHR24248:SF118', NULL, NULL, NULL, NULL, 'DOPAMINE RECEPTOR D2-LIKE', 251854),
(416255, 'PTHR24248:SF24', NULL, NULL, NULL, NULL, 'ALPHA-2A ADRENERGIC RECEPTOR', 251854),
(416256, 'PTHR24248:SF117', NULL, NULL, NULL, NULL, 'MUSCARINIC ACETYLCHOLINE RECEPTOR', 251854),
(416257, 'PTHR24248:SF25', NULL, NULL, NULL, NULL, 'ALPHA-2C ADRENERGIC RECEPTOR', 251854),
(416258, 'PTHR24248:SF66', NULL, NULL, NULL, NULL, 'OCTOPAMINE RECEPTOR BETA-3R', 251854),
(416259, 'PTHR24248:SF21', NULL, NULL, NULL, NULL, 'BETA-2 ADRENERGIC RECEPTOR', 251854),
(416260, 'PTHR24248:SF190', NULL, NULL, NULL, NULL, 'GH12381P', 251854),
(416261, 'PTHR24248:SF151', NULL, NULL, NULL, NULL, 'TYRAMINE RECEPTOR TYRA-2', 251854),
(416262, 'PTHR24248:SF154', NULL, NULL, NULL, NULL, 'D(3) DOPAMINE RECEPTOR', 251854),
(416263, 'PTHR24248:SF153', NULL, NULL, NULL, NULL, 'MUSCARINIC ACETYLCHOLINE RECEPTOR-RELATED', 251854),
(416264, 'PTHR24248:SF155', NULL, NULL, NULL, NULL, 'MUSCARINIC ACETYLCHOLINE RECEPTOR M1', 251854),
(416265, 'PTHR24248:SF129', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251854),
(416266, 'PTHR24248:SF14', NULL, NULL, NULL, NULL, 'ALPHA-1D ADRENERGIC RECEPTOR', 251854),
(416267, 'PTHR24248:SF17', NULL, NULL, NULL, NULL, 'ALPHA-1B ADRENERGIC RECEPTOR', 251854);
INSERT INTO "PUBLIC"."MODEL" VALUES
(416268, 'PTHR24248:SF16', NULL, NULL, NULL, NULL, 'ALPHA-1A ADRENERGIC RECEPTOR', 251854),
(416269, 'PTHR24248', NULL, NULL, NULL, NULL, 'ADRENERGIC RECEPTOR-RELATED G-PROTEIN COUPLED RECEPTOR', 251854),
(416270, 'PTHR24248:SF54', NULL, NULL, NULL, NULL, 'BETA-1 ADRENERGIC RECEPTOR', 251854),
(416271, 'PTHR24248:SF163', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE RECEPTOR 4', 251854),
(416272, 'PTHR24248:SF120', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251854),
(416273, 'PTHR24248:SF0', NULL, NULL, NULL, NULL, 'ADRENOCEPTOR ALPHA 2B-LIKE 2', 251854),
(416274, 'PTHR24248:SF123', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251854),
(416275, 'PTHR24248:SF125', NULL, NULL, NULL, NULL, 'DOPAMINE D2-LIKE RECEPTOR', 251854),
(416276, 'PTHR24248:SF169', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE RECEPTOR 4', 251854),
(416277, 'PTHR24248:SF168', NULL, NULL, NULL, NULL, 'IP13425P-RELATED', 251854),
(416278, 'PTHR24248:SF3', NULL, NULL, NULL, NULL, 'BETA-3 ADRENERGIC RECEPTOR', 251854),
(416279, 'PTHR24248:SF139', NULL, NULL, NULL, NULL, 'D(1A) DOPAMINE RECEPTOR', 251854),
(416280, 'PTHR24248:SF87', NULL, NULL, NULL, NULL, 'D(2) DOPAMINE RECEPTOR', 251854),
(416281, 'PTHR24248:SF172', NULL, NULL, NULL, NULL, 'DOPAMINE/ECDYSTEROID RECEPTOR, ISOFORM A', 251854),
(416282, 'PTHR24248:SF130', NULL, NULL, NULL, NULL, 'ALPHA-2B ADRENERGIC RECEPTOR', 251854),
(416283, 'PTHR24248:SF174', NULL, NULL, NULL, NULL, 'TYRAMINE/OCTOPAMINE RECEPTOR', 251854),
(416284, 'PTHR24248:SF176', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 101-RELATED', 251854),
(416285, 'PTHR24248:SF134', NULL, NULL, NULL, NULL, 'OCTOPAMINE RECEPTOR BETA-1R', 251854),
(416286, 'PTHR24248:SF177', NULL, NULL, NULL, NULL, 'DOPAMINE RECEPTOR D1A-RELATED', 251854),
(416287, 'PTHR24248:SF136', NULL, NULL, NULL, NULL, 'D(1B) DOPAMINE RECEPTOR', 251854),
(416288, 'PTHR24248:SF179', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251854),
(416289, 'PTHR24248:SF72', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251854),
(416290, 'PTHR24248:SF141', NULL, NULL, NULL, NULL, 'MUSCARINIC ACETYLCHOLINE RECEPTOR', 251854),
(416291, 'PTHR24248:SF185', NULL, NULL, NULL, NULL, 'DOPAMINE RECEPTOR 2', 251854),
(416292, 'PTHR24248:SF184', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251854),
(416293, 'PTHR24248:SF140', NULL, NULL, NULL, NULL, 'HISTAMINE RECEPTOR H3', 251854),
(416294, 'PTHR24248:SF143', NULL, NULL, NULL, NULL, 'DOPAMINE RECEPTOR D4A', 251854),
(416295, 'PTHR24248:SF187', NULL, NULL, NULL, NULL, 'OCTOPAMINE RECEPTOR BETA-2R', 251854),
(416296, 'PTHR24248:SF186', NULL, NULL, NULL, NULL, 'HISTAMINE RECEPTOR H3', 251854),
(416297, 'PTHR24248:SF142', NULL, NULL, NULL, NULL, 'MUSCARINIC ACETYLCHOLINE RECEPTOR M4', 251854),
(416298, 'PTHR24248:SF189', NULL, NULL, NULL, NULL, 'ALPHA2-ADRENERGIC-LIKE OCTOPAMINE RECEPTOR, ISOFORM B', 251854),
(416299, 'PTHR24248:SF145', NULL, NULL, NULL, NULL, 'DOPAMINE RECEPTOR D4-RELATED SEQUENCE', 251854),
(416300, 'PTHR24248:SF144', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251854),
(416301, 'PTHR24248:SF188', NULL, NULL, NULL, NULL, 'BETA-2 ADRENERGIC RECEPTOR-RELATED', 251854),
(416302, 'PTHR24248:SF146', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE RECEPTOR 4', 251854),
(416303, 'PTHR24248:SF148', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 251854),
(416304, 'PTHR42807', NULL, NULL, NULL, NULL, 'GLUTARYL-COA DEHYDROGENASE, MITOCHONDRIAL', 251855),
(416305, 'PTHR42807:SF1', NULL, NULL, NULL, NULL, 'GLUTARYL-COA DEHYDROGENASE, MITOCHONDRIAL', 251855),
(416306, 'PTHR32301:SF8', NULL, NULL, NULL, NULL, 'GOLVESIN', 251856),
(416307, 'PTHR32301:SF6', NULL, NULL, NULL, NULL, 'WW DOMAIN-CONTAINING PROTEIN', 251856),
(416308, 'PTHR32301:SF12', NULL, NULL, NULL, NULL, 'GOLGI PROTEIN 2', 251856),
(416309, 'PTHR32301:SF13', NULL, NULL, NULL, NULL, 'COUNTIN RECEPTOR CNR3-RELATED', 251856),
(416310, 'PTHR32301', NULL, NULL, NULL, NULL, 'COUNTIN RECEPTOR CNR3-RELATED', 251856);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(416311, 'PTHR46055:SF2', NULL, NULL, NULL, NULL, 'CIRCADIAN LOCOMOTER OUTPUT CYCLES PROTEIN KAPUT', 251857),
(416312, 'PTHR46055:SF1', NULL, NULL, NULL, NULL, 'NEURONAL PAS DOMAIN-CONTAINING PROTEIN 2', 251857),
(416313, 'PTHR46055', NULL, NULL, NULL, NULL, 'CIRCADIAN LOCOMOTER OUTPUT CYCLES PROTEIN KAPUT', 251857),
(416314, 'PTHR46055:SF4', NULL, NULL, NULL, NULL, 'CIRCADIAN CLOCK PROTEIN PASD1', 251857),
(416315, 'PTHR46055:SF3', NULL, NULL, NULL, NULL, 'CIRCADIAN LOCOMOTER OUTPUT CYCLES PROTEIN KAPUT', 251857),
(416316, 'PTHR45697:SF1', NULL, NULL, NULL, NULL, 'ADP RIBOSYLATION FACTOR-LIKE GTPASE 3, LIKE 1-RELATED', 251858),
(416317, 'PTHR45697:SF3', NULL, NULL, NULL, NULL, 'DEAD END', 251858),
(416318, 'PTHR45697:SF2', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 2', 251858),
(416319, 'PTHR45697', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 2-RELATED', 251858),
(416320, 'PTHR45697:SF4', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 3', 251858),
(416321, 'PTHR37873', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 33', 251859),
(416322, 'PTHR37873:SF1', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 33', 251859),
(416323, 'PTHR39313:SF1', NULL, NULL, NULL, NULL, 'IM:7138239', 251860),
(416324, 'PTHR39313', NULL, NULL, NULL, NULL, 'IM:7138239', 251860),
(416325, 'PTHR45755', NULL, NULL, NULL, NULL, '', 251861),
(416326, 'PTHR45755:SF5', NULL, NULL, NULL, NULL, 'CATION EFFLUX FAMILY PROTEIN FAMILY (AFU_ORTHOLOGUE AFUA_1G12090)', 251861),
(416327, 'PTHR45755:SF4', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER 7', 251861),
(416328, 'PTHR45755:SF3', NULL, NULL, NULL, NULL, 'METAL TOLERANCE PROTEIN C2', 251861),
(416329, 'PTHR45755:SF2', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER PROTEIN DDB_G0269332-RELATED', 251861),
(416330, 'PTHR45755:SF1', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER 5', 251861),
(416331, 'PTHR45655:SF17', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE SOLUBLE SUBUNIT BETA-2', 251862),
(416332, 'PTHR45655:SF13', NULL, NULL, NULL, NULL, 'SOLUBLE GUANYLATE CYCLASE GCY-32-RELATED', 251862),
(416333, 'PTHR45655:SF16', NULL, NULL, NULL, NULL, 'SOLUBLE GUANYLATE CYCLASE GCY-36', 251862),
(416334, 'PTHR45655:SF15', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE', 251862),
(416335, 'PTHR45655:SF10', NULL, NULL, NULL, NULL, 'SOLUBLE GUANYLATE CYCLASE 88E', 251862),
(416336, 'PTHR45655:SF12', NULL, NULL, NULL, NULL, 'SOLUBLE GUANYLATE CYCLASE GCY-34', 251862),
(416337, 'PTHR45655:SF1', NULL, NULL, NULL, NULL, 'SOLUBLE GUANYLATE CYCLASE GCY-37', 251862),
(416338, 'PTHR45655:SF2', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE SOLUBLE SUBUNIT BETA-1', 251862),
(416339, 'PTHR45655', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE SOLUBLE SUBUNIT BETA-2', 251862),
(416340, 'PTHR45655:SF5', NULL, NULL, NULL, NULL, 'SOLUBLE GUANYLATE CYCLASE 89DA-RELATED', 251862),
(416341, 'PTHR45655:SF4', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE SOLUBLE SUBUNIT ALPHA-1', 251862),
(416342, 'PTHR45655:SF7', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE SOLUBLE SUBUNIT ALPHA-2', 251862),
(416343, 'PTHR45655:SF6', NULL, NULL, NULL, NULL, 'HEAD-SPECIFIC GUANYLATE CYCLASE', 251862),
(416344, 'PTHR45655:SF8', NULL, NULL, NULL, NULL, 'SOLUBLE GUANYLATE CYCLASE GCY-33', 251862),
(416345, 'PTHR45744:SF2', NULL, NULL, NULL, NULL, 'TYROSINE AMINOTRANSFERASE', 251863),
(416346, 'PTHR45744:SF20', NULL, NULL, NULL, NULL, 'TYROSINE TRANSAMINASE FAMILY PROTEIN', 251863),
(416347, 'PTHR45744:SF40', NULL, NULL, NULL, NULL, 'TYROSINE TRANSAMINASE FAMILY PROTEIN ISOFORM 1', 251863),
(416348, 'PTHR45744:SF24', NULL, NULL, NULL, NULL, 'AMINOTRAN_1_2 DOMAIN-CONTAINING PROTEIN', 251863),
(416349, 'PTHR45744:SF5', NULL, NULL, NULL, NULL, 'NICOTIANAMINE AMINOTRANSFERASE 1', 251863),
(416350, 'PTHR45744:SF23', NULL, NULL, NULL, NULL, 'AMINOTRAN_1_2 DOMAIN-CONTAINING PROTEIN', 251863),
(416351, 'PTHR45744:SF22', NULL, NULL, NULL, NULL, 'AMINOTRAN_1_2 DOMAIN-CONTAINING PROTEIN', 251863),
(416352, 'PTHR45744:SF8', NULL, NULL, NULL, NULL, 'AMINOTRAN_1_2 DOMAIN-CONTAINING PROTEIN', 251863);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(416353, 'PTHR45744:SF21', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE TAT3-RELATED', 251863),
(416354, 'PTHR45744:SF28', NULL, NULL, NULL, NULL, 'AMINOTRAN_1_2 DOMAIN-CONTAINING PROTEIN', 251863),
(416355, 'PTHR45744:SF27', NULL, NULL, NULL, NULL, 'AMINOTRAN_1_2 DOMAIN-CONTAINING PROTEIN', 251863),
(416356, 'PTHR45744:SF26', NULL, NULL, NULL, NULL, 'AMINOTRAN_1_2 DOMAIN-CONTAINING PROTEIN', 251863),
(416357, 'PTHR45744:SF25', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE TAT2-RELATED', 251863),
(416358, 'PTHR45744:SF29', NULL, NULL, NULL, NULL, 'TYROSINE/NICOTIANAMINE AMINOTRANSFERASE, PYRIDOXAL PHOSPHATE-DEPENDENT TRANSFERASE-RELATED', 251863),
(416359, 'PTHR45744', NULL, NULL, NULL, NULL, 'TYROSINE AMINOTRANSFERASE', 251863),
(416360, 'PTHR45744:SF31', NULL, NULL, NULL, NULL, 'BNAC01G10040D PROTEIN', 251863),
(416361, 'PTHR45744:SF30', NULL, NULL, NULL, NULL, 'AMINOTRAN_1_2 DOMAIN-CONTAINING PROTEIN', 251863),
(416362, 'PTHR45744:SF13', NULL, NULL, NULL, NULL, 'OS02G0302200 PROTEIN', 251863),
(416363, 'PTHR45744:SF12', NULL, NULL, NULL, NULL, 'TYROSINE AMINOTRANSFERASE HOMOLOG1', 251863),
(416364, 'PTHR45744:SF34', NULL, NULL, NULL, NULL, 'TYROSINE/NICOTIANAMINE AMINOTRANSFERASE, PYRIDOXAL PHOSPHATE-DEPENDENT TRANSFERASE-RELATED', 251863),
(416365, 'PTHR45744:SF11', NULL, NULL, NULL, NULL, 'TYROSINE AMINOTRANSFERASE', 251863),
(416366, 'PTHR45744:SF33', NULL, NULL, NULL, NULL, 'BNAA09G41170D PROTEIN', 251863),
(416367, 'PTHR45744:SF32', NULL, NULL, NULL, NULL, 'AMINOTRAN_1_2 DOMAIN-CONTAINING PROTEIN', 251863),
(416368, 'PTHR45744:SF10', NULL, NULL, NULL, NULL, 'CYSTINE LYASE CORI3-RELATED', 251863),
(416369, 'PTHR45744:SF39', NULL, NULL, NULL, NULL, 'TRANSAMINASE', 251863),
(416370, 'PTHR45744:SF16', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE TAT1-RELATED', 251863),
(416371, 'PTHR45744:SF15', NULL, NULL, NULL, NULL, 'S-ALKYL-THIOHYDROXIMATE LYASE SUR1', 251863),
(416372, 'PTHR45744:SF14', NULL, NULL, NULL, NULL, 'TYROSINE AMINOTRANSFERASE-LIKE', 251863),
(416373, 'PTHR45744:SF36', NULL, NULL, NULL, NULL, 'AMINOTRAN_1_2 DOMAIN-CONTAINING PROTEIN', 251863),
(416374, 'PTHR45744:SF19', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE TAT2 ISOFORM X1-RELATED', 251863),
(416375, 'PTHR45744:SF18', NULL, NULL, NULL, NULL, 'NICOTIANAMINE AMINOTRANSFERASE HOMOLOG', 251863),
(416376, 'PTHR36340:SF1', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE SUBUNIT CRR3, CHLOROPLASTIC-RELATED', 251864),
(416377, 'PTHR36340', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE SUBUNIT CRR3, CHLOROPLASTIC-RELATED', 251864),
(416378, 'PTHR34757:SF1', NULL, NULL, NULL, NULL, 'JUNCTIONAL PROTEIN ASSOCIATED WITH CORONARY ARTERY DISEASE', 251865),
(416379, 'PTHR34757', NULL, NULL, NULL, NULL, 'JUNCTIONAL PROTEIN ASSOCIATED WITH CORONARY ARTERY DISEASE', 251865),
(416380, 'PTHR32338', NULL, NULL, NULL, NULL, 'N-ACETYL-GAMMA-GLUTAMYL-PHOSPHATE REDUCTASE, CHLOROPLASTIC-RELATED-RELATED', 251866),
(416381, 'PTHR32338:SF10', NULL, NULL, NULL, NULL, 'N-ACETYL-GAMMA-GLUTAMYL-PHOSPHATE REDUCTASE, CHLOROPLASTIC-RELATED', 251866),
(416382, 'PTHR32338:SF11', NULL, NULL, NULL, NULL, '[LYSW]-L-2-AMINOADIPATE/[LYSW]-L-GLUTAMATE PHOSPHATE REDUCTASE-RELATED', 251866),
(416383, 'PTHR35559', NULL, NULL, NULL, NULL, '', 251867),
(416384, 'PTHR35559:SF1', NULL, NULL, NULL, NULL, '', 251867),
(416385, 'PTHR19226', NULL, NULL, NULL, NULL, 'THY-1 MEMBRANE GLYCOPROTEIN', 251868),
(416386, 'PTHR19226:SF3', NULL, NULL, NULL, NULL, 'SI:DKEYP-69C1.7', 251868),
(416387, 'PTHR19226:SF2', NULL, NULL, NULL, NULL, 'THY-1 MEMBRANE GLYCOPROTEIN', 251868),
(416388, 'PTHR12832:SF17', NULL, NULL, NULL, NULL, 'T-COMPLEX PROTEIN 11-LIKE PROTEIN 2', 251869),
(416389, 'PTHR12832:SF15', NULL, NULL, NULL, NULL, 'T-COMPLEX PROTEIN 11-LIKE PROTEIN 1', 251869),
(416390, 'PTHR12832:SF14', NULL, NULL, NULL, NULL, 'T-COMPLEX PROTEIN 11 HOMOLOG', 251869),
(416391, 'PTHR12832', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC PROTEIN PBS13  T-COMPLEX 11', 251869),
(416392, 'PTHR12832:SF18', NULL, NULL, NULL, NULL, 'IQ CALMODULIN-BINDING MOTIF DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_1G08920)', 251869);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(416393, 'PTHR12832:SF31', NULL, NULL, NULL, NULL, 'OS02G0556700 PROTEIN', 251869),
(416394, 'PTHR12832:SF35', NULL, NULL, NULL, NULL, 'T-COMPLEX PROTEIN 11-RELATED', 251869),
(416395, 'PTHR12832:SF34', NULL, NULL, NULL, NULL, 'T-COMPLEX PROTEIN 11', 251869),
(416396, 'PTHR12832:SF11', NULL, NULL, NULL, NULL, 'LD23868P', 251869),
(416397, 'PTHR12832:SF32', NULL, NULL, NULL, NULL, 'T-COMPLEX 11 FAMILY, X-LINKED 2', 251869),
(416398, 'PTHR12832:SF21', NULL, NULL, NULL, NULL, 'T-COMPLEX PROTEIN 11 X-LINKED PROTEIN 1-RELATED', 251869),
(416399, 'PTHR35606:SF4', NULL, NULL, NULL, NULL, '', 251870),
(416400, 'PTHR35606', NULL, NULL, NULL, NULL, '', 251870),
(416401, 'PTHR12944', NULL, NULL, NULL, NULL, 'SOLUBLE LIVER ANTIGEN/LIVER PANCREAS ANTIGEN', 251871),
(416402, 'PTHR12944:SF2', NULL, NULL, NULL, NULL, 'O-PHOSPHOSERYL-TRNA(SEC) SELENIUM TRANSFERASE', 251871),
(416403, 'PTHR47587:SF2', NULL, NULL, NULL, NULL, 'OS05G0103500 PROTEIN', 251872),
(416404, 'PTHR47587', NULL, NULL, NULL, NULL, 'OS05G0103500 PROTEIN', 251872),
(416405, 'PTHR15660:SF1', NULL, NULL, NULL, NULL, 'BRISC AND BRCA1-A COMPLEX MEMBER 1', 251873),
(416406, 'PTHR15660', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 251873),
(416407, 'PTHR45704:SF2', NULL, NULL, NULL, NULL, 'SMALL MONOMERIC GTPASE', 251874),
(416408, 'PTHR45704:SF1', NULL, NULL, NULL, NULL, 'RAS-LIKE FAMILY 11 MEMBER A', 251874),
(416409, 'PTHR45704:SF4', NULL, NULL, NULL, NULL, 'RAS-LIKE PROTEIN 3', 251874),
(416410, 'PTHR45704:SF3', NULL, NULL, NULL, NULL, 'RAS-LIKE PROTEIN FAMILY MEMBER 11A', 251874),
(416411, 'PTHR45704:SF6', NULL, NULL, NULL, NULL, 'RAS-LIKE PROTEIN FAMILY MEMBER 11B', 251874),
(416412, 'PTHR45704', NULL, NULL, NULL, NULL, 'RAS-LIKE FAMILY MEMBER 11', 251874),
(416413, 'PTHR45704:SF8', NULL, NULL, NULL, NULL, 'SMALL MONOMERIC GTPASE', 251874),
(416414, 'PTHR45704:SF7', NULL, NULL, NULL, NULL, 'SMALL MONOMERIC GTPASE', 251874),
(416415, 'PTHR45704:SF9', NULL, NULL, NULL, NULL, 'RAS-RELATED AND ESTROGEN-REGULATED GROWTH INHIBITOR-LIKE PROTEIN', 251874),
(416416, 'PTHR45704:SF13', NULL, NULL, NULL, NULL, 'SMALL MONOMERIC GTPASE', 251874),
(416417, 'PTHR45704:SF10', NULL, NULL, NULL, NULL, 'RE30129P', 251874),
(416418, 'PTHR45704:SF11', NULL, NULL, NULL, NULL, 'RAS-LIKE PROTEIN FAMILY MEMBER 11A-LIKE', 251874),
(416419, 'PTHR45704:SF16', NULL, NULL, NULL, NULL, 'RAS-RELATED AND ESTROGEN-REGULATED GROWTH INHIBITOR-LIKE PROTEIN', 251874),
(416420, 'PTHR45704:SF15', NULL, NULL, NULL, NULL, 'SMALL GTPASE', 251874),
(416421, 'PTHR48222:SF4', NULL, NULL, NULL, NULL, 'PROTEINASE INHIBITOR, PROPEPTIDE', 251875),
(416422, 'PTHR48222:SF3', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE SBT3.3 ISOFORM X1', 251875),
(416423, 'PTHR48222:SF8', NULL, NULL, NULL, NULL, 'OS01G0730000 PROTEIN', 251875),
(416424, 'PTHR48222:SF7', NULL, NULL, NULL, NULL, 'OS07G0438600 PROTEIN', 251875),
(416425, 'PTHR48222:SF6', NULL, NULL, NULL, NULL, 'OS03G0838500 PROTEIN', 251875),
(416426, 'PTHR48222', NULL, NULL, NULL, NULL, 'PROTEINASE INHIBITOR, PROPEPTIDE', 251875),
(416427, 'PTHR48222:SF5', NULL, NULL, NULL, NULL, '', 251875),
(416428, 'PTHR13328', NULL, NULL, NULL, NULL, 'NEGATIVE ELONGATION FACTOR A  NELF-A', 251876),
(416429, 'PTHR13328:SF6', NULL, NULL, NULL, NULL, 'GEX-3-INTERACTING PROTEIN 13', 251876),
(416430, 'PTHR13328:SF4', NULL, NULL, NULL, NULL, 'NEGATIVE ELONGATION FACTOR A', 251876),
(416431, 'PTHR13328:SF5', NULL, NULL, NULL, NULL, 'LD28815P', 251876),
(416432, 'PTHR45648:SF8', NULL, NULL, NULL, NULL, 'OS06G0229400 PROTEIN', 251877),
(416433, 'PTHR45648:SF79', NULL, NULL, NULL, NULL, '', 251877),
(416434, 'PTHR45648:SF9', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN APG, PUTATIVE-RELATED', 251877),
(416435, 'PTHR45648:SF7', NULL, NULL, NULL, NULL, 'OS12G0126100 PROTEIN', 251877),
(416436, 'PTHR45648:SF157', NULL, NULL, NULL, NULL, 'FINGER PROTEIN, PUTATIVE-RELATED', 251877),
(416437, 'PTHR45648:SF5', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE SUPERFAMILY PROTEIN', 251877),
(416438, 'PTHR45648:SF156', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 251877);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(416439, 'PTHR45648:SF2', NULL, NULL, NULL, NULL, 'OS02G0816200 PROTEIN', 251877),
(416440, 'PTHR45648:SF159', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 251877),
(416441, 'PTHR45648:SF78', NULL, NULL, NULL, NULL, '', 251877),
(416442, 'PTHR45648:SF77', NULL, NULL, NULL, NULL, 'BNAA01G29500D PROTEIN', 251877),
(416443, 'PTHR45648:SF158', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE LTL1-LIKE', 251877),
(416444, 'PTHR45648:SF153', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 251877),
(416445, 'PTHR45648:SF152', NULL, NULL, NULL, NULL, '', 251877),
(416446, 'PTHR45648:SF1', NULL, NULL, NULL, NULL, 'ANTHER-SPECIFIC PROLINE-RICH PROTEIN APG', 251877),
(416447, 'PTHR45648:SF82', NULL, NULL, NULL, NULL, 'SGNH HYDROLASE-TYPE ESTERASE DOMAIN-CONTAINING PROTEIN-RELATED', 251877),
(416448, 'PTHR45648:SF155', NULL, NULL, NULL, NULL, '', 251877),
(416449, 'PTHR45648:SF85', NULL, NULL, NULL, NULL, 'A, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G10760)-RELATED', 251877),
(416450, 'PTHR45648:SF154', NULL, NULL, NULL, NULL, '', 251877),
(416451, 'PTHR45648:SF151', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 251877),
(416452, 'PTHR45648:SF80', NULL, NULL, NULL, NULL, 'BNAA02G09320D PROTEIN', 251877),
(416453, 'PTHR45648:SF150', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE', 251877),
(416454, 'PTHR45648:SF149', NULL, NULL, NULL, NULL, 'SGNH HYDROLASE-TYPE ESTERASE DOMAIN-CONTAINING PROTEIN-RELATED', 251877),
(416455, 'PTHR45648', NULL, NULL, NULL, NULL, 'GDSL LIPASE/ACYLHYDROLASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_4G14700)', 251877),
(416456, 'PTHR45648:SF146', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 251877),
(416457, 'PTHR45648:SF87', NULL, NULL, NULL, NULL, 'BNAC06G10400D PROTEIN', 251877),
(416458, 'PTHR45648:SF86', NULL, NULL, NULL, NULL, '', 251877),
(416459, 'PTHR45648:SF145', NULL, NULL, NULL, NULL, 'BNAA09G41930D PROTEIN', 251877),
(416460, 'PTHR45648:SF148', NULL, NULL, NULL, NULL, 'OS06G0725200 PROTEIN', 251877),
(416461, 'PTHR45648:SF88', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN APG, PUTATIVE-RELATED', 251877),
(416462, 'PTHR45648:SF147', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE', 251877),
(416463, 'PTHR45648:SF94', NULL, NULL, NULL, NULL, '', 251877),
(416464, 'PTHR45648:SF141', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE 6', 251877),
(416465, 'PTHR45648:SF93', NULL, NULL, NULL, NULL, 'SGNH HYDROLASE-TYPE ESTERASE DOMAIN-CONTAINING PROTEIN-RELATED', 251877),
(416466, 'PTHR45648:SF144', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 251877),
(416467, 'PTHR45648:SF96', NULL, NULL, NULL, NULL, 'BNAC06G06810D PROTEIN', 251877),
(416468, 'PTHR45648:SF143', NULL, NULL, NULL, NULL, 'BNAA01G08120D PROTEIN', 251877),
(416469, 'PTHR45648:SF90', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE SUPERFAMILY PROTEIN-RELATED', 251877),
(416470, 'PTHR45648:SF91', NULL, NULL, NULL, NULL, 'SGNH HYDROLASE-TYPE ESTERASE DOMAIN-CONTAINING PROTEIN-RELATED', 251877),
(416471, 'PTHR45648:SF139', NULL, NULL, NULL, NULL, 'BNAC08G21900D PROTEIN', 251877),
(416472, 'PTHR45648:SF58', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE LTL1-LIKE', 251877),
(416473, 'PTHR45648:SF57', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE', 251877),
(416474, 'PTHR45648:SF138', NULL, NULL, NULL, NULL, 'OS04G0561800 PROTEIN', 251877),
(416475, 'PTHR45648:SF59', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE', 251877),
(416476, 'PTHR45648:SF134', NULL, NULL, NULL, NULL, 'SGNH HYDROLASE-TYPE ESTERASE DOMAIN-CONTAINING PROTEIN-RELATED', 251877),
(416477, 'PTHR45648:SF137', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 251877),
(416478, 'PTHR45648:SF56', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE SUPERFAMILY PROTEIN', 251877),
(416479, 'PTHR45648:SF136', NULL, NULL, NULL, NULL, 'CUTIN-DEFICIENT 1 PROTEIN', 251877),
(416480, 'PTHR45648:SF61', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 251877),
(416481, 'PTHR45648:SF130', NULL, NULL, NULL, NULL, '', 251877),
(416482, 'PTHR45648:SF133', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE', 251877); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(416483, 'PTHR45648:SF132', NULL, NULL, NULL, NULL, '', 251877),
(416484, 'PTHR45648:SF128', NULL, NULL, NULL, NULL, 'BNAA08G29170D PROTEIN', 251877),
(416485, 'PTHR45648:SF127', NULL, NULL, NULL, NULL, 'BNAA08G29190D PROTEIN', 251877),
(416486, 'PTHR45648:SF129', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE', 251877),
(416487, 'PTHR45648:SF123', NULL, NULL, NULL, NULL, 'OS02G0668900 PROTEIN', 251877),
(416488, 'PTHR45648:SF64', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 251877),
(416489, 'PTHR45648:SF67', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE', 251877),
(416490, 'PTHR45648:SF125', NULL, NULL, NULL, NULL, 'BNAA10G09310D PROTEIN', 251877),
(416491, 'PTHR45648:SF66', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE', 251877),
(416492, 'PTHR45648:SF72', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE 22-RELATED', 251877),
(416493, 'PTHR45648:SF122', NULL, NULL, NULL, NULL, '', 251877),
(416494, 'PTHR45648:SF121', NULL, NULL, NULL, NULL, 'BNAA03G11610D PROTEIN', 251877),
(416495, 'PTHR45648:SF73', NULL, NULL, NULL, NULL, 'BNAA08G07360D PROTEIN', 251877),
(416496, 'PTHR45648:SF36', NULL, NULL, NULL, NULL, '', 251877),
(416497, 'PTHR45648:SF117', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE ESM1', 251877),
(416498, 'PTHR45648:SF119', NULL, NULL, NULL, NULL, 'FINGER PROTEIN, PUTATIVE-RELATED', 251877),
(416499, 'PTHR45648:SF33', NULL, NULL, NULL, NULL, '', 251877),
(416500, 'PTHR45648:SF41', NULL, NULL, NULL, NULL, '', 251877),
(416501, 'PTHR45648:SF111', NULL, NULL, NULL, NULL, 'SGNH HYDROLASE-TYPE ESTERASE DOMAIN-CONTAINING PROTEIN-RELATED', 251877),
(416502, 'PTHR45648:SF40', NULL, NULL, NULL, NULL, '', 251877),
(416503, 'PTHR45648:SF106', NULL, NULL, NULL, NULL, 'ANTHER-SPECIFIC PROLINE-RICH PROTEIN APG', 251877),
(416504, 'PTHR45648:SF46', NULL, NULL, NULL, NULL, 'OS06G0725100 PROTEIN', 251877),
(416505, 'PTHR45648:SF48', NULL, NULL, NULL, NULL, 'OS03G0581400 PROTEIN', 251877),
(416506, 'PTHR45648:SF107', NULL, NULL, NULL, NULL, 'ESTER HYDROLASE, PUTATIVE-RELATED', 251877),
(416507, 'PTHR45648:SF43', NULL, NULL, NULL, NULL, 'BNAA02G04090D PROTEIN', 251877),
(416508, 'PTHR45648:SF101', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 251877),
(416509, 'PTHR45648:SF104', NULL, NULL, NULL, NULL, 'OS02G0292600 PROTEIN', 251877),
(416510, 'PTHR45648:SF103', NULL, NULL, NULL, NULL, 'BNAA05G14080D PROTEIN', 251877),
(416511, 'PTHR45648:SF44', NULL, NULL, NULL, NULL, '', 251877),
(416512, 'PTHR45648:SF50', NULL, NULL, NULL, NULL, '', 251877),
(416513, 'PTHR45648:SF13', NULL, NULL, NULL, NULL, 'OS02G0290900 PROTEIN', 251877),
(416514, 'PTHR45648:SF98', NULL, NULL, NULL, NULL, 'BNAA10G09320D PROTEIN', 251877),
(416515, 'PTHR45648:SF97', NULL, NULL, NULL, NULL, 'BNAC06G06760D PROTEIN', 251877),
(416516, 'PTHR45648:SF12', NULL, NULL, NULL, NULL, '', 251877),
(416517, 'PTHR45648:SF99', NULL, NULL, NULL, NULL, 'OS02G0740400 PROTEIN', 251877),
(416518, 'PTHR45648:SF17', NULL, NULL, NULL, NULL, 'FINGER PROTEIN, PUTATIVE-RELATED', 251877),
(416519, 'PTHR45648:SF24', NULL, NULL, NULL, NULL, 'OS06G0257600 PROTEIN', 251877),
(416520, 'PTHR45648:SF21', NULL, NULL, NULL, NULL, 'OS04G0507700 PROTEIN', 251877),
(416521, 'PTHR45648:SF23', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE FAMILY PROTEIN, EXPRESSED', 251877),
(416522, 'PTHR45648:SF22', NULL, NULL, NULL, NULL, 'GDSL LIPASE/ACYLHYDROLASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_4G14700)', 251877),
(416523, 'PTHR45648:SF28', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', 251877),
(416524, 'PTHR45648:SF164', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE SUPERFAMILY PROTEIN-RELATED', 251877),
(416525, 'PTHR45648:SF163', NULL, NULL, NULL, NULL, 'OS08G0565900 PROTEIN', 251877),
(416526, 'PTHR45648:SF30', NULL, NULL, NULL, NULL, '', 251877),
(416527, 'PTHR45648:SF166', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE LTL1', 251877),
(416528, 'PTHR45648:SF165', NULL, NULL, NULL, NULL, '', 251877),
(416529, 'PTHR45648:SF160', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE FAMILY PROTEIN, EXPRESSED', 251877),
(416530, 'PTHR45648:SF162', NULL, NULL, NULL, NULL, 'FINGER PROTEIN, PUTATIVE-RELATED', 251877);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(416531, 'PTHR45648:SF161', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 251877),
(416532, 'PTHR30304:SF0', NULL, NULL, NULL, NULL, 'D-TAGATOSE-1,6-BISPHOSPHATE ALDOLASE SUBUNIT GATY-RELATED', 251878),
(416533, 'PTHR30304', NULL, NULL, NULL, NULL, 'D-TAGATOSE-1,6-BISPHOSPHATE ALDOLASE', 251878),
(416534, 'PTHR30304:SF11', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR OF PROTEASES PRTT', 251878),
(416535, 'PTHR30304:SF7', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 251878),
(416536, 'PTHR30304:SF3', NULL, NULL, NULL, NULL, '3-OXO-TETRONATE KINASE', 251878),
(416537, 'PTHR30304:SF4', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 251878),
(416538, 'PTHR31353:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAM98A-LIKE PROTEIN', 251879),
(416539, 'PTHR31353:SF10', NULL, NULL, NULL, NULL, 'PROTEIN FAM98C', 251879),
(416540, 'PTHR31353:SF5', NULL, NULL, NULL, NULL, 'IM:7138535', 251879),
(416541, 'PTHR31353:SF9', NULL, NULL, NULL, NULL, 'PROTEIN FAM98A', 251879),
(416542, 'PTHR31353', NULL, NULL, NULL, NULL, 'FAM98', 251879),
(416543, 'PTHR31353:SF11', NULL, NULL, NULL, NULL, 'PROTEIN FAM98B', 251879),
(416544, 'PTHR43408:SF2', NULL, NULL, NULL, NULL, 'FMN REDUCTASE (NADPH)', 251880),
(416545, 'PTHR43408', NULL, NULL, NULL, NULL, 'FMN REDUCTASE (NADPH)', 251880),
(416546, 'PTHR43408:SF1', NULL, NULL, NULL, NULL, 'FMN REDUCTASE (NADPH)', 251880),
(416547, 'PTHR40077', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 251881),
(416548, 'PTHR40077:SF1', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 251881),
(416549, 'PTHR40077:SF2', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 251881),
(416550, 'PTHR47192', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE 3-2, CHLOROPLASTIC', 251882),
(416551, 'PTHR47192:SF3', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE 3-1, CHLOROPLASTIC', 251882),
(416552, 'PTHR47192:SF4', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE 3-2, CHLOROPLASTIC', 251882),
(416553, 'PTHR37231', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251883),
(416554, 'PTHR37231:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251883),
(416555, 'PTHR23193:SF20', NULL, NULL, NULL, NULL, 'POM121-LIKE PROTEIN 2', 251884),
(416556, 'PTHR23193:SF40', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP214', 251884),
(416557, 'PTHR23193', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN  NUP', 251884),
(416558, 'PTHR23193:SF45', NULL, NULL, NULL, NULL, 'NUCLEAR ENVELOPE PORE MEMBRANE PROTEIN POM 121C-RELATED', 251884),
(416559, 'PTHR23193:SF23', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP153', 251884),
(416560, 'PTHR23193:SF5', NULL, NULL, NULL, NULL, 'NUCLEAR ENVELOPE PORE MEMBRANE PROTEIN POM 121', 251884),
(416561, 'PTHR23193:SF21', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP214', 251884),
(416562, 'PTHR23193:SF15', NULL, NULL, NULL, NULL, 'NUCLEAR PORE-ASSOCIATED PROTEIN 1', 251884),
(416563, 'PTHR43668', NULL, NULL, NULL, NULL, 'ALLANTOINASE', 251885),
(416564, 'PTHR43668:SF6', NULL, NULL, NULL, NULL, 'AMIDOHYDROLASE-RELATED', 251885),
(416565, 'PTHR43668:SF4', NULL, NULL, NULL, NULL, 'ALLANTOINASE', 251885),
(416566, 'PTHR43668:SF5', NULL, NULL, NULL, NULL, 'AMIDOHYDRO_3 DOMAIN-CONTAINING PROTEIN', 251885),
(416567, 'PTHR43668:SF2', NULL, NULL, NULL, NULL, 'ALLANTOINASE', 251885),
(416568, 'PTHR31691:SF1', NULL, NULL, NULL, NULL, 'ROTATIN', 251886),
(416569, 'PTHR31691', NULL, NULL, NULL, NULL, 'ROTATIN', 251886),
(416570, 'PTHR22642:SF19', NULL, NULL, NULL, NULL, 'AMIDOHYDROLASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_5G01480)', 251887),
(416571, 'PTHR22642:SF20', NULL, NULL, NULL, NULL, 'AMIDOHYDRO_3 DOMAIN-CONTAINING PROTEIN', 251887),
(416572, 'PTHR22642', NULL, NULL, NULL, NULL, 'IMIDAZOLONEPROPIONASE', 251887),
(416573, 'PTHR22642:SF21', NULL, NULL, NULL, NULL, 'PERIPLASMIC PROTEIN-RELATED', 251887),
(416574, 'PTHR22642:SF2', NULL, NULL, NULL, NULL, 'PROTEIN LONG AFTER FAR-RED 3', 251887),
(416575, 'PTHR22642:SF22', NULL, NULL, NULL, NULL, 'EXOENZYMES REGULATORY PROTEIN AEPA', 251887),
(416576, 'PTHR28601:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 24', 251888);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(416577, 'PTHR28601', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 24', 251888),
(416578, 'PTHR11477:SF0', NULL, NULL, NULL, NULL, 'PROTEIN PARTNER OF SNF, ISOFORM B', 251889),
(416579, 'PTHR11477:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR A PROTEIN 1', 251889),
(416580, 'PTHR11477:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR A PROTEIN 2', 251889),
(416581, 'PTHR11477:SF4', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR A PROTEIN 3', 251889),
(416582, 'PTHR11477:SF11', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BYE1', 251889),
(416583, 'PTHR11477:SF44', NULL, NULL, NULL, NULL, 'TFIIS CENTRAL DOMAIN-CONTAINING PROTEIN', 251889),
(416584, 'PTHR11477:SF10', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN 3', 251889),
(416585, 'PTHR11477:SF32', NULL, NULL, NULL, NULL, 'SPOC DOMAIN / TRANSCRIPTION ELONGATION FACTOR S-II PROTEIN', 251889),
(416586, 'PTHR11477:SF20', NULL, NULL, NULL, NULL, 'SPOC DOMAIN / TRANSCRIPTION ELONGATION FACTOR S-II PROTEIN', 251889),
(416587, 'PTHR11477:SF31', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR TFIIS-LIKE', 251889),
(416588, 'PTHR11477:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR A N-TERMINAL AND CENTRAL DOMAIN-CONTAINING PROTEIN', 251889),
(416589, 'PTHR11477:SF37', NULL, NULL, NULL, NULL, 'OS04G0644675 PROTEIN', 251889),
(416590, 'PTHR11477:SF47', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR TFIIS', 251889),
(416591, 'PTHR11477:SF25', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR-RELATED', 251889),
(416592, 'PTHR11477:SF14', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR A N-TERMINAL AND CENTRAL DOMAIN-CONTAINING PROTEIN 2', 251889),
(416593, 'PTHR11477:SF46', NULL, NULL, NULL, NULL, 'IP08861P-RELATED', 251889),
(416594, 'PTHR11477:SF13', NULL, NULL, NULL, NULL, 'DEATH-INDUCER OBLITERATOR 1', 251889),
(416595, 'PTHR11477', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR S-II ZINC FINGER DOMAIN-CONTAINING PROTEIN', 251889),
(416596, 'PTHR11477:SF45', NULL, NULL, NULL, NULL, 'SPOC DOMAIN-CONTAINING PROTEIN', 251889),
(416597, 'PTHR11477:SF18', NULL, NULL, NULL, NULL, 'SPOC DOMAIN-CONTAINING PROTEIN 1', 251889),
(416598, 'PTHR11477:SF39', NULL, NULL, NULL, NULL, 'TFIIS', 251889),
(416599, 'PTHR28336:SF3', NULL, NULL, NULL, NULL, 'NOVEL PROTEIN', 251890),
(416600, 'PTHR28336:SF2', NULL, NULL, NULL, NULL, 'DEATH DOMAIN CONTAINING 1', 251890),
(416601, 'PTHR28336:SF1', NULL, NULL, NULL, NULL, 'BA1-643', 251890),
(416602, 'PTHR28336', NULL, NULL, NULL, NULL, 'BA1-643', 251890),
(416603, 'PTHR23025:SF3', NULL, NULL, NULL, NULL, 'HORMONE-SENSITIVE LIPASE', 251891),
(416604, 'PTHR23025:SF1', NULL, NULL, NULL, NULL, 'HORMONE-SENSITIVE LIPASE', 251891),
(416605, 'PTHR23025:SF2', NULL, NULL, NULL, NULL, 'HORMONE-SENSITIVE LIPASE', 251891),
(416606, 'PTHR23025', NULL, NULL, NULL, NULL, 'TRIACYLGLYCEROL LIPASE', 251891),
(416607, 'PTHR35999', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM6 HOMOLOG', 251892),
(416608, 'PTHR35999:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM6 HOMOLOG', 251892),
(416609, 'PTHR14732', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 251893),
(416610, 'PTHR14732:SF0', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II SUBUNIT B1 CTD PHOSPHATASE RPAP2-RELATED', 251893),
(416611, 'PTHR34382', NULL, NULL, NULL, NULL, 'PTS SYSTEM N,N''-DIACETYLCHITOBIOSE-SPECIFIC EIIA COMPONENT', 251894),
(416612, 'PTHR34382:SF8', NULL, NULL, NULL, NULL, 'PTS SYSTEM OLIGO-BETA-MANNOSIDE-SPECIFIC EIIA COMPONENT', 251894),
(416613, 'PTHR34382:SF7', NULL, NULL, NULL, NULL, 'PTS SYSTEM N,N''-DIACETYLCHITOBIOSE-SPECIFIC EIIA COMPONENT', 251894),
(416614, 'PTHR34382:SF9', NULL, NULL, NULL, NULL, 'PHOSPHOTRANSFERASE SYSTEM SUGAR-SPECIFIC EII COMPONENT', 251894),
(416615, 'PTHR28062', NULL, NULL, NULL, NULL, 'K+-H+ EXCHANGE-LIKE PROTEIN', 251895),
(416616, 'PTHR28062:SF2', NULL, NULL, NULL, NULL, 'BNAC06G10300D PROTEIN', 251895),
(416617, 'PTHR28062:SF1', NULL, NULL, NULL, NULL, 'K+-H+ EXCHANGE-LIKE PROTEIN', 251895),
(416618, 'PTHR11309:SF136', NULL, NULL, NULL, NULL, 'FRIZZLED-5', 251896);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(416619, 'PTHR11309:SF133', NULL, NULL, NULL, NULL, 'SECRETED FRIZZLED-RELATED PROTEIN 5-LIKE', 251896),
(416620, 'PTHR11309:SF90', NULL, NULL, NULL, NULL, 'FRIZZLED-8', 251896),
(416621, 'PTHR11309:SF96', NULL, NULL, NULL, NULL, '', 251896),
(416622, 'PTHR11309:SF97', NULL, NULL, NULL, NULL, 'SECRETED FRIZZLED-RELATED PROTEIN 3', 251896),
(416623, 'PTHR11309:SF75', NULL, NULL, NULL, NULL, 'FRIZZLED-6', 251896),
(416624, 'PTHR11309:SF31', NULL, NULL, NULL, NULL, 'FRIZZLED-7', 251896),
(416625, 'PTHR11309:SF99', NULL, NULL, NULL, NULL, 'FRIZZLED-4', 251896),
(416626, 'PTHR11309:SF11', NULL, NULL, NULL, NULL, 'SIZZLED', 251896),
(416627, 'PTHR11309:SF45', NULL, NULL, NULL, NULL, 'SECRETED FRIZZLED-RELATED PROTEIN 2', 251896),
(416628, 'PTHR11309:SF23', NULL, NULL, NULL, NULL, 'FRIZZLED-4', 251896),
(416629, 'PTHR11309:SF46', NULL, NULL, NULL, NULL, 'SECRETED FRIZZLED-RELATED PROTEIN 5', 251896),
(416630, 'PTHR11309:SF47', NULL, NULL, NULL, NULL, 'FRIZZLED', 251896),
(416631, 'PTHR11309:SF7', NULL, NULL, NULL, NULL, 'SECRETED FRIZZLED-RELATED PROTEIN 4', 251896),
(416632, 'PTHR11309:SF126', NULL, NULL, NULL, NULL, 'FRIZZLED-2', 251896),
(416633, 'PTHR11309:SF148', NULL, NULL, NULL, NULL, 'SECRETED FRIZZLED-RELATED PROTEIN 1', 251896),
(416634, 'PTHR11309:SF146', NULL, NULL, NULL, NULL, 'FRIZZLED 8A PROTEIN-RELATED', 251896),
(416635, 'PTHR11309:SF147', NULL, NULL, NULL, NULL, 'FRIZZLED CLASS RECEPTOR 5', 251896),
(416636, 'PTHR11309:SF144', NULL, NULL, NULL, NULL, 'FRIZZLED CLASS RECEPTOR 3A', 251896),
(416637, 'PTHR11309:SF142', NULL, NULL, NULL, NULL, 'FRIZZLED-3', 251896),
(416638, 'PTHR11309:SF143', NULL, NULL, NULL, NULL, 'SECRETED FRIZZLED-RELATED PROTEIN 2', 251896),
(416639, 'PTHR11309:SF81', NULL, NULL, NULL, NULL, 'FRIZZLED-1', 251896),
(416640, 'PTHR11309:SF86', NULL, NULL, NULL, NULL, 'FRIZZLED-10', 251896),
(416641, 'PTHR11309:SF87', NULL, NULL, NULL, NULL, 'SECRETED FRIZZLED-RELATED PROTEIN 1', 251896),
(416642, 'PTHR11309:SF128', NULL, NULL, NULL, NULL, 'SECRETED FRIZZLED-RELATED PROTEIN 2-LIKE', 251896),
(416643, 'PTHR11309:SF22', NULL, NULL, NULL, NULL, 'FRIZZLED-3', 251896),
(416644, 'PTHR11309:SF34', NULL, NULL, NULL, NULL, 'FRIZZLED-2', 251896),
(416645, 'PTHR11309:SF35', NULL, NULL, NULL, NULL, 'SMOOTHENED HOMOLOG', 251896),
(416646, 'PTHR11309:SF79', NULL, NULL, NULL, NULL, 'FRIZZLED-9', 251896),
(416647, 'PTHR11309', NULL, NULL, NULL, NULL, 'FRIZZLED', 251896),
(416648, 'PTHR24419', NULL, NULL, NULL, NULL, 'INTERLEUKIN-1 RECEPTOR-ASSOCIATED KINASE', 251897),
(416649, 'PTHR24419:SF18', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE HASPIN', 251897),
(416650, 'PTHR24419:SF7', NULL, NULL, NULL, NULL, 'INTERLEUKIN-1 RECEPTOR-ASSOCIATED KINASE 3', 251897),
(416651, 'PTHR24419:SF34', NULL, NULL, NULL, NULL, 'AGAP003062-PA', 251897),
(416652, 'PTHR24419:SF35', NULL, NULL, NULL, NULL, 'INTERLEUKIN-1 RECEPTOR-ASSOCIATED KINASE 4', 251897),
(416653, 'PTHR24419:SF2', NULL, NULL, NULL, NULL, 'INTERLEUKIN-1 RECEPTOR-ASSOCIATED KINASE-LIKE 2', 251897),
(416654, 'PTHR24419:SF1', NULL, NULL, NULL, NULL, 'INTERLEUKIN-1 RECEPTOR-ASSOCIATED KINASE 1', 251897),
(416655, 'PTHR24419:SF33', NULL, NULL, NULL, NULL, 'PROTEIN TUBE-RELATED', 251897),
(416656, 'PTHR35404', NULL, NULL, NULL, NULL, 'TRANSPOSASE OF TN10', 251898),
(416657, 'PTHR35404:SF8', NULL, NULL, NULL, NULL, 'DDE_TNP_1 DOMAIN-CONTAINING PROTEIN', 251898),
(416658, 'PTHR45834:SF9', NULL, NULL, NULL, NULL, '', 251899),
(416659, 'PTHR45834:SF7', NULL, NULL, NULL, NULL, 'DH DOMAIN-CONTAINING PROTEIN', 251899),
(416660, 'PTHR45834:SF8', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 4', 251899),
(416661, 'PTHR45834', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 9-RELATED', 251899),
(416662, 'PTHR45834:SF5', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 13', 251899),
(416663, 'PTHR45834:SF6', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 9', 251899),
(416664, 'PTHR45834:SF3', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 3, ISOFORM L', 251899);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(416665, 'PTHR45834:SF12', NULL, NULL, NULL, NULL, 'DH DOMAIN-CONTAINING PROTEIN', 251899),
(416666, 'PTHR45834:SF13', NULL, NULL, NULL, NULL, 'RHOGEF DOMAIN-CONTAINING PROTEIN GXCI', 251899),
(416667, 'PTHR45834:SF11', NULL, NULL, NULL, NULL, 'RHOGEF DOMAIN-CONTAINING PROTEIN GXCJ', 251899),
(416668, 'PTHR31026', NULL, NULL, NULL, NULL, 'ENHANCER OF UNCOORDINATION', 251900),
(416669, 'PTHR31026:SF1', NULL, NULL, NULL, NULL, 'ENHANCER OF UNCOORDINATION', 251900),
(416670, 'PTHR43463:SF1', NULL, NULL, NULL, NULL, 'NICOTINATE-NUCLEOTIDE--DIMETHYLBENZIMIDAZOLE PHOSPHORIBOSYLTRANSFERASE', 251901),
(416671, 'PTHR43463', NULL, NULL, NULL, NULL, 'NICOTINATE-NUCLEOTIDE--DIMETHYLBENZIMIDAZOLE PHOSPHORIBOSYLTRANSFERASE', 251901),
(416672, 'PTHR21695', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 251902),
(416673, 'PTHR21695:SF0', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 414', 251902),
(416674, 'PTHR43281:SF18', NULL, NULL, NULL, NULL, 'HETERODIMERIC GERANYLGERANYL PYROPHOSPHATE SYNTHASE LARGE SUBUNIT 2', 251903),
(416675, 'PTHR43281:SF29', NULL, NULL, NULL, NULL, 'BNAA04G13910D PROTEIN', 251903),
(416676, 'PTHR43281:SF28', NULL, NULL, NULL, NULL, 'GERANYLGERANYL PYROPHOSPHATE SYNTHASE, CHLOROPLASTIC-LIKE', 251903),
(416677, 'PTHR43281:SF17', NULL, NULL, NULL, NULL, 'GERANYLGERANYL PYROPHOSPHATE SYNTHASE 4', 251903),
(416678, 'PTHR43281:SF5', NULL, NULL, NULL, NULL, 'HETERODIMERIC GERANYLGERANYL PYROPHOSPHATE SYNTHASE SMALL SUBUNIT, CHLOROPLASTIC', 251903),
(416679, 'PTHR43281:SF6', NULL, NULL, NULL, NULL, 'HETERODIMERIC GERANYLGERANYL PYROPHOSPHATE SYNTHASE SMALL SUBUNIT, CHLOROPLASTIC-LIKE', 251903),
(416680, 'PTHR43281:SF27', NULL, NULL, NULL, NULL, 'GERANYLGERANYL PYROPHOSPHATE SYNTHASE 7, CHLOROPLASTIC-LIKE', 251903),
(416681, 'PTHR43281:SF26', NULL, NULL, NULL, NULL, 'BNAA01G29350D PROTEIN', 251903),
(416682, 'PTHR43281:SF24', NULL, NULL, NULL, NULL, 'GERANYLGERANYL PYROPHOSPHATE SYNTHASE 7, CHLOROPLASTIC', 251903),
(416683, 'PTHR43281:SF1', NULL, NULL, NULL, NULL, 'FARNESYL DIPHOSPHATE SYNTHASE', 251903),
(416684, 'PTHR43281:SF23', NULL, NULL, NULL, NULL, 'GERANYLGERANYL PYROPHOSPHATE SYNTHASE 3, CHLOROPLASTIC-RELATED', 251903),
(416685, 'PTHR43281:SF12', NULL, NULL, NULL, NULL, 'BNAA08G15440D PROTEIN', 251903),
(416686, 'PTHR43281:SF22', NULL, NULL, NULL, NULL, 'GERANYLGERANYL PYROPHOSPHATE SYNTHASE 6, MITOCHONDRIAL', 251903),
(416687, 'PTHR43281:SF11', NULL, NULL, NULL, NULL, 'GERANYLGERANYL PYROPHOSPHATE SYNTHASE 11, CHLOROPLASTIC-RELATED', 251903),
(416688, 'PTHR43281:SF21', NULL, NULL, NULL, NULL, 'GERANYLGERANYL PYROPHOSPHATE SYNTHASE, CHLOROPLASTIC-LIKE', 251903),
(416689, 'PTHR43281:SF32', NULL, NULL, NULL, NULL, 'HETERODIMERIC GERANYLGERANYL PYROPHOSPHATE SYNTHASE LARGE SUBUNIT 1, CHLOROPLASTIC', 251903),
(416690, 'PTHR43281:SF31', NULL, NULL, NULL, NULL, 'GERANYLGERANYL PYROPHOSPHATE SYNTHASE, CHLOROPLASTIC-RELATED', 251903),
(416691, 'PTHR43281:SF20', NULL, NULL, NULL, NULL, 'GERANYLGERANYL PYROPHOSPHATE SYNTHASE 10, MITOCHONDRIAL', 251903),
(416692, 'PTHR43281', NULL, NULL, NULL, NULL, 'FARNESYL DIPHOSPHATE SYNTHASE', 251903),
(416693, 'PTHR33048:SF18', NULL, NULL, NULL, NULL, '', 251904),
(416694, 'PTHR33048:SF19', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN PTH11-LIKE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G14080)-RELATED', 251904),
(416695, 'PTHR33048:SF152', NULL, NULL, NULL, NULL, '', 251904),
(416696, 'PTHR33048:SF151', NULL, NULL, NULL, NULL, '', 251904),
(416697, 'PTHR33048:SF57', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_4G00600)', 251904),
(416698, 'PTHR33048:SF15', NULL, NULL, NULL, NULL, '', 251904),
(416699, 'PTHR33048:SF156', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN', 251904),
(416700, 'PTHR33048:SF96', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN', 251904),
(416701, 'PTHR33048:SF155', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN', 251904),
(416702, 'PTHR33048:SF110', NULL, NULL, NULL, NULL, '', 251904),
(416703, 'PTHR33048:SF55', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN', 251904),
(416704, 'PTHR33048:SF92', NULL, NULL, NULL, NULL, '', 251904);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(416705, 'PTHR33048:SF115', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L36', 251904),
(416706, 'PTHR33048:SF93', NULL, NULL, NULL, NULL, '', 251904),
(416707, 'PTHR33048:SF159', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G02860)-RELATED', 251904),
(416708, 'PTHR33048:SF158', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN PTH11-LIKE, PUTATIVE-RELATED', 251904),
(416709, 'PTHR33048:SF114', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN PTH11-LIKE, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G06620)-RELATED', 251904),
(416710, 'PTHR33048:SF157', NULL, NULL, NULL, NULL, '', 251904),
(416711, 'PTHR33048:SF113', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G11560)-RELATED', 251904),
(416712, 'PTHR33048:SF141', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_5G00840)', 251904),
(416713, 'PTHR33048:SF140', NULL, NULL, NULL, NULL, 'ATPASE, PUTATIVE (EUROFUNG)-RELATED', 251904),
(416714, 'PTHR33048:SF47', NULL, NULL, NULL, NULL, 'PTH11-LIKE INTEGRAL MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_5G11245)-RELATED', 251904),
(416715, 'PTHR33048:SF42', NULL, NULL, NULL, NULL, '', 251904),
(416716, 'PTHR33048:SF143', NULL, NULL, NULL, NULL, 'CFEM DOMAIN-CONTAINING PROTEIN-RELATED', 251904),
(416717, 'PTHR33048:SF149', NULL, NULL, NULL, NULL, '', 251904),
(416718, 'PTHR33048:SF105', NULL, NULL, NULL, NULL, '', 251904),
(416719, 'PTHR33048:SF147', NULL, NULL, NULL, NULL, '', 251904),
(416720, 'PTHR33048:SF146', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN', 251904),
(416721, 'PTHR33048:SF108', NULL, NULL, NULL, NULL, '', 251904),
(416722, 'PTHR33048:SF30', NULL, NULL, NULL, NULL, 'FAMILY DECARBOXYLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G00920)-RELATED', 251904),
(416723, 'PTHR33048:SF134', NULL, NULL, NULL, NULL, '', 251904),
(416724, 'PTHR33048:SF31', NULL, NULL, NULL, NULL, '', 251904),
(416725, 'PTHR33048:SF132', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G07820)-RELATED', 251904),
(416726, 'PTHR33048:SF131', NULL, NULL, NULL, NULL, 'CFEM DOMAIN-CONTAINING PROTEIN', 251904),
(416727, 'PTHR33048', NULL, NULL, NULL, NULL, 'PTH11-LIKE INTEGRAL MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_5G11245)', 251904),
(416728, 'PTHR33048:SF2', NULL, NULL, NULL, NULL, '', 251904),
(416729, 'PTHR33048:SF163', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_8G05510)', 251904),
(416730, 'PTHR33048:SF162', NULL, NULL, NULL, NULL, '', 251904),
(416731, 'PTHR33048:SF161', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN', 251904),
(416732, 'PTHR33048:SF160', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN, PUTATIVE-RELATED', 251904),
(416733, 'PTHR33048:SF123', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN, PUTATIVE-RELATED', 251904),
(416734, 'PTHR33048:SF167', NULL, NULL, NULL, NULL, '', 251904),
(416735, 'PTHR33048:SF166', NULL, NULL, NULL, NULL, '', 251904),
(416736, 'PTHR33048:SF64', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN (PTH11), PUTATIVE-RELATED', 251904),
(416737, 'PTHR33048:SF165', NULL, NULL, NULL, NULL, '', 251904),
(416738, 'PTHR33048:SF21', NULL, NULL, NULL, NULL, '', 251904),
(416739, 'PTHR33048:SF164', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_5G13725)', 251904),
(416740, 'PTHR33048:SF124', NULL, NULL, NULL, NULL, 'YALI0A07623P', 251904),
(416741, 'PTHR33048:SF129', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_5G06670)', 251904),
(416742, 'PTHR33048:SF8', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN PTH11-LIKE, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G13715)-RELATED', 251904),
(416743, 'PTHR46639:SF2', NULL, NULL, NULL, NULL, 'DIENCEPHALON/MESENCEPHALON HOMEOBOX PROTEIN 1', 251905),
(416744, 'PTHR46639:SF4', NULL, NULL, NULL, NULL, 'ZGC:101100', 251905),
(416745, 'PTHR46639:SF3', NULL, NULL, NULL, NULL, 'DIENCEPHALON/MESENCEPHALON HOMEOBOX PROTEIN 1-A-RELATED', 251905),
(416746, 'PTHR46639', NULL, NULL, NULL, NULL, 'DIENCEPHALON/MESENCEPHALON HOMEOBOX PROTEIN 1', 251905),
(416747, 'PTHR21523:SF6', NULL, NULL, NULL, NULL, 'MLT-TEN (MLT-10) RELATED', 251906),
(416748, 'PTHR21523:SF39', NULL, NULL, NULL, NULL, 'MLT-TEN (MLT-10) RELATED', 251906);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(416749, 'PTHR21523:SF38', NULL, NULL, NULL, NULL, 'MLT-TEN (MLT-10) RELATED', 251906),
(416750, 'PTHR21523', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 251906),
(416751, 'PTHR21523:SF5', NULL, NULL, NULL, NULL, 'MLT-TEN (MLT-10) RELATED', 251906),
(416752, 'PTHR21523:SF37', NULL, NULL, NULL, NULL, 'PROTEIN CBR-MLT-10', 251906),
(416753, 'PTHR21523:SF9', NULL, NULL, NULL, NULL, 'MLT-TEN (MLT-10) RELATED', 251906),
(416754, 'PTHR21523:SF10', NULL, NULL, NULL, NULL, 'MLT-TEN (MLT-10) RELATED', 251906),
(416755, 'PTHR21523:SF43', NULL, NULL, NULL, NULL, 'GI11699', 251906),
(416756, 'PTHR21523:SF40', NULL, NULL, NULL, NULL, 'SALIVARY GLUE PROTEIN SGS-3', 251906),
(416757, 'PTHR21523:SF14', NULL, NULL, NULL, NULL, 'MLT-TEN (MLT-10) RELATED', 251906),
(416758, 'PTHR21523:SF12', NULL, NULL, NULL, NULL, 'MLT-TEN (MLT-10) RELATED', 251906),
(416759, 'PTHR21523:SF44', NULL, NULL, NULL, NULL, 'MLT-TEN (MLT-10) RELATED', 251906),
(416760, 'PTHR21523:SF2', NULL, NULL, NULL, NULL, 'MLT-TEN (MLT-10) RELATED', 251906),
(416761, 'PTHR22142:SF2', NULL, NULL, NULL, NULL, 'KINETOCHORE PROTEIN SPC24', 251907),
(416762, 'PTHR22142', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 251907),
(416763, 'PTHR14969:SF18', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID PHOSPHATASE 6', 251908),
(416764, 'PTHR14969:SF28', NULL, NULL, NULL, NULL, 'DIHYDROSPHINGOSINE 1-PHOSPHATE PHOSPHATASE LCB3-RELATED', 251908),
(416765, 'PTHR14969:SF39', NULL, NULL, NULL, NULL, 'ACIDPPC DOMAIN-CONTAINING PROTEIN', 251908),
(416766, 'PTHR14969:SF17', NULL, NULL, NULL, NULL, 'INACTIVE PHOSPHOLIPID PHOSPHATASE 7', 251908),
(416767, 'PTHR14969:SF54', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLGLYCEROPHOSPHATASE B', 251908),
(416768, 'PTHR14969:SF53', NULL, NULL, NULL, NULL, 'LIPID A 1-DIPHOSPHATE SYNTHASE', 251908),
(416769, 'PTHR14969:SF45', NULL, NULL, NULL, NULL, 'SPHINGOSINE-1-PHOSPHATE PHOSPHATASE 1', 251908),
(416770, 'PTHR14969:SF56', NULL, NULL, NULL, NULL, 'DECAPRENYLPHOSPHORYL-5-PHOSPHORIBOSE PHOSPHATASE RV3807C-RELATED', 251908),
(416771, 'PTHR14969:SF55', NULL, NULL, NULL, NULL, 'ACIDPPC DOMAIN-CONTAINING PROTEIN', 251908),
(416772, 'PTHR14969:SF14', NULL, NULL, NULL, NULL, 'SPHINGOSINE-1-PHOSPHATE PHOSPHATASE 2', 251908),
(416773, 'PTHR14969:SF13', NULL, NULL, NULL, NULL, 'AT30094P', 251908),
(416774, 'PTHR14969:SF57', NULL, NULL, NULL, NULL, 'BLL5203 PROTEIN', 251908),
(416775, 'PTHR14969:SF27', NULL, NULL, NULL, NULL, 'SI:CH211-212G7.6', 251908),
(416776, 'PTHR14969', NULL, NULL, NULL, NULL, 'SPHINGOSINE-1-PHOSPHATE PHOSPHOHYDROLASE', 251908),
(416777, 'PTHR14969:SF52', NULL, NULL, NULL, NULL, 'LIPID A 1-PHOSPHATASE', 251908),
(416778, 'PTHR31062:SF134', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416779, 'PTHR31062:SF257', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416780, 'PTHR31062:SF136', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416781, 'PTHR31062:SF252', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE PROTEIN 12-RELATED', 251909),
(416782, 'PTHR31062:SF131', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416783, 'PTHR31062:SF127', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416784, 'PTHR31062:SF247', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416785, 'PTHR31062:SF249', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE PROTEIN 5-RELATED', 251909),
(416786, 'PTHR31062:SF123', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE PROTEIN 14', 251909),
(416787, 'PTHR31062:SF244', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416788, 'PTHR31062:SF243', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE PROTEIN 4', 251909),
(416789, 'PTHR31062:SF122', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE PROTEIN 11-RELATED', 251909),
(416790, 'PTHR31062:SF125', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(416791, 'PTHR31062:SF245', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416792, 'PTHR31062:SF242', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416793, 'PTHR31062:SF241', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416794, 'PTHR31062:SF120', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE PROTEIN 10-RELATED', 251909),
(416795, 'PTHR31062:SF58', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416796, 'PTHR31062:SF277', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416797, 'PTHR31062:SF155', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE PROTEIN 21-RELATED', 251909),
(416798, 'PTHR31062:SF276', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416799, 'PTHR31062:SF279', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416800, 'PTHR31062:SF158', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416801, 'PTHR31062:SF278', NULL, NULL, NULL, NULL, 'GH16 DOMAIN-CONTAINING PROTEIN', 251909),
(416802, 'PTHR31062:SF157', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE PROTEIN 19-RELATED', 251909),
(416803, 'PTHR31062:SF273', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416804, 'PTHR31062:SF151', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416805, 'PTHR31062:SF272', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416806, 'PTHR31062:SF275', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416807, 'PTHR31062:SF153', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416808, 'PTHR31062:SF274', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416809, 'PTHR31062:SF280', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416810, 'PTHR31062:SF282', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE PROTEIN 23-RELATED', 251909),
(416811, 'PTHR31062:SF281', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416812, 'PTHR31062', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE PROTEIN 8-RELATED', 251909),
(416813, 'PTHR31062:SF49', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE PROTEIN 26-RELATED', 251909),
(416814, 'PTHR31062:SF149', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416815, 'PTHR31062:SF269', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416816, 'PTHR31062:SF145', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416817, 'PTHR31062:SF266', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416818, 'PTHR31062:SF144', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE PROTEIN 33-RELATED', 251909),
(416819, 'PTHR31062:SF268', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416820, 'PTHR31062:SF267', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416821, 'PTHR31062:SF146', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE PROTEIN 31', 251909),
(416822, 'PTHR31062:SF262', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416823, 'PTHR31062:SF141', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416824, 'PTHR31062:SF140', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416825, 'PTHR31062:SF263', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416826, 'PTHR31062:SF271', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416827, 'PTHR31062:SF270', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416828, 'PTHR31062:SF41', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(416829, 'PTHR31062:SF40', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416830, 'PTHR31062:SF45', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLYCOSYLASE/HYDROLASE PROTEIN 8', 251909),
(416831, 'PTHR31062:SF219', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416832, 'PTHR31062:SF218', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416833, 'PTHR31062:SF215', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416834, 'PTHR31062:SF217', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416835, 'PTHR31062:SF211', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416836, 'PTHR31062:SF179', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416837, 'PTHR31062:SF295', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416838, 'PTHR31062:SF294', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416839, 'PTHR31062:SF176', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE PROTEIN 15', 251909),
(416840, 'PTHR31062:SF175', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416841, 'PTHR31062:SF296', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416842, 'PTHR31062:SF181', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416843, 'PTHR31062:SF183', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416844, 'PTHR31062:SF207', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416845, 'PTHR31062:SF209', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416846, 'PTHR31062:SF203', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416847, 'PTHR31062:SF206', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416848, 'PTHR31062:SF205', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416849, 'PTHR31062:SF288', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE PROTEIN 30-RELATED', 251909),
(416850, 'PTHR31062:SF167', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416851, 'PTHR31062:SF166', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE PROTEIN 7-RELATED', 251909),
(416852, 'PTHR31062:SF287', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416853, 'PTHR31062:SF169', NULL, NULL, NULL, NULL, 'GH16 DOMAIN-CONTAINING PROTEIN', 251909),
(416854, 'PTHR31062:SF202', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416855, 'PTHR31062:SF201', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416856, 'PTHR31062:SF289', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416857, 'PTHR31062:SF168', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416858, 'PTHR31062:SF284', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416859, 'PTHR31062:SF283', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416860, 'PTHR31062:SF286', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE PROTEIN 25-RELATED', 251909),
(416861, 'PTHR31062:SF164', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE PROTEIN 24', 251909),
(416862, 'PTHR31062:SF285', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416863, 'PTHR31062:SF291', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE PROTEIN 28-RELATED', 251909),
(416864, 'PTHR31062:SF9', NULL, NULL, NULL, NULL, 'GLYCOSIDASE CRF2-RELATED', 251909),
(416865, 'PTHR31062:SF290', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE PROTEIN 29-RELATED', 251909),
(416866, 'PTHR31062:SF172', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(416867, 'PTHR31062:SF293', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416868, 'PTHR31062:SF292', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416869, 'PTHR31062:SF1', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE PROTEIN 8-RELATED', 251909),
(416870, 'PTHR31062:SF119', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416871, 'PTHR31062:SF16', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE PROTEIN 27-RELATED', 251909),
(416872, 'PTHR31062:SF116', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416873, 'PTHR31062:SF236', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416874, 'PTHR31062:SF238', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416875, 'PTHR31062:SF117', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416876, 'PTHR31062:SF18', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE PROTEIN 32-RELATED', 251909),
(416877, 'PTHR31062:SF233', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416878, 'PTHR31062:SF113', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416879, 'PTHR31062:SF234', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416880, 'PTHR31062:SF195', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416881, 'PTHR31062:SF231', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416882, 'PTHR31062:SF110', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416883, 'PTHR31062:SF230', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416884, 'PTHR31062:SF95', NULL, NULL, NULL, NULL, 'OS02G0280200 PROTEIN', 251909),
(416885, 'PTHR31062:SF108', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE PROTEIN 9', 251909),
(416886, 'PTHR31062:SF226', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416887, 'PTHR31062:SF227', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE 1-RELATED', 251909),
(416888, 'PTHR31062:SF222', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416889, 'PTHR31062:SF189', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416890, 'PTHR31062:SF221', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416891, 'PTHR31062:SF188', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE PROTEIN 22', 251909),
(416892, 'PTHR31062:SF103', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416893, 'PTHR31062:SF224', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416894, 'PTHR31062:SF223', NULL, NULL, NULL, NULL, 'GH16 DOMAIN-CONTAINING PROTEIN', 251909),
(416895, 'PTHR31062:SF185', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE PROTEIN 6-RELATED', 251909),
(416896, 'PTHR31062:SF186', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE', 251909),
(416897, 'PTHR31062:SF191', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE PROTEIN 16-RELATED', 251909),
(416898, 'PTHR31062:SF194', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE PROTEIN 3', 251909),
(416899, 'PTHR31062:SF190', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE PROTEIN 2-RELATED', 251909),
(416900, 'PTHR16108:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 40', 251910),
(416901, 'PTHR16108', NULL, NULL, NULL, NULL, '', 251910),
(416902, 'PTHR23301', NULL, NULL, NULL, NULL, 'CHITIN BINDING PERITROPHIN-A', 251911),
(416903, 'PTHR23301:SF0', NULL, NULL, NULL, NULL, 'CHITIN-BINDING TYPE-2 DOMAIN-CONTAINING PROTEIN', 251911),
(416904, 'PTHR23301:SF102', NULL, NULL, NULL, NULL, 'CHONDROITIN PROTEOGLYCAN 1', 251911),
(416905, 'PTHR23301:SF101', NULL, NULL, NULL, NULL, 'PROTEIN CBG05204', 251911);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(416906, 'PTHR23301:SF100', NULL, NULL, NULL, NULL, 'GASP, ISOFORM A', 251911),
(416907, 'PTHR23301:SF99', NULL, NULL, NULL, NULL, 'GH09355P-RELATED', 251911),
(416908, 'PTHR23301:SF77', NULL, NULL, NULL, NULL, 'CHONDROITIN PROTEOGLYCAN-2', 251911),
(416909, 'PTHR23301:SF105', NULL, NULL, NULL, NULL, 'CHITIN-BINDING DOMAIN PROTEIN CBD-1', 251911),
(416910, 'PTHR23301:SF104', NULL, NULL, NULL, NULL, 'BCDNA.GH02976', 251911),
(416911, 'PTHR23301:SF103', NULL, NULL, NULL, NULL, 'FI02047P', 251911),
(416912, 'PTHR23301:SF94', NULL, NULL, NULL, NULL, 'UTERINE LUMIN EXPRESSED/LOCAILIZED', 251911),
(416913, 'PTHR23301:SF93', NULL, NULL, NULL, NULL, 'MUCIN RELATED 89F, ISOFORM B', 251911),
(416914, 'PTHR23301:SF92', NULL, NULL, NULL, NULL, 'LD20793P', 251911),
(416915, 'PTHR23301:SF91', NULL, NULL, NULL, NULL, 'FI03257P-RELATED', 251911),
(416916, 'PTHR23301:SF98', NULL, NULL, NULL, NULL, 'PROTEIN OBSTRUCTOR-E', 251911),
(416917, 'PTHR23301:SF97', NULL, NULL, NULL, NULL, 'RE09177P', 251911),
(416918, 'PTHR23301:SF96', NULL, NULL, NULL, NULL, 'CHITINASE', 251911),
(416919, 'PTHR23301:SF95', NULL, NULL, NULL, NULL, 'EG:56G7.1 PROTEIN-RELATED', 251911),
(416920, 'PTHR46966', NULL, NULL, NULL, NULL, 'HOMEOBOX EXPRESSED IN ES CELLS 1', 251912),
(416921, 'PTHR46966:SF1', NULL, NULL, NULL, NULL, 'HOMEOBOX EXPRESSED IN ES CELLS 1', 251912),
(416922, 'PTHR35191', NULL, NULL, NULL, NULL, 'PROPHAGE SIDE TAIL FIBER PROTEIN HOMOLOG STFQ-RELATED', 251913),
(416923, 'PTHR35191:SF1', NULL, NULL, NULL, NULL, 'PROPHAGE SIDE TAIL FIBER PROTEIN HOMOLOG STFQ-RELATED', 251913),
(416924, 'PTHR13453:SF12', NULL, NULL, NULL, NULL, 'KAT8 REGULATORY NSL COMPLEX SUBUNIT 2', 251914),
(416925, 'PTHR13453:SF5', NULL, NULL, NULL, NULL, 'KAT8 REGULATORY NSL COMPLEX SUBUNIT 2', 251914),
(416926, 'PTHR13453:SF8', NULL, NULL, NULL, NULL, 'KAT8 REGULATORY NSL COMPLEX SUBUNIT 2', 251914),
(416927, 'PTHR13453:SF7', NULL, NULL, NULL, NULL, 'KAT8 REGULATORY NSL COMPLEX SUBUNIT 2', 251914),
(416928, 'PTHR13453:SF9', NULL, NULL, NULL, NULL, 'KAT8 REGULATORY NSL COMPLEX SUBUNIT 2', 251914),
(416929, 'PTHR13453:SF11', NULL, NULL, NULL, NULL, 'KAT8 REGULATORY NSL COMPLEX SUBUNIT 2', 251914),
(416930, 'PTHR13453:SF1', NULL, NULL, NULL, NULL, 'KAT8 REGULATORY NSL COMPLEX SUBUNIT 2', 251914),
(416931, 'PTHR13453', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 251914),
(416932, 'PTHR13609:SF20', NULL, NULL, NULL, NULL, 'UBIQUITIN DOMAIN-CONTAINING PROTEIN 2', 251915),
(416933, 'PTHR13609:SF21', NULL, NULL, NULL, NULL, 'OS09G0345000 PROTEIN', 251915),
(416934, 'PTHR13609:SF22', NULL, NULL, NULL, NULL, 'UBIQUITIN DOMAIN-CONTAINING PROTEIN-RELATED', 251915),
(416935, 'PTHR13609:SF11', NULL, NULL, NULL, NULL, 'UBIQUITIN DOMAIN-CONTAINING PROTEIN 1', 251915),
(416936, 'PTHR13609:SF34', NULL, NULL, NULL, NULL, 'UBIQUITIN DOMAIN-CONTAINING PROTEIN 1-LIKE', 251915),
(416937, 'PTHR13609', NULL, NULL, NULL, NULL, 'UBIQUITIN DOMAIN CONTAINING 1 PROTEIN-RELATED', 251915),
(416938, 'PTHR13609:SF4', NULL, NULL, NULL, NULL, 'RE42193P', 251915),
(416939, 'PTHR13609:SF39', NULL, NULL, NULL, NULL, 'UBIQUITIN DOMAIN-CONTAINING PROTEIN 1-LIKE', 251915),
(416940, 'PTHR13609:SF18', NULL, NULL, NULL, NULL, 'UBD DOMAIN-CONTAINING PROTEIN', 251915),
(416941, 'PTHR13609:SF29', NULL, NULL, NULL, NULL, 'UBD DOMAIN-CONTAINING PROTEIN', 251915),
(416942, 'PTHR13609:SF35', NULL, NULL, NULL, NULL, 'UBD DOMAIN-CONTAINING PROTEIN', 251915),
(416943, 'PTHR13609:SF36', NULL, NULL, NULL, NULL, 'UBIQUITIN DOMAIN-CONTAINING PROTEIN', 251915),
(416944, 'PTHR13609:SF15', NULL, NULL, NULL, NULL, 'OS05G0529400 PROTEIN', 251915),
(416945, 'PTHR13609:SF37', NULL, NULL, NULL, NULL, 'UBD DOMAIN-CONTAINING PROTEIN', 251915),
(416946, 'PTHR13609:SF38', NULL, NULL, NULL, NULL, 'UBIQUITIN DOMAIN-CONTAINING PROTEIN 1-LIKE', 251915),
(416947, 'PTHR15729:SF13', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 32', 251916),
(416948, 'PTHR15729:SF12', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 30', 251916),
(416949, 'PTHR15729', NULL, NULL, NULL, NULL, 'CDC42 GTPASE-ACTIVATING PROTEIN', 251916);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(416950, 'PTHR15729:SF11', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 33', 251916),
(416951, 'PTHR15729:SF10', NULL, NULL, NULL, NULL, 'GTPASE-ACTIVATING PROTEIN CDGAPR', 251916),
(416952, 'PTHR15729:SF3', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 31', 251916),
(416953, 'PTHR39599:SF2', NULL, NULL, NULL, NULL, 'ANCHORED PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G09650)-RELATED', 251917),
(416954, 'PTHR39599:SF1', NULL, NULL, NULL, NULL, 'GPI-ANCHORED PROTEIN (EUROFUNG)-RELATED', 251917),
(416955, 'PTHR39599', NULL, NULL, NULL, NULL, 'GPI-ANCHORED PROTEIN (EUROFUNG)-RELATED-RELATED', 251917),
(416956, 'PTHR35133:SF4', NULL, NULL, NULL, NULL, 'PROTEIN EFFECTOR OF TRANSCRIPTION 1', 251918),
(416957, 'PTHR35133', NULL, NULL, NULL, NULL, 'PROTEIN EFFECTOR OF TRANSCRIPTION 2-RELATED', 251918),
(416958, 'PTHR35133:SF1', NULL, NULL, NULL, NULL, 'PROTEIN EFFECTOR OF TRANSCRIPTION 2-RELATED', 251918),
(416959, 'PTHR35133:SF3', NULL, NULL, NULL, NULL, 'BNAC04G00960D PROTEIN', 251918),
(416960, 'PTHR14449', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA GROUP F PROTEIN FANCF', 251919),
(416961, 'PTHR14449:SF2', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA GROUP F PROTEIN', 251919),
(416962, 'PTHR28680', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN X', 251920),
(416963, 'PTHR28680:SF1', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN X', 251920),
(416964, 'PTHR13715:SF53', NULL, NULL, NULL, NULL, 'INOSITOL 1,4,5-TRISPHOSPHATE RECEPTOR TYPE 2', 251921),
(416965, 'PTHR13715:SF99', NULL, NULL, NULL, NULL, 'INOSITOL 1,4,5-TRISPHOSPHATE RECEPTOR', 251921),
(416966, 'PTHR13715:SF79', NULL, NULL, NULL, NULL, 'RYANODINE RECEPTOR', 251921),
(416967, 'PTHR13715', NULL, NULL, NULL, NULL, 'RYANODINE RECEPTOR AND IP3 RECEPTOR', 251921),
(416968, 'PTHR13715:SF100', NULL, NULL, NULL, NULL, '', 251921),
(416969, 'PTHR13715:SF51', NULL, NULL, NULL, NULL, 'INOSITOL 1,4,5-TRISPHOSPHATE RECEPTOR TYPE 3', 251921),
(416970, 'PTHR13715:SF52', NULL, NULL, NULL, NULL, 'INOSITOL 1,4,5-TRISPHOSPHATE RECEPTOR TYPE 1', 251921),
(416971, 'PTHR38495', NULL, NULL, NULL, NULL, 'MCG11474', 251922),
(416972, 'PTHR38495:SF1', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1700001K19 GENE', 251922),
(416973, 'PTHR36852:SF1', NULL, NULL, NULL, NULL, 'PROTEIN GVPL 2', 251923),
(416974, 'PTHR36852', NULL, NULL, NULL, NULL, '', 251923),
(416975, 'PTHR13812', NULL, NULL, NULL, NULL, 'KETIMINE REDUCTASE MU-CRYSTALLIN', 251924),
(416976, 'PTHR13812:SF23', NULL, NULL, NULL, NULL, 'PRNX PROTEIN', 251924),
(416977, 'PTHR13812:SF19', NULL, NULL, NULL, NULL, 'KETIMINE REDUCTASE MU-CRYSTALLIN', 251924),
(416978, 'PTHR37749', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 251925),
(416979, 'PTHR37749:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 251925),
(416980, 'PTHR43439:SF1', NULL, NULL, NULL, NULL, 'PHENYLACETATE-COENZYME A LIGASE', 251926),
(416981, 'PTHR43439:SF2', NULL, NULL, NULL, NULL, 'ENZYME, PUTATIVE (JCVI)-RELATED', 251926),
(416982, 'PTHR43439', NULL, NULL, NULL, NULL, 'PHENYLACETATE-COENZYME A LIGASE', 251926),
(416983, 'PTHR47634:SF3', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 251927),
(416984, 'PTHR47634:SF4', NULL, NULL, NULL, NULL, 'SRSF PROTEIN KINASE 1', 251927),
(416985, 'PTHR47634:SF5', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251927),
(416986, 'PTHR47634:SF6', NULL, NULL, NULL, NULL, 'SRSF PROTEIN KINASE 2', 251927),
(416987, 'PTHR47634:SF2', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251927),
(416988, 'PTHR47634', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN-RELATED', 251927),
(416989, 'PTHR47634:SF20', NULL, NULL, NULL, NULL, 'SRSF PROTEIN KINASE 3', 251927),
(416990, 'PTHR47634:SF11', NULL, NULL, NULL, NULL, 'SERINE KINASE-LIKE PROTEIN', 251927),
(416991, 'PTHR47634:SF10', NULL, NULL, NULL, NULL, 'SRSF PROTEIN KINASE 1-LIKE', 251927),
(416992, 'PTHR47634:SF17', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251927),
(416993, 'PTHR47634:SF16', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 251927);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(416994, 'PTHR47634:SF19', NULL, NULL, NULL, NULL, 'SRSF PROTEIN KINASE 1A', 251927),
(416995, 'PTHR47634:SF18', NULL, NULL, NULL, NULL, 'OS09G0552300 PROTEIN', 251927),
(416996, 'PTHR47634:SF13', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251927),
(416997, 'PTHR47634:SF7', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SRPK-LIKE', 251927),
(416998, 'PTHR47634:SF12', NULL, NULL, NULL, NULL, 'SRSF PROTEIN KINASE 1-LIKE', 251927),
(416999, 'PTHR47634:SF8', NULL, NULL, NULL, NULL, 'SERINE KINASE-LIKE PROTEIN', 251927),
(417000, 'PTHR47634:SF9', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN-RELATED', 251927),
(417001, 'PTHR47634:SF15', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251927),
(417002, 'PTHR47634:SF14', NULL, NULL, NULL, NULL, 'SERINE/THREONINE KINASE FAMILY PROTEIN', 251927),
(417003, 'PTHR21060', NULL, NULL, NULL, NULL, 'ACETATE KINASE', 251928),
(417004, 'PTHR21060:SF19', NULL, NULL, NULL, NULL, 'ACETATE KINASE', 251928),
(417005, 'PTHR21060:SF17', NULL, NULL, NULL, NULL, 'PROPIONATE KINASE', 251928),
(417006, 'PTHR21060:SF15', NULL, NULL, NULL, NULL, 'ACETATE KINASE', 251928),
(417007, 'PTHR21060:SF3', NULL, NULL, NULL, NULL, 'BUTYRATE KINASE 2-RELATED', 251928),
(417008, 'PTHR15351', NULL, NULL, NULL, NULL, 'ERLIN (ER LIPID RAFT ASSOCIATED PROTEIN) HOMOLOG', 251929),
(417009, 'PTHR15351:SF3', NULL, NULL, NULL, NULL, 'ERLIN', 251929),
(417010, 'PTHR15351:SF2', NULL, NULL, NULL, NULL, 'ERLIN-1', 251929),
(417011, 'PTHR15351:SF4', NULL, NULL, NULL, NULL, 'ERLIN-2', 251929),
(417012, 'PTHR11349:SF49', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE KINASE, MITOCHONDRIAL', 251930),
(417013, 'PTHR11349:SF97', NULL, NULL, NULL, NULL, 'NDK DOMAIN-CONTAINING PROTEIN', 251930),
(417014, 'PTHR11349:SF104', NULL, NULL, NULL, NULL, 'NUCLEOSIDE-DIPHOSPHATE KINASE', 251930),
(417015, 'PTHR11349:SF105', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE KINASE 1', 251930),
(417016, 'PTHR11349:SF99', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE KINASE 1', 251930),
(417017, 'PTHR11349:SF44', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE KINASE II, CHLOROPLASTIC', 251930),
(417018, 'PTHR11349:SF54', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE KINASE 3', 251930),
(417019, 'PTHR11349:SF57', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE KINASE B', 251930),
(417020, 'PTHR11349:SF108', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE KINASE', 251930),
(417021, 'PTHR11349:SF68', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE KINASE-RELATED', 251930),
(417022, 'PTHR11349:SF109', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE KINASE', 251930),
(417023, 'PTHR11349:SF67', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE KINASE', 251930),
(417024, 'PTHR11349:SF107', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE KINASE', 251930),
(417025, 'PTHR11349:SF69', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE KINASE A', 251930),
(417026, 'PTHR11349:SF91', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE KINASE', 251930),
(417027, 'PTHR11349:SF100', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE KINASE-RELATED', 251930),
(417028, 'PTHR11349:SF111', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE KINASE', 251930),
(417029, 'PTHR11349:SF101', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE KINASE III, CHLOROPLASTIC/MITOCHONDRIAL', 251930),
(417030, 'PTHR11349', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE KINASE', 251930),
(417031, 'PTHR11349:SF110', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE KINASE, MITOCHONDRIAL', 251930),
(417032, 'PTHR39321', NULL, NULL, NULL, NULL, 'NICOTINATE-NUCLEOTIDE ADENYLYLTRANSFERASE-RELATED', 251931),
(417033, 'PTHR39321:SF3', NULL, NULL, NULL, NULL, 'NICOTINATE-NUCLEOTIDE ADENYLYLTRANSFERASE-RELATED', 251931),
(417034, 'PTHR35258:SF1', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 22', 251932),
(417035, 'PTHR35258', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 22', 251932),
(417036, 'PTHR46538:SF1', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 251933);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(417037, 'PTHR46538', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251933),
(417038, 'PTHR46538:SF2', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 10', 251933),
(417039, 'PTHR46538:SF3', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251933),
(417040, 'PTHR16093:SF6', NULL, NULL, NULL, NULL, 'INNATE IMMUNITY ACTIVATOR B', 251934),
(417041, 'PTHR16093', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 120 FAMILY MEMBER', 251934),
(417042, 'PTHR16093:SF5', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 120', 251934),
(417043, 'PTHR16093:SF4', NULL, NULL, NULL, NULL, 'INNATE IMMUNITY ACTIVATOR PROTEIN', 251934),
(417044, 'PTHR36788:SF4', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 181-RELATED', 251935),
(417045, 'PTHR36788:SF3', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 171-RELATED', 251935),
(417046, 'PTHR36788:SF6', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN', 251935),
(417047, 'PTHR36788:SF5', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 172', 251935),
(417048, 'PTHR36788:SF2', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 183', 251935),
(417049, 'PTHR36788:SF8', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN', 251935),
(417050, 'PTHR36788:SF7', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN', 251935),
(417051, 'PTHR36788', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 183', 251935),
(417052, 'PTHR12053', NULL, NULL, NULL, NULL, 'PROTEASE FAMILY M28 PLASMA GLUTAMATE CARBOXYPEPTIDASE-RELATED', 251936),
(417053, 'PTHR12053:SF3', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE Q', 251936),
(417054, 'PTHR46817:SF2', NULL, NULL, NULL, NULL, 'SAC DOMAIN-CONTAINING PROTEIN-RELATED', 251937),
(417055, 'PTHR46817:SF1', NULL, NULL, NULL, NULL, 'SAC DOMAIN-CONTAINING PROTEIN', 251937),
(417056, 'PTHR46817', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHATASE SAC9-RELATED', 251937),
(417057, 'PTHR46072', NULL, NULL, NULL, NULL, 'AMIDASE-RELATED-RELATED', 251938),
(417058, 'PTHR46072:SF1', NULL, NULL, NULL, NULL, 'AMIDASE', 251938),
(417059, 'PTHR46072:SF6', NULL, NULL, NULL, NULL, 'AMIDASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G14530)-RELATED', 251938),
(417060, 'PTHR46072:SF10', NULL, NULL, NULL, NULL, 'ACETAMIDASE', 251938),
(417061, 'PTHR46072:SF7', NULL, NULL, NULL, NULL, 'AMIDASE-RELATED', 251938),
(417062, 'PTHR46072:SF11', NULL, NULL, NULL, NULL, 'AMIDASE-RELATED', 251938),
(417063, 'PTHR46072:SF8', NULL, NULL, NULL, NULL, 'AMIDASE DOMAIN-CONTAINING PROTEIN', 251938),
(417064, 'PTHR46072:SF9', NULL, NULL, NULL, NULL, 'ACETAMIDASE', 251938),
(417065, 'PTHR46072:SF2', NULL, NULL, NULL, NULL, 'AMIDASE (EUROFUNG)', 251938),
(417066, 'PTHR46072:SF3', NULL, NULL, NULL, NULL, 'AMIDASE', 251938),
(417067, 'PTHR46072:SF4', NULL, NULL, NULL, NULL, 'AMIDASE C550.07-RELATED', 251938),
(417068, 'PTHR46072:SF5', NULL, NULL, NULL, NULL, 'GENERAL AMIDASE-C', 251938),
(417069, 'PTHR13027:SF13', NULL, NULL, NULL, NULL, 'VACUOLAR FUSION PROTEIN MON1 HOMOLOG B', 251939),
(417070, 'PTHR13027:SF14', NULL, NULL, NULL, NULL, 'VACUOLAR FUSION PROTEIN MON1 HOMOLOG A', 251939),
(417071, 'PTHR13027:SF15', NULL, NULL, NULL, NULL, 'VACUOLAR FUSION PROTEIN MON1 HOMOLOG', 251939),
(417072, 'PTHR13027:SF7', NULL, NULL, NULL, NULL, 'VACUOLAR FUSION PROTEIN MON1 HOMOLOG', 251939),
(417073, 'PTHR13027:SF16', NULL, NULL, NULL, NULL, 'VACUOLAR FUSION PROTEIN MON1 HOMOLOG', 251939),
(417074, 'PTHR13027', NULL, NULL, NULL, NULL, 'SAND PROTEIN-RELATED', 251939),
(417075, 'PTHR31809:SF0', NULL, NULL, NULL, NULL, 'BUD13 HOMOLOG', 251940),
(417076, 'PTHR31809', NULL, NULL, NULL, NULL, 'BUD13 HOMOLOG', 251940),
(417077, 'PTHR37867:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 16 OPEN READING FRAME 86', 251941),
(417078, 'PTHR37867', NULL, NULL, NULL, NULL, 'CHROMOSOME 16 OPEN READING FRAME 86', 251941),
(417079, 'PTHR42953:SF7', NULL, NULL, NULL, NULL, 'MANGANESE-BINDING LIPOPROTEIN MNTA', 251942),
(417080, 'PTHR42953:SF8', NULL, NULL, NULL, NULL, 'ZINT DOMAIN-CONTAINING PROTEIN', 251942),
(417081, 'PTHR42953:SF2', NULL, NULL, NULL, NULL, 'ADHESION PROTEIN', 251942);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(417082, 'PTHR42953:SF3', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY ZINC UPTAKE SYSTEM PROTEIN ZNUA', 251942),
(417083, 'PTHR42953:SF4', NULL, NULL, NULL, NULL, 'IRON/ZINC/COPPER-BINDING PROTEIN', 251942),
(417084, 'PTHR42953:SF1', NULL, NULL, NULL, NULL, 'MANGANESE ABC TRANSPORTER SUBSTRATE-BINDING LIPOPROTEIN', 251942),
(417085, 'PTHR42953', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY ZINC UPTAKE SYSTEM PROTEIN ZNUA-RELATED', 251942),
(417086, 'PTHR24376:SF238', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 850', 251943),
(417087, 'PTHR24376:SF118', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 226', 251943),
(417088, 'PTHR24376:SF234', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 267', 251943),
(417089, 'PTHR24376:SF235', NULL, NULL, NULL, NULL, 'SI:DKEY-30K6.5-RELATED', 251943),
(417090, 'PTHR24376:SF236', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 48', 251943),
(417091, 'PTHR24376:SF159', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 26', 251943),
(417092, 'PTHR24376:SF237', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 268-RELATED', 251943),
(417093, 'PTHR24376:SF230', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 33B', 251943),
(417094, 'PTHR24376:SF154', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 208-RELATED', 251943),
(417095, 'PTHR24376:SF198', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 658-RELATED', 251943),
(417096, 'PTHR24376:SF231', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 717', 251943),
(417097, 'PTHR24376:SF232', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 227-RELATED', 251943),
(417098, 'PTHR24376:SF155', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 788', 251943),
(417099, 'PTHR24376:SF233', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 268', 251943),
(417100, 'PTHR24376:SF193', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 33A', 251943),
(417101, 'PTHR24376:SF194', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 615', 251943),
(417102, 'PTHR24376:SF84', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 521', 251943),
(417103, 'PTHR24376:SF80', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 780B-RELATED', 251943),
(417104, 'PTHR24376:SF48', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 484', 251943),
(417105, 'PTHR24376:SF85', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 600-RELATED', 251943),
(417106, 'PTHR24376:SF88', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 267', 251943),
(417107, 'PTHR24376:SF227', NULL, NULL, NULL, NULL, '', 251943),
(417108, 'PTHR24376:SF228', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 585B', 251943),
(417109, 'PTHR24376:SF229', NULL, NULL, NULL, NULL, 'ZGC:171220', 251943),
(417110, 'PTHR24376:SF223', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 457-RELATED', 251943),
(417111, 'PTHR24376:SF103', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 229', 251943),
(417112, 'PTHR24376:SF224', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 585A', 251943),
(417113, 'PTHR24376:SF104', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 52', 251943),
(417114, 'PTHR24376:SF225', NULL, NULL, NULL, NULL, '', 251943),
(417115, 'PTHR24376:SF226', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 616', 251943),
(417116, 'PTHR24376:SF220', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN CONTAINING 41', 251943),
(417117, 'PTHR24376:SF221', NULL, NULL, NULL, NULL, '', 251943),
(417118, 'PTHR24376:SF100', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 646', 251943),
(417119, 'PTHR24376:SF189', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 544-RELATED', 251943),
(417120, 'PTHR24376:SF222', NULL, NULL, NULL, NULL, 'SI:DKEY-33C14.6', 251943),
(417121, 'PTHR24376:SF185', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 786', 251943),
(417122, 'PTHR24376:SF190', NULL, NULL, NULL, NULL, 'SI:DKEY-89B17.4', 251943),
(417123, 'PTHR24376:SF93', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 473', 251943),
(417124, 'PTHR24376:SF94', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 229-RELATED', 251943),
(417125, 'PTHR24376:SF50', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 945', 251943),
(417126, 'PTHR24376:SF192', NULL, NULL, NULL, NULL, 'REPLICATION INITIATOR 1', 251943),
(417127, 'PTHR24376:SF95', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 319', 251943);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(417128, 'PTHR24376:SF90', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 112', 251943),
(417129, 'PTHR24376:SF52', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 423', 251943),
(417130, 'PTHR24376:SF99', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 51', 251943),
(417131, 'PTHR24376:SF216', NULL, NULL, NULL, NULL, 'FI03704P-RELATED', 251943),
(417132, 'PTHR24376:SF217', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 252-LIKE', 251943),
(417133, 'PTHR24376:SF218', NULL, NULL, NULL, NULL, '', 251943),
(417134, 'PTHR24376:SF219', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 594', 251943),
(417135, 'PTHR24376:SF212', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 197', 251943),
(417136, 'PTHR24376:SF27', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 40', 251943),
(417137, 'PTHR24376:SF215', NULL, NULL, NULL, NULL, 'FINGER PROTEIN, PUTATIVE-RELATED', 251943),
(417138, 'PTHR24376:SF210', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 721-RELATED', 251943),
(417139, 'PTHR24376:SF133', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 948', 251943),
(417140, 'PTHR24376:SF211', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 606', 251943),
(417141, 'PTHR24376:SF178', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 264', 251943),
(417142, 'PTHR24376', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 251943),
(417143, 'PTHR24376:SF130', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 384', 251943),
(417144, 'PTHR24376:SF68', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 493', 251943),
(417145, 'PTHR24376:SF69', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 574', 251943),
(417146, 'PTHR24376:SF205', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 770', 251943),
(417147, 'PTHR24376:SF128', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 836-RELATED', 251943),
(417148, 'PTHR24376:SF129', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 224-RELATED', 251943),
(417149, 'PTHR24376:SF207', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 782', 251943),
(417150, 'PTHR24376:SF38', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 445', 251943),
(417151, 'PTHR24376:SF201', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 771', 251943),
(417152, 'PTHR24376:SF39', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 658', 251943),
(417153, 'PTHR24376:SF203', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 467', 251943),
(417154, 'PTHR24376:SF121', NULL, NULL, NULL, NULL, '', 251943),
(417155, 'PTHR24376:SF123', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 672', 251943),
(417156, 'PTHR24376:SF161', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 60', 251943),
(417157, 'PTHR24376:SF70', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 668', 251943),
(417158, 'PTHR24376:SF71', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 99', 251943),
(417159, 'PTHR24376:SF78', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 629', 251943),
(417160, 'PTHR24376:SF79', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 107', 251943),
(417161, 'PTHR24376:SF74', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 845', 251943),
(417162, 'PTHR24376:SF77', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 62 HOMOLOG', 251943),
(417163, 'PTHR31855', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE EXCHANGE C9ORF72', 251944),
(417164, 'PTHR31855:SF2', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE EXCHANGE C9ORF72', 251944),
(417165, 'PTHR28055', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN 41, MITOCHONDRIAL', 251945),
(417166, 'PTHR28055:SF1', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN 41, MITOCHONDRIAL', 251945),
(417167, 'PTHR35263', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 49', 251946),
(417168, 'PTHR35263:SF1', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 49', 251946),
(417169, 'PTHR12821', NULL, NULL, NULL, NULL, 'BYSTIN', 251947),
(417170, 'PTHR12821:SF0', NULL, NULL, NULL, NULL, 'BYSTIN', 251947),
(417171, 'PTHR46448', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251948),
(417172, 'PTHR46448:SF3', NULL, NULL, NULL, NULL, 'EXTRACELLULAR TYROSINE-PROTEIN KINASE PKDCC', 251948),
(417173, 'PTHR46448:SF2', NULL, NULL, NULL, NULL, 'PIP49_C DOMAIN-CONTAINING PROTEIN', 251948); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(417174, 'PTHR46448:SF1', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251948),
(417175, 'PTHR31624', NULL, NULL, NULL, NULL, 'UPF0472 PROTEIN C16ORF72', 251949),
(417176, 'PTHR31624:SF4', NULL, NULL, NULL, NULL, 'UPF0472 PROTEIN C16ORF72 HOMOLOG-RELATED', 251949),
(417177, 'PTHR31624:SF3', NULL, NULL, NULL, NULL, 'UPF0472 PROTEIN C16ORF72', 251949),
(417178, 'PTHR31624:SF2', NULL, NULL, NULL, NULL, 'SIMILAR TO PRO0149 PROTEIN', 251949),
(417179, 'PTHR39399', NULL, NULL, NULL, NULL, 'PROTEIN ZPS1', 251950),
(417180, 'PTHR39399:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ZPS1', 251950),
(417181, 'PTHR47105:SF4', NULL, NULL, NULL, NULL, 'DREG-2', 251951),
(417182, 'PTHR47105:SF1', NULL, NULL, NULL, NULL, 'OS06G0665100 PROTEIN', 251951),
(417183, 'PTHR47105:SF2', NULL, NULL, NULL, NULL, '', 251951),
(417184, 'PTHR47105:SF3', NULL, NULL, NULL, NULL, 'BNAC09G18280D PROTEIN', 251951),
(417185, 'PTHR47105', NULL, NULL, NULL, NULL, 'OS02G0173600 PROTEIN', 251951),
(417186, 'PTHR34675:SF1', NULL, NULL, NULL, NULL, 'PROTEIN TRIGALACTOSYLDIACYLGLYCEROL 2, CHLOROPLASTIC', 251952),
(417187, 'PTHR34675:SF3', NULL, NULL, NULL, NULL, 'ABC-TYPE TRANSPORT SYSTEM PROTEIN', 251952),
(417188, 'PTHR34675:SF2', NULL, NULL, NULL, NULL, 'MLAD DOMAIN-CONTAINING PROTEIN', 251952),
(417189, 'PTHR34675', NULL, NULL, NULL, NULL, 'PROTEIN TRIGALACTOSYLDIACYLGLYCEROL 2, CHLOROPLASTIC', 251952),
(417190, 'PTHR13282:SF16', NULL, NULL, NULL, NULL, '7-DEHYDROCHOLESTEROL REDUCTASE', 251953),
(417191, 'PTHR13282', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 251953),
(417192, 'PTHR13282:SF14', NULL, NULL, NULL, NULL, 'PROTEIN FAM32A-LIKE', 251953),
(417193, 'PTHR13282:SF13', NULL, NULL, NULL, NULL, 'BNAA09G56160D PROTEIN', 251953),
(417194, 'PTHR13282:SF12', NULL, NULL, NULL, NULL, '', 251953),
(417195, 'PTHR13282:SF9', NULL, NULL, NULL, NULL, 'PROTEIN FAM32A', 251953),
(417196, 'PTHR13282:SF10', NULL, NULL, NULL, NULL, 'PROTEIN FAM32A', 251953),
(417197, 'PTHR13282:SF6', NULL, NULL, NULL, NULL, 'PROTEIN FAM32A', 251953),
(417198, 'PTHR13282:SF7', NULL, NULL, NULL, NULL, '', 251953),
(417199, 'PTHR13228', NULL, NULL, NULL, NULL, 'CONSERVED OLIGOMERIC GOLGI COMPLEX COMPONENT 5', 251954),
(417200, 'PTHR13228:SF3', NULL, NULL, NULL, NULL, 'CONSERVED OLIGOMERIC GOLGI COMPLEX SUBUNIT 5', 251954),
(417201, 'PTHR16485:SF6', NULL, NULL, NULL, NULL, 'MICROFIBRILLAR-ASSOCIATED PROTEIN 5', 251955),
(417202, 'PTHR16485', NULL, NULL, NULL, NULL, 'MICROFIBRILLAR-ASSOCIATED PROTEIN 2', 251955),
(417203, 'PTHR16485:SF3', NULL, NULL, NULL, NULL, 'MICROFIBRILLAR-ASSOCIATED PROTEIN 2', 251955),
(417204, 'PTHR13886:SF2', NULL, NULL, NULL, NULL, 'C-JUN-AMINO-TERMINAL KINASE-INTERACTING PROTEIN 4', 251956),
(417205, 'PTHR13886:SF3', NULL, NULL, NULL, NULL, 'C-JUN-AMINO-TERMINAL KINASE-INTERACTING PROTEIN 3', 251956),
(417206, 'PTHR13886:SF4', NULL, NULL, NULL, NULL, 'JNK-INTERACTING PROTEIN 3', 251956),
(417207, 'PTHR13886:SF7', NULL, NULL, NULL, NULL, 'SI:DKEY-17M8.1', 251956),
(417208, 'PTHR13886', NULL, NULL, NULL, NULL, 'JNK/SAPK-ASSOCIATED PROTEIN', 251956),
(417209, 'PTHR12663:SF60', NULL, NULL, NULL, NULL, '', 251957),
(417210, 'PTHR12663:SF61', NULL, NULL, NULL, NULL, '', 251957),
(417211, 'PTHR12663:SF62', NULL, NULL, NULL, NULL, '', 251957),
(417212, 'PTHR12663:SF63', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE-LIKE PROTEIN-RELATED', 251957),
(417213, 'PTHR12663:SF64', NULL, NULL, NULL, NULL, 'TUDOR/PWWP/MBT SUPERFAMILY PROTEIN', 251957),
(417214, 'PTHR12663:SF65', NULL, NULL, NULL, NULL, 'SISTER CHROMATID COHESION PDS5-LIKE PROTEIN', 251957),
(417215, 'PTHR12663:SF44', NULL, NULL, NULL, NULL, 'OS02G0612800 PROTEIN', 251957),
(417216, 'PTHR12663:SF23', NULL, NULL, NULL, NULL, 'T24D18.4', 251957),
(417217, 'PTHR12663:SF24', NULL, NULL, NULL, NULL, 'TUDOR DOMAIN-CONTAINING PROTEIN', 251957),
(417218, 'PTHR12663', NULL, NULL, NULL, NULL, 'ANDROGEN INDUCED INHIBITOR OF PROLIFERATION  AS3  / PDS5-RELATED', 251957),
(417219, 'PTHR12663:SF2', NULL, NULL, NULL, NULL, 'SISTER CHROMATID COHESION PROTEIN PDS5 HOMOLOG A', 251957),
(417220, 'PTHR12663:SF1', NULL, NULL, NULL, NULL, 'SISTER CHROMATID COHESION PROTEIN PDS5 HOMOLOG B', 251957);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(417221, 'PTHR12663:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR', 251957),
(417222, 'PTHR12663:SF50', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 251957),
(417223, 'PTHR12663:SF52', NULL, NULL, NULL, NULL, 'NUCLEIC ACID BINDING PROTEIN', 251957),
(417224, 'PTHR12663:SF54', NULL, NULL, NULL, NULL, 'SISTER CHROMATID COHESION PDS5-LIKE PROTEIN', 251957),
(417225, 'PTHR12663:SF55', NULL, NULL, NULL, NULL, 'TUDOR/PWWP/MBT SUPERFAMILY PROTEIN', 251957),
(417226, 'PTHR12663:SF33', NULL, NULL, NULL, NULL, '', 251957),
(417227, 'PTHR12663:SF56', NULL, NULL, NULL, NULL, '', 251957),
(417228, 'PTHR12663:SF35', NULL, NULL, NULL, NULL, 'BNAA06G10610D PROTEIN', 251957),
(417229, 'PTHR12663:SF57', NULL, NULL, NULL, NULL, '', 251957),
(417230, 'PTHR12663:SF58', NULL, NULL, NULL, NULL, 'BNAA06G35320D PROTEIN', 251957),
(417231, 'PTHR12663:SF36', NULL, NULL, NULL, NULL, 'BNAA05G13160D PROTEIN', 251957),
(417232, 'PTHR12663:SF59', NULL, NULL, NULL, NULL, 'BINDING PROTEIN-RELATED', 251957),
(417233, 'PTHR12663:SF0', NULL, NULL, NULL, NULL, 'PRECOCIOUS DISSOCIATION OF SISTERS 5, ISOFORM A', 251957),
(417234, 'PTHR19321:SF9', NULL, NULL, NULL, NULL, 'OS02G0720200 PROTEIN', 251958),
(417235, 'PTHR19321:SF22', NULL, NULL, NULL, NULL, '65-KDA MICROTUBULE-ASSOCIATED PROTEIN 3-LIKE ISOFORM X1', 251958),
(417236, 'PTHR19321:SF8', NULL, NULL, NULL, NULL, '', 251958),
(417237, 'PTHR19321:SF7', NULL, NULL, NULL, NULL, '65-KDA MICROTUBULE-ASSOCIATED PROTEIN 3', 251958),
(417238, 'PTHR19321:SF43', NULL, NULL, NULL, NULL, '65-KDA MICROTUBULE-ASSOCIATED PROTEIN 3-LIKE', 251958),
(417239, 'PTHR19321:SF21', NULL, NULL, NULL, NULL, '65-KDA MICROTUBULE-ASSOCIATED PROTEIN 2', 251958),
(417240, 'PTHR19321:SF46', NULL, NULL, NULL, NULL, '', 251958),
(417241, 'PTHR19321:SF6', NULL, NULL, NULL, NULL, 'ZGC:86764', 251958),
(417242, 'PTHR19321:SF24', NULL, NULL, NULL, NULL, '65-KDA MICROTUBULE-ASSOCIATED PROTEIN 9', 251958),
(417243, 'PTHR19321:SF23', NULL, NULL, NULL, NULL, '65-KDA MICROTUBULE-ASSOCIATED PROTEIN 7', 251958),
(417244, 'PTHR19321:SF4', NULL, NULL, NULL, NULL, '65-KDA MICROTUBULE-ASSOCIATED PROTEIN 5', 251958),
(417245, 'PTHR19321:SF48', NULL, NULL, NULL, NULL, 'BNAC03G14320D PROTEIN', 251958),
(417246, 'PTHR19321:SF47', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 251958),
(417247, 'PTHR19321:SF3', NULL, NULL, NULL, NULL, '65-KDA MICROTUBULE-ASSOCIATED PROTEIN 8', 251958),
(417248, 'PTHR19321:SF25', NULL, NULL, NULL, NULL, 'ASSOCIATED PROTEIN FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 251958),
(417249, 'PTHR19321:SF1', NULL, NULL, NULL, NULL, 'PROTEIN REGULATOR OF CYTOKINESIS 1', 251958),
(417250, 'PTHR19321:SF49', NULL, NULL, NULL, NULL, 'MICROTUBULE ASSOCIATED PROTEIN, MAP65/ASE1 FAMILY PROTEIN', 251958),
(417251, 'PTHR19321:SF20', NULL, NULL, NULL, NULL, '', 251958),
(417252, 'PTHR19321:SF41', NULL, NULL, NULL, NULL, 'FASCETTO-RELATED', 251958),
(417253, 'PTHR19321:SF33', NULL, NULL, NULL, NULL, 'BNAA04G15970D PROTEIN', 251958),
(417254, 'PTHR19321:SF32', NULL, NULL, NULL, NULL, 'BNAA02G09170D PROTEIN', 251958),
(417255, 'PTHR19321:SF54', NULL, NULL, NULL, NULL, '65-KDA MICROTUBULE-ASSOCIATED PROTEIN 3-LIKE', 251958),
(417256, 'PTHR19321:SF35', NULL, NULL, NULL, NULL, '65-KDA MICROTUBULE-ASSOCIATED PROTEIN 6-LIKE ISOFORM X1', 251958),
(417257, 'PTHR19321:SF13', NULL, NULL, NULL, NULL, 'OS02G0126300 PROTEIN', 251958),
(417258, 'PTHR19321:SF34', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN, MAP65/ASE1/PRC1-RELATED', 251958),
(417259, 'PTHR19321:SF37', NULL, NULL, NULL, NULL, '65-KDA MICROTUBULE-ASSOCIATED PROTEIN 1-LIKE', 251958),
(417260, 'PTHR19321:SF14', NULL, NULL, NULL, NULL, '65-KDA MICROTUBULE-ASSOCIATED PROTEIN 6', 251958),
(417261, 'PTHR19321:SF17', NULL, NULL, NULL, NULL, 'OS06G0308300 PROTEIN', 251958),
(417262, 'PTHR19321:SF16', NULL, NULL, NULL, NULL, '', 251958),
(417263, 'PTHR19321:SF0', NULL, NULL, NULL, NULL, '65-KDA MICROTUBULE-ASSOCIATED PROTEIN 6', 251958),
(417264, 'PTHR19321:SF51', NULL, NULL, NULL, NULL, 'BNAA02G26090D PROTEIN', 251958),
(417265, 'PTHR19321:SF50', NULL, NULL, NULL, NULL, '65-KDA MICROTUBULE-ASSOCIATED PROTEIN 4-LIKE', 251958);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(417266, 'PTHR19321:SF53', NULL, NULL, NULL, NULL, '65-KDA MICROTUBULE-ASSOCIATED PROTEIN 3-LIKE', 251958),
(417267, 'PTHR19321:SF52', NULL, NULL, NULL, NULL, '65-KDA MICROTUBULE-ASSOCIATED PROTEIN 4', 251958),
(417268, 'PTHR19321', NULL, NULL, NULL, NULL, 'PROTEIN REGULATOR OF CYTOKINESIS 1 PRC1-RELATED', 251958),
(417269, 'PTHR36742:SF1', NULL, NULL, NULL, NULL, 'MYOSIN-G HEAVY CHAIN-LIKE PROTEIN', 251959),
(417270, 'PTHR36742', NULL, NULL, NULL, NULL, 'MYOSIN-G HEAVY CHAIN-LIKE PROTEIN', 251959),
(417271, 'PTHR46378:SF1', NULL, NULL, NULL, NULL, 'STEROL REGULATORY ELEMENT-BINDING PROTEIN CLEAVAGE-ACTIVATING PROTEIN', 251960),
(417272, 'PTHR46378', NULL, NULL, NULL, NULL, 'STEROL REGULATORY ELEMENT-BINDING PROTEIN CLEAVAGE-ACTIVATING PROTEIN', 251960),
(417273, 'PTHR22012', NULL, NULL, NULL, NULL, 'FIBROUS SHEATH INTERACTING PROTEIN 1', 251961),
(417274, 'PTHR22012:SF2', NULL, NULL, NULL, NULL, 'FIBROUS SHEATH-INTERACTING PROTEIN 1', 251961),
(417275, 'PTHR35971', NULL, NULL, NULL, NULL, 'SI:DKEY-31G6.6', 251962),
(417276, 'PTHR35971:SF3', NULL, NULL, NULL, NULL, 'OBSCURIN-LIKE CYTOSKELETAL ADAPTOR 1A', 251962),
(417277, 'PTHR35971:SF5', NULL, NULL, NULL, NULL, 'OBSCURIN LIKE CYTOSKELETAL ADAPTOR 1B', 251962),
(417278, 'PTHR35971:SF4', NULL, NULL, NULL, NULL, 'OBSCURIN', 251962),
(417279, 'PTHR35971:SF6', NULL, NULL, NULL, NULL, 'OBSCURIN-LIKE PROTEIN 1', 251962),
(417280, 'PTHR38537:SF16', NULL, NULL, NULL, NULL, 'FILAMIN (ACTIN BINDING PROTEIN) HOMOLOG', 251963),
(417281, 'PTHR38537:SF5', NULL, NULL, NULL, NULL, 'FILAMIN-A', 251963),
(417282, 'PTHR38537:SF13', NULL, NULL, NULL, NULL, 'JITTERBUG, ISOFORM N', 251963),
(417283, 'PTHR38537:SF12', NULL, NULL, NULL, NULL, 'FILAMIN-C', 251963),
(417284, 'PTHR38537:SF15', NULL, NULL, NULL, NULL, 'REJ DOMAIN-CONTAINING PROTEIN', 251963),
(417285, 'PTHR38537:SF14', NULL, NULL, NULL, NULL, 'FILAMIN C, GAMMA A (ACTIN-BINDING PROTEIN 280)', 251963),
(417286, 'PTHR38537', NULL, NULL, NULL, NULL, 'JITTERBUG, ISOFORM N', 251963),
(417287, 'PTHR38537:SF7', NULL, NULL, NULL, NULL, 'FILAMIN-B', 251963),
(417288, 'PTHR38537:SF8', NULL, NULL, NULL, NULL, 'FILAMIN-A', 251963),
(417289, 'PTHR10424:SF8', NULL, NULL, NULL, NULL, 'ENDOGENOUS RETROVIRUS GROUP PABLB MEMBER 1 ENV POLYPROTEIN', 251964),
(417290, 'PTHR10424:SF72', NULL, NULL, NULL, NULL, 'ENVELOPE POLYPROTEIN-RELATED', 251964),
(417291, 'PTHR10424:SF60', NULL, NULL, NULL, NULL, 'HERV-H_2Q24.1 PROVIRUS ANCESTRAL ENV POLYPROTEIN-RELATED', 251964),
(417292, 'PTHR10424:SF74', NULL, NULL, NULL, NULL, 'ENDOGENOUS RETROVIRUS GROUP V MEMBER 1 ENV POLYPROTEIN-RELATED', 251964),
(417293, 'PTHR10424:SF73', NULL, NULL, NULL, NULL, 'ENDOGENOUS RETROVIRUS GROUP FC1 ENV POLYPROTEIN-RELATED', 251964),
(417294, 'PTHR10424:SF76', NULL, NULL, NULL, NULL, 'BC035947 PROTEIN', 251964),
(417295, 'PTHR10424:SF75', NULL, NULL, NULL, NULL, 'ENDOGENOUS RETROVIRUS GROUP S71 MEMBER 1 ENV POLYPROTEIN', 251964),
(417296, 'PTHR10424:SF78', NULL, NULL, NULL, NULL, 'ENDOGENOUS RETROVIRAL ENVELOPE PROTEIN HEMO', 251964),
(417297, 'PTHR10424', NULL, NULL, NULL, NULL, 'VIRAL ENVELOPE PROTEIN', 251964),
(417298, 'PTHR10424:SF77', NULL, NULL, NULL, NULL, 'SYNCYTIN-2', 251964),
(417299, 'PTHR10424:SF79', NULL, NULL, NULL, NULL, '', 251964),
(417300, 'PTHR10424:SF68', NULL, NULL, NULL, NULL, 'ENDOGENOUS RETROVIRUS GROUP 3 MEMBER 1 ENV POLYPROTEIN', 251964),
(417301, 'PTHR10424:SF48', NULL, NULL, NULL, NULL, 'SYNCYTIN-1', 251964),
(417302, 'PTHR40060:SF1', NULL, NULL, NULL, NULL, 'UPF0316 PROTEIN YEBE', 251965),
(417303, 'PTHR40060', NULL, NULL, NULL, NULL, 'UPF0316 PROTEIN YEBE', 251965),
(417304, 'PTHR36725', NULL, NULL, NULL, NULL, 'SENESCENCE-ASSOCIATED PROTEIN AAF, CHLOROLPLASTIC', 251966),
(417305, 'PTHR36725:SF1', NULL, NULL, NULL, NULL, 'SENESCENCE-ASSOCIATED PROTEIN AAF, CHLOROLPLASTIC', 251966),
(417306, 'PTHR36725:SF2', NULL, NULL, NULL, NULL, 'BNACNNG33590D PROTEIN', 251966),
(417307, 'PTHR44420:SF5', NULL, NULL, NULL, NULL, 'DEHYDROASCORBATE REDUCTASE', 251967),
(417308, 'PTHR44420:SF6', NULL, NULL, NULL, NULL, 'REDUCTASE, PUTATIVE-RELATED', 251967);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(417309, 'PTHR44420:SF3', NULL, NULL, NULL, NULL, 'DEHYDROASCORBATE REDUCTASE', 251967),
(417310, 'PTHR44420:SF4', NULL, NULL, NULL, NULL, 'F18O14.31-RELATED', 251967),
(417311, 'PTHR44420:SF1', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE DHAR3, CHLOROPLASTIC', 251967),
(417312, 'PTHR44420:SF2', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE DHAR2-RELATED', 251967),
(417313, 'PTHR44420', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE DHAR2-RELATED', 251967),
(417314, 'PTHR23347:SF4', NULL, NULL, NULL, NULL, 'COLORECTAL MUTANT CANCER PROTEIN', 251968),
(417315, 'PTHR23347:SF5', NULL, NULL, NULL, NULL, 'USHER SYNDROME TYPE-1C PROTEIN-BINDING PROTEIN 1', 251968),
(417316, 'PTHR23347:SF6', NULL, NULL, NULL, NULL, 'FI17904P1', 251968),
(417317, 'PTHR23347', NULL, NULL, NULL, NULL, 'COLORECTAL MUTANT CANCER PROTEIN  MCC PROTEIN -RELATED', 251968),
(417318, 'PTHR31459:SF24', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN GROUP 2', 251969),
(417319, 'PTHR31459:SF23', NULL, NULL, NULL, NULL, 'WHY DOMAIN-CONTAINING PROTEIN', 251969),
(417320, 'PTHR31459:SF22', NULL, NULL, NULL, NULL, '', 251969),
(417321, 'PTHR31459:SF28', NULL, NULL, NULL, NULL, 'WHY DOMAIN-CONTAINING PROTEIN', 251969),
(417322, 'PTHR31459:SF27', NULL, NULL, NULL, NULL, 'BNAC04G50740D PROTEIN', 251969),
(417323, 'PTHR31459:SF16', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN', 251969),
(417324, 'PTHR31459:SF15', NULL, NULL, NULL, NULL, 'DESICCATION PROTECTANT PROTEIN LEA14', 251969),
(417325, 'PTHR31459:SF26', NULL, NULL, NULL, NULL, 'CHILLING-RESPONSIVE PROTEIN', 251969),
(417326, 'PTHR31459:SF25', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN LEA14-1', 251969),
(417327, 'PTHR31459:SF19', NULL, NULL, NULL, NULL, 'DESICCATION-RELATED PROTEIN LEA14-RELATED', 251969),
(417328, 'PTHR31459:SF18', NULL, NULL, NULL, NULL, 'BNAC04G00870D PROTEIN', 251969),
(417329, 'PTHR31459:SF29', NULL, NULL, NULL, NULL, 'LEA5', 251969),
(417330, 'PTHR31459', NULL, NULL, NULL, NULL, '', 251969),
(417331, 'PTHR31459:SF2', NULL, NULL, NULL, NULL, 'OS03G0843300 PROTEIN', 251969),
(417332, 'PTHR31459:SF3', NULL, NULL, NULL, NULL, 'OS01G0225600 PROTEIN', 251969),
(417333, 'PTHR31459:SF20', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS (LEA)-LIKE PROTEIN', 251969),
(417334, 'PTHR22571:SF50', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 251970),
(417335, 'PTHR22571:SF25', NULL, NULL, NULL, NULL, 'HORNERIN', 251970),
(417336, 'PTHR22571', NULL, NULL, NULL, NULL, 'FILAGGRIN-RELATED', 251970),
(417337, 'PTHR22571:SF24', NULL, NULL, NULL, NULL, 'FILAGGRIN-2', 251970),
(417338, 'PTHR22571:SF51', NULL, NULL, NULL, NULL, 'FILAGGRIN', 251970),
(417339, 'PTHR33463:SF178', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 251971),
(417340, 'PTHR33463:SF134', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 251971),
(417341, 'PTHR33463:SF135', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 251971),
(417342, 'PTHR33463:SF179', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 251971),
(417343, 'PTHR33463:SF82', NULL, NULL, NULL, NULL, '', 251971),
(417344, 'PTHR33463:SF136', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RPS2-LIKE ISOFORM X1', 251971),
(417345, 'PTHR33463:SF137', NULL, NULL, NULL, NULL, '', 251971),
(417346, 'PTHR33463:SF138', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 251971),
(417347, 'PTHR33463:SF139', NULL, NULL, NULL, NULL, '', 251971),
(417348, 'PTHR33463:SF81', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RPS2-LIKE', 251971),
(417349, 'PTHR33463:SF170', NULL, NULL, NULL, NULL, '', 251971),
(417350, 'PTHR33463:SF171', NULL, NULL, NULL, NULL, '', 251971),
(417351, 'PTHR33463', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN-RELATED', 251971),
(417352, 'PTHR33463:SF172', NULL, NULL, NULL, NULL, 'DOMAIN-CONTAINING DISEASE RESISTANCE PROTEIN, PUTATIVE-RELATED', 251971),
(417353, 'PTHR33463:SF173', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 251971);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(417354, 'PTHR33463:SF87', NULL, NULL, NULL, NULL, '', 251971),
(417355, 'PTHR33463:SF174', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RPS2-LIKE', 251971),
(417356, 'PTHR33463:SF175', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 251971),
(417357, 'PTHR33463:SF176', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 251971),
(417358, 'PTHR33463:SF88', NULL, NULL, NULL, NULL, 'OS04G0431700 PROTEIN', 251971),
(417359, 'PTHR33463:SF133', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RPS2-LIKE', 251971),
(417360, 'PTHR33463:SF177', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN DISEASE RESISTANCE PROTEIN', 251971),
(417361, 'PTHR33463:SF167', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 251971),
(417362, 'PTHR33463:SF168', NULL, NULL, NULL, NULL, '', 251971),
(417363, 'PTHR33463:SF169', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 251971),
(417364, 'PTHR33463:SF127', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 251971),
(417365, 'PTHR33463:SF70', NULL, NULL, NULL, NULL, '', 251971),
(417366, 'PTHR33463:SF160', NULL, NULL, NULL, NULL, '', 251971),
(417367, 'PTHR33463:SF161', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE FAMILY PROTEIN, PUTATIVE-RELATED', 251971),
(417368, 'PTHR33463:SF162', NULL, NULL, NULL, NULL, '', 251971),
(417369, 'PTHR33463:SF37', NULL, NULL, NULL, NULL, '', 251971),
(417370, 'PTHR33463:SF163', NULL, NULL, NULL, NULL, 'RPP4C3', 251971),
(417371, 'PTHR33463:SF164', NULL, NULL, NULL, NULL, '', 251971),
(417372, 'PTHR33463:SF165', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 251971),
(417373, 'PTHR33463:SF121', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 251971),
(417374, 'PTHR33463:SF34', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RPS2', 251971),
(417375, 'PTHR33463:SF166', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 251971),
(417376, 'PTHR33463:SF28', NULL, NULL, NULL, NULL, 'VTA1 DOMAIN-CONTAINING PROTEIN', 251971),
(417377, 'PTHR33463:SF156', NULL, NULL, NULL, NULL, 'DOMAIN-CONTAINING DISEASE RESISTANCE PROTEIN, PUTATIVE-RELATED', 251971),
(417378, 'PTHR33463:SF157', NULL, NULL, NULL, NULL, '', 251971),
(417379, 'PTHR33463:SF60', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 251971),
(417380, 'PTHR33463:SF158', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 251971),
(417381, 'PTHR33463:SF159', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 251971),
(417382, 'PTHR33463:SF116', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 251971),
(417383, 'PTHR33463:SF117', NULL, NULL, NULL, NULL, 'CC-NBS-LRR RESISTANCE PROTEIN', 251971),
(417384, 'PTHR33463:SF150', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 251971),
(417385, 'PTHR33463:SF27', NULL, NULL, NULL, NULL, '', 251971),
(417386, 'PTHR33463:SF151', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 251971),
(417387, 'PTHR33463:SF152', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING DISEASE RESISTANCE PROTEIN', 251971),
(417388, 'PTHR33463:SF64', NULL, NULL, NULL, NULL, '', 251971),
(417389, 'PTHR33463:SF153', NULL, NULL, NULL, NULL, '', 251971),
(417390, 'PTHR33463:SF154', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 251971),
(417391, 'PTHR33463:SF67', NULL, NULL, NULL, NULL, '', 251971),
(417392, 'PTHR33463:SF22', NULL, NULL, NULL, NULL, '', 251971),
(417393, 'PTHR33463:SF155', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 251971),
(417394, 'PTHR33463:SF145', NULL, NULL, NULL, NULL, 'CC-NBS-LRR RESISTANCE-LIKE PROTEIN', 251971),
(417395, 'PTHR33463:SF93', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 251971),
(417396, 'PTHR33463:SF146', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE RPH8A-LIKE PROTEIN', 251971),
(417397, 'PTHR33463:SF147', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 251971),
(417398, 'PTHR33463:SF103', NULL, NULL, NULL, NULL, 'OS04G0166000 PROTEIN', 251971),
(417399, 'PTHR33463:SF96', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (CC-NBS-LRR CLASS) FAMILY PROTEIN', 251971),
(417400, 'PTHR33463:SF148', NULL, NULL, NULL, NULL, 'OS04G0115650 PROTEIN', 251971);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(417401, 'PTHR33463:SF105', NULL, NULL, NULL, NULL, 'RPP4C3', 251971),
(417402, 'PTHR33463:SF90', NULL, NULL, NULL, NULL, '', 251971),
(417403, 'PTHR33463:SF149', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 251971),
(417404, 'PTHR33463:SF140', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 251971),
(417405, 'PTHR33463:SF141', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 251971),
(417406, 'PTHR33463:SF142', NULL, NULL, NULL, NULL, 'OS01G0518651 PROTEIN', 251971),
(417407, 'PTHR33463:SF143', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 251971),
(417408, 'PTHR33463:SF144', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 251971),
(417409, 'PTHR47560', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251972),
(417410, 'PTHR47560:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251972),
(417411, 'PTHR37398', NULL, NULL, NULL, NULL, 'ENDO-BETA-1,4-MANNANASE', 251973),
(417412, 'PTHR37398:SF3', NULL, NULL, NULL, NULL, 'CELLULASE DOMAIN-CONTAINING PROTEIN', 251973),
(417413, 'PTHR19332:SF1', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN PEX13', 251974),
(417414, 'PTHR19332:SF7', NULL, NULL, NULL, NULL, 'PEROXIN-13', 251974),
(417415, 'PTHR19332:SF10', NULL, NULL, NULL, NULL, 'PEROXIN-13', 251974),
(417416, 'PTHR19332:SF12', NULL, NULL, NULL, NULL, 'PEROXIN-13', 251974),
(417417, 'PTHR19332', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN PEX13', 251974),
(417418, 'PTHR37959:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG15758', 251975),
(417419, 'PTHR37959', NULL, NULL, NULL, NULL, 'PROTEIN CBG15758', 251975),
(417420, 'PTHR37959:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG01966', 251975),
(417421, 'PTHR47007:SF1', NULL, NULL, NULL, NULL, 'SUSHI DOMAIN-CONTAINING PROTEIN 4', 251976),
(417422, 'PTHR47007', NULL, NULL, NULL, NULL, 'SUSHI DOMAIN-CONTAINING PROTEIN 4', 251976),
(417423, 'PTHR13520:SF0', NULL, NULL, NULL, NULL, 'RAD50-INTERACTING PROTEIN 1', 251977),
(417424, 'PTHR13520:SF1', NULL, NULL, NULL, NULL, 'RINT1-LIKE PROTEIN MAG2', 251977),
(417425, 'PTHR13520', NULL, NULL, NULL, NULL, 'RAD50-INTERACTING PROTEIN 1 RINT-1', 251977),
(417426, 'PTHR47953:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71A9', 251978),
(417427, 'PTHR47953:SF5', NULL, NULL, NULL, NULL, 'OS06G0641600 PROTEIN', 251978),
(417428, 'PTHR47953:SF20', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 251978),
(417429, 'PTHR47953:SF13', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 251978),
(417430, 'PTHR47953:SF14', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 HYDROXYLASE', 251978),
(417431, 'PTHR47953:SF15', NULL, NULL, NULL, NULL, '', 251978),
(417432, 'PTHR47953', NULL, NULL, NULL, NULL, 'OS08G0105600 PROTEIN', 251978),
(417433, 'PTHR47953:SF16', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71D8', 251978),
(417434, 'PTHR47953:SF17', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71D7', 251978),
(417435, 'PTHR47953:SF18', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 251978),
(417436, 'PTHR47953:SF19', NULL, NULL, NULL, NULL, 'PREMNASPIRODIENE OXYGENASE-LIKE', 251978),
(417437, 'PTHR33187', NULL, NULL, NULL, NULL, 'WU:FI09B08', 251979),
(417438, 'PTHR33187:SF11', NULL, NULL, NULL, NULL, 'WU:FI09B08', 251979),
(417439, 'PTHR47270:SF13', NULL, NULL, NULL, NULL, 'HEAVY CHAIN-LIKE PROTEIN, PUTATIVE-RELATED', 251980),
(417440, 'PTHR47270:SF12', NULL, NULL, NULL, NULL, 'OS10G0547000 PROTEIN', 251980),
(417441, 'PTHR47270', NULL, NULL, NULL, NULL, 'PROTEIN MLP1-LIKE', 251980),
(417442, 'PTHR47270:SF11', NULL, NULL, NULL, NULL, 'EEIG1/EHBP1 N-TERMINAL DOMAIN-CONTAINING PROTEIN-RELATED', 251980),
(417443, 'PTHR47270:SF8', NULL, NULL, NULL, NULL, 'C2 NT-TYPE DOMAIN-CONTAINING PROTEIN', 251980),
(417444, 'PTHR47270:SF6', NULL, NULL, NULL, NULL, 'SARCOLEMMAL MEMBRANE-ASSOCIATED PROTEIN-LIKE ISOFORM X1', 251980),
(417445, 'PTHR47270:SF3', NULL, NULL, NULL, NULL, 'HYPOTETICAL PROTEIN', 251980),
(417446, 'PTHR46743:SF3', NULL, NULL, NULL, NULL, 'ABC-TYPE POLYSACCHARIDE/POLYOL PHOSPHATE TRANSPORT SYSTEM, ATPASE COMPONENT-RELATED', 251981),
(417447, 'PTHR46743:SF2', NULL, NULL, NULL, NULL, 'TEICHOIC ACIDS EXPORT ATP-BINDING PROTEIN TAGH', 251981);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(417448, 'PTHR46743', NULL, NULL, NULL, NULL, 'TEICHOIC ACIDS EXPORT ATP-BINDING PROTEIN TAGH', 251981),
(417449, 'PTHR11680:SF62', NULL, NULL, NULL, NULL, 'SERINE HYDROXYMETHYLTRANSFERASE', 251982),
(417450, 'PTHR11680:SF50', NULL, NULL, NULL, NULL, 'SERINE HYDROXYMETHYLTRANSFERASE', 251982),
(417451, 'PTHR11680:SF61', NULL, NULL, NULL, NULL, 'SERINE HYDROXYMETHYLTRANSFERASE, MITOCHONDRIAL', 251982),
(417452, 'PTHR11680:SF63', NULL, NULL, NULL, NULL, 'SERINE HYDROXYMETHYLTRANSFERASE 3, CHLOROPLASTIC', 251982),
(417453, 'PTHR11680:SF44', NULL, NULL, NULL, NULL, 'SERINE HYDROXYMETHYLTRANSFERASE', 251982),
(417454, 'PTHR11680:SF33', NULL, NULL, NULL, NULL, 'SERINE HYDROXYMETHYLTRANSFERASE', 251982),
(417455, 'PTHR11680:SF11', NULL, NULL, NULL, NULL, 'SERINE HYDROXYMETHYLTRANSFERASE', 251982),
(417456, 'PTHR11680:SF43', NULL, NULL, NULL, NULL, 'SERINE HYDROXYMETHYLTRANSFERASE 1, MITOCHONDRIAL', 251982),
(417457, 'PTHR11680:SF35', NULL, NULL, NULL, NULL, 'GLYCINE HYDROXYMETHYLTRANSFERASE', 251982),
(417458, 'PTHR11680:SF57', NULL, NULL, NULL, NULL, 'SERINE HYDROXYMETHYLTRANSFERASE, MITOCHONDRIAL', 251982),
(417459, 'PTHR11680:SF45', NULL, NULL, NULL, NULL, 'SERINE HYDROXYMETHYLTRANSFERASE', 251982),
(417460, 'PTHR11680:SF34', NULL, NULL, NULL, NULL, 'SERINE HYDROXYMETHYLTRANSFERASE', 251982),
(417461, 'PTHR11680:SF7', NULL, NULL, NULL, NULL, 'SERINE HYDROXYMETHYLTRANSFERASE 7', 251982),
(417462, 'PTHR11680:SF60', NULL, NULL, NULL, NULL, 'SERINE HYDROXYMETHYLTRANSFERASE 6', 251982),
(417463, 'PTHR11680:SF59', NULL, NULL, NULL, NULL, 'SERINE HYDROXYMETHYLTRANSFERASE, CYTOSOLIC', 251982),
(417464, 'PTHR11680:SF58', NULL, NULL, NULL, NULL, 'SERINE HYDROXYMETHYLTRANSFERASE, CYTOSOLIC-RELATED', 251982),
(417465, 'PTHR11680:SF36', NULL, NULL, NULL, NULL, 'SERINE HYDROXYMETHYLTRANSFERASE', 251982),
(417466, 'PTHR11680:SF28', NULL, NULL, NULL, NULL, 'SERINE HYDROXYMETHYLTRANSFERASE, MITOCHONDRIAL', 251982),
(417467, 'PTHR11680', NULL, NULL, NULL, NULL, 'SERINE HYDROXYMETHYLTRANSFERASE', 251982),
(417468, 'PTHR11680:SF18', NULL, NULL, NULL, NULL, 'SERINE HYDROXYMETHYLTRANSFERASE 2', 251982),
(417469, 'PTHR45928:SF3', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 25 MEMBER 34', 251983),
(417470, 'PTHR45928', NULL, NULL, NULL, NULL, 'RE38146P', 251983),
(417471, 'PTHR45928:SF2', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 25 MEMBER 35', 251983),
(417472, 'PTHR45928:SF1', NULL, NULL, NULL, NULL, 'RE38146P', 251983),
(417473, 'PTHR43327:SF40', NULL, NULL, NULL, NULL, 'PHB DOMAIN-CONTAINING PROTEIN', 251984),
(417474, 'PTHR43327:SF41', NULL, NULL, NULL, NULL, 'BAND 7 DOMAIN-CONTAINING PROTEIN-RELATED', 251984),
(417475, 'PTHR43327:SF39', NULL, NULL, NULL, NULL, 'PHB DOMAIN-CONTAINING PROTEIN', 251984),
(417476, 'PTHR43327:SF18', NULL, NULL, NULL, NULL, 'PHB DOMAIN-CONTAINING PROTEIN', 251984),
(417477, 'PTHR43327:SF31', NULL, NULL, NULL, NULL, 'HYPERSENSITIVE-INDUCED RESPONSE PROTEIN 2', 251984),
(417478, 'PTHR43327:SF54', NULL, NULL, NULL, NULL, 'BAND 7 DOMAIN-CONTAINING PROTEIN-RELATED', 251984),
(417479, 'PTHR43327:SF32', NULL, NULL, NULL, NULL, 'STOMATIN-LIKE PROTEIN 2, MITOCHONDRIAL', 251984),
(417480, 'PTHR43327:SF10', NULL, NULL, NULL, NULL, 'STOMATIN-LIKE PROTEIN 2, MITOCHONDRIAL', 251984),
(417481, 'PTHR43327:SF11', NULL, NULL, NULL, NULL, 'HYPERSENSITIVE-INDUCED RESPONSE PROTEIN 4', 251984),
(417482, 'PTHR43327:SF55', NULL, NULL, NULL, NULL, 'SPFH/BAND 7/PHB DOMAIN-CONTAINING MEMBRANE-ASSOCIATED PROTEIN FAMILY-RELATED', 251984),
(417483, 'PTHR43327:SF56', NULL, NULL, NULL, NULL, 'HYPERSENSITIVE-INDUCED RESPONSE PROTEIN 1', 251984),
(417484, 'PTHR43327:SF34', NULL, NULL, NULL, NULL, 'HYPERSENSITIVE-INDUCED RESPONSE PROTEIN 1-LIKE', 251984),
(417485, 'PTHR43327:SF57', NULL, NULL, NULL, NULL, 'HYPERSENSITIVE-INDUCED RESPONSE PROTEIN-LIKE PROTEIN 1', 251984),
(417486, 'PTHR43327:SF35', NULL, NULL, NULL, NULL, 'PHB DOMAIN-CONTAINING PROTEIN', 251984),
(417487, 'PTHR43327:SF36', NULL, NULL, NULL, NULL, 'HYPERSENSITIVE-INDUCED RESPONSE PROTEIN 1', 251984),
(417488, 'PTHR43327:SF38', NULL, NULL, NULL, NULL, 'PHB DOMAIN-CONTAINING PROTEIN', 251984);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(417489, 'PTHR43327', NULL, NULL, NULL, NULL, 'STOMATIN-LIKE PROTEIN 2, MITOCHONDRIAL', 251984),
(417490, 'PTHR43327:SF1', NULL, NULL, NULL, NULL, 'PHB DOMAIN-CONTAINING PROTEIN', 251984),
(417491, 'PTHR43327:SF51', NULL, NULL, NULL, NULL, 'HYPERSENSITIVE-INDUCED RESPONSE PROTEIN 3', 251984),
(417492, 'PTHR43327:SF30', NULL, NULL, NULL, NULL, 'PHB DOMAIN-CONTAINING PROTEIN', 251984),
(417493, 'PTHR43327:SF28', NULL, NULL, NULL, NULL, 'RESPONSE PROTEIN, PUTATIVE, EXPRESSED-RELATED', 251984),
(417494, 'PTHR43327:SF42', NULL, NULL, NULL, NULL, 'HYPERSENSITIVE-INDUCED RESPONSE PROTEIN 1-LIKE', 251984),
(417495, 'PTHR43327:SF5', NULL, NULL, NULL, NULL, 'BAND 7 PROTEIN', 251984),
(417496, 'PTHR43327:SF43', NULL, NULL, NULL, NULL, 'HYPERSENSITIVE-INDUCED RESPONSE PROTEIN 2-LIKE', 251984),
(417497, 'PTHR43327:SF44', NULL, NULL, NULL, NULL, 'PHB DOMAIN-CONTAINING PROTEIN', 251984),
(417498, 'PTHR43327:SF2', NULL, NULL, NULL, NULL, 'MODULATOR OF FTSH PROTEASE HFLK', 251984),
(417499, 'PTHR43327:SF3', NULL, NULL, NULL, NULL, 'PHB DOMAIN-CONTAINING PROTEIN', 251984),
(417500, 'PTHR43327:SF24', NULL, NULL, NULL, NULL, 'OS01G0588400 PROTEIN', 251984),
(417501, 'PTHR43327:SF8', NULL, NULL, NULL, NULL, 'PHB DOMAIN-CONTAINING PROTEIN', 251984),
(417502, 'PTHR43327:SF47', NULL, NULL, NULL, NULL, 'BAND 7 PROTEIN', 251984),
(417503, 'PTHR43327:SF9', NULL, NULL, NULL, NULL, 'PHB DOMAIN-CONTAINING PROTEIN', 251984),
(417504, 'PTHR43327:SF7', NULL, NULL, NULL, NULL, 'PHB DOMAIN-CONTAINING PROTEIN', 251984),
(417505, 'PTHR43327:SF27', NULL, NULL, NULL, NULL, 'HYPERSENSITIVE-INDUCED RESPONSE PROTEIN 1-LIKE', 251984),
(417506, 'PTHR18359', NULL, NULL, NULL, NULL, 'WD-REPEAT PROTEIN-RELATED', 251985),
(417507, 'PTHR18359:SF0', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RNA-ASSOCIATED PROTEIN 18 HOMOLOG', 251985),
(417508, 'PTHR18359:SF2', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RNA-ASSOCIATED PROTEIN 18 HOMOLOG', 251985),
(417509, 'PTHR18359:SF1', NULL, NULL, NULL, NULL, '', 251985),
(417510, 'PTHR35994:SF1', NULL, NULL, NULL, NULL, 'PLASTID TRANSCRIPTIONALLY ACTIVE PROTEIN 6, CHLOROPLASTIC', 251986),
(417511, 'PTHR35994', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251986),
(417512, 'PTHR10395:SF7', NULL, NULL, NULL, NULL, '5-HYDROXYISOURATE HYDROLASE', 251987),
(417513, 'PTHR10395:SF11', NULL, NULL, NULL, NULL, '5-HYDROXYISOURATE HYDROLASE', 251987),
(417514, 'PTHR10395:SF12', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN', 251987),
(417515, 'PTHR10395:SF13', NULL, NULL, NULL, NULL, '5-HYDROXYISOURATE HYDROLASE', 251987),
(417516, 'PTHR10395', NULL, NULL, NULL, NULL, 'URICASE AND TRANSTHYRETIN-RELATED', 251987),
(417517, 'PTHR16038:SF4', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 74', 251988),
(417518, 'PTHR16038:SF5', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 251988),
(417519, 'PTHR16038', NULL, NULL, NULL, NULL, 'NOP SEVEN ASSOCIATED PROTEIN 1', 251988),
(417520, 'PTHR42884:SF10', NULL, NULL, NULL, NULL, 'P/HOMO B DOMAIN-CONTAINING PROTEIN', 251989),
(417521, 'PTHR42884:SF11', NULL, NULL, NULL, NULL, 'FURIN (PAIRED BASIC AMINO ACID CLEAVING ENZYME) B', 251989),
(417522, 'PTHR42884:SF23', NULL, NULL, NULL, NULL, 'FURIN-LIKE PROTEASE 2', 251989),
(417523, 'PTHR42884:SF13', NULL, NULL, NULL, NULL, 'NEUROENDOCRINE CONVERTASE 2', 251989),
(417524, 'PTHR42884:SF14', NULL, NULL, NULL, NULL, 'NEUROENDOCRINE CONVERTASE 1', 251989),
(417525, 'PTHR42884:SF7', NULL, NULL, NULL, NULL, 'PROPROTEIN CONVERTASE SUBTILISIN/KEXIN TYPE 5', 251989),
(417526, 'PTHR42884:SF8', NULL, NULL, NULL, NULL, 'PROPROTEIN CONVERTASE SUBTILISIN/KEXIN TYPE 6', 251989),
(417527, 'PTHR42884:SF16', NULL, NULL, NULL, NULL, 'PROPROTEIN CONVERTASE SUBTILISIN/KEXIN TYPE 4', 251989),
(417528, 'PTHR42884:SF28', NULL, NULL, NULL, NULL, 'PROPROTEIN CONVERTASE SUBTILISIN/KEXIN TYPE 7', 251989),
(417529, 'PTHR42884:SF29', NULL, NULL, NULL, NULL, 'P/HOMO B DOMAIN-CONTAINING PROTEIN', 251989),
(417530, 'PTHR42884', NULL, NULL, NULL, NULL, 'PROPROTEIN CONVERTASE SUBTILISIN/KEXIN-RELATED', 251989),
(417531, 'PTHR42884:SF3', NULL, NULL, NULL, NULL, 'FURIN-LIKE PROTEASE 1, ISOFORMS 1/1-X/2', 251989);
INSERT INTO "PUBLIC"."MODEL" VALUES
(417532, 'PTHR42884:SF1', NULL, NULL, NULL, NULL, 'FURIN', 251989),
(417533, 'PTHR31904:SF1', NULL, NULL, NULL, NULL, 'BYPASS OF STOP CODON PROTEIN 5-RELATED', 251990),
(417534, 'PTHR31904', NULL, NULL, NULL, NULL, 'BYPASS OF STOP CODON PROTEIN 5-RELATED', 251990),
(417535, 'PTHR38013', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN/POLYSACCHARIDE METABOLISM', 251991),
(417536, 'PTHR38013:SF1', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN/POLYSACCHARIDE METABOLISM', 251991),
(417537, 'PTHR19877', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT I', 251992),
(417538, 'PTHR19877:SF9', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT I', 251992),
(417539, 'PTHR19877:SF19', NULL, NULL, NULL, NULL, 'SERINE-THREONINE KINASE RECEPTOR-ASSOCIATED PROTEIN', 251992),
(417540, 'PTHR19877:SF18', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 251992),
(417541, 'PTHR19877:SF17', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 251992),
(417542, 'PTHR19877:SF16', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 251992),
(417543, 'PTHR19877:SF1', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT I', 251992),
(417544, 'PTHR19877:SF11', NULL, NULL, NULL, NULL, 'F9L1.42 PROTEIN', 251992),
(417545, 'PTHR19877:SF10', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 251992),
(417546, 'PTHR19877:SF20', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 251992),
(417547, 'PTHR19877:SF15', NULL, NULL, NULL, NULL, 'SERINE-THREONINE KINASE RECEPTOR-ASSOCIATED PROTEIN-LIKE', 251992),
(417548, 'PTHR19877:SF13', NULL, NULL, NULL, NULL, 'SERINE-THREONINE KINASE RECEPTOR-ASSOCIATED PROTEIN', 251992),
(417549, 'PTHR19877:SF12', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 251992),
(417550, 'PTHR21749', NULL, NULL, NULL, NULL, 'PRION-LIKE- Q/N-RICH -DOMAIN-BEARING PROTEIN PROTEIN 24', 251993),
(417551, 'PTHR21749:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG05366', 251993),
(417552, 'PTHR21749:SF6', NULL, NULL, NULL, NULL, 'ACTIVIN_RECP DOMAIN-CONTAINING PROTEIN', 251993),
(417553, 'PTHR21749:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG03863', 251993),
(417554, 'PTHR21749:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG03867', 251993),
(417555, 'PTHR21749:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG12211', 251993),
(417556, 'PTHR21749:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG05367', 251993),
(417557, 'PTHR21749:SF4', NULL, NULL, NULL, NULL, 'PRION-LIKE-(Q/N-RICH)-DOMAIN-BEARING PROTEIN', 251993),
(417558, 'PTHR47612', NULL, NULL, NULL, NULL, 'TRICHOHYALIN-LIKE PROTEIN 1', 251994),
(417559, 'PTHR47612:SF1', NULL, NULL, NULL, NULL, 'TRICHOHYALIN-LIKE PROTEIN 1', 251994),
(417560, 'PTHR31156:SF11', NULL, NULL, NULL, NULL, 'SPEEDY PROTEIN E4', 251995),
(417561, 'PTHR31156:SF26', NULL, NULL, NULL, NULL, 'SPEEDY PROTEIN E1-RELATED', 251995),
(417562, 'PTHR31156:SF15', NULL, NULL, NULL, NULL, 'SPEEDY PROTEIN E2-RELATED', 251995),
(417563, 'PTHR31156:SF14', NULL, NULL, NULL, NULL, 'SPEEDY/RINGO CELL CYCLE REGULATOR FAMILY, MEMBER E4C', 251995),
(417564, 'PTHR31156:SF25', NULL, NULL, NULL, NULL, '4933411G11RIK PROTEIN', 251995),
(417565, 'PTHR31156', NULL, NULL, NULL, NULL, 'WBSCR19-LIKE PROTEIN', 251995),
(417566, 'PTHR21340:SF0', NULL, NULL, NULL, NULL, 'BIS(5''-NUCLEOSYL)-TETRAPHOSPHATASE [ASYMMETRICAL]', 251996),
(417567, 'PTHR21340:SF7', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 251996),
(417568, 'PTHR21340', NULL, NULL, NULL, NULL, 'DIADENOSINE 5,5-P1,P4-TETRAPHOSPHATE PYROPHOSPHOHYDROLASE MUTT', 251996),
(417569, 'PTHR38167:SF1', NULL, NULL, NULL, NULL, '', 251997),
(417570, 'PTHR38167', NULL, NULL, NULL, NULL, '', 251997),
(417571, 'PTHR34182:SF1', NULL, NULL, NULL, NULL, 'PROTEIN-EXPORT MEMBRANE PROTEIN SECG', 251998),
(417572, 'PTHR34182', NULL, NULL, NULL, NULL, 'PROTEIN-EXPORT MEMBRANE PROTEIN SECG', 251998),
(417573, 'PTHR42204:SF1', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN', 251999),
(417574, 'PTHR42204', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN', 251999);
INSERT INTO "PUBLIC"."MODEL" VALUES
(417575, 'PTHR48205:SF1', NULL, NULL, NULL, NULL, 'OS01G0742766 PROTEIN', 252000),
(417576, 'PTHR48205', NULL, NULL, NULL, NULL, 'OS01G0742766 PROTEIN', 252000),
(417577, 'PTHR46306', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN 9', 252001),
(417578, 'PTHR46306:SF1', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN 9', 252001),
(417579, 'PTHR12822:SF12', NULL, NULL, NULL, NULL, 'PROTEIN YIP', 252002),
(417580, 'PTHR12822:SF13', NULL, NULL, NULL, NULL, 'PROTEIN YIP', 252002),
(417581, 'PTHR12822', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252002),
(417582, 'PTHR12822:SF4', NULL, NULL, NULL, NULL, 'PROTEIN YIPF1', 252002),
(417583, 'PTHR12822:SF5', NULL, NULL, NULL, NULL, 'PROTEIN YIP', 252002),
(417584, 'PTHR12822:SF6', NULL, NULL, NULL, NULL, 'PROTEIN YIP', 252002),
(417585, 'PTHR12822:SF10', NULL, NULL, NULL, NULL, 'PROTEIN YIP', 252002),
(417586, 'PTHR12822:SF2', NULL, NULL, NULL, NULL, 'PROTEIN YIPF', 252002),
(417587, 'PTHR12822:SF3', NULL, NULL, NULL, NULL, 'PROTEIN YIPF2', 252002),
(417588, 'PTHR36449', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE-RELATED', 252003),
(417589, 'PTHR36449:SF1', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE-RELATED', 252003),
(417590, 'PTHR45934', NULL, NULL, NULL, NULL, 'FAD/NAD(P)-BINDING OXIDOREDUCTASE FAMILY PROTEIN', 252004),
(417591, 'PTHR45934:SF29', NULL, NULL, NULL, NULL, 'FAD_BINDING_3 DOMAIN-CONTAINING PROTEIN', 252004),
(417592, 'PTHR45934:SF17', NULL, NULL, NULL, NULL, 'FAD-DEPENDENT URATE HYDROXYLASE-LIKE', 252004),
(417593, 'PTHR45934:SF28', NULL, NULL, NULL, NULL, 'OS03G0153100 PROTEIN', 252004),
(417594, 'PTHR45934:SF16', NULL, NULL, NULL, NULL, 'MONOOXYGENASE 1', 252004),
(417595, 'PTHR45934:SF27', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE YETM ISOFORM X1-RELATED', 252004),
(417596, 'PTHR45934:SF26', NULL, NULL, NULL, NULL, 'MONOOXYGENASE 1', 252004),
(417597, 'PTHR45934:SF7', NULL, NULL, NULL, NULL, 'FAD/NAD(P)-BINDING OXIDOREDUCTASE FAMILY PROTEIN', 252004),
(417598, 'PTHR45934:SF8', NULL, NULL, NULL, NULL, 'FAD-DEPENDENT URATE HYDROXYLASE-LIKE ISOFORM X1', 252004),
(417599, 'PTHR45934:SF25', NULL, NULL, NULL, NULL, 'FAD_BINDING_3 DOMAIN-CONTAINING PROTEIN', 252004),
(417600, 'PTHR45934:SF9', NULL, NULL, NULL, NULL, 'FAD/NAD(P)-BINDING OXIDOREDUCTASE FAMILY PROTEIN', 252004),
(417601, 'PTHR45934:SF2', NULL, NULL, NULL, NULL, 'MONOOXYGENASE 1', 252004),
(417602, 'PTHR45934:SF4', NULL, NULL, NULL, NULL, 'FAD BINDING DOMAIN CONTAINING PROTEIN, EXPRESSED', 252004),
(417603, 'PTHR45934:SF10', NULL, NULL, NULL, NULL, 'FAD_BINDING_3 DOMAIN-CONTAINING PROTEIN', 252004),
(417604, 'PTHR45934:SF20', NULL, NULL, NULL, NULL, 'MONOOXYGENASE 2-RELATED', 252004),
(417605, 'PTHR45934:SF5', NULL, NULL, NULL, NULL, 'FAD BINDING DOMAIN CONTAINING PROTEIN, EXPRESSED', 252004),
(417606, 'PTHR45934:SF1', NULL, NULL, NULL, NULL, 'OS04G0423100 PROTEIN', 252004),
(417607, 'PTHR45840:SF8', NULL, NULL, NULL, NULL, 'RHOMBOID PROTEASE', 252005),
(417608, 'PTHR45840:SF9', NULL, NULL, NULL, NULL, 'INACTIVE RHOMBOID-RELATED PROTEIN 2', 252005),
(417609, 'PTHR45840:SF10', NULL, NULL, NULL, NULL, 'RHOMBOID PROTEASE', 252005),
(417610, 'PTHR45840:SF2', NULL, NULL, NULL, NULL, 'PROTEIN RHOMBOID-RELATED', 252005),
(417611, 'PTHR45840:SF6', NULL, NULL, NULL, NULL, 'RHOMBOID-RELATED PROTEIN 2', 252005),
(417612, 'PTHR45840', NULL, NULL, NULL, NULL, 'RHOMBOID-RELATED PROTEIN', 252005),
(417613, 'PTHR45840:SF4', NULL, NULL, NULL, NULL, 'RHOMBOID-RELATED PROTEIN 1', 252005),
(417614, 'PTHR45840:SF5', NULL, NULL, NULL, NULL, 'RHOMBOID-RELATED PROTEIN 3', 252005),
(417615, 'PTHR34686:SF1', NULL, NULL, NULL, NULL, 'MATERNAL EFFECT EMBRYO ARREST PROTEIN', 252006),
(417616, 'PTHR34686:SF5', NULL, NULL, NULL, NULL, 'OS05G0451300 PROTEIN', 252006),
(417617, 'PTHR34686:SF6', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252006),
(417618, 'PTHR34686', NULL, NULL, NULL, NULL, 'MATERNAL EFFECT EMBRYO ARREST PROTEIN', 252006),
(417619, 'PTHR31305', NULL, NULL, NULL, NULL, 'SNARE-ASSOCIATED PROTEIN SNAPIN', 252007),
(417620, 'PTHR31305:SF2', NULL, NULL, NULL, NULL, 'SNARE-ASSOCIATED PROTEIN SNAPIN', 252007);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(417621, 'PTHR40734', NULL, NULL, NULL, NULL, 'TRNA-SPECIFIC ADENOSINE DEAMINASE-RELATED', 252008),
(417622, 'PTHR40734:SF1', NULL, NULL, NULL, NULL, 'TRNA-SPECIFIC ADENOSINE DEAMINASE-RELATED', 252008),
(417623, 'PTHR34202:SF1', NULL, NULL, NULL, NULL, 'UPF0548 PROTEIN', 252009),
(417624, 'PTHR34202', NULL, NULL, NULL, NULL, 'UPF0548 PROTEIN', 252009),
(417625, 'PTHR37441:SF3', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR B0244.7-RELATED', 252010),
(417626, 'PTHR37441:SF2', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR B0244.10-RELATED', 252010),
(417627, 'PTHR37441:SF5', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 252010),
(417628, 'PTHR37441:SF4', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 252010),
(417629, 'PTHR37441', NULL, NULL, NULL, NULL, 'PROTEIN CBG16518', 252010),
(417630, 'PTHR37441:SF1', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR-LIKE PROTEIN B0244.6-RELATED', 252010),
(417631, 'PTHR37441:SF6', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 252010),
(417632, 'PTHR40468', NULL, NULL, NULL, NULL, 'YALI0A15257P', 252011),
(417633, 'PTHR40468:SF1', NULL, NULL, NULL, NULL, 'YALI0A15257P', 252011),
(417634, 'PTHR23179:SF3', NULL, NULL, NULL, NULL, 'RHO GTPASE ACTIVATING PROTEIN', 252012),
(417635, 'PTHR23179:SF28', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 20', 252012),
(417636, 'PTHR23179:SF39', NULL, NULL, NULL, NULL, 'GENE 1527-RELATED', 252012),
(417637, 'PTHR23179:SF27', NULL, NULL, NULL, NULL, 'RHO GTPASE ACTIVATING PROTEIN AT 71E, ISOFORM D', 252012),
(417638, 'PTHR23179:SF26', NULL, NULL, NULL, NULL, 'T-CELL ACTIVATION RHO GTPASE-ACTIVATING PROTEIN', 252012),
(417639, 'PTHR23179:SF37', NULL, NULL, NULL, NULL, '1700006A11RIK PROTEIN', 252012),
(417640, 'PTHR23179:SF36', NULL, NULL, NULL, NULL, 'RHO-GAP DOMAIN-CONTAINING PROTEIN', 252012),
(417641, 'PTHR23179', NULL, NULL, NULL, NULL, 'T-CELL ACTIVATION RHO GTPASE ACTIVATING PROTEIN-RELATED', 252012),
(417642, 'PTHR31121:SF14', NULL, NULL, NULL, NULL, 'O-GLYCOSIDE ALPHA-1,2-MANNOSYLTRANSFERASE HOMOLOG 6', 252013),
(417643, 'PTHR31121:SF2', NULL, NULL, NULL, NULL, 'MANNOSYLTRANSFERASE KTR5-RELATED', 252013),
(417644, 'PTHR31121:SF7', NULL, NULL, NULL, NULL, 'MANNOSYLTRANSFERASE KTR4-RELATED', 252013),
(417645, 'PTHR31121:SF12', NULL, NULL, NULL, NULL, 'O-GLYCOSIDE ALPHA-1,2-MANNOSYLTRANSFERASE HOMOLOG 5', 252013),
(417646, 'PTHR31121:SF8', NULL, NULL, NULL, NULL, 'GLYCOLIPID 2-ALPHA-MANNOSYLTRANSFERASE-RELATED', 252013),
(417647, 'PTHR31121:SF13', NULL, NULL, NULL, NULL, 'O-GLYCOSIDE ALPHA-1,2-MANNOSYLTRANSFERASE HOMOLOG 2', 252013),
(417648, 'PTHR31121', NULL, NULL, NULL, NULL, 'ALPHA-1,2 MANNOSYLTRANSFERASE KTR1', 252013),
(417649, 'PTHR31121:SF10', NULL, NULL, NULL, NULL, 'MANNOSYLTRANSFERASE KTR2-RELATED', 252013),
(417650, 'PTHR31121:SF6', NULL, NULL, NULL, NULL, 'ALPHA-1,2 MANNOSYLTRANSFERASE KTR1', 252013),
(417651, 'PTHR31121:SF11', NULL, NULL, NULL, NULL, 'MANNOSYLTRANSFERASE KTR3-RELATED', 252013),
(417652, 'PTHR44167:SF9', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE CHK2', 252014),
(417653, 'PTHR44167:SF18', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE', 252014),
(417654, 'PTHR44167:SF29', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE-43', 252014),
(417655, 'PTHR44167', NULL, NULL, NULL, NULL, 'OVARIAN-SPECIFIC SERINE/THREONINE-PROTEIN KINASE LOK-RELATED', 252014),
(417656, 'PTHR44167:SF24', NULL, NULL, NULL, NULL, 'OVARIAN-SPECIFIC SERINE/THREONINE-PROTEIN KINASE LOK', 252014),
(417657, 'PTHR44167:SF23', NULL, NULL, NULL, NULL, 'CDC7 KINASE, ISOFORM A-RELATED', 252014),
(417658, 'PTHR44167:SF22', NULL, NULL, NULL, NULL, 'DNA DAMAGE RESPONSE PROTEIN KINASE DUN1', 252014),
(417659, 'PTHR44167:SF10', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252014),
(417660, 'PTHR44167:SF28', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252014),
(417661, 'PTHR44167:SF17', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE FHKC-RELATED', 252014);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(417662, 'PTHR44167:SF8', NULL, NULL, NULL, NULL, 'DOUBLECORTIN-LIKE AND CAM KINASE-LIKE PROTEIN', 252014),
(417663, 'PTHR44167:SF27', NULL, NULL, NULL, NULL, 'PHOSPHORYLASE KINASE', 252014),
(417664, 'PTHR44167:SF26', NULL, NULL, NULL, NULL, 'PROTEIN KINASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G07950)-RELATED', 252014),
(417665, 'PTHR44167:SF6', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 33', 252014),
(417666, 'PTHR44167:SF25', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0283337-RELATED', 252014),
(417667, 'PTHR31719:SF162', NULL, NULL, NULL, NULL, 'NAC TRANSCRIPTION FACTOR 29-LIKE', 252015),
(417668, 'PTHR31719:SF160', NULL, NULL, NULL, NULL, 'NAC TRANSCRIPTION FACTOR 29-LIKE', 252015),
(417669, 'PTHR31719:SF121', NULL, NULL, NULL, NULL, 'NAC TRANSCRIPTION FACTOR-LIKE PROTEIN', 252015),
(417670, 'PTHR31719:SF166', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 252015),
(417671, 'PTHR31719:SF122', NULL, NULL, NULL, NULL, 'NAC TRANSCRIPTION FACTOR 32', 252015),
(417672, 'PTHR31719:SF164', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 252015),
(417673, 'PTHR31719:SF169', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 252015),
(417674, 'PTHR31719:SF203', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN-RELATED', 252015),
(417675, 'PTHR31719:SF167', NULL, NULL, NULL, NULL, '', 252015),
(417676, 'PTHR31719:SF123', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 252015),
(417677, 'PTHR31719:SF201', NULL, NULL, NULL, NULL, 'NAC TRANSCRIPTION FACTOR 47', 252015),
(417678, 'PTHR31719:SF168', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 252015),
(417679, 'PTHR31719:SF206', NULL, NULL, NULL, NULL, 'NAC TRANSCRIPTION FACTORS 75', 252015),
(417680, 'PTHR31719:SF127', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 2', 252015),
(417681, 'PTHR31719:SF192', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 252015),
(417682, 'PTHR31719:SF193', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 252015),
(417683, 'PTHR31719:SF231', NULL, NULL, NULL, NULL, 'NAC TRANSCRIPTION FACTOR 56-LIKE', 252015),
(417684, 'PTHR31719:SF154', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 252015),
(417685, 'PTHR31719:SF232', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 252015),
(417686, 'PTHR31719:SF199', NULL, NULL, NULL, NULL, 'NAC (NO APICAL MERISTEM) DOMAIN TRANSCRIPTIONAL REGULATOR SUPERFAMILY PROTEIN-RELATED', 252015),
(417687, 'PTHR31719:SF155', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 252015),
(417688, 'PTHR31719:SF197', NULL, NULL, NULL, NULL, 'OS05G0421600 PROTEIN', 252015),
(417689, 'PTHR31719:SF153', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 252015),
(417690, 'PTHR31719:SF230', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 252015),
(417691, 'PTHR31719:SF114', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 19', 252015),
(417692, 'PTHR31719:SF235', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 252015),
(417693, 'PTHR31719:SF159', NULL, NULL, NULL, NULL, 'OS05G0415400 PROTEIN', 252015),
(417694, 'PTHR31719:SF233', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 48', 252015),
(417695, 'PTHR31719:SF157', NULL, NULL, NULL, NULL, 'NAC TRANSCRIPTION FACTOR-LIKE PROTEIN', 252015),
(417696, 'PTHR31719:SF234', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 1', 252015),
(417697, 'PTHR31719:SF116', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 252015),
(417698, 'PTHR31719:SF88', NULL, NULL, NULL, NULL, 'OS07G0272700 PROTEIN', 252015),
(417699, 'PTHR31719:SF43', NULL, NULL, NULL, NULL, 'NAC TRANSCRIPTION FACTOR 56', 252015),
(417700, 'PTHR31719:SF85', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 252015),
(417701, 'PTHR31719:SF80', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 67', 252015),
(417702, 'PTHR31719:SF183', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 2', 252015),
(417703, 'PTHR31719:SF184', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 252015),
(417704, 'PTHR31719:SF181', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 104-LIKE', 252015);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(417705, 'PTHR31719:SF182', NULL, NULL, NULL, NULL, 'XYLEM NAC DOMAIN 1-RELATED', 252015),
(417706, 'PTHR31719:SF220', NULL, NULL, NULL, NULL, 'NAM-LIKE PROTEIN 1', 252015),
(417707, 'PTHR31719:SF221', NULL, NULL, NULL, NULL, 'NAC DOMAIN CONTAINING PROTEIN 97', 252015),
(417708, 'PTHR31719:SF186', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 68', 252015),
(417709, 'PTHR31719:SF224', NULL, NULL, NULL, NULL, 'PROTEIN ATAF2', 252015),
(417710, 'PTHR31719:SF103', NULL, NULL, NULL, NULL, 'OS09G0509100 PROTEIN', 252015),
(417711, 'PTHR31719:SF225', NULL, NULL, NULL, NULL, 'OS02G0555300 PROTEIN', 252015),
(417712, 'PTHR31719:SF148', NULL, NULL, NULL, NULL, 'NAC TRANSCRIPTION FACTOR 25', 252015),
(417713, 'PTHR31719:SF222', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 252015),
(417714, 'PTHR31719:SF223', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 101-LIKE', 252015),
(417715, 'PTHR31719:SF228', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 252015),
(417716, 'PTHR31719:SF107', NULL, NULL, NULL, NULL, 'OS02G0285900 PROTEIN', 252015),
(417717, 'PTHR31719:SF229', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 72', 252015),
(417718, 'PTHR31719:SF149', NULL, NULL, NULL, NULL, 'NAC TRANSCRIPTION FACTOR NAM-2', 252015),
(417719, 'PTHR31719:SF226', NULL, NULL, NULL, NULL, 'NAC TRANSCRIPTION FACTOR 29-LIKE ISOFORM X1', 252015),
(417720, 'PTHR31719:SF105', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 252015),
(417721, 'PTHR31719:SF106', NULL, NULL, NULL, NULL, 'DOMAIN TRANSCRIPTION FACTOR, PUTATIVE, EXPRESSED-RELATED', 252015),
(417722, 'PTHR31719:SF227', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 252015),
(417723, 'PTHR31719:SF219', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 2-LIKE', 252015),
(417724, 'PTHR31719:SF96', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 71', 252015),
(417725, 'PTHR31719:SF94', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 102', 252015),
(417726, 'PTHR31719:SF172', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 55', 252015),
(417727, 'PTHR31719:SF170', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 252015),
(417728, 'PTHR31719:SF176', NULL, NULL, NULL, NULL, 'NAC DOMAIN CONTAINING PROTEIN 84', 252015),
(417729, 'PTHR31719:SF177', NULL, NULL, NULL, NULL, 'OS11G0512200 PROTEIN', 252015),
(417730, 'PTHR31719:SF210', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 252015),
(417731, 'PTHR31719:SF130', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 18', 252015),
(417732, 'PTHR31719:SF175', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN JA2', 252015),
(417733, 'PTHR31719:SF213', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN', 252015),
(417734, 'PTHR31719:SF214', NULL, NULL, NULL, NULL, 'NAC TRANSCRIPTION FACTOR 29', 252015),
(417735, 'PTHR31719', NULL, NULL, NULL, NULL, 'NAC TRANSCRIPTION FACTOR 56', 252015),
(417736, 'PTHR31719:SF134', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 104', 252015),
(417737, 'PTHR31719:SF179', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 2', 252015),
(417738, 'PTHR31719:SF212', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 72-LIKE', 252015),
(417739, 'PTHR31719:SF217', NULL, NULL, NULL, NULL, 'NAC TRANSCRIPTION FACTOR-LIKE PROTEIN', 252015),
(417740, 'PTHR31719:SF218', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 104-LIKE ISOFORM X1', 252015),
(417741, 'PTHR31719:SF215', NULL, NULL, NULL, NULL, 'OS08G0148400 PROTEIN', 252015),
(417742, 'PTHR31719:SF216', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 68-LIKE', 252015),
(417743, 'PTHR31719:SF208', NULL, NULL, NULL, NULL, 'OS11G0126900 PROTEIN', 252015),
(417744, 'PTHR31719:SF209', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 68-LIKE', 252015),
(417745, 'PTHR12635:SF14', NULL, NULL, NULL, NULL, 'RHO GTPASE ACTIVATING PROTEIN 6', 252016),
(417746, 'PTHR12635:SF13', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 36', 252016),
(417747, 'PTHR12635:SF8', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 36', 252016);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(417748, 'PTHR12635', NULL, NULL, NULL, NULL, 'RHO-GTPASE-ACTIVATING PROTEIN 6 FAMILY MEMBER', 252016),
(417749, 'PTHR12635:SF6', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 6', 252016),
(417750, 'PTHR12635:SF7', NULL, NULL, NULL, NULL, 'RHO-GAP DOMAIN-CONTAINING PROTEIN', 252016),
(417751, 'PTHR16148:SF21', NULL, NULL, NULL, NULL, 'NEGATIVE RAS PROTEIN REGULATOR PROTEIN', 252017),
(417752, 'PTHR16148:SF22', NULL, NULL, NULL, NULL, 'G-PATCH DOMAIN-CONTAINING PROTEIN-RELATED', 252017),
(417753, 'PTHR16148:SF11', NULL, NULL, NULL, NULL, 'CDKN2A-INTERACTING PROTEIN', 252017),
(417754, 'PTHR16148:SF23', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN-RELATED', 252017),
(417755, 'PTHR16148:SF14', NULL, NULL, NULL, NULL, 'LD33178P', 252017),
(417756, 'PTHR16148:SF15', NULL, NULL, NULL, NULL, 'NF-KAPPA-B-REPRESSING FACTOR', 252017),
(417757, 'PTHR16148', NULL, NULL, NULL, NULL, 'NF-KAPPA-B-REPRESSING FACTOR-RELATED', 252017),
(417758, 'PTHR34369:SF8', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II 10 KDA POLYPEPTIDE, CHLOROPLASTIC', 252018),
(417759, 'PTHR34369:SF9', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II 10 KDA POLYPEPTIDE, CHLOROPLASTIC', 252018),
(417760, 'PTHR34369:SF6', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II 10 KDA POLYPEPTIDE, CHLOROPLASTIC', 252018),
(417761, 'PTHR34369:SF7', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II PROTEIN PSBR, CHLOROPLASTIC', 252018),
(417762, 'PTHR34369:SF2', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II 10 KDA POLYPEPTIDE, CHLOROPLASTIC', 252018),
(417763, 'PTHR34369', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II 10 KDA POLYPEPTIDE, CHLOROPLASTIC', 252018),
(417764, 'PTHR13281:SF0', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 70, MITOCHONDRIAL', 252019),
(417765, 'PTHR13281', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252019),
(417766, 'PTHR42682', NULL, NULL, NULL, NULL, 'HYDROGENASE-4 COMPONENT F', 252020),
(417767, 'PTHR42682:SF3', NULL, NULL, NULL, NULL, 'HYDROGENASE-4 COMPONENT B', 252020),
(417768, 'PTHR42682:SF4', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE/PLASTOQUINONE', 252020),
(417769, 'PTHR42682:SF1', NULL, NULL, NULL, NULL, 'FORMATE HYDROGENLYASE SUBUNIT 3', 252020),
(417770, 'PTHR42682:SF5', NULL, NULL, NULL, NULL, 'HYDROGENASE-4 COMPONENT F', 252020),
(417771, 'PTHR36313:SF3', NULL, NULL, NULL, NULL, '', 252021),
(417772, 'PTHR36313:SF2', NULL, NULL, NULL, NULL, '', 252021),
(417773, 'PTHR36313:SF1', NULL, NULL, NULL, NULL, 'PROTEIN GOLVEN 11-RELATED', 252021),
(417774, 'PTHR36313:SF7', NULL, NULL, NULL, NULL, '', 252021),
(417775, 'PTHR36313:SF6', NULL, NULL, NULL, NULL, 'OS09G0474600 PROTEIN', 252021),
(417776, 'PTHR36313:SF5', NULL, NULL, NULL, NULL, 'PROTEIN GOLVEN 5', 252021),
(417777, 'PTHR36313', NULL, NULL, NULL, NULL, 'ROOT MERISTEM GROWTH FACTOR 2', 252021),
(417778, 'PTHR11731:SF97', NULL, NULL, NULL, NULL, 'INACTIVE DIPEPTIDYL PEPTIDASE 10-LIKE', 252022),
(417779, 'PTHR11731:SF20', NULL, NULL, NULL, NULL, 'DIPEPTIDYL AMINOPEPTIDASE-LIKE PROTEIN 6', 252022),
(417780, 'PTHR11731:SF98', NULL, NULL, NULL, NULL, 'DIPEPTIDYL PEPTIDASE 8', 252022),
(417781, 'PTHR11731:SF21', NULL, NULL, NULL, NULL, 'INACTIVE DIPEPTIDYL PEPTIDASE 10', 252022),
(417782, 'PTHR11731:SF205', NULL, NULL, NULL, NULL, 'DIPEPTIDYL PEPTIDASE 4', 252022),
(417783, 'PTHR11731:SF128', NULL, NULL, NULL, NULL, 'DIPEPTIDYL PEPTIDASE 4', 252022),
(417784, 'PTHR11731:SF204', NULL, NULL, NULL, NULL, 'DIPEPTIDYL PEPTIDASE 4', 252022),
(417785, 'PTHR11731:SF118', NULL, NULL, NULL, NULL, 'BLR1971 PROTEIN', 252022),
(417786, 'PTHR11731:SF109', NULL, NULL, NULL, NULL, 'DIPEPTIDYL PEPTIDASE 9', 252022),
(417787, 'PTHR11731:SF154', NULL, NULL, NULL, NULL, 'VENOM DIPEPTIDYL PEPTIDASE 4-LIKE PROTEIN', 252022),
(417788, 'PTHR11731:SF187', NULL, NULL, NULL, NULL, 'INACTIVE DIPEPTIDYL PEPTIDASE 10-LIKE PROTEIN', 252022),
(417789, 'PTHR11731:SF201', NULL, NULL, NULL, NULL, 'DIPEPTIDYL-PEPTIDASE 6B', 252022),
(417790, 'PTHR11731:SF135', NULL, NULL, NULL, NULL, 'INACTIVE DIPEPTIDYL PEPTIDASE 10-LIKE PROTEIN', 252022),
(417791, 'PTHR11731:SF200', NULL, NULL, NULL, NULL, 'DIPEPTIDYL PEPTIDASE FAMILY MEMBER 1', 252022);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(417792, 'PTHR11731:SF203', NULL, NULL, NULL, NULL, 'PEPTIDASE S9 FAMILY', 252022),
(417793, 'PTHR11731:SF202', NULL, NULL, NULL, NULL, 'DIPEPTIDYL PEPTIDASE FAMILY MEMBER 2', 252022),
(417794, 'PTHR11731:SF136', NULL, NULL, NULL, NULL, 'PROLYL ENDOPEPTIDASE FAP', 252022),
(417795, 'PTHR11731', NULL, NULL, NULL, NULL, 'PROTEASE FAMILY S9B,C DIPEPTIDYL-PEPTIDASE IV-RELATED', 252022),
(417796, 'PTHR11731:SF193', NULL, NULL, NULL, NULL, 'DIPEPTIDYL-PEPTIDASE 9', 252022),
(417797, 'PTHR11731:SF160', NULL, NULL, NULL, NULL, 'DIPEPTIDYL AMINOPEPTIDASE A', 252022),
(417798, 'PTHR11731:SF192', NULL, NULL, NULL, NULL, 'IP17501P', 252022),
(417799, 'PTHR11731:SF162', NULL, NULL, NULL, NULL, 'DIPEPTIDYL PEPTIDASE 4-RELATED', 252022),
(417800, 'PTHR13267:SF3', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 277', 252023),
(417801, 'PTHR13267', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 277', 252023),
(417802, 'PTHR14898:SF4', NULL, NULL, NULL, NULL, 'ENHANCER OF POLYCOMB HOMOLOG 2', 252024),
(417803, 'PTHR14898:SF10', NULL, NULL, NULL, NULL, 'ENHANCER OF POLYCOMB-LIKE PROTEIN', 252024),
(417804, 'PTHR14898:SF6', NULL, NULL, NULL, NULL, 'ENHANCER OF POLYCOMB HOMOLOG 1', 252024),
(417805, 'PTHR14898:SF0', NULL, NULL, NULL, NULL, 'ENHANCER OF POLYCOMB-LIKE PROTEIN', 252024),
(417806, 'PTHR14898:SF2', NULL, NULL, NULL, NULL, 'ENHANCER OF POLYCOMB-LIKE PROTEIN', 252024),
(417807, 'PTHR14898', NULL, NULL, NULL, NULL, 'ENHANCER OF POLYCOMB', 252024),
(417808, 'PTHR14898:SF14', NULL, NULL, NULL, NULL, 'ENHANCER OF POLYCOMB-LIKE PROTEIN', 252024),
(417809, 'PTHR14898:SF15', NULL, NULL, NULL, NULL, 'ENHANCER OF POLYCOMB-LIKE PROTEIN', 252024),
(417810, 'PTHR14898:SF9', NULL, NULL, NULL, NULL, 'ENHANCER OF POLYCOMB-LIKE PROTEIN', 252024),
(417811, 'PTHR14898:SF13', NULL, NULL, NULL, NULL, 'OS01G0179500 PROTEIN', 252024),
(417812, 'PTHR22768', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252025),
(417813, 'PTHR22768:SF0', NULL, NULL, NULL, NULL, 'DNA REPLICATION COMPLEX GINS PROTEIN PSF3', 252025),
(417814, 'PTHR30368', NULL, NULL, NULL, NULL, 'SULFATE-BINDING PROTEIN', 252026),
(417815, 'PTHR30368:SF2', NULL, NULL, NULL, NULL, 'SULFATE-BINDING PROTEIN', 252026),
(417816, 'PTHR30368:SF1', NULL, NULL, NULL, NULL, 'THIOSULFATE-BINDING PROTEIN', 252026),
(417817, 'PTHR12336:SF0', NULL, NULL, NULL, NULL, 'ADULT CUTICLE PROTEIN 1-RELATED', 252027),
(417818, 'PTHR12336', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252027),
(417819, 'PTHR47826:SF1', NULL, NULL, NULL, NULL, 'OS03G0164700 PROTEIN', 252028),
(417820, 'PTHR47826', NULL, NULL, NULL, NULL, 'OS03G0164700 PROTEIN', 252028),
(417821, 'PTHR43498:SF1', NULL, NULL, NULL, NULL, 'COB--COM HETERODISULFIDE REDUCTASE IRON-SULFUR SUBUNIT A', 252029),
(417822, 'PTHR43498', NULL, NULL, NULL, NULL, 'FERREDOXIN:COB-COM HETERODISULFIDE REDUCTASE SUBUNIT A', 252029),
(417823, 'PTHR42282', NULL, NULL, NULL, NULL, 'PANTOATE KINASE-RELATED', 252030),
(417824, 'PTHR42282:SF1', NULL, NULL, NULL, NULL, 'PANTOATE KINASE', 252030),
(417825, 'PTHR36061', NULL, NULL, NULL, NULL, '', 252031),
(417826, 'PTHR36061:SF4', NULL, NULL, NULL, NULL, 'DUF3727 FAMILY PROTEIN', 252031),
(417827, 'PTHR36061:SF3', NULL, NULL, NULL, NULL, 'OS04G0692200 PROTEIN', 252031),
(417828, 'PTHR19857', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL DIVISION PROTEIN 1-RELATED', 252032),
(417829, 'PTHR19857:SF22', NULL, NULL, NULL, NULL, 'F-BOX/WD-40 REPEAT-CONTAINING PROTEIN', 252032),
(417830, 'PTHR19857:SF21', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 252032),
(417831, 'PTHR19857:SF20', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 252032),
(417832, 'PTHR19857:SF8', NULL, NULL, NULL, NULL, 'ANGIO-ASSOCIATED MIGRATORY CELL PROTEIN', 252032),
(417833, 'PTHR19857:SF19', NULL, NULL, NULL, NULL, '26S PROTEASOME REGULATORY SUBUNIT RPN14', 252032),
(417834, 'PTHR24286:SF336', NULL, NULL, NULL, NULL, 'CYTOCHROME P450-RELATED', 252033),
(417835, 'PTHR24286:SF335', NULL, NULL, NULL, NULL, 'OS07G0518100 PROTEIN', 252033),
(417836, 'PTHR24286:SF217', NULL, NULL, NULL, NULL, 'OS07G0520300 PROTEIN', 252033); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(417837, 'PTHR24286:SF337', NULL, NULL, NULL, NULL, '9/13 HYDROPEROXIDE LYASE', 252033),
(417838, 'PTHR24286:SF216', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 87 SUBFAMILY A POLYPEPTIDE 2', 252033),
(417839, 'PTHR24286:SF339', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN-RELATED', 252033),
(417840, 'PTHR24286:SF218', NULL, NULL, NULL, NULL, '', 252033),
(417841, 'PTHR24286:SF295', NULL, NULL, NULL, NULL, 'ENT-KAURENOIC ACID OXIDASE', 252033),
(417842, 'PTHR24286:SF294', NULL, NULL, NULL, NULL, 'BNAANNG05520D PROTEIN', 252033),
(417843, 'PTHR24286:SF330', NULL, NULL, NULL, NULL, 'CYTOCHROME P450-RELATED', 252033),
(417844, 'PTHR24286:SF176', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 STEROL 14 ALPHA-DEMETHYLASE', 252033),
(417845, 'PTHR24286:SF297', NULL, NULL, NULL, NULL, 'BETA-AMYRIN 28-OXIDASE-LIKE', 252033),
(417846, 'PTHR24286:SF296', NULL, NULL, NULL, NULL, 'P450, PUTATIVE-RELATED', 252033),
(417847, 'PTHR24286:SF299', NULL, NULL, NULL, NULL, 'BNAA03G01680D PROTEIN', 252033),
(417848, 'PTHR24286:SF331', NULL, NULL, NULL, NULL, 'BETA-AMYRIN 28-MONOOXYGENASE', 252033),
(417849, 'PTHR24286:SF177', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 26B1', 252033),
(417850, 'PTHR24286:SF210', NULL, NULL, NULL, NULL, '', 252033),
(417851, 'PTHR24286:SF298', NULL, NULL, NULL, NULL, 'BETA-AMYRIN 6-BETA-MONOOXYGENASE', 252033),
(417852, 'PTHR24286:SF333', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 85A1', 252033),
(417853, 'PTHR24286:SF53', NULL, NULL, NULL, NULL, 'BETA-AMYRIN 28-OXIDASE-LIKE', 252033),
(417854, 'PTHR24286:SF180', NULL, NULL, NULL, NULL, 'OS05G0211100 PROTEIN', 252033),
(417855, 'PTHR24286:SF105', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 85A-LIKE', 252033),
(417856, 'PTHR24286:SF226', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 SUPERFAMILY PROTEIN-RELATED', 252033),
(417857, 'PTHR24286:SF347', NULL, NULL, NULL, NULL, 'CYTOCHROME P450-RELATED', 252033),
(417858, 'PTHR24286:SF225', NULL, NULL, NULL, NULL, 'ENT-KAURENOIC ACID OXIDASE 1', 252033),
(417859, 'PTHR24286:SF349', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 716A1-RELATED', 252033),
(417860, 'PTHR24286:SF228', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 61', 252033),
(417861, 'PTHR24286:SF348', NULL, NULL, NULL, NULL, '', 252033),
(417862, 'PTHR24286:SF185', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 87A3-LIKE', 252033),
(417863, 'PTHR24286:SF184', NULL, NULL, NULL, NULL, 'OS02G0323600 PROTEIN', 252033),
(417864, 'PTHR24286:SF341', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 85A', 252033),
(417865, 'PTHR24286:SF220', NULL, NULL, NULL, NULL, 'ABSCISIC ACID 8''-HYDROXYLASE 2', 252033),
(417866, 'PTHR24286:SF340', NULL, NULL, NULL, NULL, 'P450, PUTATIVE-RELATED', 252033),
(417867, 'PTHR24286:SF101', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 26A1', 252033),
(417868, 'PTHR24286', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 26', 252033),
(417869, 'PTHR24286:SF189', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 722, SUBFAMILY A, POLYPEPTIDE 1', 252033),
(417870, 'PTHR24286:SF221', NULL, NULL, NULL, NULL, 'TAXADIENE 5-ALPHA HYDROXYLASE', 252033),
(417871, 'PTHR24286:SF100', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 26C1', 252033),
(417872, 'PTHR24286:SF345', NULL, NULL, NULL, NULL, 'ALLENE OXIDE SYNTHASE 2, CHLOROPLASTIC', 252033),
(417873, 'PTHR24286:SF223', NULL, NULL, NULL, NULL, 'ALLENE OXIDE SYNTHASE 3', 252033),
(417874, 'PTHR24286:SF344', NULL, NULL, NULL, NULL, 'OS07G0644600 PROTEIN', 252033),
(417875, 'PTHR24286:SF62', NULL, NULL, NULL, NULL, 'PHOMENOIC ACID BIOSYNTHESIS CLUSTER CYTOCHROME P450 MONOOXYGENASE', 252033),
(417876, 'PTHR24286:SF190', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 252033),
(417877, 'PTHR24286:SF191', NULL, NULL, NULL, NULL, 'LANOSTEROL 14-ALPHA DEMETHYLASE', 252033),
(417878, 'PTHR24286:SF65', NULL, NULL, NULL, NULL, 'OS04G0570600 PROTEIN', 252033),
(417879, 'PTHR24286:SF194', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 90B1', 252033),
(417880, 'PTHR24286:SF236', NULL, NULL, NULL, NULL, 'P450, PUTATIVE-RELATED', 252033),
(417881, 'PTHR24286:SF357', NULL, NULL, NULL, NULL, 'P450, PUTATIVE-RELATED', 252033);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(417882, 'PTHR24286:SF196', NULL, NULL, NULL, NULL, 'BETA-AMYRIN 11-OXIDASE-LIKE', 252033),
(417883, 'PTHR24286:SF350', NULL, NULL, NULL, NULL, 'BETA-AMYRIN 11-OXIDASE-LIKE', 252033),
(417884, 'PTHR24286:SF195', NULL, NULL, NULL, NULL, '', 252033),
(417885, 'PTHR24286:SF230', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 702, SUBFAMILY A, POLYPEPTIDE 5-RELATED', 252033),
(417886, 'PTHR24286:SF354', NULL, NULL, NULL, NULL, 'ABSCISIC ACID 8''-HYDROXYLASE 2', 252033),
(417887, 'PTHR24286:SF199', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 252033),
(417888, 'PTHR24286:SF232', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 SUPERFAMILY PROTEIN', 252033),
(417889, 'PTHR24286:SF356', NULL, NULL, NULL, NULL, 'ENT-KAURENOIC ACID OXIDASE 2', 252033),
(417890, 'PTHR24286:SF235', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 252033),
(417891, 'PTHR24286:SF355', NULL, NULL, NULL, NULL, 'ABSCISIC ACID 8''-HYDROXYLASE 3', 252033),
(417892, 'PTHR24286:SF234', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN, EXPRESSED', 252033),
(417893, 'PTHR24286:SF369', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 252033),
(417894, 'PTHR24286:SF368', NULL, NULL, NULL, NULL, 'BNAA04G20200D PROTEIN', 252033),
(417895, 'PTHR24286:SF249', NULL, NULL, NULL, NULL, 'ABSCISIC ACID 8''-HYDROXYLASE CYP707A2', 252033),
(417896, 'PTHR24286:SF240', NULL, NULL, NULL, NULL, 'ALLENE OXIDE SYNTHASE 2', 252033),
(417897, 'PTHR24286:SF361', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 85A2', 252033),
(417898, 'PTHR24286:SF360', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 252033),
(417899, 'PTHR24286:SF363', NULL, NULL, NULL, NULL, 'ALLENE OXIDE SYNTHASE', 252033),
(417900, 'PTHR24286:SF362', NULL, NULL, NULL, NULL, 'BNAA08G31650D PROTEIN', 252033),
(417901, 'PTHR24286:SF241', NULL, NULL, NULL, NULL, 'GOLD DOMAIN-CONTAINING PROTEIN', 252033),
(417902, 'PTHR24286:SF365', NULL, NULL, NULL, NULL, 'ALLENE OXIDE SYNTHASE 3', 252033),
(417903, 'PTHR24286:SF244', NULL, NULL, NULL, NULL, 'OS02G0113200 PROTEIN', 252033),
(417904, 'PTHR24286:SF364', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 718', 252033),
(417905, 'PTHR24286:SF243', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 702, SUBFAMILY A, POLYPEPTIDE 3', 252033),
(417906, 'PTHR24286:SF367', NULL, NULL, NULL, NULL, 'BNAC07G51130D PROTEIN', 252033),
(417907, 'PTHR24286:SF245', NULL, NULL, NULL, NULL, 'BNAANNG21530D PROTEIN', 252033),
(417908, 'PTHR24286:SF366', NULL, NULL, NULL, NULL, 'CYTOCHROME P450-RELATED', 252033),
(417909, 'PTHR24286:SF88', NULL, NULL, NULL, NULL, 'BETA-AMYRIN 28-OXIDASE-LIKE', 252033),
(417910, 'PTHR24286:SF370', NULL, NULL, NULL, NULL, 'BNAA08G03170D PROTEIN', 252033),
(417911, 'PTHR24286:SF81', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN, EXPRESSED', 252033),
(417912, 'PTHR24286:SF259', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 252033),
(417913, 'PTHR24286:SF258', NULL, NULL, NULL, NULL, '', 252033),
(417914, 'PTHR24286:SF379', NULL, NULL, NULL, NULL, 'P450 OXIDOREDUCTASE, PUTATIVE (EUROFUNG)-RELATED', 252033),
(417915, 'PTHR24286:SF372', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 87A3', 252033),
(417916, 'PTHR24286:SF251', NULL, NULL, NULL, NULL, 'STEROL 14-DEMETHYLASE', 252033),
(417917, 'PTHR24286:SF371', NULL, NULL, NULL, NULL, 'BETA-AMYRIN 28-OXIDASE-LIKE', 252033),
(417918, 'PTHR24286:SF374', NULL, NULL, NULL, NULL, 'BNAC02G02210D PROTEIN', 252033),
(417919, 'PTHR24286:SF253', NULL, NULL, NULL, NULL, '9-DIVINYL ETHER SYNTHASE', 252033),
(417920, 'PTHR24286:SF252', NULL, NULL, NULL, NULL, '', 252033),
(417921, 'PTHR24286:SF373', NULL, NULL, NULL, NULL, 'P450, PUTATIVE-RELATED', 252033),
(417922, 'PTHR24286:SF255', NULL, NULL, NULL, NULL, 'ALLENE OXIDE SYNTHASE, CHLOROPLASTIC', 252033),
(417923, 'PTHR24286:SF376', NULL, NULL, NULL, NULL, 'ABSCISIC ACID 8''-HYDROXYLASE 4', 252033),
(417924, 'PTHR24286:SF375', NULL, NULL, NULL, NULL, 'ABSCISIC ACID 8''-HYDROXYLASE 4-LIKE', 252033),
(417925, 'PTHR24286:SF254', NULL, NULL, NULL, NULL, '3-EPI-6-DEOXOCATHASTERONE 23-MONOOXYGENASE CYP90C1', 252033),
(417926, 'PTHR24286:SF378', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 252033);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(417927, 'PTHR24286:SF377', NULL, NULL, NULL, NULL, 'BETA-AMYRIN 28-OXIDASE-LIKE ISOFORM X1', 252033),
(417928, 'PTHR24286:SF256', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 252033),
(417929, 'PTHR24286:SF11', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 87, SUBFAMILY A, POLYPEPTIDE 2', 252033),
(417930, 'PTHR24286:SF10', NULL, NULL, NULL, NULL, 'ABSCISIC ACID 8''-HYDROXYLASE 1', 252033),
(417931, 'PTHR24286:SF12', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN, EXPRESSED', 252033),
(417932, 'PTHR24286:SF90', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 87A3-LIKE', 252033),
(417933, 'PTHR24286:SF269', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 252033),
(417934, 'PTHR24286:SF302', NULL, NULL, NULL, NULL, 'HYDROPEROXIDE LYASE', 252033),
(417935, 'PTHR24286:SF305', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 708A2', 252033),
(417936, 'PTHR24286:SF304', NULL, NULL, NULL, NULL, 'CYTOCHROME P450-RELATED', 252033),
(417937, 'PTHR24286:SF306', NULL, NULL, NULL, NULL, 'BNAA04G13470D PROTEIN', 252033),
(417938, 'PTHR24286:SF309', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 SUPERFAMILY PROTEIN-RELATED', 252033),
(417939, 'PTHR24286:SF308', NULL, NULL, NULL, NULL, 'BNAA09G42330D PROTEIN', 252033),
(417940, 'PTHR24286:SF261', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 252033),
(417941, 'PTHR24286:SF28', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 722 SUBFAMILY A POLYPEPTIDE 1', 252033),
(417942, 'PTHR24286:SF301', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 MONOOXYGENASE', 252033),
(417943, 'PTHR24286:SF268', NULL, NULL, NULL, NULL, 'BNAA06G38070D PROTEIN', 252033),
(417944, 'PTHR24286:SF271', NULL, NULL, NULL, NULL, 'P450, PUTATIVE-RELATED', 252033),
(417945, 'PTHR24286:SF24', NULL, NULL, NULL, NULL, 'LANOSTEROL 14-ALPHA DEMETHYLASE', 252033),
(417946, 'PTHR24286:SF314', NULL, NULL, NULL, NULL, 'BNAC01G31470D PROTEIN', 252033),
(417947, 'PTHR24286:SF159', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 724, SUBFAMILY A, POLYPEPTIDE 1', 252033),
(417948, 'PTHR24286:SF319', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY BRASSINOSTEROID OXIDASE', 252033),
(417949, 'PTHR24286:SF37', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 724B1', 252033),
(417950, 'PTHR24286:SF152', NULL, NULL, NULL, NULL, 'OS07G0519100 PROTEIN', 252033),
(417951, 'PTHR24286:SF273', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', 252033),
(417952, 'PTHR24286:SF275', NULL, NULL, NULL, NULL, 'ACID OXIDASE, PUTATIVE-RELATED', 252033),
(417953, 'PTHR24286:SF310', NULL, NULL, NULL, NULL, 'BNACNNG57040D PROTEIN', 252033),
(417954, 'PTHR24286:SF30', NULL, NULL, NULL, NULL, '3-EPI-6-DEOXOCATHASTERONE 23-MONOOXYGENASE CYP90D1', 252033),
(417955, 'PTHR24286:SF161', NULL, NULL, NULL, NULL, '', 252033),
(417956, 'PTHR24286:SF282', NULL, NULL, NULL, NULL, 'BNAA04G16900D PROTEIN', 252033),
(417957, 'PTHR24286:SF325', NULL, NULL, NULL, NULL, '', 252033),
(417958, 'PTHR24286:SF204', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN-RELATED', 252033),
(417959, 'PTHR24286:SF203', NULL, NULL, NULL, NULL, '', 252033),
(417960, 'PTHR24286:SF327', NULL, NULL, NULL, NULL, 'BNAC05G34660D PROTEIN', 252033),
(417961, 'PTHR24286:SF206', NULL, NULL, NULL, NULL, '', 252033),
(417962, 'PTHR24286:SF326', NULL, NULL, NULL, NULL, 'ABSCISIC ACID 8''-HYDROXYLASE3', 252033),
(417963, 'PTHR24286:SF329', NULL, NULL, NULL, NULL, 'EPOXYALCOHOL SYNTHASE CYP443D1', 252033),
(417964, 'PTHR24286:SF328', NULL, NULL, NULL, NULL, '', 252033),
(417965, 'PTHR24286:SF209', NULL, NULL, NULL, NULL, 'BETA-AMYRIN 28-OXIDASE-LIKE ISOFORM X1', 252033),
(417966, 'PTHR24286:SF283', NULL, NULL, NULL, NULL, 'BETA-AMYRIN 28-OXIDASE-LIKE', 252033),
(417967, 'PTHR24286:SF286', NULL, NULL, NULL, NULL, 'CYTOCHROME P450-RELATED', 252033),
(417968, 'PTHR24286:SF49', NULL, NULL, NULL, NULL, 'INACTIVE LINOLENATE HYDROPEROXIDE LYASE-RELATED', 252033),
(417969, 'PTHR24286:SF288', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 252033),
(417970, 'PTHR24286:SF320', NULL, NULL, NULL, NULL, 'P450, PUTATIVE-RELATED', 252033),
(417971, 'PTHR24286:SF169', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 85A1', 252033);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(417972, 'PTHR24286:SF201', NULL, NULL, NULL, NULL, '', 252033),
(417973, 'PTHR24286:SF40', NULL, NULL, NULL, NULL, 'OS05G0416400 PROTEIN', 252033),
(417974, 'PTHR24286:SF44', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 90A1', 252033),
(417975, 'PTHR24286:SF291', NULL, NULL, NULL, NULL, 'STEROL 14-DEMETHYLASE', 252033),
(417976, 'PTHR24286:SF290', NULL, NULL, NULL, NULL, 'ENT-KAURENOIC ACID OXIDASE 2-LIKE ISOFORM X1', 252033),
(417977, 'PTHR24286:SF292', NULL, NULL, NULL, NULL, '', 252033),
(417978, 'PTHR48196', NULL, NULL, NULL, NULL, '', 252034),
(417979, 'PTHR48196:SF2', NULL, NULL, NULL, NULL, 'OS01G0822100 PROTEIN', 252034),
(417980, 'PTHR48196:SF1', NULL, NULL, NULL, NULL, '', 252034),
(417981, 'PTHR36929', NULL, NULL, NULL, NULL, 'ATTACHMENT SUBUNIT, PUTATIVE-RELATED', 252035),
(417982, 'PTHR36929:SF4', NULL, NULL, NULL, NULL, 'BLL3153 PROTEIN', 252035),
(417983, 'PTHR36929:SF5', NULL, NULL, NULL, NULL, 'BLL8152 PROTEIN', 252035),
(417984, 'PTHR37468:SF1', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORTER CYSZ', 252036),
(417985, 'PTHR37468', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORTER CYSZ', 252036),
(417986, 'PTHR24343:SF519', NULL, NULL, NULL, NULL, 'CAMK FAMILY PROTEIN KINASE', 252037),
(417987, 'PTHR24343:SF517', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE ELM1', 252037),
(417988, 'PTHR24343:SF518', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE C70.05C-RELATED', 252037),
(417989, 'PTHR24343:SF76', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC SERINE/THREONINE-PROTEIN KINASE 1', 252037),
(417990, 'PTHR24343:SF74', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC SERINE/THREONINE-PROTEIN KINASE 3', 252037),
(417991, 'PTHR24343:SF232', NULL, NULL, NULL, NULL, '5''-AMP-ACTIVATED PROTEIN KINASE CATALYTIC SUBUNIT ALPHA-1', 252037),
(417992, 'PTHR24343:SF350', NULL, NULL, NULL, NULL, 'NUAK FAMILY SNF1-LIKE KINASE 1', 252037),
(417993, 'PTHR24343:SF515', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE RTK1-RELATED', 252037),
(417994, 'PTHR24343:SF516', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE YPL150W-RELATED', 252037),
(417995, 'PTHR24343:SF513', NULL, NULL, NULL, NULL, 'SUGAR-FREE FROSTING, ISOFORM A', 252037),
(417996, 'PTHR24343:SF514', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252037),
(417997, 'PTHR24343:SF511', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 252037),
(417998, 'PTHR24343:SF512', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252037),
(417999, 'PTHR24343:SF476', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SRK2F', 252037),
(418000, 'PTHR24343:SF113', NULL, NULL, NULL, NULL, 'NITROGEN PERMEASE REACTIVATOR PROTEIN-RELATED', 252037),
(418001, 'PTHR24343:SF477', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252037),
(418002, 'PTHR24343:SF84', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE BRSK2', 252037),
(418003, 'PTHR24343:SF528', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252037),
(418004, 'PTHR24343:SF529', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SAPK3-RELATED', 252037),
(418005, 'PTHR24343:SF485', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SRK2D', 252037),
(418006, 'PTHR24343:SF123', NULL, NULL, NULL, NULL, 'CBL-INTERACTING SERINE/THREONINE-PROTEIN KINASE 21-RELATED', 252037),
(418007, 'PTHR24343:SF483', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SAPK2-LIKE ISOFORM X1', 252037),
(418008, 'PTHR24343:SF120', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC SERINE/THREONINE-PROTEIN KINASE 2', 252037),
(418009, 'PTHR24343:SF121', NULL, NULL, NULL, NULL, 'MATERNAL EMBRYONIC LEUCINE ZIPPER KINASE', 252037),
(418010, 'PTHR24343:SF481', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE-RELATED', 252037),
(418011, 'PTHR24343:SF482', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PTK1/STK1-RELATED', 252037),
(418012, 'PTHR24343:SF526', NULL, NULL, NULL, NULL, 'PROTEIN KINASE, PUTATIVE-RELATED', 252037),
(418013, 'PTHR24343:SF527', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252037);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(418014, 'PTHR24343:SF128', NULL, NULL, NULL, NULL, 'SPERM MOTILITY KINASE X-RELATED', 252037),
(418015, 'PTHR24343:SF403', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SAPK3', 252037),
(418016, 'PTHR24343:SF524', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252037),
(418017, 'PTHR24343:SF525', NULL, NULL, NULL, NULL, 'FATTY ACYL-COA SYNTHETASE AND RNA PROCESSING-ASSOCIATED KINASE 1-RELATED', 252037),
(418018, 'PTHR24343:SF368', NULL, NULL, NULL, NULL, 'CBL-INTERACTING SERINE/THREONINE-PROTEIN KINASE 1', 252037),
(418019, 'PTHR24343:SF522', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 252037),
(418020, 'PTHR24343:SF369', NULL, NULL, NULL, NULL, 'SNF1-RELATED PROTEIN KINASE CATALYTIC SUBUNIT ALPHA KIN12', 252037),
(418021, 'PTHR24343:SF523', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SRK2E', 252037),
(418022, 'PTHR24343:SF487', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252037),
(418023, 'PTHR24343:SF520', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252037),
(418024, 'PTHR24343:SF366', NULL, NULL, NULL, NULL, 'CBL-INTERACTING SERINE/THREONINE-PROTEIN KINASE 4', 252037),
(418025, 'PTHR24343:SF521', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SAPK5', 252037),
(418026, 'PTHR24343:SF418', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SRK2C', 252037),
(418027, 'PTHR24343:SF419', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252037),
(418028, 'PTHR24343:SF133', NULL, NULL, NULL, NULL, 'NUAK FAMILY SNF1-LIKE KINASE 2', 252037),
(418029, 'PTHR24343:SF496', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SAPK3-LIKE', 252037),
(418030, 'PTHR24343:SF530', NULL, NULL, NULL, NULL, 'SERINE/THREONINE KINASE CATALYTIC DOMAIN PROTEIN-RELATED', 252037),
(418031, 'PTHR24343:SF376', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SRK2A-RELATED', 252037),
(418032, 'PTHR24343:SF373', NULL, NULL, NULL, NULL, 'CBL-INTERACTING SERINE/THREONINE-PROTEIN KINASE 7', 252037),
(418033, 'PTHR24343:SF371', NULL, NULL, NULL, NULL, 'CBL-INTERACTING SERINE/THREONINE-PROTEIN KINASE 8', 252037),
(418034, 'PTHR24343:SF130', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE BRSK1', 252037),
(418035, 'PTHR24343:SF372', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SAPK4', 252037),
(418036, 'PTHR24343:SF0', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NIM1', 252037),
(418037, 'PTHR24343:SF490', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SRK2H', 252037),
(418038, 'PTHR24343:SF370', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE OSK4', 252037),
(418039, 'PTHR24343:SF537', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE HAL4/SAT4', 252037),
(418040, 'PTHR24343:SF416', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G11930)-RELATED', 252037),
(418041, 'PTHR24343:SF538', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0279719-RELATED', 252037),
(418042, 'PTHR24343:SF417', NULL, NULL, NULL, NULL, 'CBL-INTERACTING PROTEIN KINASE 3', 252037),
(418043, 'PTHR24343:SF535', NULL, NULL, NULL, NULL, 'AGC FAMILY PROTEIN KINASE', 252037),
(418044, 'PTHR24343:SF415', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252037),
(418045, 'PTHR24343:SF536', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SAPK8', 252037),
(418046, 'PTHR24343:SF533', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252037),
(418047, 'PTHR24343:SF137', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE HRK1', 252037),
(418048, 'PTHR24343:SF413', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252037),
(418049, 'PTHR24343:SF534', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252037),
(418050, 'PTHR24343:SF9', NULL, NULL, NULL, NULL, 'SPERM MOTILITY KINASE Z', 252037),
(418051, 'PTHR24343:SF410', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252037),
(418052, 'PTHR24343:SF531', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252037);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(418053, 'PTHR24343:SF7', NULL, NULL, NULL, NULL, 'SPERM MOTILITY KINASE 1-RELATED', 252037),
(418054, 'PTHR24343:SF532', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-KINASE SAPK1-LIKE PROTEIN', 252037),
(418055, 'PTHR24343:SF378', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252037),
(418056, 'PTHR24343:SF420', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252037),
(418057, 'PTHR24343:SF383', NULL, NULL, NULL, NULL, 'CBL-INTERACTING PROTEIN KINASE 4', 252037),
(418058, 'PTHR24343:SF427', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252037),
(418059, 'PTHR24343:SF306', NULL, NULL, NULL, NULL, '5''-AMP-ACTIVATED PROTEIN KINASE CATALYTIC SUBUNIT ALPHA-1', 252037),
(418060, 'PTHR24343:SF428', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252037),
(418061, 'PTHR24343:SF307', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE GIN4-RELATED', 252037),
(418062, 'PTHR24343:SF304', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252037),
(418063, 'PTHR24343:SF426', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252037),
(418064, 'PTHR24343:SF303', NULL, NULL, NULL, NULL, '5''-AMP-ACTIVATED PROTEIN KINASE CATALYTIC SUBUNIT ALPHA-2', 252037),
(418065, 'PTHR24343:SF149', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 252037),
(418066, 'PTHR24343:SF424', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE CHK1', 252037),
(418067, 'PTHR24343:SF301', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC SERINE/THREONINE-PROTEIN KINASE 5', 252037),
(418068, 'PTHR24343:SF397', NULL, NULL, NULL, NULL, 'SNF1-RELATED PROTEIN KINASE CATALYTIC SUBUNIT ALPHA KIN10-LIKE', 252037),
(418069, 'PTHR24343:SF431', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SRK2A', 252037),
(418070, 'PTHR24343:SF153', NULL, NULL, NULL, NULL, 'SPERM MOTILITY KINASE Y-RELATED', 252037),
(418071, 'PTHR24343:SF154', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SIK2', 252037),
(418072, 'PTHR24343:SF396', NULL, NULL, NULL, NULL, 'CBL-INTERACTING PROTEIN KINASE 31', 252037),
(418073, 'PTHR24343:SF435', NULL, NULL, NULL, NULL, 'CBL-INTERACTING SERINE/THREONINE-PROTEIN KINASE 17', 252037),
(418074, 'PTHR24343:SF433', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252037),
(418075, 'PTHR24343:SF209', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE MARK-B-RELATED', 252037),
(418076, 'PTHR24343:SF43', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE HAL5-RELATED', 252037),
(418077, 'PTHR24343:SF166', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC SERINE/THREONINE-PROTEIN KINASE 6', 252037),
(418078, 'PTHR24343:SF442', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252037),
(418079, 'PTHR24343:SF440', NULL, NULL, NULL, NULL, 'SUCROSE NONFERMENTING 1(SNF1)-RELATED KINASE', 252037),
(418080, 'PTHR24343:SF449', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE', 252037),
(418081, 'PTHR24343:SF326', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SAPK9', 252037),
(418082, 'PTHR24343:SF324', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PRR1', 252037),
(418083, 'PTHR24343:SF204', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SIK1-RELATED', 252037),
(418084, 'PTHR24343:SF446', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SAPK1', 252037),
(418085, 'PTHR24343:SF444', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE KSP1', 252037),
(418086, 'PTHR24343:SF181', NULL, NULL, NULL, NULL, 'SNF-RELATED SERINE/THREONINE-PROTEIN KINASE', 252037),
(418087, 'PTHR24343:SF452', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252037),
(418088, 'PTHR24343:SF299', NULL, NULL, NULL, NULL, 'FI24002P1', 252037),
(418089, 'PTHR24343:SF330', NULL, NULL, NULL, NULL, 'SNF1-ACTIVATING KINASE 1', 252037),
(418090, 'PTHR24343:SF458', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PIM-1/2/3-RELATED', 252037),
(418091, 'PTHR24343:SF457', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252037);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(418092, 'PTHR24343:SF454', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252037),
(418093, 'PTHR24343:SF508', NULL, NULL, NULL, NULL, 'CBL-INTERACTING SERINE/THREONINE-PROTEIN KINASE 26', 252037),
(418094, 'PTHR24343:SF509', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SRK2I', 252037),
(418095, 'PTHR24343:SF506', NULL, NULL, NULL, NULL, 'SNF1-RELATED KINASE', 252037),
(418096, 'PTHR24343:SF507', NULL, NULL, NULL, NULL, 'CBL-INTERACTING SERINE/THREONINE-PROTEIN KINASE 24', 252037),
(418097, 'PTHR24343:SF191', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE', 252037),
(418098, 'PTHR24343', NULL, NULL, NULL, NULL, 'SERINE/THREONINE KINASE', 252037),
(418099, 'PTHR24343:SF221', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 252037),
(418100, 'PTHR24343:SF463', NULL, NULL, NULL, NULL, 'SUCROSE NON-FERMENTING-LIKE KINASE 2 FAMILY PROTEIN', 252037),
(418101, 'PTHR24343:SF101', NULL, NULL, NULL, NULL, 'CBL-INTERACTING SERINE/THREONINE-PROTEIN KINASE 23', 252037),
(418102, 'PTHR24343:SF464', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SAPK7', 252037),
(418103, 'PTHR24343:SF189', NULL, NULL, NULL, NULL, 'CBL-INTERACTING PROTEIN KINASE 32', 252037),
(418104, 'PTHR24343:SF340', NULL, NULL, NULL, NULL, 'SPERM MOTILITY KINASE W-RELATED', 252037),
(418105, 'PTHR24343:SF504', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SRK2J', 252037),
(418106, 'PTHR24343:SF108', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE KIN1-RELATED', 252037),
(418107, 'PTHR24343:SF505', NULL, NULL, NULL, NULL, 'SNF1-RELATED PROTEIN KINASE CATALYTIC SUBUNIT ALPHA KIN11', 252037),
(418108, 'PTHR24343:SF348', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252037),
(418109, 'PTHR24343:SF467', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SAPK1-LIKE', 252037),
(418110, 'PTHR24343:SF105', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 252037),
(418111, 'PTHR24343:SF468', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252037),
(418112, 'PTHR24343:SF102', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252037),
(418113, 'PTHR24343:SF465', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252037),
(418114, 'PTHR24343:SF345', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC SERINE/THREONINE-PROTEIN KINASE 4', 252037),
(418115, 'PTHR24343:SF466', NULL, NULL, NULL, NULL, 'AMP-ACTIVATED PROTEIN KINASE ALPHA SUBUNIT, ISOFORM A', 252037),
(418116, 'PTHR35317:SF5', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 252038),
(418117, 'PTHR35317:SF8', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 252038),
(418118, 'PTHR35317:SF30', NULL, NULL, NULL, NULL, 'DUF4219 DOMAIN-CONTAINING PROTEIN', 252038),
(418119, 'PTHR35317', NULL, NULL, NULL, NULL, 'OS04G0629600 PROTEIN', 252038),
(418120, 'PTHR35317:SF32', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 252038),
(418121, 'PTHR35317:SF10', NULL, NULL, NULL, NULL, '', 252038),
(418122, 'PTHR35317:SF31', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 252038),
(418123, 'PTHR35317:SF34', NULL, NULL, NULL, NULL, '', 252038),
(418124, 'PTHR35317:SF23', NULL, NULL, NULL, NULL, '', 252038),
(418125, 'PTHR35317:SF11', NULL, NULL, NULL, NULL, 'DUF4219 DOMAIN-CONTAINING PROTEIN', 252038),
(418126, 'PTHR35317:SF22', NULL, NULL, NULL, NULL, '', 252038),
(418127, 'PTHR35317:SF33', NULL, NULL, NULL, NULL, 'ZINC FINGER, CCHC-TYPE-RELATED', 252038),
(418128, 'PTHR35317:SF25', NULL, NULL, NULL, NULL, '', 252038),
(418129, 'PTHR35317:SF24', NULL, NULL, NULL, NULL, 'DUF4219 DOMAIN-CONTAINING PROTEIN', 252038),
(418130, 'PTHR35317:SF27', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H-LIKE DOMAIN, GAG-PRE-INTEGRASE DOMAIN PROTEIN-RELATED', 252038),
(418131, 'PTHR35317:SF26', NULL, NULL, NULL, NULL, 'RETROVIRUS-RELATED POL POLYPROTEIN FROM TRANSPOSON TNT 1-94-LIKE PROTEIN', 252038),
(418132, 'PTHR35317:SF29', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 252038),
(418133, 'PTHR35317:SF18', NULL, NULL, NULL, NULL, 'ZINC FINGER, CCHC-TYPE-RELATED', 252038);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(418134, 'PTHR35317:SF28', NULL, NULL, NULL, NULL, 'DUF4219 DOMAIN-CONTAINING PROTEIN', 252038),
(418135, 'PTHR20961:SF81', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 61 PROTEIN', 252039),
(418136, 'PTHR20961:SF80', NULL, NULL, NULL, NULL, '', 252039),
(418137, 'PTHR20961:SF130', NULL, NULL, NULL, NULL, 'BNAC05G35190D PROTEIN', 252039),
(418138, 'PTHR20961:SF131', NULL, NULL, NULL, NULL, '', 252039),
(418139, 'PTHR20961:SF134', NULL, NULL, NULL, NULL, '', 252039),
(418140, 'PTHR20961:SF136', NULL, NULL, NULL, NULL, '', 252039),
(418141, 'PTHR20961:SF38', NULL, NULL, NULL, NULL, 'PROTEIN O-LINKED-MANNOSE BETA-1,4-N-ACETYLGLUCOSAMINYLTRANSFERASE 2', 252039),
(418142, 'PTHR20961:SF138', NULL, NULL, NULL, NULL, '', 252039),
(418143, 'PTHR20961:SF139', NULL, NULL, NULL, NULL, 'PROTEIN O-LINKED-MANNOSE BETA-1,4-N-ACETYLGLUCOSAMINYLTRANSFERASE 2-LIKE', 252039),
(418144, 'PTHR20961:SF74', NULL, NULL, NULL, NULL, 'BNAA08G11530D PROTEIN', 252039),
(418145, 'PTHR20961:SF78', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 61 PROTEIN', 252039),
(418146, 'PTHR20961:SF34', NULL, NULL, NULL, NULL, 'OS06G0707200 PROTEIN', 252039),
(418147, 'PTHR20961:SF35', NULL, NULL, NULL, NULL, '', 252039),
(418148, 'PTHR20961:SF76', NULL, NULL, NULL, NULL, '', 252039),
(418149, 'PTHR20961:SF77', NULL, NULL, NULL, NULL, '', 252039),
(418150, 'PTHR20961', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 252039),
(418151, 'PTHR20961:SF90', NULL, NULL, NULL, NULL, 'OS04G0196600 PROTEIN', 252039),
(418152, 'PTHR20961:SF141', NULL, NULL, NULL, NULL, 'BNAC04G01980D PROTEIN', 252039),
(418153, 'PTHR20961:SF140', NULL, NULL, NULL, NULL, '', 252039),
(418154, 'PTHR20961:SF142', NULL, NULL, NULL, NULL, 'OS01G0956200 PROTEIN', 252039),
(418155, 'PTHR20961:SF101', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 61 PROTEIN', 252039),
(418156, 'PTHR20961:SF145', NULL, NULL, NULL, NULL, 'OS01G0118600 PROTEIN', 252039),
(418157, 'PTHR20961:SF100', NULL, NULL, NULL, NULL, 'OS02G0331200 PROTEIN', 252039),
(418158, 'PTHR20961:SF144', NULL, NULL, NULL, NULL, 'OS01G0119100 PROTEIN', 252039),
(418159, 'PTHR20961:SF103', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 252039),
(418160, 'PTHR20961:SF146', NULL, NULL, NULL, NULL, '', 252039),
(418161, 'PTHR20961:SF102', NULL, NULL, NULL, NULL, 'OS05G0391600 PROTEIN', 252039),
(418162, 'PTHR20961:SF149', NULL, NULL, NULL, NULL, 'PROTEIN O-LINKED-MANNOSE BETA-1,4-N-ACETYLGLUCOSAMINYLTRANSFERASE 2-LIKE', 252039),
(418163, 'PTHR20961:SF104', NULL, NULL, NULL, NULL, '', 252039),
(418164, 'PTHR20961:SF148', NULL, NULL, NULL, NULL, 'BETA-1,2-XYLOSYLTRANSFERASE', 252039),
(418165, 'PTHR20961:SF109', NULL, NULL, NULL, NULL, '', 252039),
(418166, 'PTHR20961:SF108', NULL, NULL, NULL, NULL, 'EGF DOMAIN-SPECIFIC O-LINKED N-ACETYLGLUCOSAMINE TRANSFERASE-LIKE', 252039),
(418167, 'PTHR20961:SF85', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 61 PROTEIN', 252039),
(418168, 'PTHR20961:SF86', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 61 PROTEIN', 252039),
(418169, 'PTHR20961:SF83', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 61 PROTEIN', 252039),
(418170, 'PTHR20961:SF88', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 61 PROTEIN', 252039),
(418171, 'PTHR20961:SF150', NULL, NULL, NULL, NULL, '', 252039),
(418172, 'PTHR20961:SF152', NULL, NULL, NULL, NULL, 'ALPHA-1,3-ARABINOSYLTRANSFERASE XAT2', 252039),
(418173, 'PTHR20961:SF151', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 61 PROTEIN', 252039),
(418174, 'PTHR20961:SF154', NULL, NULL, NULL, NULL, '', 252039),
(418175, 'PTHR20961:SF153', NULL, NULL, NULL, NULL, 'BNAC05G35210D PROTEIN', 252039),
(418176, 'PTHR20961:SF112', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 61 PROTEIN', 252039),
(418177, 'PTHR20961:SF156', NULL, NULL, NULL, NULL, '', 252039),
(418178, 'PTHR20961:SF155', NULL, NULL, NULL, NULL, 'OS06G0311000 PROTEIN', 252039),
(418179, 'PTHR20961:SF157', NULL, NULL, NULL, NULL, 'FAMILY 61 PROTEIN, PUTATIVE-RELATED', 252039),
(418180, 'PTHR20961:SF116', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 252039);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(418181, 'PTHR20961:SF115', NULL, NULL, NULL, NULL, '', 252039),
(418182, 'PTHR20961:SF17', NULL, NULL, NULL, NULL, 'OS01G0118400 PROTEIN', 252039),
(418183, 'PTHR20961:SF5', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE-RELATED', 252039),
(418184, 'PTHR20961:SF14', NULL, NULL, NULL, NULL, 'OS02G0135500 PROTEIN', 252039),
(418185, 'PTHR20961:SF119', NULL, NULL, NULL, NULL, 'EGF DOMAIN-SPECIFIC O-LINKED N-ACETYLGLUCOSAMINE TRANSFERASE-LIKE', 252039),
(418186, 'PTHR20961:SF19', NULL, NULL, NULL, NULL, 'OS06G0470000 PROTEIN', 252039),
(418187, 'PTHR20961:SF97', NULL, NULL, NULL, NULL, 'ALPHA-1,3-ARABINOSYLTRANSFERASE XAT3', 252039),
(418188, 'PTHR20961:SF95', NULL, NULL, NULL, NULL, '', 252039),
(418189, 'PTHR20961:SF13', NULL, NULL, NULL, NULL, 'OS01G0119000 PROTEIN', 252039),
(418190, 'PTHR20961:SF98', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE-RELATED', 252039),
(418191, 'PTHR20961:SF11', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 61 PROTEIN', 252039),
(418192, 'PTHR20961:SF120', NULL, NULL, NULL, NULL, '', 252039),
(418193, 'PTHR20961:SF122', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 61 PROTEIN-RELATED', 252039),
(418194, 'PTHR20961:SF124', NULL, NULL, NULL, NULL, 'EGF DOMAIN-SPECIFIC O-LINKED N-ACETYLGLUCOSAMINE TRANSFERASE', 252039),
(418195, 'PTHR20961:SF27', NULL, NULL, NULL, NULL, 'BETA-1,2-XYLOSYLTRANSFEREASE XAX1', 252039),
(418196, 'PTHR20961:SF127', NULL, NULL, NULL, NULL, 'BNACNNG59270D PROTEIN', 252039),
(418197, 'PTHR20961:SF28', NULL, NULL, NULL, NULL, 'OS01G0118700 PROTEIN', 252039),
(418198, 'PTHR20961:SF129', NULL, NULL, NULL, NULL, 'BETA-1,2-XYLOSYLTRANSFERASE XYXT1', 252039),
(418199, 'PTHR20961:SF26', NULL, NULL, NULL, NULL, 'PUTATIVE, EXPRESSED-RELATED', 252039),
(418200, 'PTHR20961:SF23', NULL, NULL, NULL, NULL, 'OS06G0475400 PROTEIN', 252039),
(418201, 'PTHR20961:SF68', NULL, NULL, NULL, NULL, 'OS07G0657400 PROTEIN', 252039),
(418202, 'PTHR20961:SF65', NULL, NULL, NULL, NULL, 'XYLAN GLYCOSYLTRANSFERASE MUCI21', 252039),
(418203, 'PTHR20961:SF21', NULL, NULL, NULL, NULL, 'OS02G0327700 PROTEIN', 252039),
(418204, 'PTHR45726:SF6', NULL, NULL, NULL, NULL, 'LEUK-A4-HYDRO_C DOMAIN-CONTAINING PROTEIN', 252040),
(418205, 'PTHR45726:SF3', NULL, NULL, NULL, NULL, 'LEUKOTRIENE A-4 HYDROLASE', 252040),
(418206, 'PTHR45726', NULL, NULL, NULL, NULL, 'LEUKOTRIENE A-4 HYDROLASE', 252040),
(418207, 'PTHR45726:SF2', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE RNPEPL1', 252040),
(418208, 'PTHR45726:SF1', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE B', 252040),
(418209, 'PTHR15114:SF1', NULL, NULL, NULL, NULL, 'REPLICATION PROTEIN A 14 KDA SUBUNIT', 252041),
(418210, 'PTHR15114', NULL, NULL, NULL, NULL, 'REPLICATION PROTEIN A3', 252041),
(418211, 'PTHR46101:SF2', NULL, NULL, NULL, NULL, 'SERINE DECARBOXYLASE', 252042),
(418212, 'PTHR46101:SF5', NULL, NULL, NULL, NULL, 'HISTIDINE DECARBOXYLASE-LIKE', 252042),
(418213, 'PTHR46101:SF17', NULL, NULL, NULL, NULL, 'SERINE DECARBOXYLASE', 252042),
(418214, 'PTHR46101:SF16', NULL, NULL, NULL, NULL, 'HISTIDINE DECARBOXYLASE-LIKE', 252042),
(418215, 'PTHR46101:SF19', NULL, NULL, NULL, NULL, 'SERINE DECARBOXYLASE', 252042),
(418216, 'PTHR46101', NULL, NULL, NULL, NULL, '', 252042),
(418217, 'PTHR46101:SF18', NULL, NULL, NULL, NULL, '', 252042),
(418218, 'PTHR46101:SF9', NULL, NULL, NULL, NULL, 'HISTIDINE DECARBOXYLASE', 252042),
(418219, 'PTHR46101:SF8', NULL, NULL, NULL, NULL, 'SERINE DECARBOXYLASE 2', 252042),
(418220, 'PTHR46101:SF20', NULL, NULL, NULL, NULL, 'AROMATIC AMINO ACID DECARBOXYLASE 1A', 252042),
(418221, 'PTHR46101:SF10', NULL, NULL, NULL, NULL, '', 252042),
(418222, 'PTHR46101:SF13', NULL, NULL, NULL, NULL, 'BNAA08G04700D PROTEIN', 252042),
(418223, 'PTHR46101:SF12', NULL, NULL, NULL, NULL, 'AROMATIC AMINO ACID DECARBOXYLASE 1A', 252042),
(418224, 'PTHR46101:SF15', NULL, NULL, NULL, NULL, 'BNAA09G15450D PROTEIN', 252042),
(418225, 'PTHR46101:SF14', NULL, NULL, NULL, NULL, 'HISTIDINE DECARBOXYLASE', 252042),
(418226, 'PTHR46195:SF30', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 17-RELATED', 252043); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(418227, 'PTHR46195:SF32', NULL, NULL, NULL, NULL, 'OS04G0390100 PROTEIN', 252043),
(418228, 'PTHR46195:SF10', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED DOMAIN CONTAINING PROTEIN, EXPRESSED', 252043),
(418229, 'PTHR46195:SF31', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 7-LIKE', 252043),
(418230, 'PTHR46195:SF7', NULL, NULL, NULL, NULL, 'OS07G0298900 PROTEIN', 252043),
(418231, 'PTHR46195:SF15', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORT/DETOXIFICATION SUPERFAMILY PROTEIN', 252043),
(418232, 'PTHR46195:SF18', NULL, NULL, NULL, NULL, 'SUPEROXIDE DISMUTASE 1 COPPER CHAPERONE-LIKE PROTEIN', 252043),
(418233, 'PTHR46195:SF29', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 3-LIKE', 252043),
(418234, 'PTHR46195:SF17', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 8', 252043),
(418235, 'PTHR46195:SF23', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 3-LIKE', 252043),
(418236, 'PTHR46195:SF12', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 4', 252043),
(418237, 'PTHR46195:SF2', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 7', 252043),
(418238, 'PTHR46195', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 7', 252043),
(418239, 'PTHR46195:SF11', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORT/DETOXIFICATION SUPERFAMILY PROTEIN', 252043),
(418240, 'PTHR46195:SF33', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED DOMAIN, HMA-RELATED', 252043),
(418241, 'PTHR46195:SF3', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 3-LIKE', 252043),
(418242, 'PTHR46195:SF25', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 18', 252043),
(418243, 'PTHR46195:SF24', NULL, NULL, NULL, NULL, 'BNAANNG30630D PROTEIN', 252043),
(418244, 'PTHR46195:SF9', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 252043),
(418245, 'PTHR45883:SF9', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 252044),
(418246, 'PTHR45883:SF2', NULL, NULL, NULL, NULL, 'HSC70-INTERACTING PROTEIN', 252044),
(418247, 'PTHR45883:SF3', NULL, NULL, NULL, NULL, 'PROTEIN FAM10A4-RELATED', 252044),
(418248, 'PTHR45883:SF5', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 252044),
(418249, 'PTHR45883:SF6', NULL, NULL, NULL, NULL, 'HSC70-INTERACTING PROTEIN-RELATED', 252044),
(418250, 'PTHR45883', NULL, NULL, NULL, NULL, 'HSC70-INTERACTING PROTEIN', 252044),
(418251, 'PTHR45883:SF7', NULL, NULL, NULL, NULL, 'TPR REPEAT-CONTAINING THIOREDOXIN TDX', 252044),
(418252, 'PTHR21281:SF0', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 DOMAIN-CONTAINING PROTEIN 1', 252045),
(418253, 'PTHR21281', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252045),
(418254, 'PTHR40036:SF1', NULL, NULL, NULL, NULL, 'MACROCIN O-METHYLTRANSFERASE', 252046),
(418255, 'PTHR40036', NULL, NULL, NULL, NULL, 'MACROCIN O-METHYLTRANSFERASE', 252046),
(418256, 'PTHR45530:SF3', NULL, NULL, NULL, NULL, 'TWO-COMPONENT SYSTEM NARL FAMILY SENSOR HISTIDINE KINASE BARA', 252047),
(418257, 'PTHR45530', NULL, NULL, NULL, NULL, 'SENSORY TRANSDUCTION HISTIDINE KINASE', 252047),
(418258, 'PTHR28602:SF1', NULL, NULL, NULL, NULL, 'ENDOTHELIAL CELL-SPECIFIC CHEMOTAXIS REGULATOR', 252048),
(418259, 'PTHR28602', NULL, NULL, NULL, NULL, 'ENDOTHELIAL CELL-SPECIFIC CHEMOTAXIS REGULATOR', 252048),
(418260, 'PTHR47676:SF2', NULL, NULL, NULL, NULL, 'SMR DOMAIN-CONTAINING PROTEIN', 252049),
(418261, 'PTHR47676:SF1', NULL, NULL, NULL, NULL, 'SMR DOMAIN-CONTAINING PROTEIN', 252049),
(418262, 'PTHR47676', NULL, NULL, NULL, NULL, 'OS01G0225100 PROTEIN', 252049),
(418263, 'PTHR43299:SF1', NULL, NULL, NULL, NULL, 'UPF0718 PROTEIN YRAQ', 252050),
(418264, 'PTHR43299', NULL, NULL, NULL, NULL, 'UPF0718 PROTEIN YRAQ', 252050),
(418265, 'PTHR12989', NULL, NULL, NULL, NULL, 'ALPHA-1,2-GLUCOSYLTRANSFERASE ALG10', 252051),
(418266, 'PTHR12989:SF10', NULL, NULL, NULL, NULL, 'DOL-P-GLC:GLC(2)MAN(9)GLCNAC(2)-PP-DOL ALPHA-1,2-GLUCOSYLTRANSFERASE-RELATED', 252051);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(418267, 'PTHR12989:SF12', NULL, NULL, NULL, NULL, 'DOL-P-GLC:GLC(2)MAN(9)GLCNAC(2)-PP-DOL ALPHA-1,2-GLUCOSYLTRANSFERASE-RELATED', 252051),
(418268, 'PTHR12989:SF11', NULL, NULL, NULL, NULL, 'DOL-P-GLC:GLC(2)MAN(9)GLCNAC(2)-PP-DOL ALPHA-1,2-GLUCOSYLTRANSFERASE', 252051),
(418269, 'PTHR19372:SF15', NULL, NULL, NULL, NULL, 'BNAC02G33150D PROTEIN', 252052),
(418270, 'PTHR19372:SF6', NULL, NULL, NULL, NULL, 'SULFITE OXIDASE', 252052),
(418271, 'PTHR19372:SF14', NULL, NULL, NULL, NULL, 'OS12G0442800 PROTEIN', 252052),
(418272, 'PTHR19372:SF7', NULL, NULL, NULL, NULL, 'SULFITE OXIDASE, MITOCHONDRIAL', 252052),
(418273, 'PTHR19372', NULL, NULL, NULL, NULL, 'SULFITE REDUCTASE', 252052),
(418274, 'PTHR45740:SF6', NULL, NULL, NULL, NULL, 'PROTEIN MONO-ADP-RIBOSYLTRANSFERASE PARP12', 252053),
(418275, 'PTHR45740:SF7', NULL, NULL, NULL, NULL, 'PROTEIN MONO-ADP-RIBOSYLTRANSFERASE TIPARP', 252053),
(418276, 'PTHR45740:SF8', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH-TYPE ANTIVIRAL PROTEIN 1', 252053),
(418277, 'PTHR45740:SF2', NULL, NULL, NULL, NULL, 'POLY [ADP-RIBOSE] POLYMERASE', 252053),
(418278, 'PTHR45740:SF4', NULL, NULL, NULL, NULL, 'PROTEIN MONO-ADP-RIBOSYLTRANSFERASE PARP11', 252053),
(418279, 'PTHR45740:SF10', NULL, NULL, NULL, NULL, 'NOVEL PROTEIN', 252053),
(418280, 'PTHR45740:SF13', NULL, NULL, NULL, NULL, 'POLY (ADP-RIBOSE) POLYMERASE FAMILY, MEMBER 12B', 252053),
(418281, 'PTHR45740:SF14', NULL, NULL, NULL, NULL, 'NOVEL PROTEIN', 252053),
(418282, 'PTHR45740:SF15', NULL, NULL, NULL, NULL, 'POLY [ADP-RIBOSE] POLYMERASE 12-LIKE', 252053),
(418283, 'PTHR45740', NULL, NULL, NULL, NULL, 'POLY [ADP-RIBOSE] POLYMERASE', 252053),
(418284, 'PTHR22968:SF26', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE D3', 252054),
(418285, 'PTHR22968:SF15', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DKF-1', 252054),
(418286, 'PTHR22968:SF12', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE D2', 252054),
(418287, 'PTHR22968:SF25', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C', 252054),
(418288, 'PTHR22968', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C, MU', 252054),
(418289, 'PTHR22968:SF14', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C', 252054),
(418290, 'PTHR22968:SF24', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE', 252054),
(418291, 'PTHR22968:SF9', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE D1', 252054),
(418292, 'PTHR38828:SF1', NULL, NULL, NULL, NULL, '', 252055),
(418293, 'PTHR38828', NULL, NULL, NULL, NULL, '', 252055),
(418294, 'PTHR38828:SF2', NULL, NULL, NULL, NULL, '', 252055),
(418295, 'PTHR38828:SF3', NULL, NULL, NULL, NULL, '', 252055),
(418296, 'PTHR38828:SF4', NULL, NULL, NULL, NULL, '', 252055),
(418297, 'PTHR43708:SF1', NULL, NULL, NULL, NULL, 'GALACTOSE/LACTOSE METABOLISM REGULATORY PROTEIN GAL80', 252056),
(418298, 'PTHR43708', NULL, NULL, NULL, NULL, 'CONSERVED EXPRESSED OXIDOREDUCTASE (EUROFUNG)', 252056),
(418299, 'PTHR43708:SF7', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE-RELATED', 252056),
(418300, 'PTHR43708:SF5', NULL, NULL, NULL, NULL, 'CONSERVED EXPRESSED OXIDOREDUCTASE (EUROFUNG)-RELATED', 252056),
(418301, 'PTHR43708:SF4', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE YCEM-RELATED', 252056),
(418302, 'PTHR43708:SF3', NULL, NULL, NULL, NULL, '', 252056),
(418303, 'PTHR24232:SF6', NULL, NULL, NULL, NULL, 'PURINERGIC RECEPTOR P2Y, G-PROTEIN-COUPLED 10B', 252057),
(418304, 'PTHR24232:SF7', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 20', 252057),
(418305, 'PTHR24232:SF91', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN LOC653160', 252057),
(418306, 'PTHR24232:SF103', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 35-LIKE', 252057),
(418307, 'PTHR24232:SF104', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR 184', 252057),
(418308, 'PTHR24232:SF90', NULL, NULL, NULL, NULL, 'LYSOPHOSPHATIDIC ACID RECEPTOR 5B', 252057),
(418309, 'PTHR24232:SF36', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 4', 252057),
(418310, 'PTHR24232:SF99', NULL, NULL, NULL, NULL, 'COAGULATION FACTOR II (THROMBIN) RECEPTOR-LIKE 1', 252057),
(418311, 'PTHR24232:SF56', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 55', 252057);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(418312, 'PTHR24232:SF53', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 252057),
(418313, 'PTHR24232:SF101', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 252057),
(418314, 'PTHR24232:SF97', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 252057),
(418315, 'PTHR24232:SF3', NULL, NULL, NULL, NULL, 'LYSOPHOSPHATIDIC ACID RECEPTOR 6', 252057),
(418316, 'PTHR24232', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR', 252057),
(418317, 'PTHR24232:SF102', NULL, NULL, NULL, NULL, 'ZGC:172079', 252057),
(418318, 'PTHR24232:SF54', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 35', 252057),
(418319, 'PTHR24232:SF51', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 252057),
(418320, 'PTHR24232:SF95', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 252057),
(418321, 'PTHR24232:SF0', NULL, NULL, NULL, NULL, 'PROTEINASE-ACTIVATED RECEPTOR 3', 252057),
(418322, 'PTHR24232:SF100', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR 35, TANDEM DUPLICATE 1', 252057),
(418323, 'PTHR24232:SF96', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 252057),
(418324, 'PTHR24232:SF1', NULL, NULL, NULL, NULL, 'N-ARACHIDONYL GLYCINE RECEPTOR', 252057),
(418325, 'PTHR24232:SF82', NULL, NULL, NULL, NULL, 'PROTEINASE-ACTIVATED RECEPTOR 1', 252057),
(418326, 'PTHR24232:SF83', NULL, NULL, NULL, NULL, 'GENE 5127-RELATED', 252057),
(418327, 'PTHR24232:SF25', NULL, NULL, NULL, NULL, 'P2Y PURINOCEPTOR 8', 252057),
(418328, 'PTHR24232:SF47', NULL, NULL, NULL, NULL, 'P2Y PURINOCEPTOR 10-RELATED', 252057),
(418329, 'PTHR24232:SF44', NULL, NULL, NULL, NULL, 'URACIL NUCLEOTIDE/CYSTEINYL LEUKOTRIENE RECEPTOR', 252057),
(418330, 'PTHR24232:SF22', NULL, NULL, NULL, NULL, 'PROTEINASE-ACTIVATED RECEPTOR 4', 252057),
(418331, 'PTHR24232:SF20', NULL, NULL, NULL, NULL, 'PROTEINASE-ACTIVATED RECEPTOR 1', 252057),
(418332, 'PTHR24232:SF86', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 174-RELATED', 252057),
(418333, 'PTHR24232:SF21', NULL, NULL, NULL, NULL, 'PROTEINASE-ACTIVATED RECEPTOR 2', 252057),
(418334, 'PTHR24232:SF41', NULL, NULL, NULL, NULL, 'LYSOPHOSPHATIDIC ACID RECEPTOR 4', 252057),
(418335, 'PTHR24232:SF85', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 252057),
(418336, 'PTHR24232:SF49', NULL, NULL, NULL, NULL, 'PSYCHOSINE RECEPTOR', 252057),
(418337, 'PTHR12866:SF5', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED 10, ISOFORM B', 252058),
(418338, 'PTHR12866:SF10', NULL, NULL, NULL, NULL, 'PROTEIN CBG00516', 252058),
(418339, 'PTHR12866', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE-CONJUGATING ENZYME ATG3', 252058),
(418340, 'PTHR12866:SF11', NULL, NULL, NULL, NULL, 'AUTOPHAGY_ACT_C DOMAIN-CONTAINING PROTEIN', 252058),
(418341, 'PTHR12866:SF2', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE-CONJUGATING ENZYME ATG3', 252058),
(418342, 'PTHR34610', NULL, NULL, NULL, NULL, 'SSL7007 PROTEIN', 252059),
(418343, 'PTHR34610:SF3', NULL, NULL, NULL, NULL, 'SSL7007 PROTEIN', 252059),
(418344, 'PTHR34610:SF4', NULL, NULL, NULL, NULL, 'SLL8027 PROTEIN', 252059),
(418345, 'PTHR37908:SF3', NULL, NULL, NULL, NULL, 'OS09G0415200 PROTEIN', 252060),
(418346, 'PTHR37908:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 252060),
(418347, 'PTHR37908', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 252060),
(418348, 'PTHR16317:SF1', NULL, NULL, NULL, NULL, 'KICSTOR COMPLEX PROTEIN ITFG2', 252061),
(418349, 'PTHR16317', NULL, NULL, NULL, NULL, 'INTEGRIN ALPHA REPEAT DOMAIN-CONTAINING', 252061),
(418350, 'PTHR47713', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN', 252062),
(418351, 'PTHR47713:SF3', NULL, NULL, NULL, NULL, 'HOMEOBOX-DDT DOMAIN PROTEIN RLT1-LIKE ISOFORM X1', 252062),
(418352, 'PTHR47713:SF2', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN', 252062),
(418353, 'PTHR34107:SF4', NULL, NULL, NULL, NULL, 'SLL1222 PROTEIN', 252063),
(418354, 'PTHR34107:SF5', NULL, NULL, NULL, NULL, 'SLL1956 PROTEIN', 252063),
(418355, 'PTHR34107:SF6', NULL, NULL, NULL, NULL, 'SLR0981 PROTEIN', 252063);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(418356, 'PTHR34107', NULL, NULL, NULL, NULL, 'SLL0198 PROTEIN-RELATED', 252063),
(418357, 'PTHR34107:SF7', NULL, NULL, NULL, NULL, 'SLR2092 PROTEIN', 252063),
(418358, 'PTHR34107:SF8', NULL, NULL, NULL, NULL, 'SLL1355 PROTEIN', 252063),
(418359, 'PTHR34107:SF1', NULL, NULL, NULL, NULL, 'SLL0198 PROTEIN', 252063),
(418360, 'PTHR34107:SF2', NULL, NULL, NULL, NULL, 'SLL0888 PROTEIN', 252063),
(418361, 'PTHR35400:SF1', NULL, NULL, NULL, NULL, 'SLR1083 PROTEIN', 252064),
(418362, 'PTHR35400:SF3', NULL, NULL, NULL, NULL, 'SLL1072 PROTEIN', 252064),
(418363, 'PTHR35400', NULL, NULL, NULL, NULL, 'SLR1083 PROTEIN', 252064),
(418364, 'PTHR45767', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN O', 252065),
(418365, 'PTHR45767:SF1', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN O1', 252065),
(418366, 'PTHR45767:SF2', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN O', 252065),
(418367, 'PTHR45767:SF3', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN O4', 252065),
(418368, 'PTHR45767:SF4', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN O3-RELATED', 252065),
(418369, 'PTHR45767:SF5', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN O6', 252065),
(418370, 'PTHR45767:SF7', NULL, NULL, NULL, NULL, 'FORKHEAD BOX O3A', 252065),
(418371, 'PTHR45767:SF8', NULL, NULL, NULL, NULL, 'FORKHEAD BOX O4', 252065),
(418372, 'PTHR30371:SF0', NULL, NULL, NULL, NULL, 'SEC-INDEPENDENT PROTEIN TRANSLOCASE PROTEIN TATC, CHLOROPLASTIC-RELATED', 252066),
(418373, 'PTHR30371:SF8', NULL, NULL, NULL, NULL, 'BNAA09G18470D PROTEIN', 252066),
(418374, 'PTHR30371', NULL, NULL, NULL, NULL, 'SEC-INDEPENDENT PROTEIN TRANSLOCASE PROTEIN TATC', 252066),
(418375, 'PTHR30371:SF9', NULL, NULL, NULL, NULL, 'BNAA06G35150D PROTEIN', 252066),
(418376, 'PTHR30371:SF4', NULL, NULL, NULL, NULL, 'SEC-INDEPENDENT PROTEIN TRANSLOCASE PROTEIN TATCD', 252066),
(418377, 'PTHR30371:SF6', NULL, NULL, NULL, NULL, 'SEC-INDEPENDENT PERIPLASMIC PROTEIN TRANSLOCASE TATC-RELATED', 252066),
(418378, 'PTHR47165', NULL, NULL, NULL, NULL, 'OS03G0429900 PROTEIN', 252067),
(418379, 'PTHR47165:SF1', NULL, NULL, NULL, NULL, 'HELITRON_LIKE_N DOMAIN-CONTAINING PROTEIN', 252067),
(418380, 'PTHR47165:SF3', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 252067),
(418381, 'PTHR47165:SF4', NULL, NULL, NULL, NULL, 'OS03G0429900 PROTEIN', 252067),
(418382, 'PTHR22748:SF18', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 252068),
(418383, 'PTHR22748:SF4', NULL, NULL, NULL, NULL, 'DNA-(APURINIC OR APYRIMIDINIC SITE) ENDONUCLEASE 2', 252068),
(418384, 'PTHR22748:SF14', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 252068),
(418385, 'PTHR22748', NULL, NULL, NULL, NULL, 'AP ENDONUCLEASE', 252068),
(418386, 'PTHR22748:SF6', NULL, NULL, NULL, NULL, 'DNA-(APURINIC OR APYRIMIDINIC SITE) ENDONUCLEASE', 252068),
(418387, 'PTHR22748:SF11', NULL, NULL, NULL, NULL, 'OS07G0184032 PROTEIN', 252068),
(418388, 'PTHR22748:SF22', NULL, NULL, NULL, NULL, '', 252068),
(418389, 'PTHR22748:SF20', NULL, NULL, NULL, NULL, 'DNA-(APURINIC OR APYRIMIDINIC SITE) ENDONUCLEASE', 252068),
(418390, 'PTHR22748:SF8', NULL, NULL, NULL, NULL, 'DNA-(APURINIC OR APYRIMIDINIC SITE) ENDONUCLEASE', 252068),
(418391, 'PTHR22748:SF21', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 252068),
(418392, 'PTHR22748:SF10', NULL, NULL, NULL, NULL, 'DNA-(APURINIC OR APYRIMIDINIC SITE) ENDONUCLEASE', 252068),
(418393, 'PTHR22748:SF19', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 252068),
(418394, 'PTHR28552', NULL, NULL, NULL, NULL, 'SHADOW OF PRION PROTEIN', 252069),
(418395, 'PTHR28552:SF1', NULL, NULL, NULL, NULL, 'SHADOW OF PRION PROTEIN', 252069),
(418396, 'PTHR45882:SF1', NULL, NULL, NULL, NULL, 'PITUITARY HOMEOBOX 1', 252070),
(418397, 'PTHR45882:SF4', NULL, NULL, NULL, NULL, 'PITUITARY HOMEOBOX 2', 252070),
(418398, 'PTHR45882:SF2', NULL, NULL, NULL, NULL, 'PITUITARY HOMEOBOX 3', 252070),
(418399, 'PTHR45882', NULL, NULL, NULL, NULL, 'PITUITARY HOMEOBOX HOMOLOG PTX1', 252070),
(418400, 'PTHR45882:SF3', NULL, NULL, NULL, NULL, 'PITUITARY HOMEOBOX HOMOLOG PTX1', 252070);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(418401, 'PTHR46613', NULL, NULL, NULL, NULL, 'RADIAL SPOKE HEAD 10 HOMOLOG B-RELATED', 252071),
(418402, 'PTHR46613:SF1', NULL, NULL, NULL, NULL, 'RADIAL SPOKE HEAD 10 HOMOLOG B-RELATED', 252071),
(418403, 'PTHR47474:SF1', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE RLPH2', 252072),
(418404, 'PTHR47474', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE RLPH2', 252072),
(418405, 'PTHR11384:SF63', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE-RELATED', 252073),
(418406, 'PTHR11384:SF62', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY D MEMBER 3', 252073),
(418407, 'PTHR11384:SF65', NULL, NULL, NULL, NULL, 'ABC TRANSMEMBRANE TYPE-1 DOMAIN-CONTAINING PROTEIN', 252073),
(418408, 'PTHR11384:SF21', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY D MEMBER 1', 252073),
(418409, 'PTHR11384:SF54', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER D FAMILY MEMBER 1', 252073),
(418410, 'PTHR11384:SF56', NULL, NULL, NULL, NULL, 'PEROXISOMAL LONG-CHAIN FATTY ACID IMPORT PROTEIN 2', 252073),
(418411, 'PTHR11384:SF67', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY D MEMBER', 252073),
(418412, 'PTHR11384:SF66', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE-RELATED', 252073),
(418413, 'PTHR11384:SF55', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE TRANSPORTER', 252073),
(418414, 'PTHR11384:SF24', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY D MEMBER 2', 252073),
(418415, 'PTHR11384:SF59', NULL, NULL, NULL, NULL, 'LYSOSOMAL COBALAMIN TRANSPORTER ABCD4', 252073),
(418416, 'PTHR11384', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE, SUB-FAMILY D MEMBER', 252073),
(418417, 'PTHR22741:SF5', NULL, NULL, NULL, NULL, 'SRC KINASE SIGNALING INHIBITOR 1', 252074),
(418418, 'PTHR22741:SF10', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN CG32809', 252074),
(418419, 'PTHR22741:SF11', NULL, NULL, NULL, NULL, 'SICKLE TAIL PROTEIN HOMOLOG', 252074),
(418420, 'PTHR22741', NULL, NULL, NULL, NULL, 'P140CAP/SNIP-RELATED', 252074),
(418421, 'PTHR33920', NULL, NULL, NULL, NULL, 'THIONIN-2.1-RELATED', 252075),
(418422, 'PTHR33920:SF2', NULL, NULL, NULL, NULL, 'THIONIN-2.1-RELATED', 252075),
(418423, 'PTHR33920:SF3', NULL, NULL, NULL, NULL, 'ACIDIC PROTEIN', 252075),
(418424, 'PTHR33920:SF6', NULL, NULL, NULL, NULL, 'ACIDIC PROTEIN', 252075),
(418425, 'PTHR33920:SF7', NULL, NULL, NULL, NULL, 'ACIDIC PROTEIN', 252075),
(418426, 'PTHR33920:SF8', NULL, NULL, NULL, NULL, 'BNAC02G17410D PROTEIN', 252075),
(418427, 'PTHR46824:SF5', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML50-RELATED', 252076),
(418428, 'PTHR46824', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML48-RELATED', 252076),
(418429, 'PTHR46824:SF7', NULL, NULL, NULL, NULL, 'BNAA03G55310D PROTEIN', 252076),
(418430, 'PTHR46824:SF1', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML49-RELATED', 252076),
(418431, 'PTHR46824:SF2', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML48-RELATED', 252076),
(418432, 'PTHR46824:SF10', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML49-RELATED', 252076),
(418433, 'PTHR46824:SF11', NULL, NULL, NULL, NULL, '', 252076),
(418434, 'PTHR28219:SF1', NULL, NULL, NULL, NULL, 'UPF0642 PROTEIN YBL028C', 252077),
(418435, 'PTHR28219', NULL, NULL, NULL, NULL, 'UPF0642 PROTEIN YBL028C', 252077),
(418436, 'PTHR38591', NULL, NULL, NULL, NULL, 'HYDROLASE', 252078),
(418437, 'PTHR38591:SF1', NULL, NULL, NULL, NULL, 'BLL1000 PROTEIN', 252078),
(418438, 'PTHR31623:SF111', NULL, NULL, NULL, NULL, 'STEMMADENINE O-ACETYLTRANSFERASE-LIKE', 252079),
(418439, 'PTHR31623:SF110', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE', 252079),
(418440, 'PTHR31623:SF83', NULL, NULL, NULL, NULL, 'PELARGONIDIN 3-O-(6-CAFFEOYLGLUCOSIDE) 5-O-(6-O-MALONYLGLUCOSIDE) 4''''''-MALONYLTRANSFERASE-LIKE', 252079),
(418441, 'PTHR31623:SF82', NULL, NULL, NULL, NULL, 'TRANSFERASE, CHLORAMPHENICOL ACETYLTRANSFERASE-LIKE DOMAIN PROTEIN-RELATED', 252079),
(418442, 'PTHR31623:SF41', NULL, NULL, NULL, NULL, 'ACYLSUGAR ACYLTRANSFERASE 3-LIKE', 252079),
(418443, 'PTHR31623:SF84', NULL, NULL, NULL, NULL, 'HXXXD-TYPE ACYL-TRANSFERASE FAMILY PROTEIN-RELATED', 252079);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(418444, 'PTHR31623:SF40', NULL, NULL, NULL, NULL, 'ACYLSUGAR ACYLTRANSFERASE 3-LIKE', 252079),
(418445, 'PTHR31623:SF81', NULL, NULL, NULL, NULL, 'ACYLSUGAR ACYLTRANSFERASE 3-LIKE', 252079),
(418446, 'PTHR31623:SF80', NULL, NULL, NULL, NULL, 'DEACETYLVINDOLINE O-ACETYLTRANSFERASE-RELATED', 252079),
(418447, 'PTHR31623:SF36', NULL, NULL, NULL, NULL, 'STEMMADENINE O-ACETYLTRANSFERASE-LIKE', 252079),
(418448, 'PTHR31623:SF79', NULL, NULL, NULL, NULL, 'N-BENZOYLTRANSFERASE PROTEIN, PUTATIVE-RELATED', 252079),
(418449, 'PTHR31623:SF38', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE PUN1', 252079),
(418450, 'PTHR31623:SF76', NULL, NULL, NULL, NULL, 'BNAA04G13350D PROTEIN', 252079),
(418451, 'PTHR31623:SF31', NULL, NULL, NULL, NULL, 'HXXXD-TYPE ACYL-TRANSFERASE FAMILY PROTEIN', 252079),
(418452, 'PTHR31623:SF75', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE', 252079),
(418453, 'PTHR31623:SF34', NULL, NULL, NULL, NULL, 'ACETYL-COA-BENZYLALCOHOL ACETYLTRANSFERASE-LIKE', 252079),
(418454, 'PTHR31623:SF33', NULL, NULL, NULL, NULL, 'STEMMADENINE O-ACETYLTRANSFERASE-LIKE', 252079),
(418455, 'PTHR31623:SF113', NULL, NULL, NULL, NULL, 'ANTHOCYANIN ACYLTRANSFERASE', 252079),
(418456, 'PTHR31623:SF112', NULL, NULL, NULL, NULL, 'N-BENZOYLTRANSFERASE PROTEIN, PUTATIVE-RELATED', 252079),
(418457, 'PTHR31623:SF115', NULL, NULL, NULL, NULL, '', 252079),
(418458, 'PTHR31623:SF114', NULL, NULL, NULL, NULL, 'SALUTARIDINOL 7-O-ACETYLTRANSFERASE-LIKE', 252079),
(418459, 'PTHR31623:SF39', NULL, NULL, NULL, NULL, 'ACYLSUGAR ACYLTRANSFERASE 3-LIKE', 252079),
(418460, 'PTHR31623:SF100', NULL, NULL, NULL, NULL, 'VINORINE SYNTHASE-LIKE', 252079),
(418461, 'PTHR31623:SF50', NULL, NULL, NULL, NULL, 'ANTHRANILATE N-BENZOYLTRANSFERASE PROTEIN', 252079),
(418462, 'PTHR31623:SF52', NULL, NULL, NULL, NULL, 'AT1', 252079),
(418463, 'PTHR31623:SF92', NULL, NULL, NULL, NULL, 'HXXXD-TYPE ACYL-TRANSFERASE FAMILY PROTEIN-RELATED', 252079),
(418464, 'PTHR31623:SF91', NULL, NULL, NULL, NULL, '', 252079),
(418465, 'PTHR31623:SF47', NULL, NULL, NULL, NULL, 'BAHD ACYLTRANSFERASE BIA1', 252079),
(418466, 'PTHR31623:SF46', NULL, NULL, NULL, NULL, 'F21J9.9', 252079),
(418467, 'PTHR31623:SF109', NULL, NULL, NULL, NULL, 'VINORINE SYNTHASE-RELATED', 252079),
(418468, 'PTHR31623:SF49', NULL, NULL, NULL, NULL, 'ACYLSUGAR ACYLTRANSFERASE 3-LIKE', 252079),
(418469, 'PTHR31623:SF43', NULL, NULL, NULL, NULL, 'BNAA06G39100D PROTEIN', 252079),
(418470, 'PTHR31623:SF87', NULL, NULL, NULL, NULL, 'ACETYL-COA:BENZYLALCOHOL ACETYLTRANFERASE-LIKE PROTEIN', 252079),
(418471, 'PTHR31623:SF86', NULL, NULL, NULL, NULL, 'TRANSFERASE, CHLORAMPHENICOL ACETYLTRANSFERASE-LIKE DOMAIN PROTEIN-RELATED', 252079),
(418472, 'PTHR31623:SF89', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE', 252079),
(418473, 'PTHR31623:SF45', NULL, NULL, NULL, NULL, 'ACYLSUGAR ACYLTRANSFERASE 3-LIKE', 252079),
(418474, 'PTHR31623:SF88', NULL, NULL, NULL, NULL, 'N-BENZOYLTRANSFERASE PROTEIN, PUTATIVE-RELATED', 252079),
(418475, 'PTHR31623:SF101', NULL, NULL, NULL, NULL, 'TRANSFERASE, CHLORAMPHENICOL ACETYLTRANSFERASE-LIKE DOMAIN PROTEIN-RELATED', 252079),
(418476, 'PTHR31623:SF104', NULL, NULL, NULL, NULL, 'ACETYL-COA-BENZYLALCOHOL ACETYLTRANSFERASE-LIKE', 252079),
(418477, 'PTHR31623:SF103', NULL, NULL, NULL, NULL, 'HXXXD-TYPE ACYL-TRANSFERASE FAMILY PROTEIN', 252079),
(418478, 'PTHR31623:SF106', NULL, NULL, NULL, NULL, 'N-BENZOYLTRANSFERASE, PUTATIVE-RELATED', 252079),
(418479, 'PTHR31623:SF105', NULL, NULL, NULL, NULL, 'VINORINE SYNTHASE-LIKE', 252079),
(418480, 'PTHR31623:SF108', NULL, NULL, NULL, NULL, 'VINORINE SYNTHASE-LIKE', 252079),
(418481, 'PTHR31623:SF107', NULL, NULL, NULL, NULL, '', 252079),
(418482, 'PTHR31623:SF61', NULL, NULL, NULL, NULL, 'PELARGONIDIN 3-O-(6-CAFFEOYLGLUCOSIDE) 5-O-(6-O-MALONYLGLUCOSIDE) 4''''''-MALONYLTRANSFERASE-LIKE', 252079),
(418483, 'PTHR31623:SF60', NULL, NULL, NULL, NULL, 'VINORINE SYNTHASE-LIKE', 252079),
(418484, 'PTHR31623:SF63', NULL, NULL, NULL, NULL, 'ACYLSUGAR ACYLTRANSFERASE 3', 252079),
(418485, 'PTHR31623:SF62', NULL, NULL, NULL, NULL, 'BNAA03G57990D PROTEIN', 252079);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(418486, 'PTHR31623:SF57', NULL, NULL, NULL, NULL, 'BNAC08G49150D PROTEIN', 252079),
(418487, 'PTHR31623', NULL, NULL, NULL, NULL, 'F21J9.9', 252079),
(418488, 'PTHR31623:SF59', NULL, NULL, NULL, NULL, 'F21J9.8', 252079),
(418489, 'PTHR31623:SF54', NULL, NULL, NULL, NULL, 'ACYLSUGAR ACYLTRANSFERASE 3-LIKE', 252079),
(418490, 'PTHR31623:SF53', NULL, NULL, NULL, NULL, 'STEMMADENINE O-ACETYLTRANSFERASE-LIKE', 252079),
(418491, 'PTHR31623:SF56', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE', 252079),
(418492, 'PTHR31623:SF55', NULL, NULL, NULL, NULL, 'TRANSFERASE, CHLORAMPHENICOL ACETYLTRANSFERASE-LIKE DOMAIN PROTEIN-RELATED', 252079),
(418493, 'PTHR31623:SF99', NULL, NULL, NULL, NULL, 'STEMMADENINE O-ACETYLTRANSFERASE-LIKE', 252079),
(418494, 'PTHR31623:SF17', NULL, NULL, NULL, NULL, 'TRANSFERASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_3G03580)', 252079),
(418495, 'PTHR31623:SF19', NULL, NULL, NULL, NULL, 'VINORINE SYNTHASE-RELATED', 252079),
(418496, 'PTHR31623:SF72', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE', 252079),
(418497, 'PTHR31623:SF74', NULL, NULL, NULL, NULL, 'ANTHOCYANIN ACYLTRANSFERASE', 252079),
(418498, 'PTHR31623:SF73', NULL, NULL, NULL, NULL, 'BNAA04G13400D PROTEIN', 252079),
(418499, 'PTHR31623:SF70', NULL, NULL, NULL, NULL, 'PELARGONIDIN PROTEIN-RELATED', 252079),
(418500, 'PTHR31623:SF69', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE', 252079),
(418501, 'PTHR31623:SF25', NULL, NULL, NULL, NULL, 'VINORINE SYNTHASE-LIKE', 252079),
(418502, 'PTHR31623:SF68', NULL, NULL, NULL, NULL, 'ANTHOCYANIN ACYLTRANSFERASE', 252079),
(418503, 'PTHR31623:SF24', NULL, NULL, NULL, NULL, 'HXXXD-TYPE ACYL-TRANSFERASE FAMILY PROTEIN', 252079),
(418504, 'PTHR31623:SF27', NULL, NULL, NULL, NULL, 'VINORINE SYNTHASE-LIKE', 252079),
(418505, 'PTHR31623:SF65', NULL, NULL, NULL, NULL, 'ANTHOCYANIN ACYLTRANSFERASE', 252079),
(418506, 'PTHR31623:SF21', NULL, NULL, NULL, NULL, 'VINORINE SYNTHASE-LIKE', 252079),
(418507, 'PTHR31623:SF64', NULL, NULL, NULL, NULL, 'ANTHOCYANIN ACYLTRANSFERASE', 252079),
(418508, 'PTHR31623:SF20', NULL, NULL, NULL, NULL, 'VINORINE SYNTHASE-LIKE', 252079),
(418509, 'PTHR31623:SF23', NULL, NULL, NULL, NULL, 'ACETYL-COA-BENZYLALCOHOL ACETYLTRANSFERASE-LIKE', 252079),
(418510, 'PTHR31623:SF22', NULL, NULL, NULL, NULL, 'ACETYL-COA:BENZYLALCOHOL ACETYLTRANFERASE-LIKE PROTEIN-RELATED', 252079),
(418511, 'PTHR31623:SF29', NULL, NULL, NULL, NULL, 'ACYLSUGAR ACYLTRANSFERASE 3-LIKE', 252079),
(418512, 'PTHR31623:SF28', NULL, NULL, NULL, NULL, 'VINORINE SYNTHASE-LIKE', 252079),
(418513, 'PTHR31136', NULL, NULL, NULL, NULL, 'DUF1338 DOMAIN-CONTAINING PROTEIN', 252080),
(418514, 'PTHR31136:SF4', NULL, NULL, NULL, NULL, 'PLANT/PROTEIN', 252080),
(418515, 'PTHR31136:SF3', NULL, NULL, NULL, NULL, 'DUF1338 DOMAIN-CONTAINING PROTEIN', 252080),
(418516, 'PTHR31136:SF6', NULL, NULL, NULL, NULL, 'DUF1338 DOMAIN-CONTAINING PROTEIN', 252080),
(418517, 'PTHR31136:SF5', NULL, NULL, NULL, NULL, 'OS10G0463800 PROTEIN', 252080),
(418518, 'PTHR31136:SF7', NULL, NULL, NULL, NULL, 'DUF1338 DOMAIN-CONTAINING PROTEIN', 252080),
(418519, 'PTHR11818:SF19', NULL, NULL, NULL, NULL, 'BETA-CRYSTALLIN A4', 252081),
(418520, 'PTHR11818:SF2', NULL, NULL, NULL, NULL, 'BETA/GAMMA CRYSTALLIN DOMAIN-CONTAINING PROTEIN 1', 252081),
(418521, 'PTHR11818:SF38', NULL, NULL, NULL, NULL, 'VERY LARGE A-KINASE ANCHOR PROTEIN', 252081),
(418522, 'PTHR11818:SF15', NULL, NULL, NULL, NULL, 'CRYSTALLIN BETA GAMMA X', 252081),
(418523, 'PTHR11818:SF6', NULL, NULL, NULL, NULL, 'GAMMA-CRYSTALLIN S', 252081),
(418524, 'PTHR11818:SF7', NULL, NULL, NULL, NULL, 'BETA-CRYSTALLIN A2', 252081),
(418525, 'PTHR11818', NULL, NULL, NULL, NULL, 'BETA/GAMMA CRYSTALLIN', 252081),
(418526, 'PTHR11818:SF8', NULL, NULL, NULL, NULL, 'BETA-CRYSTALLIN A3', 252081),
(418527, 'PTHR11818:SF119', NULL, NULL, NULL, NULL, 'GAMMA-CRYSTALLIN D', 252081),
(418528, 'PTHR11818:SF22', NULL, NULL, NULL, NULL, 'GAMMA-CRYSTALLIN N', 252081),
(418529, 'PTHR11818:SF21', NULL, NULL, NULL, NULL, 'CRYSTALLIN, BETA B1,-LIKE 3', 252081),
(418530, 'PTHR11818:SF42', NULL, NULL, NULL, NULL, 'RICIN B-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 252081);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(418531, 'PTHR11818:SF62', NULL, NULL, NULL, NULL, 'CRYGM2B PROTEIN-RELATED', 252081),
(418532, 'PTHR11818:SF50', NULL, NULL, NULL, NULL, 'BETA/GAMMA CRYSTALLIN DOMAIN-CONTAINING PROTEIN 2', 252081),
(418533, 'PTHR11818:SF124', NULL, NULL, NULL, NULL, 'GAMMA-CRYSTALLIN D', 252081),
(418534, 'PTHR11818:SF123', NULL, NULL, NULL, NULL, 'GAMMA-CRYSTALLIN A', 252081),
(418535, 'PTHR11818:SF101', NULL, NULL, NULL, NULL, 'GAMMA-CRYSTALLIN B', 252081),
(418536, 'PTHR11818:SF122', NULL, NULL, NULL, NULL, 'SI:DKEY-57A22.15', 252081),
(418537, 'PTHR11818:SF13', NULL, NULL, NULL, NULL, 'BETA-CRYSTALLIN B3', 252081),
(418538, 'PTHR11818:SF12', NULL, NULL, NULL, NULL, 'BETA-CRYSTALLIN B1', 252081),
(418539, 'PTHR11818:SF55', NULL, NULL, NULL, NULL, 'CRYSTALLIN, BETA B1,-LIKE 1-RELATED', 252081),
(418540, 'PTHR11818:SF107', NULL, NULL, NULL, NULL, 'CRYGMX PROTEIN', 252081),
(418541, 'PTHR11818:SF11', NULL, NULL, NULL, NULL, 'BETA-CRYSTALLIN B2', 252081),
(418542, 'PTHR11818:SF129', NULL, NULL, NULL, NULL, 'CRYSTALLIN, GAMMA M6-RELATED', 252081),
(418543, 'PTHR11818:SF128', NULL, NULL, NULL, NULL, '', 252081),
(418544, 'PTHR11818:SF32', NULL, NULL, NULL, NULL, 'GAMMA-CRYSTALLIN C', 252081),
(418545, 'PTHR11818:SF54', NULL, NULL, NULL, NULL, 'BETA A1-2-CRYSTALLIN-RELATED', 252081),
(418546, 'PTHR11818:SF98', NULL, NULL, NULL, NULL, 'CRYGM5 PROTEIN', 252081),
(418547, 'PTHR11818:SF127', NULL, NULL, NULL, NULL, 'SI:DKEY-57A22.13', 252081),
(418548, 'PTHR11818:SF126', NULL, NULL, NULL, NULL, 'CRYSTALLIN, GAMMA MX,-LIKE 2-RELATED', 252081),
(418549, 'PTHR11818:SF103', NULL, NULL, NULL, NULL, '', 252081),
(418550, 'PTHR11818:SF125', NULL, NULL, NULL, NULL, 'GAMMA-CRYSTALLIN E-RELATED', 252081),
(418551, 'PTHR30504', NULL, NULL, NULL, NULL, 'GLUCANS BIOSYNTHESIS PROTEIN', 252082),
(418552, 'PTHR30504:SF2', NULL, NULL, NULL, NULL, 'GLUCANS BIOSYNTHESIS PROTEIN G', 252082),
(418553, 'PTHR30504:SF3', NULL, NULL, NULL, NULL, 'GLUCANS BIOSYNTHESIS PROTEIN D', 252082),
(418554, 'PTHR19336', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED DUF1167', 252083),
(418555, 'PTHR19336:SF9', NULL, NULL, NULL, NULL, 'SPINDLE POLE BODY PROTEIN PPC89', 252083),
(418556, 'PTHR19336:SF12', NULL, NULL, NULL, NULL, '', 252083),
(418557, 'PTHR19336:SF11', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 57 KDA', 252083),
(418558, 'PTHR19336:SF10', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN CEP57L1', 252083),
(418559, 'PTHR24049:SF26', NULL, NULL, NULL, NULL, 'EYES SHUT HOMOLOG', 252084),
(418560, 'PTHR24049:SF27', NULL, NULL, NULL, NULL, 'DELTA-LIKE PROTEIN', 252084),
(418561, 'PTHR24049:SF28', NULL, NULL, NULL, NULL, 'NOTCH RECEPTOR 3', 252084),
(418562, 'PTHR24049:SF18', NULL, NULL, NULL, NULL, 'DELTA-LIKE PROTEIN', 252084),
(418563, 'PTHR24049:SF22', NULL, NULL, NULL, NULL, 'DROSOPHILA CRUMBS HOMOLOG', 252084),
(418564, 'PTHR24049:SF24', NULL, NULL, NULL, NULL, 'CRUMBS CELL POLARITY COMPLEX COMPONENT 2B', 252084),
(418565, 'PTHR24049:SF25', NULL, NULL, NULL, NULL, 'NEUROGENIC LOCUS NOTCH HOMOLOG PROTEIN 1', 252084),
(418566, 'PTHR24049', NULL, NULL, NULL, NULL, 'CRUMBS FAMILY MEMBER', 252084),
(418567, 'PTHR24049:SF19', NULL, NULL, NULL, NULL, 'PROTEIN CRUMBS HOMOLOG 2', 252084),
(418568, 'PTHR24049:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CRUMBS HOMOLOG 1', 252084),
(418569, 'PTHR43918:SF2', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 252085),
(418570, 'PTHR43918:SF13', NULL, NULL, NULL, NULL, 'ACETYLCHOLINESTERASE', 252085),
(418571, 'PTHR43918:SF4', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 252085),
(418572, 'PTHR43918:SF5', NULL, NULL, NULL, NULL, 'CHOLINESTERASE', 252085),
(418573, 'PTHR43918:SF12', NULL, NULL, NULL, NULL, 'ACETYLCHOLINESTERASE 1', 252085),
(418574, 'PTHR43918:SF9', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 252085),
(418575, 'PTHR43918:SF11', NULL, NULL, NULL, NULL, 'ACETYLCHOLINESTERASE', 252085),
(418576, 'PTHR43918', NULL, NULL, NULL, NULL, 'ACETYLCHOLINESTERASE', 252085),
(418577, 'PTHR28549:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252086),
(418578, 'PTHR28549:SF1', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN INTEGRAL MEMBRANE PROTEIN 1', 252086);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(418579, 'PTHR28549', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN INTEGRAL MEMBRANE PROTEIN 1', 252086),
(418580, 'PTHR42961:SF2', NULL, NULL, NULL, NULL, 'IRON-SULFUR PROTEIN NUBPL', 252087),
(418581, 'PTHR42961', NULL, NULL, NULL, NULL, 'IRON-SULFUR PROTEIN NUBPL', 252087),
(418582, 'PTHR12309', NULL, NULL, NULL, NULL, 'SEC61 GAMMA SUBUNIT', 252088),
(418583, 'PTHR12309:SF26', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC61 GAMMA SUBUNIT', 252088),
(418584, 'PTHR12309:SF27', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC61 SUBUNIT GAMMA', 252088),
(418585, 'PTHR12309:SF28', NULL, NULL, NULL, NULL, 'OS06G0653900 PROTEIN', 252088),
(418586, 'PTHR12309:SF33', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC61 SUBUNIT GAMMA-1', 252088),
(418587, 'PTHR12309:SF25', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC61 SUBUNIT GAMMA', 252088),
(418588, 'PTHR12309:SF30', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC61 GAMMA SUBUNIT', 252088),
(418589, 'PTHR12309:SF31', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORTER SEC61 SUBUNIT GAMMA-LIKE PROTEIN', 252088),
(418590, 'PTHR12309:SF32', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC61 SUBUNIT GAMMA-LIKE', 252088),
(418591, 'PTHR12309:SF5', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC61 SUBUNIT GAMMA', 252088),
(418592, 'PTHR13376:SF0', NULL, NULL, NULL, NULL, 'INTRAFLAGELLAR TRANSPORT PROTEIN 46 HOMOLOG', 252089),
(418593, 'PTHR13376', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252089),
(418594, 'PTHR10619:SF0', NULL, NULL, NULL, NULL, 'F-ACTIN-CAPPING PROTEIN SUBUNIT BETA', 252090),
(418595, 'PTHR10619', NULL, NULL, NULL, NULL, 'F-ACTIN-CAPPING PROTEIN SUBUNIT BETA', 252090),
(418596, 'PTHR30121:SF10', NULL, NULL, NULL, NULL, 'TRBE PROTEIN', 252091),
(418597, 'PTHR30121:SF1', NULL, NULL, NULL, NULL, 'DUF87 DOMAIN-CONTAINING PROTEIN', 252091),
(418598, 'PTHR30121:SF11', NULL, NULL, NULL, NULL, 'DUF87 DOMAIN-CONTAINING PROTEIN', 252091),
(418599, 'PTHR30121', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN YJGR-RELATED', 252091),
(418600, 'PTHR30121:SF6', NULL, NULL, NULL, NULL, 'TYPE IV SECRETION SYSTEM PROTEIN CAGE', 252091),
(418601, 'PTHR39085', NULL, NULL, NULL, NULL, 'SLL0924 PROTEIN', 252092),
(418602, 'PTHR39085:SF1', NULL, NULL, NULL, NULL, 'SLL0924 PROTEIN', 252092),
(418603, 'PTHR47026:SF2', NULL, NULL, NULL, NULL, 'PIGMENTOSA GTPASE REGULATOR-LIKE PROTEIN, PUTATIVE-RELATED', 252093),
(418604, 'PTHR47026', NULL, NULL, NULL, NULL, 'PIGMENTOSA GTPASE REGULATOR-LIKE PROTEIN, PUTATIVE-RELATED', 252093),
(418605, 'PTHR37404:SF1', NULL, NULL, NULL, NULL, 'HCG1796489', 252094),
(418606, 'PTHR37404', NULL, NULL, NULL, NULL, 'HCG1796489', 252094),
(418607, 'PTHR42208:SF1', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORTER-RELATED', 252095),
(418608, 'PTHR42208', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORTER-RELATED', 252095),
(418609, 'PTHR13987:SF3', NULL, NULL, NULL, NULL, 'PROTEIN BEX4', 252096),
(418610, 'PTHR13987', NULL, NULL, NULL, NULL, 'PROTEIN BEX4', 252096),
(418611, 'PTHR37157:SF4', NULL, NULL, NULL, NULL, '', 252097),
(418612, 'PTHR37157', NULL, NULL, NULL, NULL, 'PRION-LIKE-(Q/N-RICH) DOMAIN-BEARING PROTEIN 25', 252097),
(418613, 'PTHR37157:SF2', NULL, NULL, NULL, NULL, 'PRION-LIKE-(Q/N-RICH) DOMAIN-BEARING PROTEIN 25', 252097),
(418614, 'PTHR37157:SF3', NULL, NULL, NULL, NULL, 'EB DOMAIN-CONTAINING PROTEIN-RELATED', 252097),
(418615, 'PTHR45997', NULL, NULL, NULL, NULL, 'DNA LIGASE 4', 252098),
(418616, 'PTHR45997:SF2', NULL, NULL, NULL, NULL, 'ATP DEPENDENT DNA LIGASE DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_5G02430)', 252098),
(418617, 'PTHR45997:SF1', NULL, NULL, NULL, NULL, 'DNA LIGASE 4', 252098),
(418618, 'PTHR31721:SF8', NULL, NULL, NULL, NULL, '', 252099),
(418619, 'PTHR31721:SF7', NULL, NULL, NULL, NULL, '', 252099),
(418620, 'PTHR31721', NULL, NULL, NULL, NULL, 'OS06G0710300 PROTEIN', 252099),
(418621, 'PTHR31721:SF6', NULL, NULL, NULL, NULL, 'BNAC09G43360D PROTEIN', 252099),
(418622, 'PTHR31721:SF5', NULL, NULL, NULL, NULL, '', 252099),
(418623, 'PTHR31721:SF4', NULL, NULL, NULL, NULL, 'OS06G0710300 PROTEIN', 252099);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(418624, 'PTHR31721:SF3', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252099),
(418625, 'PTHR31721:SF1', NULL, NULL, NULL, NULL, 'OS07G0656700 PROTEIN', 252099),
(418626, 'PTHR24204:SF2', NULL, NULL, NULL, NULL, 'INSULIN GENE ENHANCER PROTEIN ISL-2', 252100),
(418627, 'PTHR24204:SF4', NULL, NULL, NULL, NULL, 'INSULIN GENE ENHANCER PROTEIN ISL-1', 252100),
(418628, 'PTHR24204:SF7', NULL, NULL, NULL, NULL, 'LIM HOMEOBOX TRANSCRIPTION FACTOR 1-ALPHA-LIKE', 252100),
(418629, 'PTHR24204:SF8', NULL, NULL, NULL, NULL, 'TAILUP, ISOFORM A', 252100),
(418630, 'PTHR24204', NULL, NULL, NULL, NULL, 'INSULIN GENE ENHANCER PROTEIN', 252100),
(418631, 'PTHR24204:SF10', NULL, NULL, NULL, NULL, 'LIM DOMAIN ONLY 4', 252100),
(418632, 'PTHR33935:SF2', NULL, NULL, NULL, NULL, 'OS03G0245200 PROTEIN', 252101),
(418633, 'PTHR33935:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252101),
(418634, 'PTHR33935:SF12', NULL, NULL, NULL, NULL, '', 252101),
(418635, 'PTHR33935:SF17', NULL, NULL, NULL, NULL, 'OS10G0150400 PROTEIN', 252101),
(418636, 'PTHR33935:SF18', NULL, NULL, NULL, NULL, 'OS10G0149400 PROTEIN', 252101),
(418637, 'PTHR33935:SF6', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252101),
(418638, 'PTHR33935:SF15', NULL, NULL, NULL, NULL, 'OS10G0148100 PROTEIN', 252101),
(418639, 'PTHR33935', NULL, NULL, NULL, NULL, 'OS10G0148100 PROTEIN', 252101),
(418640, 'PTHR33935:SF4', NULL, NULL, NULL, NULL, '', 252101),
(418641, 'PTHR33935:SF19', NULL, NULL, NULL, NULL, 'OS10G0150300 PROTEIN', 252101),
(418642, 'PTHR33935:SF20', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN', 252101),
(418643, 'PTHR14627', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 204', 252102),
(418644, 'PTHR14627:SF0', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 204', 252102),
(418645, 'PTHR42088', NULL, NULL, NULL, NULL, 'YALI0F10131P', 252103),
(418646, 'PTHR42088:SF1', NULL, NULL, NULL, NULL, 'YALI0F10131P', 252103),
(418647, 'PTHR48214', NULL, NULL, NULL, NULL, 'ZEIN-ALPHA PMS2', 252104),
(418648, 'PTHR48214:SF1', NULL, NULL, NULL, NULL, 'ZEIN-ALPHA PMS2', 252104),
(418649, 'PTHR36106:SF3', NULL, NULL, NULL, NULL, 'ANAEROBIC C4-DICARBOXYLATE TRANSPORTER DCUB', 252105),
(418650, 'PTHR36106', NULL, NULL, NULL, NULL, 'ANAEROBIC C4-DICARBOXYLATE TRANSPORTER DCUB', 252105),
(418651, 'PTHR36106:SF1', NULL, NULL, NULL, NULL, 'ANAEROBIC C4-DICARBOXYLATE TRANSPORTER DCUB', 252105),
(418652, 'PTHR36106:SF2', NULL, NULL, NULL, NULL, 'ANAEROBIC C4-DICARBOXYLATE TRANSPORTER DCUA', 252105),
(418653, 'PTHR38149:SF1', NULL, NULL, NULL, NULL, '', 252106),
(418654, 'PTHR38149', NULL, NULL, NULL, NULL, '', 252106),
(418655, 'PTHR32438', NULL, NULL, NULL, NULL, '4-ALPHA-GLUCANOTRANSFERASE DPE1, CHLOROPLASTIC/AMYLOPLASTIC', 252107),
(418656, 'PTHR32438:SF5', NULL, NULL, NULL, NULL, '4-ALPHA-GLUCANOTRANSFERASE DPE1, CHLOROPLASTIC/AMYLOPLASTIC', 252107),
(418657, 'PTHR47570:SF1', NULL, NULL, NULL, NULL, 'ZINC ION BINDING PROTEIN', 252108),
(418658, 'PTHR47570:SF2', NULL, NULL, NULL, NULL, 'MYND-TYPE DOMAIN-CONTAINING PROTEIN', 252108),
(418659, 'PTHR47570', NULL, NULL, NULL, NULL, 'ZINC ION BINDING PROTEIN', 252108),
(418660, 'PTHR23526:SF2', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY MFS_1', 252109),
(418661, 'PTHR23526:SF1', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY MFS_1', 252109),
(418662, 'PTHR23526', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE TRANSPORT PROTEIN-RELATED', 252109),
(418663, 'PTHR23526:SF3', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 252109),
(418664, 'PTHR31746', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 229 FAMILY MEMBER', 252110),
(418665, 'PTHR31746:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 229B', 252110),
(418666, 'PTHR31746:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 229A', 252110),
(418667, 'PTHR36149:SF1', NULL, NULL, NULL, NULL, 'HEAVY CHAIN, PUTATIVE-RELATED', 252111),
(418668, 'PTHR36149:SF4', NULL, NULL, NULL, NULL, '', 252111),
(418669, 'PTHR36149', NULL, NULL, NULL, NULL, 'HEAVY CHAIN, PUTATIVE-RELATED', 252111),
(418670, 'PTHR35395', NULL, NULL, NULL, NULL, '', 252112);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(418671, 'PTHR35395:SF1', NULL, NULL, NULL, NULL, '', 252112),
(418672, 'PTHR39608', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_5G08640)', 252113),
(418673, 'PTHR39608:SF2', NULL, NULL, NULL, NULL, 'MARVEL DOMAIN-CONTAINING PROTEIN', 252113),
(418674, 'PTHR39608:SF1', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_5G08640)', 252113),
(418675, 'PTHR33193', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (DUF3511)-RELATED', 252114),
(418676, 'PTHR33193:SF62', NULL, NULL, NULL, NULL, 'FAMILY ABC TRANSPORTER, PUTATIVE (DUF3511)-RELATED', 252114),
(418677, 'PTHR33193:SF41', NULL, NULL, NULL, NULL, '', 252114),
(418678, 'PTHR33193:SF43', NULL, NULL, NULL, NULL, 'DUF3511 DOMAIN PROTEIN', 252114),
(418679, 'PTHR33193:SF27', NULL, NULL, NULL, NULL, 'OS07G0690200 PROTEIN', 252114),
(418680, 'PTHR33193:SF66', NULL, NULL, NULL, NULL, 'DUF3511 DOMAIN PROTEIN', 252114),
(418681, 'PTHR33193:SF44', NULL, NULL, NULL, NULL, 'BNAA05G31540D PROTEIN', 252114),
(418682, 'PTHR33193:SF45', NULL, NULL, NULL, NULL, 'BNAA07G35980D PROTEIN', 252114),
(418683, 'PTHR33193:SF67', NULL, NULL, NULL, NULL, 'DUF3511 DOMAIN PROTEIN', 252114),
(418684, 'PTHR33193:SF68', NULL, NULL, NULL, NULL, '', 252114),
(418685, 'PTHR33193:SF46', NULL, NULL, NULL, NULL, 'BNAA02G16090D PROTEIN', 252114),
(418686, 'PTHR33193:SF69', NULL, NULL, NULL, NULL, 'OS06G0564100 PROTEIN', 252114),
(418687, 'PTHR33193:SF47', NULL, NULL, NULL, NULL, '', 252114),
(418688, 'PTHR33193:SF51', NULL, NULL, NULL, NULL, 'OS01G0306200 PROTEIN', 252114),
(418689, 'PTHR33193:SF73', NULL, NULL, NULL, NULL, 'DUF3511 DOMAIN PROTEIN', 252114),
(418690, 'PTHR33193:SF30', NULL, NULL, NULL, NULL, '', 252114),
(418691, 'PTHR33193:SF53', NULL, NULL, NULL, NULL, '', 252114),
(418692, 'PTHR33193:SF32', NULL, NULL, NULL, NULL, 'OS05G0356800 PROTEIN', 252114),
(418693, 'PTHR33193:SF70', NULL, NULL, NULL, NULL, 'BNAC01G37350D PROTEIN', 252114),
(418694, 'PTHR33193:SF71', NULL, NULL, NULL, NULL, 'OS01G0567400 PROTEIN', 252114),
(418695, 'PTHR33193:SF72', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (DUF3511)-RELATED', 252114),
(418696, 'PTHR33193:SF50', NULL, NULL, NULL, NULL, '', 252114),
(418697, 'PTHR33193:SF59', NULL, NULL, NULL, NULL, 'DUF3511 DOMAIN PROTEIN (DUF3511)', 252114),
(418698, 'PTHR33193:SF33', NULL, NULL, NULL, NULL, 'BNAANNG02720D PROTEIN', 252114),
(418699, 'PTHR33193:SF56', NULL, NULL, NULL, NULL, '', 252114),
(418700, 'PTHR33193:SF7', NULL, NULL, NULL, NULL, 'OS06G0686600 PROTEIN', 252114),
(418701, 'PTHR33193:SF34', NULL, NULL, NULL, NULL, 'OS02G0223700 PROTEIN', 252114),
(418702, 'PTHR33193:SF13', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252114),
(418703, 'PTHR11876:SF6', NULL, NULL, NULL, NULL, 'DEFENSIN-5', 252115),
(418704, 'PTHR11876:SF31', NULL, NULL, NULL, NULL, 'DEFENSIN ALPHA 10-RELATED', 252115),
(418705, 'PTHR11876', NULL, NULL, NULL, NULL, 'ALPHA-DEFENSIN 1', 252115),
(418706, 'PTHR11876:SF23', NULL, NULL, NULL, NULL, 'NEUTROPHIL DEFENSIN 4', 252115),
(418707, 'PTHR11876:SF34', NULL, NULL, NULL, NULL, 'RHESUS THETA DEFENSIN-1/3 SUBUNIT A', 252115),
(418708, 'PTHR11876:SF33', NULL, NULL, NULL, NULL, 'DEFENSIN-7', 252115),
(418709, 'PTHR11876:SF28', NULL, NULL, NULL, NULL, 'ALPHA-DEFENSIN 1', 252115),
(418710, 'PTHR11876:SF3', NULL, NULL, NULL, NULL, 'DEFENSIN-6', 252115),
(418711, 'PTHR11876:SF2', NULL, NULL, NULL, NULL, 'ALPHA-DEFENSIN 1-RELATED', 252115),
(418712, 'PTHR11876:SF19', NULL, NULL, NULL, NULL, 'NEUTROPHIL DEFENSIN 1-RELATED', 252115),
(418713, 'PTHR30455', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR NRDR', 252116),
(418714, 'PTHR30455:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR NRDR', 252116),
(418715, 'PTHR32176:SF91', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418716, 'PTHR32176:SF92', NULL, NULL, NULL, NULL, 'XYLOSE ISOMERASE', 252117),
(418717, 'PTHR32176:SF70', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418718, 'PTHR32176:SF111', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418719, 'PTHR32176:SF110', NULL, NULL, NULL, NULL, 'PATATIN', 252117);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(418720, 'PTHR32176:SF51', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418721, 'PTHR32176:SF95', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418722, 'PTHR32176:SF30', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418723, 'PTHR32176:SF96', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418724, 'PTHR32176:SF50', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418725, 'PTHR32176:SF55', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418726, 'PTHR32176:SF99', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418727, 'PTHR32176:SF33', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418728, 'PTHR32176', NULL, NULL, NULL, NULL, 'XYLOSE ISOMERASE', 252117),
(418729, 'PTHR32176:SF97', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418730, 'PTHR32176:SF98', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418731, 'PTHR32176:SF32', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418732, 'PTHR32176:SF38', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418733, 'PTHR32176:SF79', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418734, 'PTHR32176:SF36', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418735, 'PTHR32176:SF28', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418736, 'PTHR32176:SF109', NULL, NULL, NULL, NULL, 'PATATIN-LIKE PROTEIN 2', 252117),
(418737, 'PTHR32176:SF80', NULL, NULL, NULL, NULL, 'ACYL TRANSFERASE/ACYL HYDROLASE/LYSOPHOSPHOLIPASE-RELATED', 252117),
(418738, 'PTHR32176:SF81', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418739, 'PTHR32176:SF100', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418740, 'PTHR32176:SF0', NULL, NULL, NULL, NULL, 'XYLOSE ISOMERASE', 252117),
(418741, 'PTHR32176:SF84', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418742, 'PTHR32176:SF85', NULL, NULL, NULL, NULL, 'PATATIN GROUP D-2', 252117),
(418743, 'PTHR32176:SF60', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418744, 'PTHR32176:SF61', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418745, 'PTHR32176:SF106', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418746, 'PTHR32176:SF45', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418747, 'PTHR32176:SF105', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418748, 'PTHR32176:SF89', NULL, NULL, NULL, NULL, 'PATATIN-LIKE PROTEIN 1-RELATED', 252117),
(418749, 'PTHR32176:SF5', NULL, NULL, NULL, NULL, 'PATATIN-LIKE PROTEIN 1', 252117),
(418750, 'PTHR32176:SF67', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418751, 'PTHR32176:SF108', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418752, 'PTHR32176:SF65', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418753, 'PTHR32176:SF107', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418754, 'PTHR32176:SF43', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418755, 'PTHR32176:SF102', NULL, NULL, NULL, NULL, 'PATATIN-LIKE PROTEIN 2', 252117),
(418756, 'PTHR32176:SF26', NULL, NULL, NULL, NULL, 'PATATIN-LIKE PROTEIN 2', 252117),
(418757, 'PTHR32176:SF27', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418758, 'PTHR32176:SF101', NULL, NULL, NULL, NULL, 'PATATIN-LIKE PROTEIN 3', 252117),
(418759, 'PTHR32176:SF104', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418760, 'PTHR32176:SF46', NULL, NULL, NULL, NULL, 'PATATIN', 252117),
(418761, 'PTHR32176:SF103', NULL, NULL, NULL, NULL, 'OS08G0376550 PROTEIN', 252117),
(418762, 'PTHR48182', NULL, NULL, NULL, NULL, 'PROTEIN SERAC1', 252118),
(418763, 'PTHR48182:SF2', NULL, NULL, NULL, NULL, 'PROTEIN SERAC1', 252118),
(418764, 'PTHR48182:SF3', NULL, NULL, NULL, NULL, '', 252118),
(418765, 'PTHR45981:SF4', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MARCHF8', 252119),
(418766, 'PTHR45981:SF3', NULL, NULL, NULL, NULL, 'LD02310P', 252119),
(418767, 'PTHR45981:SF8', NULL, NULL, NULL, NULL, 'RING-CH-TYPE DOMAIN-CONTAINING PROTEIN', 252119),
(418768, 'PTHR45981:SF9', NULL, NULL, NULL, NULL, 'MYB DOMAIN-CONTAINING PROTEIN', 252119),
(418769, 'PTHR45981:SF10', NULL, NULL, NULL, NULL, 'MYB-LIKE PROTEIN X', 252119),
(418770, 'PTHR45981', NULL, NULL, NULL, NULL, 'LD02310P', 252119),
(418771, 'PTHR45981:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MARCHF1', 252119),
(418772, 'PTHR13014:SF3', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN S30, MITOCHONDRIAL', 252120);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(418773, 'PTHR13014', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 28S RIBOSOMAL PROTEIN S30/P52 PRO-APOTOTIC PROTEIN', 252120),
(418774, 'PTHR42874:SF1', NULL, NULL, NULL, NULL, 'URICASE', 252121),
(418775, 'PTHR42874', NULL, NULL, NULL, NULL, 'URICASE', 252121),
(418776, 'PTHR15397', NULL, NULL, NULL, NULL, 'SODIUM-GLUCOSE COTRANSPORTER REGULATORY PROTEIN -RELATED', 252122),
(418777, 'PTHR15397:SF3', NULL, NULL, NULL, NULL, 'DNA DAMAGE-INDUCIBLE 1 HOMOLOG 2', 252122),
(418778, 'PTHR48243', NULL, NULL, NULL, NULL, '', 252123),
(418779, 'PTHR48243:SF1', NULL, NULL, NULL, NULL, '', 252123),
(418780, 'PTHR36181', NULL, NULL, NULL, NULL, 'INTRON-ENCODED ENDONUCLEASE AI3-RELATED', 252124),
(418781, 'PTHR36181:SF4', NULL, NULL, NULL, NULL, 'LAGLIDADG ENDONUCLEASE', 252124),
(418782, 'PTHR36181:SF6', NULL, NULL, NULL, NULL, 'LAGLIDADG ENDONUCLEASE', 252124),
(418783, 'PTHR36181:SF1', NULL, NULL, NULL, NULL, 'INTRON-ENCODED DNA ENDONUCLEASE AI5 BETA', 252124),
(418784, 'PTHR36181:SF3', NULL, NULL, NULL, NULL, 'LAGLIDADG ENDONUCLEASE', 252124),
(418785, 'PTHR36181:SF2', NULL, NULL, NULL, NULL, 'INTRON-ENCODED ENDONUCLEASE AI3-RELATED', 252124),
(418786, 'PTHR37255:SF1', NULL, NULL, NULL, NULL, 'OS07G0669600 PROTEIN', 252125),
(418787, 'PTHR37255', NULL, NULL, NULL, NULL, 'OS07G0669600 PROTEIN', 252125),
(418788, 'PTHR38445:SF9', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REPRESSOR YTRA', 252126),
(418789, 'PTHR38445:SF10', NULL, NULL, NULL, NULL, 'GNTR-FAMILY TRANSCRIPTIONAL REGULATOR', 252126),
(418790, 'PTHR38445:SF7', NULL, NULL, NULL, NULL, 'GNTR FAMILY TRANSCRIPTIONAL REGULATOR', 252126),
(418791, 'PTHR38445:SF12', NULL, NULL, NULL, NULL, 'GNTR-FAMILY TRANSCRIPTIONAL REGULATOR', 252126),
(418792, 'PTHR38445:SF6', NULL, NULL, NULL, NULL, 'GNTR-FAMILY TRANSCRIPTIONAL REGULATOR', 252126),
(418793, 'PTHR38445', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REPRESSOR YTRA', 252126),
(418794, 'PTHR48202', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 252127),
(418795, 'PTHR48202:SF1', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 252127),
(418796, 'PTHR47251:SF1', NULL, NULL, NULL, NULL, 'FINGER DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G04180)-RELATED', 252128),
(418797, 'PTHR47251', NULL, NULL, NULL, NULL, 'FINGER DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G04180)-RELATED', 252128),
(418798, 'PTHR33971:SF6', NULL, NULL, NULL, NULL, 'BNAA02G29670D PROTEIN', 252129),
(418799, 'PTHR33971:SF7', NULL, NULL, NULL, NULL, '', 252129),
(418800, 'PTHR33971:SF4', NULL, NULL, NULL, NULL, 'OS07G0682700 PROTEIN', 252129),
(418801, 'PTHR33971:SF3', NULL, NULL, NULL, NULL, 'BNAC08G14940D PROTEIN', 252129),
(418802, 'PTHR33971:SF1', NULL, NULL, NULL, NULL, 'OS02G0743600 PROTEIN', 252129),
(418803, 'PTHR33971:SF15', NULL, NULL, NULL, NULL, 'OS06G0232000 PROTEIN', 252129),
(418804, 'PTHR33971:SF13', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN', 252129),
(418805, 'PTHR33971:SF12', NULL, NULL, NULL, NULL, 'PC21G16870 PROTEIN', 252129),
(418806, 'PTHR33971:SF11', NULL, NULL, NULL, NULL, 'BNACNNG17950D PROTEIN', 252129),
(418807, 'PTHR33971', NULL, NULL, NULL, NULL, 'OS06G0232000 PROTEIN', 252129),
(418808, 'PTHR33971:SF9', NULL, NULL, NULL, NULL, 'PRO-RESILIN', 252129),
(418809, 'PTHR12682:SF11', NULL, NULL, NULL, NULL, 'PROTEIN ARCHEASE', 252130),
(418810, 'PTHR12682:SF12', NULL, NULL, NULL, NULL, 'PROTEIN ARCHEASE', 252130),
(418811, 'PTHR12682:SF14', NULL, NULL, NULL, NULL, 'PROTEIN ARCHEASE', 252130),
(418812, 'PTHR12682', NULL, NULL, NULL, NULL, 'ARCHEASE', 252130),
(418813, 'PTHR43812', NULL, NULL, NULL, NULL, 'BLR2425 PROTEIN', 252131),
(418814, 'PTHR43812:SF2', NULL, NULL, NULL, NULL, 'FLAVIN_REDUCT DOMAIN-CONTAINING PROTEIN', 252131),
(418815, 'PTHR43881:SF1', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYLTRANSPEPTIDASE (AFU_ORTHOLOGUE AFUA_4G13580)', 252132),
(418816, 'PTHR43881', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYLTRANSPEPTIDASE (AFU_ORTHOLOGUE AFUA_4G13580)', 252132),
(418817, 'PTHR43881:SF5', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYLTRANSPEPTIDASE', 252132);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(418818, 'PTHR14482', NULL, NULL, NULL, NULL, 'CHROMOSOME 12 ORF 43 HOMOLOG', 252133),
(418819, 'PTHR14482:SF0', NULL, NULL, NULL, NULL, 'PROTEIN CUSTOS', 252133),
(418820, 'PTHR34404', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN, FMDB FAMILY', 252134),
(418821, 'PTHR34404:SF1', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN, FMDB FAMILY', 252134),
(418822, 'PTHR34404:SF3', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN, FMDB FAMILY', 252134),
(418823, 'PTHR34404:SF2', NULL, NULL, NULL, NULL, 'CONSERVED SERINE RICH PROTEIN', 252134),
(418824, 'PTHR12223:SF19', NULL, NULL, NULL, NULL, 'LECTIN_LEGB DOMAIN-CONTAINING PROTEIN', 252135),
(418825, 'PTHR12223:SF31', NULL, NULL, NULL, NULL, 'PROTEIN ERGIC-53-LIKE', 252135),
(418826, 'PTHR12223:SF42', NULL, NULL, NULL, NULL, 'LECTIN_LEGB DOMAIN-CONTAINING PROTEIN', 252135),
(418827, 'PTHR12223:SF20', NULL, NULL, NULL, NULL, 'VIP36-LIKE PROTEIN', 252135),
(418828, 'PTHR12223:SF40', NULL, NULL, NULL, NULL, 'PROTEIN EMP46-RELATED', 252135),
(418829, 'PTHR12223:SF34', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-LIKE DOMAIN-CONTAINING PROTEIN', 252135),
(418830, 'PTHR12223', NULL, NULL, NULL, NULL, 'VESICULAR MANNOSE-BINDING LECTIN', 252135),
(418831, 'PTHR12223:SF32', NULL, NULL, NULL, NULL, 'PROTEIN ERGIC-53', 252135),
(418832, 'PTHR12223:SF28', NULL, NULL, NULL, NULL, 'RE50040P', 252135),
(418833, 'PTHR12223:SF39', NULL, NULL, NULL, NULL, 'L-TYPE LECTIN-LIKE DOMAIN-CONTAINING PROTEIN', 252135),
(418834, 'PTHR12223:SF36', NULL, NULL, NULL, NULL, 'VESICULAR INTEGRAL-MEMBRANE PROTEIN VIP36', 252135),
(418835, 'PTHR48016:SF49', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 1-LIKE', 252136),
(418836, 'PTHR48016:SF48', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE BCK1/SLK1/SSP31', 252136),
(418837, 'PTHR48016:SF25', NULL, NULL, NULL, NULL, 'OS02G0666300 PROTEIN', 252136),
(418838, 'PTHR48016:SF47', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252136),
(418839, 'PTHR48016:SF46', NULL, NULL, NULL, NULL, 'MAP KINASE KINASE KINASE-LIKE PROTEIN', 252136),
(418840, 'PTHR48016:SF45', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252136),
(418841, 'PTHR48016:SF44', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252136),
(418842, 'PTHR48016:SF22', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252136),
(418843, 'PTHR48016:SF43', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252136),
(418844, 'PTHR48016:SF21', NULL, NULL, NULL, NULL, 'MAP KINASE KINASE KINASE', 252136),
(418845, 'PTHR48016:SF20', NULL, NULL, NULL, NULL, 'BNAC03G28150D PROTEIN', 252136),
(418846, 'PTHR48016:SF40', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252136),
(418847, 'PTHR48016:SF4', NULL, NULL, NULL, NULL, 'MAP3K EPSILON PROTEIN KINASE 1', 252136),
(418848, 'PTHR48016:SF5', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 5', 252136),
(418849, 'PTHR48016:SF2', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252136),
(418850, 'PTHR48016:SF8', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 3', 252136),
(418851, 'PTHR48016:SF9', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 14', 252136),
(418852, 'PTHR48016:SF6', NULL, NULL, NULL, NULL, 'OS02G0555900 PROTEIN', 252136),
(418853, 'PTHR48016:SF7', NULL, NULL, NULL, NULL, 'BNAA06G00700D PROTEIN', 252136),
(418854, 'PTHR48016:SF1', NULL, NULL, NULL, NULL, 'OS07G0119000 PROTEIN', 252136),
(418855, 'PTHR48016:SF29', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 1-RELATED', 252136),
(418856, 'PTHR48016:SF37', NULL, NULL, NULL, NULL, 'MAP KINASE KINASE KINASE-LIKE PROTEIN', 252136),
(418857, 'PTHR48016:SF15', NULL, NULL, NULL, NULL, 'OS04G0437600 PROTEIN', 252136),
(418858, 'PTHR48016:SF59', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252136),
(418859, 'PTHR48016:SF14', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252136),
(418860, 'PTHR48016:SF58', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252136);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(418861, 'PTHR48016:SF57', NULL, NULL, NULL, NULL, 'MAP KINASE SUPERFAMILY PROTEIN-RELATED', 252136),
(418862, 'PTHR48016:SF13', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252136),
(418863, 'PTHR48016:SF12', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252136),
(418864, 'PTHR48016:SF56', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 19', 252136),
(418865, 'PTHR48016:SF11', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252136),
(418866, 'PTHR48016:SF55', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252136),
(418867, 'PTHR48016:SF32', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 4', 252136),
(418868, 'PTHR48016:SF54', NULL, NULL, NULL, NULL, 'MAP KINASE KINASE KINASE-LIKE PROTEIN', 252136),
(418869, 'PTHR48016:SF53', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 1-LIKE', 252136),
(418870, 'PTHR48016:SF31', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 8', 252136),
(418871, 'PTHR48016:SF52', NULL, NULL, NULL, NULL, 'MAP KINASE KINASE KINASE WIN1', 252136),
(418872, 'PTHR48016:SF51', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252136),
(418873, 'PTHR48016', NULL, NULL, NULL, NULL, 'MAP KINASE KINASE KINASE SSK2-RELATED-RELATED', 252136),
(418874, 'PTHR48016:SF50', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 3', 252136),
(418875, 'PTHR48016:SF19', NULL, NULL, NULL, NULL, 'PROTEIN KINASE 1, PUTATIVE, EXPRESSED-RELATED', 252136),
(418876, 'PTHR48016:SF17', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE YODA', 252136),
(418877, 'PTHR48122', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN H', 252137),
(418878, 'PTHR48122:SF1', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN H', 252137),
(418879, 'PTHR39426', NULL, NULL, NULL, NULL, 'HOMOLOGY TO DEATH-ON-CURING PROTEIN OF PHAGE P1', 252138),
(418880, 'PTHR39426:SF1', NULL, NULL, NULL, NULL, 'HOMOLOGY TO DEATH-ON-CURING PROTEIN OF PHAGE P1', 252138),
(418881, 'PTHR42996:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATE-BINDING PROTEIN PSTS', 252139),
(418882, 'PTHR42996', NULL, NULL, NULL, NULL, 'PHOSPHATE-BINDING PROTEIN PSTS', 252139),
(418883, 'PTHR35147:SF2', NULL, NULL, NULL, NULL, 'CHEMORECEPTOR GLUTAMINE DEAMIDASE CHED-RELATED', 252140),
(418884, 'PTHR35147:SF1', NULL, NULL, NULL, NULL, 'CHEMORECEPTOR GLUTAMINE DEAMIDASE CHED', 252140),
(418885, 'PTHR35147', NULL, NULL, NULL, NULL, 'CHEMORECEPTOR GLUTAMINE DEAMIDASE CHED-RELATED', 252140),
(418886, 'PTHR45615', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN, NON-MUSCLE', 252141),
(418887, 'PTHR45615:SF60', NULL, NULL, NULL, NULL, 'CARD DOMAIN-CONTAINING PROTEIN', 252141),
(418888, 'PTHR45615:SF61', NULL, NULL, NULL, NULL, 'SYNAPTONEMAL COMPLEX PROTEIN ZIP1', 252141),
(418889, 'PTHR45615:SF62', NULL, NULL, NULL, NULL, 'MYOSIN, HEAVY CHAIN 6, CARDIAC MUSCLE, ALPHA', 252141),
(418890, 'PTHR45615:SF40', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN, NON-MUSCLE', 252141),
(418891, 'PTHR45615:SF63', NULL, NULL, NULL, NULL, 'A-TYPE INCLUSION PROTEIN, PUTATIVE-RELATED', 252141),
(418892, 'PTHR45615:SF57', NULL, NULL, NULL, NULL, 'GRIP AND COILED-COIL DOMAIN-CONTAINING PROTEIN C27D7.02C', 252141),
(418893, 'PTHR45615:SF35', NULL, NULL, NULL, NULL, 'MYOSIN-8', 252141),
(418894, 'PTHR45615:SF13', NULL, NULL, NULL, NULL, 'UNCONVENTIONAL MYOSIN-XVIIIA', 252141),
(418895, 'PTHR45615:SF36', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN-LIKE, ISOFORM B-RELATED', 252141),
(418896, 'PTHR45615:SF58', NULL, NULL, NULL, NULL, 'HOLOCENTRIC CHROMOSOME BINDING PROTEIN-RELATED', 252141),
(418897, 'PTHR45615:SF59', NULL, NULL, NULL, NULL, 'CROSSOVER SUPPRESSOR ON 3 OF GOWEN', 252141),
(418898, 'PTHR45615:SF15', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN 7-RELATED', 252141),
(418899, 'PTHR45615:SF16', NULL, NULL, NULL, NULL, 'MYOSIN-9', 252141),
(418900, 'PTHR45615:SF53', NULL, NULL, NULL, NULL, 'A-TYPE INCLUSION PROTEIN, PUTATIVE-RELATED', 252141),
(418901, 'PTHR45615:SF31', NULL, NULL, NULL, NULL, 'MYOSIN-14', 252141);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(418902, 'PTHR45615:SF54', NULL, NULL, NULL, NULL, 'MYOSIN-4', 252141),
(418903, 'PTHR45615:SF55', NULL, NULL, NULL, NULL, '', 252141),
(418904, 'PTHR45615:SF11', NULL, NULL, NULL, NULL, 'MYOSIN-6', 252141),
(418905, 'PTHR45615:SF34', NULL, NULL, NULL, NULL, 'MYOSIN MOTOR DOMAIN-CONTAINING PROTEIN', 252141),
(418906, 'PTHR45615:SF56', NULL, NULL, NULL, NULL, 'KH DOMAIN-CONTAINING PROTEIN', 252141),
(418907, 'PTHR45615:SF39', NULL, NULL, NULL, NULL, 'MYOSIN-2', 252141),
(418908, 'PTHR45615:SF17', NULL, NULL, NULL, NULL, 'MYOSIN MOTOR DOMAIN-CONTAINING PROTEIN', 252141),
(418909, 'PTHR45615:SF1', NULL, NULL, NULL, NULL, 'MYOSIN-7', 252141),
(418910, 'PTHR45615:SF50', NULL, NULL, NULL, NULL, 'MYOSIN-16', 252141),
(418911, 'PTHR45615:SF51', NULL, NULL, NULL, NULL, 'MYOSIN-1', 252141),
(418912, 'PTHR45615:SF68', NULL, NULL, NULL, NULL, '', 252141),
(418913, 'PTHR45615:SF24', NULL, NULL, NULL, NULL, 'MYOSIN-10', 252141),
(418914, 'PTHR45615:SF47', NULL, NULL, NULL, NULL, 'NON-MUSCLE MYOSIN', 252141),
(418915, 'PTHR45615:SF26', NULL, NULL, NULL, NULL, 'MYOSIN-15', 252141),
(418916, 'PTHR45615:SF27', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN, MUSCLE', 252141),
(418917, 'PTHR45615:SF64', NULL, NULL, NULL, NULL, 'MYOSIN-13', 252141),
(418918, 'PTHR45615:SF20', NULL, NULL, NULL, NULL, 'MYOSIN-2', 252141),
(418919, 'PTHR45615:SF65', NULL, NULL, NULL, NULL, '', 252141),
(418920, 'PTHR45615:SF66', NULL, NULL, NULL, NULL, 'CBM20 DOMAIN-CONTAINING PROTEIN', 252141),
(418921, 'PTHR45615:SF44', NULL, NULL, NULL, NULL, 'MYOSIN-4', 252141),
(418922, 'PTHR45615:SF23', NULL, NULL, NULL, NULL, 'MYOSIN-11', 252141),
(418923, 'PTHR45615:SF67', NULL, NULL, NULL, NULL, '', 252141),
(418924, 'PTHR45615:SF8', NULL, NULL, NULL, NULL, 'UNCONVENTIONAL MYOSIN-XVIIIB', 252141),
(418925, 'PTHR45615:SF6', NULL, NULL, NULL, NULL, 'MYOSIN-3', 252141),
(418926, 'PTHR45615:SF7', NULL, NULL, NULL, NULL, 'MYOSIN-3', 252141),
(418927, 'PTHR45615:SF29', NULL, NULL, NULL, NULL, 'MYOSIN-7B', 252141),
(418928, 'PTHR45615:SF2', NULL, NULL, NULL, NULL, 'MYOSIN-1', 252141),
(418929, 'PTHR32522', NULL, NULL, NULL, NULL, '', 252142),
(418930, 'PTHR32522:SF3', NULL, NULL, NULL, NULL, 'ABC TRANSMEMBRANE TYPE-1 DOMAIN-CONTAINING PROTEIN', 252142),
(418931, 'PTHR32522:SF8', NULL, NULL, NULL, NULL, '', 252142),
(418932, 'PTHR32522:SF5', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN YXDM', 252142),
(418933, 'PTHR42028:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 252143),
(418934, 'PTHR42028', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 252143),
(418935, 'PTHR13968:SF31', NULL, NULL, NULL, NULL, 'SI:DKEY-234I14.2', 252144),
(418936, 'PTHR13968:SF32', NULL, NULL, NULL, NULL, 'RNA-BINDING RALY-LIKE PROTEIN', 252144),
(418937, 'PTHR13968:SF21', NULL, NULL, NULL, NULL, 'RNA-BINDING RALY-LIKE PROTEIN', 252144),
(418938, 'PTHR13968:SF3', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEINS C1/C2', 252144),
(418939, 'PTHR13968', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN', 252144),
(418940, 'PTHR13968:SF26', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 252144),
(418941, 'PTHR13968:SF6', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN RALY', 252144),
(418942, 'PTHR13968:SF27', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 252144),
(418943, 'PTHR13968:SF17', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN C-LIKE 1-RELATED', 252144),
(418944, 'PTHR13968:SF28', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 252144),
(418945, 'PTHR13968:SF30', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN C-LIKE 3-RELATED', 252144),
(418946, 'PTHR11804:SF28', NULL, NULL, NULL, NULL, 'OLIGOENDOPEPTIDASE F', 252145),
(418947, 'PTHR11804:SF79', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL INTERMEDIATE PEPTIDASE', 252145),
(418948, 'PTHR11804:SF45', NULL, NULL, NULL, NULL, 'SIMILAR TO OLIGOENDOPEPTIDASE', 252145),
(418949, 'PTHR11804:SF56', NULL, NULL, NULL, NULL, 'THIMET OLIGOPEPTIDASE 1', 252145),
(418950, 'PTHR11804:SF48', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 252145);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(418951, 'PTHR11804:SF85', NULL, NULL, NULL, NULL, 'PEPTIDASE_M3 DOMAIN-CONTAINING PROTEIN', 252145),
(418952, 'PTHR11804:SF77', NULL, NULL, NULL, NULL, 'OLIGOENDOPEPTIDASE F', 252145),
(418953, 'PTHR11804:SF44', NULL, NULL, NULL, NULL, 'NEUROLYSIN, MITOCHONDRIAL', 252145),
(418954, 'PTHR11804:SF55', NULL, NULL, NULL, NULL, 'NEUROLYSIN (METALLOPEPTIDASE M3 FAMILY)', 252145),
(418955, 'PTHR11804:SF5', NULL, NULL, NULL, NULL, 'OLIGOENDOPEPTIDASE F', 252145),
(418956, 'PTHR11804', NULL, NULL, NULL, NULL, 'PROTEASE M3 THIMET OLIGOPEPTIDASE-RELATED', 252145),
(418957, 'PTHR11804:SF82', NULL, NULL, NULL, NULL, 'THIMET OLIGOPEPTIDASE-RELATED', 252145),
(418958, 'PTHR11804:SF71', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL INTERMEDIATE PEPTIDASE', 252145),
(418959, 'PTHR11804:SF84', NULL, NULL, NULL, NULL, 'SACCHAROLYSIN', 252145),
(418960, 'PTHR11804:SF73', NULL, NULL, NULL, NULL, 'CYTOSOLIC OLIGOPEPTIDASE A-RELATED', 252145),
(418961, 'PTHR11804:SF50', NULL, NULL, NULL, NULL, 'THIMET OLIGOPEPTIDASE', 252145),
(418962, 'PTHR11804:SF83', NULL, NULL, NULL, NULL, 'LD37516P', 252145),
(418963, 'PTHR47249:SF1', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN 8', 252146),
(418964, 'PTHR47249', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN 8', 252146),
(418965, 'PTHR34465:SF5', NULL, NULL, NULL, NULL, 'OS11G0598900 PROTEIN', 252147),
(418966, 'PTHR34465:SF6', NULL, NULL, NULL, NULL, 'OS11G0458500 PROTEIN', 252147),
(418967, 'PTHR34465:SF3', NULL, NULL, NULL, NULL, 'OS09G0547900 PROTEIN', 252147),
(418968, 'PTHR34465', NULL, NULL, NULL, NULL, 'CARBOXYL-TERMINAL HYDROLASE-LIKE PROTEIN, PUTATIVE (DUF627 AND DUF629)-RELATED', 252147),
(418969, 'PTHR34465:SF4', NULL, NULL, NULL, NULL, 'CARBOXYL-TERMINAL HYDROLASE-LIKE PROTEIN, PUTATIVE (DUF627 AND DUF629)-RELATED', 252147),
(418970, 'PTHR31234:SF39', NULL, NULL, NULL, NULL, 'HARPIN-INDUCED PROTEIN 1 CONTAINING PROTEIN, EXPRESSED', 252148),
(418971, 'PTHR31234:SF35', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY', 252148),
(418972, 'PTHR31234:SF36', NULL, NULL, NULL, NULL, 'CHAPERONIN CPN60-LIKE PROTEIN', 252148),
(418973, 'PTHR31234:SF58', NULL, NULL, NULL, NULL, 'SUI1 DOMAIN-CONTAINING PROTEIN', 252148),
(418974, 'PTHR31234:SF59', NULL, NULL, NULL, NULL, 'EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN, PUTATIVE-RELATED', 252148),
(418975, 'PTHR31234:SF38', NULL, NULL, NULL, NULL, 'BNAA09G11920D PROTEIN', 252148),
(418976, 'PTHR31234:SF32', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY', 252148),
(418977, 'PTHR31234:SF10', NULL, NULL, NULL, NULL, 'HARPIN-INDUCED PROTEIN 1 CONTAINING PROTEIN, EXPRESSED', 252148),
(418978, 'PTHR31234:SF54', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY', 252148),
(418979, 'PTHR31234:SF55', NULL, NULL, NULL, NULL, 'NDR1/HIN1-LIKE 25', 252148),
(418980, 'PTHR31234:SF33', NULL, NULL, NULL, NULL, '', 252148),
(418981, 'PTHR31234:SF34', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 252148),
(418982, 'PTHR31234:SF50', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 252148),
(418983, 'PTHR31234:SF52', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN, LEA-14, IMMUNOGLOBULIN-LIKE FOLD PROTEIN-RELATED', 252148),
(418984, 'PTHR31234:SF30', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 252148),
(418985, 'PTHR31234:SF29', NULL, NULL, NULL, NULL, '', 252148),
(418986, 'PTHR31234:SF26', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252148),
(418987, 'PTHR31234:SF5', NULL, NULL, NULL, NULL, 'OS07G0206800 PROTEIN', 252148),
(418988, 'PTHR31234:SF64', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN', 252148),
(418989, 'PTHR31234:SF42', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY', 252148),
(418990, 'PTHR31234:SF4', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252148),
(418991, 'PTHR31234:SF43', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY', 252148);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(418992, 'PTHR31234:SF3', NULL, NULL, NULL, NULL, 'OS01G0234700 PROTEIN', 252148),
(418993, 'PTHR31234:SF44', NULL, NULL, NULL, NULL, 'BNAA04G17590D PROTEIN', 252148),
(418994, 'PTHR31234:SF2', NULL, NULL, NULL, NULL, 'OS05G0199100 PROTEIN', 252148),
(418995, 'PTHR31234:SF60', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN, LEA-14, IMMUNOGLOBULIN-LIKE FOLD PROTEIN-RELATED', 252148),
(418996, 'PTHR31234:SF61', NULL, NULL, NULL, NULL, 'OS01G0574800 PROTEIN', 252148),
(418997, 'PTHR31234:SF62', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 252148),
(418998, 'PTHR31234:SF40', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN FAMILY', 252148),
(418999, 'PTHR31234:SF63', NULL, NULL, NULL, NULL, 'HARPIN-INDUCED PROTEIN', 252148),
(419000, 'PTHR31234:SF9', NULL, NULL, NULL, NULL, 'OS01G0195400 PROTEIN', 252148),
(419001, 'PTHR31234:SF8', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252148),
(419002, 'PTHR31234:SF6', NULL, NULL, NULL, NULL, 'LEA_2 DOMAIN-CONTAINING PROTEIN', 252148),
(419003, 'PTHR31234', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY', 252148),
(419004, 'PTHR28293:SF1', NULL, NULL, NULL, NULL, 'NUCLEAR RIM PROTEIN 1', 252149),
(419005, 'PTHR28293', NULL, NULL, NULL, NULL, 'NUCLEAR RIM PROTEIN 1', 252149),
(419006, 'PTHR11462:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR AP-1', 252150),
(419007, 'PTHR11462:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR JUN-D', 252150),
(419008, 'PTHR11462:SF51', NULL, NULL, NULL, NULL, 'JUNE PROTO-ONCOGENE, AP-1 TRANSCRIPTION FACTOR SUBUNIT', 252150),
(419009, 'PTHR11462:SF57', NULL, NULL, NULL, NULL, 'AP-1-LIKE TRANSCRIPTION FACTOR NAPA', 252150),
(419010, 'PTHR11462:SF35', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR AP-1', 252150),
(419011, 'PTHR11462:SF58', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR JUN-B', 252150),
(419012, 'PTHR11462:SF37', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR JUN-B', 252150),
(419013, 'PTHR11462:SF53', NULL, NULL, NULL, NULL, 'B-ZIP TRANSCRIPTION FACTOR (EUROFUNG)', 252150),
(419014, 'PTHR11462', NULL, NULL, NULL, NULL, 'JUN TRANSCRIPTION FACTOR-RELATED', 252150),
(419015, 'PTHR11675:SF119', NULL, NULL, NULL, NULL, 'POLYPEPTIDE N-ACETYLGALACTOSAMINYLTRANSFERASE 2', 252151),
(419016, 'PTHR11675:SF47', NULL, NULL, NULL, NULL, 'POLYPEPTIDE N-ACETYLGALACTOSAMINYLTRANSFERASE 13', 252151),
(419017, 'PTHR11675:SF68', NULL, NULL, NULL, NULL, 'N-ACETYLGALACTOSAMINYLTRANSFERASE 7', 252151),
(419018, 'PTHR11675:SF118', NULL, NULL, NULL, NULL, 'POLYPEPTIDE N-ACETYLGALACTOSAMINYLTRANSFERASE 3', 252151),
(419019, 'PTHR11675:SF28', NULL, NULL, NULL, NULL, 'POLYPEPTIDE N-ACETYLGALACTOSAMINYLTRANSFERASE 9', 252151),
(419020, 'PTHR11675:SF49', NULL, NULL, NULL, NULL, 'POLYPEPTIDE N-ACETYLGALACTOSAMINYLTRANSFERASE 2', 252151),
(419021, 'PTHR11675:SF8', NULL, NULL, NULL, NULL, 'POLYPEPTIDE N-ACETYLGALACTOSAMINYLTRANSFERASE 14', 252151),
(419022, 'PTHR11675:SF7', NULL, NULL, NULL, NULL, 'POLYPEPTIDE N-ACETYLGALACTOSAMINYLTRANSFERASE 4', 252151),
(419023, 'PTHR11675:SF43', NULL, NULL, NULL, NULL, 'POLYPEPTIDE N-ACETYLGALACTOSAMINYLTRANSFERASE 1', 252151),
(419024, 'PTHR11675:SF41', NULL, NULL, NULL, NULL, 'POLYPEPTIDE N-ACETYLGALACTOSAMINYLTRANSFERASE 10', 252151),
(419025, 'PTHR11675:SF63', NULL, NULL, NULL, NULL, 'POLYPEPTIDE N-ACETYLGALACTOSAMINYLTRANSFERASE', 252151),
(419026, 'PTHR11675:SF130', NULL, NULL, NULL, NULL, 'POLYPEPTIDE N-ACETYLGALACTOSAMINYLTRANSFERASE 5', 252151),
(419027, 'PTHR11675:SF3', NULL, NULL, NULL, NULL, 'POLYPEPTIDE N-ACETYLGALACTOSAMINYLTRANSFERASE 16', 252151),
(419028, 'PTHR11675:SF133', NULL, NULL, NULL, NULL, 'GLYCO_TRANS_2-LIKE DOMAIN-CONTAINING PROTEIN', 252151),
(419029, 'PTHR11675:SF134', NULL, NULL, NULL, NULL, 'N-ACETYLGALACTOSAMINYLTRANSFERASE 4-RELATED', 252151),
(419030, 'PTHR11675:SF131', NULL, NULL, NULL, NULL, 'POLYPEPTIDE N-ACETYLGALACTOSAMINYLTRANSFERASE 9-RELATED', 252151),
(419031, 'PTHR11675', NULL, NULL, NULL, NULL, 'N-ACETYLGALACTOSAMINYLTRANSFERASE', 252151),
(419032, 'PTHR11675:SF132', NULL, NULL, NULL, NULL, 'POLYPEPTIDE N-ACETYLGALACTOSAMINYLTRANSFERASE', 252151);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(419033, 'PTHR11675:SF116', NULL, NULL, NULL, NULL, 'N-ACETYLGALACTOSAMINYLTRANSFERASE 8-RELATED', 252151),
(419034, 'PTHR11675:SF135', NULL, NULL, NULL, NULL, 'POLYPEPTIDE N-ACETYLGALACTOSAMINYLTRANSFERASE', 252151),
(419035, 'PTHR11675:SF136', NULL, NULL, NULL, NULL, 'POLYPEPTIDE N-ACETYLGALACTOSAMINYLTRANSFERASE', 252151),
(419036, 'PTHR11675:SF37', NULL, NULL, NULL, NULL, 'POLYPEPTIDE N-ACETYLGALACTOSAMINYLTRANSFERASE 18', 252151),
(419037, 'PTHR11675:SF58', NULL, NULL, NULL, NULL, 'POLYPEPTIDE N-ACETYLGALACTOSAMINYLTRANSFERASE 6', 252151),
(419038, 'PTHR11675:SF36', NULL, NULL, NULL, NULL, 'POLYPEPTIDE N-ACETYLGALACTOSAMINYLTRANSFERASE 15', 252151),
(419039, 'PTHR11675:SF128', NULL, NULL, NULL, NULL, 'POLYPEPTIDE N-ACETYLGALACTOSAMINYLTRANSFERASE 13-RELATED', 252151),
(419040, 'PTHR11675:SF129', NULL, NULL, NULL, NULL, 'POLYPEPTIDE N-ACETYLGALACTOSAMINYLTRANSFERASE-LIKE 6', 252151),
(419041, 'PTHR11675:SF18', NULL, NULL, NULL, NULL, 'POLYPEPTIDE N-ACETYLGALACTOSAMINYLTRANSFERASE 12', 252151),
(419042, 'PTHR11675:SF17', NULL, NULL, NULL, NULL, 'INACTIVE POLYPEPTIDE N-ACETYLGALACTOSAMINYLTRANSFERASE-LIKE PROTEIN 5', 252151),
(419043, 'PTHR11675:SF38', NULL, NULL, NULL, NULL, 'POLYPEPTIDE N-ACETYLGALACTOSAMINYLTRANSFERASE 17', 252151),
(419044, 'PTHR11675:SF50', NULL, NULL, NULL, NULL, 'POLYPEPTIDE N-ACETYLGALACTOSAMINYLTRANSFERASE 8-RELATED', 252151),
(419045, 'PTHR11675:SF33', NULL, NULL, NULL, NULL, 'POLYPEPTIDE N-ACETYLGALACTOSAMINYLTRANSFERASE 3', 252151),
(419046, 'PTHR11675:SF10', NULL, NULL, NULL, NULL, 'POLYPEPTIDE N-ACETYLGALACTOSAMINYLTRANSFERASE 11', 252151),
(419047, 'PTHR11675:SF123', NULL, NULL, NULL, NULL, 'POLYPEPTIDE N-ACETYLGALACTOSAMINYLTRANSFERASE 1', 252151),
(419048, 'PTHR11675:SF101', NULL, NULL, NULL, NULL, 'POLYPEPTIDE N-ACETYLGALACTOSAMINYLTRANSFERASE 5', 252151),
(419049, 'PTHR11675:SF126', NULL, NULL, NULL, NULL, 'N-ACETYLGALACTOSAMINYLTRANSFERASE 7', 252151),
(419050, 'PTHR22655', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252152),
(419051, 'PTHR22655:SF2', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE TDRD12-RELATED', 252152),
(419052, 'PTHR37215:SF1', NULL, NULL, NULL, NULL, 'ACYL-COA-BINDING DOMAIN PROTEIN', 252153),
(419053, 'PTHR37215', NULL, NULL, NULL, NULL, 'ACYL-COA-BINDING DOMAIN PROTEIN', 252153),
(419054, 'PTHR47453', NULL, NULL, NULL, NULL, 'PHOSPHOGLUCAN, WATER DIKINASE, CHLOROPLASTIC', 252154),
(419055, 'PTHR47453:SF3', NULL, NULL, NULL, NULL, 'CBM20 DOMAIN-CONTAINING PROTEIN', 252154),
(419056, 'PTHR47453:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOGLUCAN, WATER DIKINASE, CHLOROPLASTIC', 252154),
(419057, 'PTHR24347:SF401', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DCLK1', 252155),
(419058, 'PTHR24347:SF246', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE TDA1', 252155),
(419059, 'PTHR24347:SF443', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252155),
(419060, 'PTHR24347:SF365', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-DEPENDENT PROTEIN KINASE TYPE II SUBUNIT DELTA', 252155),
(419061, 'PTHR24347:SF442', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252155),
(419062, 'PTHR24347:SF441', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-DEPENDENT PROTEIN KINASE TYPE II ALPHA CHAIN', 252155),
(419063, 'PTHR24347:SF440', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-DEPENDENT PROTEIN KINASE TYPE 1B', 252155),
(419064, 'PTHR24347:SF363', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-DEPENDENT PROTEIN KINASE IG', 252155),
(419065, 'PTHR24347:SF18', NULL, NULL, NULL, NULL, 'CAM KINASE-LIKE VESICLE-ASSOCIATED PROTEIN', 252155),
(419066, 'PTHR24347:SF19', NULL, NULL, NULL, NULL, 'CAM KINASE-LIKE VESICLE-ASSOCIATED, LIKE', 252155),
(419067, 'PTHR24347:SF408', NULL, NULL, NULL, NULL, 'MYOSIN LIGHT CHAIN KINASE DDB_G0292624-RELATED', 252155),
(419068, 'PTHR24347:SF404', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252155),
(419069, 'PTHR24347:SF403', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-DEPENDENT PROTEIN KINASE TYPE II SUBUNIT BETA', 252155),
(419070, 'PTHR24347:SF116', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-DEPENDENT PROTEIN KINASE TYPE 1G', 252155);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(419071, 'PTHR24347:SF433', NULL, NULL, NULL, NULL, 'PHOSPHORYLASE KINASE', 252155),
(419072, 'PTHR24347:SF354', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252155),
(419073, 'PTHR24347:SF431', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-DEPENDENT PROTEIN KINASE TYPE II DELTA 1 CHAIN', 252155),
(419074, 'PTHR24347:SF398', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-DEPENDENT PROTEIN KINASE TYPE II SUBUNIT GAMMA', 252155),
(419075, 'PTHR24347:SF198', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252155),
(419076, 'PTHR24347:SF197', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-DEPENDENT PROTEIN KINASE TYPE 1', 252155),
(419077, 'PTHR24347:SF394', NULL, NULL, NULL, NULL, 'MYOSIN LIGHT CHAIN KINASE 3', 252155),
(419078, 'PTHR24347:SF393', NULL, NULL, NULL, NULL, 'SPAGHETTI-SQUASH ACTIVATOR, ISOFORM C', 252155),
(419079, 'PTHR24347:SF391', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN DEPENDENT PROTEIN KINASE IV', 252155),
(419080, 'PTHR24347:SF390', NULL, NULL, NULL, NULL, 'PHOSPHORYLASE B KINASE GAMMA CATALYTIC CHAIN, LIVER/TESTIS ISOFORM', 252155),
(419081, 'PTHR24347:SF439', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252155),
(419082, 'PTHR24347:SF438', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252155),
(419083, 'PTHR24347:SF437', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252155),
(419084, 'PTHR24347:SF359', NULL, NULL, NULL, NULL, 'MYOSIN LIGHT CHAIN KINASE DDB_G0282429-RELATED', 252155),
(419085, 'PTHR24347:SF436', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-DEPENDENT PROTEIN KINASE', 252155),
(419086, 'PTHR24347:SF424', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252155),
(419087, 'PTHR24347:SF225', NULL, NULL, NULL, NULL, 'MEIOSIS-SPECIFIC SERINE/THREONINE-PROTEIN KINASE MEK1', 252155),
(419088, 'PTHR24347:SF388', NULL, NULL, NULL, NULL, 'SI:DKEY-240H12.4', 252155),
(419089, 'PTHR24347:SF386', NULL, NULL, NULL, NULL, 'PHOSPHORYLASE B KINASE GAMMA CATALYTIC CHAIN, SKELETAL MUSCLE/HEART ISOFORM', 252155),
(419090, 'PTHR24347:SF187', NULL, NULL, NULL, NULL, 'MYOSIN LIGHT CHAIN KINASE DDB_G0275057-RELATED', 252155),
(419091, 'PTHR24347:SF384', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-DEPENDENT PROTEIN KINASE TYPE II SUBUNIT ALPHA', 252155),
(419092, 'PTHR24347:SF380', NULL, NULL, NULL, NULL, 'MYOSIN LIGHT CHAIN KINASE DDB_G0271550-RELATED', 252155),
(419093, 'PTHR24347:SF427', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DCLK3', 252155),
(419094, 'PTHR24347:SF425', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 252155),
(419095, 'PTHR24347:SF412', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN DEPENDENT PROTEIN KINASE I', 252155),
(419096, 'PTHR24347:SF379', NULL, NULL, NULL, NULL, 'MYOSIN LIGHT CHAIN KINASE FAMILY MEMBER 4', 252155),
(419097, 'PTHR24347:SF376', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DCLK2', 252155),
(419098, 'PTHR24347:SF255', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE H2', 252155),
(419099, 'PTHR24347:SF254', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE H1', 252155),
(419100, 'PTHR24347:SF374', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252155),
(419101, 'PTHR24347:SF373', NULL, NULL, NULL, NULL, 'MYOSIN LIGHT CHAIN KINASE 2, SKELETAL/CARDIAC MUSCLE', 252155),
(419102, 'PTHR24347:SF252', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-DEPENDENT PROTEIN KINASE TYPE 1D', 252155),
(419103, 'PTHR24347:SF372', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252155),
(419104, 'PTHR24347:SF371', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252155),
(419105, 'PTHR24347:SF370', NULL, NULL, NULL, NULL, 'AGAP001683-PB', 252155),
(419106, 'PTHR24347', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE', 252155),
(419107, 'PTHR24347:SF417', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-DEPENDENT PROTEIN KINASE', 252155),
(419108, 'PTHR34050:SF1', NULL, NULL, NULL, NULL, 'DNA REPAIR RAD52-LIKE PROTEIN 1, MITOCHONDRIAL', 252156);
INSERT INTO "PUBLIC"."MODEL" VALUES
(419109, 'PTHR34050:SF3', NULL, NULL, NULL, NULL, 'DNA REPAIR RAD52-LIKE PROTEIN 2, CHLOROPLASTIC', 252156),
(419110, 'PTHR34050:SF4', NULL, NULL, NULL, NULL, 'OS09G0512800 PROTEIN', 252156),
(419111, 'PTHR34050:SF5', NULL, NULL, NULL, NULL, 'BNAA09G02810D PROTEIN', 252156),
(419112, 'PTHR34050', NULL, NULL, NULL, NULL, '', 252156),
(419113, 'PTHR13102:SF0', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 9', 252157),
(419114, 'PTHR13102', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 9', 252157),
(419115, 'PTHR36130', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4933430I17 GENE', 252158),
(419116, 'PTHR36130:SF1', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4933430I17 GENE', 252158),
(419117, 'PTHR46810:SF1', NULL, NULL, NULL, NULL, 'INACTIVE POLYGLYCYLASE TTLL10', 252159),
(419118, 'PTHR46810', NULL, NULL, NULL, NULL, 'INACTIVE POLYGLYCYLASE TTLL10', 252159),
(419119, 'PTHR33281:SF16', NULL, NULL, NULL, NULL, '', 252160),
(419120, 'PTHR33281:SF18', NULL, NULL, NULL, NULL, 'BESTROPHIN/UPF0187-RELATED', 252160),
(419121, 'PTHR33281:SF17', NULL, NULL, NULL, NULL, 'BNAA09G39100D PROTEIN', 252160),
(419122, 'PTHR33281:SF1', NULL, NULL, NULL, NULL, 'OS03G0106000 PROTEIN', 252160),
(419123, 'PTHR33281:SF14', NULL, NULL, NULL, NULL, 'BNAC04G50530D PROTEIN', 252160),
(419124, 'PTHR33281', NULL, NULL, NULL, NULL, 'UPF0187 PROTEIN YNEE', 252160),
(419125, 'PTHR33281:SF21', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN', 252160),
(419126, 'PTHR33281:SF20', NULL, NULL, NULL, NULL, '', 252160),
(419127, 'PTHR33281:SF19', NULL, NULL, NULL, NULL, 'UPF0187 PROTEIN YNEE', 252160),
(419128, 'PTHR35132', NULL, NULL, NULL, NULL, 'SERINE/ARGININE REPETITIVE MATRIX-LIKE PROTEIN', 252161),
(419129, 'PTHR35132:SF2', NULL, NULL, NULL, NULL, 'OS01G0922100 PROTEIN', 252161),
(419130, 'PTHR35132:SF1', NULL, NULL, NULL, NULL, 'SERINE/ARGININE REPETITIVE MATRIX-LIKE PROTEIN', 252161),
(419131, 'PTHR11803:SF50', NULL, NULL, NULL, NULL, 'BNAC01G32570D PROTEIN', 252162),
(419132, 'PTHR11803:SF51', NULL, NULL, NULL, NULL, 'BNAA05G36080D PROTEIN', 252162),
(419133, 'PTHR11803:SF42', NULL, NULL, NULL, NULL, 'MMF1', 252162),
(419134, 'PTHR11803:SF53', NULL, NULL, NULL, NULL, '2-IMINOBUTANOATE/2-IMINOPROPANOATE DEAMINASE', 252162),
(419135, 'PTHR11803:SF54', NULL, NULL, NULL, NULL, '2-IMINOBUTANOATE/2-IMINOPROPANOATE DEAMINASE', 252162),
(419136, 'PTHR11803', NULL, NULL, NULL, NULL, '2-IMINOBUTANOATE/2-IMINOPROPANOATE DEAMINASE RIDA', 252162),
(419137, 'PTHR11803:SF44', NULL, NULL, NULL, NULL, 'RUTC FAMILY PROTEIN YJGH', 252162),
(419138, 'PTHR11803:SF22', NULL, NULL, NULL, NULL, 'ENDORIBONUCLEASE FAMILY PROTEIN BRT1, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G03780)-RELATED', 252162),
(419139, 'PTHR11803:SF45', NULL, NULL, NULL, NULL, 'PERCHLORIC ACID SOLUBLE TRANSLATION INHIBITOR-LIKE PROTEIN', 252162),
(419140, 'PTHR11803:SF12', NULL, NULL, NULL, NULL, '', 252162),
(419141, 'PTHR11803:SF46', NULL, NULL, NULL, NULL, 'INDUCIBLE PLASTID-LIPID ASSOCIATED PROTEIN', 252162),
(419142, 'PTHR11803:SF57', NULL, NULL, NULL, NULL, 'BLL5130 PROTEIN', 252162),
(419143, 'PTHR11803:SF48', NULL, NULL, NULL, NULL, 'ENDORIBONUCLEASE FAMILY PROTEIN, PUTATIVE-RELATED', 252162),
(419144, 'PTHR11803:SF49', NULL, NULL, NULL, NULL, 'ENDORIBONUCLEASE L-PSP FAMILY PROTEIN-RELATED', 252162),
(419145, 'PTHR11803:SF39', NULL, NULL, NULL, NULL, '2-IMINOBUTANOATE/2-IMINOPROPANOATE DEAMINASE', 252162),
(419146, 'PTHR14939', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 22', 252163),
(419147, 'PTHR14939:SF5', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 22', 252163),
(419148, 'PTHR14939:SF8', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252163),
(419149, 'PTHR14939:SF9', NULL, NULL, NULL, NULL, 'FIST_C DOMAIN-CONTAINING PROTEIN', 252163),
(419150, 'PTHR42103:SF2', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 252164),
(419151, 'PTHR42103', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 252164),
(419152, 'PTHR13484:SF0', NULL, NULL, NULL, NULL, 'FIP1-LIKE 1 PROTEIN', 252165),
(419153, 'PTHR13484:SF9', NULL, NULL, NULL, NULL, 'PRE-MRNA 3''-END-PROCESSING FACTOR FIP1', 252165);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(419154, 'PTHR13484', NULL, NULL, NULL, NULL, 'FIP1-LIKE 1 PROTEIN', 252165),
(419155, 'PTHR13484:SF8', NULL, NULL, NULL, NULL, 'FIP1-LIKE 1 PROTEIN', 252165),
(419156, 'PTHR13484:SF10', NULL, NULL, NULL, NULL, '', 252165),
(419157, 'PTHR13936:SF14', NULL, NULL, NULL, NULL, 'PROFILIN-1', 252166),
(419158, 'PTHR13936:SF15', NULL, NULL, NULL, NULL, 'PROFILIN-2', 252166),
(419159, 'PTHR13936:SF16', NULL, NULL, NULL, NULL, 'PROFILIN', 252166),
(419160, 'PTHR13936', NULL, NULL, NULL, NULL, 'PROFILIN', 252166),
(419161, 'PTHR13936:SF2', NULL, NULL, NULL, NULL, 'PROFILIN-3', 252166),
(419162, 'PTHR13936:SF5', NULL, NULL, NULL, NULL, 'PROFILIN', 252166),
(419163, 'PTHR23284', NULL, NULL, NULL, NULL, 'PROLACTIN REGULATORY ELEMENT BINDING PROTEIN', 252167),
(419164, 'PTHR23284:SF6', NULL, NULL, NULL, NULL, 'OS07G0187700 PROTEIN', 252167),
(419165, 'PTHR23284:SF2', NULL, NULL, NULL, NULL, 'SEC12-LIKE PROTEIN 1', 252167),
(419166, 'PTHR23284:SF5', NULL, NULL, NULL, NULL, 'SEC12P-LIKE 2 PROTEIN-RELATED', 252167),
(419167, 'PTHR23284:SF4', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 252167),
(419168, 'PTHR23284:SF0', NULL, NULL, NULL, NULL, 'PROLACTIN REGULATORY ELEMENT-BINDING PROTEIN', 252167),
(419169, 'PTHR16128', NULL, NULL, NULL, NULL, 'FAD/NAD(P)-BINDING OXIDOREDUCTASE FAMILY PROTEIN', 252168),
(419170, 'PTHR16128:SF5', NULL, NULL, NULL, NULL, 'FAD/NAD(P)-BINDING OXIDOREDUCTASE FAMILY PROTEIN', 252168),
(419171, 'PTHR16128:SF8', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252168),
(419172, 'PTHR46546:SF6', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE, PUTATIVE-RELATED', 252169),
(419173, 'PTHR46546:SF4', NULL, NULL, NULL, NULL, 'SHEWANELLA-LIKE PROTEIN PHOSPHATASE 1', 252169),
(419174, 'PTHR46546', NULL, NULL, NULL, NULL, 'SHEWANELLA-LIKE PROTEIN PHOSPHATASE 1', 252169),
(419175, 'PTHR46253:SF2', NULL, NULL, NULL, NULL, 'TGF-BETA-ACTIVATED KINASE 1 AND MAP3K7-BINDING PROTEIN 2', 252170),
(419176, 'PTHR46253:SF1', NULL, NULL, NULL, NULL, 'TAB2', 252170),
(419177, 'PTHR46253', NULL, NULL, NULL, NULL, 'TGF-BETA-ACTIVATED KINASE 1 AND MAP3K7-BINDING PROTEIN TAB', 252170),
(419178, 'PTHR46253:SF3', NULL, NULL, NULL, NULL, 'TGF-BETA-ACTIVATED KINASE 1 AND MAP3K7-BINDING PROTEIN 3', 252170),
(419179, 'PTHR12532', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252171),
(419180, 'PTHR12532:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN YEBC-RELATED', 252171),
(419181, 'PTHR12532:SF0', NULL, NULL, NULL, NULL, 'TRANSLATIONAL ACTIVATOR OF CYTOCHROME C OXIDASE 1', 252171),
(419182, 'PTHR12532:SF11', NULL, NULL, NULL, NULL, '', 252171),
(419183, 'PTHR43374:SF5', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 252172),
(419184, 'PTHR43374', NULL, NULL, NULL, NULL, 'FLAVIN PRENYLTRANSFERASE', 252172),
(419185, 'PTHR43374:SF1', NULL, NULL, NULL, NULL, 'FLAVIN PRENYLTRANSFERASE PAD1, MITOCHONDRIAL', 252172),
(419186, 'PTHR43691:SF6', NULL, NULL, NULL, NULL, 'AMP NUCLEOSIDASE', 252173),
(419187, 'PTHR43691:SF10', NULL, NULL, NULL, NULL, 'URIDINE PHOSPHORYLASE 1', 252173),
(419188, 'PTHR43691:SF13', NULL, NULL, NULL, NULL, 'URIDINE PHOSPHORYLASE', 252173),
(419189, 'PTHR43691:SF14', NULL, NULL, NULL, NULL, 'URIDINE PHOSPHORYLASE', 252173),
(419190, 'PTHR43691:SF11', NULL, NULL, NULL, NULL, 'FI09636P-RELATED', 252173),
(419191, 'PTHR43691:SF8', NULL, NULL, NULL, NULL, 'URIDINE PHOSPHORYLASE 2', 252173),
(419192, 'PTHR43691', NULL, NULL, NULL, NULL, 'URIDINE PHOSPHORYLASE', 252173),
(419193, 'PTHR43691:SF15', NULL, NULL, NULL, NULL, 'PHOSPHORYLASE, PUTATIVE-RELATED', 252173),
(419194, 'PTHR43691:SF2', NULL, NULL, NULL, NULL, 'PURINE NUCLEOSIDE PHOSPHORYLASE DEOD-TYPE', 252173),
(419195, 'PTHR38506', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4930544D05 GENE', 252174),
(419196, 'PTHR38506:SF1', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4930544D05 GENE', 252174),
(419197, 'PTHR10242:SF7', NULL, NULL, NULL, NULL, 'ENDO3C DOMAIN-CONTAINING PROTEIN', 252175),
(419198, 'PTHR10242:SF4', NULL, NULL, NULL, NULL, 'ENDO3C DOMAIN-CONTAINING PROTEIN', 252175),
(419199, 'PTHR10242:SF2', NULL, NULL, NULL, NULL, 'N-GLYCOSYLASE/DNA LYASE', 252175);
INSERT INTO "PUBLIC"."MODEL" VALUES
(419200, 'PTHR10242', NULL, NULL, NULL, NULL, '8-OXOGUANINE DNA GLYCOSYLASE', 252175),
(419201, 'PTHR43986:SF1', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-GAMMA', 252176),
(419202, 'PTHR43986', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-GAMMA', 252176),
(419203, 'PTHR43986:SF9', NULL, NULL, NULL, NULL, 'FACTOR 1 GAMMA, PUTATIVE-RELATED', 252176),
(419204, 'PTHR43986:SF5', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-GAMMA', 252176),
(419205, 'PTHR43986:SF11', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-GAMMA', 252176),
(419206, 'PTHR43986:SF10', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR EEF-1B GAMMA SUBUNIT, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G17120)-RELATED', 252176),
(419207, 'PTHR43986:SF6', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-GAMMA', 252176),
(419208, 'PTHR43986:SF4', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-GAMMA', 252176),
(419209, 'PTHR36403:SF1', NULL, NULL, NULL, NULL, 'PROTEIN COFACTOR ASSEMBLY OF COMPLEX C SUBUNIT B CCB2, CHLOROPLASTIC', 252177),
(419210, 'PTHR36403', NULL, NULL, NULL, NULL, 'PROTEIN COFACTOR ASSEMBLY OF COMPLEX C SUBUNIT B CCB2, CHLOROPLASTIC', 252177),
(419211, 'PTHR12746:SF3', NULL, NULL, NULL, NULL, '60S RIBOSOMAL EXPORT PROTEIN NMD3', 252178),
(419212, 'PTHR12746:SF4', NULL, NULL, NULL, NULL, '60S RIBOSOMAL EXPORT PROTEIN NMD3', 252178),
(419213, 'PTHR12746:SF5', NULL, NULL, NULL, NULL, '60S RIBOSOMAL EXPORT PROTEIN NMD3', 252178),
(419214, 'PTHR12746', NULL, NULL, NULL, NULL, 'NONSENSE-MEDIATED MRNA DECAY PROTEIN 3', 252178),
(419215, 'PTHR12746:SF2', NULL, NULL, NULL, NULL, '60S RIBOSOMAL EXPORT PROTEIN NMD3', 252178),
(419216, 'PTHR15964:SF0', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN B RECEPTOR', 252179),
(419217, 'PTHR15964', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN B48 RECEPTOR', 252179),
(419218, 'PTHR47073', NULL, NULL, NULL, NULL, 'PROTEIN ANTI-SILENCING 1', 252180),
(419219, 'PTHR47073:SF5', NULL, NULL, NULL, NULL, 'NUCLEIC ACID BINDING PROTEIN', 252180),
(419220, 'PTHR47073:SF2', NULL, NULL, NULL, NULL, 'PROTEIN ANTI-SILENCING 1', 252180),
(419221, 'PTHR47073:SF9', NULL, NULL, NULL, NULL, 'BAH DOMAIN-CONTAINING PROTEIN', 252180),
(419222, 'PTHR47073:SF8', NULL, NULL, NULL, NULL, 'BAH DOMAIN-CONTAINING PROTEIN', 252180),
(419223, 'PTHR47073:SF7', NULL, NULL, NULL, NULL, 'BAH DOMAIN-CONTAINING PROTEIN', 252180),
(419224, 'PTHR28625:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 35', 252181),
(419225, 'PTHR28625', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 35', 252181),
(419226, 'PTHR10169:SF49', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE 2, MITOCHONDRIAL', 252182),
(419227, 'PTHR10169:SF38', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE 2', 252182),
(419228, 'PTHR10169:SF36', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE 2-BETA', 252182),
(419229, 'PTHR10169', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE/GYRASE', 252182),
(419230, 'PTHR10169:SF62', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE 2 TOP-2-RELATED', 252182),
(419231, 'PTHR10169:SF61', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE 2-ALPHA', 252182),
(419232, 'PTHR10169:SF50', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE 2', 252182),
(419233, 'PTHR31985:SF283', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF018', 252183),
(419234, 'PTHR31985:SF163', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF013', 252183),
(419235, 'PTHR31985:SF240', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF017-LIKE', 252183),
(419236, 'PTHR31985:SF284', NULL, NULL, NULL, NULL, 'INTEGRASE-TYPE DNA-BINDING SUPERFAMILY PROTEIN-RELATED', 252183),
(419237, 'PTHR31985:SF281', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 252183),
(419238, 'PTHR31985:SF282', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF025', 252183),
(419239, 'PTHR31985:SF166', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 252183),
(419240, 'PTHR31985:SF287', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF016', 252183),
(419241, 'PTHR31985:SF200', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF019', 252183);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(419242, 'PTHR31985:SF288', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF035', 252183),
(419243, 'PTHR31985:SF244', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR TINY-LIKE', 252183),
(419244, 'PTHR31985:SF285', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF034-RELATED', 252183),
(419245, 'PTHR31985:SF241', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF043', 252183),
(419246, 'PTHR31985:SF121', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF024', 252183),
(419247, 'PTHR31985:SF242', NULL, NULL, NULL, NULL, 'OS02G0676800 PROTEIN', 252183),
(419248, 'PTHR31985:SF286', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF027', 252183),
(419249, 'PTHR31985:SF85', NULL, NULL, NULL, NULL, 'AP2 DOMAIN CONTAINING PROTEIN', 252183),
(419250, 'PTHR31985:SF87', NULL, NULL, NULL, NULL, 'AP2 DOMAIN CONTAINING PROTEIN, EXPRESSED', 252183),
(419251, 'PTHR31985:SF45', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF020', 252183),
(419252, 'PTHR31985:SF280', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF027-LIKE', 252183),
(419253, 'PTHR31985:SF90', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 252183),
(419254, 'PTHR31985:SF209', NULL, NULL, NULL, NULL, 'DREB-LIKE PROTEIN', 252183),
(419255, 'PTHR31985:SF95', NULL, NULL, NULL, NULL, 'AP2 DOMAIN CLASS TRANSCRIPTION FACTOR', 252183),
(419256, 'PTHR31985:SF203', NULL, NULL, NULL, NULL, 'DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 252183),
(419257, 'PTHR31985:SF248', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF035-LIKE', 252183),
(419258, 'PTHR31985:SF204', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF012', 252183),
(419259, 'PTHR31985:SF289', NULL, NULL, NULL, NULL, 'DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 252183),
(419260, 'PTHR31985:SF125', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 252183),
(419261, 'PTHR31985:SF207', NULL, NULL, NULL, NULL, 'AP2-EREBP TRANSCRIPTION FACTOR', 252183),
(419262, 'PTHR31985:SF249', NULL, NULL, NULL, NULL, 'OS06G0197200 PROTEIN', 252183),
(419263, 'PTHR31985:SF206', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 252183),
(419264, 'PTHR31985:SF173', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 252183),
(419265, 'PTHR31985:SF130', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF038', 252183),
(419266, 'PTHR31985:SF177', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF036', 252183),
(419267, 'PTHR31985:SF210', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 252183),
(419268, 'PTHR31985:SF254', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF038-LIKE', 252183),
(419269, 'PTHR31985:SF290', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF015', 252183),
(419270, 'PTHR31985:SF291', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF038-LIKE', 252183),
(419271, 'PTHR31985:SF137', NULL, NULL, NULL, NULL, 'CBF/DREB1 TRANSCRIPTION FACTOR', 252183),
(419272, 'PTHR31985:SF215', NULL, NULL, NULL, NULL, 'OS08G0454000 PROTEIN', 252183),
(419273, 'PTHR31985:SF259', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 3', 252183),
(419274, 'PTHR31985:SF212', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 252183),
(419275, 'PTHR31985:SF213', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR TINY', 252183),
(419276, 'PTHR31985:SF136', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 252183),
(419277, 'PTHR31985:SF216', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR TINY-LIKE', 252183),
(419278, 'PTHR31985:SF261', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 252183),
(419279, 'PTHR31985:SF185', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 252183),
(419280, 'PTHR31985:SF262', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 252183);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(419281, 'PTHR31985:SF183', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 3-LIKE', 252183),
(419282, 'PTHR31985:SF260', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 252183),
(419283, 'PTHR31985:SF100', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF022', 252183),
(419284, 'PTHR31985:SF265', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR TINY-LIKE', 252183),
(419285, 'PTHR31985:SF189', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 252183),
(419286, 'PTHR31985:SF266', NULL, NULL, NULL, NULL, '', 252183),
(419287, 'PTHR31985:SF263', NULL, NULL, NULL, NULL, 'AP2 DOMAIN CLASS TRANSCRIPTION FACTOR', 252183),
(419288, 'PTHR31985:SF186', NULL, NULL, NULL, NULL, 'AP2/ERF TRANSCRIPTION FACTOR ERF/PTI6-RELATED', 252183),
(419289, 'PTHR31985:SF264', NULL, NULL, NULL, NULL, 'DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 252183),
(419290, 'PTHR31985:SF20', NULL, NULL, NULL, NULL, 'OS02G0558700 PROTEIN', 252183),
(419291, 'PTHR31985:SF180', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF039-LIKE', 252183),
(419292, 'PTHR31985:SF181', NULL, NULL, NULL, NULL, 'INTEGRASE-TYPE DNA-BINDING SUPERFAMILY PROTEIN-RELATED', 252183),
(419293, 'PTHR31985', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF042-RELATED', 252183),
(419294, 'PTHR31985:SF72', NULL, NULL, NULL, NULL, 'OS02G0657000 PROTEIN', 252183),
(419295, 'PTHR31985:SF269', NULL, NULL, NULL, NULL, 'AP2 DOMAIN CLASS TRANSCRIPTION FACTOR', 252183),
(419296, 'PTHR31985:SF148', NULL, NULL, NULL, NULL, 'OS04G0549800 PROTEIN', 252183),
(419297, 'PTHR31985:SF267', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 252183),
(419298, 'PTHR31985:SF223', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 252183),
(419299, 'PTHR31985:SF224', NULL, NULL, NULL, NULL, 'AP2 DOMAIN CONTAINING PROTEIN, EXPRESSED', 252183),
(419300, 'PTHR31985:SF268', NULL, NULL, NULL, NULL, 'OS01G0885900 PROTEIN', 252183),
(419301, 'PTHR31985:SF108', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF016-LIKE', 252183),
(419302, 'PTHR31985:SF109', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 252183),
(419303, 'PTHR31985:SF227', NULL, NULL, NULL, NULL, 'AP2/ERF TRANSCRIPTION FACTOR ERF/PTI6-RELATED', 252183),
(419304, 'PTHR31985:SF228', NULL, NULL, NULL, NULL, 'AP2-EREBP TRANSCRIPTION FACTOR', 252183),
(419305, 'PTHR31985:SF151', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF023', 252183),
(419306, 'PTHR31985:SF272', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF014', 252183),
(419307, 'PTHR31985:SF273', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF017', 252183),
(419308, 'PTHR31985:SF270', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF027-LIKE', 252183),
(419309, 'PTHR31985:SF194', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 252183),
(419310, 'PTHR31985:SF271', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF037', 252183),
(419311, 'PTHR31985:SF150', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF039', 252183),
(419312, 'PTHR31985:SF276', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF026', 252183),
(419313, 'PTHR31985:SF199', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 252183),
(419314, 'PTHR31985:SF232', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF042', 252183),
(419315, 'PTHR31985:SF111', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF021', 252183),
(419316, 'PTHR31985:SF156', NULL, NULL, NULL, NULL, 'DNA-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 252183),
(419317, 'PTHR31985:SF277', NULL, NULL, NULL, NULL, 'AP21', 252183),
(419318, 'PTHR31985:SF233', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 252183),
(419319, 'PTHR31985:SF274', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 252183),
(419320, 'PTHR31985:SF153', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF038-LIKE', 252183);
INSERT INTO "PUBLIC"."MODEL" VALUES
(419321, 'PTHR31985:SF275', NULL, NULL, NULL, NULL, 'AP2/ERF DOMAIN-CONTAINING PROTEIN', 252183),
(419322, 'PTHR31985:SF231', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF014', 252183),
(419323, 'PTHR31985:SF31', NULL, NULL, NULL, NULL, 'OS04G0572200 PROTEIN', 252183),
(419324, 'PTHR31985:SF115', NULL, NULL, NULL, NULL, 'AP2 DOMAIN CONTAINING PROTEIN, EXPRESSED', 252183),
(419325, 'PTHR31985:SF278', NULL, NULL, NULL, NULL, 'AP2/EREBP TRANSCRIPTION FACTOR SUPERFAMILY PROTEIN-RELATED', 252183),
(419326, 'PTHR31985:SF157', NULL, NULL, NULL, NULL, 'INTEGRASE-TYPE DNA-BINDING SUPERFAMILY PROTEIN-RELATED', 252183),
(419327, 'PTHR31985:SF279', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF027-LIKE', 252183),
(419328, 'PTHR24170:SF2', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 27', 252184),
(419329, 'PTHR24170:SF1', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G09870)-RELATED', 252184),
(419330, 'PTHR24170', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 27', 252184),
(419331, 'PTHR28260', NULL, NULL, NULL, NULL, 'SPINDLE POLE BODY COMPONENT SPC105', 252185),
(419332, 'PTHR28260:SF1', NULL, NULL, NULL, NULL, 'SPINDLE POLE BODY COMPONENT SPC105', 252185),
(419333, 'PTHR10582:SF25', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL CATION CHANNEL SUBFAMILY V MEMBER 6', 252186),
(419334, 'PTHR10582:SF34', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 252186),
(419335, 'PTHR10582:SF23', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 252186),
(419336, 'PTHR10582:SF22', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 252186),
(419337, 'PTHR10582:SF33', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 252186),
(419338, 'PTHR10582:SF11', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL CATION CHANNEL SUBFAMILY V MEMBER 5', 252186),
(419339, 'PTHR10582:SF30', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 252186),
(419340, 'PTHR10582:SF31', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 252186),
(419341, 'PTHR10582:SF4', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL CATION CHANNEL SUBFAMILY V MEMBER 4', 252186),
(419342, 'PTHR10582:SF5', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL CATION CHANNEL SUBFAMILY V MEMBER 2', 252186),
(419343, 'PTHR10582:SF6', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL CATION CHANNEL SUBFAMILY V MEMBER 3', 252186),
(419344, 'PTHR10582:SF2', NULL, NULL, NULL, NULL, 'INACTIVE', 252186),
(419345, 'PTHR10582:SF19', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 252186),
(419346, 'PTHR10582', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL ION CHANNEL PROTEIN', 252186),
(419347, 'PTHR10582:SF17', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL CATION CHANNEL SUBFAMILY V MEMBER 1', 252186),
(419348, 'PTHR10582:SF28', NULL, NULL, NULL, NULL, 'NANCHUNG, ISOFORM B', 252186),
(419349, 'PTHR35152:SF1', NULL, NULL, NULL, NULL, 'DOMAIN SIGNALLING PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G11310)-RELATED', 252187),
(419350, 'PTHR35152', NULL, NULL, NULL, NULL, '', 252187),
(419351, 'PTHR36791', NULL, NULL, NULL, NULL, 'OS03G0363400 PROTEIN', 252188),
(419352, 'PTHR36791:SF2', NULL, NULL, NULL, NULL, 'OS03G0363400 PROTEIN', 252188),
(419353, 'PTHR14582', NULL, NULL, NULL, NULL, 'INNER KINETOCHORE SUBUNIT MAL2', 252189),
(419354, 'PTHR14582:SF1', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN O', 252189),
(419355, 'PTHR40026:SF1', NULL, NULL, NULL, NULL, 'PROTEIN VEG', 252190),
(419356, 'PTHR40026', NULL, NULL, NULL, NULL, 'PROTEIN VEG', 252190),
(419357, 'PTHR12414:SF7', NULL, NULL, NULL, NULL, 'CHORION-SPECIFIC TRANSCRIPTION FACTOR GCMB', 252191),
(419358, 'PTHR12414:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GLIAL CELLS MISSING-RELATED', 252191),
(419359, 'PTHR12414:SF6', NULL, NULL, NULL, NULL, 'CHORION-SPECIFIC TRANSCRIPTION FACTOR GCMA', 252191),
(419360, 'PTHR12414', NULL, NULL, NULL, NULL, 'GLIAL CELLS MISSING RELATED/GLIDE', 252191);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(419361, 'PTHR13400', NULL, NULL, NULL, NULL, 'CHEMOKINE C-C MOTIF RECEPTOR 1', 252192),
(419362, 'PTHR13400:SF3', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 28A', 252192),
(419363, 'PTHR13400:SF4', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 28A-LIKE PROTEIN', 252192),
(419364, 'PTHR13400:SF2', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 28B', 252192),
(419365, 'PTHR36139:SF4', NULL, NULL, NULL, NULL, 'BNAC08G04470D PROTEIN', 252193),
(419366, 'PTHR36139:SF3', NULL, NULL, NULL, NULL, '', 252193),
(419367, 'PTHR36139:SF2', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE SUBUNIT 5, MITOCHONDRIAL-LIKE ISOFORM X1', 252193),
(419368, 'PTHR36139:SF1', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE SUBUNIT 5, MITOCHONDRIAL', 252193),
(419369, 'PTHR36139', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE SUBUNIT 5, MITOCHONDRIAL', 252193),
(419370, 'PTHR11494:SF7', NULL, NULL, NULL, NULL, 'T-CELL-SPECIFIC SURFACE GLYCOPROTEIN CD28', 252194),
(419371, 'PTHR11494:SF8', NULL, NULL, NULL, NULL, 'CYTOTOXIC T-LYMPHOCYTE PROTEIN 4', 252194),
(419372, 'PTHR11494:SF9', NULL, NULL, NULL, NULL, 'SI:DKEY-1H24.6', 252194),
(419373, 'PTHR11494', NULL, NULL, NULL, NULL, 'CYTOTOXIC T-LYMPHOCYTE PROTEIN', 252194),
(419374, 'PTHR33116:SF50', NULL, NULL, NULL, NULL, 'PROTEIN HEAT-STRESS-ASSOCIATED 32', 252195),
(419375, 'PTHR33116:SF72', NULL, NULL, NULL, NULL, 'RNASE H FAMILY PROTEIN', 252195),
(419376, 'PTHR33116', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE ZINC-BINDING DOMAIN-CONTAINING PROTEIN-RELATED-RELATED', 252195),
(419377, 'PTHR33116:SF33', NULL, NULL, NULL, NULL, 'OS01G0158850 PROTEIN', 252195),
(419378, 'PTHR33116:SF66', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN, REVERSE TRANSCRIPTASE ZINC-BINDING DOMAIN PROTEIN-RELATED', 252195),
(419379, 'PTHR33116:SF54', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 252195),
(419380, 'PTHR33116:SF43', NULL, NULL, NULL, NULL, 'OS01G0885550 PROTEIN', 252195),
(419381, 'PTHR33116:SF68', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 252195),
(419382, 'PTHR33116:SF67', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE ZINC-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 252195),
(419383, 'PTHR33116:SF69', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 252195),
(419384, 'PTHR33116:SF71', NULL, NULL, NULL, NULL, 'TN7 REVERSE TRANSCRIPTASE', 252195),
(419385, 'PTHR33116:SF70', NULL, NULL, NULL, NULL, 'LINE-TYPE RETROTRANSPOSON LIB DNA, INSERTION AT THE S11 SITE-LIKE PROTEIN', 252195),
(419386, 'PTHR24019:SF14', NULL, NULL, NULL, NULL, 'ADIPOLIN', 252196),
(419387, 'PTHR24019', NULL, NULL, NULL, NULL, 'ADIPOLIN', 252196),
(419388, 'PTHR24019:SF5', NULL, NULL, NULL, NULL, 'ADIPOLIN', 252196),
(419389, 'PTHR24019:SF11', NULL, NULL, NULL, NULL, 'ERYTHROFERRONE', 252196),
(419390, 'PTHR24019:SF13', NULL, NULL, NULL, NULL, 'C1Q DOMAIN-CONTAINING PROTEIN', 252196),
(419391, 'PTHR24019:SF12', NULL, NULL, NULL, NULL, 'ADIPOLIN', 252196),
(419392, 'PTHR18976:SF29', NULL, NULL, NULL, NULL, 'ZGC:162608', 252197),
(419393, 'PTHR18976', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN', 252197),
(419394, 'PTHR18976:SF28', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN A-IV B, TANDEM DUPLICATE 1-RELATED', 252197),
(419395, 'PTHR18976:SF1', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN A-IV', 252197),
(419396, 'PTHR18976:SF34', NULL, NULL, NULL, NULL, 'LIPID-BINDING PROTEIN', 252197),
(419397, 'PTHR18976:SF11', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN A-I', 252197),
(419398, 'PTHR18976:SF2', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN E', 252197),
(419399, 'PTHR18976:SF13', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN A-V', 252197),
(419400, 'PTHR42031:SF1', NULL, NULL, NULL, NULL, '', 252198),
(419401, 'PTHR42031', NULL, NULL, NULL, NULL, '', 252198),
(419402, 'PTHR14136:SF37', NULL, NULL, NULL, NULL, 'OXETANOCIN A RESISTANCE PROTEIN', 252199),
(419403, 'PTHR14136:SF25', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 252199),
(419404, 'PTHR14136:SF22', NULL, NULL, NULL, NULL, 'OS10G0438000 PROTEIN', 252199),
(419405, 'PTHR14136:SF21', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 252199);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(419406, 'PTHR14136:SF31', NULL, NULL, NULL, NULL, 'BTB_2 DOMAIN-CONTAINING PROTEIN', 252199),
(419407, 'PTHR14136:SF41', NULL, NULL, NULL, NULL, 'KHA DOMAIN-CONTAINING PROTEIN', 252199),
(419408, 'PTHR14136:SF30', NULL, NULL, NULL, NULL, 'KHA DOMAIN-CONTAINING PROTEIN', 252199),
(419409, 'PTHR14136:SF40', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN', 252199),
(419410, 'PTHR14136', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252199),
(419411, 'PTHR14136:SF17', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN KCTD9', 252199),
(419412, 'PTHR14136:SF39', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN KCTD9', 252199),
(419413, 'PTHR12901:SF14', NULL, NULL, NULL, NULL, 'COENZYME Q-BINDING PROTEIN COQ10 HOMOLOG, MITOCHONDRIAL', 252200),
(419414, 'PTHR12901:SF16', NULL, NULL, NULL, NULL, 'POLYKETIDE_CYC DOMAIN-CONTAINING PROTEIN', 252200),
(419415, 'PTHR12901:SF8', NULL, NULL, NULL, NULL, 'COENZYME Q-BINDING PROTEIN COQ10 HOMOLOG A, MITOCHONDRIAL', 252200),
(419416, 'PTHR12901:SF9', NULL, NULL, NULL, NULL, 'COENZYME Q-BINDING PROTEIN COQ10 HOMOLOG B, MITOCHONDRIAL', 252200),
(419417, 'PTHR12901:SF10', NULL, NULL, NULL, NULL, 'COENZYME Q-BINDING PROTEIN COQ10, MITOCHONDRIAL', 252200),
(419418, 'PTHR12901', NULL, NULL, NULL, NULL, 'SPERM PROTEIN HOMOLOG', 252200),
(419419, 'PTHR34833', NULL, NULL, NULL, NULL, 'GENE, 17359-RELATED', 252201),
(419420, 'PTHR34833:SF1', NULL, NULL, NULL, NULL, 'GENE, 17359-RELATED', 252201),
(419421, 'PTHR20787:SF10', NULL, NULL, NULL, NULL, 'TREACLE PROTEIN', 252202),
(419422, 'PTHR20787', NULL, NULL, NULL, NULL, 'TREACLE', 252202),
(419423, 'PTHR38633:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG15573', 252203),
(419424, 'PTHR38633:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG09706', 252203),
(419425, 'PTHR38633:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG15571', 252203),
(419426, 'PTHR38633:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG15572', 252203),
(419427, 'PTHR38633:SF6', NULL, NULL, NULL, NULL, 'UTERINE LUMIN EXPRESSED/LOCAILIZED', 252203),
(419428, 'PTHR38633:SF1', NULL, NULL, NULL, NULL, 'UTERINE LUMIN EXPRESSED/LOCAILIZED', 252203),
(419429, 'PTHR38633', NULL, NULL, NULL, NULL, 'PROTEIN CBG15573-RELATED', 252203),
(419430, 'PTHR15724:SF0', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 26', 252204),
(419431, 'PTHR15724', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252204),
(419432, 'PTHR12701:SF53', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM TRANSMEMBRANE PROTEIN', 252205),
(419433, 'PTHR12701:SF51', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM TRANSMEMBRANE PROTEIN', 252205),
(419434, 'PTHR12701', NULL, NULL, NULL, NULL, 'BCR-ASSOCIATED PROTEIN, BAP', 252205),
(419435, 'PTHR12701:SF13', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM TRANSMEMBRANE PROTEIN', 252205),
(419436, 'PTHR12701:SF57', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM TRANSMEMBRANE PROTEIN', 252205),
(419437, 'PTHR12701:SF58', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM TRANSMEMBRANE PROTEIN', 252205),
(419438, 'PTHR12701:SF36', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM TRANSMEMBRANE PROTEIN', 252205),
(419439, 'PTHR12701:SF55', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM TRANSMEMBRANE PROTEIN', 252205),
(419440, 'PTHR12701:SF12', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM TRANSMEMBRANE PROTEIN', 252205),
(419441, 'PTHR12701:SF56', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM TRANSMEMBRANE PROTEIN', 252205),
(419442, 'PTHR12701:SF39', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM TRANSMEMBRANE PROTEIN', 252205),
(419443, 'PTHR12701:SF18', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM TRANSMEMBRANE PROTEIN', 252205),
(419444, 'PTHR12701:SF15', NULL, NULL, NULL, NULL, 'B-CELL RECEPTOR-ASSOCIATED PROTEIN 31', 252205),
(419445, 'PTHR12701:SF59', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM TRANSMEMBRANE PROTEIN', 252205),
(419446, 'PTHR12701:SF38', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM TRANSMEMBRANE PROTEIN', 252205),
(419447, 'PTHR12701:SF19', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM TRANSMEMBRANE PROTEIN 1-RELATED', 252205);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(419448, 'PTHR12701:SF5', NULL, NULL, NULL, NULL, 'B-CELL RECEPTOR-ASSOCIATED PROTEIN 29', 252205),
(419449, 'PTHR12701:SF64', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM TRANSMEMBRANE PROTEIN', 252205),
(419450, 'PTHR12701:SF42', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM TRANSMEMBRANE PROTEIN', 252205),
(419451, 'PTHR12701:SF20', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM TRANSMEMBRANE PROTEIN', 252205),
(419452, 'PTHR12701:SF21', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM TRANSMEMBRANE PROTEIN', 252205),
(419453, 'PTHR12701:SF65', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM TRANSMEMBRANE PROTEIN', 252205),
(419454, 'PTHR12701:SF62', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM TRANSMEMBRANE PROTEIN', 252205),
(419455, 'PTHR12701:SF68', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM TRANSMEMBRANE PROTEIN', 252205),
(419456, 'PTHR12701:SF46', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM TRANSMEMBRANE PROTEIN', 252205),
(419457, 'PTHR12701:SF66', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM TRANSMEMBRANE PROTEIN', 252205),
(419458, 'PTHR12701:SF44', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM TRANSMEMBRANE PROTEIN', 252205),
(419459, 'PTHR12701:SF45', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM TRANSMEMBRANE PROTEIN', 252205),
(419460, 'PTHR12701:SF67', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM TRANSMEMBRANE PROTEIN', 252205),
(419461, 'PTHR12701:SF48', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM TRANSMEMBRANE PROTEIN', 252205),
(419462, 'PTHR12701:SF49', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM TRANSMEMBRANE PROTEIN', 252205),
(419463, 'PTHR46233:SF1', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', 252206),
(419464, 'PTHR46233:SF4', NULL, NULL, NULL, NULL, 'LACTAMASE_B DOMAIN-CONTAINING PROTEIN', 252206),
(419465, 'PTHR46233:SF3', NULL, NULL, NULL, NULL, 'HYDROXYACYLGLUTATHIONE HYDROLASE GLOC', 252206),
(419466, 'PTHR46233', NULL, NULL, NULL, NULL, 'HYDROXYACYLGLUTATHIONE HYDROLASE GLOC', 252206),
(419467, 'PTHR36949:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBR-LIN-66', 252207),
(419468, 'PTHR36949', NULL, NULL, NULL, NULL, 'PROTEIN CBR-LIN-66', 252207),
(419469, 'PTHR40640:SF1', NULL, NULL, NULL, NULL, 'ANCHORED GLYCOPROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G04860)-RELATED', 252208),
(419470, 'PTHR40640:SF2', NULL, NULL, NULL, NULL, 'ANCHORED PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G00450)-RELATED', 252208),
(419471, 'PTHR40640', NULL, NULL, NULL, NULL, 'ANCHORED GLYCOPROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G04860)-RELATED', 252208),
(419472, 'PTHR33228:SF76', NULL, NULL, NULL, NULL, 'PROTEIN GLUTAMINE DUMPER 7', 252209),
(419473, 'PTHR33228:SF54', NULL, NULL, NULL, NULL, 'BNAANNG40800D PROTEIN', 252209),
(419474, 'PTHR33228:SF77', NULL, NULL, NULL, NULL, 'PROTEIN GLUTAMINE DUMPER 2', 252209),
(419475, 'PTHR33228:SF52', NULL, NULL, NULL, NULL, '', 252209),
(419476, 'PTHR33228:SF30', NULL, NULL, NULL, NULL, 'PROTEIN GLUTAMINE DUMPER 1', 252209),
(419477, 'PTHR33228:SF2', NULL, NULL, NULL, NULL, '', 252209),
(419478, 'PTHR33228:SF75', NULL, NULL, NULL, NULL, 'PROTEIN GLUTAMINE DUMPER 6', 252209),
(419479, 'PTHR33228:SF58', NULL, NULL, NULL, NULL, 'PROTEIN GLUTAMINE DUMPER 5-LIKE', 252209),
(419480, 'PTHR33228:SF36', NULL, NULL, NULL, NULL, 'PROTEIN GLUTAMINE DUMPER 3', 252209),
(419481, 'PTHR33228:SF78', NULL, NULL, NULL, NULL, 'PROTEIN GLUTAMINE DUMPER 6-LIKE', 252209),
(419482, 'PTHR33228:SF35', NULL, NULL, NULL, NULL, 'OS02G0191800 PROTEIN', 252209),
(419483, 'PTHR33228:SF57', NULL, NULL, NULL, NULL, 'PROTEIN GLUTAMINE DUMPER 2', 252209),
(419484, 'PTHR33228:SF79', NULL, NULL, NULL, NULL, '', 252209),
(419485, 'PTHR33228:SF19', NULL, NULL, NULL, NULL, 'GDU1', 252209),
(419486, 'PTHR33228:SF38', NULL, NULL, NULL, NULL, '', 252209),
(419487, 'PTHR33228', NULL, NULL, NULL, NULL, 'PROTEIN GLUTAMINE DUMPER 4-RELATED', 252209),
(419488, 'PTHR33228:SF8', NULL, NULL, NULL, NULL, 'OS08G0249200 PROTEIN', 252209),
(419489, 'PTHR33228:SF80', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 252209),
(419490, 'PTHR33228:SF61', NULL, NULL, NULL, NULL, 'PROTEIN GLUTAMINE DUMPER 2-LIKE', 252209);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(419491, 'PTHR33228:SF60', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 252209),
(419492, 'PTHR33228:SF43', NULL, NULL, NULL, NULL, 'PROTEIN GLUTAMINE DUMPER 2-LIKE', 252209),
(419493, 'PTHR33228:SF65', NULL, NULL, NULL, NULL, 'OS06G0633100 PROTEIN', 252209),
(419494, 'PTHR33228:SF41', NULL, NULL, NULL, NULL, '', 252209),
(419495, 'PTHR33228:SF64', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 252209),
(419496, 'PTHR33228:SF67', NULL, NULL, NULL, NULL, 'PROTEIN GLUTAMINE DUMPER 4', 252209),
(419497, 'PTHR33228:SF45', NULL, NULL, NULL, NULL, '', 252209),
(419498, 'PTHR33228:SF68', NULL, NULL, NULL, NULL, 'PROTEIN GLUTAMINE DUMPER 2-LIKE', 252209),
(419499, 'PTHR33228:SF46', NULL, NULL, NULL, NULL, 'BNAA06G39670D PROTEIN', 252209),
(419500, 'PTHR33228:SF29', NULL, NULL, NULL, NULL, '', 252209),
(419501, 'PTHR33228:SF49', NULL, NULL, NULL, NULL, 'PROTEIN GLUTAMINE DUMPER 5', 252209),
(419502, 'PTHR33228:SF27', NULL, NULL, NULL, NULL, '', 252209),
(419503, 'PTHR33228:SF72', NULL, NULL, NULL, NULL, 'PROTEIN GLUTAMINE DUMPER 2-LIKE', 252209),
(419504, 'PTHR33228:SF51', NULL, NULL, NULL, NULL, '', 252209),
(419505, 'PTHR37742:SF1', NULL, NULL, NULL, NULL, 'OS01G0810200 PROTEIN', 252210),
(419506, 'PTHR37742', NULL, NULL, NULL, NULL, 'OS01G0810200 PROTEIN', 252210),
(419507, 'PTHR43264:SF1', NULL, NULL, NULL, NULL, 'IU_NUC_HYDRO DOMAIN-CONTAINING PROTEIN', 252211),
(419508, 'PTHR43264', NULL, NULL, NULL, NULL, '', 252211),
(419509, 'PTHR47680', NULL, NULL, NULL, NULL, 'SHEWANELLA-LIKE PROTEIN PHOSPHATASE 2', 252212),
(419510, 'PTHR47680:SF3', NULL, NULL, NULL, NULL, 'METALLO-DEPENDENT PHOSPHATASE-LIKE PROTEIN-RELATED', 252212),
(419511, 'PTHR47680:SF2', NULL, NULL, NULL, NULL, 'SHEWANELLA-LIKE PROTEIN PHOSPHATASE 2', 252212),
(419512, 'PTHR28133', NULL, NULL, NULL, NULL, 'REQUIRED FOR RESPIRATORY GROWTH PROTEIN 7, MITOCHONDRIAL', 252213),
(419513, 'PTHR28133:SF1', NULL, NULL, NULL, NULL, 'REQUIRED FOR RESPIRATORY GROWTH PROTEIN 7, MITOCHONDRIAL', 252213),
(419514, 'PTHR12289:SF73', NULL, NULL, NULL, NULL, 'CADMIUM RESPONSIVE', 252214),
(419515, 'PTHR12289:SF40', NULL, NULL, NULL, NULL, 'CADMIUM-INDUCIBLE LYSOSOMAL PROTEIN CDR-5', 252214),
(419516, 'PTHR12289:SF72', NULL, NULL, NULL, NULL, 'GST_C_6 DOMAIN-CONTAINING PROTEIN', 252214),
(419517, 'PTHR12289:SF64', NULL, NULL, NULL, NULL, '', 252214),
(419518, 'PTHR12289:SF75', NULL, NULL, NULL, NULL, 'GST-N-METAXIN-LIKE PROTEIN', 252214),
(419519, 'PTHR12289:SF41', NULL, NULL, NULL, NULL, 'FAILED AXON CONNECTIONS-RELATED', 252214),
(419520, 'PTHR12289:SF30', NULL, NULL, NULL, NULL, 'METAXIN-3', 252214),
(419521, 'PTHR12289:SF69', NULL, NULL, NULL, NULL, 'CADMIUM RESPONSIVE', 252214),
(419522, 'PTHR12289:SF38', NULL, NULL, NULL, NULL, 'METAXIN-2', 252214),
(419523, 'PTHR12289:SF22', NULL, NULL, NULL, NULL, 'CADMIUM RESPONSIVE', 252214),
(419524, 'PTHR12289:SF77', NULL, NULL, NULL, NULL, '', 252214),
(419525, 'PTHR12289:SF44', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN (SAM35), PUTATIVE (AFU_ORTHOLOGUE AFUA_1G13180)-RELATED', 252214),
(419526, 'PTHR12289:SF76', NULL, NULL, NULL, NULL, 'FAILED AXON CONNECTIONS HOMOLOG', 252214),
(419527, 'PTHR12289:SF32', NULL, NULL, NULL, NULL, 'PROTEIN CBG02473', 252214),
(419528, 'PTHR12289:SF68', NULL, NULL, NULL, NULL, 'METAXIN', 252214),
(419529, 'PTHR12289:SF67', NULL, NULL, NULL, NULL, 'GST N-TERMINAL DOMAIN-CONTAINING PROTEIN', 252214),
(419530, 'PTHR12289:SF34', NULL, NULL, NULL, NULL, 'METAXIN-1', 252214),
(419531, 'PTHR12289:SF23', NULL, NULL, NULL, NULL, 'CADMIUM RESPONSIVE', 252214),
(419532, 'PTHR12289', NULL, NULL, NULL, NULL, 'METAXIN RELATED', 252214),
(419533, 'PTHR23315:SF329', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419534, 'PTHR23315:SF328', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419535, 'PTHR23315:SF325', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 4-LIKE ISOFORM X1', 252215),
(419536, 'PTHR23315:SF248', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419537, 'PTHR23315:SF247', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(419538, 'PTHR23315:SF324', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419539, 'PTHR23315:SF129', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 252215),
(419540, 'PTHR23315:SF327', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419541, 'PTHR23315:SF326', NULL, NULL, NULL, NULL, 'BNAC05G47780D PROTEIN', 252215),
(419542, 'PTHR23315:SF280', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419543, 'PTHR23315:SF65', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 252215),
(419544, 'PTHR23315:SF64', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 252215),
(419545, 'PTHR23315:SF63', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 16', 252215),
(419546, 'PTHR23315:SF321', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419547, 'PTHR23315:SF288', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419548, 'PTHR23315:SF320', NULL, NULL, NULL, NULL, 'ARMADILLO-TYPE FOLD PROTEIN-RELATED', 252215),
(419549, 'PTHR23315:SF243', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419550, 'PTHR23315:SF246', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 41', 252215),
(419551, 'PTHR23315:SF245', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 10-LIKE', 252215),
(419552, 'PTHR23315:SF322', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 11', 252215),
(419553, 'PTHR23315:SF289', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419554, 'PTHR23315:SF240', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 5', 252215),
(419555, 'PTHR23315:SF284', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 7', 252215),
(419556, 'PTHR23315:SF283', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 39', 252215),
(419557, 'PTHR23315:SF242', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419558, 'PTHR23315:SF285', NULL, NULL, NULL, NULL, 'BNAA02G07540D PROTEIN', 252215),
(419559, 'PTHR23315:SF120', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 252215),
(419560, 'PTHR23315:SF318', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 18', 252215),
(419561, 'PTHR23315:SF319', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 4-LIKE', 252215),
(419562, 'PTHR23315:SF116', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419563, 'PTHR23315', NULL, NULL, NULL, NULL, 'U BOX DOMAIN-CONTAINING', 252215),
(419564, 'PTHR23315:SF237', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419565, 'PTHR23315:SF236', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SPL11', 252215),
(419566, 'PTHR23315:SF313', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 4-LIKE ISOFORM X1', 252215),
(419567, 'PTHR23315:SF239', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419568, 'PTHR23315:SF316', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 45-LIKE', 252215),
(419569, 'PTHR23315:SF238', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 252215),
(419570, 'PTHR23315:SF52', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 10', 252215),
(419571, 'PTHR23315:SF112', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 8', 252215),
(419572, 'PTHR23315:SF310', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419573, 'PTHR23315:SF276', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 38', 252215),
(419574, 'PTHR23315:SF111', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 14', 252215),
(419575, 'PTHR23315:SF278', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 3', 252215),
(419576, 'PTHR23315:SF275', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 13', 252215),
(419577, 'PTHR23315:SF274', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419578, 'PTHR23315:SF307', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 19', 252215),
(419579, 'PTHR23315:SF306', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 45', 252215);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(419580, 'PTHR23315:SF309', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419581, 'PTHR23315:SF347', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419582, 'PTHR23315:SF303', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419583, 'PTHR23315:SF346', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN', 252215),
(419584, 'PTHR23315:SF260', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 73', 252215),
(419585, 'PTHR23315:SF266', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 17', 252215),
(419586, 'PTHR23315:SF343', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN', 252215),
(419587, 'PTHR23315:SF265', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 46-RELATED', 252215),
(419588, 'PTHR23315:SF221', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419589, 'PTHR23315:SF342', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419590, 'PTHR23315:SF345', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419591, 'PTHR23315:SF301', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN-RELATED', 252215),
(419592, 'PTHR23315:SF224', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 1', 252215),
(419593, 'PTHR23315:SF344', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 252215),
(419594, 'PTHR23315:SF300', NULL, NULL, NULL, NULL, 'BNACNNG05650D PROTEIN', 252215),
(419595, 'PTHR23315:SF262', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 15-LIKE', 252215),
(419596, 'PTHR23315:SF261', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419597, 'PTHR23315:SF341', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419598, 'PTHR23315:SF264', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419599, 'PTHR23315:SF340', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419600, 'PTHR23315:SF49', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 15', 252215),
(419601, 'PTHR23315:SF263', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 2', 252215),
(419602, 'PTHR23315:SF339', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 40', 252215),
(419603, 'PTHR23315:SF7', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 4', 252215),
(419604, 'PTHR23315:SF336', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 12', 252215),
(419605, 'PTHR23315:SF335', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419606, 'PTHR23315:SF338', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419607, 'PTHR23315:SF337', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419608, 'PTHR23315:SF82', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419609, 'PTHR23315:SF291', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419610, 'PTHR23315:SF290', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419611, 'PTHR23315:SF79', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419612, 'PTHR23315:SF292', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419613, 'PTHR23315:SF299', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419614, 'PTHR23315:SF255', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 4-LIKE', 252215),
(419615, 'PTHR23315:SF332', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 6', 252215),
(419616, 'PTHR23315:SF254', NULL, NULL, NULL, NULL, 'KINESIN-ASSOCIATED PROTEIN', 252215),
(419617, 'PTHR23315:SF331', NULL, NULL, NULL, NULL, 'ARM1', 252215),
(419618, 'PTHR23315:SF334', NULL, NULL, NULL, NULL, '', 252215),
(419619, 'PTHR23315:SF257', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419620, 'PTHR23315:SF333', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419621, 'PTHR23315:SF256', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 252215);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(419622, 'PTHR23315:SF250', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419623, 'PTHR23315:SF294', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419624, 'PTHR23315:SF330', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419625, 'PTHR23315:SF253', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 9', 252215),
(419626, 'PTHR23315:SF252', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252215),
(419627, 'PTHR37543', NULL, NULL, NULL, NULL, 'CCCH ZINC FINGER DNA BINDING PROTEIN (AFU_ORTHOLOGUE AFUA_5G12760)', 252216),
(419628, 'PTHR37543:SF1', NULL, NULL, NULL, NULL, 'CCCH ZINC FINGER DNA BINDING PROTEIN (AFU_ORTHOLOGUE AFUA_5G12760)', 252216),
(419629, 'PTHR37543:SF2', NULL, NULL, NULL, NULL, 'C3H1-TYPE DOMAIN-CONTAINING PROTEIN', 252216),
(419630, 'PTHR36859', NULL, NULL, NULL, NULL, 'PROTEIN HIDE1', 252217),
(419631, 'PTHR36859:SF1', NULL, NULL, NULL, NULL, 'PROTEIN HIDE1', 252217),
(419632, 'PTHR23243:SF3', NULL, NULL, NULL, NULL, 'SUPRABASIN', 252218),
(419633, 'PTHR23243', NULL, NULL, NULL, NULL, 'SUPRABASAL-SPECIFIC PROTEIN SUPRABASIN', 252218),
(419634, 'PTHR14739', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN 9', 252219),
(419635, 'PTHR14739:SF9', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN 9', 252219),
(419636, 'PTHR34994:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM25E', 252220),
(419637, 'PTHR34994:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAM25A-RELATED', 252220),
(419638, 'PTHR34994', NULL, NULL, NULL, NULL, 'PROTEIN FAM25A-RELATED', 252220),
(419639, 'PTHR12804:SF13', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE COMPLEX SUBUNIT 3B', 252221),
(419640, 'PTHR12804:SF6', NULL, NULL, NULL, NULL, 'ADIPOCYTE-RELATED X-CHROMOSOME EXPRESSED SEQUENCE 1-RELATED', 252221),
(419641, 'PTHR12804', NULL, NULL, NULL, NULL, 'MICROSOMAL SIGNAL PEPTIDASE 23 KD SUBUNIT  SPC22/23', 252221),
(419642, 'PTHR12804:SF7', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE COMPLEX SUBUNIT 3', 252221),
(419643, 'PTHR12804:SF12', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE COMPLEX SUBUNIT 3', 252221),
(419644, 'PTHR12804:SF0', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE COMPLEX SUBUNIT 3', 252221),
(419645, 'PTHR12804:SF10', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE COMPLEX SUBUNIT 3', 252221),
(419646, 'PTHR12804:SF8', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE COMPLEX SUBUNIT 3A', 252221),
(419647, 'PTHR12804:SF9', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE COMPLEX SUBUNIT 3-RELATED', 252221),
(419648, 'PTHR12802:SF170', NULL, NULL, NULL, NULL, 'PROTEIN REVEILLE 6', 252222),
(419649, 'PTHR12802:SF171', NULL, NULL, NULL, NULL, 'OS04G0583900 PROTEIN', 252222),
(419650, 'PTHR12802:SF44', NULL, NULL, NULL, NULL, 'SWI/SNF COMPLEX SUBUNIT SWI3B', 252222),
(419651, 'PTHR12802', NULL, NULL, NULL, NULL, 'SWI/SNF COMPLEX-RELATED', 252222),
(419652, 'PTHR12802:SF136', NULL, NULL, NULL, NULL, 'PROTEIN REVEILLE 6-LIKE', 252222),
(419653, 'PTHR12802:SF135', NULL, NULL, NULL, NULL, 'BNAA06G15430D PROTEIN', 252222),
(419654, 'PTHR12802:SF138', NULL, NULL, NULL, NULL, 'PROTEIN REVEILLE 2', 252222),
(419655, 'PTHR12802:SF140', NULL, NULL, NULL, NULL, 'SWI/SNF COMPLEX SUBUNIT SWI3A', 252222),
(419656, 'PTHR12802:SF143', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 252222),
(419657, 'PTHR12802:SF97', NULL, NULL, NULL, NULL, 'OS01G0156000 PROTEIN', 252222),
(419658, 'PTHR12802:SF98', NULL, NULL, NULL, NULL, 'PROTEIN REVEILLE 4', 252222),
(419659, 'PTHR12802:SF55', NULL, NULL, NULL, NULL, 'OS05G0162800 PROTEIN', 252222),
(419660, 'PTHR12802:SF61', NULL, NULL, NULL, NULL, 'SWI/SNF COMPLEX SUBUNIT SWI3C', 252222),
(419661, 'PTHR12802:SF147', NULL, NULL, NULL, NULL, 'PROTEIN REVEILLE 1-LIKE ISOFORM X1', 252222),
(419662, 'PTHR12802:SF101', NULL, NULL, NULL, NULL, 'SWI/SNF COMPLEX SUBUNIT SWI3D', 252222),
(419663, 'PTHR12802:SF148', NULL, NULL, NULL, NULL, 'SWITCH/SUCROSE NONFERMENTING 3C', 252222),
(419664, 'PTHR12802:SF146', NULL, NULL, NULL, NULL, 'PROTEIN REVEILLE 3', 252222),
(419665, 'PTHR12802:SF103', NULL, NULL, NULL, NULL, 'PROTEIN REVEILLE 6', 252222);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(419666, 'PTHR12802:SF106', NULL, NULL, NULL, NULL, 'PROTEIN CCA1', 252222),
(419667, 'PTHR12802:SF9', NULL, NULL, NULL, NULL, 'SWI/SNF COMPLEX SUBUNIT SMARCC1', 252222),
(419668, 'PTHR12802:SF105', NULL, NULL, NULL, NULL, 'SWI/SNF COMPLEX SUBUNIT SMARCC2', 252222),
(419669, 'PTHR12802:SF149', NULL, NULL, NULL, NULL, 'PROTEIN LHY-LIKE', 252222),
(419670, 'PTHR12802:SF150', NULL, NULL, NULL, NULL, 'CHROMATIN STRUCTURE-REMODELING COMPLEX PROTEIN RSC8', 252222),
(419671, 'PTHR12802:SF151', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 252222),
(419672, 'PTHR12802:SF154', NULL, NULL, NULL, NULL, '', 252222),
(419673, 'PTHR12802:SF155', NULL, NULL, NULL, NULL, 'DEUBIQUITINASE MYSM1', 252222),
(419674, 'PTHR12802:SF152', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 252222),
(419675, 'PTHR12802:SF111', NULL, NULL, NULL, NULL, 'PROTEIN REVEILLE 5', 252222),
(419676, 'PTHR12802:SF153', NULL, NULL, NULL, NULL, 'CIRCADIAN CLOCK ASSOCIATED1', 252222),
(419677, 'PTHR12802:SF158', NULL, NULL, NULL, NULL, 'PROTEIN REVEILLE 1', 252222),
(419678, 'PTHR12802:SF159', NULL, NULL, NULL, NULL, 'PROTEIN REVEILLE 1-LIKE', 252222),
(419679, 'PTHR12802:SF115', NULL, NULL, NULL, NULL, 'PROTEIN REVEILLE 8', 252222),
(419680, 'PTHR12802:SF156', NULL, NULL, NULL, NULL, 'BNACNNG45150D PROTEIN', 252222),
(419681, 'PTHR12802:SF157', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 252222),
(419682, 'PTHR12802:SF119', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 252222),
(419683, 'PTHR12802:SF161', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 252222),
(419684, 'PTHR12802:SF162', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 252222),
(419685, 'PTHR12802:SF160', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 252222),
(419686, 'PTHR12802:SF165', NULL, NULL, NULL, NULL, 'OS06G0728700 PROTEIN', 252222),
(419687, 'PTHR12802:SF166', NULL, NULL, NULL, NULL, 'SWI/SNF AND RSC COMPLEXES SUBUNIT SSR2', 252222),
(419688, 'PTHR12802:SF163', NULL, NULL, NULL, NULL, 'MYB-LIKE PROTEIN H', 252222),
(419689, 'PTHR12802:SF164', NULL, NULL, NULL, NULL, 'PROTEIN REVEILLE 7-RELATED', 252222),
(419690, 'PTHR12802:SF121', NULL, NULL, NULL, NULL, 'OS06G0105800 PROTEIN', 252222),
(419691, 'PTHR12802:SF41', NULL, NULL, NULL, NULL, 'BRAHMA ASSOCIATED PROTEIN 155 KDA', 252222),
(419692, 'PTHR12802:SF169', NULL, NULL, NULL, NULL, 'PROTEIN REVEILLE 1', 252222),
(419693, 'PTHR12802:SF167', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 252222),
(419694, 'PTHR12802:SF168', NULL, NULL, NULL, NULL, 'PROTEIN REVEILLE 7-LIKE ISOFORM X1', 252222),
(419695, 'PTHR12802:SF125', NULL, NULL, NULL, NULL, 'MYB-LIKE PROTEIN K', 252222),
(419696, 'PTHR12802:SF128', NULL, NULL, NULL, NULL, '', 252222),
(419697, 'PTHR12802:SF127', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 252222),
(419698, 'PTHR36797:SF5', NULL, NULL, NULL, NULL, 'BNAA09G09070D PROTEIN', 252223),
(419699, 'PTHR36797:SF6', NULL, NULL, NULL, NULL, '', 252223),
(419700, 'PTHR36797:SF2', NULL, NULL, NULL, NULL, '', 252223),
(419701, 'PTHR36797:SF3', NULL, NULL, NULL, NULL, 'OS01G0258600 PROTEIN', 252223),
(419702, 'PTHR36797', NULL, NULL, NULL, NULL, 'OS01G0258600 PROTEIN', 252223),
(419703, 'PTHR36797:SF4', NULL, NULL, NULL, NULL, '', 252223),
(419704, 'PTHR34144:SF6', NULL, NULL, NULL, NULL, 'EXPORT PROTEIN (CAP59), PUTATIVE (AFU_ORTHOLOGUE AFUA_7G05020)-RELATED', 252224),
(419705, 'PTHR34144:SF5', NULL, NULL, NULL, NULL, 'ALPHA-1,3-MANNOSYLTRANSFERASE CMT1', 252224),
(419706, 'PTHR34144:SF7', NULL, NULL, NULL, NULL, 'BULB-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 252224),
(419707, 'PTHR34144', NULL, NULL, NULL, NULL, 'CHROMOSOME 8, WHOLE GENOME SHOTGUN SEQUENCE', 252224),
(419708, 'PTHR34144:SF2', NULL, NULL, NULL, NULL, 'CAPSULAR ASSOCIATED PROTEIN', 252224),
(419709, 'PTHR34144:SF1', NULL, NULL, NULL, NULL, 'CAPSULAR ASSOCIATED PROTEIN', 252224),
(419710, 'PTHR30203:SF20', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE OUTER MEMBRANE PROTEIN MDTP-RELATED', 252225);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(419711, 'PTHR30203', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE CATION EFFLUX PROTEIN', 252225),
(419712, 'PTHR30203:SF21', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE EFFLUX PROTEIN', 252225),
(419713, 'PTHR30203:SF23', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE EFFLUX PROTEIN', 252225),
(419714, 'PTHR30203:SF24', NULL, NULL, NULL, NULL, 'CATION EFFLUX SYSTEM PROTEIN', 252225),
(419715, 'PTHR30203:SF25', NULL, NULL, NULL, NULL, 'RND EFFLUX SYSTEM, OUTER MEMBRANE LIPOPROTEIN, NODT', 252225),
(419716, 'PTHR30203:SF26', NULL, NULL, NULL, NULL, 'CATION EFFLUX SYSTEM PROTEIN CUSC', 252225),
(419717, 'PTHR30203:SF27', NULL, NULL, NULL, NULL, 'TYPE I SECRETION OUTER MEMBRANE PROTEIN', 252225),
(419718, 'PTHR30203:SF28', NULL, NULL, NULL, NULL, 'BLR4455 PROTEIN', 252225),
(419719, 'PTHR30203:SF29', NULL, NULL, NULL, NULL, 'PROTEIN CYAE', 252225),
(419720, 'PTHR43840:SF35', NULL, NULL, NULL, NULL, 'METAL TOLERANCE PROTEIN 10', 252226),
(419721, 'PTHR43840:SF13', NULL, NULL, NULL, NULL, 'ZT_DIMER DOMAIN-CONTAINING PROTEIN', 252226),
(419722, 'PTHR43840:SF15', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL METAL TRANSPORTER 1-RELATED', 252226),
(419723, 'PTHR43840:SF16', NULL, NULL, NULL, NULL, 'ZT_DIMER DOMAIN-CONTAINING PROTEIN', 252226),
(419724, 'PTHR43840:SF17', NULL, NULL, NULL, NULL, 'ZT_DIMER DOMAIN-CONTAINING PROTEIN', 252226),
(419725, 'PTHR43840:SF39', NULL, NULL, NULL, NULL, 'ZT_DIMER DOMAIN-CONTAINING PROTEIN', 252226),
(419726, 'PTHR43840:SF50', NULL, NULL, NULL, NULL, 'MANGANESE EFFLUX SYSTEM PROTEIN MNES', 252226),
(419727, 'PTHR43840:SF51', NULL, NULL, NULL, NULL, 'CATION EFFLUX PROTEIN-RELATED', 252226),
(419728, 'PTHR43840:SF30', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN, HYPOTHETICAL', 252226),
(419729, 'PTHR43840:SF52', NULL, NULL, NULL, NULL, 'CATION EFFLUX FAMILY PROTEIN', 252226),
(419730, 'PTHR43840:SF11', NULL, NULL, NULL, NULL, 'CATION DIFFUSION FACILITATOR 10', 252226),
(419731, 'PTHR43840:SF12', NULL, NULL, NULL, NULL, 'CATION DIFFUSION FACILITATOR 1 (AFU_ORTHOLOGUE AFUA_1G14440)', 252226),
(419732, 'PTHR43840:SF6', NULL, NULL, NULL, NULL, 'ZT_DIMER DOMAIN-CONTAINING PROTEIN', 252226),
(419733, 'PTHR43840:SF8', NULL, NULL, NULL, NULL, 'ZT_DIMER DOMAIN-CONTAINING PROTEIN', 252226),
(419734, 'PTHR43840', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL METAL TRANSPORTER 1-RELATED', 252226),
(419735, 'PTHR43840:SF47', NULL, NULL, NULL, NULL, 'ZT_DIMER DOMAIN-CONTAINING PROTEIN', 252226),
(419736, 'PTHR43840:SF48', NULL, NULL, NULL, NULL, 'CATION DIFFUSION FACILITATOR FAMILY TRANSPORTER', 252226),
(419737, 'PTHR43840:SF26', NULL, NULL, NULL, NULL, 'METAL TOLERANCE PROTEIN 6', 252226),
(419738, 'PTHR43840:SF27', NULL, NULL, NULL, NULL, 'MN-SPECIFIC CATION DIFFUSION FACILITATOR TRANSPORTER MTP8.1', 252226),
(419739, 'PTHR43840:SF49', NULL, NULL, NULL, NULL, 'ZT_DIMER DOMAIN-CONTAINING PROTEIN', 252226),
(419740, 'PTHR43840:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG10923', 252226),
(419741, 'PTHR43840:SF41', NULL, NULL, NULL, NULL, 'FERROUS-IRON EFFLUX PUMP FIEF', 252226),
(419742, 'PTHR43840:SF2', NULL, NULL, NULL, NULL, 'METAL TOLERANCE PROTEIN 9', 252226),
(419743, 'PTHR43840:SF43', NULL, NULL, NULL, NULL, 'METAL TOLERANCE PROTEIN 4-LIKE', 252226),
(419744, 'PTHR43840:SF4', NULL, NULL, NULL, NULL, 'CDF DIVALENT METAL CATION TRANSPORTER (EUROFUNG)', 252226),
(419745, 'PTHR43840:SF23', NULL, NULL, NULL, NULL, 'METAL TOLERANCE PROTEIN 3', 252226),
(419746, 'PTHR43840:SF5', NULL, NULL, NULL, NULL, 'METAL TOLERANCE PROTEIN 11', 252226),
(419747, 'PTHR43840:SF45', NULL, NULL, NULL, NULL, 'METAL TOLERANCE PROTEIN C3-RELATED', 252226),
(419748, 'PTHR47483', NULL, NULL, NULL, NULL, 'BETA-ARABINOFURANOSYLTRANSFERASE RAY1', 252227),
(419749, 'PTHR47483:SF1', NULL, NULL, NULL, NULL, 'BETA-ARABINOFURANOSYLTRANSFERASE RAY1', 252227),
(419750, 'PTHR40099', NULL, NULL, NULL, NULL, 'ACETOLACTATE SYNTHASE, SMALL SUBUNIT', 252228),
(419751, 'PTHR40099:SF1', NULL, NULL, NULL, NULL, 'ACETOLACTATE SYNTHASE, SMALL SUBUNIT', 252228),
(419752, 'PTHR23215:SF1', NULL, NULL, NULL, NULL, 'BUB3-INTERACTING AND GLEBS MOTIF-CONTAINING PROTEIN ZNF207', 252229);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(419753, 'PTHR23215:SF0', NULL, NULL, NULL, NULL, 'BUB3-INTERACTING AND GLEBS MOTIF-CONTAINING PROTEIN ZNF207', 252229),
(419754, 'PTHR23215:SF3', NULL, NULL, NULL, NULL, 'BED-TYPE DOMAIN-CONTAINING PROTEIN', 252229),
(419755, 'PTHR23215:SF2', NULL, NULL, NULL, NULL, '', 252229),
(419756, 'PTHR23215:SF4', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 252229),
(419757, 'PTHR23215', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 207', 252229),
(419758, 'PTHR46698:SF2', NULL, NULL, NULL, NULL, 'KIELIN/CHORDIN-LIKE PROTEIN', 252230),
(419759, 'PTHR46698:SF3', NULL, NULL, NULL, NULL, 'TENECTIN ISOFORM 1', 252230),
(419760, 'PTHR46698', NULL, NULL, NULL, NULL, 'CROSSVEINLESS 2', 252230),
(419761, 'PTHR46698:SF4', NULL, NULL, NULL, NULL, 'CROSSVEINLESS 2', 252230),
(419762, 'PTHR46698:SF5', NULL, NULL, NULL, NULL, '', 252230),
(419763, 'PTHR30363:SF51', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REPRESSOR GLCR', 252231),
(419764, 'PTHR30363:SF52', NULL, NULL, NULL, NULL, 'DEOR FAMILY REGULATORY PROTEIN-RELATED', 252231),
(419765, 'PTHR30363:SF28', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN-RELATED', 252231),
(419766, 'PTHR30363:SF15', NULL, NULL, NULL, NULL, 'AGA OPERON TRANSCRIPTIONAL REPRESSOR-RELATED', 252231),
(419767, 'PTHR30363:SF49', NULL, NULL, NULL, NULL, 'L-FUCOSE OPERON ACTIVATOR', 252231),
(419768, 'PTHR30363:SF46', NULL, NULL, NULL, NULL, 'DEOR FAMILY REGULATORY PROTEINS', 252231),
(419769, 'PTHR30363:SF57', NULL, NULL, NULL, NULL, 'GLUCITOL OPERON REPRESSOR', 252231),
(419770, 'PTHR30363:SF24', NULL, NULL, NULL, NULL, 'SGC REGION TRANSCRIPTIONAL REGULATOR-RELATED', 252231),
(419771, 'PTHR30363:SF8', NULL, NULL, NULL, NULL, 'DEOXYRIBOSE OPERON REPRESSOR', 252231),
(419772, 'PTHR30363:SF58', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN, DEOR FAMILY-RELATED', 252231),
(419773, 'PTHR30363:SF44', NULL, NULL, NULL, NULL, 'L-FUCOSE OPERON ACTIVATOR', 252231),
(419774, 'PTHR30363:SF55', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR ULAR', 252231),
(419775, 'PTHR30363:SF56', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR OF THE FRUCTOSE OPERON', 252231),
(419776, 'PTHR30363:SF4', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE REGULON REPRESSOR', 252231),
(419777, 'PTHR30363:SF19', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REPRESSOR CSQR', 252231),
(419778, 'PTHR30363', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR SRLR-RELATED', 252231),
(419779, 'PTHR43409:SF3', NULL, NULL, NULL, NULL, 'HYPOTHETICAL METHYLTRANSFERASE', 252232),
(419780, 'PTHR43409:SF4', NULL, NULL, NULL, NULL, 'RADICAL SAM SUPERFAMILY PROTEIN-RELATED', 252232),
(419781, 'PTHR43409:SF1', NULL, NULL, NULL, NULL, 'B12-BINDING DOMAIN-CONTAINING PROTEIN', 252232),
(419782, 'PTHR43409:SF14', NULL, NULL, NULL, NULL, 'SLL1084 PROTEIN', 252232),
(419783, 'PTHR43409:SF15', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 252232),
(419784, 'PTHR43409:SF2', NULL, NULL, NULL, NULL, 'RADICAL SAM DOMAIN PROTEIN', 252232),
(419785, 'PTHR43409', NULL, NULL, NULL, NULL, 'ANAEROBIC MAGNESIUM-PROTOPORPHYRIN IX MONOMETHYL ESTER CYCLASE-RELATED', 252232),
(419786, 'PTHR43409:SF12', NULL, NULL, NULL, NULL, 'HYPOTHETICAL METHYLTRANSFERASE', 252232),
(419787, 'PTHR43409:SF7', NULL, NULL, NULL, NULL, 'METHYLTHIOTRANSFERASE MJ0865-RELATED', 252232),
(419788, 'PTHR43409:SF13', NULL, NULL, NULL, NULL, 'ANAEROBIC MAGNESIUM-PROTOPORPHYRIN IX MONOMETHYL ESTER CYCLASE', 252232),
(419789, 'PTHR43409:SF10', NULL, NULL, NULL, NULL, 'SLR0320 PROTEIN', 252232),
(419790, 'PTHR43409:SF9', NULL, NULL, NULL, NULL, 'BLR2995 PROTEIN', 252232),
(419791, 'PTHR31559', NULL, NULL, NULL, NULL, 'PYRIDOXAL 5''-PHOSPHATE SYNTHASE SUBUNIT SNO', 252233),
(419792, 'PTHR31559:SF0', NULL, NULL, NULL, NULL, 'PYRIDOXAL 5''-PHOSPHATE SYNTHASE SUBUNIT SNO1-RELATED', 252233),
(419793, 'PTHR31559:SF1', NULL, NULL, NULL, NULL, 'GLUTAMINASE', 252233),
(419794, 'PTHR15223:SF1', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 BETA SUBCOMPLEX SUBUNIT 2, MITOCHONDRIAL', 252234),
(419795, 'PTHR15223', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE AGGG SUBUNIT', 252234);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(419796, 'PTHR12458:SF10', NULL, NULL, NULL, NULL, 'DUF667 DOMAIN-CONTAINING PROTEIN', 252235),
(419797, 'PTHR12458', NULL, NULL, NULL, NULL, 'ORF PROTEIN', 252235),
(419798, 'PTHR12458:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CFAP20DC', 252235),
(419799, 'PTHR12458:SF8', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 20', 252235),
(419800, 'PTHR34654:SF1', NULL, NULL, NULL, NULL, 'UPF0109 PROTEIN TM_1567', 252236),
(419801, 'PTHR34654', NULL, NULL, NULL, NULL, 'UPF0109 PROTEIN SCO5592', 252236),
(419802, 'PTHR31847', NULL, NULL, NULL, NULL, 'PROTEIN CBG10327', 252237),
(419803, 'PTHR31847:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG10327', 252237),
(419804, 'PTHR39453', NULL, NULL, NULL, NULL, 'PHOSPHATE PROPANOYLTRANSFERASE', 252238),
(419805, 'PTHR39453:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATE PROPANOYLTRANSFERASE', 252238),
(419806, 'PTHR48065:SF35', NULL, NULL, NULL, NULL, 'PIRIFORMOSPORA INDICA-INSENSITIVE PROTEIN 2-LIKE', 252239),
(419807, 'PTHR48065:SF57', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 252239),
(419808, 'PTHR48065:SF14', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN EIX2', 252239),
(419809, 'PTHR48065:SF58', NULL, NULL, NULL, NULL, 'PQ-LOOP REPEAT FAMILY PROTEIN / TRANSMEMBRANE FAMILY PROTEIN', 252239),
(419810, 'PTHR48065:SF33', NULL, NULL, NULL, NULL, 'OS01G0891700 PROTEIN', 252239),
(419811, 'PTHR48065:SF11', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 252239),
(419812, 'PTHR48065:SF55', NULL, NULL, NULL, NULL, 'KINASE BRI1, PUTATIVE-RELATED', 252239),
(419813, 'PTHR48065:SF56', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 46', 252239),
(419814, 'PTHR48065:SF17', NULL, NULL, NULL, NULL, 'OS07G0466500 PROTEIN', 252239),
(419815, 'PTHR48065:SF39', NULL, NULL, NULL, NULL, 'TRANSPORTER ABC DOMAIN PROTEIN', 252239),
(419816, 'PTHR48065:SF18', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE FAMILY PROTEIN', 252239),
(419817, 'PTHR48065:SF59', NULL, NULL, NULL, NULL, 'ELICITOR-INDUCIBLE LRR RECEPTOR-LIKE PROTEIN EILP', 252239),
(419818, 'PTHR48065:SF15', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 252239),
(419819, 'PTHR48065:SF50', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 252239),
(419820, 'PTHR48065:SF53', NULL, NULL, NULL, NULL, 'OS11G0213300 PROTEIN', 252239),
(419821, 'PTHR48065:SF31', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252239),
(419822, 'PTHR48065:SF32', NULL, NULL, NULL, NULL, 'PROTEIN BRASSINOSTEROID INSENSITIVE 1-LIKE', 252239),
(419823, 'PTHR48065:SF54', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE GSO1', 252239),
(419824, 'PTHR48065:SF51', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 2', 252239),
(419825, 'PTHR48065:SF52', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE FAMILY PROTEIN', 252239),
(419826, 'PTHR48065:SF46', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 252239),
(419827, 'PTHR48065:SF25', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 252239),
(419828, 'PTHR48065:SF47', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE FAMILY PROTEIN', 252239),
(419829, 'PTHR48065:SF23', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 252239),
(419830, 'PTHR48065:SF29', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 252239),
(419831, 'PTHR48065:SF48', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 12', 252239),
(419832, 'PTHR48065:SF26', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 2', 252239),
(419833, 'PTHR48065:SF49', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 252239),
(419834, 'PTHR48065:SF27', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 252239),
(419835, 'PTHR48065:SF60', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 12', 252239),
(419836, 'PTHR48065:SF61', NULL, NULL, NULL, NULL, 'OS10G0469600 PROTEIN', 252239),
(419837, 'PTHR48065:SF5', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN CF-9 HOMOLOG', 252239),
(419838, 'PTHR48065:SF7', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE INHIBITOR 1', 252239);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(419839, 'PTHR48065:SF20', NULL, NULL, NULL, NULL, '', 252239),
(419840, 'PTHR48065:SF42', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE IRK-RELATED', 252239),
(419841, 'PTHR48065:SF43', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 252239),
(419842, 'PTHR48065:SF62', NULL, NULL, NULL, NULL, 'OS02G0515125 PROTEIN', 252239),
(419843, 'PTHR48065:SF2', NULL, NULL, NULL, NULL, 'OS10G0375400 PROTEIN', 252239),
(419844, 'PTHR48065:SF40', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR PROTEIN KINASE EMS1-LIKE', 252239),
(419845, 'PTHR48065:SF63', NULL, NULL, NULL, NULL, 'LRRNT_2 DOMAIN-CONTAINING PROTEIN', 252239),
(419846, 'PTHR48065', NULL, NULL, NULL, NULL, 'OS10G0469600 PROTEIN', 252239),
(419847, 'PTHR23247', NULL, NULL, NULL, NULL, 'NY-REN-41 ANTIGEN  L15 -RELATED', 252240),
(419848, 'PTHR23247:SF2', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 34', 252240),
(419849, 'PTHR21358', NULL, NULL, NULL, NULL, 'PROTEIN MAELSTROM HOMOLOG', 252241),
(419850, 'PTHR21358:SF4', NULL, NULL, NULL, NULL, 'PROTEIN MAELSTROM HOMOLOG', 252241),
(419851, 'PTHR21015:SF27', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE--N-ACETYLMURAMYL-(PENTAPEPTIDE) PYROPHOSPHORYL-UNDECAPRENOL N-ACETYLGLUCOSAMINE TRANSFERASE', 252242),
(419852, 'PTHR21015:SF28', NULL, NULL, NULL, NULL, 'SLL1722 PROTEIN', 252242),
(419853, 'PTHR21015', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE--N-ACETYLMURAMYL-(PENTAPEPTIDE) PYROPHOSPHORYL-UNDECAPRENOL N-ACETYLGLUCOSAMINE TRANSFERASE 1', 252242),
(419854, 'PTHR21015:SF22', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 252242),
(419855, 'PTHR46251:SF1', NULL, NULL, NULL, NULL, 'RUN DOMAIN-CONTAINING PROTEIN 3B', 252243),
(419856, 'PTHR46251:SF4', NULL, NULL, NULL, NULL, 'RUN DOMAIN-CONTAINING PROTEIN 3A', 252243),
(419857, 'PTHR46251:SF3', NULL, NULL, NULL, NULL, 'RUN DOMAIN-CONTAINING PROTEIN', 252243),
(419858, 'PTHR46251', NULL, NULL, NULL, NULL, 'RUN DOMAIN-CONTAINING 3 PROTEIN RUNDC3', 252243),
(419859, 'PTHR46251:SF5', NULL, NULL, NULL, NULL, 'RUN DOMAIN-CONTAINING PROTEIN 3A', 252243),
(419860, 'PTHR35544:SF3', NULL, NULL, NULL, NULL, 'RIBOSOMAL BIOGENESIS FACTOR', 252244),
(419861, 'PTHR35544', NULL, NULL, NULL, NULL, 'RIBOSOMAL BIOGENESIS FACTOR', 252244),
(419862, 'PTHR35544:SF4', NULL, NULL, NULL, NULL, 'RIBOSOMAL BIOGENESIS FACTOR', 252244),
(419863, 'PTHR10704:SF70', NULL, NULL, NULL, NULL, 'LD35051P-RELATED', 252245),
(419864, 'PTHR10704:SF60', NULL, NULL, NULL, NULL, 'CARBOHYDRATE SULFOTRANSFERASE 3', 252245),
(419865, 'PTHR10704', NULL, NULL, NULL, NULL, 'CARBOHYDRATE SULFOTRANSFERASE', 252245),
(419866, 'PTHR10704:SF40', NULL, NULL, NULL, NULL, 'CARBOHYDRATE SULFOTRANSFERASE 4', 252245),
(419867, 'PTHR10704:SF66', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE', 252245),
(419868, 'PTHR10704:SF44', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 252245),
(419869, 'PTHR10704:SF5', NULL, NULL, NULL, NULL, 'CARBOHYDRATE SULFOTRANSFERASE 7', 252245),
(419870, 'PTHR10704:SF13', NULL, NULL, NULL, NULL, 'CARBOHYDRATE SULFOTRANSFERASE 5', 252245),
(419871, 'PTHR10704:SF36', NULL, NULL, NULL, NULL, 'CARBOHYDRATE SULFOTRANSFERASE 1', 252245),
(419872, 'PTHR10704:SF3', NULL, NULL, NULL, NULL, 'CARBOHYDRATE SULFOTRANSFERASE 2', 252245),
(419873, 'PTHR10704:SF69', NULL, NULL, NULL, NULL, 'SULFOTRANSFER_1 DOMAIN-CONTAINING PROTEIN', 252245),
(419874, 'PTHR10704:SF4', NULL, NULL, NULL, NULL, 'CARBOHYDRATE SULFOTRANSFERASE 6', 252245),
(419875, 'PTHR14817', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 15', 252246),
(419876, 'PTHR14817:SF2', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 15', 252246),
(419877, 'PTHR47741', NULL, NULL, NULL, NULL, 'COILED COIL DOMAIN-CONTAINING PROTEIN 8, CCDC8', 252247),
(419878, 'PTHR47741:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 8', 252247),
(419879, 'PTHR28633:SF1', NULL, NULL, NULL, NULL, 'HERMANSKY-PUDLAK SYNDROME 3 PROTEIN', 252248),
(419880, 'PTHR28633', NULL, NULL, NULL, NULL, 'HERMANSKY-PUDLAK SYNDROME 3 PROTEIN', 252248);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(419881, 'PTHR21199:SF1', NULL, NULL, NULL, NULL, 'COMM DOMAIN-CONTAINING PROTEIN 1', 252249),
(419882, 'PTHR21199', NULL, NULL, NULL, NULL, 'COMM DOMAIN-CONTAINING PROTEIN 1', 252249),
(419883, 'PTHR21357:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM172B-RELATED', 252250),
(419884, 'PTHR21357:SF4', NULL, NULL, NULL, NULL, 'FAM172 FAMILY PROTEIN HOMOLOG CG10038', 252250),
(419885, 'PTHR21357', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252250),
(419886, 'PTHR21357:SF3', NULL, NULL, NULL, NULL, 'COTRANSCRIPTIONAL REGULATOR FAM172A', 252250),
(419887, 'PTHR47977:SF70', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABD2A-LIKE', 252251),
(419888, 'PTHR47977:SF71', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABD2A', 252251),
(419889, 'PTHR47977:SF64', NULL, NULL, NULL, NULL, 'RAB30, MEMBER RAS ONCOGENE FAMILY', 252251),
(419890, 'PTHR47977:SF20', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-27A', 252251),
(419891, 'PTHR47977:SF65', NULL, NULL, NULL, NULL, 'CALCIUM RELEASE-ACTIVATED CHANNEL REGULATOR 2AB', 252251),
(419892, 'PTHR47977:SF22', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABD1', 252251),
(419893, 'PTHR47977:SF66', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-6B', 252251),
(419894, 'PTHR47977:SF67', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABC1-LIKE ISOFORM X1', 252251),
(419895, 'PTHR47977:SF24', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RIC1', 252251),
(419896, 'PTHR47977:SF68', NULL, NULL, NULL, NULL, 'BNACNNG56810D PROTEIN', 252251),
(419897, 'PTHR47977:SF69', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABD2A-LIKE', 252251),
(419898, 'PTHR47977:SF26', NULL, NULL, NULL, NULL, 'LD21953P', 252251),
(419899, 'PTHR47977:SF27', NULL, NULL, NULL, NULL, 'BNAA09G46380D PROTEIN', 252251),
(419900, 'PTHR47977:SF60', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-26', 252251),
(419901, 'PTHR47977:SF50', NULL, NULL, NULL, NULL, 'RAB34, MEMBER RAS ONCOGENE FAMILY B', 252251),
(419902, 'PTHR47977:SF52', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABC2A-LIKE ISOFORM X1', 252251),
(419903, 'PTHR47977:SF53', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN', 252251),
(419904, 'PTHR47977:SF54', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-1B', 252251),
(419905, 'PTHR47977:SF10', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-36', 252251),
(419906, 'PTHR47977:SF11', NULL, NULL, NULL, NULL, 'SI:DKEY-16L2.16', 252251),
(419907, 'PTHR47977:SF12', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-26-LIKE PROTEIN', 252251),
(419908, 'PTHR47977:SF13', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-5C', 252251),
(419909, 'PTHR47977:SF58', NULL, NULL, NULL, NULL, 'RAB15, MEMBER RAS ONCOGENE FAMILY', 252251),
(419910, 'PTHR47977:SF15', NULL, NULL, NULL, NULL, 'RAB43, MEMBER RAS ONCOGENE FAMILY', 252251),
(419911, 'PTHR47977:SF16', NULL, NULL, NULL, NULL, 'RAB34, MEMBER RAS ONCOGENE FAMILY', 252251),
(419912, 'PTHR47977:SF18', NULL, NULL, NULL, NULL, 'RABX5', 252251),
(419913, 'PTHR47977', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB', 252251),
(419914, 'PTHR47977:SF83', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN, PUTATIVE-RELATED', 252251),
(419915, 'PTHR47977:SF84', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABD2B-LIKE ISOFORM X1', 252251),
(419916, 'PTHR47977:SF41', NULL, NULL, NULL, NULL, 'BNAC07G34400D PROTEIN', 252251),
(419917, 'PTHR47977:SF85', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-28', 252251),
(419918, 'PTHR47977:SF42', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-30', 252251),
(419919, 'PTHR47977:SF86', NULL, NULL, NULL, NULL, '', 252251),
(419920, 'PTHR47977:SF43', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABD2C', 252251),
(419921, 'PTHR47977:SF87', NULL, NULL, NULL, NULL, 'RAS AND EF-HAND DOMAIN-CONTAINING PROTEIN HOMOLOG', 252251),
(419922, 'PTHR47977:SF44', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB', 252251),
(419923, 'PTHR47977:SF46', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABC1-LIKE', 252251),
(419924, 'PTHR47977:SF47', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABH1B', 252251),
(419925, 'PTHR47977:SF9', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABD2B', 252251);
INSERT INTO "PUBLIC"."MODEL" VALUES
(419926, 'PTHR47977:SF5', NULL, NULL, NULL, NULL, '', 252251),
(419927, 'PTHR47977:SF6', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RABD2A-LIKE', 252251),
(419928, 'PTHR47977:SF80', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-32D', 252251),
(419929, 'PTHR47977:SF81', NULL, NULL, NULL, NULL, 'RAS AND EF-HAND DOMAIN-CONTAINING PROTEIN', 252251),
(419930, 'PTHR47977:SF8', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-34', 252251),
(419931, 'PTHR47977:SF82', NULL, NULL, NULL, NULL, 'SMALL GTPASE SUPERFAMILY-RELATED', 252251),
(419932, 'PTHR47977:SF72', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-44', 252251),
(419933, 'PTHR47977:SF1', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN YPTM2', 252251),
(419934, 'PTHR47977:SF73', NULL, NULL, NULL, NULL, 'RAS AND EF-HAND DOMAIN-CONTAINING PROTEIN', 252251),
(419935, 'PTHR47977:SF74', NULL, NULL, NULL, NULL, '', 252251),
(419936, 'PTHR47977:SF75', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN YPTM2', 252251),
(419937, 'PTHR47977:SF76', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-35', 252251),
(419938, 'PTHR47977:SF33', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB-27B', 252251),
(419939, 'PTHR47977:SF77', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN', 252251),
(419940, 'PTHR47977:SF34', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN YPTM2', 252251),
(419941, 'PTHR47977:SF78', NULL, NULL, NULL, NULL, 'BNAA03G54420D PROTEIN', 252251),
(419942, 'PTHR47977:SF35', NULL, NULL, NULL, NULL, 'RAB GTPASE-LIKE PROTEIN A5D', 252251),
(419943, 'PTHR47977:SF79', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK PROTEIN FAMILY (HSP40) MEMBER C27', 252251),
(419944, 'PTHR47977:SF37', NULL, NULL, NULL, NULL, 'RAB6A, MEMBER RAS ONCOGENE FAMILY', 252251),
(419945, 'PTHR47977:SF39', NULL, NULL, NULL, NULL, '', 252251),
(419946, 'PTHR44943:SF4', NULL, NULL, NULL, NULL, 'TPR REPEAT-CONTAINING PROTEIN MJ1428', 252252),
(419947, 'PTHR44943', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE OPERON PROTEIN C', 252252),
(419948, 'PTHR44943:SF6', NULL, NULL, NULL, NULL, 'TPR REPEAT-CONTAINING PROTEIN MJ0798', 252252),
(419949, 'PTHR44943:SF5', NULL, NULL, NULL, NULL, 'BLL7697 PROTEIN', 252252),
(419950, 'PTHR44943:SF8', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE OPERON PROTEIN C', 252252),
(419951, 'PTHR44943:SF7', NULL, NULL, NULL, NULL, 'TYPE IV PILUS ASSEMBLY PROTEIN PILF', 252252),
(419952, 'PTHR44943:SF9', NULL, NULL, NULL, NULL, 'TPR-REPEAT-CONTAINING PROTEIN', 252252),
(419953, 'PTHR47086', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 252253),
(419954, 'PTHR47086:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER SWIM-TYPE-CONTAINING 9', 252253),
(419955, 'PTHR47086:SF5', NULL, NULL, NULL, NULL, 'SWIM-TYPE DOMAIN-CONTAINING PROTEIN', 252253),
(419956, 'PTHR47086:SF4', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 252253),
(419957, 'PTHR31956:SF8', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE PHOA (AFU_ORTHOLOGUE AFUA_1G03570)', 252254),
(419958, 'PTHR31956:SF25', NULL, NULL, NULL, NULL, 'SPECIFIC PHOSPHOLIPASE C, PUTATIVE-RELATED', 252254),
(419959, 'PTHR31956:SF36', NULL, NULL, NULL, NULL, 'NON-HEMOLYTIC PHOSPHOLIPASE C', 252254),
(419960, 'PTHR31956:SF15', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE PHOA', 252254),
(419961, 'PTHR31956:SF26', NULL, NULL, NULL, NULL, 'NON-SPECIFIC PHOSPHOLIPASE C2', 252254),
(419962, 'PTHR31956:SF37', NULL, NULL, NULL, NULL, '', 252254),
(419963, 'PTHR31956:SF2', NULL, NULL, NULL, NULL, 'NON-SPECIFIC PHOSPHOLIPASE C6', 252254),
(419964, 'PTHR31956:SF34', NULL, NULL, NULL, NULL, 'BNAA06G16410D PROTEIN', 252254),
(419965, 'PTHR31956:SF23', NULL, NULL, NULL, NULL, 'PHOSPHATASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G03660)-RELATED', 252254),
(419966, 'PTHR31956:SF1', NULL, NULL, NULL, NULL, 'NON-SPECIFIC PHOSPHOLIPASE C1', 252254),
(419967, 'PTHR31956:SF24', NULL, NULL, NULL, NULL, 'PHOSPHOESTERASE SUPERFAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_1G17590)', 252254),
(419968, 'PTHR31956:SF27', NULL, NULL, NULL, NULL, 'PHOSPHOESTERASE-RELATED', 252254),
(419969, 'PTHR31956:SF28', NULL, NULL, NULL, NULL, 'NON-SPECIFIC PHOSPHOLIPASE C4-RELATED', 252254);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(419970, 'PTHR31956:SF32', NULL, NULL, NULL, NULL, 'NON-SPECIFIC PHOSPHOLIPASE C3', 252254),
(419971, 'PTHR31956:SF33', NULL, NULL, NULL, NULL, 'OS03G0300100 PROTEIN', 252254),
(419972, 'PTHR31956:SF30', NULL, NULL, NULL, NULL, 'OS11G0593000 PROTEIN', 252254),
(419973, 'PTHR31956', NULL, NULL, NULL, NULL, 'NON-SPECIFIC PHOSPHOLIPASE C4-RELATED', 252254),
(419974, 'PTHR48041:SF109', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 20', 252255),
(419975, 'PTHR48041:SF104', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 252255),
(419976, 'PTHR48041:SF88', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 252255),
(419977, 'PTHR48041:SF89', NULL, NULL, NULL, NULL, 'FI03229P', 252255),
(419978, 'PTHR48041:SF102', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE-RELATED', 252255),
(419979, 'PTHR48041:SF86', NULL, NULL, NULL, NULL, 'TRANSPORTER FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 252255),
(419980, 'PTHR48041:SF87', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 12-RELATED', 252255),
(419981, 'PTHR48041:SF108', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 6-LIKE', 252255),
(419982, 'PTHR48041:SF107', NULL, NULL, NULL, NULL, 'WHITE-BROWN COMPLEX HOMOLOG PROTEIN 30-RELATED', 252255),
(419983, 'PTHR48041:SF106', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 252255),
(419984, 'PTHR48041:SF105', NULL, NULL, NULL, NULL, 'FI02074P', 252255),
(419985, 'PTHR48041:SF81', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 22', 252255),
(419986, 'PTHR48041:SF84', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 252255),
(419987, 'PTHR48041:SF111', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 14', 252255),
(419988, 'PTHR48041:SF110', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 252255),
(419989, 'PTHR48041:SF82', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY G MEMBER 2', 252255),
(419990, 'PTHR48041:SF83', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 6', 252255),
(419991, 'PTHR48041:SF18', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 9-LIKE', 252255),
(419992, 'PTHR48041:SF11', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 16', 252255),
(419993, 'PTHR48041:SF12', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 1', 252255),
(419994, 'PTHR48041:SF98', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (EUROFUNG)-RELATED', 252255),
(419995, 'PTHR48041:SF15', NULL, NULL, NULL, NULL, 'FI05267P', 252255),
(419996, 'PTHR48041:SF14', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 25', 252255),
(419997, 'PTHR48041:SF91', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, EXTENDED', 252255),
(419998, 'PTHR48041:SF92', NULL, NULL, NULL, NULL, 'BROAD SUBSTRATE SPECIFICITY ATP-BINDING CASSETTE TRANSPORTER ABCG2', 252255),
(419999, 'PTHR48041:SF90', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY G MEMBER 1', 252255),
(420000, 'PTHR48041:SF100', NULL, NULL, NULL, NULL, 'OS01G0615500 PROTEIN', 252255),
(420001, 'PTHR48041:SF96', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 7', 252255),
(420002, 'PTHR48041:SF93', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN/PERMEASE WHT-1', 252255),
(420003, 'PTHR48041:SF94', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 22', 252255),
(420004, 'PTHR48041:SF66', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 252255),
(420005, 'PTHR48041:SF65', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 4', 252255),
(420006, 'PTHR48041:SF68', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 252255),
(420007, 'PTHR48041:SF69', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 17-RELATED', 252255),
(420008, 'PTHR48041:SF2', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT PERMEASE-RELATED', 252255),
(420009, 'PTHR48041:SF63', NULL, NULL, NULL, NULL, 'EARLY GENE AT 23, ISOFORM C', 252255),
(420010, 'PTHR48041:SF9', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 4', 252255),
(420011, 'PTHR48041:SF6', NULL, NULL, NULL, NULL, 'PROTEIN WHITE-LIKE PROTEIN', 252255);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(420012, 'PTHR48041:SF61', NULL, NULL, NULL, NULL, 'SD03967P', 252255),
(420013, 'PTHR48041:SF77', NULL, NULL, NULL, NULL, 'OS04G0194500 PROTEIN', 252255),
(420014, 'PTHR48041:SF78', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER EXPRESSED IN TRACHEA, ISOFORM A', 252255),
(420015, 'PTHR48041:SF75', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY G MEMBER 4', 252255),
(420016, 'PTHR48041:SF76', NULL, NULL, NULL, NULL, 'ABC-2 TYPE TRANSPORTER FAMILY PROTEIN-RELATED', 252255),
(420017, 'PTHR48041:SF1', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 24', 252255),
(420018, 'PTHR48041:SF79', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 5', 252255),
(420019, 'PTHR48041:SF70', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY G MEMBER 3', 252255),
(420020, 'PTHR48041:SF73', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER STR', 252255),
(420021, 'PTHR48041:SF71', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY G MEMBER 8', 252255),
(420022, 'PTHR48041:SF72', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 252255),
(420023, 'PTHR48041:SF45', NULL, NULL, NULL, NULL, 'WHITE-BROWN COMPLEX HOMOLOG PROTEIN 30-RELATED', 252255),
(420024, 'PTHR48041:SF42', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 27', 252255),
(420025, 'PTHR48041:SF49', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE, SUB-FAMILY G (WHITE), MEMBER 2B-RELATED', 252255),
(420026, 'PTHR48041:SF40', NULL, NULL, NULL, NULL, 'OS05G0120200 PROTEIN', 252255),
(420027, 'PTHR48041:SF41', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY', 252255),
(420028, 'PTHR48041:SF137', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 252255),
(420029, 'PTHR48041:SF55', NULL, NULL, NULL, NULL, 'OS01G0836600 PROTEIN', 252255),
(420030, 'PTHR48041:SF136', NULL, NULL, NULL, NULL, 'POLAR-AMINO-ACID-TRANSPORTING ATPASE-RELATED', 252255),
(420031, 'PTHR48041:SF56', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 25', 252255),
(420032, 'PTHR48041:SF135', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 26', 252255),
(420033, 'PTHR48041:SF53', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 10', 252255),
(420034, 'PTHR48041:SF134', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY', 252255),
(420035, 'PTHR48041:SF139', NULL, NULL, NULL, NULL, 'PROTEIN SCARLET', 252255),
(420036, 'PTHR48041:SF58', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 252255),
(420037, 'PTHR48041:SF138', NULL, NULL, NULL, NULL, 'XENOBIOTIC-TRANSPORTING ATPASE-RELATED', 252255),
(420038, 'PTHR48041:SF140', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 252255),
(420039, 'PTHR48041', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 28', 252255),
(420040, 'PTHR48041:SF51', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 23', 252255),
(420041, 'PTHR48041:SF50', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 252255),
(420042, 'PTHR48041:SF28', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 1', 252255),
(420043, 'PTHR48041:SF29', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 24', 252255),
(420044, 'PTHR48041:SF22', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 9', 252255),
(420045, 'PTHR48041:SF126', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 20-LIKE', 252255),
(420046, 'PTHR48041:SF125', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY', 252255),
(420047, 'PTHR48041:SF20', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER STR2', 252255),
(420048, 'PTHR48041:SF124', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 28-LIKE', 252255),
(420049, 'PTHR48041:SF21', NULL, NULL, NULL, NULL, 'PIGMENT PERMEASE, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 252255),
(420050, 'PTHR48041:SF123', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 14-LIKE', 252255),
(420051, 'PTHR48041:SF26', NULL, NULL, NULL, NULL, 'FI22810P1', 252255),
(420052, 'PTHR48041:SF129', NULL, NULL, NULL, NULL, 'PROTEIN WHITE', 252255),
(420053, 'PTHR48041:SF27', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 8', 252255);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(420054, 'PTHR48041:SF24', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 21', 252255),
(420055, 'PTHR48041:SF128', NULL, NULL, NULL, NULL, 'OS03G0282100 PROTEIN', 252255),
(420056, 'PTHR48041:SF127', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE-RELATED', 252255),
(420057, 'PTHR48041:SF25', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 252255),
(420058, 'PTHR48041:SF133', NULL, NULL, NULL, NULL, 'GH24286P', 252255),
(420059, 'PTHR48041:SF132', NULL, NULL, NULL, NULL, 'PIGMENT PERMEASE, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 252255),
(420060, 'PTHR48041:SF131', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 252255),
(420061, 'PTHR48041:SF130', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 252255),
(420062, 'PTHR48041:SF39', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 252255),
(420063, 'PTHR48041:SF115', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 2', 252255),
(420064, 'PTHR48041:SF31', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN/PERMEASE WHT-3', 252255),
(420065, 'PTHR48041:SF113', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY G MEMBER 5', 252255),
(420066, 'PTHR48041:SF32', NULL, NULL, NULL, NULL, 'PROTEIN WHITE-LIKE PROTEIN', 252255),
(420067, 'PTHR48041:SF37', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 19', 252255),
(420068, 'PTHR48041:SF119', NULL, NULL, NULL, NULL, 'ROA1P', 252255),
(420069, 'PTHR48041:SF118', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE TRANSPORTER (ABC TRANSPORTER) FAMILY G MEMBER 16', 252255),
(420070, 'PTHR48041:SF38', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, G1, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 252255),
(420071, 'PTHR48041:SF117', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 10-LIKE', 252255),
(420072, 'PTHR48041:SF35', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 252255),
(420073, 'PTHR48041:SF116', NULL, NULL, NULL, NULL, 'PROTEIN BROWN', 252255),
(420074, 'PTHR48041:SF122', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 252255),
(420075, 'PTHR48041:SF121', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE, SUB-FAMILY G (WHITE), MEMBER 2A', 252255),
(420076, 'PTHR48240:SF2', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 252256),
(420077, 'PTHR48240', NULL, NULL, NULL, NULL, 'GRF-TYPE DOMAIN-CONTAINING PROTEIN', 252256),
(420078, 'PTHR30037', NULL, NULL, NULL, NULL, 'DNA-3-METHYLADENINE GLYCOSYLASE 1', 252257),
(420079, 'PTHR30037:SF4', NULL, NULL, NULL, NULL, 'DNA-3-METHYLADENINE GLYCOSYLASE I', 252257),
(420080, 'PTHR30037:SF3', NULL, NULL, NULL, NULL, 'BLR0857 PROTEIN', 252257),
(420081, 'PTHR34468:SF2', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED FUTSCH-LIKE PROTEIN', 252258),
(420082, 'PTHR34468:SF3', NULL, NULL, NULL, NULL, 'MEDIATOR OF DNA DAMAGE CHECKPOINT PROTEIN 1-LIKE', 252258),
(420083, 'PTHR34468', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED FUTSCH-LIKE PROTEIN', 252258),
(420084, 'PTHR34468:SF6', NULL, NULL, NULL, NULL, '', 252258),
(420085, 'PTHR36872', NULL, NULL, NULL, NULL, 'GENE 5901-RELATED', 252259),
(420086, 'PTHR36872:SF1', NULL, NULL, NULL, NULL, 'GENE 5901-RELATED', 252259),
(420087, 'PTHR34001', NULL, NULL, NULL, NULL, 'BLL7405 PROTEIN', 252260),
(420088, 'PTHR34001:SF3', NULL, NULL, NULL, NULL, 'BLL7405 PROTEIN', 252260),
(420089, 'PTHR11909:SF75', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420090, 'PTHR11909:SF73', NULL, NULL, NULL, NULL, 'OS01G0744300 PROTEIN', 252261),
(420091, 'PTHR11909:SF72', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SPE-6', 252261),
(420092, 'PTHR11909:SF100', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE VRK2', 252261),
(420093, 'PTHR11909:SF463', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420094, 'PTHR11909:SF344', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420095, 'PTHR11909:SF465', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252261);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(420096, 'PTHR11909:SF466', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420097, 'PTHR11909:SF467', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252261),
(420098, 'PTHR11909:SF500', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420099, 'PTHR11909:SF105', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420100, 'PTHR11909:SF78', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE VRK1', 252261),
(420101, 'PTHR11909:SF468', NULL, NULL, NULL, NULL, 'CASEIN KINASE I', 252261),
(420102, 'PTHR11909:SF77', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420103, 'PTHR11909:SF469', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN-RELATED', 252261),
(420104, 'PTHR11909:SF349', NULL, NULL, NULL, NULL, 'CASEIN KINASE-LIKE PROTEIN', 252261),
(420105, 'PTHR11909:SF191', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420106, 'PTHR11909:SF85', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420107, 'PTHR11909:SF193', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420108, 'PTHR11909:SF84', NULL, NULL, NULL, NULL, 'CASEIN KINASE I ISOFORM ALPHA', 252261),
(420109, 'PTHR11909:SF470', NULL, NULL, NULL, NULL, 'CASEIN KINASE I-LIKE PROTEIN', 252261),
(420110, 'PTHR11909:SF81', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420111, 'PTHR11909:SF471', NULL, NULL, NULL, NULL, 'CASEIN KINASE I HOMOLOG 2', 252261),
(420112, 'PTHR11909:SF196', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420113, 'PTHR11909:SF472', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420114, 'PTHR11909:SF351', NULL, NULL, NULL, NULL, 'CASEIN KINASE I-LIKE', 252261),
(420115, 'PTHR11909:SF80', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420116, 'PTHR11909:SF473', NULL, NULL, NULL, NULL, 'PROTEIN KINASE FAMILY PROTEIN', 252261),
(420117, 'PTHR11909:SF110', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420118, 'PTHR11909:SF352', NULL, NULL, NULL, NULL, 'OS05G0593800 PROTEIN', 252261),
(420119, 'PTHR11909:SF353', NULL, NULL, NULL, NULL, 'PROTEIN KINASE FAMILY PROTEIN', 252261),
(420120, 'PTHR11909:SF474', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420121, 'PTHR11909', NULL, NULL, NULL, NULL, 'CASEIN KINASE-RELATED', 252261),
(420122, 'PTHR11909:SF475', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420123, 'PTHR11909:SF476', NULL, NULL, NULL, NULL, 'CASEIN KINASE I HOMOLOG 3', 252261),
(420124, 'PTHR11909:SF355', NULL, NULL, NULL, NULL, 'CASEIN KINASE 1-LIKE PROTEIN 13', 252261),
(420125, 'PTHR11909:SF477', NULL, NULL, NULL, NULL, 'SERINE/THREONINE/DUAL SPECIFICITY PROTEIN KINASE, CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 252261),
(420126, 'PTHR11909:SF356', NULL, NULL, NULL, NULL, 'CASEIN KINASE 1-LIKE PROTEIN 5-RELATED', 252261),
(420127, 'PTHR11909:SF478', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420128, 'PTHR11909:SF115', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420129, 'PTHR11909:SF479', NULL, NULL, NULL, NULL, 'CASEIN KINASE 1-LIKE PROTEIN 7', 252261),
(420130, 'PTHR11909:SF358', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420131, 'PTHR11909:SF88', NULL, NULL, NULL, NULL, 'PROTEIN CBG20999', 252261),
(420132, 'PTHR11909:SF108', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420133, 'PTHR11909:SF190', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420134, 'PTHR11909:SF97', NULL, NULL, NULL, NULL, 'CASEIN KINASE 1-LIKE PROTEIN 3-RELATED', 252261),
(420135, 'PTHR11909:SF96', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420136, 'PTHR11909:SF160', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(420137, 'PTHR11909:SF94', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420138, 'PTHR11909:SF90', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420139, 'PTHR11909:SF166', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420140, 'PTHR11909:SF441', NULL, NULL, NULL, NULL, 'CASEIN KINASE I HOMOLOG 1-RELATED', 252261),
(420141, 'PTHR11909:SF442', NULL, NULL, NULL, NULL, 'PROTEIN CASEIN KINASE I-LIKE 3-LIKE', 252261),
(420142, 'PTHR11909:SF15', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420143, 'PTHR11909:SF443', NULL, NULL, NULL, NULL, 'CASEIN KINASE I-LIKE PROTEIN', 252261),
(420144, 'PTHR11909:SF323', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420145, 'PTHR11909:SF445', NULL, NULL, NULL, NULL, 'OS05G0200500 PROTEIN', 252261),
(420146, 'PTHR11909:SF446', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252261),
(420147, 'PTHR11909:SF326', NULL, NULL, NULL, NULL, 'CASEIN KINASE 1-LIKE PROTEIN 9', 252261),
(420148, 'PTHR11909:SF99', NULL, NULL, NULL, NULL, 'INACTIVE SERINE/THREONINE-PROTEIN KINASE VRK3', 252261),
(420149, 'PTHR11909:SF98', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420150, 'PTHR11909:SF448', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252261),
(420151, 'PTHR11909:SF317', NULL, NULL, NULL, NULL, 'CASEIN KINASE I-LIKE', 252261),
(420152, 'PTHR11909:SF438', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420153, 'PTHR11909:SF318', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420154, 'PTHR11909:SF20', NULL, NULL, NULL, NULL, 'CASEIN KINASE I ISOFORM ALPHA', 252261),
(420155, 'PTHR11909:SF291', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420156, 'PTHR11909:SF297', NULL, NULL, NULL, NULL, 'TAU-TUBULIN KINASE 1', 252261),
(420157, 'PTHR11909:SF451', NULL, NULL, NULL, NULL, 'TAU-TUBULIN KINASE 2', 252261),
(420158, 'PTHR11909:SF176', NULL, NULL, NULL, NULL, 'KINASE I, EPSILON ISOFORM, PUTATIVE, EXPRESSED-RELATED', 252261),
(420159, 'PTHR11909:SF452', NULL, NULL, NULL, NULL, 'CASEIN KINASE 1-LIKE PROTEIN 1', 252261),
(420160, 'PTHR11909:SF456', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 252261),
(420161, 'PTHR11909:SF457', NULL, NULL, NULL, NULL, 'CASEIN KINASE 1-LIKE PROTEIN 6', 252261),
(420162, 'PTHR11909:SF458', NULL, NULL, NULL, NULL, 'CASEIN KINASE I-LIKE PROTEIN', 252261),
(420163, 'PTHR11909:SF449', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252261),
(420164, 'PTHR11909:SF329', NULL, NULL, NULL, NULL, 'OS01G0772600 PROTEIN', 252261),
(420165, 'PTHR11909:SF18', NULL, NULL, NULL, NULL, 'CASEIN KINASE I ISOFORM DELTA', 252261),
(420166, 'PTHR11909:SF381', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420167, 'PTHR11909:SF386', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420168, 'PTHR11909:SF145', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420169, 'PTHR11909:SF388', NULL, NULL, NULL, NULL, 'CASEIN KINASE 1-LIKE PROTEIN 8', 252261),
(420170, 'PTHR11909:SF300', NULL, NULL, NULL, NULL, 'TAU-TUBULIN KINASE HOMOLOG ASATOR', 252261),
(420171, 'PTHR11909:SF422', NULL, NULL, NULL, NULL, 'BCDNA.LD23371-RELATED', 252261),
(420172, 'PTHR11909:SF302', NULL, NULL, NULL, NULL, 'OS04G0514800 PROTEIN', 252261),
(420173, 'PTHR11909:SF148', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420174, 'PTHR11909:SF423', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252261),
(420175, 'PTHR11909:SF304', NULL, NULL, NULL, NULL, 'INACTIVE TAU-TUBULIN KINASE TTBK-6-RELATED', 252261),
(420176, 'PTHR11909:SF305', NULL, NULL, NULL, NULL, 'PROTEIN CBG08225', 252261),
(420177, 'PTHR11909:SF417', NULL, NULL, NULL, NULL, 'CASEIN KINASE 1-LIKE PROTEIN 11', 252261),
(420178, 'PTHR11909:SF419', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(420179, 'PTHR11909:SF390', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420180, 'PTHR11909:SF391', NULL, NULL, NULL, NULL, 'CASEIN KINASE-LIKE PROTEIN', 252261),
(420181, 'PTHR11909:SF150', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE ZK507.1-RELATED', 252261),
(420182, 'PTHR11909:SF151', NULL, NULL, NULL, NULL, 'CASEIN KINASE I ISOFORM GAMMA-3', 252261),
(420183, 'PTHR11909:SF152', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420184, 'PTHR11909:SF395', NULL, NULL, NULL, NULL, 'OS01G0198200 PROTEIN', 252261),
(420185, 'PTHR11909:SF155', NULL, NULL, NULL, NULL, 'GILGAMESH, ISOFORM L', 252261),
(420186, 'PTHR11909:SF430', NULL, NULL, NULL, NULL, 'PIRNA BIOGENESIS FACTOR PRDE-1', 252261),
(420187, 'PTHR11909:SF397', NULL, NULL, NULL, NULL, 'OS07G0171300 PROTEIN', 252261),
(420188, 'PTHR11909:SF156', NULL, NULL, NULL, NULL, 'CASEIN KINASE I ISOFORM GAMMA-1', 252261),
(420189, 'PTHR11909:SF399', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420190, 'PTHR11909:SF157', NULL, NULL, NULL, NULL, 'CASEIN KINASE I ISOFORM GAMMA-2', 252261),
(420191, 'PTHR11909:SF435', NULL, NULL, NULL, NULL, 'CASEIN KINASE I-LIKE', 252261),
(420192, 'PTHR11909:SF436', NULL, NULL, NULL, NULL, 'OS01G0231500 PROTEIN', 252261),
(420193, 'PTHR11909:SF44', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420194, 'PTHR11909:SF437', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420195, 'PTHR11909:SF428', NULL, NULL, NULL, NULL, 'CASEIN KINASE I ISOFORM EPSILON', 252261),
(420196, 'PTHR11909:SF480', NULL, NULL, NULL, NULL, 'CASEIN KINASE I-LIKE', 252261),
(420197, 'PTHR11909:SF481', NULL, NULL, NULL, NULL, 'CASEIN KINASE I HOMOLOG HHP2', 252261),
(420198, 'PTHR11909:SF482', NULL, NULL, NULL, NULL, 'CASEIN KINASE I-LIKE', 252261),
(420199, 'PTHR11909:SF483', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420200, 'PTHR11909:SF121', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420201, 'PTHR11909:SF363', NULL, NULL, NULL, NULL, 'CASEIN KINASE I-LIKE', 252261),
(420202, 'PTHR11909:SF484', NULL, NULL, NULL, NULL, 'CASEIN KINASE 1-LIKE PROTEIN 2', 252261),
(420203, 'PTHR11909:SF485', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420204, 'PTHR11909:SF365', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420205, 'PTHR11909:SF486', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420206, 'PTHR11909:SF123', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420207, 'PTHR11909:SF124', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420208, 'PTHR11909:SF366', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420209, 'PTHR11909:SF487', NULL, NULL, NULL, NULL, 'OS02G0810400 PROTEIN', 252261),
(420210, 'PTHR11909:SF488', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420211, 'PTHR11909:SF126', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420212, 'PTHR11909:SF489', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420213, 'PTHR11909:SF402', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420214, 'PTHR11909:SF403', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420215, 'PTHR11909:SF404', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420216, 'PTHR11909:SF129', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420217, 'PTHR11909:SF119', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420218, 'PTHR11909:SF490', NULL, NULL, NULL, NULL, 'CASEIN KINASE I-LIKE PROTEIN', 252261),
(420219, 'PTHR11909:SF370', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420220, 'PTHR11909:SF491', NULL, NULL, NULL, NULL, 'CASEIN KINASE I-LIKE', 252261);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(420221, 'PTHR11909:SF492', NULL, NULL, NULL, NULL, 'CK1 FAMILY PROTEIN KINASE', 252261),
(420222, 'PTHR11909:SF371', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420223, 'PTHR11909:SF372', NULL, NULL, NULL, NULL, 'CASEIN KINASE 1-LIKE PROTEIN 12', 252261),
(420224, 'PTHR11909:SF493', NULL, NULL, NULL, NULL, 'CASEIN KINASE 1-LIKE PROTEIN 10', 252261),
(420225, 'PTHR11909:SF494', NULL, NULL, NULL, NULL, 'CASEIN KINASE 1', 252261),
(420226, 'PTHR11909:SF495', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420227, 'PTHR11909:SF496', NULL, NULL, NULL, NULL, 'CASEIN KINASE', 252261),
(420228, 'PTHR11909:SF375', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN-RELATED', 252261),
(420229, 'PTHR11909:SF497', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420230, 'PTHR11909:SF135', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420231, 'PTHR11909:SF498', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420232, 'PTHR11909:SF499', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420233, 'PTHR11909:SF379', NULL, NULL, NULL, NULL, 'TAU TUBULIN KINASE 2B', 252261),
(420234, 'PTHR11909:SF137', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420235, 'PTHR11909:SF7', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE 7-RELATED PROTEIN KINASE', 252261),
(420236, 'PTHR11909:SF139', NULL, NULL, NULL, NULL, 'CASEIN KINASE I ISOFORM ALPHA-LIKE', 252261),
(420237, 'PTHR11909:SF405', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420238, 'PTHR11909:SF406', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 252261),
(420239, 'PTHR11909:SF407', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252261),
(420240, 'PTHR35249:SF2', NULL, NULL, NULL, NULL, 'DYNEIN REGULATORY COMPLEX SUBUNIT 7', 252262),
(420241, 'PTHR35249', NULL, NULL, NULL, NULL, 'DYNEIN REGULATORY COMPLEX SUBUNIT 7', 252262),
(420242, 'PTHR36456:SF1', NULL, NULL, NULL, NULL, 'UPF0232 PROTEIN SCO3875', 252263),
(420243, 'PTHR36456', NULL, NULL, NULL, NULL, 'UPF0232 PROTEIN SCO3875', 252263),
(420244, 'PTHR32085:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CSF1', 252264),
(420245, 'PTHR32085', NULL, NULL, NULL, NULL, 'PROTEIN CSF1', 252264),
(420246, 'PTHR40460', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 252265),
(420247, 'PTHR40460:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 252265),
(420248, 'PTHR34716', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 252266),
(420249, 'PTHR34716:SF1', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 252266),
(420250, 'PTHR21082', NULL, NULL, NULL, NULL, 'PROTEIN INTURNED', 252267),
(420251, 'PTHR21082:SF4', NULL, NULL, NULL, NULL, 'PROTEIN INTURNED', 252267),
(420252, 'PTHR34558', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252268),
(420253, 'PTHR34558:SF16', NULL, NULL, NULL, NULL, '', 252268),
(420254, 'PTHR34558:SF17', NULL, NULL, NULL, NULL, 'OS07G0549100 PROTEIN', 252268),
(420255, 'PTHR34558:SF12', NULL, NULL, NULL, NULL, '', 252268),
(420256, 'PTHR34558:SF11', NULL, NULL, NULL, NULL, '', 252268),
(420257, 'PTHR34558:SF9', NULL, NULL, NULL, NULL, 'F3L24.15 PROTEIN', 252268),
(420258, 'PTHR34558:SF4', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252268),
(420259, 'PTHR36054', NULL, NULL, NULL, NULL, 'PROTEIN SICKLE', 252269),
(420260, 'PTHR36054:SF2', NULL, NULL, NULL, NULL, 'PROTEIN SICKLE', 252269),
(420261, 'PTHR36054:SF5', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 252269),
(420262, 'PTHR36054:SF4', NULL, NULL, NULL, NULL, 'BNAA03G46750D PROTEIN', 252269),
(420263, 'PTHR19850:SF38', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN, BETA SUBUNIT-RELATED', 252270),
(420264, 'PTHR19850:SF27', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN G(I)/G(S)/G(T) SUBUNIT BETA-2', 252270),
(420265, 'PTHR19850:SF37', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT BETA-5B', 252270);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(420266, 'PTHR19850:SF29', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN G(I)/G(S)/G(T) SUBUNIT BETA-1', 252270),
(420267, 'PTHR19850:SF28', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT BETA-4', 252270),
(420268, 'PTHR19850:SF39', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 252270),
(420269, 'PTHR19850:SF25', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT BETA-1', 252270),
(420270, 'PTHR19850:SF36', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT BETA-5', 252270),
(420271, 'PTHR19850:SF35', NULL, NULL, NULL, NULL, 'GNB3 PROTEIN', 252270),
(420272, 'PTHR19850:SF40', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT BETA-5A', 252270),
(420273, 'PTHR19850:SF43', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT BETA-2', 252270),
(420274, 'PTHR19850:SF31', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN G(I)/G(S)/G(T) SUBUNIT BETA-3', 252270),
(420275, 'PTHR19850', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN BETA  G PROTEIN BETA', 252270),
(420276, 'PTHR33525', NULL, NULL, NULL, NULL, '', 252271),
(420277, 'PTHR33525:SF4', NULL, NULL, NULL, NULL, 'CYCLIC DI-GMP PHOSPHODIESTERASE CDGJ', 252271),
(420278, 'PTHR33525:SF3', NULL, NULL, NULL, NULL, 'RIBONUCLEASE Y', 252271),
(420279, 'PTHR33525:SF6', NULL, NULL, NULL, NULL, 'HDOD DOMAIN PROTEIN', 252271),
(420280, 'PTHR33525:SF5', NULL, NULL, NULL, NULL, 'TWO COMPONENT SIGNAL TRANSDUCTION SYSTEM RESPONSE REGULATOR', 252271),
(420281, 'PTHR14485:SF2', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 252272),
(420282, 'PTHR14485:SF4', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 23-LIKE', 252272),
(420283, 'PTHR14485:SF3', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 23', 252272),
(420284, 'PTHR14485', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 23', 252272),
(420285, 'PTHR14398:SF4', NULL, NULL, NULL, NULL, 'BNAA02G29020D PROTEIN', 252273),
(420286, 'PTHR14398:SF7', NULL, NULL, NULL, NULL, 'RRM/RNP DOMAIN', 252273),
(420287, 'PTHR14398:SF6', NULL, NULL, NULL, NULL, 'ZINC FINGER, CCCH-TYPE, NUCLEOTIDE-BINDING ALPHA-BETA PLAIT DOMAIN PROTEIN-RELATED', 252273),
(420288, 'PTHR14398:SF1', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 27', 252273),
(420289, 'PTHR14398:SF0', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN SWM', 252273),
(420290, 'PTHR14398:SF2', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 26', 252273),
(420291, 'PTHR14398', NULL, NULL, NULL, NULL, 'RNA RECOGNITION RRM/RNP DOMAIN', 252273),
(420292, 'PTHR12943:SF7', NULL, NULL, NULL, NULL, 'HOMOCYSTEINE-RESPONSIVE ENDOPLASMIC RETICULUM-RESIDENT UBIQUITIN-LIKE DOMAIN MEMBER 1 PROTEIN', 252274),
(420293, 'PTHR12943:SF5', NULL, NULL, NULL, NULL, 'HOMOCYSTEINE-RESPONSIVE ENDOPLASMIC RETICULUM-RESIDENT UBIQUITIN-LIKE DOMAIN MEMBER 2 PROTEIN', 252274),
(420294, 'PTHR12943', NULL, NULL, NULL, NULL, 'HOMOCYSTEINE-RESPONSIVE ENDOPLASMIC RETICULUM-RESIDENT UNIQUITIN-LIKE DOMAIN HERPUD PROTEIN FAMILY MEMBER', 252274),
(420295, 'PTHR12943:SF27', NULL, NULL, NULL, NULL, 'HOMOCYSTEINE-INDUCED ENDOPLASMIC RETICULUM PROTEIN, ISOFORM A', 252274),
(420296, 'PTHR12943:SF38', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 252274),
(420297, 'PTHR12941:SF14', NULL, NULL, NULL, NULL, 'ER MEMBRANE PROTEIN COMPLEX SUBUNIT 8/9 HOMOLOG', 252275),
(420298, 'PTHR12941:SF13', NULL, NULL, NULL, NULL, 'ER MEMBRANE PROTEIN COMPLEX SUBUNIT 8', 252275),
(420299, 'PTHR12941:SF15', NULL, NULL, NULL, NULL, 'MPN DOMAIN-CONTAINING PROTEIN', 252275),
(420300, 'PTHR12941:SF10', NULL, NULL, NULL, NULL, 'ER MEMBRANE PROTEIN COMPLEX SUBUNIT 8/9 HOMOLOG', 252275),
(420301, 'PTHR12941:SF12', NULL, NULL, NULL, NULL, 'ER MEMBRANE PROTEIN COMPLEX SUBUNIT 9', 252275),
(420302, 'PTHR12941', NULL, NULL, NULL, NULL, 'ER MEMBRANE PROTEIN COMPLEX', 252275),
(420303, 'PTHR34824', NULL, NULL, NULL, NULL, 'HEAT-INDUCIBLE TRANSCRIPTION REPRESSOR HRCA', 252276),
(420304, 'PTHR34824:SF1', NULL, NULL, NULL, NULL, 'HEAT-INDUCIBLE TRANSCRIPTION REPRESSOR HRCA', 252276);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(420305, 'PTHR33333:SF30', NULL, NULL, NULL, NULL, '', 252277),
(420306, 'PTHR33333:SF41', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252277),
(420307, 'PTHR33333:SF40', NULL, NULL, NULL, NULL, 'BNACNNG46650D PROTEIN', 252277),
(420308, 'PTHR33333:SF32', NULL, NULL, NULL, NULL, 'SINGLE-STRANDED DNA-BINDING PROTEIN-LIKE', 252277),
(420309, 'PTHR33333:SF21', NULL, NULL, NULL, NULL, '', 252277),
(420310, 'PTHR33333:SF43', NULL, NULL, NULL, NULL, '', 252277),
(420311, 'PTHR33333:SF42', NULL, NULL, NULL, NULL, 'KERATIN KB40', 252277),
(420312, 'PTHR33333:SF2', NULL, NULL, NULL, NULL, 'OS01G0341000 PROTEIN', 252277),
(420313, 'PTHR33333:SF23', NULL, NULL, NULL, NULL, '', 252277),
(420314, 'PTHR33333:SF34', NULL, NULL, NULL, NULL, 'PSAD1', 252277),
(420315, 'PTHR33333:SF22', NULL, NULL, NULL, NULL, 'EGG APPARATUS-1 PROTEIN', 252277),
(420316, 'PTHR33333:SF36', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN', 252277),
(420317, 'PTHR33333:SF38', NULL, NULL, NULL, NULL, 'OS06G0706700 PROTEIN', 252277),
(420318, 'PTHR33333:SF37', NULL, NULL, NULL, NULL, 'PROTEIN EGG APPARATUS-1', 252277),
(420319, 'PTHR33333:SF18', NULL, NULL, NULL, NULL, '', 252277),
(420320, 'PTHR33333:SF4', NULL, NULL, NULL, NULL, '', 252277),
(420321, 'PTHR33333:SF39', NULL, NULL, NULL, NULL, 'BNAC04G31950D PROTEIN', 252277),
(420322, 'PTHR33333:SF17', NULL, NULL, NULL, NULL, 'BNAC03G22350D PROTEIN', 252277),
(420323, 'PTHR33333:SF8', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252277),
(420324, 'PTHR33333', NULL, NULL, NULL, NULL, 'ERYTHROCYTE MEMBRANE PROTEIN 1-LIKE', 252277),
(420325, 'PTHR13440:SF7', NULL, NULL, NULL, NULL, 'SI:DKEY-72L14.4', 252278),
(420326, 'PTHR13440:SF8', NULL, NULL, NULL, NULL, 'BLOC-1-RELATED COMPLEX SUBUNIT 6', 252278),
(420327, 'PTHR13440:SF9', NULL, NULL, NULL, NULL, 'BLOC-1 RELATED COMPLEX SUBUNIT 6', 252278),
(420328, 'PTHR13440', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252278),
(420329, 'PTHR12965:SF0', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 54', 252279),
(420330, 'PTHR12965', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING 54', 252279),
(420331, 'PTHR12965:SF2', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 54, CHLOROPLASTIC-LIKE ISOFORM X1', 252279),
(420332, 'PTHR43101:SF1', NULL, NULL, NULL, NULL, 'BETA-FRUCTOSIDASE', 252280),
(420333, 'PTHR43101', NULL, NULL, NULL, NULL, 'BETA-FRUCTOSIDASE', 252280),
(420334, 'PTHR46133:SF19', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 252281),
(420335, 'PTHR46133:SF15', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTION FACTOR', 252281),
(420336, 'PTHR46133:SF29', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR ILR3-LIKE', 252281),
(420337, 'PTHR46133:SF28', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTION FACTOR', 252281),
(420338, 'PTHR46133', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTION FACTOR', 252281),
(420339, 'PTHR46133:SF9', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH104', 252281),
(420340, 'PTHR46133:SF8', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR ILR3-LIKE', 252281),
(420341, 'PTHR46133:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH34', 252281),
(420342, 'PTHR46133:SF6', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTION FACTOR', 252281),
(420343, 'PTHR46133:SF23', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 252281),
(420344, 'PTHR46133:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR ILR3', 252281),
(420345, 'PTHR46133:SF22', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN-CONTAINING PROTEIN-RELATED', 252281),
(420346, 'PTHR46133:SF13', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH115', 252281),
(420347, 'PTHR46133:SF21', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 252281),
(420348, 'PTHR46133:SF20', NULL, NULL, NULL, NULL, 'MYC-TYPE, BASIC HELIX-LOOP-HELIX (BHLH) DOMAIN-CONTAINING PROTEIN-RELATED', 252281),
(420349, 'PTHR31726', NULL, NULL, NULL, NULL, 'PROTEIN ICE2', 252282),
(420350, 'PTHR31726:SF2', NULL, NULL, NULL, NULL, 'PROTEIN ICE2', 252282),
(420351, 'PTHR43563:SF19', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOAMINE OXIDASE B-RELATED', 252283);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(420352, 'PTHR43563:SF1', NULL, NULL, NULL, NULL, 'AMINE OXIDASE [FLAVIN-CONTAINING] B', 252283),
(420353, 'PTHR43563:SF11', NULL, NULL, NULL, NULL, 'AMINE OXIDASE [FLAVIN-CONTAINING] A', 252283),
(420354, 'PTHR43563:SF12', NULL, NULL, NULL, NULL, 'FLAVIN-CONTAINING MONOAMINE OXIDASE A-RELATED', 252283),
(420355, 'PTHR43563:SF14', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 252283),
(420356, 'PTHR43563:SF15', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 252283),
(420357, 'PTHR43563:SF16', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 252283),
(420358, 'PTHR43563', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', 252283),
(420359, 'PTHR43563:SF17', NULL, NULL, NULL, NULL, 'AMINE OXIDASEDEHYDROGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G11670)-RELATED', 252283),
(420360, 'PTHR43563:SF18', NULL, NULL, NULL, NULL, 'AMINO_OXIDASE DOMAIN-CONTAINING PROTEIN', 252283),
(420361, 'PTHR10803:SF17', NULL, NULL, NULL, NULL, 'ARSENICAL PUMP-DRIVING ATPASE-LIKE PROTEIN', 252284),
(420362, 'PTHR10803:SF3', NULL, NULL, NULL, NULL, 'ATPASE GET3', 252284),
(420363, 'PTHR10803', NULL, NULL, NULL, NULL, 'ARSENICAL PUMP-DRIVING ATPASE  ARSENITE-TRANSLOCATING ATPASE', 252284),
(420364, 'PTHR10803:SF26', NULL, NULL, NULL, NULL, 'ANION TRANSPORTER ATPASE-RELATED', 252284),
(420365, 'PTHR10803:SF0', NULL, NULL, NULL, NULL, 'ATPASE GET3B', 252284),
(420366, 'PTHR10803:SF30', NULL, NULL, NULL, NULL, 'ATPASE GET3C', 252284),
(420367, 'PTHR10803:SF20', NULL, NULL, NULL, NULL, 'ATPASE LOC107812171', 252284),
(420368, 'PTHR10803:SF31', NULL, NULL, NULL, NULL, 'ATPASE RV3679-RELATED', 252284),
(420369, 'PTHR10803:SF21', NULL, NULL, NULL, NULL, 'ATPASE LOC107826790', 252284),
(420370, 'PTHR10803:SF22', NULL, NULL, NULL, NULL, 'ARSA_ATPASE DOMAIN-CONTAINING PROTEIN', 252284),
(420371, 'PTHR10803:SF8', NULL, NULL, NULL, NULL, 'ARSENICAL PUMP-DRIVING ATPASE', 252284),
(420372, 'PTHR16656', NULL, NULL, NULL, NULL, 'ALPHA-S2-CASEIN-LIKE B', 252285),
(420373, 'PTHR16656:SF7', NULL, NULL, NULL, NULL, 'ALPHA-S2-CASEIN-LIKE A', 252285),
(420374, 'PTHR16656:SF5', NULL, NULL, NULL, NULL, 'ALPHA-S2-CASEIN-LIKE B', 252285),
(420375, 'PTHR15721', NULL, NULL, NULL, NULL, 'KIAA0586 PROTEIN', 252286),
(420376, 'PTHR15721:SF2', NULL, NULL, NULL, NULL, 'PROTEIN TALPID3', 252286),
(420377, 'PTHR37461', NULL, NULL, NULL, NULL, 'ANTI-SIGMA-K FACTOR RSKA', 252287),
(420378, 'PTHR37461:SF1', NULL, NULL, NULL, NULL, 'ANTI-SIGMA-K FACTOR RSKA', 252287),
(420379, 'PTHR12080:SF106', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 252288),
(420380, 'PTHR12080:SF105', NULL, NULL, NULL, NULL, 'CD48 ANTIGEN', 252288),
(420381, 'PTHR12080:SF103', NULL, NULL, NULL, NULL, 'SLAM FAMILY MEMBER 5', 252288),
(420382, 'PTHR12080:SF109', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 252288),
(420383, 'PTHR12080:SF108', NULL, NULL, NULL, NULL, 'SI:DKEYP-97A10.1-RELATED', 252288),
(420384, 'PTHR12080:SF107', NULL, NULL, NULL, NULL, 'CD84', 252288),
(420385, 'PTHR12080:SF82', NULL, NULL, NULL, NULL, 'CARCINOEMBRYONIC ANTIGEN-RELATED CELL ADHESION MOLECULE 21', 252288),
(420386, 'PTHR12080:SF80', NULL, NULL, NULL, NULL, 'IG DOMAIN-CONTAINING PROTEIN-RELATED', 252288),
(420387, 'PTHR12080:SF46', NULL, NULL, NULL, NULL, 'SLAM FAMILY MEMBER 7', 252288),
(420388, 'PTHR12080:SF87', NULL, NULL, NULL, NULL, 'T-LYMPHOCYTE SURFACE ANTIGEN LY-9 ISOFORM X9', 252288),
(420389, 'PTHR12080:SF86', NULL, NULL, NULL, NULL, 'CARCINOEMBRYONIC ANTIGEN-RELATED CELL ADHESION MOLECULE 11-RELATED', 252288),
(420390, 'PTHR12080:SF113', NULL, NULL, NULL, NULL, 'LYMPHOCYTE FUNCTION-ASSOCIATED ANTIGEN 3', 252288),
(420391, 'PTHR12080:SF112', NULL, NULL, NULL, NULL, 'SI:DKEY-11F4.20', 252288),
(420392, 'PTHR12080:SF49', NULL, NULL, NULL, NULL, 'SIGNALING LYMPHOCYTIC ACTIVATION MOLECULE', 252288),
(420393, 'PTHR12080:SF111', NULL, NULL, NULL, NULL, '', 252288),
(420394, 'PTHR12080:SF48', NULL, NULL, NULL, NULL, 'IG DOMAIN-CONTAINING PROTEIN', 252288),
(420395, 'PTHR12080:SF110', NULL, NULL, NULL, NULL, 'SLAM FAMILY MEMBER 9-LIKE', 252288),
(420396, 'PTHR12080', NULL, NULL, NULL, NULL, 'SIGNALING LYMPHOCYTIC ACTIVATION MOLECULE', 252288);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(420397, 'PTHR12080:SF94', NULL, NULL, NULL, NULL, 'CARCINOEMBRYONIC ANTIGEN-RELATED CELL ADHESION MOLECULE 5-RELATED', 252288),
(420398, 'PTHR12080:SF93', NULL, NULL, NULL, NULL, 'V-SET AND TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN 5', 252288),
(420399, 'PTHR12080:SF92', NULL, NULL, NULL, NULL, 'SLAM FAMILY MEMBER 8', 252288),
(420400, 'PTHR12080:SF56', NULL, NULL, NULL, NULL, 'NATURAL KILLER CELL RECEPTOR 2B4', 252288),
(420401, 'PTHR12080:SF55', NULL, NULL, NULL, NULL, 'T-LYMPHOCYTE SURFACE ANTIGEN LY-9', 252288),
(420402, 'PTHR12080:SF54', NULL, NULL, NULL, NULL, 'T-CELL SURFACE ANTIGEN CD2', 252288),
(420403, 'PTHR12080:SF97', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 252288),
(420404, 'PTHR12080:SF18', NULL, NULL, NULL, NULL, 'SLAM FAMILY MEMBER 9', 252288),
(420405, 'PTHR12080:SF102', NULL, NULL, NULL, NULL, 'SI:CH211-132G1.4', 252288),
(420406, 'PTHR12080:SF16', NULL, NULL, NULL, NULL, 'SLAM FAMILY MEMBER 6', 252288),
(420407, 'PTHR12080:SF59', NULL, NULL, NULL, NULL, 'HEPATOCYTE CELL ADHESION MOLECULE', 252288),
(420408, 'PTHR10221:SF19', NULL, NULL, NULL, NULL, 'TAF DOMAIN-CONTAINING PROTEIN', 252289),
(420409, 'PTHR10221:SF20', NULL, NULL, NULL, NULL, 'TAF6_C DOMAIN-CONTAINING PROTEIN', 252289),
(420410, 'PTHR10221', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 6', 252289),
(420411, 'PTHR10221:SF22', NULL, NULL, NULL, NULL, 'TAF6-LIKE RNA POLYMERASE II P300/CBP-ASSOCIATED FACTOR-ASSOCIATED FACTOR 65 KDA SUBUNIT 6L', 252289),
(420412, 'PTHR10221:SF23', NULL, NULL, NULL, NULL, 'TATA BOX ASSOCIATED FACTOR II 59-RELATED', 252289),
(420413, 'PTHR10221:SF13', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 6', 252289),
(420414, 'PTHR10221:SF9', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 6', 252289),
(420415, 'PTHR10221:SF17', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 6-LIKE ISOFORM X1', 252289),
(420416, 'PTHR35500:SF1', NULL, NULL, NULL, NULL, 'OS03G0108700 PROTEIN', 252290),
(420417, 'PTHR35500:SF2', NULL, NULL, NULL, NULL, 'BNACNNG03100D PROTEIN', 252290),
(420418, 'PTHR35500', NULL, NULL, NULL, NULL, 'OS03G0108700 PROTEIN', 252290),
(420419, 'PTHR47327:SF14', NULL, NULL, NULL, NULL, 'PROTEIN CBG04379', 252291),
(420420, 'PTHR47327:SF4', NULL, NULL, NULL, NULL, 'NOMPA HOMOLOG (DROSOPHILA NOMPA: NO MECHANORECEPTOR POTENTIAL A)', 252291),
(420421, 'PTHR47327:SF13', NULL, NULL, NULL, NULL, '', 252291),
(420422, 'PTHR47327:SF16', NULL, NULL, NULL, NULL, 'PROTEIN CBG00939', 252291),
(420423, 'PTHR47327:SF2', NULL, NULL, NULL, NULL, 'FI18240P1-RELATED', 252291),
(420424, 'PTHR47327:SF3', NULL, NULL, NULL, NULL, 'NOMPA HOMOLOG (DROSOPHILA NOMPA: NO MECHANORECEPTOR POTENTIAL A)', 252291),
(420425, 'PTHR47327:SF15', NULL, NULL, NULL, NULL, 'PROTEIN CBG00402', 252291),
(420426, 'PTHR47327:SF18', NULL, NULL, NULL, NULL, 'CUTICLIN-LIKE', 252291),
(420427, 'PTHR47327:SF17', NULL, NULL, NULL, NULL, 'CUTICLIN-LIKE', 252291),
(420428, 'PTHR47327:SF1', NULL, NULL, NULL, NULL, 'RE15579P', 252291),
(420429, 'PTHR47327:SF19', NULL, NULL, NULL, NULL, 'CUTICLIN-LIKE', 252291),
(420430, 'PTHR47327:SF21', NULL, NULL, NULL, NULL, 'PROTEIN CBG10707', 252291),
(420431, 'PTHR47327:SF20', NULL, NULL, NULL, NULL, 'PROTEIN DYF-7', 252291),
(420432, 'PTHR47327', NULL, NULL, NULL, NULL, 'FI18240P1-RELATED', 252291),
(420433, 'PTHR47327:SF12', NULL, NULL, NULL, NULL, 'PROTEIN CBG11308', 252291),
(420434, 'PTHR47327:SF11', NULL, NULL, NULL, NULL, 'PROTEIN CBG21204', 252291),
(420435, 'PTHR47327:SF22', NULL, NULL, NULL, NULL, 'PROTEIN CBG14590', 252291),
(420436, 'PTHR47327:SF8', NULL, NULL, NULL, NULL, 'FI17836P1', 252291),
(420437, 'PTHR47327:SF9', NULL, NULL, NULL, NULL, 'NO MECHANORECEPTOR POTENTIAL A, ISOFORM A', 252291),
(420438, 'PTHR47327:SF6', NULL, NULL, NULL, NULL, 'PROTEIN LET-653', 252291),
(420439, 'PTHR47327:SF7', NULL, NULL, NULL, NULL, 'GH08941P', 252291),
(420440, 'PTHR15532:SF3', NULL, NULL, NULL, NULL, 'DERMATAN-SULFATE EPIMERASE', 252292),
(420441, 'PTHR15532:SF5', NULL, NULL, NULL, NULL, 'SULFOTRANSFER_1 DOMAIN-CONTAINING PROTEIN', 252292);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(420442, 'PTHR15532', NULL, NULL, NULL, NULL, '', 252292),
(420443, 'PTHR15532:SF2', NULL, NULL, NULL, NULL, 'DERMATAN-SULFATE EPIMERASE-LIKE PROTEIN', 252292),
(420444, 'PTHR14289', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 3', 252293),
(420445, 'PTHR14289:SF16', NULL, NULL, NULL, NULL, 'POLYMERASE DELTA-INTERACTING PROTEIN 2', 252293),
(420446, 'PTHR36765:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252294),
(420447, 'PTHR36765', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252294),
(420448, 'PTHR13455', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR P66-RELATED', 252295),
(420449, 'PTHR13455:SF7', NULL, NULL, NULL, NULL, 'SIMJANG, ISOFORM E', 252295),
(420450, 'PTHR13455:SF4', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR P66-BETA', 252295),
(420451, 'PTHR13455:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR P66-ALPHA', 252295),
(420452, 'PTHR39730:SF1', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 1', 252296),
(420453, 'PTHR39730', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 1', 252296),
(420454, 'PTHR33287:SF8', NULL, NULL, NULL, NULL, '', 252297),
(420455, 'PTHR33287:SF2', NULL, NULL, NULL, NULL, '', 252297),
(420456, 'PTHR33287:SF3', NULL, NULL, NULL, NULL, 'OS03G0453550 PROTEIN', 252297),
(420457, 'PTHR33287:SF11', NULL, NULL, NULL, NULL, 'OS03G0778400 PROTEIN', 252297),
(420458, 'PTHR33287', NULL, NULL, NULL, NULL, 'OS03G0453550 PROTEIN', 252297),
(420459, 'PTHR33287:SF12', NULL, NULL, NULL, NULL, '', 252297),
(420460, 'PTHR33287:SF10', NULL, NULL, NULL, NULL, 'BNAA01G30280D PROTEIN', 252297),
(420461, 'PTHR44200:SF1', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 7', 252298),
(420462, 'PTHR44200:SF2', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ, PUTATIVE-RELATED', 252298),
(420463, 'PTHR44200:SF3', NULL, NULL, NULL, NULL, 'PROTEIN DNAJ, PUTATIVE-RELATED', 252298),
(420464, 'PTHR44200', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 7', 252298),
(420465, 'PTHR36173', NULL, NULL, NULL, NULL, '', 252299),
(420466, 'PTHR36173:SF1', NULL, NULL, NULL, NULL, 'RIBONUCLEASE VAPC22', 252299),
(420467, 'PTHR36173:SF2', NULL, NULL, NULL, NULL, 'RIBONUCLEASE VAPC16', 252299),
(420468, 'PTHR44535:SF4', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NEK8', 252300),
(420469, 'PTHR44535', NULL, NULL, NULL, NULL, 'PROTEIN CBG16200', 252300),
(420470, 'PTHR44535:SF1', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NEK9', 252300),
(420471, 'PTHR21311:SF0', NULL, NULL, NULL, NULL, 'CONSERVED OLIGOMERIC GOLGI COMPLEX SUBUNIT 8', 252301),
(420472, 'PTHR21311', NULL, NULL, NULL, NULL, 'CONSERVED OLIGOMERIC GOLGI COMPLEX COMPONENT 8', 252301),
(420473, 'PTHR35366:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG18623', 252302),
(420474, 'PTHR35366', NULL, NULL, NULL, NULL, 'PROTEIN CBG18620', 252302),
(420475, 'PTHR24190', NULL, NULL, NULL, NULL, 'ION_TRANS DOMAIN-CONTAINING PROTEIN', 252303),
(420476, 'PTHR24190:SF15', NULL, NULL, NULL, NULL, '', 252303),
(420477, 'PTHR24190:SF14', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 252303),
(420478, 'PTHR46528', NULL, NULL, NULL, NULL, 'PROTEIN SON', 252304),
(420479, 'PTHR46528:SF1', NULL, NULL, NULL, NULL, 'PROTEIN SON', 252304),
(420480, 'PTHR46276:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE UBR5', 252305),
(420481, 'PTHR46276', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE UBR5', 252305),
(420482, 'PTHR21207', NULL, NULL, NULL, NULL, 'PARKIN COREGULATED GENE PROTEIN  PARK2 COREGULATED', 252306),
(420483, 'PTHR21207:SF6', NULL, NULL, NULL, NULL, '', 252306),
(420484, 'PTHR21207:SF1', NULL, NULL, NULL, NULL, 'PACRG-LIKE PROTEIN', 252306),
(420485, 'PTHR21207:SF2', NULL, NULL, NULL, NULL, 'PARKIN COREGULATED GENE PROTEIN', 252306),
(420486, 'PTHR43335:SF10', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER RELATED', 252307),
(420487, 'PTHR43335', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, ATP-BINDING PROTEIN', 252307),
(420488, 'PTHR43335:SF8', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, ATP-BINDING PROTEIN', 252307),
(420489, 'PTHR43335:SF3', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER', 252307);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(420490, 'PTHR43335:SF4', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, ATP-BINDING PROTEIN', 252307),
(420491, 'PTHR43335:SF2', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, ATP-BINDING PROTEIN', 252307),
(420492, 'PTHR21421:SF34', NULL, NULL, NULL, NULL, 'GUSTATORY RECEPTOR FOR SUGAR TASTE 61A-RELATED', 252308),
(420493, 'PTHR21421:SF35', NULL, NULL, NULL, NULL, 'GUSTATORY RECEPTOR FOR SUGAR TASTE 64B-RELATED', 252308),
(420494, 'PTHR21421', NULL, NULL, NULL, NULL, 'GUSTATORY RECEPTOR', 252308),
(420495, 'PTHR21421:SF29', NULL, NULL, NULL, NULL, 'GUSTATORY RECEPTOR 5A FOR TREHALOSE-RELATED', 252308),
(420496, 'PTHR33175:SF3', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN HU-BETA', 252309),
(420497, 'PTHR33175:SF2', NULL, NULL, NULL, NULL, 'INTEGRATION HOST FACTOR SUBUNIT ALPHA', 252309),
(420498, 'PTHR33175', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN HU', 252309),
(420499, 'PTHR33175:SF5', NULL, NULL, NULL, NULL, 'INTEGRATION HOST FACTOR SUBUNIT BETA', 252309),
(420500, 'PTHR33175:SF12', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN HU-ALPHA', 252309),
(420501, 'PTHR33175:SF13', NULL, NULL, NULL, NULL, 'HISTONE-LIKE PROTEIN', 252309),
(420502, 'PTHR43429', NULL, NULL, NULL, NULL, 'PYRIDINE NUCLEOTIDE-DISULFIDE OXIDOREDUCTASE DOMAIN-CONTAINING', 252310),
(420503, 'PTHR43429:SF3', NULL, NULL, NULL, NULL, 'NITRITE REDUCTASE [NAD(P)H]', 252310),
(420504, 'PTHR43429:SF1', NULL, NULL, NULL, NULL, 'NAD(P)H SULFUR OXIDOREDUCTASE (COA-DEPENDENT)', 252310),
(420505, 'PTHR43429:SF2', NULL, NULL, NULL, NULL, 'PYRIDINE NUCLEOTIDE-DISULFIDE OXIDOREDUCTASE DOMAIN-CONTAINING PROTEIN 1', 252310),
(420506, 'PTHR43328', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE-RELATED', 252311),
(420507, 'PTHR43328:SF1', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 252311),
(420508, 'PTHR13392', NULL, NULL, NULL, NULL, 'ATAXIN 1', 252312),
(420509, 'PTHR13392:SF14', NULL, NULL, NULL, NULL, 'AXH DOMAIN-CONTAINING PROTEIN', 252312),
(420510, 'PTHR13392:SF13', NULL, NULL, NULL, NULL, 'AXH DOMAIN-CONTAINING PROTEIN', 252312),
(420511, 'PTHR13392:SF5', NULL, NULL, NULL, NULL, 'ATAXIN-1', 252312),
(420512, 'PTHR13392:SF6', NULL, NULL, NULL, NULL, 'ATAXIN-1-LIKE', 252312),
(420513, 'PTHR13130', NULL, NULL, NULL, NULL, '34 KDA TRANSCRIPTIONAL CO-ACTIVATOR-RELATED', 252313),
(420514, 'PTHR13130:SF5', NULL, NULL, NULL, NULL, 'BNAC03G36240D PROTEIN', 252313),
(420515, 'PTHR13130:SF4', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 27', 252313),
(420516, 'PTHR14119:SF3', NULL, NULL, NULL, NULL, 'ISOCHORISMATASE DOMAIN-CONTAINING PROTEIN 2', 252314),
(420517, 'PTHR14119', NULL, NULL, NULL, NULL, 'HYDROLASE', 252314),
(420518, 'PTHR14119:SF12', NULL, NULL, NULL, NULL, 'ISOCHORISMATASE FAMILY PROTEIN 2A-RELATED', 252314),
(420519, 'PTHR14119:SF4', NULL, NULL, NULL, NULL, 'ISOCHORISMATASE DOMAIN-CONTAINING PROTEIN 2A', 252314),
(420520, 'PTHR14119:SF5', NULL, NULL, NULL, NULL, 'ISOCHORISMATASE DOMAIN-CONTAINING PROTEIN 2B', 252314),
(420521, 'PTHR14119:SF17', NULL, NULL, NULL, NULL, 'ISOCHORISMATASE DOMAIN-CONTAINING PROTEIN 1', 252314),
(420522, 'PTHR35297:SF2', NULL, NULL, NULL, NULL, 'OS02G0695600 PROTEIN', 252315),
(420523, 'PTHR35297', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 252315),
(420524, 'PTHR35297:SF12', NULL, NULL, NULL, NULL, '', 252315),
(420525, 'PTHR35297:SF10', NULL, NULL, NULL, NULL, 'BNAC04G44400D PROTEIN', 252315),
(420526, 'PTHR35297:SF11', NULL, NULL, NULL, NULL, '', 252315),
(420527, 'PTHR14672:SF0', NULL, NULL, NULL, NULL, 'MUCIN-16-LIKE', 252316),
(420528, 'PTHR14672:SF1', NULL, NULL, NULL, NULL, 'MUCIN-16', 252316),
(420529, 'PTHR14672', NULL, NULL, NULL, NULL, 'MUCIN-16', 252316),
(420530, 'PTHR43268:SF7', NULL, NULL, NULL, NULL, 'RHODANESE DOMAIN-CONTAINING PROTEIN', 252317),
(420531, 'PTHR43268:SF6', NULL, NULL, NULL, NULL, 'THIOSULFATE SULFURTRANSFERASE/RHODANESE-LIKE DOMAIN-CONTAINING PROTEIN 2', 252317),
(420532, 'PTHR43268:SF3', NULL, NULL, NULL, NULL, 'RHODANESE-LIKE DOMAIN-CONTAINING PROTEIN 7-RELATED', 252317),
(420533, 'PTHR43268', NULL, NULL, NULL, NULL, 'THIOSULFATE SULFURTRANSFERASE/RHODANESE-LIKE DOMAIN-CONTAINING PROTEIN 2', 252317);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(420534, 'PTHR31942:SF126', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420535, 'PTHR31942:SF125', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420536, 'PTHR31942:SF124', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420537, 'PTHR31942:SF123', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420538, 'PTHR31942:SF128', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420539, 'PTHR31942:SF127', NULL, NULL, NULL, NULL, '', 252318),
(420540, 'PTHR31942:SF62', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420541, 'PTHR31942:SF54', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN 13', 252318),
(420542, 'PTHR31942:SF98', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420543, 'PTHR31942:SF53', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN 5-RELATED', 252318),
(420544, 'PTHR31942:SF97', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420545, 'PTHR31942:SF99', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420546, 'PTHR31942:SF57', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420547, 'PTHR31942:SF59', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420548, 'PTHR31942:SF122', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN 1', 252318),
(420549, 'PTHR31942:SF121', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420550, 'PTHR31942:SF120', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420551, 'PTHR31942:SF70', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN 6', 252318),
(420552, 'PTHR31942:SF72', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420553, 'PTHR31942:SF74', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN 15', 252318),
(420554, 'PTHR31942:SF66', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420555, 'PTHR31942:SF69', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420556, 'PTHR31942:SF68', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420557, 'PTHR31942:SF104', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420558, 'PTHR31942:SF103', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420559, 'PTHR31942:SF102', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420560, 'PTHR31942:SF101', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420561, 'PTHR31942:SF107', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420562, 'PTHR31942:SF105', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420563, 'PTHR31942:SF109', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420564, 'PTHR31942:SF80', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN 6', 252318),
(420565, 'PTHR31942:SF83', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420566, 'PTHR31942:SF82', NULL, NULL, NULL, NULL, 'MLO PROTEIN HOMOLOG 1', 252318),
(420567, 'PTHR31942:SF84', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN 12', 252318),
(420568, 'PTHR31942:SF32', NULL, NULL, NULL, NULL, 'OS02G0197200 PROTEIN', 252318),
(420569, 'PTHR31942', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN 1', 252318),
(420570, 'PTHR31942:SF34', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420571, 'PTHR31942:SF77', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN 14', 252318),
(420572, 'PTHR31942:SF79', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN 10-RELATED', 252318),
(420573, 'PTHR31942:SF114', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420574, 'PTHR31942:SF112', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420575, 'PTHR31942:SF118', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420576, 'PTHR31942:SF117', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420577, 'PTHR31942:SF90', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420578, 'PTHR31942:SF91', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420579, 'PTHR31942:SF94', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420580, 'PTHR31942:SF52', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN 1', 252318),
(420581, 'PTHR31942:SF95', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420582, 'PTHR31942:SF87', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN 11', 252318),
(420583, 'PTHR31942:SF86', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN 2', 252318),
(420584, 'PTHR31942:SF89', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN 3', 252318);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(420585, 'PTHR31942:SF49', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN 8', 252318),
(420586, 'PTHR31942:SF9', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN 4', 252318),
(420587, 'PTHR31942:SF110', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN', 252318),
(420588, 'PTHR45089:SF45', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 252319),
(420589, 'PTHR45089:SF24', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK N-TERMINAL DOMAIN-CONTAINING PROTEIN', 252319),
(420590, 'PTHR45089:SF47', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK AMINO-TERMINAL DOMAIN PROTEIN', 252319),
(420591, 'PTHR45089:SF25', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK N-TERMINAL DOMAIN-CONTAINING PROTEIN', 252319),
(420592, 'PTHR45089:SF48', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 252319),
(420593, 'PTHR45089:SF26', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK AMINO-TERMINAL DOMAIN PROTEIN', 252319),
(420594, 'PTHR45089:SF41', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK N-TERMINAL DOMAIN-CONTAINING PROTEIN', 252319),
(420595, 'PTHR45089:SF42', NULL, NULL, NULL, NULL, 'DUF3444 DOMAIN-CONTAINING PROTEIN', 252319),
(420596, 'PTHR45089:SF21', NULL, NULL, NULL, NULL, 'TRICHOHYALIN-LIKE PROTEIN (DUF3444)', 252319),
(420597, 'PTHR45089:SF43', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK N-TERMINAL DOMAIN-CONTAINING PROTEIN-RELATED', 252319),
(420598, 'PTHR45089:SF22', NULL, NULL, NULL, NULL, 'DUF3444 DOMAIN-CONTAINING PROTEIN', 252319),
(420599, 'PTHR45089:SF44', NULL, NULL, NULL, NULL, 'BNAC02G39650D PROTEIN', 252319),
(420600, 'PTHR45089:SF4', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 252319),
(420601, 'PTHR45089:SF49', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK N-TERMINAL DOMAIN-CONTAINING PROTEIN', 252319),
(420602, 'PTHR45089:SF29', NULL, NULL, NULL, NULL, 'BNAA05G31000D PROTEIN', 252319),
(420603, 'PTHR45089:SF12', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 252319),
(420604, 'PTHR45089:SF56', NULL, NULL, NULL, NULL, 'BNAC09G39080D PROTEIN', 252319),
(420605, 'PTHR45089:SF34', NULL, NULL, NULL, NULL, 'BNAC02G39610D PROTEIN', 252319),
(420606, 'PTHR45089:SF37', NULL, NULL, NULL, NULL, 'BNAC05G46690D PROTEIN', 252319),
(420607, 'PTHR45089:SF15', NULL, NULL, NULL, NULL, 'DUF3444 DOMAIN-CONTAINING PROTEIN', 252319),
(420608, 'PTHR45089:SF30', NULL, NULL, NULL, NULL, 'DUF3444 DOMAIN-CONTAINING PROTEIN', 252319),
(420609, 'PTHR45089:SF52', NULL, NULL, NULL, NULL, 'DUF3444 DOMAIN-CONTAINING PROTEIN', 252319),
(420610, 'PTHR45089:SF53', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK N-TERMINAL DOMAIN-CONTAINING PROTEIN', 252319),
(420611, 'PTHR45089:SF10', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK N-TERMINAL DOMAIN-CONTAINING PROTEIN', 252319),
(420612, 'PTHR45089:SF54', NULL, NULL, NULL, NULL, 'OS11G0573800 PROTEIN', 252319),
(420613, 'PTHR45089:SF11', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 252319),
(420614, 'PTHR45089:SF55', NULL, NULL, NULL, NULL, 'DUF3444 DOMAIN-CONTAINING PROTEIN', 252319),
(420615, 'PTHR45089:SF50', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK AMINO-TERMINAL DOMAIN PROTEIN-RELATED', 252319),
(420616, 'PTHR45089', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK AMINO-TERMINAL DOMAIN PROTEIN-RELATED', 252319),
(420617, 'PTHR45089:SF51', NULL, NULL, NULL, NULL, '', 252319),
(420618, 'PTHR45089:SF38', NULL, NULL, NULL, NULL, 'BNAC05G46870D PROTEIN', 252319),
(420619, 'PTHR45089:SF16', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 252319),
(420620, 'PTHR45089:SF18', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK AMINO-TERMINAL DOMAIN PROTEIN', 252319),
(420621, 'PTHR21301:SF11', NULL, NULL, NULL, NULL, 'GIY-YIG DOMAIN-CONTAINING PROTEIN', 252320),
(420622, 'PTHR21301:SF10', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 252320),
(420623, 'PTHR21301', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE', 252320),
(420624, 'PTHR28177', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN 19, MITOCHONDRIAL', 252321),
(420625, 'PTHR28177:SF1', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN 19, MITOCHONDRIAL', 252321),
(420626, 'PTHR37042', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN RV1973', 252322);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(420627, 'PTHR37042:SF4', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN RV1973', 252322),
(420628, 'PTHR46092', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-A11-RELATED', 252323),
(420629, 'PTHR46092:SF4', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-A11', 252323),
(420630, 'PTHR46092:SF2', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-D11', 252323),
(420631, 'PTHR46092:SF3', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-A11', 252323),
(420632, 'PTHR46092:SF1', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-C11', 252323),
(420633, 'PTHR16271', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 34/46 FAMILY MEMBER', 252324),
(420634, 'PTHR16271:SF9', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252324),
(420635, 'PTHR16271:SF10', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 46', 252324),
(420636, 'PTHR16271:SF11', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 34', 252324),
(420637, 'PTHR33236:SF6', NULL, NULL, NULL, NULL, 'CUB DOMAIN-CONTAINING PROTEIN', 252325),
(420638, 'PTHR33236:SF11', NULL, NULL, NULL, NULL, '', 252325),
(420639, 'PTHR33236:SF4', NULL, NULL, NULL, NULL, 'CUB DOMAIN-CONTAINING PROTEIN', 252325),
(420640, 'PTHR33236:SF5', NULL, NULL, NULL, NULL, 'CUB DOMAIN-CONTAINING PROTEIN', 252325),
(420641, 'PTHR33236:SF12', NULL, NULL, NULL, NULL, 'CUB DOMAIN-CONTAINING PROTEIN-RELATED', 252325),
(420642, 'PTHR33236', NULL, NULL, NULL, NULL, 'INTRAFLAGELLAR TRANSPORT PROTEIN 122 FAMILY PROTEIN-RELATED', 252325),
(420643, 'PTHR36392', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 252326),
(420644, 'PTHR36392:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 252326),
(420645, 'PTHR37287:SF1', NULL, NULL, NULL, NULL, 'INO EIGHTY SUBUNIT 1', 252327),
(420646, 'PTHR37287', NULL, NULL, NULL, NULL, 'INO EIGHTY SUBUNIT 1', 252327),
(420647, 'PTHR20930', NULL, NULL, NULL, NULL, 'OVARIAN CARCINOMA ANTIGEN CA125-RELATED', 252328),
(420648, 'PTHR20930:SF8', NULL, NULL, NULL, NULL, 'BNAA03G46880D PROTEIN', 252328),
(420649, 'PTHR20930:SF7', NULL, NULL, NULL, NULL, 'OS04G0476800 PROTEIN', 252328),
(420650, 'PTHR20930:SF9', NULL, NULL, NULL, NULL, 'ZZ-TYPE DOMAIN-CONTAINING PROTEIN', 252328),
(420651, 'PTHR20930:SF4', NULL, NULL, NULL, NULL, 'NBR1 AUTOPHAGY CARGO RECEPTOR A', 252328),
(420652, 'PTHR20930:SF6', NULL, NULL, NULL, NULL, 'PROTEIN JOKA2', 252328),
(420653, 'PTHR20930:SF5', NULL, NULL, NULL, NULL, 'NBR1 AUTOPHAGY CARGO RECEPTOR B', 252328),
(420654, 'PTHR20930:SF0', NULL, NULL, NULL, NULL, 'PROTEIN ILRUN', 252328),
(420655, 'PTHR20930:SF2', NULL, NULL, NULL, NULL, 'NEXT TO BRCA1 GENE 1 PROTEIN', 252328),
(420656, 'PTHR34264:SF9', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT B, CHLOROPLASTIC', 252329),
(420657, 'PTHR34264:SF8', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT B, CHLOROPLASTIC', 252329),
(420658, 'PTHR34264', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT B, CHLOROPLASTIC', 252329),
(420659, 'PTHR34264:SF3', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT B, CHLOROPLASTIC', 252329),
(420660, 'PTHR45830:SF8', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS I', 252330),
(420661, 'PTHR45830:SF9', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS I', 252330),
(420662, 'PTHR45830', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS I', 252330),
(420663, 'PTHR45830:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG26168', 252330),
(420664, 'PTHR45830:SF15', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS I', 252330),
(420665, 'PTHR45830:SF14', NULL, NULL, NULL, NULL, 'PROTEIN CBG06651', 252330),
(420666, 'PTHR45830:SF3', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS I', 252330),
(420667, 'PTHR45830:SF6', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS I', 252330),
(420668, 'PTHR45830:SF13', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS I', 252330),
(420669, 'PTHR45830:SF5', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS I', 252330),
(420670, 'PTHR45830:SF12', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS I', 252330),
(420671, 'PTHR45830:SF19', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS I', 252330),
(420672, 'PTHR45830:SF18', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS I', 252330);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(420673, 'PTHR45830:SF17', NULL, NULL, NULL, NULL, 'PROTEIN CBG12170', 252330),
(420674, 'PTHR45830:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG24588', 252330),
(420675, 'PTHR45830:SF16', NULL, NULL, NULL, NULL, 'PROTEIN CBG13590', 252330),
(420676, 'PTHR45830:SF11', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS I', 252330),
(420677, 'PTHR45830:SF21', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS I', 252330),
(420678, 'PTHR45830:SF20', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS I', 252330),
(420679, 'PTHR13225:SF3', NULL, NULL, NULL, NULL, 'UPF0489 PROTEIN C5ORF22', 252331),
(420680, 'PTHR13225', NULL, NULL, NULL, NULL, 'MISEXPRESSION SUPPRESSOR OF RAS 6', 252331),
(420681, 'PTHR46902', NULL, NULL, NULL, NULL, 'DOMON DOMAIN-CONTAINING PROTEIN FRRS1L', 252332),
(420682, 'PTHR46902:SF1', NULL, NULL, NULL, NULL, 'DOMON DOMAIN-CONTAINING PROTEIN FRRS1L', 252332),
(420683, 'PTHR46942:SF1', NULL, NULL, NULL, NULL, 'SIALIC ACID-BINDING IG-LIKE LECTIN 15', 252333),
(420684, 'PTHR46942', NULL, NULL, NULL, NULL, 'SIALIC ACID-BINDING IG-LIKE LECTIN 15', 252333),
(420685, 'PTHR46595:SF7', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L34', 252334),
(420686, 'PTHR46595:SF6', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L34', 252334),
(420687, 'PTHR46595:SF5', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L34', 252334),
(420688, 'PTHR46595:SF4', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L34', 252334),
(420689, 'PTHR46595', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L34', 252334),
(420690, 'PTHR46595:SF2', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L34', 252334),
(420691, 'PTHR46900', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE NON-RECEPTOR TYPE 13', 252335),
(420692, 'PTHR46900:SF2', NULL, NULL, NULL, NULL, '', 252335),
(420693, 'PTHR46900:SF3', NULL, NULL, NULL, NULL, 'NON-SPECIFIC PROTEIN-TYROSINE KINASE', 252335),
(420694, 'PTHR46900:SF1', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE NON-RECEPTOR TYPE 13', 252335),
(420695, 'PTHR45693', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TGA9', 252336),
(420696, 'PTHR45693:SF19', NULL, NULL, NULL, NULL, 'FACTOR BZIP PROTEIN, PUTATIVE-RELATED', 252336),
(420697, 'PTHR45693:SF37', NULL, NULL, NULL, NULL, 'TGACG-SEQUENCE-SPECIFIC DNA-BINDING PROTEIN TGA-1A-LIKE', 252336),
(420698, 'PTHR45693:SF59', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TGA2-LIKE', 252336),
(420699, 'PTHR45693:SF15', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TGA2.3', 252336),
(420700, 'PTHR45693:SF38', NULL, NULL, NULL, NULL, 'BZIP FAMILY TRANSCRIPTION FACTOR', 252336),
(420701, 'PTHR45693:SF16', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TGAL5', 252336),
(420702, 'PTHR45693:SF39', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TGA5', 252336),
(420703, 'PTHR45693:SF11', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TGAL7', 252336),
(420704, 'PTHR45693:SF33', NULL, NULL, NULL, NULL, 'TGA7', 252336),
(420705, 'PTHR45693:SF55', NULL, NULL, NULL, NULL, 'BNAA08G20970D PROTEIN', 252336),
(420706, 'PTHR45693:SF13', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TGA10', 252336),
(420707, 'PTHR45693:SF36', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TGA4', 252336),
(420708, 'PTHR45693:SF58', NULL, NULL, NULL, NULL, 'BNAA09G07120D PROTEIN', 252336),
(420709, 'PTHR45693:SF14', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TGA2.2', 252336),
(420710, 'PTHR45693:SF51', NULL, NULL, NULL, NULL, '80A08_2', 252336),
(420711, 'PTHR45693:SF52', NULL, NULL, NULL, NULL, 'BASIC-LEUCINE ZIPPER DOMAIN, TRANSCRIPTION FACTOR TGA LIKE DOMAIN PROTEIN-RELATED', 252336),
(420712, 'PTHR45693:SF30', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TGA6', 252336),
(420713, 'PTHR45693:SF31', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TGAL10', 252336),
(420714, 'PTHR45693:SF32', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TGA3', 252336),
(420715, 'PTHR45693:SF48', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TGAL1', 252336),
(420716, 'PTHR45693:SF28', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TGAL4', 252336),
(420717, 'PTHR45693:SF22', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR FAMILY PROTEIN', 252336);
INSERT INTO "PUBLIC"."MODEL" VALUES
(420718, 'PTHR45693:SF66', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR SUPERFAMILY PROTEIN-RELATED', 252336),
(420719, 'PTHR45693:SF44', NULL, NULL, NULL, NULL, 'BASIC-LEUCINE ZIPPER DOMAIN, TRANSCRIPTION FACTOR TGA LIKE DOMAIN PROTEIN-RELATED', 252336),
(420720, 'PTHR45693:SF67', NULL, NULL, NULL, NULL, 'BNAC08G43230D PROTEIN', 252336),
(420721, 'PTHR45693:SF45', NULL, NULL, NULL, NULL, 'BNAC02G43620D PROTEIN', 252336),
(420722, 'PTHR45693:SF24', NULL, NULL, NULL, NULL, 'BZIP FAMILY TRANSCRIPTION FACTOR', 252336),
(420723, 'PTHR45693:SF46', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TGA2-RELATED', 252336),
(420724, 'PTHR45693:SF47', NULL, NULL, NULL, NULL, 'BASIC-LEUCINE ZIPPER DOMAIN, TRANSCRIPTION FACTOR TGA LIKE DOMAIN PROTEIN-RELATED', 252336),
(420725, 'PTHR45693:SF25', NULL, NULL, NULL, NULL, 'DOG1 DOMAIN-CONTAINING PROTEIN', 252336),
(420726, 'PTHR45693:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TGA7', 252336),
(420727, 'PTHR45693:SF40', NULL, NULL, NULL, NULL, 'FACTOR TGA7, PUTATIVE-RELATED', 252336),
(420728, 'PTHR45693:SF62', NULL, NULL, NULL, NULL, 'BZIP FAMILY TRANSCRIPTION FACTOR', 252336),
(420729, 'PTHR45693:SF63', NULL, NULL, NULL, NULL, 'BZIP DOMAIN-CONTAINING PROTEIN', 252336),
(420730, 'PTHR45693:SF9', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TGA9', 252336),
(420731, 'PTHR45693:SF64', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TGA1', 252336),
(420732, 'PTHR45693:SF42', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PERIANTHIA-LIKE', 252336),
(420733, 'PTHR45693:SF65', NULL, NULL, NULL, NULL, 'BNACNNG22950D PROTEIN', 252336),
(420734, 'PTHR45693:SF43', NULL, NULL, NULL, NULL, 'DOG1 DOMAIN-CONTAINING PROTEIN', 252336),
(420735, 'PTHR45693:SF60', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR HBP-1B(C38)-LIKE', 252336),
(420736, 'PTHR45693:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PERIANTHIA', 252336),
(420737, 'PTHR45693:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TGAL8', 252336),
(420738, 'PTHR30231:SF23', NULL, NULL, NULL, NULL, 'PROTEIN NEN2', 252337),
(420739, 'PTHR30231:SF22', NULL, NULL, NULL, NULL, 'EXONUCLEASE DOMAIN-CONTAINING PROTEIN', 252337),
(420740, 'PTHR30231:SF36', NULL, NULL, NULL, NULL, 'PROTEIN NEN1', 252337),
(420741, 'PTHR30231:SF35', NULL, NULL, NULL, NULL, 'EXONUCLEASE', 252337),
(420742, 'PTHR30231:SF38', NULL, NULL, NULL, NULL, 'BNAC03G60660D PROTEIN', 252337),
(420743, 'PTHR30231:SF27', NULL, NULL, NULL, NULL, 'PROTEIN NEN3', 252337),
(420744, 'PTHR30231:SF37', NULL, NULL, NULL, NULL, 'EXODEOXYRIBONUCLEASE 10', 252337),
(420745, 'PTHR30231:SF26', NULL, NULL, NULL, NULL, 'PROTEIN NEN4', 252337),
(420746, 'PTHR30231:SF39', NULL, NULL, NULL, NULL, 'DNA POLYMERASE III, EPSILON SUBUNIT', 252337),
(420747, 'PTHR30231:SF41', NULL, NULL, NULL, NULL, 'DNA POLYMERASE III SUBUNIT EPSILON', 252337),
(420748, 'PTHR30231:SF40', NULL, NULL, NULL, NULL, 'EXONUCLEASE DOMAIN-CONTAINING PROTEIN', 252337),
(420749, 'PTHR30231:SF4', NULL, NULL, NULL, NULL, 'PROTEIN NEN2', 252337),
(420750, 'PTHR30231:SF7', NULL, NULL, NULL, NULL, 'BLR4117 PROTEIN', 252337),
(420751, 'PTHR30231:SF2', NULL, NULL, NULL, NULL, 'RIBONUCLEASE T', 252337),
(420752, 'PTHR30231', NULL, NULL, NULL, NULL, 'DNA POLYMERASE III SUBUNIT EPSILON', 252337),
(420753, 'PTHR38004:SF1', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 33', 252338),
(420754, 'PTHR38004', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 33', 252338),
(420755, 'PTHR40470', NULL, NULL, NULL, NULL, 'PHYTANOYL-COA DIOXYGENASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_2G15850)', 252339),
(420756, 'PTHR40470:SF1', NULL, NULL, NULL, NULL, 'PHYTANOYL-COA DIOXYGENASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_2G15850)', 252339),
(420757, 'PTHR16318:SF0', NULL, NULL, NULL, NULL, 'GAMMA-SECRETASE SUBUNIT PEN-2', 252340),
(420758, 'PTHR16318', NULL, NULL, NULL, NULL, 'GAMMA-SECRETASE SUBUNIT PEN-2', 252340),
(420759, 'PTHR46376:SF2', NULL, NULL, NULL, NULL, 'DISTRACTED, ISOFORM B', 252341),
(420760, 'PTHR46376:SF1', NULL, NULL, NULL, NULL, 'LEUCINE-ZIPPER-LIKE TRANSCRIPTIONAL REGULATOR 1', 252341),
(420761, 'PTHR46376', NULL, NULL, NULL, NULL, 'LEUCINE-ZIPPER-LIKE TRANSCRIPTIONAL REGULATOR 1', 252341);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(420762, 'PTHR46376:SF3', NULL, NULL, NULL, NULL, 'ATTRACTIN', 252341),
(420763, 'PTHR35441:SF2', NULL, NULL, NULL, NULL, 'CIRCADIAN ASSOCIATED REPRESSOR OF TRANSCRIPTION', 252342),
(420764, 'PTHR35441:SF1', NULL, NULL, NULL, NULL, 'CIRCADIAN-ASSOCIATED TRANSCRIPTIONAL REPRESSOR', 252342),
(420765, 'PTHR35441', NULL, NULL, NULL, NULL, 'CIRCADIAN-ASSOCIATED TRANSCRIPTIONAL REPRESSOR', 252342),
(420766, 'PTHR45033:SF2', NULL, NULL, NULL, NULL, 'ZINC-TYPE ALCOHOL DEHYDROGENASE-LIKE PROTEIN C1773.06C', 252343),
(420767, 'PTHR45033:SF3', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G13270)-RELATED', 252343),
(420768, 'PTHR45033:SF1', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE (EUROFUNG)', 252343),
(420769, 'PTHR45033', NULL, NULL, NULL, NULL, '', 252343),
(420770, 'PTHR48024:SF43', NULL, NULL, NULL, NULL, 'PROTEIN RBP6, PUTATIVE-RELATED', 252344),
(420771, 'PTHR48024:SF21', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN, PUTATIVE-RELATED', 252344),
(420772, 'PTHR48024:SF22', NULL, NULL, NULL, NULL, 'GLYCINE-RICH RNA-BINDING PROTEIN 7-RELATED', 252344),
(420773, 'PTHR48024:SF44', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 252344),
(420774, 'PTHR48024:SF23', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN ARP1-RELATED', 252344),
(420775, 'PTHR48024:SF45', NULL, NULL, NULL, NULL, 'RNA BINDING DOMAIN PROTEIN', 252344),
(420776, 'PTHR48024:SF24', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 252344),
(420777, 'PTHR48024:SF46', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 252344),
(420778, 'PTHR48024:SF40', NULL, NULL, NULL, NULL, 'GLYCINE-RICH RNA-BINDING, ABSCISIC ACID-INDUCIBLE PROTEIN', 252344),
(420779, 'PTHR48024:SF41', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN', 252344),
(420780, 'PTHR48024:SF42', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 252344),
(420781, 'PTHR48024', NULL, NULL, NULL, NULL, 'GEO13361P1-RELATED', 252344),
(420782, 'PTHR48024:SF1', NULL, NULL, NULL, NULL, 'NUCLEAR RIBONUCLEOPROTEIN A1, PUTATIVE-RELATED', 252344),
(420783, 'PTHR48024:SF29', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN A0', 252344),
(420784, 'PTHR48024:SF8', NULL, NULL, NULL, NULL, 'GLYCINE-RICH RNA-BINDING PROTEIN 6, MITOCHONDRIAL', 252344),
(420785, 'PTHR48024:SF47', NULL, NULL, NULL, NULL, 'BNAA05G30560D PROTEIN', 252344),
(420786, 'PTHR48024:SF25', NULL, NULL, NULL, NULL, 'UBP1-ASSOCIATED PROTEIN 2C', 252344),
(420787, 'PTHR48024:SF48', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 252344),
(420788, 'PTHR48024:SF27', NULL, NULL, NULL, NULL, 'GLYCINE-RICH RNA-BINDING PROTEIN 1-RELATED', 252344),
(420789, 'PTHR48024:SF9', NULL, NULL, NULL, NULL, 'UBP1-ASSOCIATED PROTEINS 1A-RELATED', 252344),
(420790, 'PTHR48024:SF49', NULL, NULL, NULL, NULL, '', 252344),
(420791, 'PTHR48024:SF28', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 38', 252344),
(420792, 'PTHR48024:SF10', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 24', 252344),
(420793, 'PTHR48024:SF11', NULL, NULL, NULL, NULL, 'NUCLEAR LOCALIZATION SEQUENCE-BINDING PROTEIN', 252344),
(420794, 'PTHR48024:SF34', NULL, NULL, NULL, NULL, 'GLYCINE-RICH RNA-BINDING PROTEIN 8-RELATED', 252344),
(420795, 'PTHR48024:SF13', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN Q', 252344),
(420796, 'PTHR48024:SF50', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 252344),
(420797, 'PTHR48024:SF51', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 252344),
(420798, 'PTHR48024:SF52', NULL, NULL, NULL, NULL, '', 252344),
(420799, 'PTHR48024:SF53', NULL, NULL, NULL, NULL, 'GEO11133P1', 252344),
(420800, 'PTHR48024:SF14', NULL, NULL, NULL, NULL, '', 252344),
(420801, 'PTHR48024:SF38', NULL, NULL, NULL, NULL, 'UBP1-ASSOCIATED PROTEIN 2C-LIKE', 252344),
(420802, 'PTHR48024:SF39', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 252344),
(420803, 'PTHR48024:SF17', NULL, NULL, NULL, NULL, 'OS02G0602600 PROTEIN', 252344),
(420804, 'PTHR46466:SF1', NULL, NULL, NULL, NULL, 'GLYOXALASE DOMAIN-CONTAINING PROTEIN 4', 252345);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(420805, 'PTHR46466', NULL, NULL, NULL, NULL, 'GLYOXALASE DOMAIN-CONTAINING PROTEIN 4', 252345),
(420806, 'PTHR35182:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG04729', 252346),
(420807, 'PTHR35182:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG05388', 252346),
(420808, 'PTHR35182', NULL, NULL, NULL, NULL, 'PROTEIN CBG13762', 252346),
(420809, 'PTHR35182:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG20876', 252346),
(420810, 'PTHR35182:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG04730', 252346),
(420811, 'PTHR35182:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG13762', 252346),
(420812, 'PTHR35182:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG20471', 252346),
(420813, 'PTHR35182:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG04719', 252346),
(420814, 'PTHR35182:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG13100', 252346),
(420815, 'PTHR12785', NULL, NULL, NULL, NULL, 'SPLICING FACTOR 3B', 252347),
(420816, 'PTHR12785:SF16', NULL, NULL, NULL, NULL, 'PSP DOMAIN-CONTAINING PROTEIN', 252347),
(420817, 'PTHR12785:SF7', NULL, NULL, NULL, NULL, 'SPLICING FACTOR 3B SUBUNIT 6', 252347),
(420818, 'PTHR12785:SF6', NULL, NULL, NULL, NULL, 'SPLICING FACTOR 3B SUBUNIT 2', 252347),
(420819, 'PTHR12785:SF13', NULL, NULL, NULL, NULL, 'SPLICING FACTOR 3B SUBUNIT 2-LIKE', 252347),
(420820, 'PTHR12785:SF12', NULL, NULL, NULL, NULL, 'PROLINE-RICH SPLICEOSOME-ASSOCIATED (PSP) FAMILY PROTEIN', 252347),
(420821, 'PTHR41173', NULL, NULL, NULL, NULL, 'UPF0278 PROTEIN TK1425', 252348),
(420822, 'PTHR41173:SF1', NULL, NULL, NULL, NULL, 'RNA-FREE RIBONUCLEASE P', 252348),
(420823, 'PTHR21812:SF1', NULL, NULL, NULL, NULL, 'INO80 COMPLEX SUBUNIT E', 252349),
(420824, 'PTHR21812', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252349),
(420825, 'PTHR48141', NULL, NULL, NULL, NULL, 'KINASE C, PUTATIVE-RELATED', 252350),
(420826, 'PTHR48141:SF1', NULL, NULL, NULL, NULL, 'KINASE C, PUTATIVE-RELATED', 252350),
(420827, 'PTHR36410:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252351),
(420828, 'PTHR36410', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252351),
(420829, 'PTHR36410:SF4', NULL, NULL, NULL, NULL, 'BNAC07G48560D PROTEIN', 252351),
(420830, 'PTHR36410:SF3', NULL, NULL, NULL, NULL, '', 252351),
(420831, 'PTHR15049:SF1', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 6K', 252352),
(420832, 'PTHR15049:SF2', NULL, NULL, NULL, NULL, 'GLYCOSYL-PHOSPHATIDYLINOSITOL-ANCHORED MOLECULE-LIKE PROTEIN', 252352),
(420833, 'PTHR15049', NULL, NULL, NULL, NULL, 'GLYCOSYL-PHOSPHATIDYLINOSITOL-ANCHORED MOLECULE-LIKE PROTEIN-RELATED', 252352),
(420834, 'PTHR10989', NULL, NULL, NULL, NULL, 'ANDROGEN-INDUCED PROTEIN 1-RELATED', 252353),
(420835, 'PTHR10989:SF16', NULL, NULL, NULL, NULL, 'AT02829P-RELATED', 252353),
(420836, 'PTHR10989:SF17', NULL, NULL, NULL, NULL, 'ANDROGEN-DEPENDENT TFPI-REGULATING PROTEIN', 252353),
(420837, 'PTHR10989:SF22', NULL, NULL, NULL, NULL, 'ANDROGEN-INDUCED GENE 1 PROTEIN', 252353),
(420838, 'PTHR10989:SF11', NULL, NULL, NULL, NULL, 'ANDROGEN-INDUCED GENE 1 PROTEIN', 252353),
(420839, 'PTHR10989:SF23', NULL, NULL, NULL, NULL, 'PROTEIN CBG16310', 252353),
(420840, 'PTHR10989:SF19', NULL, NULL, NULL, NULL, 'ANDROGEN DEPENDENT TFPI REGULATING PROTEIN', 252353),
(420841, 'PTHR13422:SF18', NULL, NULL, NULL, NULL, 'SIN3-HDAC COMPLEX-ASSOCIATED FACTOR', 252354),
(420842, 'PTHR13422:SF14', NULL, NULL, NULL, NULL, 'FAMILY WITH SEQUENCE SIMILARITY 60, MEMBER A', 252354),
(420843, 'PTHR13422', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252354),
(420844, 'PTHR13422:SF16', NULL, NULL, NULL, NULL, '', 252354),
(420845, 'PTHR13422:SF12', NULL, NULL, NULL, NULL, 'SIN3-HDAC COMPLEX-ASSOCIATED FACTOR', 252354),
(420846, 'PTHR13422:SF13', NULL, NULL, NULL, NULL, 'PROTEIN FAM60A-LIKE', 252354),
(420847, 'PTHR31180:SF3', NULL, NULL, NULL, NULL, 'EXPRESSED SEQUENCE EH456644', 252355),
(420848, 'PTHR31180:SF2', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC691162', 252355),
(420849, 'PTHR31180', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252355),
(420850, 'PTHR34139', NULL, NULL, NULL, NULL, 'UPF0331 PROTEIN MJ0127', 252356),
(420851, 'PTHR34139:SF4', NULL, NULL, NULL, NULL, 'SLL1411 PROTEIN', 252356);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(420852, 'PTHR34139:SF1', NULL, NULL, NULL, NULL, 'RNASE MJ1380-RELATED', 252356),
(420853, 'PTHR35848', NULL, NULL, NULL, NULL, 'OXALATE-BINDING PROTEIN', 252357),
(420854, 'PTHR35848:SF8', NULL, NULL, NULL, NULL, 'OXALATE-BINDING PROTEIN', 252357),
(420855, 'PTHR35848:SF6', NULL, NULL, NULL, NULL, 'CUPIN_2 DOMAIN-CONTAINING PROTEIN', 252357),
(420856, 'PTHR13379', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED DUF1308', 252358),
(420857, 'PTHR13379:SF0', NULL, NULL, NULL, NULL, 'UPF0415 PROTEIN C7ORF25', 252358),
(420858, 'PTHR21634', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252359),
(420859, 'PTHR21634:SF12', NULL, NULL, NULL, NULL, 'FOLLICULIN-INTERACTING PROTEIN 1', 252359),
(420860, 'PTHR21634:SF11', NULL, NULL, NULL, NULL, 'FOLLICULIN-INTERACTING PROTEIN 2', 252359),
(420861, 'PTHR21634:SF9', NULL, NULL, NULL, NULL, 'RE13835P', 252359),
(420862, 'PTHR33057:SF139', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420863, 'PTHR33057:SF214', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420864, 'PTHR33057:SF17', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR OFP8', 252360),
(420865, 'PTHR33057:SF215', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420866, 'PTHR33057:SF138', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420867, 'PTHR33057:SF16', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420868, 'PTHR33057:SF212', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR OFP2', 252360),
(420869, 'PTHR33057:SF179', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420870, 'PTHR33057:SF135', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420871, 'PTHR33057:SF136', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420872, 'PTHR33057:SF213', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420873, 'PTHR33057:SF98', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR OFP18', 252360),
(420874, 'PTHR33057:SF210', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420875, 'PTHR33057:SF211', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420876, 'PTHR33057:SF12', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420877, 'PTHR33057:SF175', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR OFP12', 252360),
(420878, 'PTHR33057:SF132', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420879, 'PTHR33057:SF130', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR OFP15', 252360),
(420880, 'PTHR33057:SF91', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420881, 'PTHR33057:SF90', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR OFP7', 252360),
(420882, 'PTHR33057:SF172', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420883, 'PTHR33057:SF170', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420884, 'PTHR33057:SF26', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR OFP13', 252360),
(420885, 'PTHR33057:SF149', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420886, 'PTHR33057:SF27', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420887, 'PTHR33057:SF66', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420888, 'PTHR33057:SF21', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420889, 'PTHR33057:SF144', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420890, 'PTHR33057:SF68', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420891, 'PTHR33057:SF189', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420892, 'PTHR33057:SF23', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420893, 'PTHR33057:SF101', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420894, 'PTHR33057:SF142', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420895, 'PTHR33057:SF143', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420896, 'PTHR33057:SF187', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420897, 'PTHR33057:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420898, 'PTHR33057:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(420899, 'PTHR33057:SF117', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR OFP14', 252360),
(420900, 'PTHR33057:SF113', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420901, 'PTHR33057:SF32', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420902, 'PTHR33057:SF114', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR-RELATED', 252360),
(420903, 'PTHR33057:SF76', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420904, 'PTHR33057:SF199', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420905, 'PTHR33057:SF79', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420906, 'PTHR33057:SF111', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420907, 'PTHR33057:SF155', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420908, 'PTHR33057:SF35', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420909, 'PTHR33057:SF197', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420910, 'PTHR33057:SF198', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420911, 'PTHR33057:SF72', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420912, 'PTHR33057:SF110', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420913, 'PTHR33057:SF151', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR OFP4', 252360),
(420914, 'PTHR33057:SF31', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420915, 'PTHR33057:SF195', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420916, 'PTHR33057:SF196', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR OFP11', 252360),
(420917, 'PTHR33057:SF193', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR OFP1', 252360),
(420918, 'PTHR33057:SF194', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420919, 'PTHR33057:SF150', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420920, 'PTHR33057:SF192', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420921, 'PTHR33057:SF70', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR-RELATED', 252360),
(420922, 'PTHR33057:SF209', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420923, 'PTHR33057:SF207', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420924, 'PTHR33057:SF208', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420925, 'PTHR33057:SF205', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420926, 'PTHR33057:SF128', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR OFP3', 252360),
(420927, 'PTHR33057:SF206', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420928, 'PTHR33057:SF203', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420929, 'PTHR33057:SF204', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420930, 'PTHR33057:SF201', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420931, 'PTHR33057:SF168', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420932, 'PTHR33057:SF202', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR OFP10', 252360),
(420933, 'PTHR33057:SF200', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420934, 'PTHR33057:SF167', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420935, 'PTHR33057:SF89', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420936, 'PTHR33057:SF164', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420937, 'PTHR33057:SF120', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR OFP16', 252360),
(420938, 'PTHR33057:SF163', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420939, 'PTHR33057:SF160', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420940, 'PTHR33057:SF80', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420941, 'PTHR33057:SF161', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR', 252360),
(420942, 'PTHR33057', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR OFP7-RELATED', 252360),
(420943, 'PTHR33057:SF82', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR OFP5', 252360),
(420944, 'PTHR36834', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 252361);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(420945, 'PTHR36834:SF1', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN-RELATED', 252361),
(420946, 'PTHR36834:SF2', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 252361),
(420947, 'PTHR39166', NULL, NULL, NULL, NULL, 'BLL1166 PROTEIN', 252362),
(420948, 'PTHR39166:SF1', NULL, NULL, NULL, NULL, 'BLL1166 PROTEIN', 252362),
(420949, 'PTHR37972:SF2', NULL, NULL, NULL, NULL, 'AGAP013525-PA', 252363),
(420950, 'PTHR37972', NULL, NULL, NULL, NULL, 'PROTEIN CBG25533', 252363),
(420951, 'PTHR24009:SF43', NULL, NULL, NULL, NULL, 'BNAC03G44090D PROTEIN', 252364),
(420952, 'PTHR24009:SF20', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 252364),
(420953, 'PTHR24009:SF31', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 53-LIKE ISOFORM X1', 252364),
(420954, 'PTHR24009:SF42', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 18-LIKE ISOFORM X1', 252364),
(420955, 'PTHR24009:SF41', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 55', 252364),
(420956, 'PTHR24009:SF40', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 18-LIKE ISOFORM X1', 252364),
(420957, 'PTHR24009:SF14', NULL, NULL, NULL, NULL, 'RNA-BINDING ZINC FINGER FAMILY PROTEIN-RELATED', 252364),
(420958, 'PTHR24009:SF36', NULL, NULL, NULL, NULL, 'BNACNNG36710D PROTEIN', 252364),
(420959, 'PTHR24009', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS)', 252364),
(420960, 'PTHR24009:SF44', NULL, NULL, NULL, NULL, 'OS11G0125700 PROTEIN', 252364),
(420961, 'PTHR24009:SF11', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 22-LIKE ISOFORM X1', 252364),
(420962, 'PTHR24009:SF33', NULL, NULL, NULL, NULL, 'BNAC07G32610D PROTEIN', 252364),
(420963, 'PTHR24009:SF18', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 252364),
(420964, 'PTHR24009:SF17', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 46', 252364),
(420965, 'PTHR24009:SF39', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 53', 252364),
(420966, 'PTHR24009:SF27', NULL, NULL, NULL, NULL, 'RNA-BINDING ZINC FINGER FAMILY PROTEIN-RELATED', 252364),
(420967, 'PTHR24009:SF3', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN-RELATED', 252364),
(420968, 'PTHR24009:SF0', NULL, NULL, NULL, NULL, 'ZINC FINGER (CCCH-TYPE) FAMILY PROTEIN / RNA RECOGNITION MOTIF (RRM)-CONTAINING PROTEIN-RELATED', 252364),
(420969, 'PTHR39080', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L28', 252365),
(420970, 'PTHR39080:SF1', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L28-1', 252365),
(420971, 'PTHR36118', NULL, NULL, NULL, NULL, 'ION-TRANSLOCATING OXIDOREDUCTASE COMPLEX SUBUNIT G', 252366),
(420972, 'PTHR36118:SF1', NULL, NULL, NULL, NULL, 'ION-TRANSLOCATING OXIDOREDUCTASE COMPLEX SUBUNIT G', 252366),
(420973, 'PTHR22851:SF0', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 13', 252367),
(420974, 'PTHR22851:SF2', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 13', 252367),
(420975, 'PTHR22851:SF1', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE-RELATED', 252367),
(420976, 'PTHR22851', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RNA  U3 SNORNA  ASSOCIATED PROTEIN', 252367),
(420977, 'PTHR16320:SF19', NULL, NULL, NULL, NULL, '', 252368),
(420978, 'PTHR16320:SF18', NULL, NULL, NULL, NULL, 'SPHINGOMYELIN PHOSPHODIESTERASE', 252368),
(420979, 'PTHR16320', NULL, NULL, NULL, NULL, 'SPHINGOMYELINASE FAMILY MEMBER', 252368),
(420980, 'PTHR16320:SF8', NULL, NULL, NULL, NULL, 'SPHINGOMYELIN PHOSPHODIESTERASE 3', 252368),
(420981, 'PTHR16320:SF23', NULL, NULL, NULL, NULL, 'SPHINGOMYELINASE C 1', 252368),
(420982, 'PTHR16320:SF9', NULL, NULL, NULL, NULL, 'SPHINGOMYELIN PHOSPHODIESTERASE 5', 252368),
(420983, 'PTHR16320:SF22', NULL, NULL, NULL, NULL, 'SPHINGOMYELIN PHOSPHODIESTERASE', 252368),
(420984, 'PTHR16320:SF21', NULL, NULL, NULL, NULL, 'SPHINGOMYELIN PHOSPHODIESTERASE 5', 252368),
(420985, 'PTHR16320:SF1', NULL, NULL, NULL, NULL, 'SPHINGOMYELINASE DDB_G0288017', 252368),
(420986, 'PTHR13531:SF5', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 216', 252369); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(420987, 'PTHR13531:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 17A', 252369),
(420988, 'PTHR13531:SF6', NULL, NULL, NULL, NULL, 'TMEM (HUMAN TRANSMEMBRANE PROTEIN) HOMOLOG', 252369),
(420989, 'PTHR13531:SF8', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 80', 252369),
(420990, 'PTHR13531:SF14', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 17', 252369),
(420991, 'PTHR13531', NULL, NULL, NULL, NULL, 'GEO07735P1-RELATED-RELATED', 252369),
(420992, 'PTHR13531:SF0', NULL, NULL, NULL, NULL, 'GEO07735P1-RELATED', 252369),
(420993, 'PTHR47949', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 703A2-RELATED-RELATED', 252370),
(420994, 'PTHR47949:SF2', NULL, NULL, NULL, NULL, 'FLAVONOID 3''-MONOOXYGENASE-LIKE', 252370),
(420995, 'PTHR47949:SF3', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 703A2', 252370),
(420996, 'PTHR47949:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 CYP736A12-LIKE', 252370),
(420997, 'PTHR43066', NULL, NULL, NULL, NULL, 'RHOMBOID-RELATED PROTEIN', 252371),
(420998, 'PTHR43066:SF20', NULL, NULL, NULL, NULL, 'OS01G0806000 PROTEIN', 252371),
(420999, 'PTHR43066:SF21', NULL, NULL, NULL, NULL, 'UBA DOMAIN-CONTAINING 2', 252371),
(421000, 'PTHR43066:SF10', NULL, NULL, NULL, NULL, 'RANBP2-TYPE DOMAIN-CONTAINING PROTEIN', 252371),
(421001, 'PTHR43066:SF11', NULL, NULL, NULL, NULL, 'RHOMBOID PROTEASE GLPG', 252371),
(421002, 'PTHR43066:SF22', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN', 252371),
(421003, 'PTHR43066:SF12', NULL, NULL, NULL, NULL, 'RHOMBOID DOMAIN-CONTAINING 2', 252371),
(421004, 'PTHR43066:SF23', NULL, NULL, NULL, NULL, 'UBA DOMAIN-CONTAINING PROTEIN', 252371),
(421005, 'PTHR43066:SF13', NULL, NULL, NULL, NULL, 'RHOMBOID DOMAIN-CONTAINING PROTEIN 2', 252371),
(421006, 'PTHR43066:SF24', NULL, NULL, NULL, NULL, 'SIMILAR TO MEMBRANE PROTEIN', 252371),
(421007, 'PTHR43066:SF25', NULL, NULL, NULL, NULL, 'RHOMBOID DOMAIN-CONTAINING PROTEIN', 252371),
(421008, 'PTHR43066:SF14', NULL, NULL, NULL, NULL, 'RHOMBOID-RELATED PROTEIN 4', 252371),
(421009, 'PTHR43066:SF15', NULL, NULL, NULL, NULL, 'RHOMBOID DOMAIN CONTAINING 1', 252371),
(421010, 'PTHR43066:SF16', NULL, NULL, NULL, NULL, 'RHOMBOID DOMAIN-CONTAINING PROTEIN 3', 252371),
(421011, 'PTHR43066:SF5', NULL, NULL, NULL, NULL, 'RHOMBOID-LIKE PROTEIN 11, CHLOROPLASTIC-RELATED', 252371),
(421012, 'PTHR43066:SF1', NULL, NULL, NULL, NULL, 'RHOMBOID PROTEIN 2', 252371),
(421013, 'PTHR10699:SF11', NULL, NULL, NULL, NULL, 'IGLOO, ISOFORM A', 252372),
(421014, 'PTHR10699', NULL, NULL, NULL, NULL, 'NEUROMODULIN', 252372),
(421015, 'PTHR10699:SF16', NULL, NULL, NULL, NULL, 'SPERM SURFACE PROTEIN SP17', 252372),
(421016, 'PTHR10699:SF15', NULL, NULL, NULL, NULL, 'NEUROMODULIN', 252372),
(421017, 'PTHR10699:SF26', NULL, NULL, NULL, NULL, 'IMMUNITY-RELATED GTPASE FAMILY, Q', 252372),
(421018, 'PTHR47856', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 20-LIKE', 252373),
(421019, 'PTHR47856:SF2', NULL, NULL, NULL, NULL, 'HMA DOMAIN-CONTAINING PROTEIN', 252373),
(421020, 'PTHR47627', NULL, NULL, NULL, NULL, 'RUBREDOXIN', 252374),
(421021, 'PTHR47627:SF1', NULL, NULL, NULL, NULL, 'RUBREDOXIN-1-RELATED', 252374),
(421022, 'PTHR33572:SF17', NULL, NULL, NULL, NULL, 'SEXUAL DEVELOPMENT REGULATOR VELC', 252375),
(421023, 'PTHR33572:SF16', NULL, NULL, NULL, NULL, 'SPORE DEVELOPMENT REGULATOR VOSA', 252375),
(421024, 'PTHR33572:SF15', NULL, NULL, NULL, NULL, 'CHROMOSOME 12, WHOLE GENOME SHOTGUN SEQUENCE', 252375),
(421025, 'PTHR33572', NULL, NULL, NULL, NULL, 'SPORE DEVELOPMENT REGULATOR VOSA', 252375),
(421026, 'PTHR33572:SF14', NULL, NULL, NULL, NULL, 'DEVELOPMENTAL AND SECONDARY METABOLISM REGULATOR VEA', 252375),
(421027, 'PTHR33572:SF3', NULL, NULL, NULL, NULL, 'VELVET COMPLEX SUBUNIT B', 252375),
(421028, 'PTHR31304:SF1', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 39', 252376),
(421029, 'PTHR31304:SF40', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 252376),
(421030, 'PTHR31304:SF62', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 252376),
(421031, 'PTHR31304:SF41', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 38-LIKE ISOFORM X1', 252376);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(421032, 'PTHR31304:SF63', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 42', 252376),
(421033, 'PTHR31304:SF60', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 40-LIKE', 252376),
(421034, 'PTHR31304:SF61', NULL, NULL, NULL, NULL, 'SEED SPECIFIC PROTEIN BN15D17A', 252376),
(421035, 'PTHR31304', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 38', 252376),
(421036, 'PTHR31304:SF9', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 40', 252376),
(421037, 'PTHR31304:SF56', NULL, NULL, NULL, NULL, 'LATERAL ORGAN BOUNDARIES (LOB) DOMAIN PROTEIN', 252376),
(421038, 'PTHR31304:SF31', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 252376),
(421039, 'PTHR31304:SF10', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 42', 252376),
(421040, 'PTHR31304:SF38', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 252376),
(421041, 'PTHR31304:SF35', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 37', 252376),
(421042, 'PTHR31304:SF2', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN 40, PUTATIVE, EXPRESSED-RELATED', 252376),
(421043, 'PTHR31304:SF58', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 38', 252376),
(421044, 'PTHR31304:SF52', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 252376),
(421045, 'PTHR31304:SF29', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 252376),
(421046, 'PTHR31304:SF66', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 252376),
(421047, 'PTHR31304:SF67', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 41', 252376),
(421048, 'PTHR31304:SF64', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 42', 252376),
(421049, 'PTHR31304:SF43', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN-RELATED', 252376),
(421050, 'PTHR31304:SF65', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN', 252376),
(421051, 'PTHR31304:SF68', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 38', 252376),
(421052, 'PTHR31304:SF69', NULL, NULL, NULL, NULL, 'OS07G0589000 PROTEIN', 252376),
(421053, 'PTHR31304:SF25', NULL, NULL, NULL, NULL, 'LOB DOMAIN PROTEIN', 252376),
(421054, 'PTHR38221:SF1', NULL, NULL, NULL, NULL, 'BNAA04G14260D PROTEIN', 252377),
(421055, 'PTHR38221', NULL, NULL, NULL, NULL, 'BNAA04G14260D PROTEIN', 252377),
(421056, 'PTHR11474:SF122', NULL, NULL, NULL, NULL, 'TYROSINASE', 252378),
(421057, 'PTHR11474:SF100', NULL, NULL, NULL, NULL, 'POLYPHENOL OXIDASE FAMILY PROTEIN-RELATED', 252378),
(421058, 'PTHR11474:SF126', NULL, NULL, NULL, NULL, 'TYROSINASE-LIKE PROTEIN TYR-1-RELATED', 252378),
(421059, 'PTHR11474:SF125', NULL, NULL, NULL, NULL, 'N-ACETYL-6-HYDROXYTRYPTOPHAN OXIDASE IVOB-RELATED', 252378),
(421060, 'PTHR11474:SF124', NULL, NULL, NULL, NULL, 'TYROSINASE', 252378),
(421061, 'PTHR11474:SF123', NULL, NULL, NULL, NULL, 'TYROSINASE_CU-BD DOMAIN-CONTAINING PROTEIN', 252378),
(421062, 'PTHR11474:SF108', NULL, NULL, NULL, NULL, 'TYROSINASE_CU-BD DOMAIN-CONTAINING PROTEIN', 252378),
(421063, 'PTHR11474:SF107', NULL, NULL, NULL, NULL, 'POLYPHENOL OXIDASE B, CHLOROPLASTIC', 252378),
(421064, 'PTHR11474:SF129', NULL, NULL, NULL, NULL, 'TYROSINASE_CU-BD DOMAIN-CONTAINING PROTEIN', 252378),
(421065, 'PTHR11474:SF128', NULL, NULL, NULL, NULL, 'AUREUSIDIN SYNTHASE-LIKE', 252378),
(421066, 'PTHR11474:SF127', NULL, NULL, NULL, NULL, 'TYROSINASE_CU-BD DOMAIN-CONTAINING PROTEIN', 252378),
(421067, 'PTHR11474:SF50', NULL, NULL, NULL, NULL, 'TYROSINASE_CU-BD DOMAIN-CONTAINING PROTEIN', 252378),
(421068, 'PTHR11474:SF94', NULL, NULL, NULL, NULL, 'POLYPHENOL OXIDASE, CHLOROPLASTIC-LIKE', 252378),
(421069, 'PTHR11474:SF95', NULL, NULL, NULL, NULL, 'POLYPHENOL OXIDASE, CHLOROPLASTIC', 252378),
(421070, 'PTHR11474:SF109', NULL, NULL, NULL, NULL, 'CATECHOL OXIDASE', 252378),
(421071, 'PTHR11474:SF92', NULL, NULL, NULL, NULL, 'POLYPHENOL OXIDASE F, CHLOROPLASTIC', 252378),
(421072, 'PTHR11474:SF97', NULL, NULL, NULL, NULL, '', 252378),
(421073, 'PTHR11474:SF98', NULL, NULL, NULL, NULL, 'CATECHOL OXIDASE', 252378),
(421074, 'PTHR11474:SF32', NULL, NULL, NULL, NULL, 'TYROSINASE', 252378),
(421075, 'PTHR11474:SF76', NULL, NULL, NULL, NULL, 'TYROSINASE', 252378);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(421076, 'PTHR11474', NULL, NULL, NULL, NULL, 'TYROSINASE FAMILY MEMBER', 252378),
(421077, 'PTHR11474:SF111', NULL, NULL, NULL, NULL, 'POLYPHENOL OXIDASE A, CHLOROPLASTIC', 252378),
(421078, 'PTHR11474:SF110', NULL, NULL, NULL, NULL, 'CATECHOL OXIDASE', 252378),
(421079, 'PTHR11474:SF131', NULL, NULL, NULL, NULL, 'TYROSINASE_CU-BD DOMAIN-CONTAINING PROTEIN', 252378),
(421080, 'PTHR11474:SF130', NULL, NULL, NULL, NULL, 'CATECHOL OXIDASE', 252378),
(421081, 'PTHR11474:SF114', NULL, NULL, NULL, NULL, 'TYROSINASE-LIKE PROTEIN TYR-3-RELATED', 252378),
(421082, 'PTHR11474:SF112', NULL, NULL, NULL, NULL, 'POLYPHENOL OXIDASE D, CHLOROPLASTIC', 252378),
(421083, 'PTHR11474:SF119', NULL, NULL, NULL, NULL, 'POLYPHENOL OXIDASE F PROTEIN-RELATED', 252378),
(421084, 'PTHR11474:SF117', NULL, NULL, NULL, NULL, 'POLYPHENOL OXIDASE CHLOROPLASTIC', 252378),
(421085, 'PTHR11474:SF116', NULL, NULL, NULL, NULL, 'TYROSINASE', 252378),
(421086, 'PTHR11474:SF83', NULL, NULL, NULL, NULL, 'TYROSINASE_CU-BD DOMAIN-CONTAINING PROTEIN', 252378),
(421087, 'PTHR11474:SF84', NULL, NULL, NULL, NULL, 'TYROSINASE', 252378),
(421088, 'PTHR11474:SF4', NULL, NULL, NULL, NULL, 'L-DOPACHROME TAUTOMERASE', 252378),
(421089, 'PTHR11474:SF3', NULL, NULL, NULL, NULL, '5,6-DIHYDROXYINDOLE-2-CARBOXYLIC ACID OXIDASE', 252378),
(421090, 'PTHR11474:SF86', NULL, NULL, NULL, NULL, 'TYROSINASE_CU-BD DOMAIN-CONTAINING PROTEIN', 252378),
(421091, 'PTHR11474:SF87', NULL, NULL, NULL, NULL, 'POLYPHENOL OXIDASE, CHLOROPLASTIC-LIKE', 252378),
(421092, 'PTHR11474:SF21', NULL, NULL, NULL, NULL, 'TYROSINASE', 252378),
(421093, 'PTHR43074:SF1', NULL, NULL, NULL, NULL, 'PKS_AT DOMAIN-CONTAINING PROTEIN', 252379),
(421094, 'PTHR43074', NULL, NULL, NULL, NULL, 'OMEGA-3 POLYUNSATURATED FATTY ACID SYNTHASE PFAB-RELATED', 252379),
(421095, 'PTHR37227:SF2', NULL, NULL, NULL, NULL, 'OS01G0219000 PROTEIN', 252380),
(421096, 'PTHR37227', NULL, NULL, NULL, NULL, 'OS01G0219000 PROTEIN', 252380),
(421097, 'PTHR15108', NULL, NULL, NULL, NULL, 'N-ACYLGLUCOSAMINE-2-EPIMERASE', 252381),
(421098, 'PTHR15108:SF0', NULL, NULL, NULL, NULL, 'N-ACYLGLUCOSAMINE 2-EPIMERASE', 252381),
(421099, 'PTHR38148:SF3', NULL, NULL, NULL, NULL, '', 252382),
(421100, 'PTHR38148', NULL, NULL, NULL, NULL, '', 252382),
(421101, 'PTHR15663:SF4', NULL, NULL, NULL, NULL, 'COMM DOMAIN-CONTAINING PROTEIN 9', 252383),
(421102, 'PTHR15663:SF6', NULL, NULL, NULL, NULL, 'COMM DOMAIN-CONTAINING PROTEIN-RELATED', 252383),
(421103, 'PTHR15663', NULL, NULL, NULL, NULL, 'COMM DOMAIN-CONTAINING PROTEIN 9', 252383),
(421104, 'PTHR47359:SF3', NULL, NULL, NULL, NULL, 'NLPC_P60 DOMAIN-CONTAINING PROTEIN', 252384),
(421105, 'PTHR47359', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN DL-ENDOPEPTIDASE CWLO', 252384),
(421106, 'PTHR46989', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 252385),
(421107, 'PTHR46989:SF3', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 252385),
(421108, 'PTHR10887:SF527', NULL, NULL, NULL, NULL, 'SAM DOMAIN-CONTAINING PROTEIN', 252386),
(421109, 'PTHR10887:SF449', NULL, NULL, NULL, NULL, '', 252386),
(421110, 'PTHR10887:SF526', NULL, NULL, NULL, NULL, 'HELICASE SEN1', 252386),
(421111, 'PTHR10887:SF525', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN', 252386),
(421112, 'PTHR10887:SF524', NULL, NULL, NULL, NULL, 'RNA HELICASE', 252386),
(421113, 'PTHR10887:SF523', NULL, NULL, NULL, NULL, 'RNA HELICASE MOV10L1', 252386),
(421114, 'PTHR10887:SF489', NULL, NULL, NULL, NULL, 'BNAC01G22370D PROTEIN', 252386),
(421115, 'PTHR10887:SF522', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN', 252386),
(421116, 'PTHR10887:SF445', NULL, NULL, NULL, NULL, 'FINGER AND HELICASE DOMAIN PROTEIN, PUTATIVE-RELATED', 252386),
(421117, 'PTHR10887:SF521', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN-RELATED', 252386),
(421118, 'PTHR10887:SF444', NULL, NULL, NULL, NULL, 'RNA HELICASE SDE3-RELATED', 252386),
(421119, 'PTHR10887:SF488', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE SUPERFAMILY PROTEIN', 252386);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(421120, 'PTHR10887:SF322', NULL, NULL, NULL, NULL, 'HELICASE MOV-10', 252386),
(421121, 'PTHR10887:SF520', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE SUPERFAMILY PROTEIN', 252386),
(421122, 'PTHR10887:SF442', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 252386),
(421123, 'PTHR10887:SF365', NULL, NULL, NULL, NULL, 'HELICASE WITH ZINC FINGER DOMAIN-RELATED', 252386),
(421124, 'PTHR10887:SF364', NULL, NULL, NULL, NULL, 'REGULATOR OF NONSENSE TRANSCRIPTS 1', 252386),
(421125, 'PTHR10887:SF483', NULL, NULL, NULL, NULL, 'OS11G0649000 PROTEIN', 252386),
(421126, 'PTHR10887:SF519', NULL, NULL, NULL, NULL, '', 252386),
(421127, 'PTHR10887:SF518', NULL, NULL, NULL, NULL, 'RNA HELICASE NONSENSE MRNA REDUCING FACTOR', 252386),
(421128, 'PTHR10887:SF517', NULL, NULL, NULL, NULL, 'RNA HELICASE NONSENSE MRNA REDUCING FACTOR', 252386),
(421129, 'PTHR10887:SF516', NULL, NULL, NULL, NULL, 'HELICASE WITH ZINC FINGER DOMAIN 2', 252386),
(421130, 'PTHR10887:SF515', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN', 252386),
(421131, 'PTHR10887:SF317', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE ECM32-RELATED', 252386),
(421132, 'PTHR10887:SF514', NULL, NULL, NULL, NULL, 'RNA HELICASE', 252386),
(421133, 'PTHR10887:SF513', NULL, NULL, NULL, NULL, '', 252386),
(421134, 'PTHR10887:SF435', NULL, NULL, NULL, NULL, 'OS02G0684150 PROTEIN', 252386),
(421135, 'PTHR10887:SF512', NULL, NULL, NULL, NULL, 'PHD DOMAIN-CONTAINING PROTEIN', 252386),
(421136, 'PTHR10887:SF479', NULL, NULL, NULL, NULL, '', 252386),
(421137, 'PTHR10887:SF478', NULL, NULL, NULL, NULL, 'BNAC01G39160D PROTEIN', 252386),
(421138, 'PTHR10887:SF511', NULL, NULL, NULL, NULL, 'NFX1-TYPE ZINC FINGER-CONTAINING PROTEIN 1', 252386),
(421139, 'PTHR10887:SF433', NULL, NULL, NULL, NULL, 'DNA REPLICATION ATP-DEPENDENT HELICASE/NUCLEASE DNA2', 252386),
(421140, 'PTHR10887:SF510', NULL, NULL, NULL, NULL, '', 252386),
(421141, 'PTHR10887:SF476', NULL, NULL, NULL, NULL, '', 252386),
(421142, 'PTHR10887:SF509', NULL, NULL, NULL, NULL, 'ZINC FINGER, NFX1-TYPE-CONTAINING 1, GENE 2', 252386),
(421143, 'PTHR10887:SF508', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN', 252386),
(421144, 'PTHR10887:SF5', NULL, NULL, NULL, NULL, 'RNA HELICASE AQUARIUS', 252386),
(421145, 'PTHR10887:SF505', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 252386),
(421146, 'PTHR10887:SF502', NULL, NULL, NULL, NULL, 'ENHANCED RNAI (RNA INTERFERENCE)', 252386),
(421147, 'PTHR10887:SF468', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN', 252386),
(421148, 'PTHR10887:SF341', NULL, NULL, NULL, NULL, 'NFX1-TYPE ZINC FINGER-CONTAINING PROTEIN 1 HOMOLOG', 252386),
(421149, 'PTHR10887:SF461', NULL, NULL, NULL, NULL, 'OS04G0582000 PROTEIN', 252386),
(421150, 'PTHR10887', NULL, NULL, NULL, NULL, 'DNA2/NAM7 HELICASE FAMILY', 252386),
(421151, 'PTHR10887:SF419', NULL, NULL, NULL, NULL, 'RNA HELICASE-RELATED', 252386),
(421152, 'PTHR10887:SF499', NULL, NULL, NULL, NULL, 'HELICASE ATP-BINDING DOMAIN-CONTAINING PROTEIN', 252386),
(421153, 'PTHR10887:SF497', NULL, NULL, NULL, NULL, '', 252386),
(421154, 'PTHR10887:SF496', NULL, NULL, NULL, NULL, 'UVRD-LIKE HELICASE ATP-BINDING DOMAIN-CONTAINING PROTEIN', 252386),
(421155, 'PTHR10887:SF495', NULL, NULL, NULL, NULL, 'HELICASE SENATAXIN-RELATED', 252386),
(421156, 'PTHR10887:SF490', NULL, NULL, NULL, NULL, 'PROTEIN ZGRF1', 252386),
(421157, 'PTHR31918:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 181', 252387),
(421158, 'PTHR31918', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 181', 252387),
(421159, 'PTHR14296', NULL, NULL, NULL, NULL, 'REMODELING AND SPACING FACTOR 1', 252388),
(421160, 'PTHR14296:SF8', NULL, NULL, NULL, NULL, 'BNAA09G44400D PROTEIN', 252388),
(421161, 'PTHR14296:SF7', NULL, NULL, NULL, NULL, 'DDT DOMAIN-CONTAINING PROTEIN DDR4', 252388),
(421162, 'PTHR14296:SF13', NULL, NULL, NULL, NULL, 'OS01G0180700 PROTEIN', 252388);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(421163, 'PTHR14296:SF12', NULL, NULL, NULL, NULL, 'DDT DOMAIN-CONTAINING PROTEIN DDR4 ISOFORM X1', 252388),
(421164, 'PTHR14296:SF14', NULL, NULL, NULL, NULL, 'DDT DOMAIN-CONTAINING PROTEIN-RELATED', 252388),
(421165, 'PTHR14296:SF11', NULL, NULL, NULL, NULL, 'DIKAR, ISOFORM F', 252388),
(421166, 'PTHR14296:SF10', NULL, NULL, NULL, NULL, 'BNAA06G13150D PROTEIN', 252388),
(421167, 'PTHR14296:SF3', NULL, NULL, NULL, NULL, 'REMODELING AND SPACING FACTOR 1', 252388),
(421168, 'PTHR38011', NULL, NULL, NULL, NULL, 'DIHYDROFOLATE REDUCTASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_8G06820)', 252389),
(421169, 'PTHR38011:SF8', NULL, NULL, NULL, NULL, '2,5-DIAMINO-6-(5-PHOSPHO-D-RIBOSYLAMINO)PYRIMIDIN-4(3H)-ONE REDUCTASE', 252389),
(421170, 'PTHR38011:SF7', NULL, NULL, NULL, NULL, '2,5-DIAMINO-6-RIBOSYLAMINO-4(3H)-PYRIMIDINONE 5''-PHOSPHATE REDUCTASE', 252389),
(421171, 'PTHR38011:SF2', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL DEAMINASE-REDUCTASE DOMAIN PROTEIN', 252389),
(421172, 'PTHR38011:SF11', NULL, NULL, NULL, NULL, '2,5-DIAMINO-6-(5-PHOSPHO-D-RIBOSYLAMINO)PYRIMIDIN-4(3H)-ONE REDUCTASE', 252389),
(421173, 'PTHR38011:SF12', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL DEAMINASE-REDUCTASE DOMAIN PROTEIN', 252389),
(421174, 'PTHR43340:SF1', NULL, NULL, NULL, NULL, 'HYPOXANTHINE PHOSPHORIBOSYLTRANSFERASE', 252390),
(421175, 'PTHR43340:SF10', NULL, NULL, NULL, NULL, 'HYPOXANTHINE PHOSPHORIBOSYLTRANSFERASE', 252390),
(421176, 'PTHR43340:SF6', NULL, NULL, NULL, NULL, 'HYPOXANTHINE-GUANINE PHOSPHORIBOSYLTRANSFERASE', 252390),
(421177, 'PTHR43340', NULL, NULL, NULL, NULL, 'HYPOXANTHINE-GUANINE PHOSPHORIBOSYLTRANSFERASE', 252390),
(421178, 'PTHR43340:SF5', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLTRANSFERASE DOMAIN-CONTAINING PROTEIN 1', 252390),
(421179, 'PTHR43340:SF8', NULL, NULL, NULL, NULL, 'HYPOXANTHINE PHOSPHORIBOSYLTRANSFERASE', 252390),
(421180, 'PTHR43340:SF7', NULL, NULL, NULL, NULL, 'HYPOXANTHINE PHOSPHORIBOSYLTRANSFERASE', 252390),
(421181, 'PTHR43340:SF9', NULL, NULL, NULL, NULL, 'HYPOXANTHINE PHOSPHORIBOSYLTRANSFERASE', 252390),
(421182, 'PTHR37162', NULL, NULL, NULL, NULL, 'HAT FAMILY DIMERISATION DOMAINCONTAINING PROTEIN-RELATED', 252391),
(421183, 'PTHR37162:SF1', NULL, NULL, NULL, NULL, 'DIMER_TNP_HAT DOMAIN-CONTAINING PROTEIN', 252391),
(421184, 'PTHR37162:SF9', NULL, NULL, NULL, NULL, 'DIMER_TNP_HAT DOMAIN-CONTAINING PROTEIN', 252391),
(421185, 'PTHR37162:SF6', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 252391),
(421186, 'PTHR37162:SF10', NULL, NULL, NULL, NULL, 'DUF4371 DOMAIN-CONTAINING PROTEIN', 252391),
(421187, 'PTHR38123:SF4', NULL, NULL, NULL, NULL, 'CELL WALL GALACTOMANNOPROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G00870)-RELATED', 252392),
(421188, 'PTHR38123:SF5', NULL, NULL, NULL, NULL, '', 252392),
(421189, 'PTHR38123', NULL, NULL, NULL, NULL, 'CELL WALL SERINE-THREONINE-RICH GALACTOMANNOPROTEIN MP1 (AFU_ORTHOLOGUE AFUA_4G03240)', 252392),
(421190, 'PTHR38123:SF3', NULL, NULL, NULL, NULL, '', 252392),
(421191, 'PTHR38123:SF1', NULL, NULL, NULL, NULL, 'WALL PROTEIN, PUTATIVE-RELATED', 252392),
(421192, 'PTHR38123:SF6', NULL, NULL, NULL, NULL, 'CELL WALL SERINE-THREONINE-RICH GALACTOMANNOPROTEIN MP1 (AFU_ORTHOLOGUE AFUA_4G03240)', 252392),
(421193, 'PTHR39559', NULL, NULL, NULL, NULL, '', 252393),
(421194, 'PTHR39559:SF1', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE KINASE/PHOSPHATASE', 252393),
(421195, 'PTHR23105:SF165', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L7A', 252394),
(421196, 'PTHR23105:SF203', NULL, NULL, NULL, NULL, 'PROTEASOME-INTERACTING PROTEIN CIC1', 252394),
(421197, 'PTHR23105:SF169', NULL, NULL, NULL, NULL, 'RIBONUCLOPROTEIN', 252394),
(421198, 'PTHR23105:SF202', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN', 252394),
(421199, 'PTHR23105:SF125', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN', 252394),
(421200, 'PTHR23105:SF168', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L7AE DOMAIN-CONTAINING PROTEIN', 252394),
(421201, 'PTHR23105:SF201', NULL, NULL, NULL, NULL, 'BNAA02G05660D PROTEIN', 252394),
(421202, 'PTHR23105:SF200', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN', 252394);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(421203, 'PTHR23105:SF54', NULL, NULL, NULL, NULL, 'H/ACA RIBONUCLEOPROTEIN COMPLEX SUBUNIT 2', 252394),
(421204, 'PTHR23105', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L7AE FAMILY MEMBER', 252394),
(421205, 'PTHR23105:SF161', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L7A', 252394),
(421206, 'PTHR23105:SF207', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L10A-2', 252394),
(421207, 'PTHR23105:SF206', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L7A', 252394),
(421208, 'PTHR23105:SF129', NULL, NULL, NULL, NULL, 'H/ACA RIBONUCLEOPROTEIN COMPLEX SUBUNIT 2', 252394),
(421209, 'PTHR23105:SF128', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L7A', 252394),
(421210, 'PTHR23105:SF205', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L7A', 252394),
(421211, 'PTHR23105:SF204', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L1, 2-LAYER ALPHA/BETA-SANDWICH-RELATED', 252394),
(421212, 'PTHR23105:SF208', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN', 252394),
(421213, 'PTHR23105:SF133', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L1P/L10E FAMILY', 252394),
(421214, 'PTHR23105:SF132', NULL, NULL, NULL, NULL, 'RIBOSOMAL L1 DOMAIN-CONTAINING PROTEIN 1-LIKE', 252394),
(421215, 'PTHR23105:SF130', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L7A', 252394),
(421216, 'PTHR23105:SF137', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L7A', 252394),
(421217, 'PTHR23105:SF136', NULL, NULL, NULL, NULL, 'RIBONUCLOPROTEIN', 252394),
(421218, 'PTHR23105:SF173', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L7AE DOMAIN-CONTAINING PROTEIN', 252394),
(421219, 'PTHR23105:SF170', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L7AE/L30E/S12E/GADD45 FAMILY PROTEIN', 252394),
(421220, 'PTHR23105:SF188', NULL, NULL, NULL, NULL, '', 252394),
(421221, 'PTHR23105:SF187', NULL, NULL, NULL, NULL, 'RIBONUCLOPROTEIN', 252394),
(421222, 'PTHR23105:SF142', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN', 252394),
(421223, 'PTHR23105:SF186', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L10A', 252394),
(421224, 'PTHR23105:SF1', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L7A', 252394),
(421225, 'PTHR23105:SF189', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L7A', 252394),
(421226, 'PTHR23105:SF38', NULL, NULL, NULL, NULL, 'NHP2-LIKE PROTEIN 1', 252394),
(421227, 'PTHR23105:SF101', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L10A', 252394),
(421228, 'PTHR23105:SF31', NULL, NULL, NULL, NULL, 'RIBOSOMAL L1 DOMAIN-CONTAINING PROTEIN 1', 252394),
(421229, 'PTHR23105:SF180', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L10A-3', 252394),
(421230, 'PTHR23105:SF184', NULL, NULL, NULL, NULL, 'RIBONUCLOPROTEIN', 252394),
(421231, 'PTHR23105:SF183', NULL, NULL, NULL, NULL, 'RIBONUCLOPROTEIN', 252394),
(421232, 'PTHR23105:SF181', NULL, NULL, NULL, NULL, 'SNRNP CORE PROTEIN D2', 252394),
(421233, 'PTHR23105:SF105', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN', 252394),
(421234, 'PTHR23105:SF199', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L7A', 252394),
(421235, 'PTHR23105:SF111', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L7A', 252394),
(421236, 'PTHR23105:SF198', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L10A-1', 252394),
(421237, 'PTHR23105:SF197', NULL, NULL, NULL, NULL, 'H/ACA RIBONUCLEOPROTEIN COMPLEX SUBUNIT 2-LIKE PROTEIN', 252394),
(421238, 'PTHR23105:SF196', NULL, NULL, NULL, NULL, '', 252394),
(421239, 'PTHR23105:SF114', NULL, NULL, NULL, NULL, '', 252394),
(421240, 'PTHR23105:SF191', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L7A', 252394),
(421241, 'PTHR23105:SF190', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L7A', 252394),
(421242, 'PTHR23105:SF195', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L7A', 252394),
(421243, 'PTHR23105:SF194', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L7A', 252394),
(421244, 'PTHR23105:SF193', NULL, NULL, NULL, NULL, 'BNAC09G36540D PROTEIN', 252394),
(421245, 'PTHR23105:SF192', NULL, NULL, NULL, NULL, 'RIBONUCLOPROTEIN', 252394),
(421246, 'PTHR23105:SF118', NULL, NULL, NULL, NULL, 'RIBOSOMAL_L7AE DOMAIN-CONTAINING PROTEIN', 252394),
(421247, 'PTHR35802', NULL, NULL, NULL, NULL, 'PROTEASE SYNTHASE AND SPORULATION PROTEIN PAI 2', 252395);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(421248, 'PTHR35802:SF1', NULL, NULL, NULL, NULL, 'PROTEASE SYNTHASE AND SPORULATION PROTEIN PAI 2', 252395),
(421249, 'PTHR36014:SF1', NULL, NULL, NULL, NULL, 'OS03G0176700 PROTEIN', 252396),
(421250, 'PTHR36014', NULL, NULL, NULL, NULL, 'OS03G0176600 PROTEIN', 252396),
(421251, 'PTHR33646:SF6', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 252397),
(421252, 'PTHR33646:SF16', NULL, NULL, NULL, NULL, '', 252397),
(421253, 'PTHR33646:SF19', NULL, NULL, NULL, NULL, 'GB|AAF00631.1', 252397),
(421254, 'PTHR33646:SF18', NULL, NULL, NULL, NULL, 'BNAA10G16690D PROTEIN', 252397),
(421255, 'PTHR33646:SF9', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 252397),
(421256, 'PTHR33646:SF8', NULL, NULL, NULL, NULL, 'OS07G0204100 PROTEIN', 252397),
(421257, 'PTHR33646:SF20', NULL, NULL, NULL, NULL, 'BNAA02G03980D PROTEIN', 252397),
(421258, 'PTHR33646:SF10', NULL, NULL, NULL, NULL, '', 252397),
(421259, 'PTHR33646:SF21', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 252397),
(421260, 'PTHR33646:SF13', NULL, NULL, NULL, NULL, 'BNACNNG51420D PROTEIN', 252397),
(421261, 'PTHR33646', NULL, NULL, NULL, NULL, 'GB|AAF00631.1', 252397),
(421262, 'PTHR33646:SF2', NULL, NULL, NULL, NULL, 'F20H23.8 PROTEIN', 252397),
(421263, 'PTHR33646:SF1', NULL, NULL, NULL, NULL, 'OS01G0884700 PROTEIN', 252397),
(421264, 'PTHR33826:SF11', NULL, NULL, NULL, NULL, '', 252398),
(421265, 'PTHR33826:SF4', NULL, NULL, NULL, NULL, 'F20B24.21', 252398),
(421266, 'PTHR33826', NULL, NULL, NULL, NULL, 'F20B24.21', 252398),
(421267, 'PTHR33826:SF1', NULL, NULL, NULL, NULL, 'OS02G0768000 PROTEIN', 252398),
(421268, 'PTHR33826:SF2', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 252398),
(421269, 'PTHR33826:SF9', NULL, NULL, NULL, NULL, 'OS05G0373500 PROTEIN', 252398),
(421270, 'PTHR33826:SF7', NULL, NULL, NULL, NULL, '', 252398),
(421271, 'PTHR33826:SF12', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN-SORTING PROTEIN BRO1-LIKE', 252398),
(421272, 'PTHR33826:SF8', NULL, NULL, NULL, NULL, 'BNAA01G31410D PROTEIN', 252398),
(421273, 'PTHR43571', NULL, NULL, NULL, NULL, 'NADP-SPECIFIC GLUTAMATE DEHYDROGENASE 1-RELATED', 252399),
(421274, 'PTHR43571:SF1', NULL, NULL, NULL, NULL, 'NADP-SPECIFIC GLUTAMATE DEHYDROGENASE 1-RELATED', 252399),
(421275, 'PTHR43571:SF2', NULL, NULL, NULL, NULL, 'ELFV_DEHYDROG DOMAIN-CONTAINING PROTEIN', 252399),
(421276, 'PTHR30033:SF1', NULL, NULL, NULL, NULL, 'FLAGELLAR HOOK-ASSOCIATED PROTEIN 1', 252400),
(421277, 'PTHR30033', NULL, NULL, NULL, NULL, 'FLAGELLAR HOOK-ASSOCIATED PROTEIN 1', 252400),
(421278, 'PTHR47823:SF9', NULL, NULL, NULL, NULL, 'K+-CHANNEL ERG AND RELATED PROTEINS', 252401),
(421279, 'PTHR47823', NULL, NULL, NULL, NULL, 'ION_TRANS DOMAIN-CONTAINING PROTEIN', 252401),
(421280, 'PTHR47823:SF10', NULL, NULL, NULL, NULL, 'SLL1924 PROTEIN', 252401),
(421281, 'PTHR43040', NULL, NULL, NULL, NULL, 'RIBONUCLEASE D', 252402),
(421282, 'PTHR43040:SF1', NULL, NULL, NULL, NULL, 'RIBONUCLEASE D', 252402),
(421283, 'PTHR24207', NULL, NULL, NULL, NULL, 'ZYX102 PROTEIN', 252403),
(421284, 'PTHR24207:SF2', NULL, NULL, NULL, NULL, 'ZYX102 PROTEIN', 252403),
(421285, 'PTHR24207:SF0', NULL, NULL, NULL, NULL, 'LIPOMA-PREFERRED PARTNER', 252403),
(421286, 'PTHR24207:SF1', NULL, NULL, NULL, NULL, 'FILAMIN-BINDING LIM PROTEIN 1', 252403),
(421287, 'PTHR36182', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G10930)-RELATED', 252404),
(421288, 'PTHR36182:SF2', NULL, NULL, NULL, NULL, '', 252404),
(421289, 'PTHR36182:SF1', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G10930)-RELATED', 252404),
(421290, 'PTHR37928', NULL, NULL, NULL, NULL, 'CFEM DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_6G14090)', 252405),
(421291, 'PTHR37928:SF1', NULL, NULL, NULL, NULL, 'CFEM DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_6G14090)', 252405),
(421292, 'PTHR37928:SF2', NULL, NULL, NULL, NULL, 'GPI ANCHORED CFEM DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_6G10580)', 252405),
(421293, 'PTHR36395', NULL, NULL, NULL, NULL, 'RING-H2 ZINC FINGER PROTEIN', 252406),
(421294, 'PTHR36395:SF1', NULL, NULL, NULL, NULL, 'RING-H2 ZINC FINGER PROTEIN', 252406);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(421295, 'PTHR39962:SF1', NULL, NULL, NULL, NULL, 'BLL4848 PROTEIN', 252407),
(421296, 'PTHR39962', NULL, NULL, NULL, NULL, 'BLL4848 PROTEIN', 252407),
(421297, 'PTHR22437', NULL, NULL, NULL, NULL, 'WINGED HELIX DOMAIN-CONTAINING PROTEIN', 252408),
(421298, 'PTHR22437:SF2', NULL, NULL, NULL, NULL, 'STORKHEAD-BOX PROTEIN 2', 252408),
(421299, 'PTHR22437:SF1', NULL, NULL, NULL, NULL, 'STORKHEAD-BOX PROTEIN 1', 252408),
(421300, 'PTHR22437:SF0', NULL, NULL, NULL, NULL, 'FI21431P1', 252408),
(421301, 'PTHR47725', NULL, NULL, NULL, NULL, 'OS03G0364000 PROTEIN', 252409),
(421302, 'PTHR47725:SF2', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 252409),
(421303, 'PTHR47725:SF4', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 252409),
(421304, 'PTHR28583', NULL, NULL, NULL, NULL, 'ACID AMIDASE', 252410),
(421305, 'PTHR28583:SF1', NULL, NULL, NULL, NULL, 'ACID CERAMIDASE', 252410),
(421306, 'PTHR28583:SF3', NULL, NULL, NULL, NULL, 'ACID CERAMIDASE-RELATED', 252410),
(421307, 'PTHR28583:SF4', NULL, NULL, NULL, NULL, 'N-ACYLETHANOLAMINE-HYDROLYZING ACID AMIDASE', 252410),
(421308, 'PTHR33998', NULL, NULL, NULL, NULL, '', 252411),
(421309, 'PTHR33998:SF2', NULL, NULL, NULL, NULL, '', 252411),
(421310, 'PTHR33998:SF6', NULL, NULL, NULL, NULL, '', 252411),
(421311, 'PTHR14233:SF18', NULL, NULL, NULL, NULL, 'OS05G0444300 PROTEIN', 252412),
(421312, 'PTHR14233:SF19', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 35 MEMBER SLC35F1/F2/F6-RELATED', 252412),
(421313, 'PTHR14233:SF10', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 35 MEMBER F1', 252412),
(421314, 'PTHR14233:SF21', NULL, NULL, NULL, NULL, '', 252412),
(421315, 'PTHR14233:SF20', NULL, NULL, NULL, NULL, 'OS09G0513200 PROTEIN', 252412),
(421316, 'PTHR14233:SF4', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 35 PROTEIN (DUF914)', 252412),
(421317, 'PTHR14233:SF12', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 35 MEMBER F2', 252412),
(421318, 'PTHR14233:SF22', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 35 MEMBER SLC35F1/F2/F6-RELATED', 252412),
(421319, 'PTHR14233:SF11', NULL, NULL, NULL, NULL, 'CRT HOMOLOG 1-RELATED', 252412),
(421320, 'PTHR14233:SF24', NULL, NULL, NULL, NULL, 'ANTHOCYANIN-RELATED MEMBRANE PROTEIN 2-RELATED', 252412),
(421321, 'PTHR14233', NULL, NULL, NULL, NULL, 'DUF914-RELATED', 252412),
(421322, 'PTHR48221:SF2', NULL, NULL, NULL, NULL, 'ACYL-COA SYNTHETASE FAMILY PROTEIN', 252413),
(421323, 'PTHR48221', NULL, NULL, NULL, NULL, 'ACYL-COA SYNTHETASE FAMILY PROTEIN', 252413),
(421324, 'PTHR35447', NULL, NULL, NULL, NULL, 'BH3-INTERACTING DOMAIN DEATH AGONIST', 252414),
(421325, 'PTHR35447:SF1', NULL, NULL, NULL, NULL, 'BH3-INTERACTING DOMAIN DEATH AGONIST', 252414),
(421326, 'PTHR36459:SF1', NULL, NULL, NULL, NULL, 'FA_DESATURASE DOMAIN-CONTAINING PROTEIN-RELATED', 252415),
(421327, 'PTHR36459', NULL, NULL, NULL, NULL, 'ORF', 252415),
(421328, 'PTHR13115:SF12', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 19', 252416),
(421329, 'PTHR13115:SF22', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 19', 252416),
(421330, 'PTHR13115:SF14', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 19', 252416),
(421331, 'PTHR13115:SF24', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 44-LIKE', 252416),
(421332, 'PTHR13115:SF27', NULL, NULL, NULL, NULL, 'SWIB/MDM2 DOMAIN, GYF DOMAIN, PLUS-3 DOMAIN, ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 252416),
(421333, 'PTHR13115:SF15', NULL, NULL, NULL, NULL, 'PLUS-3 DOMAIN PROTEIN', 252416),
(421334, 'PTHR13115:SF26', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 252416),
(421335, 'PTHR13115:SF28', NULL, NULL, NULL, NULL, 'BNAA06G36630D PROTEIN', 252416),
(421336, 'PTHR13115:SF21', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE-RELATED', 252416),
(421337, 'PTHR13115:SF8', NULL, NULL, NULL, NULL, 'RNA POLYMERASE-ASSOCIATED PROTEIN RTF1 HOMOLOG', 252416),
(421338, 'PTHR13115:SF20', NULL, NULL, NULL, NULL, 'BNAC08G48800D PROTEIN', 252416),
(421339, 'PTHR13115', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252416);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(421340, 'PTHR13115:SF19', NULL, NULL, NULL, NULL, 'BNAC07G32070D PROTEIN', 252416),
(421341, 'PTHR37808', NULL, NULL, NULL, NULL, 'SPORE GERMINATION PROTEIN-LIKE PROTEIN YDZR-RELATED', 252417),
(421342, 'PTHR37808:SF3', NULL, NULL, NULL, NULL, 'SPORE GERMINATION PROTEIN GERPA-RELATED', 252417),
(421343, 'PTHR37808:SF1', NULL, NULL, NULL, NULL, 'SPORE GERMINATION PROTEIN-LIKE PROTEIN YDZR', 252417),
(421344, 'PTHR48302:SF2', NULL, NULL, NULL, NULL, 'DUF1985 DOMAIN-CONTAINING PROTEIN', 252418),
(421345, 'PTHR48302:SF1', NULL, NULL, NULL, NULL, 'ULP1 PROTEASE FAMILY, C-TERMINAL CATALYTIC DOMAIN CONTAINING PROTEIN', 252418),
(421346, 'PTHR48302', NULL, NULL, NULL, NULL, 'ULP1 PROTEASE FAMILY, C-TERMINAL CATALYTIC DOMAIN CONTAINING PROTEIN', 252418),
(421347, 'PTHR31046:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 265', 252419),
(421348, 'PTHR31046:SF0', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 121', 252419),
(421349, 'PTHR31046:SF1', NULL, NULL, NULL, NULL, '', 252419),
(421350, 'PTHR31046:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 264', 252419),
(421351, 'PTHR31046', NULL, NULL, NULL, NULL, '', 252419),
(421352, 'PTHR14787:SF3', NULL, NULL, NULL, NULL, 'ATPASE PAAT', 252420),
(421353, 'PTHR14787:SF2', NULL, NULL, NULL, NULL, '', 252420),
(421354, 'PTHR14787:SF1', NULL, NULL, NULL, NULL, 'ATPASE PAAT', 252420),
(421355, 'PTHR14787', NULL, NULL, NULL, NULL, 'C10ORF188 FAMILY MEMBER', 252420),
(421356, 'PTHR13475:SF5', NULL, NULL, NULL, NULL, 'TUBULIN TYROSINE LIGASE LIKE 6', 252421),
(421357, 'PTHR13475:SF4', NULL, NULL, NULL, NULL, 'NEUGRIN', 252421),
(421358, 'PTHR13475:SF3', NULL, NULL, NULL, NULL, 'NEUGRIN', 252421),
(421359, 'PTHR13475', NULL, NULL, NULL, NULL, 'NEUGRIN', 252421),
(421360, 'PTHR34487:SF1', NULL, NULL, NULL, NULL, '', 252422),
(421361, 'PTHR34487', NULL, NULL, NULL, NULL, '', 252422),
(421362, 'PTHR31616:SF11', NULL, NULL, NULL, NULL, 'GLUCOAMYLASE, INTRACELLULAR SPORULATION-SPECIFIC', 252423),
(421363, 'PTHR31616:SF0', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_15 DOMAIN-CONTAINING PROTEIN', 252423),
(421364, 'PTHR31616:SF10', NULL, NULL, NULL, NULL, 'TREHALASE', 252423),
(421365, 'PTHR31616', NULL, NULL, NULL, NULL, 'TREHALASE', 252423),
(421366, 'PTHR31616:SF2', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_15 DOMAIN-CONTAINING PROTEIN', 252423),
(421367, 'PTHR31616:SF9', NULL, NULL, NULL, NULL, '1,4-ALPHA-D-GLUCAN GLUCOHYDROLASE', 252423),
(421368, 'PTHR21683:SF9', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 73', 252424),
(421369, 'PTHR21683:SF7', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 38', 252424),
(421370, 'PTHR21683:SF8', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 42', 252424),
(421371, 'PTHR21683:SF5', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 100', 252424),
(421372, 'PTHR21683:SF13', NULL, NULL, NULL, NULL, 'DUF4200 DOMAIN-CONTAINING PROTEIN', 252424),
(421373, 'PTHR21683:SF3', NULL, NULL, NULL, NULL, 'DUF4200 DOMAIN-CONTAINING PROTEIN', 252424),
(421374, 'PTHR21683', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252424),
(421375, 'PTHR21683:SF2', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN CONTAINING 197', 252424),
(421376, 'PTHR22597:SF17', NULL, NULL, NULL, NULL, 'VEFS-BOX DOMAIN-CONTAINING PROTEIN', 252425),
(421377, 'PTHR22597:SF16', NULL, NULL, NULL, NULL, 'EMBRYONIC FLOWER 2', 252425),
(421378, 'PTHR22597:SF24', NULL, NULL, NULL, NULL, 'POLYCOMB GROUP PROTEIN FERTILIZATION-INDEPENDENT SEED 2', 252425),
(421379, 'PTHR22597:SF14', NULL, NULL, NULL, NULL, 'VEFS-BOX DOMAIN-CONTAINING PROTEIN', 252425),
(421380, 'PTHR22597:SF22', NULL, NULL, NULL, NULL, 'POLYCOMB GROUP PROTEIN EMBRYONIC FLOWER 2-RELATED', 252425),
(421381, 'PTHR22597:SF12', NULL, NULL, NULL, NULL, 'POLYCOMB GROUP PROTEIN VERNALIZATION 2', 252425),
(421382, 'PTHR22597:SF23', NULL, NULL, NULL, NULL, 'VEFS-BOX DOMAIN-CONTAINING PROTEIN', 252425),
(421383, 'PTHR22597:SF20', NULL, NULL, NULL, NULL, 'VEFS-BOX DOMAIN-CONTAINING PROTEIN', 252425),
(421384, 'PTHR22597:SF21', NULL, NULL, NULL, NULL, 'VEFS-BOX DOMAIN-CONTAINING PROTEIN', 252425);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(421385, 'PTHR22597', NULL, NULL, NULL, NULL, 'POLYCOMB GROUP PROTEIN', 252425),
(421386, 'PTHR22597:SF5', NULL, NULL, NULL, NULL, 'LOCALIZATION PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G10600)-RELATED', 252425),
(421387, 'PTHR22597:SF3', NULL, NULL, NULL, NULL, 'CHROMATIN STRUCTURE-REMODELING COMPLEX SUBUNIT RSC7', 252425),
(421388, 'PTHR22597:SF0', NULL, NULL, NULL, NULL, 'POLYCOMB PROTEIN SUZ12', 252425),
(421389, 'PTHR22597:SF19', NULL, NULL, NULL, NULL, 'BNAA03G13220D PROTEIN', 252425),
(421390, 'PTHR35663:SF1', NULL, NULL, NULL, NULL, 'TESTIS DEVELOPMENT-RELATED PROTEIN', 252426),
(421391, 'PTHR35663', NULL, NULL, NULL, NULL, 'TESTIS DEVELOPMENT-RELATED PROTEIN-RELATED', 252426),
(421392, 'PTHR35663:SF3', NULL, NULL, NULL, NULL, 'GENE, 30191-RELATED', 252426),
(421393, 'PTHR12242:SF28', NULL, NULL, NULL, NULL, '', 252427),
(421394, 'PTHR12242:SF29', NULL, NULL, NULL, NULL, 'PLANT/MGF10-16 PROTEIN', 252427),
(421395, 'PTHR12242:SF26', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 252427),
(421396, 'PTHR12242:SF37', NULL, NULL, NULL, NULL, 'BNAA08G25610D PROTEIN', 252427),
(421397, 'PTHR12242:SF38', NULL, NULL, NULL, NULL, 'PROTEIN ROLLING STONE-LIKE', 252427),
(421398, 'PTHR12242:SF42', NULL, NULL, NULL, NULL, 'OS01G0295600 PROTEIN', 252427),
(421399, 'PTHR12242:SF10', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 252427),
(421400, 'PTHR12242:SF43', NULL, NULL, NULL, NULL, '', 252427),
(421401, 'PTHR12242:SF32', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 252427),
(421402, 'PTHR12242:SF6', NULL, NULL, NULL, NULL, 'PROTEIN ROLLING PROTEIN', 252427),
(421403, 'PTHR12242:SF40', NULL, NULL, NULL, NULL, 'BNAA03G53740D PROTEIN', 252427),
(421404, 'PTHR12242:SF35', NULL, NULL, NULL, NULL, '', 252427),
(421405, 'PTHR12242:SF9', NULL, NULL, NULL, NULL, 'OS01G0171800 PROTEIN', 252427),
(421406, 'PTHR12242:SF25', NULL, NULL, NULL, NULL, '', 252427),
(421407, 'PTHR12242:SF33', NULL, NULL, NULL, NULL, 'BNAC06G31610D PROTEIN', 252427),
(421408, 'PTHR12242:SF22', NULL, NULL, NULL, NULL, 'OS02G0130600 PROTEIN', 252427),
(421409, 'PTHR12242:SF44', NULL, NULL, NULL, NULL, '', 252427),
(421410, 'PTHR12242:SF34', NULL, NULL, NULL, NULL, '', 252427),
(421411, 'PTHR12242', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252427),
(421412, 'PTHR12242:SF1', NULL, NULL, NULL, NULL, 'IP08657P-RELATED', 252427),
(421413, 'PTHR21551:SF29', NULL, NULL, NULL, NULL, 'PROTEIN PAT1 HOMOLOG 1-LIKE', 252428),
(421414, 'PTHR21551:SF18', NULL, NULL, NULL, NULL, 'PROTEIN PAT1 HOMOLOG 1-LIKE', 252428),
(421415, 'PTHR21551:SF9', NULL, NULL, NULL, NULL, 'OS02G0295700 PROTEIN', 252428),
(421416, 'PTHR21551', NULL, NULL, NULL, NULL, 'TOPOISOMERASE II-ASSOCIATED PROTEIN PAT1', 252428),
(421417, 'PTHR21551:SF0', NULL, NULL, NULL, NULL, 'PROTEIN ASSOCIATED WITH TOPO II RELATED-1, ISOFORM A', 252428),
(421418, 'PTHR21551:SF30', NULL, NULL, NULL, NULL, 'TOPOISOMERASE II-ASSOCIATED PROTEIN PAT1-RELATED', 252428),
(421419, 'PTHR21551:SF25', NULL, NULL, NULL, NULL, 'TOPOISOMERASE II-ASSOCIATED PROTEIN PAT1', 252428),
(421420, 'PTHR21551:SF15', NULL, NULL, NULL, NULL, 'TOPOISOMERASE II-ASSOCIATED PROTEIN PAT1', 252428),
(421421, 'PTHR21551:SF16', NULL, NULL, NULL, NULL, 'LOW QUALITY PROTEIN: PROTEIN PAT1 HOMOLOG 1-LIKE', 252428),
(421422, 'PTHR21551:SF28', NULL, NULL, NULL, NULL, 'OS01G0769000 PROTEIN', 252428),
(421423, 'PTHR21551:SF10', NULL, NULL, NULL, NULL, '', 252428),
(421424, 'PTHR21551:SF2', NULL, NULL, NULL, NULL, 'PROTEIN PAT1 HOMOLOG 1', 252428),
(421425, 'PTHR21551:SF11', NULL, NULL, NULL, NULL, 'PROTEIN PAT1 HOMOLOG 1', 252428),
(421426, 'PTHR21551:SF22', NULL, NULL, NULL, NULL, 'BNAC05G12690D PROTEIN', 252428),
(421427, 'PTHR21551:SF23', NULL, NULL, NULL, NULL, 'BNAA01G24760D PROTEIN', 252428),
(421428, 'PTHR21551:SF3', NULL, NULL, NULL, NULL, 'PROTEIN PAT1 HOMOLOG 2', 252428),
(421429, 'PTHR21551:SF24', NULL, NULL, NULL, NULL, 'PROTEIN PAT1 HOMOLOG 2', 252428),
(421430, 'PTHR13976:SF37', NULL, NULL, NULL, NULL, 'EPITHELIAL SPLICING REGULATORY PROTEIN 1', 252429),
(421431, 'PTHR13976:SF25', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN FUSILLI', 252429);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(421432, 'PTHR13976:SF36', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN H3', 252429),
(421433, 'PTHR13976:SF28', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 12B', 252429),
(421434, 'PTHR13976:SF88', NULL, NULL, NULL, NULL, 'FI22004P1', 252429),
(421435, 'PTHR13976:SF33', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN H2', 252429),
(421436, 'PTHR13976:SF32', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN F', 252429),
(421437, 'PTHR13976:SF87', NULL, NULL, NULL, NULL, 'RNA-BINDING MOTIF PROTEIN 12-RELATED', 252429),
(421438, 'PTHR13976:SF76', NULL, NULL, NULL, NULL, 'AT27789P', 252429),
(421439, 'PTHR13976:SF79', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 252429),
(421440, 'PTHR13976:SF84', NULL, NULL, NULL, NULL, 'HNRNP F HOMOLOG', 252429),
(421441, 'PTHR13976:SF83', NULL, NULL, NULL, NULL, 'RNA BINDING MOTIF PROTEIN 12B', 252429),
(421442, 'PTHR13976:SF31', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 12', 252429),
(421443, 'PTHR13976:SF42', NULL, NULL, NULL, NULL, 'G-RICH SEQUENCE FACTOR 1', 252429),
(421444, 'PTHR13976:SF86', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 252429),
(421445, 'PTHR13976:SF30', NULL, NULL, NULL, NULL, 'EPITHELIAL SPLICING REGULATORY PROTEIN 2', 252429),
(421446, 'PTHR13976:SF85', NULL, NULL, NULL, NULL, '', 252429),
(421447, 'PTHR13976:SF74', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 252429),
(421448, 'PTHR13976:SF71', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', 252429),
(421449, 'PTHR13976:SF60', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN H', 252429),
(421450, 'PTHR13976', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN-RELATED', 252429),
(421451, 'PTHR21020', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252430),
(421452, 'PTHR21020:SF0', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 800', 252430),
(421453, 'PTHR35101:SF11', NULL, NULL, NULL, NULL, 'OS08G0192100 PROTEIN', 252431),
(421454, 'PTHR35101:SF15', NULL, NULL, NULL, NULL, '', 252431),
(421455, 'PTHR35101:SF14', NULL, NULL, NULL, NULL, '', 252431),
(421456, 'PTHR35101:SF12', NULL, NULL, NULL, NULL, 'OS02G0162600 PROTEIN', 252431),
(421457, 'PTHR35101', NULL, NULL, NULL, NULL, 'OS02G0162600 PROTEIN', 252431),
(421458, 'PTHR35101:SF18', NULL, NULL, NULL, NULL, 'OS04G0623200 PROTEIN', 252431),
(421459, 'PTHR35101:SF17', NULL, NULL, NULL, NULL, 'BNAA03G58560D PROTEIN', 252431),
(421460, 'PTHR35101:SF16', NULL, NULL, NULL, NULL, '', 252431),
(421461, 'PTHR40763:SF5', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 252432),
(421462, 'PTHR40763:SF4', NULL, NULL, NULL, NULL, 'DUF2154 DOMAIN-CONTAINING PROTEIN', 252432),
(421463, 'PTHR40763', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', 252432),
(421464, 'PTHR45752:SF140', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 252433),
(421465, 'PTHR45752:SF184', NULL, NULL, NULL, NULL, 'NB-ARC-RELATED', 252433),
(421466, 'PTHR45752:SF80', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEATS AND CALPONIN HOMOLOGY DOMAIN CONTAINING 4', 252433),
(421467, 'PTHR45752:SF183', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT KINASE 1', 252433),
(421468, 'PTHR45752:SF186', NULL, NULL, NULL, NULL, 'ROC DOMAIN-CONTAINING PROTEIN', 252433),
(421469, 'PTHR45752:SF185', NULL, NULL, NULL, NULL, 'BNAA03G53310D PROTEIN', 252433),
(421470, 'PTHR45752:SF180', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT (LRR) FAMILY PROTEIN-RELATED', 252433),
(421471, 'PTHR45752:SF40', NULL, NULL, NULL, NULL, 'VOLUME-REGULATED ANION CHANNEL SUBUNIT LRRC8B', 252433),
(421472, 'PTHR45752:SF41', NULL, NULL, NULL, NULL, 'PLANT INTRACELLULAR RAS-GROUP-RELATED LRR PROTEIN 8', 252433),
(421473, 'PTHR45752:SF182', NULL, NULL, NULL, NULL, '', 252433),
(421474, 'PTHR45752:SF181', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE ISOFORM 1-RELATED', 252433),
(421475, 'PTHR45752:SF44', NULL, NULL, NULL, NULL, 'P53-INDUCED DEATH DOMAIN-CONTAINING PROTEIN 1', 252433),
(421476, 'PTHR45752:SF103', NULL, NULL, NULL, NULL, 'PLANT INTRACELLULAR RAS-GROUP-RELATED LRR PROTEIN 4-LIKE', 252433);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(421477, 'PTHR45752:SF46', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND IQ DOMAIN-CONTAINING PROTEIN 4', 252433),
(421478, 'PTHR45752:SF149', NULL, NULL, NULL, NULL, 'GH17740P', 252433),
(421479, 'PTHR45752:SF47', NULL, NULL, NULL, NULL, 'ERBIN', 252433),
(421480, 'PTHR45752:SF48', NULL, NULL, NULL, NULL, 'MALIGNANT FIBROUS HISTIOCYTOMA-AMPLIFIED SEQUENCE 1', 252433),
(421481, 'PTHR45752:SF187', NULL, NULL, NULL, NULL, 'GH06740P', 252433),
(421482, 'PTHR45752:SF146', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 18', 252433),
(421483, 'PTHR45752:SF101', NULL, NULL, NULL, NULL, 'PLANT INTRACELLULAR RAS-GROUP-RELATED LRR PROTEIN 4', 252433),
(421484, 'PTHR45752:SF8', NULL, NULL, NULL, NULL, 'VOLUME-REGULATED ANION CHANNEL SUBUNIT LRRC8E', 252433),
(421485, 'PTHR45752:SF5', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 28', 252433),
(421486, 'PTHR45752:SF173', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND CALPONIN HOMOLOGY DOMAIN-CONTAINING PROTEIN', 252433),
(421487, 'PTHR45752:SF4', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 59', 252433),
(421488, 'PTHR45752:SF172', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 252433),
(421489, 'PTHR45752:SF7', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT SERINE/THREONINE-PROTEIN KINASE 2', 252433),
(421490, 'PTHR45752:SF93', NULL, NULL, NULL, NULL, 'PLANT INTRACELLULAR RAS-GROUP-RELATED LRR PROTEIN 5', 252433),
(421491, 'PTHR45752:SF175', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT FAMILY PROTEIN', 252433),
(421492, 'PTHR45752:SF174', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252433),
(421493, 'PTHR45752:SF50', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND DEATH DOMAIN-CONTAINING PROTEIN 1', 252433),
(421494, 'PTHR45752:SF6', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 39', 252433),
(421495, 'PTHR45752:SF1', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 69', 252433),
(421496, 'PTHR45752:SF171', NULL, NULL, NULL, NULL, 'TMV RESISTANCE PROTEIN N-LIKE', 252433),
(421497, 'PTHR45752:SF97', NULL, NULL, NULL, NULL, 'PLANT INTRACELLULAR RAS GROUP-RELATED LRR 5-RELATED', 252433),
(421498, 'PTHR45752:SF170', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE PHLPP-LIKE PROTEIN', 252433),
(421499, 'PTHR45752:SF10', NULL, NULL, NULL, NULL, 'PH DOMAIN LEUCINE-RICH REPEAT-CONTAINING PROTEIN PHOSPHATASE 2', 252433),
(421500, 'PTHR45752:SF11', NULL, NULL, NULL, NULL, 'VOLUME-REGULATED ANION CHANNEL SUBUNIT LRRC8D', 252433),
(421501, 'PTHR45752:SF136', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 252433),
(421502, 'PTHR45752:SF12', NULL, NULL, NULL, NULL, '', 252433),
(421503, 'PTHR45752:SF13', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 58', 252433),
(421504, 'PTHR45752:SF58', NULL, NULL, NULL, NULL, 'PH DOMAIN LEUCINE-RICH REPEAT-CONTAINING PROTEIN PHOSPHATASE 1', 252433),
(421505, 'PTHR45752:SF15', NULL, NULL, NULL, NULL, 'PLANT INTRACELLULAR RAS-GROUP-RELATED LRR PROTEIN 5', 252433),
(421506, 'PTHR45752:SF177', NULL, NULL, NULL, NULL, 'PLANT INTRACELLULAR RAS-GROUP-RELATED LRR PROTEIN', 252433),
(421507, 'PTHR45752:SF176', NULL, NULL, NULL, NULL, 'PLANT INTRACELLULAR RAS-GROUP-RELATED LRR PROTEIN 3', 252433),
(421508, 'PTHR45752:SF179', NULL, NULL, NULL, NULL, '', 252433),
(421509, 'PTHR45752:SF135', NULL, NULL, NULL, NULL, 'PLANT INTRACELLULAR RAS-GROUP-RELATED LRR PROTEIN', 252433),
(421510, 'PTHR45752:SF178', NULL, NULL, NULL, NULL, 'PLANT INTRACELLULAR RAS-GROUP-RELATED LRR PROTEIN 7-LIKE', 252433),
(421511, 'PTHR45752:SF129', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252433),
(421512, 'PTHR45752', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING', 252433),
(421513, 'PTHR45752:SF120', NULL, NULL, NULL, NULL, 'PLANT INTRACELLULAR RAS-GROUP-RELATED LRR PROTEIN 1', 252433),
(421514, 'PTHR45752:SF61', NULL, NULL, NULL, NULL, 'PLANT INTRACELLULAR RAS-GROUP-RELATED LRR PROTEIN 2', 252433),
(421515, 'PTHR45752:SF163', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING 8 VRAC SUBUNIT DA', 252433);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(421516, 'PTHR45752:SF63', NULL, NULL, NULL, NULL, 'PLANT INTRACELLULAR RAS-GROUP-RELATED LRR PROTEIN 3', 252433),
(421517, 'PTHR45752:SF160', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 40', 252433),
(421518, 'PTHR45752:SF21', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 63', 252433),
(421519, 'PTHR45752:SF126', NULL, NULL, NULL, NULL, 'BNAC03G47790D PROTEIN', 252433),
(421520, 'PTHR45752:SF169', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252433),
(421521, 'PTHR45752:SF23', NULL, NULL, NULL, NULL, 'VOLUME-REGULATED ANION CHANNEL SUBUNIT LRRC8A', 252433),
(421522, 'PTHR45752:SF24', NULL, NULL, NULL, NULL, 'VOLUME-REGULATED ANION CHANNEL SUBUNIT LRRC8C', 252433),
(421523, 'PTHR45752:SF166', NULL, NULL, NULL, NULL, '', 252433),
(421524, 'PTHR45752:SF122', NULL, NULL, NULL, NULL, 'PLANT INTRACELLULAR RAS-GROUP-RELATED LRR PROTEIN 6', 252433),
(421525, 'PTHR45752:SF26', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN SHOC-2', 252433),
(421526, 'PTHR45752:SF124', NULL, NULL, NULL, NULL, 'PLANT INTRACELLULAR RAS GROUP-RELATED LRR 2-RELATED', 252433),
(421527, 'PTHR45752:SF168', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RGA1-RELATED', 252433),
(421528, 'PTHR45752:SF167', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN SOC-2 HOMOLOG', 252433),
(421529, 'PTHR45752:SF118', NULL, NULL, NULL, NULL, 'PLANT INTRACELLULAR RAS GROUP-RELATED LRR 9-RELATED', 252433),
(421530, 'PTHR45752:SF70', NULL, NULL, NULL, NULL, 'PLANT INTRACELLULAR RAS-GROUP-RELATED LRR PROTEIN 8', 252433),
(421531, 'PTHR45752:SF153', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN 1', 252433),
(421532, 'PTHR45752:SF152', NULL, NULL, NULL, NULL, 'OS11G0213700 PROTEIN', 252433),
(421533, 'PTHR45752:SF74', NULL, NULL, NULL, NULL, 'PLANT INTRACELLULAR RAS-GROUP-RELATED LRR PROTEIN 7', 252433),
(421534, 'PTHR45752:SF31', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING 10B', 252433),
(421535, 'PTHR45752:SF76', NULL, NULL, NULL, NULL, 'FLYERS-CUP, ISOFORM F', 252433),
(421536, 'PTHR45752:SF114', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT (LRR) FAMILY PROTEIN', 252433),
(421537, 'PTHR45752:SF35', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 30', 252433),
(421538, 'PTHR45752:SF117', NULL, NULL, NULL, NULL, 'SI:ZFOS-323E3.4', 252433),
(421539, 'PTHR45752:SF37', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 2', 252433),
(421540, 'PTHR45752:SF111', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 252433),
(421541, 'PTHR45752:SF38', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT CONTAINING 57', 252433),
(421542, 'PTHR45752:SF156', NULL, NULL, NULL, NULL, 'RAS SUPPRESSOR PROTEIN 1', 252433),
(421543, 'PTHR10634:SF91', NULL, NULL, NULL, NULL, '', 252434),
(421544, 'PTHR10634:SF71', NULL, NULL, NULL, NULL, 'ZINC FINGER A20 AND AN1 DOMAIN-CONTAINING STRESS-ASSOCIATED PROTEIN 6', 252434),
(421545, 'PTHR10634:SF109', NULL, NULL, NULL, NULL, 'ZINC FINGER A20 AND AN1 DOMAIN-CONTAINING STRESS-ASSOCIATED PROTEIN 4-LIKE', 252434),
(421546, 'PTHR10634:SF128', NULL, NULL, NULL, NULL, 'ZINC FINGER A20 AND AN1 DOMAIN-CONTAINING STRESS-ASSOCIATED PROTEIN 8-RELATED', 252434),
(421547, 'PTHR10634:SF106', NULL, NULL, NULL, NULL, 'AN1-TYPE DOMAIN-CONTAINING PROTEIN', 252434),
(421548, 'PTHR10634:SF129', NULL, NULL, NULL, NULL, '', 252434),
(421549, 'PTHR10634:SF107', NULL, NULL, NULL, NULL, 'ZINC FINGER A20 AND AN1 DOMAIN-CONTAINING STRESS-ASSOCIATED PROTEIN 8-LIKE', 252434),
(421550, 'PTHR10634:SF126', NULL, NULL, NULL, NULL, 'BNAC01G38560D PROTEIN', 252434),
(421551, 'PTHR10634:SF148', NULL, NULL, NULL, NULL, 'AN1-LIKE ZINC FINGER PROTEIN', 252434),
(421552, 'PTHR10634:SF104', NULL, NULL, NULL, NULL, 'ZINC FINGER A20 AND AN1 DOMAIN-CONTAINING STRESS-ASSOCIATED PROTEIN 2', 252434),
(421553, 'PTHR10634:SF149', NULL, NULL, NULL, NULL, 'RE70963P', 252434),
(421554, 'PTHR10634:SF105', NULL, NULL, NULL, NULL, 'AN1-TYPE DOMAIN-CONTAINING PROTEIN', 252434),
(421555, 'PTHR10634:SF124', NULL, NULL, NULL, NULL, 'ZINC FINGER A20 AND AN1 DOMAIN-CONTAINING STRESS-ASSOCIATED PROTEIN 8-RELATED', 252434);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(421556, 'PTHR10634:SF146', NULL, NULL, NULL, NULL, 'FINGER PROTEIN, PUTATIVE-RELATED', 252434),
(421557, 'PTHR10634:SF147', NULL, NULL, NULL, NULL, 'A20-TYPE DOMAIN-CONTAINING PROTEIN', 252434),
(421558, 'PTHR10634:SF144', NULL, NULL, NULL, NULL, 'ZINC FINGER A20 AND AN1 DOMAIN-CONTAINING STRESS-ASSOCIATED PROTEIN 5', 252434),
(421559, 'PTHR10634:SF27', NULL, NULL, NULL, NULL, '', 252434),
(421560, 'PTHR10634:SF145', NULL, NULL, NULL, NULL, 'ZINC FINGER A20 AND AN1 DOMAIN-CONTAINING STRESS-ASSOCIATED PROTEIN 8-LIKE', 252434),
(421561, 'PTHR10634:SF142', NULL, NULL, NULL, NULL, 'ZINC FINGER A20 AND AN1 DOMAIN-CONTAINING STRESS-ASSOCIATED PROTEIN 2', 252434),
(421562, 'PTHR10634:SF143', NULL, NULL, NULL, NULL, 'ZINC FINGER A20 AND AN1 DOMAIN-CONTAINING STRESS-ASSOCIATED PROTEIN 12', 252434),
(421563, 'PTHR10634:SF141', NULL, NULL, NULL, NULL, 'ZINC FINGER, AN1-TYPE, ZINC FINGER, A20-TYPE-RELATED', 252434),
(421564, 'PTHR10634:SF85', NULL, NULL, NULL, NULL, 'AN1-TYPE DOMAIN-CONTAINING PROTEIN', 252434),
(421565, 'PTHR10634:SF22', NULL, NULL, NULL, NULL, 'ZINC FINGER A20 AND AN1 DOMAIN-CONTAINING STRESS-ASSOCIATED PROTEIN 5', 252434),
(421566, 'PTHR10634:SF87', NULL, NULL, NULL, NULL, 'ZINC FINGER AN1 DOMAIN-CONTAINING STRESS-ASSOCIATED PROTEIN 15-LIKE', 252434),
(421567, 'PTHR10634:SF67', NULL, NULL, NULL, NULL, 'AN1-TYPE ZINC FINGER PROTEIN 3', 252434),
(421568, 'PTHR10634:SF26', NULL, NULL, NULL, NULL, 'AN1-TYPE ZINC FINGER PROTEIN 5', 252434),
(421569, 'PTHR10634:SF25', NULL, NULL, NULL, NULL, 'AN1-TYPE ZINC FINGER PROTEIN 6', 252434),
(421570, 'PTHR10634:SF80', NULL, NULL, NULL, NULL, '', 252434),
(421571, 'PTHR10634:SF119', NULL, NULL, NULL, NULL, '', 252434),
(421572, 'PTHR10634:SF117', NULL, NULL, NULL, NULL, 'ZINC FINGER A20 AND AN1 DOMAIN-CONTAINING STRESS-ASSOCIATED PROTEIN 10', 252434),
(421573, 'PTHR10634:SF116', NULL, NULL, NULL, NULL, 'ZINC FINGER A20 AND AN1 DOMAIN-CONTAINING STRESS-ASSOCIATED PROTEIN 1', 252434),
(421574, 'PTHR10634:SF135', NULL, NULL, NULL, NULL, '', 252434),
(421575, 'PTHR10634:SF114', NULL, NULL, NULL, NULL, 'ZINC FINGER A20 AND AN1 DOMAIN-CONTAINING STRESS-ASSOCIATED PROTEIN 6', 252434),
(421576, 'PTHR10634:SF136', NULL, NULL, NULL, NULL, '', 252434),
(421577, 'PTHR10634:SF133', NULL, NULL, NULL, NULL, 'AN1-TYPE DOMAIN-CONTAINING PROTEIN', 252434),
(421578, 'PTHR10634:SF111', NULL, NULL, NULL, NULL, 'STRESS-ASSOCIATED PROTEIN 8', 252434),
(421579, 'PTHR10634:SF112', NULL, NULL, NULL, NULL, 'ZINC FINGER A20 AND AN1 DOMAIN-CONTAINING STRESS-ASSOCIATED PROTEIN 4', 252434),
(421580, 'PTHR10634:SF110', NULL, NULL, NULL, NULL, 'ZINC FINGER A20 AND AN1 DOMAIN-CONTAINING STRESS-ASSOCIATED PROTEIN 8-LIKE', 252434),
(421581, 'PTHR10634:SF151', NULL, NULL, NULL, NULL, 'ZINC FINGER A20 AND AN1 DOMAIN STRESS-ASSOCIATED PROTEIN', 252434),
(421582, 'PTHR10634:SF152', NULL, NULL, NULL, NULL, 'BNAC06G14100D PROTEIN', 252434),
(421583, 'PTHR10634', NULL, NULL, NULL, NULL, 'AN1-TYPE ZINC FINGER PROTEIN', 252434),
(421584, 'PTHR10634:SF150', NULL, NULL, NULL, NULL, 'ZINC FINGER A20 AND AN1 DOMAIN-CONTAINING STRESS-ASSOCIATED PROTEIN 7', 252434),
(421585, 'PTHR10634:SF97', NULL, NULL, NULL, NULL, 'ZINC FINGER A20 AND AN1 DOMAIN-CONTAINING STRESS-ASSOCIATED PROTEIN 9', 252434),
(421586, 'PTHR10634:SF75', NULL, NULL, NULL, NULL, 'ZINC FINGER A20 AND AN1 DOMAIN-CONTAINING STRESS-ASSOCIATED PROTEIN 11', 252434),
(421587, 'PTHR10634:SF99', NULL, NULL, NULL, NULL, 'ZINC FINGER AN1 DOMAIN-CONTAINING STRESS-ASSOCIATED PROTEIN 15', 252434),
(421588, 'PTHR10634:SF77', NULL, NULL, NULL, NULL, 'ZINC FINGER A20 AND AN1 DOMAIN-CONTAINING STRESS-ASSOCIATED PROTEIN 9', 252434),
(421589, 'PTHR10634:SF98', NULL, NULL, NULL, NULL, 'ZINC FINGER A20 AND AN1 DOMAIN-CONTAINING STRESS-ASSOCIATED PROTEIN 3', 252434),
(421590, 'PTHR48277:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOMAL PROTEIN S5', 252435),
(421591, 'PTHR48277', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOMAL PROTEIN S5', 252435),
(421592, 'PTHR34062:SF1', NULL, NULL, NULL, NULL, 'NADH-U_OX-RDASE DOMAIN-CONTAINING PROTEIN', 252436);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(421593, 'PTHR34062:SF3', NULL, NULL, NULL, NULL, 'NADH-U_OX-RDASE DOMAIN-CONTAINING PROTEIN', 252436),
(421594, 'PTHR34062', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE 21 KDA SUBUNIT, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G04750)-RELATED', 252436),
(421595, 'PTHR11539', NULL, NULL, NULL, NULL, 'VDJ RECOMBINATION ACTIVATING PROTEIN 1 RAG1', 252437),
(421596, 'PTHR11539:SF0', NULL, NULL, NULL, NULL, 'V(D)J RECOMBINATION-ACTIVATING PROTEIN 1', 252437),
(421597, 'PTHR20889:SF5', NULL, NULL, NULL, NULL, 'OS02G0226200 PROTEIN', 252438),
(421598, 'PTHR20889:SF19', NULL, NULL, NULL, NULL, 'THIAMINE PHOSPHATE PHOSPHATASE-LIKE PROTEIN', 252438),
(421599, 'PTHR20889:SF2', NULL, NULL, NULL, NULL, 'PHOSPHOETHANOLAMINE/PHOSPHOCHOLINE PHOSPHATASE', 252438),
(421600, 'PTHR20889', NULL, NULL, NULL, NULL, 'PHOSPHATASE, ORPHAN 1, 2', 252438),
(421601, 'PTHR20889:SF1', NULL, NULL, NULL, NULL, 'PYRIDOXAL PHOSPHATE PHOSPHATASE PHOSPHO2', 252438),
(421602, 'PTHR20889:SF26', NULL, NULL, NULL, NULL, 'OS01G0720400 PROTEIN', 252438),
(421603, 'PTHR20889:SF27', NULL, NULL, NULL, NULL, 'INORGANIC PYROPHOSPHATASE 2', 252438),
(421604, 'PTHR20889:SF16', NULL, NULL, NULL, NULL, 'INORGANIC PYROPHOSPHATASE 2-LIKE', 252438),
(421605, 'PTHR20889:SF17', NULL, NULL, NULL, NULL, '2,3-DIKETO-5-METHYLTHIO-1-PHOSPHOPENTANE PHOSPHATASE', 252438),
(421606, 'PTHR20889:SF22', NULL, NULL, NULL, NULL, 'INORGANIC PYROPHOSPHATASE 2-LIKE', 252438),
(421607, 'PTHR20889:SF12', NULL, NULL, NULL, NULL, 'LP01149P', 252438),
(421608, 'PTHR20889:SF24', NULL, NULL, NULL, NULL, 'BNAA09G44850D PROTEIN', 252438),
(421609, 'PTHR20889:SF14', NULL, NULL, NULL, NULL, 'INORGANIC PYROPHOSPHATASE 1-LIKE', 252438),
(421610, 'PTHR20889:SF21', NULL, NULL, NULL, NULL, 'BNAANNG30500D PROTEIN', 252438),
(421611, 'PTHR38629:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG12672', 252439),
(421612, 'PTHR38629', NULL, NULL, NULL, NULL, 'PROTEIN CBG12672', 252439),
(421613, 'PTHR13170:SF23', NULL, NULL, NULL, NULL, 'SI:DKEY-183C6.8', 252440),
(421614, 'PTHR13170:SF24', NULL, NULL, NULL, NULL, 'O-GLCNACASE', 252440),
(421615, 'PTHR13170', NULL, NULL, NULL, NULL, 'O-GLCNACASE', 252440),
(421616, 'PTHR13170:SF19', NULL, NULL, NULL, NULL, 'O-GLCNACASE-LIKE', 252440),
(421617, 'PTHR13170:SF16', NULL, NULL, NULL, NULL, 'PROTEIN O-GLCNACASE', 252440),
(421618, 'PTHR33418:SF1', NULL, NULL, NULL, NULL, 'HA DOMAIN-CONTAINING PROTEIN', 252441),
(421619, 'PTHR33418', NULL, NULL, NULL, NULL, 'HELICASE-ASSOCIATED', 252441),
(421620, 'PTHR35156', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 52', 252442),
(421621, 'PTHR35156:SF1', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 52', 252442),
(421622, 'PTHR31341:SF4', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 252443),
(421623, 'PTHR31341:SF15', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 252443),
(421624, 'PTHR31341:SF14', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN GP100', 252443),
(421625, 'PTHR31341:SF17', NULL, NULL, NULL, NULL, 'E SET DOMAIN CONTAINING PROTEIN', 252443),
(421626, 'PTHR31341:SF16', NULL, NULL, NULL, NULL, 'CONTACT SITE A PROTEIN', 252443),
(421627, 'PTHR31341:SF11', NULL, NULL, NULL, NULL, 'IPT/TIG DOMAIN-CONTAINING PROTEIN', 252443),
(421628, 'PTHR31341', NULL, NULL, NULL, NULL, 'IPT/TIG DOMAIN-CONTAINING PROTEIN-RELATED-RELATED', 252443),
(421629, 'PTHR31341:SF10', NULL, NULL, NULL, NULL, 'IPT/TIG DOMAIN-CONTAINING PROTEIN', 252443),
(421630, 'PTHR31341:SF12', NULL, NULL, NULL, NULL, '', 252443),
(421631, 'PTHR47028:SF1', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE TYROSINE-PROTEIN PHOSPHATASE O', 252444),
(421632, 'PTHR47028', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE TYROSINE-PROTEIN PHOSPHATASE O', 252444),
(421633, 'PTHR47326:SF1', NULL, NULL, NULL, NULL, 'HTH PSQ-TYPE DOMAIN-CONTAINING PROTEIN', 252445),
(421634, 'PTHR47326:SF2', NULL, NULL, NULL, NULL, 'DUF4817 DOMAIN-CONTAINING PROTEIN', 252445),
(421635, 'PTHR47326', NULL, NULL, NULL, NULL, 'TRANSPOSABLE ELEMENT TC3 TRANSPOSASE-LIKE PROTEIN', 252445),
(421636, 'PTHR15468:SF7', NULL, NULL, NULL, NULL, 'SCIELLIN', 252446),
(421637, 'PTHR15468:SF12', NULL, NULL, NULL, NULL, '', 252446);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(421638, 'PTHR15468', NULL, NULL, NULL, NULL, 'ZNF185', 252446),
(421639, 'PTHR15468:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 185', 252446),
(421640, 'PTHR39189', NULL, NULL, NULL, NULL, 'UPF0173 METAL-DEPENDENT HYDROLASE YTKL', 252447),
(421641, 'PTHR39189:SF1', NULL, NULL, NULL, NULL, 'UPF0173 METAL-DEPENDENT HYDROLASE YTKL', 252447),
(421642, 'PTHR46313:SF1', NULL, NULL, NULL, NULL, 'FAD/NAD(P)-BINDING OXIDOREDUCTASE FAMILY PROTEIN', 252448),
(421643, 'PTHR46313:SF3', NULL, NULL, NULL, NULL, 'PROLYCOPENE ISOMERASE, CHLOROPLASTIC', 252448),
(421644, 'PTHR46313', NULL, NULL, NULL, NULL, '', 252448),
(421645, 'PTHR46313:SF6', NULL, NULL, NULL, NULL, 'FAD/NAD(P)-BINDING OXIDOREDUCTASE FAMILY PROTEIN', 252448),
(421646, 'PTHR14096:SF35', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN L 10A-RELATED', 252449),
(421647, 'PTHR14096:SF57', NULL, NULL, NULL, NULL, 'SI:CH73-233K15.2', 252449),
(421648, 'PTHR14096:SF34', NULL, NULL, NULL, NULL, 'SI:RP71-1G18.13', 252449),
(421649, 'PTHR14096', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN L', 252449),
(421650, 'PTHR14096:SF55', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN L1', 252449),
(421651, 'PTHR14096:SF28', NULL, NULL, NULL, NULL, 'PROTEIN CBG02395', 252449),
(421652, 'PTHR14096:SF39', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN L4', 252449),
(421653, 'PTHR14096:SF27', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN L2', 252449),
(421654, 'PTHR14096:SF59', NULL, NULL, NULL, NULL, 'SI:CABZ01007807.1', 252449),
(421655, 'PTHR14096:SF7', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN L6', 252449),
(421656, 'PTHR14096:SF6', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN L5', 252449),
(421657, 'PTHR14096:SF29', NULL, NULL, NULL, NULL, 'APOL9A PROTEIN-RELATED', 252449),
(421658, 'PTHR14096:SF1', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN L DOMAIN-CONTAINING PROTEIN 1', 252449),
(421659, 'PTHR14096:SF60', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN L, 1-RELATED', 252449),
(421660, 'PTHR14096:SF62', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN L 7A-RELATED', 252449),
(421661, 'PTHR14096:SF40', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN L3', 252449),
(421662, 'PTHR14096:SF61', NULL, NULL, NULL, NULL, 'SI:CABZ01007802.1-RELATED', 252449),
(421663, 'PTHR31206:SF5', NULL, NULL, NULL, NULL, 'PROTEIN FAM177A1', 252450),
(421664, 'PTHR31206:SF1', NULL, NULL, NULL, NULL, 'LP10445P', 252450),
(421665, 'PTHR31206', NULL, NULL, NULL, NULL, 'LP10445P', 252450),
(421666, 'PTHR31206:SF9', NULL, NULL, NULL, NULL, 'PROTEIN FAM177B', 252450),
(421667, 'PTHR31078', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 300', 252451),
(421668, 'PTHR31078:SF1', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 300', 252451),
(421669, 'PTHR10335:SF17', NULL, NULL, NULL, NULL, 'FIBRILLARIN', 252452),
(421670, 'PTHR10335:SF6', NULL, NULL, NULL, NULL, 'RRNA/TRNA 2''-O-METHYLTRANSFERASE FIBRILLARIN-LIKE PROTEIN 1', 252452),
(421671, 'PTHR10335', NULL, NULL, NULL, NULL, 'RRNA 2-O-METHYLTRANSFERASE FIBRILLARIN', 252452),
(421672, 'PTHR10335:SF19', NULL, NULL, NULL, NULL, 'BNAC09G28460D PROTEIN', 252452),
(421673, 'PTHR10335:SF18', NULL, NULL, NULL, NULL, 'RRNA 2''-O-METHYLTRANSFERASE FIBRILLARIN 1-RELATED', 252452),
(421674, 'PTHR10335:SF20', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 36A', 252452),
(421675, 'PTHR10335:SF0', NULL, NULL, NULL, NULL, 'RRNA 2''-O-METHYLTRANSFERASE FIBRILLARIN 2', 252452),
(421676, 'PTHR10335:SF24', NULL, NULL, NULL, NULL, 'FIBRILLARIN, S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASE-RELATED', 252452),
(421677, 'PTHR10335:SF13', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 252452),
(421678, 'PTHR10335:SF23', NULL, NULL, NULL, NULL, 'HAD_SAK_1 DOMAIN-CONTAINING PROTEIN', 252452),
(421679, 'PTHR10335:SF4', NULL, NULL, NULL, NULL, 'RRNA 2''-O-METHYLTRANSFERASE FIBRILLARIN', 252452),
(421680, 'PTHR10335:SF21', NULL, NULL, NULL, NULL, 'BNAA03G47570D PROTEIN', 252452),
(421681, 'PTHR43969:SF9', NULL, NULL, NULL, NULL, 'GLUTATHIONE S TRANSFERASE D10, ISOFORM A-RELATED', 252453),
(421682, 'PTHR43969:SF8', NULL, NULL, NULL, NULL, 'GLUTATHIONE S TRANSFERASE E13, ISOFORM A-RELATED', 252453);
INSERT INTO "PUBLIC"."MODEL" VALUES
(421683, 'PTHR43969:SF7', NULL, NULL, NULL, NULL, 'GST-CONTAINING FLYWCH ZINC-FINGER PROTEIN', 252453),
(421684, 'PTHR43969', NULL, NULL, NULL, NULL, 'GLUTATHIONE S TRANSFERASE D10, ISOFORM A-RELATED', 252453),
(421685, 'PTHR43969:SF5', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE E14', 252453),
(421686, 'PTHR43969:SF4', NULL, NULL, NULL, NULL, 'FI01423P-RELATED', 252453),
(421687, 'PTHR43969:SF3', NULL, NULL, NULL, NULL, 'GLUTATHIONE S TRANSFERASE E11, ISOFORM A-RELATED', 252453),
(421688, 'PTHR43969:SF2', NULL, NULL, NULL, NULL, 'GLUTATHIONE S TRANSFERASE D11, ISOFORM B', 252453),
(421689, 'PTHR35883', NULL, NULL, NULL, NULL, 'CYCLIC AMP-INDUCIBLE PROTEIN BP74-RELATED', 252454),
(421690, 'PTHR35883:SF1', NULL, NULL, NULL, NULL, 'CYCLIC AMP-INDUCIBLE PROTEIN BP74-RELATED', 252454),
(421691, 'PTHR47046:SF1', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE ASSEMBLY FACTOR 1, MITOCHONDRIAL', 252455),
(421692, 'PTHR47046', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE ASSEMBLY FACTOR 1, MITOCHONDRIAL', 252455),
(421693, 'PTHR47954:SF1', NULL, NULL, NULL, NULL, 'OS02G0217300 PROTEIN', 252456),
(421694, 'PTHR47954:SF2', NULL, NULL, NULL, NULL, 'OS09G0275400 PROTEIN', 252456),
(421695, 'PTHR47954:SF3', NULL, NULL, NULL, NULL, 'OS12G0640200 PROTEIN', 252456),
(421696, 'PTHR47954:SF4', NULL, NULL, NULL, NULL, 'P450 71D11, PUTATIVE, EXPRESSED-RELATED', 252456),
(421697, 'PTHR47954', NULL, NULL, NULL, NULL, 'OS09G0275400 PROTEIN-RELATED', 252456),
(421698, 'PTHR46898:SF3', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 252457),
(421699, 'PTHR46898:SF4', NULL, NULL, NULL, NULL, 'SENESCENCE-ASSOCIATED CARBOXYLESTERASE 101-LIKE ISOFORM X1', 252457),
(421700, 'PTHR46898:SF5', NULL, NULL, NULL, NULL, 'BNAC09G42600D PROTEIN', 252457),
(421701, 'PTHR46898', NULL, NULL, NULL, NULL, 'SENESCENCE-ASSOCIATED CARBOXYLESTERASE 101', 252457),
(421702, 'PTHR31054:SF6', NULL, NULL, NULL, NULL, 'ZYGOTE ARREST PROTEIN 1', 252458),
(421703, 'PTHR31054', NULL, NULL, NULL, NULL, 'ZYGOTE ARREST PROTEIN 1-LIKE ISOFORM X1', 252458),
(421704, 'PTHR31054:SF3', NULL, NULL, NULL, NULL, 'ZF-3CXXC DOMAIN-CONTAINING PROTEIN', 252458),
(421705, 'PTHR31054:SF5', NULL, NULL, NULL, NULL, 'ZAR1-LIKE PROTEIN', 252458),
(421706, 'PTHR14212:SF3', NULL, NULL, NULL, NULL, 'PRP3 DOMAIN-CONTAINING PROTEIN', 252459),
(421707, 'PTHR14212:SF0', NULL, NULL, NULL, NULL, 'U4/U6 SMALL NUCLEAR RIBONUCLEOPROTEIN PRP3', 252459),
(421708, 'PTHR14212:SF1', NULL, NULL, NULL, NULL, 'BNAC03G58240D PROTEIN', 252459),
(421709, 'PTHR14212:SF2', NULL, NULL, NULL, NULL, '', 252459),
(421710, 'PTHR14212', NULL, NULL, NULL, NULL, 'U4/U6-ASSOCIATED RNA SPLICING FACTOR-RELATED', 252459),
(421711, 'PTHR46322:SF1', NULL, NULL, NULL, NULL, 'PUROMYCIN-SENSITIVE AMINOPEPTIDASE', 252460),
(421712, 'PTHR46322', NULL, NULL, NULL, NULL, 'PUROMYCIN-SENSITIVE AMINOPEPTIDASE', 252460),
(421713, 'PTHR46322:SF6', NULL, NULL, NULL, NULL, 'BNAC06G01820D PROTEIN', 252460),
(421714, 'PTHR33772:SF1', NULL, NULL, NULL, NULL, 'THYMUS, BRAIN AND TESTES-ASSOCIATED', 252461),
(421715, 'PTHR33772:SF2', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4930579F01 GENE', 252461),
(421716, 'PTHR33772:SF3', NULL, NULL, NULL, NULL, 'PROTEIN TBATA', 252461),
(421717, 'PTHR33772', NULL, NULL, NULL, NULL, 'THYMUS, BRAIN AND TESTES-ASSOCIATED', 252461),
(421718, 'PTHR19297:SF185', NULL, NULL, NULL, NULL, 'GLYCOSYLATION RELATED', 252462),
(421719, 'PTHR19297:SF96', NULL, NULL, NULL, NULL, 'BETA-1,3-GALACTOSYL-O-GLYCOSYL-GLYCOPROTEIN BETA-1,6-N-ACETYLGLUCOSAMINYLTRANSFERASE', 252462),
(421720, 'PTHR19297:SF183', NULL, NULL, NULL, NULL, 'N-ACETYLLACTOSAMINIDE BETA-1,6-N-ACETYLGLUCOSAMINYL-TRANSFERASE', 252462),
(421721, 'PTHR19297:SF178', NULL, NULL, NULL, NULL, 'BETA-1,3-GALACTOSYL-O-GLYCOSYL-GLYCOPROTEIN BETA-1,6-N-ACETYLGLUCOSAMINYLTRANSFERASE 7', 252462),
(421722, 'PTHR19297:SF187', NULL, NULL, NULL, NULL, '', 252462),
(421723, 'PTHR19297:SF186', NULL, NULL, NULL, NULL, 'GLY-1', 252462),
(421724, 'PTHR19297', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE 14 FAMILY MEMBER', 252462),
(421725, 'PTHR19297:SF7', NULL, NULL, NULL, NULL, 'BETA-1,3-GALACTOSYL-O-GLYCOSYL-GLYCOPROTEIN BETA-1,6-N-ACETYLGLUCOSAMINYLTRANSFERASE 4', 252462);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(421726, 'PTHR19297:SF124', NULL, NULL, NULL, NULL, 'GLY-16-RELATED', 252462),
(421727, 'PTHR19297:SF81', NULL, NULL, NULL, NULL, 'BETA-1,3-GALACTOSYL-O-GLYCOSYL-GLYCOPROTEIN BETA-1,6-N-ACETYLGLUCOSAMINYLTRANSFERASE 3', 252462),
(421728, 'PTHR19297:SF181', NULL, NULL, NULL, NULL, '', 252462),
(421729, 'PTHR10290:SF3', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE 1', 252463),
(421730, 'PTHR10290', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE I', 252463),
(421731, 'PTHR10290:SF16', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE 1 ALPHA', 252463),
(421732, 'PTHR10290:SF15', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE I', 252463),
(421733, 'PTHR10290:SF1', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE I, MITOCHONDRIAL', 252463),
(421734, 'PTHR10290:SF14', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE I-RELATED', 252463),
(421735, 'PTHR10290:SF23', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE 1 BETA', 252463),
(421736, 'PTHR10290:SF5', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE 1', 252463),
(421737, 'PTHR10290:SF22', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE I', 252463),
(421738, 'PTHR10290:SF21', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE I', 252463),
(421739, 'PTHR10290:SF18', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE TYPE IB SMALL SUBUNIT', 252463),
(421740, 'PTHR41795:SF1', NULL, NULL, NULL, NULL, 'EXOPOLYSACCHARIDE SYNTHESIS PROTEIN', 252464),
(421741, 'PTHR41795', NULL, NULL, NULL, NULL, 'EXOPOLYSACCHARIDE SYNTHESIS PROTEIN', 252464),
(421742, 'PTHR32054:SF17', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252465),
(421743, 'PTHR32054:SF11', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252465),
(421744, 'PTHR32054:SF52', NULL, NULL, NULL, NULL, '', 252465),
(421745, 'PTHR32054:SF53', NULL, NULL, NULL, NULL, 'WEB FAMILY-RELATED', 252465),
(421746, 'PTHR32054:SF58', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN', 252465),
(421747, 'PTHR32054:SF15', NULL, NULL, NULL, NULL, 'OS09G0458000 PROTEIN', 252465),
(421748, 'PTHR32054:SF56', NULL, NULL, NULL, NULL, 'PROTEIN WEAK CHLOROPLAST MOVEMENT UNDER BLUE LIGHT-LIKE 2', 252465),
(421749, 'PTHR32054:SF90', NULL, NULL, NULL, NULL, 'WEB FAMILY-RELATED', 252465),
(421750, 'PTHR32054:SF91', NULL, NULL, NULL, NULL, 'BNAA09G35740D PROTEIN', 252465),
(421751, 'PTHR32054', NULL, NULL, NULL, NULL, 'HEAVY CHAIN, PUTATIVE, EXPRESSED-RELATED-RELATED', 252465),
(421752, 'PTHR32054:SF50', NULL, NULL, NULL, NULL, 'BNAC05G40210D PROTEIN', 252465),
(421753, 'PTHR32054:SF92', NULL, NULL, NULL, NULL, 'PROTEIN WEAK CHLOROPLAST MOVEMENT UNDER BLUE LIGHT 1-LIKE ISOFORM X1', 252465),
(421754, 'PTHR32054:SF43', NULL, NULL, NULL, NULL, 'WEB FAMILY PROTEIN-RELATED', 252465),
(421755, 'PTHR32054:SF87', NULL, NULL, NULL, NULL, '', 252465),
(421756, 'PTHR32054:SF44', NULL, NULL, NULL, NULL, 'PROTEIN WEAK CHLOROPLAST MOVEMENT UNDER BLUE LIGHT 1-LIKE', 252465),
(421757, 'PTHR32054:SF88', NULL, NULL, NULL, NULL, 'OS12G0182100 PROTEIN', 252465),
(421758, 'PTHR32054:SF41', NULL, NULL, NULL, NULL, '', 252465),
(421759, 'PTHR32054:SF85', NULL, NULL, NULL, NULL, 'BNAA03G19090D PROTEIN', 252465),
(421760, 'PTHR32054:SF42', NULL, NULL, NULL, NULL, 'PREFOLDIN', 252465),
(421761, 'PTHR32054:SF86', NULL, NULL, NULL, NULL, 'OS07G0677900 PROTEIN', 252465),
(421762, 'PTHR32054:SF48', NULL, NULL, NULL, NULL, 'WEB FAMILY PLANT PROTEIN', 252465),
(421763, 'PTHR32054:SF89', NULL, NULL, NULL, NULL, 'WEB FAMILY, PREFOLDIN-RELATED', 252465),
(421764, 'PTHR32054:SF46', NULL, NULL, NULL, NULL, 'WEB FAMILY PROTEIN-RELATED', 252465),
(421765, 'PTHR32054:SF83', NULL, NULL, NULL, NULL, 'PROTEIN PLASTID MOVEMENT IMPAIRED 2', 252465),
(421766, 'PTHR32054:SF84', NULL, NULL, NULL, NULL, 'WEB FAMILY-RELATED', 252465),
(421767, 'PTHR32054:SF81', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252465),
(421768, 'PTHR32054:SF82', NULL, NULL, NULL, NULL, 'BNAC07G32130D PROTEIN', 252465),
(421769, 'PTHR32054:SF2', NULL, NULL, NULL, NULL, 'PROTEIN PLASTID MOVEMENT IMPAIRED 15', 252465),
(421770, 'PTHR32054:SF0', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING CTD PHOSPHATASE 1', 252465),
(421771, 'PTHR32054:SF9', NULL, NULL, NULL, NULL, 'OS04G0116200 PROTEIN', 252465); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(421772, 'PTHR32054:SF39', NULL, NULL, NULL, NULL, 'OS05G0476100 PROTEIN', 252465),
(421773, 'PTHR32054:SF6', NULL, NULL, NULL, NULL, 'PROTEIN WEAK CHLOROPLAST MOVEMENT UNDER BLUE LIGHT 1', 252465),
(421774, 'PTHR32054:SF3', NULL, NULL, NULL, NULL, 'HEAVY CHAIN, PUTATIVE, EXPRESSED-RELATED', 252465),
(421775, 'PTHR32054:SF4', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252465),
(421776, 'PTHR32054:SF32', NULL, NULL, NULL, NULL, 'BNAA08G04180D PROTEIN', 252465),
(421777, 'PTHR32054:SF76', NULL, NULL, NULL, NULL, 'OS05G0550100 PROTEIN', 252465),
(421778, 'PTHR32054:SF33', NULL, NULL, NULL, NULL, 'WEB FAMILY PLANT PROTEIN', 252465),
(421779, 'PTHR32054:SF30', NULL, NULL, NULL, NULL, 'PROTEIN WEAK CHLOROPLAST MOVEMENT UNDER BLUE LIGHT-LIKE 3', 252465),
(421780, 'PTHR32054:SF74', NULL, NULL, NULL, NULL, 'OS03G0395300 PROTEIN', 252465),
(421781, 'PTHR32054:SF31', NULL, NULL, NULL, NULL, 'PROTEIN WEAK CHLOROPLAST MOVEMENT UNDER BLUE LIGHT 1', 252465),
(421782, 'PTHR32054:SF75', NULL, NULL, NULL, NULL, 'BNAC02G23530D PROTEIN', 252465),
(421783, 'PTHR32054:SF36', NULL, NULL, NULL, NULL, 'WEB FAMILY-RELATED', 252465),
(421784, 'PTHR32054:SF35', NULL, NULL, NULL, NULL, 'OS02G0554200 PROTEIN', 252465),
(421785, 'PTHR32054:SF70', NULL, NULL, NULL, NULL, 'OS07G0620100 PROTEIN', 252465),
(421786, 'PTHR32054:SF27', NULL, NULL, NULL, NULL, '', 252465),
(421787, 'PTHR32054:SF28', NULL, NULL, NULL, NULL, '', 252465),
(421788, 'PTHR32054:SF66', NULL, NULL, NULL, NULL, 'BNACNNG18760D PROTEIN', 252465),
(421789, 'PTHR32054:SF63', NULL, NULL, NULL, NULL, 'BNAA04G21980D PROTEIN', 252465),
(421790, 'PTHR32054:SF69', NULL, NULL, NULL, NULL, 'BNAA03G11180D PROTEIN', 252465),
(421791, 'PTHR32054:SF25', NULL, NULL, NULL, NULL, 'PROTEIN WEAK CHLOROPLAST MOVEMENT UNDER BLUE LIGHT-LIKE 1', 252465),
(421792, 'PTHR32054:SF26', NULL, NULL, NULL, NULL, 'BNAA01G17900D PROTEIN', 252465),
(421793, 'PTHR32054:SF23', NULL, NULL, NULL, NULL, 'WEB FAMILY PLANT PROTEIN', 252465),
(421794, 'PTHR40449:SF2', NULL, NULL, NULL, NULL, 'BACTERIAL MICROCOMPARTMENT SHELL PROTEIN EUTS', 252466),
(421795, 'PTHR40449', NULL, NULL, NULL, NULL, 'ETHANOLAMINE UTILIZATION PROTEIN EUTS', 252466),
(421796, 'PTHR41237:SF1', NULL, NULL, NULL, NULL, '37S RIBOSOMAL PROTEIN MRP21, MITOCHONDRIAL', 252467),
(421797, 'PTHR41237', NULL, NULL, NULL, NULL, '37S RIBOSOMAL PROTEIN MRP21, MITOCHONDRIAL', 252467),
(421798, 'PTHR17498', NULL, NULL, NULL, NULL, 'SEMINAL VESICLE SECRETORY PROTEIN 6-RELATED', 252468),
(421799, 'PTHR17498:SF3', NULL, NULL, NULL, NULL, 'SEMINAL VESICLE SECRETORY PROTEIN 5', 252468),
(421800, 'PTHR17498:SF2', NULL, NULL, NULL, NULL, 'SEMINAL VESICLE SECRETORY PROTEIN 4', 252468),
(421801, 'PTHR17498:SF1', NULL, NULL, NULL, NULL, 'SEMINAL VESICLE SECRETORY PROTEIN 6', 252468),
(421802, 'PTHR40616:SF1', NULL, NULL, NULL, NULL, '', 252469),
(421803, 'PTHR40616', NULL, NULL, NULL, NULL, '', 252469),
(421804, 'PTHR39218:SF1', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE 14 KDA SUBUNIT, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G12110)-RELATED', 252470),
(421805, 'PTHR39218', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE 14 KDA SUBUNIT, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G12110)-RELATED', 252470),
(421806, 'PTHR35850:SF1', NULL, NULL, NULL, NULL, 'TYPE VI SECRETION SYSTEM SHEATH PROTEIN TSSB1', 252471),
(421807, 'PTHR35850', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 252471),
(421808, 'PTHR35850:SF2', NULL, NULL, NULL, NULL, 'TYPE VI SECRETION SYSTEM NEEDLE SHEATH PROTEIN TSSB', 252471),
(421809, 'PTHR13002:SF1', NULL, NULL, NULL, NULL, 'COMPLEX I ASSEMBLY FACTOR TIMMDC1, MITOCHONDRIAL', 252472),
(421810, 'PTHR13002', NULL, NULL, NULL, NULL, 'C3ORF1 PROTEIN-RELATED', 252472),
(421811, 'PTHR39867:SF2', NULL, NULL, NULL, NULL, 'HELICASE ATP-BINDING DOMAIN-CONTAINING PROTEIN', 252473),
(421812, 'PTHR39867:SF1', NULL, NULL, NULL, NULL, '', 252473),
(421813, 'PTHR39867', NULL, NULL, NULL, NULL, '', 252473),
(421814, 'PTHR33063:SF13', NULL, NULL, NULL, NULL, 'OS02G0583500 PROTEIN', 252474),
(421815, 'PTHR33063:SF14', NULL, NULL, NULL, NULL, 'OS02G0241300 PROTEIN', 252474); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(421816, 'PTHR33063:SF15', NULL, NULL, NULL, NULL, '', 252474),
(421817, 'PTHR33063:SF6', NULL, NULL, NULL, NULL, '', 252474),
(421818, 'PTHR33063', NULL, NULL, NULL, NULL, 'OS02G0583500 PROTEIN', 252474),
(421819, 'PTHR33063:SF9', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 252474),
(421820, 'PTHR33063:SF11', NULL, NULL, NULL, NULL, 'TRANSPOSASE, PTTA/EN/SPM, PLANT-RELATED', 252474),
(421821, 'PTHR46202', NULL, NULL, NULL, NULL, 'DNA EXCISION REPAIR PROTEIN ERCC-8', 252475),
(421822, 'PTHR46202:SF1', NULL, NULL, NULL, NULL, 'DNA EXCISION REPAIR PROTEIN ERCC-8', 252475),
(421823, 'PTHR32457', NULL, NULL, NULL, NULL, '', 252476),
(421824, 'PTHR32457:SF62', NULL, NULL, NULL, NULL, '', 252476),
(421825, 'PTHR47398', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 3', 252477),
(421826, 'PTHR47398:SF1', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 3-RELATED', 252477),
(421827, 'PTHR47838:SF1', NULL, NULL, NULL, NULL, '21.7 KDA CLASS VI HEAT SHOCK PROTEIN', 252478),
(421828, 'PTHR47838:SF2', NULL, NULL, NULL, NULL, 'BNAA10G08500D PROTEIN', 252478),
(421829, 'PTHR47838', NULL, NULL, NULL, NULL, '21.7 KDA CLASS VI HEAT SHOCK PROTEIN', 252478),
(421830, 'PTHR34612:SF4', NULL, NULL, NULL, NULL, 'GH131_N DOMAIN-CONTAINING PROTEIN', 252479),
(421831, 'PTHR34612', NULL, NULL, NULL, NULL, 'GH131_N DOMAIN-CONTAINING PROTEIN', 252479),
(421832, 'PTHR34612:SF2', NULL, NULL, NULL, NULL, 'GH131_N DOMAIN-CONTAINING PROTEIN', 252479),
(421833, 'PTHR34612:SF6', NULL, NULL, NULL, NULL, 'GH131_N DOMAIN-CONTAINING PROTEIN', 252479),
(421834, 'PTHR36836', NULL, NULL, NULL, NULL, 'COLANIC ACID BIOSYNTHESIS PROTEIN WCAK', 252480),
(421835, 'PTHR36836:SF1', NULL, NULL, NULL, NULL, 'COLANIC ACID BIOSYNTHESIS PROTEIN WCAK', 252480),
(421836, 'PTHR36616', NULL, NULL, NULL, NULL, 'BNAC07G32700D PROTEIN', 252481),
(421837, 'PTHR36616:SF4', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HAT9', 252481),
(421838, 'PTHR36616:SF5', NULL, NULL, NULL, NULL, 'DIS3-EXONUCLEASE-LIKE PROTEIN', 252481),
(421839, 'PTHR36616:SF6', NULL, NULL, NULL, NULL, '', 252481),
(421840, 'PTHR10237:SF14', NULL, NULL, NULL, NULL, 'MYND-TYPE DOMAIN-CONTAINING PROTEIN', 252482),
(421841, 'PTHR10237:SF13', NULL, NULL, NULL, NULL, 'DEFORMED EPIDERMAL AUTOREGULATORY FACTOR 1 HOMOLOG', 252482),
(421842, 'PTHR10237', NULL, NULL, NULL, NULL, 'DEFORMED EPIDERMAL AUTOREGULATORY FACTOR 1 HOMOLOG  SUPPRESSIN', 252482),
(421843, 'PTHR10237:SF1', NULL, NULL, NULL, NULL, 'LD37257P', 252482),
(421844, 'PTHR46023:SF2', NULL, NULL, NULL, NULL, 'LIPASE FAMILY PROTEIN, EXPRESSED', 252483),
(421845, 'PTHR46023:SF1', NULL, NULL, NULL, NULL, 'OS12G0554500 PROTEIN', 252483),
(421846, 'PTHR46023:SF6', NULL, NULL, NULL, NULL, 'LIPASE CLASS 3 FAMILY PROTEIN', 252483),
(421847, 'PTHR46023', NULL, NULL, NULL, NULL, 'LIPASE CLASS 3 PROTEIN-LIKE', 252483),
(421848, 'PTHR46023:SF7', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 252483),
(421849, 'PTHR46023:SF5', NULL, NULL, NULL, NULL, 'OS02G0780700 PROTEIN', 252483),
(421850, 'PTHR46023:SF8', NULL, NULL, NULL, NULL, 'SN1-SPECIFIC DIACYLGLYCEROL LIPASE', 252483),
(421851, 'PTHR16267:SF11', NULL, NULL, NULL, NULL, 'STUMPS, ISOFORM E', 252484),
(421852, 'PTHR16267:SF12', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE 3-KINASE ADAPTER PROTEIN 1', 252484),
(421853, 'PTHR16267:SF13', NULL, NULL, NULL, NULL, 'B-CELL SCAFFOLD PROTEIN WITH ANKYRIN REPEATS', 252484),
(421854, 'PTHR16267', NULL, NULL, NULL, NULL, 'BANK1/PIK3AP1 FAMILY MEMBER', 252484),
(421855, 'PTHR44203:SF8', NULL, NULL, NULL, NULL, 'ETHYLENE-OVERPRODUCTION PROTEIN 1', 252485),
(421856, 'PTHR44203:SF9', NULL, NULL, NULL, NULL, 'ETHYLENE-OVERPRODUCTION PROTEIN 1', 252485),
(421857, 'PTHR44203:SF7', NULL, NULL, NULL, NULL, 'BNAC03G21230D PROTEIN', 252485),
(421858, 'PTHR44203:SF11', NULL, NULL, NULL, NULL, 'ETO1-LIKE PROTEIN 1', 252485),
(421859, 'PTHR44203:SF2', NULL, NULL, NULL, NULL, 'ETO1-LIKE PROTEIN 1', 252485),
(421860, 'PTHR44203:SF3', NULL, NULL, NULL, NULL, 'ETO1-LIKE PROTEIN 2', 252485),
(421861, 'PTHR44203', NULL, NULL, NULL, NULL, 'ETO1-RELATED', 252485);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(421862, 'PTHR12317:SF0', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE', 252486),
(421863, 'PTHR12317:SF71', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE', 252486),
(421864, 'PTHR12317:SF70', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE', 252486),
(421865, 'PTHR12317:SF72', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE', 252486),
(421866, 'PTHR12317:SF61', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 252486),
(421867, 'PTHR12317:SF75', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE', 252486),
(421868, 'PTHR12317:SF63', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE 2', 252486),
(421869, 'PTHR12317:SF74', NULL, NULL, NULL, NULL, '2-ACYLGLYCEROL O-ACYLTRANSFERASE 2', 252486),
(421870, 'PTHR12317:SF66', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE', 252486),
(421871, 'PTHR12317:SF77', NULL, NULL, NULL, NULL, 'O-ACYLTRANSFERASE, PUTATIVE-RELATED', 252486),
(421872, 'PTHR12317:SF65', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE', 252486),
(421873, 'PTHR12317:SF76', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE', 252486),
(421874, 'PTHR12317:SF10', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE 2-LIKE PROTEIN DGAT2L7P-RELATED', 252486),
(421875, 'PTHR12317:SF34', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE, PUTATIVE-RELATED', 252486),
(421876, 'PTHR12317:SF12', NULL, NULL, NULL, NULL, 'ACYL-COA WAX ALCOHOL ACYLTRANSFERASE 2', 252486),
(421877, 'PTHR12317:SF6', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE', 252486),
(421878, 'PTHR12317:SF37', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE', 252486),
(421879, 'PTHR12317:SF26', NULL, NULL, NULL, NULL, '2-ACYLGLYCEROL O-ACYLTRANSFERASE 1', 252486),
(421880, 'PTHR12317:SF14', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE 2', 252486),
(421881, 'PTHR12317', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', 252486),
(421882, 'PTHR12317:SF36', NULL, NULL, NULL, NULL, '2-ACYLGLYCEROL O-ACYLTRANSFERASE 3', 252486),
(421883, 'PTHR12317:SF16', NULL, NULL, NULL, NULL, 'ACYL-COA WAX ALCOHOL ACYLTRANSFERASE 1', 252486),
(421884, 'PTHR12317:SF19', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE 2-LIKE PROTEIN 6', 252486),
(421885, 'PTHR35514', NULL, NULL, NULL, NULL, 'THYLAKOID LUMENAL 15.0 KDA PROTEIN 2, CHLOROPLASTIC', 252487),
(421886, 'PTHR35514:SF1', NULL, NULL, NULL, NULL, 'THYLAKOID LUMENAL 15.0 KDA PROTEIN 2, CHLOROPLASTIC', 252487),
(421887, 'PTHR36897:SF2', NULL, NULL, NULL, NULL, 'OS10G0351100-LIKE PROTEIN', 252488),
(421888, 'PTHR36897', NULL, NULL, NULL, NULL, 'OS10G0351100-LIKE PROTEIN', 252488),
(421889, 'PTHR31542:SF1', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L50, MITOCHONDRIAL', 252489),
(421890, 'PTHR31542', NULL, NULL, NULL, NULL, '39A RIBOSOMAL PROTEIN L50, MITOCHONDRIAL', 252489),
(421891, 'PTHR22884:SF490', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE ASHR3', 252490),
(421892, 'PTHR22884:SF293', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE NSD2', 252490),
(421893, 'PTHR22884:SF492', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE ASHH4-RELATED', 252490),
(421894, 'PTHR22884:SF487', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE ASHH3-LIKE', 252490),
(421895, 'PTHR22884:SF498', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE ASHH3', 252490),
(421896, 'PTHR22884:SF312', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE, H3 LYSINE-36 SPECIFIC', 252490),
(421897, 'PTHR22884:SF455', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE ASHH1', 252490),
(421898, 'PTHR22884:SF413', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE CG1716-RELATED', 252490),
(421899, 'PTHR22884:SF494', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE ASHR3', 252490),
(421900, 'PTHR22884:SF473', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE NSD3', 252490),
(421901, 'PTHR22884', NULL, NULL, NULL, NULL, 'SET DOMAIN PROTEINS', 252490),
(421902, 'PTHR22884:SF485', NULL, NULL, NULL, NULL, 'CW-TYPE DOMAIN-CONTAINING PROTEIN', 252490),
(421903, 'PTHR22884:SF474', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE LIN-59-RELATED', 252490);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(421904, 'PTHR22884:SF497', NULL, NULL, NULL, NULL, 'SET DOMAIN PROTEIN', 252490),
(421905, 'PTHR22884:SF506', NULL, NULL, NULL, NULL, 'SET DOMAIN PROTEIN', 252490),
(421906, 'PTHR22884:SF507', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR-BINDING SET DOMAIN PROTEIN 1B', 252490),
(421907, 'PTHR22884:SF508', NULL, NULL, NULL, NULL, '', 252490),
(421908, 'PTHR22884:SF505', NULL, NULL, NULL, NULL, '', 252490),
(421909, 'PTHR38505:SF1', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC100362176', 252491),
(421910, 'PTHR38505', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC100362176', 252491),
(421911, 'PTHR43009:SF9', NULL, NULL, NULL, NULL, 'NARINGENIN 8-DIMETHYLALLYLTRANSFERASE 1 PROTEIN-RELATED', 252492),
(421912, 'PTHR43009:SF10', NULL, NULL, NULL, NULL, 'HOMOGENTISATE SOLANESYLTRANSFERASE, CHLOROPLASTIC', 252492),
(421913, 'PTHR43009', NULL, NULL, NULL, NULL, 'HOMOGENTISATE SOLANESYLTRANSFERASE, CHLOROPLASTIC', 252492),
(421914, 'PTHR43009:SF6', NULL, NULL, NULL, NULL, 'HOMOGENTISATE PHYTYLTRANSFERASE 1, CHLOROPLASTIC', 252492),
(421915, 'PTHR43009:SF8', NULL, NULL, NULL, NULL, 'UBIA PRENYLTRANSFERASE FAMILY-RELATED', 252492),
(421916, 'PTHR43009:SF7', NULL, NULL, NULL, NULL, 'HOMOGENTISATE GERANYLGERANYLTRANSFERASE, CHLOROPLASTIC', 252492),
(421917, 'PTHR21191', NULL, NULL, NULL, NULL, 'AQUAPORIN', 252493),
(421918, 'PTHR21191:SF8', NULL, NULL, NULL, NULL, 'AQUAPORIN-12A-RELATED', 252493),
(421919, 'PTHR21191:SF7', NULL, NULL, NULL, NULL, 'AQUAPORIN-11', 252493),
(421920, 'PTHR21191:SF15', NULL, NULL, NULL, NULL, 'AQUAPORIN', 252493),
(421921, 'PTHR21191:SF16', NULL, NULL, NULL, NULL, 'AQUAPORIN', 252493),
(421922, 'PTHR21191:SF2', NULL, NULL, NULL, NULL, 'AQUAPORIN', 252493),
(421923, 'PTHR37329', NULL, NULL, NULL, NULL, 'KINETOCHORE PROTEIN SOS7', 252494),
(421924, 'PTHR37329:SF1', NULL, NULL, NULL, NULL, 'KINETOCHORE PROTEIN SOS7', 252494),
(421925, 'PTHR46596', NULL, NULL, NULL, NULL, 'SORTING NEXIN-4', 252495),
(421926, 'PTHR46596:SF1', NULL, NULL, NULL, NULL, 'SORTING NEXIN-4', 252495),
(421927, 'PTHR24183', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE 3 AND ANKYRIN REPEAT DOMAINS PROTEIN 1', 252496),
(421928, 'PTHR24183:SF1', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE 3 AND ANKYRIN REPEAT DOMAINS PROTEIN 1', 252496),
(421929, 'PTHR47575:SF1', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 10', 252497),
(421930, 'PTHR47575', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 10', 252497),
(421931, 'PTHR47197:SF3', NULL, NULL, NULL, NULL, 'DIHYDRO-HEME D1 DEHYDROGENASE', 252498),
(421932, 'PTHR47197:SF4', NULL, NULL, NULL, NULL, 'BLL6485 PROTEIN', 252498),
(421933, 'PTHR47197:SF5', NULL, NULL, NULL, NULL, 'SEVEN-BLADED BETA-PROPELLER PROTEIN RV1057', 252498),
(421934, 'PTHR47197', NULL, NULL, NULL, NULL, 'PROTEIN NIRF', 252498),
(421935, 'PTHR34194:SF2', NULL, NULL, NULL, NULL, 'F17A17.7 PROTEIN', 252499),
(421936, 'PTHR34194', NULL, NULL, NULL, NULL, 'F14J8.16 PROTEIN', 252499),
(421937, 'PTHR34194:SF27', NULL, NULL, NULL, NULL, '', 252499),
(421938, 'PTHR34194:SF26', NULL, NULL, NULL, NULL, 'BNAA05G29920D PROTEIN', 252499),
(421939, 'PTHR34194:SF18', NULL, NULL, NULL, NULL, 'BNAA02G18490D PROTEIN', 252499),
(421940, 'PTHR34194:SF28', NULL, NULL, NULL, NULL, '', 252499),
(421941, 'PTHR34194:SF22', NULL, NULL, NULL, NULL, 'F14J8.16 PROTEIN', 252499),
(421942, 'PTHR34194:SF25', NULL, NULL, NULL, NULL, 'OS05G0423200 PROTEIN', 252499),
(421943, 'PTHR34194:SF24', NULL, NULL, NULL, NULL, 'OS04G0539100 PROTEIN', 252499),
(421944, 'PTHR34194:SF13', NULL, NULL, NULL, NULL, 'NUCLEOLIN-LIKE', 252499),
(421945, 'PTHR47173:SF3', NULL, NULL, NULL, NULL, 'PROTEIN DR1 HOMOLOG', 252500),
(421946, 'PTHR47173:SF2', NULL, NULL, NULL, NULL, 'CBFD_NFYB_HMF DOMAIN-CONTAINING PROTEIN', 252500),
(421947, 'PTHR47173:SF7', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y PROTEIN', 252500),
(421948, 'PTHR47173', NULL, NULL, NULL, NULL, 'PROTEIN DR1 HOMOLOG', 252500),
(421949, 'PTHR47173:SF5', NULL, NULL, NULL, NULL, 'PROTEIN DR1 HOMOLOG', 252500),
(421950, 'PTHR47173:SF6', NULL, NULL, NULL, NULL, 'PROTEIN DR1 HOMOLOG', 252500);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(421951, 'PTHR47121', NULL, NULL, NULL, NULL, 'THYLAKOID LUMENAL PROTEIN TL20.3, CHLOROPLASTIC', 252501),
(421952, 'PTHR47121:SF3', NULL, NULL, NULL, NULL, '', 252501),
(421953, 'PTHR47121:SF2', NULL, NULL, NULL, NULL, 'THYLAKOID LUMENAL PROTEIN TL20.3, CHLOROPLASTIC', 252501),
(421954, 'PTHR31369:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG23250', 252502),
(421955, 'PTHR31369', NULL, NULL, NULL, NULL, 'PROTEIN CBG02325-RELATED', 252502),
(421956, 'PTHR31369:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG02315', 252502),
(421957, 'PTHR31369:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG03069', 252502),
(421958, 'PTHR13020:SF28', NULL, NULL, NULL, NULL, 'TRINUCLEOTIDE REPEAT-CONTAINING GENE 6A PROTEIN', 252503),
(421959, 'PTHR13020', NULL, NULL, NULL, NULL, 'TRINUCLEOTIDE REPEAT-CONTAINING GENE 6', 252503),
(421960, 'PTHR13020:SF25', NULL, NULL, NULL, NULL, 'PROTEIN GAWKY', 252503),
(421961, 'PTHR13020:SF32', NULL, NULL, NULL, NULL, 'TRINUCLEOTIDE REPEAT-CONTAINING GENE 6B PROTEIN', 252503),
(421962, 'PTHR13020:SF9', NULL, NULL, NULL, NULL, 'TRINUCLEOTIDE REPEAT-CONTAINING GENE 6C PROTEIN', 252503),
(421963, 'PTHR38371:SF1', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN', 252504),
(421964, 'PTHR38371', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN', 252504),
(421965, 'PTHR36174', NULL, NULL, NULL, NULL, 'LIPID II:GLYCINE GLYCYLTRANSFERASE', 252505),
(421966, 'PTHR36174:SF2', NULL, NULL, NULL, NULL, 'AMINOACYLTRANSFERASE FEMA', 252505),
(421967, 'PTHR36174:SF1', NULL, NULL, NULL, NULL, 'LIPID II:GLYCINE GLYCYLTRANSFERASE', 252505),
(421968, 'PTHR46535:SF1', NULL, NULL, NULL, NULL, 'NEDD4-BINDING PROTEIN 2', 252506),
(421969, 'PTHR46535', NULL, NULL, NULL, NULL, 'NEDD4-BINDING PROTEIN 2', 252506),
(421970, 'PTHR37265:SF8', NULL, NULL, NULL, NULL, '', 252507),
(421971, 'PTHR37265:SF7', NULL, NULL, NULL, NULL, 'BNAA10G10950D PROTEIN', 252507),
(421972, 'PTHR37265:SF6', NULL, NULL, NULL, NULL, '', 252507),
(421973, 'PTHR37265', NULL, NULL, NULL, NULL, 'OS01G0195300 PROTEIN', 252507),
(421974, 'PTHR37265:SF5', NULL, NULL, NULL, NULL, 'OS01G0195300 PROTEIN', 252507),
(421975, 'PTHR47146:SF1', NULL, NULL, NULL, NULL, 'OTORAPLIN', 252508),
(421976, 'PTHR47146', NULL, NULL, NULL, NULL, 'OTORAPLIN', 252508),
(421977, 'PTHR33318:SF20', NULL, NULL, NULL, NULL, 'BNAA04G19430D PROTEIN', 252509),
(421978, 'PTHR33318:SF31', NULL, NULL, NULL, NULL, 'BNAA04G17850D PROTEIN', 252509),
(421979, 'PTHR33318:SF30', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252509),
(421980, 'PTHR33318:SF7', NULL, NULL, NULL, NULL, 'ASPARTYL/GLUTAMYL-TRNA(ASN/GLN) AMIDOTRANSFERASE SUBUNIT', 252509),
(421981, 'PTHR33318:SF5', NULL, NULL, NULL, NULL, 'OS06G0670100 PROTEIN', 252509),
(421982, 'PTHR33318:SF4', NULL, NULL, NULL, NULL, 'RRNA BIOGENESIS PROTEIN RRP36', 252509),
(421983, 'PTHR33318:SF19', NULL, NULL, NULL, NULL, 'PROTEIN JASON-LIKE', 252509),
(421984, 'PTHR33318:SF29', NULL, NULL, NULL, NULL, 'HISTONE H3.V1-LIKE', 252509),
(421985, 'PTHR33318:SF18', NULL, NULL, NULL, NULL, 'PROTEIN JASON', 252509),
(421986, 'PTHR33318', NULL, NULL, NULL, NULL, 'ASPARTYL/GLUTAMYL-TRNA(ASN/GLN) AMIDOTRANSFERASE SUBUNIT', 252509),
(421987, 'PTHR33318:SF26', NULL, NULL, NULL, NULL, '', 252509),
(421988, 'PTHR33318:SF15', NULL, NULL, NULL, NULL, 'OS02G0168300 PROTEIN', 252509),
(421989, 'PTHR33318:SF25', NULL, NULL, NULL, NULL, 'BNAA08G28700D PROTEIN', 252509),
(421990, 'PTHR33318:SF28', NULL, NULL, NULL, NULL, '', 252509),
(421991, 'PTHR33318:SF17', NULL, NULL, NULL, NULL, '', 252509),
(421992, 'PTHR33318:SF16', NULL, NULL, NULL, NULL, 'FK506-BINDING NUCLEAR-LIKE PROTEIN', 252509),
(421993, 'PTHR33318:SF22', NULL, NULL, NULL, NULL, '', 252509),
(421994, 'PTHR33318:SF23', NULL, NULL, NULL, NULL, 'EISOSOME PROTEIN', 252509),
(421995, 'PTHR17098', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE MWFE SUBUNIT', 252510),
(421996, 'PTHR17098:SF5', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX SUBUNIT 1', 252510),
(421997, 'PTHR17098:SF2', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX SUBUNIT 1', 252510);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(421998, 'PTHR33713:SF3', NULL, NULL, NULL, NULL, 'ANTITOXIN', 252511),
(421999, 'PTHR33713', NULL, NULL, NULL, NULL, 'ANTITOXIN YAFN-RELATED', 252511),
(422000, 'PTHR33713:SF6', NULL, NULL, NULL, NULL, 'ANTITOXIN YEFM', 252511),
(422001, 'PTHR33713:SF9', NULL, NULL, NULL, NULL, 'ANTITOXIN', 252511),
(422002, 'PTHR33713:SF8', NULL, NULL, NULL, NULL, 'ANTITOXIN YAFN', 252511),
(422003, 'PTHR33713:SF10', NULL, NULL, NULL, NULL, 'ANTITOXIN RV0268C-RELATED', 252511),
(422004, 'PTHR33713:SF1', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', 252511),
(422005, 'PTHR44170:SF31', NULL, NULL, NULL, NULL, '', 252512),
(422006, 'PTHR44170:SF30', NULL, NULL, NULL, NULL, 'CONTACTIN-LIKE PROTEIN', 252512),
(422007, 'PTHR44170:SF17', NULL, NULL, NULL, NULL, 'CONTACTIN-5', 252512),
(422008, 'PTHR44170:SF39', NULL, NULL, NULL, NULL, 'NEOGENIN 1A-RELATED', 252512),
(422009, 'PTHR44170:SF38', NULL, NULL, NULL, NULL, 'CONTACTIN 6', 252512),
(422010, 'PTHR44170:SF37', NULL, NULL, NULL, NULL, 'ROUNDABOUT GUIDANCE RECEPTOR 3', 252512),
(422011, 'PTHR44170:SF15', NULL, NULL, NULL, NULL, 'NEURONAL CELL ADHESION MOLECULE', 252512),
(422012, 'PTHR44170:SF36', NULL, NULL, NULL, NULL, '', 252512),
(422013, 'PTHR44170:SF14', NULL, NULL, NULL, NULL, 'NEOGENIN', 252512),
(422014, 'PTHR44170:SF35', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE-III DOMAIN-CONTAINING PROTEIN', 252512),
(422015, 'PTHR44170', NULL, NULL, NULL, NULL, 'PROTEIN SIDEKICK', 252512),
(422016, 'PTHR44170:SF34', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN SUPERFAMILY, MEMBER 9A', 252512),
(422017, 'PTHR44170:SF12', NULL, NULL, NULL, NULL, 'NEUROFASCIN', 252512),
(422018, 'PTHR44170:SF33', NULL, NULL, NULL, NULL, 'BROTHER OF IHOG, ISOFORM G-RELATED', 252512),
(422019, 'PTHR44170:SF11', NULL, NULL, NULL, NULL, 'ROUNDABOUT HOMOLOG 4', 252512),
(422020, 'PTHR44170:SF10', NULL, NULL, NULL, NULL, 'CONTACTIN-1', 252512),
(422021, 'PTHR44170:SF32', NULL, NULL, NULL, NULL, 'PROTEIN TURTLE-LIKE PROTEIN', 252512),
(422022, 'PTHR44170:SF19', NULL, NULL, NULL, NULL, 'PROTEIN TURTLE HOMOLOG A', 252512),
(422023, 'PTHR44170:SF18', NULL, NULL, NULL, NULL, 'CONTACTIN 3B-RELATED', 252512),
(422024, 'PTHR44170:SF5', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN SUPERFAMILY DCC SUBCLASS MEMBER 4', 252512),
(422025, 'PTHR44170:SF6', NULL, NULL, NULL, NULL, 'PROTEIN SAX-3', 252512),
(422026, 'PTHR44170:SF7', NULL, NULL, NULL, NULL, 'PALLADIN, CYTOSKELETAL-ASSOCIATED PROTEIN', 252512),
(422027, 'PTHR44170:SF8', NULL, NULL, NULL, NULL, 'NETRIN RECEPTOR DCC', 252512),
(422028, 'PTHR44170:SF1', NULL, NULL, NULL, NULL, 'CELL ADHESION MOLECULE-RELATED/DOWN-REGULATED BY ONCOGENES', 252512),
(422029, 'PTHR44170:SF3', NULL, NULL, NULL, NULL, 'BROTHER OF CDO', 252512),
(422030, 'PTHR44170:SF4', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN SUPERFAMILY, MEMBER 9BA', 252512),
(422031, 'PTHR44170:SF20', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN SUPERFAMILY DCC SUBCLASS MEMBER 3', 252512),
(422032, 'PTHR44170:SF42', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN SUPERFAMILY MEMBER 9B', 252512),
(422033, 'PTHR44170:SF41', NULL, NULL, NULL, NULL, '', 252512),
(422034, 'PTHR44170:SF40', NULL, NULL, NULL, NULL, 'SI:CH211-57N23.4', 252512),
(422035, 'PTHR44170:SF9', NULL, NULL, NULL, NULL, 'ROUNDABOUT HOMOLOG 2', 252512),
(422036, 'PTHR44170:SF28', NULL, NULL, NULL, NULL, 'CONTACTIN-2', 252512),
(422037, 'PTHR44170:SF47', NULL, NULL, NULL, NULL, 'PROTOGENIN', 252512),
(422038, 'PTHR44170:SF46', NULL, NULL, NULL, NULL, 'PROTEIN SIDEKICK', 252512),
(422039, 'PTHR44170:SF45', NULL, NULL, NULL, NULL, 'PROTEIN TYROSINE KINASE 7 (INACTIVE)', 252512),
(422040, 'PTHR44170:SF44', NULL, NULL, NULL, NULL, 'L1 CELL ADHESION MOLECULE', 252512),
(422041, 'PTHR44170:SF43', NULL, NULL, NULL, NULL, 'MYOPALLADIN', 252512),
(422042, 'PTHR44170:SF29', NULL, NULL, NULL, NULL, '', 252512),
(422043, 'PTHR33793:SF2', NULL, NULL, NULL, NULL, 'AGGLUTININ-LIKE PROTEIN 6', 252513),
(422044, 'PTHR33793', NULL, NULL, NULL, NULL, 'ALPHA-AGGLUTININ', 252513),
(422045, 'PTHR11069:SF41', NULL, NULL, NULL, NULL, 'GLUCOSYLCERAMIDASE 3-RELATED', 252514);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(422046, 'PTHR11069', NULL, NULL, NULL, NULL, 'GLUCOSYLCERAMIDASE', 252514),
(422047, 'PTHR11069:SF33', NULL, NULL, NULL, NULL, 'LYSOSOMAL ACID GLUCOSYLCERAMIDASE', 252514),
(422048, 'PTHR11069:SF34', NULL, NULL, NULL, NULL, 'GLUCOSYLCERAMIDASE', 252514),
(422049, 'PTHR11069:SF23', NULL, NULL, NULL, NULL, 'LYSOSOMAL ACID GLUCOSYLCERAMIDASE', 252514),
(422050, 'PTHR11069:SF39', NULL, NULL, NULL, NULL, 'GLUCOSYLCERAMIDASE 2-RELATED', 252514),
(422051, 'PTHR11069:SF37', NULL, NULL, NULL, NULL, 'GLUCOSYLCERAMIDASE 1-RELATED', 252514),
(422052, 'PTHR11069:SF38', NULL, NULL, NULL, NULL, 'GLUCURONOXYLANASE XYNC', 252514),
(422053, 'PTHR38692', NULL, NULL, NULL, NULL, 'PROTEIN SMG', 252515),
(422054, 'PTHR38692:SF1', NULL, NULL, NULL, NULL, 'PROTEIN SMG', 252515),
(422055, 'PTHR12546:SF55', NULL, NULL, NULL, NULL, 'MYOFERLIN', 252516),
(422056, 'PTHR12546:SF33', NULL, NULL, NULL, NULL, 'SPERM VESICLE FUSION PROTEIN FER-1', 252516),
(422057, 'PTHR12546:SF44', NULL, NULL, NULL, NULL, 'DYSFERLIN', 252516),
(422058, 'PTHR12546', NULL, NULL, NULL, NULL, 'FER-1-LIKE', 252516),
(422059, 'PTHR12546:SF32', NULL, NULL, NULL, NULL, 'OTOFERLIN', 252516),
(422060, 'PTHR12546:SF57', NULL, NULL, NULL, NULL, 'OTOFERLIN B', 252516),
(422061, 'PTHR12546:SF34', NULL, NULL, NULL, NULL, 'FER-1-LIKE PROTEIN 5', 252516),
(422062, 'PTHR12546:SF37', NULL, NULL, NULL, NULL, 'FER-1-LIKE 6 (C. ELEGANS)', 252516),
(422063, 'PTHR12546:SF36', NULL, NULL, NULL, NULL, 'FER-1-LIKE PROTEIN 4', 252516),
(422064, 'PTHR12546:SF60', NULL, NULL, NULL, NULL, 'MISFIRE, ISOFORM F', 252516),
(422065, 'PTHR46468:SF7', NULL, NULL, NULL, NULL, 'NEDD8-SPECIFIC PROTEASE 2', 252517),
(422066, 'PTHR46468:SF4', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 252517),
(422067, 'PTHR46468:SF6', NULL, NULL, NULL, NULL, 'ULP1 PROTEASE FAMILY, C-TERMINAL CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 252517),
(422068, 'PTHR46468:SF2', NULL, NULL, NULL, NULL, 'PROTEASE, SENP8, PUTATIVE-RELATED', 252517),
(422069, 'PTHR46468:SF1', NULL, NULL, NULL, NULL, 'SENTRIN-SPECIFIC PROTEASE 8', 252517),
(422070, 'PTHR46468', NULL, NULL, NULL, NULL, 'SENTRIN-SPECIFIC PROTEASE 8', 252517),
(422071, 'PTHR13355:SF9', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE BSU40680-RELATED', 252518),
(422072, 'PTHR13355:SF19', NULL, NULL, NULL, NULL, 'GLUCOSAMINE 6-PHOSPHATE N-ACETYLTRANSFERASE 1', 252518),
(422073, 'PTHR13355:SF15', NULL, NULL, NULL, NULL, 'SI:DKEYP-50B9.1', 252518),
(422074, 'PTHR13355:SF21', NULL, NULL, NULL, NULL, 'GLUCOSAMINE 6-PHOSPHATE N-ACETYLTRANSFERASE', 252518),
(422075, 'PTHR13355:SF22', NULL, NULL, NULL, NULL, 'SLL0786 PROTEIN', 252518),
(422076, 'PTHR13355:SF11', NULL, NULL, NULL, NULL, 'GLUCOSAMINE 6-PHOSPHATE N-ACETYLTRANSFERASE', 252518),
(422077, 'PTHR13355', NULL, NULL, NULL, NULL, 'GLUCOSAMINE 6-PHOSPHATE N-ACETYLTRANSFERASE', 252518),
(422078, 'PTHR35684', NULL, NULL, NULL, NULL, '', 252519),
(422079, 'PTHR35684:SF2', NULL, NULL, NULL, NULL, '', 252519),
(422080, 'PTHR43441:SF9', NULL, NULL, NULL, NULL, 'RIBOSOMAL-PROTEIN-ALANINE ACETYLTRANSFERASE', 252520),
(422081, 'PTHR43441:SF6', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 252520),
(422082, 'PTHR43441:SF5', NULL, NULL, NULL, NULL, 'FAMILY ACETYLTRANSFERASE, PUTATIVE-RELATED', 252520),
(422083, 'PTHR43441:SF8', NULL, NULL, NULL, NULL, 'SUCCINYL-COA TRANSFERASE RV0802C-RELATED', 252520),
(422084, 'PTHR43441:SF2', NULL, NULL, NULL, NULL, 'RIBOSOMAL-PROTEIN-SERINE ACETYLTRANSFERASE', 252520),
(422085, 'PTHR43441', NULL, NULL, NULL, NULL, 'RIBOSOMAL-PROTEIN-SERINE ACETYLTRANSFERASE', 252520),
(422086, 'PTHR43441:SF3', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE-RELATED', 252520),
(422087, 'PTHR32134:SF172', NULL, NULL, NULL, NULL, '', 252521),
(422088, 'PTHR32134:SF173', NULL, NULL, NULL, NULL, 'INACTIVE SERINE/THREONINE-PROTEIN KINASE FNKD-RELATED', 252521),
(422089, 'PTHR32134:SF141', NULL, NULL, NULL, NULL, '', 252521),
(422090, 'PTHR32134:SF16', NULL, NULL, NULL, NULL, '', 252521),
(422091, 'PTHR32134:SF174', NULL, NULL, NULL, NULL, 'GIFSY-1 PROPHAGE LEUCINE-RICH REPEAT PROTEIN', 252521);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(422092, 'PTHR32134:SF175', NULL, NULL, NULL, NULL, '', 252521),
(422093, 'PTHR32134:SF13', NULL, NULL, NULL, NULL, 'FNIP REPEAT-CONTAINING PROTEIN DDB_G0289381', 252521),
(422094, 'PTHR32134:SF170', NULL, NULL, NULL, NULL, 'FNIP REPEAT-CONTAINING PROTEIN DDB_G0277323', 252521),
(422095, 'PTHR32134:SF23', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN CMBB', 252521),
(422096, 'PTHR32134:SF171', NULL, NULL, NULL, NULL, '', 252521),
(422097, 'PTHR32134:SF169', NULL, NULL, NULL, NULL, 'FNIP REPEAT-CONTAINING PROTEIN-RELATED', 252521),
(422098, 'PTHR32134:SF86', NULL, NULL, NULL, NULL, '', 252521),
(422099, 'PTHR32134:SF154', NULL, NULL, NULL, NULL, '', 252521),
(422100, 'PTHR32134:SF165', NULL, NULL, NULL, NULL, 'FNIP REPEAT-CONTAINING PROTEIN', 252521),
(422101, 'PTHR32134:SF176', NULL, NULL, NULL, NULL, '', 252521),
(422102, 'PTHR32134:SF177', NULL, NULL, NULL, NULL, '', 252521),
(422103, 'PTHR32134:SF166', NULL, NULL, NULL, NULL, 'FNIP REPEAT-CONTAINING PROTEIN DDB_G0271996-RELATED', 252521),
(422104, 'PTHR32134:SF92', NULL, NULL, NULL, NULL, '', 252521),
(422105, 'PTHR32134:SF145', NULL, NULL, NULL, NULL, '', 252521),
(422106, 'PTHR32134:SF167', NULL, NULL, NULL, NULL, '', 252521),
(422107, 'PTHR32134:SF168', NULL, NULL, NULL, NULL, '', 252521),
(422108, 'PTHR32134', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252521),
(422109, 'PTHR14859:SF9', NULL, NULL, NULL, NULL, 'ENDONUCLEASE/EXONUCLEASE/PHOSPHATASE, PGAP2-INTERACTING PROTEIN-RELATED', 252522),
(422110, 'PTHR14859:SF10', NULL, NULL, NULL, NULL, 'DNASE I-LIKE SUPERFAMILY PROTEIN', 252522),
(422111, 'PTHR14859:SF15', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 252522),
(422112, 'PTHR14859', NULL, NULL, NULL, NULL, 'CALCOFLUOR WHITE HYPERSENSITIVE PROTEIN PRECURSOR', 252522),
(422113, 'PTHR14859:SF14', NULL, NULL, NULL, NULL, '', 252522),
(422114, 'PTHR14859:SF1', NULL, NULL, NULL, NULL, 'PGAP2-INTERACTING PROTEIN', 252522),
(422115, 'PTHR14859:SF0', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 252522),
(422116, 'PTHR11509:SF0', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN HORMONES ALPHA CHAIN', 252523),
(422117, 'PTHR11509', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN HORMONE ALPHA CHAIN', 252523),
(422118, 'PTHR34211', NULL, NULL, NULL, NULL, 'CALCINEURIN-LIKE METALLO-PHOSPHOESTERASE SUPERFAMILY PROTEIN', 252524),
(422119, 'PTHR34211:SF8', NULL, NULL, NULL, NULL, 'CALCINEURIN-LIKE METALLO-PHOSPHOESTERASE SUPERFAMILY PROTEIN-RELATED', 252524),
(422120, 'PTHR34211:SF7', NULL, NULL, NULL, NULL, 'METALLOPHOS DOMAIN-CONTAINING PROTEIN', 252524),
(422121, 'PTHR34211:SF6', NULL, NULL, NULL, NULL, 'OS07G0106000 PROTEIN', 252524),
(422122, 'PTHR34211:SF5', NULL, NULL, NULL, NULL, 'METALLOPHOS DOMAIN-CONTAINING PROTEIN', 252524),
(422123, 'PTHR34211:SF4', NULL, NULL, NULL, NULL, 'CALCINEURIN-LIKE METALLO-PHOSPHOESTERASE SUPERFAMILY PROTEIN', 252524),
(422124, 'PTHR34211:SF3', NULL, NULL, NULL, NULL, 'CALCINEURIN-LIKE METALLO-PHOSPHOESTERASE SUPERFAMILY PROTEIN', 252524),
(422125, 'PTHR46148:SF51', NULL, NULL, NULL, NULL, '''CHROMO'' DOMAIN CONTAINING PROTEIN', 252525),
(422126, 'PTHR46148:SF52', NULL, NULL, NULL, NULL, 'CHROMO DOMAIN-CONTAINING PROTEIN', 252525),
(422127, 'PTHR46148:SF53', NULL, NULL, NULL, NULL, '', 252525),
(422128, 'PTHR46148:SF54', NULL, NULL, NULL, NULL, '', 252525),
(422129, 'PTHR46148:SF44', NULL, NULL, NULL, NULL, 'GAG-POL POLYPROTEIN', 252525),
(422130, 'PTHR46148:SF55', NULL, NULL, NULL, NULL, 'RETROTRANSPOSON-LIKE PROTEIN', 252525),
(422131, 'PTHR46148', NULL, NULL, NULL, NULL, 'CHROMO DOMAIN-CONTAINING PROTEIN', 252525),
(422132, 'PTHR46148:SF56', NULL, NULL, NULL, NULL, 'RETROTRANSPOSON PROTEIN', 252525),
(422133, 'PTHR46148:SF57', NULL, NULL, NULL, NULL, 'OS12G0499874 PROTEIN', 252525),
(422134, 'PTHR43556', NULL, NULL, NULL, NULL, 'PEPTIDE CHAIN RELEASE FACTOR RF3', 252526),
(422135, 'PTHR43556:SF2', NULL, NULL, NULL, NULL, 'PEPTIDE CHAIN RELEASE FACTOR RF3', 252526),
(422136, 'PTHR38003:SF1', NULL, NULL, NULL, NULL, 'THYMIC STROMAL LYMPHOPOIETIN', 252527); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(422137, 'PTHR38003', NULL, NULL, NULL, NULL, 'THYMIC STROMAL LYMPHOPOIETIN', 252527),
(422138, 'PTHR32044:SF82', NULL, NULL, NULL, NULL, 'BNAA04G20690D PROTEIN', 252528),
(422139, 'PTHR32044:SF60', NULL, NULL, NULL, NULL, 'GLUCOMANNAN 4-BETA-MANNOSYLTRANSFERASE 9-LIKE', 252528),
(422140, 'PTHR32044:SF83', NULL, NULL, NULL, NULL, 'GLYCO_TRANS_2-LIKE DOMAIN-CONTAINING PROTEIN', 252528),
(422141, 'PTHR32044:SF84', NULL, NULL, NULL, NULL, 'XYLOGLUCAN GLYCOSYLTRANSFERASE 5-RELATED', 252528),
(422142, 'PTHR32044:SF63', NULL, NULL, NULL, NULL, 'GLUCOMANNAN 4-BETA-MANNOSYLTRANSFERASE 14-RELATED', 252528),
(422143, 'PTHR32044:SF85', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-DIPHOSPHO-SUGAR TRANSFERASE-RELATED', 252528),
(422144, 'PTHR32044:SF80', NULL, NULL, NULL, NULL, 'XYLOGLUCAN GLYCOSYLTRANSFERASE 2-RELATED', 252528),
(422145, 'PTHR32044:SF68', NULL, NULL, NULL, NULL, 'GLUCOMANNAN 4-BETA-MANNOSYLTRANSFERASE 5-RELATED', 252528),
(422146, 'PTHR32044:SF69', NULL, NULL, NULL, NULL, 'XYLOGLUCAN GLYCOSYLTRANSFERASE 3-RELATED', 252528),
(422147, 'PTHR32044:SF64', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE-LIKE PROTEIN A1', 252528),
(422148, 'PTHR32044:SF86', NULL, NULL, NULL, NULL, 'GLYCO_TRANS_2-LIKE DOMAIN-CONTAINING PROTEIN', 252528),
(422149, 'PTHR32044:SF43', NULL, NULL, NULL, NULL, 'GLUCOMANNAN 4-BETA-MANNOSYLTRANSFERASE 4-RELATED', 252528),
(422150, 'PTHR32044:SF65', NULL, NULL, NULL, NULL, 'GLUCOMANNAN 4-BETA-MANNOSYLTRANSFERASE 10-RELATED', 252528),
(422151, 'PTHR32044:SF21', NULL, NULL, NULL, NULL, 'GLUCOMANNAN 4-BETA-MANNOSYLTRANSFERASE 3-RELATED', 252528),
(422152, 'PTHR32044:SF44', NULL, NULL, NULL, NULL, 'XYLOGLUCAN GLYCOSYLTRANSFERASE 12-RELATED', 252528),
(422153, 'PTHR32044:SF66', NULL, NULL, NULL, NULL, 'GLUCOMANNAN 4-BETA-MANNOSYLTRANSFERASE 15-RELATED', 252528),
(422154, 'PTHR32044:SF89', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-DIPHOSPHO-SUGAR TRANSFERASE-RELATED', 252528),
(422155, 'PTHR32044:SF67', NULL, NULL, NULL, NULL, 'XYLOGLUCAN GLYCOSYLTRANSFERASE 6-RELATED', 252528),
(422156, 'PTHR32044:SF17', NULL, NULL, NULL, NULL, 'GLUCOMANNAN 4-BETA-MANNOSYLTRANSFERASE 2', 252528),
(422157, 'PTHR32044:SF18', NULL, NULL, NULL, NULL, 'GLUCOMANNAN 4-BETA-MANNOSYLTRANSFERASE 6-RELATED', 252528),
(422158, 'PTHR32044:SF100', NULL, NULL, NULL, NULL, 'MANNAN SYNTHASE 7-RELATED', 252528),
(422159, 'PTHR32044:SF94', NULL, NULL, NULL, NULL, 'GLYCO_TRANS_2-LIKE DOMAIN-CONTAINING PROTEIN', 252528),
(422160, 'PTHR32044:SF95', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-DIPHOSPHO-SUGAR TRANSFERASE-RELATED', 252528),
(422161, 'PTHR32044:SF51', NULL, NULL, NULL, NULL, 'XYLOGLUCAN GLYCOSYLTRANSFERASE 9-RELATED', 252528),
(422162, 'PTHR32044:SF73', NULL, NULL, NULL, NULL, 'GLUCOMANNAN 4-BETA-MANNOSYLTRANSFERASE 1-RELATED', 252528),
(422163, 'PTHR32044:SF90', NULL, NULL, NULL, NULL, 'GLUCOMANNAN 4-BETA-MANNOSYLTRANSFERASE 9-LIKE', 252528),
(422164, 'PTHR32044:SF91', NULL, NULL, NULL, NULL, 'GLUCOMANNAN 4-BETA-MANNOSYLTRANSFERASE 2-LIKE', 252528),
(422165, 'PTHR32044:SF70', NULL, NULL, NULL, NULL, 'XYLOGLUCAN GLYCOSYLTRANSFERASE 8-RELATED', 252528),
(422166, 'PTHR32044:SF79', NULL, NULL, NULL, NULL, 'GLUCOMANNAN 4-BETA-MANNOSYLTRANSFERASE 2-RELATED', 252528),
(422167, 'PTHR32044:SF58', NULL, NULL, NULL, NULL, 'GLUCOMANNAN 4-BETA-MANNOSYLTRANSFERASE 11-RELATED', 252528),
(422168, 'PTHR32044', NULL, NULL, NULL, NULL, 'GLUCOMANNAN 4-BETA-MANNOSYLTRANSFERASE 9', 252528),
(422169, 'PTHR32044:SF59', NULL, NULL, NULL, NULL, 'XYLOGLUCAN GLYCOSYLTRANSFERASE 10-RELATED', 252528),
(422170, 'PTHR32044:SF16', NULL, NULL, NULL, NULL, 'XYLOGLUCAN GLYCOSYLTRANSFERASE 7-RELATED', 252528),
(422171, 'PTHR32044:SF75', NULL, NULL, NULL, NULL, 'GLUCOMANNAN 4-BETA-MANNOSYLTRANSFERASE 1', 252528),
(422172, 'PTHR32044:SF53', NULL, NULL, NULL, NULL, 'XYLOGLUCAN GLYCOSYLTRANSFERASE 12-RELATED', 252528),
(422173, 'PTHR32044:SF97', NULL, NULL, NULL, NULL, 'XYLOGLUCAN GLYCOSYLTRANSFERASE 1-RELATED', 252528),
(422174, 'PTHR32044:SF54', NULL, NULL, NULL, NULL, 'GLUCOMANNAN 4-BETA-MANNOSYLTRANSFERASE 11-RELATED', 252528),
(422175, 'PTHR32044:SF98', NULL, NULL, NULL, NULL, 'GLUCOMANNAN 4-BETA-MANNOSYLTRANSFERASE 3-RELATED', 252528);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(422176, 'PTHR32044:SF76', NULL, NULL, NULL, NULL, 'GLYCO_TRANS_2-LIKE DOMAIN-CONTAINING PROTEIN', 252528),
(422177, 'PTHR32044:SF77', NULL, NULL, NULL, NULL, 'GLUCOMANNAN 4-BETA-MANNOSYLTRANSFERASE 9', 252528),
(422178, 'PTHR32044:SF11', NULL, NULL, NULL, NULL, 'XYLOGLUCAN GLYCOSYLTRANSFERASE 4', 252528),
(422179, 'PTHR32044:SF99', NULL, NULL, NULL, NULL, 'GLYCO_TRANS_2-LIKE DOMAIN-CONTAINING PROTEIN', 252528),
(422180, 'PTHR32044:SF78', NULL, NULL, NULL, NULL, 'GLUCOMANNAN 4-BETA-MANNOSYLTRANSFERASE 7', 252528),
(422181, 'PTHR32044:SF12', NULL, NULL, NULL, NULL, 'GLUCOMANNAN 4-BETA-MANNOSYLTRANSFERASE 7-RELATED', 252528),
(422182, 'PTHR31876:SF15', NULL, NULL, NULL, NULL, 'COV-LIKE PROTEIN 1', 252529),
(422183, 'PTHR31876:SF26', NULL, NULL, NULL, NULL, 'PROTEIN LIKE COV 2', 252529),
(422184, 'PTHR31876', NULL, NULL, NULL, NULL, 'COV-LIKE PROTEIN 1', 252529),
(422185, 'PTHR31876:SF25', NULL, NULL, NULL, NULL, '', 252529),
(422186, 'PTHR31876:SF22', NULL, NULL, NULL, NULL, 'BNAC07G03830D PROTEIN', 252529),
(422187, 'PTHR31876:SF23', NULL, NULL, NULL, NULL, 'PROTEIN LIKE COV 3', 252529),
(422188, 'PTHR31876:SF20', NULL, NULL, NULL, NULL, 'PROTEIN LIKE COV 1-LIKE', 252529),
(422189, 'PTHR31876:SF7', NULL, NULL, NULL, NULL, 'OS02G0269000 PROTEIN', 252529),
(422190, 'PTHR31876:SF19', NULL, NULL, NULL, NULL, 'PROTEIN CONTINUOUS VASCULAR RING 1-RELATED', 252529),
(422191, 'PTHR31876:SF3', NULL, NULL, NULL, NULL, 'OS05G0437200 PROTEIN', 252529),
(422192, 'PTHR31876:SF4', NULL, NULL, NULL, NULL, 'PROTEIN LIKE COV 2-LIKE', 252529),
(422193, 'PTHR31876:SF29', NULL, NULL, NULL, NULL, 'PROTEIN LIKE COV 3', 252529),
(422194, 'PTHR11388:SF16', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER ORGANIC ANION TRANSPORTER FAMILY MEMBER 1A2', 252530),
(422195, 'PTHR11388:SF99', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER ORGANIC ANION TRANSPORTER FAMILY MEMBER 1C1', 252530),
(422196, 'PTHR11388:SF14', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER ORGANIC ANION TRANSPORTER FAMILY MEMBER 2A1', 252530),
(422197, 'PTHR11388:SF95', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER ORGANIC ANION TRANSPORTER FAMILY MEMBER 6A1', 252530),
(422198, 'PTHR11388:SF129', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER ORGANIC ANION TRANSPORTER FAMILY, MEMBER 6C1', 252530),
(422199, 'PTHR11388:SF76', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER ORGANIC ANION TRANSPORTER FAMILY MEMBER', 252530),
(422200, 'PTHR11388:SF100', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER ORGANIC ANION TRANSPORTER FAMILY MEMBER 4A1', 252530),
(422201, 'PTHR11388:SF148', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER ORGANIC ANION TRANSPORTER FAMILY MEMBER-RELATED', 252530),
(422202, 'PTHR11388:SF103', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER ORGANIC ANION TRANSPORTER FAMILY MEMBER 4C1', 252530),
(422203, 'PTHR11388:SF149', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER ORGANIC ANION TRANSPORTER FAMILY MEMBER 1A1', 252530),
(422204, 'PTHR11388:SF160', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER ORGANIC ANION TRANSPORTER FAMILY MEMBER', 252530),
(422205, 'PTHR11388:SF142', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER ORGANIC ANION TRANSPORTER FAMILY MEMBER 5A1', 252530),
(422206, 'PTHR11388:SF89', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER ORGANIC ANION TRANSPORTER FAMILY MEMBER 1B3', 252530),
(422207, 'PTHR11388:SF4', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER ORGANIC ANION TRANSPORTER FAMILY, MEMBER 6D1', 252530),
(422208, 'PTHR11388:SF84', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER ORGANIC ANION TRANSPORTER FAMILY MEMBER 1A6', 252530),
(422209, 'PTHR11388:SF87', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER ORGANIC ANION TRANSPORTER FAMILY MEMBER 2B1', 252530),
(422210, 'PTHR11388:SF86', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER ORGANIC ANION TRANSPORTER FAMILY MEMBER 3A1', 252530),
(422211, 'PTHR11388:SF83', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER ORGANIC ANION TRANSPORTER FAMILY MEMBER', 252530),
(422212, 'PTHR11388:SF82', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER ORGANIC ANION TRANSPORTER FAMILY MEMBER 1B1', 252530),
(422213, 'PTHR11388:SF133', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER ORGANIC ANION TRANSPORTER FAMILY MEMBER', 252530);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(422214, 'PTHR11388:SF154', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER ORGANIC ANION TRANSPORTER FAMILY MEMBER 1B7-RELATED', 252530),
(422215, 'PTHR11388:SF157', NULL, NULL, NULL, NULL, 'KAZAL-LIKE DOMAIN-CONTAINING PROTEIN', 252530),
(422216, 'PTHR11388:SF159', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER ORGANIC ANION TRANSPORTER FAMILY MEMBER 74D', 252530),
(422217, 'PTHR11388:SF158', NULL, NULL, NULL, NULL, 'ORGANIC ANION TRANSPORTING POLYPEPTIDE 33EB', 252530),
(422218, 'PTHR11388', NULL, NULL, NULL, NULL, 'ORGANIC ANION TRANSPORTER', 252530),
(422219, 'PTHR11388:SF151', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER ORGANIC ANION TRANSPORTER FAMILY MEMBER', 252530),
(422220, 'PTHR11388:SF150', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER ORGANIC ANION TRANSPORTER FAMILY MEMBER', 252530),
(422221, 'PTHR11388:SF153', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER ORGANIC ANION TRANSPORTER FAMILY MEMBER', 252530),
(422222, 'PTHR11388:SF131', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER ORGANIC ANION TRANSPORTER FAMILY MEMBER', 252530),
(422223, 'PTHR36854:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 9, WHOLE GENOME SHOTGUN SEQUENCE', 252531),
(422224, 'PTHR36854', NULL, NULL, NULL, NULL, 'CHROMOSOME 9, WHOLE GENOME SHOTGUN SEQUENCE', 252531),
(422225, 'PTHR14390:SF2', NULL, NULL, NULL, NULL, 'G PATCH DOMAIN-CONTAINING PROTEIN 3', 252532),
(422226, 'PTHR14390', NULL, NULL, NULL, NULL, 'G PATCH DOMAIN CONTAINING PROTEIN 3', 252532),
(422227, 'PTHR34741:SF1', NULL, NULL, NULL, NULL, '', 252533),
(422228, 'PTHR34741:SF2', NULL, NULL, NULL, NULL, 'IMAP FAMILY MEMBER 1, PUTATIVE-RELATED', 252533),
(422229, 'PTHR34741', NULL, NULL, NULL, NULL, 'IMAP FAMILY MEMBER 1, PUTATIVE-RELATED', 252533),
(422230, 'PTHR23182', NULL, NULL, NULL, NULL, 'BREAKPOINT CLUSTER REGION PROTEIN  BCR', 252534),
(422231, 'PTHR23182:SF3', NULL, NULL, NULL, NULL, 'BREAKPOINT CLUSTER REGION PROTEIN', 252534),
(422232, 'PTHR23182:SF1', NULL, NULL, NULL, NULL, 'RHO GTPASE ACTIVATING PROTEIN AT 1A, ISOFORM E', 252534),
(422233, 'PTHR23182:SF6', NULL, NULL, NULL, NULL, 'SI:DKEY-33C9.6', 252534),
(422234, 'PTHR23182:SF5', NULL, NULL, NULL, NULL, 'ACTIVE BREAKPOINT CLUSTER REGION-RELATED PROTEIN', 252534),
(422235, 'PTHR15881', NULL, NULL, NULL, NULL, 'MARGINAL ZONE B- AND B1-CELL-SPECIFIC PROTEIN', 252535),
(422236, 'PTHR15881:SF2', NULL, NULL, NULL, NULL, 'MARGINAL ZONE B- AND B1-CELL-SPECIFIC PROTEIN', 252535),
(422237, 'PTHR23150:SF36', NULL, NULL, NULL, NULL, 'HERCYNINE OXYGENASE', 252536),
(422238, 'PTHR23150:SF35', NULL, NULL, NULL, NULL, 'BLL6746 PROTEIN', 252536),
(422239, 'PTHR23150:SF33', NULL, NULL, NULL, NULL, 'INACTIVE C-ALPHA-FORMYLGLYCINE-GENERATING ENZYME 2', 252536),
(422240, 'PTHR23150', NULL, NULL, NULL, NULL, 'SULFATASE MODIFYING FACTOR 1, 2', 252536),
(422241, 'PTHR23150:SF26', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE, PUTATIVE-RELATED', 252536),
(422242, 'PTHR23150:SF19', NULL, NULL, NULL, NULL, 'FORMYLGLYCINE-GENERATING ENZYME', 252536),
(422243, 'PTHR42887:SF2', NULL, NULL, NULL, NULL, 'OS12G0638800 PROTEIN', 252537),
(422244, 'PTHR42887:SF1', NULL, NULL, NULL, NULL, 'BLR3961 PROTEIN', 252537),
(422245, 'PTHR42887', NULL, NULL, NULL, NULL, 'OS12G0638800 PROTEIN', 252537),
(422246, 'PTHR35326:SF3', NULL, NULL, NULL, NULL, 'PROTEIN PSBN', 252538),
(422247, 'PTHR35326:SF7', NULL, NULL, NULL, NULL, 'PROTEIN PSBN', 252538),
(422248, 'PTHR35326:SF6', NULL, NULL, NULL, NULL, 'PROTEIN PSBN', 252538),
(422249, 'PTHR35326', NULL, NULL, NULL, NULL, 'PROTEIN PSBN', 252538),
(422250, 'PTHR10573:SF0', NULL, NULL, NULL, NULL, 'INTERLEUKIN-2 RECEPTOR SUBUNIT ALPHA', 252539),
(422251, 'PTHR10573', NULL, NULL, NULL, NULL, 'INTERLEUKIN-2 RECEPTOR ALPHA CHAIN', 252539),
(422252, 'PTHR11523:SF50', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM-TRANSPORTING ATPASE SUBUNIT BETA', 252540),
(422253, 'PTHR11523:SF31', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM-TRANSPORTING ATPASE SUBUNIT BETA-1', 252540),
(422254, 'PTHR11523:SF52', NULL, NULL, NULL, NULL, 'NA+/K+ ATPASE, BETA SUBUNIT', 252540),
(422255, 'PTHR11523:SF30', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM-TRANSPORTING ATPASE SUBUNIT BETA-1', 252540);
INSERT INTO "PUBLIC"."MODEL" VALUES
(422256, 'PTHR11523:SF11', NULL, NULL, NULL, NULL, 'POTASSIUM-TRANSPORTING ATPASE SUBUNIT BETA', 252540),
(422257, 'PTHR11523', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM-DEPENDENT ATPASE BETA SUBUNIT', 252540),
(422258, 'PTHR11523:SF10', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM-TRANSPORTING ATPASE SUBUNIT BETA-1', 252540),
(422259, 'PTHR11523:SF46', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM-TRANSPORTING ATPASE SUBUNIT BETA-2', 252540),
(422260, 'PTHR11523:SF12', NULL, NULL, NULL, NULL, 'PROTEIN ATP1B4', 252540),
(422261, 'PTHR11523:SF26', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM-TRANSPORTING ATPASE SUBUNIT BETA-2', 252540),
(422262, 'PTHR11523:SF47', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM-TRANSPORTING ATPASE SUBUNIT BETA-3', 252540),
(422263, 'PTHR11523:SF28', NULL, NULL, NULL, NULL, 'AT04468P-RELATED', 252540),
(422264, 'PTHR21077:SF11', NULL, NULL, NULL, NULL, 'ERCC4 DOMAIN-CONTAINING PROTEIN', 252541),
(422265, 'PTHR21077', NULL, NULL, NULL, NULL, 'EME1 PROTEIN', 252541),
(422266, 'PTHR21077:SF6', NULL, NULL, NULL, NULL, 'CROSSOVER JUNCTION ENDONUCLEASE EME2-RELATED', 252541),
(422267, 'PTHR21077:SF7', NULL, NULL, NULL, NULL, 'CROSSOVER JUNCTION ENDONUCLEASE EME1', 252541),
(422268, 'PTHR21077:SF8', NULL, NULL, NULL, NULL, 'ERCC4 DOMAIN-CONTAINING PROTEIN', 252541),
(422269, 'PTHR21077:SF5', NULL, NULL, NULL, NULL, 'CROSSOVER JUNCTION ENDONUCLEASE MMS4', 252541),
(422270, 'PTHR11860:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN TMIGD3', 252542),
(422271, 'PTHR11860:SF109', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 252542),
(422272, 'PTHR11860:SF108', NULL, NULL, NULL, NULL, 'CMRF35-LIKE MOLECULE 5', 252542),
(422273, 'PTHR11860:SF103', NULL, NULL, NULL, NULL, 'CMRF35-LIKE MOLECULE 7', 252542),
(422274, 'PTHR11860:SF113', NULL, NULL, NULL, NULL, 'CMRF-35-LIKE MOLECULE 4-RELATED', 252542),
(422275, 'PTHR11860:SF49', NULL, NULL, NULL, NULL, 'HIGH AFFINITY IMMUNOGLOBULIN ALPHA AND IMMUNOGLOBULIN MU FC RECEPTOR', 252542),
(422276, 'PTHR11860:SF101', NULL, NULL, NULL, NULL, 'CD300 MOLECULE-LIKE FAMILY MEMBER D2-RELATED', 252542),
(422277, 'PTHR11860:SF59', NULL, NULL, NULL, NULL, 'FAS APOPTOTIC INHIBITORY MOLECULE 3', 252542),
(422278, 'PTHR11860:SF112', NULL, NULL, NULL, NULL, 'PROTEIN CD300H', 252542),
(422279, 'PTHR11860:SF37', NULL, NULL, NULL, NULL, 'TREM-LIKE TRANSCRIPT 1 PROTEIN', 252542),
(422280, 'PTHR11860:SF111', NULL, NULL, NULL, NULL, 'IG DOMAIN-CONTAINING PROTEIN-RELATED', 252542),
(422281, 'PTHR11860:SF107', NULL, NULL, NULL, NULL, 'CMRF35-LIKE MOLECULE 6', 252542),
(422282, 'PTHR11860:SF89', NULL, NULL, NULL, NULL, 'CMRF35-LIKE MOLECULE 2', 252542),
(422283, 'PTHR11860:SF104', NULL, NULL, NULL, NULL, 'CMRF35-LIKE MOLECULE 6', 252542),
(422284, 'PTHR11860:SF87', NULL, NULL, NULL, NULL, 'CMRF35-LIKE MOLECULE 8', 252542),
(422285, 'PTHR11860:SF54', NULL, NULL, NULL, NULL, 'TRIGGERING RECEPTOR EXPRESSED ON MYELOID CELLS 2', 252542),
(422286, 'PTHR11860:SF98', NULL, NULL, NULL, NULL, 'IGV DOMAIN-CONTAINING PROTEIN', 252542),
(422287, 'PTHR11860:SF96', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 252542),
(422288, 'PTHR11860', NULL, NULL, NULL, NULL, 'POLYMERIC-IMMUNOGLOBULIN RECEPTOR', 252542),
(422289, 'PTHR11860:SF62', NULL, NULL, NULL, NULL, 'CMRF35-LIKE MOLECULE 9', 252542),
(422290, 'PTHR11860:SF83', NULL, NULL, NULL, NULL, 'CMRF35-LIKE MOLECULE 1-RELATED', 252542),
(422291, 'PTHR11860:SF82', NULL, NULL, NULL, NULL, 'POLYMERIC IMMUNOGLOBULIN RECEPTOR', 252542),
(422292, 'PTHR11860:SF110', NULL, NULL, NULL, NULL, 'CMRF35-LIKE MOLECULE 1', 252542),
(422293, 'PTHR46393:SF7', NULL, NULL, NULL, NULL, '', 252543),
(422294, 'PTHR46393:SF6', NULL, NULL, NULL, NULL, 'COMPLEMENT COMPONENT BFB-RELATED', 252543),
(422295, 'PTHR46393', NULL, NULL, NULL, NULL, 'SUSHI DOMAIN-CONTAINING PROTEIN', 252543),
(422296, 'PTHR46393:SF2', NULL, NULL, NULL, NULL, 'COMPLEMENT C2', 252543),
(422297, 'PTHR46393:SF1', NULL, NULL, NULL, NULL, 'COMPLEMENT FACTOR B', 252543),
(422298, 'PTHR46393:SF8', NULL, NULL, NULL, NULL, 'SI:CH1073-280E3.1', 252543); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(422299, 'PTHR35984:SF1', NULL, NULL, NULL, NULL, 'PERIPLASMIC SERINE PROTEASE', 252544),
(422300, 'PTHR35984:SF4', NULL, NULL, NULL, NULL, '', 252544),
(422301, 'PTHR35984', NULL, NULL, NULL, NULL, 'PERIPLASMIC SERINE PROTEASE', 252544),
(422302, 'PTHR10859:SF105', NULL, NULL, NULL, NULL, 'DOLICHYL-PHOSPHATE BETA-D-MANNOSYLTRANSFERASE', 252545),
(422303, 'PTHR10859', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE', 252545),
(422304, 'PTHR10859:SF108', NULL, NULL, NULL, NULL, 'DOLICHYL-PHOSPHATE BETA-GLUCOSYLTRANSFERASE', 252545),
(422305, 'PTHR10859:SF91', NULL, NULL, NULL, NULL, 'DOLICHYL-PHOSPHATE BETA-GLUCOSYLTRANSFERASE', 252545),
(422306, 'PTHR10859:SF113', NULL, NULL, NULL, NULL, 'DOLICHYL-PHOSPHATE BETA-D-MANNOSYLTRANSFERASE', 252545),
(422307, 'PTHR10859:SF114', NULL, NULL, NULL, NULL, 'DOLICHOL-PHOSPHATE MANNOSYLTRANSFERASE', 252545),
(422308, 'PTHR31734:SF149', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422309, 'PTHR31734:SF148', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422310, 'PTHR31734:SF147', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422311, 'PTHR31734:SF261', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA13', 252546),
(422312, 'PTHR31734:SF260', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA14', 252546),
(422313, 'PTHR31734:SF259', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422314, 'PTHR31734:SF138', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA9', 252546),
(422315, 'PTHR31734:SF258', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422316, 'PTHR31734:SF139', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN', 252546),
(422317, 'PTHR31734:SF255', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA34', 252546),
(422318, 'PTHR31734:SF134', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA28', 252546),
(422319, 'PTHR31734:SF254', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA7', 252546),
(422320, 'PTHR31734:SF136', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA10', 252546),
(422321, 'PTHR31734:SF257', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422322, 'PTHR31734:SF256', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA26', 252546),
(422323, 'PTHR31734:SF130', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA18', 252546),
(422324, 'PTHR31734:SF251', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA8', 252546),
(422325, 'PTHR31734:SF250', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA26', 252546),
(422326, 'PTHR31734:SF253', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422327, 'PTHR31734:SF252', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA21', 252546),
(422328, 'PTHR31734:SF131', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA12', 252546),
(422329, 'PTHR31734:SF203', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422330, 'PTHR31734:SF205', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422331, 'PTHR31734:SF200', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422332, 'PTHR31734:SF166', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422333, 'PTHR31734:SF202', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422334, 'PTHR31734:SF201', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422335, 'PTHR31734:SF208', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN', 252546),
(422336, 'PTHR31734:SF162', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422337, 'PTHR31734:SF161', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN', 252546),
(422338, 'PTHR31734:SF159', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422339, 'PTHR31734:SF157', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA27', 252546),
(422340, 'PTHR31734:SF92', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA23', 252546),
(422341, 'PTHR31734:SF94', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA30', 252546),
(422342, 'PTHR31734:SF95', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA3', 252546),
(422343, 'PTHR31734:SF7', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA33', 252546);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(422344, 'PTHR31734:SF8', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA3', 252546),
(422345, 'PTHR31734:SF87', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA5', 252546),
(422346, 'PTHR31734:SF88', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA9', 252546),
(422347, 'PTHR31734:SF6', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA11', 252546),
(422348, 'PTHR31734:SF2', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA7', 252546),
(422349, 'PTHR31734:SF151', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422350, 'PTHR31734:SF226', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA17', 252546),
(422351, 'PTHR31734:SF225', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422352, 'PTHR31734:SF104', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN', 252546),
(422353, 'PTHR31734:SF106', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422354, 'PTHR31734:SF227', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA4', 252546),
(422355, 'PTHR31734:SF189', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422356, 'PTHR31734:SF222', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA2', 252546),
(422357, 'PTHR31734:SF221', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA6', 252546),
(422358, 'PTHR31734:SF224', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422359, 'PTHR31734:SF103', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA16', 252546),
(422360, 'PTHR31734:SF16', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA5', 252546),
(422361, 'PTHR31734:SF14', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA14', 252546),
(422362, 'PTHR31734:SF185', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422363, 'PTHR31734:SF184', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422364, 'PTHR31734:SF215', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422365, 'PTHR31734:SF214', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422366, 'PTHR31734:SF216', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA31', 252546),
(422367, 'PTHR31734:SF178', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422368, 'PTHR31734:SF211', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422369, 'PTHR31734:SF177', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422370, 'PTHR31734:SF213', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422371, 'PTHR31734:SF212', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422372, 'PTHR31734:SF179', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422373, 'PTHR31734:SF219', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422374, 'PTHR31734:SF28', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA13', 252546),
(422375, 'PTHR31734', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA17', 252546),
(422376, 'PTHR31734:SF25', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA12', 252546),
(422377, 'PTHR31734:SF173', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA19', 252546),
(422378, 'PTHR31734:SF175', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422379, 'PTHR31734:SF172', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422380, 'PTHR31734:SF171', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422381, 'PTHR31734:SF248', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422382, 'PTHR31734:SF126', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA17', 252546),
(422383, 'PTHR31734:SF247', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422384, 'PTHR31734:SF249', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA15', 252546),
(422385, 'PTHR31734:SF244', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422386, 'PTHR31734:SF243', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN', 252546),
(422387, 'PTHR31734:SF246', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422388, 'PTHR31734:SF245', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA30', 252546);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(422389, 'PTHR31734:SF41', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA28-RELATED', 252546),
(422390, 'PTHR31734:SF34', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA15', 252546),
(422391, 'PTHR31734:SF35', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA27', 252546),
(422392, 'PTHR31734:SF33', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA16', 252546),
(422393, 'PTHR31734:SF38', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA29', 252546),
(422394, 'PTHR31734:SF240', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422395, 'PTHR31734:SF121', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA19', 252546),
(422396, 'PTHR31734:SF242', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA1', 252546),
(422397, 'PTHR31734:SF120', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA25', 252546),
(422398, 'PTHR31734:SF241', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA6', 252546),
(422399, 'PTHR31734:SF237', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA18', 252546),
(422400, 'PTHR31734:SF236', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN', 252546),
(422401, 'PTHR31734:SF239', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422402, 'PTHR31734:SF238', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422403, 'PTHR31734:SF199', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422404, 'PTHR31734:SF232', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422405, 'PTHR31734:SF111', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422406, 'PTHR31734:SF114', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA32', 252546),
(422407, 'PTHR31734:SF235', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA20', 252546),
(422408, 'PTHR31734:SF234', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422409, 'PTHR31734:SF45', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA2', 252546),
(422410, 'PTHR31734:SF44', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422411, 'PTHR31734:SF198', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422412, 'PTHR31734:SF110', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422413, 'PTHR31734:SF197', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 252546),
(422414, 'PTHR31734:SF193', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA31', 252546),
(422415, 'PTHR13829:SF6', NULL, NULL, NULL, NULL, 'U6 SNRNA-ASSOCIATED SM-LIKE PROTEIN LSM2', 252547),
(422416, 'PTHR13829', NULL, NULL, NULL, NULL, 'SNRNP CORE PROTEIN FAMILY MEMBER', 252547),
(422417, 'PTHR13829:SF2', NULL, NULL, NULL, NULL, 'U6 SNRNA-ASSOCIATED SM-LIKE PROTEIN LSM2', 252547),
(422418, 'PTHR13829:SF3', NULL, NULL, NULL, NULL, 'SM-LIKE PROTEIN LSM2', 252547),
(422419, 'PTHR13829:SF4', NULL, NULL, NULL, NULL, 'SM DOMAIN-CONTAINING PROTEIN', 252547),
(422420, 'PTHR13829:SF5', NULL, NULL, NULL, NULL, 'SM-LIKE PROTEIN LSM2', 252547),
(422421, 'PTHR35732:SF1', NULL, NULL, NULL, NULL, 'OS10G0545100 PROTEIN', 252548),
(422422, 'PTHR35732', NULL, NULL, NULL, NULL, 'OS10G0545100 PROTEIN', 252548),
(422423, 'PTHR43788:SF13', NULL, NULL, NULL, NULL, 'HELICASE, PUTATIVE-RELATED', 252549),
(422424, 'PTHR43788', NULL, NULL, NULL, NULL, 'DNA2/NAM7 HELICASE FAMILY MEMBER', 252549),
(422425, 'PTHR43788:SF10', NULL, NULL, NULL, NULL, 'HELICASE WITH ZINC FINGER 2, TRANSCRIPTIONAL COACTIVATOR-RELATED', 252549),
(422426, 'PTHR43788:SF9', NULL, NULL, NULL, NULL, 'RNB DOMAIN-CONTAINING PROTEIN', 252549),
(422427, 'PTHR43788:SF8', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN SMUBP-2', 252549),
(422428, 'PTHR43788:SF18', NULL, NULL, NULL, NULL, 'R3H DOMAIN-CONTAINING PROTEIN', 252549),
(422429, 'PTHR43788:SF6', NULL, NULL, NULL, NULL, 'DNA HELICASE B', 252549),
(422430, 'PTHR43788:SF17', NULL, NULL, NULL, NULL, 'OS09G0130800 PROTEIN', 252549),
(422431, 'PTHR43788:SF3', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN', 252549),
(422432, 'PTHR43788:SF16', NULL, NULL, NULL, NULL, 'AAA_12 DOMAIN-CONTAINING PROTEIN', 252549);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(422433, 'PTHR13196:SF24', NULL, NULL, NULL, NULL, 'DENN DOMAIN-CONTAINING PROTEIN 1B', 252550),
(422434, 'PTHR13196:SF14', NULL, NULL, NULL, NULL, 'UDENN DOMAIN-CONTAINING PROTEIN', 252550),
(422435, 'PTHR13196:SF25', NULL, NULL, NULL, NULL, 'DENN DOMAIN-CONTAINING PROTEIN 1C', 252550),
(422436, 'PTHR13196', NULL, NULL, NULL, NULL, 'DENN DOMAIN-CONTAINING', 252550),
(422437, 'PTHR13196:SF22', NULL, NULL, NULL, NULL, 'DENN DOMAIN-CONTAINING PROTEIN 1A', 252550),
(422438, 'PTHR47806:SF1', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L3 GLUTAMINE METHYLTRANSFERASE', 252551),
(422439, 'PTHR47806', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L3 GLUTAMINE METHYLTRANSFERASE', 252551),
(422440, 'PTHR22925:SF55', NULL, NULL, NULL, NULL, 'BETA-GLUCANASE', 252552),
(422441, 'PTHR22925:SF52', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE FAMILY 43 PROTEIN', 252552),
(422442, 'PTHR22925', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE 43 FAMILY MEMBER', 252552),
(422443, 'PTHR22925:SF51', NULL, NULL, NULL, NULL, 'BETA-GLUCANASE', 252552),
(422444, 'PTHR22925:SF39', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_5G14190)-RELATED', 252552),
(422445, 'PTHR22925:SF3', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE FAMILY PROTEIN 43', 252552),
(422446, 'PTHR22925:SF56', NULL, NULL, NULL, NULL, 'ARABINANASE/LEVANSUCRASE/INVERTASE', 252552),
(422447, 'PTHR22925:SF57', NULL, NULL, NULL, NULL, 'HYDROLASE FAMILY PROTEIN 43, PUTATIVE, EXPRESSED-RELATED', 252552),
(422448, 'PTHR45803:SF9', NULL, NULL, NULL, NULL, 'HMG BOX DOMAIN-CONTAINING PROTEIN', 252553),
(422449, 'PTHR45803', NULL, NULL, NULL, NULL, 'SOX100B', 252553),
(422450, 'PTHR45803:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SOX-8', 252553),
(422451, 'PTHR45803:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SOX-9', 252553),
(422452, 'PTHR45803:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SOX-10', 252553),
(422453, 'PTHR45803:SF5', NULL, NULL, NULL, NULL, 'SOX100B', 252553),
(422454, 'PTHR47776:SF2', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE BRCA1', 252554),
(422455, 'PTHR47776', NULL, NULL, NULL, NULL, 'F5A8.9 PROTEIN', 252554),
(422456, 'PTHR15749', NULL, NULL, NULL, NULL, 'FANCONI-ASSOCIATED NUCLEASE 1', 252555),
(422457, 'PTHR15749:SF4', NULL, NULL, NULL, NULL, 'FANCONI-ASSOCIATED NUCLEASE 1', 252555),
(422458, 'PTHR33454:SF10', NULL, NULL, NULL, NULL, 'PUROINDOLINE-B', 252556),
(422459, 'PTHR33454:SF16', NULL, NULL, NULL, NULL, 'GAMMA-GLIADIN', 252556),
(422460, 'PTHR33454:SF17', NULL, NULL, NULL, NULL, 'GLUTELIN-2', 252556),
(422461, 'PTHR33454:SF18', NULL, NULL, NULL, NULL, 'GLUTENIN, LOW MOLECULAR WEIGHT SUBUNIT', 252556),
(422462, 'PTHR33454:SF4', NULL, NULL, NULL, NULL, 'AVENIN-LIKE A6', 252556),
(422463, 'PTHR33454:SF11', NULL, NULL, NULL, NULL, 'AVENIN-LIKE B5', 252556),
(422464, 'PTHR33454:SF5', NULL, NULL, NULL, NULL, 'PUROINDOLINE-A', 252556),
(422465, 'PTHR33454:SF13', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252556),
(422466, 'PTHR33454:SF14', NULL, NULL, NULL, NULL, '50 KDA GAMMA-ZEIN', 252556),
(422467, 'PTHR33454:SF7', NULL, NULL, NULL, NULL, 'PROLAMIN PPROL 14P', 252556),
(422468, 'PTHR33454:SF8', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252556),
(422469, 'PTHR33454:SF9', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252556),
(422470, 'PTHR33454', NULL, NULL, NULL, NULL, 'PROLAMIN PPROL 14P', 252556),
(422471, 'PTHR11339:SF289', NULL, NULL, NULL, NULL, 'MUCIN-19-LIKE', 252557),
(422472, 'PTHR11339:SF388', NULL, NULL, NULL, NULL, '', 252557),
(422473, 'PTHR11339:SF365', NULL, NULL, NULL, NULL, 'RIKEN CDNA 9530053A07 GENE', 252557),
(422474, 'PTHR11339:SF244', NULL, NULL, NULL, NULL, 'IGGFC-BINDING PROTEIN', 252557),
(422475, 'PTHR11339:SF269', NULL, NULL, NULL, NULL, 'MUCIN-5B', 252557),
(422476, 'PTHR11339:SF225', NULL, NULL, NULL, NULL, 'OTOGELIN-LIKE PROTEIN', 252557),
(422477, 'PTHR11339:SF228', NULL, NULL, NULL, NULL, 'OTOGELIN', 252557),
(422478, 'PTHR11339:SF391', NULL, NULL, NULL, NULL, 'MUCIN-2', 252557),
(422479, 'PTHR11339:SF272', NULL, NULL, NULL, NULL, 'BMP-BINDING ENDOTHELIAL REGULATOR PROTEIN', 252557);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(422480, 'PTHR11339:SF371', NULL, NULL, NULL, NULL, 'MUCIN 5.1, OLIGOMERIC MUCUS/GEL-FORMING-RELATED', 252557),
(422481, 'PTHR11339:SF393', NULL, NULL, NULL, NULL, '', 252557),
(422482, 'PTHR11339:SF392', NULL, NULL, NULL, NULL, 'INTESTINAL MUCIN-LIKE PROTEIN', 252557),
(422483, 'PTHR11339:SF384', NULL, NULL, NULL, NULL, 'MUCIN 5AC, OLIGOMERIC MUCUS/GEL-FORMING', 252557),
(422484, 'PTHR11339:SF373', NULL, NULL, NULL, NULL, '', 252557),
(422485, 'PTHR11339:SF395', NULL, NULL, NULL, NULL, '', 252557),
(422486, 'PTHR11339:SF394', NULL, NULL, NULL, NULL, '', 252557),
(422487, 'PTHR11339:SF361', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR', 252557),
(422488, 'PTHR11339', NULL, NULL, NULL, NULL, 'EXTRACELLULAR MATRIX GLYCOPROTEIN RELATED', 252557),
(422489, 'PTHR11339:SF397', NULL, NULL, NULL, NULL, 'MUCIN-5AC', 252557),
(422490, 'PTHR11339:SF386', NULL, NULL, NULL, NULL, 'HEMOLECTIN, ISOFORM A', 252557),
(422491, 'PTHR11339:SF264', NULL, NULL, NULL, NULL, 'MUCIN-6', 252557),
(422492, 'PTHR11339:SF374', NULL, NULL, NULL, NULL, 'ZONADHESIN', 252557),
(422493, 'PTHR11339:SF396', NULL, NULL, NULL, NULL, 'SCO-SPONDIN', 252557),
(422494, 'PTHR40712:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM153A-RELATED', 252558),
(422495, 'PTHR40712', NULL, NULL, NULL, NULL, 'FAMILY WITH SEQUENCE SIMILARITY 153 MEMBER C-RELATED', 252558),
(422496, 'PTHR46329', NULL, NULL, NULL, NULL, 'KILLER CELL LECTIN-LIKE RECEPTOR 2', 252559),
(422497, 'PTHR46329:SF1', NULL, NULL, NULL, NULL, 'KILLER CELL LECTIN-LIKE RECEPTOR 2', 252559),
(422498, 'PTHR46329:SF4', NULL, NULL, NULL, NULL, 'KILLER CELL LECTIN-LIKE RECEPTOR, SUBFAMILY A, MEMBER 17', 252559),
(422499, 'PTHR46329:SF3', NULL, NULL, NULL, NULL, 'KILLER CELL LECTIN-LIKE RECEPTOR 3-RELATED', 252559),
(422500, 'PTHR46329:SF6', NULL, NULL, NULL, NULL, 'KILLER CELL LECTIN-LIKE RECEPTOR 4-RELATED', 252559),
(422501, 'PTHR14167:SF110', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-CONTAINING PROTEIN', 252560),
(422502, 'PTHR14167:SF111', NULL, NULL, NULL, NULL, '[PSI+] INDUCIBILITY PROTEIN 3', 252560),
(422503, 'PTHR14167:SF112', NULL, NULL, NULL, NULL, 'BAR DOMAIN-CONTAINING PROTEIN', 252560),
(422504, 'PTHR14167:SF113', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-CONTAINING PROTEIN-RELATED', 252560),
(422505, 'PTHR14167:SF28', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-CONTAINING PROTEIN 21', 252560),
(422506, 'PTHR14167:SF48', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-CONTAINING PROTEIN 19', 252560),
(422507, 'PTHR14167:SF114', NULL, NULL, NULL, NULL, 'UBP4-INTERACTOR SFP47', 252560),
(422508, 'PTHR14167:SF60', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SH3RF2', 252560),
(422509, 'PTHR14167:SF81', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-CONTAINING PROTEIN 2', 252560),
(422510, 'PTHR14167:SF68', NULL, NULL, NULL, NULL, 'DREBRIN-LIKE PROTEIN-RELATED', 252560),
(422511, 'PTHR14167:SF69', NULL, NULL, NULL, NULL, 'OS04G0539800 PROTEIN', 252560),
(422512, 'PTHR14167:SF44', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SH3RF1', 252560),
(422513, 'PTHR14167:SF45', NULL, NULL, NULL, NULL, 'ENDOPHILIN-A3', 252560),
(422514, 'PTHR14167:SF23', NULL, NULL, NULL, NULL, 'CD2-ASSOCIATED PROTEIN', 252560),
(422515, 'PTHR14167:SF64', NULL, NULL, NULL, NULL, 'SORBIN AND SH3 DOMAIN-CONTAINING PROTEIN 1', 252560),
(422516, 'PTHR14167:SF65', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-CONTAINING PROTEIN 2-LIKE ISOFORM X1', 252560),
(422517, 'PTHR14167:SF84', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-CONTAINING RING FINGER 2', 252560),
(422518, 'PTHR14167:SF62', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SH3RF3', 252560),
(422519, 'PTHR14167', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-CONTAINING', 252560),
(422520, 'PTHR14167:SF63', NULL, NULL, NULL, NULL, 'ENDOPHILIN-A2', 252560),
(422521, 'PTHR14167:SF107', NULL, NULL, NULL, NULL, 'PROTEIN CBG06887', 252560),
(422522, 'PTHR14167:SF108', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-CONTAINING PROTEIN-RELATED', 252560),
(422523, 'PTHR14167:SF109', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-CONTAINING PROTEIN', 252560),
(422524, 'PTHR14167:SF103', NULL, NULL, NULL, NULL, 'ENDOPHILIN-A', 252560);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(422525, 'PTHR14167:SF6', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-CONTAINING KINASE-BINDING PROTEIN 1', 252560),
(422526, 'PTHR14167:SF105', NULL, NULL, NULL, NULL, 'CIN85 AND CD2AP RELATED, ISOFORM J', 252560),
(422527, 'PTHR14167:SF106', NULL, NULL, NULL, NULL, 'SH3-DOMAIN GRB2-LIKE ENDOPHILIN B2B', 252560),
(422528, 'PTHR14167:SF50', NULL, NULL, NULL, NULL, 'ENDOPHILIN-A1', 252560),
(422529, 'PTHR14167:SF92', NULL, NULL, NULL, NULL, 'LD44138P', 252560),
(422530, 'PTHR14167:SF79', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-CONTAINING PROTEIN', 252560),
(422531, 'PTHR14167:SF77', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-CONTAINING PROTEIN 3', 252560),
(422532, 'PTHR14167:SF56', NULL, NULL, NULL, NULL, 'SORBIN AND SH3 DOMAIN-CONTAINING PROTEIN 2', 252560),
(422533, 'PTHR14167:SF97', NULL, NULL, NULL, NULL, 'CAP, ISOFORM AC', 252560),
(422534, 'PTHR14167:SF31', NULL, NULL, NULL, NULL, 'NOSTRIN', 252560),
(422535, 'PTHR14167:SF54', NULL, NULL, NULL, NULL, 'VINEXIN', 252560),
(422536, 'PTHR14167:SF98', NULL, NULL, NULL, NULL, 'GLUTAMINASE', 252560),
(422537, 'PTHR14167:SF76', NULL, NULL, NULL, NULL, 'ENDOPHILIN-A', 252560),
(422538, 'PTHR14167:SF51', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 252560),
(422539, 'PTHR14167:SF30', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-CONTAINING PROTEIN 1', 252560),
(422540, 'PTHR14167:SF52', NULL, NULL, NULL, NULL, 'ENDOPHILIN-B1', 252560),
(422541, 'PTHR23032:SF13', NULL, NULL, NULL, NULL, 'BRO1 DOMAIN-CONTAINING PROTEIN BROX', 252561),
(422542, 'PTHR23032:SF12', NULL, NULL, NULL, NULL, 'BRO1 DOMAIN-CONTAINING PROTEIN', 252561),
(422543, 'PTHR23032:SF11', NULL, NULL, NULL, NULL, 'BRO1 DOMAIN-CONTAINING PROTEIN', 252561),
(422544, 'PTHR23032:SF10', NULL, NULL, NULL, NULL, 'OS02G0828100 PROTEIN', 252561),
(422545, 'PTHR23032:SF20', NULL, NULL, NULL, NULL, 'ENDOSOMAL TARGETING BRO1-LIKE DOMAIN-CONTAINING PROTEIN', 252561),
(422546, 'PTHR23032:SF2', NULL, NULL, NULL, NULL, 'ENDOSOMAL TARGETING BRO1-LIKE DOMAIN-CONTAINING PROTEIN', 252561),
(422547, 'PTHR23032:SF19', NULL, NULL, NULL, NULL, 'BRO1 DOMAIN-CONTAINING PROTEIN', 252561),
(422548, 'PTHR23032', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252561),
(422549, 'PTHR23032:SF18', NULL, NULL, NULL, NULL, 'ENDOSOMAL TARGETING BRO1-LIKE DOMAIN PROTEIN', 252561),
(422550, 'PTHR23032:SF17', NULL, NULL, NULL, NULL, 'BRO1 DOMAIN-CONTAINING PROTEIN', 252561),
(422551, 'PTHR23032:SF15', NULL, NULL, NULL, NULL, 'BRO1 DOMAIN-CONTAINING PROTEIN', 252561),
(422552, 'PTHR13457:SF2', NULL, NULL, NULL, NULL, 'BP28CT DOMAIN-CONTAINING PROTEIN', 252562),
(422553, 'PTHR13457:SF1', NULL, NULL, NULL, NULL, 'HEAT REPEAT-CONTAINING PROTEIN 1', 252562),
(422554, 'PTHR13457', NULL, NULL, NULL, NULL, 'BAP28', 252562),
(422555, 'PTHR13227', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 2A', 252563),
(422556, 'PTHR13227:SF0', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 2A', 252563),
(422557, 'PTHR13923', NULL, NULL, NULL, NULL, 'SEC31-RELATED PROTEIN', 252564),
(422558, 'PTHR13923:SF23', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC31A', 252564),
(422559, 'PTHR13923:SF22', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC31B', 252564),
(422560, 'PTHR13923:SF11', NULL, NULL, NULL, NULL, 'SECRETORY 31, ISOFORM D', 252564),
(422561, 'PTHR13923:SF33', NULL, NULL, NULL, NULL, 'WD40/YVTN REPEAT-LIKE-CONTAINING DOMAIN, ANCESTRAL COATOMER ELEMENT 1, SEC16/SEC31-RELATED', 252564),
(422562, 'PTHR13923:SF31', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC31 HOMOLOG A', 252564),
(422563, 'PTHR35695:SF1', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE, CHLOROPLASTIC', 252565),
(422564, 'PTHR35695:SF2', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE, CHLOROPLASTIC', 252565),
(422565, 'PTHR35695', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE, CHLOROPLASTIC', 252565),
(422566, 'PTHR24176:SF14', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 31', 252566),
(422567, 'PTHR24176', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 31-RELATED', 252566);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(422568, 'PTHR37957:SF1', NULL, NULL, NULL, NULL, 'PHYTASE-LIKE DOMAIN-CONTAINING PROTEIN', 252567),
(422569, 'PTHR37957', NULL, NULL, NULL, NULL, 'BLR7070 PROTEIN', 252567),
(422570, 'PTHR47526:SF2', NULL, NULL, NULL, NULL, 'SWIM-TYPE DOMAIN-CONTAINING PROTEIN', 252568),
(422571, 'PTHR47526:SF1', NULL, NULL, NULL, NULL, 'SWIM-TYPE DOMAIN-CONTAINING PROTEIN', 252568),
(422572, 'PTHR47526', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 252568),
(422573, 'PTHR12877:SF7', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 10-LIKE PROTEIN', 252569),
(422574, 'PTHR12877:SF15', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 17', 252569),
(422575, 'PTHR12877', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR', 252569),
(422576, 'PTHR12877:SF16', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 10-LIKE PROTEIN', 252569),
(422577, 'PTHR12877:SF14', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 10', 252569),
(422578, 'PTHR11346:SF15', NULL, NULL, NULL, NULL, 'PLACENTAL PROTEIN 13-LIKE', 252570),
(422579, 'PTHR11346:SF120', NULL, NULL, NULL, NULL, 'GALACTOSIDE-BINDING SOLUBLE LECTIN 13-RELATED', 252570),
(422580, 'PTHR11346:SF166', NULL, NULL, NULL, NULL, 'GALECTIN-16', 252570),
(422581, 'PTHR11346:SF102', NULL, NULL, NULL, NULL, 'GALECTIN', 252570),
(422582, 'PTHR11346:SF147', NULL, NULL, NULL, NULL, 'GALECTIN', 252570),
(422583, 'PTHR11346:SF104', NULL, NULL, NULL, NULL, 'GALECTIN-2', 252570),
(422584, 'PTHR11346:SF93', NULL, NULL, NULL, NULL, 'GALECTIN', 252570),
(422585, 'PTHR11346:SF180', NULL, NULL, NULL, NULL, 'GALECTIN', 252570),
(422586, 'PTHR11346:SF181', NULL, NULL, NULL, NULL, 'GALECTIN-9B', 252570),
(422587, 'PTHR11346:SF78', NULL, NULL, NULL, NULL, 'GALECTIN', 252570),
(422588, 'PTHR11346:SF182', NULL, NULL, NULL, NULL, 'GALECTIN', 252570),
(422589, 'PTHR11346:SF97', NULL, NULL, NULL, NULL, 'GALECTIN-1', 252570),
(422590, 'PTHR11346:SF98', NULL, NULL, NULL, NULL, 'GALECTIN-RELATED PROTEIN', 252570),
(422591, 'PTHR11346:SF32', NULL, NULL, NULL, NULL, 'GALECTIN-4', 252570),
(422592, 'PTHR11346:SF80', NULL, NULL, NULL, NULL, 'GALECTIN-9C', 252570),
(422593, 'PTHR11346:SF107', NULL, NULL, NULL, NULL, 'GALECTIN-7', 252570),
(422594, 'PTHR11346:SF108', NULL, NULL, NULL, NULL, '32 KDA BETA-GALACTOSIDE-BINDING LECTIN', 252570),
(422595, 'PTHR11346:SF26', NULL, NULL, NULL, NULL, 'GALECTIN-3', 252570),
(422596, 'PTHR11346:SF174', NULL, NULL, NULL, NULL, 'GALAPTIN LEC-8-RELATED', 252570),
(422597, 'PTHR11346:SF49', NULL, NULL, NULL, NULL, 'GALAPTIN LEC-7-RELATED', 252570),
(422598, 'PTHR11346:SF176', NULL, NULL, NULL, NULL, 'GALECTIN', 252570),
(422599, 'PTHR11346:SF111', NULL, NULL, NULL, NULL, 'GALECTIN-12', 252570),
(422600, 'PTHR11346:SF177', NULL, NULL, NULL, NULL, 'GALECTIN', 252570),
(422601, 'PTHR11346:SF178', NULL, NULL, NULL, NULL, 'GALECTIN', 252570),
(422602, 'PTHR11346:SF112', NULL, NULL, NULL, NULL, 'GALECTIN', 252570),
(422603, 'PTHR11346:SF179', NULL, NULL, NULL, NULL, 'GALECTIN', 252570),
(422604, 'PTHR11346:SF158', NULL, NULL, NULL, NULL, 'GALECTIN', 252570),
(422605, 'PTHR11346:SF114', NULL, NULL, NULL, NULL, 'GALECTIN', 252570),
(422606, 'PTHR11346:SF88', NULL, NULL, NULL, NULL, 'GALECTIN', 252570),
(422607, 'PTHR11346:SF170', NULL, NULL, NULL, NULL, 'GALECTIN-9', 252570),
(422608, 'PTHR11346:SF22', NULL, NULL, NULL, NULL, 'GALECTIN-8', 252570),
(422609, 'PTHR11346:SF171', NULL, NULL, NULL, NULL, 'GALECTIN', 252570),
(422610, 'PTHR11346:SF172', NULL, NULL, NULL, NULL, 'GALECTIN', 252570),
(422611, 'PTHR11346:SF86', NULL, NULL, NULL, NULL, 'GALECTIN', 252570),
(422612, 'PTHR11346:SF21', NULL, NULL, NULL, NULL, 'GRIFIN', 252570),
(422613, 'PTHR11346:SF173', NULL, NULL, NULL, NULL, 'GALECTIN', 252570),
(422614, 'PTHR11346:SF116', NULL, NULL, NULL, NULL, 'GALECTIN', 252570),
(422615, 'PTHR11346', NULL, NULL, NULL, NULL, 'GALECTIN', 252570),
(422616, 'PTHR31790:SF460', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422617, 'PTHR31790:SF464', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(422618, 'PTHR31790:SF463', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422619, 'PTHR31790:SF501', NULL, NULL, NULL, NULL, 'F-BOX FAMILY PROTEIN', 252571),
(422620, 'PTHR31790:SF468', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN-RELATED', 252571),
(422621, 'PTHR31790:SF500', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE', 252571),
(422622, 'PTHR31790:SF465', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422623, 'PTHR31790:SF505', NULL, NULL, NULL, NULL, 'SWI-SNF-RELATED CHROMATIN BINDING PROTEIN', 252571),
(422624, 'PTHR31790:SF504', NULL, NULL, NULL, NULL, 'FBA_1 DOMAIN-CONTAINING PROTEIN', 252571),
(422625, 'PTHR31790:SF503', NULL, NULL, NULL, NULL, 'F-BOX AND ASSOCIATED INTERACTION DOMAIN PROTEIN', 252571),
(422626, 'PTHR31790:SF349', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422627, 'PTHR31790:SF502', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422628, 'PTHR31790:SF348', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422629, 'PTHR31790:SF509', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN CPR30-LIKE', 252571),
(422630, 'PTHR31790:SF508', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN-RELATED', 252571),
(422631, 'PTHR31790:SF507', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422632, 'PTHR31790:SF506', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN CPR30-LIKE', 252571),
(422633, 'PTHR31790:SF28', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422634, 'PTHR31790:SF294', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN CPR30-LIKE ISOFORM X1', 252571),
(422635, 'PTHR31790:SF457', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422636, 'PTHR31790:SF96', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422637, 'PTHR31790:SF338', NULL, NULL, NULL, NULL, 'S LOCUS F-BOX (SLF)-S5 PROTEIN', 252571),
(422638, 'PTHR31790:SF163', NULL, NULL, NULL, NULL, 'OS09G0517800 PROTEIN', 252571),
(422639, 'PTHR31790:SF283', NULL, NULL, NULL, NULL, 'F-BOX/KELCH-REPEAT PROTEIN', 252571),
(422640, 'PTHR31790:SF563', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422641, 'PTHR31790:SF562', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422642, 'PTHR31790:SF561', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422643, 'PTHR31790:SF560', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422644, 'PTHR31790:SF325', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422645, 'PTHR31790:SF567', NULL, NULL, NULL, NULL, 'LIGASE, PUTATIVE-RELATED', 252571),
(422646, 'PTHR31790:SF566', NULL, NULL, NULL, NULL, 'FBA_1 DOMAIN-CONTAINING PROTEIN', 252571),
(422647, 'PTHR31790:SF565', NULL, NULL, NULL, NULL, 'FBA_1 DOMAIN-CONTAINING PROTEIN', 252571),
(422648, 'PTHR31790:SF564', NULL, NULL, NULL, NULL, 'BNAC06G04010D PROTEIN', 252571),
(422649, 'PTHR31790:SF329', NULL, NULL, NULL, NULL, 'FBA_3 DOMAIN-CONTAINING PROTEIN', 252571),
(422650, 'PTHR31790:SF449', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422651, 'PTHR31790:SF569', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422652, 'PTHR31790:SF568', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422653, 'PTHR31790:SF393', NULL, NULL, NULL, NULL, 'CLASS S F-BOX PROTEIN', 252571),
(422654, 'PTHR31790:SF392', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422655, 'PTHR31790:SF310', NULL, NULL, NULL, NULL, 'BNAA09G24590D PROTEIN', 252571),
(422656, 'PTHR31790:SF552', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN CPR30-LIKE', 252571),
(422657, 'PTHR31790:SF430', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422658, 'PTHR31790:SF551', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422659, 'PTHR31790:SF397', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE', 252571),
(422660, 'PTHR31790:SF550', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(422661, 'PTHR31790:SF396', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN CPR30-LIKE', 252571),
(422662, 'PTHR31790:SF314', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422663, 'PTHR31790:SF556', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422664, 'PTHR31790:SF434', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422665, 'PTHR31790:SF555', NULL, NULL, NULL, NULL, 'FBA_1 DOMAIN-CONTAINING PROTEIN', 252571),
(422666, 'PTHR31790:SF313', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE', 252571),
(422667, 'PTHR31790:SF554', NULL, NULL, NULL, NULL, '', 252571),
(422668, 'PTHR31790:SF553', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422669, 'PTHR31790:SF559', NULL, NULL, NULL, NULL, 'FBA_1 DOMAIN-CONTAINING PROTEIN', 252571),
(422670, 'PTHR31790:SF558', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422671, 'PTHR31790:SF436', NULL, NULL, NULL, NULL, 'F-BOX ASSOCIATED PROTEIN', 252571),
(422672, 'PTHR31790:SF557', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422673, 'PTHR31790:SF319', NULL, NULL, NULL, NULL, 'OS12G0493566 PROTEIN', 252571),
(422674, 'PTHR31790:SF280', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN CPR1', 252571),
(422675, 'PTHR31790:SF382', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422676, 'PTHR31790:SF381', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN CPR30-LIKE', 252571),
(422677, 'PTHR31790:SF541', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422678, 'PTHR31790:SF540', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN, GALACTOSE OXIDASE/KELCH, BETA-PROPELLER-RELATED', 252571),
(422679, 'PTHR31790:SF545', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422680, 'PTHR31790:SF149', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422681, 'PTHR31790:SF423', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422682, 'PTHR31790:SF544', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422683, 'PTHR31790:SF302', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422684, 'PTHR31790:SF543', NULL, NULL, NULL, NULL, 'AND ASSOCIATED INTERACTION DOMAIN PROTEIN, PUTATIVE-RELATED', 252571),
(422685, 'PTHR31790:SF542', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422686, 'PTHR31790:SF421', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422687, 'PTHR31790:SF549', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422688, 'PTHR31790:SF427', NULL, NULL, NULL, NULL, 'BNAA04G25060D PROTEIN', 252571),
(422689, 'PTHR31790:SF306', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422690, 'PTHR31790:SF548', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422691, 'PTHR31790:SF547', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422692, 'PTHR31790:SF546', NULL, NULL, NULL, NULL, 'F-BOX/ASSOCIATED INTERACTION DOMAIN PROTEIN', 252571),
(422693, 'PTHR31790:SF429', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422694, 'PTHR31790:SF372', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN CPR30-LIKE', 252571),
(422695, 'PTHR31790:SF370', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN CPR30-LIKE', 252571),
(422696, 'PTHR31790:SF490', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE', 252571),
(422697, 'PTHR31790:SF255', NULL, NULL, NULL, NULL, '', 252571),
(422698, 'PTHR31790:SF530', NULL, NULL, NULL, NULL, '', 252571),
(422699, 'PTHR31790:SF373', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN DOR-LIKE ISOFORM X1', 252571),
(422700, 'PTHR31790:SF131', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE', 252571),
(422701, 'PTHR31790:SF534', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422702, 'PTHR31790:SF412', NULL, NULL, NULL, NULL, 'F-BOX/LRR PROTEIN', 252571),
(422703, 'PTHR31790:SF533', NULL, NULL, NULL, NULL, 'BNAC06G04000D PROTEIN', 252571),
(422704, 'PTHR31790:SF137', NULL, NULL, NULL, NULL, 'AND ASSOCIATED INTERACTION DOMAINS-CONTAINING PROTEIN, PUTATIVE-RELATED', 252571);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(422705, 'PTHR31790:SF499', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422706, 'PTHR31790:SF532', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422707, 'PTHR31790:SF377', NULL, NULL, NULL, NULL, 'F-BOX ASSOCIATED UBIQUITINATION EFFECTOR FAMILY PROTEIN', 252571),
(422708, 'PTHR31790:SF135', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN, KELCH-TYPE BETA PROPELLER-RELATED', 252571),
(422709, 'PTHR31790:SF531', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422710, 'PTHR31790:SF538', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422711, 'PTHR31790:SF537', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422712, 'PTHR31790:SF415', NULL, NULL, NULL, NULL, 'F-BOX AND ASSOCIATED INTERACTION DOMAINS-CONTAINING PROTEIN-RELATED', 252571),
(422713, 'PTHR31790:SF536', NULL, NULL, NULL, NULL, 'OS09G0449600 PROTEIN', 252571),
(422714, 'PTHR31790:SF535', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422715, 'PTHR31790:SF539', NULL, NULL, NULL, NULL, 'FBA_1 DOMAIN-CONTAINING PROTEIN', 252571),
(422716, 'PTHR31790:SF418', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422717, 'PTHR31790:SF81', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 252571),
(422718, 'PTHR31790:SF360', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422719, 'PTHR31790:SF485', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422720, 'PTHR31790:SF484', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE', 252571),
(422721, 'PTHR31790:SF127', NULL, NULL, NULL, NULL, 'FBA_1 DOMAIN-CONTAINING PROTEIN', 252571),
(422722, 'PTHR31790:SF523', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422723, 'PTHR31790:SF522', NULL, NULL, NULL, NULL, 'BNAA01G21730D PROTEIN', 252571),
(422724, 'PTHR31790:SF521', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN CPR1-LIKE ISOFORM X1', 252571),
(422725, 'PTHR31790:SF488', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422726, 'PTHR31790:SF520', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422727, 'PTHR31790:SF527', NULL, NULL, NULL, NULL, 'OS12G0618150 PROTEIN', 252571),
(422728, 'PTHR31790:SF526', NULL, NULL, NULL, NULL, 'OS05G0569600 PROTEIN', 252571),
(422729, 'PTHR31790:SF86', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422730, 'PTHR31790:SF525', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422731, 'PTHR31790:SF524', NULL, NULL, NULL, NULL, 'OS02G0199500 PROTEIN', 252571),
(422732, 'PTHR31790:SF409', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422733, 'PTHR31790:SF529', NULL, NULL, NULL, NULL, 'FBA_1 DOMAIN-CONTAINING PROTEIN', 252571),
(422734, 'PTHR31790:SF528', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN INTERACTION DOMAIN CONTAINING PROTEIN', 252571),
(422735, 'PTHR31790:SF407', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN CPR30-LIKE', 252571),
(422736, 'PTHR31790:SF193', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN CPR30-LIKE', 252571),
(422737, 'PTHR31790:SF473', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422738, 'PTHR31790:SF230', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 252571),
(422739, 'PTHR31790:SF472', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 8-LIKE', 252571),
(422740, 'PTHR31790:SF512', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE', 252571),
(422741, 'PTHR31790:SF479', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422742, 'PTHR31790:SF511', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE', 252571),
(422743, 'PTHR31790:SF510', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422744, 'PTHR31790:SF477', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422745, 'PTHR31790:SF516', NULL, NULL, NULL, NULL, 'F-BOX FAMILY PROTEIN', 252571),
(422746, 'PTHR31790:SF515', NULL, NULL, NULL, NULL, 'FBA_3 DOMAIN-CONTAINING PROTEIN', 252571),
(422747, 'PTHR31790:SF514', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(422748, 'PTHR31790:SF238', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422749, 'PTHR31790:SF513', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422750, 'PTHR31790:SF519', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE', 252571),
(422751, 'PTHR31790:SF518', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252571),
(422752, 'PTHR31790:SF517', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 252571),
(422753, 'PTHR31790', NULL, NULL, NULL, NULL, 'OS02G0783600 PROTEIN', 252571),
(422754, 'PTHR36978', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOTIDE TRIPHOSPHATE HYDROLASE', 252572),
(422755, 'PTHR36978:SF4', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOTIDE TRIPHOSPHATE HYDROLASE', 252572),
(422756, 'PTHR36978:SF7', NULL, NULL, NULL, NULL, 'GLL2605 PROTEIN', 252572),
(422757, 'PTHR36978:SF3', NULL, NULL, NULL, NULL, '', 252572),
(422758, 'PTHR47408', NULL, NULL, NULL, NULL, 'PROTEIN CBG01304-RELATED', 252573),
(422759, 'PTHR47408:SF1', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE DOMAIN-CONTAINING PROTEIN', 252573),
(422760, 'PTHR47408:SF3', NULL, NULL, NULL, NULL, 'ACETYLTRANSF_18 DOMAIN-CONTAINING PROTEIN-RELATED', 252573),
(422761, 'PTHR47408:SF2', NULL, NULL, NULL, NULL, 'ACETYLTRANSF_18 DOMAIN-CONTAINING PROTEIN-RELATED', 252573),
(422762, 'PTHR19818:SF149', NULL, NULL, NULL, NULL, '', 252574),
(422763, 'PTHR19818:SF139', NULL, NULL, NULL, NULL, 'ZINC-RESPONSIVE TRANSCRIPTIONAL REGULATOR ZAP1', 252574),
(422764, 'PTHR19818:SF137', NULL, NULL, NULL, NULL, 'INO80 COMPLEX SUBUNIT 1', 252574),
(422765, 'PTHR19818:SF148', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II TRANSCRIPTION FACTOR, PUTATIVE-RELATED', 252574),
(422766, 'PTHR19818:SF27', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZIC 2', 252574),
(422767, 'PTHR19818:SF126', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR IIIA', 252574),
(422768, 'PTHR19818:SF129', NULL, NULL, NULL, NULL, 'PAIR-RULE PROTEIN ODD-PAIRED', 252574),
(422769, 'PTHR19818', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZIC AND GLI', 252574),
(422770, 'PTHR19818:SF84', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN GLIS2', 252574),
(422771, 'PTHR19818:SF25', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZIC 3', 252574),
(422772, 'PTHR19818:SF69', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZIC 5', 252574),
(422773, 'PTHR19818:SF91', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZIC 4', 252574),
(422774, 'PTHR19818:SF141', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZIC 1', 252574),
(422775, 'PTHR19818:SF152', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G10080)-RELATED', 252574),
(422776, 'PTHR19818:SF131', NULL, NULL, NULL, NULL, 'METAL REGULATORY TRANSCRIPTION FACTOR 1', 252574),
(422777, 'PTHR19818:SF153', NULL, NULL, NULL, NULL, 'LD47926P', 252574),
(422778, 'PTHR19818:SF150', NULL, NULL, NULL, NULL, 'REGULATOR OF FUSION-RELATED', 252574),
(422779, 'PTHR19818:SF151', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 76', 252574),
(422780, 'PTHR19818:SF156', NULL, NULL, NULL, NULL, 'FEZ FAMILY ZINC FINGER PROTEIN 2-RELATED', 252574),
(422781, 'PTHR19818:SF154', NULL, NULL, NULL, NULL, 'C2H2-TYPE ZINC FINGER-CONTAINING PROTEIN', 252574),
(422782, 'PTHR19818:SF155', NULL, NULL, NULL, NULL, 'ZIC FAMILY MEMBER 4', 252574),
(422783, 'PTHR19818:SF144', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN EXPRESSION ACTIVATOR-RELATED', 252574),
(422784, 'PTHR43067:SF3', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE/DIPEPTIDE ABC TRANSPORTER, ATPASE SUBUNIT', 252575),
(422785, 'PTHR43067:SF4', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE ABC TRANSPORTER, ATP-BINDING PROTEIN', 252575),
(422786, 'PTHR43067:SF2', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE ABC TRANSPORTER, ATP-BINDING PROTEIN', 252575),
(422787, 'PTHR43067', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE/DIPEPTIDE ABC TRANSPORTER, ATPASE SUBUNIT', 252575),
(422788, 'PTHR31063:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG08684', 252576),
(422789, 'PTHR31063', NULL, NULL, NULL, NULL, 'PROTEIN CBG08668', 252576),
(422790, 'PTHR31063:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG09307', 252576);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(422791, 'PTHR31063:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG08668', 252576),
(422792, 'PTHR21292:SF4', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR ALPHA-INDUCED PROTEIN 2', 252577),
(422793, 'PTHR21292', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT SEC6-RELATED', 252577),
(422794, 'PTHR21292:SF1', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT 3', 252577),
(422795, 'PTHR21292:SF17', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT 3-LIKE 2B', 252577),
(422796, 'PTHR21292:SF14', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT 3-LIKE PROTEIN 4', 252577),
(422797, 'PTHR21292:SF7', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT 3-LIKE 2', 252577),
(422798, 'PTHR21292:SF15', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT SEC6', 252577),
(422799, 'PTHR21292:SF12', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT 3-LIKE PROTEIN', 252577),
(422800, 'PTHR21292:SF13', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT 3', 252577),
(422801, 'PTHR34779:SF7', NULL, NULL, NULL, NULL, '', 252578),
(422802, 'PTHR34779', NULL, NULL, NULL, NULL, 'OS09G0542900 PROTEIN', 252578),
(422803, 'PTHR34779:SF8', NULL, NULL, NULL, NULL, 'BNACNNG20750D PROTEIN', 252578),
(422804, 'PTHR34779:SF9', NULL, NULL, NULL, NULL, '', 252578),
(422805, 'PTHR34779:SF10', NULL, NULL, NULL, NULL, '', 252578),
(422806, 'PTHR34779:SF3', NULL, NULL, NULL, NULL, '', 252578),
(422807, 'PTHR34779:SF4', NULL, NULL, NULL, NULL, 'SYRINGOLIDE-INDUCED PROTEIN 14-1-1', 252578),
(422808, 'PTHR34779:SF6', NULL, NULL, NULL, NULL, 'SYRINGOLIDE-INDUCED PROTEIN', 252578),
(422809, 'PTHR34779:SF1', NULL, NULL, NULL, NULL, 'OS09G0542900 PROTEIN', 252578),
(422810, 'PTHR34779:SF2', NULL, NULL, NULL, NULL, 'SYRINGOLIDE-INDUCED PROTEIN 14-1-1', 252578),
(422811, 'PTHR37475:SF1', NULL, NULL, NULL, NULL, 'ZYGOTE-SPECIFIC CLASS V COPY B GENE PROTEIN', 252579),
(422812, 'PTHR37475', NULL, NULL, NULL, NULL, 'ZYGOTE-SPECIFIC CLASS V COPY B GENE PROTEIN', 252579),
(422813, 'PTHR31806:SF5', NULL, NULL, NULL, NULL, 'PURINE-CYTOSINE PERMEASE FCY21', 252580),
(422814, 'PTHR31806:SF7', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G04690)-RELATED', 252580),
(422815, 'PTHR31806:SF8', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G03000)-RELATED', 252580),
(422816, 'PTHR31806:SF16', NULL, NULL, NULL, NULL, 'PURINE-CYTOSINE TRANSPORTER (EUROFUNG)', 252580),
(422817, 'PTHR31806', NULL, NULL, NULL, NULL, 'PURINE-CYTOSINE PERMEASE FCY2-RELATED', 252580),
(422818, 'PTHR31806:SF17', NULL, NULL, NULL, NULL, 'VITAMIN B6 TRANSPORTER TPN1', 252580),
(422819, 'PTHR31806:SF1', NULL, NULL, NULL, NULL, 'PURINE-CYTOSINE PERMEASE FCY2-RELATED', 252580),
(422820, 'PTHR31658:SF0', NULL, NULL, NULL, NULL, 'CONSERVED OLIGOMERIC GOLGI COMPLEX SUBUNIT 1', 252581),
(422821, 'PTHR31658', NULL, NULL, NULL, NULL, 'CONSERVED OLIGOMERIC GOLGI COMPLEX SUBUNIT 1', 252581),
(422822, 'PTHR37016', NULL, NULL, NULL, NULL, '', 252582),
(422823, 'PTHR37016:SF7', NULL, NULL, NULL, NULL, 'NEUTRAL PROTEASE 2', 252582),
(422824, 'PTHR37016:SF2', NULL, NULL, NULL, NULL, 'NEUTRAL PROTEASE 2 HOMOLOG SNOG_02177', 252582),
(422825, 'PTHR37016:SF3', NULL, NULL, NULL, NULL, 'NEUTRAL PROTEASE 2 HOMOLOG AN3393-RELATED', 252582),
(422826, 'PTHR37016:SF5', NULL, NULL, NULL, NULL, 'DEUTEROLYSIN', 252582),
(422827, 'PTHR47350', NULL, NULL, NULL, NULL, 'PROTEIN IWS1 HOMOLOG 1', 252583),
(422828, 'PTHR47350:SF2', NULL, NULL, NULL, NULL, 'PROTEIN IWS1 HOMOLOG', 252583),
(422829, 'PTHR47350:SF4', NULL, NULL, NULL, NULL, 'PROTEIN IWS1 HOMOLOG 1', 252583),
(422830, 'PTHR47350:SF5', NULL, NULL, NULL, NULL, 'PROTEIN IWS1 HOMOLOG 2', 252583),
(422831, 'PTHR13946:SF28', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASES I AND III SUBUNIT RPAC2', 252584),
(422832, 'PTHR13946:SF40', NULL, NULL, NULL, NULL, 'RNA_POL_L_2 DOMAIN-CONTAINING PROTEIN', 252584),
(422833, 'PTHR13946:SF30', NULL, NULL, NULL, NULL, 'RNA_POL_L_2 DOMAIN-CONTAINING PROTEIN', 252584),
(422834, 'PTHR13946', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE I,II,III', 252584),
(422835, 'PTHR13946:SF33', NULL, NULL, NULL, NULL, 'RNA_POL_L_2 DOMAIN-CONTAINING PROTEIN', 252584);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(422836, 'PTHR13946:SF45', NULL, NULL, NULL, NULL, 'RNA_POL_L_2 DOMAIN-CONTAINING PROTEIN', 252584),
(422837, 'PTHR13946:SF42', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II, PUTATIVE-RELATED', 252584),
(422838, 'PTHR13946:SF37', NULL, NULL, NULL, NULL, 'RNA_POL_L_2 DOMAIN-CONTAINING PROTEIN', 252584),
(422839, 'PTHR13946:SF16', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE II SUBUNIT RPB11', 252584),
(422840, 'PTHR13946:SF38', NULL, NULL, NULL, NULL, 'RNA_POL_L_2 DOMAIN-CONTAINING PROTEIN', 252584),
(422841, 'PTHR13946:SF46', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE II SUBUNIT RPB11-A-RELATED', 252584),
(422842, 'PTHR42754:SF1', NULL, NULL, NULL, NULL, 'BULB-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 252585),
(422843, 'PTHR42754', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 252585),
(422844, 'PTHR12226:SF4', NULL, NULL, NULL, NULL, 'MANNOSE-P-DOLICHOL UTILIZATION DEFECT 1 PROTEIN HOMOLOG 1', 252586),
(422845, 'PTHR12226', NULL, NULL, NULL, NULL, 'MANNOSE-P-DOLICHOL UTILIZATION DEFECT 1  LEC35 -RELATED', 252586),
(422846, 'PTHR12226:SF3', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 66 MEMBER 3', 252586),
(422847, 'PTHR12226:SF2', NULL, NULL, NULL, NULL, 'MANNOSE-P-DOLICHOL UTILIZATION DEFECT 1 PROTEIN', 252586),
(422848, 'PTHR20921:SF0', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 222', 252587),
(422849, 'PTHR20921', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252587),
(422850, 'PTHR20921:SF9', NULL, NULL, NULL, NULL, 'RTE1-LIKE PROTEIN-RELATED', 252587),
(422851, 'PTHR20921:SF7', NULL, NULL, NULL, NULL, 'PROTEIN REVERSION-TO-ETHYLENE SENSITIVITY1', 252587),
(422852, 'PTHR20921:SF8', NULL, NULL, NULL, NULL, 'PROTEIN REVERSION-TO-ETHYLENE SENSITIVITY1-LIKE', 252587),
(422853, 'PTHR20921:SF5', NULL, NULL, NULL, NULL, '', 252587),
(422854, 'PTHR20921:SF4', NULL, NULL, NULL, NULL, 'OS05G0539800 PROTEIN', 252587),
(422855, 'PTHR11088:SF53', NULL, NULL, NULL, NULL, 'ADENYLATE ISOPENTENYLTRANSFERASE-LIKE', 252588),
(422856, 'PTHR11088:SF75', NULL, NULL, NULL, NULL, 'ADENYLATE ISOPENTENYLTRANSFERASE 1, CHLOROPLASTIC', 252588),
(422857, 'PTHR11088:SF74', NULL, NULL, NULL, NULL, 'ADENYLATE ISOPENTENYLTRANSFERASE 5, CHLOROPLASTIC', 252588),
(422858, 'PTHR11088:SF32', NULL, NULL, NULL, NULL, 'ADENYLATE ISOPENTENYLTRANSFERASE', 252588),
(422859, 'PTHR11088:SF79', NULL, NULL, NULL, NULL, 'ISOPENTENYLTRANSFERASE', 252588),
(422860, 'PTHR11088:SF56', NULL, NULL, NULL, NULL, 'ADENYLATE ISOPENTENYLTRANSFERASE 7, MITOCHONDRIAL', 252588),
(422861, 'PTHR11088:SF78', NULL, NULL, NULL, NULL, 'ADENYLATE ISOPENTENYLTRANSFERASE 5, CHLOROPLASTIC-LIKE', 252588),
(422862, 'PTHR11088:SF59', NULL, NULL, NULL, NULL, 'ADENYLATE ISOPENTENYLTRANSFERASE', 252588),
(422863, 'PTHR11088:SF37', NULL, NULL, NULL, NULL, 'ADENYLATE ISOPENTENYLTRANSFERASE', 252588),
(422864, 'PTHR11088:SF58', NULL, NULL, NULL, NULL, 'OS07G0190150 PROTEIN', 252588),
(422865, 'PTHR11088:SF36', NULL, NULL, NULL, NULL, 'ADENYLATE ISOPENTENYLTRANSFERASE', 252588),
(422866, 'PTHR11088:SF90', NULL, NULL, NULL, NULL, 'ISOPENTENYLTRANSFERASE', 252588),
(422867, 'PTHR11088:SF71', NULL, NULL, NULL, NULL, 'ISOPENTENYLTRANSFERASE 4-RELATED', 252588),
(422868, 'PTHR11088:SF70', NULL, NULL, NULL, NULL, 'ADENYLATE ISOPENTENYLTRANSFERASE 3, CHLOROPLASTIC', 252588),
(422869, 'PTHR11088:SF73', NULL, NULL, NULL, NULL, 'CYTOKININ SYNTHASE 3', 252588),
(422870, 'PTHR11088:SF64', NULL, NULL, NULL, NULL, 'SYNTHASE, PUTATIVE-RELATED', 252588),
(422871, 'PTHR11088:SF86', NULL, NULL, NULL, NULL, 'ADENYLATE ISOPENTENYLTRANSFERASE 4-RELATED', 252588),
(422872, 'PTHR11088:SF85', NULL, NULL, NULL, NULL, 'ATP BINDING PROTEIN', 252588),
(422873, 'PTHR11088:SF41', NULL, NULL, NULL, NULL, 'ADENYLATE ISOPENTENYLTRANSFERASE', 252588),
(422874, 'PTHR11088:SF88', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE-RELATED', 252588),
(422875, 'PTHR11088:SF87', NULL, NULL, NULL, NULL, 'BNAA01G26240D PROTEIN', 252588),
(422876, 'PTHR11088:SF89', NULL, NULL, NULL, NULL, 'TRNA DIMETHYLALLYLTRANSFERASE', 252588),
(422877, 'PTHR11088:SF82', NULL, NULL, NULL, NULL, 'TRNA DIMETHYLALLYLTRANSFERASE 2', 252588);
INSERT INTO "PUBLIC"."MODEL" VALUES
(422878, 'PTHR11088:SF60', NULL, NULL, NULL, NULL, 'TRNA DIMETHYLALLYLTRANSFERASE 9', 252588),
(422879, 'PTHR11088:SF62', NULL, NULL, NULL, NULL, 'BNAA07G24640D PROTEIN', 252588),
(422880, 'PTHR11088', NULL, NULL, NULL, NULL, 'TRNA DIMETHYLALLYLTRANSFERASE', 252588),
(422881, 'PTHR47362', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A THIOESTERASE THEM5', 252589),
(422882, 'PTHR47362:SF1', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A THIOESTERASE THEM5', 252589),
(422883, 'PTHR23057:SF3', NULL, NULL, NULL, NULL, 'DOUBLE PHD FINGERS 3', 252590),
(422884, 'PTHR23057:SF2', NULL, NULL, NULL, NULL, 'JAZF ZINC FINGER 1B', 252590),
(422885, 'PTHR23057', NULL, NULL, NULL, NULL, 'JUXTAPOSED WITH ANOTHER ZINC FINGER PROTEIN 1', 252590),
(422886, 'PTHR23057:SF1', NULL, NULL, NULL, NULL, 'JAZF ZINC FINGER 1A', 252590),
(422887, 'PTHR23057:SF0', NULL, NULL, NULL, NULL, 'JUXTAPOSED WITH ANOTHER ZINC FINGER PROTEIN 1', 252590),
(422888, 'PTHR24348:SF59', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE 5', 252591),
(422889, 'PTHR24348:SF58', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE 10-LIKE', 252591),
(422890, 'PTHR24348:SF69', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0271538-RELATED', 252591),
(422891, 'PTHR24348:SF68', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE ATG1C', 252591),
(422892, 'PTHR24348:SF19', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE ULK1', 252591),
(422893, 'PTHR24348:SF18', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE ULK2', 252591),
(422894, 'PTHR24348:SF52', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE ATG1B', 252591),
(422895, 'PTHR24348:SF72', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE', 252591),
(422896, 'PTHR24348', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE UNC-51-RELATED', 252591),
(422897, 'PTHR24348:SF71', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252591),
(422898, 'PTHR24348:SF67', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', 252591),
(422899, 'PTHR24348:SF45', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252591),
(422900, 'PTHR24348:SF56', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252591),
(422901, 'PTHR24348:SF66', NULL, NULL, NULL, NULL, 'SI:CH211-63O20.7', 252591),
(422902, 'PTHR24348:SF44', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252591),
(422903, 'PTHR24348:SF22', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 252591),
(422904, 'PTHR24348:SF54', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE ATG1C-LIKE', 252591),
(422905, 'PTHR24348:SF65', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE ULK3', 252591),
(422906, 'PTHR24348:SF53', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE ATG1T', 252591),
(422907, 'PTHR24348:SF64', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0278901-RELATED', 252591),
(422908, 'PTHR24348:SF70', NULL, NULL, NULL, NULL, 'CAMK FAMILY PROTEIN KINASE', 252591),
(422909, 'PTHR45088:SF1', NULL, NULL, NULL, NULL, 'OS04G0476000 PROTEIN', 252592),
(422910, 'PTHR45088', NULL, NULL, NULL, NULL, 'OSJNBA0022H21.17 PROTEIN', 252592),
(422911, 'PTHR45088:SF4', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 252592),
(422912, 'PTHR36414:SF1', NULL, NULL, NULL, NULL, 'PROTEIN SUR7', 252593),
(422913, 'PTHR36414:SF3', NULL, NULL, NULL, NULL, 'SUR7 FAMILY PROTEIN FMP45', 252593),
(422914, 'PTHR36414', NULL, NULL, NULL, NULL, 'PROTEIN SUR7', 252593),
(422915, 'PTHR46738', NULL, NULL, NULL, NULL, 'UBIQUITIN-ASSOCIATED DOMAIN-CONTAINING PROTEIN 1', 252594),
(422916, 'PTHR46738:SF1', NULL, NULL, NULL, NULL, 'UBIQUITIN-ASSOCIATED DOMAIN-CONTAINING PROTEIN 1', 252594),
(422917, 'PTHR33677', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR FRMR-RELATED', 252595),
(422918, 'PTHR33677:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR RCNR', 252595),
(422919, 'PTHR33677:SF2', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', 252595),
(422920, 'PTHR33677:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR FRMR', 252595);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(422921, 'PTHR33677:SF4', NULL, NULL, NULL, NULL, 'COPPER-SENSING TRANSCRIPTIONAL REPRESSOR CSOR', 252595),
(422922, 'PTHR47765:SF2', NULL, NULL, NULL, NULL, 'EXONUCLEASE MUT-7 HOMOLOG', 252596),
(422923, 'PTHR47765:SF3', NULL, NULL, NULL, NULL, '3''-5'' EXONUCLEASE DOMAIN-CONTAINING PROTEIN', 252596),
(422924, 'PTHR47765', NULL, NULL, NULL, NULL, '3''-5'' EXONUCLEASE DOMAIN-CONTAINING PROTEIN', 252596),
(422925, 'PTHR11140', NULL, NULL, NULL, NULL, 'PRE-MRNA SPLICING FACTOR PRP8', 252597),
(422926, 'PTHR11140:SF4', NULL, NULL, NULL, NULL, 'MPN DOMAIN-CONTAINING PROTEIN', 252597),
(422927, 'PTHR11140:SF0', NULL, NULL, NULL, NULL, 'PRE-MRNA-PROCESSING-SPLICING FACTOR 8', 252597),
(422928, 'PTHR48145:SF2', NULL, NULL, NULL, NULL, '', 252598),
(422929, 'PTHR48145:SF3', NULL, NULL, NULL, NULL, 'NUCLEAR ENVELOPE-ASSOCIATED PROTEIN 3', 252598),
(422930, 'PTHR48145:SF4', NULL, NULL, NULL, NULL, 'NUCLEAR ENVELOPE-ASSOCIATED PROTEIN 1', 252598),
(422931, 'PTHR48145:SF5', NULL, NULL, NULL, NULL, 'NUCLEAR ENVELOPE-ASSOCIATED PROTEIN 2', 252598),
(422932, 'PTHR48145:SF6', NULL, NULL, NULL, NULL, 'BNAA09G04090D PROTEIN', 252598),
(422933, 'PTHR48145', NULL, NULL, NULL, NULL, 'NUCLEAR ENVELOPE-ASSOCIATED PROTEIN 1', 252598),
(422934, 'PTHR46829', NULL, NULL, NULL, NULL, 'STERILE ALPHA MOTIF DOMAIN-CONTAINING PROTEIN 15', 252599),
(422935, 'PTHR46829:SF1', NULL, NULL, NULL, NULL, 'STERILE ALPHA MOTIF DOMAIN-CONTAINING PROTEIN 15', 252599),
(422936, 'PTHR42206:SF1', NULL, NULL, NULL, NULL, 'METAL-DEPENDENT HYDROLASE-RELATED', 252600),
(422937, 'PTHR42206', NULL, NULL, NULL, NULL, 'METAL-DEPENDENT HYDROLASE-RELATED', 252600),
(422938, 'PTHR38446:SF1', NULL, NULL, NULL, NULL, 'BLL0914 PROTEIN', 252601),
(422939, 'PTHR38446', NULL, NULL, NULL, NULL, 'BLL0914 PROTEIN', 252601),
(422940, 'PTHR43070', NULL, NULL, NULL, NULL, '', 252602),
(422941, 'PTHR43070:SF9', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL ASPARTOKINASE/HOMOSERINE DEHYDROGENASE 2, CHLOROPLASTIC', 252602),
(422942, 'PTHR43070:SF5', NULL, NULL, NULL, NULL, 'HOMOSERINE DEHYDROGENASE', 252602),
(422943, 'PTHR43070:SF6', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL ASPARTOKINASE/HOMOSERINE DEHYDROGENASE 1, CHLOROPLASTIC', 252602),
(422944, 'PTHR43070:SF7', NULL, NULL, NULL, NULL, 'ASPARTOKINASE', 252602),
(422945, 'PTHR43070:SF8', NULL, NULL, NULL, NULL, 'ASPARTOKINASE', 252602),
(422946, 'PTHR43070:SF3', NULL, NULL, NULL, NULL, 'HOMOSERINE DEHYDROGENASE', 252602),
(422947, 'PTHR31376:SF72', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422948, 'PTHR31376:SF75', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422949, 'PTHR31376:SF34', NULL, NULL, NULL, NULL, 'PURINE PERMEASE 17-RELATED', 252603),
(422950, 'PTHR31376:SF35', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422951, 'PTHR31376:SF79', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422952, 'PTHR31376:SF36', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422953, 'PTHR31376:SF37', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422954, 'PTHR31376:SF38', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422955, 'PTHR31376:SF39', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422956, 'PTHR31376:SF8', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422957, 'PTHR31376:SF7', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422958, 'PTHR31376:SF91', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422959, 'PTHR31376:SF81', NULL, NULL, NULL, NULL, 'PURINE PERMEASE 9-RELATED', 252603),
(422960, 'PTHR31376:SF3', NULL, NULL, NULL, NULL, 'PURINE PERMEASE 4-RELATED', 252603),
(422961, 'PTHR31376:SF83', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422962, 'PTHR31376:SF40', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422963, 'PTHR31376:SF84', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422964, 'PTHR31376:SF41', NULL, NULL, NULL, NULL, 'PURINE PERMEASE 16-RELATED', 252603),
(422965, 'PTHR31376:SF42', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(422966, 'PTHR31376:SF86', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422967, 'PTHR31376:SF87', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422968, 'PTHR31376:SF2', NULL, NULL, NULL, NULL, 'PURINE PERMEASE 11-RELATED', 252603),
(422969, 'PTHR31376:SF88', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422970, 'PTHR31376:SF1', NULL, NULL, NULL, NULL, 'PURINE PERMEASE 2', 252603),
(422971, 'PTHR31376:SF89', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422972, 'PTHR31376:SF46', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422973, 'PTHR31376:SF47', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422974, 'PTHR31376:SF48', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422975, 'PTHR31376:SF49', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422976, 'PTHR31376', NULL, NULL, NULL, NULL, 'OS09G0467300 PROTEIN-RELATED', 252603),
(422977, 'PTHR31376:SF106', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422978, 'PTHR31376:SF107', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422979, 'PTHR31376:SF92', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422980, 'PTHR31376:SF93', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422981, 'PTHR31376:SF50', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422982, 'PTHR31376:SF95', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422983, 'PTHR31376:SF51', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422984, 'PTHR31376:SF52', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422985, 'PTHR31376:SF97', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422986, 'PTHR31376:SF54', NULL, NULL, NULL, NULL, 'PURINE PERMEASE 3', 252603),
(422987, 'PTHR31376:SF10', NULL, NULL, NULL, NULL, 'PURINE PERMEASE 5-RELATED', 252603),
(422988, 'PTHR31376:SF99', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422989, 'PTHR31376:SF55', NULL, NULL, NULL, NULL, 'PURINE PERMEASE 1', 252603),
(422990, 'PTHR31376:SF56', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422991, 'PTHR31376:SF103', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422992, 'PTHR31376:SF57', NULL, NULL, NULL, NULL, 'PURINE PERMEASE 22-RELATED', 252603),
(422993, 'PTHR31376:SF58', NULL, NULL, NULL, NULL, 'PURINE PERMEASE 12-RELATED', 252603),
(422994, 'PTHR31376:SF104', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422995, 'PTHR31376:SF59', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422996, 'PTHR31376:SF105', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422997, 'PTHR31376:SF15', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422998, 'PTHR31376:SF16', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(422999, 'PTHR31376:SF17', NULL, NULL, NULL, NULL, 'PURINE PERMEASE 21-RELATED', 252603),
(423000, 'PTHR31376:SF100', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(423001, 'PTHR31376:SF101', NULL, NULL, NULL, NULL, 'PURINE PERMEASE 19-RELATED', 252603),
(423002, 'PTHR31376:SF61', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(423003, 'PTHR31376:SF62', NULL, NULL, NULL, NULL, 'PURINE PERMEASE 14-RELATED', 252603),
(423004, 'PTHR31376:SF63', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(423005, 'PTHR31376:SF67', NULL, NULL, NULL, NULL, 'PURINE PERMEASE 6-RELATED', 252603),
(423006, 'PTHR31376:SF68', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(423007, 'PTHR31376:SF69', NULL, NULL, NULL, NULL, 'PURINE PERMEASE-RELATED', 252603),
(423008, 'PTHR35307', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 252604),
(423009, 'PTHR35307:SF9', NULL, NULL, NULL, NULL, '', 252604),
(423010, 'PTHR35307:SF11', NULL, NULL, NULL, NULL, '', 252604),
(423011, 'PTHR35307:SF10', NULL, NULL, NULL, NULL, 'BNAA08G30280D PROTEIN', 252604),
(423012, 'PTHR35307:SF7', NULL, NULL, NULL, NULL, '', 252604),
(423013, 'PTHR35307:SF8', NULL, NULL, NULL, NULL, '', 252604);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(423014, 'PTHR35307:SF5', NULL, NULL, NULL, NULL, '', 252604),
(423015, 'PTHR35307:SF6', NULL, NULL, NULL, NULL, '', 252604),
(423016, 'PTHR35307:SF3', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 252604),
(423017, 'PTHR35307:SF4', NULL, NULL, NULL, NULL, '', 252604),
(423018, 'PTHR10870', NULL, NULL, NULL, NULL, 'CELL CYCLE CHECKPOINT PROTEIN RAD1', 252605),
(423019, 'PTHR10870:SF0', NULL, NULL, NULL, NULL, 'CELL CYCLE CHECKPOINT PROTEIN RAD1', 252605),
(423020, 'PTHR22461:SF1', NULL, NULL, NULL, NULL, 'SERINE-RICH COILED-COIL DOMAIN-CONTAINING PROTEIN 1', 252606),
(423021, 'PTHR22461:SF2', NULL, NULL, NULL, NULL, 'SERINE-RICH COILED-COIL DOMAIN-CONTAINING PROTEIN 2', 252606),
(423022, 'PTHR22461', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252606),
(423023, 'PTHR36528', NULL, NULL, NULL, NULL, 'CRISPR SYSTEM SINGLE-STRAND-SPECIFIC DEOXYRIBONUCLEASE CAS10/CSM1 (SUBTYPE III-A)', 252607),
(423024, 'PTHR36528:SF1', NULL, NULL, NULL, NULL, 'CRISPR SYSTEM SINGLE-STRAND-SPECIFIC DEOXYRIBONUCLEASE CAS10/CSM1 (SUBTYPE III-A)', 252607),
(423025, 'PTHR13238:SF0', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 298', 252608),
(423026, 'PTHR13238:SF7', NULL, NULL, NULL, NULL, '', 252608),
(423027, 'PTHR13238', NULL, NULL, NULL, NULL, 'PROTEIN C21ORF59', 252608),
(423028, 'PTHR14327:SF1', NULL, NULL, NULL, NULL, 'CATION CHANNEL SPERM-ASSOCIATED PROTEIN SUBUNIT GAMMA', 252609),
(423029, 'PTHR14327', NULL, NULL, NULL, NULL, 'CATION CHANNEL SPERM-ASSOCIATED PROTEIN SUBUNIT GAMMA', 252609),
(423030, 'PTHR40070', NULL, NULL, NULL, NULL, 'UPF0478 PROTEIN YTXG', 252610),
(423031, 'PTHR40070:SF1', NULL, NULL, NULL, NULL, 'UPF0478 PROTEIN YTXG', 252610),
(423032, 'PTHR11040', NULL, NULL, NULL, NULL, 'ZINC/IRON TRANSPORTER', 252611),
(423033, 'PTHR11040:SF52', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER 7', 252611),
(423034, 'PTHR11040:SF55', NULL, NULL, NULL, NULL, 'MEMBRANE ZINC ION TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G00470)-RELATED', 252611),
(423035, 'PTHR11040:SF171', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER 3', 252611),
(423036, 'PTHR11040:SF174', NULL, NULL, NULL, NULL, 'BNACNNG51530D PROTEIN', 252611),
(423037, 'PTHR11040:SF173', NULL, NULL, NULL, NULL, 'BNACNNG46010D PROTEIN', 252611),
(423038, 'PTHR11040:SF202', NULL, NULL, NULL, NULL, 'METAL TRANSPORT PROTEIN', 252611),
(423039, 'PTHR11040:SF169', NULL, NULL, NULL, NULL, 'FI24038P1', 252611),
(423040, 'PTHR11040:SF201', NULL, NULL, NULL, NULL, 'ZINC/IRON PERMEASE-RELATED', 252611),
(423041, 'PTHR11040:SF204', NULL, NULL, NULL, NULL, 'ZRT (ZRT), IRT-(IRT-) LIKE PROTEIN TRANSPORTER', 252611),
(423042, 'PTHR11040:SF203', NULL, NULL, NULL, NULL, 'FI18611P1-RELATED', 252611),
(423043, 'PTHR11040:SF120', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER ZIP2', 252611),
(423044, 'PTHR11040:SF164', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER 12-RELATED', 252611),
(423045, 'PTHR11040:SF200', NULL, NULL, NULL, NULL, 'METAL TRANSPORTER', 252611),
(423046, 'PTHR11040:SF209', NULL, NULL, NULL, NULL, '', 252611),
(423047, 'PTHR11040:SF58', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER ZIP1', 252611),
(423048, 'PTHR11040:SF206', NULL, NULL, NULL, NULL, 'FE(2+) TRANSPORT PROTEIN 2', 252611),
(423049, 'PTHR11040:SF205', NULL, NULL, NULL, NULL, 'ZINC-REGULATED TRANSPORTER 3', 252611),
(423050, 'PTHR11040:SF208', NULL, NULL, NULL, NULL, 'ZRT (ZRT), IRT-(IRT-) LIKE PROTEIN TRANSPORTER', 252611),
(423051, 'PTHR11040:SF207', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER 2', 252611),
(423052, 'PTHR11040:SF41', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER 7', 252611),
(423053, 'PTHR11040:SF44', NULL, NULL, NULL, NULL, 'PROTEIN ZNTC', 252611),
(423054, 'PTHR11040:SF183', NULL, NULL, NULL, NULL, 'FE(2+) TRANSPORT PROTEIN 1', 252611),
(423055, 'PTHR11040:SF141', NULL, NULL, NULL, NULL, 'BNAC04G12510D PROTEIN', 252611),
(423056, 'PTHR11040:SF185', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER 7-LIKE', 252611),
(423057, 'PTHR11040:SF140', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER ZIP3', 252611),
(423058, 'PTHR11040:SF181', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER 1', 252611);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(423059, 'PTHR11040:SF180', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER 8-RELATED', 252611),
(423060, 'PTHR11040:SF136', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 252611),
(423061, 'PTHR11040:SF135', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER 3', 252611),
(423062, 'PTHR11040:SF212', NULL, NULL, NULL, NULL, '', 252611),
(423063, 'PTHR11040:SF179', NULL, NULL, NULL, NULL, 'IRON TRANSPORTER PROTEIN IRT1', 252611),
(423064, 'PTHR11040:SF176', NULL, NULL, NULL, NULL, 'BNAA09G13960D PROTEIN', 252611),
(423065, 'PTHR11040:SF211', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER ZIP11', 252611),
(423066, 'PTHR11040:SF177', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER 9', 252611),
(423067, 'PTHR11040:SF210', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER ZTP29', 252611),
(423068, 'PTHR11040:SF48', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER 10-RELATED', 252611),
(423069, 'PTHR11040:SF71', NULL, NULL, NULL, NULL, 'ZIP METAL ION TRANSPORTER FAMILY PROTEIN', 252611),
(423070, 'PTHR11040:SF70', NULL, NULL, NULL, NULL, 'OS05G0316100 PROTEIN', 252611),
(423071, 'PTHR11040:SF74', NULL, NULL, NULL, NULL, 'ZRT (ZRT), IRT-(IRT-) LIKE PROTEIN TRANSPORTER', 252611),
(423072, 'PTHR11040:SF76', NULL, NULL, NULL, NULL, 'ZRT (ZRT), IRT-(IRT-) LIKE PROTEIN TRANSPORTER', 252611),
(423073, 'PTHR11040:SF32', NULL, NULL, NULL, NULL, 'ZINC-REGULATED TRANSPORTER 1', 252611),
(423074, 'PTHR11040:SF147', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER 4', 252611),
(423075, 'PTHR11040:SF142', NULL, NULL, NULL, NULL, 'FE(2+) TRANSPORT PROTEIN 3, CHLOROPLASTIC', 252611),
(423076, 'PTHR11040:SF145', NULL, NULL, NULL, NULL, 'FE(2+) TRANSPORT PROTEIN 2', 252611),
(423077, 'PTHR11040:SF35', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER 5', 252611),
(423078, 'PTHR11040:SF60', NULL, NULL, NULL, NULL, 'FAMILY ZINC TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G04010)-RELATED', 252611),
(423079, 'PTHR11040:SF161', NULL, NULL, NULL, NULL, '', 252611),
(423080, 'PTHR11040:SF157', NULL, NULL, NULL, NULL, 'ZIP ZINC/IRON TRANSPORT FAMILY PROTEIN', 252611),
(423081, 'PTHR11040:SF159', NULL, NULL, NULL, NULL, 'BNACNNG65140D PROTEIN', 252611),
(423082, 'PTHR11040:SF198', NULL, NULL, NULL, NULL, 'METAL HOMEOSTASIS FACTOR ATX2', 252611),
(423083, 'PTHR11040:SF154', NULL, NULL, NULL, NULL, 'OS08G0100200 PROTEIN', 252611),
(423084, 'PTHR11040:SF153', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER 8-LIKE', 252611),
(423085, 'PTHR11040:SF197', NULL, NULL, NULL, NULL, 'METAL ION TRANSPORTER ZIP5', 252611),
(423086, 'PTHR11040:SF156', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER 9', 252611),
(423087, 'PTHR11040:SF199', NULL, NULL, NULL, NULL, 'ZINC/IRON PERMEASE-RELATED', 252611),
(423088, 'PTHR11040:SF24', NULL, NULL, NULL, NULL, 'FE(2+) TRANSPORTER 3', 252611),
(423089, 'PTHR11040:SF67', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER 5', 252611),
(423090, 'PTHR11040:SF26', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER 6, CHLOROPLASTIC', 252611),
(423091, 'PTHR11040:SF69', NULL, NULL, NULL, NULL, 'ZINC-REGULATED TRANSPORTER 2', 252611),
(423092, 'PTHR35040:SF9', NULL, NULL, NULL, NULL, '4-LIKE CELL SURFACE PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G14080)-RELATED', 252612),
(423093, 'PTHR35040', NULL, NULL, NULL, NULL, '', 252612),
(423094, 'PTHR35040:SF7', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE-III DOMAIN-CONTAINING PROTEIN-RELATED', 252612),
(423095, 'PTHR35040:SF8', NULL, NULL, NULL, NULL, 'SURFACE PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G14085)-RELATED', 252612),
(423096, 'PTHR15503:SF22', NULL, NULL, NULL, NULL, 'TRANSPOSON TY3-I GAG POLYPROTEIN', 252613),
(423097, 'PTHR15503:SF33', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 252613),
(423098, 'PTHR15503:SF11', NULL, NULL, NULL, NULL, 'RETROTRANSPOSON GAG-LIKE PROTEIN 5', 252613),
(423099, 'PTHR15503:SF32', NULL, NULL, NULL, NULL, '', 252613),
(423100, 'PTHR15503:SF31', NULL, NULL, NULL, NULL, 'RETROTRANSPOSON-DERIVED PROTEIN PEG10', 252613),
(423101, 'PTHR15503:SF30', NULL, NULL, NULL, NULL, 'RETROTRANSPOSON GAG-LIKE PROTEIN 6', 252613),
(423102, 'PTHR15503:SF4', NULL, NULL, NULL, NULL, 'PROTEIN BOP', 252613);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(423103, 'PTHR15503:SF29', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', 252613),
(423104, 'PTHR15503:SF38', NULL, NULL, NULL, NULL, 'RETROTRANS_GAG DOMAIN-CONTAINING PROTEIN', 252613),
(423105, 'PTHR15503:SF37', NULL, NULL, NULL, NULL, 'ZINC FINGER, CCHC-TYPE, RETROTRANSPOSON GAG DOMAIN, ASPARTIC PEPTIDASE DOMAIN PROTEIN-RELATED', 252613),
(423106, 'PTHR15503:SF36', NULL, NULL, NULL, NULL, 'RETROTRANSPOSON-LIKE PROTEIN 1', 252613),
(423107, 'PTHR15503:SF35', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID PHOSPHATASE 6', 252613),
(423108, 'PTHR15503:SF34', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 252613),
(423109, 'PTHR15503:SF8', NULL, NULL, NULL, NULL, 'RETROTRANSPOSON GAG-LIKE PROTEIN 4', 252613),
(423110, 'PTHR15503', NULL, NULL, NULL, NULL, 'LDOC1 RELATED', 252613),
(423111, 'PTHR15503:SF7', NULL, NULL, NULL, NULL, 'RETROTRANSPOSON GAG-LIKE PROTEIN 3', 252613),
(423112, 'PTHR10269', NULL, NULL, NULL, NULL, 'GDNF RECEPTOR ALPHA', 252614),
(423113, 'PTHR10269:SF15', NULL, NULL, NULL, NULL, 'GDNF FAMILY RECEPTOR ALPHA-3', 252614),
(423114, 'PTHR10269:SF12', NULL, NULL, NULL, NULL, 'GLIAL CELL LINE-DERIVED NEUROTROPHIC FAMILY RECEPTOR-LIKE, ISOFORM E', 252614),
(423115, 'PTHR10269:SF3', NULL, NULL, NULL, NULL, 'GDNF FAMILY RECEPTOR ALPHA-1', 252614),
(423116, 'PTHR10269:SF4', NULL, NULL, NULL, NULL, 'GDNF FAMILY RECEPTOR ALPHA-2', 252614),
(423117, 'PTHR10269:SF1', NULL, NULL, NULL, NULL, 'GDNF FAMILY RECEPTOR ALPHA-LIKE', 252614),
(423118, 'PTHR10269:SF2', NULL, NULL, NULL, NULL, 'GDNF FAMILY RECEPTOR ALPHA-4', 252614),
(423119, 'PTHR38491:SF1', NULL, NULL, NULL, NULL, 'REGULATOR OF HEMOGLOBINIZATION AND ERYTHROID CELL EXPANSION PROTEIN', 252615),
(423120, 'PTHR38491', NULL, NULL, NULL, NULL, 'REGULATOR OF HEMOGLOBINIZATION AND ERYTHROID CELL EXPANSION PROTEIN', 252615),
(423121, 'PTHR47150:SF1', NULL, NULL, NULL, NULL, 'NUCLEASE', 252616),
(423122, 'PTHR47150', NULL, NULL, NULL, NULL, 'OS12G0169200 PROTEIN', 252616),
(423123, 'PTHR47150:SF2', NULL, NULL, NULL, NULL, 'OS07G0546750 PROTEIN', 252616),
(423124, 'PTHR47150:SF3', NULL, NULL, NULL, NULL, 'NUCLEASE HARBI1-RELATED', 252616),
(423125, 'PTHR47415:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAM47B', 252617),
(423126, 'PTHR47415:SF5', NULL, NULL, NULL, NULL, '', 252617),
(423127, 'PTHR47415:SF4', NULL, NULL, NULL, NULL, 'PROTEIN FAM47A', 252617),
(423128, 'PTHR47415', NULL, NULL, NULL, NULL, 'PROTEIN FAM47B', 252617),
(423129, 'PTHR47415:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM47C-RELATED', 252617),
(423130, 'PTHR15486:SF29', NULL, NULL, NULL, NULL, 'OS12G0563000 PROTEIN', 252618),
(423131, 'PTHR15486:SF49', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE 2-O-ACYLTRANSFERASE 6', 252618),
(423132, 'PTHR15486:SF25', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE RAM2', 252618),
(423133, 'PTHR15486:SF69', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID/GLYCEROL ACYLTRANSFERASE-RELATED', 252618),
(423134, 'PTHR15486:SF60', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE 3-RELATED', 252618),
(423135, 'PTHR15486:SF80', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE 5-RELATED', 252618),
(423136, 'PTHR15486:SF67', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE 2-O-ACYLTRANSFERASE 6-LIKE', 252618),
(423137, 'PTHR15486:SF45', NULL, NULL, NULL, NULL, 'OS05G0448300 PROTEIN', 252618),
(423138, 'PTHR15486:SF65', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE', 252618),
(423139, 'PTHR15486:SF88', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID/GLYCEROL ACYLTRANSFERASE', 252618),
(423140, 'PTHR15486:SF61', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE 2-O-ACYLTRANSFERASE 4', 252618),
(423141, 'PTHR15486:SF83', NULL, NULL, NULL, NULL, 'OS10G0413400 PROTEIN', 252618),
(423142, 'PTHR15486:SF84', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE 5-LIKE', 252618),
(423143, 'PTHR15486:SF62', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE 2-RELATED', 252618),
(423144, 'PTHR15486:SF58', NULL, NULL, NULL, NULL, 'OS05G0280500 PROTEIN', 252618),
(423145, 'PTHR15486:SF92', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE', 252618);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(423146, 'PTHR15486:SF70', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE 8-RELATED', 252618),
(423147, 'PTHR15486:SF93', NULL, NULL, NULL, NULL, 'PLSC DOMAIN-CONTAINING PROTEIN', 252618),
(423148, 'PTHR15486:SF90', NULL, NULL, NULL, NULL, 'OS01G0329000 PROTEIN', 252618),
(423149, 'PTHR15486:SF91', NULL, NULL, NULL, NULL, 'PLSC DOMAIN-CONTAINING PROTEIN', 252618),
(423150, 'PTHR15486:SF0', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE 1', 252618),
(423151, 'PTHR15486:SF56', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE 3-RELATED', 252618),
(423152, 'PTHR15486:SF78', NULL, NULL, NULL, NULL, 'PLSC DOMAIN-CONTAINING PROTEIN', 252618),
(423153, 'PTHR15486:SF76', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE 5', 252618),
(423154, 'PTHR15486:SF54', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE 7', 252618),
(423155, 'PTHR15486:SF77', NULL, NULL, NULL, NULL, 'OS08G0131300 PROTEIN', 252618),
(423156, 'PTHR15486:SF96', NULL, NULL, NULL, NULL, 'LIPID DROPLET-REGULATING VLDL ASSEMBLY FACTOR AUP1', 252618),
(423157, 'PTHR15486:SF74', NULL, NULL, NULL, NULL, 'PLSC DOMAIN-CONTAINING PROTEIN', 252618),
(423158, 'PTHR15486:SF97', NULL, NULL, NULL, NULL, 'PLSC DOMAIN-CONTAINING PROTEIN', 252618),
(423159, 'PTHR15486:SF53', NULL, NULL, NULL, NULL, 'PLSC DOMAIN-CONTAINING PROTEIN', 252618),
(423160, 'PTHR15486', NULL, NULL, NULL, NULL, 'ANCIENT UBIQUITOUS PROTEIN', 252618),
(423161, 'PTHR15486:SF94', NULL, NULL, NULL, NULL, 'PLSC DOMAIN-CONTAINING PROTEIN', 252618),
(423162, 'PTHR15486:SF51', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE 1', 252618),
(423163, 'PTHR15486:SF73', NULL, NULL, NULL, NULL, 'PLSC DOMAIN-CONTAINING PROTEIN', 252618),
(423164, 'PTHR15486:SF95', NULL, NULL, NULL, NULL, 'PLSC DOMAIN-CONTAINING PROTEIN', 252618),
(423165, 'PTHR47234:SF2', NULL, NULL, NULL, NULL, 'ARGR-REGULATED TONB-DEPENDENT RECEPTOR', 252619),
(423166, 'PTHR47234:SF1', NULL, NULL, NULL, NULL, '', 252619),
(423167, 'PTHR47234:SF4', NULL, NULL, NULL, NULL, 'TONB-DEPENDENT RECEPTOR', 252619),
(423168, 'PTHR47234', NULL, NULL, NULL, NULL, '', 252619),
(423169, 'PTHR47234:SF3', NULL, NULL, NULL, NULL, 'STN DOMAIN-CONTAINING PROTEIN', 252619),
(423170, 'PTHR43661:SF3', NULL, NULL, NULL, NULL, 'D-XYLONATE DEHYDRATASE YAGF-RELATED', 252620),
(423171, 'PTHR43661:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOGLUCONATE DEHYDRATASE', 252620),
(423172, 'PTHR43661', NULL, NULL, NULL, NULL, 'D-XYLONATE DEHYDRATASE', 252620),
(423173, 'PTHR17608', NULL, NULL, NULL, NULL, 'GENETIC SUPPRESSOR ELEMENT 1', 252621),
(423174, 'PTHR17608:SF4', NULL, NULL, NULL, NULL, 'GENETIC SUPPRESSOR ELEMENT 1', 252621),
(423175, 'PTHR34876', NULL, NULL, NULL, NULL, '', 252622),
(423176, 'PTHR34876:SF10', NULL, NULL, NULL, NULL, 'GLUCANASE', 252622),
(423177, 'PTHR34876:SF2', NULL, NULL, NULL, NULL, 'GLUCANASE', 252622),
(423178, 'PTHR34876:SF4', NULL, NULL, NULL, NULL, '1,4-BETA-D-GLUCAN CELLOBIOHYDROLASE C-RELATED', 252622),
(423179, 'PTHR43035:SF1', NULL, NULL, NULL, NULL, 'FATTY ACID REPRESSION MUTANT PROTEIN 2-RELATED', 252623),
(423180, 'PTHR43035:SF3', NULL, NULL, NULL, NULL, 'NITROREDUCTASE DOMAIN-CONTAINING PROTEIN', 252623),
(423181, 'PTHR43035:SF4', NULL, NULL, NULL, NULL, 'NITROREDUCTASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_3G03530)', 252623),
(423182, 'PTHR43035', NULL, NULL, NULL, NULL, 'FATTY ACID REPRESSION MUTANT PROTEIN 2-RELATED', 252623),
(423183, 'PTHR22920:SF7', NULL, NULL, NULL, NULL, 'MSP DOMAIN-CONTAINING PROTEIN-RELATED', 252624),
(423184, 'PTHR22920', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', 252624),
(423185, 'PTHR22920:SF24', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', 252624),
(423186, 'PTHR22920:SF21', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', 252624),
(423187, 'PTHR22920:SF26', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', 252624),
(423188, 'PTHR34964:SF10', NULL, NULL, NULL, NULL, 'BNAC09G40340D PROTEIN', 252625),
(423189, 'PTHR34964:SF9', NULL, NULL, NULL, NULL, 'BNAA03G50520D PROTEIN', 252625),
(423190, 'PTHR34964', NULL, NULL, NULL, NULL, 'MEMBRANE LIPOPROTEIN-RELATED', 252625); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(423191, 'PTHR34964:SF8', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252625),
(423192, 'PTHR34964:SF1', NULL, NULL, NULL, NULL, 'MEMBRANE LIPOPROTEIN-RELATED', 252625),
(423193, 'PTHR34964:SF3', NULL, NULL, NULL, NULL, 'MEMBRANE LIPOPROTEIN-RELATED', 252625),
(423194, 'PTHR16288', NULL, NULL, NULL, NULL, 'WD40 REPEAT PROTEIN 4', 252626),
(423195, 'PTHR16288:SF0', NULL, NULL, NULL, NULL, 'TRNA (GUANINE-N(7)-)-METHYLTRANSFERASE NON-CATALYTIC SUBUNIT WDR4', 252626),
(423196, 'PTHR31266:SF2', NULL, NULL, NULL, NULL, 'TRAF-INTERACTING PROTEIN WITH FHA DOMAIN-CONTAINING PROTEIN A', 252627),
(423197, 'PTHR31266:SF3', NULL, NULL, NULL, NULL, 'TRAF-INTERACTING PROTEIN WITH FHA DOMAIN-CONTAINING PROTEIN B', 252627),
(423198, 'PTHR31266', NULL, NULL, NULL, NULL, 'TRAF-INTERACTING PROTEIN WITH FHA DOMAIN-CONTAINING PROTEIN A FAMILY MEMBER', 252627),
(423199, 'PTHR34932', NULL, NULL, NULL, NULL, 'TRPL TRANSLOCATION DEFECT PROTEIN 14', 252628),
(423200, 'PTHR34932:SF1', NULL, NULL, NULL, NULL, 'TRPL TRANSLOCATION DEFECT PROTEIN 14', 252628),
(423201, 'PTHR36851:SF1', NULL, NULL, NULL, NULL, 'GLYCO_TRANS_2-LIKE DOMAIN-CONTAINING PROTEIN', 252629),
(423202, 'PTHR36851', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', 252629),
(423203, 'PTHR31161:SF29', NULL, NULL, NULL, NULL, '', 252630),
(423204, 'PTHR31161:SF18', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR', 252630),
(423205, 'PTHR31161:SF17', NULL, NULL, NULL, NULL, 'BNAC05G36610D PROTEIN', 252630),
(423206, 'PTHR31161:SF28', NULL, NULL, NULL, NULL, 'DUF641 DOMAIN-CONTAINING PROTEIN', 252630),
(423207, 'PTHR31161:SF16', NULL, NULL, NULL, NULL, 'UNE1-LIKE PROTEIN', 252630),
(423208, 'PTHR31161:SF27', NULL, NULL, NULL, NULL, 'DUF641 DOMAIN-CONTAINING PROTEIN', 252630),
(423209, 'PTHR31161:SF26', NULL, NULL, NULL, NULL, 'BNAC03G69620D PROTEIN', 252630),
(423210, 'PTHR31161:SF15', NULL, NULL, NULL, NULL, 'UNE1', 252630),
(423211, 'PTHR31161:SF14', NULL, NULL, NULL, NULL, 'PROTEIN GRAVITROPIC IN THE LIGHT 1', 252630),
(423212, 'PTHR31161:SF25', NULL, NULL, NULL, NULL, 'GOLGIN CANDIDATE 5-LIKE', 252630),
(423213, 'PTHR31161:SF2', NULL, NULL, NULL, NULL, 'MYOSIN-4 PROTEIN (DUF641)-RELATED', 252630),
(423214, 'PTHR31161:SF13', NULL, NULL, NULL, NULL, 'DUF641 DOMAIN-CONTAINING PROTEIN', 252630),
(423215, 'PTHR31161:SF24', NULL, NULL, NULL, NULL, 'BNAA07G02160D PROTEIN', 252630),
(423216, 'PTHR31161:SF23', NULL, NULL, NULL, NULL, 'DUF641 DOMAIN-CONTAINING PROTEIN', 252630),
(423217, 'PTHR31161:SF3', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252630),
(423218, 'PTHR31161', NULL, NULL, NULL, NULL, 'PROTEIN GRAVITROPIC IN THE LIGHT 1', 252630),
(423219, 'PTHR31161:SF6', NULL, NULL, NULL, NULL, 'KINECTIN-LIKE PROTEIN-RELATED', 252630),
(423220, 'PTHR31161:SF8', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252630),
(423221, 'PTHR31161:SF7', NULL, NULL, NULL, NULL, 'F28N24.3 PROTEIN', 252630),
(423222, 'PTHR33288:SF4', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I ASSEMBLY PROTEIN YCF4', 252631),
(423223, 'PTHR33288:SF14', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I ASSEMBLY PROTEIN YCF4', 252631),
(423224, 'PTHR33288', NULL, NULL, NULL, NULL, '', 252631),
(423225, 'PTHR33288:SF10', NULL, NULL, NULL, NULL, 'CYTOCHROME F', 252631),
(423226, 'PTHR31533:SF2', NULL, NULL, NULL, NULL, 'GPI-ANCHORED PROTEIN LLG1', 252632),
(423227, 'PTHR31533:SF29', NULL, NULL, NULL, NULL, 'BNAA09G05300D PROTEIN', 252632),
(423228, 'PTHR31533', NULL, NULL, NULL, NULL, 'GPI-ANCHORED PROTEIN LLG1-RELATED-RELATED', 252632),
(423229, 'PTHR31533:SF28', NULL, NULL, NULL, NULL, '', 252632),
(423230, 'PTHR31533:SF27', NULL, NULL, NULL, NULL, '', 252632),
(423231, 'PTHR31533:SF16', NULL, NULL, NULL, NULL, '', 252632),
(423232, 'PTHR31533:SF26', NULL, NULL, NULL, NULL, 'BNAA09G05290D PROTEIN', 252632),
(423233, 'PTHR31533:SF37', NULL, NULL, NULL, NULL, 'OS04G0500300 PROTEIN', 252632),
(423234, 'PTHR31533:SF15', NULL, NULL, NULL, NULL, 'OS09G0297800 PROTEIN', 252632),
(423235, 'PTHR31533:SF19', NULL, NULL, NULL, NULL, 'BNAA10G10320D PROTEIN', 252632),
(423236, 'PTHR31533:SF31', NULL, NULL, NULL, NULL, 'GPI-ANCHORED PROTEIN LORELEI', 252632);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(423237, 'PTHR31533:SF20', NULL, NULL, NULL, NULL, 'BNAC01G20810D PROTEIN', 252632),
(423238, 'PTHR31533:SF30', NULL, NULL, NULL, NULL, 'BNAA03G48050D PROTEIN', 252632),
(423239, 'PTHR31533:SF25', NULL, NULL, NULL, NULL, 'BNAA01G24970D PROTEIN', 252632),
(423240, 'PTHR31533:SF36', NULL, NULL, NULL, NULL, 'BNAC03G13790D PROTEIN', 252632),
(423241, 'PTHR31533:SF35', NULL, NULL, NULL, NULL, 'GPI-ANCHORED PROTEIN LLG2-RELATED', 252632),
(423242, 'PTHR31533:SF24', NULL, NULL, NULL, NULL, 'BNAA08G13810D PROTEIN', 252632),
(423243, 'PTHR31533:SF12', NULL, NULL, NULL, NULL, 'GPI-ANCHORED PROTEIN LORELEI-LIKE', 252632),
(423244, 'PTHR31533:SF34', NULL, NULL, NULL, NULL, 'GPI-ANCHORED PROTEIN LORELEI-LIKE', 252632),
(423245, 'PTHR20765', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 43 MEMBER 3-RELATED', 252633),
(423246, 'PTHR20765:SF0', NULL, NULL, NULL, NULL, 'L-TYPE AMINO ACID TRANSPORTER 4', 252633),
(423247, 'PTHR20765:SF1', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 43 MEMBER 3', 252633),
(423248, 'PTHR10788:SF16', NULL, NULL, NULL, NULL, 'ALPHA,ALPHA-TREHALOSE-PHOSPHATE SYNTHASE [UDP-FORMING] B', 252634),
(423249, 'PTHR10788:SF15', NULL, NULL, NULL, NULL, 'TREHALOSE SYNTHASE COMPLEX REGULATORY SUBUNIT TPS3-RELATED', 252634),
(423250, 'PTHR10788:SF14', NULL, NULL, NULL, NULL, 'ALPHA,ALPHA-TREHALOSE-PHOSPHATE SYNTHASE [UDP-FORMING] 9-RELATED', 252634),
(423251, 'PTHR10788:SF75', NULL, NULL, NULL, NULL, 'SYNTHASE SUBUNIT OF TREHALOSE-6-PHOSPHATE SYNTHASE/PHOSPHATASE COMPLEX (EUROFUNG)', 252634),
(423252, 'PTHR10788:SF121', NULL, NULL, NULL, NULL, 'TREHALOSE-PHOSPHATASE', 252634),
(423253, 'PTHR10788:SF120', NULL, NULL, NULL, NULL, 'TREHALOSE 6-PHOSPHATE PHOSPHATASE', 252634),
(423254, 'PTHR10788:SF55', NULL, NULL, NULL, NULL, 'GLYCO_TRANSF_20 DOMAIN-CONTAINING PROTEIN', 252634),
(423255, 'PTHR10788:SF123', NULL, NULL, NULL, NULL, 'TREHALOSE-PHOSPHATASE', 252634),
(423256, 'PTHR10788:SF77', NULL, NULL, NULL, NULL, 'ALPHA,ALPHA-TREHALOSE-PHOSPHATE SYNTHASE [UDP-FORMING] 9-RELATED', 252634),
(423257, 'PTHR10788:SF122', NULL, NULL, NULL, NULL, 'TREHALOSE-6-PHOSPHATE SYNTHASE2', 252634),
(423258, 'PTHR10788:SF82', NULL, NULL, NULL, NULL, 'ALPHA,ALPHA-TREHALOSE-PHOSPHATE SYNTHASE [UDP-FORMING] 4-RELATED', 252634),
(423259, 'PTHR10788:SF125', NULL, NULL, NULL, NULL, 'ALPHA,ALPHA-TREHALOSE-PHOSPHATE SYNTHASE (UDP-FORMING)', 252634),
(423260, 'PTHR10788:SF81', NULL, NULL, NULL, NULL, 'ALPHA,ALPHA-TREHALOSE-PHOSPHATE SYNTHASE [UDP-FORMING] 10-RELATED', 252634),
(423261, 'PTHR10788:SF102', NULL, NULL, NULL, NULL, 'ALPHA,ALPHA-TREHALOSE-PHOSPHATE SYNTHASE (UDP-FORMING)', 252634),
(423262, 'PTHR10788:SF124', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE, FAMILY 20-RELATED', 252634),
(423263, 'PTHR10788:SF105', NULL, NULL, NULL, NULL, 'GLYCO_TRANSF_20 DOMAIN-CONTAINING PROTEIN', 252634),
(423264, 'PTHR10788:SF84', NULL, NULL, NULL, NULL, 'TREHALOSE-6-PHOSPHATE SYNTHASE5', 252634),
(423265, 'PTHR10788:SF104', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE, FAMILY 20-RELATED', 252634),
(423266, 'PTHR10788:SF83', NULL, NULL, NULL, NULL, 'ALPHA,ALPHA-TREHALOSE-PHOSPHATE SYNTHASE [UDP-FORMING] 3-RELATED', 252634),
(423267, 'PTHR10788:SF126', NULL, NULL, NULL, NULL, 'ALPHA,ALPHA-TREHALOSE-PHOSPHATE SYNTHASE [UDP-FORMING] 7-RELATED', 252634),
(423268, 'PTHR10788:SF107', NULL, NULL, NULL, NULL, 'ALPHA,ALPHA-TREHALOSE-PHOSPHATE SYNTHASE (UDP-FORMING)', 252634),
(423269, 'PTHR10788:SF106', NULL, NULL, NULL, NULL, 'BCDNA.GH08860', 252634),
(423270, 'PTHR10788:SF109', NULL, NULL, NULL, NULL, 'CBM20 DOMAIN-CONTAINING PROTEIN', 252634),
(423271, 'PTHR10788', NULL, NULL, NULL, NULL, 'TREHALOSE-6-PHOSPHATE SYNTHASE', 252634),
(423272, 'PTHR10788:SF80', NULL, NULL, NULL, NULL, 'TREHALOSE 6-PHOSPHATE PHOSPHATASE', 252634),
(423273, 'PTHR10788:SF24', NULL, NULL, NULL, NULL, 'TREHALOSE 6-PHOSPHATE PHOSPHATASE', 252634),
(423274, 'PTHR10788:SF46', NULL, NULL, NULL, NULL, 'ALPHA,ALPHA-TREHALOSE-PHOSPHATE SYNTHASE [UDP-FORMING] 11-RELATED', 252634),
(423275, 'PTHR10788:SF48', NULL, NULL, NULL, NULL, 'ALPHA,ALPHA-TREHALOSE-PHOSPHATE SYNTHASE [UDP-FORMING] 6', 252634);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(423276, 'PTHR10788:SF86', NULL, NULL, NULL, NULL, 'ALPHA,ALPHA-TREHALOSE-PHOSPHATE SYNTHASE [UDP-FORMING] 7-RELATED', 252634),
(423277, 'PTHR10788:SF110', NULL, NULL, NULL, NULL, 'ALPHA,ALPHA-TREHALOSE-PHOSPHATE SYNTHASE [UDP-FORMING] 2', 252634),
(423278, 'PTHR10788:SF20', NULL, NULL, NULL, NULL, 'GLYCO_TRANSF_20 DOMAIN-CONTAINING PROTEIN', 252634),
(423279, 'PTHR10788:SF85', NULL, NULL, NULL, NULL, 'ALPHA,ALPHA-TREHALOSE-PHOSPHATE SYNTHASE (UDP-FORMING)', 252634),
(423280, 'PTHR10788:SF112', NULL, NULL, NULL, NULL, 'ALPHA,ALPHA-TREHALOSE-PHOSPHATE SYNTHASE [UDP-FORMING] 8-RELATED', 252634),
(423281, 'PTHR10788:SF87', NULL, NULL, NULL, NULL, 'TREHALOSE 6-PHOSPHATE PHOSPHATASE', 252634),
(423282, 'PTHR10788:SF113', NULL, NULL, NULL, NULL, 'TREHALOSE 6-PHOSPHATE PHOSPHATASE', 252634),
(423283, 'PTHR10788:SF116', NULL, NULL, NULL, NULL, 'ALPHA,ALPHA-TREHALOSE-PHOSPHATE SYNTHASE [UDP-FORMING] 7-RELATED', 252634),
(423284, 'PTHR10788:SF94', NULL, NULL, NULL, NULL, 'ALPHA,ALPHA-TREHALOSE-PHOSPHATE SYNTHASE [UDP-FORMING] 5', 252634),
(423285, 'PTHR10788:SF118', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE, FAMILY 20-RELATED', 252634),
(423286, 'PTHR10788:SF90', NULL, NULL, NULL, NULL, 'ALPHA,ALPHA-TREHALOSE-PHOSPHATE SYNTHASE [UDP-FORMING] 2-RELATED', 252634),
(423287, 'PTHR10788:SF119', NULL, NULL, NULL, NULL, 'ALPHA,ALPHA-TREHALOSE-PHOSPHATE SYNTHASE [UDP-FORMING] 100 KDA SUBUNIT-RELATED', 252634),
(423288, 'PTHR34351:SF1', NULL, NULL, NULL, NULL, 'SLR1927 PROTEIN', 252635),
(423289, 'PTHR34351:SF2', NULL, NULL, NULL, NULL, 'DUF58 DOMAIN-CONTAINING PROTEIN', 252635),
(423290, 'PTHR34351', NULL, NULL, NULL, NULL, 'SLR1927 PROTEIN-RELATED', 252635),
(423291, 'PTHR45621:SF196', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423292, 'PTHR45621:SF88', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423293, 'PTHR45621:SF1', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBL15-RELATED', 252636),
(423294, 'PTHR45621:SF195', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423295, 'PTHR45621:SF87', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBL18-RELATED', 252636),
(423296, 'PTHR45621:SF86', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE PLANT', 252636),
(423297, 'PTHR45621:SF85', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423298, 'PTHR45621:SF193', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBL19-RELATED', 252636),
(423299, 'PTHR45621:SF192', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED KINASE', 252636),
(423300, 'PTHR45621:SF191', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423301, 'PTHR45621:SF6', NULL, NULL, NULL, NULL, 'OS06G0703000 PROTEIN', 252636),
(423302, 'PTHR45621:SF3', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 252636),
(423303, 'PTHR45621:SF4', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBL12-RELATED', 252636),
(423304, 'PTHR45621:SF116', NULL, NULL, NULL, NULL, 'OS06G0168800 PROTEIN', 252636),
(423305, 'PTHR45621:SF237', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE CYTOPLASMIC KINASE 176', 252636),
(423306, 'PTHR45621:SF236', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423307, 'PTHR45621:SF114', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423308, 'PTHR45621:SF235', NULL, NULL, NULL, NULL, 'OS05G0591800 PROTEIN', 252636),
(423309, 'PTHR45621:SF234', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423310, 'PTHR45621:SF233', NULL, NULL, NULL, NULL, 'OS03G0170400 PROTEIN', 252636),
(423311, 'PTHR45621:SF112', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423312, 'PTHR45621:SF199', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423313, 'PTHR45621:SF111', NULL, NULL, NULL, NULL, 'OS07G0686800 PROTEIN', 252636),
(423314, 'PTHR45621:SF232', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE PLANT', 252636),
(423315, 'PTHR45621:SF198', NULL, NULL, NULL, NULL, 'OS10G0442800 PROTEIN', 252636);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(423316, 'PTHR45621:SF231', NULL, NULL, NULL, NULL, 'OS03G0179400 PROTEIN', 252636),
(423317, 'PTHR45621:SF230', NULL, NULL, NULL, NULL, 'OS03G0821900 PROTEIN', 252636),
(423318, 'PTHR45621:SF118', NULL, NULL, NULL, NULL, 'KINASE 1B', 252636),
(423319, 'PTHR45621:SF239', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBL1-RELATED', 252636),
(423320, 'PTHR45621:SF238', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-KINASE CX32 RELATED PROTEIN', 252636),
(423321, 'PTHR45621:SF7', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBL10-RELATED', 252636),
(423322, 'PTHR45621:SF11', NULL, NULL, NULL, NULL, 'OS01G0822200 PROTEIN', 252636),
(423323, 'PTHR45621:SF185', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423324, 'PTHR45621:SF99', NULL, NULL, NULL, NULL, 'TYROSINE KINASE FAMILY PROTEIN', 252636),
(423325, 'PTHR45621:SF184', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423326, 'PTHR45621:SF98', NULL, NULL, NULL, NULL, 'AVR9/CF-9 INDUCED KINASE 1', 252636),
(423327, 'PTHR45621:SF97', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBL36', 252636),
(423328, 'PTHR45621:SF96', NULL, NULL, NULL, NULL, 'AUXIN-REGULATED DUAL SPECIFICITY CYTOSOLIC KINASE', 252636),
(423329, 'PTHR45621:SF95', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423330, 'PTHR45621:SF180', NULL, NULL, NULL, NULL, 'ROOT-SPECIFIC KINASE 1', 252636),
(423331, 'PTHR45621:SF93', NULL, NULL, NULL, NULL, 'TRANSFERASE, PROTEIN KINASE RLK-PELLE-RLCK-VIIA-2 FAMILY-RELATED', 252636),
(423332, 'PTHR45621:SF92', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NAK-RELATED', 252636),
(423333, 'PTHR45621:SF226', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423334, 'PTHR45621:SF105', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423335, 'PTHR45621:SF225', NULL, NULL, NULL, NULL, 'SERINE/THREONINE/DUAL SPECIFICITY PROTEIN KINASE, CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 252636),
(423336, 'PTHR45621:SF104', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423337, 'PTHR45621:SF18', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE-RELATED', 252636),
(423338, 'PTHR45621:SF224', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423339, 'PTHR45621:SF17', NULL, NULL, NULL, NULL, 'OS03G0407900 PROTEIN', 252636),
(423340, 'PTHR45621:SF103', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE BIK1', 252636),
(423341, 'PTHR45621:SF223', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE PLANT-LIKE PROTEIN', 252636),
(423342, 'PTHR45621:SF102', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE PLANT', 252636),
(423343, 'PTHR45621:SF101', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBL13', 252636),
(423344, 'PTHR45621:SF222', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423345, 'PTHR45621:SF15', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBL17-RELATED', 252636),
(423346, 'PTHR45621:SF100', NULL, NULL, NULL, NULL, 'OS10G0405100 PROTEIN', 252636),
(423347, 'PTHR45621:SF221', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE PLANT', 252636),
(423348, 'PTHR45621:SF220', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 252636),
(423349, 'PTHR45621:SF187', NULL, NULL, NULL, NULL, 'SERINE-THREONINE/TYROSINE-PROTEIN KINASE CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 252636),
(423350, 'PTHR45621:SF109', NULL, NULL, NULL, NULL, 'PROTEIN KINASE 2B, CHLOROPLASTIC-LIKE', 252636),
(423351, 'PTHR45621:SF229', NULL, NULL, NULL, NULL, 'KINASE 1B', 252636),
(423352, 'PTHR45621:SF228', NULL, NULL, NULL, NULL, 'SERINE/THREONINE KINASE FAMILY PROTEIN', 252636),
(423353, 'PTHR45621:SF227', NULL, NULL, NULL, NULL, 'PROTEIN KINASE APK1A, CHLOROPLASTIC-LIKE', 252636),
(423354, 'PTHR45621:SF106', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423355, 'PTHR45621:SF22', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBL8-RELATED', 252636);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(423356, 'PTHR45621:SF21', NULL, NULL, NULL, NULL, 'OS01G0973500 PROTEIN', 252636),
(423357, 'PTHR45621:SF173', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423358, 'PTHR45621:SF215', NULL, NULL, NULL, NULL, 'CONCANAVALIN A-LIKE LECTIN/GLUCANASE DOMAIN-CONTAINING PROTEIN-RELATED', 252636),
(423359, 'PTHR45621:SF214', NULL, NULL, NULL, NULL, 'OS04G0563900 PROTEIN', 252636),
(423360, 'PTHR45621:SF28', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE RIPK', 252636),
(423361, 'PTHR45621:SF212', NULL, NULL, NULL, NULL, 'PROTEIN KINASE 2B, CHLOROPLASTIC-LIKE', 252636),
(423362, 'PTHR45621:SF179', NULL, NULL, NULL, NULL, 'APK1B, PUTATIVE-RELATED', 252636),
(423363, 'PTHR45621:SF211', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423364, 'PTHR45621:SF178', NULL, NULL, NULL, NULL, 'SERINE/THREONINE/DUAL SPECIFICITY PROTEIN KINASE, CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 252636),
(423365, 'PTHR45621:SF177', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423366, 'PTHR45621:SF25', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423367, 'PTHR45621:SF176', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423368, 'PTHR45621:SF219', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423369, 'PTHR45621:SF218', NULL, NULL, NULL, NULL, 'OS08G0457400 PROTEIN', 252636),
(423370, 'PTHR45621:SF32', NULL, NULL, NULL, NULL, 'OS10G0431900 PROTEIN', 252636),
(423371, 'PTHR45621:SF162', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423372, 'PTHR45621:SF161', NULL, NULL, NULL, NULL, 'CONCANAVALIN A-LIKE LECTIN/GLUCANASE DOMAIN-CONTAINING PROTEIN-RELATED', 252636),
(423373, 'PTHR45621:SF203', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBL11-RELATED', 252636),
(423374, 'PTHR45621:SF169', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423375, 'PTHR45621:SF168', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423376, 'PTHR45621:SF200', NULL, NULL, NULL, NULL, 'BNAA02G28760D PROTEIN', 252636),
(423377, 'PTHR45621:SF167', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423378, 'PTHR45621:SF37', NULL, NULL, NULL, NULL, 'OS06G0202900 PROTEIN', 252636),
(423379, 'PTHR45621:SF36', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE CX32 CHLOROPLASTIC-RELATED', 252636),
(423380, 'PTHR45621:SF166', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423381, 'PTHR45621:SF35', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBL3-RELATED', 252636),
(423382, 'PTHR45621', NULL, NULL, NULL, NULL, 'OS01G0588500 PROTEIN-RELATED', 252636),
(423383, 'PTHR45621:SF164', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423384, 'PTHR45621:SF209', NULL, NULL, NULL, NULL, 'OS10G0395000 PROTEIN', 252636),
(423385, 'PTHR45621:SF208', NULL, NULL, NULL, NULL, 'VASCULAR ENDOTHELIAL GROWTH FACTOR RECEPTOR 2 (VEGFR2)-RELATED', 252636),
(423386, 'PTHR45621:SF207', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423387, 'PTHR45621:SF205', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBL20-RELATED', 252636),
(423388, 'PTHR45621:SF152', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423389, 'PTHR45621:SF151', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423390, 'PTHR45621:SF43', NULL, NULL, NULL, NULL, 'OS04G0543000 PROTEIN', 252636),
(423391, 'PTHR45621:SF42', NULL, NULL, NULL, NULL, 'OS02G0670100 PROTEIN', 252636),
(423392, 'PTHR45621:SF150', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NAK-RELATED', 252636),
(423393, 'PTHR45621:SF41', NULL, NULL, NULL, NULL, 'OS01G0588500 PROTEIN', 252636),
(423394, 'PTHR45621:SF40', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PIX13-RELATED', 252636),
(423395, 'PTHR45621:SF159', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(423396, 'PTHR45621:SF158', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423397, 'PTHR45621:SF49', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423398, 'PTHR45621:SF157', NULL, NULL, NULL, NULL, 'OS09G0442100 PROTEIN', 252636),
(423399, 'PTHR45621:SF48', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PCRK2', 252636),
(423400, 'PTHR45621:SF46', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBL16-RELATED', 252636),
(423401, 'PTHR45621:SF154', NULL, NULL, NULL, NULL, 'ULP1 PROTEASE FAMILY, C-TERMINAL CATALYTIC DOMAIN CONTAINING PROTEIN', 252636),
(423402, 'PTHR45621:SF153', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423403, 'PTHR45621:SF141', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423404, 'PTHR45621:SF55', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE CST-RELATED', 252636),
(423405, 'PTHR45621:SF54', NULL, NULL, NULL, NULL, 'OS09G0533600 PROTEIN', 252636),
(423406, 'PTHR45621:SF140', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 252636),
(423407, 'PTHR45621:SF53', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PCRK1', 252636),
(423408, 'PTHR45621:SF50', NULL, NULL, NULL, NULL, 'OS06G0727400 PROTEIN', 252636),
(423409, 'PTHR45621:SF58', NULL, NULL, NULL, NULL, 'OS06G0714900 PROTEIN', 252636),
(423410, 'PTHR45621:SF144', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBL9-RELATED', 252636),
(423411, 'PTHR45621:SF57', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423412, 'PTHR45621:SF142', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423413, 'PTHR45621:SF130', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN (MAP) KINASE KINASE KINASE STE11, CRYPTOCOCCUS-RELATED', 252636),
(423414, 'PTHR45621:SF64', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-KINASE CX32, RELATED PROTEIN', 252636),
(423415, 'PTHR45621:SF137', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423416, 'PTHR45621:SF135', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423417, 'PTHR45621:SF69', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423418, 'PTHR45621:SF133', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE CX32, CHLOROPLASTIC-RELATED', 252636),
(423419, 'PTHR45621:SF68', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423420, 'PTHR45621:SF131', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423421, 'PTHR45621:SF139', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423422, 'PTHR45621:SF77', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBL35', 252636),
(423423, 'PTHR45621:SF240', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423424, 'PTHR45621:SF76', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBL4-RELATED', 252636),
(423425, 'PTHR45621:SF75', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423426, 'PTHR45621:SF74', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBL34', 252636),
(423427, 'PTHR45621:SF73', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423428, 'PTHR45621:SF72', NULL, NULL, NULL, NULL, 'TYROSINE KINASE FAMILY PROTEIN', 252636),
(423429, 'PTHR45621:SF71', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PBL2-RELATED', 252636),
(423430, 'PTHR45621:SF70', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423431, 'PTHR45621:SF126', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423432, 'PTHR45621:SF125', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423433, 'PTHR45621:SF123', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE, ACTIVE SITE PROTEIN-RELATED', 252636),
(423434, 'PTHR45621:SF122', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(423435, 'PTHR45621:SF121', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423436, 'PTHR45621:SF241', NULL, NULL, NULL, NULL, 'OS07G0495150 PROTEIN', 252636),
(423437, 'PTHR45621:SF120', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423438, 'PTHR45621:SF129', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423439, 'PTHR45621:SF128', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252636),
(423440, 'PTHR45621:SF80', NULL, NULL, NULL, NULL, 'KINASE 1B', 252636),
(423441, 'PTHR22744', NULL, NULL, NULL, NULL, 'HELIX LOOP HELIX PROTEIN 21-RELATED', 252637),
(423442, 'PTHR22744:SF14', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN-RELATED', 252637),
(423443, 'PTHR22744:SF13', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 252637),
(423444, 'PTHR22744:SF1', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 252637),
(423445, 'PTHR22744:SF12', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 252637),
(423446, 'PTHR22744:SF3', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 252637),
(423447, 'PTHR22744:SF4', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 252637),
(423448, 'PTHR22744:SF16', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 252637),
(423449, 'PTHR22744:SF7', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 252637),
(423450, 'PTHR22744:SF15', NULL, NULL, NULL, NULL, 'PROTEIN CBG14837', 252637),
(423451, 'PTHR22744:SF8', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 252637),
(423452, 'PTHR43705', NULL, NULL, NULL, NULL, 'HYDROXYACYLGLUTATHIONE HYDROLASE', 252638),
(423453, 'PTHR43705:SF1', NULL, NULL, NULL, NULL, 'HYDROXYACYLGLUTATHIONE HYDROLASE GLOB', 252638),
(423454, 'PTHR45858', NULL, NULL, NULL, NULL, 'FERM DOMAIN CONTAINING PROTEIN', 252639),
(423455, 'PTHR45858:SF1', NULL, NULL, NULL, NULL, 'FERM DOMAIN-CONTAINING PROTEIN 7', 252639),
(423456, 'PTHR45858:SF2', NULL, NULL, NULL, NULL, 'FERM, ARHGEF AND PLECKSTRIN DOMAIN-CONTAINING PROTEIN 1', 252639),
(423457, 'PTHR45858:SF4', NULL, NULL, NULL, NULL, 'FERM, ARHGEF AND PLECKSTRIN DOMAIN-CONTAINING PROTEIN 2', 252639),
(423458, 'PTHR45858:SF5', NULL, NULL, NULL, NULL, 'MOESIN/EZRIN/RADIXIN HOMOLOG 1', 252639),
(423459, 'PTHR36730:SF1', NULL, NULL, NULL, NULL, 'BNAC09G21500D PROTEIN', 252640),
(423460, 'PTHR36730', NULL, NULL, NULL, NULL, 'OS03G0210700 PROTEIN', 252640),
(423461, 'PTHR36730:SF2', NULL, NULL, NULL, NULL, 'BNAA02G36930D PROTEIN', 252640),
(423462, 'PTHR14162', NULL, NULL, NULL, NULL, 'MUCOSAL ADDRESSIN CELL ADHESION MOLECULE-1', 252641),
(423463, 'PTHR14162:SF1', NULL, NULL, NULL, NULL, 'MUCOSAL ADDRESSIN CELL ADHESION MOLECULE 1', 252641),
(423464, 'PTHR47699:SF1', NULL, NULL, NULL, NULL, 'SNARE ASSOCIATED GOLGI PROTEIN FAMILY', 252642),
(423465, 'PTHR47699', NULL, NULL, NULL, NULL, 'SNARE ASSOCIATED GOLGI PROTEIN FAMILY', 252642),
(423466, 'PTHR14409', NULL, NULL, NULL, NULL, 'MANNOSIDASE, BETA A, LYSOSOMAL-LIKE, MANBAL PROTEIN', 252643),
(423467, 'PTHR14409:SF0', NULL, NULL, NULL, NULL, 'PROTEIN MANBAL', 252643),
(423468, 'PTHR35015:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG24198', 252644),
(423469, 'PTHR35015:SF2', NULL, NULL, NULL, NULL, 'DELTA AND OSM-11 HOMOLOG PROTEIN 1', 252644),
(423470, 'PTHR35015', NULL, NULL, NULL, NULL, 'PROTEIN CBR-OSM-7-RELATED', 252644),
(423471, 'PTHR35015:SF3', NULL, NULL, NULL, NULL, 'DELTA AND OSM-11-LIKE', 252644),
(423472, 'PTHR35015:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBR-OSM-7', 252644),
(423473, 'PTHR11669:SF61', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 252645),
(423474, 'PTHR11669:SF60', NULL, NULL, NULL, NULL, 'DNA_POL3_GAMMA3 DOMAIN-CONTAINING PROTEIN', 252645),
(423475, 'PTHR11669:SF52', NULL, NULL, NULL, NULL, 'OS10G0574500 PROTEIN', 252645),
(423476, 'PTHR11669:SF63', NULL, NULL, NULL, NULL, 'PROTEIN STICHEL', 252645),
(423477, 'PTHR11669:SF51', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 252645),
(423478, 'PTHR11669:SF8', NULL, NULL, NULL, NULL, 'DNA POLYMERASE III SUBUNIT DELTA''', 252645);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(423479, 'PTHR11669:SF9', NULL, NULL, NULL, NULL, 'REPLICATION FACTOR C SUBUNIT 5', 252645),
(423480, 'PTHR11669:SF5', NULL, NULL, NULL, NULL, 'REPLICATION FACTOR C SUBUNIT 2', 252645),
(423481, 'PTHR11669:SF0', NULL, NULL, NULL, NULL, 'PROTEIN STICHEL-LIKE 2', 252645),
(423482, 'PTHR11669:SF1', NULL, NULL, NULL, NULL, 'REPLICATION FACTOR C SUBUNIT 3', 252645),
(423483, 'PTHR11669', NULL, NULL, NULL, NULL, 'REPLICATION FACTOR C / DNA POLYMERASE III GAMMA-TAU SUBUNIT', 252645),
(423484, 'PTHR11669:SF54', NULL, NULL, NULL, NULL, 'DNA POLYMERASE III SUBUNIT GAMMA/TAU', 252645),
(423485, 'PTHR11669:SF64', NULL, NULL, NULL, NULL, 'BNAA01G14140D PROTEIN', 252645),
(423486, 'PTHR11669:SF20', NULL, NULL, NULL, NULL, 'REPLICATION FACTOR C SUBUNIT 4', 252645),
(423487, 'PTHR11669:SF67', NULL, NULL, NULL, NULL, 'PROTEIN STICHEL-LIKE 1', 252645),
(423488, 'PTHR11669:SF55', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 252645),
(423489, 'PTHR11669:SF66', NULL, NULL, NULL, NULL, 'OS12G0209300 PROTEIN', 252645),
(423490, 'PTHR11669:SF25', NULL, NULL, NULL, NULL, 'OS02G0704966 PROTEIN', 252645),
(423491, 'PTHR11669:SF68', NULL, NULL, NULL, NULL, 'OS05G0529600 PROTEIN', 252645),
(423492, 'PTHR11669:SF46', NULL, NULL, NULL, NULL, 'PROTEIN STICHEL-LIKE 3', 252645),
(423493, 'PTHR11669:SF57', NULL, NULL, NULL, NULL, 'PROTEIN STICHEL-LIKE 4', 252645),
(423494, 'PTHR21663:SF0', NULL, NULL, NULL, NULL, 'SORTING OF APICAL PROTEINS', 252646),
(423495, 'PTHR21663:SF1', NULL, NULL, NULL, NULL, 'HEAT REPEAT-CONTAINING PROTEIN 5A', 252646),
(423496, 'PTHR21663:SF2', NULL, NULL, NULL, NULL, 'HEAT REPEAT-CONTAINING PROTEIN 5B', 252646),
(423497, 'PTHR21663', NULL, NULL, NULL, NULL, 'HYPOTHETICAL HEAT DOMAIN-CONTAINING', 252646),
(423498, 'PTHR12234:SF7', NULL, NULL, NULL, NULL, 'METHENYLTETRAHYDROFOLATE CYCLOHYDROLASE', 252647),
(423499, 'PTHR12234:SF6', NULL, NULL, NULL, NULL, 'FTCD_N DOMAIN-CONTAINING PROTEIN', 252647),
(423500, 'PTHR12234:SF5', NULL, NULL, NULL, NULL, 'PUTATIVE, EXPRESSED-RELATED', 252647),
(423501, 'PTHR12234:SF1', NULL, NULL, NULL, NULL, 'FORMIMINOTRANSFERASE N-TERMINAL SUBDOMAIN-CONTAINING PROTEIN', 252647),
(423502, 'PTHR12234:SF0', NULL, NULL, NULL, NULL, 'FORMIMIDOYLTRANSFERASE-CYCLODEAMINASE', 252647),
(423503, 'PTHR12234', NULL, NULL, NULL, NULL, 'FORMIMINOTRANSFERASE-CYCLODEAMINASE', 252647),
(423504, 'PTHR24138:SF10', NULL, NULL, NULL, NULL, 'INTRACELLLAR PHOSPHOLIPASE A FAMILY', 252648),
(423505, 'PTHR24138:SF14', NULL, NULL, NULL, NULL, '', 252648),
(423506, 'PTHR24138:SF12', NULL, NULL, NULL, NULL, 'PNPLA DOMAIN-CONTAINING PROTEIN', 252648),
(423507, 'PTHR24138', NULL, NULL, NULL, NULL, 'INTRACELLLAR PHOSPHOLIPASE A FAMILY', 252648),
(423508, 'PTHR24138:SF13', NULL, NULL, NULL, NULL, 'INTRACELLLAR PHOSPHOLIPASE A FAMILY', 252648),
(423509, 'PTHR42957:SF2', NULL, NULL, NULL, NULL, 'DNA HELICASE', 252649),
(423510, 'PTHR42957', NULL, NULL, NULL, NULL, 'HELICASE MJ1565-RELATED', 252649),
(423511, 'PTHR42957:SF3', NULL, NULL, NULL, NULL, 'HELICASE MJECL08-RELATED', 252649),
(423512, 'PTHR42957:SF1', NULL, NULL, NULL, NULL, 'HELICASE MJ1565-RELATED', 252649),
(423513, 'PTHR47088:SF1', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN-RELATED', 252650),
(423514, 'PTHR47088', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS W', 252650),
(423515, 'PTHR37439', NULL, NULL, NULL, NULL, 'PROTEIN CBG25991-RELATED', 252651),
(423516, 'PTHR37439:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG19417', 252651),
(423517, 'PTHR37439:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG25991', 252651),
(423518, 'PTHR47242', NULL, NULL, NULL, NULL, 'TRAF-LIKE FAMILY PROTEIN', 252652),
(423519, 'PTHR47242:SF1', NULL, NULL, NULL, NULL, 'TRAF-LIKE FAMILY PROTEIN', 252652),
(423520, 'PTHR47242:SF3', NULL, NULL, NULL, NULL, 'BNAA04G14850D PROTEIN', 252652),
(423521, 'PTHR47242:SF2', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE-RELATED', 252652),
(423522, 'PTHR24141', NULL, NULL, NULL, NULL, '2-5A-DEPENDENT RIBONUCLEASE', 252653),
(423523, 'PTHR24141:SF1', NULL, NULL, NULL, NULL, '2-5A-DEPENDENT RIBONUCLEASE', 252653);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(423524, 'PTHR30041:SF7', NULL, NULL, NULL, NULL, 'GLOBAL TRANSCRIPTIONAL REGULATOR SPX', 252654),
(423525, 'PTHR30041:SF8', NULL, NULL, NULL, NULL, 'PROTEIN YFFB', 252654),
(423526, 'PTHR30041', NULL, NULL, NULL, NULL, 'ARSENATE REDUCTASE', 252654),
(423527, 'PTHR30041:SF4', NULL, NULL, NULL, NULL, 'ARSENATE REDUCTASE', 252654),
(423528, 'PTHR30041:SF5', NULL, NULL, NULL, NULL, 'ARSENATE REDUCTASE-RELATED', 252654),
(423529, 'PTHR23538', NULL, NULL, NULL, NULL, '44.5 KD BACTERIOCHLOROPHYLL SYNTHASE SUBUNIT', 252655),
(423530, 'PTHR23538:SF1', NULL, NULL, NULL, NULL, '44.5 KD BACTERIOCHLOROPHYLL SYNTHASE SUBUNIT', 252655),
(423531, 'PTHR24044:SF308', NULL, NULL, NULL, NULL, 'DELTA-LIKE PROTEIN 3', 252656),
(423532, 'PTHR24044:SF448', NULL, NULL, NULL, NULL, 'PROTEIN JAGGED-1', 252656),
(423533, 'PTHR24044:SF501', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN C02B10.3', 252656),
(423534, 'PTHR24044:SF500', NULL, NULL, NULL, NULL, 'PROTEIN CBR-TAG-53', 252656),
(423535, 'PTHR24044:SF423', NULL, NULL, NULL, NULL, 'PROTEIN DELTA HOMOLOG 2', 252656),
(423536, 'PTHR24044:SF489', NULL, NULL, NULL, NULL, 'NEUROGENIC LOCUS NOTCH HOMOLOG PROTEIN 4', 252656),
(423537, 'PTHR24044:SF467', NULL, NULL, NULL, NULL, 'DELTA AND NOTCH-LIKE EPIDERMAL GROWTH FACTOR-RELATED RECEPTOR', 252656),
(423538, 'PTHR24044:SF488', NULL, NULL, NULL, NULL, 'DELTA-LIKE PROTEIN', 252656),
(423539, 'PTHR24044:SF421', NULL, NULL, NULL, NULL, 'PROTEIN JAGGED-2', 252656),
(423540, 'PTHR24044:SF487', NULL, NULL, NULL, NULL, 'ATTRACTIN-LIKE PROTEIN 1', 252656),
(423541, 'PTHR24044:SF420', NULL, NULL, NULL, NULL, 'DELTA AND NOTCH-LIKE EPIDERMAL GROWTH FACTOR-RELATED RECEPTOR ISOFORM X1', 252656),
(423542, 'PTHR24044:SF486', NULL, NULL, NULL, NULL, '', 252656),
(423543, 'PTHR24044:SF320', NULL, NULL, NULL, NULL, 'DELTA-LIKE PROTEIN 4', 252656),
(423544, 'PTHR24044:SF491', NULL, NULL, NULL, NULL, 'PROTEIN CBG14646', 252656),
(423545, 'PTHR24044:SF490', NULL, NULL, NULL, NULL, 'PROTEIN CBG19009', 252656),
(423546, 'PTHR24044:SF418', NULL, NULL, NULL, NULL, 'C901', 252656),
(423547, 'PTHR24044:SF417', NULL, NULL, NULL, NULL, 'SI:CH73-281K2.5', 252656),
(423548, 'PTHR24044:SF415', NULL, NULL, NULL, NULL, 'NOTCH RECEPTOR 3', 252656),
(423549, 'PTHR24044:SF499', NULL, NULL, NULL, NULL, '', 252656),
(423550, 'PTHR24044:SF411', NULL, NULL, NULL, NULL, 'SUSHI, NIDOGEN AND EGF-LIKE DOMAIN-CONTAINING PROTEIN 1', 252656),
(423551, 'PTHR24044:SF498', NULL, NULL, NULL, NULL, 'PROTEIN SERRATE', 252656),
(423552, 'PTHR24044:SF497', NULL, NULL, NULL, NULL, 'CADHERIN, EGF LAG SEVEN-PASS G-TYPE RECEPTOR 3', 252656),
(423553, 'PTHR24044:SF496', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 252656),
(423554, 'PTHR24044:SF495', NULL, NULL, NULL, NULL, 'ATTRACTIN', 252656),
(423555, 'PTHR24044', NULL, NULL, NULL, NULL, 'NOTCH LIGAND FAMILY MEMBER', 252656),
(423556, 'PTHR24044:SF494', NULL, NULL, NULL, NULL, 'AGAP003506-PA', 252656),
(423557, 'PTHR24044:SF471', NULL, NULL, NULL, NULL, 'NEUROGENIC LOCUS NOTCH HOMOLOG PROTEIN 1', 252656),
(423558, 'PTHR24044:SF493', NULL, NULL, NULL, NULL, 'DELTA-LIKE PROTEIN', 252656),
(423559, 'PTHR24044:SF492', NULL, NULL, NULL, NULL, 'NEUROGENIC LOCUS PROTEIN DELTA-RELATED', 252656),
(423560, 'PTHR24044:SF380', NULL, NULL, NULL, NULL, 'DELTA-LIKE PROTEIN 1', 252656),
(423561, 'PTHR48127:SF1', NULL, NULL, NULL, NULL, 'GRF-TYPE DOMAIN-CONTAINING PROTEIN', 252657),
(423562, 'PTHR48127', NULL, NULL, NULL, NULL, 'GRF-TYPE DOMAIN-CONTAINING PROTEIN', 252657),
(423563, 'PTHR20544', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN CEP135', 252658),
(423564, 'PTHR20544:SF0', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN CEP135', 252658),
(423565, 'PTHR43476:SF5', NULL, NULL, NULL, NULL, 'FAD-DEPENDENT MONOOXYGENASE', 252659),
(423566, 'PTHR43476:SF3', NULL, NULL, NULL, NULL, 'FAD_BINDING_3 DOMAIN-CONTAINING PROTEIN', 252659),
(423567, 'PTHR43476:SF4', NULL, NULL, NULL, NULL, 'BLR0106 PROTEIN', 252659),
(423568, 'PTHR43476', NULL, NULL, NULL, NULL, '3-(3-HYDROXY-PHENYL)PROPIONATE/3-HYDROXYCINNAMIC ACID HYDROXYLASE', 252659);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(423569, 'PTHR34191', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN (LEA) FAMILY PROTEIN', 252660),
(423570, 'PTHR34191:SF19', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN 1-LIKE', 252660),
(423571, 'PTHR34191:SF18', NULL, NULL, NULL, NULL, '', 252660),
(423572, 'PTHR34191:SF28', NULL, NULL, NULL, NULL, 'BNAANNG28600D PROTEIN', 252660),
(423573, 'PTHR34191:SF17', NULL, NULL, NULL, NULL, 'F9L1.37', 252660),
(423574, 'PTHR34191:SF27', NULL, NULL, NULL, NULL, 'BNAA02G10070D PROTEIN', 252660),
(423575, 'PTHR34191:SF16', NULL, NULL, NULL, NULL, 'STRESS-INDUCED PROTEIN KIN2-LIKE', 252660),
(423576, 'PTHR34191:SF15', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN (LEA) FAMILY PROTEIN', 252660),
(423577, 'PTHR34191:SF26', NULL, NULL, NULL, NULL, 'BNAC09G21480D PROTEIN', 252660),
(423578, 'PTHR34191:SF14', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN 1-LIKE', 252660),
(423579, 'PTHR34191:SF25', NULL, NULL, NULL, NULL, 'BNAA08G05160D PROTEIN', 252660),
(423580, 'PTHR34191:SF24', NULL, NULL, NULL, NULL, 'POLLEN COAT', 252660),
(423581, 'PTHR34191:SF13', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN (LEA) FAMILY PROTEIN', 252660),
(423582, 'PTHR34191:SF23', NULL, NULL, NULL, NULL, 'STRESS-INDUCED PROTEIN KIN2-LIKE', 252660),
(423583, 'PTHR34191:SF11', NULL, NULL, NULL, NULL, 'ABA-INDUCIBLE PROTEIN-LIKE', 252660),
(423584, 'PTHR34191:SF22', NULL, NULL, NULL, NULL, 'POLLEN COAT', 252660),
(423585, 'PTHR34191:SF33', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN 76-LIKE', 252660),
(423586, 'PTHR34191:SF32', NULL, NULL, NULL, NULL, 'STRESS-INDUCED PROTEIN KIN1-RELATED', 252660),
(423587, 'PTHR34191:SF20', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN (LEA) FAMILY PROTEIN', 252660),
(423588, 'PTHR34191:SF31', NULL, NULL, NULL, NULL, 'BNAA01G32930D PROTEIN', 252660),
(423589, 'PTHR34191:SF30', NULL, NULL, NULL, NULL, 'POLLEN COAT-LIKE PROTEIN', 252660),
(423590, 'PTHR34191:SF9', NULL, NULL, NULL, NULL, 'F6D8.10', 252660),
(423591, 'PTHR34191:SF4', NULL, NULL, NULL, NULL, 'STRESS-INDUCED PROTEIN KIN2-LIKE', 252660),
(423592, 'PTHR21759:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG02240', 252661),
(423593, 'PTHR21759:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG02235', 252661),
(423594, 'PTHR21759', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252661),
(423595, 'PTHR10927:SF2', NULL, NULL, NULL, NULL, 'RESTRICTION OF TELOMERE CAPPING PROTEIN 3', 252662),
(423596, 'PTHR10927:SF3', NULL, NULL, NULL, NULL, 'U1-TYPE DOMAIN-CONTAINING PROTEIN', 252662),
(423597, 'PTHR10927:SF1', NULL, NULL, NULL, NULL, 'RIBOSOME MATURATION PROTEIN SBDS', 252662),
(423598, 'PTHR10927', NULL, NULL, NULL, NULL, 'RIBOSOME MATURATION PROTEIN SBDS', 252662),
(423599, 'PTHR15911', NULL, NULL, NULL, NULL, 'WW DOMAIN-CONTAINING ADAPTER PROTEIN WITH COILED-COIL', 252663),
(423600, 'PTHR15911:SF6', NULL, NULL, NULL, NULL, 'WW DOMAIN-CONTAINING ADAPTER PROTEIN WITH COILED-COIL', 252663),
(423601, 'PTHR46439', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH MOTOR NEURON 1 PROTEIN', 252664),
(423602, 'PTHR46439:SF1', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH MOTOR NEURON 1 PROTEIN', 252664),
(423603, 'PTHR46439:SF2', NULL, NULL, NULL, NULL, 'AGAP000893-PA', 252664),
(423604, 'PTHR45926:SF40', NULL, NULL, NULL, NULL, 'OS02G0250300 PROTEIN', 252665),
(423605, 'PTHR45926:SF44', NULL, NULL, NULL, NULL, 'BROMODOMAIN-CONTAINING PROTEIN 2', 252665),
(423606, 'PTHR45926:SF22', NULL, NULL, NULL, NULL, 'BROMODOMAIN, NET DOMAIN PROTEIN-RELATED', 252665),
(423607, 'PTHR45926:SF21', NULL, NULL, NULL, NULL, 'BROMODOMAIN-CONTAINING PROTEIN', 252665),
(423608, 'PTHR45926:SF43', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GTE4-LIKE', 252665),
(423609, 'PTHR45926:SF42', NULL, NULL, NULL, NULL, '', 252665),
(423610, 'PTHR45926:SF41', NULL, NULL, NULL, NULL, 'BROMODOMAIN TESTIS-SPECIFIC PROTEIN', 252665),
(423611, 'PTHR45926:SF15', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GTE5, CHLOROPLASTIC', 252665),
(423612, 'PTHR45926:SF2', NULL, NULL, NULL, NULL, 'OS08G0192800 PROTEIN', 252665); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(423613, 'PTHR45926:SF37', NULL, NULL, NULL, NULL, 'BROMODOMAIN-CONTAINING PROTEIN 3', 252665),
(423614, 'PTHR45926:SF36', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GTE2', 252665),
(423615, 'PTHR45926:SF1', NULL, NULL, NULL, NULL, 'HOMEOTIC PROTEIN FEMALE STERILE-RELATED', 252665),
(423616, 'PTHR45926:SF13', NULL, NULL, NULL, NULL, 'BROMODOMAIN TESTIS-SPECIFIC PROTEIN', 252665),
(423617, 'PTHR45926:SF34', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GTE4-LIKE', 252665),
(423618, 'PTHR45926:SF19', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GTE3, CHLOROPLASTIC', 252665),
(423619, 'PTHR45926:SF6', NULL, NULL, NULL, NULL, 'OS04G0622000 PROTEIN', 252665),
(423620, 'PTHR45926:SF18', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GTE1', 252665),
(423621, 'PTHR45926:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GTE4', 252665),
(423622, 'PTHR45926:SF39', NULL, NULL, NULL, NULL, 'BROMODOMAIN TESTIS-SPECIFIC PROTEIN-RELATED', 252665),
(423623, 'PTHR45926:SF38', NULL, NULL, NULL, NULL, 'BNAC08G44700D PROTEIN', 252665),
(423624, 'PTHR45926:SF7', NULL, NULL, NULL, NULL, 'OS01G0648700 PROTEIN', 252665),
(423625, 'PTHR45926', NULL, NULL, NULL, NULL, 'OSJNBA0053K19.4 PROTEIN', 252665),
(423626, 'PTHR45926:SF11', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GTE7-LIKE', 252665),
(423627, 'PTHR45926:SF31', NULL, NULL, NULL, NULL, 'NET DOMAIN-CONTAINING PROTEIN', 252665),
(423628, 'PTHR45926:SF48', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GTE7', 252665),
(423629, 'PTHR45926:SF47', NULL, NULL, NULL, NULL, 'BNAA09G44830D PROTEIN', 252665),
(423630, 'PTHR45926:SF24', NULL, NULL, NULL, NULL, 'BNAA08G28520D PROTEIN', 252665),
(423631, 'PTHR45926:SF46', NULL, NULL, NULL, NULL, 'BRDT SUBFAMILY BROMODOMAIN-CONTAINING PROTEIN', 252665),
(423632, 'PTHR45926:SF45', NULL, NULL, NULL, NULL, 'BROMODOMAIN, NET DOMAIN PROTEIN-RELATED', 252665),
(423633, 'PTHR45926:SF23', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 252665),
(423634, 'PTHR45926:SF49', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GTE1-LIKE', 252665),
(423635, 'PTHR45926:SF27', NULL, NULL, NULL, NULL, 'BROMODOMAIN, NET DOMAIN PROTEIN-RELATED', 252665),
(423636, 'PTHR33841:SF1', NULL, NULL, NULL, NULL, 'DNA METHYLTRANSFERASE YEEA-RELATED', 252666),
(423637, 'PTHR33841:SF5', NULL, NULL, NULL, NULL, 'MODIFICATION METHYLASE HINDII-RELATED', 252666),
(423638, 'PTHR33841:SF4', NULL, NULL, NULL, NULL, 'SITE-SPECIFIC DNA-METHYLTRANSFERASE (ADENINE-SPECIFIC)', 252666),
(423639, 'PTHR33841', NULL, NULL, NULL, NULL, 'DNA METHYLTRANSFERASE YEEA-RELATED', 252666),
(423640, 'PTHR14066', NULL, NULL, NULL, NULL, 'ATRIAL NATRIURETIC FACTOR PRECURSOR', 252667),
(423641, 'PTHR14066:SF2', NULL, NULL, NULL, NULL, 'NATRIURETIC PEPTIDES A', 252667),
(423642, 'PTHR14066:SF10', NULL, NULL, NULL, NULL, 'NATRIURETIC PEPTIDES B', 252667),
(423643, 'PTHR13252', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 28', 252668),
(423644, 'PTHR13252:SF9', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 28', 252668),
(423645, 'PTHR13252:SF1', NULL, NULL, NULL, NULL, 'DAMPENED, ISOFORM A', 252668),
(423646, 'PTHR10241:SF25', NULL, NULL, NULL, NULL, 'TOMOSYN, ISOFORM C', 252669),
(423647, 'PTHR10241:SF37', NULL, NULL, NULL, NULL, 'SYNTAXIN-BINDING PROTEIN 5B (TOMOSYN)', 252669),
(423648, 'PTHR10241:SF20', NULL, NULL, NULL, NULL, 'LLGL SCRIBBLE CELL POLARITY COMPLEX COMPONENT 2', 252669),
(423649, 'PTHR10241:SF21', NULL, NULL, NULL, NULL, 'LETHAL(2) GIANT LARVAE PROTEIN HOMOLOG 1', 252669),
(423650, 'PTHR10241:SF22', NULL, NULL, NULL, NULL, 'SYNTAXIN-BINDING PROTEIN 5', 252669),
(423651, 'PTHR10241:SF38', NULL, NULL, NULL, NULL, 'TRANSDUCIN FAMILY PROTEIN / WD-40 REPEAT FAMILY PROTEIN', 252669),
(423652, 'PTHR10241:SF27', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN', 252669),
(423653, 'PTHR10241:SF39', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR WD40-LIKE FAMILY-RELATED', 252669),
(423654, 'PTHR10241:SF29', NULL, NULL, NULL, NULL, 'LETHAL(2) GIANT LARVAE PROTEIN', 252669),
(423655, 'PTHR10241', NULL, NULL, NULL, NULL, 'LETHAL 2  GIANT LARVAE PROTEIN', 252669);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(423656, 'PTHR10241:SF19', NULL, NULL, NULL, NULL, 'SYNTAXIN-BINDING PROTEIN 5-LIKE', 252669),
(423657, 'PTHR34072', NULL, NULL, NULL, NULL, 'ENZYMATIC POLYPROTEIN-RELATED', 252670),
(423658, 'PTHR34072:SF30', NULL, NULL, NULL, NULL, 'RT_RNASEH DOMAIN-CONTAINING PROTEIN', 252670),
(423659, 'PTHR34072:SF31', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE', 252670),
(423660, 'PTHR34072:SF20', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 252670),
(423661, 'PTHR34072:SF40', NULL, NULL, NULL, NULL, 'RETROTRANSPOSON REVERSE TRANSCRIPTASE', 252670),
(423662, 'PTHR34072:SF38', NULL, NULL, NULL, NULL, 'OS11G0272675 PROTEIN', 252670),
(423663, 'PTHR34072:SF27', NULL, NULL, NULL, NULL, 'OSJNBA0059D20.8-LIKE PROTEIN', 252670),
(423664, 'PTHR34072:SF39', NULL, NULL, NULL, NULL, 'RT_RNASEH_2 DOMAIN-CONTAINING PROTEIN', 252670),
(423665, 'PTHR34072:SF28', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE', 252670),
(423666, 'PTHR34072:SF36', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE', 252670),
(423667, 'PTHR34072:SF25', NULL, NULL, NULL, NULL, 'RETROVIRUS-RELATED POL POLYPROTEIN FROM TRANSPOSON 297-LIKE PROTEIN', 252670),
(423668, 'PTHR34072:SF37', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 252670),
(423669, 'PTHR34072:SF26', NULL, NULL, NULL, NULL, 'ENDONUCLEASE', 252670),
(423670, 'PTHR34072:SF34', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE', 252670),
(423671, 'PTHR34072:SF23', NULL, NULL, NULL, NULL, 'RT_RNASEH_2 DOMAIN-CONTAINING PROTEIN', 252670),
(423672, 'PTHR34072:SF35', NULL, NULL, NULL, NULL, '', 252670),
(423673, 'PTHR34072:SF24', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 252670),
(423674, 'PTHR34072:SF32', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 252670),
(423675, 'PTHR34072:SF21', NULL, NULL, NULL, NULL, 'RETROTRANSPOSON PROTEIN-RELATED', 252670),
(423676, 'PTHR34072:SF22', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 252670),
(423677, 'PTHR34072:SF33', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 252670),
(423678, 'PTHR34072:SF29', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 252670),
(423679, 'PTHR43952', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR-RELATED', 252671),
(423680, 'PTHR43952:SF48', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR', 252671),
(423681, 'PTHR43952:SF28', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR', 252671),
(423682, 'PTHR43952:SF85', NULL, NULL, NULL, NULL, 'OS05G0579600 PROTEIN', 252671),
(423683, 'PTHR43952:SF63', NULL, NULL, NULL, NULL, 'BNAA04G12340D PROTEIN', 252671),
(423684, 'PTHR43952:SF62', NULL, NULL, NULL, NULL, 'MYB-LIKE DOMAIN-CONTAINING PROTEIN', 252671),
(423685, 'PTHR43952:SF87', NULL, NULL, NULL, NULL, 'SANT DOMAIN-CONTAINING PROTEIN', 252671),
(423686, 'PTHR43952:SF86', NULL, NULL, NULL, NULL, 'SANT DOMAIN-CONTAINING PROTEIN', 252671),
(423687, 'PTHR43952:SF42', NULL, NULL, NULL, NULL, 'PROTEIN RADIALIS-LIKE 1', 252671),
(423688, 'PTHR43952:SF20', NULL, NULL, NULL, NULL, 'SANT DOMAIN-CONTAINING PROTEIN', 252671),
(423689, 'PTHR43952:SF89', NULL, NULL, NULL, NULL, 'PROTEIN RADIALIS-LIKE 5', 252671),
(423690, 'PTHR43952:SF45', NULL, NULL, NULL, NULL, 'PROTEIN RADIALIS-LIKE 3', 252671),
(423691, 'PTHR43952:SF67', NULL, NULL, NULL, NULL, 'SANT DOMAIN-CONTAINING PROTEIN', 252671),
(423692, 'PTHR43952:SF88', NULL, NULL, NULL, NULL, 'SANT DOMAIN-CONTAINING PROTEIN', 252671),
(423693, 'PTHR43952:SF66', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB/SANT FAMILY-RELATED', 252671),
(423694, 'PTHR43952:SF25', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR', 252671),
(423695, 'PTHR43952:SF68', NULL, NULL, NULL, NULL, 'PROTEIN RADIALIS-LIKE 1', 252671),
(423696, 'PTHR43952:SF90', NULL, NULL, NULL, NULL, 'PROTEIN RADIALIS-LIKE 1', 252671),
(423697, 'PTHR43952:SF7', NULL, NULL, NULL, NULL, 'OS05G0579700 PROTEIN', 252671),
(423698, 'PTHR43952:SF92', NULL, NULL, NULL, NULL, 'SANT DOMAIN-CONTAINING PROTEIN', 252671);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(423699, 'PTHR43952:SF70', NULL, NULL, NULL, NULL, 'SANT DOMAIN-CONTAINING PROTEIN', 252671),
(423700, 'PTHR43952:SF91', NULL, NULL, NULL, NULL, '', 252671),
(423701, 'PTHR43952:SF72', NULL, NULL, NULL, NULL, 'SANT DOMAIN-CONTAINING PROTEIN', 252671),
(423702, 'PTHR43952:SF94', NULL, NULL, NULL, NULL, 'MYB-LIKE DOMAIN-CONTAINING PROTEIN', 252671),
(423703, 'PTHR43952:SF93', NULL, NULL, NULL, NULL, 'PROTEIN RADIALIS-LIKE 6', 252671),
(423704, 'PTHR43952:SF71', NULL, NULL, NULL, NULL, 'PROTEIN RADIALIS-LIKE 2', 252671),
(423705, 'PTHR43952:SF59', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR', 252671),
(423706, 'PTHR43952:SF17', NULL, NULL, NULL, NULL, 'PROTEIN RADIALIS-LIKE 3', 252671),
(423707, 'PTHR43952:SF19', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR', 252671),
(423708, 'PTHR43952:SF96', NULL, NULL, NULL, NULL, 'SANT DOMAIN-CONTAINING PROTEIN', 252671),
(423709, 'PTHR43952:SF74', NULL, NULL, NULL, NULL, 'SANT DOMAIN-CONTAINING PROTEIN', 252671),
(423710, 'PTHR43952:SF95', NULL, NULL, NULL, NULL, 'PROTEIN RADIALIS-LIKE 5', 252671),
(423711, 'PTHR43952:SF32', NULL, NULL, NULL, NULL, 'PROTEIN RADIALIS-LIKE 5', 252671),
(423712, 'PTHR43952:SF54', NULL, NULL, NULL, NULL, 'SANT DOMAIN-CONTAINING PROTEIN', 252671),
(423713, 'PTHR43952:SF75', NULL, NULL, NULL, NULL, 'PROTEIN RADIALIS-LIKE 4', 252671),
(423714, 'PTHR43952:SF53', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB/SANT FAMILY-RELATED', 252671),
(423715, 'PTHR43952:SF31', NULL, NULL, NULL, NULL, '', 252671),
(423716, 'PTHR43952:SF56', NULL, NULL, NULL, NULL, 'SANT DOMAIN-CONTAINING PROTEIN', 252671),
(423717, 'PTHR43952:SF55', NULL, NULL, NULL, NULL, 'BNAC08G49320D PROTEIN', 252671),
(423718, 'PTHR43952:SF33', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR', 252671),
(423719, 'PTHR43952:SF11', NULL, NULL, NULL, NULL, 'OS01G0635200 PROTEIN', 252671),
(423720, 'PTHR43952:SF13', NULL, NULL, NULL, NULL, 'OS05G0567600 PROTEIN', 252671),
(423721, 'PTHR43952:SF57', NULL, NULL, NULL, NULL, 'OS02G0706400 PROTEIN', 252671),
(423722, 'PTHR43952:SF80', NULL, NULL, NULL, NULL, 'PROTEIN RADIALIS-LIKE 3', 252671),
(423723, 'PTHR43952:SF61', NULL, NULL, NULL, NULL, 'SANT DOMAIN-CONTAINING PROTEIN', 252671),
(423724, 'PTHR43952:SF60', NULL, NULL, NULL, NULL, 'PROTEIN RADIALIS-LIKE 1 ISOFORM X1', 252671),
(423725, 'PTHR16160', NULL, NULL, NULL, NULL, 'FERMITIN 2-RELATED', 252672),
(423726, 'PTHR16160:SF1', NULL, NULL, NULL, NULL, 'FERMITIN FAMILY HOMOLOG 3', 252672),
(423727, 'PTHR16160:SF11', NULL, NULL, NULL, NULL, 'FERMITIN FAMILY HOMOLOG 2', 252672),
(423728, 'PTHR16160:SF13', NULL, NULL, NULL, NULL, 'FERMITIN 2-RELATED', 252672),
(423729, 'PTHR16160:SF12', NULL, NULL, NULL, NULL, 'FERMITIN FAMILY HOMOLOG 1', 252672),
(423730, 'PTHR33257:SF50', NULL, NULL, NULL, NULL, '', 252673),
(423731, 'PTHR33257:SF51', NULL, NULL, NULL, NULL, 'OS05G0165500 PROTEIN', 252673),
(423732, 'PTHR33257:SF20', NULL, NULL, NULL, NULL, '', 252673),
(423733, 'PTHR33257:SF53', NULL, NULL, NULL, NULL, '', 252673),
(423734, 'PTHR33257:SF54', NULL, NULL, NULL, NULL, '', 252673),
(423735, 'PTHR33257:SF21', NULL, NULL, NULL, NULL, 'OS07G0230600 PROTEIN', 252673),
(423736, 'PTHR33257:SF33', NULL, NULL, NULL, NULL, '', 252673),
(423737, 'PTHR33257:SF55', NULL, NULL, NULL, NULL, 'OS01G0824900 PROTEIN', 252673),
(423738, 'PTHR33257:SF44', NULL, NULL, NULL, NULL, 'BNAA03G00140D PROTEIN', 252673),
(423739, 'PTHR33257:SF56', NULL, NULL, NULL, NULL, 'OS05G0335500 PROTEIN', 252673),
(423740, 'PTHR33257:SF23', NULL, NULL, NULL, NULL, '', 252673),
(423741, 'PTHR33257:SF34', NULL, NULL, NULL, NULL, 'BNAA05G34210D PROTEIN', 252673),
(423742, 'PTHR33257:SF35', NULL, NULL, NULL, NULL, 'OS02G0461700 PROTEIN', 252673),
(423743, 'PTHR33257:SF57', NULL, NULL, NULL, NULL, 'BNACNNG40650D PROTEIN', 252673),
(423744, 'PTHR33257:SF46', NULL, NULL, NULL, NULL, '', 252673),
(423745, 'PTHR33257:SF25', NULL, NULL, NULL, NULL, '', 252673),
(423746, 'PTHR33257:SF58', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING SERINE/THREONINE-PROTEIN KINASE DDB_G0286997-RELATED', 252673);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(423747, 'PTHR33257:SF48', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252673),
(423748, 'PTHR33257:SF39', NULL, NULL, NULL, NULL, 'OS01G0166500 PROTEIN', 252673),
(423749, 'PTHR33257:SF29', NULL, NULL, NULL, NULL, '', 252673),
(423750, 'PTHR33257:SF4', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252673),
(423751, 'PTHR33257:SF6', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING 4B-LIKE PROTEIN-RELATED', 252673),
(423752, 'PTHR33257', NULL, NULL, NULL, NULL, 'OS05G0165500 PROTEIN', 252673),
(423753, 'PTHR23291:SF124', NULL, NULL, NULL, NULL, 'BAX INHIBITOR', 252674),
(423754, 'PTHR23291:SF99', NULL, NULL, NULL, NULL, 'NAGLU_C DOMAIN-CONTAINING PROTEIN', 252674),
(423755, 'PTHR23291:SF102', NULL, NULL, NULL, NULL, 'BAX INHIBITOR 1-RELATED PROTEIN-RELATED', 252674),
(423756, 'PTHR23291:SF77', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR, IONOTROPIC, N-METHYL D-ASPARTATE-ASSOCIATED PROTEIN 1B (GLUTAMATE-BINDING)', 252674),
(423757, 'PTHR23291:SF33', NULL, NULL, NULL, NULL, 'PROTEIN CBR-TAG-120', 252674),
(423758, 'PTHR23291:SF78', NULL, NULL, NULL, NULL, 'FAS APOPTOTIC INHIBITORY MOLECULE 2A', 252674),
(423759, 'PTHR23291:SF101', NULL, NULL, NULL, NULL, 'BAX INHIBITOR 1-RELATED PROTEIN-RELATED', 252674),
(423760, 'PTHR23291:SF123', NULL, NULL, NULL, NULL, 'PROTEIN LIFEGUARD 1', 252674),
(423761, 'PTHR23291:SF31', NULL, NULL, NULL, NULL, 'PROTEIN LIFEGUARD 4', 252674),
(423762, 'PTHR23291:SF103', NULL, NULL, NULL, NULL, 'PROTEIN LIFEGUARD 3', 252674),
(423763, 'PTHR23291:SF125', NULL, NULL, NULL, NULL, 'PROTEIN LIFEGUARD 4-LIKE', 252674),
(423764, 'PTHR23291:SF32', NULL, NULL, NULL, NULL, 'BAX INHIBITOR 1', 252674),
(423765, 'PTHR23291:SF98', NULL, NULL, NULL, NULL, 'BNAC08G10200D PROTEIN', 252674),
(423766, 'PTHR23291:SF106', NULL, NULL, NULL, NULL, '', 252674),
(423767, 'PTHR23291:SF16', NULL, NULL, NULL, NULL, 'PROTEIN LIFEGUARD 1', 252674),
(423768, 'PTHR23291:SF108', NULL, NULL, NULL, NULL, 'OS03G0795800 PROTEIN', 252674),
(423769, 'PTHR23291:SF35', NULL, NULL, NULL, NULL, 'PROTEIN LIFEGUARD 3', 252674),
(423770, 'PTHR23291:SF107', NULL, NULL, NULL, NULL, 'PROTEIN LIFEGUARD 2', 252674),
(423771, 'PTHR23291:SF39', NULL, NULL, NULL, NULL, 'OS11G0581900 PROTEIN', 252674),
(423772, 'PTHR23291:SF18', NULL, NULL, NULL, NULL, 'PROTEIN LIFEGUARD 2', 252674),
(423773, 'PTHR23291', NULL, NULL, NULL, NULL, 'BAX INHIBITOR-RELATED', 252674),
(423774, 'PTHR23291:SF91', NULL, NULL, NULL, NULL, 'BI1-LIKE PROTEIN', 252674),
(423775, 'PTHR23291:SF92', NULL, NULL, NULL, NULL, 'OS03G0795600 PROTEIN', 252674),
(423776, 'PTHR23291:SF90', NULL, NULL, NULL, NULL, '', 252674),
(423777, 'PTHR23291:SF95', NULL, NULL, NULL, NULL, 'BAX INHIBITOR 1-RELATED PROTEIN-RELATED', 252674),
(423778, 'PTHR23291:SF30', NULL, NULL, NULL, NULL, 'PROTEIN CBG15624', 252674),
(423779, 'PTHR23291:SF93', NULL, NULL, NULL, NULL, 'BAX INHIBITOR 1-LIKE', 252674),
(423780, 'PTHR23291:SF50', NULL, NULL, NULL, NULL, 'PROTEIN LIFEGUARD 4', 252674),
(423781, 'PTHR23291:SF94', NULL, NULL, NULL, NULL, 'SI:CH211-284O19.8', 252674),
(423782, 'PTHR23291:SF113', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE BAX INHIBITOR MOTIF-CONTAINING 7', 252674),
(423783, 'PTHR23291:SF112', NULL, NULL, NULL, NULL, 'GROWTH HORMONE-INDUCIBLE TRANSMEMBRANE PROTEIN', 252674),
(423784, 'PTHR23291:SF86', NULL, NULL, NULL, NULL, 'BAX INHIBITOR 1', 252674),
(423785, 'PTHR23291:SF115', NULL, NULL, NULL, NULL, 'MODULATOR OF FTSH PROTEASE YCCA', 252674),
(423786, 'PTHR23291:SF114', NULL, NULL, NULL, NULL, 'OS07G0177300 PROTEIN', 252674),
(423787, 'PTHR23291:SF117', NULL, NULL, NULL, NULL, 'BNAA01G22850D PROTEIN', 252674),
(423788, 'PTHR23291:SF116', NULL, NULL, NULL, NULL, '', 252674),
(423789, 'PTHR23291:SF119', NULL, NULL, NULL, NULL, '', 252674),
(423790, 'PTHR23291:SF118', NULL, NULL, NULL, NULL, 'BNAA02G25030D PROTEIN', 252674),
(423791, 'PTHR23291:SF47', NULL, NULL, NULL, NULL, 'X-BOX PROMOTER ELEMENT REGULATED', 252674),
(423792, 'PTHR23291:SF120', NULL, NULL, NULL, NULL, 'INHIBITOR OF APOPTOSIS-PROMOTING BAX1 PROTEIN', 252674),
(423793, 'PTHR23291:SF84', NULL, NULL, NULL, NULL, 'INHIBITOR OF APOPTOSIS-PROMOTING BAX1 PROTEIN', 252674);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(423794, 'PTHR23291:SF40', NULL, NULL, NULL, NULL, 'OS07G0177200 PROTEIN', 252674),
(423795, 'PTHR23291:SF122', NULL, NULL, NULL, NULL, 'BAX INHIBITOR 1', 252674),
(423796, 'PTHR23291:SF100', NULL, NULL, NULL, NULL, 'BAX INHIBITOR 1-LIKE', 252674),
(423797, 'PTHR23291:SF121', NULL, NULL, NULL, NULL, 'BI1-LIKE PROTEIN', 252674),
(423798, 'PTHR14095:SF2', NULL, NULL, NULL, NULL, '', 252675),
(423799, 'PTHR14095:SF3', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT B'''' SUBUNIT ALPHA', 252675),
(423800, 'PTHR14095:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG18998', 252675),
(423801, 'PTHR14095:SF19', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN PAIR-RELATED', 252675),
(423802, 'PTHR14095', NULL, NULL, NULL, NULL, 'PHOSPHATASE 2A REGULATORY SUBUNIT-RELATED', 252675),
(423803, 'PTHR14095:SF7', NULL, NULL, NULL, NULL, 'OS02G0191700 PROTEIN', 252675),
(423804, 'PTHR14095:SF8', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF-HAND PROTEIN', 252675),
(423805, 'PTHR14095:SF18', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF-HAND FAMILY PROTEIN-RELATED', 252675),
(423806, 'PTHR14095:SF15', NULL, NULL, NULL, NULL, 'BNAA09G03510D PROTEIN', 252675),
(423807, 'PTHR14095:SF24', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT B''''EPSILON-RELATED', 252675),
(423808, 'PTHR14095:SF14', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT B''''BETA-LIKE ISOFORM X2', 252675),
(423809, 'PTHR14095:SF22', NULL, NULL, NULL, NULL, '', 252675),
(423810, 'PTHR14095:SF11', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT B''''BETA-LIKE', 252675),
(423811, 'PTHR14095:SF23', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT B''''ALPHA-LIKE ISOFORM X1', 252675),
(423812, 'PTHR14095:SF12', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT B''''DELTA-RELATED', 252675),
(423813, 'PTHR14095:SF20', NULL, NULL, NULL, NULL, 'ION BINDING PROTEIN, PUTATIVE-RELATED', 252675),
(423814, 'PTHR14095:SF10', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT B''''ALPHA', 252675),
(423815, 'PTHR14095:SF21', NULL, NULL, NULL, NULL, 'ION BINDING PROTEIN, PUTATIVE-RELATED', 252675),
(423816, 'PTHR14095:SF0', NULL, NULL, NULL, NULL, 'MIP22305P', 252675),
(423817, 'PTHR14095:SF1', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT B'''' SUBUNIT BETA', 252675),
(423818, 'PTHR35361:SF4', NULL, NULL, NULL, NULL, '', 252676),
(423819, 'PTHR35361:SF1', NULL, NULL, NULL, NULL, 'OS08G0443700 PROTEIN', 252676),
(423820, 'PTHR35361:SF2', NULL, NULL, NULL, NULL, '', 252676),
(423821, 'PTHR35361', NULL, NULL, NULL, NULL, 'OS08G0443700 PROTEIN', 252676),
(423822, 'PTHR35361:SF7', NULL, NULL, NULL, NULL, '', 252676),
(423823, 'PTHR14927:SF1', NULL, NULL, NULL, NULL, 'NUC153 DOMAIN-CONTAINING PROTEIN', 252677),
(423824, 'PTHR14927:SF0', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 10', 252677),
(423825, 'PTHR14927', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252677),
(423826, 'PTHR43278:SF1', NULL, NULL, NULL, NULL, 'IRON-SULFUR FLAVOPROTEIN MJ1083', 252678),
(423827, 'PTHR43278:SF2', NULL, NULL, NULL, NULL, 'FMN_RED DOMAIN-CONTAINING PROTEIN', 252678),
(423828, 'PTHR43278:SF3', NULL, NULL, NULL, NULL, 'IRON-SULFUR FLAVOPROTEIN MJ0731', 252678),
(423829, 'PTHR43278:SF4', NULL, NULL, NULL, NULL, 'NAD(P)H-DEPENDENT FMN-CONTAINING OXIDOREDUCTASE YWQN-RELATED', 252678),
(423830, 'PTHR43278', NULL, NULL, NULL, NULL, 'NAD(P)H-DEPENDENT FMN-CONTAINING OXIDOREDUCTASE YWQN-RELATED', 252678),
(423831, 'PTHR15605:SF2', NULL, NULL, NULL, NULL, 'KINESIN-ASSOCIATED PROTEIN 3', 252679),
(423832, 'PTHR15605', NULL, NULL, NULL, NULL, 'KINESIN-ASSOCIATED PROTEINS', 252679),
(423833, 'PTHR33444:SF2', NULL, NULL, NULL, NULL, 'SI:DKEY-19B23.12-RELATED', 252680),
(423834, 'PTHR33444:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG04286', 252680),
(423835, 'PTHR33444:SF7', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 272', 252680);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(423836, 'PTHR33444', NULL, NULL, NULL, NULL, 'SI:DKEY-19B23.12-RELATED', 252680),
(423837, 'PTHR31327:SF3', NULL, NULL, NULL, NULL, 'MULTIPLE PDZ DOMAIN PROTEIN', 252681),
(423838, 'PTHR31327:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG09116', 252681),
(423839, 'PTHR31327:SF11', NULL, NULL, NULL, NULL, 'PROTEIN CBG02257', 252681),
(423840, 'PTHR31327', NULL, NULL, NULL, NULL, 'SPERM MEIOSIS PDZ DOMAIN CONTAINING PROTEINS-RELATED', 252681),
(423841, 'PTHR31327:SF10', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN', 252681),
(423842, 'PTHR31327:SF7', NULL, NULL, NULL, NULL, 'SPERM MEIOSIS PDZ DOMAIN CONTAINING PROTEINS', 252681),
(423843, 'PTHR31327:SF6', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN', 252681),
(423844, 'PTHR31327:SF12', NULL, NULL, NULL, NULL, 'PROTEIN CBG02245', 252681),
(423845, 'PTHR31327:SF5', NULL, NULL, NULL, NULL, 'MULTIPLE PDZ DOMAIN PROTEIN', 252681),
(423846, 'PTHR31327:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG17607', 252681),
(423847, 'PTHR35329', NULL, NULL, NULL, NULL, 'CHITIN SYNTHASE EXPORT CHAPERONE', 252682),
(423848, 'PTHR35329:SF1', NULL, NULL, NULL, NULL, 'CHITIN SYNTHASE EXPORT CHAPERONE', 252682),
(423849, 'PTHR35329:SF2', NULL, NULL, NULL, NULL, 'CHITIN SYNTHASE EXPORT CHAPERONE', 252682),
(423850, 'PTHR13693:SF58', NULL, NULL, NULL, NULL, '5-AMINOLEVULINATE SYNTHASE, ERYTHROID-SPECIFIC, MITOCHONDRIAL', 252683),
(423851, 'PTHR13693:SF2', NULL, NULL, NULL, NULL, 'SERINE PALMITOYLTRANSFERASE 1', 252683),
(423852, 'PTHR13693:SF3', NULL, NULL, NULL, NULL, 'LD36009P', 252683),
(423853, 'PTHR13693:SF82', NULL, NULL, NULL, NULL, 'AMINOTRAN_1_2 DOMAIN-CONTAINING PROTEIN', 252683),
(423854, 'PTHR13693:SF81', NULL, NULL, NULL, NULL, 'LONG CHAIN BASE BIOSYNTHESIS PROTEIN 2A', 252683),
(423855, 'PTHR13693:SF79', NULL, NULL, NULL, NULL, 'SERINE PALMITOYLTRANSFERASE 2', 252683),
(423856, 'PTHR13693:SF89', NULL, NULL, NULL, NULL, 'OS01G0736400 PROTEIN', 252683),
(423857, 'PTHR13693:SF56', NULL, NULL, NULL, NULL, 'SERINE PALMITOYLTRANSFERASE 3', 252683),
(423858, 'PTHR13693:SF77', NULL, NULL, NULL, NULL, '8-AMINO-7-OXONONANOATE SYNTHASE', 252683),
(423859, 'PTHR13693:SF99', NULL, NULL, NULL, NULL, 'SERINE C-PALMITOYLTRANSFERASE', 252683),
(423860, 'PTHR13693:SF88', NULL, NULL, NULL, NULL, 'SERINE C-PALMITOYLTRANSFERASE', 252683),
(423861, 'PTHR13693:SF54', NULL, NULL, NULL, NULL, 'SERINE PALMITOYLTRANSFERASE 3', 252683),
(423862, 'PTHR13693:SF86', NULL, NULL, NULL, NULL, 'LONG CHAIN BASE BIOSYNTHESIS PROTEIN 1-LIKE', 252683),
(423863, 'PTHR13693:SF102', NULL, NULL, NULL, NULL, '2-AMINO-3-KETOBUTYRATE COENZYME A LIGASE, MITOCHONDRIAL', 252683),
(423864, 'PTHR13693:SF96', NULL, NULL, NULL, NULL, 'SERINE C-PALMITOYLTRANSFERASE', 252683),
(423865, 'PTHR13693', NULL, NULL, NULL, NULL, 'CLASS II AMINOTRANSFERASE/8-AMINO-7-OXONONANOATE SYNTHASE', 252683),
(423866, 'PTHR13693:SF95', NULL, NULL, NULL, NULL, 'SERINE C-PALMITOYLTRANSFERASE', 252683),
(423867, 'PTHR13693:SF50', NULL, NULL, NULL, NULL, '5-AMINOLEVULINATE SYNTHASE, NONSPECIFIC, MITOCHONDRIAL', 252683),
(423868, 'PTHR13693:SF100', NULL, NULL, NULL, NULL, '8-AMINO-7-OXONONANOATE SYNTHASE', 252683),
(423869, 'PTHR13693:SF83', NULL, NULL, NULL, NULL, 'SERINE PALMITOYLTRANSFERASE, LONG CHAIN BASE SUBUNIT 2B', 252683),
(423870, 'PTHR44533:SF3', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX60-RELATED', 252684),
(423871, 'PTHR44533:SF4', NULL, NULL, NULL, NULL, 'DEAD/H RNA HELICASE, PUTATIVE-RELATED', 252684),
(423872, 'PTHR44533:SF5', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX60-RELATED', 252684),
(423873, 'PTHR44533', NULL, NULL, NULL, NULL, 'DEAD/H RNA HELICASE, PUTATIVE-RELATED', 252684),
(423874, 'PTHR44533:SF1', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DDX60-LIKE-RELATED', 252684),
(423875, 'PTHR15829:SF15', NULL, NULL, NULL, NULL, 'RIPOR FAMILY MEMBER 3', 252685),
(423876, 'PTHR15829', NULL, NULL, NULL, NULL, 'PROTEIN KINASE PKN/PRK1, EFFECTOR', 252685),
(423877, 'PTHR15829:SF13', NULL, NULL, NULL, NULL, 'PL48 DOMAIN-CONTAINING PROTEIN', 252685),
(423878, 'PTHR15829:SF2', NULL, NULL, NULL, NULL, 'RHO FAMILY-INTERACTING CELL POLARIZATION REGULATOR 2', 252685);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(423879, 'PTHR15829:SF1', NULL, NULL, NULL, NULL, 'RHO FAMILY-INTERACTING CELL POLARIZATION REGULATOR 1', 252685),
(423880, 'PTHR33627', NULL, NULL, NULL, NULL, 'TRANSPOSASE', 252686),
(423881, 'PTHR33627:SF1', NULL, NULL, NULL, NULL, 'TRANSPOSASE', 252686),
(423882, 'PTHR15599:SF3', NULL, NULL, NULL, NULL, '', 252687),
(423883, 'PTHR15599:SF4', NULL, NULL, NULL, NULL, 'RADIAL SPIKE PROTEIN 8', 252687),
(423884, 'PTHR15599', NULL, NULL, NULL, NULL, 'RTDR1', 252687),
(423885, 'PTHR15599:SF1', NULL, NULL, NULL, NULL, 'RADIAL SPOKE HEAD 14 HOMOLOG', 252687),
(423886, 'PTHR22760:SF3', NULL, NULL, NULL, NULL, 'GPI MANNOSYLTRANSFERASE 4', 252688),
(423887, 'PTHR22760:SF2', NULL, NULL, NULL, NULL, 'ALPHA-1,2-MANNOSYLTRANSFERASE ALG9', 252688),
(423888, 'PTHR22760:SF5', NULL, NULL, NULL, NULL, 'MANNOSYLTRANSFERASE', 252688),
(423889, 'PTHR22760:SF4', NULL, NULL, NULL, NULL, 'GPI MANNOSYLTRANSFERASE 3', 252688),
(423890, 'PTHR22760', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 252688),
(423891, 'PTHR22760:SF1', NULL, NULL, NULL, NULL, 'DOL-P-MAN:MAN(7)GLCNAC(2)-PP-DOL ALPHA-1,6-MANNOSYLTRANSFERASE', 252688),
(423892, 'PTHR32222', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN U', 252689),
(423893, 'PTHR32222:SF1', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN U', 252689),
(423894, 'PTHR31841', NULL, NULL, NULL, NULL, 'PROTEIN FAM72A-RELATED', 252690),
(423895, 'PTHR31841:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAM72A-RELATED', 252690),
(423896, 'PTHR36837', NULL, NULL, NULL, NULL, 'POLY(3-HYDROXYALKANOATE) POLYMERASE SUBUNIT PHAC', 252691),
(423897, 'PTHR36837:SF2', NULL, NULL, NULL, NULL, 'POLY(3-HYDROXYALKANOATE) POLYMERASE SUBUNIT PHAC', 252691),
(423898, 'PTHR36837:SF4', NULL, NULL, NULL, NULL, 'BLR0908 PROTEIN', 252691),
(423899, 'PTHR38364', NULL, NULL, NULL, NULL, 'OSJNBA0022H21.9 PROTEIN', 252692),
(423900, 'PTHR38364:SF1', NULL, NULL, NULL, NULL, 'OS04G0475300 PROTEIN', 252692),
(423901, 'PTHR30250:SF28', NULL, NULL, NULL, NULL, 'POLYSACCHARIDE BIOSYNTHESIS PROTEIN', 252693),
(423902, 'PTHR30250:SF27', NULL, NULL, NULL, NULL, 'POLYSACCHARIDE BIOSYNTHESIS PROTEIN', 252693),
(423903, 'PTHR30250:SF29', NULL, NULL, NULL, NULL, 'STAGE V SPORULATION PROTEIN B', 252693),
(423904, 'PTHR30250:SF11', NULL, NULL, NULL, NULL, 'CAPSULAR POLYSACCHARIDE EXPORT PROTEIN (FLIPPASE)-RELATED', 252693),
(423905, 'PTHR30250', NULL, NULL, NULL, NULL, 'PST FAMILY PREDICTED COLANIC ACID TRANSPORTER', 252693),
(423906, 'PTHR30250:SF10', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YGHQ-RELATED', 252693),
(423907, 'PTHR30250:SF21', NULL, NULL, NULL, NULL, 'LIPID II FLIPPASE MURJ', 252693),
(423908, 'PTHR30250:SF24', NULL, NULL, NULL, NULL, 'STAGE V SPORULATION PROTEIN B', 252693),
(423909, 'PTHR30250:SF23', NULL, NULL, NULL, NULL, 'POLYSACCHARIDE BIOSYNTHESIS RELATED PROTEIN-RELATED', 252693),
(423910, 'PTHR30250:SF26', NULL, NULL, NULL, NULL, 'LIPID III FLIPPASE', 252693),
(423911, 'PTHR30250:SF25', NULL, NULL, NULL, NULL, 'O-ANTIGEN TRANSPORTER-RELATED', 252693),
(423912, 'PTHR23306:SF22', NULL, NULL, NULL, NULL, 'PROTEIN ELC', 252694),
(423913, 'PTHR23306:SF21', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME/RWD-LIKE PROTEIN', 252694),
(423914, 'PTHR23306:SF20', NULL, NULL, NULL, NULL, 'PROTEIN ELC-LIKE', 252694),
(423915, 'PTHR23306:SF25', NULL, NULL, NULL, NULL, 'ZGC:123278', 252694),
(423916, 'PTHR23306', NULL, NULL, NULL, NULL, 'TUMOR SUSCEPTIBILITY GENE 101 PROTEIN-RELATED', 252694),
(423917, 'PTHR23306:SF24', NULL, NULL, NULL, NULL, 'UEV DOMAIN-CONTAINING PROTEIN', 252694),
(423918, 'PTHR23306:SF23', NULL, NULL, NULL, NULL, '', 252694),
(423919, 'PTHR23306:SF3', NULL, NULL, NULL, NULL, 'TUMOR SUPPRESSOR PROTEIN 101', 252694),
(423920, 'PTHR23306:SF18', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2 VARIANT 3', 252694),
(423921, 'PTHR23306:SF17', NULL, NULL, NULL, NULL, 'TUMOR SUSCEPTIBILITY GENE 101 PROTEIN', 252694),
(423922, 'PTHR10031:SF0', NULL, NULL, NULL, NULL, 'ATPASE PROTEIN 9', 252695),
(423923, 'PTHR10031:SF48', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT C, CHLOROPLASTIC', 252695);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(423924, 'PTHR10031:SF49', NULL, NULL, NULL, NULL, 'ATP SYNTHASE F(0) COMPLEX SUBUNIT C2, MITOCHONDRIAL', 252695),
(423925, 'PTHR10031:SF38', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT 9, MITOCHONDRIAL', 252695),
(423926, 'PTHR10031:SF50', NULL, NULL, NULL, NULL, 'ATP SYNTHASE LIPID-BINDING PROTEIN', 252695),
(423927, 'PTHR10031:SF44', NULL, NULL, NULL, NULL, 'ATP SYNTHASE MEMBRANE SUBUNIT C LOCUS 1', 252695),
(423928, 'PTHR10031:SF45', NULL, NULL, NULL, NULL, 'ATP SYNTHASE LIPID-BINDING PROTEIN', 252695),
(423929, 'PTHR10031:SF46', NULL, NULL, NULL, NULL, 'ATP SYNTHASE F(0) COMPLEX SUBUNIT C3, MITOCHONDRIAL', 252695),
(423930, 'PTHR10031:SF13', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT 9, MITOCHONDRIAL', 252695),
(423931, 'PTHR10031:SF47', NULL, NULL, NULL, NULL, 'ATP SYNTHASE F(0) COMPLEX SUBUNIT C1, MITOCHONDRIAL', 252695),
(423932, 'PTHR10031', NULL, NULL, NULL, NULL, 'ATP SYNTHASE LIPID-BINDING PROTEIN, MITOCHONDRIAL', 252695),
(423933, 'PTHR10031:SF41', NULL, NULL, NULL, NULL, 'ATPASE, F0 COMPLEX, SUBUNIT C, V-ATPASE PROTEOLIPID SUBUNIT C-LIKE DOMAIN PROTEIN-RELATED', 252695),
(423934, 'PTHR10031:SF32', NULL, NULL, NULL, NULL, 'ATP SYNTHASE F(0) COMPLEX SUBUNIT C2, MITOCHONDRIAL', 252695),
(423935, 'PTHR23414', NULL, NULL, NULL, NULL, 'ADRENOMEDULLIN, ADM', 252696),
(423936, 'PTHR23414:SF2', NULL, NULL, NULL, NULL, 'PROTEIN ADM2', 252696),
(423937, 'PTHR23414:SF3', NULL, NULL, NULL, NULL, 'PRO-ADRENOMEDULLIN', 252696),
(423938, 'PTHR23414:SF6', NULL, NULL, NULL, NULL, 'ADRENOMEDULLIN-5-LIKE PROTEIN-RELATED', 252696),
(423939, 'PTHR23414:SF7', NULL, NULL, NULL, NULL, '', 252696),
(423940, 'PTHR35844', NULL, NULL, NULL, NULL, '', 252697),
(423941, 'PTHR35844:SF1', NULL, NULL, NULL, NULL, '', 252697),
(423942, 'PTHR13813:SF2', NULL, NULL, NULL, NULL, 'GLYCOPHORIN-B', 252698),
(423943, 'PTHR13813', NULL, NULL, NULL, NULL, 'GLYCOPHORIN', 252698),
(423944, 'PTHR13813:SF5', NULL, NULL, NULL, NULL, 'GLYCOPHORIN-A', 252698),
(423945, 'PTHR13813:SF3', NULL, NULL, NULL, NULL, 'GLYCOPHORIN-A', 252698),
(423946, 'PTHR13813:SF4', NULL, NULL, NULL, NULL, 'GLYCOPHORIN-E', 252698),
(423947, 'PTHR34322:SF2', NULL, NULL, NULL, NULL, 'Y1_TNP DOMAIN-CONTAINING PROTEIN', 252699),
(423948, 'PTHR34322', NULL, NULL, NULL, NULL, 'TRANSPOSASE, Y1_TNP DOMAIN-CONTAINING', 252699),
(423949, 'PTHR15000', NULL, NULL, NULL, NULL, 'ERYTHROID DIFFERENTIATION-RELATED FACTOR 1', 252700),
(423950, 'PTHR15000:SF1', NULL, NULL, NULL, NULL, 'ERYTHROID DIFFERENTIATION-RELATED FACTOR 1', 252700),
(423951, 'PTHR12114:SF8', NULL, NULL, NULL, NULL, '', 252701),
(423952, 'PTHR12114', NULL, NULL, NULL, NULL, 'PARVIN', 252701),
(423953, 'PTHR12114:SF1', NULL, NULL, NULL, NULL, 'GAMMA-PARVIN', 252701),
(423954, 'PTHR12114:SF4', NULL, NULL, NULL, NULL, 'GH23568P', 252701),
(423955, 'PTHR12114:SF6', NULL, NULL, NULL, NULL, 'ALPHA-PARVIN', 252701),
(423956, 'PTHR12114:SF7', NULL, NULL, NULL, NULL, 'BETA-PARVIN', 252701),
(423957, 'PTHR34759', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 48', 252702),
(423958, 'PTHR34759:SF1', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 48', 252702),
(423959, 'PTHR21736:SF36', NULL, NULL, NULL, NULL, 'PROTEIN OBERON 1-LIKE', 252703),
(423960, 'PTHR21736:SF44', NULL, NULL, NULL, NULL, 'OBERON-LIKE PROTEIN', 252703),
(423961, 'PTHR21736:SF39', NULL, NULL, NULL, NULL, 'PROTEIN OBERON 1', 252703),
(423962, 'PTHR21736', NULL, NULL, NULL, NULL, 'VERNALIZATION-INSENSITIVE PROTEIN 3', 252703),
(423963, 'PTHR21736:SF37', NULL, NULL, NULL, NULL, 'PROTEIN OBERON 2', 252703),
(423964, 'PTHR21736:SF38', NULL, NULL, NULL, NULL, 'PROTEIN OBERON 3', 252703),
(423965, 'PTHR21736:SF20', NULL, NULL, NULL, NULL, 'PROTEIN OBERON 4', 252703),
(423966, 'PTHR21736:SF42', NULL, NULL, NULL, NULL, 'PHD_OBERON DOMAIN-CONTAINING PROTEIN', 252703),
(423967, 'PTHR21736:SF43', NULL, NULL, NULL, NULL, 'BNAA05G29870D PROTEIN', 252703),
(423968, 'PTHR21736:SF40', NULL, NULL, NULL, NULL, 'PHD_OBERON DOMAIN-CONTAINING PROTEIN', 252703),
(423969, 'PTHR21736:SF41', NULL, NULL, NULL, NULL, 'OBERON-LIKE PROTEIN', 252703);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(423970, 'PTHR14047:SF31', NULL, NULL, NULL, NULL, 'X ANTIGEN FAMILY MEMBER 1', 252704),
(423971, 'PTHR14047:SF30', NULL, NULL, NULL, NULL, 'G ANTIGEN 1-RELATED', 252704),
(423972, 'PTHR14047:SF1', NULL, NULL, NULL, NULL, 'P ANTIGEN FAMILY MEMBER 3', 252704),
(423973, 'PTHR14047:SF11', NULL, NULL, NULL, NULL, 'P ANTIGEN FAMILY MEMBER 4', 252704),
(423974, 'PTHR14047:SF33', NULL, NULL, NULL, NULL, 'X ANTIGEN FAMILY MEMBER 5', 252704),
(423975, 'PTHR14047:SF35', NULL, NULL, NULL, NULL, 'X ANTIGEN FAMILY MEMBER 2', 252704),
(423976, 'PTHR14047:SF34', NULL, NULL, NULL, NULL, 'G ANTIGEN FAMILY E MEMBER 3-RELATED', 252704),
(423977, 'PTHR14047:SF37', NULL, NULL, NULL, NULL, 'P ANTIGEN FAMILY MEMBER 5', 252704),
(423978, 'PTHR14047:SF3', NULL, NULL, NULL, NULL, 'P ANTIGEN FAMILY MEMBER 1', 252704),
(423979, 'PTHR14047', NULL, NULL, NULL, NULL, 'P ANTIGEN FAMILY MEMBER 5-RELATED', 252704),
(423980, 'PTHR14047:SF4', NULL, NULL, NULL, NULL, 'X ANTIGEN FAMILY MEMBER 3', 252704),
(423981, 'PTHR36732:SF1', NULL, NULL, NULL, NULL, 'GLYCINE RICH PROTEIN 9-RELATED', 252705),
(423982, 'PTHR36732', NULL, NULL, NULL, NULL, 'GLYCINE RICH PROTEIN 9-RELATED', 252705),
(423983, 'PTHR43773:SF1', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER MGTE', 252706),
(423984, 'PTHR43773', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER MGTE', 252706),
(423985, 'PTHR43773:SF3', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER MGTE', 252706),
(423986, 'PTHR24399:SF29', NULL, NULL, NULL, NULL, 'B-CELL LYMPHOMA 6 PROTEIN', 252707),
(423987, 'PTHR24399:SF28', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 25', 252707),
(423988, 'PTHR24399', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING', 252707),
(423989, 'PTHR24399:SF27', NULL, NULL, NULL, NULL, 'HYPERMETHYLATED IN CANCER 2 PROTEIN', 252707),
(423990, 'PTHR24399:SF49', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 41', 252707),
(423991, 'PTHR24399:SF24', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR KAISO', 252707),
(423992, 'PTHR24399:SF46', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 3', 252707),
(423993, 'PTHR24399:SF23', NULL, NULL, NULL, NULL, 'FINGER PUTATIVE TRANSCRIPTION FACTOR FAMILY-RELATED', 252707),
(423994, 'PTHR24399:SF67', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 709', 252707),
(423995, 'PTHR24399:SF66', NULL, NULL, NULL, NULL, 'NOVEL KRAB BOX AND ZINC FINGER, C2H2 TYPE DOMAIN CONTAINING PROTEIN-RELATED', 252707),
(423996, 'PTHR24399:SF65', NULL, NULL, NULL, NULL, '', 252707),
(423997, 'PTHR24399:SF43', NULL, NULL, NULL, NULL, '', 252707),
(423998, 'PTHR24399:SF0', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 2', 252707),
(423999, 'PTHR24399:SF21', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 1', 252707),
(424000, 'PTHR24399:SF42', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 34', 252707),
(424001, 'PTHR24399:SF64', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 252707),
(424002, 'PTHR24399:SF41', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN GFI-1B', 252707),
(424003, 'PTHR24399:SF63', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 510', 252707),
(424004, 'PTHR24399:SF40', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 32', 252707),
(424005, 'PTHR24399:SF62', NULL, NULL, NULL, NULL, '', 252707),
(424006, 'PTHR24399:SF4', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 134', 252707),
(424007, 'PTHR24399:SF61', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 616', 252707),
(424008, 'PTHR24399:SF60', NULL, NULL, NULL, NULL, '', 252707),
(424009, 'PTHR24399:SF5', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 14', 252707),
(424010, 'PTHR24399:SF6', NULL, NULL, NULL, NULL, 'MYONEURIN', 252707),
(424011, 'PTHR24399:SF8', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 17', 252707),
(424012, 'PTHR24399:SF9', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 572', 252707),
(424013, 'PTHR24399:SF19', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 20', 252707);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(424014, 'PTHR24399:SF39', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 24', 252707),
(424015, 'PTHR24399:SF17', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING 38', 252707),
(424016, 'PTHR24399:SF38', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 12', 252707),
(424017, 'PTHR24399:SF16', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 45', 252707),
(424018, 'PTHR24399:SF37', NULL, NULL, NULL, NULL, 'B-CELL CLL/LYMPHOMA 6 MEMBER B PROTEIN', 252707),
(424019, 'PTHR24399:SF15', NULL, NULL, NULL, NULL, 'POZ-, AT HOOK-, AND ZINC FINGER-CONTAINING PROTEIN 1', 252707),
(424020, 'PTHR24399:SF36', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 6', 252707),
(424021, 'PTHR24399:SF14', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 26', 252707),
(424022, 'PTHR24399:SF35', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 131', 252707),
(424023, 'PTHR24399:SF57', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 22', 252707),
(424024, 'PTHR24399:SF34', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 39', 252707),
(424025, 'PTHR24399:SF11', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 648', 252707),
(424026, 'PTHR24399:SF32', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 37', 252707),
(424027, 'PTHR24399:SF54', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 49', 252707),
(424028, 'PTHR24399:SF31', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN PLAGL1', 252707),
(424029, 'PTHR15404', NULL, NULL, NULL, NULL, 'PROTEIN AF1Q', 252708),
(424030, 'PTHR15404:SF2', NULL, NULL, NULL, NULL, 'PROTEIN AF1Q', 252708),
(424031, 'PTHR27001:SF71', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252709),
(424032, 'PTHR27001:SF152', NULL, NULL, NULL, NULL, 'KINASE WITH ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE DOMAIN-CONTAINING PROTEIN', 252709),
(424033, 'PTHR27001:SF790', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252709),
(424034, 'PTHR27001:SF542', NULL, NULL, NULL, NULL, 'OS08G0138700 PROTEIN', 252709),
(424035, 'PTHR27001:SF663', NULL, NULL, NULL, NULL, 'OS02G0136900 PROTEIN', 252709),
(424036, 'PTHR27001:SF543', NULL, NULL, NULL, NULL, 'OS10G0516200 PROTEIN', 252709),
(424037, 'PTHR27001:SF820', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 252709),
(424038, 'PTHR27001:SF660', NULL, NULL, NULL, NULL, 'SALT TOLERANCE RECEPTOR-LIKE CYTOPLASMIC KINASE 1', 252709),
(424039, 'PTHR27001:SF782', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE NCRK', 252709),
(424040, 'PTHR27001:SF825', NULL, NULL, NULL, NULL, 'OS01G0384300 PROTEIN', 252709),
(424041, 'PTHR27001:SF707', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 252709),
(424042, 'PTHR27001:SF789', NULL, NULL, NULL, NULL, 'KINASE WITH ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE DOMAIN-CONTAINING PROTEIN', 252709),
(424043, 'PTHR27001:SF668', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252709),
(424044, 'PTHR27001:SF703', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252709),
(424045, 'PTHR27001:SF62', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 252709),
(424046, 'PTHR27001:SF66', NULL, NULL, NULL, NULL, 'OS01G0738300 PROTEIN', 252709),
(424047, 'PTHR27001:SF796', NULL, NULL, NULL, NULL, 'OS04G0213800 PROTEIN', 252709),
(424048, 'PTHR27001:SF677', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 252709),
(424049, 'PTHR27001:SF155', NULL, NULL, NULL, NULL, 'OS03G0839900 PROTEIN', 252709),
(424050, 'PTHR27001:SF673', NULL, NULL, NULL, NULL, 'PROTEIN STRUBBELIG', 252709),
(424051, 'PTHR27001:SF277', NULL, NULL, NULL, NULL, 'PROTEIN STRUBBELIG-RECEPTOR FAMILY 8', 252709),
(424052, 'PTHR27001:SF799', NULL, NULL, NULL, NULL, 'SERINE/THREONINE KINASE FAMILY PROTEIN', 252709),
(424053, 'PTHR27001:SF711', NULL, NULL, NULL, NULL, 'OS01G0927500 PROTEIN', 252709),
(424054, 'PTHR27001:SF762', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252709);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(424055, 'PTHR27001:SF487', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252709),
(424056, 'PTHR27001:SF883', NULL, NULL, NULL, NULL, 'PROLINE-RICH RECEPTOR-LIKE PROTEIN KINASE PERK9', 252709),
(424057, 'PTHR27001:SF489', NULL, NULL, NULL, NULL, 'PROLINE-RICH RECEPTOR-LIKE PROTEIN KINASE PERK8', 252709),
(424058, 'PTHR27001:SF764', NULL, NULL, NULL, NULL, 'OS05G0387700 PROTEIN', 252709),
(424059, 'PTHR27001:SF522', NULL, NULL, NULL, NULL, 'OS02G0106900 PROTEIN', 252709),
(424060, 'PTHR27001:SF523', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 40', 252709),
(424061, 'PTHR27001:SF924', NULL, NULL, NULL, NULL, 'PROTEIN NSP-INTERACTING KINASE 1', 252709),
(424062, 'PTHR27001:SF803', NULL, NULL, NULL, NULL, 'OS01G0247500 PROTEIN', 252709),
(424063, 'PTHR27001:SF925', NULL, NULL, NULL, NULL, 'OS05G0319700 PROTEIN', 252709),
(424064, 'PTHR27001:SF926', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE CDG1', 252709),
(424065, 'PTHR27001:SF927', NULL, NULL, NULL, NULL, 'OS11G0664100 PROTEIN', 252709),
(424066, 'PTHR27001:SF920', NULL, NULL, NULL, NULL, 'STRUBBELIG RECEPTOR FAMILY PROTEIN', 252709),
(424067, 'PTHR27001:SF921', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252709),
(424068, 'PTHR27001:SF801', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252709),
(424069, 'PTHR27001:SF922', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252709),
(424070, 'PTHR27001:SF527', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252709),
(424071, 'PTHR27001:SF923', NULL, NULL, NULL, NULL, 'PROTEIN KINASE PROTEIN WITH ADENINE NUCLEOTIDE ALPHA HYDROLASE-LIKE DOMAIN', 252709),
(424072, 'PTHR27001:SF773', NULL, NULL, NULL, NULL, 'PROTEIN STRUBBELIG-RECEPTOR FAMILY 1-RELATED', 252709),
(424073, 'PTHR27001:SF893', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASE-LIKE DOMAIN KINASE', 252709),
(424074, 'PTHR27001:SF539', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-REGULATED RECEPTOR-LIKE KINASE 2', 252709),
(424075, 'PTHR27001:SF898', NULL, NULL, NULL, NULL, 'PROTEIN KINASE, PLANT-TYPE, PUTATIVE-RELATED', 252709),
(424076, 'PTHR27001:SF811', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE CDG1-LIKE', 252709),
(424077, 'PTHR27001:SF538', NULL, NULL, NULL, NULL, 'OS02G0227500 PROTEIN', 252709),
(424078, 'PTHR27001:SF906', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-KINASE RKF3, PUTATIVE-RELATED', 252709),
(424079, 'PTHR27001:SF907', NULL, NULL, NULL, NULL, 'PROLIN-RICH EXTENSIN-LIKE RECEPTOR PROTEIN KINASE FAMILY PROTEIN ISOFORM 1-RELATED', 252709),
(424080, 'PTHR27001:SF908', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252709),
(424081, 'PTHR27001:SF909', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-REGULATED RECEPTOR-LIKE KINASE 1', 252709),
(424082, 'PTHR27001:SF861', NULL, NULL, NULL, NULL, 'PROTEIN STRUBBELIG-RECEPTOR FAMILY 7', 252709),
(424083, 'PTHR27001:SF500', NULL, NULL, NULL, NULL, 'KINASE WITH ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE DOMAIN-CONTAINING PROTEIN', 252709),
(424084, 'PTHR27001:SF584', NULL, NULL, NULL, NULL, 'OS08G0285600 PROTEIN', 252709),
(424085, 'PTHR27001:SF585', NULL, NULL, NULL, NULL, 'OS02G0648100 PROTEIN', 252709),
(424086, 'PTHR27001:SF869', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASE-LIKE DOMAIN KINASE', 252709),
(424087, 'PTHR27001:SF748', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 252709),
(424088, 'PTHR27001:SF39', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 252709),
(424089, 'PTHR27001:SF866', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252709),
(424090, 'PTHR27001:SF900', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE RKF3-RELATED', 252709),
(424091, 'PTHR27001:SF868', NULL, NULL, NULL, NULL, 'STRUBBELIG-RECEPTOR FAMILY 6 PROTEIN', 252709),
(424092, 'PTHR27001:SF626', NULL, NULL, NULL, NULL, 'PROLINE-RICH RECEPTOR-LIKE PROTEIN KINASE PERK9', 252709),
(424093, 'PTHR27001:SF20', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 252709);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(424094, 'PTHR27001:SF917', NULL, NULL, NULL, NULL, 'PROTEIN KINASE PROTEIN WITH ADENINE NUCLEOTIDE ALPHA HYDROLASE-LIKE DOMAIN', 252709),
(424095, 'PTHR27001:SF918', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE FAMILY PROTEIN-RELATED', 252709),
(424096, 'PTHR27001:SF919', NULL, NULL, NULL, NULL, 'PROTEIN STRUBBELIG-RECEPTOR FAMILY 4', 252709),
(424097, 'PTHR27001:SF480', NULL, NULL, NULL, NULL, 'OS06G0488050 PROTEIN', 252709),
(424098, 'PTHR27001:SF510', NULL, NULL, NULL, NULL, 'PROTEIN STRUBBELIG-RECEPTOR FAMILY 6', 252709),
(424099, 'PTHR27001:SF598', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 252709),
(424100, 'PTHR27001:SF874', NULL, NULL, NULL, NULL, 'OS07G0618400 PROTEIN', 252709),
(424101, 'PTHR27001:SF237', NULL, NULL, NULL, NULL, 'OS03G0773300 PROTEIN', 252709),
(424102, 'PTHR27001', NULL, NULL, NULL, NULL, 'OS01G0253100 PROTEIN', 252709),
(424103, 'PTHR27001:SF594', NULL, NULL, NULL, NULL, 'OS04G0689400 PROTEIN', 252709),
(424104, 'PTHR27001:SF231', NULL, NULL, NULL, NULL, 'PROTEIN KINASE FAMILY PROTEIN-RELATED', 252709),
(424105, 'PTHR27001:SF913', NULL, NULL, NULL, NULL, 'OS02G0194600 PROTEIN', 252709),
(424106, 'PTHR27001:SF638', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252709),
(424107, 'PTHR27001:SF914', NULL, NULL, NULL, NULL, 'SERINE/THREONINE/DUAL SPECIFICITY PROTEIN KINASE, CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 252709),
(424108, 'PTHR27001:SF915', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252709),
(424109, 'PTHR27001:SF916', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE-RELATED', 252709),
(424110, 'PTHR27001:SF634', NULL, NULL, NULL, NULL, 'STRUBBELIG-RECEPTOR FAMILY PROTEIN', 252709),
(424111, 'PTHR27001:SF910', NULL, NULL, NULL, NULL, 'OS02G0186500 PROTEIN', 252709),
(424112, 'PTHR27001:SF118', NULL, NULL, NULL, NULL, 'OS01G0253100 PROTEIN', 252709),
(424113, 'PTHR27001:SF911', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252709),
(424114, 'PTHR27001:SF912', NULL, NULL, NULL, NULL, 'OS02G0176100 PROTEIN', 252709),
(424115, 'PTHR27001:SF840', NULL, NULL, NULL, NULL, 'PROLINE-RICH RECEPTOR-LIKE PROTEIN KINASE PERK10', 252709),
(424116, 'PTHR27001:SF687', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-KINASE NCRK PROTEIN', 252709),
(424117, 'PTHR27001:SF688', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252709),
(424118, 'PTHR27001:SF721', NULL, NULL, NULL, NULL, 'DUAL-SPECIFICITY KINASE DOMAIN PROTEIN', 252709),
(424119, 'PTHR27001:SF560', NULL, NULL, NULL, NULL, 'RECEPTOR SERINE-THREONINE PROTEIN KINASE', 252709),
(424120, 'PTHR27001:SF561', NULL, NULL, NULL, NULL, 'OS02G0821400 PROTEIN', 252709),
(424121, 'PTHR27001:SF682', NULL, NULL, NULL, NULL, 'OS03G0113000 PROTEIN', 252709),
(424122, 'PTHR27001:SF847', NULL, NULL, NULL, NULL, 'DUAL-SPECIFICITY KINASE DOMAIN PROTEIN', 252709),
(424123, 'PTHR27001:SF726', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252709),
(424124, 'PTHR27001:SF601', NULL, NULL, NULL, NULL, 'OS06G0288100 PROTEIN', 252709),
(424125, 'PTHR27001:SF722', NULL, NULL, NULL, NULL, 'TYROSINE KINASE FAMILY PROTEIN', 252709),
(424126, 'PTHR27001:SF689', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252709),
(424127, 'PTHR27001:SF85', NULL, NULL, NULL, NULL, 'OS01G0104000 PROTEIN', 252709),
(424128, 'PTHR27001:SF88', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 252709),
(424129, 'PTHR27001:SF581', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE-RELATED', 252709),
(424130, 'PTHR27001:SF850', NULL, NULL, NULL, NULL, 'OS01G0267800 PROTEIN', 252709),
(424131, 'PTHR27001:SF213', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252709),
(424132, 'PTHR27001:SF693', NULL, NULL, NULL, NULL, 'TYROSINE KINASE FAMILY PROTEIN', 252709),
(424133, 'PTHR27001:SF178', NULL, NULL, NULL, NULL, 'OS06G0654600 PROTEIN', 252709),
(424134, 'PTHR27001:SF858', NULL, NULL, NULL, NULL, 'PROTEIN STRUBBELIG-RECEPTOR FAMILY 5', 252709);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(424135, 'PTHR27001:SF619', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT RECEPTOR KINASE', 252709),
(424136, 'PTHR27001:SF8', NULL, NULL, NULL, NULL, 'PROTEIN STRUBBELIG-RECEPTOR FAMILY 2', 252709),
(424137, 'PTHR27001:SF856', NULL, NULL, NULL, NULL, 'OS04G0465900 PROTEIN', 252709),
(424138, 'PTHR27001:SF614', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 252709),
(424139, 'PTHR43195:SF4', NULL, NULL, NULL, NULL, 'TRANSKETOLASE-LIKE PROTEIN 2', 252710),
(424140, 'PTHR43195:SF3', NULL, NULL, NULL, NULL, 'TRANSKETOLASE', 252710),
(424141, 'PTHR43195:SF2', NULL, NULL, NULL, NULL, 'TRANSKETOLASE-LIKE PROTEIN 1', 252710),
(424142, 'PTHR43195:SF1', NULL, NULL, NULL, NULL, 'FI06132P-RELATED', 252710),
(424143, 'PTHR43195', NULL, NULL, NULL, NULL, 'TRANSKETOLASE', 252710),
(424144, 'PTHR43002:SF12', NULL, NULL, NULL, NULL, 'DUF3372 DOMAIN-CONTAINING PROTEIN', 252711),
(424145, 'PTHR43002:SF9', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE-RELATED', 252711),
(424146, 'PTHR43002:SF11', NULL, NULL, NULL, NULL, 'PULLULANASE 1, CHLOROPLASTIC', 252711),
(424147, 'PTHR43002:SF7', NULL, NULL, NULL, NULL, 'AAMY DOMAIN-CONTAINING PROTEIN', 252711),
(424148, 'PTHR43002:SF10', NULL, NULL, NULL, NULL, '1,4-ALPHA-GLUCAN BRANCHING ENZYME GLGB', 252711),
(424149, 'PTHR43002:SF6', NULL, NULL, NULL, NULL, 'ISOAMYLASE 2, CHLOROPLASTIC', 252711),
(424150, 'PTHR43002:SF3', NULL, NULL, NULL, NULL, 'ISOAMYLASE 3, CHLOROPLASTIC', 252711),
(424151, 'PTHR43002', NULL, NULL, NULL, NULL, 'GLYCOGEN DEBRANCHING ENZYME', 252711),
(424152, 'PTHR43002:SF1', NULL, NULL, NULL, NULL, 'ISOAMYLASE 1, CHLOROPLASTIC', 252711),
(424153, 'PTHR45911', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 252712),
(424154, 'PTHR45911:SF2', NULL, NULL, NULL, NULL, 'MULTIPLE C2 AND TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN 2', 252712),
(424155, 'PTHR45911:SF3', NULL, NULL, NULL, NULL, 'DYSFERLIN-RELATED', 252712),
(424156, 'PTHR45911:SF4', NULL, NULL, NULL, NULL, 'MULTIPLE C2 AND TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN', 252712),
(424157, 'PTHR45911:SF7', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 252712),
(424158, 'PTHR45911:SF8', NULL, NULL, NULL, NULL, 'MULTIPLE C2 DOMAINS, TRANSMEMBRANE 2B', 252712),
(424159, 'PTHR12213:SF0', NULL, NULL, NULL, NULL, 'CORRINOID ADENOSYLTRANSFERASE', 252713),
(424160, 'PTHR12213:SF2', NULL, NULL, NULL, NULL, 'CORRINOID ADENOSYLTRANSFERASE', 252713),
(424161, 'PTHR12213', NULL, NULL, NULL, NULL, 'CORRINOID ADENOSYLTRANSFERASE', 252713),
(424162, 'PTHR39232', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 50', 252714),
(424163, 'PTHR39232:SF1', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 50', 252714),
(424164, 'PTHR33508:SF2', NULL, NULL, NULL, NULL, 'UPF0056 INNER MEMBRANE PROTEIN MARC', 252715),
(424165, 'PTHR33508:SF10', NULL, NULL, NULL, NULL, 'UPF0056 INNER MEMBRANE PROTEIN YHGN', 252715),
(424166, 'PTHR33508:SF1', NULL, NULL, NULL, NULL, 'UPF0056 MEMBRANE PROTEIN YHCE', 252715),
(424167, 'PTHR33508', NULL, NULL, NULL, NULL, 'UPF0056 MEMBRANE PROTEIN YHCE', 252715),
(424168, 'PTHR39967', NULL, NULL, NULL, NULL, '', 252716),
(424169, 'PTHR39967:SF1', NULL, NULL, NULL, NULL, 'ISH14-TYPE TRANSPOSASE HSIRS44', 252716),
(424170, 'PTHR21504:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG08468', 252717),
(424171, 'PTHR21504:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG08470', 252717),
(424172, 'PTHR21504:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG08471', 252717),
(424173, 'PTHR21504:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG08473', 252717),
(424174, 'PTHR21504', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252717),
(424175, 'PTHR21504:SF1', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN-RELATED', 252717),
(424176, 'PTHR34348', NULL, NULL, NULL, NULL, 'SURFEIT LOCUS PROTEIN 2', 252718),
(424177, 'PTHR34348:SF1', NULL, NULL, NULL, NULL, 'SURFEIT LOCUS PROTEIN 2', 252718),
(424178, 'PTHR37487:SF3', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 252719),
(424179, 'PTHR37487', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 252719);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(424180, 'PTHR37487:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252719),
(424181, 'PTHR44500:SF1', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 12', 252720),
(424182, 'PTHR44500', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 12', 252720),
(424183, 'PTHR13844:SF49', NULL, NULL, NULL, NULL, 'SWI/SNF COMPLEX COMPONENT SNF12 HOMOLOG', 252721),
(424184, 'PTHR13844:SF69', NULL, NULL, NULL, NULL, 'OS03G0761000 PROTEIN', 252721),
(424185, 'PTHR13844:SF68', NULL, NULL, NULL, NULL, 'SWIB DOMAIN-CONTAINING PROTEIN', 252721),
(424186, 'PTHR13844:SF8', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', 252721),
(424187, 'PTHR13844:SF45', NULL, NULL, NULL, NULL, 'OS09G0133000 PROTEIN', 252721),
(424188, 'PTHR13844:SF89', NULL, NULL, NULL, NULL, '', 252721),
(424189, 'PTHR13844:SF7', NULL, NULL, NULL, NULL, 'BRAHMA-ASSOCIATED PROTEIN OF 60 KDA', 252721),
(424190, 'PTHR13844:SF67', NULL, NULL, NULL, NULL, 'OS02G0130000 PROTEIN', 252721),
(424191, 'PTHR13844:SF66', NULL, NULL, NULL, NULL, 'CHROMATIN REMODELING COMPLEX SUBUNIT', 252721),
(424192, 'PTHR13844:SF88', NULL, NULL, NULL, NULL, 'BNAC03G64890D PROTEIN', 252721),
(424193, 'PTHR13844:SF87', NULL, NULL, NULL, NULL, 'PROTEIN TRI1-LIKE', 252721),
(424194, 'PTHR13844:SF5', NULL, NULL, NULL, NULL, 'SWI/SNF-RELATED MATRIX-ASSOCIATED ACTIN-DEPENDENT REGULATOR OF CHROMATIN SUBFAMILY D MEMBER 3', 252721),
(424195, 'PTHR13844:SF86', NULL, NULL, NULL, NULL, 'SWI/SNF COMPLEX COMPONENT SNF12 HOMOLOG', 252721),
(424196, 'PTHR13844:SF85', NULL, NULL, NULL, NULL, 'PROTEIN MDM4', 252721),
(424197, 'PTHR13844:SF84', NULL, NULL, NULL, NULL, 'UPSTREAM ACTIVATION FACTOR SUBUNIT SPP27-LIKE ISOFORM X1', 252721),
(424198, 'PTHR13844:SF61', NULL, NULL, NULL, NULL, 'UPSTREAM ACTIVATION FACTOR SUBUNIT SPP27-LIKE ISOFORM X1', 252721),
(424199, 'PTHR13844:SF93', NULL, NULL, NULL, NULL, 'SWIB/MDM2 DOMAIN, DEK-RELATED', 252721),
(424200, 'PTHR13844:SF92', NULL, NULL, NULL, NULL, 'SWIB/MDM2 DOMAIN SUPERFAMILY PROTEIN-RELATED', 252721),
(424201, 'PTHR13844:SF70', NULL, NULL, NULL, NULL, 'SWIB DOMAIN-CONTAINING PROTEIN', 252721),
(424202, 'PTHR13844:SF91', NULL, NULL, NULL, NULL, 'SWIB DOMAIN-CONTAINING PROTEIN', 252721),
(424203, 'PTHR13844:SF90', NULL, NULL, NULL, NULL, 'UPSTREAM ACTIVATION FACTOR SUBUNIT UAF30-LIKE', 252721),
(424204, 'PTHR13844:SF2', NULL, NULL, NULL, NULL, 'SWI/SNF-RELATED MATRIX-ASSOCIATED ACTIN-DEPENDENT REGULATOR OF CHROMATIN SUBFAMILY D MEMBER 2', 252721),
(424205, 'PTHR13844:SF1', NULL, NULL, NULL, NULL, 'SWI/SNF-RELATED MATRIX-ASSOCIATED ACTIN-DEPENDENT REGULATOR OF CHROMATIN SUBFAMILY D MEMBER 1', 252721),
(424206, 'PTHR13844:SF19', NULL, NULL, NULL, NULL, 'OS04G0665500 PROTEIN', 252721),
(424207, 'PTHR13844:SF16', NULL, NULL, NULL, NULL, 'SWI/SNF CHROMATIN-REMODELING ACCESSORY SUBUNIT 2', 252721),
(424208, 'PTHR13844:SF59', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', 252721),
(424209, 'PTHR13844:SF77', NULL, NULL, NULL, NULL, 'ACTIN-DEPENDENT REGULATOR OF CHROMATIN-RELATED', 252721),
(424210, 'PTHR13844:SF53', NULL, NULL, NULL, NULL, 'LD45195P', 252721),
(424211, 'PTHR13844:SF95', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REGULATOR SWI/SNF-BAF60B FAMILY-RELATED', 252721),
(424212, 'PTHR13844:SF50', NULL, NULL, NULL, NULL, 'CHROMATIN REMODELING COMPLEX SUBUNIT', 252721),
(424213, 'PTHR13844:SF94', NULL, NULL, NULL, NULL, 'F1L3.22', 252721),
(424214, 'PTHR13844:SF82', NULL, NULL, NULL, NULL, 'SWIB COMPLEX BAF60B DOMAIN-CONTAINING PROTEIN', 252721),
(424215, 'PTHR13844:SF81', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REGULATOR SWI/SNF-BAF60B FAMILY-RELATED', 252721),
(424216, 'PTHR13844:SF80', NULL, NULL, NULL, NULL, 'SWIB DOMAIN-CONTAINING PROTEIN', 252721),
(424217, 'PTHR13844', NULL, NULL, NULL, NULL, 'SWI/SNF-RELATED MATRIX-ASSOCIATED ACTIN-DEPENDENT REGULATOR OF CHROMATIN SUBFAMILY D', 252721),
(424218, 'PTHR19269:SF38', NULL, NULL, NULL, NULL, 'TROPOMYOSIN ALPHA-3 CHAIN', 252722),
(424219, 'PTHR19269:SF68', NULL, NULL, NULL, NULL, '', 252722),
(424220, 'PTHR19269:SF46', NULL, NULL, NULL, NULL, 'TROPOMYOSIN BETA CHAIN', 252722);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(424221, 'PTHR19269:SF70', NULL, NULL, NULL, NULL, 'TROPOMYOSIN ALPHA-4 CHAIN', 252722),
(424222, 'PTHR19269:SF45', NULL, NULL, NULL, NULL, 'TROPOMYOSIN-1, ISOFORMS 33/34', 252722),
(424223, 'PTHR19269:SF76', NULL, NULL, NULL, NULL, '', 252722),
(424224, 'PTHR19269:SF75', NULL, NULL, NULL, NULL, 'TROPOMYOSIN 4', 252722),
(424225, 'PTHR19269:SF53', NULL, NULL, NULL, NULL, 'TROPOMYOSIN-2', 252722),
(424226, 'PTHR19269:SF74', NULL, NULL, NULL, NULL, 'TROPOMYOSIN 1', 252722),
(424227, 'PTHR19269:SF41', NULL, NULL, NULL, NULL, 'TROPOMYOSIN ALPHA-1 CHAIN', 252722),
(424228, 'PTHR19269:SF40', NULL, NULL, NULL, NULL, 'TROPOMYOSIN 4A-RELATED', 252722),
(424229, 'PTHR19269:SF73', NULL, NULL, NULL, NULL, 'TROPOMYOSIN 3, RELATED SEQUENCE 7', 252722),
(424230, 'PTHR19269', NULL, NULL, NULL, NULL, 'TROPOMYOSIN', 252722),
(424231, 'PTHR28641', NULL, NULL, NULL, NULL, '', 252723),
(424232, 'PTHR28641:SF1', NULL, NULL, NULL, NULL, 'MALONYL-COA DECARBOXYLASE, MITOCHONDRIAL', 252723),
(424233, 'PTHR15398:SF7', NULL, NULL, NULL, NULL, 'BRD8 DOMAIN-CONTAINING', 252724),
(424234, 'PTHR15398:SF11', NULL, NULL, NULL, NULL, 'BROMODOMAIN PROTEIN', 252724),
(424235, 'PTHR15398:SF4', NULL, NULL, NULL, NULL, 'BROMODOMAIN-CONTAINING PROTEIN 8', 252724),
(424236, 'PTHR15398:SF10', NULL, NULL, NULL, NULL, 'BROMO DOMAIN-CONTAINING PROTEIN', 252724),
(424237, 'PTHR15398:SF12', NULL, NULL, NULL, NULL, 'BROMODOMAIN-CONTAINING PROTEIN 8', 252724),
(424238, 'PTHR15398', NULL, NULL, NULL, NULL, 'BROMODOMAIN-CONTAINING PROTEIN 8', 252724),
(424239, 'PTHR31958:SF2', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 127', 252725),
(424240, 'PTHR31958', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 127', 252725),
(424241, 'PTHR18952', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 252726),
(424242, 'PTHR18952:SF114', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE 3, ISOFORM A', 252726),
(424243, 'PTHR18952:SF236', NULL, NULL, NULL, NULL, 'ALPHA CARBONIC ANHYDRASE 1, CHLOROPLASTIC', 252726),
(424244, 'PTHR18952:SF237', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 252726),
(424245, 'PTHR18952:SF198', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 252726),
(424246, 'PTHR18952:SF110', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE 6', 252726),
(424247, 'PTHR18952:SF232', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 252726),
(424248, 'PTHR18952:SF233', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE 14', 252726),
(424249, 'PTHR18952:SF234', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 252726),
(424250, 'PTHR18952:SF228', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE-RELATED PROTEIN A, ISOFORM B', 252726),
(424251, 'PTHR18952:SF229', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 252726),
(424252, 'PTHR18952:SF268', NULL, NULL, NULL, NULL, 'AGAP013402-PA', 252726),
(424253, 'PTHR18952:SF104', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE-RELATED PROTEIN', 252726),
(424254, 'PTHR18952:SF269', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 252726),
(424255, 'PTHR18952:SF81', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE 13', 252726),
(424256, 'PTHR18952:SF227', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE 13-RELATED', 252726),
(424257, 'PTHR18952:SF264', NULL, NULL, NULL, NULL, 'ALPHA-CARBONIC ANHYDRASE DOMAIN-CONTAINING PROTEIN', 252726),
(424258, 'PTHR18952:SF220', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 252726),
(424259, 'PTHR18952:SF265', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 252726),
(424260, 'PTHR18952:SF222', NULL, NULL, NULL, NULL, 'ALPHA CARBONIC ANHYDRASE 7-LIKE', 252726),
(424261, 'PTHR18952:SF266', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE 1', 252726),
(424262, 'PTHR18952:SF84', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE 14', 252726),
(424263, 'PTHR18952:SF223', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 252726),
(424264, 'PTHR18952:SF267', NULL, NULL, NULL, NULL, 'ALPHA CARBONIC ANHYDRASE 3', 252726),
(424265, 'PTHR18952:SF260', NULL, NULL, NULL, NULL, 'ALPHA CARBONIC ANHYDRASE 7', 252726),
(424266, 'PTHR18952:SF261', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 252726),
(424267, 'PTHR18952:SF262', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 252726);
INSERT INTO "PUBLIC"."MODEL" VALUES
(424268, 'PTHR18952:SF89', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE 5A, MITOCHONDRIAL', 252726),
(424269, 'PTHR18952:SF141', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 252726),
(424270, 'PTHR18952:SF263', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 252726),
(424271, 'PTHR18952:SF270', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 252726),
(424272, 'PTHR18952:SF217', NULL, NULL, NULL, NULL, 'ALPHA CARBONIC ANHYDRASE 5-RELATED', 252726),
(424273, 'PTHR18952:SF257', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 252726),
(424274, 'PTHR18952:SF258', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE-LIKE PROTEIN 1-RELATED', 252726),
(424275, 'PTHR18952:SF137', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 252726),
(424276, 'PTHR18952:SF93', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE-RELATED PROTEIN 11', 252726),
(424277, 'PTHR18952:SF138', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE-RELATED PROTEIN 10', 252726),
(424278, 'PTHR18952:SF259', NULL, NULL, NULL, NULL, 'CARBONATE DEHYDRATASE IV', 252726),
(424279, 'PTHR18952:SF91', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE-RELATED PROTEIN 10', 252726),
(424280, 'PTHR18952:SF253', NULL, NULL, NULL, NULL, 'OS08G0470200 PROTEIN', 252726),
(424281, 'PTHR18952:SF176', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 252726),
(424282, 'PTHR18952:SF254', NULL, NULL, NULL, NULL, 'ALPHA CARBONIC ANHYDRASE 2', 252726),
(424283, 'PTHR18952:SF134', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE 15', 252726),
(424284, 'PTHR18952:SF95', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE 4', 252726),
(424285, 'PTHR18952:SF256', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 252726),
(424286, 'PTHR18952:SF250', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE 5-RELATED', 252726),
(424287, 'PTHR18952:SF251', NULL, NULL, NULL, NULL, 'ALPHA-CARBONIC ANHYDRASE DOMAIN-CONTAINING PROTEIN', 252726),
(424288, 'PTHR18952:SF18', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE 9', 252726),
(424289, 'PTHR18952:SF19', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE 12', 252726),
(424290, 'PTHR18952:SF208', NULL, NULL, NULL, NULL, 'ALPHA CARBONIC ANHYDRASE 7', 252726),
(424291, 'PTHR18952:SF202', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 252726),
(424292, 'PTHR18952:SF127', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE 3', 252726),
(424293, 'PTHR18952:SF249', NULL, NULL, NULL, NULL, 'ALPHA-CARBONIC ANHYDRASE DOMAIN-CONTAINING PROTEIN', 252726),
(424294, 'PTHR18952:SF121', NULL, NULL, NULL, NULL, 'ALPHA CARBONIC ANHYDRASE 7', 252726),
(424295, 'PTHR18952:SF243', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 252726),
(424296, 'PTHR18952:SF244', NULL, NULL, NULL, NULL, 'ALPHA-CARBONIC ANHYDRASE DOMAIN-CONTAINING PROTEIN', 252726),
(424297, 'PTHR18952:SF200', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 252726),
(424298, 'PTHR18952:SF124', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE 7', 252726),
(424299, 'PTHR18952:SF201', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 252726),
(424300, 'PTHR18952:SF25', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE 5B, MITOCHONDRIAL-RELATED', 252726),
(424301, 'PTHR18952:SF241', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', 252726),
(424302, 'PTHR18952:SF120', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE 2', 252726),
(424303, 'PTHR35516', NULL, NULL, NULL, NULL, 'CYTOCHROME B6-F COMPLEX SUBUNIT 5', 252727),
(424304, 'PTHR35516:SF10', NULL, NULL, NULL, NULL, '', 252727),
(424305, 'PTHR35516:SF11', NULL, NULL, NULL, NULL, 'CYTOCHROME B6-F COMPLEX SUBUNIT 5', 252727),
(424306, 'PTHR34375:SF2', NULL, NULL, NULL, NULL, 'GATA ZINC FINGER PROTEIN', 252728),
(424307, 'PTHR34375:SF5', NULL, NULL, NULL, NULL, '', 252728),
(424308, 'PTHR34375', NULL, NULL, NULL, NULL, 'GATA ZINC FINGER PROTEIN-RELATED', 252728),
(424309, 'PTHR34375:SF3', NULL, NULL, NULL, NULL, '', 252728),
(424310, 'PTHR34375:SF4', NULL, NULL, NULL, NULL, 'ALCOHOL ACETYLTRANSFERASE-RELATED', 252728),
(424311, 'PTHR16502:SF1', NULL, NULL, NULL, NULL, '', 252729),
(424312, 'PTHR16502:SF2', NULL, NULL, NULL, NULL, 'KERATINOCYTE-ASSOCIATED TRANSMEMBRANE PROTEIN 2', 252729),
(424313, 'PTHR16502', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252729);
INSERT INTO "PUBLIC"."MODEL" VALUES
(424314, 'PTHR16502:SF0', NULL, NULL, NULL, NULL, 'KERATINOCYTE-ASSOCIATED TRANSMEMBRANE PROTEIN 2', 252729),
(424315, 'PTHR12790:SF0', NULL, NULL, NULL, NULL, 'RNA POLYMERASE I-SPECIFIC TRANSCRIPTION INITIATION FACTOR RRN3-RELATED', 252730),
(424316, 'PTHR12790', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IA  RRN3', 252730),
(424317, 'PTHR12790:SF3', NULL, NULL, NULL, NULL, '', 252730),
(424318, 'PTHR12790:SF2', NULL, NULL, NULL, NULL, 'BNAA05G09100D PROTEIN', 252730),
(424319, 'PTHR43860:SF2', NULL, NULL, NULL, NULL, 'BETAINE ALDEHYDE DEHYDROGENASE-RELATED', 252731),
(424320, 'PTHR43860:SF7', NULL, NULL, NULL, NULL, 'BETAINE ALDEHYDE DEHYDROGENASE 1', 252731),
(424321, 'PTHR43860:SF9', NULL, NULL, NULL, NULL, 'NAD-DEPENDENT ALDEHYDE DEHYDROGENASE FAMILY PROTEIN', 252731),
(424322, 'PTHR43860:SF8', NULL, NULL, NULL, NULL, 'BETAINE ALDEHYDE DEHYDROGENASE, CHLOROPLASTIC-LIKE', 252731),
(424323, 'PTHR43860:SF15', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE', 252731),
(424324, 'PTHR43860', NULL, NULL, NULL, NULL, 'BETAINE ALDEHYDE DEHYDROGENASE', 252731),
(424325, 'PTHR43860:SF14', NULL, NULL, NULL, NULL, 'BETAINE ALDEHYDE DEHYDROGENASE 1, CHLOROPLASTIC', 252731),
(424326, 'PTHR10668', NULL, NULL, NULL, NULL, 'PHYTOENE DEHYDROGENASE', 252732),
(424327, 'PTHR10668:SF103', NULL, NULL, NULL, NULL, 'PYRIDINE NUCLEOTIDE-DISULFIDE OXIDOREDUCTASE DOMAIN-CONTAINING PROTEIN 2', 252732),
(424328, 'PTHR10668:SF104', NULL, NULL, NULL, NULL, 'FAD/NAD(P)-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 252732),
(424329, 'PTHR10668:SF105', NULL, NULL, NULL, NULL, 'DEHYDROGENASE-RELATED', 252732),
(424330, 'PTHR33064:SF29', NULL, NULL, NULL, NULL, 'LRRGT00076', 252733),
(424331, 'PTHR33064:SF28', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN-RELATED', 252733),
(424332, 'PTHR33064:SF33', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H', 252733),
(424333, 'PTHR33064:SF35', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H', 252733),
(424334, 'PTHR33064', NULL, NULL, NULL, NULL, 'POL PROTEIN', 252733),
(424335, 'PTHR33064:SF34', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H', 252733),
(424336, 'PTHR33064:SF31', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 252733),
(424337, 'PTHR16110', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 19', 252734),
(424338, 'PTHR16110:SF1', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 19', 252734),
(424339, 'PTHR12718', NULL, NULL, NULL, NULL, 'CELL CYCLE CONTROL PROTEIN CWF15', 252735),
(424340, 'PTHR12718:SF7', NULL, NULL, NULL, NULL, 'BNACNNG51390D PROTEIN', 252735),
(424341, 'PTHR12718:SF6', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR CWC15', 252735),
(424342, 'PTHR12718:SF8', NULL, NULL, NULL, NULL, '', 252735),
(424343, 'PTHR12718:SF2', NULL, NULL, NULL, NULL, 'SPLICEOSOME-ASSOCIATED PROTEIN CWC15 HOMOLOG', 252735),
(424344, 'PTHR13288:SF8', NULL, NULL, NULL, NULL, 'SPLICING FACTOR 45', 252736),
(424345, 'PTHR13288', NULL, NULL, NULL, NULL, 'SPLICING FACTOR 45 SPF45', 252736),
(424346, 'PTHR22145:SF2', NULL, NULL, NULL, NULL, 'SI:CH211-266K22.6', 252737),
(424347, 'PTHR22145:SF4', NULL, NULL, NULL, NULL, 'PROTEIN FAM217A', 252737),
(424348, 'PTHR22145:SF3', NULL, NULL, NULL, NULL, 'PROTEIN FAM217B', 252737),
(424349, 'PTHR22145', NULL, NULL, NULL, NULL, 'SI:CH211-266K22.6', 252737),
(424350, 'PTHR47201:SF3', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 252738),
(424351, 'PTHR47201', NULL, NULL, NULL, NULL, 'BNAC09G30780D PROTEIN', 252738),
(424352, 'PTHR47201:SF1', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 252738),
(424353, 'PTHR22715:SF1', NULL, NULL, NULL, NULL, 'DNA BINDING PROTEIN', 252739),
(424354, 'PTHR22715', NULL, NULL, NULL, NULL, 'TRANSFORMING GROWTH FACTOR BETA REGULATED GENE 1', 252739),
(424355, 'PTHR22715:SF0', NULL, NULL, NULL, NULL, 'TRANSFORMING GROWTH FACTOR BETA REGULATOR 1', 252739),
(424356, 'PTHR33962:SF1', NULL, NULL, NULL, NULL, 'RECQ-MEDIATED GENOME INSTABILITY PROTEIN 2', 252740),
(424357, 'PTHR33962', NULL, NULL, NULL, NULL, 'RECQ-MEDIATED GENOME INSTABILITY PROTEIN 2 RMI2', 252740);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(424358, 'PTHR35274:SF9', NULL, NULL, NULL, NULL, 'BNAA09G27270D PROTEIN', 252741),
(424359, 'PTHR35274', NULL, NULL, NULL, NULL, 'E6-LIKE PROTEIN', 252741),
(424360, 'PTHR35274:SF8', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 252741),
(424361, 'PTHR35274:SF6', NULL, NULL, NULL, NULL, 'F3M18.16', 252741),
(424362, 'PTHR35274:SF5', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE CLKA-RELATED', 252741),
(424363, 'PTHR35274:SF2', NULL, NULL, NULL, NULL, 'E6-LIKE PROTEIN', 252741),
(424364, 'PTHR31757', NULL, NULL, NULL, NULL, 'SLL0781 PROTEIN', 252742),
(424365, 'PTHR31757:SF0', NULL, NULL, NULL, NULL, 'SLL0781 PROTEIN', 252742),
(424366, 'PTHR31965', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 42', 252743),
(424367, 'PTHR31965:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 42', 252743),
(424368, 'PTHR34371:SF16', NULL, NULL, NULL, NULL, 'BNAC04G52140D PROTEIN', 252744),
(424369, 'PTHR34371:SF19', NULL, NULL, NULL, NULL, 'BNAA03G48840D PROTEIN', 252744),
(424370, 'PTHR34371:SF18', NULL, NULL, NULL, NULL, 'BNAA02G10550D PROTEIN', 252744),
(424371, 'PTHR34371:SF13', NULL, NULL, NULL, NULL, '', 252744),
(424372, 'PTHR34371:SF24', NULL, NULL, NULL, NULL, '', 252744),
(424373, 'PTHR34371', NULL, NULL, NULL, NULL, 'OS01G0551000 PROTEIN', 252744),
(424374, 'PTHR34371:SF23', NULL, NULL, NULL, NULL, '', 252744),
(424375, 'PTHR34371:SF14', NULL, NULL, NULL, NULL, 'BNAC09G29070D PROTEIN', 252744),
(424376, 'PTHR34371:SF25', NULL, NULL, NULL, NULL, '', 252744),
(424377, 'PTHR34371:SF8', NULL, NULL, NULL, NULL, 'BNAC04G50870D PROTEIN', 252744),
(424378, 'PTHR34371:SF20', NULL, NULL, NULL, NULL, 'DUF688 FAMILY PROTEIN', 252744),
(424379, 'PTHR34371:SF2', NULL, NULL, NULL, NULL, 'BNAA09G52110D PROTEIN', 252744),
(424380, 'PTHR34371:SF22', NULL, NULL, NULL, NULL, '', 252744),
(424381, 'PTHR34371:SF11', NULL, NULL, NULL, NULL, 'RESPONSE FACTOR, PUTATIVE (DUF688)-RELATED', 252744),
(424382, 'PTHR34371:SF21', NULL, NULL, NULL, NULL, '', 252744),
(424383, 'PTHR34371:SF6', NULL, NULL, NULL, NULL, 'OS01G0551000 PROTEIN', 252744),
(424384, 'PTHR35020:SF2', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINE-INDUCED PROTEIN 1', 252745),
(424385, 'PTHR35020', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINE-INDUCED PROTEIN 1', 252745),
(424386, 'PTHR35020:SF4', NULL, NULL, NULL, NULL, '', 252745),
(424387, 'PTHR46514', NULL, NULL, NULL, NULL, 'AMPHIPHYSIN', 252746),
(424388, 'PTHR46514:SF3', NULL, NULL, NULL, NULL, 'ENDOPHILIN-A', 252746),
(424389, 'PTHR46514:SF4', NULL, NULL, NULL, NULL, 'MYC BOX-DEPENDENT-INTERACTING PROTEIN 1', 252746),
(424390, 'PTHR46514:SF1', NULL, NULL, NULL, NULL, 'BRIDGING INTEGRATOR 2', 252746),
(424391, 'PTHR46514:SF2', NULL, NULL, NULL, NULL, 'AMPHIPHYSIN', 252746),
(424392, 'PTHR46514:SF7', NULL, NULL, NULL, NULL, 'BRIDGING INTEGRATOR 1B', 252746),
(424393, 'PTHR46514:SF8', NULL, NULL, NULL, NULL, 'BAR DOMAIN-CONTAINING PROTEIN', 252746),
(424394, 'PTHR46514:SF5', NULL, NULL, NULL, NULL, '', 252746),
(424395, 'PTHR35552', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 8', 252747),
(424396, 'PTHR35552:SF1', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 8', 252747),
(424397, 'PTHR35552:SF2', NULL, NULL, NULL, NULL, 'BNAA06G33860D PROTEIN', 252747),
(424398, 'PTHR18921', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN - RELATED', 252748),
(424399, 'PTHR18921:SF4', NULL, NULL, NULL, NULL, 'BNAA07G38200D PROTEIN', 252748),
(424400, 'PTHR18921:SF3', NULL, NULL, NULL, NULL, 'VESICLE TETHERING-LIKE PROTEIN, PUTATIVE-RELATED', 252748),
(424401, 'PTHR18921:SF2', NULL, NULL, NULL, NULL, 'THYROID RECEPTOR-INTERACTING PROTEIN 11', 252748),
(424402, 'PTHR12907:SF27', NULL, NULL, NULL, NULL, 'HIF PROLYL HYDROXYLASE, ISOFORM C', 252749),
(424403, 'PTHR12907:SF26', NULL, NULL, NULL, NULL, 'PROLYL HYDROXYLASE EGLN3', 252749),
(424404, 'PTHR12907', NULL, NULL, NULL, NULL, 'EGL NINE HOMOLOG-RELATED', 252749),
(424405, 'PTHR12907:SF6', NULL, NULL, NULL, NULL, 'PROLYL HYDROXYLASE EGLN2', 252749),
(424406, 'PTHR12907:SF4', NULL, NULL, NULL, NULL, 'EGL NINE HOMOLOG 1', 252749);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(424407, 'PTHR34805:SF1', NULL, NULL, NULL, NULL, 'PROTEIN MODIFIER OF SNC1 1', 252750),
(424408, 'PTHR34805:SF2', NULL, NULL, NULL, NULL, '', 252750),
(424409, 'PTHR34805:SF3', NULL, NULL, NULL, NULL, 'BNAA01G14040D PROTEIN', 252750),
(424410, 'PTHR34805', NULL, NULL, NULL, NULL, 'PROTEIN MODIFIER OF SNC1 1', 252750),
(424411, 'PTHR36682:SF1', NULL, NULL, NULL, NULL, 'RAB15 EFFECTOR PROTEIN', 252751),
(424412, 'PTHR36682', NULL, NULL, NULL, NULL, 'RAB15 EFFECTOR PROTEIN', 252751),
(424413, 'PTHR46330:SF10', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 10D', 252752),
(424414, 'PTHR46330:SF6', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 10B', 252752),
(424415, 'PTHR46330:SF13', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 10C', 252752),
(424416, 'PTHR46330:SF12', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 10A', 252752),
(424417, 'PTHR46330:SF15', NULL, NULL, NULL, NULL, 'TNF RECEPTOR SUPERFAMILY MEMBER 10B', 252752),
(424418, 'PTHR46330', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 10B', 252752),
(424419, 'PTHR46330:SF14', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 1A-LIKE', 252752),
(424420, 'PTHR46330:SF1', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 10B', 252752),
(424421, 'PTHR31317:SF21', NULL, NULL, NULL, NULL, '', 252753),
(424422, 'PTHR31317:SF20', NULL, NULL, NULL, NULL, 'BNAC01G31200D PROTEIN', 252753),
(424423, 'PTHR31317', NULL, NULL, NULL, NULL, 'OS08G0163500 PROTEIN', 252753),
(424424, 'PTHR31317:SF19', NULL, NULL, NULL, NULL, 'BNAA06G37990D PROTEIN', 252753),
(424425, 'PTHR31317:SF6', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252753),
(424426, 'PTHR31317:SF17', NULL, NULL, NULL, NULL, 'F2J10.8 PROTEIN', 252753),
(424427, 'PTHR31317:SF4', NULL, NULL, NULL, NULL, 'OS08G0163500 PROTEIN', 252753),
(424428, 'PTHR31317:SF16', NULL, NULL, NULL, NULL, 'BNAC05G33040D PROTEIN', 252753),
(424429, 'PTHR31317:SF15', NULL, NULL, NULL, NULL, 'STRESS-INDUCED PROTEIN', 252753),
(424430, 'PTHR31317:SF14', NULL, NULL, NULL, NULL, 'DUF1005 FAMILY PROTEIN (DUF1005)', 252753),
(424431, 'PTHR31317:SF3', NULL, NULL, NULL, NULL, 'OS07G0133500 PROTEIN', 252753),
(424432, 'PTHR31317:SF24', NULL, NULL, NULL, NULL, '', 252753),
(424433, 'PTHR31317:SF23', NULL, NULL, NULL, NULL, 'DUF1005 FAMILY PROTEIN', 252753),
(424434, 'PTHR35180', NULL, NULL, NULL, NULL, 'PROTEIN CBG06219', 252754),
(424435, 'PTHR35180:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG06219', 252754),
(424436, 'PTHR35180:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG21798', 252754),
(424437, 'PTHR31201:SF1', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHOCHOLINE ACYLTRANSFERASE 1', 252755),
(424438, 'PTHR31201:SF8', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHOCHOLINE ACYLTRANSFERASE 1', 252755),
(424439, 'PTHR31201:SF9', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHOCHOLINE ACYLTRANSFERASE 1', 252755),
(424440, 'PTHR31201:SF6', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHOCHOLINE ACYLTRANSFERASE 1', 252755),
(424441, 'PTHR31201', NULL, NULL, NULL, NULL, 'OS01G0585100 PROTEIN', 252755),
(424442, 'PTHR31928:SF18', NULL, NULL, NULL, NULL, '', 252756),
(424443, 'PTHR31928:SF29', NULL, NULL, NULL, NULL, 'BNAANNG29710D PROTEIN', 252756),
(424444, 'PTHR31928:SF28', NULL, NULL, NULL, NULL, 'BNAA08G20310D PROTEIN', 252756),
(424445, 'PTHR31928:SF17', NULL, NULL, NULL, NULL, 'OS11G0265300 PROTEIN', 252756),
(424446, 'PTHR31928:SF19', NULL, NULL, NULL, NULL, '', 252756),
(424447, 'PTHR31928', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252756),
(424448, 'PTHR31928:SF6', NULL, NULL, NULL, NULL, 'DUF936 FAMILY PROTEIN', 252756),
(424449, 'PTHR31928:SF7', NULL, NULL, NULL, NULL, 'FACTOR 1-DELTA, PUTATIVE (DUF936)-RELATED', 252756),
(424450, 'PTHR31928:SF4', NULL, NULL, NULL, NULL, 'DUF936 FAMILY PROTEIN', 252756),
(424451, 'PTHR31928:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252756),
(424452, 'PTHR31928:SF3', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252756);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(424453, 'PTHR31928:SF23', NULL, NULL, NULL, NULL, '', 252756),
(424454, 'PTHR31928:SF12', NULL, NULL, NULL, NULL, 'BNAC03G41030D PROTEIN', 252756),
(424455, 'PTHR31928:SF14', NULL, NULL, NULL, NULL, 'DUF936 FAMILY PROTEIN', 252756),
(424456, 'PTHR31928:SF25', NULL, NULL, NULL, NULL, 'OS08G0541500 PROTEIN', 252756),
(424457, 'PTHR31928:SF13', NULL, NULL, NULL, NULL, 'OS07G0588300 PROTEIN', 252756),
(424458, 'PTHR31928:SF27', NULL, NULL, NULL, NULL, '', 252756),
(424459, 'PTHR10253:SF5', NULL, NULL, NULL, NULL, 'POLYCOMB PROTEIN EED', 252757),
(424460, 'PTHR10253:SF7', NULL, NULL, NULL, NULL, 'POLYCOMB GROUP PROTEIN FIE1', 252757),
(424461, 'PTHR10253:SF10', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 252757),
(424462, 'PTHR10253:SF9', NULL, NULL, NULL, NULL, 'BNAA05G20190D PROTEIN', 252757),
(424463, 'PTHR10253:SF11', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 252757),
(424464, 'PTHR10253', NULL, NULL, NULL, NULL, 'POLYCOMB PROTEIN', 252757),
(424465, 'PTHR13141:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 242', 252758),
(424466, 'PTHR13141', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 242', 252758),
(424467, 'PTHR36709', NULL, NULL, NULL, NULL, 'OS02G0604100 PROTEIN', 252759),
(424468, 'PTHR36709:SF1', NULL, NULL, NULL, NULL, 'OS02G0604100 PROTEIN', 252759),
(424469, 'PTHR36794', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 252760),
(424470, 'PTHR36794:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 252760),
(424471, 'PTHR36794:SF3', NULL, NULL, NULL, NULL, '', 252760),
(424472, 'PTHR36794:SF2', NULL, NULL, NULL, NULL, 'BNAANNG05910D PROTEIN', 252760),
(424473, 'PTHR35305', NULL, NULL, NULL, NULL, 'FAD-BINDING PROTEIN', 252761),
(424474, 'PTHR35305:SF2', NULL, NULL, NULL, NULL, 'FAD-BINDING PROTEIN', 252761),
(424475, 'PTHR36175', NULL, NULL, NULL, NULL, 'CYANOPHYCINASE', 252762),
(424476, 'PTHR36175:SF1', NULL, NULL, NULL, NULL, 'CYANOPHYCINASE', 252762),
(424477, 'PTHR46608:SF3', NULL, NULL, NULL, NULL, 'HEPATITIS A VIRUS CELLULAR RECEPTOR 1-RELATED', 252763),
(424478, 'PTHR46608:SF1', NULL, NULL, NULL, NULL, 'T-CELL IMMUNOGLOBULIN AND MUCIN DOMAIN-CONTAINING PROTEIN 4', 252763),
(424479, 'PTHR46608:SF2', NULL, NULL, NULL, NULL, 'T CELL IMMUNOGLOBULIN AND MUCIN DOMAIN-CONTAINING 4', 252763),
(424480, 'PTHR46608', NULL, NULL, NULL, NULL, 'T-CELL IMMUNOGLOBULIN AND MUCIN DOMAIN-CONTAINING PROTEIN 4', 252763),
(424481, 'PTHR12547:SF170', NULL, NULL, NULL, NULL, 'FINGER PROTEIN, PUTATIVE-RELATED', 252764),
(424482, 'PTHR12547:SF63', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 37', 252764),
(424483, 'PTHR12547:SF171', NULL, NULL, NULL, NULL, 'CCCH-TYPE ZN-FINGER PROTEIN', 252764),
(424484, 'PTHR12547:SF150', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 47', 252764),
(424485, 'PTHR12547:SF172', NULL, NULL, NULL, NULL, 'FINGER-DOMAIN PROTEIN, PUTATIVE-RELATED', 252764),
(424486, 'PTHR12547:SF152', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 33', 252764),
(424487, 'PTHR12547:SF130', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 36, C3H1 TYPE-LIKE 1', 252764),
(424488, 'PTHR12547:SF153', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 9', 252764),
(424489, 'PTHR12547:SF132', NULL, NULL, NULL, NULL, 'PHARYNX AND INTESTINE IN EXCESS PROTEIN 1', 252764),
(424490, 'PTHR12547:SF110', NULL, NULL, NULL, NULL, 'CYTOPLASMIC ZINC-FINGER PROTEIN-RELATED', 252764),
(424491, 'PTHR12547:SF154', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 52', 252764),
(424492, 'PTHR12547:SF155', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 39-LIKE ISOFORM X1', 252764),
(424493, 'PTHR12547:SF156', NULL, NULL, NULL, NULL, 'MRNA DECAY ACTIVATOR PROTEIN ZFP36L2', 252764),
(424494, 'PTHR12547:SF112', NULL, NULL, NULL, NULL, 'CTH1', 252764),
(424495, 'PTHR12547:SF157', NULL, NULL, NULL, NULL, 'ZGC:162730', 252764),
(424496, 'PTHR12547:SF136', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 12-LIKE', 252764);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(424497, 'PTHR12547:SF159', NULL, NULL, NULL, NULL, 'CCCH ZINC FINGER-CONTAINING SAC3/GANP/NIN1/MTS3/EIF-3 P25 FAMILY PROTEIN', 252764),
(424498, 'PTHR12547:SF137', NULL, NULL, NULL, NULL, 'BNAA01G26190D PROTEIN', 252764),
(424499, 'PTHR12547:SF139', NULL, NULL, NULL, NULL, 'CCCH-TYPE ZN-FINGER PROTEIN', 252764),
(424500, 'PTHR12547', NULL, NULL, NULL, NULL, 'CCCH ZINC FINGER/TIS11-RELATED', 252764),
(424501, 'PTHR12547:SF71', NULL, NULL, NULL, NULL, 'CCCH-TYPE ZINC FINGER PROTEIN MOE-3-RELATED', 252764),
(424502, 'PTHR12547:SF58', NULL, NULL, NULL, NULL, 'MRNA DECAY ACTIVATOR PROTEIN ZFP36', 252764),
(424503, 'PTHR12547:SF53', NULL, NULL, NULL, NULL, 'MRNA DECAY ACTIVATOR PROTEIN ZFP36L1', 252764),
(424504, 'PTHR12547:SF160', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 52', 252764),
(424505, 'PTHR12547:SF161', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 14', 252764),
(424506, 'PTHR12547:SF162', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 15', 252764),
(424507, 'PTHR12547:SF163', NULL, NULL, NULL, NULL, '', 252764),
(424508, 'PTHR12547:SF164', NULL, NULL, NULL, NULL, 'ZINC FINGER, CCCH-TYPE-RELATED', 252764),
(424509, 'PTHR12547:SF121', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 39', 252764),
(424510, 'PTHR12547:SF165', NULL, NULL, NULL, NULL, '', 252764),
(424511, 'PTHR12547:SF18', NULL, NULL, NULL, NULL, 'PROTEIN TIS11', 252764),
(424512, 'PTHR12547:SF144', NULL, NULL, NULL, NULL, 'MEX-1', 252764),
(424513, 'PTHR12547:SF166', NULL, NULL, NULL, NULL, '', 252764),
(424514, 'PTHR12547:SF167', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 1', 252764),
(424515, 'PTHR12547:SF168', NULL, NULL, NULL, NULL, '', 252764),
(424516, 'PTHR12547:SF124', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 52', 252764),
(424517, 'PTHR12547:SF125', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 28', 252764),
(424518, 'PTHR12547:SF147', NULL, NULL, NULL, NULL, 'BNAA05G35950D PROTEIN', 252764),
(424519, 'PTHR12547:SF169', NULL, NULL, NULL, NULL, '', 252764),
(424520, 'PTHR12547:SF129', NULL, NULL, NULL, NULL, 'C3H1-TYPE DOMAIN-CONTAINING PROTEIN', 252764),
(424521, 'PTHR37290:SF1', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YIAA-RELATED', 252765),
(424522, 'PTHR37290', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YIAA-RELATED', 252765),
(424523, 'PTHR41161', NULL, NULL, NULL, NULL, 'PROTEIN NCBP2AS2', 252766),
(424524, 'PTHR41161:SF1', NULL, NULL, NULL, NULL, 'PROTEIN NCBP2AS2', 252766),
(424525, 'PTHR28604', NULL, NULL, NULL, NULL, '', 252767),
(424526, 'PTHR28604:SF3', NULL, NULL, NULL, NULL, '', 252767),
(424527, 'PTHR28604:SF2', NULL, NULL, NULL, NULL, 'RIKEN CDNA 2610028H24 GENE', 252767),
(424528, 'PTHR28604:SF1', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 29', 252767),
(424529, 'PTHR34409', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 252768),
(424530, 'PTHR34409:SF1', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 252768),
(424531, 'PTHR46224:SF62', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 252769),
(424532, 'PTHR46224:SF40', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 252769),
(424533, 'PTHR46224:SF61', NULL, NULL, NULL, NULL, 'ANKYRIN-LIKE PROTEIN', 252769),
(424534, 'PTHR46224:SF20', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 252769),
(424535, 'PTHR46224:SF64', NULL, NULL, NULL, NULL, 'IQ MOTIF AND ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 1', 252769),
(424536, 'PTHR46224:SF42', NULL, NULL, NULL, NULL, '', 252769),
(424537, 'PTHR46224:SF63', NULL, NULL, NULL, NULL, 'OS08G0325400 PROTEIN', 252769),
(424538, 'PTHR46224:SF41', NULL, NULL, NULL, NULL, 'OS03G0621400 PROTEIN', 252769),
(424539, 'PTHR46224:SF60', NULL, NULL, NULL, NULL, '', 252769),
(424540, 'PTHR46224:SF48', NULL, NULL, NULL, NULL, '', 252769),
(424541, 'PTHR46224:SF47', NULL, NULL, NULL, NULL, 'OS03G0680200 PROTEIN', 252769),
(424542, 'PTHR46224:SF25', NULL, NULL, NULL, NULL, 'OS12G0636100 PROTEIN', 252769);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(424543, 'PTHR46224:SF28', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 252769),
(424544, 'PTHR46224:SF49', NULL, NULL, NULL, NULL, '', 252769),
(424545, 'PTHR46224:SF27', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 252769),
(424546, 'PTHR46224:SF44', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 252769),
(424547, 'PTHR46224:SF22', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 252769),
(424548, 'PTHR46224:SF43', NULL, NULL, NULL, NULL, 'BNAC03G33870D PROTEIN', 252769),
(424549, 'PTHR46224:SF21', NULL, NULL, NULL, NULL, '', 252769),
(424550, 'PTHR46224', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 252769),
(424551, 'PTHR46224:SF65', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 252769),
(424552, 'PTHR46224:SF24', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 252769),
(424553, 'PTHR46224:SF6', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 252769),
(424554, 'PTHR46224:SF5', NULL, NULL, NULL, NULL, 'OS09G0124800 PROTEIN', 252769),
(424555, 'PTHR46224:SF1', NULL, NULL, NULL, NULL, '', 252769),
(424556, 'PTHR46224:SF51', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 252769),
(424557, 'PTHR46224:SF31', NULL, NULL, NULL, NULL, '', 252769),
(424558, 'PTHR46224:SF53', NULL, NULL, NULL, NULL, 'OS02G0492900 PROTEIN', 252769),
(424559, 'PTHR46224:SF59', NULL, NULL, NULL, NULL, 'OS02G0493300 PROTEIN', 252769),
(424560, 'PTHR46224:SF37', NULL, NULL, NULL, NULL, 'OS12G0600100 PROTEIN', 252769),
(424561, 'PTHR46224:SF36', NULL, NULL, NULL, NULL, 'OS03G0680600 PROTEIN', 252769),
(424562, 'PTHR46224:SF58', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 252769),
(424563, 'PTHR46224:SF38', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 252769),
(424564, 'PTHR46224:SF11', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 252769),
(424565, 'PTHR46224:SF55', NULL, NULL, NULL, NULL, '', 252769),
(424566, 'PTHR46224:SF54', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 252769),
(424567, 'PTHR46224:SF10', NULL, NULL, NULL, NULL, 'OS01G0189100 PROTEIN', 252769),
(424568, 'PTHR46224:SF57', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 252769),
(424569, 'PTHR46224:SF56', NULL, NULL, NULL, NULL, '', 252769),
(424570, 'PTHR46224:SF34', NULL, NULL, NULL, NULL, 'OS01G0171100 PROTEIN', 252769),
(424571, 'PTHR46224:SF12', NULL, NULL, NULL, NULL, 'OS03G0680400 PROTEIN', 252769),
(424572, 'PTHR46224:SF19', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 252769),
(424573, 'PTHR46224:SF18', NULL, NULL, NULL, NULL, '', 252769),
(424574, 'PTHR28204:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL DISTRIBUTION AND MORPHOLOGY PROTEIN 12', 252770),
(424575, 'PTHR28204', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL DISTRIBUTION AND MORPHOLOGY PROTEIN 12', 252770),
(424576, 'PTHR31548:SF6', NULL, NULL, NULL, NULL, 'AGAP002756-PA', 252771),
(424577, 'PTHR31548:SF5', NULL, NULL, NULL, NULL, 'CLARIN-2', 252771),
(424578, 'PTHR31548:SF4', NULL, NULL, NULL, NULL, 'CLARIN-1', 252771),
(424579, 'PTHR31548', NULL, NULL, NULL, NULL, 'CLARIN', 252771),
(424580, 'PTHR31548:SF3', NULL, NULL, NULL, NULL, 'CLARIN-3', 252771),
(424581, 'PTHR31548:SF1', NULL, NULL, NULL, NULL, 'LD47387P', 252771),
(424582, 'PTHR23401:SF0', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 5 ACTIVATOR', 252772),
(424583, 'PTHR23401:SF2', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 5 ACTIVATOR 1', 252772),
(424584, 'PTHR23401:SF1', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 5 ACTIVATOR', 252772),
(424585, 'PTHR23401:SF4', NULL, NULL, NULL, NULL, 'RANBP2-TYPE ZINC FINGER', 252772),
(424586, 'PTHR23401:SF3', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 5 ACTIVATOR 2', 252772),
(424587, 'PTHR23401', NULL, NULL, NULL, NULL, 'CYCLIN DEPENDANT KINASE-5 ACTIVATOR', 252772),
(424588, 'PTHR43416:SF41', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYLLYSINE-RESIDUE SUCCINYLTRANSFERASE COMPONENT OF 2-OXOGLUTARATE DEHYDROGENASE COMPLEX 2, MITOCHONDRIAL', 252773);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(424589, 'PTHR43416:SF42', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYLLYSINE-RESIDUE SUCCINYLTRANSFERASE', 252773),
(424590, 'PTHR43416:SF40', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYLLYSINE-RESIDUE SUCCINYLTRANSFERASE COMPONENT OF 2-OXOGLUTARATE DEHYDROGENASE COMPLEX 1, MITOCHONDRIAL', 252773),
(424591, 'PTHR43416', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYLLYSINE-RESIDUE SUCCINYLTRANSFERASE COMPONENT OF 2-OXOGLUTARATE DEHYDROGENASE COMPLEX, MITOCHONDRIAL-RELATED', 252773),
(424592, 'PTHR43416:SF29', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYLLYSINE-RESIDUE SUCCINYLTRANSFERASE', 252773),
(424593, 'PTHR43416:SF18', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYLLYSINE-RESIDUE SUCCINYLTRANSFERASE COMPONENT OF 2-OXOGLUTARATE DEHYDROGENASE COMPLEX, MITOCHONDRIAL', 252773),
(424594, 'PTHR43416:SF38', NULL, NULL, NULL, NULL, 'BIOTIN CARBOXYL CARRIER PROTEIN OF ACETYL-COA CARBOXYLASE 1, CHLOROPLASTIC', 252773),
(424595, 'PTHR43416:SF39', NULL, NULL, NULL, NULL, 'BIOTIN CARBOXYL CARRIER PROTEIN OF ACETYL-COA CARBOXYLASE', 252773),
(424596, 'PTHR43416:SF5', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYLLYSINE-RESIDUE SUCCINYLTRANSFERASE COMPONENT OF 2-OXOGLUTARATE DEHYDROGENASE COMPLEX, MITOCHONDRIAL', 252773),
(424597, 'PTHR43416:SF28', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYLLYSINE-RESIDUE SUCCINYLTRANSFERASE', 252773),
(424598, 'PTHR43416:SF8', NULL, NULL, NULL, NULL, 'LIPOAMIDE ACYLTRANSFERASE COMPONENT OF BRANCHED-CHAIN ALPHA-KETO ACID DEHYDROGENASE COMPLEX', 252773),
(424599, 'PTHR43416:SF37', NULL, NULL, NULL, NULL, 'BIOTIN CARBOXYL CARRIER PROTEIN OF ACETYL-COA CARBOXYLASE', 252773),
(424600, 'PTHR43416:SF7', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYLLYSINE-RESIDUE ACETYLTRANSFERASE COMPONENT OF PYRUVATE DEHYDROGENASE COMPLEX', 252773),
(424601, 'PTHR43416:SF15', NULL, NULL, NULL, NULL, 'DIHYDROLIPOAMIDE ACETYLTRANSFERASE COMPONENT OF PYRUVATE DEHYDROGENASE COMPLEX', 252773),
(424602, 'PTHR43416:SF23', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYLLYSINE-RESIDUE SUCCINYLTRANSFERASE', 252773),
(424603, 'PTHR43416:SF24', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYLLYSINE-RESIDUE SUCCINYLTRANSFERASE', 252773),
(424604, 'PTHR43416:SF35', NULL, NULL, NULL, NULL, 'BIOTIN CARBOXYL CARRIER PROTEIN OF ACETYL-COA CARBOXYLASE', 252773),
(424605, 'PTHR43416:SF4', NULL, NULL, NULL, NULL, 'BIOTIN CARBOXYL CARRIER PROTEIN OF ACETYL-COA CARBOXYLASE 2, CHLOROPLASTIC', 252773),
(424606, 'PTHR43416:SF43', NULL, NULL, NULL, NULL, 'BNAC06G14740D PROTEIN', 252773),
(424607, 'PTHR43470:SF4', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN YQGI-RELATED', 252774),
(424608, 'PTHR43470:SF3', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORT SYSTEM PERMEASE PROTEIN PSTA-RELATED', 252774),
(424609, 'PTHR43470', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORT SYSTEM PERMEASE PROTEIN PSTA-RELATED', 252774),
(424610, 'PTHR43470:SF6', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORT SYSTEM PERMEASE PROTEIN PSTA', 252774),
(424611, 'PTHR43470:SF5', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORT SYSTEM PERMEASE PROTEIN PSTA', 252774),
(424612, 'PTHR22812:SF155', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN CHP1P, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G02180)-RELATED', 252775),
(424613, 'PTHR22812:SF144', NULL, NULL, NULL, NULL, '', 252775),
(424614, 'PTHR22812', NULL, NULL, NULL, NULL, 'CHROMOBOX PROTEIN', 252775),
(424615, 'PTHR22812:SF154', NULL, NULL, NULL, NULL, 'CHROMO DOMAIN-CONTAINING PROTEIN', 252775),
(424616, 'PTHR22812:SF153', NULL, NULL, NULL, NULL, 'CHROMO DOMAIN-CONTAINING PROTEIN', 252775),
(424617, 'PTHR22812:SF152', NULL, NULL, NULL, NULL, 'CHROMO DOMAIN-CONTAINING PROTEIN', 252775),
(424618, 'PTHR22812:SF140', NULL, NULL, NULL, NULL, 'CHROMOBOX HOMOLOG 3B', 252775),
(424619, 'PTHR22812:SF85', NULL, NULL, NULL, NULL, 'CHROMOBOX PROTEIN HOMOLOG 5', 252775),
(424620, 'PTHR22812:SF149', NULL, NULL, NULL, NULL, 'CHROMOBOX 3', 252775),
(424621, 'PTHR22812:SF159', NULL, NULL, NULL, NULL, 'CHROMOBOX PROTEIN HOMOLOG 1', 252775),
(424622, 'PTHR22812:SF158', NULL, NULL, NULL, NULL, 'HETEROCHROMATIN PROTEIN 1-RELATED', 252775),
(424623, 'PTHR22812:SF157', NULL, NULL, NULL, NULL, 'CHROMO DOMAIN-CONTAINING PROTEIN CEC-1', 252775);
INSERT INTO "PUBLIC"."MODEL" VALUES
(424624, 'PTHR22812:SF134', NULL, NULL, NULL, NULL, 'CHROMOBOX PROTEIN HOMOLOG 3', 252775),
(424625, 'PTHR22812:SF156', NULL, NULL, NULL, NULL, 'CHROMOBOX HOMOLOG 3A (HP1 GAMMA HOMOLOG, DROSOPHILA)', 252775),
(424626, 'PTHR22812:SF145', NULL, NULL, NULL, NULL, 'CHROMO DOMAIN-CONTAINING PROTEIN', 252775),
(424627, 'PTHR22812:SF112', NULL, NULL, NULL, NULL, 'CHROMATOR, ISOFORM A-RELATED', 252775),
(424628, 'PTHR31786', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA CORE COMPLEX-ASSOCIATED PROTEIN 24', 252776),
(424629, 'PTHR31786:SF2', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA CORE COMPLEX-ASSOCIATED PROTEIN 24', 252776),
(424630, 'PTHR37356', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 239', 252777),
(424631, 'PTHR37356:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 239', 252777),
(424632, 'PTHR48099:SF8', NULL, NULL, NULL, NULL, 'C-1-TETRAHYDROFOLATE SYNTHASE, CYTOPLASMIC', 252778),
(424633, 'PTHR48099:SF7', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL METHYLENETETRAHYDROFOLATE DEHYDROGENASE/CYCLOHYDROLASE 2-RELATED', 252778),
(424634, 'PTHR48099:SF2', NULL, NULL, NULL, NULL, 'METHENYLTETRAHYDROFOLATE CYCLOHYDROLASE', 252778),
(424635, 'PTHR48099:SF1', NULL, NULL, NULL, NULL, 'C-1-TETRAHYDROFOLATE SYNTHASE, CYTOPLASMIC', 252778),
(424636, 'PTHR48099:SF6', NULL, NULL, NULL, NULL, 'METHENYL TETRAHYDROFOLATE CYCLOHYDROLASE / NADP-DEPENDENT METHYLENE H4F DEHYDROGENASE', 252778),
(424637, 'PTHR48099:SF5', NULL, NULL, NULL, NULL, 'C-1-TETRAHYDROFOLATE SYNTHASE, CYTOPLASMIC', 252778),
(424638, 'PTHR48099:SF10', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL PROTEIN FOLD 1, MITOCHONDRIAL', 252778),
(424639, 'PTHR48099:SF21', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL PROTEIN FOLD 3, CHLOROPLASTIC-RELATED', 252778),
(424640, 'PTHR48099:SF11', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL METHYLENETETRAHYDROFOLATE DEHYDROGENASE/CYCLOHYDROLASE, MITOCHONDRIAL', 252778),
(424641, 'PTHR48099:SF22', NULL, NULL, NULL, NULL, 'C-1-TETRAHYDROFOLATE SYNTHASE, CYTOPLASMIC', 252778),
(424642, 'PTHR48099:SF3', NULL, NULL, NULL, NULL, 'METHYLENETETRAHYDROFOLATE DEHYDROGENASE [NAD(+)]', 252778),
(424643, 'PTHR48099:SF23', NULL, NULL, NULL, NULL, 'FORMYLTETRAHYDROFOLATE SYNTHETASE', 252778),
(424644, 'PTHR48099:SF12', NULL, NULL, NULL, NULL, 'MONOFUNCTIONAL C1-TETRAHYDROFOLATE SYNTHASE, MITOCHONDRIAL', 252778),
(424645, 'PTHR48099:SF13', NULL, NULL, NULL, NULL, 'METHENYLTETRAHYDROFOLATE CYCLOHYDROLASE', 252778),
(424646, 'PTHR48099:SF24', NULL, NULL, NULL, NULL, 'METHENYLTETRAHYDROFOLATE CYCLOHYDROLASE', 252778),
(424647, 'PTHR48099:SF25', NULL, NULL, NULL, NULL, 'TETRAHYDROFOLATE DEHYDROGENASE/CYCLOHYDROLASE-RELATED', 252778),
(424648, 'PTHR48099:SF15', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL METHYLENETETRAHYDROFOLATE DEHYDROGENASE/CYCLOHYDROLASE, MITOCHONDRIAL', 252778),
(424649, 'PTHR48099', NULL, NULL, NULL, NULL, 'C-1-TETRAHYDROFOLATE SYNTHASE, CYTOPLASMIC-RELATED', 252778),
(424650, 'PTHR48099:SF18', NULL, NULL, NULL, NULL, 'THF_DHG_CYH_C DOMAIN-CONTAINING PROTEIN', 252778),
(424651, 'PTHR48099:SF19', NULL, NULL, NULL, NULL, 'METHENYLTETRAHYDROFOLATE CYCLOHYDROLASE', 252778),
(424652, 'PTHR47458:SF1', NULL, NULL, NULL, NULL, 'SMAD/FHA DOMAIN-CONTAINING PROTEIN', 252779),
(424653, 'PTHR47458', NULL, NULL, NULL, NULL, 'SMAD/FHA DOMAIN-CONTAINING PROTEIN', 252779),
(424654, 'PTHR46154:SF2', NULL, NULL, NULL, NULL, 'SOLUTE SYMPORTER FAMILY TRANSPORTER (AFU_ORTHOLOGUE AFUA_6G03200)', 252780),
(424655, 'PTHR46154:SF1', NULL, NULL, NULL, NULL, 'ACTIVE TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G17570)-RELATED', 252780),
(424656, 'PTHR46154:SF4', NULL, NULL, NULL, NULL, 'UREA ACTIVE TRANSPORTER', 252780),
(424657, 'PTHR46154:SF3', NULL, NULL, NULL, NULL, 'DUR32P', 252780),
(424658, 'PTHR46154', NULL, NULL, NULL, NULL, '', 252780),
(424659, 'PTHR33492:SF16', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252781),
(424660, 'PTHR33492:SF14', NULL, NULL, NULL, NULL, 'MYB-LIKE DOMAIN-CONTAINING PROTEIN', 252781),
(424661, 'PTHR33492:SF13', NULL, NULL, NULL, NULL, 'TRIHELIX TRANSCRIPTION FACTOR ASR3', 252781),
(424662, 'PTHR33492', NULL, NULL, NULL, NULL, 'OSJNBA0043A12.37 PROTEIN-RELATED', 252781);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(424663, 'PTHR33492:SF19', NULL, NULL, NULL, NULL, 'MYB-LIKE DOMAIN-CONTAINING PROTEIN', 252781),
(424664, 'PTHR33492:SF18', NULL, NULL, NULL, NULL, '', 252781),
(424665, 'PTHR33492:SF4', NULL, NULL, NULL, NULL, 'OS02G0174300 PROTEIN', 252781),
(424666, 'PTHR33492:SF3', NULL, NULL, NULL, NULL, 'TRIHELIX TRANSCRIPTION FACTOR ASR3', 252781),
(424667, 'PTHR33492:SF1', NULL, NULL, NULL, NULL, 'OS02G0516800 PROTEIN', 252781),
(424668, 'PTHR33492:SF12', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN-RELATED', 252781),
(424669, 'PTHR33492:SF9', NULL, NULL, NULL, NULL, 'GB|AAB80672.1', 252781),
(424670, 'PTHR33492:SF11', NULL, NULL, NULL, NULL, 'OS04G0670900 PROTEIN', 252781),
(424671, 'PTHR33492:SF10', NULL, NULL, NULL, NULL, 'TRIHELIX TRANSCRIPTION FACTOR ASR3-LIKE', 252781),
(424672, 'PTHR45895:SF129', NULL, NULL, NULL, NULL, '', 252782),
(424673, 'PTHR45895', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 252782),
(424674, 'PTHR45895:SF120', NULL, NULL, NULL, NULL, 'RETROVIRUS-RELATED POL POLYPROTEIN FROM TRANSPOSON TNT 1-94-LIKE PROTEIN', 252782),
(424675, 'PTHR45895:SF122', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 252782),
(424676, 'PTHR45895:SF121', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE TY1/COPIA-TYPE DOMAIN-CONTAINING PROTEIN', 252782),
(424677, 'PTHR45895:SF124', NULL, NULL, NULL, NULL, 'POLYPROTEIN/RETROTRANSPOSON, PUTATIVE-RELATED', 252782),
(424678, 'PTHR45895:SF123', NULL, NULL, NULL, NULL, '', 252782),
(424679, 'PTHR45895:SF126', NULL, NULL, NULL, NULL, 'SECRETED RXLR EFFECTOR PROTEIN 161-LIKE', 252782),
(424680, 'PTHR45895:SF125', NULL, NULL, NULL, NULL, 'ZINC FINGER, CCHC-TYPE-RELATED', 252782),
(424681, 'PTHR45895:SF128', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE TY1/COPIA-TYPE DOMAIN-CONTAINING PROTEIN', 252782),
(424682, 'PTHR45895:SF127', NULL, NULL, NULL, NULL, '', 252782),
(424683, 'PTHR45895:SF119', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 252782),
(424684, 'PTHR45895:SF118', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE TY1/COPIA-TYPE DOMAIN-CONTAINING PROTEIN', 252782),
(424685, 'PTHR45895:SF111', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 252782),
(424686, 'PTHR45895:SF110', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE TY1/COPIA-TYPE DOMAIN-CONTAINING PROTEIN', 252782),
(424687, 'PTHR45895:SF113', NULL, NULL, NULL, NULL, '', 252782),
(424688, 'PTHR45895:SF112', NULL, NULL, NULL, NULL, 'RETROTRANSPOSABLE ELEMENT, PUTATIVE-RELATED', 252782),
(424689, 'PTHR45895:SF115', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE TY1/COPIA-TYPE DOMAIN-CONTAINING PROTEIN', 252782),
(424690, 'PTHR45895:SF114', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE TY1/COPIA-TYPE DOMAIN-CONTAINING PROTEIN', 252782),
(424691, 'PTHR45895:SF117', NULL, NULL, NULL, NULL, 'PLECKSTRIN (PH) DOMAIN, REVERSE TRANSCRIPTASE, RNA-DEPENDENT DNA POLYMERASE-RELATED', 252782),
(424692, 'PTHR45895:SF116', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 252782),
(424693, 'PTHR45895:SF108', NULL, NULL, NULL, NULL, 'FLOCCULATION PROTEIN FLO11-LIKE', 252782),
(424694, 'PTHR45895:SF99', NULL, NULL, NULL, NULL, '', 252782),
(424695, 'PTHR45895:SF107', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE TY1/COPIA-TYPE DOMAIN-CONTAINING PROTEIN', 252782),
(424696, 'PTHR45895:SF109', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 252782),
(424697, 'PTHR45895:SF91', NULL, NULL, NULL, NULL, '', 252782),
(424698, 'PTHR45895:SF92', NULL, NULL, NULL, NULL, '', 252782),
(424699, 'PTHR45895:SF93', NULL, NULL, NULL, NULL, '', 252782),
(424700, 'PTHR45895:SF94', NULL, NULL, NULL, NULL, 'GAG_PRE-INTEGRS DOMAIN-CONTAINING PROTEIN', 252782),
(424701, 'PTHR45895:SF95', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 252782),
(424702, 'PTHR45895:SF96', NULL, NULL, NULL, NULL, 'ORF490 PROTEIN', 252782),
(424703, 'PTHR45895:SF97', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE, RNA-DEPENDENT DNA POLYMERASE, GAG-POLYPEPTIDE OF LTR COPIA-TYPE-RELATED', 252782);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(424704, 'PTHR45895:SF98', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE TY1/COPIA-TYPE DOMAIN-CONTAINING PROTEIN', 252782),
(424705, 'PTHR45895:SF140', NULL, NULL, NULL, NULL, 'TRANSPOSON TY1-BL GAG-POL POLYPROTEIN-RELATED', 252782),
(424706, 'PTHR45895:SF142', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 252782),
(424707, 'PTHR45895:SF141', NULL, NULL, NULL, NULL, 'RETROVIRUS-RELATED POL POLYPROTEIN FROM TRANSPOSON TNT 1-94', 252782),
(424708, 'PTHR45895:SF100', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE TY1/COPIA-TYPE DOMAIN-CONTAINING PROTEIN', 252782),
(424709, 'PTHR45895:SF144', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 252782),
(424710, 'PTHR45895:SF143', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE TY1/COPIA-TYPE DOMAIN-CONTAINING PROTEIN', 252782),
(424711, 'PTHR45895:SF146', NULL, NULL, NULL, NULL, 'TRANSPOSON TY4-H GAG-POL POLYPROTEIN-RELATED', 252782),
(424712, 'PTHR45895:SF102', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE, RNA-DEPENDENT DNA POLYMERASE-RELATED', 252782),
(424713, 'PTHR45895:SF101', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE TY1/COPIA-TYPE DOMAIN-CONTAINING PROTEIN', 252782),
(424714, 'PTHR45895:SF145', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE TY1/COPIA-TYPE DOMAIN-CONTAINING PROTEIN', 252782),
(424715, 'PTHR45895:SF104', NULL, NULL, NULL, NULL, '', 252782),
(424716, 'PTHR45895:SF148', NULL, NULL, NULL, NULL, 'FBA_1 DOMAIN-CONTAINING PROTEIN', 252782),
(424717, 'PTHR45895:SF103', NULL, NULL, NULL, NULL, '', 252782),
(424718, 'PTHR45895:SF147', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS PROTEIN BOP1 HOMOLOG', 252782),
(424719, 'PTHR45895:SF106', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE, RNA-DEPENDENT DNA POLYMERASE-RELATED', 252782),
(424720, 'PTHR45895:SF105', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE (RNA-DEPENDENT DNA POLYMERASE)', 252782),
(424721, 'PTHR45895:SF149', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE TY1/COPIA-TYPE DOMAIN-CONTAINING PROTEIN', 252782),
(424722, 'PTHR45895:SF88', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE, RNA-DEPENDENT DNA POLYMERASE-RELATED', 252782),
(424723, 'PTHR45895:SF89', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE TY1/COPIA-TYPE DOMAIN-CONTAINING PROTEIN', 252782),
(424724, 'PTHR45895:SF84', NULL, NULL, NULL, NULL, '', 252782),
(424725, 'PTHR45895:SF85', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 252782),
(424726, 'PTHR45895:SF86', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 252782),
(424727, 'PTHR45895:SF87', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE TY1/COPIA-TYPE DOMAIN-CONTAINING PROTEIN', 252782),
(424728, 'PTHR45895:SF131', NULL, NULL, NULL, NULL, 'GAG_PRE-INTEGRS DOMAIN-CONTAINING PROTEIN', 252782),
(424729, 'PTHR45895:SF130', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 252782),
(424730, 'PTHR45895:SF90', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE TY1/COPIA-TYPE DOMAIN-CONTAINING PROTEIN', 252782),
(424731, 'PTHR45895:SF133', NULL, NULL, NULL, NULL, 'RETROTRAN_GAG_3 DOMAIN-CONTAINING PROTEIN', 252782),
(424732, 'PTHR45895:SF132', NULL, NULL, NULL, NULL, 'DUF4218 DOMAIN-CONTAINING PROTEIN', 252782),
(424733, 'PTHR45895:SF135', NULL, NULL, NULL, NULL, 'RETROVIRUS-RELATED POL POLYPROTEIN FROM TRANSPOSON RE1-RELATED', 252782),
(424734, 'PTHR45895:SF134', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE TY1/COPIA-TYPE DOMAIN-CONTAINING PROTEIN', 252782),
(424735, 'PTHR45895:SF137', NULL, NULL, NULL, NULL, 'OS08G0125300 PROTEIN', 252782),
(424736, 'PTHR45895:SF136', NULL, NULL, NULL, NULL, '', 252782),
(424737, 'PTHR45895:SF139', NULL, NULL, NULL, NULL, 'LCR-LIKE PROTEIN', 252782),
(424738, 'PTHR45895:SF138', NULL, NULL, NULL, NULL, '', 252782),
(424739, 'PTHR34697:SF2', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLGLYCEROL LYSYLTRANSFERASE', 252783),
(424740, 'PTHR34697', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLGLYCEROL LYSYLTRANSFERASE', 252783),
(424741, 'PTHR12824:SF2', NULL, NULL, NULL, NULL, 'GROUP XIIB SECRETORY PHOSPHOLIPASE A2-LIKE PROTEIN', 252784);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(424742, 'PTHR12824:SF7', NULL, NULL, NULL, NULL, 'GROUP XIIA SECRETORY PHOSPHOLIPASE A2', 252784),
(424743, 'PTHR12824:SF8', NULL, NULL, NULL, NULL, 'GXIVSPLA2, ISOFORM A', 252784),
(424744, 'PTHR12824', NULL, NULL, NULL, NULL, 'GROUP XII SECRETORY PHOSPHOLIPASE A2 FAMILY MEMBER', 252784),
(424745, 'PTHR12824:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG26099', 252784),
(424746, 'PTHR30087:SF1', NULL, NULL, NULL, NULL, 'DUF523 DOMAIN-CONTAINING PROTEIN', 252785),
(424747, 'PTHR30087:SF0', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', 252785),
(424748, 'PTHR30087', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252785),
(424749, 'PTHR36045:SF4', NULL, NULL, NULL, NULL, '', 252786),
(424750, 'PTHR36045:SF2', NULL, NULL, NULL, NULL, 'OS04G0558500 PROTEIN', 252786),
(424751, 'PTHR36045', NULL, NULL, NULL, NULL, 'OS04G0558500 PROTEIN', 252786),
(424752, 'PTHR16089:SF28', NULL, NULL, NULL, NULL, 'GEO13032P1-RELATED', 252787),
(424753, 'PTHR16089', NULL, NULL, NULL, NULL, 'REST COREPRESSOR  COREST  PROTEIN-RELATED', 252787),
(424754, 'PTHR16089:SF19', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL-REGULATING FACTOR 1', 252787),
(424755, 'PTHR16089:SF12', NULL, NULL, NULL, NULL, 'REST COREPRESSOR 2', 252787),
(424756, 'PTHR16089:SF23', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 541', 252787),
(424757, 'PTHR16089:SF13', NULL, NULL, NULL, NULL, 'REST COREPRESSOR 3', 252787),
(424758, 'PTHR16089:SF24', NULL, NULL, NULL, NULL, 'MITOTIC DEACETYLASE-ASSOCIATED SANT DOMAIN PROTEIN', 252787),
(424759, 'PTHR16089:SF42', NULL, NULL, NULL, NULL, 'ELM2 DOMAIN-CONTAINING PROTEIN', 252787),
(424760, 'PTHR16089:SF43', NULL, NULL, NULL, NULL, 'SI:DKEY-19B23.10', 252787),
(424761, 'PTHR16089:SF11', NULL, NULL, NULL, NULL, 'REST COREPRESSOR 1', 252787),
(424762, 'PTHR16089:SF44', NULL, NULL, NULL, NULL, 'ELM2 DOMAIN-CONTAINING PROTEIN', 252787),
(424763, 'PTHR16089:SF40', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF ACTIVATED EGL-4 PROTEIN 1', 252787),
(424764, 'PTHR34117', NULL, NULL, NULL, NULL, 'STYLE CELL-CYCLE INHIBITOR 1', 252788),
(424765, 'PTHR34117:SF1', NULL, NULL, NULL, NULL, 'STYLE CELL-CYCLE INHIBITOR 1', 252788),
(424766, 'PTHR40131:SF1', NULL, NULL, NULL, NULL, '', 252789),
(424767, 'PTHR40131', NULL, NULL, NULL, NULL, '', 252789),
(424768, 'PTHR24007:SF7', NULL, NULL, NULL, NULL, 'BRCA1-ASSOCIATED PROTEIN', 252790),
(424769, 'PTHR24007', NULL, NULL, NULL, NULL, 'BRCA1-ASSOCIATED PROTEIN', 252790),
(424770, 'PTHR24007:SF10', NULL, NULL, NULL, NULL, 'BRAP2 RING ZNF UBP DOMAIN-CONTAINING PROTEIN 1', 252790),
(424771, 'PTHR34146:SF9', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', 252791),
(424772, 'PTHR34146:SF5', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', 252791),
(424773, 'PTHR34146:SF8', NULL, NULL, NULL, NULL, '', 252791),
(424774, 'PTHR34146:SF7', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDYL TRANSFERASE, RIBONUCLEASE H-LIKE SUPERFAMILY PROTEIN', 252791),
(424775, 'PTHR34146', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDYL TRANSFERASE, RIBONUCLEASE H-LIKE SUPERFAMILY PROTEIN-RELATED', 252791),
(424776, 'PTHR34146:SF3', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H-LIKE SUPERFAMILY PROTEIN', 252791),
(424777, 'PTHR47006', NULL, NULL, NULL, NULL, 'STAR-RELATED LIPID TRANSFER PROTEIN 4', 252792),
(424778, 'PTHR47006:SF1', NULL, NULL, NULL, NULL, 'STAR-RELATED LIPID TRANSFER PROTEIN 4', 252792),
(424779, 'PTHR45922', NULL, NULL, NULL, NULL, 'CLEAVAGE AND POLYADENYLATION SPECIFICITY FACTOR SUBUNIT 2', 252793),
(424780, 'PTHR45922:SF1', NULL, NULL, NULL, NULL, 'CLEAVAGE AND POLYADENYLATION SPECIFICITY FACTOR SUBUNIT 2', 252793),
(424781, 'PTHR15264', NULL, NULL, NULL, NULL, 'PROGRAMMED CELL DEATH PROTEIN 1', 252794),
(424782, 'PTHR15264:SF2', NULL, NULL, NULL, NULL, 'PROGRAMMED CELL DEATH PROTEIN 1', 252794),
(424783, 'PTHR14693', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1700018B08', 252795),
(424784, 'PTHR14693:SF0', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1700018B08 GENE', 252795),
(424785, 'PTHR10492:SF82', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 252796),
(424786, 'PTHR10492:SF86', NULL, NULL, NULL, NULL, '', 252796);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(424787, 'PTHR10492:SF85', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 252796),
(424788, 'PTHR10492:SF74', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 252796),
(424789, 'PTHR10492:SF84', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 252796),
(424790, 'PTHR10492:SF72', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 252796),
(424791, 'PTHR10492:SF83', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 252796),
(424792, 'PTHR10492:SF57', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 252796),
(424793, 'PTHR10492', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252796),
(424794, 'PTHR10492:SF89', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 252796),
(424795, 'PTHR10492:SF78', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 252796),
(424796, 'PTHR10492:SF88', NULL, NULL, NULL, NULL, '', 252796),
(424797, 'PTHR10492:SF87', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 252796),
(424798, 'PTHR47307', NULL, NULL, NULL, NULL, 'GLUTATHIONE-REGULATED POTASSIUM-EFFLUX SYSTEM ANCILLARY PROTEIN KEFG', 252797),
(424799, 'PTHR47307:SF1', NULL, NULL, NULL, NULL, 'GLUTATHIONE-REGULATED POTASSIUM-EFFLUX SYSTEM ANCILLARY PROTEIN KEFG', 252797),
(424800, 'PTHR47307:SF2', NULL, NULL, NULL, NULL, 'GLUTATHIONE-REGULATED POTASSIUM-EFFLUX SYSTEM ANCILLARY PROTEIN KEFF', 252797),
(424801, 'PTHR11430:SF86', NULL, NULL, NULL, NULL, 'PROSTAGLANDIN-H2 D-ISOMERASE', 252798),
(424802, 'PTHR11430:SF64', NULL, NULL, NULL, NULL, 'LIPOCALIN-15', 252798),
(424803, 'PTHR11430:SF65', NULL, NULL, NULL, NULL, 'ODORANT-BINDING PROTEIN 1A-RELATED', 252798),
(424804, 'PTHR11430:SF133', NULL, NULL, NULL, NULL, 'ZGC:153704', 252798),
(424805, 'PTHR11430:SF132', NULL, NULL, NULL, NULL, 'PROBASIN', 252798),
(424806, 'PTHR11430:SF89', NULL, NULL, NULL, NULL, 'ALLERGEN BOS D 2', 252798),
(424807, 'PTHR11430:SF139', NULL, NULL, NULL, NULL, 'LIPOCALIN-TYPE PROSTAGLANDIN D SYNTHASE-LIKE PROTEIN-RELATED', 252798),
(424808, 'PTHR11430:SF117', NULL, NULL, NULL, NULL, 'GLYCODELIN', 252798),
(424809, 'PTHR11430:SF138', NULL, NULL, NULL, NULL, 'BETA-LACTOGLOBULIN-1', 252798),
(424810, 'PTHR11430:SF135', NULL, NULL, NULL, NULL, 'LIPOCALIN 11', 252798),
(424811, 'PTHR11430:SF137', NULL, NULL, NULL, NULL, 'ODORANT-BINDING PROTEIN 2A', 252798),
(424812, 'PTHR11430:SF136', NULL, NULL, NULL, NULL, 'LIPOCALIN-1', 252798),
(424813, 'PTHR11430:SF63', NULL, NULL, NULL, NULL, 'LIPOCALIN 15-RELATED', 252798),
(424814, 'PTHR11430:SF28', NULL, NULL, NULL, NULL, 'EPIDIDYMAL-SPECIFIC LIPOCALIN-9', 252798),
(424815, 'PTHR11430', NULL, NULL, NULL, NULL, 'LIPOCALIN', 252798),
(424816, 'PTHR11430:SF120', NULL, NULL, NULL, NULL, 'LIPOCALIN 1-LIKE', 252798),
(424817, 'PTHR11430:SF76', NULL, NULL, NULL, NULL, 'MAJOR URINARY PROTEIN 1-RELATED', 252798),
(424818, 'PTHR11430:SF32', NULL, NULL, NULL, NULL, 'CHLOROPLASTIC LIPOCALIN', 252798),
(424819, 'PTHR11430:SF10', NULL, NULL, NULL, NULL, 'EPIDIDYMAL-SPECIFIC LIPOCALIN-6', 252798),
(424820, 'PTHR11430:SF77', NULL, NULL, NULL, NULL, 'LIPOCALIN-LIKE 1 PROTEIN', 252798),
(424821, 'PTHR11430:SF121', NULL, NULL, NULL, NULL, 'LIPOCLN_CYTOSOLIC_FA-BD_DOM DOMAIN-CONTAINING PROTEIN', 252798),
(424822, 'PTHR11430:SF12', NULL, NULL, NULL, NULL, 'EPIDIDYMAL-SPECIFIC LIPOCALIN-12', 252798),
(424823, 'PTHR11430:SF79', NULL, NULL, NULL, NULL, 'EPIDIDYMAL-SPECIFIC LIPOCALIN-10', 252798),
(424824, 'PTHR11430:SF13', NULL, NULL, NULL, NULL, 'NEUTROPHIL GELATINASE-ASSOCIATED LIPOCALIN', 252798),
(424825, 'PTHR11430:SF129', NULL, NULL, NULL, NULL, 'ODORANT-BINDING PROTEIN 2A-RELATED', 252798),
(424826, 'PTHR11430:SF70', NULL, NULL, NULL, NULL, 'UTEROCALIN', 252798),
(424827, 'PTHR11430:SF71', NULL, NULL, NULL, NULL, 'EPIDIDYMAL-SPECIFIC LIPOCALIN-5', 252798),
(424828, 'PTHR11430:SF124', NULL, NULL, NULL, NULL, 'LIPOCALIN 1-LIKE PROTEIN 1-RELATED', 252798),
(424829, 'PTHR11430:SF1', NULL, NULL, NULL, NULL, 'EPIDIDYMAL-SPECIFIC LIPOCALIN-8', 252798),
(424830, 'PTHR11430:SF4', NULL, NULL, NULL, NULL, 'VOMERONASAL SECRETORY PROTEIN 1', 252798),
(424831, 'PTHR11430:SF5', NULL, NULL, NULL, NULL, 'VOMERONASAL SECRETORY PROTEIN 2', 252798);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(424832, 'PTHR19302:SF14', NULL, NULL, NULL, NULL, 'GAMMA-TUBULIN COMPLEX COMPONENT 3', 252799),
(424833, 'PTHR19302:SF69', NULL, NULL, NULL, NULL, 'SPINDLE POLE BODY COMPONENT', 252799),
(424834, 'PTHR19302:SF13', NULL, NULL, NULL, NULL, 'GAMMA-TUBULIN COMPLEX COMPONENT 2', 252799),
(424835, 'PTHR19302:SF68', NULL, NULL, NULL, NULL, 'SPINDLE POLE BODY COMPONENT', 252799),
(424836, 'PTHR19302:SF27', NULL, NULL, NULL, NULL, 'GAMMA-TUBULIN COMPLEX COMPONENT 4', 252799),
(424837, 'PTHR19302:SF59', NULL, NULL, NULL, NULL, 'HYPOTHETICAL GAMMA-TUBULIN COMPLEX', 252799),
(424838, 'PTHR19302:SF70', NULL, NULL, NULL, NULL, 'GAMMA-TUBULIN COMPLEX COMPONENT 6', 252799),
(424839, 'PTHR19302:SF61', NULL, NULL, NULL, NULL, 'GAMMA-TUBULIN COMPLEX COMPONENT', 252799),
(424840, 'PTHR19302:SF33', NULL, NULL, NULL, NULL, 'GAMMA-TUBULIN COMPLEX COMPONENT 5', 252799),
(424841, 'PTHR19302', NULL, NULL, NULL, NULL, 'GAMMA TUBULIN COMPLEX PROTEIN', 252799),
(424842, 'PTHR21540:SF0', NULL, NULL, NULL, NULL, 'PHD FAMILY PROTEIN', 252800),
(424843, 'PTHR21540:SF3', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ZSWIM2', 252800),
(424844, 'PTHR21540:SF4', NULL, NULL, NULL, NULL, 'SWIM-TYPE DOMAIN-CONTAINING PROTEIN', 252800),
(424845, 'PTHR21540', NULL, NULL, NULL, NULL, 'RING FINGER AND SWIM DOMAIN-CONTAINING PROTEIN 2', 252800),
(424846, 'PTHR35073:SF1', NULL, NULL, NULL, NULL, 'OTOSPIRALIN', 252801),
(424847, 'PTHR35073', NULL, NULL, NULL, NULL, 'OTOSPIRALIN', 252801),
(424848, 'PTHR15574:SF57', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 8', 252802),
(424849, 'PTHR15574:SF21', NULL, NULL, NULL, NULL, 'DDB1 AND CUL4-ASSOCIATED FACTOR 8', 252802),
(424850, 'PTHR15574:SF65', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN', 252802),
(424851, 'PTHR15574:SF43', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 5', 252802),
(424852, 'PTHR15574:SF64', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 8-LIKE', 252802),
(424853, 'PTHR15574:SF42', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 8-LIKE PROTEIN 2', 252802),
(424854, 'PTHR15574:SF40', NULL, NULL, NULL, NULL, 'WD AND TETRATRICOPEPTIDE REPEATS PROTEIN 1', 252802),
(424855, 'PTHR15574:SF62', NULL, NULL, NULL, NULL, 'WD40/YVTN REPEAT-LIKE-CONTAINING DOMAIN-CONTAINING PROTEIN-RELATED', 252802),
(424856, 'PTHR15574:SF29', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 8-LIKE PROTEIN 1', 252802),
(424857, 'PTHR15574:SF39', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 6', 252802),
(424858, 'PTHR15574:SF38', NULL, NULL, NULL, NULL, 'OS06G0724500 PROTEIN', 252802),
(424859, 'PTHR15574:SF59', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN', 252802),
(424860, 'PTHR15574', NULL, NULL, NULL, NULL, 'WD REPEAT DOMAIN-CONTAINING FAMILY', 252802),
(424861, 'PTHR38568:SF2', NULL, NULL, NULL, NULL, '', 252803),
(424862, 'PTHR38568:SF1', NULL, NULL, NULL, NULL, '', 252803),
(424863, 'PTHR38568', NULL, NULL, NULL, NULL, '', 252803),
(424864, 'PTHR36388:SF1', NULL, NULL, NULL, NULL, 'OS02G0469000 PROTEIN', 252804),
(424865, 'PTHR36388', NULL, NULL, NULL, NULL, 'OS02G0469000 PROTEIN', 252804),
(424866, 'PTHR10153:SF33', NULL, NULL, NULL, NULL, 'SMALL CONDUCTANCE CALCIUM-ACTIVATED POTASSIUM CHANNEL PROTEIN', 252805),
(424867, 'PTHR10153:SF43', NULL, NULL, NULL, NULL, 'SMALL CONDUCTANCE CALCIUM-ACTIVATED POTASSIUM CHANNEL PROTEIN 2', 252805),
(424868, 'PTHR10153:SF41', NULL, NULL, NULL, NULL, 'INTERMEDIATE CONDUCTANCE CALCIUM-ACTIVATED POTASSIUM CHANNEL PROTEIN 4', 252805),
(424869, 'PTHR10153:SF37', NULL, NULL, NULL, NULL, 'SMALL CONDUCTANCE CALCIUM-ACTIVATED POTASSIUM CHANNEL-LIKE PROTEIN 3', 252805),
(424870, 'PTHR10153:SF36', NULL, NULL, NULL, NULL, 'CAMBD DOMAIN-CONTAINING PROTEIN', 252805),
(424871, 'PTHR10153:SF34', NULL, NULL, NULL, NULL, 'CAMBD DOMAIN-CONTAINING PROTEIN', 252805),
(424872, 'PTHR10153:SF38', NULL, NULL, NULL, NULL, 'SMALL CONDUCTANCE CALCIUM-ACTIVATED POTASSIUM CHANNEL PROTEIN 1', 252805),
(424873, 'PTHR10153:SF40', NULL, NULL, NULL, NULL, 'SMALL CONDUCTANCE CALCIUM-ACTIVATED POTASSIUM CHANNEL PROTEIN 3', 252805); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(424874, 'PTHR10153', NULL, NULL, NULL, NULL, 'SMALL CONDUCTANCE CALCIUM-ACTIVATED POTASSIUM CHANNEL', 252805),
(424875, 'PTHR31416', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 125', 252806),
(424876, 'PTHR31416:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 125', 252806),
(424877, 'PTHR10984:SF70', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE FOLD, ENDOPLASMIC RETICULUM VESICLE TRANSPORTER-RELATED', 252807),
(424878, 'PTHR10984:SF71', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 252807),
(424879, 'PTHR10984:SF29', NULL, NULL, NULL, NULL, 'SDBCAG84-RELATED PROTEIN-RELATED', 252807),
(424880, 'PTHR10984:SF25', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM-GOLGI INTERMEDIATE COMPARTMENT PROTEIN 3', 252807),
(424881, 'PTHR10984', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM-GOLGI INTERMEDIATE COMPARTMENT PROTEIN', 252807),
(424882, 'PTHR10984:SF69', NULL, NULL, NULL, NULL, 'BNAA05G17300D PROTEIN', 252807),
(424883, 'PTHR10984:SF27', NULL, NULL, NULL, NULL, '', 252807),
(424884, 'PTHR10984:SF65', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 252807),
(424885, 'PTHR10984:SF66', NULL, NULL, NULL, NULL, 'BNAA09G30800D PROTEIN', 252807),
(424886, 'PTHR10984:SF63', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM-GOLGI INTERMEDIATE COMPARTMENT PROTEIN 3-LIKE', 252807),
(424887, 'PTHR10984:SF80', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE 5-3', 252807),
(424888, 'PTHR10984:SF81', NULL, NULL, NULL, NULL, 'ER-DERIVED VESICLES PROTEIN ERV41', 252807),
(424889, 'PTHR10984:SF60', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM VESICLE TRANSPORTER PROTEIN', 252807),
(424890, 'PTHR10984:SF82', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM VESICLE TRANSPORTER PROTEIN', 252807),
(424891, 'PTHR10984:SF36', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM-GOLGI INTERMEDIATE COMPARTMENT PROTEIN 1', 252807),
(424892, 'PTHR10984:SF58', NULL, NULL, NULL, NULL, 'OS05G0490200 PROTEIN', 252807),
(424893, 'PTHR10984:SF37', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE 5-3', 252807),
(424894, 'PTHR10984:SF76', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE 5-4', 252807),
(424895, 'PTHR10984:SF55', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM-GOLGI INTERMEDIATE COMPARTMENT PROTEIN 3-LIKE', 252807),
(424896, 'PTHR10984:SF56', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM VESICLE TRANSPORTER PROTEIN', 252807),
(424897, 'PTHR10984:SF78', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM-GOLGI INTERMEDIATE COMPARTMENT PROTEIN 3-LIKE', 252807),
(424898, 'PTHR10984:SF79', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 252807),
(424899, 'PTHR10984:SF72', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM VESICLE TRANSPORTER-RELATED', 252807),
(424900, 'PTHR10984:SF30', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM-GOLGI INTERMEDIATE COMPARTMENT PROTEIN 2', 252807),
(424901, 'PTHR10984:SF53', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE 5-LIKE PROTEIN (DUF1692)', 252807),
(424902, 'PTHR10984:SF75', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM VESICLE TRANSPORTER', 252807),
(424903, 'PTHR35250', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 4', 252808),
(424904, 'PTHR35250:SF1', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 4', 252808),
(424905, 'PTHR39069:SF9', NULL, NULL, NULL, NULL, 'AGAP001390-PA', 252809),
(424906, 'PTHR39069:SF8', NULL, NULL, NULL, NULL, 'FI17111P1', 252809),
(424907, 'PTHR39069', NULL, NULL, NULL, NULL, 'ECDYSONE-INDUCIBLE GENE E1, ISOFORM A', 252809),
(424908, 'PTHR39069:SF1', NULL, NULL, NULL, NULL, 'ECDYSONE-INDUCIBLE GENE E1, ISOFORM A', 252809),
(424909, 'PTHR39069:SF4', NULL, NULL, NULL, NULL, 'LD24340P', 252809),
(424910, 'PTHR46589:SF1', NULL, NULL, NULL, NULL, 'APOPTOTIC CHROMATIN CONDENSATION INDUCER IN THE NUCLEUS', 252810),
(424911, 'PTHR46589', NULL, NULL, NULL, NULL, 'APOPTOTIC CHROMATIN CONDENSATION INDUCER IN THE NUCLEUS', 252810),
(424912, 'PTHR45904', NULL, NULL, NULL, NULL, 'TRNA (URACIL-5-)-METHYLTRANSFERASE', 252811),
(424913, 'PTHR45904:SF2', NULL, NULL, NULL, NULL, 'TRNA (URACIL-5-)-METHYLTRANSFERASE HOMOLOG A', 252811);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(424914, 'PTHR45904:SF1', NULL, NULL, NULL, NULL, 'TRNA (URACIL(54)-C(5))-METHYLTRANSFERASE HOMOLOG', 252811),
(424915, 'PTHR15954:SF4', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 51 HOMOLOG', 252812),
(424916, 'PTHR15954:SF5', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 51 HOMOLOG', 252812),
(424917, 'PTHR15954', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252812),
(424918, 'PTHR39401:SF1', NULL, NULL, NULL, NULL, 'SNOAL-LIKE DOMAIN-CONTAINING PROTEIN', 252813),
(424919, 'PTHR39401', NULL, NULL, NULL, NULL, 'SNOAL-LIKE DOMAIN-CONTAINING PROTEIN', 252813),
(424920, 'PTHR15451', NULL, NULL, NULL, NULL, 'ERGOSTEROL BIOSYNTHETIC PROTEIN 28-RELATED', 252814),
(424921, 'PTHR15451:SF20', NULL, NULL, NULL, NULL, 'ERGOSTEROL BIOSYNTHETIC PROTEIN 28', 252814),
(424922, 'PTHR15451:SF26', NULL, NULL, NULL, NULL, 'BNAA08G26030D PROTEIN', 252814),
(424923, 'PTHR15451:SF24', NULL, NULL, NULL, NULL, '', 252814),
(424924, 'PTHR15451:SF19', NULL, NULL, NULL, NULL, 'ERGOSTEROL BIOSYNTHETIC PROTEIN 28 HOMOLOG', 252814),
(424925, 'PTHR31576', NULL, NULL, NULL, NULL, 'TATA BOX-BINDING PROTEIN-ASSOCIATED FACTOR RNA POLYMERASE I SUBUNIT B', 252815),
(424926, 'PTHR31576:SF2', NULL, NULL, NULL, NULL, 'TATA BOX-BINDING PROTEIN-ASSOCIATED FACTOR RNA POLYMERASE I SUBUNIT B', 252815),
(424927, 'PTHR31576:SF4', NULL, NULL, NULL, NULL, '', 252815),
(424928, 'PTHR35041', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 1', 252816),
(424929, 'PTHR35041:SF3', NULL, NULL, NULL, NULL, '', 252816),
(424930, 'PTHR35041:SF6', NULL, NULL, NULL, NULL, '', 252816),
(424931, 'PTHR35041:SF4', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 1', 252816),
(424932, 'PTHR31315:SF13', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 252817),
(424933, 'PTHR31315:SF16', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 252817),
(424934, 'PTHR31315', NULL, NULL, NULL, NULL, 'PROTEIN SIP5', 252817),
(424935, 'PTHR31315:SF15', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE DA2', 252817),
(424936, 'PTHR31315:SF10', NULL, NULL, NULL, NULL, 'GW2', 252817),
(424937, 'PTHR31315:SF1', NULL, NULL, NULL, NULL, 'PROTEIN SIP5', 252817),
(424938, 'PTHR10547', NULL, NULL, NULL, NULL, 'SEMENOGELIN/SEMINAL VESICLE SECRETORY PROTEIN', 252818),
(424939, 'PTHR10547:SF8', NULL, NULL, NULL, NULL, '', 252818),
(424940, 'PTHR10547:SF7', NULL, NULL, NULL, NULL, 'SEMINAL VESICLE SECRETORY PROTEIN 3A-RELATED', 252818),
(424941, 'PTHR10547:SF6', NULL, NULL, NULL, NULL, 'SEMENOGELIN-2', 252818),
(424942, 'PTHR10547:SF4', NULL, NULL, NULL, NULL, 'SEMENOGELIN-1', 252818),
(424943, 'PTHR10547:SF2', NULL, NULL, NULL, NULL, 'SEMINAL VESICLE SECRETORY PROTEIN 2', 252818),
(424944, 'PTHR37466:SF1', NULL, NULL, NULL, NULL, 'SLR1628 PROTEIN', 252819),
(424945, 'PTHR37466', NULL, NULL, NULL, NULL, 'SLR1628 PROTEIN', 252819),
(424946, 'PTHR21622', NULL, NULL, NULL, NULL, 'COILED-COIL-HELIX-COILED-COIL-HELIX DOMAIN CONTAINING 4', 252820),
(424947, 'PTHR21622:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG18121', 252820),
(424948, 'PTHR21622:SF0', NULL, NULL, NULL, NULL, 'AU015836 PROTEIN-RELATED', 252820),
(424949, 'PTHR21622:SF6', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL INTERMEMBRANE SPACE IMPORT AND ASSEMBLY PROTEIN 40', 252820),
(424950, 'PTHR21622:SF5', NULL, NULL, NULL, NULL, 'CHCH DOMAIN-CONTAINING PROTEIN', 252820),
(424951, 'PTHR21622:SF4', NULL, NULL, NULL, NULL, 'CHCH DOMAIN-CONTAINING PROTEIN', 252820),
(424952, 'PTHR20968:SF2', NULL, NULL, NULL, NULL, 'INSULIN-LIKE PEPTIDE INSL5', 252821),
(424953, 'PTHR20968:SF4', NULL, NULL, NULL, NULL, 'RELAXIN-LIKE PEPTIDE LOCUS B', 252821),
(424954, 'PTHR20968', NULL, NULL, NULL, NULL, 'ILGF DOMAIN-CONTAINING PROTEIN', 252821),
(424955, 'PTHR20968:SF0', NULL, NULL, NULL, NULL, 'RELAXIN-3', 252821),
(424956, 'PTHR20968:SF1', NULL, NULL, NULL, NULL, 'ILGF DOMAIN-CONTAINING PROTEIN', 252821),
(424957, 'PTHR11689:SF89', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN', 252822),
(424958, 'PTHR11689:SF67', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN CLC-A', 252822);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(424959, 'PTHR11689:SF154', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN', 252822),
(424960, 'PTHR11689:SF144', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN CLC-C', 252822),
(424961, 'PTHR11689:SF155', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN CLC-B', 252822),
(424962, 'PTHR11689:SF145', NULL, NULL, NULL, NULL, 'OS02G0558100 PROTEIN', 252822),
(424963, 'PTHR11689:SF146', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN', 252822),
(424964, 'PTHR11689:SF68', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN', 252822),
(424965, 'PTHR11689:SF157', NULL, NULL, NULL, NULL, 'BNAA02G11800D PROTEIN', 252822),
(424966, 'PTHR11689:SF161', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN', 252822),
(424967, 'PTHR11689:SF162', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN CLC-C-LIKE', 252822),
(424968, 'PTHR11689:SF140', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN A', 252822),
(424969, 'PTHR11689:SF151', NULL, NULL, NULL, NULL, 'BNAC06G13300D PROTEIN', 252822),
(424970, 'PTHR11689:SF163', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN B', 252822),
(424971, 'PTHR11689:SF153', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN', 252822),
(424972, 'PTHR11689:SF142', NULL, NULL, NULL, NULL, 'BNAC02G36720D PROTEIN', 252822),
(424973, 'PTHR11689:SF164', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL CLC1 PROTEIN', 252822),
(424974, 'PTHR11689', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN CLC FAMILY MEMBER', 252822),
(424975, 'PTHR11689:SF92', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL-LIKE PROTEIN CLC-G-RELATED', 252822),
(424976, 'PTHR11689:SF60', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN C', 252822),
(424977, 'PTHR11689:SF158', NULL, NULL, NULL, NULL, 'CHLORIDE TRANSPORT PROTEIN 6', 252822),
(424978, 'PTHR11689:SF136', NULL, NULL, NULL, NULL, 'H(+)/CL(-) EXCHANGE TRANSPORTER 7', 252822),
(424979, 'PTHR11689:SF147', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN', 252822),
(424980, 'PTHR11689:SF159', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN', 252822),
(424981, 'PTHR47862', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP18, CHLOROPLASTIC', 252823),
(424982, 'PTHR47862:SF1', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP18, CHLOROPLASTIC', 252823),
(424983, 'PTHR37955:SF1', NULL, NULL, NULL, NULL, 'DEP DOMAIN-CONTAINING PROTEIN', 252824),
(424984, 'PTHR37955', NULL, NULL, NULL, NULL, 'TELLURITE RESISTANCE PROTEIN TEHA', 252824),
(424985, 'PTHR20844:SF0', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 9', 252825),
(424986, 'PTHR20844', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION, SUBUNIT 9', 252825),
(424987, 'PTHR33044:SF104', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN GPI-ANCHORED 2', 252826),
(424988, 'PTHR33044:SF225', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN GPI-ANCHORED 5', 252826),
(424989, 'PTHR33044:SF226', NULL, NULL, NULL, NULL, 'OS03G0664400 PROTEIN', 252826),
(424990, 'PTHR33044:SF102', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN GPI-ANCHORED 2-LIKE', 252826),
(424991, 'PTHR33044:SF223', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN GPI-ANCHORED 8-RELATED', 252826),
(424992, 'PTHR33044:SF224', NULL, NULL, NULL, NULL, 'OS03G0804200 PROTEIN', 252826),
(424993, 'PTHR33044:SF103', NULL, NULL, NULL, NULL, 'OS07G0244900 PROTEIN', 252826),
(424994, 'PTHR33044:SF229', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN GPI-ANCHORED 22', 252826),
(424995, 'PTHR33044:SF227', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN GPI-ANCHORED 27-RELATED', 252826),
(424996, 'PTHR33044:SF106', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN GPI-ANCHORED 19', 252826),
(424997, 'PTHR33044:SF107', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(424998, 'PTHR33044:SF228', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(424999, 'PTHR33044:SF182', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425000, 'PTHR33044:SF183', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(425001, 'PTHR33044:SF100', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN GPI-ANCHORED 3', 252826),
(425002, 'PTHR33044:SF189', NULL, NULL, NULL, NULL, 'LIPID TRANSFER PROTEIN', 252826),
(425003, 'PTHR33044:SF222', NULL, NULL, NULL, NULL, 'LIPID TRANSFER PROTEIN', 252826),
(425004, 'PTHR33044:SF186', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425005, 'PTHR33044:SF220', NULL, NULL, NULL, NULL, 'OS06G0341500 PROTEIN', 252826),
(425006, 'PTHR33044:SF191', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425007, 'PTHR33044:SF190', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN GPI-ANCHORED 15', 252826),
(425008, 'PTHR33044:SF236', NULL, NULL, NULL, NULL, 'PLANT LIPID TRANSFER PROTEIN/PAR ALLERGEN-RELATED', 252826),
(425009, 'PTHR33044:SF116', NULL, NULL, NULL, NULL, 'OS12G0112401 PROTEIN', 252826),
(425010, 'PTHR33044:SF237', NULL, NULL, NULL, NULL, 'OS07G0585250-LIKE PROTEIN', 252826),
(425011, 'PTHR33044:SF234', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425012, 'PTHR33044:SF235', NULL, NULL, NULL, NULL, 'LIPID TRANSFER-LIKE PROTEIN VAS', 252826),
(425013, 'PTHR33044:SF119', NULL, NULL, NULL, NULL, 'OS01G0814100 PROTEIN', 252826),
(425014, 'PTHR33044:SF238', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425015, 'PTHR33044:SF118', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN GPI-ANCHORED 1', 252826),
(425016, 'PTHR33044:SF239', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425017, 'PTHR33044:SF195', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425018, 'PTHR33044:SF196', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425019, 'PTHR33044:SF194', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN GPI-ANCHORED 6', 252826),
(425020, 'PTHR33044:SF232', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425021, 'PTHR33044:SF111', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425022, 'PTHR33044:SF233', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425023, 'PTHR33044:SF230', NULL, NULL, NULL, NULL, 'OS03G0793800 PROTEIN', 252826),
(425024, 'PTHR33044:SF231', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN-RELATED', 252826),
(425025, 'PTHR33044:SF203', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN GPI-ANCHORED 2-LIKE ISOFORM X1', 252826),
(425026, 'PTHR33044:SF204', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN GPI-ANCHORED 20', 252826),
(425027, 'PTHR33044:SF168', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425028, 'PTHR33044:SF201', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', 252826),
(425029, 'PTHR33044:SF169', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425030, 'PTHR33044:SF208', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN GPI-ANCHORED 11', 252826),
(425031, 'PTHR33044:SF206', NULL, NULL, NULL, NULL, 'PROLINE-RICH RECEPTOR-LIKE PROTEIN KINASE PERK10', 252826),
(425032, 'PTHR33044:SF161', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN GPI-ANCHORED 2-LIKE', 252826),
(425033, 'PTHR33044:SF166', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425034, 'PTHR33044:SF164', NULL, NULL, NULL, NULL, 'OS07G0489000 PROTEIN', 252826),
(425035, 'PTHR33044:SF209', NULL, NULL, NULL, NULL, 'OS06G0229700 PROTEIN', 252826),
(425036, 'PTHR33044:SF214', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425037, 'PTHR33044:SF179', NULL, NULL, NULL, NULL, 'OS03G0323900 PROTEIN', 252826),
(425038, 'PTHR33044:SF218', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN GPI-ANCHORED 21', 252826),
(425039, 'PTHR33044:SF174', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425040, 'PTHR33044:SF171', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425041, 'PTHR33044:SF172', NULL, NULL, NULL, NULL, 'PLANT LIPID TRANSFER PROTEIN/PAR ALLERGEN-RELATED', 252826);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(425042, 'PTHR33044:SF210', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT EXTENSIN-LIKE PROTEIN 5', 252826),
(425043, 'PTHR33044:SF177', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425044, 'PTHR33044:SF211', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425045, 'PTHR33044:SF178', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN GPI-ANCHORED 2-LIKE ISOFORM X1', 252826),
(425046, 'PTHR33044:SF176', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425047, 'PTHR33044:SF148', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN GPI-ANCHORED 4', 252826),
(425048, 'PTHR33044:SF149', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN GPI-ANCHORED 24', 252826),
(425049, 'PTHR33044:SF147', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN GPI-ANCHORED 12', 252826),
(425050, 'PTHR33044:SF140', NULL, NULL, NULL, NULL, 'XYLOGEN-LIKE PROTEIN 11', 252826),
(425051, 'PTHR33044:SF27', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN GPI-ANCHORED 31', 252826),
(425052, 'PTHR33044:SF29', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN GPI-ANCHORED 30', 252826),
(425053, 'PTHR33044:SF144', NULL, NULL, NULL, NULL, 'PROTEIN YLS3-LIKE', 252826),
(425054, 'PTHR33044:SF145', NULL, NULL, NULL, NULL, 'LIPID BINDING PROTEIN', 252826),
(425055, 'PTHR33044:SF142', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN GPI-ANCHORED 16', 252826),
(425056, 'PTHR33044:SF20', NULL, NULL, NULL, NULL, 'OS07G0175000 PROTEIN', 252826),
(425057, 'PTHR33044:SF22', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN-LIKE 1', 252826),
(425058, 'PTHR33044:SF159', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425059, 'PTHR33044:SF155', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425060, 'PTHR33044:SF156', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', 252826),
(425061, 'PTHR33044:SF154', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425062, 'PTHR33044:SF35', NULL, NULL, NULL, NULL, 'OS06G0682750 PROTEIN', 252826),
(425063, 'PTHR33044:SF37', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN GPI-ANCHORED 7', 252826),
(425064, 'PTHR33044:SF6', NULL, NULL, NULL, NULL, 'OS07G0625800 PROTEIN', 252826),
(425065, 'PTHR33044:SF3', NULL, NULL, NULL, NULL, 'OS10G0191100 PROTEIN', 252826),
(425066, 'PTHR33044:SF247', NULL, NULL, NULL, NULL, 'OS06G0686400 PROTEIN', 252826),
(425067, 'PTHR33044:SF245', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425068, 'PTHR33044:SF246', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425069, 'PTHR33044:SF128', NULL, NULL, NULL, NULL, 'PLANT LIPID TRANSFER PROTEIN/PAR ALLERGEN-RELATED', 252826),
(425070, 'PTHR33044:SF240', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425071, 'PTHR33044:SF243', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425072, 'PTHR33044:SF122', NULL, NULL, NULL, NULL, 'LIPID TRANSFER PROTEIN', 252826),
(425073, 'PTHR33044:SF244', NULL, NULL, NULL, NULL, 'OS07G0175600 PROTEIN', 252826),
(425074, 'PTHR33044:SF241', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN GPI-ANCHORED 29', 252826),
(425075, 'PTHR33044:SF242', NULL, NULL, NULL, NULL, 'OS07G0585200 PROTEIN', 252826),
(425076, 'PTHR33044:SF121', NULL, NULL, NULL, NULL, 'LIPID TRANSFER PROTEIN', 252826),
(425077, 'PTHR33044:SF87', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425078, 'PTHR33044:SF89', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN GPI-ANCHORED 23', 252826),
(425079, 'PTHR33044', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN-RELATED', 252826),
(425080, 'PTHR33044:SF138', NULL, NULL, NULL, NULL, 'OS07G0198300 PROTEIN', 252826),
(425081, 'PTHR33044:SF17', NULL, NULL, NULL, NULL, 'OS03G0664600 PROTEIN', 252826),
(425082, 'PTHR33044:SF18', NULL, NULL, NULL, NULL, 'OS04G0462200 PROTEIN', 252826);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(425083, 'PTHR33044:SF133', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425084, 'PTHR33044:SF134', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425085, 'PTHR33044:SF97', NULL, NULL, NULL, NULL, 'PROTEASE INHIBITOR/SEED STORAGE/LTP FAMILY PROTEIN', 252826),
(425086, 'PTHR33044:SF96', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425087, 'PTHR33044:SF99', NULL, NULL, NULL, NULL, 'AAI DOMAIN-CONTAINING PROTEIN', 252826),
(425088, 'PTHR33044:SF11', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN GPI-ANCHORED 10', 252826),
(425089, 'PTHR33044:SF12', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN C6', 252826),
(425090, 'PTHR33044:SF91', NULL, NULL, NULL, NULL, 'RALF', 252826),
(425091, 'PTHR33044:SF93', NULL, NULL, NULL, NULL, 'OS11G0583100 PROTEIN', 252826),
(425092, 'PTHR33044:SF94', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN GPI-ANCHORED 13-RELATED', 252826),
(425093, 'PTHR23078:SF2', NULL, NULL, NULL, NULL, 'VESICLE-FUSING ATPASE', 252827),
(425094, 'PTHR23078', NULL, NULL, NULL, NULL, 'VESICULAR-FUSION PROTEIN NSF', 252827),
(425095, 'PTHR23078:SF3', NULL, NULL, NULL, NULL, 'VESICLE-FUSING ATPASE', 252827),
(425096, 'PTHR23078:SF4', NULL, NULL, NULL, NULL, 'VESICLE-FUSING ATPASE', 252827),
(425097, 'PTHR23078:SF5', NULL, NULL, NULL, NULL, 'VESICLE-FUSING ATPASE', 252827),
(425098, 'PTHR21468', NULL, NULL, NULL, NULL, 'HSD9', 252828),
(425099, 'PTHR21468:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 83', 252828),
(425100, 'PTHR11227:SF61', NULL, NULL, NULL, NULL, 'BNAC06G18590D PROTEIN', 252829),
(425101, 'PTHR11227:SF60', NULL, NULL, NULL, NULL, 'BNAA09G40130D PROTEIN', 252829),
(425102, 'PTHR11227:SF52', NULL, NULL, NULL, NULL, '', 252829),
(425103, 'PTHR11227:SF51', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 18E', 252829),
(425104, 'PTHR11227:SF54', NULL, NULL, NULL, NULL, '', 252829),
(425105, 'PTHR11227:SF53', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 18A-LIKE', 252829),
(425106, 'PTHR11227:SF56', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN-RELATED', 252829),
(425107, 'PTHR11227:SF33', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 252829),
(425108, 'PTHR11227:SF58', NULL, NULL, NULL, NULL, 'WD REPEAT PHOSPHOINOSITIDE-INTERACTING-LIKE PROTEIN', 252829),
(425109, 'PTHR11227:SF59', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 18D', 252829),
(425110, 'PTHR11227:SF18', NULL, NULL, NULL, NULL, 'WD REPEAT DOMAIN PHOSPHOINOSITIDE-INTERACTING PROTEIN 3', 252829),
(425111, 'PTHR11227:SF17', NULL, NULL, NULL, NULL, 'WD REPEAT DOMAIN PHOSPHOINOSITIDE-INTERACTING PROTEIN 2', 252829),
(425112, 'PTHR11227:SF50', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 18A-LIKE ISOFORM X1', 252829),
(425113, 'PTHR11227:SF63', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 21', 252829),
(425114, 'PTHR11227:SF64', NULL, NULL, NULL, NULL, 'OS05G0169200 PROTEIN', 252829),
(425115, 'PTHR11227:SF23', NULL, NULL, NULL, NULL, 'WD REPEAT DOMAIN PHOSPHOINOSITIDE-INTERACTING PROTEIN 1', 252829),
(425116, 'PTHR11227', NULL, NULL, NULL, NULL, 'WD-REPEAT PROTEIN INTERACTING WITH PHOSPHOINOSIDES  WIPI -RELATED', 252829),
(425117, 'PTHR11227:SF44', NULL, NULL, NULL, NULL, 'WD REPEAT DOMAIN PHOSPHOINOSITIDE-INTERACTING PROTEIN 4', 252829),
(425118, 'PTHR11227:SF47', NULL, NULL, NULL, NULL, '', 252829),
(425119, 'PTHR11227:SF46', NULL, NULL, NULL, NULL, '', 252829),
(425120, 'PTHR11227:SF24', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED 18B, ISOFORM A', 252829),
(425121, 'PTHR11227:SF27', NULL, NULL, NULL, NULL, 'WD REPEAT DOMAIN PHOSPHOINOSITIDE-INTERACTING PROTEIN 2', 252829),
(425122, 'PTHR11227:SF49', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 18A', 252829),
(425123, 'PTHR11227:SF48', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 18A-LIKE', 252829),
(425124, 'PTHR11227:SF29', NULL, NULL, NULL, NULL, 'WD REPEAT DOMAIN PHOSPHOINOSITIDE-INTERACTING PROTEIN 4', 252829),
(425125, 'PTHR11227:SF3', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 21', 252829);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(425126, 'PTHR14647:SF83', NULL, NULL, NULL, NULL, 'GALACTOSE-3-O-SULFOTRANSFERASE 3', 252830),
(425127, 'PTHR14647:SF61', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE, PUTATIVE-RELATED', 252830),
(425128, 'PTHR14647:SF62', NULL, NULL, NULL, NULL, 'GALACTOSE-3-O-SULFOTRANSFERASE 2', 252830),
(425129, 'PTHR14647:SF84', NULL, NULL, NULL, NULL, '', 252830),
(425130, 'PTHR14647:SF63', NULL, NULL, NULL, NULL, 'GLR3514 PROTEIN', 252830),
(425131, 'PTHR14647:SF55', NULL, NULL, NULL, NULL, 'GALACTOSE-3-O-SULFOTRANSFERASE 2', 252830),
(425132, 'PTHR14647:SF56', NULL, NULL, NULL, NULL, 'GALACTOSYLCERAMIDE SULFOTRANSFERASE', 252830),
(425133, 'PTHR14647', NULL, NULL, NULL, NULL, 'GALACTOSE-3-O-SULFOTRANSFERASE', 252830),
(425134, 'PTHR14647:SF57', NULL, NULL, NULL, NULL, 'GALACTOSE-3-O-SULFOTRANSFERASE 4', 252830),
(425135, 'PTHR14647:SF82', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 252830),
(425136, 'PTHR38478', NULL, NULL, NULL, NULL, 'PEPTIDASE M1A AND M12B', 252831),
(425137, 'PTHR38478:SF1', NULL, NULL, NULL, NULL, 'ZINC DEPENDENT METALLOPROTEASE DOMAIN LIPOPROTEIN', 252831),
(425138, 'PTHR12913', NULL, NULL, NULL, NULL, 'UNR PROTEIN  N-RAS UPSTREAM GENE PROTEIN', 252832),
(425139, 'PTHR12913:SF3', NULL, NULL, NULL, NULL, 'SI:DKEYP-121D4.3', 252832),
(425140, 'PTHR12913:SF2', NULL, NULL, NULL, NULL, 'COLD SHOCK DOMAIN-CONTAINING E1, RNA-BINDING', 252832),
(425141, 'PTHR12913:SF1', NULL, NULL, NULL, NULL, 'COLD SHOCK DOMAIN-CONTAINING PROTEIN E1', 252832),
(425142, 'PTHR12277:SF39', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 252833),
(425143, 'PTHR12277:SF190', NULL, NULL, NULL, NULL, 'BNAA05G16340D PROTEIN', 252833),
(425144, 'PTHR12277:SF191', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 252833),
(425145, 'PTHR12277:SF72', NULL, NULL, NULL, NULL, 'ALPHA/BETA HYDROLASE DOMAIN-CONTAINING PROTEIN 16A', 252833),
(425146, 'PTHR12277:SF166', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 252833),
(425147, 'PTHR12277:SF185', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 252833),
(425148, 'PTHR12277:SF163', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN-RELATED', 252833),
(425149, 'PTHR12277:SF52', NULL, NULL, NULL, NULL, 'ALPHA/BETA HYDROLASE DOMAIN-CONTAINING PROTEIN 17A', 252833),
(425150, 'PTHR12277:SF164', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN-RELATED', 252833),
(425151, 'PTHR12277:SF161', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 252833),
(425152, 'PTHR12277:SF181', NULL, NULL, NULL, NULL, 'ALPHA/BETA HYDROLASE FOLD PROTEIN-RELATED', 252833),
(425153, 'PTHR12277:SF79', NULL, NULL, NULL, NULL, 'BLL4335 PROTEIN', 252833),
(425154, 'PTHR12277:SF37', NULL, NULL, NULL, NULL, 'PROTEIN ABHD16B', 252833),
(425155, 'PTHR12277:SF54', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLSERINE LIPASE ABHD16A', 252833),
(425156, 'PTHR12277:SF169', NULL, NULL, NULL, NULL, 'PEPTIDASE_S9 DOMAIN-CONTAINING PROTEIN', 252833),
(425157, 'PTHR12277:SF148', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 252833),
(425158, 'PTHR12277:SF167', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 252833),
(425159, 'PTHR12277:SF56', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 252833),
(425160, 'PTHR12277:SF200', NULL, NULL, NULL, NULL, 'PROTEIN ABHD17C-LIKE', 252833),
(425161, 'PTHR12277:SF55', NULL, NULL, NULL, NULL, 'ALPHA/BETA HYDROLASE DOMAIN-CONTAINING PROTEIN 17C', 252833),
(425162, 'PTHR12277:SF61', NULL, NULL, NULL, NULL, 'LYSOPHOSPHATIDYLSERINE LIPASE ABHD12', 252833),
(425163, 'PTHR12277:SF154', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 252833),
(425164, 'PTHR12277:SF198', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN-RELATED', 252833),
(425165, 'PTHR12277:SF199', NULL, NULL, NULL, NULL, '', 252833),
(425166, 'PTHR12277:SF196', NULL, NULL, NULL, NULL, 'PROTEIN CBG06738', 252833),
(425167, 'PTHR12277:SF41', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 252833);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(425168, 'PTHR12277:SF130', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 252833),
(425169, 'PTHR12277:SF197', NULL, NULL, NULL, NULL, 'DLH DOMAIN-CONTAINING PROTEIN', 252833),
(425170, 'PTHR12277:SF194', NULL, NULL, NULL, NULL, '2-ARACHIDONOYLGLYCEROL HYDROLASE ABHD12', 252833),
(425171, 'PTHR12277:SF173', NULL, NULL, NULL, NULL, 'PEPTIDASE_S15 DOMAIN-CONTAINING PROTEIN', 252833),
(425172, 'PTHR12277:SF195', NULL, NULL, NULL, NULL, 'PEPTIDASE_S15 DOMAIN-CONTAINING PROTEIN', 252833),
(425173, 'PTHR12277:SF81', NULL, NULL, NULL, NULL, 'PROTEIN ABHD13', 252833),
(425174, 'PTHR12277:SF192', NULL, NULL, NULL, NULL, 'OS02G0190800 PROTEIN', 252833),
(425175, 'PTHR12277:SF193', NULL, NULL, NULL, NULL, 'OS08G0487900 PROTEIN', 252833),
(425176, 'PTHR12277:SF69', NULL, NULL, NULL, NULL, 'PROTEIN ABHD12B', 252833),
(425177, 'PTHR12277:SF48', NULL, NULL, NULL, NULL, 'ALPHA/BETA HYDROLASE DOMAIN-CONTAINING PROTEIN 17B', 252833),
(425178, 'PTHR12277:SF139', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 252833),
(425179, 'PTHR12277:SF158', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 252833),
(425180, 'PTHR12277:SF137', NULL, NULL, NULL, NULL, 'PROTEIN ABHD17C-LIKE', 252833),
(425181, 'PTHR12277:SF64', NULL, NULL, NULL, NULL, 'SUPERFAMILY HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G01760)-RELATED', 252833),
(425182, 'PTHR12277', NULL, NULL, NULL, NULL, 'ALPHA/BETA HYDROLASE DOMAIN-CONTAINING PROTEIN', 252833),
(425183, 'PTHR12277:SF178', NULL, NULL, NULL, NULL, 'PROTEIN ABHD17C-LIKE', 252833),
(425184, 'PTHR12277:SF89', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 252833),
(425185, 'PTHR12277:SF134', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 252833),
(425186, 'PTHR12277:SF156', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 252833),
(425187, 'PTHR12558:SF9', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE PROTEIN 16 HOMOLOG', 252834),
(425188, 'PTHR12558:SF43', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE-LIKE PROTEIN', 252834),
(425189, 'PTHR12558:SF10', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE PROTEIN 23 HOMOLOG', 252834),
(425190, 'PTHR12558:SF42', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT 7', 252834),
(425191, 'PTHR12558:SF45', NULL, NULL, NULL, NULL, 'TPR DOMAIN CONTAINING PROTEIN', 252834),
(425192, 'PTHR12558:SF44', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 252834),
(425193, 'PTHR12558:SF33', NULL, NULL, NULL, NULL, 'BLL7664 PROTEIN', 252834),
(425194, 'PTHR12558:SF36', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT 7', 252834),
(425195, 'PTHR12558:SF47', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE ASSEMBLY PROTEIN B', 252834),
(425196, 'PTHR12558:SF25', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE PROTEIN 27 HOMOLOG B-LIKE', 252834),
(425197, 'PTHR12558:SF13', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE PROTEIN 27 HOMOLOG', 252834),
(425198, 'PTHR12558:SF46', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 252834),
(425199, 'PTHR12558:SF27', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE PROTEIN 27 HOMOLOG A', 252834),
(425200, 'PTHR12558:SF49', NULL, NULL, NULL, NULL, 'TPR DOMAIN CONTAINING PROTEIN', 252834),
(425201, 'PTHR12558:SF48', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 252834),
(425202, 'PTHR12558', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE 16,23,27', 252834),
(425203, 'PTHR12558:SF50', NULL, NULL, NULL, NULL, 'SI:DKEY-12J5.1', 252834),
(425204, 'PTHR17486', NULL, NULL, NULL, NULL, 'SPERMATID NUCLEAR TRANSITION PROTEIN 1', 252835),
(425205, 'PTHR17486:SF0', NULL, NULL, NULL, NULL, 'SPERMATID NUCLEAR TRANSITION PROTEIN 1', 252835),
(425206, 'PTHR34373:SF13', NULL, NULL, NULL, NULL, 'SHUGOSHIN 1', 252836),
(425207, 'PTHR34373:SF11', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252836),
(425208, 'PTHR34373', NULL, NULL, NULL, NULL, 'SHUGOSHIN 2', 252836),
(425209, 'PTHR34373:SF9', NULL, NULL, NULL, NULL, 'SHUGOSHIN 2', 252836),
(425210, 'PTHR34373:SF8', NULL, NULL, NULL, NULL, 'SHUGOSHIN', 252836);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(425211, 'PTHR34373:SF14', NULL, NULL, NULL, NULL, 'SHUGOSHIN-1-LIKE ISOFORM X1', 252836),
(425212, 'PTHR34373:SF15', NULL, NULL, NULL, NULL, 'SHUGOSHIN_C DOMAIN-CONTAINING PROTEIN', 252836),
(425213, 'PTHR45013', NULL, NULL, NULL, NULL, 'NACHT DOMAIN- AND WD REPEAT-CONTAINING PROTEIN 1', 252837),
(425214, 'PTHR45013:SF1', NULL, NULL, NULL, NULL, 'NACHT DOMAIN- AND WD REPEAT-CONTAINING PROTEIN 1', 252837),
(425215, 'PTHR47418', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 252838),
(425216, 'PTHR47418:SF1', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 252838),
(425217, 'PTHR47418:SF2', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 252838),
(425218, 'PTHR47878', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE FAD/NAD(P)-BINDING DOMAIN PROTEIN', 252839),
(425219, 'PTHR47878:SF1', NULL, NULL, NULL, NULL, 'FERREDOXIN--NADP REDUCTASE', 252839),
(425220, 'PTHR47878:SF2', NULL, NULL, NULL, NULL, 'FLAVODOXIN/FERREDOXIN--NADP REDUCTASE', 252839),
(425221, 'PTHR45932', NULL, NULL, NULL, NULL, 'PATELLIN-1', 252840),
(425222, 'PTHR45932:SF14', NULL, NULL, NULL, NULL, 'PATELLIN-5', 252840),
(425223, 'PTHR45932:SF25', NULL, NULL, NULL, NULL, 'BNAC05G23700D PROTEIN', 252840),
(425224, 'PTHR45932:SF23', NULL, NULL, NULL, NULL, 'CRAL-TRIO LIPID BINDING DOMAIN, GOLD DOMAIN-CONTAINING PROTEIN-RELATED', 252840),
(425225, 'PTHR45932:SF21', NULL, NULL, NULL, NULL, 'PATELLIN-2', 252840),
(425226, 'PTHR45932:SF10', NULL, NULL, NULL, NULL, 'PATELLIN-3 PROTEIN', 252840),
(425227, 'PTHR45932:SF19', NULL, NULL, NULL, NULL, 'PATELLIN-4-LIKE', 252840),
(425228, 'PTHR45932:SF17', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 252840),
(425229, 'PTHR45932:SF1', NULL, NULL, NULL, NULL, 'OS05G0429400 PROTEIN', 252840),
(425230, 'PTHR45932:SF18', NULL, NULL, NULL, NULL, 'PATELLIN 1-RELATED', 252840),
(425231, 'PTHR45932:SF26', NULL, NULL, NULL, NULL, 'PATELLIN-3', 252840),
(425232, 'PTHR45932:SF2', NULL, NULL, NULL, NULL, 'PATELLIN-4', 252840),
(425233, 'PTHR45932:SF3', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 252840),
(425234, 'PTHR45932:SF16', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 252840),
(425235, 'PTHR45932:SF4', NULL, NULL, NULL, NULL, 'PATELLIN-6', 252840),
(425236, 'PTHR45932:SF6', NULL, NULL, NULL, NULL, 'PATELLIN-3', 252840),
(425237, 'PTHR45932:SF9', NULL, NULL, NULL, NULL, 'PATELLIN-1', 252840),
(425238, 'PTHR39234:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 210', 252841),
(425239, 'PTHR39234', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 210', 252841),
(425240, 'PTHR28154', NULL, NULL, NULL, NULL, 'CELL WALL SYNTHESIS PROTEIN KNH1-RELATED', 252842),
(425241, 'PTHR28154:SF1', NULL, NULL, NULL, NULL, 'CELL WALL SYNTHESIS PROTEIN KNH1-RELATED', 252842),
(425242, 'PTHR36374:SF2', NULL, NULL, NULL, NULL, '', 252843),
(425243, 'PTHR36374', NULL, NULL, NULL, NULL, 'OS01G0969000 PROTEIN', 252843),
(425244, 'PTHR36374:SF1', NULL, NULL, NULL, NULL, 'OS01G0969000 PROTEIN', 252843),
(425245, 'PTHR47877:SF8', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN 17', 252844),
(425246, 'PTHR47877:SF15', NULL, NULL, NULL, NULL, 'PROTEIN COLD-REGULATED 15A, CHLOROPLASTIC-RELATED', 252844),
(425247, 'PTHR47877:SF9', NULL, NULL, NULL, NULL, 'BNAC02G35130D PROTEIN', 252844),
(425248, 'PTHR47877:SF14', NULL, NULL, NULL, NULL, '', 252844),
(425249, 'PTHR47877:SF7', NULL, NULL, NULL, NULL, 'BNAA03G56730D PROTEIN', 252844),
(425250, 'PTHR47877:SF4', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN ECP63', 252844),
(425251, 'PTHR47877:SF11', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN LEA-RELATED', 252844),
(425252, 'PTHR47877:SF5', NULL, NULL, NULL, NULL, 'EMBRYONIC PROTEIN DC-8-LIKE', 252844),
(425253, 'PTHR47877:SF2', NULL, NULL, NULL, NULL, 'SEED BIOTIN-CONTAINING PROTEIN SBP65-LIKE ISOFORM X1', 252844),
(425254, 'PTHR47877:SF3', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT DOMAIN-CONTAINING PROTEIN / LEA DOMAIN-CONTAINING PROTEIN', 252844),
(425255, 'PTHR47877', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT DOMAIN-CONTAINING PROTEIN / LEA DOMAIN-CONTAINING PROTEIN', 252844);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(425256, 'PTHR43748:SF10', NULL, NULL, NULL, NULL, 'RIBOSE-5-PHOSPHATE ISOMERASE', 252845),
(425257, 'PTHR43748:SF9', NULL, NULL, NULL, NULL, 'RIBOSE-5-PHOSPHATE ISOMERASE', 252845),
(425258, 'PTHR43748:SF7', NULL, NULL, NULL, NULL, 'RIBOSE-5-PHOSPHATE ISOMERASE', 252845),
(425259, 'PTHR43748:SF8', NULL, NULL, NULL, NULL, 'RIBOSE-5-PHOSPHATE ISOMERASE', 252845),
(425260, 'PTHR43748', NULL, NULL, NULL, NULL, 'RIBOSE-5-PHOSPHATE ISOMERASE 3, CHLOROPLASTIC-RELATED', 252845),
(425261, 'PTHR43748:SF1', NULL, NULL, NULL, NULL, 'RIBOSE-5-PHOSPHATE ISOMERASE 4, CHLOROPLASTIC-RELATED', 252845),
(425262, 'PTHR43748:SF2', NULL, NULL, NULL, NULL, 'RIBOSE-5-PHOSPHATE ISOMERASE 2-RELATED', 252845),
(425263, 'PTHR43748:SF5', NULL, NULL, NULL, NULL, 'RIBOSE-5-PHOSPHATE ISOMERASE', 252845),
(425264, 'PTHR43748:SF3', NULL, NULL, NULL, NULL, 'RIBOSE-5-PHOSPHATE ISOMERASE 3, CHLOROPLASTIC-RELATED', 252845),
(425265, 'PTHR43748:SF4', NULL, NULL, NULL, NULL, 'RIBOSE-5-PHOSPHATE ISOMERASE 1-RELATED', 252845),
(425266, 'PTHR28593:SF1', NULL, NULL, NULL, NULL, 'METEORIN-LIKE PROTEIN', 252846),
(425267, 'PTHR28593', NULL, NULL, NULL, NULL, 'METEORIN-LIKE PROTEIN', 252846),
(425268, 'PTHR28593:SF3', NULL, NULL, NULL, NULL, 'METEORIN-LIKE PROTEIN', 252846),
(425269, 'PTHR28593:SF2', NULL, NULL, NULL, NULL, 'METEORIN', 252846),
(425270, 'PTHR28593:SF4', NULL, NULL, NULL, NULL, 'METEORIN-LIKE PROTEIN', 252846),
(425271, 'PTHR28049', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN YOR223W', 252847),
(425272, 'PTHR28049:SF1', NULL, NULL, NULL, NULL, 'DSC E3 UBIQUITIN LIGASE COMPLEX SUBUNIT 3', 252847),
(425273, 'PTHR15190', NULL, NULL, NULL, NULL, 'BONE MARROW STROMAL ANTIGEN 2', 252848),
(425274, 'PTHR15190:SF1', NULL, NULL, NULL, NULL, 'BONE MARROW STROMAL ANTIGEN 2', 252848),
(425275, 'PTHR43422:SF3', NULL, NULL, NULL, NULL, 'THIAMINE THIAZOLE SYNTHASE', 252849),
(425276, 'PTHR43422:SF12', NULL, NULL, NULL, NULL, 'THIAMINE THIAZOLE SYNTHASE, CHLOROPLASTIC', 252849),
(425277, 'PTHR43422:SF14', NULL, NULL, NULL, NULL, 'THIAMINE THIAZOLE SYNTHASE, CHLOROPLASTIC', 252849),
(425278, 'PTHR43422:SF6', NULL, NULL, NULL, NULL, 'THIAMINE THIAZOLE SYNTHASE 2, CHLOROPLASTIC', 252849),
(425279, 'PTHR43422:SF16', NULL, NULL, NULL, NULL, 'THIAMINE THIAZOLE SYNTHASE 1, CHLOROPLASTIC', 252849),
(425280, 'PTHR43422:SF9', NULL, NULL, NULL, NULL, 'THIAMINE THIAZOLE SYNTHASE 2, CHLOROPLASTIC', 252849),
(425281, 'PTHR43422:SF15', NULL, NULL, NULL, NULL, 'THIAMINE THIAZOLE SYNTHASE, CHLOROPLASTIC', 252849),
(425282, 'PTHR43422:SF8', NULL, NULL, NULL, NULL, '', 252849),
(425283, 'PTHR43422', NULL, NULL, NULL, NULL, 'THIAMINE THIAZOLE SYNTHASE', 252849),
(425284, 'PTHR14957', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE-CONJUGATING ENZYME ATG10', 252850),
(425285, 'PTHR14957:SF1', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE-CONJUGATING ENZYME ATG10', 252850),
(425286, 'PTHR12810', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 28S RIBOSOMAL PROTEIN S29', 252851),
(425287, 'PTHR12810:SF0', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S29, MITOCHONDRIAL', 252851),
(425288, 'PTHR40370', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252852),
(425289, 'PTHR40370:SF1', NULL, NULL, NULL, NULL, 'DUF3074 DOMAIN-CONTAINING PROTEIN', 252852),
(425290, 'PTHR16186', NULL, NULL, NULL, NULL, 'SIGNAL-TRANSDUCING ADAPTOR PROTEIN-RELATED', 252853),
(425291, 'PTHR16186:SF12', NULL, NULL, NULL, NULL, '', 252853),
(425292, 'PTHR16186:SF11', NULL, NULL, NULL, NULL, 'SIGNAL-TRANSDUCING ADAPTOR PROTEIN 2', 252853),
(425293, 'PTHR16186:SF10', NULL, NULL, NULL, NULL, 'SIGNAL-TRANSDUCING ADAPTOR PROTEIN 1', 252853),
(425294, 'PTHR16186:SF9', NULL, NULL, NULL, NULL, '', 252853),
(425295, 'PTHR15243', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 19', 252854),
(425296, 'PTHR15243:SF0', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 19', 252854),
(425297, 'PTHR34768', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 89', 252855),
(425298, 'PTHR34768:SF3', NULL, NULL, NULL, NULL, 'TUMOR SUPPRESSOR CANDIDATE GENE 1 PROTEIN', 252855),
(425299, 'PTHR34768:SF2', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 89', 252855);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(425300, 'PTHR34768:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 89', 252855),
(425301, 'PTHR31027', NULL, NULL, NULL, NULL, 'NUCLEAR SEGREGATION PROTEIN BFR1', 252856),
(425302, 'PTHR31027:SF2', NULL, NULL, NULL, NULL, 'NUCLEAR SEGREGATION PROTEIN BFR1', 252856),
(425303, 'PTHR24303:SF35', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 303A1-RELATED', 252857),
(425304, 'PTHR24303:SF13', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 305A1-RELATED', 252857),
(425305, 'PTHR24303:SF8', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 513D1-RELATED', 252857),
(425306, 'PTHR24303:SF34', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 307A1-RELATED', 252857),
(425307, 'PTHR24303:SF37', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 514A1-RELATED', 252857),
(425308, 'PTHR24303:SF36', NULL, NULL, NULL, NULL, 'BNACNNG69050D PROTEIN', 252857),
(425309, 'PTHR24303:SF27', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 307B1', 252857),
(425310, 'PTHR24303', NULL, NULL, NULL, NULL, 'HEME-BINDING MONOOXYGENASE FAMILY', 252857),
(425311, 'PTHR24303:SF31', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 304A1-RELATED', 252857),
(425312, 'PTHR24303:SF11', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 513A1-RELATED', 252857),
(425313, 'PTHR24303:SF32', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 513C1-RELATED', 252857),
(425314, 'PTHR42833:SF7', NULL, NULL, NULL, NULL, 'MADF DOMAIN-CONTAINING PROTEIN', 252858),
(425315, 'PTHR42833:SF1', NULL, NULL, NULL, NULL, 'URIDINE MONOPHOSPHATE KINASE', 252858),
(425316, 'PTHR42833:SF4', NULL, NULL, NULL, NULL, 'AMINO ACID KINASE FAMILY PROTEIN', 252858),
(425317, 'PTHR42833', NULL, NULL, NULL, NULL, 'URIDYLATE KINASE', 252858),
(425318, 'PTHR23263', NULL, NULL, NULL, NULL, 'SMALL PROLINE-RICH PROTEIN', 252859),
(425319, 'PTHR23263:SF124', NULL, NULL, NULL, NULL, 'SMALL PROLINE-RICH PROTEIN 3', 252859),
(425320, 'PTHR33429:SF41', NULL, NULL, NULL, NULL, 'BNAA08G05490D PROTEIN', 252860),
(425321, 'PTHR33429:SF40', NULL, NULL, NULL, NULL, '', 252860),
(425322, 'PTHR33429:SF43', NULL, NULL, NULL, NULL, '', 252860),
(425323, 'PTHR33429:SF42', NULL, NULL, NULL, NULL, 'OS06G0481900 PROTEIN', 252860),
(425324, 'PTHR33429:SF19', NULL, NULL, NULL, NULL, 'FISSION REGULATOR-LIKE PROTEIN', 252860),
(425325, 'PTHR33429', NULL, NULL, NULL, NULL, 'OS02G0708000 PROTEIN-RELATED', 252860),
(425326, 'PTHR33429:SF23', NULL, NULL, NULL, NULL, 'OS02G0709350 PROTEIN', 252860),
(425327, 'PTHR33429:SF45', NULL, NULL, NULL, NULL, '', 252860),
(425328, 'PTHR33429:SF44', NULL, NULL, NULL, NULL, '', 252860),
(425329, 'PTHR33429:SF2', NULL, NULL, NULL, NULL, 'OS01G0888850 PROTEIN', 252860),
(425330, 'PTHR33429:SF25', NULL, NULL, NULL, NULL, 'OS05G0417700 PROTEIN', 252860),
(425331, 'PTHR33429:SF24', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252860),
(425332, 'PTHR33429:SF35', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 252860),
(425333, 'PTHR33429:SF26', NULL, NULL, NULL, NULL, 'BNAA08G20450D PROTEIN', 252860),
(425334, 'PTHR33429:SF29', NULL, NULL, NULL, NULL, 'BNAA09G30970D PROTEIN', 252860),
(425335, 'PTHR33429:SF39', NULL, NULL, NULL, NULL, 'BNAC02G19820D PROTEIN', 252860),
(425336, 'PTHR33429:SF7', NULL, NULL, NULL, NULL, 'OS02G0708000 PROTEIN', 252860),
(425337, 'PTHR34366:SF5', NULL, NULL, NULL, NULL, 'OS05G0355900 PROTEIN', 252861),
(425338, 'PTHR34366:SF7', NULL, NULL, NULL, NULL, '', 252861),
(425339, 'PTHR34366:SF8', NULL, NULL, NULL, NULL, 'BNAANNG20590D PROTEIN', 252861),
(425340, 'PTHR34366:SF2', NULL, NULL, NULL, NULL, 'OS07G0289901 PROTEIN', 252861),
(425341, 'PTHR34366:SF4', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252861),
(425342, 'PTHR34366:SF9', NULL, NULL, NULL, NULL, 'OS03G0304200 PROTEIN', 252861),
(425343, 'PTHR34366', NULL, NULL, NULL, NULL, 'OS07G0289901 PROTEIN-RELATED', 252861),
(425344, 'PTHR45838:SF7', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE 1-RELATED', 252862),
(425345, 'PTHR45838', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE-N-METHYLTRANSFERASE 2 KMT2 FAMILY MEMBER', 252862),
(425346, 'PTHR45838:SF8', NULL, NULL, NULL, NULL, '', 252862),
(425347, 'PTHR45838:SF3', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE 2B', 252862);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(425348, 'PTHR45838:SF4', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE TRITHORAX', 252862),
(425349, 'PTHR45838:SF2', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE 2A', 252862),
(425350, 'PTHR33604:SF5', NULL, NULL, NULL, NULL, 'BNAA02G06160D PROTEIN', 252863),
(425351, 'PTHR33604:SF6', NULL, NULL, NULL, NULL, '', 252863),
(425352, 'PTHR33604:SF1', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY PROTEIN 2', 252863),
(425353, 'PTHR33604:SF3', NULL, NULL, NULL, NULL, 'OSJNBA0004B13.7 PROTEIN', 252863),
(425354, 'PTHR33604', NULL, NULL, NULL, NULL, 'OSJNBA0004B13.7 PROTEIN', 252863),
(425355, 'PTHR45783:SF5', NULL, NULL, NULL, NULL, 'KINESIN LIGHT CHAIN', 252864),
(425356, 'PTHR45783:SF2', NULL, NULL, NULL, NULL, 'KINESIN LIGHT CHAIN 2', 252864),
(425357, 'PTHR45783:SF3', NULL, NULL, NULL, NULL, 'KINESIN LIGHT CHAIN', 252864),
(425358, 'PTHR45783:SF8', NULL, NULL, NULL, NULL, 'KINESIN LIGHT CHAIN', 252864),
(425359, 'PTHR45783:SF6', NULL, NULL, NULL, NULL, 'KINESIN LIGHT CHAIN 4', 252864),
(425360, 'PTHR45783:SF7', NULL, NULL, NULL, NULL, 'KINESIN LIGHT CHAIN 1', 252864),
(425361, 'PTHR45783', NULL, NULL, NULL, NULL, 'KINESIN LIGHT CHAIN', 252864),
(425362, 'PTHR45783:SF1', NULL, NULL, NULL, NULL, 'KINESIN LIGHT CHAIN 3', 252864),
(425363, 'PTHR36768', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT HELICASE/DEOXYRIBONUCLEASE SUBUNIT B', 252865),
(425364, 'PTHR36768:SF1', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT HELICASE/DEOXYRIBONUCLEASE SUBUNIT B', 252865),
(425365, 'PTHR12169:SF6', NULL, NULL, NULL, NULL, 'AFG1-LIKE ATPASE', 252866),
(425366, 'PTHR12169:SF31', NULL, NULL, NULL, NULL, 'AFG1-LIKE ATPASE FAMILY PROTEIN', 252866),
(425367, 'PTHR12169:SF30', NULL, NULL, NULL, NULL, 'AFG1-LIKE ATPASE FAMILY PROTEIN-RELATED', 252866),
(425368, 'PTHR12169:SF2', NULL, NULL, NULL, NULL, 'AFG1P', 252866),
(425369, 'PTHR12169:SF1', NULL, NULL, NULL, NULL, '', 252866),
(425370, 'PTHR12169:SF19', NULL, NULL, NULL, NULL, 'LACTATION ELEVATED PROTEIN 1 HOMOLOG B', 252866),
(425371, 'PTHR12169:SF29', NULL, NULL, NULL, NULL, 'AFG1-LIKE ATPASE FAMILY PROTEIN', 252866),
(425372, 'PTHR12169', NULL, NULL, NULL, NULL, 'ATPASE N2B', 252866),
(425373, 'PTHR12169:SF28', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 252866),
(425374, 'PTHR12169:SF26', NULL, NULL, NULL, NULL, '', 252866),
(425375, 'PTHR12169:SF25', NULL, NULL, NULL, NULL, 'AFG1-LIKE ATPASE A', 252866),
(425376, 'PTHR11552:SF219', NULL, NULL, NULL, NULL, 'GMC_OXRDTASE_N DOMAIN-CONTAINING PROTEIN', 252867),
(425377, 'PTHR11552:SF119', NULL, NULL, NULL, NULL, 'CHOLINE DEHYDROGENASE', 252867),
(425378, 'PTHR11552:SF218', NULL, NULL, NULL, NULL, 'CHROMOSOME 15, WHOLE GENOME SHOTGUN SEQUENCE', 252867),
(425379, 'PTHR11552:SF134', NULL, NULL, NULL, NULL, 'GMC_OXRDTASE_N DOMAIN-CONTAINING PROTEIN', 252867),
(425380, 'PTHR11552:SF111', NULL, NULL, NULL, NULL, 'GMC_OXRDTASE_N DOMAIN-CONTAINING PROTEIN', 252867),
(425381, 'PTHR11552:SF210', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G00610)-RELATED', 252867),
(425382, 'PTHR11552:SF158', NULL, NULL, NULL, NULL, 'GH23626P-RELATED', 252867),
(425383, 'PTHR11552:SF213', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE-RELATED', 252867),
(425384, 'PTHR11552:SF138', NULL, NULL, NULL, NULL, 'DEHYDROGENASE PKFF-RELATED', 252867),
(425385, 'PTHR11552:SF215', NULL, NULL, NULL, NULL, 'FI02019P', 252867),
(425386, 'PTHR11552:SF115', NULL, NULL, NULL, NULL, 'DEHYDROGENASE XPTC-RELATED', 252867),
(425387, 'PTHR11552:SF78', NULL, NULL, NULL, NULL, 'GMC_OXRDTASE_N DOMAIN-CONTAINING PROTEIN', 252867),
(425388, 'PTHR11552:SF217', NULL, NULL, NULL, NULL, 'GLUCOSE DEHYDROGENASE [FAD, QUINONE]', 252867),
(425389, 'PTHR11552:SF216', NULL, NULL, NULL, NULL, 'GLUCOSE DEHYDROGENASE [FAD, QUINONE]-LIKE PROTEIN', 252867),
(425390, 'PTHR11552', NULL, NULL, NULL, NULL, 'GLUCOSE-METHANOL-CHOLINE  GMC  OXIDOREDUCTASE', 252867),
(425391, 'PTHR11552:SF152', NULL, NULL, NULL, NULL, 'OXIDASE (CODA), PUTATIVE (AFU_ORTHOLOGUE AFUA_8G04090)-RELATED', 252867),
(425392, 'PTHR11552:SF154', NULL, NULL, NULL, NULL, 'FI04917P', 252867);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(425393, 'PTHR11552:SF208', NULL, NULL, NULL, NULL, 'RE36204P-RELATED', 252867),
(425394, 'PTHR11552:SF123', NULL, NULL, NULL, NULL, 'GMC OXIDOREDUCTASE (AFU_ORTHOLOGUE AFUA_2G01770)', 252867),
(425395, 'PTHR11552:SF188', NULL, NULL, NULL, NULL, 'NEITHER INACTIVATION NOR AFTERPOTENTIAL PROTEIN G', 252867),
(425396, 'PTHR11552:SF100', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G00630)-RELATED', 252867),
(425397, 'PTHR11552:SF147', NULL, NULL, NULL, NULL, 'CHOLINE DEHYDROGENASE, MITOCHONDRIAL', 252867),
(425398, 'PTHR11552:SF201', NULL, NULL, NULL, NULL, 'GMC_OXRDTASE_N DOMAIN-CONTAINING PROTEIN', 252867),
(425399, 'PTHR11552:SF226', NULL, NULL, NULL, NULL, 'RE28171P', 252867),
(425400, 'PTHR11552:SF228', NULL, NULL, NULL, NULL, 'GMC_OXRDTASE_N DOMAIN-CONTAINING PROTEIN', 252867),
(425401, 'PTHR11552:SF227', NULL, NULL, NULL, NULL, 'GLUCOSE DEHYDROGENASE [FAD, QUINONE]-LIKE PROTEIN', 252867),
(425402, 'PTHR11552:SF80', NULL, NULL, NULL, NULL, 'GMC_OXRDTASE_N DOMAIN-CONTAINING PROTEIN', 252867),
(425403, 'PTHR11552:SF186', NULL, NULL, NULL, NULL, 'GMC_OXRDTASE_N DOMAIN-CONTAINING PROTEIN', 252867),
(425404, 'PTHR12083', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL POLYNUCLEOTIDE PHOSPHATASE/KINASE', 252868),
(425405, 'PTHR12083:SF9', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL POLYNUCLEOTIDE PHOSPHATASE/KINASE', 252868),
(425406, 'PTHR12083:SF18', NULL, NULL, NULL, NULL, '', 252868),
(425407, 'PTHR22648:SF0', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION/ANTITERMINATION PROTEIN NUSA', 252869),
(425408, 'PTHR22648', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR NUSA', 252869),
(425409, 'PTHR30221:SF20', NULL, NULL, NULL, NULL, 'MSCS MECHANOSENSITIVE ION CHANNEL', 252870),
(425410, 'PTHR30221:SF8', NULL, NULL, NULL, NULL, 'SMALL CONDUCTANCE MECHANOSENSITIVE ION CHANNEL PROTEIN MSCS FAMILY', 252870),
(425411, 'PTHR30221:SF3', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL FAMILY PROTEIN', 252870),
(425412, 'PTHR30221:SF19', NULL, NULL, NULL, NULL, 'SMALL-CONDUCTANCE MECHANOSENSITIVE CHANNEL', 252870),
(425413, 'PTHR30221:SF18', NULL, NULL, NULL, NULL, 'SLL0590 PROTEIN', 252870),
(425414, 'PTHR30221:SF1', NULL, NULL, NULL, NULL, 'SMALL-CONDUCTANCE MECHANOSENSITIVE CHANNEL', 252870),
(425415, 'PTHR30221', NULL, NULL, NULL, NULL, 'SMALL-CONDUCTANCE MECHANOSENSITIVE CHANNEL', 252870),
(425416, 'PTHR42774:SF15', NULL, NULL, NULL, NULL, 'PFKB FAMILY CARBOHYDRATE KINASE', 252871),
(425417, 'PTHR42774:SF3', NULL, NULL, NULL, NULL, 'PFKB-LIKE CARBOHYDRATE KINASE FAMILY PROTEIN', 252871),
(425418, 'PTHR42774:SF14', NULL, NULL, NULL, NULL, '', 252871),
(425419, 'PTHR42774:SF9', NULL, NULL, NULL, NULL, 'PFKB-LIKE CARBOHYDRATE KINASE FAMILY PROTEIN', 252871),
(425420, 'PTHR42774:SF7', NULL, NULL, NULL, NULL, 'PFKB FAMILY CARBOHYDRATE KINASE', 252871),
(425421, 'PTHR42774:SF10', NULL, NULL, NULL, NULL, 'RIBOKINASE-LIKE ISOFORM X1', 252871),
(425422, 'PTHR42774:SF13', NULL, NULL, NULL, NULL, 'PFKB FAMILY CARBOHYDRATE KINASE', 252871),
(425423, 'PTHR42774:SF12', NULL, NULL, NULL, NULL, '', 252871),
(425424, 'PTHR42774', NULL, NULL, NULL, NULL, 'PHOSPHOTRANSFERASE SYSTEM TRANSPORT PROTEIN', 252871),
(425425, 'PTHR21196:SF1', NULL, NULL, NULL, NULL, 'U7 SNRNA-ASSOCIATED SM-LIKE PROTEIN LSM10', 252872),
(425426, 'PTHR21196', NULL, NULL, NULL, NULL, 'U7 SNRNA-ASSOCIATED SM-LIKE PROTEIN LSM10', 252872),
(425427, 'PTHR47553:SF1', NULL, NULL, NULL, NULL, 'FYVE-TYPE DOMAIN-CONTAINING PROTEIN', 252873),
(425428, 'PTHR47553', NULL, NULL, NULL, NULL, 'MYOSIN-11', 252873),
(425429, 'PTHR16830:SF19', NULL, NULL, NULL, NULL, '', 252874),
(425430, 'PTHR16830:SF1', NULL, NULL, NULL, NULL, 'FYN-BINDING PROTEIN 2', 252874),
(425431, 'PTHR16830:SF22', NULL, NULL, NULL, NULL, '', 252874),
(425432, 'PTHR16830:SF11', NULL, NULL, NULL, NULL, 'PML-RARA-REGULATED ADAPTER MOLECULE 1', 252874),
(425433, 'PTHR16830:SF20', NULL, NULL, NULL, NULL, 'SI:CH211-188C16.1', 252874),
(425434, 'PTHR16830', NULL, NULL, NULL, NULL, 'SH2 CONTAINING ADAPTOR PRAM-1 RELATED', 252874),
(425435, 'PTHR16830:SF13', NULL, NULL, NULL, NULL, 'FYN-BINDING PROTEIN 1', 252874);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(425436, 'PTHR16830:SF12', NULL, NULL, NULL, NULL, 'FYN BINDING PROTEIN 1', 252874),
(425437, 'PTHR10369:SF3', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L36A', 252875),
(425438, 'PTHR10369:SF40', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L44-LIKE', 252875),
(425439, 'PTHR10369:SF32', NULL, NULL, NULL, NULL, '', 252875),
(425440, 'PTHR10369:SF43', NULL, NULL, NULL, NULL, '', 252875),
(425441, 'PTHR10369:SF42', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L36A', 252875),
(425442, 'PTHR10369:SF45', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L36A-LIKE', 252875),
(425443, 'PTHR10369:SF44', NULL, NULL, NULL, NULL, '', 252875),
(425444, 'PTHR10369', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L36A/L44', 252875),
(425445, 'PTHR10369:SF47', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L36A', 252875),
(425446, 'PTHR10369:SF35', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L36A', 252875),
(425447, 'PTHR10369:SF46', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L44', 252875),
(425448, 'PTHR10369:SF48', NULL, NULL, NULL, NULL, 'OS07G0450000 PROTEIN', 252875),
(425449, 'PTHR10369:SF37', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L44-LIKE', 252875),
(425450, 'PTHR10369:SF6', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L36A', 252875),
(425451, 'PTHR10369:SF39', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L44-LIKE', 252875),
(425452, 'PTHR21545', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MLR1/2', 252876),
(425453, 'PTHR21545:SF10', NULL, NULL, NULL, NULL, 'LIGAND-DEPENDENT NUCLEAR RECEPTOR COREPRESSOR-LIKE PROTEIN', 252876),
(425454, 'PTHR21545:SF14', NULL, NULL, NULL, NULL, 'LIGAND-DEPENDENT COREPRESSOR', 252876),
(425455, 'PTHR21545:SF13', NULL, NULL, NULL, NULL, 'ECDYSONE-INDUCED PROTEIN 93F, ISOFORM C', 252876),
(425456, 'PTHR42648:SF5', NULL, NULL, NULL, NULL, 'TRANSPOSASE INSF FOR INSERTION SEQUENCE IS3A-RELATED', 252877),
(425457, 'PTHR42648:SF11', NULL, NULL, NULL, NULL, 'TRANSPOSON TY4-P GAG-POL POLYPROTEIN', 252877),
(425458, 'PTHR42648:SF3', NULL, NULL, NULL, NULL, 'PROTEIN YLBG-RELATED', 252877),
(425459, 'PTHR42648:SF12', NULL, NULL, NULL, NULL, 'BLL1855 PROTEIN', 252877),
(425460, 'PTHR42648', NULL, NULL, NULL, NULL, 'TRANSPOSASE, PUTATIVE-RELATED', 252877),
(425461, 'PTHR42648:SF15', NULL, NULL, NULL, NULL, 'BLL8290 PROTEIN', 252877),
(425462, 'PTHR42648:SF16', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 252877),
(425463, 'PTHR42648:SF17', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', 252877),
(425464, 'PTHR48084', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE OXIDOREDUCTASE SUBUNIT KORB-RELATED', 252878),
(425465, 'PTHR48084:SF3', NULL, NULL, NULL, NULL, 'SUBUNIT OF PYRUVATE:FLAVODOXIN OXIDOREDUCTASE-RELATED', 252878),
(425466, 'PTHR48084:SF4', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE OXIDOREDUCTASE SUBUNIT KORB', 252878),
(425467, 'PTHR48084:SF5', NULL, NULL, NULL, NULL, 'BLR6744 PROTEIN', 252878),
(425468, 'PTHR48084:SF1', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE SYNTHASE SUBUNIT KORB', 252878),
(425469, 'PTHR48084:SF2', NULL, NULL, NULL, NULL, 'PYRUVATE FERREDOXIN/FLAVODOXIN OXIDOREDUCTASE, BETA SUBUNIT', 252878),
(425470, 'PTHR14402:SF18', NULL, NULL, NULL, NULL, 'RECEPTOR-TRANSPORTING PROTEIN 2', 252879),
(425471, 'PTHR14402:SF8', NULL, NULL, NULL, NULL, 'RECEPTOR-TRANSPORTING PROTEIN 4', 252879),
(425472, 'PTHR14402:SF9', NULL, NULL, NULL, NULL, 'RECEPTOR-TRANSPORTING PROTEIN 3', 252879),
(425473, 'PTHR14402:SF20', NULL, NULL, NULL, NULL, 'ZF-3CXXC DOMAIN-CONTAINING PROTEIN', 252879),
(425474, 'PTHR14402:SF10', NULL, NULL, NULL, NULL, 'ZF-3CXXC DOMAIN-CONTAINING PROTEIN', 252879),
(425475, 'PTHR14402', NULL, NULL, NULL, NULL, 'RECEPTOR TRANSPORTING PROTEIN', 252879),
(425476, 'PTHR14402:SF19', NULL, NULL, NULL, NULL, 'RECEPTOR-TRANSPORTING PROTEIN 1', 252879),
(425477, 'PTHR14402:SF2', NULL, NULL, NULL, NULL, 'RECEPTOR-TRANSPORTING PROTEIN 5', 252879),
(425478, 'PTHR33799:SF1', NULL, NULL, NULL, NULL, 'PHOSPHOTRANSFERASE ENZYME IIA COMPONENT YADI-RELATED', 252880),
(425479, 'PTHR33799', NULL, NULL, NULL, NULL, 'PTS PERMEASE-RELATED-RELATED', 252880);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(425480, 'PTHR33799:SF8', NULL, NULL, NULL, NULL, 'EIIAB-MAN', 252880),
(425481, 'PTHR33799:SF9', NULL, NULL, NULL, NULL, 'N-ACETYLGALACTOSAMINE-SPECIFIC PHOSPHOTRANSFERASE ENZYME IIB COMPONENT 1-RELATED', 252880),
(425482, 'PTHR33799:SF5', NULL, NULL, NULL, NULL, 'PTS PERMEASE-RELATED', 252880),
(425483, 'PTHR33799:SF7', NULL, NULL, NULL, NULL, 'PHOSPHOTRANSFERASE SYSTEM SUGAR-SPECIFIC EIIB COMPONENT', 252880),
(425484, 'PTHR11437:SF61', NULL, NULL, NULL, NULL, '', 252881),
(425485, 'PTHR11437:SF4', NULL, NULL, NULL, NULL, 'RIBONUCLEASE K6', 252881),
(425486, 'PTHR11437:SF62', NULL, NULL, NULL, NULL, 'NON-SECRETORY RIBONUCLEASE', 252881),
(425487, 'PTHR11437:SF3', NULL, NULL, NULL, NULL, 'EOSINOPHIL CATIONIC PROTEIN', 252881),
(425488, 'PTHR11437:SF60', NULL, NULL, NULL, NULL, 'ANGIOGENIN', 252881),
(425489, 'PTHR11437', NULL, NULL, NULL, NULL, 'RIBONUCLEASE', 252881),
(425490, 'PTHR11437:SF10', NULL, NULL, NULL, NULL, 'RNASE 2-RELATED', 252881),
(425491, 'PTHR11437:SF11', NULL, NULL, NULL, NULL, 'INACTIVE RIBONUCLEASE-LIKE PROTEIN 13-RELATED', 252881),
(425492, 'PTHR11437:SF22', NULL, NULL, NULL, NULL, 'RIBONUCLEASE 11-RELATED', 252881),
(425493, 'PTHR11437:SF63', NULL, NULL, NULL, NULL, 'INACTIVE RIBONUCLEASE-LIKE PROTEIN 10', 252881),
(425494, 'PTHR11437:SF64', NULL, NULL, NULL, NULL, 'RNASE_PC DOMAIN-CONTAINING PROTEIN', 252881),
(425495, 'PTHR11437:SF31', NULL, NULL, NULL, NULL, 'RIBONUCLEASE 7', 252881),
(425496, 'PTHR11437:SF20', NULL, NULL, NULL, NULL, 'INACTIVE RIBONUCLEASE-LIKE PROTEIN 12-RELATED', 252881),
(425497, 'PTHR11437:SF53', NULL, NULL, NULL, NULL, 'RIBONUCLEASE 4', 252881),
(425498, 'PTHR11437:SF25', NULL, NULL, NULL, NULL, 'RIBONUCLEASE 8', 252881),
(425499, 'PTHR11437:SF14', NULL, NULL, NULL, NULL, 'INACTIVE RIBONUCLEASE-LIKE PROTEIN 9', 252881),
(425500, 'PTHR11437:SF59', NULL, NULL, NULL, NULL, 'ANGIOGENIN-RELATED', 252881),
(425501, 'PTHR11437:SF24', NULL, NULL, NULL, NULL, 'RIBONUCLEASE PANCREATIC', 252881),
(425502, 'PTHR33623', NULL, NULL, NULL, NULL, 'OS04G0572500 PROTEIN', 252882),
(425503, 'PTHR33623:SF17', NULL, NULL, NULL, NULL, 'DUF4378 DOMAIN PROTEIN', 252882),
(425504, 'PTHR33623:SF18', NULL, NULL, NULL, NULL, 'DUF4378 DOMAIN-CONTAINING PROTEIN', 252882),
(425505, 'PTHR33623:SF15', NULL, NULL, NULL, NULL, 'GAR2-LIKE PROTEIN', 252882),
(425506, 'PTHR33623:SF16', NULL, NULL, NULL, NULL, '', 252882),
(425507, 'PTHR33623:SF13', NULL, NULL, NULL, NULL, 'NUCLEOLIN-LIKE PROTEIN', 252882),
(425508, 'PTHR33623:SF14', NULL, NULL, NULL, NULL, 'OS10G0524000 PROTEIN', 252882),
(425509, 'PTHR33623:SF11', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252882),
(425510, 'PTHR33623:SF22', NULL, NULL, NULL, NULL, 'ZINC-REGULATED PROTEIN 8-LIKE', 252882),
(425511, 'PTHR33623:SF20', NULL, NULL, NULL, NULL, 'BNAANNG23720D PROTEIN', 252882),
(425512, 'PTHR33623:SF5', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SETD1B-LIKE PROTEIN', 252882),
(425513, 'PTHR33623:SF4', NULL, NULL, NULL, NULL, 'OS04G0572500 PROTEIN', 252882),
(425514, 'PTHR36917', NULL, NULL, NULL, NULL, 'INTRACELLULAR SEPTATION PROTEIN A-RELATED', 252883),
(425515, 'PTHR36917:SF1', NULL, NULL, NULL, NULL, 'INTRACELLULAR SEPTATION PROTEIN A-RELATED', 252883),
(425516, 'PTHR34801', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252884),
(425517, 'PTHR34801:SF6', NULL, NULL, NULL, NULL, 'SLL1620 PROTEIN', 252884),
(425518, 'PTHR34801:SF5', NULL, NULL, NULL, NULL, '', 252884),
(425519, 'PTHR34801:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 252884),
(425520, 'PTHR46035:SF2', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 252885),
(425521, 'PTHR46035:SF1', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 4', 252885),
(425522, 'PTHR46035:SF4', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 4', 252885),
(425523, 'PTHR46035', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 4', 252885),
(425524, 'PTHR46035:SF3', NULL, NULL, NULL, NULL, 'TRANSLOCATION PROTEIN SEC72', 252885),
(425525, 'PTHR31908:SF10', NULL, NULL, NULL, NULL, 'PROTEIN CROWDED NUCLEI 1-LIKE', 252886); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(425526, 'PTHR31908:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CROWDED NUCLEI 4', 252886),
(425527, 'PTHR31908:SF12', NULL, NULL, NULL, NULL, 'PEPT_C1 DOMAIN-CONTAINING PROTEIN', 252886),
(425528, 'PTHR31908', NULL, NULL, NULL, NULL, 'PROTEIN CROWDED NUCLEI 4', 252886),
(425529, 'PTHR31908:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CROWDED NUCLEI 3', 252886),
(425530, 'PTHR31908:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CROWDED NUCLEI 2', 252886),
(425531, 'PTHR31908:SF11', NULL, NULL, NULL, NULL, 'PROTEIN CROWDED NUCLEI 1', 252886),
(425532, 'PTHR47934', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN PET309, MITOCHONDRIAL', 252887),
(425533, 'PTHR47934:SF8', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 252887),
(425534, 'PTHR47934:SF9', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 252887),
(425535, 'PTHR47934:SF6', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL GROUP I INTRON SPLICING FACTOR CCM1-RELATED', 252887),
(425536, 'PTHR47934:SF7', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE (PPR) REPEAT PROTEIN', 252887),
(425537, 'PTHR47934:SF4', NULL, NULL, NULL, NULL, 'OS08G0191900 PROTEIN', 252887),
(425538, 'PTHR47934:SF5', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 252887),
(425539, 'PTHR47934:SF15', NULL, NULL, NULL, NULL, 'OS02G0644600 PROTEIN', 252887),
(425540, 'PTHR47934:SF26', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN-CONTAINING PROTEIN-RELATED', 252887),
(425541, 'PTHR47934:SF2', NULL, NULL, NULL, NULL, 'OS07G0671200 PROTEIN', 252887),
(425542, 'PTHR47934:SF16', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT PROTEIN (AFU_ORTHOLOGUE AFUA_5G07770)', 252887),
(425543, 'PTHR47934:SF3', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN-RELATED', 252887),
(425544, 'PTHR47934:SF17', NULL, NULL, NULL, NULL, 'IMD PROTEIN', 252887),
(425545, 'PTHR47934:SF18', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 252887),
(425546, 'PTHR47934:SF19', NULL, NULL, NULL, NULL, '', 252887),
(425547, 'PTHR47934:SF20', NULL, NULL, NULL, NULL, 'PPR DOMAIN PROTEIN', 252887),
(425548, 'PTHR47934:SF21', NULL, NULL, NULL, NULL, 'OS01G0546500 PROTEIN', 252887),
(425549, 'PTHR47934:SF22', NULL, NULL, NULL, NULL, 'OS07G0300200 PROTEIN', 252887),
(425550, 'PTHR47934:SF23', NULL, NULL, NULL, NULL, '', 252887),
(425551, 'PTHR47934:SF12', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN MITOCHONDRIAL', 252887),
(425552, 'PTHR47934:SF13', NULL, NULL, NULL, NULL, 'OS06G0125300 PROTEIN', 252887),
(425553, 'PTHR47934:SF24', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN MITOCHONDRIAL', 252887),
(425554, 'PTHR47934:SF14', NULL, NULL, NULL, NULL, 'OS04G0583101 PROTEIN', 252887),
(425555, 'PTHR47934:SF25', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN MITOCHONDRIAL', 252887),
(425556, 'PTHR33624:SF2', NULL, NULL, NULL, NULL, 'SIGMA FACTOR BINDING PROTEIN 1, CHLOROPLASTIC', 252888),
(425557, 'PTHR33624', NULL, NULL, NULL, NULL, 'SIGMA FACTOR BINDING PROTEIN 1, CHLOROPLASTIC', 252888),
(425558, 'PTHR33624:SF22', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 252888),
(425559, 'PTHR33624:SF21', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 252888),
(425560, 'PTHR33624:SF20', NULL, NULL, NULL, NULL, 'OS05G0491700 PROTEIN', 252888),
(425561, 'PTHR33624:SF15', NULL, NULL, NULL, NULL, 'SIGMA FACTOR BINDING PROTEIN 2, CHLOROPLASTIC', 252888),
(425562, 'PTHR33624:SF26', NULL, NULL, NULL, NULL, 'VQ MOTIF FAMILY PROTEIN', 252888),
(425563, 'PTHR33624:SF25', NULL, NULL, NULL, NULL, 'VQ MOTIF PROTEIN', 252888),
(425564, 'PTHR33624:SF14', NULL, NULL, NULL, NULL, 'OS07G0687400 PROTEIN', 252888),
(425565, 'PTHR33624:SF24', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 252888),
(425566, 'PTHR33624:SF29', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 252888),
(425567, 'PTHR33624:SF18', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 252888),
(425568, 'PTHR33624:SF17', NULL, NULL, NULL, NULL, 'VQ MOTIF PROTEIN', 252888);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(425569, 'PTHR33624:SF28', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 252888),
(425570, 'PTHR33624:SF27', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 252888),
(425571, 'PTHR48194', NULL, NULL, NULL, NULL, 'FINGER PROTEIN, PUTATIVE-RELATED', 252889),
(425572, 'PTHR48194:SF2', NULL, NULL, NULL, NULL, 'FINGER PROTEIN, PUTATIVE-RELATED', 252889),
(425573, 'PTHR48194:SF1', NULL, NULL, NULL, NULL, '', 252889),
(425574, 'PTHR48194:SF3', NULL, NULL, NULL, NULL, 'INTEGRATOR COMPLEX SUBUNIT 10-LIKE PROTEIN-RELATED', 252889),
(425575, 'PTHR42945:SF9', NULL, NULL, NULL, NULL, 'HISTIDINE BIOSYNTHESIS BIFUNCTIONAL PROTEIN HISIE', 252890),
(425576, 'PTHR42945:SF11', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYL-AMP CYCLOHYDROLASE', 252890),
(425577, 'PTHR42945:SF7', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYL-AMP CYCLOHYDROLASE', 252890),
(425578, 'PTHR42945:SF1', NULL, NULL, NULL, NULL, 'HISTIDINE BIOSYNTHESIS BIFUNCTIONAL PROTEIN HIS7', 252890),
(425579, 'PTHR42945', NULL, NULL, NULL, NULL, 'HISTIDINE BIOSYNTHESIS BIFUNCTIONAL PROTEIN', 252890),
(425580, 'PTHR28608:SF1', NULL, NULL, NULL, NULL, 'INTEGRATOR COMPLEX SUBUNIT 2', 252891),
(425581, 'PTHR28608', NULL, NULL, NULL, NULL, 'INTEGRATOR COMPLEX SUBUNIT 2', 252891),
(425582, 'PTHR11008:SF15', NULL, NULL, NULL, NULL, 'AGAP001984-PA', 252892),
(425583, 'PTHR11008:SF37', NULL, NULL, NULL, NULL, 'AGAP001353-PA', 252892),
(425584, 'PTHR11008:SF14', NULL, NULL, NULL, NULL, 'CIRCADIAN CLOCK-CONTROLLED PROTEIN-LIKE PROTEIN', 252892),
(425585, 'PTHR11008:SF25', NULL, NULL, NULL, NULL, 'IP09473P-RELATED', 252892),
(425586, 'PTHR11008:SF13', NULL, NULL, NULL, NULL, 'FI04421P', 252892),
(425587, 'PTHR11008:SF35', NULL, NULL, NULL, NULL, 'PROTEIN TAKEOUT-LIKE PROTEIN', 252892),
(425588, 'PTHR11008:SF34', NULL, NULL, NULL, NULL, 'AGAP003573-PA', 252892),
(425589, 'PTHR11008:SF33', NULL, NULL, NULL, NULL, 'PROTEIN TAKEOUT-LIKE PROTEIN', 252892),
(425590, 'PTHR11008:SF32', NULL, NULL, NULL, NULL, 'CIRCADIAN CLOCK-CONTROLLED PROTEIN DAYWAKE-RELATED', 252892),
(425591, 'PTHR11008', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252892),
(425592, 'PTHR11008:SF31', NULL, NULL, NULL, NULL, 'AGAP001983-PA', 252892),
(425593, 'PTHR11008:SF9', NULL, NULL, NULL, NULL, 'RE70318P', 252892),
(425594, 'PTHR11008:SF18', NULL, NULL, NULL, NULL, 'BCDNA.GH05536-RELATED', 252892),
(425595, 'PTHR11008:SF29', NULL, NULL, NULL, NULL, 'AGAP001354-PA', 252892),
(425596, 'PTHR11008:SF39', NULL, NULL, NULL, NULL, 'AGAP012674-PA', 252892),
(425597, 'PTHR11008:SF38', NULL, NULL, NULL, NULL, 'RE08075P', 252892),
(425598, 'PTHR33344:SF12', NULL, NULL, NULL, NULL, '', 252893),
(425599, 'PTHR33344:SF8', NULL, NULL, NULL, NULL, '', 252893),
(425600, 'PTHR33344:SF7', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 252893),
(425601, 'PTHR33344:SF10', NULL, NULL, NULL, NULL, 'OS06G0214100 PROTEIN', 252893),
(425602, 'PTHR33344:SF1', NULL, NULL, NULL, NULL, 'OS02G0761600 PROTEIN', 252893),
(425603, 'PTHR33344', NULL, NULL, NULL, NULL, 'OS02G0761600 PROTEIN', 252893),
(425604, 'PTHR25464:SF2', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 252894),
(425605, 'PTHR25464:SF3', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM32', 252894),
(425606, 'PTHR25464:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF152', 252894),
(425607, 'PTHR25464', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 2-LIKE PROTEIN', 252894),
(425608, 'PTHR25464:SF8', NULL, NULL, NULL, NULL, 'NHL REPEAT CONTAINING 4', 252894),
(425609, 'PTHR25464:SF9', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 2-LIKE PROTEIN', 252894),
(425610, 'PTHR13195', NULL, NULL, NULL, NULL, 'PSEUDOURIDINE SYNTHASE-RELATED', 252895),
(425611, 'PTHR13195:SF0', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL MRNA PSEUDOURIDINE SYNTHASE TRUB2', 252895),
(425612, 'PTHR11364:SF25', NULL, NULL, NULL, NULL, '3-MERCAPTOPYRUVATE SULFURTRANSFERASE', 252896),
(425613, 'PTHR11364:SF36', NULL, NULL, NULL, NULL, 'SULFURTRANSFERASE', 252896),
(425614, 'PTHR11364:SF35', NULL, NULL, NULL, NULL, 'RHODANESE-LIKE PROTEIN', 252896);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(425615, 'PTHR11364:SF27', NULL, NULL, NULL, NULL, 'SULFURTRANSFERASE', 252896),
(425616, 'PTHR11364:SF32', NULL, NULL, NULL, NULL, 'SULFURTRANSFERASE', 252896),
(425617, 'PTHR11364:SF12', NULL, NULL, NULL, NULL, 'OS02G0167100 PROTEIN', 252896),
(425618, 'PTHR11364:SF30', NULL, NULL, NULL, NULL, 'MERCAPTOPYRUVATE SULFURTRANSFERASE HOMOLOG', 252896),
(425619, 'PTHR11364:SF29', NULL, NULL, NULL, NULL, 'THIOSULFATE/3-MERCAPTOPYRUVATE SULFURTRANSFERASE 1, MITOCHONDRIAL-LIKE', 252896),
(425620, 'PTHR11364', NULL, NULL, NULL, NULL, 'THIOSULFATE SULFERTANSFERASE', 252896),
(425621, 'PTHR11364:SF7', NULL, NULL, NULL, NULL, 'THIOSULFATE SULFURTRANSFERASE MPST-1-RELATED', 252896),
(425622, 'PTHR11364:SF6', NULL, NULL, NULL, NULL, 'THIOSULFATE SULFURTRANSFERASE', 252896),
(425623, 'PTHR47310:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FLUORESCENT IN BLUE LIGHT, CHLOROPLASTIC', 252897),
(425624, 'PTHR47310', NULL, NULL, NULL, NULL, 'PROTEIN FLUORESCENT IN BLUE LIGHT, CHLOROPLASTIC', 252897),
(425625, 'PTHR47310:SF8', NULL, NULL, NULL, NULL, 'OS01G0510600 PROTEIN', 252897),
(425626, 'PTHR47310:SF6', NULL, NULL, NULL, NULL, 'PROTEIN FLUORESCENT IN BLUE LIGHT, CHLOROPLASTIC-LIKE', 252897),
(425627, 'PTHR31077:SF1', NULL, NULL, NULL, NULL, 'U4/U6.U5 SMALL NUCLEAR RIBONUCLEOPROTEIN 27 KDA PROTEIN', 252898),
(425628, 'PTHR31077:SF2', NULL, NULL, NULL, NULL, 'U4/U6.U5 SMALL NUCLEAR RIBONUCLEOPROTEIN 27 KDA PROTEIN', 252898),
(425629, 'PTHR31077:SF4', NULL, NULL, NULL, NULL, 'SNRNP27 DOMAIN-CONTAINING PROTEIN', 252898),
(425630, 'PTHR31077:SF7', NULL, NULL, NULL, NULL, 'U4/U6.U5 SMALL NUCLEAR RIBONUCLEOPROTEIN 27 KDA PROTEIN', 252898),
(425631, 'PTHR31077', NULL, NULL, NULL, NULL, 'U4/U6.U5 SMALL NUCLEAR RIBONUCLEOPROTEIN 27 KDA PROTEIN', 252898),
(425632, 'PTHR19960:SF28', NULL, NULL, NULL, NULL, 'TEKTIN', 252899),
(425633, 'PTHR19960:SF29', NULL, NULL, NULL, NULL, 'TEKTIN-2', 252899),
(425634, 'PTHR19960:SF11', NULL, NULL, NULL, NULL, 'TEKTIN', 252899),
(425635, 'PTHR19960:SF23', NULL, NULL, NULL, NULL, 'TEKTIN-5', 252899),
(425636, 'PTHR19960:SF12', NULL, NULL, NULL, NULL, 'TEKTIN-4', 252899),
(425637, 'PTHR19960:SF24', NULL, NULL, NULL, NULL, 'TEKTIN-3', 252899),
(425638, 'PTHR19960:SF25', NULL, NULL, NULL, NULL, 'TEKTIN-1', 252899),
(425639, 'PTHR19960', NULL, NULL, NULL, NULL, 'TEKTIN', 252899),
(425640, 'PTHR19960:SF7', NULL, NULL, NULL, NULL, 'TEKTIN', 252899),
(425641, 'PTHR16470:SF0', NULL, NULL, NULL, NULL, 'UBIQUITIN DOMAIN-CONTAINING PROTEIN UBFD1', 252900),
(425642, 'PTHR16470', NULL, NULL, NULL, NULL, 'UBIQUITIN DOMAIN-CONTAINING PROTEIN UBFD1', 252900),
(425643, 'PTHR36062', NULL, NULL, NULL, NULL, 'OS01G0687300 PROTEIN', 252901),
(425644, 'PTHR36062:SF9', NULL, NULL, NULL, NULL, 'ISOFORM 2 OF F-BOX PROTEIN', 252901),
(425645, 'PTHR36062:SF8', NULL, NULL, NULL, NULL, 'OS01G0687300 PROTEIN', 252901),
(425646, 'PTHR36062:SF7', NULL, NULL, NULL, NULL, 'BNAA07G03600D PROTEIN', 252901),
(425647, 'PTHR36062:SF1', NULL, NULL, NULL, NULL, 'OS05G0552100 PROTEIN', 252901),
(425648, 'PTHR13247:SF0', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL FISSION 1 PROTEIN', 252902),
(425649, 'PTHR13247', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 11  TPR REPEAT PROTEIN 11', 252902),
(425650, 'PTHR13247:SF18', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL FISSION 1 PROTEIN A-LIKE', 252902),
(425651, 'PTHR13247:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL FISSION 1 PROTEIN', 252902),
(425652, 'PTHR13247:SF17', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL FISSION 1 PROTEIN', 252902),
(425653, 'PTHR13247:SF2', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL FISSION 1 PROTEIN', 252902),
(425654, 'PTHR13247:SF14', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL FISSION 1 PROTEIN', 252902),
(425655, 'PTHR13247:SF13', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL FISSION 1 PROTEIN B', 252902),
(425656, 'PTHR13247:SF11', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL FISSION 1 PROTEIN', 252902),
(425657, 'PTHR38434:SF1', NULL, NULL, NULL, NULL, 'BLL2549 PROTEIN', 252903),
(425658, 'PTHR38434', NULL, NULL, NULL, NULL, 'BLL2549 PROTEIN', 252903),
(425659, 'PTHR12162', NULL, NULL, NULL, NULL, 'NIBRIN-RELATED', 252904);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(425660, 'PTHR12162:SF0', NULL, NULL, NULL, NULL, 'NIBRIN', 252904),
(425661, 'PTHR12697:SF20', NULL, NULL, NULL, NULL, 'HEAT REPEAT-CONTAINING PROTEIN 4', 252905),
(425662, 'PTHR12697', NULL, NULL, NULL, NULL, 'PBS LYASE HEAT-LIKE PROTEIN', 252905),
(425663, 'PTHR12697:SF29', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 252905),
(425664, 'PTHR12697:SF15', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING PROTEIN', 252905),
(425665, 'PTHR12697:SF37', NULL, NULL, NULL, NULL, 'CONSERVED VIRULENCE FACTOR C', 252905),
(425666, 'PTHR12697:SF36', NULL, NULL, NULL, NULL, 'PHYCOCYANOBILIN LYASE SUBUNIT ALPHA', 252905),
(425667, 'PTHR12697:SF5', NULL, NULL, NULL, NULL, 'DEOXYHYPUSINE HYDROXYLASE', 252905),
(425668, 'PTHR14224:SF6', NULL, NULL, NULL, NULL, 'PREFERENTIALLY EXPRESSED ANTIGEN IN MELANOMA-LIKE PROTEIN 1', 252906),
(425669, 'PTHR14224:SF9', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 14', 252906),
(425670, 'PTHR14224:SF81', NULL, NULL, NULL, NULL, 'PRAME FAMILY MEMBER 1-RELATED', 252906),
(425671, 'PTHR14224:SF82', NULL, NULL, NULL, NULL, '', 252906),
(425672, 'PTHR14224:SF3', NULL, NULL, NULL, NULL, 'PRAME-LIKE 17-RELATED', 252906),
(425673, 'PTHR14224:SF2', NULL, NULL, NULL, NULL, 'PRAME FAMILY MEMBER 17', 252906),
(425674, 'PTHR14224:SF86', NULL, NULL, NULL, NULL, '', 252906),
(425675, 'PTHR14224:SF42', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 75A', 252906),
(425676, 'PTHR14224:SF1', NULL, NULL, NULL, NULL, 'PRAME-LIKE, X-LINKED 1', 252906),
(425677, 'PTHR14224:SF22', NULL, NULL, NULL, NULL, 'OOG4 PROTEIN-RELATED', 252906),
(425678, 'PTHR14224:SF24', NULL, NULL, NULL, NULL, 'MELANOMA ANTIGEN PREFERENTIALLY EXPRESSED IN TUMORS', 252906),
(425679, 'PTHR14224:SF25', NULL, NULL, NULL, NULL, '4732496O08RIK PROTEIN', 252906),
(425680, 'PTHR14224:SF26', NULL, NULL, NULL, NULL, 'PRAME-LIKE 6', 252906),
(425681, 'PTHR14224:SF27', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 14B', 252906),
(425682, 'PTHR14224:SF28', NULL, NULL, NULL, NULL, 'PRAME FAMILY MEMBER 10-RELATED', 252906),
(425683, 'PTHR14224', NULL, NULL, NULL, NULL, 'SIMILAR TO PREFERENTIALLY EXPRESSED ANTIGEN IN MELANOMA-LIKE 3', 252906),
(425684, 'PTHR14224:SF90', NULL, NULL, NULL, NULL, '', 252906),
(425685, 'PTHR14224:SF92', NULL, NULL, NULL, NULL, 'EXPRESSED SEQUENCE AV320801-RELATED', 252906),
(425686, 'PTHR14224:SF93', NULL, NULL, NULL, NULL, 'PRAME FAMILY MEMBER 20', 252906),
(425687, 'PTHR14224:SF94', NULL, NULL, NULL, NULL, 'PRAME-LIKE 36-RELATED', 252906),
(425688, 'PTHR14224:SF95', NULL, NULL, NULL, NULL, 'PRAME NUCLEAR RECEPTOR TRANSCRIPTIONAL REGULATOR', 252906),
(425689, 'PTHR14224:SF30', NULL, NULL, NULL, NULL, 'PRAME FAMILY MEMBER 7-RELATED', 252906),
(425690, 'PTHR14224:SF98', NULL, NULL, NULL, NULL, 'PRAME FAMILY MEMBER 2', 252906),
(425691, 'PTHR14224:SF76', NULL, NULL, NULL, NULL, 'PRAME FAMILY MEMBER 19', 252906),
(425692, 'PTHR14224:SF77', NULL, NULL, NULL, NULL, 'D5ERTD577E PROTEIN-RELATED', 252906),
(425693, 'PTHR14224:SF12', NULL, NULL, NULL, NULL, '', 252906),
(425694, 'PTHR14224:SF79', NULL, NULL, NULL, NULL, 'PRAME FAMILY MEMBER 18-RELATED', 252906),
(425695, 'PTHR14224:SF37', NULL, NULL, NULL, NULL, '', 252906),
(425696, 'PTHR14224:SF17', NULL, NULL, NULL, NULL, 'PRAME-LIKE 14-RELATED', 252906),
(425697, 'PTHR14224:SF19', NULL, NULL, NULL, NULL, 'PRAME FAMILY MEMBER 11-RELATED', 252906),
(425698, 'PTHR14224:SF102', NULL, NULL, NULL, NULL, '', 252906),
(425699, 'PTHR14224:SF104', NULL, NULL, NULL, NULL, 'RIKEN CDNA C130073F10 GENE-RELATED', 252906),
(425700, 'PTHR14224:SF103', NULL, NULL, NULL, NULL, 'PRAME-LIKE 16-RELATED', 252906),
(425701, 'PTHR14224:SF106', NULL, NULL, NULL, NULL, 'PRAME-LIKE 13', 252906),
(425702, 'PTHR14224:SF105', NULL, NULL, NULL, NULL, 'PRAME FAMILY MEMBER 12', 252906),
(425703, 'PTHR47322', NULL, NULL, NULL, NULL, 'SUSC HOMOLOG-RELATED', 252907),
(425704, 'PTHR47322:SF22', NULL, NULL, NULL, NULL, 'TONB-DEPENDENT RECEPTOR SUSC', 252907),
(425705, 'PTHR31235:SF62', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(425706, 'PTHR31235:SF61', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425707, 'PTHR31235:SF293', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425708, 'PTHR31235:SF172', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425709, 'PTHR31235:SF292', NULL, NULL, NULL, NULL, 'PEROXIDASE 48-RELATED', 252908),
(425710, 'PTHR31235:SF211', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425711, 'PTHR31235:SF298', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425712, 'PTHR31235:SF210', NULL, NULL, NULL, NULL, 'PEROXIDASE-RELATED', 252908),
(425713, 'PTHR31235:SF331', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425714, 'PTHR31235:SF177', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425715, 'PTHR31235:SF334', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425716, 'PTHR31235:SF179', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425717, 'PTHR31235:SF212', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425718, 'PTHR31235:SF294', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425719, 'PTHR31235:SF176', NULL, NULL, NULL, NULL, 'OS01G0293900 PROTEIN', 252908),
(425720, 'PTHR31235:SF297', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425721, 'PTHR31235:SF175', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425722, 'PTHR31235:SF219', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425723, 'PTHR31235:SF218', NULL, NULL, NULL, NULL, 'PEROXIDASE 26-RELATED', 252908),
(425724, 'PTHR31235:SF336', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425725, 'PTHR31235:SF217', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425726, 'PTHR31235:SF338', NULL, NULL, NULL, NULL, 'PEROXIDASE 62', 252908),
(425727, 'PTHR31235:SF216', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425728, 'PTHR31235:SF337', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425729, 'PTHR31235:SF71', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425730, 'PTHR31235:SF181', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425731, 'PTHR31235:SF50', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425732, 'PTHR31235:SF183', NULL, NULL, NULL, NULL, 'PEROXIDASE 28', 252908),
(425733, 'PTHR31235:SF182', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425734, 'PTHR31235:SF54', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425735, 'PTHR31235:SF57', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425736, 'PTHR31235:SF56', NULL, NULL, NULL, NULL, 'PEROXIDASE 19', 252908),
(425737, 'PTHR31235:SF222', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425738, 'PTHR31235:SF189', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425739, 'PTHR31235:SF343', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425740, 'PTHR31235:SF342', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425741, 'PTHR31235:SF221', NULL, NULL, NULL, NULL, 'PEROXIDASE 61-RELATED', 252908),
(425742, 'PTHR31235:SF224', NULL, NULL, NULL, NULL, 'PEROXIDASE 42', 252908),
(425743, 'PTHR31235:SF223', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425744, 'PTHR31235:SF184', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425745, 'PTHR31235:SF187', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425746, 'PTHR31235:SF229', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425747, 'PTHR31235:SF226', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425748, 'PTHR31235:SF347', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425749, 'PTHR31235:SF346', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425750, 'PTHR31235:SF225', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425751, 'PTHR31235:SF349', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425752, 'PTHR31235:SF227', NULL, NULL, NULL, NULL, 'PEROXIDASE 30', 252908),
(425753, 'PTHR31235:SF348', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425754, 'PTHR31235:SF390', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425755, 'PTHR31235:SF392', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425756, 'PTHR31235:SF271', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425757, 'PTHR31235:SF391', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425758, 'PTHR31235:SF41', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425759, 'PTHR31235:SF44', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908);
INSERT INTO "PUBLIC"."MODEL" VALUES
(425760, 'PTHR31235:SF46', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425761, 'PTHR31235:SF277', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425762, 'PTHR31235:SF398', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425763, 'PTHR31235:SF310', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425764, 'PTHR31235:SF156', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425765, 'PTHR31235:SF397', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425766, 'PTHR31235:SF276', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425767, 'PTHR31235:SF158', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425768, 'PTHR31235:SF279', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425769, 'PTHR31235:SF312', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425770, 'PTHR31235:SF399', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425771, 'PTHR31235:SF49', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425772, 'PTHR31235:SF394', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425773, 'PTHR31235:SF272', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425774, 'PTHR31235:SF393', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425775, 'PTHR31235:SF396', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425776, 'PTHR31235:SF274', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425777, 'PTHR31235:SF395', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425778, 'PTHR31235:SF314', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425779, 'PTHR31235:SF316', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425780, 'PTHR31235:SF315', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425781, 'PTHR31235:SF280', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425782, 'PTHR31235:SF31', NULL, NULL, NULL, NULL, 'PEROXIDASE 1', 252908),
(425783, 'PTHR31235:SF282', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425784, 'PTHR31235:SF281', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425785, 'PTHR31235:SF35', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425786, 'PTHR31235:SF320', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425787, 'PTHR31235:SF287', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425788, 'PTHR31235:SF36', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425789, 'PTHR31235:SF39', NULL, NULL, NULL, NULL, 'PEROXIDASE 39', 252908),
(425790, 'PTHR31235:SF323', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425791, 'PTHR31235:SF38', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425792, 'PTHR31235:SF289', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425793, 'PTHR31235:SF163', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425794, 'PTHR31235:SF284', NULL, NULL, NULL, NULL, 'PEROXIDASE 69', 252908),
(425795, 'PTHR31235:SF286', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425796, 'PTHR31235:SF329', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425797, 'PTHR31235:SF328', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425798, 'PTHR31235', NULL, NULL, NULL, NULL, 'PEROXIDASE 25-RELATED', 252908),
(425799, 'PTHR31235:SF209', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425800, 'PTHR31235:SF325', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425801, 'PTHR31235:SF204', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425802, 'PTHR31235:SF203', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425803, 'PTHR31235:SF327', NULL, NULL, NULL, NULL, 'PEROXIDASE 27', 252908),
(425804, 'PTHR31235:SF206', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425805, 'PTHR31235:SF205', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425806, 'PTHR31235:SF326', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425807, 'PTHR31235:SF22', NULL, NULL, NULL, NULL, 'PEROXIDASE 47', 252908),
(425808, 'PTHR31235:SF21', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425809, 'PTHR31235:SF255', NULL, NULL, NULL, NULL, 'CATIONIC PEROXIDASE SPC4', 252908),
(425810, 'PTHR31235:SF376', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425811, 'PTHR31235:SF26', NULL, NULL, NULL, NULL, 'PEROXIDASE 2', 252908),
(425812, 'PTHR31235:SF375', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425813, 'PTHR31235:SF254', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(425814, 'PTHR31235:SF411', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425815, 'PTHR31235:SF256', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425816, 'PTHR31235:SF410', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425817, 'PTHR31235:SF250', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425818, 'PTHR31235:SF374', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425819, 'PTHR31235:SF373', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425820, 'PTHR31235:SF259', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425821, 'PTHR31235:SF258', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425822, 'PTHR31235:SF9', NULL, NULL, NULL, NULL, 'PEROXIDASE 18-RELATED', 252908),
(425823, 'PTHR31235:SF381', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425824, 'PTHR31235:SF380', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425825, 'PTHR31235:SF11', NULL, NULL, NULL, NULL, 'PEROXIDASE 21', 252908),
(425826, 'PTHR31235:SF13', NULL, NULL, NULL, NULL, 'PEROXIDASE 60', 252908),
(425827, 'PTHR31235:SF8', NULL, NULL, NULL, NULL, 'PEROXIDASE 7', 252908),
(425828, 'PTHR31235:SF12', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425829, 'PTHR31235:SF387', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425830, 'PTHR31235:SF15', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425831, 'PTHR31235:SF386', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425832, 'PTHR31235:SF265', NULL, NULL, NULL, NULL, 'PEROXIDASE 64', 252908),
(425833, 'PTHR31235:SF301', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425834, 'PTHR31235:SF389', NULL, NULL, NULL, NULL, 'PEROXIDASE 64', 252908),
(425835, 'PTHR31235:SF268', NULL, NULL, NULL, NULL, 'PEROXIDASE 70', 252908),
(425836, 'PTHR31235:SF388', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425837, 'PTHR31235:SF16', NULL, NULL, NULL, NULL, 'PEROXIDASE 43', 252908),
(425838, 'PTHR31235:SF383', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425839, 'PTHR31235:SF19', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425840, 'PTHR31235:SF262', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425841, 'PTHR31235:SF18', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425842, 'PTHR31235:SF261', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425843, 'PTHR31235:SF264', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425844, 'PTHR31235:SF385', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425845, 'PTHR31235:SF384', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425846, 'PTHR31235:SF306', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425847, 'PTHR31235:SF309', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425848, 'PTHR31235:SF308', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425849, 'PTHR31235:SF302', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425850, 'PTHR31235:SF305', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425851, 'PTHR31235:SF192', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425852, 'PTHR31235:SF83', NULL, NULL, NULL, NULL, 'PEROXIDASE 1-RELATED', 252908),
(425853, 'PTHR31235:SF194', NULL, NULL, NULL, NULL, 'PEROXIDASE 12', 252908),
(425854, 'PTHR31235:SF193', NULL, NULL, NULL, NULL, 'PEROXIDASE 13', 252908),
(425855, 'PTHR31235:SF87', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425856, 'PTHR31235:SF190', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425857, 'PTHR31235:SF233', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425858, 'PTHR31235:SF354', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425859, 'PTHR31235:SF353', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425860, 'PTHR31235:SF356', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425861, 'PTHR31235:SF235', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425862, 'PTHR31235:SF234', NULL, NULL, NULL, NULL, 'PEROXIDASE 56', 252908),
(425863, 'PTHR31235:SF196', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425864, 'PTHR31235:SF195', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425865, 'PTHR31235:SF231', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425866, 'PTHR31235:SF198', NULL, NULL, NULL, NULL, 'PEROXIDASE 57', 252908),
(425867, 'PTHR31235:SF197', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(425868, 'PTHR31235:SF230', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425869, 'PTHR31235:SF358', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425870, 'PTHR31235:SF357', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425871, 'PTHR31235:SF236', NULL, NULL, NULL, NULL, 'PEROXIDASE 3', 252908),
(425872, 'PTHR31235:SF239', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425873, 'PTHR31235:SF359', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425874, 'PTHR31235:SF90', NULL, NULL, NULL, NULL, 'PEROXIDASE 44-RELATED', 252908),
(425875, 'PTHR31235:SF364', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425876, 'PTHR31235:SF367', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425877, 'PTHR31235:SF246', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425878, 'PTHR31235:SF400', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425879, 'PTHR31235:SF366', NULL, NULL, NULL, NULL, 'PEROXIDASE 24', 252908),
(425880, 'PTHR31235:SF240', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425881, 'PTHR31235:SF361', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425882, 'PTHR31235:SF360', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425883, 'PTHR31235:SF362', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425884, 'PTHR31235:SF406', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425885, 'PTHR31235:SF405', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425886, 'PTHR31235:SF408', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425887, 'PTHR31235:SF407', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425888, 'PTHR31235:SF402', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425889, 'PTHR31235:SF369', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425890, 'PTHR31235:SF401', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425891, 'PTHR31235:SF247', NULL, NULL, NULL, NULL, 'PEROXIDASE 66', 252908),
(425892, 'PTHR31235:SF368', NULL, NULL, NULL, NULL, 'PEROXIDASE 25', 252908),
(425893, 'PTHR31235:SF404', NULL, NULL, NULL, NULL, 'PEROXIDASE 71', 252908),
(425894, 'PTHR31235:SF403', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425895, 'PTHR31235:SF409', NULL, NULL, NULL, NULL, 'PEROXIDASE', 252908),
(425896, 'PTHR31235:SF81', NULL, NULL, NULL, NULL, 'PEROXIDASE 1', 252908),
(425897, 'PTHR47216:SF4', NULL, NULL, NULL, NULL, 'OS01G0859400 PROTEIN', 252909),
(425898, 'PTHR47216', NULL, NULL, NULL, NULL, '', 252909),
(425899, 'PTHR47216:SF1', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PHOSPHATASE, CATALYTIC DOMAIN CONTAINING PROTEIN, EXPRESSED', 252909),
(425900, 'PTHR36219', NULL, NULL, NULL, NULL, '', 252910),
(425901, 'PTHR36219:SF1', NULL, NULL, NULL, NULL, '', 252910),
(425902, 'PTHR36766:SF30', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT FAMILY PROTEIN, EXPRESSED', 252911),
(425903, 'PTHR36766:SF21', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN DISEASE RESISTANCE PROTEIN', 252911),
(425904, 'PTHR36766:SF27', NULL, NULL, NULL, NULL, '', 252911),
(425905, 'PTHR36766:SF6', NULL, NULL, NULL, NULL, 'BNAA09G07720D PROTEIN', 252911),
(425906, 'PTHR36766:SF16', NULL, NULL, NULL, NULL, 'RPW8 DOMAIN-CONTAINING PROTEIN', 252911),
(425907, 'PTHR36766:SF28', NULL, NULL, NULL, NULL, 'PLANT BROAD-SPECTRUM MILDEW RESISTANCE PROTEIN RPW8', 252911),
(425908, 'PTHR36766:SF29', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 252911),
(425909, 'PTHR36766:SF18', NULL, NULL, NULL, NULL, 'NB-ARC-RELATED', 252911),
(425910, 'PTHR36766:SF19', NULL, NULL, NULL, NULL, 'RPW8 DOMAIN-CONTAINING PROTEIN', 252911),
(425911, 'PTHR36766:SF3', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252911),
(425912, 'PTHR36766:SF24', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 252911),
(425913, 'PTHR36766:SF13', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT DOMAIN, L DOMAIN-LIKE PROTEIN-RELATED', 252911),
(425914, 'PTHR36766:SF14', NULL, NULL, NULL, NULL, 'RPW8 DOMAIN-CONTAINING PROTEIN', 252911),
(425915, 'PTHR36766:SF25', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN ADR1', 252911),
(425916, 'PTHR36766:SF26', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN (CC-NBS-LRR CLASS) FAMILY PROTEIN', 252911);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(425917, 'PTHR36766:SF15', NULL, NULL, NULL, NULL, 'NB-ARC-RELATED', 252911),
(425918, 'PTHR36766', NULL, NULL, NULL, NULL, 'PLANT BROAD-SPECTRUM MILDEW RESISTANCE PROTEIN RPW8', 252911),
(425919, 'PTHR42944', NULL, NULL, NULL, NULL, 'ADENINE DNA GLYCOSYLASE', 252912),
(425920, 'PTHR42944:SF1', NULL, NULL, NULL, NULL, 'ADENINE DNA GLYCOSYLASE', 252912),
(425921, 'PTHR37711:SF1', NULL, NULL, NULL, NULL, 'OS01G0908400 PROTEIN', 252913),
(425922, 'PTHR37711:SF3', NULL, NULL, NULL, NULL, 'BNAA07G38640D PROTEIN', 252913),
(425923, 'PTHR37711:SF2', NULL, NULL, NULL, NULL, 'BNAA02G13350D PROTEIN', 252913),
(425924, 'PTHR37711', NULL, NULL, NULL, NULL, 'OS01G0908400 PROTEIN', 252913),
(425925, 'PTHR42998', NULL, NULL, NULL, NULL, 'TYPE I RESTRICTION ENZYME HINDVIIP M PROTEIN-RELATED', 252914),
(425926, 'PTHR42998:SF1', NULL, NULL, NULL, NULL, 'TYPE I RESTRICTION ENZYME HINDVIIP M PROTEIN-RELATED', 252914),
(425927, 'PTHR37169:SF3', NULL, NULL, NULL, NULL, 'CRISPR SYSTEM ENDORIBONUCLEASE CSX1', 252915),
(425928, 'PTHR37169', NULL, NULL, NULL, NULL, 'CRISPR SYSTEM ENDORIBONUCLEASE CSX1-RELATED', 252915),
(425929, 'PTHR37169:SF2', NULL, NULL, NULL, NULL, 'CRISPR SYSTEM CMR SUBUNIT CMR3', 252915),
(425930, 'PTHR37169:SF1', NULL, NULL, NULL, NULL, 'CRISPR SYSTEM ENDORIBONUCLEASE CSX1', 252915),
(425931, 'PTHR47448:SF2', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE 1', 252916),
(425932, 'PTHR47448:SF3', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252916),
(425933, 'PTHR47448:SF4', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 252916),
(425934, 'PTHR47448:SF5', NULL, NULL, NULL, NULL, 'STE/STE7 PROTEIN KINASE PEK1', 252916),
(425935, 'PTHR47448:SF1', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE STE7 HOMOLOG', 252916),
(425936, 'PTHR47448', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY MITOGEN-ACTIVATED PROTEIN KINASE KINASE DSOR1-LIKE PROTEIN', 252916),
(425937, 'PTHR38846', NULL, NULL, NULL, NULL, 'C3H1-TYPE DOMAIN-CONTAINING PROTEIN', 252917),
(425938, 'PTHR38846:SF1', NULL, NULL, NULL, NULL, 'C3H1-TYPE DOMAIN-CONTAINING PROTEIN', 252917),
(425939, 'PTHR45458', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/REDUCTASE SDR', 252918),
(425940, 'PTHR45458:SF3', NULL, NULL, NULL, NULL, 'CHAIN DEHYDROGENASE (ATSC), PUTATIVE-RELATED', 252918),
(425941, 'PTHR45458:SF2', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE, SHORT CHAIN DEHYDROGENASE/REDUCTASE FAMILY SUPERFAMILY (AFU_ORTHOLOGUE AFUA_3G13450)', 252918),
(425942, 'PTHR45458:SF1', NULL, NULL, NULL, NULL, 'SHORT CHAIN DEHYDROGENASE/REDUCTASE SDR', 252918),
(425943, 'PTHR46722:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM7 HOMOLOG', 252919),
(425944, 'PTHR46722', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM7 HOMOLOG', 252919),
(425945, 'PTHR22419', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 172', 252920),
(425946, 'PTHR22419:SF2', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 172', 252920),
(425947, 'PTHR10794:SF91', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 252921),
(425948, 'PTHR10794:SF80', NULL, NULL, NULL, NULL, 'MONOACYLGLYCEROL LIPASE ABHD2', 252921),
(425949, 'PTHR10794:SF81', NULL, NULL, NULL, NULL, 'EMBRYOGENESIS-ASSOCIATED PROTEIN EMB8-LIKE', 252921),
(425950, 'PTHR10794:SF60', NULL, NULL, NULL, NULL, 'PROTEIN ABHD1', 252921),
(425951, 'PTHR10794:SF82', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 252921),
(425952, 'PTHR10794:SF50', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE ABHD3', 252921),
(425953, 'PTHR10794:SF84', NULL, NULL, NULL, NULL, 'ESTERASE/LIPASE/THIOESTERASE FAMILY PROTEIN', 252921),
(425954, 'PTHR10794:SF85', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 252921),
(425955, 'PTHR10794:SF63', NULL, NULL, NULL, NULL, 'ALPHA/BETA HYDROLASE 1, ISOFORM A', 252921),
(425956, 'PTHR10794:SF86', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 252921),
(425957, 'PTHR10794:SF87', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 252921);
INSERT INTO "PUBLIC"."MODEL" VALUES
(425958, 'PTHR10794:SF88', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 252921),
(425959, 'PTHR10794:SF44', NULL, NULL, NULL, NULL, 'MEDIUM-CHAIN FATTY ACID ETHYL ESTER SYNTHASE/ESTERASE 1-RELATED', 252921),
(425960, 'PTHR10794:SF45', NULL, NULL, NULL, NULL, 'MONOACYLGLYCEROL LIPASE ABHD2', 252921),
(425961, 'PTHR10794:SF78', NULL, NULL, NULL, NULL, 'ABHYDROLASE DOMAIN-CONTAINING 15A', 252921),
(425962, 'PTHR10794:SF57', NULL, NULL, NULL, NULL, 'OS05G0432600 PROTEIN', 252921),
(425963, 'PTHR10794:SF79', NULL, NULL, NULL, NULL, 'MONOACYLGLYCEROL LIPASE ABHD2', 252921),
(425964, 'PTHR10794:SF39', NULL, NULL, NULL, NULL, 'PROTEIN ABHD15', 252921),
(425965, 'PTHR10794', NULL, NULL, NULL, NULL, 'ABHYDROLASE DOMAIN-CONTAINING PROTEIN', 252921),
(425966, 'PTHR10794:SF90', NULL, NULL, NULL, NULL, '', 252921),
(425967, 'PTHR10083:SF376', NULL, NULL, NULL, NULL, 'SERINE PEPTIDASE INHIBITOR, KUNITZ TYPE, 3', 252922),
(425968, 'PTHR10083:SF375', NULL, NULL, NULL, NULL, 'BPTI/KUNITZ INHIBITOR DOMAIN-CONTAINING PROTEIN', 252922),
(425969, 'PTHR10083:SF352', NULL, NULL, NULL, NULL, 'TISSUE FACTOR PATHWAY INHIBITOR 2', 252922),
(425970, 'PTHR10083', NULL, NULL, NULL, NULL, 'KUNITZ-TYPE PROTEASE INHIBITOR-RELATED', 252922),
(425971, 'PTHR10083:SF374', NULL, NULL, NULL, NULL, 'BPTI/KUNITZ INHIBITOR DOMAIN-CONTAINING PROTEIN', 252922),
(425972, 'PTHR10083:SF373', NULL, NULL, NULL, NULL, 'BPTI/KUNITZ INHIBITOR DOMAIN-CONTAINING PROTEIN', 252922),
(425973, 'PTHR10083:SF369', NULL, NULL, NULL, NULL, 'UTERINE PLASMIN/TRYPSIN INHIBITOR', 252922),
(425974, 'PTHR10083:SF368', NULL, NULL, NULL, NULL, 'GEO10309P1', 252922),
(425975, 'PTHR10083:SF367', NULL, NULL, NULL, NULL, 'SPLEEN TRYPSIN INHIBITOR I', 252922),
(425976, 'PTHR10083:SF328', NULL, NULL, NULL, NULL, 'TISSUE FACTOR PATHWAY INHIBITOR', 252922),
(425977, 'PTHR10083:SF217', NULL, NULL, NULL, NULL, 'WU:FB59D01', 252922),
(425978, 'PTHR10083:SF372', NULL, NULL, NULL, NULL, 'SERINE PEPTIDASE INHIBITOR, KUNITZ TYPE 5', 252922),
(425979, 'PTHR10083:SF371', NULL, NULL, NULL, NULL, 'BPTI/KUNITZ INHIBITOR DOMAIN-CONTAINING PROTEIN-RELATED', 252922),
(425980, 'PTHR10083:SF370', NULL, NULL, NULL, NULL, '', 252922),
(425981, 'PTHR13367:SF9', NULL, NULL, NULL, NULL, 'OTU DOMAIN-CONTAINING PROTEIN 7A', 252923),
(425982, 'PTHR13367', NULL, NULL, NULL, NULL, 'UBIQUITIN THIOESTERASE', 252923),
(425983, 'PTHR13367:SF27', NULL, NULL, NULL, NULL, 'OTU DOMAIN-CONTAINING PROTEIN', 252923),
(425984, 'PTHR13367:SF3', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR ALPHA-INDUCED PROTEIN 3', 252923),
(425985, 'PTHR13367:SF28', NULL, NULL, NULL, NULL, 'UBIQUITIN THIOESTERASE ZRANB1', 252923),
(425986, 'PTHR13367:SF32', NULL, NULL, NULL, NULL, '', 252923),
(425987, 'PTHR13367:SF33', NULL, NULL, NULL, NULL, '', 252923),
(425988, 'PTHR13367:SF34', NULL, NULL, NULL, NULL, '', 252923),
(425989, 'PTHR13367:SF8', NULL, NULL, NULL, NULL, 'OTU DOMAIN-CONTAINING PROTEIN 7B', 252923),
(425990, 'PTHR13906:SF14', NULL, NULL, NULL, NULL, 'LYSOPHOSPHOLIPID ACYLTRANSFERASE 5', 252924),
(425991, 'PTHR13906:SF16', NULL, NULL, NULL, NULL, 'LYSOPHOSPHOLIPID ACYLTRANSFERASE 7', 252924),
(425992, 'PTHR13906:SF18', NULL, NULL, NULL, NULL, 'LYSOPHOSPHOLIPID ACYLTRANSFERASE 2', 252924),
(425993, 'PTHR13906:SF17', NULL, NULL, NULL, NULL, 'LYSOPHOSPHOLIPID ACYLTRANSFERASE 2-LIKE', 252924),
(425994, 'PTHR13906:SF19', NULL, NULL, NULL, NULL, 'MEMBRANE BOUND O-ACYL TRANSFERASE FAMILY PROTEIN', 252924),
(425995, 'PTHR13906', NULL, NULL, NULL, NULL, 'PORCUPINE', 252924),
(425996, 'PTHR13906:SF6', NULL, NULL, NULL, NULL, 'LYSOPHOSPHOLIPID ACYLTRANSFERASE 1', 252924),
(425997, 'PTHR13906:SF7', NULL, NULL, NULL, NULL, 'LYSOPHOSPHOLIPID ACYLTRANSFERASE 2', 252924),
(425998, 'PTHR13906:SF4', NULL, NULL, NULL, NULL, 'OYSGEDART, ISOFORM A', 252924),
(425999, 'PTHR13906:SF21', NULL, NULL, NULL, NULL, 'MEMBRANE BOUND O-ACYL TRANSFERASE, MBOAT-RELATED', 252924),
(426000, 'PTHR13906:SF20', NULL, NULL, NULL, NULL, 'MEMBRANE BOUND O-ACYL TRANSFERASE, MBOAT-RELATED', 252924),
(426001, 'PTHR13906:SF12', NULL, NULL, NULL, NULL, 'PROTEIN-SERINE O-PALMITOLEOYLTRANSFERASE PORCUPINE', 252924);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(426002, 'PTHR13906:SF23', NULL, NULL, NULL, NULL, 'PORCUPINE O-ACYLTRANSFERASE-LIKE', 252924),
(426003, 'PTHR13906:SF3', NULL, NULL, NULL, NULL, 'GHRELIN O-ACYLTRANSFERASE', 252924),
(426004, 'PTHR13906:SF22', NULL, NULL, NULL, NULL, 'PORCUPINE O-ACYLTRANSFERASE', 252924),
(426005, 'PTHR13906:SF11', NULL, NULL, NULL, NULL, 'MEMBRANE BOUND O-ACYL TRANSFERASE, MBOAT', 252924),
(426006, 'PTHR43197:SF2', NULL, NULL, NULL, NULL, 'UTP--GLUCOSE-1-PHOSPHATE URIDYLYLTRANSFERASE', 252925),
(426007, 'PTHR43197:SF1', NULL, NULL, NULL, NULL, 'UTP--GLUCOSE-1-PHOSPHATE URIDYLYLTRANSFERASE', 252925),
(426008, 'PTHR43197', NULL, NULL, NULL, NULL, 'UTP--GLUCOSE-1-PHOSPHATE URIDYLYLTRANSFERASE', 252925),
(426009, 'PTHR14344:SF3', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 6', 252926),
(426010, 'PTHR14344', NULL, NULL, NULL, NULL, 'WD REPEAT PROTEIN', 252926),
(426011, 'PTHR31663:SF2', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING 3B', 252927),
(426012, 'PTHR31663', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 3', 252927),
(426013, 'PTHR31663:SF4', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 3', 252927),
(426014, 'PTHR31663:SF5', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING 3A', 252927),
(426015, 'PTHR34980:SF1', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', 252928),
(426016, 'PTHR34980:SF2', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YHAH-RELATED', 252928),
(426017, 'PTHR34980', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED-RELATED', 252928),
(426018, 'PTHR34980:SF3', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE C-RELATED', 252928),
(426019, 'PTHR23219', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE C15H7.3-RELATED', 252929),
(426020, 'PTHR23219:SF16', NULL, NULL, NULL, NULL, 'PROTEIN CBG07970', 252929),
(426021, 'PTHR23219:SF15', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE DOMAIN-CONTAINING PROTEIN', 252929),
(426022, 'PTHR23219:SF13', NULL, NULL, NULL, NULL, 'PROTEIN CBG12625', 252929),
(426023, 'PTHR23219:SF12', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE B0280.11-RELATED', 252929),
(426024, 'PTHR23219:SF8', NULL, NULL, NULL, NULL, 'PROTEIN TYROSINE PHOSPHATASE-RELATED', 252929),
(426025, 'PTHR23219:SF6', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE', 252929),
(426026, 'PTHR23219:SF18', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE DOMAIN-CONTAINING PROTEIN-RELATED', 252929),
(426027, 'PTHR12794:SF6', NULL, NULL, NULL, NULL, 'GEM-ASSOCIATED PROTEIN 2', 252930),
(426028, 'PTHR12794:SF8', NULL, NULL, NULL, NULL, 'BNAA01G33830D PROTEIN', 252930),
(426029, 'PTHR12794:SF11', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN-RELATED', 252930),
(426030, 'PTHR12794:SF9', NULL, NULL, NULL, NULL, '', 252930),
(426031, 'PTHR12794:SF2', NULL, NULL, NULL, NULL, 'PROTEIN SINE1', 252930),
(426032, 'PTHR12794:SF4', NULL, NULL, NULL, NULL, 'PROTEIN SINE2', 252930),
(426033, 'PTHR12794:SF5', NULL, NULL, NULL, NULL, '', 252930),
(426034, 'PTHR12794:SF0', NULL, NULL, NULL, NULL, 'GEM-ASSOCIATED PROTEIN 2', 252930),
(426035, 'PTHR12794', NULL, NULL, NULL, NULL, 'GEMIN2', 252930),
(426036, 'PTHR15073:SF1', NULL, NULL, NULL, NULL, 'RETICULOCYTE-BINDING PROTEIN 2 HOMOLOG A', 252931),
(426037, 'PTHR15073:SF2', NULL, NULL, NULL, NULL, 'MAP7 DOMAIN-CONTAINING PROTEIN 1', 252931),
(426038, 'PTHR15073:SF16', NULL, NULL, NULL, NULL, '', 252931),
(426039, 'PTHR15073', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN', 252931),
(426040, 'PTHR15073:SF17', NULL, NULL, NULL, NULL, 'MAP7 DOMAIN-CONTAINING 1B', 252931),
(426041, 'PTHR15073:SF18', NULL, NULL, NULL, NULL, 'ENSCONSIN, ISOFORM F', 252931),
(426042, 'PTHR15073:SF3', NULL, NULL, NULL, NULL, 'MAP7 DOMAIN-CONTAINING PROTEIN 2', 252931),
(426043, 'PTHR15073:SF4', NULL, NULL, NULL, NULL, 'ENSCONSIN', 252931),
(426044, 'PTHR15073:SF5', NULL, NULL, NULL, NULL, 'MAP7 DOMAIN-CONTAINING PROTEIN 3', 252931),
(426045, 'PTHR20987:SF1', NULL, NULL, NULL, NULL, 'LP07818P1', 252932),
(426046, 'PTHR20987', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252932),
(426047, 'PTHR20987:SF0', NULL, NULL, NULL, NULL, 'CHITIN-BINDING TYPE-2 DOMAIN-CONTAINING PROTEIN-RELATED', 252932);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(426048, 'PTHR48020:SF18', NULL, NULL, NULL, NULL, 'ALPHA-GLUCOSIDE TRANSPORTER, PUTATIVE-RELATED', 252933),
(426049, 'PTHR48020:SF32', NULL, NULL, NULL, NULL, 'INOSITOL TRANSPORTER 4', 252933),
(426050, 'PTHR48020:SF10', NULL, NULL, NULL, NULL, 'PROTON MYO-INOSITOL COTRANSPORTER HMIT-1.1', 252933),
(426051, 'PTHR48020:SF11', NULL, NULL, NULL, NULL, 'PROTON MYO-INOSITOL COTRANSPORTER HMIT-1.2', 252933),
(426052, 'PTHR48020:SF33', NULL, NULL, NULL, NULL, 'SUGAR PORTER (SP) FAMILY MFS TRANSPORTER', 252933),
(426053, 'PTHR48020:SF34', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 252933),
(426054, 'PTHR48020:SF12', NULL, NULL, NULL, NULL, 'PROTON MYO-INOSITOL COTRANSPORTER', 252933),
(426055, 'PTHR48020:SF35', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER', 252933),
(426056, 'PTHR48020:SF13', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 252933),
(426057, 'PTHR48020:SF14', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER, PUTATIVE-RELATED', 252933),
(426058, 'PTHR48020:SF36', NULL, NULL, NULL, NULL, 'SUGAR PORTER (SP) FAMILY MFS TRANSPORTER', 252933),
(426059, 'PTHR48020:SF37', NULL, NULL, NULL, NULL, 'OS04G0511400 PROTEIN', 252933),
(426060, 'PTHR48020:SF38', NULL, NULL, NULL, NULL, 'INOSITOL TRANSPORTER 2-RELATED', 252933),
(426061, 'PTHR48020:SF16', NULL, NULL, NULL, NULL, 'PROTEIN CBG12142', 252933),
(426062, 'PTHR48020:SF39', NULL, NULL, NULL, NULL, 'MYO-INOSITOL TRANSPORTER 2-RELATED', 252933),
(426063, 'PTHR48020:SF17', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G06870)-RELATED', 252933),
(426064, 'PTHR48020:SF9', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 252933),
(426065, 'PTHR48020:SF30', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 252933),
(426066, 'PTHR48020:SF31', NULL, NULL, NULL, NULL, 'INOSITOL TRANSPORTER 4-LIKE', 252933),
(426067, 'PTHR48020:SF4', NULL, NULL, NULL, NULL, 'SYMPORT, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G11790)-RELATED', 252933),
(426068, 'PTHR48020:SF1', NULL, NULL, NULL, NULL, 'INOSITOL TRANSPORTER 4-LIKE', 252933),
(426069, 'PTHR48020:SF7', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G12580)-RELATED', 252933),
(426070, 'PTHR48020:SF6', NULL, NULL, NULL, NULL, 'INOSITOL TRANSPORTER 3-RELATED', 252933),
(426071, 'PTHR48020:SF43', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 252933),
(426072, 'PTHR48020:SF44', NULL, NULL, NULL, NULL, 'MYO-INOSITOL TRANSPORTER 2', 252933),
(426073, 'PTHR48020:SF22', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN-RELATED', 252933),
(426074, 'PTHR48020:SF23', NULL, NULL, NULL, NULL, 'GENERAL SUBSTRATE TRANSPORTER', 252933),
(426075, 'PTHR48020:SF45', NULL, NULL, NULL, NULL, 'INOSITOL TRANSPORTER 2-RELATED', 252933),
(426076, 'PTHR48020:SF24', NULL, NULL, NULL, NULL, 'INOSITOL TRANSPORTER 4', 252933),
(426077, 'PTHR48020:SF46', NULL, NULL, NULL, NULL, 'SUGAR PORTER (SP) FAMILY MFS TRANSPORTER', 252933),
(426078, 'PTHR48020:SF25', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G05830)-RELATED', 252933),
(426079, 'PTHR48020:SF26', NULL, NULL, NULL, NULL, 'MYO-INOSITOL TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G01560)-RELATED', 252933),
(426080, 'PTHR48020:SF40', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 252933),
(426081, 'PTHR48020:SF41', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE-RELATED', 252933),
(426082, 'PTHR48020', NULL, NULL, NULL, NULL, 'PROTON MYO-INOSITOL COTRANSPORTER', 252933),
(426083, 'PTHR48020:SF20', NULL, NULL, NULL, NULL, 'INOSITOL TRANSPORTER 4-LIKE', 252933),
(426084, 'PTHR48020:SF42', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER', 252933),
(426085, 'PTHR10513:SF8', NULL, NULL, NULL, NULL, 'DEOXYGUANOSINE KINASE, MITOCHONDRIAL', 252934),
(426086, 'PTHR10513:SF37', NULL, NULL, NULL, NULL, 'DNK DOMAIN-CONTAINING PROTEIN', 252934),
(426087, 'PTHR10513:SF15', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX SUBUNIT 10, MITOCHONDRIAL', 252934),
(426088, 'PTHR10513:SF47', NULL, NULL, NULL, NULL, 'DNK DOMAIN-CONTAINING PROTEIN', 252934);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(426089, 'PTHR10513:SF24', NULL, NULL, NULL, NULL, 'THYMIDINE KINASE 2, MITOCHONDRIAL', 252934),
(426090, 'PTHR10513:SF46', NULL, NULL, NULL, NULL, 'DEOXYGUANOSINE KINASE', 252934),
(426091, 'PTHR10513:SF35', NULL, NULL, NULL, NULL, 'DEOXYADENOSINE KINASE', 252934),
(426092, 'PTHR10513:SF45', NULL, NULL, NULL, NULL, 'DNK DOMAIN-CONTAINING PROTEIN', 252934),
(426093, 'PTHR10513:SF44', NULL, NULL, NULL, NULL, 'DEOXYGUANOSINE KINASE', 252934),
(426094, 'PTHR10513:SF43', NULL, NULL, NULL, NULL, 'OS01G0874100 PROTEIN', 252934),
(426095, 'PTHR10513', NULL, NULL, NULL, NULL, 'DEOXYNUCLEOSIDE KINASE', 252934),
(426096, 'PTHR10513:SF19', NULL, NULL, NULL, NULL, 'DEOXYCYTIDINE KINASE', 252934),
(426097, 'PTHR10513:SF38', NULL, NULL, NULL, NULL, 'DEOXYNUCLEOSIDE KINASE-LIKE PROTEIN', 252934),
(426098, 'PTHR47578:SF1', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE PROTEIN CDSP32, CHLOROPLASTIC', 252935),
(426099, 'PTHR47578', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE PROTEIN CDSP32, CHLOROPLASTIC', 252935),
(426100, 'PTHR45860:SF3', NULL, NULL, NULL, NULL, 'EIF-2B GDP-GTP EXCHANGE FACTOR SUBUNIT ALPHA', 252936),
(426101, 'PTHR45860:SF4', NULL, NULL, NULL, NULL, 'EIF-2B GDP-GTP EXCHANGE FACTOR SUBUNIT ALPHA', 252936),
(426102, 'PTHR45860', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR EIF-2B SUBUNIT ALPHA', 252936),
(426103, 'PTHR45860:SF1', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR EIF-2B SUBUNIT ALPHA', 252936),
(426104, 'PTHR31978', NULL, NULL, NULL, NULL, 'INTRAFLAGELLAR TRANSPORT PROTEIN 20 HOMOLOG', 252937),
(426105, 'PTHR31978:SF1', NULL, NULL, NULL, NULL, 'INTRAFLAGELLAR TRANSPORT PROTEIN 20 HOMOLOG', 252937),
(426106, 'PTHR15742:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBR-TAG-241', 252938),
(426107, 'PTHR15742:SF3', NULL, NULL, NULL, NULL, 'MICROTUBULE CROSS-LINKING FACTOR 1', 252938),
(426108, 'PTHR15742:SF2', NULL, NULL, NULL, NULL, 'PROTEIN SOGA3', 252938),
(426109, 'PTHR15742:SF1', NULL, NULL, NULL, NULL, 'PROTEIN SOGA1', 252938),
(426110, 'PTHR15742', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252938),
(426111, 'PTHR35709:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PROTON GRADIENT REGULATION 5, CHLOROPLASTIC', 252939),
(426112, 'PTHR35709', NULL, NULL, NULL, NULL, 'PROTEIN PROTON GRADIENT REGULATION 5, CHLOROPLASTIC', 252939),
(426113, 'PTHR43379:SF3', NULL, NULL, NULL, NULL, 'CYS/MET METABOLISM PLP-DEPENDENT ENZYME FAMILY PROTEIN, EXPRESSED', 252940),
(426114, 'PTHR43379', NULL, NULL, NULL, NULL, 'CYSTATHIONINE GAMMA-SYNTHASE', 252940),
(426115, 'PTHR43379:SF1', NULL, NULL, NULL, NULL, 'CYSTATHIONINE GAMMA-SYNTHASE 1, CHLOROPLASTIC-RELATED', 252940),
(426116, 'PTHR43379:SF5', NULL, NULL, NULL, NULL, 'CYSTATHIONINE GAMMA-SYNTHASE 1, CHLOROPLASTIC-LIKE', 252940),
(426117, 'PTHR31225:SF93', NULL, NULL, NULL, NULL, '(S)-BETA-MACROCARPENE SYNTHASE', 252941),
(426118, 'PTHR31225:SF94', NULL, NULL, NULL, NULL, 'ALPHA-FARNESENE SYNTHASE', 252941),
(426119, 'PTHR31225:SF91', NULL, NULL, NULL, NULL, 'TERPENE_SYNTH_C DOMAIN-CONTAINING PROTEIN', 252941),
(426120, 'PTHR31225:SF92', NULL, NULL, NULL, NULL, 'OS04G0344100 PROTEIN', 252941),
(426121, 'PTHR31225:SF176', NULL, NULL, NULL, NULL, '(E,E)-GERMACRENE B SYNTHASE-LIKE', 252941),
(426122, 'PTHR31225:SF132', NULL, NULL, NULL, NULL, 'ALPHA-FARNESENE SYNTHASE', 252941),
(426123, 'PTHR31225:SF210', NULL, NULL, NULL, NULL, 'OS01G0337100 PROTEIN', 252941),
(426124, 'PTHR31225:SF177', NULL, NULL, NULL, NULL, '', 252941),
(426125, 'PTHR31225:SF211', NULL, NULL, NULL, NULL, 'VETISPIRADIENE SYNTHASE 1', 252941),
(426126, 'PTHR31225:SF212', NULL, NULL, NULL, NULL, '', 252941),
(426127, 'PTHR31225:SF131', NULL, NULL, NULL, NULL, 'VIRIDIFLORENE SYNTHASE', 252941),
(426128, 'PTHR31225:SF217', NULL, NULL, NULL, NULL, 'ALPHA-HUMULENE/(-)-(E)-BETA-CARYOPHYLLENE SYNTHASE', 252941),
(426129, 'PTHR31225:SF218', NULL, NULL, NULL, NULL, 'GERANIOL SYNTHASE, CHLOROPLASTIC-LIKE', 252941),
(426130, 'PTHR31225:SF219', NULL, NULL, NULL, NULL, 'SESQUITERPENE SYNTHASE 2', 252941),
(426131, 'PTHR31225:SF49', NULL, NULL, NULL, NULL, '', 252941),
(426132, 'PTHR31225:SF213', NULL, NULL, NULL, NULL, 'ALPHA-HUMULENE/(-)-(E)-BETA-CARYOPHYLLENE SYNTHASE', 252941);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(426133, 'PTHR31225:SF137', NULL, NULL, NULL, NULL, 'TERPENE SYNTHASE 11-RELATED', 252941),
(426134, 'PTHR31225:SF214', NULL, NULL, NULL, NULL, 'ISOPRENOID SYNTHASE DOMAIN-CONTAINING PROTEIN-RELATED', 252941),
(426135, 'PTHR31225:SF215', NULL, NULL, NULL, NULL, '(+)-DELTA-CADINENE SYNTHASE', 252941),
(426136, 'PTHR31225:SF216', NULL, NULL, NULL, NULL, '', 252941),
(426137, 'PTHR31225:SF41', NULL, NULL, NULL, NULL, 'OS04G0340300 PROTEIN', 252941),
(426138, 'PTHR31225:SF83', NULL, NULL, NULL, NULL, '(R)-LINALOOL SYNTHASE TPS5, CHLOROPLASTIC', 252941),
(426139, 'PTHR31225:SF80', NULL, NULL, NULL, NULL, 'BRADI3G14710', 252941),
(426140, 'PTHR31225:SF81', NULL, NULL, NULL, NULL, '(E,E)-GERMACRENE B SYNTHASE-LIKE', 252941),
(426141, 'PTHR31225:SF166', NULL, NULL, NULL, NULL, '', 252941),
(426142, 'PTHR31225:SF200', NULL, NULL, NULL, NULL, 'TERPENE_SYNTH_C DOMAIN-CONTAINING PROTEIN', 252941),
(426143, 'PTHR31225:SF201', NULL, NULL, NULL, NULL, '(-)-CAMPHENE/TRICYCLENE SYNTHASE, CHLOROPLASTIC', 252941),
(426144, 'PTHR31225:SF168', NULL, NULL, NULL, NULL, 'INACTIVE SESQUITHUJENE SYNTHASE', 252941),
(426145, 'PTHR31225:SF240', NULL, NULL, NULL, NULL, '(+)-DELTA-CADINENE SYNTHASE', 252941),
(426146, 'PTHR31225:SF163', NULL, NULL, NULL, NULL, 'TERPENOID SYNTHASE 9', 252941),
(426147, 'PTHR31225:SF164', NULL, NULL, NULL, NULL, 'TRICYCLENE SYNTHASE, CHLOROPLASTIC', 252941),
(426148, 'PTHR31225:SF120', NULL, NULL, NULL, NULL, 'GERMACRENE A SYNTHASE 2-RELATED', 252941),
(426149, 'PTHR31225:SF129', NULL, NULL, NULL, NULL, 'BNAC01G41830D PROTEIN', 252941),
(426150, 'PTHR31225:SF206', NULL, NULL, NULL, NULL, '', 252941),
(426151, 'PTHR31225:SF207', NULL, NULL, NULL, NULL, '(E)-BETA-OCIMENE SYNTHASE PROTEIN-RELATED', 252941),
(426152, 'PTHR31225:SF208', NULL, NULL, NULL, NULL, 'VIRIDIFLORENE SYNTHASE', 252941),
(426153, 'PTHR31225:SF209', NULL, NULL, NULL, NULL, 'SESQUITERPENE SYNTHASE-LIKE', 252941),
(426154, 'PTHR31225:SF202', NULL, NULL, NULL, NULL, '(E)-BETA-FARNESENE SYNTHASE-RELATED', 252941),
(426155, 'PTHR31225:SF125', NULL, NULL, NULL, NULL, '5-EPI-ARISTOLOCHENE SYNTHASE', 252941),
(426156, 'PTHR31225:SF203', NULL, NULL, NULL, NULL, '1,8-CINEOLE SYNTHASE 1, CHLOROPLASTIC-RELATED', 252941),
(426157, 'PTHR31225:SF204', NULL, NULL, NULL, NULL, '(R)-LIMONENE SYNTHASE', 252941),
(426158, 'PTHR31225:SF205', NULL, NULL, NULL, NULL, '(-)-GERMACRENE D SYNTHASE-LIKE', 252941),
(426159, 'PTHR31225:SF76', NULL, NULL, NULL, NULL, '(-)-GERMACRENE D SYNTHASE-LIKE ISOFORM X1', 252941),
(426160, 'PTHR31225:SF73', NULL, NULL, NULL, NULL, '(3S)-LINALOOL/(E)-NEROLIDOL/(E,E)-GERANYL LINALOOL SYNTHASE', 252941),
(426161, 'PTHR31225:SF231', NULL, NULL, NULL, NULL, 'TERPENE SYNTHASE 8-RELATED', 252941),
(426162, 'PTHR31225:SF232', NULL, NULL, NULL, NULL, '18-CINEOLE SYNTHASE 1 CHLOROPLASTIC', 252941),
(426163, 'PTHR31225:SF155', NULL, NULL, NULL, NULL, 'BNAANNG04260D PROTEIN', 252941),
(426164, 'PTHR31225:SF233', NULL, NULL, NULL, NULL, 'GERMACRENE C SYNTHASE-LIKE', 252941),
(426165, 'PTHR31225:SF234', NULL, NULL, NULL, NULL, 'TERPENE SYNTHASE 4-RELATED', 252941),
(426166, 'PTHR31225:SF113', NULL, NULL, NULL, NULL, 'TERPENE SYNTHASE 3-RELATED', 252941),
(426167, 'PTHR31225:SF150', NULL, NULL, NULL, NULL, 'TERPENE SYNTHASE 12-RELATED', 252941),
(426168, 'PTHR31225:SF194', NULL, NULL, NULL, NULL, 'TERPENE_SYNTH DOMAIN-CONTAINING PROTEIN', 252941),
(426169, 'PTHR31225:SF195', NULL, NULL, NULL, NULL, 'TERPENOID CYCLASES/PROTEIN PRENYLTRANSFERASE ALPHA-ALPHA TOROID-RELATED', 252941),
(426170, 'PTHR31225:SF196', NULL, NULL, NULL, NULL, 'AMORPHA-4,11-DIENE SYNTHASE-RELATED', 252941),
(426171, 'PTHR31225:SF230', NULL, NULL, NULL, NULL, 'TERPENE SYNTHASE TPS27', 252941),
(426172, 'PTHR31225:SF239', NULL, NULL, NULL, NULL, 'TERPENE_SYNTH DOMAIN-CONTAINING PROTEIN', 252941),
(426173, 'PTHR31225', NULL, NULL, NULL, NULL, 'OS04G0344100 PROTEIN-RELATED', 252941),
(426174, 'PTHR31225:SF118', NULL, NULL, NULL, NULL, '(E)-BETA-FARNESENE SYNTHASE', 252941),
(426175, 'PTHR31225:SF235', NULL, NULL, NULL, NULL, 'TERPENOID CYCLASES/PROTEIN PRENYLTRANSFERASE ALPHA-ALPHA TOROID-RELATED', 252941);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(426176, 'PTHR31225:SF158', NULL, NULL, NULL, NULL, '(E)-BETA-CARYOPHYLLENE SYNTHASE', 252941),
(426177, 'PTHR31225:SF236', NULL, NULL, NULL, NULL, 'TERPENE SYNTHASE 2-RELATED', 252941),
(426178, 'PTHR31225:SF237', NULL, NULL, NULL, NULL, 'TERPENE SYNTHASE FAMILY, METAL-BINDING DOMAIN PROTEIN', 252941),
(426179, 'PTHR31225:SF116', NULL, NULL, NULL, NULL, 'TERPENE_SYNTH_C DOMAIN-CONTAINING PROTEIN', 252941),
(426180, 'PTHR31225:SF238', NULL, NULL, NULL, NULL, 'ALPHA-HUMULENE/(-)-(E)-BETA-CARYOPHYLLENE SYNTHASE', 252941),
(426181, 'PTHR31225:SF62', NULL, NULL, NULL, NULL, 'BNACNNG52840D PROTEIN', 252941),
(426182, 'PTHR31225:SF63', NULL, NULL, NULL, NULL, 'BETA-SELINENE SYNTHASE', 252941),
(426183, 'PTHR31225:SF180', NULL, NULL, NULL, NULL, '(+)-DELTA-CADINENE SYNTHASE', 252941),
(426184, 'PTHR31225:SF182', NULL, NULL, NULL, NULL, 'ALPHA-HUMULENE/(-)-(E)-BETA-CARYOPHYLLENE SYNTHASE', 252941),
(426185, 'PTHR31225:SF187', NULL, NULL, NULL, NULL, '(-)-BETA-PINENE SYNTHASE PROTEIN-RELATED', 252941),
(426186, 'PTHR31225:SF220', NULL, NULL, NULL, NULL, 'TERPENE SYNTHASE TPS16', 252941),
(426187, 'PTHR31225:SF143', NULL, NULL, NULL, NULL, 'CEMBRATRIENOL SYNTHASE 2B', 252941),
(426188, 'PTHR31225:SF221', NULL, NULL, NULL, NULL, '(-)-GERMACRENE D SYNTHASE', 252941),
(426189, 'PTHR31225:SF222', NULL, NULL, NULL, NULL, 'ALPHA-COPAENE SYNTHASE', 252941),
(426190, 'PTHR31225:SF145', NULL, NULL, NULL, NULL, 'TERPENE_SYNTH_C DOMAIN-CONTAINING PROTEIN', 252941),
(426191, 'PTHR31225:SF223', NULL, NULL, NULL, NULL, 'TERPENE SYNTHASE 10-LIKE ISOFORM X1', 252941),
(426192, 'PTHR31225:SF0', NULL, NULL, NULL, NULL, 'S-(+)-LINALOOL SYNTHASE, CHLOROPLASTIC', 252941),
(426193, 'PTHR31225:SF186', NULL, NULL, NULL, NULL, 'TAU-CADINOL SYNTHASE', 252941),
(426194, 'PTHR31225:SF228', NULL, NULL, NULL, NULL, 'ALPHA-TERPINEOL SYNTHASE, CHLOROPLASTIC', 252941),
(426195, 'PTHR31225:SF229', NULL, NULL, NULL, NULL, 'TPS14', 252941),
(426196, 'PTHR31225:SF108', NULL, NULL, NULL, NULL, '(E,E)-GERMACRENE B SYNTHASE-LIKE', 252941),
(426197, 'PTHR31225:SF109', NULL, NULL, NULL, NULL, 'EUDESMANEDIOL SYNTHASE', 252941),
(426198, 'PTHR31225:SF224', NULL, NULL, NULL, NULL, '', 252941),
(426199, 'PTHR31225:SF225', NULL, NULL, NULL, NULL, 'GERMACRENE C SYNTHASE', 252941),
(426200, 'PTHR31225:SF9', NULL, NULL, NULL, NULL, 'TRICYCLENE SYNTHASE, CHLOROPLASTIC', 252941),
(426201, 'PTHR31225:SF226', NULL, NULL, NULL, NULL, '(-)-GERMACRENE D SYNTHASE', 252941),
(426202, 'PTHR31225:SF227', NULL, NULL, NULL, NULL, 'MYRCENE SYNTHASE PROTEIN-RELATED', 252941),
(426203, 'PTHR31225:SF98', NULL, NULL, NULL, NULL, 'TERPENE SYNTHASE 9-RELATED', 252941),
(426204, 'PTHR31225:SF52', NULL, NULL, NULL, NULL, 'ALPHA-HUMULENE/(-)-(E)-BETA-CARYOPHYLLENE SYNTHASE', 252941),
(426205, 'PTHR31225:SF99', NULL, NULL, NULL, NULL, '(3S)-LINALOOL/(E)-NEROLIDOL/(E,E)-GERANYL LINALOOL SYNTHASE', 252941),
(426206, 'PTHR46690', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY FACTOR 6 HOMOLOG', 252942),
(426207, 'PTHR46690:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY FACTOR 6 HOMOLOG', 252942),
(426208, 'PTHR39161:SF2', NULL, NULL, NULL, NULL, 'ADAPTER PROTEIN MECA 2', 252943),
(426209, 'PTHR39161:SF1', NULL, NULL, NULL, NULL, 'ADAPTER PROTEIN MECA 1', 252943),
(426210, 'PTHR39161', NULL, NULL, NULL, NULL, 'ADAPTER PROTEIN MECA', 252943),
(426211, 'PTHR23074:SF72', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 4B', 252944),
(426212, 'PTHR23074:SF155', NULL, NULL, NULL, NULL, 'KATANIN P60 ATPASE-CONTAINING SUBUNIT A1', 252944),
(426213, 'PTHR23074:SF71', NULL, NULL, NULL, NULL, 'KATANIN P60 ATPASE-CONTAINING SUBUNIT A1', 252944),
(426214, 'PTHR23074:SF33', NULL, NULL, NULL, NULL, 'FIDGETIN-LIKE PROTEIN 2', 252944),
(426215, 'PTHR23074:SF157', NULL, NULL, NULL, NULL, 'BNAC04G50250D PROTEIN', 252944),
(426216, 'PTHR23074:SF75', NULL, NULL, NULL, NULL, 'DYNEIN REGULATORY COMPLEX PROTEIN 11-RELATED', 252944),
(426217, 'PTHR23074:SF159', NULL, NULL, NULL, NULL, 'PROTEIN SUPPRESSOR OF K(+) TRANSPORT GROWTH DEFECT 1', 252944),
(426218, 'PTHR23074:SF14', NULL, NULL, NULL, NULL, 'FIDGETIN', 252944);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(426219, 'PTHR23074:SF78', NULL, NULL, NULL, NULL, 'KATANIN P60 ATPASE-CONTAINING SUBUNIT A-LIKE 2', 252944),
(426220, 'PTHR23074:SF19', NULL, NULL, NULL, NULL, 'KATANIN P60 ATPASE-CONTAINING SUBUNIT A1', 252944),
(426221, 'PTHR23074', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING', 252944),
(426222, 'PTHR23074:SF163', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN 4A, PUTATIVE-RELATED', 252944),
(426223, 'PTHR23074:SF17', NULL, NULL, NULL, NULL, 'FIDGETIN-LIKE PROTEIN 1', 252944),
(426224, 'PTHR23074:SF162', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 4-RELATED', 252944),
(426225, 'PTHR23074:SF83', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 4A', 252944),
(426226, 'PTHR23074:SF164', NULL, NULL, NULL, NULL, 'VESICLE-FUSING ATPASE', 252944),
(426227, 'PTHR23074:SF81', NULL, NULL, NULL, NULL, '26S PROTEASOME SUBUNIT YTA6-RELATED', 252944),
(426228, 'PTHR23074:SF167', NULL, NULL, NULL, NULL, 'OS02G0159900 PROTEIN', 252944),
(426229, 'PTHR23074:SF166', NULL, NULL, NULL, NULL, 'OS01G0673500 PROTEIN', 252944),
(426230, 'PTHR23074:SF65', NULL, NULL, NULL, NULL, 'KATANIN P60 ATPASE-CONTAINING SUBUNIT A-LIKE 1', 252944),
(426231, 'PTHR23074:SF169', NULL, NULL, NULL, NULL, 'ATPASE-LIKE FIDGETIN', 252944),
(426232, 'PTHR23074:SF168', NULL, NULL, NULL, NULL, 'KATANIN P60 ATPASE-CONTAINING SUBUNIT A1', 252944),
(426233, 'PTHR23074:SF86', NULL, NULL, NULL, NULL, 'SPASTIN', 252944),
(426234, 'PTHR23074:SF170', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN VPS4', 252944),
(426235, 'PTHR23074:SF150', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING PROTEIN', 252944),
(426236, 'PTHR23074:SF152', NULL, NULL, NULL, NULL, 'KATANIN P60 ATPASE-CONTAINING SUBUNIT A1', 252944),
(426237, 'PTHR30471:SF6', NULL, NULL, NULL, NULL, 'UPF0758 PROTEIN VC_0510', 252945),
(426238, 'PTHR30471:SF3', NULL, NULL, NULL, NULL, 'UPF0758 PROTEIN YEES-RELATED', 252945),
(426239, 'PTHR30471', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RADC', 252945),
(426240, 'PTHR47500:SF3', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM BINDING DOMAIN 3', 252946),
(426241, 'PTHR47500:SF4', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING DOMAIN 15', 252946),
(426242, 'PTHR47500:SF1', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 21', 252946),
(426243, 'PTHR47500:SF2', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING DOMAIN-CONTAINING PROTEIN 3', 252946),
(426244, 'PTHR47500', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING DOMAIN-CONTAINING PROTEIN', 252946),
(426245, 'PTHR21704:SF18', NULL, NULL, NULL, NULL, 'NIPPED-B-LIKE PROTEIN', 252947),
(426246, 'PTHR21704', NULL, NULL, NULL, NULL, 'NIPPED-B-LIKE PROTEIN  DELANGIN  SCC2-RELATED', 252947),
(426247, 'PTHR14580', NULL, NULL, NULL, NULL, 'MULTIPLE MYELOMA TUMOR-ASSOCIATED PROTEIN 2 FAMILY MEMBER', 252948),
(426248, 'PTHR14580:SF0', NULL, NULL, NULL, NULL, 'MULTIPLE MYELOMA TUMOR-ASSOCIATED PROTEIN 2', 252948),
(426249, 'PTHR42058', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F2_4 DOMAIN-CONTAINING PROTEIN', 252949),
(426250, 'PTHR42058:SF1', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F2_4 DOMAIN-CONTAINING PROTEIN', 252949),
(426251, 'PTHR46938:SF4', NULL, NULL, NULL, NULL, 'H_LECTIN DOMAIN-CONTAINING PROTEIN', 252950),
(426252, 'PTHR46938:SF3', NULL, NULL, NULL, NULL, 'F5/8 TYPE C DOMAIN-CONTAINING PROTEIN', 252950),
(426253, 'PTHR46938:SF2', NULL, NULL, NULL, NULL, 'DISCOIDIN-2', 252950),
(426254, 'PTHR46938:SF1', NULL, NULL, NULL, NULL, 'DISCOIDIN-1 SUBUNIT A-RELATED', 252950),
(426255, 'PTHR46938', NULL, NULL, NULL, NULL, 'DISCOIDIN-1 SUBUNIT A-RELATED-RELATED', 252950),
(426256, 'PTHR14206:SF5', NULL, NULL, NULL, NULL, 'BRAIN-SPECIFIC ANGIOGENESIS INHIBITOR 1-ASSOCIATED PROTEIN 2-LIKE PROTEIN 2', 252951),
(426257, 'PTHR14206:SF4', NULL, NULL, NULL, NULL, 'BRAIN-SPECIFIC ANGIOGENESIS INHIBITOR 1-ASSOCIATED PROTEIN 2-LIKE PROTEIN 1', 252951),
(426258, 'PTHR14206:SF3', NULL, NULL, NULL, NULL, 'BRAIN-SPECIFIC ANGIOGENESIS INHIBITOR 1-ASSOCIATED PROTEIN 2', 252951),
(426259, 'PTHR14206', NULL, NULL, NULL, NULL, 'BRAIN-SPECIFIC ANGIOGENESIS INHIBITOR 1-ASSOCIATED PROTEIN 2', 252951);
INSERT INTO "PUBLIC"."MODEL" VALUES
(426260, 'PTHR14206:SF8', NULL, NULL, NULL, NULL, 'BAR/IMD DOMAIN-CONTAINING ADAPTOR PROTEIN 2-LIKE 1A', 252951),
(426261, 'PTHR14206:SF7', NULL, NULL, NULL, NULL, 'INSULIN RECEPTOR SUBSTRATE 53 KDA, ISOFORM A', 252951),
(426262, 'PTHR14206:SF6', NULL, NULL, NULL, NULL, 'ZGC:158689', 252951),
(426263, 'PTHR12479:SF10', NULL, NULL, NULL, NULL, 'LYSOSOMAL-ASSOCIATED TRANSMEMBRANE PROTEIN', 252952),
(426264, 'PTHR12479:SF20', NULL, NULL, NULL, NULL, 'PROTEIN CBG06040', 252952),
(426265, 'PTHR12479:SF11', NULL, NULL, NULL, NULL, 'PROTEIN CBG14497', 252952),
(426266, 'PTHR12479:SF14', NULL, NULL, NULL, NULL, '', 252952),
(426267, 'PTHR12479:SF13', NULL, NULL, NULL, NULL, 'PROTEIN CBG20493', 252952),
(426268, 'PTHR12479:SF5', NULL, NULL, NULL, NULL, 'LYSOSOMAL-ASSOCIATED TRANSMEMBRANE PROTEIN 4A', 252952),
(426269, 'PTHR12479:SF2', NULL, NULL, NULL, NULL, 'LYSOSOMAL-ASSOCIATED TRANSMEMBRANE PROTEIN 5', 252952),
(426270, 'PTHR12479:SF16', NULL, NULL, NULL, NULL, 'PROTEIN CBG03933', 252952),
(426271, 'PTHR12479:SF18', NULL, NULL, NULL, NULL, 'PROTEIN CBG16398', 252952),
(426272, 'PTHR12479:SF17', NULL, NULL, NULL, NULL, 'DAF-16/FOXO CONTROLLED, GERMLINE TUMOR AFFECTING', 252952),
(426273, 'PTHR12479:SF19', NULL, NULL, NULL, NULL, 'PROTEIN CBG18791', 252952),
(426274, 'PTHR12479:SF6', NULL, NULL, NULL, NULL, 'LYSOSOMAL-ASSOCIATED TRANSMEMBRANE PROTEIN 4B', 252952),
(426275, 'PTHR12479', NULL, NULL, NULL, NULL, 'LYSOSOMAL-ASSOCIATED TRANSMEMBRANE PROTEIN', 252952),
(426276, 'PTHR23208', NULL, NULL, NULL, NULL, 'LYSOZYME PROTEIN', 252953),
(426277, 'PTHR23208:SF41', NULL, NULL, NULL, NULL, 'LYSOZYME-LIKE PROTEIN 1', 252953),
(426278, 'PTHR23208:SF17', NULL, NULL, NULL, NULL, 'LYSOZYME-LIKE PROTEIN 3', 252953),
(426279, 'PTHR23208:SF36', NULL, NULL, NULL, NULL, 'LYSOZYME-RELATED', 252953),
(426280, 'PTHR23208:SF14', NULL, NULL, NULL, NULL, 'LYSOZYME-RELATED', 252953),
(426281, 'PTHR23208:SF16', NULL, NULL, NULL, NULL, 'LYSOZYME', 252953),
(426282, 'PTHR23208:SF32', NULL, NULL, NULL, NULL, 'GH FAMILY 25 LYSOZYME 5-RELATED', 252953),
(426283, 'PTHR23208:SF21', NULL, NULL, NULL, NULL, 'LYSOZYME-LIKE PROTEIN 2', 252953),
(426284, 'PTHR23208:SF11', NULL, NULL, NULL, NULL, 'COUNTING FACTOR 45-1-RELATED', 252953),
(426285, 'PTHR47700:SF2', NULL, NULL, NULL, NULL, 'CHITINASE', 252954),
(426286, 'PTHR47700:SF1', NULL, NULL, NULL, NULL, 'CHITINASE-RELATED', 252954),
(426287, 'PTHR47700', NULL, NULL, NULL, NULL, 'V CHITINASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G13720)-RELATED', 252954),
(426288, 'PTHR37455:SF1', NULL, NULL, NULL, NULL, 'SIMILAR TO 1190005I06RIK PROTEIN', 252955),
(426289, 'PTHR37455', NULL, NULL, NULL, NULL, 'GENE, 27021-RELATED', 252955),
(426290, 'PTHR43724', NULL, NULL, NULL, NULL, 'PYRUVATE SYNTHASE SUBUNIT PORD', 252956),
(426291, 'PTHR43724:SF1', NULL, NULL, NULL, NULL, 'PYRUVATE SYNTHASE SUBUNIT PORD', 252956),
(426292, 'PTHR47125:SF8', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 252957),
(426293, 'PTHR47125', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN', 252957),
(426294, 'PTHR47125:SF7', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASE-LIKE SUPERFAMILY PROTEIN', 252957),
(426295, 'PTHR47125:SF4', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 252957),
(426296, 'PTHR47125:SF2', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN', 252957),
(426297, 'PTHR47588:SF1', NULL, NULL, NULL, NULL, 'CHALCONE--FLAVANONE ISOMERASE 3-RELATED', 252958),
(426298, 'PTHR47588', NULL, NULL, NULL, NULL, 'CHALCONE--FLAVONONE ISOMERASE 3-RELATED', 252958),
(426299, 'PTHR21824:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG16527', 252959),
(426300, 'PTHR21824', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252959),
(426301, 'PTHR21824:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 177', 252959),
(426302, 'PTHR21700:SF22', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-LIKE PROTEIN 2', 252960),
(426303, 'PTHR21700:SF25', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426304, 'PTHR21700:SF124', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-LIKE PROTEIN 46', 252960);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(426305, 'PTHR21700:SF125', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426306, 'PTHR21700:SF23', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426307, 'PTHR21700:SF24', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426308, 'PTHR21700:SF29', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426309, 'PTHR21700:SF27', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426310, 'PTHR21700:SF28', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426311, 'PTHR21700:SF120', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-LIKE PROTEIN 15', 252960),
(426312, 'PTHR21700:SF121', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426313, 'PTHR21700:SF122', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426314, 'PTHR21700:SF32', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426315, 'PTHR21700:SF33', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-LIKE PROTEIN 1', 252960),
(426316, 'PTHR21700:SF30', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426317, 'PTHR21700:SF31', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426318, 'PTHR21700:SF37', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426319, 'PTHR21700:SF34', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426320, 'PTHR21700:SF38', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426321, 'PTHR21700:SF39', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426322, 'PTHR21700:SF43', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426323, 'PTHR21700:SF44', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426324, 'PTHR21700', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 252960),
(426325, 'PTHR21700:SF41', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426326, 'PTHR21700:SF109', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426327, 'PTHR21700:SF42', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426328, 'PTHR21700:SF48', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426329, 'PTHR21700:SF45', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426330, 'PTHR21700:SF46', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-LIKE PROTEIN 52', 252960),
(426331, 'PTHR21700:SF49', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426332, 'PTHR21700:SF50', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426333, 'PTHR21700:SF51', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426334, 'PTHR21700:SF117', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-LIKE PROTEIN 33', 252960),
(426335, 'PTHR21700:SF54', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426336, 'PTHR21700:SF118', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426337, 'PTHR21700:SF55', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-LIKE PROTEIN 5', 252960),
(426338, 'PTHR21700:SF114', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426339, 'PTHR21700:SF15', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426340, 'PTHR21700:SF56', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426341, 'PTHR21700:SF12', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426342, 'PTHR21700:SF116', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-LIKE PROTEIN 16', 252960),
(426343, 'PTHR21700:SF13', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426344, 'PTHR21700:SF18', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426345, 'PTHR21700:SF19', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426346, 'PTHR21700:SF16', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-LIKE PROTEIN 3', 252960);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(426347, 'PTHR21700:SF17', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE-LIKE PROTEIN', 252960),
(426348, 'PTHR21700:SF6', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426349, 'PTHR21700:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG20620', 252960),
(426350, 'PTHR21700:SF4', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426351, 'PTHR21700:SF111', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426352, 'PTHR21700:SF112', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426353, 'PTHR21700:SF3', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426354, 'PTHR21700:SF8', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426355, 'PTHR21700:SF7', NULL, NULL, NULL, NULL, 'TRANSTHYRETIN-RELATED FAMILY DOMAIN', 252960),
(426356, 'PTHR43718:SF14', NULL, NULL, NULL, NULL, 'LON PROTEASE HOMOLOG 3, MITOCHONDRIAL-RELATED', 252961),
(426357, 'PTHR43718:SF13', NULL, NULL, NULL, NULL, 'LON PROTEASE HOMOLOG', 252961),
(426358, 'PTHR43718:SF12', NULL, NULL, NULL, NULL, 'BNAC06G04270D PROTEIN', 252961),
(426359, 'PTHR43718:SF11', NULL, NULL, NULL, NULL, 'BNAA06G02580D PROTEIN', 252961),
(426360, 'PTHR43718:SF7', NULL, NULL, NULL, NULL, 'LON PROTEASE HOMOLOG 2 PEROXISOMAL', 252961),
(426361, 'PTHR43718', NULL, NULL, NULL, NULL, 'LON PROTEASE', 252961),
(426362, 'PTHR43718:SF2', NULL, NULL, NULL, NULL, 'LON PROTEASE HOMOLOG, MITOCHONDRIAL', 252961),
(426363, 'PTHR43718:SF16', NULL, NULL, NULL, NULL, 'LON PROTEASE HOMOLOG, MITOCHONDRIAL 1', 252961),
(426364, 'PTHR32261:SF5', NULL, NULL, NULL, NULL, 'CALCIUM HOMEOSTASIS MODULATOR PROTEIN 4', 252962),
(426365, 'PTHR32261:SF8', NULL, NULL, NULL, NULL, 'CALCIUM HOMEOSTASIS MODULATOR PROTEIN 5', 252962),
(426366, 'PTHR32261:SF7', NULL, NULL, NULL, NULL, 'CALCIUM HOMEOSTASIS MODULATOR PROTEIN 3', 252962),
(426367, 'PTHR32261:SF2', NULL, NULL, NULL, NULL, 'CALCIUM HOMEOSTASIS MODULATOR PROTEIN 1', 252962),
(426368, 'PTHR32261:SF1', NULL, NULL, NULL, NULL, 'CALCIUM HOMEOSTASIS MODULATOR PROTEIN', 252962),
(426369, 'PTHR32261', NULL, NULL, NULL, NULL, 'CALCIUM HOMEOSTASIS MODULATOR PROTEIN', 252962),
(426370, 'PTHR32261:SF4', NULL, NULL, NULL, NULL, 'CALCIUM HOMEOSTASIS MODULATOR PROTEIN 6', 252962),
(426371, 'PTHR32261:SF3', NULL, NULL, NULL, NULL, 'CALCIUM HOMEOSTASIS MODULATOR PROTEIN 2', 252962),
(426372, 'PTHR34504', NULL, NULL, NULL, NULL, 'ANTITOXIN HICB', 252963),
(426373, 'PTHR34504:SF2', NULL, NULL, NULL, NULL, 'ANTITOXIN HICB', 252963),
(426374, 'PTHR34504:SF3', NULL, NULL, NULL, NULL, 'UPF0150 PROTEIN SSL0259', 252963),
(426375, 'PTHR39529', NULL, NULL, NULL, NULL, '', 252964),
(426376, 'PTHR39529:SF1', NULL, NULL, NULL, NULL, '', 252964),
(426377, 'PTHR30035:SF1', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 252965),
(426378, 'PTHR30035:SF3', NULL, NULL, NULL, NULL, 'INTERMEMBRANE PHOSPHOLIPID TRANSPORT SYSTEM LIPOPROTEIN MLAA', 252965),
(426379, 'PTHR30035', NULL, NULL, NULL, NULL, 'LIPOPROTEIN VACJ-RELATED', 252965),
(426380, 'PTHR12928:SF3', NULL, NULL, NULL, NULL, 'PROTEIN FRG1', 252966),
(426381, 'PTHR12928:SF2', NULL, NULL, NULL, NULL, '', 252966),
(426382, 'PTHR12928:SF1', NULL, NULL, NULL, NULL, '', 252966),
(426383, 'PTHR12928:SF0', NULL, NULL, NULL, NULL, 'FSHD REGION GENE 1', 252966),
(426384, 'PTHR12928', NULL, NULL, NULL, NULL, 'FRG1 PROTEIN', 252966),
(426385, 'PTHR46911', NULL, NULL, NULL, NULL, '', 252967),
(426386, 'PTHR46911:SF1', NULL, NULL, NULL, NULL, '2-ISOPROPYLMALATE SYNTHASE', 252967),
(426387, 'PTHR46911:SF2', NULL, NULL, NULL, NULL, '2-ISOPROPYLMALATE SYNTHASE-RELATED', 252967),
(426388, 'PTHR46471:SF6', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE', 252968),
(426389, 'PTHR46471:SF4', NULL, NULL, NULL, NULL, 'DEACETYLASE, PUTATIVE-RELATED', 252968),
(426390, 'PTHR46471:SF2', NULL, NULL, NULL, NULL, 'CHITIN DEACETYLASE-RELATED', 252968),
(426391, 'PTHR46471', NULL, NULL, NULL, NULL, 'CHITIN DEACETYLASE', 252968),
(426392, 'PTHR46471:SF7', NULL, NULL, NULL, NULL, 'CHITIN BINDING PROTEIN', 252968);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(426393, 'PTHR43135:SF3', NULL, NULL, NULL, NULL, 'ALPHA-D-RIBOSE 1-METHYLPHOSPHONATE 5-TRIPHOSPHATE DIPHOSPHATASE', 252969),
(426394, 'PTHR43135:SF4', NULL, NULL, NULL, NULL, '', 252969),
(426395, 'PTHR43135', NULL, NULL, NULL, NULL, 'ALPHA-D-RIBOSE 1-METHYLPHOSPHONATE 5-TRIPHOSPHATE DIPHOSPHATASE', 252969),
(426396, 'PTHR21228', NULL, NULL, NULL, NULL, 'FAST LEU-RICH DOMAIN-CONTAINING', 252970),
(426397, 'PTHR21228:SF1', NULL, NULL, NULL, NULL, 'FAST KINASE DOMAIN-CONTAINING PROTEIN 2, MITOCHONDRIAL', 252970),
(426398, 'PTHR21228:SF70', NULL, NULL, NULL, NULL, 'FAST KINASE DOMAIN-CONTAINING PROTEIN 5, MITOCHONDRIAL', 252970),
(426399, 'PTHR21228:SF71', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL OLIGO_U BINDING PROTEIN TBRGG1-RELATED', 252970),
(426400, 'PTHR21228:SF50', NULL, NULL, NULL, NULL, 'AGAP000447-PA', 252970),
(426401, 'PTHR21228:SF40', NULL, NULL, NULL, NULL, 'LD32258P', 252970),
(426402, 'PTHR21228:SF53', NULL, NULL, NULL, NULL, '', 252970),
(426403, 'PTHR21228:SF9', NULL, NULL, NULL, NULL, 'FAST KINASE DOMAIN-CONTAINING PROTEIN 3, MITOCHONDRIAL', 252970),
(426404, 'PTHR21228:SF65', NULL, NULL, NULL, NULL, '', 252970),
(426405, 'PTHR21228:SF55', NULL, NULL, NULL, NULL, 'AGAP002598-PA', 252970),
(426406, 'PTHR21228:SF4', NULL, NULL, NULL, NULL, 'FAS-ACTIVATED SERINE/THREONINE KINASE', 252970),
(426407, 'PTHR21228:SF69', NULL, NULL, NULL, NULL, 'GH07286P-RELATED', 252970),
(426408, 'PTHR21228:SF59', NULL, NULL, NULL, NULL, 'FAST KINASE DOMAIN-CONTAINING PROTEIN 4', 252970),
(426409, 'PTHR21228:SF29', NULL, NULL, NULL, NULL, 'FAST KINASE DOMAIN-CONTAINING PROTEIN 1, MITOCHONDRIAL', 252970),
(426410, 'PTHR43488:SF2', NULL, NULL, NULL, NULL, 'GLUTAMATE-PYRUVATE AMINOTRANSFERASE ALAA', 252971),
(426411, 'PTHR43488', NULL, NULL, NULL, NULL, 'GLUTAMATE-PYRUVATE AMINOTRANSFERASE ALAA', 252971),
(426412, 'PTHR47097', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN BETA-3', 252972),
(426413, 'PTHR47097:SF1', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN BETA-3', 252972),
(426414, 'PTHR40274:SF4', NULL, NULL, NULL, NULL, 'BLL1406 PROTEIN', 252973),
(426415, 'PTHR40274', NULL, NULL, NULL, NULL, 'VIRGINIAMYCIN B LYASE', 252973),
(426416, 'PTHR40274:SF3', NULL, NULL, NULL, NULL, 'VIRGINIAMYCIN B LYASE', 252973),
(426417, 'PTHR38119', NULL, NULL, NULL, NULL, '', 252974),
(426418, 'PTHR38119:SF1', NULL, NULL, NULL, NULL, '', 252974),
(426419, 'PTHR38119:SF2', NULL, NULL, NULL, NULL, '', 252974),
(426420, 'PTHR43739:SF2', NULL, NULL, NULL, NULL, 'XYLOGLUCANASE (EUROFUNG)', 252975),
(426421, 'PTHR43739:SF4', NULL, NULL, NULL, NULL, 'OLIGOXYLOGLUCAN-REDUCING END-SPECIFIC XYLOGLUCANASE', 252975),
(426422, 'PTHR43739', NULL, NULL, NULL, NULL, 'XYLOGLUCANASE (EUROFUNG)', 252975),
(426423, 'PTHR15343:SF0', NULL, NULL, NULL, NULL, 'T-CELL ANTIGEN CD7', 252976),
(426424, 'PTHR15343:SF1', NULL, NULL, NULL, NULL, 'CD7 ANTIGEN-LIKE', 252976),
(426425, 'PTHR15343', NULL, NULL, NULL, NULL, 'CD7', 252976),
(426426, 'PTHR11129:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FARNESYLTRANSFERASE/GERANYLGERANYLTRANSFERASE TYPE-1 SUBUNIT ALPHA', 252977),
(426427, 'PTHR11129:SF2', NULL, NULL, NULL, NULL, 'GERANYLGERANYL TRANSFERASE TYPE-2 SUBUNIT ALPHA', 252977),
(426428, 'PTHR11129', NULL, NULL, NULL, NULL, 'PROTEIN FARNESYLTRANSFERASE ALPHA SUBUNIT/RAB GERANYLGERANYL TRANSFERASE ALPHA SUBUNIT', 252977),
(426429, 'PTHR11129:SF5', NULL, NULL, NULL, NULL, 'PROTEIN FARNESYLTRANSFERASE/GERANYLGERANYLTRANSFERASE TYPE-1 SUBUNIT ALPHA', 252977),
(426430, 'PTHR11129:SF10', NULL, NULL, NULL, NULL, 'PROTEIN PRENYLYLTRANSFERASE SUPERFAMILY PROTEIN', 252977),
(426431, 'PTHR11129:SF3', NULL, NULL, NULL, NULL, 'PROTEIN PRENYLTRANSFERASE ALPHA SUBUNIT REPEAT-CONTAINING PROTEIN 1', 252977),
(426432, 'PTHR11129:SF4', NULL, NULL, NULL, NULL, '', 252977),
(426433, 'PTHR11129:SF9', NULL, NULL, NULL, NULL, 'BNAC09G18510D PROTEIN', 252977),
(426434, 'PTHR11129:SF7', NULL, NULL, NULL, NULL, '', 252977),
(426435, 'PTHR11129:SF8', NULL, NULL, NULL, NULL, 'PROTEIN ECM9', 252977),
(426436, 'PTHR35472', NULL, NULL, NULL, NULL, '', 252978),
(426437, 'PTHR35472:SF8', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE) GENE FAMILY MEMBER MTCLE10', 252978);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(426438, 'PTHR35472:SF7', NULL, NULL, NULL, NULL, 'BNAA09G12580D PROTEIN', 252978),
(426439, 'PTHR35472:SF6', NULL, NULL, NULL, NULL, '', 252978),
(426440, 'PTHR35472:SF4', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 14', 252978),
(426441, 'PTHR35472:SF3', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE) GENE FAMILY MEMBER MTCLE05', 252978),
(426442, 'PTHR12693:SF3', NULL, NULL, NULL, NULL, 'MENIN', 252979),
(426443, 'PTHR12693', NULL, NULL, NULL, NULL, 'MENIN', 252979),
(426444, 'PTHR30027', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA SMALL SUBUNIT METHYLTRANSFERASE E', 252980),
(426445, 'PTHR30027:SF3', NULL, NULL, NULL, NULL, '16S RRNA (URACIL(1498)-N(3))-METHYLTRANSFERASE', 252980),
(426446, 'PTHR31948:SF158', NULL, NULL, NULL, NULL, 'ZF-HD HOMEOBOX PROTEIN, CYS/HIS-RICH DIMERIZATION DOMAIN-CONTAINING PROTEIN-RELATED', 252981),
(426447, 'PTHR31948:SF159', NULL, NULL, NULL, NULL, 'ZINC FINGER-HOMEODOMAIN PROTEIN', 252981),
(426448, 'PTHR31948:SF116', NULL, NULL, NULL, NULL, 'ZINC-FINGER HOMEODOMAIN PROTEIN 2', 252981),
(426449, 'PTHR31948:SF118', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN, ZF-HD CLASS_ ZF-HD HOMEOBOX PROTEIN CYS/HIS-RICH DIMERISATION REGION_ HOMEODOMAIN', 252981),
(426450, 'PTHR31948:SF119', NULL, NULL, NULL, NULL, 'ZF-HD DIMERIZATION-TYPE DOMAIN-CONTAINING PROTEIN', 252981),
(426451, 'PTHR31948:SF150', NULL, NULL, NULL, NULL, 'ZF-HD DIMERIZATION-TYPE DOMAIN-CONTAINING PROTEIN', 252981),
(426452, 'PTHR31948:SF151', NULL, NULL, NULL, NULL, 'MINI ZINC FINGER PROTEIN 1', 252981),
(426453, 'PTHR31948:SF152', NULL, NULL, NULL, NULL, 'ZF-HD DIMERIZATION-TYPE DOMAIN-CONTAINING PROTEIN', 252981),
(426454, 'PTHR31948:SF153', NULL, NULL, NULL, NULL, 'ZF-HD DIMERIZATION-TYPE DOMAIN-CONTAINING PROTEIN', 252981),
(426455, 'PTHR31948:SF110', NULL, NULL, NULL, NULL, 'ZF-HD HOMEOBOX PROTEIN, CYS/HIS-RICH DIMERIZATION DOMAIN-CONTAINING PROTEIN-RELATED', 252981),
(426456, 'PTHR31948:SF154', NULL, NULL, NULL, NULL, 'ZINC-FINGER HOMEODOMAIN PROTEIN 13', 252981),
(426457, 'PTHR31948:SF155', NULL, NULL, NULL, NULL, 'ZINC-FINGER HOMEODOMAIN PROTEIN 3', 252981),
(426458, 'PTHR31948:SF156', NULL, NULL, NULL, NULL, 'ZF-HD DIMERIZATION-TYPE DOMAIN-CONTAINING PROTEIN', 252981),
(426459, 'PTHR31948:SF59', NULL, NULL, NULL, NULL, 'ZINC-FINGER HOMEODOMAIN PROTEIN 6-LIKE', 252981),
(426460, 'PTHR31948:SF16', NULL, NULL, NULL, NULL, 'ZINC-FINGER HOMEODOMAIN PROTEIN 11', 252981),
(426461, 'PTHR31948:SF157', NULL, NULL, NULL, NULL, 'ZINC-FINGER HOMEODOMAIN PROTEIN 1', 252981),
(426462, 'PTHR31948:SF113', NULL, NULL, NULL, NULL, 'ZF-HD HOMEOBOX PROTEIN, CYS/HIS-RICH DIMERIZATION DOMAIN-CONTAINING PROTEIN-RELATED', 252981),
(426463, 'PTHR31948:SF64', NULL, NULL, NULL, NULL, 'ZINC-FINGER HOMEODOMAIN PROTEIN 6', 252981),
(426464, 'PTHR31948:SF65', NULL, NULL, NULL, NULL, 'MINI ZINC FINGER PROTEIN 1', 252981),
(426465, 'PTHR31948:SF60', NULL, NULL, NULL, NULL, 'ZINC-FINGER HOMEODOMAIN PROTEIN 5', 252981),
(426466, 'PTHR31948:SF147', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN, ZF-HD CLASS PROTEIN', 252981),
(426467, 'PTHR31948:SF148', NULL, NULL, NULL, NULL, 'MINI ZINC FINGER PROTEIN 3', 252981),
(426468, 'PTHR31948:SF149', NULL, NULL, NULL, NULL, 'MINI ZINC FINGER PROTEIN 1-LIKE', 252981),
(426469, 'PTHR31948:SF106', NULL, NULL, NULL, NULL, 'ZF-HD DIMERIZATION-TYPE DOMAIN-CONTAINING PROTEIN', 252981),
(426470, 'PTHR31948:SF108', NULL, NULL, NULL, NULL, 'ZF-HD DIMERIZATION-TYPE DOMAIN-CONTAINING PROTEIN', 252981),
(426471, 'PTHR31948:SF140', NULL, NULL, NULL, NULL, 'ZINC-FINGER HOMEODOMAIN PROTEIN 2', 252981),
(426472, 'PTHR31948:SF142', NULL, NULL, NULL, NULL, 'ZF-HD DIMERIZATION-TYPE DOMAIN-CONTAINING PROTEIN', 252981),
(426473, 'PTHR31948:SF144', NULL, NULL, NULL, NULL, 'ZINC-FINGER HOMEODOMAIN PROTEIN 10-LIKE', 252981),
(426474, 'PTHR31948:SF145', NULL, NULL, NULL, NULL, 'ZINC-FINGER HOMEODOMAIN PROTEIN 11', 252981),
(426475, 'PTHR31948:SF101', NULL, NULL, NULL, NULL, 'ZINC-FINGER HOMEODOMAIN PROTEIN 3', 252981),
(426476, 'PTHR31948:SF146', NULL, NULL, NULL, NULL, 'ZINC-FINGER HOMEODOMAIN PROTEIN 1-LIKE', 252981); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(426477, 'PTHR31948:SF79', NULL, NULL, NULL, NULL, 'ZINC-FINGER HOMEODOMAIN PROTEIN 7', 252981),
(426478, 'PTHR31948:SF75', NULL, NULL, NULL, NULL, 'ZINC-FINGER HOMEODOMAIN PROTEIN 11-LIKE', 252981),
(426479, 'PTHR31948:SF76', NULL, NULL, NULL, NULL, 'ZINC-FINGER HOMEODOMAIN PROTEIN 2-LIKE', 252981),
(426480, 'PTHR31948:SF72', NULL, NULL, NULL, NULL, 'ZINC-FINGER HOMEODOMAIN PROTEIN 10', 252981),
(426481, 'PTHR31948:SF137', NULL, NULL, NULL, NULL, 'ZINC-FINGER HOMEODOMAIN PROTEIN 9', 252981),
(426482, 'PTHR31948:SF138', NULL, NULL, NULL, NULL, 'ZINC-FINGER HOMEODOMAIN PROTEIN 7', 252981),
(426483, 'PTHR31948:SF139', NULL, NULL, NULL, NULL, 'ZINC-FINGER HOMEODOMAIN PROTEIN 2-LIKE', 252981),
(426484, 'PTHR31948', NULL, NULL, NULL, NULL, 'ZINC-FINGER HOMEODOMAIN PROTEIN 2', 252981),
(426485, 'PTHR31948:SF131', NULL, NULL, NULL, NULL, 'ZINC-FINGER HOMEODOMAIN PROTEIN 14', 252981),
(426486, 'PTHR31948:SF134', NULL, NULL, NULL, NULL, 'ZINC-FINGER HOMEODOMAIN PROTEIN 2-LIKE', 252981),
(426487, 'PTHR31948:SF135', NULL, NULL, NULL, NULL, 'ZF-HD DIMERIZATION-TYPE DOMAIN-CONTAINING PROTEIN', 252981),
(426488, 'PTHR31948:SF87', NULL, NULL, NULL, NULL, 'ZINC-FINGER HOMEODOMAIN PROTEIN 12', 252981),
(426489, 'PTHR31948:SF128', NULL, NULL, NULL, NULL, 'ZINC-FINGER HOMEODOMAIN PROTEIN 8', 252981),
(426490, 'PTHR31948:SF161', NULL, NULL, NULL, NULL, 'MINI ZINC FINGER PROTEIN 2', 252981),
(426491, 'PTHR31948:SF162', NULL, NULL, NULL, NULL, 'MINI ZINC FINGER PROTEIN 2', 252981),
(426492, 'PTHR31948:SF163', NULL, NULL, NULL, NULL, 'ZINC-FINGER HOMEODOMAIN PROTEIN 4', 252981),
(426493, 'PTHR31948:SF120', NULL, NULL, NULL, NULL, 'ZF-HD DIMERIZATION-TYPE DOMAIN-CONTAINING PROTEIN', 252981),
(426494, 'PTHR31948:SF164', NULL, NULL, NULL, NULL, 'ZF-HD DIMERIZATION-TYPE DOMAIN-CONTAINING PROTEIN', 252981),
(426495, 'PTHR31948:SF165', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR ZF-HD FAMILY-RELATED', 252981),
(426496, 'PTHR31948:SF122', NULL, NULL, NULL, NULL, 'ZF-HD DIMERIZATION-TYPE DOMAIN-CONTAINING PROTEIN', 252981),
(426497, 'PTHR31948:SF166', NULL, NULL, NULL, NULL, 'ZF-HD DIMERIZATION-TYPE DOMAIN-CONTAINING PROTEIN', 252981),
(426498, 'PTHR31948:SF57', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 252981),
(426499, 'PTHR31948:SF58', NULL, NULL, NULL, NULL, 'ZINC-FINGER HOMEODOMAIN PROTEIN 8', 252981),
(426500, 'PTHR31948:SF95', NULL, NULL, NULL, NULL, 'ZINC-FINGER HOMEODOMAIN PROTEIN 5', 252981),
(426501, 'PTHR31948:SF52', NULL, NULL, NULL, NULL, 'ZINC-FINGER HOMEODOMAIN PROTEIN 9', 252981),
(426502, 'PTHR31948:SF160', NULL, NULL, NULL, NULL, 'ZINC-FINGER HOMEODOMAIN PROTEIN 9-LIKE', 252981),
(426503, 'PTHR31948:SF93', NULL, NULL, NULL, NULL, 'ZF-HD DIMERIZATION-TYPE DOMAIN-CONTAINING PROTEIN', 252981),
(426504, 'PTHR31113:SF25', NULL, NULL, NULL, NULL, 'BNAA09G07770D PROTEIN', 252982),
(426505, 'PTHR31113:SF24', NULL, NULL, NULL, NULL, 'UPF0496 PROTEIN', 252982),
(426506, 'PTHR31113:SF13', NULL, NULL, NULL, NULL, 'BNACNNG26390D PROTEIN', 252982),
(426507, 'PTHR31113:SF38', NULL, NULL, NULL, NULL, 'UPF0496 PLANT-LIKE PROTEIN', 252982),
(426508, 'PTHR31113:SF26', NULL, NULL, NULL, NULL, 'BNAC09G51110D PROTEIN', 252982),
(426509, 'PTHR31113:SF3', NULL, NULL, NULL, NULL, 'UPF0496 PROTEIN 1', 252982),
(426510, 'PTHR31113:SF2', NULL, NULL, NULL, NULL, 'OS04G0423200 PROTEIN', 252982),
(426511, 'PTHR31113:SF28', NULL, NULL, NULL, NULL, '', 252982),
(426512, 'PTHR31113:SF5', NULL, NULL, NULL, NULL, 'OS04G0405700 PROTEIN', 252982),
(426513, 'PTHR31113:SF19', NULL, NULL, NULL, NULL, '', 252982),
(426514, 'PTHR31113:SF41', NULL, NULL, NULL, NULL, '', 252982),
(426515, 'PTHR31113:SF30', NULL, NULL, NULL, NULL, 'BNAC06G29800D PROTEIN', 252982),
(426516, 'PTHR31113:SF43', NULL, NULL, NULL, NULL, 'BNAA03G52770D PROTEIN', 252982),
(426517, 'PTHR31113:SF21', NULL, NULL, NULL, NULL, 'UPF0496 PROTEIN 5-RELATED', 252982),
(426518, 'PTHR31113:SF32', NULL, NULL, NULL, NULL, 'AT14A', 252982),
(426519, 'PTHR31113:SF31', NULL, NULL, NULL, NULL, 'BNAA06G14280D PROTEIN', 252982),
(426520, 'PTHR31113:SF42', NULL, NULL, NULL, NULL, 'UPF0496 PLANT-LIKE PROTEIN', 252982);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(426521, 'PTHR31113:SF20', NULL, NULL, NULL, NULL, 'UPF0496 PROTEIN 2-RELATED', 252982),
(426522, 'PTHR31113:SF34', NULL, NULL, NULL, NULL, 'BNAC06G29750D PROTEIN', 252982),
(426523, 'PTHR31113:SF33', NULL, NULL, NULL, NULL, '', 252982),
(426524, 'PTHR31113:SF6', NULL, NULL, NULL, NULL, 'UPF0496 PROTEIN 3', 252982),
(426525, 'PTHR31113', NULL, NULL, NULL, NULL, 'UPF0496 PROTEIN 3-RELATED', 252982),
(426526, 'PTHR33107:SF82', NULL, NULL, NULL, NULL, 'KUNITZ TYPE TRYPSIN INHIBITOR / MIRACULIN', 252983),
(426527, 'PTHR33107:SF81', NULL, NULL, NULL, NULL, 'KUNITZ TRYPSIN INHIBITOR 1-RELATED', 252983),
(426528, 'PTHR33107:SF80', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 252983),
(426529, 'PTHR33107', NULL, NULL, NULL, NULL, 'KUNITZ TRYPSIN INHIBITOR 2', 252983),
(426530, 'PTHR33107:SF39', NULL, NULL, NULL, NULL, 'LATEX SERINE PROTEINASE INHIBITOR-LIKE', 252983),
(426531, 'PTHR33107:SF38', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR 5', 252983),
(426532, 'PTHR33107:SF37', NULL, NULL, NULL, NULL, '', 252983),
(426533, 'PTHR33107:SF36', NULL, NULL, NULL, NULL, 'LIPID TRANSFER PROTEIN', 252983),
(426534, 'PTHR33107:SF79', NULL, NULL, NULL, NULL, 'MIRACULIN-LIKE', 252983),
(426535, 'PTHR33107:SF35', NULL, NULL, NULL, NULL, 'KUNITZ TRYPSIN INHIBITOR 6-RELATED', 252983),
(426536, 'PTHR33107:SF78', NULL, NULL, NULL, NULL, 'KUNITZ TYPE TRYPSIN INHIBITOR / MIRACULIN', 252983),
(426537, 'PTHR33107:SF77', NULL, NULL, NULL, NULL, 'NODULE CYSTEINE-RICH (NCR) SECRETED PEPTIDE', 252983),
(426538, 'PTHR33107:SF33', NULL, NULL, NULL, NULL, 'KUNITZ TYPE TRYPSIN INHIBITOR', 252983),
(426539, 'PTHR33107:SF31', NULL, NULL, NULL, NULL, 'KUNITZ TYPE TRYPSIN INHIBITOR 104', 252983),
(426540, 'PTHR33107:SF75', NULL, NULL, NULL, NULL, 'INHIBITOR, PUTATIVE-RELATED', 252983),
(426541, 'PTHR33107:SF73', NULL, NULL, NULL, NULL, 'MIRACULIN-LIKE', 252983),
(426542, 'PTHR33107:SF28', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE INHIBITOR 8-LIKE', 252983),
(426543, 'PTHR33107:SF26', NULL, NULL, NULL, NULL, 'MIRACULIN-LIKE', 252983),
(426544, 'PTHR33107:SF69', NULL, NULL, NULL, NULL, 'BNAANNG20080D PROTEIN', 252983),
(426545, 'PTHR33107:SF68', NULL, NULL, NULL, NULL, 'BNAC02G46470D PROTEIN', 252983),
(426546, 'PTHR33107:SF67', NULL, NULL, NULL, NULL, '', 252983),
(426547, 'PTHR33107:SF66', NULL, NULL, NULL, NULL, 'BNAA07G08350D PROTEIN', 252983),
(426548, 'PTHR33107:SF22', NULL, NULL, NULL, NULL, '', 252983),
(426549, 'PTHR33107:SF5', NULL, NULL, NULL, NULL, 'KUNITZ TRYPSIN INHIBITOR 5', 252983),
(426550, 'PTHR33107:SF21', NULL, NULL, NULL, NULL, 'KUNITZ TYPE TRYPSIN INHIBITOR / ALPHA-FUCOSIDASE', 252983),
(426551, 'PTHR33107:SF65', NULL, NULL, NULL, NULL, 'AN1-TYPE DOMAIN-CONTAINING PROTEIN', 252983),
(426552, 'PTHR33107:SF64', NULL, NULL, NULL, NULL, 'BNAA02G35870D PROTEIN', 252983),
(426553, 'PTHR33107:SF63', NULL, NULL, NULL, NULL, 'KUNITZ-TYPE PROTEASE INHIBITOR KPI-D12', 252983),
(426554, 'PTHR33107:SF62', NULL, NULL, NULL, NULL, 'MIRACULIN', 252983),
(426555, 'PTHR33107:SF61', NULL, NULL, NULL, NULL, 'KUNITZ-TYPE PROTEASE INHIBITOR', 252983),
(426556, 'PTHR33107:SF60', NULL, NULL, NULL, NULL, 'BNAANNG20090D PROTEIN', 252983),
(426557, 'PTHR33107:SF19', NULL, NULL, NULL, NULL, 'MIRACULIN-LIKE', 252983),
(426558, 'PTHR33107:SF18', NULL, NULL, NULL, NULL, 'MIRACULIN-LIKE', 252983),
(426559, 'PTHR33107:SF16', NULL, NULL, NULL, NULL, '21 KDA SEED PROTEIN-LIKE', 252983),
(426560, 'PTHR33107:SF59', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE/SUBTILISIN INHIBITOR-RELATED', 252983),
(426561, 'PTHR33107:SF58', NULL, NULL, NULL, NULL, 'KUNITZ-TYPE PROTEASE INHIBITOR KPI-D12', 252983),
(426562, 'PTHR33107:SF57', NULL, NULL, NULL, NULL, 'BNAANNG20070D PROTEIN', 252983),
(426563, 'PTHR33107:SF13', NULL, NULL, NULL, NULL, 'KUNITZ TRYPSIN INHIBITOR 3', 252983),
(426564, 'PTHR33107:SF12', NULL, NULL, NULL, NULL, 'KUNITZ TRYPSIN INHIBITOR 4', 252983),
(426565, 'PTHR33107:SF54', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEASE INHIBITOR 10', 252983),
(426566, 'PTHR33107:SF53', NULL, NULL, NULL, NULL, 'BNAC09G12270D PROTEIN', 252983),
(426567, 'PTHR33107:SF52', NULL, NULL, NULL, NULL, 'KUNITZ TRYPSIN INHIBITOR', 252983);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(426568, 'PTHR33107:SF51', NULL, NULL, NULL, NULL, 'KUNITZ TYPE TRYPSIN INHIBITOR', 252983),
(426569, 'PTHR33107:SF50', NULL, NULL, NULL, NULL, 'BNAANNG33640D PROTEIN', 252983),
(426570, 'PTHR33107:SF49', NULL, NULL, NULL, NULL, 'BNAANNG20120D PROTEIN', 252983),
(426571, 'PTHR33107:SF47', NULL, NULL, NULL, NULL, 'MIRACULIN-LIKE', 252983),
(426572, 'PTHR33107:SF46', NULL, NULL, NULL, NULL, 'BNAUNNG02310D PROTEIN', 252983),
(426573, 'PTHR33107:SF45', NULL, NULL, NULL, NULL, 'MIRACULIN', 252983),
(426574, 'PTHR33107:SF44', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE INHIBITOR 1', 252983),
(426575, 'PTHR33107:SF43', NULL, NULL, NULL, NULL, 'KUNITZ-TYPE PROTEASE INHIBITOR', 252983),
(426576, 'PTHR33107:SF42', NULL, NULL, NULL, NULL, 'BNAA09G54410D PROTEIN', 252983),
(426577, 'PTHR33107:SF41', NULL, NULL, NULL, NULL, '', 252983),
(426578, 'PTHR28642:SF1', NULL, NULL, NULL, NULL, 'MEIOSIS 1 ARREST PROTEIN', 252984),
(426579, 'PTHR28642', NULL, NULL, NULL, NULL, 'MEIOSIS 1 ARREST PROTEIN', 252984),
(426580, 'PTHR28650', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-GLYCAN BIOSYNTHESIS CLASS X PROTEIN', 252985),
(426581, 'PTHR28650:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-GLYCAN BIOSYNTHESIS CLASS X PROTEIN', 252985),
(426582, 'PTHR21142:SF2', NULL, NULL, NULL, NULL, 'BETA-SARCOGLYCAN', 252986),
(426583, 'PTHR21142', NULL, NULL, NULL, NULL, 'SARCOGLYCANS', 252986),
(426584, 'PTHR46103:SF2', NULL, NULL, NULL, NULL, 'SPOU_METHYLASE DOMAIN-CONTAINING PROTEIN', 252987),
(426585, 'PTHR46103:SF1', NULL, NULL, NULL, NULL, 'RRNA METHYLTRANSFERASE 1, MITOCHONDRIAL', 252987),
(426586, 'PTHR46103', NULL, NULL, NULL, NULL, 'RRNA METHYLTRANSFERASE 1, MITOCHONDRIAL', 252987),
(426587, 'PTHR47094:SF6', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 252988),
(426588, 'PTHR47094:SF10', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 252988),
(426589, 'PTHR47094:SF5', NULL, NULL, NULL, NULL, 'OS08G0526350 PROTEIN', 252988),
(426590, 'PTHR47094:SF4', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 252988),
(426591, 'PTHR47094', NULL, NULL, NULL, NULL, 'ELFLESS, ISOFORM B', 252988),
(426592, 'PTHR47094:SF9', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 252988),
(426593, 'PTHR47094:SF14', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE/ZINC ION BINDING PROTEIN', 252988),
(426594, 'PTHR47094:SF8', NULL, NULL, NULL, NULL, 'RING ZINC FINGER PROTEIN-RELATED', 252988),
(426595, 'PTHR47094:SF12', NULL, NULL, NULL, NULL, 'ELFLESS, ISOFORM B', 252988),
(426596, 'PTHR47094:SF7', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 252988),
(426597, 'PTHR47094:SF16', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF4-LIKE ISOFORM X1', 252988),
(426598, 'PTHR47094:SF1', NULL, NULL, NULL, NULL, 'RING ZINC FINGER-RELATED', 252988),
(426599, 'PTHR45841:SF1', NULL, NULL, NULL, NULL, 'MRNA TURNOVER PROTEIN 4 HOMOLOG', 252989),
(426600, 'PTHR45841:SF2', NULL, NULL, NULL, NULL, 'MRNA TURNOVER PROTEIN 4 HOMOLOG', 252989),
(426601, 'PTHR45841:SF3', NULL, NULL, NULL, NULL, '', 252989),
(426602, 'PTHR45841:SF4', NULL, NULL, NULL, NULL, 'RIBOSOME ASSEMBLY FACTOR MRT4', 252989),
(426603, 'PTHR45841', NULL, NULL, NULL, NULL, 'MRNA TURNOVER PROTEIN 4 MRTO4', 252989),
(426604, 'PTHR34837', NULL, NULL, NULL, NULL, 'OS05G0595500 PROTEIN', 252990),
(426605, 'PTHR34837:SF2', NULL, NULL, NULL, NULL, 'OS05G0595500 PROTEIN', 252990),
(426606, 'PTHR34837:SF3', NULL, NULL, NULL, NULL, '', 252990),
(426607, 'PTHR34837:SF1', NULL, NULL, NULL, NULL, 'LOW PROTEIN: ZINC FINGER CCCH DOMAIN PROTEIN', 252990),
(426608, 'PTHR34837:SF6', NULL, NULL, NULL, NULL, 'PLECKSTRIN-LIKE (PH) DOMAIN PROTEIN', 252990),
(426609, 'PTHR34837:SF4', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 252990),
(426610, 'PTHR46628', NULL, NULL, NULL, NULL, 'PIRNA BIOGENESIS PROTEIN EXD1', 252991),
(426611, 'PTHR46628:SF1', NULL, NULL, NULL, NULL, 'PIRNA BIOGENESIS PROTEIN EXD1', 252991),
(426612, 'PTHR31578', NULL, NULL, NULL, NULL, 'PROTEIN CBG21223-RELATED', 252992),
(426613, 'PTHR31578:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG03167', 252992);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(426614, 'PTHR31578:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG23962', 252992),
(426615, 'PTHR31578:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG08965', 252992),
(426616, 'PTHR12172', NULL, NULL, NULL, NULL, 'CELL CYCLE CHECKPOINT PROTEIN RAD17', 252993),
(426617, 'PTHR12172:SF0', NULL, NULL, NULL, NULL, 'CELL CYCLE CHECKPOINT PROTEIN RAD17', 252993),
(426618, 'PTHR12172:SF1', NULL, NULL, NULL, NULL, 'AT HOOK MOTIF FAMILY PROTEIN, EXPRESSED', 252993),
(426619, 'PTHR12172:SF2', NULL, NULL, NULL, NULL, 'CELL CYCLE CHECKPOINT PROTEIN RAD17', 252993),
(426620, 'PTHR12172:SF3', NULL, NULL, NULL, NULL, '', 252993),
(426621, 'PTHR12172:SF4', NULL, NULL, NULL, NULL, 'CHECKPOINT PROTEIN RAD17/RAD24-RELATED', 252993),
(426622, 'PTHR36870:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 17 C17ORF78 HOMOLOG', 252994),
(426623, 'PTHR36870', NULL, NULL, NULL, NULL, 'C17ORF78 ISOFORM 2', 252994),
(426624, 'PTHR23268:SF100', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 252995),
(426625, 'PTHR23268:SF102', NULL, NULL, NULL, NULL, 'IGV DOMAIN-CONTAINING PROTEIN', 252995),
(426626, 'PTHR23268:SF101', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 9', 252995),
(426627, 'PTHR23268:SF104', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 252995),
(426628, 'PTHR23268:SF106', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 5-1', 252995),
(426629, 'PTHR23268:SF105', NULL, NULL, NULL, NULL, 'NON-FUNCTIONAL T CELL RECEPTOR BETA VARIABLE 7-3-RELATED', 252995),
(426630, 'PTHR23268', NULL, NULL, NULL, NULL, 'T-CELL RECEPTOR BETA CHAIN', 252995),
(426631, 'PTHR23268:SF6', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 5-5-RELATED', 252995),
(426632, 'PTHR23268:SF82', NULL, NULL, NULL, NULL, 'NON-FUNCTIONAL T CELL RECEPTOR BETA VARIABLE 23-1-RELATED', 252995),
(426633, 'PTHR23268:SF40', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 4-2', 252995),
(426634, 'PTHR23268:SF86', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 6-8-RELATED', 252995),
(426635, 'PTHR23268:SF42', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 10-1-RELATED', 252995),
(426636, 'PTHR23268:SF20', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 7-4-RELATED', 252995),
(426637, 'PTHR23268:SF89', NULL, NULL, NULL, NULL, 'IGV DOMAIN-CONTAINING PROTEIN', 252995),
(426638, 'PTHR23268:SF108', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 7-2-RELATED', 252995),
(426639, 'PTHR23268:SF45', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 2', 252995),
(426640, 'PTHR23268:SF107', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 6-1', 252995),
(426641, 'PTHR23268:SF88', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 18', 252995),
(426642, 'PTHR23268:SF47', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 11-1', 252995),
(426643, 'PTHR23268:SF46', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA, VARIABLE 21', 252995),
(426644, 'PTHR23268:SF24', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 16', 252995),
(426645, 'PTHR23268:SF109', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 4-1', 252995),
(426646, 'PTHR23268:SF28', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 19', 252995),
(426647, 'PTHR23268:SF111', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 252995),
(426648, 'PTHR23268:SF110', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 27', 252995),
(426649, 'PTHR23268:SF19', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 6-2-RELATED', 252995),
(426650, 'PTHR23268:SF113', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 5-8', 252995),
(426651, 'PTHR23268:SF115', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 10-3', 252995),
(426652, 'PTHR23268:SF114', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 7-9', 252995),
(426653, 'PTHR23268:SF117', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 29-1', 252995),
(426654, 'PTHR23268:SF116', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 252995),
(426655, 'PTHR23268:SF92', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 3-1', 252995);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(426656, 'PTHR23268:SF91', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 12-5', 252995),
(426657, 'PTHR23268:SF93', NULL, NULL, NULL, NULL, 'NON-FUNCTIONAL T CELL RECEPTOR BETA VARIABLE 17-RELATED', 252995),
(426658, 'PTHR23268:SF30', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA CHAIN MC.7.G5-RELATED', 252995),
(426659, 'PTHR23268:SF95', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 5-4', 252995),
(426660, 'PTHR23268:SF73', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 28', 252995),
(426661, 'PTHR23268:SF54', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 24-1', 252995),
(426662, 'PTHR23268:SF98', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 4-3', 252995),
(426663, 'PTHR23268:SF75', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 13', 252995),
(426664, 'PTHR23268:SF97', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 11-3', 252995),
(426665, 'PTHR23268:SF31', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 30', 252995),
(426666, 'PTHR23268:SF119', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 252995),
(426667, 'PTHR23268:SF118', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 11-2', 252995),
(426668, 'PTHR23268:SF11', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 20-1', 252995),
(426669, 'PTHR23268:SF14', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 12-3-RELATED', 252995),
(426670, 'PTHR23268:SF13', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 252995),
(426671, 'PTHR23268:SF38', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR BETA VARIABLE 14', 252995),
(426672, 'PTHR10005:SF7', NULL, NULL, NULL, NULL, 'SKI FAMILY TRANSCRIPTIONAL COREPRESSOR 2', 252996),
(426673, 'PTHR10005:SF24', NULL, NULL, NULL, NULL, 'NUCLEAR ONCOPROTEIN', 252996),
(426674, 'PTHR10005:SF8', NULL, NULL, NULL, NULL, 'SKI FAMILY TRANSCRIPTIONAL COREPRESSOR 1', 252996),
(426675, 'PTHR10005', NULL, NULL, NULL, NULL, 'SKI ONCOGENE-RELATED', 252996),
(426676, 'PTHR10005:SF25', NULL, NULL, NULL, NULL, 'SNO ONCOGENE, ISOFORM B', 252996),
(426677, 'PTHR10005:SF26', NULL, NULL, NULL, NULL, 'CORL', 252996),
(426678, 'PTHR10005:SF15', NULL, NULL, NULL, NULL, 'SKI ONCOGENE', 252996),
(426679, 'PTHR10005:SF3', NULL, NULL, NULL, NULL, 'SKI-LIKE PROTEIN', 252996),
(426680, 'PTHR11337', NULL, NULL, NULL, NULL, 'MUCIN/PORIMIN', 252997),
(426681, 'PTHR11337:SF8', NULL, NULL, NULL, NULL, 'VISGUN, ISOFORM E', 252997),
(426682, 'PTHR11337:SF12', NULL, NULL, NULL, NULL, 'SIALOMUCIN CORE PROTEIN 24', 252997),
(426683, 'PTHR11337:SF11', NULL, NULL, NULL, NULL, 'CD164 SIALOMUCIN-LIKE 2 PROTEIN', 252997),
(426684, 'PTHR11337:SF14', NULL, NULL, NULL, NULL, 'PORIMIN', 252997),
(426685, 'PTHR47464:SF2', NULL, NULL, NULL, NULL, 'MACOILIN', 252998),
(426686, 'PTHR47464:SF3', NULL, NULL, NULL, NULL, 'MACOILIN 1', 252998),
(426687, 'PTHR47464:SF1', NULL, NULL, NULL, NULL, 'MACOILIN-LIKE', 252998),
(426688, 'PTHR47464', NULL, NULL, NULL, NULL, 'MACOILIN', 252998),
(426689, 'PTHR30023', NULL, NULL, NULL, NULL, 'D-ALANYL-D-ALANINE CARBOXYPEPTIDASE', 252999),
(426690, 'PTHR30023:SF0', NULL, NULL, NULL, NULL, 'PENICILLIN-SENSITIVE CARBOXYPEPTIDASE A', 252999),
(426691, 'PTHR17611:SF3', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC680039', 253000),
(426692, 'PTHR17611', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 253000),
(426693, 'PTHR11431:SF104', NULL, NULL, NULL, NULL, 'BNAC02G40270D PROTEIN', 253001),
(426694, 'PTHR11431:SF105', NULL, NULL, NULL, NULL, 'FERRITIN', 253001),
(426695, 'PTHR11431:SF106', NULL, NULL, NULL, NULL, 'FERRITIN', 253001),
(426696, 'PTHR11431:SF107', NULL, NULL, NULL, NULL, 'FERRITIN', 253001),
(426697, 'PTHR11431:SF122', NULL, NULL, NULL, NULL, 'FERRITIN-1, CHLOROPLASTIC', 253001),
(426698, 'PTHR11431:SF101', NULL, NULL, NULL, NULL, 'FERRITIN-2, CHLOROPLASTIC', 253001),
(426699, 'PTHR11431:SF102', NULL, NULL, NULL, NULL, 'FERRITIN-3, CHLOROPLASTIC', 253001),
(426700, 'PTHR11431:SF120', NULL, NULL, NULL, NULL, 'FERRITIN', 253001),
(426701, 'PTHR11431:SF121', NULL, NULL, NULL, NULL, 'FERRITIN-3, CHLOROPLASTIC', 253001);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(426702, 'PTHR11431:SF48', NULL, NULL, NULL, NULL, 'FERRITIN', 253001),
(426703, 'PTHR11431:SF47', NULL, NULL, NULL, NULL, 'FERRITIN LIGHT CHAIN', 253001),
(426704, 'PTHR11431:SF43', NULL, NULL, NULL, NULL, 'FERRITIN', 253001),
(426705, 'PTHR11431:SF23', NULL, NULL, NULL, NULL, 'FERRITIN', 253001),
(426706, 'PTHR11431:SF84', NULL, NULL, NULL, NULL, 'FERRITIN', 253001),
(426707, 'PTHR11431:SF40', NULL, NULL, NULL, NULL, 'BACTERIAL NON-HEME FERRITIN-LIKE PROTEIN', 253001),
(426708, 'PTHR11431', NULL, NULL, NULL, NULL, 'FERRITIN', 253001),
(426709, 'PTHR11431:SF42', NULL, NULL, NULL, NULL, 'FERRITIN', 253001),
(426710, 'PTHR11431:SF108', NULL, NULL, NULL, NULL, 'FERRITIN', 253001),
(426711, 'PTHR11431:SF80', NULL, NULL, NULL, NULL, 'FERRITIN', 253001),
(426712, 'PTHR11431:SF109', NULL, NULL, NULL, NULL, 'FERRITIN', 253001),
(426713, 'PTHR11431:SF115', NULL, NULL, NULL, NULL, 'FERRITIN', 253001),
(426714, 'PTHR11431:SF116', NULL, NULL, NULL, NULL, 'FERRITIN', 253001),
(426715, 'PTHR11431:SF117', NULL, NULL, NULL, NULL, 'FERRITIN', 253001),
(426716, 'PTHR11431:SF118', NULL, NULL, NULL, NULL, 'FERRITIN', 253001),
(426717, 'PTHR11431:SF112', NULL, NULL, NULL, NULL, 'FERRITIN', 253001),
(426718, 'PTHR11431:SF37', NULL, NULL, NULL, NULL, 'FERRITIN HEAVY CHAIN', 253001),
(426719, 'PTHR11431:SF99', NULL, NULL, NULL, NULL, 'FERRITIN', 253001),
(426720, 'PTHR11431:SF54', NULL, NULL, NULL, NULL, 'FERRITIN', 253001),
(426721, 'PTHR11431:SF78', NULL, NULL, NULL, NULL, 'FERRITIN', 253001),
(426722, 'PTHR11431:SF51', NULL, NULL, NULL, NULL, 'FERRITIN', 253001),
(426723, 'PTHR11431:SF94', NULL, NULL, NULL, NULL, 'FERRITIN', 253001),
(426724, 'PTHR11431:SF97', NULL, NULL, NULL, NULL, 'FERRITIN HEAVY POLYPEPTIDE-LIKE 17-RELATED', 253001),
(426725, 'PTHR11431:SF75', NULL, NULL, NULL, NULL, 'FERRITIN', 253001),
(426726, 'PTHR11431:SF30', NULL, NULL, NULL, NULL, 'FERRITIN, MITOCHONDRIAL', 253001),
(426727, 'PTHR11431:SF119', NULL, NULL, NULL, NULL, 'FERRITIN-2, CHLOROPLASTIC', 253001),
(426728, 'PTHR11431:SF90', NULL, NULL, NULL, NULL, 'FERRITIN-1, CHLOROPLASTIC', 253001),
(426729, 'PTHR11431:SF93', NULL, NULL, NULL, NULL, 'FERRITIN', 253001),
(426730, 'PTHR46273:SF6', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 253002),
(426731, 'PTHR46273:SF14', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR DMSR-1', 253002),
(426732, 'PTHR46273:SF4', NULL, NULL, NULL, NULL, 'AT19640P', 253002),
(426733, 'PTHR46273:SF3', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 253002),
(426734, 'PTHR46273:SF15', NULL, NULL, NULL, NULL, 'MYOSUPPRESSIN RECEPTOR 1, ISOFORM B-RELATED', 253002),
(426735, 'PTHR46273:SF16', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 253002),
(426736, 'PTHR46273:SF2', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 253002),
(426737, 'PTHR46273', NULL, NULL, NULL, NULL, 'MYOSUPPRESSIN RECEPTOR 1, ISOFORM B-RELATED', 253002),
(426738, 'PTHR46273:SF9', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 253002),
(426739, 'PTHR46273:SF11', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 253002),
(426740, 'PTHR46273:SF7', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR EGL-6 ISOFORM B', 253002),
(426741, 'PTHR45872:SF2', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 2, ISOFORM D', 253003),
(426742, 'PTHR45872:SF1', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 11', 253003),
(426743, 'PTHR45872:SF4', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 1', 253003),
(426744, 'PTHR45872:SF3', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 12', 253003),
(426745, 'PTHR45872', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 2, ISOFORM D', 253003),
(426746, 'PTHR42821:SF3', NULL, NULL, NULL, NULL, 'CATALASE B', 253004),
(426747, 'PTHR42821:SF1', NULL, NULL, NULL, NULL, 'CATALASE-B', 253004),
(426748, 'PTHR42821', NULL, NULL, NULL, NULL, 'CATALASE', 253004),
(426749, 'PTHR42732:SF3', NULL, NULL, NULL, NULL, 'HYDROLASE-RELATED', 253005);
INSERT INTO "PUBLIC"."MODEL" VALUES
(426750, 'PTHR42732', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', 253005),
(426751, 'PTHR42732:SF1', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE (EUROFUNG)', 253005),
(426752, 'PTHR42732:SF2', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_2G14520)-RELATED', 253005),
(426753, 'PTHR40044', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN-RELATED', 253006),
(426754, 'PTHR40044:SF1', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN-RELATED', 253006),
(426755, 'PTHR15153', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR LIGAND SUPERFAMILY MEMBER 9', 253007),
(426756, 'PTHR15153:SF0', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR LIGAND SUPERFAMILY MEMBER 9', 253007),
(426757, 'PTHR22650:SF8', NULL, NULL, NULL, NULL, 'PLATELET GLYCOPROTEIN IX-LIKE', 253008),
(426758, 'PTHR22650:SF6', NULL, NULL, NULL, NULL, 'PLATELET GLYCOPROTEIN IX', 253008),
(426759, 'PTHR22650:SF7', NULL, NULL, NULL, NULL, 'PLATELET GLYCOPROTEIN IB BETA CHAIN', 253008),
(426760, 'PTHR22650:SF4', NULL, NULL, NULL, NULL, 'LRRNT DOMAIN-CONTAINING PROTEIN', 253008),
(426761, 'PTHR22650', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN IB BETA', 253008),
(426762, 'PTHR21215', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 253009),
(426763, 'PTHR21215:SF0', NULL, NULL, NULL, NULL, 'LD36024P', 253009),
(426764, 'PTHR35527', NULL, NULL, NULL, NULL, 'CHOLOYLGLYCINE HYDROLASE', 253010),
(426765, 'PTHR35527:SF2', NULL, NULL, NULL, NULL, 'HYDROLASE-RELATED', 253010),
(426766, 'PTHR43793:SF1', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE CYTIDYLYLTRANSFERASE', 253011),
(426767, 'PTHR43793:SF2', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL PROTEIN HLDE', 253011),
(426768, 'PTHR43793', NULL, NULL, NULL, NULL, 'FAD SYNTHASE', 253011),
(426769, 'PTHR13789:SF172', NULL, NULL, NULL, NULL, 'HYDROXYLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G12410)-RELATED', 253012),
(426770, 'PTHR13789:SF311', NULL, NULL, NULL, NULL, 'HYDROXYLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G10180)-RELATED', 253012),
(426771, 'PTHR13789:SF147', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_2G01950)-RELATED', 253012),
(426772, 'PTHR13789:SF268', NULL, NULL, NULL, NULL, '5-METHYLPHENAZINE-1-CARBOXYLATE 1-MONOOXYGENASE', 253012),
(426773, 'PTHR13789:SF261', NULL, NULL, NULL, NULL, 'HYDROXYLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G00590)-RELATED', 253012),
(426774, 'PTHR13789:SF187', NULL, NULL, NULL, NULL, 'MONOOXYGENASE', 253012),
(426775, 'PTHR13789:SF242', NULL, NULL, NULL, NULL, 'FAD_BINDING_3 DOMAIN-CONTAINING PROTEIN', 253012),
(426776, 'PTHR13789:SF317', NULL, NULL, NULL, NULL, 'FAD_BINDING_3 DOMAIN-CONTAINING PROTEIN-RELATED', 253012),
(426777, 'PTHR13789:SF306', NULL, NULL, NULL, NULL, 'HYDROXYLASE, PUTATIVE-RELATED', 253012),
(426778, 'PTHR13789:SF307', NULL, NULL, NULL, NULL, 'HYDROXYLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G04330)-RELATED', 253012),
(426779, 'PTHR13789:SF318', NULL, NULL, NULL, NULL, 'GERANYLGERANYL DIPHOSPHATE REDUCTASE', 253012),
(426780, 'PTHR13789:SF309', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_6G14510)-RELATED', 253012),
(426781, 'PTHR13789:SF236', NULL, NULL, NULL, NULL, 'MONOOXYGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G12060)-RELATED', 253012),
(426782, 'PTHR13789:SF314', NULL, NULL, NULL, NULL, 'FAD_BINDING_3 DOMAIN-CONTAINING PROTEIN', 253012),
(426783, 'PTHR13789:SF215', NULL, NULL, NULL, NULL, 'FAD_BINDING_3 DOMAIN-CONTAINING PROTEIN-RELATED', 253012),
(426784, 'PTHR13789', NULL, NULL, NULL, NULL, 'MONOOXYGENASE', 253012),
(426785, 'PTHR13789:SF315', NULL, NULL, NULL, NULL, 'FAD-DEPENDENT MONOOXYGENASE MDPD', 253012),
(426786, 'PTHR13789:SF238', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_2G01680)-RELATED', 253012),
(426787, 'PTHR13789:SF316', NULL, NULL, NULL, NULL, 'FAD_BINDING_3 DOMAIN-CONTAINING PROTEIN', 253012),
(426788, 'PTHR36938:SF1', NULL, NULL, NULL, NULL, '', 253013),
(426789, 'PTHR36938:SF3', NULL, NULL, NULL, NULL, 'WAP DOMAIN-CONTAINING PROTEIN', 253013),
(426790, 'PTHR36938:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG18914', 253013),
(426791, 'PTHR36938', NULL, NULL, NULL, NULL, 'PROTEIN CBG26935', 253013),
(426792, 'PTHR37012', NULL, NULL, NULL, NULL, 'B-ZIP TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 253014);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(426793, 'PTHR37012:SF6', NULL, NULL, NULL, NULL, '', 253014),
(426794, 'PTHR37012:SF2', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 253014),
(426795, 'PTHR34352', NULL, NULL, NULL, NULL, 'PROTEIN YHFA', 253015),
(426796, 'PTHR34352:SF1', NULL, NULL, NULL, NULL, 'PROTEIN YHFA', 253015),
(426797, 'PTHR13800:SF41', NULL, NULL, NULL, NULL, 'PROTEIN CED-11', 253016),
(426798, 'PTHR13800:SF2', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL CATION CHANNEL SUBFAMILY M MEMBER 2', 253016),
(426799, 'PTHR13800:SF1', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL CATION CHANNEL TRPM', 253016),
(426800, 'PTHR13800:SF13', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL CATION CHANNEL SUBFAMILY M MEMBER 1', 253016),
(426801, 'PTHR13800:SF12', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL CATION CHANNEL SUBFAMILY M MEMBER-LIKE 2', 253016),
(426802, 'PTHR13800:SF44', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL CHANNEL', 253016),
(426803, 'PTHR13800:SF10', NULL, NULL, NULL, NULL, 'GTL-1', 253016),
(426804, 'PTHR13800:SF43', NULL, NULL, NULL, NULL, 'PROTEIN CBG08369', 253016),
(426805, 'PTHR13800:SF15', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL CATION CHANNEL SUBFAMILY M MEMBER 6', 253016),
(426806, 'PTHR13800:SF36', NULL, NULL, NULL, NULL, 'TRP-CHANNEL-LIKE', 253016),
(426807, 'PTHR13800', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL CATION CHANNEL, SUBFAMILY M, MEMBER 6', 253016),
(426808, 'PTHR13800:SF9', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL CATION CHANNEL SUBFAMILY M MEMBER 8', 253016),
(426809, 'PTHR13800:SF8', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL CATION CHANNEL SUBFAMILY M MEMBER 7', 253016),
(426810, 'PTHR13800:SF7', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL CATION CHANNEL SUBFAMILY M MEMBER 3', 253016),
(426811, 'PTHR13800:SF6', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL CATION CHANNEL SUBFAMILY M MEMBER 4', 253016),
(426812, 'PTHR13800:SF5', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL CATION CHANNEL SUBFAMILY M MEMBER 5', 253016),
(426813, 'PTHR31482:SF16', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253017),
(426814, 'PTHR31482:SF17', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253017),
(426815, 'PTHR31482:SF2', NULL, NULL, NULL, NULL, 'ESTS AU081301(E20138)', 253017),
(426816, 'PTHR31482:SF4', NULL, NULL, NULL, NULL, 'OS01G0806200 PROTEIN', 253017),
(426817, 'PTHR31482:SF14', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253017),
(426818, 'PTHR31482', NULL, NULL, NULL, NULL, 'ESTS AU081301(E20138)', 253017),
(426819, 'PTHR31482:SF15', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN-RELATED', 253017),
(426820, 'PTHR31482:SF9', NULL, NULL, NULL, NULL, 'F-BOX PLANT-LIKE PROTEIN', 253017),
(426821, 'PTHR31482:SF10', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253017),
(426822, 'PTHR31482:SF11', NULL, NULL, NULL, NULL, 'CYCLIN-LIKE F-BOX', 253017),
(426823, 'PTHR12430:SF0', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM20 HOMOLOG B', 253018),
(426824, 'PTHR12430:SF1', NULL, NULL, NULL, NULL, 'TOMM20-LIKE PROTEIN 1', 253018),
(426825, 'PTHR12430:SF2', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM20 HOMOLOG', 253018),
(426826, 'PTHR12430:SF3', NULL, NULL, NULL, NULL, '', 253018),
(426827, 'PTHR12430:SF4', NULL, NULL, NULL, NULL, '', 253018),
(426828, 'PTHR12430:SF5', NULL, NULL, NULL, NULL, '', 253018),
(426829, 'PTHR12430', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM20', 253018),
(426830, 'PTHR36073', NULL, NULL, NULL, NULL, '', 253019),
(426831, 'PTHR36073:SF1', NULL, NULL, NULL, NULL, 'OS01G0962100 PROTEIN', 253019),
(426832, 'PTHR37572', NULL, NULL, NULL, NULL, '', 253020),
(426833, 'PTHR37572:SF1', NULL, NULL, NULL, NULL, 'GA22863', 253020),
(426834, 'PTHR30124', NULL, NULL, NULL, NULL, 'MEMBRANE-BOUND LYTIC MUREIN TRANSGLYCOSYLASE A', 253021),
(426835, 'PTHR30124:SF0', NULL, NULL, NULL, NULL, 'MEMBRANE-BOUND LYTIC MUREIN TRANSGLYCOSYLASE A', 253021);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(426836, 'PTHR39337:SF1', NULL, NULL, NULL, NULL, 'BLR5642 PROTEIN', 253022),
(426837, 'PTHR39337', NULL, NULL, NULL, NULL, 'BLR5642 PROTEIN', 253022),
(426838, 'PTHR47239:SF1', NULL, NULL, NULL, NULL, '', 253023),
(426839, 'PTHR47239', NULL, NULL, NULL, NULL, '', 253023),
(426840, 'PTHR12246:SF16', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE ZDHHC16A', 253024),
(426841, 'PTHR12246:SF15', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 253024),
(426842, 'PTHR12246:SF18', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE', 253024),
(426843, 'PTHR12246:SF17', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 253024),
(426844, 'PTHR12246:SF14', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE ZDHHC16B', 253024),
(426845, 'PTHR12246:SF13', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE ZDHHC16', 253024),
(426846, 'PTHR12246', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE ZDHHC16', 253024),
(426847, 'PTHR40055', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR YGIV-RELATED', 253025),
(426848, 'PTHR40055:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR YGIV-RELATED', 253025),
(426849, 'PTHR40055:SF2', NULL, NULL, NULL, NULL, 'DNA GYRASE INHIBITOR', 253025),
(426850, 'PTHR20878:SF0', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 25', 253026),
(426851, 'PTHR20878', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT CONTAINING PROTEIN 25', 253026),
(426852, 'PTHR15172', NULL, NULL, NULL, NULL, 'GALACTOCEREBROSIDASE', 253027),
(426853, 'PTHR15172:SF1', NULL, NULL, NULL, NULL, 'GALACTOCEREBROSIDASE', 253027),
(426854, 'PTHR14134:SF4', NULL, NULL, NULL, NULL, 'PROTEIN NCA1', 253028),
(426855, 'PTHR14134:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RAD18', 253028),
(426856, 'PTHR14134:SF3', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253028),
(426857, 'PTHR14134', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RAD18', 253028),
(426858, 'PTHR37250', NULL, NULL, NULL, NULL, 'OS05G0496000 PROTEIN', 253029),
(426859, 'PTHR37250:SF1', NULL, NULL, NULL, NULL, 'OS05G0496000 PROTEIN', 253029),
(426860, 'PTHR12763:SF7', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 15', 253030),
(426861, 'PTHR12763:SF50', NULL, NULL, NULL, NULL, 'BNAC02G03420D PROTEIN', 253030),
(426862, 'PTHR12763:SF51', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM14-3', 253030),
(426863, 'PTHR12763:SF43', NULL, NULL, NULL, NULL, '', 253030),
(426864, 'PTHR12763:SF42', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM14-3-LIKE', 253030),
(426865, 'PTHR12763:SF56', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM14', 253030),
(426866, 'PTHR12763:SF44', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM14-2-LIKE', 253030),
(426867, 'PTHR12763:SF58', NULL, NULL, NULL, NULL, 'OS01G0157800 PROTEIN', 253030),
(426868, 'PTHR12763:SF57', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM14-2', 253030),
(426869, 'PTHR12763:SF59', NULL, NULL, NULL, NULL, '', 253030),
(426870, 'PTHR12763:SF48', NULL, NULL, NULL, NULL, 'BNACNNG03120D PROTEIN', 253030),
(426871, 'PTHR12763:SF29', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL DNAJ HOMOLOG 2', 253030),
(426872, 'PTHR12763:SF28', NULL, NULL, NULL, NULL, 'GEO10507P1-RELATED', 253030),
(426873, 'PTHR12763', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 253030),
(426874, 'PTHR30269:SF32', NULL, NULL, NULL, NULL, 'MEMBRANE TRANSPORTER PROTEIN-RELATED', 253031),
(426875, 'PTHR30269', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN YFCA', 253031),
(426876, 'PTHR30269:SF36', NULL, NULL, NULL, NULL, 'MEMBRANE TRANSPORTER PROTEIN-RELATED', 253031),
(426877, 'PTHR30269:SF25', NULL, NULL, NULL, NULL, 'MEMBRANE TRANSPORTER PROTEIN-RELATED', 253031),
(426878, 'PTHR30269:SF37', NULL, NULL, NULL, NULL, 'MEMBRANE TRANSPORTER PROTEIN-RELATED', 253031),
(426879, 'PTHR30269:SF23', NULL, NULL, NULL, NULL, 'MEMBRANE TRANSPORTER PROTEIN YDHB-RELATED', 253031),
(426880, 'PTHR30269:SF0', NULL, NULL, NULL, NULL, 'MEMBRANE TRANSPORTER PROTEIN YFCA-RELATED', 253031);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(426881, 'PTHR43357', NULL, NULL, NULL, NULL, 'INNER MEMBRANE ABC TRANSPORTER PERMEASE PROTEIN YDCV', 253032),
(426882, 'PTHR43357:SF3', NULL, NULL, NULL, NULL, 'FE(3+)-TRANSPORT SYSTEM PERMEASE PROTEIN FBPB 2', 253032),
(426883, 'PTHR43357:SF4', NULL, NULL, NULL, NULL, 'INNER MEMBRANE ABC TRANSPORTER PERMEASE PROTEIN YDCV', 253032),
(426884, 'PTHR34871', NULL, NULL, NULL, NULL, '', 253033),
(426885, 'PTHR34871:SF1', NULL, NULL, NULL, NULL, '', 253033),
(426886, 'PTHR35838', NULL, NULL, NULL, NULL, 'CHROMOSOME 21, WHOLE GENOME SHOTGUN SEQUENCE', 253034),
(426887, 'PTHR35838:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 21, WHOLE GENOME SHOTGUN SEQUENCE', 253034),
(426888, 'PTHR30288:SF0', NULL, NULL, NULL, NULL, 'FLAGELLAR HOOK-ASSOCIATED PROTEIN 2', 253035),
(426889, 'PTHR30288', NULL, NULL, NULL, NULL, 'FLAGELLAR CAP/ASSEMBLY PROTEIN FLID', 253035),
(426890, 'PTHR13293', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 253036),
(426891, 'PTHR13293:SF6', NULL, NULL, NULL, NULL, 'AKIRIN-RELATED', 253036),
(426892, 'PTHR13293:SF8', NULL, NULL, NULL, NULL, 'AKIRIN-2', 253036),
(426893, 'PTHR13293:SF9', NULL, NULL, NULL, NULL, 'AKIRIN-1', 253036),
(426894, 'PTHR11991:SF20', NULL, NULL, NULL, NULL, 'TRANSLATIONALLY CONTROLLED TUMOR PROTEIN', 253037),
(426895, 'PTHR11991:SF10', NULL, NULL, NULL, NULL, 'TCTP DOMAIN-CONTAINING PROTEIN', 253037),
(426896, 'PTHR11991:SF11', NULL, NULL, NULL, NULL, 'TRANSLATIONALLY-CONTROLLED TUMOR PROTEIN HOMOLOG', 253037),
(426897, 'PTHR11991:SF9', NULL, NULL, NULL, NULL, 'TPT1-LIKE PROTEIN-RELATED', 253037),
(426898, 'PTHR11991:SF12', NULL, NULL, NULL, NULL, 'TRANSLATIONALLY-CONTROLLED TUMOR PROTEIN-LIKE PROTEIN TPT1P8-RELATED', 253037),
(426899, 'PTHR11991:SF13', NULL, NULL, NULL, NULL, 'TRANSLATIONALLY-CONTROLLED TUMOR PROTEIN HOMOLOG', 253037),
(426900, 'PTHR11991:SF17', NULL, NULL, NULL, NULL, 'TRANSLATIONALLY CONTROLLED TUMOR PROTEIN 2', 253037),
(426901, 'PTHR11991:SF18', NULL, NULL, NULL, NULL, 'TCTP DOMAIN-CONTAINING PROTEIN', 253037),
(426902, 'PTHR11991:SF19', NULL, NULL, NULL, NULL, 'TRANSLATIONALLY CONTROLLED TUMOR PROTEIN-RELATED', 253037),
(426903, 'PTHR11991:SF0', NULL, NULL, NULL, NULL, 'TRANSLATIONALLY-CONTROLLED TUMOR PROTEIN', 253037),
(426904, 'PTHR11991', NULL, NULL, NULL, NULL, 'TRANSLATIONALLY CONTROLLED TUMOR PROTEIN-RELATED', 253037),
(426905, 'PTHR47284', NULL, NULL, NULL, NULL, 'FATTY-ACID-BINDING PROTEIN 2', 253038),
(426906, 'PTHR47284:SF3', NULL, NULL, NULL, NULL, 'FATTY-ACID-BINDING PROTEIN 2', 253038),
(426907, 'PTHR47284:SF1', NULL, NULL, NULL, NULL, 'CHALCONE--FLAVONONE ISOMERASE', 253038),
(426908, 'PTHR46872:SF17', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 253039),
(426909, 'PTHR46872:SF6', NULL, NULL, NULL, NULL, 'ELM2 DOMAIN-CONTAINING PROTEIN', 253039),
(426910, 'PTHR46872:SF7', NULL, NULL, NULL, NULL, 'ATP BINDING PROTEIN', 253039),
(426911, 'PTHR46872:SF4', NULL, NULL, NULL, NULL, 'MYB-LIKE DOMAIN-CONTAINING PROTEIN', 253039),
(426912, 'PTHR46872:SF5', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE-RELATED', 253039),
(426913, 'PTHR46872:SF11', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE, MYB-LIKE DOMAIN PROTEIN-RELATED', 253039),
(426914, 'PTHR46872:SF12', NULL, NULL, NULL, NULL, 'MYB DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 253039),
(426915, 'PTHR46872', NULL, NULL, NULL, NULL, 'DNA BINDING PROTEIN', 253039),
(426916, 'PTHR46872:SF10', NULL, NULL, NULL, NULL, 'DNA BINDING PROTEIN', 253039),
(426917, 'PTHR46872:SF16', NULL, NULL, NULL, NULL, 'BNAA08G19780D PROTEIN', 253039),
(426918, 'PTHR46872:SF13', NULL, NULL, NULL, NULL, 'ELM2 DOMAIN-CONTAINING PROTEIN', 253039),
(426919, 'PTHR46872:SF14', NULL, NULL, NULL, NULL, 'ELM2 DOMAIN-CONTAINING PROTEIN', 253039),
(426920, 'PTHR24071:SF3', NULL, NULL, NULL, NULL, 'GTP-BINDING NUCLEAR PROTEIN RAN', 253040),
(426921, 'PTHR24071:SF40', NULL, NULL, NULL, NULL, 'GTP-BINDING NUCLEAR PROTEIN', 253040),
(426922, 'PTHR24071:SF38', NULL, NULL, NULL, NULL, 'GTP-BINDING NUCLEAR PROTEIN RAN', 253040),
(426923, 'PTHR24071:SF17', NULL, NULL, NULL, NULL, 'GTP-BINDING NUCLEAR PROTEIN RAN', 253040);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(426924, 'PTHR24071:SF39', NULL, NULL, NULL, NULL, 'GTP-BINDING NUCLEAR PROTEIN RAN-3', 253040),
(426925, 'PTHR24071:SF18', NULL, NULL, NULL, NULL, 'GTP-BINDING NUCLEAR PROTEIN RAN-3', 253040),
(426926, 'PTHR24071', NULL, NULL, NULL, NULL, 'RAN GTPASE', 253040),
(426927, 'PTHR24071:SF30', NULL, NULL, NULL, NULL, 'GTP-BINDING NUCLEAR PROTEIN RAN-A1', 253040),
(426928, 'PTHR24071:SF41', NULL, NULL, NULL, NULL, 'GTP-BINDING NUCLEAR PROTEIN RAN1', 253040),
(426929, 'PTHR24071:SF42', NULL, NULL, NULL, NULL, 'GTP-BINDING NUCLEAR PROTEIN RAN-1-RELATED', 253040),
(426930, 'PTHR24071:SF20', NULL, NULL, NULL, NULL, 'GTP-BINDING NUCLEAR PROTEIN RAN-2', 253040),
(426931, 'PTHR24071:SF21', NULL, NULL, NULL, NULL, 'GTP-BINDING NUCLEAR PROTEIN', 253040),
(426932, 'PTHR24071:SF33', NULL, NULL, NULL, NULL, 'GTP-BINDING NUCLEAR PROTEIN RAN-1', 253040),
(426933, 'PTHR24071:SF23', NULL, NULL, NULL, NULL, 'GTP-BINDING NUCLEAR PROTEIN RAN', 253040),
(426934, 'PTHR24071:SF2', NULL, NULL, NULL, NULL, 'GTP-BINDING NUCLEAR PROTEIN RAN, TESTIS-SPECIFIC ISOFORM', 253040),
(426935, 'PTHR24071:SF0', NULL, NULL, NULL, NULL, 'GTP-BINDING NUCLEAR PROTEIN RAN', 253040),
(426936, 'PTHR24071:SF36', NULL, NULL, NULL, NULL, 'GTP-BINDING NUCLEAR PROTEIN', 253040),
(426937, 'PTHR24071:SF25', NULL, NULL, NULL, NULL, 'GTP-BINDING NUCLEAR PROTEIN', 253040),
(426938, 'PTHR24071:SF26', NULL, NULL, NULL, NULL, 'GTP-BINDING NUCLEAR PROTEIN RAN-4', 253040),
(426939, 'PTHR24071:SF37', NULL, NULL, NULL, NULL, 'GTP-BINDING NUCLEAR PROTEIN RAN', 253040),
(426940, 'PTHR37257:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PLASTID TRANSCRIPTIONALLY ACTIVE 7', 253041),
(426941, 'PTHR37257', NULL, NULL, NULL, NULL, 'PROTEIN PLASTID TRANSCRIPTIONALLY ACTIVE 7', 253041),
(426942, 'PTHR34853:SF5', NULL, NULL, NULL, NULL, 'LIPASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G00110)-RELATED', 253042),
(426943, 'PTHR34853:SF1', NULL, NULL, NULL, NULL, 'LIPASE 5', 253042),
(426944, 'PTHR34853', NULL, NULL, NULL, NULL, '', 253042),
(426945, 'PTHR38113:SF2', NULL, NULL, NULL, NULL, 'DUF2293 DOMAIN-CONTAINING PROTEIN', 253043),
(426946, 'PTHR38113:SF1', NULL, NULL, NULL, NULL, 'DUF2293 DOMAIN-CONTAINING PROTEIN', 253043),
(426947, 'PTHR38113', NULL, NULL, NULL, NULL, '', 253043),
(426948, 'PTHR23019', NULL, NULL, NULL, NULL, 'NUCLEAR PORE MEMBRANE GLYCOPROTEIN GP210-RELATED', 253044),
(426949, 'PTHR23019:SF1', NULL, NULL, NULL, NULL, 'NUCLEAR PORE MEMBRANE GLYCOPROTEIN 210-LIKE', 253044),
(426950, 'PTHR23019:SF0', NULL, NULL, NULL, NULL, 'NUCLEAR PORE MEMBRANE GLYCOPROTEIN 210', 253044),
(426951, 'PTHR23019:SF2', NULL, NULL, NULL, NULL, 'NUCLEAR PORE MEMBRANE GLYCOPROTEIN 210', 253044),
(426952, 'PTHR10438:SF372', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_6G10300)-RELATED', 253045),
(426953, 'PTHR10438:SF417', NULL, NULL, NULL, NULL, 'THIOREDOXIN H5', 253045),
(426954, 'PTHR10438:SF414', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 253045),
(426955, 'PTHR10438:SF458', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 253045),
(426956, 'PTHR10438:SF459', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 253045),
(426957, 'PTHR10438:SF415', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 253045),
(426958, 'PTHR10438:SF456', NULL, NULL, NULL, NULL, 'THIOREDOXIN', 253045),
(426959, 'PTHR10438:SF412', NULL, NULL, NULL, NULL, 'THIOREDOXIN F1, CHLOROPLASTIC', 253045),
(426960, 'PTHR10438:SF379', NULL, NULL, NULL, NULL, 'THIOREDOXIN', 253045),
(426961, 'PTHR10438:SF413', NULL, NULL, NULL, NULL, 'THIOREDOXIN H2', 253045),
(426962, 'PTHR10438:SF457', NULL, NULL, NULL, NULL, 'THIOREDOXIN F-TYPE 1-RELATED', 253045),
(426963, 'PTHR10438:SF410', NULL, NULL, NULL, NULL, 'THIOREDOXIN H3', 253045),
(426964, 'PTHR10438:SF454', NULL, NULL, NULL, NULL, 'THIOREDOXIN', 253045),
(426965, 'PTHR10438:SF378', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 253045),
(426966, 'PTHR10438:SF453', NULL, NULL, NULL, NULL, 'THIOREDOXIN H4', 253045),
(426967, 'PTHR10438:SF242', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE PROTEIN CXXS1', 253045);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(426968, 'PTHR10438:SF409', NULL, NULL, NULL, NULL, 'THIOREDOXIN H2-2-RELATED', 253045),
(426969, 'PTHR10438:SF408', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 253045),
(426970, 'PTHR10438:SF449', NULL, NULL, NULL, NULL, 'THIOREDOXIN-RELATED', 253045),
(426971, 'PTHR10438:SF405', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 253045),
(426972, 'PTHR10438:SF447', NULL, NULL, NULL, NULL, 'THIOREDOXIN', 253045),
(426973, 'PTHR10438:SF448', NULL, NULL, NULL, NULL, 'THIOREDOXIN H7', 253045),
(426974, 'PTHR10438:SF445', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 253045),
(426975, 'PTHR10438:SF444', NULL, NULL, NULL, NULL, 'THIOREDOXIN H-TYPE 1', 253045),
(426976, 'PTHR10438:SF442', NULL, NULL, NULL, NULL, 'THIOREDOXIN H-TYPE 2', 253045),
(426977, 'PTHR10438:SF230', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN 8', 253045),
(426978, 'PTHR10438:SF18', NULL, NULL, NULL, NULL, 'THIOREDOXIN', 253045),
(426979, 'PTHR10438:SF394', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE PROTEIN CXXS2-RELATED', 253045),
(426980, 'PTHR10438:SF392', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE PROTEIN CXXS1', 253045),
(426981, 'PTHR10438:SF439', NULL, NULL, NULL, NULL, 'THIOREDOXIN O2, MITOCHONDRIAL', 253045),
(426982, 'PTHR10438:SF437', NULL, NULL, NULL, NULL, 'THIOREDOXIN H-TYPE 2', 253045),
(426983, 'PTHR10438:SF434', NULL, NULL, NULL, NULL, 'THIOREDOXIN H9', 253045),
(426984, 'PTHR10438:SF435', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 253045),
(426985, 'PTHR10438:SF433', NULL, NULL, NULL, NULL, 'THIOREDOXIN SUPERFAMILY PROTEIN-RELATED', 253045),
(426986, 'PTHR10438:SF430', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 253045),
(426987, 'PTHR10438:SF397', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 253045),
(426988, 'PTHR10438:SF461', NULL, NULL, NULL, NULL, 'THIOREDOXIN H4-2', 253045),
(426989, 'PTHR10438:SF384', NULL, NULL, NULL, NULL, 'MONODEHYDROASCORBATE REDUCTASE (NADH)-RELATED', 253045),
(426990, 'PTHR10438:SF385', NULL, NULL, NULL, NULL, 'THIOREDOXIN', 253045),
(426991, 'PTHR10438:SF462', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 253045),
(426992, 'PTHR10438:SF382', NULL, NULL, NULL, NULL, 'THIOREDOXIN F2, CHLOROPLASTIC', 253045),
(426993, 'PTHR10438:SF460', NULL, NULL, NULL, NULL, 'THIOREDOXIN', 253045),
(426994, 'PTHR10438', NULL, NULL, NULL, NULL, 'THIOREDOXIN', 253045),
(426995, 'PTHR10438:SF425', NULL, NULL, NULL, NULL, 'THIOREDOXIN H1', 253045),
(426996, 'PTHR10438:SF107', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN 2', 253045),
(426997, 'PTHR10438:SF424', NULL, NULL, NULL, NULL, 'THIOREDOXIN H1-LIKE', 253045),
(426998, 'PTHR10438:SF388', NULL, NULL, NULL, NULL, 'THIOREDOXIN H5', 253045),
(426999, 'PTHR10438:SF465', NULL, NULL, NULL, NULL, 'THIOREDOXIN-RELATED', 253045),
(427000, 'PTHR10438:SF421', NULL, NULL, NULL, NULL, 'THIOREDOXIN H-TYPE-LIKE', 253045),
(427001, 'PTHR10438:SF422', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 253045),
(427002, 'PTHR10438:SF466', NULL, NULL, NULL, NULL, 'MONODEHYDROASCORBATE REDUCTASE (NADH)-RELATED', 253045),
(427003, 'PTHR10438:SF463', NULL, NULL, NULL, NULL, 'THIOREDOXIN-1', 253045),
(427004, 'PTHR10438:SF387', NULL, NULL, NULL, NULL, 'OS09G0559600 PROTEIN', 253045),
(427005, 'PTHR10438:SF420', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 253045),
(427006, 'PTHR10438:SF464', NULL, NULL, NULL, NULL, 'THIOREDOXIN', 253045),
(427007, 'PTHR11468:SF31', NULL, NULL, NULL, NULL, 'ALPHA-1,4 GLUCAN PHOSPHORYLASE', 253046),
(427008, 'PTHR11468:SF30', NULL, NULL, NULL, NULL, 'ALPHA-1,4 GLUCAN PHOSPHORYLASE', 253046),
(427009, 'PTHR11468:SF11', NULL, NULL, NULL, NULL, 'ALPHA-1,4 GLUCAN PHOSPHORYLASE', 253046),
(427010, 'PTHR11468:SF13', NULL, NULL, NULL, NULL, 'GLYCOGEN PHOSPHORYLASE, MUSCLE FORM', 253046),
(427011, 'PTHR11468:SF26', NULL, NULL, NULL, NULL, 'GLYCOGEN PHOSPHORYLASE, LIVER FORM', 253046),
(427012, 'PTHR11468:SF25', NULL, NULL, NULL, NULL, 'MALTODEXTRIN PHOSPHORYLASE', 253046);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(427013, 'PTHR11468:SF28', NULL, NULL, NULL, NULL, 'ALPHA-GLUCAN PHOSPHORYLASE 1', 253046),
(427014, 'PTHR11468:SF27', NULL, NULL, NULL, NULL, 'ALPHA-1,4 GLUCAN PHOSPHORYLASE L-2 ISOZYME, CHLOROPLASTIC/AMYLOPLASTIC', 253046),
(427015, 'PTHR11468:SF3', NULL, NULL, NULL, NULL, 'GLYCOGEN PHOSPHORYLASE', 253046),
(427016, 'PTHR11468:SF29', NULL, NULL, NULL, NULL, 'GLYCOGEN PHOSPHORYLASE, BRAIN FORM', 253046),
(427017, 'PTHR11468:SF4', NULL, NULL, NULL, NULL, 'ALPHA-GLUCAN PHOSPHORYLASE 2, CYTOSOLIC', 253046),
(427018, 'PTHR11468:SF2', NULL, NULL, NULL, NULL, 'GLYCOGEN PHOSPHORYLASE 2', 253046),
(427019, 'PTHR11468', NULL, NULL, NULL, NULL, 'GLYCOGEN PHOSPHORYLASE', 253046),
(427020, 'PTHR36726:SF6', NULL, NULL, NULL, NULL, 'CLE FAMILY OSCLE401 PROTEIN', 253047),
(427021, 'PTHR36726:SF5', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE) GENE FAMILY MEMBER MTCLE11', 253047),
(427022, 'PTHR36726', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 45', 253047),
(427023, 'PTHR36726:SF4', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 45', 253047),
(427024, 'PTHR36726:SF3', NULL, NULL, NULL, NULL, 'CLE FAMILY OSCLE401 PROTEIN', 253047),
(427025, 'PTHR36726:SF8', NULL, NULL, NULL, NULL, 'BNAA07G24210D PROTEIN', 253047),
(427026, 'PTHR36726:SF7', NULL, NULL, NULL, NULL, 'BNAA02G14420D PROTEIN', 253047),
(427027, 'PTHR12771:SF3', NULL, NULL, NULL, NULL, 'ELMO/CED-12 FAMILY PROTEIN', 253048),
(427028, 'PTHR12771:SF8', NULL, NULL, NULL, NULL, 'ENGULFMENT AND CELL MOTILITY PROTEIN 2', 253048),
(427029, 'PTHR12771:SF18', NULL, NULL, NULL, NULL, 'ELMO DOMAIN-CONTAINING PROTEIN 1', 253048),
(427030, 'PTHR12771:SF16', NULL, NULL, NULL, NULL, 'ENGULFMENT AND CELL MOTILITY PROTEIN 3', 253048),
(427031, 'PTHR12771:SF2', NULL, NULL, NULL, NULL, 'ELMO DOMAIN-CONTAINING PROTEIN 3', 253048),
(427032, 'PTHR12771:SF56', NULL, NULL, NULL, NULL, 'CED-12', 253048),
(427033, 'PTHR12771:SF57', NULL, NULL, NULL, NULL, 'ELMO DOMAIN-CONTAINING PROTEIN', 253048),
(427034, 'PTHR12771:SF51', NULL, NULL, NULL, NULL, 'LD01482P', 253048),
(427035, 'PTHR12771:SF27', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND ELMO DOMAIN-CONTAINING PROTEIN D', 253048),
(427036, 'PTHR12771:SF49', NULL, NULL, NULL, NULL, 'ELMO/CED-12 FAMILY PROTEIN', 253048),
(427037, 'PTHR12771:SF69', NULL, NULL, NULL, NULL, 'ELMO/CED-12 FAMILY PROTEIN-RELATED', 253048),
(427038, 'PTHR12771:SF47', NULL, NULL, NULL, NULL, 'ELMO DOMAIN-CONTAINING PROTEIN 2', 253048),
(427039, 'PTHR12771:SF23', NULL, NULL, NULL, NULL, 'ENGULFMENT AND CELL MOTILITY PROTEIN 1', 253048),
(427040, 'PTHR12771:SF67', NULL, NULL, NULL, NULL, 'ELMO/CED-12 FAMILY PROTEIN-RELATED', 253048),
(427041, 'PTHR12771:SF68', NULL, NULL, NULL, NULL, 'ELMO/CED-12 FAMILY PROTEIN', 253048),
(427042, 'PTHR12771:SF24', NULL, NULL, NULL, NULL, 'OS04G0545100 PROTEIN', 253048),
(427043, 'PTHR12771:SF43', NULL, NULL, NULL, NULL, 'OS12G0126200 PROTEIN', 253048),
(427044, 'PTHR12771:SF65', NULL, NULL, NULL, NULL, 'ELMO DOMAIN-CONTAINING PROTEIN E', 253048),
(427045, 'PTHR12771:SF66', NULL, NULL, NULL, NULL, 'ELMO DOMAIN-CONTAINING PROTEIN F', 253048),
(427046, 'PTHR12771:SF63', NULL, NULL, NULL, NULL, 'ELMO DOMAIN-CONTAINING PROTEIN', 253048),
(427047, 'PTHR12771:SF41', NULL, NULL, NULL, NULL, 'ELMO DOMAIN-CONTAINING PROTEIN C', 253048),
(427048, 'PTHR12771:SF64', NULL, NULL, NULL, NULL, 'ELMO DOMAIN-CONTAINING PROTEIN', 253048),
(427049, 'PTHR12771:SF20', NULL, NULL, NULL, NULL, 'ELMO/CED-12 FAMILY PROTEIN', 253048),
(427050, 'PTHR12771:SF60', NULL, NULL, NULL, NULL, 'ELMO DOMAIN-CONTAINING PROTEIN A-LIKE ISOFORM X1', 253048),
(427051, 'PTHR12771', NULL, NULL, NULL, NULL, 'ENGULFMENT AND CELL MOTILITY', 253048),
(427052, 'PTHR23522:SF9', NULL, NULL, NULL, NULL, 'XANTHOSINE PERMEASE', 253049),
(427053, 'PTHR23522:SF10', NULL, NULL, NULL, NULL, '3-PHENYLPROPIONIC ACID TRANSPORTER-RELATED', 253049),
(427054, 'PTHR23522:SF4', NULL, NULL, NULL, NULL, 'NUCLEOSIDE PERMEASE NUPG-RELATED', 253049),
(427055, 'PTHR23522', NULL, NULL, NULL, NULL, 'BLL5896 PROTEIN', 253049),
(427056, 'PTHR14592', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED FAM3', 253050);
INSERT INTO "PUBLIC"."MODEL" VALUES
(427057, 'PTHR14592:SF13', NULL, NULL, NULL, NULL, 'PROTEIN CBG13870', 253050),
(427058, 'PTHR14592:SF11', NULL, NULL, NULL, NULL, 'PROTEIN FAM3A', 253050),
(427059, 'PTHR14592:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM3B', 253050),
(427060, 'PTHR14592:SF12', NULL, NULL, NULL, NULL, 'ILEI DOMAIN-CONTAINING PROTEIN', 253050),
(427061, 'PTHR14592:SF10', NULL, NULL, NULL, NULL, 'PROTEIN FAM3C', 253050),
(427062, 'PTHR14592:SF9', NULL, NULL, NULL, NULL, 'PROTEIN FAM3D', 253050),
(427063, 'PTHR34553:SF2', NULL, NULL, NULL, NULL, '', 253051),
(427064, 'PTHR34553:SF4', NULL, NULL, NULL, NULL, 'G1/S-SPECIFIC CYCLIN-E PROTEIN', 253051),
(427065, 'PTHR34553:SF6', NULL, NULL, NULL, NULL, '', 253051),
(427066, 'PTHR34553:SF5', NULL, NULL, NULL, NULL, '', 253051),
(427067, 'PTHR34553:SF8', NULL, NULL, NULL, NULL, '', 253051),
(427068, 'PTHR34553:SF7', NULL, NULL, NULL, NULL, 'BNAA05G10680D PROTEIN', 253051),
(427069, 'PTHR34553', NULL, NULL, NULL, NULL, 'OS05G0597400 PROTEIN', 253051),
(427070, 'PTHR42983:SF1', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', 253052),
(427071, 'PTHR42983', NULL, NULL, NULL, NULL, 'DINITROGENASE IRON-MOLYBDENUM COFACTOR PROTEIN-RELATED', 253052),
(427072, 'PTHR47835', NULL, NULL, NULL, NULL, 'HFM1, ATP DEPENDENT DNA HELICASE HOMOLOG', 253053),
(427073, 'PTHR47835:SF2', NULL, NULL, NULL, NULL, 'SEC63 DOMAIN-CONTAINING PROTEIN', 253053),
(427074, 'PTHR36497:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG17883', 253054),
(427075, 'PTHR36497', NULL, NULL, NULL, NULL, 'PROTEIN CBG17883', 253054),
(427076, 'PTHR33143:SF60', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 253055),
(427077, 'PTHR33143:SF6', NULL, NULL, NULL, NULL, 'OS08G0102900 PROTEIN', 253055),
(427078, 'PTHR33143:SF3', NULL, NULL, NULL, NULL, 'VQ MOTIF-CONTAINING PROTEIN 17-RELATED', 253055),
(427079, 'PTHR33143:SF62', NULL, NULL, NULL, NULL, 'VQ MOTIF-CONTAINING PROTEIN 25-LIKE', 253055),
(427080, 'PTHR33143:SF61', NULL, NULL, NULL, NULL, 'PROTEIN MKS1-LIKE', 253055),
(427081, 'PTHR33143:SF4', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 253055),
(427082, 'PTHR33143:SF9', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 253055),
(427083, 'PTHR33143:SF68', NULL, NULL, NULL, NULL, 'VQ MOTIF-CONTAINING PROTEIN 8, CHLOROPLASTIC-LIKE', 253055),
(427084, 'PTHR33143:SF45', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 253055),
(427085, 'PTHR33143:SF67', NULL, NULL, NULL, NULL, 'OS10G0575401 PROTEIN', 253055),
(427086, 'PTHR33143:SF48', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 253055),
(427087, 'PTHR33143:SF47', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 253055),
(427088, 'PTHR33143:SF69', NULL, NULL, NULL, NULL, 'OS06G0603300 PROTEIN', 253055),
(427089, 'PTHR33143:SF1', NULL, NULL, NULL, NULL, 'VQ MOTIF FAMILY PROTEIN', 253055),
(427090, 'PTHR33143:SF64', NULL, NULL, NULL, NULL, 'VQ MOTIF PROTEIN', 253055),
(427091, 'PTHR33143:SF63', NULL, NULL, NULL, NULL, 'F16F4.1 PROTEIN', 253055),
(427092, 'PTHR33143:SF66', NULL, NULL, NULL, NULL, 'VQ MOTIF-CONTAINING PROTEIN 20', 253055),
(427093, 'PTHR33143:SF65', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 253055),
(427094, 'PTHR33143', NULL, NULL, NULL, NULL, 'F16F4.1 PROTEIN-RELATED', 253055),
(427095, 'PTHR33143:SF71', NULL, NULL, NULL, NULL, 'VQ MOTIF PROTEIN', 253055),
(427096, 'PTHR33143:SF70', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 253055),
(427097, 'PTHR33143:SF73', NULL, NULL, NULL, NULL, 'VQ MOTIF-CONTAINING PROTEIN 20-LIKE', 253055),
(427098, 'PTHR33143:SF72', NULL, NULL, NULL, NULL, 'VQ MOTIF-CONTAINING PROTEIN 8, CHLOROPLASTIC', 253055),
(427099, 'PTHR33143:SF50', NULL, NULL, NULL, NULL, 'PROTEIN MKS1', 253055),
(427100, 'PTHR33143:SF35', NULL, NULL, NULL, NULL, 'VQ MOTIF-CONTAINING PROTEIN 18', 253055),
(427101, 'PTHR33143:SF34', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253055),
(427102, 'PTHR33143:SF59', NULL, NULL, NULL, NULL, 'OS06G0618700 PROTEIN', 253055),
(427103, 'PTHR33143:SF53', NULL, NULL, NULL, NULL, 'OS07G0161900 PROTEIN', 253055),
(427104, 'PTHR33143:SF52', NULL, NULL, NULL, NULL, 'OS02G0539500 PROTEIN', 253055);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(427105, 'PTHR33143:SF55', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 253055),
(427106, 'PTHR33143:SF39', NULL, NULL, NULL, NULL, 'VQ DOMAIN-CONTAINING PROTEIN', 253055),
(427107, 'PTHR35708:SF3', NULL, NULL, NULL, NULL, 'GB|AAD25831.1', 253056),
(427108, 'PTHR35708:SF2', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 253056),
(427109, 'PTHR35708:SF5', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 253056),
(427110, 'PTHR35708:SF4', NULL, NULL, NULL, NULL, '', 253056),
(427111, 'PTHR35708', NULL, NULL, NULL, NULL, 'GB|AAD25831.1', 253056),
(427112, 'PTHR35708:SF7', NULL, NULL, NULL, NULL, 'BNAA09G16700D PROTEIN', 253056),
(427113, 'PTHR35708:SF6', NULL, NULL, NULL, NULL, 'BNAUNNG03850D PROTEIN', 253056),
(427114, 'PTHR35708:SF8', NULL, NULL, NULL, NULL, '', 253056),
(427115, 'PTHR32004:SF1', NULL, NULL, NULL, NULL, 'TRNA LIGASE', 253057),
(427116, 'PTHR32004', NULL, NULL, NULL, NULL, 'TRNA LIGASE', 253057),
(427117, 'PTHR34192', NULL, NULL, NULL, NULL, 'PLASTOCYANIN MAJOR ISOFORM, CHLOROPLASTIC-RELATED', 253058),
(427118, 'PTHR34192:SF10', NULL, NULL, NULL, NULL, 'PLASTOCYANIN MAJOR ISOFORM, CHLOROPLASTIC-RELATED', 253058),
(427119, 'PTHR34192:SF11', NULL, NULL, NULL, NULL, 'PLASTOCYANIN', 253058),
(427120, 'PTHR34265:SF1', NULL, NULL, NULL, NULL, 'TYPE III PANTOTHENATE KINASE', 253059),
(427121, 'PTHR34265', NULL, NULL, NULL, NULL, 'TYPE III PANTOTHENATE KINASE', 253059),
(427122, 'PTHR14336:SF19', NULL, NULL, NULL, NULL, 'PROTEIN CRAC', 253060),
(427123, 'PTHR14336:SF8', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 253060),
(427124, 'PTHR14336:SF20', NULL, NULL, NULL, NULL, 'PLECKSTRIN-LIKE (PH) DOMAIN PROTEIN', 253060),
(427125, 'PTHR14336:SF4', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY A MEMBER 1', 253060),
(427126, 'PTHR14336:SF5', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY A MEMBER 2', 253060),
(427127, 'PTHR14336', NULL, NULL, NULL, NULL, 'TANDEM PH DOMAIN CONTAINING PROTEIN', 253060),
(427128, 'PTHR14336:SF16', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 253060),
(427129, 'PTHR14336:SF15', NULL, NULL, NULL, NULL, 'DUAL ADAPTER FOR PHOSPHOTYROSINE AND 3-PHOSPHOTYROSINE AND 3-PHOSPHOINOSITIDE', 253060),
(427130, 'PTHR14336:SF18', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 253060),
(427131, 'PTHR14336:SF17', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 253060),
(427132, 'PTHR47547', NULL, NULL, NULL, NULL, '', 253061),
(427133, 'PTHR47547:SF1', NULL, NULL, NULL, NULL, 'AMINO ACID-PROTON SYMPORTER YBEC-RELATED', 253061),
(427134, 'PTHR37489', NULL, NULL, NULL, NULL, '', 253062),
(427135, 'PTHR37489:SF1', NULL, NULL, NULL, NULL, '', 253062),
(427136, 'PTHR46184:SF3', NULL, NULL, NULL, NULL, 'UNCONVENTIONAL MYOSIN-IXA', 253063),
(427137, 'PTHR46184:SF2', NULL, NULL, NULL, NULL, 'UNCONVENTIONAL MYOSIN-IXB', 253063),
(427138, 'PTHR46184', NULL, NULL, NULL, NULL, 'UNCONVENTIONAL MYOSIN-IXB-LIKE PROTEIN', 253063),
(427139, 'PTHR46184:SF5', NULL, NULL, NULL, NULL, 'HEAVY CHAIN, UNCONVENTIONAL MYOSIN', 253063),
(427140, 'PTHR13245:SF14', NULL, NULL, NULL, NULL, 'RRP15-LIKE PROTEIN', 253064),
(427141, 'PTHR13245', NULL, NULL, NULL, NULL, 'RRP15-LIKE PROTEIN', 253064),
(427142, 'PTHR44472:SF3', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 4', 253065),
(427143, 'PTHR44472:SF2', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 4-LIKE PROTEIN 1', 253065),
(427144, 'PTHR44472:SF1', NULL, NULL, NULL, NULL, 'DDB1 AND CUL4-ASSOCIATED FACTOR 4', 253065),
(427145, 'PTHR44472', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 4-RELATED', 253065),
(427146, 'PTHR44472:SF4', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 4-LIKE PROTEIN 2', 253065),
(427147, 'PTHR12606:SF30', NULL, NULL, NULL, NULL, 'SENTRIN-SPECIFIC PROTEASE 1', 253066),
(427148, 'PTHR12606:SF95', NULL, NULL, NULL, NULL, 'OS03G0344300 PROTEIN', 253066),
(427149, 'PTHR12606:SF10', NULL, NULL, NULL, NULL, 'SENTRIN-SPECIFIC PROTEASE 5', 253066),
(427150, 'PTHR12606:SF1', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE-SPECIFIC PROTEASE ESD4', 253066);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(427151, 'PTHR12606:SF112', NULL, NULL, NULL, NULL, 'OS06G0122600 PROTEIN', 253066),
(427152, 'PTHR12606:SF134', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE PROTEASE 2', 253066),
(427153, 'PTHR12606:SF113', NULL, NULL, NULL, NULL, 'OS10G0388600 PROTEIN', 253066),
(427154, 'PTHR12606:SF133', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE-SPECIFIC PROTEASE 1A', 253066),
(427155, 'PTHR12606:SF111', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE-SPECIFIC PROTEASE 1B-RELATED', 253066),
(427156, 'PTHR12606:SF138', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASES SUPERFAMILY PROTEIN-RELATED', 253066),
(427157, 'PTHR12606:SF139', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 253066),
(427158, 'PTHR12606:SF136', NULL, NULL, NULL, NULL, 'ULP1 PROTEASE FAMILY PROTEIN', 253066),
(427159, 'PTHR12606:SF137', NULL, NULL, NULL, NULL, 'WD-REPEAT PROTEIN RBAP1', 253066),
(427160, 'PTHR12606:SF9', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4930444G20 GENE-RELATED', 253066),
(427161, 'PTHR12606', NULL, NULL, NULL, NULL, 'SENTRIN/SUMO-SPECIFIC PROTEASE', 253066),
(427162, 'PTHR12606:SF131', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE-SPECIFIC PROTEASE 2', 253066),
(427163, 'PTHR12606:SF150', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 253066),
(427164, 'PTHR12606:SF145', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE-SPECIFIC PROTEASE ESD4', 253066),
(427165, 'PTHR12606:SF146', NULL, NULL, NULL, NULL, 'SI:CH211-246N15.2-RELATED', 253066),
(427166, 'PTHR12606:SF124', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 253066),
(427167, 'PTHR12606:SF143', NULL, NULL, NULL, NULL, 'OS04G0316900 PROTEIN', 253066),
(427168, 'PTHR12606:SF121', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 253066),
(427169, 'PTHR12606:SF144', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 253066),
(427170, 'PTHR12606:SF122', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 253066),
(427171, 'PTHR12606:SF149', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 253066),
(427172, 'PTHR12606:SF147', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE-SPECIFIC PROTEASE 1A', 253066),
(427173, 'PTHR12606:SF103', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE-SPECIFIC PROTEASE ESD4', 253066),
(427174, 'PTHR12606:SF148', NULL, NULL, NULL, NULL, 'SENTRIN-SPECIFIC PROTEASE 8-RELATED', 253066),
(427175, 'PTHR12606:SF141', NULL, NULL, NULL, NULL, 'GH15225P-RELATED', 253066),
(427176, 'PTHR12606:SF142', NULL, NULL, NULL, NULL, 'PROTEASE ELAD', 253066),
(427177, 'PTHR12606:SF140', NULL, NULL, NULL, NULL, 'SUMO-SPECIFIC PEPTIDASE 2', 253066),
(427178, 'PTHR12606:SF11', NULL, NULL, NULL, NULL, 'SENTRIN-SPECIFIC PROTEASE 2', 253066),
(427179, 'PTHR12606:SF16', NULL, NULL, NULL, NULL, 'SENTRIN-SPECIFIC PROTEASE 3', 253066),
(427180, 'PTHR37943', NULL, NULL, NULL, NULL, 'PROTEIN VES', 253067),
(427181, 'PTHR37943:SF1', NULL, NULL, NULL, NULL, 'PROTEIN VES', 253067),
(427182, 'PTHR46063:SF1', NULL, NULL, NULL, NULL, 'KELCH DOMAIN-CONTAINING PROTEIN 4', 253068),
(427183, 'PTHR46063', NULL, NULL, NULL, NULL, 'KELCH DOMAIN-CONTAINING PROTEIN', 253068),
(427184, 'PTHR31109', NULL, NULL, NULL, NULL, 'PROTEIN FAM207A', 253069),
(427185, 'PTHR31109:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM207A', 253069),
(427186, 'PTHR23428:SF341', NULL, NULL, NULL, NULL, 'HISTONE H2B', 253070),
(427187, 'PTHR23428:SF220', NULL, NULL, NULL, NULL, 'HISTONE H2B.4', 253070),
(427188, 'PTHR23428:SF264', NULL, NULL, NULL, NULL, 'HISTONE H2B.2', 253070),
(427189, 'PTHR23428:SF342', NULL, NULL, NULL, NULL, 'HISTONE H2B.3', 253070),
(427190, 'PTHR23428:SF265', NULL, NULL, NULL, NULL, 'HISTONE H2B', 253070),
(427191, 'PTHR23428:SF340', NULL, NULL, NULL, NULL, 'HISTONE H2B-RELATED', 253070),
(427192, 'PTHR23428:SF263', NULL, NULL, NULL, NULL, 'HISTONE H2B.8', 253070),
(427193, 'PTHR23428:SF260', NULL, NULL, NULL, NULL, 'HISTONE DOMAIN-CONTAINING PROTEIN', 253070),
(427194, 'PTHR23428', NULL, NULL, NULL, NULL, 'HISTONE H2B', 253070),
(427195, 'PTHR23428:SF307', NULL, NULL, NULL, NULL, 'HISTONE H2B', 253070),
(427196, 'PTHR23428:SF305', NULL, NULL, NULL, NULL, 'HISTONE H2B', 253070);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(427197, 'PTHR23428:SF228', NULL, NULL, NULL, NULL, 'HISTONE H2B.10', 253070),
(427198, 'PTHR23428:SF349', NULL, NULL, NULL, NULL, 'HISTONE H2B-RELATED', 253070),
(427199, 'PTHR23428:SF306', NULL, NULL, NULL, NULL, 'HISTONE H2B', 253070),
(427200, 'PTHR23428:SF347', NULL, NULL, NULL, NULL, 'HISTONE H2B.5', 253070),
(427201, 'PTHR23428:SF348', NULL, NULL, NULL, NULL, 'HISTONE DOMAIN-CONTAINING PROTEIN', 253070),
(427202, 'PTHR23428:SF301', NULL, NULL, NULL, NULL, 'HISTONE H2B', 253070),
(427203, 'PTHR23428:SF268', NULL, NULL, NULL, NULL, 'HISTONE H2B', 253070),
(427204, 'PTHR23428:SF345', NULL, NULL, NULL, NULL, 'HISTONE H2B.3', 253070),
(427205, 'PTHR23428:SF346', NULL, NULL, NULL, NULL, 'HISTONE H2B.1', 253070),
(427206, 'PTHR23428:SF343', NULL, NULL, NULL, NULL, 'HISTONE H2B', 253070),
(427207, 'PTHR23428:SF344', NULL, NULL, NULL, NULL, 'HISTONE H2B-RELATED', 253070),
(427208, 'PTHR23428:SF198', NULL, NULL, NULL, NULL, 'HISTONE H2B.6', 253070),
(427209, 'PTHR23428:SF352', NULL, NULL, NULL, NULL, 'HISTONE H2B.1', 253070),
(427210, 'PTHR23428:SF70', NULL, NULL, NULL, NULL, 'HISTONE H2B 1-RELATED', 253070),
(427211, 'PTHR23428:SF232', NULL, NULL, NULL, NULL, 'HISTONE H2B TYPE 1-M', 253070),
(427212, 'PTHR23428:SF353', NULL, NULL, NULL, NULL, 'HISTONE H2B TYPE 1-B', 253070),
(427213, 'PTHR23428:SF350', NULL, NULL, NULL, NULL, 'HISTONE H2B.4', 253070),
(427214, 'PTHR23428:SF273', NULL, NULL, NULL, NULL, 'HISTONE H2B', 253070),
(427215, 'PTHR23428:SF351', NULL, NULL, NULL, NULL, 'HISTONE H2B', 253070),
(427216, 'PTHR23428:SF72', NULL, NULL, NULL, NULL, 'HISTONE H2B.4', 253070),
(427217, 'PTHR23428:SF190', NULL, NULL, NULL, NULL, 'HISTONE H2B TYPE 1-L', 253070),
(427218, 'PTHR23428:SF29', NULL, NULL, NULL, NULL, 'HISTONE H2B VARIANT L1', 253070),
(427219, 'PTHR23428:SF318', NULL, NULL, NULL, NULL, 'HISTONE H2B TYPE 2-E1', 253070),
(427220, 'PTHR23428:SF358', NULL, NULL, NULL, NULL, 'HISTONE H2B', 253070),
(427221, 'PTHR23428:SF237', NULL, NULL, NULL, NULL, 'HISTONE H2B', 253070),
(427222, 'PTHR23428:SF359', NULL, NULL, NULL, NULL, 'HISTONE H2B TYPE 3-A', 253070),
(427223, 'PTHR23428:SF238', NULL, NULL, NULL, NULL, 'HISTONE H2B.2', 253070),
(427224, 'PTHR23428:SF312', NULL, NULL, NULL, NULL, 'HISTONE H2B', 253070),
(427225, 'PTHR23428:SF356', NULL, NULL, NULL, NULL, 'HISTONE H2B.1', 253070),
(427226, 'PTHR23428:SF357', NULL, NULL, NULL, NULL, 'HISTONE H2B TYPE 1-K', 253070),
(427227, 'PTHR23428:SF354', NULL, NULL, NULL, NULL, 'HISTONE H2B.5', 253070),
(427228, 'PTHR23428:SF311', NULL, NULL, NULL, NULL, 'HISTONE H2B', 253070),
(427229, 'PTHR23428:SF355', NULL, NULL, NULL, NULL, 'HISTONE H2B', 253070),
(427230, 'PTHR23428:SF363', NULL, NULL, NULL, NULL, 'HISTONE H2B-RELATED', 253070),
(427231, 'PTHR23428:SF364', NULL, NULL, NULL, NULL, 'HISTONE H2B TYPE 2-F', 253070),
(427232, 'PTHR23428:SF361', NULL, NULL, NULL, NULL, 'HISTONE H2B.9-LIKE', 253070),
(427233, 'PTHR23428:SF362', NULL, NULL, NULL, NULL, 'HISTONE H2B', 253070),
(427234, 'PTHR23428:SF360', NULL, NULL, NULL, NULL, 'HISTONE H2B', 253070),
(427235, 'PTHR23428:SF84', NULL, NULL, NULL, NULL, 'HISTONE H2B.1', 253070),
(427236, 'PTHR23428:SF281', NULL, NULL, NULL, NULL, 'HISTONE H2B.2', 253070),
(427237, 'PTHR23428:SF160', NULL, NULL, NULL, NULL, 'HISTONE H2B TYPE 1-H', 253070),
(427238, 'PTHR23428:SF208', NULL, NULL, NULL, NULL, 'HISTONE H2B', 253070),
(427239, 'PTHR23428:SF209', NULL, NULL, NULL, NULL, 'HISTONE H2B 5', 253070),
(427240, 'PTHR23428:SF327', NULL, NULL, NULL, NULL, 'HISTONE H2B.4', 253070),
(427241, 'PTHR23428:SF206', NULL, NULL, NULL, NULL, 'HISTONE H2B.5', 253070),
(427242, 'PTHR23428:SF77', NULL, NULL, NULL, NULL, 'HISTONE H2B TYPE 1-A', 253070),
(427243, 'PTHR23428:SF328', NULL, NULL, NULL, NULL, 'HISTONE H2B', 253070),
(427244, 'PTHR23428:SF326', NULL, NULL, NULL, NULL, 'HISTONE H2B TYPE 1-J', 253070),
(427245, 'PTHR23428:SF125', NULL, NULL, NULL, NULL, 'HISTONE H2B 3-RELATED', 253070),
(427246, 'PTHR23428:SF167', NULL, NULL, NULL, NULL, 'HISTONE H2B TYPE 3-B', 253070),
(427247, 'PTHR23428:SF365', NULL, NULL, NULL, NULL, 'HISTONE H2B', 253070);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(427248, 'PTHR23428:SF289', NULL, NULL, NULL, NULL, 'HISTONE H2B', 253070),
(427249, 'PTHR23428:SF322', NULL, NULL, NULL, NULL, 'HISTONE H2B TYPE 2-E', 253070),
(427250, 'PTHR23428:SF330', NULL, NULL, NULL, NULL, 'HISTONE H2B TYPE F-M', 253070),
(427251, 'PTHR23428:SF297', NULL, NULL, NULL, NULL, 'HISTONE H2B.5-RELATED', 253070),
(427252, 'PTHR23428:SF254', NULL, NULL, NULL, NULL, 'HISTONE H2B TYPE W-T', 253070),
(427253, 'PTHR23428:SF331', NULL, NULL, NULL, NULL, 'HISTONE H2B', 253070),
(427254, 'PTHR23428:SF298', NULL, NULL, NULL, NULL, 'HISTONE H2B TYPE 2-C-RELATED', 253070),
(427255, 'PTHR23428:SF295', NULL, NULL, NULL, NULL, 'HISTONE H2B', 253070),
(427256, 'PTHR23428:SF294', NULL, NULL, NULL, NULL, 'HISTONE H2B.11', 253070),
(427257, 'PTHR23428:SF250', NULL, NULL, NULL, NULL, 'HISTONE H2B TYPE 1-D', 253070),
(427258, 'PTHR23428:SF338', NULL, NULL, NULL, NULL, 'HISTONE H2B', 253070),
(427259, 'PTHR23428:SF339', NULL, NULL, NULL, NULL, 'HISTONE H2B TYPE 1-N', 253070),
(427260, 'PTHR23428:SF336', NULL, NULL, NULL, NULL, 'HISTONE H2B', 253070),
(427261, 'PTHR23428:SF337', NULL, NULL, NULL, NULL, 'HISTONE H2B TYPE 1-O', 253070),
(427262, 'PTHR23428:SF213', NULL, NULL, NULL, NULL, 'HISTONE H2B.6-RELATED', 253070),
(427263, 'PTHR23428:SF334', NULL, NULL, NULL, NULL, 'HISTONE H2B TYPE F-S', 253070),
(427264, 'PTHR23428:SF335', NULL, NULL, NULL, NULL, 'HISTONE H2B TYPE 1-C/E/F/G/I', 253070),
(427265, 'PTHR23428:SF214', NULL, NULL, NULL, NULL, 'HISTONE H2B', 253070),
(427266, 'PTHR23428:SF255', NULL, NULL, NULL, NULL, 'HISTONE H2B', 253070),
(427267, 'PTHR23428:SF332', NULL, NULL, NULL, NULL, 'HISTONE H2B.9', 253070),
(427268, 'PTHR23428:SF211', NULL, NULL, NULL, NULL, 'HISTONE H2B.2', 253070),
(427269, 'PTHR23428:SF178', NULL, NULL, NULL, NULL, 'HISTONE H2B.V2', 253070),
(427270, 'PTHR23428:SF333', NULL, NULL, NULL, NULL, 'HISTONE H2B', 253070),
(427271, 'PTHR47113:SF1', NULL, NULL, NULL, NULL, 'LD09343P', 253071),
(427272, 'PTHR47113', NULL, NULL, NULL, NULL, 'LD09343P', 253071),
(427273, 'PTHR22667', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 253072),
(427274, 'PTHR22667:SF0', NULL, NULL, NULL, NULL, 'AT01380P-RELATED', 253072),
(427275, 'PTHR14000:SF28', NULL, NULL, NULL, NULL, 'BNAC07G50860D PROTEIN', 253073),
(427276, 'PTHR14000:SF26', NULL, NULL, NULL, NULL, 'SANT DOMAIN-CONTAINING PROTEIN', 253073),
(427277, 'PTHR14000:SF24', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 253073),
(427278, 'PTHR14000:SF44', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 253073),
(427279, 'PTHR14000:SF42', NULL, NULL, NULL, NULL, 'DUF3755 FAMILY PROTEIN', 253073),
(427280, 'PTHR14000:SF21', NULL, NULL, NULL, NULL, '', 253073),
(427281, 'PTHR14000:SF43', NULL, NULL, NULL, NULL, '', 253073),
(427282, 'PTHR14000:SF40', NULL, NULL, NULL, NULL, 'OS05G0305700 PROTEIN', 253073),
(427283, 'PTHR14000:SF41', NULL, NULL, NULL, NULL, 'BNAC04G02950D PROTEIN', 253073),
(427284, 'PTHR14000:SF9', NULL, NULL, NULL, NULL, 'OS04G0673000 PROTEIN', 253073),
(427285, 'PTHR14000:SF6', NULL, NULL, NULL, NULL, 'OS02G0631200 PROTEIN', 253073),
(427286, 'PTHR14000:SF7', NULL, NULL, NULL, NULL, 'OS04G0523100 PROTEIN', 253073),
(427287, 'PTHR14000:SF1', NULL, NULL, NULL, NULL, 'FINGER CCCH DOMAIN PROTEIN, PUTATIVE (DUF3755)-RELATED', 253073),
(427288, 'PTHR14000', NULL, NULL, NULL, NULL, 'FINGER CCCH DOMAIN PROTEIN, PUTATIVE (DUF3755)-RELATED', 253073),
(427289, 'PTHR14000:SF17', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN', 253073),
(427290, 'PTHR14000:SF37', NULL, NULL, NULL, NULL, 'OS01G0581900 PROTEIN', 253073),
(427291, 'PTHR14000:SF38', NULL, NULL, NULL, NULL, 'OS08G0100800 PROTEIN', 253073),
(427292, 'PTHR14000:SF35', NULL, NULL, NULL, NULL, 'HISTONE H2A DEUBIQUITINASE (DUF3755)', 253073),
(427293, 'PTHR14000:SF14', NULL, NULL, NULL, NULL, '', 253073),
(427294, 'PTHR14000:SF36', NULL, NULL, NULL, NULL, 'BNAA01G06840D PROTEIN', 253073),
(427295, 'PTHR14000:SF11', NULL, NULL, NULL, NULL, 'BNAA07G24780D PROTEIN', 253073),
(427296, 'PTHR14000:SF33', NULL, NULL, NULL, NULL, '', 253073);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(427297, 'PTHR14000:SF12', NULL, NULL, NULL, NULL, 'BNAA08G25560D PROTEIN', 253073),
(427298, 'PTHR14000:SF31', NULL, NULL, NULL, NULL, 'BNAC08G42330D PROTEIN', 253073),
(427299, 'PTHR14000:SF32', NULL, NULL, NULL, NULL, 'SANT DOMAIN-CONTAINING PROTEIN', 253073),
(427300, 'PTHR14000:SF30', NULL, NULL, NULL, NULL, 'BNAC05G08300D PROTEIN', 253073),
(427301, 'PTHR32158:SF18', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253074),
(427302, 'PTHR32158:SF22', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN DDB_G0287209', 253074),
(427303, 'PTHR32158:SF21', NULL, NULL, NULL, NULL, '', 253074),
(427304, 'PTHR32158:SF20', NULL, NULL, NULL, NULL, '', 253074),
(427305, 'PTHR32158', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253074),
(427306, 'PTHR37465:SF1', NULL, NULL, NULL, NULL, 'YD REPEAT PROTEIN', 253075),
(427307, 'PTHR37465', NULL, NULL, NULL, NULL, '', 253075),
(427308, 'PTHR33929:SF1', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED KINASE REGULATOR 2-RELATED', 253076),
(427309, 'PTHR33929:SF14', NULL, NULL, NULL, NULL, '', 253076),
(427310, 'PTHR33929:SF13', NULL, NULL, NULL, NULL, '', 253076),
(427311, 'PTHR33929:SF12', NULL, NULL, NULL, NULL, '', 253076),
(427312, 'PTHR33929:SF11', NULL, NULL, NULL, NULL, 'BNACNNG37070D PROTEIN', 253076),
(427313, 'PTHR33929:SF10', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED KINASE REGULATOR 2-RELATED', 253076),
(427314, 'PTHR33929', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED KINASE REGULATOR 2-RELATED', 253076),
(427315, 'PTHR33929:SF9', NULL, NULL, NULL, NULL, '', 253076),
(427316, 'PTHR33929:SF8', NULL, NULL, NULL, NULL, 'BNAC09G28910D PROTEIN', 253076),
(427317, 'PTHR33929:SF7', NULL, NULL, NULL, NULL, 'OS05G0584400 PROTEIN', 253076),
(427318, 'PTHR33929:SF6', NULL, NULL, NULL, NULL, 'OS01G0623900 PROTEIN', 253076),
(427319, 'PTHR33929:SF4', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED KINASE REGULATOR 5', 253076),
(427320, 'PTHR42647:SF47', NULL, NULL, NULL, NULL, 'BOI-RELATED E3 UBIQUITIN-PROTEIN LIGASE 1-LIKE', 253077),
(427321, 'PTHR42647:SF69', NULL, NULL, NULL, NULL, 'BOI-RELATED E3 UBIQUITIN-PROTEIN LIGASE 3-RELATED', 253077),
(427322, 'PTHR42647:SF46', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253077),
(427323, 'PTHR42647:SF68', NULL, NULL, NULL, NULL, 'OS11G0542100 PROTEIN', 253077),
(427324, 'PTHR42647:SF67', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C2H2 FAMILY-RELATED', 253077),
(427325, 'PTHR42647:SF45', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE BOI-RELATED', 253077),
(427326, 'PTHR42647:SF44', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253077),
(427327, 'PTHR42647:SF22', NULL, NULL, NULL, NULL, 'BOI-RELATED E3 UBIQUITIN-PROTEIN LIGASE 3-RELATED', 253077),
(427328, 'PTHR42647:SF66', NULL, NULL, NULL, NULL, 'BOI-RELATED E3 UBIQUITIN-PROTEIN LIGASE 2-RELATED', 253077),
(427329, 'PTHR42647:SF49', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253077),
(427330, 'PTHR42647:SF27', NULL, NULL, NULL, NULL, 'SBP (S-RIBONUCLEASE BINDING PROTEIN) FAMILY PROTEIN', 253077),
(427331, 'PTHR42647:SF26', NULL, NULL, NULL, NULL, 'RING ZINC FINGER DOMAIN SUPERFAMILY PROTEIN-RELATED', 253077),
(427332, 'PTHR42647:SF48', NULL, NULL, NULL, NULL, 'BNAANNG11660D PROTEIN', 253077),
(427333, 'PTHR42647', NULL, NULL, NULL, NULL, 'SBP (S-RIBONUCLEASE BINDING PROTEIN) FAMILY PROTEIN', 253077),
(427334, 'PTHR42647:SF5', NULL, NULL, NULL, NULL, 'SBP (S-RIBONUCLEASE BINDING PROTEIN) FAMILY PROTEIN', 253077),
(427335, 'PTHR42647:SF6', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253077),
(427336, 'PTHR42647:SF50', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253077),
(427337, 'PTHR42647:SF72', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING DOMAIN-CONTAINING PROTEIN 4A', 253077),
(427338, 'PTHR42647:SF71', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE BOI-RELATED', 253077),
(427339, 'PTHR42647:SF70', NULL, NULL, NULL, NULL, 'SBP (S-RIBONUCLEASE-BINDING PROTEIN) FAMILY PROTEIN', 253077),
(427340, 'PTHR42647:SF32', NULL, NULL, NULL, NULL, 'BOI-RELATED E3 UBIQUITIN-PROTEIN LIGASE 3-RELATED', 253077);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(427341, 'PTHR42647:SF9', NULL, NULL, NULL, NULL, 'S-RIBONUCLEASE BINDING PROTEIN SBP1-RELATED', 253077),
(427342, 'PTHR42647:SF54', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE BOI', 253077),
(427343, 'PTHR42647:SF10', NULL, NULL, NULL, NULL, 'F2G19.2', 253077),
(427344, 'PTHR42647:SF75', NULL, NULL, NULL, NULL, 'OS02G0687500 PROTEIN', 253077),
(427345, 'PTHR42647:SF31', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253077),
(427346, 'PTHR42647:SF74', NULL, NULL, NULL, NULL, 'T4O12.11', 253077),
(427347, 'PTHR42647:SF30', NULL, NULL, NULL, NULL, 'BOI-RELATED E3 UBIQUITIN-PROTEIN LIGASE 1-LIKE', 253077),
(427348, 'PTHR42647:SF51', NULL, NULL, NULL, NULL, 'SBP (S-RIBONUCLEASE BINDING PROTEIN) FAMILY PROTEIN-RELATED', 253077),
(427349, 'PTHR42647:SF73', NULL, NULL, NULL, NULL, 'BNACNNG04220D PROTEIN', 253077),
(427350, 'PTHR42647:SF57', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253077),
(427351, 'PTHR42647:SF35', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253077),
(427352, 'PTHR42647:SF12', NULL, NULL, NULL, NULL, 'BOI-RELATED E3 UBIQUITIN-PROTEIN LIGASE 2-RELATED', 253077),
(427353, 'PTHR42647:SF34', NULL, NULL, NULL, NULL, 'BOI-RELATED E3 UBIQUITIN-PROTEIN LIGASE 1-LIKE ISOFORM X1', 253077),
(427354, 'PTHR42647:SF56', NULL, NULL, NULL, NULL, 'SBP (S-RIBONUCLEASE BINDING PROTEIN) FAMILY PROTEIN-RELATED', 253077),
(427355, 'PTHR42647:SF55', NULL, NULL, NULL, NULL, 'BOI-RELATED E3 UBIQUITIN-PROTEIN LIGASE 1', 253077),
(427356, 'PTHR42647:SF33', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253077),
(427357, 'PTHR42647:SF18', NULL, NULL, NULL, NULL, 'SBP (S-RIBONUCLEASE BINDING PROTEIN) FAMILY PROTEIN', 253077),
(427358, 'PTHR42647:SF17', NULL, NULL, NULL, NULL, '', 253077),
(427359, 'PTHR42647:SF39', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE BOI-LIKE', 253077),
(427360, 'PTHR42647:SF38', NULL, NULL, NULL, NULL, '', 253077),
(427361, 'PTHR42647:SF59', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253077),
(427362, 'PTHR42647:SF19', NULL, NULL, NULL, NULL, 'BNAA01G22460D PROTEIN', 253077),
(427363, 'PTHR42647:SF60', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE BOI-RELATED', 253077),
(427364, 'PTHR42647:SF43', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253077),
(427365, 'PTHR42647:SF21', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253077),
(427366, 'PTHR42647:SF20', NULL, NULL, NULL, NULL, 'RING ZINC FINGER DOMAIN SUPERFAMILY PROTEIN-RELATED', 253077),
(427367, 'PTHR42647:SF64', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253077),
(427368, 'PTHR15910:SF1', NULL, NULL, NULL, NULL, 'ARCHAEMETZINCIN', 253078),
(427369, 'PTHR15910', NULL, NULL, NULL, NULL, 'ARCHAEMETZINCIN', 253078),
(427370, 'PTHR46567:SF3', NULL, NULL, NULL, NULL, 'MED12 DOMAIN-CONTAINING PROTEIN', 253079),
(427371, 'PTHR46567:SF2', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II TRANSCRIPTION MEDIATORS PROTEIN', 253079),
(427372, 'PTHR46567:SF1', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 12', 253079),
(427373, 'PTHR46567', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 12', 253079),
(427374, 'PTHR46206:SF4', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 253080),
(427375, 'PTHR46206:SF3', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 253080),
(427376, 'PTHR46206', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 253080),
(427377, 'PTHR46206:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 MONOOXYGENASE AUSG-RELATED', 253080),
(427378, 'PTHR46206:SF1', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 253080),
(427379, 'PTHR46206:SF9', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 253080),
(427380, 'PTHR46206:SF8', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 253080),
(427381, 'PTHR46206:SF7', NULL, NULL, NULL, NULL, 'ENT-KAURENE OXIDASE', 253080),
(427382, 'PTHR46206:SF6', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 MONOOXYGENASE AN1598-RELATED', 253080);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(427383, 'PTHR46206:SF5', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 253080),
(427384, 'PTHR38492:SF1', NULL, NULL, NULL, NULL, 'ADROPIN', 253081),
(427385, 'PTHR38492', NULL, NULL, NULL, NULL, 'ADROPIN', 253081),
(427386, 'PTHR10460:SF48', NULL, NULL, NULL, NULL, 'BNAC03G72740D PROTEIN', 253082),
(427387, 'PTHR10460:SF26', NULL, NULL, NULL, NULL, 'ABL INTERACTOR 2', 253082),
(427388, 'PTHR10460:SF37', NULL, NULL, NULL, NULL, 'PROTEIN ABIL3-RELATED', 253082),
(427389, 'PTHR10460:SF49', NULL, NULL, NULL, NULL, '', 253082),
(427390, 'PTHR10460:SF38', NULL, NULL, NULL, NULL, 'ABI FAMILY-RELATED', 253082),
(427391, 'PTHR10460:SF0', NULL, NULL, NULL, NULL, 'ABELSON INTERACTING PROTEIN, ISOFORM D', 253082),
(427392, 'PTHR10460:SF2', NULL, NULL, NULL, NULL, 'ABL INTERACTOR 1', 253082),
(427393, 'PTHR10460:SF47', NULL, NULL, NULL, NULL, 'ABIL2, PUTATIVE-RELATED', 253082),
(427394, 'PTHR10460:SF11', NULL, NULL, NULL, NULL, 'PROTEIN ABIL5-RELATED', 253082),
(427395, 'PTHR10460:SF55', NULL, NULL, NULL, NULL, 'PROTEIN ABIL1-RELATED', 253082),
(427396, 'PTHR10460:SF7', NULL, NULL, NULL, NULL, 'ABI GENE FAMILY MEMBER 3', 253082),
(427397, 'PTHR10460:SF34', NULL, NULL, NULL, NULL, 'PROTEIN ABIL2-LIKE ISOFORM X1', 253082),
(427398, 'PTHR10460:SF42', NULL, NULL, NULL, NULL, 'BNACNNG65090D PROTEIN', 253082),
(427399, 'PTHR10460:SF31', NULL, NULL, NULL, NULL, 'PROTEIN ABIL2-LIKE ISOFORM X1', 253082),
(427400, 'PTHR10460:SF53', NULL, NULL, NULL, NULL, 'ABL INTERACTOR-LIKE PROTEIN 3-RELATED', 253082),
(427401, 'PTHR10460:SF54', NULL, NULL, NULL, NULL, 'PROTEIN ABIL2', 253082),
(427402, 'PTHR10460:SF10', NULL, NULL, NULL, NULL, 'PROTEIN ABIL3', 253082),
(427403, 'PTHR10460:SF32', NULL, NULL, NULL, NULL, 'PROTEIN ABIL4', 253082),
(427404, 'PTHR10460:SF43', NULL, NULL, NULL, NULL, 'MOSC BETA BARREL DOMAIN-CONTAINING PROTEIN DOMAIN-CONTAINING PROTEIN-RELATED', 253082),
(427405, 'PTHR10460', NULL, NULL, NULL, NULL, 'ABL INTERACTOR FAMILY MEMBER', 253082),
(427406, 'PTHR10460:SF40', NULL, NULL, NULL, NULL, 'ABL-INTERACTOR 1B', 253082),
(427407, 'PTHR10460:SF41', NULL, NULL, NULL, NULL, 'BNAA03G60460D PROTEIN', 253082),
(427408, 'PTHR10460:SF52', NULL, NULL, NULL, NULL, 'ABIL1-LIKE PROTEIN', 253082),
(427409, 'PTHR42856:SF1', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A THIOESTERASE PAAI', 253083),
(427410, 'PTHR42856', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A THIOESTERASE PAAI', 253083),
(427411, 'PTHR40066', NULL, NULL, NULL, NULL, 'UPF0473 PROTEIN CBO2561/CLC_2432', 253084),
(427412, 'PTHR40066:SF1', NULL, NULL, NULL, NULL, 'UPF0473 PROTEIN CBO2561/CLC_2432', 253084),
(427413, 'PTHR21198:SF10', NULL, NULL, NULL, NULL, 'ASPARTATE RACEMASE', 253085),
(427414, 'PTHR21198', NULL, NULL, NULL, NULL, 'GLUTAMATE RACEMASE', 253085),
(427415, 'PTHR21198:SF2', NULL, NULL, NULL, NULL, 'GLUTAMATE RACEMASE', 253085),
(427416, 'PTHR21198:SF3', NULL, NULL, NULL, NULL, 'GLUTAMATE RACEMASE', 253085),
(427417, 'PTHR21198:SF9', NULL, NULL, NULL, NULL, 'BROAD SPECIFICITY AMINO-ACID RACEMASE RACX-LIKE', 253085),
(427418, 'PTHR21198:SF7', NULL, NULL, NULL, NULL, 'ASPARTATE-GLUTAMATE RACEMASE FAMILY', 253085),
(427419, 'PTHR46342:SF1', NULL, NULL, NULL, NULL, 'ALPHA-CATULIN', 253086),
(427420, 'PTHR46342', NULL, NULL, NULL, NULL, 'ALPHA-CATULIN', 253086),
(427421, 'PTHR22774:SF11', NULL, NULL, NULL, NULL, 'CHOREIN_N DOMAIN-CONTAINING PROTEIN', 253087),
(427422, 'PTHR22774:SF20', NULL, NULL, NULL, NULL, '', 253087),
(427423, 'PTHR22774:SF18', NULL, NULL, NULL, NULL, 'AMINO-TERMINAL REGION OF CHOREIN, A TM VESICLE-MEDIATED SORTER', 253087),
(427424, 'PTHR22774:SF19', NULL, NULL, NULL, NULL, 'BNAA05G20220D PROTEIN', 253087),
(427425, 'PTHR22774:SF17', NULL, NULL, NULL, NULL, 'UHRF1-BINDING PROTEIN 1-LIKE', 253087),
(427426, 'PTHR22774', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 253087),
(427427, 'PTHR22774:SF15', NULL, NULL, NULL, NULL, 'UHRF1-BINDING PROTEIN 1', 253087),
(427428, 'PTHR19836:SF26', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S14', 253088),
(427429, 'PTHR19836:SF29', NULL, NULL, NULL, NULL, '', 253088),
(427430, 'PTHR19836:SF28', NULL, NULL, NULL, NULL, 'BNAA04G20220D PROTEIN', 253088);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(427431, 'PTHR19836:SF23', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S14', 253088),
(427432, 'PTHR19836', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S14', 253088),
(427433, 'PTHR19836:SF30', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S14', 253088),
(427434, 'PTHR19836:SF19', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S14, MITOCHONDRIAL', 253088),
(427435, 'PTHR34790', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II CORE COMPLEX PROTEINS PSBY, CHLOROPLASTIC', 253089),
(427436, 'PTHR34790:SF3', NULL, NULL, NULL, NULL, 'BNAA07G38700D PROTEIN', 253089),
(427437, 'PTHR34790:SF2', NULL, NULL, NULL, NULL, '', 253089),
(427438, 'PTHR34790:SF1', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II CORE COMPLEX PROTEINS PSBY, CHLOROPLASTIC', 253089),
(427439, 'PTHR24414:SF89', NULL, NULL, NULL, NULL, 'OS09G0292900 PROTEIN', 253090),
(427440, 'PTHR24414:SF85', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427441, 'PTHR24414:SF82', NULL, NULL, NULL, NULL, 'GALACTOSE OXIDASE/KELCH REPEAT SUPERFAMILY PROTEIN', 253090),
(427442, 'PTHR24414:SF83', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427443, 'PTHR24414:SF109', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427444, 'PTHR24414:SF106', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427445, 'PTHR24414:SF105', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427446, 'PTHR24414:SF108', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427447, 'PTHR24414:SF107', NULL, NULL, NULL, NULL, 'BNAA04G27990D PROTEIN', 253090),
(427448, 'PTHR24414:SF103', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427449, 'PTHR24414:SF185', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427450, 'PTHR24414:SF91', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427451, 'PTHR24414:SF184', NULL, NULL, NULL, NULL, 'GALACTOSE OXIDASE/KELCH REPEAT SUPERFAMILY PROTEIN', 253090),
(427452, 'PTHR24414:SF90', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427453, 'PTHR24414:SF77', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427454, 'PTHR24414:SF78', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427455, 'PTHR24414:SF75', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427456, 'PTHR24414:SF72', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427457, 'PTHR24414:SF116', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427458, 'PTHR24414:SF119', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427459, 'PTHR24414:SF79', NULL, NULL, NULL, NULL, 'F-BOX/KELCH-REPEAT PROTEIN', 253090),
(427460, 'PTHR24414:SF118', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427461, 'PTHR24414:SF113', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427462, 'PTHR24414:SF112', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427463, 'PTHR24414:SF115', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427464, 'PTHR24414:SF197', NULL, NULL, NULL, NULL, 'BNAC08G11820D PROTEIN', 253090),
(427465, 'PTHR24414:SF196', NULL, NULL, NULL, NULL, 'BNACNNG12250D PROTEIN', 253090),
(427466, 'PTHR24414:SF111', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427467, 'PTHR24414:SF199', NULL, NULL, NULL, NULL, 'F-BOX/KELCH-REPEAT PROTEIN SKIP6-LIKE', 253090),
(427468, 'PTHR24414:SF198', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427469, 'PTHR24414:SF80', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427470, 'PTHR24414:SF193', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427471, 'PTHR24414:SF192', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427472, 'PTHR24414:SF195', NULL, NULL, NULL, NULL, 'F-BOX/KELCH-REPEAT PROTEIN SKIP30-LIKE', 253090),
(427473, 'PTHR24414:SF194', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(427474, 'PTHR24414:SF191', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427475, 'PTHR24414:SF23', NULL, NULL, NULL, NULL, 'F-BOX/KELCH-REPEAT PROTEIN SKIP6', 253090),
(427476, 'PTHR24414', NULL, NULL, NULL, NULL, 'F-BOX/KELCH-REPEAT PROTEIN SKIP4', 253090),
(427477, 'PTHR24414:SF128', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427478, 'PTHR24414:SF27', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 10', 253090),
(427479, 'PTHR24414:SF127', NULL, NULL, NULL, NULL, 'BNAC03G15240D PROTEIN', 253090),
(427480, 'PTHR24414:SF129', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427481, 'PTHR24414:SF124', NULL, NULL, NULL, NULL, 'BNAANNG24250D PROTEIN', 253090),
(427482, 'PTHR24414:SF123', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427483, 'PTHR24414:SF125', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427484, 'PTHR24414:SF122', NULL, NULL, NULL, NULL, 'BNAC03G72150D PROTEIN', 253090),
(427485, 'PTHR24414:SF121', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427486, 'PTHR24414:SF99', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427487, 'PTHR24414:SF97', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 253090),
(427488, 'PTHR24414:SF98', NULL, NULL, NULL, NULL, 'F-BOX/KELCH-REPEAT PROTEIN SKIP4', 253090),
(427489, 'PTHR24414:SF95', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427490, 'PTHR24414:SF138', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427491, 'PTHR24414:SF135', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427492, 'PTHR24414:SF134', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427493, 'PTHR24414:SF137', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427494, 'PTHR24414:SF136', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427495, 'PTHR24414:SF131', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427496, 'PTHR24414:SF130', NULL, NULL, NULL, NULL, 'BNAA07G08790D PROTEIN', 253090),
(427497, 'PTHR24414:SF132', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427498, 'PTHR24414:SF44', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427499, 'PTHR24414:SF40', NULL, NULL, NULL, NULL, 'F-BOX/KELCH-REPEAT PROTEIN SKIP30', 253090),
(427500, 'PTHR24414:SF149', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427501, 'PTHR24414:SF146', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427502, 'PTHR24414:SF145', NULL, NULL, NULL, NULL, 'BNAA07G38780D PROTEIN', 253090),
(427503, 'PTHR24414:SF148', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427504, 'PTHR24414:SF147', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427505, 'PTHR24414:SF142', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427506, 'PTHR24414:SF141', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427507, 'PTHR24414:SF144', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427508, 'PTHR24414:SF143', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427509, 'PTHR24414:SF140', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427510, 'PTHR24414:SF31', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN AFR', 253090),
(427511, 'PTHR24414:SF39', NULL, NULL, NULL, NULL, 'OS02G0574900 PROTEIN', 253090),
(427512, 'PTHR24414:SF157', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427513, 'PTHR24414:SF156', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427514, 'PTHR24414:SF158', NULL, NULL, NULL, NULL, 'BNAA04G14990D PROTEIN', 253090),
(427515, 'PTHR24414:SF153', NULL, NULL, NULL, NULL, 'BNACNNG54800D PROTEIN', 253090),
(427516, 'PTHR24414:SF152', NULL, NULL, NULL, NULL, 'BNAA08G05200D PROTEIN', 253090),
(427517, 'PTHR24414:SF155', NULL, NULL, NULL, NULL, 'BNAA02G16540D PROTEIN', 253090);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(427518, 'PTHR24414:SF154', NULL, NULL, NULL, NULL, 'BNAC05G49580D PROTEIN', 253090),
(427519, 'PTHR24414:SF151', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427520, 'PTHR24414:SF150', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427521, 'PTHR24414:SF65', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427522, 'PTHR24414:SF62', NULL, NULL, NULL, NULL, 'BNAA08G31090D PROTEIN', 253090),
(427523, 'PTHR24414:SF63', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 46', 253090),
(427524, 'PTHR24414:SF60', NULL, NULL, NULL, NULL, 'OS03G0415400 PROTEIN', 253090),
(427525, 'PTHR24414:SF68', NULL, NULL, NULL, NULL, 'GALACTOSE OXIDASE/KELCH REPEAT SUPERFAMILY PROTEIN-RELATED', 253090),
(427526, 'PTHR24414:SF201', NULL, NULL, NULL, NULL, 'KELCH MOTIF FAMILY PROTEIN, EXPRESSED', 253090),
(427527, 'PTHR24414:SF168', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427528, 'PTHR24414:SF200', NULL, NULL, NULL, NULL, '', 253090),
(427529, 'PTHR24414:SF202', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427530, 'PTHR24414:SF169', NULL, NULL, NULL, NULL, 'BNAA04G14980D PROTEIN', 253090),
(427531, 'PTHR24414:SF164', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427532, 'PTHR24414:SF166', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427533, 'PTHR24414:SF165', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427534, 'PTHR24414:SF160', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427535, 'PTHR24414:SF70', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427536, 'PTHR24414:SF162', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427537, 'PTHR24414:SF161', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427538, 'PTHR24414:SF178', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427539, 'PTHR24414:SF175', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427540, 'PTHR24414:SF174', NULL, NULL, NULL, NULL, 'BNAA06G40530D PROTEIN', 253090),
(427541, 'PTHR24414:SF177', NULL, NULL, NULL, NULL, 'BNAA09G00090D PROTEIN', 253090),
(427542, 'PTHR24414:SF176', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427543, 'PTHR24414:SF171', NULL, NULL, NULL, NULL, 'BNAANNG03980D PROTEIN', 253090),
(427544, 'PTHR24414:SF170', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427545, 'PTHR24414:SF173', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253090),
(427546, 'PTHR24414:SF172', NULL, NULL, NULL, NULL, 'BNAANNG12840D PROTEIN', 253090),
(427547, 'PTHR18866:SF33', NULL, NULL, NULL, NULL, 'METHYLCROTONOYL-COA CARBOXYLASE SUBUNIT ALPHA, MITOCHONDRIAL-RELATED', 253091),
(427548, 'PTHR18866', NULL, NULL, NULL, NULL, 'CARBOXYLASE:PYRUVATE/ACETYL-COA/PROPIONYL-COA CARBOXYLASE', 253091),
(427549, 'PTHR18866:SF126', NULL, NULL, NULL, NULL, 'BIOTIN CARBOXYL CARRIER PROTEIN', 253091),
(427550, 'PTHR14382', NULL, NULL, NULL, NULL, 'MDM2-BINDING PROTEIN', 253092),
(427551, 'PTHR14382:SF1', NULL, NULL, NULL, NULL, 'MDM2-BINDING PROTEIN', 253092),
(427552, 'PTHR35276', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 253093),
(427553, 'PTHR35276:SF1', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', 253093),
(427554, 'PTHR31424', NULL, NULL, NULL, NULL, 'PROTEIN CBG23806', 253094),
(427555, 'PTHR31424:SF4', NULL, NULL, NULL, NULL, 'ENHANCED RNAI (RNA INTERFERENCE)', 253094),
(427556, 'PTHR31424:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG23806', 253094),
(427557, 'PTHR45869', NULL, NULL, NULL, NULL, 'C-REACTIVE PROTEIN-RELATED', 253095),
(427558, 'PTHR45869:SF2', NULL, NULL, NULL, NULL, 'PENTAXIN-RELATED', 253095),
(427559, 'PTHR45869:SF8', NULL, NULL, NULL, NULL, '', 253095),
(427560, 'PTHR45869:SF7', NULL, NULL, NULL, NULL, 'C-REACTIVE PROTEIN', 253095),
(427561, 'PTHR45869:SF6', NULL, NULL, NULL, NULL, 'MUCOSAL PENTRAXIN-RELATED', 253095);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(427562, 'PTHR45869:SF5', NULL, NULL, NULL, NULL, 'SERUM AMYLOID P-COMPONENT', 253095),
(427563, 'PTHR46985:SF2', NULL, NULL, NULL, NULL, 'APOPTOSIS-ASSOCIATED SPECK-LIKE PROTEIN CONTAINING A CARD', 253096),
(427564, 'PTHR46985:SF4', NULL, NULL, NULL, NULL, 'CASPASE RECRUITMENT DOMAIN-CONTAINING PROTEIN 8', 253096),
(427565, 'PTHR46985', NULL, NULL, NULL, NULL, 'NACHT, LRR AND PYD DOMAINS-CONTAINING PROTEIN 1', 253096),
(427566, 'PTHR46985:SF3', NULL, NULL, NULL, NULL, 'NACHT, LRR AND PYD DOMAINS-CONTAINING PROTEIN 1', 253096),
(427567, 'PTHR32481:SF0', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE YPDE-RELATED', 253097),
(427568, 'PTHR32481:SF20', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE YSDC-RELATED', 253097),
(427569, 'PTHR32481:SF7', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE YHFE-RELATED', 253097),
(427570, 'PTHR32481', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE', 253097),
(427571, 'PTHR32481:SF6', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 253097),
(427572, 'PTHR32481:SF5', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 253097),
(427573, 'PTHR32481:SF12', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE SGCX-RELATED', 253097),
(427574, 'PTHR32481:SF9', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', 253097),
(427575, 'PTHR32481:SF21', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE YSDC-RELATED', 253097),
(427576, 'PTHR15079:SF12', NULL, NULL, NULL, NULL, 'MYELOID DIFFERENTIATION PRIMARY RESPONSE PROTEIN MYD88', 253098),
(427577, 'PTHR15079:SF3', NULL, NULL, NULL, NULL, 'MYELOID DIFFERENTIATION PRIMARY RESPONSE PROTEIN MYD88', 253098),
(427578, 'PTHR15079:SF10', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 253098),
(427579, 'PTHR15079:SF11', NULL, NULL, NULL, NULL, 'MYELOID DIFFERENTIATION PRIMARY RESPONSE PROTEIN MYD88', 253098),
(427580, 'PTHR15079', NULL, NULL, NULL, NULL, 'MYD88', 253098),
(427581, 'PTHR37857', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 273', 253099),
(427582, 'PTHR37857:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 273', 253099),
(427583, 'PTHR47795', NULL, NULL, NULL, NULL, 'UBIQUITIN AND WLM DOMAIN-CONTAINING METALLOPROTEASE SPCC1442.07C', 253100),
(427584, 'PTHR47795:SF1', NULL, NULL, NULL, NULL, 'DNA-DEPENDENT METALLOPROTEASE WSS1 HOMOLOG 2', 253100),
(427585, 'PTHR33221:SF4', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REPRESSOR NSRR', 253101),
(427586, 'PTHR33221:SF5', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR ISCR', 253101),
(427587, 'PTHR33221:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', 253101),
(427588, 'PTHR33221:SF9', NULL, NULL, NULL, NULL, 'RRF2 FAMILY PROTEIN', 253101),
(427589, 'PTHR33221', NULL, NULL, NULL, NULL, 'WINGED HELIX-TURN-HELIX TRANSCRIPTIONAL REGULATOR, RRF2 FAMILY', 253101),
(427590, 'PTHR33221:SF13', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', 253101),
(427591, 'PTHR33221:SF14', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR AQ_268-RELATED', 253101),
(427592, 'PTHR43261:SF1', NULL, NULL, NULL, NULL, 'RIBOSOME-RELEASING FACTOR 2, MITOCHONDRIAL', 253102),
(427593, 'PTHR43261', NULL, NULL, NULL, NULL, 'TRANSLATION ELONGATION FACTOR G-RELATED', 253102),
(427594, 'PTHR43261:SF7', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR G-LIKE PROTEIN', 253102),
(427595, 'PTHR43261:SF5', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR G 1', 253102),
(427596, 'PTHR43261:SF6', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR G-LIKE PROTEIN', 253102),
(427597, 'PTHR30619:SF7', NULL, NULL, NULL, NULL, 'DNA INTERNALIZATION-RELATED COMPETENCE PROTEIN COMEC/REC2', 253103),
(427598, 'PTHR30619', NULL, NULL, NULL, NULL, 'DNA INTERNALIZATION/COMPETENCE PROTEIN COMEC/REC2', 253103),
(427599, 'PTHR30619:SF1', NULL, NULL, NULL, NULL, 'RECOMBINATION PROTEIN 2', 253103),
(427600, 'PTHR10682:SF27', NULL, NULL, NULL, NULL, 'POLY(A) POLYMERASE', 253104),
(427601, 'PTHR10682:SF37', NULL, NULL, NULL, NULL, 'POLY(A) POLYMERASE', 253104),
(427602, 'PTHR10682:SF26', NULL, NULL, NULL, NULL, 'POLY(A) POLYMERASE', 253104),
(427603, 'PTHR10682:SF36', NULL, NULL, NULL, NULL, 'NUCLEAR POLY(A) POLYMERASE 4', 253104),
(427604, 'PTHR10682:SF46', NULL, NULL, NULL, NULL, 'POLY(A) POLYMERASE', 253104); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(427605, 'PTHR10682:SF35', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDE ADENYLYLTRANSFERASE', 253104),
(427606, 'PTHR10682:SF23', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDE ADENYLYLTRANSFERASE', 253104),
(427607, 'PTHR10682:SF45', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDE ADENYLYLTRANSFERASE', 253104),
(427608, 'PTHR10682:SF33', NULL, NULL, NULL, NULL, 'NUCLEAR POLY(A) POLYMERASE 3', 253104),
(427609, 'PTHR10682:SF22', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDE ADENYLYLTRANSFERASE', 253104),
(427610, 'PTHR10682:SF10', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDE ADENYLYLTRANSFERASE', 253104),
(427611, 'PTHR10682:SF21', NULL, NULL, NULL, NULL, 'POLY(A) POLYMERASE', 253104),
(427612, 'PTHR10682:SF31', NULL, NULL, NULL, NULL, 'NUCLEAR POLY(A) POLYMERASE 2', 253104),
(427613, 'PTHR10682:SF42', NULL, NULL, NULL, NULL, 'POLY(A) POLYMERASE', 253104),
(427614, 'PTHR10682:SF41', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDE ADENYLYLTRANSFERASE', 253104),
(427615, 'PTHR10682:SF40', NULL, NULL, NULL, NULL, 'POLY(A) POLYMERASE', 253104),
(427616, 'PTHR10682:SF9', NULL, NULL, NULL, NULL, 'POLY(A) POLYMERASE ALPHA', 253104),
(427617, 'PTHR10682:SF6', NULL, NULL, NULL, NULL, 'POLY(A) POLYMERASE GAMMA', 253104),
(427618, 'PTHR10682:SF19', NULL, NULL, NULL, NULL, 'POLY(A) POLYMERASE BETA', 253104),
(427619, 'PTHR10682:SF39', NULL, NULL, NULL, NULL, 'POLY(A) POLYMERASE', 253104),
(427620, 'PTHR10682', NULL, NULL, NULL, NULL, 'POLY A  POLYMERASE', 253104),
(427621, 'PTHR36216:SF1', NULL, NULL, NULL, NULL, 'HTH ARSR-TYPE DOMAIN-CONTAINING PROTEIN', 253105),
(427622, 'PTHR36216', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, TRMB', 253105),
(427623, 'PTHR47029:SF1', NULL, NULL, NULL, NULL, 'FOUR AND A HALF LIM DOMAINS 4', 253106),
(427624, 'PTHR47029:SF2', NULL, NULL, NULL, NULL, 'FOUR AND A HALF LIM DOMAINS PROTEIN 1', 253106),
(427625, 'PTHR47029:SF4', NULL, NULL, NULL, NULL, 'FOUR AND A HALF LIM DOMAINS PROTEIN 1', 253106),
(427626, 'PTHR47029', NULL, NULL, NULL, NULL, 'FOUR AND A HALF LIM DOMAINS PROTEIN 1', 253106),
(427627, 'PTHR46855:SF3', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 26-LIKE', 253107),
(427628, 'PTHR46855', NULL, NULL, NULL, NULL, 'OSJNBB0038F03.10 PROTEIN', 253107),
(427629, 'PTHR46855:SF2', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 253107),
(427630, 'PTHR46855:SF1', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 26', 253107),
(427631, 'PTHR46855:SF21', NULL, NULL, NULL, NULL, 'GATA ZINC FINGER PROTEIN', 253107),
(427632, 'PTHR46855:SF10', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 253107),
(427633, 'PTHR46855:SF11', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 26-LIKE', 253107),
(427634, 'PTHR46855:SF12', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 27', 253107),
(427635, 'PTHR46855:SF13', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 253107),
(427636, 'PTHR46855:SF20', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR-LIKE PROTEIN', 253107),
(427637, 'PTHR46855:SF19', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 253107),
(427638, 'PTHR46855:SF9', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 253107),
(427639, 'PTHR46855:SF6', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 253107),
(427640, 'PTHR46855:SF17', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', 253107),
(427641, 'PTHR46855:SF5', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 26-LIKE', 253107),
(427642, 'PTHR14140', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE UHRF-RELATED', 253108),
(427643, 'PTHR14140:SF41', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253108),
(427644, 'PTHR14140:SF44', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253108),
(427645, 'PTHR14140:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE UHRF1', 253108),
(427646, 'PTHR14140:SF3', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE UHRF2', 253108),
(427647, 'PTHR14140:SF45', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253108),
(427648, 'PTHR14140:SF35', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253108);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(427649, 'PTHR14140:SF46', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ORTHRUS 1-RELATED', 253108),
(427650, 'PTHR14140:SF36', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253108),
(427651, 'PTHR14140:SF38', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253108),
(427652, 'PTHR14140:SF27', NULL, NULL, NULL, NULL, 'OS04G0289800 PROTEIN', 253108),
(427653, 'PTHR14140:SF39', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ORTHRUS 3', 253108),
(427654, 'PTHR21711', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL INNER MEMBRANE PROTEASE', 253109),
(427655, 'PTHR21711:SF0', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL INNER MEMBRANE PROTEASE ATP23 HOMOLOG', 253109),
(427656, 'PTHR34464:SF10', NULL, NULL, NULL, NULL, 'BNAANNG04910D PROTEIN', 253110),
(427657, 'PTHR34464:SF9', NULL, NULL, NULL, NULL, 'BNAC03G48890D PROTEIN', 253110),
(427658, 'PTHR34464', NULL, NULL, NULL, NULL, 'OS09G0376300 PROTEIN', 253110),
(427659, 'PTHR34464:SF6', NULL, NULL, NULL, NULL, '', 253110),
(427660, 'PTHR34464:SF7', NULL, NULL, NULL, NULL, 'OS08G0414300 PROTEIN', 253110),
(427661, 'PTHR34464:SF4', NULL, NULL, NULL, NULL, '', 253110),
(427662, 'PTHR34464:SF5', NULL, NULL, NULL, NULL, '', 253110),
(427663, 'PTHR34464:SF3', NULL, NULL, NULL, NULL, 'OS09G0376300 PROTEIN', 253110),
(427664, 'PTHR19307:SF13', NULL, NULL, NULL, NULL, 'TUMOR PROTEIN D54', 253111),
(427665, 'PTHR19307:SF12', NULL, NULL, NULL, NULL, 'TUMOR PROTEIN D52', 253111),
(427666, 'PTHR19307', NULL, NULL, NULL, NULL, 'TUMOR PROTEIN D52', 253111),
(427667, 'PTHR19307:SF14', NULL, NULL, NULL, NULL, 'PROTEIN CBG04517', 253111),
(427668, 'PTHR19307:SF8', NULL, NULL, NULL, NULL, 'TUMOR PROTEIN D53', 253111),
(427669, 'PTHR19307:SF5', NULL, NULL, NULL, NULL, 'TUMOR PROTEIN D55', 253111),
(427670, 'PTHR39624', NULL, NULL, NULL, NULL, 'PROTEIN INVOLVED IN RIMO-MEDIATED BETA-METHYLTHIOLATION OF RIBOSOMAL PROTEIN S12 YCAO', 253112),
(427671, 'PTHR39624:SF2', NULL, NULL, NULL, NULL, 'PROTEIN INVOLVED IN RIMO-MEDIATED BETA-METHYLTHIOLATION OF RIBOSOMAL PROTEIN S12 YCAO', 253112),
(427672, 'PTHR43399:SF4', NULL, NULL, NULL, NULL, 'CELL WALL-ASSOCIATED PROTEASE', 253113),
(427673, 'PTHR43399:SF5', NULL, NULL, NULL, NULL, 'PEPTIDASE S8 FAMILY WITH PROTEASE-ASSOCIATED DOMAIN', 253113),
(427674, 'PTHR43399', NULL, NULL, NULL, NULL, 'SUBTILISIN-RELATED', 253113),
(427675, 'PTHR46837:SF10', NULL, NULL, NULL, NULL, 'OS05G0534600 PROTEIN', 253114),
(427676, 'PTHR46837:SF6', NULL, NULL, NULL, NULL, 'CASC3/BARENTSZ EIF4AIII BINDING PROTEIN', 253114),
(427677, 'PTHR46837:SF5', NULL, NULL, NULL, NULL, 'PROTEIN MLN51 HOMOLOG', 253114),
(427678, 'PTHR46837', NULL, NULL, NULL, NULL, 'PROTEIN MLN51 HOMOLOG', 253114),
(427679, 'PTHR46837:SF8', NULL, NULL, NULL, NULL, 'BTZ DOMAIN-CONTAINING PROTEIN', 253114),
(427680, 'PTHR46837:SF7', NULL, NULL, NULL, NULL, 'BTZ DOMAIN-CONTAINING PROTEIN', 253114),
(427681, 'PTHR47476:SF3', NULL, NULL, NULL, NULL, 'BNAC04G26110D PROTEIN', 253115),
(427682, 'PTHR47476', NULL, NULL, NULL, NULL, '', 253115),
(427683, 'PTHR47476:SF2', NULL, NULL, NULL, NULL, 'ARABINOSE 5-PHOSPHATE ISOMERASE-RELATED', 253115),
(427684, 'PTHR43642:SF2', NULL, NULL, NULL, NULL, 'GUANYLYL CYCLASE', 253116),
(427685, 'PTHR43642:SF1', NULL, NULL, NULL, NULL, 'HYBRID SIGNAL TRANSDUCTION HISTIDINE KINASE G', 253116),
(427686, 'PTHR43642', NULL, NULL, NULL, NULL, 'HYBRID SIGNAL TRANSDUCTION HISTIDINE KINASE G', 253116),
(427687, 'PTHR37987:SF1', NULL, NULL, NULL, NULL, 'OHCU_DECARBOX DOMAIN-CONTAINING PROTEIN', 253117),
(427688, 'PTHR37987', NULL, NULL, NULL, NULL, 'CHROMOSOME 9, WHOLE GENOME SHOTGUN SEQUENCE', 253117),
(427689, 'PTHR39110', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 253118),
(427690, 'PTHR39110:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 253118),
(427691, 'PTHR39110:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 253118),
(427692, 'PTHR39110:SF4', NULL, NULL, NULL, NULL, 'GLYCINE-RICH CELL WALL STRUCTURAL PROTEIN-LIKE', 253118),
(427693, 'PTHR39110:SF5', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN 5', 253118);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(427694, 'PTHR37419', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE TOXIN HIPA', 253119),
(427695, 'PTHR37419:SF8', NULL, NULL, NULL, NULL, 'TOXIN YJJJ', 253119),
(427696, 'PTHR37419:SF6', NULL, NULL, NULL, NULL, 'KINASE HI_0665-RELATED', 253119),
(427697, 'PTHR37419:SF1', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE TOXIN HIPA', 253119),
(427698, 'PTHR33177:SF67', NULL, NULL, NULL, NULL, '', 253120),
(427699, 'PTHR33177:SF23', NULL, NULL, NULL, NULL, 'BNAA04G05350D PROTEIN', 253120),
(427700, 'PTHR33177:SF44', NULL, NULL, NULL, NULL, 'F3O9.30', 253120),
(427701, 'PTHR33177:SF66', NULL, NULL, NULL, NULL, 'BNAA10G30640D PROTEIN', 253120),
(427702, 'PTHR33177:SF65', NULL, NULL, NULL, NULL, '', 253120),
(427703, 'PTHR33177:SF64', NULL, NULL, NULL, NULL, 'BNAA09G56300D PROTEIN', 253120),
(427704, 'PTHR33177:SF20', NULL, NULL, NULL, NULL, 'OS08G0102250 PROTEIN', 253120),
(427705, 'PTHR33177:SF27', NULL, NULL, NULL, NULL, 'INTEGRATOR COMPLEX SUBUNIT 6 HOMOLOG', 253120),
(427706, 'PTHR33177:SF25', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 253120),
(427707, 'PTHR33177:SF47', NULL, NULL, NULL, NULL, 'BNAC02G02040D PROTEIN', 253120),
(427708, 'PTHR33177:SF69', NULL, NULL, NULL, NULL, '', 253120),
(427709, 'PTHR33177:SF24', NULL, NULL, NULL, NULL, 'FILAMENTOUS HEMAGGLUTININ TRANSPORTER', 253120),
(427710, 'PTHR33177:SF68', NULL, NULL, NULL, NULL, '', 253120),
(427711, 'PTHR33177:SF3', NULL, NULL, NULL, NULL, 'OS04G0415000 PROTEIN', 253120),
(427712, 'PTHR33177:SF63', NULL, NULL, NULL, NULL, '', 253120),
(427713, 'PTHR33177:SF41', NULL, NULL, NULL, NULL, 'OS05G0442000 PROTEIN', 253120),
(427714, 'PTHR33177:SF62', NULL, NULL, NULL, NULL, '', 253120),
(427715, 'PTHR33177:SF9', NULL, NULL, NULL, NULL, 'OS01G0863500 PROTEIN', 253120),
(427716, 'PTHR33177:SF28', NULL, NULL, NULL, NULL, '', 253120),
(427717, 'PTHR33177:SF59', NULL, NULL, NULL, NULL, '', 253120),
(427718, 'PTHR33177:SF58', NULL, NULL, NULL, NULL, 'PROTEIN GL2-INTERACTING REPRESSOR 2', 253120),
(427719, 'PTHR33177:SF35', NULL, NULL, NULL, NULL, '', 253120),
(427720, 'PTHR33177:SF70', NULL, NULL, NULL, NULL, 'OS03G0660700 PROTEIN', 253120),
(427721, 'PTHR33177:SF74', NULL, NULL, NULL, NULL, 'PROTEIN GL2-INTERACTING REPRESSOR 1', 253120),
(427722, 'PTHR33177:SF30', NULL, NULL, NULL, NULL, 'PROTEIN SALT-INDUCED AND EIN3/EIL1-DEPENDENT 1', 253120),
(427723, 'PTHR33177:SF73', NULL, NULL, NULL, NULL, '', 253120),
(427724, 'PTHR33177:SF72', NULL, NULL, NULL, NULL, '', 253120),
(427725, 'PTHR33177:SF50', NULL, NULL, NULL, NULL, '', 253120),
(427726, 'PTHR33177:SF71', NULL, NULL, NULL, NULL, 'BNAA05G27460D PROTEIN', 253120),
(427727, 'PTHR33177', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 253120),
(427728, 'PTHR42280', NULL, NULL, NULL, NULL, 'CITG FAMILY PROTEIN', 253121),
(427729, 'PTHR42280:SF1', NULL, NULL, NULL, NULL, 'CITG FAMILY PROTEIN', 253121),
(427730, 'PTHR24169:SF21', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR NF-KAPPA-B P100 SUBUNIT', 253122),
(427731, 'PTHR24169:SF26', NULL, NULL, NULL, NULL, '', 253122),
(427732, 'PTHR24169:SF25', NULL, NULL, NULL, NULL, 'DORSAL-RELATED IMMUNITY FACTOR DIF-RELATED', 253122),
(427733, 'PTHR24169:SF9', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR NF-KAPPA-B P105 SUBUNIT', 253122),
(427734, 'PTHR24169:SF27', NULL, NULL, NULL, NULL, 'V-REL AVIAN RETICULOENDOTHELIOSIS VIRAL ONCOGENE HOMOLOG A', 253122),
(427735, 'PTHR24169', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR NF-KAPPA-B PROTEIN', 253122),
(427736, 'PTHR24169:SF18', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR RELB', 253122),
(427737, 'PTHR24169:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR P65', 253122),
(427738, 'PTHR24169:SF20', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR NF-KAPPA-B P110 SUBUNIT', 253122),
(427739, 'PTHR24169:SF4', NULL, NULL, NULL, NULL, 'PROTO-ONCOGENE C-REL', 253122),
(427740, 'PTHR15119:SF0', NULL, NULL, NULL, NULL, 'SECRETOGRANIN-2', 253123),
(427741, 'PTHR15119', NULL, NULL, NULL, NULL, 'SECRETOGRANIN II', 253123),
(427742, 'PTHR35324:SF5', NULL, NULL, NULL, NULL, 'BNAC07G16390D PROTEIN', 253124);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(427743, 'PTHR35324:SF4', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 253124),
(427744, 'PTHR35324:SF6', NULL, NULL, NULL, NULL, '', 253124),
(427745, 'PTHR35324', NULL, NULL, NULL, NULL, 'BNAA08G03750D PROTEIN', 253124),
(427746, 'PTHR21038:SF4', NULL, NULL, NULL, NULL, 'FORTY-TWO-THREE DOMAIN-CONTAINING PROTEIN 1', 253125),
(427747, 'PTHR21038:SF3', NULL, NULL, NULL, NULL, 'FORTY-TWO-THREE DOMAIN-CONTAINING PROTEIN 1', 253125),
(427748, 'PTHR21038:SF2', NULL, NULL, NULL, NULL, 'UAP56-INTERACTING FACTOR', 253125),
(427749, 'PTHR21038', NULL, NULL, NULL, NULL, '40-2-3 PROTEIN-RELATED', 253125),
(427750, 'PTHR34817:SF1', NULL, NULL, NULL, NULL, '', 253126),
(427751, 'PTHR34817:SF3', NULL, NULL, NULL, NULL, '', 253126),
(427752, 'PTHR34817', NULL, NULL, NULL, NULL, '', 253126),
(427753, 'PTHR34817:SF2', NULL, NULL, NULL, NULL, 'HYPOTHETICAL CYTOSOLIC PROTEIN', 253126),
(427754, 'PTHR34699:SF2', NULL, NULL, NULL, NULL, 'NTPASE_I-T DOMAIN-CONTAINING PROTEIN', 253127),
(427755, 'PTHR34699', NULL, NULL, NULL, NULL, '', 253127),
(427756, 'PTHR41695', NULL, NULL, NULL, NULL, '1,4-ALPHA-GLUCAN BRANCHING ENZYME RV3031-RELATED', 253128),
(427757, 'PTHR41695:SF1', NULL, NULL, NULL, NULL, '1,4-ALPHA-GLUCAN BRANCHING ENZYME TK1436', 253128),
(427758, 'PTHR35720:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PLASTID TRANSCRIPTIONALLY ACTIVE 12, CHLOROPLASTIC', 253129),
(427759, 'PTHR35720', NULL, NULL, NULL, NULL, 'PROTEIN PLASTID TRANSCRIPTIONALLY ACTIVE 12, CHLOROPLASTIC', 253129),
(427760, 'PTHR43869', NULL, NULL, NULL, NULL, 'GLYCINE BETAINE/PROLINE BETAINE TRANSPORT SYSTEM ATP-BINDING PROTEIN PROV', 253130),
(427761, 'PTHR43869:SF1', NULL, NULL, NULL, NULL, 'GLYCINE BETAINE/PROLINE BETAINE TRANSPORT SYSTEM ATP-BINDING PROTEIN PROV', 253130),
(427762, 'PTHR12636', NULL, NULL, NULL, NULL, 'NEP1/MRA1', 253131),
(427763, 'PTHR12636:SF5', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA SMALL SUBUNIT METHYLTRANSFERASE NEP1', 253131),
(427764, 'PTHR12636:SF12', NULL, NULL, NULL, NULL, 'EMG1/NEP1 METHYLTRANSFERASE', 253131),
(427765, 'PTHR12636:SF13', NULL, NULL, NULL, NULL, 'NUCLEOLAR ESSENTIAL-RELATED-LIKE PROTEIN', 253131),
(427766, 'PTHR12636:SF15', NULL, NULL, NULL, NULL, '', 253131),
(427767, 'PTHR12636:SF11', NULL, NULL, NULL, NULL, '', 253131),
(427768, 'PTHR21244:SF1', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S24, MITOCHONDRIAL', 253132),
(427769, 'PTHR21244', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 28S RIBOSOMAL PROTEIN S24', 253132),
(427770, 'PTHR38894:SF1', NULL, NULL, NULL, NULL, '', 253133),
(427771, 'PTHR38894', NULL, NULL, NULL, NULL, '', 253133),
(427772, 'PTHR38643:SF1', NULL, NULL, NULL, NULL, 'PURINE NUCLEOSIDE PERMEASE C285.05-RELATED', 253134),
(427773, 'PTHR38643', NULL, NULL, NULL, NULL, 'PURINE NUCLEOSIDE PERMEASE C285.05-RELATED', 253134),
(427774, 'PTHR37400:SF1', NULL, NULL, NULL, NULL, '', 253135),
(427775, 'PTHR37400', NULL, NULL, NULL, NULL, '', 253135),
(427776, 'PTHR47435:SF5', NULL, NULL, NULL, NULL, 'NITRILE-SPECIFIER PROTEIN 1-RELATED', 253136),
(427777, 'PTHR47435:SF4', NULL, NULL, NULL, NULL, 'KELCH REPEAT PROTEIN (AFU_ORTHOLOGUE AFUA_5G12780)', 253136),
(427778, 'PTHR47435:SF7', NULL, NULL, NULL, NULL, 'BNAC06G10450D PROTEIN', 253136),
(427779, 'PTHR47435:SF6', NULL, NULL, NULL, NULL, 'BNAC06G05180D PROTEIN', 253136),
(427780, 'PTHR47435:SF3', NULL, NULL, NULL, NULL, 'NITRILE-SPECIFIER PROTEIN 5', 253136),
(427781, 'PTHR47435:SF2', NULL, NULL, NULL, NULL, 'EPITHIOSPECIFIER PROTEIN', 253136),
(427782, 'PTHR47435:SF9', NULL, NULL, NULL, NULL, 'BNAC03G68960D PROTEIN', 253136),
(427783, 'PTHR47435:SF8', NULL, NULL, NULL, NULL, 'JACALIN-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', 253136),
(427784, 'PTHR47435', NULL, NULL, NULL, NULL, 'KELCH REPEAT PROTEIN (AFU_ORTHOLOGUE AFUA_5G12780)', 253136),
(427785, 'PTHR46377:SF1', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE 19', 253137),
(427786, 'PTHR46377', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE 19', 253137),
(427787, 'PTHR46377:SF5', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PHOSPHATASE', 253137),
(427788, 'PTHR43759', NULL, NULL, NULL, NULL, 'TREHALOSE TRANSPORT SYSTEM PERMEASE PROTEIN SUGA', 253138);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(427789, 'PTHR43759:SF1', NULL, NULL, NULL, NULL, 'GLUCOSE IMPORT SYSTEM PERMEASE PROTEIN GLCT', 253138),
(427790, 'PTHR31532', NULL, NULL, NULL, NULL, 'BIORIENTATION OF CHROMOSOMES IN CELL DIVISION 1 FAMILY MEMBER', 253139),
(427791, 'PTHR31532:SF10', NULL, NULL, NULL, NULL, 'BIORIENTATION OF CHROMOSOMES IN CELL DIVISION PROTEIN 1-LIKE 1', 253139),
(427792, 'PTHR36687:SF1', NULL, NULL, NULL, NULL, '', 253140),
(427793, 'PTHR36687:SF2', NULL, NULL, NULL, NULL, '', 253140),
(427794, 'PTHR36687', NULL, NULL, NULL, NULL, '', 253140),
(427795, 'PTHR43190', NULL, NULL, NULL, NULL, 'N-ACETYL-D-GLUCOSAMINE KINASE', 253141),
(427796, 'PTHR43190:SF1', NULL, NULL, NULL, NULL, 'GLCNAC KINASE', 253141),
(427797, 'PTHR43190:SF6', NULL, NULL, NULL, NULL, 'GLCNAC KINASE', 253141),
(427798, 'PTHR43190:SF7', NULL, NULL, NULL, NULL, 'GLCNAC KINASE', 253141),
(427799, 'PTHR43190:SF9', NULL, NULL, NULL, NULL, 'GLCNAC KINASE', 253141),
(427800, 'PTHR43190:SF3', NULL, NULL, NULL, NULL, 'N-ACETYL-D-GLUCOSAMINE KINASE', 253141),
(427801, 'PTHR34970:SF3', NULL, NULL, NULL, NULL, 'OS05G0535700 PROTEIN', 253142),
(427802, 'PTHR34970:SF2', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER A FAMILY PROTEIN', 253142),
(427803, 'PTHR34970', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER A FAMILY PROTEIN', 253142),
(427804, 'PTHR34970:SF5', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 253142),
(427805, 'PTHR34970:SF4', NULL, NULL, NULL, NULL, 'BNAA02G10160D PROTEIN', 253142),
(427806, 'PTHR47178:SF4', NULL, NULL, NULL, NULL, 'FAD-DEPENDENT MONOOXYGENASE APTC', 253143),
(427807, 'PTHR47178:SF5', NULL, NULL, NULL, NULL, 'FAD_BINDING_3 DOMAIN-CONTAINING PROTEIN', 253143),
(427808, 'PTHR47178:SF6', NULL, NULL, NULL, NULL, 'EARLY CONIDIAL DEVELOPMENT-2 PROTEIN', 253143),
(427809, 'PTHR47178', NULL, NULL, NULL, NULL, 'MONOOXYGENASE, FAD-BINDING', 253143),
(427810, 'PTHR47178:SF1', NULL, NULL, NULL, NULL, 'FAD_BINDING_3 DOMAIN-CONTAINING PROTEIN', 253143),
(427811, 'PTHR47178:SF2', NULL, NULL, NULL, NULL, 'FAD_BINDING_3 DOMAIN-CONTAINING PROTEIN', 253143),
(427812, 'PTHR47178:SF3', NULL, NULL, NULL, NULL, 'FAD_BINDING_3 DOMAIN-CONTAINING PROTEIN', 253143),
(427813, 'PTHR13052:SF2', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR KAPPA-B-BINDING PROTEIN', 253144),
(427814, 'PTHR13052', NULL, NULL, NULL, NULL, 'NFRKB-RELATED', 253144),
(427815, 'PTHR13052:SF3', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR RELATED TO KAPPA-B-BINDING PROTEIN', 253144),
(427816, 'PTHR13052:SF0', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN-LIKE', 253144),
(427817, 'PTHR13052:SF5', NULL, NULL, NULL, NULL, '', 253144),
(427818, 'PTHR23382:SF21', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE-RELATED', 253145),
(427819, 'PTHR23382:SF20', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE [NADP], CHLOROPLASTIC', 253145),
(427820, 'PTHR23382:SF25', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE 3-RELATED', 253145),
(427821, 'PTHR23382:SF26', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE', 253145),
(427822, 'PTHR23382', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE', 253145),
(427823, 'PTHR23382:SF23', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE [NADP], CHLOROPLASTIC', 253145),
(427824, 'PTHR23382:SF3', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE, CYTOPLASMIC', 253145),
(427825, 'PTHR23382:SF24', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE', 253145),
(427826, 'PTHR23382:SF18', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE [NADP], CHLOROPLASTIC', 253145),
(427827, 'PTHR23382:SF1', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE 1B-RELATED', 253145),
(427828, 'PTHR23382:SF19', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE 3, CYTOPLASMIC', 253145),
(427829, 'PTHR23382:SF27', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE 1, CYTOPLASMIC', 253145),
(427830, 'PTHR23382:SF0', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE 2, MITOCHONDRIAL-RELATED', 253145),
(427831, 'PTHR23382:SF28', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE [NADP], CHLOROPLASTIC', 253145),
(427832, 'PTHR47328:SF1', NULL, NULL, NULL, NULL, 'RUTC FAMILY PROTEIN YOAB', 253146),
(427833, 'PTHR47328', NULL, NULL, NULL, NULL, '', 253146);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(427834, 'PTHR12473:SF17', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE MINDY-3', 253147),
(427835, 'PTHR12473:SF13', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE MINDY-4-RELATED', 253147),
(427836, 'PTHR12473:SF14', NULL, NULL, NULL, NULL, '', 253147),
(427837, 'PTHR12473', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 253147),
(427838, 'PTHR12473:SF8', NULL, NULL, NULL, NULL, 'INACTIVE UBIQUITIN CARBOXYL-TERMINAL HYDROLASE MINDY-4B', 253147),
(427839, 'PTHR37708:SF7', NULL, NULL, NULL, NULL, '', 253148),
(427840, 'PTHR37708:SF6', NULL, NULL, NULL, NULL, 'BNAA04G11500D PROTEIN', 253148),
(427841, 'PTHR37708:SF2', NULL, NULL, NULL, NULL, 'HOMEOBOX HOX-B3-LIKE PROTEIN', 253148),
(427842, 'PTHR37708', NULL, NULL, NULL, NULL, 'HOMEOBOX HOX-B3-LIKE PROTEIN', 253148),
(427843, 'PTHR37708:SF8', NULL, NULL, NULL, NULL, '', 253148),
(427844, 'PTHR46480', NULL, NULL, NULL, NULL, 'F20B24.22', 253149),
(427845, 'PTHR46480:SF1', NULL, NULL, NULL, NULL, 'VOLTAGE-GATED HYDROGEN CHANNEL 1', 253149),
(427846, 'PTHR37917', NULL, NULL, NULL, NULL, 'PROTEIN CBG03580', 253150),
(427847, 'PTHR37917:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG03580', 253150),
(427848, 'PTHR37917:SF10', NULL, NULL, NULL, NULL, '', 253150),
(427849, 'PTHR46745', NULL, NULL, NULL, NULL, 'TSC22 DOMAIN FAMILY PROTEIN 1', 253151),
(427850, 'PTHR46745:SF1', NULL, NULL, NULL, NULL, 'TSC22 DOMAIN FAMILY PROTEIN 1', 253151),
(427851, 'PTHR36963:SF2', NULL, NULL, NULL, NULL, 'HELICASE', 253152),
(427852, 'PTHR36963', NULL, NULL, NULL, NULL, 'HELICASE', 253152),
(427853, 'PTHR36161', NULL, NULL, NULL, NULL, 'PROTEIN CBG06377-RELATED', 253153),
(427854, 'PTHR36161:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG06375', 253153),
(427855, 'PTHR36161:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG08560', 253153),
(427856, 'PTHR36161:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG05619', 253153),
(427857, 'PTHR36161:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG06377', 253153),
(427858, 'PTHR10695:SF53', NULL, NULL, NULL, NULL, 'PHOSPHOPANTETHEINE ADENYLYLTRANSFERASE-LIKE', 253154),
(427859, 'PTHR10695:SF41', NULL, NULL, NULL, NULL, '', 253154),
(427860, 'PTHR10695:SF58', NULL, NULL, NULL, NULL, 'BNACNNG43120D PROTEIN', 253154),
(427861, 'PTHR10695', NULL, NULL, NULL, NULL, 'DEPHOSPHO-COA KINASE-RELATED', 253154),
(427862, 'PTHR10695:SF46', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL COENZYME A SYNTHASE-RELATED', 253154),
(427863, 'PTHR10695:SF57', NULL, NULL, NULL, NULL, 'DEPHOSPHO-COA KINASE', 253154),
(427864, 'PTHR10695:SF56', NULL, NULL, NULL, NULL, 'PHOSPHOPANTETHEINE ADENYLYLTRANSFERASE 1', 253154),
(427865, 'PTHR10695:SF34', NULL, NULL, NULL, NULL, '', 253154),
(427866, 'PTHR10695:SF55', NULL, NULL, NULL, NULL, '', 253154),
(427867, 'PTHR10695:SF29', NULL, NULL, NULL, NULL, '', 253154),
(427868, 'PTHR10695:SF37', NULL, NULL, NULL, NULL, '', 253154),
(427869, 'PTHR12745:SF6', NULL, NULL, NULL, NULL, 'PROTEIN ST7 HOMOLOG', 253155),
(427870, 'PTHR12745:SF4', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF TUMORIGENICITY 7 PROTEIN-LIKE', 253155),
(427871, 'PTHR12745', NULL, NULL, NULL, NULL, 'SUPPRESSION OF TUMORIGENICITY 7', 253155),
(427872, 'PTHR12745:SF8', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF TUMORIGENICITY 7 PROTEIN', 253155),
(427873, 'PTHR12745:SF11', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF TUMORIGENICITY 7 PROTEIN-LIKE', 253155),
(427874, 'PTHR12745:SF12', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF TUMORIGENICITY 7 PROTEIN HOMOLOG', 253155),
(427875, 'PTHR12745:SF10', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF TUMORIGENICITY 7 PROTEIN', 253155),
(427876, 'PTHR32465:SF0', NULL, NULL, NULL, NULL, 'BARDET-BIEDL SYNDROME 2 PROTEIN', 253156),
(427877, 'PTHR32465', NULL, NULL, NULL, NULL, 'BARDET-BIEDL SYNDROME 2 PROTEIN', 253156),
(427878, 'PTHR40515:SF1', NULL, NULL, NULL, NULL, '', 253157),
(427879, 'PTHR40515', NULL, NULL, NULL, NULL, '', 253157),
(427880, 'PTHR31361:SF16', NULL, NULL, NULL, NULL, 'GLUCOSIDASE', 253158),
(427881, 'PTHR31361:SF1', NULL, NULL, NULL, NULL, 'BETA-GLUCAN SYNTHESIS-ASSOCIATED PROTEIN KRE6-RELATED', 253158),
(427882, 'PTHR31361', NULL, NULL, NULL, NULL, 'BETA-GLUCAN SYNTHESIS-ASSOCIATED PROTEIN KRE6-RELATED', 253158);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(427883, 'PTHR31361:SF15', NULL, NULL, NULL, NULL, 'GH16 DOMAIN-CONTAINING PROTEIN', 253158),
(427884, 'PTHR31361:SF14', NULL, NULL, NULL, NULL, 'GH16 DOMAIN-CONTAINING PROTEIN', 253158),
(427885, 'PTHR33912:SF12', NULL, NULL, NULL, NULL, 'ATBET12', 253159),
(427886, 'PTHR33912:SF11', NULL, NULL, NULL, NULL, 'BNAC04G28670D PROTEIN', 253159),
(427887, 'PTHR33912', NULL, NULL, NULL, NULL, 'OS01G0939400 PROTEIN', 253159),
(427888, 'PTHR33912:SF10', NULL, NULL, NULL, NULL, 'BNAA10G27810D PROTEIN', 253159),
(427889, 'PTHR33912:SF8', NULL, NULL, NULL, NULL, 'BNAA09G50560D PROTEIN', 253159),
(427890, 'PTHR33912:SF5', NULL, NULL, NULL, NULL, 'F22G5.17', 253159),
(427891, 'PTHR33912:SF3', NULL, NULL, NULL, NULL, 'OS01G0939400 PROTEIN', 253159),
(427892, 'PTHR33912:SF2', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 253159),
(427893, 'PTHR30469:SF15', NULL, NULL, NULL, NULL, 'HLYD FAMILY OF SECRETION PROTEINS', 253160),
(427894, 'PTHR30469:SF37', NULL, NULL, NULL, NULL, 'RAGD PROTEIN', 253160),
(427895, 'PTHR30469:SF36', NULL, NULL, NULL, NULL, 'SLL0180 PROTEIN', 253160),
(427896, 'PTHR30469:SF16', NULL, NULL, NULL, NULL, 'HAE1 FAMILY EFFLUX PUMP MFP COMPONENT', 253160),
(427897, 'PTHR30469:SF33', NULL, NULL, NULL, NULL, 'EFFLUX PROTEIN', 253160),
(427898, 'PTHR30469:SF11', NULL, NULL, NULL, NULL, 'BLL4320 PROTEIN', 253160),
(427899, 'PTHR30469:SF13', NULL, NULL, NULL, NULL, 'HAE1 FAMILY EFFLUX PUMP MFP COMPONENT', 253160),
(427900, 'PTHR30469:SF35', NULL, NULL, NULL, NULL, 'EFFLUX PROTEIN', 253160),
(427901, 'PTHR30469:SF12', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN MDTA', 253160),
(427902, 'PTHR30469:SF34', NULL, NULL, NULL, NULL, 'MACROLIDE EXPORT PROTEIN MACA', 253160),
(427903, 'PTHR30469:SF18', NULL, NULL, NULL, NULL, 'HLYD FAMILY SECRETION PROTEIN', 253160),
(427904, 'PTHR30469:SF29', NULL, NULL, NULL, NULL, 'BLR2860 PROTEIN', 253160),
(427905, 'PTHR30469', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN MDTA', 253160),
(427906, 'PTHR30469:SF20', NULL, NULL, NULL, NULL, 'LIPOPROTEIN-RELATED', 253160),
(427907, 'PTHR33992', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P PROTEIN COMPONENT', 253161),
(427908, 'PTHR33992:SF1', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P PROTEIN COMPONENT', 253161),
(427909, 'PTHR16234:SF5', NULL, NULL, NULL, NULL, 'SIMILAR TO HYPOTHETICAL PROTEIN FLJ20508', 253162),
(427910, 'PTHR16234', NULL, NULL, NULL, NULL, 'SIMILAR TO HYPOTHETICAL PROTEIN FLJ20508', 253162),
(427911, 'PTHR12732:SF8', NULL, NULL, NULL, NULL, 'NUCLEAR MRNA EXPORT PROTEIN THP1', 253163),
(427912, 'PTHR12732:SF0', NULL, NULL, NULL, NULL, 'PCI DOMAIN-CONTAINING PROTEIN 2', 253163),
(427913, 'PTHR12732', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEASOME COMPONENT REGION PCI-CONTAINING', 253163),
(427914, 'PTHR12732:SF3', NULL, NULL, NULL, NULL, '', 253163),
(427915, 'PTHR30486:SF12', NULL, NULL, NULL, NULL, 'TYPE IV PILUS ATPASE PILU', 253164),
(427916, 'PTHR30486:SF6', NULL, NULL, NULL, NULL, 'TYPE IV PILUS RETRACTATION ATPASE PILT', 253164),
(427917, 'PTHR30486:SF14', NULL, NULL, NULL, NULL, 'FLAGELLA ACCESSORY PROTEIN I', 253164),
(427918, 'PTHR30486:SF13', NULL, NULL, NULL, NULL, 'TWITCHING MOBILITY PROTEIN', 253164),
(427919, 'PTHR30486', NULL, NULL, NULL, NULL, 'TWITCHING MOTILITY PROTEIN PILT', 253164),
(427920, 'PTHR13414:SF9', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER 9', 253165),
(427921, 'PTHR13414', NULL, NULL, NULL, NULL, 'HUEL-CATION TRANSPORTER', 253165),
(427922, 'PTHR35296:SF3', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 253166),
(427923, 'PTHR35296:SF4', NULL, NULL, NULL, NULL, 'BNAANNG15650D PROTEIN', 253166),
(427924, 'PTHR35296', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 253166),
(427925, 'PTHR35296:SF1', NULL, NULL, NULL, NULL, 'OS02G0445700 PROTEIN', 253166),
(427926, 'PTHR35296:SF7', NULL, NULL, NULL, NULL, 'SMALL AUXIN-UP RNA-RELATED', 253166),
(427927, 'PTHR37357', NULL, NULL, NULL, NULL, 'IZUMO SPERM-EGG FUSION PROTEIN 4', 253167),
(427928, 'PTHR37357:SF1', NULL, NULL, NULL, NULL, 'IZUMO SPERM-EGG FUSION PROTEIN 4', 253167),
(427929, 'PTHR36700', NULL, NULL, NULL, NULL, 'CRISPR SYSTEM CMR SUBUNIT CMR4', 253168);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(427930, 'PTHR36700:SF1', NULL, NULL, NULL, NULL, 'CRISPR SYSTEM CMR SUBUNIT CMR4', 253168),
(427931, 'PTHR47428', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN MIG1-RELATED', 253169),
(427932, 'PTHR47428:SF1', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN MIG1-RELATED', 253169),
(427933, 'PTHR48164', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE SUBUNIT 4', 253170),
(427934, 'PTHR48164:SF1', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE SUBUNIT 4', 253170),
(427935, 'PTHR35283:SF3', NULL, NULL, NULL, NULL, 'T12C22.21 PROTEIN', 253171),
(427936, 'PTHR35283', NULL, NULL, NULL, NULL, 'T12C22.21 PROTEIN', 253171),
(427937, 'PTHR43226', NULL, NULL, NULL, NULL, 'XAA-PRO AMINOPEPTIDASE 3', 253172),
(427938, 'PTHR43226:SF8', NULL, NULL, NULL, NULL, 'XAA-PRO DIPEPTIDASE', 253172),
(427939, 'PTHR43226:SF4', NULL, NULL, NULL, NULL, 'XAA-PRO AMINOPEPTIDASE 3', 253172),
(427940, 'PTHR43226:SF1', NULL, NULL, NULL, NULL, 'XAA-PRO DIPEPTIDASE', 253172),
(427941, 'PTHR43226:SF3', NULL, NULL, NULL, NULL, 'XAA-PRO AMINOPEPTIDASE AN0832-RELATED', 253172),
(427942, 'PTHR33388:SF33', NULL, NULL, NULL, NULL, 'PROTEIN SPEAR3-LIKE', 253173),
(427943, 'PTHR33388:SF34', NULL, NULL, NULL, NULL, 'PROTEIN SPEAR2', 253173),
(427944, 'PTHR33388:SF12', NULL, NULL, NULL, NULL, 'PROTEIN SPEAR3', 253173),
(427945, 'PTHR33388:SF35', NULL, NULL, NULL, NULL, '', 253173),
(427946, 'PTHR33388:SF13', NULL, NULL, NULL, NULL, '', 253173),
(427947, 'PTHR33388:SF14', NULL, NULL, NULL, NULL, 'PROTEIN SPEAR4', 253173),
(427948, 'PTHR33388:SF26', NULL, NULL, NULL, NULL, '', 253173),
(427949, 'PTHR33388:SF18', NULL, NULL, NULL, NULL, 'PROTEIN SPEAR1', 253173),
(427950, 'PTHR33388:SF31', NULL, NULL, NULL, NULL, 'OS01G0231100 PROTEIN', 253173),
(427951, 'PTHR33388:SF20', NULL, NULL, NULL, NULL, 'BNAA03G58770D PROTEIN', 253173),
(427952, 'PTHR33388:SF21', NULL, NULL, NULL, NULL, '', 253173),
(427953, 'PTHR33388:SF32', NULL, NULL, NULL, NULL, 'BNAA09G43880D PROTEIN', 253173),
(427954, 'PTHR33388:SF19', NULL, NULL, NULL, NULL, 'SPOROCYTELESS-LIKE EAR-CONTAINING PROTEIN', 253173),
(427955, 'PTHR33388:SF1', NULL, NULL, NULL, NULL, 'OS01G0212500 PROTEIN', 253173),
(427956, 'PTHR33388:SF2', NULL, NULL, NULL, NULL, 'PROTEIN SPOROCYTELESS', 253173),
(427957, 'PTHR33388', NULL, NULL, NULL, NULL, 'OS01G0212500 PROTEIN', 253173),
(427958, 'PTHR12412', NULL, NULL, NULL, NULL, 'CAP BINDING PROTEIN', 253174),
(427959, 'PTHR12412:SF2', NULL, NULL, NULL, NULL, 'NUCLEAR CAP-BINDING PROTEIN SUBUNIT 1', 253174),
(427960, 'PTHR21646', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 253175),
(427961, 'PTHR21646:SF74', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 19', 253175),
(427962, 'PTHR21646:SF30', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 27', 253175),
(427963, 'PTHR21646:SF73', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 253175),
(427964, 'PTHR21646:SF27', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 8', 253175),
(427965, 'PTHR21646:SF69', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 253175),
(427966, 'PTHR21646:SF68', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 253175),
(427967, 'PTHR21646:SF24', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 253175),
(427968, 'PTHR21646:SF67', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 253175),
(427969, 'PTHR21646:SF23', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE USP2', 253175),
(427970, 'PTHR21646:SF21', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1', 253175),
(427971, 'PTHR21646:SF64', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 253175),
(427972, 'PTHR21646:SF20', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 43', 253175),
(427973, 'PTHR21646:SF29', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 11', 253175),
(427974, 'PTHR21646:SF28', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 15', 253175);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(427975, 'PTHR21646:SF16', NULL, NULL, NULL, NULL, 'U4/U6.U5 TRI-SNRNP-ASSOCIATED PROTEIN 2', 253175),
(427976, 'PTHR21646:SF15', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 44', 253175),
(427977, 'PTHR21646:SF14', NULL, NULL, NULL, NULL, 'FI05488P', 253175),
(427978, 'PTHR21646:SF13', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 20', 253175),
(427979, 'PTHR21646:SF12', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 16', 253175),
(427980, 'PTHR21646:SF99', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 44', 253175),
(427981, 'PTHR21646:SF11', NULL, NULL, NULL, NULL, 'INACTIVE UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 50', 253175),
(427982, 'PTHR21646:SF10', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 14', 253175),
(427983, 'PTHR21646:SF98', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 253175),
(427984, 'PTHR21646:SF97', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 1-RELATED', 253175),
(427985, 'PTHR21646:SF53', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 253175),
(427986, 'PTHR21646:SF19', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 3', 253175),
(427987, 'PTHR21646:SF18', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 5', 253175),
(427988, 'PTHR21646:SF17', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 2', 253175),
(427989, 'PTHR21646:SF96', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 6', 253175),
(427990, 'PTHR21646:SF95', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 4-RELATED', 253175),
(427991, 'PTHR21646:SF94', NULL, NULL, NULL, NULL, 'C-TERMINAL HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G13620)-RELATED', 253175),
(427992, 'PTHR21646:SF93', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 10', 253175),
(427993, 'PTHR21646:SF92', NULL, NULL, NULL, NULL, 'CARBOXYL-TERMINAL HYDROLASE, PUTATIVE-RELATED', 253175),
(427994, 'PTHR21646:SF91', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', 253175),
(427995, 'PTHR21646:SF90', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 253175),
(427996, 'PTHR21646:SF49', NULL, NULL, NULL, NULL, 'UBIQUITIN C-TERMINAL HYDROLASE 22', 253175),
(427997, 'PTHR21646:SF46', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 10-RELATED', 253175),
(427998, 'PTHR21646:SF45', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 4', 253175),
(427999, 'PTHR21646:SF44', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 31', 253175),
(428000, 'PTHR21646:SF86', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 253175),
(428001, 'PTHR21646:SF85', NULL, NULL, NULL, NULL, 'UBIQUITIN-SPECIFIC PEPTIDASE 43B', 253175),
(428002, 'PTHR21646:SF40', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 22', 253175),
(428003, 'PTHR21646:SF83', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 11-RELATED', 253175),
(428004, 'PTHR21646:SF101', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 253175),
(428005, 'PTHR21646:SF102', NULL, NULL, NULL, NULL, 'CARBOXYL-TERMINAL HYDROLASE, PUTATIVE-RELATED', 253175),
(428006, 'PTHR21646:SF38', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 51', 253175),
(428007, 'PTHR21646:SF35', NULL, NULL, NULL, NULL, '', 253175),
(428008, 'PTHR21646:SF34', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 45', 253175),
(428009, 'PTHR21646:SF100', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 253175),
(428010, 'PTHR21646:SF33', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 22', 253175),
(428011, 'PTHR21646:SF76', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 32', 253175),
(428012, 'PTHR21646:SF32', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 33', 253175),
(428013, 'PTHR21646:SF75', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 253175),
(428014, 'PTHR21646:SF7', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 49', 253175);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(428015, 'PTHR21646:SF6', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 21', 253175),
(428016, 'PTHR21646:SF5', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 253175),
(428017, 'PTHR21646:SF39', NULL, NULL, NULL, NULL, 'UBIQUITINYL HYDROLASE 1', 253175),
(428018, 'PTHR35788:SF1', NULL, NULL, NULL, NULL, 'EXPORTED PROTEIN-RELATED', 253176),
(428019, 'PTHR35788', NULL, NULL, NULL, NULL, 'EXPORTED PROTEIN-RELATED', 253176),
(428020, 'PTHR45942', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPATASE 3 REGULATORY SUBUNIT B ALPHA ISOFORM TYPE 1', 253177),
(428021, 'PTHR45942:SF2', NULL, NULL, NULL, NULL, 'CALCINEURIN SUBUNIT B TYPE 2', 253177),
(428022, 'PTHR45942:SF1', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPATASE 3 REGULATORY SUBUNIT B ALPHA ISOFORM TYPE 1', 253177),
(428023, 'PTHR45942:SF4', NULL, NULL, NULL, NULL, 'CALCINEURIN SUBUNIT B TYPE 2', 253177),
(428024, 'PTHR45942:SF3', NULL, NULL, NULL, NULL, 'CALCINEURIN SUBUNIT B TYPE 1', 253177),
(428025, 'PTHR43845', NULL, NULL, NULL, NULL, 'BLR5969 PROTEIN', 253178),
(428026, 'PTHR43845:SF1', NULL, NULL, NULL, NULL, 'BLR5969 PROTEIN', 253178),
(428027, 'PTHR22914:SF26', NULL, NULL, NULL, NULL, 'CHITIN SYNTHASE 7', 253179),
(428028, 'PTHR22914:SF14', NULL, NULL, NULL, NULL, 'CHITIN SYNTHASE', 253179),
(428029, 'PTHR22914:SF13', NULL, NULL, NULL, NULL, 'CHITIN SYNTHASE', 253179),
(428030, 'PTHR22914:SF12', NULL, NULL, NULL, NULL, 'CHITIN SYNTHASE CHS-1', 253179),
(428031, 'PTHR22914:SF45', NULL, NULL, NULL, NULL, 'CHITIN SYNTHASE', 253179),
(428032, 'PTHR22914', NULL, NULL, NULL, NULL, 'CHITIN SYNTHASE', 253179),
(428033, 'PTHR22914:SF39', NULL, NULL, NULL, NULL, 'CHITIN SYNTHASE', 253179),
(428034, 'PTHR22914:SF16', NULL, NULL, NULL, NULL, 'CHITIN SYNTHASE 3', 253179),
(428035, 'PTHR22914:SF38', NULL, NULL, NULL, NULL, 'CHITIN SYNTHASE 2', 253179),
(428036, 'PTHR22914:SF11', NULL, NULL, NULL, NULL, 'CHITIN SYNTHASE B', 253179),
(428037, 'PTHR22914:SF44', NULL, NULL, NULL, NULL, 'CHITIN SYNTHASE 2', 253179),
(428038, 'PTHR22914:SF9', NULL, NULL, NULL, NULL, 'CHITIN SYNTHASE 1', 253179),
(428039, 'PTHR22914:SF42', NULL, NULL, NULL, NULL, 'CHITIN SYNTHASE', 253179),
(428040, 'PTHR22914:SF41', NULL, NULL, NULL, NULL, 'CHITIN SYNTHASE', 253179),
(428041, 'PTHR28637:SF11', NULL, NULL, NULL, NULL, 'CDT1-LIKE PROTEIN A CHLOROPLASTIC', 253180),
(428042, 'PTHR28637:SF10', NULL, NULL, NULL, NULL, 'CDT1-LIKE PROTEIN B', 253180),
(428043, 'PTHR28637:SF1', NULL, NULL, NULL, NULL, 'DNA REPLICATION FACTOR CDT1', 253180),
(428044, 'PTHR28637', NULL, NULL, NULL, NULL, 'DNA REPLICATION FACTOR CDT1', 253180),
(428045, 'PTHR28637:SF9', NULL, NULL, NULL, NULL, 'CDT1-LIKE PROTEIN A, CHLOROPLASTIC', 253180),
(428046, 'PTHR28637:SF13', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 253180),
(428047, 'PTHR28637:SF12', NULL, NULL, NULL, NULL, 'CDT1 DOMAIN-CONTAINING PROTEIN', 253180),
(428048, 'PTHR13335', NULL, NULL, NULL, NULL, 'TARGET OF RAPAMYCIN COMPLEX 2 SUBUNIT MAPKAP1', 253181),
(428049, 'PTHR13335:SF1', NULL, NULL, NULL, NULL, 'TARGET OF RAPAMYCIN COMPLEX 2 SUBUNIT MAPKAP1', 253181),
(428050, 'PTHR37251', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM5 HOMOLOG', 253182),
(428051, 'PTHR37251:SF3', NULL, NULL, NULL, NULL, '', 253182),
(428052, 'PTHR37251:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM5 HOMOLOG', 253182),
(428053, 'PTHR37251:SF2', NULL, NULL, NULL, NULL, '', 253182),
(428054, 'PTHR46417:SF1', NULL, NULL, NULL, NULL, 'TRNA (GUANINE-N(1)-)-METHYLTRANSFERASE', 253183),
(428055, 'PTHR46417', NULL, NULL, NULL, NULL, 'TRNA (GUANINE-N(1)-)-METHYLTRANSFERASE', 253183),
(428056, 'PTHR21206', NULL, NULL, NULL, NULL, 'SLD5 PROTEIN', 253184),
(428057, 'PTHR21206:SF0', NULL, NULL, NULL, NULL, 'DNA REPLICATION COMPLEX GINS PROTEIN SLD5', 253184),
(428058, 'PTHR15367:SF2', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE III SUBUNIT', 253185),
(428059, 'PTHR15367:SF5', NULL, NULL, NULL, NULL, '', 253185),
(428060, 'PTHR15367:SF3', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE III SUBUNIT RPC7', 253185);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(428061, 'PTHR15367:SF4', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE III SUBUNIT RPC7-LIKE', 253185),
(428062, 'PTHR15367', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE III', 253185),
(428063, 'PTHR31934:SF2', NULL, NULL, NULL, NULL, 'RNA-DIRECTED DNA METHYLATION 4', 253186),
(428064, 'PTHR31934:SF6', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 253186),
(428065, 'PTHR31934:SF5', NULL, NULL, NULL, NULL, 'OS05G0557900 PROTEIN', 253186),
(428066, 'PTHR31934', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 253186),
(428067, 'PTHR31934:SF7', NULL, NULL, NULL, NULL, 'BNAA04G25990D PROTEIN', 253186),
(428068, 'PTHR11934', NULL, NULL, NULL, NULL, 'RIBOSE-5-PHOSPHATE ISOMERASE', 253187),
(428069, 'PTHR11934:SF0', NULL, NULL, NULL, NULL, 'RIBOSE-5-PHOSPHATE ISOMERASE', 253187),
(428070, 'PTHR33706', NULL, NULL, NULL, NULL, 'MORN VARIANT REPEAT PROTEIN', 253188),
(428071, 'PTHR33706:SF1', NULL, NULL, NULL, NULL, 'TPR REPEAT PROTEIN-RELATED', 253188),
(428072, 'PTHR13516:SF11', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 253189),
(428073, 'PTHR13516:SF20', NULL, NULL, NULL, NULL, 'BNACNNG26750D PROTEIN', 253189),
(428074, 'PTHR13516:SF26', NULL, NULL, NULL, NULL, 'DNA/RNA-BINDING PROTEIN ALBA-LIKE PROTEIN-RELATED', 253189),
(428075, 'PTHR13516:SF14', NULL, NULL, NULL, NULL, 'ALBA DNA/RNA-BINDING PROTEIN', 253189),
(428076, 'PTHR13516:SF25', NULL, NULL, NULL, NULL, 'ALBA DOMAIN-CONTAINING PROTEIN', 253189),
(428077, 'PTHR13516:SF13', NULL, NULL, NULL, NULL, 'ALBA DNA/RNA-BINDING PROTEIN', 253189),
(428078, 'PTHR13516:SF24', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 253189),
(428079, 'PTHR13516:SF19', NULL, NULL, NULL, NULL, 'OSJNBA0042L16.6 PROTEIN', 253189),
(428080, 'PTHR13516:SF18', NULL, NULL, NULL, NULL, 'ALBA DOMAIN-CONTAINING PROTEIN', 253189),
(428081, 'PTHR13516:SF17', NULL, NULL, NULL, NULL, 'PROTEIN ARGONAUTE 18-LIKE', 253189),
(428082, 'PTHR13516:SF27', NULL, NULL, NULL, NULL, 'COLD AND DROUGHT-REGULATED PROTEIN CORA-LIKE', 253189),
(428083, 'PTHR13516:SF8', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P PROTEIN SUBUNIT P25-LIKE PROTEIN', 253189),
(428084, 'PTHR13516:SF5', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P PROTEIN SUBUNIT P25', 253189),
(428085, 'PTHR13516:SF3', NULL, NULL, NULL, NULL, 'ALBA DNA/RNA-BINDING PROTEIN', 253189),
(428086, 'PTHR13516', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P SUBUNIT P25', 253189),
(428087, 'PTHR13516:SF4', NULL, NULL, NULL, NULL, 'FI09323P', 253189),
(428088, 'PTHR39615:SF1', NULL, NULL, NULL, NULL, 'YALI0E17897P', 253190),
(428089, 'PTHR39615', NULL, NULL, NULL, NULL, 'YALI0E17897P', 253190),
(428090, 'PTHR43450:SF7', NULL, NULL, NULL, NULL, 'ASPARTATE--TRNA LIGASE', 253191),
(428091, 'PTHR43450:SF8', NULL, NULL, NULL, NULL, 'ASPARTATE--TRNA LIGASE 1, CYTOPLASMIC', 253191),
(428092, 'PTHR43450:SF9', NULL, NULL, NULL, NULL, 'ASPARTYL-TRNA SYNTHETASE', 253191),
(428093, 'PTHR43450:SF3', NULL, NULL, NULL, NULL, 'ASPARTYL-TRNA SYNTHETASE', 253191),
(428094, 'PTHR43450:SF4', NULL, NULL, NULL, NULL, 'ASPARTATE--TRNA LIGASE', 253191),
(428095, 'PTHR43450:SF5', NULL, NULL, NULL, NULL, 'ASPARTYL-TRNA SYNTHETASE', 253191),
(428096, 'PTHR43450:SF6', NULL, NULL, NULL, NULL, 'ASPARTATE--TRNA LIGASE', 253191),
(428097, 'PTHR43450', NULL, NULL, NULL, NULL, 'ASPARTYL-TRNA SYNTHETASE', 253191),
(428098, 'PTHR43450:SF1', NULL, NULL, NULL, NULL, 'ASPARTATE--TRNA LIGASE, CYTOPLASMIC', 253191),
(428099, 'PTHR43450:SF2', NULL, NULL, NULL, NULL, 'ASPARTATE--TRNA LIGASE', 253191),
(428100, 'PTHR42039:SF2', NULL, NULL, NULL, NULL, 'ALLERGEN ASP F4 (AFU_ORTHOLOGUE AFUA_2G03830)-RELATED', 253192),
(428101, 'PTHR42039:SF1', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_3G02940)-RELATED', 253192),
(428102, 'PTHR42039', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_3G02940)-RELATED', 253192),
(428103, 'PTHR37165', NULL, NULL, NULL, NULL, 'PEPTIDASE U56 FAMILY', 253193),
(428104, 'PTHR37165:SF1', NULL, NULL, NULL, NULL, 'MARITIMACIN', 253193),
(428105, 'PTHR22576:SF38', NULL, NULL, NULL, NULL, 'MALT PARACASPASE 3', 253194);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(428106, 'PTHR22576:SF27', NULL, NULL, NULL, NULL, 'MALT PARACASPASE 2', 253194),
(428107, 'PTHR22576:SF37', NULL, NULL, NULL, NULL, 'MALT1 PARACASPASE HOMOLOG', 253194),
(428108, 'PTHR22576:SF42', NULL, NULL, NULL, NULL, 'CASPASE 23, APOPTOSIS-RELATED CYSTEINE PEPTIDASE', 253194),
(428109, 'PTHR22576:SF41', NULL, NULL, NULL, NULL, 'INACTIVE CASPASE B-RELATED', 253194),
(428110, 'PTHR22576', NULL, NULL, NULL, NULL, 'MUCOSA ASSOCIATED LYMPHOID TISSUE LYMPHOMA TRANSLOCATION PROTEIN 1/PARACASPASE', 253194),
(428111, 'PTHR22576:SF40', NULL, NULL, NULL, NULL, 'MUCOSA-ASSOCIATED LYMPHOID TISSUE LYMPHOMA TRANSLOCATION PROTEIN 1', 253194),
(428112, 'PTHR40690', NULL, NULL, NULL, NULL, 'GLL3100 PROTEIN', 253195),
(428113, 'PTHR40690:SF1', NULL, NULL, NULL, NULL, 'DUF1611 FAMILY PROTEIN', 253195),
(428114, 'PTHR38816', NULL, NULL, NULL, NULL, 'EXOSOME SUBUNIT, DUF54 FAMILY-RELATED', 253196),
(428115, 'PTHR38816:SF1', NULL, NULL, NULL, NULL, 'EXOSOME SUBUNIT, DUF54 FAMILY-RELATED', 253196),
(428116, 'PTHR33362:SF2', NULL, NULL, NULL, NULL, 'C4-DICARBOXYLATE TRANSPORT SYSTEM-RELATED', 253197),
(428117, 'PTHR33362:SF3', NULL, NULL, NULL, NULL, 'SIALIC ACID TRAP TRANSPORTER PERMEASE PROTEIN SIAT', 253197),
(428118, 'PTHR33362:SF7', NULL, NULL, NULL, NULL, 'SLL1103 PROTEIN', 253197),
(428119, 'PTHR33362:SF4', NULL, NULL, NULL, NULL, '2,3-DIKETO-L-GULONATE TRAP TRANSPORTER LARGE PERMEASE PROTEIN YIAN', 253197),
(428120, 'PTHR33362', NULL, NULL, NULL, NULL, 'SIALIC ACID TRAP TRANSPORTER PERMEASE PROTEIN SIAT-RELATED', 253197),
(428121, 'PTHR33362:SF5', NULL, NULL, NULL, NULL, 'C4-DICARBOXYLATE TRAP TRANSPORTER LARGE PERMEASE PROTEIN DCTM', 253197),
(428122, 'PTHR12313:SF4', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF5', 253198),
(428123, 'PTHR12313:SF0', NULL, NULL, NULL, NULL, 'FI06431P-RELATED', 253198),
(428124, 'PTHR12313:SF79', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253198),
(428125, 'PTHR12313:SF57', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RMA2', 253198),
(428126, 'PTHR12313:SF13', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF185', 253198),
(428127, 'PTHR12313:SF59', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RMA1', 253198),
(428128, 'PTHR12313:SF58', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RMA1H1-LIKE', 253198),
(428129, 'PTHR12313:SF97', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253198),
(428130, 'PTHR12313:SF53', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253198),
(428131, 'PTHR12313:SF96', NULL, NULL, NULL, NULL, 'YALI0D10615P', 253198),
(428132, 'PTHR12313:SF55', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF5-LIKE', 253198),
(428133, 'PTHR12313:SF77', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 253198),
(428134, 'PTHR12313:SF99', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253198),
(428135, 'PTHR12313:SF98', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 253198),
(428136, 'PTHR12313:SF71', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253198),
(428137, 'PTHR12313:SF93', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253198),
(428138, 'PTHR12313:SF70', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 253198),
(428139, 'PTHR12313:SF7', NULL, NULL, NULL, NULL, 'OS03G0678400 PROTEIN', 253198),
(428140, 'PTHR12313:SF73', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RMA1H1', 253198),
(428141, 'PTHR12313:SF95', NULL, NULL, NULL, NULL, 'OS08G0162400 PROTEIN', 253198),
(428142, 'PTHR12313:SF72', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253198),
(428143, 'PTHR12313:SF94', NULL, NULL, NULL, NULL, 'OS01G0830200 PROTEIN', 253198),
(428144, 'PTHR12313:SF107', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253198),
(428145, 'PTHR12313:SF106', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253198),
(428146, 'PTHR12313:SF101', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RMA1H1-LIKE', 253198),
(428147, 'PTHR12313:SF49', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF185-LIKE', 253198);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(428148, 'PTHR12313:SF100', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RMA1H1-LIKE', 253198),
(428149, 'PTHR12313:SF105', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RMA1H1-RELATED', 253198),
(428150, 'PTHR12313:SF104', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RMA1H1-LIKE PROTEIN', 253198),
(428151, 'PTHR12313:SF45', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RMA3-LIKE', 253198),
(428152, 'PTHR12313:SF67', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253198),
(428153, 'PTHR12313:SF89', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253198),
(428154, 'PTHR12313:SF103', NULL, NULL, NULL, NULL, 'OS04G0530500 PROTEIN', 253198),
(428155, 'PTHR12313:SF47', NULL, NULL, NULL, NULL, 'RING ZINC FINGER PROTEIN-RELATED', 253198),
(428156, 'PTHR12313:SF69', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RMA3', 253198),
(428157, 'PTHR12313:SF102', NULL, NULL, NULL, NULL, 'OS02G0639800 PROTEIN', 253198),
(428158, 'PTHR12313:SF85', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 253198),
(428159, 'PTHR12313:SF88', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253198),
(428160, 'PTHR12313:SF87', NULL, NULL, NULL, NULL, 'OS12G0636000 PROTEIN', 253198),
(428161, 'PTHR12313', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF5-RELATED', 253198),
(428162, 'PTHR12313:SF82', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RMA1H1-LIKE', 253198),
(428163, 'PTHR12313:SF60', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253198),
(428164, 'PTHR12313:SF81', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 253198),
(428165, 'PTHR12313:SF61', NULL, NULL, NULL, NULL, 'OS05G0470700 PROTEIN', 253198),
(428166, 'PTHR13680:SF36', NULL, NULL, NULL, NULL, 'MITONEET_N DOMAIN-CONTAINING PROTEIN', 253199),
(428167, 'PTHR13680:SF34', NULL, NULL, NULL, NULL, 'ZGC:110843', 253199),
(428168, 'PTHR13680', NULL, NULL, NULL, NULL, 'CDGSH IRON-SULFUR DOMAIN-CONTAINING PROTEIN 1', 253199),
(428169, 'PTHR13680:SF33', NULL, NULL, NULL, NULL, 'CDGSH IRON-SULFUR DOMAIN-CONTAINING PROTEIN 2', 253199),
(428170, 'PTHR13680:SF41', NULL, NULL, NULL, NULL, 'CDGSH IRON SULFUR DOMAIN 1', 253199),
(428171, 'PTHR13680:SF42', NULL, NULL, NULL, NULL, 'CDGSH IRON-SULFUR DOMAIN-CONTAINING PROTEIN 1', 253199),
(428172, 'PTHR13680:SF5', NULL, NULL, NULL, NULL, 'CDGSH IRON-SULFUR DOMAIN-CONTAINING PROTEIN 1', 253199),
(428173, 'PTHR33795:SF1', NULL, NULL, NULL, NULL, 'INSERTION ELEMENT IS150 PROTEIN INSJ', 253200),
(428174, 'PTHR33795', NULL, NULL, NULL, NULL, 'INSERTION ELEMENT IS150 PROTEIN INSJ', 253200),
(428175, 'PTHR30518:SF2', NULL, NULL, NULL, NULL, 'ENDOLYTIC MUREIN TRANSGLYCOSYLASE', 253201),
(428176, 'PTHR30518', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 253201),
(428177, 'PTHR13615', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE-LIKE 1', 253202),
(428178, 'PTHR13615:SF3', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE-LIKE DOMAIN-CONTAINING PROTEIN 1', 253202),
(428179, 'PTHR38825:SF1', NULL, NULL, NULL, NULL, 'LYSINE EXPORTER PROTEIN (LYSE/YGGA)', 253203),
(428180, 'PTHR38825:SF2', NULL, NULL, NULL, NULL, '', 253203),
(428181, 'PTHR38825', NULL, NULL, NULL, NULL, 'LYSINE EXPORTER PROTEIN (LYSE/YGGA)', 253203),
(428182, 'PTHR36120', NULL, NULL, NULL, NULL, '', 253204),
(428183, 'PTHR36120:SF1', NULL, NULL, NULL, NULL, 'FUCOSE_ISO_C DOMAIN-CONTAINING PROTEIN', 253204),
(428184, 'PTHR36120:SF2', NULL, NULL, NULL, NULL, '', 253204),
(428185, 'PTHR31342:SF35', NULL, NULL, NULL, NULL, 'PROTEIN CHUP1, CHLOROPLASTIC-LIKE', 253205),
(428186, 'PTHR31342:SF57', NULL, NULL, NULL, NULL, 'BNAA05G15040D PROTEIN', 253205),
(428187, 'PTHR31342:SF36', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE-BINDING CLATHRIN ADAPTOR, N-TERMINAL', 253205),
(428188, 'PTHR31342:SF58', NULL, NULL, NULL, NULL, '', 253205),
(428189, 'PTHR31342:SF56', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE-BINDING CLATHRIN ADAPTOR, N-TERMINAL', 253205),
(428190, 'PTHR31342:SF39', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 253205);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(428191, 'PTHR31342:SF18', NULL, NULL, NULL, NULL, 'OS01G0651932 PROTEIN', 253205),
(428192, 'PTHR31342:SF59', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 253205),
(428193, 'PTHR31342:SF37', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 253205),
(428194, 'PTHR31342:SF15', NULL, NULL, NULL, NULL, 'OS01G0580800 PROTEIN', 253205),
(428195, 'PTHR31342:SF16', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', 253205),
(428196, 'PTHR31342:SF50', NULL, NULL, NULL, NULL, '', 253205),
(428197, 'PTHR31342:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CHUP1, CHLOROPLASTIC', 253205),
(428198, 'PTHR31342:SF4', NULL, NULL, NULL, NULL, 'ACTIN BINDING PROTEIN FAMILY', 253205),
(428199, 'PTHR31342:SF53', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN FAMILY PROTEIN, PUTATIVE-RELATED', 253205),
(428200, 'PTHR31342:SF32', NULL, NULL, NULL, NULL, 'BNAC09G22360D PROTEIN', 253205),
(428201, 'PTHR31342:SF10', NULL, NULL, NULL, NULL, 'CHUP1-LIKE PROTEIN', 253205),
(428202, 'PTHR31342:SF54', NULL, NULL, NULL, NULL, '', 253205),
(428203, 'PTHR31342:SF51', NULL, NULL, NULL, NULL, 'BNAC08G42200D PROTEIN', 253205),
(428204, 'PTHR31342:SF52', NULL, NULL, NULL, NULL, '', 253205),
(428205, 'PTHR31342', NULL, NULL, NULL, NULL, 'PROTEIN CHUP1, CHLOROPLASTIC', 253205),
(428206, 'PTHR31342:SF46', NULL, NULL, NULL, NULL, 'OS07G0188266 PROTEIN', 253205),
(428207, 'PTHR31342:SF47', NULL, NULL, NULL, NULL, 'ACTIN BINDING PROTEIN FAMILY-RELATED', 253205),
(428208, 'PTHR31342:SF44', NULL, NULL, NULL, NULL, 'PROTEIN CHUP1, CHLOROPLASTIC-LIKE', 253205),
(428209, 'PTHR31342:SF48', NULL, NULL, NULL, NULL, 'CHUP1-LIKE PROTEIN', 253205),
(428210, 'PTHR31342:SF49', NULL, NULL, NULL, NULL, 'BNAA03G58190D PROTEIN', 253205),
(428211, 'PTHR31342:SF64', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 253205),
(428212, 'PTHR31342:SF65', NULL, NULL, NULL, NULL, 'CHUP1-LIKE PROTEIN', 253205),
(428213, 'PTHR31342:SF43', NULL, NULL, NULL, NULL, 'F11A17.16', 253205),
(428214, 'PTHR31342:SF62', NULL, NULL, NULL, NULL, '', 253205),
(428215, 'PTHR31342:SF63', NULL, NULL, NULL, NULL, '', 253205),
(428216, 'PTHR31342:SF41', NULL, NULL, NULL, NULL, 'PROTEIN CHUP1, CHLOROPLASTIC-LIKE', 253205),
(428217, 'PTHR36689', NULL, NULL, NULL, NULL, 'COLORECTAL CANCER-ASSOCIATED PROTEIN 2', 253206),
(428218, 'PTHR36689:SF1', NULL, NULL, NULL, NULL, 'COLCA2 HOMOLOG', 253206),
(428219, 'PTHR19290:SF7', NULL, NULL, NULL, NULL, 'OLIGODENDROCYTE TRANSCRIPTION FACTOR 1', 253207),
(428220, 'PTHR19290:SF105', NULL, NULL, NULL, NULL, 'NEUROGENIN-2', 253207),
(428221, 'PTHR19290:SF9', NULL, NULL, NULL, NULL, 'NEUROGENIC DIFFERENTIATION FACTOR 6', 253207),
(428222, 'PTHR19290', NULL, NULL, NULL, NULL, 'BASIC HELIX-LOOP-HELIX PROTEIN NEUROGENIN-RELATED', 253207),
(428223, 'PTHR19290:SF88', NULL, NULL, NULL, NULL, 'NEUROGENIC DIFFERENTIATION FACTOR 1', 253207),
(428224, 'PTHR19290:SF104', NULL, NULL, NULL, NULL, 'GH17679P', 253207),
(428225, 'PTHR19290:SF147', NULL, NULL, NULL, NULL, 'HELIX-LOOP-HELIX PROTEIN DELILAH', 253207),
(428226, 'PTHR19290:SF102', NULL, NULL, NULL, NULL, 'PROTEIN ATONAL HOMOLOG 8', 253207),
(428227, 'PTHR19290:SF86', NULL, NULL, NULL, NULL, 'NEUROGENIC DIFFERENTIATION FACTOR 4', 253207),
(428228, 'PTHR19290:SF166', NULL, NULL, NULL, NULL, 'ATONAL BHLH TRANSCRIPTION FACTOR 1A-RELATED', 253207),
(428229, 'PTHR19290:SF165', NULL, NULL, NULL, NULL, 'ACTIVATOR PROTEIN 4', 253207),
(428230, 'PTHR19290:SF82', NULL, NULL, NULL, NULL, 'PROTEIN ATONAL HOMOLOG 1', 253207),
(428231, 'PTHR19290:SF164', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 253207),
(428232, 'PTHR19290:SF163', NULL, NULL, NULL, NULL, 'NEUROGENIN 1', 253207),
(428233, 'PTHR19290:SF83', NULL, NULL, NULL, NULL, 'NEUROGENIC DIFFERENTIATION FACTOR 2', 253207),
(428234, 'PTHR19290:SF162', NULL, NULL, NULL, NULL, 'BASIC HELIX-LOOP-HELIX TRANSCRIPTION FACTOR AMOS-RELATED', 253207),
(428235, 'PTHR19290:SF161', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTION FACTOR 3', 253207),
(428236, 'PTHR19290:SF160', NULL, NULL, NULL, NULL, 'CLASS A BASIC HELIX-LOOP-HELIX PROTEIN 15', 253207);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(428237, 'PTHR19290:SF159', NULL, NULL, NULL, NULL, 'NEUROGENIN-1', 253207),
(428238, 'PTHR19290:SF99', NULL, NULL, NULL, NULL, 'PROTEIN ATONAL HOMOLOG 7', 253207),
(428239, 'PTHR19290:SF53', NULL, NULL, NULL, NULL, 'CLASS E BASIC HELIX-LOOP-HELIX PROTEIN 23', 253207),
(428240, 'PTHR19290:SF156', NULL, NULL, NULL, NULL, 'NEUROG3 PROTEIN', 253207),
(428241, 'PTHR19290:SF32', NULL, NULL, NULL, NULL, 'OLIGODENDROCYTE TRANSCRIPTION FACTOR 2', 253207),
(428242, 'PTHR19290:SF134', NULL, NULL, NULL, NULL, 'NEUROGENIC DIFFERENTIATION FACTOR 1', 253207),
(428243, 'PTHR19290:SF52', NULL, NULL, NULL, NULL, 'CLASS E BASIC HELIX-LOOP-HELIX PROTEIN 22', 253207),
(428244, 'PTHR19290:SF96', NULL, NULL, NULL, NULL, 'OLIGODENDROCYTE TRANSCRIPTION FACTOR 3', 253207),
(428245, 'PTHR19290:SF94', NULL, NULL, NULL, NULL, 'NEUROGENIN-3', 253207),
(428246, 'PTHR19290:SF130', NULL, NULL, NULL, NULL, 'NEUROGENIN-1', 253207),
(428247, 'PTHR19290:SF150', NULL, NULL, NULL, NULL, 'ATONAL BHLH TRANSCRIPTION FACTOR 1B', 253207),
(428248, 'PTHR41813', NULL, NULL, NULL, NULL, 'REGULATOR PAB1642, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G11955)-RELATED', 253208),
(428249, 'PTHR41813:SF2', NULL, NULL, NULL, NULL, 'REGULATOR PAB1642, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G11955)-RELATED', 253208),
(428250, 'PTHR24404:SF92', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 845', 253209),
(428251, 'PTHR24404:SF91', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 697', 253209),
(428252, 'PTHR24404:SF90', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 26-LIKE PROTEIN', 253209),
(428253, 'PTHR24404:SF28', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN EOS', 253209),
(428254, 'PTHR24404:SF49', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 24', 253209),
(428255, 'PTHR24404:SF26', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 613', 253209),
(428256, 'PTHR24404:SF46', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN GFI-1', 253209),
(428257, 'PTHR24404:SF23', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN AIOLOS', 253209),
(428258, 'PTHR24404:SF67', NULL, NULL, NULL, NULL, 'KLUMPFUSS, ISOFORM B', 253209),
(428259, 'PTHR24404:SF89', NULL, NULL, NULL, NULL, 'GROWTH FACTOR INDEPENDENT 1 TRANSCRIPTIONAL REPRESSOR', 253209),
(428260, 'PTHR24404:SF88', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 501', 253209),
(428261, 'PTHR24404:SF22', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 382', 253209),
(428262, 'PTHR24404:SF43', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR CTCF', 253209),
(428263, 'PTHR24404:SF65', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 253209),
(428264, 'PTHR24404:SF87', NULL, NULL, NULL, NULL, '', 253209),
(428265, 'PTHR24404:SF86', NULL, NULL, NULL, NULL, 'ZGC:174574-RELATED', 253209),
(428266, 'PTHR24404:SF85', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 691', 253209),
(428267, 'PTHR24404:SF41', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 567', 253209),
(428268, 'PTHR24404:SF84', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN EHN-3-RELATED', 253209),
(428269, 'PTHR24404:SF83', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 835', 253209),
(428270, 'PTHR24404:SF82', NULL, NULL, NULL, NULL, 'RH47711P-RELATED', 253209),
(428271, 'PTHR24404:SF81', NULL, NULL, NULL, NULL, '', 253209),
(428272, 'PTHR24404', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 253209),
(428273, 'PTHR24404:SF39', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN (C2H2 TYPE) 276', 253209),
(428274, 'PTHR24404:SF37', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 467', 253209),
(428275, 'PTHR24404:SF36', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN IKAROS', 253209),
(428276, 'PTHR24404:SF57', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 398', 253209),
(428277, 'PTHR24404:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 821', 253209),
(428278, 'PTHR24404:SF35', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 639', 253209),
(428279, 'PTHR24404:SF78', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZTF-16', 253209),
(428280, 'PTHR24404:SF34', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 649', 253209),
(428281, 'PTHR24404:SF56', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 281', 253209);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(428282, 'PTHR24404:SF33', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN HELIOS', 253209),
(428283, 'PTHR24404:SF11', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 350', 253209),
(428284, 'PTHR24404:SF55', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN PEGASUS', 253209),
(428285, 'PTHR24404:SF10', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 564', 253209),
(428286, 'PTHR24404:SF53', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 148', 253209),
(428287, 'PTHR24404:SF51', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 740', 253209),
(428288, 'PTHR24404:SF50', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 497', 253209),
(428289, 'PTHR11064:SF83', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT B-4', 253210),
(428290, 'PTHR11064:SF180', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT BETA', 253210),
(428291, 'PTHR11064:SF181', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT B-8', 253210),
(428292, 'PTHR11064:SF160', NULL, NULL, NULL, NULL, 'CBFD_NFYB_HMF DOMAIN-CONTAINING PROTEIN', 253210),
(428293, 'PTHR11064:SF182', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT B-5-LIKE', 253210),
(428294, 'PTHR11064:SF183', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT BETA', 253210),
(428295, 'PTHR11064:SF173', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT B-10', 253210),
(428296, 'PTHR11064:SF174', NULL, NULL, NULL, NULL, 'CBFD_NFYB_HMF DOMAIN-CONTAINING PROTEIN', 253210),
(428297, 'PTHR11064:SF130', NULL, NULL, NULL, NULL, 'CBFD_NFYB_HMF DOMAIN-CONTAINING PROTEIN', 253210),
(428298, 'PTHR11064:SF153', NULL, NULL, NULL, NULL, 'CBFD_NFYB_HMF DOMAIN-CONTAINING PROTEIN', 253210),
(428299, 'PTHR11064:SF175', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y PROTEIN', 253210),
(428300, 'PTHR11064:SF176', NULL, NULL, NULL, NULL, 'CBFD_NFYB_HMF DOMAIN-CONTAINING PROTEIN', 253210),
(428301, 'PTHR11064:SF177', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT B-1', 253210),
(428302, 'PTHR11064:SF156', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT B-2', 253210),
(428303, 'PTHR11064:SF178', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT B-3-LIKE', 253210),
(428304, 'PTHR11064:SF179', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT B-2-RELATED', 253210),
(428305, 'PTHR11064:SF115', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT B-6', 253210),
(428306, 'PTHR11064:SF139', NULL, NULL, NULL, NULL, 'CBFD_NFYB_HMF DOMAIN-CONTAINING PROTEIN', 253210),
(428307, 'PTHR11064:SF9', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT BETA', 253210),
(428308, 'PTHR11064:SF190', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT B-10-LIKE ISOFORM X1', 253210),
(428309, 'PTHR11064:SF191', NULL, NULL, NULL, NULL, 'CBFD_NFYB_HMF DOMAIN-CONTAINING PROTEIN', 253210),
(428310, 'PTHR11064:SF171', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT B-10', 253210),
(428311, 'PTHR11064:SF150', NULL, NULL, NULL, NULL, 'CBFD_NFYB_HMF DOMAIN-CONTAINING PROTEIN', 253210),
(428312, 'PTHR11064:SF140', NULL, NULL, NULL, NULL, 'CBFD_NFYB_HMF DOMAIN-CONTAINING PROTEIN', 253210),
(428313, 'PTHR11064:SF162', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT B-6', 253210),
(428314, 'PTHR11064:SF184', NULL, NULL, NULL, NULL, 'HISTONE-FOLD PROTEIN-RELATED', 253210),
(428315, 'PTHR11064:SF185', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT B-8', 253210),
(428316, 'PTHR11064:SF163', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y PROTEIN', 253210),
(428317, 'PTHR11064:SF141', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT B-1', 253210),
(428318, 'PTHR11064:SF164', NULL, NULL, NULL, NULL, 'HAP3 SUBUNIT OF HAP COMPLEX', 253210),
(428319, 'PTHR11064:SF120', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT BETA', 253210),
(428320, 'PTHR11064:SF186', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT B-10-LIKE ISOFORM X1', 253210),
(428321, 'PTHR11064:SF187', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y PROTEIN', 253210);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(428322, 'PTHR11064:SF166', NULL, NULL, NULL, NULL, 'CBFD_NFYB_HMF DOMAIN-CONTAINING PROTEIN', 253210),
(428323, 'PTHR11064:SF188', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y PROTEIN', 253210),
(428324, 'PTHR11064:SF122', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT B-7', 253210),
(428325, 'PTHR11064:SF123', NULL, NULL, NULL, NULL, 'CBFD_NFYB_HMF DOMAIN-CONTAINING PROTEIN', 253210),
(428326, 'PTHR11064:SF189', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT B-3', 253210),
(428327, 'PTHR11064:SF168', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT B-9', 253210),
(428328, 'PTHR11064:SF125', NULL, NULL, NULL, NULL, 'CBFD_NFYB_HMF DOMAIN-CONTAINING PROTEIN', 253210),
(428329, 'PTHR11064:SF148', NULL, NULL, NULL, NULL, 'CBFD_NFYB_HMF DOMAIN-CONTAINING PROTEIN', 253210),
(428330, 'PTHR11064:SF104', NULL, NULL, NULL, NULL, 'CAAT BOX DNA-BINDING PROTEIN SUBUNIT B', 253210),
(428331, 'PTHR11064:SF126', NULL, NULL, NULL, NULL, 'CBFD_NFYB_HMF DOMAIN-CONTAINING PROTEIN', 253210),
(428332, 'PTHR11064:SF37', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT B-2', 253210),
(428333, 'PTHR11064:SF149', NULL, NULL, NULL, NULL, 'OS01G0935100 PROTEIN', 253210),
(428334, 'PTHR11064:SF106', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT B-5', 253210),
(428335, 'PTHR11064', NULL, NULL, NULL, NULL, 'CCAAT-BINDING TRANSCRIPTION FACTOR-RELATED', 253210),
(428336, 'PTHR11064:SF109', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR Y SUBUNIT B-4', 253210),
(428337, 'PTHR15880', NULL, NULL, NULL, NULL, 'ASPARTATE-RICH PROTEIN 1', 253211),
(428338, 'PTHR15880:SF0', NULL, NULL, NULL, NULL, 'ASPARTATE-RICH PROTEIN 1', 253211),
(428339, 'PTHR15880:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 22 OPEN READING FRAME 42', 253211),
(428340, 'PTHR46516', NULL, NULL, NULL, NULL, 'TRNA-SPECIFIC ADENOSINE DEAMINASE 1', 253212),
(428341, 'PTHR46516:SF1', NULL, NULL, NULL, NULL, 'TRNA-SPECIFIC ADENOSINE DEAMINASE 1', 253212),
(428342, 'PTHR46237:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 REDUCTASE 4', 253213),
(428343, 'PTHR46237', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 REDUCTASE 4 FAMILY MEMBER', 253213),
(428344, 'PTHR47911', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN-LIKE', 253214),
(428345, 'PTHR47911:SF1', NULL, NULL, NULL, NULL, 'OS06G0664400 PROTEIN', 253214),
(428346, 'PTHR47911:SF2', NULL, NULL, NULL, NULL, 'BNAA05G14260D PROTEIN', 253214),
(428347, 'PTHR33831:SF9', NULL, NULL, NULL, NULL, 'SPARK DOMAIN-CONTAINING PROTEIN', 253215),
(428348, 'PTHR33831', NULL, NULL, NULL, NULL, 'GPI-ANCHORED PROTEIN', 253215),
(428349, 'PTHR33831:SF6', NULL, NULL, NULL, NULL, 'SPARK DOMAIN-CONTAINING PROTEIN', 253215),
(428350, 'PTHR33831:SF5', NULL, NULL, NULL, NULL, 'OS07G0102300 PROTEIN', 253215),
(428351, 'PTHR33831:SF8', NULL, NULL, NULL, NULL, 'SPARK DOMAIN-CONTAINING PROTEIN', 253215),
(428352, 'PTHR33831:SF4', NULL, NULL, NULL, NULL, 'GPI-ANCHORED PROTEIN', 253215),
(428353, 'PTHR33831:SF13', NULL, NULL, NULL, NULL, 'SPARK DOMAIN-CONTAINING PROTEIN', 253215),
(428354, 'PTHR33831:SF12', NULL, NULL, NULL, NULL, 'RAB-GAP TBC DOMAIN-CONTAINING PROTEIN', 253215),
(428355, 'PTHR10353:SF137', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 24', 253216),
(428356, 'PTHR10353:SF28', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 44', 253216),
(428357, 'PTHR10353:SF27', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 47', 253216),
(428358, 'PTHR10353:SF139', NULL, NULL, NULL, NULL, '6-PHOSPHO-BETA-GLUCOSIDASE GMUD', 253216),
(428359, 'PTHR10353:SF134', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_3G12600)-RELATED', 253216),
(428360, 'PTHR10353:SF254', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253216),
(428361, 'PTHR10353:SF257', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 253216),
(428362, 'PTHR10353:SF136', NULL, NULL, NULL, NULL, 'ARYL-PHOSPHO-BETA-D-GLUCOSIDASE BGLC', 253216),
(428363, 'PTHR10353:SF256', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253216),
(428364, 'PTHR10353:SF251', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253216),
(428365, 'PTHR10353:SF250', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253216);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(428366, 'PTHR10353:SF253', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 28', 253216),
(428367, 'PTHR10353:SF252', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253216),
(428368, 'PTHR10353:SF29', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 11', 253216),
(428369, 'PTHR10353:SF36', NULL, NULL, NULL, NULL, 'LACTASE-LIKE PROTEIN', 253216),
(428370, 'PTHR10353:SF249', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253216),
(428371, 'PTHR10353:SF38', NULL, NULL, NULL, NULL, 'LACTASE-PHLORIZIN HYDROLASE', 253216),
(428372, 'PTHR10353:SF122', NULL, NULL, NULL, NULL, '6-PHOSPHO-BETA-GLUCOSIDASE ASCB-RELATED', 253216),
(428373, 'PTHR10353:SF243', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253216),
(428374, 'PTHR10353:SF246', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE FAMILY 1-RELATED', 253216),
(428375, 'PTHR10353:SF245', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253216),
(428376, 'PTHR10353:SF240', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE, PUTATIVE-RELATED', 253216),
(428377, 'PTHR10353:SF242', NULL, NULL, NULL, NULL, '', 253216),
(428378, 'PTHR10353:SF241', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 253216),
(428379, 'PTHR10353:SF237', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 16', 253216),
(428380, 'PTHR10353:SF236', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 18', 253216),
(428381, 'PTHR10353:SF239', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253216),
(428382, 'PTHR10353:SF238', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253216),
(428383, 'PTHR10353:SF199', NULL, NULL, NULL, NULL, '4-HYDROXY-7-METHOXY-3-OXO-3,4-DIHYDRO-2H-1,4-BENZOXAZIN-2-YL GLUCOSIDEBETA-D-GLUCOSIDASE', 253216),
(428384, 'PTHR10353:SF235', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 24', 253216),
(428385, 'PTHR10353:SF234', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 12', 253216),
(428386, 'PTHR10353:SF196', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 43-LIKE', 253216),
(428387, 'PTHR10353:SF195', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 47', 253216),
(428388, 'PTHR10353:SF231', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253216),
(428389, 'PTHR10353:SF85', NULL, NULL, NULL, NULL, 'ARYL-PHOSPHO-BETA-D-GLUCOSIDASE BGLA', 253216),
(428390, 'PTHR10353:SF197', NULL, NULL, NULL, NULL, 'INACTIVE BETA-GLUCOSIDASE 33-RELATED', 253216),
(428391, 'PTHR10353:SF192', NULL, NULL, NULL, NULL, '4-HYDROXY-7-METHOXY-3-OXO-3,4-DIHYDRO-2H-1,4-BENZOXAZIN-2-YL GLUCOSIDEBETA-D-GLUCOSIDASE', 253216),
(428392, 'PTHR10353:SF191', NULL, NULL, NULL, NULL, 'INACTIVE BETA-GLUCOSIDASE 14-RELATED', 253216),
(428393, 'PTHR10353:SF226', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 26, PEROXISOMAL', 253216),
(428394, 'PTHR10353:SF228', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253216),
(428395, 'PTHR10353:SF227', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 46-LIKE', 253216),
(428396, 'PTHR10353:SF10', NULL, NULL, NULL, NULL, 'KLOTHO', 253216),
(428397, 'PTHR10353:SF221', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253216),
(428398, 'PTHR10353:SF224', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 15', 253216),
(428399, 'PTHR10353:SF223', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253216),
(428400, 'PTHR10353:SF184', NULL, NULL, NULL, NULL, '', 253216),
(428401, 'PTHR10353:SF220', NULL, NULL, NULL, NULL, 'FURCATIN HYDROLASE-LIKE', 253216),
(428402, 'PTHR10353:SF187', NULL, NULL, NULL, NULL, '4-HYDROXY-7-METHOXY-3-OXO-3,4-DIHYDRO-2H-1,4-BENZOXAZIN-2-YL GLUCOSIDEBETA-D-GLUCOSIDASE', 253216),
(428403, 'PTHR10353:SF182', NULL, NULL, NULL, NULL, 'MYROSINASE 2-RELATED', 253216),
(428404, 'PTHR10353:SF69', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 8', 253216),
(428405, 'PTHR10353:SF214', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 44-LIKE', 253216),
(428406, 'PTHR10353:SF217', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 26', 253216),
(428407, 'PTHR10353:SF216', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 18-LIKE ISOFORM X1', 253216),
(428408, 'PTHR10353:SF178', NULL, NULL, NULL, NULL, 'INACTIVE BETA-GLUCOSIDASE 25-RELATED', 253216),
(428409, 'PTHR10353:SF211', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 10-RELATED', 253216),
(428410, 'PTHR10353:SF298', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 12-RELATED', 253216),
(428411, 'PTHR10353:SF210', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE', 253216);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(428412, 'PTHR10353:SF65', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 27', 253216),
(428413, 'PTHR10353:SF213', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 45-RELATED', 253216),
(428414, 'PTHR10353:SF68', NULL, NULL, NULL, NULL, 'BETA-KLOTHO', 253216),
(428415, 'PTHR10353:SF179', NULL, NULL, NULL, NULL, 'BETA-D-GLUCOPYRANOSYL ABSCISATE BETA-GLUCOSIDASE', 253216),
(428416, 'PTHR10353:SF61', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 22', 253216),
(428417, 'PTHR10353:SF173', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253216),
(428418, 'PTHR10353:SF176', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 29', 253216),
(428419, 'PTHR10353:SF297', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE FAMILY 1 PROTEIN', 253216),
(428420, 'PTHR10353:SF175', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 18-LIKE', 253216),
(428421, 'PTHR10353:SF296', NULL, NULL, NULL, NULL, '6-PHOSPHO-BETA-GLUCOSIDASE', 253216),
(428422, 'PTHR10353:SF170', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 44-LIKE', 253216),
(428423, 'PTHR10353:SF291', NULL, NULL, NULL, NULL, 'CYTOSOLIC BETA-GLUCOSIDASE', 253216),
(428424, 'PTHR10353:SF290', NULL, NULL, NULL, NULL, '4-HYDROXY-7-METHOXY-3-OXO-3,4-DIHYDRO-2H-1,4-BENZOXAZIN-2-YL GLUCOSIDEBETA-D-GLUCOSIDASE', 253216),
(428425, 'PTHR10353:SF172', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE FAMILY 1 PROTEIN', 253216),
(428426, 'PTHR10353:SF292', NULL, NULL, NULL, NULL, 'VICIANIN HYDROLASE-LIKE ISOFORM X1', 253216),
(428427, 'PTHR10353:SF218', NULL, NULL, NULL, NULL, 'MYROSINASE 1', 253216),
(428428, 'PTHR10353:SF204', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 20', 253216),
(428429, 'PTHR10353:SF325', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 11-LIKE', 253216),
(428430, 'PTHR10353:SF324', NULL, NULL, NULL, NULL, 'ZP DOMAIN-CONTAINING PROTEIN', 253216),
(428431, 'PTHR10353:SF203', NULL, NULL, NULL, NULL, '4-HYDROXY-7-METHOXY-3-OXO-3,4-DIHYDRO-2H-1,4-BENZOXAZIN-2-YL GLUCOSIDEBETA-D-GLUCOSIDASE', 253216),
(428432, 'PTHR10353:SF206', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE FAMILY 1 PROTEIN', 253216),
(428433, 'PTHR10353:SF326', NULL, NULL, NULL, NULL, '4-HYDROXY-7-METHOXY-3-OXO-3,4-DIHYDRO-2H-1,4-BENZOXAZIN-2-YL GLUCOSIDE BETA-D-GLUCOSIDASE 1, CHLOROPLASTIC', 253216),
(428434, 'PTHR10353:SF321', NULL, NULL, NULL, NULL, '4-HYDROXY-7-METHOXY-3-OXO-3,4-DIHYDRO-2H-1,4-BENZOXAZIN-2-YL GLUCOSIDEBETA-D-GLUCOSIDASE', 253216),
(428435, 'PTHR10353:SF288', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253216),
(428436, 'PTHR10353:SF200', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 20', 253216),
(428437, 'PTHR10353:SF77', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 7', 253216),
(428438, 'PTHR10353:SF167', NULL, NULL, NULL, NULL, '4-HYDROXY-7-METHOXY-3-OXO-3,4-DIHYDRO-2H-1,4-BENZOXAZIN-2-YL GLUCOSIDEBETA-D-GLUCOSIDASE', 253216),
(428439, 'PTHR10353:SF320', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 33', 253216),
(428440, 'PTHR10353:SF166', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE FAMILY 1 PROTEIN', 253216),
(428441, 'PTHR10353:SF287', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253216),
(428442, 'PTHR10353:SF169', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 11-LIKE', 253216),
(428443, 'PTHR10353:SF323', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 253216),
(428444, 'PTHR10353:SF322', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 13-LIKE ISOFORM X2', 253216),
(428445, 'PTHR10353:SF289', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253216),
(428446, 'PTHR10353:SF284', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253216),
(428447, 'PTHR10353:SF163', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 19', 253216),
(428448, 'PTHR10353:SF286', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253216),
(428449, 'PTHR10353:SF165', NULL, NULL, NULL, NULL, '4-HYDROXY-7-METHOXY-3-OXO-3,4-DIHYDRO-2H-1,4-BENZOXAZIN-2-YL GLUCOSIDEBETA-D-GLUCOSIDASE', 253216),
(428450, 'PTHR10353:SF164', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 30', 253216),
(428451, 'PTHR10353:SF285', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 12-RELATED', 253216),
(428452, 'PTHR10353:SF280', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 253216),
(428453, 'PTHR10353:SF161', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 43', 253216);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(428454, 'PTHR10353:SF282', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253216),
(428455, 'PTHR10353:SF160', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 11', 253216),
(428456, 'PTHR10353:SF281', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253216),
(428457, 'PTHR10353:SF208', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE FAMILY 1 PROTEIN', 253216),
(428458, 'PTHR10353:SF207', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 27', 253216),
(428459, 'PTHR10353:SF209', NULL, NULL, NULL, NULL, 'GALACTOLIPID GALACTOSYLTRANSFERASE SFR2, CHLOROPLASTIC', 253216),
(428460, 'PTHR10353:SF314', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253216),
(428461, 'PTHR10353:SF159', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 16', 253216),
(428462, 'PTHR10353:SF313', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 6', 253216),
(428463, 'PTHR10353:SF316', NULL, NULL, NULL, NULL, '', 253216),
(428464, 'PTHR10353:SF315', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 12-LIKE', 253216),
(428465, 'PTHR10353:SF44', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 17', 253216),
(428466, 'PTHR10353:SF156', NULL, NULL, NULL, NULL, '4-HYDROXY-7-METHOXY-3-OXO-3,4-DIHYDRO-2H-1,4-BENZOXAZIN-2-YL GLUCOSIDEBETA-D-GLUCOSIDASE', 253216),
(428467, 'PTHR10353:SF310', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 42', 253216),
(428468, 'PTHR10353:SF276', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253216),
(428469, 'PTHR10353:SF279', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253216),
(428470, 'PTHR10353:SF158', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 11', 253216),
(428471, 'PTHR10353:SF312', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253216),
(428472, 'PTHR10353:SF278', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 11-LIKE', 253216),
(428473, 'PTHR10353:SF311', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253216),
(428474, 'PTHR10353:SF273', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE FAMILY 1 PROTEIN', 253216),
(428475, 'PTHR10353:SF152', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE FAMILY 1 PROTEIN', 253216),
(428476, 'PTHR10353:SF154', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE FAMILY 1 PROTEIN', 253216),
(428477, 'PTHR10353:SF150', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 1-RELATED', 253216),
(428478, 'PTHR10353:SF271', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253216),
(428479, 'PTHR10353:SF270', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253216),
(428480, 'PTHR10353:SF318', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 31-RELATED', 253216),
(428481, 'PTHR10353:SF317', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 31', 253216),
(428482, 'PTHR10353:SF319', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 32', 253216),
(428483, 'PTHR10353:SF303', NULL, NULL, NULL, NULL, '4-HYDROXY-7-METHOXY-3-OXO-3,4-DIHYDRO-2H-1,4-BENZOXAZIN-2-YL GLUCOSIDEBETA-D-GLUCOSIDASE', 253216),
(428484, 'PTHR10353:SF302', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 40', 253216),
(428485, 'PTHR10353:SF266', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 21-RELATED', 253216),
(428486, 'PTHR10353:SF265', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253216),
(428487, 'PTHR10353:SF144', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE', 253216),
(428488, 'PTHR10353:SF268', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE FAMILY 1-RELATED', 253216),
(428489, 'PTHR10353:SF301', NULL, NULL, NULL, NULL, 'MYROSINASE 4-RELATED', 253216),
(428490, 'PTHR10353:SF267', NULL, NULL, NULL, NULL, 'GLYCOSIDE HYDROLASE-RELATED', 253216),
(428491, 'PTHR10353:SF300', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 18-LIKE', 253216),
(428492, 'PTHR10353:SF56', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 38', 253216),
(428493, 'PTHR10353:SF141', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE 40-LIKE', 253216),
(428494, 'PTHR10353:SF262', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 253216),
(428495, 'PTHR10353:SF53', NULL, NULL, NULL, NULL, 'BETA-1,4-GLUCOSIDASE (EUROFUNG)', 253216),
(428496, 'PTHR10353:SF264', NULL, NULL, NULL, NULL, 'SINIGRINASE', 253216),
(428497, 'PTHR10353:SF260', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE', 253216),
(428498, 'PTHR10353', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE', 253216),
(428499, 'PTHR10353:SF306', NULL, NULL, NULL, NULL, '4-HYDROXY-7-METHOXY-3-OXO-3,4-DIHYDRO-2H-1,4-BENZOXAZIN-2-YL GLUCOSIDEBETA-D-GLUCOSIDASE', 253216);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(428500, 'PTHR31360:SF11', NULL, NULL, NULL, NULL, 'OIL BODY-ASSOCIATED PROTEIN 2C', 253217),
(428501, 'PTHR31360:SF0', NULL, NULL, NULL, NULL, 'OIL BODY-ASSOCIATED PROTEIN 1B', 253217),
(428502, 'PTHR31360:SF1', NULL, NULL, NULL, NULL, 'OIL BODY-ASSOCIATED PROTEIN 2A', 253217),
(428503, 'PTHR31360:SF13', NULL, NULL, NULL, NULL, '', 253217),
(428504, 'PTHR31360:SF14', NULL, NULL, NULL, NULL, 'OIL BODY-ASSOCIATED PROTEIN 2B', 253217),
(428505, 'PTHR31360:SF10', NULL, NULL, NULL, NULL, 'OIL BODY-ASSOCIATED PROTEIN 1A', 253217),
(428506, 'PTHR31360', NULL, NULL, NULL, NULL, '', 253217),
(428507, 'PTHR31360:SF16', NULL, NULL, NULL, NULL, '', 253217),
(428508, 'PTHR31360:SF17', NULL, NULL, NULL, NULL, 'OIL BODY-ASSOCIATED PROTEIN 2B', 253217),
(428509, 'PTHR47168:SF1', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253218),
(428510, 'PTHR47168:SF4', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253218),
(428511, 'PTHR47168:SF3', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253218),
(428512, 'PTHR47168', NULL, NULL, NULL, NULL, 'RING ZINC FINGER DOMAIN SUPERFAMILY PROTEIN-RELATED', 253218),
(428513, 'PTHR15182:SF0', NULL, NULL, NULL, NULL, 'A-KINASE ANCHOR PROTEIN 5', 253219),
(428514, 'PTHR15182', NULL, NULL, NULL, NULL, 'A-KINASE ANCHOR PROTEIN 5-RELATED', 253219),
(428515, 'PTHR45719:SF25', NULL, NULL, NULL, NULL, 'BNAC03G69390D PROTEIN', 253220),
(428516, 'PTHR45719:SF28', NULL, NULL, NULL, NULL, 'BNAC02G20540D PROTEIN', 253220),
(428517, 'PTHR45719:SF27', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE, FAMILY 14-RELATED', 253220),
(428518, 'PTHR45719:SF29', NULL, NULL, NULL, NULL, 'BETA-GLUCURONOSYLTRANSFERASE GLCAT14A-LIKE', 253220),
(428519, 'PTHR45719:SF9', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING BETA-1,6-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 253220),
(428520, 'PTHR45719:SF31', NULL, NULL, NULL, NULL, 'BETA-GLUCURONOSYLTRANSFERASE GLCAT14A-LIKE ISOFORM X1', 253220),
(428521, 'PTHR45719:SF30', NULL, NULL, NULL, NULL, 'BNAC01G19670D PROTEIN', 253220),
(428522, 'PTHR45719:SF5', NULL, NULL, NULL, NULL, 'BETA-GLUCURONOSYLTRANSFERASE GLCAT14B-LIKE', 253220),
(428523, 'PTHR45719:SF11', NULL, NULL, NULL, NULL, 'OS01G0121800 PROTEIN', 253220),
(428524, 'PTHR45719:SF33', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE, FAMILY 14-RELATED', 253220),
(428525, 'PTHR45719:SF6', NULL, NULL, NULL, NULL, 'BETA-1-3-GALACTOSYL-O-GLYCOSYL-GLYCOPROTEIN, PUTATIVE, EXPRESSED-RELATED', 253220),
(428526, 'PTHR45719:SF10', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING BETA-1,6-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 253220),
(428527, 'PTHR45719:SF32', NULL, NULL, NULL, NULL, 'BNAC04G31930D PROTEIN', 253220),
(428528, 'PTHR45719:SF7', NULL, NULL, NULL, NULL, 'OS01G0201100 PROTEIN', 253220),
(428529, 'PTHR45719:SF13', NULL, NULL, NULL, NULL, 'OS01G0772500 PROTEIN', 253220),
(428530, 'PTHR45719:SF8', NULL, NULL, NULL, NULL, 'BETA-GLUCURONOSYLTRANSFERASE GLCAT14C', 253220),
(428531, 'PTHR45719:SF34', NULL, NULL, NULL, NULL, 'BNACNNG43180D PROTEIN', 253220),
(428532, 'PTHR45719:SF12', NULL, NULL, NULL, NULL, 'BETA-GLUCURONOSYLTRANSFERASE GLCAT14A-LIKE', 253220),
(428533, 'PTHR45719', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253220),
(428534, 'PTHR45719:SF2', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING BETA-16-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 253220),
(428535, 'PTHR45719:SF3', NULL, NULL, NULL, NULL, 'BETA-GLUCURONOSYLTRANSFERASE GLCAT14A', 253220),
(428536, 'PTHR45719:SF4', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING BETA-1,6-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 253220),
(428537, 'PTHR45719:SF37', NULL, NULL, NULL, NULL, 'BETA-GLUCURONOSYLTRANSFERASE GLCAT14A-LIKE', 253220),
(428538, 'PTHR45719:SF36', NULL, NULL, NULL, NULL, '', 253220),
(428539, 'PTHR45719:SF14', NULL, NULL, NULL, NULL, 'BETA-GLUCURONOSYLTRANSFERASE GLCAT14A', 253220),
(428540, 'PTHR45719:SF39', NULL, NULL, NULL, NULL, 'OS04G0301700 PROTEIN', 253220),
(428541, 'PTHR45719:SF38', NULL, NULL, NULL, NULL, 'BETA-GLUCURONOSYLTRANSFERASE GLCAT14B', 253220);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(428542, 'PTHR45719:SF16', NULL, NULL, NULL, NULL, '', 253220),
(428543, 'PTHR45719:SF19', NULL, NULL, NULL, NULL, 'BETA-GLUCURONOSYLTRANSFERASE GLCAT14B-LIKE', 253220),
(428544, 'PTHR45719:SF18', NULL, NULL, NULL, NULL, 'BETA-GLUCURONOSYLTRANSFERASE GLCAT14B-LIKE', 253220),
(428545, 'PTHR45719:SF20', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING BETA-1,6-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN', 253220),
(428546, 'PTHR45719:SF22', NULL, NULL, NULL, NULL, 'BNAA06G01150D PROTEIN', 253220),
(428547, 'PTHR45719:SF23', NULL, NULL, NULL, NULL, 'BETA-GLUCURONOSYLTRANSFERASE GLCAT14A-LIKE', 253220),
(428548, 'PTHR15159:SF3', NULL, NULL, NULL, NULL, 'SI:DKEY-175G6.2', 253221),
(428549, 'PTHR15159:SF2', NULL, NULL, NULL, NULL, 'NEUROSECRETORY PROTEIN VGF', 253221),
(428550, 'PTHR15159', NULL, NULL, NULL, NULL, 'NEUROSECRETORY PROTEIN VGF', 253221),
(428551, 'PTHR35480', NULL, NULL, NULL, NULL, 'MATERNAL EFFECT EMBRYO ARREST 22', 253222),
(428552, 'PTHR35480:SF1', NULL, NULL, NULL, NULL, 'MATERNAL EFFECT EMBRYO ARREST 22', 253222),
(428553, 'PTHR45881:SF1', NULL, NULL, NULL, NULL, 'CHECKPOINT SUPPRESSOR 1-LIKE, ISOFORM A-RELATED', 253223),
(428554, 'PTHR45881:SF2', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN J1.2', 253223),
(428555, 'PTHR45881', NULL, NULL, NULL, NULL, 'CHECKPOINT SUPPRESSOR 1-LIKE, ISOFORM A-RELATED', 253223),
(428556, 'PTHR45881:SF3', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN K2', 253223),
(428557, 'PTHR45881:SF4', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN K1', 253223),
(428558, 'PTHR45881:SF5', NULL, NULL, NULL, NULL, 'FORK-HEAD DOMAIN-CONTAINING PROTEIN', 253223),
(428559, 'PTHR46108', NULL, NULL, NULL, NULL, 'BLUE CHEESE', 253224),
(428560, 'PTHR46108:SF4', NULL, NULL, NULL, NULL, 'BLUE CHEESE', 253224),
(428561, 'PTHR46108:SF1', NULL, NULL, NULL, NULL, 'WD REPEAT AND FYVE DOMAIN-CONTAINING PROTEIN 3', 253224),
(428562, 'PTHR46108:SF3', NULL, NULL, NULL, NULL, 'WD REPEAT- AND FYVE DOMAIN-CONTAINING PROTEIN 4', 253224),
(428563, 'PTHR11318:SF4', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE ACTIVATOR 2B', 253225),
(428564, 'PTHR11318:SF3', NULL, NULL, NULL, NULL, 'GUANYLIN', 253225),
(428565, 'PTHR11318', NULL, NULL, NULL, NULL, 'GUANYLIN FAMILY MEMBER', 253225),
(428566, 'PTHR22961:SF15', NULL, NULL, NULL, NULL, 'TRIBBLES HOMOLOG 2', 253226),
(428567, 'PTHR22961:SF14', NULL, NULL, NULL, NULL, 'TRIBBLES HOMOLOG 3', 253226),
(428568, 'PTHR22961:SF13', NULL, NULL, NULL, NULL, 'TRIBBLES', 253226),
(428569, 'PTHR22961', NULL, NULL, NULL, NULL, 'SER/THR PROTEIN KINASE-TRB', 253226),
(428570, 'PTHR22961:SF17', NULL, NULL, NULL, NULL, 'TRIBBLES HOMOLOG 1', 253226),
(428571, 'PTHR22961:SF16', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 40', 253226),
(428572, 'PTHR46367:SF1', NULL, NULL, NULL, NULL, 'SCA7 DOMAIN-CONTAINING PROTEIN', 253227),
(428573, 'PTHR46367:SF2', NULL, NULL, NULL, NULL, 'ATAXIN-7-LIKE PROTEIN 3', 253227),
(428574, 'PTHR46367:SF3', NULL, NULL, NULL, NULL, 'ATAXIN-7-LIKE PROTEIN 3', 253227),
(428575, 'PTHR46367', NULL, NULL, NULL, NULL, 'ATAXIN-7-LIKE PROTEIN 3', 253227),
(428576, 'PTHR10614', NULL, NULL, NULL, NULL, 'INSULIN RECEPTOR SUBSTRATE', 253228),
(428577, 'PTHR10614:SF9', NULL, NULL, NULL, NULL, 'SI:CH73-335L21.1', 253228),
(428578, 'PTHR10614:SF7', NULL, NULL, NULL, NULL, 'INSULIN RECEPTOR SUBSTRATE 2', 253228),
(428579, 'PTHR10614:SF8', NULL, NULL, NULL, NULL, 'INSULIN RECEPTOR SUBSTRATE 3', 253228),
(428580, 'PTHR10614:SF11', NULL, NULL, NULL, NULL, 'INSULIN RECEPTOR SUBSTRATE 1', 253228),
(428581, 'PTHR10614:SF10', NULL, NULL, NULL, NULL, '', 253228),
(428582, 'PTHR10614:SF2', NULL, NULL, NULL, NULL, 'INSULIN RECEPTOR SUBSTRATE 4', 253228),
(428583, 'PTHR10614:SF13', NULL, NULL, NULL, NULL, 'INSULIN RECEPTOR SUBSTRATE 1', 253228),
(428584, 'PTHR46162:SF58', NULL, NULL, NULL, NULL, 'TRAF-LIKE FAMILY PROTEIN', 253229),
(428585, 'PTHR46162:SF14', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE-RELATED', 253229),
(428586, 'PTHR46162:SF36', NULL, NULL, NULL, NULL, 'BNAA06G39530D PROTEIN', 253229),
(428587, 'PTHR46162:SF57', NULL, NULL, NULL, NULL, 'MEPRIN AND TRAF HOMOLOGY DOMAIN-CONTAINING PROTEIN / MATH DOMAIN-CONTAINING PROTEIN', 253229);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(428588, 'PTHR46162:SF35', NULL, NULL, NULL, NULL, 'BNAC02G19400D PROTEIN', 253229),
(428589, 'PTHR46162:SF56', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 12-LIKE', 253229),
(428590, 'PTHR46162:SF34', NULL, NULL, NULL, NULL, 'BNAA04G13830D PROTEIN', 253229),
(428591, 'PTHR46162:SF33', NULL, NULL, NULL, NULL, 'BNAC01G32590D PROTEIN', 253229),
(428592, 'PTHR46162:SF55', NULL, NULL, NULL, NULL, 'MATH DOMAIN PROTEIN', 253229),
(428593, 'PTHR46162:SF39', NULL, NULL, NULL, NULL, 'BNAC05G50540D PROTEIN', 253229),
(428594, 'PTHR46162:SF17', NULL, NULL, NULL, NULL, '', 253229),
(428595, 'PTHR46162:SF16', NULL, NULL, NULL, NULL, 'MATH DOMAIN CONTAINING PROTEIN', 253229),
(428596, 'PTHR46162:SF38', NULL, NULL, NULL, NULL, 'BNAC03G28110D PROTEIN', 253229),
(428597, 'PTHR46162:SF15', NULL, NULL, NULL, NULL, 'F9D12.8 PROTEIN-RELATED', 253229),
(428598, 'PTHR46162:SF59', NULL, NULL, NULL, NULL, 'TRAF-LIKE FAMILY PROTEIN ISOFORM 1', 253229),
(428599, 'PTHR46162:SF19', NULL, NULL, NULL, NULL, 'TRAF-LIKE FAMILY PROTEIN', 253229),
(428600, 'PTHR46162:SF50', NULL, NULL, NULL, NULL, 'BNAC03G41570D PROTEIN', 253229),
(428601, 'PTHR46162:SF54', NULL, NULL, NULL, NULL, 'MATH DOMAIN CONTAINING PROTEIN', 253229),
(428602, 'PTHR46162:SF32', NULL, NULL, NULL, NULL, '', 253229),
(428603, 'PTHR46162:SF53', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 253229),
(428604, 'PTHR46162:SF31', NULL, NULL, NULL, NULL, 'BNAC03G41590D PROTEIN', 253229),
(428605, 'PTHR46162:SF52', NULL, NULL, NULL, NULL, 'SMALL GTPASE SUPERFAMILY-RELATED', 253229),
(428606, 'PTHR46162:SF30', NULL, NULL, NULL, NULL, 'BNAA09G04280D PROTEIN', 253229),
(428607, 'PTHR46162:SF51', NULL, NULL, NULL, NULL, 'TRAF-LIKE FAMILY PROTEIN', 253229),
(428608, 'PTHR46162:SF47', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 253229),
(428609, 'PTHR46162:SF46', NULL, NULL, NULL, NULL, 'BNAA05G18690D PROTEIN', 253229),
(428610, 'PTHR46162:SF24', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 253229),
(428611, 'PTHR46162:SF23', NULL, NULL, NULL, NULL, 'BNAA09G00010D PROTEIN', 253229),
(428612, 'PTHR46162:SF45', NULL, NULL, NULL, NULL, 'BNACNNG33640D PROTEIN', 253229),
(428613, 'PTHR46162:SF22', NULL, NULL, NULL, NULL, 'TRAF-LIKE FAMILY PROTEIN', 253229),
(428614, 'PTHR46162:SF44', NULL, NULL, NULL, NULL, 'BNAC05G30530D PROTEIN', 253229),
(428615, 'PTHR46162:SF28', NULL, NULL, NULL, NULL, 'BNAA09G56140D PROTEIN', 253229),
(428616, 'PTHR46162:SF26', NULL, NULL, NULL, NULL, 'BNAA07G24190D PROTEIN', 253229),
(428617, 'PTHR46162:SF9', NULL, NULL, NULL, NULL, 'INACTIVE SERINE/THREONINE-PROTEIN KINASE FNKC-RELATED', 253229),
(428618, 'PTHR46162:SF48', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 253229),
(428619, 'PTHR46162:SF7', NULL, NULL, NULL, NULL, 'MATH DOMAIN CONTAINING PROTEIN', 253229),
(428620, 'PTHR46162:SF5', NULL, NULL, NULL, NULL, 'T23K8.6-RELATED', 253229),
(428621, 'PTHR46162:SF2', NULL, NULL, NULL, NULL, 'TRAF-LIKE FAMILY PROTEIN', 253229),
(428622, 'PTHR46162', NULL, NULL, NULL, NULL, 'TRAF-LIKE FAMILY PROTEIN', 253229),
(428623, 'PTHR46162:SF60', NULL, NULL, NULL, NULL, 'MATH DOMAIN-CONTAINING PROTEIN', 253229),
(428624, 'PTHR46162:SF43', NULL, NULL, NULL, NULL, 'BNAC01G32580D PROTEIN', 253229),
(428625, 'PTHR46162:SF21', NULL, NULL, NULL, NULL, 'BNAA09G04300D PROTEIN', 253229),
(428626, 'PTHR46162:SF20', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 7-LIKE ISOFORM X1', 253229),
(428627, 'PTHR46162:SF41', NULL, NULL, NULL, NULL, 'BNAA01G24880D PROTEIN', 253229),
(428628, 'PTHR46162:SF40', NULL, NULL, NULL, NULL, 'TRAF-LIKE FAMILY PROTEIN', 253229),
(428629, 'PTHR33938:SF15', NULL, NULL, NULL, NULL, 'FERULOYL ESTERASE B-RELATED', 253230),
(428630, 'PTHR33938:SF16', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 253230),
(428631, 'PTHR33938:SF8', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 253230),
(428632, 'PTHR33938:SF7', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 253230),
(428633, 'PTHR33938:SF2', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 253230);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(428634, 'PTHR33938', NULL, NULL, NULL, NULL, 'FERULOYL ESTERASE B-RELATED', 253230),
(428635, 'PTHR33938:SF13', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 253230),
(428636, 'PTHR36509', NULL, NULL, NULL, NULL, 'BLL3101 PROTEIN', 253231),
(428637, 'PTHR36509:SF2', NULL, NULL, NULL, NULL, 'BLL3101 PROTEIN', 253231),
(428638, 'PTHR36509:SF3', NULL, NULL, NULL, NULL, 'LMO1241 PROTEIN', 253231),
(428639, 'PTHR23086:SF35', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 5-PHOSPHATE 4-KINASE TYPE-2 GAMMA', 253232),
(428640, 'PTHR23086:SF114', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 5-KINASE 3', 253232),
(428641, 'PTHR23086:SF115', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 5-KINASE', 253232),
(428642, 'PTHR23086:SF112', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 5-KINASE', 253232),
(428643, 'PTHR23086:SF113', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 5-KINASE 6', 253232),
(428644, 'PTHR23086:SF111', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 5-KINASE 10', 253232),
(428645, 'PTHR23086:SF30', NULL, NULL, NULL, NULL, 'PIPK DOMAIN-CONTAINING PROTEIN', 253232),
(428646, 'PTHR23086:SF118', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL-4-PHOSPHATE 5-KINASE', 253232),
(428647, 'PTHR23086:SF34', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 5-KINASE TYPE-1 BETA', 253232),
(428648, 'PTHR23086:SF116', NULL, NULL, NULL, NULL, 'PIP5K1A AND PSMD4-LIKE PROTEIN-RELATED', 253232),
(428649, 'PTHR23086:SF46', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 5-KINASE-LIKE PROTEIN 1', 253232),
(428650, 'PTHR23086:SF103', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 5-KINASE', 253232),
(428651, 'PTHR23086:SF104', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 5-KINASE 7', 253232),
(428652, 'PTHR23086:SF101', NULL, NULL, NULL, NULL, 'LP03320P-RELATED', 253232),
(428653, 'PTHR23086:SF145', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 5-KINASE', 253232),
(428654, 'PTHR23086:SF144', NULL, NULL, NULL, NULL, '5-KINASE, PUTATIVE-RELATED', 253232),
(428655, 'PTHR23086', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-4-PHOSPHATE 5-KINASE', 253232),
(428656, 'PTHR23086:SF143', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 5-KINASE', 253232),
(428657, 'PTHR23086:SF142', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL PHOSPHATE KINASE DDB_G0267588-RELATED', 253232),
(428658, 'PTHR23086:SF141', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-4-PHOSPHATE 5-KINASE, TYPE I, GAMMA B', 253232),
(428659, 'PTHR23086:SF109', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 5-KINASE 11-RELATED', 253232),
(428660, 'PTHR23086:SF107', NULL, NULL, NULL, NULL, 'PIPK DOMAIN-CONTAINING PROTEIN', 253232),
(428661, 'PTHR23086:SF89', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL-4-PHOSPHATE 5-KINASE', 253232),
(428662, 'PTHR23086:SF108', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 5-KINASE', 253232),
(428663, 'PTHR23086:SF105', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-4-PHOSPHATE 5-KINASE, TYPE I, BETA', 253232),
(428664, 'PTHR23086:SF57', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL-4-PHOSPHATE 5-KINASE', 253232),
(428665, 'PTHR23086:SF140', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 5-KINASE 2', 253232),
(428666, 'PTHR23086:SF136', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL-4-PHOSPHATE 5-KINASE', 253232),
(428667, 'PTHR23086:SF134', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 5-KINASE', 253232),
(428668, 'PTHR23086:SF8', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 5-PHOSPHATE 4-KINASE, ISOFORM A', 253232),
(428669, 'PTHR23086:SF131', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 5-KINASE', 253232),
(428670, 'PTHR23086:SF90', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 5-KINASE', 253232),
(428671, 'PTHR23086:SF95', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 5-KINASE', 253232),
(428672, 'PTHR23086:SF94', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 5-KINASE 5', 253232),
(428673, 'PTHR23086:SF138', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL-4-PHOSPHATE 5-KINASE', 253232);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(428674, 'PTHR23086:SF139', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 5-KINASE', 253232),
(428675, 'PTHR23086:SF98', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 5-KINASE 1', 253232),
(428676, 'PTHR23086:SF54', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 5-KINASE TYPE-1 ALPHA', 253232),
(428677, 'PTHR23086:SF26', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 5-KINASE TYPE-1 GAMMA', 253232),
(428678, 'PTHR23086:SF27', NULL, NULL, NULL, NULL, 'PIPK DOMAIN-CONTAINING PROTEIN', 253232),
(428679, 'PTHR23086:SF25', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 5-KINASE 8', 253232),
(428680, 'PTHR23086:SF29', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 5-KINASE 4', 253232),
(428681, 'PTHR23086:SF126', NULL, NULL, NULL, NULL, 'PIPK DOMAIN-CONTAINING PROTEIN', 253232),
(428682, 'PTHR23086:SF123', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 5-KINASE', 253232),
(428683, 'PTHR23086:SF124', NULL, NULL, NULL, NULL, 'RPKA', 253232),
(428684, 'PTHR23086:SF121', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 5-KINASE', 253232),
(428685, 'PTHR23086:SF63', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-4-PHOSPHATE 5-KINASE FAMILY PROTEIN', 253232),
(428686, 'PTHR23086:SF22', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 5-PHOSPHATE 4-KINASE TYPE-2 BETA', 253232),
(428687, 'PTHR23086:SF129', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 5-KINASE', 253232),
(428688, 'PTHR23086:SF127', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-PHOSPHATE 5-KINASE', 253232),
(428689, 'PTHR23086:SF65', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-4-PHOSPHATE 5-KINASE FAMILY PROTEIN', 253232),
(428690, 'PTHR23086:SF21', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 5-PHOSPHATE 4-KINASE TYPE-2 ALPHA', 253232),
(428691, 'PTHR45808:SF9', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN GACX', 253233),
(428692, 'PTHR45808:SF12', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN GACZ', 253233),
(428693, 'PTHR45808:SF6', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 1', 253233),
(428694, 'PTHR45808:SF20', NULL, NULL, NULL, NULL, 'CRAL-TRIO LIPID BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 253233),
(428695, 'PTHR45808:SF4', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 8', 253233),
(428696, 'PTHR45808:SF3', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN GACL', 253233),
(428697, 'PTHR45808', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 68F', 253233),
(428698, 'PTHR45808:SF2', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 68F', 253233),
(428699, 'PTHR45808:SF19', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 253233),
(428700, 'PTHR45808:SF18', NULL, NULL, NULL, NULL, 'RHO-GAP DOMAIN-CONTAINING PROTEIN', 253233),
(428701, 'PTHR45808:SF17', NULL, NULL, NULL, NULL, '', 253233),
(428702, 'PTHR45808:SF16', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN GACR', 253233),
(428703, 'PTHR15594', NULL, NULL, NULL, NULL, 'PODOCALYXIN-LIKE PROTEIN 2', 253234),
(428704, 'PTHR15594:SF1', NULL, NULL, NULL, NULL, 'PODOCALYXIN-LIKE PROTEIN 2', 253234),
(428705, 'PTHR13357:SF1', NULL, NULL, NULL, NULL, 'NCK-INTERACTING PROTEIN WITH SH3 DOMAIN', 253235),
(428706, 'PTHR13357', NULL, NULL, NULL, NULL, 'SH3 ADAPTER PROTEIN SPIN90  NCK INTERACTING PROTEIN WITH SH3 DOMAIN', 253235),
(428707, 'PTHR30545', NULL, NULL, NULL, NULL, 'SUGAR FERMENTATION STIMULATION PROTEIN A', 253236),
(428708, 'PTHR30545:SF2', NULL, NULL, NULL, NULL, 'SUGAR FERMENTATION STIMULATION PROTEIN A', 253236),
(428709, 'PTHR10775:SF178', NULL, NULL, NULL, NULL, 'DUF4216 DOMAIN-CONTAINING PROTEIN', 253237),
(428710, 'PTHR10775:SF166', NULL, NULL, NULL, NULL, 'OS04G0146034 PROTEIN', 253237),
(428711, 'PTHR10775:SF177', NULL, NULL, NULL, NULL, 'TRANSPOS_ASSOC DOMAIN-CONTAINING PROTEIN', 253237),
(428712, 'PTHR10775:SF169', NULL, NULL, NULL, NULL, 'TRANSPOSON, EN/SPM-LIKE PROTEIN-RELATED', 253237),
(428713, 'PTHR10775:SF158', NULL, NULL, NULL, NULL, 'TNP2-LIKE TRANSPOSON PROTEIN', 253237),
(428714, 'PTHR10775:SF174', NULL, NULL, NULL, NULL, 'TRANSPOS_ASSOC DOMAIN-CONTAINING PROTEIN', 253237);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(428715, 'PTHR10775:SF173', NULL, NULL, NULL, NULL, 'TRANSPOSON, EN/SPM-LIKE, TRANSPOSASE-ASSOCIATED DOMAIN PROTEIN-RELATED', 253237),
(428716, 'PTHR10775:SF176', NULL, NULL, NULL, NULL, '', 253237),
(428717, 'PTHR10775:SF175', NULL, NULL, NULL, NULL, 'OS08G0208400 PROTEIN', 253237),
(428718, 'PTHR10775:SF170', NULL, NULL, NULL, NULL, 'TRANSPOS_ASSOC DOMAIN-CONTAINING PROTEIN', 253237),
(428719, 'PTHR10775:SF172', NULL, NULL, NULL, NULL, 'DUF4218 DOMAIN-CONTAINING PROTEIN', 253237),
(428720, 'PTHR10775:SF171', NULL, NULL, NULL, NULL, 'TRANSPOS_ASSOC DOMAIN-CONTAINING PROTEIN', 253237),
(428721, 'PTHR10775', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 253237),
(428722, 'PTHR10775:SF159', NULL, NULL, NULL, NULL, 'TNP2', 253237),
(428723, 'PTHR34947:SF5', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 253238),
(428724, 'PTHR34947:SF4', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 253238),
(428725, 'PTHR34947:SF7', NULL, NULL, NULL, NULL, '', 253238),
(428726, 'PTHR34947:SF6', NULL, NULL, NULL, NULL, 'BNAC05G40260D PROTEIN', 253238),
(428727, 'PTHR34947:SF3', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 253238),
(428728, 'PTHR34947', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 253238),
(428729, 'PTHR34947:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 253238),
(428730, 'PTHR12170:SF6', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN TRANSFERASE RMND5B', 253239),
(428731, 'PTHR12170:SF11', NULL, NULL, NULL, NULL, 'PROTEIN RMD5 HOMOLOG', 253239),
(428732, 'PTHR12170:SF8', NULL, NULL, NULL, NULL, '', 253239),
(428733, 'PTHR12170:SF9', NULL, NULL, NULL, NULL, '', 253239),
(428734, 'PTHR12170:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN TRANSFERASE MAEA', 253239),
(428735, 'PTHR12170:SF3', NULL, NULL, NULL, NULL, 'GH10162P', 253239),
(428736, 'PTHR12170', NULL, NULL, NULL, NULL, 'MACROPHAGE ERYTHROBLAST ATTACHER-RELATED', 253239),
(428737, 'PTHR12170:SF5', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN TRANSFERASE RMND5A', 253239),
(428738, 'PTHR17573', NULL, NULL, NULL, NULL, 'UROPLAKIN II', 253240),
(428739, 'PTHR17573:SF0', NULL, NULL, NULL, NULL, 'UROPLAKIN-2', 253240),
(428740, 'PTHR46088:SF1', NULL, NULL, NULL, NULL, 'TUBULIN--TYROSINE LIGASE-LIKE PROTEIN 12', 253241),
(428741, 'PTHR46088', NULL, NULL, NULL, NULL, 'TUBULIN--TYROSINE LIGASE-LIKE PROTEIN 12', 253241),
(428742, 'PTHR47899:SF1', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 171', 253242),
(428743, 'PTHR47899', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 171', 253242),
(428744, 'PTHR10373:SF32', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR 7-LIKE 2', 253243),
(428745, 'PTHR10373:SF33', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR 7', 253243),
(428746, 'PTHR10373:SF11', NULL, NULL, NULL, NULL, 'LYMPHOID ENHANCER-BINDING FACTOR 1', 253243),
(428747, 'PTHR10373:SF25', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR 7-LIKE 1', 253243),
(428748, 'PTHR10373:SF38', NULL, NULL, NULL, NULL, 'PROTEIN PANGOLIN, ISOFORM J', 253243),
(428749, 'PTHR10373', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR 7 FAMILY MEMBER', 253243),
(428750, 'PTHR37948', NULL, NULL, NULL, NULL, 'ZGC:113208', 253244),
(428751, 'PTHR37948:SF1', NULL, NULL, NULL, NULL, 'ZGC:113208', 253244),
(428752, 'PTHR36467:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 207', 253245),
(428753, 'PTHR36467', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 207', 253245),
(428754, 'PTHR21016', NULL, NULL, NULL, NULL, 'BETA-AMYLOID BINDING PROTEIN-RELATED', 253246),
(428755, 'PTHR21016:SF1', NULL, NULL, NULL, NULL, 'TM2 DOMAIN-CONTAINING PROTEIN 1', 253246),
(428756, 'PTHR21016:SF25', NULL, NULL, NULL, NULL, 'TM2 DOMAIN-CONTAINING PROTEIN DDB_G0287015', 253246),
(428757, 'PTHR21016:SF4', NULL, NULL, NULL, NULL, 'TM2 DOMAIN-CONTAINING PROTEIN 2', 253246),
(428758, 'PTHR21016:SF5', NULL, NULL, NULL, NULL, 'TM2 DOMAIN-CONTAINING PROTEIN DDB_G0277895', 253246),
(428759, 'PTHR21016:SF24', NULL, NULL, NULL, NULL, 'TM2 DOMAIN-CONTAINING PROTEIN DDB_G0278163', 253246),
(428760, 'PTHR21016:SF7', NULL, NULL, NULL, NULL, 'TM2 DOMAIN-CONTAINING PROTEIN 3', 253246);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(428761, 'PTHR24160', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 53', 253247),
(428762, 'PTHR24160:SF1', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 53', 253247),
(428763, 'PTHR34339', NULL, NULL, NULL, NULL, 'STIMULATOR OF INTERFERON GENES PROTEIN', 253248),
(428764, 'PTHR34339:SF1', NULL, NULL, NULL, NULL, 'STIMULATOR OF INTERFERON GENES PROTEIN', 253248),
(428765, 'PTHR31625:SF76', NULL, NULL, NULL, NULL, 'OS06G0145600 PROTEIN', 253249),
(428766, 'PTHR31625:SF75', NULL, NULL, NULL, NULL, '', 253249),
(428767, 'PTHR31625:SF53', NULL, NULL, NULL, NULL, 'OS04G0606000 PROTEIN', 253249),
(428768, 'PTHR31625:SF74', NULL, NULL, NULL, NULL, 'BNAA04G14900D PROTEIN', 253249),
(428769, 'PTHR31625:SF52', NULL, NULL, NULL, NULL, 'COUMAROYL-COA:ANTHOCYANIDIN 3-O-GLUCOSIDE-6''''-O-COUMAROYLTRANSFERASE 1-RELATED', 253249),
(428770, 'PTHR31625:SF51', NULL, NULL, NULL, NULL, 'MALONYL-COA:ANTHOCYANIDIN 5-O-GLUCOSIDE-6''''-O-MALONYLTRANSFERASE', 253249),
(428771, 'PTHR31625:SF72', NULL, NULL, NULL, NULL, 'ANTHOCYANIN 5-AROMATIC ACYLTRANSFERASE', 253249),
(428772, 'PTHR31625:SF50', NULL, NULL, NULL, NULL, 'MALONYL-COA:ISOFLAVONE 7-O-GLUCOSIDE MALONYLTRANSFERASE', 253249),
(428773, 'PTHR31625:SF91', NULL, NULL, NULL, NULL, 'MALONYLTRANSFERASE', 253249),
(428774, 'PTHR31625:SF90', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE-LIKE PROTEIN-RELATED', 253249),
(428775, 'PTHR31625', NULL, NULL, NULL, NULL, '', 253249),
(428776, 'PTHR31625:SF29', NULL, NULL, NULL, NULL, 'HXXXD-TYPE ACYL-TRANSFERASE FAMILY PROTEIN', 253249),
(428777, 'PTHR31625:SF28', NULL, NULL, NULL, NULL, '', 253249),
(428778, 'PTHR31625:SF49', NULL, NULL, NULL, NULL, 'OS02G0820400 PROTEIN', 253249),
(428779, 'PTHR31625:SF48', NULL, NULL, NULL, NULL, 'PHENOLIC GLUCOSIDE MALONYLTRANSFERASE 2', 253249),
(428780, 'PTHR31625:SF47', NULL, NULL, NULL, NULL, 'PHENOLIC GLUCOSIDE MALONYLTRANSFERASE 1', 253249),
(428781, 'PTHR31625:SF69', NULL, NULL, NULL, NULL, 'BNAC06G31620D PROTEIN', 253249),
(428782, 'PTHR31625:SF68', NULL, NULL, NULL, NULL, 'BNAA04G11630D PROTEIN', 253249),
(428783, 'PTHR31625:SF46', NULL, NULL, NULL, NULL, 'OS10G0402400 PROTEIN', 253249),
(428784, 'PTHR31625:SF89', NULL, NULL, NULL, NULL, '5-AROMATIC ACYLTRANSFERASE, PUTATIVE-RELATED', 253249),
(428785, 'PTHR31625:SF45', NULL, NULL, NULL, NULL, 'ANTHOCYANIN ACYLTRANSFERASE-LIKE PROTEIN', 253249),
(428786, 'PTHR31625:SF67', NULL, NULL, NULL, NULL, 'HXXXD-TYPE ACYL-TRANSFERASE FAMILY PROTEIN-RELATED', 253249),
(428787, 'PTHR31625:SF66', NULL, NULL, NULL, NULL, 'BNAC02G38050D PROTEIN', 253249),
(428788, 'PTHR31625:SF88', NULL, NULL, NULL, NULL, 'TRANSFERASE, CHLORAMPHENICOL ACETYLTRANSFERASE-LIKE DOMAIN PROTEIN-RELATED', 253249),
(428789, 'PTHR31625:SF87', NULL, NULL, NULL, NULL, 'TRANSFERASE, CHLORAMPHENICOL ACETYLTRANSFERASE-LIKE DOMAIN PROTEIN-RELATED', 253249),
(428790, 'PTHR31625:SF9', NULL, NULL, NULL, NULL, 'OS08G0174100 PROTEIN', 253249),
(428791, 'PTHR31625:SF8', NULL, NULL, NULL, NULL, 'OS04G0638100 PROTEIN', 253249),
(428792, 'PTHR31625:SF86', NULL, NULL, NULL, NULL, 'TRANSFERASE', 253249),
(428793, 'PTHR31625:SF64', NULL, NULL, NULL, NULL, 'BNAA02G29930D PROTEIN', 253249),
(428794, 'PTHR31625:SF42', NULL, NULL, NULL, NULL, '', 253249),
(428795, 'PTHR31625:SF85', NULL, NULL, NULL, NULL, 'PHENOLIC GLUCOSIDE MALONYLTRANSFERASE 1', 253249),
(428796, 'PTHR31625:SF63', NULL, NULL, NULL, NULL, 'TRANSFERASE, CHLORAMPHENICOL ACETYLTRANSFERASE-LIKE DOMAIN PROTEIN-RELATED', 253249),
(428797, 'PTHR31625:SF40', NULL, NULL, NULL, NULL, 'OS06G0145200 PROTEIN', 253249),
(428798, 'PTHR31625:SF84', NULL, NULL, NULL, NULL, 'PHENOLIC GLUCOSIDE MALONYLTRANSFERASE 1', 253249),
(428799, 'PTHR31625:SF62', NULL, NULL, NULL, NULL, 'BNAC06G12660D PROTEIN', 253249),
(428800, 'PTHR31625:SF60', NULL, NULL, NULL, NULL, 'BNAA08G05420D PROTEIN', 253249),
(428801, 'PTHR31625:SF80', NULL, NULL, NULL, NULL, 'COUMAROYL-COA:ANTHOCYANIDIN 3-O-GLUCOSIDE-6''''-O-COUMAROYLTRANSFERASE 1-LIKE', 253249),
(428802, 'PTHR31625:SF7', NULL, NULL, NULL, NULL, 'OS02G0483800 PROTEIN', 253249);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(428803, 'PTHR31625:SF39', NULL, NULL, NULL, NULL, 'OS08G0174300 PROTEIN', 253249),
(428804, 'PTHR31625:SF38', NULL, NULL, NULL, NULL, 'MALONYL-COA:ANTHOCYANIDIN 5-O-GLUCOSIDE-6''''-O-MALONYLTRANSFERASE-LIKE', 253249),
(428805, 'PTHR31625:SF59', NULL, NULL, NULL, NULL, 'BNAA02G29920D PROTEIN', 253249),
(428806, 'PTHR31625:SF36', NULL, NULL, NULL, NULL, 'AGMATINE COUMAROYLTRANSFERASE-RELATED', 253249),
(428807, 'PTHR31625:SF58', NULL, NULL, NULL, NULL, '5-AROMATIC ACYLTRANSFERASE, PUTATIVE-RELATED', 253249),
(428808, 'PTHR31625:SF57', NULL, NULL, NULL, NULL, 'MALONYL-COENZYME A:ANTHOCYANIN 3-O-GLUCOSIDE-6''''-O-MALONYLTRANSFERASE-RELATED', 253249),
(428809, 'PTHR31625:SF79', NULL, NULL, NULL, NULL, '', 253249),
(428810, 'PTHR31625:SF55', NULL, NULL, NULL, NULL, 'PHENOLIC GLUCOSIDE MALONYLTRANSFERASE 1-LIKE', 253249),
(428811, 'PTHR31625:SF33', NULL, NULL, NULL, NULL, 'COUMAROYL-COA:ANTHOCYANIDIN 3-O-GLUCOSIDE-6''''-O-COUMAROYLTRANSFERASE 1-LIKE', 253249),
(428812, 'PTHR23158:SF57', NULL, NULL, NULL, NULL, 'CTAGE FAMILY MEMBER 15-RELATED', 253250),
(428813, 'PTHR23158:SF58', NULL, NULL, NULL, NULL, '', 253250),
(428814, 'PTHR23158:SF55', NULL, NULL, NULL, NULL, '', 253250),
(428815, 'PTHR23158:SF33', NULL, NULL, NULL, NULL, 'TRANSPORT AND GOLGI ORGANIZATION PROTEIN 1', 253250),
(428816, 'PTHR23158:SF59', NULL, NULL, NULL, NULL, '', 253250),
(428817, 'PTHR23158:SF38', NULL, NULL, NULL, NULL, 'MELANOMA INHIBITORY ACTIVITY PROTEIN 2', 253250),
(428818, 'PTHR23158:SF53', NULL, NULL, NULL, NULL, '', 253250),
(428819, 'PTHR23158:SF54', NULL, NULL, NULL, NULL, 'TRANSPORT AND GOLGI ORGANIZATION PROTEIN 1 HOMOLOG', 253250),
(428820, 'PTHR23158', NULL, NULL, NULL, NULL, 'MELANOMA INHIBITORY ACTIVITY-RELATED', 253250),
(428821, 'PTHR23158:SF52', NULL, NULL, NULL, NULL, 'CTAGE FAMILY MEMBER 2', 253250),
(428822, 'PTHR34383', NULL, NULL, NULL, NULL, 'POLYPHOSPHATE:AMP PHOSPHOTRANSFERASE-RELATED', 253251),
(428823, 'PTHR34383:SF1', NULL, NULL, NULL, NULL, 'POLYPHOSPHATE:ADP/GDP PHOSPHOTRANSFERASE', 253251),
(428824, 'PTHR34383:SF3', NULL, NULL, NULL, NULL, 'POLYPHOSPHATE:AMP PHOSPHOTRANSFERASE', 253251),
(428825, 'PTHR12424:SF8', NULL, NULL, NULL, NULL, 'PROTEIN TWEETY', 253252),
(428826, 'PTHR12424:SF17', NULL, NULL, NULL, NULL, 'PROTEIN TWEETY HOMOLOG 2-LIKE', 253252),
(428827, 'PTHR12424:SF18', NULL, NULL, NULL, NULL, 'PROTEIN TWEETY-2', 253252),
(428828, 'PTHR12424:SF6', NULL, NULL, NULL, NULL, 'PROTEIN TWEETY HOMOLOG 2', 253252),
(428829, 'PTHR12424:SF5', NULL, NULL, NULL, NULL, 'PROTEIN TWEETY HOMOLOG 1', 253252),
(428830, 'PTHR12424:SF4', NULL, NULL, NULL, NULL, 'PROTEIN TWEETY HOMOLOG 3', 253252),
(428831, 'PTHR12424', NULL, NULL, NULL, NULL, 'TWEETY-RELATED', 253252),
(428832, 'PTHR28086', NULL, NULL, NULL, NULL, 'UPF0662 PROTEIN YPL260W', 253253),
(428833, 'PTHR28086:SF1', NULL, NULL, NULL, NULL, 'CU(2+) SUPPRESSING AND BLEOMYCIN SENSITIVE PROTEIN 1', 253253),
(428834, 'PTHR42091:SF1', NULL, NULL, NULL, NULL, 'CONSERVED GLYCINE-RICH PROTEIN (AFU_ORTHOLOGUE AFUA_7G02440)', 253254),
(428835, 'PTHR42091', NULL, NULL, NULL, NULL, 'CONSERVED GLYCINE-RICH PROTEIN (AFU_ORTHOLOGUE AFUA_7G02440)', 253254),
(428836, 'PTHR15143', NULL, NULL, NULL, NULL, 'TELETHONIN', 253255),
(428837, 'PTHR15143:SF1', NULL, NULL, NULL, NULL, 'TELETHONIN-LIKE', 253255),
(428838, 'PTHR15143:SF0', NULL, NULL, NULL, NULL, 'TELETHONIN', 253255),
(428839, 'PTHR36214:SF3', NULL, NULL, NULL, NULL, 'ACETYL-COA DECARBONYLASE/SYNTHASE COMPLEX SUBUNIT GAMMA', 253256),
(428840, 'PTHR36214', NULL, NULL, NULL, NULL, '', 253256),
(428841, 'PTHR36214:SF5', NULL, NULL, NULL, NULL, 'ACETYL-COA DECARBONYLASE/SYNTHASE COMPLEX SUBUNIT DELTA', 253256),
(428842, 'PTHR39410', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4930558K02 GENE', 253257),
(428843, 'PTHR39410:SF1', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4930558K02 GENE', 253257),
(428844, 'PTHR35261:SF1', NULL, NULL, NULL, NULL, '', 253258),
(428845, 'PTHR35261:SF2', NULL, NULL, NULL, NULL, 'ARRESTIN_C DOMAIN-CONTAINING PROTEIN', 253258),
(428846, 'PTHR35261:SF3', NULL, NULL, NULL, NULL, 'VACUOLAR IMPORT AND DEGRADATION PROTEIN 22', 253258);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(428847, 'PTHR35261', NULL, NULL, NULL, NULL, 'ORGANELLAR PROTEIN, PUTATIVE-RELATED-RELATED', 253258),
(428848, 'PTHR13604:SF0', NULL, NULL, NULL, NULL, 'ABASIC SITE PROCESSING PROTEIN HMCES', 253259),
(428849, 'PTHR13604', NULL, NULL, NULL, NULL, 'DC12-RELATED', 253259),
(428850, 'PTHR47480:SF1', NULL, NULL, NULL, NULL, 'EXPANSIN-LIKE EG45 DOMAIN-CONTAINING PROTEIN', 253260),
(428851, 'PTHR47480', NULL, NULL, NULL, NULL, 'EG45-LIKE DOMAIN CONTAINING PROTEIN', 253260),
(428852, 'PTHR47480:SF9', NULL, NULL, NULL, NULL, 'EG45-LIKE DOMAIN CONTAINING PROTEIN ISOFORM X1', 253260),
(428853, 'PTHR47480:SF8', NULL, NULL, NULL, NULL, 'RLPA-LIKE DOUBLE-PSI BETA-BARREL DOMAIN-CONTAINING PROTEIN-RELATED', 253260),
(428854, 'PTHR47480:SF13', NULL, NULL, NULL, NULL, 'EXPANSIN-LIKE EG45 DOMAIN-CONTAINING PROTEIN', 253260),
(428855, 'PTHR47480:SF7', NULL, NULL, NULL, NULL, 'EG45-LIKE DOMAIN CONTAINING PROTEIN', 253260),
(428856, 'PTHR47480:SF6', NULL, NULL, NULL, NULL, 'EXPANSIN-LIKE EG45 DOMAIN-CONTAINING PROTEIN', 253260),
(428857, 'PTHR47480:SF5', NULL, NULL, NULL, NULL, 'EG45-LIKE DOMAIN CONTAINING PROTEIN', 253260),
(428858, 'PTHR47480:SF12', NULL, NULL, NULL, NULL, 'RARE LIPOPROTEIN A-LIKE DOUBLE-PSI BETA-BARREL PROTEIN', 253260),
(428859, 'PTHR47480:SF2', NULL, NULL, NULL, NULL, 'EXPANSIN-LIKE EG45 DOMAIN-CONTAINING PROTEIN', 253260),
(428860, 'PTHR47858', NULL, NULL, NULL, NULL, 'HALOACID DEHALOGENASE-LIKE HYDROLASE (HAD) SUPERFAMILY PROTEIN', 253261),
(428861, 'PTHR47858:SF2', NULL, NULL, NULL, NULL, 'HALOACID DEHALOGENASE-LIKE HYDROLASE (HAD) SUPERFAMILY PROTEIN', 253261),
(428862, 'PTHR47858:SF3', NULL, NULL, NULL, NULL, '5-AMINO-6-(5-PHOSPHO-D-RIBITYLAMINO)URACIL PHOSPHATASE, CHLOROPLASTIC', 253261),
(428863, 'PTHR46109:SF4', NULL, NULL, NULL, NULL, '', 253262),
(428864, 'PTHR46109', NULL, NULL, NULL, NULL, 'PROTEIN LIN-28', 253262),
(428865, 'PTHR46109:SF3', NULL, NULL, NULL, NULL, 'PROTEIN LIN-28 HOMOLOG B', 253262),
(428866, 'PTHR46109:SF2', NULL, NULL, NULL, NULL, 'PROTEIN LIN-28 HOMOLOG A', 253262),
(428867, 'PTHR46109:SF1', NULL, NULL, NULL, NULL, 'PROTEIN LIN-28 HOMOLOG', 253262),
(428868, 'PTHR10869:SF191', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 253263),
(428869, 'PTHR10869:SF194', NULL, NULL, NULL, NULL, 'PROLYL 4-HYDROXYLASE 4-RELATED', 253263),
(428870, 'PTHR10869:SF193', NULL, NULL, NULL, NULL, 'PROLYL 4-HYDROXYLASE 5', 253263),
(428871, 'PTHR10869:SF196', NULL, NULL, NULL, NULL, 'PROLYL 4-HYDROXYLASE 10-RELATED', 253263),
(428872, 'PTHR10869:SF195', NULL, NULL, NULL, NULL, 'PROLYL 4-HYDROXYLASE 9-RELATED', 253263),
(428873, 'PTHR10869:SF42', NULL, NULL, NULL, NULL, 'PROLYL 4-HYDROXYLASE 1', 253263),
(428874, 'PTHR10869:SF62', NULL, NULL, NULL, NULL, 'PROCOLLAGEN-PROLINE 4-DIOXYGENASE', 253263),
(428875, 'PTHR10869:SF217', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 253263),
(428876, 'PTHR10869:SF216', NULL, NULL, NULL, NULL, 'PROCOLLAGEN-PROLINE 4-DIOXYGENASE', 253263),
(428877, 'PTHR10869', NULL, NULL, NULL, NULL, 'PROLYL 4-HYDROXYLASE ALPHA SUBUNIT', 253263),
(428878, 'PTHR10869:SF219', NULL, NULL, NULL, NULL, 'OS03G0166100 PROTEIN', 253263),
(428879, 'PTHR10869:SF218', NULL, NULL, NULL, NULL, 'PROCOLLAGEN-PROLINE 4-DIOXYGENASE', 253263),
(428880, 'PTHR10869:SF231', NULL, NULL, NULL, NULL, 'PROLYL 4-HYDROXYLASE ALPHA-LIKE PROTEIN', 253263),
(428881, 'PTHR10869:SF230', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROLYL 4-HYDROXYLASE', 253263),
(428882, 'PTHR10869:SF156', NULL, NULL, NULL, NULL, 'PROLYL 4-HYDROXYLASE SUBUNIT ALPHA-2', 253263),
(428883, 'PTHR10869:SF211', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253263),
(428884, 'PTHR10869:SF232', NULL, NULL, NULL, NULL, 'PROLYL 4-HYDROXYLASE SUBUNIT ALPHA-LIKE PROTEIN', 253263),
(428885, 'PTHR10869:SF210', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 253263),
(428886, 'PTHR10869:SF213', NULL, NULL, NULL, NULL, 'PROLYL 4-HYDROXYLASE 3-RELATED', 253263),
(428887, 'PTHR10869:SF212', NULL, NULL, NULL, NULL, 'OXOGLUTARATE/IRON-DEPENDENT DIOXYGENASE-RELATED', 253263);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(428888, 'PTHR10869:SF179', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 253263),
(428889, 'PTHR10869:SF215', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 253263),
(428890, 'PTHR10869:SF159', NULL, NULL, NULL, NULL, 'PROLYL 4-HYDROXYLASE 13', 253263),
(428891, 'PTHR10869:SF214', NULL, NULL, NULL, NULL, 'PROCOLLAGEN-PROLINE 4-DIOXYGENASE', 253263),
(428892, 'PTHR10869:SF181', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 253263),
(428893, 'PTHR10869:SF180', NULL, NULL, NULL, NULL, 'P4HC DOMAIN-CONTAINING PROTEIN', 253263),
(428894, 'PTHR10869:SF160', NULL, NULL, NULL, NULL, 'PROLYL 4-HYDROXYLASE 11-RELATED', 253263),
(428895, 'PTHR10869:SF228', NULL, NULL, NULL, NULL, 'PROCOLLAGEN-PROLINE 4-DIOXYGENASE', 253263),
(428896, 'PTHR10869:SF205', NULL, NULL, NULL, NULL, 'PROLYL 4-HYDROXYLASE 9-RELATED', 253263),
(428897, 'PTHR10869:SF227', NULL, NULL, NULL, NULL, 'P4HC DOMAIN-CONTAINING PROTEIN', 253263),
(428898, 'PTHR10869:SF207', NULL, NULL, NULL, NULL, 'PROLYL 4-HYDROXYLASE SUBUNIT ALPHA-2', 253263),
(428899, 'PTHR10869:SF229', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 253263),
(428900, 'PTHR10869:SF165', NULL, NULL, NULL, NULL, 'PROLYL 4-HYDROXYLASE 2', 253263),
(428901, 'PTHR10869:SF220', NULL, NULL, NULL, NULL, 'PROLYL 4-HYDROXYLASE 4 ISOFORM X1-RELATED', 253263),
(428902, 'PTHR10869:SF186', NULL, NULL, NULL, NULL, 'PROCOLLAGEN-PROLINE 4-DIOXYGENASE', 253263),
(428903, 'PTHR10869:SF123', NULL, NULL, NULL, NULL, 'PROLYL 4-HYDROXYLASE 10-RELATED', 253263),
(428904, 'PTHR10869:SF222', NULL, NULL, NULL, NULL, 'PROCOLLAGEN-PROLINE 4-DIOXYGENASE', 253263),
(428905, 'PTHR10869:SF101', NULL, NULL, NULL, NULL, 'PROLYL 4-HYDROXYLASE SUBUNIT ALPHA-1', 253263),
(428906, 'PTHR10869:SF221', NULL, NULL, NULL, NULL, 'PROCOLLAGEN-PROLINE 4-DIOXYGENASE', 253263),
(428907, 'PTHR10869:SF169', NULL, NULL, NULL, NULL, 'PROLYL 4-HYDROXYLASE 3-RELATED', 253263),
(428908, 'PTHR10869:SF224', NULL, NULL, NULL, NULL, 'OXOGLUTARATE/IRON-DEPENDENT DIOXYGENASE-RELATED', 253263),
(428909, 'PTHR10869:SF102', NULL, NULL, NULL, NULL, 'PROLYL 4-HYDROXYLASE 12-RELATED', 253263),
(428910, 'PTHR10869:SF223', NULL, NULL, NULL, NULL, 'PROLYL 4-HYDROXYLASE SUBUNIT ALPHA-3', 253263),
(428911, 'PTHR10869:SF226', NULL, NULL, NULL, NULL, 'P4HC DOMAIN-CONTAINING PROTEIN', 253263),
(428912, 'PTHR10869:SF204', NULL, NULL, NULL, NULL, '4-HYDROXYLASE ALPHA SUBUNIT, PUTATIVE-RELATED', 253263),
(428913, 'PTHR10869:SF225', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 253263),
(428914, 'PTHR10869:SF203', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 253263),
(428915, 'PTHR10869:SF148', NULL, NULL, NULL, NULL, 'PROCOLLAGEN-PROLINE 4-DIOXYGENASE', 253263),
(428916, 'PTHR43750:SF4', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 6-DEHYDROGENASE YWQF', 253264),
(428917, 'PTHR43750:SF2', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 6-DEHYDROGENASE', 253264),
(428918, 'PTHR43750:SF3', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 6-DEHYDROGENASE TUAD', 253264),
(428919, 'PTHR43750:SF1', NULL, NULL, NULL, NULL, 'GDP-MANNOSE 6-DEHYDROGENASE', 253264),
(428920, 'PTHR43750', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 6-DEHYDROGENASE TUAD', 253264),
(428921, 'PTHR47576', NULL, NULL, NULL, NULL, 'BRCT DOMAIN DNA REPAIR PROTEIN-RELATED', 253265),
(428922, 'PTHR47576:SF3', NULL, NULL, NULL, NULL, 'BRCT DOMAIN-CONTAINING PROTEIN-RELATED', 253265),
(428923, 'PTHR47576:SF2', NULL, NULL, NULL, NULL, 'BRCT DOMAIN DNA REPAIR PROTEIN-RELATED', 253265),
(428924, 'PTHR46552:SF1', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE CHAIN 2', 253266),
(428925, 'PTHR46552', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE CHAIN 2', 253266),
(428926, 'PTHR23249:SF16', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT 1', 253267),
(428927, 'PTHR23249:SF17', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT', 253267),
(428928, 'PTHR23249:SF15', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT 4', 253267); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(428929, 'PTHR23249', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT', 253267),
(428930, 'PTHR23249:SF19', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT', 253267),
(428931, 'PTHR23249:SF20', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT', 253267),
(428932, 'PTHR39199', NULL, NULL, NULL, NULL, 'BLR5128 PROTEIN', 253268),
(428933, 'PTHR39199:SF1', NULL, NULL, NULL, NULL, 'BLR5128 PROTEIN', 253268),
(428934, 'PTHR38594', NULL, NULL, NULL, NULL, 'PEP-DEPENDENT DIHYDROXYACETONE KINASE, PHOSPHORYL DONOR SUBUNIT DHAM', 253269),
(428935, 'PTHR38594:SF1', NULL, NULL, NULL, NULL, 'PEP-DEPENDENT DIHYDROXYACETONE KINASE, PHOSPHORYL DONOR SUBUNIT DHAM', 253269),
(428936, 'PTHR47330:SF1', NULL, NULL, NULL, NULL, 'POLY(U)-BINDING-SPLICING FACTOR PUF60', 253270),
(428937, 'PTHR47330', NULL, NULL, NULL, NULL, 'POLY(U)-BINDING-SPLICING FACTOR PUF60-B-RELATED', 253270),
(428938, 'PTHR43453:SF3', NULL, NULL, NULL, NULL, 'SPOU_METHYLASE DOMAIN-CONTAINING PROTEIN', 253271),
(428939, 'PTHR43453', NULL, NULL, NULL, NULL, 'RRNA METHYLASE-LIKE', 253271),
(428940, 'PTHR43453:SF1', NULL, NULL, NULL, NULL, 'SPOU_METHYLASE DOMAIN-CONTAINING PROTEIN', 253271),
(428941, 'PTHR43111:SF1', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE B-RELATED', 253272),
(428942, 'PTHR43111', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE B-RELATED', 253272),
(428943, 'PTHR39169:SF1', NULL, NULL, NULL, NULL, 'MONOOXYGENASE YDHR-RELATED', 253273),
(428944, 'PTHR39169', NULL, NULL, NULL, NULL, '', 253273),
(428945, 'PTHR30525:SF0', NULL, NULL, NULL, NULL, '1-DEOXY-D-XYLULOSE 5-PHOSPHATE REDUCTOISOMERASE, CHLOROPLASTIC', 253274),
(428946, 'PTHR30525:SF6', NULL, NULL, NULL, NULL, '1-DEOXY-D-XYLULOSE-5-PHOSPHATE REDUCTOISOMERASE', 253274),
(428947, 'PTHR30525', NULL, NULL, NULL, NULL, '1-DEOXY-D-XYLULOSE 5-PHOSPHATE REDUCTOISOMERASE', 253274),
(428948, 'PTHR30525:SF7', NULL, NULL, NULL, NULL, '1-DEOXY-D-XYLULOSE-5-PHOSPHATE REDUCTOISOMERASE', 253274),
(428949, 'PTHR15688:SF1', NULL, NULL, NULL, NULL, 'KINETOCHORE-ASSOCIATED PROTEIN 1', 253275),
(428950, 'PTHR15688', NULL, NULL, NULL, NULL, 'KINETOCHORE-ASSOCIATED PROTEIN 1', 253275),
(428951, 'PTHR35370', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED-RELATED', 253276),
(428952, 'PTHR35370:SF1', NULL, NULL, NULL, NULL, 'TYPE VI SECRETION SYSTEM COMPONENT TSSF1', 253276),
(428953, 'PTHR35370:SF4', NULL, NULL, NULL, NULL, 'TYPE VI SECRETION SYSTEM PROTEIN TSSF', 253276),
(428954, 'PTHR12096', NULL, NULL, NULL, NULL, 'NUCLEAR PROTEIN SKIP-RELATED', 253277),
(428955, 'PTHR12096:SF4', NULL, NULL, NULL, NULL, 'SKIP_SNW DOMAIN-CONTAINING PROTEIN', 253277),
(428956, 'PTHR12096:SF0', NULL, NULL, NULL, NULL, 'SNW DOMAIN-CONTAINING PROTEIN 1', 253277),
(428957, 'PTHR12096:SF2', NULL, NULL, NULL, NULL, 'SKIP_SNW DOMAIN-CONTAINING PROTEIN', 253277),
(428958, 'PTHR13476:SF2', NULL, NULL, NULL, NULL, 'CHROMATIN MODIFICATION MEAF6-LIKE PROTEIN', 253278),
(428959, 'PTHR13476:SF0', NULL, NULL, NULL, NULL, 'CHROMATIN MODIFICATION-RELATED PROTEIN MEAF6', 253278),
(428960, 'PTHR13476', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 253278),
(428961, 'PTHR46644:SF2', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN XRCC2', 253279),
(428962, 'PTHR46644', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN XRCC2', 253279),
(428963, 'PTHR47633:SF5', NULL, NULL, NULL, NULL, 'OBSCURIN, CYTOSKELETAL CALMODULIN AND TITIN-INTERACTING RHOGEF A', 253280),
(428964, 'PTHR47633:SF4', NULL, NULL, NULL, NULL, 'KETN-1', 253280),
(428965, 'PTHR47633:SF6', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 253280),
(428966, 'PTHR47633:SF1', NULL, NULL, NULL, NULL, 'MYOSIN LIGHT CHAIN KINASE, SMOOTH MUSCLE', 253280),
(428967, 'PTHR47633:SF3', NULL, NULL, NULL, NULL, 'STRIATED MUSCLE PREFERENTIALLY EXPRESSED PROTEIN KINASE', 253280),
(428968, 'PTHR47633', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN', 253280),
(428969, 'PTHR10656:SF38', NULL, NULL, NULL, NULL, 'NUCLEOTIDYLTRANSFERASE MAB21L1-RELATED', 253281),
(428970, 'PTHR10656:SF7', NULL, NULL, NULL, NULL, 'PROTEIN MAB-21-LIKE 4', 253281);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(428971, 'PTHR10656:SF37', NULL, NULL, NULL, NULL, 'PROTEIN MAB-21-LIKE 2', 253281),
(428972, 'PTHR10656:SF48', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 102', 253281),
(428973, 'PTHR10656:SF69', NULL, NULL, NULL, NULL, 'MAB-21 DOMAIN-CONTAINING PROTEIN', 253281),
(428974, 'PTHR10656:SF8', NULL, NULL, NULL, NULL, 'INOSITOL 1,4,5-TRISPHOSPHATE RECEPTOR-INTERACTING PROTEIN', 253281),
(428975, 'PTHR10656:SF47', NULL, NULL, NULL, NULL, 'PROTEIN MB21D2', 253281),
(428976, 'PTHR10656:SF9', NULL, NULL, NULL, NULL, 'INOSITOL 1,4,5-TRISPHOSPHATE RECEPTOR-INTERACTING PROTEIN-LIKE 2', 253281),
(428977, 'PTHR10656:SF35', NULL, NULL, NULL, NULL, 'CYCLIC GMP-AMP SYNTHASE', 253281),
(428978, 'PTHR10656:SF77', NULL, NULL, NULL, NULL, 'MAB-21 DOMAIN-CONTAINING PROTEIN', 253281),
(428979, 'PTHR10656:SF76', NULL, NULL, NULL, NULL, 'MAB-21 DOMAIN-CONTAINING PROTEIN', 253281),
(428980, 'PTHR10656:SF42', NULL, NULL, NULL, NULL, 'IP12463P', 253281),
(428981, 'PTHR10656:SF75', NULL, NULL, NULL, NULL, 'MAB-21 DOMAIN-CONTAINING PROTEIN', 253281),
(428982, 'PTHR10656:SF30', NULL, NULL, NULL, NULL, 'PROTEIN MAB-21-LIKE 3', 253281),
(428983, 'PTHR10656:SF40', NULL, NULL, NULL, NULL, 'INOSITOL 1,4,5-TRISPHOSPHATE RECEPTOR-INTERACTING PROTEIN-LIKE 1', 253281),
(428984, 'PTHR10656:SF70', NULL, NULL, NULL, NULL, 'PROTEIN MAB-21-RELATED', 253281),
(428985, 'PTHR10656', NULL, NULL, NULL, NULL, 'CELL FATE DETERMINING PROTEIN MAB21-RELATED', 253281),
(428986, 'PTHR15859', NULL, NULL, NULL, NULL, 'SETA BINDING PROTEIN 1', 253282),
(428987, 'PTHR15859:SF1', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 253282),
(428988, 'PTHR15859:SF2', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN KCTD3', 253282),
(428989, 'PTHR15859:SF5', NULL, NULL, NULL, NULL, 'SH3KBP1-BINDING PROTEIN 1', 253282),
(428990, 'PTHR35899', NULL, NULL, NULL, NULL, 'PAPAIN FAMILY CYSTEINE PROTEASE DOMAIN CONTAINING PROTEIN', 253283),
(428991, 'PTHR35899:SF1', NULL, NULL, NULL, NULL, 'PEPT_C1 DOMAIN-CONTAINING PROTEIN', 253283),
(428992, 'PTHR43246:SF2', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 253284),
(428993, 'PTHR43246:SF11', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE B', 253284),
(428994, 'PTHR43246:SF9', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 253284),
(428995, 'PTHR43246', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP38, CHLOROPLASTIC', 253284),
(428996, 'PTHR21143', NULL, NULL, NULL, NULL, 'INVERTEBRATE GUSTATORY RECEPTOR', 253285),
(428997, 'PTHR21143:SF131', NULL, NULL, NULL, NULL, 'GUSTATORY AND ODORANT RECEPTOR 63A-RELATED', 253285),
(428998, 'PTHR21143:SF130', NULL, NULL, NULL, NULL, 'GUSTATORY AND PHEROMONE RECEPTOR 32A-RELATED', 253285),
(428999, 'PTHR21143:SF100', NULL, NULL, NULL, NULL, 'GUSTATORY RECEPTOR 47B-RELATED', 253285),
(429000, 'PTHR21143:SF133', NULL, NULL, NULL, NULL, 'GUSTATORY RECEPTOR', 253285),
(429001, 'PTHR21143:SF132', NULL, NULL, NULL, NULL, 'GUSTATORY AND PHEROMONE RECEPTOR 33A', 253285),
(429002, 'PTHR21143:SF121', NULL, NULL, NULL, NULL, 'GUSTATORY AND ODORANT RECEPTOR 21A', 253285),
(429003, 'PTHR21143:SF123', NULL, NULL, NULL, NULL, 'GUSTATORY RECEPTOR FOR SUGAR TASTE 43A-RELATED', 253285),
(429004, 'PTHR21143:SF112', NULL, NULL, NULL, NULL, 'HIGH-ENERGY LIGHT UNRESPONSIVE PROTEIN 1', 253285),
(429005, 'PTHR21143:SF134', NULL, NULL, NULL, NULL, 'GUSTATORY RECEPTOR', 253285),
(429006, 'PTHR21143:SF104', NULL, NULL, NULL, NULL, 'GUSTATORY RECEPTOR-RELATED', 253285),
(429007, 'PTHR21143:SF128', NULL, NULL, NULL, NULL, 'GUSTATORY RECEPTOR FOR BITTER TASTE 66A', 253285),
(429008, 'PTHR21143:SF119', NULL, NULL, NULL, NULL, 'GUSTATORY RECEPTOR 28A-RELATED', 253285),
(429009, 'PTHR21143:SF129', NULL, NULL, NULL, NULL, 'GUSTATORY RECEPTOR', 253285),
(429010, 'PTHR43795', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL ASPARTATE AMINOTRANSFERASE AND GLUTAMATE/ASPARTATE-PREPHENATE AMINOTRANSFERASE-RELATED', 253286),
(429011, 'PTHR43795:SF111', NULL, NULL, NULL, NULL, 'TRYPTOPHAN AMINOTRANSFERASE-RELATED PROTEIN 2', 253286),
(429012, 'PTHR43795:SF112', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE SYNTHASE 3', 253286);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(429013, 'PTHR43795:SF110', NULL, NULL, NULL, NULL, 'ALLIINASE_C DOMAIN-CONTAINING PROTEIN', 253286),
(429014, 'PTHR43795:SF69', NULL, NULL, NULL, NULL, 'PYRIDOXAL PHOSPHATE-DEPENDENT TRANSFERASE-RELATED', 253286),
(429015, 'PTHR43795:SF67', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE SYNTHASE 4', 253286),
(429016, 'PTHR43795:SF113', NULL, NULL, NULL, NULL, 'AMINOTRAN_1_2 DOMAIN-CONTAINING PROTEIN', 253286),
(429017, 'PTHR43795:SF114', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE SYNTHASE 11', 253286),
(429018, 'PTHR43795:SF22', NULL, NULL, NULL, NULL, 'TRYPTOPHAN AMINOTRANSFERASE-RELATED PROTEIN 2', 253286),
(429019, 'PTHR43795:SF66', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE SYNTHASE-LIKE', 253286),
(429020, 'PTHR43795:SF63', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_4G00630)-RELATED', 253286),
(429021, 'PTHR43795:SF20', NULL, NULL, NULL, NULL, 'TRYPTOPHAN AMINOTRANSFERASE-RELATED PROTEIN 4', 253286),
(429022, 'PTHR43795:SF64', NULL, NULL, NULL, NULL, 'GLUTAMATE-OXALOACETATE TRANSAMINASE5', 253286),
(429023, 'PTHR43795:SF8', NULL, NULL, NULL, NULL, 'HTH PSQ-TYPE DOMAIN-CONTAINING PROTEIN', 253286),
(429024, 'PTHR43795:SF1', NULL, NULL, NULL, NULL, 'INACTIVE 1-AMINOCYCLOPROPANE-1-CARBOXYLATE SYNTHASE-LIKE PROTEIN 2-RELATED', 253286),
(429025, 'PTHR43795:SF2', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL ASPARTATE AMINOTRANSFERASE AND GLUTAMATE/ASPARTATE-PREPHENATE AMINOTRANSFERASE', 253286),
(429026, 'PTHR43795:SF17', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE SYNTHASE-LIKE PROTEIN 1', 253286),
(429027, 'PTHR43795:SF15', NULL, NULL, NULL, NULL, 'L-TRYPTOPHAN--PYRUVATE AMINOTRANSFERASE 1', 253286),
(429028, 'PTHR43795:SF56', NULL, NULL, NULL, NULL, 'TRYPTOPHAN AMINOTRANSFERASE-RELATED PROTEIN 4-LIKE', 253286),
(429029, 'PTHR43795:SF12', NULL, NULL, NULL, NULL, 'AROMATIC AMINOTRANSFERASE ISS1', 253286),
(429030, 'PTHR43795:SF6', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE SYNTHASE 6', 253286),
(429031, 'PTHR43795:SF54', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE SYNTHASE 5', 253286),
(429032, 'PTHR43795:SF98', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE SYNTHASE 1-RELATED', 253286),
(429033, 'PTHR43795:SF10', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE SYNTHASE 9', 253286),
(429034, 'PTHR43795:SF55', NULL, NULL, NULL, NULL, 'PYRIDOXAL PHOSPHATE-DEPENDENT TRANSFERASES SUPERFAMILY PROTEIN ISOFORM 1', 253286),
(429035, 'PTHR43795:SF97', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE SYNTHASE-LIKE', 253286),
(429036, 'PTHR43795:SF51', NULL, NULL, NULL, NULL, 'AMINOTRAN_1_2 DOMAIN-CONTAINING PROTEIN', 253286),
(429037, 'PTHR43795:SF95', NULL, NULL, NULL, NULL, 'ALLIINASE_C DOMAIN-CONTAINING PROTEIN', 253286),
(429038, 'PTHR43795:SF92', NULL, NULL, NULL, NULL, 'AMINOTRAN_1_2 DOMAIN-CONTAINING PROTEIN', 253286),
(429039, 'PTHR43795:SF93', NULL, NULL, NULL, NULL, 'AMINOTRAN_1_2 DOMAIN-CONTAINING PROTEIN', 253286),
(429040, 'PTHR43795:SF49', NULL, NULL, NULL, NULL, 'ALLIIN LYASE', 253286),
(429041, 'PTHR43795:SF45', NULL, NULL, NULL, NULL, 'OS05G0196600 PROTEIN', 253286),
(429042, 'PTHR43795:SF89', NULL, NULL, NULL, NULL, 'AMINOTRAN_1_2 DOMAIN-CONTAINING PROTEIN', 253286),
(429043, 'PTHR43795:SF46', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE ACS12-RELATED', 253286),
(429044, 'PTHR43795:SF44', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE SYNTHASE 3-LIKE', 253286),
(429045, 'PTHR43795:SF85', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE ACS10-RELATED', 253286),
(429046, 'PTHR43795:SF41', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE SYNTHASE', 253286),
(429047, 'PTHR43795:SF42', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE SYNTHASE 4', 253286),
(429048, 'PTHR43795:SF86', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE SYNTHASE 7-LIKE', 253286),
(429049, 'PTHR43795:SF40', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE SYNTHASE-LIKE PROTEIN 1', 253286),
(429050, 'PTHR43795:SF81', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE SYNTHASE 8', 253286);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(429051, 'PTHR43795:SF82', NULL, NULL, NULL, NULL, 'AMINOTRAN_1_2 DOMAIN-CONTAINING PROTEIN', 253286),
(429052, 'PTHR43795:SF108', NULL, NULL, NULL, NULL, 'TRYPTOPHAN AMINOTRANSFERASE-RELATED PROTEIN 3', 253286),
(429053, 'PTHR43795:SF109', NULL, NULL, NULL, NULL, 'ALLIINASE_C DOMAIN-CONTAINING PROTEIN', 253286),
(429054, 'PTHR43795:SF106', NULL, NULL, NULL, NULL, 'BNAA09G07210D PROTEIN', 253286),
(429055, 'PTHR43795:SF107', NULL, NULL, NULL, NULL, 'PYRIDOXAL PHOSPHATE-DEPENDENT TRANSFERASE-RELATED', 253286),
(429056, 'PTHR43795:SF100', NULL, NULL, NULL, NULL, 'ASPARTATE AMINOTRANSFERASE', 253286),
(429057, 'PTHR43795:SF101', NULL, NULL, NULL, NULL, 'AMINOTRAN_1_2 DOMAIN-CONTAINING PROTEIN', 253286),
(429058, 'PTHR43795:SF39', NULL, NULL, NULL, NULL, 'AMINOTRAN_1_2 DOMAIN-CONTAINING PROTEIN', 253286),
(429059, 'PTHR43795:SF104', NULL, NULL, NULL, NULL, 'TRYPTOPHAN AMINOTRANSFERASE-RELATED PROTEIN 1', 253286),
(429060, 'PTHR43795:SF105', NULL, NULL, NULL, NULL, 'TRYPTOPHAN AMINOTRANSFERASE-RELATED PROTEIN 2-LIKE', 253286),
(429061, 'PTHR43795:SF102', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE SYNTHASE-RELATED', 253286),
(429062, 'PTHR43795:SF103', NULL, NULL, NULL, NULL, '1-AMINO-CYCLOPROPANE-1-CARBOXYLATE SYNTHASE 7-RELATED', 253286),
(429063, 'PTHR43795:SF32', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE GLII-RELATED', 253286),
(429064, 'PTHR43795:SF74', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE SYNTHASE 2', 253286),
(429065, 'PTHR43795:SF75', NULL, NULL, NULL, NULL, 'ALLIINASE_C DOMAIN-CONTAINING PROTEIN', 253286),
(429066, 'PTHR43795:SF72', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE SYNTHASE', 253286),
(429067, 'PTHR43795:SF73', NULL, NULL, NULL, NULL, 'AMINOTRAN_1_2 DOMAIN-CONTAINING PROTEIN', 253286),
(429068, 'PTHR43795:SF71', NULL, NULL, NULL, NULL, 'ALLIINASE_C DOMAIN-CONTAINING PROTEIN', 253286),
(429069, 'PTHR32031:SF47', NULL, NULL, NULL, NULL, 'B BOX-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', 253287),
(429070, 'PTHR32031:SF45', NULL, NULL, NULL, NULL, 'B BOX-TYPE DOMAIN-CONTAINING PROTEIN', 253287),
(429071, 'PTHR32031:SF125', NULL, NULL, NULL, NULL, 'B BOX-TYPE DOMAIN-CONTAINING PROTEIN', 253287),
(429072, 'PTHR32031', NULL, NULL, NULL, NULL, 'FNIP REPEAT-CONTAINING PROTEIN-RELATED-RELATED', 253287),
(429073, 'PTHR32031:SF124', NULL, NULL, NULL, NULL, 'B BOX-TYPE DOMAIN-CONTAINING PROTEIN', 253287),
(429074, 'PTHR32031:SF123', NULL, NULL, NULL, NULL, 'B BOX-TYPE DOMAIN-CONTAINING PROTEIN', 253287),
(429075, 'PTHR37817:SF1', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE EIS', 253288),
(429076, 'PTHR37817', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE EIS', 253288),
(429077, 'PTHR10745:SF0', NULL, NULL, NULL, NULL, 'GLYCINE--TRNA LIGASE', 253289),
(429078, 'PTHR10745:SF20', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S15, CHLOROPLASTIC', 253289),
(429079, 'PTHR10745', NULL, NULL, NULL, NULL, 'GLYCYL-TRNA SYNTHETASE/DNA POLYMERASE SUBUNIT GAMMA-2', 253289),
(429080, 'PTHR10745:SF21', NULL, NULL, NULL, NULL, 'DIADENOSINE TETRAPHOSPHATE SYNTHETASE', 253289),
(429081, 'PTHR10745:SF8', NULL, NULL, NULL, NULL, 'DNA POLYMERASE SUBUNIT GAMMA-2, MITOCHONDRIAL', 253289),
(429082, 'PTHR10745:SF17', NULL, NULL, NULL, NULL, 'DIADENOSINE TETRAPHOSPHATE SYNTHETASE', 253289),
(429083, 'PTHR12838', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RNA-ASSOCIATED PROTEIN 11', 253290),
(429084, 'PTHR12838:SF0', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RNA-ASSOCIATED PROTEIN 11-RELATED', 253290),
(429085, 'PTHR12838:SF1', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RNA-ASSOCIATED PROTEIN 11', 253290),
(429086, 'PTHR37861', NULL, NULL, NULL, NULL, 'PROLINE-RICH ACIDIC PROTEIN 1', 253291),
(429087, 'PTHR37861:SF1', NULL, NULL, NULL, NULL, 'PROLINE-RICH ACIDIC PROTEIN 1', 253291),
(429088, 'PTHR16201:SF45', NULL, NULL, NULL, NULL, 'PQ-LOOP REPEAT FAMILY PROTEIN / TRANSMEMBRANE FAMILY PROTEIN', 253292),
(429089, 'PTHR16201:SF34', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 66 MEMBER 1', 253292),
(429090, 'PTHR16201:SF35', NULL, NULL, NULL, NULL, 'VACUOLAR AMINO ACID TRANSPORTER YPQ1-RELATED', 253292);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(429091, 'PTHR16201:SF11', NULL, NULL, NULL, NULL, 'PQ LOOP REPEAT PROTEIN (AFU_ORTHOLOGUE AFUA_3G10470)', 253292),
(429092, 'PTHR16201:SF44', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 44', 253292),
(429093, 'PTHR16201:SF42', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 66 MEMBER 1 LIKE', 253292),
(429094, 'PTHR16201:SF50', NULL, NULL, NULL, NULL, 'PQ-LOOP REPEAT FAMILY PROTEIN / TRANSMEMBRANE FAMILY PROTEIN-RELATED', 253292),
(429095, 'PTHR16201:SF40', NULL, NULL, NULL, NULL, '', 253292),
(429096, 'PTHR16201:SF51', NULL, NULL, NULL, NULL, 'PQ-LOOP PROTEIN/TRANSMEMBRANE FAMILY PROTEIN', 253292),
(429097, 'PTHR16201:SF36', NULL, NULL, NULL, NULL, 'LYSOSOMAL AMINO ACID TRANSPORTER 1 HOMOLOG', 253292),
(429098, 'PTHR16201:SF37', NULL, NULL, NULL, NULL, 'PQ LOOP REPEAT PROTEIN (AFU_ORTHOLOGUE AFUA_5G08410)', 253292),
(429099, 'PTHR16201', NULL, NULL, NULL, NULL, 'SEVEN TRANSMEMBRANE PROTEIN 1-RELATED', 253292),
(429100, 'PTHR13487:SF3', NULL, NULL, NULL, NULL, 'REVERSION-INDUCING CYSTEINE-RICH PROTEIN WITH KAZAL MOTIFS', 253293),
(429101, 'PTHR13487', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR', 253293),
(429102, 'PTHR19964', NULL, NULL, NULL, NULL, 'MULTIPLE PDZ DOMAIN PROTEIN', 253294),
(429103, 'PTHR19964:SF16', NULL, NULL, NULL, NULL, 'SYNTAXIN-BINDING PROTEIN 4', 253294),
(429104, 'PTHR19964:SF93', NULL, NULL, NULL, NULL, 'PROTEIN FRMPD2-LIKE-RELATED', 253294),
(429105, 'PTHR19964:SF92', NULL, NULL, NULL, NULL, 'PATJ HOMOLOG', 253294),
(429106, 'PTHR19964:SF91', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN', 253294),
(429107, 'PTHR19964:SF14', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE LNX', 253294),
(429108, 'PTHR19964:SF35', NULL, NULL, NULL, NULL, 'SI:DKEYP-72E1.9', 253294),
(429109, 'PTHR19964:SF56', NULL, NULL, NULL, NULL, 'FERM AND PDZ DOMAIN-CONTAINING PROTEIN 2', 253294),
(429110, 'PTHR19964:SF89', NULL, NULL, NULL, NULL, 'INACTIVATION-NO-AFTER-POTENTIAL D PROTEIN-LIKE PROTEIN', 253294),
(429111, 'PTHR19964:SF11', NULL, NULL, NULL, NULL, 'INAD-LIKE PROTEIN', 253294),
(429112, 'PTHR19964:SF44', NULL, NULL, NULL, NULL, 'ARC, ISOFORM A', 253294),
(429113, 'PTHR19964:SF33', NULL, NULL, NULL, NULL, 'LIGAND OF NUMB PROTEIN X 2', 253294),
(429114, 'PTHR19964:SF10', NULL, NULL, NULL, NULL, 'MULTIPLE PDZ DOMAIN PROTEIN', 253294),
(429115, 'PTHR19964:SF76', NULL, NULL, NULL, NULL, '', 253294),
(429116, 'PTHR19964:SF20', NULL, NULL, NULL, NULL, '', 253294),
(429117, 'PTHR19964:SF41', NULL, NULL, NULL, NULL, 'LIGAND OF NUMB-PROTEIN X 2B', 253294),
(429118, 'PTHR19964:SF84', NULL, NULL, NULL, NULL, '', 253294),
(429119, 'PTHR41317:SF1', NULL, NULL, NULL, NULL, '', 253295),
(429120, 'PTHR41317', NULL, NULL, NULL, NULL, '', 253295),
(429121, 'PTHR20950', NULL, NULL, NULL, NULL, 'GALANIN-RELATED PEPTIDE', 253296),
(429122, 'PTHR20950:SF1', NULL, NULL, NULL, NULL, 'GALANIN-LIKE PEPTIDE', 253296),
(429123, 'PTHR34007', NULL, NULL, NULL, NULL, 'AEROLYSIN-LIKE PROTEIN-RELATED', 253297),
(429124, 'PTHR34007:SF1', NULL, NULL, NULL, NULL, 'AEROLYSIN-LIKE PROTEIN-RELATED', 253297),
(429125, 'PTHR21272:SF5', NULL, NULL, NULL, NULL, 'CATABOLIC 3-DEHYDROQUINASE', 253298),
(429126, 'PTHR21272', NULL, NULL, NULL, NULL, 'CATABOLIC 3-DEHYDROQUINASE', 253298),
(429127, 'PTHR21272:SF3', NULL, NULL, NULL, NULL, 'CATABOLIC 3-DEHYDROQUINASE', 253298),
(429128, 'PTHR40031', NULL, NULL, NULL, NULL, 'HYPOTHETICAL MEMBRANE SPANNING PROTEIN', 253299),
(429129, 'PTHR40031:SF1', NULL, NULL, NULL, NULL, 'HYPOTHETICAL MEMBRANE SPANNING PROTEIN', 253299),
(429130, 'PTHR36025', NULL, NULL, NULL, NULL, 'DIHYDROOROTATE DEHYDROGENASE (DUF3598)', 253300),
(429131, 'PTHR36025:SF1', NULL, NULL, NULL, NULL, 'DIHYDROOROTATE DEHYDROGENASE (DUF3598)', 253300),
(429132, 'PTHR35505:SF1', NULL, NULL, NULL, NULL, 'SNF2 DOMAIN PROTEIN', 253301),
(429133, 'PTHR35505', NULL, NULL, NULL, NULL, 'OS01G0600300 PROTEIN', 253301),
(429134, 'PTHR35505:SF5', NULL, NULL, NULL, NULL, 'SUBSTRATE CARRIER FAMILY PROTEIN', 253301),
(429135, 'PTHR16196', NULL, NULL, NULL, NULL, 'CELL CYCLE CONTROL PROTEIN CWF25', 253302);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(429136, 'PTHR16196:SF0', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR CWC25 HOMOLOG', 253302),
(429137, 'PTHR11332:SF5', NULL, NULL, NULL, NULL, 'SECRETOGLOBIN FAMILY 1D MEMBER 1', 253303),
(429138, 'PTHR11332:SF6', NULL, NULL, NULL, NULL, 'SECRETOGLOBIN FAMILY 1D MEMBER 4', 253303),
(429139, 'PTHR11332:SF10', NULL, NULL, NULL, NULL, 'SECRETOGLOBIN FAMILY 1D MEMBER 2', 253303),
(429140, 'PTHR11332:SF9', NULL, NULL, NULL, NULL, 'SECRETOGLOBIN FAMILY 1D MEMBER', 253303),
(429141, 'PTHR11332', NULL, NULL, NULL, NULL, 'SECRETOGLOBIN FAMILY 1D', 253303),
(429142, 'PTHR13710:SF69', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE Q-LIKE SIM', 253304),
(429143, 'PTHR13710:SF151', NULL, NULL, NULL, NULL, 'DNA HELICASE', 253304),
(429144, 'PTHR13710:SF150', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE RECQ', 253304),
(429145, 'PTHR13710:SF145', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 253304),
(429146, 'PTHR13710:SF121', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', 253304),
(429147, 'PTHR13710:SF72', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE Q1', 253304),
(429148, 'PTHR13710:SF120', NULL, NULL, NULL, NULL, 'DNA HELICASE', 253304),
(429149, 'PTHR13710:SF142', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE Q5', 253304),
(429150, 'PTHR13710:SF84', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE RECS-RELATED', 253304),
(429151, 'PTHR13710:SF149', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE TLH2', 253304),
(429152, 'PTHR13710:SF105', NULL, NULL, NULL, NULL, 'BLOOM SYNDROME PROTEIN', 253304),
(429153, 'PTHR13710:SF148', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE Q-LIKE 4A', 253304),
(429154, 'PTHR13710:SF147', NULL, NULL, NULL, NULL, '', 253304),
(429155, 'PTHR13710:SF135', NULL, NULL, NULL, NULL, 'DNA HELICASE', 253304),
(429156, 'PTHR13710:SF124', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE Q-LIKE 1', 253304),
(429157, 'PTHR13710:SF146', NULL, NULL, NULL, NULL, 'WERNER SYNDROME ATP-DEPENDENT HELICASE', 253304),
(429158, 'PTHR13710:SF108', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE Q4', 253304),
(429159, 'PTHR13710', NULL, NULL, NULL, NULL, 'DNA HELICASE RECQ FAMILY MEMBER', 253304),
(429160, 'PTHR43591:SF83', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 253305),
(429161, 'PTHR43591:SF46', NULL, NULL, NULL, NULL, 'OS08G0411200 PROTEIN', 253305),
(429162, 'PTHR43591:SF24', NULL, NULL, NULL, NULL, '2-METHOXY-6-POLYPRENYL-1,4-BENZOQUINOL METHYLASE, MITOCHONDRIAL', 253305),
(429163, 'PTHR43591:SF67', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 253305),
(429164, 'PTHR43591', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 253305),
(429165, 'PTHR43591:SF81', NULL, NULL, NULL, NULL, 'MAGNESIUM PROTOPORPHYRIN IX METHYLTRANSFERASE, CHLOROPLASTIC', 253305),
(429166, 'PTHR43591:SF104', NULL, NULL, NULL, NULL, 'METHYLTRANSF_25 DOMAIN-CONTAINING PROTEIN', 253305),
(429167, 'PTHR43591:SF105', NULL, NULL, NULL, NULL, 'SAM-DEPENDENT METHYLTRANSFERASE (EUROFUNG)', 253305),
(429168, 'PTHR43591:SF69', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 253305),
(429169, 'PTHR43591:SF100', NULL, NULL, NULL, NULL, 'SAM BINDING MOTIF CONTAINING PROTEIN (AFU_ORTHOLOGUE AFUA_4G12760)', 253305),
(429170, 'PTHR43591:SF101', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE-LIKE PROTEIN 27', 253305),
(429171, 'PTHR43591:SF102', NULL, NULL, NULL, NULL, '', 253305),
(429172, 'PTHR43591:SF103', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 253305),
(429173, 'PTHR43591:SF95', NULL, NULL, NULL, NULL, '2-METHOXY-6-POLYPRENYL-1,4-BENZOQUINOL METHYLASE, MITOCHONDRIAL', 253305),
(429174, 'PTHR43591:SF72', NULL, NULL, NULL, NULL, 'GAMMA-TOCOPHEROL METHYLTRANSFERASE', 253305),
(429175, 'PTHR43591:SF50', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G04380)-RELATED', 253305),
(429176, 'PTHR43591:SF94', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 253305),
(429177, 'PTHR43591:SF31', NULL, NULL, NULL, NULL, 'LAEA-LIKE, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G01930)-RELATED', 253305);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(429178, 'PTHR43591:SF97', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 253305),
(429179, 'PTHR43591:SF96', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 253305),
(429180, 'PTHR43591:SF30', NULL, NULL, NULL, NULL, 'PROTEIN-METHIONINE METHYLTRANSFERASE LAEA', 253305),
(429181, 'PTHR43591:SF99', NULL, NULL, NULL, NULL, 'OS06G0646000 PROTEIN', 253305),
(429182, 'PTHR43591:SF10', NULL, NULL, NULL, NULL, 'UMTA', 253305),
(429183, 'PTHR43591:SF98', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 253305),
(429184, 'PTHR43591:SF57', NULL, NULL, NULL, NULL, 'METHYLTRANSF_25 DOMAIN-CONTAINING PROTEIN', 253305),
(429185, 'PTHR43591:SF78', NULL, NULL, NULL, NULL, 'SLR0407 PROTEIN', 253305),
(429186, 'PTHR43591:SF93', NULL, NULL, NULL, NULL, '', 253305),
(429187, 'PTHR43591:SF70', NULL, NULL, NULL, NULL, 'ABC TRANSMEMBRANE TYPE-1 DOMAIN-CONTAINING PROTEIN-RELATED', 253305),
(429188, 'PTHR43591:SF92', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', 253305),
(429189, 'PTHR43591:SF14', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', 253305),
(429190, 'PTHR47729:SF1', NULL, NULL, NULL, NULL, 'SERINE PEPTIDASE INHIBITOR, KAZAL TYPE 2, TANDEM DUPLICATE 1-RELATED', 253306),
(429191, 'PTHR47729', NULL, NULL, NULL, NULL, 'SERINE PEPTIDASE INHIBITOR, KAZAL TYPE 2, TANDEM DUPLICATE 1-RELATED', 253306),
(429192, 'PTHR31998:SF48', NULL, NULL, NULL, NULL, 'H(+)-EXPORTING DIPHOSPHATASE', 253307),
(429193, 'PTHR31998:SF36', NULL, NULL, NULL, NULL, 'H(+)-EXPORTING DIPHOSPHATASE', 253307),
(429194, 'PTHR31998:SF58', NULL, NULL, NULL, NULL, 'H(+)-EXPORTING DIPHOSPHATASE', 253307),
(429195, 'PTHR31998:SF27', NULL, NULL, NULL, NULL, 'H(+)-EXPORTING DIPHOSPHATASE', 253307),
(429196, 'PTHR31998:SF49', NULL, NULL, NULL, NULL, 'H(+)-EXPORTING DIPHOSPHATASE', 253307),
(429197, 'PTHR31998:SF55', NULL, NULL, NULL, NULL, 'K(+)-INSENSITIVE PYROPHOSPHATE-ENERGIZED PROTON PUMP', 253307),
(429198, 'PTHR31998:SF57', NULL, NULL, NULL, NULL, 'H(+)-EXPORTING DIPHOSPHATASE', 253307),
(429199, 'PTHR31998:SF46', NULL, NULL, NULL, NULL, 'H(+)-EXPORTING DIPHOSPHATASE', 253307),
(429200, 'PTHR31998:SF56', NULL, NULL, NULL, NULL, 'H(+)-EXPORTING DIPHOSPHATASE', 253307),
(429201, 'PTHR31998:SF53', NULL, NULL, NULL, NULL, 'H(+)-EXPORTING DIPHOSPHATASE', 253307),
(429202, 'PTHR31998:SF31', NULL, NULL, NULL, NULL, 'PYROPHOSPHATE-ENERGIZED MEMBRANE PROTON PUMP 2-RELATED', 253307),
(429203, 'PTHR31998:SF30', NULL, NULL, NULL, NULL, 'H(+)-EXPORTING DIPHOSPHATASE', 253307),
(429204, 'PTHR31998:SF52', NULL, NULL, NULL, NULL, 'PYROPHOSPHATE-ENERGIZED VACUOLAR MEMBRANE PROTON PUMP 1', 253307),
(429205, 'PTHR31998', NULL, NULL, NULL, NULL, 'K(+)-INSENSITIVE PYROPHOSPHATE-ENERGIZED PROTON PUMP', 253307),
(429206, 'PTHR30460', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 253308),
(429207, 'PTHR30460:SF1', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL', 253308),
(429208, 'PTHR30460:SF0', NULL, NULL, NULL, NULL, 'MODERATE CONDUCTANCE MECHANOSENSITIVE CHANNEL YBIO', 253308),
(429209, 'PTHR13369:SF3', NULL, NULL, NULL, NULL, 'METHYLTRANFER_DOM DOMAIN-CONTAINING PROTEIN', 253309),
(429210, 'PTHR13369:SF0', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE C-TERMINAL DOMAIN-CONTAINING PROTEIN', 253309),
(429211, 'PTHR13369', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 253309),
(429212, 'PTHR10285:SF75', NULL, NULL, NULL, NULL, 'URIDINE KINASE-LIKE PROTEIN 5', 253310),
(429213, 'PTHR10285:SF97', NULL, NULL, NULL, NULL, 'URIDINE KINASE-LIKE PROTEIN 3', 253310),
(429214, 'PTHR10285:SF70', NULL, NULL, NULL, NULL, 'URIDINE-CYTIDINE KINASE', 253310),
(429215, 'PTHR10285:SF72', NULL, NULL, NULL, NULL, 'PHOSPHORIBULOKINASE-RELATED', 253310),
(429216, 'PTHR10285:SF135', NULL, NULL, NULL, NULL, 'URACIL PHOSPHORIBOSYLTRANSFERASE 2', 253310),
(429217, 'PTHR10285:SF212', NULL, NULL, NULL, NULL, 'URIDINE KINASE', 253310),
(429218, 'PTHR10285:SF213', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT KINASE YFH7', 253310),
(429219, 'PTHR10285:SF158', NULL, NULL, NULL, NULL, 'SD05789P2', 253310),
(429220, 'PTHR10285:SF136', NULL, NULL, NULL, NULL, 'UMP PYROPHOSPHORYLASE', 253310);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(429221, 'PTHR10285:SF214', NULL, NULL, NULL, NULL, 'MIBP PROTEIN', 253310),
(429222, 'PTHR10285:SF159', NULL, NULL, NULL, NULL, 'PHOSPHORIBULOKINASE / URIDINE KINASE FAMILY PROTEIN', 253310),
(429223, 'PTHR10285:SF137', NULL, NULL, NULL, NULL, 'PHOSPHORIBULOKINASE', 253310),
(429224, 'PTHR10285:SF215', NULL, NULL, NULL, NULL, 'URIDINE KINASE', 253310),
(429225, 'PTHR10285:SF116', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN', 253310),
(429226, 'PTHR10285:SF138', NULL, NULL, NULL, NULL, 'URIDINE KINASE', 253310),
(429227, 'PTHR10285:SF139', NULL, NULL, NULL, NULL, 'PANTOTHENATE KINASE', 253310),
(429228, 'PTHR10285:SF216', NULL, NULL, NULL, NULL, 'URIDINE-CYTIDINE KINASE D', 253310),
(429229, 'PTHR10285:SF217', NULL, NULL, NULL, NULL, 'URIDINE KINASE-LIKE, CYTH-LIKE DOMAIN, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 253310),
(429230, 'PTHR10285:SF218', NULL, NULL, NULL, NULL, 'URIDINE KINASE-LIKE PROTEIN 4', 253310),
(429231, 'PTHR10285:SF219', NULL, NULL, NULL, NULL, 'PHOSPHORIBULOKINASE', 253310),
(429232, 'PTHR10285:SF171', NULL, NULL, NULL, NULL, 'URACIL PHOSPHORIBOSYLTRANSFERASE HOMOLOG', 253310),
(429233, 'PTHR10285:SF150', NULL, NULL, NULL, NULL, 'PHOSPHORIBULOKINASE', 253310),
(429234, 'PTHR10285:SF153', NULL, NULL, NULL, NULL, 'INORGANIC PYROPHOSPHATASE TTM2', 253310),
(429235, 'PTHR10285:SF131', NULL, NULL, NULL, NULL, 'URIDINE-CYTIDINE KINASE 2', 253310),
(429236, 'PTHR10285:SF176', NULL, NULL, NULL, NULL, 'URIDINE KINASE', 253310),
(429237, 'PTHR10285', NULL, NULL, NULL, NULL, 'URIDINE KINASE', 253310),
(429238, 'PTHR10285:SF210', NULL, NULL, NULL, NULL, 'PRK DOMAIN-CONTAINING PROTEIN', 253310),
(429239, 'PTHR10285:SF134', NULL, NULL, NULL, NULL, 'MUSCLE-SPECIFIC BETA 1 INTEGRIN-BINDING PROTEIN 2', 253310),
(429240, 'PTHR10285:SF211', NULL, NULL, NULL, NULL, 'PHOSPHORIBULOKINASE', 253310),
(429241, 'PTHR10285:SF66', NULL, NULL, NULL, NULL, 'URIDINE-CYTIDINE KINASE 1', 253310),
(429242, 'PTHR10285:SF68', NULL, NULL, NULL, NULL, 'URIDINE-CYTIDINE KINASE-LIKE 1', 253310),
(429243, 'PTHR10285:SF69', NULL, NULL, NULL, NULL, 'URIDINE-CYTIDINE KINASE', 253310),
(429244, 'PTHR10285:SF209', NULL, NULL, NULL, NULL, 'PHOSPHORIBULOKINASE, CHLOROPLASTIC', 253310),
(429245, 'PTHR10285:SF168', NULL, NULL, NULL, NULL, 'URIDINE KINASE', 253310),
(429246, 'PTHR10285:SF147', NULL, NULL, NULL, NULL, 'URIDINE-CYTIDINE KINASE 2-B', 253310),
(429247, 'PTHR10285:SF126', NULL, NULL, NULL, NULL, 'NICOTINAMIDE RIBOSIDE KINASE 1', 253310),
(429248, 'PTHR10285:SF149', NULL, NULL, NULL, NULL, 'URIDINE KINASE', 253310),
(429249, 'PTHR10285:SF208', NULL, NULL, NULL, NULL, 'URIDINE KINASE', 253310),
(429250, 'PTHR10285:SF142', NULL, NULL, NULL, NULL, 'URIDINE KINASE-LIKE PROTEIN 2, CHLOROPLASTIC', 253310),
(429251, 'PTHR10285:SF164', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT KINASE TDA10-RELATED', 253310),
(429252, 'PTHR10285:SF165', NULL, NULL, NULL, NULL, 'CYTH DOMAIN-CONTAINING PROTEIN', 253310),
(429253, 'PTHR10285:SF220', NULL, NULL, NULL, NULL, 'PHOSPHORIBULOKINASE', 253310),
(429254, 'PTHR10285:SF143', NULL, NULL, NULL, NULL, 'NICOTINAMIDE RIBOSIDE KINASE 2', 253310),
(429255, 'PTHR10285:SF187', NULL, NULL, NULL, NULL, 'URIDINE-CYTIDINE KINASE C-LIKE ISOFORM X1', 253310),
(429256, 'PTHR10285:SF122', NULL, NULL, NULL, NULL, 'URIDINE-CYTIDINE KINASE C', 253310),
(429257, 'PTHR10285:SF221', NULL, NULL, NULL, NULL, 'PHOSPHORIBULOKINASE', 253310),
(429258, 'PTHR22852', NULL, NULL, NULL, NULL, 'LETHAL 2 DENTICLELESS PROTEIN  RETINOIC ACID-REGULATED NUCLEAR MATRIX-ASSOCIATED PROTEIN', 253311),
(429259, 'PTHR22852:SF1', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 253311),
(429260, 'PTHR22852:SF0', NULL, NULL, NULL, NULL, 'DENTICLELESS PROTEIN HOMOLOG', 253311),
(429261, 'PTHR33994:SF21', NULL, NULL, NULL, NULL, '', 253312),
(429262, 'PTHR33994:SF32', NULL, NULL, NULL, NULL, '', 253312),
(429263, 'PTHR33994:SF10', NULL, NULL, NULL, NULL, 'OS04G0508700 PROTEIN', 253312),
(429264, 'PTHR33994:SF22', NULL, NULL, NULL, NULL, '', 253312);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(429265, 'PTHR33994:SF11', NULL, NULL, NULL, NULL, 'OS01G0771600 PROTEIN', 253312),
(429266, 'PTHR33994:SF33', NULL, NULL, NULL, NULL, 'OS02G0619200 PROTEIN', 253312),
(429267, 'PTHR33994:SF20', NULL, NULL, NULL, NULL, 'OS02G0619500 PROTEIN', 253312),
(429268, 'PTHR33994:SF25', NULL, NULL, NULL, NULL, 'OS02G0619166 PROTEIN', 253312),
(429269, 'PTHR33994:SF36', NULL, NULL, NULL, NULL, '', 253312),
(429270, 'PTHR33994:SF37', NULL, NULL, NULL, NULL, 'OS01G0712300 PROTEIN', 253312),
(429271, 'PTHR33994:SF23', NULL, NULL, NULL, NULL, '', 253312),
(429272, 'PTHR33994:SF34', NULL, NULL, NULL, NULL, '', 253312),
(429273, 'PTHR33994:SF24', NULL, NULL, NULL, NULL, 'OS01G0712000 PROTEIN', 253312),
(429274, 'PTHR33994:SF35', NULL, NULL, NULL, NULL, '', 253312),
(429275, 'PTHR33994:SF29', NULL, NULL, NULL, NULL, '', 253312),
(429276, 'PTHR33994:SF19', NULL, NULL, NULL, NULL, '', 253312),
(429277, 'PTHR33994:SF38', NULL, NULL, NULL, NULL, '', 253312),
(429278, 'PTHR33994:SF27', NULL, NULL, NULL, NULL, 'OS01G0771700 PROTEIN', 253312),
(429279, 'PTHR33994:SF17', NULL, NULL, NULL, NULL, 'OS01G0655600 PROTEIN', 253312),
(429280, 'PTHR33994:SF28', NULL, NULL, NULL, NULL, 'OS04G0515200 PROTEIN', 253312),
(429281, 'PTHR33994:SF39', NULL, NULL, NULL, NULL, 'OS01G0712400 PROTEIN', 253312),
(429282, 'PTHR33994', NULL, NULL, NULL, NULL, 'OS04G0515000 PROTEIN', 253312),
(429283, 'PTHR34287:SF4', NULL, NULL, NULL, NULL, 'OS04G0504200 PROTEIN', 253313),
(429284, 'PTHR34287', NULL, NULL, NULL, NULL, 'OS06G0551500 PROTEIN-RELATED', 253313),
(429285, 'PTHR34287:SF15', NULL, NULL, NULL, NULL, 'OS06G0551500 PROTEIN', 253313),
(429286, 'PTHR34287:SF14', NULL, NULL, NULL, NULL, 'BNAA08G05640D PROTEIN', 253313),
(429287, 'PTHR34287:SF2', NULL, NULL, NULL, NULL, 'OS02G0234700 PROTEIN', 253313),
(429288, 'PTHR34287:SF12', NULL, NULL, NULL, NULL, '', 253313),
(429289, 'PTHR10445:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIF SUBUNIT BETA', 253314),
(429290, 'PTHR10445:SF4', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIF SUBUNIT BETA', 253314),
(429291, 'PTHR10445', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR IIF SUBUNIT 2', 253314),
(429292, 'PTHR10445:SF0', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR IIF SUBUNIT 2', 253314),
(429293, 'PTHR10445:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIF SUBUNIT BETA', 253314),
(429294, 'PTHR10445:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIF SUBUNIT BETA', 253314),
(429295, 'PTHR10139:SF1', NULL, NULL, NULL, NULL, 'DOUBLE-STRAND BREAK REPAIR PROTEIN MRE11', 253315),
(429296, 'PTHR10139', NULL, NULL, NULL, NULL, 'DOUBLE-STRAND BREAK REPAIR PROTEIN MRE11', 253315),
(429297, 'PTHR10139:SF8', NULL, NULL, NULL, NULL, 'MRE11_DNA_BIND DOMAIN-CONTAINING PROTEIN', 253315),
(429298, 'PTHR10139:SF7', NULL, NULL, NULL, NULL, 'DOUBLE-STRAND BREAK REPAIR PROTEIN', 253315),
(429299, 'PTHR10139:SF4', NULL, NULL, NULL, NULL, 'DOUBLE-STRAND BREAK REPAIR PROTEIN MRE11', 253315),
(429300, 'PTHR10139:SF3', NULL, NULL, NULL, NULL, 'DOUBLE-STRAND BREAK REPAIR PROTEIN', 253315),
(429301, 'PTHR15458:SF11', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLETHANOLAMINE N-METHYLTRANSFERASE B', 253316),
(429302, 'PTHR15458', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLETHANOLAMINE N-METHYLTRANSFERASE', 253316),
(429303, 'PTHR15458:SF5', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLETHANOLAMINE N-METHYLTRANSFERASE', 253316),
(429304, 'PTHR37397', NULL, NULL, NULL, NULL, 'SI:CH211-183D21.1', 253317),
(429305, 'PTHR37397:SF1', NULL, NULL, NULL, NULL, 'SI:CH211-183D21.1', 253317),
(429306, 'PTHR47663', NULL, NULL, NULL, NULL, 'XYLANOLYTIC TRANSCRIPTIONAL ACTIVATOR XLNR-RELATED', 253318),
(429307, 'PTHR47663:SF1', NULL, NULL, NULL, NULL, 'XYLANOLYTIC TRANSCRIPTIONAL ACTIVATOR XLNR-RELATED', 253318),
(429308, 'PTHR47663:SF2', NULL, NULL, NULL, NULL, 'ARABINOLYTIC TRANSCRIPTIONAL ACTIVATOR ARAR-RELATED', 253318),
(429309, 'PTHR31936:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG21633', 253319),
(429310, 'PTHR31936:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG18744', 253319); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(429311, 'PTHR31936:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG15922', 253319),
(429312, 'PTHR31936', NULL, NULL, NULL, NULL, 'PROTEIN CBG18744', 253319),
(429313, 'PTHR31936:SF2', NULL, NULL, NULL, NULL, 'APPLE DOMAIN-CONTAINING PROTEIN', 253319),
(429314, 'PTHR31296:SF1', NULL, NULL, NULL, NULL, 'UPF0565 PROTEIN C2ORF69', 253320),
(429315, 'PTHR31296', NULL, NULL, NULL, NULL, 'UPF0565 PROTEIN C2ORF69', 253320),
(429316, 'PTHR13270:SF14', NULL, NULL, NULL, NULL, 'SEX DETERMINATION AND DOSAGE COMPENSATION PROTEIN SDC-2', 253321),
(429317, 'PTHR13270:SF13', NULL, NULL, NULL, NULL, 'LIMPET, ISOFORM K', 253321),
(429318, 'PTHR13270', NULL, NULL, NULL, NULL, 'PROTEIN C20ORF116-RELATED', 253321),
(429319, 'PTHR46389:SF3', NULL, NULL, NULL, NULL, 'POLYCOMB GROUP PROTEIN PC', 253322),
(429320, 'PTHR46389:SF4', NULL, NULL, NULL, NULL, 'CHROMOBOX PROTEIN HOMOLOG 6', 253322),
(429321, 'PTHR46389', NULL, NULL, NULL, NULL, 'POLYCOMB GROUP PROTEIN PC', 253322),
(429322, 'PTHR46389:SF1', NULL, NULL, NULL, NULL, 'CHROMOBOX PROTEIN HOMOLOG 8', 253322),
(429323, 'PTHR16265', NULL, NULL, NULL, NULL, 'PTB-CONTAINING, CUBILIN AND LRP1-INTERACTING PROTEIN', 253323),
(429324, 'PTHR16265:SF1', NULL, NULL, NULL, NULL, 'PTB-CONTAINING, CUBILIN AND LRP1-INTERACTING PROTEIN', 253323),
(429325, 'PTHR14869:SF0', NULL, NULL, NULL, NULL, 'MYC TARGET PROTEIN 1', 253324),
(429326, 'PTHR14869', NULL, NULL, NULL, NULL, 'MYC TARGET PROTEIN 1', 253324),
(429327, 'PTHR45460', NULL, NULL, NULL, NULL, 'SIMILAR TO CYSTEINE PROTEINASE', 253325),
(429328, 'PTHR45460:SF2', NULL, NULL, NULL, NULL, 'ALPHA 1,3 GLUCANASE, GH71 FAMILY (EUROFUNG)-RELATED', 253325),
(429329, 'PTHR10868', NULL, NULL, NULL, NULL, 'SIGMA 1-TYPE OPIOID RECEPTOR-RELATED', 253326),
(429330, 'PTHR10868:SF1', NULL, NULL, NULL, NULL, 'SIGMA NON-OPIOID INTRACELLULAR RECEPTOR 1', 253326),
(429331, 'PTHR34956', NULL, NULL, NULL, NULL, 'OS05G0397300 PROTEIN', 253327),
(429332, 'PTHR34956:SF1', NULL, NULL, NULL, NULL, '', 253327),
(429333, 'PTHR34956:SF6', NULL, NULL, NULL, NULL, 'BNAANNG08740D PROTEIN', 253327),
(429334, 'PTHR34956:SF7', NULL, NULL, NULL, NULL, '', 253327),
(429335, 'PTHR34956:SF8', NULL, NULL, NULL, NULL, 'BNAANNG03070D PROTEIN', 253327),
(429336, 'PTHR34956:SF9', NULL, NULL, NULL, NULL, 'BNAA05G31210D PROTEIN', 253327),
(429337, 'PTHR34956:SF2', NULL, NULL, NULL, NULL, 'OS05G0397300 PROTEIN', 253327),
(429338, 'PTHR34956:SF3', NULL, NULL, NULL, NULL, '', 253327),
(429339, 'PTHR34956:SF4', NULL, NULL, NULL, NULL, 'BNAC03G34540D PROTEIN', 253327),
(429340, 'PTHR38020', NULL, NULL, NULL, NULL, 'UROPORPHYRINOGEN-III SYNTHASE', 253328),
(429341, 'PTHR38020:SF1', NULL, NULL, NULL, NULL, 'HYDROXYMETHYLBILANE HYDROLYASE [CYCLIZING]', 253328),
(429342, 'PTHR34831', NULL, NULL, NULL, NULL, 'MIGRATION AND INVASION-INHIBITORY PROTEIN', 253329),
(429343, 'PTHR34831:SF1', NULL, NULL, NULL, NULL, 'MIGRATION AND INVASION-INHIBITORY PROTEIN', 253329),
(429344, 'PTHR40045', NULL, NULL, NULL, NULL, 'YCGG FAMILY PROTEIN', 253330),
(429345, 'PTHR40045:SF1', NULL, NULL, NULL, NULL, 'YCGG FAMILY PROTEIN', 253330),
(429346, 'PTHR10677:SF9', NULL, NULL, NULL, NULL, 'UBIQUILIN-LIKE PROTEIN', 253331),
(429347, 'PTHR10677:SF4', NULL, NULL, NULL, NULL, 'UBIQUILIN-3', 253331),
(429348, 'PTHR10677:SF5', NULL, NULL, NULL, NULL, 'UBIQUILIN-2', 253331),
(429349, 'PTHR10677:SF51', NULL, NULL, NULL, NULL, 'BNAA07G03090D PROTEIN', 253331),
(429350, 'PTHR10677:SF40', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', 253331),
(429351, 'PTHR10677:SF10', NULL, NULL, NULL, NULL, 'UBIQUILIN 5', 253331),
(429352, 'PTHR10677:SF21', NULL, NULL, NULL, NULL, 'UBIQUILIN-4', 253331),
(429353, 'PTHR10677:SF42', NULL, NULL, NULL, NULL, 'PLANT UBIQUILIN', 253331),
(429354, 'PTHR10677:SF53', NULL, NULL, NULL, NULL, 'UBIQUILIN-RELATED', 253331),
(429355, 'PTHR10677:SF56', NULL, NULL, NULL, NULL, 'UBA DOMAIN-CONTAINING PROTEIN', 253331),
(429356, 'PTHR10677:SF55', NULL, NULL, NULL, NULL, 'STI1 DOMAIN-CONTAINING PROTEIN', 253331),
(429357, 'PTHR10677', NULL, NULL, NULL, NULL, 'UBIQUILIN', 253331);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(429358, 'PTHR10677:SF25', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE PROTEIN 7', 253331),
(429359, 'PTHR10677:SF57', NULL, NULL, NULL, NULL, 'UBIQUITIN DOMAIN-CONTAINING PROTEIN DSK2B', 253331),
(429360, 'PTHR10677:SF16', NULL, NULL, NULL, NULL, 'UBIQUILIN-1', 253331),
(429361, 'PTHR10677:SF48', NULL, NULL, NULL, NULL, 'BNAC09G09230D PROTEIN', 253331),
(429362, 'PTHR10677:SF3', NULL, NULL, NULL, NULL, 'FI07626P-RELATED', 253331),
(429363, 'PTHR10677:SF28', NULL, NULL, NULL, NULL, 'OS10G0542200 PROTEIN', 253331),
(429364, 'PTHR48008:SF2', NULL, NULL, NULL, NULL, 'PROBABLY INACTIVE LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE IMK2', 253332),
(429365, 'PTHR48008:SF1', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253332),
(429366, 'PTHR48008', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE IMK3-RELATED', 253332),
(429367, 'PTHR48008:SF4', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE IMK3-RELATED', 253332),
(429368, 'PTHR48008:SF3', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253332),
(429369, 'PTHR48008:SF6', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE IMK3-RELATED', 253332),
(429370, 'PTHR48008:SF5', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 253332),
(429371, 'PTHR48008:SF8', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253332),
(429372, 'PTHR48008:SF11', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253332),
(429373, 'PTHR48008:SF10', NULL, NULL, NULL, NULL, 'OS02G0655800 PROTEIN', 253332),
(429374, 'PTHR48008:SF14', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253332),
(429375, 'PTHR48008:SF13', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 253332),
(429376, 'PTHR48008:SF12', NULL, NULL, NULL, NULL, 'EPHRIN RECEPTOR TYPE-A /TYPE-B-RELATED', 253332),
(429377, 'PTHR30001:SF0', NULL, NULL, NULL, NULL, 'RIBONUCLEASE G', 253333),
(429378, 'PTHR30001:SF1', NULL, NULL, NULL, NULL, 'RIBONUCLEASE E/G-LIKE PROTEIN, CHLOROPLASTIC', 253333),
(429379, 'PTHR30001', NULL, NULL, NULL, NULL, 'RIBONUCLEASE', 253333),
(429380, 'PTHR46877:SF9', NULL, NULL, NULL, NULL, 'EPHRIN TYPE-A RECEPTOR 7', 253334),
(429381, 'PTHR46877:SF16', NULL, NULL, NULL, NULL, 'EPHRIN TYPE-A RECEPTOR 10', 253334),
(429382, 'PTHR46877', NULL, NULL, NULL, NULL, 'EPH RECEPTOR A5', 253334),
(429383, 'PTHR46877:SF17', NULL, NULL, NULL, NULL, 'EPHRIN TYPE-B RECEPTOR 1', 253334),
(429384, 'PTHR46877:SF14', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN-TYROSINE KINASE', 253334),
(429385, 'PTHR46877:SF15', NULL, NULL, NULL, NULL, 'EPHRIN TYPE-B RECEPTOR 6', 253334),
(429386, 'PTHR46877:SF6', NULL, NULL, NULL, NULL, 'EPHRIN TYPE-B RECEPTOR 3', 253334),
(429387, 'PTHR46877:SF7', NULL, NULL, NULL, NULL, 'EPHRIN TYPE-A RECEPTOR 8', 253334),
(429388, 'PTHR46877:SF18', NULL, NULL, NULL, NULL, 'EPHRIN TYPE-A RECEPTOR 4', 253334),
(429389, 'PTHR46877:SF8', NULL, NULL, NULL, NULL, 'RECEPTOR PROTEIN-TYROSINE KINASE', 253334),
(429390, 'PTHR46877:SF12', NULL, NULL, NULL, NULL, 'EPHRIN TYPE-A RECEPTOR 3', 253334),
(429391, 'PTHR46877:SF13', NULL, NULL, NULL, NULL, 'EPHRIN TYPE-A RECEPTOR 5', 253334),
(429392, 'PTHR46877:SF10', NULL, NULL, NULL, NULL, 'EPHRIN TYPE-A RECEPTOR 6', 253334),
(429393, 'PTHR46877:SF11', NULL, NULL, NULL, NULL, 'EPHRIN TYPE-B RECEPTOR 2', 253334),
(429394, 'PTHR42929:SF3', NULL, NULL, NULL, NULL, 'PUTRESCINE TRANSPORT SYSTEM PERMEASE PROTEIN POTH', 253335),
(429395, 'PTHR42929:SF1', NULL, NULL, NULL, NULL, 'INNER MEMBRANE ABC TRANSPORTER PERMEASE PROTEIN YDCU-RELATED', 253335),
(429396, 'PTHR42929', NULL, NULL, NULL, NULL, 'INNER MEMBRANE ABC TRANSPORTER PERMEASE PROTEIN YDCU-RELATED-RELATED', 253335),
(429397, 'PTHR42929:SF7', NULL, NULL, NULL, NULL, 'POLYAMINE TRANSPORT PROTEIN POTB', 253335),
(429398, 'PTHR42929:SF5', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN', 253335),
(429399, 'PTHR42929:SF6', NULL, NULL, NULL, NULL, 'IRON(III)-TRANSPORT SYSTEM PERMEASE PROTEIN SFUB', 253335);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(429400, 'PTHR46883:SF1', NULL, NULL, NULL, NULL, 'BARDET-BIEDL SYNDROME 12 PROTEIN', 253336),
(429401, 'PTHR46883', NULL, NULL, NULL, NULL, 'BARDET-BIEDL SYNDROME 12 PROTEIN', 253336),
(429402, 'PTHR10569:SF2', NULL, NULL, NULL, NULL, 'GLYCOGEN DEBRANCHING ENZYME', 253337),
(429403, 'PTHR10569', NULL, NULL, NULL, NULL, 'GLYCOGEN DEBRANCHING ENZYME', 253337),
(429404, 'PTHR36540:SF1', NULL, NULL, NULL, NULL, 'PYRIMIDINE/PURINE NUCLEOSIDE PHOSPHORYLASE', 253338),
(429405, 'PTHR36540', NULL, NULL, NULL, NULL, 'PYRIMIDINE/PURINE NUCLEOSIDE PHOSPHORYLASE', 253338),
(429406, 'PTHR11157:SF5', NULL, NULL, NULL, NULL, 'ELONGATION OF VERY LONG CHAIN FATTY ACIDS PROTEIN', 253339),
(429407, 'PTHR11157:SF153', NULL, NULL, NULL, NULL, 'ELONGATION OF VERY LONG CHAIN FATTY ACIDS PROTEIN', 253339),
(429408, 'PTHR11157:SF150', NULL, NULL, NULL, NULL, 'ELONGATION OF VERY LONG CHAIN FATTY ACIDS PROTEIN', 253339),
(429409, 'PTHR11157:SF30', NULL, NULL, NULL, NULL, 'ELONGATION OF LONG CHAIN FATTY ACIDS PROTEIN 2', 253339),
(429410, 'PTHR11157:SF116', NULL, NULL, NULL, NULL, 'ELONGATION OF VERY LONG CHAIN FATTY ACIDS PROTEIN-RELATED', 253339),
(429411, 'PTHR11157:SF158', NULL, NULL, NULL, NULL, 'GNS1/SUR4 MEMBRANE FAMILY PROTEIN', 253339),
(429412, 'PTHR11157:SF156', NULL, NULL, NULL, NULL, 'FATTY ACID ELONGATION PROTEIN 4-RELATED', 253339),
(429413, 'PTHR11157:SF113', NULL, NULL, NULL, NULL, 'ELONGATION OF VERY LONG CHAIN FATTY ACIDS PROTEIN', 253339),
(429414, 'PTHR11157:SF157', NULL, NULL, NULL, NULL, 'ELONGATION OF FATTY ACIDS PROTEIN 3', 253339),
(429415, 'PTHR11157:SF118', NULL, NULL, NULL, NULL, 'ELONGATION OF VERY LONG CHAIN FATTY ACIDS PROTEIN 7', 253339),
(429416, 'PTHR11157', NULL, NULL, NULL, NULL, 'FATTY ACID ACYL TRANSFERASE-RELATED', 253339),
(429417, 'PTHR11157:SF9', NULL, NULL, NULL, NULL, 'ELONGATION OF VERY LONG CHAIN FATTY ACIDS PROTEIN', 253339),
(429418, 'PTHR11157:SF61', NULL, NULL, NULL, NULL, 'ELONGATION OF VERY LONG CHAIN FATTY ACIDS PROTEIN 4', 253339),
(429419, 'PTHR11157:SF163', NULL, NULL, NULL, NULL, '', 253339),
(429420, 'PTHR11157:SF120', NULL, NULL, NULL, NULL, 'ELONGATION OF VERY LONG CHAIN FATTY ACIDS PROTEIN 1', 253339),
(429421, 'PTHR11157:SF164', NULL, NULL, NULL, NULL, 'ELONGATION OF VERY LONG CHAIN FATTY ACIDS PROTEIN', 253339),
(429422, 'PTHR11157:SF161', NULL, NULL, NULL, NULL, 'ELONGATION OF FATTY ACIDS PROTEIN', 253339),
(429423, 'PTHR11157:SF162', NULL, NULL, NULL, NULL, 'ELONGATION OF VERY LONG CHAIN FATTY ACIDS PROTEIN', 253339),
(429424, 'PTHR11157:SF21', NULL, NULL, NULL, NULL, 'ELONGATION OF VERY LONG CHAIN FATTY ACIDS PROTEIN', 253339),
(429425, 'PTHR11157:SF62', NULL, NULL, NULL, NULL, 'ELONGATION OF VERY LONG CHAIN FATTY ACIDS PROTEIN', 253339),
(429426, 'PTHR11157:SF69', NULL, NULL, NULL, NULL, 'ELONGATION OF VERY LONG CHAIN FATTY ACIDS PROTEIN', 253339),
(429427, 'PTHR11157:SF127', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN 3-OXOACYL-COA SYNTHASE', 253339),
(429428, 'PTHR11157:SF68', NULL, NULL, NULL, NULL, 'ELONGATION OF VERY LONG CHAIN FATTY ACIDS PROTEIN 3', 253339),
(429429, 'PTHR11157:SF125', NULL, NULL, NULL, NULL, 'ELONGATION OF VERY LONG CHAIN FATTY ACIDS PROTEIN 6', 253339),
(429430, 'PTHR11157:SF22', NULL, NULL, NULL, NULL, 'ELONGATION OF VERY LONG CHAIN FATTY ACIDS PROTEIN', 253339),
(429431, 'PTHR11157:SF126', NULL, NULL, NULL, NULL, 'ELONGATION OF VERY LONG CHAIN FATTY ACIDS PROTEIN', 253339),
(429432, 'PTHR11157:SF29', NULL, NULL, NULL, NULL, 'ELONGATION OF LONG CHAIN FATTY ACIDS PROTEIN 5', 253339),
(429433, 'PTHR11157:SF167', NULL, NULL, NULL, NULL, 'ELONGATION OF VERY LONG CHAIN FATTY ACIDS PROTEIN', 253339),
(429434, 'PTHR11157:SF123', NULL, NULL, NULL, NULL, 'F25A4.4', 253339),
(429435, 'PTHR11157:SF168', NULL, NULL, NULL, NULL, 'GNS1/SUR4 MEMBRANE FAMILY PROTEIN', 253339),
(429436, 'PTHR11157:SF28', NULL, NULL, NULL, NULL, 'ELONGATION OF VERY LONG CHAIN FATTY ACIDS PROTEIN', 253339),
(429437, 'PTHR11157:SF27', NULL, NULL, NULL, NULL, 'ELONGATION OF LONG CHAIN FATTY ACIDS PROTEIN 6', 253339),
(429438, 'PTHR11157:SF165', NULL, NULL, NULL, NULL, 'DELTA5-ELONGASE', 253339);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(429439, 'PTHR11157:SF122', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN 3-OXOACYL-COA SYNTHASE', 253339),
(429440, 'PTHR11157:SF166', NULL, NULL, NULL, NULL, 'ELONGATION OF VERY LONG CHAIN FATTY ACIDS PROTEIN', 253339),
(429441, 'PTHR11157:SF26', NULL, NULL, NULL, NULL, 'ELONGATION OF LONG CHAIN FATTY ACIDS PROTEIN 1', 253339),
(429442, 'PTHR11157:SF129', NULL, NULL, NULL, NULL, 'GNS1/SUR4 MEMBRANE FAMILY PROTEIN', 253339),
(429443, 'PTHR11157:SF12', NULL, NULL, NULL, NULL, 'ELONGATION OF VERY LONG CHAIN FATTY ACIDS PROTEIN 4', 253339),
(429444, 'PTHR11157:SF137', NULL, NULL, NULL, NULL, 'ELONGATION OF VERY LONG CHAIN FATTY ACIDS PROTEIN 4', 253339),
(429445, 'PTHR11157:SF11', NULL, NULL, NULL, NULL, 'ELONGATION OF FATTY ACIDS PROTEIN 3-LIKE', 253339),
(429446, 'PTHR11157:SF18', NULL, NULL, NULL, NULL, 'ELONGATION OF VERY LONG CHAIN FATTY ACIDS PROTEIN 5', 253339),
(429447, 'PTHR11157:SF134', NULL, NULL, NULL, NULL, 'ELONGATION OF FATTY ACIDS PROTEIN 1-RELATED', 253339),
(429448, 'PTHR11157:SF17', NULL, NULL, NULL, NULL, 'ELONGATION OF VERY LONG CHAIN FATTY ACIDS PROTEIN 6', 253339),
(429449, 'PTHR11157:SF135', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN 3-OXOACYL-COA SYNTHASE', 253339),
(429450, 'PTHR11157:SF132', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN 3-OXOACYL-COA SYNTHASE', 253339),
(429451, 'PTHR11157:SF16', NULL, NULL, NULL, NULL, 'ELONGATION OF VERY LONG CHAIN FATTY ACIDS PROTEIN 2', 253339),
(429452, 'PTHR11157:SF133', NULL, NULL, NULL, NULL, 'ELONGATION OF FATTY ACIDS PROTEIN', 253339),
(429453, 'PTHR11157:SF19', NULL, NULL, NULL, NULL, 'ELONGATION OF VERY LONG CHAIN FATTY ACIDS PROTEIN 1', 253339),
(429454, 'PTHR11157:SF141', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN 3-OXOACYL-COA SYNTHASE', 253339),
(429455, 'PTHR11157:SF142', NULL, NULL, NULL, NULL, 'ELO FAMILY-RELATED', 253339),
(429456, 'PTHR11157:SF140', NULL, NULL, NULL, NULL, 'ELONGATION OF FATTY ACIDS PROTEIN', 253339),
(429457, 'PTHR11157:SF149', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN 3-OXOACYL-COA SYNTHASE', 253339),
(429458, 'PTHR11157:SF105', NULL, NULL, NULL, NULL, 'ELONGATION OF FATTY ACIDS PROTEIN', 253339),
(429459, 'PTHR11157:SF106', NULL, NULL, NULL, NULL, 'ELONGATION OF FATTY ACIDS PROTEIN', 253339),
(429460, 'PTHR11157:SF103', NULL, NULL, NULL, NULL, 'ELONGATION OF VERY LONG CHAIN FATTY ACIDS PROTEIN', 253339),
(429461, 'PTHR11157:SF148', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN 3-OXOACYL-COA SYNTHASE', 253339),
(429462, 'PTHR11157:SF104', NULL, NULL, NULL, NULL, 'ELONGATION OF FATTY ACIDS PROTEIN SRE1', 253339),
(429463, 'PTHR11157:SF145', NULL, NULL, NULL, NULL, 'ELONGATION OF VERY LONG CHAIN FATTY ACIDS PROTEIN', 253339),
(429464, 'PTHR11157:SF143', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN 3-OXOACYL-COA SYNTHASE', 253339),
(429465, 'PTHR10370', NULL, NULL, NULL, NULL, 'ERYTHROPOIETIN', 253340),
(429466, 'PTHR10370:SF0', NULL, NULL, NULL, NULL, 'ERYTHROPOIETIN', 253340),
(429467, 'PTHR10370:SF1', NULL, NULL, NULL, NULL, 'ERYTHROPOIETIN', 253340),
(429468, 'PTHR21422:SF10', NULL, NULL, NULL, NULL, 'RAB3 GTPASE-ACTIVATING PROTEIN CATALYTIC SUBUNIT', 253341),
(429469, 'PTHR21422:SF14', NULL, NULL, NULL, NULL, 'RAB3 GTPASE-ACTIVATING PROTEIN CATALYTIC SUBUNIT', 253341),
(429470, 'PTHR21422', NULL, NULL, NULL, NULL, 'RAB3 GTPASE-ACTIVATING PROTEIN CATALYTIC SUBUNIT', 253341),
(429471, 'PTHR21422:SF13', NULL, NULL, NULL, NULL, 'RAB3 GTPASE-ACTIVATING PROTEIN CATALYTIC SUBUNIT', 253341),
(429472, 'PTHR21422:SF9', NULL, NULL, NULL, NULL, 'RAB3 GTPASE-ACTIVATING PROTEIN CATALYTIC SUBUNIT', 253341),
(429473, 'PTHR21422:SF16', NULL, NULL, NULL, NULL, 'RAB3 GTPASE-ACTIVATING PROTEIN CATALYTIC SUBUNIT', 253341),
(429474, 'PTHR21422:SF15', NULL, NULL, NULL, NULL, 'RAB3 GTPASE-ACTIVATING PROTEIN CATALYTIC SUBUNIT', 253341),
(429475, 'PTHR15128:SF0', NULL, NULL, NULL, NULL, 'SCL-INTERRUPTING LOCUS PROTEIN', 253342),
(429476, 'PTHR15128', NULL, NULL, NULL, NULL, 'TAL1  SCL  INTERRUPTING LOCUS', 253342),
(429477, 'PTHR32370:SF17', NULL, NULL, NULL, NULL, 'ROOT PHOTOTROPISM PROTEIN 2', 253343),
(429478, 'PTHR32370:SF16', NULL, NULL, NULL, NULL, 'NON-PHOTOTROPIC HYPOCOTYL-LIKE PROTEIN', 253343);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(429479, 'PTHR32370:SF14', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN SR1IP1', 253343),
(429480, 'PTHR32370:SF150', NULL, NULL, NULL, NULL, 'NPH3 DOMAIN-CONTAINING PROTEIN', 253343),
(429481, 'PTHR32370:SF13', NULL, NULL, NULL, NULL, 'OS07G0584200 PROTEIN', 253343),
(429482, 'PTHR32370:SF106', NULL, NULL, NULL, NULL, 'NPH3 DOMAIN-CONTAINING PROTEIN', 253343),
(429483, 'PTHR32370:SF90', NULL, NULL, NULL, NULL, 'NPH3 DOMAIN-CONTAINING PROTEIN', 253343),
(429484, 'PTHR32370:SF108', NULL, NULL, NULL, NULL, 'ROOT PHOTOTROPISM PROTEIN 3-LIKE ISOFORM X1', 253343),
(429485, 'PTHR32370:SF109', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN NPY4', 253343),
(429486, 'PTHR32370:SF12', NULL, NULL, NULL, NULL, 'OS04G0477000 PROTEIN', 253343),
(429487, 'PTHR32370:SF141', NULL, NULL, NULL, NULL, 'PHOTOTROPIC-RESPONSIVE NPH3 FAMILY PROTEIN', 253343),
(429488, 'PTHR32370:SF99', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN DOT3', 253343),
(429489, 'PTHR32370:SF142', NULL, NULL, NULL, NULL, 'PHOTOTROPIC-RESPONSIVE NPH3 FAMILY PROTEIN', 253343),
(429490, 'PTHR32370:SF100', NULL, NULL, NULL, NULL, 'PHOTOTROPIC-RESPONSIVE NPH3 FAMILY PROTEIN', 253343),
(429491, 'PTHR32370:SF144', NULL, NULL, NULL, NULL, 'BNAA09G51040D PROTEIN', 253343),
(429492, 'PTHR32370:SF96', NULL, NULL, NULL, NULL, 'PHOTOTROPIC-RESPONSIVE NPH3 FAMILY PROTEIN', 253343),
(429493, 'PTHR32370:SF101', NULL, NULL, NULL, NULL, 'NPH3 DOMAIN-CONTAINING PROTEIN', 253343),
(429494, 'PTHR32370:SF145', NULL, NULL, NULL, NULL, 'PHOTOTROPIC-RESPONSIVE NPH3 FAMILY PROTEIN', 253343),
(429495, 'PTHR32370:SF102', NULL, NULL, NULL, NULL, 'ROOT PHOTOTROPISM PROTEIN 3', 253343),
(429496, 'PTHR32370:SF146', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN NPY3', 253343),
(429497, 'PTHR32370:SF95', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN', 253343),
(429498, 'PTHR32370:SF148', NULL, NULL, NULL, NULL, 'COLEOPTILE PHOTOTROPISM PROTEIN 1-LIKE ISOFORM X1', 253343),
(429499, 'PTHR32370:SF8', NULL, NULL, NULL, NULL, 'OS03G0738900 PROTEIN', 253343),
(429500, 'PTHR32370:SF6', NULL, NULL, NULL, NULL, 'ROOT PHOTOTROPISM PROTEIN 3', 253343),
(429501, 'PTHR32370:SF7', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN NPY1', 253343),
(429502, 'PTHR32370:SF25', NULL, NULL, NULL, NULL, 'NPH3 DOMAIN-CONTAINING PROTEIN', 253343),
(429503, 'PTHR32370:SF161', NULL, NULL, NULL, NULL, 'BNAA01G25860D PROTEIN', 253343),
(429504, 'PTHR32370:SF162', NULL, NULL, NULL, NULL, 'SKP1/BTB/POZ DOMAIN, NPH3 DOMAIN PROTEIN-RELATED', 253343),
(429505, 'PTHR32370:SF4', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN NPY2', 253343),
(429506, 'PTHR32370:SF5', NULL, NULL, NULL, NULL, 'OS04G0674300 PROTEIN', 253343),
(429507, 'PTHR32370:SF117', NULL, NULL, NULL, NULL, '', 253343),
(429508, 'PTHR32370:SF119', NULL, NULL, NULL, NULL, 'NPH3 DOMAIN-CONTAINING PROTEIN', 253343),
(429509, 'PTHR32370:SF152', NULL, NULL, NULL, NULL, 'BNAA03G54110D PROTEIN', 253343),
(429510, 'PTHR32370:SF23', NULL, NULL, NULL, NULL, 'OS08G0130600 PROTEIN', 253343),
(429511, 'PTHR32370:SF153', NULL, NULL, NULL, NULL, 'BNAA09G06800D PROTEIN', 253343),
(429512, 'PTHR32370:SF154', NULL, NULL, NULL, NULL, 'SKP1/BTB/POZ DOMAIN, NPH3 DOMAIN PROTEIN-RELATED', 253343),
(429513, 'PTHR32370:SF110', NULL, NULL, NULL, NULL, 'BNAANNG03900D PROTEIN', 253343),
(429514, 'PTHR32370:SF21', NULL, NULL, NULL, NULL, 'PHOTOTROPIC-RESPONSIVE NPH3 FAMILY PROTEIN', 253343),
(429515, 'PTHR32370:SF156', NULL, NULL, NULL, NULL, 'BNAANNG05180D PROTEIN', 253343),
(429516, 'PTHR32370:SF157', NULL, NULL, NULL, NULL, 'BNAC03G16990D PROTEIN', 253343),
(429517, 'PTHR32370:SF114', NULL, NULL, NULL, NULL, 'OS05G0178000 PROTEIN', 253343),
(429518, 'PTHR32370:SF158', NULL, NULL, NULL, NULL, 'NPH3 DOMAIN-CONTAINING PROTEIN', 253343),
(429519, 'PTHR32370:SF159', NULL, NULL, NULL, NULL, 'PHOTOTROPIC-RESPONSIVE NPH3 FAMILY PROTEIN-RELATED', 253343),
(429520, 'PTHR32370:SF115', NULL, NULL, NULL, NULL, 'OS12G0117600 PROTEIN', 253343),
(429521, 'PTHR32370:SF170', NULL, NULL, NULL, NULL, '', 253343);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(429522, 'PTHR32370:SF171', NULL, NULL, NULL, NULL, 'SKP1/BTB/POZ DOMAIN, NPH3 DOMAIN PROTEIN-RELATED', 253343),
(429523, 'PTHR32370:SF172', NULL, NULL, NULL, NULL, 'NON-PHOTOTROPIC HYPOCOTYL', 253343),
(429524, 'PTHR32370:SF173', NULL, NULL, NULL, NULL, '', 253343),
(429525, 'PTHR32370:SF127', NULL, NULL, NULL, NULL, 'NPH3 DOMAIN, BTB/POZ DOMAIN-CONTAINING PROTEIN NPY2-RELATED', 253343),
(429526, 'PTHR32370:SF129', NULL, NULL, NULL, NULL, 'PHOTOTROPIC-RESPONSIVE NPH3 FAMILY PROTEIN', 253343),
(429527, 'PTHR32370:SF163', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN NPY5', 253343),
(429528, 'PTHR32370:SF164', NULL, NULL, NULL, NULL, 'PHOTOTROPIC-RESPONSIVE NPH3 FAMILY PROTEIN', 253343),
(429529, 'PTHR32370:SF77', NULL, NULL, NULL, NULL, 'OS04G0636500 PROTEIN', 253343),
(429530, 'PTHR32370:SF32', NULL, NULL, NULL, NULL, 'OS12G0613250 PROTEIN', 253343),
(429531, 'PTHR32370:SF121', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN NPY3-LIKE', 253343),
(429532, 'PTHR32370:SF76', NULL, NULL, NULL, NULL, 'PHOTOTROPIC-RESPONSIVE NPH3 FAMILY PROTEIN', 253343),
(429533, 'PTHR32370:SF122', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN NPY2-LIKE', 253343),
(429534, 'PTHR32370:SF167', NULL, NULL, NULL, NULL, 'OS03G0609800 PROTEIN', 253343),
(429535, 'PTHR32370:SF30', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN SETH6', 253343),
(429536, 'PTHR32370:SF74', NULL, NULL, NULL, NULL, 'OS03G0205700 PROTEIN', 253343),
(429537, 'PTHR32370:SF123', NULL, NULL, NULL, NULL, 'OS01G0780600 PROTEIN', 253343),
(429538, 'PTHR32370:SF124', NULL, NULL, NULL, NULL, 'SKP1/BTB/POZ DOMAIN-CONTAINING PROTEIN-RELATED', 253343),
(429539, 'PTHR32370:SF168', NULL, NULL, NULL, NULL, 'OS06G0184500 PROTEIN', 253343),
(429540, 'PTHR32370:SF169', NULL, NULL, NULL, NULL, 'PHOTOTROPIC-RESOPONSIVE NPH3 FAMILY PROTEIN-RELATED', 253343),
(429541, 'PTHR32370', NULL, NULL, NULL, NULL, 'OS12G0117600 PROTEIN', 253343),
(429542, 'PTHR32370:SF140', NULL, NULL, NULL, NULL, 'SKP1/BTB/POZ DOMAIN, NPH3 DOMAIN PROTEIN-RELATED', 253343),
(429543, 'PTHR32370:SF138', NULL, NULL, NULL, NULL, 'BNAUNNG00030D PROTEIN', 253343),
(429544, 'PTHR32370:SF139', NULL, NULL, NULL, NULL, 'SKP1/BTB/POZ DOMAIN, NPH3 DOMAIN PROTEIN-RELATED', 253343),
(429545, 'PTHR32370:SF174', NULL, NULL, NULL, NULL, 'PHOTOTROPIC-RESPONSIVE NPH3 FAMILY PROTEIN', 253343),
(429546, 'PTHR32370:SF89', NULL, NULL, NULL, NULL, 'PHOTOTROPIC-RESPONSIVE NPH3 FAMILY PROTEIN', 253343),
(429547, 'PTHR32370:SF175', NULL, NULL, NULL, NULL, 'ROOT PHOTOTROPISM PROTEIN-RELATED', 253343),
(429548, 'PTHR32370:SF87', NULL, NULL, NULL, NULL, 'NPH3 DOMAIN-CONTAINING PROTEIN', 253343),
(429549, 'PTHR32370:SF176', NULL, NULL, NULL, NULL, 'BNAC05G01630D PROTEIN', 253343),
(429550, 'PTHR32370:SF177', NULL, NULL, NULL, NULL, 'PHOTOTROPIC-RESOPONSIVE NPH3 FAMILY PROTEIN-RELATED', 253343),
(429551, 'PTHR32370:SF133', NULL, NULL, NULL, NULL, 'SKP1/BTB/POZ DOMAIN, NPH3 DOMAIN PROTEIN-RELATED', 253343),
(429552, 'PTHR32370:SF86', NULL, NULL, NULL, NULL, 'OS03G0767600 PROTEIN', 253343),
(429553, 'PTHR32370:SF85', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN SETH6', 253343),
(429554, 'PTHR32370:SF135', NULL, NULL, NULL, NULL, 'BNAA09G07350D PROTEIN', 253343),
(429555, 'PTHR32370:SF84', NULL, NULL, NULL, NULL, 'PHOTOTROPIC-RESPONSIVE NPH3 FAMILY PROTEIN', 253343),
(429556, 'PTHR32370:SF136', NULL, NULL, NULL, NULL, 'PROTEIN BINDING / SIGNAL TRANSDUCER', 253343),
(429557, 'PTHR32370:SF83', NULL, NULL, NULL, NULL, 'ROOT PHOTOTROPISM PROTEIN', 253343),
(429558, 'PTHR35717', NULL, NULL, NULL, NULL, 'OS05G0156200 PROTEIN', 253344),
(429559, 'PTHR35717:SF1', NULL, NULL, NULL, NULL, 'OS05G0156200 PROTEIN', 253344),
(429560, 'PTHR35717:SF2', NULL, NULL, NULL, NULL, '', 253344),
(429561, 'PTHR48090:SF6', NULL, NULL, NULL, NULL, 'SLR5056 PROTEIN', 253345),
(429562, 'PTHR48090:SF7', NULL, NULL, NULL, NULL, 'RFBJ PROTEIN', 253345),
(429563, 'PTHR48090:SF1', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASES-RELATED', 253345),
(429564, 'PTHR48090:SF2', NULL, NULL, NULL, NULL, 'SLR2120 PROTEIN', 253345);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(429565, 'PTHR48090:SF3', NULL, NULL, NULL, NULL, 'UNDECAPRENYL-PHOSPHATE 4-DEOXY-4-FORMAMIDO-L-ARABINOSE TRANSFERASE', 253345),
(429566, 'PTHR48090:SF8', NULL, NULL, NULL, NULL, 'PROPHAGE BACTOPRENOL GLUCOSYL TRANSFERASE HOMOLOG', 253345),
(429567, 'PTHR48090:SF9', NULL, NULL, NULL, NULL, 'GLUCOSYL-3-PHOSPHOGLYCERATE SYNTHASE', 253345),
(429568, 'PTHR48090', NULL, NULL, NULL, NULL, 'UNDECAPRENYL-PHOSPHATE 4-DEOXY-4-FORMAMIDO-L-ARABINOSE TRANSFERASE-RELATED', 253345),
(429569, 'PTHR16088', NULL, NULL, NULL, NULL, 'YY1 ASSOCIATED PROTEIN-RELATED', 253346),
(429570, 'PTHR16088:SF3', NULL, NULL, NULL, NULL, 'GON-4-LIKE PROTEIN-RELATED', 253346),
(429571, 'PTHR33205', NULL, NULL, NULL, NULL, '', 253347),
(429572, 'PTHR33205:SF1', NULL, NULL, NULL, NULL, '', 253347),
(429573, 'PTHR38811:SF1', NULL, NULL, NULL, NULL, 'UPF0284 PROTEIN SLL1500', 253348),
(429574, 'PTHR38811', NULL, NULL, NULL, NULL, '', 253348),
(429575, 'PTHR35393:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 253349),
(429576, 'PTHR35393', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 253349),
(429577, 'PTHR15035:SF11', NULL, NULL, NULL, NULL, 'UROCORTIN', 253350),
(429578, 'PTHR15035:SF9', NULL, NULL, NULL, NULL, 'CORTICOLIBERIN', 253350),
(429579, 'PTHR15035', NULL, NULL, NULL, NULL, 'CORTICOLIBERIN/UROCORTIN', 253350),
(429580, 'PTHR35980:SF1', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE CCHAMIDE-1-RELATED', 253351),
(429581, 'PTHR35980', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE CCHAMIDE-1-RELATED', 253351),
(429582, 'PTHR48213', NULL, NULL, NULL, NULL, 'VID27-LIKE PROTEIN', 253352),
(429583, 'PTHR48213:SF1', NULL, NULL, NULL, NULL, 'PROSTATIC SPERMINE-BINDING-LIKE PROTEIN', 253352),
(429584, 'PTHR47440', NULL, NULL, NULL, NULL, 'RIKEN CDNA A430078G23 GENE', 253353),
(429585, 'PTHR47440:SF1', NULL, NULL, NULL, NULL, 'RHO/RAC GUANINE NUCLEOTIDE EXCHANGE FACTOR 18', 253353),
(429586, 'PTHR31831', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC689065', 253354),
(429587, 'PTHR31831:SF1', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC689065', 253354),
(429588, 'PTHR31780:SF15', NULL, NULL, NULL, NULL, 'STRESS RESPONSE NST1-LIKE PROTEIN', 253355),
(429589, 'PTHR31780:SF16', NULL, NULL, NULL, NULL, '', 253355),
(429590, 'PTHR31780:SF10', NULL, NULL, NULL, NULL, 'LD36051P', 253355),
(429591, 'PTHR31780', NULL, NULL, NULL, NULL, 'STRESS RESPONSE PROTEIN NST1-RELATED', 253355),
(429592, 'PTHR45898:SF13', NULL, NULL, NULL, NULL, 'TOM1-LIKE PROTEIN 7', 253356),
(429593, 'PTHR45898:SF12', NULL, NULL, NULL, NULL, 'TOM1-LIKE PROTEIN 3', 253356),
(429594, 'PTHR45898', NULL, NULL, NULL, NULL, 'TOM1-LIKE PROTEIN', 253356),
(429595, 'PTHR45898:SF23', NULL, NULL, NULL, NULL, 'OS06G0332400 PROTEIN', 253356),
(429596, 'PTHR45898:SF10', NULL, NULL, NULL, NULL, 'TARGET OF MYB PROTEIN 1-LIKE ISOFORM X1', 253356),
(429597, 'PTHR45898:SF21', NULL, NULL, NULL, NULL, 'ENTH/VHS, TARGET OF MYB PROTEIN 1-RELATED', 253356),
(429598, 'PTHR45898:SF4', NULL, NULL, NULL, NULL, 'TARGET OF MYB PROTEIN 1', 253356),
(429599, 'PTHR45898:SF3', NULL, NULL, NULL, NULL, 'TOM1-LIKE PROTEIN 5', 253356),
(429600, 'PTHR45898:SF2', NULL, NULL, NULL, NULL, 'TOM1-LIKE PROTEIN 6', 253356),
(429601, 'PTHR45898:SF18', NULL, NULL, NULL, NULL, '', 253356),
(429602, 'PTHR45898:SF28', NULL, NULL, NULL, NULL, 'ENTH/VHS/GAT FAMILY PROTEIN', 253356),
(429603, 'PTHR45898:SF17', NULL, NULL, NULL, NULL, 'BNAA03G52190D PROTEIN', 253356),
(429604, 'PTHR45898:SF16', NULL, NULL, NULL, NULL, 'BNAA02G33830D PROTEIN', 253356),
(429605, 'PTHR45898:SF27', NULL, NULL, NULL, NULL, 'GAT DOMAIN, ENTH/VHS-RELATED', 253356),
(429606, 'PTHR45898:SF26', NULL, NULL, NULL, NULL, 'BNAA07G37280D PROTEIN', 253356),
(429607, 'PTHR45898:SF14', NULL, NULL, NULL, NULL, 'TOM1-LIKE PROTEIN 4', 253356),
(429608, 'PTHR45898:SF25', NULL, NULL, NULL, NULL, 'ENTH/VHS/GAT FAMILY PROTEIN', 253356),
(429609, 'PTHR45898:SF8', NULL, NULL, NULL, NULL, 'OS01G0825700 PROTEIN', 253356),
(429610, 'PTHR45898:SF7', NULL, NULL, NULL, NULL, 'OS01G0229200 PROTEIN', 253356),
(429611, 'PTHR45898:SF6', NULL, NULL, NULL, NULL, 'OS05G0475300 PROTEIN', 253356);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(429612, 'PTHR45898:SF9', NULL, NULL, NULL, NULL, 'TOM1-LIKE PROTEIN 8', 253356),
(429613, 'PTHR39186:SF1', NULL, NULL, NULL, NULL, 'DUF2071 FAMILY PROTEIN', 253357),
(429614, 'PTHR39186', NULL, NULL, NULL, NULL, 'DUF2071 FAMILY PROTEIN', 253357),
(429615, 'PTHR24127', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND EF-HAND DOMAIN-CONTAINING PROTEIN 1', 253358),
(429616, 'PTHR24127:SF1', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND EF-HAND DOMAIN-CONTAINING PROTEIN 1', 253358),
(429617, 'PTHR34390', NULL, NULL, NULL, NULL, 'UPF0442 PROTEIN YJJB-RELATED', 253359),
(429618, 'PTHR34390:SF2', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YJJP', 253359),
(429619, 'PTHR34390:SF1', NULL, NULL, NULL, NULL, 'UPF0442 PROTEIN YJJB', 253359),
(429620, 'PTHR13169:SF18', NULL, NULL, NULL, NULL, 'MEMBRANE-ANCHORED UBIQUITIN-FOLD PROTEIN', 253360),
(429621, 'PTHR13169:SF19', NULL, NULL, NULL, NULL, 'MEMBRANE-ANCHORED UBIQUITIN-FOLD PROTEIN', 253360),
(429622, 'PTHR13169:SF9', NULL, NULL, NULL, NULL, 'MEMBRANE-ANCHORED UBIQUITIN-FOLD PROTEIN 2', 253360),
(429623, 'PTHR13169:SF25', NULL, NULL, NULL, NULL, 'MEMBRANE-ANCHORED UBIQUITIN-FOLD PROTEIN', 253360),
(429624, 'PTHR13169:SF26', NULL, NULL, NULL, NULL, 'MEMBRANE-ANCHORED UBIQUITIN-FOLD PROTEIN 2', 253360),
(429625, 'PTHR13169:SF15', NULL, NULL, NULL, NULL, 'MEMBRANE-ANCHORED UBIQUITIN-FOLD PROTEIN 5', 253360),
(429626, 'PTHR13169:SF16', NULL, NULL, NULL, NULL, 'RAD60-SLD_2 DOMAIN-CONTAINING PROTEIN', 253360),
(429627, 'PTHR13169:SF17', NULL, NULL, NULL, NULL, 'MEMBRANE-ANCHORED UBIQUITIN-FOLD PROTEIN', 253360),
(429628, 'PTHR13169:SF10', NULL, NULL, NULL, NULL, 'MEMBRANE-ANCHORED UBIQUITIN-FOLD PROTEIN 1', 253360),
(429629, 'PTHR13169:SF21', NULL, NULL, NULL, NULL, 'MEMBRANE-ANCHORED UBIQUITIN-FOLD PROTEIN', 253360),
(429630, 'PTHR13169:SF11', NULL, NULL, NULL, NULL, 'MEMBRANE-ANCHORED UBIQUITIN-FOLD PROTEIN', 253360),
(429631, 'PTHR13169:SF22', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE PROTEIN', 253360),
(429632, 'PTHR13169:SF3', NULL, NULL, NULL, NULL, 'MEMBRANE-ANCHORED UBIQUITIN-FOLD PROTEIN 3', 253360),
(429633, 'PTHR13169:SF12', NULL, NULL, NULL, NULL, 'MEMBRANE-ANCHORED UBIQUITIN-FOLD PROTEIN', 253360),
(429634, 'PTHR13169:SF2', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE PROTEIN', 253360),
(429635, 'PTHR13169:SF24', NULL, NULL, NULL, NULL, 'MEMBRANE-ANCHORED UBIQUITIN-FOLD PROTEIN', 253360),
(429636, 'PTHR13169:SF1', NULL, NULL, NULL, NULL, 'MEMBRANE-ANCHORED UBIQUITIN-FOLD PROTEIN 4', 253360),
(429637, 'PTHR13169:SF0', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE PROTEIN 3', 253360),
(429638, 'PTHR13169', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE PROTEIN 3  HCG-1 PROTEIN', 253360),
(429639, 'PTHR13169:SF20', NULL, NULL, NULL, NULL, 'RAD60-SLD_2 DOMAIN-CONTAINING PROTEIN', 253360),
(429640, 'PTHR12707', NULL, NULL, NULL, NULL, 'PINN', 253361),
(429641, 'PTHR12707:SF0', NULL, NULL, NULL, NULL, 'PININ', 253361),
(429642, 'PTHR15192:SF4', NULL, NULL, NULL, NULL, 'OXIDATIVE STRESS-INDUCED GROWTH INHIBITOR 2', 253362),
(429643, 'PTHR15192', NULL, NULL, NULL, NULL, 'PROTEIN CBG05349', 253362),
(429644, 'PTHR15192:SF15', NULL, NULL, NULL, NULL, 'OXIDATIVE STRESS-INDUCED GROWTH INHIBITOR 1', 253362),
(429645, 'PTHR15192:SF8', NULL, NULL, NULL, NULL, 'L-ORNITHINE N(5)-MONOOXYGENASE', 253362),
(429646, 'PTHR12814', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN NOB1', 253363),
(429647, 'PTHR12814:SF3', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN NOB1', 253363),
(429648, 'PTHR12814:SF2', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN NOB1', 253363),
(429649, 'PTHR12814:SF6', NULL, NULL, NULL, NULL, '', 253363),
(429650, 'PTHR16236:SF0', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 160', 253364),
(429651, 'PTHR16236', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 160', 253364),
(429652, 'PTHR38488:SF1', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE 9.5 KDA SUBUNIT, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G08980)-RELATED', 253365),
(429653, 'PTHR38488', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE 9.5 KDA SUBUNIT, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G08980)-RELATED', 253365),
(429654, 'PTHR34284:SF1', NULL, NULL, NULL, NULL, 'FG-GAP REPEAT-CONTAINING PROTEIN', 253366);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(429655, 'PTHR34284', NULL, NULL, NULL, NULL, 'FG-GAP REPEAT-CONTAINING PROTEIN', 253366),
(429656, 'PTHR47314:SF2', NULL, NULL, NULL, NULL, 'GALACTOOLIGOSACCHARIDES TRANSPORT SYSTEM PERMEASE PROTEIN GANP', 253367),
(429657, 'PTHR47314:SF1', NULL, NULL, NULL, NULL, 'MALTOSE/MALTODEXTRIN TRANSPORT SYSTEM PERMEASE PROTEIN MALF', 253367),
(429658, 'PTHR47314', NULL, NULL, NULL, NULL, 'MALTOSE/MALTODEXTRIN TRANSPORT SYSTEM PERMEASE PROTEIN MALF', 253367),
(429659, 'PTHR43000:SF4', NULL, NULL, NULL, NULL, 'STEROL-4-ALPHA-CARBOXYLATE 3-DEHYDROGENASE, DECARBOXYLATING', 253368),
(429660, 'PTHR43000:SF2', NULL, NULL, NULL, NULL, 'BLR5989 PROTEIN', 253368),
(429661, 'PTHR43000:SF7', NULL, NULL, NULL, NULL, 'DTDP-D-GLUCOSE 4,6-DEHYDRATASE', 253368),
(429662, 'PTHR43000:SF18', NULL, NULL, NULL, NULL, 'RHM1', 253368),
(429663, 'PTHR43000', NULL, NULL, NULL, NULL, 'DTDP-D-GLUCOSE 4,6-DEHYDRATASE-RELATED', 253368),
(429664, 'PTHR43000:SF1', NULL, NULL, NULL, NULL, 'REDUCTASE-RELATED', 253368),
(429665, 'PTHR43000:SF41', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING DOMAIN, RMLD-LIKE SUBSTRATE BINDING DOMAIN PROTEIN-RELATED', 253368),
(429666, 'PTHR43000:SF37', NULL, NULL, NULL, NULL, 'NUCLEOSIDE-DIPHOSPHATE-SUGAR EPIMERASE', 253368),
(429667, 'PTHR43000:SF48', NULL, NULL, NULL, NULL, 'GDP-6-DEOXY-D-MANNOSE REDUCTASE', 253368),
(429668, 'PTHR43000:SF35', NULL, NULL, NULL, NULL, 'TRIFUNCTIONAL UDP-GLUCOSE 4,6-DEHYDRATASE/UDP-4-KETO-6-DEOXY-D-GLUCOSE 3,5-EPIMERASE/UDP-4-KETO-L-RHAMNOSE-REDUCTASE RHM2', 253368),
(429669, 'PTHR43000:SF24', NULL, NULL, NULL, NULL, 'TRIFUNCTIONAL UDP-GLUCOSE 4,6-DEHYDRATASE/UDP-4-KETO-6-DEOXY-D-GLUCOSE 3,5-EPIMERASE/UDP-4-KETO-L-RHAMNOSE-REDUCTASE RHM1', 253368),
(429670, 'PTHR43000:SF46', NULL, NULL, NULL, NULL, 'SALMON SILKS1', 253368),
(429671, 'PTHR43000:SF47', NULL, NULL, NULL, NULL, 'DTDP-GLUCOSE 4,6-DEHYDRATASE 2', 253368),
(429672, 'PTHR43000:SF44', NULL, NULL, NULL, NULL, 'TRIFUNCTIONAL UDP-GLUCOSE 4,6-DEHYDRATASE/UDP-4-KETO-6-DEOXY-D-GLUCOSE 3,5-EPIMERASE/UDP-4-KETO-L-RHAMNOSE-REDUCTASE RHM3', 253368),
(429673, 'PTHR43000:SF22', NULL, NULL, NULL, NULL, 'TRIFUNCTIONAL UDP-GLUCOSE 4,6-DEHYDRATASE/UDP-4-KETO-6-DEOXY-D-GLUCOSE 3,5-EPIMERASE/UDP-4-KETO-L-RHAMNOSE-REDUCTASE RHM3-LIKE', 253368),
(429674, 'PTHR43000:SF33', NULL, NULL, NULL, NULL, 'CDP-TYVELOSE EPIMERASE', 253368),
(429675, 'PTHR43000:SF45', NULL, NULL, NULL, NULL, 'BNAA06G11470D PROTEIN', 253368),
(429676, 'PTHR43000:SF23', NULL, NULL, NULL, NULL, 'BNAA05G14410D PROTEIN', 253368),
(429677, 'PTHR43000:SF12', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING PROTEIN YBJT-RELATED', 253368),
(429678, 'PTHR43000:SF31', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 253368),
(429679, 'PTHR43000:SF42', NULL, NULL, NULL, NULL, 'RHAMNOSE BIOSYNTHETIC-LIKE ENZYME', 253368),
(429680, 'PTHR43000:SF10', NULL, NULL, NULL, NULL, 'UDP-SULFOQUINOVOSE SYNTHASE, CHLOROPLASTIC', 253368),
(429681, 'PTHR43000:SF32', NULL, NULL, NULL, NULL, 'TRIFUNCTIONAL UDP-GLUCOSE 4,6-DEHYDRATASE/UDP-4-KETO-6-DEOXY-D-GLUCOSE 3,5-EPIMERASE/UDP-4-KETO-L-RHAMNOSE-REDUCTASE RHM1-LIKE', 253368),
(429682, 'PTHR43000:SF43', NULL, NULL, NULL, NULL, 'NAD(P)-BD_DOM DOMAIN-CONTAINING PROTEIN', 253368),
(429683, 'PTHR13192:SF2', NULL, NULL, NULL, NULL, 'ZGC:92335', 253369),
(429684, 'PTHR13192', NULL, NULL, NULL, NULL, 'MY011 PROTEIN', 253369),
(429685, 'PTHR13192:SF3', NULL, NULL, NULL, NULL, 'COBALAMIN TRAFFICKING PROTEIN CBLD', 253369),
(429686, 'PTHR34065', NULL, NULL, NULL, NULL, 'CELL DIVISION CONTROL PROTEIN 14', 253370),
(429687, 'PTHR34065:SF2', NULL, NULL, NULL, NULL, 'OS10G0520900 PROTEIN', 253370),
(429688, 'PTHR34065:SF1', NULL, NULL, NULL, NULL, 'CELL DIVISION CONTROL PROTEIN 14', 253370),
(429689, 'PTHR47430:SF4', NULL, NULL, NULL, NULL, 'GB|AAC33480.1', 253371),
(429690, 'PTHR47430:SF3', NULL, NULL, NULL, NULL, 'CYCLIN-D-BINDING MYB-LIKE TRANSCRIPTION FACTOR 1', 253371),
(429691, 'PTHR47430', NULL, NULL, NULL, NULL, 'GB|AAC33480.1', 253371),
(429692, 'PTHR47170', NULL, NULL, NULL, NULL, 'MALONYL-COA ACP TRANSACYLASE, ACP-BINDING', 253372);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(429693, 'PTHR47170:SF5', NULL, NULL, NULL, NULL, '[ACYL-CARRIER-PROTEIN] S-MALONYLTRANSFERASE', 253372),
(429694, 'PTHR47170:SF2', NULL, NULL, NULL, NULL, '[ACYL-CARRIER-PROTEIN] S-MALONYLTRANSFERASE', 253372),
(429695, 'PTHR22794:SF2', NULL, NULL, NULL, NULL, 'THAP DOMAIN-CONTAINING PROTEIN 11', 253373),
(429696, 'PTHR22794', NULL, NULL, NULL, NULL, 'THAP DOMAIN PROTEIN 11', 253373),
(429697, 'PTHR36802', NULL, NULL, NULL, NULL, 'OS02G0815400 PROTEIN', 253374),
(429698, 'PTHR36802:SF1', NULL, NULL, NULL, NULL, 'OS02G0815400 PROTEIN', 253374),
(429699, 'PTHR36117:SF3', NULL, NULL, NULL, NULL, '4-HYDROXYPHENYLACETATE 3-MONOOXYGENASE-RELATED', 253375),
(429700, 'PTHR36117', NULL, NULL, NULL, NULL, '4-HYDROXYPHENYLACETATE 3-MONOOXYGENASE-RELATED', 253375),
(429701, 'PTHR11489:SF30', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN SA-1', 253376),
(429702, 'PTHR11489:SF21', NULL, NULL, NULL, NULL, '40S_SA_C DOMAIN-CONTAINING PROTEIN', 253376),
(429703, 'PTHR11489:SF31', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN SA', 253376),
(429704, 'PTHR11489:SF20', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN SA', 253376),
(429705, 'PTHR11489:SF9', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN SA', 253376),
(429706, 'PTHR11489:SF25', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN SA', 253376),
(429707, 'PTHR11489', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN SA', 253376),
(429708, 'PTHR11489:SF24', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN SA', 253376),
(429709, 'PTHR11489:SF29', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN SA', 253376),
(429710, 'PTHR11489:SF28', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN SA', 253376),
(429711, 'PTHR11489:SF17', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN SA', 253376),
(429712, 'PTHR37444:SF3', NULL, NULL, NULL, NULL, 'GALACTOSYLGALACTOSYLXYLOSYLPROTEIN 3-BETA-GLUCURONOSYLTRANSFERASE', 253377),
(429713, 'PTHR37444:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG20614', 253377),
(429714, 'PTHR37444:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG24900', 253377),
(429715, 'PTHR37444', NULL, NULL, NULL, NULL, 'PROTEIN CBG24900-RELATED', 253377),
(429716, 'PTHR10105', NULL, NULL, NULL, NULL, 'SELENOPROTEIN P', 253378),
(429717, 'PTHR10105:SF4', NULL, NULL, NULL, NULL, 'SELENOPROTEIN PB', 253378),
(429718, 'PTHR10105:SF2', NULL, NULL, NULL, NULL, 'AGAP003297-PA', 253378),
(429719, 'PTHR10105:SF3', NULL, NULL, NULL, NULL, 'SELENOPROTEIN P', 253378),
(429720, 'PTHR48068:SF7', NULL, NULL, NULL, NULL, '', 253379),
(429721, 'PTHR48068:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 9B', 253379),
(429722, 'PTHR48068:SF6', NULL, NULL, NULL, NULL, '', 253379),
(429723, 'PTHR48068:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 9', 253379),
(429724, 'PTHR48068:SF4', NULL, NULL, NULL, NULL, 'TAF9 RNA POLYMERASE II, TATA BOX-BINDING PROTEIN (TBP)-ASSOCIATED FACTOR', 253379),
(429725, 'PTHR48068', NULL, NULL, NULL, NULL, 'TAF9 RNA POLYMERASE II, TATA BOX-BINDING PROTEIN (TBP)-ASSOCIATED FACTOR', 253379),
(429726, 'PTHR48068:SF1', NULL, NULL, NULL, NULL, '', 253379),
(429727, 'PTHR48068:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 9', 253379),
(429728, 'PTHR24030', NULL, NULL, NULL, NULL, 'PROTEIN CMSS1', 253380),
(429729, 'PTHR24030:SF0', NULL, NULL, NULL, NULL, 'PROTEIN CMSS1', 253380),
(429730, 'PTHR34543:SF8', NULL, NULL, NULL, NULL, 'NEOXANTHIN SYNTHASE', 253381),
(429731, 'PTHR34543:SF9', NULL, NULL, NULL, NULL, 'NEOXANTHIN SYNTHASE', 253381),
(429732, 'PTHR34543:SF10', NULL, NULL, NULL, NULL, 'NEOXANTHIN SYNTHASE', 253381),
(429733, 'PTHR34543:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ABA DEFICIENT 4, CHLOROPLASTIC', 253381),
(429734, 'PTHR34543', NULL, NULL, NULL, NULL, 'PROTEIN ABA DEFICIENT 4, CHLOROPLASTIC', 253381),
(429735, 'PTHR36867', NULL, NULL, NULL, NULL, 'MCG131172, ISOFORM CRA_A', 253382),
(429736, 'PTHR36867:SF1', NULL, NULL, NULL, NULL, 'RIKEN CDNA 2610318N02 GENE', 253382),
(429737, 'PTHR47378:SF1', NULL, NULL, NULL, NULL, 'DIVINYL CHLOROPHYLLIDE A 8-VINYL-REDUCTASE, CHLOROPLASTIC', 253383);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(429738, 'PTHR47378', NULL, NULL, NULL, NULL, 'DIVINYL CHLOROPHYLLIDE A 8-VINYL-REDUCTASE, CHLOROPLASTIC', 253383),
(429739, 'PTHR37433:SF4', NULL, NULL, NULL, NULL, 'LU (LY6 UROKINASE PLASMINOGEN) DOMAIN RECEPTOR-RELATED PROTEIN-RELATED', 253384),
(429740, 'PTHR37433:SF17', NULL, NULL, NULL, NULL, 'UPAR/LY6 DOMAIN-CONTAINING PROTEIN', 253384),
(429741, 'PTHR37433:SF6', NULL, NULL, NULL, NULL, 'PROTEIN CBG01446', 253384),
(429742, 'PTHR37433:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG03432', 253384),
(429743, 'PTHR37433:SF19', NULL, NULL, NULL, NULL, 'ACTIVIN_RECP DOMAIN-CONTAINING PROTEIN', 253384),
(429744, 'PTHR37433', NULL, NULL, NULL, NULL, 'PROTEIN CBG25136-RELATED', 253384),
(429745, 'PTHR37433:SF15', NULL, NULL, NULL, NULL, 'PROTEIN CBG04492', 253384),
(429746, 'PTHR37433:SF20', NULL, NULL, NULL, NULL, 'PROTEIN CBG08578', 253384),
(429747, 'PTHR37433:SF11', NULL, NULL, NULL, NULL, 'PROTEIN CBG16245', 253384),
(429748, 'PTHR28026:SF2', NULL, NULL, NULL, NULL, '', 253385),
(429749, 'PTHR28026:SF9', NULL, NULL, NULL, NULL, '2-HYDROXY-PALMITIC ACID DIOXYGENASE MPO1', 253385),
(429750, 'PTHR28026:SF8', NULL, NULL, NULL, NULL, 'YGL010W-LIKE PROTEIN', 253385),
(429751, 'PTHR28026:SF11', NULL, NULL, NULL, NULL, 'BNAA08G31290D PROTEIN', 253385),
(429752, 'PTHR28026:SF5', NULL, NULL, NULL, NULL, 'OS08G0433600 PROTEIN', 253385),
(429753, 'PTHR28026', NULL, NULL, NULL, NULL, 'DUF962 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_8G05310)', 253385),
(429754, 'PTHR28026:SF10', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN, PUTATIVE (DUF962)-RELATED', 253385),
(429755, 'PTHR10226:SF8', NULL, NULL, NULL, NULL, 'A-KINASE ANCHOR PROTEIN 4', 253386),
(429756, 'PTHR10226:SF9', NULL, NULL, NULL, NULL, 'A-KINASE ANCHOR PROTEIN 3', 253386),
(429757, 'PTHR10226', NULL, NULL, NULL, NULL, 'A KINASE ANCHOR PROTEIN', 253386),
(429758, 'PTHR10226:SF7', NULL, NULL, NULL, NULL, 'A-KINASE ANCHOR PROTEIN SPHKAP', 253386),
(429759, 'PTHR10226:SF3', NULL, NULL, NULL, NULL, 'A-KINASE ANCHOR PROTEIN 11', 253386),
(429760, 'PTHR46074', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH PROTEIN CRIP FAMILY MEMBER', 253387),
(429761, 'PTHR46074:SF2', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH PROTEIN 2', 253387),
(429762, 'PTHR46074:SF3', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH PROTEIN 1', 253387),
(429763, 'PTHR46074:SF4', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH PROTEIN 3', 253387),
(429764, 'PTHR46074:SF5', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING PROTEIN C', 253387),
(429765, 'PTHR13344:SF2', NULL, NULL, NULL, NULL, 'CHCH-RELATED', 253388),
(429766, 'PTHR13344:SF0', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX SUBUNIT 8', 253388),
(429767, 'PTHR13344:SF1', NULL, NULL, NULL, NULL, 'COX19-LIKE CHCH FAMILY PROTEIN-RELATED', 253388),
(429768, 'PTHR13344', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE', 253388),
(429769, 'PTHR45753:SF2', NULL, NULL, NULL, NULL, 'ORNITHINE CARBAMOYLTRANSFERASE', 253389),
(429770, 'PTHR45753:SF1', NULL, NULL, NULL, NULL, 'ORNITHINE CARBAMOYLTRANSFERASE, CATABOLIC', 253389),
(429771, 'PTHR45753:SF6', NULL, NULL, NULL, NULL, 'ASPARTATE CARBAMOYLTRANSFERASE', 253389),
(429772, 'PTHR45753:SF5', NULL, NULL, NULL, NULL, 'ORNITHINE CARBAMOYLTRANSFERASE', 253389),
(429773, 'PTHR45753:SF4', NULL, NULL, NULL, NULL, 'ORNITHINE CARBAMOYLTRANSFERASE SUBUNIT F-RELATED', 253389),
(429774, 'PTHR45753:SF3', NULL, NULL, NULL, NULL, 'ORNITHINE TRANSCARBAMYLASE, MITOCHONDRIAL', 253389),
(429775, 'PTHR45753', NULL, NULL, NULL, NULL, 'ORNITHINE CARBAMOYLTRANSFERASE, MITOCHONDRIAL', 253389),
(429776, 'PTHR47081', NULL, NULL, NULL, NULL, '', 253390),
(429777, 'PTHR47081:SF1', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING X-LINKED PROTEIN 4', 253390),
(429778, 'PTHR47081:SF2', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING X-LINKED PROTEIN 5', 253390),
(429779, 'PTHR47081:SF3', NULL, NULL, NULL, NULL, '', 253390),
(429780, 'PTHR47204', NULL, NULL, NULL, NULL, 'OS02G0168900 PROTEIN', 253391),
(429781, 'PTHR47204:SF1', NULL, NULL, NULL, NULL, 'OS02G0168900 PROTEIN', 253391),
(429782, 'PTHR12683:SF13', NULL, NULL, NULL, NULL, 'CDK-ACTIVATING KINASE ASSEMBLY FACTOR MAT1', 253392);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(429783, 'PTHR12683:SF14', NULL, NULL, NULL, NULL, 'MAT1 DOMAIN-CONTAINING PROTEIN', 253392),
(429784, 'PTHR12683:SF10', NULL, NULL, NULL, NULL, 'OS09G0423300 PROTEIN', 253392),
(429785, 'PTHR12683', NULL, NULL, NULL, NULL, 'CDK-ACTIVATING KINASE ASSEMBLY FACTOR MAT1', 253392),
(429786, 'PTHR14649', NULL, NULL, NULL, NULL, 'ZINC FINGER C2HC DOMAIN-CONTAINING PROTEIN 1C', 253393),
(429787, 'PTHR14649:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER C2HC DOMAIN-CONTAINING PROTEIN 1C', 253393),
(429788, 'PTHR42720:SF1', NULL, NULL, NULL, NULL, 'ANAEROBIC GLYCEROL-3-PHOSPHATE DEHYDROGENASE PROTEIN-RELATED', 253394),
(429789, 'PTHR42720', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE DEHYDROGENASE', 253394),
(429790, 'PTHR22602', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 253395),
(429791, 'PTHR22602:SF0', NULL, NULL, NULL, NULL, 'TRANSFERASE CAF17, MITOCHONDRIAL-RELATED', 253395),
(429792, 'PTHR46880:SF3', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 862', 253396),
(429793, 'PTHR46880:SF10', NULL, NULL, NULL, NULL, 'DIMER_TNP_HAT DOMAIN-CONTAINING PROTEIN', 253396),
(429794, 'PTHR46880:SF11', NULL, NULL, NULL, NULL, 'PR/SET DOMAIN 11', 253396),
(429795, 'PTHR46880', NULL, NULL, NULL, NULL, 'RAS-ASSOCIATING DOMAIN-CONTAINING PROTEIN', 253396),
(429796, 'PTHR46880:SF9', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', 253396),
(429797, 'PTHR46880:SF8', NULL, NULL, NULL, NULL, 'E3 SUMO-PROTEIN LIGASE KIAA1586', 253396),
(429798, 'PTHR46880:SF6', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN C17ORF113', 253396),
(429799, 'PTHR46880:SF5', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', 253396),
(429800, 'PTHR21089:SF30', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL 3-DEHYDROQUINATE DEHYDRATASE/SHIKIMATE DEHYDROGENASE CHLOROPLASTIC', 253397),
(429801, 'PTHR21089:SF9', NULL, NULL, NULL, NULL, 'SHIKIMATE DEHYDROGENASE-LIKE PROTEIN HI_0607', 253397),
(429802, 'PTHR21089:SF29', NULL, NULL, NULL, NULL, 'SHIKIMATE DEHYDROGENASE', 253397),
(429803, 'PTHR21089:SF26', NULL, NULL, NULL, NULL, 'AROM POLYPEPTIDE, PUTATIVE-RELATED', 253397),
(429804, 'PTHR21089:SF7', NULL, NULL, NULL, NULL, 'SHIKIMATE DEHYDROGENASE', 253397),
(429805, 'PTHR21089:SF1', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL 3-DEHYDROQUINATE DEHYDRATASE/SHIKIMATE DEHYDROGENASE, CHLOROPLASTIC', 253397),
(429806, 'PTHR21089:SF12', NULL, NULL, NULL, NULL, 'SHIKIMATE DEHYDROGENASE', 253397),
(429807, 'PTHR21089:SF33', NULL, NULL, NULL, NULL, 'SHIKIMATE DEHYDROGENASE', 253397),
(429808, 'PTHR21089:SF11', NULL, NULL, NULL, NULL, 'OS01G0375500 PROTEIN', 253397),
(429809, 'PTHR21089', NULL, NULL, NULL, NULL, 'SHIKIMATE DEHYDROGENASE', 253397),
(429810, 'PTHR21089:SF10', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL 3-DEHYDROQUINATE DEHYDRATASE/SHIKIMATE DEHYDROGENASE, CHLOROPLASTIC-LIKE', 253397),
(429811, 'PTHR21089:SF32', NULL, NULL, NULL, NULL, 'SHIKIMATE DEHYDROGENASE', 253397),
(429812, 'PTHR31251:SF127', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, SBP-BOX-RELATED', 253398),
(429813, 'PTHR31251:SF124', NULL, NULL, NULL, NULL, 'SBP-TYPE DOMAIN-CONTAINING PROTEIN', 253398),
(429814, 'PTHR31251:SF125', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, SBP-BOX-RELATED', 253398),
(429815, 'PTHR31251:SF169', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN 13A-RELATED', 253398),
(429816, 'PTHR31251:SF167', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, SBP-BOX-RELATED', 253398),
(429817, 'PTHR31251:SF160', NULL, NULL, NULL, NULL, 'SBP-TYPE DOMAIN-CONTAINING PROTEIN', 253398),
(429818, 'PTHR31251:SF161', NULL, NULL, NULL, NULL, 'SBP-TYPE DOMAIN-CONTAINING PROTEIN', 253398),
(429819, 'PTHR31251:SF98', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN 15', 253398),
(429820, 'PTHR31251:SF59', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN 17', 253398),
(429821, 'PTHR31251:SF95', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN 10', 253398),
(429822, 'PTHR31251:SF93', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SBP FAMILY-RELATED', 253398),
(429823, 'PTHR31251:SF117', NULL, NULL, NULL, NULL, 'SBP-TYPE DOMAIN-CONTAINING PROTEIN', 253398);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(429824, 'PTHR31251:SF159', NULL, NULL, NULL, NULL, 'SBP-BOX 2', 253398),
(429825, 'PTHR31251:SF157', NULL, NULL, NULL, NULL, 'SBP-TYPE DOMAIN-CONTAINING PROTEIN', 253398),
(429826, 'PTHR31251:SF114', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN 10', 253398),
(429827, 'PTHR31251:SF155', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN 14', 253398),
(429828, 'PTHR31251:SF7', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN 11', 253398),
(429829, 'PTHR31251:SF110', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN 16', 253398),
(429830, 'PTHR31251:SF196', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN 15', 253398),
(429831, 'PTHR31251:SF195', NULL, NULL, NULL, NULL, 'SBP-DOMAIN PROTEIN 5', 253398),
(429832, 'PTHR31251:SF194', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN', 253398),
(429833, 'PTHR31251:SF193', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN 14', 253398),
(429834, 'PTHR31251', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN 4', 253398),
(429835, 'PTHR31251:SF108', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN 7', 253398),
(429836, 'PTHR31251:SF106', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN 2', 253398),
(429837, 'PTHR31251:SF105', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN 5', 253398),
(429838, 'PTHR31251:SF146', NULL, NULL, NULL, NULL, 'SBP-TYPE DOMAIN-CONTAINING PROTEIN', 253398),
(429839, 'PTHR31251:SF102', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN 13A ISOFORM X1', 253398),
(429840, 'PTHR31251:SF147', NULL, NULL, NULL, NULL, 'SBP-TYPE DOMAIN-CONTAINING PROTEIN', 253398),
(429841, 'PTHR31251:SF189', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN 1 ISOFORM X1', 253398),
(429842, 'PTHR31251:SF188', NULL, NULL, NULL, NULL, '1 PROTEIN, PUTATIVE-RELATED', 253398),
(429843, 'PTHR31251:SF145', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN 11', 253398),
(429844, 'PTHR31251:SF187', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, SBP-BOX-RELATED', 253398),
(429845, 'PTHR31251:SF186', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN 19-RELATED', 253398),
(429846, 'PTHR31251:SF185', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN 12 ISOFORM X1', 253398),
(429847, 'PTHR31251:SF140', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN 9', 253398),
(429848, 'PTHR31251:SF184', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN 4', 253398),
(429849, 'PTHR31251:SF183', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER BINDING PROTEIN NTABSPL6-1', 253398),
(429850, 'PTHR31251:SF182', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN 5', 253398),
(429851, 'PTHR31251:SF192', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN', 253398),
(429852, 'PTHR31251:SF33', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN 16', 253398),
(429853, 'PTHR31251:SF191', NULL, NULL, NULL, NULL, 'SBP-TYPE DOMAIN-CONTAINING PROTEIN', 253398),
(429854, 'PTHR31251:SF190', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SBP FAMILY-RELATED', 253398),
(429855, 'PTHR31251:SF74', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN 2', 253398),
(429856, 'PTHR31251:SF75', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN 8', 253398),
(429857, 'PTHR31251:SF137', NULL, NULL, NULL, NULL, 'SBP-TYPE DOMAIN-CONTAINING PROTEIN', 253398),
(429858, 'PTHR31251:SF135', NULL, NULL, NULL, NULL, 'SBP-TYPE DOMAIN-CONTAINING PROTEIN', 253398),
(429859, 'PTHR31251:SF179', NULL, NULL, NULL, NULL, 'SBP-TYPE DOMAIN-CONTAINING PROTEIN', 253398),
(429860, 'PTHR31251:SF177', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN 18', 253398),
(429861, 'PTHR31251:SF131', NULL, NULL, NULL, NULL, 'SBP-TYPE DOMAIN-CONTAINING PROTEIN', 253398),
(429862, 'PTHR31251:SF132', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN 1-RELATED', 253398),
(429863, 'PTHR31251:SF175', NULL, NULL, NULL, NULL, 'SBP TRANSCRIPTION FACTOR', 253398);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(429864, 'PTHR31251:SF181', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING PROTEIN 1-LIKE', 253398),
(429865, 'PTHR31251:SF180', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN 6', 253398),
(429866, 'PTHR31251:SF86', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN 1', 253398),
(429867, 'PTHR31251:SF81', NULL, NULL, NULL, NULL, 'SBP-TYPE DOMAIN-CONTAINING PROTEIN', 253398),
(429868, 'PTHR13707:SF28', NULL, NULL, NULL, NULL, 'SUCCINYL-COA:3-KETOACID COENZYME A TRANSFERASE 2, MITOCHONDRIAL', 253399),
(429869, 'PTHR13707', NULL, NULL, NULL, NULL, 'KETOACID-COENZYME A TRANSFERASE', 253399),
(429870, 'PTHR13707:SF23', NULL, NULL, NULL, NULL, 'SUCCINYL-COA:3-KETOACID-COENZYME A TRANSFERASE', 253399),
(429871, 'PTHR13707:SF57', NULL, NULL, NULL, NULL, 'SUCCINYL-COA:3-KETOACID COENZYME A TRANSFERASE SUBUNIT B-RELATED', 253399),
(429872, 'PTHR13707:SF58', NULL, NULL, NULL, NULL, 'SUCCINYL-COA:3-KETOACID-COENZYME A TRANSFERASE', 253399),
(429873, 'PTHR13707:SF59', NULL, NULL, NULL, NULL, 'SUCCINYL-COA:3-KETOACID COENZYME A TRANSFERASE SUBUNIT B-RELATED', 253399),
(429874, 'PTHR13707:SF30', NULL, NULL, NULL, NULL, 'SUCCINYL-COA:3-KETOACID COENZYME A TRANSFERASE 1, MITOCHONDRIAL', 253399),
(429875, 'PTHR13707:SF53', NULL, NULL, NULL, NULL, 'SUCCINYL-COA:3-KETOACID-COENZYME A TRANSFERASE', 253399),
(429876, 'PTHR46952:SF2', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN', 253400),
(429877, 'PTHR46952:SF1', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN', 253400),
(429878, 'PTHR46952:SF5', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN', 253400),
(429879, 'PTHR46952:SF3', NULL, NULL, NULL, NULL, '7TM_GPCR_SRX DOMAIN-CONTAINING PROTEIN', 253400),
(429880, 'PTHR46952', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS X-RELATED', 253400),
(429881, 'PTHR46398:SF8', NULL, NULL, NULL, NULL, '', 253401),
(429882, 'PTHR46398:SF7', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 253401),
(429883, 'PTHR46398:SF4', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 253401),
(429884, 'PTHR46398:SF5', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 253401),
(429885, 'PTHR46398:SF13', NULL, NULL, NULL, NULL, 'MONO-/DI-ACYLGLYCEROL LIPASE, ALPHA/BETA HYDROLASE FOLD PROTEIN-RELATED', 253401),
(429886, 'PTHR46398:SF12', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING HEAT-SHOCK PROTEIN', 253401),
(429887, 'PTHR46398', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 253401),
(429888, 'PTHR46398:SF14', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 253401),
(429889, 'PTHR46398:SF11', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING HEAT-SHOCK PROTEIN', 253401),
(429890, 'PTHR16982:SF2', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 6D', 253402),
(429891, 'PTHR16982', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 6D', 253402),
(429892, 'PTHR39550', NULL, NULL, NULL, NULL, 'SLL0658 PROTEIN', 253403),
(429893, 'PTHR39550:SF1', NULL, NULL, NULL, NULL, 'SLL0658 PROTEIN', 253403),
(429894, 'PTHR44974', NULL, NULL, NULL, NULL, 'V-SET AND IMMUNOGLOBULIN DOMAIN-CONTAINING PROTEIN 1', 253404),
(429895, 'PTHR44974:SF1', NULL, NULL, NULL, NULL, 'V-SET AND IMMUNOGLOBULIN DOMAIN-CONTAINING PROTEIN 1', 253404),
(429896, 'PTHR35529:SF1', NULL, NULL, NULL, NULL, 'MANGANESE EFFLUX PUMP MNTP-RELATED', 253405),
(429897, 'PTHR35529:SF2', NULL, NULL, NULL, NULL, 'SPORULATION PROTEIN YTAF-RELATED', 253405),
(429898, 'PTHR35529', NULL, NULL, NULL, NULL, 'MANGANESE EFFLUX PUMP MNTP-RELATED', 253405),
(429899, 'PTHR45792:SF10', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 253406),
(429900, 'PTHR45792:SF2', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL LIPASE-BETA', 253406),
(429901, 'PTHR45792', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL LIPASE HOMOLOG-RELATED', 253406),
(429902, 'PTHR45792:SF7', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_6G02710)-RELATED', 253406),
(429903, 'PTHR45792:SF8', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL LIPASE-ALPHA', 253406),
(429904, 'PTHR43223:SF2', NULL, NULL, NULL, NULL, 'LACTAMASE_B DOMAIN-CONTAINING PROTEIN', 253407);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(429905, 'PTHR43223:SF1', NULL, NULL, NULL, NULL, 'ALKYL/ARYL-SULFATASE BDS1', 253407),
(429906, 'PTHR43223', NULL, NULL, NULL, NULL, 'ALKYL/ARYL-SULFATASE', 253407),
(429907, 'PTHR19338:SF28', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT', 253408),
(429908, 'PTHR19338:SF27', NULL, NULL, NULL, NULL, 'NB-ARC, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 253408),
(429909, 'PTHR19338:SF29', NULL, NULL, NULL, NULL, 'RX_N DOMAIN-CONTAINING PROTEIN', 253408),
(429910, 'PTHR19338:SF22', NULL, NULL, NULL, NULL, 'OS02G0818500 PROTEIN', 253408),
(429911, 'PTHR19338:SF21', NULL, NULL, NULL, NULL, 'OS10G0124400 PROTEIN', 253408),
(429912, 'PTHR19338:SF24', NULL, NULL, NULL, NULL, 'SNKR2GH2 PROTEIN', 253408),
(429913, 'PTHR19338:SF23', NULL, NULL, NULL, NULL, '', 253408),
(429914, 'PTHR19338:SF26', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 253408),
(429915, 'PTHR19338:SF25', NULL, NULL, NULL, NULL, '', 253408),
(429916, 'PTHR19338:SF16', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT', 253408),
(429917, 'PTHR19338', NULL, NULL, NULL, NULL, 'TRANSLOCASE OF INNER MITOCHONDRIAL MEMBRANE 13 HOMOLOG', 253408),
(429918, 'PTHR19338:SF18', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT', 253408),
(429919, 'PTHR19338:SF51', NULL, NULL, NULL, NULL, 'NBS-LRR RESISTANCE PROTEIN', 253408),
(429920, 'PTHR19338:SF50', NULL, NULL, NULL, NULL, 'RX_N DOMAIN-CONTAINING PROTEIN', 253408),
(429921, 'PTHR19338:SF53', NULL, NULL, NULL, NULL, 'RX_N DOMAIN-CONTAINING PROTEIN', 253408),
(429922, 'PTHR19338:SF52', NULL, NULL, NULL, NULL, 'OS12G0272800 PROTEIN', 253408),
(429923, 'PTHR19338:SF11', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT', 253408),
(429924, 'PTHR19338:SF10', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM8 B', 253408),
(429925, 'PTHR19338:SF54', NULL, NULL, NULL, NULL, '', 253408),
(429926, 'PTHR19338:SF13', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT', 253408),
(429927, 'PTHR19338:SF12', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT', 253408),
(429928, 'PTHR19338:SF1', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM8 A-B-RELATED', 253408),
(429929, 'PTHR19338:SF49', NULL, NULL, NULL, NULL, 'OS11G0266500 PROTEIN', 253408),
(429930, 'PTHR19338:SF2', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM8 A', 253408),
(429931, 'PTHR19338:SF0', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM13', 253408),
(429932, 'PTHR19338:SF9', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT', 253408),
(429933, 'PTHR19338:SF7', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM8 B', 253408),
(429934, 'PTHR19338:SF6', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM8 A', 253408),
(429935, 'PTHR19338:SF3', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT', 253408),
(429936, 'PTHR19338:SF4', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT', 253408),
(429937, 'PTHR19338:SF40', NULL, NULL, NULL, NULL, 'OS03G0422900 PROTEIN', 253408),
(429938, 'PTHR19338:SF42', NULL, NULL, NULL, NULL, 'RX_N DOMAIN-CONTAINING PROTEIN', 253408),
(429939, 'PTHR19338:SF41', NULL, NULL, NULL, NULL, 'RX_N DOMAIN-CONTAINING PROTEIN', 253408),
(429940, 'PTHR19338:SF44', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 253408),
(429941, 'PTHR19338:SF43', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN DISEASE RESISTANCE PROTEIN', 253408),
(429942, 'PTHR19338:SF46', NULL, NULL, NULL, NULL, '', 253408),
(429943, 'PTHR19338:SF45', NULL, NULL, NULL, NULL, 'RX_N DOMAIN-CONTAINING PROTEIN', 253408),
(429944, 'PTHR19338:SF48', NULL, NULL, NULL, NULL, 'OS12G0166600 PROTEIN', 253408),
(429945, 'PTHR19338:SF47', NULL, NULL, NULL, NULL, 'RX_N DOMAIN-CONTAINING PROTEIN', 253408); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(429946, 'PTHR19338:SF39', NULL, NULL, NULL, NULL, 'TOSPOVIRUS RESISTANCE PROTEIN C', 253408),
(429947, 'PTHR19338:SF38', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', 253408),
(429948, 'PTHR19338:SF31', NULL, NULL, NULL, NULL, 'OS08G0170100 PROTEIN', 253408),
(429949, 'PTHR19338:SF30', NULL, NULL, NULL, NULL, 'RX_N DOMAIN-CONTAINING PROTEIN', 253408),
(429950, 'PTHR19338:SF33', NULL, NULL, NULL, NULL, 'RX_N DOMAIN-CONTAINING PROTEIN', 253408),
(429951, 'PTHR19338:SF32', NULL, NULL, NULL, NULL, 'OS06G0698812 PROTEIN', 253408),
(429952, 'PTHR19338:SF35', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT', 253408),
(429953, 'PTHR19338:SF34', NULL, NULL, NULL, NULL, 'OS10G0370400 PROTEIN', 253408),
(429954, 'PTHR19338:SF37', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RGA2-LIKE', 253408),
(429955, 'PTHR19338:SF36', NULL, NULL, NULL, NULL, 'OS10G0132500 PROTEIN', 253408),
(429956, 'PTHR10912', NULL, NULL, NULL, NULL, 'ADP-RIBOSYL CYCLASE', 253409),
(429957, 'PTHR10912:SF7', NULL, NULL, NULL, NULL, 'ADP-RIBOSYL CYCLASE/CYCLIC ADP-RIBOSE HYDROLASE', 253409),
(429958, 'PTHR10912:SF5', NULL, NULL, NULL, NULL, 'ADP-RIBOSYL CYCLASE/CYCLIC ADP-RIBOSE HYDROLASE 1', 253409),
(429959, 'PTHR10912:SF4', NULL, NULL, NULL, NULL, 'ADP-RIBOSYL CYCLASE/CYCLIC ADP-RIBOSE HYDROLASE 2', 253409),
(429960, 'PTHR10912:SF9', NULL, NULL, NULL, NULL, 'ADP-RIBOSYL CYCLASE/CYCLIC ADP-RIBOSE HYDROLASE', 253409),
(429961, 'PTHR10912:SF8', NULL, NULL, NULL, NULL, 'ADP-RIBOSYL CYCLASE/CYCLIC ADP-RIBOSE HYDROLASE', 253409),
(429962, 'PTHR35772:SF1', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REACTION CENTER PROTEIN I', 253410),
(429963, 'PTHR35772:SF5', NULL, NULL, NULL, NULL, '', 253410),
(429964, 'PTHR35772:SF6', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REACTION CENTER PROTEIN I', 253410),
(429965, 'PTHR35772', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REACTION CENTER PROTEIN I', 253410),
(429966, 'PTHR47880', NULL, NULL, NULL, NULL, 'OS05G0353300 PROTEIN', 253411),
(429967, 'PTHR47880:SF1', NULL, NULL, NULL, NULL, 'OS05G0353300 PROTEIN', 253411),
(429968, 'PTHR37835', NULL, NULL, NULL, NULL, 'ALPHA-CLOSTRIPAIN', 253412),
(429969, 'PTHR37835:SF1', NULL, NULL, NULL, NULL, 'ALPHA-CLOSTRIPAIN', 253412),
(429970, 'PTHR12133:SF2', NULL, NULL, NULL, NULL, 'TRNA (ADENINE(58)-N(1))-METHYLTRANSFERASE CATALYTIC SUBUNIT TRMT61A', 253413),
(429971, 'PTHR12133:SF1', NULL, NULL, NULL, NULL, 'TRNA (ADENINE(58)-N(1))-METHYLTRANSFERASE, MITOCHONDRIAL', 253413),
(429972, 'PTHR12133', NULL, NULL, NULL, NULL, 'TRNA (ADENINE(58)-N(1))-METHYLTRANSFERASE', 253413),
(429973, 'PTHR31366:SF2', NULL, NULL, NULL, NULL, 'UPF0739 PROTEIN C1ORF74', 253414),
(429974, 'PTHR31366', NULL, NULL, NULL, NULL, 'UPF0739 PROTEIN C1ORF74', 253414),
(429975, 'PTHR40622:SF1', NULL, NULL, NULL, NULL, '', 253415),
(429976, 'PTHR40622:SF2', NULL, NULL, NULL, NULL, '', 253415),
(429977, 'PTHR40622', NULL, NULL, NULL, NULL, '', 253415),
(429978, 'PTHR33055', NULL, NULL, NULL, NULL, 'TRANSPOSASE FOR INSERTION SEQUENCE ELEMENT IS1111A', 253416),
(429979, 'PTHR33055:SF13', NULL, NULL, NULL, NULL, 'THIRD ORF IN TRANSPOSON ISC1491', 253416),
(429980, 'PTHR33055:SF14', NULL, NULL, NULL, NULL, 'PUTATIVE TRANSPOSASE FOR IS117-RELATED', 253416),
(429981, 'PTHR33055:SF3', NULL, NULL, NULL, NULL, 'TRANSPOSASE FOR INSERTION SEQUENCE ELEMENT IS1111A', 253416),
(429982, 'PTHR48079:SF1', NULL, NULL, NULL, NULL, '', 253417),
(429983, 'PTHR48079:SF3', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN', 253417),
(429984, 'PTHR48079:SF6', NULL, NULL, NULL, NULL, 'EPIMERASE DOMAIN-CONTAINING PROTEIN-RELATED', 253417),
(429985, 'PTHR48079:SF5', NULL, NULL, NULL, NULL, 'DEPENDENT EPIMERASE/DEHYDRATASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G00180)-RELATED', 253417),
(429986, 'PTHR48079', NULL, NULL, NULL, NULL, 'PROTEIN YEEZ', 253417),
(429987, 'PTHR48079:SF8', NULL, NULL, NULL, NULL, 'NAD(P)-BD_DOM DOMAIN-CONTAINING PROTEIN', 253417),
(429988, 'PTHR48079:SF7', NULL, NULL, NULL, NULL, 'EPIMERASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G07170)-RELATED', 253417); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(429989, 'PTHR48079:SF9', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 253417),
(429990, 'PTHR24074:SF53', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 253418),
(429991, 'PTHR24074:SF54', NULL, NULL, NULL, NULL, 'PROTEIN DNAJ, PUTATIVE-RELATED', 253418),
(429992, 'PTHR24074:SF40', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN 1', 253418),
(429993, 'PTHR24074:SF41', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', 253418),
(429994, 'PTHR24074:SF52', NULL, NULL, NULL, NULL, 'PROTEIN DNAJ, PUTATIVE-RELATED', 253418),
(429995, 'PTHR24074:SF60', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN DNAJ FAMILY PROTEIN-RELATED', 253418),
(429996, 'PTHR24074:SF61', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 253418),
(429997, 'PTHR24074', NULL, NULL, NULL, NULL, 'CO-CHAPERONE PROTEIN DJLA', 253418),
(429998, 'PTHR24074:SF29', NULL, NULL, NULL, NULL, 'OS07G0626400 PROTEIN', 253418),
(429999, 'PTHR24074:SF59', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 253418),
(430000, 'PTHR24074:SF37', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ 8, CHLOROPLASTIC-LIKE', 253418),
(430001, 'PTHR24074:SF57', NULL, NULL, NULL, NULL, 'PROTEIN DNAJ, PUTATIVE-RELATED', 253418),
(430002, 'PTHR24074:SF35', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ 8, CHLOROPLASTIC', 253418),
(430003, 'PTHR24074:SF58', NULL, NULL, NULL, NULL, 'LD30543P', 253418),
(430004, 'PTHR24074:SF11', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 253418),
(430005, 'PTHR24074:SF56', NULL, NULL, NULL, NULL, 'CO-CHAPERONE PROTEIN DJLA', 253418),
(430006, 'PTHR48287:SF1', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 253419),
(430007, 'PTHR48287', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 253419),
(430008, 'PTHR16200', NULL, NULL, NULL, NULL, 'RING ZINC FINGER', 253420),
(430009, 'PTHR16200:SF6', NULL, NULL, NULL, NULL, 'RNF111_N DOMAIN-CONTAINING PROTEIN', 253420),
(430010, 'PTHR16200:SF3', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ZNRF3', 253420),
(430011, 'PTHR16200:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF43', 253420),
(430012, 'PTHR16200:SF5', NULL, NULL, NULL, NULL, 'SIMILAR TO HYPOTHETICAL PROTEIN', 253420),
(430013, 'PTHR16200:SF4', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ARKADIA', 253420),
(430014, 'PTHR16200:SF1', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253420),
(430015, 'PTHR12834:SF12', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE 9 KDA PROTEIN', 253421),
(430016, 'PTHR12834:SF13', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE 9 KDA PROTEIN', 253421),
(430017, 'PTHR12834', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE 9 KDA PROTEIN', 253421),
(430018, 'PTHR46620:SF2', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN SPF31-LIKE', 253422),
(430019, 'PTHR46620:SF1', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN SPF31', 253422),
(430020, 'PTHR46620:SF3', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN', 253422),
(430021, 'PTHR46620', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN SPF31', 253422),
(430022, 'PTHR37426:SF1', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA LARGE SUBUNIT METHYLTRANSFERASE J', 253423),
(430023, 'PTHR37426', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA LARGE SUBUNIT METHYLTRANSFERASE J', 253423),
(430024, 'PTHR39654:SF3', NULL, NULL, NULL, NULL, 'SI:DKEY-151P21.7', 253424),
(430025, 'PTHR39654:SF2', NULL, NULL, NULL, NULL, '', 253424),
(430026, 'PTHR39654:SF6', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING 75BB', 253424),
(430027, 'PTHR39654:SF5', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 75B', 253424),
(430028, 'PTHR39654', NULL, NULL, NULL, NULL, '', 253424),
(430029, 'PTHR31564:SF0', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT 16', 253425),
(430030, 'PTHR31564', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT 16', 253425),
(430031, 'PTHR24219:SF6', NULL, NULL, NULL, NULL, 'WILMS TUMOR PROTEIN 1-INTERACTING PROTEIN', 253426),
(430032, 'PTHR24219:SF4', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING PROTEIN JUB', 253426);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(430033, 'PTHR24219:SF3', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING PROTEIN 1', 253426),
(430034, 'PTHR24219', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING PROTEIN JUB', 253426),
(430035, 'PTHR24219:SF8', NULL, NULL, NULL, NULL, 'AJUBA LIM PROTEIN', 253426),
(430036, 'PTHR24219:SF7', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING PROTEIN AJUBA', 253426),
(430037, 'PTHR15726', NULL, NULL, NULL, NULL, 'RAB11-FAMILY INTERACTING PROTEIN', 253427),
(430038, 'PTHR15726:SF5', NULL, NULL, NULL, NULL, 'RAB11 FAMILY-INTERACTING PROTEIN 4', 253427),
(430039, 'PTHR15726:SF7', NULL, NULL, NULL, NULL, 'NUCLEAR FALLOUT, ISOFORM J', 253427),
(430040, 'PTHR15726:SF6', NULL, NULL, NULL, NULL, 'RAB11 FAMILY-INTERACTING PROTEIN 3', 253427),
(430041, 'PTHR33777', NULL, NULL, NULL, NULL, 'UPF0045 PROTEIN ECM15', 253428),
(430042, 'PTHR33777:SF1', NULL, NULL, NULL, NULL, 'UPF0045 PROTEIN ECM15', 253428),
(430043, 'PTHR21014:SF4', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-4,5-BISPHOSPHATE 4-PHOSPHATASE', 253429),
(430044, 'PTHR21014:SF6', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-4,5-BISPHOSPHATE 4-PHOSPHATASE', 253429),
(430045, 'PTHR21014:SF5', NULL, NULL, NULL, NULL, 'TYPE 2 PHOSPHATIDYLINOSITOL 4,5-BISPHOSPHATE 4-PHOSPHATASE', 253429),
(430046, 'PTHR21014:SF2', NULL, NULL, NULL, NULL, 'TYPE 1 PHOSPHATIDYLINOSITOL 4,5-BISPHOSPHATE 4-PHOSPHATASE', 253429),
(430047, 'PTHR21014', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 253429),
(430048, 'PTHR36937:SF4', NULL, NULL, NULL, NULL, 'PROTEIN CBG20935', 253430),
(430049, 'PTHR36937:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG06983', 253430),
(430050, 'PTHR36937', NULL, NULL, NULL, NULL, 'PROTEIN CBG20935-RELATED', 253430),
(430051, 'PTHR11639:SF29', NULL, NULL, NULL, NULL, 'PROTEIN S100-A15A', 253431),
(430052, 'PTHR11639:SF26', NULL, NULL, NULL, NULL, 'CORNULIN', 253431),
(430053, 'PTHR11639:SF67', NULL, NULL, NULL, NULL, 'PROTEIN S100-A7A', 253431),
(430054, 'PTHR11639:SF141', NULL, NULL, NULL, NULL, 'METASTASIN', 253431),
(430055, 'PTHR11639:SF126', NULL, NULL, NULL, NULL, 'S100 CALCIUM-BINDING PROTEIN W', 253431),
(430056, 'PTHR11639:SF127', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 253431),
(430057, 'PTHR11639', NULL, NULL, NULL, NULL, 'S100 CALCIUM-BINDING PROTEIN', 253431),
(430058, 'PTHR11639:SF144', NULL, NULL, NULL, NULL, 'BNAC09G17920D PROTEIN', 253431),
(430059, 'PTHR11639:SF145', NULL, NULL, NULL, NULL, 'CALCIUM ION BINDING PROTEIN', 253431),
(430060, 'PTHR11639:SF123', NULL, NULL, NULL, NULL, 'OS04G0601500 PROTEIN', 253431),
(430061, 'PTHR11639:SF142', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 253431),
(430062, 'PTHR11639:SF143', NULL, NULL, NULL, NULL, 'PROTEIN S100-A10', 253431),
(430063, 'PTHR11639:SF76', NULL, NULL, NULL, NULL, 'PROTEIN S100-A16', 253431),
(430064, 'PTHR11639:SF77', NULL, NULL, NULL, NULL, 'PROTEIN S100-A12', 253431),
(430065, 'PTHR11639:SF74', NULL, NULL, NULL, NULL, 'PROTEIN S100-A10', 253431),
(430066, 'PTHR11639:SF72', NULL, NULL, NULL, NULL, 'PROTEIN S100-Z', 253431),
(430067, 'PTHR11639:SF51', NULL, NULL, NULL, NULL, 'PROTEIN S100-A4', 253431),
(430068, 'PTHR11639:SF73', NULL, NULL, NULL, NULL, 'PROTEIN S100-G', 253431),
(430069, 'PTHR11639:SF128', NULL, NULL, NULL, NULL, 'PROTEIN S100-A7', 253431),
(430070, 'PTHR11639:SF59', NULL, NULL, NULL, NULL, 'PROTEIN S100-A2', 253431),
(430071, 'PTHR11639:SF12', NULL, NULL, NULL, NULL, 'PROTEIN S100-A3', 253431),
(430072, 'PTHR11639:SF57', NULL, NULL, NULL, NULL, 'PROTEIN S100-A13', 253431),
(430073, 'PTHR11639:SF79', NULL, NULL, NULL, NULL, 'PROTEIN S100-A9', 253431),
(430074, 'PTHR11639:SF5', NULL, NULL, NULL, NULL, 'PROTEIN S100-A8', 253431),
(430075, 'PTHR11639:SF130', NULL, NULL, NULL, NULL, 'S100 CALCIUM-BINDING PROTEIN A11', 253431),
(430076, 'PTHR11639:SF4', NULL, NULL, NULL, NULL, 'PROTEIN S100-A14', 253431),
(430077, 'PTHR11639:SF115', NULL, NULL, NULL, NULL, 'S100 CALCIUM-BINDING PROTEIN U-RELATED', 253431),
(430078, 'PTHR11639:SF80', NULL, NULL, NULL, NULL, 'PROTEIN S100-A6', 253431),
(430079, 'PTHR11639:SF114', NULL, NULL, NULL, NULL, 'S100 CALCIUM-BINDING PROTEIN V1-RELATED', 253431);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(430080, 'PTHR11639:SF134', NULL, NULL, NULL, NULL, 'PROTEIN S100-A1-RELATED', 253431),
(430081, 'PTHR11639:SF131', NULL, NULL, NULL, NULL, 'PROTEIN S100', 253431),
(430082, 'PTHR11639:SF65', NULL, NULL, NULL, NULL, 'PROTEIN S100-A5', 253431),
(430083, 'PTHR11639:SF44', NULL, NULL, NULL, NULL, 'PROTEIN S100-A7-LIKE 2', 253431),
(430084, 'PTHR11639:SF63', NULL, NULL, NULL, NULL, 'PROTEIN S100', 253431),
(430085, 'PTHR11639:SF119', NULL, NULL, NULL, NULL, 'PROTEIN S100', 253431),
(430086, 'PTHR11639:SF139', NULL, NULL, NULL, NULL, 'PROTEIN S100-P', 253431),
(430087, 'PTHR11639:SF118', NULL, NULL, NULL, NULL, 'PROTEIN S100', 253431),
(430088, 'PTHR11639:SF60', NULL, NULL, NULL, NULL, 'PROTEIN S100-A11', 253431),
(430089, 'PTHR13473:SF0', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L48, MITOCHONDRIAL', 253432),
(430090, 'PTHR13473', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOMAL PROTEIN L48', 253432),
(430091, 'PTHR46392', NULL, NULL, NULL, NULL, 'DUAL SERINE/THREONINE AND TYROSINE PROTEIN KINASE', 253433),
(430092, 'PTHR46392:SF1', NULL, NULL, NULL, NULL, 'DUAL SERINE/THREONINE AND TYROSINE PROTEIN KINASE', 253433),
(430093, 'PTHR43701:SF11', NULL, NULL, NULL, NULL, 'MEMBRANE TRANSPORTER PROTEIN YJNA-RELATED', 253434),
(430094, 'PTHR43701', NULL, NULL, NULL, NULL, 'MEMBRANE TRANSPORTER PROTEIN MJ0441-RELATED', 253434),
(430095, 'PTHR43701:SF2', NULL, NULL, NULL, NULL, 'MEMBRANE TRANSPORTER PROTEIN YTNM-RELATED', 253434),
(430096, 'PTHR43701:SF5', NULL, NULL, NULL, NULL, 'MEMBRANE TRANSPORTER PROTEIN-RELATED', 253434),
(430097, 'PTHR43319:SF2', NULL, NULL, NULL, NULL, 'BETA-LACTAMASE DOMAIN-CONTAINING PROTEIN', 253435),
(430098, 'PTHR43319:SF1', NULL, NULL, NULL, NULL, 'BETA-LACTAMASE DOMAIN-CONTAINING PROTEIN', 253435),
(430099, 'PTHR43319:SF4', NULL, NULL, NULL, NULL, 'BETA-LACTAMASE DOMAIN-CONTAINING PROTEIN 2', 253435),
(430100, 'PTHR43319:SF3', NULL, NULL, NULL, NULL, 'BETA-LACTAMASE DOMAIN-CONTAINING PROTEIN', 253435),
(430101, 'PTHR43319', NULL, NULL, NULL, NULL, 'BETA-LACTAMASE-RELATED', 253435),
(430102, 'PTHR43319:SF5', NULL, NULL, NULL, NULL, 'BETA-LACTAMASE DOMAIN-CONTAINING PROTEIN', 253435),
(430103, 'PTHR43319:SF7', NULL, NULL, NULL, NULL, 'BETA-LACTAMASE DOMAIN-CONTAINING PROTEIN', 253435),
(430104, 'PTHR19918:SF49', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 253436),
(430105, 'PTHR19918:SF67', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE 20.1 COFACTOR OF APC COMPLEX', 253436),
(430106, 'PTHR19918:SF45', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 253436),
(430107, 'PTHR19918:SF1', NULL, NULL, NULL, NULL, 'FIZZY-RELATED PROTEIN HOMOLOG', 253436),
(430108, 'PTHR19918:SF63', NULL, NULL, NULL, NULL, 'MEIOTIC FIZZY-RELATED PROTEIN 1', 253436),
(430109, 'PTHR19918:SF64', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 253436),
(430110, 'PTHR19918:SF43', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE 20.2, COFACTOR OF APC COMPLEX-LIKE ISOFORM X2', 253436),
(430111, 'PTHR19918:SF65', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 253436),
(430112, 'PTHR19918:SF66', NULL, NULL, NULL, NULL, 'CDC20/FIZZY FAMILY WD REPEAT PROTEIN', 253436),
(430113, 'PTHR19918:SF5', NULL, NULL, NULL, NULL, 'MEIOSIS-SPECIFIC APC/C ACTIVATOR PROTEIN AMA1', 253436),
(430114, 'PTHR19918:SF3', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE PROTEIN 20 HOMOLOG', 253436),
(430115, 'PTHR19918:SF4', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE PROTEIN 20 HOMOLOG B', 253436),
(430116, 'PTHR19918:SF51', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 253436),
(430117, 'PTHR19918:SF8', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 55 HOMOLOG', 253436),
(430118, 'PTHR19918:SF39', NULL, NULL, NULL, NULL, 'TRANSDUCIN FAMILY PROTEIN/WD-40 REPEAT PROTEIN', 253436),
(430119, 'PTHR19918:SF12', NULL, NULL, NULL, NULL, 'OS09G0242300 PROTEIN', 253436),
(430120, 'PTHR19918:SF56', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 253436),
(430121, 'PTHR19918:SF34', NULL, NULL, NULL, NULL, 'FIZZY/CELL DIVISION CYCLE 20 RELATED 1 (DROSOPHILA)', 253436);
INSERT INTO "PUBLIC"."MODEL" VALUES
(430122, 'PTHR19918:SF35', NULL, NULL, NULL, NULL, 'FIZZY/CELL DIVISION CYCLE 20-RELATED 1B', 253436),
(430123, 'PTHR19918', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE 20  CDC20   FIZZY -RELATED', 253436),
(430124, 'PTHR19918:SF36', NULL, NULL, NULL, NULL, 'PROTEIN FIZZY-RELATED 3', 253436),
(430125, 'PTHR19918:SF59', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE 20.2, COFACTOR OF APC COMPLEX-LIKE', 253436),
(430126, 'PTHR19918:SF52', NULL, NULL, NULL, NULL, 'PROTEIN CORTEX', 253436),
(430127, 'PTHR19918:SF54', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 253436),
(430128, 'PTHR19918:SF55', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE 20.2, COFACTOR OF APC COMPLEX-LIKE', 253436),
(430129, 'PTHR19918:SF61', NULL, NULL, NULL, NULL, 'PROTEIN FIZZY-RELATED 2', 253436),
(430130, 'PTHR19918:SF62', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 253436),
(430131, 'PTHR36812:SF2', NULL, NULL, NULL, NULL, 'OS07G0164800 PROTEIN', 253437),
(430132, 'PTHR36812', NULL, NULL, NULL, NULL, 'NEUROFILAMENT TRIPLET M PROTEIN-LIKE PROTEIN', 253437),
(430133, 'PTHR36812:SF9', NULL, NULL, NULL, NULL, 'MYB-LIKE PROTEIN X ISOFORM X1', 253437),
(430134, 'PTHR31189:SF61', NULL, NULL, NULL, NULL, 'GLOBULIN', 253438),
(430135, 'PTHR31189:SF62', NULL, NULL, NULL, NULL, 'OS01G0976200 PROTEIN', 253438),
(430136, 'PTHR31189:SF40', NULL, NULL, NULL, NULL, '', 253438),
(430137, 'PTHR31189:SF65', NULL, NULL, NULL, NULL, 'VICILIN', 253438),
(430138, 'PTHR31189:SF44', NULL, NULL, NULL, NULL, '', 253438),
(430139, 'PTHR31189:SF66', NULL, NULL, NULL, NULL, '11S GLOBULIN', 253438),
(430140, 'PTHR31189:SF41', NULL, NULL, NULL, NULL, 'VICILIN C72', 253438),
(430141, 'PTHR31189:SF63', NULL, NULL, NULL, NULL, 'GLYCININ G5', 253438),
(430142, 'PTHR31189:SF64', NULL, NULL, NULL, NULL, 'LEGUMIN A-LIKE', 253438),
(430143, 'PTHR31189:SF48', NULL, NULL, NULL, NULL, 'LEGUMIN B', 253438),
(430144, 'PTHR31189:SF45', NULL, NULL, NULL, NULL, 'OS09G0552500 PROTEIN', 253438),
(430145, 'PTHR31189:SF27', NULL, NULL, NULL, NULL, 'CUPINCIN', 253438),
(430146, 'PTHR31189:SF49', NULL, NULL, NULL, NULL, '11S GLOBULIN', 253438),
(430147, 'PTHR31189', NULL, NULL, NULL, NULL, 'OS03G0336100 PROTEIN-RELATED', 253438),
(430148, 'PTHR31189:SF7', NULL, NULL, NULL, NULL, 'PREPROMP73', 253438),
(430149, 'PTHR31189:SF72', NULL, NULL, NULL, NULL, 'RESERVOIR, PUTATIVE-RELATED', 253438),
(430150, 'PTHR31189:SF50', NULL, NULL, NULL, NULL, 'RMLC-LIKE JELLY ROLL FOLD PROTEIN-RELATED', 253438),
(430151, 'PTHR31189:SF73', NULL, NULL, NULL, NULL, '11S GLOBULIN', 253438),
(430152, 'PTHR31189:SF51', NULL, NULL, NULL, NULL, 'NUTRIENT RESERVOIR', 253438),
(430153, 'PTHR31189:SF54', NULL, NULL, NULL, NULL, 'CUPIN TYPE-1 DOMAIN-CONTAINING PROTEIN', 253438),
(430154, 'PTHR31189:SF76', NULL, NULL, NULL, NULL, 'LEGUMIN B-LIKE', 253438),
(430155, 'PTHR31189:SF33', NULL, NULL, NULL, NULL, 'CUPIN TYPE-1 DOMAIN-CONTAINING PROTEIN', 253438),
(430156, 'PTHR31189:SF77', NULL, NULL, NULL, NULL, 'GLYCININ G3', 253438),
(430157, 'PTHR31189:SF55', NULL, NULL, NULL, NULL, 'GLUTELIN TYPE-B 1-RELATED', 253438),
(430158, 'PTHR31189:SF74', NULL, NULL, NULL, NULL, '12S SEED STORAGE PROTEIN CRC', 253438),
(430159, 'PTHR31189:SF52', NULL, NULL, NULL, NULL, 'VICILIN', 253438),
(430160, 'PTHR31189:SF30', NULL, NULL, NULL, NULL, '12S SEED STORAGE PROTEIN CRA1', 253438),
(430161, 'PTHR31189:SF75', NULL, NULL, NULL, NULL, '7S GLOBULIN', 253438),
(430162, 'PTHR31189:SF31', NULL, NULL, NULL, NULL, 'CUPIN FAMILY PROTEIN', 253438),
(430163, 'PTHR31189:SF59', NULL, NULL, NULL, NULL, '11S GLOBULIN SUBUNIT BETA-LIKE', 253438),
(430164, 'PTHR31189:SF78', NULL, NULL, NULL, NULL, 'OS05G0116000 PROTEIN', 253438),
(430165, 'PTHR31189:SF34', NULL, NULL, NULL, NULL, 'VICILIN', 253438),
(430166, 'PTHR31189:SF56', NULL, NULL, NULL, NULL, '11S GLOBULIN SUBUNIT BETA-RELATED', 253438),
(430167, 'PTHR31189:SF2', NULL, NULL, NULL, NULL, 'RMLC-LIKE CUPINS SUPERFAMILY PROTEIN', 253438),
(430168, 'PTHR31189:SF13', NULL, NULL, NULL, NULL, '63 KDA GLOBULIN-LIKE PROTEIN', 253438),
(430169, 'PTHR31189:SF35', NULL, NULL, NULL, NULL, '12S SEED STORAGE PROTEIN CRB', 253438);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(430170, 'PTHR31189:SF38', NULL, NULL, NULL, NULL, '12S SEED STORAGE PROTEIN CRD', 253438),
(430171, 'PTHR15581', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN R', 253439),
(430172, 'PTHR15581:SF0', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN R', 253439),
(430173, 'PTHR13416', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 253440),
(430174, 'PTHR13416:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 43', 253440),
(430175, 'PTHR37685:SF1', NULL, NULL, NULL, NULL, 'GEO11136P1-RELATED', 253441),
(430176, 'PTHR37685', NULL, NULL, NULL, NULL, 'GEO11136P1-RELATED', 253441),
(430177, 'PTHR43126', NULL, NULL, NULL, NULL, 'D-ALANYL-D-ALANINE DIPEPTIDASE', 253442),
(430178, 'PTHR43126:SF2', NULL, NULL, NULL, NULL, 'D-ALANYL-D-ALANINE DIPEPTIDASE', 253442),
(430179, 'PTHR43126:SF1', NULL, NULL, NULL, NULL, 'D-ALANYL-D-ALANINE DIPEPTIDASE', 253442),
(430180, 'PTHR36303:SF1', NULL, NULL, NULL, NULL, '2'',3''-CYCLIC-NUCLEOTIDE 2''-PHOSPHODIESTERASE', 253443),
(430181, 'PTHR36303', NULL, NULL, NULL, NULL, '2'',3''-CYCLIC-NUCLEOTIDE 2''-PHOSPHODIESTERASE', 253443),
(430182, 'PTHR23267:SF491', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA VARIABLE 2-18-RELATED', 253444),
(430183, 'PTHR23267:SF490', NULL, NULL, NULL, NULL, 'NON-FUNCTIONAL IMMUNOGLOBULIN LAMBDA VARIABLE 11-55-RELATED', 253444),
(430184, 'PTHR23267:SF374', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 2', 253444),
(430185, 'PTHR23267:SF495', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 253444),
(430186, 'PTHR23267:SF494', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 253444),
(430187, 'PTHR23267:SF373', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN KAPPA VARIABLE 1-5', 253444),
(430188, 'PTHR23267:SF493', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 253444),
(430189, 'PTHR23267:SF492', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 253444),
(430190, 'PTHR23267:SF378', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA VARIABLE 3-21', 253444),
(430191, 'PTHR23267:SF499', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN KAPPA VARIABLE 2-28-RELATED', 253444),
(430192, 'PTHR23267:SF498', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 253444),
(430193, 'PTHR23267:SF497', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA VARIABLE 3-9', 253444),
(430194, 'PTHR23267:SF376', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 253444),
(430195, 'PTHR23267:SF496', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA VARIABLE 3-10', 253444),
(430196, 'PTHR23267:SF133', NULL, NULL, NULL, NULL, 'PRE-B LYMPHOCYTE PROTEIN 3', 253444),
(430197, 'PTHR23267:SF375', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA VARIABLE 3-27', 253444),
(430198, 'PTHR23267:SF414', NULL, NULL, NULL, NULL, 'IGV DOMAIN-CONTAINING PROTEIN-RELATED', 253444),
(430199, 'PTHR23267:SF413', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA VARIABLE 1-44-RELATED', 253444),
(430200, 'PTHR23267:SF379', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN KAPPA VARIABLE 2-24-RELATED', 253444),
(430201, 'PTHR23267:SF11', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN IOTA CHAIN', 253444),
(430202, 'PTHR23267:SF480', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN KAPPA VARIABLE 1-13-RELATED', 253444),
(430203, 'PTHR23267:SF484', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 38-2/DELTA VARIABLE 8', 253444),
(430204, 'PTHR23267:SF483', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 253444),
(430205, 'PTHR23267:SF362', NULL, NULL, NULL, NULL, 'IGV DOMAIN-CONTAINING PROTEIN', 253444),
(430206, 'PTHR23267:SF482', NULL, NULL, NULL, NULL, 'NON-FUNCTIONAL IMMUNOGLOBULIN KAPPA VARIABLE 6D-41-RELATED', 253444),
(430207, 'PTHR23267:SF240', NULL, NULL, NULL, NULL, 'IG KAPPA CHAIN V-V REGION MOPC 21-RELATED', 253444),
(430208, 'PTHR23267:SF481', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN KAPPA VARIABLE 10-95', 253444),
(430209, 'PTHR23267:SF360', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA VARIABLE 5-52', 253444),
(430210, 'PTHR23267:SF488', NULL, NULL, NULL, NULL, 'IG KAPPA CHAIN V-II REGION VKAPPA167', 253444),
(430211, 'PTHR23267:SF487', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN KAPPA VARIABLE 2-29', 253444);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(430212, 'PTHR23267:SF366', NULL, NULL, NULL, NULL, 'IG KAPPA CHAIN V-IV REGION S107B-RELATED', 253444),
(430213, 'PTHR23267:SF486', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 14/DELTA VARIABLE 4', 253444),
(430214, 'PTHR23267:SF364', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA VARIABLE 3-19-RELATED', 253444),
(430215, 'PTHR23267:SF485', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN KAPPA VARIABLE 1-99', 253444),
(430216, 'PTHR23267:SF369', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 253444),
(430217, 'PTHR23267:SF402', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN KAPPA VARIABLE 1-39-RELATED', 253444),
(430218, 'PTHR23267:SF489', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 253444),
(430219, 'PTHR23267:SF407', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA VARIABLE 2-14-RELATED', 253444),
(430220, 'PTHR23267:SF193', NULL, NULL, NULL, NULL, 'IG LAMBDA-1 CHAIN V REGION-RELATED', 253444),
(430221, 'PTHR23267:SF472', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN KAPPA VARIABLE 3-20-RELATED', 253444),
(430222, 'PTHR23267:SF471', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA VARIABLE 3-16', 253444),
(430223, 'PTHR23267:SF470', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA VARIABLE 1-51', 253444),
(430224, 'PTHR23267:SF477', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN KAPPA VARIABLE 3-11-RELATED', 253444),
(430225, 'PTHR23267:SF476', NULL, NULL, NULL, NULL, 'IGV DOMAIN-CONTAINING PROTEIN', 253444),
(430226, 'PTHR23267:SF355', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN KAPPA VARIABLE 1-16-RELATED', 253444),
(430227, 'PTHR23267:SF475', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN KAPPA VARIABLE 2-30-RELATED', 253444),
(430228, 'PTHR23267:SF474', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN KAPPA VARIABLE 1-12-RELATED', 253444),
(430229, 'PTHR23267:SF359', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA VARIABLE 3-22', 253444),
(430230, 'PTHR23267:SF479', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN KAPPA CHAIN VARIABLE 14-100-RELATED', 253444),
(430231, 'PTHR23267:SF478', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 253444),
(430232, 'PTHR23267:SF462', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA VARIABLE 4-3', 253444),
(430233, 'PTHR23267:SF460', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN KAPPA VARIABLE 1D-16', 253444),
(430234, 'PTHR23267:SF464', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA VARIABLE 7-46', 253444),
(430235, 'PTHR23267:SF189', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR DELTA VARIABLE 3', 253444),
(430236, 'PTHR23267:SF343', NULL, NULL, NULL, NULL, 'IG KAPPA CHAIN V-III REGION 50S10.1-RELATED', 253444),
(430237, 'PTHR23267:SF503', NULL, NULL, NULL, NULL, 'IG KAPPA CHAIN V-III REGION MOPC 321-RELATED', 253444),
(430238, 'PTHR23267:SF502', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN KAPPA VARIABLE 1-6', 253444),
(430239, 'PTHR23267:SF469', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 253444),
(430240, 'PTHR23267:SF347', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA VARIABLE 1-36', 253444),
(430241, 'PTHR23267:SF501', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA VARIABLE 2-11', 253444),
(430242, 'PTHR23267:SF468', NULL, NULL, NULL, NULL, 'NON-FUNCTIONAL IMMUNOGLOBULINN KAPPA VARIABLE 1-37-RELATED', 253444),
(430243, 'PTHR23267:SF225', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA VARIABLE 10-54', 253444),
(430244, 'PTHR23267:SF500', NULL, NULL, NULL, NULL, 'IGV DOMAIN-CONTAINING PROTEIN-RELATED', 253444),
(430245, 'PTHR23267:SF108', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA VARIABLE 6-57', 253444),
(430246, 'PTHR23267:SF176', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA VARIABLE 8-61', 253444),
(430247, 'PTHR23267:SF450', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 19', 253444),
(430248, 'PTHR23267:SF294', NULL, NULL, NULL, NULL, 'IG KAPPA CHAIN V REGION S211-RELATED', 253444),
(430249, 'PTHR23267:SF455', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA VARIABLE 1-40-RELATED', 253444),
(430250, 'PTHR23267:SF454', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA VARIABLE 3-25', 253444),
(430251, 'PTHR23267:SF453', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN KAPPA VARIABLE 2D-26', 253444);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(430252, 'PTHR23267:SF331', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN KAPPA VARIABLE 3-15-RELATED', 253444),
(430253, 'PTHR23267:SF452', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN KAPPA VARIABLE 1-33-RELATED', 253444),
(430254, 'PTHR23267:SF217', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN KAPPA VARIABLE 6-21-RELATED', 253444),
(430255, 'PTHR23267:SF458', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN KAPPA VARIABLE 1-27', 253444),
(430256, 'PTHR23267:SF216', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN KAPPA VARIABLE 1-9-RELATED', 253444),
(430257, 'PTHR23267:SF215', NULL, NULL, NULL, NULL, 'IG KAPPA CHAIN V-V REGION MOPC 149-RELATED', 253444),
(430258, 'PTHR23267', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LIGHT CHAIN', 253444),
(430259, 'PTHR23267:SF335', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA VARIABLE 7-43', 253444),
(430260, 'PTHR23267:SF164', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA VARIABLE 4-69', 253444),
(430261, 'PTHR23267:SF323', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA VARIABLE 4-60', 253444),
(430262, 'PTHR23267:SF201', NULL, NULL, NULL, NULL, 'IG KAPPA CHAIN V-VI REGION J539-RELATED', 253444),
(430263, 'PTHR23267:SF441', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 253444),
(430264, 'PTHR23267:SF320', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN KAPPA VARIABLE 1-8-RELATED', 253444),
(430265, 'PTHR23267:SF206', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA VARIABLE 9-49', 253444),
(430266, 'PTHR23267:SF446', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 253444),
(430267, 'PTHR23267:SF325', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA VARIABLE 5-37-RELATED', 253444),
(430268, 'PTHR23267:SF328', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 253444),
(430269, 'PTHR23267:SF394', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 253444),
(430270, 'PTHR23267:SF393', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA VARIABLE 3-12', 253444),
(430271, 'PTHR23267:SF158', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 253444),
(430272, 'PTHR23267:SF399', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 253444),
(430273, 'PTHR23267:SF278', NULL, NULL, NULL, NULL, 'IG KAPPA CHAIN V-II REGION 26-10', 253444),
(430274, 'PTHR23267:SF157', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 253444),
(430275, 'PTHR23267:SF437', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA VARIABLE 2-8', 253444),
(430276, 'PTHR23267:SF315', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LAMBDA VARIABLE 3-1', 253444),
(430277, 'PTHR23267:SF313', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN KAPPA VARIABLE 5-2', 253444),
(430278, 'PTHR23267:SF318', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR DELTA VARIABLE 1', 253444),
(430279, 'PTHR23267:SF381', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN KAPPA VARIABLE 2-40-RELATED', 253444),
(430280, 'PTHR23267:SF380', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN KAPPA VARIABLE 2D-29', 253444),
(430281, 'PTHR23267:SF141', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 38-1', 253444),
(430282, 'PTHR23267:SF388', NULL, NULL, NULL, NULL, 'NON-FUNCTIONAL IMMUNOGLOBULIN KAPPA VARIABLE 1D-42-RELATED', 253444),
(430283, 'PTHR23267:SF425', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN KAPPA VARIABLE 4-1', 253444),
(430284, 'PTHR23267:SF427', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 253444),
(430285, 'PTHR34153:SF2', NULL, NULL, NULL, NULL, 'SI:CH211-262H13.3-RELATED', 253445),
(430286, 'PTHR34153', NULL, NULL, NULL, NULL, 'SI:CH211-262H13.3-RELATED-RELATED', 253445),
(430287, 'PTHR34153:SF8', NULL, NULL, NULL, NULL, 'SI:DKEY-266F7.4-RELATED', 253445),
(430288, 'PTHR15739', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 253446),
(430289, 'PTHR15739:SF2', NULL, NULL, NULL, NULL, 'PROTEIN ZNF365', 253446),
(430290, 'PTHR15739:SF5', NULL, NULL, NULL, NULL, 'LD23158P', 253446),
(430291, 'PTHR15739:SF4', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 41', 253446),
(430292, 'PTHR31993:SF6', NULL, NULL, NULL, NULL, 'UBA-LIKE DOMAIN-CONTAINING PROTEIN 2', 253447),
(430293, 'PTHR31993:SF4', NULL, NULL, NULL, NULL, 'UBA-LIKE DOMAIN-CONTAINING PROTEIN 2', 253447);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(430294, 'PTHR31993:SF5', NULL, NULL, NULL, NULL, 'UBA-LIKE DOMAIN-CONTAINING PROTEIN 1', 253447),
(430295, 'PTHR31993', NULL, NULL, NULL, NULL, 'UBA-LIKE DOMAIN-CONTAINING PROTEIN 2', 253447),
(430296, 'PTHR46258:SF3', NULL, NULL, NULL, NULL, 'VESICLE-TRAFFICKING PROTEIN SEC22A', 253448),
(430297, 'PTHR46258:SF2', NULL, NULL, NULL, NULL, 'VESICLE-TRAFFICKING PROTEIN SEC22C', 253448),
(430298, 'PTHR46258:SF1', NULL, NULL, NULL, NULL, 'CTCK DOMAIN-CONTAINING PROTEIN', 253448),
(430299, 'PTHR46258', NULL, NULL, NULL, NULL, 'LONGIN DOMAIN-CONTAINING PROTEIN', 253448),
(430300, 'PTHR33309:SF8', NULL, NULL, NULL, NULL, 'KERATIN, ULTRA HIGH-SULFUR MATRIX PROTEIN-LIKE', 253449),
(430301, 'PTHR33309', NULL, NULL, NULL, NULL, 'KERATIN, ULTRA HIGH-SULFUR MATRIX PROTEIN-LIKE', 253449),
(430302, 'PTHR33309:SF1', NULL, NULL, NULL, NULL, '', 253449),
(430303, 'PTHR33309:SF3', NULL, NULL, NULL, NULL, 'MICROSOMAL DIPEPTIDASE FAMILY PROTEIN', 253449),
(430304, 'PTHR42862:SF1', NULL, NULL, NULL, NULL, 'DELTA-1-PYRROLINE-5-CARBOXYLATE DEHYDROGENASE 2, ISOFORM A-RELATED', 253450),
(430305, 'PTHR42862', NULL, NULL, NULL, NULL, 'DELTA-1-PYRROLINE-5-CARBOXYLATE DEHYDROGENASE 1, ISOFORM A-RELATED', 253450),
(430306, 'PTHR34700:SF7', NULL, NULL, NULL, NULL, 'LYSM DOMAIN-CONTAINING PROTEIN', 253451),
(430307, 'PTHR34700', NULL, NULL, NULL, NULL, 'POTASSIUM BINDING PROTEIN KBP', 253451),
(430308, 'PTHR34700:SF4', NULL, NULL, NULL, NULL, 'POTASSIUM BINDING PROTEIN KBP', 253451),
(430309, 'PTHR34700:SF3', NULL, NULL, NULL, NULL, 'PHAGE-LIKE ELEMENT PBSX PROTEIN XKDQ', 253451),
(430310, 'PTHR10345', NULL, NULL, NULL, NULL, 'BONE SIALOPROTEIN 2', 253452),
(430311, 'PTHR10345:SF0', NULL, NULL, NULL, NULL, 'BONE SIALOPROTEIN 2', 253452),
(430312, 'PTHR24292:SF102', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 308A1-RELATED', 253453),
(430313, 'PTHR24292:SF101', NULL, NULL, NULL, NULL, 'AGAP002864-PA', 253453),
(430314, 'PTHR24292:SF84', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 28A5-RELATED', 253453),
(430315, 'PTHR24292', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', 253453),
(430316, 'PTHR24292:SF93', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 310A1-RELATED', 253453),
(430317, 'PTHR24292:SF45', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 6G1-RELATED', 253453),
(430318, 'PTHR24292:SF98', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY', 253453),
(430319, 'PTHR24292:SF54', NULL, NULL, NULL, NULL, 'CYP9F3-RELATED', 253453),
(430320, 'PTHR24292:SF100', NULL, NULL, NULL, NULL, 'CYP6A16, ISOFORM B-RELATED', 253453),
(430321, 'PTHR13452:SF15', NULL, NULL, NULL, NULL, 'THUMP DOMAIN-CONTAINING PROTEIN 1', 253454),
(430322, 'PTHR13452:SF14', NULL, NULL, NULL, NULL, 'THUMP DOMAIN-CONTAINING PROTEIN', 253454),
(430323, 'PTHR13452:SF13', NULL, NULL, NULL, NULL, 'OS02G0672400 PROTEIN', 253454),
(430324, 'PTHR13452:SF11', NULL, NULL, NULL, NULL, 'THUMP DOMAIN-CONTAINING PROTEIN', 253454),
(430325, 'PTHR13452:SF10', NULL, NULL, NULL, NULL, 'THUMP DOMAIN-CONTAINING PROTEIN 1', 253454),
(430326, 'PTHR13452', NULL, NULL, NULL, NULL, 'THUMP DOMAIN CONTAINING PROTEIN 1-RELATED', 253454),
(430327, 'PTHR33392', NULL, NULL, NULL, NULL, 'POLYISOPRENYL-TEICHOIC ACID--PEPTIDOGLYCAN TEICHOIC ACID TRANSFERASE TAGU', 253455),
(430328, 'PTHR33392:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, LYTR FAMILY', 253455),
(430329, 'PTHR33392:SF6', NULL, NULL, NULL, NULL, 'POLYISOPRENYL-TEICHOIC ACID--PEPTIDOGLYCAN TEICHOIC ACID TRANSFERASE TAGU', 253455),
(430330, 'PTHR33392:SF8', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN MSRR', 253455),
(430331, 'PTHR33392:SF10', NULL, NULL, NULL, NULL, 'POLYISOPRENYL-TEICHOIC ACID--PEPTIDOGLYCAN TEICHOIC ACID TRANSFERASE TAGT', 253455),
(430332, 'PTHR30050:SF8', NULL, NULL, NULL, NULL, 'PRIMOSOMAL PROTEIN DNAI', 253456),
(430333, 'PTHR30050:SF10', NULL, NULL, NULL, NULL, 'PHAGE-LIKE ELEMENT PBSX PROTEIN XKDC', 253456),
(430334, 'PTHR30050:SF5', NULL, NULL, NULL, NULL, 'DNAA REGULATORY INACTIVATOR HDA', 253456),
(430335, 'PTHR30050:SF9', NULL, NULL, NULL, NULL, 'DNA REPLICATION PROTEIN DNAC', 253456),
(430336, 'PTHR30050', NULL, NULL, NULL, NULL, 'CHROMOSOMAL REPLICATION INITIATOR PROTEIN DNAA', 253456);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(430337, 'PTHR30050:SF4', NULL, NULL, NULL, NULL, 'ATP-BINDING PROTEIN RV3427C IN INSERTION SEQUENCE-RELATED', 253456),
(430338, 'PTHR30050:SF2', NULL, NULL, NULL, NULL, 'CHROMOSOMAL REPLICATION INITIATOR PROTEIN DNAA', 253456),
(430339, 'PTHR31021:SF2', NULL, NULL, NULL, NULL, 'PROTEIN APCDD1', 253457),
(430340, 'PTHR31021:SF3', NULL, NULL, NULL, NULL, 'PROTEIN APCDD1-LIKE', 253457),
(430341, 'PTHR31021', NULL, NULL, NULL, NULL, 'ADENOMATOSIS POLYPOSIS COLI DOWN-REGULATED 1', 253457),
(430342, 'PTHR31021:SF1', NULL, NULL, NULL, NULL, 'APCDDC DOMAIN-CONTAINING PROTEIN', 253457),
(430343, 'PTHR12517', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 13B', 253458),
(430344, 'PTHR12517:SF0', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 13B', 253458),
(430345, 'PTHR21345:SF3', NULL, NULL, NULL, NULL, 'PROTEIN SPIRE', 253459),
(430346, 'PTHR21345:SF5', NULL, NULL, NULL, NULL, 'PROTEIN SPIRE HOMOLOG 2', 253459),
(430347, 'PTHR21345', NULL, NULL, NULL, NULL, 'SPIRE', 253459),
(430348, 'PTHR21345:SF7', NULL, NULL, NULL, NULL, 'KIND DOMAIN-CONTAINING PROTEIN', 253459),
(430349, 'PTHR21345:SF8', NULL, NULL, NULL, NULL, 'PROTEIN SPIRE HOMOLOG 1', 253459),
(430350, 'PTHR21139:SF17', NULL, NULL, NULL, NULL, 'TRIOSEPHOSPHATE ISOMERASE A', 253460),
(430351, 'PTHR21139:SF39', NULL, NULL, NULL, NULL, 'TRIOSEPHOSPHATE ISOMERASE', 253460),
(430352, 'PTHR21139', NULL, NULL, NULL, NULL, 'TRIOSEPHOSPHATE ISOMERASE', 253460),
(430353, 'PTHR21139:SF38', NULL, NULL, NULL, NULL, 'TRIOSEPHOSPHATE ISOMERASE', 253460),
(430354, 'PTHR21139:SF19', NULL, NULL, NULL, NULL, 'TRIOSEPHOSPHATE ISOMERASE B', 253460),
(430355, 'PTHR21139:SF29', NULL, NULL, NULL, NULL, 'TRIOSEPHOSPHATE ISOMERASE, CHLOROPLASTIC-LIKE', 253460),
(430356, 'PTHR21139:SF35', NULL, NULL, NULL, NULL, 'BNAA07G37840D PROTEIN', 253460),
(430357, 'PTHR21139:SF2', NULL, NULL, NULL, NULL, 'TRIOSEPHOSPHATE ISOMERASE', 253460),
(430358, 'PTHR21139:SF24', NULL, NULL, NULL, NULL, 'TRIOSEPHOSPHATE ISOMERASE', 253460),
(430359, 'PTHR21139:SF34', NULL, NULL, NULL, NULL, 'TRIOSEPHOSPHATE ISOMERASE, CYTOSOLIC', 253460),
(430360, 'PTHR21139:SF23', NULL, NULL, NULL, NULL, 'TRIOSEPHOSPHATE ISOMERASE', 253460),
(430361, 'PTHR21139:SF26', NULL, NULL, NULL, NULL, 'BNAA04G12000D PROTEIN', 253460),
(430362, 'PTHR21139:SF37', NULL, NULL, NULL, NULL, 'OS01G0841600 PROTEIN', 253460),
(430363, 'PTHR21139:SF36', NULL, NULL, NULL, NULL, 'TRIOSEPHOSPHATE ISOMERASE, CHLOROPLASTIC-LIKE', 253460),
(430364, 'PTHR46302:SF3', NULL, NULL, NULL, NULL, 'DOUBLECORTIN DOMAIN-CONTAINING PROTEIN 1', 253461),
(430365, 'PTHR46302', NULL, NULL, NULL, NULL, 'DOUBLECORTIN DOMAIN-CONTAINING PROTEIN 1', 253461),
(430366, 'PTHR10947', NULL, NULL, NULL, NULL, 'PHENYLALANYL-TRNA SYNTHETASE BETA CHAIN AND LEUCINE-RICH REPEAT-CONTAINING PROTEIN 47', 253462),
(430367, 'PTHR10947:SF0', NULL, NULL, NULL, NULL, 'PHENYLALANINE--TRNA LIGASE BETA SUBUNIT', 253462),
(430368, 'PTHR10947:SF3', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 47', 253462),
(430369, 'PTHR31422:SF0', NULL, NULL, NULL, NULL, 'MYOSIN-BINDING PROTEIN 7', 253463),
(430370, 'PTHR31422:SF3', NULL, NULL, NULL, NULL, 'GTD-BINDING DOMAIN-CONTAINING PROTEIN', 253463),
(430371, 'PTHR31422:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FLOURY 1-LIKE', 253463),
(430372, 'PTHR31422:SF1', NULL, NULL, NULL, NULL, 'OS08G0442350 PROTEIN', 253463),
(430373, 'PTHR31422', NULL, NULL, NULL, NULL, 'BNAANNG28530D PROTEIN', 253463),
(430374, 'PTHR31422:SF29', NULL, NULL, NULL, NULL, 'GTD-BINDING DOMAIN-CONTAINING PROTEIN', 253463),
(430375, 'PTHR31422:SF5', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 253463),
(430376, 'PTHR31422:SF49', NULL, NULL, NULL, NULL, 'GTD-BINDING DOMAIN-CONTAINING PROTEIN', 253463),
(430377, 'PTHR31422:SF27', NULL, NULL, NULL, NULL, 'DUF593-CONTAINING PROTEIN 1', 253463),
(430378, 'PTHR31422:SF28', NULL, NULL, NULL, NULL, 'F26K24.14 PROTEIN', 253463),
(430379, 'PTHR31422:SF24', NULL, NULL, NULL, NULL, 'GTD-BINDING DOMAIN-CONTAINING PROTEIN', 253463),
(430380, 'PTHR31422:SF21', NULL, NULL, NULL, NULL, 'OS07G0162200 PROTEIN', 253463);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(430381, 'PTHR31422:SF43', NULL, NULL, NULL, NULL, 'ZEIN-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 253463),
(430382, 'PTHR31422:SF44', NULL, NULL, NULL, NULL, 'GTD-BINDING DOMAIN-CONTAINING PROTEIN', 253463),
(430383, 'PTHR31422:SF22', NULL, NULL, NULL, NULL, 'GTD-BINDING DOMAIN-CONTAINING PROTEIN', 253463),
(430384, 'PTHR31422:SF20', NULL, NULL, NULL, NULL, 'GTD-BINDING DOMAIN-CONTAINING PROTEIN', 253463),
(430385, 'PTHR31422:SF40', NULL, NULL, NULL, NULL, 'GTD-BINDING DOMAIN-CONTAINING PROTEIN', 253463),
(430386, 'PTHR31422:SF17', NULL, NULL, NULL, NULL, 'OS08G0269000 PROTEIN', 253463),
(430387, 'PTHR31422:SF39', NULL, NULL, NULL, NULL, 'GTD-BINDING DOMAIN-CONTAINING PROTEIN', 253463),
(430388, 'PTHR31422:SF58', NULL, NULL, NULL, NULL, 'GTD-BINDING DOMAIN-CONTAINING PROTEIN', 253463),
(430389, 'PTHR31422:SF56', NULL, NULL, NULL, NULL, 'MYOSIN-BINDING PROTEIN 7-LIKE', 253463),
(430390, 'PTHR31422:SF57', NULL, NULL, NULL, NULL, 'ZEIN-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 253463),
(430391, 'PTHR31422:SF35', NULL, NULL, NULL, NULL, 'GTD-BINDING DOMAIN-CONTAINING PROTEIN', 253463),
(430392, 'PTHR31422:SF54', NULL, NULL, NULL, NULL, 'GTD-BINDING DOMAIN-CONTAINING PROTEIN', 253463),
(430393, 'PTHR31422:SF55', NULL, NULL, NULL, NULL, 'OS12G0488700 PROTEIN', 253463),
(430394, 'PTHR31422:SF52', NULL, NULL, NULL, NULL, 'ZEIN-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 253463),
(430395, 'PTHR31422:SF53', NULL, NULL, NULL, NULL, 'GTD-BINDING DOMAIN-CONTAINING PROTEIN', 253463),
(430396, 'PTHR31422:SF51', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 253463),
(430397, 'PTHR47965:SF83', NULL, NULL, NULL, NULL, 'NEPENTHESIN-RELATED', 253464),
(430398, 'PTHR47965:SF84', NULL, NULL, NULL, NULL, 'BASIC 7S GLOBULIN-LIKE', 253464),
(430399, 'PTHR47965:SF40', NULL, NULL, NULL, NULL, 'BETA-SECRETASE 2', 253464),
(430400, 'PTHR47965:SF41', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 253464),
(430401, 'PTHR47965:SF85', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253464),
(430402, 'PTHR47965:SF5', NULL, NULL, NULL, NULL, 'BASIC 7S GLOBULIN-LIKE', 253464),
(430403, 'PTHR47965:SF42', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253464),
(430404, 'PTHR47965:SF87', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 253464),
(430405, 'PTHR47965:SF43', NULL, NULL, NULL, NULL, 'BASIC 7S GLOBULIN-LIKE', 253464),
(430406, 'PTHR47965:SF44', NULL, NULL, NULL, NULL, '7S GLOBULIN 2 SMALL SUBUNIT, PUTATIVE-RELATED', 253464),
(430407, 'PTHR47965:SF3', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253464),
(430408, 'PTHR47965:SF45', NULL, NULL, NULL, NULL, 'OS01G0954900 PROTEIN', 253464),
(430409, 'PTHR47965:SF2', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253464),
(430410, 'PTHR47965:SF46', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253464),
(430411, 'PTHR47965:SF47', NULL, NULL, NULL, NULL, 'OS01G0937600 PROTEIN', 253464),
(430412, 'PTHR47965:SF48', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253464),
(430413, 'PTHR47965:SF49', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253464),
(430414, 'PTHR47965:SF9', NULL, NULL, NULL, NULL, 'ASPARTYL PROTEASE AED3', 253464),
(430415, 'PTHR47965:SF8', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 253464),
(430416, 'PTHR47965:SF6', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE GIP1-RELATED', 253464),
(430417, 'PTHR47965:SF91', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253464),
(430418, 'PTHR47965:SF92', NULL, NULL, NULL, NULL, 'BASIC 7S GLOBULIN-LIKE', 253464),
(430419, 'PTHR47965:SF71', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 253464),
(430420, 'PTHR47965:SF73', NULL, NULL, NULL, NULL, 'XYLANASE INHIBITOR 725OS', 253464),
(430421, 'PTHR47965:SF74', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253464),
(430422, 'PTHR47965:SF30', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253464);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(430423, 'PTHR47965:SF31', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253464),
(430424, 'PTHR47965:SF32', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253464),
(430425, 'PTHR47965:SF76', NULL, NULL, NULL, NULL, 'TAXI_C DOMAIN-CONTAINING PROTEIN', 253464),
(430426, 'PTHR47965:SF77', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE PCS1', 253464),
(430427, 'PTHR47965:SF33', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253464),
(430428, 'PTHR47965:SF79', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE', 253464),
(430429, 'PTHR47965:SF35', NULL, NULL, NULL, NULL, 'XYLANASE INHIBITOR', 253464),
(430430, 'PTHR47965:SF36', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE PCS1-LIKE', 253464),
(430431, 'PTHR47965:SF37', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN-RELATED', 253464),
(430432, 'PTHR47965:SF38', NULL, NULL, NULL, NULL, 'PROTEASE FAMILY PROTEIN, PUTATIVE-RELATED', 253464),
(430433, 'PTHR47965:SF60', NULL, NULL, NULL, NULL, 'CHITINASE CLP', 253464),
(430434, 'PTHR47965:SF61', NULL, NULL, NULL, NULL, 'OS01G0937100 PROTEIN', 253464),
(430435, 'PTHR47965:SF63', NULL, NULL, NULL, NULL, 'OS01G0937200 PROTEIN', 253464),
(430436, 'PTHR47965:SF20', NULL, NULL, NULL, NULL, 'OS05G0591300 PROTEIN', 253464),
(430437, 'PTHR47965:SF21', NULL, NULL, NULL, NULL, 'OS06G0304600 PROTEIN', 253464),
(430438, 'PTHR47965:SF22', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 253464),
(430439, 'PTHR47965:SF67', NULL, NULL, NULL, NULL, 'BASIC 7S GLOBULIN 2-LIKE', 253464),
(430440, 'PTHR47965:SF68', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 253464),
(430441, 'PTHR47965:SF69', NULL, NULL, NULL, NULL, 'BETA-SECRETASE 1', 253464),
(430442, 'PTHR47965:SF26', NULL, NULL, NULL, NULL, 'OS09G0423500 PROTEIN', 253464),
(430443, 'PTHR47965:SF27', NULL, NULL, NULL, NULL, 'ASPARTIC PEPTIDASE A1 FAMILY-RELATED', 253464),
(430444, 'PTHR47965:SF28', NULL, NULL, NULL, NULL, 'BASIC 7S GLOBULIN', 253464),
(430445, 'PTHR47965:SF93', NULL, NULL, NULL, NULL, 'OS08G0267300 PROTEIN', 253464),
(430446, 'PTHR47965:SF50', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253464),
(430447, 'PTHR47965:SF94', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253464),
(430448, 'PTHR47965:SF51', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 253464),
(430449, 'PTHR47965:SF95', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253464),
(430450, 'PTHR47965:SF96', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253464),
(430451, 'PTHR47965:SF52', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 253464),
(430452, 'PTHR47965:SF97', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253464),
(430453, 'PTHR47965:SF53', NULL, NULL, NULL, NULL, 'PROTEASE FAMILY PROTEIN, PUTATIVE-RELATED', 253464),
(430454, 'PTHR47965:SF98', NULL, NULL, NULL, NULL, 'ASPARTIC PEPTIDASE A1 FAMILY-RELATED', 253464),
(430455, 'PTHR47965:SF10', NULL, NULL, NULL, NULL, 'OS01G0844500 PROTEIN', 253464),
(430456, 'PTHR47965:SF54', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253464),
(430457, 'PTHR47965:SF11', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN, EXPRESSED', 253464),
(430458, 'PTHR47965:SF55', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253464),
(430459, 'PTHR47965:SF99', NULL, NULL, NULL, NULL, 'BASIC 7S GLOBULIN-LIKE', 253464),
(430460, 'PTHR47965:SF12', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE 3-RELATED', 253464),
(430461, 'PTHR47965:SF13', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253464),
(430462, 'PTHR47965:SF102', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN, EXPRESSED', 253464),
(430463, 'PTHR47965:SF101', NULL, NULL, NULL, NULL, 'HYPOTHETICAL ASPARTYL PROTEASE (EUROFUNG)-RELATED', 253464),
(430464, 'PTHR47965:SF14', NULL, NULL, NULL, NULL, 'ASPARTIC PEPTIDASE A1 FAMILY-RELATED', 253464),
(430465, 'PTHR47965:SF104', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253464);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(430466, 'PTHR47965:SF16', NULL, NULL, NULL, NULL, 'BASIC 7S GLOBULIN-LIKE', 253464),
(430467, 'PTHR47965:SF103', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253464),
(430468, 'PTHR47965:SF17', NULL, NULL, NULL, NULL, 'OS01G0936900 PROTEIN', 253464),
(430469, 'PTHR47965', NULL, NULL, NULL, NULL, 'ASPARTYL PROTEASE-RELATED', 253464),
(430470, 'PTHR47965:SF19', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253464),
(430471, 'PTHR47965:SF100', NULL, NULL, NULL, NULL, 'BASIC 7S GLOBULIN 2-LIKE', 253464),
(430472, 'PTHR47965:SF106', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253464),
(430473, 'PTHR47965:SF105', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE YAPSIN-7', 253464),
(430474, 'PTHR47965:SF107', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253464),
(430475, 'PTHR18905:SF13', NULL, NULL, NULL, NULL, 'BLASTODERM-SPECIFIC PROTEIN 25D', 253465),
(430476, 'PTHR18905:SF11', NULL, NULL, NULL, NULL, 'NINEIN', 253465),
(430477, 'PTHR18905:SF12', NULL, NULL, NULL, NULL, 'NINEIN-LIKE PROTEIN', 253465),
(430478, 'PTHR18905', NULL, NULL, NULL, NULL, 'NINEIN', 253465),
(430479, 'PTHR30600', NULL, NULL, NULL, NULL, 'CYTOCHROME C PEROXIDASE-RELATED', 253466),
(430480, 'PTHR30600:SF12', NULL, NULL, NULL, NULL, 'BLL6722 PROTEIN', 253466),
(430481, 'PTHR30600:SF10', NULL, NULL, NULL, NULL, 'METHYLAMINE UTILIZATION PROTEIN', 253466),
(430482, 'PTHR30600:SF4', NULL, NULL, NULL, NULL, 'THIOL OXIDOREDUCTASE-RELATED', 253466),
(430483, 'PTHR30600:SF7', NULL, NULL, NULL, NULL, 'CYTOCHROME C PEROXIDASE-RELATED', 253466),
(430484, 'PTHR30600:SF9', NULL, NULL, NULL, NULL, 'BLR7738 PROTEIN', 253466),
(430485, 'PTHR12334:SF6', NULL, NULL, NULL, NULL, 'BAG FAMILY MOLECULAR CHAPERONE REGULATOR 2', 253467),
(430486, 'PTHR12334', NULL, NULL, NULL, NULL, 'BAG FAMILY MOLECULAR CHAPERONE REGULATOR 2', 253467),
(430487, 'PTHR31479:SF2', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 253468),
(430488, 'PTHR31479:SF18', NULL, NULL, NULL, NULL, 'ALPHA/BETA HYDROLASE-RELATED', 253468),
(430489, 'PTHR31479:SF39', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 253468),
(430490, 'PTHR31479:SF27', NULL, NULL, NULL, NULL, 'OS01G0719900 PROTEIN', 253468),
(430491, 'PTHR31479:SF38', NULL, NULL, NULL, NULL, '', 253468),
(430492, 'PTHR31479:SF37', NULL, NULL, NULL, NULL, 'TRIACYLGLYCEROL LIPASE', 253468),
(430493, 'PTHR31479:SF15', NULL, NULL, NULL, NULL, '', 253468),
(430494, 'PTHR31479:SF25', NULL, NULL, NULL, NULL, 'OS07G0528400 PROTEIN', 253468),
(430495, 'PTHR31479:SF14', NULL, NULL, NULL, NULL, 'GB|AAD29063.1', 253468),
(430496, 'PTHR31479:SF36', NULL, NULL, NULL, NULL, 'ALPHA/BETA HYDROLASE-RELATED', 253468),
(430497, 'PTHR31479:SF24', NULL, NULL, NULL, NULL, 'LIPASE CLASS 3-RELATED PROTEIN-RELATED', 253468),
(430498, 'PTHR31479:SF35', NULL, NULL, NULL, NULL, '', 253468),
(430499, 'PTHR31479:SF23', NULL, NULL, NULL, NULL, '', 253468),
(430500, 'PTHR31479:SF34', NULL, NULL, NULL, NULL, 'CLASS 3-RELATED PROTEIN, PUTATIVE-RELATED', 253468),
(430501, 'PTHR31479:SF12', NULL, NULL, NULL, NULL, 'SUPERFAMILY PROTEIN, PUTATIVE-RELATED', 253468),
(430502, 'PTHR31479:SF21', NULL, NULL, NULL, NULL, 'TRIACYLGLYCEROL LIPASE', 253468),
(430503, 'PTHR31479:SF31', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 253468),
(430504, 'PTHR31479:SF40', NULL, NULL, NULL, NULL, 'OS01G0751600 PROTEIN', 253468),
(430505, 'PTHR31479', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 253468),
(430506, 'PTHR31479:SF4', NULL, NULL, NULL, NULL, 'LIPASE_3 DOMAIN-CONTAINING PROTEIN', 253468),
(430507, 'PTHR31479:SF3', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 253468),
(430508, 'PTHR31479:SF6', NULL, NULL, NULL, NULL, 'OS07G0586800 PROTEIN', 253468),
(430509, 'PTHR31479:SF5', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 253468),
(430510, 'PTHR34266', NULL, NULL, NULL, NULL, 'THIAZOLE SYNTHASE', 253469),
(430511, 'PTHR34266:SF2', NULL, NULL, NULL, NULL, 'THIAZOLE SYNTHASE', 253469);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(430512, 'PTHR38103:SF1', NULL, NULL, NULL, NULL, 'RECOMBINATION-ASSOCIATED PROTEIN RDGC', 253470),
(430513, 'PTHR38103', NULL, NULL, NULL, NULL, 'RECOMBINATION-ASSOCIATED PROTEIN RDGC', 253470),
(430514, 'PTHR47829', NULL, NULL, NULL, NULL, 'HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G12880)-RELATED', 253471),
(430515, 'PTHR47829:SF1', NULL, NULL, NULL, NULL, 'HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G12880)-RELATED', 253471),
(430516, 'PTHR47829:SF2', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 253471),
(430517, 'PTHR14038:SF5', NULL, NULL, NULL, NULL, 'PROTEIN PRRC2A', 253472),
(430518, 'PTHR14038:SF6', NULL, NULL, NULL, NULL, 'PROTEIN PRRC2C', 253472),
(430519, 'PTHR14038:SF4', NULL, NULL, NULL, NULL, 'PROTEIN PRRC2B', 253472),
(430520, 'PTHR14038:SF0', NULL, NULL, NULL, NULL, 'LP18708P', 253472),
(430521, 'PTHR14038', NULL, NULL, NULL, NULL, 'BAT2  HLA-B-ASSOCIATED TRANSCRIPT 2', 253472),
(430522, 'PTHR13769:SF5', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN BB, TANDEM DUPLICATE 1-RELATED', 253473),
(430523, 'PTHR13769', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN B', 253473),
(430524, 'PTHR13769:SF1', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN B-100', 253473),
(430525, 'PTHR43467', NULL, NULL, NULL, NULL, 'COBALT-PRECORRIN-2 C(20)-METHYLTRANSFERASE', 253474),
(430526, 'PTHR43467:SF2', NULL, NULL, NULL, NULL, 'COBALT-PRECORRIN-2 C(20)-METHYLTRANSFERASE', 253474),
(430527, 'PTHR43467:SF1', NULL, NULL, NULL, NULL, 'PRECORRIN-6A SYNTHASE [DEACETYLATING]', 253474),
(430528, 'PTHR14679', NULL, NULL, NULL, NULL, 'GEM-ASSOCIATED PROTEIN 7', 253475),
(430529, 'PTHR14679:SF1', NULL, NULL, NULL, NULL, 'GEM-ASSOCIATED PROTEIN 7', 253475),
(430530, 'PTHR21419:SF36', NULL, NULL, NULL, NULL, '', 253476),
(430531, 'PTHR21419:SF25', NULL, NULL, NULL, NULL, 'PROTEIN FAM234B', 253476),
(430532, 'PTHR21419:SF35', NULL, NULL, NULL, NULL, 'BNAANNG24460D PROTEIN', 253476),
(430533, 'PTHR21419:SF29', NULL, NULL, NULL, NULL, 'LD24894P', 253476),
(430534, 'PTHR21419', NULL, NULL, NULL, NULL, '', 253476),
(430535, 'PTHR21419:SF7', NULL, NULL, NULL, NULL, 'PROTEIN FAM234A', 253476),
(430536, 'PTHR21419:SF30', NULL, NULL, NULL, NULL, '', 253476),
(430537, 'PTHR21419:SF23', NULL, NULL, NULL, NULL, 'PROTEIN DEFECTIVE IN EXINE FORMATION 1', 253476),
(430538, 'PTHR21419:SF34', NULL, NULL, NULL, NULL, 'PROTEIN DEFECTIVE IN EXINE FORMATION 1-LIKE ISOFORM X1', 253476),
(430539, 'PTHR11505:SF215', NULL, NULL, NULL, NULL, 'SI:CH211-196C10.15', 253477),
(430540, 'PTHR11505:SF204', NULL, NULL, NULL, NULL, '', 253477),
(430541, 'PTHR11505', NULL, NULL, NULL, NULL, 'L1 TRANSPOSABLE ELEMENT-RELATED', 253477),
(430542, 'PTHR11505:SF203', NULL, NULL, NULL, NULL, 'LINE-1 TYPE TRANSPOSASE DOMAIN-CONTAINING PROTEIN 1', 253477),
(430543, 'PTHR11505:SF205', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 253477),
(430544, 'PTHR11505:SF211', NULL, NULL, NULL, NULL, 'TRANSPOSASE_22 DOMAIN-CONTAINING PROTEIN', 253477),
(430545, 'PTHR11505:SF210', NULL, NULL, NULL, NULL, '', 253477),
(430546, 'PTHR11505:SF212', NULL, NULL, NULL, NULL, 'LINE-1 RETROTRANSPOSABLE ELEMENT ORF1 PROTEIN', 253477),
(430547, 'PTHR11707:SF28', NULL, NULL, NULL, NULL, '60 KDA LYSOPHOSPHOLIPASE', 253478),
(430548, 'PTHR11707', NULL, NULL, NULL, NULL, 'L-ASPARAGINASE', 253478),
(430549, 'PTHR36722:SF1', NULL, NULL, NULL, NULL, 'TYPE 2 DNA TOPOISOMERASE 6 SUBUNIT B-LIKE', 253479),
(430550, 'PTHR36722', NULL, NULL, NULL, NULL, 'TYPE 2 DNA TOPOISOMERASE 6 SUBUNIT B-LIKE', 253479),
(430551, 'PTHR31889:SF71', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430552, 'PTHR31889:SF72', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430553, 'PTHR31889:SF70', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430554, 'PTHR31889:SF75', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430555, 'PTHR31889:SF76', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430556, 'PTHR31889:SF73', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430557, 'PTHR31889:SF74', NULL, NULL, NULL, NULL, 'GALACTOSIDE 2-ALPHA-L-FUCOSYLTRANSFERASE', 253480);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(430558, 'PTHR31889', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE 2-RELATED', 253480),
(430559, 'PTHR31889:SF68', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430560, 'PTHR31889:SF69', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430561, 'PTHR31889:SF66', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430562, 'PTHR31889:SF67', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430563, 'PTHR31889:SF60', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430564, 'PTHR31889:SF61', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE 6', 253480),
(430565, 'PTHR31889:SF64', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430566, 'PTHR31889:SF62', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430567, 'PTHR31889:SF57', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430568, 'PTHR31889:SF14', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430569, 'PTHR31889:SF55', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430570, 'PTHR31889:SF11', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430571, 'PTHR31889:SF56', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE 9-RELATED', 253480),
(430572, 'PTHR31889:SF15', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430573, 'PTHR31889:SF59', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE 8-RELATED', 253480),
(430574, 'PTHR31889:SF50', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430575, 'PTHR31889:SF54', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430576, 'PTHR31889:SF52', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430577, 'PTHR31889:SF46', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430578, 'PTHR31889:SF45', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE 10-RELATED', 253480),
(430579, 'PTHR31889:SF49', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430580, 'PTHR31889:SF82', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430581, 'PTHR31889:SF83', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430582, 'PTHR31889:SF9', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430583, 'PTHR31889:SF80', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE 2', 253480),
(430584, 'PTHR31889:SF81', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE 7-RELATED', 253480),
(430585, 'PTHR31889:SF86', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430586, 'PTHR31889:SF43', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430587, 'PTHR31889:SF87', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430588, 'PTHR31889:SF40', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430589, 'PTHR31889:SF84', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430590, 'PTHR31889:SF85', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430591, 'PTHR31889:SF41', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430592, 'PTHR31889:SF2', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE 3', 253480),
(430593, 'PTHR31889:SF7', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430594, 'PTHR31889:SF6', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430595, 'PTHR31889:SF4', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430596, 'PTHR31889:SF35', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430597, 'PTHR31889:SF36', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430598, 'PTHR31889:SF78', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430599, 'PTHR31889:SF39', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430600, 'PTHR31889:SF37', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430601, 'PTHR31889:SF38', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE', 253480),
(430602, 'PTHR15835:SF12', NULL, NULL, NULL, NULL, 'ZINC ION-BINDING PROTEIN', 253481),
(430603, 'PTHR15835', NULL, NULL, NULL, NULL, 'NUCLEAR-INTERACTING PARTNER OF ALK', 253481),
(430604, 'PTHR15835:SF6', NULL, NULL, NULL, NULL, 'NUCLEAR-INTERACTING PARTNER OF ALK', 253481),
(430605, 'PTHR15835:SF16', NULL, NULL, NULL, NULL, 'F20D23.9 PROTEIN', 253481),
(430606, 'PTHR15835:SF15', NULL, NULL, NULL, NULL, 'ZINC FINGER, C3HC-LIKE PROTEIN-RELATED', 253481);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(430607, 'PTHR15835:SF14', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 253481),
(430608, 'PTHR34033:SF1', NULL, NULL, NULL, NULL, 'AP-5 COMPLEX SUBUNIT BETA-1', 253482),
(430609, 'PTHR34033', NULL, NULL, NULL, NULL, 'AP-5 COMPLEX SUBUNIT BETA-1', 253482),
(430610, 'PTHR45632:SF4', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 36', 253483),
(430611, 'PTHR45632:SF3', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN DIABLO', 253483),
(430612, 'PTHR45632:SF6', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 14', 253483),
(430613, 'PTHR45632:SF5', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 22', 253483),
(430614, 'PTHR45632:SF10', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 253483),
(430615, 'PTHR45632:SF11', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 9', 253483),
(430616, 'PTHR45632:SF14', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 33', 253483),
(430617, 'PTHR45632:SF25', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 253483),
(430618, 'PTHR45632:SF26', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 253483),
(430619, 'PTHR45632:SF15', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 253483),
(430620, 'PTHR45632:SF12', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 15', 253483),
(430621, 'PTHR45632:SF13', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 26', 253483),
(430622, 'PTHR45632:SF24', NULL, NULL, NULL, NULL, '', 253483),
(430623, 'PTHR45632:SF18', NULL, NULL, NULL, NULL, 'KELCH-LIKE FAMILY MEMBER 43', 253483),
(430624, 'PTHR45632:SF16', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 32', 253483),
(430625, 'PTHR45632:SF27', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', 253483),
(430626, 'PTHR45632:SF17', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 31', 253483),
(430627, 'PTHR45632', NULL, NULL, NULL, NULL, 'LD33804P', 253483),
(430628, 'PTHR45632:SF8', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 34', 253483),
(430629, 'PTHR45632:SF7', NULL, NULL, NULL, NULL, 'KELCH-LIKE PROTEIN 13', 253483),
(430630, 'PTHR45632:SF9', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN-RELATED', 253483),
(430631, 'PTHR47225:SF1', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING DOMAIN-CONTAINING PROTEIN 12', 253484),
(430632, 'PTHR47225', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING DOMAIN-CONTAINING PROTEIN 12', 253484),
(430633, 'PTHR42834:SF1', NULL, NULL, NULL, NULL, 'ENDONUCLEASE/EXONUCLEASE/PHOSPHATASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_3G09210)', 253485),
(430634, 'PTHR42834', NULL, NULL, NULL, NULL, 'ENDONUCLEASE/EXONUCLEASE/PHOSPHATASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_3G09210)', 253485),
(430635, 'PTHR44157:SF1', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 11', 253486),
(430636, 'PTHR44157:SF3', NULL, NULL, NULL, NULL, 'DNAJ (HSP40) HOMOLOG, SUBFAMILY C, MEMBER 11B', 253486),
(430637, 'PTHR44157:SF2', NULL, NULL, NULL, NULL, 'DNAJ (HSP40) HOMOLOG, SUBFAMILY C, MEMBER 11A', 253486),
(430638, 'PTHR44157', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 11', 253486),
(430639, 'PTHR12891:SF0', NULL, NULL, NULL, NULL, 'MMS19 NUCLEOTIDE EXCISION REPAIR PROTEIN HOMOLOG', 253487),
(430640, 'PTHR12891', NULL, NULL, NULL, NULL, 'DNA REPAIR/TRANSCRIPTION PROTEIN MET18/MMS19', 253487),
(430641, 'PTHR39649', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L40E', 253488),
(430642, 'PTHR39649:SF1', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L40E', 253488),
(430643, 'PTHR36482:SF6', NULL, NULL, NULL, NULL, '', 253489),
(430644, 'PTHR36482:SF7', NULL, NULL, NULL, NULL, 'OS04G0308500 PROTEIN', 253489),
(430645, 'PTHR36482:SF5', NULL, NULL, NULL, NULL, '23 KDA JASMONATE-INDUCED PROTEIN-LIKE', 253489),
(430646, 'PTHR36482:SF2', NULL, NULL, NULL, NULL, 'OS04G0308400 PROTEIN', 253489),
(430647, 'PTHR36482', NULL, NULL, NULL, NULL, 'OSJNBA0024J22.15 PROTEIN', 253489),
(430648, 'PTHR36482:SF8', NULL, NULL, NULL, NULL, '', 253489),
(430649, 'PTHR12352:SF27', NULL, NULL, NULL, NULL, '', 253490),
(430650, 'PTHR12352:SF3', NULL, NULL, NULL, NULL, 'NIDOGEN-2', 253490),
(430651, 'PTHR12352:SF30', NULL, NULL, NULL, NULL, 'FI05255P', 253490),
(430652, 'PTHR12352:SF21', NULL, NULL, NULL, NULL, 'SPARC-RELATED MODULAR CALCIUM-BINDING PROTEIN 2', 253490);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(430653, 'PTHR12352:SF31', NULL, NULL, NULL, NULL, 'THYROGLOBULIN TYPE-1 DOMAIN-CONTAINING PROTEIN', 253490),
(430654, 'PTHR12352', NULL, NULL, NULL, NULL, 'SECRETED MODULAR CALCIUM-BINDING PROTEIN', 253490),
(430655, 'PTHR12352:SF25', NULL, NULL, NULL, NULL, 'SPARC/OSTEONECTIN, CWCV AND KAZAL-LIKE DOMAINS PROTEOGLYCAN 1', 253490),
(430656, 'PTHR12352:SF13', NULL, NULL, NULL, NULL, 'SPARC-RELATED MODULAR CALCIUM-BINDING PROTEIN 1', 253490),
(430657, 'PTHR12352:SF24', NULL, NULL, NULL, NULL, 'AGAP007053-PA', 253490),
(430658, 'PTHR12232:SF1', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-BINDING GLUTAMIC ACID-RICH PROTEIN', 253491),
(430659, 'PTHR12232:SF0', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING PROTEIN', 253491),
(430660, 'PTHR12232:SF6', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-BINDING GLUTAMIC ACID-RICH-LIKE PROTEIN', 253491),
(430661, 'PTHR12232:SF5', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-BINDING GLUTAMIC ACID-RICH-LIKE PROTEIN', 253491),
(430662, 'PTHR12232:SF4', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-BINDING GLUTAMIC ACID-RICH-LIKE PROTEIN 2', 253491),
(430663, 'PTHR12232:SF14', NULL, NULL, NULL, NULL, 'ZGC:153284', 253491),
(430664, 'PTHR12232:SF3', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-BINDING GLUTAMIC ACID-RICH-LIKE PROTEIN 3', 253491),
(430665, 'PTHR12232:SF15', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-BINDING GLUTAMIC ACID-RICH PROTEIN HOMOLOG', 253491),
(430666, 'PTHR12232', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-BINDING GLUTAMIC ACID-RICH-LIKE PROTEIN', 253491),
(430667, 'PTHR42680:SF1', NULL, NULL, NULL, NULL, 'DEOXYURIDINE 5''-TRIPHOSPHATE NUCLEOTIDOHYDROLASE', 253492),
(430668, 'PTHR42680:SF2', NULL, NULL, NULL, NULL, 'DCTP DEAMINASE', 253492),
(430669, 'PTHR42680', NULL, NULL, NULL, NULL, 'DCTP DEAMINASE', 253492),
(430670, 'PTHR42680:SF3', NULL, NULL, NULL, NULL, 'DCTP DEAMINASE', 253492),
(430671, 'PTHR37418', NULL, NULL, NULL, NULL, '3-KETO-5-AMINOHEXANOATE CLEAVAGE ENZYME-RELATED', 253493),
(430672, 'PTHR37418:SF1', NULL, NULL, NULL, NULL, '', 253493),
(430673, 'PTHR37418:SF2', NULL, NULL, NULL, NULL, '3-KETO-5-AMINOHEXANOATE CLEAVAGE ENZYME', 253493),
(430674, 'PTHR32096:SF36', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 41-RELATED', 253494),
(430675, 'PTHR32096:SF110', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 253494),
(430676, 'PTHR32096:SF77', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 14-RELATED', 253494),
(430677, 'PTHR32096:SF79', NULL, NULL, NULL, NULL, 'WRKY DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 253494),
(430678, 'PTHR32096:SF112', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 253494),
(430679, 'PTHR32096', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 30-RELATED-RELATED', 253494),
(430680, 'PTHR32096:SF116', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 63-RELATED', 253494),
(430681, 'PTHR32096:SF115', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 253494),
(430682, 'PTHR32096:SF69', NULL, NULL, NULL, NULL, 'OS04G0597300 PROTEIN', 253494),
(430683, 'PTHR32096:SF28', NULL, NULL, NULL, NULL, 'OS03G0855100 PROTEIN', 253494),
(430684, 'PTHR32096:SF142', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 41-RELATED', 253494),
(430685, 'PTHR32096:SF141', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 69-RELATED', 253494),
(430686, 'PTHR32096:SF140', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 14-RELATED', 253494),
(430687, 'PTHR32096:SF23', NULL, NULL, NULL, NULL, 'OS01G0624700 PROTEIN', 253494),
(430688, 'PTHR32096:SF61', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 22', 253494),
(430689, 'PTHR32096:SF100', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 253494),
(430690, 'PTHR32096:SF107', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 253494),
(430691, 'PTHR32096:SF106', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 29-RELATED', 253494),
(430692, 'PTHR32096:SF104', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN-RELATED', 253494),
(430693, 'PTHR32096:SF109', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 253494),
(430694, 'PTHR32096:SF108', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 253494);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(430695, 'PTHR32096:SF19', NULL, NULL, NULL, NULL, 'OS01G0750100 PROTEIN', 253494),
(430696, 'PTHR32096:SF18', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RRS1B-RELATED', 253494),
(430697, 'PTHR32096:SF99', NULL, NULL, NULL, NULL, 'WRKY FAMILY TRANSCRIPTION FACTOR-RELATED', 253494),
(430698, 'PTHR32096:SF55', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR WRKY19', 253494),
(430699, 'PTHR32096:SF132', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 41-RELATED', 253494),
(430700, 'PTHR32096:SF98', NULL, NULL, NULL, NULL, 'OS06G0158100 PROTEIN', 253494),
(430701, 'PTHR32096:SF131', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 253494),
(430702, 'PTHR32096:SF57', NULL, NULL, NULL, NULL, 'WRKY DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 253494),
(430703, 'PTHR32096:SF95', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 253494),
(430704, 'PTHR32096:SF136', NULL, NULL, NULL, NULL, 'OS09G0334500 PROTEIN', 253494),
(430705, 'PTHR32096:SF94', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 53-RELATED', 253494),
(430706, 'PTHR32096:SF135', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 46-RELATED', 253494),
(430707, 'PTHR32096:SF134', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 253494),
(430708, 'PTHR32096:SF133', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 19-RELATED', 253494),
(430709, 'PTHR32096:SF91', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 253494),
(430710, 'PTHR32096:SF139', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 253494),
(430711, 'PTHR32096:SF138', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR WRKY FAMILY-RELATED', 253494),
(430712, 'PTHR32096:SF93', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 253494),
(430713, 'PTHR32096:SF137', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 253494),
(430714, 'PTHR32096:SF121', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 253494),
(430715, 'PTHR32096:SF89', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 253494),
(430716, 'PTHR32096:SF125', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 53-RELATED', 253494),
(430717, 'PTHR32096:SF83', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 54-RELATED', 253494),
(430718, 'PTHR32096:SF124', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 22-LIKE', 253494),
(430719, 'PTHR32096:SF80', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 27-RELATED', 253494),
(430720, 'PTHR32096:SF128', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 253494),
(430721, 'PTHR32096:SF127', NULL, NULL, NULL, NULL, 'WRKY DOMAIN-CONTAINING PROTEIN', 253494),
(430722, 'PTHR32096:SF126', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 29-RELATED', 253494),
(430723, 'PTHR24121:SF12', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 253495),
(430724, 'PTHR24121:SF2', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX PROTEIN 14', 253495),
(430725, 'PTHR24121:SF13', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', 253495),
(430726, 'PTHR24121:SF11', NULL, NULL, NULL, NULL, 'TONSOKU-LIKE PROTEIN', 253495),
(430727, 'PTHR24121:SF16', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 253495),
(430728, 'PTHR24121:SF17', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 253495),
(430729, 'PTHR24121:SF14', NULL, NULL, NULL, NULL, 'PROTEIN ACCELERATED CELL DEATH 6-LIKE', 253495),
(430730, 'PTHR24121:SF15', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 253495),
(430731, 'PTHR24121', NULL, NULL, NULL, NULL, 'NO MECHANORECEPTOR POTENTIAL C, ISOFORM D-RELATED', 253495),
(430732, 'PTHR24121:SF18', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 253495),
(430733, 'PTHR31492:SF14', NULL, NULL, NULL, NULL, 'M CELL-TYPE AGGLUTINATION PROTEIN MAM3-RELATED', 253496),
(430734, 'PTHR31492', NULL, NULL, NULL, NULL, 'M CELL-TYPE AGGLUTINATION PROTEIN MAM3-RELATED', 253496),
(430735, 'PTHR31492:SF15', NULL, NULL, NULL, NULL, 'CELL AGGLUTINATION PROTEIN SPAPB2C8.01-RELATED', 253496),
(430736, 'PTHR45523:SF6', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', 253497); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(430737, 'PTHR45523:SF1', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-CONTAINING PROTEIN', 253497),
(430738, 'PTHR45523:SF2', NULL, NULL, NULL, NULL, 'OS02G0470600 PROTEIN', 253497),
(430739, 'PTHR45523:SF3', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 13A-RELATED', 253497),
(430740, 'PTHR45523', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-CONTAINING PROTEIN-RELATED', 253497),
(430741, 'PTHR20898', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 253498),
(430742, 'PTHR20898:SF0', NULL, NULL, NULL, NULL, 'FI12029P-RELATED', 253498),
(430743, 'PTHR20898:SF1', NULL, NULL, NULL, NULL, 'FI17833P1', 253498),
(430744, 'PTHR45813:SF1', NULL, NULL, NULL, NULL, 'ADHESION G PROTEIN-COUPLED RECEPTOR F4', 253499),
(430745, 'PTHR45813', NULL, NULL, NULL, NULL, '', 253499),
(430746, 'PTHR45813:SF8', NULL, NULL, NULL, NULL, '', 253499),
(430747, 'PTHR45813:SF9', NULL, NULL, NULL, NULL, '', 253499),
(430748, 'PTHR45813:SF6', NULL, NULL, NULL, NULL, 'ADHESION G-PROTEIN COUPLED RECEPTOR F2', 253499),
(430749, 'PTHR45813:SF4', NULL, NULL, NULL, NULL, 'ADHESION G PROTEIN-COUPLED RECEPTOR F5', 253499),
(430750, 'PTHR45813:SF2', NULL, NULL, NULL, NULL, 'ADHESION G-PROTEIN COUPLED RECEPTOR F3', 253499),
(430751, 'PTHR45813:SF3', NULL, NULL, NULL, NULL, 'ADHESION G-PROTEIN COUPLED RECEPTOR F1', 253499),
(430752, 'PTHR37178:SF1', NULL, NULL, NULL, NULL, 'PLANT/PROTEIN', 253500),
(430753, 'PTHR37178', NULL, NULL, NULL, NULL, 'PLANT/PROTEIN', 253500),
(430754, 'PTHR12730', NULL, NULL, NULL, NULL, 'HSDA/SDA1-RELATED', 253501),
(430755, 'PTHR12730:SF2', NULL, NULL, NULL, NULL, 'PROTEIN SDA1', 253501),
(430756, 'PTHR12730:SF0', NULL, NULL, NULL, NULL, 'PROTEIN SDA1 HOMOLOG', 253501),
(430757, 'PTHR12730:SF1', NULL, NULL, NULL, NULL, 'PROTEIN SDA1 HOMOLOG', 253501),
(430758, 'PTHR48055:SF26', NULL, NULL, NULL, NULL, 'SERINE-THREONINE PROTEIN KINASE, PLANT-TYPE', 253502),
(430759, 'PTHR48055:SF25', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253502),
(430760, 'PTHR48055:SF46', NULL, NULL, NULL, NULL, 'REPEAT FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', 253502),
(430761, 'PTHR48055:SF24', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253502),
(430762, 'PTHR48055:SF45', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT PROTEIN KINASE FAMILY PROTEIN', 253502),
(430763, 'PTHR48055:SF23', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE-LIKE PROTEIN ACR4', 253502),
(430764, 'PTHR48055:SF29', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253502),
(430765, 'PTHR48055:SF28', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253502),
(430766, 'PTHR48055:SF27', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE FEI 2', 253502),
(430767, 'PTHR48055', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR PROTEIN KINASE EMS1', 253502),
(430768, 'PTHR48055:SF9', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253502),
(430769, 'PTHR48055:SF6', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR PROTEIN KINASE EMS1', 253502),
(430770, 'PTHR48055:SF40', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253502),
(430771, 'PTHR48055:SF3', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253502),
(430772, 'PTHR48055:SF2', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253502),
(430773, 'PTHR48055:SF44', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 253502),
(430774, 'PTHR48055:SF22', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253502),
(430775, 'PTHR48055:SF43', NULL, NULL, NULL, NULL, 'MDIS1-INTERACTING RECEPTOR LIKE KINASE 2-LIKE', 253502),
(430776, 'PTHR48055:SF21', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 2', 253502),
(430777, 'PTHR48055:SF42', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253502),
(430778, 'PTHR48055:SF20', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR PROTEIN KINASE MSP1', 253502),
(430779, 'PTHR48055:SF41', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253502);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(430780, 'PTHR48055:SF37', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253502),
(430781, 'PTHR48055:SF14', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253502),
(430782, 'PTHR48055:SF36', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253502),
(430783, 'PTHR48055:SF35', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINE RECEPTOR 2-RELATED', 253502),
(430784, 'PTHR48055:SF13', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE RPK1-RELATED', 253502),
(430785, 'PTHR48055:SF34', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE KINASE', 253502),
(430786, 'PTHR48055:SF19', NULL, NULL, NULL, NULL, 'RETROTRANSPOSON GAG PROTEIN', 253502),
(430787, 'PTHR48055:SF18', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253502),
(430788, 'PTHR48055:SF39', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR PROTEIN KINASE EMS1', 253502),
(430789, 'PTHR48055:SF38', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT SERINE/THREONINE-PROTEIN KINASE 1', 253502),
(430790, 'PTHR48055:SF33', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253502),
(430791, 'PTHR48055:SF32', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253502),
(430792, 'PTHR48055:SF31', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253502),
(430793, 'PTHR48055:SF30', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253502),
(430794, 'PTHR21534', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 253503),
(430795, 'PTHR21534:SF0', NULL, NULL, NULL, NULL, 'KATANIN-INTERACTING PROTEIN', 253503),
(430796, 'PTHR39647:SF1', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-BETA', 253504),
(430797, 'PTHR39647', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-BETA', 253504),
(430798, 'PTHR35442:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 249', 253505),
(430799, 'PTHR35442', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 249', 253505),
(430800, 'PTHR46929:SF23', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 253506),
(430801, 'PTHR46929:SF13', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DNA-BINDING DOMAIN PROTEIN', 253506),
(430802, 'PTHR46929:SF32', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 253506),
(430803, 'PTHR46929:SF11', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DNA-BINDING DOMAIN PROTEIN', 253506),
(430804, 'PTHR46929:SF30', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 253506),
(430805, 'PTHR46929:SF31', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 253506),
(430806, 'PTHR46929:SF29', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 253506),
(430807, 'PTHR46929:SF18', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DNA-BINDING DOMAIN PROTEIN', 253506),
(430808, 'PTHR46929:SF9', NULL, NULL, NULL, NULL, 'L10-INTERACTING MYB DOMAIN-CONTAINING PROTEIN-LIKE ISOFORM X1', 253506),
(430809, 'PTHR46929:SF16', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 253506),
(430810, 'PTHR46929:SF8', NULL, NULL, NULL, NULL, '', 253506),
(430811, 'PTHR46929:SF27', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DNA-BINDING DOMAIN PROTEIN', 253506),
(430812, 'PTHR46929:SF28', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DNA-BINDING DOMAIN PROTEIN', 253506),
(430813, 'PTHR46929:SF26', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 253506),
(430814, 'PTHR46929:SF15', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 253506),
(430815, 'PTHR46929:SF4', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 253506),
(430816, 'PTHR46929', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 253506),
(430817, 'PTHR46929:SF3', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 253506),
(430818, 'PTHR46929:SF2', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN', 253506),
(430819, 'PTHR46430:SF2', NULL, NULL, NULL, NULL, 'SYNTHASE ACTIVATOR (CHS3), PUTATIVE (AFU_ORTHOLOGUE AFUA_3G05580)-RELATED', 253507),
(430820, 'PTHR46430:SF3', NULL, NULL, NULL, NULL, 'ACTIVATOR OF C KINASE PROTEIN 1', 253507);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(430821, 'PTHR46430:SF1', NULL, NULL, NULL, NULL, 'CHITIN SYNTHASE REGULATOR SKT5-RELATED', 253507),
(430822, 'PTHR46430', NULL, NULL, NULL, NULL, 'PROTEIN SKT5-RELATED', 253507),
(430823, 'PTHR35814', NULL, NULL, NULL, NULL, '', 253508),
(430824, 'PTHR35814:SF1', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YECN', 253508),
(430825, 'PTHR31622:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 218', 253509),
(430826, 'PTHR31622', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 218', 253509),
(430827, 'PTHR33828:SF1', NULL, NULL, NULL, NULL, 'OS05G0596200 PROTEIN', 253510),
(430828, 'PTHR33828:SF2', NULL, NULL, NULL, NULL, 'NUCLEOLIN', 253510),
(430829, 'PTHR33828', NULL, NULL, NULL, NULL, 'OS05G0596200 PROTEIN', 253510),
(430830, 'PTHR34226:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBR-ABU-10', 253511),
(430831, 'PTHR34226:SF12', NULL, NULL, NULL, NULL, 'LAM_G_DOMAIN DOMAIN-CONTAINING PROTEIN', 253511),
(430832, 'PTHR34226:SF11', NULL, NULL, NULL, NULL, '', 253511),
(430833, 'PTHR34226', NULL, NULL, NULL, NULL, '', 253511),
(430834, 'PTHR23051:SF9', NULL, NULL, NULL, NULL, 'EAMA DOMAIN-CONTAINING PROTEIN', 253512),
(430835, 'PTHR23051', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 35, MEMBER F5', 253512),
(430836, 'PTHR23051:SF12', NULL, NULL, NULL, NULL, 'OS04G0645600 PROTEIN', 253512),
(430837, 'PTHR23051:SF11', NULL, NULL, NULL, NULL, 'BNAA01G32470D PROTEIN', 253512),
(430838, 'PTHR23051:SF10', NULL, NULL, NULL, NULL, 'EAMA DOMAIN-CONTAINING PROTEIN', 253512),
(430839, 'PTHR23051:SF0', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 35 MEMBER F5', 253512),
(430840, 'PTHR36344:SF5', NULL, NULL, NULL, NULL, '', 253513),
(430841, 'PTHR36344', NULL, NULL, NULL, NULL, '', 253513),
(430842, 'PTHR36344:SF1', NULL, NULL, NULL, NULL, '', 253513),
(430843, 'PTHR36344:SF2', NULL, NULL, NULL, NULL, '', 253513),
(430844, 'PTHR21516:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG24541', 253514),
(430845, 'PTHR21516', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 253514),
(430846, 'PTHR21516:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG06240', 253514),
(430847, 'PTHR21516:SF4', NULL, NULL, NULL, NULL, 'SNF2_N DOMAIN-CONTAINING PROTEIN', 253514),
(430848, 'PTHR35773', NULL, NULL, NULL, NULL, '', 253515),
(430849, 'PTHR35773:SF5', NULL, NULL, NULL, NULL, '40S RIBOSOMAL S10-LIKE PROTEIN', 253515),
(430850, 'PTHR36060', NULL, NULL, NULL, NULL, 'OS02G0272400 PROTEIN', 253516),
(430851, 'PTHR36060:SF2', NULL, NULL, NULL, NULL, 'BNAA03G52180D PROTEIN', 253516),
(430852, 'PTHR36060:SF1', NULL, NULL, NULL, NULL, 'OS02G0272400 PROTEIN', 253516),
(430853, 'PTHR42078', NULL, NULL, NULL, NULL, '', 253517),
(430854, 'PTHR42078:SF1', NULL, NULL, NULL, NULL, '', 253517),
(430855, 'PTHR46404', NULL, NULL, NULL, NULL, 'DNA POLYMERASE IOTA', 253518),
(430856, 'PTHR46404:SF1', NULL, NULL, NULL, NULL, 'DNA POLYMERASE IOTA', 253518),
(430857, 'PTHR42989:SF1', NULL, NULL, NULL, NULL, 'FORMATE HYDROGENLYASE SUBUNIT 7-RELATED', 253519),
(430858, 'PTHR42989', NULL, NULL, NULL, NULL, 'HYDROGENASE-4 COMPONENT I', 253519),
(430859, 'PTHR12888', NULL, NULL, NULL, NULL, 'PEROXISOME ASSEMBLY PROTEIN 12  PEROXIN-12', 253520),
(430860, 'PTHR12888:SF1', NULL, NULL, NULL, NULL, 'PEROXISOME ASSEMBLY PROTEIN 12', 253520),
(430861, 'PTHR12888:SF0', NULL, NULL, NULL, NULL, 'PEROXISOME ASSEMBLY PROTEIN 12', 253520),
(430862, 'PTHR12888:SF3', NULL, NULL, NULL, NULL, 'PEROXISOME BIOGENESIS PROTEIN 12', 253520),
(430863, 'PTHR12888:SF2', NULL, NULL, NULL, NULL, 'PEROXISOME ASSEMBLY PROTEIN 12', 253520),
(430864, 'PTHR17463:SF0', NULL, NULL, NULL, NULL, 'SCRAPIE-RESPONSIVE PROTEIN 1', 253521),
(430865, 'PTHR17463', NULL, NULL, NULL, NULL, 'SCRAPIE-RESPONSIVE PROTEIN 1 SCRG1', 253521),
(430866, 'PTHR23288', NULL, NULL, NULL, NULL, 'OCCLUDIN AND RNA POLYMERASE II ELONGATION FACTOR ELL', 253522),
(430867, 'PTHR23288:SF8', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II ELONGATION FACTOR ELL2', 253522),
(430868, 'PTHR23288:SF9', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II ELONGATION FACTOR ELL', 253522),
(430869, 'PTHR23288:SF6', NULL, NULL, NULL, NULL, 'OCCLUDIN', 253522); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(430870, 'PTHR23288:SF4', NULL, NULL, NULL, NULL, 'OCCLUDIN', 253522),
(430871, 'PTHR23288:SF17', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II ELONGATION FACTOR ELL', 253522),
(430872, 'PTHR23288:SF18', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II ELONGATION FACTOR ELL3', 253522),
(430873, 'PTHR23288:SF3', NULL, NULL, NULL, NULL, 'MARVEL DOMAIN-CONTAINING PROTEIN 2', 253522),
(430874, 'PTHR23288:SF37', NULL, NULL, NULL, NULL, 'SI:DKEY-208K22.6', 253522),
(430875, 'PTHR23288:SF15', NULL, NULL, NULL, NULL, 'OCCLUDIN/ELL DOMAIN-CONTAINING PROTEIN 1', 253522),
(430876, 'PTHR23288:SF38', NULL, NULL, NULL, NULL, 'OCCLUDIN', 253522),
(430877, 'PTHR23288:SF36', NULL, NULL, NULL, NULL, '', 253522),
(430878, 'PTHR23288:SF12', NULL, NULL, NULL, NULL, 'SI:CH211-13K12.2', 253522),
(430879, 'PTHR23288:SF34', NULL, NULL, NULL, NULL, 'OCCLUDIN B', 253522),
(430880, 'PTHR23288:SF40', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II ELONGATION FACTOR ELL2-LIKE', 253522),
(430881, 'PTHR31384:SF79', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 2', 253523),
(430882, 'PTHR31384:SF102', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 4', 253523),
(430883, 'PTHR31384:SF146', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 9', 253523),
(430884, 'PTHR31384:SF101', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430885, 'PTHR31384:SF37', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 8', 253523),
(430886, 'PTHR31384:SF104', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430887, 'PTHR31384:SF75', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430888, 'PTHR31384:SF105', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430889, 'PTHR31384:SF182', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 2', 253523),
(430890, 'PTHR31384:SF72', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 4', 253523),
(430891, 'PTHR31384:SF181', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430892, 'PTHR31384:SF74', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430893, 'PTHR31384:SF183', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430894, 'PTHR31384:SF141', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 1', 253523),
(430895, 'PTHR31384:SF144', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 2A', 253523),
(430896, 'PTHR31384:SF143', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430897, 'PTHR31384:SF109', NULL, NULL, NULL, NULL, 'BNAANNG13910D PROTEIN', 253523),
(430898, 'PTHR31384:SF39', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430899, 'PTHR31384:SF115', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 6', 253523),
(430900, 'PTHR31384:SF86', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 10', 253523),
(430901, 'PTHR31384:SF116', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430902, 'PTHR31384:SF119', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430903, 'PTHR31384:SF88', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430904, 'PTHR31384:SF40', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 24', 253523),
(430905, 'PTHR31384:SF151', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430906, 'PTHR31384:SF150', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 6', 253523),
(430907, 'PTHR31384:SF153', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430908, 'PTHR31384:SF111', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430909, 'PTHR31384:SF110', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430910, 'PTHR31384:SF81', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 18', 253523),
(430911, 'PTHR31384:SF13', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 3', 253523),
(430912, 'PTHR31384:SF168', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430913, 'PTHR31384:SF124', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430914, 'PTHR31384:SF167', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430915, 'PTHR31384:SF14', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 5', 253523),
(430916, 'PTHR31384:SF125', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523);
INSERT INTO "PUBLIC"."MODEL" VALUES
(430917, 'PTHR31384:SF169', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430918, 'PTHR31384:SF128', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430919, 'PTHR31384:SF10', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 5', 253523),
(430920, 'PTHR31384:SF127', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430921, 'PTHR31384:SF93', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 7', 253523),
(430922, 'PTHR31384:SF160', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 10', 253523),
(430923, 'PTHR31384:SF94', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 17', 253523),
(430924, 'PTHR31384:SF162', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430925, 'PTHR31384:SF161', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 18-LIKE', 253523),
(430926, 'PTHR31384:SF96', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 1', 253523),
(430927, 'PTHR31384:SF164', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 12-RELATED', 253523),
(430928, 'PTHR31384:SF163', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 21', 253523),
(430929, 'PTHR31384:SF90', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430930, 'PTHR31384:SF122', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430931, 'PTHR31384:SF166', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430932, 'PTHR31384:SF165', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 22', 253523),
(430933, 'PTHR31384', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 4-RELATED', 253523),
(430934, 'PTHR31384:SF179', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN', 253523),
(430935, 'PTHR31384:SF178', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 16', 253523),
(430936, 'PTHR31384:SF25', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430937, 'PTHR31384:SF137', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430938, 'PTHR31384:SF27', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430939, 'PTHR31384:SF136', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430940, 'PTHR31384:SF138', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430941, 'PTHR31384:SF21', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 19', 253523),
(430942, 'PTHR31384:SF22', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 17', 253523),
(430943, 'PTHR31384:SF23', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 14', 253523),
(430944, 'PTHR31384:SF171', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430945, 'PTHR31384:SF170', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430946, 'PTHR31384:SF173', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430947, 'PTHR31384:SF172', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 13', 253523),
(430948, 'PTHR31384:SF175', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430949, 'PTHR31384:SF131', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430950, 'PTHR31384:SF174', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430951, 'PTHR31384:SF130', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430952, 'PTHR31384:SF177', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 25', 253523),
(430953, 'PTHR31384:SF176', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430954, 'PTHR31384:SF132', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430955, 'PTHR31384:SF1', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 9', 253523),
(430956, 'PTHR31384:SF180', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR', 253523),
(430957, 'PTHR31384:SF8', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 11', 253523),
(430958, 'PTHR31384:SF9', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 19', 253523),
(430959, 'PTHR31384:SF5', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 3', 253523),
(430960, 'PTHR31384:SF3', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 8', 253523),
(430961, 'PTHR10114:SF22', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L36', 253524),
(430962, 'PTHR10114:SF21', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L36', 253524),
(430963, 'PTHR10114:SF20', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L36', 253524);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(430964, 'PTHR10114:SF31', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L36', 253524),
(430965, 'PTHR10114:SF30', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L36', 253524),
(430966, 'PTHR10114:SF0', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L36', 253524),
(430967, 'PTHR10114:SF19', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L36', 253524),
(430968, 'PTHR10114:SF29', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L36', 253524),
(430969, 'PTHR10114:SF28', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L36', 253524),
(430970, 'PTHR10114:SF27', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L36', 253524),
(430971, 'PTHR10114:SF26', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L36', 253524),
(430972, 'PTHR10114:SF14', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L36-1-RELATED', 253524),
(430973, 'PTHR10114:SF25', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L36', 253524),
(430974, 'PTHR10114', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L36', 253524),
(430975, 'PTHR10114:SF9', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L36', 253524),
(430976, 'PTHR10527:SF82', NULL, NULL, NULL, NULL, 'IMPORTIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 253525),
(430977, 'PTHR10527:SF83', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT BETA-1', 253525),
(430978, 'PTHR10527:SF63', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT BETA-LIKE PROTEIN', 253525),
(430979, 'PTHR10527:SF65', NULL, NULL, NULL, NULL, 'IMPORTIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 253525),
(430980, 'PTHR10527:SF21', NULL, NULL, NULL, NULL, 'TRANSPORTIN-1', 253525),
(430981, 'PTHR10527:SF77', NULL, NULL, NULL, NULL, 'IMPORTIN-5-LIKE', 253525),
(430982, 'PTHR10527:SF99', NULL, NULL, NULL, NULL, 'IMPORTIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 253525),
(430983, 'PTHR10527', NULL, NULL, NULL, NULL, 'IMPORTIN BETA', 253525),
(430984, 'PTHR10527:SF56', NULL, NULL, NULL, NULL, 'IMPORTIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 253525),
(430985, 'PTHR10527:SF58', NULL, NULL, NULL, NULL, 'IMPORTIN-5-LIKE', 253525),
(430986, 'PTHR10527:SF16', NULL, NULL, NULL, NULL, 'RAN-BINDING PROTEIN 6', 253525),
(430987, 'PTHR10527:SF17', NULL, NULL, NULL, NULL, 'TRANSPORTIN-2', 253525),
(430988, 'PTHR10527:SF102', NULL, NULL, NULL, NULL, 'RRNA PROCESSING/RIBOSOME BIOGENESIS PROTEIN', 253525),
(430989, 'PTHR10527:SF101', NULL, NULL, NULL, NULL, 'TOG DOMAIN-CONTAINING PROTEIN', 253525),
(430990, 'PTHR10527:SF100', NULL, NULL, NULL, NULL, 'BETA-3, PUTATIVE-RELATED', 253525),
(430991, 'PTHR10527:SF106', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT BETA-1', 253525),
(430992, 'PTHR10527:SF105', NULL, NULL, NULL, NULL, 'BETA-3 FAMILY PROTEIN, PUTATIVE-RELATED', 253525),
(430993, 'PTHR10527:SF104', NULL, NULL, NULL, NULL, 'HEAT REPEAT DOMAIN CONTAINING PROTEIN', 253525),
(430994, 'PTHR10527:SF103', NULL, NULL, NULL, NULL, 'IMPORTIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 253525),
(430995, 'PTHR10527:SF70', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 253525),
(430996, 'PTHR10527:SF71', NULL, NULL, NULL, NULL, 'IMPORTIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 253525),
(430997, 'PTHR10527:SF93', NULL, NULL, NULL, NULL, 'IMPORTIN BETA-3 SUBUNIT', 253525),
(430998, 'PTHR10527:SF72', NULL, NULL, NULL, NULL, 'IMPORTIN-5-LIKE', 253525),
(430999, 'PTHR10527:SF94', NULL, NULL, NULL, NULL, 'TRANSPORTIN2-LIKE PROTEIN', 253525),
(431000, 'PTHR10527:SF73', NULL, NULL, NULL, NULL, 'IMPORTIN-5-LIKE', 253525),
(431001, 'PTHR10527:SF95', NULL, NULL, NULL, NULL, 'IMPORTIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 253525),
(431002, 'PTHR10527:SF96', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 253525),
(431003, 'PTHR10527:SF52', NULL, NULL, NULL, NULL, 'IMPORTIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 253525),
(431004, 'PTHR10527:SF74', NULL, NULL, NULL, NULL, 'IMPORTIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 253525),
(431005, 'PTHR10527:SF97', NULL, NULL, NULL, NULL, 'IMPORTIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 253525),
(431006, 'PTHR10527:SF53', NULL, NULL, NULL, NULL, 'IMPORTIN N-TERMINAL DOMAIN-CONTAINING PROTEIN', 253525),
(431007, 'PTHR10527:SF98', NULL, NULL, NULL, NULL, 'TOG DOMAIN-CONTAINING PROTEIN', 253525);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(431008, 'PTHR10527:SF32', NULL, NULL, NULL, NULL, 'HEAT DOMAIN-CONTAINING PROTEIN', 253525),
(431009, 'PTHR10527:SF22', NULL, NULL, NULL, NULL, 'IMPORTIN-5', 253525),
(431010, 'PTHR10527:SF66', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', 253525),
(431011, 'PTHR10527:SF5', NULL, NULL, NULL, NULL, 'KARYOPHERIN (IMPORTIN) BETA 3', 253525),
(431012, 'PTHR10527:SF67', NULL, NULL, NULL, NULL, 'IMPORTIN-5-LIKE', 253525),
(431013, 'PTHR10527:SF69', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN-RELATED', 253525),
(431014, 'PTHR10527:SF6', NULL, NULL, NULL, NULL, 'IMPORTIN-4', 253525),
(431015, 'PTHR10527:SF1', NULL, NULL, NULL, NULL, 'IMPORTIN SUBUNIT BETA-1', 253525),
(431016, 'PTHR10527:SF3', NULL, NULL, NULL, NULL, 'FI21453P1-RELATED', 253525),
(431017, 'PTHR42934', NULL, NULL, NULL, NULL, 'GLYCOLATE OXIDASE SUBUNIT GLCD', 253526),
(431018, 'PTHR42934:SF1', NULL, NULL, NULL, NULL, 'GLYCOLATE OXIDASE SUBUNIT GLCD', 253526),
(431019, 'PTHR42934:SF2', NULL, NULL, NULL, NULL, 'GLYCOLATE OXIDASE SUBUNIT GLCD', 253526),
(431020, 'PTHR42934:SF3', NULL, NULL, NULL, NULL, 'D-LACTATE DEHYDROGENASE', 253526),
(431021, 'PTHR14694:SF1', NULL, NULL, NULL, NULL, 'CALCIUM-RESPONSIVE TRANSCRIPTION FACTOR', 253527),
(431022, 'PTHR14694', NULL, NULL, NULL, NULL, 'CALCIUM-RESPONSIVE TRANSCRIPTION FACTOR', 253527),
(431023, 'PTHR10418:SF7', NULL, NULL, NULL, NULL, 'SECURIN', 253528),
(431024, 'PTHR10418:SF8', NULL, NULL, NULL, NULL, 'SECURIN-2', 253528),
(431025, 'PTHR10418', NULL, NULL, NULL, NULL, 'SECURIN-3', 253528),
(431026, 'PTHR10418:SF2', NULL, NULL, NULL, NULL, 'SECURIN', 253528),
(431027, 'PTHR10418:SF3', NULL, NULL, NULL, NULL, 'PITUITARY TUMOR-TRANSFORMING GENE 3 PROTEIN-RELATED', 253528),
(431028, 'PTHR33326:SF4', NULL, NULL, NULL, NULL, 'OS08G0495300 PROTEIN', 253529),
(431029, 'PTHR33326:SF16', NULL, NULL, NULL, NULL, '', 253529),
(431030, 'PTHR33326:SF38', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 253529),
(431031, 'PTHR33326:SF39', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 253529),
(431032, 'PTHR33326', NULL, NULL, NULL, NULL, 'OS05G0543800 PROTEIN', 253529),
(431033, 'PTHR33326:SF19', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 253529),
(431034, 'PTHR33326:SF32', NULL, NULL, NULL, NULL, '', 253529),
(431035, 'PTHR33326:SF31', NULL, NULL, NULL, NULL, '', 253529),
(431036, 'PTHR33326:SF34', NULL, NULL, NULL, NULL, 'OS10G0373300 PROTEIN', 253529),
(431037, 'PTHR33326:SF33', NULL, NULL, NULL, NULL, '', 253529),
(431038, 'PTHR33326:SF11', NULL, NULL, NULL, NULL, 'OS10G0549700 PROTEIN', 253529),
(431039, 'PTHR33326:SF14', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 253529),
(431040, 'PTHR33326:SF35', NULL, NULL, NULL, NULL, '', 253529),
(431041, 'PTHR33326:SF50', NULL, NULL, NULL, NULL, 'OS06G0136100 PROTEIN', 253529),
(431042, 'PTHR33326:SF27', NULL, NULL, NULL, NULL, '', 253529),
(431043, 'PTHR33326:SF49', NULL, NULL, NULL, NULL, 'GENOME ASSEMBLY, CHROMOSOME: II', 253529),
(431044, 'PTHR33326:SF48', NULL, NULL, NULL, NULL, 'OS11G0648800 PROTEIN', 253529),
(431045, 'PTHR33326:SF29', NULL, NULL, NULL, NULL, '', 253529),
(431046, 'PTHR33326:SF28', NULL, NULL, NULL, NULL, '', 253529),
(431047, 'PTHR33326:SF43', NULL, NULL, NULL, NULL, '', 253529),
(431048, 'PTHR33326:SF21', NULL, NULL, NULL, NULL, '', 253529),
(431049, 'PTHR33326:SF42', NULL, NULL, NULL, NULL, '', 253529),
(431050, 'PTHR33326:SF45', NULL, NULL, NULL, NULL, 'OS05G0477500 PROTEIN', 253529),
(431051, 'PTHR33326:SF23', NULL, NULL, NULL, NULL, 'OS06G0134400 PROTEIN', 253529),
(431052, 'PTHR33326:SF44', NULL, NULL, NULL, NULL, 'OS10G0494950 PROTEIN', 253529),
(431053, 'PTHR33326:SF22', NULL, NULL, NULL, NULL, 'OS10G0372700 PROTEIN', 253529),
(431054, 'PTHR33326:SF24', NULL, NULL, NULL, NULL, '', 253529),
(431055, 'PTHR14274', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 8', 253530),
(431056, 'PTHR14274:SF1', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 8', 253530),
(431057, 'PTHR15211:SF0', NULL, NULL, NULL, NULL, 'GASTRIC INHIBITORY POLYPEPTIDE', 253531),
(431058, 'PTHR15211', NULL, NULL, NULL, NULL, 'GLUCOSE-DEPENDENT INSULINOTROPIC POLYPEPTIDE', 253531);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(431059, 'PTHR15840', NULL, NULL, NULL, NULL, 'CGI-121 FAMILY MEMBER', 253532),
(431060, 'PTHR15840:SF10', NULL, NULL, NULL, NULL, 'EKC/KEOPS COMPLEX SUBUNIT TPRKB', 253532),
(431061, 'PTHR46193:SF19', NULL, NULL, NULL, NULL, '', 253533),
(431062, 'PTHR46193', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONATE PHOSPHATASE', 253533),
(431063, 'PTHR46193:SF18', NULL, NULL, NULL, NULL, 'HEXITOL PHOSPHATASE B', 253533),
(431064, 'PTHR46193:SF11', NULL, NULL, NULL, NULL, 'PHOSPHATASE, PUTATIVE-RELATED', 253533),
(431065, 'PTHR46193:SF10', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONATE PHOSPHATASE', 253533),
(431066, 'PTHR46193:SF21', NULL, NULL, NULL, NULL, 'SLL1138 PROTEIN', 253533),
(431067, 'PTHR46193:SF20', NULL, NULL, NULL, NULL, 'OS06G0109500 PROTEIN', 253533),
(431068, 'PTHR46193:SF16', NULL, NULL, NULL, NULL, 'BNAA04G22170D PROTEIN', 253533),
(431069, 'PTHR46193:SF9', NULL, NULL, NULL, NULL, 'HALOACID DEHALOGENASE-LIKE HYDROLASE DOMAIN-CONTAINING PROTEIN SGPP', 253533),
(431070, 'PTHR46193:SF13', NULL, NULL, NULL, NULL, 'HALOACID DEHALOGENASE-LIKE HYDROLASE DOMAIN-CONTAINING PROTEIN SGPP', 253533),
(431071, 'PTHR17378:SF1', NULL, NULL, NULL, NULL, 'SECRETIN', 253534),
(431072, 'PTHR17378', NULL, NULL, NULL, NULL, 'SECRETIN', 253534),
(431073, 'PTHR10491', NULL, NULL, NULL, NULL, 'DTDP-4-DEHYDRORHAMNOSE REDUCTASE', 253535),
(431074, 'PTHR10491:SF4', NULL, NULL, NULL, NULL, 'METHIONINE ADENOSYLTRANSFERASE 2 SUBUNIT BETA', 253535),
(431075, 'PTHR35270', NULL, NULL, NULL, NULL, 'FUSELESS, ISOFORM A', 253536),
(431076, 'PTHR35270:SF2', NULL, NULL, NULL, NULL, 'FUSELESS, ISOFORM A', 253536),
(431077, 'PTHR37820:SF1', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN DIVIB', 253537),
(431078, 'PTHR37820', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN DIVIB', 253537),
(431079, 'PTHR12555:SF21', NULL, NULL, NULL, NULL, 'UBIQUITIN FUSION DEGRADATION 1 PROTEIN', 253538),
(431080, 'PTHR12555:SF20', NULL, NULL, NULL, NULL, 'UBIQUITIN RECOGNITION FACTOR IN ER-ASSOCIATED DEGRADATION PROTEIN 1', 253538),
(431081, 'PTHR12555:SF15', NULL, NULL, NULL, NULL, 'FUSION DEGRADATION PROTEIN (UFD1), PUTATIVE (AFU_ORTHOLOGUE AFUA_4G04640)-RELATED', 253538),
(431082, 'PTHR12555:SF23', NULL, NULL, NULL, NULL, 'UBIQUITIN FUSION DEGRADATION PROTEIN 1 HOMOLOG', 253538),
(431083, 'PTHR12555:SF13', NULL, NULL, NULL, NULL, 'UBIQUITIN RECOGNITION FACTOR IN ER-ASSOCIATED DEGRADATION PROTEIN 1', 253538),
(431084, 'PTHR12555', NULL, NULL, NULL, NULL, 'UBIQUITIN FUSION DEGRADATON PROTEIN 1', 253538),
(431085, 'PTHR12555:SF18', NULL, NULL, NULL, NULL, '', 253538),
(431086, 'PTHR12555:SF19', NULL, NULL, NULL, NULL, 'UBIQUITIN FUSION DEGRADATION UFD1 FAMILY PROTEIN', 253538),
(431087, 'PTHR12555:SF27', NULL, NULL, NULL, NULL, 'UBIQUITIN FUSION DEGRADATION UFD1 FAMILY PROTEIN', 253538),
(431088, 'PTHR12555:SF16', NULL, NULL, NULL, NULL, 'OS04G0577000 PROTEIN', 253538),
(431089, 'PTHR48019:SF67', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431090, 'PTHR48019:SF66', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431091, 'PTHR48019:SF117', NULL, NULL, NULL, NULL, 'BNAC09G37550D PROTEIN', 253539),
(431092, 'PTHR48019:SF63', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR FBP28', 253539),
(431093, 'PTHR48019:SF64', NULL, NULL, NULL, NULL, 'K-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431094, 'PTHR48019:SF60', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 25', 253539),
(431095, 'PTHR48019:SF199', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431096, 'PTHR48019:SF111', NULL, NULL, NULL, NULL, 'MIKC-TYPE MADS-BOX TRANSCRIPTION FACTOR WM30', 253539),
(431097, 'PTHR48019:SF197', NULL, NULL, NULL, NULL, 'MYOCYTE ENHANCER FACTOR 2D', 253539),
(431098, 'PTHR48019:SF198', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431099, 'PTHR48019:SF113', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431100, 'PTHR48019:SF191', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 27-RELATED', 253539),
(431101, 'PTHR48019:SF192', NULL, NULL, NULL, NULL, 'K-BOX DOMAIN-CONTAINING PROTEIN', 253539); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(431102, 'PTHR48019:SF190', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431103, 'PTHR48019:SF195', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 47', 253539),
(431104, 'PTHR48019:SF196', NULL, NULL, NULL, NULL, 'MADS2', 253539),
(431105, 'PTHR48019:SF193', NULL, NULL, NULL, NULL, 'K-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431106, 'PTHR48019:SF194', NULL, NULL, NULL, NULL, 'FBP11 PROTEIN', 253539),
(431107, 'PTHR48019:SF79', NULL, NULL, NULL, NULL, 'TRUNCATED TRANSCRIPTION FACTOR CAULIFLOWER A', 253539),
(431108, 'PTHR48019:SF76', NULL, NULL, NULL, NULL, 'FLORAL HOMEOTIC PROTEIN PISTILLATA', 253539),
(431109, 'PTHR48019:SF109', NULL, NULL, NULL, NULL, 'MYOCYTE-SPECIFIC ENHANCER FACTOR 2A', 253539),
(431110, 'PTHR48019:SF77', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431111, 'PTHR48019:SF72', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 6', 253539),
(431112, 'PTHR48019:SF188', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE 105-RELATED', 253539),
(431113, 'PTHR48019:SF189', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL16', 253539),
(431114, 'PTHR48019:SF101', NULL, NULL, NULL, NULL, 'MADS-BOX PROTEIN SVP ISOFORM X1', 253539),
(431115, 'PTHR48019:SF186', NULL, NULL, NULL, NULL, 'BNAA02G04770D PROTEIN', 253539),
(431116, 'PTHR48019:SF187', NULL, NULL, NULL, NULL, 'MADS TRANSCRIPTIONAL FACTOR', 253539),
(431117, 'PTHR48019:SF102', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR ANR1', 253539),
(431118, 'PTHR48019:SF180', NULL, NULL, NULL, NULL, 'K-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431119, 'PTHR48019:SF181', NULL, NULL, NULL, NULL, 'FLOWERING LOCUS C-LIKE PROTEIN', 253539),
(431120, 'PTHR48019:SF184', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431121, 'PTHR48019:SF185', NULL, NULL, NULL, NULL, 'K-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431122, 'PTHR48019:SF182', NULL, NULL, NULL, NULL, 'SERUM RESPONSE FACTOR B', 253539),
(431123, 'PTHR48019:SF183', NULL, NULL, NULL, NULL, '', 253539),
(431124, 'PTHR48019:SF49', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431125, 'PTHR48019:SF48', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431126, 'PTHR48019:SF45', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL12', 253539),
(431127, 'PTHR48019:SF43', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR FBP29', 253539),
(431128, 'PTHR48019:SF44', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN FUL-L', 253539),
(431129, 'PTHR48019:SF41', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431130, 'PTHR48019:SF177', NULL, NULL, NULL, NULL, 'MADS-BOX PROTEIN', 253539),
(431131, 'PTHR48019:SF178', NULL, NULL, NULL, NULL, 'SRF-TYPE TRANSCRIPTION FACTOR FAMILY PROTEIN', 253539),
(431132, 'PTHR48019:SF175', NULL, NULL, NULL, NULL, 'K-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431133, 'PTHR48019:SF176', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431134, 'PTHR48019:SF179', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL21', 253539),
(431135, 'PTHR48019:SF170', NULL, NULL, NULL, NULL, 'MADS-BOX PROTEIN 9', 253539),
(431136, 'PTHR48019:SF173', NULL, NULL, NULL, NULL, 'MADS-BOX', 253539),
(431137, 'PTHR48019:SF174', NULL, NULL, NULL, NULL, 'BOX PROTEIN, PUTATIVE-RELATED', 253539),
(431138, 'PTHR48019:SF171', NULL, NULL, NULL, NULL, 'BOX PROTEIN, PUTATIVE-RELATED', 253539),
(431139, 'PTHR48019:SF172', NULL, NULL, NULL, NULL, 'FLORAL HOMEOTIC PROTEIN DEFICIENS-LIKE', 253539),
(431140, 'PTHR48019:SF58', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431141, 'PTHR48019:SF57', NULL, NULL, NULL, NULL, '', 253539),
(431142, 'PTHR48019:SF54', NULL, NULL, NULL, NULL, '', 253539),
(431143, 'PTHR48019:SF55', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431144, 'PTHR48019:SF52', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL104', 253539),
(431145, 'PTHR48019:SF53', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL17', 253539);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(431146, 'PTHR48019:SF166', NULL, NULL, NULL, NULL, 'MADS-BOX PROTEIN AEAP3-2-LIKE', 253539),
(431147, 'PTHR48019:SF167', NULL, NULL, NULL, NULL, '', 253539),
(431148, 'PTHR48019:SF200', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431149, 'PTHR48019:SF164', NULL, NULL, NULL, NULL, 'OS06G0347700 PROTEIN', 253539),
(431150, 'PTHR48019:SF165', NULL, NULL, NULL, NULL, 'BNACNNG36870D PROTEIN', 253539),
(431151, 'PTHR48019:SF168', NULL, NULL, NULL, NULL, 'SERUM RESPONSE FACTOR', 253539),
(431152, 'PTHR48019:SF169', NULL, NULL, NULL, NULL, 'BOX PROTEIN, PUTATIVE-RELATED', 253539),
(431153, 'PTHR48019:SF162', NULL, NULL, NULL, NULL, '', 253539),
(431154, 'PTHR48019:SF163', NULL, NULL, NULL, NULL, 'TYPE I MADS BOX TRANSCRIPTION FACTOR', 253539),
(431155, 'PTHR48019:SF160', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR', 253539),
(431156, 'PTHR48019:SF161', NULL, NULL, NULL, NULL, 'K-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431157, 'PTHR48019:SF29', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL9 HOMOLOG', 253539),
(431158, 'PTHR48019:SF27', NULL, NULL, NULL, NULL, 'MADS-BOX PROTEIN 15', 253539),
(431159, 'PTHR48019:SF28', NULL, NULL, NULL, NULL, 'DNA BINDING PROTEIN', 253539),
(431160, 'PTHR48019:SF26', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR', 253539),
(431161, 'PTHR48019:SF23', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431162, 'PTHR48019:SF3', NULL, NULL, NULL, NULL, 'MADS BOX PROTEIN', 253539),
(431163, 'PTHR48019:SF4', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPARENT TESTA 16-LIKE ISOFORM X1', 253539),
(431164, 'PTHR48019:SF20', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL23', 253539),
(431165, 'PTHR48019:SF6', NULL, NULL, NULL, NULL, 'MADS-BOX PROTEIN AGL24-LIKE ISOFORM X1', 253539),
(431166, 'PTHR48019:SF1', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPARENT TESTA 16', 253539),
(431167, 'PTHR48019:SF2', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 57', 253539),
(431168, 'PTHR48019:SF155', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 23-LIKE', 253539),
(431169, 'PTHR48019:SF156', NULL, NULL, NULL, NULL, 'MADS-BOX FAMILY PROTEIN', 253539),
(431170, 'PTHR48019:SF153', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 23', 253539),
(431171, 'PTHR48019:SF154', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 23-LIKE ISOFORM X1', 253539),
(431172, 'PTHR48019:SF159', NULL, NULL, NULL, NULL, 'F23H11.23 PROTEIN-RELATED', 253539),
(431173, 'PTHR48019:SF8', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL29', 253539),
(431174, 'PTHR48019:SF9', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431175, 'PTHR48019:SF157', NULL, NULL, NULL, NULL, 'K-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431176, 'PTHR48019:SF158', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431177, 'PTHR48019:SF151', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431178, 'PTHR48019:SF152', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431179, 'PTHR48019:SF150', NULL, NULL, NULL, NULL, 'MADS BOX TRANSCRIPTION FACTOR', 253539),
(431180, 'PTHR48019:SF38', NULL, NULL, NULL, NULL, 'BNAA06G01120D PROTEIN', 253539),
(431181, 'PTHR48019:SF39', NULL, NULL, NULL, NULL, 'K-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431182, 'PTHR48019:SF37', NULL, NULL, NULL, NULL, '', 253539),
(431183, 'PTHR48019:SF30', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL8 HOMOLOG', 253539),
(431184, 'PTHR48019:SF31', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN MADS4', 253539),
(431185, 'PTHR48019:SF144', NULL, NULL, NULL, NULL, 'K-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431186, 'PTHR48019:SF145', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431187, 'PTHR48019:SF142', NULL, NULL, NULL, NULL, 'SRF-TYPE TRANSCRIPTION FACTOR (DNA-BINDING AND DIMERIZATION DOMAIN) PROTEIN', 253539),
(431188, 'PTHR48019:SF143', NULL, NULL, NULL, NULL, 'K-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431189, 'PTHR48019:SF148', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 27', 253539);
INSERT INTO "PUBLIC"."MODEL" VALUES
(431190, 'PTHR48019:SF149', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431191, 'PTHR48019:SF146', NULL, NULL, NULL, NULL, '', 253539),
(431192, 'PTHR48019:SF147', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR MADS-RIN', 253539),
(431193, 'PTHR48019:SF140', NULL, NULL, NULL, NULL, 'MADS BOX PROTEIN', 253539),
(431194, 'PTHR48019:SF141', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 23-LIKE ISOFORM X1', 253539),
(431195, 'PTHR48019:SF88', NULL, NULL, NULL, NULL, 'K-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431196, 'PTHR48019:SF85', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431197, 'PTHR48019:SF86', NULL, NULL, NULL, NULL, 'FLORAL HOMEOTIC PROTEIN PMADS 2', 253539),
(431198, 'PTHR48019:SF81', NULL, NULL, NULL, NULL, 'BNAANNG30140D PROTEIN', 253539),
(431199, 'PTHR48019:SF90', NULL, NULL, NULL, NULL, 'MYOCYTE-SPECIFIC ENHANCER FACTOR 2C', 253539),
(431200, 'PTHR48019:SF134', NULL, NULL, NULL, NULL, 'SERUM RESPONSE FACTOR HOMOLOG', 253539),
(431201, 'PTHR48019:SF137', NULL, NULL, NULL, NULL, 'OS01G0340000 PROTEIN', 253539),
(431202, 'PTHR48019:SF135', NULL, NULL, NULL, NULL, 'MADS-BOX PROTEIN SOC1', 253539),
(431203, 'PTHR48019:SF19', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431204, 'PTHR48019:SF16', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431205, 'PTHR48019:SF17', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431206, 'PTHR48019:SF15', NULL, NULL, NULL, NULL, 'BNAC02G42240D PROTEIN', 253539),
(431207, 'PTHR48019:SF12', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431208, 'PTHR48019:SF10', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431209, 'PTHR48019:SF11', NULL, NULL, NULL, NULL, 'MADS-BOX TRANSCRIPTION FACTOR 4', 253539),
(431210, 'PTHR48019:SF128', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL15', 253539),
(431211, 'PTHR48019:SF97', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL8 HOMOLOG', 253539),
(431212, 'PTHR48019', NULL, NULL, NULL, NULL, 'SERUM RESPONSE FACTOR HOMOLOG', 253539),
(431213, 'PTHR48019:SF92', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431214, 'PTHR48019:SF93', NULL, NULL, NULL, NULL, 'K-BOX REGION AND MADS-BOX TRANSCRIPTION FACTOR FAMILY PROTEIN', 253539),
(431215, 'PTHR48019:SF127', NULL, NULL, NULL, NULL, 'AGAMOUS-LIKE MADS-BOX PROTEIN AGL18', 253539),
(431216, 'PTHR48019:SF124', NULL, NULL, NULL, NULL, 'DEVELOPMENTAL PROTEIN SEPALLATA 1', 253539),
(431217, 'PTHR48019:SF125', NULL, NULL, NULL, NULL, 'MADS-BOX DOMAIN-CONTAINING PROTEIN', 253539),
(431218, 'PTHR42883', NULL, NULL, NULL, NULL, 'GLUCOSE-1-PHOSPHATE THYMIDYLTRANSFERASE', 253540),
(431219, 'PTHR42883:SF2', NULL, NULL, NULL, NULL, 'ZGC:136439', 253540),
(431220, 'PTHR42883:SF3', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL PROTEIN GLMU', 253540),
(431221, 'PTHR46720:SF3', NULL, NULL, NULL, NULL, 'HYDROXYLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G01460)-RELATED', 253541),
(431222, 'PTHR46720:SF1', NULL, NULL, NULL, NULL, 'HYDROXYLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G06050)-RELATED', 253541),
(431223, 'PTHR46720', NULL, NULL, NULL, NULL, 'HYDROXYLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G01460)-RELATED', 253541),
(431224, 'PTHR46720:SF4', NULL, NULL, NULL, NULL, 'FAD-DEPENDENT MONOOXYGENASE AFOD-RELATED', 253541),
(431225, 'PTHR43684:SF6', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC CHROMODOMAIN PROTEIN Y 1-RELATED', 253542),
(431226, 'PTHR43684:SF5', NULL, NULL, NULL, NULL, 'CHROMODOMAIN Y-LIKE PROTEIN', 253542),
(431227, 'PTHR43684:SF4', NULL, NULL, NULL, NULL, 'ENOYL-COA HYDRATASE/ISOMERASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_1G01890)', 253542),
(431228, 'PTHR43684:SF3', NULL, NULL, NULL, NULL, '', 253542),
(431229, 'PTHR43684:SF2', NULL, NULL, NULL, NULL, 'CHROMODOMAIN Y-LIKE PROTEIN 2', 253542),
(431230, 'PTHR43684:SF1', NULL, NULL, NULL, NULL, 'ENOYL-COA DELTA ISOMERASE 2', 253542),
(431231, 'PTHR43684:SF13', NULL, NULL, NULL, NULL, '', 253542),
(431232, 'PTHR43684:SF14', NULL, NULL, NULL, NULL, 'PROTEIN CBG16141', 253542);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(431233, 'PTHR43684:SF11', NULL, NULL, NULL, NULL, 'CHROMO DOMAIN-CONTAINING PROTEIN', 253542),
(431234, 'PTHR43684:SF12', NULL, NULL, NULL, NULL, 'ENOYL-COA ISOMERASE', 253542),
(431235, 'PTHR43684', NULL, NULL, NULL, NULL, '', 253542),
(431236, 'PTHR10960:SF0', NULL, NULL, NULL, NULL, 'V(D)J RECOMBINATION-ACTIVATING PROTEIN 2', 253543),
(431237, 'PTHR10960', NULL, NULL, NULL, NULL, 'V D J RECOMBINATION-ACTIVATING PROTEIN 2', 253543),
(431238, 'PTHR21600:SF85', NULL, NULL, NULL, NULL, 'RIBOSOMAL LARGE SUBUNIT PSEUDOURIDINE SYNTHASE E', 253544),
(431239, 'PTHR21600:SF84', NULL, NULL, NULL, NULL, 'PSEUDOU_SYNTH_2 DOMAIN-CONTAINING PROTEIN', 253544),
(431240, 'PTHR21600:SF40', NULL, NULL, NULL, NULL, 'RNA PSEUDOURIDYLATE SYNTHASE DOMAIN-CONTAINING PROTEIN 2', 253544),
(431241, 'PTHR21600:SF62', NULL, NULL, NULL, NULL, 'PSEUDOURIDINE SYNTHASE', 253544),
(431242, 'PTHR21600', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RNA PSEUDOURIDINE SYNTHASE', 253544),
(431243, 'PTHR21600:SF87', NULL, NULL, NULL, NULL, 'RNA PSEUDOURIDYLATE SYNTHASE DOMAIN-CONTAINING PROTEIN 1', 253544),
(431244, 'PTHR21600:SF42', NULL, NULL, NULL, NULL, 'TRNA PSEUDOURIDINE(31) SYNTHASE', 253544),
(431245, 'PTHR21600:SF86', NULL, NULL, NULL, NULL, 'PSEUDOU_SYNTH_2 DOMAIN-CONTAINING PROTEIN', 253544),
(431246, 'PTHR21600:SF89', NULL, NULL, NULL, NULL, 'RIBOSOMAL LARGE SUBUNIT PSEUDOURIDINE SYNTHASE A', 253544),
(431247, 'PTHR21600:SF44', NULL, NULL, NULL, NULL, 'RIBOSOMAL LARGE SUBUNIT PSEUDOURIDINE SYNTHASE D', 253544),
(431248, 'PTHR21600:SF88', NULL, NULL, NULL, NULL, 'RNA PSEUDOURIDINE SYNTHASE 5', 253544),
(431249, 'PTHR21600:SF47', NULL, NULL, NULL, NULL, 'RNA PSEUDOURIDINE SYNTHASE 1', 253544),
(431250, 'PTHR21600:SF69', NULL, NULL, NULL, NULL, 'PSEUDOU_SYNTH_2 DOMAIN-CONTAINING PROTEIN', 253544),
(431251, 'PTHR21600:SF49', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL MRNA PSEUDOURIDINE SYNTHASE RPUSD3', 253544),
(431252, 'PTHR21600:SF90', NULL, NULL, NULL, NULL, 'PSEUDOU_SYNTH_2 DOMAIN-CONTAINING PROTEIN', 253544),
(431253, 'PTHR21600:SF70', NULL, NULL, NULL, NULL, 'PSEUDOU_SYNTH_2 DOMAIN-CONTAINING PROTEIN', 253544),
(431254, 'PTHR21600:SF91', NULL, NULL, NULL, NULL, 'DUAL-SPECIFICITY RNA PSEUDOURIDINE SYNTHASE RLUA', 253544),
(431255, 'PTHR21600:SF71', NULL, NULL, NULL, NULL, 'LARGE SUBUNIT PSEUDOURIDINE SYNTHASE, RLUD SUBFAMILY, PUTATIVE-RELATED', 253544),
(431256, 'PTHR21600:SF52', NULL, NULL, NULL, NULL, 'RNA PSEUDOURIDINE SYNTHASE 6, CHLOROPLASTIC', 253544),
(431257, 'PTHR21600:SF74', NULL, NULL, NULL, NULL, 'TRNA PSEUDOURIDYLATE SYNTHASE', 253544),
(431258, 'PTHR21600:SF53', NULL, NULL, NULL, NULL, 'RNA PSEUDOURIDINE SYNTHASE 3, MITOCHONDRIAL', 253544),
(431259, 'PTHR21600:SF75', NULL, NULL, NULL, NULL, 'DUAL-SPECIFICITY RNA PSEUDOURIDINE SYNTHASE RLUF', 253544),
(431260, 'PTHR21600:SF56', NULL, NULL, NULL, NULL, 'TRNA PSEUDOURIDINE SYNTHASE C', 253544),
(431261, 'PTHR21600:SF77', NULL, NULL, NULL, NULL, 'PSEUDOU_SYNTH_2 DOMAIN-CONTAINING PROTEIN', 253544),
(431262, 'PTHR21600:SF35', NULL, NULL, NULL, NULL, 'PSEUDOURIDINE SYNTHASE', 253544),
(431263, 'PTHR21600:SF19', NULL, NULL, NULL, NULL, 'PSEUDOU_SYNTH_2 DOMAIN-CONTAINING PROTEIN', 253544),
(431264, 'PTHR21600:SF81', NULL, NULL, NULL, NULL, '21S RRNA PSEUDOURIDINE(2819) SYNTHASE', 253544),
(431265, 'PTHR21600:SF83', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RNA PSEUDOURIDINE SYNTHASE RPUSD4', 253544),
(431266, 'PTHR31874:SF59', NULL, NULL, NULL, NULL, 'CCT MOTIF FAMILY PROTEIN', 253545),
(431267, 'PTHR31874:SF38', NULL, NULL, NULL, NULL, 'BNAA02G08300D PROTEIN', 253545),
(431268, 'PTHR31874:SF39', NULL, NULL, NULL, NULL, '', 253545),
(431269, 'PTHR31874:SF44', NULL, NULL, NULL, NULL, 'BNAA02G13920D PROTEIN', 253545),
(431270, 'PTHR31874:SF55', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CONSTANS-LIKE 8', 253545),
(431271, 'PTHR31874:SF45', NULL, NULL, NULL, NULL, 'BNAC08G46470D PROTEIN', 253545),
(431272, 'PTHR31874:SF56', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CONSTANS-LIKE 16', 253545),
(431273, 'PTHR31874:SF57', NULL, NULL, NULL, NULL, 'CCT MOTIF FAMILY PROTEIN, EXPRESSED', 253545);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(431274, 'PTHR31874:SF46', NULL, NULL, NULL, NULL, 'BNACNNG04690D PROTEIN', 253545),
(431275, 'PTHR31874:SF58', NULL, NULL, NULL, NULL, 'B-BOX ZINC FINGER PROTEIN 10', 253545),
(431276, 'PTHR31874:SF25', NULL, NULL, NULL, NULL, 'OS04G0117801 PROTEIN', 253545),
(431277, 'PTHR31874:SF51', NULL, NULL, NULL, NULL, 'CCT DOMAIN-CONTAINING PROTEIN', 253545),
(431278, 'PTHR31874:SF40', NULL, NULL, NULL, NULL, 'OS02G0731700 PROTEIN', 253545),
(431279, 'PTHR31874:SF41', NULL, NULL, NULL, NULL, 'CCT MOTIF FAMILY PROTEIN', 253545),
(431280, 'PTHR31874:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CONSTANS-LIKE 6-RELATED', 253545),
(431281, 'PTHR31874:SF42', NULL, NULL, NULL, NULL, 'BNAANNG25560D PROTEIN', 253545),
(431282, 'PTHR31874:SF10', NULL, NULL, NULL, NULL, 'PROTEIN CHLOROPLAST IMPORT APPARATUS 2', 253545),
(431283, 'PTHR31874', NULL, NULL, NULL, NULL, 'CCT MOTIF FAMILY PROTEIN, EXPRESSED', 253545),
(431284, 'PTHR31874:SF7', NULL, NULL, NULL, NULL, 'OS06G0699600 PROTEIN', 253545),
(431285, 'PTHR12688:SF1', NULL, NULL, NULL, NULL, 'CYTOPLASMIC DYNEIN 1 LIGHT INTERMEDIATE CHAIN 2', 253546),
(431286, 'PTHR12688:SF0', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT INTERMEDIATE CHAIN', 253546),
(431287, 'PTHR12688:SF2', NULL, NULL, NULL, NULL, 'CYTOPLASMIC DYNEIN 1 LIGHT INTERMEDIATE CHAIN 1', 253546),
(431288, 'PTHR12688', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT INTERMEDIATE CHAIN', 253546),
(431289, 'PTHR43638', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE, ALDO/KETO REDUCTASE FAMILY PROTEIN', 253547),
(431290, 'PTHR43638:SF3', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE, ALDO/KETO REDUCTASE FAMILY PROTEIN', 253547),
(431291, 'PTHR16795:SF13', NULL, NULL, NULL, NULL, 'ELLIS-VAN CREVELD SYNDROME PROTEIN', 253548),
(431292, 'PTHR16795', NULL, NULL, NULL, NULL, 'LIMBIN/ELLIS-VAN CREVELD PROTEIN', 253548),
(431293, 'PTHR16795:SF14', NULL, NULL, NULL, NULL, 'LIMBIN', 253548),
(431294, 'PTHR20993:SF0', NULL, NULL, NULL, NULL, 'GH07914P', 253549),
(431295, 'PTHR20993', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 253549),
(431296, 'PTHR12589:SF7', NULL, NULL, NULL, NULL, '6-PYRUVOYL TETRAHYDROBIOPTERIN SYNTHASE', 253550),
(431297, 'PTHR12589:SF8', NULL, NULL, NULL, NULL, '6-CARBOXY-5,6,7,8-TETRAHYDROPTERIN SYNTHASE', 253550),
(431298, 'PTHR12589', NULL, NULL, NULL, NULL, 'PYRUVOYL TETRAHYDROBIOPTERIN SYNTHASE', 253550),
(431299, 'PTHR35602', NULL, NULL, NULL, NULL, 'ESTERASE YQIA-RELATED', 253551),
(431300, 'PTHR35602:SF3', NULL, NULL, NULL, NULL, 'ESTERASE YQIA', 253551),
(431301, 'PTHR35602:SF2', NULL, NULL, NULL, NULL, 'UPF0227 PROTEIN YCFP', 253551),
(431302, 'PTHR30478', NULL, NULL, NULL, NULL, 'DNA POLYMERASE III SUBUNIT BETA', 253552),
(431303, 'PTHR30478:SF0', NULL, NULL, NULL, NULL, 'BETA SLIDING CLAMP', 253552),
(431304, 'PTHR38389:SF1', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT BETA', 253553),
(431305, 'PTHR38389', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT BETA', 253553),
(431306, 'PTHR45029', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE-RELATED', 253554),
(431307, 'PTHR45029:SF6', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 253554),
(431308, 'PTHR45029:SF7', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 253554),
(431309, 'PTHR45029:SF2', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 253554),
(431310, 'PTHR45029:SF1', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 253554),
(431311, 'PTHR45029:SF4', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 253554),
(431312, 'PTHR45029:SF3', NULL, NULL, NULL, NULL, 'ESTERASE CM06B1', 253554),
(431313, 'PTHR46982', NULL, NULL, NULL, NULL, 'CITRATE/OXOGLUTARATE CARRIER PROTEIN', 253555),
(431314, 'PTHR46982:SF1', NULL, NULL, NULL, NULL, 'CITRATE/OXOGLUTARATE CARRIER PROTEIN', 253555),
(431315, 'PTHR43842', NULL, NULL, NULL, NULL, 'PROPIONYL-COA CARBOXYLASE BETA CHAIN', 253556),
(431316, 'PTHR43842:SF2', NULL, NULL, NULL, NULL, 'PROPIONYL-COA CARBOXYLASE BETA CHAIN-RELATED', 253556),
(431317, 'PTHR43842:SF3', NULL, NULL, NULL, NULL, 'PROPIONYL-COA CARBOXYLASE BETA CHAIN, MITOCHONDRIAL', 253556);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(431318, 'PTHR10157:SF29', NULL, NULL, NULL, NULL, 'DOPAMINE BETA-HYDROXYLASE', 253557),
(431319, 'PTHR10157:SF28', NULL, NULL, NULL, NULL, 'DBH-LIKE MONOOXYGENASE PROTEIN 1', 253557),
(431320, 'PTHR10157:SF23', NULL, NULL, NULL, NULL, 'MOXD1 HOMOLOG 1', 253557),
(431321, 'PTHR10157:SF41', NULL, NULL, NULL, NULL, 'DBH-LIKE MONOOXYGENASE PROTEIN 2 HOMOLOG', 253557),
(431322, 'PTHR10157', NULL, NULL, NULL, NULL, 'DOPAMINE BETA HYDROXYLASE RELATED', 253557),
(431323, 'PTHR10157:SF42', NULL, NULL, NULL, NULL, 'DBH-LIKE MONOOXYGENASE PROTEIN 1 HOMOLOG', 253557),
(431324, 'PTHR10157:SF31', NULL, NULL, NULL, NULL, 'DBH-LIKE MONOOXYGENASE PROTEIN 2-RELATED', 253557),
(431325, 'PTHR10157:SF40', NULL, NULL, NULL, NULL, 'MOXD1 HOMOLOG 2', 253557),
(431326, 'PTHR46164', NULL, NULL, NULL, NULL, 'ATF6, ISOFORM C', 253558),
(431327, 'PTHR46164:SF1', NULL, NULL, NULL, NULL, 'CYCLIC AMP-DEPENDENT TRANSCRIPTION FACTOR ATF-6 ALPHA', 253558),
(431328, 'PTHR46164:SF4', NULL, NULL, NULL, NULL, 'BASIC-LEUCINE ZIPPER TRANSCRIPTION FACTOR C-RELATED', 253558),
(431329, 'PTHR46164:SF2', NULL, NULL, NULL, NULL, 'CYCLIC AMP-DEPENDENT TRANSCRIPTION FACTOR ATF-6 BETA', 253558),
(431330, 'PTHR46164:SF3', NULL, NULL, NULL, NULL, 'ATF6, ISOFORM C', 253558),
(431331, 'PTHR47967:SF115', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE NEPENTHESIN-1-LIKE', 253559),
(431332, 'PTHR47967:SF16', NULL, NULL, NULL, NULL, 'OS09G0452800 PROTEIN', 253559),
(431333, 'PTHR47967:SF59', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE CDR1-LIKE', 253559),
(431334, 'PTHR47967:SF114', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE CDR1-LIKE', 253559),
(431335, 'PTHR47967:SF15', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431336, 'PTHR47967:SF117', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431337, 'PTHR47967:SF18', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431338, 'PTHR47967:SF116', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE CDR1-LIKE', 253559),
(431339, 'PTHR47967:SF17', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN, EXPRESSED', 253559),
(431340, 'PTHR47967:SF19', NULL, NULL, NULL, NULL, 'ASPARTIC PEPTIDASE A1 FAMILY-RELATED', 253559),
(431341, 'PTHR47967:SF118', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431342, 'PTHR47967:SF96', NULL, NULL, NULL, NULL, 'OS08G0207800 PROTEIN', 253559),
(431343, 'PTHR47967:SF51', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE NEPENTHESIN-2', 253559),
(431344, 'PTHR47967:SF54', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431345, 'PTHR47967:SF97', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431346, 'PTHR47967:SF53', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431347, 'PTHR47967:SF12', NULL, NULL, NULL, NULL, 'ASPARTYL PROTEASE FAMILY PROTEIN', 253559),
(431348, 'PTHR47967:SF56', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 253559),
(431349, 'PTHR47967:SF55', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431350, 'PTHR47967:SF11', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431351, 'PTHR47967:SF14', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 253559),
(431352, 'PTHR47967:SF58', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE CDR1-LIKE PROTEIN-RELATED', 253559),
(431353, 'PTHR47967:SF13', NULL, NULL, NULL, NULL, 'ASPARTYL PROTEASE UND-RELATED', 253559),
(431354, 'PTHR47967:SF57', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431355, 'PTHR47967:SF61', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE NEPENTHESIN-1', 253559),
(431356, 'PTHR47967:SF60', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431357, 'PTHR47967:SF111', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431358, 'PTHR47967:SF110', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431359, 'PTHR47967:SF113', NULL, NULL, NULL, NULL, 'ASPARTYL PROTEASE FAMILY PROTEIN, PUTATIVE-RELATED', 253559);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(431360, 'PTHR47967:SF112', NULL, NULL, NULL, NULL, 'OS10G0447300 PROTEIN', 253559),
(431361, 'PTHR47967:SF104', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431362, 'PTHR47967:SF27', NULL, NULL, NULL, NULL, 'OS07G0533600 PROTEIN', 253559),
(431363, 'PTHR47967:SF26', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431364, 'PTHR47967:SF29', NULL, NULL, NULL, NULL, 'ASPARTYL PROTEASE-RELATED', 253559),
(431365, 'PTHR47967:SF106', NULL, NULL, NULL, NULL, 'OS08G0469000 PROTEIN', 253559),
(431366, 'PTHR47967:SF105', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431367, 'PTHR47967:SF28', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431368, 'PTHR47967:SF108', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431369, 'PTHR47967:SF107', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431370, 'PTHR47967:SF109', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431371, 'PTHR47967:SF63', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431372, 'PTHR47967:SF62', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431373, 'PTHR47967:SF21', NULL, NULL, NULL, NULL, 'ASPARTIC PEPTIDASE A1 FAMILY-RELATED', 253559),
(431374, 'PTHR47967:SF1', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431375, 'PTHR47967:SF64', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431376, 'PTHR47967:SF20', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431377, 'PTHR47967:SF67', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431378, 'PTHR47967:SF23', NULL, NULL, NULL, NULL, 'OS04G0448300 PROTEIN', 253559),
(431379, 'PTHR47967:SF22', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431380, 'PTHR47967:SF66', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE CDR1-RELATED', 253559),
(431381, 'PTHR47967:SF25', NULL, NULL, NULL, NULL, 'OS06G0209100 PROTEIN', 253559),
(431382, 'PTHR47967:SF69', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE NANA, CHLOROPLAST', 253559),
(431383, 'PTHR47967:SF68', NULL, NULL, NULL, NULL, 'OS07G0533000 PROTEIN', 253559),
(431384, 'PTHR47967:SF24', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431385, 'PTHR47967:SF9', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE NEPENTHESIN-2', 253559),
(431386, 'PTHR47967:SF8', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431387, 'PTHR47967:SF70', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE CDR1-LIKE', 253559),
(431388, 'PTHR47967:SF6', NULL, NULL, NULL, NULL, 'ASPARTYL PROTEASE 37', 253559),
(431389, 'PTHR47967:SF71', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431390, 'PTHR47967:SF101', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431391, 'PTHR47967:SF38', NULL, NULL, NULL, NULL, 'OS09G0452400 PROTEIN', 253559),
(431392, 'PTHR47967:SF37', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE NEPENTHESIN-1-LIKE', 253559),
(431393, 'PTHR47967:SF39', NULL, NULL, NULL, NULL, 'ASPARTYL PROTEASE FAMILY PROTEIN, PUTATIVE-RELATED', 253559),
(431394, 'PTHR47967:SF74', NULL, NULL, NULL, NULL, 'ASPARTIC PROTEINASE CDR1-LIKE', 253559),
(431395, 'PTHR47967:SF30', NULL, NULL, NULL, NULL, 'OS01G0696800 PROTEIN', 253559),
(431396, 'PTHR47967:SF73', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431397, 'PTHR47967:SF32', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431398, 'PTHR47967:SF76', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 253559),
(431399, 'PTHR47967:SF31', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN, EXPRESSED', 253559),
(431400, 'PTHR47967:SF78', NULL, NULL, NULL, NULL, 'PROTEIN ASPARTIC PROTEASE IN GUARD CELL 1-LIKE', 253559),
(431401, 'PTHR47967:SF34', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(431402, 'PTHR47967:SF36', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431403, 'PTHR47967:SF35', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN, EXPRESSED', 253559),
(431404, 'PTHR47967:SF79', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431405, 'PTHR47967:SF83', NULL, NULL, NULL, NULL, 'OS05G0375700 PROTEIN', 253559),
(431406, 'PTHR47967:SF82', NULL, NULL, NULL, NULL, 'ASPARTYL PROTEASE FAMILY PROTEIN', 253559),
(431407, 'PTHR47967:SF48', NULL, NULL, NULL, NULL, 'OS08G0469100 PROTEIN', 253559),
(431408, 'PTHR47967', NULL, NULL, NULL, NULL, 'OS07G0603500 PROTEIN-RELATED', 253559),
(431409, 'PTHR47967:SF85', NULL, NULL, NULL, NULL, 'OS05G0384300 PROTEIN', 253559),
(431410, 'PTHR47967:SF41', NULL, NULL, NULL, NULL, 'ASPARTYL PROTEASE FAMILY PROTEIN', 253559),
(431411, 'PTHR47967:SF84', NULL, NULL, NULL, NULL, 'OS05G0596000 PROTEIN', 253559),
(431412, 'PTHR47967:SF43', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431413, 'PTHR47967:SF42', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431414, 'PTHR47967:SF86', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 253559),
(431415, 'PTHR47967:SF89', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431416, 'PTHR47967:SF45', NULL, NULL, NULL, NULL, 'OS07G0533800 PROTEIN', 253559),
(431417, 'PTHR47967:SF88', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431418, 'PTHR47967:SF44', NULL, NULL, NULL, NULL, 'OS05G0557100 PROTEIN', 253559),
(431419, 'PTHR47967:SF47', NULL, NULL, NULL, NULL, 'CHLOROPLAST NUCLEOID DNA-BINDING PROTEIN-LIKE', 253559),
(431420, 'PTHR47967:SF46', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431421, 'PTHR47967:SF91', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431422, 'PTHR47967:SF50', NULL, NULL, NULL, NULL, 'PEPTIDASE A1 DOMAIN-CONTAINING PROTEIN', 253559),
(431423, 'PTHR47967:SF94', NULL, NULL, NULL, NULL, 'EUKARYOTIC ASPARTYL PROTEASE FAMILY PROTEIN', 253559),
(431424, 'PTHR37750:SF1', NULL, NULL, NULL, NULL, 'COX19-LIKE CHCH FAMILY PROTEIN', 253560),
(431425, 'PTHR37750', NULL, NULL, NULL, NULL, 'COX19-LIKE CHCH FAMILY PROTEIN', 253560),
(431426, 'PTHR44791:SF1', NULL, NULL, NULL, NULL, 'TELOMERASE PROTEIN COMPONENT 1', 253561),
(431427, 'PTHR44791', NULL, NULL, NULL, NULL, 'TELOMERASE PROTEIN COMPONENT 1 TEP1', 253561),
(431428, 'PTHR42115:SF1', NULL, NULL, NULL, NULL, 'BETA-SYNTHASE (BETA-THIONASE), PUTATIVE (AFU_ORTHOLOGUE AFUA_3G08420)-RELATED', 253562),
(431429, 'PTHR42115', NULL, NULL, NULL, NULL, 'BETA-SYNTHASE (BETA-THIONASE), PUTATIVE (AFU_ORTHOLOGUE AFUA_3G08420)-RELATED', 253562),
(431430, 'PTHR15681', NULL, NULL, NULL, NULL, 'MAD2L1-BINDING PROTEIN', 253563),
(431431, 'PTHR15681:SF1', NULL, NULL, NULL, NULL, 'MAD2L1-BINDING PROTEIN', 253563),
(431432, 'PTHR16736:SF5', NULL, NULL, NULL, NULL, 'CORTEXIN DOMAIN-CONTAINING 1', 253564),
(431433, 'PTHR16736:SF4', NULL, NULL, NULL, NULL, 'CORTEXIN-3-LIKE', 253564),
(431434, 'PTHR16736:SF3', NULL, NULL, NULL, NULL, 'CORTEXIN-1', 253564),
(431435, 'PTHR16736:SF2', NULL, NULL, NULL, NULL, 'CORTEXIN-2', 253564),
(431436, 'PTHR16736:SF1', NULL, NULL, NULL, NULL, 'CORTEXIN-3', 253564),
(431437, 'PTHR16736', NULL, NULL, NULL, NULL, 'CORTEXIN-1-RELATED', 253564),
(431438, 'PTHR16736:SF7', NULL, NULL, NULL, NULL, '', 253564),
(431439, 'PTHR16736:SF6', NULL, NULL, NULL, NULL, 'CORTEXIN DOMAIN CONTAINING 2', 253564),
(431440, 'PTHR16277', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE ASSOCIATED PROTEIN 4/SERTA DOMAIN-CONTAINING PROTEIN 2', 253565),
(431441, 'PTHR16277:SF14', NULL, NULL, NULL, NULL, 'SERTA DOMAIN-CONTAINING PROTEIN', 253565),
(431442, 'PTHR16277:SF13', NULL, NULL, NULL, NULL, 'ZGC:113340', 253565),
(431443, 'PTHR16277:SF12', NULL, NULL, NULL, NULL, 'SERTA DOMAIN-CONTAINING PROTEIN 1', 253565),
(431444, 'PTHR16277:SF11', NULL, NULL, NULL, NULL, 'SI:DKEY-177P2.6', 253565),
(431445, 'PTHR16277:SF6', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE-ASSOCIATED PROTEIN 4', 253565);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(431446, 'PTHR16277:SF10', NULL, NULL, NULL, NULL, 'SERTA DOMAIN-CONTAINING PROTEIN 2', 253565),
(431447, 'PTHR16277:SF7', NULL, NULL, NULL, NULL, 'RE12330P', 253565),
(431448, 'PTHR15936', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN G I /G S /G O  GAMMA-13 SUBUNIT', 253566),
(431449, 'PTHR15936:SF2', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN G(I)/G(S)/G(O) SUBUNIT GAMMA-13', 253566),
(431450, 'PTHR47855:SF6', NULL, NULL, NULL, NULL, 'BNAC06G29620D PROTEIN', 253567),
(431451, 'PTHR47855', NULL, NULL, NULL, NULL, 'OS01G0525701 PROTEIN', 253567),
(431452, 'PTHR47855:SF3', NULL, NULL, NULL, NULL, 'SMALL POLYPEPTIDE DEVIL 1-RELATED', 253567),
(431453, 'PTHR47855:SF4', NULL, NULL, NULL, NULL, '', 253567),
(431454, 'PTHR47855:SF5', NULL, NULL, NULL, NULL, '', 253567),
(431455, 'PTHR46918:SF1', NULL, NULL, NULL, NULL, 'SYNAPTONEMAL COMPLEX PROTEIN 1', 253568),
(431456, 'PTHR46918', NULL, NULL, NULL, NULL, 'SYNAPTONEMAL COMPLEX PROTEIN 1', 253568),
(431457, 'PTHR31835', NULL, NULL, NULL, NULL, 'URIDINE DIPHOSPHATE GLUCOSE PYROPHOSPHATASE', 253569),
(431458, 'PTHR31835:SF1', NULL, NULL, NULL, NULL, 'URIDINE DIPHOSPHATE GLUCOSE PYROPHOSPHATASE NUDT22', 253569),
(431459, 'PTHR47082', NULL, NULL, NULL, NULL, 'KERATIN-LIKE PROTEIN KRT222', 253570),
(431460, 'PTHR47082:SF1', NULL, NULL, NULL, NULL, 'KERATIN-LIKE PROTEIN KRT222', 253570),
(431461, 'PTHR43709', NULL, NULL, NULL, NULL, 'ACONITATE ISOMERASE-RELATED', 253571),
(431462, 'PTHR43709:SF3', NULL, NULL, NULL, NULL, 'ISOMERASE YBHH-RELATED', 253571),
(431463, 'PTHR43709:SF2', NULL, NULL, NULL, NULL, 'DUF453 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_6G00360)', 253571),
(431464, 'PTHR11589:SF10', NULL, NULL, NULL, NULL, 'BETA-NERVE GROWTH FACTOR', 253572),
(431465, 'PTHR11589:SF11', NULL, NULL, NULL, NULL, 'PREPRO-NEUROTROPHIN', 253572),
(431466, 'PTHR11589:SF8', NULL, NULL, NULL, NULL, 'NEUROTROPHIN-4', 253572),
(431467, 'PTHR11589', NULL, NULL, NULL, NULL, 'NERVE GROWTH FACTOR  NGF -RELATED', 253572),
(431468, 'PTHR11589:SF3', NULL, NULL, NULL, NULL, 'BRAIN-DERIVED NEUROTROPHIC FACTOR', 253572),
(431469, 'PTHR11589:SF4', NULL, NULL, NULL, NULL, 'NEUROTROPHIN-3', 253572),
(431470, 'PTHR46549:SF1', NULL, NULL, NULL, NULL, 'MACPF DOMAIN-CONTAINING PROTEIN', 253573),
(431471, 'PTHR46549', NULL, NULL, NULL, NULL, 'MACPF DOMAIN-CONTAINING PROTEIN', 253573),
(431472, 'PTHR46871:SF1', NULL, NULL, NULL, NULL, 'BROMO-ADJACENT HOMOLOGY (BAH) DOMAIN-CONTAINING PROTEIN', 253574),
(431473, 'PTHR46871:SF3', NULL, NULL, NULL, NULL, 'BAH DOMAIN-CONTAINING PROTEIN', 253574),
(431474, 'PTHR46871:SF4', NULL, NULL, NULL, NULL, 'BNAA03G45750D PROTEIN', 253574),
(431475, 'PTHR46871:SF5', NULL, NULL, NULL, NULL, 'BAH DOMAIN-CONTAINING PROTEIN', 253574),
(431476, 'PTHR46871:SF6', NULL, NULL, NULL, NULL, 'BNAA03G45740D PROTEIN', 253574),
(431477, 'PTHR46871', NULL, NULL, NULL, NULL, 'BROMO-ADJACENT HOMOLOGY (BAH) DOMAIN-CONTAINING PROTEIN', 253574),
(431478, 'PTHR46871:SF7', NULL, NULL, NULL, NULL, 'BNAA03G45770D PROTEIN', 253574),
(431479, 'PTHR15074:SF0', NULL, NULL, NULL, NULL, 'METHYL-CPG-BINDING DOMAIN PROTEIN 4-LIKE PROTEIN', 253575),
(431480, 'PTHR15074', NULL, NULL, NULL, NULL, 'METHYL-CPG-BINDING PROTEIN', 253575),
(431481, 'PTHR15074:SF5', NULL, NULL, NULL, NULL, '', 253575),
(431482, 'PTHR15074:SF6', NULL, NULL, NULL, NULL, 'METHYL-CPG-BINDING PROTEIN 2', 253575),
(431483, 'PTHR15074:SF7', NULL, NULL, NULL, NULL, 'METHYL-CPG-BINDING DOMAIN PROTEIN 4', 253575),
(431484, 'PTHR35460', NULL, NULL, NULL, NULL, 'TRNA LIGASE 1', 253576),
(431485, 'PTHR35460:SF3', NULL, NULL, NULL, NULL, '', 253576),
(431486, 'PTHR35460:SF4', NULL, NULL, NULL, NULL, 'TRNA_LIG_CPD DOMAIN-CONTAINING PROTEIN', 253576),
(431487, 'PTHR35460:SF1', NULL, NULL, NULL, NULL, 'TRNA LIGASE 1', 253576),
(431488, 'PTHR36740', NULL, NULL, NULL, NULL, 'PRC DOMAIN-CONTAINING PROTEIN', 253577),
(431489, 'PTHR36740:SF1', NULL, NULL, NULL, NULL, 'PRC DOMAIN-CONTAINING PROTEIN', 253577),
(431490, 'PTHR15736:SF4', NULL, NULL, NULL, NULL, 'PROTEIN FAM131A', 253578),
(431491, 'PTHR15736:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM131C', 253578);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(431492, 'PTHR15736', NULL, NULL, NULL, NULL, 'PROTEIN FAM131B-RELATED', 253578),
(431493, 'PTHR15736:SF9', NULL, NULL, NULL, NULL, 'PROTEIN FAM131B', 253578),
(431494, 'PTHR15736:SF10', NULL, NULL, NULL, NULL, 'FAMILY WITH SEQUENCE SIMILARITY 131 MEMBER BA', 253578),
(431495, 'PTHR30607', NULL, NULL, NULL, NULL, 'POTASSIUM-TRANSPORTING ATPASE A CHAIN', 253579),
(431496, 'PTHR30607:SF2', NULL, NULL, NULL, NULL, 'POTASSIUM-TRANSPORTING ATPASE POTASSIUM-BINDING SUBUNIT', 253579),
(431497, 'PTHR48015:SF7', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE TAO2', 253580),
(431498, 'PTHR48015:SF8', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 253580),
(431499, 'PTHR48015:SF9', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PAKG', 253580),
(431500, 'PTHR48015:SF3', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PAKA', 253580),
(431501, 'PTHR48015:SF4', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PAK MBT', 253580),
(431502, 'PTHR48015:SF5', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PAKB', 253580),
(431503, 'PTHR48015:SF6', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE CLA4-RELATED', 253580),
(431504, 'PTHR48015:SF18', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DST3', 253580),
(431505, 'PTHR48015:SF19', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PAK 6', 253580),
(431506, 'PTHR48015:SF38', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PAKH', 253580),
(431507, 'PTHR48015:SF16', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SULU', 253580),
(431508, 'PTHR48015:SF17', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PAK 4', 253580),
(431509, 'PTHR48015:SF39', NULL, NULL, NULL, NULL, 'TRAF2 AND NCK-INTERACTING PROTEIN KINASE', 253580),
(431510, 'PTHR48015:SF2', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE KINASE 4', 253580),
(431511, 'PTHR48015:SF32', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 4', 253580),
(431512, 'PTHR48015:SF10', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE MAX-2', 253580),
(431513, 'PTHR48015:SF11', NULL, NULL, NULL, NULL, 'MISSHAPEN-LIKE KINASE 1', 253580),
(431514, 'PTHR48015:SF33', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE HIPPO', 253580),
(431515, 'PTHR48015:SF30', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PAK 3', 253580),
(431516, 'PTHR48015:SF31', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253580),
(431517, 'PTHR48015:SF14', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE TAO3', 253580),
(431518, 'PTHR48015:SF15', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 4 HOMOLOG B', 253580),
(431519, 'PTHR48015:SF12', NULL, NULL, NULL, NULL, 'SI:ZFOS-2326C3.2', 253580),
(431520, 'PTHR48015:SF13', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DST4', 253580),
(431521, 'PTHR48015:SF35', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PAK', 253580),
(431522, 'PTHR48015', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE TAO', 253580),
(431523, 'PTHR48015:SF27', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PAK 5', 253580),
(431524, 'PTHR48015:SF21', NULL, NULL, NULL, NULL, 'MISSHAPEN, ISOFORM A', 253580),
(431525, 'PTHR48015:SF22', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PAK 2', 253580),
(431526, 'PTHR48015:SF20', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PAK 1', 253580),
(431527, 'PTHR48015:SF25', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE FLR-4', 253580),
(431528, 'PTHR48015:SF26', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PAKD', 253580),
(431529, 'PTHR48015:SF23', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 3', 253580),
(431530, 'PTHR27002:SF998', NULL, NULL, NULL, NULL, 'G-TYPE LECTIN S-RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431531, 'PTHR27002:SF999', NULL, NULL, NULL, NULL, 'S-LOCUS LECTIN KINASE FAMILY PROTEIN', 253581),
(431532, 'PTHR27002:SF878', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE SD1-8 ISOFORM X1', 253581);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(431533, 'PTHR27002:SF996', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN KINASE RK20-1', 253581),
(431534, 'PTHR27002:SF76', NULL, NULL, NULL, NULL, 'OS10G0136400 PROTEIN', 253581),
(431535, 'PTHR27002:SF634', NULL, NULL, NULL, NULL, 'LECTIN KINASE FAMILY PROTEIN, PUTATIVE-RELATED', 253581),
(431536, 'PTHR27002:SF997', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 19-RELATED', 253581),
(431537, 'PTHR27002:SF518', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN', 253581),
(431538, 'PTHR27002:SF990', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 10 ISOFORM X1', 253581),
(431539, 'PTHR27002:SF870', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253581),
(431540, 'PTHR27002:SF991', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431541, 'PTHR27002:SF510', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-KINASE-LIKE PROTEIN', 253581),
(431542, 'PTHR27002:SF994', NULL, NULL, NULL, NULL, 'BNACNNG25670D PROTEIN', 253581),
(431543, 'PTHR27002:SF995', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 253581),
(431544, 'PTHR27002:SF874', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431545, 'PTHR27002:SF992', NULL, NULL, NULL, NULL, 'BNAC03G64190D PROTEIN', 253581),
(431546, 'PTHR27002:SF871', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431547, 'PTHR27002:SF872', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 10', 253581),
(431548, 'PTHR27002:SF993', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431549, 'PTHR27002:SF509', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 16-RELATED', 253581),
(431550, 'PTHR27002:SF987', NULL, NULL, NULL, NULL, 'BNAC02G47540D PROTEIN', 253581),
(431551, 'PTHR27002:SF866', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 10', 253581),
(431552, 'PTHR27002:SF988', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431553, 'PTHR27002:SF622', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 5', 253581),
(431554, 'PTHR27002:SF864', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431555, 'PTHR27002:SF985', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431556, 'PTHR27002:SF986', NULL, NULL, NULL, NULL, 'BNAC03G29890D PROTEIN', 253581),
(431557, 'PTHR27002:SF989', NULL, NULL, NULL, NULL, 'BNAC04G37380D PROTEIN', 253581),
(431558, 'PTHR27002:SF747', NULL, NULL, NULL, NULL, 'G-TYPE LECTIN S-RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE RKS1', 253581),
(431559, 'PTHR27002:SF506', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431560, 'PTHR27002:SF869', NULL, NULL, NULL, NULL, 'OS02G0710500 PROTEIN', 253581),
(431561, 'PTHR27002:SF748', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-KINASE-LIKE PROTEIN', 253581),
(431562, 'PTHR27002:SF980', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 10 ISOFORM X1', 253581),
(431563, 'PTHR27002:SF983', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431564, 'PTHR27002:SF984', NULL, NULL, NULL, NULL, 'BNAA03G45810D PROTEIN', 253581),
(431565, 'PTHR27002:SF742', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 21', 253581),
(431566, 'PTHR27002:SF860', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431567, 'PTHR27002:SF981', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431568, 'PTHR27002:SF982', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431569, 'PTHR27002:SF861', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 25', 253581),
(431570, 'PTHR27002:SF776', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RLK (RECEPTOR-LIKE KINASE) PROTEIN', 253581),
(431571, 'PTHR27002:SF897', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(431572, 'PTHR27002:SF777', NULL, NULL, NULL, NULL, 'OS07G0541000 PROTEIN', 253581),
(431573, 'PTHR27002:SF898', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431574, 'PTHR27002:SF659', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 25', 253581),
(431575, 'PTHR27002:SF892', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253581),
(431576, 'PTHR27002:SF411', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431577, 'PTHR27002:SF896', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431578, 'PTHR27002:SF646', NULL, NULL, NULL, NULL, 'S-LOCUS LECTIN KINASE FAMILY PROTEIN', 253581),
(431579, 'PTHR27002:SF888', NULL, NULL, NULL, NULL, 'S-LOCUS LECTIN PROTEIN KINASE FAMILY PROTEIN', 253581),
(431580, 'PTHR27002:SF526', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431581, 'PTHR27002:SF402', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-KINASE-LIKE PROTEIN', 253581),
(431582, 'PTHR27002:SF523', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431583, 'PTHR27002:SF527', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431584, 'PTHR27002:SF528', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 37', 253581),
(431585, 'PTHR27002:SF880', NULL, NULL, NULL, NULL, 'G-TYPE LECTIN S-RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE SD1-1', 253581),
(431586, 'PTHR27002:SF884', NULL, NULL, NULL, NULL, '', 253581),
(431587, 'PTHR27002:SF885', NULL, NULL, NULL, NULL, 'DUF26-DOMAIN RECEPTOR-LIKE PROTEIN KINASE FAMILY PROTEIN-RELATED', 253581),
(431588, 'PTHR27002:SF883', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253581),
(431589, 'PTHR27002:SF762', NULL, NULL, NULL, NULL, '', 253581),
(431590, 'PTHR27002:SF1006', NULL, NULL, NULL, NULL, 'BNAC01G14360D PROTEIN', 253581),
(431591, 'PTHR27002:SF1005', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431592, 'PTHR27002:SF1004', NULL, NULL, NULL, NULL, 'BNAC01G14850D PROTEIN', 253581),
(431593, 'PTHR27002:SF1003', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253581),
(431594, 'PTHR27002:SF1009', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253581),
(431595, 'PTHR27002:SF1008', NULL, NULL, NULL, NULL, 'BNACNNG25690D PROTEIN', 253581),
(431596, 'PTHR27002:SF1007', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431597, 'PTHR27002:SF679', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 10 ISOFORM X1', 253581),
(431598, 'PTHR27002:SF559', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RLK (RECEPTOR-LIKE KINASE) PROTEIN', 253581),
(431599, 'PTHR27002:SF798', NULL, NULL, NULL, NULL, 'OS08G0343000 PROTEIN', 253581),
(431600, 'PTHR27002:SF556', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 35-RELATED', 253581),
(431601, 'PTHR27002:SF678', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431602, 'PTHR27002:SF799', NULL, NULL, NULL, NULL, 'BNAA03G45820D PROTEIN', 253581),
(431603, 'PTHR27002:SF1002', NULL, NULL, NULL, NULL, '', 253581),
(431604, 'PTHR27002:SF1001', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 10-RELATED', 253581),
(431605, 'PTHR27002:SF1000', NULL, NULL, NULL, NULL, 'BNAC01G14680D PROTEIN', 253581),
(431606, 'PTHR27002:SF674', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253581),
(431607, 'PTHR27002:SF1017', NULL, NULL, NULL, NULL, 'SERINE-THREONINE/TYROSINE-PROTEIN KINASE CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 253581),
(431608, 'PTHR27002:SF1016', NULL, NULL, NULL, NULL, 'BNAC08G14870D PROTEIN', 253581),
(431609, 'PTHR27002:SF1015', NULL, NULL, NULL, NULL, 'G-TYPE LECTIN S-RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE CES101', 253581),
(431610, 'PTHR27002:SF1014', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(431611, 'PTHR27002:SF1019', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 10', 253581),
(431612, 'PTHR27002:SF1018', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253581),
(431613, 'PTHR27002:SF427', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 10', 253581),
(431614, 'PTHR27002:SF548', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431615, 'PTHR27002', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE SD1-8', 253581),
(431616, 'PTHR27002:SF666', NULL, NULL, NULL, NULL, '', 253581),
(431617, 'PTHR27002:SF428', NULL, NULL, NULL, NULL, 'OS07G0541900 PROTEIN', 253581),
(431618, 'PTHR27002:SF1013', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431619, 'PTHR27002:SF422', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431620, 'PTHR27002:SF1012', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431621, 'PTHR27002:SF423', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 10', 253581),
(431622, 'PTHR27002:SF783', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 31-RELATED', 253581),
(431623, 'PTHR27002:SF1011', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431624, 'PTHR27002:SF1010', NULL, NULL, NULL, NULL, 'BNAC01G14630D PROTEIN', 253581),
(431625, 'PTHR27002:SF542', NULL, NULL, NULL, NULL, 'ATP BINDING / PROTEIN KINASE', 253581),
(431626, 'PTHR27002:SF1028', NULL, NULL, NULL, NULL, 'BNAC06G41760D PROTEIN', 253581),
(431627, 'PTHR27002:SF1027', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431628, 'PTHR27002:SF1026', NULL, NULL, NULL, NULL, 'G-TYPE LECTIN S-RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE SD1-29', 253581),
(431629, 'PTHR27002:SF1025', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 30-RELATED', 253581),
(431630, 'PTHR27002:SF1029', NULL, NULL, NULL, NULL, 'BNAA09G20420D PROTEIN', 253581),
(431631, 'PTHR27002:SF1020', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431632, 'PTHR27002:SF452', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 40-RELATED', 253581),
(431633, 'PTHR27002:SF1024', NULL, NULL, NULL, NULL, 'BNAA01G12650D PROTEIN', 253581),
(431634, 'PTHR27002:SF697', NULL, NULL, NULL, NULL, 'OS01G0296000 PROTEIN', 253581),
(431635, 'PTHR27002:SF214', NULL, NULL, NULL, NULL, 'SERINE/THREONINE KINASE FAMILY PROTEIN', 253581),
(431636, 'PTHR27002:SF1023', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253581),
(431637, 'PTHR27002:SF698', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 38', 253581),
(431638, 'PTHR27002:SF453', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 11-RELATED', 253581),
(431639, 'PTHR27002:SF695', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 13-RELATED', 253581),
(431640, 'PTHR27002:SF1022', NULL, NULL, NULL, NULL, 'G-TYPE LECTIN S-RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE B120', 253581),
(431641, 'PTHR27002:SF454', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431642, 'PTHR27002:SF1021', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431643, 'PTHR27002:SF1039', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431644, 'PTHR27002:SF1038', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 19', 253581),
(431645, 'PTHR27002:SF1037', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431646, 'PTHR27002:SF1036', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431647, 'PTHR27002:SF68', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431648, 'PTHR27002:SF1031', NULL, NULL, NULL, NULL, 'BNAC01G14620D PROTEIN', 253581),
(431649, 'PTHR27002:SF1030', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(431650, 'PTHR27002:SF1035', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE SD1-6-RELATED', 253581),
(431651, 'PTHR27002:SF1034', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431652, 'PTHR27002:SF566', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253581),
(431653, 'PTHR27002:SF1033', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431654, 'PTHR27002:SF443', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431655, 'PTHR27002:SF1032', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431656, 'PTHR27002:SF1049', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 20-RELATED', 253581),
(431657, 'PTHR27002:SF1048', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431658, 'PTHR27002:SF1047', NULL, NULL, NULL, NULL, 'BNAC03G65160D PROTEIN', 253581),
(431659, 'PTHR27002:SF4', NULL, NULL, NULL, NULL, 'OS05G0130100 PROTEIN', 253581),
(431660, 'PTHR27002:SF919', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253581),
(431661, 'PTHR27002:SF910', NULL, NULL, NULL, NULL, 'OS07G0537000 PROTEIN', 253581),
(431662, 'PTHR27002:SF911', NULL, NULL, NULL, NULL, 'OS07G0538700 PROTEIN', 253581),
(431663, 'PTHR27002:SF914', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253581),
(431664, 'PTHR27002:SF915', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 8', 253581),
(431665, 'PTHR27002:SF912', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431666, 'PTHR27002:SF913', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431667, 'PTHR27002:SF1042', NULL, NULL, NULL, NULL, 'RLK (RECEPTOR-LIKE PROTEIN KINASE) 25, PUTATIVE-RELATED', 253581),
(431668, 'PTHR27002:SF1041', NULL, NULL, NULL, NULL, 'BNAA03G45860D PROTEIN', 253581),
(431669, 'PTHR27002:SF1040', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 10', 253581),
(431670, 'PTHR27002:SF471', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431671, 'PTHR27002:SF472', NULL, NULL, NULL, NULL, 'OS07G0534700 PROTEIN', 253581),
(431672, 'PTHR27002:SF1046', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 36', 253581),
(431673, 'PTHR27002:SF1045', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431674, 'PTHR27002:SF1044', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', 253581),
(431675, 'PTHR27002:SF113', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253581),
(431676, 'PTHR27002:SF355', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431677, 'PTHR27002:SF1043', NULL, NULL, NULL, NULL, 'BNAA01G12590D PROTEIN', 253581),
(431678, 'PTHR27002:SF1059', NULL, NULL, NULL, NULL, 'BNAA01G12660D PROTEIN', 253581),
(431679, 'PTHR27002:SF1058', NULL, NULL, NULL, NULL, 'OS07G0487300 PROTEIN', 253581),
(431680, 'PTHR27002:SF907', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431681, 'PTHR27002:SF906', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431682, 'PTHR27002:SF900', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253581),
(431683, 'PTHR27002:SF347', NULL, NULL, NULL, NULL, 'OS07G0540100 PROTEIN', 253581),
(431684, 'PTHR27002:SF589', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-KINASE-LIKE PROTEIN', 253581),
(431685, 'PTHR27002:SF901', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431686, 'PTHR27002:SF902', NULL, NULL, NULL, NULL, '', 253581),
(431687, 'PTHR27002:SF583', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431688, 'PTHR27002:SF1053', NULL, NULL, NULL, NULL, 'BNAC03G44170D PROTEIN', 253581),
(431689, 'PTHR27002:SF1052', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 10', 253581);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(431690, 'PTHR27002:SF460', NULL, NULL, NULL, NULL, 'OS01G0366300 PROTEIN', 253581),
(431691, 'PTHR27002:SF1051', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253581),
(431692, 'PTHR27002:SF1050', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 5', 253581),
(431693, 'PTHR27002:SF345', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253581),
(431694, 'PTHR27002:SF1057', NULL, NULL, NULL, NULL, 'S-LOCUS LECTIN KINASE FAMILY PROTEIN', 253581),
(431695, 'PTHR27002:SF1056', NULL, NULL, NULL, NULL, 'BNAC01G14610D PROTEIN', 253581),
(431696, 'PTHR27002:SF1055', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253581),
(431697, 'PTHR27002:SF1054', NULL, NULL, NULL, NULL, 'OS07G0628700 PROTEIN', 253581),
(431698, 'PTHR27002:SF819', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431699, 'PTHR27002:SF938', NULL, NULL, NULL, NULL, 'S-LOCUS LECTIN KINASE FAMILY PROTEIN', 253581),
(431700, 'PTHR27002:SF18', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 10', 253581),
(431701, 'PTHR27002:SF939', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431702, 'PTHR27002:SF16', NULL, NULL, NULL, NULL, 'OS07G0537500 PROTEIN', 253581),
(431703, 'PTHR27002:SF811', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-KINASE-LIKE PROTEIN', 253581),
(431704, 'PTHR27002:SF932', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431705, 'PTHR27002:SF812', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431706, 'PTHR27002:SF933', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431707, 'PTHR27002:SF930', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431708, 'PTHR27002:SF810', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 33-RELATED', 253581),
(431709, 'PTHR27002:SF931', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253581),
(431710, 'PTHR27002:SF1060', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431711, 'PTHR27002:SF936', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431712, 'PTHR27002:SF937', NULL, NULL, NULL, NULL, 'OS12G0249900 PROTEIN', 253581),
(431713, 'PTHR27002:SF934', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253581),
(431714, 'PTHR27002:SF935', NULL, NULL, NULL, NULL, 'OS01G0545500 PROTEIN', 253581),
(431715, 'PTHR27002:SF814', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 10', 253581),
(431716, 'PTHR27002:SF1064', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 14', 253581),
(431717, 'PTHR27002:SF496', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431718, 'PTHR27002:SF1063', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431719, 'PTHR27002:SF1062', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431720, 'PTHR27002:SF372', NULL, NULL, NULL, NULL, 'OS04G0197200 PROTEIN', 253581),
(431721, 'PTHR27002:SF1061', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 35-RELATED', 253581),
(431722, 'PTHR27002:SF1066', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 10', 253581),
(431723, 'PTHR27002:SF1065', NULL, NULL, NULL, NULL, 'BNACNNG49020D PROTEIN', 253581),
(431724, 'PTHR27002:SF498', NULL, NULL, NULL, NULL, 'DUF26-DOMAIN PROTEIN KINASE FAMILY PROTEIN-RELATED', 253581),
(431725, 'PTHR27002:SF929', NULL, NULL, NULL, NULL, 'GNK2-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', 253581),
(431726, 'PTHR27002:SF808', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431727, 'PTHR27002:SF927', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431728, 'PTHR27002:SF928', NULL, NULL, NULL, NULL, 'G-TYPE LECTIN S-RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(431729, 'PTHR27002:SF921', NULL, NULL, NULL, NULL, '', 253581),
(431730, 'PTHR27002:SF801', NULL, NULL, NULL, NULL, 'BNAA01G24810D PROTEIN', 253581),
(431731, 'PTHR27002:SF925', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431732, 'PTHR27002:SF804', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253581),
(431733, 'PTHR27002:SF926', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431734, 'PTHR27002:SF805', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431735, 'PTHR27002:SF803', NULL, NULL, NULL, NULL, 'OS07G0628900 PROTEIN', 253581),
(431736, 'PTHR27002:SF126', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 6', 253581),
(431737, 'PTHR27002:SF123', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 45', 253581),
(431738, 'PTHR27002:SF839', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253581),
(431739, 'PTHR27002:SF954', NULL, NULL, NULL, NULL, '', 253581),
(431740, 'PTHR27002:SF955', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431741, 'PTHR27002:SF834', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431742, 'PTHR27002:SF952', NULL, NULL, NULL, NULL, 'BNAA03G45850D PROTEIN', 253581),
(431743, 'PTHR27002:SF953', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431744, 'PTHR27002:SF711', NULL, NULL, NULL, NULL, 'OS10G0327000 PROTEIN', 253581),
(431745, 'PTHR27002:SF837', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431746, 'PTHR27002:SF958', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253581),
(431747, 'PTHR27002:SF716', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431748, 'PTHR27002:SF959', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253581),
(431749, 'PTHR27002:SF838', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431750, 'PTHR27002:SF956', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253581),
(431751, 'PTHR27002:SF957', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431752, 'PTHR27002:SF396', NULL, NULL, NULL, NULL, 'OS06G0496800 PROTEIN', 253581),
(431753, 'PTHR27002:SF950', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN S6, PUTATIVE-RELATED', 253581),
(431754, 'PTHR27002:SF951', NULL, NULL, NULL, NULL, 'GNK2-HOMOLOGOUS DOMAIN-CONTAINING PROTEIN', 253581),
(431755, 'PTHR27002:SF399', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 24', 253581),
(431756, 'PTHR27002:SF150', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE SD1-8', 253581),
(431757, 'PTHR27002:SF709', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-KINASE-LIKE PROTEIN', 253581),
(431758, 'PTHR27002:SF828', NULL, NULL, NULL, NULL, 'OS04G0633600 PROTEIN', 253581),
(431759, 'PTHR27002:SF949', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431760, 'PTHR27002:SF943', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253581),
(431761, 'PTHR27002:SF944', NULL, NULL, NULL, NULL, 'G-TYPE LECTIN S-RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE CES101', 253581),
(431762, 'PTHR27002:SF941', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431763, 'PTHR27002:SF942', NULL, NULL, NULL, NULL, 'BNACNNG60310D PROTEIN', 253581),
(431764, 'PTHR27002:SF947', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431765, 'PTHR27002:SF827', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431766, 'PTHR27002:SF948', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-KINASE-LIKE PROTEIN', 253581),
(431767, 'PTHR27002:SF945', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431768, 'PTHR27002:SF824', NULL, NULL, NULL, NULL, 'OS07G0535800 PROTEIN', 253581);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(431769, 'PTHR27002:SF946', NULL, NULL, NULL, NULL, '', 253581),
(431770, 'PTHR27002:SF825', NULL, NULL, NULL, NULL, 'S-LOCUS LECTIN KINASE FAMILY PROTEIN', 253581),
(431771, 'PTHR27002:SF940', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE, STRIATED MUSCLE-SPECIFIC-RELATED', 253581),
(431772, 'PTHR27002:SF145', NULL, NULL, NULL, NULL, 'OS06G0693000 PROTEIN', 253581),
(431773, 'PTHR27002:SF180', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE SD1-8', 253581),
(431774, 'PTHR27002:SF181', NULL, NULL, NULL, NULL, 'G-TYPE LECTIN S-RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE SD1-13', 253581),
(431775, 'PTHR27002:SF976', NULL, NULL, NULL, NULL, 'BNAC02G26130D PROTEIN', 253581),
(431776, 'PTHR27002:SF977', NULL, NULL, NULL, NULL, '', 253581),
(431777, 'PTHR27002:SF974', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431778, 'PTHR27002:SF853', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RLK (RECEPTOR-LIKE KINASE) PROTEIN', 253581),
(431779, 'PTHR27002:SF975', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253581),
(431780, 'PTHR27002:SF859', NULL, NULL, NULL, NULL, 'BNAA09G40890D PROTEIN', 253581),
(431781, 'PTHR27002:SF739', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431782, 'PTHR27002:SF978', NULL, NULL, NULL, NULL, 'OS11G0226201 PROTEIN', 253581),
(431783, 'PTHR27002:SF979', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253581),
(431784, 'PTHR27002:SF616', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431785, 'PTHR27002:SF972', NULL, NULL, NULL, NULL, 'SERINE/THREONINE/DUAL SPECIFICITY PROTEIN KINASE, CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 253581),
(431786, 'PTHR27002:SF851', NULL, NULL, NULL, NULL, 'G-TYPE LECTIN S-RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE SD1-1', 253581),
(431787, 'PTHR27002:SF973', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431788, 'PTHR27002:SF852', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431789, 'PTHR27002:SF970', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE KINASE', 253581),
(431790, 'PTHR27002:SF971', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431791, 'PTHR27002:SF729', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-KINASE-LIKE PROTEIN', 253581),
(431792, 'PTHR27002:SF844', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 41', 253581),
(431793, 'PTHR27002:SF965', NULL, NULL, NULL, NULL, 'PROTEIN KINASE, PUTATIVE,EXPRESSED-RELATED', 253581),
(431794, 'PTHR27002:SF724', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431795, 'PTHR27002:SF966', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431796, 'PTHR27002:SF963', NULL, NULL, NULL, NULL, 'RLK (RECEPTOR-LIKE PROTEIN KINASE) 14, PUTATIVE ISOFORM 2-RELATED', 253581),
(431797, 'PTHR27002:SF964', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431798, 'PTHR27002:SF722', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431799, 'PTHR27002:SF969', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 27-RELATED', 253581),
(431800, 'PTHR27002:SF967', NULL, NULL, NULL, NULL, 'BNACNNG59240D PROTEIN', 253581),
(431801, 'PTHR27002:SF847', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-KINASE-LIKE PROTEIN', 253581),
(431802, 'PTHR27002:SF968', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253581),
(431803, 'PTHR27002:SF961', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RLK (RECEPTOR-LIKE PROTEIN KINASE) 7-RELATED', 253581),
(431804, 'PTHR27002:SF962', NULL, NULL, NULL, NULL, 'BNAA03G45760D PROTEIN', 253581),
(431805, 'PTHR27002:SF841', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE', 253581),
(431806, 'PTHR27002:SF960', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 26', 253581);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(431807, 'PTHR13556:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ADAPTER 3', 253582),
(431808, 'PTHR13556', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ADAPTER 3-RELATED', 253582),
(431809, 'PTHR28570:SF16', NULL, NULL, NULL, NULL, 'ASPARTYL AMINOPEPTIDASE-RELATED', 253583),
(431810, 'PTHR28570', NULL, NULL, NULL, NULL, 'ASPARTYL AMINOPEPTIDASE', 253583),
(431811, 'PTHR28570:SF2', NULL, NULL, NULL, NULL, 'M18 FAMILY AMINOPEPTIDASE 1-RELATED', 253583),
(431812, 'PTHR28570:SF4', NULL, NULL, NULL, NULL, 'VACUOLAR AMINOPEPTIDASE 1', 253583),
(431813, 'PTHR28570:SF3', NULL, NULL, NULL, NULL, 'ASPARTYL AMINOPEPTIDASE', 253583),
(431814, 'PTHR28570:SF15', NULL, NULL, NULL, NULL, '', 253583),
(431815, 'PTHR22100', NULL, NULL, NULL, NULL, 'WINGS APART-LIKE PROTEIN HOMOLOG', 253584),
(431816, 'PTHR22100:SF13', NULL, NULL, NULL, NULL, 'WINGS APART-LIKE PROTEIN HOMOLOG', 253584),
(431817, 'PTHR22100:SF14', NULL, NULL, NULL, NULL, 'BNAC08G42210D PROTEIN', 253584),
(431818, 'PTHR43800', NULL, NULL, NULL, NULL, 'PEPTIDYL-LYSINE N-ACETYLTRANSFERASE YJAB', 253585),
(431819, 'PTHR43800:SF1', NULL, NULL, NULL, NULL, 'PEPTIDYL-LYSINE N-ACETYLTRANSFERASE YJAB', 253585),
(431820, 'PTHR16209:SF3', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 7', 253586),
(431821, 'PTHR16209:SF4', NULL, NULL, NULL, NULL, 'WW DOMAIN BINDING PROTEIN 1-LIKE', 253586),
(431822, 'PTHR16209', NULL, NULL, NULL, NULL, '', 253586),
(431823, 'PTHR16209:SF5', NULL, NULL, NULL, NULL, 'WW DOMAIN-BINDING PROTEIN 1', 253586),
(431824, 'PTHR16209:SF6', NULL, NULL, NULL, NULL, '', 253586),
(431825, 'PTHR16209:SF7', NULL, NULL, NULL, NULL, 'WW DOMAIN-BINDING PROTEIN 1', 253586),
(431826, 'PTHR31662:SF100', NULL, NULL, NULL, NULL, 'STOREKEEPER PROTEIN', 253587),
(431827, 'PTHR31662:SF101', NULL, NULL, NULL, NULL, 'OS07G0636100 PROTEIN', 253587),
(431828, 'PTHR31662:SF102', NULL, NULL, NULL, NULL, 'TYROSINE SPECIFIC PROTEIN PHOSPHATASE-LIKE', 253587),
(431829, 'PTHR31662:SF80', NULL, NULL, NULL, NULL, '', 253587),
(431830, 'PTHR31662:SF79', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REGULATOR', 253587),
(431831, 'PTHR31662:SF38', NULL, NULL, NULL, NULL, 'PROTEIN PFC0760C-LIKE', 253587),
(431832, 'PTHR31662:SF39', NULL, NULL, NULL, NULL, '', 253587),
(431833, 'PTHR31662:SF72', NULL, NULL, NULL, NULL, 'OS01G0249900 PROTEIN', 253587),
(431834, 'PTHR31662:SF71', NULL, NULL, NULL, NULL, '', 253587),
(431835, 'PTHR31662:SF32', NULL, NULL, NULL, NULL, 'OS09G0101300 PROTEIN', 253587),
(431836, 'PTHR31662:SF76', NULL, NULL, NULL, NULL, '', 253587),
(431837, 'PTHR31662:SF33', NULL, NULL, NULL, NULL, 'DNA-BINDING STOREKEEPER PROTEIN TRANSCRIPTIONAL REGULATOR-LIKE PROTEIN', 253587),
(431838, 'PTHR31662:SF77', NULL, NULL, NULL, NULL, '', 253587),
(431839, 'PTHR31662:SF74', NULL, NULL, NULL, NULL, 'LISH DOMAIN-CONTAINING PROTEIN C1711.05-LIKE', 253587),
(431840, 'PTHR31662:SF31', NULL, NULL, NULL, NULL, 'OS06G0498000 PROTEIN', 253587),
(431841, 'PTHR31662:SF1', NULL, NULL, NULL, NULL, 'DUF573 FAMILY PROTEIN', 253587),
(431842, 'PTHR31662:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR-RELATED', 253587),
(431843, 'PTHR31662:SF69', NULL, NULL, NULL, NULL, 'BNAANNG29040D PROTEIN', 253587),
(431844, 'PTHR31662:SF9', NULL, NULL, NULL, NULL, 'OS09G0126600 PROTEIN', 253587),
(431845, 'PTHR31662:SF68', NULL, NULL, NULL, NULL, 'DNA-BINDING STOREKEEPER PROTEIN TRANSCRIPTIONAL REGULATOR-LIKE PROTEIN-RELATED', 253587),
(431846, 'PTHR31662:SF8', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 253587),
(431847, 'PTHR31662:SF28', NULL, NULL, NULL, NULL, '', 253587),
(431848, 'PTHR31662:SF61', NULL, NULL, NULL, NULL, 'BNAANNG07420D PROTEIN', 253587),
(431849, 'PTHR31662:SF65', NULL, NULL, NULL, NULL, '', 253587),
(431850, 'PTHR31662:SF66', NULL, NULL, NULL, NULL, '', 253587),
(431851, 'PTHR31662:SF63', NULL, NULL, NULL, NULL, 'BRIX DOMAIN', 253587),
(431852, 'PTHR31662:SF64', NULL, NULL, NULL, NULL, 'BNAC07G47850D PROTEIN', 253587),
(431853, 'PTHR31662:SF58', NULL, NULL, NULL, NULL, 'BNAA03G60220D PROTEIN', 253587),
(431854, 'PTHR31662:SF13', NULL, NULL, NULL, NULL, 'OS09G0287600 PROTEIN', 253587);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(431855, 'PTHR31662:SF94', NULL, NULL, NULL, NULL, '', 253587),
(431856, 'PTHR31662:SF50', NULL, NULL, NULL, NULL, 'TYROSINE SPECIFIC PROTEIN PHOSPHATASE-LIKE', 253587),
(431857, 'PTHR31662:SF95', NULL, NULL, NULL, NULL, 'DNA-BINDING STOREKEEPER PROTEIN-RELATED TRANSCRIPTIONAL REGULATOR-RELATED', 253587),
(431858, 'PTHR31662:SF51', NULL, NULL, NULL, NULL, 'GLABROUS1 ENHANCER-BINDING PROTEIN-LIKE', 253587),
(431859, 'PTHR31662:SF92', NULL, NULL, NULL, NULL, 'TRANSPOSASE_23 DOMAIN-CONTAINING PROTEIN', 253587),
(431860, 'PTHR31662:SF93', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GEBP FAMILY-RELATED', 253587),
(431861, 'PTHR31662:SF98', NULL, NULL, NULL, NULL, 'STOREKEEPER PROTEIN-LIKE', 253587),
(431862, 'PTHR31662:SF10', NULL, NULL, NULL, NULL, 'OS02G0288200 PROTEIN', 253587),
(431863, 'PTHR31662:SF99', NULL, NULL, NULL, NULL, 'BNAC06G12070D PROTEIN', 253587),
(431864, 'PTHR31662:SF96', NULL, NULL, NULL, NULL, 'OS08G0467600 PROTEIN', 253587),
(431865, 'PTHR31662', NULL, NULL, NULL, NULL, 'BNAANNG10740D PROTEIN-RELATED', 253587),
(431866, 'PTHR31662:SF97', NULL, NULL, NULL, NULL, '', 253587),
(431867, 'PTHR31662:SF90', NULL, NULL, NULL, NULL, 'DNA-BINDING STOREKEEPER PROTEIN-RELATED TRANSCRIPTIONAL REGULATOR-RELATED', 253587),
(431868, 'PTHR31662:SF91', NULL, NULL, NULL, NULL, 'BNACNNG38830D PROTEIN', 253587),
(431869, 'PTHR31662:SF89', NULL, NULL, NULL, NULL, '(BREAD WHEAT) HYPOTHETICAL PROTEIN', 253587),
(431870, 'PTHR31662:SF45', NULL, NULL, NULL, NULL, 'OS02G0768700 PROTEIN', 253587),
(431871, 'PTHR31662:SF49', NULL, NULL, NULL, NULL, 'GLABROUS1 ENHANCER-BINDING PROTEIN-RELATED', 253587),
(431872, 'PTHR31662:SF83', NULL, NULL, NULL, NULL, 'GLABROUS1 ENHANCER-BINDING PROTEIN-LIKE', 253587),
(431873, 'PTHR31662:SF84', NULL, NULL, NULL, NULL, 'BNAUNNG00070D PROTEIN', 253587),
(431874, 'PTHR31662:SF81', NULL, NULL, NULL, NULL, 'DNA-BINDING STOREKEEPER PROTEIN-RELATED TRANSCRIPTIONAL REGULATOR-RELATED', 253587),
(431875, 'PTHR31662:SF43', NULL, NULL, NULL, NULL, 'BNAC08G08690D PROTEIN', 253587),
(431876, 'PTHR31662:SF41', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GEBP FAMILY-RELATED', 253587),
(431877, 'PTHR31662:SF42', NULL, NULL, NULL, NULL, 'TYROSINE SPECIFIC PROTEIN PHOSPHATASE-LIKE', 253587),
(431878, 'PTHR23500', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 2, FACILITATED GLUCOSE TRANSPORTER', 253588),
(431879, 'PTHR23500:SF429', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588),
(431880, 'PTHR23500:SF549', NULL, NULL, NULL, NULL, 'POLYOL TRANSPORTER 2-RELATED', 253588),
(431881, 'PTHR23500:SF428', NULL, NULL, NULL, NULL, 'POLYOL TRANSPORTER 6-RELATED', 253588),
(431882, 'PTHR23500:SF544', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588),
(431883, 'PTHR23500:SF545', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORT PROTEIN MST2', 253588),
(431884, 'PTHR23500:SF424', NULL, NULL, NULL, NULL, 'POLYOL TRANSPORTER 5', 253588),
(431885, 'PTHR23500:SF542', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588),
(431886, 'PTHR23500:SF421', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR, SUGAR TRANSPORTER, MAJOR FACILITATOR SUPERFAMILY-RELATED', 253588),
(431887, 'PTHR23500:SF541', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588),
(431888, 'PTHR23500:SF420', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588),
(431889, 'PTHR23500:SF2', NULL, NULL, NULL, NULL, 'OS04G0453400 PROTEIN', 253588),
(431890, 'PTHR23500:SF73', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORT PROTEIN MST1', 253588),
(431891, 'PTHR23500:SF559', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588),
(431892, 'PTHR23500:SF74', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORT PROTEIN MST5', 253588),
(431893, 'PTHR23500:SF557', NULL, NULL, NULL, NULL, 'POLYOL TRANSPORTER 5-LIKE', 253588),
(431894, 'PTHR23500:SF6', NULL, NULL, NULL, NULL, 'POLYOL TRANSPORTER 4-RELATED', 253588),
(431895, 'PTHR23500:SF437', NULL, NULL, NULL, NULL, '', 253588),
(431896, 'PTHR23500:SF5', NULL, NULL, NULL, NULL, 'OS12G0514000 PROTEIN', 253588),
(431897, 'PTHR23500:SF558', NULL, NULL, NULL, NULL, 'HEXOSE CARRIER PROTEIN HEX6-LIKE', 253588);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(431898, 'PTHR23500:SF555', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588),
(431899, 'PTHR23500:SF556', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORT PROTEIN MST6', 253588),
(431900, 'PTHR23500:SF432', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588),
(431901, 'PTHR23500:SF554', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORT PROTEIN 8-LIKE', 253588),
(431902, 'PTHR23500:SF430', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORT PROTEIN 9', 253588),
(431903, 'PTHR23500:SF155', NULL, NULL, NULL, NULL, 'OS04G0679050 PROTEIN', 253588),
(431904, 'PTHR23500:SF431', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORT PROTEIN 14-LIKE', 253588),
(431905, 'PTHR23500:SF552', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588),
(431906, 'PTHR23500:SF550', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588),
(431907, 'PTHR23500:SF152', NULL, NULL, NULL, NULL, 'POLYOL TRANSPORTER 1-RELATED', 253588),
(431908, 'PTHR23500:SF568', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588),
(431909, 'PTHR23500:SF601', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR, SUGAR TRANSPORTER-LIKE, MAJOR FACILITATOR SUPERFAMILY DOMAIN PROTEIN-RELATED', 253588),
(431910, 'PTHR23500:SF602', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER', 253588),
(431911, 'PTHR23500:SF569', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORT PROTEIN 4', 253588),
(431912, 'PTHR23500:SF445', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588),
(431913, 'PTHR23500:SF600', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588),
(431914, 'PTHR23500:SF567', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORT PROTEIN 12-LIKE', 253588),
(431915, 'PTHR23500:SF446', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588),
(431916, 'PTHR23500:SF564', NULL, NULL, NULL, NULL, 'CARRIER PROTEIN HEX6, PUTATIVE, EXPRESSED-RELATED', 253588),
(431917, 'PTHR23500:SF565', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER 14-RELATED', 253588),
(431918, 'PTHR23500:SF562', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588),
(431919, 'PTHR23500:SF563', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588),
(431920, 'PTHR23500:SF560', NULL, NULL, NULL, NULL, 'OS07G0582850 PROTEIN', 253588),
(431921, 'PTHR23500:SF561', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORT PROTEIN 5', 253588),
(431922, 'PTHR23500:SF440', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588),
(431923, 'PTHR23500:SF160', NULL, NULL, NULL, NULL, 'OS09G0297300 PROTEIN', 253588),
(431924, 'PTHR23500:SF14', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORT PROTEIN 14', 253588),
(431925, 'PTHR23500:SF17', NULL, NULL, NULL, NULL, 'OS11G0637200 PROTEIN', 253588),
(431926, 'PTHR23500:SF92', NULL, NULL, NULL, NULL, 'OS04G0452600 PROTEIN', 253588),
(431927, 'PTHR23500:SF579', NULL, NULL, NULL, NULL, 'HEXOSE CARRIER PROTEIN HEX6-LIKE', 253588),
(431928, 'PTHR23500:SF458', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588),
(431929, 'PTHR23500:SF10', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORT PROTEIN MST8', 253588),
(431930, 'PTHR23500:SF575', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588),
(431931, 'PTHR23500:SF455', NULL, NULL, NULL, NULL, 'POLYOL/MONOSACCHARIDE TRANSPORTER 1', 253588),
(431932, 'PTHR23500:SF334', NULL, NULL, NULL, NULL, 'CARRIER PROTEIN HEX6, PUTATIVE, EXPRESSED-RELATED', 253588),
(431933, 'PTHR23500:SF576', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588),
(431934, 'PTHR23500:SF573', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588),
(431935, 'PTHR23500:SF452', NULL, NULL, NULL, NULL, 'POLYOL TRANSPORTER 1-RELATED', 253588),
(431936, 'PTHR23500:SF178', NULL, NULL, NULL, NULL, 'OS02G0160400 PROTEIN', 253588),
(431937, 'PTHR23500:SF453', NULL, NULL, NULL, NULL, 'POLYOL TRANSPORTER 3-RELATED', 253588),
(431938, 'PTHR23500:SF574', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORT PROTEIN 1', 253588),
(431939, 'PTHR23500:SF450', NULL, NULL, NULL, NULL, 'POLYOL TRANSPORTER 1-RELATED', 253588),
(431940, 'PTHR23500:SF571', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(431941, 'PTHR23500:SF570', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588),
(431942, 'PTHR23500:SF506', NULL, NULL, NULL, NULL, 'POLYOL TRANSPORTER 6-RELATED', 253588),
(431943, 'PTHR23500:SF109', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORT PROTEIN 7', 253588),
(431944, 'PTHR23500:SF505', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR, SUGAR TRANSPORTER, MAJOR FACILITATOR SUPERFAMILY-RELATED', 253588),
(431945, 'PTHR23500:SF502', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588),
(431946, 'PTHR23500:SF469', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR, SUGAR TRANSPORTER, MAJOR FACILITATOR SUPERFAMILY-RELATED', 253588),
(431947, 'PTHR23500:SF588', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR, SUGAR TRANSPORTER, MAJOR FACILITATOR SUPERFAMILY-RELATED', 253588),
(431948, 'PTHR23500:SF105', NULL, NULL, NULL, NULL, 'OS02G0574100 PROTEIN', 253588),
(431949, 'PTHR23500:SF589', NULL, NULL, NULL, NULL, 'POLYOL TRANSPORTER 5-LIKE', 253588),
(431950, 'PTHR23500:SF463', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588),
(431951, 'PTHR23500:SF584', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORT PROTEIN 10', 253588),
(431952, 'PTHR23500:SF585', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588),
(431953, 'PTHR23500:SF582', NULL, NULL, NULL, NULL, 'POLYOL TRANSPORTER 1-RELATED', 253588),
(431954, 'PTHR23500:SF461', NULL, NULL, NULL, NULL, 'POLYOL/MONOSACCHARIDE TRANSPORTER 1', 253588),
(431955, 'PTHR23500:SF580', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR, SUGAR TRANSPORTER-LIKE, MAJOR FACILITATOR SUPERFAMILY DOMAIN PROTEIN-RELATED', 253588),
(431956, 'PTHR23500:SF460', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORT PROTEIN 11', 253588),
(431957, 'PTHR23500:SF38', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE, EXPRESSED-RELATED', 253588),
(431958, 'PTHR23500:SF519', NULL, NULL, NULL, NULL, 'POLYOL TRANSPORTER 1-RELATED', 253588),
(431959, 'PTHR23500:SF517', NULL, NULL, NULL, NULL, 'SUGAR CARRIER PROTEIN C-LIKE', 253588),
(431960, 'PTHR23500:SF30', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORT PROTEIN 3', 253588),
(431961, 'PTHR23500:SF33', NULL, NULL, NULL, NULL, 'OS04G0453200 PROTEIN', 253588),
(431962, 'PTHR23500:SF32', NULL, NULL, NULL, NULL, 'OS12G0512100 PROTEIN', 253588),
(431963, 'PTHR23500:SF511', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORT PROTEIN 2', 253588),
(431964, 'PTHR23500:SF357', NULL, NULL, NULL, NULL, 'IP12678P', 253588),
(431965, 'PTHR23500:SF599', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588),
(431966, 'PTHR23500:SF478', NULL, NULL, NULL, NULL, 'OS07G0131250 PROTEIN', 253588),
(431967, 'PTHR23500:SF597', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORT PROTEIN 12-LIKE', 253588),
(431968, 'PTHR23500:SF598', NULL, NULL, NULL, NULL, 'OS01G0966900 PROTEIN', 253588),
(431969, 'PTHR23500:SF477', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588),
(431970, 'PTHR23500:SF474', NULL, NULL, NULL, NULL, '', 253588),
(431971, 'PTHR23500:SF595', NULL, NULL, NULL, NULL, 'OS09G0416200 PROTEIN', 253588),
(431972, 'PTHR23500:SF596', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORT PROTEIN 12', 253588),
(431973, 'PTHR23500:SF472', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORT PROTEIN 6', 253588),
(431974, 'PTHR23500:SF593', NULL, NULL, NULL, NULL, 'HEXOSE CARRIER PROTEIN HEX6-LIKE', 253588),
(431975, 'PTHR23500:SF594', NULL, NULL, NULL, NULL, 'POLYOL/MONOSACCHARIDE TRANSPORTER 1', 253588),
(431976, 'PTHR23500:SF591', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR, SUGAR TRANSPORTER, MAJOR FACILITATOR SUPERFAMILY-RELATED', 253588),
(431977, 'PTHR23500:SF592', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588),
(431978, 'PTHR23500:SF590', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORT PROTEIN 8', 253588),
(431979, 'PTHR23500:SF44', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORT PROTEIN 5', 253588),
(431980, 'PTHR23500:SF525', NULL, NULL, NULL, NULL, 'HEXOSE CARRIER PROTEIN HEX6-LIKE', 253588),
(431981, 'PTHR23500:SF522', NULL, NULL, NULL, NULL, 'POLYOL TRANSPORTER 1-RELATED', 253588),
(431982, 'PTHR23500:SF126', NULL, NULL, NULL, NULL, 'OS02G0573500 PROTEIN', 253588);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(431983, 'PTHR23500:SF127', NULL, NULL, NULL, NULL, 'OS05G0169700 PROTEIN', 253588),
(431984, 'PTHR23500:SF487', NULL, NULL, NULL, NULL, 'POLYOL TRANSPORTER 1-RELATED', 253588),
(431985, 'PTHR23500:SF485', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588),
(431986, 'PTHR23500:SF537', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588),
(431987, 'PTHR23500:SF498', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR, SUGAR TRANSPORTER, MAJOR FACILITATOR SUPERFAMILY-RELATED', 253588),
(431988, 'PTHR23500:SF531', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR, SUGAR TRANSPORTER, MAJOR FACILITATOR SUPERFAMILY-RELATED', 253588),
(431989, 'PTHR23500:SF530', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253588),
(431990, 'PTHR23500:SF373', NULL, NULL, NULL, NULL, 'OS04G0679000 PROTEIN', 253588),
(431991, 'PTHR23500:SF371', NULL, NULL, NULL, NULL, 'OS07G0206600 PROTEIN', 253588),
(431992, 'PTHR23500:SF492', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORT PROTEIN 2-LIKE', 253588),
(431993, 'PTHR14932', NULL, NULL, NULL, NULL, 'RAS GTPASE-RELATED', 253589),
(431994, 'PTHR14932:SF1', NULL, NULL, NULL, NULL, 'RAB-LIKE PROTEIN 6', 253589),
(431995, 'PTHR14491:SF3', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN SOWAHB', 253590),
(431996, 'PTHR14491:SF2', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN SOWAHA', 253590),
(431997, 'PTHR14491:SF4', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN SOWAHC', 253590),
(431998, 'PTHR14491:SF7', NULL, NULL, NULL, NULL, 'SOSONDOWAH, ISOFORM G', 253590),
(431999, 'PTHR14491', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 253590),
(432000, 'PTHR14491:SF9', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 253590),
(432001, 'PTHR14491:SF8', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN SOWAHD', 253590),
(432002, 'PTHR21621:SF1', NULL, NULL, NULL, NULL, 'N-ACETYLASPARTYLGLUTAMATE SYNTHASE A', 253591),
(432003, 'PTHR21621:SF2', NULL, NULL, NULL, NULL, 'COENZYME GAMMA-F420-2:ALPHA-L-GLUTAMATE LIGASE', 253591),
(432004, 'PTHR21621:SF4', NULL, NULL, NULL, NULL, 'GLUTATHIONE SYNTHETASE', 253591),
(432005, 'PTHR21621', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S6 MODIFICATION PROTEIN', 253591),
(432006, 'PTHR21621:SF0', NULL, NULL, NULL, NULL, 'BETA-CITRYLGLUTAMATE SYNTHASE B', 253591),
(432007, 'PTHR21621:SF5', NULL, NULL, NULL, NULL, 'BETA-CITRYLGLUTAMATE SYNTHASE B', 253591),
(432008, 'PTHR21621:SF7', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S6--L-GLUTAMATE LIGASE', 253591),
(432009, 'PTHR48095', NULL, NULL, NULL, NULL, 'PYRUVATE CARBOXYLASE SUBUNIT A', 253592),
(432010, 'PTHR48095:SF5', NULL, NULL, NULL, NULL, 'BLL7292 PROTEIN', 253592),
(432011, 'PTHR48095:SF4', NULL, NULL, NULL, NULL, 'BIOTIN CARBOXYL CARRIER PROTEIN OF ACETYL-COA CARBOXYLASE', 253592),
(432012, 'PTHR48095:SF1', NULL, NULL, NULL, NULL, 'BIOTIN CARBOXYLASE', 253592),
(432013, 'PTHR48095:SF2', NULL, NULL, NULL, NULL, 'BIOTIN CARBOXYLASE, CHLOROPLASTIC', 253592),
(432014, 'PTHR37183', NULL, NULL, NULL, NULL, 'PLANT THIONIN FAMILY PROTEIN', 253593),
(432015, 'PTHR37183:SF3', NULL, NULL, NULL, NULL, 'BNAA09G28400D PROTEIN', 253593),
(432016, 'PTHR37183:SF1', NULL, NULL, NULL, NULL, 'PLANT THIONIN FAMILY PROTEIN', 253593),
(432017, 'PTHR37183:SF2', NULL, NULL, NULL, NULL, '', 253593),
(432018, 'PTHR36464', NULL, NULL, NULL, NULL, 'PROTEIN BEAN1', 253594),
(432019, 'PTHR36464:SF1', NULL, NULL, NULL, NULL, 'PROTEIN BEAN1', 253594),
(432020, 'PTHR13962:SF19', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN N2', 253595),
(432021, 'PTHR13962:SF32', NULL, NULL, NULL, NULL, 'CHECKPOINT SUPPRESSOR 1', 253595),
(432022, 'PTHR13962:SF20', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN N3', 253595),
(432023, 'PTHR13962:SF24', NULL, NULL, NULL, NULL, 'FORK-HEAD DOMAIN-CONTAINING PROTEIN', 253595),
(432024, 'PTHR13962', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN N3-LIKE PROTEIN-RELATED', 253595),
(432025, 'PTHR13962:SF22', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN N3-LIKE PROTEIN', 253595),
(432026, 'PTHR13962:SF17', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN N4', 253595);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(432027, 'PTHR13962:SF26', NULL, NULL, NULL, NULL, 'SI:CH211-145O7.3', 253595),
(432028, 'PTHR36359:SF1', NULL, NULL, NULL, NULL, 'PROTEIN RESISTANCE TO PHYTOPHTHORA 1, CHLOROPLASTIC', 253596),
(432029, 'PTHR36359', NULL, NULL, NULL, NULL, 'PROTEIN RESISTANCE TO PHYTOPHTHORA 1, CHLOROPLASTIC', 253596),
(432030, 'PTHR30389', NULL, NULL, NULL, NULL, 'FUMARATE HYDRATASE-RELATED', 253597),
(432031, 'PTHR30389:SF0', NULL, NULL, NULL, NULL, 'FUMARATE HYDRATASE CLASS I, AEROBIC', 253597),
(432032, 'PTHR30389:SF16', NULL, NULL, NULL, NULL, 'FUMARATE HYDRATASE 2', 253597),
(432033, 'PTHR30389:SF17', NULL, NULL, NULL, NULL, 'L(+)-TARTRATE DEHYDRATASE SUBUNIT ALPHA-RELATED', 253597),
(432034, 'PTHR30389:SF18', NULL, NULL, NULL, NULL, 'FUMARATE HYDRATASE CLASS I, ANAEROBIC', 253597),
(432035, 'PTHR30389:SF19', NULL, NULL, NULL, NULL, 'L(+)-TARTRATE DEHYDRATASE SUBUNIT ALPHA', 253597),
(432036, 'PTHR31262:SF17', NULL, NULL, NULL, NULL, 'RIBULOSE BISPHOSPHATE CARBOXYLASE SMALL SUBUNIT', 253598),
(432037, 'PTHR31262:SF16', NULL, NULL, NULL, NULL, 'RIBULOSE BISPHOSPHATE CARBOXYLASE SMALL SUBUNIT', 253598),
(432038, 'PTHR31262:SF19', NULL, NULL, NULL, NULL, 'RIBULOSE BISPHOSPHATE CARBOXYLASE SMALL SUBUNIT, CHLOROPLASTIC 2', 253598),
(432039, 'PTHR31262:SF18', NULL, NULL, NULL, NULL, 'RIBULOSE BISPHOSPHATE CARBOXYLASE SMALL SUBUNIT', 253598),
(432040, 'PTHR31262:SF0', NULL, NULL, NULL, NULL, 'RIBULOSE BISPHOSPHATE CARBOXYLASE SMALL SUBUNIT, CHLOROPLASTIC 1', 253598),
(432041, 'PTHR31262:SF24', NULL, NULL, NULL, NULL, 'RIBULOSE BISPHOSPHATE CARBOXYLASE SMALL SUBUNIT', 253598),
(432042, 'PTHR31262:SF23', NULL, NULL, NULL, NULL, 'RIBULOSE BISPHOSPHATE CARBOXYLASE SMALL SUBUNIT', 253598),
(432043, 'PTHR31262:SF15', NULL, NULL, NULL, NULL, 'RIBULOSE BISPHOSPHATE CARBOXYLASE SMALL SUBUNIT 1A, CHLOROPLASTIC', 253598),
(432044, 'PTHR31262:SF26', NULL, NULL, NULL, NULL, 'RIBULOSE BISPHOSPHATE CARBOXYLASE SMALL SUBUNIT', 253598),
(432045, 'PTHR31262:SF25', NULL, NULL, NULL, NULL, 'RIBULOSE BISPHOSPHATE CARBOXYLASE SMALL SUBUNIT', 253598),
(432046, 'PTHR31262:SF14', NULL, NULL, NULL, NULL, 'RIBULOSE BISPHOSPHATE CARBOXYLASE SMALL SUBUNIT, CHLOROPLASTIC 1', 253598),
(432047, 'PTHR31262', NULL, NULL, NULL, NULL, 'RIBULOSE BISPHOSPHATE CARBOXYLASE SMALL CHAIN 1, CHLOROPLASTIC', 253598),
(432048, 'PTHR31262:SF10', NULL, NULL, NULL, NULL, 'RIBULOSE BISPHOSPHATE CARBOXYLASE SMALL SUBUNIT 1B, CHLOROPLASTIC-RELATED', 253598),
(432049, 'PTHR32026:SF9', NULL, NULL, NULL, NULL, 'METHYLTRANFER_DOM DOMAIN-CONTAINING PROTEIN', 253599),
(432050, 'PTHR32026:SF6', NULL, NULL, NULL, NULL, 'METHYLTRANSF_21 DOMAIN-CONTAINING PROTEIN', 253599),
(432051, 'PTHR32026:SF10', NULL, NULL, NULL, NULL, 'METHYLTRANFER_DOM DOMAIN-CONTAINING PROTEIN-RELATED', 253599),
(432052, 'PTHR32026:SF20', NULL, NULL, NULL, NULL, 'METHYLTRANFER_DOM DOMAIN-CONTAINING PROTEIN', 253599),
(432053, 'PTHR32026:SF23', NULL, NULL, NULL, NULL, 'METHYLTRANFER_DOM DOMAIN-CONTAINING PROTEIN', 253599),
(432054, 'PTHR32026:SF27', NULL, NULL, NULL, NULL, 'METHYLTRANFER_DOM DOMAIN-CONTAINING PROTEIN', 253599),
(432055, 'PTHR32026:SF5', NULL, NULL, NULL, NULL, 'METHYLTRANSF_21 DOMAIN-CONTAINING PROTEIN', 253599),
(432056, 'PTHR32026:SF28', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE-LIKE PROTEIN 24', 253599),
(432057, 'PTHR32026', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE-LIKE PROTEIN 24', 253599),
(432058, 'PTHR35580', NULL, NULL, NULL, NULL, 'CELL SURFACE GLYCOPROTEIN (S-LAYER PROTEIN)-LIKE PROTEIN', 253600),
(432059, 'PTHR35580:SF1', NULL, NULL, NULL, NULL, 'CELL SURFACE GLYCOPROTEIN (S-LAYER PROTEIN)-LIKE PROTEIN', 253600),
(432060, 'PTHR38782', NULL, NULL, NULL, NULL, '', 253601),
(432061, 'PTHR38782:SF1', NULL, NULL, NULL, NULL, 'SIGMA-E FACTOR REGULATORY PROTEIN RSEB', 253601),
(432062, 'PTHR42210:SF1', NULL, NULL, NULL, NULL, 'DNA POLYMERASE II LARGE SUBUNIT', 253602),
(432063, 'PTHR42210', NULL, NULL, NULL, NULL, 'DNA POLYMERASE II LARGE SUBUNIT', 253602),
(432064, 'PTHR24027:SF96', NULL, NULL, NULL, NULL, 'CADHERIN-12', 253603),
(432065, 'PTHR24027:SF91', NULL, NULL, NULL, NULL, 'CADHERIN-7', 253603);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(432066, 'PTHR24027:SF419', NULL, NULL, NULL, NULL, 'CADHERIN-17', 253603),
(432067, 'PTHR24027:SF319', NULL, NULL, NULL, NULL, 'CADHERIN-3', 253603),
(432068, 'PTHR24027:SF79', NULL, NULL, NULL, NULL, 'CADHERIN-2', 253603),
(432069, 'PTHR24027:SF439', NULL, NULL, NULL, NULL, 'CADHERIN-RELATED FAMILY MEMBER 3', 253603),
(432070, 'PTHR24027:SF99', NULL, NULL, NULL, NULL, 'CADHERIN-9', 253603),
(432071, 'PTHR24027:SF438', NULL, NULL, NULL, NULL, 'CADHERIN-RELATED 23', 253603),
(432072, 'PTHR24027:SF416', NULL, NULL, NULL, NULL, 'CADHERIN EGF LAG SEVEN-PASS G-TYPE RECEPTOR 2', 253603),
(432073, 'PTHR24027:SF78', NULL, NULL, NULL, NULL, 'CADHERIN-LIKE PROTEIN 26', 253603),
(432074, 'PTHR24027:SF414', NULL, NULL, NULL, NULL, 'CADHERIN-RELATED FAMILY MEMBER 5B', 253603),
(432075, 'PTHR24027:SF435', NULL, NULL, NULL, NULL, 'CADHERIN-1', 253603),
(432076, 'PTHR24027:SF413', NULL, NULL, NULL, NULL, 'CADHERIN-RELATED FAMILY MEMBER 1', 253603),
(432077, 'PTHR24027:SF433', NULL, NULL, NULL, NULL, 'CADHERIN 27', 253603),
(432078, 'PTHR24027:SF411', NULL, NULL, NULL, NULL, 'CADHERIN RELATED FAMILY MEMBER 2', 253603),
(432079, 'PTHR24027:SF311', NULL, NULL, NULL, NULL, 'CADHERIN-22', 253603),
(432080, 'PTHR24027:SF432', NULL, NULL, NULL, NULL, 'NEURAL-CADHERIN-LIKE', 253603),
(432081, 'PTHR24027:SF431', NULL, NULL, NULL, NULL, 'CADHERIN DOMAIN-CONTAINING PROTEIN', 253603),
(432082, 'PTHR24027:SF273', NULL, NULL, NULL, NULL, 'CADHERIN-8', 253603),
(432083, 'PTHR24027:SF272', NULL, NULL, NULL, NULL, 'CADHERIN-24', 253603),
(432084, 'PTHR24027:SF290', NULL, NULL, NULL, NULL, 'CADHERIN-10', 253603),
(432085, 'PTHR24027:SF84', NULL, NULL, NULL, NULL, 'CADHERIN-20', 253603),
(432086, 'PTHR24027:SF85', NULL, NULL, NULL, NULL, 'CADHERIN-11', 253603),
(432087, 'PTHR24027:SF80', NULL, NULL, NULL, NULL, 'CADHERIN-13', 253603),
(432088, 'PTHR24027:SF81', NULL, NULL, NULL, NULL, 'CADHERIN-4', 253603),
(432089, 'PTHR24027', NULL, NULL, NULL, NULL, 'CADHERIN-23', 253603),
(432090, 'PTHR24027:SF428', NULL, NULL, NULL, NULL, 'CADHERIN 6', 253603),
(432091, 'PTHR24027:SF89', NULL, NULL, NULL, NULL, 'CADHERIN-5', 253603),
(432092, 'PTHR24027:SF106', NULL, NULL, NULL, NULL, 'CADHERIN-18', 253603),
(432093, 'PTHR24027:SF425', NULL, NULL, NULL, NULL, 'CADHERIN-23', 253603),
(432094, 'PTHR24027:SF424', NULL, NULL, NULL, NULL, 'CADHERIN 16, KSP-CADHERIN', 253603),
(432095, 'PTHR24027:SF423', NULL, NULL, NULL, NULL, 'PROTOCADHERIN-16', 253603),
(432096, 'PTHR24027:SF323', NULL, NULL, NULL, NULL, 'CADHERIN-19', 253603),
(432097, 'PTHR24027:SF422', NULL, NULL, NULL, NULL, 'CADHERIN DOMAIN-CONTAINING PROTEIN', 253603),
(432098, 'PTHR24027:SF300', NULL, NULL, NULL, NULL, 'CADHERIN-15', 253603),
(432099, 'PTHR24027:SF322', NULL, NULL, NULL, NULL, 'CADHERIN-6', 253603),
(432100, 'PTHR24027:SF421', NULL, NULL, NULL, NULL, '', 253603),
(432101, 'PTHR24027:SF441', NULL, NULL, NULL, NULL, '', 253603),
(432102, 'PTHR24027:SF440', NULL, NULL, NULL, NULL, 'DESMOCOLLIN-1', 253603),
(432103, 'PTHR37860', NULL, NULL, NULL, NULL, 'AGAP008810-PA', 253604),
(432104, 'PTHR37860:SF1', NULL, NULL, NULL, NULL, '', 253604),
(432105, 'PTHR34229', NULL, NULL, NULL, NULL, 'METAL TRANSPORT PROTEIN HI_1621-RELATED', 253605),
(432106, 'PTHR34229:SF1', NULL, NULL, NULL, NULL, 'METAL TRANSPORT PROTEIN HI_1621-RELATED', 253605),
(432107, 'PTHR33910', NULL, NULL, NULL, NULL, 'PROTEIN TRANSLOCASE SUBUNIT SECE', 253606),
(432108, 'PTHR33910:SF1', NULL, NULL, NULL, NULL, 'PROTEIN TRANSLOCASE SUBUNIT SECE', 253606),
(432109, 'PTHR47136', NULL, NULL, NULL, NULL, 'SYNEMIN', 253607),
(432110, 'PTHR47136:SF1', NULL, NULL, NULL, NULL, 'SYNEMIN', 253607),
(432111, 'PTHR14508', NULL, NULL, NULL, NULL, 'SNRPN UPSTREAM READING FRAME PROTEIN, SNURF', 253608),
(432112, 'PTHR14508:SF2', NULL, NULL, NULL, NULL, 'SNRPN UPSTREAM READING FRAME PROTEIN-RELATED', 253608),
(432113, 'PTHR13539', NULL, NULL, NULL, NULL, 'CALMODULIN-LYSINE N-METHYLTRANSFERASE', 253609),
(432114, 'PTHR13539:SF3', NULL, NULL, NULL, NULL, 'CALMODULIN-LYSINE N-METHYLTRANSFERASE', 253609),
(432115, 'PTHR34283:SF3', NULL, NULL, NULL, NULL, 'PROTEIN RESPONSE TO LOW SULFUR 3', 253610);
INSERT INTO "PUBLIC"."MODEL" VALUES
(432116, 'PTHR34283:SF6', NULL, NULL, NULL, NULL, 'UP-9A', 253610),
(432117, 'PTHR34283:SF5', NULL, NULL, NULL, NULL, 'PROTEIN RESPONSE TO LOW SULFUR 2-RELATED', 253610),
(432118, 'PTHR34283', NULL, NULL, NULL, NULL, 'PROTEIN RESPONSE TO LOW SULFUR 1', 253610),
(432119, 'PTHR34283:SF1', NULL, NULL, NULL, NULL, 'PROTEIN RESPONSE TO LOW SULFUR 1', 253610),
(432120, 'PTHR34283:SF8', NULL, NULL, NULL, NULL, 'UP-9A', 253610),
(432121, 'PTHR34283:SF7', NULL, NULL, NULL, NULL, 'UP-9A', 253610),
(432122, 'PTHR34283:SF9', NULL, NULL, NULL, NULL, 'OS10G0509401 PROTEIN', 253610),
(432123, 'PTHR47243', NULL, NULL, NULL, NULL, 'SIALOADHESIN', 253611),
(432124, 'PTHR47243:SF1', NULL, NULL, NULL, NULL, 'SIALOADHESIN', 253611),
(432125, 'PTHR22734', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RIBONUCLEOPROTEIN PROTEIN IMP4', 253612),
(432126, 'PTHR22734:SF3', NULL, NULL, NULL, NULL, 'RIBOSOME PRODUCTION FACTOR 1', 253612),
(432127, 'PTHR22734:SF2', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RIBONUCLEOPROTEIN PROTEIN IMP4', 253612),
(432128, 'PTHR10805:SF0', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT EPSILON', 253613),
(432129, 'PTHR10805:SF3', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT EPSILON-1', 253613),
(432130, 'PTHR10805:SF4', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT EPSILON', 253613),
(432131, 'PTHR10805:SF2', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT EPSILON-2', 253613),
(432132, 'PTHR10805:SF5', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT EPSILON', 253613),
(432133, 'PTHR10805', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT EPSILON', 253613),
(432134, 'PTHR43880:SF29', NULL, NULL, NULL, NULL, '', 253614),
(432135, 'PTHR43880:SF28', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE-LIKE 1-RELATED', 253614),
(432136, 'PTHR43880:SF1', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE 1A', 253614),
(432137, 'PTHR43880:SF5', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE-LIKE 6', 253614),
(432138, 'PTHR43880:SF4', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE CLASS-3', 253614),
(432139, 'PTHR43880:SF3', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE 8A-RELATED', 253614),
(432140, 'PTHR43880:SF2', NULL, NULL, NULL, NULL, 'ALL-TRANS-RETINOL DEHYDROGENASE [NAD(+)] ADH7', 253614),
(432141, 'PTHR43880:SF9', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE-LIKE', 253614),
(432142, 'PTHR43880:SF8', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 253614),
(432143, 'PTHR43880:SF7', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE-LIKE 7', 253614),
(432144, 'PTHR43880:SF6', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE 6A (CLASS V)', 253614),
(432145, 'PTHR43880:SF61', NULL, NULL, NULL, NULL, 'OS03G0189400 PROTEIN', 253614),
(432146, 'PTHR43880:SF60', NULL, NULL, NULL, NULL, 'ADH_N DOMAIN-CONTAINING PROTEIN', 253614),
(432147, 'PTHR43880:SF41', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE A', 253614),
(432148, 'PTHR43880:SF40', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE 1', 253614),
(432149, 'PTHR43880:SF21', NULL, NULL, NULL, NULL, 'S-(HYDROXYMETHYL)GLUTATHIONE DEHYDROGENASE', 253614),
(432150, 'PTHR43880:SF42', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE-LIKE 3', 253614),
(432151, 'PTHR43880:SF20', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE 6', 253614),
(432152, 'PTHR43880:SF45', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE-LIKE', 253614),
(432153, 'PTHR43880:SF44', NULL, NULL, NULL, NULL, 'OS03G0189600 PROTEIN', 253614),
(432154, 'PTHR43880:SF47', NULL, NULL, NULL, NULL, 'S-(HYDROXYMETHYL)GLUTATHIONE DEHYDROGENASE', 253614),
(432155, 'PTHR43880:SF49', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE SUPERFAMILY, ZINC-TYPE, GROES-LIKE, NAD(P)-BINDING DOMAIN PROTEIN-RELATED', 253614),
(432156, 'PTHR43880:SF48', NULL, NULL, NULL, NULL, 'PKS_ER DOMAIN-CONTAINING PROTEIN', 253614),
(432157, 'PTHR43880:SF26', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE CLASS-P', 253614),
(432158, 'PTHR43880:SF39', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE-LIKE 3', 253614),
(432159, 'PTHR43880', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE', 253614),
(432160, 'PTHR43880:SF51', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE 6B (CLASS V)', 253614);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(432161, 'PTHR43880:SF10', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE-LIKE 2', 253614),
(432162, 'PTHR43880:SF32', NULL, NULL, NULL, NULL, 'ZGC:63568-RELATED', 253614),
(432163, 'PTHR43880:SF53', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE 1', 253614),
(432164, 'PTHR43880:SF31', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE-LIKE 7', 253614),
(432165, 'PTHR43880:SF12', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE CLASS-3', 253614),
(432166, 'PTHR43880:SF34', NULL, NULL, NULL, NULL, 'S-(HYDROXYMETHYL)GLUTATHIONE DEHYDROGENASE', 253614),
(432167, 'PTHR43880:SF56', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE-LIKE 4', 253614),
(432168, 'PTHR43880:SF11', NULL, NULL, NULL, NULL, 'ALL-TRANS-RETINOL DEHYDROGENASE [NAD(+)] ADH1B', 253614),
(432169, 'PTHR43880:SF55', NULL, NULL, NULL, NULL, 'ZINC-BINDING ALCOHOL DEHYDROGENASE FAMILY PROTEIN', 253614),
(432170, 'PTHR43880:SF58', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE CLASS-3', 253614),
(432171, 'PTHR43880:SF36', NULL, NULL, NULL, NULL, 'ADH_N DOMAIN-CONTAINING PROTEIN', 253614),
(432172, 'PTHR43880:SF14', NULL, NULL, NULL, NULL, 'ALL-TRANS-RETINOL DEHYDROGENASE [NAD(+)] ADH4', 253614),
(432173, 'PTHR43880:SF57', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE 1C', 253614),
(432174, 'PTHR43880:SF35', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE 1-LIKE', 253614),
(432175, 'PTHR43880:SF38', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE-RELATED', 253614),
(432176, 'PTHR43880:SF37', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE ADH3D', 253614),
(432177, 'PTHR43880:SF59', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE 2', 253614),
(432178, 'PTHR14432:SF2', NULL, NULL, NULL, NULL, 'TANK-BINDING KINASE 1-BINDING PROTEIN 1', 253615),
(432179, 'PTHR14432:SF6', NULL, NULL, NULL, NULL, '5-AZACYTIDINE-INDUCED PROTEIN 2', 253615),
(432180, 'PTHR14432', NULL, NULL, NULL, NULL, 'PROSAPIP2 PROTEIN/5-AZACYTIDINE INDUCED GENE 2', 253615),
(432181, 'PTHR28066', NULL, NULL, NULL, NULL, '37S RIBOSOMAL PROTEIN MRP10, MITOCHONDRIAL', 253616),
(432182, 'PTHR28066:SF2', NULL, NULL, NULL, NULL, 'CX9C DOMAIN-CONTAINING PROTEIN', 253616),
(432183, 'PTHR28066:SF1', NULL, NULL, NULL, NULL, '37S RIBOSOMAL PROTEIN MRP10, MITOCHONDRIAL', 253616),
(432184, 'PTHR34983:SF1', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN ENDO-BETA-1,4-GALACTANASE A', 253617),
(432185, 'PTHR34983:SF2', NULL, NULL, NULL, NULL, 'ENDO-BETA-1,4-GALACTANASE', 253617),
(432186, 'PTHR34983', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN ENDO-BETA-1,4-GALACTANASE A', 253617),
(432187, 'PTHR17554:SF3', NULL, NULL, NULL, NULL, 'DNAX-ACTIVATION PROTEIN 12', 253618),
(432188, 'PTHR17554:SF2', NULL, NULL, NULL, NULL, 'TYRO PROTEIN TYROSINE KINASE-BINDING PROTEIN', 253618),
(432189, 'PTHR17554', NULL, NULL, NULL, NULL, 'TYRO PROTEIN TYROSINE KINASE-BINDING PROTEIN', 253618),
(432190, 'PTHR33862', NULL, NULL, NULL, NULL, 'OROFACIAL CLEFT 1 CANDIDATE GENE 1 PROTEIN', 253619),
(432191, 'PTHR33862:SF3', NULL, NULL, NULL, NULL, '', 253619),
(432192, 'PTHR36881:SF1', NULL, NULL, NULL, NULL, 'DERMOKINE', 253620),
(432193, 'PTHR36881', NULL, NULL, NULL, NULL, 'DERMOKINE', 253620),
(432194, 'PTHR23537', NULL, NULL, NULL, NULL, '', 253621),
(432195, 'PTHR23537:SF1', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER-RELATED', 253621),
(432196, 'PTHR31507:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CBG24542', 253622),
(432197, 'PTHR31507:SF11', NULL, NULL, NULL, NULL, 'PROTEIN CBG00663', 253622),
(432198, 'PTHR31507:SF10', NULL, NULL, NULL, NULL, 'PROTEIN CBG15923', 253622),
(432199, 'PTHR31507', NULL, NULL, NULL, NULL, 'PROTEIN CBG15923', 253622),
(432200, 'PTHR31507:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG19881', 253622),
(432201, 'PTHR22596:SF14', NULL, NULL, NULL, NULL, 'PROTEIN CBG13641', 253623),
(432202, 'PTHR22596:SF16', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 253623),
(432203, 'PTHR22596:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG12691', 253623),
(432204, 'PTHR22596:SF19', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 253623),
(432205, 'PTHR22596:SF3', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 253623);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(432206, 'PTHR22596:SF4', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 253623),
(432207, 'PTHR22596:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG21834', 253623),
(432208, 'PTHR22596:SF7', NULL, NULL, NULL, NULL, 'PEPTIDASE S1 DOMAIN-CONTAINING PROTEIN', 253623),
(432209, 'PTHR22596', NULL, NULL, NULL, NULL, 'TRYPSIN-LIKE PROTEASE PROTEIN 6', 253623),
(432210, 'PTHR13142:SF1', NULL, NULL, NULL, NULL, 'INNER CENTROMERE PROTEIN', 253624),
(432211, 'PTHR13142', NULL, NULL, NULL, NULL, 'INNER CENTROMERE PROTEIN', 253624),
(432212, 'PTHR43582:SF4', NULL, NULL, NULL, NULL, 'ANTIBIOTIC RESISTANCE ABC TRANSPORTER ATP-BINDING PROTEIN', 253625),
(432213, 'PTHR43582:SF2', NULL, NULL, NULL, NULL, 'LINEARMYCIN RESISTANCE ATP-BINDING PROTEIN LNRL', 253625),
(432214, 'PTHR43582', NULL, NULL, NULL, NULL, 'LINEARMYCIN RESISTANCE ATP-BINDING PROTEIN LNRL', 253625),
(432215, 'PTHR46771:SF7', NULL, NULL, NULL, NULL, 'BACULOVIRAL IAP REPEAT-CONTAINING PROTEIN BIR-2', 253626),
(432216, 'PTHR46771:SF5', NULL, NULL, NULL, NULL, 'DETERIN', 253626),
(432217, 'PTHR46771', NULL, NULL, NULL, NULL, 'DETERIN', 253626),
(432218, 'PTHR46771:SF2', NULL, NULL, NULL, NULL, 'BACULOVIRAL IAP REPEAT-CONTAINING PROTEIN 5-LIKE', 253626),
(432219, 'PTHR46771:SF3', NULL, NULL, NULL, NULL, 'BACULOVIRAL IAP REPEAT-CONTAINING PROTEIN 5', 253626),
(432220, 'PTHR46922', NULL, NULL, NULL, NULL, 'DHHA1 DOMAIN PROTEIN', 253627),
(432221, 'PTHR46922:SF3', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN', 253627),
(432222, 'PTHR46922:SF4', NULL, NULL, NULL, NULL, 'DHHA1 DOMAIN PROTEIN', 253627),
(432223, 'PTHR11534:SF5', NULL, NULL, NULL, NULL, 'MYOGENIN', 253628),
(432224, 'PTHR11534', NULL, NULL, NULL, NULL, 'MYOGENIC FACTOR', 253628),
(432225, 'PTHR11534:SF9', NULL, NULL, NULL, NULL, 'MYOGENIC-DETERMINATION PROTEIN', 253628),
(432226, 'PTHR11534:SF2', NULL, NULL, NULL, NULL, 'MYOBLAST DETERMINATION PROTEIN 1', 253628),
(432227, 'PTHR11534:SF4', NULL, NULL, NULL, NULL, 'MYOGENIC FACTOR 6', 253628),
(432228, 'PTHR11534:SF3', NULL, NULL, NULL, NULL, 'MYOGENIC FACTOR 5', 253628),
(432229, 'PTHR37015:SF1', NULL, NULL, NULL, NULL, '', 253629),
(432230, 'PTHR37015:SF2', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 253629),
(432231, 'PTHR37015', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', 253629),
(432232, 'PTHR47356:SF3', NULL, NULL, NULL, NULL, 'FAD-DEPENDENT MONOOXYGENASE SRDH', 253630),
(432233, 'PTHR47356:SF2', NULL, NULL, NULL, NULL, 'FAD-DEPENDENT MONOOXYGENASE ASQG-RELATED', 253630),
(432234, 'PTHR47356', NULL, NULL, NULL, NULL, 'FAD-DEPENDENT MONOOXYGENASE ASQG-RELATED', 253630),
(432235, 'PTHR39081', NULL, NULL, NULL, NULL, 'MUT7-C DOMAIN-CONTAINING PROTEIN', 253631),
(432236, 'PTHR39081:SF1', NULL, NULL, NULL, NULL, 'MUT7-C DOMAIN-CONTAINING PROTEIN', 253631),
(432237, 'PTHR14269:SF60', NULL, NULL, NULL, NULL, 'CARDIOLIPIN SYNTHASE (CMP-FORMING)', 253632),
(432238, 'PTHR14269:SF40', NULL, NULL, NULL, NULL, 'CDP-DIACYLGLYCEROL--GLYCEROL-3-PHOSPHATE 3-PHOSPHATIDYLTRANSFERASE 2', 253632),
(432239, 'PTHR14269:SF62', NULL, NULL, NULL, NULL, 'CDP-DIACYLGLYCEROL--GLYCEROL-3-PHOSPHATE 3-PHOSPHATIDYLTRANSFERASE 1, CHLOROPLASTIC', 253632),
(432240, 'PTHR14269:SF51', NULL, NULL, NULL, NULL, 'HYPOTHETICAL HAD-SUPERFAMILY HYDROLASE (EUROFUNG)', 253632),
(432241, 'PTHR14269:SF61', NULL, NULL, NULL, NULL, 'CDP-DIACYLGLYCEROL--SERINE O-PHOSPHATIDYLTRANSFERASE', 253632),
(432242, 'PTHR14269:SF42', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLGLYCEROLPHOSPHATE SYNTHASE', 253632),
(432243, 'PTHR14269:SF52', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLGLYCEROPHOSPHATE SYNTHASE-RELATED', 253632),
(432244, 'PTHR14269:SF44', NULL, NULL, NULL, NULL, 'BNAA09G54840D PROTEIN', 253632),
(432245, 'PTHR14269:SF11', NULL, NULL, NULL, NULL, 'CDP-DIACYLGLYCEROL--GLYCEROL-3-PHOSPHATE 3-PHOSPHATIDYLTRANSFERASE', 253632),
(432246, 'PTHR14269:SF55', NULL, NULL, NULL, NULL, 'CDP-ALCOHOL PHOSPHATIDYLTRANSFERASE-RELATED', 253632),
(432247, 'PTHR14269:SF43', NULL, NULL, NULL, NULL, 'ZGC:77375', 253632),
(432248, 'PTHR14269:SF57', NULL, NULL, NULL, NULL, 'SUPERFAMILY HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G02580)-RELATED', 253632);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(432249, 'PTHR14269:SF59', NULL, NULL, NULL, NULL, 'CDP-DIACYLGLYCEROL--SERINE O-PHOSPHATIDYLTRANSFERASE', 253632),
(432250, 'PTHR14269:SF4', NULL, NULL, NULL, NULL, 'HYDROLASE FAMILY PROTEIN / HAD-SUPERFAMILY PROTEIN', 253632),
(432251, 'PTHR14269:SF58', NULL, NULL, NULL, NULL, 'CDP-DIACYLGLYCEROL--GLYCEROL-3-PHOSPHATE 3-PHOSPHATIDYLTRANSFERASE 2-LIKE', 253632),
(432252, 'PTHR14269:SF17', NULL, NULL, NULL, NULL, 'HALOACID DEHALOGENASE-LIKE HYDROLASE DOMAIN-CONTAINING 5', 253632),
(432253, 'PTHR14269:SF49', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 253632),
(432254, 'PTHR14269', NULL, NULL, NULL, NULL, 'CDP-DIACYLGLYCEROL--GLYCEROL-3-PHOSPHATE 3-PHOSPHATIDYLTRANSFERASE-RELATED', 253632),
(432255, 'PTHR17469:SF1', NULL, NULL, NULL, NULL, 'PROTEIN TESPA1', 253633),
(432256, 'PTHR17469:SF11', NULL, NULL, NULL, NULL, 'PROTEIN ITPRID2', 253633),
(432257, 'PTHR17469', NULL, NULL, NULL, NULL, 'SPERM SPECIFIC ANTIGEN 2-RELATED', 253633),
(432258, 'PTHR17469:SF14', NULL, NULL, NULL, NULL, 'PROTEIN ITPRID1', 253633),
(432259, 'PTHR17469:SF15', NULL, NULL, NULL, NULL, 'KRAP_IP3R_BIND DOMAIN-CONTAINING PROTEIN', 253633),
(432260, 'PTHR40704', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR SPT4', 253634),
(432261, 'PTHR40704:SF1', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR SPT4', 253634),
(432262, 'PTHR14759:SF31', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN 6B', 253635),
(432263, 'PTHR14759:SF33', NULL, NULL, NULL, NULL, 'PROTEIN CBG28115', 253635),
(432264, 'PTHR14759', NULL, NULL, NULL, NULL, 'STOP PROTEIN', 253635),
(432265, 'PTHR14759:SF35', NULL, NULL, NULL, NULL, 'MUCIN-LIKE DOMAIN-CONTAINING PROTEIN', 253635),
(432266, 'PTHR14759:SF34', NULL, NULL, NULL, NULL, '', 253635),
(432267, 'PTHR14759:SF37', NULL, NULL, NULL, NULL, 'MAP6 DOMAIN-CONTAINING PROTEIN 1', 253635),
(432268, 'PTHR14759:SF36', NULL, NULL, NULL, NULL, 'ERYTHROCYTE MEMBRANE-ASSOCIATED GIANT PROTEIN ANTIGEN 332 CONTAINING PROTEIN', 253635),
(432269, 'PTHR14759:SF29', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN 6', 253635),
(432270, 'PTHR36063:SF1', NULL, NULL, NULL, NULL, 'ARABIDOPSIS THALIANA GENOMIC DNA, CHROMOSOME 5, P1 CLONE:MOK16', 253636),
(432271, 'PTHR36063:SF4', NULL, NULL, NULL, NULL, 'BNAA09G17820D PROTEIN', 253636),
(432272, 'PTHR36063:SF3', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 253636),
(432273, 'PTHR36063:SF6', NULL, NULL, NULL, NULL, 'BNAC01G40880D PROTEIN', 253636),
(432274, 'PTHR36063:SF5', NULL, NULL, NULL, NULL, 'BNAA02G24330D PROTEIN', 253636),
(432275, 'PTHR36063:SF7', NULL, NULL, NULL, NULL, '', 253636),
(432276, 'PTHR36063', NULL, NULL, NULL, NULL, 'ARABIDOPSIS THALIANA GENOMIC DNA, CHROMOSOME 5, P1 CLONE:MOK16', 253636),
(432277, 'PTHR43266:SF2', NULL, NULL, NULL, NULL, 'LYSOPHOSPHOLIPID TRANSPORTER LPLT', 253637),
(432278, 'PTHR43266:SF5', NULL, NULL, NULL, NULL, 'MFS DOMAIN-CONTAINING PROTEIN', 253637),
(432279, 'PTHR43266:SF6', NULL, NULL, NULL, NULL, 'BACILYSIN EXPORTER BACE-RELATED', 253637),
(432280, 'PTHR43266', NULL, NULL, NULL, NULL, 'MACROLIDE-EFFLUX PROTEIN', 253637),
(432281, 'PTHR43783:SF2', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE 1-CARBOXYVINYLTRANSFERASE 2', 253638),
(432282, 'PTHR43783', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE 1-CARBOXYVINYLTRANSFERASE', 253638),
(432283, 'PTHR43783:SF1', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE 1-CARBOXYVINYLTRANSFERASE', 253638),
(432284, 'PTHR46200', NULL, NULL, NULL, NULL, 'GATOR COMPLEX PROTEIN WDR24', 253639),
(432285, 'PTHR46200:SF1', NULL, NULL, NULL, NULL, 'GATOR COMPLEX PROTEIN WDR24', 253639),
(432286, 'PTHR11808', NULL, NULL, NULL, NULL, 'TRANS-SULFURATION ENZYME FAMILY MEMBER', 253640),
(432287, 'PTHR11808:SF80', NULL, NULL, NULL, NULL, 'GAMMA-CYSTATHIONASE', 253640),
(432288, 'PTHR11808:SF82', NULL, NULL, NULL, NULL, 'BNAC04G24570D PROTEIN', 253640),
(432289, 'PTHR11808:SF84', NULL, NULL, NULL, NULL, 'ENZYME FAMILY PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G13810)-RELATED', 253640),
(432290, 'PTHR11808:SF50', NULL, NULL, NULL, NULL, 'CYSTATHIONINE BETA-LYASE', 253640);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(432291, 'PTHR11808:SF86', NULL, NULL, NULL, NULL, 'METHIONINE GAMMA-LYASE', 253640),
(432292, 'PTHR11808:SF75', NULL, NULL, NULL, NULL, 'CYSTATHIONINE GAMMA-SYNTHASE', 253640),
(432293, 'PTHR11808:SF85', NULL, NULL, NULL, NULL, 'CYSTATHIONINE GAMMA-LYASE-RELATED', 253640),
(432294, 'PTHR11808:SF77', NULL, NULL, NULL, NULL, 'CYSTATHIONINE BETA-LYASE METC', 253640),
(432295, 'PTHR11808:SF76', NULL, NULL, NULL, NULL, 'CYSTATHIONINE GAMMA-SYNTHASE', 253640),
(432296, 'PTHR11808:SF35', NULL, NULL, NULL, NULL, 'CYSTATHIONINE GAMMA-SYNTHASE (AFU_ORTHOLOGUE AFUA_7G01590)', 253640),
(432297, 'PTHR11808:SF89', NULL, NULL, NULL, NULL, 'METHIONINE GAMMA-LYASE', 253640),
(432298, 'PTHR11808:SF15', NULL, NULL, NULL, NULL, 'CYSTATHIONINE GAMMA-LYASE', 253640),
(432299, 'PTHR34137:SF1', NULL, NULL, NULL, NULL, 'EXODEOXYRIBONUCLEASE 7 SMALL SUBUNIT', 253641),
(432300, 'PTHR34137', NULL, NULL, NULL, NULL, 'EXODEOXYRIBONUCLEASE 7 SMALL SUBUNIT', 253641),
(432301, 'PTHR42535', NULL, NULL, NULL, NULL, 'OOKINETE PROTEIN, PUTATIVE-RELATED', 253642),
(432302, 'PTHR42535:SF2', NULL, NULL, NULL, NULL, 'OOKINETE PROTEIN, PUTATIVE-RELATED', 253642),
(432303, 'PTHR46908', NULL, NULL, NULL, NULL, 'CUBILIN-LIKE PROTEIN', 253643),
(432304, 'PTHR46908:SF7', NULL, NULL, NULL, NULL, 'CUB DOMAINCONTAINING PROTEIN', 253643),
(432305, 'PTHR46908:SF6', NULL, NULL, NULL, NULL, 'METALLOENDOPEPTIDASE', 253643),
(432306, 'PTHR46908:SF5', NULL, NULL, NULL, NULL, 'PROTEIN CBG02117', 253643),
(432307, 'PTHR46908:SF4', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR-INDUCIBLE GENE 6 PROTEIN', 253643),
(432308, 'PTHR48071:SF5', NULL, NULL, NULL, NULL, 'NEUROTRYPSIN', 253644),
(432309, 'PTHR48071:SF18', NULL, NULL, NULL, NULL, 'LCCL/LECTIN ADHESIVE-LIKE PROTEIN 1', 253644),
(432310, 'PTHR48071:SF19', NULL, NULL, NULL, NULL, '', 253644),
(432311, 'PTHR48071', NULL, NULL, NULL, NULL, 'SRCR DOMAIN-CONTAINING PROTEIN', 253644),
(432312, 'PTHR48071:SF8', NULL, NULL, NULL, NULL, 'CD5 ANTIGEN-LIKE', 253644),
(432313, 'PTHR48071:SF15', NULL, NULL, NULL, NULL, 'DELETED IN MALIGNANT BRAIN TUMORS 1 PROTEIN', 253644),
(432314, 'PTHR48071:SF16', NULL, NULL, NULL, NULL, 'SRCR DOMAIN-CONTAINING PROTEIN', 253644),
(432315, 'PTHR48071:SF17', NULL, NULL, NULL, NULL, 'SRCR DOMAIN-CONTAINING PROTEIN', 253644),
(432316, 'PTHR48071:SF21', NULL, NULL, NULL, NULL, 'SRCR DOMAIN-CONTAINING PROTEIN', 253644),
(432317, 'PTHR48071:SF4', NULL, NULL, NULL, NULL, 'NEUROTRYPSIN', 253644),
(432318, 'PTHR48071:SF20', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 292', 253644),
(432319, 'PTHR38496', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AND COILED-COIL DOMAIN-CONTAINING PROTEIN 2', 253645),
(432320, 'PTHR38496:SF1', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AND COILED-COIL DOMAIN-CONTAINING PROTEIN 2', 253645),
(432321, 'PTHR47354:SF3', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE-RELATED', 253646),
(432322, 'PTHR47354:SF2', NULL, NULL, NULL, NULL, 'BLR2392 PROTEIN', 253646),
(432323, 'PTHR47354:SF1', NULL, NULL, NULL, NULL, 'CARNITINE MONOOXYGENASE REDUCTASE SUBUNIT', 253646),
(432324, 'PTHR47354:SF7', NULL, NULL, NULL, NULL, 'NAD(P)H-FLAVIN REDUCTASE', 253646),
(432325, 'PTHR47354:SF6', NULL, NULL, NULL, NULL, 'NADH OXIDOREDUCTASE HCR', 253646),
(432326, 'PTHR47354:SF5', NULL, NULL, NULL, NULL, 'PROTEIN RFBI', 253646),
(432327, 'PTHR47354', NULL, NULL, NULL, NULL, 'NADH OXIDOREDUCTASE HCR', 253646),
(432328, 'PTHR47354:SF8', NULL, NULL, NULL, NULL, '1,2-PHENYLACETYL-COA EPOXIDASE, SUBUNIT E', 253646),
(432329, 'PTHR31111:SF91', NULL, NULL, NULL, NULL, 'FBA_3 DOMAIN-CONTAINING PROTEIN', 253647),
(432330, 'PTHR31111:SF92', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432331, 'PTHR31111:SF93', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432332, 'PTHR31111:SF94', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432333, 'PTHR31111:SF95', NULL, NULL, NULL, NULL, 'FBA_3 DOMAIN-CONTAINING PROTEIN', 253647),
(432334, 'PTHR31111:SF96', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432335, 'PTHR31111:SF97', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647);
INSERT INTO "PUBLIC"."MODEL" VALUES
(432336, 'PTHR31111:SF98', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432337, 'PTHR31111:SF99', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432338, 'PTHR31111:SF104', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432339, 'PTHR31111:SF103', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432340, 'PTHR31111:SF106', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432341, 'PTHR31111:SF14', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432342, 'PTHR31111:SF105', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432343, 'PTHR31111:SF100', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432344, 'PTHR31111:SF15', NULL, NULL, NULL, NULL, 'BNAA03G19310D PROTEIN', 253647),
(432345, 'PTHR31111:SF17', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432346, 'PTHR31111:SF102', NULL, NULL, NULL, NULL, 'FBA_3 DOMAIN-CONTAINING PROTEIN', 253647),
(432347, 'PTHR31111:SF101', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432348, 'PTHR31111:SF19', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432349, 'PTHR31111:SF108', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN CPR30-LIKE', 253647),
(432350, 'PTHR31111:SF107', NULL, NULL, NULL, NULL, 'FBA_3 DOMAIN-CONTAINING PROTEIN', 253647),
(432351, 'PTHR31111:SF109', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432352, 'PTHR31111:SF80', NULL, NULL, NULL, NULL, 'FBA_3 DOMAIN-CONTAINING PROTEIN', 253647),
(432353, 'PTHR31111:SF81', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432354, 'PTHR31111:SF82', NULL, NULL, NULL, NULL, 'F-BOX ASSOCIATED UBIQUITINATION EFFECTOR FAMILY PROTEIN', 253647),
(432355, 'PTHR31111:SF83', NULL, NULL, NULL, NULL, 'F-BOX ASSOCIATED UBIQUITINATION EFFECTOR FAMILY PROTEIN-RELATED', 253647),
(432356, 'PTHR31111:SF84', NULL, NULL, NULL, NULL, 'FBA_3 DOMAIN-CONTAINING PROTEIN', 253647),
(432357, 'PTHR31111:SF85', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432358, 'PTHR31111:SF86', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432359, 'PTHR31111:SF87', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432360, 'PTHR31111:SF88', NULL, NULL, NULL, NULL, 'FBA_3 DOMAIN-CONTAINING PROTEIN', 253647),
(432361, 'PTHR31111:SF89', NULL, NULL, NULL, NULL, 'F-BOX ASSOCIATED UBIQUITINATION EFFECTOR FAMILY PROTEIN', 253647),
(432362, 'PTHR31111:SF90', NULL, NULL, NULL, NULL, 'BNAC04G42990D PROTEIN', 253647),
(432363, 'PTHR31111:SF70', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432364, 'PTHR31111:SF120', NULL, NULL, NULL, NULL, 'FBA_3 DOMAIN-CONTAINING PROTEIN', 253647),
(432365, 'PTHR31111:SF71', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432366, 'PTHR31111:SF72', NULL, NULL, NULL, NULL, 'F-BOX ASSOCIATED UBIQUITINATION EFFECTOR FAMILY PROTEIN', 253647),
(432367, 'PTHR31111:SF73', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432368, 'PTHR31111:SF74', NULL, NULL, NULL, NULL, 'FBA_3 DOMAIN-CONTAINING PROTEIN', 253647),
(432369, 'PTHR31111:SF75', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432370, 'PTHR31111:SF76', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432371, 'PTHR31111:SF77', NULL, NULL, NULL, NULL, 'OS07G0196600 PROTEIN', 253647),
(432372, 'PTHR31111:SF78', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432373, 'PTHR31111:SF79', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN DOR', 253647),
(432374, 'PTHR31111:SF122', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432375, 'PTHR31111:SF121', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432376, 'PTHR31111:SF124', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432377, 'PTHR31111:SF123', NULL, NULL, NULL, NULL, 'ISOFORM 2 OF F-BOX PROTEIN', 253647),
(432378, 'PTHR31111:SF60', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(432379, 'PTHR31111:SF61', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432380, 'PTHR31111:SF62', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432381, 'PTHR31111:SF63', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432382, 'PTHR31111:SF64', NULL, NULL, NULL, NULL, 'F-BOX ASSOCIATED UBIQUITINATION EFFECTOR FAMILY PROTEIN-RELATED', 253647),
(432383, 'PTHR31111:SF65', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432384, 'PTHR31111:SF66', NULL, NULL, NULL, NULL, 'F-BOX ASSOCIATED UBIQUITINATION EFFECTOR FAMILY PROTEIN', 253647),
(432385, 'PTHR31111:SF115', NULL, NULL, NULL, NULL, 'PBPE DOMAIN-CONTAINING PROTEIN', 253647),
(432386, 'PTHR31111:SF67', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432387, 'PTHR31111:SF114', NULL, NULL, NULL, NULL, 'F-BOX ASSOCIATED UBIQUITINATION EFFECTOR FAMILY PROTEIN', 253647),
(432388, 'PTHR31111:SF68', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432389, 'PTHR31111:SF117', NULL, NULL, NULL, NULL, 'CLASS S F-BOX PROTEIN', 253647),
(432390, 'PTHR31111:SF116', NULL, NULL, NULL, NULL, 'BNAC04G42970D PROTEIN', 253647),
(432391, 'PTHR31111:SF69', NULL, NULL, NULL, NULL, 'FBA_3 DOMAIN-CONTAINING PROTEIN', 253647),
(432392, 'PTHR31111:SF111', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432393, 'PTHR31111:SF110', NULL, NULL, NULL, NULL, 'F-BOX ASSOCIATED UBIQUITINATION EFFECTOR FAMILY PROTEIN', 253647),
(432394, 'PTHR31111:SF113', NULL, NULL, NULL, NULL, 'BNAC04G02840D PROTEIN', 253647),
(432395, 'PTHR31111:SF112', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432396, 'PTHR31111:SF119', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432397, 'PTHR31111:SF118', NULL, NULL, NULL, NULL, 'FBA_3 DOMAIN-CONTAINING PROTEIN', 253647),
(432398, 'PTHR31111', NULL, NULL, NULL, NULL, 'BNAA05G37150D PROTEIN-RELATED', 253647),
(432399, 'PTHR31111:SF50', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432400, 'PTHR31111:SF51', NULL, NULL, NULL, NULL, 'F-BOX ASSOCIATED UBIQUITINATION EFFECTOR FAMILY PROTEIN', 253647),
(432401, 'PTHR31111:SF52', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432402, 'PTHR31111:SF53', NULL, NULL, NULL, NULL, 'F-BOX FAMILY PROTEIN-LIKE PROTEIN', 253647),
(432403, 'PTHR31111:SF54', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432404, 'PTHR31111:SF55', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432405, 'PTHR31111:SF56', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432406, 'PTHR31111:SF57', NULL, NULL, NULL, NULL, 'FBA_3 DOMAIN-CONTAINING PROTEIN', 253647),
(432407, 'PTHR31111:SF58', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432408, 'PTHR31111:SF59', NULL, NULL, NULL, NULL, 'BNAA05G14190D PROTEIN', 253647),
(432409, 'PTHR31111:SF41', NULL, NULL, NULL, NULL, 'FBA_3 DOMAIN-CONTAINING PROTEIN', 253647),
(432410, 'PTHR31111:SF42', NULL, NULL, NULL, NULL, 'F-BOX ASSOCIATED UBIQUITINATION EFFECTOR FAMILY PROTEIN', 253647),
(432411, 'PTHR31111:SF43', NULL, NULL, NULL, NULL, 'F-BOX ASSOCIATED UBIQUITINATION EFFECTOR FAMILY PROTEIN', 253647),
(432412, 'PTHR31111:SF44', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432413, 'PTHR31111:SF45', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432414, 'PTHR31111:SF46', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432415, 'PTHR31111:SF47', NULL, NULL, NULL, NULL, 'F-BOX ASSOCIATED UBIQUITINATION EFFECTOR FAMILY PROTEIN', 253647),
(432416, 'PTHR31111:SF48', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432417, 'PTHR31111:SF49', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432418, 'PTHR31111:SF31', NULL, NULL, NULL, NULL, 'FBA_3 DOMAIN-CONTAINING PROTEIN', 253647),
(432419, 'PTHR31111:SF33', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432420, 'PTHR31111:SF36', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(432421, 'PTHR31111:SF37', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432422, 'PTHR31111:SF39', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432423, 'PTHR31111:SF20', NULL, NULL, NULL, NULL, 'FBA_3 DOMAIN-CONTAINING PROTEIN', 253647),
(432424, 'PTHR31111:SF21', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432425, 'PTHR31111:SF22', NULL, NULL, NULL, NULL, 'FBA_3 DOMAIN-CONTAINING PROTEIN', 253647),
(432426, 'PTHR31111:SF23', NULL, NULL, NULL, NULL, 'FBA_3 DOMAIN-CONTAINING PROTEIN', 253647),
(432427, 'PTHR31111:SF24', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN', 253647),
(432428, 'PTHR31111:SF25', NULL, NULL, NULL, NULL, 'F-BOX ASSOCIATED UBIQUITINATION EFFECTOR FAMILY PROTEIN', 253647),
(432429, 'PTHR31111:SF26', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432430, 'PTHR31111:SF27', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432431, 'PTHR31111:SF28', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253647),
(432432, 'PTHR15756:SF6', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 176A', 253648),
(432433, 'PTHR15756', NULL, NULL, NULL, NULL, 'LR8/HCA112', 253648),
(432434, 'PTHR15756:SF7', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 176B', 253648),
(432435, 'PTHR46654', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HECTD3', 253649),
(432436, 'PTHR46654:SF1', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HECTD3', 253649),
(432437, 'PTHR46654:SF2', NULL, NULL, NULL, NULL, '', 253649),
(432438, 'PTHR33449', NULL, NULL, NULL, NULL, 'NUCLEOID-ASSOCIATED PROTEIN YBAB', 253650),
(432439, 'PTHR33449:SF5', NULL, NULL, NULL, NULL, 'BNAA08G12980D PROTEIN', 253650),
(432440, 'PTHR33449:SF7', NULL, NULL, NULL, NULL, 'BNAA02G17680D PROTEIN', 253650),
(432441, 'PTHR33449:SF11', NULL, NULL, NULL, NULL, '', 253650),
(432442, 'PTHR33449:SF8', NULL, NULL, NULL, NULL, '', 253650),
(432443, 'PTHR33449:SF1', NULL, NULL, NULL, NULL, 'NUCLEOID-ASSOCIATED PROTEIN YBAB', 253650),
(432444, 'PTHR31186:SF1', NULL, NULL, NULL, NULL, 'MODULATOR OF SMOOTHENED PROTEIN', 253651),
(432445, 'PTHR31186', NULL, NULL, NULL, NULL, 'MODULATOR OF SMOOTHENED PROTEIN', 253651),
(432446, 'PTHR47942:SF80', NULL, NULL, NULL, NULL, 'OS06G0499301 PROTEIN', 253652),
(432447, 'PTHR47942:SF75', NULL, NULL, NULL, NULL, '', 253652),
(432448, 'PTHR47942:SF30', NULL, NULL, NULL, NULL, 'OS11G0607100 PROTEIN', 253652),
(432449, 'PTHR47942:SF33', NULL, NULL, NULL, NULL, 'OS02G0121900 PROTEIN', 253652),
(432450, 'PTHR47942:SF32', NULL, NULL, NULL, NULL, 'OS05G0393900 PROTEIN', 253652),
(432451, 'PTHR47942:SF71', NULL, NULL, NULL, NULL, 'OS01G0852900 PROTEIN', 253652),
(432452, 'PTHR47942:SF70', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE (PPR) REPEAT PROTEIN', 253652),
(432453, 'PTHR47942:SF39', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT PROTEIN', 253652),
(432454, 'PTHR47942:SF38', NULL, NULL, NULL, NULL, 'REPEAT SUPERFAMILY PROTEIN, PUTATIVE-RELATED', 253652),
(432455, 'PTHR47942:SF79', NULL, NULL, NULL, NULL, 'OS12G0102600 PROTEIN', 253652),
(432456, 'PTHR47942:SF35', NULL, NULL, NULL, NULL, 'OS09G0110200 PROTEIN', 253652),
(432457, 'PTHR47942:SF34', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 253652),
(432458, 'PTHR47942:SF78', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT DOMAIN CONTAINING PROTEIN-RELATED', 253652),
(432459, 'PTHR47942:SF37', NULL, NULL, NULL, NULL, 'OS07G0674300 PROTEIN', 253652),
(432460, 'PTHR47942:SF36', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 253652),
(432461, 'PTHR47942:SF7', NULL, NULL, NULL, NULL, 'OS02G0711100 PROTEIN', 253652),
(432462, 'PTHR47942', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN-RELATED', 253652),
(432463, 'PTHR47942:SF64', NULL, NULL, NULL, NULL, 'F21B23.6 PROTEIN', 253652),
(432464, 'PTHR47942:SF20', NULL, NULL, NULL, NULL, 'OS05G0294600 PROTEIN', 253652),
(432465, 'PTHR47942:SF63', NULL, NULL, NULL, NULL, 'ATPASE EXPRESSION PROTEIN 3', 253652),
(432466, 'PTHR47942:SF22', NULL, NULL, NULL, NULL, 'OS04G0643700 PROTEIN', 253652);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(432467, 'PTHR47942:SF21', NULL, NULL, NULL, NULL, 'OS05G0275100 PROTEIN', 253652),
(432468, 'PTHR47942:SF65', NULL, NULL, NULL, NULL, 'OS04G0618050 PROTEIN', 253652),
(432469, 'PTHR47942:SF60', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 253652),
(432470, 'PTHR47942:SF62', NULL, NULL, NULL, NULL, '', 253652),
(432471, 'PTHR47942:SF6', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 253652),
(432472, 'PTHR47942:SF28', NULL, NULL, NULL, NULL, 'OS04G0520900 PROTEIN', 253652),
(432473, 'PTHR47942:SF5', NULL, NULL, NULL, NULL, 'OS09G0417500 PROTEIN', 253652),
(432474, 'PTHR47942:SF27', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 253652),
(432475, 'PTHR47942:SF4', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 253652),
(432476, 'PTHR47942:SF3', NULL, NULL, NULL, NULL, 'OS10G0506000 PROTEIN', 253652),
(432477, 'PTHR47942:SF2', NULL, NULL, NULL, NULL, 'OS09G0532800 PROTEIN', 253652),
(432478, 'PTHR47942:SF67', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', 253652),
(432479, 'PTHR47942:SF26', NULL, NULL, NULL, NULL, 'OS10G0363500 PROTEIN', 253652),
(432480, 'PTHR47942:SF69', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 253652),
(432481, 'PTHR47942:SF97', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 253652),
(432482, 'PTHR47942:SF96', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', 253652),
(432483, 'PTHR47942:SF98', NULL, NULL, NULL, NULL, 'OS05G0481800 PROTEIN', 253652),
(432484, 'PTHR47942:SF93', NULL, NULL, NULL, NULL, '', 253652),
(432485, 'PTHR47942:SF92', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN-CONTAINING PROTEIN-RELATED', 253652),
(432486, 'PTHR47942:SF51', NULL, NULL, NULL, NULL, 'OS02G0321000 PROTEIN', 253652),
(432487, 'PTHR47942:SF95', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', 253652),
(432488, 'PTHR47942:SF94', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN CRP1 HOMOLOG, CHLOROPLASTIC', 253652),
(432489, 'PTHR47942:SF50', NULL, NULL, NULL, NULL, 'OS03G0284900 PROTEIN', 253652),
(432490, 'PTHR47942:SF17', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 253652),
(432491, 'PTHR47942:SF16', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE (PPR) REPEAT PROTEIN', 253652),
(432492, 'PTHR47942:SF19', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT SUPERFAMILY PROTEIN', 253652),
(432493, 'PTHR47942:SF18', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE (PPR) REPEAT PROTEIN', 253652),
(432494, 'PTHR47942:SF13', NULL, NULL, NULL, NULL, 'OS06G0710800 PROTEIN', 253652),
(432495, 'PTHR47942:SF57', NULL, NULL, NULL, NULL, 'OS02G0119700 PROTEIN', 253652),
(432496, 'PTHR47942:SF56', NULL, NULL, NULL, NULL, '', 253652),
(432497, 'PTHR47942:SF12', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 253652),
(432498, 'PTHR47942:SF15', NULL, NULL, NULL, NULL, 'OS12G0557800 PROTEIN', 253652),
(432499, 'PTHR47942:SF14', NULL, NULL, NULL, NULL, 'BNACNNG37440D PROTEIN', 253652),
(432500, 'PTHR47942:SF58', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 253652),
(432501, 'PTHR47942:SF91', NULL, NULL, NULL, NULL, '', 253652),
(432502, 'PTHR47942:SF90', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE (PPR) REPEAT PROTEIN', 253652),
(432503, 'PTHR47942:SF86', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN-CONTAINING PROTEIN-RELATED', 253652),
(432504, 'PTHR47942:SF85', NULL, NULL, NULL, NULL, '', 253652),
(432505, 'PTHR47942:SF41', NULL, NULL, NULL, NULL, 'OS05G0548600 PROTEIN', 253652),
(432506, 'PTHR47942:SF88', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', 253652),
(432507, 'PTHR47942:SF87', NULL, NULL, NULL, NULL, 'OS02G0679200 PROTEIN', 253652),
(432508, 'PTHR47942:SF82', NULL, NULL, NULL, NULL, 'CHROMOSOME 16, WHOLE GENOME SHOTGUN SEQUENCE', 253652),
(432509, 'PTHR47942:SF81', NULL, NULL, NULL, NULL, '', 253652),
(432510, 'PTHR47942:SF84', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL GROUP I INTRON SPLICING FACTOR CCM1', 253652),
(432511, 'PTHR47942:SF40', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT PROTEIN (AFU_ORTHOLOGUE AFUA_4G07240)', 253652);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(432512, 'PTHR47942:SF83', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE ISOFORM 1-RELATED', 253652),
(432513, 'PTHR47942:SF49', NULL, NULL, NULL, NULL, 'OS01G0559500 PROTEIN', 253652),
(432514, 'PTHR47942:SF45', NULL, NULL, NULL, NULL, 'OS07G0599201 PROTEIN', 253652),
(432515, 'PTHR47942:SF89', NULL, NULL, NULL, NULL, 'OS03G0165100 PROTEIN', 253652),
(432516, 'PTHR47942:SF48', NULL, NULL, NULL, NULL, 'OS05G0355200 PROTEIN', 253652),
(432517, 'PTHR47942:SF47', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', 253652),
(432518, 'PTHR16674:SF2', NULL, NULL, NULL, NULL, 'B-LYMPHOCYTE ANTIGEN CD19', 253653),
(432519, 'PTHR16674', NULL, NULL, NULL, NULL, 'B-LYMPHOCYTE ANTIGEN CD19', 253653),
(432520, 'PTHR47161', NULL, NULL, NULL, NULL, 'LYMPHOID-SPECIFIC HELICASE', 253654),
(432521, 'PTHR47161:SF1', NULL, NULL, NULL, NULL, 'LYMPHOID-SPECIFIC HELICASE', 253654),
(432522, 'PTHR40780:SF2', NULL, NULL, NULL, NULL, 'DUF3669 DOMAIN-CONTAINING PROTEIN', 253655),
(432523, 'PTHR40780', NULL, NULL, NULL, NULL, 'DUF3669 DOMAIN-CONTAINING PROTEIN', 253655),
(432524, 'PTHR31152:SF13', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HAKAI-LIKE ISOFORM X1', 253656),
(432525, 'PTHR31152:SF23', NULL, NULL, NULL, NULL, '', 253656),
(432526, 'PTHR31152:SF15', NULL, NULL, NULL, NULL, 'PLAC8 FAMILY PROTEIN', 253656),
(432527, 'PTHR31152:SF20', NULL, NULL, NULL, NULL, 'BASIC SALIVARY PROLINE-RICH PROTEIN 2-LIKE', 253656),
(432528, 'PTHR31152:SF6', NULL, NULL, NULL, NULL, 'OS10G0535800 PROTEIN', 253656),
(432529, 'PTHR31152:SF22', NULL, NULL, NULL, NULL, 'PLAC8 FAMILY PROTEIN', 253656),
(432530, 'PTHR31152:SF21', NULL, NULL, NULL, NULL, '', 253656),
(432531, 'PTHR31152:SF10', NULL, NULL, NULL, NULL, 'ENHANCER OF AG-4 PROTEIN 2-LIKE', 253656),
(432532, 'PTHR31152:SF1', NULL, NULL, NULL, NULL, 'PLAC8 FAMILY PROTEIN', 253656),
(432533, 'PTHR31152', NULL, NULL, NULL, NULL, 'PLAC8 FAMILY PROTEIN', 253656),
(432534, 'PTHR31152:SF17', NULL, NULL, NULL, NULL, '', 253656),
(432535, 'PTHR31152:SF16', NULL, NULL, NULL, NULL, 'BNACNNG42060D PROTEIN', 253656),
(432536, 'PTHR31152:SF19', NULL, NULL, NULL, NULL, '', 253656),
(432537, 'PTHR37520:SF1', NULL, NULL, NULL, NULL, 'INTRON-ENCODED DNA ENDONUCLEASE AI2A-RELATED', 253657),
(432538, 'PTHR37520', NULL, NULL, NULL, NULL, 'INTRON-ENCODED DNA ENDONUCLEASE AI2A-RELATED', 253657),
(432539, 'PTHR48048:SF12', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432540, 'PTHR48048:SF56', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432541, 'PTHR48048:SF13', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432542, 'PTHR48048:SF14', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432543, 'PTHR48048:SF58', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432544, 'PTHR48048:SF15', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432545, 'PTHR48048:SF53', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432546, 'PTHR48048:SF54', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 91A1', 253658),
(432547, 'PTHR48048:SF11', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432548, 'PTHR48048', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432549, 'PTHR48048:SF16', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432550, 'PTHR48048:SF17', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432551, 'PTHR48048:SF18', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 71B1', 253658),
(432552, 'PTHR48048:SF67', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432553, 'PTHR48048:SF23', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432554, 'PTHR48048:SF68', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432555, 'PTHR48048:SF69', NULL, NULL, NULL, NULL, '', 253658),
(432556, 'PTHR48048:SF26', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432557, 'PTHR48048:SF63', NULL, NULL, NULL, NULL, 'UDPGT DOMAIN-CONTAINING PROTEIN', 253658),
(432558, 'PTHR48048:SF20', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432559, 'PTHR48048:SF64', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(432560, 'PTHR48048:SF21', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432561, 'PTHR48048:SF65', NULL, NULL, NULL, NULL, 'OS07G0510400 PROTEIN', 253658),
(432562, 'PTHR48048:SF22', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432563, 'PTHR48048:SF66', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 88A1', 253658),
(432564, 'PTHR48048:SF60', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432565, 'PTHR48048:SF62', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432566, 'PTHR48048:SF29', NULL, NULL, NULL, NULL, 'OS01G0865400 PROTEIN', 253658),
(432567, 'PTHR48048:SF78', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 88A1-LIKE', 253658),
(432568, 'PTHR48048:SF79', NULL, NULL, NULL, NULL, 'ANTHOCYANIDIN 3-O-GLUCOSYLTRANSFERASE', 253658),
(432569, 'PTHR48048:SF35', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432570, 'PTHR48048:SF37', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 71B1', 253658),
(432571, 'PTHR48048:SF30', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432572, 'PTHR48048:SF74', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432573, 'PTHR48048:SF75', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432574, 'PTHR48048:SF76', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 708D1-LIKE', 253658),
(432575, 'PTHR48048:SF77', NULL, NULL, NULL, NULL, '', 253658),
(432576, 'PTHR48048:SF33', NULL, NULL, NULL, NULL, 'ISOFLAVONE 7-O-GLUCOSYLTRANSFERASE 1', 253658),
(432577, 'PTHR48048:SF70', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432578, 'PTHR48048:SF71', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432579, 'PTHR48048:SF72', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432580, 'PTHR48048:SF73', NULL, NULL, NULL, NULL, 'OS10G0162980 PROTEIN', 253658),
(432581, 'PTHR48048:SF39', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432582, 'PTHR48048:SF45', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432583, 'PTHR48048:SF47', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 88A1', 253658),
(432584, 'PTHR48048:SF41', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432585, 'PTHR48048:SF42', NULL, NULL, NULL, NULL, 'OS07G0502900 PROTEIN', 253658),
(432586, 'PTHR48048:SF44', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432587, 'PTHR48048:SF81', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432588, 'PTHR48048:SF82', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432589, 'PTHR48048:SF83', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432590, 'PTHR48048:SF80', NULL, NULL, NULL, NULL, '', 253658),
(432591, 'PTHR48048:SF2', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432592, 'PTHR48048:SF1', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432593, 'PTHR48048:SF7', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432594, 'PTHR48048:SF4', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432595, 'PTHR48048:SF49', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432596, 'PTHR48048:SF3', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432597, 'PTHR48048:SF5', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', 253658),
(432598, 'PTHR47519:SF3', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-5', 253659),
(432599, 'PTHR47519:SF4', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', 253659),
(432600, 'PTHR47519:SF1', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-31', 253659),
(432601, 'PTHR47519:SF2', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-97', 253659),
(432602, 'PTHR47519:SF5', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR DOMAIN-CONTAINING PROTEIN', 253659),
(432603, 'PTHR47519', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-31-RELATED', 253659),
(432604, 'PTHR11476:SF6', NULL, NULL, NULL, NULL, 'HISTIDINE--TRNA LIGASE, MITOCHONDRIAL', 253660),
(432605, 'PTHR11476:SF7', NULL, NULL, NULL, NULL, 'HISTIDINE--TRNA LIGASE', 253660),
(432606, 'PTHR11476:SF11', NULL, NULL, NULL, NULL, 'HISTIDINE--TRNA LIGASE', 253660);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(432607, 'PTHR11476', NULL, NULL, NULL, NULL, 'HISTIDYL-TRNA SYNTHETASE', 253660),
(432608, 'PTHR11476:SF10', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', 253660),
(432609, 'PTHR11476:SF8', NULL, NULL, NULL, NULL, 'HISTIDINE--TRNA LIGASE, CYTOPLASMIC', 253660),
(432610, 'PTHR46825:SF10', NULL, NULL, NULL, NULL, 'BETA-LACTAMASE DOMAIN-CONTAINING PROTEIN', 253661),
(432611, 'PTHR46825', NULL, NULL, NULL, NULL, 'D-ALANYL-D-ALANINE-CARBOXYPEPTIDASE/ENDOPEPTIDASE AMPH', 253661),
(432612, 'PTHR46825:SF12', NULL, NULL, NULL, NULL, 'PENICILLIN-BINDING PROTEIN 4', 253661),
(432613, 'PTHR46825:SF11', NULL, NULL, NULL, NULL, 'PENICILLIN-BINDING PROTEIN 4*', 253661),
(432614, 'PTHR46825:SF14', NULL, NULL, NULL, NULL, 'BETA-LACTAMASE DOMAIN-CONTAINING PROTEIN', 253661),
(432615, 'PTHR46825:SF13', NULL, NULL, NULL, NULL, 'BETA-LACTAMASE DOMAIN-CONTAINING PROTEIN', 253661),
(432616, 'PTHR46825:SF7', NULL, NULL, NULL, NULL, 'D-ALANYL-D-ALANINE CARBOXYPEPTIDASE', 253661),
(432617, 'PTHR46825:SF8', NULL, NULL, NULL, NULL, 'BETA-LACTAMASE-RELATED', 253661),
(432618, 'PTHR46825:SF9', NULL, NULL, NULL, NULL, 'BETA-LACTAMASE DOMAIN-CONTAINING PROTEIN', 253661),
(432619, 'PTHR40657:SF1', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC681367', 253662),
(432620, 'PTHR40657', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC681367', 253662),
(432621, 'PTHR36379:SF1', NULL, NULL, NULL, NULL, 'PUTATIVE RECOMBINATION INITIATION DEFECT 1-RELATED', 253663),
(432622, 'PTHR36379', NULL, NULL, NULL, NULL, 'PROTEIN PRD1', 253663),
(432623, 'PTHR42845:SF1', NULL, NULL, NULL, NULL, 'F420-NON-REDUCING HYDROGENASE VHU SUBUNIT G', 253664),
(432624, 'PTHR42845:SF3', NULL, NULL, NULL, NULL, 'CYTOSOLIC NIFE-HYDROGENASE, DELTA SUBUNIT', 253664),
(432625, 'PTHR42845:SF2', NULL, NULL, NULL, NULL, 'COENZYME F420 HYDROGENASE SUBUNIT GAMMA', 253664),
(432626, 'PTHR42845', NULL, NULL, NULL, NULL, 'COENZYME F420-REDUCING HYDROGENASE, GAMMA SUBUNIT', 253664),
(432627, 'PTHR21242:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 10', 253665),
(432628, 'PTHR21242:SF2', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 10', 253665),
(432629, 'PTHR21242', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 10', 253665),
(432630, 'PTHR21242:SF0', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 10', 253665),
(432631, 'PTHR13265:SF1', NULL, NULL, NULL, NULL, 'SI:DKEYP-97B10.3', 253666),
(432632, 'PTHR13265:SF0', NULL, NULL, NULL, NULL, 'HPR1', 253666),
(432633, 'PTHR13265:SF2', NULL, NULL, NULL, NULL, 'THO COMPLEX SUBUNIT 1', 253666),
(432634, 'PTHR13265', NULL, NULL, NULL, NULL, 'THO COMPLEX SUBUNIT 1', 253666),
(432635, 'PTHR10055:SF5', NULL, NULL, NULL, NULL, 'TRYPTOPHAN--TRNA LIGASE', 253667),
(432636, 'PTHR10055:SF8', NULL, NULL, NULL, NULL, 'TRYPTOPHANYL-TRNA SYNTHETASE', 253667),
(432637, 'PTHR10055:SF13', NULL, NULL, NULL, NULL, 'TRYPTOPHANYL-TRNA SYNTHETASE', 253667),
(432638, 'PTHR10055:SF14', NULL, NULL, NULL, NULL, 'TRYPTOPHANYL-TRNA SYNTHETASE', 253667),
(432639, 'PTHR10055:SF10', NULL, NULL, NULL, NULL, 'TRYPTOPHANYL-TRNA SYNTHETASE', 253667),
(432640, 'PTHR10055:SF11', NULL, NULL, NULL, NULL, 'TRYPTOPHANYL-TRNA SYNTHETASE', 253667),
(432641, 'PTHR10055:SF1', NULL, NULL, NULL, NULL, 'TRYPTOPHAN--TRNA LIGASE, CYTOPLASMIC', 253667),
(432642, 'PTHR10055', NULL, NULL, NULL, NULL, 'TRYPTOPHANYL-TRNA SYNTHETASE', 253667),
(432643, 'PTHR10055:SF12', NULL, NULL, NULL, NULL, 'TRYPTOPHANYL-TRNA SYNTHETASE', 253667),
(432644, 'PTHR12254:SF0', NULL, NULL, NULL, NULL, 'BARBU-RELATED', 253668),
(432645, 'PTHR12254', NULL, NULL, NULL, NULL, 'ENHANCER OF SPLIT MALPHA PROTEIN', 253668),
(432646, 'PTHR36681:SF3', NULL, NULL, NULL, NULL, 'NUCLEAR GTPASE, GERMINAL CENTER-ASSOCIATED, TANDEM DUPLICATE 3', 253669),
(432647, 'PTHR36681', NULL, NULL, NULL, NULL, 'NUCLEAR GTPASE, GERMINAL CENTER-ASSOCIATED, TANDEM DUPLICATE 3', 253669),
(432648, 'PTHR20893', NULL, NULL, NULL, NULL, 'LD08641P', 253670),
(432649, 'PTHR20893:SF2', NULL, NULL, NULL, NULL, 'LD08641P', 253670);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(432650, 'PTHR47999:SF23', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 253671),
(432651, 'PTHR47999:SF68', NULL, NULL, NULL, NULL, 'MYB DOMAIN PROTEIN 40', 253671),
(432652, 'PTHR47999:SF24', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB90', 253671),
(432653, 'PTHR47999', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB8-RELATED-RELATED', 253671),
(432654, 'PTHR47999:SF21', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB114-LIKE', 253671),
(432655, 'PTHR47999:SF66', NULL, NULL, NULL, NULL, 'PROTEIN ODORANT1-LIKE', 253671),
(432656, 'PTHR47999:SF20', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 253671),
(432657, 'PTHR47999:SF62', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR MYB92', 253671),
(432658, 'PTHR47999:SF29', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB114-LIKE', 253671),
(432659, 'PTHR47999:SF27', NULL, NULL, NULL, NULL, '', 253671),
(432660, 'PTHR47999:SF101', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB114-LIKE', 253671),
(432661, 'PTHR47999:SF3', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 253671),
(432662, 'PTHR47999:SF4', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR MYB185', 253671),
(432663, 'PTHR47999:SF100', NULL, NULL, NULL, NULL, 'PROTEIN ODORANT1-LIKE', 253671),
(432664, 'PTHR47999:SF1', NULL, NULL, NULL, NULL, '', 253671),
(432665, 'PTHR47999:SF103', NULL, NULL, NULL, NULL, 'OS03G0244875 PROTEIN', 253671),
(432666, 'PTHR47999:SF25', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB7', 253671),
(432667, 'PTHR47999:SF102', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR MYB4', 253671),
(432668, 'PTHR47999:SF2', NULL, NULL, NULL, NULL, 'PROTEIN ODORANT1-LIKE', 253671),
(432669, 'PTHR47999:SF105', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR MYB6', 253671),
(432670, 'PTHR47999:SF104', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB1-LIKE', 253671),
(432671, 'PTHR47999:SF8', NULL, NULL, NULL, NULL, 'BNAA07G10350D PROTEIN', 253671),
(432672, 'PTHR47999:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB32', 253671),
(432673, 'PTHR47999:SF107', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB114-LIKE', 253671),
(432674, 'PTHR47999:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB11-RELATED', 253671),
(432675, 'PTHR47999:SF106', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB1-LIKE', 253671),
(432676, 'PTHR47999:SF109', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN 111, PUTATIVE-RELATED', 253671),
(432677, 'PTHR47999:SF108', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB3', 253671),
(432678, 'PTHR47999:SF9', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN 308-LIKE', 253671),
(432679, 'PTHR47999:SF70', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB13-LIKE', 253671),
(432680, 'PTHR47999:SF71', NULL, NULL, NULL, NULL, 'BNACNNG69610D PROTEIN', 253671),
(432681, 'PTHR47999:SF56', NULL, NULL, NULL, NULL, 'MYB DOMAIN PROTEIN 6-RELATED', 253671),
(432682, 'PTHR47999:SF12', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 253671),
(432683, 'PTHR47999:SF57', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR MYB6-LIKE', 253671),
(432684, 'PTHR47999:SF98', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 253671),
(432685, 'PTHR47999:SF10', NULL, NULL, NULL, NULL, 'MYB FAMILY PROTEIN', 253671),
(432686, 'PTHR47999:SF54', NULL, NULL, NULL, NULL, 'OS01G0874300 PROTEIN', 253671),
(432687, 'PTHR47999:SF99', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR MYB5-LIKE', 253671),
(432688, 'PTHR47999:SF96', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR MYB6-LIKE', 253671),
(432689, 'PTHR47999:SF97', NULL, NULL, NULL, NULL, 'BNAA08G29930D PROTEIN', 253671),
(432690, 'PTHR47999:SF50', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR MYB6-LIKE', 253671),
(432691, 'PTHR47999:SF94', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB90-LIKE', 253671),
(432692, 'PTHR47999:SF95', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 253671),
(432693, 'PTHR47999:SF16', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN 308-LIKE', 253671),
(432694, 'PTHR47999:SF17', NULL, NULL, NULL, NULL, 'MYB 12 TRANSCRIPTION FACTOR', 253671),
(432695, 'PTHR47999:SF58', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB047', 253671);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(432696, 'PTHR47999:SF14', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB63-LIKE', 253671),
(432697, 'PTHR47999:SF15', NULL, NULL, NULL, NULL, 'HTH MYB-TYPE DOMAIN-CONTAINING PROTEIN', 253671),
(432698, 'PTHR47999:SF59', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR WER-LIKE', 253671),
(432699, 'PTHR47999:SF60', NULL, NULL, NULL, NULL, 'BNAA09G03290D PROTEIN', 253671),
(432700, 'PTHR47999:SF89', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN MYB4', 253671),
(432701, 'PTHR47999:SF85', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN-RELATED', 253671),
(432702, 'PTHR47999:SF86', NULL, NULL, NULL, NULL, 'ANTHOCYANIN REGULATORY C1 PROTEIN-LIKE', 253671),
(432703, 'PTHR47999:SF40', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR ODORANT-D1', 253671),
(432704, 'PTHR47999:SF47', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN 308-LIKE', 253671),
(432705, 'PTHR47999:SF48', NULL, NULL, NULL, NULL, 'R2R3 MYB TRANSCRIPTIONAL FACTOR', 253671),
(432706, 'PTHR47999:SF93', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB113-RELATED', 253671),
(432707, 'PTHR47999:SF91', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB111', 253671),
(432708, 'PTHR47999:SF34', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 253671),
(432709, 'PTHR47999:SF78', NULL, NULL, NULL, NULL, '', 253671),
(432710, 'PTHR47999:SF35', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB8-RELATED', 253671),
(432711, 'PTHR47999:SF32', NULL, NULL, NULL, NULL, 'PROTEIN ODORANT1-LIKE', 253671),
(432712, 'PTHR47999:SF76', NULL, NULL, NULL, NULL, 'BNAA03G53110D PROTEIN', 253671),
(432713, 'PTHR47999:SF77', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR MYB5-LIKE', 253671),
(432714, 'PTHR47999:SF30', NULL, NULL, NULL, NULL, '', 253671),
(432715, 'PTHR47999:SF75', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB114-LIKE', 253671),
(432716, 'PTHR47999:SF73', NULL, NULL, NULL, NULL, 'BNAC03G60080D PROTEIN', 253671),
(432717, 'PTHR47999:SF110', NULL, NULL, NULL, NULL, 'OS01G0305900 PROTEIN', 253671),
(432718, 'PTHR47999:SF38', NULL, NULL, NULL, NULL, 'PROTEIN ODORANT1-LIKE', 253671),
(432719, 'PTHR47999:SF39', NULL, NULL, NULL, NULL, 'MYB8', 253671),
(432720, 'PTHR47999:SF82', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', 253671),
(432721, 'PTHR47999:SF80', NULL, NULL, NULL, NULL, 'MYB-RELATED PROTEIN MYB4-LIKE', 253671),
(432722, 'PTHR21085:SF2', NULL, NULL, NULL, NULL, 'CHORISMATE SYNTHASE', 253672),
(432723, 'PTHR21085:SF1', NULL, NULL, NULL, NULL, 'CHORISMATE SYNTHASE 1, CHLOROPLASTIC', 253672),
(432724, 'PTHR21085', NULL, NULL, NULL, NULL, 'CHORISMATE SYNTHASE', 253672),
(432725, 'PTHR21085:SF0', NULL, NULL, NULL, NULL, 'CHORISMATE SYNTHASE', 253672),
(432726, 'PTHR42101', NULL, NULL, NULL, NULL, 'CHROMOSOME 16, WHOLE GENOME SHOTGUN SEQUENCE', 253673),
(432727, 'PTHR42101:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 16, WHOLE GENOME SHOTGUN SEQUENCE', 253673),
(432728, 'PTHR34940:SF1', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II 5 KDA PROTEIN, CHLOROPLASTIC', 253674),
(432729, 'PTHR34940:SF6', NULL, NULL, NULL, NULL, 'BNAANNG17550D PROTEIN', 253674),
(432730, 'PTHR34940', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II 5 KDA PROTEIN, CHLOROPLASTIC', 253674),
(432731, 'PTHR34940:SF5', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II 5 KDA PROTEIN, CHLOROPLASTIC', 253674),
(432732, 'PTHR34940:SF4', NULL, NULL, NULL, NULL, 'OS02G0581100 PROTEIN', 253674),
(432733, 'PTHR34940:SF3', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II 5 KDA PROTEIN, CHLOROPLASTIC-LIKE', 253674),
(432734, 'PTHR42993', NULL, NULL, NULL, NULL, 'MAOC-LIKE DEHYDRATASE DOMAIN-CONTAINING PROTEIN', 253675),
(432735, 'PTHR42993:SF1', NULL, NULL, NULL, NULL, 'MAOC-LIKE DEHYDRATASE DOMAIN-CONTAINING PROTEIN', 253675),
(432736, 'PTHR21017', NULL, NULL, NULL, NULL, 'NIPSNAP-RELATED', 253676),
(432737, 'PTHR21017:SF14', NULL, NULL, NULL, NULL, 'PROTEIN NIPSNAP HOMOLOG 2', 253676),
(432738, 'PTHR21017:SF22', NULL, NULL, NULL, NULL, 'PROTEIN NIPSNAP HOMOLOG 3B', 253676),
(432739, 'PTHR21017:SF11', NULL, NULL, NULL, NULL, 'PROTEIN NIPSNAP HOMOLOG 1', 253676),
(432740, 'PTHR21017:SF12', NULL, NULL, NULL, NULL, 'NIPSNAP HOMOLOG 3A', 253676); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(432741, 'PTHR21017:SF23', NULL, NULL, NULL, NULL, 'PROTEIN NIPSNAP HOMOLOG 3A', 253676),
(432742, 'PTHR21017:SF17', NULL, NULL, NULL, NULL, 'PROTEIN NIPSNAP', 253676),
(432743, 'PTHR21017:SF18', NULL, NULL, NULL, NULL, 'PROTEIN NIPSNAP HOMOLOG 3B', 253676),
(432744, 'PTHR21017:SF19', NULL, NULL, NULL, NULL, 'NIPSNAP HOMOLOG 3A (C. ELEGANS)', 253676),
(432745, 'PTHR30579:SF3', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', 253677),
(432746, 'PTHR30579:SF2', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR ARGP', 253677),
(432747, 'PTHR30579', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR', 253677),
(432748, 'PTHR30579:SF7', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR LRHA-RELATED', 253677),
(432749, 'PTHR30579:SF8', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR HDFR', 253677),
(432750, 'PTHR30579:SF0', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL ACTIVATOR ALLS', 253677),
(432751, 'PTHR12187:SF4', NULL, NULL, NULL, NULL, 'INOSITOL POLYPHOSPHATE-4-PHOSPHATASE TYPE I A', 253678),
(432752, 'PTHR12187:SF11', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-3,4-BISPHOSPHATE 4-PHOSPHATASE', 253678),
(432753, 'PTHR12187:SF12', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-3,4-BISPHOSPHATE 4-PHOSPHATASE', 253678),
(432754, 'PTHR12187:SF3', NULL, NULL, NULL, NULL, 'INOSITOL POLYPHOSPHATE 4-PHOSPHATASE TYPE II', 253678),
(432755, 'PTHR12187', NULL, NULL, NULL, NULL, 'AGAP000124-PA', 253678),
(432756, 'PTHR38357:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 253679),
(432757, 'PTHR38357', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 253679),
(432758, 'PTHR46300:SF1', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 253680),
(432759, 'PTHR46300:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 MONOOXYGENASE ALNH-RELATED', 253680),
(432760, 'PTHR46300', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED-RELATED', 253680),
(432761, 'PTHR46300:SF5', NULL, NULL, NULL, NULL, '', 253680),
(432762, 'PTHR46300:SF4', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 98A3', 253680),
(432763, 'PTHR46300:SF7', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 253680),
(432764, 'PTHR46300:SF6', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 2C30', 253680),
(432765, 'PTHR46300:SF11', NULL, NULL, NULL, NULL, 'P450, PUTATIVE-RELATED', 253680),
(432766, 'PTHR46300:SF9', NULL, NULL, NULL, NULL, 'P450, PUTATIVE-RELATED', 253680),
(432767, 'PTHR46300:SF10', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', 253680),
(432768, 'PTHR46300:SF8', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 2E1', 253680),
(432769, 'PTHR13375:SF5', NULL, NULL, NULL, NULL, 'THO COMPLEX SUBUNIT 5A', 253681),
(432770, 'PTHR13375:SF6', NULL, NULL, NULL, NULL, '', 253681),
(432771, 'PTHR13375', NULL, NULL, NULL, NULL, 'FMS INTERACTING PROTEIN', 253681),
(432772, 'PTHR13375:SF3', NULL, NULL, NULL, NULL, 'THO COMPLEX SUBUNIT 5 HOMOLOG', 253681),
(432773, 'PTHR19944:SF99', NULL, NULL, NULL, NULL, 'HLA CLASS II HISTOCOMPATIBILITY ANTIGEN, DRB1 BETA CHAIN', 253682),
(432774, 'PTHR19944:SF44', NULL, NULL, NULL, NULL, 'HLA CLASS II HISTOCOMPATIBILITY ANTIGEN, DO ALPHA CHAIN', 253682),
(432775, 'PTHR19944:SF66', NULL, NULL, NULL, NULL, 'HISTOCOMPATIBILITY 2, CLASS II ANTIGEN E BETA2', 253682),
(432776, 'PTHR19944:SF65', NULL, NULL, NULL, NULL, 'HLA CLASS II HISTOCOMPATIBILITY ANTIGEN, DM BETA CHAIN', 253682),
(432777, 'PTHR19944:SF43', NULL, NULL, NULL, NULL, 'HLA CLASS II HISTOCOMPATIBILITY ANTIGEN, DO BETA CHAIN', 253682),
(432778, 'PTHR19944:SF87', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 253682),
(432779, 'PTHR19944:SF98', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 253682),
(432780, 'PTHR19944:SF97', NULL, NULL, NULL, NULL, 'HLA CLASS II HISTOCOMPATIBILITY ANTIGEN, DR BETA 5 CHAIN', 253682),
(432781, 'PTHR19944:SF86', NULL, NULL, NULL, NULL, 'HLA CLASS II HISTOCOMPATIBILITY ANTIGEN, DR ALPHA CHAIN-RELATED', 253682),
(432782, 'PTHR19944', NULL, NULL, NULL, NULL, 'MHC CLASS II-RELATED', 253682),
(432783, 'PTHR19944:SF64', NULL, NULL, NULL, NULL, 'HLA CLASS II HISTOCOMPATIBILITY ANTIGEN, DP ALPHA 1 CHAIN', 253682);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(432784, 'PTHR19944:SF59', NULL, NULL, NULL, NULL, 'HLA CLASS II HISTOCOMPATIBILITY ANTIGEN, DQ ALPHA 1 CHAIN', 253682),
(432785, 'PTHR19944:SF68', NULL, NULL, NULL, NULL, 'HLA CLASS II HISTOCOMPATIBILITY ANTIGEN, DQ BETA 2 CHAIN', 253682),
(432786, 'PTHR19944:SF46', NULL, NULL, NULL, NULL, 'HLA CLASS II HISTOCOMPATIBILITY ANTIGEN, DP BETA 1 CHAIN', 253682),
(432787, 'PTHR19944:SF102', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', 253682),
(432788, 'PTHR19944:SF91', NULL, NULL, NULL, NULL, 'IG EPSILON CHAIN C REGION', 253682),
(432789, 'PTHR19944:SF101', NULL, NULL, NULL, NULL, 'HLA CLASS II HISTOCOMPATIBILITY ANTIGEN, DQ BETA 1 CHAIN', 253682),
(432790, 'PTHR19944:SF84', NULL, NULL, NULL, NULL, 'HLA CLASS II HISTOCOMPATIBILITY ANTIGEN, DR BETA 3 CHAIN-RELATED', 253682),
(432791, 'PTHR19944:SF62', NULL, NULL, NULL, NULL, 'BETA-2-MICROGLOBULIN', 253682),
(432792, 'PTHR19944:SF50', NULL, NULL, NULL, NULL, 'HLA CLASS II HISTOCOMPATIBILITY ANTIGEN, DM ALPHA CHAIN', 253682),
(432793, 'PTHR19944:SF94', NULL, NULL, NULL, NULL, 'HLA CLASS II HISTOCOMPATIBILITY ANTIGEN, DQ ALPHA 2 CHAIN', 253682),
(432794, 'PTHR37723:SF1', NULL, NULL, NULL, NULL, 'PROTEIN FAR-RED-ELONGATED HYPOCOTYL 1-LIKE', 253683),
(432795, 'PTHR37723:SF4', NULL, NULL, NULL, NULL, 'PROTEIN FAR-RED ELONGATED HYPOCOTYL 1', 253683),
(432796, 'PTHR37723', NULL, NULL, NULL, NULL, 'PROTEIN FAR-RED ELONGATED HYPOCOTYL 1', 253683),
(432797, 'PTHR41536', NULL, NULL, NULL, NULL, 'PKHD-TYPE HYDROXYLASE YBIX', 253684),
(432798, 'PTHR41536:SF1', NULL, NULL, NULL, NULL, 'PKHD-TYPE HYDROXYLASE YBIX', 253684),
(432799, 'PTHR16099', NULL, NULL, NULL, NULL, '8-OXO-DGTP DIPHOSPHATES NUDT15', 253685),
(432800, 'PTHR16099:SF7', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', 253685),
(432801, 'PTHR16099:SF6', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-LIKE PROTEIN-RELATED', 253685),
(432802, 'PTHR16099:SF5', NULL, NULL, NULL, NULL, 'NUCLEOTIDE TRIPHOSPHATE DIPHOSPHATASE NUDT15', 253685),
(432803, 'PTHR10878', NULL, NULL, NULL, NULL, 'SEGMENT POLARITY PROTEIN DISHEVELLED', 253686),
(432804, 'PTHR10878:SF40', NULL, NULL, NULL, NULL, 'DISHEVELLED RELATED', 253686),
(432805, 'PTHR10878:SF22', NULL, NULL, NULL, NULL, 'DIXIN', 253686),
(432806, 'PTHR10878:SF8', NULL, NULL, NULL, NULL, 'SEGMENT POLARITY PROTEIN DISHEVELLED HOMOLOG DVL-2', 253686),
(432807, 'PTHR10878:SF5', NULL, NULL, NULL, NULL, 'SEGMENT POLARITY PROTEIN DISHEVELLED HOMOLOG DVL-1-RELATED', 253686),
(432808, 'PTHR10878:SF24', NULL, NULL, NULL, NULL, 'SEGMENT POLARITY PROTEIN DISHEVELLED HOMOLOG MIG-5', 253686),
(432809, 'PTHR10878:SF6', NULL, NULL, NULL, NULL, 'SEGMENT POLARITY PROTEIN DISHEVELLED HOMOLOG DVL-3', 253686),
(432810, 'PTHR10878:SF25', NULL, NULL, NULL, NULL, 'SEGMENT POLARITY PROTEIN DISHEVELLED', 253686),
(432811, 'PTHR10878:SF38', NULL, NULL, NULL, NULL, 'DIXIN-A', 253686),
(432812, 'PTHR10878:SF39', NULL, NULL, NULL, NULL, 'DIX DOMAIN-CONTAINING 1B', 253686),
(432813, 'PTHR46582:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 18', 253687),
(432814, 'PTHR46582', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 18', 253687),
(432815, 'PTHR12894:SF45', NULL, NULL, NULL, NULL, 'CORVET COMPLEX SUBUNIT', 253688),
(432816, 'PTHR12894:SF34', NULL, NULL, NULL, NULL, 'BETA RECEPTOR ASSOCIATED PROTEIN 1, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G14260)-RELATED', 253688),
(432817, 'PTHR12894:SF46', NULL, NULL, NULL, NULL, 'CNH DOMAIN-CONTAINING PROTEIN', 253688),
(432818, 'PTHR12894:SF43', NULL, NULL, NULL, NULL, 'VACUOLAR SORTING PROTEIN 3', 253688),
(432819, 'PTHR12894:SF44', NULL, NULL, NULL, NULL, 'CNH DOMAIN-CONTAINING PROTEIN', 253688),
(432820, 'PTHR12894:SF33', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN-CONTAINING PROTEIN', 253688),
(432821, 'PTHR12894:SF27', NULL, NULL, NULL, NULL, 'VAM6/VPS39-LIKE PROTEIN', 253688),
(432822, 'PTHR12894:SF38', NULL, NULL, NULL, NULL, 'CNH DOMAIN-CONTAINING PROTEIN', 253688),
(432823, 'PTHR12894:SF28', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 3', 253688);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(432824, 'PTHR12894:SF47', NULL, NULL, NULL, NULL, 'VACUOLAR MORPHOGENESIS PROTEIN 6', 253688),
(432825, 'PTHR12894:SF48', NULL, NULL, NULL, NULL, 'TRANSFORMING GROWTH FACTOR-BETA RECEPTOR-ASSOCIATED PROTEIN 1', 253688),
(432826, 'PTHR12894:SF30', NULL, NULL, NULL, NULL, 'SI:CH211-266G18.9', 253688),
(432827, 'PTHR12894', NULL, NULL, NULL, NULL, 'CNH DOMAIN CONTAINING', 253688),
(432828, 'PTHR12894:SF29', NULL, NULL, NULL, NULL, 'TRANSFORMING GROWTH FACTOR-BETA RECEPTOR-ASSOCIATED PROTEIN 1 HOMOLOG', 253688),
(432829, 'PTHR46950:SF7', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER CORA-LIKE FAMILY PROTEIN-RELATED', 253689),
(432830, 'PTHR46950:SF3', NULL, NULL, NULL, NULL, 'BNAA04G24710D PROTEIN', 253689),
(432831, 'PTHR46950:SF4', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER CORA FAMILY PROTEIN', 253689),
(432832, 'PTHR46950:SF10', NULL, NULL, NULL, NULL, 'OS01G0664100 PROTEIN', 253689),
(432833, 'PTHR46950:SF2', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER CORA-LIKE FAMILY PROTEIN', 253689),
(432834, 'PTHR46950', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER CORA-LIKE FAMILY PROTEIN', 253689),
(432835, 'PTHR46950:SF9', NULL, NULL, NULL, NULL, 'ZINC TRANSPORT PROTEIN ZNTB-LIKE ISOFORM X1', 253689),
(432836, 'PTHR37199:SF6', NULL, NULL, NULL, NULL, '', 253690),
(432837, 'PTHR37199', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 253690),
(432838, 'PTHR37199:SF5', NULL, NULL, NULL, NULL, 'MEMBRANE LIPOPROTEIN-RELATED', 253690),
(432839, 'PTHR37199:SF2', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', 253690),
(432840, 'PTHR22845', NULL, NULL, NULL, NULL, 'APOPTOTIC PROTEASE-ACTIVATING FACTOR 1', 253691),
(432841, 'PTHR22845:SF7', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN AFSR', 253691),
(432842, 'PTHR22845:SF5', NULL, NULL, NULL, NULL, 'APOPTOTIC PROTEASE-ACTIVATING FACTOR 1', 253691),
(432843, 'PTHR11764:SF70', NULL, NULL, NULL, NULL, 'BNAA05G18980D PROTEIN', 253692),
(432844, 'PTHR11764:SF84', NULL, NULL, NULL, NULL, 'TERPENE CYCLASE/MUTASE FAMILY MEMBER', 253692),
(432845, 'PTHR11764:SF85', NULL, NULL, NULL, NULL, 'TERPENE CYCLASE/MUTASE FAMILY MEMBER', 253692),
(432846, 'PTHR11764:SF82', NULL, NULL, NULL, NULL, 'TERPENE CYCLASE/MUTASE FAMILY MEMBER', 253692),
(432847, 'PTHR11764:SF61', NULL, NULL, NULL, NULL, 'TERPENE CYCLASE/MUTASE FAMILY MEMBER', 253692),
(432848, 'PTHR11764:SF83', NULL, NULL, NULL, NULL, 'TERPENE CYCLASE/MUTASE FAMILY MEMBER', 253692),
(432849, 'PTHR11764:SF44', NULL, NULL, NULL, NULL, 'LANOSTEROL SYNTHASE', 253692),
(432850, 'PTHR11764:SF66', NULL, NULL, NULL, NULL, 'TERPENE CYCLASE/MUTASE FAMILY MEMBER', 253692),
(432851, 'PTHR11764:SF88', NULL, NULL, NULL, NULL, 'ACHILLEOL B SYNTHASE', 253692),
(432852, 'PTHR11764:SF45', NULL, NULL, NULL, NULL, 'TERPENE CYCLASE/MUTASE FAMILY MEMBER', 253692),
(432853, 'PTHR11764:SF64', NULL, NULL, NULL, NULL, 'TERPENE CYCLASE/MUTASE FAMILY MEMBER', 253692),
(432854, 'PTHR11764:SF20', NULL, NULL, NULL, NULL, 'LANOSTEROL SYNTHASE', 253692),
(432855, 'PTHR11764:SF86', NULL, NULL, NULL, NULL, 'DELTA-AMYRIN SYNTHASE', 253692),
(432856, 'PTHR11764:SF87', NULL, NULL, NULL, NULL, 'LUPEOL SYNTHASE 1', 253692),
(432857, 'PTHR11764:SF65', NULL, NULL, NULL, NULL, 'TERPENE CYCLASE/MUTASE FAMILY MEMBER', 253692),
(432858, 'PTHR11764:SF48', NULL, NULL, NULL, NULL, 'TERPENE CYCLASE/MUTASE FAMILY MEMBER', 253692),
(432859, 'PTHR11764:SF49', NULL, NULL, NULL, NULL, 'ARABIDIOL SYNTHASE-RELATED', 253692),
(432860, 'PTHR11764:SF68', NULL, NULL, NULL, NULL, 'TERPENE CYCLASE/MUTASE FAMILY MEMBER', 253692),
(432861, 'PTHR11764:SF69', NULL, NULL, NULL, NULL, 'TERPENE CYCLASE/MUTASE FAMILY MEMBER', 253692),
(432862, 'PTHR11764:SF81', NULL, NULL, NULL, NULL, 'TERPENE CYCLASE/MUTASE FAMILY MEMBER', 253692),
(432863, 'PTHR11764:SF73', NULL, NULL, NULL, NULL, 'TERPENE CYCLASE/MUTASE FAMILY MEMBER', 253692),
(432864, 'PTHR11764:SF52', NULL, NULL, NULL, NULL, 'AMYRIN SYNTHASE LUP2-RELATED', 253692),
(432865, 'PTHR11764:SF71', NULL, NULL, NULL, NULL, 'TERPENE CYCLASE/MUTASE FAMILY MEMBER', 253692),
(432866, 'PTHR11764:SF77', NULL, NULL, NULL, NULL, 'TERPENE CYCLASE/MUTASE FAMILY MEMBER', 253692);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(432867, 'PTHR11764:SF55', NULL, NULL, NULL, NULL, 'TERPENE CYCLASE/MUTASE FAMILY MEMBER', 253692),
(432868, 'PTHR11764:SF76', NULL, NULL, NULL, NULL, 'TERPENE CYCLASE/MUTASE FAMILY MEMBER', 253692),
(432869, 'PTHR11764:SF37', NULL, NULL, NULL, NULL, 'PARKEOL SYNTHASE', 253692),
(432870, 'PTHR11764:SF59', NULL, NULL, NULL, NULL, 'TERPENE CYCLASE/MUTASE FAMILY MEMBER', 253692),
(432871, 'PTHR11764:SF38', NULL, NULL, NULL, NULL, 'TERPENE CYCLASE/MUTASE FAMILY MEMBER', 253692),
(432872, 'PTHR11764:SF57', NULL, NULL, NULL, NULL, 'TIRUCALLADIENOL SYNTHASE-RELATED', 253692),
(432873, 'PTHR11764', NULL, NULL, NULL, NULL, 'TERPENE CYCLASE/MUTASE FAMILY MEMBER', 253692),
(432874, 'PTHR11764:SF58', NULL, NULL, NULL, NULL, 'BETA-AMYRIN SYNTHASE-RELATED', 253692),
(432875, 'PTHR11764:SF14', NULL, NULL, NULL, NULL, 'TERPENE CYCLASE/MUTASE FAMILY MEMBER', 253692),
(432876, 'PTHR11764:SF19', NULL, NULL, NULL, NULL, 'TERPENE CYCLASE/MUTASE FAMILY MEMBER', 253692),
(432877, 'PTHR11764:SF17', NULL, NULL, NULL, NULL, 'TERPENE CYCLASE/MUTASE FAMILY MEMBER', 253692),
(432878, 'PTHR11764:SF39', NULL, NULL, NULL, NULL, 'TERPENE CYCLASE/MUTASE FAMILY MEMBER', 253692),
(432879, 'PTHR14303:SF2', NULL, NULL, NULL, NULL, 'OS08G0163300 PROTEIN', 253693),
(432880, 'PTHR14303:SF0', NULL, NULL, NULL, NULL, 'DNA POLYMERASE DELTA SUBUNIT 4', 253693),
(432881, 'PTHR14303', NULL, NULL, NULL, NULL, 'DNA POLYMERASE DELTA SUBUNIT 4', 253693),
(432882, 'PTHR14303:SF15', NULL, NULL, NULL, NULL, 'DELTA DNA POLYMERASE', 253693),
(432883, 'PTHR14303:SF16', NULL, NULL, NULL, NULL, '', 253693),
(432884, 'PTHR21524', NULL, NULL, NULL, NULL, 'SPECTRIN REPEAT CONTAINING NUCLEAR ENVELOPE PROTEIN 2', 253694),
(432885, 'PTHR21524:SF5', NULL, NULL, NULL, NULL, 'KLARSICHT, ISOFORM E', 253694),
(432886, 'PTHR30074:SF4', NULL, NULL, NULL, NULL, 'NI/FE-HYDROGENASE 2 B-TYPE CYTOCHROME SUBUNIT-RELATED', 253695),
(432887, 'PTHR30074:SF6', NULL, NULL, NULL, NULL, 'FORMATE DEHYDROGENASE GAMMA SUBUNIT', 253695),
(432888, 'PTHR30074:SF5', NULL, NULL, NULL, NULL, 'FORMATE DEHYDROGENASE, NITRATE-INDUCIBLE, CYTOCHROME B556(FDN) SUBUNIT', 253695),
(432889, 'PTHR30074:SF2', NULL, NULL, NULL, NULL, 'FORMATE DEHYDROGENASE, CYTOCHROME B556(FDO) SUBUNIT', 253695),
(432890, 'PTHR30074', NULL, NULL, NULL, NULL, 'FORMATE DEHYDROGENASE, NITRATE-INDUCIBLE, CYTOCHROME B556 FDN  SUBUNIT', 253695),
(432891, 'PTHR14845:SF0', NULL, NULL, NULL, NULL, 'DUF4515 DOMAIN-CONTAINING PROTEIN', 253696),
(432892, 'PTHR14845:SF3', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING 121', 253696),
(432893, 'PTHR14845:SF4', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 166', 253696),
(432894, 'PTHR14845', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING 166', 253696),
(432895, 'PTHR14845:SF7', NULL, NULL, NULL, NULL, 'GENE 6583-RELATED', 253696),
(432896, 'PTHR14845:SF8', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4930548H24 GENE', 253696),
(432897, 'PTHR14845:SF5', NULL, NULL, NULL, NULL, 'BASAL BODY-ORIENTATION FACTOR 1', 253696),
(432898, 'PTHR14845:SF6', NULL, NULL, NULL, NULL, '', 253696),
(432899, 'PTHR14845:SF9', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 121', 253696),
(432900, 'PTHR10257:SF93', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A 57 KDA REGULATORY SUBUNIT B'' EPSILON ISOFORM', 253697),
(432901, 'PTHR10257:SF94', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT', 253697),
(432902, 'PTHR10257:SF51', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT', 253697),
(432903, 'PTHR10257:SF96', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT', 253697),
(432904, 'PTHR10257:SF99', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT', 253697),
(432905, 'PTHR10257:SF55', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT', 253697),
(432906, 'PTHR10257:SF59', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A 57 KDA REGULATORY SUBUNIT B'' KAPPA ISOFORM', 253697);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(432907, 'PTHR10257:SF19', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 56 KDA REGULATORY SUBUNIT GAMMA ISOFORM', 253697),
(432908, 'PTHR10257:SF60', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A 55 KDA REGULATORY SUBUNIT B'' DELTA ISOFORM', 253697),
(432909, 'PTHR10257:SF6', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 56 KDA REGULATORY SUBUNIT ALPHA ISOFORM', 253697),
(432910, 'PTHR10257:SF62', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT', 253697),
(432911, 'PTHR10257:SF63', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT', 253697),
(432912, 'PTHR10257:SF64', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT', 253697),
(432913, 'PTHR10257:SF66', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A 59 KDA REGULATORY SUBUNIT B'' ETA ISOFORM', 253697),
(432914, 'PTHR10257:SF69', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT', 253697),
(432915, 'PTHR10257:SF28', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT', 253697),
(432916, 'PTHR10257', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A  PP2A  REGULATORY SUBUNIT B', 253697),
(432917, 'PTHR10257:SF3', NULL, NULL, NULL, NULL, 'WELL-ROUNDED, ISOFORM B', 253697),
(432918, 'PTHR10257:SF5', NULL, NULL, NULL, NULL, 'WIDERBORST, ISOFORM H', 253697),
(432919, 'PTHR10257:SF4', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 56 KDA REGULATORY SUBUNIT BETA ISOFORM', 253697),
(432920, 'PTHR10257:SF71', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A 57 KDA REGULATORY SUBUNIT B'' ALPHA ISOFORM', 253697),
(432921, 'PTHR10257:SF73', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A 57 KDA REGULATORY SUBUNIT B'' THETA ISOFORM', 253697),
(432922, 'PTHR10257:SF75', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT', 253697),
(432923, 'PTHR10257:SF31', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A 57 KDA REGULATORY SUBUNIT B'' KAPPA ISOFORM', 253697),
(432924, 'PTHR10257:SF76', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT', 253697),
(432925, 'PTHR10257:SF77', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT', 253697),
(432926, 'PTHR10257:SF102', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT', 253697),
(432927, 'PTHR10257:SF104', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT', 253697),
(432928, 'PTHR10257:SF103', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT', 253697),
(432929, 'PTHR10257:SF106', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT', 253697),
(432930, 'PTHR10257:SF107', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT', 253697),
(432931, 'PTHR10257:SF109', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT', 253697),
(432932, 'PTHR10257:SF80', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 56 KDA REGULATORY SUBUNIT EPSILON ISOFORM', 253697),
(432933, 'PTHR10257:SF82', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT', 253697),
(432934, 'PTHR10257:SF83', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT', 253697),
(432935, 'PTHR10257:SF84', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT', 253697),
(432936, 'PTHR10257:SF85', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT', 253697),
(432937, 'PTHR10257:SF86', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT', 253697),
(432938, 'PTHR10257:SF87', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT', 253697),
(432939, 'PTHR10257:SF88', NULL, NULL, NULL, NULL, 'BNACNNG54820D PROTEIN', 253697);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(432940, 'PTHR10257:SF89', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 56 KDA REGULATORY SUBUNIT DELTA ISOFORM', 253697),
(432941, 'PTHR10257:SF111', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT', 253697),
(432942, 'PTHR10257:SF110', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 56 KDA REGULATORY SUBUNIT DELTA 1 ISOFORM', 253697),
(432943, 'PTHR10257:SF113', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT', 253697),
(432944, 'PTHR10257:SF112', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT', 253697),
(432945, 'PTHR10257:SF115', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A 59 KDA REGULATORY SUBUNIT B'' GAMMA ISOFORM', 253697),
(432946, 'PTHR10257:SF114', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT', 253697),
(432947, 'PTHR10257:SF116', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A 57 KDA REGULATORY SUBUNIT B'' BETA ISOFORM', 253697),
(432948, 'PTHR10257:SF90', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT', 253697),
(432949, 'PTHR10257:SF92', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A 56 KDA REGULATORY SUBUNIT EPSILON ISOFORM', 253697),
(432950, 'PTHR12196', NULL, NULL, NULL, NULL, 'DOMAIN OF UNKNOWN FUNCTION 71  DUF71 -CONTAINING PROTEIN', 253698),
(432951, 'PTHR12196:SF2', NULL, NULL, NULL, NULL, 'DIPHTHINE--AMMONIA LIGASE', 253698),
(432952, 'PTHR45639:SF2', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 105 KDA', 253699),
(432953, 'PTHR45639:SF3', NULL, NULL, NULL, NULL, 'HYPOXIA UP-REGULATED PROTEIN 1', 253699),
(432954, 'PTHR45639', NULL, NULL, NULL, NULL, 'HSC70CB, ISOFORM G-RELATED', 253699),
(432955, 'PTHR45639:SF4', NULL, NULL, NULL, NULL, 'HSC70CB, ISOFORM G', 253699),
(432956, 'PTHR45639:SF5', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN 4L', 253699),
(432957, 'PTHR45639:SF6', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN 4', 253699),
(432958, 'PTHR45639:SF8', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN 4', 253699),
(432959, 'PTHR45639:SF9', NULL, NULL, NULL, NULL, 'PROTEIN CBG02604', 253699),
(432960, 'PTHR45639:SF30', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN 14', 253699),
(432961, 'PTHR45639:SF31', NULL, NULL, NULL, NULL, 'BNAC07G50110D PROTEIN', 253699),
(432962, 'PTHR45639:SF21', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN', 253699),
(432963, 'PTHR45639:SF32', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN PDR13', 253699),
(432964, 'PTHR45639:SF10', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN 16', 253699),
(432965, 'PTHR45639:SF15', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN 16', 253699),
(432966, 'PTHR45639:SF28', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', 253699),
(432967, 'PTHR45639:SF29', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN', 253699),
(432968, 'PTHR45639:SF18', NULL, NULL, NULL, NULL, 'BNAA06G00870D PROTEIN', 253699),
(432969, 'PTHR45639:SF23', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 70 FAMILY DOMAIN PROTEIN-RELATED', 253699),
(432970, 'PTHR45639:SF14', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN 17', 253699),
(432971, 'PTHR45639:SF25', NULL, NULL, NULL, NULL, 'RRNA N-GLYCOSIDASE', 253699),
(432972, 'PTHR38477:SF1', NULL, NULL, NULL, NULL, 'HYPOTHETICAL EXPORTED PROTEIN', 253700),
(432973, 'PTHR38477', NULL, NULL, NULL, NULL, 'HYPOTHETICAL EXPORTED PROTEIN', 253700),
(432974, 'PTHR10763:SF26', NULL, NULL, NULL, NULL, 'CELL DIVISION CONTROL PROTEIN 6 HOMOLOG', 253701),
(432975, 'PTHR10763', NULL, NULL, NULL, NULL, 'CELL DIVISION CONTROL PROTEIN 6-RELATED', 253701),
(432976, 'PTHR10763:SF31', NULL, NULL, NULL, NULL, 'ORC1-TYPE DNA REPLICATION PROTEIN 2', 253701),
(432977, 'PTHR10763:SF22', NULL, NULL, NULL, NULL, 'ORC1-TYPE DNA REPLICATION PROTEIN', 253701),
(432978, 'PTHR10763:SF23', NULL, NULL, NULL, NULL, 'ORIGIN RECOGNITION COMPLEX SUBUNIT 1', 253701),
(432979, 'PTHR43058:SF1', NULL, NULL, NULL, NULL, 'NTP_TRANSF_9 DOMAIN-CONTAINING PROTEIN', 253702); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(432980, 'PTHR43058', NULL, NULL, NULL, NULL, 'SLR0655 PROTEIN', 253702),
(432981, 'PTHR43151:SF2', NULL, NULL, NULL, NULL, 'FE(2+) TRANSPORT PROTEIN A-RELATED', 253703),
(432982, 'PTHR43151:SF1', NULL, NULL, NULL, NULL, 'SSR2333 PROTEIN', 253703),
(432983, 'PTHR43151', NULL, NULL, NULL, NULL, 'FEOA FAMILY PROTEIN', 253703),
(432984, 'PTHR45823', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 253704),
(432985, 'PTHR45823:SF1', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', 253704),
(432986, 'PTHR31655', NULL, NULL, NULL, NULL, '', 253705),
(432987, 'PTHR31655:SF0', NULL, NULL, NULL, NULL, 'PROTEIN FAM78B', 253705),
(432988, 'PTHR31655:SF3', NULL, NULL, NULL, NULL, 'PROTEIN FAM78A', 253705),
(432989, 'PTHR31655:SF4', NULL, NULL, NULL, NULL, 'FAMILY WITH SEQUENCE SIMILARITY 78 MEMBER BA', 253705),
(432990, 'PTHR31655:SF7', NULL, NULL, NULL, NULL, '', 253705),
(432991, 'PTHR39381', NULL, NULL, NULL, NULL, 'PROTEIN CBG14825-RELATED', 253706),
(432992, 'PTHR39381:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG14825', 253706),
(432993, 'PTHR39381:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG14824', 253706),
(432994, 'PTHR47309', NULL, NULL, NULL, NULL, 'T-CELL SURFACE GLYCOPROTEIN CD5', 253707),
(432995, 'PTHR47309:SF1', NULL, NULL, NULL, NULL, 'T-CELL SURFACE GLYCOPROTEIN CD5', 253707),
(432996, 'PTHR13513:SF10', NULL, NULL, NULL, NULL, 'UBR-TYPE DOMAIN-CONTAINING PROTEIN', 253708),
(432997, 'PTHR13513:SF11', NULL, NULL, NULL, NULL, 'UBIQUITIN PROTEIN LIGASE E3 COMPONENT N-RECOGNIN 7', 253708),
(432998, 'PTHR13513', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE UBR7', 253708),
(432999, 'PTHR13513:SF9', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE UBR7-RELATED', 253708),
(433000, 'PTHR10845:SF263', NULL, NULL, NULL, NULL, 'RGS DOMAIN-CONTAINING PROTEIN', 253709),
(433001, 'PTHR10845:SF187', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING 16', 253709),
(433002, 'PTHR10845:SF242', NULL, NULL, NULL, NULL, 'REGULATOR OF G PROTEIN-SIGNALING 3A', 253709),
(433003, 'PTHR10845:SF264', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING RGS-1', 253709),
(433004, 'PTHR10845:SF184', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING 4', 253709),
(433005, 'PTHR10845:SF160', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING 21', 253709),
(433006, 'PTHR10845:SF260', NULL, NULL, NULL, NULL, 'RGS DOMAIN-CONTAINING PROTEIN', 253709),
(433007, 'PTHR10845', NULL, NULL, NULL, NULL, 'REGULATOR OF G PROTEIN SIGNALING', 253709),
(433008, 'PTHR10845:SF43', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING 2', 253709),
(433009, 'PTHR10845:SF269', NULL, NULL, NULL, NULL, 'RGS DOMAIN-CONTAINING PROTEIN-RELATED', 253709),
(433010, 'PTHR10845:SF245', NULL, NULL, NULL, NULL, 'REGULATOR OF G PROTEIN-SIGNALING 16', 253709),
(433011, 'PTHR10845:SF267', NULL, NULL, NULL, NULL, 'REGULATOR OF G PROTEIN SIGNALING DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_6G06860)', 253709),
(433012, 'PTHR10845:SF268', NULL, NULL, NULL, NULL, 'RGS DOMAIN-CONTAINING PROTEIN', 253709),
(433013, 'PTHR10845:SF147', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING 8', 253709),
(433014, 'PTHR10845:SF265', NULL, NULL, NULL, NULL, 'REGULATOR OF G PROTEIN-SIGNALING 5B', 253709),
(433015, 'PTHR10845:SF145', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING 19', 253709),
(433016, 'PTHR10845:SF266', NULL, NULL, NULL, NULL, 'REGULATOR OF G PROTEIN-SIGNALING 20', 253709),
(433017, 'PTHR10845:SF274', NULL, NULL, NULL, NULL, 'SI:CH211-196H16.12', 253709),
(433018, 'PTHR10845:SF272', NULL, NULL, NULL, NULL, 'DOUBLE HIT, ISOFORM B', 253709),
(433019, 'PTHR10845:SF273', NULL, NULL, NULL, NULL, 'RGS DOMAIN-CONTAINING PROTEIN', 253709),
(433020, 'PTHR10845:SF251', NULL, NULL, NULL, NULL, 'RGS DOMAIN-CONTAINING PROTEIN', 253709),
(433021, 'PTHR10845:SF196', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING 17', 253709),
(433022, 'PTHR10845:SF270', NULL, NULL, NULL, NULL, 'RGS DOMAIN-CONTAINING PROTEIN', 253709),
(433023, 'PTHR10845:SF271', NULL, NULL, NULL, NULL, 'SI:CH211-117L17.6', 253709);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(433024, 'PTHR10845:SF192', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING 20', 253709),
(433025, 'PTHR10845:SF42', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING 5', 253709),
(433026, 'PTHR10845:SF34', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING 1', 253709),
(433027, 'PTHR10845:SF32', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING 13', 253709),
(433028, 'PTHR10845:SF258', NULL, NULL, NULL, NULL, 'NOVEL PROTEIN SIMILAR TO VERTEBRATE REGULATOR OF G-PROTEIN SIGNALLING FAMILY', 253709),
(433029, 'PTHR10845:SF259', NULL, NULL, NULL, NULL, 'RGS DOMAIN-CONTAINING PROTEIN-RELATED', 253709),
(433030, 'PTHR10845:SF235', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING RGS-3', 253709),
(433031, 'PTHR10845:SF254', NULL, NULL, NULL, NULL, 'RGS DOMAIN-CONTAINING PROTEIN', 253709),
(433032, 'PTHR10845:SF155', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING 18', 253709),
(433033, 'PTHR13149', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN VPS25', 253710),
(433034, 'PTHR13149:SF1', NULL, NULL, NULL, NULL, '', 253710),
(433035, 'PTHR13149:SF0', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN-SORTING-ASSOCIATED PROTEIN 25', 253710),
(433036, 'PTHR46854:SF1', NULL, NULL, NULL, NULL, '5''-ADENYLYLSULFATE REDUCTASE-LIKE 4-RELATED', 253711),
(433037, 'PTHR46854:SF3', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE FOLD PROTEIN-RELATED', 253711),
(433038, 'PTHR46854:SF2', NULL, NULL, NULL, NULL, '5''-ADENYLYLSULFATE REDUCTASE-LIKE 4', 253711),
(433039, 'PTHR46854', NULL, NULL, NULL, NULL, '5''-ADENYLYLSULFATE REDUCTASE-LIKE 4-RELATED', 253711),
(433040, 'PTHR46854:SF4', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN', 253711),
(433041, 'PTHR36038:SF2', NULL, NULL, NULL, NULL, '', 253712),
(433042, 'PTHR36038:SF3', NULL, NULL, NULL, NULL, 'OS06G0102750 PROTEIN', 253712),
(433043, 'PTHR36038', NULL, NULL, NULL, NULL, 'OS06G0102750 PROTEIN', 253712),
(433044, 'PTHR22443:SF14', NULL, NULL, NULL, NULL, 'KAT8 REGULATORY NSL COMPLEX SUBUNIT 1', 253713),
(433045, 'PTHR22443:SF18', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LETHAL 1, ISOFORM M', 253713),
(433046, 'PTHR22443:SF17', NULL, NULL, NULL, NULL, 'PEHE DOMAIN-CONTAINING PROTEIN', 253713),
(433047, 'PTHR22443:SF16', NULL, NULL, NULL, NULL, 'KAT8 REGULATORY NSL COMPLEX SUBUNIT 1-LIKE PROTEIN', 253713),
(433048, 'PTHR22443', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LETHAL 1, ISOFORM M', 253713),
(433049, 'PTHR35311:SF9', NULL, NULL, NULL, NULL, 'KINETOCHORE-ASSOCIATED PROTEIN KNL-2 HOMOLOG', 253714),
(433050, 'PTHR35311:SF6', NULL, NULL, NULL, NULL, 'OS04G0348000 PROTEIN', 253714),
(433051, 'PTHR35311', NULL, NULL, NULL, NULL, 'KINETOCHORE-ASSOCIATED PROTEIN KNL-2 HOMOLOG', 253714),
(433052, 'PTHR35311:SF1', NULL, NULL, NULL, NULL, 'PROTEIN EMBRYO DEFECTIVE 1674', 253714),
(433053, 'PTHR35311:SF10', NULL, NULL, NULL, NULL, 'OS04G0347900 PROTEIN', 253714),
(433054, 'PTHR35311:SF11', NULL, NULL, NULL, NULL, 'SANTA DOMAIN-CONTAINING PROTEIN', 253714),
(433055, 'PTHR10317', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT E', 253715),
(433056, 'PTHR10317:SF1', NULL, NULL, NULL, NULL, 'EIF3_N DOMAIN-CONTAINING PROTEIN', 253715),
(433057, 'PTHR10317:SF3', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT E', 253715),
(433058, 'PTHR10317:SF4', NULL, NULL, NULL, NULL, 'EIF3_N DOMAIN-CONTAINING PROTEIN', 253715),
(433059, 'PTHR10317:SF0', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT E', 253715),
(433060, 'PTHR22910', NULL, NULL, NULL, NULL, 'PROTEIN MGARP', 253716),
(433061, 'PTHR22910:SF6', NULL, NULL, NULL, NULL, 'PROTEIN MGARP', 253716),
(433062, 'PTHR23352', NULL, NULL, NULL, NULL, 'NEURAL PROLIFERATION DIFFERENTIATION AND CONTROL PROTEIN-1  NPDC-1 PROTEIN', 253717),
(433063, 'PTHR23352:SF2', NULL, NULL, NULL, NULL, 'NEURAL PROLIFERATION DIFFERENTIATION AND CONTROL PROTEIN 1', 253717),
(433064, 'PTHR11861:SF1', NULL, NULL, NULL, NULL, 'MELANOCYTE PROTEIN PMEL', 253718),
(433065, 'PTHR11861:SF10', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 130', 253718);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(433066, 'PTHR11861', NULL, NULL, NULL, NULL, 'MELANOCYTE PROTEIN PMEL 17-RELATED', 253718),
(433067, 'PTHR11861:SF8', NULL, NULL, NULL, NULL, '', 253718),
(433068, 'PTHR11861:SF11', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE GLYCOPROTEIN NMB', 253718),
(433069, 'PTHR11861:SF12', NULL, NULL, NULL, NULL, 'PREMELANOSOME PROTEIN B', 253718),
(433070, 'PTHR42886:SF29', NULL, NULL, NULL, NULL, 'PROTEIN ABHD8', 253719),
(433071, 'PTHR42886:SF49', NULL, NULL, NULL, NULL, 'BAAT/ACYL-COA THIOESTER HYDROLASE CARBOXY-TERMINAL PROTEIN', 253719),
(433072, 'PTHR42886:SF65', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN-RELATED', 253719),
(433073, 'PTHR42886:SF21', NULL, NULL, NULL, NULL, '(LYSO)-N-ACYLPHOSPHATIDYLETHANOLAMINE LIPASE', 253719),
(433074, 'PTHR42886:SF43', NULL, NULL, NULL, NULL, 'ABHYDROLASE DOMAIN-CONTAINING PROTEIN ABHD-5.1-RELATED', 253719),
(433075, 'PTHR42886:SF42', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 253719),
(433076, 'PTHR42886:SF64', NULL, NULL, NULL, NULL, 'HYDROLASE-RELATED', 253719),
(433077, 'PTHR42886:SF48', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 253719),
(433078, 'PTHR42886', NULL, NULL, NULL, NULL, 'RE40534P-RELATED', 253719),
(433079, 'PTHR42886:SF23', NULL, NULL, NULL, NULL, '1-ACYLGLYCEROL-3-PHOSPHATE O-ACYLTRANSFERASE ICT1-RELATED', 253719),
(433080, 'PTHR42886:SF72', NULL, NULL, NULL, NULL, 'HYDROLASE_4 DOMAIN-CONTAINING PROTEIN', 253719),
(433081, 'PTHR42886:SF73', NULL, NULL, NULL, NULL, '1-ACYLGLYCEROL-3-PHOSPHATE O-ACYLTRANSFERASE-RELATED', 253719),
(433082, 'PTHR42886:SF18', NULL, NULL, NULL, NULL, 'PIGMENT BIOSYNTHESIS PROTEIN AYG1', 253719),
(433083, 'PTHR42886:SF38', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 253719),
(433084, 'PTHR42886:SF76', NULL, NULL, NULL, NULL, 'CARBOXYMETHYLENEBUTENOLIDASE-RELATED PROTEIN', 253719),
(433085, 'PTHR42886:SF77', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN-RELATED', 253719),
(433086, 'PTHR42886:SF74', NULL, NULL, NULL, NULL, 'POSSIBLE NON-HEME HALOPEROXIDASE HPX', 253719),
(433087, 'PTHR42886:SF53', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', 253719),
(433088, 'PTHR42886:SF75', NULL, NULL, NULL, NULL, 'HYDROLASE-RELATED', 253719),
(433089, 'PTHR42886:SF36', NULL, NULL, NULL, NULL, 'OS01G0580000 PROTEIN', 253719),
(433090, 'PTHR42886:SF59', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 253719),
(433091, 'PTHR42886:SF78', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN', 253719),
(433092, 'PTHR42886:SF34', NULL, NULL, NULL, NULL, '1-ACYLGLYCEROL-3-PHOSPHATE O-ACYLTRANSFERASE ABHD5', 253719),
(433093, 'PTHR42886:SF79', NULL, NULL, NULL, NULL, 'CHLOROPLAST 30S RIBOSOMAL PROTEIN S10', 253719),
(433094, 'PTHR42886:SF80', NULL, NULL, NULL, NULL, 'ALPHA/BETA FOLD HYDROLASE', 253719),
(433095, 'PTHR42886:SF61', NULL, NULL, NULL, NULL, 'HYDROLASE', 253719),
(433096, 'PTHR40682', NULL, NULL, NULL, NULL, 'F5/8 TYPE C DOMAIN CONTAINING PROTEIN', 253720),
(433097, 'PTHR40682:SF1', NULL, NULL, NULL, NULL, 'F5/8 TYPE C DOMAIN CONTAINING PROTEIN', 253720),
(433098, 'PTHR34214:SF1', NULL, NULL, NULL, NULL, 'DUF1230 FAMILY PROTEIN', 253721),
(433099, 'PTHR34214', NULL, NULL, NULL, NULL, '', 253721),
(433100, 'PTHR34214:SF3', NULL, NULL, NULL, NULL, 'PROTEIN CONSERVED IN THE GREEN LINEAGE AND DIATOMS 27, CHLOROPLASTIC', 253721),
(433101, 'PTHR14122', NULL, NULL, NULL, NULL, 'GHRELIN PRECURSOR', 253722),
(433102, 'PTHR14122:SF1', NULL, NULL, NULL, NULL, 'APPETITE-REGULATING HORMONE', 253722),
(433103, 'PTHR36535:SF1', NULL, NULL, NULL, NULL, 'YALI0E30327P', 253723),
(433104, 'PTHR36535', NULL, NULL, NULL, NULL, 'YALI0E30327P', 253723),
(433105, 'PTHR44129', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN POP1', 253724),
(433106, 'PTHR44129:SF15', NULL, NULL, NULL, NULL, 'RIK1-ASSOCIATED FACTOR 1', 253724),
(433107, 'PTHR44129:SF1', NULL, NULL, NULL, NULL, 'LISSENCEPHALY-1 HOMOLOG A-RELATED', 253724),
(433108, 'PTHR44129:SF14', NULL, NULL, NULL, NULL, 'AGAP007816-PA', 253724);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(433109, 'PTHR44129:SF13', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN POP1', 253724),
(433110, 'PTHR44129:SF18', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 253724),
(433111, 'PTHR44129:SF3', NULL, NULL, NULL, NULL, 'WD REPEAT PROTEIN (AFU_ORTHOLOGUE AFUA_1G12380)', 253724),
(433112, 'PTHR44129:SF17', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN WDR-5.2-RELATED', 253724),
(433113, 'PTHR44129:SF4', NULL, NULL, NULL, NULL, 'F-BOX/WD REPEAT-CONTAINING PROTEIN 11', 253724),
(433114, 'PTHR44129:SF16', NULL, NULL, NULL, NULL, 'PLATELET-ACTIVATING FACTOR ACETYLHYDROLASE IB SUBUNIT BETA', 253724),
(433115, 'PTHR43640:SF1', NULL, NULL, NULL, NULL, 'THIOREDOXIN-DEPENDENT PEROXIREDOXIN', 253725),
(433116, 'PTHR43640', NULL, NULL, NULL, NULL, 'OS07G0260300 PROTEIN', 253725),
(433117, 'PTHR12765:SF5', NULL, NULL, NULL, NULL, 'PROTEIN RED', 253726),
(433118, 'PTHR12765:SF7', NULL, NULL, NULL, NULL, 'PROTEIN RED', 253726),
(433119, 'PTHR12765', NULL, NULL, NULL, NULL, 'RED PROTEIN  IK FACTOR   CYTOKINE IK', 253726),
(433120, 'PTHR12765:SF6', NULL, NULL, NULL, NULL, '', 253726),
(433121, 'PTHR32345:SF3', NULL, NULL, NULL, NULL, 'MYB-RELATED TRANSCRIPTION FACTOR, PARTNER OF PROFILIN', 253727),
(433122, 'PTHR32345', NULL, NULL, NULL, NULL, 'MYB-RELATED TRANSCRIPTION FACTOR, PARTNER OF PROFILIN', 253727),
(433123, 'PTHR21049', NULL, NULL, NULL, NULL, 'RIBOPHORIN I', 253728),
(433124, 'PTHR21049:SF0', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE SUBUNIT 1', 253728),
(433125, 'PTHR21049:SF4', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE SUBUNIT 1', 253728),
(433126, 'PTHR21049:SF2', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE SUBUNIT 1B', 253728),
(433127, 'PTHR34937:SF2', NULL, NULL, NULL, NULL, 'OS08G0559800 PROTEIN', 253729),
(433128, 'PTHR34937:SF1', NULL, NULL, NULL, NULL, 'PARAMYOSIN', 253729),
(433129, 'PTHR34937', NULL, NULL, NULL, NULL, 'OS08G0559800 PROTEIN', 253729),
(433130, 'PTHR34937:SF4', NULL, NULL, NULL, NULL, '', 253729),
(433131, 'PTHR10410:SF6', NULL, NULL, NULL, NULL, 'COP9 SIGNALOSOME COMPLEX SUBUNIT 5', 253730),
(433132, 'PTHR10410:SF5', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 14', 253730),
(433133, 'PTHR10410:SF3', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT H', 253730),
(433134, 'PTHR10410:SF2', NULL, NULL, NULL, NULL, 'LYS-63-SPECIFIC DEUBIQUITINASE BRCC36-RELATED', 253730),
(433135, 'PTHR10410:SF33', NULL, NULL, NULL, NULL, 'MPN DOMAIN-CONTAINING PROTEIN', 253730),
(433136, 'PTHR10410:SF32', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT H', 253730),
(433137, 'PTHR10410:SF31', NULL, NULL, NULL, NULL, 'LYS-63-SPECIFIC DEUBIQUITINASE', 253730),
(433138, 'PTHR10410:SF42', NULL, NULL, NULL, NULL, '26S PROTEASOME REGULATORY SUBUNIT RPN11', 253730),
(433139, 'PTHR10410:SF41', NULL, NULL, NULL, NULL, 'MPN DOMAIN-CONTAINING PROTEIN', 253730),
(433140, 'PTHR10410:SF40', NULL, NULL, NULL, NULL, '26S PROTEASOME REGULATORY SUBUNIT RPN11', 253730),
(433141, 'PTHR10410:SF7', NULL, NULL, NULL, NULL, 'PROTEIN CBG16582', 253730),
(433142, 'PTHR10410', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 -RELATED', 253730),
(433143, 'PTHR10410:SF39', NULL, NULL, NULL, NULL, 'DOMAIN-CONTAINING PROTEIN, PUTATIVE-RELATED', 253730),
(433144, 'PTHR10410:SF28', NULL, NULL, NULL, NULL, 'OS06G0703600 PROTEIN', 253730),
(433145, 'PTHR10410:SF38', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT H', 253730),
(433146, 'PTHR10410:SF37', NULL, NULL, NULL, NULL, '26S PROTEASOME REGULATORY SUBUNIT RPN11', 253730),
(433147, 'PTHR10410:SF25', NULL, NULL, NULL, NULL, '', 253730),
(433148, 'PTHR10410:SF34', NULL, NULL, NULL, NULL, 'LYS-63-SPECIFIC DEUBIQUITINASE BRCC36', 253730),
(433149, 'PTHR10410:SF23', NULL, NULL, NULL, NULL, '26S PROTEASOME REGULATORY SUBUNIT RPN11', 253730),
(433150, 'PTHR42997', NULL, NULL, NULL, NULL, 'HIT FAMILY HYDROLASE', 253731);
INSERT INTO "PUBLIC"."MODEL" VALUES
(433151, 'PTHR42997:SF1', NULL, NULL, NULL, NULL, 'AP-4-A PHOSPHORYLASE', 253731),
(433152, 'PTHR31974', NULL, NULL, NULL, NULL, 'BIOGENESIS OF LYSOSOME-RELATED ORGANELLES COMPLEX 1 SUBUNIT 3', 253732),
(433153, 'PTHR31974:SF2', NULL, NULL, NULL, NULL, 'BIOGENESIS OF LYSOSOME-RELATED ORGANELLES COMPLEX 1 SUBUNIT 3', 253732),
(433154, 'PTHR33921:SF16', NULL, NULL, NULL, NULL, 'CALVIN CYCLE PROTEIN CP12-3, CHLOROPLASTIC', 253733),
(433155, 'PTHR33921', NULL, NULL, NULL, NULL, 'CALVIN CYCLE PROTEIN CP12-2, CHLOROPLASTIC', 253733),
(433156, 'PTHR33921:SF18', NULL, NULL, NULL, NULL, 'CP12 DOMAIN-CONTAINING PROTEIN', 253733),
(433157, 'PTHR33921:SF19', NULL, NULL, NULL, NULL, 'CALVIN CYCLE PROTEIN CP12-2, CHLOROPLASTIC-LIKE', 253733),
(433158, 'PTHR33921:SF24', NULL, NULL, NULL, NULL, 'CP12 DOMAIN-CONTAINING PROTEIN', 253733),
(433159, 'PTHR33921:SF14', NULL, NULL, NULL, NULL, 'CALVIN CYCLE PROTEIN CP12-1, CHLOROPLASTIC', 253733),
(433160, 'PTHR33921:SF15', NULL, NULL, NULL, NULL, 'CALVIN CYCLE PROTEIN CP12-2, CHLOROPLASTIC', 253733),
(433161, 'PTHR33921:SF26', NULL, NULL, NULL, NULL, 'PUTATIVE, EXPRESSED-RELATED', 253733),
(433162, 'PTHR39683:SF4', NULL, NULL, NULL, NULL, 'POLYKETIDE_CYC DOMAIN-CONTAINING PROTEIN', 253734),
(433163, 'PTHR39683', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN TB16.3', 253734),
(433164, 'PTHR43595:SF1', NULL, NULL, NULL, NULL, '37S RIBOSOMAL PROTEIN MRP1, MITOCHONDRIAL', 253735),
(433165, 'PTHR43595:SF2', NULL, NULL, NULL, NULL, '37S RIBOSOMAL PROTEIN S26, MITOCHONDRIAL', 253735),
(433166, 'PTHR43595:SF3', NULL, NULL, NULL, NULL, '37S RIBOSOMAL PROTEIN S26A, MITOCHONDRIAL-RELATED', 253735),
(433167, 'PTHR43595', NULL, NULL, NULL, NULL, '37S RIBOSOMAL PROTEIN S26, MITOCHONDRIAL', 253735),
(433168, 'PTHR31668:SF4', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR PROTEIN DAL81', 253736),
(433169, 'PTHR31668:SF20', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 253736),
(433170, 'PTHR31668:SF9', NULL, NULL, NULL, NULL, 'URACIL CATABOLISM PROTEIN 2', 253736),
(433171, 'PTHR31668:SF17', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 253736),
(433172, 'PTHR31668:SF27', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 253736),
(433173, 'PTHR31668:SF26', NULL, NULL, NULL, NULL, 'GLUCOSE TRANSPORT TRANSCRIPTION REGULATOR RGT1-RELATED', 253736),
(433174, 'PTHR31668:SF25', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 253736),
(433175, 'PTHR31668:SF24', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, PUTATIVE-RELATED', 253736),
(433176, 'PTHR31668:SF23', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 253736),
(433177, 'PTHR31668', NULL, NULL, NULL, NULL, 'GLUCOSE TRANSPORT TRANSCRIPTION REGULATOR RGT1-RELATED-RELATED', 253736),
(433178, 'PTHR31668:SF10', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', 253736),
(433179, 'PTHR31668:SF19', NULL, NULL, NULL, NULL, 'ZN(2)-C6 FUNGAL-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', 253736),
(433180, 'PTHR31668:SF18', NULL, NULL, NULL, NULL, 'MALTOSE FERMENTATION REGULATORY PROTEIN MAL13-RELATED', 253736),
(433181, 'PTHR35987', NULL, NULL, NULL, NULL, 'PROTEIN PLASTID REDOX INSENSITIVE 2, CHLOROPLASTIC-RELATED', 253737),
(433182, 'PTHR35987:SF3', NULL, NULL, NULL, NULL, 'PROTEIN PLASTID REDOX INSENSITIVE 2, CHLOROPLASTIC-LIKE', 253737),
(433183, 'PTHR35987:SF2', NULL, NULL, NULL, NULL, 'PROTEIN PLASTID REDOX INSENSITIVE 2, CHLOROPLASTIC', 253737),
(433184, 'PTHR36739:SF1', NULL, NULL, NULL, NULL, 'D-TAGATOSE-1,6-BISPHOSPHATE ALDOLASE SUBUNIT', 253738),
(433185, 'PTHR36739', NULL, NULL, NULL, NULL, 'D-TAGATOSE-1,6-BISPHOSPHATE ALDOLASE SUBUNIT', 253738),
(433186, 'PTHR13872:SF43', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE SUBUNIT STT3A', 253739),
(433187, 'PTHR13872:SF44', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOTRANSFERASE', 253739),
(433188, 'PTHR13872:SF46', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOTRANSFERASE', 253739);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(433189, 'PTHR13872:SF47', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOTRANSFERASE', 253739),
(433190, 'PTHR13872:SF48', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE SUBUNIT STT3A', 253739),
(433191, 'PTHR13872:SF1', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE SUBUNIT STT3B', 253739),
(433192, 'PTHR13872', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE SUBUNIT', 253739),
(433193, 'PTHR13872:SF41', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOTRANSFERASE', 253739),
(433194, 'PTHR33767', NULL, NULL, NULL, NULL, '', 253740),
(433195, 'PTHR33767:SF3', NULL, NULL, NULL, NULL, '', 253740),
(433196, 'PTHR33767:SF2', NULL, NULL, NULL, NULL, 'LEUCINE RICH ADAPTOR PROTEIN 1', 253740),
(433197, 'PTHR33767:SF1', NULL, NULL, NULL, NULL, 'LEUCINE RICH ADAPTOR PROTEIN 1-LIKE', 253740),
(433198, 'PTHR46633:SF3', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE WNK (WITH NO LYSINE)-LIKE PROTEIN', 253741),
(433199, 'PTHR46633:SF6', NULL, NULL, NULL, NULL, 'BHLH-MYC_N DOMAIN-CONTAINING PROTEIN', 253741),
(433200, 'PTHR46633:SF2', NULL, NULL, NULL, NULL, 'OS06G0233800 PROTEIN', 253741),
(433201, 'PTHR46633:SF7', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYC/MYB DOMAIN-CONTAINING PROTEIN-RELATED', 253741),
(433202, 'PTHR46633:SF8', NULL, NULL, NULL, NULL, 'BHLH-MYC_N DOMAIN-CONTAINING PROTEIN', 253741),
(433203, 'PTHR46633:SF9', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYC/MYB-RELATED', 253741),
(433204, 'PTHR46633', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYC/MYB-RELATED', 253741),
(433205, 'PTHR31107', NULL, NULL, NULL, NULL, 'APOPTOGENIC PROTEIN 1, MITOCHONDRIAL', 253742),
(433206, 'PTHR31107:SF2', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY FACTOR 8', 253742),
(433207, 'PTHR34601', NULL, NULL, NULL, NULL, 'NEMATODE SPECIFIC PEPTIDE FAMILY, GROUP B', 253743),
(433208, 'PTHR34601:SF1', NULL, NULL, NULL, NULL, 'NEMATODE SPECIFIC PEPTIDE FAMILY, GROUP B', 253743),
(433209, 'PTHR31981:SF1', NULL, NULL, NULL, NULL, 'GLYCOSYLATED LYSOSOMAL MEMBRANE PROTEIN', 253744),
(433210, 'PTHR31981', NULL, NULL, NULL, NULL, 'GLYCOSYLATED LYSOSOMAL MEMBRANE PROTEIN', 253744),
(433211, 'PTHR36911', NULL, NULL, NULL, NULL, 'LIM ZINC-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 253745),
(433212, 'PTHR36911:SF1', NULL, NULL, NULL, NULL, 'CEREBELLAR DEGENERATION-RELATED ANTIGEN 1', 253745),
(433213, 'PTHR36911:SF3', NULL, NULL, NULL, NULL, 'GATA ZINC FINGER DOMAIN-CONTAINING PROTEIN 4', 253745),
(433214, 'PTHR34151', NULL, NULL, NULL, NULL, 'PROTEIN CBG24195', 253746),
(433215, 'PTHR34151:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG24195', 253746),
(433216, 'PTHR34151:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG19729', 253746),
(433217, 'PTHR19842:SF3', NULL, NULL, NULL, NULL, 'WD_REPEATS_REGION DOMAIN-CONTAINING PROTEIN', 253747),
(433218, 'PTHR19842', NULL, NULL, NULL, NULL, 'G BETA-LIKE PROTEIN GBL', 253747),
(433219, 'PTHR19842:SF2', NULL, NULL, NULL, NULL, 'WD REPEAT PROTEIN (AFU_ORTHOLOGUE AFUA_5G04300)', 253747),
(433220, 'PTHR19842:SF0', NULL, NULL, NULL, NULL, 'TARGET OF RAPAMYCIN COMPLEX SUBUNIT LST8', 253747),
(433221, 'PTHR42687:SF1', NULL, NULL, NULL, NULL, 'L-THREONINE 3-DEHYDROGENASE, MITOCHONDRIAL', 253748),
(433222, 'PTHR42687:SF4', NULL, NULL, NULL, NULL, 'L-THREONINE DEHYDROGENASE', 253748),
(433223, 'PTHR42687:SF5', NULL, NULL, NULL, NULL, 'L-THREONINE DEHYDROGENASE 2', 253748),
(433224, 'PTHR42687', NULL, NULL, NULL, NULL, 'L-THREONINE 3-DEHYDROGENASE', 253748),
(433225, 'PTHR45797:SF3', NULL, NULL, NULL, NULL, 'RAD54-LIKE', 253749),
(433226, 'PTHR45797:SF1', NULL, NULL, NULL, NULL, 'HELICASE ARIP4', 253749),
(433227, 'PTHR45797', NULL, NULL, NULL, NULL, 'RAD54-LIKE', 253749),
(433228, 'PTHR22669:SF15', NULL, NULL, NULL, NULL, 'DELTA-LIKE PROTEIN', 253750),
(433229, 'PTHR22669', NULL, NULL, NULL, NULL, 'DELTA/SERRATE/LAG-2 DOMAIN PROTEIN', 253750),
(433230, 'PTHR22669:SF16', NULL, NULL, NULL, NULL, 'CHONDROITIN PROTEOGLYCAN', 253750);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(433231, 'PTHR22669:SF8', NULL, NULL, NULL, NULL, 'PROTEIN LAG-2', 253750),
(433232, 'PTHR22669:SF10', NULL, NULL, NULL, NULL, 'DELTA-LIKE PROTEIN', 253750),
(433233, 'PTHR22669:SF1', NULL, NULL, NULL, NULL, 'DELTA-LIKE PROTEIN', 253750),
(433234, 'PTHR22669:SF17', NULL, NULL, NULL, NULL, 'PROTEIN CBG13578', 253750),
(433235, 'PTHR36970:SF1', NULL, NULL, NULL, NULL, '', 253751),
(433236, 'PTHR36970', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', 253751),
(433237, 'PTHR46141:SF1', NULL, NULL, NULL, NULL, 'SODIUM LEAK CHANNEL NON-SELECTIVE PROTEIN', 253752),
(433238, 'PTHR46141:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBR-NCA-1', 253752),
(433239, 'PTHR46141', NULL, NULL, NULL, NULL, 'SODIUM LEAK CHANNEL NON-SELECTIVE PROTEIN', 253752),
(433240, 'PTHR21393', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 28S RIBOSOMAL PROTEIN S27', 253753),
(433241, 'PTHR21393:SF0', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S27, MITOCHONDRIAL', 253753),
(433242, 'PTHR28286', NULL, NULL, NULL, NULL, '', 253754),
(433243, 'PTHR28286:SF2', NULL, NULL, NULL, NULL, 'BACTERIORHODOPSIN /OPSIN, NOPA (EUROFUNG)-RELATED', 253754),
(433244, 'PTHR28286:SF1', NULL, NULL, NULL, NULL, '30 KDA HEAT SHOCK PROTEIN-RELATED', 253754),
(433245, 'PTHR31587', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN (DUF2215)', 253755),
(433246, 'PTHR31587:SF3', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 253755),
(433247, 'PTHR31587:SF4', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN (DUF2215)', 253755),
(433248, 'PTHR31587:SF5', NULL, NULL, NULL, NULL, 'NEMP FAMILY, MAJOR FACILITATOR SUPERFAMILY DOMAIN PROTEIN-RELATED', 253755),
(433249, 'PTHR34524:SF12', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 253756),
(433250, 'PTHR34524:SF10', NULL, NULL, NULL, NULL, '', 253756),
(433251, 'PTHR34524', NULL, NULL, NULL, NULL, 'CALCYPHOSIN', 253756),
(433252, 'PTHR34524:SF11', NULL, NULL, NULL, NULL, 'CALCYPHOSINE-LIKE A', 253756),
(433253, 'PTHR34524:SF1', NULL, NULL, NULL, NULL, 'UPF0686 PROTEIN C11ORF1', 253756),
(433254, 'PTHR34524:SF2', NULL, NULL, NULL, NULL, 'CALCYPHOSIN', 253756),
(433255, 'PTHR34524:SF3', NULL, NULL, NULL, NULL, 'CALCYPHOSIN-2', 253756),
(433256, 'PTHR34524:SF5', NULL, NULL, NULL, NULL, 'CALCYPHOSIN-LIKE PROTEIN', 253756),
(433257, 'PTHR34524:SF6', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN P', 253756),
(433258, 'PTHR34524:SF8', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 253756),
(433259, 'PTHR34524:SF9', NULL, NULL, NULL, NULL, '', 253756),
(433260, 'PTHR21341', NULL, NULL, NULL, NULL, 'PROTAMINE-2', 253757),
(433261, 'PTHR21341:SF2', NULL, NULL, NULL, NULL, 'PROTAMINE-2', 253757),
(433262, 'PTHR48042:SF31', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 11-LIKE', 253758),
(433263, 'PTHR48042:SF30', NULL, NULL, NULL, NULL, 'ABC2_MEMBRANE DOMAIN-CONTAINING PROTEIN', 253758),
(433264, 'PTHR48042:SF19', NULL, NULL, NULL, NULL, 'OS09G0472100 PROTEIN', 253758),
(433265, 'PTHR48042:SF18', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 12', 253758),
(433266, 'PTHR48042:SF17', NULL, NULL, NULL, NULL, 'PLEIOTROPIC DRUG RESISTANCE PROTEIN PDR/CDR-RELATED', 253758),
(433267, 'PTHR48042:SF16', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 253758),
(433268, 'PTHR48042:SF15', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 13', 253758),
(433269, 'PTHR48042:SF14', NULL, NULL, NULL, NULL, 'WHITE-BROWN-COMPLEX ABC TRANSPORTER FAMILY PROTEIN', 253758),
(433270, 'PTHR48042:SF13', NULL, NULL, NULL, NULL, 'OS07G0288700 PROTEIN', 253758),
(433271, 'PTHR48042:SF12', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 3', 253758),
(433272, 'PTHR48042:SF11', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 11', 253758),
(433273, 'PTHR48042:SF33', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 11-LIKE ISOFORM X1', 253758),
(433274, 'PTHR48042:SF32', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 253758),
(433275, 'PTHR48042:SF1', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 253758),
(433276, 'PTHR48042:SF20', NULL, NULL, NULL, NULL, 'OS10G0163290 PROTEIN', 253758);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(433277, 'PTHR48042:SF2', NULL, NULL, NULL, NULL, 'TAURINE-TRANSPORTING ATPASE-RELATED', 253758),
(433278, 'PTHR48042:SF3', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 253758),
(433279, 'PTHR48042:SF4', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 253758),
(433280, 'PTHR48042:SF7', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, G1, P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE-RELATED', 253758),
(433281, 'PTHR48042:SF8', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 253758),
(433282, 'PTHR48042:SF9', NULL, NULL, NULL, NULL, 'ABC-2 TYPE TRANSPORTER FAMILY PROTEIN, EXPRESSED', 253758),
(433283, 'PTHR48042', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 11', 253758),
(433284, 'PTHR48042:SF29', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 15-RELATED', 253758),
(433285, 'PTHR48042:SF25', NULL, NULL, NULL, NULL, 'OS04G0528300 PROTEIN', 253758),
(433286, 'PTHR48042:SF24', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 3-LIKE', 253758),
(433287, 'PTHR48042:SF23', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', 253758),
(433288, 'PTHR48042:SF21', NULL, NULL, NULL, NULL, 'PLEIOTROPIC DRUG RESISTANCE PROTEIN PDR/CDR-RELATED', 253758),
(433289, 'PTHR39643:SF1', NULL, NULL, NULL, NULL, 'CCA-ADDING ENZYME', 253759),
(433290, 'PTHR39643', NULL, NULL, NULL, NULL, 'CCA-ADDING ENZYME', 253759),
(433291, 'PTHR36007:SF3', NULL, NULL, NULL, NULL, 'BNAA06G34080D PROTEIN', 253760),
(433292, 'PTHR36007:SF2', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN-RELATED', 253760),
(433293, 'PTHR36007', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN-RELATED', 253760),
(433294, 'PTHR12857', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 253761),
(433295, 'PTHR12857:SF0', NULL, NULL, NULL, NULL, 'CXXC MOTIF CONTAINING ZINC BINDING PROTEIN', 253761),
(433296, 'PTHR36288', NULL, NULL, NULL, NULL, 'SIMILAR TO RIKEN CDNA A930018P22', 253762),
(433297, 'PTHR36288:SF1', NULL, NULL, NULL, NULL, 'SIMILAR TO RIKEN CDNA A930018P22', 253762),
(433298, 'PTHR37773:SF1', NULL, NULL, NULL, NULL, '', 253763),
(433299, 'PTHR37773', NULL, NULL, NULL, NULL, '', 253763),
(433300, 'PTHR47836', NULL, NULL, NULL, NULL, 'PROTEIN CBG09520-RELATED', 253764),
(433301, 'PTHR47836:SF1', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_19_CAT DOMAIN-CONTAINING PROTEIN', 253764),
(433302, 'PTHR47836:SF2', NULL, NULL, NULL, NULL, 'GLYCO_HYDRO_19_CAT DOMAIN-CONTAINING PROTEIN', 253764),
(433303, 'PTHR22805', NULL, NULL, NULL, NULL, 'WDR41-RELATED', 253765),
(433304, 'PTHR22805:SF2', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 41', 253765),
(433305, 'PTHR42888:SF1', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L36, CHLOROPLASTIC', 253766),
(433306, 'PTHR42888', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L36, CHLOROPLASTIC', 253766),
(433307, 'PTHR24075', NULL, NULL, NULL, NULL, 'SEC63 DOMAIN-CONTAINING', 253767),
(433308, 'PTHR24075:SF11', NULL, NULL, NULL, NULL, 'DNAJ PROTEIN ERDJ2A-LIKE ISOFORM X1', 253767),
(433309, 'PTHR24075:SF10', NULL, NULL, NULL, NULL, 'DNAJ PROTEIN ERDJ2B', 253767),
(433310, 'PTHR24075:SF14', NULL, NULL, NULL, NULL, 'C2 DOMAIN, DNAJ DOMAIN, SEC63 DOMAIN, IMMUNOGLOBULIN E-SET-RELATED', 253767),
(433311, 'PTHR24075:SF0', NULL, NULL, NULL, NULL, 'TRANSLOCATION PROTEIN SEC63 HOMOLOG', 253767),
(433312, 'PTHR24075:SF13', NULL, NULL, NULL, NULL, 'U5 SMALL NUCLEAR RIBONUCLEOPROTEIN 200 KDA HELICASE', 253767),
(433313, 'PTHR24075:SF12', NULL, NULL, NULL, NULL, 'SEC63 DOMAIN-CONTAINING PROTEIN', 253767),
(433314, 'PTHR24075:SF6', NULL, NULL, NULL, NULL, 'ACTIVATING SIGNAL COINTEGRATOR 1 COMPLEX SUBUNIT 3', 253767),
(433315, 'PTHR24075:SF5', NULL, NULL, NULL, NULL, 'U5 SMALL NUCLEAR RIBONUCLEOPROTEIN 200 KDA HELICASE', 253767),
(433316, 'PTHR12875:SF2', NULL, NULL, NULL, NULL, 'BNAC03G74870D PROTEIN', 253768),
(433317, 'PTHR12875', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 253768),
(433318, 'PTHR12875:SF0', NULL, NULL, NULL, NULL, 'GOLGI TO ER TRAFFIC PROTEIN 4 HOMOLOG', 253768),
(433319, 'PTHR12875:SF1', NULL, NULL, NULL, NULL, 'GOLGI TO ER TRAFFIC PROTEIN 4 HOMOLOG ISOFORM X1', 253768);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(433320, 'PTHR47695:SF3', NULL, NULL, NULL, NULL, 'PID DOMAIN-CONTAINING PROTEIN', 253769),
(433321, 'PTHR47695', NULL, NULL, NULL, NULL, 'PID DOMAIN-CONTAINING PROTEIN', 253769),
(433322, 'PTHR47695:SF5', NULL, NULL, NULL, NULL, 'DISABLED HOMOLOG 2', 253769),
(433323, 'PTHR47695:SF4', NULL, NULL, NULL, NULL, 'DISABLED HOMOLOG 1', 253769),
(433324, 'PTHR37725', NULL, NULL, NULL, NULL, '', 253770),
(433325, 'PTHR37725:SF3', NULL, NULL, NULL, NULL, 'BNAC03G21620D PROTEIN', 253770),
(433326, 'PTHR37725:SF2', NULL, NULL, NULL, NULL, 'BNAA03G18120D PROTEIN', 253770),
(433327, 'PTHR37725:SF1', NULL, NULL, NULL, NULL, '', 253770),
(433328, 'PTHR43457', NULL, NULL, NULL, NULL, 'NITROGENASE MOLYBDENUM-IRON PROTEIN ALPHA CHAIN', 253771),
(433329, 'PTHR43457:SF1', NULL, NULL, NULL, NULL, 'NITROGENASE MOLYBDENUM-IRON PROTEIN ALPHA CHAIN', 253771),
(433330, 'PTHR35769', NULL, NULL, NULL, NULL, 'CALCINEURIN-LIKE METALLO-PHOSPHOESTERASE SUPERFAMILY PROTEIN', 253772),
(433331, 'PTHR35769:SF2', NULL, NULL, NULL, NULL, 'CALCINEURIN-LIKE METALLO-PHOSPHOESTERASE SUPERFAMILY PROTEIN', 253772),
(433332, 'PTHR36729', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 253773),
(433333, 'PTHR36729:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 253773),
(433334, 'PTHR12348:SF26', NULL, NULL, NULL, NULL, 'PROTEIN CBG15980', 253774),
(433335, 'PTHR12348:SF27', NULL, NULL, NULL, NULL, 'PROTEIN CBG20790', 253774),
(433336, 'PTHR12348', NULL, NULL, NULL, NULL, 'TSC22', 253774),
(433337, 'PTHR12348:SF30', NULL, NULL, NULL, NULL, 'PROTEIN CBG00127', 253774),
(433338, 'PTHR12348:SF23', NULL, NULL, NULL, NULL, 'TSC22 DOMAIN FAMILY PROTEIN 1', 253774),
(433339, 'PTHR12348:SF24', NULL, NULL, NULL, NULL, 'TSC22 DOMAIN FAMILY PROTEIN 3', 253774),
(433340, 'PTHR19920:SF2', NULL, NULL, NULL, NULL, 'CYTOSOLIC IRON-SULFUR PROTEIN ASSEMBLY PROTEIN CIAO1 HOMOLOG-RELATED', 253775),
(433341, 'PTHR19920:SF3', NULL, NULL, NULL, NULL, 'CYTOSOLIC IRON-SULFUR PROTEIN ASSEMBLY PROTEIN CIAO1 HOMOLOG-RELATED', 253775),
(433342, 'PTHR19920', NULL, NULL, NULL, NULL, 'WD40 PROTEIN CIAO1', 253775),
(433343, 'PTHR19920:SF0', NULL, NULL, NULL, NULL, 'CYTOSOLIC IRON-SULFUR PROTEIN ASSEMBLY PROTEIN CIAO1-RELATED', 253775),
(433344, 'PTHR38940:SF5', NULL, NULL, NULL, NULL, '', 253776),
(433345, 'PTHR38940:SF4', NULL, NULL, NULL, NULL, 'PLUS3 DOMAIN-CONTAINING PROTEIN', 253776),
(433346, 'PTHR38940', NULL, NULL, NULL, NULL, 'PLUS3 DOMAIN-CONTAINING PROTEIN', 253776),
(433347, 'PTHR21032:SF3', NULL, NULL, NULL, NULL, 'G PATCH DOMAIN-CONTAINING PROTEIN 11', 253777),
(433348, 'PTHR21032:SF4', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 75', 253777),
(433349, 'PTHR21032', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 253777),
(433350, 'PTHR21032:SF2', NULL, NULL, NULL, NULL, 'RESISTANCE PROTEIN ARS2, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G14710)-RELATED', 253777),
(433351, 'PTHR21032:SF0', NULL, NULL, NULL, NULL, 'G PATCH DOMAIN-CONTAINING PROTEIN 11', 253777),
(433352, 'PTHR22933', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 253778),
(433353, 'PTHR22933:SF18', NULL, NULL, NULL, NULL, 'CHITIN-BINDING TYPE-2 DOMAIN-CONTAINING PROTEIN', 253778),
(433354, 'PTHR22933:SF40', NULL, NULL, NULL, NULL, 'CUTICULAR PROTEIN ANALOGOUS TO PERITROPHINS 1-H', 253778),
(433355, 'PTHR22933:SF44', NULL, NULL, NULL, NULL, 'RE15157P', 253778),
(433356, 'PTHR22933:SF45', NULL, NULL, NULL, NULL, 'CPAP1-I', 253778),
(433357, 'PTHR22933:SF31', NULL, NULL, NULL, NULL, 'FI18007P1', 253778),
(433358, 'PTHR22933:SF42', NULL, NULL, NULL, NULL, 'CHITIN-BINDING TYPE-2 DOMAIN-CONTAINING PROTEIN-RELATED', 253778),
(433359, 'PTHR22933:SF32', NULL, NULL, NULL, NULL, 'MIND THE GAP, ISOFORM E', 253778),
(433360, 'PTHR22933:SF43', NULL, NULL, NULL, NULL, 'LP10131P', 253778),
(433361, 'PTHR45819:SF2', NULL, NULL, NULL, NULL, 'ARF-GAP WITH GTPASE, ANK REPEAT AND PH DOMAIN-CONTAINING PROTEIN 3', 253779),
(433362, 'PTHR45819:SF3', NULL, NULL, NULL, NULL, 'ARF-GAP WITH GTPASE, ANK REPEAT AND PH DOMAIN-CONTAINING PROTEIN 2', 253779),
(433363, 'PTHR45819:SF1', NULL, NULL, NULL, NULL, 'ARF-GAP WITH GTPASE, ANK REPEAT AND PH DOMAIN-CONTAINING PROTEIN 1', 253779);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(433364, 'PTHR45819', NULL, NULL, NULL, NULL, 'CENTAURIN-GAMMA-1A', 253779),
(433365, 'PTHR45819:SF7', NULL, NULL, NULL, NULL, 'ARF-GAP WITH GTPASE, ANK REPEAT AND PH DOMAIN-CONTAINING PROTEIN 4-RELATED', 253779),
(433366, 'PTHR45819:SF5', NULL, NULL, NULL, NULL, 'CENTAURIN-GAMMA-1A', 253779),
(433367, 'PTHR45819:SF8', NULL, NULL, NULL, NULL, 'ARF-GAP WITH GTPASE, ANK REPEAT AND PH DOMAIN-CONTAINING PROTEIN 11', 253779),
(433368, 'PTHR42749:SF4', NULL, NULL, NULL, NULL, 'CELL SHAPE-DETERMINING PROTEIN MBL', 253780),
(433369, 'PTHR42749:SF1', NULL, NULL, NULL, NULL, 'CELL SHAPE-DETERMINING PROTEIN MREB', 253780),
(433370, 'PTHR42749', NULL, NULL, NULL, NULL, 'CELL SHAPE-DETERMINING PROTEIN MREB', 253780),
(433371, 'PTHR42749:SF8', NULL, NULL, NULL, NULL, 'HSP70 FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_3G13740)', 253780),
(433372, 'PTHR10292:SF12', NULL, NULL, NULL, NULL, 'CLATHRIN HEAVY CHAIN', 253781),
(433373, 'PTHR10292:SF34', NULL, NULL, NULL, NULL, 'CLATHRIN HEAVY CHAIN 1-RELATED', 253781),
(433374, 'PTHR10292:SF35', NULL, NULL, NULL, NULL, 'CLATHRIN HEAVY CHAIN', 253781),
(433375, 'PTHR10292:SF25', NULL, NULL, NULL, NULL, 'CLATHRIN HEAVY CHAIN', 253781),
(433376, 'PTHR10292', NULL, NULL, NULL, NULL, 'CLATHRIN HEAVY CHAIN RELATED', 253781),
(433377, 'PTHR10292:SF36', NULL, NULL, NULL, NULL, 'CLATHRIN HEAVY CHAIN 1-LIKE', 253781),
(433378, 'PTHR10292:SF37', NULL, NULL, NULL, NULL, 'CLATHRIN HEAVY CHAIN', 253781),
(433379, 'PTHR10292:SF38', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', 253781),
(433380, 'PTHR10292:SF39', NULL, NULL, NULL, NULL, 'CLATHRIN, HEAVY CHAIN-RELATED', 253781),
(433381, 'PTHR10292:SF19', NULL, NULL, NULL, NULL, 'CLATHRIN HEAVY CHAIN', 253781),
(433382, 'PTHR10292:SF7', NULL, NULL, NULL, NULL, 'CLATHRIN HEAVY CHAIN 1', 253781),
(433383, 'PTHR10292:SF6', NULL, NULL, NULL, NULL, 'CLATHRIN HEAVY CHAIN 2', 253781),
(433384, 'PTHR10292:SF1', NULL, NULL, NULL, NULL, 'CLATHRIN HEAVY CHAIN', 253781),
(433385, 'PTHR10292:SF32', NULL, NULL, NULL, NULL, 'CLATHRIN HEAVY CHAIN 1-LIKE', 253781),
(433386, 'PTHR10292:SF11', NULL, NULL, NULL, NULL, 'CLATHRIN HEAVY CHAIN LINKER DOMAIN-CONTAINING PROTEIN 1', 253781),
(433387, 'PTHR10292:SF33', NULL, NULL, NULL, NULL, 'CLATHRIN HEAVY CHAIN', 253781),
(433388, 'PTHR36558:SF1', NULL, NULL, NULL, NULL, 'UMA2 DOMAIN-CONTAINING PROTEIN', 253782),
(433389, 'PTHR36558', NULL, NULL, NULL, NULL, 'GLR1098 PROTEIN', 253782),
(433390, 'PTHR38925', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 253783),
(433391, 'PTHR38925:SF1', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', 253783),
(433392, 'PTHR47808', NULL, NULL, NULL, NULL, 'INNER NUCLEAR MEMBRANE PROTEIN HEH2-RELATED', 253784),
(433393, 'PTHR47808:SF2', NULL, NULL, NULL, NULL, 'LEM DOMAIN-CONTAINING PROTEIN 2', 253784),
(433394, 'PTHR46379:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER MYND DOMAIN-CONTAINING PROTEIN 11', 253785),
(433395, 'PTHR46379', NULL, NULL, NULL, NULL, 'ZINC FINGER MYND DOMAIN-CONTAINING', 253785),
(433396, 'PTHR45876', NULL, NULL, NULL, NULL, 'FI04035P', 253786),
(433397, 'PTHR45876:SF11', NULL, NULL, NULL, NULL, 'MENTAL RETARDATION GTPASE ACTIVATING PROTEIN HOMOLOG 3-RELATED', 253786),
(433398, 'PTHR45876:SF6', NULL, NULL, NULL, NULL, 'SI:CH211-218G4.2', 253786),
(433399, 'PTHR45876:SF8', NULL, NULL, NULL, NULL, 'FI04035P', 253786),
(433400, 'PTHR45876:SF12', NULL, NULL, NULL, NULL, 'MENTAL RETARDATION GTPASE ACTIVATING PROTEIN HOMOLOG 4', 253786),
(433401, 'PTHR45876:SF7', NULL, NULL, NULL, NULL, 'MENTAL RETARDATION GTPASE ACTIVATING PROTEIN HOMOLOG 2', 253786),
(433402, 'PTHR45876:SF2', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN GACD', 253786),
(433403, 'PTHR45876:SF1', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 39', 253786),
(433404, 'PTHR45876:SF4', NULL, NULL, NULL, NULL, 'ZGC:92107', 253786),
(433405, 'PTHR46157:SF9', NULL, NULL, NULL, NULL, 'RCK N-TERMINAL DOMAIN-CONTAINING PROTEIN', 253787),
(433406, 'PTHR46157:SF8', NULL, NULL, NULL, NULL, 'GLUTATHIONE-REGULATED POTASSIUM-EFFLUX SYSTEM PROTEIN', 253787),
(433407, 'PTHR46157:SF7', NULL, NULL, NULL, NULL, 'RCK N-TERMINAL DOMAIN-CONTAINING PROTEIN', 253787);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(433408, 'PTHR46157:SF4', NULL, NULL, NULL, NULL, 'K(+) EFFLUX ANTIPORTER 3, CHLOROPLASTIC', 253787),
(433409, 'PTHR46157:SF3', NULL, NULL, NULL, NULL, 'GLUTATHIONE-REGULATED POTASSIUM-EFFLUX SYSTEM PROTEIN KEFC', 253787),
(433410, 'PTHR46157:SF2', NULL, NULL, NULL, NULL, 'K(+) EFFLUX ANTIPORTER 1, CHLOROPLASTIC-RELATED', 253787),
(433411, 'PTHR46157', NULL, NULL, NULL, NULL, 'K(+) EFFLUX ANTIPORTER 3, CHLOROPLASTIC', 253787),
(433412, 'PTHR46157:SF10', NULL, NULL, NULL, NULL, 'K+ EFFLUX ANTIPORTER 1-RELATED', 253787),
(433413, 'PTHR40202', NULL, NULL, NULL, NULL, '', 253788),
(433414, 'PTHR40202:SF1', NULL, NULL, NULL, NULL, 'HD_DOMAIN DOMAIN-CONTAINING PROTEIN', 253788),
(433415, 'PTHR33322:SF4', NULL, NULL, NULL, NULL, 'BAG DOMAIN CONTAINING PROTEIN, EXPRESSED', 253789),
(433416, 'PTHR33322:SF3', NULL, NULL, NULL, NULL, 'BAG FAMILY MOLECULAR CHAPERONE REGULATOR 7', 253789),
(433417, 'PTHR33322:SF17', NULL, NULL, NULL, NULL, 'BAG FAMILY MOLECULAR CHAPERONE REGULATOR 7', 253789),
(433418, 'PTHR33322:SF18', NULL, NULL, NULL, NULL, 'BAG FAMILY MOLECULAR CHAPERONE REGULATOR 8, CHLOROPLASTIC', 253789),
(433419, 'PTHR33322:SF16', NULL, NULL, NULL, NULL, 'BAG FAMILY MOLECULAR CHAPERONE REGULATOR 6', 253789),
(433420, 'PTHR33322:SF22', NULL, NULL, NULL, NULL, 'BAG DOMAIN-CONTAINING PROTEIN', 253789),
(433421, 'PTHR33322', NULL, NULL, NULL, NULL, 'BAG DOMAIN CONTAINING PROTEIN, EXPRESSED', 253789),
(433422, 'PTHR33322:SF8', NULL, NULL, NULL, NULL, 'BAG FAMILY MOLECULAR CHAPERONE REGULATOR 5, MITOCHONDRIAL', 253789),
(433423, 'PTHR30071:SF1', NULL, NULL, NULL, NULL, 'CYTOCHROME B/B6 PROTEIN-RELATED', 253790),
(433424, 'PTHR30071', NULL, NULL, NULL, NULL, 'HEME EXPORTER PROTEIN C', 253790),
(433425, 'PTHR30071:SF17', NULL, NULL, NULL, NULL, 'CYTOCHROME C ASSEMBLY PROTEIN-RELATED', 253790),
(433426, 'PTHR30071:SF15', NULL, NULL, NULL, NULL, 'PROTEIN HEMX', 253790),
(433427, 'PTHR47441', NULL, NULL, NULL, NULL, '', 253791),
(433428, 'PTHR47441:SF3', NULL, NULL, NULL, NULL, 'RELEASE FACTOR GLUTAMINE METHYLTRANSFERASE', 253791),
(433429, 'PTHR11245:SF1', NULL, NULL, NULL, NULL, 'STANNIOCALCIN-1', 253792),
(433430, 'PTHR11245', NULL, NULL, NULL, NULL, 'STANNIOCALCIN', 253792),
(433431, 'PTHR11245:SF2', NULL, NULL, NULL, NULL, 'STANNIOCALCIN-2', 253792),
(433432, 'PTHR11245:SF7', NULL, NULL, NULL, NULL, 'CORPUSCLES OF STANNIUS PROTEIN', 253792),
(433433, 'PTHR11245:SF6', NULL, NULL, NULL, NULL, 'STANNIOCALCIN PROTEIN-LIKE PROTEIN', 253792),
(433434, 'PTHR11792:SF22', NULL, NULL, NULL, NULL, 'BETA-ARRESTIN-1', 253793),
(433435, 'PTHR11792:SF20', NULL, NULL, NULL, NULL, 'BETA-ARRESTIN-2', 253793),
(433436, 'PTHR11792:SF15', NULL, NULL, NULL, NULL, 'S-ARRESTIN', 253793),
(433437, 'PTHR11792:SF24', NULL, NULL, NULL, NULL, 'ARRESTIN-C', 253793),
(433438, 'PTHR11792:SF23', NULL, NULL, NULL, NULL, 'PHOSRESTIN-1', 253793),
(433439, 'PTHR11792:SF19', NULL, NULL, NULL, NULL, 'ARRESTIN-C', 253793),
(433440, 'PTHR11792:SF18', NULL, NULL, NULL, NULL, 'FI20035P1', 253793),
(433441, 'PTHR11792:SF17', NULL, NULL, NULL, NULL, 'KURTZ ARRESTIN', 253793),
(433442, 'PTHR11792:SF16', NULL, NULL, NULL, NULL, 'PHOSRESTIN-2', 253793),
(433443, 'PTHR11792', NULL, NULL, NULL, NULL, 'ARRESTIN', 253793),
(433444, 'PTHR23222', NULL, NULL, NULL, NULL, 'PROHIBITIN', 253794),
(433445, 'PTHR23222:SF29', NULL, NULL, NULL, NULL, 'PROHIBITIN', 253794),
(433446, 'PTHR23222:SF17', NULL, NULL, NULL, NULL, 'PROHIBITIN-3, MITOCHONDRIAL-RELATED', 253794),
(433447, 'PTHR23222:SF39', NULL, NULL, NULL, NULL, 'PROHIBITIN', 253794),
(433448, 'PTHR23222:SF28', NULL, NULL, NULL, NULL, 'PROHIBITIN', 253794),
(433449, 'PTHR23222:SF23', NULL, NULL, NULL, NULL, 'PROHIBITIN', 253794),
(433450, 'PTHR23222:SF34', NULL, NULL, NULL, NULL, 'PROHIBITIN', 253794),
(433451, 'PTHR23222:SF21', NULL, NULL, NULL, NULL, 'PROHIBITIN', 253794),
(433452, 'PTHR23222:SF43', NULL, NULL, NULL, NULL, 'PROHIBITIN', 253794),
(433453, 'PTHR23222:SF0', NULL, NULL, NULL, NULL, 'PROHIBITIN', 253794),
(433454, 'PTHR23222:SF32', NULL, NULL, NULL, NULL, 'PROHIBITIN', 253794),
(433455, 'PTHR23222:SF42', NULL, NULL, NULL, NULL, 'PROHIBITIN', 253794);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(433456, 'PTHR23222:SF1', NULL, NULL, NULL, NULL, 'PROHIBITIN-2', 253794),
(433457, 'PTHR23222:SF20', NULL, NULL, NULL, NULL, 'PROHIBITIN-2, MITOCHONDRIAL-RELATED', 253794),
(433458, 'PTHR23222:SF16', NULL, NULL, NULL, NULL, 'PROHIBITIN', 253794),
(433459, 'PTHR23222:SF27', NULL, NULL, NULL, NULL, 'PROHIBITIN', 253794),
(433460, 'PTHR23222:SF37', NULL, NULL, NULL, NULL, 'PROHIBITIN', 253794),
(433461, 'PTHR23222:SF25', NULL, NULL, NULL, NULL, 'PROHIBITIN', 253794),
(433462, 'PTHR23222:SF13', NULL, NULL, NULL, NULL, 'PROHIBITIN', 253794),
(433463, 'PTHR23222:SF41', NULL, NULL, NULL, NULL, 'PROHIBITIN', 253794),
(433464, 'PTHR23222:SF3', NULL, NULL, NULL, NULL, 'PROHIBITIN', 253794),
(433465, 'PTHR23222:SF40', NULL, NULL, NULL, NULL, 'PROHIBITIN', 253794),
(433466, 'PTHR38572', NULL, NULL, NULL, NULL, 'BCDNA.GH07269-RELATED', 253795),
(433467, 'PTHR38572:SF1', NULL, NULL, NULL, NULL, 'BCDNA.GH07269-RELATED', 253795),
(433468, 'PTHR31285', NULL, NULL, NULL, NULL, 'NICOTINAMIDE MONONUCLEOTIDE ADENYLYLTRANSFERASE', 253796),
(433469, 'PTHR31285:SF0', NULL, NULL, NULL, NULL, 'NICOTINAMIDE MONONUCLEOTIDE ADENYLYLTRANSFERASE', 253796),
(433470, 'PTHR42188', NULL, NULL, NULL, NULL, '23S RRNA-SPECIFIC ENDONUCLEASE VAPC20', 253797),
(433471, 'PTHR42188:SF1', NULL, NULL, NULL, NULL, '23S RRNA-SPECIFIC ENDONUCLEASE VAPC20', 253797),
(433472, 'PTHR45818:SF1', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE EXCHANGE FACTOR VAV3', 253798),
(433473, 'PTHR45818:SF2', NULL, NULL, NULL, NULL, 'PROTO-ONCOGENE VAV', 253798),
(433474, 'PTHR45818:SF3', NULL, NULL, NULL, NULL, 'PROTEIN VAV', 253798),
(433475, 'PTHR45818:SF4', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE EXCHANGE FACTOR VAV2', 253798),
(433476, 'PTHR45818', NULL, NULL, NULL, NULL, 'PROTEIN VAV', 253798),
(433477, 'PTHR31053:SF2', NULL, NULL, NULL, NULL, 'MAGNESIUM-PROTOPORPHYRIN IX MONOMETHYL ESTER [OXIDATIVE] CYCLASE, CHLOROPLASTIC', 253799),
(433478, 'PTHR31053', NULL, NULL, NULL, NULL, 'MAGNESIUM-PROTOPORPHYRIN IX MONOMETHYL ESTER [OXIDATIVE] CYCLASE, CHLOROPLASTIC', 253799),
(433479, 'PTHR31053:SF4', NULL, NULL, NULL, NULL, 'S-ACYLTRANSFERASE', 253799),
(433480, 'PTHR12264:SF21', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 12', 253800),
(433481, 'PTHR12264:SF22', NULL, NULL, NULL, NULL, 'TFIID_20KDA DOMAIN-CONTAINING PROTEIN', 253800),
(433482, 'PTHR12264', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 12', 253800),
(433483, 'PTHR12264:SF23', NULL, NULL, NULL, NULL, 'TFIID_20KDA DOMAIN-CONTAINING PROTEIN', 253800),
(433484, 'PTHR12264:SF24', NULL, NULL, NULL, NULL, 'TFIID_20KDA DOMAIN-CONTAINING PROTEIN', 253800),
(433485, 'PTHR12264:SF25', NULL, NULL, NULL, NULL, 'TFIID_20KDA DOMAIN-CONTAINING PROTEIN', 253800),
(433486, 'PTHR34415:SF1', NULL, NULL, NULL, NULL, '', 253801),
(433487, 'PTHR34415', NULL, NULL, NULL, NULL, '', 253801),
(433488, 'PTHR36777:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 253802),
(433489, 'PTHR36777', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 253802),
(433490, 'PTHR15416:SF6', NULL, NULL, NULL, NULL, 'CAMP-DEPENDENT PROTEIN KINASE INHIBITOR BETA', 253803),
(433491, 'PTHR15416:SF7', NULL, NULL, NULL, NULL, 'SI:CH211-255I3.4-RELATED', 253803),
(433492, 'PTHR15416', NULL, NULL, NULL, NULL, 'CAMP-DEPENDENT PROTEIN KINASE INHIBITOR/PKI', 253803),
(433493, 'PTHR15416:SF5', NULL, NULL, NULL, NULL, 'CAMP-DEPENDENT PROTEIN KINASE INHIBITOR GAMMA', 253803),
(433494, 'PTHR15416:SF2', NULL, NULL, NULL, NULL, 'CAMP-DEPENDENT PROTEIN KINASE INHIBITOR ALPHA', 253803),
(433495, 'PTHR15416:SF3', NULL, NULL, NULL, NULL, 'AGAP001779-PB', 253803),
(433496, 'PTHR15416:SF10', NULL, NULL, NULL, NULL, 'CAMP-DEPENDENT PROTEIN KINASE INHIBITOR ALPHA', 253803),
(433497, 'PTHR11806:SF0', NULL, NULL, NULL, NULL, 'PROTEIN MTO1 HOMOLOG, MITOCHONDRIAL', 253804),
(433498, 'PTHR11806:SF2', NULL, NULL, NULL, NULL, 'METHYLENETETRAHYDROFOLATE--TRNA-(URACIL-5-)-METHYLTRANSFERASE TRMFO', 253804),
(433499, 'PTHR11806:SF3', NULL, NULL, NULL, NULL, 'GIDA_ASSOC DOMAIN-CONTAINING PROTEIN', 253804),
(433500, 'PTHR11806', NULL, NULL, NULL, NULL, 'GLUCOSE INHIBITED DIVISION PROTEIN A', 253804);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(433501, 'PTHR38426', NULL, NULL, NULL, NULL, 'MAINTENANCE OF TELOMERE CAPPING PROTEIN 4', 253805),
(433502, 'PTHR38426:SF1', NULL, NULL, NULL, NULL, 'MAINTENANCE OF TELOMERE CAPPING PROTEIN 4', 253805),
(433503, 'PTHR23195:SF27', NULL, NULL, NULL, NULL, 'ENL/AF9-RELATED, ISOFORM B', 253806),
(433504, 'PTHR23195:SF7', NULL, NULL, NULL, NULL, 'YEATS DOMAIN-CONTAINING PROTEIN 2', 253806),
(433505, 'PTHR23195:SF45', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 14', 253806),
(433506, 'PTHR23195', NULL, NULL, NULL, NULL, 'YEATS DOMAIN', 253806),
(433507, 'PTHR23195:SF47', NULL, NULL, NULL, NULL, 'GAS41-LIKE', 253806),
(433508, 'PTHR23195:SF15', NULL, NULL, NULL, NULL, 'YEATS DOMAIN-CONTAINING PROTEIN 4', 253806),
(433509, 'PTHR23195:SF2', NULL, NULL, NULL, NULL, 'SOMETHING ABOUT SILENCING PROTEIN 5-RELATED', 253806),
(433510, 'PTHR23195:SF43', NULL, NULL, NULL, NULL, '', 253806),
(433511, 'PTHR46381:SF3', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DDB_G0277071-RELATED', 253807),
(433512, 'PTHR46381', NULL, NULL, NULL, NULL, 'MKPA PROTEIN', 253807),
(433513, 'PTHR46381:SF4', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE-PHOSPHATASE MKP1', 253807),
(433514, 'PTHR46381:SF2', NULL, NULL, NULL, NULL, 'MKPA PROTEIN', 253807),
(433515, 'PTHR34644:SF2', NULL, NULL, NULL, NULL, 'SINGLE-PASS MEMBRANE AND COILED-COIL DOMAIN-CONTAINING PROTEIN 4', 253808),
(433516, 'PTHR34644', NULL, NULL, NULL, NULL, 'SINGLE-PASS MEMBRANE AND COILED-COIL DOMAIN-CONTAINING PROTEIN 4', 253808),
(433517, 'PTHR23010:SF1', NULL, NULL, NULL, NULL, 'MIDNOLIN', 253809),
(433518, 'PTHR23010', NULL, NULL, NULL, NULL, 'MIDNOLIN', 253809),
(433519, 'PTHR47134', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 11A', 253810),
(433520, 'PTHR47134:SF1', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 11A', 253810),
(433521, 'PTHR33018:SF27', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 253811),
(433522, 'PTHR33018:SF29', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DNA-BINDING DOMAIN PROTEIN', 253811),
(433523, 'PTHR33018', NULL, NULL, NULL, NULL, 'OS10G0338966 PROTEIN-RELATED', 253811),
(433524, 'PTHR33018:SF19', NULL, NULL, NULL, NULL, 'OS12G0558775 PROTEIN', 253811),
(433525, 'PTHR33018:SF30', NULL, NULL, NULL, NULL, 'OS02G0472350 PROTEIN', 253811),
(433526, 'PTHR33018:SF32', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 253811),
(433527, 'PTHR33018:SF31', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 253811),
(433528, 'PTHR33018:SF34', NULL, NULL, NULL, NULL, 'OS10G0338966 PROTEIN', 253811),
(433529, 'PTHR33018:SF22', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', 253811),
(433530, 'PTHR33018:SF33', NULL, NULL, NULL, NULL, 'OS04G0516275 PROTEIN', 253811),
(433531, 'PTHR33018:SF36', NULL, NULL, NULL, NULL, 'TRANSPOSASE, TNP1/EN/SPM-LIKE PROTEIN-RELATED', 253811),
(433532, 'PTHR33018:SF35', NULL, NULL, NULL, NULL, 'ULP1 PROTEASE FAMILY, C-TERMINAL CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', 253811),
(433533, 'PTHR45580:SF1', NULL, NULL, NULL, NULL, 'COESTERASE DOMAIN-CONTAINING PROTEIN', 253812),
(433534, 'PTHR45580:SF6', NULL, NULL, NULL, NULL, 'COESTERASE DOMAIN-CONTAINING PROTEIN-RELATED', 253812),
(433535, 'PTHR45580:SF4', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', 253812),
(433536, 'PTHR45580', NULL, NULL, NULL, NULL, 'PROTEIN CBG05369', 253812),
(433537, 'PTHR45580:SF9', NULL, NULL, NULL, NULL, 'COESTERASE DOMAIN-CONTAINING PROTEIN', 253812),
(433538, 'PTHR45580:SF8', NULL, NULL, NULL, NULL, 'COESTERASE DOMAIN-CONTAINING PROTEIN', 253812),
(433539, 'PTHR45580:SF7', NULL, NULL, NULL, NULL, 'COESTERASE DOMAIN-CONTAINING PROTEIN-RELATED', 253812),
(433540, 'PTHR46299:SF2', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR A DOMAIN-CONTAINING PROTEIN 5B2', 253813),
(433541, 'PTHR46299:SF1', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR A DOMAIN-CONTAINING PROTEIN 5B1', 253813),
(433542, 'PTHR46299', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR A DOMAIN-CONTAINING PROTEIN 5B2-RELATED', 253813);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(433543, 'PTHR46299:SF3', NULL, NULL, NULL, NULL, '', 253813),
(433544, 'PTHR42715:SF2', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE L-RELATED', 253814),
(433545, 'PTHR42715:SF3', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE B', 253814),
(433546, 'PTHR42715:SF5', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE M-RELATED', 253814),
(433547, 'PTHR42715', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE', 253814),
(433548, 'PTHR42715:SF13', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE K-RELATED', 253814),
(433549, 'PTHR42715:SF25', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE F-RELATED', 253814),
(433550, 'PTHR42715:SF14', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE D-RELATED', 253814),
(433551, 'PTHR42715:SF26', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 253814),
(433552, 'PTHR42715:SF16', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE J-RELATED', 253814),
(433553, 'PTHR42715:SF17', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE H-RELATED', 253814),
(433554, 'PTHR42715:SF19', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE G-RELATED', 253814),
(433555, 'PTHR42715:SF20', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE E-RELATED', 253814),
(433556, 'PTHR42715:SF10', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE-RELATED', 253814),
(433557, 'PTHR42715:SF12', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE A-RELATED', 253814),
(433558, 'PTHR35824', NULL, NULL, NULL, NULL, 'MEMBRANE-ANCHORED JUNCTION PROTEIN MAJIN', 253815),
(433559, 'PTHR35824:SF1', NULL, NULL, NULL, NULL, 'MEMBRANE-ANCHORED JUNCTION PROTEIN', 253815),
(433560, 'PTHR14225', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN C-III', 253816),
(433561, 'PTHR14225:SF0', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN C-III', 253816),
(433562, 'PTHR13056', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 253817),
(433563, 'PTHR13056:SF3', NULL, NULL, NULL, NULL, 'VACUOLAR FUSION PROTEIN CCZ1 HOMOLOG A', 253817),
(433564, 'PTHR13056:SF0', NULL, NULL, NULL, NULL, 'VACUOLAR FUSION PROTEIN CCZ1 HOMOLOG-RELATED', 253817),
(433565, 'PTHR34239', NULL, NULL, NULL, NULL, 'APPLE DOMAIN-CONTAINING PROTEIN', 253818),
(433566, 'PTHR34239:SF2', NULL, NULL, NULL, NULL, '', 253818),
(433567, 'PTHR30158:SF24', NULL, NULL, NULL, NULL, 'HLYD FAMILY SECRETION PROTEIN', 253819),
(433568, 'PTHR30158', NULL, NULL, NULL, NULL, 'ACRA/E-RELATED COMPONENT OF DRUG EFFLUX TRANSPORTER', 253819),
(433569, 'PTHR30158:SF25', NULL, NULL, NULL, NULL, 'CATION EFFLUX PUMP-RELATED', 253819),
(433570, 'PTHR30158:SF23', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN MEXA', 253819),
(433571, 'PTHR30158:SF21', NULL, NULL, NULL, NULL, 'MULTIDRUG EXPORT PROTEIN ACRE', 253819),
(433572, 'PTHR30158:SF10', NULL, NULL, NULL, NULL, 'HLYD FAMILY SECRETION PROTEIN', 253819),
(433573, 'PTHR30158:SF3', NULL, NULL, NULL, NULL, 'MULTIDRUG EFFLUX PUMP SUBUNIT ACRA-RELATED', 253819),
(433574, 'PTHR46665:SF13', NULL, NULL, NULL, NULL, 'OS02G0221100 PROTEIN', 253820),
(433575, 'PTHR46665:SF14', NULL, NULL, NULL, NULL, '', 253820),
(433576, 'PTHR46665:SF15', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH041-RELATED', 253820),
(433577, 'PTHR46665:SF8', NULL, NULL, NULL, NULL, 'OS05G0199800 PROTEIN', 253820),
(433578, 'PTHR46665:SF7', NULL, NULL, NULL, NULL, 'OS01G0773800 PROTEIN', 253820),
(433579, 'PTHR46665:SF6', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH92', 253820),
(433580, 'PTHR46665:SF5', NULL, NULL, NULL, NULL, 'HLH DNA-BINDING DOMAIN SUPERFAMILY PROTEIN-RELATED', 253820),
(433581, 'PTHR46665:SF4', NULL, NULL, NULL, NULL, 'OS01G0575200 PROTEIN', 253820),
(433582, 'PTHR46665', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH041-RELATED-RELATED', 253820),
(433583, 'PTHR46665:SF2', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTION FACTOR', 253820),
(433584, 'PTHR46665:SF1', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS- AND OOGENESIS-SPECIFIC BASIC HELIX-LOOP-HELIX-CONTAINING PROTEIN 1', 253820),
(433585, 'PTHR46665:SF10', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', 253820),
(433586, 'PTHR36701:SF1', NULL, NULL, NULL, NULL, 'EPOXYQUEUOSINE REDUCTASE QUEH', 253821),
(433587, 'PTHR36701', NULL, NULL, NULL, NULL, 'EPOXYQUEUOSINE REDUCTASE QUEH', 253821);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(433588, 'PTHR33933', NULL, NULL, NULL, NULL, 'NUCLEOTIDYLTRANSFERASE', 253822),
(433589, 'PTHR33933:SF2', NULL, NULL, NULL, NULL, 'PROTEIN ADENYLYLTRANSFERASE MJ0141-RELATED', 253822),
(433590, 'PTHR33933:SF1', NULL, NULL, NULL, NULL, 'PROTEIN ADENYLYLTRANSFERASE MNTA-RELATED', 253822),
(433591, 'PTHR35540', NULL, NULL, NULL, NULL, 'IZUMO SPERM-EGG FUSION PROTEIN 1', 253823),
(433592, 'PTHR35540:SF1', NULL, NULL, NULL, NULL, 'IZUMO SPERM-EGG FUSION PROTEIN 1', 253823),
(433593, 'PTHR48177', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 189', 253824),
(433594, 'PTHR48177:SF1', NULL, NULL, NULL, NULL, 'PLASMANYLETHANOLAMINE DESATURASE', 253824),
(433595, 'PTHR21051:SF4', NULL, NULL, NULL, NULL, 'CAMP-RESPONSIVE ELEMENT-BINDING PROTEIN-LIKE 2', 253825),
(433596, 'PTHR21051', NULL, NULL, NULL, NULL, 'CAMP-RESPONSIVE ELEMENT-BINDING PROTEIN-LIKE 2', 253825),
(433597, 'PTHR13139:SF6', NULL, NULL, NULL, NULL, 'ROQUIN-1', 253826),
(433598, 'PTHR13139', NULL, NULL, NULL, NULL, 'RING FINGER AND CCCH-TYPE ZINC FINGER DOMAIN-CONTAINING PROTEIN', 253826),
(433599, 'PTHR13139:SF54', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253826),
(433600, 'PTHR13139:SF2', NULL, NULL, NULL, NULL, 'ROQUIN-2', 253826),
(433601, 'PTHR23262:SF28', NULL, NULL, NULL, NULL, 'DOMAIN TRANSCRIPTION FACTOR AP2-O3, PUTATIVE-RELATED', 253827),
(433602, 'PTHR23262:SF233', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 10-12', 253827),
(433603, 'PTHR23262:SF234', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 1-1', 253827),
(433604, 'PTHR23262:SF235', NULL, NULL, NULL, NULL, 'GENE 11563-RELATED', 253827),
(433605, 'PTHR23262:SF236', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 1-4', 253827),
(433606, 'PTHR23262:SF230', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 5-1', 253827),
(433607, 'PTHR23262:SF231', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 5-6', 253827),
(433608, 'PTHR23262:SF232', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 4-6', 253827),
(433609, 'PTHR23262:SF199', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 2-1-RELATED', 253827),
(433610, 'PTHR23262:SF27', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 31-1-RELATED', 253827),
(433611, 'PTHR23262:SF237', NULL, NULL, NULL, NULL, '', 253827),
(433612, 'PTHR23262:SF238', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 13-1-RELATED', 253827),
(433613, 'PTHR23262:SF239', NULL, NULL, NULL, NULL, 'KERATIN ASSOCIATED PROTEIN 15-1', 253827),
(433614, 'PTHR23262:SF67', NULL, NULL, NULL, NULL, 'HCG2042992-RELATED', 253827),
(433615, 'PTHR23262:SF145', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 1-3', 253827),
(433616, 'PTHR23262:SF148', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 12-3', 253827),
(433617, 'PTHR23262:SF186', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 1-3-RELATED', 253827),
(433618, 'PTHR23262:SF220', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 9-5', 253827),
(433619, 'PTHR23262:SF221', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 9-1', 253827),
(433620, 'PTHR23262:SF188', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 5-2-RELATED', 253827),
(433621, 'PTHR23262:SF226', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 5-7', 253827),
(433622, 'PTHR23262:SF149', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 10-8', 253827),
(433623, 'PTHR23262:SF227', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 10-7', 253827),
(433624, 'PTHR23262:SF91', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 29-1', 253827),
(433625, 'PTHR23262:SF193', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 1-5', 253827),
(433626, 'PTHR23262:SF55', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 16-1', 253827),
(433627, 'PTHR23262:SF195', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 1-5', 253827),
(433628, 'PTHR23262:SF50', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 10-6', 253827),
(433629, 'PTHR23262:SF134', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 5-11', 253827),
(433630, 'PTHR23262:SF212', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 5-8', 253827);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(433631, 'PTHR23262:SF131', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 5-9', 253827),
(433632, 'PTHR23262:SF175', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 10-3', 253827),
(433633, 'PTHR23262:SF210', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 9-3', 253827),
(433634, 'PTHR23262:SF133', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 9-6-RELATED', 253827),
(433635, 'PTHR23262:SF219', NULL, NULL, NULL, NULL, 'HCG2042993-RELATED', 253827),
(433636, 'PTHR23262:SF8', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 10-2', 253827),
(433637, 'PTHR23262:SF217', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 1-4', 253827),
(433638, 'PTHR23262:SF7', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 2-4', 253827),
(433639, 'PTHR23262:SF218', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 5-10-RELATED', 253827),
(433640, 'PTHR23262:SF182', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 4-2', 253827),
(433641, 'PTHR23262:SF183', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 4-11-RELATED', 253827),
(433642, 'PTHR23262:SF184', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 10-10', 253827),
(433643, 'PTHR23262:SF180', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 12-1-RELATED', 253827),
(433644, 'PTHR23262:SF244', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 4-3', 253827),
(433645, 'PTHR23262:SF200', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 4-1-RELATED', 253827),
(433646, 'PTHR23262:SF201', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 4-4', 253827),
(433647, 'PTHR23262:SF245', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 26-1', 253827),
(433648, 'PTHR23262:SF202', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 5-3', 253827),
(433649, 'PTHR23262:SF125', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 10-11', 253827),
(433650, 'PTHR23262:SF203', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 4-9', 253827),
(433651, 'PTHR23262:SF240', NULL, NULL, NULL, NULL, 'KERATIN ASSOCIATED PROTEIN 9-7', 253827),
(433652, 'PTHR23262:SF241', NULL, NULL, NULL, NULL, 'GENE 11567-RELATED', 253827),
(433653, 'PTHR23262:SF242', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 5-4', 253827),
(433654, 'PTHR23262:SF243', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 10-4', 253827),
(433655, 'PTHR23262:SF208', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 4-1', 253827),
(433656, 'PTHR23262:SF127', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 5-1', 253827),
(433657, 'PTHR23262:SF206', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 10-1-RELATED', 253827),
(433658, 'PTHR23262', NULL, NULL, NULL, NULL, 'KERATIN ASSOCIATED PROTEIN', 253827),
(433659, 'PTHR23262:SF170', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 10-9', 253827),
(433660, 'PTHR23262:SF32', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 9-2-RELATED', 253827),
(433661, 'PTHR23262:SF173', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 5-5', 253827),
(433662, 'PTHR23262:SF71', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 4-5', 253827),
(433663, 'PTHR42256', NULL, NULL, NULL, NULL, 'OXOGLUTARATE/IRON-DEPENDENT DIOXYGENASE', 253828),
(433664, 'PTHR42256:SF1', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', 253828),
(433665, 'PTHR43982:SF5', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXY TERMINAL HYDROLASE UBP2', 253829),
(433666, 'PTHR43982:SF3', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 253829),
(433667, 'PTHR43982:SF1', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE 14', 253829),
(433668, 'PTHR43982:SF2', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 253829),
(433669, 'PTHR43982', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', 253829),
(433670, 'PTHR37019:SF1', NULL, NULL, NULL, NULL, '', 253830),
(433671, 'PTHR37019:SF2', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 253830),
(433672, 'PTHR37019', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', 253830),
(433673, 'PTHR41683', NULL, NULL, NULL, NULL, 'MUCIN-7', 253831);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(433674, 'PTHR41683:SF1', NULL, NULL, NULL, NULL, 'MUCIN-7', 253831),
(433675, 'PTHR35087:SF1', NULL, NULL, NULL, NULL, 'SIMILAR TO HYPOTHETICAL PROTEIN FLJ40298', 253832),
(433676, 'PTHR35087', NULL, NULL, NULL, NULL, 'SIMILAR TO HYPOTHETICAL PROTEIN FLJ40298', 253832),
(433677, 'PTHR46388:SF2', NULL, NULL, NULL, NULL, 'NHL REPEAT-CONTAINING PROTEIN 2', 253833),
(433678, 'PTHR46388', NULL, NULL, NULL, NULL, 'NHL REPEAT-CONTAINING PROTEIN 2', 253833),
(433679, 'PTHR10411:SF8', NULL, NULL, NULL, NULL, 'FI09246P', 253834),
(433680, 'PTHR10411:SF9', NULL, NULL, NULL, NULL, 'GROWTH ARREST AND DNA-DAMAGE-INDUCIBLE, GAMMA B, TANDEM DUPLICATE 1', 253834),
(433681, 'PTHR10411:SF4', NULL, NULL, NULL, NULL, 'GROWTH ARREST AND DNA DAMAGE-INDUCIBLE PROTEIN GADD45 GAMMA', 253834),
(433682, 'PTHR10411:SF5', NULL, NULL, NULL, NULL, 'GROWTH ARREST AND DNA DAMAGE-INDUCIBLE PROTEIN GADD45 BETA', 253834),
(433683, 'PTHR10411', NULL, NULL, NULL, NULL, 'GROWTH ARREST AND DNA DAMAGE-INDUCIBLE PROTEIN GADD45', 253834),
(433684, 'PTHR10411:SF3', NULL, NULL, NULL, NULL, 'GROWTH ARREST AND DNA DAMAGE-INDUCIBLE PROTEIN GADD45 ALPHA', 253834),
(433685, 'PTHR47245:SF1', NULL, NULL, NULL, NULL, 'FOLDASE PROTEIN PRSA', 253835),
(433686, 'PTHR47245:SF2', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE HP_0175-RELATED', 253835),
(433687, 'PTHR47245', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', 253835),
(433688, 'PTHR47291', NULL, NULL, NULL, NULL, 'PEPTIDE UPSTREAM PROTEIN', 253836),
(433689, 'PTHR47291:SF4', NULL, NULL, NULL, NULL, 'UPSTREAM ORF PROTEIN, PUTATIVE-RELATED', 253836),
(433690, 'PTHR47291:SF1', NULL, NULL, NULL, NULL, 'PEPTIDE UPSTREAM PROTEIN', 253836),
(433691, 'PTHR23238:SF3', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN EWS', 253837),
(433692, 'PTHR23238', NULL, NULL, NULL, NULL, 'RNA BINDING PROTEIN', 253837),
(433693, 'PTHR23238:SF28', NULL, NULL, NULL, NULL, '', 253837),
(433694, 'PTHR23238:SF26', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN-LIKE PROTEIN', 253837),
(433695, 'PTHR23238:SF25', NULL, NULL, NULL, NULL, 'TATA-BINDING PROTEIN-ASSOCIATED FACTOR 2N', 253837),
(433696, 'PTHR23238:SF31', NULL, NULL, NULL, NULL, 'GH13594P-RELATED', 253837),
(433697, 'PTHR23238:SF5', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN FUS', 253837),
(433698, 'PTHR46114:SF1', NULL, NULL, NULL, NULL, 'APPLE DOMAIN-CONTAINING PROTEIN', 253838),
(433699, 'PTHR46114', NULL, NULL, NULL, NULL, 'APPLE DOMAIN-CONTAINING PROTEIN', 253838),
(433700, 'PTHR34466:SF3', NULL, NULL, NULL, NULL, 'OS11G0129800 PROTEIN', 253839),
(433701, 'PTHR34466:SF1', NULL, NULL, NULL, NULL, 'HD-ZIP_N DOMAIN-CONTAINING PROTEIN', 253839),
(433702, 'PTHR34466', NULL, NULL, NULL, NULL, 'OS11G0129800 PROTEIN', 253839),
(433703, 'PTHR46026:SF1', NULL, NULL, NULL, NULL, 'RHO-TYPE GUANINE NUCLEOTIDE EXCHANGE FACTOR, ISOFORM F', 253840),
(433704, 'PTHR46026:SF2', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 6', 253840),
(433705, 'PTHR46026:SF3', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 7', 253840),
(433706, 'PTHR46026:SF4', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', 253840),
(433707, 'PTHR46026', NULL, NULL, NULL, NULL, 'RHO-TYPE GUANINE NUCLEOTIDE EXCHANGE FACTOR, ISOFORM F', 253840),
(433708, 'PTHR48103:SF2', NULL, NULL, NULL, NULL, 'MIDASIN', 253841),
(433709, 'PTHR48103', NULL, NULL, NULL, NULL, 'MIDASIN-RELATED', 253841),
(433710, 'PTHR48103:SF3', NULL, NULL, NULL, NULL, '', 253841),
(433711, 'PTHR32256:SF6', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 253842),
(433712, 'PTHR32256:SF3', NULL, NULL, NULL, NULL, '', 253842),
(433713, 'PTHR32256:SF2', NULL, NULL, NULL, NULL, '', 253842),
(433714, 'PTHR32256:SF17', NULL, NULL, NULL, NULL, 'SRFA-INDUCED GENE K PROTEIN', 253842),
(433715, 'PTHR32256:SF7', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', 253842),
(433716, 'PTHR32256', NULL, NULL, NULL, NULL, '', 253842),
(433717, 'PTHR32256:SF8', NULL, NULL, NULL, NULL, 'P-SELECTIN', 253842),
(433718, 'PTHR35349:SF4', NULL, NULL, NULL, NULL, 'CUPIN SUPERFAMILY MEMBER 1', 253843);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(433719, 'PTHR35349', NULL, NULL, NULL, NULL, 'DYNACTIN-ASSOCIATED PROTEIN', 253843),
(433720, 'PTHR35349:SF6', NULL, NULL, NULL, NULL, 'CLLAC DOMAIN-CONTAINING PROTEIN', 253843),
(433721, 'PTHR35349:SF5', NULL, NULL, NULL, NULL, 'DYNACTIN-ASSOCIATED PROTEIN', 253843),
(433722, 'PTHR35349:SF7', NULL, NULL, NULL, NULL, 'DYNACTIN-ASSOCIATED PROTEIN', 253843),
(433723, 'PTHR21141:SF110', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P2-2', 253844),
(433724, 'PTHR21141:SF100', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P2A', 253844),
(433725, 'PTHR21141:SF84', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P2-3', 253844),
(433726, 'PTHR21141:SF102', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P2-5', 253844),
(433727, 'PTHR21141:SF88', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P2-LIKE', 253844),
(433728, 'PTHR21141:SF99', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P2-4', 253844),
(433729, 'PTHR21141:SF58', NULL, NULL, NULL, NULL, 'ACIDIC RIBOSOMAL PROTEIN P2, PUTATIVE-RELATED', 253844),
(433730, 'PTHR21141:SF108', NULL, NULL, NULL, NULL, 'OS02G0529700 PROTEIN', 253844),
(433731, 'PTHR21141', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN FAMILY MEMBER', 253844),
(433732, 'PTHR21141:SF109', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P2', 253844),
(433733, 'PTHR21141:SF103', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P2-ALPHA', 253844),
(433734, 'PTHR21141:SF92', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P2A-LIKE', 253844),
(433735, 'PTHR21141:SF91', NULL, NULL, NULL, NULL, 'BNAA04G15980D PROTEIN', 253844),
(433736, 'PTHR21141:SF104', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P2A-LIKE', 253844),
(433737, 'PTHR21141:SF80', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P2', 253844),
(433738, 'PTHR21141:SF5', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P2', 253844),
(433739, 'PTHR21141:SF106', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P2', 253844),
(433740, 'PTHR21141:SF38', NULL, NULL, NULL, NULL, 'OS08G0250300 PROTEIN', 253844),
(433741, 'PTHR35972:SF1', NULL, NULL, NULL, NULL, 'SINGLE-PASS MEMBRANE AND COILED-COIL DOMAIN-CONTAINING PROTEIN 3', 253845),
(433742, 'PTHR35972', NULL, NULL, NULL, NULL, 'SINGLE-PASS MEMBRANE AND COILED-COIL DOMAIN-CONTAINING PROTEIN 3', 253845),
(433743, 'PTHR33476:SF7', NULL, NULL, NULL, NULL, 'EMB|CAB62613.1', 253846),
(433744, 'PTHR33476:SF4', NULL, NULL, NULL, NULL, 'POLAR LOCALIZATION DURING ASYMMETRIC DIVISION AND PROTEIN', 253846),
(433745, 'PTHR33476:SF24', NULL, NULL, NULL, NULL, 'PROTEIN POLAR LOCALIZATION DURING ASYMMETRIC DIVISION AND REDISTRIBUTION', 253846),
(433746, 'PTHR33476:SF22', NULL, NULL, NULL, NULL, 'PROTEIN POLAR LOCALIZATION DURING ASYMMETRIC DIVISION AND REDISTRIBUTION', 253846),
(433747, 'PTHR33476:SF28', NULL, NULL, NULL, NULL, 'PROTEIN POLAR LOCALIZATION DURING ASYMMETRIC DIVISION AND REDISTRIBUTION', 253846),
(433748, 'PTHR33476:SF18', NULL, NULL, NULL, NULL, '', 253846),
(433749, 'PTHR33476:SF29', NULL, NULL, NULL, NULL, '', 253846),
(433750, 'PTHR33476:SF26', NULL, NULL, NULL, NULL, '', 253846),
(433751, 'PTHR33476:SF16', NULL, NULL, NULL, NULL, 'OS06G0648500 PROTEIN', 253846),
(433752, 'PTHR33476:SF27', NULL, NULL, NULL, NULL, '', 253846),
(433753, 'PTHR33476:SF31', NULL, NULL, NULL, NULL, '', 253846),
(433754, 'PTHR33476:SF21', NULL, NULL, NULL, NULL, 'PROTEIN POLAR-LIKE 1', 253846),
(433755, 'PTHR33476:SF30', NULL, NULL, NULL, NULL, '', 253846),
(433756, 'PTHR33476', NULL, NULL, NULL, NULL, 'EMB|CAB62613.1', 253846),
(433757, 'PTHR12548:SF19', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR-LIKE PROTEIN DPA', 253847),
(433758, 'PTHR12548:SF18', NULL, NULL, NULL, NULL, 'DP TF', 253847),
(433759, 'PTHR12548', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR DP', 253847),
(433760, 'PTHR12548:SF22', NULL, NULL, NULL, NULL, 'BNACNNG78250D PROTEIN', 253847),
(433761, 'PTHR12548:SF9', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR DP', 253847),
(433762, 'PTHR12548:SF20', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR', 253847);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(433763, 'PTHR12548:SF5', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR DP-2', 253847),
(433764, 'PTHR12548:SF13', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR DP FAMILY MEMBER 3', 253847),
(433765, 'PTHR12548:SF4', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR DP-1', 253847),
(433766, 'PTHR12548:SF23', NULL, NULL, NULL, NULL, 'BNAA03G00880D PROTEIN', 253847),
(433767, 'PTHR12045:SF3', NULL, NULL, NULL, NULL, 'ALLANTOICASE-RELATED', 253848),
(433768, 'PTHR12045', NULL, NULL, NULL, NULL, 'ALLANTOICASE', 253848),
(433769, 'PTHR12552:SF1', NULL, NULL, NULL, NULL, 'GTPASE REGULATOR ASSOCIATED WITH FAK, ISOFORM G', 253849),
(433770, 'PTHR12552:SF2', NULL, NULL, NULL, NULL, 'OLIGOPHRENIN-1', 253849),
(433771, 'PTHR12552:SF13', NULL, NULL, NULL, NULL, 'ADAPTOR PROTEIN, PHOSPHOTYROSINE INTERACTING WITH PH DOMAIN AND LEUCINE ZIPPER 1', 253849),
(433772, 'PTHR12552:SF3', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 42', 253849),
(433773, 'PTHR12552:SF4', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 26', 253849),
(433774, 'PTHR12552:SF5', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 10', 253849),
(433775, 'PTHR12552', NULL, NULL, NULL, NULL, 'OLIGOPHRENIN 1', 253849),
(433776, 'PTHR37392', NULL, NULL, NULL, NULL, 'OS09G0556800 PROTEIN', 253850),
(433777, 'PTHR37392:SF1', NULL, NULL, NULL, NULL, 'OS09G0556800 PROTEIN', 253850),
(433778, 'PTHR37826', NULL, NULL, NULL, NULL, 'FLOTILLIN BAND_7_5 DOMAIN PROTEIN', 253851),
(433779, 'PTHR37826:SF2', NULL, NULL, NULL, NULL, 'BAND_7_1 DOMAIN-CONTAINING PROTEIN', 253851),
(433780, 'PTHR37826:SF3', NULL, NULL, NULL, NULL, '', 253851),
(433781, 'PTHR37718', NULL, NULL, NULL, NULL, 'BNAC03G61340D PROTEIN', 253852),
(433782, 'PTHR37718:SF2', NULL, NULL, NULL, NULL, 'BNAC03G61340D PROTEIN', 253852),
(433783, 'PTHR37718:SF3', NULL, NULL, NULL, NULL, '', 253852),
(433784, 'PTHR37718:SF4', NULL, NULL, NULL, NULL, 'BNAA03G54120D PROTEIN', 253852),
(433785, 'PTHR10151:SF73', NULL, NULL, NULL, NULL, '', 253853),
(433786, 'PTHR10151:SF63', NULL, NULL, NULL, NULL, 'ECTONUCLEOTIDE PYROPHOSPHATASE/PHOSPHODIESTERASE FAMILY MEMBER 7', 253853),
(433787, 'PTHR10151:SF77', NULL, NULL, NULL, NULL, 'ECTONUCLEOTIDE PYROPHOSPHATASE/PHOSPHODIESTERASE FAMILY MEMBER 1', 253853),
(433788, 'PTHR10151:SF66', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHOCHOLINE CHOLINEPHOSPHODIESTERASE ENPP6', 253853),
(433789, 'PTHR10151:SF65', NULL, NULL, NULL, NULL, 'ZGC:153896', 253853),
(433790, 'PTHR10151:SF21', NULL, NULL, NULL, NULL, 'ECTONUCLEOTIDE PYROPHOSPHATASE/PHOSPHODIESTERASE FAMILY MEMBER 2', 253853),
(433791, 'PTHR10151:SF79', NULL, NULL, NULL, NULL, 'BIS(5''-ADENOSYL)-TRIPHOSPHATASE ENPP4', 253853),
(433792, 'PTHR10151:SF125', NULL, NULL, NULL, NULL, 'ECTONUCLEOTIDE PYROPHOSPHATASE/PHOSPHODIESTERASE FAMILY MEMBER 5', 253853),
(433793, 'PTHR10151:SF114', NULL, NULL, NULL, NULL, 'ECTONUCLEOTIDE PYROPHOSPHATASE/PHOSPHODIESTERASE C27A7.3', 253853),
(433794, 'PTHR10151:SF124', NULL, NULL, NULL, NULL, 'AP3A HYDROLASE', 253853),
(433795, 'PTHR10151:SF113', NULL, NULL, NULL, NULL, 'ALKALINE-PHOSPHATASE-LIKE FAMILY PROTEIN', 253853),
(433796, 'PTHR10151:SF111', NULL, NULL, NULL, NULL, 'PROTEIN CBG02074', 253853),
(433797, 'PTHR10151:SF122', NULL, NULL, NULL, NULL, 'PROTEIN CBG05971', 253853),
(433798, 'PTHR10151:SF121', NULL, NULL, NULL, NULL, 'ECTONUCLEOTIDE PYROPHOSPHATASE/PHOSPHODIESTERASE C27A7.1', 253853),
(433799, 'PTHR10151:SF110', NULL, NULL, NULL, NULL, 'ALKALINE-PHOSPHATASE-LIKE FAMILY PROTEIN', 253853),
(433800, 'PTHR10151:SF120', NULL, NULL, NULL, NULL, 'ECTONUCLEOTIDE PYROPHOSPHATASE/PHOSPHODIESTERASE 1-RELATED', 253853),
(433801, 'PTHR10151:SF119', NULL, NULL, NULL, NULL, 'BNAA08G13350D PROTEIN', 253853),
(433802, 'PTHR10151:SF107', NULL, NULL, NULL, NULL, 'ECTONUCLEOTIDE PYROPHOSPHATASE/PHOSPHODIESTERASE FAMILY MEMBER 3', 253853),
(433803, 'PTHR10151:SF118', NULL, NULL, NULL, NULL, 'BNAA01G07240D PROTEIN', 253853),
(433804, 'PTHR10151', NULL, NULL, NULL, NULL, 'ECTONUCLEOTIDE PYROPHOSPHATASE/PHOSPHODIESTERASE', 253853),
(433805, 'PTHR10151:SF116', NULL, NULL, NULL, NULL, 'BNAA01G07270D PROTEIN', 253853);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(433806, 'PTHR10151:SF115', NULL, NULL, NULL, NULL, 'ECTONUCLEOTIDE PYROPHOSPHATASE/PHOSPHODIESTERASE', 253853),
(433807, 'PTHR31196', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II NUCLEAR LOCALIZATION PROTEIN SLC7A6OS-RELATED', 253854),
(433808, 'PTHR31196:SF2', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II NUCLEAR LOCALIZATION PROTEIN SLC7A6OS-RELATED', 253854),
(433809, 'PTHR22752:SF9', NULL, NULL, NULL, NULL, 'COUPLED RECEPTOR, PUTATIVE-RELATED', 253855),
(433810, 'PTHR22752:SF10', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 161', 253855),
(433811, 'PTHR22752:SF11', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 62', 253855),
(433812, 'PTHR22752:SF12', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 253855),
(433813, 'PTHR22752:SF2', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', 253855),
(433814, 'PTHR22752:SF1', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 176', 253855),
(433815, 'PTHR22752', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR', 253855),
(433816, 'PTHR22752:SF3', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 135', 253855),
(433817, 'PTHR22752:SF5', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 61', 253855),
(433818, 'PTHR45950:SF11', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-15-LIKE ISOFORM X1', 253856),
(433819, 'PTHR45950:SF22', NULL, NULL, NULL, NULL, 'PHAVOLUTA-LIKE HD-ZIPIII PROTEIN', 253856),
(433820, 'PTHR45950:SF12', NULL, NULL, NULL, NULL, 'BNAC03G55030D PROTEIN', 253856),
(433821, 'PTHR45950:SF7', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-14', 253856),
(433822, 'PTHR45950:SF6', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-8', 253856),
(433823, 'PTHR45950:SF14', NULL, NULL, NULL, NULL, 'BNAA02G06170D PROTEIN', 253856),
(433824, 'PTHR45950:SF1', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-15', 253856),
(433825, 'PTHR45950:SF15', NULL, NULL, NULL, NULL, 'START DOMAIN, HOMEODOMAIN-LIKE, MEKHLA, START-LIKE DOMAIN PROTEIN-RELATED', 253856),
(433826, 'PTHR45950:SF26', NULL, NULL, NULL, NULL, 'START DOMAIN, HOMEODOMAIN-LIKE, MEKHLA, START-LIKE DOMAIN PROTEIN-RELATED', 253856),
(433827, 'PTHR45950:SF27', NULL, NULL, NULL, NULL, 'START DOMAIN, HOMEODOMAIN-LIKE, MEKHLA, START-LIKE DOMAIN PROTEIN-RELATED', 253856),
(433828, 'PTHR45950:SF28', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HOX10', 253856),
(433829, 'PTHR45950:SF3', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HOX33', 253856),
(433830, 'PTHR45950:SF17', NULL, NULL, NULL, NULL, 'BNAC03G69040D PROTEIN', 253856),
(433831, 'PTHR45950:SF18', NULL, NULL, NULL, NULL, 'BNAA04G20300D PROTEIN', 253856),
(433832, 'PTHR45950', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-14', 253856),
(433833, 'PTHR45950:SF20', NULL, NULL, NULL, NULL, 'BNAC03G66860D PROTEIN', 253856),
(433834, 'PTHR45950:SF10', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN REVOLUTA', 253856),
(433835, 'PTHR45950:SF19', NULL, NULL, NULL, NULL, 'CRM DOMAIN-CONTAINING PROTEIN', 253856),
(433836, 'PTHR45950:SF9', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-9', 253856),
(433837, 'PTHR37459:SF1', NULL, NULL, NULL, NULL, 'CRISPR-ASSOCIATED PROTEIN CAS7/CST2/DEVR', 253857),
(433838, 'PTHR37459', NULL, NULL, NULL, NULL, '', 253857),
(433839, 'PTHR36855:SF1', NULL, NULL, NULL, NULL, 'PEX14_N DOMAIN-CONTAINING PROTEIN', 253858),
(433840, 'PTHR36855', NULL, NULL, NULL, NULL, 'CHROMOSOME 10, WHOLE GENOME SHOTGUN SEQUENCE', 253858),
(433841, 'PTHR19970:SF1', NULL, NULL, NULL, NULL, '', 253859),
(433842, 'PTHR19970:SF0', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L39', 253859),
(433843, 'PTHR19970:SF18', NULL, NULL, NULL, NULL, '', 253859),
(433844, 'PTHR19970:SF19', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L39-3', 253859),
(433845, 'PTHR19970:SF34', NULL, NULL, NULL, NULL, '', 253859),
(433846, 'PTHR19970:SF23', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L39', 253859),
(433847, 'PTHR19970:SF35', NULL, NULL, NULL, NULL, '', 253859);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(433848, 'PTHR19970:SF24', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L39-3', 253859),
(433849, 'PTHR19970:SF22', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L39-LIKE', 253859),
(433850, 'PTHR19970', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L39E', 253859),
(433851, 'PTHR19970:SF27', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L39-1', 253859),
(433852, 'PTHR19970:SF38', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L39-2', 253859),
(433853, 'PTHR19970:SF25', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L39', 253859),
(433854, 'PTHR19970:SF36', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L39-LIKE 5-RELATED', 253859),
(433855, 'PTHR19970:SF26', NULL, NULL, NULL, NULL, '', 253859),
(433856, 'PTHR19970:SF37', NULL, NULL, NULL, NULL, '', 253859),
(433857, 'PTHR23226:SF317', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 234', 253860),
(433858, 'PTHR23226', NULL, NULL, NULL, NULL, 'ZINC FINGER AND SCAN DOMAIN-CONTAINING', 253860),
(433859, 'PTHR23226:SF273', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 696', 253860),
(433860, 'PTHR23226:SF152', NULL, NULL, NULL, NULL, 'RCG50438, ISOFORM CRA_A', 253860),
(433861, 'PTHR23226:SF275', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 771', 253860),
(433862, 'PTHR23226:SF155', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 621', 253860),
(433863, 'PTHR23226:SF310', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 418', 253860),
(433864, 'PTHR23226:SF157', NULL, NULL, NULL, NULL, 'ZINC FINGER AND SCAN DOMAIN-CONTAINING PROTEIN 18', 253860),
(433865, 'PTHR23226:SF279', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 70', 253860),
(433866, 'PTHR23226:SF313', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 718', 253860),
(433867, 'PTHR23226:SF150', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 444', 253860),
(433868, 'PTHR23226:SF271', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 34', 253860),
(433869, 'PTHR23226:SF151', NULL, NULL, NULL, NULL, 'ZINC FINGER AND SCAN DOMAIN-CONTAINING PROTEIN 5C-RELATED', 253860),
(433870, 'PTHR23226:SF272', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 75D', 253860),
(433871, 'PTHR23226:SF304', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 2', 253860),
(433872, 'PTHR23226:SF305', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 624', 253860),
(433873, 'PTHR23226:SF306', NULL, NULL, NULL, NULL, 'ZINC FINGER AND SCAN DOMAIN-CONTAINING PROTEIN 5B', 253860),
(433874, 'PTHR23226:SF308', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 715', 253860),
(433875, 'PTHR23226:SF309', NULL, NULL, NULL, NULL, '', 253860),
(433876, 'PTHR23226:SF141', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 530', 253860),
(433877, 'PTHR23226:SF142', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 75C-RELATED', 253860),
(433878, 'PTHR23226:SF300', NULL, NULL, NULL, NULL, 'ZINC FINGER WITH KRAB AND SCAN DOMAINS 7', 253860),
(433879, 'PTHR23226:SF146', NULL, NULL, NULL, NULL, '', 253860),
(433880, 'PTHR23226:SF268', NULL, NULL, NULL, NULL, 'ZINC FINGER AND SCAN DOMAIN CONTAINING 16', 253860),
(433881, 'PTHR23226:SF302', NULL, NULL, NULL, NULL, '', 253860),
(433882, 'PTHR23226:SF259', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 445', 253860),
(433883, 'PTHR23226:SF138', NULL, NULL, NULL, NULL, 'ZINC FINGER AND SCAN DOMAIN-CONTAINING PROTEIN 5A', 253860),
(433884, 'PTHR23226:SF139', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN X-LINKED', 253860),
(433885, 'PTHR23226:SF130', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN WITH KRAB AND SCAN DOMAINS 3', 253860),
(433886, 'PTHR23226:SF132', NULL, NULL, NULL, NULL, 'ZINC FINGER AND SCAN DOMAIN-CONTAINING PROTEIN 31', 253860),
(433887, 'PTHR23226:SF255', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 883', 253860),
(433888, 'PTHR23226:SF134', NULL, NULL, NULL, NULL, 'MYC-ASSOCIATED ZINC FINGER PROTEIN', 253860),
(433889, 'PTHR23226:SF258', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 213', 253860),
(433890, 'PTHR23226:SF370', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 570', 253860),
(433891, 'PTHR23226:SF371', NULL, NULL, NULL, NULL, 'SI:RP71-1G18.1', 253860),
(433892, 'PTHR23226:SF15', NULL, NULL, NULL, NULL, 'ZINC FINGER AND SCAN DOMAIN-CONTAINING PROTEIN 9', 253860);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(433893, 'PTHR23226:SF248', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 648', 253860),
(433894, 'PTHR23226:SF127', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 24', 253860),
(433895, 'PTHR23226:SF369', NULL, NULL, NULL, NULL, 'FINGER PROTEIN, PUTATIVE-RELATED', 253860),
(433896, 'PTHR23226:SF128', NULL, NULL, NULL, NULL, 'ZINC FINGER AND SCAN DOMAIN-CONTAINING PROTEIN 30', 253860),
(433897, 'PTHR23226:SF10', NULL, NULL, NULL, NULL, 'ZINC FINGER AND SCAN DOMAIN-CONTAINING PROTEIN 21', 253860),
(433898, 'PTHR23226:SF94', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN WITH KRAB AND SCAN DOMAINS 1', 253860),
(433899, 'PTHR23226:SF93', NULL, NULL, NULL, NULL, 'NEUROTROPHIN RECEPTOR-INTERACTING FACTOR HOMOLOG', 253860),
(433900, 'PTHR23226:SF361', NULL, NULL, NULL, NULL, 'PR DOMAIN ZINC FINGER PROTEIN 5', 253860),
(433901, 'PTHR23226:SF240', NULL, NULL, NULL, NULL, 'SI:CH211-255F4.11-RELATED', 253860),
(433902, 'PTHR23226:SF362', NULL, NULL, NULL, NULL, 'PROTEIN CBG19812', 253860),
(433903, 'PTHR23226:SF363', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 2', 253860),
(433904, 'PTHR23226:SF364', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 263', 253860),
(433905, 'PTHR23226:SF365', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 768', 253860),
(433906, 'PTHR23226:SF366', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 2 HOMOLOG', 253860),
(433907, 'PTHR23226:SF367', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 169', 253860),
(433908, 'PTHR23226:SF368', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 550', 253860),
(433909, 'PTHR23226:SF247', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN CONTAINING 24', 253860),
(433910, 'PTHR23226:SF360', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 79', 253860),
(433911, 'PTHR23226:SF358', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 668', 253860),
(433912, 'PTHR23226:SF238', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 528', 253860),
(433913, 'PTHR23226:SF88', NULL, NULL, NULL, NULL, 'ZINC FINGER AND SCAN DOMAIN-CONTAINING PROTEIN 4', 253860),
(433914, 'PTHR23226:SF359', NULL, NULL, NULL, NULL, 'CROL ALPHA-RELATED', 253860),
(433915, 'PTHR23226:SF85', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 397', 253860),
(433916, 'PTHR23226:SF83', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 75A', 253860),
(433917, 'PTHR23226:SF350', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 26', 253860),
(433918, 'PTHR23226:SF197', NULL, NULL, NULL, NULL, 'GLI FAMILY ZINC FINGER 4', 253860),
(433919, 'PTHR23226:SF351', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 660', 253860),
(433920, 'PTHR23226:SF352', NULL, NULL, NULL, NULL, 'ZNF1', 253860),
(433921, 'PTHR23226:SF353', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 77-LIKE', 253860),
(433922, 'PTHR23226:SF354', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 37A', 253860),
(433923, 'PTHR23226:SF355', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING 16', 253860),
(433924, 'PTHR23226:SF234', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 716', 253860),
(433925, 'PTHR23226:SF356', NULL, NULL, NULL, NULL, 'ZINC FINGER AND SCAN DOMAIN CONTAINING 2', 253860),
(433926, 'PTHR23226:SF236', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 354C', 253860),
(433927, 'PTHR23226:SF357', NULL, NULL, NULL, NULL, 'PATERNALLY-EXPRESSED GENE 3 PROTEIN', 253860),
(433928, 'PTHR23226:SF190', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 18', 253860),
(433929, 'PTHR23226:SF191', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 780B', 253860),
(433930, 'PTHR23226:SF192', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 853', 253860),
(433931, 'PTHR23226:SF193', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 275', 253860),
(433932, 'PTHR23226:SF194', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 287', 253860),
(433933, 'PTHR23226:SF195', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 202', 253860),
(433934, 'PTHR23226:SF3', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 394', 253860),
(433935, 'PTHR23226:SF4', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 449', 253860),
(433936, 'PTHR23226:SF1', NULL, NULL, NULL, NULL, 'ZINC FINGER AND SCAN DOMAIN-CONTAINING PROTEIN 25', 253860);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(433937, 'PTHR23226:SF347', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 420', 253860),
(433938, 'PTHR23226:SF78', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 396', 253860),
(433939, 'PTHR23226:SF348', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 497', 253860),
(433940, 'PTHR23226:SF77', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 205', 253860),
(433941, 'PTHR23226:SF349', NULL, NULL, NULL, NULL, '', 253860),
(433942, 'PTHR23226:SF76', NULL, NULL, NULL, NULL, 'ZINC FINGER AND SCAN DOMAIN-CONTAINING PROTEIN 23', 253860),
(433943, 'PTHR23226:SF229', NULL, NULL, NULL, NULL, 'ZINC FINGER AND SCAN DOMAIN-CONTAINING PROTEIN 29-LIKE', 253860),
(433944, 'PTHR23226:SF75', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN WITH KRAB AND SCAN DOMAINS 8', 253860),
(433945, 'PTHR23226:SF74', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 500', 253860),
(433946, 'PTHR23226:SF341', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 501-LIKE', 253860),
(433947, 'PTHR23226:SF189', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 239', 253860),
(433948, 'PTHR23226:SF343', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 596-LIKE', 253860),
(433949, 'PTHR23226:SF344', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 829', 253860),
(433950, 'PTHR23226:SF345', NULL, NULL, NULL, NULL, '', 253860),
(433951, 'PTHR23226:SF346', NULL, NULL, NULL, NULL, 'RB-ASSOCIATED KRAB ZINC FINGER PROTEIN', 253860),
(433952, 'PTHR23226:SF180', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 496', 253860),
(433953, 'PTHR23226:SF184', NULL, NULL, NULL, NULL, 'ZINC FINGER AND SCAN DOMAIN-CONTAINING PROTEIN 29', 253860),
(433954, 'PTHR23226:SF68', NULL, NULL, NULL, NULL, 'ZINC FINGER AND SCAN DOMAIN-CONTAINING PROTEIN 12', 253860),
(433955, 'PTHR23226:SF67', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN WITH KRAB AND SCAN DOMAINS 4', 253860),
(433956, 'PTHR23226:SF336', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 594', 253860),
(433957, 'PTHR23226:SF337', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 548 ISOFORM 1', 253860),
(433958, 'PTHR23226:SF65', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 215', 253860),
(433959, 'PTHR23226:SF217', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 727', 253860),
(433960, 'PTHR23226:SF218', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 956', 253860),
(433961, 'PTHR23226:SF219', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 408', 253860),
(433962, 'PTHR23226:SF61', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 165', 253860),
(433963, 'PTHR23226:SF175', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 174', 253860),
(433964, 'PTHR23226:SF330', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING PROTEIN 41', 253860),
(433965, 'PTHR23226:SF210', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 446', 253860),
(433966, 'PTHR23226:SF298', NULL, NULL, NULL, NULL, 'PLURIPOTENCY-ASSOCIATED TRANSCRIPT 25-RELATED', 253860),
(433967, 'PTHR23226:SF211', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 773', 253860),
(433968, 'PTHR23226:SF332', NULL, NULL, NULL, NULL, 'ZINC FINGER AND SCAN DOMAIN-CONTAINING PROTEIN 1', 253860),
(433969, 'PTHR23226:SF333', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 629', 253860),
(433970, 'PTHR23226:SF179', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 713', 253860),
(433971, 'PTHR23226:SF335', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 572', 253860),
(433972, 'PTHR23226:SF214', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 32', 253860),
(433973, 'PTHR23226:SF290', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 197', 253860),
(433974, 'PTHR23226:SF170', NULL, NULL, NULL, NULL, 'MYONEURIN', 253860),
(433975, 'PTHR23226:SF293', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 664', 253860),
(433976, 'PTHR23226:SF59', NULL, NULL, NULL, NULL, 'ZINC FINGER AND SCAN DOMAIN-CONTAINING PROTEIN 22', 253860),
(433977, 'PTHR23226:SF325', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 322', 253860),
(433978, 'PTHR23226:SF56', NULL, NULL, NULL, NULL, 'ZINC FINGER AND SCAN DOMAIN-CONTAINING PROTEIN 26', 253860),
(433979, 'PTHR23226:SF327', NULL, NULL, NULL, NULL, 'ZINC FINGER AND SCAN DOMAIN-CONTAINING PROTEIN 20', 253860),
(433980, 'PTHR23226:SF54', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 232', 253860);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(433981, 'PTHR23226:SF206', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 575', 253860),
(433982, 'PTHR23226:SF207', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 697', 253860),
(433983, 'PTHR23226:SF52', NULL, NULL, NULL, NULL, 'ZINC FINGER AND SCAN DOMAIN-CONTAINING PROTEIN 16', 253860),
(433984, 'PTHR23226:SF209', NULL, NULL, NULL, NULL, 'ZINC FINGER AND SCAN DOMAIN-CONTAINING PROTEIN 32', 253860),
(433985, 'PTHR23226:SF284', NULL, NULL, NULL, NULL, '', 253860),
(433986, 'PTHR23226:SF164', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN WITH KRAB AND SCAN DOMAINS 2', 253860),
(433987, 'PTHR23226:SF321', NULL, NULL, NULL, NULL, 'ZFP28 ZINC FINGER PROTEIN', 253860),
(433988, 'PTHR23226:SF324', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 525-RELATED', 253860),
(433989, 'PTHR23226:SF203', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 80', 253860),
(433990, 'PTHR23226:SF160', NULL, NULL, NULL, NULL, 'SI:CH211-154O6.2', 253860),
(433991, 'PTHR23226:SF161', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 641', 253860),
(433992, 'PTHR35834', NULL, NULL, NULL, NULL, 'ARMADILLO-TYPE FOLD PROTEIN-RELATED', 253861),
(433993, 'PTHR35834:SF3', NULL, NULL, NULL, NULL, '', 253861),
(433994, 'PTHR35834:SF2', NULL, NULL, NULL, NULL, 'ARMADILLO-TYPE FOLD PROTEIN-RELATED', 253861),
(433995, 'PTHR10190:SF16', NULL, NULL, NULL, NULL, 'DEVELOPMENTAL PROTEIN EYES ABSENT', 253862),
(433996, 'PTHR10190', NULL, NULL, NULL, NULL, 'EYES ABSENT', 253862),
(433997, 'PTHR10190:SF11', NULL, NULL, NULL, NULL, 'EYES ABSENT HOMOLOG 1', 253862),
(433998, 'PTHR10190:SF7', NULL, NULL, NULL, NULL, 'EYES ABSENT HOMOLOG 2', 253862),
(433999, 'PTHR10190:SF17', NULL, NULL, NULL, NULL, 'EYES ABSENT HOMOLOG 4', 253862),
(434000, 'PTHR10190:SF5', NULL, NULL, NULL, NULL, 'EYES ABSENT HOMOLOG 3', 253862),
(434001, 'PTHR33936:SF18', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 253863),
(434002, 'PTHR33936:SF2', NULL, NULL, NULL, NULL, 'MODIFIER OF CELL DEATH', 253863),
(434003, 'PTHR33936:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG06911', 253863),
(434004, 'PTHR33936', NULL, NULL, NULL, NULL, 'PROTEIN CBG17840', 253863),
(434005, 'PTHR33936:SF15', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 253863),
(434006, 'PTHR33936:SF3', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 253863),
(434007, 'PTHR33936:SF24', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 253863),
(434008, 'PTHR33936:SF23', NULL, NULL, NULL, NULL, 'PROTEIN CBG21722', 253863),
(434009, 'PTHR33936:SF22', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 253863),
(434010, 'PTHR33936:SF8', NULL, NULL, NULL, NULL, 'PROTEIN CBG22545', 253863),
(434011, 'PTHR33936:SF21', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 253863),
(434012, 'PTHR33936:SF9', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', 253863),
(434013, 'PTHR45785:SF9', NULL, NULL, NULL, NULL, 'COMPLEMENT FACTOR H-RELATED PROTEIN 5', 253864),
(434014, 'PTHR45785:SF12', NULL, NULL, NULL, NULL, 'COMPLEMENT FACTOR H-RELATED PROTEIN 1-RELATED', 253864),
(434015, 'PTHR45785:SF7', NULL, NULL, NULL, NULL, 'COMPLEMENT FACTOR H', 253864),
(434016, 'PTHR45785:SF4', NULL, NULL, NULL, NULL, 'COMPLEMENT FACTOR H-RELATED PROTEIN 3-RELATED', 253864),
(434017, 'PTHR45785:SF13', NULL, NULL, NULL, NULL, 'SUSHI DOMAIN-CONTAINING PROTEIN', 253864),
(434018, 'PTHR45785', NULL, NULL, NULL, NULL, 'COMPLEMENT FACTOR H-RELATED', 253864),
(434019, 'PTHR45785:SF2', NULL, NULL, NULL, NULL, 'COMPLEMENT FACTOR H-RELATED', 253864),
(434020, 'PTHR45785:SF3', NULL, NULL, NULL, NULL, 'COAGULATION FACTOR XIII B CHAIN', 253864),
(434021, 'PTHR43050:SF2', NULL, NULL, NULL, NULL, 'SERINE RACEMASE', 253865),
(434022, 'PTHR43050:SF1', NULL, NULL, NULL, NULL, 'SERINE RACEMASE', 253865),
(434023, 'PTHR43050', NULL, NULL, NULL, NULL, 'SERINE / THREONINE RACEMASE FAMILY MEMBER', 253865),
(434024, 'PTHR46249:SF38', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN, VIRAL MOVEMENT PROTEIN-RELATED', 253866),
(434025, 'PTHR46249:SF29', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', 253866);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(434026, 'PTHR46249:SF41', NULL, NULL, NULL, NULL, 'ZINC KNUCKLE FAMILY PROTEIN', 253866),
(434027, 'PTHR46249:SF31', NULL, NULL, NULL, NULL, 'VIRAL MOVEMENT PROTEIN', 253866),
(434028, 'PTHR46249:SF42', NULL, NULL, NULL, NULL, 'PEPTIDASE A2 DOMAIN-CONTAINING PROTEIN', 253866),
(434029, 'PTHR46249', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', 253866),
(434030, 'PTHR46249:SF43', NULL, NULL, NULL, NULL, 'RVP DOMAIN-CONTAINING PROTEIN', 253866),
(434031, 'PTHR46249:SF32', NULL, NULL, NULL, NULL, 'ZINC KNUCKLE FAMILY PROTEIN', 253866),
(434032, 'PTHR21404', NULL, NULL, NULL, NULL, 'HEN1', 253867),
(434033, 'PTHR21404:SF3', NULL, NULL, NULL, NULL, 'SMALL RNA 2''-O-METHYLTRANSFERASE', 253867),
(434034, 'PTHR43271:SF2', NULL, NULL, NULL, NULL, 'BLL2771 PROTEIN', 253868),
(434035, 'PTHR43271:SF1', NULL, NULL, NULL, NULL, 'INNER MEMBRANE TRANSPORT PROTEIN YNFM', 253868),
(434036, 'PTHR43271', NULL, NULL, NULL, NULL, 'BLL2771 PROTEIN', 253868),
(434037, 'PTHR43825', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT', 253869),
(434038, 'PTHR43825:SF4', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT', 253869),
(434039, 'PTHR43825:SF3', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT', 253869),
(434040, 'PTHR43825:SF5', NULL, NULL, NULL, NULL, 'HYPOTHETICAL TRANSKETOLASE FAMILY PROTEIN', 253869),
(434041, 'PTHR43825:SF1', NULL, NULL, NULL, NULL, 'TRANSKET_PYR DOMAIN-CONTAINING PROTEIN', 253869),
(434042, 'PTHR43364:SF9', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE', 253870),
(434043, 'PTHR43364:SF4', NULL, NULL, NULL, NULL, 'NAD(P)-LINKED OXIDOREDUCTASE SUPERFAMILY PROTEIN', 253870),
(434044, 'PTHR43364:SF2', NULL, NULL, NULL, NULL, 'ARYL-ALCOHOL DEHYDROGENASE AAD10-RELATED', 253870),
(434045, 'PTHR43364:SF11', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN', 253870),
(434046, 'PTHR43364:SF1', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE YDHF', 253870),
(434047, 'PTHR43364', NULL, NULL, NULL, NULL, 'NADH-SPECIFIC METHYLGLYOXAL REDUCTASE-RELATED', 253870),
(434048, 'PTHR43364:SF16', NULL, NULL, NULL, NULL, 'NADH-SPECIFIC METHYLGLYOXAL REDUCTASE', 253870),
(434049, 'PTHR43364:SF17', NULL, NULL, NULL, NULL, 'ALDO KETO REDUCTASE', 253870),
(434050, 'PTHR43364:SF7', NULL, NULL, NULL, NULL, 'ALDO_KET_RED DOMAIN-CONTAINING PROTEIN-RELATED', 253870),
(434051, 'PTHR43364:SF6', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE-RELATED', 253870),
(434052, 'PTHR43364:SF15', NULL, NULL, NULL, NULL, 'ARYL-ALCOHOL DEHYDROGENASE AAD16-RELATED', 253870),
(434053, 'PTHR43364:SF5', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE-RELATED', 253870),
(434054, 'PTHR38075', NULL, NULL, NULL, NULL, 'DUF4139 DOMAIN-CONTAINING PROTEIN', 253871),
(434055, 'PTHR38075:SF1', NULL, NULL, NULL, NULL, 'DUF4139 DOMAIN-CONTAINING PROTEIN', 253871),
(434056, 'PTHR36698:SF3', NULL, NULL, NULL, NULL, 'ABC_TRANS_AUX DOMAIN-CONTAINING PROTEIN', 253872),
(434057, 'PTHR36698:SF2', NULL, NULL, NULL, NULL, 'MLAD DOMAIN-CONTAINING PROTEIN', 253872),
(434058, 'PTHR36698', NULL, NULL, NULL, NULL, 'BLL5892 PROTEIN', 253872),
(434059, 'PTHR42643:SF30', NULL, NULL, NULL, NULL, 'IONOTROPIC RECEPTOR 40A-RELATED', 253873),
(434060, 'PTHR42643:SF31', NULL, NULL, NULL, NULL, 'IONOTROPIC RECEPTOR 85A', 253873),
(434061, 'PTHR42643:SF32', NULL, NULL, NULL, NULL, 'IONOTROPIC RECEPTOR 75A-RELATED', 253873),
(434062, 'PTHR42643:SF33', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR 2-LIKE PROTEIN', 253873),
(434063, 'PTHR42643:SF23', NULL, NULL, NULL, NULL, 'IONOTROPIC RECEPTOR 100A', 253873),
(434064, 'PTHR42643:SF34', NULL, NULL, NULL, NULL, 'IONOTROPIC RECEPTOR 60A', 253873),
(434065, 'PTHR42643:SF13', NULL, NULL, NULL, NULL, 'IONOTROPIC RECEPTOR 31A, ISOFORM C', 253873),
(434066, 'PTHR42643:SF24', NULL, NULL, NULL, NULL, 'IONOTROPIC RECEPTOR 20A-RELATED', 253873),
(434067, 'PTHR42643:SF16', NULL, NULL, NULL, NULL, 'IONOTROPIC RECEPTOR 11A-RELATED', 253873),
(434068, 'PTHR42643:SF28', NULL, NULL, NULL, NULL, 'IONOTROPIC RECEPTOR 68B', 253873),
(434069, 'PTHR42643:SF29', NULL, NULL, NULL, NULL, 'IONOTROPIC RECEPTOR 68A, ISOFORM A', 253873);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(434070, 'PTHR42643', NULL, NULL, NULL, NULL, 'IONOTROPIC RECEPTOR 20A-RELATED', 253873),
(434071, 'PTHR46778:SF1', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR 1', 253874),
(434072, 'PTHR46778:SF2', NULL, NULL, NULL, NULL, 'CDI DOMAIN-CONTAINING PROTEIN', 253874),
(434073, 'PTHR46778', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR 1-RELATED', 253874),
(434074, 'PTHR47520', NULL, NULL, NULL, NULL, 'CX DOMAIN-CONTAINING PROTEIN-RELATED', 253875),
(434075, 'PTHR47520:SF10', NULL, NULL, NULL, NULL, 'CX DOMAIN-CONTAINING PROTEIN', 253875),
(434076, 'PTHR47520:SF11', NULL, NULL, NULL, NULL, 'CX DOMAIN-CONTAINING PROTEIN', 253875),
(434077, 'PTHR47520:SF4', NULL, NULL, NULL, NULL, 'CX DOMAIN-CONTAINING PROTEIN', 253875),
(434078, 'PTHR47520:SF5', NULL, NULL, NULL, NULL, 'CX DOMAIN-CONTAINING PROTEIN', 253875),
(434079, 'PTHR47520:SF6', NULL, NULL, NULL, NULL, 'CX DOMAIN-CONTAINING PROTEIN', 253875),
(434080, 'PTHR47520:SF7', NULL, NULL, NULL, NULL, 'CX DOMAIN-CONTAINING PROTEIN', 253875),
(434081, 'PTHR47520:SF14', NULL, NULL, NULL, NULL, 'CX DOMAIN-CONTAINING PROTEIN', 253875),
(434082, 'PTHR47520:SF8', NULL, NULL, NULL, NULL, 'CX DOMAIN-CONTAINING PROTEIN', 253875),
(434083, 'PTHR47520:SF12', NULL, NULL, NULL, NULL, 'CX DOMAIN-CONTAINING PROTEIN', 253875),
(434084, 'PTHR47520:SF13', NULL, NULL, NULL, NULL, 'CX DOMAIN-CONTAINING PROTEIN', 253875),
(434085, 'PTHR47520:SF1', NULL, NULL, NULL, NULL, 'CX DOMAIN-CONTAINING PROTEIN', 253875),
(434086, 'PTHR47520:SF2', NULL, NULL, NULL, NULL, 'CX DOMAIN-CONTAINING PROTEIN', 253875),
(434087, 'PTHR10380:SF160', NULL, NULL, NULL, NULL, 'CUTICULAR PROTEIN 100A', 253876),
(434088, 'PTHR10380:SF239', NULL, NULL, NULL, NULL, 'CUTICULAR PROTEIN 47EF, ISOFORM C-RELATED', 253876),
(434089, 'PTHR10380:SF217', NULL, NULL, NULL, NULL, 'CUTICULAR PROTEIN 49AE', 253876),
(434090, 'PTHR10380:SF238', NULL, NULL, NULL, NULL, 'CUTICULAR PROTEIN 65EA-RELATED', 253876),
(434091, 'PTHR10380:SF119', NULL, NULL, NULL, NULL, 'PROTEIN LETHAL(3)MALIGNANT BLOOD NEOPLASM 1', 253876),
(434092, 'PTHR10380:SF218', NULL, NULL, NULL, NULL, 'ADULT CUTICLE PROTEIN 65AA-RELATED', 253876),
(434093, 'PTHR10380:SF235', NULL, NULL, NULL, NULL, 'CUTICULAR PROTEIN 73D, ISOFORM B', 253876),
(434094, 'PTHR10380:SF234', NULL, NULL, NULL, NULL, 'CUTICULAR PROTEIN 97EA, ISOFORM A', 253876),
(434095, 'PTHR10380:SF215', NULL, NULL, NULL, NULL, 'CUTICULAR PROTEIN 49AG', 253876),
(434096, 'PTHR10380:SF237', NULL, NULL, NULL, NULL, 'CUTICULAR PROTEIN 65EB-RELATED', 253876),
(434097, 'PTHR10380:SF236', NULL, NULL, NULL, NULL, 'AGAP006497-PA', 253876),
(434098, 'PTHR10380:SF230', NULL, NULL, NULL, NULL, 'CUTICULAR PROTEIN 47EE', 253876),
(434099, 'PTHR10380:SF233', NULL, NULL, NULL, NULL, 'CUTICULAR PROTEIN 12A-RELATED', 253876),
(434100, 'PTHR10380:SF199', NULL, NULL, NULL, NULL, '', 253876),
(434101, 'PTHR10380:SF232', NULL, NULL, NULL, NULL, '', 253876),
(434102, 'PTHR10380:SF196', NULL, NULL, NULL, NULL, 'CUTICULAR PROTEIN 72EA', 253876),
(434103, 'PTHR10380', NULL, NULL, NULL, NULL, 'CUTICLE PROTEIN', 253876),
(434104, 'PTHR10380:SF173', NULL, NULL, NULL, NULL, 'CUTICULAR PROTEIN 47EG-RELATED', 253876),
(434105, 'PTHR10380:SF192', NULL, NULL, NULL, NULL, 'CUTICULAR PROTEIN 65AU, ISOFORM A-RELATED', 253876),
(434106, 'PTHR10380:SF2', NULL, NULL, NULL, NULL, 'AGAP003037-PA', 253876),
(434107, 'PTHR10380:SF209', NULL, NULL, NULL, NULL, 'AGAP000744-PA', 253876),
(434108, 'PTHR10380:SF228', NULL, NULL, NULL, NULL, 'CUTICULAR PROTEIN 11A-RELATED', 253876),
(434109, 'PTHR10380:SF206', NULL, NULL, NULL, NULL, 'GH27759P', 253876),
(434110, 'PTHR10380:SF205', NULL, NULL, NULL, NULL, 'CUTICULAR PROTEIN 97EB', 253876),
(434111, 'PTHR10380:SF109', NULL, NULL, NULL, NULL, 'CUTICULAR PROTEIN 49AH', 253876),
(434112, 'PTHR10380:SF229', NULL, NULL, NULL, NULL, 'CUTICULAR PROTEIN 49AF, ISOFORM A', 253876),
(434113, 'PTHR10380:SF224', NULL, NULL, NULL, NULL, 'AGAP013248-PA', 253876),
(434114, 'PTHR10380:SF200', NULL, NULL, NULL, NULL, 'CUTICULAR PROTEIN 49AB-RELATED', 253876),
(434115, 'PTHR10380:SF222', NULL, NULL, NULL, NULL, 'CUTICULAR PROTEIN 47EA', 253876);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(434116, 'PTHR42002', NULL, NULL, NULL, NULL, 'ANAEROBIC C4-DICARBOXYLATE TRANSPORTER DCUC-RELATED', 253877),
(434117, 'PTHR42002:SF2', NULL, NULL, NULL, NULL, 'ANAEROBIC C4-DICARBOXYLATE TRANSPORTER DCUC-RELATED', 253877),
(434118, 'PTHR31797:SF2', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE PHOSPHODIESTERASE INHIBITOR', 253878),
(434119, 'PTHR31797', NULL, NULL, NULL, NULL, 'EXTRACELLULAR MATRIX PROTEIN A-RELATED', 253878),
(434120, 'PTHR31797:SF3', NULL, NULL, NULL, NULL, 'EXTRACELLULAR MATRIX PROTEIN A-RELATED', 253878),
(434121, 'PTHR31797:SF6', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN CAMBP64-RELATED', 253878),
(434122, 'PTHR31797:SF4', NULL, NULL, NULL, NULL, '', 253878),
(434123, 'PTHR35787:SF1', NULL, NULL, NULL, NULL, 'GLYCEROL UPTAKE OPERON ANTITERMINATOR REGULATORY PROTEIN', 253879),
(434124, 'PTHR35787', NULL, NULL, NULL, NULL, 'GLYCEROL UPTAKE OPERON ANTITERMINATOR REGULATORY PROTEIN', 253879),
(434125, 'PTHR21706:SF13', NULL, NULL, NULL, NULL, '', 253880),
(434126, 'PTHR21706', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 65', 253880),
(434127, 'PTHR21706:SF15', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 65', 253880),
(434128, 'PTHR47090:SF2', NULL, NULL, NULL, NULL, 'PROTEIN EDS1-RELATED', 253881),
(434129, 'PTHR47090:SF6', NULL, NULL, NULL, NULL, 'EDS1_EP DOMAIN-CONTAINING PROTEIN', 253881),
(434130, 'PTHR47090:SF5', NULL, NULL, NULL, NULL, 'ENHANCED DISEASE SUSCEPTIBILITY PROTEIN', 253881),
(434131, 'PTHR47090:SF4', NULL, NULL, NULL, NULL, 'ALPHA/BETA HYDROLASE FOLD PROTEIN-RELATED', 253881),
(434132, 'PTHR47090', NULL, NULL, NULL, NULL, 'PROTEIN EDS1-RELATED', 253881),
(434133, 'PTHR11644:SF2', NULL, NULL, NULL, NULL, 'CYTIDINE DEAMINASE', 253882),
(434134, 'PTHR11644:SF11', NULL, NULL, NULL, NULL, 'CYTIDINE DEAMINASE', 253882),
(434135, 'PTHR11644:SF24', NULL, NULL, NULL, NULL, 'CYTIDINE DEAMINASE', 253882),
(434136, 'PTHR11644', NULL, NULL, NULL, NULL, 'CYTIDINE DEAMINASE', 253882),
(434137, 'PTHR11644:SF25', NULL, NULL, NULL, NULL, 'CYTIDINE DEAMINASE', 253882),
(434138, 'PTHR11644:SF26', NULL, NULL, NULL, NULL, 'CYTIDINE DEAMINASE', 253882),
(434139, 'PTHR11644:SF27', NULL, NULL, NULL, NULL, 'CYTIDINE DEAMINASE', 253882),
(434140, 'PTHR11644:SF28', NULL, NULL, NULL, NULL, 'CYTIDINE DEAMINASE 8-RELATED', 253882),
(434141, 'PTHR33168:SF35', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 253883),
(434142, 'PTHR33168:SF93', NULL, NULL, NULL, NULL, 'STRESS INDUCED PROTEIN', 253883),
(434143, 'PTHR33168:SF94', NULL, NULL, NULL, NULL, '', 253883),
(434144, 'PTHR33168:SF91', NULL, NULL, NULL, NULL, '', 253883),
(434145, 'PTHR33168:SF92', NULL, NULL, NULL, NULL, 'OS05G0516100 PROTEIN', 253883),
(434146, 'PTHR33168:SF70', NULL, NULL, NULL, NULL, 'OS01G0182300 PROTEIN', 253883),
(434147, 'PTHR33168:SF97', NULL, NULL, NULL, NULL, 'OS06G0646100 PROTEIN', 253883),
(434148, 'PTHR33168:SF31', NULL, NULL, NULL, NULL, 'OS01G0751400 PROTEIN', 253883),
(434149, 'PTHR33168:SF98', NULL, NULL, NULL, NULL, 'OS02G0182850 PROTEIN', 253883),
(434150, 'PTHR33168:SF95', NULL, NULL, NULL, NULL, '', 253883),
(434151, 'PTHR33168:SF73', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 253883),
(434152, 'PTHR33168:SF96', NULL, NULL, NULL, NULL, '', 253883),
(434153, 'PTHR33168', NULL, NULL, NULL, NULL, 'STRESS INDUCED PROTEIN-RELATED', 253883),
(434154, 'PTHR33168:SF52', NULL, NULL, NULL, NULL, '', 253883),
(434155, 'PTHR33168:SF90', NULL, NULL, NULL, NULL, '', 253883),
(434156, 'PTHR33168:SF8', NULL, NULL, NULL, NULL, 'OS08G0293100 PROTEIN', 253883),
(434157, 'PTHR33168:SF88', NULL, NULL, NULL, NULL, '', 253883),
(434158, 'PTHR33168:SF44', NULL, NULL, NULL, NULL, '', 253883),
(434159, 'PTHR33168:SF89', NULL, NULL, NULL, NULL, '', 253883),
(434160, 'PTHR33168:SF67', NULL, NULL, NULL, NULL, 'OS06G0666800 PROTEIN', 253883),
(434161, 'PTHR33168:SF83', NULL, NULL, NULL, NULL, '', 253883),
(434162, 'PTHR33168:SF81', NULL, NULL, NULL, NULL, '', 253883),
(434163, 'PTHR33168:SF86', NULL, NULL, NULL, NULL, 'OS02G0209400 PROTEIN', 253883),
(434164, 'PTHR33168:SF43', NULL, NULL, NULL, NULL, '', 253883);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(434165, 'PTHR33168:SF87', NULL, NULL, NULL, NULL, 'OS04G0558700 PROTEIN', 253883),
(434166, 'PTHR33168:SF84', NULL, NULL, NULL, NULL, '', 253883),
(434167, 'PTHR33168:SF63', NULL, NULL, NULL, NULL, 'BNACNNG20090D PROTEIN', 253883),
(434168, 'PTHR33168:SF85', NULL, NULL, NULL, NULL, '', 253883),
(434169, 'PTHR46668:SF6', NULL, NULL, NULL, NULL, 'BOP1', 253884),
(434170, 'PTHR46668:SF5', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN NPR6', 253884),
(434171, 'PTHR46668', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN AND ANKYRIN REPEAT-CONTAINING PROTEIN NH5.2', 253884),
(434172, 'PTHR46668:SF8', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN NPR5-LIKE ISOFORM X1', 253884),
(434173, 'PTHR46668:SF11', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN AND ANKYRIN REPEAT-CONTAINING PROTEIN NOOT2', 253884),
(434174, 'PTHR46668:SF9', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 253884),
(434175, 'PTHR46668:SF2', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN AND ANKYRIN REPEAT-CONTAINING PROTEIN NH5.2', 253884),
(434176, 'PTHR46668:SF1', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN NPR5', 253884),
(434177, 'PTHR46668:SF4', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN NPR5', 253884),
(434178, 'PTHR43011:SF5', NULL, NULL, NULL, NULL, 'FE-S_BIOSYN DOMAIN-CONTAINING PROTEIN', 253885),
(434179, 'PTHR43011:SF4', NULL, NULL, NULL, NULL, 'FE-S_BIOSYN DOMAIN-CONTAINING PROTEIN', 253885),
(434180, 'PTHR43011:SF1', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER ASSEMBLY 2 HOMOLOG, MITOCHONDRIAL', 253885),
(434181, 'PTHR43011', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER ASSEMBLY 2 HOMOLOG, MITOCHONDRIAL', 253885),
(434182, 'PTHR31737:SF3', NULL, NULL, NULL, NULL, 'CELL WALL PROTEIN YJL171C', 253886),
(434183, 'PTHR31737:SF2', NULL, NULL, NULL, NULL, 'PROTEIN TOS1', 253886),
(434184, 'PTHR31737', NULL, NULL, NULL, NULL, 'PROTEIN TOS1', 253886),
(434185, 'PTHR41259:SF1', NULL, NULL, NULL, NULL, 'AAA_27 DOMAIN-CONTAINING PROTEIN', 253887),
(434186, 'PTHR41259', NULL, NULL, NULL, NULL, 'DOUBLE-STRAND BREAK REPAIR RAD50 ATPASE, PUTATIVE-RELATED', 253887),
(434187, 'PTHR24178:SF33', NULL, NULL, NULL, NULL, 'ANKYRIN-2', 253888),
(434188, 'PTHR24178:SF32', NULL, NULL, NULL, NULL, 'OS07G0527800 PROTEIN', 253888),
(434189, 'PTHR24178:SF21', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX PROTEIN 3', 253888),
(434190, 'PTHR24178:SF9', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 253888),
(434191, 'PTHR24178:SF37', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 253888),
(434192, 'PTHR24178:SF36', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 253888),
(434193, 'PTHR24178:SF35', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 253888),
(434194, 'PTHR24178:SF34', NULL, NULL, NULL, NULL, 'OS07G0532500 PROTEIN', 253888),
(434195, 'PTHR24178:SF23', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 253888),
(434196, 'PTHR24178:SF38', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', 253888),
(434197, 'PTHR24178:SF2', NULL, NULL, NULL, NULL, 'INVERSIN', 253888),
(434198, 'PTHR24178', NULL, NULL, NULL, NULL, 'MOLTING PROTEIN MLT-4', 253888),
(434199, 'PTHR36758', NULL, NULL, NULL, NULL, 'OS01G0342800 PROTEIN', 253889),
(434200, 'PTHR36758:SF1', NULL, NULL, NULL, NULL, 'LYR MOTIF-CONTAINING PROTEIN PHYPADRAFT_186863', 253889),
(434201, 'PTHR34992:SF1', NULL, NULL, NULL, NULL, 'CHROMOSOME 19, WHOLE GENOME SHOTGUN SEQUENCE', 253890),
(434202, 'PTHR34992:SF10', NULL, NULL, NULL, NULL, 'HYPHAL ANASTAMOSIS-7 PROTEIN', 253890),
(434203, 'PTHR34992:SF8', NULL, NULL, NULL, NULL, '', 253890),
(434204, 'PTHR34992', NULL, NULL, NULL, NULL, 'HYPHAL ANASTAMOSIS-7 PROTEIN', 253890),
(434205, 'PTHR34992:SF5', NULL, NULL, NULL, NULL, 'ANCHORED PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G02800)-RELATED', 253890),
(434206, 'PTHR34992:SF2', NULL, NULL, NULL, NULL, '', 253890),
(434207, 'PTHR11760:SF19', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S3, CHLOROPLASTIC', 253891),
(434208, 'PTHR11760:SF48', NULL, NULL, NULL, NULL, 'PROTEIN GET1-LIKE ISOFORM X1', 253891);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(434209, 'PTHR11760:SF37', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S3, PUTATIVE, EXPRESSED-RELATED', 253891),
(434210, 'PTHR11760:SF38', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S3', 253891),
(434211, 'PTHR11760:SF68', NULL, NULL, NULL, NULL, 'KH TYPE-2 DOMAIN-CONTAINING PROTEIN', 253891),
(434212, 'PTHR11760:SF36', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S3', 253891),
(434213, 'PTHR11760:SF69', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S3, CHLOROPLASTIC', 253891),
(434214, 'PTHR11760:SF44', NULL, NULL, NULL, NULL, 'BNAC07G33680D PROTEIN', 253891),
(434215, 'PTHR11760:SF66', NULL, NULL, NULL, NULL, 'KH TYPE-2 DOMAIN-CONTAINING PROTEIN', 253891),
(434216, 'PTHR11760:SF34', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S3', 253891),
(434217, 'PTHR11760:SF67', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S3, CHLOROPLASTIC', 253891),
(434218, 'PTHR11760:SF64', NULL, NULL, NULL, NULL, 'KH TYPE-2 DOMAIN-CONTAINING PROTEIN', 253891),
(434219, 'PTHR11760:SF42', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S3, CHLOROPLASTIC', 253891),
(434220, 'PTHR11760:SF32', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S3', 253891),
(434221, 'PTHR11760:SF21', NULL, NULL, NULL, NULL, 'PROTEIN GET1', 253891),
(434222, 'PTHR11760:SF65', NULL, NULL, NULL, NULL, '', 253891),
(434223, 'PTHR11760:SF40', NULL, NULL, NULL, NULL, '', 253891),
(434224, 'PTHR11760:SF62', NULL, NULL, NULL, NULL, 'BNAC06G02420D PROTEIN', 253891),
(434225, 'PTHR11760:SF63', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S3-1-RELATED', 253891),
(434226, 'PTHR11760', NULL, NULL, NULL, NULL, '30S/40S RIBOSOMAL PROTEIN S3', 253891),
(434227, 'PTHR31162:SF2', NULL, NULL, NULL, NULL, 'MALIC ACID TRANSPORT PROTEIN', 253892),
(434228, 'PTHR31162:SF1', NULL, NULL, NULL, NULL, 'TRANSPORTER/MALIC ACID TRANSPORT PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G17660)-RELATED', 253892),
(434229, 'PTHR31162:SF0', NULL, NULL, NULL, NULL, 'MALIC ACID TRANSPORT PROTEIN-RELATED', 253892),
(434230, 'PTHR31162', NULL, NULL, NULL, NULL, 'MALIC ACID TRANSPORT PROTEIN-RELATED', 253892),
(434231, 'PTHR12897:SF4', NULL, NULL, NULL, NULL, 'REGULATOR OF MON1-CCZ1 COMPLEX', 253893),
(434232, 'PTHR12897', NULL, NULL, NULL, NULL, 'COLON CANCER-ASSOCIATED PROTEIN MIC1', 253893),
(434233, 'PTHR31632', NULL, NULL, NULL, NULL, 'IRON TRANSPORTER FTH1', 253894),
(434234, 'PTHR31632:SF7', NULL, NULL, NULL, NULL, 'IRON TRANSPORTER FTH1', 253894),
(434235, 'PTHR31632:SF2', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE IRON PERMEASE', 253894),
(434236, 'PTHR43108:SF4', NULL, NULL, NULL, NULL, 'EXTRACELLULAR SULFATASE SULF-2', 253895),
(434237, 'PTHR43108:SF1', NULL, NULL, NULL, NULL, 'EXTRACELLULAR SULFATASE SULF-1', 253895),
(434238, 'PTHR43108', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINE-6-SULFATASE FAMILY MEMBER', 253895),
(434239, 'PTHR43108:SF7', NULL, NULL, NULL, NULL, 'EXTRACELLULAR SULFATASE', 253895),
(434240, 'PTHR43108:SF8', NULL, NULL, NULL, NULL, 'SD21168P', 253895),
(434241, 'PTHR43108:SF5', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINE-6-SULFATASE', 253895),
(434242, 'PTHR43108:SF6', NULL, NULL, NULL, NULL, 'N-SULPHOGLUCOSAMINE SULPHOHYDROLASE', 253895),
(434243, 'PTHR43108:SF16', NULL, NULL, NULL, NULL, 'EXTRACELLULAR SULFATASE SULF-1 HOMOLOG', 253895),
(434244, 'PTHR43108:SF9', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINE-6-SULFATASE', 253895),
(434245, 'PTHR43108:SF15', NULL, NULL, NULL, NULL, 'SULFATASE DOMAIN-CONTAINING PROTEIN', 253895),
(434246, 'PTHR43108:SF10', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YEJM', 253895),
(434247, 'PTHR43124:SF10', NULL, NULL, NULL, NULL, 'PURINE EFFLUX PUMP PBUE', 253896),
(434248, 'PTHR43124:SF9', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORT FAMILY PROTEIN', 253896),
(434249, 'PTHR43124:SF8', NULL, NULL, NULL, NULL, 'INNER MEMBRANE TRANSPORT PROTEIN YDHP', 253896),
(434250, 'PTHR43124:SF6', NULL, NULL, NULL, NULL, 'TRANSPORTER ARAJ-RELATED', 253896),
(434251, 'PTHR43124:SF5', NULL, NULL, NULL, NULL, 'PURINE RIBONUCLEOSIDE EFFLUX PUMP NEPI', 253896),
(434252, 'PTHR43124', NULL, NULL, NULL, NULL, 'PURINE EFFLUX PUMP PBUE', 253896);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(434253, 'PTHR43124:SF4', NULL, NULL, NULL, NULL, 'SUGAR EFFLUX TRANSPORTER', 253896),
(434254, 'PTHR43124:SF3', NULL, NULL, NULL, NULL, 'CHLORAMPHENICOL EFFLUX PUMP RV0191', 253896),
(434255, 'PTHR21146:SF0', NULL, NULL, NULL, NULL, 'BLOC-1-RELATED COMPLEX SUBUNIT 8', 253897),
(434256, 'PTHR21146:SF2', NULL, NULL, NULL, NULL, '', 253897),
(434257, 'PTHR21146:SF1', NULL, NULL, NULL, NULL, 'PROTEIN MEF2BNB HOMOLOG', 253897),
(434258, 'PTHR21146', NULL, NULL, NULL, NULL, 'MEF2B PROTEIN', 253897),
(434259, 'PTHR48167:SF2', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 253898),
(434260, 'PTHR48167', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 253898),
(434261, 'PTHR35584:SF1', NULL, NULL, NULL, NULL, '', 253899),
(434262, 'PTHR35584', NULL, NULL, NULL, NULL, 'FLAGELLAR ASSOCIATED PROTEIN', 253899),
(434263, 'PTHR12085', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT B'''' SUBUNIT GAMMA', 253900),
(434264, 'PTHR12085:SF4', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', 253900),
(434265, 'PTHR12085:SF3', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT B'''' SUBUNIT GAMMA', 253900),
(434266, 'PTHR12085:SF6', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN PAIR-RELATED', 253900),
(434267, 'PTHR12085:SF5', NULL, NULL, NULL, NULL, 'BNAC09G39240D PROTEIN', 253900),
(434268, 'PTHR37479:SF1', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN FTSL', 253901),
(434269, 'PTHR37479', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN FTSL', 253901),
(434270, 'PTHR43025:SF1', NULL, NULL, NULL, NULL, 'MONOGALACTOSYLDIACYLGLYCEROL SYNTHASE 2, CHLOROPLASTIC', 253902),
(434271, 'PTHR43025:SF6', NULL, NULL, NULL, NULL, 'MONOGALACTOSYLDIACYLGLYCEROL SYNTHASE 3, CHLOROPLASTIC', 253902),
(434272, 'PTHR43025:SF5', NULL, NULL, NULL, NULL, 'MONOGALACTOSYLDIACYLGLYCEROL SYNTHASE', 253902),
(434273, 'PTHR43025:SF3', NULL, NULL, NULL, NULL, 'MONOGALACTOSYLDIACYLGLYCEROL SYNTHASE 1, CHLOROPLASTIC', 253902),
(434274, 'PTHR43025:SF8', NULL, NULL, NULL, NULL, 'MONOGALACTOSYLDIACYLGLYCEROL SYNTHASE 2, CHLOROPLASTIC-RELATED', 253902),
(434275, 'PTHR43025', NULL, NULL, NULL, NULL, 'MONOGALACTOSYLDIACYLGLYCEROL SYNTHASE', 253902),
(434276, 'PTHR14326:SF59', NULL, NULL, NULL, NULL, 'PROTEIN TPX2-LIKE', 253903),
(434277, 'PTHR14326:SF15', NULL, NULL, NULL, NULL, 'OS06G0130200 PROTEIN', 253903),
(434278, 'PTHR14326:SF48', NULL, NULL, NULL, NULL, '', 253903),
(434279, 'PTHR14326:SF25', NULL, NULL, NULL, NULL, 'OS12G0577000 PROTEIN', 253903),
(434280, 'PTHR14326:SF58', NULL, NULL, NULL, NULL, 'TPX2 (TARGETING PROTEIN FOR XKLP2) PROTEIN FAMILY', 253903),
(434281, 'PTHR14326:SF47', NULL, NULL, NULL, NULL, 'PROTEIN TPX2-LIKE ISOFORM X1', 253903),
(434282, 'PTHR14326:SF57', NULL, NULL, NULL, NULL, 'PROTEIN TPX2-LIKE', 253903),
(434283, 'PTHR14326:SF46', NULL, NULL, NULL, NULL, 'PROTEIN TPX2', 253903),
(434284, 'PTHR14326:SF56', NULL, NULL, NULL, NULL, 'CELL CYCLE REGULATED MICROTUBULE ASSOCIATED PROTEIN', 253903),
(434285, 'PTHR14326:SF39', NULL, NULL, NULL, NULL, 'TPX2 (TARGETING PROTEIN FOR XKLP2) PROTEIN FAMILY', 253903),
(434286, 'PTHR14326:SF49', NULL, NULL, NULL, NULL, 'TPX2 DOMAIN-CONTAINING PROTEIN', 253903),
(434287, 'PTHR14326:SF62', NULL, NULL, NULL, NULL, 'TPX2-RELATED', 253903),
(434288, 'PTHR14326:SF61', NULL, NULL, NULL, NULL, 'CELL CYCLE REGULATED MICROTUBULE ASSOCIATED PROTEIN', 253903),
(434289, 'PTHR14326:SF60', NULL, NULL, NULL, NULL, 'TPX2 (TARGETING PROTEIN FOR XKLP2) PROTEIN FAMILY-RELATED', 253903),
(434290, 'PTHR14326:SF44', NULL, NULL, NULL, NULL, 'TARGETING PROTEIN FOR XKLP2', 253903),
(434291, 'PTHR14326:SF55', NULL, NULL, NULL, NULL, 'TPX2_IMPORTIN DOMAIN-CONTAINING PROTEIN', 253903),
(434292, 'PTHR14326:SF54', NULL, NULL, NULL, NULL, 'TPX2 (TARGETING PROTEIN FOR XKLP2) PROTEIN FAMILY', 253903),
(434293, 'PTHR14326:SF32', NULL, NULL, NULL, NULL, 'CELL CYCLE REGULATED MICROTUBULE ASSOCIATED PROTEIN', 253903),
(434294, 'PTHR14326:SF52', NULL, NULL, NULL, NULL, 'BNAC07G17070D PROTEIN', 253903),
(434295, 'PTHR14326:SF63', NULL, NULL, NULL, NULL, 'CELL CYCLE REGULATED MICROTUBULE-ASSOCIATED PROTEIN', 253903);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(434296, 'PTHR14326:SF30', NULL, NULL, NULL, NULL, 'TPX2_IMPORTIN DOMAIN-CONTAINING PROTEIN', 253903),
(434297, 'PTHR14326', NULL, NULL, NULL, NULL, 'TARGETING PROTEIN FOR XKLP2', 253903),
(434298, 'PTHR34267:SF12', NULL, NULL, NULL, NULL, '', 253904),
(434299, 'PTHR34267:SF11', NULL, NULL, NULL, NULL, 'AT0ZI1 PROTEIN', 253904),
(434300, 'PTHR34267:SF16', NULL, NULL, NULL, NULL, 'OS06G0115100 PROTEIN', 253904),
(434301, 'PTHR34267:SF17', NULL, NULL, NULL, NULL, 'OS06G0114500 PROTEIN', 253904),
(434302, 'PTHR34267:SF15', NULL, NULL, NULL, NULL, '', 253904),
(434303, 'PTHR34267:SF18', NULL, NULL, NULL, NULL, '', 253904),
(434304, 'PTHR34267:SF1', NULL, NULL, NULL, NULL, 'OZONE-RESPONSIVE STRESS-LIKE PROTEIN', 253904),
(434305, 'PTHR34267', NULL, NULL, NULL, NULL, 'OS11G0161033 PROTEIN', 253904),
(434306, 'PTHR28083:SF1', NULL, NULL, NULL, NULL, 'GOOD FOR FULL DBP5 ACTIVITY PROTEIN 2', 253905),
(434307, 'PTHR28083', NULL, NULL, NULL, NULL, 'GOOD FOR FULL DBP5 ACTIVITY PROTEIN 2', 253905),
(434308, 'PTHR47118:SF1', NULL, NULL, NULL, NULL, 'CYTOTOXIC AND REGULATORY T-CELL MOLECULE', 253906),
(434309, 'PTHR47118', NULL, NULL, NULL, NULL, 'CYTOTOXIC AND REGULATORY T-CELL MOLECULE', 253906),
(434310, 'PTHR36140:SF3', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253907),
(434311, 'PTHR36140:SF2', NULL, NULL, NULL, NULL, 'OS01G0152950 PROTEIN', 253907),
(434312, 'PTHR36140:SF1', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', 253907),
(434313, 'PTHR36140:SF10', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253907),
(434314, 'PTHR36140:SF7', NULL, NULL, NULL, NULL, '', 253907),
(434315, 'PTHR36140:SF12', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', 253907),
(434316, 'PTHR36140', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN-RELATED', 253907),
(434317, 'PTHR36140:SF13', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN', 253907),
(434318, 'PTHR36140:SF9', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN', 253907),
(434319, 'PTHR34789', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 253908),
(434320, 'PTHR34789:SF1', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 253908),
(434321, 'PTHR34789:SF3', NULL, NULL, NULL, NULL, 'BNAA07G01290D PROTEIN', 253908),
(434322, 'PTHR34789:SF4', NULL, NULL, NULL, NULL, '', 253908),
(434323, 'PTHR34789:SF5', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN', 253908),
(434324, 'PTHR34789:SF6', NULL, NULL, NULL, NULL, 'KERATIN, TYPE II CYTOSKELETAL 1-LIKE', 253908),
(434325, 'PTHR34789:SF7', NULL, NULL, NULL, NULL, '', 253908),
(434326, 'PTHR34789:SF8', NULL, NULL, NULL, NULL, '', 253908),
(434327, 'PTHR14454:SF5', NULL, NULL, NULL, NULL, 'GRB2-ASSOCIATED AND REGULATOR OF MAPK PROTEIN 2', 253909),
(434328, 'PTHR14454:SF6', NULL, NULL, NULL, NULL, 'GRB2-ASSOCIATED AND REGULATOR OF MAPK PROTEIN 1', 253909),
(434329, 'PTHR14454', NULL, NULL, NULL, NULL, 'GRB2-ASSOCIATED AND REGULATOR OF MAPK PROTEIN FAMILY MEMBER', 253909),
(434330, 'PTHR14454:SF11', NULL, NULL, NULL, NULL, 'SERRANO, ISOFORM F', 253909),
(434331, 'PTHR43778', NULL, NULL, NULL, NULL, 'PYRUVATE CARBOXYLASE', 253910),
(434332, 'PTHR43778:SF2', NULL, NULL, NULL, NULL, 'PYRUVATE CARBOXYLASE, MITOCHONDRIAL', 253910),
(434333, 'PTHR40288:SF2', NULL, NULL, NULL, NULL, 'PROTEIN CBG16535', 253911),
(434334, 'PTHR40288:SF1', NULL, NULL, NULL, NULL, 'PROTEIN CBG00647', 253911),
(434335, 'PTHR40288', NULL, NULL, NULL, NULL, 'PROTEIN CBG16535-RELATED', 253911),
(434336, 'PTHR13172:SF10', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM10B', 253912),
(434337, 'PTHR13172', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM9B', 253912),
(434338, 'PTHR13172:SF11', NULL, NULL, NULL, NULL, 'ZF-TIM10_DDP DOMAIN-CONTAINING PROTEIN', 253912),
(434339, 'PTHR13172:SF4', NULL, NULL, NULL, NULL, '', 253912),
(434340, 'PTHR13172:SF2', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM9', 253912),
(434341, 'PTHR13172:SF7', NULL, NULL, NULL, NULL, 'OS05G0111100 PROTEIN', 253912); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(434342, 'PTHR13172:SF5', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM9', 253912),
(434343, 'PTHR13172:SF6', NULL, NULL, NULL, NULL, 'ZF-TIM10_DDP DOMAIN-CONTAINING PROTEIN', 253912),
(434344, 'PTHR13172:SF0', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM10 B', 253912),
(434345, 'PTHR31914', NULL, NULL, NULL, NULL, 'PROTEIN FAM163A', 253913),
(434346, 'PTHR31914:SF2', NULL, NULL, NULL, NULL, 'PROTEIN FAM163A', 253913),
(434347, 'PTHR14389:SF14', NULL, NULL, NULL, NULL, 'SERINE PROTEASE FAM111A', 253914),
(434348, 'PTHR14389:SF4', NULL, NULL, NULL, NULL, 'SERINE PROTEASE FAM111B', 253914),
(434349, 'PTHR14389', NULL, NULL, NULL, NULL, 'SI:CH1073-475A24.1', 253914),
(434350, 'PTHR14389:SF3', NULL, NULL, NULL, NULL, 'SI:CH1073-475A24.1', 253914),
(434351, 'PTHR22306', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 253915),
(434352, 'PTHR22306:SF2', NULL, NULL, NULL, NULL, 'ZMP:0000000624', 253915),
(434353, 'PTHR11412:SF136', NULL, NULL, NULL, NULL, 'GH01829P-RELATED', 253916),
(434354, 'PTHR11412:SF86', NULL, NULL, NULL, NULL, 'COMPLEMENT C4-A-RELATED', 253916),
(434355, 'PTHR11412:SF146', NULL, NULL, NULL, NULL, '', 253916),
(434356, 'PTHR11412:SF133', NULL, NULL, NULL, NULL, 'MURINOGLOBULIN-1-RELATED', 253916),
(434357, 'PTHR11412:SF83', NULL, NULL, NULL, NULL, 'COMPLEMENT C5', 253916),
(434358, 'PTHR11412:SF111', NULL, NULL, NULL, NULL, 'ANAPHYLATOXIN-LIKE DOMAIN-CONTAINING PROTEIN', 253916),
(434359, 'PTHR11412:SF144', NULL, NULL, NULL, NULL, '', 253916),
(434360, 'PTHR11412:SF170', NULL, NULL, NULL, NULL, 'OVOSTATIN', 253916),
(434361, 'PTHR11412:SF160', NULL, NULL, NULL, NULL, 'ALPHA-2-MACROGLOBULIN-LIKE PROTEIN 1', 253916),
(434362, 'PTHR11412:SF171', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 253916),
(434363, 'PTHR11412:SF172', NULL, NULL, NULL, NULL, 'LD23292P', 253916),
(434364, 'PTHR11412:SF150', NULL, NULL, NULL, NULL, 'ALPHA-2-MACROGLOBULIN-LIKE PROTEIN 1', 253916),
(434365, 'PTHR11412:SF162', NULL, NULL, NULL, NULL, 'CD109 ANTIGEN', 253916),
(434366, 'PTHR11412:SF173', NULL, NULL, NULL, NULL, 'ALPHA-2-MACROGLOBULIN-LIKE 1 PSEUDOGENE', 253916),
(434367, 'PTHR11412:SF174', NULL, NULL, NULL, NULL, 'OVOSTATIN HOMOLOG 1-RELATED', 253916),
(434368, 'PTHR11412:SF175', NULL, NULL, NULL, NULL, 'TEP (THIOLESTER CONTAINING PROTEIN)', 253916),
(434369, 'PTHR11412:SF81', NULL, NULL, NULL, NULL, 'COMPLEMENT C3', 253916),
(434370, 'PTHR11412', NULL, NULL, NULL, NULL, 'MACROGLOBULIN / COMPLEMENT', 253916),
(434371, 'PTHR11412:SF92', NULL, NULL, NULL, NULL, 'PREGNANCY ZONE PROTEIN', 253916),
(434372, 'PTHR11412:SF165', NULL, NULL, NULL, NULL, 'ALPHA-2-MACROGLOBULIN', 253916),
(434373, 'PTHR11412:SF166', NULL, NULL, NULL, NULL, 'COMPLEMENT COMPONENT C3', 253916),
(434374, 'PTHR11412:SF167', NULL, NULL, NULL, NULL, 'COMPLEMENT COMPONENT C3B, TANDEM DUPLICATE 1-RELATED', 253916),
(434375, 'PTHR11412:SF139', NULL, NULL, NULL, NULL, 'C3 AND PZP-LIKE ALPHA-2-MACROGLOBULIN DOMAIN-CONTAINING PROTEIN 8', 253916),
(434376, 'PTHR11412:SF116', NULL, NULL, NULL, NULL, 'PREGNANCY ZONE PROTEIN', 253916),
(434377, 'PTHR39515:SF2', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', 253917),
(434378, 'PTHR39515', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', 253917),
(434379, 'PTHR45985:SF8', NULL, NULL, NULL, NULL, 'CHITIN DEACETYLASE-LIKE 9, ISOFORM A', 253918),
(434380, 'PTHR45985:SF6', NULL, NULL, NULL, NULL, 'FI03450P', 253918),
(434381, 'PTHR45985:SF12', NULL, NULL, NULL, NULL, 'CHITIN DEACETYLASE-LIKE 5, ISOFORM B', 253918),
(434382, 'PTHR45985:SF11', NULL, NULL, NULL, NULL, 'LIN-12 AND GLP-1 X-HYBRIDIZING', 253918),
(434383, 'PTHR45985:SF1', NULL, NULL, NULL, NULL, 'VERMIFORM, ISOFORM I', 253918),
(434384, 'PTHR45985:SF5', NULL, NULL, NULL, NULL, 'CHLD3', 253918),
(434385, 'PTHR45985', NULL, NULL, NULL, NULL, '', 253918),
(434386, 'PTHR45985:SF3', NULL, NULL, NULL, NULL, 'CHITIN DEACETYLASE-LIKE 4', 253918),
(434387, 'PTHR13546:SF12', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 85B', 253919),
(434388, 'PTHR13546', NULL, NULL, NULL, NULL, 'RE60986P', 253919); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(434389, 'PTHR13546:SF14', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 85C', 253919),
(434390, 'PTHR13546:SF13', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 85A', 253919),
(434391, 'PTHR13546:SF15', NULL, NULL, NULL, NULL, 'CCDC85', 253919),
(434392, 'PTHR13066:SF2', NULL, NULL, NULL, NULL, 'GOLGIN-45', 253920),
(434393, 'PTHR13066', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER NUCLEAR FACTOR 1 BLZF1  PROTEIN', 253920),
(434394, 'PTHR16046:SF10', NULL, NULL, NULL, NULL, 'SMC5-SMC6 COMPLEX LOCALIZATION FACTOR PROTEIN 2', 253921),
(434395, 'PTHR16046', NULL, NULL, NULL, NULL, 'SMC5-SMC6 COMPLEX LOCALIZATION FACTOR 2', 253921),
(434396, 'PTHR16046:SF9', NULL, NULL, NULL, NULL, 'SMC5-SMC6 COMPLEX LOCALIZATION FACTOR 2', 253921),
(434397, 'PTHR16046:SF11', NULL, NULL, NULL, NULL, 'PROTEIN FAM178B', 253921),
(434398, 'PTHR12917:SF13', NULL, NULL, NULL, NULL, 'PROTEIN DDI1 HOMOLOG 2', 253922),
(434399, 'PTHR12917:SF1', NULL, NULL, NULL, NULL, 'AT13091P', 253922),
(434400, 'PTHR12917:SF15', NULL, NULL, NULL, NULL, 'PROTEIN DDI1 HOMOLOG 1', 253922),
(434401, 'PTHR12917:SF16', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR-INTERACTING PROTEIN 3', 253922),
(434402, 'PTHR12917:SF17', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR-INTERACTING PROTEIN 2', 253922),
(434403, 'PTHR12917:SF18', NULL, NULL, NULL, NULL, 'DNA DAMAGE-INDUCIBLE PROTEIN 1-LIKE', 253922),
(434404, 'PTHR12917:SF19', NULL, NULL, NULL, NULL, 'OS04G0246650 PROTEIN', 253922),
(434405, 'PTHR12917', NULL, NULL, NULL, NULL, 'ASPARTYL PROTEASE DDI-RELATED', 253922),
(434406, 'PTHR17224:SF1', NULL, NULL, NULL, NULL, 'PEPTIDYL-TRNA HYDROLASE-RELATED', 253923),
(434407, 'PTHR17224:SF3', NULL, NULL, NULL, NULL, 'CHLOROPLASTIC GROUP IIB INTRON SPLICING FACILITATOR CRS2-B, CHLOROPLASTIC', 253923),
(434408, 'PTHR17224:SF4', NULL, NULL, NULL, NULL, 'PEPTIDYL-TRNA HYDROLASE, MITOCHONDRIAL', 253923),
(434409, 'PTHR17224:SF5', NULL, NULL, NULL, NULL, 'PEPTIDYL-TRNA HYDROLASE CHLOROPLASTIC', 253923),
(434410, 'PTHR17224:SF7', NULL, NULL, NULL, NULL, 'CHLOROPLASTIC GROUP IIB INTRON SPLICING FACILITATOR CRS2-A, CHLOROPLASTIC', 253923),
(434411, 'PTHR17224', NULL, NULL, NULL, NULL, 'PEPTIDYL-TRNA HYDROLASE', 253923),
(434412, 'PTHR15710:SF129', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253924),
(434413, 'PTHR15710', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE PRAJA', 253924),
(434414, 'PTHR15710:SF126', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434415, 'PTHR15710:SF67', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SGR9, AMYLOPLASTIC', 253924),
(434416, 'PTHR15710:SF124', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253924),
(434417, 'PTHR15710:SF125', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253924),
(434418, 'PTHR15710:SF122', NULL, NULL, NULL, NULL, 'BNACNNG46920D PROTEIN', 253924),
(434419, 'PTHR15710:SF197', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434420, 'PTHR15710:SF230', NULL, NULL, NULL, NULL, 'OS08G0464400 PROTEIN', 253924),
(434421, 'PTHR15710:SF198', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434422, 'PTHR15710:SF195', NULL, NULL, NULL, NULL, 'BNAA04G14410D PROTEIN', 253924),
(434423, 'PTHR15710:SF196', NULL, NULL, NULL, NULL, 'F6A14.12 PROTEIN-RELATED', 253924),
(434424, 'PTHR15710:SF193', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253924),
(434425, 'PTHR15710:SF194', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 253924),
(434426, 'PTHR15710:SF191', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434427, 'PTHR15710:SF192', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434428, 'PTHR15710:SF55', NULL, NULL, NULL, NULL, 'C3HC4-TYPE RING ZINC FINGER PROTEIN', 253924),
(434429, 'PTHR15710:SF115', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL20-LIKE', 253924),
(434430, 'PTHR15710:SF116', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 253924),
(434431, 'PTHR15710:SF59', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL19-RELATED', 253924);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(434432, 'PTHR15710:SF114', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434433, 'PTHR15710:SF199', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434434, 'PTHR15710:SF140', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434435, 'PTHR15710:SF141', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 253924),
(434436, 'PTHR15710:SF44', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434437, 'PTHR15710:SF45', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253924),
(434438, 'PTHR15710:SF146', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RING1-LIKE', 253924),
(434439, 'PTHR15710:SF47', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RZF1', 253924),
(434440, 'PTHR15710:SF132', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MPSR1', 253924),
(434441, 'PTHR15710:SF138', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253924),
(434442, 'PTHR15710:SF34', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RHC1A-RELATED', 253924),
(434443, 'PTHR15710:SF135', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253924),
(434444, 'PTHR15710:SF209', NULL, NULL, NULL, NULL, 'BNAA09G29280D PROTEIN', 253924),
(434445, 'PTHR15710:SF207', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434446, 'PTHR15710:SF208', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RING1-LIKE', 253924),
(434447, 'PTHR15710:SF165', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434448, 'PTHR15710:SF163', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253924),
(434449, 'PTHR15710:SF160', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF181', 253924),
(434450, 'PTHR15710:SF161', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434451, 'PTHR15710:SF22', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434452, 'PTHR15710:SF205', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253924),
(434453, 'PTHR15710:SF206', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 253924),
(434454, 'PTHR15710:SF21', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF126', 253924),
(434455, 'PTHR15710:SF203', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434456, 'PTHR15710:SF204', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434457, 'PTHR15710:SF23', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434458, 'PTHR15710:SF201', NULL, NULL, NULL, NULL, 'BNAA07G04100D PROTEIN', 253924),
(434459, 'PTHR15710:SF168', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434460, 'PTHR15710:SF202', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434461, 'PTHR15710:SF169', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434462, 'PTHR15710:SF200', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253924),
(434463, 'PTHR15710:SF167', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253924),
(434464, 'PTHR15710:SF18', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434465, 'PTHR15710:SF93', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RHC2A-RELATED', 253924),
(434466, 'PTHR15710:SF94', NULL, NULL, NULL, NULL, 'BNAC03G41290D PROTEIN', 253924),
(434467, 'PTHR15710:SF150', NULL, NULL, NULL, NULL, 'BNAA02G05550D PROTEIN', 253924),
(434468, 'PTHR15710:SF97', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434469, 'PTHR15710:SF98', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253924),
(434470, 'PTHR15710:SF159', NULL, NULL, NULL, NULL, 'BNAA09G45710D PROTEIN', 253924),
(434471, 'PTHR15710:SF16', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF115', 253924),
(434472, 'PTHR15710:SF229', NULL, NULL, NULL, NULL, 'RECEPTOR HOMOLOGY REGION, TRANSMEMBRANE DOMAIN- AND RING DOMAIN-CONTAINING PROTEIN 6-LIKE', 253924),
(434473, 'PTHR15710:SF108', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253924);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(434474, 'PTHR15710:SF109', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434475, 'PTHR15710:SF190', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434476, 'PTHR15710:SF2', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE PRAJA-1', 253924),
(434477, 'PTHR15710:SF4', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253924),
(434478, 'PTHR15710:SF5', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE PRAJA-2', 253924),
(434479, 'PTHR15710:SF186', NULL, NULL, NULL, NULL, 'FINGER PROTEIN, PUTATIVE-RELATED', 253924),
(434480, 'PTHR15710:SF220', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253924),
(434481, 'PTHR15710:SF187', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434482, 'PTHR15710:SF82', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434483, 'PTHR15710:SF184', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', 253924),
(434484, 'PTHR15710:SF185', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434485, 'PTHR15710:SF183', NULL, NULL, NULL, NULL, 'OS12G0139201 PROTEIN', 253924),
(434486, 'PTHR15710:SF227', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434487, 'PTHR15710:SF88', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253924),
(434488, 'PTHR15710:SF228', NULL, NULL, NULL, NULL, 'FINGER DOMAIN PROTEIN, PUTATIVE-RELATED', 253924),
(434489, 'PTHR15710:SF104', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253924),
(434490, 'PTHR15710:SF225', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RDUF1', 253924),
(434491, 'PTHR15710:SF226', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434492, 'PTHR15710:SF102', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253924),
(434493, 'PTHR15710:SF223', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE AIP2-LIKE', 253924),
(434494, 'PTHR15710:SF224', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253924),
(434495, 'PTHR15710:SF221', NULL, NULL, NULL, NULL, 'BNAA09G55460D PROTEIN', 253924),
(434496, 'PTHR15710:SF188', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434497, 'PTHR15710:SF189', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253924),
(434498, 'PTHR15710:SF222', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434499, 'PTHR15710:SF218', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253924),
(434500, 'PTHR15710:SF219', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253924),
(434501, 'PTHR15710:SF176', NULL, NULL, NULL, NULL, 'BNAC06G02030D PROTEIN', 253924),
(434502, 'PTHR15710:SF73', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253924),
(434503, 'PTHR15710:SF171', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253924),
(434504, 'PTHR15710:SF74', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE LISTERIN', 253924),
(434505, 'PTHR15710:SF216', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434506, 'PTHR15710:SF77', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253924),
(434507, 'PTHR15710:SF217', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RDUF2', 253924),
(434508, 'PTHR15710:SF214', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253924),
(434509, 'PTHR15710:SF215', NULL, NULL, NULL, NULL, 'BNAC01G28030D PROTEIN', 253924),
(434510, 'PTHR15710:SF212', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434511, 'PTHR15710:SF213', NULL, NULL, NULL, NULL, 'BNAA05G28120D PROTEIN', 253924),
(434512, 'PTHR15710:SF210', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253924),
(434513, 'PTHR15710:SF211', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', 253924),
(434514, 'PTHR15710:SF178', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', 253924),
(434515, 'PTHR12258:SF11', NULL, NULL, NULL, NULL, 'SI:DKEY-51E6.1', 253925);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(434516, 'PTHR12258:SF10', NULL, NULL, NULL, NULL, '14 KDA PHOSPHOHISTIDINE PHOSPHATASE', 253925),
(434517, 'PTHR12258', NULL, NULL, NULL, NULL, 'JANUS-A/JANUS-B', 253925),
(434518, 'PTHR12258:SF5', NULL, NULL, NULL, NULL, 'BCDNA.GH02250-RELATED', 253925),
(434519, 'PTHR30570:SF1', NULL, NULL, NULL, NULL, 'PHOSPHATE-BINDING PROTEIN PSTS', 253926),
(434520, 'PTHR30570:SF6', NULL, NULL, NULL, NULL, 'PHOSPHATE-BINDING PROTEIN PSTS', 253926),
(434521, 'PTHR30570', NULL, NULL, NULL, NULL, 'PERIPLASMIC PHOSPHATE BINDING COMPONENT OF PHOSPHATE ABC TRANSPORTER', 253926),
(434522, 'PTHR30570:SF4', NULL, NULL, NULL, NULL, 'PHOSPHATE-BINDING PROTEIN PSTS 1', 253926),
(434523, 'PTHR31002:SF34', NULL, NULL, NULL, NULL, 'CELL WALL PROTEIN CWP1-RELATED', 253927),
(434524, 'PTHR31002', NULL, NULL, NULL, NULL, 'SERIPAUPERIN', 253927),
(434525, 'PTHR14974:SF3', NULL, NULL, NULL, NULL, 'SIMILAR TO RIKEN CDNA 1700025G04 GENE', 253928),
(434526, 'PTHR14974', NULL, NULL, NULL, NULL, 'SIMILAR TO RIKEN CDNA 1700025G04 GENE', 253928),
(434527, 'PTHR14815', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 17', 253929),
(434528, 'PTHR14815:SF2', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 17', 253929),
(434529, 'PTHR46170', NULL, NULL, NULL, NULL, 'GATOR COMPLEX PROTEIN WDR59', 253930),
(434530, 'PTHR46170:SF1', NULL, NULL, NULL, NULL, 'GATOR COMPLEX PROTEIN WDR59', 253930),
(434531, 'PTHR16001', NULL, NULL, NULL, NULL, 'ECTO-NOX DISULFIDE-THIOL EXCHANGER', 253931),
(434532, 'PTHR16001:SF7', NULL, NULL, NULL, NULL, 'ECTO-NOX DISULFIDE-THIOL EXCHANGER 2', 253931),
(434533, 'PTHR16001:SF6', NULL, NULL, NULL, NULL, 'ECTO-NOX DISULFIDE-THIOL EXCHANGER 1', 253931),
(434534, 'PTHR16001:SF4', NULL, NULL, NULL, NULL, 'ECTO-NOX DISULFIDE-THIOL EXCHANGER 1-LIKE PROTEIN', 253931),
(434535, 'PTHR40081', NULL, NULL, NULL, NULL, 'CONCANAVALIN A-LIKE LECTIN/GLUCANASE', 253932),
(434536, 'PTHR40081:SF1', NULL, NULL, NULL, NULL, 'CONCANAVALIN A-LIKE LECTIN/GLUCANASE', 253932),
(434537, 'PTHR34629:SF4', NULL, NULL, NULL, NULL, 'REPETITIVE PROLINE-RICH CELL WALL PROTEIN 3', 253933),
(434538, 'PTHR34629:SF5', NULL, NULL, NULL, NULL, 'EARLY NODULIN-75-LIKE', 253933),
(434539, 'PTHR34629', NULL, NULL, NULL, NULL, 'PROLINE-RICH EXTENSIN-LIKE PROTEIN EPR1', 253933),
(434540, 'PTHR34629:SF1', NULL, NULL, NULL, NULL, 'PROLINE-RICH EXTENSIN-LIKE PROTEIN EPR1', 253933),
(434541, 'PTHR47102:SF1', NULL, NULL, NULL, NULL, 'BNI1-RELATED PROTEIN 1', 253934),
(434542, 'PTHR47102:SF2', NULL, NULL, NULL, NULL, 'PROTEIN BNI1', 253934),
(434543, 'PTHR47102:SF3', NULL, NULL, NULL, NULL, 'FORMIN-3', 253934),
(434544, 'PTHR47102:SF4', NULL, NULL, NULL, NULL, 'CELL FUSION PROTEIN FUS1', 253934),
(434545, 'PTHR47102', NULL, NULL, NULL, NULL, 'PROTEIN BNI1', 253934),
(434546, 'PTHR36746:SF2', NULL, NULL, NULL, NULL, '', 253935),
(434547, 'PTHR36746:SF4', NULL, NULL, NULL, NULL, '', 253935),
(434548, 'PTHR36746:SF3', NULL, NULL, NULL, NULL, 'BNAC04G51760D PROTEIN', 253935),
(434549, 'PTHR36746', NULL, NULL, NULL, NULL, 'BNAC04G51760D PROTEIN', 253935),
(434550, 'PTHR36746:SF10', NULL, NULL, NULL, NULL, '', 253935),
(434551, 'PTHR36746:SF11', NULL, NULL, NULL, NULL, 'BNACNNG09210D PROTEIN', 253935),
(434552, 'PTHR36746:SF5', NULL, NULL, NULL, NULL, '', 253935),
(434553, 'PTHR36746:SF7', NULL, NULL, NULL, NULL, '', 253935),
(434554, 'PTHR37360', NULL, NULL, NULL, NULL, 'FRAGILE X MENTAL RETARDATION 1 NEIGHBOR PROTEIN', 253936),
(434555, 'PTHR37360:SF1', NULL, NULL, NULL, NULL, 'FRAGILE X MENTAL RETARDATION 1 NEIGHBOR PROTEIN', 253936),
(434556, 'PTHR34038', NULL, NULL, NULL, NULL, 'ATP SYNTHASE MEMBRANE SUBUNIT DAPIT, MITOCHONDRIAL', 253937),
(434557, 'PTHR34038:SF1', NULL, NULL, NULL, NULL, 'ATP SYNTHASE MEMBRANE SUBUNIT K, MITOCHONDRIAL', 253937),
(434558, 'PTHR46905', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL78', 253938),
(434559, 'PTHR46905:SF10', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ATL76-RELATED', 253938),
(434560, 'PTHR46905:SF11', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253938),
(434561, 'PTHR46905:SF20', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL79', 253938);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(434562, 'PTHR46905:SF18', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253938),
(434563, 'PTHR46905:SF19', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253938),
(434564, 'PTHR46905:SF16', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253938),
(434565, 'PTHR46905:SF17', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253938),
(434566, 'PTHR46905:SF8', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL77', 253938),
(434567, 'PTHR46905:SF14', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253938),
(434568, 'PTHR46905:SF7', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL78', 253938),
(434569, 'PTHR46905:SF15', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253938),
(434570, 'PTHR46905:SF12', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253938),
(434571, 'PTHR46905:SF13', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253938),
(434572, 'PTHR46905:SF9', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253938),
(434573, 'PTHR46905:SF4', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253938),
(434574, 'PTHR46905:SF5', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253938),
(434575, 'PTHR46905:SF1', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', 253938),
(434576, 'PTHR28270', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 19', 253939),
(434577, 'PTHR28270:SF1', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 19', 253939),
(434578, 'PTHR47371:SF3', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCEROL TRANSFERASE I', 253940),
(434579, 'PTHR47371:SF1', NULL, NULL, NULL, NULL, 'LIPOTEICHOIC ACID SYNTHASE-LIKE YQGS', 253940),
(434580, 'PTHR47371', NULL, NULL, NULL, NULL, 'LIPOTEICHOIC ACID SYNTHASE', 253940),
(434581, 'PTHR35613:SF2', NULL, NULL, NULL, NULL, '', 253941),
(434582, 'PTHR35613', NULL, NULL, NULL, NULL, '', 253941),
(434583, 'PTHR46881:SF1', NULL, NULL, NULL, NULL, 'PALMDELPHIN', 253942),
(434584, 'PTHR46881', NULL, NULL, NULL, NULL, 'PALMDELPHIN', 253942),
(434585, 'PTHR31996', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 115', 253943),
(434586, 'PTHR31996:SF2', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 115', 253943),
(434587, 'PTHR31996:SF3', NULL, NULL, NULL, NULL, 'BNAC07G15180D PROTEIN', 253943),
(434588, 'PTHR45544:SF1', NULL, NULL, NULL, NULL, 'THIOSULFATE:GLUTATHIONE SULFURTRANSFERASE', 253944),
(434589, 'PTHR45544', NULL, NULL, NULL, NULL, 'THIOSULFATE:GLUTATHIONE SULFURTRANSFERASE', 253944),
(434590, 'PTHR32116:SF27', NULL, NULL, NULL, NULL, 'GALACTURONOSYLTRANSFERASE 13-RELATED', 253945),
(434591, 'PTHR32116:SF66', NULL, NULL, NULL, NULL, 'GALACTURONOSYLTRANSFERASE 5-RELATED', 253945),
(434592, 'PTHR32116:SF88', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 253945),
(434593, 'PTHR32116:SF89', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 253945),
(434594, 'PTHR32116:SF68', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 253945),
(434595, 'PTHR32116:SF62', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 253945),
(434596, 'PTHR32116:SF63', NULL, NULL, NULL, NULL, 'GALACTURONOSYLTRANSFERASE 12-RELATED', 253945),
(434597, 'PTHR32116:SF85', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 253945),
(434598, 'PTHR32116:SF86', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 253945),
(434599, 'PTHR32116:SF64', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 253945),
(434600, 'PTHR32116:SF20', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE GAUT11', 253945),
(434601, 'PTHR32116:SF65', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 253945),
(434602, 'PTHR32116:SF21', NULL, NULL, NULL, NULL, 'OS09G0480400 PROTEIN', 253945),
(434603, 'PTHR32116', NULL, NULL, NULL, NULL, 'GALACTURONOSYLTRANSFERASE 4-RELATED', 253945),
(434604, 'PTHR32116:SF70', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 253945),
(434605, 'PTHR32116:SF92', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 253945),
(434606, 'PTHR32116:SF71', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 253945);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(434607, 'PTHR32116:SF90', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 253945),
(434608, 'PTHR32116:SF101', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 253945),
(434609, 'PTHR32116:SF102', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 253945),
(434610, 'PTHR32116:SF100', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 253945),
(434611, 'PTHR32116:SF59', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 253945),
(434612, 'PTHR32116:SF4', NULL, NULL, NULL, NULL, 'POLYGALACTURONATE 4-ALPHA-GALACTURONOSYLTRANSFERASE', 253945),
(434613, 'PTHR32116:SF7', NULL, NULL, NULL, NULL, 'GALACTURONOSYLTRANSFERASE 4-RELATED', 253945),
(434614, 'PTHR32116:SF99', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 253945),
(434615, 'PTHR32116:SF33', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 253945),
(434616, 'PTHR32116:SF78', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 253945),
(434617, 'PTHR32116:SF12', NULL, NULL, NULL, NULL, 'GALACTURONOSYLTRANSFERASE 7-RELATED', 253945),
(434618, 'PTHR32116:SF58', NULL, NULL, NULL, NULL, 'GALACTURONOSYLTRANSFERASE 2-RELATED', 253945),
(434619, 'PTHR32116:SF73', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 253945),
(434620, 'PTHR32116:SF30', NULL, NULL, NULL, NULL, 'GALACTURONOSYLTRANSFERASE 15-RELATED', 253945),
(434621, 'PTHR32116:SF74', NULL, NULL, NULL, NULL, 'GALACTURONOSYLTRANSFERASE 10-RELATED', 253945),
(434622, 'PTHR32116:SF31', NULL, NULL, NULL, NULL, 'GALACTURONOSYLTRANSFERASE 8', 253945),
(434623, 'PTHR32116:SF98', NULL, NULL, NULL, NULL, 'GALACTURONOSYLTRANSFERASE 14-RELATED', 253945),
(434624, 'PTHR32116:SF76', NULL, NULL, NULL, NULL, 'GALACTURONOSYLTRANSFERASE 3-RELATED', 253945),
(434625, 'PTHR32116:SF80', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 253945),
(434626, 'PTHR32116:SF60', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 253945),
(434627, 'PTHR32116:SF83', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-DIPHOSPHO-SUGAR TRANSFERASE, PLANT GALACTURONOSYLTRANSFERASE GAUT-RELATED', 253945),
(434628, 'PTHR32116:SF61', NULL, NULL, NULL, NULL, 'GALACTURONOSYLTRANSFERASE 9-RELATED', 253945),
(434629, 'PTHR32116:SF0', NULL, NULL, NULL, NULL, 'GALACTURONOSYLTRANSFERASE 6-RELATED', 253945),
(434630, 'PTHR32116:SF105', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 253945),
(434631, 'PTHR32116:SF103', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 253945),
(434632, 'PTHR32116:SF104', NULL, NULL, NULL, NULL, 'HEXOSYLTRANSFERASE', 253945),
(434633, 'PTHR46226:SF14', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL/PHOSPHATIDYLCHOLINE TRANSFER PROTEIN SFH2-LIKE ISOFORM X1', 253946),
(434634, 'PTHR46226:SF3', NULL, NULL, NULL, NULL, 'OS02G0200000 PROTEIN', 253946),
(434635, 'PTHR46226:SF13', NULL, NULL, NULL, NULL, 'OS09G0258000 PROTEIN', 253946),
(434636, 'PTHR46226:SF6', NULL, NULL, NULL, NULL, 'SEC14P-LIKE PHOSPHATIDYLINOSITOL TRANSFER FAMILY PROTEIN', 253946),
(434637, 'PTHR46226:SF5', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 253946),
(434638, 'PTHR46226:SF8', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 253946),
(434639, 'PTHR46226:SF11', NULL, NULL, NULL, NULL, 'SEC14P-LIKE PHOSPHATIDYLINOSITOL TRANSFER FAMILY PROTEIN-RELATED', 253946),
(434640, 'PTHR46226:SF7', NULL, NULL, NULL, NULL, 'CRAL-TRIO LIPID BINDING DOMAIN-CONTAINING PROTEIN-RELATED', 253946),
(434641, 'PTHR46226:SF10', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 253946),
(434642, 'PTHR46226:SF9', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 253946),
(434643, 'PTHR46226', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', 253946),
(434644, 'PTHR20858:SF17', NULL, NULL, NULL, NULL, 'HYDROXYMETHYLPYRIMIDINE/PHOSPHOMETHYLPYRIMIDINE KINASE THI20-RELATED', 253947),
(434645, 'PTHR20858:SF19', NULL, NULL, NULL, NULL, 'PYRIDOXINE KINASE', 253947),
(434646, 'PTHR20858', NULL, NULL, NULL, NULL, 'PHOSPHOMETHYLPYRIMIDINE KINASE', 253947),
(434647, 'PTHR20858:SF21', NULL, NULL, NULL, NULL, 'THIAMINE-PHOSPHATE SYNTHASE', 253947),
(434648, 'PTHR20858:SF20', NULL, NULL, NULL, NULL, 'HYDROXYMETHYLPYRIMIDINE/PHOSPHOMETHYLPYRIMIDINE KINASE C18B5.05C-RELATED', 253947); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(434649, 'PTHR20858:SF22', NULL, NULL, NULL, NULL, 'HYDROXYMETHYLPYRIMIDINE/PHOSPHOMETHYLPYRIMIDINE KINASE 1-RELATED', 253947),
(434650, 'PTHR46165:SF5', NULL, NULL, NULL, NULL, 'RE32936P', 253948),
(434651, 'PTHR46165:SF6', NULL, NULL, NULL, NULL, 'SET AND MYND DOMAIN-CONTAINING PROTEIN 4-LIKE PROTEIN', 253948),
(434652, 'PTHR46165:SF7', NULL, NULL, NULL, NULL, 'SET AND MYND DOMAIN CONTAINING, CLASS 4, MEMBER 3', 253948),
(434653, 'PTHR46165', NULL, NULL, NULL, NULL, 'SET AND MYND DOMAIN-CONTAINING PROTEIN 4', 253948),
(434654, 'PTHR46165:SF2', NULL, NULL, NULL, NULL, 'SET AND MYND DOMAIN-CONTAINING PROTEIN 4', 253948),
(434655, 'PTHR44520:SF1', NULL, NULL, NULL, NULL, 'TWO-COMPONENT SYSTEM REGULATORY PROTEIN', 253949),
(434656, 'PTHR44520', NULL, NULL, NULL, NULL, 'RESPONSE REGULATOR RCP1-RELATED', 253949),
(434657, 'PTHR44520:SF2', NULL, NULL, NULL, NULL, 'RESPONSE REGULATOR RCP1', 253949),
(434658, 'PTHR31013:SF12', NULL, NULL, NULL, NULL, 'THAUMATIN FAMILY', 253950),
(434659, 'PTHR31013:SF13', NULL, NULL, NULL, NULL, 'THAUMATIN FAMILY', 253950),
(434660, 'PTHR31013:SF2', NULL, NULL, NULL, NULL, '', 253950),
(434661, 'PTHR31013:SF10', NULL, NULL, NULL, NULL, 'THAUMATIN FAMILY', 253950),
(434662, 'PTHR31013', NULL, NULL, NULL, NULL, 'THAUMATIN FAMILY PROTEIN-RELATED', 253950),
(434663, 'PTHR23151:SF82', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE COMPLEX PROTEIN X COMPONENT, MITOCHONDRIAL', 253951),
(434664, 'PTHR23151:SF83', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYLLYSINE-RESIDUE ACETYLTRANSFERASE COMPONENT 4 OF PYRUVATE DEHYDROGENASE COMPLEX, CHLOROPLASTIC', 253951),
(434665, 'PTHR23151:SF9', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE PROTEIN X COMPONENT, MITOCHONDRIAL', 253951),
(434666, 'PTHR23151:SF75', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYLLYSINE-RESIDUE ACETYLTRANSFERASE COMPONENT 5 OF PYRUVATE DEHYDROGENASE COMPLEX, CHLOROPLASTIC', 253951),
(434667, 'PTHR23151', NULL, NULL, NULL, NULL, 'DIHYDROLIPOAMIDE ACETYL/SUCCINYL-TRANSFERASE-RELATED', 253951),
(434668, 'PTHR23151:SF88', NULL, NULL, NULL, NULL, 'PERIPHERAL SUBUNIT-BINDING (PSBD) DOMAIN-CONTAINING PROTEIN', 253951),
(434669, 'PTHR23151:SF89', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYLLYSINE-RESIDUE ACETYLTRANSFERASE COMPONENT OF PYRUVATE DEHYDROGENASE COMPLEX, MITOCHONDRIAL', 253951),
(434670, 'PTHR23151:SF67', NULL, NULL, NULL, NULL, 'DIHYDROLIPOAMIDE ACETYLTRANSFERASE COMPONENT OF PYRUVATE DEHYDROGENASE COMPLEX', 253951),
(434671, 'PTHR23151:SF90', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYLLYSINE-RESIDUE ACETYLTRANSFERASE COMPONENT OF PYRUVATE DEHYDROGENASE COMPLEX, MITOCHONDRIAL', 253951),
(434672, 'PTHR35743:SF1', NULL, NULL, NULL, NULL, 'NODULIN HOMEOBOX', 253952),
(434673, 'PTHR35743:SF2', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', 253952),
(434674, 'PTHR35743', NULL, NULL, NULL, NULL, 'NODULIN HOMEOBOX', 253952),
(434675, 'PTHR35598:SF1', NULL, NULL, NULL, NULL, '', 253953),
(434676, 'PTHR35598:SF2', NULL, NULL, NULL, NULL, 'ENDOTOXIN_N DOMAIN-CONTAINING PROTEIN', 253953),
(434677, 'PTHR35598:SF3', NULL, NULL, NULL, NULL, 'N-TERMINAL DELTA ENDOTOXIN DOMAIN-CONTAINING PROTEIN', 253953),
(434678, 'PTHR35598', NULL, NULL, NULL, NULL, 'ENDOTOXIN_N DOMAIN-CONTAINING PROTEIN', 253953),
(434679, 'PTHR43605:SF5', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A SYNTHETASE ACSM1, MITOCHONDRIAL', 253954),
(434680, 'PTHR43605:SF6', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A SYNTHETASE ACSM5, MITOCHONDRIAL', 253954),
(434681, 'PTHR43605:SF3', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A SYNTHETASE ACSM2B, MITOCHONDRIAL', 253954),
(434682, 'PTHR43605:SF1', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A SYNTHETASE ACSM6, MITOCHONDRIAL', 253954),
(434683, 'PTHR43605:SF12', NULL, NULL, NULL, NULL, '', 253954),
(434684, 'PTHR43605', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A SYNTHETASE', 253954),
(434685, 'PTHR43605:SF14', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A SYNTHETASE ACSM2A, MITOCHONDRIAL', 253954),
(434686, 'PTHR43605:SF10', NULL, NULL, NULL, NULL, 'ACYL-COA SYNTHETASE MEDIUM CHAIN FAMILY MEMBER 3', 253954),
(434687, 'PTHR43605:SF7', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A SYNTHETASE ACSM3, MITOCHONDRIAL', 253954);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(434688, 'PTHR43605:SF8', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A SYNTHETASE ACSM4, MITOCHONDRIAL', 253954),
(434689, 'PTHR47905', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE PROTEIN 4B', 253955),
(434690, 'PTHR47905:SF1', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE PROTEIN 4B', 253955),
(434691, 'PTHR43734:SF1', NULL, NULL, NULL, NULL, 'PHYTOENE DESATURASE', 253956),
(434692, 'PTHR43734', NULL, NULL, NULL, NULL, 'PHYTOENE DESATURASE', 253956),
(434693, 'PTHR43734:SF7', NULL, NULL, NULL, NULL, '4,4''-DIAPONEUROSPORENE OXYGENASE', 253956),
(434694, 'PTHR43734:SF3', NULL, NULL, NULL, NULL, 'B-CAROTENE KETOLASE', 253956),
(434695, 'PTHR43734:SF4', NULL, NULL, NULL, NULL, 'UDP-GALACTOPYRANOSE MUTASE', 253956),
(434696, 'PTHR47149:SF1', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN RMF', 253957),
(434697, 'PTHR47149:SF2', NULL, NULL, NULL, NULL, 'BNAC06G18130D PROTEIN', 253957),
(434698, 'PTHR47149', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN RMF', 253957),
(434699, 'PTHR13890:SF7', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER MRS2-D-RELATED', 253958),
(434700, 'PTHR13890:SF38', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER MRS2-7-RELATED', 253958),
(434701, 'PTHR13890:SF0', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER MRS2 HOMOLOG, MITOCHONDRIAL', 253958),
(434702, 'PTHR13890:SF58', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER', 253958),
(434703, 'PTHR13890:SF36', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER MRS2-H-RELATED', 253958),
(434704, 'PTHR13890:SF35', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER MRS2-3', 253958),
(434705, 'PTHR13890:SF57', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER', 253958),
(434706, 'PTHR13890:SF2', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER MRS2-4-RELATED', 253958),
(434707, 'PTHR13890:SF39', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER MRS2-5', 253958),
(434708, 'PTHR13890:SF52', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER', 253958),
(434709, 'PTHR13890:SF51', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER', 253958),
(434710, 'PTHR13890:SF50', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER', 253958),
(434711, 'PTHR13890:SF56', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER', 253958),
(434712, 'PTHR13890:SF34', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER MRS2-E', 253958),
(434713, 'PTHR13890:SF10', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER MRS2-C', 253958),
(434714, 'PTHR13890:SF53', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER', 253958),
(434715, 'PTHR13890:SF31', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER MRS2-2-RELATED', 253958),
(434716, 'PTHR13890', NULL, NULL, NULL, NULL, 'RNA SPLICING PROTEIN MRS2, MITOCHONDRIAL', 253958),
(434717, 'PTHR13890:SF49', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER', 253958),
(434718, 'PTHR13890:SF27', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER MRS2, MITOCHONDRIAL', 253958),
(434719, 'PTHR13890:SF26', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER MRS2-1', 253958),
(434720, 'PTHR13890:SF47', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER', 253958),
(434721, 'PTHR13890:SF46', NULL, NULL, NULL, NULL, 'RNA_GG_BIND DOMAIN-CONTAINING PROTEIN', 253958),
(434722, 'PTHR13890:SF29', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER MRS2-F', 253958),
(434723, 'PTHR13890:SF41', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER', 253958),
(434724, 'PTHR13890:SF40', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER MRS2-10', 253958),
(434725, 'PTHR13890:SF45', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER', 253958),
(434726, 'PTHR13890:SF44', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER', 253958),
(434727, 'PTHR13890:SF42', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER', 253958),
(434728, 'PTHR16461:SF5', NULL, NULL, NULL, NULL, 'TOLL-INTERACTING PROTEIN', 253959),
(434729, 'PTHR16461', NULL, NULL, NULL, NULL, 'TOLL-INTERACTING PROTEIN', 253959),
(434730, 'PTHR11442:SF8', NULL, NULL, NULL, NULL, 'HEMOGLOBIN SUBUNIT MU', 253960),
(434731, 'PTHR11442:SF7', NULL, NULL, NULL, NULL, 'HEMOGLOBIN SUBUNIT EPSILON', 253960),
(434732, 'PTHR11442:SF87', NULL, NULL, NULL, NULL, 'GLOBIN DOMAIN-CONTAINING PROTEIN', 253960),
(434733, 'PTHR11442:SF88', NULL, NULL, NULL, NULL, 'GLOBIN DOMAIN-CONTAINING PROTEIN', 253960);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(434734, 'PTHR11442:SF89', NULL, NULL, NULL, NULL, 'HEMOGLOBIN SUBUNIT GAMMA-2', 253960),
(434735, 'PTHR11442:SF35', NULL, NULL, NULL, NULL, 'HEMOGLOBIN SUBUNIT EPSILON-2', 253960),
(434736, 'PTHR11442:SF79', NULL, NULL, NULL, NULL, 'HEMOGLOBIN SUBUNIT ALPHA-3', 253960),
(434737, 'PTHR11442:SF47', NULL, NULL, NULL, NULL, 'HEMOGLOBIN SUBUNIT BETA-H0', 253960),
(434738, 'PTHR11442:SF48', NULL, NULL, NULL, NULL, 'HEMOGLOBIN SUBUNIT ALPHA', 253960),
(434739, 'PTHR11442:SF15', NULL, NULL, NULL, NULL, 'HEMOGLOBIN SUBUNIT THETA-1', 253960),
(434740, 'PTHR11442:SF90', NULL, NULL, NULL, NULL, 'HEMOGLOBIN SUBUNIT DELTA', 253960),
(434741, 'PTHR11442', NULL, NULL, NULL, NULL, 'HEMOGLOBIN FAMILY MEMBER', 253960),
(434742, 'PTHR11442:SF91', NULL, NULL, NULL, NULL, 'EMBRYONIC ALPHA GLOBIN E1-RELATED', 253960),
(434743, 'PTHR11442:SF92', NULL, NULL, NULL, NULL, '', 253960),
(434744, 'PTHR11442:SF93', NULL, NULL, NULL, NULL, 'HEMOGLOBIN SUBUNIT ALPHA-RELATED', 253960),
(434745, 'PTHR11442:SF50', NULL, NULL, NULL, NULL, 'HEMOGLOBIN SUBUNIT DELTA', 253960),
(434746, 'PTHR11442:SF94', NULL, NULL, NULL, NULL, 'HEMOGLOBIN SUBUNIT GAMMA-1', 253960),
(434747, 'PTHR11442:SF84', NULL, NULL, NULL, NULL, 'HEMOGLOBIN SUBUNIT EPSILON-Y2', 253960),
(434748, 'PTHR11442:SF95', NULL, NULL, NULL, NULL, 'GLOBIN DOMAIN-CONTAINING PROTEIN', 253960),
(434749, 'PTHR11442:SF41', NULL, NULL, NULL, NULL, 'HEMOGLOBIN SUBUNIT ZETA', 253960),
(434750, 'PTHR11442:SF52', NULL, NULL, NULL, NULL, 'HEMOGLOBIN SUBUNIT GAMMA-1', 253960),
(434751, 'PTHR11442:SF96', NULL, NULL, NULL, NULL, 'GLOBIN DOMAIN-CONTAINING PROTEIN', 253960),
(434752, 'PTHR11442:SF42', NULL, NULL, NULL, NULL, 'HEMOGLOBIN SUBUNIT BETA', 253960),
(434753, 'PTHR11442:SF97', NULL, NULL, NULL, NULL, 'ZGC:163057', 253960),
(434754, 'PTHR43552:SF2', NULL, NULL, NULL, NULL, 'DIAMINOBUTYRATE--2-OXOGLUTARATE TRANSAMINASE', 253961),
(434755, 'PTHR43552:SF1', NULL, NULL, NULL, NULL, 'DIAMINOBUTYRATE--2-OXOGLUTARATE AMINOTRANSFERASE', 253961),
(434756, 'PTHR43552', NULL, NULL, NULL, NULL, 'DIAMINOBUTYRATE--2-OXOGLUTARATE AMINOTRANSFERASE', 253961),
(434757, 'PTHR45654', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN MERISTEM L1', 253962),
(434758, 'PTHR45654:SF12', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ROC8', 253962),
(434759, 'PTHR45654:SF56', NULL, NULL, NULL, NULL, 'START DOMAIN-CONTAINING PROTEIN', 253962),
(434760, 'PTHR45654:SF58', NULL, NULL, NULL, NULL, 'BNAA07G37850D PROTEIN', 253962),
(434761, 'PTHR45654:SF15', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN PROTODERMAL FACTOR 2-LIKE', 253962),
(434762, 'PTHR45654:SF17', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HDG11-LIKE', 253962),
(434763, 'PTHR45654:SF101', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN PROTODERMAL FACTOR 2', 253962),
(434764, 'PTHR45654:SF18', NULL, NULL, NULL, NULL, 'BNAC02G09070D PROTEIN', 253962),
(434765, 'PTHR45654:SF100', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN MERISTEM L1-LIKE', 253962),
(434766, 'PTHR45654:SF92', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HDG2-LIKE', 253962),
(434767, 'PTHR45654:SF93', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HDG3', 253962),
(434768, 'PTHR45654:SF94', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER FAMILY PROTEIN / LIPID-BINDING START DOMAIN-CONTAINING PROTEIN-RELATED', 253962),
(434769, 'PTHR45654:SF95', NULL, NULL, NULL, NULL, 'HOMEOBOX LEUCINE ZIPPER PROTEIN', 253962),
(434770, 'PTHR45654:SF96', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ANTHOCYANINLESS 2-LIKE', 253962),
(434771, 'PTHR45654:SF53', NULL, NULL, NULL, NULL, 'HD DOMAIN CLASS TRANSCRIPTION FACTOR', 253962),
(434772, 'PTHR45654:SF97', NULL, NULL, NULL, NULL, 'LEUCINE ZIPPER PROTEIN HDG11, PUTATIVE-RELATED', 253962),
(434773, 'PTHR45654:SF98', NULL, NULL, NULL, NULL, 'BNAC03G30030D PROTEIN', 253962),
(434774, 'PTHR45654:SF55', NULL, NULL, NULL, NULL, 'BNAC04G12430D PROTEIN', 253962),
(434775, 'PTHR45654:SF99', NULL, NULL, NULL, NULL, 'HOMEOBOX AND START DOMAINS CONTAINING PROTEIN', 253962);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(434776, 'PTHR45654:SF11', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HDG5', 253962),
(434777, 'PTHR45654:SF9', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HDG10-RELATED', 253962),
(434778, 'PTHR45654:SF23', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN', 253962),
(434779, 'PTHR45654:SF24', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN GLABRA 2', 253962),
(434780, 'PTHR45654:SF25', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HDG7', 253962),
(434781, 'PTHR45654:SF69', NULL, NULL, NULL, NULL, 'START DOMAIN, HOMEODOMAIN-LIKE PROTEIN-RELATED', 253962),
(434782, 'PTHR45654:SF28', NULL, NULL, NULL, NULL, 'HOMEODOMAIN LEUCINE ZIPPER FAMILY IV PROTEIN', 253962),
(434783, 'PTHR45654:SF29', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN', 253962),
(434784, 'PTHR45654:SF2', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN TF1', 253962),
(434785, 'PTHR45654:SF1', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HDG12', 253962),
(434786, 'PTHR45654:SF61', NULL, NULL, NULL, NULL, 'BNACNNG18470D PROTEIN', 253962),
(434787, 'PTHR45654:SF62', NULL, NULL, NULL, NULL, '', 253962),
(434788, 'PTHR45654:SF63', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HDG8', 253962),
(434789, 'PTHR45654:SF64', NULL, NULL, NULL, NULL, 'BNAC08G44100D PROTEIN', 253962),
(434790, 'PTHR45654:SF5', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ANTHOCYANINLESS 2-RELATED', 253962),
(434791, 'PTHR45654:SF20', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ANTHOCYANINLESS 2-LIKE', 253962),
(434792, 'PTHR45654:SF3', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ROC1', 253962),
(434793, 'PTHR45654:SF80', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ROC7', 253962),
(434794, 'PTHR45654:SF37', NULL, NULL, NULL, NULL, 'HOMEODOMAIN LEUCINE ZIPPER FAMILY IV PROTEIN', 253962),
(434795, 'PTHR45654:SF70', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HDG11', 253962),
(434796, 'PTHR45654:SF71', NULL, NULL, NULL, NULL, 'START DOMAIN, HOMEODOMAIN-LIKE PROTEIN-RELATED', 253962),
(434797, 'PTHR45654:SF72', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN PROTODERMAL FACTOR 2-LIKE ISOFORM X1', 253962),
(434798, 'PTHR45654:SF74', NULL, NULL, NULL, NULL, 'BNAC04G04470D PROTEIN', 253962),
(434799, 'PTHR45654:SF75', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HDG7', 253962),
(434800, 'PTHR45654:SF76', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HDG1', 253962),
(434801, 'PTHR45654:SF77', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN MERISTEM L1', 253962),
(434802, 'PTHR45654:SF90', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ROC7-LIKE', 253962),
(434803, 'PTHR45654:SF91', NULL, NULL, NULL, NULL, 'BNAA09G28630D PROTEIN', 253962),
(434804, 'PTHR45654:SF89', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ROC4', 253962),
(434805, 'PTHR45654:SF48', NULL, NULL, NULL, NULL, 'HOMEOBOX LEUCINE ZIPPER PROTEIN ROC2', 253962),
(434806, 'PTHR45654:SF49', NULL, NULL, NULL, NULL, 'HOMEOBOX LEUCINE ZIPPER PROTEIN', 253962),
(434807, 'PTHR45654:SF81', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HDG2', 253962),
(434808, 'PTHR45654:SF82', NULL, NULL, NULL, NULL, 'BNAA06G35810D PROTEIN', 253962),
(434809, 'PTHR45654:SF83', NULL, NULL, NULL, NULL, 'START DOMAIN-CONTAINING PROTEIN', 253962),
(434810, 'PTHR45654:SF42', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HDG6', 253962),
(434811, 'PTHR45654:SF87', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ROC6', 253962),
(434812, 'PTHR45654:SF88', NULL, NULL, NULL, NULL, 'BNAA04G18690D PROTEIN', 253962),
(434813, 'PTHR45654:SF44', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HDG4', 253962),
(434814, 'PTHR21298:SF2', NULL, NULL, NULL, NULL, 'GH01721P', 253963),
(434815, 'PTHR21298', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', 253963),
(434816, 'PTHR20966', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX PROTEIN 17', 253964),
(434817, 'PTHR20966:SF2', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX PROTEIN 17', 253964);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(434818, 'PTHR47693', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR RISBZ3-RELATED', 253965),
(434819, 'PTHR47693:SF1', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR RISBZ3', 253965),
(434820, 'PTHR47693:SF2', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR RISBZ5', 253965),
(434821, 'PTHR28124', NULL, NULL, NULL, NULL, 'DNA REPLICATION REGULATOR SLD2', 253966),
(434822, 'PTHR28124:SF1', NULL, NULL, NULL, NULL, 'DNA REPLICATION REGULATOR SLD2', 253966),
(434823, 'PTHR47863:SF2', NULL, NULL, NULL, NULL, 'MYB-LIKE DOMAIN-CONTAINING PROTEIN', 253967),
(434824, 'PTHR47863:SF4', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', 253967),
(434825, 'PTHR47863:SF5', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE PROTEIN WITH RING/FYVE/PHD-TYPE ZINC FINGER DOMAIN-CONTAINING PROTEIN-RELATED', 253967),
(434826, 'PTHR47863:SF8', NULL, NULL, NULL, NULL, 'MYB-LIKE DOMAIN-CONTAINING PROTEIN', 253967),
(434827, 'PTHR47863:SF9', NULL, NULL, NULL, NULL, 'F10B6.17', 253967),
(434828, 'PTHR47863:SF10', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE, ZINC FINGER, RING/FYVE/PHD-TYPE-RELATED', 253967),
(434829, 'PTHR47863:SF13', NULL, NULL, NULL, NULL, 'PHD DOMAIN-CONTAINING PROTEIN', 253967),
(434830, 'PTHR47863', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER SUPERFAMILY PROTEIN', 253967),
(434831, 'PTHR47863:SF12', NULL, NULL, NULL, NULL, 'PHD-FINGER PROTEIN', 253967),
(434832, 'PTHR36710:SF2', NULL, NULL, NULL, NULL, 'EMB|CAB66412.1-RELATED', 253968),
(434833, 'PTHR36710:SF11', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR', 253968),
(434834, 'PTHR36710:SF3', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR SUPERFAMILY PROTEIN', 253968),
(434835, 'PTHR36710:SF12', NULL, NULL, NULL, NULL, 'CELL WALL / VACUOLAR INHIBITOR OF FRUCTOSIDASE 2-LIKE', 253968),
(434836, 'PTHR36710:SF13', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', 253968),
(434837, 'PTHR36710:SF1', NULL, NULL, NULL, NULL, 'F14J9.2 PROTEIN', 253968),
(434838, 'PTHR36710:SF14', NULL, NULL, NULL, NULL, 'PECTINESTERASE INHIBITOR 2', 253968),
(434839, 'PTHR36710:SF15', NULL, NULL, NULL, NULL, 'PECTINESTERASE INHIBITOR 5-RELATED', 253968),
(434840, 'PTHR36710:SF16', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR SUPERFAMILY PROTEIN', 253968),
(434841, 'PTHR36710:SF17', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR SUPERFAMILY PROTEIN', 253968),
(434842, 'PTHR36710:SF4', NULL, NULL, NULL, NULL, 'PECTINESTERASE INHIBITOR 1', 253968),
(434843, 'PTHR36710:SF5', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 253968),
(434844, 'PTHR36710:SF18', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 253968),
(434845, 'PTHR36710:SF20', NULL, NULL, NULL, NULL, 'PECTINESTERASE INHIBITOR DOMAIN PROTEIN', 253968),
(434846, 'PTHR36710:SF21', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 253968),
(434847, 'PTHR36710:SF10', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 253968),
(434848, 'PTHR36710:SF19', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 253968),
(434849, 'PTHR36710:SF8', NULL, NULL, NULL, NULL, 'PECTINESTERASE INHIBITOR-LIKE', 253968),
(434850, 'PTHR36710:SF9', NULL, NULL, NULL, NULL, 'PMEI DOMAIN-CONTAINING PROTEIN', 253968),
(434851, 'PTHR36710', NULL, NULL, NULL, NULL, 'PECTINESTERASE INHIBITOR-LIKE', 253968),
(434852, 'PTHR13087', NULL, NULL, NULL, NULL, 'NF-KAPPA B ACTIVATING PROTEIN', 253969),
(434853, 'PTHR13087:SF3', NULL, NULL, NULL, NULL, 'NKAP-LIKE PROTEIN', 253969),
(434854, 'PTHR13087:SF12', NULL, NULL, NULL, NULL, 'NKAP_C DOMAIN-CONTAINING PROTEIN', 253969),
(434855, 'PTHR13087:SF2', NULL, NULL, NULL, NULL, 'NF-KAPPA-B-ACTIVATING PROTEIN', 253969),
(434856, 'PTHR13087:SF11', NULL, NULL, NULL, NULL, 'NKAP_C DOMAIN-CONTAINING PROTEIN', 253969),
(434857, 'PTHR13087:SF0', NULL, NULL, NULL, NULL, 'NKAP_C DOMAIN-CONTAINING PROTEIN', 253969),
(434858, 'PTHR36752:SF2', NULL, NULL, NULL, NULL, 'OS12G0405700 PROTEIN', 253970),
(434859, 'PTHR36752:SF3', NULL, NULL, NULL, NULL, 'WOUND-INDUCED BASIC PROTEIN-LIKE', 253970);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(434860, 'PTHR36752:SF7', NULL, NULL, NULL, NULL, 'WOUND-INDUCED BASIC PROTEIN', 253970),
(434861, 'PTHR36752', NULL, NULL, NULL, NULL, 'OS12G0405700 PROTEIN', 253970),
(434862, 'PTHR28097', NULL, NULL, NULL, NULL, 'PHEROMONE A FACTOR RECEPTOR', 253971),
(434863, 'PTHR28097:SF1', NULL, NULL, NULL, NULL, 'PHEROMONE A FACTOR RECEPTOR', 253971),
(434864, 'PTHR19300:SF33', NULL, NULL, NULL, NULL, 'BETA-1,4-GALACTOSYLTRANSFERASE 3', 253972),
(434865, 'PTHR19300:SF45', NULL, NULL, NULL, NULL, 'BETA-1,4-GALACTOSYLTRANSFERASE 5', 253972),
(434866, 'PTHR19300:SF34', NULL, NULL, NULL, NULL, 'SI:DKEY-199F5.8', 253972),
(434867, 'PTHR19300:SF46', NULL, NULL, NULL, NULL, 'N-ACETYLLACTOSAMINE SYNTHASE', 253972),
(434868, 'PTHR19300:SF57', NULL, NULL, NULL, NULL, 'BETA1,4-N-ACETYLGALACTOSAMINYLTRANSFERASE A', 253972),
(434869, 'PTHR19300:SF47', NULL, NULL, NULL, NULL, 'BETA-1,4-GALACTOSYLTRANSFERASE 6', 253972),
(434870, 'PTHR19300:SF59', NULL, NULL, NULL, NULL, '', 253972),
(434871, 'PTHR19300:SF48', NULL, NULL, NULL, NULL, 'BETA1,4-N-ACETYLGALACTOSAMINYLTRANSFERASE B', 253972),
(434872, 'PTHR19300:SF38', NULL, NULL, NULL, NULL, 'GLYCO_TRANSF_7N DOMAIN-CONTAINING PROTEIN', 253972),
(434873, 'PTHR19300:SF5', NULL, NULL, NULL, NULL, 'BETA-1,4-GALACTOSYLTRANSFERASE 1', 253972),
(434874, 'PTHR19300:SF30', NULL, NULL, NULL, NULL, 'BETA-1,4-GALACTOSYLTRANSFERASE 7', 253972),
(434875, 'PTHR19300:SF42', NULL, NULL, NULL, NULL, 'BETA-1,4-GALACTOSYLTRANSFERASE 3-LIKE', 253972),
(434876, 'PTHR19300:SF32', NULL, NULL, NULL, NULL, 'BETA-1,4-GALACTOSYLTRANSFERASE 2', 253972),
(434877, 'PTHR19300', NULL, NULL, NULL, NULL, 'BETA-1,4-GALACTOSYLTRANSFERASE', 253972),
(434878, 'PTHR19300:SF9', NULL, NULL, NULL, NULL, 'BETA-1,4-GALACTOSYLTRANSFERASE 4', 253972),
(434879, 'PF19796', NULL, 'Family of unknown function (DUF6280)', 86, NULL, 'DUF6280', 253973),
(434880, 'PF03403', NULL, 'Platelet-activating factor acetylhydrolase, isoform II', 379, NULL, 'PAF-AH_p_II', 253974),
(434881, 'PF11707', NULL, 'Ribosome 60S biogenesis N-terminal', 339, NULL, 'Npa1', 253975),
(434882, 'PF16999', NULL, 'Vacuolar (H+)-ATPase G subunit', 104, NULL, 'V-ATPase_G_2', 253976),
(434883, 'PF03972', NULL, 'MmgE/PrpD N-terminal domain', 245, NULL, 'MmgE_PrpD', 253977),
(434884, 'PF09632', NULL, 'Rac1-binding domain', 297, NULL, 'Rac1', 253978),
(434885, 'PF01223', NULL, 'DNA/RNA non-specific endonuclease', 226, NULL, 'Endonuclease_NS', 253979),
(434886, 'PF18026', NULL, 'Endo/exonuclease (EXOG) C-terminal domain', 49, NULL, 'Exog_C', 253980),
(434887, 'PF15657', NULL, 'HNH/Endo VII superfamily nuclease toxins', 72, NULL, 'Tox-HNH-EHHH', 253981),
(434888, 'PF16326', NULL, 'ABC transporter C-terminal domain', 69, NULL, 'ABC_tran_CTD', 253982),
(434889, 'PF16958', NULL, 'Pre-mRNA-splicing factor PRP9 N-terminus', 150, NULL, 'PRP9_N', 253983),
(434890, 'PF08810', NULL, 'Kinase associated protein B', 112, NULL, 'KapB', 253984),
(434891, 'PF13425', NULL, 'O-antigen ligase like membrane protein', 465, NULL, 'O-antigen_lig', 253985),
(434892, 'PF03475', NULL, '3-alpha domain', 44, NULL, '3-alpha', 253986),
(434893, 'PF07614', NULL, 'Protein of unknown function (DUF1577)', 256, NULL, 'DUF1577', 253987),
(434894, 'PF13131', NULL, 'Protein of unknown function (DUF3951)', 52, NULL, 'DUF3951', 253988),
(434895, 'PF04227', NULL, 'Indigoidine synthase A like protein', 291, NULL, 'Indigoidine_A', 253989),
(434896, 'PF00212', NULL, 'Atrial natriuretic peptide', 31, NULL, 'ANP', 253990),
(434897, 'PF02175', NULL, 'Serpentine type 7TM GPCR chemoreceptor Srb', 236, NULL, '7TM_GPCR_Srb', 253991),
(434898, 'PF05733', NULL, 'Tenuivirus/Phlebovirus nucleocapsid protein', 246, NULL, 'Tenui_N', 253992),
(434899, 'PF04391', NULL, 'Protein of unknown function (DUF533)', 178, NULL, 'DUF533', 253993),
(434900, 'PF13540', NULL, 'Regulator of chromosome condensation (RCC1) repeat', 30, NULL, 'RCC1_2', 253994),
(434901, 'PF17590', NULL, 'Family of unknown function (DUF5488)', 70, NULL, 'DUF5488', 253995),
(434902, 'PF10667', NULL, 'Protein of unknown function (DUF2486)', 251, NULL, 'DUF2486', 253996);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(434903, 'PF17500', NULL, 'Colicin-K immunity', 96, NULL, 'CKI', 253997),
(434904, 'PF17603', NULL, 'Family of unknown function (DUF5499)', 97, NULL, 'DUF5499', 253998),
(434905, 'PF00705', NULL, 'Proliferating cell nuclear antigen, N-terminal domain', 127, NULL, 'PCNA_N', 253999),
(434906, 'PF02983', NULL, 'Alpha-lytic protease prodomain', 59, NULL, 'Pro_Al_protease', 254000),
(434907, 'PF15782', NULL, 'GREB1 N-terminal region', 1102, NULL, 'GREB1', 254001),
(434908, 'PF01553', NULL, 'Acyltransferase', 135, NULL, 'Acyltransferase', 254002),
(434909, 'PF06304', NULL, 'Protein of unknown function (DUF1048)', 102, NULL, 'DUF1048', 254003),
(434910, 'PF11182', NULL, 'Alginate O-acetyl transferase AlgF', 178, NULL, 'AlgF', 254004),
(434911, 'PF19180', NULL, 'Family of unknown function (DUF5862)', 68, NULL, 'DUF5862', 254005),
(434912, 'PF10818', NULL, 'secA translation cis-regulator SecM, small type', 96, NULL, 'SecM_small', 254006),
(434913, 'PF00992', NULL, 'Troponin', 132, NULL, 'Troponin', 254007),
(434914, 'PF01481', NULL, 'Arterivirus nucleocapsid protein', 116, NULL, 'Arteri_nucleo', 254008),
(434915, 'PF00808', NULL, 'Histone-like transcription factor (CBF/NF-Y) and archaeal histone', 65, NULL, 'CBFD_NFYB_HMF', 254009),
(434916, 'PF04053', NULL, 'Coatomer WD associated region', 445, NULL, 'Coatomer_WDAD', 254010),
(434917, 'PF01431', NULL, 'Peptidase family M13', 205, NULL, 'Peptidase_M13', 254011),
(434918, 'PF06904', NULL, 'Extensin-like protein C-terminus', 177, NULL, 'Extensin-like_C', 254012),
(434919, 'PF14627', NULL, 'Domain of unknown function (DUF4453)', 107, NULL, 'DUF4453', 254013),
(434920, 'PF13694', NULL, 'Sec63/Sec62 complex-interacting family', 184, NULL, 'Hph', 254014),
(434921, 'PF14312', NULL, 'FG-GAP repeat', 49, NULL, 'FG-GAP_2', 254015),
(434922, 'PF10260', NULL, 'Uncharacterized conserved domain (SAYSvFN)', 70, NULL, 'SAYSvFN', 254016),
(434923, 'PF12482', NULL, 'Phage integrase protein', 93, NULL, 'DUF3701', 254017),
(434924, 'PF02439', NULL, 'Adenovirus E3 region protein CR2', 38, NULL, 'Adeno_E3_CR2', 254018),
(434925, 'PF15967', NULL, 'Nucleoporin FG repeated region', 583, NULL, 'Nucleoporin_FG2', 254019),
(434926, 'PF03928', NULL, 'Haem degrading protein HbpS-like', 120, NULL, 'HbpS-like', 254020),
(434927, 'PF06678', NULL, 'Protein of unknown function (DUF1179)', 107, NULL, 'DUF1179', 254021),
(434928, 'PF10853', NULL, 'Protein of unknown function (DUF2650)', 37, NULL, 'DUF2650', 254022),
(434929, 'PF01558', NULL, 'Pyruvate ferredoxin/flavodoxin oxidoreductase', 176, NULL, 'POR', 254023),
(434930, 'PF06465', NULL, 'CHD subfamily II, DUF1087', 65, NULL, 'DUF1087', 254024),
(434931, 'PF20352', NULL, 'Family of unknown function (DUF6647)', 175, NULL, 'DUF6647', 254025),
(434932, 'PF20609', NULL, 'Putative adhesive domain (group 17)', 291, NULL, 'pAdhesive_17', 254026),
(434933, 'PF05215', NULL, 'Spiralin domain', 82, NULL, 'Spiralin', 254027),
(434934, 'PF00552', NULL, 'Integrase DNA binding domain', 45, NULL, 'IN_DBD_C', 254028),
(434935, 'PF17384', NULL, 'RimP C-terminal SH3 domain', 70, NULL, 'DUF150_C', 254029),
(434936, 'PF15571', NULL, 'Immunity protein 44', 126, NULL, 'Imm44', 254030),
(434937, 'PF19420', NULL, 'N,N dimethylarginine dimethylhydrolase, eukaryotic', 291, NULL, 'DDAH_eukar', 254031),
(434938, 'PF11350', NULL, 'Protein of unknown function (DUF3152)', 206, NULL, 'DUF3152', 254032),
(434939, 'PF00799', NULL, 'Geminivirus Rep catalytic domain', 113, NULL, 'Gemini_AL1', 254033),
(434940, 'PF07393', NULL, 'Exocyst complex component Sec10', 711, NULL, 'Sec10', 254034),
(434941, 'PF12475', NULL, 'Amdovirus non-structural protein', 48, NULL, 'Amdo_NSP', 254035),
(434942, 'PF17793', NULL, 'ANC1 homology domain (AHD)', 61, NULL, 'AHD', 254036),
(434943, 'PF09117', NULL, 'MiAMP1', 76, NULL, 'MiAMP1', 254037),
(434944, 'PF07611', NULL, 'Protein of unknown function (DUF1574)', 342, NULL, 'DUF1574', 254038),
(434945, 'PF14962', NULL, 'Mitochondria Localisation Sequence', 192, NULL, 'AIF-MLS', 254039),
(434946, 'PF06328', NULL, 'Ig-like C2-type domain', 86, NULL, 'Lep_receptor_Ig', 254040);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(434947, 'PF17102', NULL, 'Stealth protein CR3, conserved region 3', 49, NULL, 'Stealth_CR3', 254041),
(434948, 'PF10767', NULL, 'Protein of unknown function (DUF2593)', 141, NULL, 'DUF2593', 254042),
(434949, 'PF07267', NULL, 'Nucleopolyhedrovirus capsid protein P87', 650, NULL, 'Nucleo_P87', 254043),
(434950, 'PF10522', NULL, 'RII binding domain', 19, NULL, 'RII_binding_1', 254044),
(434951, 'PF13248', NULL, 'zinc-ribbon domain', 27, NULL, 'zf-ribbon_3', 254045),
(434952, 'PF06596', NULL, 'Photosystem II reaction centre X protein (PsbX)', 38, NULL, 'PsbX', 254046),
(434953, 'PF20052', NULL, 'GTPase-associated protein 1, C-terminal domain', 514, NULL, 'GAP1-C', 254047),
(434954, 'PF04394', NULL, 'Protein of unknown function, DUF536', 43, NULL, 'DUF536', 254048),
(434955, 'PF15067', NULL, 'FAM124 family', 235, NULL, 'FAM124', 254049),
(434956, 'PF02429', NULL, 'Peridinin-chlorophyll A binding protein', 145, NULL, 'PCP', 254050),
(434957, 'PF06684', NULL, 'Amino acid synthesis', 176, NULL, 'AA_synth', 254051),
(434958, 'PF17600', NULL, 'Family of unknown function (DUF5496)', 87, NULL, 'DUF5496', 254052),
(434959, 'PF15499', NULL, 'Ubiquitin-specific peptidase-like, SUMO isopeptidase', 272, NULL, 'Peptidase_C98', 254053),
(434960, 'PF19549', NULL, 'Family of unknown function (DUF6072)', 129, NULL, 'DUF6072', 254054),
(434961, 'PF00449', NULL, 'Urease alpha-subunit, N-terminal domain', 121, NULL, 'Urease_alpha', 254055),
(434962, 'PF13578', NULL, 'Methyltransferase domain', 107, NULL, 'Methyltransf_24', 254056),
(434963, 'PF19626', NULL, 'Family of unknown function (DUF6131)', 59, NULL, 'DUF6131', 254057),
(434964, 'PF16621', NULL, 'SH3 terminal domain of 2nd SH3 on Neutrophil cytosol factor 1', 50, NULL, 'NECFESHC', 254058),
(434965, 'PF05052', NULL, 'MerE protein', 75, NULL, 'MerE', 254059),
(434966, 'PF07827', NULL, 'KNTase C-terminal domain', 132, NULL, 'KNTase_C', 254060),
(434967, 'PF18138', NULL, 'Bacterial HORMA domain family 1', 169, NULL, 'bacHORMA_1', 254061),
(434968, 'PF19280', NULL, 'Ceramide kinase C-terminal domain', 227, NULL, 'CERK_C', 254062),
(434969, 'PF15560', NULL, 'Immunity protein 12', 138, NULL, 'Imm12', 254063),
(434970, 'PF06208', NULL, 'Borna disease virus G protein', 503, NULL, 'BDV_G', 254064),
(434971, 'PF09296', NULL, 'NADH pyrophosphatase-like rudimentary NUDIX domain', 102, NULL, 'NUDIX-like', 254065),
(434972, 'PF10458', NULL, 'Valyl tRNA synthetase tRNA binding arm', 66, NULL, 'Val_tRNA-synt_C', 254066),
(434973, 'PF11760', NULL, 'Cobalamin synthesis G N-terminal', 82, NULL, 'CbiG_N', 254067),
(434974, 'PF19285', NULL, 'Neuromedin-U receptor 2, C-terminal', 67, NULL, 'NmU-R2_C_term', 254068),
(434975, 'PF02394', NULL, 'Interleukin-1 propeptide', 108, NULL, 'IL1_propep', 254069),
(434976, 'PF14363', NULL, 'Domain associated at C-terminal with AAA', 96, NULL, 'AAA_assoc', 254070),
(434977, 'PF05262', NULL, 'Borrelia P83/100 protein', 489, NULL, 'Borrelia_P83', 254071),
(434978, 'PF06293', NULL, 'Lipopolysaccharide kinase (Kdo/WaaP) family', 207, NULL, 'Kdo', 254072),
(434979, 'PF04017', NULL, 'Domain of unknown function (DUF366)', 183, NULL, 'DUF366', 254073),
(434980, 'PF19234', NULL, 'Family of unknown function (DUF5887)', 136, NULL, 'DUF5887', 254074),
(434981, 'PF15556', NULL, 'ZW10 interactor', 252, NULL, 'Zwint', 254075),
(434982, 'PF09154', NULL, 'Alpha-amylase C-terminal', 57, NULL, 'Alpha-amy_C_pro', 254076),
(434983, 'PF13768', NULL, 'von Willebrand factor type A domain', 155, NULL, 'VWA_3', 254077),
(434984, 'PF14457', NULL, 'Prokaryotic E2 family A', 163, NULL, 'Prok-E2_A', 254078),
(434985, 'PF07877', NULL, 'Protein of unknown function (DUF1661)', 31, NULL, 'DUF1661', 254079),
(434986, 'PF14583', NULL, 'Oligogalacturonate lyase', 386, NULL, 'Pectate_lyase22', 254080),
(434987, 'PF03902', NULL, 'Gal4-like dimerisation domain', 54, NULL, 'Gal4_dimer', 254081),
(434988, 'PF14079', NULL, 'Domain of unknown function (DUF4260)', 113, NULL, 'DUF4260', 254082),
(434989, 'PF16962', NULL, 'Putative ABC exporter', 533, NULL, 'ABC_export', 254083),
(434990, 'PF19719', NULL, 'Family of unknown function (DUF6213)', 66, NULL, 'DUF6213', 254084);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(434991, 'PF13492', NULL, 'GAF domain', 129, NULL, 'GAF_3', 254085),
(434992, 'PF13671', NULL, 'AAA domain', 143, NULL, 'AAA_33', 254086),
(434993, 'PF04768', NULL, 'NAT, N-acetyltransferase, of N-acetylglutamate synthase', 170, NULL, 'NAT', 254087),
(434994, 'PF05077', NULL, 'Protein of unknown function (DUF678)', 75, NULL, 'DUF678', 254088),
(434995, 'PF16724', NULL, 'T4-like virus Myoviridae tail sheath stabiliser', 234, NULL, 'T4-gp15_tss', 254089),
(434996, 'PF03032', NULL, 'Frog skin active peptide family signal and propeptide', 46, NULL, 'FSAP_sig_propep', 254090),
(434997, 'PF15906', NULL, 'Zinc-finger of nitric oxide synthase-interacting protein', 75, NULL, 'zf-NOSIP', 254091),
(434998, 'PF13485', NULL, 'Peptidase MA superfamily', 243, NULL, 'Peptidase_MA_2', 254092),
(434999, 'PF09269', NULL, 'Domain of unknown function (DUF1967)', 69, NULL, 'DUF1967', 254093),
(435000, 'PF16283', NULL, 'Domain of unknown function (DUF4929)', 366, NULL, 'DUF4929', 254094),
(435001, 'PF18036', NULL, 'Ubiquitin-like domain', 89, NULL, 'Ubiquitin_4', 254095),
(435002, 'PF00456', NULL, 'Transketolase, thiamine diphosphate binding domain', 334, NULL, 'Transketolase_N', 254096),
(435003, 'PF19301', NULL, 'LigXa C-terminal domain like', 303, NULL, 'LigXa_C', 254097),
(435004, 'PF09186', NULL, 'Domain of unknown function (DUF1949)', 56, NULL, 'DUF1949', 254098),
(435005, 'PF00207', NULL, 'Alpha-2-macroglobulin family', 92, NULL, 'A2M', 254099),
(435006, 'PF05094', NULL, 'Late expression factor 9 (LEF-9)', 490, NULL, 'LEF-9', 254100),
(435007, 'PF10800', NULL, 'Protein of unknown function (DUF2528)', 104, NULL, 'DUF2528', 254101),
(435008, 'PF03225', NULL, 'Viral heat shock protein Hsp90 homologue', 512, NULL, 'Viral_Hsp90', 254102),
(435009, 'PF13126', NULL, 'Protein of unknown function (DUF3975)', 80, NULL, 'DUF3975', 254103),
(435010, 'PF17122', NULL, 'Zinc-finger', 35, NULL, 'zf-C3H2C3', 254104),
(435011, 'PF03671', NULL, 'Ubiquitin fold modifier 1 protein', 75, NULL, 'Ufm1', 254105),
(435012, 'PF04754', NULL, 'Putative transposase, YhgA-like', 205, NULL, 'Transposase_31', 254106),
(435013, 'PF16445', NULL, 'Domain of unknown function (DUF5042)', 434, NULL, 'DUF5042', 254107),
(435014, 'PF04435', NULL, 'Domain of unknown function (DUF545)', 104, NULL, 'SPK', 254108),
(435015, 'PF06366', NULL, 'Flagellar protein FlhE', 106, NULL, 'FlhE', 254109),
(435016, 'PF19739', NULL, 'Family of unknown function (DUF6228)', 133, NULL, 'DUF6228', 254110),
(435017, 'PF00533', NULL, 'BRCA1 C Terminus (BRCT) domain', 79, NULL, 'BRCT', 254111),
(435018, 'PF10629', NULL, 'Protein of unknown function (DUF2475)', 67, NULL, 'DUF2475', 254112),
(435019, 'PF14550', NULL, 'Putative phage serine protease XkdF', 120, NULL, 'Peptidase_S78_2', 254113),
(435020, 'PF14400', NULL, 'Inactive transglutaminase fused to 7 transmembrane helices', 161, NULL, 'Transglut_i_TM', 254114),
(435021, 'PF16113', NULL, 'Enoyl-CoA hydratase/isomerase', 335, NULL, 'ECH_2', 254115),
(435022, 'PF18982', NULL, 'Family of unknown function (DUF5716)', 434, NULL, 'DUF5716', 254116),
(435023, 'PF04139', NULL, 'Rad9', 256, NULL, 'Rad9', 254117),
(435024, 'PF18971', NULL, 'CagA protein', 876, NULL, 'CagA_N', 254118),
(435025, 'PF09481', NULL, 'CRISPR-associated protein Cse1 (CRISPR_cse1)', 451, NULL, 'CRISPR_Cse1', 254119),
(435026, 'PF20432', NULL, 'Antitoxin Xre-like helix-turn-helix domain', 63, NULL, 'Xre-like-HTH', 254120),
(435027, 'PF05007', NULL, 'Mannosyltransferase (PIG-M)', 259, NULL, 'Mannosyl_trans', 254121),
(435028, 'PF00403', NULL, 'Heavy-metal-associated domain', 62, NULL, 'HMA', 254122),
(435029, 'PF07237', NULL, 'Protein of unknown function (DUF1428)', 101, NULL, 'DUF1428', 254123),
(435030, 'PF16580', NULL, 'C-terminal tail of astrovirus capsid projection or spike', 245, NULL, 'Astro_capsid_p2', 254124),
(435031, 'PF01551', NULL, 'Peptidase family M23', 96, NULL, 'Peptidase_M23', 254125),
(435032, 'PF06315', NULL, 'Isocitrate dehydrogenase kinase/phosphatase (AceK) kinase domain', 256, NULL, 'AceK_kinase', 254126),
(435033, 'PF13835', NULL, 'Domain of unknown function (DUF4194)', 167, NULL, 'DUF4194', 254127);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(435034, 'PF14571', NULL, 'Stress-induced protein Di19, C-terminal', 101, NULL, 'Di19_C', 254128),
(435035, 'PF00767', NULL, 'Potyvirus coat protein', 244, NULL, 'Poty_coat', 254129),
(435036, 'PF01414', NULL, 'Delta serrate ligand', 46, NULL, 'DSL', 254130),
(435037, 'PF12119', NULL, 'Protein of unknown function (DUF3581)', 217, NULL, 'DUF3581', 254131),
(435038, 'PF09052', NULL, 'SipA N-terminal domain', 214, NULL, 'SipA', 254132),
(435039, 'PF15100', NULL, 'TMEM187 protein family', 244, NULL, 'TMEM187', 254133),
(435040, 'PF16890', NULL, 'Domain of unknown function (DUF5083)', 157, NULL, 'DUF5083', 254134),
(435041, 'PF05115', NULL, 'Cytochrome B6-F complex subunit VI (PetL)', 31, NULL, 'PetL', 254135),
(435042, 'PF14506', NULL, 'CppA N-terminal', 124, NULL, 'CppA_N', 254136),
(435043, 'PF07905', NULL, 'Purine catabolism regulatory protein-like family', 117, NULL, 'PucR', 254137),
(435044, 'PF05038', NULL, 'Cytochrome Cytochrome b558 alpha-subunit', 184, NULL, 'Cytochrom_B558a', 254138),
(435045, 'PF10874', NULL, 'Protein of unknown function (DUF2746)', 101, NULL, 'DUF2746', 254139),
(435046, 'PF06018', NULL, 'CodY GAF-like domain', 177, NULL, 'CodY', 254140),
(435047, 'PF13205', NULL, 'Bacterial Ig-like domain', 108, NULL, 'Big_5', 254141),
(435048, 'PF06040', NULL, 'Adenovirus E3 protein', 127, NULL, 'Adeno_E3', 254142),
(435049, 'PF00107', NULL, 'Zinc-binding dehydrogenase', 130, NULL, 'ADH_zinc_N', 254143),
(435050, 'PF05991', NULL, 'YacP-like NYN domain', 166, NULL, 'NYN_YacP', 254144),
(435051, 'PF08637', NULL, 'ATP synthase regulation protein NCA2', 289, NULL, 'NCA2', 254145),
(435052, 'PF09869', NULL, 'Uncharacterized protein conserved in archaea (DUF2096)', 169, NULL, 'DUF2096', 254146),
(435053, 'PF10976', NULL, 'Protein of unknown function (DUF2790)', 78, NULL, 'DUF2790', 254147),
(435054, 'PF10041', NULL, 'Uncharacterized conserved protein (DUF2277)', 78, NULL, 'DUF2277', 254148),
(435055, 'PF02155', NULL, 'Glucocorticoid receptor', 377, NULL, 'GCR', 254149),
(435056, 'PF03088', NULL, 'Strictosidine synthase', 89, NULL, 'Str_synth', 254150),
(435057, 'PF19231', NULL, 'Family of unknown function (DUF5884)', 155, NULL, 'DUF5884', 254151),
(435058, 'PF15283', NULL, 'Domain of unknown function (DUF4595) with porin-like fold', 203, NULL, 'DUF4595', 254152),
(435059, 'PF12061', NULL, 'Late blight resistance protein R1', 297, NULL, 'NB-LRR', 254153),
(435060, 'PF15149', NULL, 'Cation channel sperm-associated protein subunit beta protein family', 520, NULL, 'CATSPERB', 254154),
(435061, 'PF20254', NULL, 'Domain of unknown function (DUF6605)', 380, NULL, 'DUF6605', 254155),
(435062, 'PF00230', NULL, 'Major intrinsic protein', 227, NULL, 'MIP', 254156),
(435063, 'PF04860', NULL, 'Phage portal protein', 316, NULL, 'Phage_portal', 254157),
(435064, 'PF00739', NULL, 'Trans-activation protein X', 142, NULL, 'X', 254158),
(435065, 'PF07873', NULL, 'YabP family', 64, NULL, 'YabP', 254159),
(435066, 'PF03835', NULL, 'Rad4 transglutaminase-like domain', 147, NULL, 'Rad4', 254160),
(435067, 'PF11774', NULL, 'Lsr2', 110, NULL, 'Lsr2', 254161),
(435068, 'PF08967', NULL, 'Domain of unknown function (DUF1884)', 92, NULL, 'DUF1884', 254162),
(435069, 'PF13085', NULL, '2Fe-2S iron-sulfur cluster binding domain', 109, NULL, 'Fer2_3', 254163),
(435070, 'PF03055', NULL, 'Retinal pigment epithelial membrane protein', 476, NULL, 'RPE65', 254164),
(435071, 'PF16418', NULL, 'CCR4-NOT transcription complex subunit 1 HEAT repeat', 150, NULL, 'CNOT1_HEAT', 254165),
(435072, 'PF13466', NULL, 'STAS domain', 80, NULL, 'STAS_2', 254166),
(435073, 'PF00752', NULL, 'XPG N-terminal domain', 101, NULL, 'XPG_N', 254167),
(435074, 'PF04262', NULL, 'Glutamate-cysteine ligase', 372, NULL, 'Glu_cys_ligase', 254168),
(435075, 'PF06162', NULL, 'Putative pyroglutamyl peptidase PgaPase_1', 166, NULL, 'PgaPase_1', 254169),
(435076, 'PF19186', NULL, 'Family of unknown function (DUF5868)', 193, NULL, 'DUF5868', 254170),
(435077, 'PF03213', NULL, 'Poxvirus P35 protein', 323, NULL, 'Pox_P35', 254171),
(435078, 'PF04041', NULL, 'beta-1,4-mannooligosaccharide phosphorylase', 322, NULL, 'Glyco_hydro_130', 254172);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(435079, 'PF07713', NULL, 'Protein of unknown function (DUF1604)', 85, NULL, 'DUF1604', 254173),
(435080, 'PF08235', NULL, 'LNS2 (Lipin/Ned1/Smp2)', 226, NULL, 'LNS2', 254174),
(435081, 'PF08975', NULL, 'Domain of unknown function (DUF1868)', 116, NULL, '2H-phosphodiest', 254175),
(435082, 'PF16885', NULL, 'Voltage-gated calcium channel subunit alpha, C-term', 359, NULL, 'CAC1F_C', 254176),
(435083, 'PF11460', NULL, 'Protein of unknown function (DUF3007)', 96, NULL, 'DUF3007', 254177),
(435084, 'PF06695', NULL, 'Putative small multi-drug export protein', 121, NULL, 'Sm_multidrug_ex', 254178),
(435085, 'PF12377', NULL, 'Duffy binding protein N terminal', 65, NULL, 'DuffyBP_N', 254179),
(435086, 'PF15750', NULL, 'Ubiquitin-binding zinc-finger', 35, NULL, 'UBZ_FAAP20', 254180),
(435087, 'PF07038', NULL, 'Circovirus 2, anti-apoptotic ORF4', 59, NULL, 'Circovir2_Orf4', 254181),
(435088, 'PF19760', NULL, 'Family of unknown function (DUF6247)', 100, NULL, 'DUF6247', 254182),
(435089, 'PF05600', NULL, 'CDK5 regulatory subunit-associated protein 3', 507, NULL, 'CDK5RAP3', 254183),
(435090, 'PF03818', NULL, 'Malonate/sodium symporter MadM subunit', 249, NULL, 'MadM', 254184),
(435091, 'PF16030', NULL, 'Serine protease gd N-terminus', 108, NULL, 'GD_N', 254185),
(435092, 'PF08437', NULL, 'Glycosyl transferase family 8 C-terminal', 57, NULL, 'Glyco_transf_8C', 254186),
(435093, 'PF12940', NULL, 'Recombination-activation protein 1 (RAG1), recombinase', 651, NULL, 'RAG1', 254187),
(435094, 'PF03302', NULL, 'Giardia variant-specific surface protein', 397, NULL, 'VSP', 254188),
(435095, 'PF10285', NULL, 'Luciferase catalytic domain', 296, NULL, 'Luciferase_cat', 254189),
(435096, 'PF16649', NULL, 'Interleukin 23 subunit alpha', 158, NULL, 'IL23', 254190),
(435097, 'PF05713', NULL, 'Bacterial mobilisation protein (MobC)', 45, NULL, 'MobC', 254191),
(435098, 'PF02613', NULL, 'Nitrate reductase delta subunit', 138, NULL, 'Nitrate_red_del', 254192),
(435099, 'PF04843', NULL, 'Herpesvirus tegument protein, N-terminal conserved region', 183, NULL, 'Herpes_teg_N', 254193),
(435100, 'PF01166', NULL, 'TSC-22/dip/bun family', 57, NULL, 'TSC22', 254194),
(435101, 'PF13686', NULL, 'DsrE/DsrF/DrsH-like family', 153, NULL, 'DrsE_2', 254195),
(435102, 'PF16486', NULL, 'N-terminal domain of argonaute', 143, NULL, 'ArgoN', 254196),
(435103, 'PF02965', NULL, 'Vitamin B12 dependent methionine synthase, activation domain', 273, NULL, 'Met_synt_B12', 254197),
(435104, 'PF12803', NULL, 'mRNA (guanine-7-)methyltransferase (G-7-MTase)', 317, NULL, 'G-7-MTase', 254198),
(435105, 'PF15500', NULL, 'Putative RNase-like toxin, toxin_1', 96, NULL, 'Ntox1', 254199),
(435106, 'PF04475', NULL, 'Protein of unknown function (DUF555)', 101, NULL, 'DUF555', 254200),
(435107, 'PF09221', NULL, 'Bacteriocin class IId cyclical uberolysin-like', 67, NULL, 'Bacteriocin_IId', 254201),
(435108, 'PF12621', NULL, 'Extracellular tail, of 10TM putative phosphate transporter', 93, NULL, 'PHM7_ext', 254202),
(435109, 'PF00838', NULL, 'Translationally controlled tumour protein', 166, NULL, 'TCTP', 254203),
(435110, 'PF10029', NULL, 'Predicted periplasmic protein (DUF2271)', 136, NULL, 'DUF2271', 254204),
(435111, 'PF20493', NULL, 'Fungal WD-like', 199, NULL, 'WD-like_fungi', 254205),
(435112, 'PF08603', NULL, 'Adenylate cyclase associated (CAP) C terminal', 158, NULL, 'CAP_C', 254206),
(435113, 'PF14514', NULL, 'Tetracyclin repressor-like, C-terminal domain', 130, NULL, 'TetR_C_9', 254207),
(435114, 'PF06271', NULL, 'RDD family', 138, NULL, 'RDD', 254208),
(435115, 'PF17419', NULL, 'Methylamine utilization protein MauJ', 282, NULL, 'MauJ', 254209),
(435116, 'PF02071', NULL, 'Aromatic-di-Alanine (AdAR) repeat', 12, NULL, 'NSF', 254210),
(435117, 'PF06139', NULL, 'BphX-like', 133, NULL, 'BphX', 254211),
(435118, 'PF18516', NULL, 'RuvC nuclease domain', 244, NULL, 'RuvC_1', 254212),
(435119, 'PF18686', NULL, 'Family of unknown function (DUF5636)', 194, NULL, 'DUF5636', 254213),
(435120, 'PF18921', NULL, 'Cyanophycin synthase-like N-terminal domain', 115, NULL, 'Cyanophycin_syn', 254214);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(435121, 'PF05842', NULL, 'Euplotes octocarinatus mating pheromone protein', 134, NULL, 'Euplotes_phero', 254215),
(435122, 'PF12456', NULL, 'Inositol phosphatase', 115, NULL, 'hSac2', 254216),
(435123, 'PF06314', NULL, 'Acetoacetate decarboxylase (ADC)', 237, NULL, 'ADC', 254217),
(435124, 'PF18502', NULL, '54S ribosomal protein L8 C-terminal domain', 111, NULL, 'Mrpl_C', 254218),
(435125, 'PF19522', NULL, 'Family of unknown function (DUF6052)', 61, NULL, 'DUF6052', 254219),
(435126, 'PF12559', NULL, 'Serine endopeptidase inhibitors', 64, NULL, 'Inhibitor_I10', 254220),
(435127, 'PF04265', NULL, 'Thiamin pyrophosphokinase, vitamin B1 binding domain', 70, NULL, 'TPK_B1_binding', 254221),
(435128, 'PF10573', NULL, 'Uncharacterised protein family UPF0561', 120, NULL, 'UPF0561', 254222),
(435129, 'PF15872', NULL, 'Serine-rich and transmembrane domain-containing protein 1', 103, NULL, 'SRTM1', 254223),
(435130, 'PF00275', NULL, 'EPSP synthase (3-phosphoshikimate 1-carboxyvinyltransferase)', 416, NULL, 'EPSP_synthase', 254224),
(435131, 'PF15367', NULL, 'Calcium-binding and spermatid-specific protein 1', 397, NULL, 'CABS1', 254225),
(435132, 'PF17781', NULL, 'RPN1 N-terminal domain', 304, NULL, 'RPN1_RPN2_N', 254226),
(435133, 'PF14162', NULL, 'YozD-like protein', 56, NULL, 'YozD', 254227),
(435134, 'PF04165', NULL, 'Protein of unknown function (DUF401)', 389, NULL, 'DUF401', 254228),
(435135, 'PF05450', NULL, 'Nicastrin', 234, NULL, 'Nicastrin', 254229),
(435136, 'PF07642', NULL, 'Putative beta-barrel porin-2, OmpL-like. bbp2', 346, NULL, 'BBP2', 254230),
(435137, 'PF18682', NULL, 'Pilin A4', 83, NULL, 'PilA4', 254231),
(435138, 'PF02432', NULL, 'Fimbrial, major and minor subunit', 155, NULL, 'Fimbrial_K88', 254232),
(435139, 'PF18717', NULL, 'CxC4 like cysteine cluster associated with KDZ transposases', 130, NULL, 'CxC4', 254233),
(435140, 'PF11229', NULL, 'Focadhesin', 589, NULL, 'Focadhesin', 254234),
(435141, 'PF06751', NULL, 'Ethanolamine ammonia lyase large subunit (EutB)', 436, NULL, 'EutB', 254235),
(435142, 'PF17597', NULL, 'Family of unknown function (DUF5493)', 82, NULL, 'DUF5493', 254236),
(435143, 'PF17609', NULL, 'Family of unknown function', 126, NULL, 'HCMV_UL124', 254237),
(435144, 'PF12165', NULL, 'Alfin', 127, NULL, 'Alfin', 254238),
(435145, 'PF13854', NULL, 'Kelch motif', 42, NULL, 'Kelch_5', 254239),
(435146, 'PF18137', NULL, 'Origin recognition complex winged helix C-terminal', 145, NULL, 'ORC_WH_C', 254240),
(435147, 'PF16947', NULL, 'N-terminal region of 4Fe-4S ferredoxin iron-sulfur binding', 65, NULL, 'Ferredoxin_N', 254241),
(435148, 'PF16197', NULL, 'Ketoacyl-synthetase C-terminal extension', 112, NULL, 'KAsynt_C_assoc', 254242),
(435149, 'PF10048', NULL, 'Predicted integral membrane protein (DUF2282)', 53, NULL, 'DUF2282', 254243),
(435150, 'PF06080', NULL, 'Protein of unknown function (DUF938)', 204, NULL, 'DUF938', 254244),
(435151, 'PF17169', NULL, 'MIT domain of nuclear receptor-binding factor 2', 83, NULL, 'NRBF2_MIT', 254245),
(435152, 'PF02371', NULL, 'Transposase IS116/IS110/IS902 family', 87, NULL, 'Transposase_20', 254246),
(435153, 'PF03464', NULL, 'eRF1 domain 2', 133, NULL, 'eRF1_2', 254247),
(435154, 'PF12485', NULL, 'Lymphocyte signaling adaptor protein', 156, NULL, 'SLY', 254248),
(435155, 'PF19183', NULL, 'Family of unknown function (DUF5865)', 210, NULL, 'DUF5865', 254249),
(435156, 'PF18422', NULL, 'Tumor necrosis factor receptor member 16 trans-membrane domain', 38, NULL, 'TNFR_16_TM', 254250),
(435157, 'PF01036', NULL, 'Bacteriorhodopsin-like protein', 224, NULL, 'Bac_rhodopsin', 254251),
(435158, 'PF16178', NULL, 'Dimerisation domain of Ca+-activated chloride-channel, anoctamin', 229, NULL, 'Anoct_dimer', 254252),
(435159, 'PF01476', NULL, 'LysM domain', 44, NULL, 'LysM', 254253),
(435160, 'PF08807', NULL, 'Bacterial domain of unknown function (DUF1798)', 108, NULL, 'DUF1798', 254254),
(435161, 'PF10896', NULL, 'Protein of unknown function (DUF2714)', 143, NULL, 'DUF2714', 254255),
(435162, 'PF15507', NULL, 'Domain of unknown function (DUF4649)', 68, NULL, 'DUF4649', 254256);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(435163, 'PF04678', NULL, 'Mitochondrial calcium uniporter', 177, NULL, 'MCU', 254257),
(435164, 'PF09415', NULL, 'CENP-S associating Centromere protein X', 75, NULL, 'CENP-X', 254258),
(435165, 'PF01691', NULL, 'Adenovirus E1B 19K protein / small t-antigen', 135, NULL, 'Adeno_E1B_19K', 254259),
(435166, 'PF18159', NULL, 'SMODS-associating 4TM effector domain', 290, NULL, 'S_4TM', 254260),
(435167, 'PF04189', NULL, 'Gcd10p family', 312, NULL, 'Gcd10p', 254261),
(435168, 'PF06411', NULL, 'HdeA/HdeB family', 92, NULL, 'HdeA', 254262),
(435169, 'PF17310', NULL, 'Family of unknown function (DUF5357)', 322, NULL, 'DUF5357', 254263),
(435170, 'PF00771', NULL, 'FHIPEP family', 658, NULL, 'FHIPEP', 254264),
(435171, 'PF05439', NULL, 'Jumping translocation breakpoint protein (JTB)', 110, NULL, 'JTB', 254265),
(435172, 'PF12541', NULL, 'Protein of unknown function (DUF3737)', 275, NULL, 'DUF3737', 254266),
(435173, 'PF13931', NULL, 'Kinesin-associated microtubule-binding', 139, NULL, 'Microtub_bind', 254267),
(435174, 'PF11298', NULL, 'Protein of unknown function (DUF3099)', 72, NULL, 'DUF3099', 254268),
(435175, 'PF03120', NULL, 'NAD-dependent DNA ligase OB-fold domain', 79, NULL, 'DNA_ligase_OB', 254269),
(435176, 'PF03357', NULL, 'Snf7', 173, NULL, 'Snf7', 254270),
(435177, 'PF14299', NULL, 'Phloem protein 2', 146, NULL, 'PP2', 254271),
(435178, 'PF10654', NULL, 'Protein of unknown function (DUF2481)', 126, NULL, 'DUF2481', 254272),
(435179, 'PF20082', NULL, 'Family of unknown function (DUF6476)', 91, NULL, 'DUF6476', 254273),
(435180, 'PF04949', NULL, 'Transcriptional activator', 154, NULL, 'Transcrip_act', 254274),
(435181, 'PF11743', NULL, 'Protein of unknown function (DUF3301)', 95, NULL, 'DUF3301', 254275),
(435182, 'PF10886', NULL, 'Protein of unknown function (DUF2685)', 55, NULL, 'DUF2685', 254276),
(435183, 'PF01403', NULL, 'Sema domain', 180, NULL, 'Sema', 254277),
(435184, 'PF02551', NULL, 'Acyl-CoA thioesterase', 132, NULL, 'Acyl_CoA_thio', 254278),
(435185, 'PF15088', NULL, 'NADH dehydrogenase [ubiquinone] 1 subunit C1, mitochondrial', 49, NULL, 'NADH_dh_m_C1', 254279),
(435186, 'PF00786', NULL, 'P21-Rho-binding domain', 59, NULL, 'PBD', 254280),
(435187, 'PF14382', NULL, 'Exosome complex exonuclease RRP4 N-terminal region', 38, NULL, 'ECR1_N', 254281),
(435188, 'PF01129', NULL, 'NAD:arginine ADP-ribosyltransferase', 222, NULL, 'ART', 254282),
(435189, 'PF19004', NULL, 'Family of unknown function (DUF5733)', 115, NULL, 'DUF5733', 254283),
(435190, 'PF06752', NULL, 'Enhancer of Polycomb C-terminus', 230, NULL, 'E_Pc_C', 254284),
(435191, 'PF00545', NULL, 'ribonuclease', 86, NULL, 'Ribonuclease', 254285),
(435192, 'PF19830', NULL, 'Family of unknown function (DUF6311)', 303, NULL, 'DUF6311', 254286),
(435193, 'PF02803', NULL, 'Thiolase, C-terminal domain', 123, NULL, 'Thiolase_C', 254287),
(435194, 'PF16961', NULL, 'Putative OmpA-OmpF-like porin family', 197, NULL, 'OmpA_like', 254288),
(435195, 'PF08432', NULL, 'AAA-ATPase Vps4-associated protein 1', 181, NULL, 'Vfa1', 254289),
(435196, 'PF19992', NULL, 'Family of unknown function (DUF6427)', 301, NULL, 'DUF6427', 254290),
(435197, 'PF08127', NULL, 'Peptidase family C1 propeptide', 40, NULL, 'Propeptide_C1', 254291),
(435198, 'PF19391', NULL, 'Family of unknown function (DUF5966)', 95, NULL, 'DUF5966', 254292),
(435199, 'PF06864', NULL, 'Pilin accessory protein (PilO)', 416, NULL, 'PAP_PilO', 254293),
(435200, 'PF04568', NULL, 'Mitochondrial ATPase inhibitor, IATP', 98, NULL, 'IATP', 254294),
(435201, 'PF07503', NULL, 'HypF finger', 34, NULL, 'zf-HYPF', 254295),
(435202, 'PF04930', NULL, 'FUN14 family', 92, NULL, 'FUN14', 254296),
(435203, 'PF10205', NULL, 'Predicted coiled-coil domain-containing protein', 105, NULL, 'KLRAQ', 254297),
(435204, 'PF09807', NULL, 'Elongation complex protein 6', 252, NULL, 'ELP6', 254298),
(435205, 'PF17775', NULL, 'UPF0225 domain', 99, NULL, 'UPF0225', 254299),
(435206, 'PF06152', NULL, 'Phage minor capsid protein 2', 364, NULL, 'Phage_min_cap2', 254300),
(435207, 'PF08601', NULL, 'Transcription factor PAP1', 371, NULL, 'PAP1', 254301);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(435208, 'PF17812', NULL, 'RET Cadherin like domain 3', 116, NULL, 'RET_CLD3', 254302),
(435209, 'PF18804', NULL, 'CxC3 like cysteine cluster associated with KDZ transposases', 113, NULL, 'CxC3', 254303),
(435210, 'PF11813', NULL, 'Protein of unknown function (DUF3334)', 226, NULL, 'DUF3334', 254304),
(435211, 'PF01485', NULL, 'IBR domain, a half RING-finger domain', 65, NULL, 'IBR', 254305),
(435212, 'PF04582', NULL, 'Reovirus sigma C capsid protein C-terminal domain', 130, NULL, 'Reo_sigmaC', 254306),
(435213, 'PF12622', NULL, 'mRNA biogenesis factor', 51, NULL, 'NpwBP', 254307),
(435214, 'PF07944', NULL, 'Beta-L-arabinofuranosidase, GH127', 508, NULL, 'Glyco_hydro_127', 254308),
(435215, 'PF06374', NULL, 'NADH-ubiquinone oxidoreductase subunit b14.5b (NDUFC2)', 109, NULL, 'NDUF_C2', 254309),
(435216, 'PF12868', NULL, 'Domain of unknwon function (DUF3824)', 148, NULL, 'DUF3824', 254310),
(435217, 'PF18696', NULL, 'Synaptotagmin-like, mitochondrial and lipid-binding domain', 152, NULL, 'SMP_C2CD2L', 254311),
(435218, 'PF20062', NULL, 'Family of unknown function (DUF6461)', 212, NULL, 'DUF6461', 254312),
(435219, 'PF08882', NULL, 'Acetone carboxylase gamma subunit', 114, NULL, 'Acetone_carb_G', 254313),
(435220, 'PF15035', NULL, 'Ciliary rootlet component, centrosome cohesion', 191, NULL, 'Rootletin', 254314),
(435221, 'PF04481', NULL, 'Protein of unknown function (DUF561)', 243, NULL, 'DUF561', 254315),
(435222, 'PF17995', NULL, 'Endo-alpha-N-acetylgalactosaminidase N-terminal', 180, NULL, 'GH101_N', 254316),
(435223, 'PF06493', NULL, 'Protein of unknown function (DUF1096)', 51, NULL, 'DUF1096', 254317),
(435224, 'PF04447', NULL, 'dATP/dGTP pyrophosphohydrolase', 97, NULL, 'dATP-dGTP_PPHyd', 254318),
(435225, 'PF03715', NULL, 'Noc2p family', 299, NULL, 'Noc2', 254319),
(435226, 'PF19685', NULL, 'Family of unknown function (DUF6187)', 141, NULL, 'DUF6187', 254320),
(435227, 'PF19818', NULL, 'Family of unknown function (DUF6301)', 141, NULL, 'DUF6301', 254321),
(435228, 'PF00163', NULL, 'Ribosomal protein S4/S9 N-terminal domain', 93, NULL, 'Ribosomal_S4', 254322),
(435229, 'PF04655', NULL, 'Aminoglycoside/hydroxyurea antibiotic resistance kinase', 252, NULL, 'APH_6_hur', 254323),
(435230, 'PF11891', NULL, 'Protein RETICULATA-related', 177, NULL, 'RETICULATA-like', 254324),
(435231, 'PF20012', NULL, 'GTPase-associated protein 1, N-terminal domain type 1', 102, NULL, 'GAP1-N1', 254325),
(435232, 'PF16024', NULL, 'Domain of unknown function (DUF4785)', 372, NULL, 'DUF4785', 254326),
(435233, 'PF02444', NULL, 'Hepatitis E virus ORF-2 (Putative capsid protein)', 114, NULL, 'HEV_ORF1', 254327),
(435234, 'PF11223', NULL, 'SPP41, DUF3020', 49, NULL, 'DUF3020', 254328),
(435235, 'PF14153', NULL, 'Spore coat protein CotO', 192, NULL, 'Spore_coat_CotO', 254329),
(435236, 'PF08593', NULL, 'Domain of unknown function', 58, NULL, 'DUF1773', 254330),
(435237, 'PF11546', NULL, 'Staphylococcal complement inhibitor SCIN', 114, NULL, 'CompInhib_SCIN', 254331),
(435238, 'PF12612', NULL, 'Tubulin folding cofactor D C terminal', 188, NULL, 'TFCD_C', 254332),
(435239, 'PF06460', NULL, 'Coronavirus 2''-O-methyltransferase', 299, NULL, 'CoV_Methyltr_2', 254333),
(435240, 'PF06630', NULL, 'Enterobacterial exodeoxyribonuclease VIII', 192, NULL, 'Exonuc_VIII', 254334),
(435241, 'PF09205', NULL, 'Domain of unknown function (DUF1955)', 159, NULL, 'DUF1955', 254335),
(435242, 'PF12983', NULL, 'Protein of unknown function (DUF3867)', 185, NULL, 'DUF3867', 254336),
(435243, 'PF10992', NULL, 'Epiplasmin protein', 83, NULL, 'Epiplasmin', 254337),
(435244, 'PF08743', NULL, 'Nse4 C-terminal', 89, NULL, 'Nse4_C', 254338),
(435245, 'PF02480', NULL, 'Alphaherpesvirus glycoprotein E', 175, NULL, 'Herpes_gE', 254339),
(435246, 'PF04720', NULL, 'PDDEXK-like family of unknown function', 220, NULL, 'PDDEXK_6', 254340),
(435247, 'PF08759', NULL, 'Glycosyltransferase GT-D fold', 224, NULL, 'GT-D', 254341),
(435248, 'PF13423', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 322, NULL, 'UCH_1', 254342),
(435249, 'PF16957', NULL, 'Malonate decarboxylase, alpha subunit, transporter', 548, NULL, 'Mal_decarbox_Al', 254343);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(435250, 'PF18766', NULL, 'SWI2/SNF2 ATPase', 225, NULL, 'SWI2_SNF2', 254344),
(435251, 'PF05572', NULL, 'Pregnancy-associated plasma protein-A', 152, NULL, 'Peptidase_M43', 254345),
(435252, 'PF13377', NULL, 'Periplasmic binding protein-like domain', 166, NULL, 'Peripla_BP_3', 254346),
(435253, 'PF02680', NULL, 'Uncharacterized ArCR, COG1888', 89, NULL, 'DUF211', 254347),
(435254, 'PF09175', NULL, 'Vitellinogen, beta-sheet shell', 167, NULL, 'Vit_b-sht_shell', 254348),
(435255, 'PF09260', NULL, 'Alpha-amylase, domain C', 90, NULL, 'A_amylase_dom_C', 254349),
(435256, 'PF17043', NULL, 'Mating type protein 1-1-2 of unknown function', 147, NULL, 'MAT1-1-2', 254350),
(435257, 'PF15997', NULL, 'Domain of unknown function (DUF4772)', 118, NULL, 'DUF4772', 254351),
(435258, 'PF19650', NULL, 'Family of unknown function (DUF6153)', 115, NULL, 'DUF6153', 254352),
(435259, 'PF02667', NULL, 'Short chain fatty acid transporter', 453, NULL, 'SCFA_trans', 254353),
(435260, 'PF00583', NULL, 'Acetyltransferase (GNAT) family', 117, NULL, 'Acetyltransf_1', 254354),
(435261, 'PF00381', NULL, 'PTS HPr component phosphorylation site', 82, NULL, 'PTS-HPr', 254355),
(435262, 'PF10145', NULL, 'Phage-related minor tail protein', 198, NULL, 'PhageMin_Tail', 254356),
(435263, 'PF19942', NULL, 'Family of unknown function (DUF6404)', 114, NULL, 'DUF6404', 254357),
(435264, 'PF05080', NULL, 'Protein of unknown function (DUF681)', 101, NULL, 'DUF681', 254358),
(435265, 'PF11848', NULL, 'Domain of unknown function (DUF3368)', 46, NULL, 'DUF3368', 254359),
(435266, 'PF17571', NULL, 'Family of unknown function (DUF5477)', 77, NULL, 'DUF5477', 254360),
(435267, 'PF03286', NULL, 'Pox virus Ag35 surface protein', 196, NULL, 'Pox_Ag35', 254361),
(435268, 'PF06966', NULL, 'Protein of unknown function (DUF1295)', 235, NULL, 'DUF1295', 254362),
(435269, 'PF01244', NULL, 'Membrane dipeptidase (Peptidase family M19)', 318, NULL, 'Peptidase_M19', 254363),
(435270, 'PF09202', NULL, 'Rio2, N-terminal', 82, NULL, 'Rio2_N', 254364),
(435271, 'PF08142', NULL, 'AARP2CN (NUC121) domain', 86, NULL, 'AARP2CN', 254365),
(435272, 'PF01000', NULL, 'RNA polymerase Rpb3/RpoA insert domain', 112, NULL, 'RNA_pol_A_bac', 254366),
(435273, 'PF11263', NULL, 'Borrelia burgdorferi attachment protein P66', 253, NULL, 'Attachment_P66', 254367),
(435274, 'PF13503', NULL, 'Domain of unknown function (DUF4123)', 127, NULL, 'DUF4123', 254368),
(435275, 'PF04434', NULL, 'SWIM zinc finger', 40, NULL, 'SWIM', 254369),
(435276, 'PF16625', NULL, 'Unstructured linking region I-set and fnIII on Brother of CDO', 65, NULL, 'ISET-FN3_linker', 254370),
(435277, 'PF01467', NULL, 'Cytidylyltransferase-like', 143, NULL, 'CTP_transf_like', 254371),
(435278, 'PF00191', NULL, 'Annexin', 66, NULL, 'Annexin', 254372),
(435279, 'PF16241', NULL, 'Domain of unknown function (DUF4900)', 89, NULL, 'DUF4900', 254373),
(435280, 'PF02487', NULL, 'CLN3 protein', 394, NULL, 'CLN3', 254374),
(435281, 'PF11431', NULL, 'Membrane transport protein MerF', 45, NULL, 'Transport_MerF', 254375),
(435282, 'PF16787', NULL, 'Centromere DNA-binding protein complex CBF3 subunit, domain 2', 318, NULL, 'NDC10_II', 254376),
(435283, 'PF17909', NULL, 'Htr2 transmembrane domain', 61, NULL, 'Htr2', 254377),
(435284, 'PF19122', NULL, 'Family of unknown function (DUF5806)', 148, NULL, 'DUF5806', 254378),
(435285, 'PF18411', NULL, 'Annexin-like domain', 93, NULL, 'Annexin_like', 254379),
(435286, 'PF18526', NULL, 'Thymine dioxygenase JBP1 DNA-binding domain', 164, NULL, 'DB_JBP1', 254380),
(435287, 'PF18745', NULL, 'Secreted Novel AID/APOBEC-like Deaminase 2', 200, NULL, 'SNAD2', 254381),
(435288, 'PF06532', NULL, 'Negative regulator of sigma F', 204, NULL, 'NrsF', 254382),
(435289, 'PF08534', NULL, 'Redoxin', 147, NULL, 'Redoxin', 254383),
(435290, 'PF04099', NULL, 'Sybindin-like family', 143, NULL, 'Sybindin', 254384),
(435291, 'PF05134', NULL, 'Type II secretion system (T2SS), protein L', 233, NULL, 'T2SSL', 254385),
(435292, 'PF19503', NULL, 'Family of unknown function (DUF6037)', 200, NULL, 'DUF6037', 254386);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(435293, 'PF20611', NULL, 'Family of unknown function (DUF6801)', 162, NULL, 'DUF6801', 254387),
(435294, 'PF05570', NULL, 'Circovirus protein of unknown function (DUF765)', 29, NULL, 'DUF765', 254388),
(435295, 'PF13288', NULL, 'DXP reductoisomerase C-terminal domain', 115, NULL, 'DXPR_C', 254389),
(435296, 'PF13514', NULL, 'AAA domain', 207, NULL, 'AAA_27', 254390),
(435297, 'PF15389', NULL, 'Domain of unknown function (DUF4612)', 121, NULL, 'DUF4612', 254391),
(435298, 'PF12938', NULL, 'M domain of GW182', 243, NULL, 'M_domain', 254392),
(435299, 'PF13494', NULL, 'Domain of unknown function, B. Theta Gene description (DUF4119)', 87, NULL, 'DUF4119', 254393),
(435300, 'PF15386', NULL, 'Drosophila Tantalus-like', 57, NULL, 'Tantalus', 254394),
(435301, 'PF09866', NULL, 'Uncharacterized protein conserved in bacteria (DUF2093)', 42, NULL, 'DUF2093', 254395),
(435302, 'PF18145', NULL, 'SMODS-associated and fused to various effectors sensor domain', 189, NULL, 'SAVED', 254396),
(435303, 'PF17796', NULL, 'Major Vault Protein repeat domain', 61, NULL, 'Vault_4', 254397),
(435304, 'PF20389', NULL, 'Family of unknown function (DUF6684)', 79, NULL, 'DUF6684', 254398),
(435305, 'PF02831', NULL, 'gpW', 67, NULL, 'gpW', 254399),
(435306, 'PF08493', NULL, 'Aflatoxin regulatory protein', 101, NULL, 'AflR', 254400),
(435307, 'PF11767', NULL, 'Histone lysine methyltransferase SET associated', 66, NULL, 'SET_assoc', 254401),
(435308, 'PF08107', NULL, 'Pleurocidin family', 42, NULL, 'Antimicrobial12', 254402),
(435309, 'PF13295', NULL, 'Domain of unknown function (DUF4077)', 176, NULL, 'DUF4077', 254403),
(435310, 'PF18851', NULL, 'Bacterial archaeo-eukaryotic release factor family 8', 141, NULL, 'baeRF_family8', 254404),
(435311, 'PF17164', NULL, 'Domain of unknown function (DUF5122) beta-propeller', 36, NULL, 'DUF5122', 254405),
(435312, 'PF13107', NULL, 'Protein of unknown function (DUF3964)', 109, NULL, 'DUF3964', 254406),
(435313, 'PF01774', NULL, 'UreD urease accessory protein', 213, NULL, 'UreD', 254407),
(435314, 'PF02994', NULL, 'L1 transposable element RBD-like domain', 98, NULL, 'Transposase_22', 254408),
(435315, 'PF08746', NULL, 'RING-like domain', 43, NULL, 'zf-RING-like', 254409),
(435316, 'PF07133', NULL, 'Merozoite surface protein (SPAM)', 176, NULL, 'Merozoite_SPAM', 254410),
(435317, 'PF18471', NULL, 'Ribosomal L27 protein C-terminal domain', 240, NULL, 'Ribosomal_L27_C', 254411),
(435318, 'PF11429', NULL, 'Colicin D', 85, NULL, 'Colicin_D', 254412),
(435319, 'PF17585', NULL, 'Accessory recombination function protein', 47, NULL, 'Phage_Arf', 254413),
(435320, 'PF07183', NULL, 'Protein of unknown function (DUF1403)', 320, NULL, 'DUF1403', 254414),
(435321, 'PF16800', NULL, 'IseA DL-endopeptidase inhibitor', 150, NULL, 'Endopep_inhib', 254415),
(435322, 'PF10589', NULL, 'NADH-ubiquinone oxidoreductase-F iron-sulfur binding region', 85, NULL, 'NADH_4Fe-4S', 254416),
(435323, 'PF12807', NULL, 'Translation initiation factor eIF3 subunit 135', 172, NULL, 'eIF3_p135', 254417),
(435324, 'PF19742', NULL, 'Family of unknown function (DUF6231)', 142, NULL, 'DUF6231', 254418),
(435325, 'PF18960', NULL, 'Family of unknown function (DUF5702)', 275, NULL, 'DUF5702', 254419),
(435326, 'PF11486', NULL, 'Protein of unknown function (DUF3212)', 120, NULL, 'DUF3212', 254420),
(435327, 'PF00587', NULL, 'tRNA synthetase class II core domain (G, H, P, S and T)', 179, NULL, 'tRNA-synt_2b', 254421),
(435328, 'PF11190', NULL, 'Protein of unknown function (DUF2976)', 88, NULL, 'DUF2976', 254422),
(435329, 'PF03557', NULL, 'Bunyavirus glycoprotein G1', 871, NULL, 'Bunya_G1', 254423),
(435330, 'PF14397', NULL, 'Sugar-transfer associated ATP-grasp', 278, NULL, 'ATPgrasp_ST', 254424),
(435331, 'PF19358', NULL, 'Family of unknown function (DUF5935)', 193, NULL, 'DUF5935', 254425),
(435332, 'PF08423', NULL, 'Rad51', 255, NULL, 'Rad51', 254426),
(435333, 'PF00310', NULL, 'Glutamine amidotransferases class-II', 420, NULL, 'GATase_2', 254427),
(435334, 'PF02121', NULL, 'Phosphatidylinositol transfer protein', 247, NULL, 'IP_trans', 254428);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(435335, 'PF14874', NULL, 'Flagellar-associated PapD-like', 102, NULL, 'PapD-like', 254429),
(435336, 'PF16255', NULL, 'GDSL-like Lipase/Acylhydrolase', 203, NULL, 'Lipase_GDSL_lke', 254430),
(435337, 'PF06687', NULL, 'SUR7/PalI family', 212, NULL, 'SUR7', 254431),
(435338, 'PF19179', NULL, 'E3 ubiquitin-protein ligase TTC3/DZIP3 domain', 116, NULL, 'TTC3_DZIP3_dom', 254432),
(435339, 'PF07291', NULL, 'Methylamine utilisation protein MauE', 185, NULL, 'MauE', 254433),
(435340, 'PF07481', NULL, 'Domain of Unknown Function (DUF1521)', 169, NULL, 'DUF1521', 254434),
(435341, 'PF18242', NULL, 'Legionella ubiquitin-specific protease A domain', 178, NULL, 'LupA', 254435),
(435342, 'PF02915', NULL, 'Rubrerythrin', 137, NULL, 'Rubrerythrin', 254436),
(435343, 'PF07337', NULL, 'DC-EC Repeat', 32, NULL, 'CagY_M', 254437),
(435344, 'PF17624', NULL, 'Family of unknown function', 282, NULL, 'US30', 254438),
(435345, 'PF19255', NULL, 'Family of unknown function (DUF5902)', 104, NULL, 'DUF5902', 254439),
(435346, 'PF07833', NULL, 'Copper amine oxidase N-terminal domain', 94, NULL, 'Cu_amine_oxidN1', 254440),
(435347, 'PF13113', NULL, 'Protein of unknown function (DUF3970)', 55, NULL, 'DUF3970', 254441),
(435348, 'PF19898', NULL, 'Domain of unknown function (DUF6371)', 150, NULL, 'DUF6371', 254442),
(435349, 'PF04459', NULL, 'Protein of unknown function (DUF512)', 199, NULL, 'DUF512', 254443),
(435350, 'PF09247', NULL, 'TATA box-binding protein binding', 61, NULL, 'TBP-binding', 254444),
(435351, 'PF15874', NULL, 'Putative Interleukin 2 receptor, gamma chain', 91, NULL, 'Il2rg', 254445),
(435352, 'PF13563', NULL, '2''-5'' RNA ligase superfamily', 153, NULL, '2_5_RNA_ligase2', 254446),
(435353, 'PF09533', NULL, 'Predicted lipoprotein of unknown function (DUF2380)', 189, NULL, 'DUF2380', 254447),
(435354, 'PF20267', NULL, 'GREB1 C-terminal region', 694, NULL, 'GREB1_C', 254448),
(435355, 'PF02096', NULL, '60Kd inner membrane protein', 166, NULL, '60KD_IMP', 254449),
(435356, 'PF02957', NULL, 'TT viral ORF2', 122, NULL, 'TT_ORF2', 254450),
(435357, 'PF15248', NULL, 'Domain of unknown function (DUF4587)', 80, NULL, 'DUF4587', 254451),
(435358, 'PF18658', NULL, 'Spin-doc zinc-finger', 64, NULL, 'zf-C2H2_12', 254452),
(435359, 'PF00530', NULL, 'Scavenger receptor cysteine-rich domain', 100, NULL, 'SRCR', 254453),
(435360, 'PF13387', NULL, 'Domain of unknown function (DUF4105)', 170, NULL, 'DUF4105', 254454),
(435361, 'PF14269', NULL, 'Arylsulfotransferase (ASST)', 299, NULL, 'Arylsulfotran_2', 254455),
(435362, 'PF18737', NULL, 'MAE_28990/MAE_18760-like HEPN', 218, NULL, 'HEPN_MAE_28990', 254456),
(435363, 'PF00790', NULL, 'VHS domain', 141, NULL, 'VHS', 254457),
(435364, 'PF09720', NULL, 'Putative addiction module component', 54, NULL, 'Unstab_antitox', 254458),
(435365, 'PF00929', NULL, 'Exonuclease', 165, NULL, 'RNase_T', 254459),
(435366, 'PF09070', NULL, 'PFU (PLAA family ubiquitin binding)', 112, NULL, 'PFU', 254460),
(435367, 'PF20054', NULL, 'Trypanosoma Tc-38 (p38) protein', 69, NULL, 'Tc-38', 254461),
(435368, 'PF11694', NULL, 'Protein of unknown function (DUF3290)', 144, NULL, 'DUF3290', 254462),
(435369, 'PF06656', NULL, 'Tenuivirus PVC2 protein', 784, NULL, 'Tenui_PVC2', 254463),
(435370, 'PF16997', NULL, 'Wap1 domain', 382, NULL, 'Wap1', 254464),
(435371, 'PF01487', NULL, 'Type I 3-dehydroquinase', 229, NULL, 'DHquinase_I', 254465),
(435372, 'PF08549', NULL, 'SWI/SNF and RSC complexes subunit Ssr4 N-terminal', 217, NULL, 'SWI-SNF_Ssr4_N', 254466),
(435373, 'PF18230', NULL, 'Glycosyl hydrolases family 38 C-terminal sub-domain', 89, NULL, 'Glyc_hyd_38C_2', 254467),
(435374, 'PF09334', NULL, 'tRNA synthetases class I (M)', 391, NULL, 'tRNA-synt_1g', 254468),
(435375, 'PF04494', NULL, 'WD40 associated region in TFIID subunit, NTD2 domain', 133, NULL, 'TFIID_NTD2', 254469),
(435376, 'PF00711', NULL, 'Beta defensin', 36, NULL, 'Defensin_beta', 254470),
(435377, 'PF02982', NULL, 'Scytalone dehydratase', 160, NULL, 'Scytalone_dh', 254471),
(435378, 'PF06202', NULL, 'Amylo-alpha-1,6-glucosidase', 379, NULL, 'GDE_C', 254472);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(435379, 'PF17710', NULL, 'Family of unknown function (DUF5555)', 295, NULL, 'DUF5555', 254473),
(435380, 'PF13338', NULL, 'Transcriptional regulator, AbiEi antitoxin', 49, NULL, 'AbiEi_4', 254474),
(435381, 'PF08353', NULL, 'MurT ligase C-terminal', 110, NULL, 'MurT_C', 254475),
(435382, 'PF19029', NULL, 'DUF883 C-terminal glycine zipper region', 30, NULL, 'DUF883_C', 254476),
(435383, 'PF05906', NULL, 'Herpesvirus-7 repeat of unknown function (DUF865)', 35, NULL, 'DUF865', 254477),
(435384, 'PF05728', NULL, 'Uncharacterised protein family (UPF0227)', 187, NULL, 'UPF0227', 254478),
(435385, 'PF11119', NULL, 'Protein of unknown function (DUF2633)', 43, NULL, 'DUF2633', 254479),
(435386, 'PF03451', NULL, 'HELP motif', 72, NULL, 'HELP', 254480),
(435387, 'PF13256', NULL, 'Domain of unknown function (DUF4047)', 125, NULL, 'DUF4047', 254481),
(435388, 'PF18262', NULL, 'Phe-tRNA synthetase beta subunit B1 domain', 83, NULL, 'PhetRS_B1', 254482),
(435389, 'PF15973', NULL, 'Domain of unknown function (DUF4766)', 115, NULL, 'DUF4766', 254483),
(435390, 'PF16816', NULL, 'DotD protein', 120, NULL, 'DotD', 254484),
(435391, 'PF01679', NULL, 'Proteolipid membrane potential modulator', 49, NULL, 'Pmp3', 254485),
(435392, 'PF05107', NULL, 'CRISPR-associated protein Cas7', 252, NULL, 'Cas_Cas7', 254486),
(435393, 'PF08533', NULL, 'Beta-galactosidase C-terminal domain', 58, NULL, 'Glyco_hydro_42C', 254487),
(435394, 'PF17334', NULL, 'Minor curli fiber component A', 83, NULL, 'CsgA', 254488),
(435395, 'PF11055', NULL, 'Glucose signalling factor 2', 373, NULL, 'Gsf2', 254489),
(435396, 'PF15905', NULL, 'Hyaluronan mediated motility receptor N-terminal', 330, NULL, 'HMMR_N', 254490),
(435397, 'PF00726', NULL, 'Interleukin 10', 170, NULL, 'IL10', 254491),
(435398, 'PF17082', NULL, 'Spindle Pole Component 29', 244, NULL, 'Spc29', 254492),
(435399, 'PF11503', NULL, 'Protein of unknown function (DUF3215)', 72, NULL, 'DUF3215', 254493),
(435400, 'PF15290', NULL, 'Golgi-localised syntaxin-1-binding clamp', 305, NULL, 'Syntaphilin', 254494),
(435401, 'PF01037', NULL, 'Lrp/AsnC ligand binding domain', 75, NULL, 'AsnC_trans_reg', 254495),
(435402, 'PF05657', NULL, 'Protein of unknown function (DUF806)', 121, NULL, 'DUF806', 254496),
(435403, 'PF13601', NULL, 'Winged helix DNA-binding domain', 80, NULL, 'HTH_34', 254497),
(435404, 'PF14854', NULL, 'Leucine rich adaptor protein', 118, NULL, 'LURAP', 254498),
(435405, 'PF17185', NULL, 'NlpE C-terminal OB domain', 90, NULL, 'NlpE_C', 254499),
(435406, 'PF00158', NULL, 'Sigma-54 interaction domain', 168, NULL, 'Sigma54_activat', 254500),
(435407, 'PF11076', NULL, 'Putative inner membrane protein YbhQ', 132, NULL, 'YbhQ', 254501),
(435408, 'PF04489', NULL, 'Protein of unknown function (DUF570)', 427, NULL, 'DUF570', 254502),
(435409, 'PF12460', NULL, 'RNAPII transcription regulator C-terminal', 431, NULL, 'MMS19_C', 254503),
(435410, 'PF20457', NULL, 'Family of unknown function (DUF6710)', 203, NULL, 'DUF6710', 254504),
(435411, 'PF15682', NULL, 'Musculoskeletal, temporally activated-embryonic nuclear protein 1', 75, NULL, 'Mustang', 254505),
(435412, 'PF13250', NULL, 'Domain of unknown function (DUF4041)', 56, NULL, 'DUF4041', 254506),
(435413, 'PF20056', NULL, 'Family of unknown function (DUF6455)', 85, NULL, 'DUF6455', 254507),
(435414, 'PF16906', NULL, 'Ribosomal proteins L26 eukaryotic, L24P archaeal', 82, NULL, 'Ribosomal_L26', 254508),
(435415, 'PF18567', NULL, 'Toll/interleukin-1 receptor domain', 131, NULL, 'TIR_3', 254509),
(435416, 'PF19174', NULL, 'Family of unknown function (DUF5856)', 94, NULL, 'DUF5856', 254510),
(435417, 'PF05578', NULL, 'Pestivirus NS3 polyprotein peptidase S31', 211, NULL, 'Peptidase_S31', 254511),
(435418, 'PF17113', NULL, 'Regulatory signalling modulator protein AmpE', 284, NULL, 'AmpE', 254512),
(435419, 'PF01617', NULL, 'Surface antigen', 250, NULL, 'Surface_Ag_2', 254513),
(435420, 'PF19904', NULL, 'Domain of unknown function (DUF6377)', 249, NULL, 'DUF6377', 254514),
(435421, 'PF04161', NULL, 'Arv1-like family', 208, NULL, 'Arv1', 254515);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(435422, 'PF12412', NULL, 'Protein of unknown function (DUF3667)', 45, NULL, 'DUF3667', 254516),
(435423, 'PF14953', NULL, 'Domain of unknown function (DUF4504)', 264, NULL, 'DUF4504', 254517),
(435424, 'PF07293', NULL, 'Protein of unknown function (DUF1450)', 75, NULL, 'DUF1450', 254518),
(435425, 'PF04801', NULL, 'RPC5 protein', 429, NULL, 'RPC5', 254519),
(435426, 'PF12137', NULL, 'RNA polymerase recycling family C-terminal', 360, NULL, 'RapA_C', 254520),
(435427, 'PF09109', NULL, 'Switch protein XOL-1, GHMP-like', 189, NULL, 'Xol-1_GHMP-like', 254521),
(435428, 'PF12417', NULL, 'Zinc finger protein', 66, NULL, 'DUF3669', 254522),
(435429, 'PF14660', NULL, 'Domain of unknown function (DUF4458)', 110, NULL, 'DUF4458', 254523),
(435430, 'PF17264', NULL, 'Family of unknown function (DUF5330)', 65, NULL, 'DUF5330', 254524),
(435431, 'PF13943', NULL, 'WPP domain', 99, NULL, 'WPP', 254525),
(435432, 'PF16908', NULL, 'Vacuolar sorting-associated protein 13, N-terminal', 238, NULL, 'VPS13', 254526),
(435433, 'PF06831', NULL, 'Formamidopyrimidine-DNA glycosylase H2TH domain', 93, NULL, 'H2TH', 254527),
(435434, 'PF12294', NULL, 'Protein of unknown function (DUF3626)', 301, NULL, 'DUF3626', 254528),
(435435, 'PF01196', NULL, 'Ribosomal protein L17', 97, NULL, 'Ribosomal_L17', 254529),
(435436, 'PF06200', NULL, 'tify domain', 34, NULL, 'tify', 254530),
(435437, 'PF04983', NULL, 'RNA polymerase Rpb1, domain 3', 157, NULL, 'RNA_pol_Rpb1_3', 254531),
(435438, 'PF09419', NULL, 'Mitochondrial PGP phosphatase', 170, NULL, 'PGP_phosphatase', 254532),
(435439, 'PF12164', NULL, 'Stage V sporulation protein AA', 89, NULL, 'SporV_AA', 254533),
(435440, 'PF04111', NULL, 'Apg6 BARA domain', 179, NULL, 'APG6', 254534),
(435441, 'PF14289', NULL, 'Domain of unknown function (DUF4369)', 92, NULL, 'DUF4369', 254535),
(435442, 'PF08520', NULL, 'Fungal protein of unknown function (DUF1748)', 69, NULL, 'DUF1748', 254536),
(435443, 'PF19277', NULL, 'Glycerol-3-phosphate acyltransferase C-terminal region', 380, NULL, 'GPAT_C', 254537),
(435444, 'PF17650', NULL, 'RACo linker region', 85, NULL, 'RACo_linker', 254538),
(435445, 'PF02135', NULL, 'TAZ zinc finger', 72, NULL, 'zf-TAZ', 254539),
(435446, 'PF10474', NULL, 'Protein of unknown function C-terminus (DUF2451)', 234, NULL, 'DUF2451', 254540),
(435447, 'PF14134', NULL, 'Domain of unknown function (DUF4301)', 508, NULL, 'DUF4301', 254541),
(435448, 'PF07455', NULL, 'Phage polarity suppression protein (Psu)', 182, NULL, 'Psu', 254542),
(435449, 'PF15763', NULL, 'Regulator of human erythroid cell expansion (RHEX)', 167, NULL, 'DUF4692', 254543),
(435450, 'PF10244', NULL, 'Mitochondrial ribosomal subunit', 93, NULL, 'MRP-L51', 254544),
(435451, 'PF01686', NULL, 'Adenovirus penton base protein', 461, NULL, 'Adeno_Penton_B', 254545),
(435452, 'PF07268', NULL, 'Exported protein precursor (EppA/BapA)', 138, NULL, 'EppA_BapA', 254546),
(435453, 'PF15693', NULL, 'Mediator complex subunit 26 C-terminal', 183, NULL, 'Med26_C', 254547),
(435454, 'PF06154', NULL, 'CbeA_antitoxin, type IV, cytoskeleton bundling-enhancing factor A', 101, NULL, 'CbeA_antitoxin', 254548),
(435455, 'PF19038', NULL, 'Third Longin domain of FUZ, MON1 and HPS1', 106, NULL, 'Fuz_longin_3', 254549),
(435456, 'PF05406', NULL, 'WGR domain', 80, NULL, 'WGR', 254550),
(435457, 'PF17851', NULL, 'Beta xylosidase C-terminal Concanavalin A-like domain', 202, NULL, 'GH43_C2', 254551),
(435458, 'PF01005', NULL, 'Flavivirus non-structural protein NS2A', 185, NULL, 'Flavi_NS2A', 254552),
(435459, 'PF09462', NULL, 'Mus7/MMS22 family', 614, NULL, 'Mus7', 254553),
(435460, 'PF16181', NULL, 'RelB transactivation domain', 178, NULL, 'RelB_transactiv', 254554),
(435461, 'PF17349', NULL, 'Family of unknown function (DUF5378)', 282, NULL, 'DUF5378', 254555),
(435462, 'PF03796', NULL, 'DnaB-like helicase C terminal domain', 254, NULL, 'DnaB_C', 254556),
(435463, 'PF10793', NULL, 'Gloverin-like protein', 161, NULL, 'Gloverin', 254557),
(435464, 'PF15580', NULL, 'Immunity protein 53', 91, NULL, 'Imm53', 254558),
(435465, 'PF01363', NULL, 'FYVE zinc finger', 69, NULL, 'FYVE', 254559);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(435466, 'PF02786', NULL, 'Carbamoyl-phosphate synthase L chain, ATP binding domain', 211, NULL, 'CPSase_L_D2', 254560),
(435467, 'PF15735', NULL, 'Domain of unknown function (DUF4683)', 398, NULL, 'DUF4683', 254561),
(435468, 'PF19404', NULL, 'Family of unknown function (DUF5977)', 64, NULL, 'DUF5977', 254562),
(435469, 'PF11880', NULL, 'Domain of unknown function (DUF3400)', 45, NULL, 'DUF3400', 254563),
(435470, 'PF16782', NULL, 'Nucleotide exchange factor SIL1', 292, NULL, 'SIL1', 254564),
(435471, 'PF08875', NULL, 'Domain of unknown function (DUF1833)', 150, NULL, 'DUF1833', 254565),
(435472, 'PF12217', NULL, 'Catalytic beta propeller domain of bacteriophage endosialidase', 367, NULL, 'End_beta_propel', 254566),
(435473, 'PF06241', NULL, 'Castor and Pollux, part of voltage-gated ion channel', 104, NULL, 'Castor_Poll_mid', 254567),
(435474, 'PF16029', NULL, 'Domain of unknown function (DUF4787)', 63, NULL, 'DUF4787', 254568),
(435475, 'PF20605', NULL, 'Antitoxin-like ribbon-helix-helix', 50, NULL, 'Antitox_RHH', 254569),
(435476, 'PF05182', NULL, 'Fip1 motif', 43, NULL, 'Fip1', 254570),
(435477, 'PF07926', NULL, 'TPR/MLP1/MLP2-like protein', 129, NULL, 'TPR_MLP1_2', 254571),
(435478, 'PF12703', NULL, 'Toxin of toxin-antitoxin type 1 system', 73, NULL, 'ptaRNA1_toxin', 254572),
(435479, 'PF09898', NULL, 'Uncharacterized protein conserved in bacteria (DUF2125)', 319, NULL, 'DUF2125', 254573),
(435480, 'PF10307', NULL, 'HAD domain family 1 in Swiss Army Knife RNA repair proteins', 203, NULL, 'HAD_SAK_1', 254574),
(435481, 'PF19656', NULL, 'Family of unknown function (DUF6159)', 204, NULL, 'DUF6159', 254575),
(435482, 'PF11292', NULL, 'Protein of unknown function (DUF3093)', 141, NULL, 'DUF3093', 254576),
(435483, 'PF03277', NULL, 'Herpesvirus UL4 family', 187, NULL, 'Herpes_UL4', 254577),
(435484, 'PF07452', NULL, 'CHRD domain', 116, NULL, 'CHRD', 254578),
(435485, 'PF12323', NULL, 'Helix-turn-helix domain', 47, NULL, 'HTH_OrfB_IS605', 254579),
(435486, 'PF17495', NULL, 'Vpr-like OrfA', 106, NULL, 'OrfA', 254580),
(435487, 'PF02974', NULL, 'Protease inhibitor Inh', 97, NULL, 'Inh', 254581),
(435488, 'PF19441', NULL, 'Astrotactin 1/2 N-terminal', 549, NULL, 'ASTN_1_2_N', 254582),
(435489, 'PF17155', NULL, 'Gammaproteobacterial periplasmic sensor domain', 274, NULL, 'GAPES1', 254583),
(435490, 'PF11842', NULL, 'Domain of unknown function (DUF3362)', 150, NULL, 'DUF3362', 254584),
(435491, 'PF12641', NULL, 'Flavodoxin domain', 160, NULL, 'Flavodoxin_3', 254585),
(435492, 'PF12364', NULL, 'Protein of unknown function (DUF3648)', 141, NULL, 'DUF3648', 254586),
(435493, 'PF11383', NULL, 'Protein of unknown function (DUF3187)', 320, NULL, 'DUF3187', 254587),
(435494, 'PF16661', NULL, 'Metallo-beta-lactamase superfamily domain', 193, NULL, 'Lactamase_B_6', 254588),
(435495, 'PF16877', NULL, 'Domain of unknown function (DUF5078)', 118, NULL, 'DUF5078', 254589),
(435496, 'PF17240', NULL, 'Family of unknown function (DUF5313)', 123, NULL, 'DUF5313', 254590),
(435497, 'PF05526', NULL, 'Rhodococcus equi virulence-associated protein', 177, NULL, 'R_equi_Vir', 254591),
(435498, 'PF18730', NULL, 'Cthe_2314-like HEPN', 173, NULL, 'HEPN_Cthe2314', 254592),
(435499, 'PF19985', NULL, 'Family of unknown function (DUF6421)', 437, NULL, 'DUF6421', 254593),
(435500, 'PF18690', NULL, 'Family of unknown function (DUF5639)', 82, NULL, 'DUF5639', 254594),
(435501, 'PF02933', NULL, 'Cell division protein 48 (CDC48), domain 2', 64, NULL, 'CDC48_2', 254595),
(435502, 'PF10730', NULL, 'Protein of unknown function (DUF2521)', 146, NULL, 'DUF2521', 254596),
(435503, 'PF01704', NULL, 'UTP--glucose-1-phosphate uridylyltransferase', 412, NULL, 'UDPGP', 254597),
(435504, 'PF11979', NULL, 'Domain of unknown function (DUF3480)', 353, NULL, 'DUF3480', 254598),
(435505, 'PF10046', NULL, 'Biogenesis of lysosome-related organelles complex-1 subunit 2', 96, NULL, 'BLOC1_2', 254599),
(435506, 'PF13596', NULL, 'PAS domain', 106, NULL, 'PAS_10', 254600),
(435507, 'PF16092', NULL, 'Cilia- and flagella-associated protein 61, N-terminal domain', 264, NULL, 'CFAP61_N', 254601);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(435508, 'PF13066', NULL, 'Protein of unknown function (DUF3929)', 64, NULL, 'DUF3929', 254602),
(435509, 'PF16576', NULL, 'Barrel-sandwich domain of CusB or HlyD membrane-fusion', 214, NULL, 'HlyD_D23', 254603),
(435510, 'PF13024', NULL, 'Protein of unknown function (DUF3884)', 73, NULL, 'DUF3884', 254604),
(435511, 'PF17095', NULL, 'Spectrin-binding region of Ca2+-Calmodulin', 59, NULL, 'CAMSAP_CC1', 254605),
(435512, 'PF05845', NULL, 'Bacterial phosphonate metabolism protein (PhnH)', 188, NULL, 'PhnH', 254606),
(435513, 'PF13962', NULL, 'Domain of unknown function', 116, NULL, 'PGG', 254607),
(435514, 'PF08207', NULL, 'Elongation factor P (EF-P) KOW-like domain', 58, NULL, 'EFP_N', 254608),
(435515, 'PF11838', NULL, 'ERAP1-like C-terminal domain', 315, NULL, 'ERAP1_C', 254609),
(435516, 'PF06472', NULL, 'ABC transporter transmembrane region 2', 269, NULL, 'ABC_membrane_2', 254610),
(435517, 'PF14915', NULL, 'CCDC144C protein coiled-coil region', 304, NULL, 'CCDC144C', 254611),
(435518, 'PF11454', NULL, 'Protein of unknown function (DUF3016)', 139, NULL, 'DUF3016', 254612),
(435519, 'PF07976', NULL, 'Phenol hydroxylase, C-terminal dimerisation domain', 167, NULL, 'Phe_hydrox_dim', 254613),
(435520, 'PF13605', NULL, 'Domain of unknown function (DUF4141)', 53, NULL, 'DUF4141', 254614),
(435521, 'PF17201', NULL, 'Cache 3/Cache 2 fusion domain', 299, NULL, 'Cache_3-Cache_2', 254615),
(435522, 'PF11341', NULL, 'Protein of unknown function (DUF3143)', 65, NULL, 'DUF3143', 254616),
(435523, 'PF06979', NULL, 'TMEM70/TMEM186/TMEM223 protein family', 165, NULL, 'TMEM70', 254617),
(435524, 'PF04512', NULL, 'Baculovirus polyhedron envelope protein, PEP, N terminus', 111, NULL, 'Baculo_PEP_N', 254618),
(435525, 'PF13242', NULL, 'HAD-hyrolase-like', 75, NULL, 'Hydrolase_like', 254619),
(435526, 'PF19171', NULL, 'Family of unknown function (DUF5853)', 136, NULL, 'DUF5853', 254620),
(435527, 'PF03386', NULL, 'Early nodulin 93 ENOD93 protein', 78, NULL, 'ENOD93', 254621),
(435528, 'PF03454', NULL, 'MoeA C-terminal region (domain IV)', 72, NULL, 'MoeA_C', 254622),
(435529, 'PF10595', NULL, 'Uncharacterised protein family UPF0564', 364, NULL, 'UPF0564', 254623),
(435530, 'PF02207', NULL, 'Putative zinc finger in N-recognin (UBR box)', 70, NULL, 'zf-UBR', 254624),
(435531, 'PF11718', NULL, 'Pre-mRNA 3''-end-processing endonuclease polyadenylation factor C-term', 217, NULL, 'CPSF73-100_C', 254625),
(435532, 'PF20340', NULL, 'Family of unknown function (DUF6635)', 273, NULL, 'DUF6635', 254626),
(435533, 'PF14381', NULL, 'Ethylene-responsive protein kinase Le-CTR1', 203, NULL, 'EDR1', 254627),
(435534, 'PF15314', NULL, 'Proline-rich acidic protein 1, pregnancy-specific uterine', 45, NULL, 'PRAP', 254628),
(435535, 'PF13328', NULL, 'HD domain', 157, NULL, 'HD_4', 254629),
(435536, 'PF09895', NULL, 'RecB-family nuclease (DUF2122)', 106, NULL, 'DUF2122', 254630),
(435537, 'PF17748', NULL, 'VID27 N-terminal region', 173, NULL, 'VID27_N', 254631),
(435538, 'PF11344', NULL, 'Protein of unknown function (DUF3146)', 80, NULL, 'DUF3146', 254632),
(435539, 'PF10350', NULL, 'THADA/TRM732, DUF2428', 276, NULL, 'DUF2428', 254633),
(435540, 'PF02425', NULL, 'Paralytic/GBP/PSP peptide', 23, NULL, 'GBP_PSP', 254634),
(435541, 'PF12438', NULL, 'Protein of unknown function (DUF3679)', 56, NULL, 'DUF3679', 254635),
(435542, 'PF12843', NULL, 'Putative quorum-sensing-regulated virulence factor', 66, NULL, 'QSregVF_b', 254636),
(435543, 'PF13682', NULL, 'Chemoreceptor zinc-binding domain', 59, NULL, 'CZB', 254637),
(435544, 'PF01528', NULL, 'Herpesvirus glycoprotein M', 373, NULL, 'Herpes_glycop', 254638),
(435545, 'PF19998', NULL, 'FtsH ternary system domain X1', 273, NULL, 'fvmX1', 254639),
(435546, 'PF02258', NULL, 'Shiga-like toxin beta subunit', 70, NULL, 'SLT_beta', 254640),
(435547, 'PF12791', NULL, 'Anti-sigma factor N-terminus', 53, NULL, 'RsgI_N', 254641),
(435548, 'PF16448', NULL, 'LapD/MoxY periplasmic domain', 124, NULL, 'LapD_MoxY_N', 254642),
(435549, 'PF06288', NULL, 'Protein of unknown function (DUF1040)', 86, NULL, 'DUF1040', 254643);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(435550, 'PF08949', NULL, 'Bacteriophage PRD1, spike protein P5, C-terminal', 219, NULL, 'PRD1_P5_C', 254644),
(435551, 'PF17274', NULL, 'Family of unknown function (DUF5339)', 70, NULL, 'DUF5339', 254645),
(435552, 'PF12896', NULL, 'Anaphase-promoting complex, cyclosome, subunit 4', 204, NULL, 'ANAPC4', 254646),
(435553, 'PF07809', NULL, 'RTP801 C-terminal region', 119, NULL, 'RTP801_C', 254647),
(435554, 'PF16791', NULL, 'Connexin 40 C-terminal domain', 106, NULL, 'Connexin40_C', 254648),
(435555, 'PF20518', NULL, 'Anaphase-promoting complex subunit 1 middle domain', 371, NULL, 'Apc1_MidN', 254649),
(435556, 'PF15247', NULL, 'Histone RNA hairpin-binding protein RNA-binding domain', 70, NULL, 'SLBP_RNA_bind', 254650),
(435557, 'PF16315', NULL, 'Domain of unknown function (DUF4955)', 149, NULL, 'DUF4955', 254651),
(435558, 'PF12842', NULL, 'CCR4-Not complex, Not1 subunit, domain of unknown function DUF3819', 144, NULL, 'DUF3819', 254652),
(435559, 'PF09270', NULL, 'Beta-trefoil DNA-binding domain', 123, NULL, 'BTD', 254653),
(435560, 'PF11618', NULL, 'First C2 domain of RPGR-interacting protein 1', 141, NULL, 'C2-C2_1', 254654),
(435561, 'PF06435', NULL, 'Repeat of unknown function (DUF1079)', 31, NULL, 'DUF1079', 254655),
(435562, 'PF07534', NULL, 'TLD', 139, NULL, 'TLD', 254656),
(435563, 'PF00793', NULL, 'DAHP synthetase I family', 275, NULL, 'DAHP_synth_1', 254657),
(435564, 'PF12970', NULL, 'Domain of Unknown Function with PDB structure (DUF3858)', 116, NULL, 'DUF3858', 254658),
(435565, 'PF17770', NULL, 'Ribonuclease J C-terminal domain', 102, NULL, 'RNase_J_C', 254659),
(435566, 'PF12430', NULL, 'Abscisic acid G-protein coupled receptor', 182, NULL, 'ABA_GPCR', 254660),
(435567, 'PF00254', NULL, 'FKBP-type peptidyl-prolyl cis-trans isomerase', 94, NULL, 'FKBP_C', 254661),
(435568, 'PF12563', NULL, 'Hemolytic toxin N terminal', 188, NULL, 'Hemolysin_N', 254662),
(435569, 'PF16728', NULL, 'Domain of unknown function (DUF5066)', 222, NULL, 'DUF5066', 254663),
(435570, 'PF07127', NULL, 'Late nodulin protein', 54, NULL, 'Nodulin_late', 254664),
(435571, 'PF20270', NULL, 'CASPASE and TPR Repeat-Associated C-terminal domain', 138, NULL, 'CATRA-C', 254665),
(435572, 'PF08119', NULL, 'Scorpion acidic alpha-KTx toxin family', 37, NULL, 'Toxin_31', 254666),
(435573, 'PF12660', NULL, 'Putative zinc-finger of transcription factor IIIC complex', 101, NULL, 'zf-TFIIIC', 254667),
(435574, 'PF10891', NULL, 'Protein of unknown function (DUF2719)', 81, NULL, 'DUF2719', 254668),
(435575, 'PF11881', NULL, 'C-terminal domain of SPAR protein', 243, NULL, 'SPAR_C', 254669),
(435576, 'PF13855', NULL, 'Leucine rich repeat', 61, NULL, 'LRR_8', 254670),
(435577, 'PF11449', NULL, 'Putative, 10TM heavy-metal exporter', 363, NULL, 'ArsP_2', 254671),
(435578, 'PF18336', NULL, 'Fragile X mental retardation Tudor domain', 49, NULL, 'Tudor_FRX1', 254672),
(435579, 'PF06681', NULL, 'Protein of unknown function (DUF1182)', 208, NULL, 'DUF1182', 254673),
(435580, 'PF08349', NULL, 'Protein of unknown function (DUF1722)', 117, NULL, 'DUF1722', 254674),
(435581, 'PF18521', NULL, 'Transactivation domain 2', 25, NULL, 'TAD2', 254675),
(435582, 'PF18566', NULL, 'Linalool dehydratase/isomerase', 319, NULL, 'Ldi', 254676),
(435583, 'PF08225', NULL, 'Pseudin antimicrobial peptide', 23, NULL, 'Antimicrobial19', 254677),
(435584, 'PF18644', NULL, 'Phage integrase SAM-like domain', 132, NULL, 'Phage_int_SAM_6', 254678),
(435585, 'PF16209', NULL, 'Phospholipid-translocating ATPase N-terminal', 67, NULL, 'PhoLip_ATPase_N', 254679),
(435586, 'PF02170', NULL, 'PAZ domain', 132, NULL, 'PAZ', 254680),
(435587, 'PF18175', NULL, 'CCDC81-like prokaryotic HU domain 2', 70, NULL, 'HU-CCDC81_bac_2', 254681),
(435588, 'PF20201', NULL, 'Family of unknown function (DUF6563)', 191, NULL, 'DUF6563', 254682),
(435589, 'PF13654', NULL, 'LonB-like, AAA domain', 133, NULL, 'AAA_32', 254683),
(435590, 'PF18681', NULL, 'Family of unknown function (DUF5634)', 98, NULL, 'DUF5634', 254684),
(435591, 'PF19438', NULL, 'LIN9 C-terminal', 273, NULL, 'LIN9_C', 254685);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(435592, 'PF06519', NULL, 'TolA C-terminal', 96, NULL, 'TolA', 254686),
(435593, 'PF09690', NULL, 'Plasmodium yoelii subtelomeric region (PYST-C1)', 55, NULL, 'PYST-C1', 254687),
(435594, 'PF13924', NULL, 'Lipocalin-like domain', 143, NULL, 'Lipocalin_5', 254688),
(435595, 'PF14984', NULL, 'CD24 protein', 52, NULL, 'CD24', 254689),
(435596, 'PF11719', NULL, 'DNA replication and checkpoint protein', 450, NULL, 'Drc1-Sld2', 254690),
(435597, 'PF08827', NULL, 'Domain of unknown function (DUF1805)', 64, NULL, 'DUF1805', 254691),
(435598, 'PF00636', NULL, 'Ribonuclease III domain', 105, NULL, 'Ribonuclease_3', 254692),
(435599, 'PF04335', NULL, 'VirB8 protein', 212, NULL, 'VirB8', 254693),
(435600, 'PF15817', NULL, 'Transmembrane protein 40 family', 120, NULL, 'TMEM40', 254694),
(435601, 'PF20311', NULL, 'Family of unknown function (DUF6607)', 296, NULL, 'DUF6607', 254695),
(435602, 'PF10827', NULL, 'Protein of unknown function (DUF2552)', 79, NULL, 'DUF2552', 254696),
(435603, 'PF11629', NULL, 'C terminal SARAH domain of Mst1', 48, NULL, 'Mst1_SARAH', 254697),
(435604, 'PF10328', NULL, 'Serpentine type 7TM GPCR chemoreceptor Srx', 263, NULL, '7TM_GPCR_Srx', 254698),
(435605, 'PF08190', NULL, 'PIH1 N-terminal domain', 166, NULL, 'PIH1', 254699),
(435606, 'PF14230', NULL, 'Domain of unknown function (DUF4333)', 78, NULL, 'DUF4333', 254700),
(435607, 'PF10079', NULL, 'Bacillithiol biosynthesis BshC', 541, NULL, 'BshC', 254701),
(435608, 'PF04536', NULL, 'TPM domain', 125, NULL, 'TPM_phosphatase', 254702),
(435609, 'PF16224', NULL, 'DOmain of unknown function (DUF4883)', 119, NULL, 'DUF4883', 254703),
(435610, 'PF19631', NULL, 'Trypsin-co-occurring domain 2', 78, NULL, 'Trypco2', 254704),
(435611, 'PF17869', NULL, 'Anosmin cysteine rich domain', 82, NULL, 'Cys_box', 254705),
(435612, 'PF09763', NULL, 'Exocyst complex component Sec3', 707, NULL, 'Sec3_C', 254706),
(435613, 'PF07316', NULL, 'Protein of unknown function (DUF1463)', 137, NULL, 'DUF1463', 254707),
(435614, 'PF03976', NULL, 'Polyphosphate kinase 2 (PPK2)', 229, NULL, 'PPK2', 254708),
(435615, 'PF16097', NULL, 'Fragile X-related 1 protein C-terminal region 3', 68, NULL, 'FXR_C3', 254709),
(435616, 'PF14709', NULL, 'double strand RNA binding domain from DEAD END PROTEIN 1', 80, NULL, 'DND1_DSRM', 254710),
(435617, 'PF20051', NULL, 'Family of unknown function (DUF6453)', 291, NULL, 'DUF6453', 254711),
(435618, 'PF04350', NULL, 'Pilus assembly protein, PilO', 146, NULL, 'PilO', 254712),
(435619, 'PF11564', NULL, 'Restriction endonuclease BpuJI - N terminal', 278, NULL, 'BpuJI_N', 254713),
(435620, 'PF11256', NULL, 'Protein of unknown function (DUF3055)', 80, NULL, 'DUF3055', 254714),
(435621, 'PF05594', NULL, 'Haemagglutinin repeat', 77, NULL, 'Fil_haemagg', 254715),
(435622, 'PF10345', NULL, 'Cohesin loading factor', 586, NULL, 'Cohesin_load', 254716),
(435623, 'PF06068', NULL, 'TIP49 P-loop domain', 351, NULL, 'TIP49', 254717),
(435624, 'PF13813', NULL, 'Membrane bound O-acyl transferase family', 83, NULL, 'MBOAT_2', 254718),
(435625, 'PF20150', NULL, '2EXR family', 99, NULL, '2EXR', 254719),
(435626, 'PF06399', NULL, 'GTP cyclohydrolase I feedback regulatory protein (GFRP)', 83, NULL, 'GFRP', 254720),
(435627, 'PF14419', NULL, 'AF2226-like SPOUT RNA Methylase fused to THUMP', 173, NULL, 'SPOUT_MTase_2', 254721),
(435628, 'PF13953', NULL, 'PapC C-terminal domain', 66, NULL, 'PapC_C', 254722),
(435629, 'PF04293', NULL, 'SpoVR like protein', 418, NULL, 'SpoVR', 254723),
(435630, 'PF00348', NULL, 'Polyprenyl synthetase', 256, NULL, 'polyprenyl_synt', 254724),
(435631, 'PF01684', NULL, 'ET module', 79, NULL, 'ET', 254725),
(435632, 'PF17532', NULL, 'Family of unknown function (DUF5451)', 148, NULL, 'DUF5451', 254726),
(435633, 'PF07919', NULL, 'Gryzun, putative trafficking through Golgi', 589, NULL, 'Gryzun', 254727),
(435634, 'PF15927', NULL, 'Cancer susceptibility candidate 1 N-terminus', 201, NULL, 'Casc1_N', 254728),
(435635, 'PF01597', NULL, 'Glycine cleavage H-protein', 122, NULL, 'GCV_H', 254729),
(435636, 'PF08684', NULL, 'DNA mimic ocr', 101, NULL, 'ocr', 254730);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(435637, 'PF08155', NULL, 'NOGCT (NUC087) domain', 54, NULL, 'NOGCT', 254731),
(435638, 'PF05463', NULL, 'Sclerostin (SOST)', 198, NULL, 'Sclerostin', 254732),
(435639, 'PF02287', NULL, 'Dehydratase small subunit', 133, NULL, 'Dehydratase_SU', 254733),
(435640, 'PF11994', NULL, 'Protein of unknown function (DUF3489)', 68, NULL, 'DUF3489', 254734),
(435641, 'PF18932', NULL, 'Family of unknown function (DUF5681)', 77, NULL, 'DUF5681', 254735),
(435642, 'PF07019', NULL, 'EMC6', 83, NULL, 'EMC6', 254736),
(435643, 'PF09756', NULL, 'DDRGK domain', 188, NULL, 'DDRGK', 254737),
(435644, 'PF16569', NULL, 'Gram-positive pilin backbone subunit 2, Cna-B-like domain', 114, NULL, 'GramPos_pilinBB', 254738),
(435645, 'PF07936', NULL, 'Potassium-channel blocking toxin', 34, NULL, 'Defensin_4', 254739),
(435646, 'PF17529', NULL, 'Family of unknown function (DUF5450)', 161, NULL, 'DUF5450', 254740),
(435647, 'PF02298', NULL, 'Plastocyanin-like domain', 84, NULL, 'Cu_bind_like', 254741),
(435648, 'PF07699', NULL, 'Tyrosine-protein kinase ephrin type A/B receptor-like', 48, NULL, 'Ephrin_rec_like', 254742),
(435649, 'PF02548', NULL, 'Ketopantoate hydroxymethyltransferase', 259, NULL, 'Pantoate_transf', 254743),
(435650, 'PF03206', NULL, 'Nitrogen fixation protein NifW', 99, NULL, 'NifW', 254744),
(435651, 'PF16520', NULL, 'ssRNA-binding matrix protein of Bornaviridae', 103, NULL, 'BDV_M', 254745),
(435652, 'PF01025', NULL, 'GrpE', 166, NULL, 'GrpE', 254746),
(435653, 'PF07861', NULL, 'WisP family N-Terminal Region', 239, NULL, 'WND', 254747),
(435654, 'PF09827', NULL, 'CRISPR associated protein Cas2', 76, NULL, 'CRISPR_Cas2', 254748),
(435655, 'PF17942', NULL, 'Morc6 ribosomal protein S5 domain 2-like', 139, NULL, 'Morc6_S5', 254749),
(435656, 'PF07391', NULL, 'NPR nonapeptide repeat (2 copies)', 17, NULL, 'NPR', 254750),
(435657, 'PF11830', NULL, 'Domain of unknown function (DUF3350)', 63, NULL, 'DUF3350', 254751),
(435658, 'PF04994', NULL, 'TfoX C-terminal domain', 81, NULL, 'TfoX_C', 254752),
(435659, 'PF16439', NULL, 'Domain of unknown function (DUF5036)', 227, NULL, 'DUF5036', 254753),
(435660, 'PF08602', NULL, 'Mgr1-like, i-AAA protease complex subunit', 388, NULL, 'Mgr1', 254754),
(435661, 'PF16596', NULL, 'Disordered region downstream of MFMR', 136, NULL, 'MFMR_assoc', 254755),
(435662, 'PF11315', NULL, 'Mediator complex subunit 30', 147, NULL, 'Med30', 254756),
(435663, 'PF13648', NULL, 'Lipocalin-like domain', 89, NULL, 'Lipocalin_4', 254757),
(435664, 'PF14578', NULL, 'Elongation factor Tu domain 4', 87, NULL, 'GTP_EFTU_D4', 254758),
(435665, 'PF04945', NULL, 'YHS domain', 46, NULL, 'YHS', 254759),
(435666, 'PF18728', NULL, 'AbiV', 168, NULL, 'HEPN_AbiV', 254760),
(435667, 'PF18011', NULL, 'C-terminal domain found in long catalases', 151, NULL, 'Catalase_C', 254761),
(435668, 'PF13314', NULL, 'Domain of unknown function (DUF4083)', 57, NULL, 'DUF4083', 254762),
(435669, 'PF07900', NULL, 'Protein of unknown function (DUF1670)', 220, NULL, 'DUF1670', 254763),
(435670, 'PF08909', NULL, 'Domain of unknown function (DUF1854)', 130, NULL, 'DUF1854', 254764),
(435671, 'PF08028', NULL, 'Acyl-CoA dehydrogenase, C-terminal domain', 134, NULL, 'Acyl-CoA_dh_2', 254765),
(435672, 'PF04562', NULL, 'Dictyostelium spore coat protein, N terminus', 114, NULL, 'Dicty_spore_N', 254766),
(435673, 'PF11402', NULL, 'Antifungal protein', 50, NULL, 'Antifungal_prot', 254767),
(435674, 'PF18464', NULL, 'Proprotein convertase subtilisin-like/kexin type 9 C-terminal domain', 66, NULL, 'PCSK9_C2', 254768),
(435675, 'PF17670', NULL, 'Family of unknown function (DUF5530)', 141, NULL, 'DUF5530', 254769),
(435676, 'PF01682', NULL, 'DB module', 98, NULL, 'DB', 254770),
(435677, 'PF02770', NULL, 'Acyl-CoA dehydrogenase, middle domain', 97, NULL, 'Acyl-CoA_dh_M', 254771),
(435678, 'PF05032', NULL, 'Spo12 family', 35, NULL, 'Spo12', 254772),
(435679, 'PF13915', NULL, 'Domain of unknown function (DUF4210)', 73, NULL, 'DUF4210', 254773),
(435680, 'PF01310', NULL, 'Adenovirus hexon associated protein, protein VIII', 216, NULL, 'Adeno_PVIII', 254774);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(435681, 'PF16173', NULL, 'Domain of unknown function (DUF4874)', 160, NULL, 'DUF4874', 254775),
(435682, 'PF15046', NULL, 'Protein of unknown function (DUF4532)', 279, NULL, 'DUF4532', 254776),
(435683, 'PF00078', NULL, 'Reverse transcriptase (RNA-dependent DNA polymerase)', 222, NULL, 'RVT_1', 254777),
(435684, 'PF03981', NULL, 'Ubiquinol-cytochrome C chaperone', 141, NULL, 'Ubiq_cyt_C_chap', 254778),
(435685, 'PF09557', NULL, 'Domain of unknown function (DUF2382)', 111, NULL, 'DUF2382', 254779),
(435686, 'PF07906', NULL, 'ShET2 enterotoxin, N-terminal region', 278, NULL, 'Toxin_15', 254780),
(435687, 'PF15830', NULL, 'Domain of unknown function (DUF4712)', 254, NULL, 'DUF4712', 254781),
(435688, 'PF09107', NULL, 'Elongation factor SelB, winged helix', 47, NULL, 'SelB-wing_3', 254782),
(435689, 'PF17125', NULL, 'N-terminal domain of 16S rRNA methyltransferase RsmF', 91, NULL, 'Methyltr_RsmF_N', 254783),
(435690, 'PF05678', NULL, 'VQ motif', 28, NULL, 'VQ', 254784),
(435691, 'PF08467', NULL, 'Luteovirus RNA polymerase P1-P2/replicase', 339, NULL, 'Luteo_P1-P2', 254785),
(435692, 'PF17135', NULL, 'Ribosomal protein 60S L18 and 50S L18e', 187, NULL, 'Ribosomal_L18', 254786),
(435693, 'PF03707', NULL, 'Bacterial signalling protein N terminal repeat', 59, NULL, 'MHYT', 254787),
(435694, 'PF03327', NULL, 'Herpesvirus capsid shell protein VP19C', 265, NULL, 'Herpes_VP19C', 254788),
(435695, 'PF15521', NULL, 'Novel toxin 11', 272, NULL, 'Ntox11', 254789),
(435696, 'PF10460', NULL, 'Peptidase M30', 369, NULL, 'Peptidase_M30', 254790),
(435697, 'PF17680', NULL, 'FlgO protein', 131, NULL, 'FlgO', 254791),
(435698, 'PF02960', NULL, 'K1 glycoprotein', 120, NULL, 'K1', 254792),
(435699, 'PF11672', NULL, 'zinc-finger-containing domain', 117, NULL, 'DUF3268', 254793),
(435700, 'PF01387', NULL, 'Synuclein', 134, NULL, 'Synuclein', 254794),
(435701, 'PF04253', NULL, 'Transferrin receptor-like dimerisation domain', 125, NULL, 'TFR_dimer', 254795),
(435702, 'PF06033', NULL, 'Nucleopolyhedrovirus protein of unknown function (DUF918)', 152, NULL, 'DUF918', 254796),
(435703, 'PF15864', NULL, 'Protein glycosylation ligase', 26, NULL, 'PglL_A', 254797),
(435704, 'PF01169', NULL, 'Uncharacterized protein family UPF0016', 75, NULL, 'UPF0016', 254798),
(435705, 'PF17535', NULL, 'Family of unknown function (DUF5454)', 221, NULL, 'DUF5454', 254799),
(435706, 'PF14393', NULL, 'Domain of unknown function (DUF4422)', 225, NULL, 'DUF4422', 254800),
(435707, 'PF17003', NULL, 'Putative actin-like family', 369, NULL, 'Actin_micro', 254801),
(435708, 'PF09015', NULL, 'NgoMIV restriction enzyme', 275, NULL, 'NgoMIV_restric', 254802),
(435709, 'PF09492', NULL, 'Pectic acid lyase', 292, NULL, 'Pec_lyase', 254803),
(435710, 'PF11515', NULL, 'Mouse development and cellular proliferation protein Cullin-7', 78, NULL, 'Cul7', 254804),
(435711, 'PF01014', NULL, 'Uricase', 133, NULL, 'Uricase', 254805),
(435712, 'PF11195', NULL, 'Protein of unknown function (DUF2829)', 72, NULL, 'DUF2829', 254806),
(435713, 'PF06308', NULL, '23S rRNA methylastransferase leader peptide (ErmCL)', 31, NULL, 'ErmC', 254807),
(435714, 'PF04440', NULL, 'Dysbindin (Dystrobrevin binding protein 1)', 145, NULL, 'Dysbindin', 254808),
(435715, 'PF08745', NULL, 'PINc domain ribonuclease', 207, NULL, 'PIN_5', 254809),
(435716, 'PF12361', NULL, 'Duffy-antigen binding protein', 304, NULL, 'DBP', 254810),
(435717, 'PF18947', NULL, 'HAMP domain', 67, NULL, 'HAMP_2', 254811),
(435718, 'PF17077', NULL, 'Mitotic spindle associated protein SHE1', 331, NULL, 'Msap1', 254812),
(435719, 'PF04565', NULL, 'RNA polymerase Rpb2, domain 3', 68, NULL, 'RNA_pol_Rpb2_3', 254813),
(435720, 'PF08558', NULL, 'Telomere repeat binding factor (TRF)', 239, NULL, 'TRF', 254814),
(435721, 'PF03509', NULL, 'Gap junction alpha-8 protein (Cx50)', 66, NULL, 'Connexin50', 254815),
(435722, 'PF14207', NULL, 'DpnD/PcfM-like protein', 46, NULL, 'DpnD-PcfM', 254816),
(435723, 'PF17844', NULL, 'Bacterial SCP ortholog', 93, NULL, 'SCP_3', 254817),
(435724, 'PF10403', NULL, 'Rad4 beta-hairpin domain 1', 56, NULL, 'BHD_1', 254818);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(435725, 'PF09701', NULL, 'CRISPR-associated protein (Cas_Cmr5)', 121, NULL, 'Cas_Cmr5', 254819),
(435726, 'PF10266', NULL, 'Hereditary spastic paraplegia protein strumpellin', 1085, NULL, 'Strumpellin', 254820),
(435727, 'PF20279', NULL, 'C-terminal domain 12 of the ABC-three component (ABC-3C) systems', 144, NULL, 'CTD12', 254821),
(435728, 'PF11729', NULL, 'nodavirus capsid protein', 340, NULL, 'Capsid-VNN', 254822),
(435729, 'PF07715', NULL, 'TonB-dependent Receptor Plug Domain', 108, NULL, 'Plug', 254823),
(435730, 'PF19394', NULL, 'Family of unknown function (DUF5969)', 93, NULL, 'DUF5969', 254824),
(435731, 'PF00955', NULL, 'HCO3- transporter family', 498, NULL, 'HCO3_cotransp', 254825),
(435732, 'PF07448', NULL, 'Secreted phosphoprotein 24 (Spp-24) cystatin-like domain', 64, NULL, 'Spp-24', 254826),
(435733, 'PF14880', NULL, 'Cytochrome oxidase c assembly', 59, NULL, 'COX14', 254827),
(435734, 'PF11952', NULL, 'XRN-Two Binding Domain, XTBD', 85, NULL, 'XTBD', 254828),
(435735, 'PF10651', NULL, 'BppU N-terminal domain', 144, NULL, 'BppU_N', 254829),
(435736, 'PF07645', NULL, 'Calcium-binding EGF domain', 42, NULL, 'EGF_CA', 254830),
(435737, 'PF20065', NULL, 'Family of unknown function (DUF6464)', 117, NULL, 'DUF6464', 254831),
(435738, 'PF00180', NULL, 'Isocitrate/isopropylmalate dehydrogenase', 347, NULL, 'Iso_dh', 254832),
(435739, 'PF02203', NULL, 'Tar ligand binding domain homologue', 177, NULL, 'TarH', 254833),
(435740, 'PF02570', NULL, 'Precorrin-8X methylmutase', 196, NULL, 'CbiC', 254834),
(435741, 'PF05358', NULL, 'DicB protein', 62, NULL, 'DicB', 254835),
(435742, 'PF02038', NULL, 'ATP1G1/PLM/MAT8 family', 48, NULL, 'ATP1G1_PLM_MAT8', 254836),
(435743, 'PF08111', NULL, 'Pea-VEAacid family', 15, NULL, 'Pea-VEAacid', 254837),
(435744, 'PF10567', NULL, 'RNA-recognition motif', 310, NULL, 'Nab6_mRNP_bdg', 254838),
(435745, 'PF02975', NULL, 'Methylamine dehydrogenase, L chain', 113, NULL, 'Me-amine-dh_L', 254839),
(435746, 'PF03492', NULL, 'SAM dependent carboxyl methyltransferase', 334, NULL, 'Methyltransf_7', 254840),
(435747, 'PF15621', NULL, 'Proline-rich submaxillary gland androgen-regulated family', 104, NULL, 'PROL5-SMR', 254841),
(435748, 'PF04157', NULL, 'EAP30/Vps36 family', 236, NULL, 'EAP30', 254842),
(435749, 'PF11275', NULL, 'Protein of unknown function (DUF3077)', 77, NULL, 'DUF3077', 254843),
(435750, 'PF11797', NULL, 'Protein of unknown function C-terminal (DUF3324)', 138, NULL, 'DUF3324', 254844),
(435751, 'PF18310', NULL, 'Domain of unknown function (DUF5605)', 73, NULL, 'DUF5605', 254845),
(435752, 'PF20078', NULL, 'Domain of unknown function (DUF6473)', 274, NULL, 'DUF6473', 254846),
(435753, 'PF00386', NULL, 'C1q domain', 127, NULL, 'C1q', 254847),
(435754, 'PF02021', NULL, 'Uncharacterised protein family UPF0102', 79, NULL, 'UPF0102', 254848),
(435755, 'PF18058', NULL, 'SbsC C-terminal domain', 132, NULL, 'SbsC_C', 254849),
(435756, 'PF04056', NULL, 'Ssl1-like', 193, NULL, 'Ssl1', 254850),
(435757, 'PF08384', NULL, 'Pro-opiomelanocortin, N-terminal region', 44, NULL, 'NPP', 254851),
(435758, 'PF19644', NULL, 'Family of unknown function (DUF6147)', 138, NULL, 'DUF6147', 254852),
(435759, 'PF20343', NULL, 'Family of unknown function (DUF6638)', 439, NULL, 'DUF6638', 254853),
(435760, 'PF09002', NULL, 'Domain of unknown function (DUF1887)', 386, NULL, 'DUF1887', 254854),
(435761, 'PF05525', NULL, 'Branched-chain amino acid transport protein', 429, NULL, 'Branch_AA_trans', 254855),
(435762, 'PF08000', NULL, 'Bacterial PH domain', 123, NULL, 'bPH_1', 254856),
(435763, 'PF15691', NULL, 'Protein phosphatase 1 regulatory subunit 32', 422, NULL, 'PPP1R32', 254857),
(435764, 'PF00924', NULL, 'Mechanosensitive ion channel', 206, NULL, 'MS_channel', 254858),
(435765, 'PF20503', NULL, 'Family of unknown function (DUF6730)', 82, NULL, 'DUF6730', 254859),
(435766, 'PF13347', NULL, 'MFS/sugar transport protein', 427, NULL, 'MFS_2', 254860),
(435767, 'PF16309', NULL, 'Domian of unknown function (DUF4951)', 83, NULL, 'DUF4951', 254861),
(435768, 'PF05400', NULL, 'Flagellar protein FliT', 85, NULL, 'FliT', 254862);
INSERT INTO "PUBLIC"."MODEL" VALUES
(435769, 'PF13481', NULL, 'AAA domain', 194, NULL, 'AAA_25', 254863),
(435770, 'PF04896', NULL, 'Ammonia monooxygenase/methane monooxygenase, subunit C', 245, NULL, 'AmoC', 254864),
(435771, 'PF06628', NULL, 'Catalase-related immune-responsive', 65, NULL, 'Catalase-rel', 254865),
(435772, 'PF13676', NULL, 'TIR domain', 121, NULL, 'TIR_2', 254866),
(435773, 'PF10590', NULL, 'Pyridoxine 5''-phosphate oxidase C-terminal dimerisation region', 43, NULL, 'PNP_phzG_C', 254867),
(435774, 'PF14928', NULL, 'Short tail fibre protein receptor-binding domain', 93, NULL, 'S_tail_recep_bd', 254868),
(435775, 'PF12511', NULL, 'Protein of unknown function (DUF3716)', 59, NULL, 'DUF3716', 254869),
(435776, 'PF07851', NULL, 'TMPIT-like protein', 324, NULL, 'TMPIT', 254870),
(435777, 'PF01048', NULL, 'Phosphorylase superfamily', 234, NULL, 'PNP_UDP_1', 254871),
(435778, 'PF13362', NULL, 'Toprim domain', 95, NULL, 'Toprim_3', 254872),
(435779, 'PF03361', NULL, 'Herpes virus intermediate/early protein 2/3', 162, NULL, 'Herpes_IE2_3', 254873),
(435780, 'PF09738', NULL, 'LRRFIP family', 305, NULL, 'LRRFIP', 254874),
(435781, 'PF15922', NULL, 'YjeJ-like', 283, NULL, 'YjeJ', 254875),
(435782, 'PF01030', NULL, 'Receptor L domain', 110, NULL, 'Recep_L_domain', 254876),
(435783, 'PF15177', NULL, 'Interleukin-28A', 157, NULL, 'IL28A', 254877),
(435784, 'PF18623', NULL, 'TnsE C-terminal domain', 145, NULL, 'TnsE_C', 254878),
(435785, 'PF12590', NULL, 'Acyl-ATP thioesterase', 130, NULL, 'Acyl-thio_N', 254879),
(435786, 'PF07902', NULL, 'gp58-like protein', 594, NULL, 'Gp58', 254880),
(435787, 'PF00804', NULL, 'Syntaxin', 199, NULL, 'Syntaxin', 254881),
(435788, 'PF01220', NULL, 'Dehydroquinase class II', 138, NULL, 'DHquinase_II', 254882),
(435789, 'PF08366', NULL, 'LLGL2', 104, NULL, 'LLGL', 254883),
(435790, 'PF11702', NULL, 'Protein of unknown function (DUF3295)', 498, NULL, 'DUF3295', 254884),
(435791, 'PF08643', NULL, 'Fungal family of unknown function (DUF1776)', 296, NULL, 'DUF1776', 254885),
(435792, 'PF11804', NULL, 'Protein of unknown function (DUF3325)', 101, NULL, 'DUF3325', 254886),
(435793, 'PF09508', NULL, 'Lacto-N-biose phosphorylase N-terminal TIM barrel domain', 434, NULL, 'Lact_bio_phlase', 254887),
(435794, 'PF14253', NULL, 'Bacteriophage abortive infection AbiH', 260, NULL, 'AbiH', 254888),
(435795, 'PF04593', NULL, 'Selenoprotein P, C terminal region', 133, NULL, 'SelP_C', 254889),
(435796, 'PF18637', NULL, 'Aldos-2-ulose dehydratase/isomerase (AUDH) Cupin domain', 158, NULL, 'AUDH_Cupin', 254890),
(435797, 'PF03504', NULL, 'Chlamydia cysteine-rich outer membrane protein 6', 91, NULL, 'Chlam_OMP6', 254891),
(435798, 'PF05793', NULL, 'Transcription initiation factor IIF, alpha subunit (TFIIF-alpha)', 528, NULL, 'TFIIF_alpha', 254892),
(435799, 'PF14613', NULL, 'Protein of unknown function (DUF4449)', 163, NULL, 'DUF4449', 254893),
(435800, 'PF09235', NULL, 'Ste50p, sterile alpha motif', 75, NULL, 'SAM_Ste50p', 254894),
(435801, 'PF16018', NULL, 'Anillin N-terminus', 86, NULL, 'Anillin_N', 254895),
(435802, 'PF15491', NULL, 'CST, telomere maintenance, complex subunit CTC1', 291, NULL, 'CTC1_2', 254896),
(435803, 'PF03208', NULL, 'PRA1 family protein', 143, NULL, 'PRA1', 254897),
(435804, 'PF14729', NULL, 'Domain of unknown function with cystatin-like fold (DUF4467)', 94, NULL, 'DUF4467', 254898),
(435805, 'PF15508', NULL, 'beta subunit of N-acylethanolamine-hydrolyzing acid amidase', 63, NULL, 'NAAA-beta', 254899),
(435806, 'PF13752', NULL, 'Domain of unknown function (DUF4165)', 121, NULL, 'DUF4165', 254900),
(435807, 'PF11738', NULL, 'Protein of unknown function (DUF3298)', 84, NULL, 'DUF3298', 254901),
(435808, 'PF13164', NULL, 'Diedel', 75, NULL, 'Diedel', 254902),
(435809, 'PF15301', NULL, 'SLAIN motif-containing family', 436, NULL, 'SLAIN', 254903),
(435810, 'PF12890', NULL, 'Dihydro-orotase-like', 142, NULL, 'DHOase', 254904),
(435811, 'PF15002', NULL, 'ERK and JNK pathways, inhibitor', 200, NULL, 'ERK-JNK_inhib', 254905),
(435812, 'PF15094', NULL, 'Domain of unknown function (DUF4556)', 215, NULL, 'DUF4556', 254906);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(435813, 'PF19577', NULL, 'DcaP outer membrane protein', 410, NULL, 'DcaP', 254907),
(435814, 'PF04587', NULL, 'ADP-specific Phosphofructokinase/Glucokinase conserved region', 427, NULL, 'ADP_PFK_GK', 254908),
(435815, 'PF14137', NULL, 'Domain of unknown function (DUF4304)', 116, NULL, 'DUF4304', 254909),
(435816, 'PF18562', NULL, 'Cysteine-Rich Interdomain Region 1 gamma', 52, NULL, 'CIDR1_gamma', 254910),
(435817, 'PF12668', NULL, 'Protein of unknown function (DUF3791)', 60, NULL, 'DUF3791', 254911),
(435818, 'PF01577', NULL, 'Potyvirus P1 protease', 245, NULL, 'Peptidase_S30', 254912),
(435819, 'PF12722', NULL, 'High-temperature-induced dauer-formation protein', 811, NULL, 'Hid1', 254913),
(435820, 'PF11671', NULL, 'Complementary sex determiner protein', 146, NULL, 'Apis_Csd', 254914),
(435821, 'PF04333', NULL, 'MlaA lipoprotein', 196, NULL, 'MlaA', 254915),
(435822, 'PF17423', NULL, 'Swarming motility protein', 116, NULL, 'SwrA', 254916),
(435823, 'PF03729', NULL, 'Short repeat of unknown function (DUF308)', 73, NULL, 'DUF308', 254917),
(435824, 'PF09016', NULL, 'Pas factor saposin fold', 73, NULL, 'Pas_Saposin', 254918),
(435825, 'PF12518', NULL, 'Protein of unknown function', 33, NULL, 'DUF3721', 254919),
(435826, 'PF16368', NULL, 'Cytoplasmic polyadenylation element-binding protein 1 N-terminus', 307, NULL, 'CEBP1_N', 254920),
(435827, 'PF08670', NULL, 'MEKHLA domain', 143, NULL, 'MEKHLA', 254921),
(435828, 'PF08764', NULL, 'Staphylococcus aureus coagulase', 279, NULL, 'Coagulase', 254922),
(435829, 'PF15697', NULL, 'Domain of unknown function (DUF4666)', 113, NULL, 'DUF4666', 254923),
(435830, 'PF14414', NULL, 'A nuclease of the HNH/ENDO VII superfamily with conserved WHH', 43, NULL, 'WHH', 254924),
(435831, 'PF11134', NULL, 'Phage stabilisation protein', 469, NULL, 'Phage_stabilise', 254925),
(435832, 'PF02076', NULL, 'Pheromone A receptor', 289, NULL, 'STE3', 254926),
(435833, 'PF20053', NULL, 'Wolframin cysteine-rich domain', 111, NULL, 'WC-rich', 254927),
(435834, 'PF06097', NULL, 'Bacterial protein of unknown function (DUF945)', 457, NULL, 'DUF945', 254928),
(435835, 'PF13375', NULL, 'RnfC Barrel sandwich hybrid domain', 101, NULL, 'RnfC_N', 254929),
(435836, 'PF10824', NULL, 'Excreted virulence factor EspC, type VII ESX diderm', 100, NULL, 'T7SS_ESX_EspC', 254930),
(435837, 'PF15258', NULL, 'Protein family of FAM222A', 527, NULL, 'FAM222A', 254931),
(435838, 'PF02206', NULL, 'Domain of unknown function', 66, NULL, 'WSN', 254932),
(435839, 'PF19653', NULL, 'Family of unknown function (DUF6156)', 97, NULL, 'DUF6156', 254933),
(435840, 'PF11090', NULL, 'Bacteriophage T7, probable scaffold protein Gp13', 86, NULL, 'Phage_T7_Gp13', 254934),
(435841, 'PF00498', NULL, 'FHA domain', 69, NULL, 'FHA', 254935),
(435842, 'PF05698', NULL, 'Bacterial trigger factor protein (TF) C-terminus', 162, NULL, 'Trigger_C', 254936),
(435843, 'PF05651', NULL, 'Putative sugar diacid recognition', 134, NULL, 'Diacid_rec', 254937),
(435844, 'PF08316', NULL, 'Pal1 cell morphology protein', 138, NULL, 'Pal1', 254938),
(435845, 'PF04516', NULL, 'CP2 transcription factor', 230, NULL, 'CP2', 254939),
(435846, 'PF11488', NULL, 'Transcriptional regulatory protein LGE1', 71, NULL, 'Lge1', 254940),
(435847, 'PF13642', NULL, 'protein structure with unknown function', 108, NULL, 'DUF4144', 254941),
(435848, 'PF01880', NULL, 'Desulfoferrodoxin', 97, NULL, 'Desulfoferrodox', 254942),
(435849, 'PF04732', NULL, 'Intermediate filament head (DNA binding) region', 86, NULL, 'Filament_head', 254943),
(435850, 'PF00729', NULL, 'Viral coat protein (S domain)', 207, NULL, 'Viral_coat', 254944),
(435851, 'PF09362', NULL, 'Domain of unknown function (DUF1996)', 233, NULL, 'DUF1996', 254945),
(435852, 'PF11295', NULL, 'Protein of unknown function (DUF3096)', 37, NULL, 'DUF3096', 254946),
(435853, 'PF00488', NULL, 'MutS domain V', 188, NULL, 'MutS_V', 254947),
(435854, 'PF01731', NULL, 'Arylesterase', 86, NULL, 'Arylesterase', 254948),
(435855, 'PF19001', NULL, 'Family of unknown function (DUF5730)', 182, NULL, 'DUF5730', 254949);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(435856, 'PF01514', NULL, 'Secretory protein of YscJ/FliF family', 179, NULL, 'YscJ_FliF', 254950),
(435857, 'PF19041', NULL, 'Nuclear cap binding complex subunit CBP30', 299, NULL, 'CBP30', 254951),
(435858, 'PF03181', NULL, 'BURP domain', 215, NULL, 'BURP', 254952),
(435859, 'PF05199', NULL, 'GMC oxidoreductase', 145, NULL, 'GMC_oxred_C', 254953),
(435860, 'PF15816', NULL, 'Transmembrane protein 82', 305, NULL, 'TMEM82', 254954),
(435861, 'PF07466', NULL, 'Protein of unknown function (DUF1517)', 184, NULL, 'DUF1517', 254955),
(435862, 'PF17741', NULL, 'Family of unknown function (DUF5578)', 268, NULL, 'DUF5578', 254956),
(435863, 'PF19676', NULL, 'Family of unknown function (DUF6178)', 565, NULL, 'DUF6178', 254957),
(435864, 'PF02797', NULL, 'Chalcone and stilbene synthases, C-terminal domain', 151, NULL, 'Chal_sti_synt_C', 254958),
(435865, 'PF06637', NULL, 'PV-1 protein (PLVAP)', 439, NULL, 'PV-1', 254959),
(435866, 'PF17432', NULL, 'Domain of unknown function (DUF3458_C) ARM repeats', 319, NULL, 'DUF3458_C', 254960),
(435867, 'PF14252', NULL, 'Domain of unknown function (DUF4347)', 164, NULL, 'DUF4347', 254961),
(435868, 'PF07226', NULL, 'Protein of unknown function (DUF1422)', 114, NULL, 'DUF1422', 254962),
(435869, 'PF08355', NULL, 'EF hand associated', 73, NULL, 'EF_assoc_1', 254963),
(435870, 'PF00986', NULL, 'DNA gyrase B subunit, carboxyl terminus', 63, NULL, 'DNA_gyraseB_C', 254964),
(435871, 'PF11941', NULL, 'Domain of unknown function (DUF3459)', 91, NULL, 'DUF3459', 254965),
(435872, 'PF02079', NULL, 'Nuclear transition protein 1', 51, NULL, 'TP1', 254966),
(435873, 'PF11824', NULL, 'Protein of unknown function (DUF3344)', 265, NULL, 'DUF3344', 254967),
(435874, 'PF02621', NULL, 'Menaquinone biosynthesis', 261, NULL, 'VitK2_biosynth', 254968),
(435875, 'PF16514', NULL, 'putative NADH-ubiquinone oxidoreductase chain E', 74, NULL, 'NADH-UOR_E', 254969),
(435876, 'PF03732', NULL, 'Retrotransposon gag protein', 96, NULL, 'Retrotrans_gag', 254970),
(435877, 'PF18672', NULL, 'N-terminal PilZ-like domain PilZN1', 93, NULL, 'PilZN1', 254971),
(435878, 'PF09535', NULL, 'Protein of unknown function (Gmx_para_CXXCG)', 235, NULL, 'Gmx_para_CXXCG', 254972),
(435879, 'PF14108', NULL, 'ABA DEFICIENT 4-like', 127, NULL, 'ABA4-like', 254973),
(435880, 'PF06955', NULL, 'Xyloglucan endo-transglycosylase (XET) C-terminus', 47, NULL, 'XET_C', 254974),
(435881, 'PF13137', NULL, 'Protein of unknown function (DUF3983)', 34, NULL, 'DUF3983', 254975),
(435882, 'PF16436', NULL, 'Domain of unknown function (DUF5033)', 178, NULL, 'DUF5033', 254976),
(435883, 'PF15911', NULL, 'WD domain, G-beta repeat', 57, NULL, 'WD40_3', 254977),
(435884, 'PF03726', NULL, 'Polyribonucleotide nucleotidyltransferase, RNA binding domain', 83, NULL, 'PNPase', 254978),
(435885, 'PF06054', NULL, 'Competence protein CoiA-like family', 377, NULL, 'CoiA', 254979),
(435886, 'PF19889', NULL, 'Domain of unknown function (DUF6362)', 98, NULL, 'DUF6362', 254980),
(435887, 'PF03797', NULL, 'Autotransporter beta-domain', 255, NULL, 'Autotransporter', 254981),
(435888, 'PF07626', NULL, 'Protein of unknown function (DUF1587)', 65, NULL, 'PSD3', 254982),
(435889, 'PF09145', NULL, 'Ubiquitin-associated', 44, NULL, 'Ubiq-assoc', 254983),
(435890, 'PF09556', NULL, 'HaeIII restriction endonuclease', 298, NULL, 'RE_HaeIII', 254984),
(435891, 'PF15876', NULL, 'Domain of unknown function (DUF4732)', 159, NULL, 'DUF4732', 254985),
(435892, 'PF06261', NULL, 'Actinobacillus actinomycetemcomitans leukotoxin activator LktC', 150, NULL, 'LktC', 254986),
(435893, 'PF19779', NULL, 'Family of unknown function (DUF6264)', 185, NULL, 'DUF6264', 254987),
(435894, 'PF02084', NULL, 'Bindin', 238, NULL, 'Bindin', 254988),
(435895, 'PF14319', NULL, 'Transposase zinc-binding domain', 91, NULL, 'Zn_Tnp_IS91', 254989),
(435896, 'PF07311', NULL, 'Dodecin', 64, NULL, 'Dodecin', 254990),
(435897, 'PF03009', NULL, 'Glycerophosphoryl diester phosphodiesterase family', 259, NULL, 'GDPD', 254991),
(435898, 'PF15359', NULL, 'Carnitine deficiency-associated protein 3', 130, NULL, 'CDV3', 254992);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(435899, 'PF19261', NULL, 'Domain of unknown function (DUF5904)', 133, NULL, 'DUF5904', 254993),
(435900, 'PF03630', NULL, 'Fumble', 333, NULL, 'Fumble', 254994),
(435901, 'PF17100', NULL, 'N-terminal domain of NWD NACHT-NTPase', 220, NULL, 'NACHT_N', 254995),
(435902, 'PF13699', NULL, 'Domain of unknown function (DUF4157)', 79, NULL, 'DUF4157', 254996),
(435903, 'PF15152', NULL, 'Kisspeptin', 76, NULL, 'Kisspeptin', 254997),
(435904, 'PF02698', NULL, 'DUF218 domain', 130, NULL, 'DUF218', 254998),
(435905, 'PF09573', NULL, 'TaqI restriction endonuclease', 229, NULL, 'RE_TaqI', 254999),
(435906, 'PF00944', NULL, 'Alphavirus core protein', 159, NULL, 'Peptidase_S3', 255000),
(435907, 'PF11281', NULL, 'Protein of unknown function (DUF3083)', 314, NULL, 'DUF3083', 255001),
(435908, 'PF00505', NULL, 'HMG (high mobility group) box', 69, NULL, 'HMG_box', 255002),
(435909, 'PF16834', NULL, 'Shu complex component Csm2, DNA-binding', 202, NULL, 'CSM2', 255003),
(435910, 'PF11319', NULL, 'Type VI secretion system VasI, EvfG, VC_A0118', 183, NULL, 'VasI', 255004),
(435911, 'PF02485', NULL, 'Core-2/I-Branching enzyme', 247, NULL, 'Branch', 255005),
(435912, 'PF08449', NULL, 'UAA transporter family', 307, NULL, 'UAA', 255006),
(435913, 'PF04849', NULL, 'HAP1 N-terminal conserved region', 310, NULL, 'HAP1_N', 255007),
(435914, 'PF03303', NULL, 'WTF protein', 221, NULL, 'WTF', 255008),
(435915, 'PF13287', NULL, 'Fn3 associated', 59, NULL, 'Fn3_assoc', 255009),
(435916, 'PF14442', NULL, 'Bd3614-like deaminase N-terminal', 92, NULL, 'Bd3614_N', 255010),
(435917, 'PF08883', NULL, 'Dopa 4,5-dioxygenase family', 107, NULL, 'DOPA_dioxygen', 255011),
(435918, 'PF15656', NULL, 'Toxin with a H, D/N and C signature', 130, NULL, 'Tox-HDC', 255012),
(435919, 'PF07869', NULL, 'Protein of unknown function (DUF1656)', 56, NULL, 'DUF1656', 255013),
(435920, 'PF13122', NULL, 'Protein of unknown function (DUF3977)', 77, NULL, 'DUF3977', 255014),
(435921, 'PF08691', NULL, 'DNA repair proteins Nse5 and Nse6', 513, NULL, 'Nse5', 255015),
(435922, 'PF10971', NULL, 'Protein of unknown function (DUF2773)', 81, NULL, 'DUF2773', 255016),
(435923, 'PF02293', NULL, 'AmiS/UreI family transporter', 166, NULL, 'AmiS_UreI', 255017),
(435924, 'PF14907', NULL, 'Uncharacterised nucleotidyltransferase', 250, NULL, 'NTP_transf_5', 255018),
(435925, 'PF08664', NULL, 'YcbB domain', 136, NULL, 'YcbB', 255019),
(435926, 'PF16770', NULL, 'Regulator of Ty1 transposition protein 107 BRCT domain', 100, NULL, 'RTT107_BRCT_5', 255020),
(435927, 'PF03284', NULL, 'Phenazine biosynthesis protein A/B', 162, NULL, 'PHZA_PHZB', 255021),
(435928, 'PF17184', NULL, 'Rit1 N-terminal domain', 267, NULL, 'Rit1_C', 255022),
(435929, 'PF08723', NULL, 'Gag protein p15', 123, NULL, 'Gag_p15', 255023),
(435930, 'PF10294', NULL, 'Lysine methyltransferase', 174, NULL, 'Methyltransf_16', 255024),
(435931, 'PF06570', NULL, 'Protein of unknown function (DUF1129)', 207, NULL, 'DUF1129', 255025),
(435932, 'PF04004', NULL, 'Leo1-like protein', 165, NULL, 'Leo1', 255026),
(435933, 'PF10036', NULL, 'RNA transcription, translation and transport factor protein', 257, NULL, 'RLL', 255027),
(435934, 'PF04780', NULL, 'Protein of unknown function (DUF629)', 466, NULL, 'DUF629', 255028),
(435935, 'PF20059', NULL, 'Domain of unknown function (DUF6458)', 78, NULL, 'DUF6458', 255029),
(435936, 'PF04425', NULL, 'Bul1 N terminus', 451, NULL, 'Bul1_N', 255030),
(435937, 'PF13253', NULL, 'Protein of unknown function (DUF4044)', 33, NULL, 'DUF4044', 255031),
(435938, 'PF15244', NULL, 'Spermatogenesis-associated protein 7, or HSD3', 416, NULL, 'HSD3', 255032),
(435939, 'PF13477', NULL, 'Glycosyl transferase 4-like', 139, NULL, 'Glyco_trans_4_2', 255033),
(435940, 'PF14199', NULL, 'Domain of unknown function (DUF4317)', 371, NULL, 'DUF4317', 255034),
(435941, 'PF13782', NULL, 'Stage V sporulation protein AB', 109, NULL, 'SpoVAB', 255035),
(435942, 'PF05474', NULL, 'Semenogelin', 582, NULL, 'Semenogelin', 255036),
(435943, 'PF05680', NULL, 'ATP synthase E chain', 96, NULL, 'ATP-synt_E', 255037);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(435944, 'PF04080', NULL, 'Per1-like family', 260, NULL, 'Per1', 255038),
(435945, 'PF11960', NULL, 'Domain of unknown function (DUF3474)', 136, NULL, 'DUF3474', 255039),
(435946, 'PF05232', NULL, 'Chlorhexidine efflux transporter', 64, NULL, 'BTP', 255040),
(435947, 'PF11705', NULL, 'DNA-directed RNA polymerase III subunit Rpc31', 214, NULL, 'RNA_pol_3_Rpc31', 255041),
(435948, 'PF16742', NULL, 'N-terminus of interleukin 17 receptor D', 122, NULL, 'IL17R_D_N', 255042),
(435949, 'PF08638', NULL, 'Mediator complex subunit MED14', 193, NULL, 'Med14', 255043),
(435950, 'PF01957', NULL, 'NfeD-like C-terminal, partner-binding', 88, NULL, 'NfeD', 255044),
(435951, 'PF09286', NULL, 'Pro-kumamolisin, activation domain', 142, NULL, 'Pro-kuma_activ', 255045),
(435952, 'PF02446', NULL, '4-alpha-glucanotransferase', 465, NULL, 'Glyco_hydro_77', 255046),
(435953, 'PF19236', NULL, 'ADAMTS cysteine-rich domain', 115, NULL, 'ADAMTS_CR_3', 255047),
(435954, 'PF16517', NULL, 'Novel Ras effector 1 C-terminal SARAH (Sav/Rassf/Hpo) domain', 40, NULL, 'Nore1-SARAH', 255048),
(435955, 'PF18436', NULL, 'Helical box domain of E3 ubiquitin-protein ligase HECW1', 67, NULL, 'HECW1_helix', 255049),
(435956, 'PF04277', NULL, 'Oxaloacetate decarboxylase, gamma chain', 77, NULL, 'OAD_gamma', 255050),
(435957, 'PF14147', NULL, 'Sporulation protein YhaL', 52, NULL, 'Spore_YhaL', 255051),
(435958, 'PF11818', NULL, 'C-terminal domain of tail specific protease (DUF3340)', 156, NULL, 'DUF3340', 255052),
(435959, 'PF17245', NULL, 'Cell division control protein 24, OB domain 2', 129, NULL, 'CDC24_OB2', 255053),
(435960, 'PF16379', NULL, 'Domain of unknown function (DUF4989)', 293, NULL, 'DUF4989', 255054),
(435961, 'PF01790', NULL, 'Prolipoprotein diacylglyceryl transferase', 242, NULL, 'LGT', 255055),
(435962, 'PF01877', NULL, 'RNA binding', 119, NULL, 'RNA_binding', 255056),
(435963, 'PF05413', NULL, 'Putative closterovirus papain-like endopeptidase', 92, NULL, 'Peptidase_C34', 255057),
(435964, 'PF18089', NULL, 'DAPG hydrolase PhiG domain', 224, NULL, 'DAPG_hydrolase', 255058),
(435965, 'PF18401', NULL, 'Thioredoxin-like domain', 136, NULL, 'Thioredoxin_13', 255059),
(435966, 'PF15265', NULL, 'FAM196 family', 491, NULL, 'FAM196', 255060),
(435967, 'PF01426', NULL, 'BAH domain', 122, NULL, 'BAH', 255061),
(435968, 'PF10354', NULL, 'rRNA (uridine-N3-)-methyltransferase BTM5-like', 169, NULL, 'BMT5-like', 255062),
(435969, 'PF12301', NULL, 'CD99 antigen like protein 2', 173, NULL, 'CD99L2', 255063),
(435970, 'PF15196', NULL, 'Activator of apoptosis harakiri', 92, NULL, 'Harakiri', 255064),
(435971, 'PF15370', NULL, 'NOP protein chaperone 1', 110, NULL, 'NOPCHAP1', 255065),
(435972, 'PF02108', NULL, 'Flagellar assembly protein FliH', 128, NULL, 'FliH', 255066),
(435973, 'PF01359', NULL, 'Transposase (partial DDE domain)', 80, NULL, 'Transposase_1', 255067),
(435974, 'PF16868', NULL, 'NMT1-like family', 289, NULL, 'NMT1_3', 255068),
(435975, 'PF10009', NULL, 'Uncharacterized protein conserved in bacteria (DUF2252)', 384, NULL, 'DUF2252', 255069),
(435976, 'PF17410', NULL, 'Subtelomeric Variable Open Reading frame', 275, NULL, 'Stevor', 255070),
(435977, 'PF00598', NULL, 'Influenza Matrix protein (M1)', 157, NULL, 'Flu_M1', 255071),
(435978, 'PF11802', NULL, 'Centromere-associated protein K', 264, NULL, 'CENP-K', 255072),
(435979, 'PF04181', NULL, 'Rtr1/RPAP2 family', 76, NULL, 'RPAP2_Rtr1', 255073),
(435980, 'PF16095', NULL, 'C-terminal of Roc, COR, domain', 194, NULL, 'COR', 255074),
(435981, 'PF09092', NULL, 'Lyase, N terminal', 167, NULL, 'Lyase_N', 255075),
(435982, 'PF20418', NULL, 'Alphaherpesvirus glycoprotein E N-terminal', 129, NULL, 'Herpes_gE_N', 255076),
(435983, 'PF06870', NULL, 'A49-like RNA polymerase I associated factor', 375, NULL, 'RNA_pol_I_A49', 255077),
(435984, 'PF11432', NULL, 'Protein of unknown function (DUF3197)', 113, NULL, 'DUF3197', 255078),
(435985, 'PF19142', NULL, 'Family of unknown function (DUF5825)', 179, NULL, 'DUF5825', 255079),
(435986, 'PF12558', NULL, 'ATP-binding cassette cobalt transporter', 73, NULL, 'DUF3744', 255080);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(435987, 'PF14029', NULL, 'Protein of unknown function (DUF4244)', 54, NULL, 'DUF4244', 255081),
(435988, 'PF04822', NULL, 'Takusan', 85, NULL, 'Takusan', 255082),
(435989, 'PF06233', NULL, 'Usg-like family', 80, NULL, 'Usg', 255083),
(435990, 'PF08796', NULL, 'Protein of unknown function (DUF1797)', 67, NULL, 'DUF1797', 255084),
(435991, 'PF02210', NULL, 'Laminin G domain', 126, NULL, 'Laminin_G_2', 255085),
(435992, 'PF04395', NULL, 'Poxvirus B22R protein', 210, NULL, 'Poxvirus_B22R', 255086),
(435993, 'PF00586', NULL, 'AIR synthase related protein, N-terminal domain', 107, NULL, 'AIRS', 255087),
(435994, 'PF02813', NULL, 'Retroviral M domain', 86, NULL, 'Retro_M', 255088),
(435995, 'PF11030', NULL, 'Nucleocapsid protein N', 167, NULL, 'Nucleocapsid-N', 255089),
(435996, 'PF05467', NULL, 'Herpesvirus glycoprotein U47', 677, NULL, 'Herpes_U47', 255090),
(435997, 'PF12000', NULL, 'Glycosyl transferase family 4 group', 169, NULL, 'Glyco_trans_4_3', 255091),
(435998, 'PF01200', NULL, 'Ribosomal protein S28e', 64, NULL, 'Ribosomal_S28e', 255092),
(435999, 'PF07042', NULL, 'TrfA protein', 282, NULL, 'TrfA', 255093),
(436000, 'PF12560', NULL, 'RAG1 importin binding', 286, NULL, 'RAG1_imp_bd', 255094),
(436001, 'PF04954', NULL, 'Siderophore-interacting protein', 119, NULL, 'SIP', 255095),
(436002, 'PF15716', NULL, 'Domain of unknown function (DUF4672)', 197, NULL, 'DUF4672', 255096),
(436003, 'PF16923', NULL, 'Glycosyl hydrolase family 63 N-terminal domain', 227, NULL, 'Glyco_hydro_63N', 255097),
(436004, 'PF11565', NULL, 'Alpha helical Porin B', 99, NULL, 'PorB', 255098),
(436005, 'PF01098', NULL, 'Cell cycle protein', 358, NULL, 'FTSW_RODA_SPOVE', 255099),
(436006, 'PF20386', NULL, 'Family of unknown function (DUF6681)', 268, NULL, 'DUF6681', 255100),
(436007, 'PF04724', NULL, 'Glycosyltransferase family 17', 349, NULL, 'Glyco_transf_17', 255101),
(436008, 'PF14691', NULL, 'Dihydroprymidine dehydrogenase domain II, 4Fe-4S cluster', 112, NULL, 'Fer4_20', 255102),
(436009, 'PF13921', NULL, 'Myb-like DNA-binding domain', 60, NULL, 'Myb_DNA-bind_6', 255103),
(436010, 'PF15569', NULL, 'Immunity protein 40', 93, NULL, 'Imm40', 255104),
(436011, 'PF18563', NULL, 'TubC N-terminal docking domain', 52, NULL, 'TubC_N', 255105),
(436012, 'PF17365', NULL, 'Family of unknown function (DUF5390)', 141, NULL, 'DUF5390', 255106),
(436013, 'PF09863', NULL, 'Uncharacterized protein conserved in bacteria (DUF2090)', 311, NULL, 'DUF2090', 255107),
(436014, 'PF14797', NULL, 'Serine-rich region of AP3B1, clathrin-adaptor complex', 111, NULL, 'SEEEED', 255108),
(436015, 'PF18739', NULL, 'Apea-like HEPN', 106, NULL, 'HEPN_Apea', 255109),
(436016, 'PF06779', NULL, 'Uncharacterised MFS-type transporter YbfB', 365, NULL, 'MFS_4', 255110),
(436017, 'PF11052', NULL, 'Trans-sialidase of Trypanosoma hydrophobic C-terminal', 24, NULL, 'Tr-sialidase_C', 255111),
(436018, 'PF19682', NULL, 'Family of unknown function (DUF6184)', 81, NULL, 'DUF6184', 255112),
(436019, 'PF19630', NULL, 'Domain of unknown function (DUF6134)', 183, NULL, 'DUF6134', 255113),
(436020, 'PF03967', NULL, 'Photosynthetic reaction centre, H-chain N-terminal region', 132, NULL, 'PRCH', 255114),
(436021, 'PF08459', NULL, 'UvrC RNAse H endonuclease domain', 161, NULL, 'UvrC_RNaseH_dom', 255115),
(436022, 'PF07954', NULL, 'Protein of unknown function (DUF1689)', 146, NULL, 'DUF1689', 255116),
(436023, 'PF19842', NULL, 'YqeC protein', 150, NULL, 'YqeC', 255117),
(436024, 'PF06440', NULL, 'DNA polymerase III, theta subunit', 70, NULL, 'DNA_pol3_theta', 255118),
(436025, 'PF01044', NULL, 'Vinculin family', 969, NULL, 'Vinculin', 255119),
(436026, 'PF05542', NULL, 'Protein of unknown function (DUF760)', 84, NULL, 'DUF760', 255120),
(436027, 'PF19355', NULL, 'Family of unknown function (DUF5932)', 111, NULL, 'DUF5932', 255121),
(436028, 'PF10965', NULL, 'Protein of unknown function (DUF2767)', 67, NULL, 'DUF2767', 255122),
(436029, 'PF07636', NULL, 'PSRT', 32, NULL, 'PSRT', 255123),
(436030, 'PF07863', NULL, 'Homologues of TraJ from Bacteroides conjugative transposon', 66, NULL, 'CtnDOT_TraJ', 255124);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(436031, 'PF04431', NULL, 'Pectate lyase, N terminus', 56, NULL, 'Pec_lyase_N', 255125),
(436032, 'PF14565', NULL, 'Interleukin 22 IL-10-related T-cell-derived-inducible factor', 139, NULL, 'IL22', 255126),
(436033, 'PF14721', NULL, 'Apoptosis-inducing factor, mitochondrion-associated, C-term', 130, NULL, 'AIF_C', 255127),
(436034, 'PF17681', NULL, 'Gamma tubulin complex component N-terminal', 304, NULL, 'GCP_N_terminal', 255128),
(436035, 'PF03954', NULL, 'Hepatic lectin, N-terminal domain', 140, NULL, 'Lectin_N', 255129),
(436036, 'PF03837', NULL, 'RecT family', 199, NULL, 'RecT', 255130),
(436037, 'PF07494', NULL, 'Two component regulator propeller', 24, NULL, 'Reg_prop', 255131),
(436038, 'PF00623', NULL, 'RNA polymerase Rpb1, domain 2', 166, NULL, 'RNA_pol_Rpb1_2', 255132),
(436039, 'PF17747', NULL, 'VID27 PH-like domain', 109, NULL, 'VID27_PH', 255133),
(436040, 'PF01636', NULL, 'Phosphotransferase enzyme family', 239, NULL, 'APH', 255134),
(436041, 'PF08700', NULL, 'Vps51/Vps67', 87, NULL, 'Vps51', 255135),
(436042, 'PF16331', NULL, 'TolA binding protein trimerisation', 76, NULL, 'TolA_bind_tri', 255136),
(436043, 'PF17713', NULL, 'Family of unknown function (DUF5558)', 124, NULL, 'DUF5558', 255137),
(436044, 'PF07401', NULL, 'Bovine Lentivirus VIF protein', 198, NULL, 'Lenti_VIF_2', 255138),
(436045, 'PF15398', NULL, 'Domain of unknown function (DUF4619)', 296, NULL, 'DUF4619', 255139),
(436046, 'PF06602', NULL, 'Myotubularin-like phosphatase domain', 357, NULL, 'Myotub-related', 255140),
(436047, 'PF03031', NULL, 'NLI interacting factor-like phosphatase', 156, NULL, 'NIF', 255141),
(436048, 'PF20465', NULL, 'MmeI, helicase spacer domain', 147, NULL, 'MmeI_hel', 255142),
(436049, 'PF10183', NULL, 'ESSS subunit of NADH:ubiquinone oxidoreductase (complex I)', 115, NULL, 'ESSS', 255143),
(436050, 'PF18907', NULL, 'Family of unknown function (DUF5662)', 153, NULL, 'DUF5662', 255144),
(436051, 'PF07030', NULL, 'Bacteriophage Mu, Gp36', 124, NULL, 'Phage_Mu_Gp36', 255145),
(436052, 'PF07163', NULL, 'Pex26 protein', 301, NULL, 'Pex26', 255146),
(436053, 'PF09502', NULL, 'Bacterial type III secretion protein (HrpB4)', 217, NULL, 'HrpB4', 255147),
(436054, 'PF12980', NULL, 'Domain of Unknown Function with PDB structure (DUF3864)', 80, NULL, 'DUF3864', 255148),
(436055, 'PF19477', NULL, 'Family of unknown function (DUF6014)', 389, NULL, 'DUF6014', 255149),
(436056, 'PF20161', NULL, 'VpsR domain', 121, NULL, 'VpsR', 255150),
(436057, 'PF04065', NULL, 'Not1 N-terminal domain, CCR4-Not complex component', 232, NULL, 'Not3', 255151),
(436058, 'PF15541', NULL, 'Bacterial toxin 4', 106, NULL, 'Ntox4', 255152),
(436059, 'PF19601', NULL, 'Family of unknown function (DUF6106)', 173, NULL, 'DUF6106', 255153),
(436060, 'PF01578', NULL, 'Cytochrome C assembly protein', 214, NULL, 'Cytochrom_C_asm', 255154),
(436061, 'PF18713', NULL, 'Domain of unknown function (DUF5645)', 125, NULL, 'DUF5645', 255155),
(436062, 'PF14887', NULL, 'HMG (high mobility group) box 5', 86, NULL, 'HMG_box_5', 255156),
(436063, 'PF11892', NULL, 'Domain of unknown function (DUF3412)', 121, NULL, 'DUF3412', 255157),
(436064, 'PF06925', NULL, 'Monogalactosyldiacylglycerol (MGDG) synthase', 169, NULL, 'MGDG_synth', 255158),
(436065, 'PF09886', NULL, 'Uncharacterized protein conserved in archaea (DUF2113)', 185, NULL, 'DUF2113', 255159),
(436066, 'PF11367', NULL, 'Protein of unknown function (DUF3168)', 117, NULL, 'DUF3168', 255160),
(436067, 'PF13157', NULL, 'Endospore appendages', 111, NULL, 'Enas', 255161),
(436068, 'PF05452', NULL, 'Clavanin', 80, NULL, 'Clavanin', 255162),
(436069, 'PF18746', NULL, 'Alpha-glutamyl/putrescinyl thymine pyrophosphorylase clade 3', 279, NULL, 'aGPT-Pplase3', 255163),
(436070, 'PF20444', NULL, 'Family of unknown function (DUF6703)', 122, NULL, 'DUF6703', 255164),
(436071, 'PF05473', NULL, 'UL45 protein, carbohydrate-binding C-type lectin-like', 200, NULL, 'UL45', 255165),
(436072, 'PF10184', NULL, 'Uncharacterized conserved protein (DUF2358)', 113, NULL, 'DUF2358', 255166),
(436073, 'PF17885', NULL, 'Styrene monooxygenase A putative substrate binding domain', 108, NULL, 'Smoa_sbd', 255167);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(436074, 'PF10904', NULL, 'Protein of unknown function (DUF2694)', 97, NULL, 'DUF2694', 255168),
(436075, 'PF10359', NULL, 'RNA pol II promoter Fmp27 protein domain', 483, NULL, 'Fmp27_WPPW', 255169),
(436076, 'PF13750', NULL, 'Bacterial Ig-like domain (group 3)', 157, NULL, 'Big_3_3', 255170),
(436077, 'PF00508', NULL, 'E2 (early) protein, N terminal', 200, NULL, 'PPV_E2_N', 255171),
(436078, 'PF11379', NULL, 'Protein of unknown function (DUF3182)', 353, NULL, 'DUF3182', 255172),
(436079, 'PF01018', NULL, 'GTP1/OBG', 155, NULL, 'GTP1_OBG', 255173),
(436080, 'PF12770', NULL, 'CHAT domain', 290, NULL, 'CHAT', 255174),
(436081, 'PF11973', NULL, 'NQRA C-terminal domain', 51, NULL, 'NQRA_SLBB', 255175),
(436082, 'PF11905', NULL, 'Domain of unknown function (DUF3425)', 124, NULL, 'DUF3425', 255176),
(436083, 'PF04503', NULL, 'Single-stranded DNA binding protein, SSDP', 291, NULL, 'SSDP', 255177),
(436084, 'PF11335', NULL, 'Protein of unknown function (DUF3137)', 135, NULL, 'DUF3137', 255178),
(436085, 'PF03488', NULL, 'Nematode insulin-related peptide beta type', 48, NULL, 'Ins_beta', 255179),
(436086, 'PF10550', NULL, 'Conantokin toxin', 17, NULL, 'Toxin_36', 255180),
(436087, 'PF12853', NULL, 'C-terminal of NADH-ubiquinone oxidoreductase 21 kDa subunit', 89, NULL, 'NADH_u_ox_C', 255181),
(436088, 'PF05160', NULL, 'DSS1/SEM1 family', 60, NULL, 'DSS1_SEM1', 255182),
(436089, 'PF20535', NULL, 'Family of unknown function (DUF6750)', 129, NULL, 'DUF6750', 255183),
(436090, 'PF14001', NULL, 'YdfZ protein', 64, NULL, 'YdfZ', 255184),
(436091, 'PF12345', NULL, 'Protein of unknown function (DUF3641)', 135, NULL, 'DUF3641', 255185),
(436092, 'PF20447', NULL, 'Family of unknown function (DUF6704)', 68, NULL, 'DUF6704', 255186),
(436093, 'PF02541', NULL, 'Ppx/GppA phosphatase family', 285, NULL, 'Ppx-GppA', 255187),
(436094, 'PF18280', NULL, 'Aminoglycoside adenyltransferase C-terminal domain', 104, NULL, 'AadA_C', 255188),
(436095, 'PF00272', NULL, 'Cecropin family', 30, NULL, 'Cecropin', 255189),
(436096, 'PF12799', NULL, 'Leucine Rich repeats (2 copies)', 43, NULL, 'LRR_4', 255190),
(436097, 'PF12867', NULL, 'DinB superfamily', 128, NULL, 'DinB_2', 255191),
(436098, 'PF17907', NULL, 'AWS domain', 39, NULL, 'AWS', 255192),
(436099, 'PF02236', NULL, 'Viral DNA-binding protein, all alpha domain', 79, NULL, 'Viral_DNA_bi', 255193),
(436100, 'PF09332', NULL, 'Mcm10 replication factor', 349, NULL, 'Mcm10', 255194),
(436101, 'PF10809', NULL, 'Protein of unknown function (DUF2732)', 74, NULL, 'DUF2732', 255195),
(436102, 'PF04375', NULL, 'HemX, putative uroporphyrinogen-III C-methyltransferase', 236, NULL, 'HemX', 255196),
(436103, 'PF04921', NULL, 'XAP5, circadian clock regulator', 254, NULL, 'XAP5', 255197),
(436104, 'PF20334', NULL, 'Family of unknown function (DUF6629)', 209, NULL, 'DUF6629', 255198),
(436105, 'PF04046', NULL, 'PSP', 46, NULL, 'PSP', 255199),
(436106, 'PF13538', NULL, 'UvrD-like helicase C-terminal domain', 52, NULL, 'UvrD_C_2', 255200),
(436107, 'PF19605', NULL, 'Family of unknown function (DUF6110)', 85, NULL, 'DUF6110', 255201),
(436108, 'PF00114', NULL, 'Pilin (bacterial filament)', 109, NULL, 'Pilin', 255202),
(436109, 'PF04544', NULL, 'Herpesvirus egress protein UL20', 179, NULL, 'Herpes_UL20', 255203),
(436110, 'PF07574', NULL, 'Nse1 non-SMC component of SMC5-6 complex', 194, NULL, 'SMC_Nse1', 255204),
(436111, 'PF01541', NULL, 'GIY-YIG catalytic domain', 78, NULL, 'GIY-YIG', 255205),
(436112, 'PF05348', NULL, 'Proteasome maturation factor UMP1', 117, NULL, 'UMP1', 255206),
(436113, 'PF16106', NULL, 'Domain of unknown function (DUF4824)', 252, NULL, 'DUF4824', 255207),
(436114, 'PF01228', NULL, 'Glycine radical', 106, NULL, 'Gly_radical', 255208),
(436115, 'PF18796', NULL, 'Large polyvalent protein-associated domain 1', 78, NULL, 'LPD1', 255209),
(436116, 'PF18033', NULL, 'SpuA C-terminal', 93, NULL, 'SpuA_C', 255210),
(436117, 'PF16251', NULL, 'Betacoronavirus nucleic acid-binding (NAB)', 117, NULL, 'bCoV_NAB', 255211),
(436118, 'PF05347', NULL, 'Complex 1 protein (LYR family)', 59, NULL, 'Complex1_LYR', 255212);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(436119, 'PF12768', NULL, 'Cortical protein marker for cell polarity', 148, NULL, 'Rax2', 255213),
(436120, 'PF14813', NULL, 'NADH dehydrogenase 1 beta subcomplex subunit 2', 69, NULL, 'NADH_B2', 255214),
(436121, 'PF06956', NULL, 'Regulator of RNA terminal phosphate cyclase', 183, NULL, 'RtcR', 255215),
(436122, 'PF05324', NULL, 'Sperm antigen HE2', 70, NULL, 'Sperm_Ag_HE2', 255216),
(436123, 'PF16878', NULL, 'Transcriptional regulator, SIX1, N-terminal SD domain', 115, NULL, 'SIX1_SD', 255217),
(436124, 'PF18160', NULL, 'SMODS and SLOG-associating 2TM effector domain family 5', 193, NULL, 'SLATT_5', 255218),
(436125, 'PF17280', NULL, 'Family of unknown function (DUF5345)', 77, NULL, 'DUF5345', 255219),
(436126, 'PF10272', NULL, 'Putative transmembrane protein precursor', 349, NULL, 'Tmpp129', 255220),
(436127, 'PF09703', NULL, 'CRISPR-associated protein (Cas_Csa4)', 355, NULL, 'Cas_Csa4', 255221),
(436128, 'PF10978', NULL, 'Protein of unknown function (DUF2785)', 174, NULL, 'DUF2785', 255222),
(436129, 'PF11750', NULL, 'Protein of unknown function (DUF3307)', 126, NULL, 'DUF3307', 255223),
(436130, 'PF09440', NULL, 'eIF3 subunit 6 N terminal domain', 133, NULL, 'eIF3_N', 255224),
(436131, 'PF09310', NULL, 'POU domain, class 2, associating factor 1', 249, NULL, 'PD-C2-AF1', 255225),
(436132, 'PF04214', NULL, 'Protein of unknown function, DUF', 69, NULL, 'DUF411', 255226),
(436133, 'PF08354', NULL, 'Domain of unknown function (DUF1729)', 353, NULL, 'DUF1729', 255227),
(436134, 'PF19474', NULL, 'Family of unknown function (DUF6011)', 37, NULL, 'DUF6011', 255228),
(436135, 'PF15289', NULL, 'Regulatory factor X-associated C-terminal binding domain', 122, NULL, 'RFXA_RFXANK_bdg', 255229),
(436136, 'PF01771', NULL, 'Viral alkaline exonuclease', 480, NULL, 'Viral_alk_exo', 255230),
(436137, 'PF06876', NULL, 'Plant self-incompatibility response (SCRL) protein', 67, NULL, 'SCRL', 255231),
(436138, 'PF14398', NULL, 'YheC/D like ATP-grasp', 256, NULL, 'ATPgrasp_YheCD', 255232),
(436139, 'PF04028', NULL, 'Domain of unknown function (DUF374)', 69, NULL, 'DUF374', 255233),
(436140, 'PF18976', NULL, 'Family of unknown function (DUF5712)', 296, NULL, 'DUF5712', 255234),
(436141, 'PF00500', NULL, 'L1 (late) protein', 498, NULL, 'Late_protein_L1', 255235),
(436142, 'PF01905', NULL, 'CRISPR-associated negative auto-regulator DevR/Csa2', 269, NULL, 'DevR', 255236),
(436143, 'PF19822', NULL, 'Family of unknown function (DUF6304)', 157, NULL, 'DUF6304', 255237),
(436144, 'PF02194', NULL, 'PXA domain', 182, NULL, 'PXA', 255238),
(436145, 'PF10277', NULL, 'Frag1/DRAM/Sfk1 family', 219, NULL, 'Frag1', 255239),
(436146, 'PF14846', NULL, 'Domain of unknown function (DUF4485)', 84, NULL, 'DUF4485', 255240),
(436147, 'PF06115', NULL, 'Domain of unknown function (DUF956)', 117, NULL, 'DUF956', 255241),
(436148, 'PF10529', NULL, 'Histidine-rich Calcium-binding repeat region', 15, NULL, 'Hist_rich_Ca-bd', 255242),
(436149, 'PF18929', NULL, 'Family of unknown function (DUF5678)', 50, NULL, 'DUF5678', 255243),
(436150, 'PF04525', NULL, 'LURP-one-related', 187, NULL, 'LOR', 255244),
(436151, 'PF19669', NULL, 'Family of unknown function (DUF6172)', 95, NULL, 'DUF6172', 255245),
(436152, 'PF14345', NULL, 'GDYXXLXY protein', 143, NULL, 'GDYXXLXY', 255246),
(436153, 'PF00608', NULL, 'Adenoviral fibre protein (repeat/shaft region)', 44, NULL, 'Adeno_shaft', 255247),
(436154, 'PF09617', NULL, 'CRISPR-associated protein GSU0053 (Cas_GSU0053)', 172, NULL, 'Cas_GSU0053', 255248),
(436155, 'PF12317', NULL, 'Intraflagellar transport complex B protein 46 C terminal', 212, NULL, 'IFT46_B_C', 255249),
(436156, 'PF20242', NULL, 'Emfourin', 89, NULL, 'Emfourin', 255250),
(436157, 'PF04765', NULL, 'Protein of unknown function (DUF616)', 314, NULL, 'DUF616', 255251),
(436158, 'PF00172', NULL, 'Fungal Zn(2)-Cys(6) binuclear cluster domain', 40, NULL, 'Zn_clus', 255252),
(436159, 'PF20042', NULL, 'Family of unknown function (DUF6444)', 76, NULL, 'DUF6444', 255253),
(436160, 'PF12343', NULL, 'DeaD helicase C-terminal disordered region', 61, NULL, 'DeaD_C', 255254);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(436161, 'PF17702', NULL, 'Family of unknown function (DUF5548)', 177, NULL, 'DUF5548', 255255),
(436162, 'PF01798', NULL, 'snoRNA binding domain, fibrillarin', 232, NULL, 'Nop', 255256),
(436163, 'PF01251', NULL, 'Ribosomal protein S7e', 182, NULL, 'Ribosomal_S7e', 255257),
(436164, 'PF13373', NULL, 'DSC E3 ubiquitin ligase complex subunit 3, C-terminal domain', 141, NULL, 'Dsc3_C', 255258),
(436165, 'PF13484', NULL, '4Fe-4S double cluster binding domain', 67, NULL, 'Fer4_16', 255259),
(436166, 'PF19073', NULL, 'Family of unknown function (DUF5769)', 191, NULL, 'DUF5769', 255260),
(436167, 'PF08286', NULL, 'Spc24 subunit of Ndc80', 107, NULL, 'Spc24', 255261),
(436168, 'PF12496', NULL, 'Bcl2-/adenovirus E1B nineteen kDa-interacting protein 2', 138, NULL, 'BNIP2', 255262),
(436169, 'PF11426', NULL, 'Tn7 transposition regulator TnsC', 47, NULL, 'Tn7_TnsC_Int', 255263),
(436170, 'PF13741', NULL, 'Mitochondrial ribosomal protein S25', 230, NULL, 'MRP-S25', 255264),
(436171, 'PF08929', NULL, 'Domain of unknown function (DUF1911)', 107, NULL, 'DUF1911', 255265),
(436172, 'PF15629', NULL, 'Permuted single zf-CXXC unit', 32, NULL, 'Perm-CXXC', 255266),
(436173, 'PF08679', NULL, 'Dissimilatory sulfite reductase D (DsrD)', 65, NULL, 'DsrD', 255267),
(436174, 'PF19870', NULL, 'Family of unknown function (DUF6343)', 82, NULL, 'DUF6343', 255268),
(436175, 'PF07966', NULL, 'A1 Propeptide', 27, NULL, 'A1_Propeptide', 255269),
(436176, 'PF15376', NULL, 'Domain of unknown function (DUF4603)', 1297, NULL, 'DUF4603', 255270),
(436177, 'PF19846', NULL, 'Domain of unknown function (DUF6321)', 72, NULL, 'DUF6321', 255271),
(436178, 'PF07796', NULL, 'Protein of unknown function (DUF1638)', 165, NULL, 'DUF1638', 255272),
(436179, 'PF13277', NULL, 'YmdB-like protein', 253, NULL, 'YmdB', 255273),
(436180, 'PF17955', NULL, 'Cas6b N-terminal domain', 105, NULL, 'Cas6b_N', 255274),
(436181, 'PF09340', NULL, 'Histone acetyltransferase subunit NuA4', 79, NULL, 'NuA4', 255275),
(436182, 'PF14911', NULL, 'S-phase genomic integrity recombination mediator, C-terminal', 376, NULL, 'MMS22L_C', 255276),
(436183, 'PF18494', NULL, 'Pullulanase Ins domain', 74, NULL, 'Pullulanase_Ins', 255277),
(436184, 'PF19327', NULL, 'Ap4A phosphorylase N-terminal domain', 179, NULL, 'Ap4A_phos_N', 255278),
(436185, 'PF08977', NULL, 'Bypass of Forespore C, N terminal', 51, NULL, 'BOFC_N', 255279),
(436186, 'PF17015', NULL, 'Domain of unknown function (DUF5094)', 178, NULL, 'DUF5094', 255280),
(436187, 'PF05715', NULL, 'Piccolo Zn-finger', 60, NULL, 'zf-piccolo', 255281),
(436188, 'PF00624', NULL, 'Flocculin repeat', 41, NULL, 'Flocculin', 255282),
(436189, 'PF06052', NULL, '3-hydroxyanthranilic acid dioxygenase', 151, NULL, '3-HAO', 255283),
(436190, 'PF06746', NULL, 'Protein of unknown function (DUF1216)', 134, NULL, 'DUF1216', 255284),
(436191, 'PF16910', NULL, 'Repeating coiled region of VPS13', 236, NULL, 'VPS13_mid_rpt', 255285),
(436192, 'PF09101', NULL, 'Exotoxin A binding', 262, NULL, 'Exotox-A_bind', 255286),
(436193, 'PF13645', NULL, 'L,D-transpeptidase catalytic domain', 169, NULL, 'YkuD_2', 255287),
(436194, 'PF12946', NULL, 'MSP1 EGF domain 1', 37, NULL, 'EGF_MSP1_1', 255288),
(436195, 'PF12904', NULL, 'Putative collagen-binding domain of a collagenase', 92, NULL, 'Collagen_bind_2', 255289),
(436196, 'PF05277', NULL, 'Protein of unknown function (DUF726)', 343, NULL, 'DUF726', 255290),
(436197, 'PF00022', NULL, 'Actin', 385, NULL, 'Actin', 255291),
(436198, 'PF10592', NULL, 'AIPR protein', 294, NULL, 'AIPR', 255292),
(436199, 'PF19295', NULL, 'SufBD protein N-terminal region', 172, NULL, 'SufBD_N', 255293),
(436200, 'PF20187', NULL, 'Family of unknown function (DUF6550)', 190, NULL, 'DUF6550', 255294),
(436201, 'PF01222', NULL, 'Ergosterol biosynthesis ERG4/ERG24 family', 432, NULL, 'ERG4_ERG24', 255295),
(436202, 'PF08680', NULL, 'TATA-box binding', 204, NULL, 'DUF1779', 255296),
(436203, 'PF10920', NULL, 'Protein of unknown function (DUF2705)', 226, NULL, 'DUF2705', 255297),
(436204, 'PF13054', NULL, 'Protein of unknown function (DUF3915)', 123, NULL, 'DUF3915', 255298);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(436205, 'PF01293', NULL, 'Phosphoenolpyruvate carboxykinase', 465, NULL, 'PEPCK_ATP', 255299),
(436206, 'PF11517', NULL, 'Nuclear abundant poly(A) RNA-bind protein 2 (Nab2)', 101, NULL, 'Nab2', 255300),
(436207, 'PF11133', NULL, 'Head fiber protein', 277, NULL, 'Phage_head_fibr', 255301),
(436208, 'PF09287', NULL, 'CEP-1, DNA binding', 196, NULL, 'CEP1-DNA_bind', 255302),
(436209, 'PF06296', NULL, 'RelE toxin of RelE / RelB toxin-antitoxin system', 120, NULL, 'RelE', 255303),
(436210, 'PF00812', NULL, 'Ephrin', 143, NULL, 'Ephrin', 255304),
(436211, 'PF02902', NULL, 'Ulp1 protease family, C-terminal catalytic domain', 216, NULL, 'Peptidase_C48', 255305),
(436212, 'PF16516', NULL, 'Leucine zipper of domain CC2 of NEMO, NF-kappa-B essential modulator', 100, NULL, 'CC2-LZ', 255306),
(436213, 'PF15996', NULL, 'Arginine/serine-rich protein PNISR', 182, NULL, 'PNISR', 255307),
(436214, 'PF07242', NULL, 'Protein of unknown function (DUF1430)', 100, NULL, 'DUF1430', 255308),
(436215, 'PF15096', NULL, 'G6B family', 224, NULL, 'G6B', 255309),
(436216, 'PF16114', NULL, 'ATP citrate lyase citrate-binding', 177, NULL, 'Citrate_bind', 255310),
(436217, 'PF17051', NULL, 'Cytochrome C oxidase assembly factor 2', 86, NULL, 'COA2', 255311),
(436218, 'PF08696', NULL, 'DNA replication factor Dna2', 203, NULL, 'Dna2', 255312),
(436219, 'PF17893', NULL, 'CRISPR-associated endonuclease Cas9 beta-hairpin domain', 90, NULL, 'Cas9_b_hairpin', 255313),
(436220, 'PF12825', NULL, 'Domain of unknown function in PX-proteins (DUF3818)', 338, NULL, 'DUF3818', 255314),
(436221, 'PF08376', NULL, 'Nitrate and nitrite sensing', 225, NULL, 'NIT', 255315),
(436222, 'PF04796', NULL, 'Plasmid encoded RepA protein', 161, NULL, 'RepA_C', 255316),
(436223, 'PF09882', NULL, 'Predicted membrane protein (DUF2109)', 76, NULL, 'DUF2109', 255317),
(436224, 'PF15818', NULL, 'Coiled-coil domain-containing protein 73 family', 1050, NULL, 'CCDC73', 255318),
(436225, 'PF14144', NULL, 'Seed dormancy control', 77, NULL, 'DOG1', 255319),
(436226, 'PF05881', NULL, '2'',3''-cyclic nucleotide 3''-phosphodiesterase (CNP or CNPase)', 236, NULL, 'CNPase', 255320),
(436227, 'PF11283', NULL, 'Protein of unknown function (DUF3084)', 77, NULL, 'DUF3084', 255321),
(436228, 'PF12261', NULL, 'Thermostable hemolysin', 174, NULL, 'T_hemolysin', 255322),
(436229, 'PF13393', NULL, 'Histidyl-tRNA synthetase', 309, NULL, 'tRNA-synt_His', 255323),
(436230, 'PF05625', NULL, 'PAXNEB protein', 371, NULL, 'PAXNEB', 255324),
(436231, 'PF18788', NULL, 'Defence against restriction A N-terminal', 122, NULL, 'DarA_N', 255325),
(436232, 'PF07848', NULL, 'PaaX-like protein', 70, NULL, 'PaaX', 255326),
(436233, 'PF00406', NULL, 'Adenylate kinase', 151, NULL, 'ADK', 255327),
(436234, 'PF03147', NULL, 'Ferredoxin-fold anticodon binding domain', 94, NULL, 'FDX-ACB', 255328),
(436235, 'PF17914', NULL, 'HopA1 effector protein family', 170, NULL, 'HopA1', 255329),
(436236, 'PF14156', NULL, 'Antirepressor AbbA', 63, NULL, 'AbbA_antirepres', 255330),
(436237, 'PF08752', NULL, 'Coatomer gamma subunit appendage platform subdomain', 152, NULL, 'COP-gamma_platf', 255331),
(436238, 'PF14003', NULL, 'YlbE-like protein', 61, NULL, 'YlbE', 255332),
(436239, 'PF02568', NULL, 'Thiamine biosynthesis protein (ThiI)', 197, NULL, 'ThiI', 255333),
(436240, 'PF12437', NULL, 'Glutamine synthetase type III N terminal', 163, NULL, 'GSIII_N', 255334),
(436241, 'PF03244', NULL, 'Photosystem I reaction centre subunit VI', 139, NULL, 'PSI_PsaH', 255335),
(436242, 'PF05957', NULL, 'DUF883 N-terminal domain', 53, NULL, 'DUF883', 255336),
(436243, 'PF07786', NULL, 'Heparan-alpha-glucosaminide N-acetyltransferase, catalytic', 223, NULL, 'HGSNAT_cat', 255337),
(436244, 'PF11857', NULL, 'Domain of unknown function (DUF3377)', 72, NULL, 'DUF3377', 255338),
(436245, 'PF01523', NULL, 'PmbA/TldA metallopeptidase domain 1', 66, NULL, 'PmbA_TldD', 255339),
(436246, 'PF00282', NULL, 'Pyridoxal-dependent decarboxylase conserved domain', 375, NULL, 'Pyridoxal_deC', 255340),
(436247, 'PF09779', NULL, 'Ima1 N-terminal domain', 138, NULL, 'Ima1_N', 255341);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(436248, 'PF10747', NULL, 'Sporulation inhibitor of replication protein SirA', 140, NULL, 'SirA', 255342),
(436249, 'PF04776', NULL, 'Protein MS5', 120, NULL, 'protein_MS5', 255343),
(436250, 'PF19136', NULL, 'Family of unknown function (DUF5819)', 171, NULL, 'DUF5819', 255344),
(436251, 'PF04240', NULL, 'Carotenoid biosynthesis protein', 209, NULL, 'Caroten_synth', 255345),
(436252, 'PF06773', NULL, 'Bim protein N-terminus', 40, NULL, 'Bim_N', 255346),
(436253, 'PF09257', NULL, 'BCMA, TALL-1 binding', 37, NULL, 'BCMA-Tall_bind', 255347),
(436254, 'PF13280', NULL, 'WYL domain', 172, NULL, 'WYL', 255348),
(436255, 'PF07654', NULL, 'Immunoglobulin C1-set domain', 86, NULL, 'C1-set', 255349),
(436256, 'PF02114', NULL, 'Phosducin', 265, NULL, 'Phosducin', 255350),
(436257, 'PF14922', NULL, 'Protein of unknown function', 150, NULL, 'FWWh', 255351),
(436258, 'PF02420', NULL, 'Insect antifreeze protein repeat', 12, NULL, 'AFP', 255352),
(436259, 'PF16875', NULL, 'Glycosyl hydrolase family 36 N-terminal domain', 252, NULL, 'Glyco_hydro_36N', 255353),
(436260, 'PF13589', NULL, 'Histidine kinase-, DNA gyrase B-, and HSP90-like ATPase', 137, NULL, 'HATPase_c_3', 255354),
(436261, 'PF20531', NULL, 'Family of unknown function (DUF6746)', 124, NULL, 'DUF6746', 255355),
(436262, 'PF05071', NULL, 'NADH ubiquinone oxidoreductase subunit NDUFA12', 101, NULL, 'NDUFA12', 255356),
(436263, 'PF07263', NULL, 'Dentin matrix protein 1 (DMP1)', 520, NULL, 'DMP1', 255357),
(436264, 'PF02954', NULL, 'Bacterial regulatory protein, Fis family', 42, NULL, 'HTH_8', 255358),
(436265, 'PF08767', NULL, 'CRM1 C terminal', 321, NULL, 'CRM1_C', 255359),
(436266, 'PF03609', NULL, 'PTS system sorbose-specific iic component', 233, NULL, 'EII-Sor', 255360),
(436267, 'PF15550', NULL, 'Draxin', 324, NULL, 'Draxin', 255361),
(436268, 'PF18164', NULL, 'GNAT-like C-terminal domain', 153, NULL, 'GNAT_C', 255362),
(436269, 'PF20286', NULL, 'Divergent Family B DNA polymerase', 705, NULL, 'divDNApol', 255363),
(436270, 'PF13146', NULL, 'TRL-like protein family', 77, NULL, 'TRL', 255364),
(436271, 'PF12022', NULL, 'COG complex component, COG2, C-terminal', 130, NULL, 'COG2_C', 255365),
(436272, 'PF19598', NULL, 'Family of unknown function (DUF6103)', 89, NULL, 'DUF6103', 255366),
(436273, 'PF16054', NULL, 'Transmembrane protein family 72', 153, NULL, 'TMEM72', 255367),
(436274, 'PF13774', NULL, 'Regulated-SNARE-like domain', 84, NULL, 'Longin', 255368),
(436275, 'PF18899', NULL, 'Domain of unknown function (DUF5655)', 109, NULL, 'DUF5655', 255369),
(436276, 'PF06850', NULL, 'PHB de-polymerase C-terminus', 203, NULL, 'PHB_depo_C', 255370),
(436277, 'PF09346', NULL, 'SMI1 / KNR4 family (SUKH-1)', 133, NULL, 'SMI1_KNR4', 255371),
(436278, 'PF08003', NULL, 'Protein of unknown function (DUF1698)', 315, NULL, 'Methyltransf_9', 255372),
(436279, 'PF15519', NULL, 'linker between RRM2 and RRM3 domains in RBM39 protein', 86, NULL, 'RBM39linker', 255373),
(436280, 'PF02719', NULL, 'Polysaccharide biosynthesis protein', 294, NULL, 'Polysacc_synt_2', 255374),
(436281, 'PF16611', NULL, 'Unstructured region between RBD and GoLoco', 72, NULL, 'RGS12_us2', 255375),
(436282, 'PF03307', NULL, 'Adenovirus 15.3kD protein in E3 region', 117, NULL, 'Adeno_E3_15_3', 255376),
(436283, 'PF00727', NULL, 'Interleukin 4', 116, NULL, 'IL4', 255377),
(436284, 'PF12574', NULL, '120 KDa Rickettsia surface antigen', 238, NULL, '120_Rick_ant', 255378),
(436285, 'PF19835', NULL, 'Putative endonuclease segE, GIY-YIG domain', 119, NULL, 'SegE_GIY-YIG', 255379),
(436286, 'PF18648', NULL, 'Tse2 ADP-ribosyltransferase toxins', 155, NULL, 'ADPRTs_Tse2', 255380),
(436287, 'PF19824', NULL, 'Small, acid-soluble spore protein Tlp', 70, NULL, 'Tlp', 255381),
(436288, 'PF20076', NULL, 'Domain of unknown function (DUF6472)', 57, NULL, 'DUF6472', 255382),
(436289, 'PF05456', NULL, 'Eukaryotic translation initiation factor 4E binding protein (EIF4EBP)', 117, NULL, 'eIF_4EBP', 255383),
(436290, 'PF04411', NULL, 'PD-(D/E)XK nuclease superfamily', 164, NULL, 'PDDEXK_7', 255384),
(436291, 'PF02984', NULL, 'Cyclin, C-terminal domain', 119, NULL, 'Cyclin_C', 255385);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(436292, 'PF11035', NULL, 'Small nuclear RNA activating complex (SNAPc), subunit 2', 371, NULL, 'SNAPC2', 255386),
(436293, 'PF06398', NULL, 'Integral peroxisomal membrane peroxin', 366, NULL, 'Pex24p', 255387),
(436294, 'PF19330', NULL, 'Delta and Notch-like EGF-related receptor C-terminus', 112, NULL, 'DNER_C', 255388),
(436295, 'PF19876', NULL, 'Family of unknown function (DUF6349)', 186, NULL, 'DUF6349', 255389),
(436296, 'PF03822', NULL, 'NAF domain', 54, NULL, 'NAF', 255390),
(436297, 'PF09778', NULL, 'Guanylylate cyclase', 212, NULL, 'Guanylate_cyc_2', 255391),
(436298, 'PF15110', NULL, 'TMEM141 protein family', 91, NULL, 'TMEM141', 255392),
(436299, 'PF11875', NULL, 'DnaJ-like protein C11, C-terminal', 153, NULL, 'DnaJ-like_C11_C', 255393),
(436300, 'PF00134', NULL, 'Cyclin, N-terminal domain', 127, NULL, 'Cyclin_N', 255394),
(436301, 'PF01547', NULL, 'Bacterial extracellular solute-binding protein', 315, NULL, 'SBP_bac_1', 255395),
(436302, 'PF03185', NULL, 'Calcium-activated potassium channel, beta subunit', 195, NULL, 'CaKB', 255396),
(436303, 'PF17405', NULL, 'Nrap protein nucleotidyltransferase domain 4', 206, NULL, 'Nrap_D4', 255397),
(436304, 'PF18465', NULL, 'Rieske 3Fe-4S', 96, NULL, 'Rieske_3', 255398),
(436305, 'PF05588', NULL, 'Clostridium botulinum HA-17 domain', 146, NULL, 'Botulinum_HA-17', 255399),
(436306, 'PF13534', NULL, '4Fe-4S dicluster domain', 61, NULL, 'Fer4_17', 255400),
(436307, 'PF05556', NULL, 'Calcineurin-binding protein (Calsarcin)', 255, NULL, 'Calsarcin', 255401),
(436308, 'PF09889', NULL, 'Uncharacterized protein containing a Zn-ribbon (DUF2116)', 59, NULL, 'DUF2116', 255402),
(436309, 'PF19133', NULL, 'Family of unknown function (DUF5816)', 72, NULL, 'DUF5816', 255403),
(436310, 'PF19665', NULL, 'Family of unknown function (DUF6168)', 128, NULL, 'DUF6168', 255404),
(436311, 'PF01924', NULL, 'Hydrogenase formation hypA family', 351, NULL, 'HypD', 255405),
(436312, 'PF17706', NULL, 'Family of unknown function (DUF5552)', 217, NULL, 'DUF5552', 255406),
(436313, 'PF14590', NULL, 'Domain of unknown function (DUF4447)', 166, NULL, 'DUF4447', 255407),
(436314, 'PF10783', NULL, 'Protein of unknown function (DUF2599)', 94, NULL, 'DUF2599', 255408),
(436315, 'PF02006', NULL, 'Phosphopantothenate/pantothenate synthetase', 176, NULL, 'PPS_PS', 255409),
(436316, 'PF19519', NULL, 'Family of unknown function (DUF6051)', 406, NULL, 'DUF6051', 255410),
(436317, 'PF18707', NULL, 'Interleukin-2 receptor subunit beta N-terminal domain 1', 92, NULL, 'IL2RB_N1', 255411),
(436318, 'PF09140', NULL, 'ATPase MipZ', 262, NULL, 'MipZ', 255412),
(436319, 'PF16531', NULL, 'Centriolar protein SAS N-terminal', 97, NULL, 'SAS-6_N', 255413),
(436320, 'PF17581', NULL, 'Family of unknown function (DUF5483)', 441, NULL, 'DUF5483', 255414),
(436321, 'PF08005', NULL, 'PHR domain', 152, NULL, 'PHR', 255415),
(436322, 'PF06814', NULL, 'Lung seven transmembrane receptor', 295, NULL, 'Lung_7-TM_R', 255416),
(436323, 'PF08819', NULL, 'Domain of unknown function (DUF1802)', 175, NULL, 'DUF1802', 255417),
(436324, 'PF01842', NULL, 'ACT domain', 66, NULL, 'ACT', 255418),
(436325, 'PF02602', NULL, 'Uroporphyrinogen-III synthase HemD', 232, NULL, 'HEM4', 255419),
(436326, 'PF03135', NULL, 'CagE, TrbE, VirB family, component of type IV transporter system', 206, NULL, 'CagE_TrbE_VirB', 255420),
(436327, 'PF11332', NULL, 'Protein of unknown function (DUF3134)', 70, NULL, 'DUF3134', 255421),
(436328, 'PF10574', NULL, 'Arp2/3-interacting proteins Arpin', 224, NULL, 'UPF0552', 255422),
(436329, 'PF12731', NULL, 'Mating-type protein beta 1', 95, NULL, 'Mating_N', 255423),
(436330, 'PF01391', NULL, 'Collagen triple helix repeat (20 copies)', 60, NULL, 'Collagen', 255424),
(436331, 'PF10707', NULL, 'PhoP regulatory network protein YrbL', 185, NULL, 'YrbL-PhoP_reg', 255425),
(436332, 'PF00016', NULL, 'Ribulose bisphosphate carboxylase large chain, catalytic domain', 299, NULL, 'RuBisCO_large', 255426),
(436333, 'PF03079', NULL, 'ARD/ARD'' family', 157, NULL, 'ARD', 255427),
(436334, 'PF20470', NULL, 'Helix-turn-helix domain', 93, NULL, 'HTH_61', 255428);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(436335, 'PF18871', NULL, 'HEPN/Toprim N-terminal domain 1', 223, NULL, 'HEPN_Toprim_N', 255429),
(436336, 'PF00712', NULL, 'DNA polymerase III beta subunit, N-terminal domain', 121, NULL, 'DNA_pol3_beta', 255430),
(436337, 'PF14819', NULL, 'Nitrile reductase, 7-cyano-7-deazaguanine-reductase N-term', 111, NULL, 'QueF_N', 255431),
(436338, 'PF07573', NULL, 'Nitrogen regulatory protein AreA N terminus', 94, NULL, 'AreA_N', 255432),
(436339, 'PF13395', NULL, 'HNH endonuclease', 55, NULL, 'HNH_4', 255433),
(436340, 'PF15294', NULL, 'Leucine zipper', 276, NULL, 'Leu_zip', 255434),
(436341, 'PF01374', NULL, 'Glycosyl hydrolase family 46', 210, NULL, 'Glyco_hydro_46', 255435),
(436342, 'PF11152', NULL, 'Cofactor assembly of complex C subunit B, CCB2/CCB4', 195, NULL, 'CCB2_CCB4', 255436),
(436343, 'PF02746', NULL, 'Mandelate racemase / muconate lactonizing enzyme, N-terminal domain', 117, NULL, 'MR_MLE_N', 255437),
(436344, 'PF18990', NULL, 'Family of unknown function (DUF5723)', 376, NULL, 'DUF5723', 255438),
(436345, 'PF14564', NULL, 'Membrane binding', 110, NULL, 'Membrane_bind', 255439),
(436346, 'PF09017', NULL, 'Microbial transglutaminase', 414, NULL, 'Transglut_prok', 255440),
(436347, 'PF16412', NULL, 'Domain of unknown function (DUF5020)', 212, NULL, 'DUF5020', 255441),
(436348, 'PF03167', NULL, 'Uracil DNA glycosylase superfamily', 155, NULL, 'UDG', 255442),
(436349, 'PF10476', NULL, 'Protein of unknown function C-terminus (DUF2448)', 205, NULL, 'DUF2448', 255443),
(436350, 'PF13511', NULL, 'Domain of unknown function (DUF4124)', 56, NULL, 'DUF4124', 255444),
(436351, 'PF20245', NULL, 'Family of unknown function (DUF6600)', 102, NULL, 'DUF6600', 255445),
(436352, 'PF06221', NULL, 'Putative zinc finger motif, C2HC5-type', 54, NULL, 'zf-C2HC5', 255446),
(436353, 'PF14569', NULL, 'Zinc-binding RING-finger', 78, NULL, 'zf-UDP', 255447),
(436354, 'PF01600', NULL, 'Coronavirus spike glycoprotein S1', 413, NULL, 'CoV_S1', 255448),
(436355, 'PF17723', NULL, 'Ribbon-Helix-Helix transcriptional regulator family', 119, NULL, 'RHH_8', 255449),
(436356, 'PF07336', NULL, 'Putative stress-induced transcription regulator', 128, NULL, 'ABATE', 255450),
(436357, 'PF01259', NULL, 'SAICAR synthetase', 252, NULL, 'SAICAR_synt', 255451),
(436358, 'PF02349', NULL, 'Major surface glycoprotein', 75, NULL, 'MSG', 255452),
(436359, 'PF17998', NULL, 'Cell surface antigen I/II C2 terminal domain', 167, NULL, 'AgI_II_C2', 255453),
(436360, 'PF17922', NULL, 'Tetracyclin repressor-like, C-terminal domain', 100, NULL, 'TetR_C_17', 255454),
(436361, 'PF08846', NULL, 'Domain of unknown function (DUF1816)', 65, NULL, 'DUF1816', 255455),
(436362, 'PF10161', NULL, 'Putative mitochondrial precursor protein', 76, NULL, 'DDDD', 255456),
(436363, 'PF20032', NULL, 'ADYC domain', 180, NULL, 'ADYC', 255457),
(436364, 'PF07866', NULL, 'Protein of unknown function (DUF1653)', 62, NULL, 'DUF1653', 255458),
(436365, 'PF07078', NULL, 'Forty-two-three protein', 310, NULL, 'FYTT', 255459),
(436366, 'PF06748', NULL, 'Protein of unknown function (DUF1217)', 149, NULL, 'DUF1217', 255460),
(436367, 'PF10108', NULL, 'Predicted 3''-5'' exonuclease related to the exonuclease domain of PolB', 211, NULL, 'DNA_pol_B_exo2', 255461),
(436368, 'PF11083', NULL, 'Lantibiotic streptin immunity protein', 93, NULL, 'Streptin-Immun', 255462),
(436369, 'PF00159', NULL, 'Pancreatic hormone peptide', 36, NULL, 'Hormone_3', 255463),
(436370, 'PF12176', NULL, 'Methanol-cobalamin methyltransferase B subunit', 459, NULL, 'MtaB', 255464),
(436371, 'PF20368', NULL, 'Family of unknown function (DUF6663)', 243, NULL, 'DUF6663', 255465),
(436372, 'PF07380', NULL, 'Pneumovirus M2 protein', 89, NULL, 'Pneumo_M2', 255466),
(436373, 'PF20406', NULL, 'Kinase suppressor RAS 1 N-terminal helical hairpin', 54, NULL, 'SAM_KSR1_N', 255467),
(436374, 'PF01327', NULL, 'Polypeptide deformylase', 159, NULL, 'Pep_deformylase', 255468),
(436375, 'PF09681', NULL, 'N-terminal phage replisome organiser (Phage_rep_org_N)', 121, NULL, 'Phage_rep_org_N', 255469),
(436376, 'PF09845', NULL, 'Zn-ribbon containing protein', 134, NULL, 'DUF2072', 255470);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(436377, 'PF17687', NULL, 'Family of unknown function (DUF5535)', 105, NULL, 'DUF5535', 255471),
(436378, 'PF14412', NULL, 'A nuclease family of the HNH/ENDO VII superfamily with conserved AHH', 112, NULL, 'AHH', 255472),
(436379, 'PF10462', NULL, 'Peptidase M66', 306, NULL, 'Peptidase_M66', 255473),
(436380, 'PF07224', NULL, 'Chlorophyllase', 307, NULL, 'Chlorophyllase', 255474),
(436381, 'PF00523', NULL, 'Fusion glycoprotein F0', 487, NULL, 'Fusion_gly', 255475),
(436382, 'PF18740', NULL, 'EC042_2821-lke REase', 188, NULL, 'EC042_2821', 255476),
(436383, 'PF09084', NULL, 'NMT1/THI5 like', 216, NULL, 'NMT1', 255477),
(436384, 'PF11155', NULL, 'Domain of unknown function (DUF2935)', 121, NULL, 'DUF2935', 255478),
(436385, 'PF03176', NULL, 'MMPL family', 333, NULL, 'MMPL', 255479),
(436386, 'PF04221', NULL, 'RelB antitoxin', 83, NULL, 'RelB', 255480),
(436387, 'PF09689', NULL, 'Plasmodium yoelii repeat (PY_rept_46)', 51, NULL, 'PY_rept_46', 255481),
(436388, 'PF13068', NULL, 'Protein of unknown function (DUF3932)', 81, NULL, 'DUF3932', 255482),
(436389, 'PF03920', NULL, 'Groucho/TLE N-terminal Q-rich domain', 117, NULL, 'TLE_N', 255483),
(436390, 'PF06306', NULL, 'Beta-1,4-N-acetylgalactosaminyltransferase (CgtA)', 347, NULL, 'CgtA', 255484),
(436391, 'PF12568', NULL, 'Acetyltransferase (GNAT) domain, PanZ', 128, NULL, 'PanZ', 255485),
(436392, 'PF13585', NULL, 'CHU_C Type IX secretion signal domain', 86, NULL, 'CHU_C', 255486),
(436393, 'PF20377', NULL, 'Family of unknown function (DUF6672)', 153, NULL, 'DUF6672', 255487),
(436394, 'PF01781', NULL, 'Ribosomal L38e protein family', 69, NULL, 'Ribosomal_L38e', 255488),
(436395, 'PF07615', NULL, 'YKOF-related Family', 81, NULL, 'Ykof', 255489),
(436396, 'PF14517', NULL, 'Tachylectin', 234, NULL, 'Tachylectin', 255490),
(436397, 'PF01968', NULL, 'Hydantoinase/oxoprolinase', 291, NULL, 'Hydantoinase_A', 255491),
(436398, 'PF03442', NULL, 'Carbohydrate binding domain X2', 83, NULL, 'CBM_X2', 255492),
(436399, 'PF03352', NULL, 'Methyladenine glycosylase', 177, NULL, 'Adenine_glyco', 255493),
(436400, 'PF10866', NULL, 'Protein of unknown function (DUF2704)', 167, NULL, 'DUF2704', 255494),
(436401, 'PF15142', NULL, 'INCA1', 178, NULL, 'INCA1', 255495),
(436402, 'PF19198', NULL, 'RsaA N-terminal domain', 180, NULL, 'RsaA_NTD', 255496),
(436403, 'PF00444', NULL, 'Ribosomal protein L36', 38, NULL, 'Ribosomal_L36', 255497),
(436404, 'PF07370', NULL, 'Protein of unknown function (DUF1489)', 139, NULL, 'DUF1489', 255498),
(436405, 'PF10467', NULL, 'Peptidase inhibitor clitocypin', 142, NULL, 'Inhibitor_I48', 255499),
(436406, 'PF12465', NULL, 'Proteasome beta subunits C terminal', 36, NULL, 'Pr_beta_C', 255500),
(436407, 'PF10111', NULL, 'Glycosyltransferase like family 2', 276, NULL, 'Glyco_tranf_2_2', 255501),
(436408, 'PF17333', NULL, 'Beta defensin 136', 51, NULL, 'DEFB136', 255502),
(436409, 'PF00123', NULL, 'Peptide hormone', 28, NULL, 'Hormone_2', 255503),
(436410, 'PF18409', NULL, 'Polo-like Kinase 4 Polo Box 2', 109, NULL, 'Plk4_PB2', 255504),
(436411, 'PF08901', NULL, 'Protein of unknown function (DUF1847)', 157, NULL, 'DUF1847', 255505),
(436412, 'PF00102', NULL, 'Protein-tyrosine phosphatase', 235, NULL, 'Y_phosphatase', 255506),
(436413, 'PF01067', NULL, 'Calpain large subunit, domain III', 138, NULL, 'Calpain_III', 255507),
(436414, 'PF15503', NULL, 'Protein phosphatase 1 regulatory subunit 35 C-terminus', 140, NULL, 'PPP1R35_C', 255508),
(436415, 'PF10163', NULL, 'Transcription factor e(y)2', 84, NULL, 'EnY2', 255509),
(436416, 'PF13102', NULL, 'Phage integrase SAM-like domain', 99, NULL, 'Phage_int_SAM_5', 255510),
(436417, 'PF14122', NULL, 'YokU-like protein, putative antitoxin', 87, NULL, 'YokU', 255511),
(436418, 'PF08210', NULL, 'APOBEC-like N-terminal domain', 175, NULL, 'APOBEC_N', 255512),
(436419, 'PF19373', NULL, 'Family of unknown function (DUF5948)', 70, NULL, 'DUF5948', 255513),
(436420, 'PF09953', NULL, 'Uncharacterized protein conserved in bacteria (DUF2187)', 60, NULL, 'DUF2187', 255514),
(436421, 'PF06126', NULL, 'Herpesvirus Latent membrane protein 2', 497, NULL, 'Herpes_LAMP2', 255515);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(436422, 'PF17024', NULL, 'Putative DMAP1-like', 113, NULL, 'DMAP1_like', 255516),
(436423, 'PF09998', NULL, 'Uncharacterized protein conserved in bacteria (DUF2239)', 183, NULL, 'DUF2239', 255517),
(436424, 'PF15042', NULL, 'Late cornified envelope-like proline-rich protein 1', 116, NULL, 'LELP1', 255518),
(436425, 'PF08766', NULL, 'DEK C terminal domain', 54, NULL, 'DEK_C', 255519),
(436426, 'PF06229', NULL, 'FRG1-like domain', 191, NULL, 'FRG1', 255520),
(436427, 'PF05006', NULL, 'Per os infectivity factor 3', 149, NULL, 'PIF3', 255521),
(436428, 'PF17672', NULL, 'Fertilisation-influencing membrane protein', 130, NULL, 'FIMP', 255522),
(436429, 'PF09680', NULL, 'Family of unknown function', 24, NULL, 'YjcZ_2', 255523),
(436430, 'PF08855', NULL, 'Domain of unknown function (DUF1825)', 103, NULL, 'DUF1825', 255524),
(436431, 'PF10962', NULL, 'Protein of unknown function (DUF2764)', 271, NULL, 'DUF2764', 255525),
(436432, 'PF12424', NULL, 'Plasma membrane calcium transporter ATPase C terminal', 48, NULL, 'ATP_Ca_trans_C', 255526),
(436433, 'PF08665', NULL, 'PglZ domain', 176, NULL, 'PglZ', 255527),
(436434, 'PF05305', NULL, 'Protein of unknown function (DUF732)', 72, NULL, 'DUF732', 255528),
(436435, 'PF05910', NULL, 'Plant protein of unknown function (DUF868)', 279, NULL, 'DUF868', 255529),
(436436, 'PF08117', NULL, 'Ptu family', 35, NULL, 'Toxin_30', 255530),
(436437, 'PF08131', NULL, 'Defensin-like peptide family', 39, NULL, 'Defensin_3', 255531),
(436438, 'PF14630', NULL, 'Origin recognition complex (ORC) subunit 5 C-terminus', 288, NULL, 'ORC5_C', 255532),
(436439, 'PF11623', NULL, 'NAD(P)H dehydrogenase subunit S', 52, NULL, 'NdhS', 255533),
(436440, 'PF18326', NULL, 'RFX5 N-terminal domain', 59, NULL, 'RFX5_N', 255534),
(436441, 'PF14042', NULL, 'Domain of unknown function (DUF4247)', 125, NULL, 'DUF4247', 255535),
(436442, 'PF16433', NULL, 'Domain of unknown function (DUF5030)', 314, NULL, 'DUF5030', 255536),
(436443, 'PF07171', NULL, 'MlrC C-terminus', 178, NULL, 'MlrC_C', 255537),
(436444, 'PF02334', NULL, 'Replication terminator protein', 113, NULL, 'RTP', 255538),
(436445, 'PF08595', NULL, 'RXT2-like, N-terminal', 153, NULL, 'RXT2_N', 255539),
(436446, 'PF19264', NULL, 'Repeat of unknown function (DUF5907)', 80, NULL, 'DUF5907', 255540),
(436447, 'PF04906', NULL, 'Tweety', 431, NULL, 'Tweety', 255541),
(436448, 'PF13793', NULL, 'N-terminal domain of ribose phosphate pyrophosphokinase', 116, NULL, 'Pribosyltran_N', 255542),
(436449, 'PF14652', NULL, 'Domain of unknown function (DUF4457)', 323, NULL, 'DUF4457', 255543),
(436450, 'PF06275', NULL, 'Protein of unknown function (DUF1031)', 80, NULL, 'DUF1031', 255544),
(436451, 'PF17014', NULL, 'Putative Mad3/BUB1 like region 1 protein', 128, NULL, 'Mad3_BUB1_I_2', 255545),
(436452, 'PF09629', NULL, 'YorP protein', 71, NULL, 'YorP', 255546),
(436453, 'PF14567', NULL, 'SMI1-KNR4 cell-wall', 142, NULL, 'SUKH_5', 255547),
(436454, 'PF07578', NULL, 'Lipid A Biosynthesis N-terminal domain', 71, NULL, 'LAB_N', 255548),
(436455, 'PF11713', NULL, 'Peptidase C80 family', 154, NULL, 'Peptidase_C80', 255549),
(436456, 'PF02900', NULL, 'Catalytic LigB subunit of aromatic ring-opening dioxygenase', 273, NULL, 'LigB', 255550),
(436457, 'PF08228', NULL, 'RNase P subunit Pop3', 158, NULL, 'RNase_P_pop3', 255551),
(436458, 'PF12358', NULL, 'Protein of unknown function (DUF3644)', 74, NULL, 'DUF3644', 255552),
(436459, 'PF19771', NULL, 'Family of unknown function (DUF6257)', 61, NULL, 'DUF6257', 255553),
(436460, 'PF09404', NULL, 'KICSTOR complex C12orf66 like', 440, NULL, 'C12orf66_like', 255554),
(436461, 'PF05501', NULL, 'Domain of unknown function (DUF755)', 123, NULL, 'DUF755', 255555),
(436462, 'PF05198', NULL, 'Translation initiation factor IF-3, N-terminal domain', 70, NULL, 'IF3_N', 255556),
(436463, 'PF14480', NULL, 'DNA polymerase III polC-type N-terminus I', 72, NULL, 'DNA_pol3_a_NI', 255557),
(436464, 'PF11642', NULL, 'Mite allergen Blo t 5', 119, NULL, 'Blo-t-5', 255558),
(436465, 'PF19097', NULL, 'Snu56-like U1 small nuclear ribonucleoprotein component', 438, NULL, 'Snu56_snRNP', 255559);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(436466, 'PF09821', NULL, 'C-terminal AAA-associated domain', 119, NULL, 'AAA_assoc_C', 255560),
(436467, 'PF02995', NULL, 'Protein of unknown function (DUF229)', 497, NULL, 'DUF229', 255561),
(436468, 'PF17660', NULL, 'Bacterial tandem repeat domain 1', 50, NULL, 'BTRD1', 255562),
(436469, 'PF08699', NULL, 'Argonaute linker 1 domain', 51, NULL, 'ArgoL1', 255563),
(436470, 'PF17304', NULL, 'Family of unknown function (DUF5353)', 68, NULL, 'DUF5353', 255564),
(436471, 'PF02416', NULL, 'mttA/Hcf106 family', 53, NULL, 'TatA_B_E', 255565),
(436472, 'PF03703', NULL, 'Bacterial PH domain', 80, NULL, 'bPH_2', 255566),
(436473, 'PF05309', NULL, 'TraE protein', 182, NULL, 'TraE', 255567),
(436474, 'PF12661', NULL, 'Human growth factor-like EGF', 22, NULL, 'hEGF', 255568),
(436475, 'PF01252', NULL, 'Signal peptidase (SPase) II', 142, NULL, 'Peptidase_A8', 255569),
(436476, 'PF04788', NULL, 'Protein of unknown function (DUF620)', 243, NULL, 'DUF620', 255570),
(436477, 'PF03394', NULL, 'Poxvirus E8 protein', 239, NULL, 'Pox_E8', 255571),
(436478, 'PF15495', NULL, 'Major fimbrial subunit protein type IV, Fimbrillin, C-terminal', 84, NULL, 'Fimbrillin_C', 255572),
(436479, 'PF15528', NULL, 'Bacterial toxin 23', 193, NULL, 'Ntox23', 255573),
(436480, 'PF03821', NULL, 'Golgi 4-transmembrane spanning transporter', 229, NULL, 'Mtp', 255574),
(436481, 'PF03843', NULL, 'Outer membrane lipoprotein Slp family', 153, NULL, 'Slp', 255575),
(436482, 'PF01857', NULL, 'Retinoblastoma-associated protein B domain', 132, NULL, 'RB_B', 255576),
(436483, 'PF00700', NULL, 'Bacterial flagellin C-terminal helical region', 86, NULL, 'Flagellin_C', 255577),
(436484, 'PF13271', NULL, 'Domain of unknown function (DUF4062)', 83, NULL, 'DUF4062', 255578),
(436485, 'PF01917', NULL, 'Archaebacterial flagellin', 164, NULL, 'Arch_flagellin', 255579),
(436486, 'PF17338', NULL, 'Gene product 88', 231, NULL, 'GP88', 255580),
(436487, 'PF03756', NULL, 'A-factor biosynthesis hotdog domain', 133, NULL, 'AfsA', 255581),
(436488, 'PF14067', NULL, 'LssY C-terminus', 188, NULL, 'LssY_C', 255582),
(436489, 'PF15072', NULL, 'Homologous recombination OB-fold protein', 86, NULL, 'HROB', 255583),
(436490, 'PF19020', NULL, 'Ta1207 family', 277, NULL, 'Ta1207', 255584),
(436491, 'PF19910', NULL, 'Domain of unknown function (DUF6383)', 74, NULL, 'DUF6383', 255585),
(436492, 'PF00046', NULL, 'Homeodomain', 57, NULL, 'Homeodomain', 255586),
(436493, 'PF02419', NULL, 'PsbL protein', 37, NULL, 'PsbL', 255587),
(436494, 'PF18008', NULL, 'Replication initiator protein A C-terminal domain', 95, NULL, 'Bac_RepA_C', 255588),
(436495, 'PF19433', NULL, 'Neuron-derived Neurotrophic Factor C-terminal', 175, NULL, 'NDNF_C', 255589),
(436496, 'PF14951', NULL, 'Domain of unknown function (DUF4503)', 392, NULL, 'DUF4503', 255590),
(436497, 'PF17258', NULL, 'Family of unknown function (DUF5324)', 220, NULL, 'DUF5324', 255591),
(436498, 'PF01764', NULL, 'Lipase (class 3)', 142, NULL, 'Lipase_3', 255592),
(436499, 'PF12798', NULL, '4Fe-4S binding domain', 15, NULL, 'Fer4_3', 255593),
(436500, 'PF16480', NULL, 'Domain of unknown function (DUF5057)', 359, NULL, 'DUF5057', 255594),
(436501, 'PF02015', NULL, 'Glycosyl hydrolase family 45', 210, NULL, 'Glyco_hydro_45', 255595),
(436502, 'PF14155', NULL, 'Domain of unknown function (DUF4307)', 111, NULL, 'DUF4307', 255596),
(436503, 'PF14547', NULL, 'Hydrophobic seed protein', 85, NULL, 'Hydrophob_seed', 255597),
(436504, 'PF00382', NULL, 'Transcription factor TFIIB repeat', 92, NULL, 'TFIIB', 255598),
(436505, 'PF15659', NULL, 'JAB-like toxin  1', 87, NULL, 'Toxin-JAB1', 255599),
(436506, 'PF17000', NULL, 'Accessory secretory protein Sec, Asp5', 71, NULL, 'Asp5', 255600),
(436507, 'PF05566', NULL, 'Orthopoxvirus interleukin 18 binding protein', 126, NULL, 'Pox_vIL-18BP', 255601),
(436508, 'PF06560', NULL, 'Glucose-6-phosphate isomerase (GPI)', 182, NULL, 'GPI', 255602),
(436509, 'PF19810', NULL, 'Family of unknown function (DUF6293)', 209, NULL, 'DUF6293', 255603),
(436510, 'PF07721', NULL, 'Tetratricopeptide repeat', 26, NULL, 'TPR_4', 255604);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(436511, 'PF13857', NULL, 'Ankyrin repeats (many copies)', 56, NULL, 'Ank_5', 255605),
(436512, 'PF15212', NULL, 'Spermatogenesis-associated protein 19, mitochondrial', 130, NULL, 'SPATA19', 255606),
(436513, 'PF04197', NULL, 'Birnavirus RNA dependent RNA polymerase (VP1), palm domain', 531, NULL, 'Birna_RdRp_palm', 255607),
(436514, 'PF05416', NULL, 'Southampton virus-type processing peptidase', 535, NULL, 'Peptidase_C37', 255608),
(436515, 'PF11260', NULL, 'Major ampullate spidroin 1 and 2', 85, NULL, 'Spidroin_MaSp', 255609),
(436516, 'PF18777', NULL, 'Chromosome region maintenance or exportin repeat', 37, NULL, 'CRM1_repeat', 255610),
(436517, 'PF17093', NULL, 'Penicillin-binding protein N-terminus', 138, NULL, 'PBP_N', 255611),
(436518, 'PF10754', NULL, 'Protein of unknown function (DUF2569)', 143, NULL, 'DUF2569', 255612),
(436519, 'PF18148', NULL, 'Regulator of G-protein signalling DHEX domain', 100, NULL, 'RGS_DHEX', 255613),
(436520, 'PF02322', NULL, 'Cytochrome bd terminal oxidase subunit II', 303, NULL, 'Cyt_bd_oxida_II', 255614),
(436521, 'PF05167', NULL, 'Uncharacterised ACR (DUF711)', 406, NULL, 'DUF711', 255615),
(436522, 'PF12664', NULL, 'Protein of unknown function (DUF3789)', 32, NULL, 'DUF3789', 255616),
(436523, 'PF01992', NULL, 'ATP synthase (C/AC39) subunit', 336, NULL, 'vATP-synt_AC39', 255617),
(436524, 'PF19512', NULL, 'Domain of unknown function (DUF6046)', 122, NULL, 'DUF6046', 255618),
(436525, 'PF06324', NULL, 'Pigment-dispersing hormone (PDH)', 18, NULL, 'Pigment_DH', 255619),
(436526, 'PF19100', NULL, 'Family of unknown function (DUF5787)', 263, NULL, 'DUF5787', 255620),
(436527, 'PF17232', NULL, 'Elicitor peptide 1-7', 82, NULL, 'Pep1_7', 255621),
(436528, 'PF00730', NULL, 'HhH-GPD superfamily base excision DNA repair protein', 108, NULL, 'HhH-GPD', 255622),
(436529, 'PF10639', NULL, 'Putative transmembrane family 234', 116, NULL, 'TMEM234', 255623),
(436530, 'PF17517', NULL, 'IgGFc binding protein', 295, NULL, 'IgGFc_binding', 255624),
(436531, 'PF04662', NULL, 'Luteovirus P0 protein', 208, NULL, 'Luteo_PO', 255625),
(436532, 'PF05889', NULL, 'O-phosphoseryl-tRNA(Sec) selenium transferase, SepSecS', 389, NULL, 'SepSecS', 255626),
(436533, 'PF03604', NULL, 'DNA directed RNA polymerase, 7 kDa subunit', 32, NULL, 'DNA_RNApol_7kD', 255627),
(436534, 'PF17198', NULL, 'Spirocyclase AveC-like', 234, NULL, 'AveC_like', 255628),
(436535, 'PF05992', NULL, 'SbmA/BacA-like family', 315, NULL, 'SbmA_BacA', 255629),
(436536, 'PF11523', NULL, 'Protein of unknown function (DUF3223)', 75, NULL, 'DUF3223', 255630),
(436537, 'PF14961', NULL, 'Broad-minded protein', 1292, NULL, 'BROMI', 255631),
(436538, 'PF03141', NULL, 'Putative S-adenosyl-L-methionine-dependent methyltransferase', 506, NULL, 'Methyltransf_29', 255632),
(436539, 'PF04722', NULL, 'Ssu72-like protein', 191, NULL, 'Ssu72', 255633),
(436540, 'PF03436', NULL, 'Domain of unknown function (DUF281)', 55, NULL, 'DUF281', 255634),
(436541, 'PF09948', NULL, 'Predicted metal-binding integral membrane protein (DUF2182)', 188, NULL, 'DUF2182', 255635),
(436542, 'PF13464', NULL, 'Domain of unknown function (DUF4115)', 74, NULL, 'DUF4115', 255636),
(436543, 'PF00028', NULL, 'Cadherin domain', 93, NULL, 'Cadherin', 255637),
(436544, 'PF18784', NULL, 'CRM1 / Exportin repeat 2', 68, NULL, 'CRM1_repeat_2', 255638),
(436545, 'PF18372', NULL, 'Integrin beta epidermal growth factor like domain 1', 29, NULL, 'I-EGF_1', 255639),
(436546, 'PF10117', NULL, 'McrBC 5-methylcytosine restriction system component', 317, NULL, 'McrBC', 255640),
(436547, 'PF13371', NULL, 'Tetratricopeptide repeat', 73, NULL, 'TPR_9', 255641),
(436548, 'PF11819', NULL, 'Cytohesin Ubiquitin Protein Inducing Domain', 136, NULL, 'CUPID', 255642),
(436549, 'PF07500', NULL, 'Transcription factor S-II (TFIIS), central domain', 116, NULL, 'TFIIS_M', 255643),
(436550, 'PF18592', NULL, 'Tho1/MOS11 C-terminal domain', 37, NULL, 'Tho1_MOS11_C', 255644),
(436551, 'PF06705', NULL, 'SF-assemblin/beta giardin', 247, NULL, 'SF-assemblin', 255645),
(436552, 'PF06651', NULL, 'Protein of unknown function (DUF1163)', 68, NULL, 'DUF1163', 255646);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(436553, 'PF17926', NULL, 'Tetracyclin repressor-like, C-terminal domain', 111, NULL, 'TetR_C_21', 255647),
(436554, 'PF18271', NULL, 'Glycoside hydrolase 131 catalytic N-terminal domain', 256, NULL, 'GH131_N', 255648),
(436555, 'PF05634', NULL, 'APO RNA-binding', 200, NULL, 'APO_RNA-bind', 255649),
(436556, 'PF06456', NULL, 'Arfaptin-like domain', 229, NULL, 'Arfaptin', 255650),
(436557, 'PF07343', NULL, 'Protein of unknown function (DUF1475)', 236, NULL, 'DUF1475', 255651),
(436558, 'PF13602', NULL, 'Zinc-binding dehydrogenase', 133, NULL, 'ADH_zinc_N_2', 255652),
(436559, 'PF20431', NULL, 'E motif', 63, NULL, 'E_motif', 255653),
(436560, 'PF15255', NULL, 'WASH complex subunit CAP-Z interacting, central region', 140, NULL, 'CAP-ZIP_m', 255654),
(436561, 'PF17181', NULL, 'Epidermal patterning factor proteins', 52, NULL, 'EPF', 255655),
(436562, 'PF06005', NULL, 'Cell division protein ZapB', 71, NULL, 'ZapB', 255656),
(436563, 'PF10675', NULL, 'Protein of unknown function (DUF2489)', 130, NULL, 'DUF2489', 255657),
(436564, 'PF00466', NULL, 'Ribosomal protein L10', 100, NULL, 'Ribosomal_L10', 255658),
(436565, 'PF14804', NULL, 'Jag N-terminus', 51, NULL, 'Jag_N', 255659),
(436566, 'PF05688', NULL, 'Bacterial Immunoglobulin-like 21', 110, NULL, 'BIg21', 255660),
(436567, 'PF09149', NULL, 'Domain of unknown function (DUF1935)', 103, NULL, 'DUF1935', 255661),
(436568, 'PF00467', NULL, 'KOW motif', 32, NULL, 'KOW', 255662),
(436569, 'PF09284', NULL, 'Rhamnogalacturonan lyase B, N-terminal', 251, NULL, 'RhgB_N', 255663),
(436570, 'PF10763', NULL, 'Protein of unknown function (DUF2584)', 81, NULL, 'DUF2584', 255664),
(436571, 'PF06737', NULL, 'Transglycosylase-like domain', 77, NULL, 'Transglycosylas', 255665),
(436572, 'PF07478', NULL, 'D-ala D-ala ligase C-terminus', 204, NULL, 'Dala_Dala_lig_C', 255666),
(436573, 'PF09317', NULL, 'Acyl-CoA dehydrogenase, C-terminal, bacterial type', 284, NULL, 'ACDH_C', 255667),
(436574, 'PF03676', NULL, 'Phagosome assembly factor 1', 392, NULL, 'PHAF1', 255668),
(436575, 'PF08960', NULL, 'STIV B116-like', 104, NULL, 'STIV_B116-like', 255669),
(436576, 'PF00563', NULL, 'EAL domain', 235, NULL, 'EAL', 255670),
(436577, 'PF04665', NULL, 'Poxvirus A32 protein', 242, NULL, 'Pox_A32', 255671),
(436578, 'PF13554', NULL, 'Bacteriophage related domain of unknown function', 128, NULL, 'DUF4128', 255672),
(436579, 'PF07419', NULL, 'PilM', 135, NULL, 'PilM', 255673),
(436580, 'PF15582', NULL, 'Immunity protein 65', 321, NULL, 'Imm65', 255674),
(436581, 'PF07651', NULL, 'ANTH domain', 277, NULL, 'ANTH', 255675),
(436582, 'PF16721', NULL, 'Zinc-finger like, probable DNA-binding', 102, NULL, 'zf-H3C2', 255676),
(436583, 'PF04345', NULL, 'Chorismate lyase', 168, NULL, 'Chor_lyase', 255677),
(436584, 'PF20492', NULL, 'Ezrin/radixin/moesin, alpha-helical domain', 120, NULL, 'ERM_helical', 255678),
(436585, 'PF04531', NULL, 'Bacteriophage holin', 82, NULL, 'Phage_holin_1', 255679),
(436586, 'PF00200', NULL, 'Disintegrin', 76, NULL, 'Disintegrin', 255680),
(436587, 'PF02450', NULL, 'Lecithin:cholesterol acyltransferase', 392, NULL, 'LCAT', 255681),
(436588, 'PF11009', NULL, 'Protein of unknown function (DUF2847)', 103, NULL, 'DUF2847', 255682),
(436589, 'PF20373', NULL, 'Family of unknown function (DUF6668)', 128, NULL, 'DUF6668', 255683),
(436590, 'PF04943', NULL, 'Poxvirus F11 protein', 409, NULL, 'Pox_F11', 255684),
(436591, 'PF13378', NULL, 'Enolase C-terminal domain-like', 220, NULL, 'MR_MLE_C', 255685),
(436592, 'PF05618', NULL, 'Putative ATP-dependant zinc protease', 138, NULL, 'Zn_protease', 255686),
(436593, 'PF09622', NULL, 'Putative integral membrane protein (DUF2391)', 268, NULL, 'DUF2391', 255687),
(436594, 'PF18407', NULL, 'GCN5-related N-acetyltransferase like domain', 62, NULL, 'GNAT_like', 255688),
(436595, 'PF14790', NULL, 'Tetrahydrodipicolinate N-succinyltransferase N-terminal', 168, NULL, 'THDPS_N', 255689),
(436596, 'PF06500', NULL, 'Esterase FrsA-like', 414, NULL, 'FrsA-like', 255690),
(436597, 'PF18028', NULL, 'Zmiz1 N-terminal tetratricopeptide repeat domain', 99, NULL, 'Zmiz1_N', 255691);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(436598, 'PF04576', NULL, 'Zein-binding', 92, NULL, 'Zein-binding', 255692),
(436599, 'PF17960', NULL, 'TIG domain', 89, NULL, 'TIG_plexin', 255693),
(436600, 'PF11069', NULL, 'Cilia- and flagella-associated protein 298', 97, NULL, 'CFAP298', 255694),
(436601, 'PF08230', NULL, 'CW_7 repeat', 40, NULL, 'CW_7', 255695),
(436602, 'PF11438', NULL, '36-mer N-terminal peptide of the N protein (N36)', 35, NULL, 'N36', 255696),
(436603, 'PF15120', NULL, 'Sperm acrosome-associated protein 9', 164, NULL, 'SPACA9', 255697),
(436604, 'PF20285', NULL, 'C-terminal domain 9 of the ABC-three component (ABC-3C) systems', 113, NULL, 'CTD9', 255698),
(436605, 'PF02749', NULL, 'Quinolinate phosphoribosyl transferase, N-terminal domain', 89, NULL, 'QRPTase_N', 255699),
(436606, 'PF08847', NULL, 'Chlororespiratory reduction 6', 150, NULL, 'Crr6', 255700),
(436607, 'PF11966', NULL, 'SSURE domain', 149, NULL, 'SSURE', 255701),
(436608, 'PF14635', NULL, 'Helix-hairpin-helix motif', 104, NULL, 'HHH_7', 255702),
(436609, 'PF03559', NULL, 'NDP-hexose 2,3-dehydratase', 204, NULL, 'Hexose_dehydrat', 255703),
(436610, 'PF14856', NULL, 'Pathogen effector; putative necrosis-inducing factor', 101, NULL, 'Hce2', 255704),
(436611, 'PF02627', NULL, 'Carboxymuconolactone decarboxylase family', 85, NULL, 'CMD', 255705),
(436612, 'PF12047', NULL, 'Cytosine specific DNA methyltransferase replication foci domain', 144, NULL, 'DNMT1-RFD', 255706),
(436613, 'PF03645', NULL, 'Tctex-1 family', 94, NULL, 'Tctex-1', 255707),
(436614, 'PF18005', NULL, 'eIF3 subunit M, C-terminal helix', 29, NULL, 'eIF3m_C_helix', 255708),
(436615, 'PF18397', NULL, 'IQBAL scaffold dimerization domain', 275, NULL, 'IKBKB_SDD', 255709),
(436616, 'PF18539', NULL, 'Domain of unknown function (DUF5625)', 135, NULL, 'DUF5625', 255710),
(436617, 'PF19703', NULL, 'Family of unknown function (DUF6201)', 129, NULL, 'DUF6201', 255711),
(436618, 'PF03133', NULL, 'Tubulin-tyrosine ligase family', 295, NULL, 'TTL', 255712),
(436619, 'PF07185', NULL, 'Protein of unknown function (DUF1404)', 169, NULL, 'DUF1404', 255713),
(436620, 'PF17834', NULL, 'Beta-sandwich domain in beta galactosidase', 72, NULL, 'GHD', 255714),
(436621, 'PF05247', NULL, 'Flagellar transcriptional activator (FlhD)', 102, NULL, 'FlhD', 255715),
(436622, 'PF19104', NULL, 'Family of unknown function (DUF5791)', 124, NULL, 'DUF5791', 255716),
(436623, 'PF04570', NULL, 'zinc-finger of the FCS-type, C2-C2', 54, NULL, 'zf-FLZ', 255717),
(436624, 'PF11150', NULL, 'Protein of unknown function (DUF2927)', 208, NULL, 'DUF2927', 255718),
(436625, 'PF07069', NULL, 'Porcine reproductive and respiratory syndrome virus 2b', 73, NULL, 'PRRSV_2b', 255719),
(436626, 'PF04869', NULL, 'Uso1 / p115 like vesicle tethering protein, head region', 314, NULL, 'Uso1_p115_head', 255720),
(436627, 'PF06640', NULL, 'P protein C-terminus', 235, NULL, 'P_C', 255721),
(436628, 'PF19635', NULL, 'Family of unknown function (DUF6138)', 551, NULL, 'DUF6138', 255722),
(436629, 'PF02195', NULL, 'ParB/Sulfiredoxin domain', 90, NULL, 'ParBc', 255723),
(436630, 'PF17658', NULL, 'Family of unknown function (DUF5520)', 342, NULL, 'DUF5520', 255724),
(436631, 'PF19470', NULL, 'Family of unknown function (DUF6007)', 65, NULL, 'DUF6007', 255725),
(436632, 'PF03701', NULL, 'Uncharacterised protein family (UPF0181)', 50, NULL, 'UPF0181', 255726),
(436633, 'PF08583', NULL, 'Cytochrome c oxidase biogenesis protein Cmc1 like', 70, NULL, 'Cmc1', 255727),
(436634, 'PF01824', NULL, 'MatK/TrnK amino terminal region', 331, NULL, 'MatK_N', 255728),
(436635, 'PF02969', NULL, 'TATA box binding protein associated factor (TAF)', 66, NULL, 'TAF', 255729),
(436636, 'PF06682', NULL, 'SOCE-associated regulatory factor of calcium homoeostasis', 340, NULL, 'SARAF', 255730),
(436637, 'PF05567', NULL, 'Neisseria PilC beta-propeller domain', 367, NULL, 'Neisseria_PilC', 255731),
(436638, 'PF06621', NULL, 'Single-minded protein C-terminus', 305, NULL, 'SIM_C', 255732),
(436639, 'PF00145', NULL, 'C-5 cytosine-specific DNA methylase', 335, NULL, 'DNA_methylase', 255733);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(436640, 'PF07823', NULL, 'Cyclic phosphodiesterase-like protein', 199, NULL, 'CPDase', 255734),
(436641, 'PF04207', NULL, 'Tetrahydromethanopterin S-methyltransferase, subunit D', 218, NULL, 'MtrD', 255735),
(436642, 'PF20561', NULL, 'Domain of unknown function (DUF6771)', 63, NULL, 'DUF6771', 255736),
(436643, 'PF15393', NULL, 'Domain of unknown function (DUF4615)', 140, NULL, 'DUF4615', 255737),
(436644, 'PF16539', NULL, 'Flagellar assembly protein T, middle domain', 158, NULL, 'FlgT_M', 255738),
(436645, 'PF20287', NULL, 'SH3 fold domain associated with phage DNA polymerases', 122, NULL, 'SH3DP', 255739),
(436646, 'PF08885', NULL, 'GSCFA family', 237, NULL, 'GSCFA', 255740),
(436647, 'PF09243', NULL, 'Mitochondrial small ribosomal subunit Rsm22', 287, NULL, 'Rsm22', 255741),
(436648, 'PF14296', NULL, 'O-antigen polysaccharide polymerase Wzy', 468, NULL, 'O-ag_pol_Wzy', 255742),
(436649, 'PF03658', NULL, 'RnfH family Ubiquitin', 83, NULL, 'Ub-RnfH', 255743),
(436650, 'PF16740', NULL, 'Spindle and kinetochore-associated protein 2', 110, NULL, 'SKA2', 255744),
(436651, 'PF06487', NULL, 'Sin3 associated polypeptide p18 (SAP18)', 141, NULL, 'SAP18', 255745),
(436652, 'PF16111', NULL, 'Domain of unknown function (DUF4829)', 119, NULL, 'DUF4829', 255746),
(436653, 'PF06478', NULL, 'Coronavirus RNA-dependent RNA polymerase, N-terminal', 350, NULL, 'CoV_RPol_N', 255747),
(436654, 'PF20614', NULL, 'Homologues of viral RNAse III, found in viruses infecting fungi', 77, NULL, 'Mycovirus_RNAse', 255748),
(436655, 'PF20227', NULL, 'Family of unknown function (DUF6586)', 153, NULL, 'DUF6586', 255749),
(436656, 'PF12911', NULL, 'N-terminal TM domain of oligopeptide transport permease C', 51, NULL, 'OppC_N', 255750),
(436657, 'PF18614', NULL, 'RNase II-type exonuclease C-terminal S1 domain', 59, NULL, 'RNase_II_C_S1', 255751),
(436658, 'PF00754', NULL, 'F5/8 type C domain', 127, NULL, 'F5_F8_type_C', 255752),
(436659, 'PF04131', NULL, 'Putative N-acetylmannosamine-6-phosphate epimerase', 192, NULL, 'NanE', 255753),
(436660, 'PF16806', NULL, 'Antiactivator protein ExsD', 234, NULL, 'ExsD', 255754),
(436661, 'PF08740', NULL, 'BCS1 N terminal', 187, NULL, 'BCS1_N', 255755),
(436662, 'PF02697', NULL, 'Putative antitoxin', 69, NULL, 'VAPB_antitox', 255756),
(436663, 'PF18117', NULL, 'Enhanced disease susceptibility 1 protein EP domain', 214, NULL, 'EDS1_EP', 255757),
(436664, 'PF02104', NULL, 'SURF1 family', 195, NULL, 'SURF1', 255758),
(436665, 'PF09077', NULL, 'Mu B transposition protein, C terminal', 78, NULL, 'Phage-MuB_C', 255759),
(436666, 'PF14834', NULL, 'Glutathione S-transferase, C-terminal domain', 117, NULL, 'GST_C_4', 255760),
(436667, 'PF14577', NULL, 'Sieve element occlusion C-terminus', 232, NULL, 'SEO_C', 255761),
(436668, 'PF20430', NULL, 'E+ motif', 28, NULL, 'Eplus_motif', 255762),
(436669, 'PF07227', NULL, 'PHD - plant homeodomain finger protein', 130, NULL, 'PHD_Oberon', 255763),
(436670, 'PF18984', NULL, 'Family of unknown function (DUF5717)N-terminal', 875, NULL, 'DUF5717_N', 255764),
(436671, 'PF04269', NULL, 'Protein of unknown function, DUF440', 101, NULL, 'DUF440', 255765),
(436672, 'PF10401', NULL, 'Interferon-regulatory factor 3', 180, NULL, 'IRF-3', 255766),
(436673, 'PF19417', NULL, 'RNase LS, bacterial toxin N-terminal', 82, NULL, 'RnlA_toxin_N', 255767),
(436674, 'PF00424', NULL, 'REV protein (anti-repression trans-activator protein)', 94, NULL, 'REV', 255768),
(436675, 'PF12808', NULL, 'Micro-tubular organiser Mto1 C-term Mto2-binding region', 52, NULL, 'Mto2_bdg', 255769),
(436676, 'PF16264', NULL, 'SatD family (SatD)', 211, NULL, 'SatD', 255770),
(436677, 'PF18743', NULL, 'REase_AHJR-like', 123, NULL, 'AHJR-like', 255771),
(436678, 'PF05901', NULL, 'Excalibur calcium-binding domain', 38, NULL, 'Excalibur', 255772),
(436679, 'PF01588', NULL, 'Putative tRNA binding domain', 96, NULL, 'tRNA_bind', 255773),
(436680, 'PF05653', NULL, 'Magnesium transporter NIPA', 295, NULL, 'Mg_trans_NIPA', 255774),
(436681, 'PF18873', NULL, 'Sgo0707 N-terminal domain', 269, NULL, 'Sgo0707_N1', 255775); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(436682, 'PF15907', NULL, 'Integrin-alpha FG-GAP repeat-containing protein 2', 332, NULL, 'Itfg2', 255776),
(436683, 'PF10091', NULL, 'Putative glucoamylase', 222, NULL, 'Glycoamylase', 255777),
(436684, 'PF15940', NULL, 'Family of unknown function', 90, NULL, 'YjcB', 255778),
(436685, 'PF17439', NULL, 'Family of unknown function (DUF5418)', 151, NULL, 'DUF5418', 255779),
(436686, 'PF11646', NULL, 'Protein of unknown function DUF3258', 111, NULL, 'DUF3258', 255780),
(436687, 'PF08782', NULL, 'c-SKI Smad4 binding domain', 94, NULL, 'c-SKI_SMAD_bind', 255781),
(436688, 'PF14924', NULL, 'Protein of unknown function (DUF4497)', 108, NULL, 'DUF4497', 255782),
(436689, 'PF07028', NULL, 'Protein of unknown function (DUF1319)', 109, NULL, 'DUF1319', 255783),
(436690, 'PF10343', NULL, 'Potential Queuosine, Q, salvage protein family', 288, NULL, 'Q_salvage', 255784),
(436691, 'PF12640', NULL, 'UPF0489 domain', 175, NULL, 'UPF0489', 255785),
(436692, 'PF17428', NULL, 'Family of unknown function (DUF5412)', 118, NULL, 'DUF5412', 255786),
(436693, 'PF18569', NULL, 'Thioredoxin-like domain', 93, NULL, 'Thioredoxin_16', 255787),
(436694, 'PF17735', NULL, 'Biofilm surface layer A', 121, NULL, 'BslA', 255788),
(436695, 'PF12998', NULL, 'Inhibitor of growth proteins N-terminal histone-binding', 102, NULL, 'ING', 255789),
(436696, 'PF19336', NULL, 'Domain of unknown function (DUF5921)', 431, NULL, 'DUF5921', 255790),
(436697, 'PF07857', NULL, 'Transmembrane family, TMEM144 of transporters', 336, NULL, 'TMEM144', 255791),
(436698, 'PF09063', NULL, 'Phage PP7 coat protein', 127, NULL, 'Phage_coat', 255792),
(436699, 'PF01539', NULL, 'Hepatitis C virus envelope glycoprotein E1', 190, NULL, 'HCV_env', 255793),
(436700, 'PF00258', NULL, 'Flavodoxin', 143, NULL, 'Flavodoxin_1', 255794),
(436701, 'PF09545', NULL, 'AccI restriction endonuclease', 366, NULL, 'RE_AccI', 255795),
(436702, 'PF09050', NULL, 'Stannin unstructured linker', 26, NULL, 'SNN_linker', 255796),
(436703, 'PF15400', NULL, 'Testis-expressed sequence 33 protein family', 138, NULL, 'TEX33', 255797),
(436704, 'PF00748', NULL, 'Calpain inhibitor', 133, NULL, 'Calpain_inhib', 255798),
(436705, 'PF00769', NULL, 'Ezrin/radixin/moesin family C terminal', 77, NULL, 'ERM_C', 255799),
(436706, 'PF20540', NULL, 'Family of unknown function (DUF6755)', 75, NULL, 'DUF6755', 255800),
(436707, 'PF01580', NULL, 'FtsK/SpoIIIE family', 243, NULL, 'FtsK_SpoIIIE', 255801),
(436708, 'PF10302', NULL, 'DSC E3 ubiquitin ligase complex subunit 3, ubiquitin-like domain', 104, NULL, 'Dsc3_N', 255802),
(436709, 'PF13118', NULL, 'Protein of unknown function (DUF3972)', 125, NULL, 'DUF3972', 255803),
(436710, 'PF10571', NULL, 'Uncharacterised protein family UPF0547', 26, NULL, 'UPF0547', 255804),
(436711, 'PF04550', NULL, 'Phage holin family 2', 86, NULL, 'Phage_holin_3_2', 255805),
(436712, 'PF18733', NULL, 'LA2681-like HEPN', 208, NULL, 'HEPN_LA2681', 255806),
(436713, 'PF19855', NULL, 'Family of unknown function (DUF6330)', 69, NULL, 'DUF6330', 255807),
(436714, 'PF04109', NULL, 'Autophagy protein ATG9', 480, NULL, 'ATG9', 255808),
(436715, 'PF07552', NULL, 'Spore Coat Protein X and V domain', 58, NULL, 'Coat_X', 255809),
(436716, 'PF03506', NULL, 'Influenza C non-structural protein (NS1)', 162, NULL, 'Flu_C_NS1', 255810),
(436717, 'PF14783', NULL, 'Ciliary BBSome complex subunit 2, middle region', 108, NULL, 'BBS2_Mid', 255811),
(436718, 'PF17392', NULL, 'Urocanase C-terminal domain', 196, NULL, 'Urocanase_C', 255812),
(436719, 'PF01060', NULL, 'Transthyretin-like family', 81, NULL, 'TTR-52', 255813),
(436720, 'PF18821', NULL, 'Large polyvalent protein-associated domain 7', 92, NULL, 'LPD7', 255814),
(436721, 'PF00803', NULL, '3A/RNA2 movement protein family', 236, NULL, '3A', 255815),
(436722, 'PF07188', NULL, 'Kaposi''s sarcoma-associated herpesvirus (KSHV) K8 protein', 238, NULL, 'KSHV_K8', 255816),
(436723, 'PF17683', NULL, 'TFIIF, beta subunit N-terminus', 132, NULL, 'TFIIF_beta_N', 255817),
(436724, 'PF08507', NULL, 'COPI associated protein', 130, NULL, 'COPI_assoc', 255818);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(436725, 'PF16895', NULL, 'Domain of unknown function (DUF5085)', 141, NULL, 'DUF5085', 255819),
(436726, 'PF14690', NULL, 'zinc-finger of transposase IS204/IS1001/IS1096/IS1165', 47, NULL, 'zf-ISL3', 255820),
(436727, 'PF13552', NULL, 'Protein of unknown function (DUF4127)', 491, NULL, 'DUF4127', 255821),
(436728, 'PF14833', NULL, 'NAD-binding of NADP-dependent 3-hydroxyisobutyrate dehydrogenase', 122, NULL, 'NAD_binding_11', 255822),
(436729, 'PF03035', NULL, 'Calicivirus putative RNA polymerase/capsid protein', 226, NULL, 'RNA_capsid', 255823),
(436730, 'PF14268', NULL, 'YoaP-like', 44, NULL, 'YoaP', 255824),
(436731, 'PF18653', NULL, 'Arcadin 1', 111, NULL, 'Arcadin_1', 255825),
(436732, 'PF12642', NULL, 'Conjugative transposon protein TcpC', 230, NULL, 'TpcC', 255826),
(436733, 'PF20526', NULL, 'Domain of unknown function (DUF6741)', 129, NULL, 'DUF6741', 255827),
(436734, 'PF07061', NULL, 'Swi5', 80, NULL, 'Swi5', 255828),
(436735, 'PF15279', NULL, 'Sine oculis-binding protein', 323, NULL, 'SOBP', 255829),
(436736, 'PF04379', NULL, 'ApaG domain', 87, NULL, 'DUF525', 255830),
(436737, 'PF14064', NULL, 'HmuY protein', 155, NULL, 'HmuY', 255831),
(436738, 'PF17519', NULL, 'Family of unknown function (DUF5444)', 62, NULL, 'DUF5444', 255832),
(436739, 'PF19194', NULL, 'Family of unknown function (DUF5869)', 159, NULL, 'DUF5869', 255833),
(436740, 'PF07891', NULL, 'Protein of unknown function (DUF1666)', 246, NULL, 'DUF1666', 255834),
(436741, 'PF11174', NULL, 'Protein of unknown function (DUF2970)', 56, NULL, 'DUF2970', 255835),
(436742, 'PF04836', NULL, 'Interferon-related protein conserved region', 52, NULL, 'IFRD_C', 255836),
(436743, 'PF09370', NULL, 'Phosphoenolpyruvate hydrolase-like', 267, NULL, 'PEP_hydrolase', 255837),
(436744, 'PF15766', NULL, 'Domain of unknown function (DUF4695)', 108, NULL, 'DUF4695', 255838),
(436745, 'PF18609', NULL, 'Exuperantia SAM-like domain', 73, NULL, 'SAM_Exu', 255839),
(436746, 'PF14543', NULL, 'Xylanase inhibitor N-terminal', 178, NULL, 'TAXi_N', 255840),
(436747, 'PF16931', NULL, 'Putative phage holin', 123, NULL, 'Phage_holin_8', 255841),
(436748, 'PF13018', NULL, 'Extended Signal Peptide of Type V secretion system', 50, NULL, 'ESPR', 255842),
(436749, 'PF18140', NULL, 'Propionyl-coenzyme A carboxylase BT domain', 127, NULL, 'PCC_BT', 255843),
(436750, 'PF06123', NULL, 'Inner membrane protein CreD', 427, NULL, 'CreD', 255844),
(436751, 'PF02270', NULL, 'TFIIF, beta subunit HTH domain', 65, NULL, 'TFIIF_beta', 255845),
(436752, 'PF07459', NULL, 'CTX phage RstB protein', 90, NULL, 'CTX_RstB', 255846),
(436753, 'PF19787', NULL, 'Family of unknown function (DUF6271)', 435, NULL, 'DUF6271', 255847),
(436754, 'PF01560', NULL, 'Hepatitis C virus non-structural protein E2/NS1', 344, NULL, 'HCV_NS1', 255848),
(436755, 'PF15203', NULL, 'TMEM95 family', 151, NULL, 'TMEM95', 255849),
(436756, 'PF17237', NULL, 'ERMES regulator 1', 44, NULL, 'Emr1', 255850),
(436757, 'PF11268', NULL, 'Protein of unknown function (DUF3071)', 166, NULL, 'DUF3071', 255851),
(436758, 'PF11883', NULL, 'Domain of unknown function (DUF3403)', 45, NULL, 'DUF3403', 255852),
(436759, 'PF11502', NULL, 'B-cell lymphoma 9 protein', 39, NULL, 'BCL9', 255853),
(436760, 'PF06371', NULL, 'Diaphanous GTPase-binding Domain', 192, NULL, 'Drf_GBD', 255854),
(436761, 'PF04337', NULL, 'Protein of unknown function, DUF480', 149, NULL, 'DUF480', 255855),
(436762, 'PF02126', NULL, 'Phosphotriesterase family', 298, NULL, 'PTE', 255856),
(436763, 'PF01778', NULL, 'Ribosomal L28e protein family', 115, NULL, 'Ribosomal_L28e', 255857),
(436764, 'PF08478', NULL, 'POTRA domain, FtsQ-type', 69, NULL, 'POTRA_1', 255858),
(436765, 'PF01607', NULL, 'Chitin binding Peritrophin-A domain', 53, NULL, 'CBM_14', 255859),
(436766, 'PF14875', NULL, 'N-term cysteine-rich ER, FAM69', 157, NULL, 'PIP49_N', 255860),
(436767, 'PF20436', NULL, 'Archaeal LonB, AAA+ ATPase LID domain', 65, NULL, 'LonB_AAA-LID', 255861),
(436768, 'PF15171', NULL, 'Neuropeptide secretory protein family, NPQ, spexin', 90, NULL, 'Spexin', 255862);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(436769, 'PF15590', NULL, 'Immunity protein 27', 67, NULL, 'Imm27', 255863),
(436770, 'PF04167', NULL, 'Protein of unknown function (DUF402)', 68, NULL, 'DUF402', 255864),
(436771, 'PF04388', NULL, 'Hamartin protein', 731, NULL, 'Hamartin', 255865),
(436772, 'PF10849', NULL, 'Protein of unknown function (DUF2654)', 70, NULL, 'DUF2654', 255866),
(436773, 'PF03546', NULL, 'Treacher Collins syndrome protein Treacle', 532, NULL, 'Treacle', 255867),
(436774, 'PF16710', NULL, 'N-terminal N1 domain of Vibrio phage CTXphi pIII', 111, NULL, 'CTXphi_pIII-N1', 255868),
(436775, 'PF05373', NULL, 'L-proline 3-hydroxylase, C-terminal', 101, NULL, 'Pro_3_hydrox_C', 255869),
(436776, 'PF13145', NULL, 'PPIC-type PPIASE domain', 121, NULL, 'Rotamase_2', 255870),
(436777, 'PF04634', NULL, 'Protein of unknown function, DUF600', 146, NULL, 'DUF600', 255871),
(436778, 'PF02471', NULL, 'Borrelia outer surface protein E', 107, NULL, 'OspE', 255872),
(436779, 'PF14202', NULL, 'Transposon-encoded protein TnpW', 35, NULL, 'TnpW', 255873),
(436780, 'PF03764', NULL, 'Elongation factor G, domain IV', 121, NULL, 'EFG_IV', 255874),
(436781, 'PF15552', NULL, 'Domain of unknown function (DUF4657)', 300, NULL, 'DUF4657', 255875),
(436782, 'PF13591', NULL, 'MerR HTH family regulatory protein', 84, NULL, 'MerR_2', 255876),
(436783, 'PF17859', NULL, 'Pelovaterin', 42, NULL, 'Pelovaterin', 255877),
(436784, 'PF07313', NULL, 'Protein of unknown function (DUF1460)', 216, NULL, 'DUF1460', 255878),
(436785, 'PF18256', NULL, 'Co-chaperone HscB tetracysteine metal binding motif', 27, NULL, 'HscB_4_cys', 255879),
(436786, 'PF20095', NULL, 'Domain of unknown function (DUF6485)', 70, NULL, 'DUF6485', 255880),
(436787, 'PF13442', NULL, 'Cytochrome C oxidase, cbb3-type, subunit III', 67, NULL, 'Cytochrome_CBB3', 255881),
(436788, 'PF16605', NULL, 'LSM-interacting associated unstructured', 61, NULL, 'LSM_int_assoc', 255882),
(436789, 'PF03301', NULL, 'Tryptophan 2,3-dioxygenase', 346, NULL, 'Trp_dioxygenase', 255883),
(436790, 'PF01116', NULL, 'Fructose-bisphosphate aldolase class-II', 280, NULL, 'F_bP_aldolase', 255884),
(436791, 'PF02348', NULL, 'Cytidylyltransferase', 221, NULL, 'CTP_transf_3', 255885),
(436792, 'PF03793', NULL, 'PASTA domain', 63, NULL, 'PASTA', 255886),
(436793, 'PF10133', NULL, 'CO dehydrogenase accessory protein CooT', 60, NULL, 'CooT', 255887),
(436794, 'PF05521', NULL, 'Phage head-tail joining protein', 96, NULL, 'Phage_H_T_join', 255888),
(436795, 'PF05738', NULL, 'Cna protein B-type domain', 90, NULL, 'Cna_B', 255889),
(436796, 'PF09603', NULL, 'Fibrobacter succinogenes major domain (Fib_succ_major)', 177, NULL, 'Fib_succ_major', 255890),
(436797, 'PF05292', NULL, 'Malonyl-CoA decarboxylase C-terminal domain', 259, NULL, 'MCD', 255891),
(436798, 'PF12120', NULL, 'Rifampin ADP-ribosyl transferase', 99, NULL, 'Arr-ms', 255892),
(436799, 'PF14958', NULL, 'ATPase PAAT-like', 141, NULL, 'PAAT-like', 255893),
(436800, 'PF00651', NULL, 'BTB/POZ domain', 111, NULL, 'BTB', 255894),
(436801, 'PF14365', NULL, 'Neprosin activation peptide', 119, NULL, 'Neprosin_AP', 255895),
(436802, 'PF16648', NULL, 'Unstructured region on Calpain-3', 68, NULL, 'Calpain_u2', 255896),
(436803, 'PF14524', NULL, 'Wzt C-terminal domain', 141, NULL, 'Wzt_C', 255897),
(436804, 'PF04089', NULL, 'BRICHOS domain', 91, NULL, 'BRICHOS', 255898),
(436805, 'PF18199', NULL, 'Dynein heavy chain C-terminal domain', 309, NULL, 'Dynein_C', 255899),
(436806, 'PF07000', NULL, 'Protein of unknown function (DUF1308)', 163, NULL, 'DUF1308', 255900),
(436807, 'PF05758', NULL, 'Ycf1', 945, NULL, 'Ycf1', 255901),
(436808, 'PF02896', NULL, 'PEP-utilising enzyme, PEP-binding domain', 294, NULL, 'PEP-utilizers_C', 255902),
(436809, 'PF10750', NULL, 'Protein of unknown function (DUF2536)', 68, NULL, 'DUF2536', 255903),
(436810, 'PF11943', NULL, 'Protein of unknown function (DUF3460)', 58, NULL, 'DUF3460', 255904),
(436811, 'PF16546', NULL, 'Homodimerisation domain of SGTA', 67, NULL, 'SGTA_dimer', 255905),
(436812, 'PF04266', NULL, 'ASCH domain', 107, NULL, 'ASCH', 255906);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(436813, 'PF14426', NULL, 'Immunity protein Imm2', 60, NULL, 'Imm2', 255907),
(436814, 'PF05648', NULL, 'Peroxisomal biogenesis factor 11 (PEX11)', 223, NULL, 'PEX11', 255908),
(436815, 'PF10507', NULL, 'Transmembrane protein 65', 109, NULL, 'TMEM65', 255909),
(436816, 'PF14865', NULL, 'Macin', 60, NULL, 'Macin', 255910),
(436817, 'PF17863', NULL, 'AAA lid domain', 73, NULL, 'AAA_lid_2', 255911),
(436818, 'PF06971', NULL, 'Putative DNA-binding protein N-terminus', 49, NULL, 'Put_DNA-bind_N', 255912),
(436819, 'PF16371', NULL, 'N terminal of Calcineurin-like phosphoesterase', 78, NULL, 'MetallophosN', 255913),
(436820, 'PF10143', NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase', 171, NULL, 'PhosphMutase', 255914),
(436821, 'PF02657', NULL, 'Fe-S metabolism associated domain', 122, NULL, 'SufE', 255915),
(436822, 'PF12271', NULL, 'Chitin synthase export chaperone', 287, NULL, 'Chs7', 255916),
(436823, 'PF18362', NULL, 'Tri-helix bundle domain', 34, NULL, 'THB', 255917),
(436824, 'PF00321', NULL, 'Plant thionin', 46, NULL, 'Thionin', 255918),
(436825, 'PF01532', NULL, 'Glycosyl hydrolase family 47', 458, NULL, 'Glyco_hydro_47', 255919),
(436826, 'PF01540', NULL, 'Adhesin lipoprotein', 112, NULL, 'Lipoprotein_7', 255920),
(436827, 'PF09359', NULL, 'VTC domain', 275, NULL, 'VTC', 255921),
(436828, 'PF08727', NULL, 'Poliovirus 3A protein like', 59, NULL, 'P3A', 255922),
(436829, 'PF12887', NULL, 'SICA extracellular alpha domain', 183, NULL, 'SICA_alpha', 255923),
(436830, 'PF05693', NULL, 'Glycogen synthase', 638, NULL, 'Glycogen_syn', 255924),
(436831, 'PF10691', NULL, 'Protein of unknown function (DUF2497)', 75, NULL, 'DUF2497', 255925),
(436832, 'PF13049', NULL, 'Protein of unknown function (DUF3910)', 95, NULL, 'DUF3910', 255926),
(436833, 'PF17430', NULL, 'Uncharacterized YqgC-like', 51, NULL, 'YqgC', 255927),
(436834, 'PF07602', NULL, 'Protein of unknown function (DUF1565)', 247, NULL, 'DUF1565', 255928),
(436835, 'PF11078', NULL, 'Optomotor-blind protein N-terminal region', 79, NULL, 'Optomotor-blind', 255929),
(436836, 'PF05353', NULL, 'Delta Atracotoxin', 42, NULL, 'Atracotoxin', 255930),
(436837, 'PF15995', NULL, 'Domain of unknown function (DUF4771)', 160, NULL, 'DUF4771', 255931),
(436838, 'PF08830', NULL, 'Protein of unknown function (DUF1806)', 112, NULL, 'DUF1806', 255932),
(436839, 'PF20450', NULL, 'Papillomavirus E1, DNA-binding domain', 140, NULL, 'PPV_E1_DBD', 255933),
(436840, 'PF02158', NULL, 'Neuregulin intracellular region', 359, NULL, 'Neuregulin', 255934),
(436841, 'PF08087', NULL, 'Conotoxin O-superfamily', 31, NULL, 'Toxin_18', 255935),
(436842, 'PF12314', NULL, 'Inner membrane complex protein', 94, NULL, 'IMCp', 255936),
(436843, 'PF16567', NULL, 'Pathogenicity island component CagD', 205, NULL, 'CagD', 255937),
(436844, 'PF04782', NULL, 'Protein of unknown function (DUF632)', 321, NULL, 'DUF632', 255938),
(436845, 'PF03936', NULL, 'Terpene synthase family, metal binding domain', 267, NULL, 'Terpene_synth_C', 255939),
(436846, 'PF16348', NULL, 'Coronavirus replicase NSP4, C-terminal', 96, NULL, 'CoV_NSP4_C', 255940),
(436847, 'PF08313', NULL, 'SCA7, zinc-binding domain', 68, NULL, 'SCA7', 255941),
(436848, 'PF05980', NULL, 'Toxin 7', 34, NULL, 'Toxin_7', 255942),
(436849, 'PF18924', NULL, 'Protein of unknown function (DUF5674)', 109, NULL, 'DUF5674', 255943),
(436850, 'PF12033', NULL, 'Protein of unknown function (DUF3519)', 105, NULL, 'DUF3519', 255944),
(436851, 'PF00714', NULL, 'Interferon gamma', 138, NULL, 'IFN-gamma', 255945),
(436852, 'PF09288', NULL, 'Fungal ubiquitin-associated domain', 55, NULL, 'UBA_3', 255946),
(436853, 'PF19967', NULL, 'vWA-MoxR associated protein middle region (VMAP-M) 5', 136, NULL, 'VMAP-M5', 255947),
(436854, 'PF10166', NULL, 'Uncharacterised conserved protein (DUF2368)', 134, NULL, 'DUF2368', 255948),
(436855, 'PF03652', NULL, 'Holliday junction resolvase', 134, NULL, 'RuvX', 255949),
(436856, 'PF11917', NULL, 'Protein of unknown function (DUF3435)', 418, NULL, 'DUF3435', 255950),
(436857, 'PF15975', NULL, 'Flotillin', 124, NULL, 'Flot', 255951);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(436858, 'PF07424', NULL, 'TrbM', 156, NULL, 'TrbM', 255952),
(436859, 'PF01579', NULL, 'Domain of unknown function (DUF19)', 158, NULL, 'DUF19', 255953),
(436860, 'PF13483', NULL, 'Beta-lactamase superfamily domain', 163, NULL, 'Lactamase_B_3', 255954),
(436861, 'PF09496', NULL, 'Cenp-O kinetochore centromere component', 209, NULL, 'CENP-O', 255955),
(436862, 'PF07506', NULL, 'RepB plasmid partitioning protein', 185, NULL, 'RepB', 255956),
(436863, 'PF18112', NULL, 'Autophagy receptor zinc finger-C2H2 domain', 27, NULL, 'Zn-C2H2_12', 255957),
(436864, 'PF18177', NULL, 'La HTH in kinetoplastid DICER domain', 90, NULL, 'La_HTH_kDCL', 255958),
(436865, 'PF10858', NULL, 'Protein of unknown function (DUF2659)', 224, NULL, 'DUF2659', 255959),
(436866, 'PF10912', NULL, 'Protein of unknown function (DUF2700)', 146, NULL, 'DUF2700', 255960),
(436867, 'PF20424', NULL, 'PilZN3 domain', 135, NULL, 'PilZN3', 255961),
(436868, 'PF09619', NULL, 'Type III secretion system lipoprotein chaperone (YscW)', 107, NULL, 'YscW', 255962),
(436869, 'PF12869', NULL, 'tRNA_anti-like', 161, NULL, 'tRNA_anti-like', 255963),
(436870, 'PF10873', NULL, 'Cysteine and tyrosine-rich protein 1', 149, NULL, 'CYYR1', 255964),
(436871, 'PF20089', NULL, 'Family of unknown function (DUF6481)', 119, NULL, 'DUF6481', 255965),
(436872, 'PF18109', NULL, 'Ferredoxin I 4Fe-4S cluster domain', 35, NULL, 'Fer4_24', 255966),
(436873, 'PF11645', NULL, 'PD-(D/E)XK endonuclease', 137, NULL, 'PDDEXK_5', 255967),
(436874, 'PF20364', NULL, 'Family of unknown function (DUF6659)', 131, NULL, 'DUF6659', 255968),
(436875, 'PF19395', NULL, 'Family of unknown function (DUF5970)', 77, NULL, 'DUF5970', 255969),
(436876, 'PF09970', NULL, 'Nucleotidyl transferase of unknown function (DUF2204)', 181, NULL, 'DUF2204', 255970),
(436877, 'PF14759', NULL, 'Reductase C-terminal', 85, NULL, 'Reductase_C', 255971),
(436878, 'PF17592', NULL, 'Family of unknown function (DUF5489)', 78, NULL, 'DUF5489', 255972),
(436879, 'PF07679', NULL, 'Immunoglobulin I-set domain', 90, NULL, 'I-set', 255973),
(436880, 'PF03646', NULL, 'FlaG protein', 101, NULL, 'FlaG', 255974),
(436881, 'PF12250', NULL, 'Arabinofuranosyltransferase N terminal', 427, NULL, 'AftA_N', 255975),
(436882, 'PF13036', NULL, 'Peptidoglycan-synthase activator LpoB', 147, NULL, 'LpoB', 255976),
(436883, 'PF02113', NULL, 'D-Ala-D-Ala carboxypeptidase 3 (S13) family', 444, NULL, 'Peptidase_S13', 255977),
(436884, 'PF12759', NULL, 'InsA C-terminal domain', 46, NULL, 'HTH_Tnp_IS1', 255978),
(436885, 'PF19081', NULL, 'Ig-like domain CHU_C associated', 84, NULL, 'Ig_7', 255979),
(436886, 'PF07464', NULL, 'Apolipophorin-III precursor (apoLp-III)', 146, NULL, 'ApoLp-III', 255980),
(436887, 'PF07075', NULL, 'Protein of unknown function (DUF1343)', 353, NULL, 'DUF1343', 255981),
(436888, 'PF00430', NULL, 'ATP synthase B/B'' CF(0)', 132, NULL, 'ATP-synt_B', 255982),
(436889, 'PF03550', NULL, 'Outer membrane lipoprotein LolB', 152, NULL, 'LolB', 255983),
(436890, 'PF10736', NULL, 'Protein of unknown function (DUF2627)', 38, NULL, 'DUF2527', 255984),
(436891, 'PF03549', NULL, 'Translocated intimin receptor (Tir) intimin-binding domain', 66, NULL, 'Tir_receptor_M', 255985),
(436892, 'PF05966', NULL, 'Chordopoxvirus A33R protein', 186, NULL, 'Chordopox_A33R', 255986),
(436893, 'PF09468', NULL, 'Ydr279p protein family (RNase H2 complex component) wHTH domain', 159, NULL, 'RNase_H2-Ydr279', 255987),
(436894, 'PF16970', NULL, 'Type-1 fimbrial protein, A', 143, NULL, 'FimA', 255988),
(436895, 'PF04417', NULL, 'Protein of unknown function (DUF501)', 140, NULL, 'DUF501', 255989),
(436896, 'PF16227', NULL, 'Domain of unknown function (DUF4886)', 250, NULL, 'DUF4886', 255990),
(436897, 'PF00241', NULL, 'Cofilin/tropomyosin-type actin-binding protein', 125, NULL, 'Cofilin_ADF', 255991),
(436898, 'PF08809', NULL, 'Phage related hypothetical protein (DUF1799)', 80, NULL, 'DUF1799', 255992),
(436899, 'PF13407', NULL, 'Periplasmic binding protein domain', 259, NULL, 'Peripla_BP_4', 255993),
(436900, 'PF05076', NULL, 'Suppressor of fused protein (SUFU)', 172, NULL, 'SUFU', 255994);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(436901, 'PF12995', NULL, 'Domain of unknown function, E. rectale Gene description (DUF3879)', 181, NULL, 'DUF3879', 255995),
(436902, 'PF08084', NULL, 'PROCT (NUC072) domain', 123, NULL, 'PROCT', 255996),
(436903, 'PF10022', NULL, 'Uncharacterized protein conserved in bacteria (DUF2264)', 352, NULL, 'DUF2264', 255997),
(436904, 'PF20260', NULL, 'RNA methyltransferase PUA domain', 48, NULL, 'PUA_4', 255998),
(436905, 'PF04596', NULL, 'Poxvirus protein F15', 137, NULL, 'Pox_F15', 255999),
(436906, 'PF02277', NULL, 'Phosphoribosyltransferase', 329, NULL, 'DBI_PRT', 256000),
(436907, 'PF17159', NULL, 'Membrane-associated sensor domain', 226, NULL, 'MASE3', 256001),
(436908, 'PF19565', NULL, 'Family of unknown function (DUF6087)', 99, NULL, 'DUF6087', 256002),
(436909, 'PF16009', NULL, 'Domain of unknown function (DUF4779)', 160, NULL, 'DUF4779', 256003),
(436910, 'PF17263', NULL, 'Family of unknown function (DUF5329)', 95, NULL, 'DUF5329', 256004),
(436911, 'PF20277', NULL, 'C-terminal domain 11 of the ABC-three component (ABC-3C) systems', 140, NULL, 'CTD11', 256005),
(436912, 'PF13911', NULL, 'AhpC/TSA antioxidant enzyme', 113, NULL, 'AhpC-TSA_2', 256006),
(436913, 'PF06796', NULL, 'Periplasmic nitrate reductase protein NapE', 54, NULL, 'NapE', 256007),
(436914, 'PF15455', NULL, 'Proline-rich 19', 363, NULL, 'Pro-rich_19', 256008),
(436915, 'PF04146', NULL, 'YT521-B-like domain', 183, NULL, 'YTH', 256009),
(436916, 'PF02579', NULL, 'Dinitrogenase iron-molybdenum cofactor', 94, NULL, 'Nitro_FeMo-Co', 256010),
(436917, 'PF17133', NULL, 'Domain of unknown function (DUF5108)', 218, NULL, 'DUF5108', 256011),
(436918, 'PF08172', NULL, 'CASP C terminal', 256, NULL, 'CASP_C', 256012),
(436919, 'PF12971', NULL, 'Alpha-N-acetylglucosaminidase (NAGLU) N-terminal domain', 82, NULL, 'NAGLU_N', 256013),
(436920, 'PF05539', NULL, 'Pneumovirinae attachment membrane glycoprotein G', 408, NULL, 'Pneumo_att_G', 256014),
(436921, 'PF18158', NULL, 'Adaptive response protein AidB N-terminal domain', 156, NULL, 'AidB_N', 256015),
(436922, 'PF11606', NULL, 'Family 31 carbohydrate binding protein', 93, NULL, 'AlcCBM31', 256016),
(436923, 'PF06837', NULL, 'Fijivirus P9-2 protein', 207, NULL, 'Fijivirus_P9-2', 256017),
(436924, 'PF12239', NULL, 'Protein of unknown function (DUF3605)', 154, NULL, 'DUF3605', 256018),
(436925, 'PF08588', NULL, 'Protein of unknown function (DUF1769)', 213, NULL, 'DUF1769', 256019),
(436926, 'PF03851', NULL, 'UV-endonuclease UvdE', 276, NULL, 'UvdE', 256020),
(436927, 'PF06093', NULL, 'Spt4/RpoE2 zinc finger', 77, NULL, 'Spt4', 256021),
(436928, 'PF14428', NULL, 'Double-stranded DNA deaminase toxin A', 137, NULL, 'DddA-like', 256022),
(436929, 'PF18178', NULL, 'TIR- and PNP-associating SLOG family', 232, NULL, 'TPALS', 256023),
(436930, 'PF13177', NULL, 'DNA polymerase III, delta subunit', 161, NULL, 'DNA_pol3_delta2', 256024),
(436931, 'PF02202', NULL, 'Tachykinin family', 11, NULL, 'Tachykinin', 256025),
(436932, 'PF08715', NULL, 'Coronavirus papain-like peptidase', 320, NULL, 'CoV_peptidase', 256026),
(436933, 'PF13031', NULL, 'Protein of unknown function (DUF3892)', 76, NULL, 'DUF3892', 256027),
(436934, 'PF07540', NULL, 'Nucleolar complex-associated protein', 92, NULL, 'NOC3p', 256028),
(436935, 'PF15930', NULL, 'Domain of unknown function', 62, NULL, 'YdiH', 256029),
(436936, 'PF06323', NULL, 'Phage antitermination protein Q', 220, NULL, 'Phage_antiter_Q', 256030),
(436937, 'PF13219', NULL, 'Protein of unknown function (DUF4027)', 36, NULL, 'DUF4027', 256031),
(436938, 'PF09272', NULL, 'Hepsin, SRCR domain', 110, NULL, 'Hepsin-SRCR', 256032),
(436939, 'PF18156', NULL, 'pPIWI_RE three-gene island domain Y', 144, NULL, 'pPIWI_RE_Y', 256033),
(436940, 'PF02495', NULL, 'Triple gene block 3', 59, NULL, 'TGBp3', 256034),
(436941, 'PF11587', NULL, 'Major prion protein bPrPp - N terminal', 30, NULL, 'Prion_bPrPp', 256035),
(436942, 'PF05932', NULL, 'Tir chaperone protein (CesT) family', 119, NULL, 'CesT', 256036),
(436943, 'PF12118', NULL, 'SprA-related family', 335, NULL, 'SprA-related', 256037);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(436944, 'PF07444', NULL, 'Ycf66 protein N-terminus', 76, NULL, 'Ycf66_N', 256038),
(436945, 'PF13501', NULL, 'Sulfur oxidation protein SoxY', 112, NULL, 'SoxY', 256039),
(436946, 'PF08277', NULL, 'PAN-like domain', 71, NULL, 'PAN_3', 256040),
(436947, 'PF17586', NULL, 'Family of unknown function (DUF5485)', 56, NULL, 'DUF5485', 256041),
(436948, 'PF06276', NULL, 'Ferric iron reductase FhuF-like transporter', 163, NULL, 'FhuF', 256042),
(436949, 'PF03334', NULL, 'Na+/H+ antiporter subunit', 79, NULL, 'PhaG_MnhG_YufB', 256043),
(436950, 'PF15934', NULL, 'Yuri gagarin', 234, NULL, 'Yuri_gagarin', 256044),
(436951, 'PF12101', NULL, 'Protein of unknown function (DUF3577)', 133, NULL, 'DUF3577', 256045),
(436952, 'PF05959', NULL, 'Nucleopolyhedrovirus protein of unknown function (DUF884)', 188, NULL, 'DUF884', 256046),
(436953, 'PF04158', NULL, 'Sof1-like domain', 87, NULL, 'Sof1', 256047),
(436954, 'PF13077', NULL, 'Protein of unknown function (DUF3909)', 108, NULL, 'DUF3909', 256048),
(436955, 'PF18456', NULL, 'Diiron non-heme beta-hydroxylase N-terminal domain', 232, NULL, 'CmlA_N', 256049),
(436956, 'PF03775', NULL, 'Septum formation inhibitor MinC, C-terminal domain', 102, NULL, 'MinC_C', 256050),
(436957, 'PF08168', NULL, 'NUC205 domain', 44, NULL, 'NUC205', 256051),
(436958, 'PF05270', NULL, 'Alpha-L-arabinofuranosidase B (ABFB) domain', 139, NULL, 'AbfB', 256052),
(436959, 'PF08994', NULL, 'T4 gene Gp59 loader of gp41 DNA helicase C-term', 104, NULL, 'T4_Gp59_C', 256053),
(436960, 'PF04917', NULL, 'Bacterial shufflon protein, N-terminal constant region', 324, NULL, 'Shufflon_N', 256054),
(436961, 'PF11143', NULL, 'Protein of unknown function (DUF2919)', 146, NULL, 'DUF2919', 256055),
(436962, 'PF12254', NULL, 'DNA polymerase alpha subunit p180 N terminal', 66, NULL, 'DNA_pol_alpha_N', 256056),
(436963, 'PF15410', NULL, 'Pleckstrin homology domain', 121, NULL, 'PH_9', 256057),
(436964, 'PF00385', NULL, 'Chromo (CHRromatin Organisation MOdifier) domain', 54, NULL, 'Chromo', 256058),
(436965, 'PF19007', NULL, 'Family of unknown function (DUF5736)', 111, NULL, 'DUF5736', 256059),
(436966, 'PF11085', NULL, 'Conserved membrane protein YqhR', 165, NULL, 'YqhR', 256060),
(436967, 'PF07562', NULL, 'Nine Cysteines Domain of family 3 GPCR', 53, NULL, 'NCD3G', 256061),
(436968, 'PF17010', NULL, 'Domain of unknown function (DUF5092)', 163, NULL, 'DUF5092', 256062),
(436969, 'PF20115', NULL, 'Family of unknown function (DUF6505)', 159, NULL, 'DUF6505', 256063),
(436970, 'PF20501', NULL, 'MBH, subunit E', 98, NULL, 'MbhE', 256064),
(436971, 'PF10956', NULL, 'Protein of unknown function (DUF2756)', 104, NULL, 'DUF2756', 256065),
(436972, 'PF13413', NULL, 'Helix-turn-helix domain', 62, NULL, 'HTH_25', 256066),
(436973, 'PF15662', NULL, 'Spermatogenesis-associated protein 3 family', 192, NULL, 'SPATA3', 256067),
(436974, 'PF16992', NULL, 'DNA-directed RNA polymerase, subunit G', 119, NULL, 'RNA_pol_RpbG', 256068),
(436975, 'PF13644', NULL, 'DKNYY family', 142, NULL, 'DKNYY', 256069),
(436976, 'PF10112', NULL, '5-bromo-4-chloroindolyl phosphate hydrolysis protein', 191, NULL, 'Halogen_Hydrol', 256070),
(436977, 'PF06629', NULL, 'MltA-interacting protein MipA', 212, NULL, 'MipA', 256071),
(436978, 'PF14433', NULL, 'SUKH-3 immunity protein', 143, NULL, 'SUKH-3', 256072),
(436979, 'PF14662', NULL, 'Coiled-coil region of CCDC155 or KASH', 191, NULL, 'KASH_CCD', 256073),
(436980, 'PF01700', NULL, 'Orbivirus VP3 (T2) protein', 888, NULL, 'Orbi_VP3', 256074),
(436981, 'PF06877', NULL, 'Regulator of ribonuclease activity B', 102, NULL, 'RraB', 256075),
(436982, 'PF19465', NULL, 'Family of unknown function (DUF6002)', 447, NULL, 'DUF6002', 256076),
(436983, 'PF02993', NULL, 'Minor capsid protein VI', 225, NULL, 'MCPVI', 256077),
(436984, 'PF04370', NULL, 'Domain of unknown function (DUF508)', 149, NULL, 'DUF508', 256078),
(436985, 'PF02798', NULL, 'Glutathione S-transferase, N-terminal domain', 76, NULL, 'GST_N', 256079),
(436986, 'PF06727', NULL, 'Protein of unknown function (DUF1207)', 342, NULL, 'DUF1207', 256080);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(436987, 'PF15059', NULL, 'Speriolin C-terminus', 148, NULL, 'Speriolin_C', 256081),
(436988, 'PF15281', NULL, 'Consortin C-terminus', 113, NULL, 'Consortin_C', 256082),
(436989, 'PF10480', NULL, 'Beta-1 integrin binding protein', 200, NULL, 'ICAP-1_inte_bdg', 256083),
(436990, 'PF03146', NULL, 'Agrin NtA domain', 116, NULL, 'NtA', 256084),
(436991, 'PF19040', NULL, 'SGNH domain (fused to AT3 domains)', 254, NULL, 'SGNH', 256085),
(436992, 'PF01915', NULL, 'Glycosyl hydrolase family 3 C-terminal domain', 204, NULL, 'Glyco_hydro_3_C', 256086),
(436993, 'PF07334', NULL, 'Interferon-induced 35 kDa protein (IFP 35) N-terminus', 76, NULL, 'IFP_35_N', 256087),
(436994, 'PF09467', NULL, 'Hypothetical protein Yopt', 71, NULL, 'Yopt', 256088),
(436995, 'PF14132', NULL, 'Domain of unknown function (DUF4299)', 301, NULL, 'DUF4299', 256089),
(436996, 'PF09558', NULL, 'Protein of unknown function (DUF2375)', 69, NULL, 'DUF2375', 256090),
(436997, 'PF15190', NULL, 'Transmembrane protein 251', 128, NULL, 'TMEM251', 256091),
(436998, 'PF07340', NULL, 'Cytomegalovirus IE1 protein', 391, NULL, 'Herpes_IE1', 256092),
(436999, 'PF03762', NULL, 'Vitelline membrane outer layer protein I (VOMI)', 167, NULL, 'VOMI', 256093),
(437000, 'PF13625', NULL, 'Helicase conserved C-terminal domain', 128, NULL, 'Helicase_C_3', 256094),
(437001, 'PF18186', NULL, 'SMODS and SLOG-associating 2TM effector domain family 4', 165, NULL, 'SLATT_4', 256095),
(437002, 'PF05731', NULL, 'TROVE domain', 449, NULL, 'TROVE', 256096),
(437003, 'PF04580', NULL, 'Chordopoxvirinae D3 protein', 248, NULL, 'Pox_D3', 256097),
(437004, 'PF08042', NULL, 'PqqA family', 19, NULL, 'PqqA', 256098),
(437005, 'PF13268', NULL, 'Protein of unknown function (DUF4059)', 72, NULL, 'DUF4059', 256099),
(437006, 'PF01278', NULL, 'Omptin family', 283, NULL, 'Omptin', 256100),
(437007, 'PF01801', NULL, 'Cytomegalovirus glycoprotein L', 211, NULL, 'Cytomega_gL', 256101),
(437008, 'PF03214', NULL, 'Reversibly glycosylated polypeptide', 342, NULL, 'RGP', 256102),
(437009, 'PF05674', NULL, 'Baculovirus protein of unknown function (DUF816)', 172, NULL, 'DUF816', 256103),
(437010, 'PF17919', NULL, 'RNase H-like domain found in reverse transcriptase', 100, NULL, 'RT_RNaseH_2', 256104),
(437011, 'PF15136', NULL, 'Uncharacterised protein family UPF0449', 100, NULL, 'UPF0449', 256105),
(437012, 'PF03965', NULL, 'Penicillinase repressor', 115, NULL, 'Penicillinase_R', 256106),
(437013, 'PF07943', NULL, 'Penicillin-binding protein 5, C-terminal domain', 91, NULL, 'PBP5_C', 256107),
(437014, 'PF07308', NULL, 'Protein of unknown function (DUF1456)', 68, NULL, 'DUF1456', 256108),
(437015, 'PF09238', NULL, 'Interleukin-4 receptor alpha chain, N-terminal', 94, NULL, 'IL4Ra_N', 256109),
(437016, 'PF18628', NULL, 'Viral coat protein P2 N-terminal domain', 127, NULL, 'P2_N', 256110),
(437017, 'PF04239', NULL, 'Protein of unknown function (DUF421)', 109, NULL, 'DUF421', 256111),
(437018, 'PF18911', NULL, 'PKD domain', 85, NULL, 'PKD_4', 256112),
(437019, 'PF15023', NULL, 'Protein of unknown function (DUF4523)', 166, NULL, 'DUF4523', 256113),
(437020, 'PF14090', NULL, 'Helix-turn-helix domain', 70, NULL, 'HTH_39', 256114),
(437021, 'PF09631', NULL, 'Sen15 protein', 101, NULL, 'Sen15', 256115),
(437022, 'PF05063', NULL, 'MT-A70', 172, NULL, 'MT-A70', 256116),
(437023, 'PF11851', NULL, 'Domain of unknown function (DUF3371)', 126, NULL, 'DUF3371', 256117),
(437024, 'PF04003', NULL, 'Dip2/Utp12 Family', 107, NULL, 'Utp12', 256118),
(437025, 'PF05538', NULL, 'Campylobacter major outer membrane protein', 421, NULL, 'Campylo_MOMP', 256119),
(437026, 'PF11896', NULL, 'Alpha-1,4-glucan:maltose-1-phosphate maltosyltransferase, domain N/S', 179, NULL, 'GlgE_dom_N_S', 256120),
(437027, 'PF05479', NULL, 'Photosystem I reaction centre subunit N (PSAN or PSI-N)', 132, NULL, 'PsaN', 256121),
(437028, 'PF01183', NULL, 'Glycosyl hydrolases family 25', 181, NULL, 'Glyco_hydro_25', 256122),
(437029, 'PF14700', NULL, 'DNA-directed RNA polymerase N-terminal', 335, NULL, 'RPOL_N', 256123),
(437030, 'PF16334', NULL, 'Domain of unknown function (DUF4964)', 88, NULL, 'DUF4964', 256124);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(437031, 'PF13577', NULL, 'SnoaL-like domain', 126, NULL, 'SnoaL_4', 256125),
(437032, 'PF06525', NULL, 'Sulfocyanin (SoxE) domain', 149, NULL, 'SoxE', 256126),
(437033, 'PF09210', NULL, '1,4-alpha-glucan branching enzyme, C-terminal', 101, NULL, 'BE_C', 256127),
(437034, 'PF00038', NULL, 'Intermediate filament protein', 312, NULL, 'Filament', 256128),
(437035, 'PF16788', NULL, 'ATF-interacting protein binding domain', 220, NULL, 'ATF7IP_BD', 256129),
(437036, 'PF03730', NULL, 'Ku70/Ku80 C-terminal arm', 91, NULL, 'Ku_C', 256130),
(437037, 'PF17482', NULL, 'Phage tail sheath C-terminal domain', 104, NULL, 'Phage_sheath_1C', 256131),
(437038, 'PF07348', NULL, 'Syd protein (SUKH-2)', 175, NULL, 'Syd', 256132),
(437039, 'PF12146', NULL, 'Serine aminopeptidase, S33', 239, NULL, 'Hydrolase_4', 256133),
(437040, 'PF16403', NULL, 'Domain of unknown function (DUF5011)', 71, NULL, 'DUF5011', 256134),
(437041, 'PF14559', NULL, 'Tetratricopeptide repeat', 68, NULL, 'TPR_19', 256135),
(437042, 'PF07286', NULL, 'D-glutamate cyclase', 143, NULL, 'D-Glu_cyclase', 256136),
(437043, 'PF16876', NULL, 'Lipin/Ned1/Smp2 multi-domain protein middle domain', 100, NULL, 'Lipin_mid', 256137),
(437044, 'PF20479', NULL, 'TMEM128 protein', 124, NULL, 'TMEM128', 256138),
(437045, 'PF02008', NULL, 'CXXC zinc finger domain', 48, NULL, 'zf-CXXC', 256139),
(437046, 'PF08043', NULL, 'Xin repeat', 16, NULL, 'Xin', 256140),
(437047, 'PF03644', NULL, 'Glycosyl hydrolase family 85', 304, NULL, 'Glyco_hydro_85', 256141),
(437048, 'PF05055', NULL, 'Protein of unknown function (DUF677)', 336, NULL, 'DUF677', 256142),
(437049, 'PF01762', NULL, 'Galactosyltransferase', 195, NULL, 'Galactosyl_T', 256143),
(437050, 'PF07437', NULL, 'YfaZ precursor', 180, NULL, 'YfaZ', 256144),
(437051, 'PF12031', NULL, 'SWI/SNF-like complex subunit BAF250/Osa', 256, NULL, 'BAF250_C', 256145),
(437052, 'PF03904', NULL, 'Domain of unknown function (DUF334)', 121, NULL, 'DUF334', 256146),
(437053, 'PF16056', NULL, 'Domain of unknown function (DUF4799)', 375, NULL, 'DUF4799', 256147),
(437054, 'PF09836', NULL, 'Putative DNA-binding domain', 83, NULL, 'DUF2063', 256148),
(437055, 'PF04461', NULL, 'Protein of unknown function (DUF520)', 161, NULL, 'DUF520', 256149),
(437056, 'PF15509', NULL, 'Domain of unknown function (DUF4650)', 519, NULL, 'DUF4650', 256150),
(437057, 'PF06109', NULL, 'Haemolysin E (HlyE)', 309, NULL, 'HlyE', 256151),
(437058, 'PF06401', NULL, 'Alpha-2-macroglobulin RAP, C-terminal domain', 212, NULL, 'Alpha-2-MRAP_C', 256152),
(437059, 'PF14306', NULL, 'PUA-like domain', 158, NULL, 'PUA_2', 256153),
(437060, 'PF09532', NULL, 'FDF domain', 104, NULL, 'FDF', 256154),
(437061, 'PF16206', NULL, 'C-terminal region of Mon2 protein', 785, NULL, 'Mon2_C', 256155),
(437062, 'PF04188', NULL, 'Mannosyltransferase (PIG-V)', 443, NULL, 'Mannosyl_trans2', 256156),
(437063, 'PF12954', NULL, 'Protein of unknown function (DUF3843)', 410, NULL, 'DUF3843', 256157),
(437064, 'PF09042', NULL, 'Titin Z', 43, NULL, 'Titin_Z', 256158),
(437065, 'PF06096', NULL, 'Baculoviridae 8.2 KDa protein', 65, NULL, 'Baculo_8kDa', 256159),
(437066, 'PF17820', NULL, 'PDZ domain', 54, NULL, 'PDZ_6', 256160),
(437067, 'PF19423', NULL, 'E3 ubiquitin-protein ligase UBR4 N-terminal', 1594, NULL, 'E3_UBR4_N', 256161),
(437068, 'PF19206', NULL, 'Family of unknown function (DUF5878)', 148, NULL, 'DUF5878', 256162),
(437069, 'PF07680', NULL, 'TQO small subunit DoxA', 131, NULL, 'DoxA', 256163),
(437070, 'PF18522', NULL, 'Domain of unknown function (DUF5620)', 126, NULL, 'DUF5620', 256164),
(437071, 'PF06170', NULL, 'Protein of unknown function (DUF983)', 85, NULL, 'DUF983', 256165),
(437072, 'PF08937', NULL, 'MTH538 TIR-like domain (DUF1863)', 130, NULL, 'DUF1863', 256166),
(437073, 'PF11029', NULL, 'DAZ associated protein 2 (DAZAP2)', 133, NULL, 'DAZAP2', 256167),
(437074, 'PF02463', NULL, 'RecF/RecN/SMC N terminal domain', 220, NULL, 'SMC_N', 256168),
(437075, 'PF11476', NULL, 'Toxoplasma gondii micronemal protein 1 TgMIC1', 137, NULL, 'TgMIC1', 256169),
(437076, 'PF11594', NULL, 'Mediator complex subunit 28', 102, NULL, 'Med28', 256170);
INSERT INTO "PUBLIC"."MODEL" VALUES
(437077, 'PF03247', NULL, 'Prothymosin/parathymosin family', 112, NULL, 'Prothymosin', 256171),
(437078, 'PF02796', NULL, 'Helix-turn-helix domain of resolvase', 45, NULL, 'HTH_7', 256172),
(437079, 'PF10323', NULL, 'Serpentine type 7TM GPCR chemoreceptor Srv', 283, NULL, '7TM_GPCR_Srv', 256173),
(437080, 'PF00101', NULL, 'Ribulose bisphosphate carboxylase, small chain', 97, NULL, 'RuBisCO_small', 256174),
(437081, 'PF06578', NULL, 'YOP proteins translocation protein K (YscK)', 209, NULL, 'YscK', 256175),
(437082, 'PF09605', NULL, 'Hypothetical bacterial integral membrane protein (Trep_Strep)', 185, NULL, 'Trep_Strep', 256176),
(437083, 'PF03038', NULL, 'UL95 family', 322, NULL, 'Herpes_UL95', 256177),
(437084, 'PF07289', NULL, 'Bardet-Biedl syndrome 5 protein', 334, NULL, 'BBL5', 256178),
(437085, 'PF16236', NULL, 'Domain of unknown function (DUF4895)', 221, NULL, 'DUF4895', 256179),
(437086, 'PF10334', NULL, 'Aromatic acid exporter family member 2', 229, NULL, 'ArAE_2', 256180),
(437087, 'PF12159', NULL, 'Protein of unknown function (DUF3593)', 88, NULL, 'DUF3593', 256181),
(437088, 'PF11245', NULL, 'Protein of unknown function (DUF2544)', 246, NULL, 'DUF2544', 256182),
(437089, 'PF11910', NULL, 'Cyanobacterial and plant NDH-1 subunit O', 67, NULL, 'NdhO', 256183),
(437090, 'PF20481', NULL, 'Domain of unknown function (DUF6721)', 96, NULL, 'DUF6721', 256184),
(437091, 'PF14308', NULL, 'X-domain of DnaJ-containing', 209, NULL, 'DnaJ-X', 256185),
(437092, 'PF10339', NULL, 'Yeast-specific zinc responsive', 202, NULL, 'Vel1p', 256186),
(437093, 'PF17067', NULL, 'Ribosomal protein S31e', 99, NULL, 'RPS31', 256187),
(437094, 'PF08629', NULL, 'PDE8 phosphodiesterase', 52, NULL, 'PDE8', 256188),
(437095, 'PF07430', NULL, 'Phloem filament protein PP1 cystatin-like domain', 78, NULL, 'PP1', 256189),
(437096, 'PF06623', NULL, 'MHC_I C-terminus', 28, NULL, 'MHC_I_C', 256190),
(437097, 'PF16913', NULL, 'Purine nucleobase transmembrane transport', 322, NULL, 'PUNUT', 256191),
(437098, 'PF19701', NULL, 'Family of unknown function (DUF6199)', 50, NULL, 'DUF6199', 256192),
(437099, 'PF18203', NULL, 'IPTL-CTERM motif', 28, NULL, 'IPTL-CTERM', 256193),
(437100, 'PF17253', NULL, 'Family of unknown function (DUF5320)', 100, NULL, 'DUF5320', 256194),
(437101, 'PF13327', NULL, 'Type III secretion system subunit', 162, NULL, 'T3SS_LEE_assoc', 256195),
(437102, 'PF18470', NULL, 'Cas9 alpha-helical lobe domain', 223, NULL, 'Cas9_a', 256196),
(437103, 'PF15208', NULL, 'Rab15 effector', 240, NULL, 'Rab15_effector', 256197),
(437104, 'PF02260', NULL, 'FATC domain', 32, NULL, 'FATC', 256198),
(437105, 'PF11697', NULL, 'Protein of unknown function (DUF3293)', 73, NULL, 'DUF3293', 256199),
(437106, 'PF11514', NULL, 'Protein of unknown function (DUF3219)', 94, NULL, 'DUF3219', 256200),
(437107, 'PF17778', NULL, 'Beta-lactamase associated winged helix domain', 47, NULL, 'BLACT_WH', 256201),
(437108, 'PF07694', NULL, '5TMR of 5TMR-LYT', 168, NULL, '5TM-5TMR_LYT', 256202),
(437109, 'PF11202', NULL, 'Phosphoribosyl transferase (PRTase)', 246, NULL, 'PRTase_1', 256203),
(437110, 'PF10531', NULL, 'SLBB domain', 58, NULL, 'SLBB', 256204),
(437111, 'PF16387', NULL, 'Domain of unknown function', 102, NULL, 'DUF4996', 256205),
(437112, 'PF01138', NULL, '3'' exoribonuclease family, domain 1', 132, NULL, 'RNase_PH', 256206),
(437113, 'PF07034', NULL, 'Origin recognition complex (ORC) subunit 3 N-terminus', 333, NULL, 'ORC3_N', 256207),
(437114, 'PF12102', NULL, 'MrcB-like, N-terminal domain', 183, NULL, 'MrcB_N', 256208),
(437115, 'PF09321', NULL, 'Domain of unknown function (DUF1978)', 244, NULL, 'DUF1978', 256209),
(437116, 'PF00342', NULL, 'Phosphoglucose isomerase', 486, NULL, 'PGI', 256210),
(437117, 'PF01671', NULL, 'African swine fever virus multigene family 360 protein', 215, NULL, 'ASFV_360', 256211),
(437118, 'PF15720', NULL, 'Domain of unknown function (DUF4675)', 198, NULL, 'DUF4675', 256212),
(437119, 'PF10681', NULL, 'Chaperone for protein-folding within the ER, fungal', 209, NULL, 'Rot1', 256213),
(437120, 'PF11873', NULL, 'Membrane-bound lytic murein transglycosylase C, N-terminal domain', 168, NULL, 'Mltc_N', 256214);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(437121, 'PF05268', NULL, 'Phage tail fibre adhesin Gp38', 260, NULL, 'GP38', 256215),
(437122, 'PF12687', NULL, 'Protein of unknown function (DUF3801)', 182, NULL, 'DUF3801', 256216),
(437123, 'PF10250', NULL, 'GDP-fucose protein O-fucosyltransferase', 328, NULL, 'O-FucT', 256217),
(437124, 'PF11650', NULL, 'P22 tail accessory factor', 164, NULL, 'P22_Tail-4', 256218),
(437125, 'PF00463', NULL, 'Isocitrate lyase family', 526, NULL, 'ICL', 256219),
(437126, 'PF05686', NULL, 'Glycosyl transferase family 90', 396, NULL, 'Glyco_transf_90', 256220),
(437127, 'PF12487', NULL, 'Protein of unknown function (DUF3703)', 109, NULL, 'DUF3703', 256221),
(437128, 'PF15122', NULL, 'TMEM206 protein family', 296, NULL, 'TMEM206', 256222),
(437129, 'PF17267', NULL, 'Family of unknown function (DUF5333)', 110, NULL, 'DUF5333', 256223),
(437130, 'PF06368', NULL, 'Methylaspartate mutase E chain (MutE)', 441, NULL, 'Met_asp_mut_E', 256224),
(437131, 'PF07063', NULL, 'Domain of unknown function (DUF1338)', 325, NULL, 'DUF1338', 256225),
(437132, 'PF10291', NULL, 'Muniscin C-terminal mu homology domain', 263, NULL, 'muHD', 256226),
(437133, 'PF05470', NULL, 'Eukaryotic translation initiation factor 3 subunit 8 N-terminus', 593, NULL, 'eIF-3c_N', 256227),
(437134, 'PF10206', NULL, 'Mitochondrial F1F0-ATP synthase, subunit f', 102, NULL, 'WRW', 256228),
(437135, 'PF05735', NULL, 'Thrombospondin C-terminal region', 198, NULL, 'TSP_C', 256229),
(437136, 'PF02156', NULL, 'Glycosyl hydrolase family 26', 311, NULL, 'Glyco_hydro_26', 256230),
(437137, 'PF11480', NULL, 'Colicin-E5 Imm protein', 82, NULL, 'ImmE5', 256231),
(437138, 'PF01871', NULL, 'AMMECR1', 167, NULL, 'AMMECR1', 256232),
(437139, 'PF03398', NULL, 'Regulator of Vps4 activity in the MVB pathway', 164, NULL, 'Ist1', 256233),
(437140, 'PF11316', NULL, 'Putative rhamnosyl transferase', 235, NULL, 'Rhamno_transf', 256234),
(437141, 'PF11567', NULL, 'Plasmodium falciparum UIS3 membrane protein', 101, NULL, 'PfUIS3', 256235),
(437142, 'PF00092', NULL, 'von Willebrand factor type A domain', 175, NULL, 'VWA', 256236),
(437143, 'PF06338', NULL, 'ComK protein', 152, NULL, 'ComK', 256237),
(437144, 'PF16424', NULL, 'Domain of unknown function (DUF5021)', 157, NULL, 'DUF5021', 256238),
(437145, 'PF05935', NULL, 'Arylsulfotransferase (ASST)', 381, NULL, 'Arylsulfotrans', 256239),
(437146, 'PF11712', NULL, 'Endoplasmic reticulum-based factor for assembly of V-ATPase', 139, NULL, 'Vma12', 256240),
(437147, 'PF18735', NULL, 'RiboL-PSP-HEPN', 193, NULL, 'HEPN_RiboL-PSP', 256241),
(437148, 'PF06369', NULL, 'Sea anemone cytotoxic protein', 176, NULL, 'Anemone_cytotox', 256242),
(437149, 'PF19901', NULL, 'Family of unknown function (DUF6374)', 59, NULL, 'DUF6374', 256243),
(437150, 'PF11769', NULL, 'Protein of unknown function (DUF3313)', 185, NULL, 'DUF3313', 256244),
(437151, 'PF13657', NULL, 'HipA N-terminal domain', 99, NULL, 'Couple_hipA', 256245),
(437152, 'PF15690', NULL, 'Nuclear receptor-interacting protein 1 repression 4', 313, NULL, 'NRIP1_repr_4', 256246),
(437153, 'PF08017', NULL, 'Fibrinogen binding protein', 393, NULL, 'Fibrinogen_BP', 256247),
(437154, 'PF15838', NULL, 'LLLL and CFNLAS motif-containing protein 1', 72, NULL, 'LLCFC1', 256248),
(437155, 'PF18952', NULL, 'Family of unknown function (DUF5696)', 610, NULL, 'DUF5696', 256249),
(437156, 'PF16798', NULL, 'Domain of unknown function (DUF5069)', 133, NULL, 'DUF5069', 256250),
(437157, 'PF11132', NULL, 'Transcriptional regulator protein (SplA)', 74, NULL, 'SplA', 256251),
(437158, 'PF18968', NULL, 'Family of unknown function (DUF5707)', 98, NULL, 'DUF5707', 256252),
(437159, 'PF12963', NULL, 'Protein of unknown function (DUF3852)', 108, NULL, 'DUF3852', 256253),
(437160, 'PF00697', NULL, 'N-(5''phosphoribosyl)anthranilate (PRA) isomerase', 193, NULL, 'PRAI', 256254),
(437161, 'PF03457', NULL, 'Helicase associated domain', 63, NULL, 'HA', 256255),
(437162, 'PF10674', NULL, 'Protein of unknown function (DUF2488)', 92, NULL, 'Ycf54', 256256),
(437163, 'PF01321', NULL, 'Creatinase/Prolidase N-terminal domain', 130, NULL, 'Creatinase_N', 256257);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(437164, 'PF18654', NULL, 'LegC3 N-terminal coiled-coil domain', 297, NULL, 'LegC3_N', 256258),
(437165, 'PF19945', NULL, 'Family of unknown function (DUF6407)', 96, NULL, 'DUF6407', 256259),
(437166, 'PF19801', NULL, 'Family of unknown function (DUF6284)', 86, NULL, 'DUF6284', 256260),
(437167, 'PF19971', NULL, 'Ternary complex associated domain 2', 90, NULL, 'TCAD2', 256261),
(437168, 'PF09022', NULL, 'Staphostatin A', 105, NULL, 'Staphostatin_A', 256262),
(437169, 'PF03162', NULL, 'Tyrosine phosphatase family', 165, NULL, 'Y_phosphatase2', 256263),
(437170, 'PF12610', NULL, 'Suppressor of cytokine signalling', 58, NULL, 'SOCS', 256264),
(437171, 'PF09095', NULL, 'Alpha-amylase/4-alpha-glucanotransferase, C-terminal', 284, NULL, 'AmyA-gluTrfs_C', 256265),
(437172, 'PF07934', NULL, '8-oxoguanine DNA glycosylase, N-terminal domain', 121, NULL, 'OGG_N', 256266),
(437173, 'PF13557', NULL, 'Putative MetA-pathway of phenol degradation', 241, NULL, 'Phenol_MetA_deg', 256267),
(437174, 'PF11170', NULL, 'Protein of unknown function (DUF2957)', 359, NULL, 'DUF2957', 256268),
(437175, 'PF15834', NULL, 'Testis highly expressed protein 4', 201, NULL, 'THEG4', 256269),
(437176, 'PF19961', NULL, 'Effector-associated domain 8', 96, NULL, 'EAD8', 256270),
(437177, 'PF19304', NULL, 'D-3-phosphoglycerate dehydrogenase intervening domain', 119, NULL, 'PGDH_inter', 256271),
(437178, 'PF02082', NULL, 'Iron-dependent Transcriptional regulator', 132, NULL, 'Rrf2', 256272),
(437179, 'PF19714', NULL, 'Family of unknown function (DUF6209)', 240, NULL, 'DUF6209', 256273),
(437180, 'PF15807', NULL, 'Membrane-associated protein 117 kDa, PDZK1-interacting protein 1', 122, NULL, 'MAP17', 256274),
(437181, 'PF05194', NULL, 'UreE urease accessory protein, C-terminal domain', 87, NULL, 'UreE_C', 256275),
(437182, 'PF15664', NULL, 'Transmembrane protein 252 family', 139, NULL, 'TMEM252', 256276),
(437183, 'PF16066', NULL, 'Domain of unknown function (DUF4808)', 121, NULL, 'DUF4808', 256277),
(437184, 'PF09623', NULL, 'CRISPR-associated protein NE0113 (Cas_NE0113)', 209, NULL, 'Cas_NE0113', 256278),
(437185, 'PF11081', NULL, 'Adenovirus L4-33K/L4-22K', 168, NULL, 'Adeno_L433K_22K', 256279),
(437186, 'PF17825', NULL, 'Family of unknown function (DUF5587)', 1445, NULL, 'DUF5587', 256280),
(437187, 'PF08070', NULL, 'DTHCT (NUC029) region', 102, NULL, 'DTHCT', 256281),
(437188, 'PF19177', NULL, 'Family of unknown function (DUF5859)', 162, NULL, 'DUF5859', 256282),
(437189, 'PF00643', NULL, 'B-box zinc finger', 42, NULL, 'zf-B_box', 256283),
(437190, 'PF17332', NULL, 'Family of unknown function (DUF5592)', 89, NULL, 'DUF5592', 256284),
(437191, 'PF09636', NULL, 'XkdW protein', 108, NULL, 'XkdW', 256285),
(437192, 'PF05541', NULL, 'Entomopoxvirus spheroidin protein', 944, NULL, 'Spheroidin', 256286),
(437193, 'PF12899', NULL, 'Alkaline and neutral invertase', 435, NULL, 'Glyco_hydro_100', 256287),
(437194, 'PF01817', NULL, 'Chorismate mutase type II', 75, NULL, 'CM_2', 256288),
(437195, 'PF19674', NULL, 'Family of unknown function (DUF6177)', 330, NULL, 'DUF6177', 256289),
(437196, 'PF06937', NULL, 'EURL protein', 283, NULL, 'EURL', 256290),
(437197, 'PF08435', NULL, 'Calicivirus coat protein C-terminal', 230, NULL, 'Calici_coat_C', 256291),
(437198, 'PF06004', NULL, 'Bacterial protein of unknown function (DUF903)', 49, NULL, 'DUF903', 256292),
(437199, 'PF00601', NULL, 'Influenza non-structural protein (NS2)', 94, NULL, 'Flu_NS2', 256293),
(437200, 'PF04118', NULL, 'Dopey, N-terminal', 309, NULL, 'Dopey_N', 256294),
(437201, 'PF19028', NULL, 'Spondin-like TSP1 domain', 53, NULL, 'TSP1_spondin', 256295),
(437202, 'PF20522', NULL, 'Domain of unknown function (DUF6737)', 57, NULL, 'DUF6737', 256296),
(437203, 'PF15014', NULL, 'Ceroid-lipofuscinosis neuronal protein 5', 302, NULL, 'CLN5', 256297),
(437204, 'PF09281', NULL, 'Taq polymerase, exonuclease', 132, NULL, 'Taq-exonuc', 256298),
(437205, 'PF16779', NULL, 'DNA-mimic protein', 115, NULL, 'DMP12', 256299),
(437206, 'PF20124', NULL, 'Family of unknown function (DUF6514)', 94, NULL, 'DUF6514', 256300);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(437207, 'PF05453', NULL, 'BmTXKS1/BmP02 toxin family', 28, NULL, 'Toxin_6', 256301),
(437208, 'PF05557', NULL, 'Mitotic checkpoint protein', 661, NULL, 'MAD', 256302),
(437209, 'PF16364', NULL, 'Cell surface antigen C-terminus', 171, NULL, 'Antigen_C', 256303),
(437210, 'PF16518', NULL, 'T3SS negative regulator,GrlR', 112, NULL, 'GrlR', 256304),
(437211, 'PF02637', NULL, 'GatB domain', 148, NULL, 'GatB_Yqey', 256305),
(437212, 'PF07590', NULL, 'Protein of unknown function (DUF1556)', 82, NULL, 'DUF1556', 256306),
(437213, 'PF14062', NULL, 'Domain of unknown function (DUF4253)', 109, NULL, 'DUF4253', 256307),
(437214, 'PF06643', NULL, 'Protein of unknown function (DUF1158)', 79, NULL, 'DUF1158', 256308),
(437215, 'PF06810', NULL, 'Phage minor structural protein GP20', 149, NULL, 'Phage_GP20', 256309),
(437216, 'PF19827', NULL, 'Family of unknown function (DUF6308)', 193, NULL, 'DUF6308', 256310),
(437217, 'PF17570', NULL, 'Bacteriophage T7-like, protein 6.7', 62, NULL, 'T7-like_gp67', 256311),
(437218, 'PF14905', NULL, 'Outer membrane protein beta-barrel family', 408, NULL, 'OMP_b-brl_3', 256312),
(437219, 'PF17467', NULL, 'Viral Protein E7', 60, NULL, 'E7R', 256313),
(437220, 'PF04675', NULL, 'DNA ligase N terminus', 173, NULL, 'DNA_ligase_A_N', 256314),
(437221, 'PF18426', NULL, 'Tle cognate immunity protein 4 C-terminal domain', 161, NULL, 'Tli4_C', 256315),
(437222, 'PF03999', NULL, 'Microtubule associated protein (MAP65/ASE1 family)', 477, NULL, 'MAP65_ASE1', 256316),
(437223, 'PF12596', NULL, '87kDa Transposase', 106, NULL, 'Tnp_P_element_C', 256317),
(437224, 'PF06237', NULL, 'Protein of unknown function (DUF1011)', 99, NULL, 'DUF1011', 256318),
(437225, 'PF01678', NULL, 'Diaminopimelate epimerase', 121, NULL, 'DAP_epimerase', 256319),
(437226, 'PF11709', NULL, 'Mitochondrial ribosomal protein subunit', 366, NULL, 'Mit_ribos_Mrp51', 256320),
(437227, 'PF16726', NULL, 'Inositol polyphosphate 5-phosphatase clathrin binding domain', 101, NULL, 'OCRL_clath_bd', 256321),
(437228, 'PF20473', NULL, 'MmeI, DNA-methyltransferase domain', 257, NULL, 'MmeI_Mtase', 256322),
(437229, 'PF02205', NULL, 'WH2 motif', 30, NULL, 'WH2', 256323),
(437230, 'PF12788', NULL, 'YmaF family', 97, NULL, 'YmaF', 256324),
(437231, 'PF15101', NULL, 'Telomere-associated protein TERB2', 207, NULL, 'TERB2', 256325),
(437232, 'PF01273', NULL, 'LBP / BPI / CETP family, N-terminal domain', 164, NULL, 'LBP_BPI_CETP', 256326),
(437233, 'PF07973', NULL, 'Threonyl and Alanyl tRNA synthetase second additional domain', 44, NULL, 'tRNA_SAD', 256327),
(437234, 'PF15318', NULL, 'Putative Bcl-2 like protein of testis', 192, NULL, 'Bclt', 256328),
(437235, 'PF10810', NULL, 'Protein of unknown function (DUF2545)', 80, NULL, 'DUF2545', 256329),
(437236, 'PF14347', NULL, 'Domain of unknown function (DUF4399)', 91, NULL, 'DUF4399', 256330),
(437237, 'PF08868', NULL, 'YugN-like family', 130, NULL, 'YugN', 256331),
(437238, 'PF09559', NULL, 'Cas6 Crispr', 196, NULL, 'Cas6', 256332),
(437239, 'PF18624', NULL, 'CDI immunity protein', 101, NULL, 'CdiI_4', 256333),
(437240, 'PF11920', NULL, 'Protein of unknown function (DUF3438)', 288, NULL, 'DUF3438', 256334),
(437241, 'PF18432', NULL, 'Extracellular Cadherin domain', 110, NULL, 'ECD', 256335),
(437242, 'PF17217', NULL, 'UPA domain', 140, NULL, 'UPA', 256336),
(437243, 'PF12273', NULL, 'Chitin synthesis regulation, resistance to Congo red', 119, NULL, 'RCR', 256337),
(437244, 'PF04102', NULL, 'SlyX', 67, NULL, 'SlyX', 256338),
(437245, 'PF05498', NULL, 'Rapid ALkalinization Factor (RALF)', 65, NULL, 'RALF', 256339),
(437246, 'PF06055', NULL, 'Exopolysaccharide synthesis, ExoD', 180, NULL, 'ExoD', 256340),
(437247, 'PF18561', NULL, 'Endoribonuclease Regnase 1/ ZC3H12 C-terminal domain', 46, NULL, 'Regnase_1_C', 256341),
(437248, 'PF19016', NULL, 'Domain of unknown function (DUF5745)', 58, NULL, 'DUF5745', 256342),
(437249, 'PF11027', NULL, 'Protein of unknown function (DUF2615)', 106, NULL, 'DUF2615', 256343),
(437250, 'PF00593', NULL, 'TonB dependent receptor', 470, NULL, 'TonB_dep_Rec', 256344);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(437251, 'PF10443', NULL, 'RNA12 protein', 444, NULL, 'RNA12', 256345),
(437252, 'PF10991', NULL, 'Protein of unknown function (DUF2815)', 173, NULL, 'DUF2815', 256346),
(437253, 'PF19708', NULL, 'Family of unknown function (DUF6205)', 141, NULL, 'DUF6205', 256347),
(437254, 'PF04030', NULL, 'D-arabinono-1,4-lactone oxidase', 264, NULL, 'ALO', 256348),
(437255, 'PF04948', NULL, 'Poxvirus A51 protein', 337, NULL, 'Pox_A51', 256349),
(437256, 'PF06120', NULL, 'Tail length tape measure protein', 295, NULL, 'Phage_HK97_TLTM', 256350),
(437257, 'PF06301', NULL, 'Bacteriophage lambda Kil protein', 42, NULL, 'Lambda_Kil', 256351),
(437258, 'PF03092', NULL, 'BT1 family', 524, NULL, 'BT1', 256352),
(437259, 'PF20603', NULL, 'Bacterial hydrolase', 160, NULL, 'Bact_hydrolase', 256353),
(437260, 'PF17594', NULL, 'Phage Tail fiber assembly helper gene product 57', 75, NULL, 'GP57', 256354),
(437261, 'PF12575', NULL, 'Poxvirus entry protein complex L1 and I2', 72, NULL, 'Pox_EPC_I2-L1', 256355),
(437262, 'PF18196', NULL, 'Chromodomain helicase DNA-binding domain 1', 120, NULL, 'Cdh1_DBD_1', 256356),
(437263, 'PF00994', NULL, 'Probable molybdopterin binding domain', 144, NULL, 'MoCF_biosynth', 256357),
(437264, 'PF08253', NULL, 'Erm Leader peptide', 19, NULL, 'Leader_Erm', 256358),
(437265, 'PF14566', NULL, 'Inositol hexakisphosphate', 156, NULL, 'PTPlike_phytase', 256359),
(437266, 'PF12243', NULL, 'CTD kinase subunit gamma CTK3', 123, NULL, 'CTK3', 256360),
(437267, 'PF03687', NULL, 'Uncharacterised protein family (UPF0164)', 325, NULL, 'UPF0164', 256361),
(437268, 'PF11531', NULL, 'Coactivator-associated arginine methyltransferase 1 N terminal', 112, NULL, 'CARM1', 256362),
(437269, 'PF13536', NULL, 'Putative multidrug resistance efflux transporter', 258, NULL, 'EmrE', 256363),
(437270, 'PF13983', NULL, 'YsaB-like lipoprotein', 75, NULL, 'YsaB', 256364),
(437271, 'PF16032', NULL, 'Domain of unknown function (DUF4788)', 229, NULL, 'DUF4788', 256365),
(437272, 'PF03028', NULL, 'Dynein heavy chain region D6 P-loop domain', 115, NULL, 'Dynein_heavy', 256366),
(437273, 'PF03977', NULL, 'Na+-transporting oxaloacetate decarboxylase beta subunit', 349, NULL, 'OAD_beta', 256367),
(437274, 'PF16468', NULL, 'Domain of unknown function (DUF5049)', 57, NULL, 'DUF5049', 256368),
(437275, 'PF19188', NULL, 'Adhesion GPCR B N-terminal region', 177, NULL, 'AGRB_N', 256369),
(437276, 'PF04022', NULL, 'Staphylocoagulase repeat', 27, NULL, 'Staphylcoagulse', 256370),
(437277, 'PF00152', NULL, 'tRNA synthetases class II (D, K and N)', 314, NULL, 'tRNA-synt_2', 256371),
(437278, 'PF06384', NULL, 'Beta-catenin-interacting protein ICAT', 76, NULL, 'ICAT', 256372),
(437279, 'PF11816', NULL, 'Domain of unknown function (DUF3337)', 172, NULL, 'DUF3337', 256373),
(437280, 'PF08029', NULL, 'HisG, C-terminal domain', 73, NULL, 'HisG_C', 256374),
(437281, 'PF08702', NULL, 'Fibrinogen alpha/beta chain family', 143, NULL, 'Fib_alpha', 256375),
(437282, 'PF02085', NULL, 'Class III cytochrome C family', 102, NULL, 'Cytochrom_CIII', 256376),
(437283, 'PF03326', NULL, 'Herpesvirus transcription activation factor (transactivator)', 568, NULL, 'Herpes_TAF50', 256377),
(437284, 'PF04683', NULL, 'Proteasome complex subunit Rpn13 ubiquitin receptor', 87, NULL, 'Proteasom_Rpn13', 256378),
(437285, 'PF10319', NULL, 'Serpentine type 7TM GPCR chemoreceptor Srj', 310, NULL, '7TM_GPCR_Srj', 256379),
(437286, 'PF12535', NULL, 'Hydrolase of X-linked nucleoside diphosphate N terminal', 56, NULL, 'Nudix_N', 256380),
(437287, 'PF08722', NULL, 'TnsA-like endonuclease N terminal', 85, NULL, 'Tn7_TnsA-like_N', 256381),
(437288, 'PF13011', NULL, 'leucine-zipper of insertion element IS481', 85, NULL, 'LZ_Tnp_IS481', 256382),
(437289, 'PF10832', NULL, 'Protein of unknown function (DUF2559)', 54, NULL, 'DUF2559', 256383),
(437290, 'PF01258', NULL, 'Prokaryotic dksA/traR C4-type zinc finger', 36, NULL, 'zf-dskA_traR', 256384),
(437291, 'PF20545', NULL, 'Domain of unknown function (DUF6759)', 94, NULL, 'DUF6759', 256385),
(437292, 'PF14802', NULL, 'TMEM192 family', 235, NULL, 'TMEM192', 256386);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(437293, 'PF12114', NULL, 'Period protein 2/3C-terminal region', 171, NULL, 'Period_C', 256387),
(437294, 'PF14104', NULL, 'Domain of unknown function (DUF4277)', 109, NULL, 'DUF4277', 256388),
(437295, 'PF15639', NULL, 'Metallopeptidase toxin 3', 137, NULL, 'Tox-MPTase3', 256389),
(437296, 'PF01343', NULL, 'Peptidase family S49', 154, NULL, 'Peptidase_S49', 256390),
(437297, 'PF12403', NULL, 'Paired-box protein 2 C terminal', 113, NULL, 'Pax2_C', 256391),
(437298, 'PF19150', NULL, 'Family of unknown function (DUF5832)', 81, NULL, 'DUF5832', 256392),
(437299, 'PF19382', NULL, 'Family of unknown function (DUF5957)', 59, NULL, 'DUF5957', 256393),
(437300, 'PF09832', NULL, 'Uncharacterized protein conserved in bacteria (DUF2059)', 60, NULL, 'DUF2059', 256394),
(437301, 'PF16482', NULL, 'Staufen C-terminal domain', 111, NULL, 'Staufen_C', 256395),
(437302, 'PF05545', NULL, 'Cbb3-type cytochrome oxidase component FixQ', 49, NULL, 'FixQ', 256396),
(437303, 'PF04427', NULL, 'Brix domain', 191, NULL, 'Brix', 256397),
(437304, 'PF03081', NULL, 'Exo70 exocyst complex subunit', 373, NULL, 'Exo70', 256398),
(437305, 'PF12145', NULL, 'Eukaryotic Mediator 12 subunit domain', 481, NULL, 'Med12-LCEWAV', 256399),
(437306, 'PF01741', NULL, 'Large-conductance mechanosensitive channel, MscL', 121, NULL, 'MscL', 256400),
(437307, 'PF17476', NULL, 'Clostridial binary toxin B/anthrax toxin PA domain 3', 102, NULL, 'Binary_toxB_3', 256401),
(437308, 'PF03800', NULL, 'Nuf2 family', 142, NULL, 'Nuf2', 256402),
(437309, 'PF18365', NULL, 'Phosphoinositide phosphatase C-terminal domain', 125, NULL, 'PI_PP_C', 256403),
(437310, 'PF02999', NULL, 'Borrelia orf-D family', 100, NULL, 'Borrelia_orfD', 256404),
(437311, 'PF01419', NULL, 'Jacalin-like lectin domain', 133, NULL, 'Jacalin', 256405),
(437312, 'PF12489', NULL, 'Nuclear coactivator', 135, NULL, 'ARA70', 256406),
(437313, 'PF06201', NULL, 'PITH domain', 151, NULL, 'PITH', 256407),
(437314, 'PF07240', NULL, 'Stress-inducible humoral factor Turandot', 81, NULL, 'Turandot', 256408),
(437315, 'PF17668', NULL, 'Acetyltransferase (GNAT) domain', 116, NULL, 'Acetyltransf_17', 256409),
(437316, 'PF10647', NULL, 'Lipoprotein LpqB beta-propeller domain', 253, NULL, 'Gmad1', 256410),
(437317, 'PF11596', NULL, 'Protein of unknown function (DUF3246)', 243, NULL, 'DUF3246', 256411),
(437318, 'PF16359', NULL, 'RcsD-ABL domain', 103, NULL, 'RcsD_ABL', 256412),
(437319, 'PF06965', NULL, 'Na+/H+ antiporter 1', 374, NULL, 'Na_H_antiport_1', 256413),
(437320, 'PF14745', NULL, 'WASH complex subunit 4, N-terminal', 574, NULL, 'WASH-4_N', 256414),
(437321, 'PF14787', NULL, 'GAG-polyprotein viral zinc-finger', 36, NULL, 'zf-CCHC_5', 256415),
(437322, 'PF07747', NULL, 'MTH865-like family', 70, NULL, 'MTH865', 256416),
(437323, 'PF19581', NULL, 'Glyoxalase superfamily protein', 131, NULL, 'Glyoxalase_7', 256417),
(437324, 'PF08974', NULL, 'Domain of unknown function (DUF1877)', 165, NULL, 'DUF1877', 256418),
(437325, 'PF09745', NULL, 'Nuclear speckle splicing regulatory protein 1, N-terminal', 121, NULL, 'NSRP1_N', 256419),
(437326, 'PF13282', NULL, 'Domain of unknown function (DUF4070)', 140, NULL, 'DUF4070', 256420),
(437327, 'PF14728', NULL, 'PTHB1 C-terminus', 376, NULL, 'PHTB1_C', 256421),
(437328, 'PF20210', NULL, 'Laa1/Sip1/HEATR5 HEAT repeat region', 178, NULL, 'Laa1_Sip1_HTR5', 256422),
(437329, 'PF08009', NULL, 'CDP-alcohol phosphatidyltransferase 2', 37, NULL, 'CDP-OH_P_tran_2', 256423),
(437330, 'PF04275', NULL, 'Phosphomevalonate kinase', 114, NULL, 'P-mevalo_kinase', 256424),
(437331, 'PF03477', NULL, 'ATP cone domain', 86, NULL, 'ATP-cone', 256425),
(437332, 'PF05517', NULL, 'p25-alpha', 155, NULL, 'p25-alpha', 256426),
(437333, 'PF05401', NULL, 'Nodulation protein S (NodS)', 201, NULL, 'NodS', 256427),
(437334, 'PF00213', NULL, 'ATP synthase delta (OSCP) subunit', 172, NULL, 'OSCP', 256428),
(437335, 'PF05540', NULL, 'Serpulina hyodysenteriae variable surface protein', 387, NULL, 'Serpulina_VSP', 256429),
(437336, 'PF12395', NULL, 'Protein of unknown function', 107, NULL, 'DUF3658', 256430);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(437337, 'PF17989', NULL, 'Actin like proteins N terminal domain', 147, NULL, 'ALP_N', 256431),
(437338, 'PF14758', NULL, 'Non-essential region of nsp2 of arterivirus polyprotein', 203, NULL, 'NSP2_assoc', 256432),
(437339, 'PF03439', NULL, 'Early transcription elongation factor of RNA pol II, NGN section', 84, NULL, 'Spt5-NGN', 256433),
(437340, 'PF15227', NULL, 'zinc finger of C3HC4-type, RING', 42, NULL, 'zf-C3HC4_4', 256434),
(437341, 'PF07108', NULL, 'PipA protein', 200, NULL, 'PipA', 256435),
(437342, 'PF17537', NULL, 'Family of unknown function (DUF5455)', 102, NULL, 'DUF5455', 256436),
(437343, 'PF08744', NULL, 'Plant transcription factor NOZZLE', 335, NULL, 'NOZZLE', 256437),
(437344, 'PF20190', NULL, 'Family of unknown function (DUF6553)', 188, NULL, 'DUF6553', 256438),
(437345, 'PF16936', NULL, 'Putative holin', 78, NULL, 'Holin_9', 256439),
(437346, 'PF02295', NULL, 'Adenosine deaminase z-alpha domain', 67, NULL, 'z-alpha', 256440),
(437347, 'PF02514', NULL, 'CobN/Magnesium Chelatase', 1092, NULL, 'CobN-Mg_chel', 256441),
(437348, 'PF01266', NULL, 'FAD dependent oxidoreductase', 353, NULL, 'DAO', 256442),
(437349, 'PF03474', NULL, 'DMRTA motif', 37, NULL, 'DMA', 256443),
(437350, 'PF06434', NULL, 'Aconitate hydratase 2 N-terminus', 204, NULL, 'Aconitase_2_N', 256444),
(437351, 'PF17504', NULL, 'Family of unknown function (DUF5436)', 79, NULL, 'DUF5436', 256445),
(437352, 'PF18172', NULL, 'LepB GAP domain N-terminal subdomain', 188, NULL, 'LepB_GAP_N', 256446),
(437353, 'PF17168', NULL, 'Domain of unknown function (DUF5127)', 227, NULL, 'DUF5127', 256447),
(437354, 'PF14327', NULL, 'Hinge domain of cleavage stimulation factor subunit 2', 81, NULL, 'CSTF2_hinge', 256448),
(437355, 'PF14139', NULL, 'YpzG-like protein', 49, NULL, 'YpzG', 256449),
(437356, 'PF09094', NULL, 'Alpha-amylase/4-alpha-glucanotransferase, middle domain', 80, NULL, 'AmyA-A_glucT_m', 256450),
(437357, 'PF18754', NULL, 'Nucleotide modification associated domain 3', 250, NULL, 'Nmad3', 256451),
(437358, 'PF02016', NULL, 'LD-carboxypeptidase N-terminal domain', 119, NULL, 'Peptidase_S66', 256452),
(437359, 'PF04947', NULL, 'Poxvirus Late Transcription Factor VLTF3 like', 168, NULL, 'Pox_VLTF3', 256453),
(437360, 'PF09762', NULL, 'CCDC93, coiled-coil domain', 177, NULL, 'CCDC93_CC', 256454),
(437361, 'PF14561', NULL, 'Tetratricopeptide repeat', 90, NULL, 'TPR_20', 256455),
(437362, 'PF01806', NULL, 'Paramyxovirinae P phosphoprotein C-terminal region', 248, NULL, 'Paramyxo_P', 256456),
(437363, 'PF09466', NULL, 'Hypothetical protein Yqai', 66, NULL, 'Yqai', 256457),
(437364, 'PF19080', NULL, 'Family of unknown function (DUF5772)', 84, NULL, 'DUF5772', 256458),
(437365, 'PF14898', NULL, 'Domain of unknown function (DUF4491)', 92, NULL, 'DUF4491', 256459),
(437366, 'PF08104', NULL, 'Ponericin L family', 24, NULL, 'Antimicrobial_9', 256460),
(437367, 'PF15702', NULL, 'Hermansky-Pudlak syndrome 6 protein N-terminal domain', 378, NULL, 'HPS6', 256461),
(437368, 'PF08333', NULL, 'Protein of unknown function (DUF1725)', 19, NULL, 'DUF1725', 256462),
(437369, 'PF09398', NULL, 'FOP N terminal dimerisation domain', 81, NULL, 'FOP_dimer', 256463),
(437370, 'PF09414', NULL, 'RNA ligase', 165, NULL, 'RNA_ligase', 256464),
(437371, 'PF02959', NULL, 'HTLV Tax', 222, NULL, 'Tax', 256465),
(437372, 'PF14639', NULL, 'Holliday-junction resolvase-like of SPT6', 150, NULL, 'YqgF', 256466),
(437373, 'PF14908', NULL, 'CCDC81 eukaryotic HU domain 1', 94, NULL, 'HU-CCDC81_euk_1', 256467),
(437374, 'PF11317', NULL, 'Protein of unknown function (DUF3119)', 126, NULL, 'DUF3119', 256468),
(437375, 'PF03091', NULL, 'CutA1 divalent ion tolerance protein', 99, NULL, 'CutA1', 256469),
(437376, 'PF14438', NULL, 'Ataxin 2 SM domain', 81, NULL, 'SM-ATX', 256470),
(437377, 'PF17347', NULL, 'Family of unknown function (DUF5377)', 96, NULL, 'DUF5377', 256471),
(437378, 'PF19456', NULL, 'MobI protein', 116, NULL, 'MobI', 256472),
(437379, 'PF16397', NULL, 'Domain of unknown function (DUF5006)', 263, NULL, 'DUF5006', 256473),
(437380, 'PF08129', NULL, 'Alpha/beta enterocin family', 57, NULL, 'Antimicrobial17', 256474);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(437381, 'PF03122', NULL, 'Herpes virus major capsid protein', 1370, NULL, 'Herpes_MCP', 256475),
(437382, 'PF00135', NULL, 'Carboxylesterase family', 515, NULL, 'COesterase', 256476),
(437383, 'PF16266', NULL, 'Domain of unknown function (DUF4919)', 185, NULL, 'DUF4919', 256477),
(437384, 'PF00859', NULL, 'CTF/NF-I family transcription modulation region', 288, NULL, 'CTF_NFI', 256478),
(437385, 'PF07526', NULL, 'Associated with HOX', 136, NULL, 'POX', 256479),
(437386, 'PF10757', NULL, 'Biofilm formation regulator YbaJ', 118, NULL, 'YbaJ', 256480),
(437387, 'PF12604', NULL, 'Tail fibre protein gp37 C terminal', 168, NULL, 'gp37_C', 256481),
(437388, 'PF05334', NULL, 'Protein of unknown function (DUF719)', 185, NULL, 'DUF719', 256482),
(437389, 'PF15073', NULL, 'Spermatogenesis-associated protein 48', 128, NULL, 'SPATA48', 256483),
(437390, 'PF17832', NULL, 'Pre-PUA-like domain', 87, NULL, 'Pre-PUA', 256484),
(437391, 'PF14228', NULL, 'Cell morphogenesis central region', 1113, NULL, 'MOR2-PAG1_mid', 256485),
(437392, 'PF15974', NULL, 'Cadherin C-terminal cytoplasmic tail, catenin-binding region', 134, NULL, 'Cadherin_tail', 256486),
(437393, 'PF01935', NULL, 'Helicase HerA, central domain', 227, NULL, 'DUF87', 256487),
(437394, 'PF03400', NULL, 'IS1 transposase', 131, NULL, 'DDE_Tnp_IS1', 256488),
(437395, 'PF20196', NULL, 'Family of unknown function (DUF6559)', 125, NULL, 'DUF6559', 256489),
(437396, 'PF17401', NULL, 'Family of unknown function (DUF5407)', 74, NULL, 'DUF5407', 256490),
(437397, 'PF11624', NULL, 'MHC class I-like protein M157', 256, NULL, 'M157', 256491),
(437398, 'PF12133', NULL, 'Betacoronavirus NS6 protein', 62, NULL, 'bCoV_NS6', 256492),
(437399, 'PF18369', NULL, 'Polyketide synthase dimerisation element domain', 45, NULL, 'PKS_DE', 256493),
(437400, 'PF18264', NULL, 'CXC domain', 32, NULL, 'preSET_CXC', 256494),
(437401, 'PF07165', NULL, 'Protein of unknown function (DUF1397)', 207, NULL, 'DUF1397', 256495),
(437402, 'PF15474', NULL, 'Meiotically up-regulated gene family', 103, NULL, 'MU117', 256496),
(437403, 'PF18201', NULL, 'PIH1 CS-like domain', 99, NULL, 'PIH1_CS', 256497),
(437404, 'PF04893', NULL, 'Yip1 domain', 173, NULL, 'Yip1', 256498),
(437405, 'PF08314', NULL, 'Secretory pathway protein Sec39', 750, NULL, 'Sec39', 256499),
(437406, 'PF09460', NULL, 'Saf-pilin pilus formation protein', 144, NULL, 'Saf-Nte_pilin', 256500),
(437407, 'PF01370', NULL, 'NAD dependent epimerase/dehydratase family', 241, NULL, 'Epimerase', 256501),
(437408, 'PF14235', NULL, 'Domain of unknown function (DUF4337)', 161, NULL, 'DUF4337', 256502),
(437409, 'PF17717', NULL, 'Family of unknown function (DUF5562)', 168, NULL, 'DUF5562', 256503),
(437410, 'PF05983', NULL, 'MED7 protein', 193, NULL, 'Med7', 256504),
(437411, 'PF14815', NULL, 'NUDIX domain', 109, NULL, 'NUDIX_4', 256505),
(437412, 'PF07501', NULL, 'G5 domain', 75, NULL, 'G5', 256506),
(437413, 'PF00112', NULL, 'Papain family cysteine protease', 219, NULL, 'Peptidase_C1', 256507),
(437414, 'PF20172', NULL, 'Domain of unknown function (DUF6538)', 60, NULL, 'DUF6538', 256508),
(437415, 'PF15448', NULL, 'N-terminal segments of P. falciparum erythrocyte membrane protein', 50, NULL, 'NTS_2', 256509),
(437416, 'PF18330', NULL, 'Ligase Pab1020 C-terminal region', 125, NULL, 'Lig_C', 256510),
(437417, 'PF11989', NULL, 'Retrograde transport protein Dsl1 C terminal', 194, NULL, 'Dsl1_C', 256511),
(437418, 'PF13637', NULL, 'Ankyrin repeats (many copies)', 55, NULL, 'Ank_4', 256512),
(437419, 'PF04548', NULL, 'AIG1 family', 212, NULL, 'AIG1', 256513),
(437420, 'PF04226', NULL, 'Transglycosylase associated protein', 49, NULL, 'Transgly_assoc', 256514),
(437421, 'PF14657', NULL, 'Arm DNA-binding domain', 46, NULL, 'Arm-DNA-bind_4', 256515),
(437422, 'PF11218', NULL, 'Protein of unknown function (DUF3011)', 197, NULL, 'DUF3011', 256516),
(437423, 'PF05908', NULL, 'Poly-gamma-glutamate hydrolase', 191, NULL, 'Gamma_PGA_hydro', 256517),
(437424, 'PF07737', NULL, 'Anthrax toxin lethal factor, N- and C-terminal domain', 218, NULL, 'ATLF', 256518);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(437425, 'PF09136', NULL, 'Glucodextranase, domain B', 83, NULL, 'Glucodextran_B', 256519),
(437426, 'PF06906', NULL, 'Protein of unknown function (DUF1272)', 57, NULL, 'DUF1272', 256520),
(437427, 'PF14974', NULL, 'Protein C10', 103, NULL, 'P_C10', 256521),
(437428, 'PF05499', NULL, 'DNA methyltransferase 1-associated protein 1 (DMAP1)', 165, NULL, 'DMAP1', 256522),
(437429, 'PF18520', NULL, 'Spindle pole body component 110 C-terminal domain', 52, NULL, 'Spc110_C', 256523),
(437430, 'PF12743', NULL, 'Oestrogen-type nuclear receptor final C-terminal', 44, NULL, 'ESR1_C', 256524),
(437431, 'PF05360', NULL, 'yiaA/B two helix domain', 53, NULL, 'YiaAB', 256525),
(437432, 'PF15516', NULL, 'BpuSI N-terminal domain', 162, NULL, 'BpuSI_N', 256526),
(437433, 'PF16544', NULL, 'Homodimerisation region of STAR domain protein', 53, NULL, 'STAR_dimer', 256527),
(437434, 'PF07140', NULL, 'Interferon gamma receptor (IFNGR1)', 133, NULL, 'IFNGR1', 256528),
(437435, 'PF17158', NULL, 'Membrane-associated sensor, integral membrane domain', 239, NULL, 'MASE4', 256529),
(437436, 'PF18944', NULL, 'Family of unknown function (DUF5691)', 210, NULL, 'DUF5691', 256530),
(437437, 'PF07533', NULL, 'BRK domain', 44, NULL, 'BRK', 256531),
(437438, 'PF01040', NULL, 'UbiA prenyltransferase family', 251, NULL, 'UbiA', 256532),
(437439, 'PF00232', NULL, 'Glycosyl hydrolase family 1', 453, NULL, 'Glyco_hydro_1', 256533),
(437440, 'PF01987', NULL, 'Mitochondrial biogenesis AIM24', 202, NULL, 'AIM24', 256534),
(437441, 'PF03188', NULL, 'Eukaryotic cytochrome b561', 137, NULL, 'Cytochrom_B561', 256535),
(437442, 'PF14782', NULL, 'Ciliary BBSome complex subunit 2, C-terminal', 432, NULL, 'BBS2_C', 256536),
(437443, 'PF18072', NULL, 'Formylglycinamide ribonucleotide amidotransferase linker domain', 50, NULL, 'FGAR-AT_linker', 256537),
(437444, 'PF19764', NULL, 'Family of unknown function (DUF6251)', 128, NULL, 'DUF6251', 256538),
(437445, 'PF05746', NULL, 'DALR anticodon binding domain', 119, NULL, 'DALR_1', 256539),
(437446, 'PF20213', NULL, 'Family of unknown function (DUF6573)', 138, NULL, 'DUF6573', 256540),
(437447, 'PF20039', NULL, 'Family of unknown function (DUF6441)', 216, NULL, 'DUF6441', 256541),
(437448, 'PF14395', NULL, 'Phage phiEco32-like COOH.NH2 ligase-type 2', 253, NULL, 'COOH-NH2_lig', 256542),
(437449, 'PF00391', NULL, 'PEP-utilising enzyme, mobile domain', 73, NULL, 'PEP-utilizers', 256543),
(437450, 'PF18101', NULL, 'Pan3 Pseudokinase domain', 138, NULL, 'Pan3_PK', 256544),
(437451, 'PF00603', NULL, 'Influenza RNA-dependent RNA polymerase subunit PA', 694, NULL, 'Flu_PA', 256545),
(437452, 'PF14624', NULL, 'VWA / Hh  protein intein-like', 70, NULL, 'Vwaint', 256546),
(437453, 'PF18836', NULL, 'YdcK Beta solenoid repeat', 17, NULL, 'B_solenoid_ydck', 256547),
(437454, 'PF08339', NULL, 'RTX C-terminal domain', 131, NULL, 'RTX_C', 256548),
(437455, 'PF14007', NULL, 'YtpI-like protein', 87, NULL, 'YtpI', 256549),
(437456, 'PF10445', NULL, 'Protein of unknown function (DUF2456)', 95, NULL, 'DUF2456', 256550),
(437457, 'PF11929', NULL, 'Domain of unknown function (DUF3447)', 76, NULL, 'DUF3447', 256551),
(437458, 'PF03408', NULL, 'Foamy virus envelope protein', 984, NULL, 'Foamy_virus_ENV', 256552),
(437459, 'PF03879', NULL, 'Cgr1 family', 107, NULL, 'Cgr1', 256553),
(437460, 'PF04334', NULL, 'Protein of unknown function (DUF478)', 68, NULL, 'DUF478', 256554),
(437461, 'PF19792', NULL, 'Family of unknown function (DUF6276)', 129, NULL, 'DUF6276', 256555),
(437462, 'PF04392', NULL, 'ABC transporter substrate binding protein', 293, NULL, 'ABC_sub_bind', 256556),
(437463, 'PF14513', NULL, 'Diacylglycerol kinase N-terminus', 166, NULL, 'DAG_kinase_N', 256557),
(437464, 'PF01399', NULL, 'PCI domain', 105, NULL, 'PCI', 256558),
(437465, 'PF03153', NULL, 'Transcription factor IIA, alpha/beta subunit', 415, NULL, 'TFIIA', 256559),
(437466, 'PF13222', NULL, 'Protein of unknown function (DUF4030)', 142, NULL, 'DUF4030', 256560),
(437467, 'PF06182', NULL, 'ABC-2 family transporter protein', 229, NULL, 'ABC2_membrane_6', 256561);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(437468, 'PF08498', NULL, 'Sterol methyltransferase C-terminal', 66, NULL, 'Sterol_MT_C', 256562),
(437469, 'PF09932', NULL, 'Uncharacterized conserved protein (DUF2164)', 74, NULL, 'DUF2164', 256563),
(437470, 'PF18060', NULL, 'F actin bundling C terminal', 87, NULL, 'F_actin_bund_C', 256564),
(437471, 'PF00337', NULL, 'Galactoside-binding lectin', 134, NULL, 'Gal-bind_lectin', 256565),
(437472, 'PF13105', NULL, 'Protein of unknown function (DUF3959)', 238, NULL, 'DUF3959', 256566),
(437473, 'PF00709', NULL, 'Adenylosuccinate synthetase', 415, NULL, 'Adenylsucc_synt', 256567),
(437474, 'PF10300', NULL, 'Iml2/Tetratricopeptide repeat protein 39', 479, NULL, 'Iml2-TPR_39', 256568),
(437475, 'PF12543', NULL, 'Protein of unknown function (DUF3738)', 189, NULL, 'DUF3738', 256569),
(437476, 'PF10171', NULL, 'Translocase of the Inner Mitochondrial membrane 29', 169, NULL, 'Tim29', 256570),
(437477, 'PF06016', NULL, 'Reovirus core-spike protein lambda-2 (L2)', 1297, NULL, 'Reovirus_L2', 256571),
(437478, 'PF17860', NULL, 'RK-1-like defensin', 34, NULL, 'Defensin_RK-1', 256572),
(437479, 'PF12073', NULL, 'Protein of unknown function (DUF3553)', 50, NULL, 'DUF3553', 256573),
(437480, 'PF19000', NULL, 'Family of unknown function (DUF5729)', 141, NULL, 'DUF5729', 256574),
(437481, 'PF19495', NULL, 'Family of unknown function (DUF6030)', 252, NULL, 'DUF6030', 256575),
(437482, 'PF04014', NULL, 'Antidote-toxin recognition MazE, bacterial antitoxin', 46, NULL, 'MazE_antitoxin', 256576),
(437483, 'PF04545', NULL, 'Sigma-70, region 4', 50, NULL, 'Sigma70_r4', 256577),
(437484, 'PF14161', NULL, 'Centrosome-associated N terminus', 115, NULL, 'FAM110_N', 256578),
(437485, 'PF18437', NULL, 'Nup54 C-terminal interacting domain', 39, NULL, 'Nup54_C', 256579),
(437486, 'PF00011', NULL, 'Hsp20/alpha crystallin family', 102, NULL, 'HSP20', 256580),
(437487, 'PF14960', NULL, 'ATP synthase regulation', 50, NULL, 'ATP_synth_reg', 256581),
(437488, 'PF16880', NULL, 'N-terminal EH-domain containing protein', 33, NULL, 'EHD_N', 256582),
(437489, 'PF03576', NULL, 'Peptidase family S58', 305, NULL, 'Peptidase_S58', 256583),
(437490, 'PF03158', NULL, 'Multigene family 530 protein', 192, NULL, 'DUF249', 256584),
(437491, 'PF03353', NULL, 'Ras-mediated vulval-induction antagonist', 306, NULL, 'Lin-8', 256585),
(437492, 'PF08966', NULL, 'Domain of unknown function (DUF1882)', 73, NULL, 'DUF1882', 256586),
(437493, 'PF03949', NULL, 'Malic enzyme, NAD binding domain', 258, NULL, 'Malic_M', 256587),
(437494, 'PF17879', NULL, 'DNA ligase C-terminal domain', 109, NULL, 'DNA_ligase_C', 256588),
(437495, 'PF19271', NULL, 'Nis1 family', 114, NULL, 'Nis1', 256589),
(437496, 'PF11872', NULL, 'Protein of unknown function (DUF3392)', 105, NULL, 'DUF3392', 256590),
(437497, 'PF14096', NULL, 'Domain of unknown function (DUF4274)', 76, NULL, 'DUF4274', 256591),
(437498, 'PF15180', NULL, 'Neuropeptides B and W', 118, NULL, 'NPBW', 256592),
(437499, 'PF17002', NULL, 'Domain of unknown function (DUF5089)', 193, NULL, 'DUF5089', 256593),
(437500, 'PF10588', NULL, 'NADH-ubiquinone oxidoreductase-G iron-sulfur binding region', 40, NULL, 'NADH-G_4Fe-4S_3', 256594),
(437501, 'PF02898', NULL, 'Nitric oxide synthase, oxygenase domain', 362, NULL, 'NO_synthase', 256595),
(437502, 'PF07490', NULL, 'Translocated intimin receptor (Tir) N-terminus', 266, NULL, 'Tir_receptor_N', 256596),
(437503, 'PF14505', NULL, 'Domain of unknown function (DUF4438)', 259, NULL, 'DUF4438', 256597),
(437504, 'PF08156', NULL, 'NOP5NT (NUC127) domain', 64, NULL, 'NOP5NT', 256598),
(437505, 'PF10410', NULL, 'DnaB-helicase binding domain of primase', 56, NULL, 'DnaB_bind', 256599),
(437506, 'PF13521', NULL, 'AAA domain', 163, NULL, 'AAA_28', 256600),
(437507, 'PF03339', NULL, 'Poxvirus L3/FP4 protein', 316, NULL, 'Pox_L3_FP4', 256601),
(437508, 'PF17905', NULL, 'GLD-3 KH domain 5', 95, NULL, 'KH_10', 256602),
(437509, 'PF10987', NULL, 'Protein of unknown function (DUF2806)', 221, NULL, 'DUF2806', 256603),
(437510, 'PF06841', NULL, 'T4-like virus tail tube protein gp19', 134, NULL, 'Phage_T4_gp19', 256604);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(437511, 'PF04479', NULL, 'RTA1 like protein', 206, NULL, 'RTA1', 256605),
(437512, 'PF12223', NULL, 'Protein of unknown function (DUF3602)', 81, NULL, 'DUF3602', 256606),
(437513, 'PF17364', NULL, 'Family of unknown function (DUF5389)', 104, NULL, 'DUF5389', 256607),
(437514, 'PF04794', NULL, 'YdjC-like protein', 253, NULL, 'YdjC', 256608),
(437515, 'PF09524', NULL, 'Conserved phage C-terminus (Phg_2220_C)', 73, NULL, 'Phg_2220_C', 256609),
(437516, 'PF11580', NULL, 'Protein of unknown function (DUF3239)', 125, NULL, 'DUF3239', 256610),
(437517, 'PF10178', NULL, 'Proteasome assembly chaperone 3', 87, NULL, 'PAC3', 256611),
(437518, 'PF19767', NULL, 'Family of unknown function (DUF6254)', 36, NULL, 'DUF6254', 256612),
(437519, 'PF01989', NULL, 'Aconitase X swivel domain', 80, NULL, 'AcnX_swivel_put', 256613),
(437520, 'PF08121', NULL, 'Waglerin family', 22, NULL, 'Toxin_33', 256614),
(437521, 'PF12060', NULL, 'Domain of unknown function (DUF3541)', 225, NULL, 'DUF3541', 256615),
(437522, 'PF05755', NULL, 'Rubber elongation factor protein (REF)', 206, NULL, 'REF', 256616),
(437523, 'PF11419', NULL, 'Protein of unknown function (DUF3194)', 83, NULL, 'DUF3194', 256617),
(437524, 'PF02363', NULL, 'Cysteine rich repeat', 17, NULL, 'C_tripleX', 256618),
(437525, 'PF07916', NULL, 'TraG-like protein, N-terminal region', 468, NULL, 'TraG_N', 256619),
(437526, 'PF15403', NULL, 'HiaBD2_N domain of Trimeric autotransporter adhesin (GIN)', 52, NULL, 'HiaBD2', 256620),
(437527, 'PF06484', NULL, 'Teneurin Intracellular Region', 367, NULL, 'Ten_N', 256621),
(437528, 'PF02049', NULL, 'Flagellar hook-basal body complex protein FliE', 89, NULL, 'FliE', 256622),
(437529, 'PF19190', NULL, 'Viral BACON domain', 91, NULL, 'BACON_2', 256623),
(437530, 'PF11369', NULL, 'Protein of unknown function (DUF3160)', 627, NULL, 'DUF3160', 256624),
(437531, 'PF07862', NULL, 'Nif11 domain', 48, NULL, 'Nif11', 256625),
(437532, 'PF07180', NULL, 'CaiF/GrlA transcriptional regulator', 146, NULL, 'CaiF_GrlA', 256626),
(437533, 'PF13358', NULL, 'DDE superfamily endonuclease', 146, NULL, 'DDE_3', 256627),
(437534, 'PF14361', NULL, 'RsbT co-antagonist protein rsbRD N-terminal domain', 104, NULL, 'RsbRD_N', 256628),
(437535, 'PF19418', NULL, 'DEPDC5 protein C-terminal region', 308, NULL, 'DEPDC5_CTD', 256629),
(437536, 'PF10185', NULL, 'Chaperone for wingless signalling and trafficking of LDL receptor', 155, NULL, 'Mesd', 256630),
(437537, 'PF03343', NULL, 'SART-1 family', 585, NULL, 'SART-1', 256631),
(437538, 'PF18832', NULL, 'Large polyvalent protein-associated domain 18', 86, NULL, 'LPD18', 256632),
(437539, 'PF09345', NULL, 'SiaC family regulatory phosphoprotein', 121, NULL, 'SiaC', 256633),
(437540, 'PF10075', NULL, 'CSN8/PSMD8/EIF3K family', 144, NULL, 'CSN8_PSD8_EIF3K', 256634),
(437541, 'PF14218', NULL, 'Circadian oscillating protein COP23', 138, NULL, 'COP23', 256635),
(437542, 'PF19852', NULL, 'Family of unknown function (DUF6327)', 83, NULL, 'DUF6327', 256636),
(437543, 'PF19159', NULL, 'Family of unknown function (DUF5841)', 48, NULL, 'DUF5841', 256637),
(437544, 'PF01980', NULL, 'tRNA-methyltransferase O', 119, NULL, 'TrmO', 256638),
(437545, 'PF13179', NULL, 'Family of unknown function (DUF4006)', 64, NULL, 'DUF4006', 256639),
(437546, 'PF16416', NULL, 'ARM-like repeat domain, GUN4-N terminal', 83, NULL, 'GUN4_N', 256640),
(437547, 'PF19067', NULL, 'Family of unknown function (DUF5763)', 39, NULL, 'DUF5763', 256641),
(437548, 'PF07344', NULL, 'Amastin surface glycoprotein', 155, NULL, 'Amastin', 256642),
(437549, 'PF11329', NULL, 'Protein of unknown function (DUF3131)', 366, NULL, 'DUF3131', 256643),
(437550, 'PF19839', NULL, 'Ribbon-helix-helix protein', 65, NULL, 'RHH_9', 256644),
(437551, 'PF11233', NULL, 'Protein of unknown function (DUF3035)', 141, NULL, 'DUF3035', 256645),
(437552, 'PF03237', NULL, 'Terminase large subunit, T4likevirus-type, N-terminal', 215, NULL, 'Terminase_6N', 256646),
(437553, 'PF10875', NULL, 'Protein of unknown function (DUF2670)', 141, NULL, 'DUF2670', 256647),
(437554, 'PF07950', NULL, 'MDM10-complementing protein 1, transmembrane domain', 107, NULL, 'MCP1_TM', 256648);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(437555, 'PF01217', NULL, 'Clathrin adaptor complex small chain', 142, NULL, 'Clat_adaptor_s', 256649),
(437556, 'PF02838', NULL, 'Glycosyl hydrolase family 20, domain 2', 124, NULL, 'Glyco_hydro_20b', 256650),
(437557, 'PF05743', NULL, 'UEV domain', 121, NULL, 'UEV', 256651),
(437558, 'PF00302', NULL, 'Chloramphenicol acetyltransferase', 204, NULL, 'CAT', 256652),
(437559, 'PF04925', NULL, 'SHQ1 protein', 186, NULL, 'SHQ1', 256653),
(437560, 'PF19836', NULL, 'Family of unknown function (DUF6315)', 174, NULL, 'DUF6315', 256654),
(437561, 'PF02141', NULL, 'DENN (AEX-3) domain', 186, NULL, 'DENN', 256655),
(437562, 'PF16733', NULL, 'Rhomboid N-terminal domain', 69, NULL, 'NRho', 256656),
(437563, 'PF03752', NULL, 'Short repeats of unknown function', 42, NULL, 'ALF', 256657),
(437564, 'PF18141', NULL, 'RNA helicase UPF1, 1B domain', 93, NULL, 'UPF1_1B_dom', 256658),
(437565, 'PF15106', NULL, 'TMEM156 protein family', 226, NULL, 'TMEM156', 256659),
(437566, 'PF13451', NULL, 'Probable zinc-ribbon domain', 48, NULL, 'zf-trcl', 256660),
(437567, 'PF14923', NULL, 'Coiled-coil protein 142', 451, NULL, 'CCDC142', 256661),
(437568, 'PF02201', NULL, 'SWIB/MDM2 domain', 74, NULL, 'SWIB', 256662),
(437569, 'PF14130', NULL, 'Cap4 dsDNA endonuclease', 211, NULL, 'Cap4_nuclease', 256663),
(437570, 'PF03388', NULL, 'Legume-like lectin family', 230, NULL, 'Lectin_leg-like', 256664),
(437571, 'PF01627', NULL, 'Hpt domain', 85, NULL, 'Hpt', 256665),
(437572, 'PF00380', NULL, 'Ribosomal protein S9/S16', 121, NULL, 'Ribosomal_S9', 256666),
(437573, 'PF03957', NULL, 'Jun-like transcription factor', 232, NULL, 'Jun', 256667),
(437574, 'PF06213', NULL, 'Cobalamin biosynthesis protein CobT', 277, NULL, 'CobT', 256668),
(437575, 'PF17296', NULL, 'Arenavirus cap snatching domain', 172, NULL, 'ArenaCapSnatch', 256669),
(437576, 'PF20193', NULL, 'Family of unknown function (DUF6556)', 113, NULL, 'DUF6556', 256670),
(437577, 'PF14300', NULL, 'Domain of unknown function (DUF4375)', 120, NULL, 'DUF4375', 256671),
(437578, 'PF00169', NULL, 'PH domain', 105, NULL, 'PH', 256672),
(437579, 'PF10023', NULL, 'Putative aminopeptidase', 322, NULL, 'Aminopep', 256673),
(437580, 'PF10742', NULL, 'Protein of unknown function (DUF2555)', 55, NULL, 'DUF2555', 256674),
(437581, 'PF16664', NULL, 'Unstructured on SH3 and cysteine-rich domain-containing protein 2', 126, NULL, 'STAC2_u1', 256675),
(437582, 'PF00039', NULL, 'Fibronectin type I domain', 40, NULL, 'fn1', 256676),
(437583, 'PF13867', NULL, 'Sin3 binding region of histone deacetylase complex subunit SAP30', 54, NULL, 'SAP30_Sin3_bdg', 256677),
(437584, 'PF05382', NULL, 'Bacteriophage peptidoglycan hydrolase', 142, NULL, 'Amidase_5', 256678),
(437585, 'PF10094', NULL, 'Uncharacterized protein conserved in bacteria (DUF2332)', 335, NULL, 'DUF2332', 256679),
(437586, 'PF19216', NULL, 'Coronavirus replicase NSP15, middle domain', 118, NULL, 'CoV_NSP15_M', 256680),
(437587, 'PF16674', NULL, 'N-terminal of ubiquitin carboxyl-terminal hydrolase 37', 105, NULL, 'UCH_N', 256681),
(437588, 'PF02682', NULL, 'Carboxyltransferase domain, subdomain C and D', 202, NULL, 'CT_C_D', 256682),
(437589, 'PF12521', NULL, 'Protein of unknown function (DUF3724)', 23, NULL, 'DUF3724', 256683),
(437590, 'PF11108', NULL, 'Viral glycoprotein L', 102, NULL, 'Phage_glycop_gL', 256684),
(437591, 'PF19921', NULL, 'MoxR-vWA-beta-propeller ternary system domain bpX5', 135, NULL, 'bpX5', 256685),
(437592, 'PF20410', NULL, 'Domain of unknown function (DUF6696)', 101, NULL, 'DUF6696', 256686),
(437593, 'PF13593', NULL, 'SBF-like CPA transporter family (DUF4137)', 313, NULL, 'SBF_like', 256687),
(437594, 'PF15780', NULL, 'Abnormal spindle-like microcephaly-assoc''d, ASPM-SPD-2-Hydin', 98, NULL, 'ASH', 256688),
(437595, 'PF02935', NULL, 'Cytochrome c oxidase subunit VIIc', 64, NULL, 'COX7C', 256689),
(437596, 'PF01261', NULL, 'Xylose isomerase-like TIM barrel', 250, NULL, 'AP_endonuc_2', 256690),
(437597, 'PF11726', NULL, 'Inovirus Gp2', 179, NULL, 'Inovirus_Gp2', 256691),
(437598, 'PF19089', NULL, 'Membrane bound beta barrel domain (DUF5777)', 246, NULL, 'DUF5777', 256692);
INSERT INTO "PUBLIC"."MODEL" VALUES
(437599, 'PF00542', NULL, 'Ribosomal protein L7/L12 C-terminal domain', 67, NULL, 'Ribosomal_L12', 256693),
(437600, 'PF08719', NULL, 'NADAR domain', 163, NULL, 'NADAR', 256694),
(437601, 'PF15661', NULL, 'C6orf222, uncharacterised family', 648, NULL, 'CF222', 256695),
(437602, 'PF08904', NULL, 'EipB-like', 248, NULL, 'EipB_like', 256696),
(437603, 'PF08884', NULL, 'Flagellin D3 domain', 90, NULL, 'Flagellin_D3', 256697),
(437604, 'PF20257', NULL, 'SAM hydroxide adenosyltransferase C-terminal domain', 85, NULL, 'SAM_HAT_C', 256698),
(437605, 'PF00252', NULL, 'Ribosomal protein L16p/L10e', 132, NULL, 'Ribosomal_L16', 256699),
(437606, 'PF02493', NULL, 'MORN repeat', 23, NULL, 'MORN', 256700),
(437607, 'PF15567', NULL, 'Immunity protein 35', 85, NULL, 'Imm35', 256701),
(437608, 'PF07826', NULL, 'IMP cyclohydrolase-like protein', 191, NULL, 'IMP_cyclohyd', 256702),
(437609, 'PF09168', NULL, 'X-Prolyl dipeptidyl aminopeptidase PepX, N-terminal', 157, NULL, 'PepX_N', 256703),
(437610, 'PF19894', NULL, 'Family of unknown function (DUF6367)', 147, NULL, 'DUF6367', 256704),
(437611, 'PF18556', NULL, 'Bacterial Tetracyclin repressor,  C-terminal domain', 105, NULL, 'TetR_C_35', 256705),
(437612, 'PF04988', NULL, 'A-kinase anchoring protein 95 (AKAP95)', 136, NULL, 'AKAP95', 256706),
(437613, 'PF15323', NULL, 'Developmental protein', 223, NULL, 'Ashwin', 256707),
(437614, 'PF04518', NULL, 'Effector from type III secretion system', 371, NULL, 'Effector_1', 256708),
(437615, 'PF00881', NULL, 'Nitroreductase family', 168, NULL, 'Nitroreductase', 256709),
(437616, 'PF04261', NULL, 'Dyp-type peroxidase family', 327, NULL, 'Dyp_perox', 256710),
(437617, 'PF04941', NULL, 'Late expression factor 8 (LEF-8)', 730, NULL, 'LEF-8', 256711),
(437618, 'PF04210', NULL, 'Tetrahydromethanopterin S-methyltransferase, subunit G', 64, NULL, 'MtrG', 256712),
(437619, 'PF19302', NULL, 'Domain of unknown function (DUF5915)', 195, NULL, 'DUF5915', 256713),
(437620, 'PF00265', NULL, 'Thymidine kinase', 177, NULL, 'TK', 256714),
(437621, 'PF06116', NULL, 'Transcriptional activator RinB', 51, NULL, 'RinB', 256715),
(437622, 'PF13062', NULL, 'Protein of unknown function (DUF3924)', 62, NULL, 'DUF3924', 256716),
(437623, 'PF20491', NULL, 'Ermin', 284, NULL, 'Ermin', 256717),
(437624, 'PF01947', NULL, 'Chorismate pyruvate-lyase Rv2949c-like', 149, NULL, 'Rv2949c-like', 256718),
(437625, 'PF12698', NULL, 'ABC-2 family transporter protein', 346, NULL, 'ABC2_membrane_3', 256719),
(437626, 'PF09289', NULL, 'Follistatin/Osteonectin-like EGF domain', 22, NULL, 'FOLN', 256720),
(437627, 'PF13343', NULL, 'Bacterial extracellular solute-binding protein', 244, NULL, 'SBP_bac_6', 256721),
(437628, 'PF15669', NULL, 'Coiled-coil domain-containing protein 24 family', 200, NULL, 'CCDC24', 256722),
(437629, 'PF12931', NULL, 'Sec23-binding domain of Sec16', 302, NULL, 'Sec16_C', 256723),
(437630, 'PF15407', NULL, 'Sporulation protein family 7', 64, NULL, 'Spo7_2_N', 256724),
(437631, 'PF07232', NULL, 'Putative rep protein (DUF1424)', 328, NULL, 'DUF1424', 256725),
(437632, 'PF11042', NULL, 'Protein of unknown function (DUF2750)', 102, NULL, 'DUF2750', 256726),
(437633, 'PF20237', NULL, 'Family of unknown function (DUF6594)', 236, NULL, 'DUF6594', 256727),
(437634, 'PF02142', NULL, 'MGS-like domain', 95, NULL, 'MGS', 256728),
(437635, 'PF18692', NULL, 'Family of unknown function (DUF5640)', 84, NULL, 'DUF5640', 256729),
(437636, 'PF18379', NULL, 'FERM F1 ubiquitin-like domain', 96, NULL, 'FERM_F1', 256730),
(437637, 'PF12876', NULL, 'Sugar-binding cellulase-like', 355, NULL, 'Cellulase-like', 256731),
(437638, 'PF14836', NULL, 'Ubiquitin-like domain', 88, NULL, 'Ubiquitin_3', 256732),
(437639, 'PF08079', NULL, 'Ribosomal L30 N-terminal domain', 72, NULL, 'Ribosomal_L30_N', 256733),
(437640, 'PF03255', NULL, 'Acetyl co-enzyme A carboxylase carboxyltransferase alpha subunit', 144, NULL, 'ACCA', 256734),
(437641, 'PF07111', NULL, 'Alpha helical coiled-coil rod protein (HCR)', 749, NULL, 'HCR', 256735),
(437642, 'PF03131', NULL, 'bZIP Maf transcription factor', 92, NULL, 'bZIP_Maf', 256736);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(437643, 'PF10102', NULL, 'Domain of unknown function (DUF2341)', 84, NULL, 'DUF2341', 256737),
(437644, 'PF00305', NULL, 'Lipoxygenase', 673, NULL, 'Lipoxygenase', 256738),
(437645, 'PF15924', NULL, 'ALG11 mannosyltransferase N-terminus', 209, NULL, 'ALG11_N', 256739),
(437646, 'PF17050', NULL, 'Altered inheritance of mitochondria 5', 60, NULL, 'AIM5', 256740),
(437647, 'PF17899', NULL, 'Peptidase M61 N-terminal domain', 167, NULL, 'Peptidase_M61_N', 256741),
(437648, 'PF02567', NULL, 'Phenazine biosynthesis-like protein', 283, NULL, 'PhzC-PhzF', 256742),
(437649, 'PF17206', NULL, 'SeqA protein N-terminal domain', 36, NULL, 'SeqA_N', 256743),
(437650, 'PF20009', NULL, 'GEVED domain', 77, NULL, 'GEVED', 256744),
(437651, 'PF17512', NULL, 'Metapneumovirus Small hydrophobic protein', 174, NULL, 'Sh_2', 256745),
(437652, 'PF01187', NULL, 'Macrophage migration inhibitory factor (MIF)', 114, NULL, 'MIF', 256746),
(437653, 'PF14018', NULL, 'Domain of unknown function (DUF4234)', 70, NULL, 'DUF4234', 256747),
(437654, 'PF14258', NULL, 'Domain of unknown function (DUF4350)', 195, NULL, 'DUF4350', 256748),
(437655, 'PF12249', NULL, 'Arabinofuranosyltransferase A C terminal', 176, NULL, 'AftA_C', 256749),
(437656, 'PF15686', NULL, 'Lysine-rich CEACAM1 co-isolated protein family', 424, NULL, 'LYRIC', 256750),
(437657, 'PF20144', NULL, 'TIG domain', 94, NULL, 'TIG_SUH', 256751),
(437658, 'PF04280', NULL, 'Tim44-like domain', 147, NULL, 'Tim44', 256752),
(437659, 'PF05837', NULL, 'Centromere protein H (CENP-H)', 117, NULL, 'CENP-H', 256753),
(437660, 'PF00408', NULL, 'Phosphoglucomutase/phosphomannomutase, C-terminal domain', 74, NULL, 'PGM_PMM_IV', 256754),
(437661, 'PF05053', NULL, 'Menin', 680, NULL, 'Menin', 256755),
(437662, 'PF07731', NULL, 'Multicopper oxidase', 137, NULL, 'Cu-oxidase_2', 256756),
(437663, 'PF12624', NULL, 'N-terminal region of Chorein or VPS13', 116, NULL, 'Chorein_N', 256757),
(437664, 'PF18277', NULL, 'AbrB C-terminal domain', 37, NULL, 'AbrB_C', 256758),
(437665, 'PF20619', NULL, 'Family of unknown function (DUF6804)', 91, NULL, 'DUF6804', 256759),
(437666, 'PF06496', NULL, 'Protein of unknown function (DUF1097)', 146, NULL, 'DUF1097', 256760),
(437667, 'PF11779', NULL, 'Small subunit of serine palmitoyltransferase-like', 54, NULL, 'SPT_ssu-like', 256761),
(437668, 'PF20219', NULL, 'Family of unknown function (DUF6579)', 210, NULL, 'DUF6579', 256762),
(437669, 'PF16676', NULL, 'Transactivation domain of FOXO protein family', 42, NULL, 'FOXO-TAD', 256763),
(437670, 'PF06476', NULL, 'Protein of unknown function (DUF1090)', 110, NULL, 'DUF1090', 256764),
(437671, 'PF09862', NULL, 'Protein of unknown function (DUF2089)', 115, NULL, 'DUF2089', 256765),
(437672, 'PF04887', NULL, 'Poxvirus M2 protein', 196, NULL, 'Pox_M2', 256766),
(437673, 'PF15082', NULL, 'Domain of unknown function (DUF4549)', 142, NULL, 'DUF4549', 256767),
(437674, 'PF13537', NULL, 'Glutamine amidotransferase domain', 123, NULL, 'GATase_7', 256768),
(437675, 'PF14206', NULL, 'Cysteine-rich CPCC', 75, NULL, 'Cys_rich_CPCC', 256769),
(437676, 'PF12001', NULL, 'Domain of unknown function (DUF3496)', 109, NULL, 'DUF3496', 256770),
(437677, 'PF11070', NULL, 'Protein of unknown function (DUF2871)', 134, NULL, 'DUF2871', 256771),
(437678, 'PF03636', NULL, 'Glycosyl hydrolase family 65, N-terminal domain', 229, NULL, 'Glyco_hydro_65N', 256772),
(437679, 'PF00691', NULL, 'OmpA family', 99, NULL, 'OmpA', 256773),
(437680, 'PF08332', NULL, 'Calcium/calmodulin dependent protein kinase II association domain', 128, NULL, 'CaMKII_AD', 256774),
(437681, 'PF18150', NULL, 'Domain of unknown function (DUF5600)', 107, NULL, 'DUF5600', 256775),
(437682, 'PF02273', NULL, 'Acyl transferase', 294, NULL, 'Acyl_transf_2', 256776),
(437683, 'PF05544', NULL, 'Proline racemase', 325, NULL, 'Pro_racemase', 256777),
(437684, 'PF02918', NULL, 'Pertussis toxin, subunit 2 and 3, C-terminal domain', 109, NULL, 'Pertussis_S2S3', 256778),
(437685, 'PF09666', NULL, 'Sororin protein', 157, NULL, 'Sororin', 256779),
(437686, 'PF04787', NULL, 'Late protein H7', 143, NULL, 'Pox_H7', 256780);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(437687, 'PF06017', NULL, 'Unconventional myosin tail, actin- and lipid-binding', 189, NULL, 'Myosin_TH1', 256781),
(437688, 'PF12786', NULL, 'GB virus C genotype envelope', 413, NULL, 'GBV-C_env', 256782),
(437689, 'PF00757', NULL, 'Furin-like cysteine rich region', 149, NULL, 'Furin-like', 256783),
(437690, 'PF13785', NULL, 'Domain of unknown function (DUF4178)', 142, NULL, 'DUF4178', 256784),
(437691, 'PF16042', NULL, 'Domain of unknown function (DUF4794)', 79, NULL, 'DUF4794', 256785),
(437692, 'PF13044', NULL, 'Fusion glycoprotein F0, Isavirus', 436, NULL, 'Fusion_F0', 256786),
(437693, 'PF17223', NULL, 'Cuticle protein CPCFC', 17, NULL, 'CPCFC', 256787),
(437694, 'PF09656', NULL, 'Putative transmembrane protein (PGPGW)', 53, NULL, 'PGPGW', 256788),
(437695, 'PF12393', NULL, 'Dr family adhesin', 21, NULL, 'Dr_adhesin', 256789),
(437696, 'PF03514', NULL, 'GRAS domain family', 374, NULL, 'GRAS', 256790),
(437697, 'PF08816', NULL, 'Inhibitor of vertebrate lysozyme (Ivy)', 117, NULL, 'Ivy', 256791),
(437698, 'PF13519', NULL, 'von Willebrand factor type A domain', 108, NULL, 'VWA_2', 256792),
(437699, 'PF20423', NULL, 'Isocitrate dehydrogenase kinase/phosphatase (AceK), regulatory domain', 302, NULL, 'AceK_regulatory', 256793),
(437700, 'PF17693', NULL, 'Family of unknown function (DUF5539)', 232, NULL, 'DUF5539', 256794),
(437701, 'PF18021', NULL, 'Agglutinin C-terminal', 93, NULL, 'Agglutinin_C', 256795),
(437702, 'PF14835', NULL, 'zf-RING of BARD1-type protein', 65, NULL, 'zf-RING_6', 256796),
(437703, 'PF00931', NULL, 'NB-ARC domain', 252, NULL, 'NB-ARC', 256797),
(437704, 'PF18410', NULL, 'Basic tilted helix bundle domain', 72, NULL, 'BTHB', 256798),
(437705, 'PF03263', NULL, 'Cucumovirus protein 2B', 105, NULL, 'Cucumo_2B', 256799),
(437706, 'PF05835', NULL, 'Synaphin protein', 142, NULL, 'Synaphin', 256800),
(437707, 'PF11455', NULL, 'Antitoxin MazE-like', 64, NULL, 'MazE-like', 256801),
(437708, 'PF13491', NULL, '4TM region of DNA translocase FtsK/SpoIIIE', 171, NULL, 'FtsK_4TM', 256802),
(437709, 'PF10537', NULL, 'ATP-utilising chromatin assembly and remodelling N-terminal', 101, NULL, 'WAC_Acf1_DNA_bd', 256803),
(437710, 'PF16460', NULL, 'Phage tail tube, TTP, lambda-like', 137, NULL, 'Phage_TTP_11', 256804),
(437711, 'PF00477', NULL, 'Small hydrophilic plant seed protein', 109, NULL, 'LEA_5', 256805),
(437712, 'PF15225', NULL, 'Interleukin 32', 101, NULL, 'IL32', 256806),
(437713, 'PF06309', NULL, 'Torsin', 127, NULL, 'Torsin', 256807),
(437714, 'PF09935', NULL, 'Protein of unknown function (DUF2167)', 239, NULL, 'DUF2167', 256808),
(437715, 'PF02217', NULL, 'Origin of replication binding protein', 94, NULL, 'T_Ag_DNA_bind', 256809),
(437716, 'PF16146', NULL, 'Domain of unknown function (DUF4854)', 105, NULL, 'DUF4854', 256810),
(437717, 'PF01846', NULL, 'FF domain', 51, NULL, 'FF', 256811),
(437718, 'PF11220', NULL, 'Protein of unknown function (DUF3015)', 142, NULL, 'DUF3015', 256812),
(437719, 'PF20580', NULL, 'Domain of unknown function (DUF6784)', 101, NULL, 'DUF6784', 256813),
(437720, 'PF13391', NULL, 'HNH endonuclease', 73, NULL, 'HNH_2', 256814),
(437721, 'PF17048', NULL, 'Neutral/alkaline non-lysosomal ceramidase, C-terminal', 169, NULL, 'Ceramidse_alk_C', 256815),
(437722, 'PF07302', NULL, 'AroM protein', 218, NULL, 'AroM', 256816),
(437723, 'PF11401', NULL, 'Tetrabrachion', 49, NULL, 'Tetrabrachion', 256817),
(437724, 'PF13290', NULL, 'Chitobiase/beta-hexosaminidase C-terminal domain', 67, NULL, 'CHB_HEX_C_1', 256818),
(437725, 'PF17634', NULL, 'Gene product 67', 80, NULL, 'GP67', 256819),
(437726, 'PF16186', NULL, 'Atypical Arm repeat', 53, NULL, 'Arm_3', 256820),
(437727, 'PF06134', NULL, 'L-rhamnose isomerase (RhaA)', 417, NULL, 'RhaA', 256821),
(437728, 'PF19064', NULL, 'Family of unknown function (DUF5760)', 86, NULL, 'DUF5760', 256822),
(437729, 'PF19114', NULL, 'EsV-1-7 cysteine-rich motif', 26, NULL, 'EsV_1_7_cys', 256823),
(437730, 'PF03840', NULL, 'Preprotein translocase SecG subunit', 71, NULL, 'SecG', 256824),
(437731, 'PF00312', NULL, 'Ribosomal protein S15', 81, NULL, 'Ribosomal_S15', 256825);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(437732, 'PF17588', NULL, 'Family of unknown function (DUF5486)', 53, NULL, 'DUF5486', 256826),
(437733, 'PF18019', NULL, 'HD domain', 197, NULL, 'HD_6', 256827),
(437734, 'PF04601', NULL, 'Domain of unknown function (DUF569)', 142, NULL, 'DUF569', 256828),
(437735, 'PF13569', NULL, 'Domain of unknown function (DUF4132)', 180, NULL, 'DUF4132', 256829),
(437736, 'PF02232', NULL, 'Alpha trans-inducing protein (Alpha-TIF)', 343, NULL, 'Alpha_TIF', 256830),
(437737, 'PF03591', NULL, 'AzlC protein', 136, NULL, 'AzlC', 256831),
(437738, 'PF08272', NULL, 'Topoisomerase I zinc-ribbon-like', 41, NULL, 'Topo_Zn_Ribbon', 256832),
(437739, 'PF07619', NULL, 'Protein of unknown function (DUF1581)', 84, NULL, 'DUF1581', 256833),
(437740, 'PF09926', NULL, 'Uncharacterized small protein (DUF2158)', 52, NULL, 'DUF2158', 256834),
(437741, 'PF12088', NULL, 'Protein of unknown function (DUF3565)', 58, NULL, 'DUF3565', 256835),
(437742, 'PF05189', NULL, 'RNA 3''-terminal phosphate cyclase (RTC), insert domain', 103, NULL, 'RTC_insert', 256836),
(437743, 'PF15755', NULL, 'Domain of unknown function (DUF4689)', 223, NULL, 'DUF4689', 256837),
(437744, 'PF04996', NULL, 'Succinylarginine dihydrolase', 443, NULL, 'AstB', 256838),
(437745, 'PF07225', NULL, 'NADH-ubiquinone oxidoreductase B15 subunit (NDUFB4)', 124, NULL, 'NDUF_B4', 256839),
(437746, 'PF10176', NULL, 'Protein of unknown function (DUF2370)', 226, NULL, 'DUF2370', 256840),
(437747, 'PF10438', NULL, 'Cyclo-malto-dextrinase C-terminal domain', 76, NULL, 'Cyc-maltodext_C', 256841),
(437748, 'PF14058', NULL, 'PcfK-like protein', 125, NULL, 'PcfK', 256842),
(437749, 'PF19882', NULL, 'Family of unknown function (DUF6355)', 63, NULL, 'DUF6355', 256843),
(437750, 'PF07559', NULL, 'Flagellar basal body protein FlaE', 131, NULL, 'FlaE', 256844),
(437751, 'PF06890', NULL, 'Bacteriophage Mu Gp45 spike protein', 68, NULL, 'Phage_Mu_Gp45', 256845),
(437752, 'PF06107', NULL, 'Bacterial protein of unknown function (DUF951)', 55, NULL, 'DUF951', 256846),
(437753, 'PF09871', NULL, 'Uncharacterized protein conserved in archaea (DUF2098)', 94, NULL, 'DUF2098', 256847),
(437754, 'PF00946', NULL, 'Mononegavirales RNA dependent RNA polymerase', 1068, NULL, 'Mononeg_RNA_pol', 256848),
(437755, 'PF15484', NULL, 'Domain of unknown function (DUF4642)', 159, NULL, 'DUF4642', 256849),
(437756, 'PF06676', NULL, 'Protein of unknown function (DUF1178)', 150, NULL, 'DUF1178', 256850),
(437757, 'PF16987', NULL, 'KIX domain', 82, NULL, 'KIX_2', 256851),
(437758, 'PF03689', NULL, 'Nepovirus coat protein, N-terminal domain', 91, NULL, 'Nepo_coat_N', 256852),
(437759, 'PF12143', NULL, 'Protein of unknown function (DUF_B2219)', 130, NULL, 'PPO1_KFDV', 256853),
(437760, 'PF00949', NULL, 'Peptidase S7, Flavivirus NS3 serine protease', 131, NULL, 'Peptidase_S7', 256854),
(437761, 'PF03882', NULL, 'MukF winged-helix domain', 115, NULL, 'KicB', 256855),
(437762, 'PF05185', NULL, 'PRMT5 arginine-N-methyltransferase', 173, NULL, 'PRMT5', 256856),
(437763, 'PF17858', NULL, 'Platypus intermediate defensin-like peptide', 44, NULL, 'Defensin_int', 256857),
(437764, 'PF05520', NULL, 'Citrus tristeza virus P18 protein', 167, NULL, 'Citrus_P18', 256858),
(437765, 'PF07202', NULL, 'T-complex protein 10 C-terminus', 35, NULL, 'Tcp10_C', 256859),
(437766, 'PF07689', NULL, 'KaiB domain', 82, NULL, 'KaiB', 256860),
(437767, 'PF18395', NULL, 'Cas3 C-terminal domain', 106, NULL, 'Cas3_C', 256861),
(437768, 'PF06009', NULL, 'Laminin Domain II', 138, NULL, 'Laminin_II', 256862),
(437769, 'PF14853', NULL, 'Fis1 C-terminal tetratricopeptide repeat', 53, NULL, 'Fis1_TPR_C', 256863),
(437770, 'PF13929', NULL, 'mRNA stabilisation', 288, NULL, 'mRNA_stabil', 256864),
(437771, 'PF06652', NULL, 'Methuselah N-terminus', 178, NULL, 'Methuselah_N', 256865),
(437772, 'PF07799', NULL, 'Protein of unknown function (DUF1643)', 134, NULL, 'DUF1643', 256866),
(437773, 'PF08931', NULL, 'Receptor-binding protein of phage tail base-plate Siphoviridae, head', 262, NULL, 'Caudo_bapla_RBP', 256867),
(437774, 'PF02001', NULL, 'Protein of unknown function  DUF134', 98, NULL, 'DUF134', 256868);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(437775, 'PF06852', NULL, 'Protein of unknown function (DUF1248)', 181, NULL, 'DUF1248', 256869),
(437776, 'PF15253', NULL, 'SCL-interrupting locus protein N-terminus', 404, NULL, 'STIL_N', 256870),
(437777, 'PF17341', NULL, 'Family of unknown function (DUF5371)', 65, NULL, 'DUF5371', 256871),
(437778, 'PF06448', NULL, 'Domain of Unknown Function (DUF1081)', 114, NULL, 'DUF1081', 256872),
(437779, 'PF09626', NULL, 'Dihaem cytochrome c', 111, NULL, 'DHC', 256873),
(437780, 'PF06862', NULL, 'Utp25, U3 small nucleolar RNA-associated SSU processome protein 25', 473, NULL, 'UTP25', 256874),
(437781, 'PF04016', NULL, 'Putative heavy-metal chelation', 147, NULL, 'DUF364', 256875),
(437782, 'PF06246', NULL, 'Isy1-like splicing family', 260, NULL, 'Isy1', 256876),
(437783, 'PF19807', NULL, 'Family of unknown function (DUF6290)', 72, NULL, 'DUF6290', 256877),
(437784, 'PF06450', NULL, 'Bacterial Na+/H+ antiporter B (NhaB)', 515, NULL, 'NhaB', 256878),
(437785, 'PF03253', NULL, 'Urea transporter', 293, NULL, 'UT', 256879),
(437786, 'PF03443', NULL, 'Auxiliary Activity family 9 (formerly GH61)', 205, NULL, 'AA9', 256880),
(437787, 'PF10528', NULL, 'GLEYA domain', 91, NULL, 'GLEYA', 256881),
(437788, 'PF17431', NULL, 'Uncharacterized YmpT-like', 62, NULL, 'YpmT', 256882),
(437789, 'PF14163', NULL, 'Super-infection exclusion protein B', 147, NULL, 'SieB', 256883),
(437790, 'PF01749', NULL, 'Importin beta binding domain', 89, NULL, 'IBB', 256884),
(437791, 'PF02861', NULL, 'Clp amino terminal domain, pathogenicity island component', 53, NULL, 'Clp_N', 256885),
(437792, 'PF13232', NULL, 'Complex1_LYR-like', 97, NULL, 'Complex1_LYR_1', 256886),
(437793, 'PF03937', NULL, 'Flavinator of succinate dehydrogenase', 75, NULL, 'Sdh5', 256887),
(437794, 'PF06461', NULL, 'CHD subfamily II, SANT-like domain', 138, NULL, 'CHDII_SANT-like', 256888),
(437795, 'PF16215', NULL, 'Protein of unknown function (DUF4876)', 188, NULL, 'DUF4876', 256889),
(437796, 'PF20328', NULL, 'Family of unknown function (DUF6623)', 149, NULL, 'DUF6623', 256890),
(437797, 'PF10834', NULL, 'Protein of unknown function (DUF2560)', 72, NULL, 'DUF2560', 256891),
(437798, 'PF04446', NULL, 'tRNAHis guanylyltransferase', 132, NULL, 'Thg1', 256892),
(437799, 'PF13125', NULL, 'Protein of unknown function (DUF3958)', 107, NULL, 'DUF3958', 256893),
(437800, 'PF17079', NULL, 'Male-specific protein scotti', 101, NULL, 'SOTI', 256894),
(437801, 'PF00005', NULL, 'ABC transporter', 137, NULL, 'ABC_tran', 256895),
(437802, 'PF16635', NULL, 'Unstructured region on APC between SAMP and APC_crr', 94, NULL, 'APC_u14', 256896),
(437803, 'PF05690', NULL, 'Thiazole biosynthesis protein ThiG', 247, NULL, 'ThiG', 256897),
(437804, 'PF13901', NULL, 'Putative zinc-RING and/or ribbon', 205, NULL, 'zf-RING_9', 256898),
(437805, 'PF19024', NULL, 'Family of unknown function (DUF5750)', 91, NULL, 'DUF5750', 256899),
(437806, 'PF01967', NULL, 'MoaC family', 136, NULL, 'MoaC', 256900),
(437807, 'PF10454', NULL, 'Protein of unknown function (DUF2458)', 172, NULL, 'DUF2458', 256901),
(437808, 'PF13386', NULL, 'Cytochrome C biogenesis protein transmembrane region', 199, NULL, 'DsbD_2', 256902),
(437809, 'PF09495', NULL, 'Protein of unknown function (DUF2462)', 77, NULL, 'DUF2462', 256903),
(437810, 'PF18779', NULL, 'Capping Ribonuclease inhibitor Leucine Rich Repeat', 30, NULL, 'LRR_RI_capping', 256904),
(437811, 'PF20048', NULL, 'Domain of unknown function (DUF6450)', 68, NULL, 'DUF6450', 256905),
(437812, 'PF18575', NULL, 'HAMP N-terminal domain 3', 43, NULL, 'HAMP_N3', 256906),
(437813, 'PF18586', NULL, 'Chromatin remodeling factor Mit1 C-terminal Zn finger 1', 90, NULL, 'zf-CCCH_7', 256907),
(437814, 'PF10232', NULL, 'Mediator of RNA polymerase II transcription complex subunit 8', 231, NULL, 'Med8', 256908),
(437815, 'PF10561', NULL, 'C2orf69', 299, NULL, 'C2orf69', 256909),
(437816, 'PF19453', NULL, 'Family of unknown function (DUF5991)', 124, NULL, 'DUF5991', 256910),
(437817, 'PF02901', NULL, 'Pyruvate formate lyase-like', 647, NULL, 'PFL-like', 256911),
(437818, 'PF00871', NULL, 'Acetokinase family', 392, NULL, 'Acetate_kinase', 256912);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(437819, 'PF12064', NULL, 'Protein kinase C-binding protein 1', 198, NULL, 'DUF3544', 256913),
(437820, 'PF03456', NULL, 'uDENN domain', 57, NULL, 'uDENN', 256914),
(437821, 'PF06209', NULL, 'Cofactor of BRCA1 (COBRA1)', 346, NULL, 'COBRA1', 256915),
(437822, 'PF10817', NULL, 'Protein of unknown function (DUF2563)', 104, NULL, 'DUF2563', 256916),
(437823, 'PF11095', NULL, 'Gem-associated protein 7 (Gemin7)', 76, NULL, 'Gemin7', 256917),
(437824, 'PF12738', NULL, 'twin BRCT domain', 63, NULL, 'PTCB-BRCT', 256918),
(437825, 'PF04608', NULL, 'Phosphatidylglycerophosphatase A', 135, NULL, 'PgpA', 256919),
(437826, 'PF00426', NULL, 'Outer Capsid protein VP4 (Hemagglutinin) Concanavalin-like domain', 170, NULL, 'VP4_haemagglut', 256920),
(437827, 'PF00023', NULL, 'Ankyrin repeat', 33, NULL, 'Ank', 256921),
(437828, 'PF09768', NULL, 'Peptidase M76 family', 171, NULL, 'Peptidase_M76', 256922),
(437829, 'PF01881', NULL, 'CRISPR associated protein Cas6, C-terminal', 124, NULL, 'Cas_Cas6_C', 256923),
(437830, 'PF07741', NULL, 'Brf1-like TBP-binding domain', 102, NULL, 'BRF1', 256924),
(437831, 'PF10315', NULL, 'Altered inheritance of mitochondria protein 19', 118, NULL, 'Aim19', 256925),
(437832, 'PF13630', NULL, 'SdpI/YfhL protein family', 68, NULL, 'SdpI', 256926),
(437833, 'PF11399', NULL, 'Protein of unknown function (DUF3192)', 102, NULL, 'DUF3192', 256927),
(437834, 'PF12221', NULL, 'Bacterial membrane protein N terminal', 46, NULL, 'HflK_N', 256928),
(437835, 'PF05073', NULL, 'Baculovirus P24 capsid protein', 182, NULL, 'Baculo_p24', 256929),
(437836, 'PF20579', NULL, 'LapA domain', 99, NULL, 'LapA', 256930),
(437837, 'PF14456', NULL, 'Alpha-helical domain 2', 303, NULL, 'alpha-hel2', 256931),
(437838, 'PF00108', NULL, 'Thiolase, N-terminal domain', 260, NULL, 'Thiolase_N', 256932),
(437839, 'PF18227', NULL, 'LepB GAP domain C-terminal subdomain', 80, NULL, 'LepB_GAP_C', 256933),
(437840, 'PF01969', NULL, 'Nickel insertion protein', 372, NULL, 'Ni_insertion', 256934),
(437841, 'PF09372', NULL, 'PRANC domain', 97, NULL, 'PRANC', 256935),
(437842, 'PF02940', NULL, 'mRNA capping enzyme, beta chain', 221, NULL, 'mRNA_triPase', 256936),
(437843, 'PF16076', NULL, 'Acyltransferase C-terminus', 74, NULL, 'Acyltransf_C', 256937),
(437844, 'PF13419', NULL, 'Haloacid dehalogenase-like hydrolase', 178, NULL, 'HAD_2', 256938),
(437845, 'PF16940', NULL, 'Chloroplast envelope transporter', 574, NULL, 'Tic110', 256939),
(437846, 'PF03968', NULL, 'LptA/(LptD N-terminal domain) LPS transport protein', 113, NULL, 'LptD_N', 256940),
(437847, 'PF06442', NULL, 'R67 dihydrofolate reductase', 78, NULL, 'DHFR_2', 256941),
(437848, 'PF16027', NULL, 'Domain of unknown function (DUF4786)', 169, NULL, 'DUF4786', 256942),
(437849, 'PF18385', NULL, 'T-lymphoma invasion and metastasis CC-Ex domain', 98, NULL, 'Tiam_CC_Ex', 256943),
(437850, 'PF10491', NULL, 'NLS-binding and DNA-binding and dimerisation domains of Nrf1', 213, NULL, 'Nrf1_DNA-bind', 256944),
(437851, 'PF20303', NULL, 'YEATS-Like-Associating Three TM', 108, NULL, 'YLATT', 256945),
(437852, 'PF01497', NULL, 'Periplasmic binding protein', 237, NULL, 'Peripla_BP_2', 256946),
(437853, 'PF06470', NULL, 'SMC proteins Flexible Hinge Domain', 117, NULL, 'SMC_hinge', 256947),
(437854, 'PF08741', NULL, 'YwhD family', 162, NULL, 'YwhD', 256948),
(437855, 'PF10031', NULL, 'Small integral membrane protein (DUF2273)', 48, NULL, 'DUF2273', 256949),
(437856, 'PF12556', NULL, 'Cobaltochelatase CobS subunit N terminal', 34, NULL, 'CobS_N', 256950),
(437857, 'PF05761', NULL, '5'' nucleotidase family', 461, NULL, '5_nucleotid', 256951),
(437858, 'PF14632', NULL, 'Acidic N-terminal SPT6', 89, NULL, 'SPT6_acidic', 256952),
(437859, 'PF00797', NULL, 'N-acetyltransferase', 240, NULL, 'Acetyltransf_2', 256953),
(437860, 'PF02705', NULL, 'K+ potassium transporter', 533, NULL, 'K_trans', 256954),
(437861, 'PF07131', NULL, 'Protein of unknown function (DUF1382)', 60, NULL, 'DUF1382', 256955),
(437862, 'PF15739', NULL, 'Translin-associated factor X-interacting N-terminus', 111, NULL, 'TSNAXIP1_N', 256956);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(437863, 'PF01026', NULL, 'TatD related DNase', 255, NULL, 'TatD_DNase', 256957),
(437864, 'PF13588', NULL, 'Type I restriction enzyme R protein N terminus (HSDR_N)', 110, NULL, 'HSDR_N_2', 256958),
(437865, 'PF16719', NULL, 'SAWADEE domain', 141, NULL, 'SAWADEE', 256959),
(437866, 'PF08539', NULL, 'HbrB-like', 169, NULL, 'HbrB', 256960),
(437867, 'PF15956', NULL, 'Domain of unknown function (DUF4760)', 142, NULL, 'DUF4760', 256961),
(437868, 'PF07304', NULL, 'Steroid receptor RNA activator (SRA1)', 147, NULL, 'SRA1', 256962),
(437869, 'PF08359', NULL, 'YsiA-like protein, C-terminal region', 133, NULL, 'TetR_C_4', 256963),
(437870, 'PF10287', NULL, 'Cell wall protein YJL171C/Tos1, C-terminal', 227, NULL, 'YJL171C_Tos1_C', 256964),
(437871, 'PF05643', NULL, 'Putative bacterial lipoprotein (DUF799)', 185, NULL, 'DUF799', 256965),
(437872, 'PF05916', NULL, 'GINS complex protein', 109, NULL, 'Sld5', 256966),
(437873, 'PF19804', NULL, 'Domain of unknown function (DUF6287)', 34, NULL, 'DUF6287', 256967),
(437874, 'PF03922', NULL, 'OmpW family', 193, NULL, 'OmpW', 256968),
(437875, 'PF15271', NULL, 'Spindle pole body component BBP1, Mps2-binding protein', 152, NULL, 'BBP1_N', 256969),
(437876, 'PF10963', NULL, 'Phage tail assembly chaperone', 82, NULL, 'Phage_TAC_10', 256970),
(437877, 'PF17732', NULL, 'Family of unknown function (DUF5571)', 353, NULL, 'DUF5571', 256971),
(437878, 'PF06165', NULL, 'Glycosyltransferase family 36', 251, NULL, 'Glyco_transf_36', 256972),
(437879, 'PF04890', NULL, 'Family of unknown function (DUF648)', 287, NULL, 'DUF648', 256973),
(437880, 'PF13841', NULL, 'Beta defensin', 30, NULL, 'Defensin_beta_2', 256974),
(437881, 'PF11348', NULL, 'Protein of unknown function (DUF3150)', 257, NULL, 'DUF3150', 256975),
(437882, 'PF19126', NULL, 'Family of unknown function (DUF5810)', 66, NULL, 'DUF5810', 256976),
(437883, 'PF11216', NULL, 'Protein of unknown function (DUF3012)', 32, NULL, 'DUF3012', 256977),
(437884, 'PF20154', NULL, 'Apolipoprotein N-acyltransferase N-terminal domain', 156, NULL, 'LNT_N', 256978),
(437885, 'PF11949', NULL, 'Protein of unknown function (DUF3466)', 608, NULL, 'DUF3466', 256979),
(437886, 'PF05405', NULL, 'Mitochondrial ATP synthase B chain precursor (ATP-synt_B)', 163, NULL, 'Mt_ATP-synt_B', 256980),
(437887, 'PF05873', NULL, 'ATP synthase D chain, mitochondrial (ATP5H)', 154, NULL, 'Mt_ATP-synt_D', 256981),
(437888, 'PF14932', NULL, 'HAUS augmin-like complex subunit 3', 261, NULL, 'HAUS-augmin3', 256982),
(437889, 'PF19401', NULL, 'Family of unknown function (DUF5976)', 50, NULL, 'DUF5976', 256983),
(437890, 'PF11137', NULL, 'Protein of unknown function (DUF2909)', 60, NULL, 'DUF2909', 256984),
(437891, 'PF19990', NULL, 'Family of unknown function (DUF6426)', 210, NULL, 'DUF6426', 256985),
(437892, 'PF02267', NULL, 'ADP-ribosyl cyclase', 241, NULL, 'Rib_hydrolayse', 256986),
(437893, 'PF15040', NULL, 'Humanin family', 24, NULL, 'Humanin', 256987),
(437894, 'PF09839', NULL, 'Uncharacterized protein conserved in bacteria (DUF2066)', 233, NULL, 'DUF2066', 256988),
(437895, 'PF18274', NULL, 'Vacuolar ATPase Subunit I N-terminal proximal lobe', 52, NULL, 'V_ATPase_prox', 256989),
(437896, 'PF10872', NULL, 'Protein of unknown function (DUF2740)', 48, NULL, 'DUF2740', 256990),
(437897, 'PF20035', NULL, 'Family of unknown function (DUF6439)', 92, NULL, 'DUF6439', 256991),
(437898, 'PF17754', NULL, 'MftR C-terminal domain', 112, NULL, 'TetR_C_14', 256992),
(437899, 'PF19758', NULL, 'Family of unknown function (DUF6245)', 168, NULL, 'DUF6245', 256993),
(437900, 'PF20497', NULL, 'SWI/SNF and RSC complexes subunit Ssr4 C-terminal', 460, NULL, 'SWI-SNF_Ssr4_C', 256994),
(437901, 'PF20127', NULL, 'Family of unknown function (DUF6517)', 186, NULL, 'DUF6517', 256995),
(437902, 'PF19936', NULL, 'Family of unknown function (DUF6399)', 146, NULL, 'DUF6399', 256996),
(437903, 'PF09986', NULL, 'Uncharacterized protein conserved in bacteria (DUF2225)', 214, NULL, 'DUF2225', 256997),
(437904, 'PF07817', NULL, 'GLE1-like protein', 250, NULL, 'GLE1', 256998),
(437905, 'PF04195', NULL, 'Putative gypsy type transposon', 69, NULL, 'Transposase_28', 256999);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(437906, 'PF05426', NULL, 'Alginate lyase', 272, NULL, 'Alginate_lyase', 257000),
(437907, 'PF14687', NULL, 'Domain of unknown function (DUF4460)', 110, NULL, 'DUF4460', 257001),
(437908, 'PF07820', NULL, 'TraC-like protein', 88, NULL, 'TraC', 257002),
(437909, 'PF19389', NULL, 'Family of unknown function (DUF5964)', 60, NULL, 'DUF5964', 257003),
(437910, 'PF04914', NULL, 'DltD protein', 349, NULL, 'DltD', 257004),
(437911, 'PF06265', NULL, 'Putative antitoxin YutD-like', 85, NULL, 'YutD-like', 257005),
(437912, 'PF13928', NULL, 'Flocculin type 3 repeat', 44, NULL, 'Flocculin_t3', 257006),
(437913, 'PF09449', NULL, 'Domain of unknown function (DUF2020)', 144, NULL, 'DUF2020', 257007),
(437914, 'PF17608', NULL, 'Family of unknown function (DUF5504)', 124, NULL, 'DUF5504', 257008),
(437915, 'PF14223', NULL, 'gag-polypeptide of LTR copia-type', 138, NULL, 'Retrotran_gag_2', 257009),
(437916, 'PF10780', NULL, '39S ribosomal protein L53/MRP-L53', 53, NULL, 'MRP_L53', 257010),
(437917, 'PF18708', NULL, 'MapZ extracellular C-terminal domain 2', 94, NULL, 'MapZ_C2', 257011),
(437918, 'PF18958', NULL, 'Putative zinc dependent peptidase (DUF5700)', 283, NULL, 'DUF5700', 257012),
(437919, 'PF17902', NULL, 'SH3 domain', 65, NULL, 'SH3_10', 257013),
(437920, 'PF05772', NULL, 'NinB protein', 127, NULL, 'NinB', 257014),
(437921, 'PF08926', NULL, 'Domain of unknown function (DUF1908)', 284, NULL, 'DUF1908', 257015),
(437922, 'PF05956', NULL, 'APC basic domain', 344, NULL, 'APC_basic', 257016),
(437923, 'PF10450', NULL, 'POC1 chaperone', 273, NULL, 'POC1', 257017),
(437924, 'PF11326', NULL, 'Protein of unknown function (DUF3128)', 79, NULL, 'DUF3128', 257018),
(437925, 'PF12444', NULL, 'Sox developmental protein N terminal', 77, NULL, 'Sox_N', 257019),
(437926, 'PF02755', NULL, 'RPEL repeat', 24, NULL, 'RPEL', 257020),
(437927, 'PF08955', NULL, 'BofC C-terminal domain', 74, NULL, 'BofC_C', 257021),
(437928, 'PF10951', NULL, 'Protein of unknown function (DUF2776)', 348, NULL, 'DUF2776', 257022),
(437929, 'PF14596', NULL, 'STAT6 C-terminal', 193, NULL, 'STAT6_C', 257023),
(437930, 'PF06753', NULL, 'Bradykinin', 19, NULL, 'Bradykinin', 257024),
(437931, 'PF08776', NULL, 'VASP tetramerisation domain', 36, NULL, 'VASP_tetra', 257025),
(437932, 'PF15645', NULL, 'Dermonecrotoxin of the Papain-like fold', 141, NULL, 'Tox-PLDMTX', 257026),
(437933, 'PF10015', NULL, 'Uncharacterized protein conserved in archaea (DUF2258)', 78, NULL, 'DUF2258', 257027),
(437934, 'PF00779', NULL, 'BTK motif', 30, NULL, 'BTK', 257028),
(437935, 'PF15010', NULL, 'Putative cell signalling', 291, NULL, 'FAM131', 257029),
(437936, 'PF01926', NULL, '50S ribosome-binding GTPase', 114, NULL, 'MMR_HSR1', 257030),
(437937, 'PF06713', NULL, 'Bacterial PH domain', 74, NULL, 'bPH_4', 257031),
(437938, 'PF06954', NULL, 'Resistin', 88, NULL, 'Resistin', 257032),
(437939, 'PF16716', NULL, 'Bone marrow stromal antigen 2', 91, NULL, 'BST2', 257033),
(437940, 'PF06195', NULL, 'Protein of unknown function (DUF996)', 138, NULL, 'DUF996', 257034),
(437941, 'PF01982', NULL, 'Domain of unknown function DUF120', 121, NULL, 'CTP-dep_RFKase', 257035),
(437942, 'PF01566', NULL, 'Natural resistance-associated macrophage protein', 359, NULL, 'Nramp', 257036),
(437943, 'PF01175', NULL, 'Urocanase Rossmann-like domain', 209, NULL, 'Urocanase', 257037),
(437944, 'PF01289', NULL, 'Thiol-activated cytolysin', 354, NULL, 'Thiol_cytolysin', 257038),
(437945, 'PF17027', NULL, 'Histone-fold protein', 119, NULL, 'Bromo_TP_like', 257039),
(437946, 'PF12103', NULL, 'Surface lipoprotein of Spirochaetales order', 179, NULL, 'Lipl32', 257040),
(437947, 'PF11079', NULL, 'Bacterial protein YqhG of unknown function', 258, NULL, 'YqhG', 257041),
(437948, 'PF00835', NULL, 'SNAP-25 family', 56, NULL, 'SNAP-25', 257042),
(437949, 'PF18425', NULL, 'Csp protease B prodomain', 89, NULL, 'CspB_prodomain', 257043),
(437950, 'PF04610', NULL, 'TrbL/VirB6 plasmid conjugal transfer protein', 215, NULL, 'TrbL', 257044),
(437951, 'PF16060', NULL, 'Domain of unknown function (DUF4802)', 64, NULL, 'DUF4802', 257045);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(437952, 'PF03785', NULL, 'Peptidase family C25, C terminal ig-like domain', 79, NULL, 'Peptidase_C25_C', 257046),
(437953, 'PF04423', NULL, 'Rad50 zinc hook motif', 52, NULL, 'Rad50_zn_hook', 257047),
(437954, 'PF13825', NULL, 'Paramyxovirus structural protein V/P N-terminus', 309, NULL, 'Paramyxo_P_V_N', 257048),
(437955, 'PF06830', NULL, 'Root cap', 57, NULL, 'Root_cap', 257049),
(437956, 'PF07474', NULL, 'G2F domain', 184, NULL, 'G2F', 257050),
(437957, 'PF16583', NULL, 'Zinc-regulated secreted antivirulence protein C-terminal domain', 145, NULL, 'ZirS_C', 257051),
(437958, 'PF19554', NULL, 'Family of unknown function (DUF6077)', 354, NULL, 'DUF6077', 257052),
(437959, 'PF19978', NULL, 'Tail virion protein G7P', 33, NULL, 'Inovirus_G7P_2', 257053),
(437960, 'PF07129', NULL, 'Protein of unknown function (DUF1381)', 44, NULL, 'DUF1381', 257054),
(437961, 'PF18322', NULL, 'Serine protease Clip domain PPAF-2', 53, NULL, 'CLIP_1', 257055),
(437962, 'PF19734', NULL, 'Family of unknown function (DUF6224)', 146, NULL, 'DUF6224', 257056),
(437963, 'PF07509', NULL, 'Protein of unknown function (DUF1523)', 176, NULL, 'DUF1523', 257057),
(437964, 'PF10621', NULL, 'F420H2 dehydrogenase subunit FpoO', 110, NULL, 'FpoO', 257058),
(437965, 'PF14859', NULL, 'Colicin M', 270, NULL, 'Colicin_M', 257059),
(437966, 'PF01081', NULL, 'KDPG and KHG aldolase', 196, NULL, 'Aldolase', 257060),
(437967, 'PF14902', NULL, 'Domain of unknown function (DUF4494)', 139, NULL, 'DUF4494', 257061),
(437968, 'PF18619', NULL, 'GPCR-Autoproteolysis-INducing (GAIN) subdomain A', 48, NULL, 'GAIN_A', 257062),
(437969, 'PF20552', NULL, 'Recombinase-like helix-turn-helix domain', 72, NULL, 'HTH_62', 257063),
(437970, 'PF19337', NULL, 'BMP and activin membrane-bound inhibitor homolog C-terminus', 138, NULL, 'BAMBI_C', 257064),
(437971, 'PF06066', NULL, 'SepZ', 99, NULL, 'SepZ', 257065),
(437972, 'PF11472', NULL, 'Protein of unknown function (DUF3206)', 128, NULL, 'DUF3206', 257066),
(437973, 'PF17275', NULL, 'Family of unknown function (DUF5340)', 70, NULL, 'DUF5340', 257067),
(437974, 'PF19864', NULL, 'Radical SAM proteins, N-terminal', 151, NULL, 'Radical_SAM_N2', 257068),
(437975, 'PF10660', NULL, 'Iron-containing outer mitochondrial membrane protein N-terminus', 64, NULL, 'MitoNEET_N', 257069),
(437976, 'PF17221', NULL, 'COMMD1 N-terminal domain', 102, NULL, 'COMMD1_N', 257070),
(437977, 'PF00778', NULL, 'DIX domain', 77, NULL, 'DIX', 257071),
(437978, 'PF03628', NULL, 'PapG chaperone-binding domain', 108, NULL, 'PapG_C', 257072),
(437979, 'PF14465', NULL, 'NFRKB Winged Helix-like', 103, NULL, 'NFRKB_winged', 257073),
(437980, 'PF04064', NULL, 'Domain of unknown function (DUF384)', 55, NULL, 'DUF384', 257074),
(437981, 'PF06599', NULL, 'Protein of unknown function (DUF1139)', 309, NULL, 'DUF1139', 257075),
(437982, 'PF06583', NULL, 'Neogenin C-terminus', 297, NULL, 'Neogenin_C', 257076),
(437983, 'PF20184', NULL, 'Family of unknown function (DUF6547)', 117, NULL, 'DUF6547', 257077),
(437984, 'PF15568', NULL, 'Immunity protein 39', 129, NULL, 'Imm39', 257078),
(437985, 'PF18467', NULL, 'Domain of unknown function (DUF5613)', 97, NULL, 'DUF5613', 257079),
(437986, 'PF19843', NULL, 'Family of unknown function (DUF6318)', 158, NULL, 'DUF6318', 257080),
(437987, 'PF13067', NULL, 'Protein of unknown function (DUF3930)', 51, NULL, 'DUF3930', 257081),
(437988, 'PF18613', NULL, 'Tyrosine kinase receptor A trans-membrane domain', 22, NULL, 'TrkA_TMD', 257082),
(437989, 'PF01160', NULL, 'Vertebrate endogenous opioids neuropeptide', 47, NULL, 'Opiods_neuropep', 257083),
(437990, 'PF03186', NULL, 'CobD/Cbib protein', 277, NULL, 'CobD_Cbib', 257084),
(437991, 'PF06483', NULL, 'Chitinase C', 174, NULL, 'ChiC', 257085),
(437992, 'PF20403', NULL, 'Family of unknown function (DUF6693)', 109, NULL, 'DUF6693', 257086),
(437993, 'PF13512', NULL, 'Tetratricopeptide repeat', 145, NULL, 'TPR_18', 257087),
(437994, 'PF01340', NULL, 'Met Apo-repressor, MetJ', 97, NULL, 'MetJ', 257088),
(437995, 'PF20553', NULL, 'Putative O-methyltransferase', 311, NULL, 'Methyltransf_35', 257089);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(437996, 'PF01721', NULL, 'Class II bacteriocin', 35, NULL, 'Bacteriocin_II', 257090),
(437997, 'PF16889', NULL, 'Heparinase II/III N-terminus', 340, NULL, 'Hepar_II_III_N', 257091),
(437998, 'PF12382', NULL, 'Retrotransposon peptidase', 137, NULL, 'Peptidase_A2_2', 257092),
(437999, 'PF08915', NULL, 'Archaea-specific editing domain of threonyl-tRNA synthetase', 137, NULL, 'tRNA-Thr_ED', 257093),
(438000, 'PF18545', NULL, 'Halobacterial output domain 1', 75, NULL, 'HalOD1', 257094),
(438001, 'PF08681', NULL, 'Protein of unknown function (DUF1778)', 80, NULL, 'DUF1778', 257095),
(438002, 'PF20337', NULL, 'Family of unknown function (DUF6632)', 136, NULL, 'DUF6632', 257096),
(438003, 'PF19303', NULL, 'Anticodon binding domain of methionyl tRNA ligase', 152, NULL, 'Anticodon_3', 257097),
(438004, 'PF02923', NULL, 'Restriction endonuclease BamHI', 157, NULL, 'BamHI', 257098),
(438005, 'PF04727', NULL, 'ELMO/CED-12 family', 172, NULL, 'ELMO_CED12', 257099),
(438006, 'PF19507', NULL, 'Family of unknown function (DUF6041)', 140, NULL, 'DUF6041', 257100),
(438007, 'PF13318', NULL, '1-carboxybiuret hydrolase subunit AtzG-like', 50, NULL, 'AtzG-like', 257101),
(438008, 'PF12215', NULL, 'beta-glucosidase 2, glycosyl-hydrolase family 116 N-term', 313, NULL, 'Glyco_hydr_116N', 257102),
(438009, 'PF14669', NULL, 'Putative aspartate racemase', 176, NULL, 'Asp_Glu_race_2', 257103),
(438010, 'PF09995', NULL, 'ER-bound oxygenase mpaB/B''/Rubber oxygenase, catalytic domain', 224, NULL, 'MPAB_Lcp_cat', 257104),
(438011, 'PF11338', NULL, 'Protein of unknown function (DUF3140)', 92, NULL, 'DUF3140', 257105),
(438012, 'PF01247', NULL, 'Ribosomal protein L35Ae', 95, NULL, 'Ribosomal_L35Ae', 257106),
(438013, 'PF09814', NULL, 'HECT-like Ubiquitin-conjugating enzyme (E2)-binding', 371, NULL, 'HECT_2', 257107),
(438014, 'PF00362', NULL, 'Integrin beta chain VWA domain', 248, NULL, 'Integrin_beta', 257108),
(438015, 'PF16118', NULL, 'Domain of unknown function (DUF4834)', 99, NULL, 'DUF4834', 257109),
(438016, 'PF12581', NULL, 'Protein of unknown function (DUF3756)', 41, NULL, 'DUF3756', 257110),
(438017, 'PF17939', NULL, 'Tetracyclin repressor-like, C-terminal domain', 115, NULL, 'TetR_C_30', 257111),
(438018, 'PF01728', NULL, 'FtsJ-like methyltransferase', 177, NULL, 'FtsJ', 257112),
(438019, 'PF19168', NULL, 'Family of unknown function (DUF5850)', 168, NULL, 'DUF5850', 257113),
(438020, 'PF19435', NULL, 'Integrator complex subunit 14, beta-barrel domain', 148, NULL, 'IntS14_b-barrel', 257114),
(438021, 'PF13151', NULL, 'Protein of unknown function (DUF3990)', 152, NULL, 'DUF3990', 257115),
(438022, 'PF15015', NULL, 'Spermatogenesis-associated, N-terminal', 564, NULL, 'NYD-SP12_N', 257116),
(438023, 'PF02189', NULL, 'Immunoreceptor tyrosine-based activation motif', 20, NULL, 'ITAM', 257117),
(438024, 'PF11792', NULL, 'Baculoviridae late expression factor 5 C-terminal domain', 42, NULL, 'Baculo_LEF5_C', 257118),
(438025, 'PF08528', NULL, 'Whi5 like', 25, NULL, 'Whi5', 257119),
(438026, 'PF11360', NULL, 'Protein of unknown function (DUF3110)', 84, NULL, 'DUF3110', 257120),
(438027, 'PF14383', NULL, 'DUF761-associated sequence motif', 32, NULL, 'VARLMGL', 257121),
(438028, 'PF00959', NULL, 'Phage lysozyme', 109, NULL, 'Phage_lysozyme', 257122),
(438029, 'PF04179', NULL, 'Rit1 DUSP-like domain', 110, NULL, 'Init_tRNA_PT', 257123),
(438030, 'PF07306', NULL, 'Protein of unknown function (DUF1455)', 130, NULL, 'DUF1455', 257124),
(438031, 'PF19256', NULL, 'LAIKA domain', 68, NULL, 'LAIKA', 257125),
(438032, 'PF15117', NULL, 'Uncharacterised protein family UPF0697', 98, NULL, 'UPF0697', 257126),
(438033, 'PF17853', NULL, 'GGDEF-like domain', 117, NULL, 'GGDEF_2', 257127),
(438034, 'PF15585', NULL, 'Immunity protein 7', 130, NULL, 'Imm7', 257128),
(438035, 'PF07998', NULL, 'Peptidase family M54', 194, NULL, 'Peptidase_M54', 257129),
(438036, 'PF11309', NULL, 'Protein of unknown function (DUF3112)', 218, NULL, 'DUF3112', 257130),
(438037, 'PF05819', NULL, 'NolX protein', 435, NULL, 'NolX', 257131),
(438038, 'PF10500', NULL, 'Nuclear RNA-splicing-associated protein', 225, NULL, 'SR-25', 257132);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(438039, 'PF16558', NULL, 'Amino-terminal Zinc-binding domain of ubiquitin ligase E3A', 59, NULL, 'AZUL', 257133),
(438040, 'PF07742', NULL, 'BTG family', 117, NULL, 'BTG', 257134),
(438041, 'PF10830', NULL, 'Protein of unknown function (DUF2553)', 75, NULL, 'DUF2553', 257135),
(438042, 'PF15399', NULL, 'Domain of unknown function (DUF4620)', 113, NULL, 'DUF4620', 257136),
(438043, 'PF06129', NULL, 'Chordopoxvirus G3 protein', 108, NULL, 'Chordopox_G3', 257137),
(438044, 'PF08397', NULL, 'IRSp53/MIM homology domain', 219, NULL, 'IMD', 257138),
(438045, 'PF04966', NULL, 'Carbohydrate-selective porin, OprB family', 378, NULL, 'OprB', 257139),
(438046, 'PF06747', NULL, 'CHCH domain', 35, NULL, 'CHCH', 257140),
(438047, 'PF19568', NULL, 'Sporulation stage III, protein AA', 306, NULL, 'Spore_III_AA', 257141),
(438048, 'PF17177', NULL, 'Pentacotripeptide-repeat region of PRORP', 212, NULL, 'PPR_long', 257142),
(438049, 'PF07638', NULL, 'ECF sigma factor', 185, NULL, 'Sigma70_ECF', 257143),
(438050, 'PF12366', NULL, 'Cancer susceptibility candidate 1 C-terminal', 222, NULL, 'Casc1_C', 257144),
(438051, 'PF14734', NULL, 'Domain of unknown function (DUF4469) with IG-like fold', 101, NULL, 'DUF4469', 257145),
(438052, 'PF16149', NULL, 'Domain of unknown function (DUF4857)', 270, NULL, 'DUF4857', 257146),
(438053, 'PF04103', NULL, 'CD20-like family', 156, NULL, 'CD20', 257147),
(438054, 'PF14542', NULL, 'GCN5-related N-acetyl-transferase', 79, NULL, 'Acetyltransf_CG', 257148),
(438055, 'PF03683', NULL, 'Uncharacterised protein family (UPF0175)', 75, NULL, 'UPF0175', 257149),
(438056, 'PF10455', NULL, 'Bin/amphiphysin/Rvs domain for vesicular trafficking', 289, NULL, 'BAR_2', 257150),
(438057, 'PF10954', NULL, 'Protein of unknown function (DUF2755)', 100, NULL, 'DUF2755', 257151),
(438058, 'PF18356', NULL, 'Domain of unknown function (DUF5608)', 56, NULL, 'DUF5608', 257152),
(438059, 'PF16170', NULL, 'Domain of unknown function (DUF4873)', 91, NULL, 'DUF4873', 257153),
(438060, 'PF20105', NULL, 'Family of unknown function (DUF6495)', 156, NULL, 'DUF6495', 257154),
(438061, 'PF13216', NULL, 'Protein of unknown function (DUF4024)', 35, NULL, 'DUF4024', 257155),
(438062, 'PF02289', NULL, 'Cyclohydrolase (MCH)', 311, NULL, 'MCH', 257156),
(438063, 'PF02478', NULL, 'Pneumovirus phosphoprotein', 286, NULL, 'Pneumo_phosprot', 257157),
(438064, 'PF19610', NULL, 'Family of unknown function (DUF6115)', 167, NULL, 'DUF6115', 257158),
(438065, 'PF05913', NULL, '6-phospho-N-acetylmuramidase, C-terminal', 119, NULL, 'MupG_C', 257159),
(438066, 'PF10080', NULL, 'Membrane iron-sulfur containing protein FtrD-like', 101, NULL, 'FtrD-like', 257160),
(438067, 'PF17472', NULL, 'Family of unknown function (DUF5425)', 76, NULL, 'DUF5425', 257161),
(438068, 'PF01382', NULL, 'Avidin family', 115, NULL, 'Avidin', 257162),
(438069, 'PF11192', NULL, 'Protein of unknown function (DUF2977)', 61, NULL, 'DUF2977', 257163),
(438070, 'PF03059', NULL, 'Nicotianamine synthase protein', 276, NULL, 'NAS', 257164),
(438071, 'PF01480', NULL, 'PWI domain', 72, NULL, 'PWI', 257165),
(438072, 'PF16131', NULL, 'Torus domain', 109, NULL, 'Torus', 257166),
(438073, 'PF10190', NULL, 'Putative transmembrane protein 170', 106, NULL, 'Tmemb_170', 257167),
(438074, 'PF03594', NULL, 'Benzoate membrane transport protein', 378, NULL, 'BenE', 257168),
(438075, 'PF16790', NULL, 'Bacteriophage clamp loader A subunit', 137, NULL, 'Phage_clamp_A', 257169),
(438076, 'PF10720', NULL, 'Protein of unknown function (DUF2515)', 310, NULL, 'DUF2515', 257170),
(438077, 'PF16843', NULL, 'Binding domain to Get4 on Get5, Golgi to ER traffic protein', 53, NULL, 'Get5_bdg', 257171),
(438078, 'PF19981', NULL, 'Family of unknown function (DUF6417)', 139, NULL, 'DUF6417', 257172),
(438079, 'PF01368', NULL, 'DHH family', 122, NULL, 'DHH', 257173),
(438080, 'PF08252', NULL, 'arg-2/CPA1 leader peptide', 23, NULL, 'Leader_CPA1', 257174),
(438081, 'PF16819', NULL, 'Domain of unknown function (DUF5074)', 115, NULL, 'DUF5074', 257175),
(438082, 'PF13728', NULL, 'F plasmid transfer operon protein', 224, NULL, 'TraF', 257176);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(438083, 'PF01282', NULL, 'Ribosomal protein S24e', 79, NULL, 'Ribosomal_S24e', 257177),
(438084, 'PF04381', NULL, 'Putative exonuclease, RdgC', 298, NULL, 'RdgC', 257178),
(438085, 'PF11938', NULL, 'TLR4 regulator and MIR-interacting MSAP', 151, NULL, 'DUF3456', 257179),
(438086, 'PF06344', NULL, 'Parechovirus Genome-linked protein', 20, NULL, 'Parecho_VpG', 257180),
(438087, 'PF08573', NULL, 'DNA endonuclease activator SAE2/CtIP C-terminus', 109, NULL, 'SAE2', 257181),
(438088, 'PF00049', NULL, 'Insulin/IGF/Relaxin family', 85, NULL, 'Insulin', 257182),
(438089, 'PF09913', NULL, 'Predicted membrane protein (DUF2142)', 393, NULL, 'DUF2142', 257183),
(438090, 'PF04670', NULL, 'Gtr1/RagA G protein conserved region', 233, NULL, 'Gtr1_RagA', 257184),
(438091, 'PF08221', NULL, 'RNA polymerase III subunit RPC82 helix-turn-helix domain', 62, NULL, 'HTH_9', 257185),
(438092, 'PF00253', NULL, 'Ribosomal protein S14p/S29e', 54, NULL, 'Ribosomal_S14', 257186),
(438093, 'PF12505', NULL, 'Protein of unknown function (DUF3712)', 125, NULL, 'DUF3712', 257187),
(438094, 'PF01226', NULL, 'Formate/nitrite transporter', 236, NULL, 'Form_Nir_trans', 257188),
(438095, 'PF02320', NULL, 'Ubiquinol-cytochrome C reductase hinge protein', 66, NULL, 'UCR_hinge', 257189),
(438096, 'PF10221', NULL, 'Cell cycle and development regulator Mat89Bb', 691, NULL, 'Mat89Bb', 257190),
(438097, 'PF12429', NULL, 'Protein of unknown function (DUF3676)', 230, NULL, 'DUF3676', 257191),
(438098, 'PF05739', NULL, 'SNARE domain', 53, NULL, 'SNARE', 257192),
(438099, 'PF12127', NULL, 'Flotillin-like protein FloA', 314, NULL, 'FloA', 257193),
(438100, 'PF14588', NULL, 'YjgF/chorismate_mutase-like, putative endoribonuclease', 148, NULL, 'YjgF_endoribonc', 257194),
(438101, 'PF00704', NULL, 'Glycosyl hydrolases family 18', 312, NULL, 'Glyco_hydro_18', 257195),
(438102, 'PF06593', NULL, 'Raspberry bushy dwarf virus coat protein', 274, NULL, 'RBDV_coat', 257196),
(438103, 'PF01997', NULL, 'Translin family', 206, NULL, 'Translin', 257197),
(438104, 'PF07465', NULL, 'Photosystem I protein M (PsaM)', 29, NULL, 'PsaM', 257198),
(438105, 'PF20419', NULL, 'Family of unknown function (DUF6701)', 580, NULL, 'DUF6701', 257199),
(438106, 'PF02542', NULL, 'YgbB family', 155, NULL, 'YgbB', 257200),
(438107, 'PF16805', NULL, 'Phage late-transcription coactivator', 69, NULL, 'Trans_coact', 257201),
(438108, 'PF20175', NULL, 'Tra1 HEAT repeat central region', 593, NULL, 'Tra1_central', 257202),
(438109, 'PF03713', NULL, 'Domain of unknown function (DUF305)', 151, NULL, 'DUF305', 257203),
(438110, 'PF08983', NULL, 'Vasopressin V1 receptor, C-terminal', 48, NULL, 'V1R_C', 257204),
(438111, 'PF02437', NULL, 'SKI/SNO/DAC family', 108, NULL, 'Ski_Sno', 257205),
(438112, 'PF19339', NULL, 'Protein angel homolog 2 N-terminal', 172, NULL, 'ANGEL2_N', 257206),
(438113, 'PF03484', NULL, 'tRNA synthetase B5 domain', 67, NULL, 'B5', 257207),
(438114, 'PF11759', NULL, 'Keratin-associated matrix', 65, NULL, 'KRTAP', 257208),
(438115, 'PF13138', NULL, 'Protein of unknown function (DUF3982)', 35, NULL, 'DUF3982', 257209),
(438116, 'PF15299', NULL, 'Amyotrophic lateral sclerosis 2 chromosomal region candidate gene 8', 233, NULL, 'ALS2CR8', 257210),
(438117, 'PF17530', NULL, 'Non-structural protein NS3', 220, NULL, 'NS3', 257211),
(438118, 'PF02992', NULL, 'Transposase family tnp2', 213, NULL, 'Transposase_21', 257212),
(438119, 'PF07852', NULL, 'Protein of unknown function (DUF1642)', 138, NULL, 'DUF1642', 257213),
(438120, 'PF11679', NULL, 'Protein of unknown function (DUF3275)', 207, NULL, 'DUF3275', 257214),
(438121, 'PF20136', NULL, 'Family of unknown function (DUF6526)', 144, NULL, 'DUF6526', 257215),
(438122, 'PF07204', NULL, 'Orthoreovirus membrane fusion protein p10', 98, NULL, 'Orthoreo_P10', 257216),
(438123, 'PF13927', NULL, 'Immunoglobulin domain', 79, NULL, 'Ig_3', 257217),
(438124, 'PF16754', NULL, 'Bacterial toxin homologue of phage lysozyme, C-term', 156, NULL, 'Pesticin', 257218),
(438125, 'PF15305', NULL, 'Intraflagellar transport protein 43', 136, NULL, 'IFT43', 257219);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(438126, 'PF12435', NULL, 'Protein of unknown function (DUF3678)', 35, NULL, 'DUF3678', 257220),
(438127, 'PF18288', NULL, 'Fumarylacetoacetase N-terminal domain 2', 78, NULL, 'FAA_hydro_N_2', 257221),
(438128, 'PF18833', NULL, 'Tetratricopeptide repeat', 92, NULL, 'TPR_22', 257222),
(438129, 'PF00283', NULL, 'Cytochrome b559, alpha (gene psbE) and beta (gene psbF)subunits', 29, NULL, 'Cytochrom_B559', 257223),
(438130, 'PF11786', NULL, 'Aft1 HRA domain', 79, NULL, 'Aft1_HRA', 257224),
(438131, 'PF19398', NULL, 'Family of unknown function (DUF5973)', 81, NULL, 'DUF5973', 257225),
(438132, 'PF04960', NULL, 'Glutaminase', 286, NULL, 'Glutaminase', 257226),
(438133, 'PF15734', NULL, 'Migration and invasion-inhibitory', 344, NULL, 'MIIP', 257227),
(438134, 'PF19492', NULL, 'Family of unknown function (DUF6027)', 134, NULL, 'DUF6027', 257228),
(438135, 'PF06257', NULL, 'Biofilm formation stimulator VEG', 73, NULL, 'VEG', 257229),
(438136, 'PF10448', NULL, '20S proteasome chaperone assembly proteins 3 and 4', 144, NULL, 'POC3_POC4', 257230),
(438137, 'PF07017', NULL, 'Antimicrobial peptide resistance and lipid A acylation protein PagP', 144, NULL, 'PagP', 257231),
(438138, 'PF14574', NULL, 'C-terminal domain of RACo the ASKHA domain', 260, NULL, 'RACo_C_ter', 257232),
(438139, 'PF15779', NULL, 'Leucine-rich repeat-containing protein 37 family', 73, NULL, 'LRRC37', 257233),
(438140, 'PF05903', NULL, 'PPPDE putative peptidase domain', 151, NULL, 'Peptidase_C97', 257234),
(438141, 'PF07824', NULL, 'Type III secretion chaperone domain', 110, NULL, 'Chaperone_III', 257235),
(438142, 'PF13040', NULL, 'Fur-regulated basic protein B', 39, NULL, 'Fur_reg_FbpB', 257236),
(438143, 'PF19192', NULL, 'Response receiver domain', 181, NULL, 'Response_reg_2', 257237),
(438144, 'PF09215', NULL, 'Bacteriophage T4, Gp8', 334, NULL, 'Phage-Gp8', 257238),
(438145, 'PF12844', NULL, 'Helix-turn-helix domain', 65, NULL, 'HTH_19', 257239),
(438146, 'PF18233', NULL, 'Cdc13 OB4 dimerization domain', 115, NULL, 'Cdc13_OB4_dimer', 257240),
(438147, 'PF06156', NULL, 'Initiation control protein YabA', 102, NULL, 'YabA', 257241),
(438148, 'PF16616', NULL, 'Unstructured region on Polyhomeotic-like protein 1 and 2', 123, NULL, 'PHC2_SAM_assoc', 257242),
(438149, 'PF05320', NULL, 'Poxvirus DNA-directed RNA polymerase 19 kDa subunit', 166, NULL, 'Pox_RNA_Pol_19', 257243),
(438150, 'PF16006', NULL, 'Nucleolar and spindle-associated protein', 298, NULL, 'NUSAP', 257244),
(438151, 'PF09802', NULL, 'Preprotein translocase subunit Sec66', 180, NULL, 'Sec66', 257245),
(438152, 'PF15183', NULL, 'Melanocortin-2 receptor accessory protein family', 89, NULL, 'MRAP', 257246),
(438153, 'PF09734', NULL, 'RNA polymerase III transcription factor (TF)IIIC subunit HTH domain', 140, NULL, 'Tau95', 257247),
(438154, 'PF01621', NULL, 'Cell fusion glycoprotein K', 339, NULL, 'Fusion_gly_K', 257248),
(438155, 'PF02183', NULL, 'Homeobox associated leucine zipper', 43, NULL, 'HALZ', 257249),
(438156, 'PF10241', NULL, 'Uncharacterized conserved protein', 86, NULL, 'KxDL', 257250),
(438157, 'PF10188', NULL, 'Organic solute transport protein 1', 173, NULL, 'Oscp1', 257251),
(438158, 'PF16897', NULL, 'C-terminal region of MMR_HSR1 domain', 106, NULL, 'MMR_HSR1_Xtn', 257252),
(438159, 'PF18954', NULL, 'Family of unknown function (DUF5697)', 160, NULL, 'DUF5697', 257253),
(438160, 'PF06995', NULL, 'Phage P2 GpU', 120, NULL, 'Phage_P2_GpU', 257254),
(438161, 'PF07977', NULL, 'FabA-like domain', 138, NULL, 'FabA', 257255),
(438162, 'PF13161', NULL, 'Protein of unknown function (DUF3996)', 154, NULL, 'DUF3996', 257256),
(438163, 'PF14959', NULL, 'gamma-Secretase-activating protein C-term', 108, NULL, 'GSAP-16', 257257),
(438164, 'PF05455', NULL, 'GvpH', 175, NULL, 'GvpH', 257258),
(438165, 'PF01070', NULL, 'FMN-dependent dehydrogenase', 348, NULL, 'FMN_dh', 257259),
(438166, 'PF07696', NULL, '7TMR-DISM extracellular 2', 134, NULL, '7TMR-DISMED2', 257260),
(438167, 'PF07912', NULL, 'ERp29, N-terminal domain', 126, NULL, 'ERp29_N', 257261),
(438168, 'PF00227', NULL, 'Proteasome subunit', 190, NULL, 'Proteasome', 257262);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(438169, 'PF12092', NULL, 'Protein of unknown function (DUF3568)', 124, NULL, 'DUF3568', 257263),
(438170, 'PF06239', NULL, 'Evolutionarily conserved signalling intermediate in Toll pathway', 194, NULL, 'ECSIT', 257264),
(438171, 'PF03382', NULL, 'Mycoplasma protein of unknown function, DUF285', 121, NULL, 'DUF285', 257265),
(438172, 'PF05968', NULL, 'Bacillus PapR protein', 48, NULL, 'Bacillus_PapR', 257266),
(438173, 'PF15219', NULL, 'Testis-expressed 12', 85, NULL, 'TEX12', 257267),
(438174, 'PF04805', NULL, 'E10-like protein conserved region', 70, NULL, 'Pox_E10', 257268),
(438175, 'PF13586', NULL, 'Transposase DDE domain', 90, NULL, 'DDE_Tnp_1_2', 257269),
(438176, 'PF03973', NULL, 'Triabin', 148, NULL, 'Triabin', 257270),
(438177, 'PF09916', NULL, 'Uncharacterized protein conserved in bacteria (DUF2145)', 200, NULL, 'DUF2145', 257271),
(438178, 'PF17833', NULL, 'UPF0113 Pre-PUA domain', 83, NULL, 'UPF0113_N', 257272),
(438179, 'PF13763', NULL, 'Domain of unknown function (DUF4167)', 77, NULL, 'DUF4167', 257273),
(438180, 'PF04340', NULL, 'Protein of unknown function, DUF484', 225, NULL, 'DUF484', 257274),
(438181, 'PF04881', NULL, 'Adenovirus GP19K', 132, NULL, 'Adeno_GP19K', 257275),
(438182, 'PF07253', NULL, 'Gypsy protein', 472, NULL, 'Gypsy', 257276),
(438183, 'PF17971', NULL, 'Leukemia inhibitory factor receptor D2 domain', 114, NULL, 'LIFR_D2', 257277),
(438184, 'PF16833', NULL, 'Erythroid krueppel-like transcription factor, transactivation 2', 27, NULL, 'EKLF_TAD2', 257278),
(438185, 'PF13330', NULL, 'Mucin-2 protein WxxW repeating region', 91, NULL, 'Mucin2_WxxW', 257279),
(438186, 'PF20139', NULL, 'Family of unknown function (DUF6529)', 171, NULL, 'DUF6529', 257280),
(438187, 'PF16853', NULL, 'Cell division control protein 13 N-terminus', 209, NULL, 'CDC13_N', 257281),
(438188, 'PF02594', NULL, 'Uncharacterised ACR, YggU family COG1872', 75, NULL, 'DUF167', 257282),
(438189, 'PF11301', NULL, 'Protein of unknown function (DUF3103)', 351, NULL, 'DUF3103', 257283),
(438190, 'PF14321', NULL, 'Domain of unknown function (DUF4382)', 139, NULL, 'DUF4382', 257284),
(438191, 'PF16986', NULL, 'Heavy-metal resistance protein CzcE', 80, NULL, 'CzcE', 257285),
(438192, 'PF20513', NULL, 'Prokaryotic ubiquitin-like protein UBact', 43, NULL, 'UBact', 257286),
(438193, 'PF07022', NULL, 'Bacteriophage CI repressor helix-turn-helix domain', 65, NULL, 'Phage_CI_repr', 257287),
(438194, 'PF11621', NULL, 'C3 binding domain 4 of IgG-bind protein SBI', 69, NULL, 'Sbi-IV', 257288),
(438195, 'PF18350', NULL, 'Restriction endonuclease SH3 domain', 53, NULL, 'SH3_17', 257289),
(438196, 'PF03907', NULL, 'Spo7-like protein', 221, NULL, 'Spo7', 257290),
(438197, 'PF04219', NULL, 'Protein of unknown function, DUF', 90, NULL, 'DUF413', 257291),
(438198, 'PF16568', NULL, 'Tyrosine-rich domain of Sam68', 55, NULL, 'Sam68-YY', 257292),
(438199, 'PF17470', NULL, 'Phage gene product 45.2', 57, NULL, 'Gp45_2', 257293),
(438200, 'PF17890', NULL, 'Peptidoglycan hydrolase LytB WW-like domain', 53, NULL, 'WW_like', 257294),
(438201, 'PF00178', NULL, 'Ets-domain', 81, NULL, 'Ets', 257295),
(438202, 'PF04793', NULL, 'BRRF1-like protein', 286, NULL, 'Herpes_BBRF1', 257296),
(438203, 'PF17278', NULL, 'Family of unknown function (DUF5343)', 138, NULL, 'DUF5343', 257297),
(438204, 'PF10174', NULL, 'RIM-binding protein of the cytomatrix active zone', 762, NULL, 'Cast', 257298),
(438205, 'PF00125', NULL, 'Core histone H2A/H2B/H3/H4', 127, NULL, 'Histone', 257299),
(438206, 'PF17782', NULL, 'DprA winged helix domain', 61, NULL, 'DprA_WH', 257300),
(438207, 'PF10868', NULL, 'Cysteine-rich antifungal protein 2, defensin-like', 50, NULL, 'Defensin_like', 257301),
(438208, 'PF03660', NULL, 'PHF5-like protein', 104, NULL, 'PHF5', 257302),
(438209, 'PF13545', NULL, 'Crp-like helix-turn-helix domain', 68, NULL, 'HTH_Crp_2', 257303),
(438210, 'PF16556', NULL, 'Interleukin-17 receptor, fibronectin-III-like domain 1', 154, NULL, 'IL17R_fnIII_D1', 257304),
(438211, 'PF10749', NULL, 'Protein of unknown function (DUF2534)', 80, NULL, 'DUF2534', 257305);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(438212, 'PF18627', NULL, 'Peptidoglycan GlcNAc deacetylase N-terminal domain', 218, NULL, 'PgdA_N', 257306),
(438213, 'PF06708', NULL, 'Protein of unknown function (DUF1195)', 147, NULL, 'DUF1195', 257307),
(438214, 'PF10358', NULL, 'N-terminal C2 in EEIG1 and EHBP1 proteins', 147, NULL, 'NT-C2', 257308),
(438215, 'PF11763', NULL, 'Cell-wall adhesin ligand-binding C-terminal', 122, NULL, 'DIPSY', 257309),
(438216, 'PF15828', NULL, 'Domain of unknown function (DUF4710)', 77, NULL, 'DUF4710', 257310),
(438217, 'PF14060', NULL, 'Domain of unknown function (DUF4252)', 125, NULL, 'DUF4252', 257311),
(438218, 'PF18632', NULL, 'Family of unknown function (DUF5630)', 218, NULL, 'DUF5630', 257312),
(438219, 'PF08831', NULL, 'Class II MHC-associated invariant chain trimerisation domain', 69, NULL, 'MHCassoc_trimer', 257313),
(438220, 'PF12534', NULL, 'Pannexin-like TM region of LRRC8', 350, NULL, 'Pannexin_like', 257314),
(438221, 'PF19449', NULL, 'Family of unknown function (DUF5987)', 180, NULL, 'DUF5987', 257315),
(438222, 'PF03586', NULL, 'Herpesvirus UL36 tegument protein', 251, NULL, 'Herpes_UL36', 257316),
(438223, 'PF09336', NULL, 'Vps4 C terminal oligomerisation domain', 61, NULL, 'Vps4_C', 257317),
(438224, 'PF10326', NULL, 'Serpentine type 7TM GPCR chemoreceptor Str', 307, NULL, '7TM_GPCR_Str', 257318),
(438225, 'PF09726', NULL, 'Macoilin family', 673, NULL, 'Macoilin', 257319),
(438226, 'PF10505', NULL, 'NMDA receptor-regulated gene protein 2 C-terminus', 211, NULL, 'NARG2_C', 257320),
(438227, 'PF09273', NULL, 'Rubisco LSMT substrate-binding', 130, NULL, 'Rubis-subs-bind', 257321),
(438228, 'PF05036', NULL, 'SPOR domain', 76, NULL, 'SPOR', 257322),
(438229, 'PF09718', NULL, 'Lambda phage tail tape-measure protein (Tape_meas_lam_C)', 76, NULL, 'Tape_meas_lam_C', 257323),
(438230, 'PF11463', NULL, 'R.HinP1I restriction endonuclease', 205, NULL, 'R-HINP1I', 257324),
(438231, 'PF00912', NULL, 'Transglycosylase', 178, NULL, 'Transgly', 257325),
(438232, 'PF12428', NULL, 'Protein of unknown function (DUF3675)', 119, NULL, 'DUF3675', 257326),
(438233, 'PF14081', NULL, 'Domain of unknown function (DUF4262)', 127, NULL, 'DUF4262', 257327),
(438234, 'PF06598', NULL, 'Chlorovirus glycoprotein repeat', 34, NULL, 'Chlorovi_GP_rpt', 257328),
(438235, 'PF03169', NULL, 'OPT oligopeptide transporter protein', 616, NULL, 'OPT', 257329),
(438236, 'PF10011', NULL, 'Predicted membrane protein (DUF2254)', 365, NULL, 'DUF2254', 257330),
(438237, 'PF03534', NULL, 'Salmonella virulence plasmid 65kDa B protein', 290, NULL, 'SpvB', 257331),
(438238, 'PF16247', NULL, 'Domain of unknown function (DUF4904)', 129, NULL, 'DUF4904', 257332),
(438239, 'PF08182', NULL, 'Pedibin/Hym-346 family', 35, NULL, 'Pedibin', 257333),
(438240, 'PF03437', NULL, 'BtpA family', 254, NULL, 'BtpA', 257334),
(438241, 'PF13529', NULL, 'Peptidase_C39 like family', 144, NULL, 'Peptidase_C39_2', 257335),
(438242, 'PF06577', NULL, 'Envelope integrity protein A', 160, NULL, 'EipA', 257336),
(438243, 'PF12181', NULL, 'DNA binding domain of the motility gene repressor (MogR)', 148, NULL, 'MogR_DNAbind', 257337),
(438244, 'PF13852', NULL, 'Protein of unknown function (DUF4197)', 201, NULL, 'DUF4197', 257338),
(438245, 'PF11269', NULL, 'Protein of unknown function (DUF3069)', 119, NULL, 'DUF3069', 257339),
(438246, 'PF00006', NULL, 'ATP synthase alpha/beta family, nucleotide-binding domain', 214, NULL, 'ATP-synt_ab', 257340),
(438247, 'PF00735', NULL, 'Septin', 281, NULL, 'Septin', 257341),
(438248, 'PF14967', NULL, 'FAM70 protein', 316, NULL, 'FAM70', 257342),
(438249, 'PF19541', NULL, 'Family of unknown function (DUF6065)', 236, NULL, 'DUF6065', 257343),
(438250, 'PF12682', NULL, 'Flavodoxin', 155, NULL, 'Flavodoxin_4', 257344),
(438251, 'PF13379', NULL, 'NMT1-like family', 252, NULL, 'NMT1_2', 257345),
(438252, 'PF15108', NULL, 'Voltage-dependent calcium channel gamma-like subunit protein family', 182, NULL, 'TMEM37', 257346),
(438253, 'PF14261', NULL, 'Domain of unknown function (DUF4351)', 59, NULL, 'DUF4351', 257347),
(438254, 'PF04402', NULL, 'Protein of unknown function (DUF541)', 197, NULL, 'SIMPL', 257348);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(438255, 'PF10802', NULL, 'Protein of unknown function (DUF2540)', 75, NULL, 'DUF2540', 257349),
(438256, 'PF12310', NULL, 'Transcription factor protein N terminal', 109, NULL, 'Elf-1_N', 257350),
(438257, 'PF03306', NULL, 'Alpha-acetolactate decarboxylase', 219, NULL, 'AAL_decarboxy', 257351),
(438258, 'PF19444', NULL, 'MTP large subunit, lipid-binding domain', 296, NULL, 'MTP_lip_bd', 257352),
(438259, 'PF19813', NULL, 'Family of unknown function (DUF6296)', 75, NULL, 'DUF6296', 257353),
(438260, 'PF04193', NULL, 'PQ loop repeat', 61, NULL, 'PQ-loop', 257354),
(438261, 'PF18783', NULL, 'Isopullulanase beta-solenoid repeat', 33, NULL, 'IPU_b_solenoid', 257355),
(438262, 'PF11755', NULL, 'Protein of unknown function (DUF3311)', 61, NULL, 'DUF3311', 257356),
(438263, 'PF01328', NULL, 'Peroxidase, family 2', 187, NULL, 'Peroxidase_2', 257357),
(438264, 'PF05018', NULL, 'CFA20 domain', 185, NULL, 'CFA20_dom', 257358),
(438265, 'PF04840', NULL, 'Vps16, C-terminal region', 320, NULL, 'Vps16_C', 257359),
(438266, 'PF05342', NULL, 'M26 IgA1-specific Metallo-endopeptidase N-terminal region', 250, NULL, 'Peptidase_M26_N', 257360),
(438267, 'PF17191', NULL, 'RecG wedge domain', 162, NULL, 'RecG_wedge', 257361),
(438268, 'PF19885', NULL, 'Family of unknown function (DUF6358)', 61, NULL, 'DUF6358', 257362),
(438269, 'PF10135', NULL, 'Rod binding protein', 51, NULL, 'Rod-binding', 257363),
(438270, 'PF13858', NULL, 'Protein of unknown function (DUF4199)', 167, NULL, 'DUF4199', 257364),
(438271, 'PF10734', NULL, 'Protein of unknown function (DUF2523)', 80, NULL, 'DUF2523', 257365),
(438272, 'PF02830', NULL, 'V4R domain', 62, NULL, 'V4R', 257366),
(438273, 'PF03114', NULL, 'BAR domain', 239, NULL, 'BAR', 257367),
(438274, 'PF12662', NULL, 'Complement Clr-like EGF-like', 24, NULL, 'cEGF', 257368),
(438275, 'PF12180', NULL, 'TSG101 and ALIX binding domain of CEP55', 34, NULL, 'EABR', 257369),
(438276, 'PF11118', NULL, 'Protein of unknown function (DUF2627)', 76, NULL, 'DUF2627', 257370),
(438277, 'PF17357', NULL, 'Facilitor Of iron transport 1 and 2', 86, NULL, 'FIT1_2', 257371),
(438278, 'PF16623', NULL, 'Unstructured linker region between on GAS7 protein', 92, NULL, 'WW_FCH_linker', 257372),
(438279, 'PF03924', NULL, 'CHASE domain', 188, NULL, 'CHASE', 257373),
(438280, 'PF04977', NULL, 'Septum formation initiator', 80, NULL, 'DivIC', 257374),
(438281, 'PF11749', NULL, 'Protein of unknown function (DUF3305)', 140, NULL, 'DUF3305', 257375),
(438282, 'PF04445', NULL, 'Putative SAM-dependent methyltransferase', 230, NULL, 'SAM_MT', 257376),
(438283, 'PF04817', NULL, 'Umbravirus long distance movement (LDM) family', 231, NULL, 'Umbravirus_LDM', 257377),
(438284, 'PF05584', NULL, 'Sulfolobus plasmid regulatory protein', 72, NULL, 'Sulfolobus_pRN', 257378),
(438285, 'PF09275', NULL, 'Pertussis toxin S4 subunit', 110, NULL, 'Pertus-S4-tox', 257379),
(438286, 'PF08542', NULL, 'Replication factor C C-terminal domain', 88, NULL, 'Rep_fac_C', 257380),
(438287, 'PF19891', NULL, 'Family of unknown function (DUF6364)', 70, NULL, 'DUF6364', 257381),
(438288, 'PF20572', NULL, 'Family of unknown function (DUF6781)', 213, NULL, 'DUF6781', 257382),
(438289, 'PF03103', NULL, 'Domain of unknown function (DUF243)', 98, NULL, 'DUF243', 257383),
(438290, 'PF17779', NULL, 'NOD2 winged helix domain', 57, NULL, 'NOD2_WH', 257384),
(438291, 'PF18210', NULL, 'Knl1 RWD C-terminal domain', 155, NULL, 'Knl1_RWD_C', 257385),
(438292, 'PF16369', NULL, 'C-terminal lipocalin-like domain', 105, NULL, 'GH43_C', 257386),
(438293, 'PF18548', NULL, 'Metanogen output domain 2', 88, NULL, 'MetOD2', 257387),
(438294, 'PF07058', NULL, 'Microtubule-associated protein 70', 554, NULL, 'MAP70', 257388),
(438295, 'PF01034', NULL, 'Syndecan domain', 63, NULL, 'Syndecan', 257389),
(438296, 'PF01439', NULL, 'Metallothionein', 81, NULL, 'Metallothio_2', 257390),
(438297, 'PF03727', NULL, 'Hexokinase', 241, NULL, 'Hexokinase_2', 257391),
(438298, 'PF04356', NULL, 'Protein of unknown function (DUF489)', 192, NULL, 'DUF489', 257392),
(438299, 'PF04942', NULL, 'CC domain', 34, NULL, 'CC', 257393);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(438300, 'PF15946', NULL, 'Domain of unknown function (DUF4754)', 80, NULL, 'DUF4754', 257394),
(438301, 'PF00288', NULL, 'GHMP kinases N terminal domain', 66, NULL, 'GHMP_kinases_N', 257395),
(438302, 'PF09153', NULL, 'Methylated DNA-protein cysteine methyltransferase, N-terminal', 89, NULL, 'MGMT_N', 257396),
(438303, 'PF16455', NULL, 'Ubiquitin-binding domain', 104, NULL, 'UBD', 257397),
(438304, 'PF11382', NULL, 'Copper transport outer membrane protein, MctB', 305, NULL, 'MctB', 257398),
(438305, 'PF18555', NULL, 'MobL relaxases', 387, NULL, 'MobL', 257399),
(438306, 'PF13624', NULL, 'SurA N-terminal domain', 162, NULL, 'SurA_N_3', 257400),
(438307, 'PF01384', NULL, 'Phosphate transporter family', 363, NULL, 'PHO4', 257401),
(438308, 'PF15564', NULL, 'Immunity protein 25', 131, NULL, 'Imm25', 257402),
(438309, 'PF00083', NULL, 'Sugar (and other) transporter', 452, NULL, 'Sugar_tr', 257403),
(438310, 'PF09574', NULL, 'Protein  of unknown function (Duf2374)', 42, NULL, 'DUF2374', 257404),
(438311, 'PF07235', NULL, 'Protein of unknown function (DUF1427)', 84, NULL, 'DUF1427', 257405),
(438312, 'PF11854', NULL, 'Putative outer membrane beta-barrel porin, MtrB/PioB', 661, NULL, 'MtrB_PioB', 257406),
(438313, 'PF20252', NULL, 'BIG2 C-terminal domain', 177, NULL, 'BIG2_C', 257407),
(438314, 'PF02696', NULL, 'Protein adenylyltransferase SelO', 468, NULL, 'SelO', 257408),
(438315, 'PF11436', NULL, 'Protein of unknown function (DUF3199)', 124, NULL, 'DUF3199', 257409),
(438316, 'PF09328', NULL, 'Domain of unknown function (DUF1984)', 252, NULL, 'Phytochelatin_C', 257410),
(438317, 'PF19137', NULL, 'Family of unknown function (DUF5820)', 117, NULL, 'DUF5820', 257411),
(438318, 'PF02048', NULL, 'Heat-stable enterotoxin ST', 54, NULL, 'Enterotoxin_ST', 257412),
(438319, 'PF08400', NULL, 'Prophage tail fibre N-terminal', 134, NULL, 'phage_tail_N', 257413),
(438320, 'PF15259', NULL, 'G-2 and S-phase expressed 1', 144, NULL, 'GTSE1_N', 257414),
(438321, 'PF19526', NULL, 'S-layer protein Slr4', 366, NULL, 'Slr4', 257415),
(438322, 'PF11604', NULL, 'Copper binding periplasmic protein CusF', 68, NULL, 'CusF_Ec', 257416),
(438323, 'PF18130', NULL, 'ATP-grasp N-terminal domain', 81, NULL, 'ATPgrasp_N', 257417),
(438324, 'PF04517', NULL, 'Microvirus lysis protein (E), C terminus', 42, NULL, 'Microvir_lysis', 257418),
(438325, 'PF10151', NULL, 'TMEM214, C-terminal, caspase 4 activator', 662, NULL, 'TMEM214', 257419),
(438326, 'PF12329', NULL, 'TATA element modulatory factor 1 DNA binding', 74, NULL, 'TMF_DNA_bd', 257420),
(438327, 'PF05102', NULL, 'holin, BlyA family', 61, NULL, 'Holin_BlyA', 257421),
(438328, 'PF15144', NULL, 'Domain of unknown function (DUF4576)', 90, NULL, 'DUF4576', 257422),
(438329, 'PF13320', NULL, 'Domain of unknown function (DUF4091)', 65, NULL, 'DUF4091', 257423),
(438330, 'PF12859', NULL, 'Anaphase-promoting complex subunit 1 WD40 beta-propeller domain', 295, NULL, 'ANAPC1', 257424),
(438331, 'PF20412', NULL, 'RALGAPB N-terminal domain', 126, NULL, 'RALGAPB_N', 257425),
(438332, 'PF01593', NULL, 'Flavin containing amine oxidoreductase', 452, NULL, 'Amino_oxidase', 257426),
(438333, 'PF02057', NULL, 'Glycosyl hydrolase family 59', 294, NULL, 'Glyco_hydro_59', 257427),
(438334, 'PF02515', NULL, 'CoA-transferase family III', 367, NULL, 'CoA_transf_3', 257428),
(438335, 'PF13047', NULL, 'Protein of unknown function (DUF3907)', 147, NULL, 'DUF3907', 257429),
(438336, 'PF09165', NULL, 'Ubiquinol-cytochrome c reductase 8 kDa, N-terminal', 75, NULL, 'Ubiq-Cytc-red_N', 257430),
(438337, 'PF06073', NULL, 'Bacterial protein of unknown function (DUF934)', 107, NULL, 'DUF934', 257431),
(438338, 'PF19579', NULL, 'Bacteriodetes cell division protein (FtsL-like)', 100, NULL, 'FtsL_2', 257432),
(438339, 'PF11660', NULL, 'Protein of unknown function (DUF3262)', 76, NULL, 'DUF3262', 257433),
(438340, 'PF08243', NULL, 'SPT2 chromatin protein', 111, NULL, 'SPT2', 257434),
(438341, 'PF11214', NULL, 'Mediator complex subunit 2', 100, NULL, 'Med2', 257435),
(438342, 'PF05141', NULL, 'Pyoverdine/dityrosine biosynthesis protein', 277, NULL, 'DIT1_PvcA', 257436);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(438343, 'PF18217', NULL, 'Zap1 zinc finger 2', 24, NULL, 'Zap1_zf2', 257437),
(438344, 'PF13213', NULL, 'Protein of unknown function (DUF4021)', 46, NULL, 'DUF4021', 257438),
(438345, 'PF13445', NULL, 'RING-type zinc-finger', 40, NULL, 'zf-RING_UBOX', 257439),
(438346, 'PF12847', NULL, 'Methyltransferase domain', 151, NULL, 'Methyltransf_18', 257440),
(438347, 'PF14939', NULL, 'DDB1-and CUL4-substrate receptor 15, WD repeat', 215, NULL, 'DCAF15_WD40', 257441),
(438348, 'PF05802', NULL, 'Enterobacterial EspB protein', 203, NULL, 'EspB', 257442),
(438349, 'PF09194', NULL, 'Restriction endonuclease BsobI', 314, NULL, 'Endonuc-BsobI', 257443),
(438350, 'PF00465', NULL, 'Iron-containing alcohol dehydrogenase', 364, NULL, 'Fe-ADH', 257444),
(438351, 'PF06767', NULL, 'Sif protein', 337, NULL, 'Sif', 257445),
(438352, 'PF00318', NULL, 'Ribosomal protein S2', 215, NULL, 'Ribosomal_S2', 257446),
(438353, 'PF07247', NULL, 'Alcohol acetyltransferase', 500, NULL, 'AATase', 257447),
(438354, 'PF13551', NULL, 'Winged helix-turn helix', 63, NULL, 'HTH_29', 257448),
(438355, 'PF13988', NULL, 'Protein of unknown function (DUF4225)', 163, NULL, 'DUF4225', 257449),
(438356, 'PF18294', NULL, 'Peptidase S41 N-terminal domain', 49, NULL, 'Pept_S41_N', 257450),
(438357, 'PF02754', NULL, 'Cysteine-rich domain', 85, NULL, 'CCG', 257451),
(438358, 'PF11866', NULL, 'Protein of unknown function (DUF3386)', 211, NULL, 'DUF3386', 257452),
(438359, 'PF06764', NULL, 'Protein of unknown function (DUF1223)', 202, NULL, 'DUF1223', 257453),
(438360, 'PF03688', NULL, 'Nepovirus coat protein, C-terminal domain', 163, NULL, 'Nepo_coat_C', 257454),
(438361, 'PF09819', NULL, 'ABC-type cobalt transport system, permease component', 121, NULL, 'ABC_cobalt', 257455),
(438362, 'PF13711', NULL, 'Domain of unknown function (DUF4160)', 65, NULL, 'DUF4160', 257456),
(438363, 'PF19057', NULL, 'PH domain', 152, NULL, 'PH_19', 257457),
(438364, 'PF11692', NULL, 'Protein of unknown function (DUF3289)', 272, NULL, 'DUF3289', 257458),
(438365, 'PF02895', NULL, 'Signal transducing histidine kinase, homodimeric domain', 69, NULL, 'H-kinase_dim', 257459),
(438366, 'PF15843', NULL, 'Domain of unknown function (DUF4719)', 202, NULL, 'DUF4719', 257460),
(438367, 'PF04300', NULL, 'F-box associated region', 178, NULL, 'FBA', 257461),
(438368, 'PF08517', NULL, 'Ataxin-1 and HBP1 module (AXH)', 112, NULL, 'AXH', 257462),
(438369, 'PF15184', NULL, 'Mitochondrial import receptor subunit TOM6 homolog', 74, NULL, 'TOM6p', 257463),
(438370, 'PF04324', NULL, 'BFD-like [2Fe-2S] binding domain', 51, NULL, 'Fer2_BFD', 257464),
(438371, 'PF16953', NULL, 'Protein-only RNase P', 242, NULL, 'PRORP', 257465),
(438372, 'PF07248', NULL, 'Protein of unknown function (DUF1431)', 155, NULL, 'DUF1431', 257466),
(438373, 'PF17480', NULL, 'AlphaC N-terminal domain 2', 71, NULL, 'AlphaC_N2', 257467),
(438374, 'PF17194', NULL, 'Transcriptional regulator, AbiEi antitoxin N-terminal domain', 93, NULL, 'AbiEi_3_N', 257468),
(438375, 'PF09173', NULL, 'Initiation factor eIF2 gamma, C terminal', 86, NULL, 'eIF2_C', 257469),
(438376, 'PF17112', NULL, 'Mitochondrial import receptor subunit Tom6, fungal', 45, NULL, 'Tom6', 257470),
(438377, 'PF18814', NULL, 'phage-Barnase-EndoU-ColicinE5/D-RelE like nuclease5', 249, NULL, 'PBECR5', 257471),
(438378, 'PF07967', NULL, 'C3HC zinc finger-like', 133, NULL, 'zf-C3HC', 257472),
(438379, 'PF15287', NULL, 'KRBA1 family repeat', 44, NULL, 'KRBA1', 257473),
(438380, 'PF11175', NULL, 'Protein of unknown function (DUF2961)', 234, NULL, 'DUF2961', 257474),
(438381, 'PF03684', NULL, 'Uncharacterised protein family (UPF0179)', 140, NULL, 'UPF0179', 257475),
(438382, 'PF15382', NULL, 'Domain of unknown function (DUF4609)', 68, NULL, 'DUF4609', 257476),
(438383, 'PF00087', NULL, 'Snake toxin and toxin-like protein', 70, NULL, 'Toxin_TOLIP', 257477),
(438384, 'PF17175', NULL, 'Modulator of levamisole receptor-1', 122, NULL, 'MOLO1', 257478),
(438385, 'PF11107', NULL, 'Fanconi anemia group F protein (FANCF)', 346, NULL, 'FANCF', 257479),
(438386, 'PF01696', NULL, 'Adenovirus EB1 55K protein / large t-antigen', 387, NULL, 'Adeno_E1B_55K', 257480);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(438387, 'PF18388', NULL, 'Atg29 N-terminal domain', 54, NULL, 'ATG29_N', 257481),
(438388, 'PF12577', NULL, 'PPAR gamma N-terminal region', 84, NULL, 'PPARgamma_N', 257482),
(438389, 'PF17739', NULL, 'Family of unknown function (DUF5576)', 134, NULL, 'DUF5576', 257483),
(438390, 'PF10129', NULL, 'OpgC protein', 358, NULL, 'OpgC_C', 257484),
(438391, 'PF10306', NULL, 'Hypothetical protein FLILHELTA', 88, NULL, 'FLILHELTA', 257485),
(438392, 'PF12977', NULL, 'Domain of Unknown Function with PDB structure (DUF3861)', 90, NULL, 'DUF3861', 257486),
(438393, 'PF14779', NULL, 'Ciliary BBSome complex subunit 1', 255, NULL, 'BBS1', 257487),
(438394, 'PF00037', NULL, '4Fe-4S binding domain', 24, NULL, 'Fer4', 257488),
(438395, 'PF01435', NULL, 'Peptidase family M48', 187, NULL, 'Peptidase_M48', 257489),
(438396, 'PF04314', NULL, 'Copper chaperone PCu(A)C', 109, NULL, 'PCuAC', 257490),
(438397, 'PF06138', NULL, 'Chordopoxvirus E11 protein', 128, NULL, 'Chordopox_E11', 257491),
(438398, 'PF08561', NULL, 'Mitochondrial ribosomal protein L37', 114, NULL, 'Ribosomal_L37', 257492),
(438399, 'PF07978', NULL, 'NIPSNAP', 102, NULL, 'NIPSNAP', 257493),
(438400, 'PF09824', NULL, 'ArsR transcriptional regulator', 159, NULL, 'ArsR', 257494),
(438401, 'PF05303', NULL, 'GSKIP domain', 105, NULL, 'GSKIP_dom', 257495),
(438402, 'PF08495', NULL, 'FIST N domain', 173, NULL, 'FIST', 257496),
(438403, 'PF18292', NULL, 'Zinc transporter ZIP4 domain', 171, NULL, 'ZIP4_domain', 257497),
(438404, 'PF09864', NULL, 'Membrane-bound lysozyme-inhibitor of c-type lysozyme', 67, NULL, 'MliC', 257498),
(438405, 'PF10549', NULL, 'ORF11CD3 domain', 53, NULL, 'ORF11CD3', 257499),
(438406, 'PF12870', NULL, 'Domain of unknown function (DUF4878)', 112, NULL, 'DUF4878', 257500),
(438407, 'PF20268', NULL, 'SBDS protein, C-terminal domain', 71, NULL, 'SBDS_C', 257501),
(438408, 'PF05095', NULL, 'Protein of unknown function (DUF687)', 537, NULL, 'DUF687', 257502),
(438409, 'PF06825', NULL, 'Heat shock factor binding protein 1', 51, NULL, 'HSBP1', 257503),
(438410, 'PF05109', NULL, 'Herpes virus major outer envelope glycoprotein (BLLF1)', 886, NULL, 'Herpes_BLLF1', 257504),
(438411, 'PF03030', NULL, 'Inorganic H+ pyrophosphatase', 649, NULL, 'H_PPase', 257505),
(438412, 'PF12582', NULL, 'Protein of unknown function (DUF3757)', 120, NULL, 'DUF3757', 257506),
(438413, 'PF09184', NULL, 'PPP4R2', 258, NULL, 'PPP4R2', 257507),
(438414, 'PF03321', NULL, 'GH3 auxin-responsive promoter', 532, NULL, 'GH3', 257508),
(438415, 'PF03043', NULL, 'Herpesvirus UL87 family', 524, NULL, 'Herpes_UL87', 257509),
(438416, 'PF04066', NULL, 'Multiple resistance and pH regulation protein F (MrpF / PhaF)', 53, NULL, 'MrpF_PhaF', 257510),
(438417, 'PF10836', NULL, 'Protein of unknown function (DUF2574)', 93, NULL, 'DUF2574', 257511),
(438418, 'PF14738', NULL, 'Cilia- and flagella-associated protein 91', 153, NULL, 'CFAP91', 257512),
(438419, 'PF01232', NULL, 'Mannitol dehydrogenase Rossmann domain', 151, NULL, 'Mannitol_dh', 257513),
(438420, 'PF07443', NULL, 'HepA-related protein (HARP)', 55, NULL, 'HARP', 257514),
(438421, 'PF10598', NULL, 'RNA recognition motif of the spliceosomal PrP8', 92, NULL, 'RRM_4', 257515),
(438422, 'PF01581', NULL, 'FMRFamide related peptide family', 11, NULL, 'FARP', 257516),
(438423, 'PF05883', NULL, 'Baculovirus U-box/Ring-like domain', 134, NULL, 'Baculo_RING', 257517),
(438424, 'PF00653', NULL, 'Inhibitor of Apoptosis domain', 73, NULL, 'BIR', 257518),
(438425, 'PF15713', NULL, 'Protein tyrosine phosphatase receptor type C-associated', 156, NULL, 'PTPRCAP', 257519),
(438426, 'PF02043', NULL, 'Bacteriochlorophyll C binding protein', 80, NULL, 'Bac_chlorC', 257520),
(438427, 'PF09923', NULL, 'Uncharacterized protein conserved in bacteria (DUF2155)', 89, NULL, 'DUF2155', 257521),
(438428, 'PF05660', NULL, 'Coxiella burnetii protein of unknown function (DUF807)', 142, NULL, 'DUF807', 257522),
(438429, 'PF07288', NULL, 'RNA polymerase epsilon subunit', 68, NULL, 'RpoY', 257523),
(438430, 'PF18057', NULL, 'Domain of unknown function (DUF5594)', 128, NULL, 'DUF5594', 257524);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(438431, 'PF20315', NULL, 'Family of unknown function (DUF6611)', 168, NULL, 'DUF6611', 257525),
(438432, 'PF14357', NULL, 'Domain of unknown function (DUF4404)', 83, NULL, 'DUF4404', 257526),
(438433, 'PF20472', NULL, 'PD-(D/E)XK nuclease superfamily domain', 144, NULL, 'PDDEXK_11', 257527),
(438434, 'PF08592', NULL, 'Anthrone oxygenase', 107, NULL, 'Anthrone_oxy', 257528),
(438435, 'PF15309', NULL, 'ALMS motif', 136, NULL, 'ALMS_motif', 257529),
(438436, 'PF16965', NULL, 'Ceramide synthase regulator', 397, NULL, 'CSG2', 257530),
(438437, 'PF02019', NULL, 'WIF domain', 132, NULL, 'WIF', 257531),
(438438, 'PF01167', NULL, 'Tub family', 263, NULL, 'Tub', 257532),
(438439, 'PF05507', NULL, 'Microfibril-associated glycoprotein (MAGP)', 137, NULL, 'MAGP', 257533),
(438440, 'PF05894', NULL, 'Podovirus DNA encapsidation protein (Gp16)', 331, NULL, 'Podovirus_Gp16', 257534),
(438441, 'PF13101', NULL, 'Protein of unknown function (DUF3945)', 59, NULL, 'DUF3945', 257535),
(438442, 'PF09159', NULL, 'Mitochondrial resolvase Ydc2 / RNA splicing MRS1', 280, NULL, 'Ydc2-catalyt', 257536),
(438443, 'PF18463', NULL, 'Proprotein convertase subtilisin-like/kexin type 9 C-terminal domain', 74, NULL, 'PCSK9_C3', 257537),
(438444, 'PF08303', NULL, 'tRNA ligase kinase domain', 168, NULL, 'tRNA_lig_kinase', 257538),
(438445, 'PF07388', NULL, 'Alpha-2,8-polysialyltransferase (POLYST)', 310, NULL, 'A-2_8-polyST', 257539),
(438446, 'PF13672', NULL, 'Protein phosphatase 2C', 210, NULL, 'PP2C_2', 257540),
(438447, 'PF09962', NULL, 'Uncharacterized conserved protein (DUF2196)', 61, NULL, 'DUF2196', 257541),
(438448, 'PF14795', NULL, 'Leucine-tRNA synthetase-specific domain', 56, NULL, 'Leucyl-specific', 257542),
(438449, 'PF03042', NULL, 'Birnavirus VP5 protein', 135, NULL, 'Birna_VP5', 257543),
(438450, 'PF06595', NULL, 'Borna disease virus P24 protein', 201, NULL, 'BDV_P24', 257544),
(438451, 'PF18374', NULL, 'Enolase N-terminal domain-like', 52, NULL, 'Enolase_like_N', 257545),
(438452, 'PF03569', NULL, 'Peptidase family C8', 208, NULL, 'Peptidase_C8', 257546),
(438453, 'PF13285', NULL, 'Domain of unknown function (DUF4073)', 157, NULL, 'DUF4073', 257547),
(438454, 'PF04173', NULL, 'TQO small subunit DoxD', 167, NULL, 'DoxD', 257548),
(438455, 'PF10355', NULL, 'Protein of unknown function (Ytp1)', 277, NULL, 'Ytp1', 257549),
(438456, 'PF01521', NULL, 'Iron-sulphur cluster biosynthesis', 111, NULL, 'Fe-S_biosyn', 257550),
(438457, 'PF04798', NULL, 'Baculovirus 19 kDa protein conserved region', 143, NULL, 'Baculo_19', 257551),
(438458, 'PF15700', NULL, 'Domain of unknown function (DUF4667)', 226, NULL, 'DUF4667', 257552),
(438459, 'PF17262', NULL, 'Cas6b C-terminal domain', 114, NULL, 'Cas6b_C', 257553),
(438460, 'PF08146', NULL, 'BP28CT (NUC211) domain', 158, NULL, 'BP28CT', 257554),
(438461, 'PF11365', NULL, 'Protein SOGA', 95, NULL, 'SOGA', 257555),
(438462, 'PF00389', NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase, catalytic domain', 134, NULL, '2-Hacid_dh', 257556),
(438463, 'PF06985', NULL, 'Heterokaryon incompatibility protein (HET)', 146, NULL, 'HET', 257557),
(438464, 'PF03013', NULL, 'Pyrimidine dimer DNA glycosylase', 82, NULL, 'Pyr_excise', 257558),
(438465, 'PF05025', NULL, 'RbsD / FucU transport protein family', 134, NULL, 'RbsD_FucU', 257559),
(438466, 'PF15575', NULL, 'Immunity protein 49', 214, NULL, 'Imm49', 257560),
(438467, 'PF19416', NULL, 'Astrovirus VPg protein', 95, NULL, 'Astro_VPg', 257561),
(438468, 'PF01676', NULL, 'Metalloenzyme superfamily', 248, NULL, 'Metalloenzyme', 257562),
(438469, 'PF16272', NULL, 'Domain of unknown function (DUF4925)', 324, NULL, 'DUF4925', 257563),
(438470, 'PF15553', NULL, 'Testis-expressed protein 19', 159, NULL, 'TEX19', 257564),
(438471, 'PF08979', NULL, 'Domain of unknown function (DUF1894)', 88, NULL, 'DUF1894', 257565),
(438472, 'PF18128', NULL, 'Hydrogen maturase F dimerization domain', 99, NULL, 'HydF_dimer', 257566),
(438473, 'PF05951', NULL, 'Bacterial protein of unknown function (DUF882)', 153, NULL, 'Peptidase_M15_2', 257567),
(438474, 'PF11626', NULL, 'TRF2-interacting telomeric protein/Rap1 - C terminal domain', 84, NULL, 'Rap1_C', 257568);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(438475, 'PF01254', NULL, 'Nuclear transition protein 2', 133, NULL, 'TP2', 257569),
(438476, 'PF16449', NULL, 'Fimbrillin MatB', 168, NULL, 'MatB', 257570),
(438477, 'PF14374', NULL, '60S ribosomal protein L4 C-terminal domain', 77, NULL, 'Ribos_L4_asso_C', 257571),
(438478, 'PF08152', NULL, 'GUCT (NUC152) domain', 97, NULL, 'GUCT', 257572),
(438479, 'PF06367', NULL, 'Diaphanous FH3 Domain', 195, NULL, 'Drf_FH3', 257573),
(438480, 'PF08462', NULL, 'Carmovirus coat protein', 99, NULL, 'Carmo_coat_C', 257574),
(438481, 'PF13998', NULL, 'MgrB protein', 29, NULL, 'MgrB', 257575),
(438482, 'PF06337', NULL, 'DUSP domain', 93, NULL, 'DUSP', 257576),
(438483, 'PF06379', NULL, 'L-rhamnose-proton symport protein (RhaT)', 344, NULL, 'RhaT', 257577),
(438484, 'PF09971', NULL, 'Predicted membrane protein (DUF2206)', 380, NULL, 'DUF2206', 257578),
(438485, 'PF00250', NULL, 'Forkhead domain', 88, NULL, 'Forkhead', 257579),
(438486, 'PF14392', NULL, 'Zinc knuckle', 49, NULL, 'zf-CCHC_4', 257580),
(438487, 'PF04870', NULL, 'Moulting cycle', 345, NULL, 'Moulting_cycle', 257581),
(438488, 'PF17864', NULL, 'RuvB AAA lid domain', 74, NULL, 'AAA_lid_4', 257582),
(438489, 'PF03180', NULL, 'NlpA lipoprotein', 237, NULL, 'Lipoprotein_9', 257583),
(438490, 'PF02241', NULL, 'Methyl-coenzyme M reductase beta subunit, C-terminal domain', 249, NULL, 'MCR_beta', 257584),
(438491, 'PF20181', NULL, 'Family of unknown function (DUF6544)', 222, NULL, 'DUF6544', 257585),
(438492, 'PF12635', NULL, 'Protein of unknown function (DUF3780)', 184, NULL, 'DUF3780', 257586),
(438493, 'PF09157', NULL, 'Pseudouridine synthase II TruB, C-terminal', 58, NULL, 'TruB-C_2', 257587),
(438494, 'PF14818', NULL, 'Domain of unknown function (DUF4482)', 139, NULL, 'DUF4482', 257588),
(438495, 'PF09891', NULL, 'Uncharacterized protein conserved in archaea (DUF2118)', 151, NULL, 'DUF2118', 257589),
(438496, 'PF17019', NULL, 'Domain of unknown function (DUF5096)', 192, NULL, 'DUF5096', 257590),
(438497, 'PF10547', NULL, 'P22_AR N-terminal domain', 114, NULL, 'P22_AR_N', 257591),
(438498, 'PF14892', NULL, 'Domain of unknown function (DUF4490)', 103, NULL, 'DUF4490', 257592),
(438499, 'PF07790', NULL, 'Archaeal Type IV pilin, N-terminal', 81, NULL, 'Pilin_N', 257593),
(438500, 'PF17632', NULL, 'Family of unknown function (DUF5513)', 91, NULL, 'DUF5513', 257594),
(438501, 'PF19781', NULL, 'Family of unknown function (DUF6266)', 198, NULL, 'DUF6266', 257595),
(438502, 'PF08707', NULL, 'Primase C terminal 2 (PriCT-2)', 77, NULL, 'PriCT_2', 257596),
(438503, 'PF15932', NULL, 'Domain of unknown function (DUF4748)', 52, NULL, 'DUF4748', 257597),
(438504, 'PF20224', NULL, 'Family of unknown function (DUF6583)', 447, NULL, 'DUF6583', 257598),
(438505, 'PF01595', NULL, 'Cyclin M transmembrane N-terminal domain', 180, NULL, 'CNNM', 257599),
(438506, 'PF12623', NULL, 'RNA repair, ligase-Pnkp-associating, region of Hen1', 242, NULL, 'Hen1_L', 257600),
(438507, 'PF01630', NULL, 'Hyaluronidase', 335, NULL, 'Glyco_hydro_56', 257601),
(438508, 'PF03742', NULL, 'PetN', 29, NULL, 'PetN', 257602),
(438509, 'PF17073', NULL, 'Two-component-system connector protein', 66, NULL, 'SafA', 257603),
(438510, 'PF05710', NULL, 'Coiled coil', 91, NULL, 'Coiled', 257604),
(438511, 'PF11038', NULL, 'Dispersed gene family protein 1 of Trypanosoma cruzi region 5', 278, NULL, 'DGF-1_5', 257605),
(438512, 'PF12861', NULL, 'Anaphase-promoting complex subunit 11 RING-H2 finger', 85, NULL, 'zf-ANAPC11', 257606),
(438513, 'PF18239', NULL, 'Hemagglutinin I', 90, NULL, 'HA1', 257607),
(438514, 'PF05091', NULL, 'Eukaryotic translation initiation factor 3 subunit 7 (eIF-3)', 526, NULL, 'eIF-3_zeta', 257608),
(438515, 'PF01479', NULL, 'S4 domain', 48, NULL, 'S4', 257609),
(438516, 'PF17868', NULL, 'AAA lid domain', 72, NULL, 'AAA_lid_8', 257610),
(438517, 'PF16871', NULL, 'Domain of unknown function (DUF5077)', 191, NULL, 'DUF5077', 257611),
(438518, 'PF16461', NULL, 'Lambda phage tail tube protein, TTP', 134, NULL, 'Phage_TTP_12', 257612),
(438519, 'PF18805', NULL, 'Leucine-rich repeat', 67, NULL, 'LRR_10', 257613);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(438520, 'PF09196', NULL, 'Domain of unknown function (DUF1953)', 63, NULL, 'DUF1953', 257614),
(438521, 'PF13237', NULL, '4Fe-4S dicluster domain', 56, NULL, 'Fer4_10', 257615),
(438522, 'PF01465', NULL, 'GRIP domain', 44, NULL, 'GRIP', 257616),
(438523, 'PF06416', NULL, 'Effector protein NleG', 113, NULL, 'T3SS_NleG', 257617),
(438524, 'PF17049', NULL, 'ATPase expression protein 1', 395, NULL, 'AEP1', 257618),
(438525, 'PF16863', NULL, 'N-terminal barrel of NtMGAM and CtMGAM, maltase-glucoamylase', 114, NULL, 'NtCtMGAM_N', 257619),
(438526, 'PF18265', NULL, 'Nas2 N_terminal domain', 79, NULL, 'Nas2_N', 257620),
(438527, 'PF09253', NULL, 'Pollen allergen Ole e 6', 39, NULL, 'Ole_e_6', 257621),
(438528, 'PF19130', NULL, 'Family of unknown function (DUF5813)', 144, NULL, 'DUF5813', 257622),
(438529, 'PF00221', NULL, 'Aromatic amino acid lyase', 463, NULL, 'Lyase_aromatic', 257623),
(438530, 'PF19690', NULL, 'Family of unknown function (DUF6191)', 42, NULL, 'DUF6191', 257624),
(438531, 'PF15054', NULL, 'Domain of unknown function (DUF4535)', 45, NULL, 'DUF4535', 257625),
(438532, 'PF08606', NULL, 'Prp19/Pso4-like', 68, NULL, 'Prp19', 257626),
(438533, 'PF07052', NULL, 'Hepatocellular carcinoma-associated antigen 59', 106, NULL, 'Hep_59', 257627),
(438534, 'PF11568', NULL, 'Mediator complex subunit 29', 139, NULL, 'Med29', 257628),
(438535, 'PF19746', NULL, 'Family of unknown function (DUF6233)', 58, NULL, 'DUF6233', 257629),
(438536, 'PF14540', NULL, 'Nucleotidyltransferase-like', 118, NULL, 'NTF-like', 257630),
(438537, 'PF08821', NULL, 'CGGC domain', 106, NULL, 'CGGC', 257631),
(438538, 'PF01616', NULL, 'Orbivirus NS3', 193, NULL, 'Orbi_NS3', 257632),
(438539, 'PF00644', NULL, 'Poly(ADP-ribose) polymerase catalytic domain', 194, NULL, 'PARP', 257633),
(438540, 'PF00969', NULL, 'Class II histocompatibility antigen, beta domain', 75, NULL, 'MHC_II_beta', 257634),
(438541, 'PF12084', NULL, 'Protein of unknown function (DUF3561)', 107, NULL, 'DUF3561', 257635),
(438542, 'PF16176', NULL, 'T-box transcription factor-associated', 226, NULL, 'T-box_assoc', 257636),
(438543, 'PF17807', NULL, 'Variant UBP zinc finger', 64, NULL, 'zf-UBP_var', 257637),
(438544, 'PF00927', NULL, 'Transglutaminase family, C-terminal ig like domain', 106, NULL, 'Transglut_C', 257638),
(438545, 'PF18585', NULL, 'Chromatin remodeling factor Mit1 C-terminal Zn finger 2', 53, NULL, 'zf-CCCH_6', 257639),
(438546, 'PF13448', NULL, 'Domain of unknown function (DUF4114)', 88, NULL, 'DUF4114', 257640),
(438547, 'PF01157', NULL, 'Ribosomal protein L21e', 101, NULL, 'Ribosomal_L21e', 257641),
(438548, 'PF01197', NULL, 'Ribosomal protein L31', 67, NULL, 'Ribosomal_L31', 257642),
(438549, 'PF00747', NULL, 'ssDNA binding protein', 1132, NULL, 'Viral_DNA_bp', 257643),
(438550, 'PF02926', NULL, 'THUMP domain', 144, NULL, 'THUMP', 257644),
(438551, 'PF19979', NULL, 'Family of unknown function (DUF6415)', 95, NULL, 'DUF6415', 257645),
(438552, 'PF01351', NULL, 'Ribonuclease HII', 198, NULL, 'RNase_HII', 257646),
(438553, 'PF06813', NULL, 'Nodulin-like', 250, NULL, 'Nodulin-like', 257647),
(438554, 'PF12689', NULL, 'Acid Phosphatase', 169, NULL, 'Acid_PPase', 257648),
(438555, 'PF18880', NULL, 'Uracil-DNA glycosylase inhibitor', 82, NULL, 'UDI', 257649),
(438556, 'PF01488', NULL, 'Shikimate / quinate 5-dehydrogenase', 138, NULL, 'Shikimate_DH', 257650),
(438557, 'PF19218', NULL, 'Coronavirus replicase NSP3, C-terminal', 459, NULL, 'CoV_NSP3_C', 257651),
(438558, 'PF17012', NULL, 'Domain of unknown function (DUF5091)', 147, NULL, 'DUF5091', 257652),
(438559, 'PF09661', NULL, 'Protein of unknown function (DUF2398)', 363, NULL, 'DUF2398', 257653),
(438560, 'PF00010', NULL, 'Helix-loop-helix DNA-binding domain', 54, NULL, 'HLH', 257654),
(438561, 'PF15530', NULL, 'Bacterial toxin 25', 167, NULL, 'Ntox25', 257655),
(438562, 'PF12459', NULL, 'D-Ala-teichoic acid biosynthesis protein', 43, NULL, 'DUF3687', 257656),
(438563, 'PF03983', NULL, 'SLA1 homology domain 1, SHD1', 67, NULL, 'SHD1', 257657),
(438564, 'PF07100', NULL, 'Anabaena sensory rhodopsin transducer', 119, NULL, 'ASRT', 257658);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(438565, 'PF18999', NULL, 'Family of unknown function (DUF5728)', 188, NULL, 'DUF5728', 257659),
(438566, 'PF00432', NULL, 'Prenyltransferase and squalene oxidase repeat', 44, NULL, 'Prenyltrans', 257660),
(438567, 'PF20259', NULL, 'tRNA methyl transferase PRC-barrel domain', 66, NULL, 'tRNA_Me_trans_M', 257661),
(438568, 'PF19334', NULL, 'Domain of unknown function (DUF5920)', 203, NULL, 'DUF5920', 257662),
(438569, 'PF07600', NULL, 'Protein of unknown function (DUF1564)', 167, NULL, 'DUF1564', 257663),
(438570, 'PF15547', NULL, 'Steroid receptor-associated and regulated protein', 137, NULL, 'C1ORF64', 257664),
(438571, 'PF01395', NULL, 'PBP/GOBP family', 112, NULL, 'PBP_GOBP', 257665),
(438572, 'PF17083', NULL, 'Nucleolar protein Swm2', 130, NULL, 'Swm2', 257666),
(438573, 'PF01697', NULL, 'Glycosyltransferase family 92', 258, NULL, 'Glyco_transf_92', 257667),
(438574, 'PF03746', NULL, 'LamB/YcsF family', 239, NULL, 'LamB_YcsF', 257668),
(438575, 'PF05398', NULL, 'PufQ cytochrome subunit', 74, NULL, 'PufQ', 257669),
(438576, 'PF11607', NULL, 'Protein of unknown function (DUF3247)', 92, NULL, 'DUF3247', 257670),
(438577, 'PF18544', NULL, 'Polo box domain', 98, NULL, 'Polo_box_3', 257671),
(438578, 'PF11533', NULL, 'Protein of unknown function (DUF3225)', 126, NULL, 'DUF3225', 257672),
(438579, 'PF11990', NULL, 'Protein of unknown function (DUF3487)', 115, NULL, 'DUF3487', 257673),
(438580, 'PF10946', NULL, 'Protein of unknown function DUF2625', 207, NULL, 'DUF2625', 257674),
(438581, 'PF08771', NULL, 'FKBP12-rapamycin binding domain', 99, NULL, 'FRB_dom', 257675),
(438582, 'PF14796', NULL, 'Clathrin-adaptor complex-3 beta-1 subunit C-terminal', 148, NULL, 'AP3B1_C', 257676),
(438583, 'PF03171', NULL, '2OG-Fe(II) oxygenase superfamily', 101, NULL, '2OG-FeII_Oxy', 257677),
(438584, 'PF01831', NULL, 'Peptidase C16 family', 249, NULL, 'Peptidase_C16', 257678),
(438585, 'PF14871', NULL, 'Hypothetical glycosyl hydrolase 6', 137, NULL, 'GHL6', 257679),
(438586, 'PF00223', NULL, 'Photosystem I psaA/psaB protein', 717, NULL, 'PsaA_PsaB', 257680),
(438587, 'PF13487', NULL, 'HD domain', 64, NULL, 'HD_5', 257681),
(438588, 'PF01977', NULL, '3-octaprenyl-4-hydroxybenzoate carboxy-lyase', 406, NULL, 'UbiD', 257682),
(438589, 'PF17889', NULL, 'NLRC4 helical domain', 107, NULL, 'NLRC4_HD', 257683),
(438590, 'PF00412', NULL, 'LIM domain', 58, NULL, 'LIM', 257684),
(438591, 'PF19784', NULL, 'Family of unknown function (DUF6269)', 77, NULL, 'DUF6269', 257685),
(438592, 'PF05485', NULL, 'THAP domain', 86, NULL, 'THAP', 257686),
(438593, 'PF07124', NULL, 'Phytoreovirus outer capsid protein P8', 426, NULL, 'Phytoreo_P8', 257687),
(438594, 'PF03765', NULL, 'CRAL/TRIO, N-terminal domain', 54, NULL, 'CRAL_TRIO_N', 257688),
(438595, 'PF02675', NULL, 'S-adenosylmethionine decarboxylase', 106, NULL, 'AdoMet_dc', 257689),
(438596, 'PF07987', NULL, 'Domain of unkown function (DUF1775)', 149, NULL, 'DUF1775', 257690),
(438597, 'PF11536', NULL, 'Protein of unknown function (DUF3226)', 217, NULL, 'DUF3226', 257691),
(438598, 'PF20036', NULL, 'Major capsid protein 13-like', 313, NULL, 'Gp13-like', 257692),
(438599, 'PF00299', NULL, 'Squash family serine protease inhibitor', 29, NULL, 'Squash', 257693),
(438600, 'PF00780', NULL, 'CNH domain', 254, NULL, 'CNH', 257694),
(438601, 'PF05783', NULL, 'Dynein light intermediate chain (DLIC)', 471, NULL, 'DLIC', 257695),
(438602, 'PF06392', NULL, 'Acid shock protein repeat', 21, NULL, 'Asr', 257696),
(438603, 'PF03896', NULL, 'Translocon-associated protein (TRAP), alpha subunit', 282, NULL, 'TRAP_alpha', 257697),
(438604, 'PF02161', NULL, 'Progesterone receptor', 564, NULL, 'Prog_receptor', 257698),
(438605, 'PF10741', NULL, 'Type II secretion system (T2SS), protein M subtype b', 111, NULL, 'T2SSM_b', 257699),
(438606, 'PF09883', NULL, 'Uncharacterized protein conserved in archaea (DUF2110)', 223, NULL, 'DUF2110', 257700),
(438607, 'PF20169', NULL, 'Family of unknown function (DUF6537)', 203, NULL, 'DUF6537', 257701),
(438608, 'PF07858', NULL, 'Limonene-1,2-epoxide hydrolase catalytic domain', 125, NULL, 'LEH', 257702);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(438609, 'PF11034', NULL, 'Glucose-repressible protein Grg1', 67, NULL, 'Grg1', 257703),
(438610, 'PF04191', NULL, 'Phospholipid methyltransferase', 105, NULL, 'PEMT', 257704),
(438611, 'PF06609', NULL, 'Fungal trichothecene efflux pump (TRI12)', 599, NULL, 'TRI12', 257705),
(438612, 'PF05297', NULL, 'Herpesvirus latent membrane protein 1 (LMP1)', 386, NULL, 'Herpes_LMP1', 257706),
(438613, 'PF10583', NULL, 'Involucrin of squamous epithelia N-terminus', 69, NULL, 'Involucrin_N', 257707),
(438614, 'PF20221', NULL, 'Family of unknown function (DUF6580)', 163, NULL, 'DUF6580', 257708),
(438615, 'PF04364', NULL, 'DNA polymerase III chi subunit, HolC', 137, NULL, 'DNA_pol3_chi', 257709),
(438616, 'PF03544', NULL, 'Gram-negative bacterial TonB protein C-terminal', 79, NULL, 'TonB_C', 257710),
(438617, 'PF17947', NULL, 'Four helical bundle domain', 78, NULL, '4HB', 257711),
(438618, 'PF00314', NULL, 'Thaumatin family', 214, NULL, 'Thaumatin', 257712),
(438619, 'PF16495', NULL, 'SWIRM-associated region 1', 84, NULL, 'SWIRM-assoc_1', 257713),
(438620, 'PF11126', NULL, 'Transcriptional regulator DsbA', 67, NULL, 'Phage_DsbA', 257714),
(438621, 'PF10677', NULL, 'Protein of unknown function (DUF2490)', 187, NULL, 'DUF2490', 257715),
(438622, 'PF10709', NULL, 'Protein of unknown function (DUF2511)', 87, NULL, 'DUF2511', 257716),
(438623, 'PF11701', NULL, 'Myosin-binding striated muscle assembly central', 153, NULL, 'UNC45-central', 257717),
(438624, 'PF11180', NULL, 'Protein of unknown function (DUF2968)', 180, NULL, 'DUF2968', 257718),
(438625, 'PF10840', NULL, 'Protein of unknown function (DUF2645)', 98, NULL, 'DUF2645', 257719),
(438626, 'PF17760', NULL, 'UvrA interaction domain', 109, NULL, 'UvrA_inter', 257720),
(438627, 'PF06802', NULL, 'Protein of unknown function (DUF1231)', 340, NULL, 'DUF1231', 257721),
(438628, 'PF09039', NULL, 'Mu DNA binding, I gamma subdomain', 109, NULL, 'HTH_Tnp_Mu_2', 257722),
(438629, 'PF05381', NULL, 'Tymovirus endopeptidase', 111, NULL, 'Peptidase_C21', 257723),
(438630, 'PF08454', NULL, 'RyR and IP3R Homology associated', 99, NULL, 'RIH_assoc', 257724),
(438631, 'PF11077', NULL, 'Protein of unknown function (DUF2616)', 173, NULL, 'DUF2616', 257725),
(438632, 'PF19270', NULL, 'F-box only protein C-terminal region', 210, NULL, 'FBO_C', 257726),
(438633, 'PF05727', NULL, 'Uncharacterised protein family (UPF0228)', 124, NULL, 'UPF0228', 257727),
(438634, 'PF01928', NULL, 'CYTH domain', 179, NULL, 'CYTH', 257728),
(438635, 'PF07756', NULL, 'Protein of unknown function (DUF1612)', 127, NULL, 'DUF1612', 257729),
(438636, 'PF11364', NULL, 'Protein of unknown function (DUF3165)', 81, NULL, 'DUF3165', 257730),
(438637, 'PF09225', NULL, 'Restriction endonuclease PvuII', 155, NULL, 'Endonuc-PvuII', 257731),
(438638, 'PF13610', NULL, 'DDE domain', 139, NULL, 'DDE_Tnp_IS240', 257732),
(438639, 'PF00345', NULL, 'Pili and flagellar-assembly chaperone, PapD N-terminal domain', 125, NULL, 'PapD_N', 257733),
(438640, 'PF09917', NULL, 'Uncharacterized protein conserved in bacteria (DUF2147)', 112, NULL, 'DUF2147', 257734),
(438641, 'PF12441', NULL, 'CopG antitoxin of type II toxin-antitoxin system', 79, NULL, 'CopG_antitoxin', 257735),
(438642, 'PF15496', NULL, 'Domain of unknown function (DUF4646)', 125, NULL, 'DUF4646', 257736),
(438643, 'PF01635', NULL, 'Coronavirus M matrix/glycoprotein', 208, NULL, 'CoV_M', 257737),
(438644, 'PF09201', NULL, 'SRX, signal recognition particle receptor alpha subunit', 148, NULL, 'SRX', 257738),
(438645, 'PF19582', NULL, 'Solute-binding protein AdeT 1/2', 392, NULL, 'AdeT1_2', 257739),
(438646, 'PF04630', NULL, 'Phage tail tube protein', 199, NULL, 'Phage_TTP_1', 257740),
(438647, 'PF00607', NULL, 'gag protein p24 N-terminal domain', 128, NULL, 'Gag_p24', 257741),
(438648, 'PF03857', NULL, 'Colicin immunity protein', 138, NULL, 'Colicin_im', 257742),
(438649, 'PF10395', NULL, 'Utp8 family', 690, NULL, 'Utp8', 257743),
(438650, 'PF16859', NULL, 'Tetracyclin repressor-like, C-terminal domain', 113, NULL, 'TetR_C_11', 257744),
(438651, 'PF03064', NULL, 'HSV U79 / HCMV P34', 135, NULL, 'U79_P34', 257745);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(438652, 'PF08362', NULL, 'YcdC-like protein, C-terminal region', 143, NULL, 'TetR_C_3', 257746),
(438653, 'PF11389', NULL, 'Leptospira porin protein OmpL1', 272, NULL, 'Porin_OmpL1', 257747),
(438654, 'PF20349', NULL, 'Family of unknown function (DUF6644)', 155, NULL, 'DUF6644', 257748),
(438655, 'PF20426', NULL, 'Neurobeachin beta propeller domain', 350, NULL, 'NBCH_WD40', 257749),
(438656, 'PF01130', NULL, 'CD36 family', 469, NULL, 'CD36', 257750),
(438657, 'PF02036', NULL, 'SCP-2 sterol transfer family', 101, NULL, 'SCP2', 257751),
(438658, 'PF06094', NULL, 'Gamma-glutamyl cyclotransferase, AIG2-like', 122, NULL, 'GGACT', 257752),
(438659, 'PF09764', NULL, 'N-terminal glutamine amidase', 186, NULL, 'Nt_Gln_amidase', 257753),
(438660, 'PF03258', NULL, 'Baculovirus FP protein', 147, NULL, 'Baculo_FP', 257754),
(438661, 'PF16075', NULL, 'Domain of unknown function (DUF4815)', 570, NULL, 'DUF4815', 257755),
(438662, 'PF13872', NULL, 'P-loop containing NTP hydrolase pore-1', 302, NULL, 'AAA_34', 257756),
(438663, 'PF05265', NULL, 'Protein of unknown function (DUF723)', 60, NULL, 'DUF723', 257757),
(438664, 'PF14934', NULL, 'Transmembrane protein 254', 91, NULL, 'TMEM254', 257758),
(438665, 'PF02393', NULL, 'US22 like', 125, NULL, 'US22', 257759),
(438666, 'PF04054', NULL, 'CCR4-Not complex component, Not1', 369, NULL, 'Not1', 257760),
(438667, 'PF13978', NULL, 'Protein of unknown function (DUF4223)', 54, NULL, 'DUF4223', 257761),
(438668, 'PF03959', NULL, 'Serine hydrolase (FSH1)', 212, NULL, 'FSH1', 257762),
(438669, 'PF04577', NULL, 'Glycosyltransferase 61', 128, NULL, 'Glyco_transf_61', 257763),
(438670, 'PF08997', NULL, 'Ubiquinol-cytochrome C reductase complex, 6.4kD protein', 55, NULL, 'UCR_6-4kD', 257764),
(438671, 'PF10732', NULL, 'Protein of unknown function (DUF2524)', 84, NULL, 'DUF2524', 257765),
(438672, 'PF17751', NULL, 'SKICH domain', 104, NULL, 'SKICH', 257766),
(438673, 'PF05701', NULL, 'Weak chloroplast movement under blue light', 562, NULL, 'WEMBL', 257767),
(438674, 'PF07352', NULL, 'Bacteriophage Mu Gam like protein', 154, NULL, 'Phage_Mu_Gam', 257768),
(438675, 'PF10496', NULL, 'SNARE-complex protein Syntaxin-18 N-terminus', 87, NULL, 'Syntaxin-18_N', 257769),
(438676, 'PF02985', NULL, 'HEAT repeat', 31, NULL, 'HEAT', 257770),
(438677, 'PF10657', NULL, 'Photosystem P840 reaction centre protein PscD', 144, NULL, 'RC-P840_PscD', 257771),
(438678, 'PF11053', NULL, 'Terminase DNA packaging enzyme', 157, NULL, 'DNA_Packaging', 257772),
(438679, 'PF16627', NULL, 'Unstructured region between BRX_N and BRX domain', 70, NULL, 'BRX_assoc', 257773),
(438680, 'PF03165', NULL, 'MH1 domain', 103, NULL, 'MH1', 257774),
(438681, 'PF20028', NULL, 'vWA-MoxR associated protein C-terminal domain', 228, NULL, 'VMAP-C', 257775),
(438682, 'PF01913', NULL, 'Formylmethanofuran-tetrahydromethanopterin formyltransferase', 142, NULL, 'FTR', 257776),
(438683, 'PF07325', NULL, 'Curtovirus V2 protein', 126, NULL, 'Curto_V2', 257777),
(438684, 'PF19499', NULL, 'Family of unknown function (DUF6034)', 494, NULL, 'DUF6034', 257778),
(438685, 'PF07496', NULL, 'CW-type Zinc Finger', 48, NULL, 'zf-CW', 257779),
(438686, 'PF03881', NULL, 'Fructosamine kinase', 288, NULL, 'Fructosamin_kin', 257780),
(438687, 'PF06761', NULL, 'Intracellular multiplication and human macrophage-killing', 307, NULL, 'IcmF-related', 257781),
(438688, 'PF12793', NULL, 'Sugar transport-related sRNA regulator N-term', 115, NULL, 'SgrR_N', 257782),
(438689, 'PF16552', NULL, 'D-ornithine 4,5-aminomutase alpha-subunit', 115, NULL, 'OAM_alpha', 257783),
(438690, 'PF08013', NULL, 'D-tagatose-1,6-bisphosphate aldolase subunit GatZ/KbaZ-like', 420, NULL, 'GatZ_KbaZ-like', 257784),
(438691, 'PF16214', NULL, 'Adenylyl cyclase N-terminal extracellular and transmembrane region', 415, NULL, 'AC_N', 257785),
(438692, 'PF05284', NULL, 'Protein of unknown function (DUF736)', 100, NULL, 'DUF736', 257786),
(438693, 'PF04061', NULL, 'ORMDL family', 135, NULL, 'ORMDL', 257787),
(438694, 'PF00631', NULL, 'GGL domain', 69, NULL, 'G-gamma', 257788),
(438695, 'PF02600', NULL, 'Disulfide bond formation protein DsbB', 148, NULL, 'DsbB', 257789); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(438696, 'PF09785', NULL, 'Prp31 C terminal domain', 124, NULL, 'Prp31_C', 257790),
(438697, 'PF00751', NULL, 'DM DNA binding domain', 47, NULL, 'DM', 257791),
(438698, 'PF13860', NULL, 'FlgD Ig-like domain', 81, NULL, 'FlgD_ig', 257792),
(438699, 'PF06563', NULL, 'Protein of unknown function (DUF1125)', 55, NULL, 'DUF1125', 257793),
(438700, 'PF15557', NULL, 'CAF1 complex subunit p150, region binding to PCNA', 230, NULL, 'CAF1-p150_N', 257794),
(438701, 'PF01231', NULL, 'Indoleamine 2,3-dioxygenase', 438, NULL, 'IDO', 257795),
(438702, 'PF02090', NULL, 'Salmonella surface presentation of antigen gene type M protein', 140, NULL, 'SPAM', 257796),
(438703, 'PF18866', NULL, 'CxC7 like cysteine cluster associated with KDZ transposases', 64, NULL, 'CxC7', 257797),
(438704, 'PF16976', NULL, 'Flp pilus assembly protein RcpC/CpaB', 116, NULL, 'RcpC', 257798),
(438705, 'PF04939', NULL, 'Ribosome biogenesis regulatory protein (RRS1)', 166, NULL, 'RRS1', 257799),
(438706, 'PF09182', NULL, 'Bacterial purine repressor, N-terminal', 70, NULL, 'PuR_N', 257800),
(438707, 'PF16155', NULL, 'Domain of unknown function (DUF4863)', 153, NULL, 'DUF4863', 257801),
(438708, 'PF09999', NULL, 'Uncharacterized protein conserved in archaea (DUF2240)', 144, NULL, 'DUF2240', 257802),
(438709, 'PF00485', NULL, 'Phosphoribulokinase / Uridine kinase family', 196, NULL, 'PRK', 257803),
(438710, 'PF15725', NULL, 'Renal cancer differentiation gene 1 protein', 83, NULL, 'RCDG1', 257804),
(438711, 'PF01874', NULL, 'ATP:dephospho-CoA triphosphoribosyl transferase', 285, NULL, 'CitG', 257805),
(438712, 'PF07422', NULL, 'Sexual stage antigen s48/45 domain', 108, NULL, 's48_45', 257806),
(438713, 'PF07517', NULL, 'SecA DEAD-like domain', 290, NULL, 'SecA_DEAD', 257807),
(438714, 'PF11525', NULL, 'Copper resistance protein K', 70, NULL, 'CopK', 257808),
(438715, 'PF11478', NULL, 'Antimicrobial chitin binding protein tachystatin B', 42, NULL, 'Tachystatin_B', 257809),
(438716, 'PF15949', NULL, 'Domain of unknown function (DUF4757)', 170, NULL, 'DUF4757', 257810),
(438717, 'PF12841', NULL, 'YvrJ protein family', 36, NULL, 'YvrJ', 257811),
(438718, 'PF00647', NULL, 'Elongation factor 1 gamma, conserved domain', 107, NULL, 'EF1G', 257812),
(438719, 'PF01559', NULL, 'Zein seed storage protein', 245, NULL, 'Zein', 257813),
(438720, 'PF01653', NULL, 'NAD-dependent DNA ligase adenylation domain', 319, NULL, 'DNA_ligase_aden', 257814),
(438721, 'PF03995', NULL, 'Peptidase inhibitor family I36', 69, NULL, 'Inhibitor_I36', 257815),
(438722, 'PF04229', NULL, 'GrpB protein', 160, NULL, 'GrpB', 257816),
(438723, 'PF19873', NULL, 'Family of unknown function (DUF6346)', 145, NULL, 'DUF6346', 257817),
(438724, 'PF02903', NULL, 'Alpha amylase, N-terminal ig-like domain', 120, NULL, 'Alpha-amylase_N', 257818),
(438725, 'PF08116', NULL, 'PhTx neurotoxin family', 31, NULL, 'Toxin_29', 257819),
(438726, 'PF14794', NULL, 'Domain of unknown function (DUF4479)', 71, NULL, 'DUF4479', 257820),
(438727, 'PF06497', NULL, 'Baculovirus Ac102', 93, NULL, 'Baculo_Ac102', 257821),
(438728, 'PF00363', NULL, 'Casein', 87, NULL, 'Casein', 257822),
(438729, 'PF08167', NULL, 'rRNA processing/ribosome biogenesis', 193, NULL, 'RIX1', 257823),
(438730, 'PF10098', NULL, 'Uncharacterised protein conserved in bacteria (DUF2336)', 262, NULL, 'DUF2336', 257824),
(438731, 'PF14443', NULL, 'DBC1', 123, NULL, 'DBC1', 257825),
(438732, 'PF19647', NULL, 'Family of unknown function (DUF6150)', 98, NULL, 'DUF6150', 257826),
(438733, 'PF19408', NULL, 'PKD-like domain', 85, NULL, 'PKD_6', 257827),
(438734, 'PF04260', NULL, 'Protein of unknown function (DUF436)', 171, NULL, 'DUF436', 257828),
(438735, 'PF05187', NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase, 4Fe-4S', 104, NULL, 'ETF_QO', 257829),
(438736, 'PF08381', NULL, 'Transcription factor regulating root and shoot growth via Pin3', 56, NULL, 'BRX', 257830),
(438737, 'PF20248', NULL, 'Family of unknown function (DUF6603)', 498, NULL, 'DUF6603', 257831),
(438738, 'PF02130', NULL, 'Endoribonuclease YbeY', 131, NULL, 'YbeY', 257832);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(438739, 'PF17317', NULL, 'Mating hormone A-factor 1&2', 34, NULL, 'MFA1_2', 257833),
(438740, 'PF05858', NULL, 'Bovine immunodeficiency virus surface protein (SU)', 548, NULL, 'BIV_Env', 257834),
(438741, 'PF10198', NULL, 'Histone acetyltransferases subunit 3', 132, NULL, 'Ada3', 257835),
(438742, 'PF09314', NULL, 'Domain of unknown function (DUF1972)', 186, NULL, 'DUF1972', 257836),
(438743, 'PF13269', NULL, 'Protein of unknown function (DUF4060)', 74, NULL, 'DUF4060', 257837),
(438744, 'PF01237', NULL, 'Oxysterol-binding protein', 376, NULL, 'Oxysterol_BP', 257838),
(438745, 'PF04873', NULL, 'Ethylene insensitive 3', 253, NULL, 'EIN3', 257839),
(438746, 'PF02758', NULL, 'PAAD/DAPIN/Pyrin domain', 75, NULL, 'PYRIN', 257840),
(438747, 'PF19712', NULL, 'Acylglycerol kinase C-terminal', 215, NULL, 'AGK_C', 257841),
(438748, 'PF11280', NULL, 'Protein of unknown function (DUF3081)', 77, NULL, 'DUF3081', 257842),
(438749, 'PF11997', NULL, 'Domain of unknown function (DUF3492)', 268, NULL, 'DUF3492', 257843),
(438750, 'PF14742', NULL, 'N-terminal domain of (some) glycogen debranching enzymes', 194, NULL, 'GDE_N_bis', 257844),
(438751, 'PF01437', NULL, 'Plexin repeat', 51, NULL, 'PSI', 257845),
(438752, 'PF07806', NULL, 'Nodule-specific GRP repeat', 38, NULL, 'Nod_GRP', 257846),
(438753, 'PF10376', NULL, 'Double-strand recombination repair protein', 206, NULL, 'Mei5', 257847),
(438754, 'PF12589', NULL, 'Methyltransferase involved in Williams-Beuren syndrome', 82, NULL, 'WBS_methylT', 257848),
(438755, 'PF08345', NULL, 'Flagellar M-ring protein C-terminal', 149, NULL, 'YscJ_FliF_C', 257849),
(438756, 'PF13758', NULL, 'Prefoldin subunit', 99, NULL, 'Prefoldin_3', 257850),
(438757, 'PF04224', NULL, 'Protein of unknown function, DUF417', 175, NULL, 'DUF417', 257851),
(438758, 'PF18887', NULL, 'MBG domain', 72, NULL, 'MBG_3', 257852),
(438759, 'PF04957', NULL, 'Ribosome modulation factor', 54, NULL, 'RMF', 257853),
(438760, 'PF08918', NULL, 'PhoQ Sensor', 179, NULL, 'PhoQ_Sensor', 257854),
(438761, 'PF10471', NULL, 'Anaphase-promoting complex APC subunit CDC26', 74, NULL, 'ANAPC_CDC26', 257855),
(438762, 'PF11895', NULL, 'Fungal peroxidase extension region', 79, NULL, 'Peroxidase_ext', 257856),
(438763, 'PF12036', NULL, 'Protein of unknown function (DUF3522)', 186, NULL, 'DUF3522', 257857),
(438764, 'PF13124', NULL, 'Protein of unknown function (DUF3963)', 40, NULL, 'DUF3963', 257858),
(438765, 'PF15444', NULL, 'Transmembrane protein 247', 206, NULL, 'TMEM247', 257859),
(438766, 'PF13522', NULL, 'Glutamine amidotransferase domain', 133, NULL, 'GATase_6', 257860),
(438767, 'PF09848', NULL, 'Schlafen group 3, DNA/RNA helicase domain', 364, NULL, 'DUF2075', 257861),
(438768, 'PF18000', NULL, 'Type 2 DNA topoisomerase 6 subunit B C-terminal domain', 112, NULL, 'Top6b_C', 257862),
(438769, 'PF09177', NULL, 'Syntaxin 6, N-terminal', 100, NULL, 'Syntaxin-6_N', 257863),
(438770, 'PF12446', NULL, 'Protein of unknown function (DUF3682)', 130, NULL, 'DUF3682', 257864),
(438771, 'PF07181', NULL, 'VirC2 protein', 202, NULL, 'VirC2', 257865),
(438772, 'PF11158', NULL, 'Protein of unknown function (DUF2938)', 150, NULL, 'DUF2938', 257866),
(438773, 'PF16813', NULL, 'CRISPR-associated protein Csn2 subfamily St', 343, NULL, 'Cas_St_Csn2', 257867),
(438774, 'PF08499', NULL, '3''5''-cyclic nucleotide phosphodiesterase N-terminal', 61, NULL, 'PDEase_I_N', 257868),
(438775, 'PF10365', NULL, 'Domain of unknown function (DUF2436)', 164, NULL, 'DUF2436', 257869),
(438776, 'PF07215', NULL, 'Protein of unknown function (DUF1419)', 112, NULL, 'DUF1419', 257870),
(438777, 'PF11374', NULL, 'Protein of unknown function (DUF3176)', 106, NULL, 'DUF3176', 257871),
(438778, 'PF00957', NULL, 'Synaptobrevin', 89, NULL, 'Synaptobrevin', 257872),
(438779, 'PF01833', NULL, 'IPT/TIG domain', 85, NULL, 'TIG', 257873),
(438780, 'PF14879', NULL, 'Domain of unknown function (DUF4489)', 143, NULL, 'DUF4489', 257874),
(438781, 'PF11066', NULL, 'Protein of unknown function (DUF2867)', 144, NULL, 'DUF2867', 257875),
(438782, 'PF20086', NULL, 'Family of unknown function (DUF6478)', 257, NULL, 'DUF6478', 257876);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(438783, 'PF07097', NULL, 'Protein of unknown function (DUF1359)', 102, NULL, 'DUF1359', 257877),
(438784, 'PF05940', NULL, 'NnrS protein', 368, NULL, 'NnrS', 257878),
(438785, 'PF06180', NULL, 'Cobalt chelatase (CbiK)', 262, NULL, 'CbiK', 257879),
(438786, 'PF16864', NULL, 'Dimerisation domain', 90, NULL, 'Dimerisation2', 257880),
(438787, 'PF08894', NULL, 'Protein of unknown function (DUF1838)', 232, NULL, 'DUF1838', 257881),
(438788, 'PF06235', NULL, 'NADH dehydrogenase subunit 4L (NAD4L)', 86, NULL, 'NAD4L', 257882),
(438789, 'PF13801', NULL, 'Heavy-metal resistance', 125, NULL, 'Metal_resist', 257883),
(438790, 'PF13996', NULL, 'YobH-like protein', 70, NULL, 'YobH', 257884),
(438791, 'PF13944', NULL, 'Calycin-like beta-barrel domain', 123, NULL, 'Calycin_like', 257885),
(438792, 'PF19589', NULL, 'Family of unknown function (DUF6095)', 73, NULL, 'DUF6095', 257886),
(438793, 'PF13757', NULL, 'Vault protein inter-alpha-trypsin domain', 78, NULL, 'VIT_2', 257887),
(438794, 'PF06166', NULL, 'Protein of unknown function (DUF979)', 311, NULL, 'DUF979', 257888),
(438795, 'PF09771', NULL, 'Transmembrane protein 188', 118, NULL, 'Tmemb_18A', 257889),
(438796, 'PF19939', NULL, 'Family of unknown function (DUF6401)', 77, NULL, 'DUF6401', 257890),
(438797, 'PF05275', NULL, 'Copper resistance protein B precursor (CopB)', 208, NULL, 'CopB', 257891),
(438798, 'PF06459', NULL, 'Ryanodine Receptor TM 4-6', 281, NULL, 'RR_TM4-6', 257892),
(438799, 'PF08962', NULL, 'Rv2632c-like', 82, NULL, 'Rv2632c-like', 257893),
(438800, 'PF04651', NULL, 'Poxvirus A12 protein', 183, NULL, 'Pox_A12', 257894),
(438801, 'PF02127', NULL, 'Aminopeptidase I zinc metalloprotease (M18)', 432, NULL, 'Peptidase_M18', 257895),
(438802, 'PF08018', NULL, 'Frog antimicrobial peptide', 24, NULL, 'Antimicrobial_1', 257896),
(438803, 'PF03663', NULL, 'Glycosyl hydrolase family 76', 366, NULL, 'Glyco_hydro_76', 257897),
(438804, 'PF02788', NULL, 'Ribulose bisphosphate carboxylase large chain, N-terminal domain', 120, NULL, 'RuBisCO_large_N', 257898),
(438805, 'PF15336', NULL, 'Autism susceptibility gene 2 protein', 217, NULL, 'Auts2', 257899),
(438806, 'PF01708', NULL, 'Geminivirus putative movement protein', 92, NULL, 'Gemini_mov', 257900),
(438807, 'PF09950', NULL, 'Uncharacterized protein conserved in bacteria (DUF2184)', 251, NULL, 'DUF2184', 257901),
(438808, 'PF04011', NULL, 'LemA family', 149, NULL, 'LemA', 257902),
(438809, 'PF04000', NULL, 'Sas10/Utp3/C1D family', 86, NULL, 'Sas10_Utp3', 257903),
(438810, 'PF19317', NULL, 'Gag protein p24 C-terminal domain', 74, NULL, 'Gag_p24_C', 257904),
(438811, 'PF16801', NULL, 'Dimerisation domain of Male-specific-Lethal 1', 37, NULL, 'MSL1_dimer', 257905),
(438812, 'PF09580', NULL, 'Sporulation lipoprotein YhcN/YlaJ (Spore_YhcN_YlaJ)', 159, NULL, 'Spore_YhcN_YlaJ', 257906),
(438813, 'PF00639', NULL, 'PPIC-type PPIASE domain', 97, NULL, 'Rotamase', 257907),
(438814, 'PF08529', NULL, 'NusA N-terminal domain', 120, NULL, 'NusA_N', 257908),
(438815, 'PF05202', NULL, 'Recombinase Flp protein', 251, NULL, 'Flp_C', 257909),
(438816, 'PF13354', NULL, 'Beta-lactamase enzyme family', 215, NULL, 'Beta-lactamase2', 257910),
(438817, 'PF17096', NULL, 'Altered inheritance of mitochondria protein 3', 88, NULL, 'AIM3', 257911),
(438818, 'PF06524', NULL, 'NOA36 protein', 307, NULL, 'NOA36', 257912),
(438819, 'PF07588', NULL, 'Protein of unknown function (DUF1554)', 135, NULL, 'DUF1554', 257913),
(438820, 'PF06090', NULL, 'Inositol-pentakisphosphate 2-kinase', 373, NULL, 'Ins_P5_2-kin', 257914),
(438821, 'PF02988', NULL, 'Phospholipase A2 inhibitor', 83, NULL, 'PLA2_inh', 257915),
(438822, 'PF07067', NULL, 'Protein of unknown function (DUF1340)', 236, NULL, 'DUF1340', 257916),
(438823, 'PF14741', NULL, 'N-terminal glycosyl-hydrolase-114-associated domain', 129, NULL, 'GH114_assoc', 257917),
(438824, 'PF19816', NULL, 'Family of unknown function (DUF6299)', 114, NULL, 'DUF6299', 257918),
(438825, 'PF03909', NULL, 'BSD domain', 58, NULL, 'BSD', 257919),
(438826, 'PF16762', NULL, 'Ribbon-helix-helix domain', 77, NULL, 'RHH_6', 257920);
INSERT INTO "PUBLIC"."MODEL" VALUES
(438827, 'PF10546', NULL, 'P63C domain', 93, NULL, 'P63C', 257921),
(438828, 'PF11836', NULL, 'Phage tail tube protein, GTA-gp10', 98, NULL, 'Phage_TAC_11', 257922),
(438829, 'PF17920', NULL, 'Tetracyclin repressor-like, C-terminal domain', 107, NULL, 'TetR_C_16', 257923),
(438830, 'PF02643', NULL, 'Uncharacterized ACR, COG1430', 96, NULL, 'DUF192', 257924),
(438831, 'PF19675', NULL, 'Origin recognition complex subunit 3 insertion domain', 233, NULL, 'ORC3_ins', 257925),
(438832, 'PF15344', NULL, 'FAM217 family', 238, NULL, 'FAM217', 257926),
(438833, 'PF06084', NULL, 'Cytomegalovirus TRL10 protein', 150, NULL, 'Cytomega_TRL10', 257927),
(438834, 'PF15643', NULL, 'Papain fold toxin 2', 102, NULL, 'Tox-PL-2', 257928),
(438835, 'PF16678', NULL, 'HOIP UBA domain pair', 153, NULL, 'HOIP-UBA', 257929),
(438836, 'PF16465', NULL, 'Domain of unknown function (DUF5046)', 264, NULL, 'DUF5046', 257930),
(438837, 'PF16203', NULL, 'ERCC3/RAD25/XPB C-terminal helicase', 247, NULL, 'ERCC3_RAD25_C', 257931),
(438838, 'PF17651', NULL, 'RACo middle region', 163, NULL, 'Raco_middle', 257932),
(438839, 'PF12072', NULL, 'RNase Y N-terminal region', 201, NULL, 'RNase_Y_N', 257933),
(438840, 'PF14171', NULL, 'Toxin SpoIISA, type II toxin-antitoxin system', 243, NULL, 'SpoIISA_toxin', 257934),
(438841, 'PF11969', NULL, 'Scavenger mRNA decapping enzyme C-term binding', 114, NULL, 'DcpS_C', 257935),
(438842, 'PF13712', NULL, 'Glycosyltransferase like family', 211, NULL, 'Glyco_tranf_2_5', 257936),
(438843, 'PF18012', NULL, 'PH domain', 60, NULL, 'PH_17', 257937),
(438844, 'PF10610', NULL, 'Thin aggregative fimbriae synthesis protein', 98, NULL, 'Tafi-CsgC', 257938),
(438845, 'PF01951', NULL, 'Archease protein family (MTH1598/TM1083)', 140, NULL, 'Archease', 257939),
(438846, 'PF11183', NULL, 'Polymyxin resistance protein PmrD', 81, NULL, 'PmrD', 257940),
(438847, 'PF16239', NULL, 'Domain of unknown function (DUF4898)', 82, NULL, 'DUF4898', 257941),
(438848, 'PF16195', NULL, 'SUMO-activating enzyme subunit 2 C-terminus', 95, NULL, 'UBA2_C', 257942),
(438849, 'PF13039', NULL, 'Protein of unknown function (DUF3900)', 253, NULL, 'DUF3900', 257943),
(438850, 'PF17774', NULL, 'Putative RNA-binding domain in YlmH', 84, NULL, 'YlmH_RBD', 257944),
(438851, 'PF04682', NULL, 'Herpesvirus BTRF1 protein conserved region', 259, NULL, 'Herpes_BTRF1', 257945),
(438852, 'PF19039', NULL, 'ASK kinase PH domain', 101, NULL, 'ASK_PH', 257946),
(438853, 'PF04867', NULL, 'Protein of unknown function (DUF643)', 114, NULL, 'DUF643', 257947),
(438854, 'PF10495', NULL, 'Pericentrin-AKAP-450 domain of centrosomal targeting protein', 83, NULL, 'PACT_coil_coil', 257948),
(438855, 'PF02337', NULL, 'Retroviral GAG p10 protein', 85, NULL, 'Gag_p10', 257949),
(438856, 'PF08037', NULL, 'Attractin family', 55, NULL, 'Attractin', 257950),
(438857, 'PF09470', NULL, 'Telethonin protein', 163, NULL, 'Telethonin', 257951),
(438858, 'PF11359', NULL, 'Glycoprotein UL132', 238, NULL, 'gpUL132', 257952),
(438859, 'PF06992', NULL, 'Replication protein P', 162, NULL, 'Phage_lambda_P', 257953),
(438860, 'PF19013', NULL, 'Family of unknown function (DUF5742)', 111, NULL, 'DUF5742', 257954),
(438861, 'PF02426', NULL, 'Muconolactone delta-isomerase', 90, NULL, 'MIase', 257955),
(438862, 'PF05380', NULL, 'Pao retrotransposon peptidase', 163, NULL, 'Peptidase_A17', 257956),
(438863, 'PF04386', NULL, 'Stringent starvation protein B', 160, NULL, 'SspB', 257957),
(438864, 'PF15822', NULL, 'MAPK-interacting and spindle-stabilising protein-like', 238, NULL, 'MISS', 257958),
(438865, 'PF18847', NULL, 'Large polyvalent protein associated domain 29', 94, NULL, 'LPD29', 257959),
(438866, 'PF05251', NULL, 'Oligosaccharyltransferase subunit 5', 73, NULL, 'Ost5', 257960),
(438867, 'PF11022', NULL, 'ATP synthase subunit K', 68, NULL, 'ATP19', 257961),
(438868, 'PF19877', NULL, 'Family of unknown function (DUF6350)', 332, NULL, 'DUF6350', 257962),
(438869, 'PF12871', NULL, 'Pre-mRNA-splicing factor 38-associated hydrophilic C-term', 99, NULL, 'PRP38_assoc', 257963),
(438870, 'PF13663', NULL, 'Domain of unknown function (DUF4148)', 54, NULL, 'DUF4148', 257964);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(438871, 'PF03958', NULL, 'Bacterial type II/III secretion system short domain', 82, NULL, 'Secretin_N', 257965),
(438872, 'PF04857', NULL, 'CAF1 family ribonuclease', 323, NULL, 'CAF1', 257966),
(438873, 'PF11036', NULL, 'Virulence promoting factor', 43, NULL, 'YqgB', 257967),
(438874, 'PF07162', NULL, 'Ciliary basal body-associated, B9 protein', 168, NULL, 'B9-C2', 257968),
(438875, 'PF16636', NULL, 'Unstructured region on APC between APC_crr regions 5 and 6', 81, NULL, 'APC_u15', 257969),
(438876, 'PF14140', NULL, 'YpzI-like protein', 42, NULL, 'YpzI', 257970),
(438877, 'PF00901', NULL, 'Orbivirus outer capsid protein VP5', 507, NULL, 'Orbi_VP5', 257971),
(438878, 'PF12760', NULL, 'Transposase zinc-ribbon domain', 46, NULL, 'Zn_Tnp_IS1595', 257972),
(438879, 'PF19273', NULL, 'Exportin-5 family', 825, NULL, 'Exportin-5', 257973),
(438880, 'PF04286', NULL, 'Protein of unknown function (DUF445)', 367, NULL, 'DUF445', 257974),
(438881, 'PF02685', NULL, 'Glucokinase', 316, NULL, 'Glucokinase', 257975),
(438882, 'PF17817', NULL, 'PDZ domain', 73, NULL, 'PDZ_5', 257976),
(438883, 'PF00266', NULL, 'Aminotransferase class-V', 371, NULL, 'Aminotran_5', 257977),
(438884, 'PF19146', NULL, 'Family of unknown function (DUF5828)', 175, NULL, 'DUF5828', 257978),
(438885, 'PF07371', NULL, 'Protein of unknown function (DUF1490)', 88, NULL, 'DUF1490', 257979),
(438886, 'PF03699', NULL, 'Uncharacterised protein family (UPF0182)', 758, NULL, 'UPF0182', 257980),
(438887, 'PF15578', NULL, 'Domain of unknown function (DUF4662)', 269, NULL, 'DUF4662', 257981),
(438888, 'PF15741', NULL, 'Ligand-dependent nuclear receptor-interacting factor 1', 749, NULL, 'LRIF1', 257982),
(438889, 'PF09006', NULL, 'Lung surfactant protein D coiled-coil trimerisation', 46, NULL, 'Surfac_D-trimer', 257983),
(438890, 'PF01469', NULL, 'Pentapeptide repeats (8 copies)', 40, NULL, 'Pentapeptide_2', 257984),
(438891, 'PF05568', NULL, 'African swine fever virus J13L protein', 189, NULL, 'ASFV_J13L', 257985),
(438892, 'PF07635', NULL, 'Planctomycete cytochrome C', 59, NULL, 'PSCyt1', 257986),
(438893, 'PF15884', NULL, 'MICOS complex subunit MIC13, QIL1', 77, NULL, 'QIL1', 257987),
(438894, 'PF02886', NULL, 'LBP / BPI / CETP family, C-terminal domain', 238, NULL, 'LBP_BPI_CETP_C', 257988),
(438895, 'PF05466', NULL, 'Brain acid soluble protein 1 (BASP1 protein)', 236, NULL, 'BASP1', 257989),
(438896, 'PF13954', NULL, 'PapC N-terminal domain', 146, NULL, 'PapC_N', 257990),
(438897, 'PF00633', NULL, 'Helix-hairpin-helix motif', 30, NULL, 'HHH', 257991),
(438898, 'PF16660', NULL, 'PHD finger protein 20-like protein 1', 97, NULL, 'PHD20L1_u1', 257992),
(438899, 'PF08914', NULL, 'Rap1 Myb domain', 65, NULL, 'Myb_DNA-bind_2', 257993),
(438900, 'PF08224', NULL, 'Domain of unknown function (DUF1719)', 231, NULL, 'DUF1719', 257994),
(438901, 'PF12638', NULL, 'Staygreen protein', 148, NULL, 'Staygreen', 257995),
(438902, 'PF01381', NULL, 'Helix-turn-helix', 55, NULL, 'HTH_3', 257996),
(438903, 'PF16975', NULL, 'Ly6/PLAUR domain-containing protein 6, Lypd6', 106, NULL, 'UPAR_LY6_2', 257997),
(438904, 'PF16907', NULL, 'Proline rich region of Caskin proteins', 91, NULL, 'Caskin-Pro-rich', 257998),
(438905, 'PF15881', NULL, 'Domain of unknown function (DUF4734)', 91, NULL, 'DUF4734', 257999),
(438906, 'PF11304', NULL, 'Protein of unknown function (DUF3106)', 104, NULL, 'DUF3106', 258000),
(438907, 'PF00358', NULL, 'phosphoenolpyruvate-dependent sugar phosphotransferase system, EIIA 1', 127, NULL, 'PTS_EIIA_1', 258001),
(438908, 'PF04832', NULL, 'SOUL heme-binding protein', 173, NULL, 'SOUL', 258002),
(438909, 'PF06871', NULL, 'TraH_2', 206, NULL, 'TraH_2', 258003),
(438910, 'PF17244', NULL, 'Cell division control protein 24, OB domain 3', 225, NULL, 'CDC24_OB3', 258004),
(438911, 'PF00297', NULL, 'Ribosomal protein L3', 369, NULL, 'Ribosomal_L3', 258005),
(438912, 'PF13742', NULL, 'OB-fold nucleic acid binding domain', 95, NULL, 'tRNA_anti_2', 258006),
(438913, 'PF17445', NULL, 'Mating factor A1', 42, NULL, 'Mfa1', 258007),
(438914, 'PF06333', NULL, 'Mediator complex subunit 13 C-terminal domain', 330, NULL, 'Med13_C', 258008);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(438915, 'PF14355', NULL, 'Abortive infection C-terminus', 83, NULL, 'Abi_C', 258009),
(438916, 'PF00519', NULL, 'Papillomavirus helicase', 289, NULL, 'PPV_E1_C', 258010),
(438917, 'PF05178', NULL, 'KRI1-like family', 104, NULL, 'Kri1', 258011),
(438918, 'PF07807', NULL, 'RED-like protein C-terminal region', 112, NULL, 'RED_C', 258012),
(438919, 'PF09343', NULL, 'Conserved hypothetical protein 2217 (DUF2460)', 200, NULL, 'DUF2460', 258013),
(438920, 'PF02963', NULL, 'Restriction endonuclease EcoRI', 257, NULL, 'EcoRI', 258014),
(438921, 'PF05884', NULL, 'Interactor of ZYG-11', 295, NULL, 'ZYG-11_interact', 258015),
(438922, 'PF20305', NULL, 'prokaryotic YEATS domain', 73, NULL, 'pYEATS', 258016),
(438923, 'PF13595', NULL, 'Domain of unknown function (DUF4138)', 245, NULL, 'DUF4138', 258017),
(438924, 'PF06413', NULL, 'Neugrin', 218, NULL, 'Neugrin', 258018),
(438925, 'PF08579', NULL, 'Mitochondrial ribonuclease P subunit (RPM2)', 119, NULL, 'RPM2', 258019),
(438926, 'PF01843', NULL, 'DIL domain', 105, NULL, 'DIL', 258020),
(438927, 'PF19050', NULL, 'PhoD related phosphatase', 543, NULL, 'PhoD_2', 258021),
(438928, 'PF15396', NULL, 'Protein Family FAM60A', 207, NULL, 'FAM60A', 258022),
(438929, 'PF10842', NULL, 'Protein of unknown function (DUF2642)', 64, NULL, 'DUF2642', 258023),
(438930, 'PF20133', NULL, 'Protein HHL1-like', 139, NULL, 'HHL1-like', 258024),
(438931, 'PF02441', NULL, 'Flavoprotein', 157, NULL, 'Flavoprotein', 258025),
(438932, 'PF20102', NULL, 'Family of unknown function (DUF6492)', 291, NULL, 'DUF6492', 258026),
(438933, 'PF00486', NULL, 'Transcriptional regulatory protein, C terminal', 77, NULL, 'Trans_reg_C', 258027),
(438934, 'PF15231', NULL, 'Variable charge X/Y family', 129, NULL, 'VCX_VCY', 258028),
(438935, 'PF17875', NULL, 'RPA43 OB domain in RNA Pol I', 127, NULL, 'RPA43_OB', 258029),
(438936, 'PF10557', NULL, 'Cullin protein neddylation domain', 63, NULL, 'Cullin_Nedd8', 258030),
(438937, 'PF01736', NULL, 'Polyomavirus agnoprotein', 62, NULL, 'Polyoma_agno', 258031),
(438938, 'PF06258', NULL, 'Mitochondrial fission ELM1', 309, NULL, 'Mito_fiss_Elm1', 258032),
(438939, 'PF05776', NULL, 'Papillomavirus E5A protein', 91, NULL, 'Papilloma_E5A', 258033),
(438940, 'PF09080', NULL, 'K cyclin, C terminal', 106, NULL, 'K-cyclin_vir_C', 258034),
(438941, 'PF05256', NULL, 'Uncharacterised protein family (UPF0223)', 86, NULL, 'UPF0223', 258035),
(438942, 'PF11827', NULL, 'Protein of unknown function (DUF3347)', 93, NULL, 'DUF3347', 258036),
(438943, 'PF11473', NULL, 'RNA binding protein B2', 73, NULL, 'B2', 258037),
(438944, 'PF03022', NULL, 'Major royal jelly protein', 287, NULL, 'MRJP', 258038),
(438945, 'PF11181', NULL, 'Heat induced stress protein YflT domain', 100, NULL, 'YflT', 258039),
(438946, 'PF09791', NULL, 'Oxidoreductase-like protein, N-terminal', 46, NULL, 'Oxidored-like', 258040),
(438947, 'PF17036', NULL, 'Cellulose biosynthesis protein BcsS', 207, NULL, 'CBP_BcsS', 258041),
(438948, 'PF10109', NULL, 'Phage tail assembly chaperone proteins, E, or 41 or 14', 83, NULL, 'Phage_TAC_7', 258042),
(438949, 'PF18124', NULL, 'Kindlin-2 N-terminal domain', 89, NULL, 'Kindlin_2_N', 258043),
(438950, 'PF15644', NULL, 'Papain fold toxin 1, glutamine deamidase', 114, NULL, 'Gln_amidase', 258044),
(438951, 'PF18884', NULL, 'Bacterial TSP3 repeat', 22, NULL, 'TSP3_bac', 258045),
(438952, 'PF02053', NULL, 'Gene 66 (IR5) protein', 209, NULL, 'Gene66', 258046),
(438953, 'PF15064', NULL, 'Cation channel sperm-associated protein subunit gamma', 971, NULL, 'CATSPERG', 258047),
(438954, 'PF15532', NULL, 'Bacterial toxin 30', 103, NULL, 'Ntox30', 258048),
(438955, 'PF01364', NULL, 'Peptidase family C25', 378, NULL, 'Peptidase_C25', 258049),
(438956, 'PF10189', NULL, 'Integrator complex subunit 3 N-terminal', 409, NULL, 'Ints3_N', 258050),
(438957, 'PF17290', NULL, 'Arenavirus nucleocapsid C-terminal domain', 181, NULL, 'Arena_ncap_C', 258051),
(438958, 'PF05421', NULL, 'Protein of unknown function (DUF751)', 60, NULL, 'DUF751', 258052),
(438959, 'PF13641', NULL, 'Glycosyltransferase like family 2', 230, NULL, 'Glyco_tranf_2_3', 258053);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(438960, 'PF14287', NULL, 'Domain of unknown function (DUF4368)', 67, NULL, 'DUF4368', 258054),
(438961, 'PF03347', NULL, 'Vibrio thermostable direct hemolysin', 165, NULL, 'TDH', 258055),
(438962, 'PF08532', NULL, 'Beta-galactosidase trimerisation domain', 207, NULL, 'Glyco_hydro_42M', 258056),
(438963, 'PF01109', NULL, 'Granulocyte-macrophage colony-stimulating factor', 122, NULL, 'GM_CSF', 258057),
(438964, 'PF09422', NULL, 'WTX protein', 479, NULL, 'WTX', 258058),
(438965, 'PF16845', NULL, 'Aspartic acid proteinase inhibitor', 83, NULL, 'SQAPI', 258059),
(438966, 'PF20439', NULL, 'Sporulation stage IV protein A, C-terminal', 76, NULL, 'SpoIVA_C', 258060),
(438967, 'PF03483', NULL, 'B3/4 domain', 174, NULL, 'B3_4', 258061),
(438968, 'PF14301', NULL, 'Domain of unknown function (DUF4376)', 102, NULL, 'DUF4376', 258062),
(438969, 'PF11574', NULL, 'Resuscitation-promoting factor Rpf1, C-terminal', 88, NULL, 'Rpf1_C', 258063),
(438970, 'PF19376', NULL, 'Family of unknown function (DUF5951)', 59, NULL, 'DUF5951', 258064),
(438971, 'PF15894', NULL, 'Inhibitor of glucose uptake transporter SgrT', 53, NULL, 'SgrT', 258065),
(438972, 'PF04656', NULL, 'Pox virus E6 protein', 566, NULL, 'Pox_E6', 258066),
(438973, 'PF15335', NULL, 'Caspase activity and apoptosis inhibitor 1', 63, NULL, 'CAAP1', 258067),
(438974, 'PF17962', NULL, 'Bacterial macroglobulin domain 6', 112, NULL, 'bMG6', 258068),
(438975, 'PF06428', NULL, 'GDP/GTP exchange factor Sec2p', 92, NULL, 'Sec2p', 258069),
(438976, 'PF20460', NULL, 'Family of unknown function (DUF6713)', 117, NULL, 'DUF6713', 258070),
(438977, 'PF19569', NULL, 'START-like superfamily domain', 126, NULL, 'START_2', 258071),
(438978, 'PF03505', NULL, 'Clostridium enterotoxin', 197, NULL, 'Clenterotox', 258072),
(438979, 'PF03690', NULL, 'Uncharacterised protein family (UPF0160)', 319, NULL, 'UPF0160', 258073),
(438980, 'PF19214', NULL, 'Coronavirus spike glycoprotein S2, intravirion', 42, NULL, 'CoV_S2_C', 258074),
(438981, 'PF11806', NULL, 'Enterochelin esterase, N-terminal', 120, NULL, 'Enterochelin_N', 258075),
(438982, 'PF17323', NULL, 'Trans-membrane regulatory protein ToxS', 147, NULL, 'ToxS', 258076),
(438983, 'PF08630', NULL, 'Dfp1/Him1, central region', 127, NULL, 'Dfp1_Him1_M', 258077),
(438984, 'PF14500', NULL, 'Dos2-interacting transcription regulator of RNA-Pol-II', 261, NULL, 'MMS19_N', 258078),
(438985, 'PF18179', NULL, 'SMODS- and Ubiquitin system-associated 2TM effector domain', 279, NULL, 'SUa-2TM', 258079),
(438986, 'PF02250', NULL, '35kD major secreted virus protein', 227, NULL, 'Orthopox_35kD', 258080),
(438987, 'PF19638', NULL, 'Family of unknown function (DUF6141)', 164, NULL, 'DUF6141', 258081),
(438988, 'PF01513', NULL, 'ATP-NAD kinase N-terminal domain', 135, NULL, 'NAD_kinase', 258082),
(438989, 'PF04452', NULL, 'RNA methyltransferase domain', 166, NULL, 'Methyltrans_RNA', 258083),
(438990, 'PF15480', NULL, 'Domain of unknown function (DUF4640)', 292, NULL, 'DUF4640', 258084),
(438991, 'PF10325', NULL, 'Serpentine type 7TM GPCR chemoreceptor Srz', 266, NULL, '7TM_GPCR_Srz', 258085),
(438992, 'PF03711', NULL, 'Orn/Lys/Arg decarboxylase, C-terminal domain', 132, NULL, 'OKR_DC_1_C', 258086),
(438993, 'PF16901', NULL, 'C-terminal domain of alpha-glycerophosphate oxidase', 126, NULL, 'DAO_C', 258087),
(438994, 'PF08705', NULL, 'Gag protein p6', 37, NULL, 'Gag_p6', 258088),
(438995, 'PF01555', NULL, 'DNA methylase', 231, NULL, 'N6_N4_Mtase', 258089),
(438996, 'PF04471', NULL, 'Restriction endonuclease', 115, NULL, 'Mrr_cat', 258090),
(438997, 'PF17188', NULL, 'MucB/RseB C-terminal domain', 97, NULL, 'MucB_RseB_C', 258091),
(438998, 'PF08365', NULL, 'Insulin-like growth factor II E-peptide', 56, NULL, 'IGF2_C', 258092),
(438999, 'PF02219', NULL, 'Methylenetetrahydrofolate reductase', 287, NULL, 'MTHFR', 258093),
(439000, 'PF03435', NULL, 'Saccharopine dehydrogenase NADP binding domain', 130, NULL, 'Sacchrp_dh_NADP', 258094),
(439001, 'PF12355', NULL, 'Down syndrome cell adhesion molecule C terminal', 118, NULL, 'Dscam_C', 258095),
(439002, 'PF13130', NULL, 'Domain of unknown function (DUF3952)', 101, NULL, 'DUF3952', 258096);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(439003, 'PF09693', NULL, 'Phage uncharacterised protein (Phage_XkdX)', 40, NULL, 'Phage_XkdX', 258097),
(439004, 'PF15724', NULL, 'TMEM119 family', 252, NULL, 'TMEM119', 258098),
(439005, 'PF15745', NULL, 'AP-1 complex-associated regulatory protein', 275, NULL, 'AP1AR', 258099),
(439006, 'PF18474', NULL, 'Family of unknown function (DUF5614)', 221, NULL, 'DUF5614', 258100),
(439007, 'PF15483', NULL, 'Domain of unknown function (DUF4641)', 443, NULL, 'DUF4641', 258101),
(439008, 'PF17566', NULL, 'Family of unknown function (DUF5472)', 73, NULL, 'DUF5472', 258102),
(439009, 'PF05004', NULL, 'Interferon-related developmental regulator (IFRD)', 307, NULL, 'IFRD', 258103),
(439010, 'PF07516', NULL, 'SecA Wing and Scaffold domain', 199, NULL, 'SecA_SW', 258104),
(439011, 'PF10515', NULL, 'Beta-amyloid precursor protein C-terminus', 52, NULL, 'APP_amyloid', 258105),
(439012, 'PF01405', NULL, 'Photosystem II reaction centre T protein', 29, NULL, 'PsbT', 258106),
(439013, 'PF08154', NULL, 'NLE (NUC135) domain', 68, NULL, 'NLE', 258107),
(439014, 'PF03942', NULL, 'DTW domain', 202, NULL, 'DTW', 258108),
(439015, 'PF17167', NULL, 'Glycosyl hydrolase 36 superfamily, catalytic domain', 423, NULL, 'Glyco_hydro_36', 258109),
(439016, 'PF09552', NULL, 'BstXI restriction endonuclease', 288, NULL, 'RE_BstXI', 258110),
(439017, 'PF08985', NULL, 'DP-EP family', 120, NULL, 'DP-EP', 258111),
(439018, 'PF18988', NULL, 'Family of unknown function (DUF5721)', 149, NULL, 'DUF5721', 258112),
(439019, 'PF10303', NULL, 'Protein of unknown function (DUF2408)', 134, NULL, 'DUF2408', 258113),
(439020, 'PF15804', NULL, 'Coiled-coil domain-containing protein 168', 204, NULL, 'CCDC168_N', 258114),
(439021, 'PF00257', NULL, 'Dehydrin', 174, NULL, 'Dehydrin', 258115),
(439022, 'PF08986', NULL, 'Domain of unknown function (DUF1889)', 96, NULL, 'DUF1889', 258116),
(439023, 'PF10035', NULL, 'Uncharacterized protein conserved in bacteria (DUF2179)', 55, NULL, 'DUF2179', 258117),
(439024, 'PF19604', NULL, 'Family of unknown function (DUF6109)', 671, NULL, 'DUF6109', 258118),
(439025, 'PF09075', NULL, 'Heat-stable enterotoxin B, secretory', 48, NULL, 'STb_secrete', 258119),
(439026, 'PF16705', NULL, 'NUDIX, or N-terminal NPxY motif-rich,  region of KRIT', 177, NULL, 'NUDIX_5', 258120),
(439027, 'PF00743', NULL, 'Flavin-binding monooxygenase-like', 532, NULL, 'FMO-like', 258121),
(439028, 'PF18243', NULL, 'Metal-independent restriction enzyme BfiI DNA binding domain', 165, NULL, 'BfiI_DBD', 258122),
(439029, 'PF04940', NULL, 'Sensors of blue-light using FAD', 92, NULL, 'BLUF', 258123),
(439030, 'PF18869', NULL, 'RnaseLS-like HEPN', 124, NULL, 'HEPN_RnaseLS', 258124),
(439031, 'PF01291', NULL, 'LIF / OSM family', 162, NULL, 'LIF_OSM', 258125),
(439032, 'PF05784', NULL, 'Betaherpesvirus UL82/83 protein N terminus', 345, NULL, 'Herpes_UL82_83', 258126),
(439033, 'PF03276', NULL, 'Spumavirus gag protein', 614, NULL, 'Gag_spuma', 258127),
(439034, 'PF14406', NULL, 'Ribosomally synthesized peptide in Bacteroidetes', 52, NULL, 'Bacteroid_pep', 258128),
(439035, 'PF15223', NULL, 'Elongin BC and Polycomb repressive complex 2-associated protein', 426, NULL, 'EPOP', 258129),
(439036, 'PF17447', NULL, 'Uncharacterized YkpC-like', 42, NULL, 'YkpC', 258130),
(439037, 'PF02931', NULL, 'Neurotransmitter-gated ion-channel ligand binding domain', 217, NULL, 'Neur_chan_LBD', 258131),
(439038, 'PF08103', NULL, 'Uperin family', 17, NULL, 'Antimicrobial_8', 258132),
(439039, 'PF08662', NULL, 'Eukaryotic translation initiation factor eIF2A', 194, NULL, 'eIF2A', 258133),
(439040, 'PF14410', NULL, 'HNH/ENDO VII superfamily nuclease with conserved GHE residues', 70, NULL, 'GH-E', 258134),
(439041, 'PF16122', NULL, '40S ribosomal protein SA C-terminus', 95, NULL, '40S_SA_C', 258135),
(439042, 'PF16188', NULL, 'C-terminal region of peptidase_M24', 62, NULL, 'Peptidase_M24_C', 258136),
(439043, 'PF08095', NULL, 'Hefutoxin family', 22, NULL, 'Toxin_25', 258137),
(439044, 'PF03556', NULL, 'Cullin binding', 120, NULL, 'Cullin_binding', 258138),
(439045, 'PF04574', NULL, 'Protein of unknown function (DUF592)', 153, NULL, 'DUF592', 258139);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(439046, 'PF06667', NULL, 'Phage shock protein B', 73, NULL, 'PspB', 258140),
(439047, 'PF05927', NULL, 'Penaeidin', 73, NULL, 'Penaeidin', 258141),
(439048, 'PF11870', NULL, 'Lactate utilisation protein B, C-terminal', 88, NULL, 'LutB_C', 258142),
(439049, 'PF11608', NULL, 'MARF1, RNA recognition motif 1', 89, NULL, 'MARF1_RRM1', 258143),
(439050, 'PF08046', NULL, 'IlvGEDA operon leader peptide', 32, NULL, 'IlvGEDA_leader', 258144),
(439051, 'PF12341', NULL, 'Minichromosome loss protein, Mcl1, middle region', 296, NULL, 'Mcl1_mid', 258145),
(439052, 'PF19217', NULL, 'Coronavirus replicase NSP4, N-terminal', 352, NULL, 'CoV_NSP4_N', 258146),
(439053, 'PF12172', NULL, 'Rubredoxin-like zinc ribbon domain (DUF35_N)', 37, NULL, 'DUF35_N', 258147),
(439054, 'PF16956', NULL, 'Putative general bacterial porin', 267, NULL, 'Porin_7', 258148),
(439055, 'PF11409', NULL, 'Smad anchor for receptor activation (SARA)', 37, NULL, 'SARA', 258149),
(439056, 'PF11923', NULL, 'NFACT protein C-terminal domain', 108, NULL, 'NFACT-C', 258150),
(439057, 'PF01944', NULL, 'Stage II sporulation protein M', 156, NULL, 'SpoIIM', 258151),
(439058, 'PF08492', NULL, 'SRP72 RNA-binding domain', 58, NULL, 'SRP72', 258152),
(439059, 'PF18617', NULL, 'Nucleoporin Nup214 phenylalanine-glycine (FG) domain', 63, NULL, 'Nup214_FG', 258153),
(439060, 'PF02817', NULL, 'e3 binding domain', 36, NULL, 'E3_binding', 258154),
(439061, 'PF13482', NULL, 'RNase_H superfamily', 166, NULL, 'RNase_H_2', 258155),
(439062, 'PF04538', NULL, 'Brain expressed X-linked like family', 118, NULL, 'BEX', 258156),
(439063, 'PF12631', NULL, 'MnmE helical domain', 208, NULL, 'MnmE_helical', 258157),
(439064, 'PF20616', NULL, 'Capsule biosynthesis GfcC, N-terminal', 129, NULL, 'Caps_syn_GfcC_N', 258158),
(439065, 'PF12918', NULL, 'TcdB toxin N-terminal helical domain', 66, NULL, 'TcdB_N', 258159),
(439066, 'PF19212', NULL, 'Coronavirus replicase NSP2, C-terminal', 157, NULL, 'CoV_NSP2_C', 258160),
(439067, 'PF16373', NULL, 'Domain of unknown function', 114, NULL, 'DUF4985', 258161),
(439068, 'PF13609', NULL, 'Gram-negative porin', 312, NULL, 'Porin_4', 258162),
(439069, 'PF02178', NULL, 'AT hook motif', 13, NULL, 'AT_hook', 258163),
(439070, 'PF18023', NULL, 'BDBT FKBP like N-terminal', 113, NULL, 'FKBP_N_2', 258164),
(439071, 'PF13675', NULL, 'Type IV pili methyl-accepting chemotaxis transducer N-term', 114, NULL, 'PilJ', 258165),
(439072, 'PF15347', NULL, 'Phosphoprotein associated with glycosphingolipid-enriched', 428, NULL, 'PAG', 258166),
(439073, 'PF11253', NULL, 'Protein of unknown function (DUF3052)', 125, NULL, 'DUF3052', 258167),
(439074, 'PF17839', NULL, 'C-terminal domain of cyclic nucleotide phosphodiesterase', 108, NULL, 'CNP_C_terminal', 258168),
(439075, 'PF02477', NULL, 'Nucleocapsid N protein', 442, NULL, 'Nairo_nucleo', 258169),
(439076, 'PF18067', NULL, 'Lipase C-terminal domain', 96, NULL, 'Lipase_C', 258170),
(439077, 'PF18771', NULL, 'APOBEC3', 135, NULL, 'APOBEC3', 258171),
(439078, 'PF17563', NULL, 'Cupiennin', 27, NULL, 'Cu', 258172),
(439079, 'PF20592', NULL, 'Putative adhesin domain (group 10)', 168, NULL, 'pAdhesive_10', 258173),
(439080, 'PF05239', NULL, 'PRC-barrel domain', 79, NULL, 'PRC', 258174),
(439081, 'PF04409', NULL, 'Protein of unknown function (DUF530)', 521, NULL, 'DUF530', 258175),
(439082, 'PF11049', NULL, 'Glycoprotein K1 of Kaposi''s sarcoma-associated herpes virus', 71, NULL, 'KSHV_K1', 258176),
(439083, 'PF11708', NULL, 'Pre-mRNA splicing Prp18-interacting factor', 266, NULL, 'Slu7', 258177),
(439084, 'PF15964', NULL, 'Centrosomal colon cancer autoantigen protein family', 703, NULL, 'CCCAP', 258178),
(439085, 'PF10678', NULL, 'Protein of unknown function (DUF2492)', 77, NULL, 'DUF2492', 258179),
(439086, 'PF16842', NULL, 'Occluded RNA-recognition motif', 79, NULL, 'RRM_occluded', 258180),
(439087, 'PF07813', NULL, 'LTXXQ motif family protein', 98, NULL, 'LTXXQ', 258181),
(439088, 'PF18920', NULL, 'Domain of unknown function (DUF5671)', 131, NULL, 'DUF5671', 258182),
(439089, 'PF01799', NULL, '[2Fe-2S] binding domain', 75, NULL, 'Fer2_2', 258183);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(439090, 'PF07104', NULL, 'Protein of unknown function (DUF1366)', 117, NULL, 'DUF1366', 258184),
(439091, 'PF02172', NULL, 'KIX domain', 81, NULL, 'KIX', 258185),
(439092, 'PF06688', NULL, 'Protein of unknown function (DUF1187)', 61, NULL, 'DUF1187', 258186),
(439093, 'PF07143', NULL, 'CrtC N-terminal lipocalin domain', 164, NULL, 'CrtC', 258187),
(439094, 'PF13660', NULL, 'Domain of unknown function (DUF4147)', 235, NULL, 'DUF4147', 258188),
(439095, 'PF07047', NULL, 'Optic atrophy 3 protein (OPA3)', 123, NULL, 'OPA3', 258189),
(439096, 'PF17876', NULL, 'Cold shock domain', 74, NULL, 'CSD2', 258190),
(439097, 'PF07792', NULL, 'Docking domain of Afi1 for Arf3 in vesicle trafficking', 133, NULL, 'Afi1', 258191),
(439098, 'PF15355', NULL, 'Stretch-responsive small skeletal muscle X protein, Chisel', 86, NULL, 'Chisel', 258192),
(439099, 'PF15602', NULL, 'Immunity protein 71', 158, NULL, 'Imm71', 258193),
(439100, 'PF09377', NULL, 'SBDS protein, domain II', 82, NULL, 'SBDS_domain_II', 258194),
(439101, 'PF11863', NULL, 'Protein of unknown function (DUF3383)', 478, NULL, 'DUF3383', 258195),
(439102, 'PF07396', NULL, 'Phosphate-selective porin O and P', 370, NULL, 'Porin_O_P', 258196),
(439103, 'PF05428', NULL, 'Corticotropin-releasing factor binding protein (CRF-BP)', 307, NULL, 'CRF-BP', 258197),
(439104, 'PF15192', NULL, 'TMEM213 family', 79, NULL, 'TMEM213', 258198),
(439105, 'PF03381', NULL, 'LEM3 (ligand-effect modulator 3) family / CDC50 family', 287, NULL, 'CDC50', 258199),
(439106, 'PF04390', NULL, 'Lipopolysaccharide-assembly', 108, NULL, 'LptE', 258200),
(439107, 'PF11191', NULL, 'Protein of unknown function (DUF2782)', 89, NULL, 'DUF2782', 258201),
(439108, 'PF10636', NULL, 'Hemin uptake protein hemP', 37, NULL, 'hemP', 258202),
(439109, 'PF00537', NULL, 'Scorpion toxin-like domain', 55, NULL, 'Toxin_3', 258203),
(439110, 'PF07174', NULL, 'Fibronectin-attachment protein (FAP)', 301, NULL, 'FAP', 258204),
(439111, 'PF13684', NULL, 'Dihydroxyacetone kinase family', 313, NULL, 'Dak1_2', 258205),
(439112, 'PF10415', NULL, 'Fumarase C C-terminus', 54, NULL, 'FumaraseC_C', 258206),
(439113, 'PF06554', NULL, 'Olfactory marker protein', 150, NULL, 'Olfactory_mark', 258207),
(439114, 'PF12207', NULL, 'Domain of unknown function (DUF3600)', 160, NULL, 'DUF3600', 258208),
(439115, 'PF00876', NULL, 'Innexin', 339, NULL, 'Innexin', 258209),
(439116, 'PF01573', NULL, 'Bromovirus movement protein', 276, NULL, 'Bromo_MP', 258210),
(439117, 'PF20173', NULL, 'Family of unknown function (DUF6539)', 54, NULL, 'DUF6539', 258211),
(439118, 'PF20578', NULL, 'Atrophied bacterial Ig domain', 89, NULL, 'aBig_2', 258212),
(439119, 'PF02598', NULL, 'Putative RNA methyltransferase', 308, NULL, 'Methyltrn_RNA_3', 258213),
(439120, 'PF02947', NULL, 'flt3 ligand', 131, NULL, 'Flt3_lig', 258214),
(439121, 'PF09904', NULL, 'Winged helix-turn helix', 89, NULL, 'HTH_43', 258215),
(439122, 'PF08799', NULL, 'pre-mRNA processing factor 4 (PRP4) like', 29, NULL, 'PRP4', 258216),
(439123, 'PF12683', NULL, 'Protein of unknown function (DUF3798)', 271, NULL, 'DUF3798', 258217),
(439124, 'PF11578', NULL, 'Protein of unknown function (DUF3237)', 149, NULL, 'DUF3237', 258218),
(439125, 'PF00550', NULL, 'Phosphopantetheine attachment site', 67, NULL, 'PP-binding', 258219),
(439126, 'PF06929', NULL, 'Rotavirus VP3 protein', 692, NULL, 'Rotavirus_VP3', 258220),
(439127, 'PF04371', NULL, 'Porphyromonas-type peptidyl-arginine deiminase', 319, NULL, 'PAD_porph', 258221),
(439128, 'PF00887', NULL, 'Acyl CoA binding protein', 82, NULL, 'ACBP', 258222),
(439129, 'PF12076', NULL, 'WAX2 C-terminal domain', 164, NULL, 'Wax2_C', 258223),
(439130, 'PF06666', NULL, 'Protein of unknown function (DUF1173)', 386, NULL, 'DUF1173', 258224),
(439131, 'PF01509', NULL, 'TruB family pseudouridylate synthase (N terminal domain)', 149, NULL, 'TruB_N', 258225),
(439132, 'PF10173', NULL, 'Mitochondrial K+-H+ exchange-related', 190, NULL, 'Mit_KHE1', 258226),
(439133, 'PF07134', NULL, 'Autographa californica nuclear polyhedrosis virus (AcMNPV), Orf18', 328, NULL, 'AcMNPV_Orf18', 258227);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(439134, 'PF11498', NULL, 'Transcriptional activator LAG-3', 468, NULL, 'Activator_LAG-3', 258228),
(439135, 'PF05410', NULL, 'Porcine arterivirus-type cysteine proteinase alpha', 105, NULL, 'Peptidase_C31', 258229),
(439136, 'PF10193', NULL, 'Telomere length regulation protein', 109, NULL, 'Telomere_reg-2', 258230),
(439137, 'PF08808', NULL, 'RES domain', 162, NULL, 'RES', 258231),
(439138, 'PF06794', NULL, 'Uncharacterised protein family (UPF0270)', 69, NULL, 'UPF0270', 258232),
(439139, 'PF05164', NULL, 'Cell division protein ZapA', 88, NULL, 'ZapA', 258233),
(439140, 'PF08391', NULL, 'Ly49-like protein, N-terminal region', 119, NULL, 'Ly49', 258234),
(439141, 'PF16063', NULL, 'Domain of unknown function (DUF4805)', 265, NULL, 'DUF4805', 258235),
(439142, 'PF19058', NULL, 'Family of unknown function (DUF5754)', 49, NULL, 'DUF5754', 258236),
(439143, 'PF08987', NULL, 'Protein of unknown function (DUF1892)', 109, NULL, 'DUF1892', 258237),
(439144, 'PF19608', NULL, 'Family of unknown function (DUF6113)', 132, NULL, 'DUF6113', 258238),
(439145, 'PF04310', NULL, 'MukB N-terminal', 226, NULL, 'MukB', 258239),
(439146, 'PF18668', NULL, 'Tail spike TSP1/Gp66 receptor binding N-terminal domain', 70, NULL, 'Tail_spike_N', 258240),
(439147, 'PF01407', NULL, 'Geminivirus AL3 protein', 119, NULL, 'Gemini_AL3', 258241),
(439148, 'PF00448', NULL, 'SRP54-type protein, GTPase domain', 196, NULL, 'SRP54', 258242),
(439149, 'PF00541', NULL, 'Adenoviral fibre protein (knob domain)', 193, NULL, 'Adeno_knob', 258243),
(439150, 'PF09719', NULL, 'Putative redox-active protein (C_GCAxxG_C_C)', 119, NULL, 'C_GCAxxG_C_C', 258244),
(439151, 'PF15727', NULL, 'Domain of unknown function (DUF4678)', 380, NULL, 'DUF4678', 258245),
(439152, 'PF05724', NULL, 'Thiopurine S-methyltransferase (TPMT)', 218, NULL, 'TPMT', 258246),
(439153, 'PF17993', NULL, 'Haemagglutinin 70 C-terminal domain', 135, NULL, 'HA70_C', 258247),
(439154, 'PF00502', NULL, 'Phycobilisome protein', 155, NULL, 'Phycobilisome', 258248),
(439155, 'PF16610', NULL, 'Unstructured region between two PDZ domains on Dlg5', 81, NULL, 'dbPDZ_assoc', 258249),
(439156, 'PF20564', NULL, 'Family of unknown function (DUF6774)', 28, NULL, 'DUF6774', 258250),
(439157, 'PF01548', NULL, 'Transposase', 155, NULL, 'DEDD_Tnp_IS110', 258251),
(439158, 'PF03152', NULL, 'Ubiquitin fusion degradation protein UFD1', 173, NULL, 'UFD1', 258252),
(439159, 'PF05106', NULL, 'Phage holin family (Lysis protein S)', 99, NULL, 'Phage_holin_3_1', 258253),
(439160, 'PF03283', NULL, 'Pectinacetylesterase', 356, NULL, 'PAE', 258254),
(439161, 'PF06267', NULL, 'Family of unknown function (DUF1028)', 193, NULL, 'DUF1028', 258255),
(439162, 'PF10394', NULL, 'Histone acetyl transferase HAT1 N-terminus', 160, NULL, 'Hat1_N', 258256),
(439163, 'PF19927', NULL, 'Family of unknown function (DUF6390)', 244, NULL, 'DUF6390', 258257),
(439164, 'PF10106', NULL, 'Uncharacterized protein conserved in bacteria (DUF2345)', 151, NULL, 'DUF2345', 258258),
(439165, 'PF20098', NULL, 'Family of unknown function (DUF6488)', 111, NULL, 'DUF6488', 258259),
(439166, 'PF15633', NULL, 'HYD1 signature containing ADP-ribosyltransferase', 98, NULL, 'Tox-ART-HYD1', 258260),
(439167, 'PF09162', NULL, 'Tap, RNA-binding', 80, NULL, 'Tap-RNA_bind', 258261),
(439168, 'PF09553', NULL, 'Eco47II restriction endonuclease', 202, NULL, 'RE_Eco47II', 258262),
(439169, 'PF17938', NULL, 'Tetracyclin repressor-like, C-terminal domain', 119, NULL, 'TetR_C_29', 258263),
(439170, 'PF15861', NULL, 'Partial cleavage stimulation factor domain', 62, NULL, 'partial_CstF', 258264),
(439171, 'PF01344', NULL, 'Kelch motif', 46, NULL, 'Kelch_1', 258265),
(439172, 'PF10533', NULL, 'Plant zinc cluster domain', 48, NULL, 'Plant_zn_clust', 258266),
(439173, 'PF07761', NULL, 'Protein of unknown function (DUF1617)', 143, NULL, 'DUF1617', 258267),
(439174, 'PF11771', NULL, 'Protein of unknown function (DUF3314)', 162, NULL, 'DUF3314', 258268),
(439175, 'PF13868', NULL, 'Trichohyalin-plectin-homology domain', 352, NULL, 'TPH', 258269),
(439176, 'PF08299', NULL, 'Bacterial dnaA protein helix-turn-helix', 69, NULL, 'Bac_DnaA_C', 258270);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(439177, 'PF07021', NULL, 'Methionine biosynthesis protein MetW', 193, NULL, 'MetW', 258271),
(439178, 'PF06388', NULL, 'Protein of unknown function (DUF1075)', 124, NULL, 'DUF1075', 258272),
(439179, 'PF16700', NULL, 'Synphilin-1 alpha-Synuclein-binding domain', 46, NULL, 'SNCAIP_SNCA_bd', 258273),
(439180, 'PF00558', NULL, 'Vpu protein', 81, NULL, 'Vpu', 258274),
(439181, 'PF15274', NULL, 'Muscular LMNA-interacting protein', 269, NULL, 'MLIP', 258275),
(439182, 'PF11777', NULL, 'Protein of unknown function (DUF3316)', 145, NULL, 'DUF3316', 258276),
(439183, 'PF13888', NULL, 'Myelin gene regulatory factor C-terminal domain 2', 139, NULL, 'MRF_C2', 258277),
(439184, 'PF03878', NULL, 'YIF1', 244, NULL, 'YIF1', 258278),
(439185, 'PF08718', NULL, 'Glycolipid transfer protein (GLTP)', 147, NULL, 'GLTP', 258279),
(439186, 'PF12177', NULL, 'Prohormone convertase enzyme', 39, NULL, 'Proho_convert', 258280),
(439187, 'PF15155', NULL, 'MORF4 family-associated protein1', 119, NULL, 'MRFAP1', 258281),
(439188, 'PF03801', NULL, 'HEC/Ndc80p family', 154, NULL, 'Ndc80_HEC', 258282),
(439189, 'PF16115', NULL, 'Domain of unknown function (DUF4831)', 319, NULL, 'DUF4831', 258283),
(439190, 'PF16112', NULL, 'Domain of unknown function (DUF4830)', 84, NULL, 'DUF4830', 258284),
(439191, 'PF11946', NULL, 'Domain of unknown function (DUF3463)', 134, NULL, 'DUF3463', 258285),
(439192, 'PF13830', NULL, 'Domain of unknown function (DUF4192)', 322, NULL, 'DUF4192', 258286),
(439193, 'PF19290', NULL, 'PmbA/TldA metallopeptidase central domain', 113, NULL, 'PmbA_TldD_M', 258287),
(439194, 'PF02291', NULL, 'Transcription initiation factor IID, 31kD subunit', 123, NULL, 'TFIID-31kDa', 258288),
(439195, 'PF09835', NULL, 'Uncharacterized protein conserved in bacteria (DUF2062)', 141, NULL, 'DUF2062', 258289),
(439196, 'PF01884', NULL, 'PcrB family', 226, NULL, 'PcrB', 258290),
(439197, 'PF11955', NULL, 'Plant organelle RNA recognition domain', 326, NULL, 'PORR', 258291),
(439198, 'PF15676', NULL, 'Six6 opposite strand transcript 1 family', 558, NULL, 'S6OS1', 258292),
(439199, 'PF20358', NULL, 'Family of unknown function (DUF6653)', 170, NULL, 'DUF6653', 258293),
(439200, 'PF18828', NULL, 'Large polyvalent-protein-associated domain 15', 99, NULL, 'LPD15', 258294),
(439201, 'PF16847', NULL, 'Avirulence AvrPtoB, BAK1-binding domain', 91, NULL, 'AvrPtoB_bdg', 258295),
(439202, 'PF17765', NULL, 'MmyB-like transcription regulator ligand binding domain', 168, NULL, 'MLTR_LBD', 258296),
(439203, 'PF11538', NULL, 'Snurportin1', 40, NULL, 'Snurportin1', 258297),
(439204, 'PF04034', NULL, 'Ribosome biogenesis protein, C-terminal', 127, NULL, 'Ribo_biogen_C', 258298),
(439205, 'PF09816', NULL, 'RNA polymerase II transcription elongation factor', 105, NULL, 'EAF', 258299),
(439206, 'PF09696', NULL, 'Ctf8', 144, NULL, 'Ctf8', 258300),
(439207, 'PF00761', NULL, 'Polyomavirus coat protein', 322, NULL, 'Polyoma_coat2', 258301),
(439208, 'PF13384', NULL, 'Homeodomain-like domain', 50, NULL, 'HTH_23', 258302),
(439209, 'PF06977', NULL, 'SdiA-regulated', 249, NULL, 'SdiA-regulated', 258303),
(439210, 'PF14840', NULL, 'Processivity clamp loader gamma complex DNA pol III C-term', 125, NULL, 'DNA_pol3_delt_C', 258304),
(439211, 'PF12810', NULL, 'Glycine rich protein', 241, NULL, 'Gly_rich', 258305),
(439212, 'PF10475', NULL, 'Vacuolar-sorting protein 54, of GARP complex', 291, NULL, 'Vps54_N', 258306),
(439213, 'PF15083', NULL, 'Colipase-like', 89, NULL, 'Colipase-like', 258307),
(439214, 'PF19755', NULL, 'Domain of unknown function (DUF6242)', 208, NULL, 'DUF6242', 258308),
(439215, 'PF00301', NULL, 'Rubredoxin', 47, NULL, 'Rubredoxin', 258309),
(439216, 'PF12381', NULL, 'Tungro spherical virus-type peptidase', 231, NULL, 'Peptidase_C3G', 258310),
(439217, 'PF00170', NULL, 'bZIP transcription factor', 64, NULL, 'bZIP_1', 258311),
(439218, 'PF11736', NULL, 'Protein of unknown function (DUF3299)', 142, NULL, 'DUF3299', 258312),
(439219, 'PF18015', NULL, 'Acetyltransferase (GNAT) domain', 114, NULL, 'Acetyltransf_19', 258313),
(439220, 'PF17552', NULL, 'Family of unknown function (DUF5464)', 51, NULL, 'DUF5464', 258314);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(439221, 'PF03749', NULL, 'Sugar fermentation stimulation protein RE domain', 138, NULL, 'SfsA', 258315),
(439222, 'PF11540', NULL, 'Cytoplasmic dynein 1 intermediate chain 2', 31, NULL, 'Dynein_IC2', 258316),
(439223, 'PF06531', NULL, 'Protein of unknown function (DUF1108)', 84, NULL, 'DUF1108', 258317),
(439224, 'PF13883', NULL, 'Pyridoxamine 5''-phosphate oxidase', 170, NULL, 'Pyrid_oxidase_2', 258318),
(439225, 'PF16002', NULL, 'Headcase protein', 198, NULL, 'Headcase', 258319),
(439226, 'PF19617', NULL, 'Family of unknown function (DUF6122)', 102, NULL, 'DUF6122', 258320),
(439227, 'PF04090', NULL, 'RNA polymerase I specific initiation factor', 199, NULL, 'RNA_pol_I_TF', 258321),
(439228, 'PF00074', NULL, 'Pancreatic ribonuclease', 121, NULL, 'RnaseA', 258322),
(439229, 'PF03989', NULL, 'DNA gyrase C-terminal domain, beta-propeller', 48, NULL, 'DNA_gyraseA_C', 258323),
(439230, 'PF01269', NULL, 'Fibrillarin', 226, NULL, 'Fibrillarin', 258324),
(439231, 'PF07856', NULL, 'Mediator of CRAC channel activity', 177, NULL, 'Orai-1', 258325),
(439232, 'PF03872', NULL, 'Anti sigma-E protein RseA, N-terminal domain', 87, NULL, 'RseA_N', 258326),
(439233, 'PF07246', NULL, 'Phlebovirus nonstructural protein NS-M', 264, NULL, 'Phlebovirus_NSM', 258327),
(439234, 'PF05119', NULL, 'Phage terminase, small subunit', 98, NULL, 'Terminase_4', 258328),
(439235, 'PF05638', NULL, 'Type VI secretion system effector, Hcp', 129, NULL, 'T6SS_HCP', 258329),
(439236, 'PF03292', NULL, 'Poxvirus P4B major core protein', 657, NULL, 'Pox_P4B', 258330),
(439237, 'PF10408', NULL, 'Ubiquitin elongating factor core', 627, NULL, 'Ufd2P_core', 258331),
(439238, 'PF11398', NULL, 'Protein of unknown function (DUF2813)', 372, NULL, 'DUF2813', 258332),
(439239, 'PF04320', NULL, 'YggL 50S ribosome-binding protein', 102, NULL, 'YggL_50S_bp', 258333),
(439240, 'PF16026', NULL, 'Mitochondria-eating protein', 200, NULL, 'MIEAP', 258334),
(439241, 'PF07411', NULL, 'Domain of unknown function (DUF1508)', 48, NULL, 'DUF1508', 258335),
(439242, 'PF11005', NULL, 'Protein of unknown function (DUF2844)', 133, NULL, 'DUF2844', 258336),
(439243, 'PF04549', NULL, 'CD47 transmembrane region', 147, NULL, 'CD47', 258337),
(439244, 'PF15769', NULL, 'Domain of unknown function (DUF4698)', 498, NULL, 'DUF4698', 258338),
(439245, 'PF18891', NULL, 'FANCL UBC-like domain 3', 97, NULL, 'FANCL_d3', 258339),
(439246, 'PF19960', NULL, 'Effector-associated domain 7', 62, NULL, 'EAD7', 258340),
(439247, 'PF08628', NULL, 'Sorting nexin C terminal', 112, NULL, 'Nexin_C', 258341),
(439248, 'PF15487', NULL, 'FAM220 family', 275, NULL, 'FAM220', 258342),
(439249, 'PF04450', NULL, 'Peptidase of plants and bacteria', 206, NULL, 'BSP', 258343),
(439250, 'PF15877', NULL, 'Transmembrane protein family 232', 452, NULL, 'TMEM232', 258344),
(439251, 'PF06634', NULL, 'Protein of unknown function (DUF1156)', 72, NULL, 'DUF1156', 258345),
(439252, 'PF19457', NULL, 'Family of unknown function (DUF5994)', 112, NULL, 'DUF5994', 258346),
(439253, 'PF02847', NULL, 'MA3 domain', 113, NULL, 'MA3', 258347),
(439254, 'PF17964', NULL, 'Bacterial Ig domain', 182, NULL, 'Big_10', 258348),
(439255, 'PF04522', NULL, 'Broad bean mottle virus, Gp1, N-terminal', 234, NULL, 'BBMV_Gp1_N', 258349),
(439256, 'PF01868', NULL, 'Ribonuclease P/MRP, subunit p29', 91, NULL, 'RNase_P-MRP_p29', 258350),
(439257, 'PF16613', NULL, 'Unstructured region of RGS12', 118, NULL, 'RGS12_us1', 258351),
(439258, 'PF04827', NULL, 'Plant transposon protein', 205, NULL, 'Plant_tran', 258352),
(439259, 'PF06957', NULL, 'Coatomer (COPI) alpha subunit C-terminus', 401, NULL, 'COPI_C', 258353),
(439260, 'PF15139', NULL, 'Domain of unknown function (DUF4572)', 195, NULL, 'DUF4572', 258354),
(439261, 'PF08626', NULL, 'Transport protein Trs120 or TRAPPC9, TRAPP II complex subunit', 1231, NULL, 'TRAPPC9-Trs120', 258355),
(439262, 'PF08906', NULL, 'Domain of unknown function (DUF1851)', 75, NULL, 'DUF1851', 258356),
(439263, 'PF09548', NULL, 'Stage III sporulation protein AB (spore_III_AB)', 170, NULL, 'Spore_III_AB', 258357);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(439264, 'PF15963', NULL, 'Myb DNA-binding like', 88, NULL, 'Myb_DNA-bind_7', 258358),
(439265, 'PF17542', NULL, 'Uncharacterized RP853', 317, NULL, 'RP853', 258359),
(439266, 'PF16694', NULL, 'Cytochrome P460', 125, NULL, 'Cytochrome_P460', 258360),
(439267, 'PF00111', NULL, '2Fe-2S iron-sulfur cluster binding domain', 78, NULL, 'Fer2', 258361),
(439268, 'PF14461', NULL, 'Prokaryotic E2 family B', 135, NULL, 'Prok-E2_B', 258362),
(439269, 'PF06947', NULL, 'Protein of unknown function (DUF1290)', 86, NULL, 'DUF1290', 258363),
(439270, 'PF17785', NULL, 'PUA-like domain', 64, NULL, 'PUA_3', 258364),
(439271, 'PF05675', NULL, 'Protein of unknown function (DUF817)', 237, NULL, 'DUF817', 258365),
(439272, 'PF14165', NULL, 'YtzH-like protein', 86, NULL, 'YtzH', 258366),
(439273, 'PF19793', NULL, 'Family of unknown function (DUF6277)', 117, NULL, 'DUF6277', 258367),
(439274, 'PF20591', NULL, 'Domain of unknown function (DUF6792)', 220, NULL, 'DUF6792', 258368),
(439275, 'PF12269', NULL, 'CpG binding protein C-terminal domain', 234, NULL, 'CpG_bind_C', 258369),
(439276, 'PF04162', NULL, 'Gyrovirus capsid protein (VP1)', 449, NULL, 'Gyro_capsid', 258370),
(439277, 'PF13016', NULL, 'Cys-rich Gliadin N-terminal', 77, NULL, 'Gliadin', 258371),
(439278, 'PF14152', NULL, 'YfhE-like protein', 36, NULL, 'YfhE', 258372),
(439279, 'PF13939', NULL, 'Toxin TisB, type I toxin-antitoxin system', 28, NULL, 'TisB_toxin', 258373),
(439280, 'PF17326', NULL, 'Family of unknown function (DUF5365)', 116, NULL, 'DUF5365', 258374),
(439281, 'PF19593', NULL, 'Family of unknown function (DUF6098)', 141, NULL, 'DUF6098', 258375),
(439282, 'PF05509', NULL, 'TraY domain', 49, NULL, 'TraY', 258376),
(439283, 'PF16870', NULL, '2-oxoglutarate dehydrogenase C-terminal', 152, NULL, 'OxoGdeHyase_C', 258377),
(439284, 'PF18076', NULL, 'Formylglycinamide ribonucleotide amidotransferase N-terminal', 115, NULL, 'FGAR-AT_N', 258378),
(439285, 'PF19049', NULL, 'SidE DUB domain', 173, NULL, 'SidE_DUB', 258379),
(439286, 'PF04377', NULL, 'Arginine-tRNA-protein transferase, C terminus', 134, NULL, 'ATE_C', 258380),
(439287, 'PF20490', NULL, 'Secretoglobin 3A', 68, NULL, 'SCGB3A', 258381),
(439288, 'PF08657', NULL, 'DASH complex subunit Spc34', 255, NULL, 'DASH_Spc34', 258382),
(439289, 'PF03783', NULL, 'Curli production assembly/transport component CsgG', 211, NULL, 'CsgG', 258383),
(439290, 'PF18010', NULL, 'Cry35Ab1 HTH C-terminal domain', 29, NULL, 'HTH_49', 258384),
(439291, 'PF14773', NULL, 'Helicase-associated putative binding domain, C-terminal', 62, NULL, 'VIGSSK', 258385),
(439292, 'PF05459', NULL, 'Herpesvirus transcriptional regulator family', 221, NULL, 'Herpes_UL69', 258386),
(439293, 'PF19521', NULL, 'Anaphase-promoting complex subunit 1 N-terminal', 136, NULL, 'Apc1_N', 258387),
(439294, 'PF00361', NULL, 'Proton-conducting membrane transporter', 293, NULL, 'Proton_antipo_M', 258388),
(439295, 'PF05112', NULL, 'Baculovirus P47 protein', 306, NULL, 'Baculo_p47', 258389),
(439296, 'PF11356', NULL, 'Type II secretion system protein C', 145, NULL, 'T2SSC', 258390),
(439297, 'PF06528', NULL, 'Phage P2 GpE', 37, NULL, 'Phage_P2_GpE', 258391),
(439298, 'PF07345', NULL, 'ATPase inhibitor subunit zeta', 102, NULL, 'DUF1476', 258392),
(439299, 'PF08081', NULL, 'RBM1CTR (NUC064) family', 45, NULL, 'RBM1CTR', 258393),
(439300, 'PF09783', NULL, 'Vacuolar import and degradation protein', 162, NULL, 'Vac_ImportDeg', 258394),
(439301, 'PF02819', NULL, 'Spider toxin', 44, NULL, 'Toxin_9', 258395),
(439302, 'PF13311', NULL, 'Protein of unknown function (DUF4080)', 188, NULL, 'DUF4080', 258396),
(439303, 'PF17450', NULL, 'Alpha galactosidase A C-terminal beta sandwich domain', 86, NULL, 'Melibiase_2_C', 258397),
(439304, 'PF16370', NULL, 'C terminal of Calcineurin-like phosphoesterase', 163, NULL, 'MetallophosC', 258398),
(439305, 'PF17750', NULL, 'Reovirus sigma C capsid protein triple beta spiral', 40, NULL, 'Reo_sigmaC_M', 258399),
(439306, 'PF17593', NULL, 'Family of unknown function (DUF5490)', 62, NULL, 'DUF5490', 258400),
(439307, 'PF00497', NULL, 'Bacterial extracellular solute-binding proteins, family 3', 225, NULL, 'SBP_bac_3', 258401);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(439308, 'PF19723', NULL, 'Family of unknown function (DUF6216)', 269, NULL, 'DUF6216', 258402),
(439309, 'PF04664', NULL, 'Opioid growth factor receptor (OGFr) conserved region', 208, NULL, 'OGFr_N', 258403),
(439310, 'PF13969', NULL, 'Pab87 octamerisation domain', 97, NULL, 'Pab87_oct', 258404),
(439311, 'PF19923', NULL, 'Family of unknown function (DUF6386)', 145, NULL, 'DUF6386', 258405),
(439312, 'PF04486', NULL, 'SchA/CurD like domain', 119, NULL, 'SchA_CurD', 258406),
(439313, 'PF19329', NULL, 'BTB/POZ domain-containing protein KCTD11/21 C-terminus', 154, NULL, 'KCTD11_21_C', 258407),
(439314, 'PF20118', NULL, 'Family of unknown function (DUF6508)', 130, NULL, 'DUF6508', 258408),
(439315, 'PF03863', NULL, 'Phage maturation protein', 395, NULL, 'Phage_mat-A', 258409),
(439316, 'PF09093', NULL, 'Lyase, catalytic', 361, NULL, 'Lyase_catalyt', 258410),
(439317, 'PF07271', NULL, 'Cytadhesin P30/P32', 275, NULL, 'Cytadhesin_P30', 258411),
(439318, 'PF01221', NULL, 'Dynein light chain type 1', 86, NULL, 'Dynein_light', 258412),
(439319, 'PF04241', NULL, 'Protein of unknown function (DUF423)', 86, NULL, 'DUF423', 258413),
(439320, 'PF09251', NULL, 'Salmonella phage P22 tail-spike', 550, NULL, 'PhageP22-tail', 258414),
(439321, 'PF13885', NULL, 'Keratin, high sulfur B2 protein', 45, NULL, 'Keratin_B2_2', 258415),
(439322, 'PF10934', NULL, 'Protein of unknown function (DUF2634)', 105, NULL, 'DUF2634', 258416),
(439323, 'PF01543', NULL, 'Hepatitis C virus capsid protein', 121, NULL, 'HCV_capsid', 258417),
(439324, 'PF01978', NULL, 'Sugar-specific transcriptional regulator TrmB', 68, NULL, 'TrmB', 258418),
(439325, 'PF05750', NULL, 'Rubella capsid protein', 300, NULL, 'Rubella_Capsid', 258419),
(439326, 'PF05954', NULL, 'Phage tail baseplate hub (GPD)', 305, NULL, 'Phage_GPD', 258420),
(439327, 'PF02442', NULL, 'Lipid membrane protein of large eukaryotic DNA viruses', 196, NULL, 'L1R_F9L', 258421),
(439328, 'PF10797', NULL, 'Protein of unknown function', 422, NULL, 'YhfT', 258422),
(439329, 'PF17320', NULL, 'Family of unknown function (DUF5363)', 54, NULL, 'DUF5363', 258423),
(439330, 'PF18933', NULL, 'PsbP-like protein', 193, NULL, 'PsbP_2', 258424),
(439331, 'PF07070', NULL, 'SpoOM protein', 210, NULL, 'Spo0M', 258425),
(439332, 'PF18715', NULL, 'Phage spike trimer', 53, NULL, 'Phage_spike', 258426),
(439333, 'PF16258', NULL, 'Domain of unknown function (DUF4912)', 117, NULL, 'DUF4912', 258427),
(439334, 'PF04858', NULL, 'TH1 protein', 580, NULL, 'TH1', 258428),
(439335, 'PF18074', NULL, 'Primosomal protein N C-terminal domain', 94, NULL, 'PriA_C', 258429),
(439336, 'PF19246', NULL, 'Family of unknown function (DUF5894)', 57, NULL, 'DUF5894', 258430),
(439337, 'PF13315', NULL, 'Protein of unknown function (DUF4085)', 205, NULL, 'DUF4085', 258431),
(439338, 'PF18970', NULL, 'Family of unknown function (DUF5709)', 49, NULL, 'DUF5709', 258432),
(439339, 'PF18285', NULL, 'Tetracycline repressor LuxT C-terminal domain', 87, NULL, 'LuxT_C', 258433),
(439340, 'PF17120', NULL, 'RING/Ubox like zinc-binding domain', 58, NULL, 'zf-RING_16', 258434),
(439341, 'PF06176', NULL, 'Lipopolysaccharide core biosynthesis protein (WaaY)', 229, NULL, 'WaaY', 258435),
(439342, 'PF07495', NULL, 'Y_Y_Y domain', 66, NULL, 'Y_Y_Y', 258436),
(439343, 'PF20204', NULL, 'Domain of unknown function (DUF6566)', 78, NULL, 'DUF6566', 258437),
(439344, 'PF05138', NULL, 'Phenylacetic acid catabolic protein', 263, NULL, 'PaaA_PaaC', 258438),
(439345, 'PF14194', NULL, 'Cysteine-rich VLP', 57, NULL, 'Cys_rich_VLP', 258439),
(439346, 'PF02661', NULL, 'Fic/DOC family', 97, NULL, 'Fic', 258440),
(439347, 'PF12399', NULL, 'Branched-chain amino acid ATP-binding cassette transporter', 27, NULL, 'BCA_ABC_TP_C', 258441),
(439348, 'PF18226', NULL, 'LasR-specific antiactivator QslA chain E', 71, NULL, 'QslA_E', 258442),
(439349, 'PF08245', NULL, 'Mur ligase middle domain', 200, NULL, 'Mur_ligase_M', 258443),
(439350, 'PF10204', NULL, 'Dual oxidase maturation factor', 279, NULL, 'DuoxA', 258444),
(439351, 'PF07777', NULL, 'G-box binding protein MFMR', 97, NULL, 'MFMR', 258445);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(439352, 'PF15660', NULL, 'Putative Immunity protein 75', 84, NULL, 'Imm75', 258446),
(439353, 'PF07156', NULL, 'Prenylcysteine lyase', 363, NULL, 'Prenylcys_lyase', 258447),
(439354, 'PF05418', NULL, 'Apovitellenin I (Apo-VLDL-II)', 79, NULL, 'Apo-VLDL-II', 258448),
(439355, 'PF15695', NULL, 'Rec (regulator of expression encoded by corf) of HERV-K-113', 87, NULL, 'HERV-K_REC', 258449),
(439356, 'PF02200', NULL, 'STE like transcription factor', 110, NULL, 'STE', 258450),
(439357, 'PF15641', NULL, 'Metallopeptidase toxin 5', 110, NULL, 'Tox-MPTase5', 258451),
(439358, 'PF05435', NULL, 'Phi-29 DNA terminal protein GP3', 265, NULL, 'Phi-29_GP3', 258452),
(439359, 'PF07554', NULL, 'FIVAR domain', 71, NULL, 'FIVAR', 258453),
(439360, 'PF00547', NULL, 'Urease, gamma subunit', 99, NULL, 'Urease_gamma', 258454),
(439361, 'PF18378', NULL, 'Nuclear pore protein NUP188 C-terminal domain', 371, NULL, 'Nup188_C', 258455),
(439362, 'PF04899', NULL, 'MbeD/MobD like', 70, NULL, 'MbeD_MobD', 258456),
(439363, 'PF10175', NULL, 'M-phase phosphoprotein 6', 141, NULL, 'MPP6', 258457),
(439364, 'PF11879', NULL, 'Domain of unknown function (DUF3399)', 77, NULL, 'DUF3399', 258458),
(439365, 'PF01695', NULL, 'IstB-like ATP binding protein', 238, NULL, 'IstB_IS21', 258459),
(439366, 'PF12532', NULL, 'Protein of unknown function (DUF3732)', 187, NULL, 'DUF3732', 258460),
(439367, 'PF13134', NULL, 'Protein of unknown function (DUF3948)', 35, NULL, 'DUF3948', 258461),
(439368, 'PF00802', NULL, 'Pneumovirus attachment glycoprotein G', 263, NULL, 'Glycoprotein_G', 258462),
(439369, 'PF09144', NULL, 'Yersinia pseudo-tuberculosis mitogen', 117, NULL, 'YpM', 258463),
(439370, 'PF07690', NULL, 'Major Facilitator Superfamily', 353, NULL, 'MFS_1', 258464),
(439371, 'PF13127', NULL, 'Protein of unknown function (DUF3955)', 59, NULL, 'DUF3955', 258465),
(439372, 'PF12398', NULL, 'Receptor serine/threonine kinase', 42, NULL, 'DUF3660', 258466),
(439373, 'PF20319', NULL, 'Family of unknown function (DUF6614)', 116, NULL, 'DUF6614', 258467),
(439374, 'PF11550', NULL, 'Intracellular growth locus C protein', 211, NULL, 'IglC', 258468),
(439375, 'PF16981', NULL, 'chi-Conotoxin or t superfamily', 60, NULL, 'Chi-conotoxin', 258469),
(439376, 'PF05087', NULL, 'Rotavirus VP2 protein', 884, NULL, 'Rota_VP2', 258470),
(439377, 'PF09781', NULL, 'NADH:ubiquinone oxidoreductase, NDUFB5/SGDH subunit', 187, NULL, 'NDUF_B5', 258471),
(439378, 'PF00418', NULL, 'Tau and MAP protein, tubulin-binding repeat', 31, NULL, 'Tubulin-binding', 258472),
(439379, 'PF05298', NULL, 'Bombinin', 141, NULL, 'Bombinin', 258473),
(439380, 'PF12196', NULL, 'FHA Ki67 binding domain of hNIFK', 40, NULL, 'hNIFK_binding', 258474),
(439381, 'PF04774', NULL, 'Hyaluronan / mRNA binding family', 116, NULL, 'HABP4_PAI-RBP1', 258475),
(439382, 'PF07522', NULL, 'DNA repair metallo-beta-lactamase', 116, NULL, 'DRMBL', 258476),
(439383, 'PF12619', NULL, 'Mini-chromosome maintenance protein 2', 153, NULL, 'MCM2_N', 258477),
(439384, 'PF20516', NULL, 'PD-(D/E)XK nuclease superfamily', 252, NULL, 'PDDEXK_12', 258478),
(439385, 'PF07842', NULL, 'GC-rich sequence DNA-binding factor-like protein', 277, NULL, 'GCFC', 258479),
(439386, 'PF17149', NULL, 'Periplasmic sensor domain found in signal transduction proteins', 108, NULL, 'CHASE5', 258480),
(439387, 'PF01882', NULL, 'Protein of unknown function DUF58', 86, NULL, 'DUF58', 258481),
(439388, 'PF10579', NULL, 'Rapsyn N-terminal myristoylation and linker region', 80, NULL, 'Rapsyn_N', 258482),
(439389, 'PF01552', NULL, 'Picornavirus 2B protein', 99, NULL, 'Pico_P2B', 258483),
(439390, 'PF12302', NULL, 'Protein of unknown function (DUF3629)', 218, NULL, 'DUF3629', 258484),
(439391, 'PF02914', NULL, 'Bacteriophage Mu transposase', 219, NULL, 'DDE_2', 258485),
(439392, 'PF09939', NULL, 'Uncharacterized protein conserved in bacteria (DUF2171)', 65, NULL, 'DUF2171', 258486),
(439393, 'PF19613', NULL, 'Family of unknown function (DUF6118)', 245, NULL, 'DUF6118', 258487),
(439394, 'PF14335', NULL, 'Domain of unknown function (DUF4391)', 242, NULL, 'DUF4391', 258488);
INSERT INTO "PUBLIC"."MODEL" VALUES
(439395, 'PF01389', NULL, 'OmpA-like transmembrane domain', 183, NULL, 'OmpA_membrane', 258489),
(439396, 'PF12308', NULL, 'Neurogenesis glycoprotein', 100, NULL, 'Noelin-1', 258490),
(439397, 'PF04208', NULL, 'Tetrahydromethanopterin S-methyltransferase, subunit A', 173, NULL, 'MtrA', 258491),
(439398, 'PF05480', NULL, 'Phenol-soluble modulin beta protein', 43, NULL, 'PSMbeta', 258492),
(439399, 'PF02946', NULL, 'GTF2I-like repeat', 75, NULL, 'GTF2I', 258493),
(439400, 'PF01925', NULL, 'Sulfite exporter TauE/SafE', 237, NULL, 'TauE', 258494),
(439401, 'PF06133', NULL, 'Control of competence regulator ComK, YlbF/YmcA', 105, NULL, 'Com_YlbF', 258495),
(439402, 'PF12493', NULL, 'Protein of unknown function (DUF3709)', 33, NULL, 'DUF3709', 258496),
(439403, 'PF16855', NULL, 'Small outer capsid protein', 74, NULL, 'Soc', 258497),
(439404, 'PF18446', NULL, 'Domain of unknown function (DUF5611)', 103, NULL, 'DUF5611', 258498),
(439405, 'PF09096', NULL, 'Baseplate structural protein, domain 2', 173, NULL, 'Phage-tail_2', 258499),
(439406, 'PF19487', NULL, 'Family of unknown function (DUF6023)', 150, NULL, 'DUF6023', 258500),
(439407, 'PF19562', NULL, 'Family of unknown function (DUF6084)', 213, NULL, 'DUF6084', 258501),
(439408, 'PF04483', NULL, 'Protein of unknown function (DUF565)', 60, NULL, 'DUF565', 258502),
(439409, 'PF14764', NULL, 'AP-5 complex subunit, vesicle trafficking', 118, NULL, 'SPG48', 258503),
(439410, 'PF13902', NULL, 'R3H-associated N-terminal domain', 128, NULL, 'R3H-assoc', 258504),
(439411, 'PF16709', NULL, 'Ig domain of plant-specific actin-binding protein', 98, NULL, 'SCAB-Ig', 258505),
(439412, 'PF01825', NULL, 'GPCR proteolysis site, GPS, motif', 44, NULL, 'GPS', 258506),
(439413, 'PF04117', NULL, 'Mpv17 / PMP22 family', 62, NULL, 'Mpv17_PMP22', 258507),
(439414, 'PF15185', NULL, 'Bcl-2-modifying factor, apoptosis', 192, NULL, 'BMF', 258508),
(439415, 'PF02709', NULL, 'N-terminal domain of galactosyltransferase', 78, NULL, 'Glyco_transf_7C', 258509),
(439416, 'PF08181', NULL, 'DegQ (SacQ) family', 46, NULL, 'DegQ', 258510),
(439417, 'PF06053', NULL, 'Domain of unknown function (DUF929)', 206, NULL, 'DUF929', 258511),
(439418, 'PF14919', NULL, 'MDM2-binding', 335, NULL, 'MTBP_mid', 258512),
(439419, 'PF19988', NULL, 'Family of unknown function (DUF6424)', 277, NULL, 'DUF6424', 258513),
(439420, 'PF13265', NULL, 'Protein of unknown function (DUF4056)', 266, NULL, 'DUF4056', 258514),
(439421, 'PF08546', NULL, 'Ketopantoate reductase PanE/ApbA C terminal', 125, NULL, 'ApbA_C', 258515),
(439422, 'PF12902', NULL, 'Ferritin-like', 222, NULL, 'Ferritin-like', 258516),
(439423, 'PF19063', NULL, 'Family of unknown function (DUF5759)', 71, NULL, 'DUF5759', 258517),
(439424, 'PF06899', NULL, 'WzyE protein, O-antigen assembly polymerase', 447, NULL, 'WzyE', 258518),
(439425, 'PF08367', NULL, 'Peptidase M16C associated', 251, NULL, 'M16C_assoc', 258519),
(439426, 'PF14751', NULL, 'Domain of unknown function (DUF4474)', 240, NULL, 'DUF4474', 258520),
(439427, 'PF01889', NULL, 'Membrane protein of unknown function DUF63', 270, NULL, 'DUF63', 258521),
(439428, 'PF18384', NULL, 'Unkempt Zinc finger domain 1 (Znf1)', 40, NULL, 'zf_CCCH_5', 258522),
(439429, 'PF04620', NULL, 'Flagellar filament outer layer protein Flaa', 230, NULL, 'FlaA', 258523),
(439430, 'PF02324', NULL, 'Glycosyl hydrolase family 70', 823, NULL, 'Glyco_hydro_70', 258524),
(439431, 'PF08863', NULL, 'YolD-like protein', 94, NULL, 'YolD', 258525),
(439432, 'PF01350', NULL, 'Flavivirus non-structural protein NS4A', 144, NULL, 'Flavi_NS4A', 258526),
(439433, 'PF18750', NULL, 'Secreted Novel AID/APOBEC-like Deaminase 4', 116, NULL, 'SNAD4', 258527),
(439434, 'PF08247', NULL, 'ENOD40 protein', 12, NULL, 'ENOD40', 258528),
(439435, 'PF00081', NULL, 'Iron/manganese superoxide dismutases, alpha-hairpin domain', 82, NULL, 'Sod_Fe_N', 258529),
(439436, 'PF10311', NULL, 'Increased loss of mitochondrial DNA protein 1', 163, NULL, 'Ilm1', 258530),
(439437, 'PF10859', NULL, 'Protein of unknown function (DUF2660)', 87, NULL, 'DUF2660', 258531);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(439438, 'PF12330', NULL, 'Haspin like kinase domain', 369, NULL, 'Haspin_kinase', 258532),
(439439, 'PF09403', NULL, 'Adhesion protein FadA', 99, NULL, 'FadA', 258533),
(439440, 'PF12957', NULL, 'Domain of unknown function (DUF3846)', 91, NULL, 'DUF3846', 258534),
(439441, 'PF17234', NULL, 'Mitochondrial peculiar membrane protein 1', 170, NULL, 'MPM1', 258535),
(439442, 'PF09595', NULL, 'Metaviral_G glycoprotein', 183, NULL, 'Metaviral_G', 258536),
(439443, 'PF17375', NULL, 'Family of unknown function (DUF5397)', 64, NULL, 'DUF5397', 258537),
(439444, 'PF18376', NULL, 'Mevalonate 5-diphosphate decarboxylase C-terminal domain', 187, NULL, 'MDD_C', 258538),
(439445, 'PF05225', NULL, 'helix-turn-helix, Psq domain', 45, NULL, 'HTH_psq', 258539),
(439446, 'PF17826', NULL, 'Family of unknown function (DUF5588)', 362, NULL, 'DUF5588', 258540),
(439447, 'PF03861', NULL, 'ANTAR domain', 54, NULL, 'ANTAR', 258541),
(439448, 'PF20008', NULL, 'Domain of unknown function (DUF6429)', 48, NULL, 'DUF6429', 258542),
(439449, 'PF12298', NULL, 'Eukaryotic mitochondrial regulator protein', 172, NULL, 'Bot1p', 258543),
(439450, 'PF06866', NULL, 'Protein of unknown function (DUF1256)', 164, NULL, 'DUF1256', 258544),
(439451, 'PF04134', NULL, 'DCC1-like thiol-disulfide oxidoreductase', 113, NULL, 'DCC1-like', 258545),
(439452, 'PF09654', NULL, 'Protein of unknown function (DUF2396)', 159, NULL, 'DUF2396', 258546),
(439453, 'PF02582', NULL, 'RMND1/Sif2-Sif3/Mrx10, DUF155', 174, NULL, 'DUF155', 258547),
(439454, 'PF16557', NULL, 'CUT1-like DNA-binding domain of SATB', 72, NULL, 'CUTL', 258548),
(439455, 'PF03495', NULL, 'Clostridial binary toxin B/anthrax toxin PA Ca-binding domain', 78, NULL, 'Binary_toxB', 258549),
(439456, 'PF12707', NULL, 'Protein of unknown function (DUF3804)', 128, NULL, 'DUF3804', 258550),
(439457, 'PF18853', NULL, 'Large polyvalent protein associated domain 37', 245, NULL, 'LPD37', 258551),
(439458, 'PF14861', NULL, 'Plant antimicrobial peptide', 30, NULL, 'Antimicrobial21', 258552),
(439459, 'PF04995', NULL, 'Heme exporter protein D (CcmD)', 44, NULL, 'CcmD', 258553),
(439460, 'PF05206', NULL, 'Methyltransferase TRM13', 263, NULL, 'TRM13', 258554),
(439461, 'PF05610', NULL, 'Protein of unknown function (DUF779)', 94, NULL, 'DUF779', 258555),
(439462, 'PF12449', NULL, 'Protein of unknown function (DUF3684)', 1098, NULL, 'DUF3684', 258556),
(439463, 'PF02601', NULL, 'Exonuclease VII, large subunit', 305, NULL, 'Exonuc_VII_L', 258557),
(439464, 'PF10055', NULL, 'Uncharacterized small protein (DUF2292)', 37, NULL, 'DUF2292', 258558),
(439465, 'PF12989', NULL, 'Domain of unknown function, B. Theta Gene description (DUF3873)', 68, NULL, 'DUF3873', 258559),
(439466, 'PF05529', NULL, 'Bap31/Bap29 transmembrane region', 138, NULL, 'Bap31', 258560),
(439467, 'PF01483', NULL, 'Proprotein convertase P-domain', 86, NULL, 'P_proprotein', 258561),
(439468, 'PF11087', NULL, 'PRD1 phage membrane DNA delivery', 54, NULL, 'PRD1_DD', 258562),
(439469, 'PF18862', NULL, 'ApeA N-terminal domain 1', 392, NULL, 'ApeA_NTD1', 258563),
(439470, 'PF01287', NULL, 'Eukaryotic elongation factor 5A hypusine, DNA-binding OB fold', 69, NULL, 'eIF-5a', 258564),
(439471, 'PF06060', NULL, 'Pre-pro-megakaryocyte potentiating factor precursor (Mesothelin)', 624, NULL, 'Mesothelin', 258565),
(439472, 'PF20085', NULL, 'Protein-glutamine gamma-glutamyltransferase', 248, NULL, 'TGL', 258566),
(439473, 'PF20586', NULL, 'Family of unknown function (DUF6788)', 103, NULL, 'DUF6788', 258567),
(439474, 'PF11586', NULL, 'Protein of unknown function (DUF3242)', 126, NULL, 'DUF3242', 258568),
(439475, 'PF16319', NULL, 'Domain of unknown function (DUF4958)', 731, NULL, 'DUF4958', 258569),
(439476, 'PF04740', NULL, 'LXG domain of WXG superfamily', 202, NULL, 'LXG', 258570),
(439477, 'PF15074', NULL, 'Domain of unknown function (DUF4541)', 92, NULL, 'DUF4541', 258571),
(439478, 'PF14677', NULL, 'FANCI solenoid 3', 216, NULL, 'FANCI_S3', 258572),
(439479, 'PF03012', NULL, 'Phosphoprotein', 296, NULL, 'PP_M1', 258573),
(439480, 'PF09128', NULL, 'Regulator of G protein signalling-like domain', 191, NULL, 'RGS-like', 258574);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(439481, 'PF18809', NULL, 'phage-Barnase-EndoU-ColicinE5/D-RelE like nuclease1', 108, NULL, 'PBECR1', 258575),
(439482, 'PF19347', NULL, 'Domain of unknown function (DUF5925)', 178, NULL, 'DUF5925', 258576),
(439483, 'PF10565', NULL, 'N-methyl D-aspartate receptor 2B3 C-terminus', 672, NULL, 'NMDAR2_C', 258577),
(439484, 'PF12571', NULL, 'Phage tail-collar fibre protein', 150, NULL, 'DUF3751', 258578),
(439485, 'PF15679', NULL, 'Domain of unknown function (DUF4665)', 99, NULL, 'DUF4665', 258579),
(439486, 'PF03482', NULL, 'sic protein repeat', 30, NULL, 'SIC', 258580),
(439487, 'PF19125', NULL, 'Family of unknown function (DUF5809)', 130, NULL, 'DUF5809', 258581),
(439488, 'PF18487', NULL, 'Thrombospondin type 1 repeat', 50, NULL, 'TSR', 258582),
(439489, 'PF09229', NULL, 'Activator of Hsp90 ATPase, N-terminal', 137, NULL, 'Aha1_N', 258583),
(439490, 'PF04598', NULL, 'Gasdermin pore forming domain', 242, NULL, 'Gasdermin', 258584),
(439491, 'PF08942', NULL, 'Domain of unknown function (DUF1919)', 196, NULL, 'DUF1919', 258585),
(439492, 'PF09208', NULL, 'Restriction endonuclease MspI', 259, NULL, 'Endonuc-MspI', 258586),
(439493, 'PF15953', NULL, 'Putative propanediol utilisation', 153, NULL, 'PDU_like', 258587),
(439494, 'PF05085', NULL, 'Protein of unknown function (DUF685)', 265, NULL, 'DUF685', 258588),
(439495, 'PF05907', NULL, 'CXXC motif containing zinc binding protein, eukaryotic', 155, NULL, 'CXXC_Zn-b_euk', 258589),
(439496, 'PF10843', NULL, 'Respiratory growth induced protein 1', 194, NULL, 'RGI1', 258590),
(439497, 'PF14671', NULL, 'Dual specificity protein phosphatase, N-terminal half', 141, NULL, 'DSPn', 258591),
(439498, 'PF07228', NULL, 'Stage II sporulation protein E (SpoIIE)', 193, NULL, 'SpoIIE', 258592),
(439499, 'PF16872', NULL, 'Putative phage abortive infection protein', 80, NULL, 'putAbiC', 258593),
(439500, 'PF19529', NULL, 'Family of unknown function (DUF6057)', 568, NULL, 'DUF6057', 258594),
(439501, 'PF07090', NULL, 'Putative glutamine amidotransferase', 247, NULL, 'GATase1_like', 258595),
(439502, 'PF15288', NULL, 'Zinc knuckle', 42, NULL, 'zf-CCHC_6', 258596),
(439503, 'PF00686', NULL, 'Starch binding domain', 96, NULL, 'CBM_20', 258597),
(439504, 'PF10857', NULL, 'Protein of unknown function (DUF2701)', 63, NULL, 'DUF2701', 258598),
(439505, 'PF16208', NULL, 'Keratin type II head', 161, NULL, 'Keratin_2_head', 258599),
(439506, 'PF08123', NULL, 'Histone methylation protein DOT1', 205, NULL, 'DOT1', 258600),
(439507, 'PF11845', NULL, 'Protein of unknown function (DUF3365)', 141, NULL, 'DUF3365', 258601),
(439508, 'PF16615', NULL, 'Unstructured region one on RhoGEF 6 and 7', 47, NULL, 'RhoGEF67_u1', 258602),
(439509, 'PF00728', NULL, 'Glycosyl hydrolase family 20, catalytic domain', 352, NULL, 'Glyco_hydro_20', 258603),
(439510, 'PF08447', NULL, 'PAS fold', 89, NULL, 'PAS_3', 258604),
(439511, 'PF17161', NULL, 'Domain of unknown function (DUF5123)', 117, NULL, 'DUF5123', 258605),
(439512, 'PF05495', NULL, 'CHY zinc finger', 75, NULL, 'zf-CHY', 258606),
(439513, 'PF17612', NULL, 'Family of unknown function (DUF5507)', 160, NULL, 'DUF5507', 258607),
(439514, 'PF15146', NULL, 'Fanconi anemia-associated', 441, NULL, 'FANCAA', 258608),
(439515, 'PF16869', NULL, 'Condensin II complex subunit CAP-H2 or CNDH2, mid domain', 139, NULL, 'CNDH2_M', 258609),
(439516, 'PF06622', NULL, 'SepQ protein', 305, NULL, 'SepQ', 258610),
(439517, 'PF12122', NULL, 'Cytoplasmic N-terminal domain of rhomboid serine protease', 85, NULL, 'Rhomboid_N', 258611),
(439518, 'PF14820', NULL, 'Small proline-rich 2', 68, NULL, 'SPRR2', 258612),
(439519, 'PF20548', NULL, 'Family of unknown function (DUF6762)', 132, NULL, 'DUF6762', 258613),
(439520, 'PF11492', NULL, 'Cricket paralysis virus, VP4', 57, NULL, 'Dicistro_VP4', 258614),
(439521, 'PF00948', NULL, 'Flavivirus non-structural Protein NS1', 360, NULL, 'Flavi_NS1', 258615),
(439522, 'PF09032', NULL, 'Siah interacting protein, N terminal', 78, NULL, 'Siah-Interact_N', 258616),
(439523, 'PF03289', NULL, 'Poxvirus protein I1', 307, NULL, 'Pox_I1', 258617); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(439524, 'PF06130', NULL, 'Phosphate propanoyltransferase', 67, NULL, 'PTAC', 258618),
(439525, 'PF04015', NULL, 'Domain of unknown function (DUF362)', 203, NULL, 'DUF362', 258619),
(439526, 'PF12939', NULL, 'Domain of unknown function (DUF3837)', 101, NULL, 'DUF3837', 258620),
(439527, 'PF03224', NULL, 'V-ATPase subunit H', 315, NULL, 'V-ATPase_H_N', 258621),
(439528, 'PF16158', NULL, 'Ig-like domain from next to BRCA1 gene', 107, NULL, 'N_BRCA1_IG', 258622),
(439529, 'PF02829', NULL, '3H domain', 97, NULL, '3H', 258623),
(439530, 'PF20478', NULL, 'P2X purinoreceptor 7 intracellular domain', 192, NULL, 'P2RX7_C', 258624),
(439531, 'PF09695', NULL, 'Bacterial protein of unknown function (YtfJ_HI0045)', 160, NULL, 'YtfJ_HI0045', 258625),
(439532, 'PF20309', NULL, 'Deoxyribohydrolase (DRHyd) domain of the ASK signalosome', 36, NULL, 'DRHyd-ASK', 258626),
(439533, 'PF17460', NULL, 'Uncharacterized protein RP854', 212, NULL, 'RP854', 258627),
(439534, 'PF16363', NULL, 'GDP-mannose 4,6 dehydratase', 332, NULL, 'GDP_Man_Dehyd', 258628),
(439535, 'PF18142', NULL, 'SMODS and SLOG-associating 2TM effector domain', 120, NULL, 'SLATT_fungal', 258629),
(439536, 'PF20216', NULL, 'Family of unknown function (DUF6576)', 47, NULL, 'DUF6576', 258630),
(439537, 'PF01263', NULL, 'Aldose 1-epimerase', 301, NULL, 'Aldose_epim', 258631),
(439538, 'PF13453', NULL, 'Transcription factor zinc-finger', 41, NULL, 'zf-TFIIB', 258632),
(439539, 'PF09342', NULL, 'Domain of unknown function (DUF1986)', 116, NULL, 'DUF1986', 258633),
(439540, 'PF16848', NULL, 'Substrate of the Dot/Icm secretion system, putative', 178, NULL, 'SoDot-IcmSS', 258634),
(439541, 'PF14471', NULL, 'Domain of unknown function (DUF4428)', 51, NULL, 'DUF4428', 258635),
(439542, 'PF11683', NULL, 'Protein of unknown function (DUF3278)', 130, NULL, 'DUF3278', 258636),
(439543, 'PF04842', NULL, 'Plant protein of unknown function (DUF639)', 231, NULL, 'DUF639', 258637),
(439544, 'PF05302', NULL, 'Protein of unknown function (DUF720)', 125, NULL, 'DUF720', 258638),
(439545, 'PF08500', NULL, 'Tombusvirus p33', 142, NULL, 'Tombus_P33', 258639),
(439546, 'PF01863', NULL, 'YgjP-like, metallopeptidase domain', 207, NULL, 'YgjP-like', 258640),
(439547, 'PF08161', NULL, 'NUC173 domain', 204, NULL, 'NUC173', 258641),
(439548, 'PF01738', NULL, 'Dienelactone hydrolase family', 217, NULL, 'DLH', 258642),
(439549, 'PF08083', NULL, 'PROCN (NUC071) domain', 407, NULL, 'PROCN', 258643),
(439550, 'PF16699', NULL, 'Cleavage stimulation factor subunit 1, dimerisation domain', 57, NULL, 'CSTF1_dimer', 258644),
(439551, 'PF01191', NULL, 'RNA polymerase Rpb5, C-terminal domain', 73, NULL, 'RNA_pol_Rpb5_C', 258645),
(439552, 'PF17071', NULL, 'Outer capsid protein VP7', 276, NULL, 'Capsid_VP7', 258646),
(439553, 'PF18207', NULL, 'Leukemia inhibitory factor receptor N-terminal domain', 79, NULL, 'LIFR_N', 258647),
(439554, 'PF05590', NULL, 'Xylella fastidiosa protein of unknown function (DUF769)', 259, NULL, 'DUF769', 258648),
(439555, 'PF16046', NULL, 'FAM76 protein', 305, NULL, 'FAM76', 258649),
(439556, 'PF12297', NULL, 'Ellis van Creveld protein 2 like protein', 428, NULL, 'EVC2_like', 258650),
(439557, 'PF00096', NULL, 'Zinc finger, C2H2 type', 23, NULL, 'zf-C2H2', 258651),
(439558, 'PF10748', NULL, 'DNA utilization proteins HofP', 132, NULL, 'HofP', 258652),
(439559, 'PF04492', NULL, 'Bacteriophage replication protein O', 96, NULL, 'Phage_rep_O', 258653),
(439560, 'PF17666', NULL, 'Family of unknown function (DUF5528)', 152, NULL, 'DUF5528', 258654),
(439561, 'PF14493', NULL, 'Helix-turn-helix domain', 89, NULL, 'HTH_40', 258655),
(439562, 'PF13132', NULL, 'Domain of unknown function (DUF3950)', 30, NULL, 'DUF3950', 258656),
(439563, 'PF12015', NULL, 'Bud3, N-terminal', 182, NULL, 'Bud3_N', 258657),
(439564, 'PF02377', NULL, 'Dishevelled specific domain', 160, NULL, 'Dishevelled', 258658),
(439565, 'PF02448', NULL, 'L71 family', 71, NULL, 'L71', 258659),
(439566, 'PF02424', NULL, 'ApbE family', 257, NULL, 'ApbE', 258660),
(439567, 'PF03207', NULL, 'Borrelia outer surface protein D (OspD)', 254, NULL, 'OspD', 258661);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(439568, 'PF11047', NULL, 'Salmonella outer protein D', 319, NULL, 'SopD', 258662),
(439569, 'PF07161', NULL, 'LppX_LprAFG lipoprotein', 191, NULL, 'LppX_LprAFG', 258663),
(439570, 'PF15466', NULL, 'Domain of unknown function (DUF4635)', 134, NULL, 'DUF4635', 258664),
(439571, 'PF00708', NULL, 'Acylphosphatase', 85, NULL, 'Acylphosphatase', 258665),
(439572, 'PF16618', NULL, 'Linker region between SH3 and WW domains on ARHGAP12', 198, NULL, 'SH3-WW_linker', 258666),
(439573, 'PF11144', NULL, 'Protein of unknown function (DUF2920)', 394, NULL, 'DUF2920', 258667),
(439574, 'PF16137', NULL, 'Domain of unknown function (DUF4845)', 85, NULL, 'DUF4845', 258668),
(439575, 'PF13942', NULL, 'YfhG lipoprotein', 175, NULL, 'Lipoprotein_20', 258669),
(439576, 'PF00841', NULL, 'Sperm histone P2', 89, NULL, 'Protamine_P2', 258670),
(439577, 'PF18119', NULL, 'RIG-I receptor C-terminal domain', 139, NULL, 'RIG-I_C', 258671),
(439578, 'PF19868', NULL, 'Family of unknown function (DUF6341)', 50, NULL, 'DUF6341', 258672),
(439579, 'PF15418', NULL, 'Domain of unknown function (DUF4625)', 132, NULL, 'DUF4625', 258673),
(439580, 'PF18452', NULL, 'Immunoglobulin domain', 128, NULL, 'Ig_6', 258674),
(439581, 'PF18824', NULL, 'Large polyvalent protein-associated domain 11', 69, NULL, 'LPD11', 258675),
(439582, 'PF01683', NULL, 'EB module', 52, NULL, 'EB', 258676),
(439583, 'PF03128', NULL, 'CXCXC repeat', 13, NULL, 'CXCXC', 258677),
(439584, 'PF04799', NULL, 'fzo-like conserved region', 161, NULL, 'Fzo_mitofusin', 258678),
(439585, 'PF12553', NULL, 'Protein of unknown function (DUF3742)', 121, NULL, 'DUF3742', 258679),
(439586, 'PF18529', NULL, 'Mitochondrial membrane-anchored proteins', 152, NULL, 'MIX', 258680),
(439587, 'PF11741', NULL, 'AMIN domain', 97, NULL, 'AMIN', 258681),
(439588, 'PF00732', NULL, 'GMC oxidoreductase', 296, NULL, 'GMC_oxred_N', 258682),
(439589, 'PF10160', NULL, 'Predicted membrane protein', 258, NULL, 'Tmemb_40', 258683),
(439590, 'PF07148', NULL, 'Maltose operon periplasmic protein precursor (MalM)', 134, NULL, 'MalM', 258684),
(439591, 'PF05355', NULL, 'Apolipoprotein C-II', 77, NULL, 'Apo-CII', 258685),
(439592, 'PF04950', NULL, '40S ribosome biogenesis protein Tsr1 and BMS1 C-terminal', 292, NULL, 'RIBIOP_C', 258686),
(439593, 'PF05717', NULL, 'IS66 Orf2 like protein', 101, NULL, 'TnpB_IS66', 258687),
(439594, 'PF04770', NULL, 'ZF-HD protein dimerisation region', 55, NULL, 'ZF-HD_dimer', 258688),
(439595, 'PF10473', NULL, 'Leucine-rich repeats of kinetochore protein Cenp-F/LEK1', 140, NULL, 'CENP-F_leu_zip', 258689),
(439596, 'PF15332', NULL, 'Lck-interacting transmembrane adapter 1', 239, NULL, 'LIME1', 258690),
(439597, 'PF14232', NULL, 'Domain of unknown function (DUF4334)', 58, NULL, 'DUF4334', 258691),
(439598, 'PF19743', NULL, 'ASTN1/2 EGF-like and Fn(III) domains', 231, NULL, 'ASTN1_2_EGF_Fn', 258692),
(439599, 'PF08091', NULL, 'Spider insecticidal peptide', 39, NULL, 'Toxin_21', 258693),
(439600, 'PF06394', NULL, 'Pepsin inhibitor-3-like repeated domain', 74, NULL, 'Pepsin-I3', 258694),
(439601, 'PF11068', NULL, 'YlqD protein', 131, NULL, 'YlqD', 258695),
(439602, 'PF05851', NULL, 'Lentivirus virion infectivity factor (VIF)', 251, NULL, 'Lentivirus_VIF', 258696),
(439603, 'PF13955', NULL, 'Toxin Fst, type I toxin-antitoxin system', 21, NULL, 'Fst_toxin', 258697),
(439604, 'PF15251', NULL, 'Domain of unknown function (DUF4588)', 251, NULL, 'DUF4588', 258698),
(439605, 'PF08870', NULL, 'DNA sulphur modification protein DndE', 112, NULL, 'DndE', 258699),
(439606, 'PF19426', NULL, 'Mesoderm induction early response protein 1/3 C-terminal', 218, NULL, 'MIER1_3_C', 258700),
(439607, 'PF08396', NULL, 'Spider toxin omega agatoxin/Tx1 family', 75, NULL, 'Toxin_34', 258701),
(439608, 'PF06545', NULL, 'Protein of unknown function (DUF1116)', 215, NULL, 'DUF1116', 258702),
(439609, 'PF08309', NULL, 'LVIVD repeat', 42, NULL, 'LVIVD', 258703),
(439610, 'PF03542', NULL, 'Tuberin', 351, NULL, 'Tuberin', 258704),
(439611, 'PF11570', NULL, 'Coiled-coil receptor-binding R-domain of colicin E2', 136, NULL, 'E2R135', 258705);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(439612, 'PF07560', NULL, 'Domain of Unknown Function (DUF1539)', 126, NULL, 'DUF1539', 258706),
(439613, 'PF09748', NULL, 'Transcription factor subunit Med10 of Mediator complex', 121, NULL, 'Med10', 258707),
(439614, 'PF00577', NULL, 'Outer membrane usher protein', 549, NULL, 'Usher', 258708),
(439615, 'PF08062', NULL, 'P120R (NUC006) repeat', 22, NULL, 'P120R', 258709),
(439616, 'PF10542', NULL, 'Vitelline membrane cysteine-rich region', 38, NULL, 'Vitelline_membr', 258710),
(439617, 'PF12463', NULL, 'Protein of unknown function (DUF3689)', 315, NULL, 'DUF3689', 258711),
(439618, 'PF11811', NULL, 'Domain of unknown function (DUF3331)', 93, NULL, 'DUF3331', 258712),
(439619, 'PF20282', NULL, 'C-terminal domain 6 of the ABC-three component (ABC-3C) systems', 130, NULL, 'CTD6', 258713),
(439620, 'PF14557', NULL, 'Putative AphA-like transcriptional regulator', 175, NULL, 'AphA_like', 258714),
(439621, 'PF17436', NULL, 'Family of unknown function (DUF5415)', 66, NULL, 'DUF5415', 258715),
(439622, 'PF15003', NULL, 'HAUS augmin-like complex subunit 2', 191, NULL, 'HAUS2', 258716),
(439623, 'PF01073', NULL, '3-beta hydroxysteroid dehydrogenase/isomerase family', 280, NULL, '3Beta_HSD', 258717),
(439624, 'PF14685', NULL, 'Tricorn protease PDZ domain', 88, NULL, 'Tricorn_PDZ', 258718),
(439625, 'PF14828', NULL, 'Amnionless', 452, NULL, 'Amnionless', 258719),
(439626, 'PF05615', NULL, 'Tho complex subunit 7', 132, NULL, 'THOC7', 258720),
(439627, 'PF00116', NULL, 'Cytochrome C oxidase subunit II, periplasmic domain', 120, NULL, 'COX2', 258721),
(439628, 'PF10050', NULL, 'Predicted metal-binding protein (DUF2284)', 163, NULL, 'DUF2284', 258722),
(439629, 'PF12158', NULL, 'Protein of unknown function (DUF3592)', 148, NULL, 'DUF3592', 258723),
(439630, 'PF03640', NULL, 'Secreted repeat of unknown function', 47, NULL, 'Lipoprotein_15', 258724),
(439631, 'PF04838', NULL, 'Baculoviridae late expression factor 5', 156, NULL, 'Baculo_LEF5', 258725),
(439632, 'PF14092', NULL, 'Domain of unknown function (DUF4270)', 439, NULL, 'DUF4270', 258726),
(439633, 'PF03254', NULL, 'Xyloglucan fucosyltransferase', 475, NULL, 'XG_FTase', 258727),
(439634, 'PF18107', NULL, 'Fission yeast centromere protein N-terminal domain', 61, NULL, 'HTH_ABP1_N', 258728),
(439635, 'PF01519', NULL, 'Protein of unknown function DUF16', 104, NULL, 'DUF16', 258729),
(439636, 'PF10591', NULL, 'Secreted protein acidic and rich in cysteine Ca binding region', 113, NULL, 'SPARC_Ca_bdg', 258730),
(439637, 'PF19919', NULL, 'MoxR-vWA-beta-propeller ternary system domain bpX3', 175, NULL, 'bpX3', 258731),
(439638, 'PF05636', NULL, 'HIGH Nucleotidyl Transferase', 404, NULL, 'HIGH_NTase1', 258732),
(439639, 'PF19932', NULL, 'Family of unknown function (DUF6395)', 174, NULL, 'DUF6395', 258733),
(439640, 'PF06362', NULL, 'Protein of unknown function (DUF1067)', 97, NULL, 'DUF1067', 258734),
(439641, 'PF00494', NULL, 'Squalene/phytoene synthase', 263, NULL, 'SQS_PSY', 258735),
(439642, 'PF05614', NULL, 'Circovirus ORF3', 104, NULL, 'Circovir_ORF3', 258736),
(439643, 'PF05915', NULL, 'Transmembrane proteins 230/134', 119, NULL, 'TMEM_230_134', 258737),
(439644, 'PF08551', NULL, 'Eukaryotic integral membrane protein (DUF1751)', 99, NULL, 'DUF1751', 258738),
(439645, 'PF14634', NULL, 'zinc-RING finger domain', 44, NULL, 'zf-RING_5', 258739),
(439646, 'PF11479', NULL, 'RNA silencing suppressor P21 C-terminal domain', 80, NULL, 'Suppressor_P21', 258740),
(439647, 'PF12326', NULL, 'N-glycosylation protein', 175, NULL, 'EOS1', 258741),
(439648, 'PF08321', NULL, 'PPP5 TPR repeat region', 94, NULL, 'PPP5', 258742),
(439649, 'PF18352', NULL, 'Phage protein Gp138 N-terminal domain', 98, NULL, 'Gp138_N', 258743),
(439650, 'PF03545', NULL, 'Yersinia virulence determinant (YopE)', 70, NULL, 'YopE', 258744),
(439651, 'PF14254', NULL, 'Domain of unknown function (DUF4348)', 230, NULL, 'DUF4348', 258745),
(439652, 'PF09874', NULL, 'Predicted membrane protein (DUF2101)', 206, NULL, 'DUF2101', 258746),
(439653, 'PF14257', NULL, 'Domain of unknown function (DUF4349)', 213, NULL, 'DUF4349', 258747);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(439654, 'PF12676', NULL, 'Protein of unknown function (DUF3796)', 120, NULL, 'DUF3796', 258748),
(439655, 'PF01151', NULL, 'GNS1/SUR4 family', 242, NULL, 'ELO', 258749),
(439656, 'PF09341', NULL, 'Transcription factor Pcc1', 74, NULL, 'Pcc1', 258750),
(439657, 'PF16841', NULL, 'Ca-dependent carbohydrate-binding module xylan-binding', 93, NULL, 'CBM60', 258751),
(439658, 'PF19385', NULL, 'Family of unknown function (DUF5960)', 83, NULL, 'DUF5960', 258752),
(439659, 'PF03368', NULL, 'Dicer dimerisation domain', 90, NULL, 'Dicer_dimer', 258753),
(439660, 'PF16732', NULL, 'Type IV minor pilin ComP, DNA uptake sequence receptor', 87, NULL, 'ComP_DUS', 258754),
(439661, 'PF15543', NULL, 'Bacterial toxin 5', 135, NULL, 'Ntox5', 258755),
(439662, 'PF18240', NULL, 'Photosystem II Psb31 protein', 93, NULL, 'PSII_Pbs31', 258756),
(439663, 'PF03943', NULL, 'TAP C-terminal domain', 49, NULL, 'TAP_C', 258757),
(439664, 'PF03369', NULL, 'Herpesvirus UL3 protein', 135, NULL, 'Herpes_UL3', 258758),
(439665, 'PF00698', NULL, 'Acyl transferase domain', 319, NULL, 'Acyl_transf_1', 258759),
(439666, 'PF12659', NULL, 'Telomere capping C-terminal wHTH', 165, NULL, 'Stn1_C', 258760),
(439667, 'PF16508', NULL, 'Second BRCT domain on Nijmegen syndrome breakage protein', 123, NULL, 'NIBRIN_BRCT_II', 258761),
(439668, 'PF00476', NULL, 'DNA polymerase family A', 377, NULL, 'DNA_pol_A', 258762),
(439669, 'PF14479', NULL, 'Prion-inhibition and propagation', 206, NULL, 'HeLo', 258763),
(439670, 'PF05859', NULL, 'Mis12 protein', 143, NULL, 'Mis12', 258764),
(439671, 'PF16500', NULL, 'Cyclin-A N-terminal APC/C binding region', 117, NULL, 'Cyclin_N2', 258765),
(439672, 'PF11094', NULL, 'Membrane-associated tegument protein', 39, NULL, 'UL11', 258766),
(439673, 'PF09818', NULL, 'ATPase of the ABC class', 283, NULL, 'ABC_ATPase', 258767),
(439674, 'PF16630', NULL, 'Unstructured region on APC between 1st and 2nd catenin-bdg motifs', 100, NULL, 'APC_u5', 258768),
(439675, 'PF16941', NULL, 'Putative cyclodextrin porin', 341, NULL, 'CymA', 258769),
(439676, 'PF16943', NULL, 'Cag pathogenicity island, type IV secretory system', 107, NULL, 'T4SS_CagC', 258770),
(439677, 'PF17499', NULL, 'Ant venom peptides', 74, NULL, 'Pilosulin', 258771),
(439678, 'PF00781', NULL, 'Diacylglycerol kinase catalytic domain', 127, NULL, 'DAGK_cat', 258772),
(439679, 'PF17344', NULL, 'Family of unknown function (DUF5374)', 40, NULL, 'DUF5374', 258773),
(439680, 'PF06284', NULL, 'Cytomegalovirus UL84 protein', 586, NULL, 'Cytomega_UL84', 258774),
(439681, 'PF14073', NULL, 'Centrosome localisation domain of Cep57', 178, NULL, 'Cep57_CLD', 258775),
(439682, 'PF02607', NULL, 'B12 binding domain', 75, NULL, 'B12-binding_2', 258776),
(439683, 'PF04813', NULL, 'Hepatocyte nuclear factor 1 (HNF-1), alpha isoform C terminus', 88, NULL, 'HNF-1A_C', 258777),
(439684, 'PF14707', NULL, 'C-terminal region of aryl-sulfatase', 124, NULL, 'Sulfatase_C', 258778),
(439685, 'PF12775', NULL, 'P-loop containing dynein motor region', 181, NULL, 'AAA_7', 258779),
(439686, 'PF03089', NULL, 'Recombination activating protein 2', 339, NULL, 'RAG2', 258780),
(439687, 'PF01740', NULL, 'STAS domain', 117, NULL, 'STAS', 258781),
(439688, 'PF06044', NULL, 'Dam-replacing family', 183, NULL, 'DpnI', 258782),
(439689, 'PF12315', NULL, 'Protein DA1', 215, NULL, 'DA1-like', 258783),
(439690, 'PF01292', NULL, 'Prokaryotic cytochrome b561', 182, NULL, 'Ni_hydr_CYTB', 258784),
(439691, 'PF16218', NULL, 'Peptidase family C101', 265, NULL, 'Peptidase_C101', 258785),
(439692, 'PF09546', NULL, 'Stage III sporulation protein AE (spore_III_AE)', 321, NULL, 'Spore_III_AE', 258786),
(439693, 'PF18915', NULL, 'Domain of unknown function (DUF5667)', 102, NULL, 'DUF5667', 258787),
(439694, 'PF19251', NULL, 'Family of unknown function (DUF5899)', 139, NULL, 'DUF5899', 258788),
(439695, 'PF17904', NULL, 'FMRP KH0 domain', 85, NULL, 'KH_9', 258789),
(439696, 'PF19800', NULL, 'Family of unknown function (DUF6283)', 115, NULL, 'DUF6283', 258790),
(439697, 'PF05014', NULL, 'Nucleoside 2-deoxyribosyltransferase', 118, NULL, 'Nuc_deoxyrib_tr', 258791);
INSERT INTO "PUBLIC"."MODEL" VALUES
(439698, 'PF17915', NULL, 'Reverse gyrase zinc finger', 49, NULL, 'zf_Rg', 258792),
(439699, 'PF01004', NULL, 'Flavivirus envelope glycoprotein M', 74, NULL, 'Flavi_M', 258793),
(439700, 'PF16407', NULL, 'PKD-like family', 157, NULL, 'PKD_2', 258794),
(439701, 'PF17944', NULL, 'Arginine decarboxylase C-terminal helical extension', 51, NULL, 'Arg_decarbox_C', 258795),
(439702, 'PF13141', NULL, 'Protein of unknown function (DUF3979)', 115, NULL, 'DUF3979', 258796),
(439703, 'PF17360', NULL, 'Family of unknown function (DUF5386)', 170, NULL, 'DUF5386', 258797),
(439704, 'PF14041', NULL, 'LppP/LprE lipoprotein', 88, NULL, 'Lipoprotein_21', 258798),
(439705, 'PF05699', NULL, 'hAT family C-terminal dimerisation region', 86, NULL, 'Dimer_Tnp_hAT', 258799),
(439706, 'PF14682', NULL, 'Sporulation initiation phospho-transferase B, C-terminal', 113, NULL, 'SPOB_ab', 258800),
(439707, 'PF19622', NULL, 'Family of unknown function (DUF6127)', 79, NULL, 'DUF6127', 258801),
(439708, 'PF08877', NULL, 'MepB-like', 122, NULL, 'MepB-like', 258802),
(439709, 'PF15128', NULL, 'T-cell leukemia translocation-altered', 92, NULL, 'T_cell_tran_alt', 258803),
(439710, 'PF19948', NULL, 'Family of unknown function (DUF6410)', 198, NULL, 'DUF6410', 258804),
(439711, 'PF07734', NULL, 'F-box associated', 164, NULL, 'FBA_1', 258805),
(439712, 'PF03112', NULL, 'Uncharacterized protein family (ORF7) DUF', 161, NULL, 'DUF244', 258806),
(439713, 'PF13321', NULL, 'Domain of unknown function (DUF4084)', 304, NULL, 'DUF4084', 258807),
(439714, 'PF12226', NULL, 'Turkey astrovirus capsid protein', 363, NULL, 'Astro_capsid_p', 258808),
(439715, 'PF05226', NULL, 'CHASE2 domain', 249, NULL, 'CHASE2', 258809),
(439716, 'PF19751', NULL, 'Family of unknown function (DUF6238)', 152, NULL, 'DUF6238', 258810),
(439717, 'PF00021', NULL, 'u-PAR/Ly-6 domain', 77, NULL, 'UPAR_LY6', 258811),
(439718, 'PF17284', NULL, 'Spermidine synthase tetramerisation domain', 53, NULL, 'Spermine_synt_N', 258812),
(439719, 'PF16874', NULL, 'Glycosyl hydrolase family 36 C-terminal domain', 77, NULL, 'Glyco_hydro_36C', 258813),
(439720, 'PF17783', NULL, 'CvfB-like winged helix domain', 58, NULL, 'CvfB_WH', 258814),
(439721, 'PF06059', NULL, 'Domain of Unknown Function (DUF930)', 99, NULL, 'DUF930', 258815),
(439722, 'PF01769', NULL, 'Divalent cation transporter', 120, NULL, 'MgtE', 258816),
(439723, 'PF17931', NULL, 'Tetracyclin repressor-like, C-terminal domain', 127, NULL, 'TetR_C_23', 258817),
(439724, 'PF07456', NULL, 'Heptaprenyl diphosphate synthase component I', 147, NULL, 'Hpre_diP_synt_I', 258818),
(439725, 'PF19195', NULL, 'Family of unknown function (DUF5870)', 488, NULL, 'DUF5870', 258819),
(439726, 'PF11553', NULL, 'Protein of unknown function (DUF3231)', 165, NULL, 'DUF3231', 258820),
(439727, 'PF06745', NULL, 'KaiC', 231, NULL, 'ATPase', 258821),
(439728, 'PF18232', NULL, 'Chalcone isomerase N-terminal domain', 102, NULL, 'Chalcone_N', 258822),
(439729, 'PF17490', NULL, 'L1 transposable element dsRBD-like domain', 65, NULL, 'Tnp_22_dsRBD', 258823),
(439730, 'PF13274', NULL, 'Protein of unknown function (DUF4065)', 114, NULL, 'DUF4065', 258824),
(439731, 'PF05289', NULL, 'Borrelia hemolysin accessory protein', 120, NULL, 'BLYB', 258825),
(439732, 'PF05408', NULL, 'Foot-and-mouth virus L-proteinase', 201, NULL, 'Peptidase_C28', 258826),
(439733, 'PF04992', NULL, 'RNA polymerase Rpb1, domain 6', 189, NULL, 'RNA_pol_Rpb1_6', 258827),
(439734, 'PF17587', NULL, 'Discriminator of mRNA degradation', 60, NULL, 'Dmd', 258828),
(439735, 'PF13720', NULL, 'Udp N-acetylglucosamine O-acyltransferase; Domain 2', 82, NULL, 'Acetyltransf_11', 258829),
(439736, 'PF12241', NULL, 'Trans-2-enoyl-CoA reductase catalytic region', 236, NULL, 'Enoyl_reductase', 258830),
(439737, 'PF07768', NULL, 'PVL ORF-50-like family', 116, NULL, 'PVL_ORF50', 258831),
(439738, 'PF19412', NULL, 'Domain of unknown function (DUF5982)', 64, NULL, 'DUF5982', 258832),
(439739, 'PF12252', NULL, 'SidE phosphodiesterase (PDE) domain', 233, NULL, 'SidE_PDE', 258833),
(439740, 'PF00118', NULL, 'TCP-1/cpn60 chaperonin family', 491, NULL, 'Cpn60_TCP1', 258834);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(439741, 'PF09135', NULL, 'Alb1', 106, NULL, 'Alb1', 258835),
(439742, 'PF12024', NULL, 'Domain of unknown function (DUF3512)', 186, NULL, 'DUF3512', 258836),
(439743, 'PF03468', NULL, 'XS domain', 113, NULL, 'XS', 258837),
(439744, 'PF15007', NULL, 'Centrosomal spindle body, CEP44', 126, NULL, 'CEP44', 258838),
(439745, 'PF04731', NULL, 'Caudal like protein activation region', 136, NULL, 'Caudal_act', 258839),
(439746, 'PF04809', NULL, 'HupH hydrogenase expression protein, C-terminal conserved region', 118, NULL, 'HupH_C', 258840),
(439747, 'PF15421', NULL, 'Putative polysaccharide deacetylase', 423, NULL, 'Polysacc_deac_3', 258841),
(439748, 'PF08392', NULL, 'FAE1/Type III polyketide synthase-like protein', 290, NULL, 'FAE1_CUT1_RppA', 258842),
(439749, 'PF02511', NULL, 'Thymidylate synthase complementing protein', 191, NULL, 'Thy1', 258843),
(439750, 'PF09214', NULL, 'Bacteriophage Prd1, adsorption protein P2', 555, NULL, 'Prd1-P2', 258844),
(439751, 'PF09498', NULL, 'Protein of unknown function (DUF2388)', 70, NULL, 'DUF2388', 258845),
(439752, 'PF06505', NULL, 'Activator of aromatic catabolism', 101, NULL, 'XylR_N', 258846),
(439753, 'PF18398', NULL, 'Clip-domain serine protease homolog masquerade', 33, NULL, 'CLIP_SPH_mas', 258847),
(439754, 'PF00506', NULL, 'Influenza virus nucleoprotein', 520, NULL, 'Flu_NP', 258848),
(439755, 'PF03895', NULL, 'YadA-like membrane anchor domain', 60, NULL, 'YadA_anchor', 258849),
(439756, 'PF04637', NULL, 'Herpesvirus phosphoprotein 85 (HHV6-7 U14/HCMV UL25)', 524, NULL, 'Herpes_pp85', 258850),
(439757, 'PF19491', NULL, 'Family of unknown function (DUF6026)', 51, NULL, 'DUF6026', 258851),
(439758, 'PF08724', NULL, 'Rep protein catalytic domain like', 186, NULL, 'Rep_N', 258852),
(439759, 'PF01554', NULL, 'MatE', 161, NULL, 'MatE', 258853),
(439760, 'PF12028', NULL, 'Protein of unknown function (DUF3515)', 158, NULL, 'DUF3515', 258854),
(439761, 'PF14568', NULL, 'SMI1-KNR4 cell-wall', 122, NULL, 'SUKH_6', 258855),
(439762, 'PF17151', NULL, 'Periplasmic sensor domain', 187, NULL, 'CHASE7', 258856),
(439763, 'PF12797', NULL, '4Fe-4S binding domain', 22, NULL, 'Fer4_2', 258857),
(439764, 'PF13408', NULL, 'Recombinase zinc beta ribbon domain', 58, NULL, 'Zn_ribbon_recom', 258858),
(439765, 'PF16647', NULL, 'Granulocyte colony-stimulating factor', 149, NULL, 'GCSF', 258859),
(439766, 'PF12421', NULL, 'Fibronectin type III protein', 133, NULL, 'DUF3672', 258860),
(439767, 'PF18635', NULL, 'Epithelial cell adhesion molecule N-terminal domain', 33, NULL, 'EpCAM_N', 258861),
(439768, 'PF20280', NULL, 'C-terminal domain 4 of the ABC-three component (ABC-3C) systems', 218, NULL, 'CTD4', 258862),
(439769, 'PF02821', NULL, 'Staphylokinase/Streptokinase family', 112, NULL, 'Staphylokinase', 258863),
(439770, 'PF20269', NULL, 'CASPASE and TPR Repeat-Associated N-terminal domain', 204, NULL, 'CATRA-N', 258864),
(439771, 'PF16494', NULL, 'C-terminal extension of sodium/calcium exchanger domain', 134, NULL, 'Na_Ca_ex_C', 258865),
(439772, 'PF05278', NULL, 'Arabidopsis phospholipase-like protein (PEARLI 4)', 269, NULL, 'PEARLI-4', 258866),
(439773, 'PF07272', NULL, 'Orthoreovirus P17 protein', 146, NULL, 'Orthoreo_P17', 258867),
(439774, 'PF09448', NULL, 'Methylmuconolactone methyl-isomerase', 109, NULL, 'MmlI', 258868),
(439775, 'PF18583', NULL, 'Aminoarabinose transferase C-terminal domain', 103, NULL, 'Arnt_C', 258869),
(439776, 'PF15298', NULL, 'AJAP1/PANP C-terminus', 204, NULL, 'AJAP1_PANP_C', 258870),
(439777, 'PF17871', NULL, 'AAA lid domain', 104, NULL, 'AAA_lid_9', 258871),
(439778, 'PF00443', NULL, 'Ubiquitin carboxyl-terminal hydrolase', 278, NULL, 'UCH', 258872),
(439779, 'PF09801', NULL, 'Integral membrane protein S linking to the trans Golgi network', 144, NULL, 'SYS1', 258873),
(439780, 'PF04728', NULL, 'Lipoprotein leucine-zipper', 53, NULL, 'LPP', 258874),
(439781, 'PF18651', NULL, 'Surface adhesin CshA non-repetitive domain 2', 269, NULL, 'CshA_NR2', 258875),
(439782, 'PF06419', NULL, 'Conserved oligomeric complex COG6', 626, NULL, 'COG6', 258876);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(439783, 'PF12723', NULL, 'Protein of unknown function (DUF3809)', 137, NULL, 'DUF3809', 258877),
(439784, 'PF05811', NULL, 'Eukaryotic protein of unknown function (DUF842)', 131, NULL, 'DUF842', 258878),
(439785, 'PF01503', NULL, 'Phosphoribosyl-ATP pyrophosphohydrolase', 83, NULL, 'PRA-PH', 258879),
(439786, 'PF08294', NULL, 'TIM21', 145, NULL, 'TIM21', 258880),
(439787, 'PF14946', NULL, 'Domain of unknown function (DUF4501)', 179, NULL, 'DUF4501', 258881),
(439788, 'PF09954', NULL, 'Uncharacterized protein conserved in bacteria (DUF2188)', 62, NULL, 'DUF2188', 258882),
(439789, 'PF17804', NULL, 'Tail specific protease N-terminal domain', 189, NULL, 'TSP_NTD', 258883),
(439790, 'PF11242', NULL, 'Protein of unknown function (DUF2774)', 63, NULL, 'DUF2774', 258884),
(439791, 'PF07692', NULL, 'Low iron-inducible periplasmic protein', 359, NULL, 'Fea1', 258885),
(439792, 'PF12796', NULL, 'Ankyrin repeats (3 copies)', 83, NULL, 'Ank_2', 258886),
(439793, 'PF10658', NULL, 'Protein of unknown function (DUF2484)', 76, NULL, 'DUF2484', 258887),
(439794, 'PF15130', NULL, 'Domain of unknown function (DUF4566)', 226, NULL, 'DUF4566', 258888),
(439795, 'PF05825', NULL, 'Beta-microseminoprotein (PSP-94)', 94, NULL, 'PSP94', 258889),
(439796, 'PF07822', NULL, 'Neurotoxin B-IV-like protein', 55, NULL, 'Toxin_13', 258890),
(439797, 'PF12477', NULL, 'Sex factor F TraW protein N terminal', 30, NULL, 'TraW_N', 258891),
(439798, 'PF07791', NULL, 'Protein of unknown function (DUF1629)', 123, NULL, 'DUF1629', 258892),
(439799, 'PF12522', NULL, 'Cytomegalovirus glycoprotein N terminal', 27, NULL, 'UL73_N', 258893),
(439800, 'PF16007', NULL, 'Domain of unknown function (DUF4777)', 66, NULL, 'DUF4777', 258894),
(439801, 'PF02937', NULL, 'Cytochrome c oxidase subunit VIc', 70, NULL, 'COX6C', 258895),
(439802, 'PF09013', NULL, 'YopH, N-terminal', 121, NULL, 'YopH_N', 258896),
(439803, 'PF11318', NULL, 'Protein of unknown function (DUF3120)', 199, NULL, 'DUF3120', 258897),
(439804, 'PF06089', NULL, 'L-asparaginase II', 322, NULL, 'Asparaginase_II', 258898),
(439805, 'PF02752', NULL, 'Arrestin (or S-antigen), C-terminal domain', 136, NULL, 'Arrestin_C', 258899),
(439806, 'PF19672', NULL, 'Family of unknown function (DUF6175)', 287, NULL, 'DUF6175', 258900),
(439807, 'PF10374', NULL, 'Telomerase activating protein Est1', 135, NULL, 'EST1', 258901),
(439808, 'PF18197', NULL, 'Domain of unknown function (DUF5602)', 52, NULL, 'DUF5602', 258902),
(439809, 'PF14904', NULL, 'Family of unknown function', 94, NULL, 'FAM86', 258903),
(439810, 'PF19045', NULL, 'Ligase-CoA domain', 162, NULL, 'Ligase_CoA_2', 258904),
(439811, 'PF00109', NULL, 'Beta-ketoacyl synthase, N-terminal domain', 253, NULL, 'ketoacyl-synt', 258905),
(439812, 'PF08147', NULL, 'DBP10CT (NUC160) domain', 67, NULL, 'DBP10CT', 258906),
(439813, 'PF09911', NULL, 'Uncharacterized protein conserved in bacteria (DUF2140)', 187, NULL, 'DUF2140', 258907),
(439814, 'PF12508', NULL, 'Conjugative transposon, TraM', 194, NULL, 'Transposon_TraM', 258908),
(439815, 'PF20291', NULL, 'ABC-three component (ABC-3C) system Middle Component 5', 167, NULL, 'MC5', 258909),
(439816, 'PF05127', NULL, 'Helicase', 177, NULL, 'Helicase_RecD', 258910),
(439817, 'PF08465', NULL, 'Thymidine kinase from Herpesvirus C-terminal', 33, NULL, 'Herpes_TK_C', 258911),
(439818, 'PF14970', NULL, 'Tubulin epsilon and delta complex protein 1', 165, NULL, 'TEDC1', 258912),
(439819, 'PF00376', NULL, 'MerR family regulatory protein', 38, NULL, 'MerR', 258913),
(439820, 'PF17034', NULL, 'Zinc-ribbon like family', 125, NULL, 'zinc_ribbon_16', 258914),
(439821, 'PF09170', NULL, 'CST, complex subunit STN1, C terminal', 167, NULL, 'STN1_2', 258915),
(439822, 'PF11128', NULL, 'Plant viral coat protein nucleocapsid', 179, NULL, 'Nucleocap_ssRNA', 258916),
(439823, 'PF14186', NULL, 'Axin interactor dorsalisation-associated protein, C-terminal', 146, NULL, 'Aida_C2', 258917),
(439824, 'PF10333', NULL, 'GPI-Mannosyltransferase II co-activator', 175, NULL, 'Pga1', 258918),
(439825, 'PF04026', NULL, 'SpoVG', 82, NULL, 'SpoVG', 258919);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(439826, 'PF03903', NULL, 'Phage T4 tail fibre', 131, NULL, 'Phage_T4_gp36', 258920),
(439827, 'PF08879', NULL, 'WRC', 43, NULL, 'WRC', 258921),
(439828, 'PF10103', NULL, 'Zincin-like metallopeptidase', 332, NULL, 'Zincin_2', 258922),
(439829, 'PF02033', NULL, 'Ribosome-binding factor A', 105, NULL, 'RBFA', 258923),
(439830, 'PF06868', NULL, 'Protein of unknown function (DUF1257)', 104, NULL, 'DUF1257', 258924),
(439831, 'PF17697', NULL, 'Family of unknown function (DUF5543)', 118, NULL, 'DUF5543', 258925),
(439832, 'PF12856', NULL, 'Anaphase-promoting complex subunit 9', 119, NULL, 'ANAPC9', 258926),
(439833, 'PF11867', NULL, 'Domain of unknown function (DUF3387)', 331, NULL, 'DUF3387', 258927),
(439834, 'PF16120', NULL, 'Domain of unknown function (DUF4836)', 481, NULL, 'DUF4836', 258928),
(439835, 'PF11512', NULL, 'Agrobacterium tumefaciens protein Atu4866', 75, NULL, 'Atu4866', 258929),
(439836, 'PF10997', NULL, 'Alternate to MurJ', 253, NULL, 'Amj', 258930),
(439837, 'PF16715', NULL, 'Cyclodipeptide synthase', 220, NULL, 'CDPS', 258931),
(439838, 'PF19307', NULL, 'Phage capsid-like protein', 254, NULL, 'PCLP', 258932),
(439839, 'PF01272', NULL, 'Transcription elongation factor, GreA/GreB, C-term', 77, NULL, 'GreA_GreB', 258933),
(439840, 'PF19982', NULL, 'Family of unknown function (DUF6418)', 109, NULL, 'DUF6418', 258934),
(439841, 'PF13136', NULL, 'Protein of unknown function (DUF3984)', 329, NULL, 'DUF3984', 258935),
(439842, 'PF19815', NULL, 'Family of unknown function (DUF6298)', 487, NULL, 'DUF6298', 258936),
(439843, 'PF01841', NULL, 'Transglutaminase-like superfamily', 112, NULL, 'Transglut_core', 258937),
(439844, 'PF12335', NULL, 'Myotubularin protein', 227, NULL, 'SBF2', 258938),
(439845, 'PF09983', NULL, 'Uncharacterized protein conserved in bacteria C-term(DUF2220)', 181, NULL, 'DUF2220', 258939),
(439846, 'PF15957', NULL, 'Commissureless', 118, NULL, 'Comm', 258940),
(439847, 'PF15181', NULL, 'Spermatid-specific manchette-related protein 1', 262, NULL, 'SMRP1', 258941),
(439848, 'PF18676', NULL, 'MBG domain (YGX type)', 72, NULL, 'MBG_2', 258942),
(439849, 'PF10948', NULL, 'Protein of unknown function (DUF2635)', 46, NULL, 'DUF2635', 258943),
(439850, 'PF03387', NULL, 'Herpesvirus UL46 protein', 435, NULL, 'Herpes_UL46', 258944),
(439851, 'PF14554', NULL, 'VEGF heparin-binding domain', 58, NULL, 'VEGF_C', 258945),
(439852, 'PF01991', NULL, 'ATP synthase (E/31 kDa) subunit', 199, NULL, 'vATP-synt_E', 258946),
(439853, 'PF20119', NULL, 'Family of unknown function (DUF6509)', 95, NULL, 'DUF6509', 258947),
(439854, 'PF08412', NULL, 'Ion transport protein N-terminal', 44, NULL, 'Ion_trans_N', 258948),
(439855, 'PF11448', NULL, 'Protein of unknown function (DUF3005)', 124, NULL, 'DUF3005', 258949),
(439856, 'PF01502', NULL, 'Phosphoribosyl-AMP cyclohydrolase', 74, NULL, 'PRA-CH', 258950),
(439857, 'PF13497', NULL, 'Domain of unknown function (DUF4121)', 264, NULL, 'DUF4121', 258951),
(439858, 'PF05562', NULL, 'Cold acclimation protein WCOR413', 183, NULL, 'WCOR413', 258952),
(439859, 'PF15085', NULL, 'Neuropeptide FF', 109, NULL, 'NPFF', 258953),
(439860, 'PF07020', NULL, 'Orthopoxvirus C10L protein', 79, NULL, 'Orthopox_C10L', 258954),
(439861, 'PF09751', NULL, 'Nuclear protein Es2', 429, NULL, 'Es2', 258955),
(439862, 'PF14035', NULL, 'YlzJ-like protein', 65, NULL, 'YlzJ', 258956),
(439863, 'PF18893', NULL, 'Family of unknown function (DUF5652)', 71, NULL, 'DUF5652', 258957),
(439864, 'PF02775', NULL, 'Thiamine pyrophosphate enzyme, C-terminal TPP binding domain', 153, NULL, 'TPP_enzyme_C', 258958),
(439865, 'PF05797', NULL, 'Yeast trans-acting factor (REP1/REP2)', 344, NULL, 'Rep_4', 258959),
(439866, 'PF08853', NULL, 'Domain of unknown function (DUF1823)', 113, NULL, 'DUF1823', 258960),
(439867, 'PF14298', NULL, 'Domain of unknown function (DUF4374)', 437, NULL, 'DUF4374', 258961),
(439868, 'PF18509', NULL, 'Magnetochrome domain', 30, NULL, 'MCR', 258962),
(439869, 'PF09892', NULL, 'Uncharacterized protein conserved in archaea (DUF2119)', 188, NULL, 'DUF2119', 258963),
(439870, 'PF13704', NULL, 'Glycosyl transferase family 2', 96, NULL, 'Glyco_tranf_2_4', 258964);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(439871, 'PF11025', NULL, 'Glycoprotein GP40 of Cryptosporidium', 164, NULL, 'GP40', 258965),
(439872, 'PF16944', NULL, 'Fungal potassium channel', 250, NULL, 'KCH', 258966),
(439873, 'PF14164', NULL, 'YqzH-like protein', 64, NULL, 'YqzH', 258967),
(439874, 'PF00817', NULL, 'impB/mucB/samB family', 151, NULL, 'IMS', 258968),
(439875, 'PF11122', NULL, 'Inner spore coat protein D', 99, NULL, 'Spore-coat_CotD', 258969),
(439876, 'PF12266', NULL, 'Protein of unknown function (DUF3613)', 66, NULL, 'DUF3613', 258970),
(439877, 'PF14373', NULL, 'Superinfection immunity protein', 42, NULL, 'Imm_superinfect', 258971),
(439878, 'PF12836', NULL, 'Helix-hairpin-helix motif', 65, NULL, 'HHH_3', 258972),
(439879, 'PF01249', NULL, 'Ribosomal protein S21e', 79, NULL, 'Ribosomal_S21e', 258973),
(439880, 'PF14193', NULL, 'Domain of unknown function (DUF4315)', 81, NULL, 'DUF4315', 258974),
(439881, 'PF01199', NULL, 'Ribosomal protein L34e', 94, NULL, 'Ribosomal_L34e', 258975),
(439882, 'PF04218', NULL, 'CENP-B N-terminal DNA-binding domain', 53, NULL, 'CENP-B_N', 258976),
(439883, 'PF01773', NULL, 'Na+ dependent nucleoside transporter N-terminus', 74, NULL, 'Nucleos_tra2_N', 258977),
(439884, 'PF05790', NULL, 'Immunoglobulin C2-set domain', 80, NULL, 'C2-set', 258978),
(439885, 'PF08259', NULL, 'Periviscerokinin family', 11, NULL, 'Periviscerokin', 258979),
(439886, 'PF10412', NULL, 'Type IV secretion-system coupling protein DNA-binding domain', 387, NULL, 'TrwB_AAD_bind', 258980),
(439887, 'PF11215', NULL, 'Protein of unknown function (DUF3010)', 137, NULL, 'DUF3010', 258981),
(439888, 'PF05975', NULL, 'Bacterial ABC transporter protein EcsB', 383, NULL, 'EcsB', 258982),
(439889, 'PF11569', NULL, 'Homeodomain leucine-zipper encoding, Homez', 57, NULL, 'Homez', 258983),
(439890, 'PF00197', NULL, 'Trypsin and protease inhibitor', 175, NULL, 'Kunitz_legume', 258984),
(439891, 'PF17298', NULL, 'Family of unknown function (DUF5349)', 362, NULL, 'DUF5349', 258985),
(439892, 'PF07989', NULL, 'Centrosomin N-terminal motif 1', 73, NULL, 'Cnn_1N', 258986),
(439893, 'PF14020', NULL, 'Protein of unknown function (DUF4236)', 55, NULL, 'DUF4236', 258987),
(439894, 'PF05866', NULL, 'Endodeoxyribonuclease RusA', 126, NULL, 'RusA', 258988),
(439895, 'PF15022', NULL, 'Protein of unknown function (DUF4522)', 117, NULL, 'DUF4522', 258989),
(439896, 'PF16324', NULL, 'Domain of unknown function (DUF4960)', 250, NULL, 'DUF4960', 258990),
(439897, 'PF09551', NULL, 'Stage II sporulation protein R (spore_II_R)', 128, NULL, 'Spore_II_R', 258991),
(439898, 'PF18763', NULL, 'ddrB-like ParB superfamily domain', 124, NULL, 'ddrB-ParB', 258992),
(439899, 'PF19462', NULL, 'Family of unknown function (DUF5999)', 57, NULL, 'DUF5999', 258993),
(439900, 'PF12187', NULL, 'Viral/Archaeal nuclease', 190, NULL, 'VirArc_Nuclease', 258994),
(439901, 'PF12684', NULL, 'PDDEXK-like domain of unknown function (DUF3799)', 232, NULL, 'DUF3799', 258995),
(439902, 'PF11471', NULL, 'Maltoporin periplasmic N-terminal extension', 31, NULL, 'Sugarporin_N', 258996),
(439903, 'PF06707', NULL, 'Protein of unknown function (DUF1194)', 206, NULL, 'DUF1194', 258997),
(439904, 'PF12932', NULL, 'Vesicle coat trafficking protein Sec16 mid-region', 118, NULL, 'Sec16', 258998),
(439905, 'PF17946', NULL, 'RecC C-terminal domain', 202, NULL, 'RecC_C', 258999),
(439906, 'PF20617', NULL, 'Family of unknown function (DUF6803)', 162, NULL, 'DUF6803', 259000),
(439907, 'PF03222', NULL, 'Tryptophan/tyrosine permease family', 394, NULL, 'Trp_Tyr_perm', 259001),
(439908, 'PF08508', NULL, 'Fungal domain of unknown function (DUF1746)', 115, NULL, 'DUF1746', 259002),
(439909, 'PF07434', NULL, 'CblD like pilus biogenesis initiator', 293, NULL, 'CblD', 259003),
(439910, 'PF15293', NULL, 'Nuclear fragile X mental retardation-interacting protein 2', 596, NULL, 'NUFIP2', 259004),
(439911, 'PF02544', NULL, '3-oxo-5-alpha-steroid 4-dehydrogenase', 150, NULL, 'Steroid_dh', 259005),
(439912, 'PF02588', NULL, 'Uncharacterised 5xTM membrane BCR, YitT family COG1284', 206, NULL, 'YitT_membrane', 259006);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(439913, 'PF09141', NULL, 'Talin, middle domain', 161, NULL, 'Talin_middle', 259007),
(439914, 'PF17768', NULL, 'RecJ OB domain', 108, NULL, 'RecJ_OB', 259008),
(439915, 'PF13619', NULL, 'KTSC domain', 58, NULL, 'KTSC', 259009),
(439916, 'PF16553', NULL, 'BCORL-PCGF1-binding domain', 114, NULL, 'PUFD', 259010),
(439917, 'PF13405', NULL, 'EF-hand domain', 31, NULL, 'EF-hand_6', 259011),
(439918, 'PF14560', NULL, 'Ubiquitin-like domain', 87, NULL, 'Ubiquitin_2', 259012),
(439919, 'PF18211', NULL, 'Csm1 subunit domain B', 94, NULL, 'Csm1_B', 259013),
(439920, 'PF05301', NULL, 'GNAT acetyltransferase, Mec-17', 173, NULL, 'Acetyltransf_16', 259014),
(439921, 'PF17744', NULL, 'Family of unknown function (DUF5581)', 312, NULL, 'DUF5581', 259015),
(439922, 'PF19103', NULL, 'Family of unknown function (DUF5790)', 126, NULL, 'DUF5790', 259016),
(439923, 'PF06816', NULL, 'NOTCH protein', 56, NULL, 'NOD', 259017),
(439924, 'PF05432', NULL, 'Bone sialoprotein II (BSP-II)', 299, NULL, 'BSP_II', 259018),
(439925, 'PF09113', NULL, 'Peptide-N-glycosidase F, C terminal', 136, NULL, 'N-glycanase_C', 259019),
(439926, 'PF12838', NULL, '4Fe-4S dicluster domain', 52, NULL, 'Fer4_7', 259020),
(439927, 'PF14654', NULL, 'Mucin, catalytic, TM and cytoplasmic tail region', 91, NULL, 'Epiglycanin_C', 259021),
(439928, 'PF02411', NULL, 'MerT mercuric transport protein', 116, NULL, 'MerT', 259022),
(439929, 'PF18460', NULL, 'Heterocyst differentiation regulator C-terminal Hood domain', 79, NULL, 'HetR_C', 259023),
(439930, 'PF00956', NULL, 'Nucleosome assembly protein (NAP)', 272, NULL, 'NAP', 259024),
(439931, 'PF17936', NULL, 'Bacterial Ig domain', 83, NULL, 'Big_6', 259025),
(439932, 'PF04736', NULL, 'Eclosion hormone', 61, NULL, 'Eclosion', 259026),
(439933, 'PF05238', NULL, 'Kinetochore protein CHL4 like', 415, NULL, 'CENP-N', 259027),
(439934, 'PF08479', NULL, 'POTRA domain, ShlB-type', 76, NULL, 'POTRA_2', 259028),
(439935, 'PF00054', NULL, 'Laminin G domain', 131, NULL, 'Laminin_G_1', 259029),
(439936, 'PF14744', NULL, 'WASH complex subunit 7', 346, NULL, 'WASH-7_mid', 259030),
(439937, 'PF14349', NULL, 'Motility related/secretion protein', 508, NULL, 'SprA_N', 259031),
(439938, 'PF07209', NULL, 'Protein of unknown function (DUF1415)', 171, NULL, 'DUF1415', 259032),
(439939, 'PF00567', NULL, 'Tudor domain', 122, NULL, 'TUDOR', 259033),
(439940, 'PF17406', NULL, 'Nrap protein PAP/OAS1-like domain 5', 162, NULL, 'Nrap_D5', 259034),
(439941, 'PF01768', NULL, 'Birnavirus VP4 protein', 259, NULL, 'Birna_VP4', 259035),
(439942, 'PF17606', NULL, 'Family of unknown function (DUF5502)', 87, NULL, 'DUF5502', 259036),
(439943, 'PF13629', NULL, 'Pilus formation protein N terminal region', 72, NULL, 'T2SS-T3SS_pil_N', 259037),
(439944, 'PF09488', NULL, 'Mannosyl-3-phosphoglycerate synthase (osmo_MPGsynth)', 388, NULL, 'Osmo_MPGsynth', 259038),
(439945, 'PF10164', NULL, 'Brain protein I3', 106, NULL, 'BRI3', 259039),
(439946, 'PF10280', NULL, 'Mediator complex protein', 137, NULL, 'Med11', 259040),
(439947, 'PF06873', NULL, 'Cell surface immobilisation antigen SerH', 417, NULL, 'SerH', 259041),
(439948, 'PF12751', NULL, 'Vacuolar segregation subunit 7', 379, NULL, 'Vac7', 259042),
(439949, 'PF03268', NULL, 'Caenorhabditis protein of unknown function, DUF267', 360, NULL, 'DUF267', 259043),
(439950, 'PF15517', NULL, 'TBP-interacting protein N-terminus', 100, NULL, 'TBPIP_N', 259044),
(439951, 'PF03196', NULL, 'Protein of unknown function, DUF261', 137, NULL, 'DUF261', 259045),
(439952, 'PF01324', NULL, 'Diphtheria toxin, R domain', 154, NULL, 'Diphtheria_R', 259046),
(439953, 'PF08416', NULL, 'Phosphotyrosine-binding domain', 131, NULL, 'PTB', 259047),
(439954, 'PF13541', NULL, 'Subunit ChlI of Mg-chelatase', 121, NULL, 'ChlI', 259048),
(439955, 'PF14111', NULL, 'Domain of unknown function (DUF4283)', 145, NULL, 'DUF4283', 259049),
(439956, 'PF15460', NULL, 'Something about silencing, SAS, complex subunit 4', 99, NULL, 'SAS4', 259050),
(439957, 'PF06916', NULL, 'FAM210A/B-like domain', 92, NULL, 'FAM210A-B_dom', 259051),
(439958, 'PF19489', NULL, 'Transglycosylase SLT domain', 184, NULL, 'SLT_4', 259052);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(439959, 'PF07930', NULL, 'D-aminopeptidase, domain B', 182, NULL, 'DAP_B', 259053),
(439960, 'PF14340', NULL, 'Domain of unknown function (DUF4395)', 130, NULL, 'DUF4395', 259054),
(439961, 'PF01520', NULL, 'N-acetylmuramoyl-L-alanine amidase', 174, NULL, 'Amidase_3', 259055),
(439962, 'PF10434', NULL, 'Monopolin complex protein MAM1', 268, NULL, 'MAM1', 259056),
(439963, 'PF12779', NULL, 'WXXGXW repeat (2 copies)', 26, NULL, 'WXXGXW', 259057),
(439964, 'PF10292', NULL, 'Serpentine type 7TM GPCR receptor class ab chemoreceptor', 324, NULL, '7TM_GPCR_Srab', 259058),
(439965, 'PF02595', NULL, 'Glycerate kinase family', 366, NULL, 'Gly_kinase', 259059),
(439966, 'PF06242', NULL, 'Transcriptional cell cycle regulator TrcR', 139, NULL, 'TrcR', 259060),
(439967, 'PF03433', NULL, 'EspA-like secreted protein', 180, NULL, 'EspA', 259061),
(439968, 'PF04086', NULL, 'Signal recognition particle, alpha subunit, N-terminal', 301, NULL, 'SRP-alpha_N', 259062),
(439969, 'PF20003', NULL, 'FtsH ternary system domain X5', 187, NULL, 'fvmX5', 259063),
(439970, 'PF07335', NULL, 'Fungal chitosanase of glycosyl hydrolase group 75', 163, NULL, 'Glyco_hydro_75', 259064),
(439971, 'PF02743', NULL, 'Cache domain', 241, NULL, 'dCache_1', 259065),
(439972, 'PF19588', NULL, 'Saxitoxin biosynthesis operon protein SxtJ', 99, NULL, 'SxtJ', 259066),
(439973, 'PF01058', NULL, 'NADH ubiquinone oxidoreductase, 20 Kd subunit', 129, NULL, 'Oxidored_q6', 259067),
(439974, 'PF12160', NULL, 'Fibrinogen alpha C domain', 68, NULL, 'Fibrinogen_aC', 259068),
(439975, 'PF07591', NULL, 'Pretoxin HINT domain', 137, NULL, 'PT-HINT', 259069),
(439976, 'PF10835', NULL, 'Protein of unknown function (DUF2573)', 78, NULL, 'DUF2573', 259070),
(439977, 'PF11944', NULL, 'Protein of unknown function (DUF3461)', 125, NULL, 'DUF3461', 259071),
(439978, 'PF20197', NULL, 'Family of unknown function (DUF6560)', 174, NULL, 'DUF6560', 259072),
(439979, 'PF17894', NULL, 'Topo homolgy domain in CRISPR-associated endonuclease Cas9', 71, NULL, 'Cas9_Topo', 259073),
(439980, 'PF04368', NULL, 'Protein of unknown function (DUF507)', 182, NULL, 'DUF507', 259074),
(439981, 'PF03023', NULL, 'Lipid II flippase MurJ', 452, NULL, 'MurJ', 259075),
(439982, 'PF08002', NULL, 'Protein of unknown function (DUF1697)', 137, NULL, 'DUF1697', 259076),
(439983, 'PF15492', NULL, 'Neuroblastoma-amplified sequence, N terminal', 282, NULL, 'Nbas_N', 259077),
(439984, 'PF13796', NULL, 'Putative sensor', 162, NULL, 'Sensor', 259078),
(439985, 'PF00160', NULL, 'Cyclophilin type peptidyl-prolyl cis-trans isomerase/CLD', 158, NULL, 'Pro_isomerase', 259079),
(439986, 'PF08866', NULL, 'Putative amino acid metabolism', 111, NULL, 'DUF1831', 259080),
(439987, 'PF10248', NULL, 'Myelodysplasia-myeloid leukemia factor 1-interacting protein', 174, NULL, 'Mlf1IP', 259081),
(439988, 'PF17293', NULL, 'Arm DNA-binding domain', 86, NULL, 'Arm-DNA-bind_5', 259082),
(439989, 'PF00455', NULL, 'DeoR C terminal sensor domain', 160, NULL, 'DeoRC', 259083),
(439990, 'PF11026', NULL, 'Protein of unknown function (DUF2721)', 129, NULL, 'DUF2721', 259084),
(439991, 'PF19856', NULL, 'Family of unknown function (DUF6331)', 103, NULL, 'DUF6331', 259085),
(439992, 'PF14592', NULL, 'Chondroitinase B', 426, NULL, 'Chondroitinas_B', 259086),
(439993, 'PF01213', NULL, 'Adenylate cyclase associated (CAP) N terminal', 78, NULL, 'CAP_N', 259087),
(439994, 'PF10518', NULL, 'TAT (twin-arginine translocation) pathway signal sequence', 26, NULL, 'TAT_signal', 259088),
(439995, 'PF10949', NULL, 'Protein of unknown function (DUF2777)', 182, NULL, 'DUF2777', 259089),
(439996, 'PF15596', NULL, 'Immunity protein 57', 109, NULL, 'Imm57', 259090),
(439997, 'PF00750', NULL, 'tRNA synthetases class I (R)', 349, NULL, 'tRNA-synt_1d', 259091),
(439998, 'PF18068', NULL, 'Npun R1517', 76, NULL, 'Npun_R1517', 259092),
(439999, 'PF12907', NULL, 'Zinc-binding', 38, NULL, 'zf-met2', 259093),
(440000, 'PF01633', NULL, 'Choline/ethanolamine kinase', 213, NULL, 'Choline_kinase', 259094),
(440001, 'PF13926', NULL, 'Domain of unknown function (DUF4211)', 139, NULL, 'DUF4211', 259095);
INSERT INTO "PUBLIC"."MODEL" VALUES
(440002, 'PF17466', NULL, 'Family of unknown function', 57, NULL, 'NinD', 259096),
(440003, 'PF20308', NULL, 'Tetratricopeptide Repeats-Sensor', 103, NULL, 'TPR-S', 259097),
(440004, 'PF00590', NULL, 'Tetrapyrrole (Corrin/Porphyrin) Methylases', 213, NULL, 'TP_methylase', 259098),
(440005, 'PF05726', NULL, 'Pirin C-terminal cupin domain', 105, NULL, 'Pirin_C', 259099),
(440006, 'PF08688', NULL, 'Apx/Shroom domain ASD1', 184, NULL, 'ASD1', 259100),
(440007, 'PF02093', NULL, 'Gag P30 core shell protein', 208, NULL, 'Gag_p30', 259101),
(440008, 'PF02365', NULL, 'No apical meristem (NAM) protein', 122, NULL, 'NAM', 259102),
(440009, 'PF00794', NULL, 'PI3-kinase family, ras-binding domain', 107, NULL, 'PI3K_rbd', 259103),
(440010, 'PF03338', NULL, 'Poxvirus J1 protein', 146, NULL, 'Pox_J1', 259104),
(440011, 'PF00916', NULL, 'Sulfate permease family', 380, NULL, 'Sulfate_transp', 259105),
(440012, 'PF06943', NULL, 'LSD1 zinc finger', 25, NULL, 'zf-LSD1', 259106),
(440013, 'PF05445', NULL, 'Poxvirus serine/threonine protein kinase', 434, NULL, 'Pox_ser-thr_kin', 259107),
(440014, 'PF14323', NULL, 'GxGYxYP putative glycoside hydrolase C-terminal domain', 240, NULL, 'GxGYxYP_C', 259108),
(440015, 'PF14701', NULL, 'Glycogen debranching enzyme, glucanotransferase domain', 439, NULL, 'hDGE_amylase', 259109),
(440016, 'PF15609', NULL, 'Phosphoribosyl transferase', 190, NULL, 'PRTase_2', 259110),
(440017, 'PF10353', NULL, 'Protein of unknown function (DUF2430)', 107, NULL, 'DUF2430', 259111),
(440018, 'PF12148', NULL, 'Tandem tudor domain within UHRF1', 155, NULL, 'TTD', 259112),
(440019, 'PF06742', NULL, 'Protein of unknown function (DUF1214)', 111, NULL, 'DUF1214', 259113),
(440020, 'PF11668', NULL, 'HCMV glycoprotein pUL130', 159, NULL, 'Gp_UL130', 259114),
(440021, 'PF08034', NULL, 'Trematode eggshell synthesis protein', 66, NULL, 'TES', 259115),
(440022, 'PF20367', NULL, 'Family of unknown function (DUF6662)', 308, NULL, 'DUF6662', 259116),
(440023, 'PF04433', NULL, 'SWIRM domain', 90, NULL, 'SWIRM', 259117),
(440024, 'PF05929', NULL, 'Phage capsid scaffolding protein (GPO) serine peptidase', 271, NULL, 'Phage_GPO', 259118),
(440025, 'PF16065', NULL, 'Domain of unknown function (DUF4807)', 126, NULL, 'DUF4807', 259119),
(440026, 'PF13839', NULL, 'GDSL/SGNH-like Acyl-Esterase family found in Pmr5 and Cas1p', 283, NULL, 'PC-Esterase', 259120),
(440027, 'PF02653', NULL, 'Branched-chain amino acid transport system / permease component', 270, NULL, 'BPD_transp_2', 259121),
(440028, 'PF09066', NULL, 'Beta2-adaptin appendage, C-terminal sub-domain', 112, NULL, 'B2-adapt-app_C', 259122),
(440029, 'PF07693', NULL, 'KAP family P-loop domain', 326, NULL, 'KAP_NTPase', 259123),
(440030, 'PF06295', NULL, 'Protein of unknown function (DUF1043)', 124, NULL, 'DUF1043', 259124),
(440031, 'PF01253', NULL, 'Translation initiation factor SUI1', 79, NULL, 'SUI1', 259125),
(440032, 'PF03525', NULL, 'Meiotic recombination protein Rec7 N-terminal domain', 134, NULL, 'Meiotic_rec114', 259126),
(440033, 'PF18883', NULL, 'Autochaperone Domain Type 1', 114, NULL, 'AC_1', 259127),
(440034, 'PF05072', NULL, 'Herpesvirus UL43 protein', 375, NULL, 'Herpes_UL43', 259128),
(440035, 'PF15405', NULL, 'Pleckstrin homology domain', 135, NULL, 'PH_5', 259129),
(440036, 'PF18699', NULL, 'Mitoribosomal protein mL52', 92, NULL, 'MRPL52', 259130),
(440037, 'PF20528', NULL, 'Domain of unknown function (DUF6743)', 78, NULL, 'DUF6743', 259131),
(440038, 'PF01648', NULL, '4''-phosphopantetheinyl transferase superfamily', 114, NULL, 'ACPS', 259132),
(440039, 'PF04883', NULL, 'Bacteriophage HK97-gp10, putative tail-component', 81, NULL, 'HK97-gp10_like', 259133),
(440040, 'PF05547', NULL, 'Immune inhibitor A peptidase M6', 656, NULL, 'Peptidase_M6', 259134),
(440041, 'PF19219', NULL, 'Coronavirus replicase NSP15, N-terminal oligomerisation', 61, NULL, 'CoV_NSP15_N', 259135),
(440042, 'PF14158', NULL, 'YndJ-like protein', 261, NULL, 'YndJ', 259136),
(440043, 'PF00996', NULL, 'GDP dissociation inhibitor', 436, NULL, 'GDI', 259137),
(440044, 'PF07341', NULL, 'Protein of unknown function (DUF1473)', 163, NULL, 'DUF1473', 259138);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(440045, 'PF08246', NULL, 'Cathepsin propeptide inhibitor domain (I29)', 58, NULL, 'Inhibitor_I29', 259139),
(440046, 'PF04206', NULL, 'Tetrahydromethanopterin S-methyltransferase, subunit E', 271, NULL, 'MtrE', 259140),
(440047, 'PF05062', NULL, 'RICH domain', 83, NULL, 'RICH', 259141),
(440048, 'PF06590', NULL, 'PerB protein', 129, NULL, 'PerB', 259142),
(440049, 'PF07637', NULL, 'Protein of unknown function (DUF1595)', 62, NULL, 'PSD5', 259143),
(440050, 'PF12671', NULL, 'Putative amidase domain', 164, NULL, 'Amidase_6', 259144),
(440051, 'PF11861', NULL, 'Domain of unknown function (DUF3381)', 167, NULL, 'DUF3381', 259145),
(440052, 'PF13046', NULL, 'Protein of unknown function (DUF3906)', 64, NULL, 'DUF3906', 259146),
(440053, 'PF17694', NULL, 'Family of unknown function (DUF5540)', 77, NULL, 'DUF5540', 259147),
(440054, 'PF10986', NULL, 'Protein of unknown function (DUF2796)', 164, NULL, 'DUF2796', 259148),
(440055, 'PF09014', NULL, 'Beta-2-glycoprotein-1 fifth domain', 88, NULL, 'Sushi_2', 259149),
(440056, 'PF00084', NULL, 'Sushi repeat (SCR repeat)', 56, NULL, 'Sushi', 259150),
(440057, 'PF18550', NULL, 'Nitrososphaera output domain 2', 104, NULL, 'NitrOD2', 259151),
(440058, 'PF14673', NULL, 'Domain of unknown function (DUF4459)', 159, NULL, 'DUF4459', 259152),
(440059, 'PF20177', NULL, 'Domain of unknown function (DUF6542)', 123, NULL, 'DUF6542', 259153),
(440060, 'PF08833', NULL, 'Axin beta-catenin binding motif', 37, NULL, 'Axin_b-cat_bind', 259154),
(440061, 'PF19087', NULL, 'Domain of unknown function (DUF5776)', 68, NULL, 'DUF5776', 259155),
(440062, 'PF08597', NULL, 'Translation initiation factor eIF3 subunit', 250, NULL, 'eIF3_subunit', 259156),
(440063, 'PF16808', NULL, 'Coiled-coil N-terminus of cGMP-dependent protein kinase', 35, NULL, 'PKcGMP_CC', 259157),
(440064, 'PF20452', NULL, 'Calmodulin binding protein C-terminal domain', 62, NULL, 'Calmod_bind_C', 259158),
(440065, 'PF19397', NULL, 'Family of unknown function (DUF5972)', 28, NULL, 'DUF5972', 259159),
(440066, 'PF02913', NULL, 'FAD linked oxidases, C-terminal domain', 250, NULL, 'FAD-oxidase_C', 259160),
(440067, 'PF01657', NULL, 'Salt stress response/antifungal', 94, NULL, 'Stress-antifung', 259161),
(440068, 'PF04454', NULL, 'Encapsulating protein for peroxidase', 255, NULL, 'Linocin_M18', 259162),
(440069, 'PF04120', NULL, 'Low affinity iron permease', 128, NULL, 'Iron_permease', 259163),
(440070, 'PF19725', NULL, 'DNA-directed RNA polymerase III subunit RPC5 C-terminal', 254, NULL, 'RPC5_C', 259164),
(440071, 'PF01404', NULL, 'Ephrin receptor ligand binding domain', 177, NULL, 'Ephrin_lbd', 259165),
(440072, 'PF08801', NULL, 'Nup133 N terminal like', 434, NULL, 'Nucleoporin_N', 259166),
(440073, 'PF13346', NULL, 'ABC-2 family transporter protein', 205, NULL, 'ABC2_membrane_5', 259167),
(440074, 'PF16119', NULL, 'Domain of unknown function (DUF4835)', 276, NULL, 'DUF4835', 259168),
(440075, 'PF00174', NULL, 'Oxidoreductase molybdopterin binding domain', 170, NULL, 'Oxidored_molyb', 259169),
(440076, 'PF09921', NULL, 'Uncharacterized protein conserved in archaea (DUF2153)', 123, NULL, 'DUF2153', 259170),
(440077, 'PF01212', NULL, 'Beta-eliminating lyase', 291, NULL, 'Beta_elim_lyase', 259171),
(440078, 'PF12340', NULL, 'Protein of unknown function (DUF3638)', 226, NULL, 'DUF3638', 259172),
(440079, 'PF01830', NULL, 'Peptidase C7 family', 243, NULL, 'Peptidase_C7', 259173),
(440080, 'PF16991', NULL, 'Sir4 SID domain', 163, NULL, 'SIR4_SID', 259174),
(440081, 'PF10269', NULL, 'Transmembrane Fragile-X-F protein', 250, NULL, 'Tmemb_185A', 259175),
(440082, 'PF19200', NULL, '6-phospho-N-acetylmuramidase, N-terminal', 235, NULL, 'MupG_N', 259176),
(440083, 'PF19152', NULL, 'Family of unknown function (DUF5834)', 159, NULL, 'DUF5834', 259177),
(440084, 'PF18868', NULL, 'Zinc finger C2H2-type, 3 repeats', 126, NULL, 'zf-C2H2_3rep', 259178),
(440085, 'PF17059', NULL, 'MgtA leader peptide', 17, NULL, 'MGTL', 259179),
(440086, 'PF17039', NULL, 'Fucosyltransferase, N-terminal', 110, NULL, 'Glyco_tran_10_N', 259180),
(440087, 'PF16477', NULL, 'Domain of unknown function (DUF5054)', 287, NULL, 'DUF5054', 259181);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(440088, 'PF03787', NULL, 'RAMP superfamily', 213, NULL, 'RAMPs', 259182),
(440089, 'PF16256', NULL, 'Domain of unknown function (DUF4911)', 57, NULL, 'DUF4911', 259183),
(440090, 'PF10083', NULL, 'Uncharacterized protein conserved in bacteria (DUF2321)', 156, NULL, 'DUF2321', 259184),
(440091, 'PF19506', NULL, 'Family of unknown function (DUF6040)', 233, NULL, 'DUF6040', 259185),
(440092, 'PF07276', NULL, 'Apopolysialoglycoprotein (PSGP)', 13, NULL, 'PSGP', 259186),
(440093, 'PF20228', NULL, 'Family of unknown function (DUF6587)', 82, NULL, 'DUF6587', 259187),
(440094, 'PF01386', NULL, 'Ribosomal L25p family', 81, NULL, 'Ribosomal_L25p', 259188),
(440095, 'PF15594', NULL, 'Immunity protein 50', 118, NULL, 'Imm50', 259189),
(440096, 'PF02383', NULL, 'SacI homology domain', 323, NULL, 'Syja_N', 259190),
(440097, 'PF02976', NULL, 'DNA mismatch repair enzyme MutH', 103, NULL, 'MutH', 259191),
(440098, 'PF11444', NULL, 'Protein of unknown function (DUF2895)', 198, NULL, 'DUF2895', 259192),
(440099, 'PF08815', NULL, 'Nuclear receptor coactivator', 49, NULL, 'Nuc_rec_co-act', 259193),
(440100, 'PF19821', NULL, 'Phage capsid protein', 292, NULL, 'Phage_capsid_2', 259194),
(440101, 'PF14877', NULL, 'Mitochondrial translation initiation factor', 177, NULL, 'mIF3', 259195),
(440102, 'PF09876', NULL, 'Predicted metal-binding protein (DUF2103)', 98, NULL, 'DUF2103', 259196),
(440103, 'PF13433', NULL, 'Periplasmic binding protein domain', 363, NULL, 'Peripla_BP_5', 259197),
(440104, 'PF13713', NULL, 'Transcription factor BRX N-terminal domain', 37, NULL, 'BRX_N', 259198),
(440105, 'PF09806', NULL, 'Cyclin-dependent kinase 2-associated protein', 217, NULL, 'CDK2AP', 259199),
(440106, 'PF19025', NULL, 'Family of unknown function (DUF5751)', 116, NULL, 'DUF5751', 259200),
(440107, 'PF00895', NULL, 'ATP synthase protein 8', 55, NULL, 'ATP-synt_8', 259201),
(440108, 'PF00277', NULL, 'Serum amyloid A protein', 102, NULL, 'SAA', 259202),
(440109, 'PF08238', NULL, 'Sel1 repeat', 38, NULL, 'Sel1', 259203),
(440110, 'PF20371', NULL, 'Family of unknown function (DUF6666)', 370, NULL, 'DUF6666', 259204),
(440111, 'PF14766', NULL, 'Replication protein A interacting N-terminal', 39, NULL, 'RPA_interact_N', 259205),
(440112, 'PF14718', NULL, 'Soluble lytic murein transglycosylase L domain', 68, NULL, 'SLT_L', 259206),
(440113, 'PF14817', NULL, 'HAUS augmin-like complex subunit 5', 643, NULL, 'HAUS5', 259207),
(440114, 'PF17536', NULL, 'Matrix and Matrix long proteins N-terminal', 149, NULL, 'Mx_ML', 259208),
(440115, 'PF04009', NULL, 'Protein of unknown function (DUF356)', 106, NULL, 'DUF356', 259209),
(440116, 'PF08144', NULL, 'CPL (NUC119) domain', 143, NULL, 'CPL', 259210),
(440117, 'PF11602', NULL, 'ATPase P4 of dsRNA bacteriophage phi-12', 320, NULL, 'NTPase_P4', 259211),
(440118, 'PF16048', NULL, 'Frog antimicrobial peptide', 17, NULL, 'Antimicrobial23', 259212),
(440119, 'PF05022', NULL, 'SRP40, C-terminal domain', 76, NULL, 'SRP40_C', 259213),
(440120, 'PF15610', NULL, 'PRTase ComF-like', 264, NULL, 'PRTase_3', 259214),
(440121, 'PF17424', NULL, 'Family of unknown function (DUF5411)', 134, NULL, 'DUF5411', 259215),
(440122, 'PF07703', NULL, 'Alpha-2-macroglobulin bait region domain', 138, NULL, 'A2M_BRD', 259216),
(440123, 'PF13863', NULL, 'Domain of unknown function (DUF4200)', 119, NULL, 'DUF4200', 259217),
(440124, 'PF08832', NULL, 'Steroid receptor coactivator', 92, NULL, 'SRC-1', 259218),
(440125, 'PF15958', NULL, 'Domain of unknown function (DUF4761)', 105, NULL, 'DUF4761', 259219),
(440126, 'PF18570', NULL, 'NUP57/Nup54 C-terminal domain', 29, NULL, 'Nup54_57_C', 259220),
(440127, 'PF04929', NULL, 'Herpes DNA replication accessory factor', 400, NULL, 'Herpes_DNAp_acc', 259221),
(440128, 'PF12108', NULL, 'Splicing factor SF3a60 binding domain', 27, NULL, 'SF3a60_bindingd', 259222),
(440129, 'PF05484', NULL, 'LRV protein FeS4 cluster', 53, NULL, 'LRV_FeS', 259223),
(440130, 'PF08635', NULL, 'Putative oxidoreductase C terminal domain', 142, NULL, 'ox_reductase_C', 259224),
(440131, 'PF02069', NULL, 'Prokaryotic metallothionein', 51, NULL, 'Metallothio_Pro', 259225);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(440132, 'PF00976', NULL, 'Corticotropin ACTH domain', 19, NULL, 'ACTH_domain', 259226),
(440133, 'PF01124', NULL, 'MAPEG family', 130, NULL, 'MAPEG', 259227),
(440134, 'PF04059', NULL, 'RNA recognition motif 2', 97, NULL, 'RRM_2', 259228),
(440135, 'PF09885', NULL, 'Uncharacterized protein conserved in archaea (DUF2112)', 143, NULL, 'DUF2112', 259229),
(440136, 'PF09192', NULL, 'Actin-fragmin kinase, catalytic', 282, NULL, 'Act-Frag_cataly', 259230),
(440137, 'PF20380', NULL, 'Family of unknown function (DUF6675)', 255, NULL, 'DUF6675', 259231),
(440138, 'PF07561', NULL, 'Domain of Unknown Function (DUF1540)', 48, NULL, 'DUF1540', 259232),
(440139, 'PF04467', NULL, 'Protein of unknown function (DUF483)', 122, NULL, 'DUF483', 259233),
(440140, 'PF20416', NULL, 'Domain of unknown function (DUF6700)', 221, NULL, 'DUF6700', 259234),
(440141, 'PF01379', NULL, 'Porphobilinogen deaminase, dipyromethane cofactor binding domain', 208, NULL, 'Porphobil_deam', 259235),
(440142, 'PF18703', NULL, 'MALT1 Ig-like domain', 138, NULL, 'MALT1_Ig', 259236),
(440143, 'PF11462', NULL, 'Protein of unknown function (DUF3203)', 74, NULL, 'DUF3203', 259237),
(440144, 'PF17562', NULL, 'Styelin', 59, NULL, 'Styelin', 259238),
(440145, 'PF03533', NULL, 'SPO11 homologue', 43, NULL, 'SPO11_like', 259239),
(440146, 'PF08689', NULL, 'Mediator complex subunit Med5', 1082, NULL, 'Med5', 259240),
(440147, 'PF14549', NULL, 'DNA-binding transcriptional regulator Cro', 60, NULL, 'P22_Cro', 259241),
(440148, 'PF01690', NULL, 'Potato leaf roll virus readthrough protein', 485, NULL, 'PLRV_ORF5', 259242),
(440149, 'PF03473', NULL, 'MOSC domain', 137, NULL, 'MOSC', 259243),
(440150, 'PF06150', NULL, 'ChaB', 60, NULL, 'ChaB', 259244),
(440151, 'PF01190', NULL, 'Pollen protein Ole e 1 like', 99, NULL, 'Pollen_Ole_e_1', 259245),
(440152, 'PF09409', NULL, 'PUB domain', 82, NULL, 'PUB', 259246),
(440153, 'PF10762', NULL, 'Protein of unknown function (DUF2583)', 88, NULL, 'DUF2583', 259247),
(440154, 'PF11893', NULL, 'Domain of unknown function (DUF3413)', 248, NULL, 'DUF3413', 259248),
(440155, 'PF12295', NULL, 'Symplekin tight junction protein C terminal', 186, NULL, 'Symplekin_C', 259249),
(440156, 'PF12161', NULL, 'HsdM N-terminal domain', 139, NULL, 'HsdM_N', 259250),
(440157, 'PF17166', NULL, 'Domain of unknown function (DUF5126)', 104, NULL, 'DUF5126', 259251),
(440158, 'PF15752', NULL, 'Domain of unknown function (DUF4688)', 400, NULL, 'DUF4688', 259252),
(440159, 'PF17388', NULL, 'Mycobacteriophage tail assembly protein', 123, NULL, 'GP24_25', 259253),
(440160, 'PF13526', NULL, 'Protein of unknown function (DUF4125)', 197, NULL, 'DUF4125', 259254),
(440161, 'PF10372', NULL, 'Bacterial membrane-spanning protein N-terminus', 69, NULL, 'YojJ', 259255),
(440162, 'PF18542', NULL, 'Transcription factor IIB C-terminal module 1', 99, NULL, 'TFIIB_C_1', 259256),
(440163, 'PF08934', NULL, 'Rb C-terminal domain', 152, NULL, 'Rb_C', 259257),
(440164, 'PF00677', NULL, 'Lumazine binding domain', 87, NULL, 'Lum_binding', 259258),
(440165, 'PF00934', NULL, 'PE family', 91, NULL, 'PE', 259259),
(440166, 'PF01809', NULL, 'Putative membrane protein insertion efficiency factor', 67, NULL, 'YidD', 259260),
(440167, 'PF09254', NULL, 'FokI, cleavage domain', 188, NULL, 'FokI_cleav_dom', 259261),
(440168, 'PF09567', NULL, 'MamI restriction endonuclease', 183, NULL, 'RE_MamI', 259262),
(440169, 'PF02347', NULL, 'Glycine cleavage system P-protein', 430, NULL, 'GDC-P', 259263),
(440170, 'PF19880', NULL, 'Family of unknown function (DUF6353)', 255, NULL, 'DUF6353', 259264),
(440171, 'PF05039', NULL, 'Agouti protein', 43, NULL, 'Agouti', 259265),
(440172, 'PF15812', NULL, 'Melanoregulin', 149, NULL, 'MREG', 259266),
(440173, 'PF19161', NULL, 'Family of unknown function (DUF5843)', 196, NULL, 'DUF5843', 259267),
(440174, 'PF20074', NULL, 'Family of unknown function (DUF6470)', 179, NULL, 'DUF6470', 259268),
(440175, 'PF14702', NULL, 'Central domain of human glycogen debranching enzyme', 253, NULL, 'hGDE_central', 259269),
(440176, 'PF03605', NULL, 'Anaerobic c4-dicarboxylate membrane transporter', 368, NULL, 'DcuA_DcuB', 259270); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(440177, 'PF05705', NULL, 'Eukaryotic protein of unknown function (DUF829)', 245, NULL, 'DUF829', 259271),
(440178, 'PF13530', NULL, 'Sterol carrier protein domain', 104, NULL, 'SCP2_2', 259272),
(440179, 'PF01242', NULL, '6-pyruvoyl tetrahydropterin synthase', 123, NULL, 'PTPS', 259273),
(440180, 'PF00833', NULL, 'Ribosomal S17', 122, NULL, 'Ribosomal_S17e', 259274),
(440181, 'PF04952', NULL, 'Succinylglutamate desuccinylase / Aspartoacylase family', 291, NULL, 'AstE_AspA', 259275),
(440182, 'PF07999', NULL, 'Retrotransposon hot spot protein, P-loop domain', 312, NULL, 'RHSP', 259276),
(440183, 'PF04233', NULL, 'Phage Mu protein F like protein', 112, NULL, 'Phage_Mu_F', 259277),
(440184, 'PF07194', NULL, 'P2 response regulator binding domain', 81, NULL, 'P2', 259278),
(440185, 'PF05575', NULL, 'Vibrio cholerae RfbT protein', 286, NULL, 'V_cholerae_RfbT', 259279),
(440186, 'PF03179', NULL, 'Vacuolar (H+)-ATPase G subunit', 105, NULL, 'V-ATPase_G', 259280),
(440187, 'PF01707', NULL, 'Peptidase family C9', 202, NULL, 'Peptidase_C9', 259281),
(440188, 'PF01524', NULL, 'Geminivirus V2 protein', 78, NULL, 'Gemini_V2', 259282),
(440189, 'PF10267', NULL, 'Predicted transmembrane and coiled-coil 2 protein', 397, NULL, 'Tmemb_cc2', 259283),
(440190, 'PF17733', NULL, 'Family of unknown function (DUF5572)', 48, NULL, 'DUF5572', 259284),
(440191, 'PF09480', NULL, 'Type III secretion system protein PrgH-EprH (PrgH)', 372, NULL, 'PrgH', 259285),
(440192, 'PF06381', NULL, 'Protein of unknown function (DUF1073)', 357, NULL, 'DUF1073', 259286),
(440193, 'PF13668', NULL, 'Ferritin-like domain', 138, NULL, 'Ferritin_2', 259287),
(440194, 'PF10877', NULL, 'Protein of unknown function (DUF2671)', 88, NULL, 'DUF2671', 259288),
(440195, 'PF09478', NULL, 'Carbohydrate binding domain CBM49', 81, NULL, 'CBM49', 259289),
(440196, 'PF11222', NULL, 'Protein of unknown function (DUF3017)', 74, NULL, 'DUF3017', 259290),
(440197, 'PF00281', NULL, 'Ribosomal protein L5', 57, NULL, 'Ribosomal_L5', 259291),
(440198, 'PF00606', NULL, 'Herpesvirus Glycoprotein B ectodomain', 222, NULL, 'Glycoprotein_B', 259292),
(440199, 'PF04204', NULL, 'Homoserine O-succinyltransferase', 298, NULL, 'HTS', 259293),
(440200, 'PF11043', NULL, 'Bacteriophage P22, anti-RecBCD protein 2', 97, NULL, 'Anti-RecBCD_p2', 259294),
(440201, 'PF13400', NULL, 'Putative Flp pilus-assembly TadE/G-like', 48, NULL, 'Tad', 259295),
(440202, 'PF10502', NULL, 'Signal peptidase, peptidase S26', 170, NULL, 'Peptidase_S26', 259296),
(440203, 'PF01779', NULL, 'Ribosomal L29e protein family', 40, NULL, 'Ribosomal_L29e', 259297),
(440204, 'PF08248', NULL, 'Tryptophyllin-3 skin active peptide', 12, NULL, 'Tryp_FSAP', 259298),
(440205, 'PF06919', NULL, 'Phage Gp30.7 protein', 121, NULL, 'Phage_T4_Gp30_7', 259299),
(440206, 'PF14053', NULL, 'Domain of unknown function (DUF4248)', 68, NULL, 'DUF4248', 259300),
(440207, 'PF19283', NULL, 'Acylamino-acid-releasing enzyme, N-terminal domain', 274, NULL, 'APEH_N', 259301),
(440208, 'PF13426', NULL, 'PAS domain', 104, NULL, 'PAS_9', 259302),
(440209, 'PF07338', NULL, 'YdgH/BhsA/McbA-like domain', 55, NULL, 'YdgH_BhsA-like', 259303),
(440210, 'PF12872', NULL, 'OST-HTH/LOTUS domain', 72, NULL, 'OST-HTH', 259304),
(440211, 'PF03011', NULL, 'PFEMP1 DBL domain', 160, NULL, 'PFEMP', 259305),
(440212, 'PF06067', NULL, 'Domain of unknown function (DUF932)', 228, NULL, 'DUF932', 259306),
(440213, 'PF05577', NULL, 'Serine carboxypeptidase S28', 434, NULL, 'Peptidase_S28', 259307),
(440214, 'PF08097', NULL, 'Conotoxin T-superfamily', 11, NULL, 'Toxin_26', 259308),
(440215, 'PF05049', NULL, 'Interferon-inducible GTPase (IIGP)', 375, NULL, 'IIGP', 259309),
(440216, 'PF08519', NULL, 'Replication factor RFC1 C terminal domain', 157, NULL, 'RFC1', 259310),
(440217, 'PF18111', NULL, 'Retinitis pigmentosa G-protein regulator interacting C-terminal', 166, NULL, 'RPGR1_C', 259311),
(440218, 'PF19823', NULL, 'Domain of unknown function (DUF6305)', 155, NULL, 'DUF6305', 259312),
(440219, 'PF00215', NULL, 'Orotidine 5''-phosphate decarboxylase / HUMPS family', 225, NULL, 'OMPdecase', 259313);
INSERT INTO "PUBLIC"."MODEL" VALUES
(440220, 'PF16622', NULL, 'zinc-finger C2H2-type', 29, NULL, 'zf-C2H2_11', 259314),
(440221, 'PF09240', NULL, 'Interleukin-6 receptor alpha chain, binding', 96, NULL, 'IL6Ra-bind', 259315),
(440222, 'PF01918', NULL, 'Alba', 67, NULL, 'Alba', 259316),
(440223, 'PF17305', NULL, 'Family of unknown function (DUF5354)', 124, NULL, 'DUF5354', 259317),
(440224, 'PF16332', NULL, 'Domain of unknown function (DUF4962)', 476, NULL, 'DUF4962', 259318),
(440225, 'PF19082', NULL, 'Family of unknown function (DUF5773)', 177, NULL, 'DUF5773', 259319),
(440226, 'PF19473', NULL, 'Family of unknown function (DUF6010)', 120, NULL, 'DUF6010', 259320),
(440227, 'PF05402', NULL, 'Coenzyme PQQ synthesis protein D (PqqD)', 67, NULL, 'PqqD', 259321),
(440228, 'PF15616', NULL, 'TerY-C metal binding domain', 129, NULL, 'TerY_C', 259322),
(440229, 'PF01533', NULL, 'Tospovirus nucleocapsid protein', 246, NULL, 'Tospo_nucleocap', 259323),
(440230, 'PF11157', NULL, 'Protein of unknown function (DUF2937)', 162, NULL, 'DUF2937', 259324),
(440231, 'PF09397', NULL, 'Ftsk gamma domain', 63, NULL, 'FtsK_gamma', 259325),
(440232, 'PF12387', NULL, 'Pestivirus NS2 peptidase', 200, NULL, 'Peptidase_C74', 259326),
(440233, 'PF01849', NULL, 'NAC domain', 57, NULL, 'NAC', 259327),
(440234, 'PF02635', NULL, 'DsrE/DsrF-like family', 117, NULL, 'DrsE', 259328),
(440235, 'PF16426', NULL, 'Domain of unknown function (DUF5023)', 197, NULL, 'DUF5023', 259329),
(440236, 'PF00132', NULL, 'Bacterial transferase hexapeptide (six repeats)', 36, NULL, 'Hexapep', 259330),
(440237, 'PF05304', NULL, 'Protein of unknown function (DUF728)', 139, NULL, 'DUF728', 259331),
(440238, 'PF11211', NULL, 'Protein of unknown function (DUF2997)', 47, NULL, 'DUF2997', 259332),
(440239, 'PF19079', NULL, 'Collagen-flanked surface repeat', 49, NULL, 'CFSR', 259333),
(440240, 'PF16134', NULL, 'THO complex subunit 2 N-terminus', 624, NULL, 'THOC2_N', 259334),
(440241, 'PF11496', NULL, 'Class II histone deacetylase complex subunits 2 and 3', 292, NULL, 'HDA2-3', 259335),
(440242, 'PF06806', NULL, 'Putative excisionase (DUF1233)', 70, NULL, 'DUF1233', 259336),
(440243, 'PF08567', NULL, 'TFIIH p62 subunit, N-terminal domain', 89, NULL, 'PH_TFIIH', 259337),
(440244, 'PF11197', NULL, 'Protein of unknown function (DUF2835)', 71, NULL, 'DUF2835', 259338),
(440245, 'PF03853', NULL, 'YjeF-related protein N-terminus', 171, NULL, 'YjeF_N', 259339),
(440246, 'PF07151', NULL, 'Protein of unknown function (DUF1391)', 48, NULL, 'DUF1391', 259340),
(440247, 'PF11762', NULL, 'L-arabinose isomerase C-terminal domain', 114, NULL, 'Arabinose_Iso_C', 259341),
(440248, 'PF14270', NULL, 'Domain of unknown function (DUF4358)', 102, NULL, 'DUF4358', 259342),
(440249, 'PF19543', NULL, 'Family of unknown function (DUF6067)', 969, NULL, 'DUF6067', 259343),
(440250, 'PF08329', NULL, 'Chitinase A, N-terminal domain', 133, NULL, 'ChitinaseA_N', 259344),
(440251, 'PF12017', NULL, 'Transposase protein', 219, NULL, 'Tnp_P_element', 259345),
(440252, 'PF16059', NULL, 'MGA, conserved domain', 51, NULL, 'MGA_dom', 259346),
(440253, 'PF14655', NULL, 'Rab3 GTPase-activating protein regulatory subunit N-terminus', 417, NULL, 'RAB3GAP2_N', 259347),
(440254, 'PF18095', NULL, 'UPF0242 C-terminal PAS-like domain', 153, NULL, 'PAS_12', 259348),
(440255, 'PF02892', NULL, 'BED zinc finger', 44, NULL, 'zf-BED', 259349),
(440256, 'PF15969', NULL, 'Intracellular sensor of Lambda phage, Abi component', 236, NULL, 'RexA', 259350),
(440257, 'PF09249', NULL, 'tRNA nucleotidyltransferase, second domain', 113, NULL, 'tRNA_NucTransf2', 259351),
(440258, 'PF09979', NULL, 'Uncharacterized protein conserved in bacteria (DUF2213)', 167, NULL, 'DUF2213', 259352),
(440259, 'PF18801', NULL, 'response regulator aspartate phosphatase H, N terminal', 62, NULL, 'RapH_N', 259353),
(440260, 'PF03117', NULL, 'UL49 family', 245, NULL, 'Herpes_UL49_1', 259354),
(440261, 'PF03935', NULL, 'Beta-glucan synthesis-associated protein SKN1/KRE6/Sbg1', 501, NULL, 'SKN1_KRE6_Sbg1', 259355),
(440262, 'PF07897', NULL, 'Ethylene-responsive binding factor-associated repression', 36, NULL, 'EAR', 259356);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(440263, 'PF13083', NULL, 'KH domain', 73, NULL, 'KH_4', 259357),
(440264, 'PF17289', NULL, 'Terminase RNaseH-like domain', 155, NULL, 'Terminase_6C', 259358),
(440265, 'PF00528', NULL, 'Binding-protein-dependent transport system inner membrane component', 185, NULL, 'BPD_transp_1', 259359),
(440266, 'PF03391', NULL, 'Nepovirus coat protein, central domain', 167, NULL, 'Nepo_coat', 259360),
(440267, 'PF08880', NULL, 'QLQ', 35, NULL, 'QLQ', 259361),
(440268, 'PF08066', NULL, 'PMC2NT (NUC016) domain', 92, NULL, 'PMC2NT', 259362),
(440269, 'PF00551', NULL, 'Formyl transferase', 181, NULL, 'Formyl_trans_N', 259363),
(440270, 'PF06433', NULL, 'Methylamine dehydrogenase heavy chain (MADH)', 343, NULL, 'Me-amine-dh_H', 259364),
(440271, 'PF01119', NULL, 'DNA mismatch repair protein, C-terminal domain', 119, NULL, 'DNA_mis_repair', 259365),
(440272, 'PF20537', NULL, 'Domain of unknown function (DUF6752)', 55, NULL, 'DUF6752', 259366),
(440273, 'PF16187', NULL, 'Middle or third domain of peptidase_M16', 285, NULL, 'Peptidase_M16_M', 259367),
(440274, 'PF09628', NULL, 'YvfG protein', 67, NULL, 'YvfG', 259368),
(440275, 'PF11337', NULL, 'Protein of unknown function (DUF3139)', 83, NULL, 'DUF3139', 259369),
(440276, 'PF09399', NULL, 'Betacoronavirus lipid binding protein', 98, NULL, 'bCoV_lipid_BD', 259370),
(440277, 'PF09531', NULL, 'Nucleoporin protein Ndc1-Nup', 608, NULL, 'Ndc1_Nup', 259371),
(440278, 'PF14615', NULL, 'Ribosome-assembly protein 3', 46, NULL, 'Rsa3', 259372),
(440279, 'PF00407', NULL, 'Pathogenesis-related protein Bet v 1 family', 151, NULL, 'Bet_v_1', 259373),
(440280, 'PF10659', NULL, 'Trypanosome variant surface glycoprotein C-terminal domain', 104, NULL, 'Trypan_glycop_C', 259374),
(440281, 'PF01024', NULL, 'Colicin pore forming domain', 185, NULL, 'Colicin', 259375),
(440282, 'PF05168', NULL, 'HEPN domain', 117, NULL, 'HEPN', 259376),
(440283, 'PF06832', NULL, 'Penicillin-Binding Protein C-terminus Family', 90, NULL, 'BiPBP_C', 259377),
(440284, 'PF17923', NULL, 'Tetracyclin repressor-like, C-terminal domain', 113, NULL, 'TetR_C_18', 259378),
(440285, 'PF19611', NULL, 'Family of unknown function (DUF6116)', 50, NULL, 'DUF6116', 259379),
(440286, 'PF10993', NULL, 'Protein of unknown function (DUF2818)', 93, NULL, 'DUF2818', 259380),
(440287, 'PF16883', NULL, 'Domain of unknown function (DUF5080)', 197, NULL, 'DUF5080', 259381),
(440288, 'PF11123', NULL, 'DNA packaging protein', 82, NULL, 'DNA_Packaging_2', 259382),
(440289, 'PF13217', NULL, 'Protein of unknown function (DUF4025)', 50, NULL, 'DUF4025', 259383),
(440290, 'PF02120', NULL, 'Flagellar hook-length control protein FliK', 85, NULL, 'Flg_hook', 259384),
(440291, 'PF14579', NULL, 'Helix-hairpin-helix motif', 90, NULL, 'HHH_6', 259385),
(440292, 'PF15300', NULL, 'INTS6/SAGE1/DDX26B/CT45 C-terminus', 63, NULL, 'INT_SG_DDX_CT_C', 259386),
(440293, 'PF14947', NULL, 'Winged helix-turn-helix', 77, NULL, 'HTH_45', 259387),
(440294, 'PF01436', NULL, 'NHL repeat', 28, NULL, 'NHL', 259388),
(440295, 'PF13909', NULL, 'C2H2-type zinc-finger domain', 25, NULL, 'zf-H2C2_5', 259389),
(440296, 'PF15079', NULL, 'Testis-specific protein 35', 205, NULL, 'Tsc35', 259390),
(440297, 'PF00217', NULL, 'ATP:guanido phosphotransferase, C-terminal catalytic domain', 212, NULL, 'ATP-gua_Ptrans', 259391),
(440298, 'PF01963', NULL, 'TraB/PrgY/gumN family', 263, NULL, 'TraB_PrgY_gumN', 259392),
(440299, 'PF03944', NULL, 'delta endotoxin', 143, NULL, 'Endotoxin_C', 259393),
(440300, 'PF19560', NULL, 'Family of unknown function (DUF6082)', 163, NULL, 'DUF6082', 259394),
(440301, 'PF09713', NULL, 'Plant protein 1589 of unknown function (A_thal_3526)', 53, NULL, 'A_thal_3526', 259395),
(440302, 'PF18992', NULL, 'Family of unknown function (DUF5725)', 158, NULL, 'DUF5725', 259396),
(440303, 'PF05315', NULL, 'ICEA Protein', 218, NULL, 'ICEA', 259397),
(440304, 'PF06108', NULL, 'Protein of unknown function (DUF952)', 90, NULL, 'DUF952', 259398),
(440305, 'PF13221', NULL, 'Protein of unknown function (DUF4029)', 96, NULL, 'DUF4029', 259399),
(440306, 'PF02806', NULL, 'Alpha amylase, C-terminal all-beta domain', 96, NULL, 'Alpha-amylase_C', 259400);
INSERT INTO "PUBLIC"."MODEL" VALUES
(440307, 'PF17686', NULL, 'Family of unknown function (DUF5534)', 183, NULL, 'DUF5534', 259401),
(440308, 'PF10017', NULL, 'Histidine-specific methyltransferase, SAM-dependent', 309, NULL, 'Methyltransf_33', 259402),
(440309, 'PF03930', NULL, 'Recombinase Flp protein N-terminus', 82, NULL, 'Flp_N', 259403),
(440310, 'PF16193', NULL, 'AAA C-terminal domain', 82, NULL, 'AAA_assoc_2', 259404),
(440311, 'PF18182', NULL, 'minimal CRISPR polymerase domain', 114, NULL, 'mCpol', 259405),
(440312, 'PF00453', NULL, 'Ribosomal protein L20', 107, NULL, 'Ribosomal_L20', 259406),
(440313, 'PF04784', NULL, 'Protein of unknown function, DUF547', 125, NULL, 'DUF547', 259407),
(440314, 'PF05974', NULL, 'Domain of unknown function (DUF892)', 159, NULL, 'DUF892', 259408),
(440315, 'PF10192', NULL, 'Rhodopsin-like GPCR transmembrane domain', 256, NULL, 'GpcrRhopsn4', 259409),
(440316, 'PF01065', NULL, 'Hexon, adenovirus major coat protein, N-terminal domain', 586, NULL, 'Adeno_hexon', 259410),
(440317, 'PF11040', NULL, 'Dispersed gene family protein 1 of Trypanosoma cruzi C-terminus', 87, NULL, 'DGF-1_C', 259411),
(440318, 'PF09435', NULL, 'Fungal protein of unknown function (DUF2015)', 112, NULL, 'DUF2015', 259412),
(440319, 'PF09102', NULL, 'Exotoxin A, targeting', 142, NULL, 'Exotox-A_target', 259413),
(440320, 'PF09373', NULL, 'Pseudomurein-binding repeat', 33, NULL, 'PMBR', 259414),
(440321, 'PF02457', NULL, 'DisA bacterial checkpoint controller nucleotide-binding', 119, NULL, 'DAC', 259415),
(440322, 'PF20514', NULL, 'ROXA-like winged helix', 119, NULL, 'ROXA-like_wH', 259416),
(440323, 'PF03735', NULL, 'ENT domain', 71, NULL, 'ENT', 259417),
(440324, 'PF13239', NULL, '2TM domain', 78, NULL, '2TM', 259418),
(440325, 'PF17980', NULL, 'Cysteine rich ADD domain in DNMT3', 56, NULL, 'ADD_DNMT3', 259419),
(440326, 'PF19847', NULL, 'Family of unknown function (DUF6322)', 101, NULL, 'DUF6322', 259420),
(440327, 'PF20324', NULL, 'Family of unknown function (DUF6619)', 100, NULL, 'DUF6619', 259421),
(440328, 'PF01634', NULL, 'ATP phosphoribosyltransferase', 159, NULL, 'HisG', 259422),
(440329, 'PF08390', NULL, 'TRAM1-like protein', 63, NULL, 'TRAM1', 259423),
(440330, 'PF03694', NULL, 'Erg28 like protein', 112, NULL, 'Erg28', 259424),
(440331, 'PF09069', NULL, 'EF-hand', 89, NULL, 'EF-hand_3', 259425),
(440332, 'PF07015', NULL, 'VirC1 protein', 231, NULL, 'VirC1', 259426),
(440333, 'PF19042', NULL, 'Nuclear cap binding complex subunit CBP110', 986, NULL, 'CBP110', 259427),
(440334, 'PF07421', NULL, 'Neurotensin/neuromedin N precursor', 161, NULL, 'Pro-NT_NN', 259428),
(440335, 'PF12967', NULL, 'Domain of Unknown Function with PDB structure (DUF3855)', 158, NULL, 'DUF3855', 259429),
(440336, 'PF05970', NULL, 'PIF1-like helicase', 362, NULL, 'PIF1', 259430),
(440337, 'PF11285', NULL, 'Protein of unknown function (DUF3086)', 277, NULL, 'DUF3086', 259431),
(440338, 'PF16963', NULL, 'PelD GGDEF domain', 125, NULL, 'PelD_GGDEF', 259432),
(440339, 'PF16669', NULL, 'Tetratricopeptide repeat protein 5 OB fold domain', 115, NULL, 'TTC5_OB', 259433),
(440340, 'PF15722', NULL, 'FAM153 family', 114, NULL, 'FAM153', 259434),
(440341, 'PF15163', NULL, 'Meiosis-expressed', 75, NULL, 'Meiosis_expr', 259435),
(440342, 'PF00086', NULL, 'Thyroglobulin type-1 repeat', 67, NULL, 'Thyroglobulin_1', 259436),
(440343, 'PF15050', NULL, 'SCIMP protein', 132, NULL, 'SCIMP', 259437),
(440344, 'PF14696', NULL, 'Hydroxyphenylpyruvate dioxygenase, HPPD, N-terminal', 139, NULL, 'Glyoxalase_5', 259438),
(440345, 'PF02423', NULL, 'Ornithine cyclodeaminase/mu-crystallin family', 320, NULL, 'OCD_Mu_crystall', 259439),
(440346, 'PF05608', NULL, 'Protein of unknown function (DUF778)', 189, NULL, 'DUF778', 259440),
(440347, 'PF20113', NULL, 'Family of unknown function (DUF6503)', 235, NULL, 'DUF6503', 259441),
(440348, 'PF08388', NULL, 'Group II intron, maturase-specific domain', 80, NULL, 'GIIM', 259442),
(440349, 'PF20188', NULL, 'Family of unknown function (DUF6551)', 241, NULL, 'DUF6551', 259443),
(440350, 'PF02938', NULL, 'GAD domain', 95, NULL, 'GAD', 259444);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(440351, 'PF07718', NULL, 'Coatomer beta C-terminal region', 140, NULL, 'Coatamer_beta_C', 259445),
(440352, 'PF18219', NULL, 'SidC N-terminal domain', 465, NULL, 'SidC_N', 259446),
(440353, 'PF20408', NULL, 'Alpha/beta hydrolase domain', 194, NULL, 'Abhydrolase_11', 259447),
(440354, 'PF19065', NULL, 'Family of unknown function (DUF5761)', 62, NULL, 'DUF5761', 259448),
(440355, 'PF05609', NULL, 'Lamina-associated polypeptide 1, AAA+ activator domain', 233, NULL, 'LAP1_C', 259449),
(440356, 'PF13021', NULL, 'Domain of unknown function (DUF3885)', 38, NULL, 'DUF3885', 259450),
(440357, 'PF10483', NULL, 'Elongator subunit Iki1', 298, NULL, 'Elong_Iki1', 259451),
(440358, 'PF19841', NULL, 'Gliding motility associated protein GldN', 220, NULL, 'GldN', 259452),
(440359, 'PF01755', NULL, 'Glycosyltransferase family 25 (LPS biosynthesis protein)', 200, NULL, 'Glyco_transf_25', 259453),
(440360, 'PF11146', NULL, 'Protein of unknown function (DUF2905)', 63, NULL, 'DUF2905', 259454),
(440361, 'PF06021', NULL, 'Aralkyl acyl-CoA:amino acid N-acyltransferase', 205, NULL, 'Gly_acyl_tr_N', 259455),
(440362, 'PF10618', NULL, 'Phage tail tube protein', 117, NULL, 'Tail_tube', 259456),
(440363, 'PF20434', NULL, 'BD-FAE', 215, NULL, 'BD-FAE', 259457),
(440364, 'PF02078', NULL, 'Synapsin, N-terminal domain', 102, NULL, 'Synapsin', 259458),
(440365, 'PF09963', NULL, 'Uncharacterized protein conserved in bacteria (DUF2197)', 56, NULL, 'DUF2197', 259459),
(440366, 'PF01338', NULL, 'Bacillus thuringiensis toxin', 230, NULL, 'Bac_thur_toxin', 259460),
(440367, 'PF04814', NULL, 'Hepatocyte nuclear factor 1 (HNF-1), N terminus', 191, NULL, 'HNF-1_N', 259461),
(440368, 'PF05767', NULL, 'Poxvirus virion envelope protein A14', 93, NULL, 'Pox_A14', 259462),
(440369, 'PF19974', NULL, 'Ternary complex associated domain 9', 435, NULL, 'TCAD9', 259463),
(440370, 'PF04920', NULL, 'Beet necrotic yellow vein virus, p31', 126, NULL, 'BNYVV_p31', 259464),
(440371, 'PF00384', NULL, 'Molybdopterin oxidoreductase', 432, NULL, 'Molybdopterin', 259465),
(440372, 'PF18152', NULL, 'DAHP synthase ferredoxin-like domain', 67, NULL, 'DAHP_snth_FXD', 259466),
(440373, 'PF00749', NULL, 'tRNA synthetases class I (E and Q), catalytic domain', 314, NULL, 'tRNA-synt_1c', 259467),
(440374, 'PF18351', NULL, 'Fungal Argonaute N-terminal domain', 95, NULL, 'Ago_N_1', 259468),
(440375, 'PF20400', NULL, 'BAR-like domain', 192, NULL, 'BAR_4', 259469),
(440376, 'PF13580', NULL, 'SIS domain', 138, NULL, 'SIS_2', 259470),
(440377, 'PF14776', NULL, 'Cation-channel complex subunit UNC-79', 524, NULL, 'UNC-79', 259471),
(440378, 'PF08716', NULL, 'Coronavirus replicase NSP7', 83, NULL, 'CoV_NSP7', 259472),
(440379, 'PF08730', NULL, 'Rad33', 165, NULL, 'Rad33', 259473),
(440380, 'PF03613', NULL, 'PTS system mannose/fructose/sorbose family IID component', 265, NULL, 'EIID-AGA', 259474),
(440381, 'PF09825', NULL, 'Biotin-protein ligase, N terminal', 282, NULL, 'BPL_N', 259475),
(440382, 'PF07109', NULL, 'Magnesium-protoporphyrin IX methyltransferase C-terminus', 97, NULL, 'Mg-por_mtran_C', 259476),
(440383, 'PF18795', NULL, 'DNA mismatch repair protein HSM3, N terminal domain', 237, NULL, 'HSM3_N', 259477),
(440384, 'PF06249', NULL, 'Ethanolamine utilisation protein EutQ', 152, NULL, 'EutQ', 259478),
(440385, 'PF14277', NULL, 'Domain of unknown function (DUF4364)', 162, NULL, 'DUF4364', 259479),
(440386, 'PF18896', NULL, 'Lysozyme like domain', 89, NULL, 'SLT_3', 259480),
(440387, 'PF20233', NULL, 'Family of unknown function (DUF6590)', 152, NULL, 'DUF6590', 259481),
(440388, 'PF00982', NULL, 'Glycosyltransferase family 20', 474, NULL, 'Glyco_transf_20', 259482),
(440389, 'PF09562', NULL, 'LlaMI restriction endonuclease', 242, NULL, 'RE_LlaMI', 259483),
(440390, 'PF12265', NULL, 'Histone-binding protein RBBP4 or subunit C of CAF1 complex', 69, NULL, 'CAF1C_H4-bd', 259484),
(440391, 'PF11011', NULL, 'Protein of unknown function (DUF2849)', 86, NULL, 'DUF2849', 259485),
(440392, 'PF11416', NULL, 'Syntaxin-5 N-terminal, Sly1p-binding domain', 23, NULL, 'Syntaxin-5_N', 259486);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(440393, 'PF13945', NULL, 'Salt tolerance down-regulator', 192, NULL, 'NST1', 259487),
(440394, 'PF09740', NULL, 'Uncharacterized conserved protein (DUF2043)', 106, NULL, 'DUF2043', 259488),
(440395, 'PF11073', NULL, 'Rift valley fever virus non structural protein (NSs) like', 242, NULL, 'NSs', 259489),
(440396, 'PF17653', NULL, 'Family of unknown function (DUF5522)', 48, NULL, 'DUF5522', 259490),
(440397, 'PF13421', NULL, 'SPFH domain-Band 7 family', 211, NULL, 'Band_7_1', 259491),
(440398, 'PF01408', NULL, 'Oxidoreductase family, NAD-binding Rossmann fold', 120, NULL, 'GFO_IDH_MocA', 259492),
(440399, 'PF02678', NULL, 'Pirin', 108, NULL, 'Pirin', 259493),
(440400, 'PF12864', NULL, 'Protein of unknown function (DUF3822)', 241, NULL, 'DUF3822', 259494),
(440401, 'PF10383', NULL, 'Transcription-silencing protein Clr2', 143, NULL, 'Clr2', 259495),
(440402, 'PF01186', NULL, 'Lysyl oxidase', 204, NULL, 'Lysyl_oxidase', 259496),
(440403, 'PF01365', NULL, 'RIH domain', 201, NULL, 'RYDR_ITPR', 259497),
(440404, 'PF10398', NULL, 'Protein of unknown function (DUF2443)', 79, NULL, 'DUF2443', 259498),
(440405, 'PF08312', NULL, 'cwf21 domain', 44, NULL, 'cwf21', 259499),
(440406, 'PF07435', NULL, 'YycH protein', 438, NULL, 'YycH', 259500),
(440407, 'PF13509', NULL, 'S1 domain', 61, NULL, 'S1_2', 259501),
(440408, 'PF15374', NULL, 'Coiled-coil domain-containing protein 71L', 393, NULL, 'CCDC71L', 259502),
(440409, 'PF02563', NULL, 'Polysaccharide biosynthesis/export protein', 82, NULL, 'Poly_export', 259503),
(440410, 'PF11858', NULL, 'Domain of unknown function (DUF3378)', 76, NULL, 'DUF3378', 259504),
(440411, 'PF04327', NULL, 'Cysteine protease Prp', 90, NULL, 'Peptidase_Prp', 259505),
(440412, 'PF13038', NULL, 'Domain of unknown function (DUF3899)', 86, NULL, 'DUF3899', 259506),
(440413, 'PF08244', NULL, 'Glycosyl hydrolases family 32 C terminal', 158, NULL, 'Glyco_hydro_32C', 259507),
(440414, 'PF11826', NULL, 'Protein of unknown function (DUF3346)', 225, NULL, 'DUF3346', 259508),
(440415, 'PF13831', NULL, 'PHD-finger', 36, NULL, 'PHD_2', 259509),
(440416, 'PF03620', NULL, 'IBV 3C protein', 92, NULL, 'IBV_3C', 259510),
(440417, 'PF08031', NULL, 'Berberine and berberine like', 46, NULL, 'BBE', 259511),
(440418, 'PF15631', NULL, 'NTF2 fold immunity protein', 72, NULL, 'Imm-NTF2-2', 259512),
(440419, 'PF06644', NULL, 'ATP11 protein', 271, NULL, 'ATP11', 259513),
(440420, 'PF12096', NULL, 'Protein of unknown function (DUF3572)', 84, NULL, 'DUF3572', 259514),
(440421, 'PF16248', NULL, 'Domain of unknown function (DUF4905)', 83, NULL, 'DUF4905', 259515),
(440422, 'PF17791', NULL, 'Macroglobulin domain MG3', 85, NULL, 'MG3', 259516),
(440423, 'PF03459', NULL, 'TOBE domain', 64, NULL, 'TOBE', 259517),
(440424, 'PF17497', NULL, 'Family of unknown function (DUF5432)', 74, NULL, 'DUF5432', 259518),
(440425, 'PF13759', NULL, 'Putative 2OG-Fe(II) oxygenase', 101, NULL, '2OG-FeII_Oxy_5', 259519),
(440426, 'PF00919', NULL, 'Uncharacterized protein family UPF0004', 98, NULL, 'UPF0004', 259520),
(440427, 'PF17257', NULL, 'Family of unknown function (DUF5323)', 62, NULL, 'DUF5323', 259521),
(440428, 'PF00813', NULL, 'FliP family', 191, NULL, 'FliP', 259522),
(440429, 'PF01001', NULL, 'Hepatitis C virus non-structural protein NS4b', 192, NULL, 'HCV_NS4b', 259523),
(440430, 'PF10910', NULL, 'Protein of unknown function (DUF2744)', 118, NULL, 'DUF2744', 259524),
(440431, 'PF05890', NULL, 'Eukaryotic rRNA processing protein EBP2', 247, NULL, 'Ebp2', 259525),
(440432, 'PF16350', NULL, 'FAD dependent oxidoreductase central domain', 56, NULL, 'FAO_M', 259526),
(440433, 'PF09826', NULL, 'Beta propeller domain', 511, NULL, 'Beta_propel', 259527),
(440434, 'PF01692', NULL, 'Paramyxovirus non-structural protein C', 204, NULL, 'Paramyxo_C', 259528),
(440435, 'PF17329', NULL, 'Family of unknown function (DUF5367)', 98, NULL, 'DUF5367', 259529),
(440436, 'PF13581', NULL, 'Histidine kinase-like ATPase domain', 125, NULL, 'HATPase_c_2', 259530),
(440437, 'PF19840', NULL, 'Family of unknown function (DUF6317)', 100, NULL, 'DUF6317', 259531); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(440438, 'PF16329', NULL, 'Pestivirus envelope glycoprotein E2', 372, NULL, 'Pestivirus_E2', 259532),
(440439, 'PF17582', NULL, 'Cytomegalovirus UL20', 304, NULL, 'UL20', 259533),
(440440, 'PF18849', NULL, 'Bacterial archaeo-eukaryotic release factor family 7', 144, NULL, 'baeRF_family7', 259534),
(440441, 'PF14311', NULL, 'Probable Zinc-ribbon domain', 56, NULL, 'DUF4379', 259535),
(440442, 'PF19806', NULL, 'Family of unknown function (DUF6289)', 43, NULL, 'DUF6289', 259536),
(440443, 'PF15322', NULL, 'Protein missing in infertile sperm 1, putative', 315, NULL, 'PMSI1', 259537),
(440444, 'PF17420', NULL, 'Superinfection exclusion gene product 17', 98, NULL, 'GP17', 259538),
(440445, 'PF12832', NULL, 'MFS_1 like family', 385, NULL, 'MFS_1_like', 259539),
(440446, 'PF06972', NULL, 'GBF-interacting protein 1 N-terminal', 60, NULL, 'GIP1_N', 259540),
(440447, 'PF13486', NULL, 'Reductive dehalogenase subunit', 288, NULL, 'Dehalogenase', 259541),
(440448, 'PF00032', NULL, 'Cytochrome b(C-terminal)/b6/petD', 103, NULL, 'Cytochrom_B_C', 259542),
(440449, 'PF15647', NULL, 'Restriction endonuclease fold toxin 3', 102, NULL, 'Tox-REase-3', 259543),
(440450, 'PF06573', NULL, 'Churchill protein', 111, NULL, 'Churchill', 259544),
(440451, 'PF15637', NULL, 'HNH/Endo VII superfamily nuclease toxin with a HHH motif', 103, NULL, 'Tox-HNH-HHH', 259545),
(440452, 'PF02065', NULL, 'Melibiase', 347, NULL, 'Melibiase', 259546),
(440453, 'PF06501', NULL, 'Human herpesvirus U55 protein', 432, NULL, 'Herpes_U55', 259547),
(440454, 'PF02676', NULL, 'Methyltransferase TYW3', 227, NULL, 'TYW3', 259548),
(440455, 'PF04257', NULL, 'Exodeoxyribonuclease V, gamma subunit', 314, NULL, 'Exonuc_V_gamma', 259549),
(440456, 'PF14803', NULL, 'Nudix N-terminal', 34, NULL, 'Nudix_N_2', 259550),
(440457, 'PF01011', NULL, 'PQQ enzyme repeat', 38, NULL, 'PQQ', 259551),
(440458, 'PF14824', NULL, 'Sirohaem biosynthesis protein central', 28, NULL, 'Sirohm_synth_M', 259552),
(440459, 'PF16589', NULL, 'BRCT domain, a BRCA1 C-terminus domain', 85, NULL, 'BRCT_2', 259553),
(440460, 'PF16571', NULL, 'FBP C-terminal treble-clef zinc-finger', 155, NULL, 'FBP_C', 259554),
(440461, 'PF00856', NULL, 'SET domain', 169, NULL, 'SET', 259555),
(440462, 'PF08748', NULL, 'Phage tail assembly chaperone', 128, NULL, 'Phage_TAC_4', 259556),
(440463, 'PF15910', NULL, 'ICOS V-set domain', 113, NULL, 'V-set_2', 259557),
(440464, 'PF07981', NULL, 'Plasmodium repeat_MYXSPDY', 17, NULL, 'Plasmod_MYXSPDY', 259558),
(440465, 'PF10234', NULL, 'Clusterin-associated protein-1', 268, NULL, 'Cluap1', 259559),
(440466, 'PF04200', NULL, 'Lipoprotein associated domain', 84, NULL, 'Lipoprotein_17', 259560),
(440467, 'PF06853', NULL, 'Protein of unknown function (DUF1249)', 116, NULL, 'DUF1249', 259561),
(440468, 'PF07962', NULL, 'Replication Fork Protection Component Swi3', 84, NULL, 'Swi3', 259562),
(440469, 'PF13707', NULL, 'RloB-like protein', 196, NULL, 'RloB', 259563),
(440470, 'PF19766', NULL, 'Family of unknown function (DUF6253)', 81, NULL, 'DUF6253', 259564),
(440471, 'PF12371', NULL, 'Transmembrane protein 131-like N-terminal', 84, NULL, 'TMEM131_like_N', 259565),
(440472, 'PF12679', NULL, 'ABC-2 family transporter protein', 288, NULL, 'ABC2_membrane_2', 259566),
(440473, 'PF14490', NULL, 'Helix-hairpin-helix containing domain', 92, NULL, 'HHH_4', 259567),
(440474, 'PF20128', NULL, 'Family of unknown function (DUF6518)', 204, NULL, 'DUF6518', 259568),
(440475, 'PF00311', NULL, 'Phosphoenolpyruvate carboxylase', 920, NULL, 'PEPcase', 259569),
(440476, 'PF07408', NULL, 'Protein of unknown function (DUF1507)', 85, NULL, 'DUF1507', 259570),
(440477, 'PF11982', NULL, 'Domain of unknown function (DUF3483)', 218, NULL, 'DUF3483', 259571),
(440478, 'PF04641', NULL, 'Rtf2 RING-finger', 262, NULL, 'Rtf2', 259572),
(440479, 'PF08663', NULL, 'HalX domain', 67, NULL, 'HalX', 259573),
(440480, 'PF10807', NULL, 'Protein of unknown function (DUF2541)', 130, NULL, 'DUF2541', 259574),
(440481, 'PF03524', NULL, 'Conjugal transfer protein', 206, NULL, 'CagX', 259575),
(440482, 'PF10778', NULL, 'Halocarboxylic acid dehydrogenase DehI', 148, NULL, 'DehI', 259576);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(440483, 'PF12699', NULL, 'phiKZ-like phage internal head proteins', 339, NULL, 'phiKZ_IP', 259577),
(440484, 'PF14829', NULL, 'Glycerol-3-phosphate acyltransferase N-terminal', 76, NULL, 'GPAT_N', 259578),
(440485, 'PF01031', NULL, 'Dynamin central region', 287, NULL, 'Dynamin_M', 259579),
(440486, 'PF06475', NULL, 'Putative glycolipid-binding', 178, NULL, 'Glycolipid_bind', 259580),
(440487, 'PF01973', NULL, '6-hydroxymethylpterin diphosphokinase MptE-like', 171, NULL, 'MptE-like', 259581),
(440488, 'PF17961', NULL, 'Bacterial Ig domain', 102, NULL, 'Big_8', 259582),
(440489, 'PF10964', NULL, 'Protein of unknown function (DUF2766)', 79, NULL, 'DUF2766', 259583),
(440490, 'PF17799', NULL, 'Rrp7 RRM-like N-terminal domain', 161, NULL, 'RRM_Rrp7', 259584),
(440491, 'PF00205', NULL, 'Thiamine pyrophosphate enzyme, central domain', 137, NULL, 'TPP_enzyme_M', 259585),
(440492, 'PF09163', NULL, 'Formate dehydrogenase N, transmembrane', 44, NULL, 'Form-deh_trans', 259586),
(440493, 'PF11876', NULL, 'Protein of unknown function (DUF3396)', 207, NULL, 'DUF3396', 259587),
(440494, 'PF15285', NULL, 'Beclin-1 BH3 domain, Bcl-2-interacting', 25, NULL, 'BH3', 259588),
(440495, 'PF09212', NULL, 'Carbohydrate binding module 27', 170, NULL, 'CBM27', 259589),
(440496, 'PF03335', NULL, 'Phage tail fibre repeat', 14, NULL, 'Phage_fiber', 259590),
(440497, 'PF08256', NULL, 'Aurein-like antibiotic peptide', 13, NULL, 'Antimicrobial20', 259591),
(440498, 'PF09038', NULL, 'Tumour suppressor p53-binding protein-1 Tudor', 122, NULL, '53-BP1_Tudor', 259592),
(440499, 'PF15981', NULL, 'Envelope glycoprotein GP 5 of equine arteritis virus', 80, NULL, 'EAV_GP5', 259593),
(440500, 'PF17443', NULL, 'Uncharacterized protein pXO2-72', 62, NULL, 'pXO2-72', 259594),
(440501, 'PF19602', NULL, 'Family of unknown function (DUF6107)', 106, NULL, 'DUF6107', 259595),
(440502, 'PF00364', NULL, 'Biotin-requiring enzyme', 73, NULL, 'Biotin_lipoyl', 259596),
(440503, 'PF00733', NULL, 'Asparagine synthase', 355, NULL, 'Asn_synthase', 259597),
(440504, 'PF05235', NULL, 'CHAD domain', 226, NULL, 'CHAD', 259598),
(440505, 'PF13293', NULL, 'Domain of unknown function (DUF4074)', 63, NULL, 'DUF4074', 259599),
(440506, 'PF17416', NULL, 'Herpesvirus Glycoprotein B', 210, NULL, 'Glycoprot_B_PH1', 259600),
(440507, 'PF14221', NULL, 'Domain of unknown function (DUF4330)', 167, NULL, 'DUF4330', 259601),
(440508, 'PF20236', NULL, 'Family of unknown function (DUF6593)', 152, NULL, 'DUF6593', 259602),
(440509, 'PF13154', NULL, 'Protein of unknown function (DUF3991)', 76, NULL, 'DUF3991', 259603),
(440510, 'PF15328', NULL, 'Putative GRINL1B complex locus protein 2', 214, NULL, 'GCOM2', 259604),
(440511, 'PF16300', NULL, 'Type of WD40 repeat', 44, NULL, 'WD40_4', 259605),
(440512, 'PF02794', NULL, 'RTX toxin acyltransferase family', 127, NULL, 'HlyC', 259606),
(440513, 'PF11601', NULL, 'Shal-type voltage-gated potassium channels, N-terminal', 28, NULL, 'Shal-type', 259607),
(440514, 'PF02102', NULL, 'Deuterolysin metalloprotease (M35) family', 359, NULL, 'Peptidase_M35', 259608),
(440515, 'PF13309', NULL, 'HTH domain', 63, NULL, 'HTH_22', 259609),
(440516, 'PF00679', NULL, 'Elongation factor G C-terminus', 89, NULL, 'EFG_C', 259610),
(440517, 'PF13301', NULL, 'Protein of unknown function (DUF4079)', 141, NULL, 'DUF4079', 259611),
(440518, 'PF08753', NULL, 'NikR C terminal nickel binding domain', 77, NULL, 'NikR_C', 259612),
(440519, 'PF18618', NULL, 'HP0268', 80, NULL, 'HP0268', 259613),
(440520, 'PF06124', NULL, 'Staphylococcal protein of unknown function (DUF960)', 94, NULL, 'DUF960', 259614),
(440521, 'PF17539', NULL, 'Family of unknown function (DUF5456)', 152, NULL, 'DUF5456', 259615),
(440522, 'PF11791', NULL, 'Aconitate B N-terminal domain', 153, NULL, 'Aconitase_B_N', 259616),
(440523, 'PF01899', NULL, 'Na+/H+ ion antiporter subunit', 146, NULL, 'MNHE', 259617),
(440524, 'PF03205', NULL, 'Molybdopterin guanine dinucleotide synthesis protein B', 134, NULL, 'MobB', 259618),
(440525, 'PF02538', NULL, 'Hydantoinase B/oxoprolinase', 517, NULL, 'Hydantoinase_B', 259619);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(440526, 'PF17719', NULL, 'Family of unknown function (DUF5564)', 98, NULL, 'DUF5564', 259620),
(440527, 'PF17755', NULL, 'UvrA DNA-binding domain', 110, NULL, 'UvrA_DNA-bind', 259621),
(440528, 'PF10235', NULL, 'Microtubule-associated protein CRIPT', 88, NULL, 'Cript', 259622),
(440529, 'PF18272', NULL, 'single-stranded DNA binding TraI N-terminal subdomain', 53, NULL, 'ssDNA_TraI_N', 259623),
(440530, 'PF04795', NULL, 'PAPA-1-like conserved region', 86, NULL, 'PAPA-1', 259624),
(440531, 'PF19879', NULL, 'Family of unknown function (DUF6352)', 290, NULL, 'DUF6352', 259625),
(440532, 'PF04741', NULL, 'InvH outer membrane lipoprotein', 147, NULL, 'InvH', 259626),
(440533, 'PF19220', NULL, 'Crescentin protein', 401, NULL, 'Crescentin', 259627),
(440534, 'PF00975', NULL, 'Thioesterase domain', 230, NULL, 'Thioesterase', 259628),
(440535, 'PF17224', NULL, 'Domain of unknown function (DUF5300)', 98, NULL, 'DUF5300', 259629),
(440536, 'PF19471', NULL, 'Family of unknown function (DUF6008)', 238, NULL, 'DUF6008', 259630),
(440537, 'PF10509', NULL, 'Galactokinase galactose-binding signature', 50, NULL, 'GalKase_gal_bdg', 259631),
(440538, 'PF16082', NULL, 'Bacteriophage holin family, superfamily II-like', 76, NULL, 'Phage_holin_2_4', 259632),
(440539, 'PF00370', NULL, 'FGGY family of carbohydrate kinases, N-terminal domain', 245, NULL, 'FGGY_N', 259633),
(440540, 'PF08829', NULL, 'Alpha C protein N terminal', 106, NULL, 'AlphaC_N', 259634),
(440541, 'PF19300', NULL, 'Binding-prot-dependent transport system membrane comp, N-term', 114, NULL, 'BPD_transp_1_N', 259635),
(440542, 'PF12386', NULL, 'Pseudomurein endo-isopeptidase Pei', 149, NULL, 'Peptidase_C71', 259636),
(440543, 'PF13074', NULL, 'Protein of unknown function (DUF3938)', 98, NULL, 'DUF3938', 259637),
(440544, 'PF04344', NULL, 'Chemotaxis phosphatase, CheZ', 201, NULL, 'CheZ', 259638),
(440545, 'PF10852', NULL, 'Protein of unknown function (DUF2651)', 73, NULL, 'DUF2651', 259639),
(440546, 'PF18615', NULL, 'Short myomegalin-like EB1 binding proteins, N-terminal domain', 388, NULL, 'SMYLE_N', 259640),
(440547, 'PF18389', NULL, 'TrmO C-terminal domain', 65, NULL, 'TrmO_C', 259641),
(440548, 'PF20145', NULL, 'ARMET, N-terminal', 96, NULL, 'ARMET_N', 259642),
(440549, 'PF18738', NULL, 'DZIP3/ hRUL138-like HEPN', 143, NULL, 'HEPN_DZIP3', 259643),
(440550, 'PF04811', NULL, 'Sec23/Sec24 trunk domain', 243, NULL, 'Sec23_trunk', 259644),
(440551, 'PF09936', NULL, 'SAM-dependent RNA methyltransferase', 182, NULL, 'Methyltrn_RNA_4', 259645),
(440552, 'PF01392', NULL, 'Fz domain', 117, NULL, 'Fz', 259646),
(440553, 'PF04834', NULL, 'Early E3 14.5 kDa protein', 100, NULL, 'Adeno_E3_14_5', 259647),
(440554, 'PF10026', NULL, 'Predicted Zn-dependent protease (DUF2268)', 195, NULL, 'DUF2268', 259648),
(440555, 'PF02122', NULL, 'Peptidase S39', 203, NULL, 'Peptidase_S39', 259649),
(440556, 'PF02245', NULL, 'Methylpurine-DNA glycosylase (MPG)', 183, NULL, 'Pur_DNA_glyco', 259650),
(440557, 'PF01584', NULL, 'CheW-like domain', 138, NULL, 'CheW', 259651),
(440558, 'PF05595', NULL, 'Domain of unknown function (DUF771)', 90, NULL, 'DUF771', 259652),
(440559, 'PF05617', NULL, 'Prolamin-like', 67, NULL, 'Prolamin_like', 259653),
(440560, 'PF15836', NULL, 'SSTK-interacting protein, TSSK6-activating co-chaperone protein', 125, NULL, 'SSTK-IP', 259654),
(440561, 'PF07681', NULL, 'DoxX', 85, NULL, 'DoxX', 259655),
(440562, 'PF11267', NULL, 'Domain of unknown function (DUF3067)', 98, NULL, 'DUF3067', 259656),
(440563, 'PF12230', NULL, 'Pre-mRNA splicing factor PRP21 like protein', 217, NULL, 'PRP21_like_P', 259657),
(440564, 'PF20585', NULL, 'Putative pectate lyase-like adhesive domain', 126, NULL, 'Pectate_lyase_5', 259658),
(440565, 'PF01542', NULL, 'Hepatitis C virus core protein', 75, NULL, 'HCV_core', 259659),
(440566, 'PF13240', NULL, 'zinc-ribbon domain', 23, NULL, 'zinc_ribbon_2', 259660),
(440567, 'PF18301', NULL, 'pre ATP-grasp 3 domain', 76, NULL, 'preATP-grasp_3', 259661),
(440568, 'PF16435', NULL, 'Domain of unknown function (DUF5032)', 259, NULL, 'DUF5032', 259662);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(440569, 'PF08982', NULL, 'Acetylaranotin biosynthesis cluster protein L', 149, NULL, 'AtaL', 259663),
(440570, 'PF16162', NULL, 'Domain of unknown function (DUF4868)', 187, NULL, 'DUF4868', 259664),
(440571, 'PF15915', NULL, 'GAF and HTH_10 associated domain', 156, NULL, 'BAT', 259665),
(440572, 'PF07059', NULL, 'Protein ENHANCED DISEASE RESISTANCE 2, C-terminal', 213, NULL, 'EDR2_C', 259666),
(440573, 'PF18898', NULL, 'Family of unknown function (DUF5654)', 71, NULL, 'DUF5654', 259667),
(440574, 'PF20208', NULL, 'Family of unknown function (DUF6569)', 300, NULL, 'DUF6569', 259668),
(440575, 'PF18673', NULL, 'interleukin receptor mimic protein A', 109, NULL, 'IrmA', 259669),
(440576, 'PF20413', NULL, 'Kiaa1109 N-terminal region', 965, NULL, 'Kiaa1109_N', 259670),
(440577, 'PF07026', NULL, 'Protein of unknown function (DUF1317)', 60, NULL, 'DUF1317', 259671),
(440578, 'PF09198', NULL, 'Bacteriophage T4 beta-glucosyltransferase', 38, NULL, 'T4-Gluco-transf', 259672),
(440579, 'PF01753', NULL, 'MYND finger', 40, NULL, 'zf-MYND', 259673),
(440580, 'PF12359', NULL, 'Protein of unknown function (DUF3645)', 33, NULL, 'DUF3645', 259674),
(440581, 'PF18225', NULL, 'Sensor histidine kinase (AbfS) sensor domain', 65, NULL, 'AbfS_sensor', 259675),
(440582, 'PF19886', NULL, 'Domain of unknown function (DUF6359)', 110, NULL, 'DUF6359', 259676),
(440583, 'PF13332', NULL, 'Hemagglutinin repeat', 170, NULL, 'Fil_haemagg_2', 259677),
(440584, 'PF20571', NULL, 'Domain of unknown function (DUF6780)', 62, NULL, 'DUF6780', 259678),
(440585, 'PF14633', NULL, 'SH2 domain', 215, NULL, 'SH2_2', 259679),
(440586, 'PF06167', NULL, 'Glucose-regulated metallo-peptidase M90', 245, NULL, 'Peptidase_M90', 259680),
(440587, 'PF18636', NULL, 'Mitochondrial morphogenesis protein SLD7 N-terminal domain', 125, NULL, 'Sld7_N', 259681),
(440588, 'PF10182', NULL, 'Flo11 domain', 150, NULL, 'Flo11', 259682),
(440589, 'PF19011', NULL, 'Family of unknown function (DUF5740)', 94, NULL, 'DUF5740', 259683),
(440590, 'PF07682', NULL, 'Sulphur oxygenase reductase', 302, NULL, 'SOR', 259684),
(440591, 'PF14777', NULL, 'Cilia BBSome complex subunit 10', 66, NULL, 'BBIP10', 259685),
(440592, 'PF17895', NULL, 'Giardia Dicer N-terminal domain', 144, NULL, 'Dicer_N', 259686),
(440593, 'PF10972', NULL, 'Peptidoglycan-binding protein, CsiV', 228, NULL, 'CsiV', 259687),
(440594, 'PF17281', NULL, 'Family of unknown function (DUF5346)', 102, NULL, 'DUF5346', 259688),
(440595, 'PF16766', NULL, 'Binding region of GANP to ENY2', 71, NULL, 'CID_GANP', 259689),
(440596, 'PF10033', NULL, 'Autophagy-related protein 13', 239, NULL, 'ATG13', 259690),
(440597, 'PF08652', NULL, 'RAI1 like PD-(D/E)XK nuclease', 68, NULL, 'RAI1', 259691),
(440598, 'PF18842', NULL, 'Large polyvalent protein associated domain 26', 57, NULL, 'LPD26', 259692),
(440599, 'PF15451', NULL, 'Domain of unknown function (DUF4632)', 71, NULL, 'DUF4632', 259693),
(440600, 'PF20225', NULL, 'Family of unknown function (DUF6584)', 167, NULL, 'DUF6584', 259694),
(440601, 'PF13121', NULL, 'Domain of unknown function (DUF3976)', 40, NULL, 'DUF3976', 259695),
(440602, 'PF13340', NULL, 'Putative transposase of IS4/5 family (DUF4096)', 75, NULL, 'DUF4096', 259696),
(440603, 'PF02171', NULL, 'Piwi domain', 302, NULL, 'Piwi', 259697),
(440604, 'PF05285', NULL, 'SDA1', 343, NULL, 'SDA1', 259698),
(440605, 'PF04378', NULL, 'Ribosomal RNA large subunit methyltransferase D, RlmJ', 245, NULL, 'RsmJ', 259699),
(440606, 'PF07529', NULL, 'HSA domain', 71, NULL, 'HSA', 259700),
(440607, 'PF08939', NULL, 'Domain of unknown function (DUF1917)', 261, NULL, 'DUF1917', 259701),
(440608, 'PF01820', NULL, 'D-ala D-ala ligase N-terminus', 108, NULL, 'Dala_Dala_lig_N', 259702),
(440609, 'PF04410', NULL, 'Gar1/Naf1 RNA binding region', 92, NULL, 'Gar1', 259703),
(440610, 'PF13773', NULL, 'Domain of unknown function (DUF4170)', 68, NULL, 'DUF4170', 259704),
(440611, 'PF17106', NULL, 'Sigma domain on NACHT-NTPases', 42, NULL, 'NACHT_sigma', 259705),
(440612, 'PF16560', NULL, 'Putative mobile pathogenicity island', 213, NULL, 'SAPI', 259706);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(440613, 'PF19745', NULL, 'Alpha-(1,6)-fucosyltransferase N- and catalytic domains', 499, NULL, 'FUT8_N_cat', 259707),
(440614, 'PF00365', NULL, 'Phosphofructokinase', 286, NULL, 'PFK', 259708),
(440615, 'PF04263', NULL, 'Thiamin pyrophosphokinase, catalytic domain', 121, NULL, 'TPK_catalytic', 259709),
(440616, 'PF08562', NULL, 'Crisp', 55, NULL, 'Crisp', 259710),
(440617, 'PF00181', NULL, 'Ribosomal Proteins L2, RNA binding domain', 77, NULL, 'Ribosomal_L2', 259711),
(440618, 'PF07176', NULL, 'Alpha/beta hydrolase of unknown function (DUF1400)', 127, NULL, 'DUF1400', 259712),
(440619, 'PF13399', NULL, 'LytR cell envelope-related transcriptional attenuator', 85, NULL, 'LytR_C', 259713),
(440620, 'PF14331', NULL, 'IcmF-related N-terminal domain', 259, NULL, 'IcmF-related_N', 259714),
(440621, 'PF06445', NULL, 'GyrI-like small molecule binding domain', 155, NULL, 'GyrI-like', 259715),
(440622, 'PF19970', NULL, 'vWA-MoxR associated protein middle region (VMAP-M) 9', 135, NULL, 'VMAP-M9', 259716),
(440623, 'PF14694', NULL, 'Lines N-terminus', 350, NULL, 'LINES_N', 259717),
(440624, 'PF11699', NULL, 'Mif2/CENP-C like', 85, NULL, 'CENP-C_C', 259718),
(440625, 'PF02274', NULL, 'Arginine deiminase', 377, NULL, 'ADI', 259719),
(440626, 'PF13617', NULL, 'YnbE-like lipoprotein', 34, NULL, 'Lipoprotein_19', 259720),
(440627, 'PF19964', NULL, 'Effector-associated domain 11', 80, NULL, 'EAD11', 259721),
(440628, 'PF19414', NULL, 'Astrovirus p19 protein', 174, NULL, 'Astro_p19', 259722),
(440629, 'PF02958', NULL, 'Ecdysteroid kinase-like family', 294, NULL, 'EcKL', 259723),
(440630, 'PF02475', NULL, 'Met-10+ like-protein', 199, NULL, 'Met_10', 259724),
(440631, 'PF11106', NULL, 'Exopolysaccharide production protein YjbE', 79, NULL, 'YjbE', 259725),
(440632, 'PF09677', NULL, 'Type-F conjugative transfer system protein (TrbI_Ftype)', 106, NULL, 'TrbI_Ftype', 259726),
(440633, 'PF01812', NULL, '5-formyltetrahydrofolate cyclo-ligase family', 187, NULL, '5-FTHF_cyc-lig', 259727),
(440634, 'PF10791', NULL, 'Mitochondrial F1-F0 ATP synthase subunit F of fungi', 92, NULL, 'F1F0-ATPsyn_F', 259728),
(440635, 'PF16346', NULL, 'Domain of unknown function (DUF4975)', 176, NULL, 'DUF4975', 259729),
(440636, 'PF11002', NULL, 'RFPL defining motif (RDM)', 42, NULL, 'RDM', 259730),
(440637, 'PF12912', NULL, 'NLPC_P60 stabilising domain, N term', 122, NULL, 'N_NLPC_P60', 259731),
(440638, 'PF00088', NULL, 'Trefoil (P-type) domain', 43, NULL, 'Trefoil', 259732),
(440639, 'PF04316', NULL, 'Anti-sigma-28 factor, FlgM', 55, NULL, 'FlgM', 259733),
(440640, 'PF18825', NULL, 'Large polyvalent protein-associated domain 13', 139, NULL, 'LPD13', 259734),
(440641, 'PF19976', NULL, 'GTPase-associated adaptor domain', 62, NULL, 'GAAD', 259735),
(440642, 'PF07520', NULL, 'Virulence factor SrfB', 988, NULL, 'SrfB', 259736),
(440643, 'PF12663', NULL, 'Protein of unknown function (DUF3788)', 127, NULL, 'DUF3788', 259737),
(440644, 'PF15839', NULL, 'Testis-expressed sequence 29 protein', 76, NULL, 'TEX29', 259738),
(440645, 'PF14050', NULL, 'N-terminal conserved domain of Nudc.', 60, NULL, 'Nudc_N', 259739),
(440646, 'PF16663', NULL, 'Unstructured region on MAGI', 60, NULL, 'MAGI_u1', 259740),
(440647, 'PF18798', NULL, 'Large polyvalent protein-associated domain 3', 113, NULL, 'LPD3', 259741),
(440648, 'PF14389', NULL, 'Leucine-zipper of ternary complex factor MIP1', 84, NULL, 'Lzipper-MIP1', 259742),
(440649, 'PF07829', NULL, 'Alpha-A conotoxin PIVA-like protein', 26, NULL, 'Toxin_14', 259743),
(440650, 'PF11516', NULL, 'Protein of unknown function (DUF3120)', 106, NULL, 'DUF3220', 259744),
(440651, 'PF09477', NULL, 'Bacterial type II secretion system chaperone protein (type_III_yscG)', 116, NULL, 'Type_III_YscG', 259745),
(440652, 'PF12105', NULL, 'SpoU, rRNA methylase, C-terminal', 54, NULL, 'SpoU_methylas_C', 259746),
(440653, 'PF16077', NULL, 'Spaetzle', 98, NULL, 'Spaetzle', 259747),
(440654, 'PF14181', NULL, 'YqfQ-like protein', 177, NULL, 'YqfQ', 259748),
(440655, 'PF03467', NULL, 'Smg-4/UPF3 family', 176, NULL, 'Smg4_UPF3', 259749);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(440656, 'PF10441', NULL, 'Urb2/Npa2 family', 206, NULL, 'Urb2', 259750),
(440657, 'PF02747', NULL, 'Proliferating cell nuclear antigen, C-terminal domain', 128, NULL, 'PCNA_C', 259751),
(440658, 'PF07695', NULL, '7TM diverse intracellular signalling', 205, NULL, '7TMR-DISM_7TM', 259752),
(440659, 'PF12501', NULL, 'Phosphate ATP-binding cassette transporter', 166, NULL, 'DUF3708', 259753),
(440660, 'PF03119', NULL, 'NAD-dependent DNA ligase C4 zinc finger domain', 27, NULL, 'DNA_ligase_ZBD', 259754),
(440661, 'PF13334', NULL, 'Domain of unknown function (DUF4094)', 90, NULL, 'DUF4094', 259755),
(440662, 'PF17502', NULL, 'Family of unknown function (DUF5434)', 186, NULL, 'DUF5434', 259756),
(440663, 'PF04159', NULL, 'NB glycoprotein', 100, NULL, 'NB', 259757),
(440664, 'PF12830', NULL, 'Sister chromatid cohesion C-terminus', 190, NULL, 'Nipped-B_C', 259758),
(440665, 'PF05378', NULL, 'Hydantoinase/oxoprolinase N-terminal region', 178, NULL, 'Hydant_A_N', 259759),
(440666, 'PF07555', NULL, 'beta-N-acetylglucosaminidase', 292, NULL, 'NAGidase', 259760),
(440667, 'PF03768', NULL, 'Attacin, N-terminal region', 64, NULL, 'Attacin_N', 259761),
(440668, 'PF18400', NULL, 'Thioredoxin-like domain', 193, NULL, 'Thioredoxin_12', 259762),
(440669, 'PF18633', NULL, 'Zinc-finger antiviral protein (ZAP) zinc finger domain 3', 28, NULL, 'zf-CCCH_8', 259763),
(440670, 'PF18756', NULL, 'Nucleotide modification associated domain 4', 87, NULL, 'Nmad4', 259764),
(440671, 'PF01611', NULL, 'Filovirus glycoprotein', 375, NULL, 'Filo_glycop', 259765),
(440672, 'PF18928', NULL, 'Family of unknown function (DUF5677)', 166, NULL, 'DUF5677', 259766),
(440673, 'PF07415', NULL, 'Gammaherpesvirus latent membrane protein (LMP2) protein', 497, NULL, 'Herpes_LMP2', 259767),
(440674, 'PF11901', NULL, 'Protein of unknown function (DUF3421)', 115, NULL, 'DUF3421', 259768),
(440675, 'PF19627', NULL, 'Activity-dependent neuroprotector homeobox protein N-terminal', 752, NULL, 'ADNP_N', 259769),
(440676, 'PF15377', NULL, 'Domain of unknown function (DUF4604)', 175, NULL, 'DUF4604', 259770),
(440677, 'PF00626', NULL, 'Gelsolin repeat', 76, NULL, 'Gelsolin', 259771),
(440678, 'PF03300', NULL, 'Tenuivirus non-structural, movement protein NS4', 282, NULL, 'Tenui_NS4', 259772),
(440679, 'PF17246', NULL, 'Cell division control protein 24, OB domain 1', 125, NULL, 'CDC24_OB1', 259773),
(440680, 'PF18208', NULL, 'Nicking enzyme C-terminal middle helical domain', 109, NULL, 'NES_C_h', 259774),
(440681, 'PF04408', NULL, 'Helicase associated domain (HA2)', 107, NULL, 'HA2', 259775),
(440682, 'PF06347', NULL, 'Bacterial SH3 domain', 56, NULL, 'SH3_4', 259776),
(440683, 'PF13196', NULL, 'Protein of unknown function (DUF4012)', 144, NULL, 'DUF4012', 259777),
(440684, 'PF04455', NULL, 'LOR/SDH bifunctional enzyme conserved region', 100, NULL, 'Saccharop_dh_N', 259778),
(440685, 'PF16729', NULL, 'Domain of unknown function (DUF5067)', 126, NULL, 'DUF5067', 259779),
(440686, 'PF08383', NULL, 'Maf N-terminal region', 34, NULL, 'Maf_N', 259780),
(440687, 'PF15731', NULL, 'Antitoxin component of bacterial toxin-antitoxin system, MqsA', 131, NULL, 'MqsA_antitoxin', 259781),
(440688, 'PF18345', NULL, 'Zinc finger domain', 19, NULL, 'zf_CCCH_4', 259782),
(440689, 'PF18856', NULL, 'Bacterial archaeo-eukaryotic release factor family 12', 138, NULL, 'baeRF_family12', 259783),
(440690, 'PF09445', NULL, 'RNA cap guanine-N2 methyltransferase', 165, NULL, 'Methyltransf_15', 259784),
(440691, 'PF08758', NULL, 'Cadherin prodomain like', 90, NULL, 'Cadherin_pro', 259785),
(440692, 'PF00654', NULL, 'Voltage gated chloride channel', 348, NULL, 'Voltage_CLC', 259786),
(440693, 'PF12650', NULL, 'Domain of unknown function (DUF3784)', 94, NULL, 'DUF3784', 259787),
(440694, 'PF14317', NULL, 'YcxB-like protein', 61, NULL, 'YcxB', 259788),
(440695, 'PF18431', NULL, 'Bacterial CdiA-CT RNAse A domain', 113, NULL, 'RNAse_A_bac', 259789),
(440696, 'PF17098', NULL, 'WTAP/Mum2p family', 155, NULL, 'Wtap', 259790),
(440697, 'PF14674', NULL, 'FANCI solenoid 1 cap', 53, NULL, 'FANCI_S1-cap', 259791);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(440698, 'PF16796', NULL, 'Microtubule binding', 156, NULL, 'Microtub_bd', 259792),
(440699, 'PF10682', NULL, 'Glycoprotein of human cytomegalovirus HHV-5', 214, NULL, 'UL40', 259793),
(440700, 'PF08163', NULL, 'DNA-dependent protein kinase catalytic subunit, CC3', 388, NULL, 'DNAPKcs_CC3', 259794),
(440701, 'PF09040', NULL, 'Gastric H+/K+-ATPase, N terminal domain', 43, NULL, 'H-K_ATPase_N', 259795),
(440702, 'PF15174', NULL, 'Prion-related protein testis-specific', 51, NULL, 'PRNT', 259796),
(440703, 'PF00908', NULL, 'dTDP-4-dehydrorhamnose 3,5-epimerase', 168, NULL, 'dTDP_sugar_isom', 259797),
(440704, 'PF15459', NULL, '60S ribosome biogenesis protein Rrp14', 62, NULL, 'RRP14', 259798),
(440705, 'PF17953', NULL, 'CRISPR Csm4 C-terminal domain', 91, NULL, 'Csm4_C', 259799),
(440706, 'PF05695', NULL, 'Plant protein of unknown function (DUF825)', 1486, NULL, 'DUF825', 259800),
(440707, 'PF11013', NULL, 'Protein of unknown function (DUF2851)', 375, NULL, 'DUF2851', 259801),
(440708, 'PF12749', NULL, 'Eukaryotic metallothionein', 66, NULL, 'Metallothio_Euk', 259802),
(440709, 'PF03536', NULL, 'Salmonella virulence-associated 28kDa protein', 240, NULL, 'VRP3', 259803),
(440710, 'PF01510', NULL, 'N-acetylmuramoyl-L-alanine amidase', 127, NULL, 'Amidase_2', 259804),
(440711, 'PF11363', NULL, 'Protein of unknown function (DUF3164)', 194, NULL, 'DUF3164', 259805),
(440712, 'PF11665', NULL, 'Protein of unknown function (DUF3265)', 28, NULL, 'DUF3265', 259806),
(440713, 'PF01022', NULL, 'Bacterial regulatory protein, arsR family', 47, NULL, 'HTH_5', 259807),
(440714, 'PF18878', NULL, 'PPE-PPW subfamily C-terminal region', 48, NULL, 'PPE-PPW', 259808),
(440715, 'PF13178', NULL, 'Protein of unknown function (DUF4005)', 93, NULL, 'DUF4005', 259809),
(440716, 'PF11511', NULL, 'Intrinsic membrane protein PufX', 67, NULL, 'RhodobacterPufX', 259810),
(440717, 'PF06594', NULL, 'Haemolysin-type calcium binding protein related domain', 42, NULL, 'HCBP_related', 259811),
(440718, 'PF04961', NULL, 'Formiminotransferase-cyclodeaminase', 182, NULL, 'FTCD_C', 259812),
(440719, 'PF09469', NULL, 'Cordon-bleu ubiquitin-like domain', 92, NULL, 'Cobl', 259813),
(440720, 'PF11912', NULL, 'Counting factor-associated protein A/B/C', 212, NULL, 'CfaA_B_C', 259814),
(440721, 'PF13009', NULL, 'Putative integrase', 329, NULL, 'Integrase_2', 259815),
(440722, 'PF07055', NULL, 'Enoyl reductase FAD binding domain', 64, NULL, 'Eno-Rase_FAD_bd', 259816),
(440723, 'PF17736', NULL, 'C17orf99 Ig domain', 95, NULL, 'Ig_C17orf99', 259817),
(440724, 'PF17249', NULL, 'Family of unknown function (DUF5318)', 131, NULL, 'DUF5318', 259818),
(440725, 'PF07173', NULL, 'Glycine-rich domain-containing protein-like', 142, NULL, 'GRDP-like', 259819),
(440726, 'PF07256', NULL, 'Protein of unknown function (DUF1435)', 75, NULL, 'DUF1435', 259820),
(440727, 'PF17992', NULL, 'Agarase CBM like domain', 182, NULL, 'Agarase_CBM', 259821),
(440728, 'PF05345', NULL, 'Putative Ig domain', 96, NULL, 'He_PIG', 259822),
(440729, 'PF17819', NULL, 'Family of unknown function (DUF5582)', 146, NULL, 'DUF5582', 259823),
(440730, 'PF14520', NULL, 'Helix-hairpin-helix domain', 57, NULL, 'HHH_5', 259824),
(440731, 'PF19455', NULL, 'Family of unknown function (DUF5993)', 50, NULL, 'DUF5993', 259825),
(440732, 'PF17250', NULL, 'NADH-ubiquinone oxidoreductase 11 kDa subunit', 86, NULL, 'NDUFB11', 259826),
(440733, 'PF16658', NULL, 'Class II release factor RF3, C-terminal domain', 131, NULL, 'RF3_C', 259827),
(440734, 'PF11614', NULL, 'IG-like fold at C-terminal of FixG, putative oxidoreductase', 119, NULL, 'FixG_C', 259828),
(440735, 'PF00706', NULL, 'Anenome neurotoxin', 43, NULL, 'Toxin_4', 259829),
(440736, 'PF00648', NULL, 'Calpain family cysteine protease', 299, NULL, 'Peptidase_C2', 259830),
(440737, 'PF12877', NULL, 'Domain of unknown function (DUF3827)', 679, NULL, 'DUF3827', 259831),
(440738, 'PF20041', NULL, 'Domain of unknown function (DUF6443)', 90, NULL, 'DUF6443', 259832),
(440739, 'PF05763', NULL, 'Protein of unknown function (DUF835)', 136, NULL, 'DUF835', 259833);
INSERT INTO "PUBLIC"."MODEL" VALUES
(440740, 'PF17771', NULL, 'ADAMTS cysteine-rich domain 2', 70, NULL, 'ADAMTS_CR_2', 259834),
(440741, 'PF10092', NULL, 'Uncharacterized protein conserved in bacteria (DUF2330)', 305, NULL, 'DUF2330', 259835),
(440742, 'PF16470', NULL, 'Peptidase S8 pro-domain', 79, NULL, 'S8_pro-domain', 259836),
(440743, 'PF05213', NULL, 'Coronavirus NS2A protein', 252, NULL, 'Corona_NS2A', 259837),
(440744, 'PF09930', NULL, 'Predicted transporter (DUF2162)', 223, NULL, 'DUF2162', 259838),
(440745, 'PF11167', NULL, 'Protein of unknown function (DUF2953)', 53, NULL, 'DUF2953', 259839),
(440746, 'PF10975', NULL, 'Protein of unknown function (DUF2802)', 68, NULL, 'DUF2802', 259840),
(440747, 'PF11833', NULL, 'Protein CHAPERONE-LIKE PROTEIN OF POR1-like', 198, NULL, 'CPP1-like', 259841),
(440748, 'PF08113', NULL, 'Cytochrome c oxidase subunit IIa family', 33, NULL, 'CoxIIa', 259842),
(440749, 'PF08402', NULL, 'TOBE domain', 76, NULL, 'TOBE_2', 259843),
(440750, 'PF14322', NULL, 'Starch-binding associating with outer membrane', 190, NULL, 'SusD-like_3', 259844),
(440751, 'PF17547', NULL, 'Family of unknown function (DUF5462)', 157, NULL, 'DUF5462', 259845),
(440752, 'PF05217', NULL, 'STOP protein', 36, NULL, 'STOP', 259846),
(440753, 'PF11725', NULL, 'AvrE-family Type-III effector proteins (T3Es)', 1518, NULL, 'AvrE_T3Es', 259847),
(440754, 'PF19984', NULL, 'Family of unknown function (DUF6420)', 158, NULL, 'DUF6420', 259848),
(440755, 'PF07508', NULL, 'Recombinase', 103, NULL, 'Recombinase', 259849),
(440756, 'PF00642', NULL, 'Zinc finger C-x8-C-x5-C-x3-H type (and similar)', 27, NULL, 'zf-CCCH', 259850),
(440757, 'PF01140', NULL, 'Matrix protein (MA), p15', 126, NULL, 'Gag_MA', 259851),
(440758, 'PF13065', NULL, 'Protein of unknown function (DUF3928)', 95, NULL, 'DUF3928', 259852),
(440759, 'PF09789', NULL, 'Coiled-coil domain-containing protein 149-A', 314, NULL, 'CC149', 259853),
(440760, 'PF16497', NULL, 'MHC-I family domain', 198, NULL, 'MHC_I_3', 259854),
(440761, 'PF05395', NULL, 'Protein phosphatase inhibitor 1/DARPP-32', 160, NULL, 'DARPP-32', 259855),
(440762, 'PF01475', NULL, 'Ferric uptake regulator family', 121, NULL, 'FUR', 259856),
(440763, 'PF18726', NULL, 'SAV_6107-like HEPN', 98, NULL, 'HEPN_SAV_6107', 259857),
(440764, 'PF10552', NULL, 'ORF6C domain', 114, NULL, 'ORF6C', 259858),
(440765, 'PF19170', NULL, 'Family of unknown function (DUF5852)', 199, NULL, 'DUF5852', 259859),
(440766, 'PF20333', NULL, 'Family of unknown function (DUF6628)', 137, NULL, 'DUF6628', 259860),
(440767, 'PF08033', NULL, 'Sec23/Sec24 beta-sandwich domain', 96, NULL, 'Sec23_BS', 259861),
(440768, 'PF09058', NULL, 'L27_1', 59, NULL, 'L27_1', 259862),
(440769, 'PF19429', NULL, 'Evasins Class A', 73, NULL, 'EVA_Class_A', 259863),
(440770, 'PF13307', NULL, 'Helicase C-terminal domain', 170, NULL, 'Helicase_C_2', 259864),
(440771, 'PF03874', NULL, 'RNA polymerase Rpb4', 125, NULL, 'RNA_pol_Rpb4', 259865),
(440772, 'PF14692', NULL, 'Domain of unknown function (DUF4462)', 28, NULL, 'DUF4462', 259866),
(440773, 'PF07473', NULL, 'Spasmodic peptide gm9a; conotoxin from Conus species', 28, NULL, 'Toxin_11', 259867),
(440774, 'PF04085', NULL, 'rod shape-determining protein MreC', 151, NULL, 'MreC', 259868),
(440775, 'PF10777', NULL, 'Inner membrane protein YlaC', 154, NULL, 'YlaC', 259869),
(440776, 'PF01076', NULL, 'Plasmid recombination enzyme', 196, NULL, 'Mob_Pre', 259870),
(440777, 'PF14775', NULL, 'Sperm tail C-terminal domain', 60, NULL, 'NYD-SP28_assoc', 259871),
(440778, 'PF17975', NULL, 'Ribonucleotide reductase alpha domain', 101, NULL, 'RNR_Alpha', 259872),
(440779, 'PF15982', NULL, 'N-terminal cysteine-rich region of Transmembrane protein 135', 134, NULL, 'TMEM135_C_rich', 259873),
(440780, 'PF15526', NULL, 'Novel toxin 21', 71, NULL, 'Ntox21', 259874),
(440781, 'PF11433', NULL, 'Protein of unknown function (DUF3198)', 50, NULL, 'DUF3198', 259875),
(440782, 'PF15632', NULL, 'ATP-grasp in the biosynthetic pathway with Ter operon', 131, NULL, 'ATPgrasp_Ter', 259876),
(440783, 'PF17756', NULL, 'RET Cadherin like domain 1', 124, NULL, 'RET_CLD1', 259877);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(440784, 'PF11772', NULL, 'DNA-directed RNA polymerase subunit beta', 46, NULL, 'EpuA', 259878),
(440785, 'PF04451', NULL, 'Large eukaryotic DNA virus major capsid protein', 195, NULL, 'Capsid_NCLDV', 259879),
(440786, 'PF15441', NULL, 'RhoGEF 5/35 N-terminal disordered region', 488, NULL, 'ARHGEF5_35', 259880),
(440787, 'PF06251', NULL, 'Capsule biosynthesis GfcC C-terminal', 90, NULL, 'Caps_syn_GfcC_C', 259881),
(440788, 'PF01152', NULL, 'Bacterial-like globin', 121, NULL, 'Bac_globin', 259882),
(440789, 'PF08619', NULL, 'Alkali metal cation/H+ antiporter Nha1 C terminus', 466, NULL, 'Nha1_C', 259883),
(440790, 'PF17429', NULL, 'Gene product 70', 54, NULL, 'GP70', 259884),
(440791, 'PF00951', NULL, 'Arterivirus GL envelope glycoprotein', 179, NULL, 'Arteri_Gl', 259885),
(440792, 'PF04365', NULL, 'Ribonuclease toxin, BrnT, of type II toxin-antitoxin system', 78, NULL, 'BrnT_toxin', 259886),
(440793, 'PF12813', NULL, 'XPG domain containing', 249, NULL, 'XPG_I_2', 259887),
(440794, 'PF06819', NULL, 'Archaeal Peptidase A24 C-terminal Domain', 112, NULL, 'Arc_PepC', 259888),
(440795, 'PF03810', NULL, 'Importin-beta N-terminal domain', 74, NULL, 'IBN_N', 259889),
(440796, 'PF11501', NULL, 'Betacoronavirus replicase NSP1', 138, NULL, 'bCoV_NSP1', 259890),
(440797, 'PF05946', NULL, 'Toxin-coregulated pilus subunit TcpA', 130, NULL, 'TcpA', 259891),
(440798, 'PF08069', NULL, 'Ribosomal S13/S15 N-terminal domain', 60, NULL, 'Ribosomal_S13_N', 259892),
(440799, 'PF11808', NULL, 'Phosphate regulon sensor protein PhoR', 86, NULL, 'PhoR', 259893),
(440800, 'PF20496', NULL, 'Double strand break localizing Dbl7', 268, NULL, 'Dbl7', 259894),
(440801, 'PF03130', NULL, 'PBS lyase HEAT-like repeat', 27, NULL, 'HEAT_PBS', 259895),
(440802, 'PF18712', NULL, 'Family of unknown function (DUF5644)', 109, NULL, 'DUF5644', 259896),
(440803, 'PF12512', NULL, 'Protein of unknown function (DUF3717)', 68, NULL, 'DUF3717', 259897),
(440804, 'PF17560', NULL, 'Aphid Megourins', 63, NULL, 'Megourin', 259898),
(440805, 'PF06671', NULL, 'Repeat of unknown function (DUF1174)', 25, NULL, 'DUF1174', 259899),
(440806, 'PF04236', NULL, 'Tc5 transposase C-terminal domain', 63, NULL, 'Transp_Tc5_C', 259900),
(440807, 'PF06547', NULL, 'Protein of unknown function (DUF1117)', 113, NULL, 'DUF1117', 259901),
(440808, 'PF09972', NULL, 'Predicted membrane protein (DUF2207)', 483, NULL, 'DUF2207', 259902),
(440809, 'PF10404', NULL, 'Rad4 beta-hairpin domain 2', 64, NULL, 'BHD_2', 259903),
(440810, 'PF02557', NULL, 'D-alanyl-D-alanine carboxypeptidase', 133, NULL, 'VanY', 259904),
(440811, 'PF04955', NULL, 'HupE / UreJ protein', 179, NULL, 'HupE_UreJ', 259905),
(440812, 'PF20094', NULL, 'GWxTD domain', 172, NULL, 'GWxTD_dom', 259906),
(440813, 'PF08386', NULL, 'TAP-like protein', 103, NULL, 'Abhydrolase_4', 259907),
(440814, 'PF01586', NULL, 'Myogenic Basic domain', 86, NULL, 'Basic', 259908),
(440815, 'PF10790', NULL, 'Protein of Unknown function (DUF2604)', 85, NULL, 'DUF2604', 259909),
(440816, 'PF11796', NULL, 'Protein of unknown function N-terminus (DUF3323)', 209, NULL, 'DUF3323', 259910),
(440817, 'PF14213', NULL, 'STAS-like domain of unknown function (DUF4325)', 64, NULL, 'DUF4325', 259911),
(440818, 'PF20342', NULL, 'Family of unknown function (DUF6637)', 103, NULL, 'DUF6637', 259912),
(440819, 'PF06357', NULL, 'Omega-atracotoxin', 37, NULL, 'Omega-toxin', 259913),
(440820, 'PF14413', NULL, 'Thg1 C terminal domain', 124, NULL, 'Thg1C', 259914),
(440821, 'PF16654', NULL, 'Diaminopimelic acid dehydrogenase C-terminal domain', 154, NULL, 'DAPDH_C', 259915),
(440822, 'PF14246', NULL, 'AefR-like transcriptional repressor, C-terminal domain', 119, NULL, 'TetR_C_7', 259916),
(440823, 'PF10399', NULL, 'Ubiquitinol-cytochrome C reductase Fe-S subunit TAT signal', 41, NULL, 'UCR_Fe-S_N', 259917),
(440824, 'PF08269', NULL, 'Cache domain', 296, NULL, 'dCache_2', 259918),
(440825, 'PF16265', NULL, 'Domain of unknown function (DUF4918)', 225, NULL, 'DUF4918', 259919),
(440826, 'PF13892', NULL, 'DNA-binding domain', 134, NULL, 'DBINO', 259920);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(440827, 'PF11023', NULL, 'Zinc-ribbon containing domain', 111, NULL, 'DUF2614', 259921),
(440828, 'PF11311', NULL, 'Protein of unknown function (DUF3114)', 251, NULL, 'DUF3114', 259922),
(440829, 'PF00878', NULL, 'Cation-independent mannose-6-phosphate receptor repeat', 143, NULL, 'CIMR', 259923),
(440830, 'PF02998', NULL, 'Lentiviral Tat protein', 86, NULL, 'Lentiviral_Tat', 259924),
(440831, 'PF11673', NULL, 'Protein of unknown function (DUF3269)', 73, NULL, 'DUF3269', 259925),
(440832, 'PF00845', NULL, 'Geminivirus BL1 movement protein', 276, NULL, 'Gemini_BL1', 259926),
(440833, 'PF07868', NULL, 'Protein of unknown function (DUF1655)', 55, NULL, 'DUF1655', 259927),
(440834, 'PF17272', NULL, 'Family of unknown function (DUF5337)', 74, NULL, 'DUF5337', 259928),
(440835, 'PF15613', NULL, 'Williams-Beuren syndrome DDT (WSD), D-TOX E motif', 98, NULL, 'WSD', 259929),
(440836, 'PF17742', NULL, 'Family of unknown function (DUF5579)', 202, NULL, 'DUF5579', 259930),
(440837, 'PF19354', NULL, 'Family of unknown function (DUF5931)', 175, NULL, 'DUF5931', 259931),
(440838, 'PF05691', NULL, 'Raffinose synthase or seed imbibition protein Sip1', 750, NULL, 'Raffinose_syn', 259932),
(440839, 'PF15898', NULL, 'cGMP-dependent protein kinase interacting domain', 102, NULL, 'PRKG1_interact', 259933),
(440840, 'PF08940', NULL, 'Domain of unknown function (DUF1918)', 58, NULL, 'DUF1918', 259934),
(440841, 'PF05184', NULL, 'Saposin-like type B, region 1', 38, NULL, 'SapB_1', 259935),
(440842, 'PF06351', NULL, 'Allene oxide cyclase', 175, NULL, 'Allene_ox_cyc', 259936),
(440843, 'PF18679', NULL, 'ThcOx helix turn helix domain', 112, NULL, 'HTH_57', 259937),
(440844, 'PF08784', NULL, 'Replication protein A C terminal', 104, NULL, 'RPA_C', 259938),
(440845, 'PF10417', NULL, 'C-terminal domain of 1-Cys peroxiredoxin', 40, NULL, '1-cysPrx_C', 259939),
(440846, 'PF03869', NULL, 'Arc-like DNA binding domain', 50, NULL, 'Arc', 259940),
(440847, 'PF13853', NULL, 'Olfactory receptor', 280, NULL, '7tm_4', 259941),
(440848, 'PF04420', NULL, 'CHD5-like protein', 159, NULL, 'CHD5', 259942),
(440849, 'PF15137', NULL, 'Domain of unknown function (DUF4571)', 218, NULL, 'DUF4571', 259943),
(440850, 'PF09860', NULL, 'Uncharacterized protein conserved in bacteria (DUF2087)', 69, NULL, 'DUF2087', 259944),
(440851, 'PF17720', NULL, 'Family of unknown function (DUF5565)', 324, NULL, 'DUF5565', 259945),
(440852, 'PF19679', NULL, 'Family of unknown function (DUF6181)', 134, NULL, 'DUF6181', 259946),
(440853, 'PF14944', NULL, 'Tongue Cancer Chemotherapy Resistant Protein 1', 243, NULL, 'TCRP1', 259947),
(440854, 'PF14862', NULL, 'Big defensin', 58, NULL, 'Defensin_big', 259948),
(440855, 'PF05709', NULL, 'Phage tail protein', 255, NULL, 'Sipho_tail', 259949),
(440856, 'PF07196', NULL, 'Flagellin hook IN motif', 56, NULL, 'Flagellin_IN', 259950),
(440857, 'PF11669', NULL, 'WW domain-binding protein 1', 105, NULL, 'WBP-1', 259951),
(440858, 'PF11972', NULL, 'HTH DNA binding domain', 54, NULL, 'HTH_13', 259952),
(440859, 'PF03960', NULL, 'ArsC family', 66, NULL, 'ArsC', 259953),
(440860, 'PF09894', NULL, 'Uncharacterized protein conserved in archaea (DUF2121)', 195, NULL, 'DUF2121', 259954),
(440861, 'PF19135', NULL, 'Protein of unknown function (DUF5818)', 57, NULL, 'DUF5818', 259955),
(440862, 'PF14339', NULL, 'Domain of unknown function (DUF4394)', 230, NULL, 'DUF4394', 259956),
(440863, 'PF12892', NULL, 'Spy0128-like isopeptide containing domain', 121, NULL, 'FctA', 259957),
(440864, 'PF07686', NULL, 'Immunoglobulin V-set domain', 109, NULL, 'V-set', 259958),
(440865, 'PF06721', NULL, 'Protein of unknown function (DUF1204)', 228, NULL, 'DUF1204', 259959),
(440866, 'PF04307', NULL, 'LexA-binding, inner membrane-associated putative hydrolase', 173, NULL, 'YdjM', 259960),
(440867, 'PF04645', NULL, 'Protein of unknown function, DUF603', 181, NULL, 'DUF603', 259961),
(440868, 'PF07278', NULL, 'Protein of unknown function (DUF1441)', 147, NULL, 'DUF1441', 259962),
(440869, 'PF18461', NULL, 'Atypical caspase recruitment domain', 95, NULL, 'Atypical_Card', 259963); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(440870, 'PF08900', NULL, 'Transcriptional regulator AcaB', 215, NULL, 'AcaB', 259964),
(440871, 'PF11742', NULL, 'Protein of unknown function (DUF3302)', 77, NULL, 'DUF3302', 259965),
(440872, 'PF11942', NULL, 'Spt5 transcription elongation factor, acidic N-terminal', 99, NULL, 'Spt5_N', 259966),
(440873, 'PF00446', NULL, 'Gonadotropin-releasing hormone', 10, NULL, 'GnRH', 259967),
(440874, 'PF04934', NULL, 'MED6 mediator sub complex component', 133, NULL, 'Med6', 259968),
(440875, 'PF12597', NULL, 'Cytochrome c oxidase assembly protein COX20', 101, NULL, 'Cox20', 259969),
(440876, 'PF01650', NULL, 'Peptidase C13 family', 256, NULL, 'Peptidase_C13', 259970),
(440877, 'PF15044', NULL, 'Mitochondrial function, CLU-N-term', 79, NULL, 'CLU_N', 259971),
(440878, 'PF14753', NULL, 'Protein FAM221A/B', 196, NULL, 'FAM221', 259972),
(440879, 'PF20379', NULL, 'Family of unknown function (DUF6674)', 253, NULL, 'DUF6674', 259973),
(440880, 'PF13469', NULL, 'Sulfotransferase family', 217, NULL, 'Sulfotransfer_3', 259974),
(440881, 'PF12580', NULL, 'Tripeptidyl peptidase II', 187, NULL, 'TPPII', 259975),
(440882, 'PF06336', NULL, 'Coronavirus 5a protein', 64, NULL, 'Corona_5a', 259976),
(440883, 'PF14247', NULL, 'Putative metallopeptidase', 220, NULL, 'DUF4344', 259977),
(440884, 'PF00122', NULL, 'E1-E2 ATPase', 181, NULL, 'E1-E2_ATPase', 259978),
(440885, 'PF11956', NULL, 'Ankyrin-G binding motif of KCNQ2-3', 102, NULL, 'KCNQC3-Ank-G_bd', 259979),
(440886, 'PF19341', NULL, 'Beta-1,3-galactosyltransferase 2 N-terminus', 82, NULL, 'B3GALT2_N', 259980),
(440887, 'PF00296', NULL, 'Luciferase-like monooxygenase', 314, NULL, 'Bac_luciferase', 259981),
(440888, 'PF01283', NULL, 'Ribosomal protein S26e', 108, NULL, 'Ribosomal_S26e', 259982),
(440889, 'PF01975', NULL, 'Survival protein SurE', 195, NULL, 'SurE', 259983),
(440890, 'PF14004', NULL, 'Protein of unknown function (DUF4227)', 71, NULL, 'DUF4227', 259984),
(440891, 'PF01105', NULL, 'emp24/gp25L/p24 family/GOLD', 182, NULL, 'EMP24_GP25L', 259985),
(440892, 'PF16595', NULL, 'PAM-interacting domain of CRISPR-associated endonuclease Cas9', 265, NULL, 'Cas9_PI', 259986),
(440893, 'PF04693', NULL, 'Archaeal putative transposase ISC1217', 327, NULL, 'DDE_Tnp_2', 259987),
(440894, 'PF09537', NULL, 'Domain of unknown function (DUF2383)', 111, NULL, 'DUF2383', 259988),
(440895, 'PF11207', NULL, 'Protein of unknown function (DUF2989)', 201, NULL, 'DUF2989', 259989),
(440896, 'PF12136', NULL, 'RNA polymerase Rpo13 subunit HTH domain', 43, NULL, 'RNA_pol_Rpo13', 259990),
(440897, 'PF07991', NULL, 'Acetohydroxy acid isomeroreductase, NADPH-binding domain', 165, NULL, 'IlvN', 259991),
(440898, 'PF00823', NULL, 'PPE family', 158, NULL, 'PPE', 259992),
(440899, 'PF02144', NULL, 'Repair protein Rad1/Rec1/Rad17', 275, NULL, 'Rad1', 259993),
(440900, 'PF07903', NULL, 'PaRep2a protein', 122, NULL, 'PaRep2a', 259994),
(440901, 'PF11346', NULL, 'Protein of unknown function (DUF3149)', 40, NULL, 'DUF3149', 259995),
(440902, 'PF18552', NULL, 'PheRS DNA binding domain 1', 59, NULL, 'PheRS_DBD1', 259996),
(440903, 'PF18886', NULL, 'Repeats of unknown function (DUF5649)', 68, NULL, 'DUF5649', 259997),
(440904, 'PF18503', NULL, '26S proteasome subunit RPN6 C-terminal helix domain', 27, NULL, 'RPN6_C_helix', 259998),
(440905, 'PF04110', NULL, 'Ubiquitin-like autophagy protein Apg12', 87, NULL, 'APG12', 259999),
(440906, 'PF04439', NULL, 'Streptomycin adenylyltransferase', 279, NULL, 'Adenyl_transf', 260000),
(440907, 'PF12483', NULL, 'E3 Ubiquitin ligase', 159, NULL, 'GIDE', 260001),
(440908, 'PF07876', NULL, 'Stress responsive A/B Barrel Domain', 97, NULL, 'Dabb', 260002),
(440909, 'PF12923', NULL, 'Ribosomal RNA-processing protein 7 (RRP7) C-terminal domain', 119, NULL, 'RRP7', 260003),
(440910, 'PF03189', NULL, 'Otopetrin', 447, NULL, 'Otopetrin', 260004),
(440911, 'PF06526', NULL, 'Protein of unknown function (DUF1107)', 63, NULL, 'DUF1107', 260005),
(440912, 'PF09712', NULL, 'Poly(R)-hydroxyalkanoic acid synthase subunit (PHA_synth_III_E)', 314, NULL, 'PHA_synth_III_E', 260006);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(440913, 'PF01243', NULL, 'Pyridoxamine 5''-phosphate oxidase', 88, NULL, 'Putative_PNPOx', 260007),
(440914, 'PF05366', NULL, 'Sarcolipin', 31, NULL, 'Sarcolipin', 260008),
(440915, 'PF08101', NULL, 'Meiotically up-regulated protein Msb1/Mug8 domain', 424, NULL, 'Msb1-Mug8_dom', 260009),
(440916, 'PF00889', NULL, 'Elongation factor TS', 208, NULL, 'EF_TS', 260010),
(440917, 'PF07184', NULL, 'Citrus tristeza virus P33 protein', 303, NULL, 'CTV_P33', 260011),
(440918, 'PF15031', NULL, 'Domain of unknown function (DUF4528)', 126, NULL, 'DUF4528', 260012),
(440919, 'PF19113', NULL, 'Family of unknown function (DUF5799)', 148, NULL, 'DUF5799', 260013),
(440920, 'PF18630', NULL, 'Peptidase M60 C-terminal domain', 64, NULL, 'Peptidase_M60_C', 260014),
(440921, 'PF05098', NULL, 'Late expression factor 4 (LEF-4)', 472, NULL, 'LEF-4', 260015),
(440922, 'PF04729', NULL, 'ASF1 like histone chaperone', 154, NULL, 'ASF1_hist_chap', 260016),
(440923, 'PF06968', NULL, 'Biotin and Thiamin Synthesis associated domain', 86, NULL, 'BATS', 260017),
(440924, 'PF08647', NULL, 'BRE1 E3 ubiquitin ligase', 95, NULL, 'BRE1', 260018),
(440925, 'PF19262', NULL, 'Family of unknown function (DUF5905)', 105, NULL, 'DUF5905', 260019),
(440926, 'PF02596', NULL, 'Uncharacterised ArCR, COG2043', 206, NULL, 'DUF169', 260020),
(440927, 'PF13111', NULL, 'pPIWI_RE module N-terminal domain', 400, NULL, 'pPIWI_RE_X', 260021),
(440928, 'PF03950', NULL, 'tRNA synthetases class I (E and Q), anti-codon binding domain', 174, NULL, 'tRNA-synt_1c_C', 260022),
(440929, 'PF04075', NULL, 'F420H(2)-dependent quinone reductase', 130, NULL, 'F420H2_quin_red', 260023),
(440930, 'PF15129', NULL, 'FAM150 family', 124, NULL, 'FAM150', 260024),
(440931, 'PF03666', NULL, 'Nitrogen Permease regulator of amino acid transport activity 3', 466, NULL, 'NPR3', 260025),
(440932, 'PF17540', NULL, 'Family of unknown function (DUF5457)', 89, NULL, 'DUF5457', 260026),
(440933, 'PF13478', NULL, 'XdhC Rossmann domain', 125, NULL, 'XdhC_C', 260027),
(440934, 'PF19699', NULL, 'Calsyntenin C-terminal', 354, NULL, 'CLSTN_C', 260028),
(440935, 'PF07468', NULL, 'Agglutinin domain', 153, NULL, 'Agglutinin', 260029),
(440936, 'PF12130', NULL, 'Bivalent Mical/EHBP Rab binding domain', 133, NULL, 'bMERB_dom', 260030),
(440937, 'PF03155', NULL, 'ALG6, ALG8 glycosyltransferase family', 485, NULL, 'Alg6_Alg8', 260031),
(440938, 'PF03639', NULL, 'Glycosyl hydrolase family 81 N-terminal domain', 323, NULL, 'Glyco_hydro_81', 260032),
(440939, 'PF08082', NULL, 'PRO8NT (NUC069), PrP8 N-terminal domain', 152, NULL, 'PRO8NT', 260033),
(440940, 'PF15802', NULL, 'DDB1- and CUL4-associated factor 17', 474, NULL, 'DCAF17', 260034),
(440941, 'PF08334', NULL, 'Type II secretion system (T2SS), protein G', 108, NULL, 'T2SSG', 260035),
(440942, 'PF02801', NULL, 'Beta-ketoacyl synthase, C-terminal domain', 119, NULL, 'Ketoacyl-synt_C', 260036),
(440943, 'PF00050', NULL, 'Kazal-type serine protease inhibitor domain', 49, NULL, 'Kazal_1', 260037),
(440944, 'PF02823', NULL, 'ATP synthase, Delta/Epsilon chain, beta-sandwich domain', 80, NULL, 'ATP-synt_DE_N', 260038),
(440945, 'PF16496', NULL, 'SWIRM-associated domain at the N-terminal', 412, NULL, 'SWIRM-assoc_2', 260039),
(440946, 'PF10411', NULL, 'Disulfide bond isomerase protein N-terminus', 54, NULL, 'DsbC_N', 260040),
(440947, 'PF20474', NULL, 'PHL domain', 155, NULL, 'PHL', 260041),
(440948, 'PF10493', NULL, 'Rough deal protein C-terminal region', 551, NULL, 'Rod_C', 260042),
(440949, 'PF15084', NULL, 'Domain of unknown function (DUF4550)', 95, NULL, 'DUF4550', 260043),
(440950, 'PF17030', NULL, 'Putative beta-lactamase-like family', 214, NULL, 'Beta_lactamase3', 260044),
(440951, 'PF02408', NULL, 'CUB-like domain', 120, NULL, 'CUB_2', 260045),
(440952, 'PF06857', NULL, 'Malonate decarboxylase delta subunit (MdcD)', 83, NULL, 'ACP', 260046),
(440953, 'PF06861', NULL, 'BALF1 protein', 182, NULL, 'BALF1', 260047),
(440954, 'PF19445', NULL, 'C-terminal region of eIF3h', 197, NULL, 'eIF3h_C', 260048),
(440955, 'PF02955', NULL, 'Prokaryotic glutathione synthetase, ATP-grasp domain', 175, NULL, 'GSH-S_ATP', 260049); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(440956, 'PF10414', NULL, 'Sirohaem synthase dimerisation region', 58, NULL, 'CysG_dimeriser', 260050),
(440957, 'PF08525', NULL, 'Opacity-associated protein A N-terminal motif', 28, NULL, 'OapA_N', 260051),
(440958, 'PF12614', NULL, 'Ribosome recycling factor', 126, NULL, 'RRF_GI', 260052),
(440959, 'PF03571', NULL, 'Peptidase family M49', 551, NULL, 'Peptidase_M49', 260053),
(440960, 'PF04476', NULL, '4-HFC-P synthase', 228, NULL, '4HFCP_synth', 260054),
(440961, 'PF05627', NULL, 'Cleavage site for pathogenic type III effector avirulence factor Avr', 37, NULL, 'AvrRpt-cleavage', 260055),
(440962, 'PF09213', NULL, 'M3', 376, NULL, 'M3', 260056),
(440963, 'PF02524', NULL, 'KID repeat', 11, NULL, 'KID', 260057),
(440964, 'PF18286', NULL, 'Type III secretion system ExsE', 46, NULL, 'T3SS_ExsE', 260058),
(440965, 'PF06658', NULL, 'Protein of unknown function (DUF1168)', 136, NULL, 'DUF1168', 260059),
(440966, 'PF00685', NULL, 'Sulfotransferase domain', 267, NULL, 'Sulfotransfer_1', 260060),
(440967, 'PF09803', NULL, 'Pet100', 74, NULL, 'Pet100', 260061),
(440968, 'PF11958', NULL, 'Domain of unknown function (DUF3472)', 173, NULL, 'DUF3472', 260062),
(440969, 'PF13636', NULL, 'RNA-binding PUA-like domain of methyltransferase RsmF', 50, NULL, 'Methyltranf_PUA', 260063),
(440970, 'PF03595', NULL, 'Voltage-dependent anion channel', 326, NULL, 'SLAC1', 260064),
(440971, 'PF02805', NULL, 'Metal binding domain of Ada', 65, NULL, 'Ada_Zn_binding', 260065),
(440972, 'PF14099', NULL, 'Polysaccharide lyase', 213, NULL, 'Polysacc_lyase', 260066),
(440973, 'PF08669', NULL, 'Glycine cleavage T-protein C-terminal barrel domain', 80, NULL, 'GCV_T_C', 260067),
(440974, 'PF14778', NULL, 'Odorant response abnormal 4-like', 376, NULL, 'ODR4-like', 260068),
(440975, 'PF09823', NULL, 'Domain of unknown function (DUF2357)', 248, NULL, 'DUF2357', 260069),
(440976, 'PF14396', NULL, 'Cystic fibrosis TM conductance regulator (CFTR), regulator domain', 213, NULL, 'CFTR_R', 260070),
(440977, 'PF05770', NULL, 'Inositol 1,3,4-trisphosphate 5/6-kinase ATP-grasp domain', 201, NULL, 'Ins134_P3_kin', 260071),
(440978, 'PF03429', NULL, 'Major surface protein 1B', 756, NULL, 'MSP1b', 260072),
(440979, 'PF12740', NULL, 'Chlorophyllase enzyme', 254, NULL, 'Chlorophyllase2', 260073),
(440980, 'PF14332', NULL, 'Domain of unknown function (DUF4388)', 94, NULL, 'DUF4388', 260074),
(440981, 'PF20555', NULL, 'Domain of unknown function (DUF6767)', 57, NULL, 'DUF6767', 260075),
(440982, 'PF17983', NULL, 'Trypsin inhibitors 1,2 and 3', 33, NULL, 'Tryp_inh', 260076),
(440983, 'PF15236', NULL, 'Coiled-coil domain-containing protein 66', 154, NULL, 'CCDC66', 260077),
(440984, 'PF16780', NULL, 'AIMP2 lysyl-tRNA synthetase binding domain', 47, NULL, 'AIMP2_LysRS_bd', 260078),
(440985, 'PF16955', NULL, 'Ferrous iron uptake permease, iron-lead transporter', 207, NULL, 'OFeT_1', 260079),
(440986, 'PF02818', NULL, 'PPAK motif', 27, NULL, 'PPAK', 260080),
(440987, 'PF14488', NULL, 'Domain of unknown function (DUF4434)', 168, NULL, 'DUF4434', 260081),
(440988, 'PF08972', NULL, 'Domain of unknown function (DUF1902)', 75, NULL, 'DUF1902', 260082),
(440989, 'PF11388', NULL, 'Phagosome trafficking protein DotA', 105, NULL, 'DotA', 260083),
(440990, 'PF08785', NULL, 'Ku C terminal domain like', 119, NULL, 'Ku_PK_bind', 260084),
(440991, 'PF17057', NULL, 'Poxviridae B3 protein', 123, NULL, 'B3R', 260085),
(440992, 'PF11102', NULL, 'Group 4 capsule polysaccharide lipoprotein gfcB, YjbF', 190, NULL, 'YjbF', 260086),
(440993, 'PF07595', NULL, 'Planctomycete extracellular', 24, NULL, 'Planc_extracel', 260087),
(440994, 'PF03418', NULL, 'Germination protease', 354, NULL, 'Peptidase_A25', 260088),
(440995, 'PF12087', NULL, 'Protein of unknown function (DUF3564)', 120, NULL, 'DUF3564', 260089),
(440996, 'PF07632', NULL, 'Protein of unknown function (DUF1593)', 256, NULL, 'DUF1593', 260090),
(440997, 'PF06463', NULL, 'Molybdenum Cofactor Synthesis C', 128, NULL, 'Mob_synth_C', 260091),
(440998, 'PF11276', NULL, 'Protein of unknown function (DUF3078)', 93, NULL, 'DUF3078', 260092);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(440999, 'PF13231', NULL, 'Dolichyl-phosphate-mannose-protein mannosyltransferase', 160, NULL, 'PMT_2', 260093),
(441000, 'PF19363', NULL, 'Family of unknown function (DUF5939)', 281, NULL, 'DUF5939', 260094),
(441001, 'PF05276', NULL, 'SH3 domain-binding protein 5 (SH3BP5)', 231, NULL, 'SH3BP5', 260095),
(441002, 'PF11294', NULL, 'Protein of unknown function (DUF3095)', 377, NULL, 'DUF3095', 260096),
(441003, 'PF06194', NULL, 'Phage Conserved Open Reading Frame 51', 80, NULL, 'Phage_Orf51', 260097),
(441004, 'PF08406', NULL, 'CbbQ/NirQ/NorQ C-terminal', 85, NULL, 'CbbQ_C', 260098),
(441005, 'PF01322', NULL, 'Cytochrome C''', 121, NULL, 'Cytochrom_C_2', 260099),
(441006, 'PF00522', NULL, 'VPR/VPX protein', 96, NULL, 'VPR', 260100),
(441007, 'PF18386', NULL, 'Roquin II domain', 56, NULL, 'ROQ_II', 260101),
(441008, 'PF07423', NULL, 'Domain of unknown function (DUF1510)', 93, NULL, 'DUF1510', 260102),
(441009, 'PF03121', NULL, 'Herpesviridae UL52/UL70 DNA primase', 75, NULL, 'Herpes_UL52', 260103),
(441010, 'PF04923', NULL, 'Ninjurin', 103, NULL, 'Ninjurin', 260104),
(441011, 'PF16383', NULL, 'Domain of unknown function', 182, NULL, 'DUF4992', 260105),
(441012, 'PF12220', NULL, 'U1 small nuclear ribonucleoprotein of 70kDa MW N terminal', 92, NULL, 'U1snRNP70_N', 260106),
(441013, 'PF08671', NULL, 'Anti-repressor SinI', 28, NULL, 'SinI', 260107),
(441014, 'PF02181', NULL, 'Formin Homology 2 Domain', 372, NULL, 'FH2', 260108),
(441015, 'PF00576', NULL, 'HIUase/Transthyretin family', 110, NULL, 'Transthyretin', 260109),
(441016, 'PF13972', NULL, 'Bacterial transcriptional repressor', 144, NULL, 'TetR', 260110),
(441017, 'PF00225', NULL, 'Kinesin motor domain', 332, NULL, 'Kinesin', 260111),
(441018, 'PF07710', NULL, 'P53 tetramerisation motif', 42, NULL, 'P53_tetramer', 260112),
(441019, 'PF16276', NULL, 'Nucleophosmin C-terminal domain', 49, NULL, 'NPM1-C', 260113),
(441020, 'PF08460', NULL, 'Bacterial SH3 domain', 68, NULL, 'SH3_5', 260114),
(441021, 'PF03966', NULL, 'Trm112p-like protein', 68, NULL, 'Trm112p', 260115),
(441022, 'PF10406', NULL, 'Transcription factor TFIID complex subunit 8 C-term', 49, NULL, 'TAF8_C', 260116),
(441023, 'PF02083', NULL, 'Urotensin II', 12, NULL, 'Urotensin_II', 260117),
(441024, 'PF07598', NULL, 'Protein of unknown function (DUF1561)', 625, NULL, 'DUF1561', 260118),
(441025, 'PF16772', NULL, 'Telomeric repeat-binding factor 2 Rap1-binding motif', 41, NULL, 'TERF2_RBM', 260119),
(441026, 'PF05454', NULL, 'Dystroglycan (Dystrophin-associated glycoprotein 1)', 290, NULL, 'DAG1', 260120),
(441027, 'PF10442', NULL, 'FIST C domain', 132, NULL, 'FIST_C', 260121),
(441028, 'PF10792', NULL, 'Protein of unknown function (DUF2605)', 96, NULL, 'DUF2605', 260122),
(441029, 'PF16367', NULL, 'RNA recognition motif', 97, NULL, 'RRM_7', 260123),
(441030, 'PF03241', NULL, '4-hydroxyphenylacetate 3-hydroxylase C terminal', 202, NULL, 'HpaB', 260124),
(441031, 'PF11681', NULL, 'Bacteriophage KPP10, Structural protein ORF10', 144, NULL, 'KPP10_Orf10', 260125),
(441032, 'PF20483', NULL, 'Flavivirus RNA-directed RNA polymerase, thumb domain', 164, NULL, 'Flavi_NS5_thumb', 260126),
(441033, 'PF06739', NULL, 'Beta-propeller repeat', 38, NULL, 'SBBP', 260127),
(441034, 'PF07406', NULL, 'NICE-3 protein', 182, NULL, 'NICE-3', 260128),
(441035, 'PF15501', NULL, 'Nuclear protein MDM1', 562, NULL, 'MDM1', 260129),
(441036, 'PF06855', NULL, 'YozE SAM-like fold', 66, NULL, 'YozE_SAM_like', 260130),
(441037, 'PF01393', NULL, 'Chromo shadow domain', 52, NULL, 'Chromo_shadow', 260131),
(441038, 'PF09174', NULL, 'Maf1 regulator', 174, NULL, 'Maf1', 260132),
(441039, 'PF04775', NULL, 'Acyl-CoA thioester hydrolase/BAAT N-terminal region', 125, NULL, 'Bile_Hydr_Trans', 260133),
(441040, 'PF07810', NULL, 'TMC domain', 111, NULL, 'TMC', 260134),
(441041, 'PF14582', NULL, 'Metallophosphoesterase, calcineurin superfamily', 257, NULL, 'Metallophos_3', 260135),
(441042, 'PF06157', NULL, 'Protein of unknown function (DUF973)', 310, NULL, 'DUF973', 260136),
(441043, 'PF18195', NULL, 'GatD N-terminal domain', 55, NULL, 'GatD_N', 260137);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(441044, 'PF17727', NULL, 'CtsR C-terminal dimerization domain', 72, NULL, 'CtsR_C', 260138),
(441045, 'PF13987', NULL, 'YedD-like protein', 106, NULL, 'YedD', 260139),
(441046, 'PF13614', NULL, 'AAA domain', 177, NULL, 'AAA_31', 260140),
(441047, 'PF11020', NULL, 'Domain of unknown function (DUF2610)', 81, NULL, 'DUF2610', 260141),
(441048, 'PF18611', NULL, 'IL-3 receptor alpha chain N-terminal domain', 78, NULL, 'IL3Ra_N', 260142),
(441049, 'PF19431', NULL, 'MEKK4 N-terminal', 1208, NULL, 'MEKK4_N', 260143),
(441050, 'PF13880', NULL, 'ESCO1/2 acetyl-transferase', 69, NULL, 'Acetyltransf_13', 260144),
(441051, 'PF16730', NULL, 'DnaG-primase C-terminal, helicase-binding domain', 118, NULL, 'DnaGprimase_HBD', 260145),
(441052, 'PF07222', NULL, 'Proacrosin binding protein sp32', 240, NULL, 'PBP_sp32', 260146),
(441053, 'PF15992', NULL, 'Domain of unknown function (DUF4769)', 256, NULL, 'DUF4769', 260147),
(441054, 'PF14526', NULL, 'Integron-associated effector binding protein', 149, NULL, 'Cass2', 260148),
(441055, 'PF09602', NULL, 'Polyhydroxyalkanoic acid inclusion protein (PhaP_Bmeg)', 168, NULL, 'PhaP_Bmeg', 260149),
(441056, 'PF03249', NULL, 'Type specific antigen', 510, NULL, 'TSA', 260150),
(441057, 'PF13918', NULL, 'PLD-like domain', 180, NULL, 'PLDc_3', 260151),
(441058, 'PF10803', NULL, 'Spore germination GerPB', 52, NULL, 'GerPB', 260152),
(441059, 'PF17214', NULL, 'KH domain', 68, NULL, 'KH_7', 260153),
(441060, 'PF03414', NULL, 'Glycosyltransferase family 6', 313, NULL, 'Glyco_transf_6', 260154),
(441061, 'PF19863', NULL, 'Family of unknown function (DUF6337)', 358, NULL, 'DUF6337', 260155),
(441062, 'PF15879', NULL, 'NADH-ubiquinone oxidoreductase MWFE subunit', 55, NULL, 'MWFE', 260156),
(441063, 'PF05058', NULL, 'ActA Protein', 633, NULL, 'ActA', 260157),
(441064, 'PF01042', NULL, 'Endoribonuclease L-PSP', 121, NULL, 'Ribonuc_L-PSP', 260158),
(441065, 'PF17794', NULL, 'Major Vault Protein repeat domain', 61, NULL, 'Vault_2', 260159),
(441066, 'PF04591', NULL, 'Protein of unknown function, DUF596', 73, NULL, 'DUF596', 260160),
(441067, 'PF05205', NULL, 'COMPASS (Complex proteins associated with Set1p) component shg1', 102, NULL, 'COMPASS-Shg1', 260161),
(441068, 'PF16037', NULL, 'Domain of unknown function (DUF4790)', 93, NULL, 'DUF4790', 260162),
(441069, 'PF19686', NULL, 'Family of unknown function (DUF6188)', 121, NULL, 'DUF6188', 260163),
(441070, 'PF18551', NULL, 'Thaumarchaeal output domain 1', 188, NULL, 'TackOD1', 260164),
(441071, 'PF05872', NULL, 'Helicase HerA-like C-terminal', 504, NULL, 'HerA_C', 260165),
(441072, 'PF09051', NULL, 'Stannin cytoplasmic', 26, NULL, 'SNN_cytoplasm', 260166),
(441073, 'PF09578', NULL, 'Spore cortex protein YabQ (Spore_YabQ)', 78, NULL, 'Spore_YabQ', 260167),
(441074, 'PF05193', NULL, 'Peptidase M16 inactive domain', 183, NULL, 'Peptidase_M16_C', 260168),
(441075, 'PF16199', NULL, 'Radical_SAM C-terminal domain', 82, NULL, 'Radical_SAM_C', 260169),
(441076, 'PF13296', NULL, 'Putative type VI secretion system Rhs element Vgr', 108, NULL, 'T6SS_Vgr', 260170),
(441077, 'PF03324', NULL, 'Herpesvirus DNA helicase/primase complex associated protein', 95, NULL, 'Herpes_HEPA', 260171),
(441078, 'PF08625', NULL, 'Utp13 specific WD40 associated domain', 142, NULL, 'Utp13', 260172),
(441079, 'PF07098', NULL, 'Protein of unknown function (DUF1360)', 102, NULL, 'DUF1360', 260173),
(441080, 'PF12993', NULL, 'Domain of unknown function, E. rectale Gene description (DUF3877)', 173, NULL, 'DUF3877', 260174),
(441081, 'PF10796', NULL, 'Sigma-S stabilisation anti-adaptor protein', 86, NULL, 'Anti-adapt_IraP', 260175),
(441082, 'PF04859', NULL, 'Plant protein of unknown function (DUF641)', 128, NULL, 'DUF641', 260176),
(441083, 'PF01062', NULL, 'Bestrophin, RFP-TM, chloride channel', 289, NULL, 'Bestrophin', 260177),
(441084, 'PF15790', NULL, 'E1A-binding protein p400, N-terminal', 490, NULL, 'EP400_N', 260178),
(441085, 'PF02888', NULL, 'Calmodulin binding domain', 75, NULL, 'CaMBD', 260179),
(441086, 'PF08581', NULL, 'Tup N-terminal', 77, NULL, 'Tup_N', 260180);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(441087, 'PF09805', NULL, 'Nucleolar protein 12 (25kDa)', 134, NULL, 'Nop25', 260181),
(441088, 'PF19935', NULL, 'Domain of unknown function (DUF6398)', 106, NULL, 'DUF6398', 260182),
(441089, 'PF10924', NULL, 'Protein of unknown function (DUF2711)', 217, NULL, 'DUF2711', 260183),
(441090, 'PF01933', NULL, '2-phospho-L-lactate transferase CofD', 294, NULL, 'CofD', 260184),
(441091, 'PF12570', NULL, 'Protein of unknown function (DUF3750)', 128, NULL, 'DUF3750', 260185),
(441092, 'PF13302', NULL, 'Acetyltransferase (GNAT) domain', 138, NULL, 'Acetyltransf_3', 260186),
(441093, 'PF17165', NULL, 'Domain of unknown function (DUF5121)', 115, NULL, 'DUF5121', 260187),
(441094, 'PF12827', NULL, 'Peroxisomal biogenesis protein family', 113, NULL, 'Peroxin-22', 260188),
(441095, 'PF17292', NULL, 'POB3-like N-terminal PH domain', 93, NULL, 'POB3_N', 260189),
(441096, 'PF00274', NULL, 'Fructose-bisphosphate aldolase class-I', 349, NULL, 'Glycolytic', 260190),
(441097, 'PF07005', NULL, 'Sugar-binding N-terminal domain', 227, NULL, 'SBD_N', 260191),
(441098, 'PF19952', NULL, 'Family of unknown function (DUF6414)', 250, NULL, 'DUF6414', 260192),
(441099, 'PF02854', NULL, 'MIF4G domain', 212, NULL, 'MIF4G', 260193),
(441100, 'PF14841', NULL, 'FliG middle domain', 76, NULL, 'FliG_M', 260194),
(441101, 'PF15016', NULL, 'Domain of unknown function (DUF4520)', 91, NULL, 'DUF4520', 260195),
(441102, 'PF18080', NULL, 'Galactose mutarotase-like fold domain', 241, NULL, 'Gal_mutarotas_3', 260196),
(441103, 'PF05230', NULL, 'MASE2 domain', 89, NULL, 'MASE2', 260197),
(441104, 'PF10006', NULL, 'Uncharacterized conserved protein (DUF2249)', 70, NULL, 'DUF2249', 260198),
(441105, 'PF04715', NULL, 'Anthranilate synthase component I, N terminal region', 142, NULL, 'Anth_synt_I_N', 260199),
(441106, 'PF11800', NULL, 'Replication protein C C-terminal region', 102, NULL, 'RP-C_C', 260200),
(441107, 'PF12701', NULL, 'Scd6-like Sm domain', 75, NULL, 'LSM14', 260201),
(441108, 'PF16303', NULL, 'Domain of unknown function (DUF4945)', 120, NULL, 'DUF4945', 260202),
(441109, 'PF14737', NULL, 'Domain of unknown function (DUF4470)', 100, NULL, 'DUF4470', 260203),
(441110, 'PF20275', NULL, 'C-terminal domain 10 of the ABC-three component (ABC-3C) systems', 132, NULL, 'CTD10', 260204),
(441111, 'PF07458', NULL, 'Sperm protein associated with nucleus, mapped to X chromosome', 94, NULL, 'SPAN-X', 260205),
(441112, 'PF03154', NULL, 'Atrophin-1 family', 994, NULL, 'Atrophin-1', 260206),
(441113, 'PF20072', NULL, 'Domain of unknown function (DUF6468)', 76, NULL, 'DUF6468', 260207),
(441114, 'PF06032', NULL, 'Protein of unknown function (DUF917)', 351, NULL, 'DUF917', 260208),
(441115, 'PF10772', NULL, 'Bacteriophage HP1, Orf24', 134, NULL, 'Phage_HP1_Orf24', 260209),
(441116, 'PF09072', NULL, 'Translation machinery associated TMA7', 62, NULL, 'TMA7', 260210),
(441117, 'PF02116', NULL, 'Fungal pheromone mating factor STE2 GPCR', 280, NULL, 'STE2', 260211),
(441118, 'PF08374', NULL, 'Protocadherin', 217, NULL, 'Protocadherin', 260212),
(441119, 'PF14600', NULL, 'Cellulose-binding domain', 62, NULL, 'CBM_5_12_2', 260213),
(441120, 'PF19250', NULL, 'Family of unknown function (DUF5898)', 109, NULL, 'DUF5898', 260214),
(441121, 'PF13784', NULL, 'Fic/DOC family N-terminal', 82, NULL, 'Fic_N', 260215),
(441122, 'PF04763', NULL, 'Protein of unknown function (DUF562)', 146, NULL, 'DUF562', 260216),
(441123, 'PF12039', NULL, 'Protein of unknown function (DUF3525)', 453, NULL, 'DUF3525', 260217),
(441124, 'PF03664', NULL, 'Glycosyl hydrolase family 62', 272, NULL, 'Glyco_hydro_62', 260218),
(441125, 'PF15058', NULL, 'Speriolin N terminus', 232, NULL, 'Speriolin_N', 260219),
(441126, 'PF02239', NULL, 'Cytochrome D1 heme domain', 368, NULL, 'Cytochrom_D1', 260220),
(441127, 'PF05419', NULL, 'GUN4-like', 141, NULL, 'GUN4', 260221),
(441128, 'PF04346', NULL, 'Ethanolamine utilisation protein, EutH', 351, NULL, 'EutH', 260222),
(441129, 'PF19832', NULL, 'Family of unknown function (DUF6313)', 183, NULL, 'DUF6313', 260223),
(441130, 'PF12008', NULL, 'Type I restriction and modification enzyme - subunit R C terminal', 259, NULL, 'EcoR124_C', 260224);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(441131, 'PF12888', NULL, 'Lipid-binding putative hydrolase', 142, NULL, 'Lipid_bd', 260225),
(441132, 'PF04615', NULL, 'Utp14 protein', 729, NULL, 'Utp14', 260226),
(441133, 'PF08552', NULL, 'Inositolphosphorylceramide synthase subunit Kei1', 189, NULL, 'Kei1', 260227),
(441134, 'PF10870', NULL, 'Protein of unknown function (DUF2729)', 57, NULL, 'DUF2729', 260228),
(441135, 'PF04095', NULL, 'Nicotinate phosphoribosyltransferase (NAPRTase) family', 247, NULL, 'NAPRTase', 260229),
(441136, 'PF11392', NULL, 'Protein of unknown function (DUF2877)', 109, NULL, 'DUF2877', 260230),
(441137, 'PF16023', NULL, 'DUF4784 WD40-like domain', 304, NULL, 'DUF4784', 260231),
(441138, 'PF13646', NULL, 'HEAT repeats', 88, NULL, 'HEAT_2', 260232),
(441139, 'PF00035', NULL, 'Double-stranded RNA binding motif', 67, NULL, 'dsrm', 260233),
(441140, 'PF05838', NULL, 'Glycosyl hydrolase 108', 85, NULL, 'Glyco_hydro_108', 260234),
(441141, 'PF08405', NULL, 'Viral polyprotein N-terminal', 358, NULL, 'Calici_PP_N', 260235),
(441142, 'PF15684', NULL, 'Active regulator of SIRT1, or 40S ribosomal protein S19-binding 1', 130, NULL, 'AROS', 260236),
(441143, 'PF00029', NULL, 'Connexin', 228, NULL, 'Connexin', 260237),
(441144, 'PF07277', NULL, 'SapC', 221, NULL, 'SapC', 260238),
(441145, 'PF03908', NULL, 'Sec20', 92, NULL, 'Sec20', 260239),
(441146, 'PF00487', NULL, 'Fatty acid desaturase', 254, NULL, 'FA_desaturase', 260240),
(441147, 'PF09115', NULL, 'DNA polymerase III, delta subunit, C terminal', 117, NULL, 'DNApol3-delta_C', 260241),
(441148, 'PF04825', NULL, 'N terminus of Rad21 / Rec8 like protein', 111, NULL, 'Rad21_Rec8_N', 260242),
(441149, 'PF16341', NULL, 'Domain of unknown function (DUF4971)', 139, NULL, 'DUF4971', 260243),
(441150, 'PF05001', NULL, 'RNA polymerase Rpb1 C-terminal repeat', 14, NULL, 'RNA_pol_Rpb1_R', 260244),
(441151, 'PF12336', NULL, 'SOX transcription factor', 91, NULL, 'SOXp', 260245),
(441152, 'PF03584', NULL, 'Herpesvirus ICP4-like protein N-terminal region', 174, NULL, 'Herpes_ICP4_N', 260246),
(441153, 'PF12763', NULL, 'Cytoskeletal-regulatory complex EF hand', 104, NULL, 'EF-hand_4', 260247),
(441154, 'PF19308', NULL, 'CRISPR Cas6 N-terminal domain', 148, NULL, 'CRISPR_Cas6_N', 260248),
(441155, 'PF20217', NULL, 'Family of unknown function (DUF6577)', 204, NULL, 'DUF6577', 260249),
(441156, 'PF10038', NULL, 'Protein of unknown function (DUF2274)', 69, NULL, 'DUF2274', 260250),
(441157, 'PF04990', NULL, 'RNA polymerase Rpb1, domain 7', 135, NULL, 'RNA_pol_Rpb1_7', 260251),
(441158, 'PF02133', NULL, 'Permease for cytosine/purines, uracil, thiamine, allantoin', 440, NULL, 'Transp_cyt_pur', 260252),
(441159, 'PF02534', NULL, 'Type IV secretory system Conjugative DNA transfer', 469, NULL, 'T4SS-DNA_transf', 260253),
(441160, 'PF05153', NULL, 'Myo-inositol oxygenase', 249, NULL, 'MIOX', 260254),
(441161, 'PF19480', NULL, 'Domain of unknown function (DUF6016)', 141, NULL, 'DUF6016', 260255),
(441162, 'PF00400', NULL, 'WD domain, G-beta repeat', 38, NULL, 'WD40', 260256),
(441163, 'PF13454', NULL, 'FAD-NAD(P)-binding', 155, NULL, 'NAD_binding_9', 260257),
(441164, 'PF08164', NULL, 'Apoptosis-antagonizing transcription factor, C-terminal', 83, NULL, 'TRAUB', 260258),
(441165, 'PF10728', NULL, 'Domain of unknown function (DUF2520)', 127, NULL, 'DUF2520', 260259),
(441166, 'PF06188', NULL, 'HrpE/YscL/FliH and V-type ATPase subunit E', 191, NULL, 'HrpE', 260260),
(441167, 'PF12201', NULL, 'Bcl2-interacting killer, BH3-domain containing', 156, NULL, 'bcl-2I13', 260261),
(441168, 'PF14425', NULL, 'Immunity protein Imm3', 119, NULL, 'Imm3', 260262),
(441169, 'PF18184', NULL, 'SMODS and SLOG-associating 2TM effector domain 3', 156, NULL, 'SLATT_3', 260263),
(441170, 'PF06720', NULL, 'Bacteriophage phi-29 early protein GP16.7', 130, NULL, 'Phi-29_GP16_7', 260264),
(441171, 'PF09929', NULL, 'Putative PD-(D/E)XK phosphodiesterase (DUF2161)', 118, NULL, 'DUF2161', 260265),
(441172, 'PF18308', NULL, 'N-terminal extension of GAT domain', 39, NULL, 'GGA_N-GAT', 260266),
(441173, 'PF18541', NULL, 'RuvC endonuclease subdomain 3', 180, NULL, 'RuvC_III', 260267);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(441174, 'PF13778', NULL, 'Domain of unknown function (DUF4174)', 120, NULL, 'DUF4174', 260268),
(441175, 'PF14695', NULL, 'Lines C-terminus', 37, NULL, 'LINES_C', 260269),
(441176, 'PF05972', NULL, 'APC 15 residue motif', 15, NULL, 'APC_15aa', 260270),
(441177, 'PF07592', NULL, 'Rhodopirellula transposase DDE domain', 308, NULL, 'DDE_Tnp_ISAZ013', 260271),
(441178, 'PF08198', NULL, 'Thymopoietin protein', 48, NULL, 'Thymopoietin', 260272),
(441179, 'PF14353', NULL, 'CpXC protein', 118, NULL, 'CpXC', 260273),
(441180, 'PF13709', NULL, 'Domain of unknown function (DUF4159)', 205, NULL, 'DUF4159', 260274),
(441181, 'PF18267', NULL, 'Rubredoxin NAD+ reductase C-terminal domain', 70, NULL, 'Rubredoxin_C', 260275),
(441182, 'PF09309', NULL, 'FCP1, C-terminal', 260, NULL, 'FCP1_C', 260276),
(441183, 'PF19711', NULL, 'Family of unknown function (DUF6207)', 67, NULL, 'DUF6207', 260277),
(441184, 'PF19789', NULL, 'Family of unknown function (DUF6273)', 171, NULL, 'DUF6273', 260278),
(441185, 'PF02240', NULL, 'Methyl-coenzyme M reductase gamma subunit', 246, NULL, 'MCR_gamma', 260279),
(441186, 'PF10871', NULL, 'Protein of unknown function (DUF2748)', 438, NULL, 'DUF2748', 260280),
(441187, 'PF00420', NULL, 'NADH-ubiquinone/plastoquinone oxidoreductase chain 4L', 105, NULL, 'Oxidored_q2', 260281),
(441188, 'PF12240', NULL, 'Angiomotin C terminal', 201, NULL, 'Angiomotin_C', 260282),
(441189, 'PF02056', NULL, 'Family 4 glycosyl hydrolase', 183, NULL, 'Glyco_hydro_4', 260283),
(441190, 'PF15036', NULL, 'Interleukin 34', 157, NULL, 'IL34', 260284),
(441191, 'PF16844', NULL, 'Dinitrogenase iron-molybdenum cofactor, N-terminal', 91, NULL, 'DIMCO_N', 260285),
(441192, 'PF13402', NULL, 'Peptidase M60, enhancin and enhancin-like', 269, NULL, 'Peptidase_M60', 260286),
(441193, 'PF14647', NULL, 'FAM91 N-terminus', 307, NULL, 'FAM91_N', 260287),
(441194, 'PF05752', NULL, 'Calicivirus minor structural protein', 165, NULL, 'Calici_MSP', 260288),
(441195, 'PF06024', NULL, 'Orf78 (ac78)', 103, NULL, 'Orf78', 260289),
(441196, 'PF10159', NULL, 'Multiple myeloma tumor-associated', 79, NULL, 'MMtag', 260290),
(441197, 'PF14468', NULL, 'Protein of unknown function (DUF4427)', 132, NULL, 'DUF4427', 260291),
(441198, 'PF16389', NULL, 'Domain of unknown function', 199, NULL, 'DUF4998', 260292),
(441199, 'PF07621', NULL, 'Protein of unknown function (DUF1582)', 29, NULL, 'DUF1582', 260293),
(441200, 'PF08180', NULL, 'B melanoma antigen family', 28, NULL, 'BAGE', 260294),
(441201, 'PF13364', NULL, 'Beta-galactosidase jelly roll domain', 114, NULL, 'BetaGal_dom4_5', 260295),
(441202, 'PF13467', NULL, 'Ribbon-helix-helix domain', 65, NULL, 'RHH_4', 260296),
(441203, 'PF19258', NULL, 'KxYKxGKxW signal peptide', 41, NULL, 'KxYKxGKxW_sig', 260297),
(441204, 'PF16036', NULL, 'Chalcone isomerase-like', 165, NULL, 'Chalcone_3', 260298),
(441205, 'PF11720', NULL, 'Peptidase inhibitor I78 family', 65, NULL, 'Inhibitor_I78', 260299),
(441206, 'PF07684', NULL, 'NOTCH protein', 59, NULL, 'NODP', 260300),
(441207, 'PF10751', NULL, 'Protein of unknown function (DUF2535)', 83, NULL, 'DUF2535', 260301),
(441208, 'PF13693', NULL, 'Winged helix-turn-helix DNA-binding', 75, NULL, 'HTH_35', 260302),
(441209, 'PF18936', NULL, 'Family of unknown function (DUF5684)', 79, NULL, 'DUF5684', 260303),
(441210, 'PF05820', NULL, 'Baculoviridae AC81', 181, NULL, 'Ac81', 260304),
(441211, 'PF01995', NULL, 'NrpR regulatory domains NRD1 and 2', 238, NULL, 'NRD1_2', 260305),
(441212, 'PF16915', NULL, 'Annelid erythrocruorin linker subunit C-terminus', 121, NULL, 'Eryth_link_C', 260306),
(441213, 'PF16570', NULL, 'Gram-positive pilin backbone subunit 3, Cna-B-like domain', 141, NULL, 'GramPos_pilinD3', 260307),
(441214, 'PF19905', NULL, 'Domain of unknown function (DUF6378)', 81, NULL, 'DUF6378', 260308),
(441215, 'PF01176', NULL, 'Translation initiation factor 1A / IF-1', 64, NULL, 'eIF-1a', 260309),
(441216, 'PF19924', NULL, 'Family of unknown function (DUF6387)', 274, NULL, 'DUF6387', 260310),
(441217, 'PF09351', NULL, 'Domain of unknown function (DUF1993)', 161, NULL, 'DUF1993', 260311);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(441218, 'PF04491', NULL, 'Poxvirus T4 protein, N terminus', 46, NULL, 'Pox_T4_N', 260312),
(441219, 'PF18998', NULL, 'Divergent InlB B-repeat domain', 74, NULL, 'Flg_new_2', 260313),
(441220, 'PF03251', NULL, 'Tymovirus 45/70Kd protein', 468, NULL, 'Tymo_45kd_70kd', 260314),
(441221, 'PF03635', NULL, 'Vacuolar protein sorting-associated protein 35', 728, NULL, 'Vps35', 260315),
(441222, 'PF01823', NULL, 'MAC/Perforin domain', 212, NULL, 'MACPF', 260316),
(441223, 'PF20563', NULL, 'Family of unknown function (DUF6773)', 163, NULL, 'DUF6773', 260317),
(441224, 'PF03291', NULL, 'mRNA capping enzyme', 333, NULL, 'Pox_MCEL', 260318),
(441225, 'PF20058', NULL, 'Domain of unknown function (DUF6457)', 78, NULL, 'DUF6457', 260319),
(441226, 'PF19654', NULL, 'Family of unknown function (DUF6157)', 136, NULL, 'DUF6157', 260320),
(441227, 'PF15065', NULL, 'Lysosomal transcription factor, NCU-G1', 356, NULL, 'NCU-G1', 260321),
(441228, 'PF01137', NULL, 'RNA 3''-terminal phosphate cyclase', 222, NULL, 'RTC', 260322),
(441229, 'PF19496', NULL, 'Family of unknown function (DUF6031)', 175, NULL, 'DUF6031', 260323),
(441230, 'PF02283', NULL, 'Cobinamide kinase / cobinamide phosphate guanyltransferase', 170, NULL, 'CobU', 260324),
(441231, 'PF04283', NULL, 'Chemotaxis signal transduction system protein F from archaea', 217, NULL, 'CheF-arch', 260325),
(441232, 'PF20203', NULL, 'Domain of unknown function (DUF6565)', 106, NULL, 'DUF6565', 260326),
(441233, 'PF12982', NULL, 'Protein of unknown function (DUF3866)', 319, NULL, 'DUF3866', 260327),
(441234, 'PF18473', NULL, 'Urease subunit beta-alpha linker domain', 34, NULL, 'Urease_linker', 260328),
(441235, 'PF07136', NULL, 'Protein of unknown function (DUF1385)', 227, NULL, 'DUF1385', 260329),
(441236, 'PF11074', NULL, 'Domain of unknown function(DUF2779)', 126, NULL, 'DUF2779', 260330),
(441237, 'PF08010', NULL, 'Bacteriophage protein GP30.3', 138, NULL, 'Phage_30_3', 260331),
(441238, 'PF13568', NULL, 'Outer membrane protein beta-barrel domain', 180, NULL, 'OMP_b-brl_2', 260332),
(441239, 'PF19749', NULL, 'Family of unknown function (DUF6236)', 332, NULL, 'DUF6236', 260333),
(441240, 'PF03349', NULL, 'Outer membrane protein transport protein (OMPP1/FadL/TodX)', 431, NULL, 'Toluene_X', 260334),
(441241, 'PF05431', NULL, 'Insecticidal Crystal Toxin, P42', 169, NULL, 'Toxin_10', 260335),
(441242, 'PF08535', NULL, 'KorB domain', 89, NULL, 'KorB', 260336),
(441243, 'PF11372', NULL, 'Domain of unknown function (DUF3173)', 58, NULL, 'DUF3173', 260337),
(441244, 'PF16152', NULL, 'Domain of unknown function (DUF4860)', 98, NULL, 'DUF4860', 260338),
(441245, 'PF09185', NULL, 'Domain of unknown function (DUF1948)', 140, NULL, 'DUF1948', 260339),
(441246, 'PF12126', NULL, 'Protein of unknown function (DUF3583)', 329, NULL, 'DUF3583', 260340),
(441247, 'PF11221', NULL, 'Subunit 21 of Mediator complex', 145, NULL, 'Med21', 260341),
(441248, 'PF13603', NULL, 'Leucyl-tRNA synthetase, Domain 2', 185, NULL, 'tRNA-synt_1_2', 260342),
(441249, 'PF14539', NULL, 'Domain of unknown function (DUF4442)', 132, NULL, 'DUF4442', 260343),
(441250, 'PF17886', NULL, 'HSP20-like domain found in ArsA', 63, NULL, 'ArsA_HSP20', 260344),
(441251, 'PF06432', NULL, 'Phosphatidylinositol N-acetylglucosaminyltransferase', 280, NULL, 'GPI2', 260345),
(441252, 'PF08166', NULL, 'NUC202 domain', 61, NULL, 'NUC202', 260346),
(441253, 'PF04096', NULL, 'Nucleoporin autopeptidase', 149, NULL, 'Nucleoporin2', 260347),
(441254, 'PF14378', NULL, 'PAP2 superfamily', 190, NULL, 'PAP2_3', 260348),
(441255, 'PF19257', NULL, 'BURAN domain', 88, NULL, 'BURAN', 260349),
(441256, 'PF00493', NULL, 'MCM P-loop domain', 224, NULL, 'MCM', 260350),
(441257, 'PF13876', NULL, 'Phage protein (N4 Gp49/phage Sf6 gene 66) family', 83, NULL, 'Phage_gp49_66', 260351),
(441258, 'PF08302', NULL, 'Fungal tRNA ligase phosphodiesterase domain', 253, NULL, 'tRNA_lig_CPD', 260352),
(441259, 'PF10826', NULL, 'Protein of unknown function (DUF2551)', 83, NULL, 'DUF2551', 260353),
(441260, 'PF13246', NULL, 'Cation transport ATPase (P-type)', 91, NULL, 'Cation_ATPase', 260354);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(441261, 'PF07802', NULL, 'GCK domain', 74, NULL, 'GCK', 260355),
(441262, 'PF14851', NULL, 'FAM176 family', 146, NULL, 'FAM176', 260356),
(441263, 'PF20568', NULL, 'Domain of unknown function (DUF6777)', 163, NULL, 'DUF6777', 260357),
(441264, 'PF03233', NULL, 'Aphid transmission protein', 163, NULL, 'Cauli_AT', 260358),
(441265, 'PF11408', NULL, 'Sgs1 RecQ helicase', 80, NULL, 'Helicase_Sgs1', 260359),
(441266, 'PF15107', NULL, 'FAM216B protein family', 111, NULL, 'FAM216B', 260360),
(441267, 'PF00100', NULL, 'Zona pellucida-like domain', 259, NULL, 'Zona_pellucida', 260361),
(441268, 'PF02919', NULL, 'Eukaryotic DNA topoisomerase I, DNA binding fragment', 213, NULL, 'Topoisom_I_N', 260362),
(441269, 'PF18501', NULL, 'Alpha helical recognition lobe domain', 248, NULL, 'REC1', 260363),
(441270, 'PF13450', NULL, 'NAD(P)-binding Rossmann-like domain', 68, NULL, 'NAD_binding_8', 260364),
(441271, 'PF15158', NULL, 'Domain of unknown function (DUF4579)', 185, NULL, 'DUF4579', 260365),
(441272, 'PF15692', NULL, 'NF-kappa-B-activating protein', 81, NULL, 'NKAP', 260366),
(441273, 'PF20304', NULL, 'Small protein from certain CxC ATPase-based DNA modification systems', 63, NULL, 'Sp-CxC', 260367),
(441274, 'PF03781', NULL, 'Sulfatase-modifying factor enzyme 1', 260, NULL, 'FGE-sulfatase', 260368),
(441275, 'PF08658', NULL, 'Rad54 N terminal', 183, NULL, 'Rad54_N', 260369),
(441276, 'PF02404', NULL, 'Stem cell factor', 275, NULL, 'SCF', 260370),
(441277, 'PF11649', NULL, 'Virus neck protein', 278, NULL, 'T4_neck-protein', 260371),
(441278, 'PF10014', NULL, '2OG-Fe dioxygenase', 191, NULL, '2OG-Fe_Oxy_2', 260372),
(441279, 'PF10240', NULL, 'Multivesicular body subunit 12', 255, NULL, 'DUF2464', 260373),
(441280, 'PF14798', NULL, 'Calcium homeostasis modulator', 253, NULL, 'Ca_hom_mod', 260374),
(441281, 'PF15796', NULL, 'KELK-motif containing domain of MRCK Ser/Thr protein kinase', 80, NULL, 'KELK', 260375),
(441282, 'PF16028', NULL, 'Solute carrier family 3 member 2 N-terminus', 77, NULL, 'SLC3A2_N', 260376),
(441283, 'PF00571', NULL, 'CBS domain', 57, NULL, 'CBS', 260377),
(441284, 'PF02713', NULL, 'Domain of unknown function DUF220', 73, NULL, 'DUF220', 260378),
(441285, 'PF10007', NULL, 'Uncharacterized protein conserved in archaea (DUF2250)', 93, NULL, 'DUF2250', 260379),
(441286, 'PF17524', NULL, 'Anti-sigma factor CnrY', 95, NULL, 'CnrY', 260380),
(441287, 'PF11782', NULL, 'Protein of unknown function (DUF3319)', 89, NULL, 'DUF3319', 260381),
(441288, 'PF18424', NULL, 'Alpha-Dystroglycan N-terminal domain 2', 123, NULL, 'a_DG1_N2', 260382),
(441289, 'PF03862', NULL, 'SpoVAC/SpoVAEB sporulation membrane protein', 114, NULL, 'SpoVAC_SpoVAEB', 260383),
(441290, 'PF01702', NULL, 'Queuine tRNA-ribosyltransferase', 355, NULL, 'TGT', 260384),
(441291, 'PF19775', NULL, 'Family of unknown function (DUF6261)', 154, NULL, 'DUF6261', 260385),
(441292, 'PF20015', NULL, 'vWA-MoxR associated protein middle region (VMAP-M) 12', 136, NULL, 'VMAP-M12', 260386),
(441293, 'PF07212', NULL, 'Hyaluronidase protein (HylP)', 273, NULL, 'Hyaluronidase_1', 260387),
(441294, 'PF01447', NULL, 'Thermolysin metallopeptidase, catalytic domain', 146, NULL, 'Peptidase_M4', 260388),
(441295, 'PF15116', NULL, 'CAMPATH-1 antigen', 44, NULL, 'CD52', 260389),
(441296, 'PF03265', NULL, 'Deoxyribonuclease II', 328, NULL, 'DNase_II', 260390),
(441297, 'PF13532', NULL, '2OG-Fe(II) oxygenase superfamily', 194, NULL, '2OG-FeII_Oxy_2', 260391),
(441298, 'PF18523', NULL, 'Sld3 N-terminal domain', 116, NULL, 'Sld3_N', 260392),
(441299, 'PF03033', NULL, 'Glycosyltransferase family 28 N-terminal domain', 139, NULL, 'Glyco_transf_28', 260393),
(441300, 'PF07685', NULL, 'CobB/CobQ-like glutamine amidotransferase domain', 197, NULL, 'GATase_3', 260394),
(441301, 'PF01641', NULL, 'SelR domain', 121, NULL, 'SelR', 260395),
(441302, 'PF15431', NULL, 'Transmembrane protein 190', 128, NULL, 'TMEM190', 260396),
(441303, 'PF18527', NULL, 'STT3/PglB C-terminal beta-barrel domain', 80, NULL, 'STT3_PglB_C', 260397),
(441304, 'PF13967', NULL, 'Late exocytosis, associated with Golgi transport', 156, NULL, 'RSN1_TM', 260398);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(441305, 'PF20394', NULL, 'Family of unknown function (DUF6688)', 366, NULL, 'DUF6688', 260399),
(441306, 'PF20211', NULL, 'Family of unknown function (DUF6571)', 705, NULL, 'DUF6571', 260400),
(441307, 'PF00629', NULL, 'MAM domain, meprin/A5/mu', 161, NULL, 'MAM', 260401),
(441308, 'PF15038', NULL, 'Jiraiya', 169, NULL, 'Jiraiya', 260402),
(441309, 'PF15584', NULL, 'Immunity protein 72', 81, NULL, 'Imm72', 260403),
(441310, 'PF17846', NULL, 'Xrn1 helical domain', 443, NULL, 'XRN_M', 260404),
(441311, 'PF03543', NULL, 'Yersinia/Haemophilus virulence surface antigen', 204, NULL, 'Peptidase_C58', 260405),
(441312, 'PF20475', NULL, 'Family of unknown function (DUF6717)', 115, NULL, 'DUF6717', 260406),
(441313, 'PF01821', NULL, 'Anaphylotoxin-like domain', 36, NULL, 'ANATO', 260407),
(441314, 'PF10587', NULL, 'Eukaryotic elongation factor 1 beta central acidic region', 28, NULL, 'EF-1_beta_acid', 260408),
(441315, 'PF14810', NULL, 'Patch-forming domain C2 of tRNA-guanine transglycosylase', 71, NULL, 'TGT_C2', 260409),
(441316, 'PF01742', NULL, 'Clostridial neurotoxin zinc protease', 417, NULL, 'Peptidase_M27', 260410),
(441317, 'PF09820', NULL, 'Predicted AAA-ATPase', 280, NULL, 'AAA-ATPase_like', 260411),
(441318, 'PF14142', NULL, 'YrzO-like protein', 46, NULL, 'YrzO', 260412),
(441319, 'PF08184', NULL, 'Cuticle protein 7 isoform family', 59, NULL, 'Cuticle_2', 260413),
(441320, 'PF18680', NULL, 'Plasmodium host cell traversal SPECT1', 180, NULL, 'SPECT1', 260414),
(441321, 'PF00699', NULL, 'Urease beta subunit', 98, NULL, 'Urease_beta', 260415),
(441322, 'PF05364', NULL, 'Salmonella type III secretion SopE effector N-terminus', 74, NULL, 'SecIII_SopE_N', 260416),
(441323, 'PF03760', NULL, 'Late embryogenesis abundant (LEA) group 1', 71, NULL, 'LEA_1', 260417),
(441324, 'PF14641', NULL, 'Helix-turn-helix DNA-binding domain of SPT6', 117, NULL, 'HTH_44', 260418),
(441325, 'PF08170', NULL, 'POPLD (NUC188) domain', 93, NULL, 'POPLD', 260419),
(441326, 'PF06568', NULL, 'Domain of unknown function (DUF1127)', 37, NULL, 'DUF1127', 260420),
(441327, 'PF07142', NULL, 'Repeat of unknown function (DUF1388)', 28, NULL, 'DUF1388', 260421),
(441328, 'PF02248', NULL, 'Small coat protein', 183, NULL, 'Como_SCP', 260422),
(441329, 'PF00056', NULL, 'lactate/malate dehydrogenase, NAD binding domain', 141, NULL, 'Ldh_1_N', 260423),
(441330, 'PF02870', NULL, '6-O-methylguanine DNA methyltransferase, ribonuclease-like domain', 77, NULL, 'Methyltransf_1N', 260424),
(441331, 'PF04237', NULL, 'YjbR', 90, NULL, 'YjbR', 260425),
(441332, 'PF10237', NULL, 'Probable N6-adenine methyltransferase', 168, NULL, 'N6-adenineMlase', 260426),
(441333, 'PF01012', NULL, 'Electron transfer flavoprotein domain', 182, NULL, 'ETF', 260427),
(441334, 'PF08266', NULL, 'Cadherin-like', 83, NULL, 'Cadherin_2', 260428),
(441335, 'PF18048', NULL, 'TNF receptor-associated factor 6 zinc finger 2', 27, NULL, 'TRAF6_Z2', 260429),
(441336, 'PF00890', NULL, 'FAD binding domain', 417, NULL, 'FAD_binding_2', 260430),
(441337, 'PF08608', NULL, 'Wyosine base formation', 63, NULL, 'Wyosine_form', 260431),
(441338, 'PF07040', NULL, 'Protein of unknown function (DUF1326)', 177, NULL, 'DUF1326', 260432),
(441339, 'PF18125', NULL, 'RlmM ferredoxin-like domain', 71, NULL, 'RlmM_FDX', 260433),
(441340, 'PF09454', NULL, 'Vps23 core domain', 64, NULL, 'Vps23_core', 260434),
(441341, 'PF04578', NULL, 'Protein of unknown function, DUF594', 55, NULL, 'DUF594', 260435),
(441342, 'PF17485', NULL, 'Satellite RNA 48 kDa protein', 299, NULL, 'SatRNA_48', 260436),
(441343, 'PF18827', NULL, 'Large polyvalent protein-associated domain 14', 136, NULL, 'LPD14', 260437),
(441344, 'PF06268', NULL, 'Fascin domain', 111, NULL, 'Fascin', 260438),
(441345, 'PF11776', NULL, 'Nickel/cobalt transporter regulator', 51, NULL, 'RcnB', 260439),
(441346, 'PF09868', NULL, 'Uncharacterized protein conserved in archaea (DUF2095)', 129, NULL, 'DUF2095', 260440),
(441347, 'PF07281', NULL, 'Insulin-induced protein (INSIG)', 220, NULL, 'INSIG', 260441),
(441348, 'PF12644', NULL, 'Protein of unknown function (DUF3782)', 78, NULL, 'DUF3782', 260442); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(441349, 'PF17064', NULL, 'Sleepless protein', 85, NULL, 'QVR', 260443),
(441350, 'PF08231', NULL, 'SYF2 splicing factor', 163, NULL, 'SYF2', 260444),
(441351, 'PF00666', NULL, 'Cathelicidin', 101, NULL, 'Cathelicidins', 260445),
(441352, 'PF13173', NULL, 'AAA domain', 130, NULL, 'AAA_14', 260446),
(441353, 'PF17213', NULL, 'Hydin Adenylate kinase-like domain', 198, NULL, 'Hydin_ADK', 260447),
(441354, 'PF10713', NULL, 'Protein of unknown function (DUF2509)', 131, NULL, 'DUF2509', 260448),
(441355, 'PF09857', NULL, 'Putative toxin of bacterial toxin-antitoxin pair', 85, NULL, 'YjhX_toxin', 260449),
(441356, 'PF05987', NULL, 'Bacterial protein of unknown function (DUF898)', 343, NULL, 'DUF898', 260450),
(441357, 'PF07647', NULL, 'SAM domain (Sterile alpha motif)', 66, NULL, 'SAM_2', 260451),
(441358, 'PF11522', NULL, 'Yeast phosphatidylinositol-4-OH kinase Pik1', 51, NULL, 'Pik1', 260452),
(441359, 'PF17583', NULL, 'Family of unknown function (DUF5484)', 43, NULL, 'DUF5484', 260453),
(441360, 'PF19694', NULL, 'Family of unknown function (DUF6194)', 156, NULL, 'DUF6194', 260454),
(441361, 'PF20353', NULL, 'Family of unknown function (DUF6648)', 182, NULL, 'DUF6648', 260455),
(441362, 'PF04905', NULL, 'NAB conserved region 2 (NCD2)', 125, NULL, 'NCD2', 260456),
(441363, 'PF16398', NULL, 'Domain of unknown function (DUF5007)', 287, NULL, 'DUF5007', 260457),
(441364, 'PF00958', NULL, 'GMP synthase C terminal domain', 92, NULL, 'GMP_synt_C', 260458),
(441365, 'PF11704', NULL, 'Vesicle coat protein involved in Golgi to plasma membrane transport', 186, NULL, 'Folliculin', 260459),
(441366, 'PF03704', NULL, 'Bacterial transcriptional activator domain', 146, NULL, 'BTAD', 260460),
(441367, 'PF10820', NULL, 'Protein of unknown function (DUF2543)', 81, NULL, 'DUF2543', 260461),
(441368, 'PF19314', NULL, 'Family of unknown function (DUF5917)', 94, NULL, 'DUF5917', 260462),
(441369, 'PF17116', NULL, 'Domain of unknown function (DUF5103)', 288, NULL, 'DUF5103', 260463),
(441370, 'PF17104', NULL, 'Domain of unknown function (DUF5102)', 292, NULL, 'DUF5102', 260464),
(441371, 'PF10752', NULL, 'Protein of unknown function (DUF2533)', 83, NULL, 'DUF2533', 260465),
(441372, 'PF09139', NULL, 'Phosphatidate cytidylyltransferase, mitochondrial', 323, NULL, 'Tam41_Mmp37', 260466),
(441373, 'PF11682', NULL, 'Probable zinc-ribbon', 128, NULL, 'zinc_ribbon_11', 260467),
(441374, 'PF18129', NULL, 'Xrn1 SH3-like domain', 67, NULL, 'SH3_12', 260468),
(441375, 'PF09456', NULL, 'RcsC Alpha-Beta-Loop (ABL)', 91, NULL, 'RcsC', 260469),
(441376, 'PF10230', NULL, 'Lipid-droplet associated hydrolase', 266, NULL, 'LIDHydrolase', 260470),
(441377, 'PF09074', NULL, 'Mer2', 193, NULL, 'Mer2', 260471),
(441378, 'PF11252', NULL, 'Protein of unknown function (DUF3051)', 189, NULL, 'DUF3051', 260472),
(441379, 'PF12173', NULL, 'Bacteriocin class IIc cyclic gassericin A-like', 91, NULL, 'BacteriocIIc_cy', 260473),
(441380, 'PF16078', NULL, '2-oxoglutarate dehydrogenase N-terminus', 41, NULL, '2-oxogl_dehyd_N', 260474),
(441381, 'PF12357', NULL, 'Phospholipase D C terminal', 72, NULL, 'PLD_C', 260475),
(441382, 'PF03151', NULL, 'Triose-phosphate Transporter family', 290, NULL, 'TPT', 260476),
(441383, 'PF08078', NULL, 'PsaX family', 35, NULL, 'PsaX', 260477),
(441384, 'PF00491', NULL, 'Arginase family', 280, NULL, 'Arginase', 260478),
(441385, 'PF00858', NULL, 'Amiloride-sensitive sodium channel', 445, NULL, 'ASC', 260479),
(441386, 'PF02296', NULL, 'Alpha adaptin AP2, C-terminal domain', 113, NULL, 'Alpha_adaptin_C', 260480),
(441387, 'PF18997', NULL, 'Family of unknown function (DUF5727)', 192, NULL, 'DUF5727', 260481),
(441388, 'PF11821', NULL, 'Alternative complex III, ActD subunit', 170, NULL, 'ActD', 260482),
(441389, 'PF09741', NULL, 'Uncharacterized conserved protein (DUF2045)', 233, NULL, 'DUF2045', 260483),
(441390, 'PF04127', NULL, 'DNA / pantothenate metabolism flavoprotein', 186, NULL, 'DFP', 260484),
(441391, 'PF03618', NULL, 'Kinase/pyrophosphorylase', 255, NULL, 'Kinase-PPPase', 260485),
(441392, 'PF08545', NULL, '3-Oxoacyl-[acyl-carrier-protein (ACP)] synthase III', 80, NULL, 'ACP_syn_III', 260486);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(441393, 'PF19328', NULL, '2,4-diaminopentanoate dehydrogenase C-terminal domain', 206, NULL, 'DAP_DH_C', 260487),
(441394, 'PF10313', NULL, 'Uncharacterised protein domain (DUF2415)', 43, NULL, 'DUF2415', 260488),
(441395, 'PF18931', NULL, 'Domain of unknown function (DUF5680)', 104, NULL, 'DUF5680', 260489),
(441396, 'PF05963', NULL, 'Cytomegalovirus US3 protein', 185, NULL, 'Cytomega_US3', 260490),
(441397, 'PF00473', NULL, 'Corticotropin-releasing factor family', 38, NULL, 'CRF', 260491),
(441398, 'PF14439', NULL, 'Bd3614-like deaminase', 136, NULL, 'Bd3614-deam', 260492),
(441399, 'PF04706', NULL, 'Dickkopf N-terminal cysteine-rich region', 52, NULL, 'Dickkopf_N', 260493),
(441400, 'PF01948', NULL, 'Aspartate carbamoyltransferase regulatory chain, allosteric domain', 94, NULL, 'PyrI', 260494),
(441401, 'PF11549', NULL, 'Protein transport protein SEC31', 50, NULL, 'Sec31', 260495),
(441402, 'PF00472', NULL, 'RF-1 domain', 116, NULL, 'RF-1', 260496),
(441403, 'PF19240', NULL, 'Family of unknown function (DUF5890)', 75, NULL, 'DUF5890', 260497),
(441404, 'PF11551', NULL, 'Outer membrane protein Omp28', 171, NULL, 'Omp28', 260498),
(441405, 'PF15680', NULL, 'Orofacial cleft 1 candidate gene 1 protein', 109, NULL, 'OFCC1', 260499),
(441406, 'PF01443', NULL, 'Viral (Superfamily 1) RNA helicase', 234, NULL, 'Viral_helicase1', 260500),
(441407, 'PF07119', NULL, 'Protein of unknown function (DUF1375)', 53, NULL, 'DUF1375', 260501),
(441408, 'PF16888', NULL, 'Domain of unknown function (DUF5082)', 123, NULL, 'DUF5082', 260502),
(441409, 'PF18922', NULL, 'Protein of unknown function (DUF5672)', 165, NULL, 'DUF5672', 260503),
(441410, 'PF11225', NULL, 'Protein of unknown function (DUF3024)', 56, NULL, 'DUF3024', 260504),
(441411, 'PF19269', NULL, 'Anticodon binding domain', 142, NULL, 'Anticodon_2', 260505),
(441412, 'PF09089', NULL, 'Phage short tail fibre protein gp12, middle domain', 81, NULL, 'gp12-short_mid', 260506),
(441413, 'PF15352', NULL, 'Susceptibility to monomelic amyotrophy', 983, NULL, 'K1377', 260507),
(441414, 'PF10123', NULL, 'Mu-like prophage I protein', 326, NULL, 'Mu-like_Pro', 260508),
(441415, 'PF10686', NULL, 'YspA, cpYpsA-related SLOG family', 67, NULL, 'YAcAr', 260509),
(441416, 'PF14805', NULL, 'Tetrahydrodipicolinate N-succinyltransferase N-terminal', 67, NULL, 'THDPS_N_2', 260510),
(441417, 'PF19010', NULL, 'Family of unknown function (DUF5739)', 114, NULL, 'DUF5739', 260511),
(441418, 'PF00892', NULL, 'EamA-like transporter family', 137, NULL, 'EamA', 260512),
(441419, 'PF12257', NULL, 'Vacuolar membrane-associated protein Iml1', 286, NULL, 'IML1', 260513),
(441420, 'PF12617', NULL, 'Iron-Sulfur binding protein C terminal', 187, NULL, 'LdpA_C', 260514),
(441421, 'PF02812', NULL, 'Glu/Leu/Phe/Val dehydrogenase, dimerisation domain', 130, NULL, 'ELFV_dehydrog_N', 260515),
(441422, 'PF13875', NULL, 'Domain of unknown function (DUF4202)', 184, NULL, 'DUF4202', 260516),
(441423, 'PF15846', NULL, 'Domain of unknown function (DUF4720)', 96, NULL, 'DUF4720', 260517),
(441424, 'PF18390', NULL, 'Glycogen debranching enzyme C-terminal domain', 85, NULL, 'GlgX_C', 260518),
(441425, 'PF08899', NULL, 'Domain of unknown function (DUF1844)', 76, NULL, 'DUF1844', 260519),
(441426, 'PF02335', NULL, 'Cytochrome c552', 439, NULL, 'Cytochrom_C552', 260520),
(441427, 'PF15160', NULL, 'Spermatogenesis-associated serine-rich protein 1', 238, NULL, 'SASRP1', 260521),
(441428, 'PF05591', NULL, 'Type VI secretion system, VipA, VC_A0107 or Hcp2', 155, NULL, 'T6SS_VipA', 260522),
(441429, 'PF06407', NULL, 'Borna disease virus P40 protein', 349, NULL, 'BDV_P40', 260523),
(441430, 'PF12128', NULL, 'Protein of unknown function (DUF3584)', 1191, NULL, 'DUF3584', 260524),
(441431, 'PF12826', NULL, 'Helix-hairpin-helix motif', 64, NULL, 'HHH_2', 260525),
(441432, 'PF20414', NULL, 'Family of unknown function (DUF6698)', 206, NULL, 'DUF6698', 260526),
(441433, 'PF03018', NULL, 'Dirigent-like protein', 149, NULL, 'Dirigent', 260527),
(441434, 'PF19388', NULL, 'Family of unknown function (DUF5963)', 83, NULL, 'DUF5963', 260528);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(441435, 'PF05411', NULL, 'Equine arteritis virus putative proteinase', 128, NULL, 'Peptidase_C32', 260529),
(441436, 'PF00034', NULL, 'Cytochrome c', 92, NULL, 'Cytochrom_C', 260530),
(441437, 'PF03308', NULL, 'Methylmalonyl Co-A mutase-associated GTPase MeaB', 267, NULL, 'MeaB', 260531),
(441438, 'PF02774', NULL, 'Semialdehyde dehydrogenase, dimerisation domain', 184, NULL, 'Semialdhyde_dhC', 260532),
(441439, 'PF00873', NULL, 'AcrB/AcrD/AcrF family', 1021, NULL, 'ACR_tran', 260533),
(441440, 'PF06728', NULL, 'GPI transamidase subunit PIG-U', 381, NULL, 'PIG-U', 260534),
(441441, 'PF12883', NULL, 'Protein of unknown function (DUF3828)', 122, NULL, 'DUF3828', 260535),
(441442, 'PF16375', NULL, 'Domain of unknown function', 84, NULL, 'DUF4986', 260536),
(441443, 'PF03144', NULL, 'Elongation factor Tu domain 2', 74, NULL, 'GTP_EFTU_D2', 260537),
(441444, 'PF05365', NULL, 'Ubiquinol-cytochrome C reductase, UQCRX/QCR9 like', 53, NULL, 'UCR_UQCRX_QCR9', 260538),
(441445, 'PF06518', NULL, 'Protein of unknown function (DUF1104)', 92, NULL, 'DUF1104', 260539),
(441446, 'PF04306', NULL, 'Protein of unknown function (DUF456)', 139, NULL, 'DUF456', 260540),
(441447, 'PF07477', NULL, 'Glycosyl hydrolase family 67 C-terminus', 223, NULL, 'Glyco_hydro_67C', 260541),
(441448, 'PF11739', NULL, 'Dicarboxylate transport', 207, NULL, 'DctA-YdbH', 260542),
(441449, 'PF13189', NULL, 'Cytidylate kinase-like family', 178, NULL, 'Cytidylate_kin2', 260543),
(441450, 'PF04400', NULL, '(Na+)-NQR maturation NqrM', 43, NULL, 'NqrM', 260544),
(441451, 'PF15781', NULL, 'ParE-like toxin of type II bacterial toxin-antitoxin system', 87, NULL, 'ParE-like_toxin', 260545),
(441452, 'PF16202', NULL, 'N-terminal region of Bloom syndrome protein', 370, NULL, 'BLM_N', 260546),
(441453, 'PF07773', NULL, 'Tectonic domain DUF1619', 317, NULL, 'TCTN_DUF1619', 260547),
(441454, 'PF17510', NULL, 'Gene product 44', 107, NULL, 'GP44', 260548),
(441455, 'PF09008', NULL, 'Head binding', 113, NULL, 'Head_binding', 260549),
(441456, 'PF16234', NULL, 'Domain of unknown function (DUF4892)', 183, NULL, 'DUF4892', 260550),
(441457, 'PF01302', NULL, 'CAP-Gly domain', 66, NULL, 'CAP_GLY', 260551),
(441458, 'PF12520', NULL, 'Protein of unknown function (DUF3723)', 508, NULL, 'DUF3723', 260552),
(441459, 'PF09465', NULL, 'Lamin-B receptor of TUDOR domain', 55, NULL, 'LBR_tudor', 260553),
(441460, 'PF13056', NULL, 'Protein of unknown function (DUF3918)', 43, NULL, 'DUF3918', 260554),
(441461, 'PF03962', NULL, 'Mnd1 HTH domain', 60, NULL, 'Mnd1', 260555),
(441462, 'PF03692', NULL, 'Putative zinc- or iron-chelating domain', 85, NULL, 'CxxCxxCC', 260556),
(441463, 'PF03947', NULL, 'Ribosomal Proteins L2, C-terminal domain', 126, NULL, 'Ribosomal_L2_C', 260557),
(441464, 'PF13507', NULL, 'CobB/CobQ-like glutamine amidotransferase domain', 260, NULL, 'GATase_5', 260558),
(441465, 'PF19583', NULL, 'ODP family beta lactamase', 193, NULL, 'ODP', 260559),
(441466, 'PF09111', NULL, 'SLIDE', 116, NULL, 'SLIDE', 260560),
(441467, 'PF14570', NULL, 'RING/Ubox like zinc-binding domain', 48, NULL, 'zf-RING_4', 260561),
(441468, 'PF16608', NULL, 'TNRC6-PABC binding domain', 289, NULL, 'TNRC6-PABC_bdg', 260562),
(441469, 'PF15966', NULL, 'F-box', 116, NULL, 'F-box_4', 260563),
(441470, 'PF09293', NULL, 'T4 RNase H, C terminal', 124, NULL, 'RNaseH_C', 260564),
(441471, 'PF11841', NULL, 'ELMO, armadillo-like helical domain', 154, NULL, 'ELMO_ARM', 260565),
(441472, 'PF13933', NULL, 'Putative peptidase family', 245, NULL, 'HRXXH', 260566),
(441473, 'PF13398', NULL, 'Peptidase M50B-like', 200, NULL, 'Peptidase_M50B', 260567),
(441474, 'PF19119', NULL, 'Family of unknown function (DUF5803)', 196, NULL, 'DUF5803', 260568),
(441475, 'PF19969', NULL, 'vWA-MoxR associated protein middle region (VMAP-M) 8', 97, NULL, 'VMAP-M8', 260569),
(441476, 'PF05234', NULL, 'UAF complex subunit Rrn10', 120, NULL, 'UAF_Rrn10', 260570),
(441477, 'PF03520', NULL, 'KCNQ voltage-gated potassium channel', 189, NULL, 'KCNQ_channel', 260571),
(441478, 'PF16058', NULL, 'Mucin-like', 94, NULL, 'Mucin-like', 260572);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(441479, 'PF11248', NULL, 'Protein of unknown function (DUF3046)', 62, NULL, 'DUF3046', 260573),
(441480, 'PF12182', NULL, 'Bacterial lipoprotein', 93, NULL, 'DUF3642', 260574),
(441481, 'PF03912', NULL, 'Psb28 protein', 106, NULL, 'Psb28', 260575),
(441482, 'PF15195', NULL, 'TMEM210 family', 114, NULL, 'TMEM210', 260576),
(441483, 'PF12721', NULL, 'RIP homotypic interaction motif', 22, NULL, 'RHIM', 260577),
(441484, 'PF19128', NULL, 'Family of unknown function (DUF5811)', 103, NULL, 'DUF5811', 260578),
(441485, 'PF20351', NULL, 'Family of unknown function (DUF6646)', 158, NULL, 'DUF6646', 260579),
(441486, 'PF18320', NULL, 'Csc2 Crispr', 298, NULL, 'Csc2', 260580),
(441487, 'PF10784', NULL, 'Plasmid stability protein', 72, NULL, 'Plasmid_stab_B', 260581),
(441488, 'PF17193', NULL, 'MukF C-terminal domain', 158, NULL, 'MukF_C', 260582),
(441489, 'PF00330', NULL, 'Aconitase family (aconitate hydratase)', 461, NULL, 'Aconitase', 260583),
(441490, 'PF20593', NULL, 'Family of unknown function (DUF6793)', 107, NULL, 'DUF6793', 260584),
(441491, 'PF16286', NULL, 'Domain of unknown function (DUF4932)', 329, NULL, 'DUF4932', 260585),
(441492, 'PF01274', NULL, 'Malate synthase', 526, NULL, 'Malate_synthase', 260586),
(441493, 'PF19941', NULL, 'Family of unknown function (DUF6403)', 77, NULL, 'DUF6403', 260587),
(441494, 'PF01816', NULL, 'Leucine rich repeat variant', 26, NULL, 'LRV', 260588),
(441495, 'PF16127', NULL, 'Domain of unknown function (DUF4839)', 123, NULL, 'DUF4839', 260589),
(441496, 'PF03552', NULL, 'Cellulose synthase', 722, NULL, 'Cellulose_synt', 260590),
(441497, 'PF18287', NULL, 'Integron Cassette Protein Hfx_Cass5', 77, NULL, 'Hfx_Cass5', 260591),
(441498, 'PF10211', NULL, 'Axonemal dynein light chain', 187, NULL, 'Ax_dynein_light', 260592),
(441499, 'PF20464', NULL, 'MmeI, N-terminal domain', 187, NULL, 'MmeI_N', 260593),
(441500, 'PF00079', NULL, 'Serpin (serine protease inhibitor)', 370, NULL, 'Serpin', 260594),
(441501, 'PF18498', NULL, 'Domain of unknown function (DUF5618)', 121, NULL, 'DUF5618', 260595),
(441502, 'PF15176', NULL, 'Leucine-rich repeat family 19 TM domain', 115, NULL, 'LRR19-TM', 260596),
(441503, 'PF03480', NULL, 'Bacterial extracellular solute-binding protein, family 7', 286, NULL, 'DctP', 260597),
(441504, 'PF03248', NULL, 'Rer1 family', 171, NULL, 'Rer1', 260598),
(441505, 'PF10233', NULL, 'Uncharacterized conserved protein CG6151-P', 113, NULL, 'Cg6151-P', 260599),
(441506, 'PF10676', NULL, 'Spore germination protein gerPA/gerPF', 72, NULL, 'gerPA', 260600),
(441507, 'PF17107', NULL, 'N-terminal domain on NACHT_NTPase and P-loop NTPases', 122, NULL, 'SesA', 260601),
(441508, 'PF11166', NULL, 'Protein of unknown function (DUF2951)', 98, NULL, 'DUF2951', 260602),
(441509, 'PF17645', NULL, 'Arylmalonate decarboxylase', 217, NULL, 'Amdase', 260603),
(441510, 'PF10685', NULL, 'Stress-induced bacterial acidophilic repeat motif', 22, NULL, 'KGG', 260604),
(441511, 'PF04815', NULL, 'Sec23/Sec24 helical domain', 102, NULL, 'Sec23_helical', 260605),
(441512, 'PF02132', NULL, 'RecR protein', 40, NULL, 'RecR', 260606),
(441513, 'PF18787', NULL, 'CRM1 / Exportin repeat 3', 51, NULL, 'CRM1_repeat_3', 260607),
(441514, 'PF06983', NULL, '3-demethylubiquinone-9 3-methyltransferase', 116, NULL, '3-dmu-9_3-mt', 260608),
(441515, 'PF02724', NULL, 'CDC45-like protein', 641, NULL, 'CDC45', 260609),
(441516, 'PF00580', NULL, 'UvrD/REP helicase N-terminal domain', 315, NULL, 'UvrD-helicase', 260610),
(441517, 'PF01810', NULL, 'LysE type translocator', 193, NULL, 'LysE', 260611),
(441518, 'PF10999', NULL, 'Protein of unknown function (DUF2839)', 68, NULL, 'DUF2839', 260612),
(441519, 'PF08150', NULL, 'FerB (NUC096) domain', 76, NULL, 'FerB', 260613),
(441520, 'PF02840', NULL, 'Prp18 domain', 143, NULL, 'Prp18', 260614),
(441521, 'PF16774', NULL, 'Baseplate protein', 166, NULL, 'Baseplate', 260615),
(441522, 'PF01499', NULL, 'Herpesvirus UL25 family', 554, NULL, 'Herpes_UL25', 260616),
(441523, 'PF17646', NULL, 'Closterovirus 1a polyprotein central region', 106, NULL, 'Zemlya', 260617);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(441524, 'PF13337', NULL, 'Lon-like protease BrxL-like, ATPase domain', 313, NULL, 'BrxL_ATPase', 260618),
(441525, 'PF04681', NULL, 'Blastomyces yeast-phase-specific protein', 155, NULL, 'Bys1', 260619),
(441526, 'PF13417', NULL, 'Glutathione S-transferase, N-terminal domain', 75, NULL, 'GST_N_3', 260620),
(441527, 'PF16485', NULL, 'Protealysin propeptide', 43, NULL, 'PLN_propep', 260621),
(441528, 'PF19895', NULL, 'Family of unknown function (DUF6368)', 183, NULL, 'DUF6368', 260622),
(441529, 'PF03685', NULL, 'Uncharacterised protein family (UPF0147)', 81, NULL, 'UPF0147', 260623),
(441530, 'PF07056', NULL, 'Protein of unknown function (DUF1335)', 131, NULL, 'DUF1335', 260624),
(441531, 'PF19956', NULL, 'Effector-associated domain 2', 82, NULL, 'EAD2', 260625),
(441532, 'PF07403', NULL, 'Protein of unknown function (DUF1505)', 114, NULL, 'DUF1505', 260626),
(441533, 'PF13952', NULL, 'Domain of unknown function (DUF4216)', 73, NULL, 'DUF4216', 260627),
(441534, 'PF00359', NULL, 'Phosphoenolpyruvate-dependent sugar phosphotransferase system, EIIA 2', 144, NULL, 'PTS_EIIA_2', 260628),
(441535, 'PF15788', NULL, 'Domain of unknown function (DUF4705)', 52, NULL, 'DUF4705', 260629),
(441536, 'PF16464', NULL, 'Domain of unknown function (DUF5045)', 85, NULL, 'DUF5045', 260630),
(441537, 'PF14091', NULL, 'Domain of unknown function (DUF4269)', 151, NULL, 'DUF4269', 260631),
(441538, 'PF18249', NULL, 'Calcium binding protein SSO6904', 90, NULL, 'Ca_bind_SSO6904', 260632),
(441539, 'PF16969', NULL, 'RNA-binding signal recognition particle 68', 563, NULL, 'SRP68', 260633),
(441540, 'PF00670', NULL, 'S-adenosyl-L-homocysteine hydrolase, NAD binding domain', 162, NULL, 'AdoHcyase_NAD', 260634),
(441541, 'PF05161', NULL, 'MOFRL family', 109, NULL, 'MOFRL', 260635),
(441542, 'PF15419', NULL, 'Leukemia NUP98 fusion partner 1', 161, NULL, 'LNP1', 260636),
(441543, 'PF01104', NULL, 'Bunyavirus non-structural protein NS-s', 91, NULL, 'Bunya_NS-S', 260637),
(441544, 'PF04847', NULL, 'Calcipressin', 186, NULL, 'Calcipressin', 260638),
(441545, 'PF08439', NULL, 'Oligopeptidase F', 70, NULL, 'Peptidase_M3_N', 260639),
(441546, 'PF10683', NULL, 'Hermes transposase DNA-binding domain', 68, NULL, 'DBD_Tnp_Hermes', 260640),
(441547, 'PF06780', NULL, 'Erp protein C-terminus', 140, NULL, 'Erp_C', 260641),
(441548, 'PF19446', NULL, 'Family of unknown function (DUF5984)', 247, NULL, 'DUF5984', 260642),
(441549, 'PF11595', NULL, 'Protein of unknown function (DUF3245)', 149, NULL, 'DUF3245', 260643),
(441550, 'PF16632', NULL, 'C-terminal region of Caskin', 62, NULL, 'Caskin-tail', 260644),
(441551, 'PF01059', NULL, 'NADH-ubiquinone oxidoreductase chain 4, amino terminus', 110, NULL, 'Oxidored_q5_N', 260645),
(441552, 'PF16225', NULL, 'Domain of unknown function (DUF4884)', 49, NULL, 'DUF4884', 260646),
(441553, 'PF10988', NULL, 'Putative auto-transporter adhesin, head GIN domain', 181, NULL, 'DUF2807', 260647),
(441554, 'PF03447', NULL, 'Homoserine dehydrogenase, NAD binding domain', 117, NULL, 'NAD_binding_3', 260648),
(441555, 'PF07613', NULL, 'Protein of unknown function (DUF1576)', 176, NULL, 'DUF1576', 260649),
(441556, 'PF08183', NULL, 'Stage V sporulation protein family', 25, NULL, 'SpoV', 260650),
(441557, 'PF13339', NULL, 'Apoptosis antagonizing transcription factor', 137, NULL, 'AATF-Che1', 260651),
(441558, 'PF13651', NULL, 'Adenine-specific methyltransferase EcoRI', 346, NULL, 'EcoRI_methylase', 260652),
(441559, 'PF14621', NULL, 'RFX5 DNA-binding domain', 219, NULL, 'RFX5_DNA_bdg', 260653),
(441560, 'PF18786', NULL, 'Importin 13 repeat', 44, NULL, 'Importin_rep_2', 260654),
(441561, 'PF08632', NULL, 'Activator of mitotic machinery Cdc14 phosphatase activation C-term', 52, NULL, 'Zds_C', 260655),
(441562, 'PF13896', NULL, 'Glycosyl-transferase for dystroglycan', 332, NULL, 'Glyco_transf_49', 260656),
(441563, 'PF17414', NULL, 'MatP C-terminal ribbon-helix-helix domain', 60, NULL, 'MatP_C', 260657),
(441564, 'PF12279', NULL, 'Protein of unknown function (DUF3619)', 131, NULL, 'DUF3619', 260658),
(441565, 'PF18251', NULL, 'Fungal defensin Copsin', 39, NULL, 'Defensin_5', 260659);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(441566, 'PF15119', NULL, 'Apolipoprotein C4', 94, NULL, 'APOC4', 260660),
(441567, 'PF12079', NULL, 'Protein of unknown function (DUF3558)', 173, NULL, 'DUF3558', 260661),
(441568, 'PF02491', NULL, 'SHS2 domain inserted in FTSA', 79, NULL, 'SHS2_FTSA', 260662),
(441569, 'PF00199', NULL, 'Catalase', 383, NULL, 'Catalase', 260663),
(441570, 'PF08429', NULL, 'PLU-1-like protein', 339, NULL, 'PLU-1', 260664),
(441571, 'PF18834', NULL, 'Large polyvalent protein associated domain 22', 98, NULL, 'LPD22', 260665),
(441572, 'PF10461', NULL, 'Peptidase S68', 34, NULL, 'Peptidase_S68', 260666),
(441573, 'PF10429', NULL, 'Nuclear pore RNA shuttling protein Mtr2', 164, NULL, 'Mtr2', 260667),
(441574, 'PF12134', NULL, 'PRP8 domain IV core', 230, NULL, 'PRP8_domainIV', 260668),
(441575, 'PF10101', NULL, 'Predicted membrane protein (DUF2339)', 667, NULL, 'DUF2339', 260669),
(441576, 'PF08485', NULL, 'Polysaccharide biosynthesis protein C-terminal', 48, NULL, 'Polysacc_syn_2C', 260670),
(441577, 'PF11728', NULL, 'Putative aromatic acid exporter C-terminal domain', 166, NULL, 'ArAE_1_C', 260671),
(441578, 'PF17097', NULL, 'Spindle pole body component', 362, NULL, 'Kre28', 260672),
(441579, 'PF17805', NULL, 'AsnC-like ligand binding domain', 82, NULL, 'AsnC_trans_reg2', 260673),
(441580, 'PF08735', NULL, 'Putative pyruvate format-lyase activating enzyme (DUF1786)', 252, NULL, 'DUF1786', 260674),
(441581, 'PF04506', NULL, 'Rft protein', 514, NULL, 'Rft-1', 260675),
(441582, 'PF04744', NULL, 'Monooxygenase subunit B protein', 381, NULL, 'Monooxygenase_B', 260676),
(441583, 'PF20258', NULL, 'Aminomethyltransferase beta-barrel domain', 77, NULL, 'tRNA_Me_trans_C', 260677),
(441584, 'PF04864', NULL, 'Allinase', 363, NULL, 'Alliinase_C', 260678),
(441585, 'PF20598', NULL, 'Domain of unknown function (DUF6795)', 103, NULL, 'DUF6795', 260679),
(441586, 'PF16739', NULL, 'Caspase recruitment domain', 93, NULL, 'CARD_2', 260680),
(441587, 'PF06546', NULL, 'Vertebrate heat shock transcription factor', 275, NULL, 'Vert_HS_TF', 260681),
(441588, 'PF10439', NULL, 'Bacteriocin class II with double-glycine leader peptide', 62, NULL, 'Bacteriocin_IIc', 260682),
(441589, 'PF04129', NULL, 'Vps52 / Sac2 family', 508, NULL, 'Vps52', 260683),
(441590, 'PF16652', NULL, 'Pleckstrin homology domain', 154, NULL, 'PH_13', 260684),
(441591, 'PF02354', NULL, 'Latrophilin Cytoplasmic C-terminal region', 377, NULL, 'Latrophilin', 260685),
(441592, 'PF10422', NULL, 'Monopolin complex subunit LRS4', 249, NULL, 'LRS4', 260686),
(441593, 'PF12540', NULL, 'Protein of unknown function (DUF3736)', 132, NULL, 'DUF3736', 260687),
(441594, 'PF18429', NULL, 'Domain of unknown function (DUF5609)', 65, NULL, 'DUF5609', 260688),
(441595, 'PF19663', NULL, 'Family of unknown function (DUF6166)', 96, NULL, 'DUF6166', 260689),
(441596, 'PF14402', NULL, '7 transmembrane helices usually fused to an inactive transglutaminase', 248, NULL, '7TM_transglut', 260690),
(441597, 'PF12814', NULL, 'Meiotic cell cortex C-terminal pleckstrin homology', 119, NULL, 'Mcp5_PH', 260691),
(441598, 'PF13020', NULL, 'Protein NO VEIN, C-terminal', 92, NULL, 'NOV_C', 260692),
(441599, 'PF04912', NULL, 'Dynamitin', 397, NULL, 'Dynamitin', 260693),
(441600, 'PF05720', NULL, 'Cell-cell adhesion domain', 82, NULL, 'Dicty_CAD', 260694),
(441601, 'PF15980', NULL, 'Putative Competence protein ComGF', 99, NULL, 'ComGF', 260695),
(441602, 'PF17154', NULL, 'Gammaproteobacterial periplasmic sensor domain', 121, NULL, 'GAPES3', 260696),
(441603, 'PF14280', NULL, 'Domain of unknown function (DUF4365)', 139, NULL, 'DUF4365', 260697),
(441604, 'PF13007', NULL, 'Transposase C of IS166 homeodomain', 69, NULL, 'LZ_Tnp_IS66', 260698),
(441605, 'PF14572', NULL, 'Phosphoribosyl synthetase-associated domain', 184, NULL, 'Pribosyl_synth', 260699),
(441606, 'PF15457', NULL, 'Type III T3SS secreted effector HopW1-1/HopPmaA', 321, NULL, 'HopW1-1', 260700),
(441607, 'PF04325', NULL, 'Protein of unknown function (DUF465)', 47, NULL, 'DUF465', 260701),
(441608, 'PF06486', NULL, 'Protein of unknown function (DUF1093)', 80, NULL, 'DUF1093', 260702);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(441609, 'PF10498', NULL, 'Intra-flagellar transport protein 57', 359, NULL, 'IFT57', 260703),
(441610, 'PF09446', NULL, 'VMA21-like domain', 64, NULL, 'VMA21', 260704),
(441611, 'PF16541', NULL, 'Alternaria alternata allergen 1', 110, NULL, 'AltA1', 260705),
(441612, 'PF01215', NULL, 'Cytochrome c oxidase subunit Vb', 129, NULL, 'COX5B', 260706),
(441613, 'PF06926', NULL, 'Putative replisome organiser protein C-terminus', 95, NULL, 'Rep_Org_C', 260707),
(441614, 'PF08544', NULL, 'GHMP kinases C terminal', 85, NULL, 'GHMP_kinases_C', 260708),
(441615, 'PF19790', NULL, 'Family of unknown function (DUF6274)', 79, NULL, 'DUF6274', 260709),
(441616, 'PF09453', NULL, 'HIRA B motif', 23, NULL, 'HIRA_B', 260710),
(441617, 'PF15043', NULL, 'CB1 cannabinoid receptor-interacting protein 1', 157, NULL, 'CNRIP1', 260711),
(441618, 'PF17599', NULL, 'Family of unknown function (DUF5495)', 87, NULL, 'DUF5495', 260712),
(441619, 'PF11598', NULL, 'Cartilage oligomeric matrix protein', 45, NULL, 'COMP', 260713),
(441620, 'PF18268', NULL, 'Hit1 C-terminal', 82, NULL, 'Hit1_C', 260714),
(441621, 'PF12322', NULL, 'T4 bacteriophage base plate protein', 205, NULL, 'T4_baseplate', 260715),
(441622, 'PF19903', NULL, 'Family of unknown function (DUF6376)', 116, NULL, 'DUF6376', 260716),
(441623, 'PF07624', NULL, 'Protein of unknown function (DUF1585)', 74, NULL, 'PSD2', 260717),
(441624, 'PF12442', NULL, 'Protein of unknown function (DUF3681)', 97, NULL, 'DUF3681', 260718),
(441625, 'PF08711', NULL, 'TFIIS helical bundle-like domain', 53, NULL, 'Med26', 260719),
(441626, 'PF09670', NULL, 'CRISPR-associated protein (Cas_Cas02710)', 380, NULL, 'Cas_Cas02710', 260720),
(441627, 'PF20624', NULL, 'DMRT5, DMB domain', 88, NULL, 'DMRT5_DMB', 260721),
(441628, 'PF14544', NULL, 'Domain of unknown function (DUF4443)', 100, NULL, 'DUF4443', 260722),
(441629, 'PF17575', NULL, 'Family of unknown function (DUF5479)', 101, NULL, 'DUF5479', 260723),
(441630, 'PF00818', NULL, 'Ice nucleation protein repeat', 15, NULL, 'Ice_nucleation', 260724),
(441631, 'PF04707', NULL, 'PRELI-like family', 157, NULL, 'PRELI', 260725),
(441632, 'PF10781', NULL, 'Dextransucrase DSRB', 61, NULL, 'DSRB', 260726),
(441633, 'PF15361', NULL, 'Resistance to inhibitors of cholinesterase homologue 3', 144, NULL, 'RIC3', 260727),
(441634, 'PF16852', NULL, 'Herpes viral adaptor-to-host cellular mRNA binding domain', 42, NULL, 'HHV-1_VABD', 260728),
(441635, 'PF01168', NULL, 'Alanine racemase, N-terminal domain', 219, NULL, 'Ala_racemase_N', 260729),
(441636, 'PF15360', NULL, 'APJ endogenous ligand', 55, NULL, 'Apelin', 260730),
(441637, 'PF16311', NULL, 'Transmembrane protein 100', 133, NULL, 'TMEM100', 260731),
(441638, 'PF15555', NULL, 'Domain of unknown function (DUF4658)', 123, NULL, 'DUF4658', 260732),
(441639, 'PF18167', NULL, 'SMODS-associated NUDIX domain', 199, NULL, 'Sa_NUDIX', 260733),
(441640, 'PF11794', NULL, '4-hydroxyphenylacetate 3-hydroxylase N terminal', 272, NULL, 'HpaB_N', 260734),
(441641, 'PF08690', NULL, 'GET complex subunit GET2', 309, NULL, 'GET2', 260735),
(441642, 'PF04413', NULL, '3-Deoxy-D-manno-octulosonic-acid transferase (kdotransferase)', 178, NULL, 'Glycos_transf_N', 260736),
(441643, 'PF02732', NULL, 'ERCC4 domain', 157, NULL, 'ERCC4', 260737),
(441644, 'PF20122', NULL, 'Family of unknown function (DUF6512)', 181, NULL, 'DUF6512', 260738),
(441645, 'PF08363', NULL, 'Glucan-binding protein C', 300, NULL, 'GbpC', 260739),
(441646, 'PF09549', NULL, 'Bpu10I restriction endonuclease', 220, NULL, 'RE_Bpu10I', 260740),
(441647, 'PF12210', NULL, 'Hepatocyte growth factor-regulated tyrosine kinase substrate', 95, NULL, 'Hrs_helical', 260741),
(441648, 'PF17026', NULL, 'Putative ribonucleoprotein zinc-finger pf C4 type', 108, NULL, 'zf-RRPl_C4', 260742),
(441649, 'PF14119', NULL, 'Domain of unknown function (DUF4288)', 85, NULL, 'DUF4288', 260743),
(441650, 'PF03938', NULL, 'Outer membrane protein (OmpH-like)', 140, NULL, 'OmpH', 260744),
(441651, 'PF19479', NULL, 'Family of unknown function (DUF6015)', 140, NULL, 'DUF6015', 260745);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(441652, 'PF05033', NULL, 'Pre-SET motif', 110, NULL, 'Pre-SET', 260746),
(441653, 'PF13245', NULL, 'AAA domain', 147, NULL, 'AAA_19', 260747),
(441654, 'PF10602', NULL, '26S proteasome subunit RPN7', 174, NULL, 'RPN7', 260748),
(441655, 'PF14021', NULL, 'Tuberculosis necrotizing toxin', 88, NULL, 'TNT', 260749),
(441656, 'PF19574', NULL, 'Outer membrane lipoprotein carrier protein LolA-like', 192, NULL, 'LolA_3', 260750),
(441657, 'PF20220', NULL, 'ABC toxin N-terminal region', 124, NULL, 'ABC_toxin_N', 260751),
(441658, 'PF13079', NULL, 'Protein of unknown function (DUF3916)', 151, NULL, 'DUF3916', 260752),
(441659, 'PF15075', NULL, 'Domain of unknown function (DUF4542)', 134, NULL, 'DUF4542', 260753),
(441660, 'PF19837', NULL, 'Domain of unknown function (DUF6316)', 55, NULL, 'DUF6316', 260754),
(441661, 'PF16506', NULL, 'Putative virion glycoprotein of insect viruses', 233, NULL, 'DiSB-ORF2_chro', 260755),
(441662, 'PF07904', NULL, 'Chromatin modification-related protein EAF7', 104, NULL, 'Eaf7', 260756),
(441663, 'PF12781', NULL, 'ATP-binding dynein motor region', 222, NULL, 'AAA_9', 260757),
(441664, 'PF08311', NULL, 'Mad3/BUB1 homology region 1', 124, NULL, 'Mad3_BUB1_I', 260758),
(441665, 'PF13702', NULL, 'Lysozyme-like', 165, NULL, 'Lysozyme_like', 260759),
(441666, 'PF20033', NULL, 'Domain of unknown function (DUF6438)', 76, NULL, 'DUF6438', 260760),
(441667, 'PF19943', NULL, 'Family of unknown function (DUF6405)', 37, NULL, 'DUF6405', 260761),
(441668, 'PF10154', NULL, 'Uncharacterised conserved protein (DUF2362)', 501, NULL, 'DUF2362', 260762),
(441669, 'PF18710', NULL, 'ComR tetratricopeptide', 222, NULL, 'ComR_TPR', 260763),
(441670, 'PF08444', NULL, 'Aralkyl acyl-CoA:amino acid N-acyltransferase, C-terminal region', 89, NULL, 'Gly_acyl_tr_C', 260764),
(441671, 'PF18872', NULL, 'Daz repeat', 21, NULL, 'Daz', 260765),
(441672, 'PF15004', NULL, 'Myeloma-overexpressed-like', 57, NULL, 'MYEOV2', 260766),
(441673, 'PF01719', NULL, 'Plasmid replication protein', 188, NULL, 'Rep_2', 260767),
(441674, 'PF00849', NULL, 'RNA pseudouridylate synthase', 160, NULL, 'PseudoU_synth_2', 260768),
(441675, 'PF17763', NULL, 'Glutaminase/Asparaginase C-terminal domain', 114, NULL, 'Asparaginase_C', 260769),
(441676, 'PF13443', NULL, 'Cro/C1-type HTH DNA-binding domain', 63, NULL, 'HTH_26', 260770),
(441677, 'PF00925', NULL, 'GTP cyclohydrolase II', 164, NULL, 'GTP_cyclohydro2', 260771),
(441678, 'PF11582', NULL, 'Protein of unknown function (DUF3240)', 102, NULL, 'DUF3240', 260772),
(441679, 'PF05031', NULL, 'Iron Transport-associated domain', 119, NULL, 'NEAT', 260773),
(441680, 'PF10444', NULL, 'Nbl1 / Borealin N terminal', 57, NULL, 'Nbl1_Borealin_N', 260774),
(441681, 'PF16776', NULL, 'Type II inositol 1,4,5-trisphosphate 5-phosphatase PH domain', 145, NULL, 'INPP5B_PH', 260775),
(441682, 'PF07701', NULL, 'Heme NO binding associated', 222, NULL, 'HNOBA', 260776),
(441683, 'PF15068', NULL, 'FAM101 family', 208, NULL, 'FAM101', 260777),
(441684, 'PF01858', NULL, 'Retinoblastoma-associated protein A domain', 197, NULL, 'RB_A', 260778),
(441685, 'PF13513', NULL, 'HEAT-like repeat', 55, NULL, 'HEAT_EZ', 260779),
(441686, 'PF12139', NULL, 'Adenosine-5''-phosphosulfate reductase beta subunit', 82, NULL, 'APS-reductase_C', 260780),
(441687, 'PF12984', NULL, 'Domain of unknown function, B. Theta Gene description (DUF3868)', 109, NULL, 'DUF3868', 260781),
(441688, 'PF12670', NULL, 'Protein of unknown function (DUF3792)', 115, NULL, 'DUF3792', 260782),
(441689, 'PF05645', NULL, 'RNA polymerase III subunit RPC82', 258, NULL, 'RNA_pol_Rpc82', 260783),
(441690, 'PF12280', NULL, 'Brain specific membrane anchored protein', 197, NULL, 'BSMAP', 260784),
(441691, 'PF01504', NULL, 'Phosphatidylinositol-4-phosphate 5-Kinase', 278, NULL, 'PIP5K', 260785),
(441692, 'PF03718', NULL, 'Glycosyl hydrolase family 49', 118, NULL, 'Glyco_hydro_49', 260786),
(441693, 'PF03617', NULL, 'IBV 3A protein', 57, NULL, 'IBV_3A', 260787),
(441694, 'PF05515', NULL, 'Viral nucleic acid binding', 222, NULL, 'Viral_NABP', 260788),
(441695, 'PF00504', NULL, 'Chlorophyll A-B binding protein', 161, NULL, 'Chloroa_b-bind', 260789);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(441696, 'PF01202', NULL, 'Shikimate kinase', 158, NULL, 'SKI', 260790),
(441697, 'PF06297', NULL, 'PET Domain', 85, NULL, 'PET', 260791),
(441698, 'PF08203', NULL, 'Yeast RNA polymerase I subunit RPA14', 117, NULL, 'RNA_polI_A14', 260792),
(441699, 'PF08440', NULL, 'Potyviridae polyprotein', 277, NULL, 'Poty_PP', 260793),
(441700, 'PF07110', NULL, 'EthD domain', 97, NULL, 'EthD', 260794),
(441701, 'PF11250', NULL, 'Fantastic Four meristem regulator', 54, NULL, 'FAF', 260795),
(441702, 'PF19189', NULL, 'Mtf2 family', 197, NULL, 'Mtf2', 260796),
(441703, 'PF09027', NULL, 'GTPase binding', 66, NULL, 'GTPase_binding', 260797),
(441704, 'PF02199', NULL, 'Saposin A-type domain', 33, NULL, 'SapA', 260798),
(441705, 'PF17174', NULL, 'Domain of unknown function (DUF5130)', 136, NULL, 'DUF5130', 260799),
(441706, 'PF15306', NULL, 'LIN37', 155, NULL, 'LIN37', 260800),
(441707, 'PF19551', NULL, 'Family of unknown function (DUF6074)', 83, NULL, 'DUF6074', 260801),
(441708, 'PF12961', NULL, 'Domain of unknown function (DUF3850)', 77, NULL, 'DUF3850', 260802),
(441709, 'PF17569', NULL, 'Family of unknown function (DUF5475)', 81, NULL, 'DUF5475', 260803),
(441710, 'PF09804', NULL, 'DENN domain-containing protein 11', 282, NULL, 'DENND11', 260804),
(441711, 'PF13815', NULL, 'Iguana/Dzip1-like DAZ-interacting protein N-terminal', 118, NULL, 'Dzip-like_N', 260805),
(441712, 'PF18034', NULL, 'Bacterial Glycosyl hydrolase family 3 C-terminal domain', 137, NULL, 'Bac_GH3_C', 260806),
(441713, 'PF00684', NULL, 'DnaJ central domain', 66, NULL, 'DnaJ_CXXCXGXG', 260807),
(441714, 'PF07407', NULL, 'Seadornavirus VP6 protein', 420, NULL, 'Seadorna_VP6', 260808),
(441715, 'PF20140', NULL, 'Family of unknown function (DUF6530)', 159, NULL, 'DUF6530', 260809),
(441716, 'PF09945', NULL, 'Predicted membrane protein (DUF2177)', 124, NULL, 'DUF2177', 260810),
(441717, 'PF10881', NULL, 'Protein of unknown function (DUF2726)', 126, NULL, 'DUF2726', 260811),
(441718, 'PF05629', NULL, 'Nanovirus component 8 (C8) protein', 153, NULL, 'Nanovirus_C8', 260812),
(441719, 'PF12023', NULL, 'Domain of unknown function (DUF3511)', 45, NULL, 'DUF3511', 260813),
(441720, 'PF19242', NULL, 'Putative zinc finger protein', 268, NULL, 'Zn_finger_prot', 260814),
(441721, 'PF00675', NULL, 'Insulinase (Peptidase family M16)', 149, NULL, 'Peptidase_M16', 260815),
(441722, 'PF04738', NULL, 'Lantibiotic dehydratase, N terminus', 650, NULL, 'Lant_dehydr_N', 260816),
(441723, 'PF10815', NULL, 'ComZ', 55, NULL, 'ComZ', 260817),
(441724, 'PF17109', NULL, 'fungal STAND N-terminal Goodbye domain', 121, NULL, 'Goodbye', 260818),
(441725, 'PF18687', NULL, 'Family of unknown function (DUF5637)', 33, NULL, 'DUF5637', 260819),
(441726, 'PF04130', NULL, 'Gamma tubulin complex component C-terminal', 309, NULL, 'GCP_C_terminal', 260820),
(441727, 'PF08530', NULL, 'X-Pro dipeptidyl-peptidase C-terminal non-catalytic domain', 217, NULL, 'PepX_C', 260821),
(441728, 'PF08265', NULL, 'YL1 nuclear protein C-terminal domain', 29, NULL, 'YL1_C', 260822),
(441729, 'PF03325', NULL, 'Herpesvirus polymerase accessory protein', 166, NULL, 'Herpes_PAP', 260823),
(441730, 'PF03849', NULL, 'Transcription factor Tfb2', 356, NULL, 'Tfb2', 260824),
(441731, 'PF04660', NULL, 'Nanovirus coat protein', 170, NULL, 'Nanovirus_coat', 260825),
(441732, 'PF06385', NULL, 'Baculovirus LEF-11 protein', 93, NULL, 'Baculo_LEF-11', 260826),
(441733, 'PF12040', NULL, 'Domain of unknown function (DUF3526)', 155, NULL, 'DUF3526', 260827),
(441734, 'PF12913', NULL, 'SH3 domain (SH3b1 type)', 53, NULL, 'SH3_6', 260828),
(441735, 'PF05769', NULL, 'SIKE family', 180, NULL, 'SIKE', 260829),
(441736, 'PF19048', NULL, 'SidE mono-ADP-ribosyltransferase domain', 337, NULL, 'SidE_mART', 260830),
(441737, 'PF05831', NULL, 'GAGE protein', 107, NULL, 'GAGE', 260831),
(441738, 'PF00421', NULL, 'Photosystem II protein', 511, NULL, 'PSII', 260832),
(441739, 'PF19095', NULL, 'Family of unknown function (DUF5783)', 105, NULL, 'DUF5783', 260833),
(441740, 'PF13974', NULL, 'YebO-like protein', 78, NULL, 'YebO', 260834);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(441741, 'PF15546', NULL, 'Domain of unknown function (DUF4653)', 257, NULL, 'DUF4653', 260835),
(441742, 'PF17415', NULL, 'NigD-like C-terminal beta sandwich domain', 120, NULL, 'NigD_C', 260836),
(441743, 'PF12046', NULL, 'Cofactor assembly of complex C subunit B', 168, NULL, 'CCB1', 260837),
(441744, 'PF18327', NULL, 'Proline utilization A proline dehydrogenase N-terminal domain', 48, NULL, 'PRODH', 260838),
(441745, 'PF08518', NULL, 'Spa2 homology domain (SHD) of GIT', 29, NULL, 'GIT_SHD', 260839),
(441746, 'PF11554', NULL, 'Protein of unknown function (DUF3232)', 152, NULL, 'DUF3232', 260840),
(441747, 'PF06453', NULL, 'Type II heat-labile enterotoxin , B subunit (LT-IIB)', 122, NULL, 'LT-IIB', 260841),
(441748, 'PF14608', NULL, 'RNA-binding, Nab2-type zinc finger', 19, NULL, 'zf-CCCH_2', 260842),
(441749, 'PF02991', NULL, 'Autophagy protein Atg8 ubiquitin like', 104, NULL, 'ATG8', 260843),
(441750, 'PF07384', NULL, 'Protein of unknown function (DUF1497)', 59, NULL, 'DUF1497', 260844),
(441751, 'PF01456', NULL, 'Mucin-like glycoprotein', 143, NULL, 'Mucin', 260845),
(441752, 'PF03166', NULL, 'MH2 domain', 174, NULL, 'MH2', 260846),
(441753, 'PF02505', NULL, 'Methyl-coenzyme M reductase operon protein D', 142, NULL, 'MCR_D', 260847),
(441754, 'PF10187', NULL, 'FAM192A/Fyv6, N-terminal domain', 105, NULL, 'FAM192A_Fyv6_N', 260848),
(441755, 'PF17379', NULL, 'Family of unknown function (DUF5400)', 100, NULL, 'DUF5400', 260849),
(441756, 'PF16392', NULL, 'Ig-like domain', 86, NULL, 'DUF5001', 260850),
(441757, 'PF19380', NULL, 'Family of unknown function (DUF5955)', 88, NULL, 'DUF5955', 260851),
(441758, 'PF11963', NULL, 'Betacoronavirus, lineage A, NSP1', 355, NULL, 'B-CoV_A_NSP1', 260852),
(441759, 'PF07763', NULL, 'FEZ-like protein', 240, NULL, 'FEZ', 260853),
(441760, 'PF16172', NULL, 'DOCK N-terminus', 385, NULL, 'DOCK_N', 260854),
(441761, 'PF18734', NULL, 'AbiU2', 197, NULL, 'HEPN_AbiU2', 260855),
(441762, 'PF10782', NULL, 'Zinc-finger', 58, NULL, 'zf-C2HCIx2C', 260856),
(441763, 'PF18533', NULL, 'Domain of unknown function (DUF5622)', 66, NULL, 'DUF5622', 260857),
(441764, 'PF02462', NULL, 'Opacity family porin protein', 132, NULL, 'Opacity', 260858),
(441765, 'PF06933', NULL, 'Special lobe-specific silk protein SSP160', 756, NULL, 'SSP160', 260859),
(441766, 'PF00240', NULL, 'Ubiquitin family', 72, NULL, 'ubiquitin', 260860),
(441767, 'PF12666', NULL, 'PrgI family protein', 91, NULL, 'PrgI', 260861),
(441768, 'PF13811', NULL, 'Domain of unknown function (DUF4186)', 109, NULL, 'DUF4186', 260862),
(441769, 'PF00855', NULL, 'PWWP domain', 93, NULL, 'PWWP', 260863),
(441770, 'PF11744', NULL, 'Aluminium activated malate transporter', 408, NULL, 'ALMT', 260864),
(441771, 'PF12538', NULL, 'DNA transporter', 117, NULL, 'FtsK_SpoIIIE_N', 260865),
(441772, 'PF09083', NULL, 'Domain of unknown function (DUF1923)', 64, NULL, 'DUF1923', 260866),
(441773, 'PF08414', NULL, 'Respiratory burst NADPH oxidase', 101, NULL, 'NADPH_Ox', 260867),
(441774, 'PF09124', NULL, 'T4 recombination endonuclease VII, dimerisation', 54, NULL, 'Endonuc-dimeris', 260868),
(441775, 'PF18659', NULL, 'Cell-traversal protein for ookinetes and sporozoites', 122, NULL, 'CelTOS', 260869),
(441776, 'PF00061', NULL, 'Lipocalin / cytosolic fatty-acid binding protein family', 144, NULL, 'Lipocalin', 260870),
(441777, 'PF18629', NULL, 'Family of unknown function (DUF5629)', 98, NULL, 'DUF5629', 260871),
(441778, 'PF10869', NULL, 'Protein of unknown function (DUF2666)', 135, NULL, 'DUF2666', 260872),
(441779, 'PF14644', NULL, 'Domain of unknown function (DUF4456)', 209, NULL, 'DUF4456', 260873),
(441780, 'PF13416', NULL, 'Bacterial extracellular solute-binding protein', 284, NULL, 'SBP_bac_8', 260874),
(441781, 'PF18235', NULL, 'Oligosaccharyltransferase Peripheral 2 domain', 133, NULL, 'OST_P2', 260875),
(441782, 'PF11404', NULL, 'Potassium voltage-gated channel', 29, NULL, 'Potassium_chann', 260876),
(441783, 'PF03643', NULL, 'Vacuolar protein sorting-associated protein 26', 275, NULL, 'Vps26', 260877),
(441784, 'PF06079', NULL, 'Apyrase', 293, NULL, 'Apyrase', 260878);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(441785, 'PF15976', NULL, 'CS1-pili formation C-terminal', 93, NULL, 'CooC_C', 260879),
(441786, 'PF11414', NULL, 'Adenomatous polyposis coli tumour suppressor protein', 82, NULL, 'Suppressor_APC', 260880),
(441787, 'PF14052', NULL, 'Capsule assembly protein Wzi', 394, NULL, 'Caps_assemb_Wzi', 260881),
(441788, 'PF05287', NULL, 'PMG protein', 180, NULL, 'PMG', 260882),
(441789, 'PF10400', NULL, 'Virulence activator alpha C-term', 77, NULL, 'Vir_act_alpha_C', 260883),
(441790, 'PF04397', NULL, 'LytTr DNA-binding domain', 98, NULL, 'LytTR', 260884),
(441791, 'PF01204', NULL, 'Trehalase', 512, NULL, 'Trehalase', 260885),
(441792, 'PF15837', NULL, 'Domain of unknown function (DUF4716)', 60, NULL, 'DUF4716', 260886),
(441793, 'PF11886', NULL, 'Translocase of chloroplast 159/132, membrane anchor domain', 267, NULL, 'TOC159_MAD', 260887),
(441794, 'PF01314', NULL, 'Aldehyde ferredoxin oxidoreductase, domains 2 & 3', 382, NULL, 'AFOR_C', 260888),
(441795, 'PF10925', NULL, 'Protein of unknown function (DUF2680)', 57, NULL, 'DUF2680', 260889),
(441796, 'PF04024', NULL, 'PspC domain', 53, NULL, 'PspC', 260890),
(441797, 'PF06462', NULL, 'Propeller', 30, NULL, 'Hyd_WA', 260891),
(441798, 'PF20027', NULL, 'Family of unknown function (DUF6435)', 53, NULL, 'DUF6435', 260892),
(441799, 'PF05860', NULL, 'TPS secretion domain', 255, NULL, 'TPS', 260893),
(441800, 'PF06232', NULL, 'Embryo-specific protein 3, (ATS3)', 125, NULL, 'ATS3', 260894),
(441801, 'PF15024', NULL, 'Glycosyltransferase family 18', 557, NULL, 'Glyco_transf_18', 260895),
(441802, 'PF06552', NULL, 'Plant specific mitochondrial import receptor subunit TOM20', 187, NULL, 'TOM20_plant', 260896),
(441803, 'PF01663', NULL, 'Type I phosphodiesterase / nucleotide pyrophosphatase', 357, NULL, 'Phosphodiest', 260897),
(441804, 'PF09731', NULL, 'Mitochondrial inner membrane protein', 622, NULL, 'Mitofilin', 260898),
(441805, 'PF15291', NULL, 'Dermcidin, antibiotic peptide', 99, NULL, 'Dermcidin', 260899),
(441806, 'PF11788', NULL, '39S mitochondrial ribosomal protein L46', 119, NULL, 'MRP-L46', 260900),
(441807, 'PF16818', NULL, 'Protein SLM4', 161, NULL, 'SLM4', 260901),
(441808, 'PF06888', NULL, 'Putative Phosphatase', 234, NULL, 'Put_Phosphatase', 260902),
(441809, 'PF19950', NULL, 'Family of unknown function (DUF6412)', 30, NULL, 'DUF6412', 260903),
(441810, 'PF08800', NULL, 'VirE N-terminal domain', 134, NULL, 'VirE_N', 260904),
(441811, 'PF12885', NULL, 'Transducer of regulated CREB activity middle domain', 158, NULL, 'TORC_M', 260905),
(441812, 'PF16129', NULL, 'Domain of unknown function (DUF4841)', 69, NULL, 'DUF4841', 260906),
(441813, 'PF19361', NULL, 'Family of unknown function (DUF5937)', 268, NULL, 'DUF5937', 260907),
(441814, 'PF14279', NULL, 'HNH endonuclease', 56, NULL, 'HNH_5', 260908),
(441815, 'PF17400', NULL, 'Family of unknown function (DUF5406)', 107, NULL, 'DUF5406', 260909),
(441816, 'PF04691', NULL, 'Apolipoprotein C-I (ApoC-1)', 61, NULL, 'ApoC-I', 260910),
(441817, 'PF09152', NULL, 'Domain of unknown function (DUF1937)', 116, NULL, 'DUF1937', 260911),
(441818, 'PF01335', NULL, 'Death effector domain', 82, NULL, 'DED', 260912),
(441819, 'PF09646', NULL, 'Gp37 protein', 143, NULL, 'Gp37', 260913),
(441820, 'PF11543', NULL, 'Nuclear pore localisation protein NPL4', 80, NULL, 'UN_NPL4', 260914),
(441821, 'PF11548', NULL, 'Protein-tyrosine phosphatase receptor IA-2', 89, NULL, 'Receptor_IA-2', 260915),
(441822, 'PF17463', NULL, 'Gene product 79', 51, NULL, 'GP79', 260916),
(441823, 'PF04666', NULL, 'N-Acetylglucosaminyltransferase-IV (GnT-IV) conserved region', 278, NULL, 'Glyco_transf_54', 260917),
(441824, 'PF16759', NULL, 'DNA ligase 3 BRCT domain', 78, NULL, 'LIG3_BRCT', 260918),
(441825, 'PF09405', NULL, 'CASC3/Barentsz eIF4AIII binding', 131, NULL, 'Btz', 260919),
(441826, 'PF20232', NULL, 'C-terminal domain of Type VI secretion system FHA protein', 180, NULL, 'T6SS_FHA_C', 260920),
(441827, 'PF11031', NULL, 'Bacteriophage T holin', 216, NULL, 'Phage_holin_T', 260921),
(441828, 'PF04757', NULL, 'Pex2 / Pex12 amino terminal region', 225, NULL, 'Pex2_Pex12', 260922);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(441829, 'PF10155', NULL, 'CCR4-NOT transcription complex subunit 11', 125, NULL, 'CNOT11', 260923),
(441830, 'PF05370', NULL, 'Domain of unknown function (DUF749)', 87, NULL, 'DUF749', 260924),
(441831, 'PF14343', NULL, 'PrcB C-terminal', 58, NULL, 'PrcB_C', 260925),
(441832, 'PF14705', NULL, 'Costars', 76, NULL, 'Costars', 260926),
(441833, 'PF07395', NULL, 'Mig-14', 264, NULL, 'Mig-14', 260927),
(441834, 'PF15029', NULL, 'Transmembrane protein 174', 235, NULL, 'TMEM174', 260928),
(441835, 'PF06363', NULL, 'Picornaviridae P3A protein', 97, NULL, 'Picorna_P3A', 260929),
(441836, 'PF15593', NULL, 'Immunity protein 42', 162, NULL, 'Imm42', 260930),
(441837, 'PF19377', NULL, 'Family of unknown function (DUF5952)', 93, NULL, 'DUF5952', 260931),
(441838, 'PF01239', NULL, 'Protein prenyltransferase alpha subunit repeat', 32, NULL, 'PPTA', 260932),
(441839, 'PF00220', NULL, 'Neurohypophysial hormones, N-terminal Domain', 9, NULL, 'Hormone_4', 260933),
(441840, 'PF00637', NULL, 'Region in Clathrin and VPS', 143, NULL, 'Clathrin', 260934),
(441841, 'PF08278', NULL, 'DNA primase DnaG DnaB-binding', 124, NULL, 'DnaG_DnaB_bind', 260935),
(441842, 'PF10833', NULL, 'Protein of unknown function (DUF2572)', 219, NULL, 'DUF2572', 260936),
(441843, 'PF14927', NULL, 'Neurensin', 133, NULL, 'Neurensin', 260937),
(441844, 'PF17655', NULL, 'Inward rectifier potassium channel C-terminal domain', 174, NULL, 'IRK_C', 260938),
(441845, 'PF03461', NULL, 'TRCF domain', 95, NULL, 'TRCF', 260939),
(441846, 'PF03065', NULL, 'Glycosyl hydrolase family 57', 325, NULL, 'Glyco_hydro_57', 260940),
(441847, 'PF12595', NULL, 'Rhomboid serine protease', 189, NULL, 'Rhomboid_SP', 260941),
(441848, 'PF18303', NULL, 'SAVED-fused 2TM effector domain', 152, NULL, 'Saf_2TM', 260942),
(441849, 'PF01473', NULL, 'Putative cell wall binding repeat', 19, NULL, 'Choline_bind_1', 260943),
(441850, 'PF06889', NULL, 'Protein of unknown function (DUF1266)', 177, NULL, 'DUF1266', 260944),
(441851, 'PF11844', NULL, 'Domain of unknown function (DUF3364)', 56, NULL, 'DUF3364', 260945),
(441852, 'PF14638', NULL, 'Folliculin-interacting protein C-terminus', 193, NULL, 'FNIP_C', 260946),
(441853, 'PF17437', NULL, 'Family of unknown function (DUF5416)', 167, NULL, 'DUF5416', 260947),
(441854, 'PF16927', NULL, 'N-terminal 7TM region of histidine kinase', 220, NULL, 'HisKA_7TM', 260948),
(441855, 'PF19249', NULL, 'Family of unknown function (DUF5897)', 200, NULL, 'DUF5897', 260949),
(441856, 'PF18663', NULL, 'Pallilysin beta barrel domain', 118, NULL, 'Pallilysin', 260950),
(441857, 'PF07182', NULL, 'Protein of unknown function (DUF1402)', 300, NULL, 'DUF1402', 260951),
(441858, 'PF18442', NULL, 'E3 gp78 Ube2g2-binding region (G2BR)', 27, NULL, 'G2BR', 260952),
(441859, 'PF01512', NULL, 'Respiratory-chain NADH dehydrogenase 51 Kd subunit', 152, NULL, 'Complex1_51K', 260953),
(441860, 'PF04999', NULL, 'Cell division protein FtsL', 97, NULL, 'FtsL', 260954),
(441861, 'PF09294', NULL, 'Interferon-alpha/beta receptor, fibronectin type III', 104, NULL, 'Interfer-bind', 260955),
(441862, 'PF15599', NULL, 'Immunity protein 63', 83, NULL, 'Imm63', 260956),
(441863, 'PF17967', NULL, 'Pullulanase N2 domain', 112, NULL, 'Pullulanase_N2', 260957),
(441864, 'PF03080', NULL, 'Neprosin', 213, NULL, 'Neprosin', 260958),
(441865, 'PF10955', NULL, 'Anti-sigma-F factor Fin', 76, NULL, 'Fin', 260959),
(441866, 'PF01787', NULL, 'Ilarvirus coat protein', 204, NULL, 'Ilar_coat', 260960),
(441867, 'PF07717', NULL, 'Oligonucleotide/oligosaccharide-binding (OB)-fold', 83, NULL, 'OB_NTP_bind', 260961),
(441868, 'PF01990', NULL, 'ATP synthase (F/14-kDa) subunit', 91, NULL, 'ATP-synt_F', 260962),
(441869, 'PF11916', NULL, 'Vacuolar protein 14 C-terminal Fig4p binding', 179, NULL, 'Vac14_Fig4_bd', 260963),
(441870, 'PF12467', NULL, 'Cucumber mosaic virus 1a protein family', 169, NULL, 'CMV_1a', 260964),
(441871, 'PF13226', NULL, 'Domain of unknown function (DUF4034)', 274, NULL, 'DUF4034', 260965),
(441872, 'PF16822', NULL, 'SGNH hydrolase-like domain, acetyltransferase AlgX', 268, NULL, 'ALGX', 260966);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(441873, 'PF05042', NULL, 'Caleosin related protein', 170, NULL, 'Caleosin', 260967),
(441874, 'PF02305', NULL, 'Capsid protein (F protein)', 510, NULL, 'Phage_F', 260968),
(441875, 'PF03980', NULL, 'Nnf1', 110, NULL, 'Nnf1', 260969),
(441876, 'PF15902', NULL, 'Sortilin, neurotensin receptor 3,', 445, NULL, 'Sortilin-Vps10', 260970),
(441877, 'PF00906', NULL, 'Hepatitis core antigen', 259, NULL, 'Hepatitis_core', 260971),
(441878, 'PF04632', NULL, 'Fusaric acid resistance protein family', 657, NULL, 'FUSC', 260972),
(441879, 'PF10392', NULL, 'Golgi transport complex subunit 5', 132, NULL, 'COG5', 260973),
(441880, 'PF16668', NULL, 'Adhesin from Campylobacter', 352, NULL, 'JLPA', 260974),
(441881, 'PF18114', NULL, 'Suv3 helical N-terminal domain', 116, NULL, 'Suv3_N', 260975),
(441882, 'PF13434', NULL, 'L-lysine 6-monooxygenase/L-ornithine 5-monooxygenase', 341, NULL, 'Lys_Orn_oxgnase', 260976),
(441883, 'PF14665', NULL, 'Rapamycin-insensitive companion of mTOR, phosphorylation-site', 112, NULL, 'RICTOR_phospho', 260977),
(441884, 'PF04245', NULL, '37-kD nucleoid-associated bacterial protein', 309, NULL, 'NA37', 260978),
(441885, 'PF19027', NULL, 'Family of unknown function (DUF5752)', 208, NULL, 'DUF5752', 260979),
(441886, 'PF06112', NULL, 'Gammaherpesvirus capsid protein', 169, NULL, 'Herpes_capsid', 260980),
(441887, 'PF07883', NULL, 'Cupin domain', 71, NULL, 'Cupin_2', 260981),
(441888, 'PF07957', NULL, 'Protein of unknown function (DUF3294)', 213, NULL, 'DUF3294', 260982),
(441889, 'PF16964', NULL, 'Putative tight adherence pilin protein F', 182, NULL, 'TadF', 260983),
(441890, 'PF15465', NULL, 'Domain of unknown function (DUF4634)', 131, NULL, 'DUF4634', 260984),
(441891, 'PF08064', NULL, 'UME (NUC010) domain', 102, NULL, 'UME', 260985),
(441892, 'PF02497', NULL, 'Arterivirus glycoprotein', 178, NULL, 'Arteri_GP4', 260986),
(441893, 'PF09728', NULL, 'Myosin-like coiled-coil protein', 302, NULL, 'Taxilin', 260987),
(441894, 'PF08106', NULL, 'Formaecin family', 16, NULL, 'Antimicrobial11', 260988),
(441895, 'PF16405', NULL, 'Domain of unknown function (DUF5013)', 149, NULL, 'DUF5013', 260989),
(441896, 'PF02333', NULL, 'Phytase', 375, NULL, 'Phytase', 260990),
(441897, 'PF13847', NULL, 'Methyltransferase domain', 152, NULL, 'Methyltransf_31', 260991),
(441898, 'PF00130', NULL, 'Phorbol esters/diacylglycerol binding domain (C1 domain)', 53, NULL, 'C1_1', 260992),
(441899, 'PF00628', NULL, 'PHD-finger', 52, NULL, 'PHD', 260993),
(441900, 'PF12411', NULL, 'Choline sulfatase enzyme C terminal', 53, NULL, 'Choline_sulf_C', 260994),
(441901, 'PF00317', NULL, 'Ribonucleotide reductase, all-alpha domain', 83, NULL, 'Ribonuc_red_lgN', 260995),
(441902, 'PF01093', NULL, 'Clusterin', 428, NULL, 'Clusterin', 260996),
(441903, 'PF12142', NULL, 'Polyphenol oxidase middle domain', 52, NULL, 'PPO1_DWL', 260997),
(441904, 'PF17103', NULL, 'Stealth protein CR4, conserved region 4', 55, NULL, 'Stealth_CR4', 260998),
(441905, 'PF07412', NULL, 'Geminin', 197, NULL, 'Geminin', 260999),
(441906, 'PF18890', NULL, 'FANCL UBC-like domain 2', 91, NULL, 'FANCL_d2', 261000),
(441907, 'PF04807', NULL, 'Geminivirus AC4/5 conserved region', 33, NULL, 'Gemini_AC4_5', 261001),
(441908, 'PF04609', NULL, 'Methyl-coenzyme M reductase operon protein C', 271, NULL, 'MCR_C', 261002),
(441909, 'PF14371', NULL, 'Domain of unknown function (DUF4412)', 191, NULL, 'DUF4412', 261003),
(441910, 'PF18660', NULL, 'Tsi6', 83, NULL, 'Tsi6', 261004),
(441911, 'PF17798', NULL, 'TRIF N-terminal domain', 157, NULL, 'TRIF-NTD', 261005),
(441912, 'PF17509', NULL, 'Family of unknown function (DUF5440)', 93, NULL, 'DUF5440', 261006),
(441913, 'PF08216', NULL, 'Catenin-beta-like, Arm-motif containing nuclear', 475, NULL, 'CTNNBL', 261007),
(441914, 'PF08071', NULL, 'RS4NT (NUC023) domain', 37, NULL, 'RS4NT', 261008),
(441915, 'PF01114', NULL, 'Colipase, N-terminal domain', 40, NULL, 'Colipase', 261009),
(441916, 'PF14576', NULL, 'Sieve element occlusion N-terminus', 287, NULL, 'SEO_N', 261010),
(441917, 'PF11443', NULL, 'Domain of unknown function (DUF2828)', 640, NULL, 'DUF2828', 261011);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(441918, 'PF18504', NULL, 'Csm1 N-terminal domain', 70, NULL, 'Csm1_N', 261012),
(441919, 'PF12944', NULL, 'Hepatitis A virus viral protein VP', 168, NULL, 'HAV_VP', 261013),
(441920, 'PF03371', NULL, 'PRP38 family', 174, NULL, 'PRP38', 261014),
(441921, 'PF14607', NULL, 'N-terminus of Esterase_SGNH_hydro-type', 146, NULL, 'GxDLY', 261015),
(441922, 'PF09035', NULL, 'Excisionase from transposon Tn916', 69, NULL, 'Tn916-Xis', 261016),
(441923, 'PF12431', NULL, 'Transcriptional regulator', 30, NULL, 'CitT', 261017),
(441924, 'PF19989', NULL, 'Family of unknown function (DUF6425)', 233, NULL, 'DUF6425', 261018),
(441925, 'PF08907', NULL, 'Domain of unknown function (DUF1853)', 281, NULL, 'DUF1853', 261019),
(441926, 'PF16143', NULL, 'Domain of unknown function (DUF4851)', 195, NULL, 'DUF4851', 261020),
(441927, 'PF00965', NULL, 'Tissue inhibitor of metalloproteinase', 183, NULL, 'TIMP', 261021),
(441928, 'PF05451', NULL, 'Phytoreovirus nonstructural protein Pns10/11', 352, NULL, 'Phytoreo_Pns', 261022),
(441929, 'PF15200', NULL, 'Keratinocyte differentiation-associated', 77, NULL, 'KRTDAP', 261023),
(441930, 'PF15917', NULL, 'Piezo', 226, NULL, 'PIEZO', 261024),
(441931, 'PF01158', NULL, 'Ribosomal protein L36e', 96, NULL, 'Ribosomal_L36e', 261025),
(441932, 'PF14324', NULL, 'PINIT domain', 140, NULL, 'PINIT', 261026),
(441933, 'PF02095', NULL, 'Extensin-like protein repeat', 10, NULL, 'Extensin_1', 261027),
(441934, 'PF16390', NULL, 'Domain of unknown function', 76, NULL, 'DUF4999', 261028),
(441935, 'PF18236', NULL, 'Argonaute N domain', 122, NULL, 'AGO_N', 261029),
(441936, 'PF19518', NULL, 'p190RhoGAP, pG1 and pG2 domains', 700, NULL, 'RhoGAP_pG1_pG2', 261030),
(441937, 'PF00862', NULL, 'Sucrose synthase', 548, NULL, 'Sucrose_synth', 261031),
(441938, 'PF09486', NULL, 'Bacterial type III secretion protein (HrpB7)', 157, NULL, 'HrpB7', 261032),
(441939, 'PF10909', NULL, 'Protein of unknown function (DUF2682)', 88, NULL, 'DUF2682', 261033),
(441940, 'PF05227', NULL, 'CHASE3 domain', 138, NULL, 'CHASE3', 261034),
(441941, 'PF15369', NULL, 'Uncharacterised protein KIAA1328', 327, NULL, 'KIAA1328', 261035),
(441942, 'PF06429', NULL, 'Flagellar basal body rod FlgEFG protein C-terminal', 74, NULL, 'Flg_bbr_C', 261036),
(441943, 'PF13730', NULL, 'Helix-turn-helix domain', 55, NULL, 'HTH_36', 261037),
(441944, 'PF08404', NULL, 'Baculoviridae P74 N-terminal', 300, NULL, 'Baculo_p74_N', 261038),
(441945, 'PF00148', NULL, 'Nitrogenase component 1 type Oxidoreductase', 399, NULL, 'Oxidored_nitro', 261039),
(441946, 'PF16591', NULL, 'Helical bimodular sensor domain', 254, NULL, 'HBM', 261040),
(441947, 'PF11644', NULL, 'Protein of unknown function (DUF3256)', 195, NULL, 'DUF3256', 261041),
(441948, 'PF02550', NULL, 'Acetyl-CoA hydrolase/transferase N-terminal domain', 198, NULL, 'AcetylCoA_hydro', 261042),
(441949, 'PF14314', NULL, 'Virus-capping methyltransferase', 685, NULL, 'Methyltrans_Mon', 261043),
(441950, 'PF03900', NULL, 'Porphobilinogen deaminase, C-terminal domain', 75, NULL, 'Porphobil_deamC', 261044),
(441951, 'PF05637', NULL, 'galactosyl transferase GMA12/MNN10 family', 239, NULL, 'Glyco_transf_34', 261045),
(441952, 'PF14825', NULL, 'Cilia- and flagella-associated protein 77', 158, NULL, 'CFAP77', 261046),
(441953, 'PF16502', NULL, 'Domain of unknown function (DUF5059)', 620, NULL, 'DUF5059', 261047),
(441954, 'PF10899', NULL, 'Putative abortive phage resistance protein AbiGi, antitoxin', 174, NULL, 'AbiGi', 261048),
(441955, 'PF11785', NULL, 'Aft1 osmotic stress response (OSM) domain', 57, NULL, 'Aft1_OSA', 261049),
(441956, 'PF20153', NULL, 'Family of unknown function (DUF6535)', 176, NULL, 'DUF6535', 261050),
(441957, 'PF02815', NULL, 'MIR domain', 186, NULL, 'MIR', 261051),
(441958, 'PF04749', NULL, 'PLAC8 family', 95, NULL, 'PLAC8', 261052),
(441959, 'PF07885', NULL, 'Ion channel', 79, NULL, 'Ion_trans_2', 261053),
(441960, 'PF05065', NULL, 'Phage capsid family', 280, NULL, 'Phage_capsid', 261054),
(441961, 'PF15456', NULL, 'Up-regulated During Septation', 130, NULL, 'Uds1', 261055);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(441962, 'PF15711', NULL, 'Interleukin-like EMT inducer', 88, NULL, 'ILEI', 261056),
(441963, 'PF02964', NULL, 'Methane monooxygenase, hydrolase gamma chain', 161, NULL, 'MeMO_Hyd_G', 261057),
(441964, 'PF05934', NULL, 'Mid-1-related chloride channel (MCLC)', 549, NULL, 'MCLC', 261058),
(441965, 'PF19918', NULL, 'MoxR-vWA-beta-propeller ternary system domain bpX2', 226, NULL, 'bpX2', 261059),
(441966, 'PF14916', NULL, 'Coiled-coil domain of unknown function', 57, NULL, 'CCDC92', 261060),
(441967, 'PF01229', NULL, 'Glycosyl hydrolases family 39', 472, NULL, 'Glyco_hydro_39', 261061),
(441968, 'PF04369', NULL, 'Lactococcin-like family', 60, NULL, 'Lactococcin', 261062),
(441969, 'PF17553', NULL, 'Family of unknown function (DUF5465)', 19, NULL, 'DUF5465', 261063),
(441970, 'PF09129', NULL, 'Cholesterol oxidase, substrate-binding', 321, NULL, 'Chol_subst-bind', 261064),
(441971, 'PF17708', NULL, 'Gasdermin PUB domain', 175, NULL, 'Gasdermin_C', 261065),
(441972, 'PF04312', NULL, 'Protein of unknown function (DUF460)', 142, NULL, 'DUF460', 261066),
(441973, 'PF19618', NULL, 'Family of unknown function (DUF6123)', 89, NULL, 'DUF6123', 261067),
(441974, 'PF10065', NULL, 'Uncharacterized conserved protein (DUF2303)', 269, NULL, 'DUF2303', 261068),
(441975, 'PF18547', NULL, 'Halobacterial output domain 2', 52, NULL, 'HalOD2', 261069),
(441976, 'PF05383', NULL, 'La domain', 59, NULL, 'La', 261070),
(441977, 'PF01794', NULL, 'Ferric reductase like transmembrane component', 124, NULL, 'Ferric_reduct', 261071),
(441978, 'PF19379', NULL, 'Family of unknown function (DUF5954)', 298, NULL, 'DUF5954', 261072),
(441979, 'PF08963', NULL, 'Protein of unknown function (DUF1878)', 110, NULL, 'DUF1878', 261073),
(441980, 'PF20097', NULL, 'Domain of unknown function (DUF6487)', 50, NULL, 'DUF6487', 261074),
(441981, 'PF18905', NULL, 'Protein of unknown function (DUF5661)', 71, NULL, 'DUF5661', 261075),
(441982, 'PF00347', NULL, 'Ribosomal protein L6', 76, NULL, 'Ribosomal_L6', 261076),
(441983, 'PF12593', NULL, 'Microcystin synthetase C terminal', 43, NULL, 'McyA_C', 261077),
(441984, 'PF11021', NULL, 'Protein of unknown function (DUF2613)', 55, NULL, 'DUF2613', 261078),
(441985, 'PF12494', NULL, 'Protein of unknown function (DUF3695)', 99, NULL, 'DUF3695', 261079),
(441986, 'PF12006', NULL, 'Protein of unknown function (DUF3500)', 296, NULL, 'DUF3500', 261080),
(441987, 'PF18656', NULL, 'Family of unknown function (DUF5633)', 41, NULL, 'DUF5633', 261081),
(441988, 'PF15878', NULL, 'Domain of unknown function (DUF4733)', 94, NULL, 'DUF4733', 261082),
(441989, 'PF05397', NULL, 'Mediator complex subunit 15', 112, NULL, 'Med15_fungi', 261083),
(441990, 'PF12175', NULL, 'White spot syndrome virus structural envelope protein VP', 201, NULL, 'WSS_VP', 261084),
(441991, 'PF12509', NULL, 'Protein of unknown function (DUF3715)', 151, NULL, 'DUF3715', 261085),
(441992, 'PF15726', NULL, 'Domain of unknown function (DUF4677)', 194, NULL, 'DUF4677', 261086),
(441993, 'PF05350', NULL, 'Glycogen synthase kinase-3 binding', 238, NULL, 'GSK-3_bind', 261087),
(441994, 'PF07355', NULL, 'Glycine/sarcosine/betaine reductase selenoprotein B (GRDB)', 347, NULL, 'GRDB', 261088),
(441995, 'PF16768', NULL, 'Nucleoporin homology of Germinal-centre associated nuclear protein', 292, NULL, 'NupH_GANP', 261089),
(441996, 'PF17358', NULL, 'Family of unknown function (DUF5384)', 145, NULL, 'DUF5384', 261090),
(441997, 'PF07197', NULL, 'Protein of unknown function (DUF1409)', 48, NULL, 'DUF1409', 261091),
(441998, 'PF19724', NULL, 'Family of unknown function (DUF6217)', 132, NULL, 'DUF6217', 261092),
(441999, 'PF00106', NULL, 'short chain dehydrogenase', 195, NULL, 'adh_short', 261093),
(442000, 'PF09679', NULL, 'Type-F conjugative transfer system pilin chaperone (TraQ)', 87, NULL, 'TraQ', 261094),
(442001, 'PF06725', NULL, '3D domain', 75, NULL, '3D', 261095),
(442002, 'PF08953', NULL, 'Domain of unknown function (DUF1899)', 66, NULL, 'DUF1899', 261096),
(442003, 'PF00214', NULL, 'Calcitonin / CGRP / IAPP family', 130, NULL, 'Calc_CGRP_IAPP', 261097);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(442004, 'PF18198', NULL, 'Dynein heavy chain AAA lid domain', 139, NULL, 'AAA_lid_11', 261098),
(442005, 'PF11450', NULL, 'Protein of unknwon function (DUF3008)', 57, NULL, 'DUF3008', 261099),
(442006, 'PF03802', NULL, 'Apo-citrate lyase phosphoribosyl-dephospho-CoA transferase', 165, NULL, 'CitX', 261100),
(442007, 'PF05510', NULL, 'Sarcoglycan alpha/epsilon', 410, NULL, 'Sarcoglycan_2', 261101),
(442008, 'PF17372', NULL, 'Family of unknown function (DUF5394)', 219, NULL, 'DUF5394', 261102),
(442009, 'PF04979', NULL, 'Protein phosphatase inhibitor 2 (IPP-2)', 134, NULL, 'IPP-2', 261103),
(442010, 'PF19342', NULL, 'MGP3 C-terminal domain', 113, NULL, 'MGP3_C', 261104),
(442011, 'PF03280', NULL, 'Proteobacterial lipase chaperone protein', 192, NULL, 'Lipase_chap', 261105),
(442012, 'PF07836', NULL, 'DmpG-like communication domain', 63, NULL, 'DmpG_comm', 261106),
(442013, 'PF00538', NULL, 'linker histone H1 and H5 family', 74, NULL, 'Linker_histone', 261107),
(442014, 'PF11656', NULL, 'YjbD family (DUF3811)', 88, NULL, 'DUF3811', 261108),
(442015, 'PF20507', NULL, 'Family of unknown function (DUF6733)', 243, NULL, 'DUF6733', 261109),
(442016, 'PF01418', NULL, 'Helix-turn-helix domain, rpiR family', 77, NULL, 'HTH_6', 261110),
(442017, 'PF18443', NULL, 'Tle cognate immunity protein 4 N-terminal domain', 138, NULL, 'Tli4_N', 261111),
(442018, 'PF18974', NULL, 'Domain of unknown function (DUF5710)', 44, NULL, 'DUF5710', 261112),
(442019, 'PF00540', NULL, 'gag gene protein p17 (matrix protein)', 140, NULL, 'Gag_p17', 261113),
(442020, 'PF15486', NULL, 'Domain of unknown function (DUF4644)', 161, NULL, 'DUF4644', 261114),
(442021, 'PF02319', NULL, 'E2F/DP family winged-helix DNA-binding domain', 65, NULL, 'E2F_TDP', 261115),
(442022, 'PF05443', NULL, 'ROS/MUCR transcriptional regulator protein', 125, NULL, 'ROS_MUCR', 261116),
(442023, 'PF18165', NULL, 'Predicted pPIWI-associating nuclease', 133, NULL, 'pP_pnuc_1', 261117),
(442024, 'PF02807', NULL, 'ATP:guanido phosphotransferase, N-terminal domain', 67, NULL, 'ATP-gua_PtransN', 261118),
(442025, 'PF05694', NULL, '56kDa selenium binding protein (SBP56)', 453, NULL, 'SBP56', 261119),
(442026, 'PF05488', NULL, 'PAAR motif', 70, NULL, 'PAAR_motif', 261120),
(442027, 'PF12889', NULL, 'Protein of unknown function (DUF3829)', 283, NULL, 'DUF3829', 261121),
(442028, 'PF20437', NULL, 'Lon-like LonC helical domain', 34, NULL, 'LonC_helical', 261122),
(442029, 'PF16423', NULL, 'Transcription factor COE1 helix-loop-helix domain', 44, NULL, 'COE1_HLH', 261123),
(442030, 'PF20256', NULL, 'Molybdopterin cofactor-binding domain', 285, NULL, 'MoCoBD_2', 261124),
(442031, 'PF16814', NULL, 'Read-through domain', 182, NULL, 'Read-through', 261125),
(442032, 'PF01819', NULL, 'Levivirus coat protein', 132, NULL, 'Levi_coat', 261126),
(442033, 'PF15213', NULL, 'CMT1A duplicated region transcript 4 protein', 137, NULL, 'CDRT4', 261127),
(442034, 'PF19750', NULL, 'Family of unknown function (DUF6237)', 90, NULL, 'DUF6237', 261128),
(442035, 'PF14938', NULL, 'Soluble NSF attachment protein, SNAP', 282, NULL, 'SNAP', 261129),
(442036, 'PF00188', NULL, 'Cysteine-rich secretory protein family', 126, NULL, 'CAP', 261130),
(442037, 'PF08338', NULL, 'Domain of unknown function (DUF1731)', 47, NULL, 'DUF1731', 261131),
(442038, 'PF02558', NULL, 'Ketopantoate reductase PanE/ApbA', 152, NULL, 'ApbA', 261132),
(442039, 'PF14648', NULL, 'FAM91 C-terminus', 429, NULL, 'FAM91_C', 261133),
(442040, 'PF08067', NULL, 'ROKNT (NUC014) domain', 41, NULL, 'ROKNT', 261134),
(442041, 'PF18914', NULL, 'Domain of unknown function (DUF5666)', 61, NULL, 'DUF5666', 261135),
(442042, 'PF03057', NULL, 'DUF236 repeat', 31, NULL, 'DUF236', 261136),
(442043, 'PF15658', NULL, 'Latrotoxin C-terminal domain', 137, NULL, 'Latrotoxin_C', 261137),
(442044, 'PF07898', NULL, 'Protein of unknown function (DUF1676)', 172, NULL, 'DUF1676', 261138),
(442045, 'PF00036', NULL, 'EF hand', 29, NULL, 'EF-hand_1', 261139),
(442046, 'PF00669', NULL, 'Bacterial flagellin N-terminal helical region', 139, NULL, 'Flagellin_N', 261140);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(442047, 'PF12503', NULL, 'Cucumber mosaic virus 1a protein C terminal', 84, NULL, 'CMV_1a_C', 261141),
(442048, 'PF04717', NULL, 'Type VI secretion system/phage-baseplate injector OB domain', 75, NULL, 'Phage_base_V', 261142),
(442049, 'PF13459', NULL, '4Fe-4S single cluster domain', 66, NULL, 'Fer4_15', 261143),
(442050, 'PF05097', NULL, 'Protein of unknown function (DUF688)', 446, NULL, 'DUF688', 261144),
(442051, 'PF07767', NULL, 'Nop53 (60S ribosomal biogenesis)', 402, NULL, 'Nop53', 261145),
(442052, 'PF20612', NULL, 'SHOCT domain', 53, NULL, 'SHOCT_2', 261146),
(442053, 'PF04797', NULL, 'Herpesvirus dUTPase protein', 379, NULL, 'Herpes_ORF11', 261147),
(442054, 'PF06001', NULL, 'CREB-binding protein/p300, atypical RING domain', 40, NULL, 'RING_CBP-p300', 261148),
(442055, 'PF15292', NULL, 'Treslin N-terminus', 797, NULL, 'Treslin_N', 261149),
(442056, 'PF15687', NULL, 'Nuclear receptor-interacting protein 1 repression 1', 305, NULL, 'NRIP1_repr_1', 261150),
(442057, 'PF01802', NULL, 'Herpesvirus VP23 like capsid protein', 290, NULL, 'Herpes_V23', 261151),
(442058, 'PF04295', NULL, 'D-galactarate dehydratase / Altronate hydrolase, C terminus', 392, NULL, 'GD_AH_C', 261152),
(442059, 'PF12426', NULL, 'RNA dependent RNA polymerase', 41, NULL, 'DUF3674', 261153),
(442060, 'PF10738', NULL, 'Probable lipoprotein LpqN', 174, NULL, 'Lpp-LpqN', 261154),
(442061, 'PF15356', NULL, 'Psoriasis susceptibility locus 2', 114, NULL, 'SPR1', 261155),
(442062, 'PF03377', NULL, 'TAL effector repeat', 33, NULL, 'TAL_effector', 261156),
(442063, 'PF05216', NULL, 'UNC-50 family', 221, NULL, 'UNC-50', 261157),
(442064, 'PF18780', NULL, 'Homing endonuclease associated repeat', 54, NULL, 'HNH_repeat', 261158),
(442065, 'PF19294', NULL, 'Diadenylate cyclase, N-terminal', 125, NULL, 'DACZ_N', 261159),
(442066, 'PF11693', NULL, 'Protein of unknown function (DUF2990)', 63, NULL, 'DUF2990', 261160),
(442067, 'PF08100', NULL, 'Dimerisation domain', 51, NULL, 'Dimerisation', 261161),
(442068, 'PF09224', NULL, 'Domain of unknown function (DUF1961)', 214, NULL, 'DUF1961', 261162),
(442069, 'PF16856', NULL, 'Cell division control protein 4 dimerisation domain', 51, NULL, 'CDC4_D', 261163),
(442070, 'PF04499', NULL, 'SIT4 phosphatase-associated protein', 490, NULL, 'SAPS', 261164),
(442071, 'PF02522', NULL, 'Aminoglycoside 3-N-acetyltransferase', 230, NULL, 'Antibiotic_NAT', 261165),
(442072, 'PF05791', NULL, 'Bacillus haemolytic enterotoxin (HBL)', 177, NULL, 'Bacillus_HBL', 261166),
(442073, 'PF13374', NULL, 'Tetratricopeptide repeat', 42, NULL, 'TPR_10', 261167),
(442074, 'PF16472', NULL, 'Domain of unknown function (DUF5050)', 282, NULL, 'DUF5050', 261168),
(442075, 'PF14415', NULL, 'Domain of unknown function (DUF4424)', 306, NULL, 'DUF4424', 261169),
(442076, 'PF19322', NULL, 'E3 ubiquitin-protein ligase RKP N-terminus', 137, NULL, 'RKP_N', 261170),
(442077, 'PF05024', NULL, 'N-acetylglucosaminyl transferase component (Gpi1)', 274, NULL, 'Gpi1', 261171),
(442078, 'PF04539', NULL, 'Sigma-70 region 3', 78, NULL, 'Sigma70_r3', 261172),
(442079, 'PF18829', NULL, 'Importin repeat 6', 110, NULL, 'Importin_rep_6', 261173),
(442080, 'PF10895', NULL, 'Domain of unknown function (DUF2715)', 176, NULL, 'DUF2715', 261174),
(442081, 'PF14996', NULL, 'Retinal Maintenance', 154, NULL, 'RMP', 261175),
(442082, 'PF16809', NULL, 'NleF caspase inhibitor', 150, NULL, 'NleF_casp_inhib', 261176),
(442083, 'PF10717', NULL, 'Occlusion-derived virus envelope protein ODV-E18', 87, NULL, 'ODV-E18', 261177),
(442084, 'PF12744', NULL, 'Autophagy protein Atg19, Atg8-binding', 251, NULL, 'ATG19', 261178),
(442085, 'PF16945', NULL, 'Putative lactococcus lactis phage r1t holin', 72, NULL, 'Phage_r1t_holin', 261179),
(442086, 'PF12085', NULL, 'Protein of unknown function (DUF3562)', 60, NULL, 'DUF3562', 261180),
(442087, 'PF08153', NULL, 'NGP1NT (NUC091) domain', 131, NULL, 'NGP1NT', 261181),
(442088, 'PF12021', NULL, 'Protein of unknown function (DUF3509)', 87, NULL, 'DUF3509', 261182),
(442089, 'PF01376', NULL, 'Heat-labile enterotoxin beta chain', 102, NULL, 'Enterotoxin_b', 261183);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(442090, 'PF07547', NULL, 'RSD-2 N-terminal domain', 85, NULL, 'RSD-2', 261184),
(442091, 'PF13072', NULL, 'Mother cell inhibitor of FtsZ', 37, NULL, 'MciZ', 261185),
(442092, 'PF13907', NULL, 'Domain of unknown function (DUF4208)', 96, NULL, 'DUF4208', 261186),
(442093, 'PF17625', NULL, 'Family of unknown function (DUF5509)', 362, NULL, 'DUF5509', 261187),
(442094, 'PF06716', NULL, 'Movement protein p6', 54, NULL, 'MP_p6', 261188),
(442095, 'PF14882', NULL, 'Integrase repeat unit', 55, NULL, 'INT_rpt', 261189),
(442096, 'PF00979', NULL, 'Reovirus outer capsid protein, Sigma 3', 367, NULL, 'Reovirus_cap', 261190),
(442097, 'PF02498', NULL, 'BRO family, N-terminal domain', 95, NULL, 'Bro-N', 261191),
(442098, 'PF02508', NULL, 'Rnf-Nqr subunit, membrane protein', 174, NULL, 'Rnf-Nqr', 261192),
(442099, 'PF19933', NULL, 'Domain of unknown function (DUF6396)', 108, NULL, 'DUF6396', 261193),
(442100, 'PF02166', NULL, 'Androgen receptor', 501, NULL, 'Androgen_recep', 261194),
(442101, 'PF09900', NULL, 'Predicted membrane protein (DUF2127)', 140, NULL, 'DUF2127', 261195),
(442102, 'PF10693', NULL, 'Protein of unknown function (DUF2499)', 89, NULL, 'DUF2499', 261196),
(442103, 'PF18685', NULL, 'Family of unknown function (DUF5635)', 86, NULL, 'DUF5635', 261197),
(442104, 'PF04183', NULL, 'IucA / IucC family', 239, NULL, 'IucA_IucC', 261198),
(442105, 'PF07476', NULL, 'Methylaspartate ammonia-lyase C-terminus', 249, NULL, 'MAAL_C', 261199),
(442106, 'PF09855', NULL, 'Nucleic-acid-binding protein containing Zn-ribbon domain (DUF2082)', 63, NULL, 'zinc_ribbon_13', 261200),
(442107, 'PF07818', NULL, 'HCNGP-like protein', 94, NULL, 'HCNGP', 261201),
(442108, 'PF14497', NULL, 'Glutathione S-transferase, C-terminal domain', 104, NULL, 'GST_C_3', 261202),
(442109, 'PF07708', NULL, 'Tash protein PEST motif', 18, NULL, 'Tash_PEST', 261203),
(442110, 'PF14531', NULL, 'Kinase-like', 288, NULL, 'Kinase-like', 261204),
(442111, 'PF04010', NULL, 'Protein of unknown function (DUF357)', 73, NULL, 'DUF357', 261205),
(442112, 'PF14809', NULL, 'C1 domain of tRNA-guanine transglycosylase dimerisation', 70, NULL, 'TGT_C1', 261206),
(442113, 'PF10737', NULL, 'Spore germination protein GerPC', 174, NULL, 'GerPC', 261207),
(442114, 'PF17862', NULL, 'AAA+ lid domain', 45, NULL, 'AAA_lid_3', 261208),
(442115, 'PF06791', NULL, 'Prophage tail length tape measure protein', 207, NULL, 'TMP_2', 261209),
(442116, 'PF19386', NULL, 'Family of unknown function (DUF5961)', 72, NULL, 'DUF5961', 261210),
(442117, 'PF18514', NULL, 'Get5 C-terminal domain', 38, NULL, 'Get5_C', 261211),
(442118, 'PF04349', NULL, 'Periplasmic glucan biosynthesis protein, MdoG', 476, NULL, 'MdoG', 261212),
(442119, 'PF00875', NULL, 'DNA photolyase', 164, NULL, 'DNA_photolyase', 261213),
(442120, 'PF07287', NULL, 'Acyclic terpene utilisation family protein AtuA', 351, NULL, 'AtuA', 261214),
(442121, 'PF09526', NULL, 'Probable metal-binding protein (DUF2387)', 72, NULL, 'DUF2387', 261215),
(442122, 'PF05377', NULL, 'Flagella accessory protein C (FlaC)', 55, NULL, 'FlaC_arch', 261216),
(442123, 'PF17954', NULL, 'Quercetinase C-terminal cupin domain', 86, NULL, 'Pirin_C_2', 261217),
(442124, 'PF07318', NULL, 'Protein of unknown function (DUF1464)', 327, NULL, 'DUF1464', 261218),
(442125, 'PF19926', NULL, 'Family of unknown function (DUF6389)', 149, NULL, 'DUF6389', 261219),
(442126, 'PF16020', NULL, 'Deltamethrin resistance', 52, NULL, 'Deltameth_res', 261220),
(442127, 'PF16737', NULL, 'PHD finger protein 12 MRG binding domain', 40, NULL, 'PHF12_MRG_bd', 261221),
(442128, 'PF05990', NULL, 'Alpha/beta hydrolase of unknown function (DUF900)', 237, NULL, 'DUF900', 261222),
(442129, 'PF07922', NULL, 'Glycosyltransferase family 52', 272, NULL, 'Glyco_transf_52', 261223),
(442130, 'PF11355', NULL, 'Protein of unknown function (DUF3157)', 199, NULL, 'DUF3157', 261224),
(442131, 'PF11839', NULL, 'Alanine-zipper, major outer membrane lipoprotein', 69, NULL, 'Alanine_zipper', 261225),
(442132, 'PF04303', NULL, 'PrpF protein', 384, NULL, 'PrpF', 261226),
(442133, 'PF10056', NULL, 'Uncharacterized conserved protein (DUF2293)', 85, NULL, 'DUF2293', 261227);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(442134, 'PF12274', NULL, 'Protein of unknown function (DUF3615)', 91, NULL, 'DUF3615', 261228),
(442135, 'PF05800', NULL, 'Gas vesicle synthesis protein GvpO', 94, NULL, 'GvpO', 261229),
(442136, 'PF01931', NULL, 'Protein of unknown function DUF84', 163, NULL, 'NTPase_I-T', 261230),
(442137, 'PF20443', NULL, 'Lamina-associated polypeptide 1, N-terminal', 234, NULL, 'LAP1_N', 261231),
(442138, 'PF18607', NULL, 'ParA helix turn helix domain', 92, NULL, 'HTH_54', 261232),
(442139, 'PF09353', NULL, 'Domain of unknown function (DUF1995)', 199, NULL, 'DUF1995', 261233),
(442140, 'PF19773', NULL, 'Domain of unknown function (DUF6259)', 300, NULL, 'DUF6259', 261234),
(442141, 'PF15908', NULL, 'Hyaluronan mediated motility receptor C-terminal', 157, NULL, 'HMMR_C', 261235),
(442142, 'PF02304', NULL, 'Scaffold protein B', 117, NULL, 'Phage_B', 261236),
(442143, 'PF03553', NULL, 'Na+/H+ antiporter family', 303, NULL, 'Na_H_antiporter', 261237),
(442144, 'PF18370', NULL, 'Rhamnogalacturonan I lyases beta-sheet domain', 86, NULL, 'RGI_lyase', 261238),
(442145, 'PF05580', NULL, 'SpoIVB peptidase S55', 210, NULL, 'Peptidase_S55', 261239),
(442146, 'PF18126', NULL, 'Mitochondrial ribosomal protein mL59', 129, NULL, 'Mitoc_mL59', 261240),
(442147, 'PF18017', NULL, 'SAM domain (Sterile alpha motif)', 84, NULL, 'SAM_4', 261241),
(442148, 'PF14127', NULL, 'Domain of unknown function (DUF4294)', 155, NULL, 'DUF4294', 261242),
(442149, 'PF13995', NULL, 'YebF-like protein', 89, NULL, 'YebF', 261243),
(442150, 'PF15218', NULL, 'Spermatogenesis-associated protein 25', 228, NULL, 'SPATA25', 261244),
(442151, 'PF02614', NULL, 'Glucuronate isomerase', 464, NULL, 'UxaC', 261245),
(442152, 'PF09104', NULL, 'BRCA2, oligonucleotide/oligosaccharide-binding, domain 3', 139, NULL, 'BRCA-2_OB3', 261246),
(442153, 'PF06838', NULL, 'Methionine gamma-lyase', 405, NULL, 'Met_gamma_lyase', 261247),
(442154, 'PF08772', NULL, 'Nin one binding (NOB1) Zn-ribbon like', 72, NULL, 'NOB1_Zn_bind', 261248),
(442155, 'PF16130', NULL, 'Domain of unknown function (DUF4842)', 213, NULL, 'DUF4842', 261249),
(442156, 'PF17321', NULL, 'Vacuole-related protein 17', 452, NULL, 'Vac17', 261250),
(442157, 'PF00810', NULL, 'ER lumen protein retaining receptor', 147, NULL, 'ER_lumen_recept', 261251),
(442158, 'PF07231', NULL, 'Hs1pro-1 N-terminus', 200, NULL, 'Hs1pro-1_N', 261252),
(442159, 'PF18014', NULL, 'Acetyltransferase (GNAT) domain', 123, NULL, 'Acetyltransf_18', 261253),
(442160, 'PF17584', NULL, 'Bacillus competence protein S', 44, NULL, 'ComS', 261254),
(442161, 'PF19596', NULL, 'Family of unknown function (DUF6101)', 184, NULL, 'DUF6101', 261255),
(442162, 'PF18155', NULL, 'pPIWI RE three-gene island domain Z', 167, NULL, 'pPIWI_RE_Z', 261256),
(442163, 'PF06212', NULL, 'GRIM-19 protein', 132, NULL, 'GRIM-19', 261257),
(442164, 'PF09062', NULL, 'PI-PfuI Endonuclease subdomain', 98, NULL, 'Endonuc_subdom', 261258),
(442165, 'PF17963', NULL, 'Bacterial Ig domain', 90, NULL, 'Big_9', 261259),
(442166, 'PF04270', NULL, 'Streptococcal histidine triad protein', 51, NULL, 'Strep_his_triad', 261260),
(442167, 'PF01463', NULL, 'Leucine rich repeat C-terminal domain', 26, NULL, 'LRRCT', 261261),
(442168, 'PF17386', NULL, 'Lacto-N-biose phosphorylase C-terminal domain', 53, NULL, 'LBP_C', 261262),
(442169, 'PF02609', NULL, 'Exonuclease VII small subunit', 52, NULL, 'Exonuc_VII_S', 261263),
(442170, 'PF15747', NULL, 'Domain of unknown function (DUF4687)', 120, NULL, 'DUF4687', 261264),
(442171, 'PF20489', NULL, 'Birnavirus RNA dependent RNA polymerase (VP1), C-terminal', 106, NULL, 'Birna_RdRp_C', 261265),
(442172, 'PF00722', NULL, 'Glycosyl hydrolases family 16', 178, NULL, 'Glyco_hydro_16', 261266),
(442173, 'PF19009', NULL, 'Family of unknown function (DUF5738)', 104, NULL, 'DUF5738', 261267),
(442174, 'PF09396', NULL, 'Thrombin light chain', 48, NULL, 'Thrombin_light', 261268),
(442175, 'PF02169', NULL, 'LPP20 lipoprotein', 95, NULL, 'LPP20', 261269),
(442176, 'PF08292', NULL, 'RNA polymerase III subunit Rpc25', 125, NULL, 'RNA_pol_Rbc25', 261270);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(442177, 'PF17546', NULL, 'Beta defensin 50', 50, NULL, 'Defb50', 261271),
(442178, 'PF08196', NULL, 'UL2 protein', 59, NULL, 'UL2', 261272),
(442179, 'PF08337', NULL, 'Plexin cytoplasmic RasGAP domain', 441, NULL, 'Plexin_cytopl', 261273),
(442180, 'PF18596', NULL, 'Sld7 C-terminal domain', 78, NULL, 'Sld7_C', 261274),
(442181, 'PF18879', NULL, 'EspA/EspE family', 84, NULL, 'EspA_EspE', 261275),
(442182, 'PF17032', NULL, 'zinc-ribbon family', 86, NULL, 'zinc_ribbon_15', 261276),
(442183, 'PF14719', NULL, 'Phosphotyrosine interaction domain (PTB/PID)', 184, NULL, 'PID_2', 261277),
(442184, 'PF15840', NULL, 'ADP-ribosylation factor-like protein 17', 62, NULL, 'ARL17', 261278),
(442185, 'PF03634', NULL, 'TCP family transcription factor', 154, NULL, 'TCP', 261279),
(442186, 'PF15262', NULL, 'Domain of unknown function (DUF4592)', 127, NULL, 'DUF4592', 261280),
(442187, 'PF04831', NULL, 'Popeye protein conserved region', 140, NULL, 'Popeye', 261281),
(442188, 'PF01909', NULL, 'Nucleotidyltransferase domain', 94, NULL, 'NTP_transf_2', 261282),
(442189, 'PF07039', NULL, 'SGF29 tudor-like domain', 132, NULL, 'DUF1325', 261283),
(442190, 'PF10646', NULL, 'Sporulation and spore germination', 105, NULL, 'Germane', 261284),
(442191, 'PF15246', NULL, 'Nck-associated protein 5, Peripheral clock protein', 310, NULL, 'NCKAP5', 261285),
(442192, 'PF04242', NULL, 'Protein of unknown function (DUF424)', 92, NULL, 'DUF424', 261286),
(442193, 'PF12106', NULL, 'Colicin E5 ribonuclease domain', 88, NULL, 'Colicin_E5', 261287),
(442194, 'PF12875', NULL, 'Protein of unknown function (DUF3826)', 186, NULL, 'DUF3826', 261288),
(442195, 'PF16760', NULL, 'Starch/carbohydrate-binding module (family 53)', 84, NULL, 'CBM53', 261289),
(442196, 'PF20362', NULL, 'Family of unknown function (DUF6657)', 141, NULL, 'DUF6657', 261290),
(442197, 'PF03603', NULL, 'DNA polymerase III psi subunit', 126, NULL, 'DNA_III_psi', 261291),
(442198, 'PF14498', NULL, 'Glycosyl hydrolase family 65, N-terminal domain', 239, NULL, 'Glyco_hyd_65N_2', 261292),
(442199, 'PF19482', NULL, 'Family of unknown function (DUF6018)', 115, NULL, 'DUF6018', 261293),
(442200, 'PF18517', NULL, 'Leucine zipper with capping helix domain', 55, NULL, 'LZ3wCH', 261294),
(442201, 'PF18215', NULL, 'Histone chaperone Rtt106 N-terminal domain', 46, NULL, 'Rtt106_N', 261295),
(442202, 'PF09977', NULL, 'Putative Tad-like Flp pilus-assembly', 93, NULL, 'Tad_C', 261296),
(442203, 'PF07152', NULL, 'YaeQ protein', 173, NULL, 'YaeQ', 261297),
(442204, 'PF00676', NULL, 'Dehydrogenase E1 component', 300, NULL, 'E1_dh', 261298),
(442205, 'PF08022', NULL, 'FAD-binding domain', 109, NULL, 'FAD_binding_8', 261299),
(442206, 'PF09012', NULL, 'FeoC like transcriptional regulator', 69, NULL, 'FeoC', 261300),
(442207, 'PF15655', NULL, 'NTF2 fold immunity protein', 129, NULL, 'Imm-NTF2', 261301),
(442208, 'PF15545', NULL, 'Bacterial toxin 8', 70, NULL, 'Ntox8', 261302),
(442209, 'PF04648', NULL, 'Yeast mating factor alpha hormone', 13, NULL, 'MF_alpha', 261303),
(442210, 'PF09858', NULL, 'Predicted membrane protein (DUF2085)', 93, NULL, 'DUF2085', 261304),
(442211, 'PF10721', NULL, 'Protein of unknown function (DUF2514)', 161, NULL, 'DUF2514', 261305),
(442212, 'PF08335', NULL, 'GlnD PII-uridylyltransferase', 152, NULL, 'GlnD_UR_UTase', 261306),
(442213, 'PF09665', NULL, 'Type II restriction endonuclease (RE_Alw26IDE)', 507, NULL, 'RE_Alw26IDE', 261307),
(442214, 'PF00758', NULL, 'Erythropoietin/thrombopoietin', 158, NULL, 'EPO_TPO', 261308),
(442215, 'PF01303', NULL, 'Egg lysin (Sperm-lysin)', 121, NULL, 'Egg_lysin', 261309),
(442216, 'PF06421', NULL, 'GTP-binding protein LepA C-terminus', 107, NULL, 'LepA_C', 261310),
(442217, 'PF12708', NULL, 'Pectate lyase superfamily protein', 215, NULL, 'Pectate_lyase_3', 261311),
(442218, 'PF08344', NULL, 'Transient receptor ion channel II', 63, NULL, 'TRP_2', 261312),
(442219, 'PF19949', NULL, 'Family of unknown function (DUF6411)', 63, NULL, 'DUF6411', 261313),
(442220, 'PF09331', NULL, 'Domain of unknown function (DUF1985)', 141, NULL, 'DUF1985', 261314);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(442221, 'PF13139', NULL, 'Domain of unknown function (DUF3981)', 115, NULL, 'DUF3981', 261315),
(442222, 'PF16031', NULL, 'TonB polyproline region', 134, NULL, 'TonB_N', 261316),
(442223, 'PF14575', NULL, 'Ephrin type-A receptor 2 transmembrane domain', 76, NULL, 'EphA2_TM', 261317),
(442224, 'PF00560', NULL, 'Leucine Rich Repeat', 23, NULL, 'LRR_1', 261318),
(442225, 'PF04625', NULL, 'DEC-1 protein, N-terminal region', 403, NULL, 'DEC-1_N', 261319),
(442226, 'PF04978', NULL, 'Protein of unknown function (DUF664)', 149, NULL, 'DUF664', 261320),
(442227, 'PF00555', NULL, 'delta endotoxin', 205, NULL, 'Endotoxin_M', 261321),
(442228, 'PF05712', NULL, 'MRG', 208, NULL, 'MRG', 261322),
(442229, 'PF13117', NULL, 'Cag pathogenicity island protein Cag12', 96, NULL, 'Cag12', 261323),
(442230, 'PF10213', NULL, 'Mitochondrial ribosomal subunit protein', 127, NULL, 'MRP-S28', 261324),
(442231, 'PF13174', NULL, 'Tetratricopeptide repeat', 33, NULL, 'TPR_6', 261325),
(442232, 'PF16939', NULL, 'Putative porin', 282, NULL, 'Porin_6', 261326),
(442233, 'PF18273', NULL, 'Type III R-M EcoP15I C-terminal domain', 97, NULL, 'T3RM_EcoP15I_C', 261327),
(442234, 'PF11537', NULL, 'Nitrosopumilus output domain 5', 94, NULL, 'NitrOD5', 261328),
(442235, 'PF12958', NULL, 'Protein of unknown function (DUF3847)', 81, NULL, 'DUF3847', 261329),
(442236, 'PF04252', NULL, 'Predicted SAM-dependent RNA methyltransferase', 200, NULL, 'RNA_Me_trans', 261330),
(442237, 'PF07735', NULL, 'F-box associated', 67, NULL, 'FBA_2', 261331),
(442238, 'PF11353', NULL, 'Protein of unknown function (DUF3153)', 208, NULL, 'DUF3153', 261332),
(442239, 'PF04583', NULL, 'Baculoviridae p74 conserved region', 216, NULL, 'Baculo_p74', 261333),
(442240, 'PF08315', NULL, 'cwf18 pre-mRNA splicing factor', 139, NULL, 'cwf18', 261334),
(442241, 'PF04304', NULL, 'Protein of unknown function (DUF454)', 115, NULL, 'DUF454', 261335),
(442242, 'PF04697', NULL, 'pinin/SDK conserved region', 135, NULL, 'Pinin_SDK_N', 261336),
(442243, 'PF19912', NULL, 'Domain of unknown function (DUF6385)', 82, NULL, 'DUF6385', 261337),
(442244, 'PF09151', NULL, 'Domain of unknown function (DUF1936)', 34, NULL, 'DUF1936', 261338),
(442245, 'PF02737', NULL, '3-hydroxyacyl-CoA dehydrogenase, NAD binding domain', 180, NULL, '3HCDH_N', 261339),
(442246, 'PF05941', NULL, 'Chordopoxvirus A20R protein', 334, NULL, 'Chordopox_A20R', 261340),
(442247, 'PF03531', NULL, 'Structure-specific recognition protein (SSRP1)', 69, NULL, 'SSrecog', 261341),
(442248, 'PF13689', NULL, 'YfiR/HmsC-like', 143, NULL, 'DUF4154', 261342),
(442249, 'PF01567', NULL, 'Hantavirus glycoprotein G1', 523, NULL, 'Hanta_G1', 261343),
(442250, 'PF08036', NULL, 'Diapausin family of antimicrobial peptide', 39, NULL, 'Antimicrobial_6', 261344),
(442251, 'PF06279', NULL, 'Protein of unknown function (DUF1033)', 118, NULL, 'DUF1033', 261345),
(442252, 'PF19702', NULL, 'Family of unknown function (DUF6200)', 76, NULL, 'DUF6200', 261346),
(442253, 'PF02040', NULL, 'Arsenical pump membrane protein', 423, NULL, 'ArsB', 261347),
(442254, 'PF08857', NULL, 'Putative ParB-like nuclease', 161, NULL, 'ParBc_2', 261348),
(442255, 'PF13264', NULL, 'Domain of unknown function (DUF4055)', 135, NULL, 'DUF4055', 261349),
(442256, 'PF16347', NULL, 'Domain of unknown function (DUF4976)', 103, NULL, 'DUF4976', 261350),
(442257, 'PF19263', NULL, 'Family of unknown function (DUF5906)', 111, NULL, 'DUF5906', 261351),
(442258, 'PF08378', NULL, 'Nuclease-related domain', 108, NULL, 'NERD', 261352),
(442259, 'PF13415', NULL, 'Galactose oxidase, central domain', 49, NULL, 'Kelch_3', 261353),
(442260, 'PF13474', NULL, 'SnoaL-like domain', 121, NULL, 'SnoaL_3', 261354),
(442261, 'PF20378', NULL, 'Family of unknown function (DUF6673)', 114, NULL, 'DUF6673', 261355),
(442262, 'PF16287', NULL, 'Domain of unknown function (DUF4933)', 386, NULL, 'DUF4933', 261356),
(442263, 'PF01268', NULL, 'Formate--tetrahydrofolate ligase', 556, NULL, 'FTHFS', 261357),
(442264, 'PF16802', NULL, 'Domain of unknown function (DUF5070)', 154, NULL, 'DUF5070', 261358);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(442265, 'PF14511', NULL, 'Type II restriction endonuclease EcoO109I', 198, NULL, 'RE_EcoO109I', 261359),
(442266, 'PF18096', NULL, 'THUMP domain-like', 78, NULL, 'Thump_like', 261360),
(442267, 'PF10332', NULL, 'Protein of unknown function (DUF2418)', 96, NULL, 'DUF2418', 261361),
(442268, 'PF15733', NULL, 'Domain of unknown function (DUF4682)', 129, NULL, 'DUF4682', 261362),
(442269, 'PF15436', NULL, 'Plasminogen-binding protein pgbA N-terminal', 217, NULL, 'PGBA_N', 261363),
(442270, 'PF16643', NULL, 'Unstructured region on cNMP-binding protein', 155, NULL, 'cNMPbd_u2', 261364),
(442271, 'PF18667', NULL, 'Baseplate upper protein immunoglobulin like domain', 96, NULL, 'BppU_IgG', 261365),
(442272, 'PF05536', NULL, 'Neurochondrin', 605, NULL, 'Neurochondrin', 261366),
(442273, 'PF04050', NULL, 'Up-frameshift suppressor 2', 133, NULL, 'Upf2', 261367),
(442274, 'PF01612', NULL, '3''-5'' exonuclease', 176, NULL, 'DNA_pol_A_exo1', 261368),
(442275, 'PF06749', NULL, 'Protein of unknown function (DUF1218)', 96, NULL, 'DUF1218', 261369),
(442276, 'PF20399', NULL, 'PH domain', 84, NULL, 'PH_20', 261370),
(442277, 'PF11926', NULL, 'Domain of unknown function (DUF3444)', 212, NULL, 'DUF3444', 261371),
(442278, 'PF14326', NULL, 'Domain of unknown function (DUF4384)', 81, NULL, 'DUF4384', 261372),
(442279, 'PF05781', NULL, 'MRVI1 protein', 533, NULL, 'MRVI1', 261373),
(442280, 'PF06317', NULL, 'Arenavirus RNA polymerase', 2048, NULL, 'Arena_RNA_pol', 261374),
(442281, 'PF09994', NULL, 'Uncharacterized alpha/beta hydrolase domain (DUF2235)', 286, NULL, 'DUF2235', 261375),
(442282, 'PF07963', NULL, 'Prokaryotic N-terminal methylation motif', 27, NULL, 'N_methyl', 261376),
(442283, 'PF15923', NULL, 'Domain of unknown function (DUF4745)', 133, NULL, 'DUF4745', 261377),
(442284, 'PF17647', NULL, 'Family of unknown function (DUF5518)', 118, NULL, 'DUF5518', 261378),
(442285, 'PF11560', NULL, 'Lamina-associated polypeptide 2 alpha', 234, NULL, 'LAP2alpha', 261379),
(442286, 'PF03227', NULL, 'Gamma interferon inducible lysosomal thiol reductase (GILT)', 107, NULL, 'GILT', 261380),
(442287, 'PF09910', NULL, 'Uncharacterized protein conserved in archaea (DUF2139)', 340, NULL, 'DUF2139', 261381),
(442288, 'PF17117', NULL, 'Domain of unknown function (DUF5104)', 108, NULL, 'DUF5104', 261382),
(442289, 'PF08369', NULL, 'Proto-chlorophyllide reductase 57 kD subunit', 45, NULL, 'PCP_red', 261383),
(442290, 'PF11251', NULL, 'Protein of unknown function (DUF3050)', 232, NULL, 'DUF3050', 261384),
(442291, 'PF18098', NULL, '26S proteasome regulatory subunit RPN5 C-terminal domain', 33, NULL, 'RPN5_C', 261385),
(442292, 'PF15230', NULL, 'Serine/arginine repetitive matrix protein C-terminus', 67, NULL, 'SRRM_C', 261386),
(442293, 'PF19528', NULL, 'Family of unknown function (DUF6056)', 436, NULL, 'DUF6056', 261387),
(442294, 'PF11039', NULL, 'Protein of unknown function (DUF2824)', 151, NULL, 'DUF2824', 261388),
(442295, 'PF05902', NULL, '4.1 protein C-terminal domain (CTD)', 107, NULL, '4_1_CTD', 261389),
(442296, 'PF00516', NULL, 'Envelope glycoprotein GP120', 487, NULL, 'GP120', 261390),
(442297, 'PF02572', NULL, 'ATP:corrinoid adenosyltransferase BtuR/CobO/CobP', 172, NULL, 'CobA_CobO_BtuR', 261391),
(442298, 'PF12183', NULL, 'Restriction endonuclease NotI', 232, NULL, 'NotI', 261392),
(442299, 'PF06679', NULL, 'Protein of unknown function (DUF1180)', 169, NULL, 'DUF1180', 261393),
(442300, 'PF18508', NULL, 'Zinc finger domain', 42, NULL, 'zf_C2H2_13', 261394),
(442301, 'PF14881', NULL, 'Tubulin domain', 180, NULL, 'Tubulin_3', 261395),
(442302, 'PF09758', NULL, 'Uncharacterised conserved protein', 149, NULL, 'FPL', 261396),
(442303, 'PF15243', NULL, 'Anaphase-promoting complex subunit 15', 90, NULL, 'ANAPC15', 261397),
(442304, 'PF19917', NULL, 'MoxR-vWA-beta-propeller ternary system domain bpX1', 84, NULL, 'bpX1', 261398),
(442305, 'PF01290', NULL, 'Thymosin beta-4 family', 39, NULL, 'Thymosin', 261399),
(442306, 'PF16161', NULL, 'Domain of unknown function (DUF4867)', 201, NULL, 'DUF4867', 261400),
(442307, 'PF14337', NULL, 'Abortive infection alpha', 194, NULL, 'Abi_alpha', 261401);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(442308, 'PF16280', NULL, 'Domain of unknown function (DUF4928)', 306, NULL, 'DUF4928', 261402),
(442309, 'PF12833', NULL, 'Helix-turn-helix domain', 81, NULL, 'HTH_18', 261403),
(442310, 'PF10317', NULL, 'Serpentine type 7TM GPCR chemoreceptor Srd', 292, NULL, '7TM_GPCR_Srd', 261404),
(442311, 'PF13204', NULL, 'Protein of unknown function (DUF4038)', 306, NULL, 'DUF4038', 261405),
(442312, 'PF01208', NULL, 'Uroporphyrinogen decarboxylase (URO-D)', 345, NULL, 'URO-D', 261406),
(442313, 'PF04322', NULL, 'Protein of unknown function (DUF473)', 118, NULL, 'DUF473', 261407),
(442314, 'PF17788', NULL, 'HypF Kae1-like domain', 102, NULL, 'HypF_C', 261408),
(442315, 'PF02791', NULL, 'DDT domain', 60, NULL, 'DDT', 261409),
(442316, 'PF10812', NULL, 'Protein of unknown function (DUF2561)', 209, NULL, 'DUF2561', 261410),
(442317, 'PF10274', NULL, 'Parkin co-regulated protein', 183, NULL, 'ParcG', 261411),
(442318, 'PF01189', NULL, '16S rRNA methyltransferase RsmB/F', 200, NULL, 'Methyltr_RsmB-F', 261412),
(442319, 'PF15810', NULL, 'Coiled-coil domain-containing protein 117', 143, NULL, 'CCDC117', 261413),
(442320, 'PF09676', NULL, 'Type IV conjugative transfer system lipoprotein (TraV)', 131, NULL, 'TraV', 261414),
(442321, 'PF10596', NULL, 'U6-snRNA interacting domain of PrP8', 159, NULL, 'U6-snRNA_bdg', 261415),
(442322, 'PF20569', NULL, 'Family of unknown function (DUF6778)', 164, NULL, 'DUF6778', 261416),
(442323, 'PF12353', NULL, 'Eukaryotic translation initiation factor 3 subunit G', 125, NULL, 'eIF3g', 261417),
(442324, 'PF19488', NULL, 'Family of unknown function (DUF6024)', 290, NULL, 'DUF6024', 261418),
(442325, 'PF08443', NULL, 'RimK-like ATP-grasp domain', 188, NULL, 'RimK', 261419),
(442326, 'PF13664', NULL, 'Domain of unknown function (DUF4149)', 102, NULL, 'DUF4149', 261420),
(442327, 'PF19144', NULL, 'Family of unknown function (DUF5826)', 68, NULL, 'DUF5826', 261421),
(442328, 'PF06048', NULL, 'Domain of unknown function (DUF927)', 286, NULL, 'DUF927', 261422),
(442329, 'PF10936', NULL, 'Protein of unknown function DUF2617', 161, NULL, 'DUF2617', 261423),
(442330, 'PF14282', NULL, 'FlxA-like protein', 101, NULL, 'FlxA', 261424),
(442331, 'PF08293', NULL, 'Mitochondrial ribosomal subunit S27', 88, NULL, 'MRP-S33', 261425),
(442332, 'PF11371', NULL, 'Protein of unknown function (DUF3172)', 139, NULL, 'DUF3172', 261426),
(442333, 'PF08418', NULL, 'DNA polymerase alpha subunit B N-terminal', 235, NULL, 'Pol_alpha_B_N', 261427),
(442334, 'PF11961', NULL, 'Domain of unknown function (DUF3475)', 57, NULL, 'DUF3475', 261428),
(442335, 'PF09236', NULL, 'Alpha-haemoglobin stabilising protein', 87, NULL, 'AHSP', 261429),
(442336, 'PF17974', NULL, 'Galactose-binding domain-like', 190, NULL, 'GalBD_like', 261430),
(442337, 'PF19534', NULL, 'Family of unknown function (DUF6059)', 58, NULL, 'DUF6059', 261431),
(442338, 'PF09067', NULL, 'Erythropoietin receptor, ligand binding', 104, NULL, 'EpoR_lig-bind', 261432),
(442339, 'PF13656', NULL, 'RNA polymerase Rpb3/Rpb11 dimerisation domain', 75, NULL, 'RNA_pol_L_2', 261433),
(442340, 'PF12350', NULL, 'CTD kinase subunit gamma CTK3 C-terminus', 69, NULL, 'CTK3_C', 261434),
(442341, 'PF14532', NULL, 'Sigma-54 interaction domain', 138, NULL, 'Sigma54_activ_2', 261435),
(442342, 'PF15307', NULL, 'Sperm acrosome-associated protein 7', 107, NULL, 'SPACA7', 261436),
(442343, 'PF09685', NULL, 'Domain of unknown function (DUF4870)', 110, NULL, 'DUF4870', 261437),
(442344, 'PF09382', NULL, 'RQC domain', 114, NULL, 'RQC', 261438),
(442345, 'PF00285', NULL, 'Citrate synthase, C-terminal domain', 359, NULL, 'Citrate_synt', 261439),
(442346, 'PF02100', NULL, 'Ornithine decarboxylase antizyme', 114, NULL, 'ODC_AZ', 261440),
(442347, 'PF00844', NULL, 'Geminivirus coat protein/nuclear export factor BR1 family', 244, NULL, 'Gemini_coat', 261441),
(442348, 'PF15685', NULL, 'Gametogenetin', 661, NULL, 'GGN', 261442),
(442349, 'PF20096', NULL, 'Family of unknown function (DUF6486)', 31, NULL, 'DUF6486', 261443),
(442350, 'PF04116', NULL, 'Fatty acid hydroxylase', 133, NULL, 'FA_hydroxylase', 261444);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(442351, 'PF12448', NULL, 'Kinesin associated protein', 175, NULL, 'Milton', 261445),
(442352, 'PF15939', NULL, 'Putative antitoxin of bacterial toxin-antitoxin system', 76, NULL, 'YmcE_antitoxin', 261446),
(442353, 'PF13476', NULL, 'AAA domain', 200, NULL, 'AAA_23', 261447),
(442354, 'PF02950', NULL, 'Conotoxin', 75, NULL, 'Conotoxin', 261448),
(442355, 'PF12928', NULL, 'tRNA-splicing endonuclease subunit sen54 N-term', 71, NULL, 'tRNA_int_end_N2', 261449),
(442356, 'PF06022', NULL, 'Plasmodium variant antigen protein Cir/Yir/Bir', 258, NULL, 'Cir_Bir_Yir', 261450),
(442357, 'PF04073', NULL, 'Aminoacyl-tRNA editing domain', 123, NULL, 'tRNA_edit', 261451),
(442358, 'PF07383', NULL, 'Protein of unknown function (DUF1496)', 53, NULL, 'DUF1496', 261452),
(442359, 'PF03847', NULL, 'Transcription initiation factor TFIID subunit A', 68, NULL, 'TFIID_20kDa', 261453),
(442360, 'PF13573', NULL, 'SprB repeat', 37, NULL, 'SprB', 261454),
(442361, 'PF06738', NULL, 'Putative threonine/serine exporter', 241, NULL, 'ThrE', 261455),
(442362, 'PF12643', NULL, 'MazG-like family', 85, NULL, 'MazG-like', 261456),
(442363, 'PF09367', NULL, 'CpeS-like protein', 170, NULL, 'CpeS', 261457),
(442364, 'PF11981', NULL, 'Domain of unknown function (DUF3482)', 294, NULL, 'DUF3482', 261458),
(442365, 'PF20546', NULL, 'Family of unknown function (DUF6760)', 89, NULL, 'DUF6760', 261459),
(442366, 'PF13096', NULL, 'CENP-A-nucleosome distal (CAD) centromere subunit, CENP-P', 177, NULL, 'CENP-P', 261460),
(442367, 'PF19566', NULL, 'Sorting nexin 8/Mvp1 BAR domain', 258, NULL, 'Snx8_BAR_dom', 261461),
(442368, 'PF19575', NULL, 'Helix-turn-helix domain', 73, NULL, 'HTH_58', 261462),
(442369, 'PF00239', NULL, 'Resolvase, N terminal domain', 146, NULL, 'Resolvase', 261463),
(442370, 'PF06062', NULL, 'Uncharacterised protein family (UPF0231)', 121, NULL, 'UPF0231', 261464),
(442371, 'PF01348', NULL, 'Type II intron maturase', 140, NULL, 'Intron_maturas2', 261465),
(442372, 'PF01311', NULL, 'Bacterial export proteins, family 1', 230, NULL, 'Bac_export_1', 261466),
(442373, 'PF12548', NULL, 'Sulfatase protein', 147, NULL, 'DUF3740', 261467),
(442374, 'PF19999', NULL, 'FtsH ternary system domain X3', 85, NULL, 'fvmX3', 261468),
(442375, 'PF13238', NULL, 'AAA domain', 129, NULL, 'AAA_18', 261469),
(442376, 'PF15852', NULL, 'Domain of unknown function (DUF4724)', 93, NULL, 'DUF4724', 261470),
(442377, 'PF13894', NULL, 'C2H2-type zinc finger', 24, NULL, 'zf-C2H2_4', 261471),
(442378, 'PF05537', NULL, 'Borrelia burgdorferi protein of unknown function (DUF759)', 429, NULL, 'DUF759', 261472),
(442379, 'PF09893', NULL, 'Uncharacterized protein conserved in archaea (DUF2120)', 136, NULL, 'DUF2120', 261473),
(442380, 'PF12517', NULL, 'Protein of unknown function (DUF3720)', 99, NULL, 'DUF3720', 261474),
(442381, 'PF04894', NULL, 'Archaeal Nre, N-terminal', 270, NULL, 'Nre_N', 261475),
(442382, 'PF00613', NULL, 'Phosphoinositide 3-kinase family, accessory domain (PIK domain)', 185, NULL, 'PI3Ka', 261476),
(442383, 'PF02042', NULL, 'RWP-RK domain', 49, NULL, 'RWP-RK', 261477),
(442384, 'PF15179', NULL, 'Myc target protein 1', 193, NULL, 'Myc_target_1', 261478),
(442385, 'PF18765', NULL, 'Polymerase beta, Nucleotidyltransferase', 93, NULL, 'Polbeta', 261479),
(442386, 'PF14248', NULL, 'Domain of unknown function (DUF4345)', 119, NULL, 'DUF4345', 261480),
(442387, 'PF12840', NULL, 'Helix-turn-helix domain', 61, NULL, 'HTH_20', 261481),
(442388, 'PF04826', NULL, 'Armadillo-like', 221, NULL, 'Arm_2', 261482),
(442389, 'PF11885', NULL, 'Protein of unknown function (DUF3405)', 516, NULL, 'DUF3405', 261483),
(442390, 'PF12077', NULL, 'Transmembrane protein of unknown function (DUF3556)', 572, NULL, 'DUF3556', 261484),
(442391, 'PF15970', NULL, 'HicB_like antitoxin of bacterial toxin-antitoxin system', 81, NULL, 'HicB-like_2', 261485),
(442392, 'PF03723', NULL, 'Hemocyanin, ig-like domain', 248, NULL, 'Hemocyanin_C', 261486),
(442393, 'PF10672', NULL, 'S-adenosylmethionine-dependent methyltransferase', 286, NULL, 'Methyltrans_SAM', 261487),
(442394, 'PF20325', NULL, 'Family of unknown function (DUF6620)', 450, NULL, 'DUF6620', 261488);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(442395, 'PF13148', NULL, 'Protein of unknown function (DUF3987)', 366, NULL, 'DUF3987', 261489),
(442396, 'PF17496', NULL, 'Family of unknown function (DUF5431)', 70, NULL, 'DUF5431', 261490),
(442397, 'PF08446', NULL, 'PAS fold', 107, NULL, 'PAS_2', 261491),
(442398, 'PF18016', NULL, 'SAM domain (Sterile alpha motif)', 65, NULL, 'SAM_3', 261492),
(442399, 'PF15668', NULL, 'Domain of unknown function (DUF4663)', 339, NULL, 'DUF4663', 261493),
(442400, 'PF04025', NULL, 'Domain of unknown function (DUF370)', 73, NULL, 'DUF370', 261494),
(442401, 'PF05103', NULL, 'DivIVA protein', 131, NULL, 'DivIVA', 261495),
(442402, 'PF10066', NULL, 'Uncharacterized conserved protein (DUF2304)', 106, NULL, 'DUF2304', 261496),
(442403, 'PF17351', NULL, 'Family of unknown function (DUF5380)', 85, NULL, 'DUF5380', 261497),
(442404, 'PF06601', NULL, 'Orthopoxvirus F6 protein', 72, NULL, 'Orthopox_F6', 261498),
(442405, 'PF08213', NULL, 'Mitochondrial mRNA-processing protein COX24, C-terminal', 33, NULL, 'COX24_C', 261499),
(442406, 'PF08249', NULL, 'Mastoparan protein', 14, NULL, 'Mastoparan', 261500),
(442407, 'PF15210', NULL, 'Surfactant-associated protein 2', 59, NULL, 'SFTA2', 261501),
(442408, 'PF08188', NULL, 'Spermatozal protamine family', 48, NULL, 'Protamine_3', 261502),
(442409, 'PF08613', NULL, 'Cyclin', 161, NULL, 'Cyclin', 261503),
(442410, 'PF08001', NULL, 'CMV US', 251, NULL, 'CMV_US', 261504),
(442411, 'PF09811', NULL, 'Essential protein Yae1, N terminal', 39, NULL, 'Yae1_N', 261505),
(442412, 'PF03854', NULL, 'P-11 zinc finger', 50, NULL, 'zf-P11', 261506),
(442413, 'PF06777', NULL, 'Helical and beta-bridge domain', 190, NULL, 'HBB', 261507),
(442414, 'PF08453', NULL, 'Peptidase family M9 N-terminal', 183, NULL, 'Peptidase_M9_N', 261508),
(442415, 'PF16084', NULL, 'LydA-holin antagonist', 147, NULL, 'LydB', 261509),
(442416, 'PF14342', NULL, 'Domain of unknown function (DUF4396)', 141, NULL, 'DUF4396', 261510),
(442417, 'PF02834', NULL, 'LigT like Phosphoesterase', 87, NULL, 'LigT_PEase', 261511),
(442418, 'PF07470', NULL, 'Glycosyl Hydrolase Family 88', 353, NULL, 'Glyco_hydro_88', 261512),
(442419, 'PF12733', NULL, 'Cadherin-like beta sandwich domain', 93, NULL, 'Cadherin-like', 261513),
(442420, 'PF02929', NULL, 'Beta galactosidase small chain', 244, NULL, 'Bgal_small_N', 261514),
(442421, 'PF08133', NULL, 'Anticodon nuclease activator family', 26, NULL, 'Nuclease_act', 261515),
(442422, 'PF06211', NULL, 'BMP and activin membrane-bound inhibitor (BAMBI) N-terminal domain', 107, NULL, 'BAMBI', 261516),
(442423, 'PF05871', NULL, 'ESCRT-II complex subunit', 141, NULL, 'ESCRT-II', 261517),
(442424, 'PF11911', NULL, 'Protein of unknown function (DUF3429)', 145, NULL, 'DUF3429', 261518),
(442425, 'PF18031', NULL, 'Ubiquitin carboxyl-terminal hydrolases', 46, NULL, 'UCH_C', 261519),
(442426, 'PF06441', NULL, 'Epoxide hydrolase N terminus', 108, NULL, 'EHN', 261520),
(442427, 'PF14581', NULL, 'SseB protein C-terminal domain', 106, NULL, 'SseB_C', 261521),
(442428, 'PF15353', NULL, 'Headcase protein family homologue', 102, NULL, 'HECA', 261522),
(442429, 'PF07041', NULL, 'Protein of unknown function (DUF1327)', 113, NULL, 'DUF1327', 261523),
(442430, 'PF18772', NULL, 'APOBEC2', 174, NULL, 'APOBEC2', 261524),
(442431, 'PF06244', NULL, 'Coiled-coil domain-containing protein 124 /Oxs1', 82, NULL, 'Ccdc124', 261525),
(442432, 'PF19693', NULL, 'Phenol-soluble modulin delta protein', 22, NULL, 'PSMdelta', 261526),
(442433, 'PF12190', NULL, 'Fungal protease inhibitor', 91, NULL, 'amfpi-1', 261527),
(442434, 'PF16391', NULL, 'Domain of unknown function', 149, NULL, 'DUF5000', 261528),
(442435, 'PF04072', NULL, 'Leucine carboxyl methyltransferase', 188, NULL, 'LCM', 261529),
(442436, 'PF08045', NULL, 'Cell division control protein 14, SIN component', 286, NULL, 'CDC14', 261530),
(442437, 'PF13947', NULL, 'Wall-associated receptor kinase galacturonan-binding', 63, NULL, 'GUB_WAK_bind', 261531),
(442438, 'PF08114', NULL, 'ATPase proteolipid family', 43, NULL, 'PMP1_2', 261532),
(442439, 'PF09133', NULL, 'SANTA (SANT Associated)', 93, NULL, 'SANTA', 261533);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(442440, 'PF08717', NULL, 'Coronavirus replicase NSP8', 197, NULL, 'CoV_NSP8', 261534),
(442441, 'PF08787', NULL, 'Alginate lyase', 236, NULL, 'Alginate_lyase2', 261535),
(442442, 'PF12975', NULL, 'Domain of unknown function (DUF3859)', 133, NULL, 'DUF3859', 261536),
(442443, 'PF09918', NULL, 'Uncharacterized protein containing a ferredoxin domain (DUF2148)', 68, NULL, 'DUF2148', 261537),
(442444, 'PF12260', NULL, 'Protein-kinase domain of FAM69', 190, NULL, 'PIP49_C', 261538),
(442445, 'PF06859', NULL, 'Bicoid-interacting protein 3 (Bin3)', 108, NULL, 'Bin3', 261539),
(442446, 'PF04723', NULL, 'Glycine reductase complex selenoprotein A', 147, NULL, 'GRDA', 261540),
(442447, 'PF10538', NULL, 'Hantavirus ITAM motif', 38, NULL, 'ITAM_Cys-rich', 261541),
(442448, 'PF13091', NULL, 'PLD-like domain', 133, NULL, 'PLDc_2', 261542),
(442449, 'PF08964', NULL, 'Beta/Gamma crystallin', 86, NULL, 'Crystall_3', 261543),
(442450, 'PF05412', NULL, 'Equine arterivirus Nsp2-type cysteine proteinase', 108, NULL, 'Peptidase_C33', 261544),
(442451, 'PF09957', NULL, 'Bacterial antitoxin of type II TA system, VapB', 47, NULL, 'VapB_antitoxin', 261545),
(442452, 'PF15476', NULL, 'Histone deacetylase complex subunit SAP25', 202, NULL, 'SAP25', 261546),
(442453, 'PF04823', NULL, 'Herpesvirus UL49 tegument protein', 96, NULL, 'Herpes_UL49_2', 261547),
(442454, 'PF09743', NULL, 'E3 UFM1-protein ligase 1', 272, NULL, 'E3_UFM1_ligase', 261548),
(442455, 'PF03901', NULL, 'Alg9-like mannosyltransferase family', 417, NULL, 'Glyco_transf_22', 261549),
(442456, 'PF06692', NULL, 'Melon necrotic spot virus P7B protein', 61, NULL, 'MNSV_P7B', 261550),
(442457, 'PF12422', NULL, 'Condensin II non structural maintenance of chromosomes subunit', 149, NULL, 'Condensin2nSMC', 261551),
(442458, 'PF15502', NULL, 'M-phase-specific PLK1-interacting protein', 65, NULL, 'MPLKIP', 261552),
(442459, 'PF10599', NULL, 'Retro-transposon transporting motif', 86, NULL, 'Nup_retrotrp_bd', 261553),
(442460, 'PF13294', NULL, 'Domain of unknown function (DUF4075)', 79, NULL, 'DUF4075', 261554),
(442461, 'PF04285', NULL, 'Protein of unknown function (DUF444)', 421, NULL, 'DUF444', 261555),
(442462, 'PF08379', NULL, 'Bacterial transglutaminase-like N-terminal region', 80, NULL, 'Bact_transglu_N', 261556),
(442463, 'PF10242', NULL, 'Lipoma HMGIC fusion partner-like protein', 181, NULL, 'L_HMGIC_fpl', 261557),
(442464, 'PF11084', NULL, 'Protein of unknown function (DUF2621)', 139, NULL, 'DUF2621', 261558),
(442465, 'PF18530', NULL, 'Swi6 N-terminal domain', 108, NULL, 'Swi6_N', 261559),
(442466, 'PF05787', NULL, 'Bacterial protein of unknown function (DUF839)', 516, NULL, 'DUF839', 261560),
(442467, 'PF09678', NULL, 'Cytochrome c oxidase caa3 assembly factor (Caa3_CtaG)', 236, NULL, 'Caa3_CtaG', 261561),
(442468, 'PF10296', NULL, 'Maintenance of mitochondrial morphology protein 1', 332, NULL, 'MMM1', 261562),
(442469, 'PF02067', NULL, 'Metallothionein family 5', 41, NULL, 'Metallothio_5', 261563),
(442470, 'PF06025', NULL, 'Domain of Unknown Function (DUF913)', 384, NULL, 'DUF913', 261564),
(442471, 'PF00998', NULL, 'Viral RNA dependent RNA polymerase', 486, NULL, 'RdRP_3', 261565),
(442472, 'PF07347', NULL, 'NADH:ubiquinone oxidoreductase subunit B14.5a (Complex I-B14.5a)', 95, NULL, 'CI-B14_5a', 261566),
(442473, 'PF15678', NULL, 'Centriole duplication and mitotic chromosome congression', 412, NULL, 'SPICE', 261567),
(442474, 'PF16510', NULL, 'Phage P22-like portal protein', 668, NULL, 'P22_portal', 261568),
(442475, 'PF00184', NULL, 'Neurohypophysial hormones, C-terminal Domain', 79, NULL, 'Hormone_5', 261569),
(442476, 'PF02784', NULL, 'Pyridoxal-dependent decarboxylase, pyridoxal binding domain', 247, NULL, 'Orn_Arg_deC_N', 261570),
(442477, 'PF05029', NULL, 'Timeless PAB domain', 88, NULL, 'TIMELESS_C', 261571),
(442478, 'PF11100', NULL, 'Conjugal transfer protein TrbE', 66, NULL, 'TrbE', 261572),
(442479, 'PF06967', NULL, 'Mo-dependent nitrogenase C-terminus', 83, NULL, 'Mo-nitro_C', 261573),
(442480, 'PF14431', NULL, 'YwqJ-like deaminase', 134, NULL, 'YwqJ-deaminase', 261574);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(442481, 'PF01563', NULL, 'Alphavirus E3 glycoprotein', 59, NULL, 'Alpha_E3_glycop', 261575),
(442482, 'PF09587', NULL, 'Bacterial capsule synthesis protein PGA_cap', 257, NULL, 'PGA_cap', 261576),
(442483, 'PF10652', NULL, 'Protein of unknown function (DUF2480)', 165, NULL, 'DUF2480', 261577),
(442484, 'PF01529', NULL, 'DHHC palmitoyltransferase', 134, NULL, 'DHHC', 261578),
(442485, 'PF15608', NULL, 'PELOTA RNA binding domain', 81, NULL, 'PELOTA_1', 261579),
(442486, 'PF19353', NULL, 'Family of unknown function (DUF5930)', 320, NULL, 'DUF5930', 261580),
(442487, 'PF18496', NULL, 'Collagenase G catalytic helper subdomain', 117, NULL, 'ColG_sub', 261581),
(442488, 'PF04018', NULL, 'Domain of unknown function (DUF368)', 246, NULL, 'DUF368', 261582),
(442489, 'PF02874', NULL, 'ATP synthase alpha/beta family, beta-barrel domain', 69, NULL, 'ATP-synt_ab_N', 261583),
(442490, 'PF14118', NULL, 'YfzA-like protein', 90, NULL, 'YfzA', 261584),
(442491, 'PF08760', NULL, 'Domain of unknown function (DUF1793)', 166, NULL, 'DUF1793', 261585),
(442492, 'PF11747', NULL, 'Killing trait', 68, NULL, 'RebB', 261586),
(442493, 'PF01277', NULL, 'Oleosin', 113, NULL, 'Oleosin', 261587),
(442494, 'PF04104', NULL, 'Eukaryotic and archaeal DNA primase, large subunit', 266, NULL, 'DNA_primase_lrg', 261588),
(442495, 'PF06680', NULL, 'Protein of unknown function (DUF1181)', 120, NULL, 'DUF1181', 261589),
(442496, 'PF20508', NULL, 'Family of unknown function (DUF6734)', 288, NULL, 'DUF6734', 261590),
(442497, 'PF04387', NULL, 'Protein tyrosine phosphatase-like protein, PTPLA', 161, NULL, 'PTPLA', 261591),
(442498, 'PF04466', NULL, 'Phage terminase large subunit', 201, NULL, 'Terminase_3', 261592),
(442499, 'PF13286', NULL, 'Phosphohydrolase-associated domain', 91, NULL, 'HD_assoc', 261593),
(442500, 'PF15527', NULL, 'Bacterial toxin 22', 129, NULL, 'Ntox22', 261594),
(442501, 'PF09390', NULL, 'Protein of unknown function (DUF1999)', 159, NULL, 'DUF1999', 261595),
(442502, 'PF00231', NULL, 'ATP synthase', 276, NULL, 'ATP-synt', 261596),
(442503, 'PF12236', NULL, 'Bacteriophage head to tail connecting protein', 479, NULL, 'Head-tail_con', 261597),
(442504, 'PF00447', NULL, 'HSF-type DNA-binding', 98, NULL, 'HSF_DNA-bind', 261598),
(442505, 'PF00863', NULL, 'Peptidase family C4', 233, NULL, 'Peptidase_C4', 261599),
(442506, 'PF06034', NULL, 'Nucleopolyhedrovirus protein of unknown function (DUF919)', 62, NULL, 'DUF919', 261600),
(442507, 'PF02704', NULL, 'Gibberellin regulated protein', 60, NULL, 'GASA', 261601),
(442508, 'PF19774', NULL, 'Family of unknown function (DUF6260)', 303, NULL, 'DUF6260', 261602),
(442509, 'PF09909', NULL, 'Uncharacterized protein conserved in bacteria (DUF2138)', 555, NULL, 'DUF2138', 261603),
(442510, 'PF11734', NULL, 'TilS substrate C-terminal domain', 74, NULL, 'TilS_C', 261604),
(442511, 'PF13380', NULL, 'CoA binding domain', 116, NULL, 'CoA_binding_2', 261605),
(442512, 'PF14334', NULL, 'Domain of unknown function (DUF4390)', 161, NULL, 'DUF4390', 261606),
(442513, 'PF00638', NULL, 'RanBP1 domain', 122, NULL, 'Ran_BP1', 261607),
(442514, 'PF09134', NULL, 'Invasin, domain 3', 97, NULL, 'Invasin_D3', 261608),
(442515, 'PF00080', NULL, 'Copper/zinc superoxide dismutase (SODC)', 133, NULL, 'Sod_Cu', 261609),
(442516, 'PF09608', NULL, 'Putative transmembrane protein (Alph_Pro_TM)', 227, NULL, 'Alph_Pro_TM', 261610),
(442517, 'PF18073', NULL, 'Rubredoxin metal binding domain', 28, NULL, 'Rubredoxin_2', 261611),
(442518, 'PF05274', NULL, 'Occlusion-derived virus envelope protein E25', 190, NULL, 'Baculo_E25', 261612),
(442519, 'PF01043', NULL, 'SecA preprotein cross-linking domain', 110, NULL, 'SecA_PP_bind', 261613),
(442520, 'PF13109', NULL, 'AsmA-like C-terminal region', 214, NULL, 'AsmA_1', 261614),
(442521, 'PF07655', NULL, 'Secretin N-terminal domain', 95, NULL, 'Secretin_N_2', 261615),
(442522, 'PF03193', NULL, 'RsgA GTPase', 167, NULL, 'RsgA_GTPase', 261616),
(442523, 'PF05596', NULL, 'Taeniidae antigen', 64, NULL, 'Taeniidae_ag', 261617),
(442524, 'PF07951', NULL, 'Clostridium neurotoxin, C-terminal receptor binding', 210, NULL, 'Toxin_R_bind_C', 261618);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(442525, 'PF12704', NULL, 'MacB-like periplasmic core domain', 196, NULL, 'MacB_PCD', 261619),
(442526, 'PF09992', NULL, 'Phosphodiester glycosidase', 170, NULL, 'NAGPA', 261620),
(442527, 'PF02920', NULL, 'DNA binding domain of tn916 integrase', 58, NULL, 'Integrase_DNA', 261621),
(442528, 'PF12016', NULL, 'Stonin 2', 338, NULL, 'Stonin2_N', 261622),
(442529, 'PF14941', NULL, 'Transcriptional regulator, Out at first', 243, NULL, 'OAF', 261623),
(442530, 'PF09635', NULL, 'MetRS-N binding domain', 121, NULL, 'MetRS-N', 261624),
(442531, 'PF11345', NULL, 'Protein of unknown function (DUF3147)', 111, NULL, 'DUF3147', 261625),
(442532, 'PF08703', NULL, 'PLC-beta C terminal', 176, NULL, 'PLC-beta_C', 261626),
(442533, 'PF12470', NULL, 'Suppressor of Fused Gli/Ci N terminal binding domain', 215, NULL, 'SUFU_C', 261627),
(442534, 'PF15955', NULL, 'Cuticle protein', 81, NULL, 'Cuticle_4', 261628),
(442535, 'PF16536', NULL, 'PNKP adenylyltransferase domain, C-terminal region', 60, NULL, 'PNKP-ligase_C', 261629),
(442536, 'PF16645', NULL, 'Unstructured region on Pneumococcal histidine triad protein', 56, NULL, 'PHtD_u1', 261630),
(442537, 'PF14501', NULL, 'GHKL domain', 101, NULL, 'HATPase_c_5', 261631),
(442538, 'PF19603', NULL, 'Family of unknown function (DUF6108)', 138, NULL, 'DUF6108', 261632),
(442539, 'PF01201', NULL, 'Ribosomal protein S8e', 133, NULL, 'Ribosomal_S8e', 261633),
(442540, 'PF13012', NULL, 'Maintenance of mitochondrial structure and function', 112, NULL, 'MitMem_reg', 261634),
(442541, 'PF09279', NULL, 'Phosphoinositide-specific phospholipase C, efhand-like', 86, NULL, 'EF-hand_like', 261635),
(442542, 'PF03404', NULL, 'Mo-co oxidoreductase dimerisation domain', 138, NULL, 'Mo-co_dimer', 261636),
(442543, 'PF03406', NULL, 'Phage tail fibre repeat', 42, NULL, 'Phage_fiber_2', 261637),
(442544, 'PF13209', NULL, 'Protein of unknown function (DUF4017)', 60, NULL, 'DUF4017', 261638),
(442545, 'PF15729', NULL, 'Amyotrophic lateral sclerosis 2 candidate 11', 417, NULL, 'ALS2CR11', 261639),
(442546, 'PF19977', NULL, 'xRRM domain', 120, NULL, 'xRRM', 261640),
(442547, 'PF06723', NULL, 'MreB/Mbl protein', 327, NULL, 'MreB_Mbl', 261641),
(442548, 'PF12601', NULL, 'Rubivirus non-structural protein', 66, NULL, 'Rubi_NSP_C', 261642),
(442549, 'PF18816', NULL, 'Importin repeat', 52, NULL, 'Importin_rep_5', 261643),
(442550, 'PF11633', NULL, 'Betacoronavirus single-stranded poly(A) binding domain', 143, NULL, 'bCoV_SUD_M', 261644),
(442551, 'PF05778', NULL, 'Apolipoprotein CIII (Apo-CIII)', 69, NULL, 'Apo-CIII', 261645),
(442552, 'PF05993', NULL, 'Reovirus major virion structural protein Mu-1/Mu-1C (M2)', 647, NULL, 'Reovirus_M2', 261646),
(442553, 'PF01776', NULL, 'Ribosomal L22e protein family', 109, NULL, 'Ribosomal_L22e', 261647),
(442554, 'PF12693', NULL, 'GspL periplasmic domain', 158, NULL, 'GspL_C', 261648),
(442555, 'PF18937', NULL, 'Family of unknown function (DUF5685)', 273, NULL, 'DUF5685', 261649),
(442556, 'PF11482', NULL, 'Protein of unknown function (DUF3208)', 110, NULL, 'DUF3208', 261650),
(442557, 'PF13523', NULL, 'Acetyltransferase (GNAT) domain', 145, NULL, 'Acetyltransf_8', 261651),
(442558, 'PF20202', NULL, 'Domain of unknown function (DUF6564)', 230, NULL, 'DUF6564', 261652),
(442559, 'PF16884', NULL, 'N-terminal domain of oxidoreductase', 108, NULL, 'ADH_N_2', 261653),
(442560, 'PF06567', NULL, 'Neural chondroitin sulphate proteoglycan cytoplasmic domain', 120, NULL, 'Neural_ProG_Cyt', 261654),
(442561, 'PF18053', NULL, 'DNA gyrase B subunit insert domain', 167, NULL, 'GyrB_insert', 261655),
(442562, 'PF16861', NULL, 'Carbamoyltransferase C-terminus', 169, NULL, 'Carbam_trans_C', 261656),
(442563, 'PF17814', NULL, 'LisH-like dimerisation domain', 30, NULL, 'LisH_TPL', 261657),
(442564, 'PF00903', NULL, 'Glyoxalase/Bleomycin resistance protein/Dioxygenase superfamily', 128, NULL, 'Glyoxalase', 261658),
(442565, 'PF10139', NULL, 'Putative bacterial virulence factor', 877, NULL, 'Virul_Fac', 261659),
(442566, 'PF18064', NULL, 'Centromere-binding protein ParB C-terminal', 47, NULL, 'ParB_C', 261660);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(442567, 'PF06215', NULL, 'Infectious salmon anaemia virus haemagglutinin', 353, NULL, 'ISAV_HA', 261661),
(442568, 'PF15245', NULL, 'Transcription cofactor vestigial-like protein 4', 222, NULL, 'VGLL4', 261662),
(442569, 'PF13184', NULL, 'NusA-like KH domain', 69, NULL, 'KH_5', 261663),
(442570, 'PF20289', NULL, 'ABC-three component (ABC-3C) system Middle Component 1', 101, NULL, 'MComp1', 261664),
(442571, 'PF20306', NULL, 'Small protein found in certain Dnd DNA modification systems', 51, NULL, 'Sp-DndD', 261665),
(442572, 'PF09227', NULL, 'Bubble protein', 64, NULL, 'Bubble', 261666),
(442573, 'PF20088', NULL, 'Family of unknown function (DUF6480)', 78, NULL, 'DUF6480', 261667),
(442574, 'PF03979', NULL, 'Sigma-70 factor, region 1.1', 82, NULL, 'Sigma70_r1_1', 261668),
(442575, 'PF11995', NULL, 'Domain of unknown function (DUF3490)', 161, NULL, 'DUF3490', 261669),
(442576, 'PF17099', NULL, 'Tryptophan transporter TrpP', 169, NULL, 'TrpP', 261670),
(442577, 'PF20435', NULL, 'Meiosis-specific protein ASY3-like', 793, NULL, 'ASY3-like', 261671),
(442578, 'PF15863', NULL, 'Extended EGL-27 and MTA1 homology domain', 170, NULL, 'EELM2', 261672),
(442579, 'PF05108', NULL, 'Type VII secretion system ESX-1, transport TM domain B', 474, NULL, 'T7SS_ESX1_EccB', 261673),
(442580, 'PF10356', NULL, 'Protein of unknown function (DUF2034)', 185, NULL, 'DUF2034', 261674),
(442581, 'PF06350', NULL, 'Hormone-sensitive lipase (HSL) N-terminus', 306, NULL, 'HSL_N', 261675),
(442582, 'PF01780', NULL, 'Ribosomal L37ae protein family', 85, NULL, 'Ribosomal_L37ae', 261676),
(442583, 'PF17937', NULL, 'Tetracyclin repressor-like, C-terminal domain', 96, NULL, 'TetR_C_28', 261677),
(442584, 'PF04232', NULL, 'Stage V sporulation protein S (SpoVS)', 83, NULL, 'SpoVS', 261678),
(442585, 'PF16793', NULL, 'RepB DNA-primase from phage plasmid', 240, NULL, 'RepB_primase', 261679),
(442586, 'PF17324', NULL, 'BLOC-1 interactor 1', 111, NULL, 'BLI1', 261680),
(442587, 'PF09056', NULL, 'Prokaryotic phospholipase A2', 111, NULL, 'Phospholip_A2_3', 261681),
(442588, 'PF10623', NULL, 'Plasmid conjugative transfer protein PilI', 83, NULL, 'PilI', 261682),
(442589, 'PF06437', NULL, 'IMP-specific 5''-nucleotidase', 410, NULL, 'ISN1', 261683),
(442590, 'PF10430', NULL, 'Tie-2 Ig-like domain 1', 95, NULL, 'Ig_Tie2_1', 261684),
(442591, 'PF15873', NULL, 'Domain of unknown function (DUF4730)', 55, NULL, 'DUF4730', 261685),
(442592, 'PF12307', NULL, 'Protein of unknown function (DUF3631)', 184, NULL, 'DUF3631', 261686),
(442593, 'PF17297', NULL, 'Phosphoenolpyruvate carboxykinase N-terminal domain', 218, NULL, 'PEPCK_N', 261687),
(442594, 'PF20344', NULL, 'Family of unknown function (DUF6639)', 231, NULL, 'DUF6639', 261688),
(442595, 'PF11778', NULL, 'Septation initiation', 135, NULL, 'SID', 261689),
(442596, 'PF03290', NULL, 'Vaccinia virus I7 processing peptidase', 425, NULL, 'Peptidase_C57', 261690),
(442597, 'PF08125', NULL, 'Mannitol dehydrogenase C-terminal domain', 246, NULL, 'Mannitol_dh_C', 261691),
(442598, 'PF19498', NULL, 'Protein of unknown function (DUF6033)', 189, NULL, 'DUF6033', 261692),
(442599, 'PF03137', NULL, 'Organic Anion Transporter Polypeptide (OATP) family', 545, NULL, 'OATP', 261693),
(442600, 'PF17282', NULL, 'Family of unknown function (DUF5347)', 102, NULL, 'DUF5347', 261694),
(442601, 'PF12476', NULL, 'Protein of unknown function (DUF3696)', 53, NULL, 'DUF3696', 261695),
(442602, 'PF20121', NULL, 'Family of unknown function (DUF6511)', 69, NULL, 'DUF6511', 261696),
(442603, 'PF02167', NULL, 'Cytochrome C1 family', 219, NULL, 'Cytochrom_C1', 261697),
(442604, 'PF04456', NULL, 'Protein of unknown function (DUF503)', 88, NULL, 'DUF503', 261698),
(442605, 'PF07740', NULL, 'Ion channel inhibitory toxin', 30, NULL, 'Toxin_12', 261699),
(442606, 'PF20020', NULL, 'Domain of unknown function (DUF6431)', 83, NULL, 'DUF6431', 261700),
(442607, 'PF17515', NULL, 'Cypovirus polyhedrin', 241, NULL, 'CPV_Polyhedrin', 261701),
(442608, 'PF10893', NULL, 'Bacteriophage 186, Fil', 63, NULL, 'Phage_186_Fil', 261702),
(442609, 'PF06396', NULL, 'Angiotensin II, type I receptor-associated protein (AGTRAP)', 148, NULL, 'AGTRAP', 261703);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(442610, 'PF06608', NULL, 'Protein of unknown function (DUF1143)', 148, NULL, 'DUF1143', 261704),
(442611, 'PF12783', NULL, 'Guanine nucleotide exchange factor in Golgi transport N-terminal', 158, NULL, 'Sec7_N', 261705),
(442612, 'PF02566', NULL, 'OsmC-like protein', 100, NULL, 'OsmC', 261706),
(442613, 'PF10293', NULL, 'Domain of unknown function (DUF2405)', 153, NULL, 'DUF2405', 261707),
(442614, 'PF19424', NULL, 'Protein UNC80 central region', 707, NULL, 'UNC80', 261708),
(442615, 'PF07969', NULL, 'Amidohydrolase family', 473, NULL, 'Amidohydro_3', 261709),
(442616, 'PF07739', NULL, 'TipAS antibiotic-recognition domain', 117, NULL, 'TipAS', 261710),
(442617, 'PF03969', NULL, 'AFG1-like ATPase', 361, NULL, 'AFG1_ATPase', 261711),
(442618, 'PF02351', NULL, 'GDNF/GAS1 domain', 89, NULL, 'GDNF', 261712),
(442619, 'PF10025', NULL, 'Uncharacterized conserved protein (DUF2267)', 122, NULL, 'DUF2267', 261713),
(442620, 'PF02430', NULL, 'Apical membrane antigen 1', 477, NULL, 'AMA-1', 261714),
(442621, 'PF11748', NULL, 'Protein of unknown function (DUF3306)', 120, NULL, 'DUF3306', 261715),
(442622, 'PF14929', NULL, 'TAF RNA Polymerase I subunit A', 371, NULL, 'TAF1_subA', 261716),
(442623, 'PF17247', NULL, 'Family of unknown function (DUF5316)', 74, NULL, 'DUF5316', 261717),
(442624, 'PF19037', NULL, 'Second Longin domain of FUZ, MON1 and HPS1', 100, NULL, 'Fuz_longin_2', 261718),
(442625, 'PF18582', NULL, 'Hydrazine synthase alpha subunit middle domain', 102, NULL, 'HZS_alpha', 261719),
(442626, 'PF19544', NULL, 'Family of unknown function (DUF6068)', 392, NULL, 'DUF6068', 261720),
(442627, 'PF03317', NULL, 'ELF protein', 123, NULL, 'ELF', 261721),
(442628, 'PF16406', NULL, 'Domain of unknown function (DUF5014)', 90, NULL, 'DUF5014', 261722),
(442629, 'PF09158', NULL, 'Bacteriophage T4 MotA, C-terminal', 103, NULL, 'MotCF', 261723),
(442630, 'PF06305', NULL, 'Lipopolysaccharide assembly protein A domain', 64, NULL, 'LapA_dom', 261724),
(442631, 'PF13229', NULL, 'Right handed beta helix region', 158, NULL, 'Beta_helix', 261725),
(442632, 'PF19505', NULL, 'Family of unknown function (DUF6039)', 298, NULL, 'DUF6039', 261726),
(442633, 'PF09651', NULL, 'CRISPR-associated protein (Cas_APE2256)', 136, NULL, 'Cas_APE2256', 261727),
(442634, 'PF10839', NULL, 'Protein of unknown function (DUF2647)', 70, NULL, 'DUF2647', 261728),
(442635, 'PF01325', NULL, 'Iron dependent repressor, N-terminal DNA binding domain', 60, NULL, 'Fe_dep_repress', 261729),
(442636, 'PF12968', NULL, 'Domain of Unknown Function (DUF3856)', 143, NULL, 'DUF3856', 261730),
(442637, 'PF05002', NULL, 'SGS domain', 83, NULL, 'SGS', 261731),
(442638, 'PF06210', NULL, 'Protein of unknown function (DUF1003)', 104, NULL, 'DUF1003', 261732),
(442639, 'PF09850', NULL, 'Type VI secretion system protein DotU', 205, NULL, 'DotU', 261733),
(442640, 'PF12625', NULL, 'Arabinose-binding domain of AraC transcription regulator, N-term', 185, NULL, 'Arabinose_bd', 261734),
(442641, 'PF05971', NULL, 'RNA methyltransferase', 299, NULL, 'Methyltransf_10', 261735),
(442642, 'PF12486', NULL, 'Type VI secretion system, EvfB, or VasL', 147, NULL, 'VasL', 261736),
(442643, 'PF17438', NULL, 'Family of unknown function (DUF5417)', 91, NULL, 'DUF5417', 261737),
(442644, 'PF05384', NULL, 'Sensor protein DegS', 159, NULL, 'DegS', 261738),
(442645, 'PF11894', NULL, 'Nuclear pore complex scaffold, nucleoporins 186/192/205', 1695, NULL, 'Nup192', 261739),
(442646, 'PF17656', NULL, 'FlgA N-terminal domain', 77, NULL, 'ChapFlgA_N', 261740),
(442647, 'PF05181', NULL, 'XPA protein C-terminus', 51, NULL, 'XPA_C', 261741),
(442648, 'PF20226', NULL, 'Family of unknown function (DUF6585)', 249, NULL, 'DUF6585', 261742),
(442649, 'PF16175', NULL, 'Domain of unknown function (DUF4875)', 120, NULL, 'DUF4875', 261743),
(442650, 'PF02041', NULL, 'Auxin binding protein', 167, NULL, 'Auxin_BP', 261744),
(442651, 'PF13279', NULL, 'Thioesterase-like superfamily', 123, NULL, '4HBT_2', 261745),
(442652, 'PF00713', NULL, 'Hirudin', 64, NULL, 'Hirudin', 261746),
(442653, 'PF08048', NULL, 'Tap RepA1 leader peptide', 25, NULL, 'RepA1_leader', 261747);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(442654, 'PF18450', NULL, 'Zinc Finger domain', 28, NULL, 'zf_C2H2_6', 261748),
(442655, 'PF10821', NULL, 'Protein of unknown function (DUF2567)', 166, NULL, 'DUF2567', 261749),
(442656, 'PF09884', NULL, 'Uncharacterized protein conserved in archaea (DUF2111)', 83, NULL, 'DUF2111', 261750),
(442657, 'PF00821', NULL, 'Phosphoenolpyruvate carboxykinase C-terminal P-loop domain', 358, NULL, 'PEPCK_GTP', 261751),
(442658, 'PF09938', NULL, 'Uncharacterized protein conserved in bacteria (DUF2170)', 137, NULL, 'DUF2170', 261752),
(442659, 'PF17041', NULL, 'E domain', 48, NULL, 'SasG_E', 261753),
(442660, 'PF07299', NULL, 'Elongation factor G-binding protein, N-terminal', 83, NULL, 'EF-G-binding_N', 261754),
(442661, 'PF16628', NULL, 'Unstructured region on maltose acetyltransferase', 185, NULL, 'Mac_assoc', 261755),
(442662, 'PF19436', NULL, 'ACS/CODH beta subunit C-terminal', 245, NULL, 'ACS_CODH_B_C', 261756),
(442663, 'PF11931', NULL, 'SF3a60/Prp9 C-terminal', 121, NULL, 'SF3a60_Prp9_C', 261757),
(442664, 'PF16088', NULL, 'BLOC-1-related complex sub-unit 7', 103, NULL, 'BORCS7', 261758),
(442665, 'PF15387', NULL, 'Domain of unknown function (DUF4611)', 96, NULL, 'DUF4611', 261759),
(442666, 'PF14518', NULL, 'Iron-containing redox enzyme', 178, NULL, 'Haem_oxygenas_2', 261760),
(442667, 'PF16511', NULL, 'N-terminal or F0 domain of Talin-head FERM', 82, NULL, 'FERM_f0', 261761),
(442668, 'PF03724', NULL, 'META domain', 109, NULL, 'META', 261762),
(442669, 'PF09974', NULL, 'Uncharacterized protein conserved in archaea (DUF2209)', 121, NULL, 'DUF2209', 261763),
(442670, 'PF19636', NULL, 'Family of unknown function (DUF6139)', 77, NULL, 'DUF6139', 261764),
(442671, 'PF04313', NULL, 'Type I restriction enzyme R protein N terminus (HSDR_N)', 194, NULL, 'HSDR_N', 261765),
(442672, 'PF14263', NULL, 'Domain of unknown function (DUF4354)', 125, NULL, 'DUF4354', 261766),
(442673, 'PF14375', NULL, 'Cysteine-rich CWC', 50, NULL, 'Cys_rich_CWC', 261767),
(442674, 'PF03984', NULL, 'Repeat of unknown function (DUF346)', 39, NULL, 'DUF346', 261768),
(442675, 'PF17286', NULL, 'PRMT5 oligomerisation domain', 177, NULL, 'PRMT5_C', 261769),
(442676, 'PF00659', NULL, 'POLO box duplicated region', 61, NULL, 'POLO_box', 261770),
(442677, 'PF10998', NULL, 'Protein of unknown function (DUF2838)', 111, NULL, 'DUF2838', 261771),
(442678, 'PF02561', NULL, 'Flagellar protein FliS', 115, NULL, 'FliS', 261772),
(442679, 'PF02022', NULL, 'Integrase Zinc binding domain', 38, NULL, 'Integrase_Zn', 261773),
(442680, 'PF16899', NULL, 'Cyclin C-terminal domain', 107, NULL, 'Cyclin_C_2', 261774),
(442681, 'PF17265', NULL, 'Family of unknown function (DUF5331)', 113, NULL, 'DUF5331', 261775),
(442682, 'PF11975', NULL, 'Family 4 glycosyl hydrolase C-terminal domain', 211, NULL, 'Glyco_hydro_4C', 261776),
(442683, 'PF12163', NULL, 'DNA replication regulator', 180, NULL, 'HobA', 261777),
(442684, 'PF09965', NULL, 'Uncharacterized protein conserved in bacteria (DUF2199)', 146, NULL, 'DUF2199', 261778),
(442685, 'PF02631', NULL, 'RecX family', 122, NULL, 'RecX', 261779),
(442686, 'PF11831', NULL, 'pre-mRNA splicing factor component', 238, NULL, 'Myb_Cef', 261780),
(442687, 'PF18991', NULL, 'Family of unknown function (DUF5724)', 343, NULL, 'DUF5724', 261781),
(442688, 'PF00043', NULL, 'Glutathione S-transferase, C-terminal domain', 93, NULL, 'GST_C', 261782),
(442689, 'PF20562', NULL, 'Domain of unknown function (DUF6772)', 285, NULL, 'DUF6772', 261783),
(442690, 'PF11185', NULL, 'Protein of unknown function (DUF2971)', 83, NULL, 'DUF2971', 261784),
(442691, 'PF02681', NULL, 'Divergent PAP2 family', 126, NULL, 'DUF212', 261785),
(442692, 'PF18306', NULL, 'SLOG cluster4 family', 151, NULL, 'LDcluster4', 261786),
(442693, 'PF20468', NULL, 'Hermansky-Pudlak syndrome 6 protein C-terminal domain', 385, NULL, 'HPS6_C', 261787),
(442694, 'PF13022', NULL, 'Helix-turn-helix of insertion element transposase', 123, NULL, 'HTH_Tnp_1_2', 261788),
(442695, 'PF12952', NULL, 'Domain of unknown function (DUF3841)', 180, NULL, 'DUF3841', 261789),
(442696, 'PF20001', NULL, 'Family of unknown function (DUF6428)', 140, NULL, 'DUF6428', 261790);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(442697, 'PF19371', NULL, 'Family of unknown function (DUF5946)', 141, NULL, 'DUF5946', 261791),
(442698, 'PF01875', NULL, 'Memo-like protein', 271, NULL, 'Memo', 261792),
(442699, 'PF01413', NULL, 'C-terminal tandem repeated domain in type 4 procollagen', 111, NULL, 'C4', 261793),
(442700, 'PF05131', NULL, 'Pep3/Vps18/deep orange family', 151, NULL, 'Pep3_Vps18', 261794),
(442701, 'PF02302', NULL, 'PTS system, Lactose/Cellobiose specific IIB subunit', 90, NULL, 'PTS_IIB', 261795),
(442702, 'PF02673', NULL, 'Bacitracin resistance protein BacA', 256, NULL, 'BacA', 261796),
(442703, 'PF06403', NULL, 'Lamprin', 91, NULL, 'Lamprin', 261797),
(442704, 'PF10361', NULL, 'Protein of unknown function (DUF2434)', 294, NULL, 'DUF2434', 261798),
(442705, 'PF12829', NULL, 'Transcriptional regulation of mitochondrial recombination', 84, NULL, 'Mhr1', 261799),
(442706, 'PF01966', NULL, 'HD domain', 122, NULL, 'HD', 261800),
(442707, 'PF09704', NULL, 'CRISPR-associated protein (Cas_Cas5)', 216, NULL, 'Cas_Cas5d', 261801),
(442708, 'PF04006', NULL, 'Mpp10 protein', 523, NULL, 'Mpp10', 261802),
(442709, 'PF17294', NULL, 'Uncharacterised lipoprotein family', 166, NULL, 'Lipoprotein_22', 261803),
(442710, 'PF19311', NULL, 'KELAA motif', 32, NULL, 'KELAA', 261804),
(442711, 'PF16049', NULL, 'Frog antimicrobial peptide', 25, NULL, 'Antimicrobial24', 261805),
(442712, 'PF10775', NULL, 'ATP synthase complex subunit h', 69, NULL, 'ATP_sub_h', 261806),
(442713, 'PF00055', NULL, 'Laminin N-terminal (Domain VI)', 233, NULL, 'Laminin_N', 261807),
(442714, 'PF11064', NULL, 'Protein of unknown function (DUF2865)', 115, NULL, 'DUF2865', 261808),
(442715, 'PF19012', NULL, 'Family of unknown function (DUF5741)', 82, NULL, 'DUF5741', 261809),
(442716, 'PF04414', NULL, 'D-aminoacyl-tRNA deacylase', 206, NULL, 'tRNA_deacylase', 261810),
(442717, 'PF05171', NULL, 'Haemin-degrading HemS.ChuX domain', 128, NULL, 'HemS', 261811),
(442718, 'PF14508', NULL, 'Glycosyl-hydrolase 97 N-terminal', 233, NULL, 'GH97_N', 261812),
(442719, 'PF17661', NULL, 'Family of unknown function (DUF5523)', 255, NULL, 'DUF5523', 261813),
(442720, 'PF13726', NULL, 'Na+-H+ antiporter family', 88, NULL, 'Na_H_antiport_2', 261814),
(442721, 'PF13546', NULL, 'DDE superfamily endonuclease', 273, NULL, 'DDE_5', 261815),
(442722, 'PF06970', NULL, 'Replication initiator protein A (RepA) N-terminus', 76, NULL, 'RepA_N', 261816),
(442723, 'PF11918', NULL, 'N-terminal domain of Peptidase_S41 in eukaryotic IRBP', 129, NULL, 'Peptidase_S41_N', 261817),
(442724, 'PF02836', NULL, 'Glycosyl hydrolases family 2, TIM barrel domain', 302, NULL, 'Glyco_hydro_2_C', 261818),
(442725, 'PF04679', NULL, 'ATP dependent DNA ligase C terminal region', 99, NULL, 'DNA_ligase_A_C', 261819),
(442726, 'PF10684', NULL, 'Putative biofilm-dependent modulation protein', 71, NULL, 'BDM', 261820),
(442727, 'PF17704', NULL, 'Family of unknown function (DUF5550)', 123, NULL, 'DUF5550', 261821),
(442728, 'PF08693', NULL, 'SKG6 family', 666, NULL, 'SKG6', 261822),
(442729, 'PF03737', NULL, 'Aldolase/RraA', 150, NULL, 'RraA-like', 261823),
(442730, 'PF05266', NULL, 'Protein of unknown function (DUF724)', 188, NULL, 'DUF724', 261824),
(442731, 'PF05753', NULL, 'Translocon-associated protein beta (TRAPB)', 178, NULL, 'TRAP_beta', 261825),
(442732, 'PF20081', NULL, 'Domain of unknown function (DUF6475)', 90, NULL, 'DUF6475', 261826),
(442733, 'PF08817', NULL, 'WXG100 protein secretion system (Wss), protein YukD', 76, NULL, 'YukD', 261827),
(442734, 'PF08947', NULL, 'BPS (Between PH and SH2)', 48, NULL, 'BPS', 261828),
(442735, 'PF20178', NULL, 'Family of unknown function (DUF6543)', 585, NULL, 'DUF6543', 261829),
(442736, 'PF15931', NULL, 'Domain of unknown function (DUF4747)', 257, NULL, 'DUF4747', 261830),
(442737, 'PF18135', NULL, 'Type ISP C-terminal specificity domain', 344, NULL, 'Type_ISP_C', 261831),
(442738, 'PF08893', NULL, 'Domain of unknown function (DUF1839)', 312, NULL, 'DUF1839', 261832),
(442739, 'PF17633', NULL, 'Family of unknown function (DUF5514)', 142, NULL, 'DUF5514', 261833);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(442740, 'PF17448', NULL, 'Uncharacterized YqaH-like', 88, NULL, 'YqaH', 261834),
(442741, 'PF00926', NULL, '3,4-dihydroxy-2-butanone 4-phosphate synthase', 191, NULL, 'DHBP_synthase', 261835),
(442742, 'PF03512', NULL, 'Glycosyl hydrolase family 52', 414, NULL, 'Glyco_hydro_52', 261836),
(442743, 'PF08239', NULL, 'Bacterial SH3 domain', 55, NULL, 'SH3_3', 261837),
(442744, 'PF08318', NULL, 'COG4 transport protein', 345, NULL, 'COG4', 261838),
(442745, 'PF00707', NULL, 'Translation initiation factor IF-3, C-terminal domain', 86, NULL, 'IF3_C', 261839),
(442746, 'PF19878', NULL, 'Tannase-like family of unknown function (DUF6351)', 653, NULL, 'DUF6351', 261840),
(442747, 'PF19178', NULL, 'Family of unknown function (DUF5860)', 167, NULL, 'DUF5860', 261841),
(442748, 'PF01506', NULL, 'Hepatitis C virus non-structural 5a protein membrane anchor', 23, NULL, 'HCV_NS5a', 261842),
(442749, 'PF10671', NULL, 'Toxin co-regulated pilus biosynthesis protein Q', 80, NULL, 'TcpQ', 261843),
(442750, 'PF07956', NULL, 'Protein of Unknown function (DUF1690)', 139, NULL, 'DUF1690', 261844),
(442751, 'PF00458', NULL, 'WHEP-TRS domain', 53, NULL, 'WHEP-TRS', 261845),
(442752, 'PF08370', NULL, 'Plant PDR ABC transporter associated', 65, NULL, 'PDR_assoc', 261846),
(442753, 'PF14735', NULL, 'HAUS augmin-like complex subunit 4', 235, NULL, 'HAUS4', 261847),
(442754, 'PF14121', NULL, 'Putative porin', 600, NULL, 'Porin_10', 261848),
(442755, 'PF05414', NULL, 'Viral domain of unknown function (DUF1717)', 78, NULL, 'DUF1717', 261849),
(442756, 'PF13289', NULL, 'SIR2-like domain', 144, NULL, 'SIR2_2', 261850),
(442757, 'PF14173', NULL, 'ComG operon protein 7', 95, NULL, 'ComGG', 261851),
(442758, 'PF08004', NULL, 'Protein of unknown function (DUF1699)', 130, NULL, 'DUF1699', 261852),
(442759, 'PF05824', NULL, 'Pro-melanin-concentrating hormone (Pro-MCH)', 86, NULL, 'Pro-MCH', 261853),
(442760, 'PF07955', NULL, 'Protein of unknown function (DUF1687)', 128, NULL, 'DUF1687', 261854),
(442761, 'PF06361', NULL, 'Rice tungro bacilliform virus P12 protein', 110, NULL, 'RTBV_P12', 261855),
(442762, 'PF00278', NULL, 'Pyridoxal-dependent decarboxylase, C-terminal sheet domain', 95, NULL, 'Orn_DAP_Arg_deC', 261856),
(442763, 'PF19968', NULL, 'vWA-MoxR associated protein middle region (VMAP-M) 7', 160, NULL, 'VMAP-M7', 261857),
(442764, 'PF14842', NULL, 'FliG N-terminal domain', 104, NULL, 'FliG_N', 261858),
(442765, 'PF17928', NULL, 'Tetracyclin repressor-like, C-terminal domain', 113, NULL, 'TetR_C_22', 261859),
(442766, 'PF08484', NULL, 'C-methyltransferase C-terminal domain', 160, NULL, 'Methyltransf_14', 261860),
(442767, 'PF17035', NULL, 'Bromodomain extra-terminal - transcription regulation', 64, NULL, 'BET', 261861),
(442768, 'PF06105', NULL, 'Aph-1 protein', 231, NULL, 'Aph-1', 261862),
(442769, 'PF13797', NULL, 'Post-transcriptional regulator', 83, NULL, 'Post_transc_reg', 261863),
(442770, 'PF12914', NULL, 'SH3 domain of SH3b2 type', 47, NULL, 'SH3_7', 261864),
(442771, 'PF06106', NULL, 'S. aureus uracil DNA glycosylase inhibitor', 112, NULL, 'SAUGI', 261865),
(442772, 'PF10894', NULL, 'Protein of unknown function (DUF2689)', 57, NULL, 'DUF2689', 261866),
(442773, 'PF00882', NULL, 'Zinc dependent phospholipase C', 179, NULL, 'Zn_dep_PLPC', 261867),
(442774, 'PF13312', NULL, 'Domain of unknown function (DUF4081)', 105, NULL, 'DUF4081', 261868),
(442775, 'PF20415', NULL, 'Family of unknown function (DUF6699)', 133, NULL, 'DUF6699', 261869),
(442776, 'PF07845', NULL, 'Protein of unknown function (DUF1636)', 117, NULL, 'DUF1636', 261870),
(442777, 'PF06605', NULL, 'Prophage endopeptidase tail', 267, NULL, 'Prophage_tail', 261871),
(442778, 'PF20429', NULL, 'RNA-binding protein Tab2/Atab2, C terminal', 211, NULL, 'Tab2-like_C', 261872),
(442779, 'PF13470', NULL, 'PIN domain', 117, NULL, 'PIN_3', 261873),
(442780, 'PF09267', NULL, 'Dictyostelium STAT, coiled coil', 114, NULL, 'Dict-STAT-coil', 261874),
(442781, 'PF12591', NULL, 'Protein of unknown function (DUF3762)', 80, NULL, 'DUF3762', 261875),
(442782, 'PF15848', NULL, 'Odontogenesis associated phosphoprotein', 106, NULL, 'ODAPH', 261876);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(442783, 'PF18213', NULL, 'SUB1 protease Prodomain ProdP9', 80, NULL, 'SUB1_ProdP9', 261877),
(442784, 'PF16599', NULL, 'Unstructured linker region on PTN13 protein between PDZ', 191, NULL, 'PTN13_u3', 261878),
(442785, 'PF12766', NULL, 'Pyridoxamine 5''-phosphate oxidase', 100, NULL, 'Pyridox_oxase_2', 261879),
(442786, 'PF10970', NULL, 'Spore germination protein GerPE', 123, NULL, 'GerPE', 261880),
(442787, 'PF02927', NULL, 'Cellulase N-terminal ig-like domain', 86, NULL, 'CelD_N', 261881),
(442788, 'PF08175', NULL, 'Small acid-soluble spore protein O family', 50, NULL, 'SspO', 261882),
(442789, 'PF17795', NULL, 'Major Vault Protein Repeat domain', 62, NULL, 'Vault_3', 261883),
(442790, 'PF18341', NULL, 'PSA endolysin C-terminal cell wall binding domain', 61, NULL, 'PSA_CBD', 261884),
(442791, 'PF09078', NULL, 'CheY binding', 63, NULL, 'CheY-binding', 261885),
(442792, 'PF07425', NULL, 'Pardaxin', 33, NULL, 'Pardaxin', 261886),
(442793, 'PF15595', NULL, 'Immunity protein 51', 105, NULL, 'Imm51', 261887),
(442794, 'PF15799', NULL, 'Coiled-coil domain-containing protein 48', 578, NULL, 'CCD48', 261888),
(442795, 'PF19741', NULL, 'Family of unknown function (DUF6230)', 145, NULL, 'DUF6230', 261889),
(442796, 'PF13276', NULL, 'HTH-like domain', 60, NULL, 'HTH_21', 261890),
(442797, 'PF19241', NULL, 'Family of unknown function (DUF5891)', 198, NULL, 'DUF5891', 261891),
(442798, 'PF19831', NULL, 'Family of unknown function (DUF6312)', 98, NULL, 'DUF6312', 261892),
(442799, 'PF00413', NULL, 'Matrixin', 159, NULL, 'Peptidase_M10', 261893),
(442800, 'PF15063', NULL, 'Thyroid cancer protein 1', 75, NULL, 'TC1', 261894),
(442801, 'PF15099', NULL, 'Phosphoinositide-interacting protein family', 128, NULL, 'PIRT', 261895),
(442802, 'PF13073', NULL, 'Protein of unknown function (DUF3937)', 72, NULL, 'DUF3937', 261896),
(442803, 'PF03318', NULL, 'Clostridium epsilon toxin ETX/Bacillus mosquitocidal toxin MTX2', 228, NULL, 'ETX_MTX2', 261897),
(442804, 'PF05394', NULL, 'Avirulence protein', 326, NULL, 'AvrB_AvrC', 261898),
(442805, 'PF15998', NULL, 'Domain of unknown function (DUF4773)', 118, NULL, 'DUF4773', 261899),
(442806, 'PF20057', NULL, 'Domain of unknown function (DUF6456)', 128, NULL, 'DUF6456', 261900),
(442807, 'PF15278', NULL, 'Sec3 exocyst complex subunit', 86, NULL, 'Sec3_C_2', 261901),
(442808, 'PF15365', NULL, 'Proline-rich nuclear receptor coactivator motif', 20, NULL, 'PNRC', 261902),
(442809, 'PF13414', NULL, 'TPR repeat', 42, NULL, 'TPR_11', 261903),
(442810, 'PF16679', NULL, 'DNA replication factor Cdt1 C-terminal domain', 96, NULL, 'CDT1_C', 261904),
(442811, 'PF07195', NULL, 'Flagellar hook-associated protein 2 C-terminus', 240, NULL, 'FliD_C', 261905),
(442812, 'PF20425', NULL, 'Neurobeachin alpha solenoid region', 423, NULL, 'Neurobeachin', 261906),
(442813, 'PF02101', NULL, 'Ocular albinism type 1 protein', 403, NULL, 'Ocular_alb', 261907),
(442814, 'PF11878', NULL, 'Dedicator of cytokinesis C/D, N terminal', 112, NULL, 'DOCK_C-D_N', 261908),
(442815, 'PF15069', NULL, 'FAM163 family', 164, NULL, 'FAM163', 261909),
(442816, 'PF05196', NULL, 'PTN/MK heparin-binding protein family, N-terminal domain', 57, NULL, 'PTN_MK_N', 261910),
(442817, 'PF04093', NULL, 'rod shape-determining protein MreD', 160, NULL, 'MreD', 261911),
(442818, 'PF03390', NULL, '2-hydroxycarboxylate transporter family', 416, NULL, '2HCT', 261912),
(442819, 'PF08063', NULL, 'PADR1 (NUC008) domain', 53, NULL, 'PADR1', 261913),
(442820, 'PF06467', NULL, 'MYM-type Zinc finger with FCS sequence motif', 41, NULL, 'zf-FCS', 261914),
(442821, 'PF17018', NULL, 'Spore wall protein', 193, NULL, 'MICSWaP', 261915),
(442822, 'PF20401', NULL, 'Rhomboid-like protein', 194, NULL, 'Rhomboid_2', 261916),
(442823, 'PF00187', NULL, 'Chitin recognition protein', 38, NULL, 'Chitin_bind_1', 261917),
(442824, 'PF03831', NULL, 'PhnA domain', 69, NULL, 'YjdM', 261918),
(442825, 'PF13881', NULL, 'Ubiquitin-2 like Rad60 SUMO-like', 111, NULL, 'Rad60-SLD_2', 261919),
(442826, 'PF18768', NULL, 'RNPP family C-terminal domain', 213, NULL, 'RNPP_C', 261920);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(442827, 'PF13255', NULL, 'Protein of unknown function (DUF4046)', 90, NULL, 'DUF4046', 261921),
(442828, 'PF17233', NULL, 'Family of unknown function (DUF5308)', 165, NULL, 'DUF5308', 261922),
(442829, 'PF18248', NULL, 'RalF C-terminal Sec-7 capping domain', 147, NULL, 'RalF_SCD', 261923),
(442830, 'PF18222', NULL, 'PilN biogenesis protein dimerization domain', 102, NULL, 'PilN_bio_d', 261924),
(442831, 'PF20387', NULL, 'Family of unknown function (DUF6682)', 231, NULL, 'DUF6682', 261925),
(442832, 'PF16294', NULL, 'RNSP1-SAP18 binding (RSB) motif', 102, NULL, 'RSB_motif', 261926),
(442833, 'PF09100', NULL, 'Quinohemoprotein amine dehydrogenase, alpha subunit domain IV', 133, NULL, 'Qn_am_d_aIV', 261927),
(442834, 'PF16586', NULL, 'Domain of unknown function (DUF5060)', 70, NULL, 'DUF5060', 261928),
(442835, 'PF15060', NULL, 'Differentiation and proliferation regulator', 110, NULL, 'PPDFL', 261929),
(442836, 'PF04421', NULL, 'Mss4 protein', 94, NULL, 'Mss4', 261930),
(442837, 'PF19887', NULL, 'Family of unknown function (DUF6360)', 91, NULL, 'DUF6360', 261931),
(442838, 'PF12919', NULL, 'TcdA/TcdB catalytic glycosyltransferase domain', 407, NULL, 'TcdA_TcdB', 261932),
(442839, 'PF15371', NULL, 'Domain of unknown function (DUF4599)', 88, NULL, 'DUF4599', 261933),
(442840, 'PF05623', NULL, 'Protein of unknown function (DUF789)', 295, NULL, 'DUF789', 261934),
(442841, 'PF17927', NULL, 'Inositol 1,3,4-trisphosphate 5/6-kinase pre-ATP-grasp domain', 80, NULL, 'Ins134_P3_kin_N', 261935),
(442842, 'PF04222', NULL, 'Protein of unknown function (DUF416)', 188, NULL, 'DUF416', 261936),
(442843, 'PF05817', NULL, 'Oligosaccharyltransferase subunit Ribophorin II', 633, NULL, 'Ribophorin_II', 261937),
(442844, 'PF10508', NULL, 'Proteasome non-ATPase 26S subunit', 499, NULL, 'Proteasom_PSMB', 261938),
(442845, 'PF06491', NULL, 'Disulphide isomerase', 136, NULL, 'Disulph_isomer', 261939),
(442846, 'PF07765', NULL, 'KIP1-like protein', 74, NULL, 'KIP1', 261940),
(442847, 'PF11968', NULL, '25S rRNA (adenine(2142)-N(1))-methyltransferase, Bmt2', 220, NULL, 'Bmt2', 261941),
(442848, 'PF12225', NULL, 'Methylene-tetrahydrofolate reductase C terminal', 95, NULL, 'DUF5981', 261942),
(442849, 'PF05642', NULL, 'Sporozoite P67 surface antigen', 727, NULL, 'Sporozoite_P67', 261943),
(442850, 'PF02700', NULL, 'Phosphoribosylformylglycinamidine (FGAM) synthase', 77, NULL, 'PurS', 261944),
(442851, 'PF04646', NULL, 'Protein of unknown function, DUF604', 256, NULL, 'DUF604', 261945),
(442852, 'PF18725', NULL, 'SAV2148-like HEPN', 216, NULL, 'HEPN_SAV2148', 261946),
(442853, 'PF03816', NULL, 'LytR_cpsA_psr family', 152, NULL, 'LytR_cpsA_psr', 261947),
(442854, 'PF07312', NULL, 'Protein of unknown function (DUF1459)', 81, NULL, 'DUF1459', 261948),
(442855, 'PF08720', NULL, 'Influenza C hemagglutinin stalk', 175, NULL, 'Hema_stalk', 261949),
(442856, 'PF10338', NULL, 'Protein of unknown function (DUF2423)', 44, NULL, 'DUF2423', 261950),
(442857, 'PF17058', NULL, 'Mitochondrial biogenesis regulation protein 1', 230, NULL, 'MBR1', 261951),
(442858, 'PF18420', NULL, 'CSN4/RPN5/eIF3a helix turn helix domain', 42, NULL, 'CSN4_RPN5_eIF3a', 261952),
(442859, 'PF00621', NULL, 'RhoGEF domain', 183, NULL, 'RhoGEF', 261953),
(442860, 'PF20091', NULL, 'Alpha/beta hydrolase domain', 410, NULL, 'Abhydrolase_10', 261954),
(442861, 'PF18205', NULL, 'VPDSG-CTERM motif', 26, NULL, 'VPDSG-CTERM', 261955),
(442862, 'PF13923', NULL, 'Zinc finger, C3HC4 type (RING finger)', 40, NULL, 'zf-C3HC4_2', 261956),
(442863, 'PF12735', NULL, 'TRAPP trafficking subunit Trs65', 313, NULL, 'Trs65', 261957),
(442864, 'PF10543', NULL, 'ORF6N domain', 84, NULL, 'ORF6N', 261958),
(442865, 'PF14558', NULL, 'ML-like domain', 139, NULL, 'TRP_N', 261959),
(442866, 'PF18405', NULL, 'Mitochondrial SLC25 homolog', 285, NULL, 'SLC25_like', 261960),
(442867, 'PF02417', NULL, 'Chromate transporter', 157, NULL, 'Chromate_transp', 261961),
(442868, 'PF00952', NULL, 'Bunyavirus nucleocapsid (N) protein', 229, NULL, 'Bunya_nucleocap', 261962),
(442869, 'PF10040', NULL, 'CRISPR-associated endoribonuclease Cas6', 86, NULL, 'CRISPR_Cas6', 261963);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(442870, 'PF03705', NULL, 'CheR methyltransferase, all-alpha domain', 53, NULL, 'CheR_N', 261964),
(442871, 'PF15588', NULL, 'Immunity protein 10', 106, NULL, 'Imm10', 261965),
(442872, 'PF10759', NULL, 'Bacterial proteasome activator', 160, NULL, 'BPA', 261966),
(442873, 'PF10945', NULL, 'Cellulose biosynthesis protein BcsR', 42, NULL, 'CBP_BcsR', 261967),
(442874, 'PF15157', NULL, 'Fusion protein IQCJ-SCHIP1 with IQ-like motif', 155, NULL, 'IQCJ-SCHIP1', 261968),
(442875, 'PF08524', NULL, 'rRNA processing', 146, NULL, 'rRNA_processing', 261969),
(442876, 'PF02472', NULL, 'Biopolymer transport protein ExbD/TolR', 130, NULL, 'ExbD', 261970),
(442877, 'PF08352', NULL, 'Oligopeptide/dipeptide transporter, C-terminal region', 65, NULL, 'oligo_HPY', 261971),
(442878, 'PF16892', NULL, 'Chitin biosynthesis protein CHS5 N-terminus', 48, NULL, 'CHS5_N', 261972),
(442879, 'PF17688', NULL, 'Family of unknown function (DUF5536)', 214, NULL, 'DUF5536', 261973),
(442880, 'PF10488', NULL, 'Phosphatase-1 catalytic subunit binding region', 287, NULL, 'PP1c_bdg', 261974),
(442881, 'PF07860', NULL, 'WisP family C-Terminal Region', 130, NULL, 'CCD', 261975),
(442882, 'PF09849', NULL, 'Uncharacterized protein conserved in bacteria (DUF2076)', 262, NULL, 'DUF2076', 261976),
(442883, 'PF14710', NULL, 'Respiratory nitrate reductase alpha N-terminal', 38, NULL, 'Nitr_red_alph_N', 261977),
(442884, 'PF09583', NULL, 'Phage shock protein G (Phageshock_PspG)', 64, NULL, 'Phageshock_PspG', 261978),
(442885, 'PF01946', NULL, 'Thi4 family', 235, NULL, 'Thi4', 261979),
(442886, 'PF16918', NULL, 'Protein kinase G tetratricopeptide repeat', 340, NULL, 'PknG_TPR', 261980),
(442887, 'PF07938', NULL, 'Fungal fucose-specific lectin', 299, NULL, 'Fungal_lectin', 261981),
(442888, 'PF02571', NULL, 'Precorrin-6x reductase CbiJ/CobK', 233, NULL, 'CbiJ', 261982),
(442889, 'PF15191', NULL, 'Synaptonemal complex central element protein 3', 90, NULL, 'Synaptonemal_3', 261983),
(442890, 'PF00416', NULL, 'Ribosomal protein S13/S18', 128, NULL, 'Ribosomal_S13', 261984),
(442891, 'PF02711', NULL, 'E4 protein', 96, NULL, 'Pap_E4', 261985),
(442892, 'PF17576', NULL, 'Family of unknown function (DUF5480)', 71, NULL, 'DUF5480', 261986),
(442893, 'PF20462', NULL, 'Domain of unknown function (DUF6715)', 192, NULL, 'DUF6715', 261987),
(442894, 'PF07309', NULL, 'Flagellar protein FlaF', 113, NULL, 'FlaF', 261988),
(442895, 'PF08178', NULL, 'GnsA/GnsB toxin of bacterial toxin-antitoxin system', 54, NULL, 'GnsAB_toxin', 261989),
(442896, 'PF11869', NULL, 'Protein of unknown function (DUF3389)', 75, NULL, 'DUF3389', 261990),
(442897, 'PF15944', NULL, 'Domain of unknown function (DUF4752)', 84, NULL, 'DUF4752', 261991),
(442898, 'PF05057', NULL, 'Putative serine esterase (DUF676)', 219, NULL, 'DUF676', 261992),
(442899, 'PF05269', NULL, 'Bacteriophage CII protein', 91, NULL, 'Phage_CII', 261993),
(442900, 'PF17306', NULL, 'Family of unknown function (DUF5355)', 332, NULL, 'DUF5355', 261994),
(442901, 'PF05805', NULL, 'L6 membrane protein', 194, NULL, 'L6_membrane', 261995),
(442902, 'PF07754', NULL, 'Small zinc finger protein HVO_2753-like, Zn-binding pocket', 46, NULL, 'HVO_2753_ZBP', 261996),
(442903, 'PF19628', NULL, 'Family of unknown function (DUF6132)', 60, NULL, 'DUF6132', 261997),
(442904, 'PF00860', NULL, 'Permease family', 389, NULL, 'Xan_ur_permease', 261998),
(442905, 'PF17605', NULL, 'Family of unknown function (DUF5501)', 107, NULL, 'DUF5501', 261999),
(442906, 'PF08074', NULL, 'CHDCT2 (NUC038) domain', 146, NULL, 'CHDCT2', 262000),
(442907, 'PF03016', NULL, 'Exostosin family', 300, NULL, 'Exostosin', 262001),
(442908, 'PF02355', NULL, 'Protein export membrane protein', 189, NULL, 'SecD_SecF', 262002),
(442909, 'PF07676', NULL, 'WD40-like Beta Propeller Repeat', 38, NULL, 'PD40', 262003),
(442910, 'PF14215', NULL, 'bHLH-MYC and R2R3-MYB transcription factors N-terminal', 177, NULL, 'bHLH-MYC_N', 262004),
(442911, 'PF12229', NULL, 'Putative peptidoglycan binding domain', 116, NULL, 'PG_binding_4', 262005),
(442912, 'PF10335', NULL, 'Putative nucleotidyltransferase substrate binding domain', 145, NULL, 'DUF294_C', 262006);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(442913, 'PF17115', NULL, 'N-terminal domain of toast_rack, DUF2154', 92, NULL, 'Toast_rack_N', 262007),
(442914, 'PF05511', NULL, 'Mitochondrial ATP synthase coupling factor 6', 97, NULL, 'ATP-synt_F6', 262008),
(442915, 'PF19003', NULL, 'Family of unknown function (DUF5732)', 85, NULL, 'DUF5732', 262009),
(442916, 'PF14437', NULL, 'MafB19-like deaminase', 138, NULL, 'MafB19-deam', 262010),
(442917, 'PF05207', NULL, 'CSL zinc finger', 59, NULL, 'zf-CSL', 262011),
(442918, 'PF20209', NULL, 'Domain of unknown function (DUF6570)', 134, NULL, 'DUF6570', 262012),
(442919, 'PF03691', NULL, 'Uncharacterised protein family (UPF0167)', 176, NULL, 'UPF0167', 262013),
(442920, 'PF03097', NULL, 'BRO1-like domain', 386, NULL, 'BRO1', 262014),
(442921, 'PF00368', NULL, 'Hydroxymethylglutaryl-coenzyme A reductase', 367, NULL, 'HMG-CoA_red', 262015),
(442922, 'PF16362', NULL, 'YaiA protein', 63, NULL, 'YaiA', 262016),
(442923, 'PF13168', NULL, 'Poxvirus B22R protein C-terminal', 195, NULL, 'Poxvirus_B22R_C', 262017),
(442924, 'PF16022', NULL, 'Domain of unknown function (DUF4783)', 102, NULL, 'DUF4783', 262018),
(442925, 'PF12074', NULL, 'Generalcontrol nonderepressible 1 (Gcn1) N-terminal', 358, NULL, 'Gcn1_N', 262019),
(442926, 'PF02470', NULL, 'MlaD protein', 81, NULL, 'MlaD', 262020),
(442927, 'PF03479', NULL, 'Plants and Prokaryotes Conserved (PCC) domain', 110, NULL, 'PCC', 262021),
(442928, 'PF12525', NULL, 'Protein of unknown function (DUF3726)', 73, NULL, 'DUF3726', 262022),
(442929, 'PF16533', NULL, 'STIM1 Orai1-activating region', 101, NULL, 'SOAR', 262023),
(442930, 'PF20500', NULL, 'DNA-PKcs, N-terminal', 810, NULL, 'DNA-PKcs_N', 262024),
(442931, 'PF05425', NULL, 'Copper resistance protein D', 105, NULL, 'CopD', 262025),
(442932, 'PF09512', NULL, 'Thiamine-precursor transporter protein (ThiW)', 150, NULL, 'ThiW', 262026),
(442933, 'PF11557', NULL, 'Solitary outer membrane autotransporter beta-barrel domain', 327, NULL, 'Omp_AT', 262027),
(442934, 'PF13976', NULL, 'GAG-pre-integrase domain', 67, NULL, 'gag_pre-integrs', 262028),
(442935, 'PF01241', NULL, 'Photosystem I psaG / psaK', 70, NULL, 'PSI_PSAK', 262029),
(442936, 'PF12002', NULL, 'MgsA AAA+ ATPase C terminal', 167, NULL, 'MgsA_C', 262030),
(442937, 'PF09928', NULL, 'Predicted small integral membrane protein (DUF2160)', 88, NULL, 'DUF2160', 262031),
(442938, 'PF15472', NULL, 'Domain of unknown function (DUF4638)', 262, NULL, 'DUF4638', 262032),
(442939, 'PF17086', NULL, 'Small capsid protein of Herpesviridae', 77, NULL, 'HV_small_capsid', 262033),
(442940, 'PF15378', NULL, 'Domain of unknown function (DUF4605)', 59, NULL, 'DUF4605', 262034),
(442941, 'PF10501', NULL, 'Ribosomal subunit 39S', 110, NULL, 'Ribosomal_L50', 262035),
(442942, 'PF11012', NULL, 'Protein of unknown function (DUF2850)', 79, NULL, 'DUF2850', 262036),
(442943, 'PF04083', NULL, 'Partial alpha/beta-hydrolase lipase region', 64, NULL, 'Abhydro_lipase', 262037),
(442944, 'PF02330', NULL, 'Mitochondrial glycoprotein', 212, NULL, 'MAM33', 262038),
(442945, 'PF06575', NULL, 'Protein of unknown function (DUF1132)', 94, NULL, 'DUF1132', 262039),
(442946, 'PF04854', NULL, 'Protein of unknown function, DUF624', 77, NULL, 'DUF624', 262040),
(442947, 'PF03378', NULL, 'CAS/CSE protein, C-terminus', 443, NULL, 'CAS_CSE1', 262041),
(442948, 'PF15030', NULL, 'Protein of unknown function (DUF4527)', 277, NULL, 'DUF4527', 262042),
(442949, 'PF01369', NULL, 'Sec7 domain', 183, NULL, 'Sec7', 262043),
(442950, 'PF10887', NULL, 'Protein of unknown function (DUF2686)', 276, NULL, 'DUF2686', 262044),
(442951, 'PF13115', NULL, 'YtkA-like', 86, NULL, 'YtkA', 262045),
(442952, 'PF19957', NULL, 'Effector-associated domain 5', 135, NULL, 'EAD5', 262046),
(442953, 'PF19324', NULL, 'LETM1 domain-containing protein LETM2 N-terminus', 111, NULL, 'LETM2_N', 262047),
(442954, 'PF17743', NULL, 'Family of unknown function (DUF5580)', 547, NULL, 'DUF5580', 262048),
(442955, 'PF18490', NULL, 'tRNA-binding domain', 162, NULL, 'tRNA_bind_4', 262049),
(442956, 'PF09028', NULL, 'Mac 1', 353, NULL, 'Mac-1', 262050); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(442957, 'PF11381', NULL, 'Protein of unknown function (DUF3185)', 59, NULL, 'DUF3185', 262051),
(442958, 'PF07546', NULL, 'EMI domain', 68, NULL, 'EMI', 262052),
(442959, 'PF00354', NULL, 'Pentaxin family', 194, NULL, 'Pentaxin', 262053),
(442960, 'PF04607', NULL, 'Region found in RelA / SpoT proteins', 117, NULL, 'RelA_SpoT', 262054),
(442961, 'PF03614', NULL, 'Repressor of phase-1 flagellin', 167, NULL, 'Flag1_repress', 262055),
(442962, 'PF18423', NULL, 'Zinc binding domain', 62, NULL, 'zf_CopZ', 262056),
(442963, 'PF18693', NULL, 'TRAM domain', 62, NULL, 'TRAM_2', 262057),
(442964, 'PF19525', NULL, 'Ets1 N-terminal flanking region of Ets domain', 188, NULL, 'Ets1_N_flank', 262058),
(442965, 'PF11837', NULL, 'Beta-fructofuranosidase, N-terminal domain', 109, NULL, 'INV_N', 262059),
(442966, 'PF15542', NULL, 'Bacterial toxin 50', 93, NULL, 'Ntox50', 262060),
(442967, 'PF05257', NULL, 'CHAP domain', 83, NULL, 'CHAP', 262061),
(442968, 'PF10223', NULL, 'Uncharacterized conserved protein (DUF2181)', 241, NULL, 'DUF2181', 262062),
(442969, 'PF17132', NULL, 'alpha-L-rhamnosidase', 742, NULL, 'Glyco_hydro_106', 262063),
(442970, 'PF10768', NULL, 'Class II flagellar assembly regulator', 135, NULL, 'FliX', 262064),
(442971, 'PF10236', NULL, 'Mitochondrial ribosomal death-associated protein 3', 311, NULL, 'DAP3', 262065),
(442972, 'PF18854', NULL, 'Bacterial archaeo-eukaryotic release factor family 10', 143, NULL, 'baeRF_family10', 262066),
(442973, 'PF07368', NULL, 'Protein of unknown function (DUF1487)', 215, NULL, 'DUF1487', 262067),
(442974, 'PF09401', NULL, 'Coronavirus RNA synthesis protein NSP10', 122, NULL, 'CoV_NSP10', 262068),
(442975, 'PF18453', NULL, 'Oligomerization domain of C4b-binding protein alpha', 49, NULL, 'C4bp_oligo', 262069),
(442976, 'PF19319', NULL, 'Domain of unknown function (DUF5919)', 161, NULL, 'DUF5919', 262070),
(442977, 'PF20022', NULL, 'vWA-MoxR associated protein middle region 19', 115, NULL, 'VMAP-M19', 262071),
(442978, 'PF00117', NULL, 'Glutamine amidotransferase class-I', 191, NULL, 'GATase', 262072),
(442979, 'PF04186', NULL, 'FxsA cytoplasmic membrane protein', 109, NULL, 'FxsA', 262073),
(442980, 'PF11427', NULL, 'Tc3 transposase', 50, NULL, 'HTH_Tnp_Tc3_1', 262074),
(442981, 'PF18626', NULL, 'Glutaminase', 106, NULL, 'Gln_deamidase_2', 262075),
(442982, 'PF09491', NULL, 'AlwI restriction endonuclease', 451, NULL, 'RE_AlwI', 262076),
(442983, 'PF04177', NULL, 'TAP42-like family', 349, NULL, 'TAP42', 262077),
(442984, 'PF05392', NULL, 'Cytochrome C oxidase chain VIIB', 79, NULL, 'COX7B', 262078),
(442985, 'PF08991', NULL, 'Mature-T-Cell Proliferation I type', 62, NULL, 'MTCP1', 262079),
(442986, 'PF18778', NULL, 'Novel AID APOBEC clade 1', 174, NULL, 'NAD1', 262080),
(442987, 'PF19447', NULL, 'Family of unknown function (DUF5985)', 89, NULL, 'DUF5985', 262081),
(442988, 'PF13496', NULL, 'Domain of unknown function (DUF4120)', 96, NULL, 'DUF4120', 262082),
(442989, 'PF00531', NULL, 'Death domain', 86, NULL, 'Death', 262083),
(442990, 'PF04725', NULL, 'Photosystem II 10 kDa polypeptide PsbR', 98, NULL, 'PsbR', 262084),
(442991, 'PF08295', NULL, 'Sin3 family co-repressor', 98, NULL, 'Sin3_corepress', 262085),
(442992, 'PF04281', NULL, 'Mitochondrial import receptor subunit Tom22', 139, NULL, 'Tom22', 262086),
(442993, 'PF13528', NULL, 'Glycosyl transferase family 1', 322, NULL, 'Glyco_trans_1_3', 262087),
(442994, 'PF04493', NULL, 'Endonuclease V', 197, NULL, 'Endonuclease_5', 262088),
(442995, 'PF05870', NULL, 'Phenolic acid decarboxylase (PAD)', 158, NULL, 'PA_decarbox', 262089),
(442996, 'PF06377', NULL, 'Adipokinetic hormone', 51, NULL, 'Adipokin_hormo', 262090),
(442997, 'PF13570', NULL, 'PQQ-like domain', 40, NULL, 'PQQ_3', 262091),
(442998, 'PF17101', NULL, 'Stealth protein CR1, conserved region 1', 29, NULL, 'Stealth_CR1', 262092),
(442999, 'PF06934', NULL, 'Fatty acid cis/trans isomerase (CTI)', 692, NULL, 'CTI', 262093),
(443000, 'PF06556', NULL, 'IAP-like protein p27 C-terminus', 131, NULL, 'ASFV_p27', 262094),
(443001, 'PF04902', NULL, 'Conserved region in Nab1', 179, NULL, 'Nab1', 262095);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(443002, 'PF15789', NULL, 'Hyphally regulated cell wall GPI-anchored protein 1', 41, NULL, 'Hyr1', 262096),
(443003, 'PF01805', NULL, 'Surp module', 53, NULL, 'Surp', 262097),
(443004, 'PF05546', NULL, 'She9 / Mdm33 family', 198, NULL, 'She9_MDM33', 262098),
(443005, 'PF07001', NULL, 'BAT2 N-terminus', 191, NULL, 'BAT2_N', 262099),
(443006, 'PF10318', NULL, 'Serpentine type 7TM GPCR chemoreceptor Srh', 302, NULL, '7TM_GPCR_Srh', 262100),
(443007, 'PF15960', NULL, 'Domain of unknown function (DUF4763)', 244, NULL, 'DUF4763', 262101),
(443008, 'PF19306', NULL, 'Helicase Lhr winged helix domain', 147, NULL, 'Lhr_WH', 262102),
(443009, 'PF12030', NULL, 'Domain of unknown function (DUF3517)', 406, NULL, 'DUF3517', 262103),
(443010, 'PF00617', NULL, 'RasGEF domain', 179, NULL, 'RasGEF', 262104),
(443011, 'PF06793', NULL, 'Uncharacterised protein family (UPF0262)', 153, NULL, 'UPF0262', 262105),
(443012, 'PF02255', NULL, 'PTS system, Lactose/Cellobiose specific IIA subunit', 94, NULL, 'PTS_IIA', 262106),
(443013, 'PF11721', NULL, 'Malectin domain', 165, NULL, 'Malectin', 262107),
(443014, 'PF01255', NULL, 'Putative undecaprenyl diphosphate synthase', 221, NULL, 'Prenyltransf', 262108),
(443015, 'PF03812', NULL, '2-keto-3-deoxygluconate permease', 305, NULL, 'KdgT', 262109),
(443016, 'PF09610', NULL, 'Mycoplasma virulence signal region (Myco_arth_vir_N)', 32, NULL, 'Myco_arth_vir_N', 262110),
(443017, 'PF14159', NULL, 'CAAD domains of cyanobacterial aminoacyl-tRNA synthetase', 85, NULL, 'CAAD', 262111),
(443018, 'PF18447', NULL, 'Fibronectin type III domain', 97, NULL, 'FN3_7', 262112),
(443019, 'PF06439', NULL, '3-keto-disaccharide hydrolase', 185, NULL, '3keto-disac_hyd', 262113),
(443020, 'PF00738', NULL, 'Polyhedrin', 232, NULL, 'Polyhedrin', 262114),
(443021, 'PF12054', NULL, 'Domain of unknown function (DUF3535)', 441, NULL, 'DUF3535', 262115),
(443022, 'PF06075', NULL, 'Plant protein of unknown function (DUF936)', 699, NULL, 'DUF936', 262116),
(443023, 'PF06334', NULL, 'Orthopoxvirus A47 protein', 244, NULL, 'Orthopox_A47', 262117),
(443024, 'PF08708', NULL, 'Primase C terminal 1 (PriCT-1)', 67, NULL, 'PriCT_1', 262118),
(443025, 'PF11576', NULL, 'FeGP cofactor biosynthesis protein HcgB, guanylyltransferase', 153, NULL, 'HcgB', 262119),
(443026, 'PF15432', NULL, 'Accessory Sec secretory system ASP3', 126, NULL, 'Sec-ASP3', 262120),
(443027, 'PF04366', NULL, 'Las17-binding protein actin regulator', 128, NULL, 'Ysc84', 262121),
(443028, 'PF08701', NULL, 'GNL3L/Grn1 putative GTPase', 77, NULL, 'GN3L_Grn1', 262122),
(443029, 'PF11056', NULL, 'Recombination, repair and ssDNA binding protein UvsY', 128, NULL, 'UvsY', 262123),
(443030, 'PF10703', NULL, 'MoaF N-terminal domain', 108, NULL, 'MoaF', 262124),
(443031, 'PF10512', NULL, 'Cell division cycle-associated protein 8', 120, NULL, 'Borealin', 262125),
(443032, 'PF08844', NULL, 'Domain of unknown function (DUF1815)', 101, NULL, 'DUF1815', 262126),
(443033, 'PF06714', NULL, 'Gp5 N-terminal OB domain', 144, NULL, 'Gp5_OB', 262127),
(443034, 'PF05762', NULL, 'VWA domain containing CoxE-like protein', 221, NULL, 'VWA_CoxE', 262128),
(443035, 'PF16361', NULL, 'N-terminal of Subtilase family', 142, NULL, 'Peptidase_S8_N', 262129),
(443036, 'PF13690', NULL, 'Chemotaxis phosphatase CheX', 94, NULL, 'CheX', 262130),
(443037, 'PF03269', NULL, 'Caenorhabditis protein of unknown function, DUF268', 176, NULL, 'DUF268', 262131),
(443038, 'PF17131', NULL, 'Outer membrane lipoprotein-sorting protein', 184, NULL, 'LolA_like', 262132),
(443039, 'PF01422', NULL, 'NF-X1 type zinc finger', 19, NULL, 'zf-NF-X1', 262133),
(443040, 'PF02925', NULL, 'Bacteriophage scaffolding protein D', 141, NULL, 'gpD', 262134),
(443041, 'PF17861', NULL, 'Laterosporulin defensin-like peptide', 49, NULL, 'Laterosporulin', 262135),
(443042, 'PF02591', NULL, 'C4-type zinc ribbon domain', 33, NULL, 'zf-RING_7', 262136),
(443043, 'PF06815', NULL, 'Reverse transcriptase connection domain', 102, NULL, 'RVT_connect', 262137),
(443044, 'PF15710', NULL, 'Break repair meiotic recombinase recruitment factor 1', 666, NULL, 'Brme1', 262138);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(443045, 'PF09246', NULL, 'PHAT', 110, NULL, 'PHAT', 262139),
(443046, 'PF17383', NULL, 'Uncharacterized KorC regulated protein A', 76, NULL, 'kleA_kleC', 262140),
(443047, 'PF15620', NULL, 'Centromere assembly component CENP-C middle DNMT3B-binding region', 260, NULL, 'CENP-C_mid', 262141),
(443048, 'PF08773', NULL, 'Cathepsin C exclusion domain', 121, NULL, 'CathepsinC_exc', 262142),
(443049, 'PF01458', NULL, 'SUF system FeS cluster assembly, SufBD', 218, NULL, 'SUFBD', 262143),
(443050, 'PF12602', NULL, 'Fertility inhibition protein N terminal', 62, NULL, 'FinO_N', 262144),
(443051, 'PF16752', NULL, 'Tubulin-specific chaperone C N-terminal domain', 115, NULL, 'TBCC_N', 262145),
(443052, 'PF10769', NULL, 'Protein of unknown function (DUF2594)', 74, NULL, 'DUF2594', 262146),
(443053, 'PF14145', NULL, 'YrhK-like protein', 61, NULL, 'YrhK', 262147),
(443054, 'PF06071', NULL, 'Protein of unknown function (DUF933)', 84, NULL, 'YchF-GTPase_C', 262148),
(443055, 'PF06722', NULL, 'Protein of unknown function (DUF1205)', 95, NULL, 'DUF1205', 262149),
(443056, 'PF09291', NULL, 'Domain of unknown function (DUF1968)', 81, NULL, 'DUF1968', 262150),
(443057, 'PF14038', NULL, 'YqzE-like protein', 54, NULL, 'YqzE', 262151),
(443058, 'PF14420', NULL, 'Clr5 domain', 54, NULL, 'Clr5', 262152),
(443059, 'PF09147', NULL, 'Carbapenam-3-carboxylate synthase, N-terminal', 199, NULL, 'CarA_N', 262153),
(443060, 'PF17330', NULL, 'SWR1 chromatin-remodelling complex, sub-unit Swc7', 98, NULL, 'SWC7', 262154),
(443061, 'PF13798', NULL, 'Protein of unknown function with PCYCGC motif', 154, NULL, 'PCYCGC', 262155),
(443062, 'PF08737', NULL, 'Rgp1', 414, NULL, 'Rgp1', 262156),
(443063, 'PF03855', NULL, 'M-factor', 43, NULL, 'M-factor', 262157),
(443064, 'PF04284', NULL, 'Protein of unknown function (DUF441)', 139, NULL, 'DUF441', 262158),
(443065, 'PF09223', NULL, 'ZinT (YodA) periplasmic lipocalin-like zinc-recruitment', 181, NULL, 'ZinT', 262159),
(443066, 'PF11210', NULL, 'Protein of unknown function (DUF2996)', 121, NULL, 'DUF2996', 262160),
(443067, 'PF10601', NULL, 'LITAF-like zinc ribbon domain', 70, NULL, 'zf-LITAF-like', 262161),
(443068, 'PF12906', NULL, 'RING-variant domain', 48, NULL, 'RINGv', 262162),
(443069, 'PF13163', NULL, 'Protein of unknown function (DUF3999)', 426, NULL, 'DUF3999', 262163),
(443070, 'PF14054', NULL, 'Domain of unknown function (DUF4249)', 276, NULL, 'DUF4249', 262164),
(443071, 'PF14484', NULL, 'Fish-specific NACHT associated domain', 72, NULL, 'FISNA', 262165),
(443072, 'PF05291', NULL, 'Bystin', 292, NULL, 'Bystin', 262166),
(443073, 'PF10200', NULL, 'NADH:ubiquinone oxidoreductase, NDUFS5-15kDa', 96, NULL, 'Ndufs5', 262167),
(443074, 'PF11196', NULL, 'Protein of unknown function DUF2834', 96, NULL, 'DUF2834', 262168),
(443075, 'PF02173', NULL, 'pKID domain', 41, NULL, 'pKID', 262169),
(443076, 'PF09633', NULL, 'Protein of unknown function (DUF2023)', 101, NULL, 'DUF2023', 262170),
(443077, 'PF11336', NULL, 'Protein of unknown function (DUF3138)', 524, NULL, 'DUF3138', 262171),
(443078, 'PF18406', NULL, 'Ferredoxin-like domain in Api92-like protein', 87, NULL, 'DUF1281_C', 262172),
(443079, 'PF03859', NULL, 'CG-1 domain', 116, NULL, 'CG-1', 262173),
(443080, 'PF10341', NULL, 'Shelterin complex subunit, TPP1/ACD', 110, NULL, 'TPP1', 262174),
(443081, 'PF12468', NULL, 'Type III secretion system leucine rich repeat protein', 54, NULL, 'TTSSLRR', 262175),
(443082, 'PF18364', NULL, 'Molybdopterin oxidoreductase N-terminal domain', 41, NULL, 'Molybdopterin_N', 262176),
(443083, 'PF00336', NULL, 'DNA polymerase (viral) C-terminal domain', 233, NULL, 'DNA_pol_viral_C', 262177),
(443084, 'PF09529', NULL, 'Integral membrane protein (intg_mem_TP0381)', 224, NULL, 'Intg_mem_TP0381', 262178),
(443085, 'PF09047', NULL, 'MEF2 binding', 35, NULL, 'MEF2_binding', 262179),
(443086, 'PF13590', NULL, 'Domain of unknown function (DUF4136)', 131, NULL, 'DUF4136', 262180),
(443087, 'PF07929', NULL, 'Plasmid pRiA4b ORF-3-like protein', 174, NULL, 'PRiA4_ORF3', 262181),
(443088, 'PF12379', NULL, 'Betacoronavirus replicase NSP3, N-terminal', 149, NULL, 'bCoV_NSP3_N', 262182);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(443089, 'PF10426', NULL, 'Recombination-activating protein 1 zinc-finger domain', 30, NULL, 'zf-RAG1', 262183),
(443090, 'PF06046', NULL, 'Exocyst complex component Sec6', 576, NULL, 'Sec6', 262184),
(443091, 'PF18105', NULL, 'PGM1 C-terminal domain', 53, NULL, 'PGM1_C', 262185),
(443092, 'PF19472', NULL, 'Family of unknown function (DUF6009)', 127, NULL, 'DUF6009', 262186),
(443093, 'PF19845', NULL, 'Family of unknown function (DUF6320)', 186, NULL, 'DUF6320', 262187),
(443094, 'PF16820', NULL, 'PKD-like domain', 68, NULL, 'PKD_3', 262188),
(443095, 'PF02050', NULL, 'Flagellar FliJ protein', 123, NULL, 'FliJ', 262189),
(443096, 'PF08762', NULL, 'CRPV capsid protein like', 199, NULL, 'CRPV_capsid', 262190),
(443097, 'PF20290', NULL, 'ABC-three component (ABC-3C) system Middle Component 4', 133, NULL, 'MC4', 262191),
(443098, 'PF08076', NULL, 'Tetracycline resistance determinant leader peptide', 28, NULL, 'TetM_leader', 262192),
(443099, 'PF19897', NULL, 'Family of unknown function (DUF6370)', 75, NULL, 'DUF6370', 262193),
(443100, 'PF03294', NULL, 'RNA polymerase-associated transcription specificity factor, Rap94', 800, NULL, 'Pox_Rap94', 262194),
(443101, 'PF09497', NULL, 'Transcription mediator complex subunit Med12', 63, NULL, 'Med12', 262195),
(443102, 'PF05086', NULL, 'Dictyostelium (Slime Mold) REP protein', 911, NULL, 'Dicty_REP', 262196),
(443103, 'PF00834', NULL, 'Ribulose-phosphate 3 epimerase family', 198, NULL, 'Ribul_P_3_epim', 262197),
(443104, 'PF04244', NULL, 'Deoxyribodipyrimidine photo-lyase-related protein', 224, NULL, 'DPRP', 262198),
(443105, 'PF09365', NULL, 'Conserved hypothetical protein (DUF2461)', 208, NULL, 'DUF2461', 262199),
(443106, 'PF10456', NULL, 'WASP-binding domain of Sorting nexin protein', 236, NULL, 'BAR_3_WASP_bdg', 262200),
(443107, 'PF04153', NULL, 'NOT2 / NOT3 / NOT5 family', 132, NULL, 'NOT2_3_5', 262201),
(443108, 'PF07558', NULL, 'Shugoshin N-terminal coiled-coil region', 45, NULL, 'Shugoshin_N', 262202),
(443109, 'PF07947', NULL, 'YhhN family', 184, NULL, 'YhhN', 262203),
(443110, 'PF14595', NULL, 'Thioredoxin', 129, NULL, 'Thioredoxin_9', 262204),
(443111, 'PF00017', NULL, 'SH2 domain', 77, NULL, 'SH2', 262205),
(443112, 'PF03333', NULL, 'Adhesin biosynthesis transcription regulatory protein', 91, NULL, 'PapB', 262206),
(443113, 'PF09688', NULL, 'Protein of unknown function (Wx5_PLAF3D7)', 144, NULL, 'Wx5_PLAF3D7', 262207),
(443114, 'PF17711', NULL, 'Family of unknown function (DUF5556)', 178, NULL, 'DUF5556', 262208),
(443115, 'PF15707', NULL, 'Mitochondrial coiled-coil domain protein 1', 90, NULL, 'MCCD1', 262209),
(443116, 'PF11136', NULL, 'Protein of unknown function (DUF2889)', 123, NULL, 'DUF2889', 262210),
(443117, 'PF14436', NULL, 'Bacterial EndoU nuclease', 125, NULL, 'EndoU_bacteria', 262211),
(443118, 'PF18574', NULL, 'C2HC Zing finger domain', 33, NULL, 'zf_C2HC_14', 262212),
(443119, 'PF02011', NULL, 'Glycosyl hydrolase family 48', 619, NULL, 'Glyco_hydro_48', 262213),
(443120, 'PF16086', NULL, 'Domain of unknown function (DUF4816)', 43, NULL, 'DUF4816', 262214),
(443121, 'PF20584', NULL, 'Family of unknown function (DUF6787)', 79, NULL, 'DUF6787', 262215),
(443122, 'PF02686', NULL, 'Glu-tRNAGln amidotransferase C subunit', 62, NULL, 'Glu-tRNAGln', 262216),
(443123, 'PF07046', NULL, 'Cytoplasmic repetitive antigen (CRA) like repeat', 42, NULL, 'CRA_rpt', 262217),
(443124, 'PF12234', NULL, 'RAVE protein 1 C terminal', 640, NULL, 'Rav1p_C', 262218),
(443125, 'PF07755', NULL, 'Domain of unknown function (DUF1611_C) P-loop domain', 200, NULL, 'DUF1611', 262219),
(443126, 'PF00787', NULL, 'PX domain', 84, NULL, 'PX', 262220),
(443127, 'PF18515', NULL, 'Rh5 coiled-coil domain', 255, NULL, 'Rh5', 262221),
(443128, 'PF18665', NULL, 'Tetracyclin repressor-like, C-terminal domain', 117, NULL, 'TetR_C_37', 262222),
(443129, 'PF18444', NULL, 'RNA recognition motif', 70, NULL, 'RRM_9', 262223),
(443130, 'PF12420', NULL, 'Protein of unknown function', 115, NULL, 'DUF3671', 262224),
(443131, 'PF04668', NULL, 'Twisted gastrulation (Tsg) protein conserved region', 132, NULL, 'Tsg', 262225);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(443132, 'PF11271', NULL, 'Porin PorA', 300, NULL, 'PorA', 262226),
(443133, 'PF11757', NULL, 'Suppressor of RNA silencing P21-like N-terminal domain', 94, NULL, 'RSS_P20', 262227),
(443134, 'PF15372', NULL, 'Domain of unknown function (DUF4600)', 128, NULL, 'DUF4600', 262228),
(443135, 'PF08860', NULL, 'Domain of unknown function (DUF1827)', 92, NULL, 'DUF1827', 262229),
(443136, 'PF03590', NULL, 'Aspartate-ammonia ligase', 228, NULL, 'AsnA', 262230),
(443137, 'PF12324', NULL, 'Helix-turn-helix domain of alkylmercury lyase', 74, NULL, 'HTH_15', 262231),
(443138, 'PF01531', NULL, 'Glycosyl transferase family 11', 298, NULL, 'Glyco_transf_11', 262232),
(443139, 'PF19043', NULL, 'Nuclear cap binding complex subunit CBP66', 585, NULL, 'CBP66', 262233),
(443140, 'PF14192', NULL, 'Domain of unknown function (DUF4314)', 69, NULL, 'DUF4314', 262234),
(443141, 'PF07946', NULL, 'PAT complex subunit CCDC47', 326, NULL, 'CCDC47', 262235),
(443142, 'PF09030', NULL, 'Creb binding', 111, NULL, 'Creb_binding', 262236),
(443143, 'PF03860', NULL, 'Domain of Unknown Function (DUF326)', 21, NULL, 'DUF326', 262237),
(443144, 'PF19732', NULL, 'Stage II sporulation protein E N-terminal', 605, NULL, 'SpoIIE_N', 262238),
(443145, 'PF05475', NULL, 'Pgp3 C-terminal domain', 146, NULL, 'Chlam_vir', 262239),
(443146, 'PF17028', NULL, '8TM Microsporidial transmembrane domain', 255, NULL, '8TM_micro', 262240),
(443147, 'PF06975', NULL, 'Protein of unknown function (DUF1299)', 47, NULL, 'DUF1299', 262241),
(443148, 'PF12052', NULL, 'Voltage gated calcium channel subunit beta domain 4Aa N terminal', 41, NULL, 'VGCC_beta4Aa_N', 262242),
(443149, 'PF15866', NULL, 'Domain of unknown function (DUF4729)', 210, NULL, 'DUF4729', 262243),
(443150, 'PF11868', NULL, 'Protein of unknown function (DUF3388)', 190, NULL, 'DUF3388', 262244),
(443151, 'PF18270', NULL, 'Virulence factor Evf', 235, NULL, 'Evf', 262245),
(443152, 'PF01039', NULL, 'Carboxyl transferase domain', 494, NULL, 'Carboxyl_trans', 262246),
(443153, 'PF03497', NULL, 'Anthrax toxin LF subunit', 176, NULL, 'Anthrax_toxA', 262247),
(443154, 'PF05145', NULL, 'Transition state regulatory protein AbrB', 314, NULL, 'AbrB', 262248),
(443155, 'PF10058', NULL, 'Predicted integral membrane zinc-ribbon metal-binding protein', 54, NULL, 'zinc_ribbon_10', 262249),
(443156, 'PF05593', NULL, 'RHS Repeat', 38, NULL, 'RHS_repeat', 262250),
(443157, 'PF08023', NULL, 'Frog antimicrobial peptide', 33, NULL, 'Antimicrobial_2', 262251),
(443158, 'PF05722', NULL, 'Ustilago B locus mating-type protein', 286, NULL, 'Ustilago_mating', 262252),
(443159, 'PF11265', NULL, 'Mediator complex subunit 25 von Willebrand factor type A', 213, NULL, 'Med25_VWA', 262253),
(443160, 'PF01614', NULL, 'Bacterial transcriptional regulator', 128, NULL, 'IclR', 262254),
(443161, 'PF06730', NULL, 'FAM92 protein', 222, NULL, 'FAM92', 262255),
(443162, 'PF00880', NULL, 'Nebulin repeat', 28, NULL, 'Nebulin', 262256),
(443163, 'PF05504', NULL, 'Spore germination B3/ GerAC like, C-terminal', 164, NULL, 'Spore_GerAC', 262257),
(443164, 'PF14780', NULL, 'Domain of unknown function (DUF4477)', 189, NULL, 'DUF4477', 262258),
(443165, 'PF16998', NULL, '17 kDa outer membrane surface antigen', 116, NULL, '17kDa_Anti_2', 262259),
(443166, 'PF16764', NULL, 'Sharpin PH domain', 121, NULL, 'Sharpin_PH', 262260),
(443167, 'PF13562', NULL, 'Sugar nucleotidyl transferase', 160, NULL, 'NTP_transf_4', 262261),
(443168, 'PF16736', NULL, 'Single Cache-like', 117, NULL, 'sCache_like', 262262),
(443169, 'PF03270', NULL, 'Protein of unknown function, DUF269', 121, NULL, 'DUF269', 262263),
(443170, 'PF10008', NULL, 'Uncharacterized protein conserved in bacteria (DUF2251)', 94, NULL, 'DUF2251', 262264),
(443171, 'PF09594', NULL, 'Glycosyltransferase family 87', 238, NULL, 'GT87', 262265),
(443172, 'PF07940', NULL, 'Heparinase II/III-like protein', 237, NULL, 'Hepar_II_III', 262266),
(443173, 'PF01477', NULL, 'PLAT/LH2 domain', 117, NULL, 'PLAT', 262267),
(443174, 'PF17322', NULL, 'Family of unknown function (DUF5364)', 185, NULL, 'DUF5364', 262268); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(443175, 'PF19862', NULL, 'Family of unknown function (DUF6336)', 128, NULL, 'DUF6336', 262269),
(443176, 'PF06613', NULL, 'KorB C-terminal beta-barrel domain', 59, NULL, 'KorB_C', 262270),
(443177, 'PF08134', NULL, 'cIII protein family', 37, NULL, 'cIII', 262271),
(443178, 'PF08262', NULL, 'Leucophaea maderae tachykinin-related peptide', 10, NULL, 'Lem_TRP', 262272),
(443179, 'PF17689', NULL, 'Arabinosyltransferase concanavalin like domain', 157, NULL, 'Arabino_trans_N', 262273),
(443180, 'PF13779', NULL, 'Domain of unknown function (DUF4175)', 819, NULL, 'DUF4175', 262274),
(443181, 'PF12267', NULL, 'Protein of unknown function (DUF3614)', 173, NULL, 'DUF3614', 262275),
(443182, 'PF02884', NULL, 'Polysaccharide lyase family 8, C-terminal beta-sandwich domain', 69, NULL, 'Lyase_8_C', 262276),
(443183, 'PF08565', NULL, 'Cdc37 Hsp90 binding domain', 118, NULL, 'CDC37_M', 262277),
(443184, 'PF14112', NULL, 'Immunity protein 22', 122, NULL, 'DUF4284', 262278),
(443185, 'PF02025', NULL, 'Interleukin 5', 112, NULL, 'IL5', 262279),
(443186, 'PF19335', NULL, 'Heavy metal binding domain', 28, NULL, 'HMBD', 262280),
(443187, 'PF07362', NULL, 'Post-segregation antitoxin CcdA', 71, NULL, 'CcdA', 262281),
(443188, 'PF11859', NULL, 'Protein of unknown function (DUF3379)', 235, NULL, 'DUF3379', 262282),
(443189, 'PF11640', NULL, 'Telomere-length maintenance and DNA damage repair', 151, NULL, 'TAN', 262283),
(443190, 'PF07453', NULL, 'NUMOD1 domain', 37, NULL, 'NUMOD1', 262284),
(443191, 'PF00062', NULL, 'C-type lysozyme/alpha-lactalbumin family', 123, NULL, 'Lys', 262285),
(443192, 'PF04986', NULL, 'Putative transposase', 183, NULL, 'Y2_Tnp', 262286),
(443193, 'PF17328', NULL, 'Family of unknown function (DUF5366)', 158, NULL, 'DUF5366', 262287),
(443194, 'PF04751', NULL, 'Protein of unknown function (DUF615)', 153, NULL, 'DUF615', 262288),
(443195, 'PF09658', NULL, 'CRISPR-associated protein (Cas_Csx9)', 377, NULL, 'Cas_Csx9', 262289),
(443196, 'PF13019', NULL, 'Silencing defective 2 N-terminal ubiquitin domain', 164, NULL, 'Sde2_N_Ubi', 262290),
(443197, 'PF15831', NULL, 'Domain of unknown function (DUF4713)', 56, NULL, 'DUF4713', 262291),
(443198, 'PF06144', NULL, 'DNA polymerase III, delta subunit', 174, NULL, 'DNA_pol3_delta', 262292),
(443199, 'PF17726', NULL, 'Dam-replacing HTH domain', 70, NULL, 'DpnI_C', 262293),
(443200, 'PF01960', NULL, 'ArgJ family', 375, NULL, 'ArgJ', 262294),
(443201, 'PF18885', NULL, 'Repeat of unknown function (DUF5648)', 39, NULL, 'DUF5648', 262295),
(443202, 'PF00796', NULL, 'Photosystem I reaction centre subunit VIII', 25, NULL, 'PSI_8', 262296),
(443203, 'PF20271', NULL, 'CATRA-Associated Small Protein', 86, NULL, 'CATASP', 262297),
(443204, 'PF06781', NULL, 'Cell division protein CrgA', 89, NULL, 'CrgA', 262298),
(443205, 'PF17994', NULL, 'Galactofuranosyltransferase 2 N-terminal', 142, NULL, 'Glft2_N', 262299),
(443206, 'PF04908', NULL, 'SH3-binding, glutamic acid-rich protein', 99, NULL, 'SH3BGR', 262300),
(443207, 'PF20199', NULL, 'Replication initiator protein, pSAM2', 437, NULL, 'RepSA', 262301),
(443208, 'PF05192', NULL, 'MutS domain III', 191, NULL, 'MutS_III', 262302),
(443209, 'PF02080', NULL, 'TrkA-C domain', 70, NULL, 'TrkA_C', 262303),
(443210, 'PF04192', NULL, 'Utp21 specific WD40 associated putative domain', 213, NULL, 'Utp21', 262304),
(443211, 'PF09204', NULL, 'Bacterial self-protective colicin-like immunity', 88, NULL, 'Colicin_immun', 262305),
(443212, 'PF14649', NULL, 'Spatacsin C-terminus', 299, NULL, 'Spatacsin_C', 262306),
(443213, 'PF12141', NULL, 'Beta-mannosyltransferases', 491, NULL, 'BMT', 262307),
(443214, 'PF16815', NULL, 'Protein HRI1', 236, NULL, 'HRI1', 262308),
(443215, 'PF02547', NULL, 'Queuosine biosynthesis protein', 325, NULL, 'Queuosine_synth', 262309),
(443216, 'PF05224', NULL, 'NDT80 / PhoG like DNA-binding  family', 186, NULL, 'NDT80_PhoG', 262310),
(443217, 'PF08925', NULL, 'Domain of Unknown Function (DUF1907)', 282, NULL, 'DUF1907', 262311),
(443218, 'PF17613', NULL, 'Modifier of transcription', 162, NULL, 'motB', 262312);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(443219, 'PF15815', NULL, 'E3 ubiquitin-protein ligase makorin, C-terminal', 91, NULL, 'MKRN1_C', 262313),
(443220, 'PF02458', NULL, 'Transferase family', 434, NULL, 'Transferase', 262314),
(443221, 'PF12423', NULL, 'Kinesin protein 1B', 49, NULL, 'KIF1B', 262315),
(443222, 'PF17199', NULL, 'Protein of unknown function (DUF5136)', 28, NULL, 'DUF5136', 262316),
(443223, 'PF08560', NULL, 'Protein of unknown function (DUF1757)', 148, NULL, 'DUF1757', 262317),
(443224, 'PF14629', NULL, 'Origin recognition complex (ORC) subunit 4 C-terminus', 221, NULL, 'ORC4_C', 262318),
(443225, 'PF18848', NULL, 'Bacterial archaeo-eukaryotic release factor family 6', 150, NULL, 'baeRF_family6', 262319),
(443226, 'PF00932', NULL, 'Lamin Tail Domain', 112, NULL, 'LTD', 262320),
(443227, 'PF07924', NULL, 'Nuclease A inhibitor-like protein', 130, NULL, 'NuiA', 262321),
(443228, 'PF17852', NULL, 'Dynein heavy chain AAA lid domain', 130, NULL, 'Dynein_AAA_lid', 262322),
(443229, 'PF07808', NULL, 'RED-like protein N-terminal region', 235, NULL, 'RED_N', 262323),
(443230, 'PF03607', NULL, 'Doublecortin', 60, NULL, 'DCX', 262324),
(443231, 'PF04485', NULL, 'Phycobilisome degradation protein nblA', 50, NULL, 'NblA', 262325),
(443232, 'PF06809', NULL, 'Neural proliferation differentiation control-1 protein (NPDC1)', 341, NULL, 'NPDC1', 262326),
(443233, 'PF17721', NULL, 'Family of unknown function (DUF5566)', 233, NULL, 'DUF5566', 262327),
(443234, 'PF01294', NULL, 'Ribosomal protein L13e', 180, NULL, 'Ribosomal_L13e', 262328),
(443235, 'PF09947', NULL, 'Uncharacterized protein conserved in archaea (DUF2180)', 68, NULL, 'DUF2180', 262329),
(443236, 'PF15791', NULL, 'Doublesex-and mab-3-related transcription factor C1 and C2', 119, NULL, 'DMRT-like', 262330),
(443237, 'PF04649', NULL, 'Mycoplasma hyorhinis VlpA repeat', 13, NULL, 'VlpA_repeat', 262331),
(443238, 'PF18578', NULL, 'Rubisco accumulation factor 1 alpha helical domain', 106, NULL, 'Raf1_N', 262332),
(443239, 'PF00295', NULL, 'Glycosyl hydrolases family 28', 325, NULL, 'Glyco_hydro_28', 262333),
(443240, 'PF15824', NULL, 'Spermatogenesis-associated protein 9', 253, NULL, 'SPATA9', 262334),
(443241, 'PF07016', NULL, 'Cysteine-rich acidic integral membrane protein precursor', 22, NULL, 'CRAM_rpt', 262335),
(443242, 'PF04520', NULL, 'Senescence regulator', 167, NULL, 'Senescence_reg', 262336),
(443243, 'PF16355', NULL, 'Domain of unknown function (DUF4982)', 62, NULL, 'DUF4982', 262337),
(443244, 'PF07527', NULL, 'Hairy Orange', 40, NULL, 'Hairy_orange', 262338),
(443245, 'PF06114', NULL, 'IrrE N-terminal-like domain', 123, NULL, 'Peptidase_M78', 262339),
(443246, 'PF13037', NULL, 'Domain of unknown function (DUF3898)', 90, NULL, 'DUF3898', 262340),
(443247, 'PF13090', NULL, 'Polyphosphate kinase C-terminal domain 2', 172, NULL, 'PP_kinase_C', 262341),
(443248, 'PF05667', NULL, 'Coiled-coil domain-containing protein 22', 604, NULL, 'CCDC22', 262342),
(443249, 'PF12497', NULL, 'Estrogen receptor beta', 114, NULL, 'ERbeta_N', 262343),
(443250, 'PF15891', NULL, 'Nucleoside 2-deoxyribosyltransferase like', 108, NULL, 'Nuc_deoxyri_tr2', 262344),
(443251, 'PF18631', NULL, 'Cucumopine synthase C-terminal helical bundle domain', 141, NULL, 'Cucumopine_C', 262345),
(443252, 'PF20234', NULL, 'Family of unknown function (DUF6591)', 227, NULL, 'DUF6591', 262346),
(443253, 'PF12933', NULL, 'FTO catalytic domain', 275, NULL, 'FTO_NTD', 262347),
(443254, 'PF14789', NULL, 'Tetrahydrodipicolinate N-succinyltransferase middle', 41, NULL, 'THDPS_M', 262348),
(443255, 'PF07112', NULL, 'Protein of unknown function (DUF1368)', 404, NULL, 'DUF1368', 262349),
(443256, 'PF07223', NULL, 'UBA-like domain (DUF1421)', 45, NULL, 'DUF1421', 262350),
(443257, 'PF18793', NULL, 'Nitrous oxide reductase propeller repeat 2', 70, NULL, 'nos_propeller_2', 262351),
(443258, 'PF15131', NULL, 'Domain of unknown function (DUF4567)', 75, NULL, 'DUF4567', 262352),
(443259, 'PF06231', NULL, 'Protein of unknown function (DUF1010)', 81, NULL, 'DUF1010', 262353),
(443260, 'PF10774', NULL, 'Domain of unknown function (DUF4226)', 115, NULL, 'DUF4226', 262354);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(443261, 'PF07221', NULL, 'N-acylglucosamine 2-epimerase (GlcNAc 2-epimerase)', 346, NULL, 'GlcNAc_2-epim', 262355),
(443262, 'PF14489', NULL, 'QueF-like protein', 81, NULL, 'QueF', 262356),
(443263, 'PF15772', NULL, 'UPF0688 family', 233, NULL, 'UPF0688', 262357),
(443264, 'PF04888', NULL, 'Secretion system effector C (SseC) like family', 315, NULL, 'SseC', 262358),
(443265, 'PF13230', NULL, 'Glutamine amidotransferases class-II', 271, NULL, 'GATase_4', 262359),
(443266, 'PF02769', NULL, 'AIR synthase related protein, C-terminal domain', 156, NULL, 'AIRS_C', 262360),
(443267, 'PF07255', NULL, 'Benyvirus 14KDa protein', 123, NULL, 'Benyvirus_14KDa', 262361),
(443268, 'PF08563', NULL, 'P53 transactivation motif', 25, NULL, 'P53_TAD', 262362),
(443269, 'PF04714', NULL, 'BCL7, N-terminal conserver region', 49, NULL, 'BCL_N', 262363),
(443270, 'PF05132', NULL, 'RNA polymerase III RPC4', 150, NULL, 'RNA_pol_Rpc4', 262364),
(443271, 'PF12413', NULL, 'Homeobox protein distal-less-like N terminal', 85, NULL, 'DLL_N', 262365),
(443272, 'PF11639', NULL, 'REDY-like protein HapK', 104, NULL, 'HapK', 262366),
(443273, 'PF15757', NULL, 'Amelotin', 195, NULL, 'Amelotin', 262367),
(443274, 'PF19120', NULL, 'Family of unknown function (DUF5804)', 108, NULL, 'DUF5804', 262368),
(443275, 'PF13028', NULL, 'Protein of unknown function (DUF3889)', 94, NULL, 'DUF3889', 262369),
(443276, 'PF10224', NULL, 'Short coiled-coil protein', 75, NULL, 'DUF2205', 262370),
(443277, 'PF04719', NULL, 'hTAFII28-like protein conserved region', 86, NULL, 'TAFII28', 262371),
(443278, 'PF13254', NULL, 'Domain of unknown function (DUF4045)', 416, NULL, 'DUF4045', 262372),
(443279, 'PF14143', NULL, 'YrhC-like protein', 72, NULL, 'YrhC', 262373),
(443280, 'PF17308', NULL, 'Pro-corazonin', 134, NULL, 'Corazonin', 262374),
(443281, 'PF10425', NULL, 'C-terminus of bacterial fibrinogen-binding adhesin', 156, NULL, 'SdrG_C_C', 262375),
(443282, 'PF10960', NULL, 'BhlA holin family', 70, NULL, 'Holin_BhlA', 262376),
(443283, 'PF12018', NULL, 'Domain of unknown function', 272, NULL, 'FAP206', 262377),
(443284, 'PF13873', NULL, 'Myb/SANT-like DNA-binding domain', 78, NULL, 'Myb_DNA-bind_5', 262378),
(443285, 'PF16051', NULL, 'Domain of unknown function (DUF4797)', 44, NULL, 'DUF4797', 262379),
(443286, 'PF18718', NULL, 'CxC5 like cysteine cluster associated with KDZ transposases', 117, NULL, 'CxC5', 262380),
(443287, 'PF00030', NULL, 'Beta/Gamma crystallin', 82, NULL, 'Crystall', 262381),
(443288, 'PF09735', NULL, 'Nck-associated protein 1', 1119, NULL, 'Nckap1', 262382),
(443289, 'PF12168', NULL, 'DNA polymerase III subunits tau domain IV DnaB-binding', 80, NULL, 'DNA_pol3_tau_4', 262383),
(443290, 'PF12228', NULL, 'Protein of unknown function (DUF3604)', 591, NULL, 'DUF3604', 262384),
(443291, 'PF01638', NULL, 'HxlR-like helix-turn-helix', 91, NULL, 'HxlR', 262385),
(443292, 'PF11415', NULL, 'Antifungal peptide termicin', 35, NULL, 'Toxin_37', 262386),
(443293, 'PF15337', NULL, 'Vascular protein family Vasculin-like 1', 97, NULL, 'Vasculin', 262387),
(443294, 'PF15681', NULL, 'Lymphocyte activation family X', 350, NULL, 'LAX', 262388),
(443295, 'PF17712', NULL, 'Family of unknown function (DUF5557)', 90, NULL, 'DUF5557', 262389),
(443296, 'PF09001', NULL, 'Domain of unknown function (DUF1890)', 139, NULL, 'DUF1890', 262390),
(443297, 'PF17307', NULL, 'Small integral membrane protein 3', 60, NULL, 'Smim3', 262391),
(443298, 'PF14178', NULL, 'YppF-like protein', 59, NULL, 'YppF', 262392),
(443299, 'PF18025', NULL, 'Alpha-(1,3)-fucosyltransferase FucT N-terminal domain', 92, NULL, 'FucT_N', 262393),
(443300, 'PF05331', NULL, 'Protein of unknown function (DUF742)', 114, NULL, 'DUF742', 262394),
(443301, 'PF17797', NULL, 'RL domain', 71, NULL, 'RL', 262395),
(443302, 'PF01929', NULL, 'Ribosomal protein L14', 75, NULL, 'Ribosomal_L14e', 262396),
(443303, 'PF12188', NULL, 'Signal transducer and activator of transcription 2 C terminal', 56, NULL, 'STAT2_C', 262397),
(443304, 'PF01357', NULL, 'Expansin C-terminal domain', 80, NULL, 'Expansin_C', 262398);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(443305, 'PF18930', NULL, 'Domain of unknown function (DUF5679)', 40, NULL, 'DUF5679', 262399),
(443306, 'PF13064', NULL, 'Protein of unknown function (DUF3927)', 53, NULL, 'DUF3927', 262400),
(443307, 'PF03309', NULL, 'Type III pantothenate kinase', 207, NULL, 'Pan_kinase', 262401),
(443308, 'PF06974', NULL, 'WS/DGAT C-terminal domain', 145, NULL, 'WS_DGAT_C', 262402),
(443309, 'PF09604', NULL, 'F subunit of K+-transporting ATPase (Potass_KdpF)', 24, NULL, 'Potass_KdpF', 262403),
(443310, 'PF19402', NULL, 'Lanthionine-containing peptide SapB precursor RamS', 44, NULL, 'RamS', 262404),
(443311, 'PF09484', NULL, 'CRISPR-associated protein TM1802 (cas_TM1802)', 609, NULL, 'Cas_TM1802', 262405),
(443312, 'PF11109', NULL, 'Orexigenic neuropeptide Qrfp/P518', 131, NULL, 'RFamide_26RFa', 262406),
(443313, 'PF01074', NULL, 'Glycosyl hydrolases family 38 N-terminal domain', 289, NULL, 'Glyco_hydro_38N', 262407),
(443314, 'PF12447', NULL, 'Protein of unknown function (DUF3683)', 114, NULL, 'DUF3683', 262408),
(443315, 'PF08917', NULL, 'Transforming growth factor beta receptor 2 ectodomain', 110, NULL, 'ecTbetaR2', 262409),
(443316, 'PF19814', NULL, 'Family of unknown function (DUF6297)', 372, NULL, 'DUF6297', 262410),
(443317, 'PF05047', NULL, 'Mitochondrial ribosomal protein L51 / S25 / CI-B8 domain', 52, NULL, 'L51_S25_CI-B8', 262411),
(443318, 'PF05130', NULL, 'FlgN protein', 146, NULL, 'FlgN', 262412),
(443319, 'PF05362', NULL, 'Lon protease (S16) C-terminal proteolytic domain', 205, NULL, 'Lon_C', 262413),
(443320, 'PF11046', NULL, 'Transcriptional repressor of hyc and hyp operons', 146, NULL, 'HycA_repressor', 262414),
(443321, 'PF03786', NULL, 'D-mannonate dehydratase (UxuA)', 352, NULL, 'UxuA', 262415),
(443322, 'PF06585', NULL, 'Haemolymph juvenile hormone binding protein (JHBP)', 240, NULL, 'JHBP', 262416),
(443323, 'PF03528', NULL, 'Rabaptin', 486, NULL, 'Rabaptin', 262417),
(443324, 'PF06397', NULL, 'Desulfoferrodoxin, N-terminal domain', 36, NULL, 'Desulfoferrod_N', 262418),
(443325, 'PF09230', NULL, 'DNA fragmentation factor 40 kDa', 227, NULL, 'DFF40', 262419),
(443326, 'PF01131', NULL, 'DNA topoisomerase', 412, NULL, 'Topoisom_bac', 262420),
(443327, 'PF17381', NULL, 'Seminal vesicle secretory proteins 4/5/6', 91, NULL, 'Svs_4_5_6', 262421),
(443328, 'PF11057', NULL, 'Cortexin of kidney', 76, NULL, 'Cortexin', 262422),
(443329, 'PF15326', NULL, 'Testis expressed sequence 15', 236, NULL, 'TEX15', 262423),
(443330, 'PF11588', NULL, 'Protein of unknown function (DUF3243)', 79, NULL, 'DUF3243', 262424),
(443331, 'PF12419', NULL, 'SNF2 Helicase protein', 136, NULL, 'DUF3670', 262425),
(443332, 'PF13571', NULL, 'Domain of unknown function (DUF4133)', 91, NULL, 'DUF4133', 262426),
(443333, 'PF19645', NULL, 'Family of unknown function (DUF6148)', 74, NULL, 'DUF6148', 262427),
(443334, 'PF08768', NULL, 'THAP4-like, heme-binding beta-barrel domain', 153, NULL, 'THAP4_heme-bd', 262428),
(443335, 'PF18858', NULL, 'Large polyvalent protein associated domain 39', 198, NULL, 'LPD39', 262429),
(443336, 'PF13771', NULL, 'PHD-like zinc-binding domain', 90, NULL, 'zf-HC5HC2H', 262430),
(443337, 'PF12222', NULL, 'Peptide N-acetyl-beta-D-glucosaminyl asparaginase amidase A', 434, NULL, 'PNGaseA', 262431),
(443338, 'PF09955', NULL, 'Predicted integral membrane protein (DUF2189)', 126, NULL, 'DUF2189', 262432),
(443339, 'PF14469', NULL, '28 kDa A-kinase anchor', 121, NULL, 'AKAP28', 262433),
(443340, 'PF15095', NULL, 'Interleukin 33', 269, NULL, 'IL33', 262434),
(443341, 'PF18154', NULL, 'REase associating with pPIWI_RE', 117, NULL, 'pPIWI_RE_REase', 262435),
(443342, 'PF12242', NULL, 'NAD(P)H binding domain of trans-2-enoyl-CoA reductase', 79, NULL, 'Eno-Rase_NADH_b', 262436),
(443343, 'PF15104', NULL, 'Domain of unknown function (DUF4558)', 86, NULL, 'DUF4558', 262437),
(443344, 'PF16458', NULL, 'Beta-prism lectin', 131, NULL, 'Beta-prism_lec', 262438),
(443345, 'PF10130', NULL, 'PIN domain', 133, NULL, 'PIN_2', 262439),
(443346, 'PF03364', NULL, 'Polyketide cyclase / dehydrase and lipid transport', 130, NULL, 'Polyketide_cyc', 262440);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(443347, 'PF17973', NULL, 'Bacterial Alpha-2-macroglobulin MG10 domain', 131, NULL, 'bMG10', 262441),
(443348, 'PF03656', NULL, 'Pam16', 127, NULL, 'Pam16', 262442),
(443349, 'PF17734', NULL, 'Spermatogenesis-associated protein 46', 228, NULL, 'Spt46', 262443),
(443350, 'PF06706', NULL, 'Citrus tristeza virus 6-kDa protein', 51, NULL, 'CTV_P6', 262444),
(443351, 'PF14885', NULL, 'Hypothetical glycosyl hydrolase family 15', 276, NULL, 'GHL15', 262445),
(443352, 'PF11420', NULL, 'Bacteriocin subtilosin A', 35, NULL, 'Subtilosin_A', 262446),
(443353, 'PF15240', NULL, 'Proline-rich protein', 180, NULL, 'Pro-rich', 262447),
(443354, 'PF20137', NULL, 'Family of unknown function (DUF6527)', 63, NULL, 'DUF6527', 262448),
(443355, 'PF18018', NULL, 'DNA polymerase delta subunit OB-fold domain', 129, NULL, 'DNA_pol_D_N', 262449),
(443356, 'PF13734', NULL, 'Spi protease inhibitor', 99, NULL, 'Inhibitor_I69', 262450),
(443357, 'PF01057', NULL, 'Parvovirus non-structural protein NS1', 272, NULL, 'Parvo_NS1', 262451),
(443358, 'PF05796', NULL, 'Chordopoxvirus protein G2', 215, NULL, 'Chordopox_G2', 262452),
(443359, 'PF06566', NULL, 'Chondroitin sulphate attachment domain', 250, NULL, 'Chon_Sulph_att', 262453),
(443360, 'PF09759', NULL, 'Spinocerebellar ataxia type 10 protein domain', 99, NULL, 'Atx10homo_assoc', 262454),
(443361, 'PF06287', NULL, 'Protein of unknown function (DUF1039)', 65, NULL, 'DUF1039', 262455),
(443362, 'PF04060', NULL, 'Putative Fe-S cluster', 33, NULL, 'FeS', 262456),
(443363, 'PF20575', NULL, 'Helix-turn-helix domain', 148, NULL, 'HTH_63', 262457),
(443364, 'PF08571', NULL, 'Yos1-like', 80, NULL, 'Yos1', 262458),
(443365, 'PF19490', NULL, 'Family of unknown function (DUF6025)', 458, NULL, 'DUF6025', 262459),
(443366, 'PF13210', NULL, 'Domain of unknown function (DUF4018)', 195, NULL, 'DUF4018', 262460),
(443367, 'PF11446', NULL, 'Protein of unknown function (DUF2897)', 54, NULL, 'DUF2897', 262461),
(443368, 'PF14240', NULL, 'YHYH protein', 198, NULL, 'YHYH', 262462),
(443369, 'PF14010', NULL, 'Phosphoenolpyruvate carboxylase', 494, NULL, 'PEPcase_2', 262463),
(443370, 'PF07262', NULL, 'CDI immunity protein', 155, NULL, 'CdiI', 262464),
(443371, 'PF12567', NULL, 'Leukocyte receptor CD45', 59, NULL, 'CD45', 262465),
(443372, 'PF02361', NULL, 'Cobalt transport protein', 218, NULL, 'CbiQ', 262466),
(443373, 'PF00682', NULL, 'HMGL-like', 264, NULL, 'HMGL-like', 262467),
(443374, 'PF07207', NULL, 'Light regulated protein Lir1', 134, NULL, 'Lir1', 262468),
(443375, 'PF19782', NULL, 'Family of unknown function (DUF6267)', 373, NULL, 'DUF6267', 262469),
(443376, 'PF16444', NULL, 'Domain of unknown function (DUF5041)', 192, NULL, 'DUF5041', 262470),
(443377, 'PF16587', NULL, '17 kDa common-antigen outer membrane protein', 82, NULL, 'DUF5061', 262471),
(443378, 'PF00045', NULL, 'Hemopexin', 45, NULL, 'Hemopexin', 262472),
(443379, 'PF14310', NULL, 'Fibronectin type III-like domain', 71, NULL, 'Fn3-like', 262473),
(443380, 'PF08357', NULL, 'SEFIR domain', 150, NULL, 'SEFIR', 262474),
(443381, 'PF17828', NULL, 'N-terminal domain in fatty acid synthase subunit beta', 129, NULL, 'FAS_N', 262475),
(443382, 'PF18377', NULL, 'FERM F2 acyl-CoA binding protein-like domain', 131, NULL, 'FERM_F2', 262476),
(443383, 'PF17528', NULL, 'Histidine decarboxylase maturation protein HdcB', 174, NULL, 'HdcB', 262477),
(443384, 'PF14260', NULL, 'C4-type zinc-finger of DNA polymerase delta', 70, NULL, 'zf-C4pol', 262478),
(443385, 'PF06772', NULL, 'Bacterial low temperature requirement A protein (LtrA)', 356, NULL, 'LtrA', 262479),
(443386, 'PF10405', NULL, 'Rad4 beta-hairpin domain 3', 76, NULL, 'BHD_3', 262480),
(443387, 'PF06610', NULL, 'L-alanine exporter', 141, NULL, 'AlaE', 262481),
(443388, 'PF11638', NULL, 'DnaA N-terminal domain', 64, NULL, 'DnaA_N', 262482),
(443389, 'PF06576', NULL, 'Protein of unknown function (DUF1133)', 176, NULL, 'DUF1133', 262483),
(443390, 'PF08661', NULL, 'Replication factor A protein 3', 105, NULL, 'Rep_fac-A_3', 262484),
(443391, 'PF15636', NULL, 'GHH signature containing HNH/Endo VII superfamily nuclease toxin', 78, NULL, 'Tox-GHH', 262485);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(443392, 'PF17208', NULL, 'RNA binding Region', 57, NULL, 'RBR', 262486),
(443393, 'PF20570', NULL, 'Domain of unknown function (DUF6779)', 108, NULL, 'DUF6779', 262487),
(443394, 'PF00357', NULL, 'Integrin alpha cytoplasmic region', 15, NULL, 'Integrin_alpha', 262488),
(443395, 'PF10141', NULL, 'Single-strand DNA-specific exonuclease, C terminal domain', 202, NULL, 'ssDNA-exonuc_C', 262489),
(443396, 'PF00469', NULL, 'Negative factor, (F-Protein) or Nef', 220, NULL, 'F-protein', 262490),
(443397, 'PF06672', NULL, 'Protein of unknown function (DUF1175)', 225, NULL, 'DUF1175', 262491),
(443398, 'PF15913', NULL, 'Furin-like repeat, cysteine-rich', 102, NULL, 'Furin-like_2', 262492),
(443399, 'PF05116', NULL, 'Sucrose-6F-phosphate phosphohydrolase', 247, NULL, 'S6PP', 262493),
(443400, 'PF15206', NULL, 'FAM209 family', 149, NULL, 'FAM209', 262494),
(443401, 'PF17789', NULL, 'Macroglobulin domain MG4', 97, NULL, 'MG4', 262495),
(443402, 'PF03610', NULL, 'PTS system fructose IIA component', 116, NULL, 'EIIA-man', 262496),
(443403, 'PF15411', NULL, 'Pleckstrin homology domain', 124, NULL, 'PH_10', 262497),
(443404, 'PF17273', NULL, 'Family of unknown function (DUF5338)', 69, NULL, 'DUF5338', 262498),
(443405, 'PF04701', NULL, 'Pox virus D2 protein', 139, NULL, 'Pox_D2', 262499),
(443406, 'PF11561', NULL, 'Single strand annealing-weakened 1', 244, NULL, 'Saw1', 262500),
(443407, 'PF11208', NULL, 'Protein of unknown function (DUF2992)', 132, NULL, 'DUF2992', 262501),
(443408, 'PF18055', NULL, '26S proteasome regulatory subunit RPN6 N-terminal domain', 117, NULL, 'RPN6_N', 262502),
(443409, 'PF08085', NULL, 'Entericidin EcnA/B family', 20, NULL, 'Entericidin', 262503),
(443410, 'PF13197', NULL, 'Protein of unknown function (DUF4013)', 169, NULL, 'DUF4013', 262504),
(443411, 'PF14432', NULL, 'DYW family of nucleic acid deaminases', 93, NULL, 'DYW_deaminase', 262505),
(443412, 'PF15379', NULL, 'Domain of unknown function (DUF4606)', 103, NULL, 'DUF4606', 262506),
(443413, 'PF06466', NULL, 'PCAF (P300/CBP-associated factor) N-terminal domain', 250, NULL, 'PCAF_N', 262507),
(443414, 'PF15260', NULL, 'Protein family FAM219A', 124, NULL, 'FAM219A', 262508),
(443415, 'PF03659', NULL, 'Glycosyl hydrolase family 71', 376, NULL, 'Glyco_hydro_71', 262509),
(443416, 'PF19888', NULL, 'Family of unknown function (DUF6361)', 388, NULL, 'DUF6361', 262510),
(443417, 'PF04560', NULL, 'RNA polymerase Rpb2, domain 7', 87, NULL, 'RNA_pol_Rpb2_7', 262511),
(443418, 'PF05139', NULL, 'Erythromycin esterase', 341, NULL, 'Erythro_esteras', 262512),
(443419, 'PF04886', NULL, 'PT repeat', 36, NULL, 'PT', 262513),
(443420, 'PF09378', NULL, 'HAS barrel domain', 93, NULL, 'HAS-barrel', 262514),
(443421, 'PF19233', NULL, 'Family of unknown function (DUF5886)', 135, NULL, 'DUF5886', 262515),
(443422, 'PF04534', NULL, 'Herpesvirus UL56 protein', 197, NULL, 'Herpes_UL56', 262516),
(443423, 'PF17949', NULL, 'FANCM pseudonuclease domain', 125, NULL, 'PND', 262517),
(443424, 'PF05528', NULL, 'Accessory protein 5b, avian coronavirus', 82, NULL, 'Acc5b_avian_CoV', 262518),
(443425, 'PF08874', NULL, 'Domain of unknown function (DUF1835)', 120, NULL, 'DUF1835', 262519),
(443426, 'PF04250', NULL, 'Protein of unknown function (DUF429)', 209, NULL, 'DUF429', 262520),
(443427, 'PF09601', NULL, 'Protein of unknown function (DUF2459)', 171, NULL, 'DUF2459', 262521),
(443428, 'PF17046', NULL, 'SesB domain on fungal death-pathway protein', 28, NULL, 'Ses_B', 262522),
(443429, 'PF17811', NULL, 'Jumonji helical domain', 104, NULL, 'JHD', 262523),
(443430, 'PF03150', NULL, 'Di-haem cytochrome c peroxidase', 150, NULL, 'CCP_MauG', 262524),
(443431, 'PF07484', NULL, 'Phage Tail Collar Domain', 57, NULL, 'Collar', 262525),
(443432, 'PF08197', NULL, 'pORF2a truncated protein', 49, NULL, 'TT_ORF2a', 262526),
(443433, 'PF11795', NULL, 'Uncharacterized protein conserved in bacteria N-term (DUF3322)', 190, NULL, 'DUF3322', 262527),
(443434, 'PF11846', NULL, 'Virulence factor membrane-bound polymerase, C-terminal', 188, NULL, 'Wzy_C_2', 262528),
(443435, 'PF17006', NULL, 'Domain of unknown function (DUF5087)', 292, NULL, 'DUF5087', 262529);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(443436, 'PF18297', NULL, 'NFACT protein RNA binding domain', 104, NULL, 'NFACT-R_2', 262530),
(443437, 'PF17622', NULL, 'Viral unique long protein 16', 204, NULL, 'UL16', 262531),
(443438, 'PF02863', NULL, 'Arginine repressor, C-terminal domain', 68, NULL, 'Arg_repressor_C', 262532),
(443439, 'PF18557', NULL, 'Anti-sigma factor NepR', 35, NULL, 'NepR', 262533),
(443440, 'PF07519', NULL, 'Tannase and feruloyl esterase', 469, NULL, 'Tannase', 262534),
(443441, 'PF10125', NULL, 'NADH dehydrogenase I, subunit N related protein', 218, NULL, 'NADHdeh_related', 262535),
(443442, 'PF11019', NULL, 'Protein of unknown function (DUF2608)', 244, NULL, 'DUF2608', 262536),
(443443, 'PF11616', NULL, 'WD repeat binding protein EZH2', 30, NULL, 'EZH2_WD-Binding', 262537),
(443444, 'PF02251', NULL, 'Proteasome activator pa28 alpha subunit', 61, NULL, 'PA28_alpha', 262538),
(443445, 'PF01985', NULL, 'CRS1 / YhbY (CRM) domain', 84, NULL, 'CRS1_YhbY', 262539),
(443446, 'PF14850', NULL, 'DNA-binding domain of Proline dehydrogenase', 112, NULL, 'Pro_dh-DNA_bdg', 262540),
(443447, 'PF11939', NULL, '[NiFe]-hydrogenase assembly, chaperone, HybE', 158, NULL, 'NiFe-hyd_HybE', 262541),
(443448, 'PF12461', NULL, 'Spiroplasma phage ORF1-like family', 708, NULL, 'DUF3688', 262542),
(443449, 'PF19002', NULL, 'Family of unknown function (DUF5731)', 108, NULL, 'DUF5731', 262543),
(443450, 'PF16135', NULL, 'Tify domain binding domain', 52, NULL, 'TDBD', 262544),
(443451, 'PF10391', NULL, 'Fingers domain of DNA polymerase lambda', 51, NULL, 'DNA_pol_lambd_f', 262545),
(443452, 'PF08393', NULL, 'Dynein heavy chain, N-terminal region 2', 399, NULL, 'DHC_N2', 262546),
(443453, 'PF13030', NULL, 'Protein of unknown function (DUF3891)', 218, NULL, 'DUF3891', 262547),
(443454, 'PF06891', NULL, 'P2 phage tail completion protein R (GpR)', 131, NULL, 'P2_Phage_GpR', 262548),
(443455, 'PF02885', NULL, 'Glycosyl transferase family, helical bundle domain', 63, NULL, 'Glycos_trans_3N', 262549),
(443456, 'PF17242', NULL, 'Disordered region of unknown function (DUF5315)', 77, NULL, 'DUF5315', 262550),
(443457, 'PF10606', NULL, 'Homer-binding domain of metabotropic glutamate receptor', 51, NULL, 'GluR_Homer-bdg', 262551),
(443458, 'PF07910', NULL, 'Peptidase family C78', 212, NULL, 'Peptidase_C78', 262552),
(443459, 'PF13564', NULL, 'DoxX-like family', 103, NULL, 'DoxX_2', 262553),
(443460, 'PF01930', NULL, 'Domain of unknown function DUF83', 162, NULL, 'Cas_Cas4', 262554),
(443461, 'PF10347', NULL, 'RNA pol II promoter Fmp27 protein domain', 156, NULL, 'Fmp27_GFWDK', 262555),
(443462, 'PF12678', NULL, 'RING-H2 zinc finger domain', 55, NULL, 'zf-rbx1', 262556),
(443463, 'PF18106', NULL, 'Rolling Circle replication initiation protein N-terminal domain', 91, NULL, 'Rol_Rep_N', 262557),
(443464, 'PF14157', NULL, 'YmzC-like protein', 58, NULL, 'YmzC', 262558),
(443465, 'PF02229', NULL, 'Transcriptional Coactivator p15 (PC4)', 52, NULL, 'PC4', 262559),
(443466, 'PF06406', NULL, 'StbA protein', 317, NULL, 'StbA', 262560),
(443467, 'PF08202', NULL, 'Mis12-Mtw1 protein family', 301, NULL, 'MIS13', 262561),
(443468, 'PF08208', NULL, 'DNA-directed RNA polymerase I subunit RPA34.5', 207, NULL, 'RNA_polI_A34', 262562),
(443469, 'PF03842', NULL, 'Silicon transporter', 513, NULL, 'Silic_transp', 262563),
(443470, 'PF13859', NULL, 'BNR repeat-like domain', 310, NULL, 'BNR_3', 262564),
(443471, 'PF13455', NULL, 'Meiotically up-regulated gene 113', 77, NULL, 'MUG113', 262565),
(443472, 'PF05374', NULL, 'Mu-Conotoxin', 22, NULL, 'Mu-conotoxin', 262566),
(443473, 'PF08792', NULL, 'A2L zinc ribbon domain', 33, NULL, 'A2L_zn_ribbon', 262567),
(443474, 'PF10625', NULL, 'Universal stress protein B (UspB)', 107, NULL, 'UspB', 262568),
(443475, 'PF06935', NULL, 'Protein of unknown function (DUF1284)', 102, NULL, 'DUF1284', 262569),
(443476, 'PF05375', NULL, 'Pacifastin inhibitor (LCMII)', 40, NULL, 'Pacifastin_I', 262570),
(443477, 'PF19437', NULL, 'VCIP135 N-terminal', 167, NULL, 'VCIP135_N', 262571),
(443478, 'PF05757', NULL, 'Oxygen evolving enhancer protein 3 (PsbQ)', 200, NULL, 'PsbQ', 262572);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(443479, 'PF02308', NULL, 'MgtC family', 121, NULL, 'MgtC', 262573),
(443480, 'PF03754', NULL, 'B3 domain-containing protein At2g31720-like', 113, NULL, 'At2g31720-like', 262574),
(443481, 'PF01920', NULL, 'Prefoldin subunit', 106, NULL, 'Prefoldin_2', 262575),
(443482, 'PF11395', NULL, 'Betacoronavirus NS7B protein', 43, NULL, 'bCoV_NS7B', 262576),
(443483, 'PF18290', NULL, 'Nudix hydrolase domain', 80, NULL, 'Nudix_hydro', 262577),
(443484, 'PF18588', NULL, 'Polysaccharide biosynthesis enzyme WcbI', 205, NULL, 'WcbI', 262578),
(443485, 'PF08946', NULL, 'Osmosensory transporter coiled coil', 46, NULL, 'Osmo_CC', 262579),
(443486, 'PF15808', NULL, 'BCL-6 co-repressor, non-ankyrin-repeat region', 216, NULL, 'BCOR', 262580),
(443487, 'PF16414', NULL, 'Niemann-Pick C1 N terminus', 247, NULL, 'NPC1_N', 262581),
(443488, 'PF14271', NULL, 'Domain of unknown function (DUF4359)', 103, NULL, 'DUF4359', 262582),
(443489, 'PF13313', NULL, 'Domain of unknown function (DUF4082)', 145, NULL, 'DUF4082', 262583),
(443490, 'PF01101', NULL, 'HMG14 and HMG17', 90, NULL, 'HMG14_17', 262584),
(443491, 'PF15368', NULL, 'Spermatogenesis family BioT2', 170, NULL, 'BioT2', 262585),
(443492, 'PF09034', NULL, 'TRADD, N-terminal domain', 112, NULL, 'TRADD_N', 262586),
(443493, 'PF03337', NULL, 'Poxvirus F12L protein', 648, NULL, 'Pox_F12L', 262587),
(443494, 'PF16358', NULL, 'RcsF lipoprotein', 110, NULL, 'RcsF', 262588),
(443495, 'PF17248', NULL, 'Family of unknown function (DUF5317)', 150, NULL, 'DUF5317', 262589),
(443496, 'PF18038', NULL, 'FERM N-terminal domain', 99, NULL, 'FERM_N_2', 262590),
(443497, 'PF14522', NULL, 'Cytochrome c7 and related cytochrome c', 64, NULL, 'Cytochrome_C7', 262591),
(443498, 'PF07548', NULL, 'Chlamydia polymorphic membrane protein middle domain', 178, NULL, 'ChlamPMP_M', 262592),
(443499, 'PF08888', NULL, 'HopJ type III effector protein', 109, NULL, 'HopJ', 262593),
(443500, 'PF19520', NULL, 'Dipeptidyl peptidase 8 and 9 N-terminal', 155, NULL, 'Dpp_8_9_N', 262594),
(443501, 'PF04507', NULL, 'Csa1 family', 225, NULL, 'DUF576', 262595),
(443502, 'PF04588', NULL, 'Hypoxia induced protein conserved region', 52, NULL, 'HIG_1_N', 262596),
(443503, 'PF04755', NULL, 'PAP_fibrillin', 198, NULL, 'PAP_fibrillin', 262597),
(443504, 'PF14082', NULL, 'Domain of unknown function (DUF4263)', 159, NULL, 'DUF4263', 262598),
(443505, 'PF13489', NULL, 'Methyltransferase domain', 165, NULL, 'Methyltransf_23', 262599),
(443506, 'PF15598', NULL, 'Immunity protein 61', 157, NULL, 'Imm61', 262600),
(443507, 'PF12385', NULL, 'Papain-like cysteine protease AvrRpt2', 143, NULL, 'Peptidase_C70', 262601),
(443508, 'PF00544', NULL, 'Pectate lyase', 211, NULL, 'Pectate_lyase_4', 262602),
(443509, 'PF15611', NULL, 'EH_Signature domain', 418, NULL, 'EH_Signature', 262603),
(443510, 'PF00352', NULL, 'Transcription factor TFIID (or TATA-binding protein, TBP)', 85, NULL, 'TBP', 262604),
(443511, 'PF18438', NULL, 'Glycosyl hydrolases family 38 C-terminal domain 1', 111, NULL, 'Glyco_hydro_38', 262605),
(443512, 'PF19074', NULL, 'Family of unknown function (DUF5770)', 131, NULL, 'DUF5770', 262606),
(443513, 'PF09815', NULL, 'XK-related protein', 339, NULL, 'XK-related', 262607),
(443514, 'PF10114', NULL, 'Sensory domain found in PocR', 162, NULL, 'PocR', 262608),
(443515, 'PF10534', NULL, 'Connector enhancer of kinase suppressor of ras', 93, NULL, 'CRIC_ras_sig', 262609),
(443516, 'PF01561', NULL, 'Hantavirus/Nairovirus glycoprotein G2', 551, NULL, 'Hanta_G2', 262610),
(443517, 'PF11386', NULL, 'Vitelline envelope receptor for lysin', 78, NULL, 'VERL', 262611),
(443518, 'PF00584', NULL, 'SecE/Sec61-gamma subunits of protein translocation complex', 55, NULL, 'SecE', 262612),
(443519, 'PF10044', NULL, 'Retinal tissue protein', 95, NULL, 'LIN52', 262613),
(443520, 'PF18606', NULL, 'Zap  helix turn helix N-terminal domain', 62, NULL, 'HTH_53', 262614),
(443521, 'PF12197', NULL, 'Bacillus cereus group antimicrobial protein', 45, NULL, 'lci', 262615),
(443522, 'PF13938', NULL, 'Putative heavy-metal chelation', 73, NULL, 'DUF4213', 262616);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(443523, 'PF10113', NULL, 'FeGP cofactor biosynthesis protein, fibrillarin family', 501, NULL, 'Fibrillarin_2', 262617),
(443524, 'PF04404', NULL, 'ERF superfamily', 151, NULL, 'ERF', 262618),
(443525, 'PF05336', NULL, 'L-rhamnose mutarotase', 108, NULL, 'rhaM', 262619),
(443526, 'PF03564', NULL, 'Protein of unknown function (DUF1759)', 148, NULL, 'DUF1759', 262620),
(443527, 'PF10938', NULL, 'YfdX protein', 149, NULL, 'YfdX', 262621),
(443528, 'PF00399', NULL, 'Yeast PIR protein repeat', 18, NULL, 'PIR', 262622),
(443529, 'PF07353', NULL, 'Uroplakin II', 179, NULL, 'Uroplakin_II', 262623),
(443530, 'PF00993', NULL, 'Class II histocompatibility antigen, alpha domain', 81, NULL, 'MHC_II_alpha', 262624),
(443531, 'PF07781', NULL, 'Reovirus minor core protein Mu-2', 727, NULL, 'Reovirus_Mu2', 262625),
(443532, 'PF12199', NULL, 'Extracellular fibrinogen binding protein C terminal', 65, NULL, 'efb-c', 262626),
(443533, 'PF11902', NULL, 'Protein of unknown function (DUF3422)', 419, NULL, 'DUF3422', 262627),
(443534, 'PF13649', NULL, 'Methyltransferase domain', 97, NULL, 'Methyltransf_25', 262628),
(443535, 'PF05673', NULL, 'Protein of unknown function (DUF815)', 247, NULL, 'DUF815', 262629),
(443536, 'PF10908', NULL, 'Protein of unknown function (DUF2778)', 120, NULL, 'DUF2778', 262630),
(443537, 'PF04501', NULL, 'Baculovirus major capsid protein VP39', 244, NULL, 'Baculo_VP39', 262631),
(443538, 'PF08695', NULL, 'Cytochrome oxidase complex assembly protein 1', 117, NULL, 'Coa1', 262632),
(443539, 'PF10532', NULL, 'Plant specific N-all beta domain', 114, NULL, 'Plant_all_beta', 262633),
(443540, 'PF18843', NULL, 'Large polyvalent protein associated domain 28', 97, NULL, 'LPD28', 262634),
(443541, 'PF20453', NULL, 'Family of unknown function (DUF6707)', 291, NULL, 'DUF6707', 262635),
(443542, 'PF18266', NULL, 'Nicastrin small lobe', 169, NULL, 'Ncstrn_small', 262636),
(443543, 'PF02119', NULL, 'Flagellar P-ring protein', 343, NULL, 'FlgI', 262637),
(443544, 'PF04835', NULL, 'A9 protein conserved region', 53, NULL, 'Pox_A9', 262638),
(443545, 'PF20335', NULL, 'Family of unknown function (DUF6630)', 172, NULL, 'DUF6630', 262639),
(443546, 'PF01345', NULL, 'Domain of unknown function DUF11', 114, NULL, 'DUF11', 262640),
(443547, 'PF02177', NULL, 'Amyloid A4 N-terminal heparin-binding', 100, NULL, 'APP_N', 262641),
(443548, 'PF08709', NULL, 'Inositol 1,4,5-trisphosphate/ryanodine receptor', 213, NULL, 'Ins145_P3_rec', 262642),
(443549, 'PF02502', NULL, 'Ribose/Galactose Isomerase', 139, NULL, 'LacAB_rpiB', 262643),
(443550, 'PF03190', NULL, 'Protein of unknown function, DUF255', 163, NULL, 'Thioredox_DsbH', 262644),
(443551, 'PF14724', NULL, 'Mitochondrial-associated sphingomyelin phosphodiesterase', 816, NULL, 'mit_SMPDase', 262645),
(443552, 'PF09727', NULL, 'Cortactin-binding protein-2', 188, NULL, 'CortBP2', 262646),
(443553, 'PF13292', NULL, '1-deoxy-D-xylulose-5-phosphate synthase', 273, NULL, 'DXP_synthase_N', 262647),
(443554, 'PF07048', NULL, 'Protein of unknown function (DUF1331)', 35, NULL, 'DUF1331', 262648),
(443555, 'PF00897', NULL, 'Orbivirus inner capsid protein VP7', 348, NULL, 'Orbi_VP7', 262649),
(443556, 'PF14460', NULL, 'Prokaryotic E2 family D', 171, NULL, 'Prok-E2_D', 262650),
(443557, 'PF08864', NULL, 'UPF0302 domain', 105, NULL, 'UPF0302', 262651),
(443558, 'PF19619', NULL, 'Family of unknown function (DUF6124)', 75, NULL, 'DUF6124', 262652),
(443559, 'PF14920', NULL, 'MDM2-binding', 257, NULL, 'MTBP_C', 262653),
(443560, 'PF14774', NULL, 'FAM177 family', 117, NULL, 'FAM177', 262654),
(443561, 'PF01758', NULL, 'Sodium Bile acid symporter family', 195, NULL, 'SBF', 262655),
(443562, 'PF20049', NULL, 'Domain of unknown function (DUF6451)', 33, NULL, 'DUF6451', 262656),
(443563, 'PF02247', NULL, 'Large coat protein', 373, NULL, 'Como_LCP', 262657),
(443564, 'PF01850', NULL, 'PIN domain', 122, NULL, 'PIN', 262658),
(443565, 'PF08599', NULL, 'DNA damage repair protein Nbs1', 64, NULL, 'Nbs1_C', 262659),
(443566, 'PF16671', NULL, 'Actin cross-linking domain', 386, NULL, 'ACD', 262660);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(443567, 'PF18855', NULL, 'Bacterial archaeo-eukaryotic release factor family 11', 139, NULL, 'baeRF_family11', 262661),
(443568, 'PF10136', NULL, 'Site-specific recombinase', 641, NULL, 'SpecificRecomb', 262662),
(443569, 'PF05403', NULL, 'Plasmodium histidine-rich protein (HRPII/III)', 218, NULL, 'Plasmodium_HRP', 262663),
(443570, 'PF16795', NULL, 'Archaeal phage integrase', 160, NULL, 'Phage_integr_3', 262664),
(443571, 'PF10554', NULL, 'Ash protein family', 109, NULL, 'Phage_ASH', 262665),
(443572, 'PF14618', NULL, 'Domain of unknown function (DUF4452)', 170, NULL, 'DUF4452', 262666),
(443573, 'PF07840', NULL, 'FadR C-terminal domain', 164, NULL, 'FadR_C', 262667),
(443574, 'PF20273', NULL, 'Domain observed between E2 and E1 domains', 118, NULL, 'E2-E1mid', 262668),
(443575, 'PF07068', NULL, 'Major capsid protein Gp23', 509, NULL, 'Gp23', 262669),
(443576, 'PF13719', NULL, 'zinc-ribbon domain', 37, NULL, 'zinc_ribbon_5', 262670),
(443577, 'PF02414', NULL, 'Borrelia ORF-A', 291, NULL, 'Borrelia_orfA', 262671),
(443578, 'PF08742', NULL, 'C8 domain', 67, NULL, 'C8', 262672),
(443579, 'PF07357', NULL, 'Dinitrogenase reductase ADP-ribosyltransferase (DRAT)', 257, NULL, 'DRAT', 262673),
(443580, 'PF04272', NULL, 'Phospholamban', 52, NULL, 'Phospholamban', 262674),
(443581, 'PF06012', NULL, 'Domain of Unknown Function (DUF908)', 358, NULL, 'DUF908', 262675),
(443582, 'PF01681', NULL, 'C6 domain', 91, NULL, 'C6', 262676),
(443583, 'PF03632', NULL, 'Glycosyl hydrolase family 65 central catalytic domain', 387, NULL, 'Glyco_hydro_65m', 262677),
(443584, 'PF08200', NULL, 'Bacteriophage 1.1 Protein', 45, NULL, 'Phage_1_1', 262678),
(443585, 'PF11843', NULL, 'Protein of unknown function (DUF3363)', 377, NULL, 'DUF3363', 262679),
(443586, 'PF19595', NULL, 'Family of unknown function (DUF6100)', 222, NULL, 'DUF6100', 262680),
(443587, 'PF03462', NULL, 'PCRF domain', 192, NULL, 'PCRF', 262681),
(443588, 'PF09639', NULL, 'YjcQ protein', 96, NULL, 'YjcQ', 262682),
(443589, 'PF08923', NULL, 'Mitogen-activated protein kinase kinase 1 interacting', 119, NULL, 'MAPKK1_Int', 262683),
(443590, 'PF07382', NULL, 'Histone H1-like nucleoprotein HC2', 194, NULL, 'HC2', 262684),
(443591, 'PF19757', NULL, 'Family of unknown function (DUF6244)', 87, NULL, 'DUF6244', 262685),
(443592, 'PF07716', NULL, 'Basic region leucine zipper', 54, NULL, 'bZIP_2', 262686),
(443593, 'PF13808', NULL, 'DDE_Tnp_1-associated', 88, NULL, 'DDE_Tnp_1_assoc', 262687),
(443594, 'PF19222', NULL, 'Nodavirus Vmethyltransferase', 148, NULL, 'Noda_Vmethyltr', 262688),
(443595, 'PF15151', NULL, 'Response gene to complement 32 protein family', 128, NULL, 'RGCC', 262689),
(443596, 'PF04911', NULL, 'ATP synthase j chain', 51, NULL, 'ATP-synt_J', 262690),
(443597, 'PF17969', NULL, 'L,D-transpeptidase C-terminal domain', 67, NULL, 'Ldt_C', 262691),
(443598, 'PF06649', NULL, 'Protein of unknown function (DUF1161)', 52, NULL, 'DUF1161', 262692),
(443599, 'PF11445', NULL, 'Protein of unknown function (DUF2894)', 181, NULL, 'DUF2894', 262693),
(443600, 'PF13982', NULL, 'YbfN-like lipoprotein', 88, NULL, 'YbfN', 262694),
(443601, 'PF16581', NULL, 'Cytidyltransferase-related C-terminal region', 203, NULL, 'HIGH_NTase1_ass', 262695),
(443602, 'PF06701', NULL, 'Mib_herc2', 66, NULL, 'MIB_HERC2', 262696),
(443603, 'PF08515', NULL, 'Transforming growth factor beta type I GS-motif', 28, NULL, 'TGF_beta_GS', 262697),
(443604, 'PF08466', NULL, 'Inward rectifier potassium channel N-terminal', 45, NULL, 'IRK_N', 262698),
(443605, 'PF04389', NULL, 'Peptidase family M28', 198, NULL, 'Peptidase_M28', 262699),
(443606, 'PF16144', NULL, 'Domain of unknown function (DUF4852)', 119, NULL, 'DUF4852', 262700),
(443607, 'PF00091', NULL, 'Tubulin/FtsZ family, GTPase domain', 197, NULL, 'Tubulin', 262701),
(443608, 'PF09786', NULL, 'Cytochrome B561, N terminal', 570, NULL, 'CytochromB561_N', 262702),
(443609, 'PF16935', NULL, 'Putative Holin-like Toxin (Hol-Tox)', 35, NULL, 'Hol_Tox', 262703),
(443610, 'PF02310', NULL, 'B12 binding domain', 121, NULL, 'B12-binding', 262704),
(443611, 'PF03948', NULL, 'Ribosomal protein L9, C-terminal domain', 87, NULL, 'Ribosomal_L9_C', 262705);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(443612, 'PF07147', NULL, 'Mitochondrial 28S ribosomal protein S30 (PDCD9)', 448, NULL, 'PDCD9', 262706),
(443613, 'PF00058', NULL, 'Low-density lipoprotein receptor repeat class B', 42, NULL, 'Ldl_recept_b', 262707),
(443614, 'PF00496', NULL, 'Bacterial extracellular solute-binding proteins, family 5 Middle', 377, NULL, 'SBP_bac_5', 262708),
(443615, 'PF18661', NULL, 'Avirulence Effector AvrLm4-7', 86, NULL, 'AvrLm4-7', 262709),
(443616, 'PF12874', NULL, 'Zinc-finger of C2H2 type', 25, NULL, 'zf-met', 262710),
(443617, 'PF03095', NULL, 'Phosphotyrosyl phosphate activator (PTPA) protein', 303, NULL, 'PTPA', 262711),
(443618, 'PF04376', NULL, 'Arginine-tRNA-protein transferase, N terminus', 81, NULL, 'ATE_N', 262712),
(443619, 'PF04984', NULL, 'Phage tail sheath protein subtilisin-like domain', 168, NULL, 'Phage_sheath_1', 262713),
(443620, 'PF11200', NULL, 'Protein of unknown function (DUF2981)', 354, NULL, 'DUF2981', 262714),
(443621, 'PF14285', NULL, 'Domain of unknown function (DUF4367)', 110, NULL, 'DUF4367', 262715),
(443622, 'PF18212', NULL, 'ZNRF-3 Ectodomain', 105, NULL, 'ZNRF_3_ecto', 262716),
(443623, 'PF01984', NULL, 'Double-stranded DNA-binding domain', 109, NULL, 'dsDNA_bind', 262717),
(443624, 'PF04523', NULL, 'Herpes virus tegument protein U30', 917, NULL, 'Herpes_U30', 262718),
(443625, 'PF07539', NULL, 'Down-regulated in metastasis', 619, NULL, 'DRIM', 262719),
(443626, 'PF14602', NULL, 'Hexapeptide repeat of succinyl-transferase', 34, NULL, 'Hexapep_2', 262720),
(443627, 'PF16606', NULL, 'Unstructured conserved, between two C2H2-type zinc-fingers', 81, NULL, 'zf-C2H2_assoc', 262721),
(443628, 'PF08631', NULL, 'Meiosis protein SPO22/ZIP4 like', 275, NULL, 'SPO22', 262722),
(443629, 'PF14049', NULL, 'Dppa2/4 conserved region in higher vertebrates', 85, NULL, 'Dppa2_A', 262723),
(443630, 'PF02415', NULL, 'Chlamydia polymorphic membrane protein (Chlamydia_PMP) repeat', 28, NULL, 'Chlam_PMP', 262724),
(443631, 'PF05491', NULL, 'RuvB C-terminal winged helix domain', 72, NULL, 'RuvB_C', 262725),
(443632, 'PF13908', NULL, 'Wnt and FGF inhibitory regulator', 194, NULL, 'Shisa', 262726),
(443633, 'PF04599', NULL, 'Poxvirus G5 protein', 425, NULL, 'Pox_G5', 262727),
(443634, 'PF09528', NULL, 'Ehrlichia tandem repeat (Ehrlichia_rpt)', 36, NULL, 'Ehrlichia_rpt', 262728),
(443635, 'PF13856', NULL, 'ATP-binding sugar transporter from pro-phage', 99, NULL, 'Gifsy-2', 262729),
(443636, 'PF02391', NULL, 'MoaE protein', 113, NULL, 'MoaE', 262730),
(443637, 'PF00331', NULL, 'Glycosyl hydrolase family 10', 316, NULL, 'Glyco_hydro_10', 262731),
(443638, 'PF00335', NULL, 'Tetraspanin family', 232, NULL, 'Tetraspanin', 262732),
(443639, 'PF07746', NULL, 'Aromatic-ring-opening dioxygenase LigAB, LigA subunit', 87, NULL, 'LigA', 262733),
(443640, 'PF06686', NULL, 'Stage III sporulation protein AC/AD protein family', 56, NULL, 'SpoIIIAC', 262734),
(443641, 'PF06732', NULL, 'Pescadillo N-terminus', 273, NULL, 'Pescadillo_N', 262735),
(443642, 'PF20370', NULL, 'Family of unknown function (DUF6665)', 106, NULL, 'DUF6665', 262736),
(443643, 'PF07837', NULL, 'Formiminotransferase domain, N-terminal subdomain', 176, NULL, 'FTCD_N', 262737),
(443644, 'PF13300', NULL, 'Domain of unknown function (DUF4078)', 86, NULL, 'DUF4078', 262738),
(443645, 'PF14379', NULL, 'MYB-CC type transfactor, LHEQLE motif', 48, NULL, 'Myb_CC_LHEQLE', 262739),
(443646, 'PF15013', NULL, 'CCSMST1 family', 75, NULL, 'CCSMST1', 262740),
(443647, 'PF07841', NULL, 'DM4/DM12 family', 85, NULL, 'DM4_12', 262741),
(443648, 'PF20186', NULL, 'Family of unknown function (DUF6549)', 167, NULL, 'DUF6549', 262742),
(443649, 'PF02710', NULL, 'Hemagglutinin domain of haemagglutinin-esterase-fusion glycoprotein', 155, NULL, 'Hema_HEFG', 262743),
(443650, 'PF03848', NULL, 'Tellurite resistance protein TehB', 193, NULL, 'TehB', 262744),
(443651, 'PF04828', NULL, 'Glutathione-dependent formaldehyde-activating enzyme', 93, NULL, 'GFA', 262745),
(443652, 'PF06380', NULL, 'Protein of unknown function (DUF1072)', 39, NULL, 'DUF1072', 262746),
(443653, 'PF02091', NULL, 'Glycyl-tRNA synthetase alpha subunit', 278, NULL, 'tRNA-synt_2e', 262747);
INSERT INTO "PUBLIC"."MODEL" VALUES
(443654, 'PF06222', NULL, 'Phage tail assembly chaperone', 127, NULL, 'Phage_TAC_1', 262748),
(443655, 'PF14391', NULL, 'Domain of unknown function (DUF4421)', 298, NULL, 'DUF4421', 262749),
(443656, 'PF12462', NULL, 'DNA helicase IV / RNA helicase N terminal', 162, NULL, 'Helicase_IV_N', 262750),
(443657, 'PF10420', NULL, 'Cytokine interleukin-12p40 C-terminus', 84, NULL, 'IL12p40_C', 262751),
(443658, 'PF02702', NULL, 'Osmosensitive K+ channel His kinase sensor domain', 210, NULL, 'KdpD', 262752),
(443659, 'PF02282', NULL, 'DNA polymerase processivity factor (UL42)', 154, NULL, 'Herpes_UL42', 262753),
(443660, 'PF12862', NULL, 'Anaphase-promoting complex subunit 5', 92, NULL, 'ANAPC5', 262754),
(443661, 'PF05652', NULL, 'Scavenger mRNA decapping enzyme (DcpS) N-terminal', 104, NULL, 'DcpS', 262755),
(443662, 'PF01372', NULL, 'Melittin', 26, NULL, 'Melittin', 262756),
(443663, 'PF15138', NULL, 'Syncollin', 112, NULL, 'Syncollin', 262757),
(443664, 'PF20004', NULL, 'FtsH ternary system domain X6', 349, NULL, 'fvmX6', 262758),
(443665, 'PF10731', NULL, 'Thrombin inhibitor from mosquito', 65, NULL, 'Anophelin', 262759),
(443666, 'PF01701', NULL, 'Photosystem I reaction centre subunit IX / PsaJ', 37, NULL, 'PSI_PsaJ', 262760),
(443667, 'PF04758', NULL, 'Ribosomal protein S30', 58, NULL, 'Ribosomal_S30', 262761),
(443668, 'PF11700', NULL, 'Vacuole effluxer Atg22 like', 478, NULL, 'ATG22', 262762),
(443669, 'PF02632', NULL, 'BioY family', 137, NULL, 'BioY', 262763),
(443670, 'PF08340', NULL, 'Domain of unknown function (DUF1732)', 85, NULL, 'DUF1732', 262764),
(443671, 'PF13144', NULL, 'Chaperone for flagella basal body P-ring formation', 122, NULL, 'ChapFlgA', 262765),
(443672, 'PF12124', NULL, 'Betacoronavirus SUD-C domain', 66, NULL, 'bCoV_SUD_C', 262766),
(443673, 'PF05343', NULL, 'M42 glutamyl aminopeptidase', 292, NULL, 'Peptidase_M42', 262767),
(443674, 'PF04603', NULL, 'Ran-interacting Mog1 protein', 135, NULL, 'Mog1', 262768),
(443675, 'PF12576', NULL, 'Protein of unknown function (DUF3754)', 140, NULL, 'DUF3754', 262769),
(443676, 'PF00410', NULL, 'Ribosomal protein S8', 126, NULL, 'Ribosomal_S8', 262770),
(443677, 'PF14135', NULL, 'Domain of unknown function (DUF4302)', 236, NULL, 'DUF4302', 262771),
(443678, 'PF02535', NULL, 'ZIP Zinc transporter', 333, NULL, 'Zip', 262772),
(443679, 'PF09248', NULL, 'Domain of unknown function (DUF1965)', 69, NULL, 'DUF1965', 262773),
(443680, 'PF16773', NULL, 'Lactococcus phage single-stranded DNA binding protein', 117, NULL, 'Phage_SSB', 262774),
(443681, 'PF07706', NULL, 'Aminotransferase ubiquitination site', 40, NULL, 'TAT_ubiq', 262775),
(443682, 'PF14987', NULL, 'NADH dehydrogenase 1 alpha subcomplex subunit 3', 78, NULL, 'NADHdh_A3', 262776),
(443683, 'PF13833', NULL, 'EF-hand domain pair', 54, NULL, 'EF-hand_8', 262777),
(443684, 'PF12109', NULL, 'CXCR4 Chemokine receptor N terminal', 33, NULL, 'CXCR4_N', 262778),
(443685, 'PF05792', NULL, 'Candida agglutinin-like (ALS)', 32, NULL, 'Candida_ALS', 262779),
(443686, 'PF14237', NULL, 'GYF domain 2', 50, NULL, 'GYF_2', 262780),
(443687, 'PF04967', NULL, 'HTH DNA binding domain', 53, NULL, 'HTH_10', 262781),
(443688, 'PF06636', NULL, 'Protein of unknown function (DUF1157)', 370, NULL, 'DUF1157', 262782),
(443689, 'PF15034', NULL, 'KRTAP type 7 family', 84, NULL, 'KRTAP7', 262783),
(443690, 'PF06886', NULL, 'Targeting protein for Xklp2 (TPX2) domain', 77, NULL, 'TPX2', 262784),
(443691, 'PF14659', NULL, 'Phage integrase, N-terminal SAM-like domain', 58, NULL, 'Phage_int_SAM_3', 262785),
(443692, 'PF15941', NULL, 'FidL-like putative membrane protein', 90, NULL, 'FidL_like', 262786),
(443693, 'PF00940', NULL, 'DNA-dependent RNA polymerase', 426, NULL, 'RNA_pol', 262787),
(443694, 'PF10545', NULL, 'Alcohol dehydrogenase transcription factor Myb/SANT-like', 84, NULL, 'MADF_DNA_bdg', 262788),
(443695, 'PF19680', NULL, 'Family of unknown function (DUF6182)', 242, NULL, 'DUF6182', 262789),
(443696, 'PF08417', NULL, 'Pheophorbide a oxygenase', 88, NULL, 'PaO', 262790),
(443697, 'PF09618', NULL, 'CRISPR-associated protein (Cas_Csy4)', 182, NULL, 'Cas_Csy4', 262791);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(443698, 'PF13119', NULL, 'Domain of unknown function (DUF3973)', 40, NULL, 'DUF3973', 262792),
(443699, 'PF17007', NULL, 'HTH-like', 454, NULL, 'HTH_micro', 262793),
(443700, 'PF03767', NULL, 'HAD superfamily, subfamily IIIB (Acid phosphatase)', 230, NULL, 'Acid_phosphat_B', 262794),
(443701, 'PF16696', NULL, 'Zinc finger FYVE domain-containing protein 21 C-terminus', 123, NULL, 'ZFYVE21_C', 262795),
(443702, 'PF02107', NULL, 'Flagellar L-ring protein', 168, NULL, 'FlgH', 262796),
(443703, 'PF08285', NULL, 'Dolichol-phosphate mannosyltransferase subunit 3 (DPM3)', 90, NULL, 'DPM3', 262797),
(443704, 'PF20538', NULL, 'Family of unknown function (DUF6753)', 217, NULL, 'DUF6753', 262798),
(443705, 'PF07505', NULL, 'Protein of unknown function (DUF5131)', 247, NULL, 'DUF5131', 262799),
(443706, 'PF09007', NULL, 'EBP50, C-terminal', 128, NULL, 'EBP50_C', 262800),
(443707, 'PF16831', NULL, 'CS6 fimbrial subunits A and B, Coli surface antigen 6', 129, NULL, 'CssAB', 262801),
(443708, 'PF09964', NULL, 'Uncharacterized protein conserved in bacteria (DUF2198)', 72, NULL, 'DUF2198', 262802),
(443709, 'PF15653', NULL, 'URI fold toxin 2', 86, NULL, 'Tox-URI2', 262803),
(443710, 'PF18649', NULL, 'EcpB C-terminal domain', 72, NULL, 'EcpB_C', 262804),
(443711, 'PF01767', NULL, 'Birnavirus VP3 protein', 227, NULL, 'Birna_VP3', 262805),
(443712, 'PF13877', NULL, 'Potential Monad-binding region of RPAP3', 92, NULL, 'RPAP3_C', 262806),
(443713, 'PF17446', NULL, 'Late transcription unit A', 46, NULL, 'LtuA', 262807),
(443714, 'PF14611', NULL, 'Mitochondrial inner-membrane-bound regulator', 221, NULL, 'SLS', 262808),
(443715, 'PF17399', NULL, 'Domain of unknown function (DUF5405)', 94, NULL, 'DUF5405', 262809),
(443716, 'PF17055', NULL, 'Viral matrix protein M2', 235, NULL, 'VMR2', 262810),
(443717, 'PF10084', NULL, 'Uncharacterized protein conserved in bacteria (DUF2322)', 99, NULL, 'DUF2322', 262811),
(443718, 'PF04119', NULL, 'Heat shock protein 9/12', 59, NULL, 'HSP9_HSP12', 262812),
(443719, 'PF05246', NULL, 'Protein of unknown function (DUF735)', 204, NULL, 'DUF735', 262813),
(443720, 'PF01103', NULL, 'Omp85 superfamily domain', 324, NULL, 'Omp85', 262814),
(443721, 'PF12289', NULL, 'Rotavirus VP1 C-terminal domain', 313, NULL, 'Rotavirus_VP1', 262815),
(443722, 'PF14636', NULL, 'Folliculin-interacting protein N-terminus', 142, NULL, 'FNIP_N', 262816),
(443723, 'PF03380', NULL, 'Caenorhabditis protein of unknown function, DUF282', 38, NULL, 'DUF282', 262817),
(443724, 'PF09444', NULL, 'MRC1-like domain', 147, NULL, 'MRC1', 262818),
(443725, 'PF05142', NULL, 'Domain of unknown function (DUF702)', 147, NULL, 'DUF702', 262819),
(443726, 'PF03405', NULL, 'Fatty acid desaturase', 326, NULL, 'FA_desaturase_2', 262820),
(443727, 'PF07589', NULL, 'PEP-CTERM motif', 23, NULL, 'PEP-CTERM', 262821),
(443728, 'PF00588', NULL, 'SpoU rRNA Methylase family', 142, NULL, 'SpoU_methylase', 262822),
(443729, 'PF04480', NULL, 'Protein of unknown function (DUF559)', 109, NULL, 'DUF559', 262823),
(443730, 'PF16250', NULL, 'Domain of unknown function (DUF4907)', 67, NULL, 'DUF4907', 262824),
(443731, 'PF15430', NULL, 'Single domain von Willebrand factor type C', 66, NULL, 'SVWC', 262825),
(443732, 'PF10124', NULL, 'Mu-like prophage major head subunit gpT', 289, NULL, 'Mu-like_gpT', 262826),
(443733, 'PF04676', NULL, 'Protein similar to CwfJ C-terminus 2', 99, NULL, 'CwfJ_C_2', 262827),
(443734, 'PF07736', NULL, 'Chorismate mutase type I', 117, NULL, 'CM_1', 262828),
(443735, 'PF19036', NULL, 'First Longin domain of FUZ, MON1 and HPS1', 126, NULL, 'Fuz_longin_1', 262829),
(443736, 'PF08852', NULL, 'Protein of unknown function (DUF1822)', 368, NULL, 'DUF1822', 262830),
(443737, 'PF08873', NULL, 'Bacteriophage Mu, Gp37', 204, NULL, 'Phage_Mu_Gp37', 262831),
(443738, 'PF08088', NULL, 'Conotoxin I-superfamily', 40, NULL, 'Toxin_19', 262832),
(443739, 'PF07812', NULL, 'TfuA-like protein', 120, NULL, 'TfuA', 262833),
(443740, 'PF07870', NULL, 'Protein of unknown function (DUF1657)', 49, NULL, 'DUF1657', 262834),
(443741, 'PF11259', NULL, 'Protein of unknown function (DUF3060)', 58, NULL, 'DUF3060', 262835);
INSERT INTO "PUBLIC"."MODEL" VALUES
(443742, 'PF12069', NULL, 'Protein of unknown function (DUF3549)', 340, NULL, 'DUF3549', 262836),
(443743, 'PF00316', NULL, 'Fructose-1-6-bisphosphatase, N-terminal domain', 191, NULL, 'FBPase', 262837),
(443744, 'PF07460', NULL, 'NUMOD3 motif', 37, NULL, 'NUMOD3', 262838),
(443745, 'PF10990', NULL, 'Protein of unknown function (DUF2809)', 86, NULL, 'DUF2809', 262839),
(443746, 'PF19169', NULL, 'Family of unknown function (DUF5851)', 353, NULL, 'DUF5851', 262840),
(443747, 'PF19370', NULL, 'Family of unknown function (DUF5945)', 129, NULL, 'DUF5945', 262841),
(443748, 'PF06187', NULL, 'Protein of unknown function (DUF993)', 382, NULL, 'DUF993', 262842),
(443749, 'PF19162', NULL, 'Family of unknown function (DUF5844)', 109, NULL, 'DUF5844', 262843),
(443750, 'PF17956', NULL, 'Nicotinate phosphoribosyltransferase C-terminal domain', 111, NULL, 'NAPRTase_C', 262844),
(443751, 'PF01194', NULL, 'RNA polymerases N / 8 kDa subunit', 58, NULL, 'RNA_pol_N', 262845),
(443752, 'PF09386', NULL, 'Antitoxin ParD', 80, NULL, 'ParD', 262846),
(443753, 'PF18132', NULL, 'Tyosinase C-terminal domain', 122, NULL, 'Tyosinase_C', 262847),
(443754, 'PF20050', NULL, 'Family of unknown function (DUF6452)', 107, NULL, 'DUF6452', 262848),
(443755, 'PF13989', NULL, 'YejG-like protein', 106, NULL, 'YejG', 262849),
(443756, 'PF09797', NULL, 'N-acetyltransferase B complex (NatB) non catalytic subunit', 382, NULL, 'NatB_MDM20', 262850),
(443757, 'PF14421', NULL, 'A distinct subfamily of CDD/CDA-like deaminases', 210, NULL, 'LmjF365940-deam', 262851),
(443758, 'PF11691', NULL, 'Protein of unknown function (DUF3288)', 89, NULL, 'DUF3288', 262852),
(443759, 'PF07646', NULL, 'Kelch motif', 49, NULL, 'Kelch_2', 262853),
(443760, 'PF20007', NULL, 'FtsH ternary system-associated peptide', 73, NULL, 'fvmRadSAM-pep', 262854),
(443761, 'PF03359', NULL, 'Guanylate-kinase-associated protein (GKAP) protein', 345, NULL, 'GKAP', 262855),
(443762, 'PF08557', NULL, 'Sphingolipid Delta4-desaturase (DES)', 37, NULL, 'Lipid_DES', 262856),
(443763, 'PF09121', NULL, 'Tower', 42, NULL, 'Tower', 262857),
(443764, 'PF17696', NULL, 'Family of unknown function (DUF5542)', 68, NULL, 'DUF5542', 262858),
(443765, 'PF11927', NULL, 'Protein of unknown function (DUF3445)', 226, NULL, 'DUF3445', 262859),
(443766, 'PF15787', NULL, 'Neurobeachin/BDCP, DUF4704 alpha solenoid region', 496, NULL, 'DUF4704', 262860),
(443767, 'PF15380', NULL, 'Domain of unknown function (DUF4607)', 264, NULL, 'DUF4607', 262861),
(443768, 'PF11810', NULL, 'Domain of unknown function (DUF3332)', 171, NULL, 'DUF3332', 262862),
(443769, 'PF00328', NULL, 'Histidine phosphatase superfamily (branch 2)', 383, NULL, 'His_Phos_2', 262863),
(443770, 'PF13218', NULL, 'Protein of unknown function (DUF4026)', 323, NULL, 'DUF4026', 262864),
(443771, 'PF14234', NULL, 'Domain of unknown function (DUF4336)', 318, NULL, 'DUF4336', 262865),
(443772, 'PF15775', NULL, 'Domain of unknown function (DUF4703)', 186, NULL, 'DUF4703', 262866),
(443773, 'PF12526', NULL, 'Protein of unknown function (DUF3729)', 113, NULL, 'DUF3729', 262867),
(443774, 'PF17356', NULL, 'Phage-like element PBSX protein XtrA', 64, NULL, 'PBSX_XtrA', 262868),
(443775, 'PF12231', NULL, 'Rap1-interacting factor 1 N terminal', 374, NULL, 'Rif1_N', 262869),
(443776, 'PF05437', NULL, 'Branched-chain amino acid transport protein (AzlD)', 99, NULL, 'AzlD', 262870),
(443777, 'PF02603', NULL, 'HPr Serine kinase N terminus', 125, NULL, 'Hpr_kinase_N', 262871),
(443778, 'PF17568', NULL, 'Family of unknown function (DUF5474)', 77, NULL, 'DUF5474', 262872),
(443779, 'PF14012', NULL, 'Protein of unknown function (DUF4229)', 68, NULL, 'DUF4229', 262873),
(443780, 'PF18664', NULL, 'CdiA C-terminal tRNase domain', 116, NULL, 'CdiA_C_tRNase', 262874),
(443781, 'PF09859', NULL, 'Oxygenase, catalysing oxidative methylation of damaged DNA', 172, NULL, 'Oxygenase-NA', 262875),
(443782, 'PF04098', NULL, 'Rad52/22 family double-strand break repair protein', 153, NULL, 'Rad52_Rad22', 262876),
(443783, 'PF09613', NULL, 'Bacterial type III secretion protein (HrpB1_HrpK)', 126, NULL, 'HrpB1_HrpK', 262877);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(443784, 'PF15303', NULL, 'E3 ubiquitin-protein ligase Arkadia N-terminus', 279, NULL, 'RNF111_N', 262878),
(443785, 'PF11328', NULL, 'Protein of unknown function (DUF3130', 89, NULL, 'DUF3130', 262879),
(443786, 'PF00452', NULL, 'Apoptosis regulator proteins, Bcl-2 family', 100, NULL, 'Bcl-2', 262880),
(443787, 'PF08053', NULL, 'Tryptophanase operon leader peptide', 24, NULL, 'Tna_leader', 262881),
(443788, 'PF00401', NULL, 'ATP synthase, Delta/Epsilon chain, long alpha-helix domain', 47, NULL, 'ATP-synt_DE', 262882),
(443789, 'PF11422', NULL, 'Initiator binding protein 39 kDa', 179, NULL, 'IBP39', 262883),
(443790, 'PF01535', NULL, 'PPR repeat', 31, NULL, 'PPR', 262884),
(443791, 'PF08455', NULL, 'Bacterial SNF2 helicase associated', 375, NULL, 'SNF2_assoc', 262885),
(443792, 'PF19031', NULL, 'First Longin domain of INTU, CCZ1 and HPS4', 113, NULL, 'Intu_longin_1', 262886),
(443793, 'PF19704', NULL, 'DNA-PKcs, CC5', 691, NULL, 'DNAPKcs_CC5', 262887),
(443794, 'PF20112', NULL, 'Family of unknown function (DUF6502)', 268, NULL, 'DUF6502', 262888),
(443795, 'PF07585', NULL, 'Putative beta barrel porin-7 (BBP7)', 349, NULL, 'BBP7', 262889),
(443796, 'PF12780', NULL, 'P-loop containing dynein motor region D4', 259, NULL, 'AAA_8', 262890),
(443797, 'PF12053', NULL, 'N-terminal of Par3 and HAL proteins', 83, NULL, 'Par3_HAL_N_term', 262891),
(443798, 'PF02636', NULL, 'Putative S-adenosyl-L-methionine-dependent methyltransferase', 263, NULL, 'Methyltransf_28', 262892),
(443799, 'PF05647', NULL, 'Tandem-repeating region of mucin, epiglycanin-like', 68, NULL, 'Epiglycanin_TR', 262893),
(443800, 'PF05896', NULL, 'Na(+)-translocating NADH-quinone reductase subunit A (NQRA)', 257, NULL, 'NQRA', 262894),
(443801, 'PF05258', NULL, 'Dna[CI] antecedent, DciA', 89, NULL, 'DciA', 262895),
(443802, 'PF12562', NULL, 'Protein of unknown function (DUF3746)', 37, NULL, 'DUF3746', 262896),
(443803, 'PF05099', NULL, 'Tellurite resistance protein TerB', 118, NULL, 'TerB', 262897),
(443804, 'PF05369', NULL, 'Monomethylamine methyltransferase MtmB', 450, NULL, 'MtmB', 262898),
(443805, 'PF13135', NULL, 'Protein of unknown function (DUF3947)', 82, NULL, 'DUF3947', 262899),
(443806, 'PF19733', NULL, 'Family of unknown function (DUF6223)', 99, NULL, 'DUF6223', 262900),
(443807, 'PF12630', NULL, 'Poxvirus poly(A) polymerase N-terminal domain', 108, NULL, 'Pox_polyA_pol_N', 262901),
(443808, 'PF10536', NULL, 'Plant mobile domain', 355, NULL, 'PMD', 262902),
(443809, 'PF14598', NULL, 'PAS domain', 113, NULL, 'PAS_11', 262903),
(443810, 'PF15622', NULL, 'Kinetochore assembly subunit CENP-C N-terminal', 287, NULL, 'CENP_C_N', 262904),
(443811, 'PF13181', NULL, 'Tetratricopeptide repeat', 34, NULL, 'TPR_8', 262905),
(443812, 'PF08714', NULL, 'Formaldehyde-activating enzyme (Fae)', 159, NULL, 'Fae', 262906),
(443813, 'PF16004', NULL, '116 kDa U5 small nuclear ribonucleoprotein component N-terminus', 121, NULL, 'EFTUD2', 262907),
(443814, 'PF14940', NULL, 'Transmembrane 219', 236, NULL, 'TMEM219', 262908),
(443815, 'PF16701', NULL, 'Adenylate cyclase regulatory domain', 186, NULL, 'Ad_Cy_reg', 262909),
(443816, 'PF11877', NULL, 'Protein of unknown function (DUF3397)', 112, NULL, 'DUF3397', 262910),
(443817, 'PF11970', NULL, 'G protein-coupled glucose receptor regulating Gpa2 C-term', 76, NULL, 'GPR_Gpa2_C', 262911),
(443818, 'PF06082', NULL, 'Exopolysaccharide biosynthesis protein YbjH', 660, NULL, 'YjbH', 262912),
(443819, 'PF17442', NULL, 'Functional domain of U62 and UL91 proteins', 65, NULL, 'U62_UL91', 262913),
(443820, 'PF13447', NULL, 'Seven times multi-haem cytochrome CxxCH', 269, NULL, 'Multi-haem_cyto', 262914),
(443821, 'PF03259', NULL, 'Roadblock/LC7 domain', 91, NULL, 'Robl_LC7', 262915),
(443822, 'PF06911', NULL, 'Senescence domain', 187, NULL, 'Senescence', 262916),
(443823, 'PF14325', NULL, 'Domain of unknown function (DUF4383)', 124, NULL, 'DUF4383', 262917),
(443824, 'PF18815', NULL, 'Bacterial antifreeze protein repeat', 52, NULL, 'AFP_2', 262918),
(443825, 'PF15103', NULL, 'G0/G1 switch protein 2', 105, NULL, 'G0-G1_switch_2', 262919);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(443826, 'PF10252', NULL, 'Casein kinase substrate phosphoprotein PP28', 85, NULL, 'PP28', 262920),
(443827, 'PF12071', NULL, 'Protein of unknown function (DUF3551)', 76, NULL, 'DUF3551', 262921),
(443828, 'PF13383', NULL, 'Methyltransferase domain', 252, NULL, 'Methyltransf_22', 262922),
(443829, 'PF14876', NULL, 'Respiratory growth transcriptional regulator', 217, NULL, 'RSF', 262923),
(443830, 'PF09494', NULL, 'Slx4 endonuclease', 61, NULL, 'Slx4', 262924),
(443831, 'PF20104', NULL, 'Family of unknown function (DUF6494)', 68, NULL, 'DUF6494', 262925),
(443832, 'PF08035', NULL, 'Opioids neuropeptide', 30, NULL, 'Op_neuropeptide', 262926),
(443833, 'PF05008', NULL, 'Vesicle transport v-SNARE protein N-terminus', 79, NULL, 'V-SNARE', 262927),
(443834, 'PF05104', NULL, 'Ribosome receptor lysine/proline rich region', 142, NULL, 'Rib_recp_KP_reg', 262928),
(443835, 'PF10511', NULL, 'Trappin protein transglutaminase binding domain', 17, NULL, 'Cementoin', 262929),
(443836, 'PF14986', NULL, 'Domain of unknown function (DUF4514)', 60, NULL, 'DUF4514', 262930),
(443837, 'PF06086', NULL, 'Orthopoxvirus A26L/A30L protein', 220, NULL, 'Pox_A30L_A26L', 262931),
(443838, 'PF20454', NULL, 'Terminase large subunit gpA, endonuclease domain', 294, NULL, 'GpA_nuclease', 262932),
(443839, 'PF19055', NULL, 'ABC-2 type transporter', 409, NULL, 'ABC2_membrane_7', 262933),
(443840, 'PF20026', NULL, 'Domain of unknown function (DUF6434)', 64, NULL, 'DUF6434', 262934),
(443841, 'PF00864', NULL, 'ATP P2X receptor', 361, NULL, 'P2X_receptor', 262935),
(443842, 'PF04762', NULL, 'IKI3 family', 935, NULL, 'IKI3', 262936),
(443843, 'PF15164', NULL, 'Williams-Beuren syndrome chromosomal region 28 protein homologue', 267, NULL, 'WBS28', 262937),
(443844, 'PF09842', NULL, 'Predicted membrane protein (DUF2069)', 104, NULL, 'DUF2069', 262938),
(443845, 'PF11627', NULL, 'Nuclear factor hnRNPA1', 38, NULL, 'HnRNPA1', 262939),
(443846, 'PF12894', NULL, 'Anaphase-promoting complex subunit 4 WD40 domain', 92, NULL, 'ANAPC4_WD40', 262940),
(443847, 'PF16938', NULL, 'Putative phage holin Dp-1', 63, NULL, 'Phage_holin_Dp1', 262941),
(443848, 'PF06530', NULL, 'Phage antitermination protein Q', 118, NULL, 'Phage_antitermQ', 262942),
(443849, 'PF09984', NULL, 'Single cache domain 4', 148, NULL, 'sCache_4', 262943),
(443850, 'PF03070', NULL, 'TENA/THI-4/PQQC family', 210, NULL, 'TENA_THI-4', 262944),
(443851, 'PF17327', NULL, 'Acyl homoserine lactone synthase', 376, NULL, 'AHL_synthase', 262945),
(443852, 'PF11302', NULL, 'Protein of unknown function (DUF3104)', 69, NULL, 'DUF3104', 262946),
(443853, 'PF17226', NULL, 'MTA R1 domain', 78, NULL, 'MTA_R1', 262947),
(443854, 'PF12750', NULL, 'Maff2 family', 70, NULL, 'Maff2', 262948),
(443855, 'PF14487', NULL, 'ssDNA thymidine ADP-ribosyltransferase, DarT', 201, NULL, 'DarT', 262949),
(443856, 'PF15406', NULL, 'Pleckstrin homology domain', 112, NULL, 'PH_6', 262950),
(443857, 'PF14245', NULL, 'Type IV pilin PilA', 136, NULL, 'Pilin_PilA', 262951),
(443858, 'PF14997', NULL, 'CECR6/TMEM121 family', 195, NULL, 'CECR6_TMEM121', 262952),
(443859, 'PF01163', NULL, 'RIO1 family', 188, NULL, 'RIO1', 262953),
(443860, 'PF02783', NULL, 'Methyl-coenzyme M reductase beta subunit, N-terminal domain', 182, NULL, 'MCR_beta_N', 262954),
(443861, 'PF01333', NULL, 'Apocytochrome F, C-terminal', 118, NULL, 'Apocytochr_F_C', 262955),
(443862, 'PF00731', NULL, 'AIR carboxylase', 148, NULL, 'AIRC', 262956),
(443863, 'PF01672', NULL, 'Putative plasmid partition protein', 85, NULL, 'Plasmid_parti', 262957),
(443864, 'PF11249', NULL, 'Protein of unknown function (DUF3047)', 188, NULL, 'DUF3047', 262958),
(443865, 'PF04968', NULL, 'CHORD', 62, NULL, 'CHORD', 262959),
(443866, 'PF02722', NULL, 'Major Outer Sheath Protein C-terminal domain', 205, NULL, 'MOSP_C', 262960),
(443867, 'PF14435', NULL, 'SUKH-4 immunity protein', 176, NULL, 'SUKH-4', 262961),
(443868, 'PF07596', NULL, 'Protein of unknown function (DUF1559)', 274, NULL, 'SBP_bac_10', 262962),
(443869, 'PF19671', NULL, 'Family of unknown function (DUF6174)', 121, NULL, 'DUF6174', 262963);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(443870, 'PF01307', NULL, 'Plant viral movement protein', 100, NULL, 'Plant_vir_prot', 262964),
(443871, 'PF09956', NULL, 'Uncharacterized conserved protein (DUF2190)', 101, NULL, 'DUF2190', 262965),
(443872, 'PF16459', NULL, 'Phage tail assembly chaperone, TAC', 97, NULL, 'Phage_TAC_13', 262966),
(443873, 'PF05931', NULL, 'Staphylococcal AgrD protein', 45, NULL, 'AgrD', 262967),
(443874, 'PF12513', NULL, 'Mitochondrial degradasome RNA helicase subunit C terminal', 48, NULL, 'SUV3_C', 262968),
(443875, 'PF13361', NULL, 'UvrD-like helicase C-terminal domain', 348, NULL, 'UvrD_C', 262969),
(443876, 'PF05697', NULL, 'Bacterial trigger factor protein (TF)', 140, NULL, 'Trigger_N', 262970),
(443877, 'PF04674', NULL, 'Phosphate-induced protein 1 conserved region', 276, NULL, 'Phi_1', 262971),
(443878, 'PF11243', NULL, 'Protein of unknown function (DUF3045)', 88, NULL, 'DUF3045', 262972),
(443879, 'PF18200', NULL, 'Bacterial Ig-like domain', 80, NULL, 'Big_11', 262973),
(443880, 'PF04985', NULL, 'Phage tail tube protein FII', 165, NULL, 'Phage_tube', 262974),
(443881, 'PF10989', NULL, 'Protein of unknown function (DUF2808)', 145, NULL, 'DUF2808', 262975),
(443882, 'PF03865', NULL, 'Haemolysin secretion/activation protein ShlB/FhaC/HecB', 313, NULL, 'ShlB', 262976),
(443883, 'PF06504', NULL, 'Replication protein C (RepC)', 273, NULL, 'RepC', 262977),
(443884, 'PF03710', NULL, 'Glutamate-ammonia ligase adenylyltransferase', 250, NULL, 'GlnE', 262978),
(443885, 'PF17999', NULL, 'Pullulanase N1-terminal domain', 85, NULL, 'PulA_N1', 262979),
(443886, 'PF13899', NULL, 'Thioredoxin-like', 83, NULL, 'Thioredoxin_7', 262980),
(443887, 'PF15256', NULL, 'SPATIAL', 201, NULL, 'SPATIAL', 262981),
(443888, 'PF04868', NULL, 'Retinal cGMP phosphodiesterase, gamma subunit', 82, NULL, 'PDE6_gamma', 262982),
(443889, 'PF19662', NULL, 'Family of unknown function (DUF6165)', 134, NULL, 'DUF6165', 262983),
(443890, 'PF13120', NULL, 'Domain of unknown function (DUF3974)', 126, NULL, 'DUF3974', 262984),
(443891, 'PF14749', NULL, 'Acyl-coenzyme A oxidase N-terminal', 125, NULL, 'Acyl-CoA_ox_N', 262985),
(443892, 'PF15264', NULL, 'Tumour suppressing sub-chromosomal transferable candidate 4', 126, NULL, 'TSSC4', 262986),
(443893, 'PF19293', NULL, 'CdaA N-terminal transmembrane domain', 81, NULL, 'CdaA_N', 262987),
(443894, 'PF15450', NULL, 'Coiled-coil domain-containing protein 154', 527, NULL, 'CCDC154', 262988),
(443895, 'PF17987', NULL, 'Phosphoethanolamine N-methyltransferase 2 N-terminal', 125, NULL, 'PMT2_N', 262989),
(443896, 'PF14070', NULL, 'Putative motility protein', 57, NULL, 'YjfB_motility', 262990),
(443897, 'PF18705', NULL, 'Family of unknown function (DUF5643)', 115, NULL, 'DUF5643', 262991),
(443898, 'PF00971', NULL, 'EIAV coat protein, gp90', 385, NULL, 'EIAV_GP90', 262992),
(443899, 'PF17087', NULL, 'Herpesvirus US34A protein family', 64, NULL, 'HHV-5_US34A', 262993),
(443900, 'PF01943', NULL, 'Polysaccharide biosynthesis protein', 275, NULL, 'Polysacc_synt', 262994),
(443901, 'PF05128', NULL, 'Domain of unknown function (DUF697)', 162, NULL, 'DUF697', 262995),
(443902, 'PF17598', NULL, 'Family of unknown function (DUF5494)', 84, NULL, 'DUF5494', 262996),
(443903, 'PF11286', NULL, 'Protein of unknown function (DUF3087)', 165, NULL, 'DUF3087', 262997),
(443904, 'PF17147', NULL, 'Pyruvate:ferredoxin oxidoreductase core domain II', 102, NULL, 'PFOR_II', 262998),
(443905, 'PF18027', NULL, 'Cytosolic carboxypeptidase N-terminal domain', 107, NULL, 'Pepdidase_M14_N', 262999),
(443906, 'PF20466', NULL, 'MmeI, target recognition domain', 207, NULL, 'MmeI_TRD', 263000),
(443907, 'PF04748', NULL, 'Divergent polysaccharide deacetylase', 213, NULL, 'Polysacc_deac_2', 263001),
(443908, 'PF18283', NULL, 'Carbohydrate binding module 77', 109, NULL, 'CBM77', 263002),
(443909, 'PF10158', NULL, 'Tumour suppressor protein', 131, NULL, 'LOH1CR12', 263003),
(443910, 'PF05914', NULL, 'RIB43A', 372, NULL, 'RIB43A', 263004),
(443911, 'PF11033', NULL, 'Competence protein J (ComJ)', 122, NULL, 'ComJ', 263005),
(443912, 'PF18822', NULL, 'CdvA-like coiled-coil domain', 123, NULL, 'CdvA', 263006);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(443913, 'PF01900', NULL, 'Rpp14/Pop5 family', 103, NULL, 'RNase_P_Rpp14', 263007),
(443914, 'PF10436', NULL, 'Mitochondrial branched-chain alpha-ketoacid dehydrogenase kinase', 162, NULL, 'BCDHK_Adom3', 263008),
(443915, 'PF04652', NULL, 'Vta1 like', 145, NULL, 'Vta1', 263009),
(443916, 'PF05122', NULL, 'Mobile element transfer protein', 50, NULL, 'SpdB', 263010),
(443917, 'PF06662', NULL, 'D-glucuronyl C5-epimerase C-terminus', 187, NULL, 'C5-epim_C', 263011),
(443918, 'PF16366', NULL, 'Cytoplasmic polyadenylation element-binding protein ZZ domain', 58, NULL, 'CEBP_ZZ', 263012),
(443919, 'PF02223', NULL, 'Thymidylate kinase', 185, NULL, 'Thymidylate_kin', 263013),
(443920, 'PF08124', NULL, 'Polysaccharide lyase family 8, N terminal alpha-helical domain', 323, NULL, 'Lyase_8_N', 263014),
(443921, 'PF02740', NULL, 'Colipase, C-terminal domain', 44, NULL, 'Colipase_C', 263015),
(443922, 'PF18850', NULL, 'Large polyvalent protein associated domain 30', 121, NULL, 'LPD30', 263016),
(443923, 'PF12820', NULL, 'Serine-rich domain associated with BRCT', 164, NULL, 'BRCT_assoc', 263017),
(443924, 'PF03376', NULL, 'Adenovirus E3B protein', 67, NULL, 'Adeno_E3B', 263018),
(443925, 'PF18295', NULL, 'M17 aminopeptidase N-terminal domain 2', 122, NULL, 'Pdase_M17_N2', 263019),
(443926, 'PF11630', NULL, 'Anti-lipopolysaccharide factor/Scygonadin', 100, NULL, 'Anti-LPS-SCYG', 263020),
(443927, 'PF03682', NULL, 'Uncharacterised protein family (UPF0158)', 157, NULL, 'UPF0158', 263021),
(443928, 'PF14889', NULL, 'Penicillin-binding protein Tp47 domain a', 164, NULL, 'PBP-Tp47_a', 263022),
(443929, 'PF08475', NULL, 'Viral capsid protein 91 N-terminal', 192, NULL, 'Baculo_VP91_N', 263023),
(443930, 'PF03139', NULL, 'Vanadium/alternative nitrogenase delta subunit', 111, NULL, 'AnfG_VnfG', 263024),
(443931, 'PF12402', NULL, 'NocA-like zinc-finger protein 1', 58, NULL, 'nlz1', 263025),
(443932, 'PF13153', NULL, 'Protein of unknown function (DUF3985)', 44, NULL, 'DUF3985', 263026),
(443933, 'PF08600', NULL, 'Rsm1-like', 92, NULL, 'Rsm1', 263027),
(443934, 'PF13410', NULL, 'Glutathione S-transferase, C-terminal domain', 70, NULL, 'GST_C_2', 263028),
(443935, 'PF00883', NULL, 'Cytosol aminopeptidase family, catalytic domain', 312, NULL, 'Peptidase_M17', 263029),
(443936, 'PF06589', NULL, 'Circumsporozoite-related antigen (CRA)', 134, NULL, 'CRA', 263030),
(443937, 'PF08640', NULL, 'U3 small nucleolar RNA-associated protein 6', 86, NULL, 'U3_assoc_6', 263031),
(443938, 'PF05988', NULL, 'Bacterial protein of unknown function (DUF899)', 216, NULL, 'DUF899', 263032),
(443939, 'PF08241', NULL, 'Methyltransferase domain', 96, NULL, 'Methyltransf_11', 263033),
(443940, 'PF11131', NULL, 'Rap-phr extracellular signalling', 38, NULL, 'PhrC_PhrF', 263034),
(443941, 'PF17815', NULL, 'PDZ domain', 145, NULL, 'PDZ_3', 263035),
(443942, 'PF04305', NULL, 'Protein of unknown function (DUF455)', 249, NULL, 'DUF455', 263036),
(443943, 'PF19695', NULL, 'Family of unknown function (DUF6195)', 139, NULL, 'DUF6195', 263037),
(443944, 'PF07965', NULL, 'Integrin beta tail domain', 84, NULL, 'Integrin_B_tail', 263038),
(443945, 'PF03566', NULL, 'Peptidase family A21', 653, NULL, 'Peptidase_A21', 263039),
(443946, 'PF05344', NULL, 'Domain of Unknown Function (DUF746)', 64, NULL, 'DUF746', 263040),
(443947, 'PF01066', NULL, 'CDP-alcohol phosphatidyltransferase', 150, NULL, 'CDP-OH_P_transf', 263041),
(443948, 'PF10620', NULL, 'Phosphoribosyl-dephospho-CoA transferase MdcG', 199, NULL, 'MdcG', 263042),
(443949, 'PF13677', NULL, 'Membrane MotB of proton-channel complex MotA/MotB', 58, NULL, 'MotB_plug', 263043),
(443950, 'PF17454', NULL, 'Honey bee toxin', 50, NULL, 'Bee_toxin', 263044),
(443951, 'PF07672', NULL, 'Mycoplasma MFS transporter', 300, NULL, 'MFS_Mycoplasma', 263045),
(443952, 'PF02238', NULL, 'Cytochrome c oxidase subunit VII', 53, NULL, 'COX7a', 263046),
(443953, 'PF12816', NULL, 'Golgi CORVET complex core vacuolar protein 8', 199, NULL, 'Vps8', 263047),
(443954, 'PF14100', NULL, 'Family of unknown function (DUF6807)', 272, NULL, 'DUF6807', 263048);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(443955, 'PF12045', NULL, 'Protein of unknown function (DUF3528)', 127, NULL, 'DUF3528', 263049),
(443956, 'PF19552', NULL, 'Family of unknown function (DUF6075)', 129, NULL, 'DUF6075', 263050),
(443957, 'PF02285', NULL, 'Cytochrome oxidase c subunit VIII', 43, NULL, 'COX8', 263051),
(443958, 'PF17628', NULL, 'Inclusion membrane protein D', 141, NULL, 'IncD', 263052),
(443959, 'PF04696', NULL, 'pinin/SDK/memA/ protein conserved region', 130, NULL, 'Pinin_SDK_memA', 263053),
(443960, 'PF18500', NULL, 'CadC C-terminal domain 1', 134, NULL, 'CadC_C1', 263054),
(443961, 'PF00468', NULL, 'Ribosomal protein L34', 44, NULL, 'Ribosomal_L34', 263055),
(443962, 'PF08687', NULL, 'Apx/Shroom domain ASD2', 290, NULL, 'ASD2', 263056),
(443963, 'PF19913', NULL, 'Wolframin C-terminal OB-fold domain', 122, NULL, 'WCOB', 263057),
(443964, 'PF16532', NULL, 'Sf6-type phage tail needle knob or tip of some Caudovirales', 175, NULL, 'Phage_tail_NK', 263058),
(443965, 'PF07712', NULL, 'Stress up-regulated Nod 19', 377, NULL, 'SURNod19', 263059),
(443966, 'PF00672', NULL, 'HAMP domain', 53, NULL, 'HAMP', 263060),
(443967, 'PF03982', NULL, 'Diacylglycerol acyltransferase', 297, NULL, 'DAGAT', 263061),
(443968, 'PF04802', NULL, 'Phosphatase 4 regulatory subunit 3', 191, NULL, 'PP4R3', 263062),
(443969, 'PF11483', NULL, 'Protein of unknown function (DUF3209)', 124, NULL, 'DUF3209', 263063),
(443970, 'PF16559', NULL, 'GIT coiled-coil Rho guanine nucleotide exchange factor', 66, NULL, 'GIT_CC', 263064),
(443971, 'PF17017', NULL, 'Aberrant zinc-finger', 176, NULL, 'zf-C2H2_aberr', 263065),
(443972, 'PF19313', NULL, 'Domain of unknown function (DUF5916)', 572, NULL, 'DUF5916', 263066),
(443973, 'PF16008', NULL, 'Domain of unknown function (DUF4778)', 285, NULL, 'DUF4778', 263067),
(443974, 'PF14074', NULL, 'Protein of unknown function (DUF4257)', 81, NULL, 'DUF4257', 263068),
(443975, 'PF16221', NULL, 'winged helix-turn-helix', 78, NULL, 'HTH_47', 263069),
(443976, 'PF16427', NULL, 'Domain of unknown function (DUF5024)', 104, NULL, 'DUF5024', 263070),
(443977, 'PF13171', NULL, 'Protein of unknown function (DUF4004)', 197, NULL, 'DUF4004', 263071),
(443978, 'PF06818', NULL, 'Fez1', 197, NULL, 'Fez1', 263072),
(443979, 'PF11099', NULL, 'Apoptosis regulator M11L like', 160, NULL, 'M11L', 263073),
(443980, 'PF14714', NULL, 'KH-domain-like of EngA bacterial GTPase enzymes, C-terminal', 81, NULL, 'KH_dom-like', 263074),
(443981, 'PF18393', NULL, 'MotY N-terminal domain', 146, NULL, 'MotY_N', 263075),
(443982, 'PF02728', NULL, 'Copper amine oxidase, N3 domain', 100, NULL, 'Cu_amine_oxidN3', 263076),
(443983, 'PF13556', NULL, 'PucR C-terminal helix-turn-helix domain', 59, NULL, 'HTH_30', 263077),
(443984, 'PF15001', NULL, 'AP-5 complex subunit sigma-1', 192, NULL, 'AP-5_subunit_s1', 263078),
(443985, 'PF15008', NULL, 'Domain of unknown function (DUF4518)', 271, NULL, 'DUF4518', 263079),
(443986, 'PF13325', NULL, 'N-terminal region of micro-spherule protein', 199, NULL, 'MCRS_N', 263080),
(443987, 'PF12287', NULL, 'Cytoplasmic activation/proliferation-associated protein-1 C term', 324, NULL, 'Caprin-1_C', 263081),
(443988, 'PF01862', NULL, 'Pyruvoyl-dependent arginine decarboxylase (PvlArgDC)', 162, NULL, 'PvlArgDC', 263082),
(443989, 'PF14045', NULL, 'YIEGIA protein', 282, NULL, 'YIEGIA', 263083),
(443990, 'PF14873', NULL, 'N-terminal domain of BNR-repeat neuraminidase', 153, NULL, 'BNR_assoc_N', 263084),
(443991, 'PF00204', NULL, 'DNA gyrase B', 174, NULL, 'DNA_gyraseB', 263085),
(443992, 'PF12812', NULL, 'PDZ-like domain', 78, NULL, 'PDZ_1', 263086),
(443993, 'PF18983', NULL, 'Family of unknown function (DUF5717)C-terminal', 306, NULL, 'DUF5717', 263087),
(443994, 'PF17225', NULL, 'Domain of unknown function (DUF5300)', 97, NULL, 'DUF5301', 263088),
(443995, 'PF19396', NULL, 'Family of unknown function (DUF5971)', 92, NULL, 'DUF5971', 263089),
(443996, 'PF10309', NULL, 'Nuclear cap-binding protein subunit 3', 59, NULL, 'NCBP3', 263090),
(443997, 'PF12959', NULL, 'Protein of unknown function (DUF3848)', 95, NULL, 'DUF3848', 263091);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(443998, 'PF16598', NULL, 'Linker region of enhancer of mRNA-decapping protein 3', 91, NULL, 'Edc3_linker', 263092),
(443999, 'PF15785', NULL, 'Serine/threonine-protein kinase smg-1', 607, NULL, 'SMG1', 263093),
(444000, 'PF10931', NULL, 'Protein of unknown function (DUF2735)', 52, NULL, 'DUF2735', 263094),
(444001, 'PF01077', NULL, 'Nitrite and sulphite reductase 4Fe-4S domain', 159, NULL, 'NIR_SIR', 263095),
(444002, 'PF00478', NULL, 'IMP dehydrogenase / GMP reductase domain', 345, NULL, 'IMPDH', 263096),
(444003, 'PF07483', NULL, 'Tryptophan-rich Synechocystis species C-terminal domain', 105, NULL, 'W_rich_C', 263097),
(444004, 'PF03510', NULL, '2C endopeptidase (C24) cysteine protease family', 105, NULL, 'Peptidase_C24', 263098),
(444005, 'PF05533', NULL, 'Beet yellows virus-type papain-like endopeptidase C42', 88, NULL, 'Peptidase_C42', 263099),
(444006, 'PF14593', NULL, 'PH domain', 104, NULL, 'PH_3', 263100),
(444007, 'PF14645', NULL, 'Chibby family', 114, NULL, 'Chibby', 263101),
(444008, 'PF07937', NULL, 'Protein of unknown function (DUF1686)', 181, NULL, 'DUF1686', 263102),
(444009, 'PF08145', NULL, 'BOP1NT (NUC169) domain', 259, NULL, 'BOP1NT', 263103),
(444010, 'PF17426', NULL, 'Putative Gamma DNA binding protein G5P', 108, NULL, 'Putative_G5P', 263104),
(444011, 'PF03319', NULL, 'Ethanolamine utilisation protein EutN/carboxysome', 83, NULL, 'EutN_CcmL', 263105),
(444012, 'PF13191', NULL, 'AAA ATPase domain', 170, NULL, 'AAA_16', 263106),
(444013, 'PF13553', NULL, 'Function to find', 252, NULL, 'FIIND', 263107),
(444014, 'PF11768', NULL, 'WD repeat-containing and planar cell polarity effector protein Fritz', 544, NULL, 'Frtz', 263108),
(444015, 'PF12290', NULL, 'Protein of unknown function (DUF3802)', 111, NULL, 'DUF3802', 263109),
(444016, 'PF08976', NULL, 'EF-hand domain', 105, NULL, 'EF-hand_11', 263110),
(444017, 'PF02910', NULL, 'Fumarate reductase flavoprotein C-term', 129, NULL, 'Succ_DH_flav_C', 263111),
(444018, 'PF18488', NULL, 'WYL domain', 63, NULL, 'WYL_3', 263112),
(444019, 'PF01545', NULL, 'Cation efflux family', 199, NULL, 'Cation_efflux', 263113),
(444020, 'PF04213', NULL, 'Htaa', 160, NULL, 'HtaA', 263114),
(444021, 'PF11177', NULL, 'Protein of unknown function (DUF2964)', 62, NULL, 'DUF2964', 263115),
(444022, 'PF02876', NULL, 'Staphylococcal/Streptococcal toxin, beta-grasp domain', 106, NULL, 'Stap_Strp_tox_C', 263116),
(444023, 'PF03956', NULL, 'Lysine exporter LysO', 190, NULL, 'Lys_export', 263117),
(444024, 'PF10472', NULL, 'eIF2-alpha phosphatase phosphorylation constitutive repressor', 411, NULL, 'CReP_N', 263118),
(444025, 'PF00464', NULL, 'Serine hydroxymethyltransferase', 399, NULL, 'SHMT', 263119),
(444026, 'PF05173', NULL, 'Dihydrodipicolinate reductase, C-terminus', 121, NULL, 'DapB_C', 263120),
(444027, 'PF01903', NULL, 'CbiX', 106, NULL, 'CbiX', 263121),
(444028, 'PF03420', NULL, 'Prohead core protein serine protease', 185, NULL, 'Peptidase_S77', 263122),
(444029, 'PF16339', NULL, 'Domain of unknown function (DUF4969)', 79, NULL, 'DUF4969', 263123),
(444030, 'PF19427', NULL, 'Protein inscuteable C-terminal', 453, NULL, 'Insc_C', 263124),
(444031, 'PF11044', NULL, 'Plectrovirus spv1-c74 ORF 12 transmembrane protein', 49, NULL, 'TMEMspv1-c74-12', 263125),
(444032, 'PF13394', NULL, '4Fe-4S single cluster domain', 118, NULL, 'Fer4_14', 263126),
(444033, 'PF16619', NULL, 'Unstructured region C-term to UIM in Ataxin3', 64, NULL, 'SUIM_assoc', 263127),
(444034, 'PF03577', NULL, 'Peptidase family C69', 402, NULL, 'Peptidase_C69', 263128),
(444035, 'PF04029', NULL, '2-phosphosulpholactate phosphatase', 226, NULL, '2-ph_phosp', 263129),
(444036, 'PF08878', NULL, 'HamA', 231, NULL, 'HamA', 263130),
(444037, 'PF07441', NULL, 'SigmaK-factor processing regulatory protein BofA', 75, NULL, 'BofA', 263131),
(444038, 'PF15268', NULL, 'Dapper', 807, NULL, 'Dapper', 263132),
(444039, 'PF00851', NULL, 'Helper component proteinase', 440, NULL, 'Peptidase_C6', 263133),
(444040, 'PF02031', NULL, 'Streptomyces extracellular neutral proteinase (M7) family', 133, NULL, 'Peptidase_M7', 263134);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(444041, 'PF13055', NULL, 'Protein of unknown function (DUF3917)', 71, NULL, 'DUF3917', 263135),
(444042, 'PF15362', NULL, 'Enamelin', 907, NULL, 'Enamelin', 263136),
(444043, 'PF08610', NULL, 'Peroxisomal membrane protein (Pex16)', 365, NULL, 'Pex16', 263137),
(444044, 'PF12384', NULL, 'Ty3 transposon peptidase', 177, NULL, 'Peptidase_A2B', 263138),
(444045, 'PF00650', NULL, 'CRAL/TRIO domain', 156, NULL, 'CRAL_TRIO', 263139),
(444046, 'PF07076', NULL, 'Protein of unknown function (DUF1344)', 60, NULL, 'DUF1344', 263140),
(444047, 'PF05714', NULL, 'Borrelia Bbcrasp-1 domain containing protein', 185, NULL, 'PFam54_60', 263141),
(444048, 'PF13936', NULL, 'Helix-turn-helix domain', 44, NULL, 'HTH_38', 263142),
(444049, 'PF04211', NULL, 'Tetrahydromethanopterin S-methyltransferase, subunit C', 268, NULL, 'MtrC', 263143),
(444050, 'PF19527', NULL, 'Family of unknown function (DUF6055)', 421, NULL, 'DUF6055', 263144),
(444051, 'PF03470', NULL, 'XS zinc finger domain', 43, NULL, 'zf-XS', 263145),
(444052, 'PF12400', NULL, 'STIMATE family', 125, NULL, 'STIMATE', 263146),
(444053, 'PF06513', NULL, 'Repeat of unknown function (DUF1103)', 215, NULL, 'DUF1103', 263147),
(444054, 'PF14077', NULL, 'Alternative WD40 repeat motif', 48, NULL, 'WD40_alt', 263148),
(444055, 'PF01518', NULL, 'Sigma NS protein', 366, NULL, 'PolyG_pol', 263149),
(444056, 'PF18524', NULL, 'High potential iron-sulfur protein like', 40, NULL, 'HPIP_like', 263150),
(444057, 'PF03323', NULL, 'Bacillus/Clostridium GerA spore germination protein', 467, NULL, 'GerA', 263151),
(444058, 'PF19504', NULL, 'Family of unknown function (DUF6038)', 491, NULL, 'DUF6038', 263152),
(444059, 'PF00142', NULL, '4Fe-4S iron sulfur cluster binding proteins, NifH/frxC family', 271, NULL, 'Fer4_NifH', 263153),
(444060, 'PF13403', NULL, 'Hint domain', 143, NULL, 'Hint_2', 263154),
(444061, 'PF14370', NULL, 'C-terminal topoisomerase domain', 70, NULL, 'Topo_C_assoc', 263155),
(444062, 'PF06300', NULL, 'Tsp45I type II restriction enzyme', 260, NULL, 'Tsp45I', 263156),
(444063, 'PF05056', NULL, 'Protein of unknown function (DUF674)', 452, NULL, 'DUF674', 263157),
(444064, 'PF15351', NULL, 'Junctional protein associated with coronary artery disease', 1358, NULL, 'JCAD', 263158),
(444065, 'PF20369', NULL, 'Family of unknown function (DUF6664)', 107, NULL, 'DUF6664', 263159),
(444066, 'PF12742', NULL, 'Gryzun, putative Golgi trafficking', 56, NULL, 'Gryzun-like', 263160),
(444067, 'PF13029', NULL, 'Domain of unknown function (DUF3890)', 84, NULL, 'DUF3890', 263161),
(444068, 'PF11442', NULL, 'Protein of unknown function (DUF2826)', 158, NULL, 'DUF2826', 263162),
(444069, 'PF17749', NULL, 'Microtubule-binding protein MIP-T3 C-terminal region', 154, NULL, 'MIP-T3_C', 263163),
(444070, 'PF02165', NULL, 'Wilm''s tumour protein', 290, NULL, 'WT1', 263164),
(444071, 'PF08024', NULL, 'Ant antimicrobial peptide', 24, NULL, 'Antimicrobial_4', 263165),
(444072, 'PF13780', NULL, 'Domain of unknown function (DUF4176)', 74, NULL, 'DUF4176', 263166),
(444073, 'PF10819', NULL, 'Protein of unknown function (DUF2564)', 79, NULL, 'DUF2564', 263167),
(444074, 'PF16566', NULL, 'Cell-cycle alteration and expression-elevated protein in tumour', 147, NULL, 'CREPT', 263168),
(444075, 'PF05854', NULL, 'Non-histone chromosomal protein MC1', 90, NULL, 'MC1', 263169),
(444076, 'PF03069', NULL, 'Acetamidase/Formamidase family', 373, NULL, 'FmdA_AmdA', 263170),
(444077, 'PF12029', NULL, 'Domain of unknown function (DUF3516)', 458, NULL, 'DUF3516', 263171),
(444078, 'PF01478', NULL, 'Type IV leader peptidase family', 107, NULL, 'Peptidase_A24', 263172),
(444079, 'PF00554', NULL, 'Rel homology DNA-binding domain', 169, NULL, 'RHD_DNA_bind', 263173),
(444080, 'PF02844', NULL, 'Phosphoribosylglycinamide synthetase, N domain', 100, NULL, 'GARS_N', 263174),
(444081, 'PF18820', NULL, 'Bdellovibrio Beta-sandwich', 131, NULL, 'BD_b_sandwich', 263175),
(444082, 'PF17659', NULL, 'Family of unknown function (DUF5521)', 848, NULL, 'DUF5521', 263176),
(444083, 'PF20166', NULL, 'ATG4, F-type LIR motif', 29, NULL, 'ATG4_LIR', 263177);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(444084, 'PF12152', NULL, 'Eukaryotic translation initiation factor 4G1', 70, NULL, 'eIF_4G1', 263178),
(444085, 'PF11437', NULL, 'Vanadium-binding protein 2', 96, NULL, 'Vanabin-2', 263179),
(444086, 'PF04231', NULL, 'Endonuclease I', 230, NULL, 'Endonuclease_1', 263180),
(444087, 'PF10386', NULL, 'Protein of unknown function (DUF2441)', 141, NULL, 'DUF2441', 263181),
(444088, 'PF13095', NULL, 'Kinetochore Sim4 complex subunit FTA2', 220, NULL, 'FTA2', 263182),
(444089, 'PF09441', NULL, 'ARS binding protein 2', 171, NULL, 'Abp2', 263183),
(444090, 'PF13786', NULL, 'Domain of unknown function (DUF4179)', 90, NULL, 'DUF4179', 263184),
(444091, 'PF13243', NULL, 'Squalene-hopene cyclase C-terminal domain', 319, NULL, 'SQHop_cyclase_C', 263185),
(444092, 'PF14594', NULL, 'Siphovirus ReqiPepy6 Gp37-like protein', 352, NULL, 'Sipho_Gp37', 263186),
(444093, 'PF11168', NULL, 'Protein of unknown function (DUF2955)', 140, NULL, 'DUF2955', 263187),
(444094, 'PF15109', NULL, 'TMEM125 protein family', 111, NULL, 'TMEM125', 263188),
(444095, 'PF10555', NULL, 'Phospho-N-acetylmuramoyl-pentapeptide-transferase signature 1', 13, NULL, 'MraY_sig1', 263189),
(444096, 'PF13099', NULL, 'Domain of unknown function (DUF3944)', 35, NULL, 'DUF3944', 263190),
(444097, 'PF04644', NULL, 'Motilin/ghrelin', 28, NULL, 'Motilin_ghrelin', 263191),
(444098, 'PF09750', NULL, 'Alternative splicing regulator', 134, NULL, 'DRY_EERY', 263192),
(444099, 'PF17921', NULL, 'Integrase zinc binding domain', 58, NULL, 'Integrase_H2C2', 263193),
(444100, 'PF16934', NULL, 'Two-component Enterococcus faecalis cytolysin (EFC)', 68, NULL, 'Mersacidin', 263194),
(444101, 'PF14350', NULL, 'Beta protein', 342, NULL, 'Beta_protein', 263195),
(444102, 'PF19513', NULL, 'Family of unknown function (DUF6047)', 189, NULL, 'DUF6047', 263196),
(444103, 'PF13550', NULL, 'Putative phage tail protein', 164, NULL, 'Phage-tail_3', 263197),
(444104, 'PF02123', NULL, 'Viral RNA-directed RNA-polymerase', 479, NULL, 'RdRP_4', 263198),
(444105, 'PF18383', NULL, 'Intraflagellar transport 81 calponin homology domain', 124, NULL, 'IFT81_CH', 263199),
(444106, 'PF02186', NULL, 'TFIIE beta subunit core domain', 68, NULL, 'TFIIE_beta', 263200),
(444107, 'PF06506', NULL, 'Propionate catabolism activator', 167, NULL, 'PrpR_N', 263201),
(444108, 'PF07801', NULL, 'Protein of unknown function (DUF1647)', 141, NULL, 'DUF1647', 263202),
(444109, 'PF12455', NULL, 'Dynein associated protein', 286, NULL, 'Dynactin', 263203),
(444110, 'PF19587', NULL, 'Uncharacterised methyltransferase family (DUF6094)', 339, NULL, 'DUF6094', 263204),
(444111, 'PF15402', NULL, 'MELT motif', 26, NULL, 'MELT_2', 263205),
(444112, 'PF00688', NULL, 'TGF-beta propeptide', 242, NULL, 'TGFb_propeptide', 263206),
(444113, 'PF16564', NULL, 'p55-binding region of Methyl-CpG-binding domain proteins MBD', 71, NULL, 'MBDa', 263207),
(444114, 'PF06950', NULL, 'Protein of unknown function (DUF1293)', 115, NULL, 'DUF1293', 263208),
(444115, 'PF18736', NULL, 'HEPN pEK499 p136', 152, NULL, 'pEK499_p136', 263209),
(444116, 'PF03228', NULL, 'Adenoviral core protein VII', 122, NULL, 'Adeno_VII', 263210),
(444117, 'PF09648', NULL, 'YycI protein', 232, NULL, 'YycI', 263211),
(444118, 'PF16057', NULL, 'Domain of unknown function (DUF4800)', 254, NULL, 'DUF4800', 263212),
(444119, 'PF00989', NULL, 'PAS fold', 113, NULL, 'PAS', 263213),
(444120, 'PF12078', NULL, 'Domain of unknown function (DUF3557)', 154, NULL, 'DUF3557', 263214),
(444121, 'PF05671', NULL, 'GETHR pentapeptide repeat (5 copies)', 25, NULL, 'GETHR', 263215),
(444122, 'PF07543', NULL, 'Protein trafficking PGA2', 138, NULL, 'PGA2', 263216),
(444123, 'PF08881', NULL, 'CVNH domain', 101, NULL, 'CVNH', 263217),
(444124, 'PF17396', NULL, 'Domain of unknown function (DUF1611_N) Rossmann-like domain', 95, NULL, 'DUF1611_N', 263218),
(444125, 'PF01318', NULL, 'Bromovirus coat protein', 187, NULL, 'Bromo_coat', 263219),
(444126, 'PF06253', NULL, 'Trimethylamine methyltransferase (MTTB)', 502, NULL, 'MTTB', 263220),
(444127, 'PF09920', NULL, 'Uncharacterized protein conserved in archaea (DUF2150)', 189, NULL, 'DUF2150', 263221);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(444128, 'PF07752', NULL, 'S-layer protein', 259, NULL, 'S-layer', 263222),
(444129, 'PF10322', NULL, 'Serpentine type 7TM GPCR chemoreceptor Sru', 304, NULL, '7TM_GPCR_Sru', 263223),
(444130, 'PF09207', NULL, 'Yeast killer toxin', 87, NULL, 'Yeast-kill-tox', 263224),
(444131, 'PF05228', NULL, 'CHASE4 domain', 136, NULL, 'CHASE4', 263225),
(444132, 'PF16153', NULL, 'Domain of unknown function (DUF4861)', 376, NULL, 'DUF4861', 263226),
(444133, 'PF12367', NULL, 'Pyruvate ferredoxin oxidoreductase beta subunit C terminal', 66, NULL, 'PFO_beta_C', 263227),
(444134, 'PF12615', NULL, 'F sex factor protein N terminal', 92, NULL, 'TraD_N', 263228),
(444135, 'PF16799', NULL, 'C-terminal membrane-localisation domain of ion-channel, VCN1', 48, NULL, 'VGPC1_C', 263229),
(444136, 'PF06787', NULL, 'FeGP cofactor biosynthesis protein HcgF', 163, NULL, 'HcgF', 263230),
(444137, 'PF11361', NULL, 'Protein of unknown function (DUF3159)', 188, NULL, 'DUF3159', 263231),
(444138, 'PF08672', NULL, 'Anaphase promoting complex (APC) subunit 2', 60, NULL, 'ANAPC2', 263232),
(444139, 'PF15358', NULL, 'Testis-specific serine kinase substrate', 532, NULL, 'TSKS', 263233),
(444140, 'PF20218', NULL, 'Family of unknown function (DUF6578)', 121, NULL, 'DUF6578', 263234),
(444141, 'PF01568', NULL, 'Molydopterin dinucleotide binding domain', 111, NULL, 'Molydop_binding', 263235),
(444142, 'PF04097', NULL, 'Nup93/Nic96', 605, NULL, 'Nic96', 263236),
(444143, 'PF09071', NULL, 'Alpha-amylase, C terminal', 67, NULL, 'Alpha-amyl_C', 263237),
(444144, 'PF11610', NULL, 'Scaffold protein Ste5, Fus3-binding region', 30, NULL, 'Ste5', 263238),
(444145, 'PF13322', NULL, 'Domain of unknown function (DUF4092)', 176, NULL, 'DUF4092', 263239),
(444146, 'PF15435', NULL, 'UNC119-binding protein C5orf30 homologue', 198, NULL, 'UNC119_bdg', 263240),
(444147, 'PF02620', NULL, 'Large ribosomal RNA subunit accumulation protein YceD', 121, NULL, 'YceD', 263241),
(444148, 'PF15746', NULL, 'TMEM215 family', 225, NULL, 'TMEM215', 263242),
(444149, 'PF07092', NULL, 'Protein of unknown function (DUF1356)', 232, NULL, 'DUF1356', 263243),
(444150, 'PF00454', NULL, 'Phosphatidylinositol 3- and 4-kinase', 250, NULL, 'PI3_PI4_kinase', 263244),
(444151, 'PF20326', NULL, 'Family of unknown function (DUF6621)', 190, NULL, 'DUF6621', 263245),
(444152, 'PF03939', NULL, 'Ribosomal protein L23, N-terminal domain', 51, NULL, 'Ribosomal_L23eN', 263246),
(444153, 'PF07141', NULL, 'Putative bacteriophage terminase small subunit', 174, NULL, 'Phage_term_sma', 263247),
(444154, 'PF18223', NULL, 'Pili PilJ C-terminal domain', 95, NULL, 'PilJ_C', 263248),
(444155, 'PF18909', NULL, 'dATP/dGTP diphosphohydrolase, N-terminal', 99, NULL, 'dGTP_diPhyd_N', 263249),
(444156, 'PF14504', NULL, 'CAP-associated N-terminal', 140, NULL, 'CAP_assoc_N', 263250),
(444157, 'PF19153', NULL, 'Family of unknown function (DUF5835)', 53, NULL, 'DUF5835', 263251),
(444158, 'PF10679', NULL, 'Protein of unknown function (DUF2491)', 210, NULL, 'DUF2491', 263252),
(444159, 'PF15153', NULL, 'Cytokine-like protein 1', 127, NULL, 'CYTL1', 263253),
(444160, 'PF18399', NULL, 'Clip-domain serine protease homolog Scarface', 66, NULL, 'CLIP_SPH_Scar', 263254),
(444161, 'PF02124', NULL, 'Marek''s disease glycoprotein A', 90, NULL, 'Marek_A', 263255),
(444162, 'PF19717', NULL, 'Family of unknown function (DUF6212)', 390, NULL, 'DUF6212', 263256),
(444163, 'PF08674', NULL, 'Acetylcholinesterase tetramerisation domain', 35, NULL, 'AChE_tetra', 263257),
(444164, 'PF03422', NULL, 'Carbohydrate binding module (family 6)', 125, NULL, 'CBM_6', 263258),
(444165, 'PF18094', NULL, 'DNA polymerase beta N-terminal domain', 104, NULL, 'DNA_pol_B_N', 263259),
(444166, 'PF03078', NULL, 'ATHILA ORF-1 family', 458, NULL, 'ATHILA', 263260),
(444167, 'PF06670', NULL, 'Microneme protein Etmic-2', 379, NULL, 'Etmic-2', 263261),
(444168, 'PF05997', NULL, 'Nucleolar protein,Nop52', 216, NULL, 'Nop52', 263262),
(444169, 'PF17822', NULL, 'Armadillo-like helical domain-containing protein 2', 229, NULL, 'ARMH2', 263263),
(444170, 'PF20361', NULL, 'Family of unknown function (DUF6656)', 182, NULL, 'DUF6656', 263264);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(444171, 'PF02387', NULL, 'IncFII RepA protein family', 275, NULL, 'IncFII_repA', 263265),
(444172, 'PF09090', NULL, 'MIF4G like', 272, NULL, 'MIF4G_like_2', 263266),
(444173, 'PF10231', NULL, 'Cytochrome c oxidase assembly factor 8', 126, NULL, 'COA8', 263267),
(444174, 'PF13662', NULL, 'Toprim domain', 89, NULL, 'Toprim_4', 263268),
(444175, 'PF00193', NULL, 'Extracellular link domain', 93, NULL, 'Xlink', 263269),
(444176, 'PF13437', NULL, 'HlyD family secretion protein', 106, NULL, 'HlyD_3', 263270),
(444177, 'PF01267', NULL, 'F-actin capping protein alpha subunit', 265, NULL, 'F-actin_cap_A', 263271),
(444178, 'PF01706', NULL, 'FliG C-terminal domain', 108, NULL, 'FliG_C', 263272),
(444179, 'PF20467', NULL, 'MmeI, C-terminal domain', 83, NULL, 'MmeI_C', 263273),
(444180, 'PF05204', NULL, 'Homing endonuclease', 110, NULL, 'Hom_end', 263274),
(444181, 'PF13555', NULL, 'P-loop containing region of AAA domain', 61, NULL, 'AAA_29', 263275),
(444182, 'PF20141', NULL, 'Brassinosteroid receptor island domain', 65, NULL, 'Island', 263276),
(444183, 'PF20529', NULL, 'Family of unknown function (DUF6744)', 320, NULL, 'DUF6744', 263277),
(444184, 'PF17620', NULL, 'Family of unknown function', 191, NULL, 'ORF45', 263278),
(444185, 'PF03220', NULL, 'Tombusvirus P19 core protein', 171, NULL, 'Tombus_P19', 263279),
(444186, 'PF04212', NULL, 'MIT (microtubule interacting and transport) domain', 65, NULL, 'MIT', 263280),
(444187, 'PF11362', NULL, 'Protein of unknown function (DUF3161)', 83, NULL, 'DUF3161', 263281),
(444188, 'PF01375', NULL, 'Heat-labile enterotoxin alpha chain', 258, NULL, 'Enterotoxin_a', 263282),
(444189, 'PF06936', NULL, 'Selenoprotein S (SelS)', 192, NULL, 'Selenoprotein_S', 263283),
(444190, 'PF02045', NULL, 'CCAAT-binding transcription factor (CBF-B/NF-YA) subunit B', 56, NULL, 'CBFB_NFYA', 263284),
(444191, 'PF18549', NULL, 'Nitrosopumilus output domain 1', 70, NULL, 'NitrOD1', 263285),
(444192, 'PF15127', NULL, 'Small membrane A-kinase anchor protein', 93, NULL, 'SmAKAP', 263286),
(444193, 'PF20613', NULL, 'HipA-like kinase', 240, NULL, 'HipA_2', 263287),
(444194, 'PF08505', NULL, 'Mitochondrial Myo2 receptor-related protein', 265, NULL, 'MMR1', 263288),
(444195, 'PF12121', NULL, 'Dermaseptin', 23, NULL, 'DD_K', 263289),
(444196, 'PF20152', NULL, 'Family of unknown function (DUF6534)', 78, NULL, 'DUF6534', 263290),
(444197, 'PF03486', NULL, 'HI0933-like protein', 409, NULL, 'HI0933_like', 263291),
(444198, 'PF04752', NULL, 'ChaC-like protein', 181, NULL, 'ChaC', 263292),
(444199, 'PF09725', NULL, 'Folate-sensitive fragile site protein Fra10Ac1', 127, NULL, 'Fra10Ac1', 263293),
(444200, 'PF19288', NULL, 'CofH/MqnC C-terminal region', 125, NULL, 'CofH_C', 263294),
(444201, 'PF04671', NULL, 'Erythrocyte membrane-associated giant protein antigen 332', 21, NULL, 'Ag332', 263295),
(444202, 'PF04969', NULL, 'CS domain', 77, NULL, 'CS', 263296),
(444203, 'PF01829', NULL, 'Peptidase A6 family', 358, NULL, 'Peptidase_A6', 263297),
(444204, 'PF09442', NULL, 'Domain of unknown function (DUF2018)', 82, NULL, 'DUF2018', 263298),
(444205, 'PF12025', NULL, 'Phage protein C', 68, NULL, 'Phage_C', 263299),
(444206, 'PF14860', NULL, 'DrrA phosphatidylinositol 4-phosphate binding domain', 104, NULL, 'DrrA_P4M', 263300),
(444207, 'PF03886', NULL, 'ABC-type transport auxiliary lipoprotein component', 161, NULL, 'ABC_trans_aux', 263301),
(444208, 'PF18246', NULL, 'Oligosaccharyltransferase Insert domain', 91, NULL, 'OST_IS', 263302),
(444209, 'PF01885', NULL, 'RNA 2''-phosphotransferase, Tpt1 / KptA family', 187, NULL, 'PTS_2-RNA', 263303),
(444210, 'PF09443', NULL, 'Cripto_Frl-1_Cryptic (CFC)', 35, NULL, 'CFC', 263304),
(444211, 'PF19034', NULL, 'RNase LS, bacterial toxin DBD domain', 125, NULL, 'RnlA-toxin_DBD', 263305),
(444212, 'PF04405', NULL, 'Domain of Unknown function (DUF542)', 56, NULL, 'ScdA_N', 263306),
(444213, 'PF08218', NULL, 'Citrate lyase ligase C-terminal domain', 182, NULL, 'Citrate_ly_lig', 263307),
(444214, 'PF17780', NULL, 'OCRE domain', 52, NULL, 'OCRE', 263308),
(444215, 'PF10039', NULL, 'Predicted integral membrane protein (DUF2275)', 210, NULL, 'DUF2275', 263309);
INSERT INTO "PUBLIC"."MODEL" VALUES
(444216, 'PF17722', NULL, 'Intraflagellar transport-associated protein', 234, NULL, 'IFTAP', 263310),
(444217, 'PF03134', NULL, 'TB2/DP1, HVA22 family', 78, NULL, 'TB2_DP1_HVA22', 263311),
(444218, 'PF16478', NULL, 'Domain of unknown function (DUF5055)', 105, NULL, 'DUF5055', 263312),
(444219, 'PF19369', NULL, 'Family of unknown function (DUF5944)', 243, NULL, 'DUF5944', 263313),
(444220, 'PF05582', NULL, 'YabG peptidase U57', 281, NULL, 'Peptidase_U57', 263314),
(444221, 'PF03197', NULL, 'Bacteriophage FRD2 protein', 103, NULL, 'FRD2', 263315),
(444222, 'PF16573', NULL, 'N-terminal beta-sandwich domain of polyadenylation factor', 92, NULL, 'CLP1_N', 263316),
(444223, 'PF13342', NULL, 'C-terminal repeat of topoisomerase', 61, NULL, 'Toprim_Crpt', 263317),
(444224, 'PF10142', NULL, 'PhoPQ-activated pathogenicity-related protein', 366, NULL, 'PhoPQ_related', 263318),
(444225, 'PF15394', NULL, 'Domain of unknown function (DUF4616)', 524, NULL, 'DUF4616', 263319),
(444226, 'PF18122', NULL, 'Anaphase-promoting complex sub unit 1 C-terminal domain', 167, NULL, 'APC1_C', 263320),
(444227, 'PF12611', NULL, 'Putative flagellar', 24, NULL, 'Flagellar_put', 263321),
(444228, 'PF08151', NULL, 'FerI (NUC094) domain', 52, NULL, 'FerI', 263322),
(444229, 'PF01916', NULL, 'Deoxyhypusine synthase', 288, NULL, 'DS', 263323),
(444230, 'PF20482', NULL, 'Family of unknown function (DUF6722)', 49, NULL, 'DUF6722', 263324),
(444231, 'PF16882', NULL, 'Domain of unknown function (DUF5079)', 223, NULL, 'DUF5079', 263325),
(444232, 'PF05067', NULL, 'Manganese containing catalase', 284, NULL, 'Mn_catalase', 263326),
(444233, 'PF09707', NULL, 'CRISPR-associated protein (Cas_Cas2CT1978)', 86, NULL, 'Cas_Cas2CT1978', 263327),
(444234, 'PF15638', NULL, 'Metallopeptidase toxin 2', 194, NULL, 'Tox-MPTase2', 263328),
(444235, 'PF12960', NULL, 'Protein of unknown function (DUF3849)', 123, NULL, 'DUF3849', 263329),
(444236, 'PF18975', NULL, 'Family of unknown function (DUF5711)', 344, NULL, 'DUF5711', 263330),
(444237, 'PF06049', NULL, 'Coagulation Factor V LSPD Repeat', 9, NULL, 'LSPR', 263331),
(444238, 'PF13822', NULL, 'Acyl-CoA carboxylase epsilon subunit', 61, NULL, 'ACC_epsilon', 263332),
(444239, 'PF19896', NULL, 'Family of unknown function (DUF6369)', 412, NULL, 'DUF6369', 263333),
(444240, 'PF10181', NULL, 'GPI-GlcNAc transferase complex, PIG-H component', 70, NULL, 'PIG-H', 263334),
(444241, 'PF13236', NULL, 'Clustered mitochondria', 225, NULL, 'CLU', 263335),
(444242, 'PF04135', NULL, 'Nucleolar RNA-binding protein, Nop10p family', 52, NULL, 'Nop10p', 263336),
(444243, 'PF12007', NULL, 'Protein of unknown function (DUF3501)', 187, NULL, 'DUF3501', 263337),
(444244, 'PF17160', NULL, 'Domain of unknown function (DUF5124)', 100, NULL, 'DUF5124', 263338),
(444245, 'PF20274', NULL, 'Cyclic-phosphate processing Receiver domain', 89, NULL, 'cREC_REC', 263339),
(444246, 'PF04733', NULL, 'Coatomer epsilon subunit', 290, NULL, 'Coatomer_E', 263340),
(444247, 'PF03096', NULL, 'Ndr family', 283, NULL, 'Ndr', 263341),
(444248, 'PF05523', NULL, 'WxcM-like, C-terminal', 131, NULL, 'FdtA', 263342),
(444249, 'PF05472', NULL, 'DNA replication terminus site-binding protein (Ter protein)', 295, NULL, 'Ter', 263343),
(444250, 'PF18188', NULL, 'Prim-pol 4', 159, NULL, 'PPL4', 263344),
(444251, 'PF09691', NULL, 'Type II secretion system pilotin lipoprotein (PulS_OutS)', 106, NULL, 'T2SS_PulS_OutS', 263345),
(444252, 'PF13799', NULL, 'Domain of unknown function (DUF4183)', 74, NULL, 'DUF4183', 263346),
(444253, 'PF17988', NULL, 'VEGFR-2 Transmembrane domain', 35, NULL, 'VEGFR-2_TMD', 263347),
(444254, 'PF01171', NULL, 'PP-loop family', 184, NULL, 'ATP_bind_3', 263348),
(444255, 'PF14348', NULL, 'Domain of unknown function (DUF4400)', 203, NULL, 'DUF4400', 263349),
(444256, 'PF02075', NULL, 'Crossover junction endodeoxyribonuclease RuvC', 148, NULL, 'RuvC', 263350),
(444257, 'PF04533', NULL, 'Herpes virus U44 protein', 202, NULL, 'Herpes_U44', 263351),
(444258, 'PF17047', NULL, 'Synaptotagmin-like mitochondrial-lipid-binding domain', 180, NULL, 'SMP_LBD', 263352);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(444259, 'PF07024', NULL, 'ImpE protein', 122, NULL, 'ImpE', 263353),
(444260, 'PF13870', NULL, 'Domain of unknown function (DUF4201)', 177, NULL, 'DUF4201', 263354),
(444261, 'PF03202', NULL, 'Putative mycoplasma lipoprotein, C-terminal region', 129, NULL, 'Lipoprotein_10', 263355),
(444262, 'PF14019', NULL, 'Protein of unknown function (DUF4235)', 77, NULL, 'DUF4235', 263356),
(444263, 'PF02723', NULL, 'Coronavirus small envelope protein E', 75, NULL, 'CoV_E', 263357),
(444264, 'PF12692', NULL, 'S-adenosyl-L-methionine methyltransferase', 160, NULL, 'Methyltransf_17', 263358),
(444265, 'PF03066', NULL, 'Nucleoplasmin/nucleophosmin domain', 102, NULL, 'Nucleoplasmin', 263359),
(444266, 'PF16159', NULL, 'FOXP coiled-coil domain', 69, NULL, 'FOXP-CC', 263360),
(444267, 'PF03621', NULL, 'MbtH-like protein', 53, NULL, 'MbtH', 263361),
(444268, 'PF04002', NULL, 'RadC-like JAB domain', 122, NULL, 'RadC', 263362),
(444269, 'PF19410', NULL, 'Family of unknown function (DUF5980)', 97, NULL, 'DUF5980', 263363),
(444270, 'PF05379', NULL, 'Carlavirus endopeptidase', 88, NULL, 'Peptidase_C23', 263364),
(444271, 'PF19362', NULL, 'Family of unknown function (DUF5938)', 234, NULL, 'DUF5938', 263365),
(444272, 'PF14154', NULL, 'Domain of unknown function (DUF4306)', 88, NULL, 'DUF4306', 263366),
(444273, 'PF08678', NULL, 'Rsbr N terminal', 130, NULL, 'Rsbr_N', 263367),
(444274, 'PF04367', NULL, 'Protein of unknown function (DUF502)', 106, NULL, 'DUF502', 263368),
(444275, 'PF10902', NULL, 'WYL_2, Sm-like SH3 beta-barrel fold', 74, NULL, 'WYL_2', 263369),
(444276, 'PF19207', NULL, 'Family of unknown function (DUF5879)', 273, NULL, 'DUF5879', 263370),
(444277, 'PF02017', NULL, 'CIDE-N domain', 77, NULL, 'CIDE-N', 263371),
(444278, 'PF14407', NULL, 'Ribosomally synthesized peptide prototyped by Frankia Franean1_4349.', 63, NULL, 'Frankia_peptide', 263372),
(444279, 'PF19403', NULL, 'Prealbumin-like fold domain', 97, NULL, 'SpaA_2', 263373),
(444280, 'PF17644', NULL, 'Core domain of 30K viral movement proteins', 138, NULL, '30K_MP_core', 263374),
(444281, 'PF12917', NULL, '5''-deoxynucleotidase YfbR-like', 182, NULL, 'YfbR-like', 263375),
(444282, 'PF07258', NULL, 'COMM domain', 64, NULL, 'COMM_domain', 263376),
(444283, 'PF09108', NULL, 'Switch protein XOL-1, N-terminal', 160, NULL, 'Xol-1_N', 263377),
(444284, 'PF06507', NULL, 'Auxin response factor', 83, NULL, 'Auxin_resp', 263378),
(444285, 'PF20521', NULL, 'Family of unknown function (DUF6736)', 131, NULL, 'DUF6736', 263379),
(444286, 'PF12757', NULL, 'Eisosome protein 1', 125, NULL, 'Eisosome1', 263380),
(444287, 'PF13535', NULL, 'ATP-grasp domain', 160, NULL, 'ATP-grasp_4', 263381),
(444288, 'PF03372', NULL, 'Endonuclease/Exonuclease/phosphatase family', 237, NULL, 'Exo_endo_phos', 263382),
(444289, 'PF10191', NULL, 'Golgi complex component 7 (COG7)', 772, NULL, 'COG7', 263383),
(444290, 'PF09374', NULL, 'Predicted Peptidoglycan domain', 76, NULL, 'PG_binding_3', 263384),
(444291, 'PF11080', NULL, 'Endoribonuclease GhoS', 92, NULL, 'GhoS', 263385),
(444292, 'PF09303', NULL, 'KCNMB2, ball and chain domain', 31, NULL, 'KcnmB2_inactiv', 263386),
(444293, 'PF03098', NULL, 'Animal haem peroxidase', 529, NULL, 'An_peroxidase', 263387),
(444294, 'PF18419', NULL, 'ATP-grasp-like domain', 54, NULL, 'ATP-grasp_6', 263388),
(444295, 'PF03090', NULL, 'Replicase family', 131, NULL, 'Replicase', 263389),
(444296, 'PF02990', NULL, 'Endomembrane protein 70', 521, NULL, 'EMP70', 263390),
(444297, 'PF10650', NULL, 'Putative zinc-finger domain', 22, NULL, 'zf-C3H1', 263391),
(444298, 'PF19238', NULL, 'Radical SAM-like domain', 151, NULL, 'Radical_SAM_2', 263392),
(444299, 'PF13081', NULL, 'Domain of unknown function (DUF3941)', 24, NULL, 'DUF3941', 263393),
(444300, 'PF01133', NULL, 'Enhancer of rudimentary', 98, NULL, 'ER', 263394),
(444301, 'PF07775', NULL, 'PaRep2b protein', 512, NULL, 'PaRep2b', 263395),
(444302, 'PF16507', NULL, 'Proteasome-substrate-size regulator, mid region', 524, NULL, 'BLM10_mid', 263396),
(444303, 'PF00194', NULL, 'Eukaryotic-type carbonic anhydrase', 254, NULL, 'Carb_anhydrase', 263397);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(444304, 'PF02649', NULL, 'Type I GTP cyclohydrolase folE2', 259, NULL, 'GCHY-1', 263398),
(444305, 'PF06149', NULL, 'Protein of unknown function (DUF969)', 216, NULL, 'DUF969', 263399),
(444306, 'PF03084', NULL, 'Reoviral Sigma1/Sigma2 family', 418, NULL, 'Sigma_1_2', 263400),
(444307, 'PF02970', NULL, 'Tubulin binding cofactor A', 99, NULL, 'TBCA', 263401),
(444308, 'PF19387', NULL, 'Family of unknown function (DUF5962)', 94, NULL, 'DUF5962', 263402),
(444309, 'PF17342', NULL, 'Family of unknown function (DUF5372)', 78, NULL, 'DUF5372', 263403),
(444310, 'PF14670', NULL, 'Coagulation Factor Xa inhibitory site', 36, NULL, 'FXa_inhibition', 263404),
(444311, 'PF07398', NULL, 'MDMPI C-terminal domain', 90, NULL, 'MDMPI_C', 263405),
(444312, 'PF14838', NULL, 'Integrator complex subunit 5 C-terminus', 691, NULL, 'INTS5_C', 263406),
(444313, 'PF16786', NULL, 'Recombination enhancement, RecA-dependent nuclease', 103, NULL, 'RecA_dep_nuc', 263407),
(444314, 'PF05137', NULL, 'Fimbrial assembly protein (PilN)', 78, NULL, 'PilN', 263408),
(444315, 'PF08540', NULL, 'Hydroxymethylglutaryl-coenzyme A synthase C terminal', 280, NULL, 'HMG_CoA_synt_C', 263409),
(444316, 'PF07789', NULL, 'Protein of unknown function (DUF1627)', 155, NULL, 'DUF1627', 263410),
(444317, 'PF06076', NULL, 'Orthopoxvirus F14 protein', 73, NULL, 'Orthopox_F14', 263411),
(444318, 'PF02507', NULL, 'Photosystem I reaction centre subunit III', 172, NULL, 'PSI_PsaF', 263412),
(444319, 'PF00168', NULL, 'C2 domain', 103, NULL, 'C2', 263413),
(444320, 'PF12929', NULL, 'Stretch-activated Ca2+-permeable channel component', 426, NULL, 'Mid1', 263414),
(444321, 'PF03209', NULL, 'PUCC protein', 401, NULL, 'PUCC', 263415),
(444322, 'PF11528', NULL, 'Protein of unknown function (DUF3224)', 126, NULL, 'DUF3224', 263416),
(444323, 'PF18166', NULL, 'Predicted pPIWI-associating nuclease', 122, NULL, 'pP_pnuc_2', 263417),
(444324, 'PF19620', NULL, 'Family of unknown function (DUF6125)', 164, NULL, 'DUF6125', 263418),
(444325, 'PF04143', NULL, 'Sulphur transport', 310, NULL, 'Sulf_transp', 263419),
(444326, 'PF12300', NULL, 'ATP-dependent RNA helicase RhlB', 175, NULL, 'RhlB', 263420),
(444327, 'PF02748', NULL, 'Aspartate carbamoyltransferase regulatory chain, metal binding domain', 48, NULL, 'PyrI_C', 263421),
(444328, 'PF13140', NULL, 'Domain of unknown function (DUF3980)', 87, NULL, 'DUF3980', 263422),
(444329, 'PF15194', NULL, 'TMEM191C family', 121, NULL, 'TMEM191C', 263423),
(444330, 'PF18967', NULL, 'Family of unknown function (DUF5706)', 107, NULL, 'DUF5706', 263424),
(444331, 'PF04422', NULL, 'Coenzyme F420 hydrogenase/dehydrogenase, beta subunit N-term', 78, NULL, 'FrhB_FdhB_N', 263425),
(444332, 'PF12259', NULL, 'Baculovirus F protein', 610, NULL, 'Baculo_F', 263426),
(444333, 'PF18338', NULL, 'Lower baseplate protein N-terminal domain', 25, NULL, 'BppL_N', 263427),
(444334, 'PF13422', NULL, 'Domain of unknown function (DUF4110)', 95, NULL, 'DUF4110', 263428),
(444335, 'PF06386', NULL, 'Gas vesicle synthesis protein GvpL/GvpF', 244, NULL, 'GvpL_GvpF', 263429),
(444336, 'PF12992', NULL, 'Domain of unknown function, B. Theta Gene description (DUF3876)', 91, NULL, 'DUF3876', 263430),
(444337, 'PF06313', NULL, 'Drosophila ACP53EA protein', 90, NULL, 'ACP53EA', 263431),
(444338, 'PF15312', NULL, 'Junctional sarcoplasmic reticulum protein', 62, NULL, 'JSRP', 263432),
(444339, 'PF14220', NULL, 'Domain of unknown function (DUF4329)', 119, NULL, 'DUF4329', 263433),
(444340, 'PF15485', NULL, 'Domain of unknown function (DUF4643)', 270, NULL, 'DUF4643', 263434),
(444341, 'PF17152', NULL, 'Periplasmic sensor domain', 102, NULL, 'CHASE8', 263435),
(444342, 'PF11421', NULL, 'ATP synthase F1 beta subunit', 49, NULL, 'Synthase_beta', 263436),
(444343, 'PF04509', NULL, 'CheC-like family', 38, NULL, 'CheC', 263437),
(444344, 'PF16302', NULL, 'Domain of unknown function (DUF4944)', 128, NULL, 'DUF4944', 263438),
(444345, 'PF19096', NULL, 'Family of unknown function (DUF5784)', 329, NULL, 'DUF5784', 263439),
(444346, 'PF06355', NULL, 'Aegerolysin', 131, NULL, 'Aegerolysin', 263440); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(444347, 'PF12555', NULL, 'Thiamine pyrophosphokinase C terminal', 52, NULL, 'TPPK_C', 263441),
(444348, 'PF05938', NULL, 'Plant self-incompatibility protein S1', 104, NULL, 'Self-incomp_S1', 263442),
(444349, 'PF01019', NULL, 'Gamma-glutamyltranspeptidase', 512, NULL, 'G_glu_transpept', 263443),
(444350, 'PF07728', NULL, 'AAA domain (dynein-related subfamily)', 138, NULL, 'AAA_5', 263444),
(444351, 'PF06173', NULL, 'Protein of unknown function (DUF986)', 148, NULL, 'DUF986', 263445),
(444352, 'PF11615', NULL, 'CCR4-associated factor 4', 60, NULL, 'Caf4', 263446),
(444353, 'PF02707', NULL, 'Major Outer Sheath Protein N-terminal region', 196, NULL, 'MOSP_N', 263447),
(444354, 'PF10755', NULL, 'Protein of unknown function (DUF2585)', 164, NULL, 'DUF2585', 263448),
(444355, 'PF02275', NULL, 'Linear amide C-N hydrolases, choloylglycine hydrolase family', 316, NULL, 'CBAH', 263449),
(444356, 'PF08426', NULL, 'ICE2', 411, NULL, 'ICE2', 263450),
(444357, 'PF02734', NULL, 'DAK2 domain', 175, NULL, 'Dak2', 263451),
(444358, 'PF19559', NULL, 'Family of unknown function (DUF6081)', 275, NULL, 'DUF6081', 263452),
(444359, 'PF09324', NULL, 'Domain of unknown function (DUF1981)', 84, NULL, 'DUF1981', 263453),
(444360, 'PF17891', NULL, 'Mu-like prophage FluMu N-terminal domain', 49, NULL, 'FluMu_N', 263454),
(444361, 'PF01142', NULL, 'tRNA pseudouridine synthase D (TruD)', 415, NULL, 'TruD', 263455),
(444362, 'PF12351', NULL, 'Ca2+ regulator and membrane fusion protein Fig1', 188, NULL, 'Fig1', 263456),
(444363, 'PF01765', NULL, 'Ribosome recycling factor', 162, NULL, 'RRF', 263457),
(444364, 'PF09407', NULL, 'AbiEi antitoxin C-terminal domain', 142, NULL, 'AbiEi_1', 263458),
(444365, 'PF11354', NULL, 'Protein of unknown function (DUF3156)', 161, NULL, 'DUF3156', 263459),
(444366, 'PF14141', NULL, 'YqzM-like protein', 42, NULL, 'YqzM', 263460),
(444367, 'PF14858', NULL, 'Cilia- and flagella-associated protein 54', 542, NULL, 'CFAP54_N', 263461),
(444368, 'PF18180', NULL, 'SLOG cluster3 family', 170, NULL, 'LD_cluster3', 263462),
(444369, 'PF03478', NULL, 'Protein of unknown function (DUF295)', 55, NULL, 'DUF295', 263463),
(444370, 'PF14785', NULL, 'Maltose transport system permease protein MalF P2 domain', 164, NULL, 'MalF_P2', 263464),
(444371, 'PF19925', NULL, 'Family of unknown function (DUF6388)', 107, NULL, 'DUF6388', 263465),
(444372, 'PF20073', NULL, 'Domain of unknown function (DUF6469)', 130, NULL, 'DUF6469', 263466),
(444373, 'PF10593', NULL, 'Z1 domain', 229, NULL, 'Z1', 263467),
(444374, 'PF12852', NULL, 'Cupin', 184, NULL, 'Cupin_6', 263468),
(444375, 'PF19248', NULL, 'Family of unknown function (DUF5896)', 191, NULL, 'DUF5896', 263469),
(444376, 'PF01610', NULL, 'Transposase', 240, NULL, 'DDE_Tnp_ISL3', 263470),
(444377, 'PF13299', NULL, 'Cleavage and polyadenylation factor 2 C-terminal', 170, NULL, 'CPSF100_C', 263471),
(444378, 'PF01086', NULL, 'Clathrin light chain', 228, NULL, 'Clathrin_lg_ch', 263472),
(444379, 'PF01180', NULL, 'Dihydroorotate dehydrogenase', 295, NULL, 'DHO_dh', 263473),
(444380, 'PF16217', NULL, 'Peptidase M64 N-terminus', 122, NULL, 'M64_N', 263474),
(444381, 'PF17703', NULL, 'Family of unknown function (DUF5549)', 186, NULL, 'DUF5549', 263475),
(444382, 'PF10451', NULL, 'Telomere regulation protein Stn1', 252, NULL, 'Stn1', 263476),
(444383, 'PF16104', NULL, 'Formyl peptide receptor-like 1 inhibitory protein', 105, NULL, 'FPRL1_inhibitor', 263477),
(444384, 'PF14936', NULL, 'Tumour protein p53-inducible protein 11', 179, NULL, 'p53-inducible11', 263478),
(444385, 'PF15331', NULL, 'Cellular tumour antigen p53-inducible 5', 217, NULL, 'TP53IP5', 263479),
(444386, 'PF16279', NULL, 'Domain of unknown function (DUF4927)', 89, NULL, 'DUF4927', 263480),
(444387, 'PF09788', NULL, 'Transmembrane protein 55A', 251, NULL, 'Tmemb_55A', 263481),
(444388, 'PF05486', NULL, 'Signal recognition particle 9 kDa protein (SRP9)', 97, NULL, 'SRP9-21', 263482),
(444389, 'PF09716', NULL, 'Malarial early transcribed membrane protein (ETRAMP)', 83, NULL, 'ETRAMP', 263483),
(444390, 'PF12414', NULL, 'Calcitonin gene-related peptide regulator C terminal', 94, NULL, 'Fox-1_C', 263484);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(444391, 'PF19934', NULL, 'Family of unknown function (DUF6397)', 243, NULL, 'DUF6397', 263485),
(444392, 'PF08734', NULL, 'GYD domain', 91, NULL, 'GYD', 263486),
(444393, 'PF06481', NULL, 'COX Aromatic Rich Motif', 46, NULL, 'COX_ARM', 263487),
(444394, 'PF19709', NULL, 'Family of unknown function (DUF6206)', 271, NULL, 'DUF6206', 263488),
(444395, 'PF07854', NULL, 'Protein of unknown function (DUF1646)', 347, NULL, 'DUF1646', 263489),
(444396, 'PF06427', NULL, 'UDP-glucose:Glycoprotein Glucosyltransferase', 109, NULL, 'UDP-g_GGTase', 263490),
(444397, 'PF09687', NULL, 'Plasmodium RESA N-terminal', 125, NULL, 'PRESAN', 263491),
(444398, 'PF14219', NULL, 'Domain of unknown function (DUF4328)', 167, NULL, 'DUF4328', 263492),
(444399, 'PF15123', NULL, 'Domain of unknown function (DUF4562)', 115, NULL, 'DUF4562', 263493),
(444400, 'PF13755', NULL, 'Sensor N-terminal transmembrane domain', 68, NULL, 'Sensor_TM1', 263494),
(444401, 'PF10805', NULL, 'Protein of unknown function (DUF2730)', 102, NULL, 'DUF2730', 263495),
(444402, 'PF17837', NULL, '4''-phosphopantetheinyl transferase N-terminal domain', 68, NULL, '4PPT_N', 263496),
(444403, 'PF12835', NULL, 'Integrase', 146, NULL, 'Integrase_1', 263497),
(444404, 'PF14894', NULL, 'Lsm C-terminal', 63, NULL, 'Lsm_C', 263498),
(444405, 'PF02488', NULL, 'Merozoite Antigen', 250, NULL, 'EMA', 263499),
(444406, 'PF11007', NULL, 'Spore coat associated protein JA (CotJA)', 35, NULL, 'CotJA', 263500),
(444407, 'PF15893', NULL, 'Domain of unknown function (DUF4739)', 237, NULL, 'DUF4739', 263501),
(444408, 'PF14369', NULL, 'zinc-ribbon', 35, NULL, 'zinc_ribbon_9', 263502),
(444409, 'PF19871', NULL, 'Family of unknown function (DUF6344)', 34, NULL, 'DUF6344', 263503),
(444410, 'PF08587', NULL, 'Ubiquitin associated domain (UBA)', 46, NULL, 'UBA_2', 263504),
(444411, 'PF14226', NULL, 'non-haem dioxygenase in morphine synthesis N-terminal', 118, NULL, 'DIOX_N', 263505),
(444412, 'PF14160', NULL, 'Centrosome-associated C terminus', 115, NULL, 'FAM110_C', 263506),
(444413, 'PF09591', NULL, 'Protein of unknown function (DUF2463)', 210, NULL, 'DUF2463', 263507),
(444414, 'PF14912', NULL, 'Testicular haploid expressed repeat', 58, NULL, 'THEG', 263508),
(444415, 'PF05223', NULL, 'NTF2-like N-terminal transpeptidase domain', 117, NULL, 'MecA_N', 263509),
(444416, 'PF00404', NULL, 'Dockerin type I domain', 58, NULL, 'Dockerin_1', 263510),
(444417, 'PF16128', NULL, 'Domain of unknown function (DUF4840)', 143, NULL, 'DUF4840', 263511),
(444418, 'PF06273', NULL, 'Plant specific eukaryotic initiation factor 4B', 502, NULL, 'eIF-4B', 263512),
(444419, 'PF11393', NULL, 'Type-IV b secretion system, inner-membrane complex component', 180, NULL, 'T4BSS_DotI_IcmL', 263513),
(444420, 'PF03061', NULL, 'Thioesterase superfamily', 79, NULL, '4HBT', 263514),
(444421, 'PF18075', NULL, 'FtsX extracellular domain', 96, NULL, 'FtsX_ECD', 263515),
(444422, 'PF19428', NULL, 'Semaphorin 4F C-terminal', 197, NULL, 'Sema4F_C', 263516),
(444423, 'PF17457', NULL, 'Family of unknown function (DUF5420)', 185, NULL, 'DUF5420', 263517),
(444424, 'PF13842', NULL, 'DDE_Tnp_1-like zinc-ribbon', 31, NULL, 'Tnp_zf-ribbon_2', 263518),
(444425, 'PF10648', NULL, 'Immunoglobulin-like domain of bacterial spore germination', 86, NULL, 'Gmad2', 263519),
(444426, 'PF05867', NULL, 'Protein of unknown function (DUF851)', 241, NULL, 'DUF851', 263520),
(444427, 'PF20530', NULL, 'Domain of unknown function (DUF6745)', 206, NULL, 'DUF6745', 263521),
(444428, 'PF01793', NULL, 'Glycolipid 2-alpha-mannosyltransferase', 325, NULL, 'Glyco_transf_15', 263522),
(444429, 'PF04321', NULL, 'RmlD substrate binding domain', 287, NULL, 'RmlD_sub_bind', 263523),
(444430, 'PF14459', NULL, 'Prokaryotic E2 family C', 129, NULL, 'Prok-E2_C', 263524),
(444431, 'PF04604', NULL, 'Type-A lantibiotic', 51, NULL, 'L_biotic_typeA', 263525),
(444432, 'PF14839', NULL, 'DOR family', 237, NULL, 'DOR', 263526),
(444433, 'PF19481', NULL, 'Family of unknown function (DUF6017)', 148, NULL, 'DUF6017', 263527),
(444434, 'PF04419', NULL, '4F5 protein related disordered region', 38, NULL, '4F5', 263528);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(444435, 'PF12857', NULL, 'TOBE-like domain', 59, NULL, 'TOBE_3', 263529),
(444436, 'PF16044', NULL, 'Domain of unknown function (DUF4796)', 189, NULL, 'DUF4796', 263530),
(444437, 'PF06512', NULL, 'Sodium ion transport-associated', 199, NULL, 'Na_trans_assoc', 263531),
(444438, 'PF04837', NULL, 'MbeB-like, N-term conserved region', 52, NULL, 'MbeB_N', 263532),
(444439, 'PF10694', NULL, 'Protein of unknown function (DUF2500)', 105, NULL, 'DUF2500', 263533),
(444440, 'PF08736', NULL, 'FERM adjacent (FA)', 44, NULL, 'FA', 263534),
(444441, 'PF01084', NULL, 'Ribosomal protein S18', 52, NULL, 'Ribosomal_S18', 263535),
(444442, 'PF11508', NULL, 'Protein of unknown function (DUF3218)', 213, NULL, 'DUF3218', 263536),
(444443, 'PF00173', NULL, 'Cytochrome b5-like Heme/Steroid binding domain', 75, NULL, 'Cyt-b5', 263537),
(444444, 'PF09237', NULL, 'GAGA factor', 54, NULL, 'GAGA', 263538),
(444445, 'PF03616', NULL, 'Sodium/glutamate symporter', 368, NULL, 'Glt_symporter', 263539),
(444446, 'PF09082', NULL, 'Domain of unknown function (DUF1922)', 67, NULL, 'DUF1922', 263540),
(444447, 'PF01271', NULL, 'Granin (chromogranin or secretogranin)', 586, NULL, 'Granin', 263541),
(444448, 'PF19432', NULL, 'DNAJ protein RME-8 N-terminal', 815, NULL, 'RME-8_N', 263542),
(444449, 'PF01643', NULL, 'Acyl-ACP thioesterase', 248, NULL, 'Acyl-ACP_TE', 263543),
(444450, 'PF07800', NULL, 'Protein of unknown function (DUF1644)', 168, NULL, 'DUF1644', 263544),
(444451, 'PF14115', NULL, 'YuzL-like protein', 41, NULL, 'YuzL', 263545),
(444452, 'PF06311', NULL, 'NUMB domain', 95, NULL, 'NumbF', 263546),
(444453, 'PF08305', NULL, 'NPCBM/NEW2 domain', 137, NULL, 'NPCBM', 263547),
(444454, 'PF14333', NULL, 'Domain of unknown function (DUF4389)', 76, NULL, 'DUF4389', 263548),
(444455, 'PF00428', NULL, '60s Acidic ribosomal protein', 88, NULL, 'Ribosomal_60s', 263549),
(444456, 'PF15688', NULL, 'Nuclear receptor-interacting protein 1 repression 2', 324, NULL, 'NRIP1_repr_2', 263550),
(444457, 'PF09381', NULL, 'Outer membrane protein G (OmpG)', 285, NULL, 'Porin_OmpG', 263551),
(444458, 'PF11407', NULL, 'Type II restriction enzyme MunI', 202, NULL, 'RestrictionMunI', 263552),
(444459, 'PF12831', NULL, 'FAD dependent oxidoreductase', 427, NULL, 'FAD_oxidored', 263553),
(444460, 'PF05059', NULL, 'Orbivirus VP4 core protein', 640, NULL, 'Orbi_VP4', 263554),
(444461, 'PF01450', NULL, 'Acetohydroxy acid isomeroreductase, catalytic domain', 144, NULL, 'IlvC', 263555),
(444462, 'PF13227', NULL, 'Protein of unknown function (DUF4035)', 55, NULL, 'DUF4035', 263556),
(444463, 'PF14445', NULL, 'Prokaryotic RING finger family 2', 56, NULL, 'Prok-RING_2', 263557),
(444464, 'PF16105', NULL, 'Domain of unknown function (DUF4823)', 141, NULL, 'DUF4823', 263558),
(444465, 'PF17136', NULL, 'Ribosomal proteins 50S L24/mitochondrial 39S L24', 65, NULL, 'ribosomal_L24', 263559),
(444466, 'PF16098', NULL, 'Fragile X-related mental retardation protein C-terminal region 2', 86, NULL, 'FXMR_C2', 263560),
(444467, 'PF09452', NULL, 'ESCRT-I subunit Mvb12', 90, NULL, 'Mvb12', 263561),
(444468, 'PF17657', NULL, 'Bacterial DNA polymerase III alpha subunit finger domain', 166, NULL, 'DNA_pol3_finger', 263562),
(444469, 'PF03554', NULL, 'UL73 viral envelope glycoprotein', 75, NULL, 'Herpes_UL73', 263563),
(444470, 'PF04100', NULL, 'Vps53-like, N-terminal', 378, NULL, 'Vps53_N', 263564),
(444471, 'PF13005', NULL, 'zinc-finger binding domain of transposase IS66', 46, NULL, 'zf-IS66', 263565),
(444472, 'PF09131', NULL, 'Bacillus thuringiensis delta-Endotoxin, middle domain', 206, NULL, 'Endotoxin_mid', 263566),
(444473, 'PF14103', NULL, 'Domain of unknown function (DUF4276)', 184, NULL, 'DUF4276', 263567),
(444474, 'PF17427', NULL, 'Phage Single-stranded DNA-binding protein', 123, NULL, 'Phi29_Phage_SSB', 263568),
(444475, 'PF09505', NULL, 'Dimethylamine methyltransferase (Dimeth_PyL)', 463, NULL, 'Dimeth_Pyl', 263569),
(444476, 'PF09018', NULL, 'P3 major capsid protein', 394, NULL, 'Phage_Capsid_P3', 263570),
(444477, 'PF19953', NULL, 'Effector Associated Constant Component 1', 107, NULL, 'EACC1', 263571);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(444478, 'PF17752', NULL, 'Burkholderia lethal factor 1', 210, NULL, 'BLF1', 263572),
(444479, 'PF00972', NULL, 'Flavivirus RNA-directed RNA polymerase, fingers and palm domains', 451, NULL, 'Flavi_NS5', 263573),
(444480, 'PF04910', NULL, 'Transcriptional repressor TCF25', 351, NULL, 'Tcf25', 263574),
(444481, 'PF08105', NULL, 'Metchnikowin family', 50, NULL, 'Antimicrobial10', 263575),
(444482, 'PF12700', NULL, 'HlyD family secretion protein', 413, NULL, 'HlyD_2', 263576),
(444483, 'PF00762', NULL, 'Ferrochelatase', 317, NULL, 'Ferrochelatase', 263577),
(444484, 'PF00051', NULL, 'Kringle domain', 79, NULL, 'Kringle', 263578),
(444485, 'PF02212', NULL, 'Dynamin GTPase effector domain', 92, NULL, 'GED', 263579),
(444486, 'PF02889', NULL, 'Sec63 Brl domain', 259, NULL, 'Sec63', 263580),
(444487, 'PF16488', NULL, 'Argonaute linker 2 domain', 47, NULL, 'ArgoL2', 263581),
(444488, 'PF06533', NULL, 'Protein of unknown function (DUF1110)', 189, NULL, 'DUF1110', 263582),
(444489, 'PF12674', NULL, 'Putative zinc ribbon domain', 82, NULL, 'Zn_ribbon_2', 263583),
(444490, 'PF07542', NULL, 'ATP12 chaperone protein', 129, NULL, 'ATP12', 263584),
(444491, 'PF12282', NULL, 'Histidine kinase PdtaS, GAF domain', 144, NULL, 'PdtaS_GAF', 263585),
(444492, 'PF14720', NULL, 'NiFe/NiFeSe hydrogenase small subunit C-terminal', 80, NULL, 'NiFe_hyd_SSU_C', 263586),
(444493, 'PF08073', NULL, 'CHDNT (NUC034) domain', 54, NULL, 'CHDNT', 263587),
(444494, 'PF00070', NULL, 'Pyridine nucleotide-disulphide oxidoreductase', 81, NULL, 'Pyr_redox', 263588),
(444495, 'PF09640', NULL, 'Domain of unknown function (DUF2027)', 156, NULL, 'DUF2027', 263589),
(444496, 'PF02652', NULL, 'L-lactate permease', 522, NULL, 'Lactate_perm', 263590),
(444497, 'PF15860', NULL, 'Domain of unknown function (DUF4728)', 92, NULL, 'DUF4728', 263591),
(444498, 'PF02268', NULL, 'Transcription initiation factor IIA, gamma subunit, helical domain', 47, NULL, 'TFIIA_gamma_N', 263592),
(444499, 'PF05768', NULL, 'Glutaredoxin-like domain (DUF836)', 82, NULL, 'Glrx-like', 263593),
(444500, 'PF07296', NULL, 'TraP protein', 202, NULL, 'TraP', 263594),
(444501, 'PF07317', NULL, 'Flagellar regulator YcgR, PilZN domain', 107, NULL, 'PilZN', 263595),
(444502, 'PF11993', NULL, 'Ribosomal S4P (gammaproteobacterial)', 163, NULL, 'Ribosomal_S4Pg', 263596),
(444503, 'PF18510', NULL, 'Nuclease domain', 160, NULL, 'NUC', 263597),
(444504, 'PF05683', NULL, 'Fumarase C-terminus', 206, NULL, 'Fumerase_C', 263598),
(444505, 'PF18483', NULL, 'Bacterial lectin', 193, NULL, 'Bact_lectin', 263599),
(444506, 'PF00543', NULL, 'Nitrogen regulatory protein P-II', 108, NULL, 'P-II', 263600),
(444507, 'PF20554', NULL, 'Domain of unknown function (DUF6766)', 221, NULL, 'DUF6766', 263601),
(444508, 'PF09565', NULL, 'NgoFVII restriction endonuclease', 287, NULL, 'RE_NgoFVII', 263602),
(444509, 'PF17753', NULL, 'Ig-fold domain', 81, NULL, 'Ig_mannosidase', 263603),
(444510, 'PF19464', NULL, 'Family of unknown function (DUF6001)', 359, NULL, 'DUF6001', 263604),
(444511, 'PF01412', NULL, 'Putative GTPase activating protein for Arf', 117, NULL, 'ArfGap', 263605),
(444512, 'PF06882', NULL, 'Protein of unknown function (DUF1263)', 57, NULL, 'DUF1263', 263606),
(444513, 'PF14126', NULL, 'Domain of unknown function (DUF4293)', 152, NULL, 'DUF4293', 263607),
(444514, 'PF19791', NULL, 'Family of unknown function (DUF6275)', 76, NULL, 'DUF6275', 263608),
(444515, 'PF12041', NULL, 'Transcriptional regulator DELLA protein N terminal', 69, NULL, 'DELLA', 263609),
(444516, 'PF06949', NULL, 'Protein of unknown function (DUF1292)', 75, NULL, 'DUF1292', 263610),
(444517, 'PF12762', NULL, 'ISXO2-like transposase domain', 154, NULL, 'DDE_Tnp_IS1595', 263611),
(444518, 'PF08306', NULL, 'Glycosyl hydrolase family 98', 329, NULL, 'Glyco_hydro_98M', 263612),
(444519, 'PF02608', NULL, 'ABC transporter substrate-binding protein PnrA-like', 302, NULL, 'Bmp', 263613),
(444520, 'PF20495', NULL, 'Family of unknown function (DUF6727)', 152, NULL, 'DUF6727', 263614),
(444521, 'PF04829', NULL, 'Pre-toxin domain with VENN motif', 52, NULL, 'PT-VENN', 263615);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(444522, 'PF07889', NULL, 'Protein of unknown function (DUF1664)', 124, NULL, 'DUF1664', 263616),
(444523, 'PF11953', NULL, 'Domain of unknown function (DUF3470)', 42, NULL, 'DUF3470', 263617),
(444524, 'PF12821', NULL, 'Threonine/Serine exporter, ThrE', 129, NULL, 'ThrE_2', 263618),
(444525, 'PF02115', NULL, 'RHO protein GDP dissociation inhibitor', 193, NULL, 'Rho_GDI', 263619),
(444526, 'PF17173', NULL, 'Domain of unknown function (DUF5129)', 337, NULL, 'DUF5129', 263620),
(444527, 'PF07779', NULL, '10 TM Acyl Transferase domain found in Cas1p', 480, NULL, 'Cas1_AcylT', 263621),
(444528, 'PF08270', NULL, 'M protein trans-acting positive regulator (MGA) PRD domain', 220, NULL, 'PRD_Mga', 263622),
(444529, 'PF09642', NULL, 'YonK protein', 60, NULL, 'YonK', 263623),
(444530, 'PF01008', NULL, 'Initiation factor 2 subunit family', 282, NULL, 'IF-2B', 263624),
(444531, 'PF05702', NULL, 'Herpesvirus UL49.5 envelope/tegument protein', 98, NULL, 'Herpes_UL49_5', 263625),
(444532, 'PF12195', NULL, 'Beta barrel domain of bacteriophage endosialidase', 83, NULL, 'End_beta_barrel', 263626),
(444533, 'PF10047', NULL, 'Protein of unknown function (DUF2281)', 64, NULL, 'DUF2281', 263627),
(444534, 'PF10363', NULL, 'Required for nuclear transport of RNA pol II C-terminus 1', 112, NULL, 'RTP1_C1', 263628),
(444535, 'PF11213', NULL, 'Protein of unknown function (DUF3006)', 67, NULL, 'DUF3006', 263629),
(444536, 'PF15049', NULL, 'Protein of unknown function (DUF4534)', 163, NULL, 'DUF4534', 263630),
(444537, 'PF08783', NULL, 'DWNN domain', 74, NULL, 'DWNN', 263631),
(444538, 'PF10239', NULL, 'Protein of unknown function (DUF2465)', 302, NULL, 'DUF2465', 263632),
(444539, 'PF20195', NULL, 'Family of unknown function (DUF6558)', 260, NULL, 'DUF6558', 263633),
(444540, 'PF01027', NULL, 'Inhibitor of apoptosis-promoting Bax1', 207, NULL, 'Bax1-I', 263634),
(444541, 'PF11526', NULL, 'Subunit of cleavage factor IA Pcf11', 90, NULL, 'CFIA_Pcf11', 263635),
(444542, 'PF17053', NULL, 'Genetic interactor of prohibitin 5', 222, NULL, 'GEP5', 263636),
(444543, 'PF00052', NULL, 'Laminin B (Domain IV)', 136, NULL, 'Laminin_B', 263637),
(444544, 'PF19535', NULL, 'Family of unknown function (DUF6060)', 172, NULL, 'DUF6060', 263638),
(444545, 'PF15777', NULL, 'Tryptophan RNA-binding attenuator protein inhibitory protein', 59, NULL, 'Anti-TRAP', 263639),
(444546, 'PF07057', NULL, 'DNA helicase TraI', 124, NULL, 'TraI', 263640),
(444547, 'PF14812', NULL, 'Transmembrane domain of transglycosylase PBP1 at N-terminal', 85, NULL, 'PBP1_TM', 263641),
(444548, 'PF15778', NULL, 'UNC80 N-terminal', 187, NULL, 'UNC80_N', 263642),
(444549, 'PF12237', NULL, 'Phosphorylated CTD interacting factor 1 WW domain', 176, NULL, 'PCIF1_WW', 263643),
(444550, 'PF06452', NULL, 'Carbohydrate family 9 binding domain-like', 185, NULL, 'CBM9_1', 263644),
(444551, 'PF07915', NULL, 'Glucosidase II beta subunit-like protein', 81, NULL, 'PRKCSH', 263645),
(444552, 'PF08118', NULL, 'Yeast mitochondrial distribution and morphology (MDM) proteins', 525, NULL, 'MDM31_MDM32', 263646),
(444553, 'PF18342', NULL, 'Endo-beta-N-acetylglucosaminidase LytB WW domain', 66, NULL, 'LytB_WW', 263647),
(444554, 'PF19951', NULL, 'Family of unknown function (DUF6413)', 77, NULL, 'DUF6413', 263648),
(444555, 'PF17373', NULL, 'Family of unknown function (DUF5395)', 81, NULL, 'DUF5395', 263649),
(444556, 'PF16677', NULL, 'DNA-packaging protein gp3', 120, NULL, 'GP3_package', 263650),
(444557, 'PF02346', NULL, 'Chordopoxvirus multifunctional envelope protein A27', 56, NULL, 'Vac_Fusion', 263651),
(444558, 'PF17640', NULL, 'Uncharacterized UL17', 102, NULL, 'UL17', 263652),
(444559, 'PF14852', NULL, 'Fis1 N-terminal tetratricopeptide repeat', 33, NULL, 'Fis1_TPR_N', 263653),
(444560, 'PF01161', NULL, 'Phosphatidylethanolamine-binding protein', 132, NULL, 'PBP', 263654),
(444561, 'PF07229', NULL, 'VirE2', 556, NULL, 'VirE2', 263655),
(444562, 'PF07524', NULL, 'Bromodomain associated', 77, NULL, 'Bromo_TP', 263656),
(444563, 'PF07074', NULL, 'Translocon-associated protein, gamma subunit (TRAP-gamma)', 170, NULL, 'TRAP-gamma', 263657);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(444564, 'PF00067', NULL, 'Cytochrome P450', 463, NULL, 'p450', 263658),
(444565, 'PF18892', NULL, 'Family of unknown function (DUF5651)', 54, NULL, 'DUF5651', 263659),
(444566, 'PF09684', NULL, 'Phage tail protein (Tail_P2_I)', 136, NULL, 'Tail_P2_I', 263660),
(444567, 'PF12086', NULL, 'Protein of unknown function (DUF3563)', 61, NULL, 'DUF3563', 263661),
(444568, 'PF01538', NULL, 'Hepatitis C virus non-structural protein NS2', 195, NULL, 'HCV_NS2', 263662),
(444569, 'PF02340', NULL, 'PRRSV putative envelope protein', 234, NULL, 'PRRSV_Env', 263663),
(444570, 'PF02703', NULL, 'Early E1A protein', 289, NULL, 'Adeno_E1A', 263664),
(444571, 'PF16821', NULL, 'C protein from hendra and measles viruses', 153, NULL, 'C_Hendra', 263665),
(444572, 'PF13412', NULL, 'Winged helix-turn-helix DNA-binding', 48, NULL, 'HTH_24', 263666),
(444573, 'PF09607', NULL, 'Brinker DNA-binding domain', 58, NULL, 'BrkDBD', 263667),
(444574, 'PF13304', NULL, 'AAA domain, putative AbiEii toxin, Type IV TA system', 304, NULL, 'AAA_21', 263668),
(444575, 'PF17393', NULL, 'Family of unknown function (DUF5402)', 120, NULL, 'DUF5402', 263669),
(444576, 'PF05630', NULL, 'Necrosis inducing protein (NPP1)', 196, NULL, 'NPP1', 263670),
(444577, 'PF09455', NULL, 'CRISPR-associated (Cas) DxTHG family', 356, NULL, 'Cas_DxTHG', 263671),
(444578, 'PF10081', NULL, 'Alpha/beta-hydrolase family', 288, NULL, 'Abhydrolase_9', 263672),
(444579, 'PF04636', NULL, 'PA26 p53-induced protein (sestrin)', 443, NULL, 'PA26', 263673),
(444580, 'PF15076', NULL, 'Domain of unknown function (DUF4543)', 74, NULL, 'DUF4543', 263674),
(444581, 'PF11976', NULL, 'Ubiquitin-2 like Rad60 SUMO-like', 72, NULL, 'Rad60-SLD', 263675),
(444582, 'PF13166', NULL, 'AAA domain', 714, NULL, 'AAA_13', 263676),
(444583, 'PF14449', NULL, 'Pre-toxin TG', 69, NULL, 'PT-TG', 263677),
(444584, 'PF19748', NULL, 'Family of unknown function (DUF6235)', 96, NULL, 'DUF6235', 263678),
(444585, 'PF00962', NULL, 'Adenosine deaminase', 330, NULL, 'A_deaminase', 263679),
(444586, 'PF02879', NULL, 'Phosphoglucomutase/phosphomannomutase, alpha/beta/alpha domain II', 103, NULL, 'PGM_PMM_II', 263680),
(444587, 'PF05810', NULL, 'NinF protein', 57, NULL, 'NinF', 263681),
(444588, 'PF00658', NULL, 'Poly-adenylate binding protein, unique domain', 66, NULL, 'PABP', 263682),
(444589, 'PF17060', NULL, 'Monopolar spindle protein 2', 348, NULL, 'MPS2', 263683),
(444590, 'PF00720', NULL, 'Subtilisin inhibitor-like', 92, NULL, 'SSI', 263684),
(444591, 'PF15592', NULL, 'Immunity protein 41', 108, NULL, 'Imm41', 263685),
(444592, 'PF15113', NULL, 'TMEM117 protein family', 410, NULL, 'TMEM117', 263686),
(444593, 'PF08194', NULL, 'DIM protein', 36, NULL, 'DIM', 263687),
(444594, 'PF15597', NULL, 'Immunity protein 59', 100, NULL, 'Imm59', 263688),
(444595, 'PF12178', NULL, 'Chromosome passenger complex (CPC) protein INCENP N terminal', 36, NULL, 'INCENP_N', 263689),
(444596, 'PF09952', NULL, 'Transcriptional regulator, AbiEi antitoxin, Type IV TA system', 143, NULL, 'AbiEi_2', 263690),
(444597, 'PF07426', NULL, 'Dynactin subunit p22', 168, NULL, 'Dynactin_p22', 263691),
(444598, 'PF00346', NULL, 'Respiratory-chain NADH dehydrogenase, 49 Kd subunit', 271, NULL, 'Complex1_49kDa', 263692),
(444599, 'PF09659', NULL, 'CRISPR-associated protein (Cas_Csm6)', 373, NULL, 'Cas_Csm6', 263693),
(444600, 'PF18361', NULL, 'Single stranded DNA-binding protein ss DNA binding domain', 136, NULL, 'ssDBP_DBD', 263694),
(444601, 'PF07013', NULL, 'Protein of unknown function (DUF1314)', 179, NULL, 'DUF1314', 263695),
(444602, 'PF09937', NULL, 'Uncharacterized protein conserved in bacteria (DUF2169)', 294, NULL, 'DUF2169', 263696),
(444603, 'PF01172', NULL, 'Shwachman-Bodian-Diamond syndrome (SBDS) protein', 88, NULL, 'SBDS', 263697),
(444604, 'PF02081', NULL, 'Tryptophan RNA-binding attenuator protein', 69, NULL, 'TrpBP', 263698),
(444605, 'PF02952', NULL, 'L-fucose isomerase, C-terminal domain', 143, NULL, 'Fucose_iso_C', 263699),
(444606, 'PF19854', NULL, 'Family of unknown function (DUF6329)', 56, NULL, 'DUF6329', 263700);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(444607, 'PF09085', NULL, 'Adhesion molecule, immunoglobulin-like', 110, NULL, 'Adhes-Ig_like', 263701),
(444608, 'PF20130', NULL, 'Family of unknown function (DUF6520)', 83, NULL, 'DUF6520', 263702),
(444609, 'PF11758', NULL, 'Aureocin-like type II bacteriocin', 51, NULL, 'Bacteriocin_IIi', 263703),
(444610, 'PF06694', NULL, 'Plant nuclear matrix protein 1 (NMP1)', 318, NULL, 'Plant_NMP1', 263704),
(444611, 'PF04927', NULL, 'Seed maturation protein', 59, NULL, 'SMP', 263705),
(444612, 'PF20433', NULL, 'PKAT, KLD domain', 51, NULL, 'PKAT_KLD', 263706),
(444613, 'PF09769', NULL, 'Apolipoprotein O', 131, NULL, 'ApoO', 263707),
(444614, 'PF14242', NULL, 'Domain of unknown function (DUF4342)', 81, NULL, 'DUF4342', 263708),
(444615, 'PF12339', NULL, 'DNA-J related protein', 128, NULL, 'DNAJ_related', 263709),
(444616, 'PF02072', NULL, 'Prepro-orexin', 129, NULL, 'Orexin', 263710),
(444617, 'PF04348', NULL, 'LppC putative lipoprotein', 535, NULL, 'LppC', 263711),
(444618, 'PF08501', NULL, 'Shikimate dehydrogenase substrate binding domain', 83, NULL, 'Shikimate_dh_N', 263712),
(444619, 'PF05386', NULL, 'TEP1 N-terminal domain', 29, NULL, 'TEP1_N', 263713),
(444620, 'PF10153', NULL, 'rRNA-processing protein Efg1', 114, NULL, 'Efg1', 263714),
(444621, 'PF08621', NULL, 'RPAP1-like, N-terminal', 46, NULL, 'RPAP1_N', 263715),
(444622, 'PF06339', NULL, 'Ectoine synthase', 127, NULL, 'Ectoine_synth', 263716),
(444623, 'PF16321', NULL, 'Sigma 54 modulation/S30EA ribosomal protein C terminus', 57, NULL, 'Ribosom_S30AE_C', 263717),
(444624, 'PF03929', NULL, 'PepSY-associated TM region', 288, NULL, 'PepSY_TM', 263718),
(444625, 'PF13370', NULL, '4Fe-4S single cluster domain of Ferredoxin I', 58, NULL, 'Fer4_13', 263719),
(444626, 'PF07985', NULL, 'SRR1 domain', 177, NULL, 'SRR1', 263720),
(444627, 'PF17137', NULL, 'Domain of unknown function (DUF5110)', 71, NULL, 'DUF5110', 263721),
(444628, 'PF05163', NULL, 'DinB family', 166, NULL, 'DinB', 263722),
(444629, 'PF13869', NULL, 'Nucleotide hydrolase', 188, NULL, 'NUDIX_2', 263723),
(444630, 'PF17554', NULL, 'Family of unknown function (DUF5466)', 57, NULL, 'DUF5466', 263724),
(444631, 'PF14563', NULL, 'Domain of unknown function (DUF4444)', 42, NULL, 'DUF4444', 263725),
(444632, 'PF06319', NULL, 'DNA repair protein MmcB-like', 148, NULL, 'MmcB-like', 263726),
(444633, 'PF06353', NULL, 'Protein of unknown function (DUF1062)', 135, NULL, 'DUF1062', 263727),
(444634, 'PF10388', NULL, 'EAL-domain associated signalling protein domain', 166, NULL, 'YkuI_C', 263728),
(444635, 'PF03870', NULL, 'RNA polymerase Rpb8', 140, NULL, 'RNA_pol_Rpb8', 263729),
(444636, 'PF02191', NULL, 'Olfactomedin-like domain', 246, NULL, 'OLF', 263730),
(444637, 'PF08790', NULL, 'LYAR-type C2HC zinc finger', 28, NULL, 'zf-LYAR', 263731),
(444638, 'PF11985', NULL, 'Bacteriophage Mu, Gp27', 173, NULL, 'Phage_Mu_Gp27', 263732),
(444639, 'PF14643', NULL, 'Domain of unknown function (DUF4455)', 469, NULL, 'DUF4455', 263733),
(444640, 'PF12318', NULL, 'Membrane bound FAD containing D-sorbitol dehydrogenase', 162, NULL, 'FAD-SLDH', 263734),
(444641, 'PF20164', NULL, 'GspA/SrpA SigLec-like domain', 117, NULL, 'GspA_SrpA_N', 263735),
(444642, 'PF07190', NULL, 'Protein of unknown function (DUF1406)', 172, NULL, 'DUF1406', 263736),
(444643, 'PF06153', NULL, 'Cyclic-di-AMP receptor', 109, NULL, 'CdAMP_rec', 263737),
(444644, 'PF15284', NULL, 'Phage-encoded virulence factor', 64, NULL, 'PAGK', 263738),
(444645, 'PF04879', NULL, 'Molybdopterin oxidoreductase Fe4S4 domain', 55, NULL, 'Molybdop_Fe4S4', 263739),
(444646, 'PF13897', NULL, 'Golgi-dynamics membrane-trafficking', 133, NULL, 'GOLD_2', 263740),
(444647, 'PF15706', NULL, 'Mature oligodendrocyte transmembrane protein, TMEM132D, C-term', 87, NULL, 'TMEM132D_C', 263741),
(444648, 'PF08511', NULL, 'COQ9', 77, NULL, 'COQ9', 263742),
(444649, 'PF19572', NULL, 'Type IX secretion system protein PorV', 243, NULL, 'PorV', 263743),
(444650, 'PF18318', NULL, 'Glutamine synthetase C-terminal domain', 118, NULL, 'Gln-synt_C-ter', 263744),
(444651, 'PF02581', NULL, 'Thiamine monophosphate synthase', 181, NULL, 'TMP-TENI', 263745);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(444652, 'PF11320', NULL, 'Protein of unknown function (DUF3122)', 136, NULL, 'DUF3122', 263746),
(444653, 'PF18599', NULL, 'Limiting CO2-inducible proteins B/C beta carbonyic anhydrases', 222, NULL, 'LCIB_C_CA', 263747),
(444654, 'PF10107', NULL, 'Endonuclease related to archaeal Holliday junction resolvase', 159, NULL, 'Endonuc_Holl', 263748),
(444655, 'PF02044', NULL, 'Bombesin-like peptide', 14, NULL, 'Bombesin', 263749),
(444656, 'PF14503', NULL, 'YhfZ C-terminal domain', 236, NULL, 'YhfZ_C', 263750),
(444657, 'PF16505', NULL, 'P4 movement protein of Emaravirus, and the 30K superfamily', 349, NULL, 'Emaravirus_P4', 263751),
(444658, 'PF10494', NULL, 'Serine-threonine protein kinase 19', 245, NULL, 'Stk19', 263752),
(444659, 'PF02827', NULL, 'cAMP-dependent protein kinase inhibitor', 69, NULL, 'PKI', 263753),
(444660, 'PF07210', NULL, 'Protein of unknown function (DUF1416)', 97, NULL, 'DUF1416', 263754),
(444661, 'PF13397', NULL, 'RNA polymerase-binding protein', 104, NULL, 'RbpA', 263755),
(444662, 'PF19338', NULL, 'Neutrophin-3 N-terminus', 114, NULL, 'NTF3_N', 263756),
(444663, 'PF14896', NULL, 'EmbC C-terminal domain', 385, NULL, 'Arabino_trans_C', 263757),
(444664, 'PF19440', NULL, 'Tetratricopeptide repeat protein 7 N-terminal', 386, NULL, 'TTC7_N', 263758),
(444665, 'PF17371', NULL, 'Family of unknown function (DUF5393)', 666, NULL, 'DUF5393', 263759),
(444666, 'PF18953', NULL, 'SAP domain-containing new25', 51, NULL, 'SAP_new25', 263760),
(444667, 'PF00120', NULL, 'Glutamine synthetase, catalytic domain', 345, NULL, 'Gln-synt_C', 263761),
(444668, 'PF03971', NULL, 'Monomeric isocitrate dehydrogenase', 734, NULL, 'IDH', 263762),
(444669, 'PF17759', NULL, 'Phenylalanyl tRNA synthetase beta chain CLM domain', 215, NULL, 'tRNA_synthFbeta', 263763),
(444670, 'PF15689', NULL, 'Nuclear receptor-interacting protein 1 repression 3', 88, NULL, 'NRIP1_repr_3', 263764),
(444671, 'PF03627', NULL, 'PapG carbohydrate binding domain', 226, NULL, 'PapG_N', 263765),
(444672, 'PF08747', NULL, 'BREX protein BrxB', 124, NULL, 'BrxB', 263766),
(444673, 'PF18354', NULL, 'CarS bacterial SH3 domain', 85, NULL, 'SH3_18', 263767),
(444674, 'PF01010', NULL, 'NADH-dehyrogenase subunit F, TMs, (complex I) C-terminus', 243, NULL, 'Proton_antipo_C', 263768),
(444675, 'PF15242', NULL, 'Family of FAM53', 304, NULL, 'FAM53', 263769),
(444676, 'PF15373', NULL, 'Domain of unknown function (DUF4601)', 438, NULL, 'DUF4601', 263770),
(444677, 'PF01941', NULL, 'S-adenosylmethionine synthetase (AdoMet synthetase)', 395, NULL, 'AdoMet_Synthase', 263771),
(444678, 'PF03931', NULL, 'Skp1 family, tetramerisation domain', 63, NULL, 'Skp1_POZ', 263772),
(444679, 'PF15469', NULL, 'Exocyst complex component Sec5', 825, NULL, 'Sec5', 263773),
(444680, 'PF08093', NULL, 'Magi 5 toxic peptide family', 30, NULL, 'Toxin_23', 263774),
(444681, 'PF00604', NULL, 'Influenza RNA-dependent RNA polymerase subunit PB2', 754, NULL, 'Flu_PB2', 263775),
(444682, 'PF01297', NULL, 'Zinc-uptake complex component A periplasmic', 247, NULL, 'ZnuA', 263776),
(444683, 'PF11303', NULL, 'Protein of unknown function (DUF3105)', 128, NULL, 'DUF3105', 263777),
(444684, 'PF20103', NULL, 'Family of unknown function (DUF6493)', 933, NULL, 'DUF6493', 263778),
(444685, 'PF07504', NULL, 'Fungalysin/Thermolysin Propeptide Motif', 51, NULL, 'FTP', 263779),
(444686, 'PF15220', NULL, 'Hypoxia-inducible lipid droplet-associated', 63, NULL, 'HILPDA', 263780),
(444687, 'PF18621', NULL, 'Family of unknown function (DUF5628)', 110, NULL, 'DUF5628', 263781),
(444688, 'PF02297', NULL, 'Cytochrome oxidase c subunit VIb', 76, NULL, 'COX6B', 263782),
(444689, 'PF14586', NULL, 'Class I Histocompatibility antigen, NKG2D ligand, domains 1 and 2', 174, NULL, 'MHC_I_2', 263783),
(444690, 'PF15464', NULL, 'Domain of unknown function (DUF4633)', 113, NULL, 'DUF4633', 263784),
(444691, 'PF00438', NULL, 'S-adenosylmethionine synthetase, N-terminal domain', 99, NULL, 'S-AdoMet_synt_N', 263785),
(444692, 'PF15392', NULL, 'Joubert syndrome-associated', 339, NULL, 'Joubert', 263786),
(444693, 'PF19378', NULL, 'Family of unknown function (DUF5953)', 233, NULL, 'DUF5953', 263787);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(444694, 'PF20251', NULL, 'Bacterial Ig-like domain', 105, NULL, 'Big_14', 263788),
(444695, 'PF13807', NULL, 'G-rich domain on putative tyrosine kinase', 82, NULL, 'GNVR', 263789),
(444696, 'PF03558', NULL, 'TBSV core protein P21/P22', 187, NULL, 'TBSV_P22', 263790),
(444697, 'PF10466', NULL, 'Saccharopepsin inhibitor I34', 69, NULL, 'Inhibitor_I34', 263791),
(444698, 'PF14684', NULL, 'Tricorn protease C1 domain', 70, NULL, 'Tricorn_C1', 263792),
(444699, 'PF07106', NULL, 'TBPIP/Hop2 winged helix domain', 62, NULL, 'TBPIP', 263793),
(444700, 'PF15276', NULL, 'Protein phosphatase 1 binding', 62, NULL, 'PP1_bind', 263794),
(444701, 'PF07462', NULL, 'Merozoite surface protein 1 (MSP1) C-terminus', 554, NULL, 'MSP1_C', 263795),
(444702, 'PF12613', NULL, 'Flagellin structural protein', 53, NULL, 'FliC_SP', 263796),
(444703, 'PF17635', NULL, 'Betacoronavirus uncharacterised protein 14 (SARS-CoV-2 like)', 70, NULL, 'bCoV_Orf14', 263797),
(444704, 'PF04951', NULL, 'D-aminopeptidase', 264, NULL, 'Peptidase_M55', 263798),
(444705, 'PF20604', NULL, 'Domain of unknown function (DUF6798)', 61, NULL, 'DUF6798', 263799),
(444706, 'PF04510', NULL, 'Family of unknown function (DUF577)', 173, NULL, 'DUF577', 263800),
(444707, 'PF05066', NULL, 'HB1, ASXL, restriction endonuclease HTH domain', 72, NULL, 'HARE-HTH', 263801),
(444708, 'PF02179', NULL, 'BAG domain', 78, NULL, 'BAG', 263802),
(444709, 'PF02145', NULL, 'Rap/ran-GAP', 186, NULL, 'Rap_GAP', 263803),
(444710, 'PF12976', NULL, 'Domain of Unknown Function with PDB structure (DUF3860)', 92, NULL, 'DUF3860', 263804),
(444711, 'PF01658', NULL, 'Myo-inositol-1-phosphate synthase', 107, NULL, 'Inos-1-P_synth', 263805),
(444712, 'PF17816', NULL, 'PDZ domain', 114, NULL, 'PDZ_4', 263806),
(444713, 'PF05051', NULL, 'Cytochrome C oxidase copper chaperone (COX17)', 48, NULL, 'COX17', 263807),
(444714, 'PF05272', NULL, 'Virulence-associated protein E', 217, NULL, 'VirE', 263808),
(444715, 'PF07282', NULL, 'Putative transposase DNA-binding domain', 69, NULL, 'OrfB_Zn_ribbon', 263809),
(444716, 'PF13621', NULL, 'Cupin-like domain', 254, NULL, 'Cupin_8', 263810),
(444717, 'PF05589', NULL, 'Protein of unknown function (DUF768)', 67, NULL, 'DUF768', 263811),
(444718, 'PF06715', NULL, 'Gp5 C-terminal repeat (3 copies)', 24, NULL, 'Gp5_C', 263812),
(444719, 'PF00548', NULL, '3C cysteine protease (picornain 3C)', 174, NULL, 'Peptidase_C3', 263813),
(444720, 'PF06569', NULL, 'Protein of unknown function (DUF1128)', 71, NULL, 'DUF1128', 263814),
(444721, 'PF10468', NULL, 'Carboxypeptidase inhibitor I68', 87, NULL, 'Inhibitor_I68', 263815),
(444722, 'PF16171', NULL, 'Centromere kinetochore component CENP-T N-terminus', 366, NULL, 'CENP-T_N', 263816),
(444723, 'PF09943', NULL, 'Uncharacterized protein conserved in archaea (DUF2175)', 98, NULL, 'DUF2175', 263817),
(444724, 'PF14730', NULL, 'Domain of unknown function (DUF4468) with TBP-like fold', 92, NULL, 'DUF4468', 263818),
(444725, 'PF08317', NULL, 'Spc7 kinetochore protein', 196, NULL, 'Spc7', 263819),
(444726, 'PF12637', NULL, 'TSCPD domain', 74, NULL, 'TSCPD', 263820),
(444727, 'PF19448', NULL, 'Family of unknown function (DUF5986)', 240, NULL, 'DUF5986', 263821),
(444728, 'PF15498', NULL, 'Nephrin and CD2AP-binding protein, Dendrin', 656, NULL, 'Dendrin', 263822),
(444729, 'PF01709', NULL, 'Transcriptional regulator', 239, NULL, 'Transcrip_reg', 263823),
(444730, 'PF04958', NULL, 'Arginine N-succinyltransferase beta subunit', 337, NULL, 'AstA', 263824),
(444731, 'PF02574', NULL, 'Homocysteine S-methyltransferase', 274, NULL, 'S-methyl_trans', 263825),
(444732, 'PF18485', NULL, 'Glutathione S-transferase, N-terminal domain', 74, NULL, 'GST_N_5', 263826),
(444733, 'PF20476', NULL, 'Family of unknown function (DUF6718)', 74, NULL, 'DUF6718', 263827),
(444734, 'PF12080', NULL, 'GldM C-terminal domain', 172, NULL, 'GldM_C', 263828),
(444735, 'PF12656', NULL, 'G-patch domain', 61, NULL, 'G-patch_2', 263829),
(444736, 'PF04051', NULL, 'Transport protein particle (TRAPP) component', 155, NULL, 'TRAPP', 263830),
(444737, 'PF03305', NULL, 'Mycoplasma MG185/MG260 protein', 183, NULL, 'Lipoprotein_X', 263831);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(444738, 'PF05282', NULL, 'AAR2 protein', 369, NULL, 'AAR2', 263832),
(444739, 'PF09459', NULL, 'Ethylbenzene dehydrogenase', 272, NULL, 'EB_dh', 263833),
(444740, 'PF19531', NULL, 'Family of unknown function (DUF6058)', 126, NULL, 'DUF6058', 263834),
(444741, 'PF13592', NULL, 'Winged helix-turn helix', 60, NULL, 'HTH_33', 263835),
(444742, 'PF15774', NULL, 'Domain of unknown function (DUF4702)', 395, NULL, 'DUF4702', 263836),
(444743, 'PF06603', NULL, 'UpxZ family of transcription anti-terminator antagonists', 105, NULL, 'UpxZ', 263837),
(444744, 'PF04071', NULL, 'Cysteine-rich small domain', 82, NULL, 'zf-like', 263838),
(444745, 'PF15222', NULL, 'Kidney androgen-regulated', 103, NULL, 'KAR', 263839),
(444746, 'PF08007', NULL, 'JmjC domain', 127, NULL, 'JmjC_2', 263840),
(444747, 'PF16001', NULL, 'Domain of unknown function (DUF4775)', 456, NULL, 'DUF4775', 263841),
(444748, 'PF16320', NULL, 'Ribosomal protein L7/L12 dimerisation domain', 48, NULL, 'Ribosomal_L12_N', 263842),
(444749, 'PF05917', NULL, 'Helicobacter pylori protein of unknown function (DUF874)', 398, NULL, 'DUF874', 263843),
(444750, 'PF03755', NULL, 'YicC-like family, N-terminal region', 152, NULL, 'YicC_N', 263844),
(444751, 'PF20599', NULL, 'Family of unknown function (DUF6796)', 225, NULL, 'DUF6796', 263845),
(444752, 'PF09729', NULL, 'Gti1/Pac2 family', 181, NULL, 'Gti1_Pac2', 263846),
(444753, 'PF05299', NULL, 'M61 glycyl aminopeptidase', 118, NULL, 'Peptidase_M61', 263847),
(444754, 'PF15121', NULL, 'TMEM71 protein family', 150, NULL, 'TMEM71', 263848),
(444755, 'PF20090', NULL, 'Family of unknown function (DUF6482)', 101, NULL, 'DUF6482', 263849),
(444756, 'PF08786', NULL, 'DcrB', 129, NULL, 'DcrB', 263850),
(444757, 'PF14083', NULL, 'PGDYG protein', 102, NULL, 'PGDYG', 263851),
(444758, 'PF00332', NULL, 'Glycosyl hydrolases family 17', 313, NULL, 'Glyco_hydro_17', 263852),
(444759, 'PF01453', NULL, 'D-mannose binding lectin', 106, NULL, 'B_lectin', 263853),
(444760, 'PF10073', NULL, 'Uncharacterized protein conserved in bacteria (DUF2312)', 72, NULL, 'DUF2312', 263854),
(444761, 'PF03650', NULL, 'Mitochondrial pyruvate carriers', 110, NULL, 'MPC', 263855),
(444762, 'PF17627', NULL, 'Inclusion membrane protein E', 132, NULL, 'IncE', 263856),
(444763, 'PF16920', NULL, 'Leucine rich repeat C-terminal motif', 45, NULL, 'LRRCT_2', 263857),
(444764, 'PF17577', NULL, 'ECORI-T site', 109, NULL, 'ETM', 263858),
(444765, 'PF13431', NULL, 'Tetratricopeptide repeat', 34, NULL, 'TPR_17', 263859),
(444766, 'PF14056', NULL, 'Domain of unknown function (DUF4250)', 55, NULL, 'DUF4250', 263860),
(444767, 'PF16904', NULL, 'Phosphoribosylformylglycinamidine synthase II C-terminus', 92, NULL, 'PurL_C', 263861),
(444768, 'PF20301', NULL, 'Predicted novel nucleotide synthetase', 165, NULL, 'pNTSase1', 263862),
(444769, 'PF02110', NULL, 'Hydroxyethylthiazole kinase family', 246, NULL, 'HK', 263863),
(444770, 'PF05219', NULL, 'DREV methyltransferase', 265, NULL, 'DREV', 263864),
(444771, 'PF16693', NULL, 'Inner membrane component of T3SS, periplasmic domain', 254, NULL, 'Yop-YscD_ppl', 263865),
(444772, 'PF17239', NULL, 'Family of unknown function (DUF5312)', 553, NULL, 'DUF5312', 263866),
(444773, 'PF05635', NULL, '23S rRNA-intervening sequence protein', 106, NULL, '23S_rRNA_IVP', 263867),
(444774, 'PF06673', NULL, 'Lactococcus lactis bacteriophage major capsid protein', 347, NULL, 'L_lactis_ph-MCP', 263868),
(444775, 'PF01624', NULL, 'MutS domain I', 113, NULL, 'MutS_I', 263869),
(444776, 'PF05248', NULL, 'Adenovirus E3A', 104, NULL, 'Adeno_E3A', 263870),
(444777, 'PF02945', NULL, 'Recombination endonuclease VII', 82, NULL, 'Endonuclease_7', 263871),
(444778, 'PF15829', NULL, 'Domain of unknown function (DUF4711)', 224, NULL, 'DUF4711', 263872),
(444779, 'PF07230', NULL, 'Bacteriophage T4-like portal protein (Gp20)', 432, NULL, 'Portal_Gp20', 263873),
(444780, 'PF17874', NULL, 'MalT-like TPR region', 336, NULL, 'TPR_MalT', 263874),
(444781, 'PF11423', NULL, 'Regulatory protein Mnt', 28, NULL, 'Repressor_Mnt', 263875),
(444782, 'PF14265', NULL, 'Domain of unknown function (DUF4355)', 124, NULL, 'DUF4355', 263876);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(444783, 'PF02814', NULL, 'UreE urease accessory protein, N-terminal domain', 62, NULL, 'UreE_N', 263877),
(444784, 'PF16126', NULL, 'Domain of unknown function (DUF4838)', 266, NULL, 'DUF4838', 263878),
(444785, 'PF04878', NULL, 'Baculovirus P48 protein', 371, NULL, 'Baculo_p48', 263879),
(444786, 'PF15844', NULL, 'Transmembrane and coiled-coil domain-containing protein 2', 171, NULL, 'TMCCDC2', 263880),
(444787, 'PF12333', NULL, 'Rix1 complex component involved in 60S ribosome maturation', 102, NULL, 'Ipi1_N', 263881),
(444788, 'PF12834', NULL, 'Phage integrase, N-terminal', 91, NULL, 'Phage_int_SAM_2', 263882),
(444789, 'PF09155', NULL, 'Domain of unknown function (DUF1940)', 143, NULL, 'DUF1940', 263883),
(444790, 'PF17391', NULL, 'Urocanase N-terminal domain', 127, NULL, 'Urocanase_N', 263884),
(444791, 'PF20006', NULL, 'YukD-like N-terminal domain', 86, NULL, 'fvmYukDl_N', 263885),
(444792, 'PF04710', NULL, 'Pellino', 411, NULL, 'Pellino', 263886),
(444793, 'PF12979', NULL, 'Domain of Unknown Function with PDB structure (DUF3863)', 349, NULL, 'DUF3863', 263887),
(444794, 'PF19696', NULL, 'Family of unknown function (DUF6196)', 144, NULL, 'DUF6196', 263888),
(444795, 'PF20244', NULL, 'Family of unknown function (DUF6599)', 185, NULL, 'DUF6599', 263889),
(444796, 'PF14913', NULL, 'DPCD protein family', 190, NULL, 'DPCD', 263890),
(444797, 'PF15057', NULL, 'Domain of unknown function (DUF4537)', 124, NULL, 'DUF4537', 263891),
(444798, 'PF12113', NULL, 'SVM protein signal sequence', 33, NULL, 'SVM_signal', 263892),
(444799, 'PF09940', NULL, 'Domain of unknown function (DUF2172)', 92, NULL, 'DUF2172', 263893),
(444800, 'PF17965', NULL, 'Mucin binding domain', 76, NULL, 'MucBP_2', 263894),
(444801, 'PF06197', NULL, 'Protein of unknown function (DUF998)', 185, NULL, 'DUF998', 263895),
(444802, 'PF09025', NULL, 'YopR, type III needle-polymerisation regulator', 145, NULL, 'T3SS_needle_reg', 263896),
(444803, 'PF11300', NULL, 'Protein of unknown function (DUF3102)', 130, NULL, 'DUF3102', 263897),
(444804, 'PF20100', NULL, 'Family of unknown function (DUF6490)', 127, NULL, 'DUF6490', 263898),
(444805, 'PF09355', NULL, 'Phage protein Gp19/Gp15/Gp42', 116, NULL, 'Phage_Gp19', 263899),
(444806, 'PF17374', NULL, 'Family of unknown function (DUF5396)', 947, NULL, 'DUF5396', 263900),
(444807, 'PF20021', NULL, 'vWA-MoxR associated protein middle region (VMAP-M) 18', 109, NULL, 'VMAP-M18', 263901),
(444808, 'PF15773', NULL, 'Dynein axonemal-associated protein 1', 505, NULL, 'DAAP1', 263902),
(444809, 'PF17564', NULL, 'Family of unknown function (DUF5470)', 73, NULL, 'DUF5470', 263903),
(444810, 'PF11135', NULL, 'Protein of unknown function (DUF2888)', 144, NULL, 'DUF2888', 263904),
(444811, 'PF17523', NULL, 'MinK-related peptide, potassium channel accessory sub-unit protein 4', 78, NULL, 'MPS-4', 263905),
(444812, 'PF02509', NULL, 'Rotavirus non-structural protein 35', 316, NULL, 'Rota_NS35', 263906),
(444813, 'PF05670', NULL, 'NFACT protein RNA binding domain', 111, NULL, 'NFACT-R_1', 263907),
(444814, 'PF14762', NULL, 'Hermansky-Pudlak syndrome 3, middle region', 385, NULL, 'HPS3_Mid', 263908),
(444815, 'PF00338', NULL, 'Ribosomal protein S10p/S20e', 98, NULL, 'Ribosomal_S10', 263909),
(444816, 'PF03880', NULL, 'DbpA RNA binding domain', 72, NULL, 'DbpA', 263910),
(444817, 'PF11006', NULL, 'Protein of unknown function (DUF2845)', 83, NULL, 'DUF2845', 263911),
(444818, 'PF07285', NULL, 'Protein of unknown function (DUF1444)', 264, NULL, 'DUF1444', 263912),
(444819, 'PF16639', NULL, 'Apocytochrome F, N-terminal', 155, NULL, 'Apocytochr_F_N', 263913),
(444820, 'PF11412', NULL, 'Disulphide bond corrector protein DsbC', 120, NULL, 'DsbC', 263914),
(444821, 'PF20182', NULL, 'Family of unknown function (DUF6545)', 137, NULL, 'DUF6545', 263915),
(444822, 'PF20265', NULL, 'ATPase, RavA, LARA domain', 104, NULL, 'LARA_dom', 263916),
(444823, 'PF15198', NULL, 'Dexamethasone-induced', 90, NULL, 'Dexa_ind', 263917),
(444824, 'PF04005', NULL, 'Hus1-like protein', 292, NULL, 'Hus1', 263918),
(444825, 'PF14120', NULL, 'YhzD-like protein', 61, NULL, 'YhzD', 263919);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(444826, 'PF11731', NULL, 'Pathogenicity locus', 86, NULL, 'Cdd1', 263920),
(444827, 'PF03082', NULL, 'Male accessory gland secretory protein', 264, NULL, 'MAGSP', 263921),
(444828, 'PF06616', NULL, 'BsuBI/PstI restriction endonuclease domain', 154, NULL, 'BsuBI_PstI_RE', 263922),
(444829, 'PF02052', NULL, 'Gallidermin', 52, NULL, 'Gallidermin', 263923),
(444830, 'PF13142', NULL, 'Domain of unknown function (DUF3960)', 89, NULL, 'DUF3960', 263924),
(444831, 'PF15811', NULL, 'Small VCP/p97-interacting protein', 77, NULL, 'SVIP', 263925),
(444832, 'PF03661', NULL, 'Transmembrane protein 33/Nucleoporin POM33', 240, NULL, 'TMEM33_Pom33', 263926),
(444833, 'PF08260', NULL, 'Insect kinin peptide', 8, NULL, 'Kinin', 263927),
(444834, 'PF15115', NULL, 'Domain of unknown function with conserved HDNR motif', 177, NULL, 'HDNR', 263928),
(444835, 'PF10276', NULL, 'Zinc-finger domain', 37, NULL, 'zf-CHCC', 263929),
(444836, 'PF10282', NULL, 'Lactonase, 7-bladed beta-propeller', 344, NULL, 'Lactonase', 263930),
(444837, 'PF13882', NULL, 'Bravo-like intracellular region', 88, NULL, 'Bravo_FIGEY', 263931),
(444838, 'PF18875', NULL, 'AF4 interaction motif', 15, NULL, 'AF4_int', 263932),
(444839, 'PF10628', NULL, 'Outer spore coat protein E (CotE)', 177, NULL, 'CotE', 263933),
(444840, 'PF01424', NULL, 'R3H domain', 60, NULL, 'R3H', 263934),
(444841, 'PF02501', NULL, 'Type II secretion system (T2SS), protein I', 80, NULL, 'T2SSI', 263935),
(444842, 'PF07486', NULL, 'Cell Wall Hydrolase', 107, NULL, 'Hydrolase_2', 263936),
(444843, 'PF09363', NULL, 'XFP C-terminal domain', 202, NULL, 'XFP_C', 263937),
(444844, 'PF11756', NULL, 'Nitrous oxide-stimulated promoter', 107, NULL, 'YgbA_NO', 263938),
(444845, 'PF15890', NULL, 'Putative zinc-binding metallo-peptidase', 243, NULL, 'Peptidase_Mx1', 263939),
(444846, 'PF18147', NULL, 'Suv3 C-terminal domain 1', 43, NULL, 'Suv3_C_1', 263940),
(444847, 'PF10034', NULL, 'Q-cell neuroblast polarisation', 655, NULL, 'Dpy19', 263941),
(444848, 'PF03264', NULL, 'NapC/NirT cytochrome c family, N-terminal region', 174, NULL, 'Cytochrom_NNT', 263942),
(444849, 'PF10393', NULL, 'Trimeric coiled-coil oligomerisation domain of matrilin', 45, NULL, 'Matrilin_ccoil', 263943),
(444850, 'PF00059', NULL, 'Lectin C-type domain', 109, NULL, 'Lectin_C', 263944),
(444851, 'PF13170', NULL, 'Protein of unknown function (DUF4003)', 296, NULL, 'DUF4003', 263945),
(444852, 'PF03759', NULL, 'PRONE (Plant-specific Rop nucleotide exchanger)', 363, NULL, 'PRONE', 263946),
(444853, 'PF06270', NULL, 'Protein of unknown function (DUF1030)', 53, NULL, 'DUF1030', 263947),
(444854, 'PF17212', NULL, 'Tail tubular protein', 169, NULL, 'Tube', 263948),
(444855, 'PF19127', NULL, 'Choline-binding repeat', 48, NULL, 'Choline_bind_3', 263949),
(444856, 'PF19753', NULL, 'Family of unknown function (DUF6240)', 278, NULL, 'DUF6240', 263950),
(444857, 'PF06027', NULL, 'Solute carrier family 35', 299, NULL, 'SLC35F', 263951),
(444858, 'PF07628', NULL, 'Protein of unknown function (DUF1589)', 164, NULL, 'DUF1589', 263952),
(444859, 'PF19442', NULL, 'Cysteine-rich motor neuron 1 protein C-terminal', 130, NULL, 'CRIM1_C', 263953),
(444860, 'PF18462', NULL, 'Domain of unknown function (DUF5612)', 143, NULL, 'DUF5612', 263954),
(444861, 'PF19321', NULL, 'BTB/POZ domain-containing protein KCTD18 C-terminus', 309, NULL, 'KCTD18_C', 263955),
(444862, 'PF19829', NULL, 'Family of unknown function (DUF6310)', 126, NULL, 'DUF6310', 263956),
(444863, 'PF08261', NULL, 'Carcinustatin peptide', 8, NULL, 'Carcinustatin', 263957),
(444864, 'PF02098', NULL, 'Tick histamine binding protein', 152, NULL, 'His_binding', 263958),
(444865, 'PF14222', NULL, 'Cell morphogenesis N-terminal', 555, NULL, 'MOR2-PAG1_N', 263959),
(444866, 'PF13749', NULL, 'Putative ATP-dependent DNA helicase recG C-terminal', 88, NULL, 'HATPase_c_4', 263960),
(444867, 'PF03029', NULL, 'Conserved hypothetical ATP binding protein', 241, NULL, 'ATP_bind_1', 263961),
(444868, 'PF05016', NULL, 'ParE toxin of type II toxin-antitoxin system, parDE', 90, NULL, 'ParE_toxin', 263962); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(444869, 'PF06620', NULL, 'Protein of unknown function (DUF1150)', 76, NULL, 'DUF1150', 263963),
(444870, 'PF06833', NULL, 'Malonate decarboxylase gamma subunit (MdcE)', 232, NULL, 'MdcE', 263964),
(444871, 'PF11798', NULL, 'IMS family HHH motif', 32, NULL, 'IMS_HHH', 263965),
(444872, 'PF17001', NULL, 'Type III secretion basal body protein I, YscI, HrpB, PscI', 100, NULL, 'T3SS_basalb_I', 263966),
(444873, 'PF02254', NULL, 'TrkA-N domain', 116, NULL, 'TrkA_N', 263967),
(444874, 'PF03379', NULL, 'CcmB protein', 215, NULL, 'CcmB', 263968),
(444875, 'PF15150', NULL, 'Phorbol-12-myristate-13-acetate-induced', 54, NULL, 'PMAIP1', 263969),
(444876, 'PF16922', NULL, 'DNA replication complex GINS protein SLD5 C-terminus', 56, NULL, 'SLD5_C', 263970),
(444877, 'PF16959', NULL, 'Renal amino acid transporter', 154, NULL, 'Collectrin', 263971),
(444878, 'PF10245', NULL, 'Mitochondrial 28S ribosomal protein S22', 243, NULL, 'MRP-S22', 263972),
(444879, 'PF14167', NULL, 'YfkD-like protein', 232, NULL, 'YfkD', 263973),
(444880, 'PF09499', NULL, 'ApaLI-like restriction endonuclease', 189, NULL, 'RE_ApaLI', 263974),
(444881, 'PF05092', NULL, 'Per os infectivity', 522, NULL, 'PIF', 263975),
(444882, 'PF02725', NULL, 'Non-structural protein C', 164, NULL, 'Paramyxo_NS_C', 263976),
(444883, 'PF19637', NULL, 'Family of unknown function (DUF6140)', 69, NULL, 'DUF6140', 263977),
(444884, 'PF02264', NULL, 'LamB porin', 378, NULL, 'LamB', 263978),
(444885, 'PF10137', NULL, 'Predicted nucleotide-binding protein containing TIR-like domain', 119, NULL, 'TIR-like', 263979),
(444886, 'PF17729', NULL, 'Family of unknown function (DUF5569)', 225, NULL, 'DUF5569', 263980),
(444887, 'PF07009', NULL, 'NusG domain II', 107, NULL, 'NusG_II', 263981),
(444888, 'PF11459', NULL, 'Transcriptional regulator, AbiEi antitoxin, Type IV TA system', 159, NULL, 'AbiEi_3', 263982),
(444889, 'PF16689', NULL, 'Coiled-coil N-terminus of APC, dimerisation domain', 52, NULL, 'APC_N_CC', 263983),
(444890, 'PF16756', NULL, 'Partner and localizer of BRCA2 WD40 domain', 347, NULL, 'PALB2_WD40', 263984),
(444891, 'PF11003', NULL, 'Protein of unknown function (DUF2842)', 61, NULL, 'DUF2842', 263985),
(444892, 'PF10220', NULL, 'Smg8_Smg9', 882, NULL, 'Smg8_Smg9', 263986),
(444893, 'PF16720', NULL, 'Albumin I chain a', 48, NULL, 'Albumin_I_a', 263987),
(444894, 'PF02953', NULL, 'Tim10/DDP family zinc finger', 64, NULL, 'zf-Tim10_DDP', 263988),
(444895, 'PF04497', NULL, 'Poxviridae protein', 741, NULL, 'Pox_E2-like', 263989),
(444896, 'PF11653', NULL, 'Bacteriophage T7 virion assembly protein', 99, NULL, 'VirionAssem_T7', 263990),
(444897, 'PF05939', NULL, 'Phage minor tail protein', 108, NULL, 'Phage_min_tail', 263991),
(444898, 'PF04070', NULL, 'Domain of unknown function (DUF378)', 60, NULL, 'DUF378', 263992),
(444899, 'PF10284', NULL, 'Luciferase helical bundle domain', 66, NULL, 'Luciferase_3H', 263993),
(444900, 'PF13714', NULL, 'Phosphoenolpyruvate phosphomutase', 241, NULL, 'PEP_mutase', 263994),
(444901, 'PF16988', NULL, 'Vacuolar protein sorting 36 NZF-N zinc-finger domain', 65, NULL, 'Vps36-NZF-N', 263995),
(444902, 'PF12443', NULL, 'AT-hook-containing transcription factor', 95, NULL, 'AKNA', 263996),
(444903, 'PF06172', NULL, 'Cupin superfamily (DUF985)', 141, NULL, 'Cupin_5', 263997),
(444904, 'PF12305', NULL, 'Protein of unknown function (DUF3630)', 94, NULL, 'DUF3630', 263998),
(444905, 'PF13263', NULL, 'PHP-associated', 56, NULL, 'PHP_C', 263999),
(444906, 'PF11357', NULL, 'Cell cycle regulatory protein', 131, NULL, 'Spy1', 264000),
(444907, 'PF06131', NULL, 'Schizosaccharomyces pombe repeat of unknown function (DUF963)', 36, NULL, 'DUF963', 264001),
(444908, 'PF05663', NULL, 'Protein of unknown function (DUF809)', 138, NULL, 'DUF809', 264002),
(444909, 'PF04810', NULL, 'Sec23/Sec24 zinc finger', 39, NULL, 'zf-Sec23_Sec24', 264003),
(444910, 'PF01732', NULL, 'Mycoplasma peptidase (DUF31)', 373, NULL, 'Mycop_pep_DUF31', 264004),
(444911, 'PF13848', NULL, 'Thioredoxin-like domain', 185, NULL, 'Thioredoxin_6', 264005),
(444912, 'PF14183', NULL, 'YwpF-like protein', 133, NULL, 'YwpF', 264006);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(444913, 'PF18959', NULL, 'Family of unknown function (DUF5701)', 192, NULL, 'DUF5701', 264007),
(444914, 'PF14284', NULL, 'PcfJ-like protein', 147, NULL, 'PcfJ', 264008),
(444915, 'PF02013', NULL, 'Cellulose or protein binding domain', 36, NULL, 'CBM_10', 264009),
(444916, 'PF18163', NULL, 'SLOG cluster2', 261, NULL, 'LD_cluster2', 264010),
(444917, 'PF11628', NULL, 'T-cell surface glycoprotein CD3 zeta chain', 31, NULL, 'TCR_zetazeta', 264011),
(444918, 'PF19756', NULL, 'Family of unknown function (DUF6243)', 67, NULL, 'DUF6243', 264012),
(444919, 'PF07847', NULL, 'PCO_ADO', 201, NULL, 'PCO_ADO', 264013),
(444920, 'PF07126', NULL, 'Cell-division protein ZapC', 169, NULL, 'ZapC', 264014),
(444921, 'PF13851', NULL, 'Growth-arrest specific micro-tubule binding', 200, NULL, 'GAS', 264015),
(444922, 'PF19958', NULL, 'Effector-associated domain 6', 76, NULL, 'EAD6', 264016),
(444923, 'PF03602', NULL, 'Conserved hypothetical protein 95', 182, NULL, 'Cons_hypoth95', 264017),
(444924, 'PF09568', NULL, 'MjaI restriction endonuclease', 170, NULL, 'RE_MjaI', 264018),
(444925, 'PF09946', NULL, 'Predicted membrane protein (DUF2178)', 106, NULL, 'DUF2178', 264019),
(444926, 'PF20151', NULL, 'Family of unknown function (DUF6533)', 47, NULL, 'DUF6533', 264020),
(444927, 'PF10304', NULL, 'Required for nuclear transport of RNA pol II C-terminus 2', 34, NULL, 'RTP1_C2', 264021),
(444928, 'PF14359', NULL, 'Domain of unknown function (DUF4406)', 91, NULL, 'DUF4406', 264022),
(444929, 'PF08704', NULL, 'tRNA methyltransferase complex GCD14 subunit', 247, NULL, 'GCD14', 264023),
(444930, 'PF05372', NULL, 'Delta lysin family', 25, NULL, 'Delta_lysin', 264024),
(444931, 'PF10813', NULL, 'Herpesvirus UL11 homologue', 32, NULL, 'Herpesvir_UL11', 264025),
(444932, 'PF16165', NULL, 'Ferlin C-terminus', 154, NULL, 'Ferlin_C', 264026),
(444933, 'PF10490', NULL, 'Rb-binding domain of kinetochore protein Cenp-F/LEK1', 47, NULL, 'CENP-F_C_Rb_bdg', 264027),
(444934, 'PF02436', NULL, 'Conserved carboxylase domain', 201, NULL, 'PYC_OADA', 264028),
(444935, 'PF18077', NULL, 'Domain of unknown function (DUF5595)', 73, NULL, 'DUF5595', 264029),
(444936, 'PF09348', NULL, 'Domain of unknown function (DUF1990)', 154, NULL, 'DUF1990', 264030),
(444937, 'PF05295', NULL, 'Luciferase/LBP N-terminal domain', 82, NULL, 'Luciferase_N', 264031),
(444938, 'PF14309', NULL, 'Domain of unknown function (DUF4378)', 164, NULL, 'DUF4378', 264032),
(444939, 'PF18454', NULL, 'Major tropism determinant N-terminal domain', 37, NULL, 'Mtd_N', 264033),
(444940, 'PF01006', NULL, 'Hepatitis C virus non-structural protein NS4a', 56, NULL, 'HCV_NS4a', 264034),
(444941, 'PF15390', NULL, 'WD repeat and coiled-coil-containing protein family', 688, NULL, 'WDCP', 264035),
(444942, 'PF15880', NULL, 'NADH dehydrogenase [ubiquinone] flavoprotein 3, mitochondrial', 35, NULL, 'NDUFV3', 264036),
(444943, 'PF02150', NULL, 'RNA polymerases M/15 Kd subunit', 36, NULL, 'RNA_POL_M_15KD', 264037),
(444944, 'PF13057', NULL, 'Protein of unknown function (DUF3919)', 232, NULL, 'DUF3919', 264038),
(444945, 'PF00866', NULL, 'Ring hydroxylating beta subunit', 144, NULL, 'Ring_hydroxyl_B', 264039),
(444946, 'PF18669', NULL, 'Trimeric autotransporter adhesin Trp ring domain', 50, NULL, 'Trp_ring', 264040),
(444947, 'PF13993', NULL, 'YccJ-like protein', 67, NULL, 'YccJ', 264041),
(444948, 'PF13723', NULL, 'Beta-ketoacyl synthase, N-terminal domain', 226, NULL, 'Ketoacyl-synt_2', 264042),
(444949, 'PF02435', NULL, 'Levansucrase/Invertase', 424, NULL, 'Glyco_hydro_68', 264043),
(444950, 'PF13356', NULL, 'Arm DNA-binding domain', 76, NULL, 'Arm-DNA-bind_3', 264044),
(444951, 'PF04027', NULL, 'Domain of unknown function (DUF371)', 133, NULL, 'DUF371', 264045),
(444952, 'PF07249', NULL, 'Cerato-platanin', 119, NULL, 'Cerato-platanin', 264046),
(444953, 'PF02987', NULL, 'Late embryogenesis abundant protein', 44, NULL, 'LEA_4', 264047),
(444954, 'PF01828', NULL, 'Peptidase A4 family', 209, NULL, 'Peptidase_A4', 264048),
(444955, 'PF03686', NULL, 'Uncharacterised protein family (UPF0146)', 129, NULL, 'UPF0146', 264049);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(444956, 'PF12331', NULL, 'Protein of unknown function (DUF3636)', 148, NULL, 'DUF3636', 264050),
(444957, 'PF14229', NULL, 'Domain of unknown function (DUF4332)', 122, NULL, 'DUF4332', 264051),
(444958, 'PF15162', NULL, 'Protein SPO16 homolog', 162, NULL, 'SCRE', 264052),
(444959, 'PF14098', NULL, 'Small, acid-soluble spore protein I', 65, NULL, 'SSPI', 264053),
(444960, 'PF14957', NULL, 'Cdc42 effector', 130, NULL, 'BORG_CEP', 264054),
(444961, 'PF18300', NULL, 'Domain of unknown function (DUF5604)', 58, NULL, 'DUF5604', 264055),
(444962, 'PF01665', NULL, 'Rotavirus non-structural protein NSP3', 299, NULL, 'Rota_NSP3', 264056),
(444963, 'PF08214', NULL, 'Histone acetylation protein', 352, NULL, 'HAT_KAT11', 264057),
(444964, 'PF03215', NULL, 'Rad17 P-loop domain', 186, NULL, 'Rad17', 264058),
(444965, 'PF03833', NULL, 'DNA polymerase II large subunit DP2', 865, NULL, 'PolC_DP2', 264059),
(444966, 'PF20402', NULL, 'Domain of unknown function (DUF6692)', 162, NULL, 'DUF6692', 264060),
(444967, 'PF05937', NULL, 'EB-1 Binding Domain', 174, NULL, 'EB1_binding', 264061),
(444968, 'PF06223', NULL, 'Minor tail protein T', 100, NULL, 'Phage_tail_T', 264062),
(444969, 'PF06840', NULL, 'Protein of unknown function (DUF1241)', 150, NULL, 'DUF1241', 264063),
(444970, 'PF17887', NULL, 'Jak1 pleckstrin homology-like domain', 140, NULL, 'Jak1_Phl', 264064),
(444971, 'PF12627', NULL, 'Probable RNA and SrmB- binding site of polymerase A', 64, NULL, 'PolyA_pol_RNAbd', 264065),
(444972, 'PF14800', NULL, 'Domain of unknown function (DUF4481)', 295, NULL, 'DUF4481', 264066),
(444973, 'PF17849', NULL, 'Dis3-like cold-shock domain 2 (CSD2)', 77, NULL, 'OB_Dis3', 264067),
(444974, 'PF18382', NULL, 'Formin N-terminal GTPase-binding domain', 119, NULL, 'Formin_GBD_N', 264068),
(444975, 'PF15601', NULL, 'Immunity protein 70', 131, NULL, 'Imm70', 264069),
(444976, 'PF13015', NULL, 'Glucosidase II beta subunit-like protein', 154, NULL, 'PRKCSH_1', 264070),
(444977, 'PF12811', NULL, 'Bax inhibitor 1 like', 233, NULL, 'BaxI_1', 264071),
(444978, 'PF03836', NULL, 'RasGAP C-terminus', 136, NULL, 'RasGAP_C', 264072),
(444979, 'PF05191', NULL, 'Adenylate kinase, active site lid', 36, NULL, 'ADK_lid', 264073),
(444980, 'PF13201', NULL, 'Putative carbohydrate metabolism domain', 232, NULL, 'PCMD', 264074),
(444981, 'PF13937', NULL, 'Domain of unknown function (DUF4212)', 79, NULL, 'DUF4212', 264075),
(444982, 'PF16099', NULL, 'Recq-mediated genome instability protein 1, C-terminal OB-fold', 143, NULL, 'RMI1_C', 264076),
(444983, 'PF05267', NULL, 'Protein of unknown function (DUF725)', 121, NULL, 'DUF725', 264077),
(444984, 'PF08456', NULL, 'Viral methyltransferase C-terminal', 230, NULL, 'Vmethyltransf_C', 264078),
(444985, 'PF09520', NULL, 'Type II restriction endonuclease, TdeIII', 243, NULL, 'RE_TdeIII', 264079),
(444986, 'PF06584', NULL, 'DIRP', 107, NULL, 'DIRP', 264080),
(444987, 'PF12458', NULL, 'ATPase involved in DNA repair', 447, NULL, 'DUF3686', 264081),
(444988, 'PF00339', NULL, 'Arrestin (or S-antigen), N-terminal domain', 146, NULL, 'Arrestin_N', 264082),
(444989, 'PF17516', NULL, 'ProQ C-terminal domain', 51, NULL, 'ProQ_C', 264083),
(444990, 'PF00872', NULL, 'Transposase, Mutator family', 381, NULL, 'Transposase_mut', 264084),
(444991, 'PF03772', NULL, 'Competence protein', 271, NULL, 'Competence', 264085),
(444992, 'PF03195', NULL, 'Lateral organ boundaries (LOB) domain', 99, NULL, 'LOB', 264086),
(444993, 'PF19215', NULL, 'Coronavirus replicase NSP15, uridylate-specific endoribonuclease', 155, NULL, 'CoV_NSP15_C', 264087),
(444994, 'PF17075', NULL, 'Regular of rDNA transcription protein 14', 197, NULL, 'RRT14', 264088),
(444995, 'PF11513', NULL, 'Thermoplasma acidophilum protein TA0956', 110, NULL, 'TA0956', 264089),
(444996, 'PF13080', NULL, 'Protein of unknown function (DUF3926)', 43, NULL, 'DUF3926', 264090),
(444997, 'PF05013', NULL, 'N-formylglutamate amidohydrolase', 216, NULL, 'FGase', 264091),
(444998, 'PF14030', NULL, 'Protein of unknown function (DUF4245)', 166, NULL, 'DUF4245', 264092),
(444999, 'PF19759', NULL, 'Family of unknown function (DUF6246)', 185, NULL, 'DUF6246', 264093);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(445000, 'PF11101', NULL, 'Protein of unknown function (DUF2884)', 228, NULL, 'DUF2884', 264094),
(445001, 'PF20135', NULL, 'Family of unknown function (DUF6525)', 79, NULL, 'DUF6525', 264095),
(445002, 'PF16688', NULL, 'Replicase polyprotein N-term from Coronavirus nsp1', 108, NULL, 'CNV-Replicase_N', 264096),
(445003, 'PF03720', NULL, 'UDP-glucose/GDP-mannose dehydrogenase family, UDP binding domain', 105, NULL, 'UDPG_MGDP_dh_C', 264097),
(445004, 'PF06143', NULL, 'Baculovirus 11 kDa family', 84, NULL, 'Baculo_11_kDa', 264098),
(445005, 'PF12389', NULL, 'Camelysin metallo-endopeptidase', 196, NULL, 'Peptidase_M73', 264099),
(445006, 'PF07305', NULL, 'Protein of unknown function (DUF1454)', 189, NULL, 'DUF1454', 264100),
(445007, 'PF08242', NULL, 'Methyltransferase domain', 99, NULL, 'Methyltransf_12', 264101),
(445008, 'PF12639', NULL, 'DNase/tRNase domain of colicin-like bacteriocin', 96, NULL, 'Colicin-DNase', 264102),
(445009, 'PF09211', NULL, 'Domain of unknown function (DUF1958)', 63, NULL, 'DUF1958', 264103),
(445010, 'PF10917', NULL, 'Fungus-induced protein', 50, NULL, 'Fungus-induced', 264104),
(445011, 'PF03299', NULL, 'Transcription factor AP-2', 197, NULL, 'TF_AP-2', 264105),
(445012, 'PF17558', NULL, 'Androgenic gland hormone', 121, NULL, 'AGH', 264106),
(445013, 'PF06495', NULL, 'Fruit fly transformer protein', 182, NULL, 'Transformer', 264107),
(445014, 'PF10704', NULL, 'Protein of unknown function (DUF2508)', 71, NULL, 'DUF2508', 264108),
(445015, 'PF19844', NULL, 'Family of unknown function (DUF6319)', 116, NULL, 'DUF6319', 264109),
(445016, 'PF02382', NULL, 'N-terminal domain in RTX protein', 324, NULL, 'RTX', 264110),
(445017, 'PF02763', NULL, 'Diphtheria toxin, C domain', 187, NULL, 'Diphtheria_C', 264111),
(445018, 'PF08943', NULL, 'CsiD', 294, NULL, 'CsiD', 264112),
(445019, 'PF09523', NULL, 'Protein of unknown function (DUF2390)', 106, NULL, 'DUF2390', 264113),
(445020, 'PF12189', NULL, 'Single-strand DNA-binding protein', 63, NULL, 'VirE1', 264114),
(445021, 'PF11424', NULL, 'Protein of unknown function (DUF3195)', 85, NULL, 'DUF3195', 264115),
(445022, 'PF17481', NULL, 'Phage tail sheath protein beta-sandwich domain', 106, NULL, 'Phage_sheath_1N', 264116),
(445023, 'PF05700', NULL, 'Breast carcinoma amplified sequence 2 (BCAS2)', 206, NULL, 'BCAS2', 264117),
(445024, 'PF07409', NULL, 'Phage protein GP46', 100, NULL, 'GP46', 264118),
(445025, 'PF07709', NULL, 'Seven Residue Repeat', 14, NULL, 'SRR', 264119),
(445026, 'PF03918', NULL, 'Cytochrome C biogenesis protein', 143, NULL, 'CcmH', 264120),
(445027, 'PF13559', NULL, 'Domain of unknown function (DUF4129)', 69, NULL, 'DUF4129', 264121),
(445028, 'PF05211', NULL, 'Neuraminyllactose-binding hemagglutinin precursor (NLBH)', 254, NULL, 'NLBH', 264122),
(445029, 'PF07650', NULL, 'KH domain', 78, NULL, 'KH_2', 264123),
(445030, 'PF10261', NULL, 'Inositol phospholipid synthesis and fat-storage-inducing TM', 246, NULL, 'Scs3p', 264124),
(445031, 'PF20158', NULL, 'Cas5fv helical domain', 158, NULL, 'Cas5fv_helical', 264125),
(445032, 'PF10016', NULL, 'Predicted secreted protein (DUF2259)', 188, NULL, 'DUF2259', 264126),
(445033, 'PF02311', NULL, 'AraC-like ligand binding domain', 136, NULL, 'AraC_binding', 264127),
(445034, 'PF08778', NULL, 'HIF-1 alpha C terminal transactivation domain', 37, NULL, 'HIF-1a_CTAD', 264128),
(445035, 'PF11957', NULL, 'THO complex subunit 1 transcription elongation factor', 489, NULL, 'efThoc1', 264129),
(445036, 'PF04458', NULL, 'Protein of unknown function (DUF505)', 623, NULL, 'DUF505', 264130),
(445037, 'PF06254', NULL, 'Putative bacterial toxin ydaT', 88, NULL, 'YdaT_toxin', 264131),
(445038, 'PF04359', NULL, 'Protein of unknown function (DUF493)', 84, NULL, 'DUF493', 264132),
(445039, 'PF19553', NULL, 'Family of unknown function (DUF6076)', 168, NULL, 'DUF6076', 264133),
(445040, 'PF04688', NULL, 'SPP1 phage holin', 74, NULL, 'Holin_SPP1', 264134),
(445041, 'PF09172', NULL, 'Vitellinogen, open beta-sheet', 303, NULL, 'Vit_open_b-sht', 264135),
(445042, 'PF03045', NULL, 'DAN domain', 114, NULL, 'DAN', 264136);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(445043, 'PF02768', NULL, 'DNA polymerase III beta subunit, C-terminal domain', 121, NULL, 'DNA_pol3_beta_3', 264137),
(445044, 'PF12038', NULL, 'Domain of unknown function (DUF3524)', 168, NULL, 'DUF3524', 264138),
(445045, 'PF00195', NULL, 'Chalcone and stilbene synthases, N-terminal domain', 225, NULL, 'Chal_sti_synt_N', 264139),
(445046, 'PF11959', NULL, 'Domain of unknown function (DUF3473)', 130, NULL, 'DUF3473', 264140),
(445047, 'PF03083', NULL, 'Sugar efflux transporter for intercellular exchange', 87, NULL, 'MtN3_slv', 264141),
(445048, 'PF07379', NULL, 'Protein of unknown function (DUF1494)', 173, NULL, 'DUF1494', 264142),
(445049, 'PF17486', NULL, 'Cystine knot toxins', 70, NULL, 'Cys_Knot_tox', 264143),
(445050, 'PF18698', NULL, 'Histidine kinase sensor domain', 126, NULL, 'HisK_sensor', 264144),
(445051, 'PF19570', NULL, 'Family of unknown function (DUF6088)', 172, NULL, 'DUF6088', 264145),
(445052, 'PF18537', NULL, 'Carbon monoxide dehydrogenase subunit alpha N-terminal domain', 83, NULL, 'CODH_A_N', 264146),
(445053, 'PF19430', NULL, 'TBC1 domain family member 23 C-terminal', 226, NULL, 'TBC1D23_C', 264147),
(445054, 'PF20185', NULL, 'Family of unknown function (DUF6548)', 166, NULL, 'DUF6548', 264148),
(445055, 'PF01353', NULL, 'Green fluorescent protein', 213, NULL, 'GFP', 264149),
(445056, 'PF14553', NULL, 'YqbF, hypothetical protein domain', 43, NULL, 'YqbF', 264150),
(445057, 'PF07795', NULL, 'Protein of unknown function (DUF1635)', 223, NULL, 'DUF1635', 264151),
(445058, 'PF04342', NULL, 'Putative member of DMT superfamily (DUF486)', 105, NULL, 'DMT_6', 264152),
(445059, 'PF07392', NULL, 'Cyclin-dependent kinase inhibitor 2a p19Arf N-terminus', 51, NULL, 'P19Arf_N', 264153),
(445060, 'PF07764', NULL, 'Omega Transcriptional Repressor', 69, NULL, 'Omega_Repress', 264154),
(445061, 'PF10222', NULL, 'Uncharacterized conserved protein (DUF2152)', 593, NULL, 'DUF2152', 264155),
(445062, 'PF16741', NULL, 'mRNA-decapping enzyme C-terminus', 43, NULL, 'mRNA_decap_C', 264156),
(445063, 'PF09722', NULL, 'Antitoxin Xre/MbcA/ParS C-terminal toxin-binding domain', 51, NULL, 'Xre_MbcA_ParS_C', 264157),
(445064, 'PF10630', NULL, 'Protein of unknown function (DUF2476)', 259, NULL, 'DUF2476', 264158),
(445065, 'PF10916', NULL, 'Protein of unknown function (DUF2712)', 112, NULL, 'DUF2712', 264159),
(445066, 'PF14148', NULL, 'YhdB-like protein', 71, NULL, 'YhdB', 264160),
(445067, 'PF02063', NULL, 'MARCKS family', 289, NULL, 'MARCKS', 264161),
(445068, 'PF06056', NULL, 'Putative ATPase subunit of terminase (gpP-like)', 58, NULL, 'Terminase_5', 264162),
(445069, 'PF15624', NULL, 'Kinetochore CENP-C fungal homologue, Mif2, N-terminal', 135, NULL, 'Mif2_N', 264163),
(445070, 'PF10209', NULL, 'Uncharacterized conserved protein (DUF2340)', 120, NULL, 'DUF2340', 264164),
(445071, 'PF04069', NULL, 'Substrate binding domain of ABC-type glycine betaine transport system', 257, NULL, 'OpuAC', 264165),
(445072, 'PF11312', NULL, 'Putative SAM-dependent methyltransferase', 306, NULL, 'Methyltransf_34', 264166),
(445073, 'PF08609', NULL, 'Nucleotide exchange factor Fes1', 92, NULL, 'Fes1', 264167),
(445074, 'PF03722', NULL, 'Hemocyanin, all-alpha domain', 124, NULL, 'Hemocyanin_N', 264168),
(445075, 'PF07622', NULL, 'Protein of unknown function (DUF1583) C domain', 256, NULL, 'DUF1583', 264169),
(445076, 'PF18258', NULL, 'Interleukin-4 inducing immunoglobulin-binding domain', 89, NULL, 'IL4_i_Ig', 264170),
(445077, 'PF15914', NULL, 'FAM193 family C-terminal', 58, NULL, 'FAM193_C', 264171),
(445078, 'PF10510', NULL, 'Phosphatidylinositol-glycan biosynthesis class S protein', 517, NULL, 'PIG-S', 264172),
(445079, 'PF16035', NULL, 'Chalcone isomerase like', 204, NULL, 'Chalcone_2', 264173),
(445080, 'PF07297', NULL, 'Dolichol phosphate-mannose biosynthesis regulatory protein (DPM2)', 75, NULL, 'DPM2', 264174),
(445081, 'PF08463', NULL, 'EcoEI R protein C-terminal', 167, NULL, 'EcoEI_R_C', 264175),
(445082, 'PF04311', NULL, 'Protein of unknown function (DUF459)', 322, NULL, 'DUF459', 264176),
(445083, 'PF08047', NULL, 'Histidine operon leader peptide', 16, NULL, 'His_leader', 264177);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(445084, 'PF14454', NULL, 'Prokaryotic Ubiquitin', 64, NULL, 'Prok_Ub', 264178),
(445085, 'PF01279', NULL, 'Parathyroid hormone family', 107, NULL, 'Parathyroid', 264179),
(445086, 'PF08258', NULL, 'WWamide peptide', 7, NULL, 'WWamide', 264180),
(445087, 'PF03637', NULL, 'Mob1/phocein family', 170, NULL, 'Mob1_phocein', 264181),
(445088, 'PF07275', NULL, 'Antirestriction protein (ArdA)', 163, NULL, 'ArdA', 264182),
(445089, 'PF11217', NULL, 'Protein of unknown function (DUF3013)', 160, NULL, 'DUF3013', 264183),
(445090, 'PF15522', NULL, 'Novel toxin 14', 205, NULL, 'Ntox14', 264184),
(445091, 'PF16528', NULL, 'Exocyst component 84 C-terminal', 205, NULL, 'Exo84_C', 264185),
(445092, 'PF02660', NULL, 'Glycerol-3-phosphate acyltransferase', 163, NULL, 'G3P_acyltransf', 264186),
(445093, 'PF12669', NULL, 'FeoB-associated Cys-rich membrane protein', 44, NULL, 'FeoB_associated', 264187),
(445094, 'PF13363', NULL, 'Beta-galactosidase, domain 3', 76, NULL, 'BetaGal_dom3', 264188),
(445095, 'PF03411', NULL, 'Penicillin-insensitive murein endopeptidase', 239, NULL, 'Peptidase_M74', 264189),
(445096, 'PF02058', NULL, 'Guanylin precursor', 88, NULL, 'Guanylin', 264190),
(445097, 'PF04806', NULL, 'EspF protein repeat', 47, NULL, 'EspF', 264191),
(445098, 'PF12083', NULL, 'Domain of unknown function (DUF3560)', 124, NULL, 'DUF3560', 264192),
(445099, 'PF16310', NULL, 'Domian of unknown function (DUF4952)', 77, NULL, 'DUF4952', 264193),
(445100, 'PF16322', NULL, 'Tubby N-terminal', 200, NULL, 'Tub_N', 264194),
(445101, 'PF15813', NULL, 'Domain of unknown function (DUF4708)', 274, NULL, 'DUF4708', 264195),
(445102, 'PF07479', NULL, 'NAD-dependent glycerol-3-phosphate dehydrogenase C-terminus', 142, NULL, 'NAD_Gly3P_dh_C', 264196),
(445103, 'PF01613', NULL, 'Flavin reductase like domain', 155, NULL, 'Flavin_Reduct', 264197),
(445104, 'PF17801', NULL, 'Alpha galactosidase C-terminal beta sandwich domain', 71, NULL, 'Melibiase_C', 264198),
(445105, 'PF20167', NULL, 'Putative plant transposon protein', 178, NULL, 'Transposase_32', 264199),
(445106, 'PF10506', NULL, 'PDZ domain of MCC-2 bdg protein for Usher syndrome', 65, NULL, 'MCC-bdg_PDZ', 264200),
(445107, 'PF08591', NULL, 'Ribonucleotide reductase inhibitor', 107, NULL, 'RNR_inhib', 264201),
(445108, 'PF16804', NULL, 'Domain of unknown function (DUF5071)', 119, NULL, 'DUF5071', 264202),
(445109, 'PF14599', NULL, 'Zinc-ribbon', 59, NULL, 'zinc_ribbon_6', 264203),
(445110, 'PF01445', NULL, 'Viral small hydrophobic protein', 57, NULL, 'SH', 264204),
(445111, 'PF19332', NULL, 'E3 ubiquitin-protein ligase RNF180 C-terminus', 101, NULL, 'RNF180_C', 264205),
(445112, 'PF01108', NULL, 'Tissue factor', 107, NULL, 'Tissue_fac', 264206),
(445113, 'PF02233', NULL, 'NAD(P) transhydrogenase beta subunit', 460, NULL, 'PNTB', 264207),
(445114, 'PF00075', NULL, 'RNase H', 143, NULL, 'RNase_H', 264208),
(445115, 'PF15409', NULL, 'Pleckstrin homology domain', 89, NULL, 'PH_8', 264209),
(445116, 'PF00557', NULL, 'Metallopeptidase family M24', 209, NULL, 'Peptidase_M24', 264210),
(445117, 'PF18758', NULL, 'Kyakuja-Dileera-Zisupton transposase', 220, NULL, 'KDZ', 264211),
(445118, 'PF09634', NULL, 'Protein of unknown function (DUF2025)', 105, NULL, 'DUF2025', 264212),
(445119, 'PF07722', NULL, 'Peptidase C26', 217, NULL, 'Peptidase_C26', 264213),
(445120, 'PF04201', NULL, 'Tumour protein D52 family', 108, NULL, 'TPD52', 264214),
(445121, 'PF00920', NULL, 'Dehydratase family', 516, NULL, 'ILVD_EDD', 264215),
(445122, 'PF13874', NULL, 'Nucleoporin complex subunit 54', 140, NULL, 'Nup54', 264216),
(445123, 'PF01618', NULL, 'MotA/TolQ/ExbB proton channel family', 127, NULL, 'MotA_ExbB', 264217),
(445124, 'PF17901', NULL, 'EF-hand fold domain', 93, NULL, 'EF-hand_12', 264218),
(445125, 'PF14968', NULL, 'Coiled coil protein 84', 340, NULL, 'CCDC84', 264219),
(445126, 'PF15414', NULL, 'Protein of unknown function (DUF4621)', 329, NULL, 'DUF4621', 264220),
(445127, 'PF03951', NULL, 'Glutamine synthetase, beta-Grasp domain', 83, NULL, 'Gln-synt_N', 264221),
(445128, 'PF03975', NULL, 'CheD chemotactic sensory transduction', 109, NULL, 'CheD', 264222);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(445129, 'PF18151', NULL, 'Domain of unknown function (DUF5601)', 65, NULL, 'DUF5601', 264223),
(445130, 'PF11996', NULL, 'Protein of unknown function (DUF3491)', 944, NULL, 'DUF3491', 264224),
(445131, 'PF20461', NULL, 'Family of unknown function (DUF6714)', 159, NULL, 'DUF6714', 264225),
(445132, 'PF10208', NULL, 'ARMET, C-terminal', 43, NULL, 'ARMET_C', 264226),
(445133, 'PF20581', NULL, 'Family of unknown function (DUF6785)', 499, NULL, 'DUF6785', 264227),
(445134, 'PF06804', NULL, 'NlpB/DapX lipoprotein', 321, NULL, 'Lipoprotein_18', 264228),
(445135, 'PF15909', NULL, 'C2H2-type zinc ribbon', 98, NULL, 'zf-C2H2_8', 264229),
(445136, 'PF04803', NULL, 'Cor1/Xlr/Xmr conserved region', 132, NULL, 'Cor1', 264230),
(445137, 'PF03964', NULL, 'Chorion family 2', 130, NULL, 'Chorion_2', 264231),
(445138, 'PF05782', NULL, 'Extracellular matrix protein 1 (ECM1)', 516, NULL, 'ECM1', 264232),
(445139, 'PF14385', NULL, 'Domain of unknown function (DUF4416)', 162, NULL, 'DUF4416', 264233),
(445140, 'PF04597', NULL, 'Ribophorin I', 446, NULL, 'Ribophorin_I', 264234),
(445141, 'PF06262', NULL, 'Zincin-like metallopeptidase', 97, NULL, 'Zincin_1', 264235),
(445142, 'PF02670', NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', 129, NULL, 'DXP_reductoisom', 264236),
(445143, 'PF04465', NULL, 'Protein of unknown function (DUF499)', 1024, NULL, 'DUF499', 264237),
(445144, 'PF14172', NULL, 'Domain of unknown function (DUF4309)', 133, NULL, 'DUF4309', 264238),
(445145, 'PF13013', NULL, 'F-box-like domain', 107, NULL, 'F-box-like_2', 264239),
(445146, 'PF16298', NULL, 'Domain of unknown function (DUF4940)', 206, NULL, 'DUF4940', 264240),
(445147, 'PF16857', NULL, 'RNA polymerase inhibitor', 47, NULL, 'RNA_pol_inhib', 264241),
(445148, 'PF02809', NULL, 'Ubiquitin interaction motif', 17, NULL, 'UIM', 264242),
(445149, 'PF20071', NULL, 'Family of unknown function (DUF6467)', 74, NULL, 'DUF6467', 264243),
(445150, 'PF06920', NULL, 'DHR-2, Lobe A', 158, NULL, 'DHR-2_Lobe_A', 264244),
(445151, 'PF06633', NULL, 'Protein of unknown function (DUF1155)', 42, NULL, 'DUF1155', 264245),
(445152, 'PF17619', NULL, 'Secreted clade V proteins', 97, NULL, 'SCVP', 264246),
(445153, 'PF01433', NULL, 'Peptidase family M1 domain', 218, NULL, 'Peptidase_M1', 264247),
(445154, 'PF07700', NULL, 'Haem-NO-binding', 163, NULL, 'HNOB', 264248),
(445155, 'PF00387', NULL, 'Phosphatidylinositol-specific phospholipase C, Y domain', 115, NULL, 'PI-PLC-Y', 264249),
(445156, 'PF07035', NULL, 'Colon cancer-associated protein Mic1-like', 157, NULL, 'Mic1', 264250),
(445157, 'PF20109', NULL, 'Family of unknown function (DUF6499)', 68, NULL, 'DUF6499', 264251),
(445158, 'PF03516', NULL, 'Filaggrin', 56, NULL, 'Filaggrin', 264252),
(445159, 'PF15827', NULL, 'UPF0730 unknown protein family', 46, NULL, 'UPF0730', 264253),
(445160, 'PF20266', NULL, 'Mab-21 protein HhH/H2TH-like domain', 97, NULL, 'Mab-21_C', 264254),
(445161, 'PF00902', NULL, 'Sec-independent protein translocase protein (TatC)', 207, NULL, 'TatC', 264255),
(445162, 'PF03562', NULL, 'MltA specific insert domain', 226, NULL, 'MltA', 264256),
(445163, 'PF12055', NULL, 'Domain of unknown function (DUF3536)', 284, NULL, 'DUF3536', 264257),
(445164, 'PF18086', NULL, 'Diphosphoinositol pentakisphosphate kinase 2 N-terminal domain', 90, NULL, 'PPIP5K2_N', 264258),
(445165, 'PF19720', NULL, 'Family of unknown function (DUF6214)', 156, NULL, 'DUF6214', 264259),
(445166, 'PF01184', NULL, 'GPR1/FUN34/yaaH family', 207, NULL, 'Gpr1_Fun34_YaaH', 264260),
(445167, 'PF10067', NULL, 'Predicted membrane protein (DUF2306)', 147, NULL, 'DUF2306', 264261),
(445168, 'PF08781', NULL, 'Transcription factor DP', 138, NULL, 'DP', 264262),
(445169, 'PF16718', NULL, 'Immunity factor for SPN', 164, NULL, 'IFS', 264263),
(445170, 'PF19938', NULL, 'Family of unknown function (DUF6400)', 69, NULL, 'DUF6400', 264264),
(445171, 'PF04049', NULL, 'Anaphase promoting complex subunit 8 / Cdc23', 140, NULL, 'ANAPC8', 264265),
(445172, 'PF17114', NULL, 'Gef2-related medial cortical node protein Nod1', 145, NULL, 'Nod1', 264266); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(445173, 'PF16823', NULL, 'Atypical PilZ domain, cyclic di-GMP receptor', 136, NULL, 'tPilZ', 264267),
(445174, 'PF00350', NULL, 'Dynamin family', 168, NULL, 'Dynamin_N', 264268),
(445175, 'PF11934', NULL, 'Domain of unknown function (DUF3452)', 138, NULL, 'DUF3452', 264269),
(445176, 'PF00245', NULL, 'Alkaline phosphatase', 418, NULL, 'Alk_phosphatase', 264270),
(445177, 'PF03297', NULL, 'S25 ribosomal protein', 101, NULL, 'Ribosomal_S25', 264271),
(445178, 'PF04928', NULL, 'Poly(A) polymerase central domain', 250, NULL, 'PAP_central', 264272),
(445179, 'PF13764', NULL, 'E3 ubiquitin-protein ligase UBR4', 813, NULL, 'E3_UbLigase_R4', 264273),
(445180, 'PF09010', NULL, 'Anti-Sigma Factor A', 85, NULL, 'AsiA', 264274),
(445181, 'PF11413', NULL, 'Hypoxia-inducible factor-1', 32, NULL, 'HIF-1', 264275),
(445182, 'PF04684', NULL, 'BAF1 / ABF1 chromatin reorganising factor', 576, NULL, 'BAF1_ABF1', 264276),
(445183, 'PF16072', NULL, 'Domain of unknown function (DUF4813)', 291, NULL, 'DUF4813', 264277),
(445184, 'PF17377', NULL, 'Family of unknown function (DUF5399)', 140, NULL, 'DUF5399', 264278),
(445185, 'PF10517', NULL, 'Electron transfer DM13', 104, NULL, 'DM13', 264279),
(445186, 'PF17483', NULL, 'C-lobe handle domain of Tf-binding protein B', 109, NULL, 'TbpB_C', 264280),
(445187, 'PF01797', NULL, 'Transposase IS200 like', 122, NULL, 'Y1_Tnp', 264281),
(445188, 'PF05795', NULL, 'Plasmodium vivax Vir protein', 381, NULL, 'Plasmodium_Vir', 264282),
(445189, 'PF03073', NULL, 'TspO/MBR family', 143, NULL, 'TspO_MBR', 264283),
(445190, 'PF16657', NULL, 'Maltogenic Amylase, C-terminal domain', 75, NULL, 'Malt_amylase_C', 264284),
(445191, 'PF17567', NULL, 'Family of unknown function (DUF5473)', 106, NULL, 'DUF5473', 264285),
(445192, 'PF08559', NULL, 'Cut8, nuclear proteasome tether protein', 244, NULL, 'Cut8', 264286),
(445193, 'PF08984', NULL, 'Domain of unknown function (DUF1858)', 59, NULL, 'DUF1858', 264287),
(445194, 'PF16638', NULL, 'Unstructured region on methyltransferase between zinc-fingers', 130, NULL, 'Tristanin_u2', 264288),
(445195, 'PF09547', NULL, 'Stage IV sporulation protein A, ATPase domain', 237, NULL, 'SpoIVA_ATPase', 264289),
(445196, 'PF06146', NULL, 'Phosphate-starvation-inducible E family', 120, NULL, 'PsiE', 264290),
(445197, 'PF07683', NULL, 'Cobalamin synthesis protein cobW C-terminal domain', 94, NULL, 'CobW_C', 264291),
(445198, 'PF10360', NULL, 'Protein of unknown function (DUF2433)', 124, NULL, 'DUF2433', 264292),
(445199, 'PF02739', NULL, '5''-3'' exonuclease, N-terminal resolvase-like domain', 159, NULL, '5_3_exonuc_N', 264293),
(445200, 'PF03596', NULL, 'Cadmium resistance transporter', 192, NULL, 'Cad', 264294),
(445201, 'PF10733', NULL, 'Protein of unknown function (DUF2525)', 60, NULL, 'DUF2525', 264295),
(445202, 'PF16154', NULL, 'Domain of unknown function (DUF4862)', 291, NULL, 'DUF4862', 264296),
(445203, 'PF20594', NULL, 'Domain of unknown function (DUF6794)', 83, NULL, 'DUF6794', 264297),
(445204, 'PF02023', NULL, 'SCAN domain', 90, NULL, 'SCAN', 264298),
(445205, 'PF06412', NULL, 'Conjugal transfer protein TraD', 61, NULL, 'TraD', 264299),
(445206, 'PF00820', NULL, 'Borrelia lipoprotein', 261, NULL, 'Lipoprotein_1', 264300),
(445207, 'PF12583', NULL, 'Tripeptidyl peptidase II N terminal', 139, NULL, 'TPPII_N', 264301),
(445208, 'PF01855', NULL, 'Pyruvate flavodoxin/ferredoxin oxidoreductase, thiamine diP-bdg', 231, NULL, 'POR_N', 264302),
(445209, 'PF04622', NULL, 'ERG2 and Sigma1 receptor like protein', 210, NULL, 'ERG2_Sigma1R', 264303),
(445210, 'PF00002', NULL, '7 transmembrane receptor (Secretin family)', 246, NULL, '7tm_2', 264304),
(445211, 'PF11591', NULL, 'Ferredoxin chloroplastic transit peptide', 34, NULL, '2Fe-2S_Ferredox', 264305),
(445212, 'PF01295', NULL, 'Adenylate cyclase, class-I', 601, NULL, 'Adenylate_cycl', 264306),
(445213, 'PF09081', NULL, 'Glucan 1,4-alpha-maltotetraohydrolase, domain C', 64, NULL, 'AMT4_dom_C', 264307),
(445214, 'PF12881', NULL, 'NUT protein', 731, NULL, 'NUT', 264308),
(445215, 'PF19731', NULL, 'Family of unknown function (DUF6222)', 62, NULL, 'DUF6222', 264309);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(445216, 'PF02109', NULL, 'DAD family', 109, NULL, 'DAD', 264310),
(445217, 'PF01674', NULL, 'Lipase (class 2)', 219, NULL, 'Lipase_2', 264311),
(445218, 'PF00341', NULL, 'PDGF/VEGF domain', 82, NULL, 'PDGF', 264312),
(445219, 'PF20348', NULL, 'Family of unknown function (DUF6643)', 150, NULL, 'DUF6643', 264313),
(445220, 'PF10892', NULL, 'Protein of unknown function (DUF2688)', 56, NULL, 'DUF2688', 264314),
(445221, 'PF03110', NULL, 'SBP domain', 75, NULL, 'SBP', 264315),
(445222, 'PF02338', NULL, 'OTU-like cysteine protease', 127, NULL, 'OTU', 264316),
(445223, 'PF07065', NULL, 'D123', 306, NULL, 'D123', 264317),
(445224, 'PF09870', NULL, 'Uncharacterized protein conserved in archaea (DUF2097)', 84, NULL, 'DUF2097', 264318),
(445225, 'PF06283', NULL, 'Trehalose utilisation', 210, NULL, 'ThuA', 264319),
(445226, 'PF06755', NULL, 'CbtA_toxin of type IV toxin-antitoxin system', 112, NULL, 'CbtA_toxin', 264320),
(445227, 'PF17146', NULL, 'PIN domain of ribonuclease', 89, NULL, 'PIN_6', 264321),
(445228, 'PF15475', NULL, 'Transmembrane protein C12orf23, UPF0444', 91, NULL, 'UPF0444', 264322),
(445229, 'PF17452', NULL, 'Uncharacterized YnfE-like', 78, NULL, 'YnfE', 264323),
(445230, 'PF17746', NULL, 'SfsA N-terminal OB domain', 63, NULL, 'SfsA_N', 264324),
(445231, 'PF08115', NULL, 'SFI toxin family', 35, NULL, 'Toxin_28', 264325),
(445232, 'PF20060', NULL, 'Family of unknown function (DUF6459)', 117, NULL, 'DUF6459', 264326),
(445233, 'PF09226', NULL, 'Restriction endonuclease HincII', 247, NULL, 'Endonuc-HincII', 264327),
(445234, 'PF07958', NULL, 'Protein of unknown function (DUF1688)', 422, NULL, 'DUF1688', 264328),
(445235, 'PF09271', NULL, 'LAG1, DNA binding', 151, NULL, 'LAG1-DNAbind', 264329),
(445236, 'PF16304', NULL, 'Domain of unknown function (DUF4946)', 152, NULL, 'DUF4946', 264330),
(445237, 'PF18337', NULL, 'RapA N-terminal Tudor like domain', 62, NULL, 'Tudor_RapA', 264331),
(445238, 'PF14784', NULL, 'C-terminal domain of the ECSIT protein', 129, NULL, 'ECSIT_C', 264332),
(445239, 'PF00425', NULL, 'chorismate binding enzyme', 256, NULL, 'Chorismate_bind', 264333),
(445240, 'PF11487', NULL, 'Type II restriction enzyme SfiI', 215, NULL, 'RestrictionSfiI', 264334),
(445241, 'PF02401', NULL, 'LytB protein', 265, NULL, 'LYTB', 264335),
(445242, 'PF00289', NULL, 'Biotin carboxylase, N-terminal domain', 110, NULL, 'Biotin_carb_N', 264336),
(445243, 'PF00375', NULL, 'Sodium:dicarboxylate symporter family', 391, NULL, 'SDF', 264337),
(445244, 'PF07487', NULL, 'SopE GEF domain', 136, NULL, 'SopE_GEF', 264338),
(445245, 'PF07099', NULL, 'Protein of unknown function (DUF1361)', 169, NULL, 'DUF1361', 264339),
(445246, 'PF08140', NULL, 'Crustacean cuticle protein repeat', 40, NULL, 'Cuticle_1', 264340),
(445247, 'PF17589', NULL, 'Family of unknown function (DUF5487)', 66, NULL, 'DUF5487', 264341),
(445248, 'PF10096', NULL, 'Uncharacterized protein conserved in bacteria (DUF2334)', 210, NULL, 'DUF2334', 264342),
(445249, 'PF12942', NULL, 'Archaeal ammonia monooxygenase subunit A (AmoA)', 183, NULL, 'Archaeal_AmoA', 264343),
(445250, 'PF01400', NULL, 'Astacin (Peptidase family M12A)', 191, NULL, 'Astacin', 264344),
(445251, 'PF12519', NULL, 'Mitochondrial distribution and morphology protein 10', 464, NULL, 'MDM10', 264345),
(445252, 'PF08898', NULL, 'Domain of unknown function (DUF1843)', 52, NULL, 'DUF1843', 264346),
(445253, 'PF14027', NULL, 'Questin oxidase-like', 348, NULL, 'Questin_oxidase', 264347),
(445254, 'PF13895', NULL, 'Immunoglobulin domain', 79, NULL, 'Ig_2', 264348),
(445255, 'PF00703', NULL, 'Glycosyl hydrolases family 2', 110, NULL, 'Glyco_hydro_2', 264349),
(445256, 'PF05026', NULL, 'Dcp2, box A domain', 83, NULL, 'DCP2', 264350),
(445257, 'PF07160', NULL, 'Spindle and kinetochore-associated protein 1', 237, NULL, 'SKA1', 264351),
(445258, 'PF07997', NULL, 'Protein of unknown function (DUF1694)', 117, NULL, 'DUF1694', 264352),
(445259, 'PF06905', NULL, 'Fas apoptotic inhibitory molecule (FAIM1)', 172, NULL, 'FAIM1', 264353),
(445260, 'PF17841', NULL, 'BID domain of Bartonella effector protein (Bep)', 97, NULL, 'Bep_C_terminal', 264354);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(445261, 'PF19375', NULL, 'Family of unknown function (DUF5950)', 103, NULL, 'DUF5950', 264355),
(445262, 'PF12089', NULL, 'Transmembrane domain of unknown function (DUF3566)', 118, NULL, 'DUF3566', 264356),
(445263, 'PF18097', NULL, 'Vta1 C-terminal domain', 38, NULL, 'Vta1_C', 264357),
(445264, 'PF01425', NULL, 'Amidase', 446, NULL, 'Amidase', 264358),
(445265, 'PF00481', NULL, 'Protein phosphatase 2C', 258, NULL, 'PP2C', 264359),
(445266, 'PF00064', NULL, 'Neuraminidase', 334, NULL, 'Neur', 264360),
(445267, 'PF11494', NULL, 'Ta0938', 92, NULL, 'Ta0938', 264361),
(445268, 'PF07374', NULL, 'Protein of unknown function (DUF1492)', 100, NULL, 'DUF1492', 264362),
(445269, 'PF20307', NULL, 'Divergent DnaB-like ATPase', 356, NULL, 'divDNAB', 264363),
(445270, 'PF05716', NULL, 'A-kinase anchor protein 110 kDa (AKAP 110)', 692, NULL, 'AKAP_110', 264364),
(445271, 'PF18289', NULL, 'CCDC81 eukaryotic HU domain 2', 75, NULL, 'HU-CCDC81_euk_2', 264365),
(445272, 'PF07175', NULL, 'Osteoregulin', 160, NULL, 'Osteoregulin', 264366),
(445273, 'PF19018', NULL, 'Vanin C-terminal domain', 167, NULL, 'Vanin_C', 264367),
(445274, 'PF13262', NULL, 'Protein of unknown function (DUF4054)', 105, NULL, 'DUF4054', 264368),
(445275, 'PF18704', NULL, 'Chromatin organization modifier domain 2', 70, NULL, 'Chromo_2', 264369),
(445276, 'PF19514', NULL, 'MobC-like protein', 141, NULL, 'MobC_2', 264370),
(445277, 'PF14637', NULL, 'Folliculin-interacting protein middle domain', 227, NULL, 'FNIP_M', 264371),
(445278, 'PF09471', NULL, 'IgA Peptidase M64', 260, NULL, 'Peptidase_M64', 264372),
(445279, 'PF17488', NULL, 'Herpesvirus glycoprotein H C-terminal domain', 135, NULL, 'Herpes_glycoH_C', 264373),
(445280, 'PF06516', NULL, 'Purine nucleoside permease (NUP)', 313, NULL, 'NUP', 264374),
(445281, 'PF08992', NULL, 'Quinohemoprotein amine dehydrogenase, gamma subunit', 75, NULL, 'QH-AmDH_gamma', 264375),
(445282, 'PF04614', NULL, 'Pex19 protein family', 247, NULL, 'Pex19', 264376),
(445283, 'PF10520', NULL, 'Lipid desaturase domain', 177, NULL, 'Lipid_desat', 264377),
(445284, 'PF06699', NULL, 'GPI biosynthesis protein family Pig-F', 182, NULL, 'PIG-F', 264378),
(445285, 'PF06901', NULL, 'RTX iron-regulated protein FrpC', 271, NULL, 'FrpC', 264379),
(445286, 'PF11988', NULL, 'Retrograde transport protein Dsl1 N terminal', 352, NULL, 'Dsl1_N', 264380),
(445287, 'PF06880', NULL, 'Protein of unknown function (DUF1262)', 99, NULL, 'DUF1262', 264381),
(445288, 'PF14910', NULL, 'S-phase genomic integrity recombination mediator, N-terminal', 708, NULL, 'MMS22L_N', 264382),
(445289, 'PF12212', NULL, 'PAZ domain', 127, NULL, 'PAZ_2', 264383),
(445290, 'PF10605', NULL, '3HB-oligomer hydrolase (3HBOH)', 689, NULL, '3HBOH', 264384),
(445291, 'PF18962', NULL, 'Secretion system C-terminal sorting domain', 75, NULL, 'Por_Secre_tail', 264385),
(445292, 'PF02269', NULL, 'Transcription initiation factor IID, 18kD subunit', 93, NULL, 'TFIID-18kDa', 264386),
(445293, 'PF11224', NULL, 'Protein of unknown function (DUF3023)', 130, NULL, 'DUF3023', 264387),
(445294, 'PF14552', NULL, 'Tautomerase enzyme', 82, NULL, 'Tautomerase_2', 264388),
(445295, 'PF08596', NULL, 'Lethal giant larvae(Lgl) like, C-terminal', 393, NULL, 'Lgl_C', 264389),
(445296, 'PF11065', NULL, 'Protein of unknown function (DUF2866)', 64, NULL, 'DUF2866', 264390),
(445297, 'PF03366', NULL, 'YEATS family', 82, NULL, 'YEATS', 264391),
(445298, 'PF11690', NULL, 'Protein of unknown function (DUF3287)', 128, NULL, 'DUF3287', 264392),
(445299, 'PF09711', NULL, 'CRISPR-associated protein (Cas_Csn2)', 181, NULL, 'Cas_Csn2', 264393),
(445300, 'PF16079', NULL, 'Phage holin family Hol44, in holin superfamily V', 66, NULL, 'Phage_holin_5_2', 264394),
(445301, 'PF14496', NULL, 'C-terminal novel E3 ligase, LRR-interacting', 222, NULL, 'NEL', 264395),
(445302, 'PF13905', NULL, 'Thioredoxin-like', 94, NULL, 'Thioredoxin_8', 264396),
(445303, 'PF19890', NULL, 'Domain of unknown function (DUF6363)', 75, NULL, 'DUF6363', 264397),
(445304, 'PF19052', NULL, 'BMP/retinoic acid-inducible neural-specific protein', 448, NULL, 'BRINP', 264398);
INSERT INTO "PUBLIC"."MODEL" VALUES
(445305, 'PF09663', NULL, 'Amidohydrolase ring-opening protein (Amido_AtzD_TrzD)', 360, NULL, 'Amido_AtzD_TrzD', 264399),
(445306, 'PF18430', NULL, 'Putative DNA-binding domain', 35, NULL, 'DBD_HTH', 264400),
(445307, 'PF19649', NULL, 'Family of unknown function (DUF6152)', 98, NULL, 'DUF6152', 264401),
(445308, 'PF00484', NULL, 'Carbonic anhydrase', 156, NULL, 'Pro_CA', 264402),
(445309, 'PF12406', NULL, 'Surface protein', 99, NULL, 'DUF3664', 264403),
(445310, 'PF13365', NULL, 'Trypsin-like peptidase domain', 150, NULL, 'Trypsin_2', 264404),
(445311, 'PF05493', NULL, 'ATP synthase subunit H', 62, NULL, 'ATP_synt_H', 264405),
(445312, 'PF06247', NULL, 'Pvs28 EGF domain', 41, NULL, 'Plasmod_Pvs28', 264406),
(445313, 'PF04885', NULL, 'Stigma-specific protein, Stig1', 140, NULL, 'Stig1', 264407),
(445314, 'PF00518', NULL, 'Early Protein (E6)', 110, NULL, 'E6', 264408),
(445315, 'PF02162', NULL, 'XYPPX repeat (two copies)', 15, NULL, 'XYPPX', 264409),
(445316, 'PF06856', NULL, 'Autographa californica nuclear polyhedrosis virus (AcMNPV), Orf17', 121, NULL, 'AcMNPV_Orf17', 264410),
(445317, 'PF09132', NULL, 'BmKX', 30, NULL, 'BmKX', 264411),
(445318, 'PF12044', NULL, 'Putative peptidase family', 429, NULL, 'Metallopep', 264412),
(445319, 'PF04042', NULL, 'DNA polymerase alpha/epsilon subunit B', 211, NULL, 'DNA_pol_E_B', 264413),
(445320, 'PF18852', NULL, 'Large polyvalent protein associated domain 34', 213, NULL, 'LPD34', 264414),
(445321, 'PF06854', NULL, 'Bacteriophage Gp15 protein', 170, NULL, 'Phage_Gp15', 264415),
(445322, 'PF03702', NULL, 'Anhydro-N-acetylmuramic acid kinase', 366, NULL, 'AnmK', 264416),
(445323, 'PF05774', NULL, 'Herpesvirus helicase-primase complex component', 127, NULL, 'Herpes_heli_pri', 264417),
(445324, 'PF20390', NULL, 'Family of unknown function (DUF6685)', 207, NULL, 'DUF6685', 264418),
(445325, 'PF14748', NULL, 'Pyrroline-5-carboxylate reductase dimerisation', 104, NULL, 'P5CR_dimer', 264419),
(445326, 'PF13667', NULL, 'ThiC-associated domain', 81, NULL, 'ThiC-associated', 264420),
(445327, 'PF01156', NULL, 'Inosine-uridine preferring nucleoside hydrolase', 301, NULL, 'IU_nuc_hydro', 264421),
(445328, 'PF17935', NULL, 'Tetracyclin repressor-like, C-terminal domain', 106, NULL, 'TetR_C_27', 264422),
(445329, 'PF10624', NULL, 'Plasmid conjugative transfer entry exclusion protein TraS', 162, NULL, 'TraS', 264423),
(445330, 'PF16356', NULL, 'Domain of unknown function (DUF4983)', 93, NULL, 'DUF4983', 264424),
(445331, 'PF09931', NULL, 'Uncharacterized conserved protein (DUF2163)', 163, NULL, 'DUF2163', 264425),
(445332, 'PF09919', NULL, 'Uncharacterized conserved protein (DUF2149)', 92, NULL, 'DUF2149', 264426),
(445333, 'PF09988', NULL, 'Uncharacterized metal-binding protein (DUF2227)', 167, NULL, 'DUF2227', 264427),
(445334, 'PF19274', NULL, 'PI4-kinase N-terminal region', 1179, NULL, 'PI4K_N', 264428),
(445335, 'PF12801', NULL, '4Fe-4S binding domain', 48, NULL, 'Fer4_5', 264429),
(445336, 'PF15425', NULL, 'Domain of unknown function (DUF4627)', 211, NULL, 'DUF4627', 264430),
(445337, 'PF12695', NULL, 'Alpha/beta hydrolase family', 164, NULL, 'Abhydrolase_5', 264431),
(445338, 'PF04363', NULL, 'Protein of unknown function (DUF496)', 93, NULL, 'DUF496', 264432),
(445339, 'PF00356', NULL, 'Bacterial regulatory proteins, lacI family', 46, NULL, 'LacI', 264433),
(445340, 'PF15819', NULL, 'Fin bud initiation factor homologue', 190, NULL, 'Fibin', 264434),
(445341, 'PF19678', NULL, 'Family of unknown function (DUF6180)', 102, NULL, 'DUF6180', 264435),
(445342, 'PF12755', NULL, 'Vacuolar 14 Fab1-binding region', 97, NULL, 'Vac14_Fab1_bd', 264436),
(445343, 'PF19497', NULL, 'Family of unknown function (DUF6032)', 476, NULL, 'DUF6032', 264437),
(445344, 'PF02800', NULL, 'Glyceraldehyde 3-phosphate dehydrogenase, C-terminal domain', 158, NULL, 'Gp_dh_C', 264438),
(445345, 'PF19454', NULL, 'Family of unknown function (DUF5992)', 106, NULL, 'DUF5992', 264439),
(445346, 'PF06635', NULL, 'Type 3 secretion system stator protein', 206, NULL, 'T3SS_SCTL', 264440),
(445347, 'PF19352', NULL, 'Tetracyclin repressor-like, C-terminal domain', 135, NULL, 'TetR_C_38', 264441);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(445348, 'PF20038', NULL, 'Helix-turn-helix domain', 66, NULL, 'HTH_59', 264442),
(445349, 'PF17123', NULL, 'RING-like zinc finger', 29, NULL, 'zf-RING_11', 264443),
(445350, 'PF07234', NULL, 'Movement and RNA silencing protein', 117, NULL, 'Babuvirus_MP', 264444),
(445351, 'PF07732', NULL, 'Multicopper oxidase', 119, NULL, 'Cu-oxidase_3', 264445),
(445352, 'PF09822', NULL, 'ABC-type uncharacterized transport system', 265, NULL, 'ABC_transp_aux', 264446),
(445353, 'PF12348', NULL, 'CLASP N terminal', 227, NULL, 'CLASP_N', 264447),
(445354, 'PF04043', NULL, 'Plant invertase/pectin methylesterase inhibitor', 154, NULL, 'PMEI', 264448),
(445355, 'PF18004', NULL, '26S proteasome regulatory subunit RPN2 C-terminal domain', 161, NULL, 'RPN2_C', 264449),
(445356, 'PF05543', NULL, 'Staphopain peptidase C47', 174, NULL, 'Peptidase_C47', 264450),
(445357, 'PF17029', NULL, 'Domain of unknown function (DUF5100)', 126, NULL, 'DUF5100', 264451),
(445358, 'PF03351', NULL, 'DOMON domain', 125, NULL, 'DOMON', 264452),
(445359, 'PF18650', NULL, 'Immunomodulating metalloprotease N-terminal domain', 200, NULL, 'IMPa_N_2', 264453),
(445360, 'PF00943', NULL, 'Alphavirus E2 glycoprotein', 403, NULL, 'Alpha_E2_glycop', 264454),
(445361, 'PF07420', NULL, 'Protein of unknown function (DUF1509)', 384, NULL, 'DUF1509', 264455),
(445362, 'PF05212', NULL, 'Protein of unknown function (DUF707)', 299, NULL, 'DUF707', 264456),
(445363, 'PF10688', NULL, 'Bacterial inner membrane protein', 159, NULL, 'Imp-YgjV', 264457),
(445364, 'PF19118', NULL, 'Family of unknown function (DUF5802)', 113, NULL, 'DUF5802', 264458),
(445365, 'PF14072', NULL, 'DNA-sulfur modification-associated', 346, NULL, 'DndB', 264459),
(445366, 'PF02261', NULL, 'Aspartate decarboxylase', 115, NULL, 'Asp_decarbox', 264460),
(445367, 'PF17054', NULL, 'Microtubule-Associated protein Jupiter', 359, NULL, 'JUPITER', 264461),
(445368, 'PF11205', NULL, 'Protein of unknown function (DUF2987)', 146, NULL, 'DUF2987', 264462),
(445369, 'PF14476', NULL, 'Petal formation-expressed', 320, NULL, 'Chloroplast_duf', 264463),
(445370, 'PF17309', NULL, 'Family of unknown function (DUF5356)', 135, NULL, 'DUF5356', 264464),
(445371, 'PF13753', NULL, 'Putative flagellar system-associated repeat', 86, NULL, 'SWM_repeat', 264465),
(445372, 'PF14185', NULL, 'Antitoxin SpoIISB, type II toxin-antitoxin system', 56, NULL, 'SpoIISB_antitox', 264466),
(445373, 'PF11347', NULL, 'Protein of unknown function (DUF3148)', 62, NULL, 'DUF3148', 264467),
(445374, 'PF08512', NULL, 'Histone chaperone Rttp106-like', 88, NULL, 'Rtt106', 264468),
(445375, 'PF11631', NULL, 'Protein of unknown function (DUF3255)', 123, NULL, 'DUF3255', 264469),
(445376, 'PF03866', NULL, 'Hydrophobic abundant protein (HAP)', 164, NULL, 'HAP', 264470),
(445377, 'PF08297', NULL, 'U3 snoRNA associated', 90, NULL, 'U3_snoRNA_assoc', 264471),
(445378, 'PF01861', NULL, 'Branched-chain polyamine synthase A C-terminal domain', 243, NULL, 'BpsA_C', 264472),
(445379, 'PF13211', NULL, 'Protein of unknown function (DUF4019)', 104, NULL, 'DUF4019', 264473),
(445380, 'PF00431', NULL, 'CUB domain', 110, NULL, 'CUB', 264474),
(445381, 'PF12206', NULL, 'Domain of unknown function (DUF3599)', 116, NULL, 'DUF3599', 264475),
(445382, 'PF09698', NULL, 'Geobacter CxxxxCH...CXXCH motif (GSu_C4xC__C2xCH)', 36, NULL, 'GSu_C4xC__C2xCH', 264476),
(445383, 'PF19287', NULL, 'Family of unknown function (DUF5910)', 121, NULL, 'DUF5910', 264477),
(445384, 'PF07565', NULL, 'Band 3 cytoplasmic domain', 262, NULL, 'Band_3_cyto', 264478),
(445385, 'PF19225', NULL, 'Spo16 protein', 165, NULL, 'Spo16', 264479),
(445386, 'PF17023', NULL, 'Domain of unknown function (DUF5098)', 463, NULL, 'DUF5098', 264480),
(445387, 'PF08291', NULL, 'Peptidase M15', 111, NULL, 'Peptidase_M15_3', 264481),
(445388, 'PF09907', NULL, 'HigB_toxin, RelE-like toxic component of a toxin-antitoxin system', 74, NULL, 'HigB_toxin', 264482),
(445389, 'PF12500', NULL, 'TRSP domain C terminus to PRTase_2', 130, NULL, 'TRSP', 264483),
(445390, 'PF09599', NULL, 'Salmonella-Shigella invasin protein C (IpaC_SipC)', 334, NULL, 'IpaC_SipC', 264484);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(445391, 'PF00219', NULL, 'Insulin-like growth factor binding protein', 55, NULL, 'IGFBP', 264485),
(445392, 'PF00622', NULL, 'SPRY domain', 120, NULL, 'SPRY', 264486),
(445393, 'PF11590', NULL, 'DNA polymerase catalytic subunit Pol', 36, NULL, 'DNAPolymera_Pol', 264487),
(445394, 'PF13169', NULL, 'Poxvirus B22R protein N-terminal', 89, NULL, 'Poxvirus_B22R_N', 264488),
(445395, 'PF03887', NULL, 'YfbU domain', 166, NULL, 'YfbU', 264489),
(445396, 'PF07948', NULL, 'Nairovirus M polyprotein-like', 644, NULL, 'Nairovirus_M', 264490),
(445397, 'PF17189', NULL, 'Glycosyl hydrolase family 30 beta sandwich domain', 65, NULL, 'Glyco_hydro_30C', 264491),
(445398, 'PF20455', NULL, 'Family of unknown function (DUF6708)', 171, NULL, 'DUF6708', 264492),
(445399, 'PF15938', NULL, 'Domain of unknown function (DUF4750)', 54, NULL, 'DUF4750', 264493),
(445400, 'PF18604', NULL, 'Pre ATP-grasp domain', 94, NULL, 'PreAtp-grasp', 264494),
(445401, 'PF14344', NULL, 'Domain of unknown function (DUF4397)', 119, NULL, 'DUF4397', 264495),
(445402, 'PF20567', NULL, 'Family of unknown function (DUF6776)', 149, NULL, 'DUF6776', 264496),
(445403, 'PF08205', NULL, 'CD80-like C2-set immunoglobulin domain', 89, NULL, 'C2-set_2', 264497),
(445404, 'PF04778', NULL, 'LMP repeated region', 157, NULL, 'LMP', 264498),
(445405, 'PF08598', NULL, 'Sds3-like', 218, NULL, 'Sds3', 264499),
(445406, 'PF03529', NULL, 'Otx1 transcription factor', 92, NULL, 'TF_Otx', 264500),
(445407, 'PF14470', NULL, 'Bacterial PH domain', 95, NULL, 'bPH_3', 264501),
(445408, 'PF09515', NULL, 'Thiamine transporter protein (Thia_YuaJ)', 177, NULL, 'Thia_YuaJ', 264502),
(445409, 'PF06458', NULL, 'MucBP domain', 63, NULL, 'MucBP', 264503),
(445410, 'PF12174', NULL, 'RCD1-SRO-TAF4 (RST) plant domain', 67, NULL, 'RST', 264504),
(445411, 'PF03487', NULL, 'Interleukin-13', 129, NULL, 'IL13', 264505),
(445412, 'PF12891', NULL, 'Glycoside hydrolase family 44', 231, NULL, 'Glyco_hydro_44', 264506),
(445413, 'PF16960', NULL, 'Haemoglobin-haptoglobin utilisation, porphyrin transporter', 308, NULL, 'HpuA', 264507),
(445414, 'PF10568', NULL, 'Outer mitochondrial membrane transport complex protein', 125, NULL, 'Tom37', 264508),
(445415, 'PF17910', NULL, 'FeoB cytosolic helical domain', 91, NULL, 'FeoB_Cyto', 264509),
(445416, 'PF17982', NULL, 'NSD Cys-His rich domain', 50, NULL, 'C5HCH', 264510),
(445417, 'PF15199', NULL, 'D-amino acid oxidase activator', 82, NULL, 'DAOA', 264511),
(445418, 'PF09103', NULL, 'BRCA2, oligonucleotide/oligosaccharide-binding, domain 1', 124, NULL, 'BRCA-2_OB1', 264512),
(445419, 'PF11983', NULL, 'Cell division protein FtsA, C-terminal', 66, NULL, 'FtsA_C', 264513),
(445420, 'PF18062', NULL, 'Restriction endonuclease AspBHI N-terminal', 185, NULL, 'RE_AspBHI_N', 264514),
(445421, 'PF06186', NULL, 'Protein of unknown function (DUF992)', 143, NULL, 'DUF992', 264515),
(445422, 'PF15017', NULL, 'Putative WW-binding domain and destruction box', 69, NULL, 'WRNPLPNID', 264516),
(445423, 'PF13640', NULL, '2OG-Fe(II) oxygenase superfamily', 96, NULL, '2OG-FeII_Oxy_3', 264517),
(445424, 'PF06572', NULL, 'Protein of unknown function (DUF1131)', 170, NULL, 'DUF1131', 264518),
(445425, 'PF19783', NULL, 'Domain of unknown function (DUF6268)', 280, NULL, 'DUF6268', 264519),
(445426, 'PF00930', NULL, 'Dipeptidyl peptidase IV (DPP IV) N-terminal region', 355, NULL, 'DPPIV_N', 264520),
(445427, 'PF16755', NULL, 'Nucleoporin or Nuclear pore complex subunit NUP214=Nup159', 359, NULL, 'NUP214', 264521),
(445428, 'PF18927', NULL, 'Glycosyl-4,4''-diaponeurosporenoate acyltransferase', 123, NULL, 'CrtO', 264522),
(445429, 'PF04052', NULL, 'TolB amino-terminal domain', 106, NULL, 'TolB_N', 264523),
(445430, 'PF10147', NULL, 'Growth arrest and DNA-damage-inducible proteins-interacting protein 1', 204, NULL, 'CR6_interact', 264524),
(445431, 'PF18808', NULL, 'Importin repeat', 90, NULL, 'Importin_rep_4', 264525),
(445432, 'PF10513', NULL, 'Enhancer of polycomb-like', 174, NULL, 'EPL1', 264526),
(445433, 'PF08988', NULL, 'Type III secretion system, cytoplasmic E component of needle', 66, NULL, 'T3SS_needle_E', 264527);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(445434, 'PF13458', NULL, 'Periplasmic binding protein', 343, NULL, 'Peripla_BP_6', 264528),
(445435, 'PF16512', NULL, 'p190-A and -B Rho GAPs FF domain', 80, NULL, 'RhoGAP-FF1', 264529),
(445436, 'PF03313', NULL, 'Serine dehydratase alpha chain', 260, NULL, 'SDH_alpha', 264530),
(445437, 'PF10004', NULL, 'Uncharacterized protein conserved in bacteria (DUF2247)', 157, NULL, 'DUF2247', 264531),
(445438, 'PF00503', NULL, 'G-protein alpha subunit', 355, NULL, 'G-alpha', 264532),
(445439, 'PF04756', NULL, 'OST3 / OST6 family, transporter family', 293, NULL, 'OST3_OST6', 264533),
(445440, 'PF06800', NULL, 'Sugar transport protein', 280, NULL, 'Sugar_transport', 264534),
(445441, 'PF15561', NULL, 'Immunity protein 15', 151, NULL, 'Imm15', 264535),
(445442, 'PF01155', NULL, 'Hydrogenase/urease nickel incorporation, metallochaperone, hypA', 112, NULL, 'HypA', 264536),
(445443, 'PF01420', NULL, 'Type I restriction modification DNA specificity domain', 168, NULL, 'Methylase_S', 264537),
(445444, 'PF01628', NULL, 'HrcA protein C terminal domain', 219, NULL, 'HrcA', 264538),
(445445, 'PF17511', NULL, 'Mobilization protein B', 136, NULL, 'Mobilization_B', 264539),
(445446, 'PF07118', NULL, 'Protein of unknown function (DUF1374)', 92, NULL, 'DUF1374', 264540),
(445447, 'PF18955', NULL, 'Domain of unknown function (DUF5698)', 58, NULL, 'DUF5698', 264541),
(445448, 'PF05852', NULL, 'Gammaherpesvirus protein of unknown function (DUF848)', 145, NULL, 'DUF848', 264542),
(445449, 'PF17873', NULL, 'Replicase polyprotein 1ab', 53, NULL, 'Rep_1B', 264543),
(445450, 'PF14739', NULL, 'Domain of unknown function (DUF4472)', 107, NULL, 'DUF4472', 264544),
(445451, 'PF15918', NULL, 'Domain of unknown function (DUF4744)', 70, NULL, 'DUF4744', 264545),
(445452, 'PF17866', NULL, 'AAA lid domain', 61, NULL, 'AAA_lid_6', 264546),
(445453, 'PF10907', NULL, 'Protein of unknown function (DUF2749)', 72, NULL, 'DUF2749', 264547),
(445454, 'PF06894', NULL, 'Bacteriophage lambda tail assembly chaperone, TAC, protein G', 126, NULL, 'Phage_TAC_2', 264548),
(445455, 'PF17241', NULL, 'Ty5 Gag N-terminal region', 154, NULL, 'Retrotran_gag_4', 264549),
(445456, 'PF18334', NULL, 'Exoribonuclease Xrn1 D2/D3 domain', 87, NULL, 'XRN1_D2_D3', 264550),
(445457, 'PF04705', NULL, 'Thiostrepton-resistance methylase, N terminus', 111, NULL, 'TSNR_N', 264551),
(445458, 'PF11115', NULL, 'Protein of unknown function (DUF2623)', 93, NULL, 'DUF2623', 264552),
(445459, 'PF19267', NULL, 'Contractile injection system spike tip protein', 141, NULL, 'CIS_spike_tip', 264553),
(445460, 'PF02530', NULL, 'Porin subfamily', 379, NULL, 'Porin_2', 264554),
(445461, 'PF04248', NULL, 'Domain of unknown function (DUF427)', 93, NULL, 'NTP_transf_9', 264555),
(445462, 'PF14722', NULL, 'Ki-ras-induced actin-interacting protein-IP3R-interacting domain', 145, NULL, 'KRAP_IP3R_bind', 264556),
(445463, 'PF07244', NULL, 'Surface antigen variable number repeat', 80, NULL, 'POTRA', 264557),
(445464, 'PF08604', NULL, 'Nucleoporin Nup153-like', 512, NULL, 'Nup153', 264558),
(445465, 'PF02303', NULL, 'Helix-destabilising protein', 83, NULL, 'Phage_DNA_bind', 264559),
(445466, 'PF00190', NULL, 'Cupin', 151, NULL, 'Cupin_1', 264560),
(445467, 'PF10256', NULL, 'Golgin subfamily A member 7/ERF4 family', 116, NULL, 'Erf4', 264561),
(445468, 'PF14781', NULL, 'Ciliary BBSome complex subunit 2, N-terminal', 106, NULL, 'BBS2_N', 264562),
(445469, 'PF13208', NULL, 'TerB N-terminal domain', 208, NULL, 'TerB_N', 264563),
(445470, 'PF05899', NULL, 'EutQ-like cupin domain', 74, NULL, 'Cupin_3', 264564),
(445471, 'PF12767', NULL, 'Transcriptional regulator of RNA polII, SAGA, subunit', 235, NULL, 'SAGA-Tad1', 264565),
(445472, 'PF08032', NULL, 'RNA 2''-O ribose methyltransferase substrate binding', 76, NULL, 'SpoU_sub_bind', 264566),
(445473, 'PF13871', NULL, 'C-terminal domain on Strawberry notch homologue', 271, NULL, 'Helicase_C_4', 264567),
(445474, 'PF01423', NULL, 'LSM domain', 67, NULL, 'LSM', 264568),
(445475, 'PF05502', NULL, 'Dynactin p62 family', 477, NULL, 'Dynactin_p62', 264569);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(445476, 'PF14683', NULL, 'Polysaccharide lyase family 4, domain III', 169, NULL, 'CBM-like', 264570),
(445477, 'PF05079', NULL, 'Protein of unknown function (DUF680)', 56, NULL, 'DUF680', 264571),
(445478, 'PF14313', NULL, 'N-terminal region of Paramyxovirinae phosphoprotein (P)', 58, NULL, 'Soyouz_module', 264572),
(445479, 'PF17366', NULL, 'A-agglutinin-binding subunit Aga2', 58, NULL, 'AGA2', 264573),
(445480, 'PF05110', NULL, 'AF-4 proto-oncoprotein N-terminal region', 514, NULL, 'AF-4', 264574),
(445481, 'PF05633', NULL, 'Protein ROH1-like', 384, NULL, 'ROH1-like', 264575),
(445482, 'PF10516', NULL, 'SHNi-TPR', 38, NULL, 'SHNi-TPR', 264576),
(445483, 'PF10616', NULL, 'Protein of unknown function (DUF2471)', 117, NULL, 'DUF2471', 264577),
(445484, 'PF16016', NULL, 'VAD1 Analog of StAR-related lipid transfer domain', 151, NULL, 'VASt', 264578),
(445485, 'PF01534', NULL, 'Frizzled/Smoothened family membrane region', 323, NULL, 'Frizzled', 264579),
(445486, 'PF03738', NULL, 'Glutathionylspermidine synthase preATP-grasp', 373, NULL, 'GSP_synth', 264580),
(445487, 'PF02629', NULL, 'CoA binding domain', 96, NULL, 'CoA_binding', 264581),
(445488, 'PF05458', NULL, 'Cd27 binding protein (Siva)', 173, NULL, 'Siva', 264582),
(445489, 'PF14801', NULL, 'tRNA methyltransferase complex GCD14 subunit N-term', 51, NULL, 'GCD14_N', 264583),
(445490, 'PF00526', NULL, 'Dictyostelium (slime mold) repeat', 24, NULL, 'Dicty_CTDC', 264584),
(445491, 'PF12378', NULL, 'Mycoplasma adhesin P1, N-terminal', 310, NULL, 'P1_N', 264585),
(445492, 'PF00615', NULL, 'Regulator of G protein signaling domain', 118, NULL, 'RGS', 264586),
(445493, 'PF12705', NULL, 'PD-(D/E)XK nuclease superfamily', 255, NULL, 'PDDEXK_1', 264587),
(445494, 'PF19861', NULL, 'Family of unknown function (DUF6335)', 124, NULL, 'DUF6335', 264588),
(445495, 'PF12153', NULL, 'LPS binding domain of CAP18 (C terminal)', 28, NULL, 'CAP18_C', 264589),
(445496, 'PF16929', NULL, 'Accessory Sec system GspB-transporter', 500, NULL, 'Asp2', 264590),
(445497, 'PF18451', NULL, 'Contact-dependent growth inhibition CdiA C-terminal domain', 81, NULL, 'CdiA_C', 264591),
(445498, 'PF03535', NULL, 'Paxillin family', 201, NULL, 'Paxillin', 264592),
(445499, 'PF14973', NULL, 'TERF1-interacting nuclear factor 2 N-terminus', 148, NULL, 'TINF2_N', 264593),
(445500, 'PF15286', NULL, 'Apoptosis regulator M11, B cell 2 leukaemia/lymphoma like', 126, NULL, 'Bcl-2_3', 264594),
(445501, 'PF14616', NULL, 'Transcription regulator Rua1, C-terminal', 122, NULL, 'Rua1_C', 264595),
(445502, 'PF08930', NULL, 'Domain of unknown function (DUF1912)', 84, NULL, 'DUF1912', 264596),
(445503, 'PF07252', NULL, 'Protein of unknown function (DUF1433)', 88, NULL, 'DUF1433', 264597),
(445504, 'PF18312', NULL, 'Copper resistance protein ScsC N-terminal domain', 34, NULL, 'ScsC_N', 264598),
(445505, 'PF11274', NULL, 'Protein of unknown function (DUF3074)', 184, NULL, 'DUF3074', 264599),
(445506, 'PF13284', NULL, 'Domain of unknown function (DUF4072)', 46, NULL, 'DUF4072', 264600),
(445507, 'PF16204', NULL, 'BDHCT-box associated domain on Bloom syndrome protein', 223, NULL, 'BDHCT_assoc', 264601),
(445508, 'PF06199', NULL, 'Phage tail tube protein', 135, NULL, 'Phage_tail_2', 264602),
(445509, 'PF19129', NULL, 'Family of unknown function (DUF5812)', 140, NULL, 'DUF5812', 264603),
(445510, 'PF14116', NULL, 'YyzF-like protein', 48, NULL, 'YyzF', 264604),
(445511, 'PF10484', NULL, 'Mitochondrial ribosomal protein S23', 128, NULL, 'MRP-S23', 264605),
(445512, 'PF14992', NULL, 'TMCO5 family', 275, NULL, 'TMCO5', 264606),
(445513, 'PF00423', NULL, 'Haemagglutinin-neuraminidase', 542, NULL, 'HN', 264607),
(445514, 'PF01637', NULL, 'ATPase domain predominantly from Archaea', 233, NULL, 'ATPase_2', 264608),
(445515, 'PF02197', NULL, 'Regulatory subunit of type II PKA R-subunit', 38, NULL, 'RIIa', 264609),
(445516, 'PF11928', NULL, 'Early growth response N-terminal domain', 105, NULL, 'DUF3446', 264610),
(445517, 'PF12415', NULL, 'Poxvirus DNA dependent RNA polymerase', 32, NULL, 'rpo132', 264611),
(445518, 'PF00532', NULL, 'Periplasmic binding proteins and sugar binding domain of LacI family', 279, NULL, 'Peripla_BP_1', 264612);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(445519, 'PF19893', NULL, 'Family of unknown function (DUF6366)', 69, NULL, 'DUF6366', 264613),
(445520, 'PF01619', NULL, 'Proline dehydrogenase', 282, NULL, 'Pro_dh', 264614),
(445521, 'PF15740', NULL, 'Protein phosphatase 1 regulatory subunit 26 N-terminus', 864, NULL, 'PPP1R26_N', 264615),
(445522, 'PF16148', NULL, 'Domain of unknown function (DUF4856)', 362, NULL, 'DUF4856', 264616),
(445523, 'PF00429', NULL, 'ENV polyprotein (coat polyprotein)', 561, NULL, 'TLV_coat', 264617),
(445524, 'PF15554', NULL, 'FSIP1 family', 400, NULL, 'FSIP1', 264618),
(445525, 'PF09394', NULL, 'Chagasin family peptidase inhibitor I42', 91, NULL, 'Inhibitor_I42', 264619),
(445526, 'PF12227', NULL, 'Protein of unknown function (DUF3603)', 214, NULL, 'DUF3603', 264620),
(445527, 'PF05736', NULL, 'OprF membrane domain', 184, NULL, 'OprF', 264621),
(445528, 'PF13622', NULL, 'Thioesterase-like superfamily', 250, NULL, '4HBT_3', 264622),
(445529, 'PF20171', NULL, 'Glucose-6-phosphate dehydrogenase subunit C-terminal domain', 133, NULL, 'OpcA_G6PD_C', 264623),
(445530, 'PF20295', NULL, 'ABC-three component (ABC-3C) system Middle Component 8', 48, NULL, 'MC8', 264624),
(445531, 'PF11410', NULL, 'Antifungal peptide', 33, NULL, 'Antifungal_pept', 264625),
(445532, 'PF12211', NULL, 'Low molecular weight S layer protein N terminal', 262, NULL, 'LMWSLP_N', 264626),
(445533, 'PF18709', NULL, 'Dynamin-like helical domain', 344, NULL, 'DLP_helical', 264627),
(445534, 'PF12948', NULL, 'MSP7-like protein C-terminal domain', 125, NULL, 'MSP7_C', 264628),
(445535, 'PF14606', NULL, 'GDSL-like Lipase/Acylhydrolase family', 181, NULL, 'Lipase_GDSL_3', 264629),
(445536, 'PF07095', NULL, 'Intracellular growth attenuator protein IgaA', 703, NULL, 'IgaA', 264630),
(445537, 'PF11507', NULL, 'Ebola virus-specific transcription factor VP30', 131, NULL, 'Transcript_VP30', 264631),
(445538, 'PF09973', NULL, 'Predicted membrane protein (DUF2208)', 231, NULL, 'DUF2208', 264632),
(445539, 'PF02922', NULL, 'Carbohydrate-binding module 48 (Isoamylase N-terminal domain)', 83, NULL, 'CBM_48', 264633),
(445540, 'PF08891', NULL, 'YfcL protein', 83, NULL, 'YfcL', 264634),
(445541, 'PF15145', NULL, 'Domain of unknown function (DUF4577)', 128, NULL, 'DUF4577', 264635),
(445542, 'PF08398', NULL, 'Phospholipase A2-like domain', 83, NULL, 'Phospholip_A2_4', 264636),
(445543, 'PF04048', NULL, 'Sec8 exocyst complex component specific domain', 142, NULL, 'Sec8_exocyst', 264637),
(445544, 'PF13059', NULL, 'Protein of unknown function (DUF3992)', 79, NULL, 'DUF3922', 264638),
(445545, 'PF19838', NULL, 'LptD protein', 465, NULL, 'LptD_2', 264639),
(445546, 'PF08837', NULL, 'Protein of unknown function (DUF1810)', 136, NULL, 'DUF1810', 264640),
(445547, 'PF10911', NULL, 'Bacteriophage T7-like gene 6.5', 77, NULL, 'T7-like_Y65', 264641),
(445548, 'PF12616', NULL, 'Protein of unknown function (DUF3775)', 73, NULL, 'DUF3775', 264642),
(445549, 'PF03392', NULL, 'Insect pheromone-binding family, A10/OS-D', 93, NULL, 'OS-D', 264643),
(445550, 'PF10000', NULL, 'ACT domain', 70, NULL, 'ACT_3', 264644),
(445551, 'PF11636', NULL, 'Troponin I residues 1-32', 31, NULL, 'Troponin-I_N', 264645),
(445552, 'PF18565', NULL, 'Glycoside hydrolase family 2 C-terminal domain 5', 103, NULL, 'Glyco_hydro2_C5', 264646),
(445553, 'PF20030', NULL, 'MoxR domain in the MoxR-vWA-beta-propeller ternary systems', 205, NULL, 'bpMoxR', 264647),
(445554, 'PF04399', NULL, 'Glutaredoxin 2, C terminal domain', 130, NULL, 'Glutaredoxin2_C', 264648),
(445555, 'PF03350', NULL, 'Uncharacterized protein family, UPF0114', 118, NULL, 'UPF0114', 264649),
(445556, 'PF08627', NULL, 'CRT-like, chloroquine-resistance transporter-like', 336, NULL, 'CRT-like', 264650),
(445557, 'PF17614', NULL, 'Viral CC-type chemokine', 188, NULL, 'FPV060', 264651),
(445558, 'PF14294', NULL, 'Domain of unknown function (DUF4372)', 74, NULL, 'DUF4372', 264652),
(445559, 'PF07928', NULL, 'Vps54-like protein', 133, NULL, 'Vps54', 264653),
(445560, 'PF03721', NULL, 'UDP-glucose/GDP-mannose dehydrogenase family, NAD binding domain', 187, NULL, 'UDPG_MGDP_dh_N', 264654);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(445561, 'PF04178', NULL, 'Got1/Sft2-like family', 110, NULL, 'Got1', 264655),
(445562, 'PF07846', NULL, 'Metallothionein family', 20, NULL, 'Metallothio_Cad', 264656),
(445563, 'PF13233', NULL, 'Complex1_LYR-like', 82, NULL, 'Complex1_LYR_2', 264657),
(445564, 'PF01486', NULL, 'K-box region', 93, NULL, 'K-box', 264658),
(445565, 'PF03743', NULL, 'Bacterial conjugation TrbI-like protein', 187, NULL, 'TrbI', 264659),
(445566, 'PF20336', NULL, 'Family of unknown function (DUF6631)', 157, NULL, 'DUF6631', 264660),
(445567, 'PF10577', NULL, 'Uncharacterised protein family UPF0560', 817, NULL, 'UPF0560', 264661),
(445568, 'PF13984', NULL, 'MsyB protein', 122, NULL, 'MsyB', 264662),
(445569, 'PF02760', NULL, 'HIN-200/IF120x domain', 168, NULL, 'HIN', 264663),
(445570, 'PF02204', NULL, 'Vacuolar sorting protein 9 (VPS9) domain', 104, NULL, 'VPS9', 264664),
(445571, 'PF19780', NULL, 'Domain of unknown function (DUF6265)', 118, NULL, 'DUF6265', 264665),
(445572, 'PF16982', NULL, 'Putative Flagellin, Flp1-like, domain', 49, NULL, 'Flp1_like', 264666),
(445573, 'PF12569', NULL, 'N-terminal acetyltransferase A, auxiliary subunit', 515, NULL, 'NatA_aux_su', 264667),
(445574, 'PF11092', NULL, 'Neuronal protein 3.1 (p311)', 67, NULL, 'Alveol-reg_P311', 264668),
(445575, 'PF04444', NULL, 'Catechol dioxygenase N terminus', 75, NULL, 'Dioxygenase_N', 264669),
(445576, 'PF17491', NULL, 'Spider Toxins mu-diguetoxin-1 a, b and c', 55, NULL, 'm_DGTX_Dc1a_b_c', 264670),
(445577, 'PF14799', NULL, 'FAM195 family', 103, NULL, 'FAM195', 264671),
(445578, 'PF02531', NULL, 'PsaD', 136, NULL, 'PsaD', 264672),
(445579, 'PF16952', NULL, 'Glutamine synthetase N-terminal domain', 107, NULL, 'Gln-synt_N_2', 264673),
(445580, 'PF11764', NULL, 'COMPASS (Complex proteins associated with Set1p) component N', 174, NULL, 'N-SET', 264674),
(445581, 'PF16554', NULL, 'Dimerisation domain of d-ornithine 4,5-aminomutase', 78, NULL, 'OAM_dimer', 264675),
(445582, 'PF10722', NULL, 'Putative bacterial sensory transduction regulator', 127, NULL, 'YbjN', 264676),
(445583, 'PF09195', NULL, 'Restriction endonuclease BglII', 183, NULL, 'Endonuc-BglII', 264677),
(445584, 'PF17287', NULL, 'POTRA domain', 56, NULL, 'POTRA_3', 264678),
(445585, 'PF01594', NULL, 'AI-2E family transporter', 327, NULL, 'AI-2E_transport', 264679),
(445586, 'PF00746', NULL, 'LPXTG cell wall anchor motif', 43, NULL, 'Gram_pos_anchor', 264680),
(445587, 'PF19278', NULL, 'Hydantoinase/oxoprolinase C-terminal domain', 193, NULL, 'Hydant_A_C', 264681),
(445588, 'PF15204', NULL, 'Kita-kyushu lung cancer antigen 1', 87, NULL, 'KKLCAg1', 264682),
(445589, 'PF18882', NULL, 'Family of unknown function (DUF5647)', 79, NULL, 'DUF5647', 264683),
(445590, 'PF02140', NULL, 'Galactose binding lectin domain', 80, NULL, 'Gal_Lectin', 264684),
(445591, 'PF07085', NULL, 'DRTGG domain', 105, NULL, 'DRTGG', 264685),
(445592, 'PF10378', NULL, 'Putative RRM domain', 52, NULL, 'RRM', 264686),
(445593, 'PF10612', NULL, 'Spore coat protein Z', 159, NULL, 'Spore-coat_CotZ', 264687),
(445594, 'PF07219', NULL, 'HemY protein N-terminus', 107, NULL, 'HemY_N', 264688),
(445595, 'PF02405', NULL, 'Permease MlaE', 212, NULL, 'MlaE', 264689),
(445596, 'PF03109', NULL, 'ABC1 atypical kinase-like domain', 244, NULL, 'ABC1', 264690),
(445597, 'PF16307', NULL, 'Domain of unknown function (DUF4949)', 108, NULL, 'DUF4949', 264691),
(445598, 'PF05840', NULL, 'Bacteriophage replication gene A protein (GPA)', 318, NULL, 'Phage_GPA', 264692),
(445599, 'PF12507', NULL, 'Human Cytomegalovirus UL139 protein', 121, NULL, 'HCMV_UL139', 264693),
(445600, 'PF04063', NULL, 'Domain of unknown function (DUF383)', 188, NULL, 'DUF383', 264694),
(445601, 'PF02979', NULL, 'Nitrile hydratase, alpha chain', 184, NULL, 'NHase_alpha', 264695),
(445602, 'PF17718', NULL, 'Family of unknown function (DUF5563)', 192, NULL, 'DUF5563', 264696),
(445603, 'PF20129', NULL, 'Family of unknown function (DUF6519)', 578, NULL, 'DUF6519', 264697),
(445604, 'PF12095', NULL, 'Protein CHLORORESPIRATORY REDUCTION 7', 84, NULL, 'CRR7', 264698),
(445605, 'PF05962', NULL, 'HutD', 181, NULL, 'HutD', 264699);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(445606, 'PF16714', NULL, 'Tyrosyl-tRNA synthetase C-terminal domain', 120, NULL, 'TyrRSs_C', 264700),
(445607, 'PF10413', NULL, 'Amino terminal of the G-protein receptor rhodopsin', 36, NULL, 'Rhodopsin_N', 264701),
(445608, 'PF17362', NULL, 'Family of unknown function', 79, NULL, 'pXO2-34', 264702),
(445609, 'PF11793', NULL, 'FANCL C-terminal domain', 69, NULL, 'FANCL_C', 264703),
(445610, 'PF06393', NULL, 'BH3 interacting domain (BID)', 191, NULL, 'BID', 264704),
(445611, 'PF15205', NULL, 'Placenta-specific protein 9', 74, NULL, 'PLAC9', 264705),
(445612, 'PF06248', NULL, 'Centromere/kinetochore Zw10', 513, NULL, 'Zw10', 264706),
(445613, 'PF01083', NULL, 'Cutinase', 178, NULL, 'Cutinase', 264707),
(445614, 'PF05833', NULL, 'NFACT N-terminal and middle domains', 455, NULL, 'NFACT_N', 264708),
(445615, 'PF06946', NULL, 'Bacteriophage A118-like holin, Hol118', 93, NULL, 'Phage_holin_5_1', 264709),
(445616, 'PF04078', NULL, 'Cell differentiation family, Rcd1-like', 259, NULL, 'Rcd1', 264710),
(445617, 'PF16902', NULL, 'FokI, D3 domain', 69, NULL, 'FokI_D3', 264711),
(445618, 'PF04611', NULL, 'Mating type protein A alpha Y mating type dependent binding region', 145, NULL, 'AalphaY_MDB', 264712),
(445619, 'PF07128', NULL, 'Protein of unknown function (DUF1380)', 137, NULL, 'DUF1380', 264713),
(445620, 'PF15754', NULL, 'Sperm equatorial segment protein 1', 322, NULL, 'SPESP1', 264714),
(445621, 'PF18183', NULL, 'SMODS and SLOG-associating 2TM effector domain 2', 192, NULL, 'SLATT_2', 264715),
(445622, 'PF06536', NULL, 'Avian adenovirus fibre, N-terminal', 56, NULL, 'Av_adeno_fibre', 264716),
(445623, 'PF06887', NULL, 'Protein of unknown function (DUF1265)', 47, NULL, 'DUF1265', 264717),
(445624, 'PF16723', NULL, 'Domain of unknown function (DUF5065)', 152, NULL, 'DUF5065', 264718),
(445625, 'PF01337', NULL, 'Barstar (barnase inhibitor)', 80, NULL, 'Barstar', 264719),
(445626, 'PF10903', NULL, 'Protein of unknown function (DUF2691)', 152, NULL, 'DUF2691', 264720),
(445627, 'PF12194', NULL, 'Protein kinase Fus3-binding', 189, NULL, 'Ste5_C', 264721),
(445628, 'PF00334', NULL, 'Nucleoside diphosphate kinase', 135, NULL, 'NDK', 264722),
(445629, 'PF03062', NULL, 'MBOAT, membrane-bound O-acyltransferase family', 348, NULL, 'MBOAT', 264723),
(445630, 'PF19768', NULL, 'Family of unknown function (DUF6255)', 69, NULL, 'DUF6255', 264724),
(445631, 'PF17363', NULL, 'Family of unknown function (DUF5388)', 70, NULL, 'DUF5388', 264725),
(445632, 'PF06776', NULL, 'Invasion associated locus B (IalB) protein', 132, NULL, 'IalB', 264726),
(445633, 'PF14356', NULL, 'Domain of unknown function (DUF4403)', 424, NULL, 'DUF4403', 264727),
(445634, 'PF17128', NULL, 'Domain of unknown function (DUF5107)', 295, NULL, 'DUF5107', 264728),
(445635, 'PF03963', NULL, 'Flagellar hook capping protein - N-terminal region', 75, NULL, 'FlgD', 264729),
(445636, 'PF08971', NULL, 'Glycogen synthesis protein', 66, NULL, 'GlgS', 264730),
(445637, 'PF12325', NULL, 'TATA element modulatory factor 1 TATA binding', 115, NULL, 'TMF_TATA_bd', 264731),
(445638, 'PF08120', NULL, 'Tamulustoxin family', 35, NULL, 'Toxin_32', 264732),
(445639, 'PF20345', NULL, 'Family of unknown function (DUF6640)', 133, NULL, 'DUF6640', 264733),
(445640, 'PF01234', NULL, 'NNMT/PNMT/TEMT family', 256, NULL, 'NNMT_PNMT_TEMT', 264734),
(445641, 'PF03178', NULL, 'CPSF A subunit region', 324, NULL, 'CPSF_A', 264735),
(445642, 'PF12737', NULL, 'C-terminal domain of homeodomain 1', 414, NULL, 'Mating_C', 264736),
(445643, 'PF05261', NULL, 'TraM protein, DNA-binding', 126, NULL, 'Tra_M', 264737),
(445644, 'PF10558', NULL, 'Mitochondrial 18 KDa protein (MTP18)', 173, NULL, 'MTP18', 264738),
(445645, 'PF03815', NULL, 'LCCL domain', 96, NULL, 'LCCL', 264739),
(445646, 'PF07321', NULL, 'Type III secretion protein YscO', 149, NULL, 'YscO', 264740),
(445647, 'PF08274', NULL, 'PhnA Zinc-Ribbon', 30, NULL, 'YjdM_Zn_Ribbon', 264741),
(445648, 'PF15708', NULL, 'Proline-rich protein family 20', 221, NULL, 'PRR20', 264742),
(445649, 'PF07927', NULL, 'HicA toxin of bacterial toxin-antitoxin,', 58, NULL, 'HicA_toxin', 264743);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(445650, 'PF17715', NULL, 'Family of unknown function (DUF5560)', 165, NULL, 'DUF5560', 264744),
(445651, 'PF18349', NULL, 'PAZ domain', 93, NULL, 'PAZ_4', 264745),
(445652, 'PF20339', NULL, 'Family of unknown function (DUF6634)', 157, NULL, 'DUF6634', 264746),
(445653, 'PF16163', NULL, 'Domain of unknown function (DUF4869)', 128, NULL, 'DUF4869', 264747),
(445654, 'PF07553', NULL, 'Host cell surface-exposed lipoprotein', 48, NULL, 'Lipoprotein_Ltp', 264748),
(445655, 'PF08713', NULL, 'DNA alkylation repair enzyme', 213, NULL, 'DNA_alkylation', 264749),
(445656, 'PF17709', NULL, 'Family of unknown function (DUF5554)', 73, NULL, 'DUF5554', 264750),
(445657, 'PF11530', NULL, 'Minor type IV pilin, PilX', 127, NULL, 'Pilin_PilX', 264751),
(445658, 'PF17408', NULL, 'Malonyl-CoA decarboxylase N-terminal domain', 85, NULL, 'MCD_N', 264752),
(445659, 'PF03795', NULL, 'YCII-related domain', 95, NULL, 'YCII', 264753),
(445660, 'PF10562', NULL, 'Calmodulin-binding domain C0 of NMDA receptor NR1 subunit', 29, NULL, 'CaM_bdg_C0', 264754),
(445661, 'PF01214', NULL, 'Casein kinase II regulatory subunit', 182, NULL, 'CK_II_beta', 264755),
(445662, 'PF13572', NULL, 'Domain of unknown function (DUF4134)', 93, NULL, 'DUF4134', 264756),
(445663, 'PF17757', NULL, 'UvrB interaction domain', 91, NULL, 'UvrB_inter', 264757),
(445664, 'PF06390', NULL, 'Neuroendocrine-specific golgi protein P55 (NESP55)', 257, NULL, 'NESP55', 264758),
(445665, 'PF10883', NULL, 'Protein of unknown function (DUF2681)', 87, NULL, 'DUF2681', 264759),
(445666, 'PF05021', NULL, 'NPL4 family', 309, NULL, 'NPL4', 264760),
(445667, 'PF14032', NULL, 'PknH-like extracellular domain', 188, NULL, 'PknH_C', 264761),
(445668, 'PF06580', NULL, 'Histidine kinase', 78, NULL, 'His_kinase', 264762),
(445669, 'PF17197', NULL, 'Domain of unknown function (DUF5134)', 150, NULL, 'DUF5134', 264763),
(445670, 'PF17216', NULL, 'Rrp44-like cold shock domain', 148, NULL, 'Rrp44_CSD1', 264764),
(445671, 'PF17222', NULL, 'Viral cysteine endopeptidase C107', 314, NULL, 'Peptidase_C107', 264765),
(445672, 'PF00445', NULL, 'Ribonuclease T2 family', 188, NULL, 'Ribonuclease_T2', 264766),
(445673, 'PF10497', NULL, 'Zinc-finger domain of monoamine-oxidase A repressor R1', 99, NULL, 'zf-4CXXC_R1', 264767),
(445674, 'PF18315', NULL, 'Integron cassette protein VCH_CASS1 chain', 97, NULL, 'VCH_CASS14', 264768),
(445675, 'PF02209', NULL, 'Villin headpiece domain', 36, NULL, 'VHP', 264769),
(445676, 'PF02701', NULL, 'Dof domain, zinc finger', 59, NULL, 'zf-Dof', 264770),
(445677, 'PF15308', NULL, 'CEP170 C-terminus', 682, NULL, 'CEP170_C', 264771),
(445678, 'PF06786', NULL, 'Uncharacterised protein family (UPF0253)', 65, NULL, 'UPF0253', 264772),
(445679, 'PF20316', NULL, 'Family of unknown function (DUF6612)', 237, NULL, 'DUF6612', 264773),
(445680, 'PF07875', NULL, 'Coat F domain', 63, NULL, 'Coat_F', 264774),
(445681, 'PF01298', NULL, 'C-lobe and N-lobe beta barrels of Tf-binding protein B', 135, NULL, 'TbpB_B_D', 264775),
(445682, 'PF09474', NULL, 'Type III secretion system YscX (type_III_YscX)', 121, NULL, 'Type_III_YscX', 264776),
(445683, 'PF03198', NULL, 'Glucanosyltransferase', 315, NULL, 'Glyco_hydro_72', 264777),
(445684, 'PF19044', NULL, 'TraG P-loop domain', 413, NULL, 'P-loop_TraG', 264778),
(445685, 'PF02059', NULL, 'Interleukin-3', 117, NULL, 'IL3', 264779),
(445686, 'PF17503', NULL, 'Family of unknown function (DUF5435)', 205, NULL, 'DUF5435', 264780),
(445687, 'PF18469', NULL, 'Pleckstrin homology domain', 141, NULL, 'PH_18', 264781),
(445688, 'PF00355', NULL, 'Rieske [2Fe-2S] domain', 89, NULL, 'Rieske', 264782),
(445689, 'PF03085', NULL, 'Rhoptry-associated protein 1 (RAP-1)', 241, NULL, 'RAP-1', 264783),
(445690, 'PF01159', NULL, 'Ribosomal protein L6e', 112, NULL, 'Ribosomal_L6e', 264784),
(445691, 'PF08497', NULL, 'Radical SAM N-terminal', 298, NULL, 'Radical_SAM_N', 264785),
(445692, 'PF20138', NULL, 'Family of unknown function (DUF6528)', 327, NULL, 'DUF6528', 264786),
(445693, 'PF11010', NULL, 'Protein of unknown function (DUF2848)', 194, NULL, 'DUF2848', 264787);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(445694, 'PF04695', NULL, 'Pex14 N-terminal domain', 46, NULL, 'Pex14_N', 264788),
(445695, 'PF13225', NULL, 'Beta-carotene isomerase D27-like, C-terminal', 88, NULL, 'D27-like_C', 264789),
(445696, 'PF12603', NULL, 'Protein of unknown function (DUF3770)', 235, NULL, 'DUF3770', 264790),
(445697, 'PF09368', NULL, 'Sas10 C-terminal domain', 74, NULL, 'Sas10', 264791),
(445698, 'PF04138', NULL, 'GtrA-like protein', 117, NULL, 'GtrA', 264792),
(445699, 'PF11874', NULL, 'Domain of unknown function (DUF3394)', 181, NULL, 'DUF3394', 264793),
(445700, 'PF12155', NULL, 'NADH dehydrogenase subunit 2 N-terminal', 88, NULL, 'NADHdh-2_N', 264794),
(445701, 'PF20397', NULL, 'Family of unknown function (DUF6690)', 253, NULL, 'DUF6690', 264795),
(445702, 'PF12765', NULL, 'HEAT repeat associated with sister chromatid cohesion', 42, NULL, 'Cohesin_HEAT', 264796),
(445703, 'PF15045', NULL, 'Clathrin-binding box of Aftiphilin, vesicle trafficking', 80, NULL, 'Clathrin_bdg', 264797),
(445704, 'PF07714', NULL, 'Protein tyrosine and serine/threonine kinase', 259, NULL, 'PK_Tyr_Ser-Thr', 264798),
(445705, 'PF07203', NULL, 'Protein of unknown function (DUF1412)', 53, NULL, 'DUF1412', 264799),
(445706, 'PF10828', NULL, 'Protein of unknown function (DUF2570)', 108, NULL, 'DUF2570', 264800),
(445707, 'PF17314', NULL, 'Family of unknown function (DUF5360)', 127, NULL, 'DUF5360', 264801),
(445708, 'PF03243', NULL, 'Alkylmercury lyase', 126, NULL, 'MerB', 264802),
(445709, 'PF15870', NULL, 'ElonginA binding-protein 1', 166, NULL, 'EloA-BP1', 264803),
(445710, 'PF09160', NULL, 'FimH, mannose binding', 146, NULL, 'FimH_man-bind', 264804),
(445711, 'PF13925', NULL, 'con80 domain of Katanin', 160, NULL, 'Katanin_con80', 264805),
(445712, 'PF06014', NULL, 'Bacterial protein of unknown function (DUF910)', 61, NULL, 'DUF910', 264806),
(445713, 'PF13652', NULL, 'Putative quorum-sensing-regulated virulence factor', 112, NULL, 'QSregVF', 264807),
(445714, 'PF09489', NULL, 'Probable cobalt transporter subunit (CbtB)', 51, NULL, 'CbtB', 264808),
(445715, 'PF14672', NULL, 'Late cornified envelope', 99, NULL, 'LCE', 264809),
(445716, 'PF08450', NULL, 'SMP-30/Gluconolactonase/LRE-like region', 246, NULL, 'SGL', 264810),
(445717, 'PF08471', NULL, 'Class II vitamin B12-dependent ribonucleotide reductase', 99, NULL, 'Ribonuc_red_2_N', 264811),
(445718, 'PF07439', NULL, 'Protein of unknown function (DUF1515)', 113, NULL, 'DUF1515', 264812),
(445719, 'PF02352', NULL, 'Decorin binding protein', 141, NULL, 'Decorin_bind', 264813),
(445720, 'PF06260', NULL, 'Protein of unknown function (DUF1024)', 82, NULL, 'DUF1024', 264814),
(445721, 'PF01901', NULL, 'Putative O-antigen polymerase', 336, NULL, 'O_anti_polymase', 264815),
(445722, 'PF06207', NULL, 'Protein of unknown function (DUF1002)', 220, NULL, 'DUF1002', 264816),
(445723, 'PF17777', NULL, 'Insertion domain in 60S ribosomal protein L10P', 71, NULL, 'RL10P_insert', 264817),
(445724, 'PF18506', NULL, 'RelB Antitoxin alpha helical domain', 47, NULL, 'RelB_N', 264818),
(445725, 'PF10739', NULL, 'Protein of unknown function (DUF2550)', 127, NULL, 'DUF2550', 264819),
(445726, 'PF16087', NULL, 'Helix-turn-helix domain (DUF4817)', 55, NULL, 'DUF4817', 264820),
(445727, 'PF10013', NULL, 'Uncharacterized protein conserved in bacteria (DUF2256)', 40, NULL, 'DUF2256', 264821),
(445728, 'PF20405', NULL, 'Family of unknown function (DUF6695)', 325, NULL, 'DUF6695', 264822),
(445729, 'PF03245', NULL, 'Bacteriophage Rz lysis protein', 127, NULL, 'Phage_lysis', 264823),
(445730, 'PF02097', NULL, 'Filoviridae VP35', 329, NULL, 'Filo_VP35', 264824),
(445731, 'PF04142', NULL, 'Nucleotide-sugar transporter', 315, NULL, 'Nuc_sug_transp', 264825),
(445732, 'PF08924', NULL, 'Domain of unknown function (DUF1906)', 198, NULL, 'DUF1906', 264826),
(445733, 'PF03540', NULL, 'Transcription initiation factor TFIID 23-30kDa subunit', 50, NULL, 'TFIID_30kDa', 264827),
(445734, 'PF15646', NULL, 'Restriction endonuclease fold toxin 2', 129, NULL, 'Tox-REase-2', 264828),
(445735, 'PF03734', NULL, 'L,D-transpeptidase catalytic domain', 146, NULL, 'YkuD', 264829);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(445736, 'PF16850', NULL, 'Peptidase inhibitor I66', 146, NULL, 'Inhibitor_I66', 264830),
(445737, 'PF12233', NULL, 'Human adult T cell leukemia/lymphoma virus protein', 99, NULL, 'p12I', 264831),
(445738, 'PF12457', NULL, 'Tuftelin interacting protein N terminal', 105, NULL, 'TIP_N', 264832),
(445739, 'PF16277', NULL, 'Domain of unknown function (DUF4926)', 58, NULL, 'DUF4926', 264833),
(445740, 'PF10669', NULL, 'Protein gp23 (Bacteriophage A118)', 120, NULL, 'Phage_Gp23', 264834),
(445741, 'PF17464', NULL, 'Non-structural protein 11 and 12', 203, NULL, 'Pns11_12', 264835),
(445742, 'PF03143', NULL, 'Elongation factor Tu C-terminal domain', 108, NULL, 'GTP_EFTU_D3', 264836),
(445743, 'PF09501', NULL, 'Probable sporulation protein (Bac_small_yrzI)', 45, NULL, 'Bac_small_YrzI', 264837),
(445744, 'PF02226', NULL, 'Picornavirus coat protein (VP4)', 68, NULL, 'Pico_P1A', 264838),
(445745, 'PF06259', NULL, 'Alpha/beta hydrolase', 178, NULL, 'Abhydrolase_8', 264839),
(445746, 'PF00715', NULL, 'Interleukin 2', 145, NULL, 'IL2', 264840),
(445747, 'PF14217', NULL, 'Domain of unknown function (DUF4327)', 67, NULL, 'DUF4327', 264841),
(445748, 'PF07983', NULL, 'X8 domain', 76, NULL, 'X8', 264842),
(445749, 'PF11935', NULL, 'Symplekin/PTA1 N-terminal', 228, NULL, 'SYMPK_PTA1_N', 264843),
(445750, 'PF17845', NULL, 'FbpC C-terminal regulatory nucleotide binding domain', 55, NULL, 'FbpC_C_terminal', 264844),
(445751, 'PF07086', NULL, 'Jagunal, ER re-organisation during oogenesis', 186, NULL, 'Jagunal', 264845),
(445752, 'PF05064', NULL, 'Nsp1-like C-terminal region', 114, NULL, 'Nsp1_C', 264846),
(445753, 'PF03385', NULL, 'STELLO glycosyltransferases', 387, NULL, 'STELLO', 264847),
(445754, 'PF16233', NULL, 'Domain of unknown function (DUF4893)', 169, NULL, 'DUF4893', 264848),
(445755, 'PF02905', NULL, 'Epstein Barr virus nuclear antigen-1, DNA-binding domain', 146, NULL, 'EBV-NA1', 264849),
(445756, 'PF14658', NULL, 'EF-hand domain', 66, NULL, 'EF-hand_9', 264850),
(445757, 'PF10690', NULL, 'Myticin pre-proprotein from the mussel', 98, NULL, 'Myticin-prepro', 264851),
(445758, 'PF00990', NULL, 'Diguanylate cyclase, GGDEF domain', 161, NULL, 'GGDEF', 264852),
(445759, 'PF06074', NULL, 'Protein of unknown function (DUF935)', 520, NULL, 'DUF935', 264853),
(445760, 'PF02317', NULL, 'NAD/NADP octopine/nopaline dehydrogenase, alpha-helical domain', 150, NULL, 'Octopine_DH', 264854),
(445761, 'PF03987', NULL, 'Autophagocytosis associated protein, active-site domain', 206, NULL, 'Autophagy_act_C', 264855),
(445762, 'PF15282', NULL, 'BMP-2-inducible protein kinase C-terminus', 263, NULL, 'BMP2K_C', 264856),
(445763, 'PF01411', NULL, 'tRNA synthetases class II (A)', 552, NULL, 'tRNA-synt_2c', 264857),
(445764, 'PF13748', NULL, 'ABC transporter transmembrane region', 235, NULL, 'ABC_membrane_3', 264858),
(445765, 'PF06521', NULL, 'PAR1 protein', 156, NULL, 'PAR1', 264859),
(445766, 'PF14057', NULL, 'GGGtGRT protein', 327, NULL, 'GGGtGRT', 264860),
(445767, 'PF05255', NULL, 'Uncharacterised protein family (UPF0220)', 166, NULL, 'UPF0220', 264861),
(445768, 'PF13805', NULL, 'Eisosome component PIL1', 265, NULL, 'Pil1', 264862),
(445769, 'PF15703', NULL, 'Linker for activation of T-cells family member 2', 177, NULL, 'LAT2', 264863),
(445770, 'PF07911', NULL, 'Protein of unknown function (DUF1677)', 89, NULL, 'DUF1677', 264864),
(445771, 'PF05876', NULL, 'Phage terminase large subunit gpA, ATPase domain', 246, NULL, 'GpA_ATPase', 264865),
(445772, 'PF08895', NULL, 'Domain of unknown function (DUF1840)', 108, NULL, 'DUF1840', 264866),
(445773, 'PF01660', NULL, 'Viral methyltransferase', 346, NULL, 'Vmethyltransf', 264867),
(445774, 'PF02597', NULL, 'ThiS family', 77, NULL, 'ThiS', 264868),
(445775, 'PF10027', NULL, 'Predicted integral membrane protein (DUF2269)', 150, NULL, 'DUF2269', 264869),
(445776, 'PF02129', NULL, 'X-Pro dipeptidyl-peptidase (S15 family)', 269, NULL, 'Peptidase_S15', 264870),
(445777, 'PF09847', NULL, 'Membrane protein of 12 TMs', 449, NULL, '12TM_1', 264871),
(445778, 'PF04137', NULL, 'Endoplasmic Reticulum Oxidoreductin 1 (ERO1)', 353, NULL, 'ERO1', 264872);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(445779, 'PF04001', NULL, 'Transcription factor Vhr1', 91, NULL, 'Vhr1', 264873),
(445780, 'PF06827', NULL, 'Zinc finger found in FPG and IleRS', 30, NULL, 'zf-FPG_IleRS', 264874),
(445781, 'PF16249', NULL, 'Domain of unknown function (DUF4906)', 203, NULL, 'DUF4906', 264875),
(445782, 'PF04633', NULL, 'Herpesvirus BMRF2 protein', 349, NULL, 'Herpes_BMRF2', 264876),
(445783, 'PF19272', NULL, 'Acid sphingomyelin phosphodiesterase C-terminal region', 143, NULL, 'ASMase_C', 264877),
(445784, 'PF00710', NULL, 'Asparaginase, N-terminal', 191, NULL, 'Asparaginase', 264878),
(445785, 'PF10127', NULL, 'RNA repair pathway DNA polymerase beta family', 246, NULL, 'RlaP', 264879),
(445786, 'PF00377', NULL, 'Prion/Doppel alpha-helical domain', 117, NULL, 'Prion', 264880),
(445787, 'PF09614', NULL, 'CRISPR-associated protein (Cas_Csy2)', 295, NULL, 'Cas_Csy2', 264881),
(445788, 'PF10283', NULL, 'PBZ domain', 26, NULL, 'zf-CCHH', 264882),
(445789, 'PF06290', NULL, 'Plasmid SOS inhibition protein (PsiB)', 138, NULL, 'PsiB', 264883),
(445790, 'PF14689', NULL, 'Sensor_kinase_SpoOB-type, alpha-helical domain', 62, NULL, 'SPOB_a', 264884),
(445791, 'PF08290', NULL, 'Hepatitis core protein, putative zinc finger', 27, NULL, 'Hep_core_N', 264885),
(445792, 'PF10953', NULL, 'Protein of unknown function (DUF2754)', 70, NULL, 'DUF2754', 264886),
(445793, 'PF15324', NULL, 'Hedgehog signalling target', 1287, NULL, 'TALPID3', 264887),
(445794, 'PF00025', NULL, 'ADP-ribosylation factor family', 175, NULL, 'Arf', 264888),
(445795, 'PF17985', NULL, 'SipA vinculin binding site', 22, NULL, 'SipA_VBS', 264889),
(445796, 'PF14453', NULL, 'ThiS-like ubiquitin', 57, NULL, 'ThiS-like', 264890),
(445797, 'PF16440', NULL, 'Domain of unknown function (DUF5037)', 242, NULL, 'DUF5037', 264891),
(445798, 'PF20207', NULL, 'Family of unknown function (DUF6568)', 161, NULL, 'DUF6568', 264892),
(445799, 'PF00276', NULL, 'Ribosomal protein L23', 86, NULL, 'Ribosomal_L23', 264893),
(445800, 'PF16243', NULL, 'Sm_like domain', 85, NULL, 'Sm_like', 264894),
(445801, 'PF18595', NULL, 'Nuf2, DHR10-like domain', 117, NULL, 'Nuf2_DHR10-like', 264895),
(445802, 'PF13816', NULL, 'Haem-containing dehydratase', 310, NULL, 'Dehydratase_hem', 264896),
(445803, 'PF06754', NULL, 'Phosphonate metabolism protein PhnG', 142, NULL, 'PhnG', 264897),
(445804, 'PF14584', NULL, 'Protein of unknown function (DUF4446)', 150, NULL, 'DUF4446', 264898),
(445805, 'PF06743', NULL, 'FAST kinase-like protein, subdomain 1', 72, NULL, 'FAST_1', 264899),
(445806, 'PF08822', NULL, 'Protein of unknown function (DUF1804)', 164, NULL, 'DUF1804', 264900),
(445807, 'PF14750', NULL, 'Integrator complex subunit 2', 1052, NULL, 'INTS2', 264901),
(445808, 'PF13499', NULL, 'EF-hand domain pair', 71, NULL, 'EF-hand_7', 264902),
(445809, 'PF20106', NULL, 'Family of unknown function (DUF6496)', 58, NULL, 'DUF6496', 264903),
(445810, 'PF06769', NULL, 'YoeB-like toxin of bacterial type II toxin-antitoxin system', 80, NULL, 'YoeB_toxin', 264904),
(445811, 'PF12654', NULL, 'Domain of unknown function (DUF3786)', 176, NULL, 'DUF3786', 264905),
(445812, 'PF01813', NULL, 'ATP synthase subunit D', 196, NULL, 'ATP-synt_D', 264906),
(445813, 'PF08401', NULL, 'N-terminal domain of anti-restriction factor ArdC', 122, NULL, 'ArdcN', 264907),
(445814, 'PF17948', NULL, 'DnaT DNA-binding domain', 71, NULL, 'DnaT', 264908),
(445815, 'PF12255', NULL, 'Insecticide toxin TcdB middle/C-terminal region', 148, NULL, 'TcdB_toxin_midC', 264909),
(445816, 'PF01397', NULL, 'Terpene synthase, N-terminal domain', 192, NULL, 'Terpene_synth', 264910),
(445817, 'PF18830', NULL, 'Large polyvalent protein-associated domain 16', 82, NULL, 'LPD16', 264911),
(445818, 'PF05729', NULL, 'NACHT domain', 166, NULL, 'NACHT', 264912),
(445819, 'PF11469', NULL, 'Ribonuclease III', 119, NULL, 'Ribonucleas_3_2', 264913),
(445820, 'PF00634', NULL, 'BRCA2 repeat', 29, NULL, 'BRCA2', 264914),
(445821, 'PF15439', NULL, 'Neuronal tyrosine-phosphorylated phosphoinositide-3-kinase adapter', 395, NULL, 'NYAP_N', 264915),
(445822, 'PF11852', NULL, 'Alpha-1,6-glucosidases, pullulanase-type, C-terminal', 167, NULL, 'Pullul_strch_C', 264916);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(445823, 'PF15539', NULL, 'CAF1 complex subunit p150, region binding to CAF1-p60 at C-term', 288, NULL, 'CAF1-p150_C2', 264917),
(445824, 'PF10708', NULL, 'Protein of unknown function (DUF2510)', 35, NULL, 'DUF2510', 264918),
(445825, 'PF12516', NULL, 'Protein of unknown function (DUF3719)', 66, NULL, 'DUF3719', 264919),
(445826, 'PF18355', NULL, 'Domain of unknown function (DUF5607)', 65, NULL, 'DUF5607', 264920),
(445827, 'PF06858', NULL, 'Nucleolar GTP-binding protein 1 (NOG1)', 58, NULL, 'NOG1', 264921),
(445828, 'PF18826', NULL, 'Bacteroidetes VLRF1 release factor', 153, NULL, 'bVLRF1', 264922),
(445829, 'PF00104', NULL, 'Ligand-binding domain of nuclear hormone receptor', 213, NULL, 'Hormone_recep', 264923),
(445830, 'PF12739', NULL, 'ER-Golgi trafficking TRAPP I complex 85 kDa subunit', 422, NULL, 'TRAPPC-Trs85', 264924),
(445831, 'PF13843', NULL, 'Transposase IS4', 350, NULL, 'DDE_Tnp_1_7', 264925),
(445832, 'PF15615', NULL, 'TerB-C domain', 151, NULL, 'TerB_C', 264926),
(445833, 'PF01087', NULL, 'Galactose-1-phosphate uridyl transferase, N-terminal domain', 184, NULL, 'GalP_UDP_transf', 264927),
(445834, 'PF03910', NULL, 'Adenovirus minor core protein PV', 355, NULL, 'Adeno_PV', 264928),
(445835, 'PF04353', NULL, 'Regulator of RNA polymerase sigma(70) subunit, Rsd/AlgQ', 150, NULL, 'Rsd_AlgQ', 264929),
(445836, 'PF04629', NULL, 'Islet cell autoantigen ICA69, C-terminal domain', 248, NULL, 'ICA69', 264930),
(445837, 'PF09333', NULL, 'Autophagy-related protein C terminal domain', 96, NULL, 'ATG_C', 264931),
(445838, 'PF10787', NULL, 'Uncharacterised protein from bacillus cereus group', 142, NULL, 'YfmQ', 264932),
(445839, 'PF13887', NULL, 'Myelin regulatory factor ICA domain', 36, NULL, 'MYRF_ICA', 264933),
(445840, 'PF18427', NULL, 'DD-reactivating factor swiveling domain', 162, NULL, 'DDR_swiveling', 264934),
(445841, 'PF13291', NULL, 'ACT domain', 80, NULL, 'ACT_4', 264935),
(445842, 'PF17621', NULL, 'Family of unknown function (DUF5508)', 263, NULL, 'DUF5508', 264936),
(445843, 'PF19138', NULL, 'Family of unknown function (DUF5821)', 217, NULL, 'DUF5821', 264937),
(445844, 'PF07442', NULL, 'Ponericin', 29, NULL, 'Ponericin', 264938),
(445845, 'PF04362', NULL, 'Bacterial Fe(2+) trafficking', 88, NULL, 'Iron_traffic', 264939),
(445846, 'PF10804', NULL, 'Protein of unknown function (DUF2538)', 155, NULL, 'DUF2538', 264940),
(445847, 'PF04558', NULL, 'Glutaminyl-tRNA synthetase, non-specific RNA binding region part 1', 162, NULL, 'tRNA_synt_1c_R1', 264941),
(445848, 'PF03599', NULL, 'CO dehydrogenase/acetyl-CoA synthase delta subunit', 386, NULL, 'CdhD', 264942),
(445849, 'PF07970', NULL, 'Endoplasmic reticulum vesicle transporter', 228, NULL, 'COPIIcoated_ERV', 264943),
(445850, 'PF16157', NULL, 'Domain of unknown function (DUF4865)', 183, NULL, 'DUF4865', 264944),
(445851, 'PF09475', NULL, 'Dot/Icm secretion system protein (dot_icm_IcmQ)', 179, NULL, 'Dot_icm_IcmQ', 264945),
(445852, 'PF02943', NULL, 'Ferredoxin thioredoxin reductase catalytic beta chain', 106, NULL, 'FeThRed_B', 264946),
(445853, 'PF05332', NULL, 'Vesivirus VP2 protein', 113, NULL, 'Vesi_VP2', 264947),
(445854, 'PF06775', NULL, 'Putative adipose-regulatory protein (Seipin)', 198, NULL, 'Seipin', 264948),
(445855, 'PF09218', NULL, 'Domain of unknown function (DUF1959)', 116, NULL, 'DUF1959', 264949),
(445856, 'PF14080', NULL, 'Domain of unknown function (DUF4261)', 77, NULL, 'DUF4261', 264950),
(445857, 'PF11937', NULL, 'Protein of unknown function (DUF3455)', 158, NULL, 'DUF3455', 264951),
(445858, 'PF17084', NULL, 'Topoisomerase I damage affected protein 11', 465, NULL, 'TDA11', 264952),
(445859, 'PF14424', NULL, 'The  BURPS668_1122 family of deaminases', 146, NULL, 'Toxin-deaminase', 264953),
(445860, 'PF18755', NULL, 'Restriction Enzyme Adenine Methylase Associated', 108, NULL, 'RAMA', 264954),
(445861, 'PF12094', NULL, 'Protein of unknown function (DUF3570)', 421, NULL, 'DUF3570', 264955),
(445862, 'PF08945', NULL, 'Bcl-x interacting, BH3 domain', 38, NULL, 'Bclx_interact', 264956),
(445863, 'PF18943', NULL, 'Family of unknown function (DUF5690)', 382, NULL, 'DUF5690', 264957);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(445864, 'PF16411', NULL, 'Outer membrane protein SusF_SusE', 130, NULL, 'SusF_SusE', 264958),
(445865, 'PF06812', NULL, 'ImpA, N-terminal, type VI secretion system', 119, NULL, 'ImpA_N', 264959),
(445866, 'PF06823', NULL, 'Protein of unknown function (DUF1236)', 65, NULL, 'DUF1236', 264960),
(445867, 'PF15904', NULL, 'LKB1 serine/threonine kinase interacting protein 1', 90, NULL, 'LIP1', 264961),
(445868, 'PF06820', NULL, 'Putative prophage tail fibre C-terminus', 64, NULL, 'Phage_fiber_C', 264962),
(445869, 'PF13599', NULL, 'Pentapeptide repeats (9 copies)', 78, NULL, 'Pentapeptide_4', 264963),
(445870, 'PF05785', NULL, 'Rho-activating domain of cytotoxic necrotizing factor', 286, NULL, 'CNF1', 264964),
(445871, 'PF00071', NULL, 'Ras family', 162, NULL, 'Ras', 264965),
(445872, 'PF09264', NULL, 'Vibrio cholerae sialidase, lectin insertion', 198, NULL, 'Sial-lect-inser', 264966),
(445873, 'PF15182', NULL, 'Otospiralin', 69, NULL, 'OTOS', 264967),
(445874, 'PF03226', NULL, 'Yippee zinc-binding/DNA-binding /Mis18, centromere assembly', 105, NULL, 'Yippee-Mis18', 264968),
(445875, 'PF10649', NULL, 'Protein of unknown function (DUF2478)', 159, NULL, 'DUF2478', 264969),
(445876, 'PF14516', NULL, 'AAA-like domain', 331, NULL, 'AAA_35', 264970),
(445877, 'PF15009', NULL, 'Transmembrane protein 173', 293, NULL, 'TMEM173', 264971),
(445878, 'PF05084', NULL, 'Granule antigen protein (GRA6)', 215, NULL, 'GRA6', 264972),
(445879, 'PF14631', NULL, 'Fanconi anaemia protein FancD2 nuclease', 1417, NULL, 'FancD2', 264973),
(445880, 'PF06041', NULL, 'Bacterial protein of unknown function (DUF924)', 181, NULL, 'DUF924', 264974),
(445881, 'PF08624', NULL, 'Chromatin remodelling complex Rsc7/Swp82 subunit', 135, NULL, 'CRC_subunit', 264975),
(445882, 'PF14605', NULL, 'Nup53/35/40-type RNA recognition motif', 53, NULL, 'Nup35_RRM_2', 264976),
(445883, 'PF10278', NULL, 'Mediator of RNA pol II transcription subunit 19', 178, NULL, 'Med19', 264977),
(445884, 'PF16487', NULL, 'Mid domain of argonaute', 84, NULL, 'ArgoMid', 264978),
(445885, 'PF17847', NULL, 'Glucose ABC transporter C-terminal domain', 61, NULL, 'GlcV_C_terminal', 264979),
(445886, 'PF02459', NULL, 'Adenoviral DNA terminal protein', 557, NULL, 'Adeno_terminal', 264980),
(445887, 'PF16698', NULL, 'Membrane-proximal domain, switch, for ADAM17', 62, NULL, 'ADAM17_MPD', 264981),
(445888, 'PF18253', NULL, 'Hsp70-interacting protein N N-terminal domain', 42, NULL, 'HipN', 264982),
(445889, 'PF19209', NULL, 'Coronavirus spike glycoprotein S1, C-terminal', 58, NULL, 'CoV_S1_C', 264983),
(445890, 'PF04747', NULL, 'Protein of unknown function, DUF612', 504, NULL, 'DUF612', 264984),
(445891, 'PF06174', NULL, 'Protein of unknown function (DUF987)', 65, NULL, 'DUF987', 264985),
(445892, 'PF00665', NULL, 'Integrase core domain', 102, NULL, 'rve', 264986),
(445893, 'PF03014', NULL, 'Structural protein 2', 628, NULL, 'SP2', 264987),
(445894, 'PF10243', NULL, 'Microtubule-binding protein MIP-T3 CH-like domain', 113, NULL, 'MIP-T3', 264988),
(445895, 'PF00723', NULL, 'Glycosyl hydrolases family 15', 448, NULL, 'Glyco_hydro_15', 264989),
(445896, 'PF13411', NULL, 'MerR HTH family regulatory protein', 69, NULL, 'MerR_1', 264990),
(445897, 'PF03274', NULL, 'Foamy virus BEL 1/2 protein', 257, NULL, 'Foamy_BEL', 264991),
(445898, 'PF19909', NULL, 'Domain of unknown function (DUF6382)', 163, NULL, 'DUF6382', 264992),
(445899, 'PF17094', NULL, 'Uncharacterised protein family (UPF0715)', 115, NULL, 'UPF0715', 264993),
(445900, 'PF07385', NULL, 'D-lyxose isomerase', 223, NULL, 'Lyx_isomer', 264994),
(445901, 'PF14763', NULL, 'Hermansky-Pudlak syndrome 3, C-terminal', 352, NULL, 'HPS3_C', 264995),
(445902, 'PF04884', NULL, 'Vitamin B6 photo-protection and homoeostasis', 241, NULL, 'UVB_sens_prot', 264996),
(445903, 'PF04039', NULL, 'Domain related to MnhB subunit of Na+/H+ antiporter', 124, NULL, 'MnhB', 264997),
(445904, 'PF18408', NULL, 'C2H2 Hakai zinc finger domain', 32, NULL, 'zf_Hakai', 264998),
(445905, 'PF06896', NULL, 'Phage tail assembly chaperone proteins, TAC', 115, NULL, 'Phage_TAC_3', 264999);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(445906, 'PF19223', NULL, 'Chroparavirus methyltransferase', 319, NULL, 'Chropara_Vmeth', 265000),
(445907, 'PF19881', NULL, 'Family of unknown function (DUF6354)', 121, NULL, 'DUF6354', 265001),
(445908, 'PF03776', NULL, 'Septum formation topological specificity factor MinE', 68, NULL, 'MinE', 265002),
(445909, 'PF02543', NULL, 'Carbamoyltransferase N-terminus', 346, NULL, 'Carbam_trans_N', 265003),
(445910, 'PF05832', NULL, 'Eukaryotic protein of unknown function (DUF846)', 139, NULL, 'DUF846', 265004),
(445911, 'PF18348', NULL, 'Bacterial dipeptidyl-peptidase Sh3 domain', 48, NULL, 'SH3_16', 265005),
(445912, 'PF14329', NULL, 'Domain of unknown function (DUF4386)', 210, NULL, 'DUF4386', 265006),
(445913, 'PF09925', NULL, 'Predicted membrane protein (DUF2157)', 147, NULL, 'DUF2157', 265007),
(445914, 'PF18066', NULL, 'Phage ABA sandwich domain', 92, NULL, 'Phage_ABA_S', 265008),
(445915, 'PF09620', NULL, 'CRISPR-associated protein (Cas_csx3)', 78, NULL, 'Cas_csx3', 265009),
(445916, 'PF09428', NULL, 'Fungal protein of unknown function (DUF2011)', 89, NULL, 'DUF2011', 265010),
(445917, 'PF13162', NULL, 'Protein of unknown function (DUF3997)', 107, NULL, 'DUF3997', 265011),
(445918, 'PF07191', NULL, 'zinc-ribbons', 67, NULL, 'zinc-ribbons_6', 265012),
(445919, 'PF09242', NULL, 'Flavocytochrome c sulphide dehydrogenase, flavin-binding', 70, NULL, 'FCSD-flav_bind', 265013),
(445920, 'PF15835', NULL, 'Domain of unknown function (DUF4715)', 139, NULL, 'DUF4715', 265014),
(445921, 'PF00185', NULL, 'Aspartate/ornithine carbamoyltransferase, Asp/Orn binding domain', 157, NULL, 'OTCace', 265015),
(445922, 'PF01331', NULL, 'mRNA capping enzyme, catalytic domain', 195, NULL, 'mRNA_cap_enzyme', 265016),
(445923, 'PF00211', NULL, 'Adenylate and Guanylate cyclase catalytic domain', 183, NULL, 'Guanylate_cyc', 265017),
(445924, 'PF17038', NULL, 'Cellulose biosynthesis protein BcsN', 186, NULL, 'CBP_BcsN', 265018),
(445925, 'PF10514', NULL, 'Pro-apoptotic Bcl-2 protein, BAD', 166, NULL, 'Bcl-2_BAD', 265019),
(445926, 'PF10729', NULL, 'Cell division activator CedA', 77, NULL, 'CedA', 265020),
(445927, 'PF13620', NULL, 'Carboxypeptidase regulatory-like domain', 82, NULL, 'CarboxypepD_reg', 265021),
(445928, 'PF15640', NULL, 'Metallopeptidase toxin 4', 132, NULL, 'Tox-MPTase4', 265022),
(445929, 'PF00450', NULL, 'Serine carboxypeptidase', 421, NULL, 'Peptidase_S10', 265023),
(445930, 'PF09166', NULL, 'Biliverdin reductase, catalytic', 113, NULL, 'Biliv-reduc_cat', 265024),
(445931, 'PF13751', NULL, 'Transposase DDE domain', 125, NULL, 'DDE_Tnp_1_6', 265025),
(445932, 'PF15037', NULL, 'Interleukin-17 receptor extracellular region', 386, NULL, 'IL17_R_N', 265026),
(445933, 'PF17091', NULL, 'Inovirus G7P protein', 38, NULL, 'Inovirus_G7P_1', 265027),
(445934, 'PF19062', NULL, 'Family of unknown function (DUF5758)', 105, NULL, 'DUF5758', 265028),
(445935, 'PF10409', NULL, 'C2 domain of PTEN tumour-suppressor protein', 135, NULL, 'PTEN_C2', 265029),
(445936, 'PF15566', NULL, 'Immunity protein 32', 54, NULL, 'Imm32', 265030),
(445937, 'PF02403', NULL, 'Seryl-tRNA synthetase N-terminal domain', 108, NULL, 'Seryl_tRNA_N', 265031),
(445938, 'PF02778', NULL, 'tRNA intron endonuclease, N-terminal domain', 67, NULL, 'tRNA_int_endo_N', 265032),
(445939, 'PF19799', NULL, 'Family of unknown function (DUF6282)', 196, NULL, 'DUF6282', 265033),
(445940, 'PF14752', NULL, 'Retinol binding protein receptor', 608, NULL, 'RBP_receptor', 265034),
(445941, 'PF09232', NULL, 'Caenorhabditis elegans Her-1', 132, NULL, 'Caenor_Her-1', 265035),
(445942, 'PF12288', NULL, 'Carboxysome shell peptide mid-region', 421, NULL, 'CsoS2_M', 265036),
(445943, 'PF10745', NULL, 'Protein of unknown function (DUF2530)', 77, NULL, 'DUF2530', 265037),
(445944, 'PF03940', NULL, 'Male specific sperm protein', 51, NULL, 'MSSP', 265038),
(445945, 'PF15959', NULL, 'Domain of unknown function (DUF4762)', 61, NULL, 'DUF4762', 265039),
(445946, 'PF13820', NULL, 'Putative nucleic acid-binding region', 144, NULL, 'Nucleic_acid_bd', 265040),
(445947, 'PF17119', NULL, 'Mitochondrial protein up-regulated during meiosis', 255, NULL, 'MMU163', 265041);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(445948, 'PF09570', NULL, 'SinI restriction endonuclease', 217, NULL, 'RE_SinI', 265042),
(445949, 'PF15006', NULL, 'Domain of unknown function (DUF4517)', 152, NULL, 'DUF4517', 265043),
(445950, 'PF12773', NULL, 'Double zinc ribbon', 49, NULL, 'DZR', 265044),
(445951, 'PF15574', NULL, 'Immunity protein 48', 123, NULL, 'Imm48', 265045),
(445952, 'PF01498', NULL, 'Transposase', 72, NULL, 'HTH_Tnp_Tc3_2', 265046),
(445953, 'PF04643', NULL, 'Motilin/ghrelin-associated peptide', 59, NULL, 'Motilin_assoc', 265047),
(445954, 'PF08774', NULL, 'VRR-NUC domain', 115, NULL, 'VRR_NUC', 265048),
(445955, 'PF12283', NULL, 'Bacteriophage protein K', 56, NULL, 'Protein_K', 265049),
(445956, 'PF12714', NULL, 'TILa domain', 55, NULL, 'TILa', 265050),
(445957, 'PF17458', NULL, 'Family of unknown function (DUF5421)', 283, NULL, 'DUF5421', 265051),
(445958, 'PF04160', NULL, 'Orf-X protein', 154, NULL, 'Borrelia_orfX', 265052),
(445959, 'PF16837', NULL, 'Pre-mRNA-splicing factor SF3A3, of SF3a complex, Prp9', 46, NULL, 'SF3A3', 265053),
(445960, 'PF01950', NULL, 'Fructose-1,6-bisphosphatase', 361, NULL, 'FBPase_3', 265054),
(445961, 'PF02590', NULL, 'Predicted SPOUT methyltransferase', 154, NULL, 'SPOUT_MTase', 265055),
(445962, 'PF01544', NULL, 'CorA-like Mg2+ transporter protein', 292, NULL, 'CorA', 265056),
(445963, 'PF04013', NULL, 'Putative SAM-dependent RNA methyltransferase', 198, NULL, 'Methyltrn_RNA_2', 265057),
(445964, 'PF02751', NULL, 'Transcription initiation factor IIA, gamma subunit', 44, NULL, 'TFIIA_gamma_C', 265058),
(445965, 'PF13655', NULL, 'N-terminal domain of reverse transcriptase', 83, NULL, 'RVT_N', 265059),
(445966, 'PF10270', NULL, 'Membrane magnesium transporter', 100, NULL, 'MMgT', 265060),
(445967, 'PF05725', NULL, 'FNIP Repeat', 44, NULL, 'FNIP', 265061),
(445968, 'PF16274', NULL, 'Qua1 domain', 52, NULL, 'Qua1', 265062),
(445969, 'PF02517', NULL, 'Type II CAAX prenyl endopeptidase Rce1-like', 92, NULL, 'Rce1-like', 265063),
(445970, 'PF07485', NULL, 'Domain of Unknown Function (DUF1259)', 121, NULL, 'DUF1529', 265064),
(445971, 'PF12618', NULL, 'Protein of unknown function (DUF3776)', 110, NULL, 'DUF3776', 265065),
(445972, 'PF13106', NULL, 'Domain of unknown function (DUF3961)', 39, NULL, 'DUF3961', 265066),
(445973, 'PF09650', NULL, 'Putative polyhydroxyalkanoic acid system protein (PHA_gran_rgn)', 87, NULL, 'PHA_gran_rgn', 265067),
(445974, 'PF13427', NULL, 'Domain of unknown function (DUF4111)', 103, NULL, 'DUF4111', 265068),
(445975, 'PF06750', NULL, 'Bacterial Peptidase A24 N-terminal domain', 84, NULL, 'DiS_P_DiS', 265069),
(445976, 'PF01664', NULL, 'Reovirus viral attachment protein sigma 1', 219, NULL, 'Reo_sigma1', 265070),
(445977, 'PF03453', NULL, 'MoeA N-terminal region (domain I and II)', 156, NULL, 'MoeA_N', 265071),
(445978, 'PF09130', NULL, 'Domain of unknown function (DUF1932)', 70, NULL, 'DUF1932', 265072),
(445979, 'PF14450', NULL, 'Cell division protein FtsA', 99, NULL, 'FtsA', 265073),
(445980, 'PF12718', NULL, 'Tropomyosin like', 143, NULL, 'Tropomyosin_1', 265074),
(445981, 'PF07254', NULL, 'Membrane-bound toxin component of toxin-antitoxin system', 133, NULL, 'Cpta_toxin', 265075),
(445982, 'PF12646', NULL, 'Domain of unknown function (DUF3783)', 56, NULL, 'DUF3783', 265076),
(445983, 'PF18857', NULL, 'Large polyvalent protein associated domain 38', 190, NULL, 'LPD38', 265077),
(445984, 'PF13886', NULL, 'Domain of unknown function (DUF4203)', 201, NULL, 'DUF4203', 265078),
(445985, 'PF11321', NULL, 'Protein of unknown function (DUF3123)', 62, NULL, 'DUF3123', 265079),
(445986, 'PF17219', NULL, 'Yaf2/RYBP C-terminal binding motif', 33, NULL, 'YAF2_RYBP', 265080),
(445987, 'PF17063', NULL, 'Phenol-soluble modulin alpha peptide family', 21, NULL, 'PSMalpha', 265081),
(445988, 'PF06586', NULL, 'TraK protein', 233, NULL, 'TraK', 265082),
(445989, 'PF03203', NULL, 'MerC mercury resistance protein', 117, NULL, 'MerC', 265083),
(445990, 'PF07206', NULL, 'Baculovirus late expression factor 10 (LEF-10)', 71, NULL, 'Baculo_LEF-10', 265084),
(445991, 'PF12157', NULL, 'Protein of unknown function (DUF3591)', 450, NULL, 'DUF3591', 265085);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(445992, 'PF00164', NULL, 'Ribosomal protein S12/S23', 114, NULL, 'Ribosom_S12_S23', 265086),
(445993, 'PF16047', NULL, 'Frog antimicrobial peptide', 21, NULL, 'Antimicrobial22', 265087),
(445994, 'PF01698', NULL, 'Floricaula / Leafy protein SAM domain', 80, NULL, 'SAM_LFY', 265088),
(445995, 'PF14573', NULL, 'Acyl-carrier', 96, NULL, 'PP-binding_2', 265089),
(445996, 'PF09810', NULL, 'Exonuclease V - a 5'' deoxyribonuclease', 370, NULL, 'Exo5', 265090),
(445997, 'PF11597', NULL, 'Mediator complex subunit 13 N-terminal', 322, NULL, 'Med13_N', 265091),
(445998, 'PF07995', NULL, 'Glucose / Sorbosone dehydrogenase', 332, NULL, 'GSDH', 265092),
(445999, 'PF19296', NULL, 'RelA/SpoT, AH and RIS domains', 185, NULL, 'RelA_AH_RIS', 265093),
(446000, 'PF03036', NULL, 'Perilipin family', 403, NULL, 'Perilipin', 265094),
(446001, 'PF11014', NULL, 'Protein of unknown function (DUF2852)', 118, NULL, 'DUF2852', 265095),
(446002, 'PF10942', NULL, 'Protein of unknown function (DUF2619)', 69, NULL, 'DUF2619', 265096),
(446003, 'PF06734', NULL, 'UL97', 182, NULL, 'UL97', 265097),
(446004, 'PF13033', NULL, 'Protein of unknown function (DUF3894)', 54, NULL, 'DUF3894', 265098),
(446005, 'PF12063', NULL, 'Domain of unknown function (DUF3543)', 267, NULL, 'DUF3543', 265099),
(446006, 'PF14972', NULL, 'Mitochondrial morphogenesis regulator', 159, NULL, 'Mito_morph_reg', 265100),
(446007, 'PF04528', NULL, 'Adenovirus early E4 34 kDa protein conserved region', 145, NULL, 'Adeno_E4_34', 265101),
(446008, 'PF16682', NULL, 'CXC domain of E3 ubiquitin-protein ligase MSL2', 55, NULL, 'MSL2-CXC', 265102),
(446009, 'PF06423', NULL, 'GWT1', 156, NULL, 'GWT1', 265103),
(446010, 'PF14411', NULL, 'A nuclease of the HNH/ENDO VII superfamily with conserved LHH', 76, NULL, 'LHH', 265104),
(446011, 'PF19191', NULL, 'HEF_HK domain', 67, NULL, 'HEF_HK', 265105),
(446012, 'PF06964', NULL, 'Alpha-L-arabinofuranosidase C-terminal domain', 168, NULL, 'Alpha-L-AF_C', 265106),
(446013, 'PF20323', NULL, 'Family of unknown function (DUF6618)', 92, NULL, 'DUF6618', 265107),
(446014, 'PF20427', NULL, 'Nuclear speckle splicing regulatory protein 1, RS-like domain', 178, NULL, 'NRP1_C', 265108),
(446015, 'PF05000', NULL, 'RNA polymerase Rpb1, domain 4', 108, NULL, 'RNA_pol_Rpb1_4', 265109),
(446016, 'PF15619', NULL, 'Ciliary protein causing Leber congenital amaurosis disease', 193, NULL, 'Lebercilin', 265110),
(446017, 'PF09048', NULL, 'Cro', 59, NULL, 'Cro', 265111),
(446018, 'PF10258', NULL, 'Phosphorylated adapter RNA export protein, RNA-binding domain', 84, NULL, 'PHAX_RNA-bd', 265112),
(446019, 'PF15666', NULL, 'Germinal center-associated lymphoma', 88, NULL, 'HGAL', 265113),
(446020, 'PF02301', NULL, 'HORMA domain', 218, NULL, 'HORMA', 265114),
(446021, 'PF04108', NULL, 'Autophagy protein ATG17-like domain', 355, NULL, 'ATG17_like', 265115),
(446022, 'PF10128', NULL, 'Glucose-6-phosphate dehydrogenase subunit N-terminal domain', 112, NULL, 'OpcA_G6PD_assem', 265116),
(446023, 'PF06986', NULL, 'Type-1V conjugative transfer system mating pair stabilisation', 240, NULL, 'TraN', 265117),
(446024, 'PF16617', NULL, 'Intersectin and clathrin adaptor AP2 binding region', 115, NULL, 'INTAP', 265118),
(446025, 'PF15901', NULL, 'Sortilin, neurotensin receptor 3, C-terminal', 171, NULL, 'Sortilin_C', 265119),
(446026, 'PF19546', NULL, 'Family of unknown function (DUF6070)', 345, NULL, 'DUF6070', 265120),
(446027, 'PF07006', NULL, 'Protein of unknown function (DUF1310)', 119, NULL, 'DUF1310', 265121),
(446028, 'PF10921', NULL, 'Protein of unknown function (DUF2710)', 104, NULL, 'DUF2710', 265122),
(446029, 'PF16246', NULL, 'Domain of unknown function (DUF4903)', 190, NULL, 'DUF4903', 265123),
(446030, 'PF07150', NULL, 'Protein of unknown function (DUF1390)', 226, NULL, 'DUF1390', 265124),
(446031, 'PF10724', NULL, 'Protein of unknown function (DUF2516)', 93, NULL, 'DUF2516', 265125),
(446032, 'PF14698', NULL, 'Argininosuccinate lyase C-terminal', 69, NULL, 'ASL_C2', 265126),
(446033, 'PF16745', NULL, 'RsgA N-terminal domain', 54, NULL, 'RsgA_N', 265127);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(446034, 'PF06006', NULL, 'Bacterial protein of unknown function (DUF905)', 70, NULL, 'DUF905', 265128),
(446035, 'PF02455', NULL, 'Hexon-associated protein (IIIa)', 511, NULL, 'Hex_IIIa', 265129),
(446036, 'PF05924', NULL, 'SAMP Motif', 22, NULL, 'SAMP', 265130),
(446037, 'PF05188', NULL, 'MutS domain II', 137, NULL, 'MutS_II', 265131),
(446038, 'PF00069', NULL, 'Protein kinase domain', 264, NULL, 'Pkinase', 265132),
(446039, 'PF13220', NULL, 'Protein of unknown function (DUF4028)', 65, NULL, 'DUF4028', 265133),
(446040, 'PF09059', NULL, 'TyeA', 81, NULL, 'TyeA', 265134),
(446041, 'PF18391', NULL, 'CHIP N-terminal tetratricopeptide repeat domain', 83, NULL, 'CHIP_TPR_N', 265135),
(446042, 'PF11727', NULL, 'Invariant surface glycoprotein', 281, NULL, 'ISG65-75', 265136),
(446043, 'PF13500', NULL, 'AAA domain', 198, NULL, 'AAA_26', 265137),
(446044, 'PF14732', NULL, 'Ubiquitin/SUMO-activating enzyme ubiquitin-like domain', 87, NULL, 'UAE_UbL', 265138),
(446045, 'PF17677', NULL, 'Glycosyl hydrolases family 38 C-terminal beta sandwich domain', 69, NULL, 'Glyco_hydro38C2', 265139),
(446046, 'PF07727', NULL, 'Reverse transcriptase (RNA-dependent DNA polymerase)', 243, NULL, 'RVT_2', 265140),
(446047, 'PF09798', NULL, 'DNA damage checkpoint protein', 613, NULL, 'LCD1', 265141),
(446048, 'PF15715', NULL, 'PCNA-associated factor histone like domain', 135, NULL, 'PAF', 265142),
(446049, 'PF08605', NULL, 'Fungal Rad9-like Rad53-binding', 129, NULL, 'Rad9_Rad53_bind', 265143),
(446050, 'PF02221', NULL, 'ML domain', 134, NULL, 'E1_DerP2_DerF2', 265144),
(446051, 'PF04735', NULL, 'Baculovirus DNA helicase', 1217, NULL, 'Baculo_helicase', 265145),
(446052, 'PF08547', NULL, 'Complex I intermediate-associated protein 30 (CIA30)', 159, NULL, 'CIA30', 265146),
(446053, 'PF10503', NULL, 'Esterase PHB depolymerase', 219, NULL, 'Esterase_PHB', 265147),
(446054, 'PF01724', NULL, 'Domain of unknown function DUF29', 138, NULL, 'DUF29', 265148),
(446055, 'PF16946', NULL, 'OMPG-porin 1 family', 294, NULL, 'Porin_OmpG_1_2', 265149),
(446056, 'PF02521', NULL, 'Putative outer membrane protein', 446, NULL, 'HP_OMP_2', 265150),
(446057, 'PF16479', NULL, 'Domain of unknown function (DUF5056)', 93, NULL, 'DUF5056', 265151),
(446058, 'PF18480', NULL, 'Domain of unknown function (DUF5615)', 77, NULL, 'DUF5615', 265152),
(446059, 'PF13198', NULL, 'Protein of unknown function (DUF4014)', 72, NULL, 'DUF4014', 265153),
(446060, 'PF20067', NULL, 'Strictosidine synthase-like, N-terminal', 46, NULL, 'SSL_N', 265154),
(446061, 'PF13175', NULL, 'AAA ATPase domain', 374, NULL, 'AAA_15', 265155),
(446062, 'PF19805', NULL, 'Family of unknown function (DUF6288)', 402, NULL, 'DUF6288', 265156),
(446063, 'PF08933', NULL, 'Domain of unknown function (DUF1864)', 387, NULL, 'DUF1864', 265157),
(446064, 'PF19716', NULL, 'Family of unknown function (DUF6211)', 92, NULL, 'DUF6211', 265158),
(446065, 'PF04871', NULL, 'Uso1 / p115 like vesicle tethering protein, C terminal region', 121, NULL, 'Uso1_p115_C', 265159),
(446066, 'PF14538', NULL, 'Raptor N-terminal CASPase like domain', 151, NULL, 'Raptor_N', 265160),
(446067, 'PF14009', NULL, 'PADRE domain', 177, NULL, 'PADRE', 265161),
(446068, 'PF19501', NULL, 'YetA-like protein', 867, NULL, 'YetA', 265162),
(446069, 'PF09577', NULL, 'Sporulation protein YpjB (SpoYpjB)', 230, NULL, 'Spore_YpjB', 265163),
(446070, 'PF01955', NULL, 'Adenosylcobinamide amidohydrolase', 191, NULL, 'CbiZ', 265164),
(446071, 'PF07663', NULL, 'Sorbitol phosphotransferase enzyme II C-terminus', 93, NULL, 'EIIBC-GUT_C', 265165),
(446072, 'PF13305', NULL, 'Tetracyclin repressor-like, C-terminal domain', 104, NULL, 'TetR_C_33', 265166),
(446073, 'PF16540', NULL, 'Arf6-interacting domain of mitotic kinesin-like protein 1', 107, NULL, 'MKLP1_Arf_bdg', 265167),
(446074, 'PF20080', NULL, 'ALTTAQ repeat', 38, NULL, 'ALTTAQ_rpt', 265168),
(446075, 'PF06574', NULL, 'FAD synthetase', 158, NULL, 'FAD_syn', 265169),
(446076, 'PF09856', NULL, 'Short-chain fatty acyl coenzyme A regulators', 157, NULL, 'ScfRs', 265170),
(446077, 'PF19066', NULL, 'Family of unknown function (DUF5762)', 69, NULL, 'DUF5762', 265171);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(446078, 'PF15296', NULL, 'Codanin-1 C-terminus', 120, NULL, 'Codanin-1_C', 265172),
(446079, 'PF18176', NULL, 'KptA in kinetoplastid DICER domain', 159, NULL, 'KptA_kDCL', 265173),
(446080, 'PF05407', NULL, 'Rubella virus endopeptidase', 164, NULL, 'Peptidase_C27', 265174),
(446081, 'PF13092', NULL, 'Kinetochore complex Sim4 subunit Fta1', 162, NULL, 'CENP-L', 265175),
(446082, 'PF14733', NULL, 'AP2-coincident C-terminal', 93, NULL, 'ACDC', 265176),
(446083, 'PF19305', NULL, 'MmgE/PrpD C-terminal domain', 173, NULL, 'MmgE_PrpD_C', 265177),
(446084, 'PF01023', NULL, 'S-100/ICaBP type calcium binding domain', 45, NULL, 'S_100', 265178),
(446085, 'PF00333', NULL, 'Ribosomal protein S5, N-terminal domain', 65, NULL, 'Ribosomal_S5', 265179),
(446086, 'PF09732', NULL, 'Cactus-binding C-terminus of cactin protein', 125, NULL, 'CactinC_cactus', 265180),
(446087, 'PF08993', NULL, 'T4 gene Gp59 loader of gp41 DNA helicase', 93, NULL, 'T4_Gp59_N', 265181),
(446088, 'PF20357', NULL, 'Family of unknown function (DUF6652)', 183, NULL, 'DUF6652', 265182),
(446089, 'PF08824', NULL, 'Serine rich protein interaction domain', 157, NULL, 'Serine_rich', 265183),
(446090, 'PF09834', NULL, 'Predicted membrane protein (DUF2061)', 52, NULL, 'DUF2061', 265184),
(446091, 'PF07279', NULL, 'Protein of unknown function (DUF1442)', 218, NULL, 'DUF1442', 265185),
(446092, 'PF05592', NULL, 'Bacterial alpha-L-rhamnosidase concanavalin-like domain', 102, NULL, 'Bac_rhamnosid', 265186),
(446093, 'PF06069', NULL, 'PerC transcriptional activator', 90, NULL, 'PerC', 265187),
(446094, 'PF05846', NULL, 'Chordopoxvirus A15 protein', 90, NULL, 'Chordopox_A15', 265188),
(446095, 'PF10994', NULL, 'Protein of unknown function (DUF2817)', 340, NULL, 'DUF2817', 265189),
(446096, 'PF04235', NULL, 'Protein of unknown function (DUF418)', 163, NULL, 'DUF418', 265190),
(446097, 'PF06923', NULL, 'Glucitol operon activator protein (GutM)', 107, NULL, 'GutM', 265191),
(446098, 'PF08858', NULL, 'IDEAL domain', 37, NULL, 'IDEAL', 265192),
(446099, 'PF19542', NULL, 'Family of unknown function (DUF6066)', 211, NULL, 'DUF6066', 265193),
(446100, 'PF03739', NULL, 'Lipopolysaccharide export system permease LptF/LptG', 354, NULL, 'LptF_LptG', 265194),
(446101, 'PF16483', NULL, 'Beta-1,3-glucanase', 373, NULL, 'Glyco_hydro_64', 265195),
(446102, 'PF02313', NULL, 'Fumarate reductase subunit D', 114, NULL, 'Fumarate_red_D', 265196),
(446103, 'PF15032', NULL, 'Protein of unknown function (DUF4529)', 406, NULL, 'DUF4529', 265197),
(446104, 'PF14767', NULL, 'Replication protein A interacting middle', 94, NULL, 'RPA_interact_M', 265198),
(446105, 'PF09671', NULL, 'Spore coat protein (Spore_GerQ)', 76, NULL, 'Spore_GerQ', 265199),
(446106, 'PF07581', NULL, 'The GLUG motif', 28, NULL, 'Glug', 265200),
(446107, 'PF20264', NULL, 'DUF4784 N-terminal Ig-like domain', 107, NULL, 'DUF4784_N', 265201),
(446108, 'PF09507', NULL, 'DNA polymerase subunit Cdc27', 427, NULL, 'CDC27', 265202),
(446109, 'PF14963', NULL, 'Get2-like', 270, NULL, 'Get2_like', 265203),
(446110, 'PF15719', NULL, 'Domain of unknown function (DUF4674)', 191, NULL, 'DUF4674', 265204),
(446111, 'PF00014', NULL, 'Kunitz/Bovine pancreatic trypsin inhibitor domain', 53, NULL, 'Kunitz_BPTI', 265205),
(446112, 'PF12363', NULL, 'Phage tail assembly chaperone protein, TAC', 111, NULL, 'Phage_TAC_12', 265206),
(446113, 'PF02679', NULL, '(2R)-phospho-3-sulfolactate synthase (ComA)', 243, NULL, 'ComA', 265207),
(446114, 'PF15148', NULL, 'Apolipoprotein F', 199, NULL, 'Apolipo_F', 265208),
(446115, 'PF11086', NULL, 'Protein of unknown function (DUF2878)', 151, NULL, 'DUF2878', 265209),
(446116, 'PF19590', NULL, 'TrbL/VirB6 plasmid conjugal transfer like protein', 377, NULL, 'TrbL_3', 265210),
(446117, 'PF15383', NULL, 'Transmembrane protein 237', 249, NULL, 'TMEM237', 265211),
(446118, 'PF16282', NULL, 'SANT/Myb-like domain of DAMP1', 80, NULL, 'SANT_DAMP1_like', 265212),
(446119, 'PF10273', NULL, 'Pre-rRNA-processing protein TSR2', 81, NULL, 'WGG', 265213),
(446120, 'PF01102', NULL, 'Glycophorin A', 114, NULL, 'Glycophorin_A', 265214);
INSERT INTO "PUBLIC"."MODEL" VALUES
(446121, 'PF11871', NULL, 'Domain of unknown function (DUF3391)', 136, NULL, 'DUF3391', 265215),
(446122, 'PF01454', NULL, 'MAGE homology domain', 212, NULL, 'MAGE', 265216),
(446123, 'PF08438', NULL, 'GTPase of unknown function C-terminal', 110, NULL, 'MMR_HSR1_C', 265217),
(446124, 'PF09875', NULL, 'Uncharacterized protein conserved in archaea (DUF2102)', 103, NULL, 'DUF2102', 265218),
(446125, 'PF14646', NULL, 'MYCBP-associated protein family', 439, NULL, 'MYCBPAP', 265219),
(446126, 'PF02368', NULL, 'Bacterial Ig-like domain (group 2)', 79, NULL, 'Big_2', 265220),
(446127, 'PF15897', NULL, 'Domain of unknown function (DUF4741)', 169, NULL, 'DUF4741', 265221),
(446128, 'PF00773', NULL, 'RNB domain', 323, NULL, 'RNB', 265222),
(446129, 'PF05930', NULL, 'Prophage CP4-57 regulatory protein (AlpA)', 51, NULL, 'Phage_AlpA', 265223),
(446130, 'PF16744', NULL, 'KIAA1045 RING finger', 73, NULL, 'zf-RING_15', 265224),
(446131, 'PF09176', NULL, 'Methylene-tetrahydromethanopterin dehydrogenase, N-terminal', 81, NULL, 'Mpt_N', 265225),
(446132, 'PF12672', NULL, 'Protein of unknown function (DUF3793)', 167, NULL, 'DUF3793', 265226),
(446133, 'PF03600', NULL, 'Citrate transporter', 296, NULL, 'CitMHS', 265227),
(446134, 'PF10974', NULL, 'Protein of unknown function (DUF2804)', 328, NULL, 'DUF2804', 265228),
(446135, 'PF11611', NULL, 'Domain of unknown function (DUF4352)', 125, NULL, 'DUF4352', 265229),
(446136, 'PF18299', NULL, 'ATP-grasp domain, R2K clade family 2', 146, NULL, 'R2K_2', 265230),
(446137, 'PF01205', NULL, 'Uncharacterized protein family UPF0029', 108, NULL, 'UPF0029', 265231),
(446138, 'PF08510', NULL, 'PIG-P', 126, NULL, 'PIG-P', 265232),
(446139, 'PF05351', NULL, 'GMP-PDE, delta subunit', 156, NULL, 'GMP_PDE_delta', 265233),
(446140, 'PF17211', NULL, 'VHL box domain', 49, NULL, 'VHL_C', 265234),
(446141, 'PF17477', NULL, 'Rotavirus VP4 membrane interaction domain', 227, NULL, 'Rota_VP4_MID', 265235),
(446142, 'PF00063', NULL, 'Myosin head (motor domain)', 677, NULL, 'Myosin_head', 265236),
(446143, 'PF00807', NULL, 'Apidaecin', 29, NULL, 'Apidaecin', 265237),
(446144, 'PF16750', NULL, 'Sensor domain of 2-component histidine kinase', 110, NULL, 'HK_sensor', 265238),
(446145, 'PF13195', NULL, 'Protein of unknown function (DUF4011)', 162, NULL, 'DUF4011', 265239),
(446146, 'PF06218', NULL, 'Nitrogen permease regulator 2', 440, NULL, 'NPR2', 265240),
(446147, 'PF05865', NULL, 'Cypovirus polyhedrin protein', 248, NULL, 'Cypo_polyhedrin', 265241),
(446148, 'PF06193', NULL, 'Orthopoxvirus A5L protein-like', 271, NULL, 'Orthopox_A5L', 265242),
(446149, 'PF02761', NULL, 'CBL proto-oncogene N-terminus, EF hand-like domain', 84, NULL, 'Cbl_N2', 265243),
(446150, 'PF18587', NULL, 'PTX/LNS-Like (PLL) domain', 134, NULL, 'PLL', 265244),
(446151, 'PF06847', NULL, 'Archaeal Peptidase A24 C-terminus Type II', 93, NULL, 'Arc_PepC_II', 265245),
(446152, 'PF07205', NULL, 'Domain of unknown function (DUF1413)', 69, NULL, 'DUF1413', 265246),
(446153, 'PF08452', NULL, 'DNA polymerase family B exonuclease domain, N-terminal', 22, NULL, 'DNAP_B_exo_N', 265247),
(446154, 'PF17389', NULL, 'Bacterial alpha-L-rhamnosidase 6 hairpin glycosidase domain', 340, NULL, 'Bac_rhamnosid6H', 265248),
(446155, 'PF08572', NULL, 'pre-mRNA processing factor 3 (PRP3)', 222, NULL, 'PRP3', 265249),
(446156, 'PF16642', NULL, 'Unstructured region on Potassium channel subunit alpha KvLQT2', 98, NULL, 'KCNQ2_u3', 265250),
(446157, 'PF13075', NULL, 'Protein of unknown function (DUF3939)', 134, NULL, 'DUF3939', 265251),
(446158, 'PF03852', NULL, 'DNA mismatch endonuclease Vsr', 74, NULL, 'Vsr', 265252),
(446159, 'PF08486', NULL, 'Stage II sporulation protein', 94, NULL, 'SpoIID', 265253),
(446160, 'PF14101', NULL, 'Domain of unknown function (DUF4275)', 139, NULL, 'DUF4275', 265254),
(446161, 'PF07432', NULL, 'Histone H1-like protein Hc1', 57, NULL, 'Hc1', 265255),
(446162, 'PF19658', NULL, 'Family of unknown function (DUF6161)', 216, NULL, 'DUF6161', 265256),
(446163, 'PF04152', NULL, 'Mre11 DNA-binding presumed domain', 179, NULL, 'Mre11_DNA_bind', 265257); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(446164, 'PF02286', NULL, 'Dehydratase large subunit', 552, NULL, 'Dehydratase_LU', 265258),
(446165, 'PF02916', NULL, 'DNA polymerase processivity factor', 116, NULL, 'DNA_PPF', 265259),
(446166, 'PF15295', NULL, 'Coiled-coil domain-containing protein 50  N-terminus', 126, NULL, 'CCDC50_N', 265260),
(446167, 'PF20542', NULL, 'Family of unknown function (DUF6757)', 54, NULL, 'DUF6757', 265261),
(446168, 'PF03532', NULL, 'OMS28 porin', 253, NULL, 'OMS28_porin', 265262),
(446169, 'PF10203', NULL, 'Cytochrome c oxidase assembly protein PET191', 67, NULL, 'Pet191_N', 265263),
(446170, 'PF13565', NULL, 'Homeodomain-like domain', 73, NULL, 'HTH_32', 265264),
(446171, 'PF04168', NULL, 'A predicted alpha-helical domain with a conserved ER motif.', 292, NULL, 'Alpha-E', 265265),
(446172, 'PF02518', NULL, 'Histidine kinase-, DNA gyrase B-, and HSP90-like ATPase', 112, NULL, 'HATPase_c', 265266),
(446173, 'PF13665', NULL, 'Toxin PAAR-like domain', 108, NULL, 'Tox-PAAR-like', 265267),
(446174, 'PF09922', NULL, 'Cell wall-active antibiotics response 4TMS YvqF', 114, NULL, 'DUF2154', 265268),
(446175, 'PF18314', NULL, 'Fatty acid synthase type I helical domain', 203, NULL, 'FAS_I_H', 265269),
(446176, 'PF15649', NULL, 'Restriction endonuclease fold toxin 7', 86, NULL, 'Tox-REase-7', 265270),
(446177, 'PF02606', NULL, 'Tetraacyldisaccharide-1-P 4''-kinase', 327, NULL, 'LpxK', 265271),
(446178, 'PF16749', NULL, 'Arterivirus nonstructural protein 7 alpha', 130, NULL, 'Arteri_nsp7a', 265272),
(446179, 'PF03071', NULL, 'GNT-I family', 434, NULL, 'GNT-I', 265273),
(446180, 'PF02883', NULL, 'Adaptin C-terminal domain', 111, NULL, 'Alpha_adaptinC2', 265274),
(446181, 'PF12110', NULL, 'Nuclear protein 96', 290, NULL, 'Nup96', 265275),
(446182, 'PF05186', NULL, 'Dpy-30 motif', 42, NULL, 'Dpy-30', 265276),
(446183, 'PF10385', NULL, 'RNA polymerase beta subunit external 1 domain', 65, NULL, 'RNA_pol_Rpb2_45', 265277),
(446184, 'PF10847', NULL, 'Protein of unknown function (DUF2656)', 141, NULL, 'DUF2656', 265278),
(446185, 'PF20017', NULL, 'vWA-MoxR associated protein middle region (VMAP-M) 15', 81, NULL, 'VMAP-M15', 265279),
(446186, 'PF00980', NULL, 'Rotavirus major capsid protein VP6', 396, NULL, 'Rota_Capsid_VP6', 265280),
(446187, 'PF04403', NULL, 'Paraquat-inducible protein A', 156, NULL, 'PqiA', 265281),
(446188, 'PF03389', NULL, 'MobA/MobL family', 225, NULL, 'MobA_MobL', 265282),
(446189, 'PF13981', NULL, 'SopA-like central domain', 127, NULL, 'SopA', 265283),
(446190, 'PF01136', NULL, 'Peptidase family U32', 233, NULL, 'Peptidase_U32', 265284),
(446191, 'PF14711', NULL, 'Respiratory nitrate reductase beta C-terminal', 81, NULL, 'Nitr_red_bet_C', 265285),
(446192, 'PF11418', NULL, 'Phi29 scaffolding protein', 99, NULL, 'Scaffolding_pro', 265286),
(446193, 'PF09861', NULL, 'Lactate racemase N-terminal domain', 204, NULL, 'Lar_N', 265287),
(446194, 'PF14362', NULL, 'Domain of unknown function (DUF4407)', 298, NULL, 'DUF4407', 265288),
(446195, 'PF14125', NULL, 'Domain of unknown function (DUF4292)', 210, NULL, 'DUF4292', 265289),
(446196, 'PF12863', NULL, 'Domain of unknown function (DUF3821)', 209, NULL, 'DUF3821', 265290),
(446197, 'PF04384', NULL, 'Iron-sulphur cluster assembly', 64, NULL, 'Fe-S_assembly', 265291),
(446198, 'PF10806', NULL, 'SAM35, subunit of SAM coomplex', 127, NULL, 'SAM35', 265292),
(446199, 'PF15971', NULL, 'DolP-mannose mannosyltransferase', 163, NULL, 'Mannosyl_trans4', 265293),
(446200, 'PF20230', NULL, 'Family of unknown function (DUF6588)', 321, NULL, 'DUF6588', 265294),
(446201, 'PF20235', NULL, 'Family of unknown function (DUF6592)', 123, NULL, 'DUF6592', 265295),
(446202, 'PF13228', NULL, 'Domain of unknown function (DUF4037)', 101, NULL, 'DUF4037', 265296),
(446203, 'PF19809', NULL, 'Family of unknown function (DUF6292)', 89, NULL, 'DUF6292', 265297),
(446204, 'PF19022', NULL, 'Family of unknown function (DUF5748)', 101, NULL, 'DUF5748', 265298),
(446205, 'PF05349', NULL, 'GATA-type transcription activator, N-terminal', 176, NULL, 'GATA-N', 265299),
(446206, 'PF11124', NULL, 'Inorganic phosphate transporter chaperone Pho86', 295, NULL, 'Pho86', 265300);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(446207, 'PF11441', NULL, 'Pilot protein MxiM', 115, NULL, 'MxiM', 265301),
(446208, 'PF05478', NULL, 'Prominin', 799, NULL, 'Prominin', 265302),
(446209, 'PF13695', NULL, 'Zinc-binding domain', 100, NULL, 'zf-3CxxC', 265303),
(446210, 'PF07330', NULL, 'Protein of unknown function (DUF1467)', 83, NULL, 'DUF1467', 265304),
(446211, 'PF14071', NULL, 'Putative coat protein', 127, NULL, 'YlbD_coat', 265305),
(446212, 'PF04973', NULL, 'Nicotinamide mononucleotide transporter', 176, NULL, 'NMN_transporter', 265306),
(446213, 'PF18776', NULL, 'Hexapeptide repeat including loop', 24, NULL, 'Hexapep_loop', 265307),
(446214, 'PF16093', NULL, 'Proteasome assembly chaperone 4', 80, NULL, 'PAC4', 265308),
(446215, 'PF18600', NULL, 'MCSS domain', 53, NULL, 'Ezh2_MCSS', 265309),
(446216, 'PF12392', NULL, 'Collagenase', 107, NULL, 'DUF3656', 265310),
(446217, 'PF16043', NULL, 'Domain of unknown function (DUF4795)', 207, NULL, 'DUF4795', 265311),
(446218, 'PF16968', NULL, 'Pilus assembly protein TadZ N-terminal', 133, NULL, 'TadZ_N', 265312),
(446219, 'PF03295', NULL, 'Poxvirus trans-activator protein A1 C-terminal', 63, NULL, 'Pox_TAA1', 265313),
(446220, 'PF05942', NULL, 'Archaeal PaREP1/PaREP8 family', 115, NULL, 'PaREP1', 265314),
(446221, 'PF16995', NULL, 'Transmembrane region of lysyl-tRNA synthetase', 215, NULL, 'tRNA-synt_2_TM', 265315),
(446222, 'PF19158', NULL, 'Family of unknown function (DUF5840)', 49, NULL, 'DUF5840', 265316),
(446223, 'PF14717', NULL, 'Domain of unknown function (DUF4465)', 181, NULL, 'DUF4465', 265317),
(446224, 'PF19794', NULL, 'Family of unknown function (DUF6278)', 146, NULL, 'DUF6278', 265318),
(446225, 'PF19612', NULL, 'Family of unknown function (DUF6117)', 87, NULL, 'DUF6117', 265319),
(446226, 'PF12498', NULL, 'Basic leucine-zipper C terminal', 122, NULL, 'bZIP_C', 265320),
(446227, 'PF07648', NULL, 'Kazal-type serine protease inhibitor domain', 49, NULL, 'Kazal_2', 265321),
(446228, 'PF14316', NULL, 'Domain of unknown function (DUF4381)', 146, NULL, 'DUF4381', 265322),
(446229, 'PF17489', NULL, 'L1 transposable element trimerization domain', 43, NULL, 'Tnp_22_trimer', 265323),
(446230, 'PF15589', NULL, 'Immunity protein 21', 155, NULL, 'Imm21', 265324),
(446231, 'PF10344', NULL, 'Mitochondrial protein from FMP27', 873, NULL, 'Fmp27', 265325),
(446232, 'PF05037', NULL, 'Protein of unknown function (DUF669)', 140, NULL, 'DUF669', 265326),
(446233, 'PF15732', NULL, 'Domain of unknown function (DUF4681)', 125, NULL, 'DUF4681', 265327),
(446234, 'PF06826', NULL, 'Predicted Permease Membrane Region', 167, NULL, 'Asp-Al_Ex', 265328),
(446235, 'PF12550', NULL, 'Transcriptional activator of glycolytic enzymes', 80, NULL, 'GCR1_C', 265329),
(446236, 'PF19276', NULL, 'HD associated region', 222, NULL, 'HD_assoc_2', 265330),
(446237, 'PF19688', NULL, 'Family of unknown function (DUF6189)', 102, NULL, 'DUF6189', 265331),
(446238, 'PF13708', NULL, 'Domain of unknown function (DUF4942)', 193, NULL, 'DUF4942', 265332),
(446239, 'PF19765', NULL, 'Family of unknown function (DUF6252)', 126, NULL, 'DUF6252', 265333),
(446240, 'PF02672', NULL, 'CP12 domain', 70, NULL, 'CP12', 265334),
(446241, 'PF07850', NULL, 'Renin receptor-like protein', 100, NULL, 'Renin_r', 265335),
(446242, 'PF00868', NULL, 'Transglutaminase family', 114, NULL, 'Transglut_N', 265336),
(446243, 'PF01326', NULL, 'Pyruvate phosphate dikinase, AMP/ATP-binding domain', 328, NULL, 'PPDK_N', 265337),
(446244, 'PF12320', NULL, 'Type 5 capsule protein repressor C-terminal domain', 92, NULL, 'SbcD_C', 265338),
(446245, 'PF11634', NULL, 'Nuclease inhibitor from bacteriophage T4', 76, NULL, 'IPI_T4', 265339),
(446246, 'PF11977', NULL, 'Zc3h12a-like Ribonuclease NYN domain', 156, NULL, 'RNase_Zc3h12a', 265340),
(446247, 'PF15916', NULL, 'Domain of unknown function (DUF4743)', 121, NULL, 'DUF4743', 265341),
(446248, 'PF15672', NULL, 'Cell-membrane associated Mucin15', 315, NULL, 'Mucin15', 265342),
(446249, 'PF02510', NULL, 'Surface presentation of antigens protein', 336, NULL, 'SPAN', 265343),
(446250, 'PF11733', NULL, 'Non-capsid protein NP1', 213, NULL, 'NP1-WLL', 265344);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(446251, 'PF07138', NULL, 'Baculovirus protein AC11', 334, NULL, 'AcMNPV_AC11', 265345),
(446252, 'PF03107', NULL, 'C1 domain', 47, NULL, 'C1_2', 265346),
(446253, 'PF13190', NULL, 'PDGLE domain', 102, NULL, 'PDGLE', 265347),
(446254, 'PF02136', NULL, 'Nuclear transport factor 2 (NTF2) domain', 120, NULL, 'NTF2', 265348),
(446255, 'PF03994', NULL, 'Domain of Unknown Function (DUF350)', 54, NULL, 'DUF350', 265349),
(446256, 'PF06534', NULL, 'Repulsive guidance molecule (RGM) C-terminus', 173, NULL, 'RGM_C', 265350),
(446257, 'PF20484', NULL, 'Family of unknown function (DUF6723)', 73, NULL, 'DUF6723', 265351),
(446258, 'PF05030', NULL, 'SSXT protein (N-terminal region)', 62, NULL, 'SSXT', 265352),
(446259, 'PF13224', NULL, 'Domain of unknown function (DUF4032)', 163, NULL, 'DUF4032', 265353),
(446260, 'PF20327', NULL, 'Family of unknown function (DUF6622)', 183, NULL, 'DUF6622', 265354),
(446261, 'PF06581', NULL, 'Mad1 and Cdc20-bound-Mad2 binding', 265, NULL, 'p31comet', 265355),
(446262, 'PF14288', NULL, '1,3-beta-glucan synthase subunit FKS1, domain-1', 119, NULL, 'FKS1_dom1', 265356),
(446263, 'PF05868', NULL, 'Rotavirus major outer capsid protein VP7', 249, NULL, 'Rotavirus_VP7', 265357),
(446264, 'PF08973', NULL, 'Domain of unknown function (DUF1893)', 130, NULL, 'TM1506', 265358),
(446265, 'PF11184', NULL, 'Protein of unknown function (DUF2969)', 71, NULL, 'DUF2969', 265359),
(446266, 'PF05154', NULL, 'TM2 domain', 51, NULL, 'TM2', 265360),
(446267, 'PF08428', NULL, 'Rib domain', 76, NULL, 'Rib', 265361),
(446268, 'PF11754', NULL, 'Velvet factor', 242, NULL, 'Velvet', 265362),
(446269, 'PF14886', NULL, 'FAM183A and FAM183B related', 108, NULL, 'FAM183', 265363),
(446270, 'PF00090', NULL, 'Thrombospondin type 1 domain', 49, NULL, 'TSP_1', 265364),
(446271, 'PF04298', NULL, 'Putative neutral zinc metallopeptidase', 218, NULL, 'Zn_peptidase_2', 265365),
(446272, 'PF15968', NULL, 'Membrane-anchored ion channel, Abi component', 139, NULL, 'RexB', 265366),
(446273, 'PF10831', NULL, 'Protein of unknown function (DUF2556)', 53, NULL, 'DUF2556', 265367),
(446274, 'PF05483', NULL, 'Synaptonemal complex protein 1 (SCP-1)', 786, NULL, 'SCP-1', 265368),
(446275, 'PF17848', NULL, 'Acetyl-coA carboxylase zinc finger domain', 26, NULL, 'zf-ACC', 265369),
(446276, 'PF17802', NULL, 'Prealbumin-like fold domain', 69, NULL, 'SpaA', 265370),
(446277, 'PF17639', NULL, 'Family of unknown function (DUF5517)', 100, NULL, 'DUF5517', 265371),
(446278, 'PF11913', NULL, 'Protein of unknown function (DUF3431)', 215, NULL, 'DUF3431', 265372),
(446279, 'PF19407', NULL, 'Domain of unknown function (DUF5979)', 107, NULL, 'DUF5979', 265373),
(446280, 'PF07510', NULL, 'Protein of unknown function (DUF1524)', 139, NULL, 'DUF1524', 265374),
(446281, 'PF06140', NULL, 'Interferon-induced 6-16 family', 79, NULL, 'Ifi-6-16', 265375),
(446282, 'PF06952', NULL, 'PsiA protein', 237, NULL, 'PsiA', 265376),
(446283, 'PF15051', NULL, 'FAM198 protein', 321, NULL, 'FAM198', 265377),
(446284, 'PF18433', NULL, 'Domain of unknown function (DUF5610)', 118, NULL, 'DUF5610', 265378),
(446285, 'PF08300', NULL, 'Hepatitis C virus non-structural 5a zinc finger domain', 62, NULL, 'HCV_NS5a_1a', 265379),
(446286, 'PF18459', NULL, 'Proprotein convertase subtilisin-like/kexin type 9 C-terminal domain', 83, NULL, 'PCSK9_C1', 265380),
(446287, 'PF08995', NULL, 'Necrosis inducing protein-1', 82, NULL, 'NIP_1', 265381),
(446288, 'PF08176', NULL, 'Small acid-soluble spore protein K family', 47, NULL, 'SspK', 265382),
(446289, 'PF09190', NULL, 'DALR domain', 63, NULL, 'DALR_2', 265383),
(446290, 'PF12097', NULL, 'Protein of unknown function (DUF3573)', 383, NULL, 'DUF3573', 265384),
(446291, 'PF09123', NULL, 'Domain of unknown function (DUF1931)', 138, NULL, 'DUF1931', 265385),
(446292, 'PF11169', NULL, 'Protein of unknown function (DUF2956)', 102, NULL, 'DUF2956', 265386),
(446293, 'PF17951', NULL, 'Fatty acid synthase meander beta sheet domain', 146, NULL, 'FAS_meander', 265387),
(446294, 'PF05563', NULL, 'Salmonella plasmid virulence protein SpvD', 212, NULL, 'SpvD', 265388);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(446295, 'PF14276', NULL, 'Domain of unknown function (DUF4363)', 107, NULL, 'DUF4363', 265389),
(446296, 'PF11674', NULL, 'Protein of unknown function (DUF3270)', 88, NULL, 'DUF3270', 265390),
(446297, 'PF08026', NULL, 'Bee antimicrobial peptide', 31, NULL, 'Antimicrobial_5', 265391),
(446298, 'PF05925', NULL, 'Enterobacterial virulence protein IpgD', 559, NULL, 'IpgD', 265392),
(446299, 'PF15712', NULL, 'NPAT C terminus', 680, NULL, 'NPAT_C', 265393),
(446300, 'PF02249', NULL, 'Methyl-coenzyme M reductase alpha subunit, C-terminal domain', 127, NULL, 'MCR_alpha', 265394),
(446301, 'PF08651', NULL, 'DASH complex subunit Duo1', 74, NULL, 'DASH_Duo1', 265395),
(446302, 'PF12014', NULL, 'Cyclin D1 binding domain', 153, NULL, 'Cyclin_D1_bind', 265396),
(446303, 'PF08336', NULL, 'Prolyl 4-Hydroxylase alpha-subunit, N-terminal region', 135, NULL, 'P4Ha_N', 265397),
(446304, 'PF20509', NULL, 'Family of unknown function (DUF6735)', 204, NULL, 'DUF6735', 265398),
(446305, 'PF09593', NULL, 'Beta-satellite pathogenicity beta C1 protein', 117, NULL, 'Pathogen_betaC1', 265399),
(446306, 'PF20417', NULL, 'Gemin6 C-terminal domain', 80, NULL, 'Gemin6_C', 265400),
(446307, 'PF08623', NULL, 'TATA-binding protein interacting (TIP20)', 168, NULL, 'TIP120', 265401),
(446308, 'PF15565', NULL, 'Immunity protein 30', 98, NULL, 'Imm30', 265402),
(446309, 'PF08952', NULL, 'Domain of unknown function (DUF1866)', 146, NULL, 'DUF1866', 265403),
(446310, 'PF07544', NULL, 'RNA polymerase II transcription mediator complex subunit 9', 80, NULL, 'Med9', 265404),
(446311, 'PF18942', NULL, 'Family of unknown function (DUF5689)', 220, NULL, 'DUF5689', 265405),
(446312, 'PF15169', NULL, 'Cytochrome b-245 chaperone 1 / Eros', 184, NULL, 'Cybc1_Eros', 265406),
(446313, 'PF11105', NULL, 'Arthropod cardioacceleratory peptide 2a', 128, NULL, 'CCAP', 265407),
(446314, 'PF00985', NULL, 'Merozoite Surface Antigen 2 (MSA-2) family', 171, NULL, 'MSA_2', 265408),
(446315, 'PF10368', NULL, 'Putative cell-wall binding lipoprotein', 186, NULL, 'YkyA', 265409),
(446316, 'PF18581', NULL, 'Synaptonemal complex 2 armadillo-repeat-like domain', 175, NULL, 'SYCP2_ARLD', 265410),
(446317, 'PF06217', NULL, 'GAGA binding protein-like family', 295, NULL, 'GAGA_bind', 265411),
(446318, 'PF05751', NULL, 'FixH', 146, NULL, 'FixH', 265412),
(446319, 'PF18087', NULL, 'Rubisco Assembly chaperone C-terminal domain', 138, NULL, 'RuBisCo_chap_C', 265413),
(446320, 'PF01847', NULL, 'VHL beta domain', 82, NULL, 'VHL', 265414),
(446321, 'PF10584', NULL, 'Proteasome subunit A N-terminal signature', 23, NULL, 'Proteasome_A_N', 265415),
(446322, 'PF00891', NULL, 'O-methyltransferase domain', 210, NULL, 'Methyltransf_2', 265416),
(446323, 'PF01904', NULL, 'Protein of unknown function DUF72', 218, NULL, 'DUF72', 265417),
(446324, 'PF19149', NULL, 'Family of unknown function (DUF5831)', 72, NULL, 'DUF5831', 265418),
(446325, 'PF02699', NULL, 'Preprotein translocase subunit', 80, NULL, 'YajC', 265419),
(446326, 'PF17520', NULL, 'Family of unknown function (DUF5445)', 52, NULL, 'DUF5445', 265420),
(446327, 'PF08089', NULL, 'Huwentoxin-II family', 39, NULL, 'Toxin_20', 265421),
(446328, 'PF17279', NULL, 'Family of unknown function (DUF5344)', 87, NULL, 'DUF5344', 265422),
(446329, 'PF08068', NULL, 'DKCLD (NUC011) domain', 58, NULL, 'DKCLD', 265423),
(446330, 'PF18458', NULL, 'Xeroderma pigmentosum group B helicase damage recognition domain', 57, NULL, 'XPB_DRD', 265424),
(446331, 'PF01677', NULL, 'Herpesvirus UL7 like', 214, NULL, 'Herpes_UL7', 265425),
(446332, 'PF20126', NULL, 'Family of unknown function (DUF6516)', 85, NULL, 'DUF6516', 265426),
(446333, 'PF17179', NULL, '4Fe-4S dicluster domain', 96, NULL, 'Fer4_22', 265427),
(446334, 'PF05326', NULL, 'Seminal vesicle autoantigen (SVA)', 124, NULL, 'SVA', 265428),
(446335, 'PF06230', NULL, 'LpxI C-terminal domain', 133, NULL, 'LpxI_C', 265429),
(446336, 'PF12093', NULL, 'Betacoronavirus NS8 protein', 118, NULL, 'bCoV_NS8', 265430),
(446337, 'PF13045', NULL, 'Protein of unknown function (DUF3905)', 84, NULL, 'DUF3905', 265431);
INSERT INTO "PUBLIC"."MODEL" VALUES
(446338, 'PF18989', NULL, 'Family of unknown function (DUF5722)', 393, NULL, 'DUF5722', 265432),
(446339, 'PF04418', NULL, 'Domain of unknown function (DUF543)', 75, NULL, 'DUF543', 265433),
(446340, 'PF11862', NULL, 'Domain of unknown function (DUF3382)', 97, NULL, 'DUF3382', 265434),
(446341, 'PF16064', NULL, 'Domain of unknown function (DUF4806)', 90, NULL, 'DUF4806', 265435),
(446342, 'PF20411', NULL, 'Domain of unknown function (DUF6697)', 178, NULL, 'DUF6697', 265436),
(446343, 'PF03530', NULL, 'Calcium-activated SK potassium channel', 118, NULL, 'SK_channel', 265437),
(446344, 'PF13912', NULL, 'C2H2-type zinc finger', 27, NULL, 'zf-C2H2_6', 265438),
(446345, 'PF12020', NULL, 'TAFA family', 89, NULL, 'TAFA', 265439),
(446346, 'PF06851', NULL, 'Protein of unknown function (DUF1247)', 149, NULL, 'DUF1247', 265440),
(446347, 'PF13531', NULL, 'Bacterial extracellular solute-binding protein', 230, NULL, 'SBP_bac_11', 265441),
(446348, 'PF16985', NULL, 'Domain of unknown function (DUF5086)', 134, NULL, 'DUF5086', 265442),
(446349, 'PF09354', NULL, 'HNF3 C-terminal domain', 67, NULL, 'HNF_C', 265443),
(446350, 'PF04360', NULL, 'Serglycin', 149, NULL, 'Serglycin', 265444),
(446351, 'PF00973', NULL, 'Paramyxovirus nucleocapsid protein', 524, NULL, 'Paramyxo_ncap', 265445),
(446352, 'PF08350', NULL, 'Methanogenesis regulatory protein FilR1, middle domain', 62, NULL, 'FilR1_middle', 265446),
(446353, 'PF12924', NULL, 'Copper-binding of amyloid precursor, CuBD', 57, NULL, 'APP_Cu_bd', 265447),
(446354, 'PF19154', NULL, 'Family of unknown function (DUF5836)', 38, NULL, 'DUF5836', 265448),
(446355, 'PF00759', NULL, 'Glycosyl hydrolase family 9', 440, NULL, 'Glyco_hydro_9', 265449),
(446356, 'PF05639', NULL, 'Pup-like protein', 69, NULL, 'Pup', 265450),
(446357, 'PF19367', NULL, 'Domain of unknown function (DUF5943)', 96, NULL, 'DUF5943', 265451),
(446358, 'PF19670', NULL, 'Family of unknown function (DUF6173)', 102, NULL, 'DUF6173', 265452),
(446359, 'PF13781', NULL, 'DoxX-like family', 102, NULL, 'DoxX_3', 265453),
(446360, 'PF15882', NULL, 'Domain of unknown function (DUF4735)', 285, NULL, 'DUF4735', 265454),
(446361, 'PF01144', NULL, 'Coenzyme A transferase', 217, NULL, 'CoA_trans', 265455),
(446362, 'PF05367', NULL, 'Phage endonuclease I', 149, NULL, 'Phage_endo_I', 265456),
(446363, 'PF18149', NULL, 'N-terminal helicase PWI domain', 111, NULL, 'Helicase_PWI', 265457),
(446364, 'PF18912', NULL, 'Double zinc ribbon domain', 56, NULL, 'DZR_2', 265458),
(446365, 'PF14318', NULL, 'Mononegavirales mRNA-capping region V', 247, NULL, 'Mononeg_mRNAcap', 265459),
(446366, 'PF17924', NULL, 'Tetracyclin repressor-like, C-terminal domain', 117, NULL, 'TetR_C_19', 265460),
(446367, 'PF00591', NULL, 'Glycosyl transferase family, a/b domain', 253, NULL, 'Glycos_transf_3', 265461),
(446368, 'PF11327', NULL, 'Egh16-like virulence factor', 183, NULL, 'Egh16-like', 265462),
(446369, 'PF00309', NULL, 'Sigma-54 factor, Activator interacting domain (AID)', 46, NULL, 'Sigma54_AID', 265463),
(446370, 'PF06128', NULL, 'Shigella flexneri OspC protein', 292, NULL, 'Shigella_OspC', 265464),
(446371, 'PF15862', NULL, 'Coilin N-terminus', 136, NULL, 'Coilin_N', 265465),
(446372, 'PF03725', NULL, '3'' exoribonuclease family, domain 2', 67, NULL, 'RNase_PH_C', 265466),
(446373, 'PF16396', NULL, 'Domain of unknown function (DUF5005)', 437, NULL, 'DUF5005', 265467),
(446374, 'PF17153', NULL, 'Periplasmic sensor domain, extracellular', 116, NULL, 'CHASE9', 265468),
(446375, 'PF17551', NULL, 'Family of unknown function (DUF5463)', 32, NULL, 'DUF5463', 265469),
(446376, 'PF18134', NULL, 'Adenylyl/Guanylyl and SMODS C-terminal sensor domain', 128, NULL, 'AGS_C', 265470),
(446377, 'PF14231', NULL, 'GXWXG protein', 59, NULL, 'GXWXG', 265471),
(446378, 'PF18260', NULL, 'Nuclear polyadenylated RNA-binding 2 protein CCCH zinc finger 1', 26, NULL, 'Nab2p_Zf1', 265472),
(446379, 'PF18343', NULL, 'Dda helicase SH3 domain', 130, NULL, 'SH3_14', 265473),
(446380, 'PF10600', NULL, 'PDZ-associated domain of NMDA receptors', 70, NULL, 'PDZ_assoc', 265474);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(446381, 'PF00894', NULL, 'Luteovirus coat protein', 138, NULL, 'Luteo_coat', 265475),
(446382, 'PF17821', NULL, 'Family of unknown function (DUF5583)', 130, NULL, 'DUF5583', 265476),
(446383, 'PF15612', NULL, 'WSTF, HB1, Itc1p, MBD9 motif 1', 46, NULL, 'WHIM1', 265477),
(446384, 'PF16743', NULL, 'Periplasmic lysozyme inhibitor of I-type lysozyme', 123, NULL, 'PliI', 265478),
(446385, 'PF18346', NULL, 'Mind bomb SH3 repeat domain', 68, NULL, 'SH3_15', 265479),
(446386, 'PF15489', NULL, 'CST, telomere maintenance, complex subunit CTC1', 1139, NULL, 'CTC1', 265480),
(446387, 'PF09447', NULL, 'Cnl2/NKP2 family protein', 65, NULL, 'Cnl2_NKP2', 265481),
(446388, 'PF05760', NULL, 'Immediate early response protein (IER)', 318, NULL, 'IER', 265482),
(446389, 'PF08102', NULL, 'Scorpion antimicrobial peptide', 43, NULL, 'Antimicrobial_7', 265483),
(446390, 'PF05100', NULL, 'Phage minor tail protein L', 206, NULL, 'Phage_tail_L', 265484),
(446391, 'PF18047', NULL, 'PatG Domain', 118, NULL, 'PatG_D', 265485),
(446392, 'PF07599', NULL, 'Protein of unknown function (DUF1563)', 43, NULL, 'DUF1563', 265486),
(446393, 'PF18985', NULL, 'Family of unknown function (DUF5718)', 250, NULL, 'DUF5718', 265487),
(446394, 'PF06834', NULL, 'TraU protein', 308, NULL, 'TraU', 265488),
(446395, 'PF02516', NULL, 'Oligosaccharyl transferase STT3 subunit', 488, NULL, 'STT3', 265489),
(446396, 'PF09597', NULL, 'IGR protein motif', 55, NULL, 'IGR', 265490),
(446397, 'PF11919', NULL, 'Domain of unknown function (DUF3437)', 88, NULL, 'DUF3437', 265491),
(446398, 'PF11801', NULL, 'Tom37 C-terminal domain', 147, NULL, 'Tom37_C', 265492),
(446399, 'PF06372', NULL, 'Gemin6 Sm-like domain', 86, NULL, 'Gemin6', 265493),
(446400, 'PF08229', NULL, 'ER membrane protein SH3', 188, NULL, 'SHR3_chaperone', 265494),
(446401, 'PF03336', NULL, 'Poxvirus C4/C10 protein', 322, NULL, 'Pox_C4_C10', 265495),
(446402, 'PF05043', NULL, 'Mga helix-turn-helix domain', 87, NULL, 'Mga', 265496),
(446403, 'PF16167', NULL, 'Domain of unknown function (DUF4871)', 128, NULL, 'DUF4871', 265497),
(446404, 'PF17411', NULL, 'Type II site-specific deoxyribonuclease', 241, NULL, 'SmaI', 265498),
(446405, 'PF08331', NULL, 'Epoxyqueuosine reductase QueG, DUF1730', 76, NULL, 'QueG_DUF1730', 265499),
(446406, 'PF11980', NULL, 'C-terminal domain of neuropilin glycoprotein', 82, NULL, 'DUF3481', 265500),
(446407, 'PF01796', NULL, 'DUF35 OB-fold domain, acyl-CoA-associated', 65, NULL, 'OB_aCoA_assoc', 265501),
(446408, 'PF03649', NULL, 'Uncharacterised protein family (UPF0014)', 242, NULL, 'UPF0014', 265502),
(446409, 'PF16597', NULL, 'Thyroglobulin_1 repeat associated disordered domain', 61, NULL, 'Thyroglob_assoc', 265503),
(446410, 'PF20014', NULL, 'GTPase-associated protein 1, middle domain', 101, NULL, 'GAP1-M', 265504),
(446411, 'PF12019', NULL, 'Type II transport protein GspH', 110, NULL, 'GspH', 265505),
(446412, 'PF03867', NULL, 'Fushi tarazu (FTZ), N-terminal region', 269, NULL, 'FTZ', 265506),
(446413, 'PF01603', NULL, 'Protein phosphatase 2A regulatory B subunit (B56 family)', 413, NULL, 'B56', 265507),
(446414, 'PF15929', NULL, 'Myofilin', 148, NULL, 'Myofilin', 265508),
(446415, 'PF04426', NULL, 'Bul1 C terminus', 272, NULL, 'Bul1_C', 265509),
(446416, 'PF04287', NULL, 'tRNA pseudouridine synthase C', 98, NULL, 'DUF446', 265510),
(446417, 'PF07093', NULL, 'SGT1 protein', 584, NULL, 'SGT1', 265511),
(446418, 'PF00304', NULL, 'Gamma-thionin family', 47, NULL, 'Gamma-thionin', 265512),
(446419, 'PF02665', NULL, 'Nitrate reductase gamma subunit', 217, NULL, 'Nitrate_red_gam', 265513),
(446420, 'PF17808', NULL, 'Fn3-like domain from Purple Acid Phosphatase', 118, NULL, 'fn3_PAP', 265514),
(446421, 'PF18823', NULL, 'Inorganic Pyrophosphatase', 135, NULL, 'InPase', 265515),
(446422, 'PF08148', NULL, 'DSHCT (NUC185) domain', 162, NULL, 'DSHCT', 265516),
(446423, 'PF00569', NULL, 'Zinc finger, ZZ type', 45, NULL, 'ZZ', 265517),
(446424, 'PF08527', NULL, 'Protein-arginine deiminase (PAD) middle domain', 159, NULL, 'PAD_M', 265518),
(446425, 'PF01358', NULL, 'Poly A polymerase regulatory subunit', 291, NULL, 'PARP_regulatory', 265519);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(446426, 'PF07923', NULL, 'N1221-like protein', 289, NULL, 'N1221', 265520),
(446427, 'PF13244', NULL, 'MBH, subunit D', 67, NULL, 'MbhD', 265521),
(446428, 'PF15935', NULL, 'RNase LS, bacterial toxin', 87, NULL, 'RnlA_toxin', 265522),
(446429, 'PF20288', NULL, 'ABC-three component (ABC-3C) system Middle Component 2', 145, NULL, 'MC2', 265523),
(446430, 'PF01914', NULL, 'MarC family integral membrane protein', 203, NULL, 'MarC', 265524),
(446431, 'PF11809', NULL, 'Domain of unknown function (DUF3330)', 69, NULL, 'DUF3330', 265525),
(446432, 'PF02583', NULL, 'Metal-sensitive transcriptional repressor', 77, NULL, 'Trns_repr_metal', 265526),
(446433, 'PF06321', NULL, 'Major fimbrial subunit protein (FimA)', 156, NULL, 'P_gingi_FimA', 265527),
(446434, 'PF05586', NULL, 'Anthrax receptor C-terminus region', 93, NULL, 'Ant_C', 265528),
(446435, 'PF12804', NULL, 'MobA-like NTP transferase domain', 160, NULL, 'NTP_transf_3', 265529),
(446436, 'PF12930', NULL, 'Family of unknown function (DUF3836)', 127, NULL, 'DUF3836', 265530),
(446437, 'PF08941', NULL, 'USP8 interacting', 179, NULL, 'USP8_interact', 265531),
(446438, 'PF05151', NULL, 'Photosystem II reaction centre M protein (PsbM)', 31, NULL, 'PsbM', 265532),
(446439, 'PF10396', NULL, 'GTP-binding protein TrmE N-terminus', 117, NULL, 'TrmE_N', 265533),
(446440, 'PF18252', NULL, 'Copper(I)-binding protein CorA', 175, NULL, 'Cu_bind_CorA', 265534),
(446441, 'PF06057', NULL, 'Bacterial virulence protein (VirJ)', 192, NULL, 'VirJ', 265535),
(446442, 'PF04613', NULL, 'UDP-3-O-[3-hydroxymyristoyl] glucosamine N-acyltransferase, LpxD', 70, NULL, 'LpxD', 265536),
(446443, 'PF05129', NULL, 'Transcription elongation factor Elf1 like', 78, NULL, 'Elf1', 265537),
(446444, 'PF11278', NULL, 'Protein of unknown function (DUF3079)', 51, NULL, 'DUF3079', 265538),
(446445, 'PF12466', NULL, 'Glutamate dehydrogenase N terminal', 95, NULL, 'GDH_N', 265539),
(446446, 'PF01878', NULL, 'EVE domain', 145, NULL, 'EVE', 265540),
(446447, 'PF01248', NULL, 'Ribosomal protein L7Ae/L30e/S12e/Gadd45 family', 95, NULL, 'Ribosomal_L7Ae', 265541),
(446448, 'PF18662', NULL, 'Cch helix turn helix domain', 111, NULL, 'HTH_56', 265542),
(446449, 'PF06400', NULL, 'Alpha-2-macroglobulin RAP, N-terminal domain', 123, NULL, 'Alpha-2-MRAP_N', 265543),
(446450, 'PF15936', NULL, 'Domain of unknown function (DUF4749)', 98, NULL, 'DUF4749', 265544),
(446451, 'PF07631', NULL, 'Protein of unknown function (DUF1592)', 128, NULL, 'PSD4', 265545),
(446452, 'PF16538', NULL, 'Flagellar assembly protein T, C-terminal domain', 77, NULL, 'FlgT_C', 265546),
(446453, 'PF04962', NULL, 'KduI/IolB family', 261, NULL, 'KduI', 265547),
(446454, 'PF07618', NULL, 'Protein of unknown function (DUF1580)', 57, NULL, 'DUF1580', 265548),
(446455, 'PF01316', NULL, 'Arginine repressor, DNA binding domain', 70, NULL, 'Arg_repressor', 265549),
(446456, 'PF13439', NULL, 'Glycosyltransferase Family 4', 170, NULL, 'Glyco_transf_4', 265550),
(446457, 'PF18070', NULL, 'CRISPR-Cas9 PI domain', 59, NULL, 'Cas9_PI2', 265551),
(446458, 'PF11299', NULL, 'Protein of unknown function (DUF3100)', 235, NULL, 'DUF3100', 265552),
(446459, 'PF05240', NULL, 'APOBEC-like C-terminal domain', 78, NULL, 'APOBEC_C', 265553),
(446460, 'PF17313', NULL, 'Family of unknown function (DUF5359)', 56, NULL, 'DUF5359', 265554),
(446461, 'PF00286', NULL, 'Viral coat protein', 138, NULL, 'Flexi_CP', 265555),
(446462, 'PF07576', NULL, 'BRCA1-associated protein 2', 99, NULL, 'BRAP2', 265556),
(446463, 'PF16942', NULL, 'Putative cyclic bacteriocin', 103, NULL, 'CclA_1', 265557),
(446464, 'PF15512', NULL, 'Chromatin assembly factor complex 1 subunit p60, C-terminal', 174, NULL, 'CAF-1_p60_C', 265558),
(446465, 'PF04216', NULL, 'Protein involved in formate dehydrogenase formation', 287, NULL, 'FdhE', 265559),
(446466, 'PF02899', NULL, 'Phage integrase, N-terminal SAM-like domain', 83, NULL, 'Phage_int_SAM_1', 265560),
(446467, 'PF18558', NULL, 'Helix-turn-helix domain', 90, NULL, 'HTH_51', 265561),
(446468, 'PF10214', NULL, 'RNA polymerase I-specific transcription-initiation factor', 853, NULL, 'Rrn6', 265562);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(446469, 'PF12491', NULL, 'Apolipoprotein B100 C terminal', 57, NULL, 'ApoB100_C', 265563),
(446470, 'PF01150', NULL, 'GDA1/CD39 (nucleoside phosphatase) family', 423, NULL, 'GDA1_CD39', 265564),
(446471, 'PF14302', NULL, 'Domain of unknown function (DUF4377)', 75, NULL, 'DUF4377', 265565),
(446472, 'PF18081', NULL, 'Fanconi anemia-associated nuclease SAP domain', 51, NULL, 'FANC_SAP', 265566),
(446473, 'PF13729', NULL, 'F plasmid transfer operon, TraF, protein', 278, NULL, 'TraF_2', 265567),
(446474, 'PF15675', NULL, 'CLLAC-motif containing domain', 30, NULL, 'CLLAC', 265568),
(446475, 'PF20120', NULL, 'Family of unknown function (DUF6510)', 86, NULL, 'DUF6510', 265569),
(446476, 'PF13298', NULL, 'DNA polymerase Ligase (LigD)', 105, NULL, 'LigD_N', 265570),
(446477, 'PF16811', NULL, 'TRAP transporter T-component', 263, NULL, 'TAtT', 265571),
(446478, 'PF17673', NULL, 'Family of unknown function (DUF5532)', 92, NULL, 'DUF5532', 265572),
(446479, 'PF01207', NULL, 'Dihydrouridine synthase (Dus)', 310, NULL, 'Dus', 265573),
(446480, 'PF07270', NULL, 'Protein of unknown function (DUF1438)', 151, NULL, 'DUF1438', 265574),
(446481, 'PF03410', NULL, 'Metallopeptidase from vaccinia pox', 598, NULL, 'Peptidase_M44', 265575),
(446482, 'PF07273', NULL, 'Protein of unknown function (DUF1439)', 152, NULL, 'DUF1439', 265576),
(446483, 'PF13449', NULL, 'Esterase-like activity of phytase', 288, NULL, 'Phytase-like', 265577),
(446484, 'PF11909', NULL, 'NADH-quinone oxidoreductase cyanobacterial subunit N', 153, NULL, 'NdhN', 265578),
(446485, 'PF13200', NULL, 'Putative glycosyl hydrolase domain', 315, NULL, 'DUF4015', 265579),
(446486, 'PF07507', NULL, 'WavE lipopolysaccharide synthesis', 305, NULL, 'WavE', 265580),
(446487, 'PF16160', NULL, 'Domain of unknown function (DUF4866)', 246, NULL, 'DUF4866', 265581),
(446488, 'PF19983', NULL, 'Family of unknown function (DUF6419)', 71, NULL, 'DUF6419', 265582),
(446489, 'PF00842', NULL, 'Alanine racemase, C-terminal domain', 125, NULL, 'Ala_racemase_C', 265583),
(446490, 'PF10099', NULL, 'Anti-sigma-K factor rskA', 180, NULL, 'RskA', 265584),
(446491, 'PF19312', NULL, 'NtrY N-terminal region', 291, NULL, 'NtrY_N', 265585),
(446492, 'PF03508', NULL, 'Gap junction alpha-1 protein (Cx43)', 79, NULL, 'Connexin43', 265586),
(446493, 'PF03670', NULL, 'Uncharacterised protein family (UPF0184)', 83, NULL, 'UPF0184', 265587),
(446494, 'PF04122', NULL, 'ell wall binding domain 2 (CWB2)', 69, NULL, 'CW_binding_2', 265588),
(446495, 'PF17835', NULL, 'NOG1 N-terminal helical domain', 160, NULL, 'NOG1_N', 265589),
(446496, 'PF02089', NULL, 'Palmitoyl protein thioesterase', 257, NULL, 'Palm_thioest', 265590),
(446497, 'PF10100', NULL, 'Staphylopine dehydrogenase', 424, NULL, 'Staph_opine_DH', 265591),
(446498, 'PF06085', NULL, 'Lipoprotein Rz1 precursor', 41, NULL, 'Rz1', 265592),
(446499, 'PF01804', NULL, 'Penicillin amidase', 674, NULL, 'Penicil_amidase', 265593),
(446500, 'PF13618', NULL, 'Gluconate 2-dehydrogenase subunit 3', 136, NULL, 'Gluconate_2-dh3', 265594),
(446501, 'PF17930', NULL, 'LpxI N-terminal domain', 129, NULL, 'LpxI_N', 265595),
(446502, 'PF02276', NULL, 'Photosynthetic reaction centre cytochrome C subunit', 311, NULL, 'CytoC_RC', 265596),
(446503, 'PF17761', NULL, 'DUF1016 N-terminal domain', 137, NULL, 'DUF1016_N', 265597),
(446504, 'PF08325', NULL, 'WLM domain', 191, NULL, 'WLM', 265598),
(446505, 'PF13275', NULL, 'S4 domain', 65, NULL, 'S4_2', 265599),
(446506, 'PF17378', NULL, 'Meiotic recombination protein REC104', 182, NULL, 'REC104', 265600),
(446507, 'PF19208', NULL, 'Family of unknown function (DUF5880)', 97, NULL, 'DUF5880', 265601),
(446508, 'PF00137', NULL, 'ATP synthase subunit C', 60, NULL, 'ATP-synt_C', 265602),
(446509, 'PF06969', NULL, 'HemN C-terminal domain', 66, NULL, 'HemN_C', 265603),
(446510, 'PF07748', NULL, 'Glycosyl hydrolases family 38 C-terminal domain', 214, NULL, 'Glyco_hydro_38C', 265604),
(446511, 'PF08448', NULL, 'PAS fold', 110, NULL, 'PAS_4', 265605),
(446512, 'PF18298', NULL, 'NusG additional domain', 109, NULL, 'NusG_add', 265606);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(446513, 'PF02018', NULL, 'Carbohydrate binding domain', 138, NULL, 'CBM_4_9', 265607),
(446514, 'PF03116', NULL, 'NQR2, RnfD, RnfE family', 292, NULL, 'NQR2_RnfD_RnfE', 265608),
(446515, 'PF02585', NULL, 'GlcNAc-PI de-N-acetylase', 130, NULL, 'PIG-L', 265609),
(446516, 'PF18421', NULL, 'Peptidase family M23 N-terminal domain', 73, NULL, 'Peptidase_M23_N', 265610),
(446517, 'PF03511', NULL, 'Fanconi anaemia group A protein', 63, NULL, 'Fanconi_A', 265611),
(446518, 'PF04299', NULL, 'Putative FMN-binding domain', 168, NULL, 'FMN_bind_2', 265612),
(446519, 'PF14864', NULL, 'Alkyl sulfatase C-terminal', 126, NULL, 'Alkyl_sulf_C', 265613),
(446520, 'PF17550', NULL, 'Family of unknown function', 162, NULL, 'PsaF', 265614),
(446521, 'PF17616', NULL, 'Viral unique short region 6', 161, NULL, 'US6', 265615),
(446522, 'PF18360', NULL, 'Heterogeneous nuclear ribonucleoprotein Q acidic domain', 70, NULL, 'hnRNP_Q_AcD', 265616),
(446523, 'PF05280', NULL, 'Flagellar transcriptional activator (FlhC)', 173, NULL, 'FlhC', 265617),
(446524, 'PF00816', NULL, 'H-NS histone family', 92, NULL, 'Histone_HNS', 265618),
(446525, 'PF06141', NULL, 'Phage minor tail protein U', 130, NULL, 'Phage_tail_U', 265619),
(446526, 'PF06789', NULL, 'MINAR1 C-terminal domain', 159, NULL, 'MINAR1_C', 265620),
(446527, 'PF16182', NULL, 'Putative adherens-junction anchoring region of AbLIM', 366, NULL, 'AbLIM_anchor', 265621),
(446528, 'PF00139', NULL, 'Legume lectin domain', 249, NULL, 'Lectin_legB', 265622),
(446529, 'PF00393', NULL, '6-phosphogluconate dehydrogenase, C-terminal domain', 291, NULL, '6PGD', 265623),
(446530, 'PF02428', NULL, 'Potato type II proteinase inhibitor family', 51, NULL, 'Prot_inhib_II', 265624),
(446531, 'PF10165', NULL, 'Guanine nucleotide exchange factor synembryn', 459, NULL, 'Ric8', 265625),
(446532, 'PF04246', NULL, 'Positive regulator of sigma(E), RseC/MucC', 130, NULL, 'RseC_MucC', 265626),
(446533, 'PF08143', NULL, 'CBFNT (NUC161) domain', 70, NULL, 'CBFNT', 265627),
(446534, 'PF15604', NULL, 'Novel toxin 15', 154, NULL, 'Ntox15', 265628),
(446535, 'PF11050', NULL, 'Virus envelope protein E26', 225, NULL, 'Viral_env_E26', 265629),
(446536, 'PF15511', NULL, 'Centromere kinetochore component CENP-T histone fold', 108, NULL, 'CENP-T_C', 265630),
(446537, 'PF08090', NULL, 'Heat stable E.coli enterotoxin 1', 36, NULL, 'Enterotoxin_HS1', 265631),
(446538, 'PF14743', NULL, 'DNA ligase OB-like domain', 66, NULL, 'DNA_ligase_OB_2', 265632),
(446539, 'PF09285', NULL, 'Elongation factor P, C-terminal', 56, NULL, 'Elong-fact-P_C', 265633),
(446540, 'PF13769', NULL, 'Virulence factor', 81, NULL, 'Virulence_fact', 265634),
(446541, 'PF05684', NULL, 'Protein of unknown function (DUF819)', 378, NULL, 'DUF819', 265635),
(446542, 'PF17611', NULL, 'Family of unknown function (DUF5506)', 161, NULL, 'DUF5506', 265636),
(446543, 'PF19351', NULL, 'Domain of unknown function (DUF5929)', 222, NULL, 'DUF5929', 265637),
(446544, 'PF06471', NULL, 'Coronavirus proofreading exoribonuclease', 513, NULL, 'CoV_ExoN', 265638),
(446545, 'PF00047', NULL, 'Immunoglobulin domain', 87, NULL, 'ig', 265639),
(446546, 'PF11186', NULL, 'Protein of unknown function (DUF2972)', 199, NULL, 'DUF2972', 265640),
(446547, 'PF20512', NULL, 'Phosphomannose isomerase type I, helical insertion domain', 94, NULL, 'PMI_typeI_hel', 265641),
(446548, 'PF07413', NULL, 'Betaherpesvirus immediate-early glycoprotein UL37', 278, NULL, 'Herpes_UL37_2', 265642),
(446549, 'PF13864', NULL, 'Calmodulin-binding', 95, NULL, 'Enkurin', 265643),
(446550, 'PF06007', NULL, 'Phosphonate metabolism protein PhnJ', 275, NULL, 'PhnJ', 265644),
(446551, 'PF16141', NULL, 'Putative glycoside hydrolase Family 18, chitinase_18', 325, NULL, 'DUF4849', 265645),
(446552, 'PF10032', NULL, 'Phosphate transport (Pho88)', 182, NULL, 'Pho88', 265646),
(446553, 'PF04282', NULL, 'Family of unknown function (DUF438)', 67, NULL, 'DUF438', 265647),
(446554, 'PF05136', NULL, 'Phage portal protein, lambda family', 362, NULL, 'Phage_portal_2', 265648),
(446555, 'PF04082', NULL, 'Fungal specific transcription factor domain', 267, NULL, 'Fungal_trans', 265649);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(446556, 'PF20596', NULL, 'Putative adhesive domain (group 11)', 112, NULL, 'pAdhesive_11', 265650),
(446557, 'PF02336', NULL, 'Capsid protein VP4', 431, NULL, 'Denso_VP4', 265651),
(446558, 'PF09408', NULL, 'Betacoronavirus spike glycoprotein S1, receptor binding', 180, NULL, 'bCoV_S1_RBD', 265652),
(446559, 'PF16971', NULL, 'Rough colony protein B, tight adherence - tad - subunit', 167, NULL, 'RcpB', 265653),
(446560, 'PF17522', NULL, 'Family of unknown function (DUF5446)', 72, NULL, 'DUF5446', 265654),
(446561, 'PF07372', NULL, 'Protein of unknown function (DUF1491)', 104, NULL, 'DUF1491', 265655),
(446562, 'PF05821', NULL, 'NADH-ubiquinone oxidoreductase ASHI subunit (CI-ASHI or NDUFB8)', 172, NULL, 'NDUF_B8', 265656),
(446563, 'PF07832', NULL, 'Cfr10I/Bse634I restriction endonuclease', 280, NULL, 'Bse634I', 265657),
(446564, 'PF17525', NULL, 'Family of unknown function (DUF5447)', 92, NULL, 'DUF5447', 265658),
(446565, 'PF04734', NULL, 'Neutral/alkaline non-lysosomal ceramidase, N-terminal', 509, NULL, 'Ceramidase_alk', 265659),
(446566, 'PF05009', NULL, 'Epstein-Barr virus nuclear antigen 3 (EBNA-3)', 254, NULL, 'EBV-NA3', 265660),
(446567, 'PF19872', NULL, 'Family of unknown function (DUF6345)', 221, NULL, 'DUF6345', 265661),
(446568, 'PF05089', NULL, 'Alpha-N-acetylglucosaminidase (NAGLU) tim-barrel domain', 333, NULL, 'NAGLU', 265662),
(446569, 'PF06148', NULL, 'COG (conserved oligomeric Golgi) complex component, COG2', 133, NULL, 'COG2', 265663),
(446570, 'PF10613', NULL, 'Ligated ion channel L-glutamate- and glycine-binding site', 115, NULL, 'Lig_chan-Glu_bd', 265664),
(446571, 'PF17312', NULL, 'Bacteriocin helveticin-J', 317, NULL, 'Helveticin_J', 265665),
(446572, 'PF09425', NULL, 'Jas motif', 26, NULL, 'Jas_motif', 265666),
(446573, 'PF14233', NULL, 'Domain of unknown function (DUF4335)', 185, NULL, 'DUF4335', 265667),
(446574, 'PF00805', NULL, 'Pentapeptide repeats (8 copies)', 40, NULL, 'Pentapeptide', 265668),
(446575, 'PF01193', NULL, 'RNA polymerase Rpb3/Rpb11 dimerisation domain', 74, NULL, 'RNA_pol_L', 265669),
(446576, 'PF04166', NULL, 'Pyridoxal phosphate biosynthetic protein PdxA', 281, NULL, 'PdxA', 265670),
(446577, 'PF16824', NULL, 'C-terminal carbohydrate-binding module', 125, NULL, 'CBM_26', 265671),
(446578, 'PF05313', NULL, 'Poxvirus P21 membrane protein', 189, NULL, 'Pox_P21', 265672),
(446579, 'PF19667', NULL, 'Family of unknown function (DUF6170)', 100, NULL, 'DUF6170', 265673),
(446580, 'PF17695', NULL, 'Family of unknown function (DUF5541)', 116, NULL, 'DUF5541', 265674),
(446581, 'PF17918', NULL, 'Tetracyclin repressor-like, C-terminal domain', 108, NULL, 'TetR_C_15', 265675),
(446582, 'PF06430', NULL, 'Lactococcus lactis RepB C-terminus', 122, NULL, 'L_lactis_RepB_C', 265676),
(446583, 'PF04626', NULL, 'Dec-1 protein, C terminal region', 131, NULL, 'DEC-1_C', 265677),
(446584, 'PF11058', NULL, 'Antirestriction protein Ral', 66, NULL, 'Ral', 265678),
(446585, 'PF14727', NULL, 'PTHB1 N-terminus', 414, NULL, 'PHTB1_N', 265679),
(446586, 'PF19740', NULL, 'Family of unknown function (DUF6229)', 62, NULL, 'DUF6229', 265680),
(446587, 'PF01177', NULL, 'Asp/Glu/Hydantoin racemase', 211, NULL, 'Asp_Glu_race', 265681),
(446588, 'PF14040', NULL, 'Deoxyribonuclease NucA/NucB', 113, NULL, 'DNase_NucA_NucB', 265682),
(446589, 'PF14278', NULL, 'Transcriptional regulator C-terminal region', 103, NULL, 'TetR_C_8', 265683),
(446590, 'PF01667', NULL, 'Ribosomal protein S27', 55, NULL, 'Ribosomal_S27e', 265684),
(446591, 'PF18903', NULL, 'Domain of unknown function (DUF5659)', 75, NULL, 'DUF5659', 265685),
(446592, 'PF15761', NULL, 'Immortalisation up-regulated protein', 108, NULL, 'IMUP', 265686),
(446593, 'PF05912', NULL, 'Caenorhabditis elegans protein of unknown function (DUF870)', 112, NULL, 'DUF870', 265687),
(446594, 'PF03026', NULL, 'Influenza C virus M1 protein', 235, NULL, 'CM1', 265688),
(446595, 'PF16492', NULL, 'Cadherin cytoplasmic C-terminal', 85, NULL, 'Cadherin_C_2', 265689),
(446596, 'PF13006', NULL, 'Insertion element 4 transposase N-terminal', 97, NULL, 'Nterm_IS4', 265690);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(446597, 'PF18678', NULL, 'Allene oxide cyclase barrel like domain', 122, NULL, 'AOC_like', 265691),
(446598, 'PF06159', NULL, 'Protein of unknown function (DUF974)', 246, NULL, 'DUF974', 265692),
(446599, 'PF14793', NULL, 'Pyrimidine/purine nucleotide 5''-monophosphate nucleosidases', 109, NULL, 'DUF4478', 265693),
(446600, 'PF16317', NULL, 'Glycosyl hydrolase family 99', 341, NULL, 'Glyco_hydro_99', 265694),
(446601, 'PF09068', NULL, 'EF hand', 123, NULL, 'EF-hand_2', 265695),
(446602, 'PF04938', NULL, 'Survival motor neuron (SMN) interacting protein 1 (SIP1)', 218, NULL, 'SIP1', 265696),
(446603, 'PF06996', NULL, 'Type VI secretion, TssG', 304, NULL, 'T6SS_TssG', 265697),
(446604, 'PF12502', NULL, 'Protein of unknown function (DUF3710)', 178, NULL, 'DUF3710', 265698),
(446605, 'PF16238', NULL, 'Domain of unknown function (DUF4897)', 157, NULL, 'DUF4897', 265699),
(446606, 'PF18689', NULL, 'Primase X', 95, NULL, 'PriX', 265700),
(446607, 'PF08236', NULL, 'SRI (Set2 Rpb1 interacting) domain', 85, NULL, 'SRI', 265701),
(446608, 'PF19026', NULL, 'HYPK UBA domain', 41, NULL, 'HYPK_UBA', 265702),
(446609, 'PF10879', NULL, 'Protein of unknown function (DUF2674)', 63, NULL, 'DUF2674', 265703),
(446610, 'PF06553', NULL, 'BNIP3', 187, NULL, 'BNIP3', 265704),
(446611, 'PF13804', NULL, 'Retro-transcribing viruses envelope glycoprotein', 169, NULL, 'HERV-K_env_2', 265705),
(446612, 'PF09220', NULL, 'L-A virus, major coat protein', 439, NULL, 'LA-virus_coat', 265706),
(446613, 'PF17898', NULL, 'Spore germination GerD central core domain', 114, NULL, 'GerD', 265707),
(446614, 'PF17932', NULL, 'Tetracyclin repressor-like, C-terminal domain', 114, NULL, 'TetR_C_24', 265708),
(446615, 'PF16318', NULL, 'Domain of unknown function (DUF4957)', 141, NULL, 'DUF4957', 265709),
(446616, 'PF19340', NULL, 'Gamma-tubulin complex component 6 N-terminus', 315, NULL, 'GCP6_N', 265710),
(446617, 'PF17896', NULL, 'Non-structural protein 2, gammacoronavirus', 358, NULL, 'NSP2_gammaCoV', 265711),
(446618, 'PF15478', NULL, 'Family of unknown function with LKAAEAR motif', 137, NULL, 'LKAAEAR', 265712),
(446619, 'PF04225', NULL, 'Opacity-associated protein A LysM-like domain', 85, NULL, 'OapA', 265713),
(446620, 'PF05708', NULL, 'Permuted papain-like amidase enzyme, YaeF/YiiX, C92 family', 166, NULL, 'Peptidase_C92', 265714),
(446621, 'PF07724', NULL, 'AAA domain (Cdc48 subfamily)', 171, NULL, 'AAA_2', 265715),
(446622, 'PF11625', NULL, 'Protein of unknown function (DUF3253)', 81, NULL, 'DUF3253', 265716),
(446623, 'PF12373', NULL, 'Major surface glycoprotein 2 C terminal', 30, NULL, 'Msg2_C', 265717),
(446624, 'PF11140', NULL, 'Protein of unknown function (DUF2913)', 207, NULL, 'DUF2913', 265718),
(446625, 'PF17138', NULL, 'Domain of unknown function (DUF5111)', 122, NULL, 'DUF5111', 265719),
(446626, 'PF09116', NULL, 'gp45 sliding clamp, C terminal', 105, NULL, 'gp45-slide_C', 265720),
(446627, 'PF13108', NULL, 'Protein of unknown function (DUF3969)', 106, NULL, 'DUF3969', 265721),
(446628, 'PF07105', NULL, 'Protein of unknown function (DUF1367)', 196, NULL, 'DUF1367', 265722),
(446629, 'PF13004', NULL, 'Putative binding domain, N-terminal', 53, NULL, 'BACON', 265723),
(446630, 'PF03985', NULL, 'Paf1', 426, NULL, 'Paf1', 265724),
(446631, 'PF05083', NULL, 'LST-1 protein', 78, NULL, 'LST1', 265725),
(446632, 'PF03820', NULL, 'Sideroflexins', 319, NULL, 'SFXNs', 265726),
(446633, 'PF00131', NULL, 'Metallothionein', 65, NULL, 'Metallothio', 265727),
(446634, 'PF01265', NULL, 'Cytochrome c/c1 heme lyase', 298, NULL, 'Cyto_heme_lyase', 265728),
(446635, 'PF17685', NULL, 'Family of unknown function (DUF5533)', 139, NULL, 'DUF5533', 265729),
(446636, 'PF04623', NULL, 'Adenovirus E1B protein N-terminus', 71, NULL, 'Adeno_E1B_55K_N', 265730),
(446637, 'PF19561', NULL, 'Family of unknown function (DUF6083)', 112, NULL, 'DUF6083', 265731),
(446638, 'PF01939', NULL, 'Endonuclease NucS', 229, NULL, 'NucS', 265732),
(446639, 'PF11716', NULL, 'Mycothiol maleylpyruvate isomerase N-terminal domain', 141, NULL, 'MDMPI_N', 265733),
(446640, 'PF14597', NULL, 'Metallo-beta-lactamase superfamily', 199, NULL, 'Lactamase_B_5', 265734);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(446641, 'PF18413', NULL, 'Neuraminidase-like domain', 169, NULL, 'Neuraminidase', 265735),
(446642, 'PF02733', NULL, 'Dak1 domain', 311, NULL, 'Dak1', 265736),
(446643, 'PF13063', NULL, 'Protein of unknown function (DUF3925)', 65, NULL, 'DUF3925', 265737),
(446644, 'PF09323', NULL, 'Domain of unknown function (DUF1980)', 181, NULL, 'DUF1980', 265738),
(446645, 'PF13273', NULL, 'Protein of unknown function (DUF4064)', 103, NULL, 'DUF4064', 265739),
(446646, 'PF11159', NULL, 'Protein of unknown function (DUF2939)', 93, NULL, 'DUF2939', 265740),
(446647, 'PF09770', NULL, 'Topoisomerase II-associated protein PAT1', 864, NULL, 'PAT1', 265741),
(446648, 'PF20294', NULL, 'KTSC and Metallopeptidase N-terminal fusion domain', 66, NULL, 'KMPT-N', 265742),
(446649, 'PF19071', NULL, 'Family of unknown function (DUF5767)', 85, NULL, 'DUF5767', 265743),
(446650, 'PF18414', NULL, 'C2H2 type zinc-finger', 26, NULL, 'zf_C2H2_10', 265744),
(446651, 'PF10416', NULL, 'Transcription-initiator DNA-binding domain IBD', 128, NULL, 'IBD', 265745),
(446652, 'PF15805', NULL, 'Acidic C-terminal region of sodium channel modifier 1 SCNM1', 47, NULL, 'SCNM1_acidic', 265746),
(446653, 'PF02569', NULL, 'Pantoate-beta-alanine ligase', 264, NULL, 'Pantoate_ligase', 265747),
(446654, 'PF11666', NULL, 'Protein of unknown function (DUF2933)', 52, NULL, 'DUF2933', 265748),
(446655, 'PF11752', NULL, 'Protein of unknown function (DUF3309)', 49, NULL, 'DUF3309', 265749),
(446656, 'PF17004', NULL, 'Putative TPR-like repeat', 118, NULL, 'SRP_TPR_like', 265750),
(446657, 'PF07798', NULL, 'Coiled-coil domain-containing protein 90-like', 175, NULL, 'CCDC90-like', 265751),
(446658, 'PF16601', NULL, 'Rabosyn-5 repeating NPF sequence-motif', 187, NULL, 'NPF', 265752),
(446659, 'PF01761', NULL, '3-dehydroquinate synthase', 262, NULL, 'DHQ_synthase', 265753),
(446660, 'PF05891', NULL, 'AdoMet dependent proline di-methyltransferase', 218, NULL, 'Methyltransf_PK', 265754),
(446661, 'PF14255', NULL, 'Cysteine-rich CPXCG', 52, NULL, 'Cys_rich_CPXG', 265755),
(446662, 'PF08686', NULL, 'PLAC (protease and lacunin) domain', 31, NULL, 'PLAC', 265756),
(446663, 'PF08789', NULL, 'PBCV-specific basic adaptor domain', 38, NULL, 'PBCV_basic_adap', 265757),
(446664, 'PF06184', NULL, 'Potexvirus coat protein', 153, NULL, 'Potex_coat', 265758),
(446665, 'PF12246', NULL, 'Temperature dependent protein affecting M2 dsRNA replication', 240, NULL, 'MKT1_C', 265759),
(446666, 'PF15869', NULL, 'TolB-like 6-blade propeller-like', 295, NULL, 'TolB_like', 265760),
(446667, 'PF10298', NULL, 'WhiA N-terminal LAGLIDADG-like domain', 86, NULL, 'WhiA_N', 265761),
(446668, 'PF16924', NULL, 'Dipicolinate synthase subunit A N-terminal domain', 116, NULL, 'DpaA_N', 265762),
(446669, 'PF07326', NULL, 'Regulator of chromosome segregation 1', 232, NULL, 'RCS1', 265763),
(446670, 'PF05177', NULL, 'RCSD region', 91, NULL, 'RCSD', 265764),
(446671, 'PF07982', NULL, 'Herpes UL74 glycoproteins', 418, NULL, 'Herpes_UL74', 265765),
(446672, 'PF16145', NULL, 'Domain of unknown function (DUF4853)', 135, NULL, 'DUF4853', 265766),
(446673, 'PF08961', NULL, 'Nuclear receptor-binding factor 2, autophagy regulator', 200, NULL, 'NRBF2', 265767),
(446674, 'PF09543', NULL, 'Protein of unknown function (DUF2379)', 120, NULL, 'DUF2379', 265768),
(446675, 'PF02182', NULL, 'SAD/SRA domain', 153, NULL, 'SAD_SRA', 265769),
(446676, 'PF15021', NULL, 'Protein of unknown function (DUF4521)', 204, NULL, 'DUF4521', 265770),
(446677, 'PF12115', NULL, 'Salivary protein of 15kDa inhibits CD4+ T cell activation', 118, NULL, 'Salp15', 265771),
(446678, 'PF01668', NULL, 'SmpB protein', 143, NULL, 'SmpB', 265772),
(446679, 'PF09384', NULL, 'UTP15 C terminal', 147, NULL, 'UTP15_C', 265773),
(446680, 'PF13032', NULL, 'RNaseH domain of pPIWI_RE', 292, NULL, 'RNaseH_pPIWI_RE', 265774),
(446681, 'PF19047', NULL, 'HOOK domain', 151, NULL, 'HOOK_N', 265775),
(446682, 'PF14351', NULL, 'Domain of unknown function (DUF4401)', 310, NULL, 'DUF4401', 265776),
(446683, 'PF06375', NULL, 'AP-3 complex subunit delta-1', 156, NULL, 'AP3D1', 265777);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(446684, 'PF17118', NULL, 'Domain of unknown function (DUF5105)', 189, NULL, 'DUF5105', 265778),
(446685, 'PF13097', NULL, 'CENP-A nucleosome associated complex (NAC) subunit', 181, NULL, 'CENP-U', 265779),
(446686, 'PF16068', NULL, 'Domain of unknown function (DUF4810)', 85, NULL, 'DUF4810', 265780),
(446687, 'PF18284', NULL, 'DNA methylase N-terminal domain', 57, NULL, 'DNA_meth_N', 265781),
(446688, 'PF12010', NULL, 'Domain of unknown function (DUF3502)', 130, NULL, 'DUF3502', 265782),
(446689, 'PF12658', NULL, 'Telomere capping, CST complex subunit', 121, NULL, 'Ten1', 265783),
(446690, 'PF01339', NULL, 'CheB methylesterase', 168, NULL, 'CheB_methylest', 265784),
(446691, 'PF15718', NULL, 'Protein moonraker', 960, NULL, 'MNR', 265785),
(446692, 'PF01747', NULL, 'ATP-sulfurylase', 211, NULL, 'ATP-sulfurylase', 265786),
(446693, 'PF08267', NULL, 'Cobalamin-independent synthase, N-terminal domain', 313, NULL, 'Meth_synt_1', 265787),
(446694, 'PF19145', NULL, 'Family of unknown function (DUF5827)', 87, NULL, 'DUF5827', 265788),
(446695, 'PF19937', NULL, 'Gliding motility-associated protein GldC-like', 90, NULL, 'GldC-like', 265789),
(446696, 'PF17836', NULL, 'PglD N-terminal domain', 78, NULL, 'PglD_N', 265790),
(446697, 'PF05283', NULL, 'Multi-glycosylated core protein 24 (MGC-24), sialomucin', 140, NULL, 'MGC-24', 265791),
(446698, 'PF09086', NULL, 'Domain of unknown function (DUF1924)', 96, NULL, 'DUF1924', 265792),
(446699, 'PF20046', NULL, 'Family of unknown function (DUF6448)', 147, NULL, 'DUF6448', 265793),
(446700, 'PF06632', NULL, 'DNA double-strand break repair and V(D)J recombination protein XRCC4', 337, NULL, 'XRCC4', 265794),
(446701, 'PF11593', NULL, 'Mediator complex subunit 3 fungal', 398, NULL, 'Med3', 265795),
(446702, 'PF08050', NULL, 'Tetracycline resistance leader peptide', 20, NULL, 'Tet_res_leader', 265796),
(446703, 'PF12572', NULL, 'Protein of unknown function (DUF3752)', 154, NULL, 'DUF3752', 265797),
(446704, 'PF03074', NULL, 'Glutamate-cysteine ligase', 372, NULL, 'GCS', 265798),
(446705, 'PF05496', NULL, 'Holliday junction DNA helicase RuvB P-loop domain', 159, NULL, 'RuvB_N', 265799),
(446706, 'PF06303', NULL, 'MatP N-terminal domain', 84, NULL, 'MatP', 265800),
(446707, 'PF02099', NULL, 'Josephin', 165, NULL, 'Josephin', 265801),
(446708, 'PF02822', NULL, 'Antistasin family', 26, NULL, 'Antistasin', 265802),
(446709, 'PF07523', NULL, 'Bacterial Ig-like domain (group 3)', 68, NULL, 'Big_3', 265803),
(446710, 'PF06169', NULL, 'Protein of unknown function (DUF982)', 73, NULL, 'DUF982', 265804),
(446711, 'PF13838', NULL, 'Clathrin-H-link', 66, NULL, 'Clathrin_H_link', 265805),
(446712, 'PF06942', NULL, 'GlpM protein', 107, NULL, 'GlpM', 265806),
(446713, 'PF07333', NULL, 'S locus-related glycoprotein 1 binding pollen coat protein (SLR1-BP)', 58, NULL, 'SLR1-BP', 265807),
(446714, 'PF08222', NULL, 'CodY helix-turn-helix domain', 61, NULL, 'HTH_CodY', 265808),
(446715, 'PF12966', NULL, 'N-ATPase, AtpR subunit', 86, NULL, 'AtpR', 265809),
(446716, 'PF12677', NULL, 'Domain of unknown function (DUF3797)', 48, NULL, 'DUF3797', 265810),
(446717, 'PF15786', NULL, 'PET assembly of cytochrome c oxidase, mitochondrial', 70, NULL, 'PET117', 265811),
(446718, 'PF13241', NULL, 'Putative NAD(P)-binding', 104, NULL, 'NAD_binding_7', 265812),
(446719, 'PF17081', NULL, 'Suppressor of PMA 1-7 protein', 209, NULL, 'SOP4', 265813),
(446720, 'PF18380', NULL, 'Holliday junction resolvase Gen1 C-terminal domain', 105, NULL, 'GEN1_C', 265814),
(446721, 'PF18534', NULL, 'Helical bundle domain', 84, NULL, 'HBD', 265815),
(446722, 'PF01148', NULL, 'Cytidylyltransferase family', 265, NULL, 'CTP_transf_1', 265816),
(446723, 'PF00683', NULL, 'TB domain', 44, NULL, 'TB', 265817),
(446724, 'PF14293', NULL, 'YWFCY protein', 144, NULL, 'YWFCY', 265818),
(446725, 'PF03537', NULL, 'Glycoside-hydrolase family GH114', 232, NULL, 'Glyco_hydro_114', 265819),
(446726, 'PF07429', NULL, '4-alpha-L-fucosyltransferase glycosyl transferase group 56', 358, NULL, 'Glyco_transf_56', 265820),
(446727, 'PF16973', NULL, 'Flagellar motor switch protein FliN N-terminal', 50, NULL, 'FliN_N', 265821);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(446728, 'PF09600', NULL, 'Cyd operon protein YbgE (Cyd_oper_YbgE)', 79, NULL, 'Cyd_oper_YbgE', 265822),
(446729, 'PF00249', NULL, 'Myb-like DNA-binding domain', 46, NULL, 'Myb_DNA-binding', 265823),
(446730, 'PF07054', NULL, 'Pericardin like repeat', 35, NULL, 'Pericardin_rpt', 265824),
(446731, 'PF19558', NULL, 'Family of unknown function (DUF6080)', 447, NULL, 'DUF6080', 265825),
(446732, 'PF10271', NULL, 'Putative transmembrane protein', 427, NULL, 'Tmp39', 265826),
(446733, 'PF02512', NULL, 'Virulence determinant', 96, NULL, 'UK', 265827),
(446734, 'PF14943', NULL, 'Mitochondrial ribosome subunit S26', 168, NULL, 'MRP-S26', 265828),
(446735, 'PF08841', NULL, 'Diol dehydratase reactivase ATPase-like domain', 328, NULL, 'DDR', 265829),
(446736, 'PF17792', NULL, 'ThiD2 family', 124, NULL, 'ThiD2', 265830),
(446737, 'PF11825', NULL, 'Nuclear/hormone receptor activator site AF-1', 114, NULL, 'Nuc_recep-AF1', 265831),
(446738, 'PF10379', NULL, 'Virulence protein nec1', 184, NULL, 'nec1', 265832),
(446739, 'PF02464', NULL, 'Competence-damaged protein', 155, NULL, 'CinA', 265833),
(446740, 'PF11113', NULL, 'Head assembly gene product', 56, NULL, 'Phage_head_chap', 265834),
(446741, 'PF18296', NULL, 'MID domain of medPIWI', 256, NULL, 'MID_MedPIWI', 265835),
(446742, 'PF02828', NULL, 'L27 domain', 53, NULL, 'L27', 265836),
(446743, 'PF15071', NULL, 'Transmembrane family 220, helix', 101, NULL, 'TMEM220', 265837),
(446744, 'PF05666', NULL, 'Fels-1 Prophage Protein-like', 43, NULL, 'Fels1', 265838),
(446745, 'PF11592', NULL, 'Central core of the bacterial effector protein AvrPto', 105, NULL, 'AvrPto', 265839),
(446746, 'PF04989', NULL, 'Cephalosporin hydroxylase', 206, NULL, 'CmcI', 265840),
(446747, 'PF11458', NULL, 'Membrane-integrating protein Mistic', 74, NULL, 'Mistic', 265841),
(446748, 'PF08721', NULL, 'TnsA endonuclease C terminal', 83, NULL, 'Tn7_Tnp_TnsA_C', 265842),
(446749, 'PF10788', NULL, 'Protein of unknown function (DUF2603)', 137, NULL, 'DUF2603', 265843),
(446750, 'PF14367', NULL, 'Domain of unknown function (DUF4411)', 160, NULL, 'DUF4411', 265844),
(446751, 'PF16351', NULL, 'Domain of unknown function (DUF4979)', 161, NULL, 'DUF4979', 265845),
(446752, 'PF19533', NULL, 'Rab3 GTPase-activating protein catalytic subunit C-terminal', 204, NULL, 'Rab3-GAP_cat_C', 265846),
(446753, 'PF08283', NULL, 'Geminivirus rep protein central domain', 107, NULL, 'Gemini_AL1_M', 265847),
(446754, 'PF15395', NULL, 'Domain of unknown function (DUF4617)', 1085, NULL, 'DUF4617', 265848),
(446755, 'PF20547', NULL, 'Family of unknown function (DUF6761)', 82, NULL, 'DUF6761', 265849),
(446756, 'PF00988', NULL, 'Carbamoyl-phosphate synthase small chain, CPSase domain', 125, NULL, 'CPSase_sm_chain', 265850),
(446757, 'PF15544', NULL, 'Bacterial toxin 6', 271, NULL, 'Ntox6', 265851),
(446758, 'PF14620', NULL, 'YpeB sporulation', 361, NULL, 'YPEB', 265852),
(446759, 'PF10316', NULL, 'Serpentine type 7TM GPCR chemoreceptor Srbc', 275, NULL, '7TM_GPCR_Srbc', 265853),
(446760, 'PF17679', NULL, 'gp37/Dip protein', 273, NULL, 'Dip', 265854),
(446761, 'PF09794', NULL, 'Transport protein Avl9', 378, NULL, 'Avl9', 265855),
(446762, 'PF15226', NULL, 'HCF-1 beta-propeller-interacting protein family', 133, NULL, 'HPIP', 265856),
(446763, 'PF06101', NULL, 'Vacuolar protein sorting-associated protein 62', 542, NULL, 'Vps62', 265857),
(446764, 'PF07804', NULL, 'HipA-like C-terminal domain', 212, NULL, 'HipA_C', 265858),
(446765, 'PF17080', NULL, 'Multidrug Resistance efflux pump', 144, NULL, 'SepA', 265859),
(446766, 'PF07404', NULL, 'Telomere-binding protein beta subunit (TEBP beta)', 140, NULL, 'TEBP_beta', 265860),
(446767, 'PF12824', NULL, 'Mitochondrial ribosomal protein subunit L20', 164, NULL, 'MRP-L20', 265861),
(446768, 'PF11467', NULL, 'Lens epithelium-derived growth factor (LEDGF)', 120, NULL, 'LEDGF', 265862),
(446769, 'PF01410', NULL, 'Fibrillar collagen C-terminal domain', 233, NULL, 'COLFI', 265863),
(446770, 'PF02756', NULL, 'GYR motif', 18, NULL, 'GYR', 265864),
(446771, 'PF08346', NULL, 'AntA/AntB antirepressor', 68, NULL, 'AntA', 265865);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(446772, 'PF11491', NULL, 'Protein of unknown function (DUF3213)', 84, NULL, 'DUF3213', 265866),
(446773, 'PF20310', NULL, 'Transposon related HTH domain protein', 131, NULL, 'HTH_Tnp_2', 265867),
(446774, 'PF13185', NULL, 'GAF domain', 138, NULL, 'GAF_2', 265868),
(446775, 'PF15349', NULL, 'DDB1- and CUL4-associated factor 16', 216, NULL, 'DCA16', 265869),
(446776, 'PF12945', NULL, 'Flagellar protein YcgR', 85, NULL, 'PilZNR', 265870),
(446777, 'PF15506', NULL, 'OCC1 family', 61, NULL, 'OCC1', 265871),
(446778, 'PF15482', NULL, 'Coiled-coil domain-containing glutamate-rich protein family 1', 213, NULL, 'CCER1', 265872),
(446779, 'PF08288', NULL, 'PIGA (GPI anchor biosynthesis)', 90, NULL, 'PIGA', 265873),
(446780, 'PF03669', NULL, 'PAT complex subunit Asterix', 97, NULL, 'ASTER', 265874),
(446781, 'PF02972', NULL, 'Phycoerythrin, alpha/beta chain', 57, NULL, 'Phycoerythr_ab', 265875),
(446782, 'PF19298', NULL, '3-Ketosteroid 9alpha-hydroxylase C-terminal domain', 202, NULL, 'KshA_C', 265876),
(446783, 'PF10168', NULL, 'Nuclear pore component', 713, NULL, 'Nup88', 265877),
(446784, 'PF07886', NULL, 'BA14K-like protein', 30, NULL, 'BA14K', 265878),
(446785, 'PF12192', NULL, 'Fungal calcium binding protein', 79, NULL, 'CBP', 265879),
(446786, 'PF02066', NULL, 'Metallothionein family 11', 54, NULL, 'Metallothio_11', 265880),
(446787, 'PF20428', NULL, 'Sey1 three-helix bundle domain', 419, NULL, 'Sey1_3HB', 265881),
(446788, 'PF17062', NULL, 'Outer spore wall 5', 70, NULL, 'Osw5', 265882),
(446789, 'PF01589', NULL, 'Alphavirus E1 glycoprotein', 504, NULL, 'Alpha_E1_glycop', 265883),
(446790, 'PF18001', NULL, 'Interleukin-13 receptor subunit alpha Ig-like domain', 95, NULL, 'Il13Ra_Ig', 265884),
(446791, 'PF05020', NULL, 'NPL4 family, putative zinc binding region', 145, NULL, 'zf-NPL4', 265885),
(446792, 'PF14945', NULL, 'Normal lung function maintenance, Low in Lung Cancer 1 protein', 119, NULL, 'LLC1', 265886),
(446793, 'PF01402', NULL, 'Ribbon-helix-helix protein, copG family', 39, NULL, 'RHH_1', 265887),
(446794, 'PF09426', NULL, 'Vacuolar R-SNARE Nyv1, longin domain', 138, NULL, 'Nyv1_longin', 265888),
(446795, 'PF10932', NULL, 'Protein of unknown function (DUF2783)', 59, NULL, 'DUF2783', 265889),
(446796, 'PF00721', NULL, 'Virus coat protein (TMV like)', 163, NULL, 'TMV_coat', 265890),
(446797, 'PF15497', NULL, 'snRNA-activating protein complex subunit 19, SNAPc subunit 19', 103, NULL, 'SNAPC5', 265891),
(446798, 'PF09361', NULL, 'Phasin protein', 100, NULL, 'Phasin_2', 265892),
(446799, 'PF00602', NULL, 'Influenza RNA-dependent RNA polymerase subunit PB1', 732, NULL, 'Flu_PB1', 265893),
(446800, 'PF00261', NULL, 'Tropomyosin', 237, NULL, 'Tropomyosin', 265894),
(446801, 'PF11954', NULL, 'Domain of unknown function (DUF3471)', 103, NULL, 'DUF3471', 265895),
(446802, 'PF15903', NULL, 'Filopodia upregulated, FAM65', 348, NULL, 'PL48', 265896),
(446803, 'PF19869', NULL, 'Family of unknown function (DUF6342)', 99, NULL, 'DUF6342', 265897),
(446804, 'PF00915', NULL, 'Calicivirus coat protein', 291, NULL, 'Calici_coat', 265898),
(446805, 'PF00068', NULL, 'Phospholipase A2', 111, NULL, 'Phospholip_A2_1', 265899),
(446806, 'PF02917', NULL, 'Pertussis toxin, subunit 1', 233, NULL, 'Pertussis_S1', 265900),
(446807, 'PF12774', NULL, 'Hydrolytic ATP binding site of dynein motor region', 327, NULL, 'AAA_6', 265901),
(446808, 'PF01751', NULL, 'Toprim domain', 104, NULL, 'Toprim', 265902),
(446809, 'PF12854', NULL, 'PPR repeat', 34, NULL, 'PPR_1', 265903),
(446810, 'PF17343', NULL, 'Family of unknown function (DUF5373)', 182, NULL, 'DUF5373', 265904),
(446811, 'PF09274', NULL, 'ParG', 76, NULL, 'ParG', 265905),
(446812, 'PF13970', NULL, 'Domain of unknown function (DUF4221)', 312, NULL, 'DUF4221', 265906),
(446813, 'PF13579', NULL, 'Glycosyl transferase 4-like domain', 159, NULL, 'Glyco_trans_4_4', 265907),
(446814, 'PF04112', NULL, 'Mak10 subunit, NatC N(alpha)-terminal acetyltransferase', 169, NULL, 'Mak10', 265908),
(446815, 'PF04690', NULL, 'YABBY protein', 166, NULL, 'YABBY', 265909),
(446816, 'PF04488', NULL, 'Glycosyltransferase sugar-binding region containing DXD motif', 98, NULL, 'Gly_transf_sug', 265910);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(446817, 'PF05949', NULL, 'Bacterial protein of unknown function (DUF881)', 145, NULL, 'DUF881', 265911),
(446818, 'PF11289', NULL, 'Betacoronavirus viroporin', 273, NULL, 'bCoV_viroporin', 265912),
(446819, 'PF01752', NULL, 'Collagenase', 289, NULL, 'Peptidase_M9', 265913),
(446820, 'PF12533', NULL, 'Neuronal helix-loop-helix transcription factor', 126, NULL, 'Neuro_bHLH', 265914),
(446821, 'PF15605', NULL, 'Bacterial toxin 28', 104, NULL, 'Ntox28', 265915),
(446822, 'PF13520', NULL, 'Amino acid permease', 427, NULL, 'AA_permease_2', 265916),
(446823, 'PF18994', NULL, 'Prophage endopeptidase tail N-terminal domain', 85, NULL, 'Prophage_tailD1', 265917),
(446824, 'PF12884', NULL, 'Transducer of regulated CREB activity, N terminus', 71, NULL, 'TORC_N', 265918),
(446825, 'PF01549', NULL, 'ShK domain-like', 37, NULL, 'ShK', 265919),
(446826, 'PF05279', NULL, 'Aspartyl beta-hydroxylase N-terminal region', 66, NULL, 'Asp-B-Hydro_N', 265920),
(446827, 'PF15548', NULL, 'Domain of unknown function (DUF4655)', 525, NULL, 'DUF4655', 265921),
(446828, 'PF07766', NULL, 'LETM1-like, RBD', 229, NULL, 'LETM1_RBD', 265922),
(446829, 'PF06522', NULL, 'NADH-ubiquinone reductase complex 1 MLRQ subunit', 69, NULL, 'B12D', 265923),
(446830, 'PF09989', NULL, 'CoA enzyme activase uncharacterised domain (DUF2229)', 216, NULL, 'DUF2229', 265924),
(446831, 'PF17402', NULL, 'Family of unknown function (DUF5408)', 63, NULL, 'DUF5408', 265925),
(446832, 'PF16860', NULL, 'CHCH-CHCH-like Cx9C, IMS import disulfide relay-system,', 44, NULL, 'CX9C', 265926),
(446833, 'PF20597', NULL, 'Putative Ice-binding-like adhesive domain', 257, NULL, 'pAdhesive_15', 265927),
(446834, 'PF08897', NULL, 'Domain of unknown function (DUF1841)', 135, NULL, 'DUF1841', 265928),
(446835, 'PF16670', NULL, 'Phosphoinositide phospholipase C, Ca2+-dependent', 328, NULL, 'PI-PLC-C1', 265929),
(446836, 'PF12123', NULL, 'PlyG Cell wall binding domain', 44, NULL, 'CBD_PlyG', 265930),
(446837, 'PF09674', NULL, 'Protein of unknown function (DUF2400)', 227, NULL, 'DUF2400', 265931),
(446838, 'PF16080', NULL, 'Bacteriophage holin family HP1', 56, NULL, 'Phage_holin_2_3', 265932),
(446839, 'PF05777', NULL, 'Drosophila accessory gland-specific peptide 26Ab (Acp26Ab)', 90, NULL, 'Acp26Ab', 265933),
(446840, 'PF15413', NULL, 'Pleckstrin homology domain', 105, NULL, 'PH_11', 265934),
(446841, 'PF05114', NULL, 'Protein of unknown function (DUF692)', 263, NULL, 'DUF692', 265935),
(446842, 'PF18634', NULL, 'RXLR phytopathogen effector protein WY-domain', 51, NULL, 'RXLR_WY', 265936),
(446843, 'PF16996', NULL, 'Accessory secretory protein Sec Asp4', 55, NULL, 'Asp4', 265937),
(446844, 'PF11655', NULL, 'Protein of unknown function (DUF2589)', 154, NULL, 'DUF2589', 265938),
(446845, 'PF11004', NULL, '3-deoxy-D-manno-oct-2-ulosonic acid (Kdo) hydroxylase', 275, NULL, 'Kdo_hydroxy', 265939),
(446846, 'PF17045', NULL, 'Centrosomal protein of 63 kDa', 263, NULL, 'CEP63', 265940),
(446847, 'PF17790', NULL, 'Macroglobulin domain MG1', 101, NULL, 'MG1', 265941),
(446848, 'PF19931', NULL, 'Family of unknown function (DUF6394)', 90, NULL, 'DUF6394', 265942),
(446849, 'PF14404', NULL, 'Ribosomally synthesized peptide in Streptomyces species', 63, NULL, 'Strep_pep', 265943),
(446850, 'PF09379', NULL, 'FERM N-terminal domain', 64, NULL, 'FERM_N', 265944),
(446851, 'PF13973', NULL, 'Domain of unknown function (DUF4222)', 53, NULL, 'DUF4222', 265945),
(446852, 'PF07208', NULL, 'Protein of unknown function (DUF1414)', 44, NULL, 'DUF1414', 265946),
(446853, 'PF05922', NULL, 'Peptidase inhibitor I9', 82, NULL, 'Inhibitor_I9', 265947),
(446854, 'PF18445', NULL, 'PR zinc knuckle motif', 38, NULL, 'zf_PR_Knuckle', 265948),
(446855, 'PF00910', NULL, 'RNA helicase', 107, NULL, 'RNA_helicase', 265949),
(446856, 'PF01230', NULL, 'HIT domain', 98, NULL, 'HIT', 265950),
(446857, 'PF16288', NULL, 'Domain of unknown function (DUF4934)', 102, NULL, 'DUF4934', 265951),
(446858, 'PF15237', NULL, 'PTRF/SDPR family', 252, NULL, 'PTRF_SDPR', 265952),
(446859, 'PF11198', NULL, 'Protein of unknown function (DUF2857)', 175, NULL, 'DUF2857', 265953);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(446860, 'PF07880', NULL, 'Bacteriophage T4 gp9/10-like protein', 285, NULL, 'T4_gp9_10', 265954),
(446861, 'PF14899', NULL, 'Domain of unknown function (DUF4492)', 63, NULL, 'DUF4492', 265955),
(446862, 'PF10463', NULL, 'Peptidase U49', 198, NULL, 'Peptidase_U49', 265956),
(446863, 'PF16905', NULL, 'Voltage-dependent L-type calcium channel, IQ-associated', 54, NULL, 'GPHH', 265957),
(446864, 'PF02092', NULL, 'Glycyl-tRNA synthetase beta subunit', 534, NULL, 'tRNA_synt_2f', 265958),
(446865, 'PF10310', NULL, 'Family of unknown function (DUF5427)', 463, NULL, 'DUF5427', 265959),
(446866, 'PF12376', NULL, 'Protein of unknown function (DUF3654)', 138, NULL, 'DUF3654', 265960),
(446867, 'PF03673', NULL, 'Uncharacterised protein family (UPF0128)', 221, NULL, 'UPF0128', 265961),
(446868, 'PF18185', NULL, 'Sir2- and TIR-associating SLOG family', 207, NULL, 'STALD', 265962),
(446869, 'PF13767', NULL, 'Domain of unknown function (DUF4168)', 90, NULL, 'DUF4168', 265963),
(446870, 'PF19975', NULL, 'Double-GTPase 1', 273, NULL, 'DO-GTPase1', 265964),
(446871, 'PF15758', NULL, 'Histidine-rich carboxyl terminus protein 1', 78, NULL, 'HRCT1', 265965),
(446872, 'PF02077', NULL, 'SURF4 family', 267, NULL, 'SURF4', 265966),
(446873, 'PF01893', NULL, 'Uncharacterised protein family UPF0058', 87, NULL, 'UPF0058', 265967),
(446874, 'PF04703', NULL, 'FaeA-like protein', 62, NULL, 'FaeA', 265968),
(446875, 'PF07774', NULL, 'ER membrane protein complex subunit 1, C-terminal', 213, NULL, 'EMC1_C', 265969),
(446876, 'PF09191', NULL, 'CD4, extracellular', 107, NULL, 'CD4-extracel', 265970),
(446877, 'PF16919', NULL, 'Protein kinase G rubredoxin domain', 139, NULL, 'PknG_rubred', 265971),
(446878, 'PF20117', NULL, 'Family of unknown function (DUF6507)', 124, NULL, 'DUF6507', 265972),
(446879, 'PF00741', NULL, 'Gas vesicle protein', 39, NULL, 'Gas_vesicle', 265973),
(446880, 'PF01923', NULL, 'Cobalamin adenosyltransferase', 170, NULL, 'Cob_adeno_trans', 265974),
(446881, 'PF10199', NULL, 'Alpha and gamma adaptin binding protein p34', 123, NULL, 'Adaptin_binding', 265975),
(446882, 'PF15091', NULL, 'Domain of unknown function (DUF4554)', 458, NULL, 'DUF4554', 265976),
(446883, 'PF03054', NULL, 'tRNA methyl transferase HUP domain', 202, NULL, 'tRNA_Me_trans', 265977),
(446884, 'PF16886', NULL, 'ATPsynthase alpha/beta subunit N-term extension', 121, NULL, 'ATP-synt_ab_Xtn', 265978),
(446885, 'PF03803', NULL, 'Scramblase', 221, NULL, 'Scramblase', 265979),
(446886, 'PF03978', NULL, 'Borrelia burgdorferi REV protein', 174, NULL, 'Borrelia_REV', 265980),
(446887, 'PF17145', NULL, 'Domain of unknown function (DUF5119)', 195, NULL, 'DUF5119', 265981),
(446888, 'PF17631', NULL, 'Family of unknown function (DUF5512)', 139, NULL, 'DUF5512', 265982),
(446889, 'PF07769', NULL, 'psiF repeat', 34, NULL, 'PsiF_repeat', 265983),
(446890, 'PF04764', NULL, 'Protein of unknown function (DUF613)', 120, NULL, 'DUF613', 265984),
(446891, 'PF18375', NULL, 'CDH1/2 SANT-Helical linker 1', 91, NULL, 'CDH1_2_SANT_HL1', 265985),
(446892, 'PF12081', NULL, 'GldM N-terminal domain', 193, NULL, 'GldM_N', 265986),
(446893, 'PF07839', NULL, 'Plant calmodulin-binding domain', 117, NULL, 'CaM_binding', 265987),
(446894, 'PF19747', NULL, 'Family of unknown function (DUF6234)', 126, NULL, 'DUF6234', 265988),
(446895, 'PF05506', NULL, 'Bacterial phospholipase C, C-terminal domain', 82, NULL, 'PLipase_C_C', 265989),
(446896, 'PF11950', NULL, 'Protein of unknown function (DUF3467)', 92, NULL, 'DUF3467', 265990),
(446897, 'PF15579', NULL, 'Immunity protein 52', 99, NULL, 'Imm52', 265991),
(446898, 'PF19691', NULL, 'Family of unknown function (DUF6192)', 248, NULL, 'DUF6192', 265992),
(446899, 'PF08636', NULL, 'ER protein Pkr1', 73, NULL, 'Pkr1', 265993),
(446900, 'PF11922', NULL, 'Domain of unknown function (DUF3440)', 182, NULL, 'DUF3440', 265994),
(446901, 'PF12048', NULL, 'Protein of unknown function (DUF3530)', 321, NULL, 'DUF3530', 265995),
(446902, 'PF17355', NULL, 'Family of unknown function (DUF5383)', 124, NULL, 'DUF5383', 265996),
(446903, 'PF17838', NULL, 'PH domain', 127, NULL, 'PH_16', 265997);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(446904, 'PF11226', NULL, 'Protein of unknown function (DUF3022)', 105, NULL, 'DUF3022', 265998),
(446905, 'PF02520', NULL, 'SXP/RAL-2 family protein Ani s 5-like, metal-binding domain', 109, NULL, 'ANIS5_cation-bd', 265999),
(446906, 'PF20318', NULL, 'Family of unknown function (DUF6613)', 194, NULL, 'DUF6613', 266000),
(446907, 'PF02730', NULL, 'Aldehyde ferredoxin oxidoreductase, N-terminal domain', 199, NULL, 'AFOR_N', 266001),
(446908, 'PF01870', NULL, 'Archaeal holliday junction resolvase (hjc)', 93, NULL, 'Hjc', 266002),
(446909, 'PF00167', NULL, 'Fibroblast growth factor', 125, NULL, 'FGF', 266003),
(446910, 'PF02580', NULL, 'D-Tyr-tRNA(Tyr) deacylase', 144, NULL, 'Tyr_Deacylase', 266004),
(446911, 'PF15820', NULL, 'Endothelial cell-specific chemotaxis regulator', 103, NULL, 'ECSCR', 266005),
(446912, 'PF02622', NULL, 'Uncharacterized ACR, COG1678', 160, NULL, 'DUF179', 266006),
(446913, 'PF19621', NULL, 'Family of unknown function (DUF6126)', 40, NULL, 'DUF6126', 266007),
(446914, 'PF08922', NULL, 'Domain of unknown function (DUF1905)', 82, NULL, 'DUF1905', 266008),
(446915, 'PF12920', NULL, 'TcdA/TcdB pore forming domain', 655, NULL, 'TcdA_TcdB_pore', 266009),
(446916, 'PF07214', NULL, 'Protein of unknown function (DUF1418)', 94, NULL, 'DUF1418', 266010),
(446917, 'PF14731', NULL, 'Staphopain proregion', 169, NULL, 'Staphopain_pro', 266011),
(446918, 'PF12058', NULL, 'Protein of unknown function (DUF3539)', 86, NULL, 'DUF3539', 266012),
(446919, 'PF06110', NULL, 'Eukaryotic protein of unknown function (DUF953)', 119, NULL, 'DUF953', 266013),
(446920, 'PF11474', NULL, 'Telomerase reverse transcriptase TEN domain', 188, NULL, 'N-Term_TEN', 266014),
(446921, 'PF09364', NULL, 'XFP N-terminal domain', 364, NULL, 'XFP_N', 266015),
(446922, 'PF04561', NULL, 'RNA polymerase Rpb2, domain 2', 190, NULL, 'RNA_pol_Rpb2_2', 266016),
(446923, 'PF05703', NULL, 'Auxin canalisation', 257, NULL, 'Auxin_canalis', 266017),
(446924, 'PF19500', NULL, 'Family of unknown function (DUF6035)', 548, NULL, 'DUF6035', 266018),
(446925, 'PF07475', NULL, 'HPr Serine kinase C-terminal domain', 171, NULL, 'Hpr_kinase_C', 266019),
(446926, 'PF15052', NULL, 'TMEM169 protein family', 131, NULL, 'TMEM169', 266020),
(446927, 'PF09329', NULL, 'Primase zinc finger', 46, NULL, 'zf-primase', 266021),
(446928, 'PF20281', NULL, 'C-terminal domain 5 of the ABC-three component (ABC-3C) systems', 207, NULL, 'CTD5', 266022),
(446929, 'PF06898', NULL, 'Putative stage IV sporulation protein YqfD', 379, NULL, 'YqfD', 266023),
(446930, 'PF16374', NULL, 'Cycle inhibiting factor (CIF)', 136, NULL, 'CIF', 266024),
(446931, 'PF19853', NULL, 'Family of unknown function (DUF6328)', 142, NULL, 'DUF6328', 266025),
(446932, 'PF04790', NULL, 'Sarcoglycan complex subunit protein', 260, NULL, 'Sarcoglycan_1', 266026),
(446933, 'PF01448', NULL, 'ELM2 domain', 53, NULL, 'ELM2', 266027),
(446934, 'PF01666', NULL, 'DX module', 76, NULL, 'DX', 266028),
(446935, 'PF09297', NULL, 'NADH pyrophosphatase zinc ribbon domain', 32, NULL, 'zf-NADH-PPase', 266029),
(446936, 'PF05368', NULL, 'NmrA-like family', 233, NULL, 'NmrA', 266030),
(446937, 'PF17916', NULL, 'LIM interaction domain (LID)', 29, NULL, 'LID', 266031),
(446938, 'PF02545', NULL, 'Maf-like protein', 189, NULL, 'Maf', 266032),
(446939, 'PF12921', NULL, 'Mitochondrial ATPase expression', 115, NULL, 'ATP13', 266033),
(446940, 'PF20194', NULL, 'Family of unknown function (DUF6557)', 144, NULL, 'DUF6557', 266034),
(446941, 'PF15723', NULL, 'Motility quorum-sensing regulator, toxin of MqsA', 96, NULL, 'MqsR_toxin', 266035),
(446942, 'PF09843', NULL, 'Predicted membrane protein (DUF2070)', 561, NULL, 'DUF2070', 266036),
(446943, 'PF03312', NULL, 'Protein of unknown function (DUF272)', 124, NULL, 'DUF272', 266037),
(446944, 'PF16422', NULL, 'Transcription factor COE1 DNA-binding domain', 231, NULL, 'COE1_DBD', 266038),
(446945, 'PF10785', NULL, 'NADH-ubiquinone oxidoreductase complex I, 21 kDa subunit', 82, NULL, 'NADH-u_ox-rdase', 266039),
(446946, 'PF19227', NULL, 'Salyut domain', 51, NULL, 'Salyut', 266040);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(446947, 'PF07358', NULL, 'Protein of unknown function (DUF1482)', 57, NULL, 'DUF1482', 266041),
(446948, 'PF11088', NULL, 'Glycoprotein encoding membrane proteins RL5A and RL6', 99, NULL, 'RL11D', 266042),
(446949, 'PF00171', NULL, 'Aldehyde dehydrogenase family', 462, NULL, 'Aldedh', 266043),
(446950, 'PF03126', NULL, 'Plus-3 domain', 109, NULL, 'Plus-3', 266044),
(446951, 'PF05960', NULL, 'Bacterial protein of unknown function (DUF885)', 529, NULL, 'DUF885', 266045),
(446952, 'PF15607', NULL, 'Bacterial toxin 44', 100, NULL, 'Ntox44', 266046),
(446953, 'PF15583', NULL, 'Immunity protein 68', 152, NULL, 'Imm68', 266047),
(446954, 'PF01994', NULL, 'tRNA ribose 2''-O-methyltransferase, aTrm56', 119, NULL, 'Trm56', 266048),
(446955, 'PF03113', NULL, 'Respiratory synctial virus non-structural protein NS2', 124, NULL, 'RSV_NS2', 266049),
(446956, 'PF05438', NULL, 'Thyrotropin-releasing hormone (TRH)', 221, NULL, 'TRH', 266050),
(446957, 'PF12828', NULL, 'PX-associated', 130, NULL, 'PXB', 266051),
(446958, 'PF10186', NULL, 'Vacuolar sorting 38 and autophagy-related subunit 14', 324, NULL, 'ATG14', 266052),
(446959, 'PF19486', NULL, 'Family of unknown function (DUF6022)', 155, NULL, 'DUF6022', 266053),
(446960, 'PF20087', NULL, 'Family of unknown function (DUF6479)', 119, NULL, 'DUF6479', 266054),
(446961, 'PF19439', NULL, 'CLEC16A C-terminal', 766, NULL, 'CLEC16A_C', 266055),
(446962, 'PF19857', NULL, 'Family of unknown function (DUF6332)', 86, NULL, 'DUF6332', 266056),
(446963, 'PF12068', NULL, 'Rab-binding domain (RBD)', 170, NULL, 'PH_RBD', 266057),
(446964, 'PF03002', NULL, 'Somatostatin/Cortistatin family', 18, NULL, 'Somatostatin', 266058),
(446965, 'PF20366', NULL, 'Family of unknown function (DUF6661)', 174, NULL, 'DUF6661', 266059),
(446966, 'PF16301', NULL, 'Domain of unknown function (DUF4943)', 150, NULL, 'DUF4943', 266060),
(446967, 'PF17361', NULL, 'Family of unknown function (DUF5387)', 222, NULL, 'DUF5387', 266061),
(446968, 'PF14985', NULL, 'TM140 protein family', 180, NULL, 'TM140', 266062),
(446969, 'PF02816', NULL, 'Alpha-kinase family', 185, NULL, 'Alpha_kinase', 266063),
(446970, 'PF07394', NULL, 'Protein of unknown function (DUF1501)', 390, NULL, 'DUF1501', 266064),
(446971, 'PF17186', NULL, 'Lipocalin-like domain', 132, NULL, 'Lipocalin_9', 266065),
(446972, 'PF12193', NULL, 'Sulfolobus virus coat protein C terminal', 134, NULL, 'Sulf_coat_C', 266066),
(446973, 'PF14509', NULL, 'Glycosyl-hydrolase 97 C-terminal, oligomerisation', 97, NULL, 'GH97_C', 266067),
(446974, 'PF11139', NULL, 'Sap, sulfolipid-1-addressing protein', 214, NULL, 'SfLAP', 266068),
(446975, 'PF07988', NULL, 'LMSTEN motif', 47, NULL, 'LMSTEN', 266069),
(446976, 'PF11853', NULL, 'Protein of unknown function (DUF3373)', 409, NULL, 'DUF3373', 266070),
(446977, 'PF04712', NULL, 'Radial spokehead-like protein', 495, NULL, 'Radial_spoke', 266071),
(446978, 'PF02453', NULL, 'Reticulon', 157, NULL, 'Reticulon', 266072),
(446979, 'PF05687', NULL, 'BES1/BZR1 plant transcription factor, N-terminal', 151, NULL, 'BES1_N', 266073),
(446980, 'PF15420', NULL, 'Alpha/beta-hydrolase family N-terminus', 209, NULL, 'Abhydrolase_9_N', 266074),
(446981, 'PF18181', NULL, 'SMODS and SLOG-associating 2TM effector domain 1', 122, NULL, 'SLATT_1', 266075),
(446982, 'PF09749', NULL, 'Uncharacterised conserved protein', 243, NULL, 'HVSL', 266076),
(446983, 'PF19422', NULL, 'Ariadne domain', 262, NULL, 'Ariadne', 266077),
(446984, 'PF07192', NULL, 'SNURF/RPN4 protein', 69, NULL, 'SNURF', 266078),
(446985, 'PF14149', NULL, 'YhfH-like protein', 37, NULL, 'YhfH', 266079),
(446986, 'PF00076', NULL, 'RNA recognition motif. (a.k.a. RRM, RBD, or RNP domain)', 70, NULL, 'RRM_1', 266080),
(446987, 'PF13806', NULL, 'Rieske-like [2Fe-2S] domain', 104, NULL, 'Rieske_2', 266081),
(446988, 'PF16213', NULL, 'Dimerisation and cyclophilin-binding domain of Mon2', 176, NULL, 'DCB', 266082),
(446989, 'PF15463', NULL, 'Extracellular mutant protein 11', 133, NULL, 'ECM11', 266083),
(446990, 'PF03601', NULL, 'Conserved hypothetical protein 698', 305, NULL, 'Cons_hypoth698', 266084);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(446991, 'PF10262', NULL, 'Rdx family', 74, NULL, 'Rdx', 266085),
(446992, 'PF14390', NULL, 'Putative  PD-(D/E)XK family member, (DUF4420)', 305, NULL, 'DUF4420', 266086),
(446993, 'PF00539', NULL, 'Transactivating regulatory protein (Tat)', 63, NULL, 'Tat', 266087),
(446994, 'PF20445', NULL, 'Retrotransposon hot spot proteins N-terminal', 127, NULL, 'RHS_N', 266088),
(446995, 'PF07397', NULL, 'Repeat of unknown function (DUF1502)', 34, NULL, 'DUF1502', 266089),
(446996, 'PF02562', NULL, 'PhoH-like protein', 205, NULL, 'PhoH', 266090),
(446997, 'PF14214', NULL, 'Helitron helicase-like domain at N-terminus', 190, NULL, 'Helitron_like_N', 266091),
(446998, 'PF12369', NULL, 'Gonadotropin hormone receptor transmembrane region', 68, NULL, 'GnHR_trans', 266092),
(446999, 'PF04385', NULL, 'Domain of unknown function, DUF529', 78, NULL, 'FAINT', 266093),
(447000, 'PF14848', NULL, 'DNA-binding domain', 124, NULL, 'HU-DNA_bdg', 266094),
(447001, 'PF14979', NULL, 'Transmembrane 52', 149, NULL, 'TMEM52', 266095),
(447002, 'PF12997', NULL, 'Domain of unknown function, E. rectale Gene description (DUF3881)', 283, NULL, 'DUF3881', 266096),
(447003, 'PF16967', NULL, 'E-set like domain', 68, NULL, 'TcfC', 266097),
(447004, 'PF06984', NULL, 'Mitochondrial 39-S ribosomal protein L47 (MRP-L47)', 87, NULL, 'MRP-L47', 266098),
(447005, 'PF08820', NULL, 'Domain of unknown function (DUF1803)', 93, NULL, 'DUF1803', 266099),
(447006, 'PF19111', NULL, 'Family of unknown function (DUF5798)', 89, NULL, 'DUF5798', 266100),
(447007, 'PF06102', NULL, 'rRNA biogenesis protein RRP36', 166, NULL, 'RRP36', 266101),
(447008, 'PF07738', NULL, 'Sad1 / UNC-like C-terminal', 131, NULL, 'Sad1_UNC', 266102),
(447009, 'PF03421', NULL, 'YopJ Serine/Threonine acetyltransferase', 177, NULL, 'Acetyltransf_14', 266103),
(447010, 'PF06565', NULL, 'DM10 domain', 105, NULL, 'DM10_dom', 266104),
(447011, 'PF19247', NULL, 'Family of unknown function (DUF5895)', 153, NULL, 'DUF5895', 266105),
(447012, 'PF14952', NULL, 'Putative treble-clef, zinc-finger, Zn-binding', 42, NULL, 'zf-tcix', 266106),
(447013, 'PF05773', NULL, 'RWD domain', 116, NULL, 'RWD', 266107),
(447014, 'PF12495', NULL, 'Vegetative insecticide protein 3A N terminal', 177, NULL, 'Vip3A_N', 266108),
(447015, 'PF01974', NULL, 'tRNA intron endonuclease, catalytic C-terminal domain', 85, NULL, 'tRNA_int_endo', 266109),
(447016, 'PF19075', NULL, 'Family of unknown function (DUF5771)', 69, NULL, 'DUF5771', 266110),
(447017, 'PF03580', NULL, 'Herpesvirus UL14-like protein', 146, NULL, 'Herpes_UL14', 266111),
(447018, 'PF03235', NULL, 'Protein of unknown function DUF262', 221, NULL, 'DUF262', 266112),
(447019, 'PF08876', NULL, 'Domain of unknown function (DUF1836)', 105, NULL, 'DUF1836', 266113),
(447020, 'PF01680', NULL, 'SOR/SNZ family', 207, NULL, 'SOR_SNZ', 266114),
(447021, 'PF20499', NULL, 'Domain of unknown function (DUF6729)', 232, NULL, 'DUF6729', 266115),
(447022, 'PF16900', NULL, 'Replication protein A OB domain', 98, NULL, 'REPA_OB_2', 266116),
(447023, 'PF17435', NULL, 'Family of unknown function (DUF5414)', 183, NULL, 'DUF5414', 266117),
(447024, 'PF12238', NULL, 'Merozoite surface antigen 2c', 216, NULL, 'MSA-2c', 266118),
(447025, 'PF15333', NULL, 'TATA box-binding protein-associated factor 1D', 220, NULL, 'TAF1D', 266119),
(447026, 'PF08803', NULL, 'Putative mono-oxygenase ydhR', 96, NULL, 'ydhR', 266120),
(447027, 'PF20278', NULL, 'C-terminal domain 2 of the ABC-three component (ABC-3C) systems', 330, NULL, 'CTD2', 266121),
(447028, 'PF05999', NULL, 'Herpesvirus U5-like family', 441, NULL, 'Herpes_U5', 266122),
(447029, 'PF08323', NULL, 'Starch synthase catalytic domain', 244, NULL, 'Glyco_transf_5', 266123),
(447030, 'PF14843', NULL, 'Growth factor receptor domain IV', 132, NULL, 'GF_recep_IV', 266124),
(447031, 'PF11766', NULL, 'Cell-wall agglutinin N-terminal ligand-sugar binding', 249, NULL, 'Candida_ALS_N', 266125),
(447032, 'PF19346', NULL, 'Family of unknown function (DUF5924)', 259, NULL, 'DUF5924', 266126),
(447033, 'PF00937', NULL, 'Coronavirus nucleocapsid', 342, NULL, 'CoV_nucleocap', 266127);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(447034, 'PF16893', NULL, 'Fibronectin type III domain', 89, NULL, 'fn3_2', 266128),
(447035, 'PF00015', NULL, 'Methyl-accepting chemotaxis protein (MCP) signalling domain', 172, NULL, 'MCPsignal', 266129),
(447036, 'PF11732', NULL, 'Transcription- and export-related complex subunit', 76, NULL, 'Thoc2', 266130),
(447037, 'PF02384', NULL, 'N-6 DNA Methylase', 310, NULL, 'N6_Mtase', 266131),
(447038, 'PF03917', NULL, 'Eukaryotic glutathione synthase, ATP binding domain', 365, NULL, 'GSH_synth_ATP', 266132),
(447039, 'PF11110', NULL, 'Baseplate hub distal subunit', 154, NULL, 'Phage_hub_GP28', 266133),
(447040, 'PF14678', NULL, 'FANCI solenoid 4', 254, NULL, 'FANCI_S4', 266134),
(447041, 'PF02674', NULL, 'Colicin V production protein', 144, NULL, 'Colicin_V', 266135),
(447042, 'PF07993', NULL, 'Male sterility protein', 257, NULL, 'NAD_binding_4', 266136),
(447043, 'PF13917', NULL, 'Zinc knuckle', 41, NULL, 'zf-CCHC_3', 266137),
(447044, 'PF18486', NULL, 'PNGase/UBA- or UBX-containing domain', 64, NULL, 'PUB_1', 266138),
(447045, 'PF01646', NULL, 'Herpes virus proteins UL24 and UL76', 177, NULL, 'Herpes_UL24', 266139),
(447046, 'PF06252', NULL, 'Bacteriophage Mu, GemA protein', 118, NULL, 'GemA', 266140),
(447047, 'PF20198', NULL, 'Family of unknown function (DUF6561)', 83, NULL, 'DUF6561', 266141),
(447048, 'PF17141', NULL, 'Domain of unknown function (DUF5114)', 88, NULL, 'DUF5114', 266142),
(447049, 'PF13001', NULL, 'Proteasome stabiliser', 498, NULL, 'Ecm29', 266143),
(447050, 'PF16829', NULL, 'Avirulence protein ATR13, RxLR effector', 101, NULL, 'ATR13', 266144),
(447051, 'PF01262', NULL, 'Alanine dehydrogenase/PNT, C-terminal domain', 214, NULL, 'AlaDh_PNT_C', 266145),
(447052, 'PF15062', NULL, 'Haemopoietic lineage transmembrane helix', 86, NULL, 'ARL6IP6', 266146),
(447053, 'PF02489', NULL, 'Herpesvirus glycoprotein H main domain', 512, NULL, 'Herpes_glycop_H', 266147),
(447054, 'PF09660', NULL, 'Protein of unknown function (DUF2397)', 483, NULL, 'DUF2397', 266148),
(447055, 'PF12434', NULL, 'Malate dehydrogenase enzyme', 32, NULL, 'Malate_DH', 266149),
(447056, 'PF00870', NULL, 'P53 DNA-binding domain', 187, NULL, 'P53', 266150),
(447057, 'PF01275', NULL, 'Myelin proteolipid protein (PLP or lipophilin)', 235, NULL, 'Myelin_PLP', 266151),
(447058, 'PF03677', NULL, 'Uncharacterised protein family (UPF0137)', 237, NULL, 'UPF0137', 266152),
(447059, 'PF19108', NULL, 'Family of unknown function (DUF5795)', 74, NULL, 'DUF5795', 266153),
(447060, 'PF15417', NULL, 'Domain of unknown function (DUF4624)', 132, NULL, 'DUF4624', 266154),
(447061, 'PF06988', NULL, 'NifT/FixU protein', 64, NULL, 'NifT', 266155),
(447062, 'PF12125', NULL, 'D domain of beta-TrCP', 39, NULL, 'Beta-TrCP_D', 266156),
(447063, 'PF13824', NULL, 'Zinc-finger of mitochondrial splicing suppressor 51', 57, NULL, 'zf-Mss51', 266157),
(447064, 'PF02198', NULL, 'Sterile alpha motif (SAM)/Pointed domain', 83, NULL, 'SAM_PNT', 266158),
(447065, 'PF11358', NULL, 'Protein of unknown function (DUF3158)', 156, NULL, 'DUF3158', 266159),
(447066, 'PF12321', NULL, 'Protein of unknown function (DUF3634)', 102, NULL, 'DUF3634', 266160),
(447067, 'PF14502', NULL, 'Helix-turn-helix domain', 48, NULL, 'HTH_41', 266161),
(447068, 'PF14109', NULL, 'GldH lipoprotein', 128, NULL, 'GldH_lipo', 266162),
(447069, 'PF14995', NULL, 'Transmembrane protein', 123, NULL, 'TMEM107', 266163),
(447070, 'PF13539', NULL, 'D-alanyl-D-alanine carboxypeptidase', 67, NULL, 'Peptidase_M15_4', 266164),
(447071, 'PF10387', NULL, 'Protein of unknown function (DUF2442)', 79, NULL, 'DUF2442', 266165),
(447072, 'PF18162', NULL, 'Arc C-lobe', 83, NULL, 'Arc_C', 266166),
(447073, 'PF15504', NULL, 'Domain of unknown function (DUF4647)', 467, NULL, 'DUF4647', 266167),
(447074, 'PF05933', NULL, 'Fungal ATP synthase protein 8 (A6L)', 48, NULL, 'Fun_ATP-synt_8', 266168),
(447075, 'PF18973', NULL, 'Putative Chitin binding like', 49, NULL, 'CBL', 266169),
(447076, 'PF10530', NULL, 'Toxin with inhibitor cystine knot ICK or Knottin scaffold', 61, NULL, 'Toxin_35', 266170),
(447077, 'PF14933', NULL, 'CEP19-like protein', 165, NULL, 'CEP19', 266171);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(447078, 'PF05148', NULL, 'Hypothetical methyltransferase', 219, NULL, 'Methyltransf_8', 266172),
(447079, 'PF05448', NULL, 'Acetyl xylan esterase (AXE1)', 318, NULL, 'AXE1', 266173),
(447080, 'PF02921', NULL, 'Ubiquinol cytochrome reductase transmembrane region', 66, NULL, 'UCR_TM', 266174),
(447081, 'PF08279', NULL, 'HTH domain', 55, NULL, 'HTH_11', 266175),
(447082, 'PF03423', NULL, 'Carbohydrate binding domain (family 25)', 105, NULL, 'CBM_25', 266176),
(447083, 'PF04007', NULL, 'Protein of unknown function (DUF354)', 340, NULL, 'DUF354', 266177),
(447084, 'PF02617', NULL, 'ATP-dependent Clp protease adaptor protein ClpS', 80, NULL, 'ClpS', 266178),
(447085, 'PF05023', NULL, 'Phytochelatin synthase', 210, NULL, 'Phytochelatin', 266179),
(447086, 'PF19463', NULL, 'Family of unknown function (DUF6000)', 185, NULL, 'DUF6000', 266180),
(447087, 'PF20077', NULL, 'CcmD family protein', 61, NULL, 'CcmD_alt', 266181),
(447088, 'PF19461', NULL, 'Family of unknown function (DUF5998)', 179, NULL, 'DUF5998', 266182),
(447089, 'PF07179', NULL, 'SseB protein N-terminal domain', 126, NULL, 'SseB', 266183),
(447090, 'PF10397', NULL, 'Adenylosuccinate lyase C-terminus', 77, NULL, 'ADSL_C', 266184),
(447091, 'PF02364', NULL, '1,3-beta-glucan synthase component', 819, NULL, 'Glucan_synthase', 266185),
(447092, 'PF10357', NULL, 'Domain of Kin17 curved DNA-binding protein', 126, NULL, 'Kin17_mid', 266186),
(447093, 'PF09209', NULL, 'HTH-type transcriptional dual regulator CecR, C-terminal domain', 125, NULL, 'CecR_C', 266187),
(447094, 'PF01380', NULL, 'SIS domain', 131, NULL, 'SIS', 266188),
(447095, 'PF08096', NULL, 'Bombolitin family', 17, NULL, 'Bombolitin', 266189),
(447096, 'PF09969', NULL, 'Uncharacterized conserved protein (DUF2203)', 122, NULL, 'DUF2203', 266190),
(447097, 'PF12368', NULL, 'Rhodanase C-terminal', 67, NULL, 'Rhodanese_C', 266191),
(447098, 'PF09982', NULL, 'Uncharacterized protein conserved in bacteria (DUF2219)', 290, NULL, 'DUF2219', 266192),
(447099, 'PF06690', NULL, 'FeGP cofactor biosynthesis protein, methyltransferase HcgC', 248, NULL, 'HcgC', 266193),
(447100, 'PF09302', NULL, 'XLF-Cernunnos, XRcc4-like factor, NHEJ component', 180, NULL, 'XLF', 266194),
(447101, 'PF04502', NULL, 'Saf4/Yju2 protein', 331, NULL, 'Saf4_Yju2', 266195),
(447102, 'PF03961', NULL, 'Flagellar Assembly Protein A beta solenoid domain', 272, NULL, 'FapA', 266196),
(447103, 'PF15434', NULL, 'Family 104', 110, NULL, 'FAM104', 266197),
(447104, 'PF14205', NULL, 'Cysteine-rich KTR', 54, NULL, 'Cys_rich_KTR', 266198),
(447105, 'PF00374', NULL, 'Nickel-dependent hydrogenase', 508, NULL, 'NiFeSe_Hases', 266199),
(447106, 'PF08227', NULL, 'DASH complex subunit Hsk3 like', 45, NULL, 'DASH_Hsk3', 266200),
(447107, 'PF13879', NULL, 'Hemingway/CFA97', 102, NULL, 'Hmw_CFAP97', 266201),
(447108, 'PF10563', NULL, 'Delta carbonic anhydrase', 178, NULL, 'CA_like', 266202),
(447109, 'PF12837', NULL, '4Fe-4S binding domain', 24, NULL, 'Fer4_6', 266203),
(447110, 'PF15186', NULL, 'Testis-expressed sequence 13 protein family', 150, NULL, 'TEX13', 266204),
(447111, 'PF02753', NULL, 'Pili assembly chaperone PapD, C-terminal domain', 63, NULL, 'PapD_C', 266205),
(447112, 'PF13549', NULL, 'ATP-grasp domain', 222, NULL, 'ATP-grasp_5', 266206),
(447113, 'PF20215', NULL, 'Family of unknown function (DUF6575)', 217, NULL, 'DUF6575', 266207),
(447114, 'PF16838', NULL, 'Caudoviral major tail protein N-terminus', 116, NULL, 'Caud_tail_N', 266208),
(447115, 'PF09004', NULL, 'Alkylated DNA repair protein alkB homolog 8, N-terminal', 42, NULL, 'ALKBH8_N', 266209),
(447116, 'PF11148', NULL, 'Protein of unknown function (DUF2922)', 67, NULL, 'DUF2922', 266210),
(447117, 'PF17665', NULL, 'Family of unknown function (DUF5527)', 139, NULL, 'DUF5527', 266211),
(447118, 'PF03067', NULL, 'Lytic polysaccharide mono-oxygenase, cellulose-degrading', 193, NULL, 'LPMO_10', 266212),
(447119, 'PF11145', NULL, 'Protein of unknown function (DUF2921)', 887, NULL, 'DUF2921', 266213),
(447120, 'PF07201', NULL, 'HrpJ-like domain', 166, NULL, 'HrpJ', 266214);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(447121, 'PF12546', NULL, 'Blue/Ultraviolet sensing protein C terminal', 121, NULL, 'Cryptochrome_C', 266215),
(447122, 'PF18269', NULL, 'T3SS EscN ATPase C-terminal domain', 72, NULL, 'T3SS_ATPase_C', 266216),
(447123, 'PF14610', NULL, 'Ykl077w/Psg1 (Pma1 Stabilization in Golgi)', 194, NULL, 'Psg1', 266217),
(447124, 'PF15865', NULL, 'Fanconi anaemia group A protein N terminus', 355, NULL, 'Fanconi_A_N', 266218),
(447125, 'PF02727', NULL, 'Copper amine oxidase, N2 domain', 87, NULL, 'Cu_amine_oxidN2', 266219),
(447126, 'PF10673', NULL, 'Protein of unknown function (DUF2487)', 142, NULL, 'DUF2487', 266220),
(447127, 'PF13112', NULL, 'Protein of unknown function (DUF3965)', 291, NULL, 'DUF3965', 266221),
(447128, 'PF17295', NULL, 'Domain of unknown function (DUF5348)', 70, NULL, 'DUF5348', 266222),
(447129, 'PF00044', NULL, 'Glyceraldehyde 3-phosphate dehydrogenase, NAD binding domain', 101, NULL, 'Gp_dh_N', 266223),
(447130, 'PF13803', NULL, 'Domain of unknown function (DUF4184)', 217, NULL, 'DUF4184', 266224),
(447131, 'PF03633', NULL, 'Glycosyl hydrolase family 65, C-terminal domain', 51, NULL, 'Glyco_hydro_65C', 266225),
(447132, 'PF13975', NULL, 'gag-polyprotein putative aspartyl protease', 92, NULL, 'gag-asp_proteas', 266226),
(447133, 'PF18996', NULL, 'Family of unknown function (DUF5726)', 90, NULL, 'DUF5726', 266227),
(447134, 'PF19710', NULL, 'PIK3 catalytic subunit gamma adaptor-binding domain', 195, NULL, 'PIK3CG_ABD', 266228),
(447135, 'PF03003', NULL, 'Pox virus entry-fusion-complex G9/A16', 128, NULL, 'Pox_G9-A16', 266229),
(447136, 'PF08395', NULL, '7tm Chemosensory receptor', 370, NULL, '7tm_7', 266230),
(447137, 'PF18749', NULL, 'Secreted Novel AID/APOBEC-like Deaminase 3', 379, NULL, 'SNAD3', 266231),
(447138, 'PF16103', NULL, 'Domain of unknown function (DUF4822)', 123, NULL, 'DUF4822', 266232),
(447139, 'PF14491', NULL, 'Protein of unknown function (DUF4435)', 237, NULL, 'DUF4435', 266233),
(447140, 'PF04964', NULL, 'Flp/Fap pilin component', 46, NULL, 'Flp_Fap', 266234),
(447141, 'PF20250', NULL, 'Flagellar Assembly Protein A N-terminal region', 176, NULL, 'FapA_N', 266235),
(447142, 'PF20420', NULL, 'Domain of unknown function (DUF6702)', 141, NULL, 'DUF6702', 266236),
(447143, 'PF09767', NULL, 'Predicted membrane protein (DUF2053)', 160, NULL, 'DUF2053', 266237),
(447144, 'PF16751', NULL, 'Anti-sigma-D factor RsdA to sigma factor binding region', 46, NULL, 'RsdA_SigD_bd', 266238),
(447145, 'PF17469', NULL, 'Gp68-like predicted RNA polymerase component', 78, NULL, 'GP68', 266239),
(447146, 'PF08442', NULL, 'ATP-grasp domain', 202, NULL, 'ATP-grasp_2', 266240),
(447147, 'PF20601', NULL, 'Domain of unknown function (DUF6797)', 96, NULL, 'DUF6797', 266241),
(447148, 'PF11951', NULL, 'Fungal specific transcription factor domain', 384, NULL, 'Fungal_trans_2', 266242),
(447149, 'PF05612', NULL, 'Leg1', 331, NULL, 'Leg1', 266243),
(447150, 'PF05028', NULL, 'Poly (ADP-ribose) glycohydrolase (PARG)', 336, NULL, 'PARG_cat', 266244),
(447151, 'PF12860', NULL, 'PAS fold', 115, NULL, 'PAS_7', 266245),
(447152, 'PF02074', NULL, 'Carboxypeptidase Taq (M32) metallopeptidase', 490, NULL, 'Peptidase_M32', 266246),
(447153, 'PF04496', NULL, 'Herpesvirus UL35 family', 109, NULL, 'Herpes_UL35', 266247),
(447154, 'PF03281', NULL, 'Mab-21 protein nucleotidyltransferase domain', 201, NULL, 'Mab-21', 266248),
(447155, 'PF08526', NULL, 'Protein-arginine deiminase (PAD) N-terminal domain', 113, NULL, 'PAD_N', 266249),
(447156, 'PF11165', NULL, 'Protein of unknown function (DUF2949)', 56, NULL, 'DUF2949', 266250),
(447157, 'PF09991', NULL, 'Predicted membrane protein (DUF2232)', 290, NULL, 'DUF2232', 266251),
(447158, 'PF00536', NULL, 'SAM domain (Sterile alpha motif)', 64, NULL, 'SAM_1', 266252),
(447159, 'PF19955', NULL, 'Effector-associated domain 1', 90, NULL, 'EAD1', 266253),
(447160, 'PF00801', NULL, 'PKD domain', 71, NULL, 'PKD', 266254),
(447161, 'PF08310', NULL, 'LGFP repeat', 53, NULL, 'LGFP', 266255),
(447162, 'PF13058', NULL, 'Protein of unknown function (DUF3920)', 126, NULL, 'DUF3920', 266256);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(447163, 'PF14931', NULL, 'Intraflagellar transport complex B, subunit 20', 119, NULL, 'IFT20', 266257),
(447164, 'PF13669', NULL, 'Glyoxalase/Bleomycin resistance protein/Dioxygenase superfamily', 109, NULL, 'Glyoxalase_4', 266258),
(447165, 'PF20025', NULL, 'Family of unknown function (DUF6433)', 115, NULL, 'DUF6433', 266259),
(447166, 'PF02086', NULL, 'D12 class N6 adenine-specific DNA methyltransferase', 260, NULL, 'MethyltransfD12', 266260),
(447167, 'PF08641', NULL, 'Kinetochore protein Mis14 like', 134, NULL, 'Mis14', 266261),
(447168, 'PF16226', NULL, 'Domain of unknown function (DUF4885)', 325, NULL, 'DUF4885', 266262),
(447169, 'PF03341', NULL, 'Poxvirus mRNA capping enzyme, small subunit', 286, NULL, 'Pox_mRNA-cap', 266263),
(447170, 'PF09902', NULL, 'Uncharacterized protein conserved in bacteria (DUF2129)', 70, NULL, 'DUF2129', 266264),
(447171, 'PF06817', NULL, 'Reverse transcriptase thumb domain', 66, NULL, 'RVT_thumb', 266265),
(447172, 'PF08268', NULL, 'F-box associated domain', 128, NULL, 'FBA_3', 266266),
(447173, 'PF00950', NULL, 'ABC 3 transport family', 258, NULL, 'ABC-3', 266267),
(447174, 'PF08281', NULL, 'Sigma-70, region 4', 54, NULL, 'Sigma70_r4_2', 266268),
(447175, 'PF18333', NULL, 'Non-canonical single-stranded DNA-binding domain', 106, NULL, 'ssDNA_DBD', 266269),
(447176, 'PF02962', NULL, '5-carboxymethyl-2-hydroxymuconate isomerase', 125, NULL, 'CHMI', 266270),
(447177, 'PF10867', NULL, 'Protein of unknown function (DUF2664)', 89, NULL, 'DUF2664', 266271),
(447178, 'PF14832', NULL, 'Putative oxalocrotonate tautomerase enzyme', 137, NULL, 'Tautomerase_3', 266272),
(447179, 'PF11539', NULL, 'Protein of unknown function (DUF3228)', 194, NULL, 'DUF3228', 266273),
(447180, 'PF02410', NULL, 'Ribosomal silencing factor during starvation', 100, NULL, 'RsfS', 266274),
(447181, 'PF04851', NULL, 'Type III restriction enzyme, res subunit', 171, NULL, 'ResIII', 266275),
(447182, 'PF00840', NULL, 'Glycosyl hydrolase family 7', 434, NULL, 'Glyco_hydro_7', 266276),
(447183, 'PF09483', NULL, 'Type III secretion protein (HpaP)', 90, NULL, 'HpaP', 266277),
(447184, 'PF02372', NULL, 'Interleukin 15', 135, NULL, 'IL15', 266278),
(447185, 'PF17908', NULL, 'APAF-1 helical domain', 135, NULL, 'APAF1_C', 266279),
(447186, 'PF08356', NULL, 'EF hand associated', 87, NULL, 'EF_assoc_2', 266280),
(447187, 'PF17740', NULL, 'Family of unknown function (DUF5577)', 307, NULL, 'DUF5577', 266281),
(447188, 'PF03100', NULL, 'CcmE', 128, NULL, 'CcmE', 266282),
(447189, 'PF14475', NULL, 'Sec1-binding region of Mso1', 40, NULL, 'Mso1_Sec1_bdg', 266283),
(447190, 'PF02278', NULL, 'Polysaccharide lyase family 8, super-sandwich domain', 254, NULL, 'Lyase_8', 266284),
(447191, 'PF16434', NULL, 'Domain of unknown function (DUF5031)', 377, NULL, 'DUF5031', 266285),
(447192, 'PF19828', NULL, 'Family of unknown function (DUF6309)', 186, NULL, 'DUF6309', 266286),
(447193, 'PF20438', NULL, 'Stage IV sporulation protein A, middle domain', 179, NULL, 'SpoIVA_middle', 266287),
(447194, 'PF14088', NULL, 'Domain of unknown function (DUF4268)', 140, NULL, 'DUF4268', 266288),
(447195, 'PF14262', NULL, 'Carbohydrate-binding domain-containing protein Cthe_2159', 262, NULL, 'Cthe_2159', 266289),
(447196, 'PF09536', NULL, 'Protein of unknown function (DUF2378)', 177, NULL, 'DUF2378', 266290),
(447197, 'PF13462', NULL, 'Thioredoxin', 165, NULL, 'Thioredoxin_4', 266291),
(447198, 'PF16498', NULL, 'SWIRM-associated domain at the C-terminal', 67, NULL, 'SWIRM-assoc_3', 266292),
(447199, 'PF05183', NULL, 'RNA dependent RNA polymerase', 586, NULL, 'RdRP', 266293),
(447200, 'PF14059', NULL, 'Domain of unknown function (DUF4251)', 134, NULL, 'DUF4251', 266294),
(447201, 'PF05208', NULL, 'ALG3 protein', 358, NULL, 'ALG3', 266295),
(447202, 'PF03256', NULL, 'Anaphase-promoting complex, subunit 10 (APC10)', 185, NULL, 'ANAPC10', 266296),
(447203, 'PF05015', NULL, 'RelE-like toxin of type II toxin-antitoxin system HigB', 93, NULL, 'HigB-like_toxin', 266297),
(447204, 'PF12474', NULL, 'Polo kinase kinase', 139, NULL, 'PKK', 266298);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(447205, 'PF18046', NULL, 'FKBP26_C-terminal', 72, NULL, 'FKBP26_C', 266299),
(447206, 'PF06061', NULL, 'Baculoviridae ME53', 330, NULL, 'Baculo_ME53', 266300),
(447207, 'PF07867', NULL, 'Protein of unknown function (DUF1654)', 70, NULL, 'DUF1654', 266301),
(447208, 'PF12286', NULL, 'Protein of unknown function (DUF3622)', 71, NULL, 'DUF3622', 266302),
(447209, 'PF03210', NULL, 'Paramyxovirus P/V phosphoprotein C-terminal', 178, NULL, 'Paramyx_P_V_C', 266303),
(447210, 'PF09840', NULL, 'Uncharacterized protein conserved in archaea (DUF2067)', 186, NULL, 'DUF2067', 266304),
(447211, 'PF14372', NULL, 'Domain of unknown function (DUF4413)', 98, NULL, 'DUF4413', 266305),
(447212, 'PF20363', NULL, 'Family of unknown function (DUF6658)', 178, NULL, 'DUF6658', 266306),
(447213, 'PF11041', NULL, 'Protein of unknown function (DUF2612)', 183, NULL, 'DUF2612', 266307),
(447214, 'PF04535', NULL, 'Casparian strip membrane protein domain', 150, NULL, 'CASP_dom', 266308),
(447215, 'PF00216', NULL, 'Bacterial DNA-binding protein', 90, NULL, 'Bac_DNA_binding', 266309),
(447216, 'PF05696', NULL, 'Protein of unknown function (DUF826)', 65, NULL, 'DUF826', 266310),
(447217, 'PF15952', NULL, 'Enhancer of split M4 family', 177, NULL, 'ESM4', 266311),
(447218, 'PF15674', NULL, 'Coiled-coil domain-containing protein 23', 63, NULL, 'CCDC23', 266312),
(447219, 'PF06657', NULL, 'Centrosome microtubule-binding domain of Cep57', 77, NULL, 'Cep57_MT_bd', 266313),
(447220, 'PF06900', NULL, 'Protein of unknown function (DUF1270)', 53, NULL, 'DUF1270', 266314),
(447221, 'PF08273', NULL, 'Zinc-binding domain of primase-helicase', 38, NULL, 'Prim_Zn_Ribbon', 266315),
(447222, 'PF08611', NULL, 'Fungal protein of unknown function (DUF1774)', 95, NULL, 'DUF1774', 266316),
(447223, 'PF05995', NULL, 'Cysteine dioxygenase type I', 170, NULL, 'CDO_I', 266317),
(447224, 'PF02325', NULL, 'YGGT family', 69, NULL, 'YGGT', 266318),
(447225, 'PF11703', NULL, 'UPF0506', 59, NULL, 'UPF0506', 266319),
(447226, 'PF15202', NULL, 'Adipogenin', 79, NULL, 'Adipogenin', 266320),
(447227, 'PF18002', NULL, 'T6 antigen Ig like domain', 145, NULL, 'T6_Ig_like', 266321),
(447228, 'PF14625', NULL, 'Lustrin, cysteine-rich repeated domain', 45, NULL, 'Lustrin_cystein', 266322),
(447229, 'PF15794', NULL, 'Coiled-coil domain-containing protein 106', 223, NULL, 'CCDC106', 266323),
(447230, 'PF01601', NULL, 'Coronavirus spike glycoprotein S2', 525, NULL, 'CoV_S2', 266324),
(447231, 'PF07027', NULL, 'Protein of unknown function (DUF1318)', 93, NULL, 'DUF1318', 266325),
(447232, 'PF01441', NULL, 'Lipoprotein', 170, NULL, 'Lipoprotein_6', 266326),
(447233, 'PF05121', NULL, 'Gas vesicle protein K', 85, NULL, 'GvpK', 266327),
(447234, 'PF06527', NULL, 'TniQ', 137, NULL, 'TniQ', 266328),
(447235, 'PF03328', NULL, 'HpcH/HpaI aldolase/citrate lyase family', 221, NULL, 'HpcH_HpaI', 266329),
(447236, 'PF19718', NULL, 'Ubiquitin carboxyl-terminal hydrolase 47 C-terminal', 240, NULL, 'USP47_C', 266330),
(447237, 'PF14591', NULL, 'AF0941-like', 113, NULL, 'AF0941-like', 266331),
(447238, 'PF02771', NULL, 'Acyl-CoA dehydrogenase, N-terminal domain', 113, NULL, 'Acyl-CoA_dh_N', 266332),
(447239, 'PF07327', NULL, 'Neuroparsin', 103, NULL, 'Neuroparsin', 266333),
(447240, 'PF00806', NULL, 'Pumilio-family RNA binding repeat', 35, NULL, 'PUF', 266334),
(447241, 'PF08538', NULL, 'Protein of unknown function (DUF1749)', 299, NULL, 'DUF1749', 266335),
(447242, 'PF12347', NULL, 'Holliday junction regulator protein family C-terminal repeat', 63, NULL, 'HJURP_C', 266336),
(447243, 'PF07366', NULL, 'SnoaL-like polyketide cyclase', 126, NULL, 'SnoaL', 266337),
(447244, 'PF11850', NULL, 'Protein of unknown function (DUF3370)', 422, NULL, 'DUF3370', 266338),
(447245, 'PF02575', NULL, 'YbaB/EbfC DNA-binding family', 90, NULL, 'YbaB_DNA_bd', 266339),
(447246, 'PF16826', NULL, 'Domain of unknown function (DUF5076)', 84, NULL, 'DUF5076', 266340),
(447247, 'PF03538', NULL, 'Salmonella virulence plasmid 28.1kDa A protein', 329, NULL, 'VRP1', 266341),
(447248, 'PF19102', NULL, 'Family of unknown function (DUF5789)', 74, NULL, 'DUF5789', 266342);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(447249, 'PF01471', NULL, 'Putative peptidoglycan binding domain', 57, NULL, 'PG_binding_1', 266343),
(447250, 'PF06799', NULL, 'Conserved in the green lineage and diatoms 27', 143, NULL, 'CGLD27-like', 266344),
(447251, 'PF11051', NULL, 'Mannosyltransferase putative', 273, NULL, 'Mannosyl_trans3', 266345),
(447252, 'PF10696', NULL, 'Protein of unknown function (DUF2501)', 78, NULL, 'DUF2501', 266346),
(447253, 'PF07942', NULL, 'Carnosine N-methyltransferase', 272, NULL, 'CARME', 266347),
(447254, 'PF10380', NULL, 'Transcription factor CRF1', 113, NULL, 'CRF1', 266348),
(447255, 'PF05548', NULL, 'Gametolysin peptidase M11', 314, NULL, 'Peptidase_M11', 266349),
(447256, 'PF17617', NULL, 'Viral unique short region 10', 161, NULL, 'US10', 266350),
(447257, 'PF02513', NULL, 'Spin/Ssty Family', 50, NULL, 'Spin-Ssty', 266351),
(447258, 'PF05481', NULL, 'Mycobacterium 19 kDa lipoprotein antigen', 118, NULL, 'Myco_19_kDa', 266352),
(447259, 'PF20620', NULL, 'Family of unknown function (DUF6805)', 133, NULL, 'DUF6805', 266353),
(447260, 'PF10966', NULL, 'Protein of unknown function (DUF2768)', 58, NULL, 'DUF2768', 266354),
(447261, 'PF14239', NULL, 'RRXRR protein', 174, NULL, 'RRXRR', 266355),
(447262, 'PF08793', NULL, '2-cysteine adaptor domain', 35, NULL, '2C_adapt', 266356),
(447263, 'PF18489', NULL, 'Alpha helical domain', 127, NULL, 'Alpha_Helical', 266357),
(447264, 'PF14866', NULL, 'Potassium channel toxin', 57, NULL, 'Toxin_38', 266358),
(447265, 'PF20241', NULL, 'Domain of unknown function (DUF6598)', 241, NULL, 'DUF6598', 266359),
(447266, 'PF07677', NULL, 'A-macroglobulin receptor binding domain', 94, NULL, 'A2M_recep', 266360),
(447267, 'PF09958', NULL, 'Uncharacterized protein conserved in archaea (DUF2192)', 229, NULL, 'DUF2192', 266361),
(447268, 'PF13261', NULL, 'Protein of unknown function (DUF4052)', 217, NULL, 'DUF4052', 266362),
(447269, 'PF04783', NULL, 'Protein of unknown function (DUF630)', 59, NULL, 'DUF630', 266363),
(447270, 'PF03548', NULL, 'Outer membrane lipoprotein carrier protein LolA', 165, NULL, 'LolA', 266364),
(447271, 'PF13203', NULL, 'Putative metallopeptidase domain', 273, NULL, 'DUF2201_N', 266365),
(447272, 'PF10523', NULL, 'BEN domain', 77, NULL, 'BEN', 266366),
(447273, 'PF12208', NULL, 'Domain of unknown function (DUF3601)', 79, NULL, 'DUF3601', 266367),
(447274, 'PF16229', NULL, 'Domain of unknown function (DUF4888)', 141, NULL, 'DUF4888', 266368),
(447275, 'PF07691', NULL, 'PA14 domain', 147, NULL, 'PA14', 266369),
(447276, 'PF13281', NULL, 'MAP3K TRAFs-binding domain', 369, NULL, 'MAP3K_TRAF_bd', 266370),
(447277, 'PF05140', NULL, 'ResB-like family', 496, NULL, 'ResB', 266371),
(447278, 'PF17800', NULL, 'Nucleoplasmin-like domain', 114, NULL, 'NPL', 266372),
(447279, 'PF17192', NULL, 'MukF middle domain', 161, NULL, 'MukF_M', 266373),
(447280, 'PF00008', NULL, 'EGF-like domain', 32, NULL, 'EGF', 266374),
(447281, 'PF11888', NULL, 'Protein of unknown function (DUF3408)', 139, NULL, 'DUF3408', 266375),
(447282, 'PF01783', NULL, 'Ribosomal L32p protein family', 56, NULL, 'Ribosomal_L32p', 266376),
(447283, 'PF02906', NULL, 'Iron only hydrogenase large subunit, C-terminal domain', 243, NULL, 'Fe_hyd_lg_C', 266377),
(447284, 'PF13430', NULL, 'Domain of unknown function (DUF4112)', 105, NULL, 'DUF4112', 266378),
(447285, 'PF08580', NULL, 'Yeast cortical protein KAR9', 678, NULL, 'KAR9', 266379),
(447286, 'PF11820', NULL, 'Protein of unknown function (DUF3339)', 67, NULL, 'DUF3339', 266380),
(447287, 'PF19825', NULL, 'Domain of unknown function (DUF6306)', 129, NULL, 'DUF6306', 266381),
(447288, 'PF15989', NULL, 'Domain of unknown function (DUF4768)', 88, NULL, 'DUF4768', 266382),
(447289, 'PF11751', NULL, 'Type IX secretion system membrane protein PorP/SprF', 273, NULL, 'PorP_SprF', 266383),
(447290, 'PF02887', NULL, 'Pyruvate kinase, alpha/beta domain', 116, NULL, 'PK_C', 266384),
(447291, 'PF05327', NULL, 'RNA polymerase I specific transcription initiation factor RRN3', 556, NULL, 'RRN3', 266385),
(447292, 'PF07077', NULL, 'Protein of unknown function (DUF1345)', 173, NULL, 'DUF1345', 266386);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(447293, 'PF20375', NULL, 'Family of unknown function (DUF6670)', 294, NULL, 'DUF6670', 266387),
(447294, 'PF00165', NULL, 'Bacterial regulatory helix-turn-helix proteins, AraC family', 42, NULL, 'HTH_AraC', 266388),
(447295, 'PF20560', NULL, 'Motility protein A N-terminal', 91, NULL, 'MotA_N', 266389),
(447296, 'PF05534', NULL, 'HicB family', 51, NULL, 'HicB', 266390),
(447297, 'PF05158', NULL, 'RNA polymerase Rpc34 subunit', 336, NULL, 'RNA_pol_Rpc34', 266391),
(447298, 'PF15140', NULL, 'Domain of unknown function (DUF4573)', 176, NULL, 'DUF4573', 266392),
(447299, 'PF18228', NULL, 'CdiI N-terminal domain', 108, NULL, 'CdiI_N', 266393),
(447300, 'PF00556', NULL, 'Antenna complex alpha/beta subunit', 39, NULL, 'LHC', 266394),
(447301, 'PF15019', NULL, 'C9orf72-like protein family', 243, NULL, 'C9orf72-like', 266395),
(447302, 'PF06224', NULL, 'Winged helix DNA-binding domain', 329, NULL, 'HTH_42', 266396),
(447303, 'PF18110', NULL, 'BRCC36 C-terminal helical domain', 81, NULL, 'BRCC36_C', 266397),
(447304, 'PF00351', NULL, 'Biopterin-dependent aromatic amino acid hydroxylase', 331, NULL, 'Biopterin_H', 266398),
(447305, 'PF02073', NULL, 'Thermophilic metalloprotease (M29)', 406, NULL, 'Peptidase_M29', 266399),
(447306, 'PF19515', NULL, 'Domain of unknown function (DUF6048)', 233, NULL, 'DUF6048', 266400),
(447307, 'PF03174', NULL, 'Chitobiase/beta-hexosaminidase C-terminal domain', 75, NULL, 'CHB_HEX_C', 266401),
(447308, 'PF10744', NULL, 'Mediator of RNA polymerase II transcription subunit 1', 414, NULL, 'Med1', 266402),
(447309, 'PF08905', NULL, 'Domain of unknown function (DUF1850)', 86, NULL, 'DUF1850', 266403),
(447310, 'PF19664', NULL, 'Family of unknown function (DUF6167)', 96, NULL, 'DUF6167', 266404),
(447311, 'PF20360', NULL, 'Family of unknown function (DUF6655)', 259, NULL, 'DUF6655', 266405),
(447312, 'PF18580', NULL, 'SUN2 helix-turn-helix domain', 58, NULL, 'HTH_SUN2', 266406),
(447313, 'PF16979', NULL, 'SAPK-interacting protein 1 (Sin1), Pleckstrin-homology', 108, NULL, 'SIN1_PH', 266407),
(447314, 'PF06835', NULL, 'Lipopolysaccharide-assembly, LptC-related', 175, NULL, 'LptC', 266408),
(447315, 'PF12213', NULL, 'DNA polymerases epsilon N terminal', 73, NULL, 'Dpoe2NT', 266409),
(447316, 'PF08616', NULL, 'Stabilization of polarity axis', 113, NULL, 'SPA', 266410),
(447317, 'PF04521', NULL, 'ssRNA positive strand viral 18kD cysteine rich protein', 122, NULL, 'Viral_P18', 266411),
(447318, 'PF08848', NULL, 'Domain of unknown function (DUF1818)', 113, NULL, 'DUF1818', 266412),
(447319, 'PF10727', NULL, 'Rossmann-like domain', 127, NULL, 'Rossmann-like', 266413),
(447320, 'PF17336', NULL, 'Family of unknown function (DUF5368)', 111, NULL, 'DUF5368', 266414),
(447321, 'PF03838', NULL, 'Recombination protein U', 162, NULL, 'RecU', 266415),
(447322, 'PF15105', NULL, 'TMEM61 protein family', 189, NULL, 'TMEM61', 266416),
(447323, 'PF17076', NULL, 'SBE2, cell-wall formation', 820, NULL, 'SBE2', 266417),
(447324, 'PF01722', NULL, 'BolA-like protein', 78, NULL, 'BolA', 266418),
(447325, 'PF01315', NULL, 'Aldehyde oxidase and xanthine dehydrogenase, a/b hammerhead domain', 110, NULL, 'Ald_Xan_dh_C', 266419),
(447326, 'PF19788', NULL, 'Family of unknown function (DUF6272)', 134, NULL, 'DUF6272', 266420),
(447327, 'PF03885', NULL, 'Protein of unknown function (DUF327)', 143, NULL, 'DUF327', 266421),
(447328, 'PF10336', NULL, 'Protein of unknown function (DUF2420)', 108, NULL, 'DUF2420', 266422),
(447329, 'PF12951', NULL, 'Passenger-associated-transport-repeat', 30, NULL, 'PATR', 266423),
(447330, 'PF11688', NULL, 'Protein of unknown function (DUF3285)', 44, NULL, 'DUF3285', 266424),
(447331, 'PF16711', NULL, 'Actin-binding domain of plant-specific actin-binding protein', 43, NULL, 'SCAB-ABD', 266425),
(447332, 'PF02357', NULL, 'Transcription termination factor nusG', 98, NULL, 'NusG', 266426),
(447333, 'PF09644', NULL, 'Mg296 protein', 126, NULL, 'Mg296', 266427),
(447334, 'PF10939', NULL, 'Protein of unknown function (DUF2631)', 66, NULL, 'DUF2631', 266428),
(447335, 'PF06959', NULL, 'RecQ helicase protein-like 5 (RecQ5)', 203, NULL, 'RecQ5', 266429);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(447336, 'PF05650', NULL, 'Domain of unknown function (DUF802)', 53, NULL, 'DUF802', 266430),
(447337, 'PF10926', NULL, 'Protein of unknown function (DUF2800)', 365, NULL, 'DUF2800', 266431),
(447338, 'PF18926', NULL, '2TM family of unknown function (DUF5676)', 82, NULL, 'DUF5676', 266432),
(447339, 'PF09612', NULL, 'Bacterial protein of unknown function (HtrL_YibB)', 267, NULL, 'HtrL_YibB', 266433),
(447340, 'PF02474', NULL, 'Nodulation protein A (NodA)', 195, NULL, 'NodA', 266434),
(447341, 'PF15479', NULL, 'Domain of unknown function (DUF4639)', 580, NULL, 'DUF4639', 266435),
(447342, 'PF02880', NULL, 'Phosphoglucomutase/phosphomannomutase, alpha/beta/alpha domain III', 114, NULL, 'PGM_PMM_III', 266436),
(447343, 'PF15233', NULL, 'Synaptonemal complex central element protein 1', 152, NULL, 'SYCE1', 266437),
(447344, 'PF14464', NULL, 'Prokaryotic homologs of the JAB domain', 117, NULL, 'Prok-JAB', 266438),
(447345, 'PF15540', NULL, 'Bacterial toxin 47', 112, NULL, 'Ntox47', 266439),
(447346, 'PF09924', NULL, 'Phosphatidylglycerol lysyltransferase, C-terminal', 299, NULL, 'LPG_synthase_C', 266440),
(447347, 'PF13837', NULL, 'Myb/SANT-like DNA-binding domain', 90, NULL, 'Myb_DNA-bind_4', 266441),
(447348, 'PF04904', NULL, 'NAB conserved region 1 (NCD1)', 79, NULL, 'NCD1', 266442),
(447349, 'PF03915', NULL, 'Actin interacting protein 3', 408, NULL, 'AIP3', 266443),
(447350, 'PF12815', NULL, 'Spt5 C-terminal nonapeptide repeat binding Spt4', 71, NULL, 'CTD', 266444),
(447351, 'PF07964', NULL, 'Rec10 / Red1', 754, NULL, 'Red1', 266445),
(447352, 'PF13650', NULL, 'Aspartyl protease', 90, NULL, 'Asp_protease_2', 266446),
(447353, 'PF02689', NULL, 'Helicase', 809, NULL, 'Herpes_Helicase', 266447),
(447354, 'PF01020', NULL, 'Ribosomal L40e family', 50, NULL, 'Ribosomal_L40e', 266448),
(447355, 'PF11310', NULL, 'Protein of unknown function (DUF3113)', 60, NULL, 'DUF3113', 266449),
(447356, 'PF16466', NULL, 'Domain of unknown function (DUF5047)', 134, NULL, 'DUF5047', 266450),
(447357, 'PF06415', NULL, 'BPG-independent PGAM N-terminus (iPGM_N)', 215, NULL, 'iPGM_N', 266451),
(447358, 'PF09485', NULL, 'CRISPR-associated protein Cse2 (CRISPR_cse2)', 138, NULL, 'CRISPR_Cse2', 266452),
(447359, 'PF09514', NULL, 'SSXRD motif', 31, NULL, 'SSXRD', 266453),
(447360, 'PF11212', NULL, 'Protein of unknown function (DUF2999)', 82, NULL, 'DUF2999', 266454),
(447361, 'PF01922', NULL, 'SRP19 protein', 95, NULL, 'SRP19', 266455),
(447362, 'PF02736', NULL, 'Myosin N-terminal SH3-like domain', 45, NULL, 'Myosin_N', 266456),
(447363, 'PF19360', NULL, 'TadB/TadC N-terminal domain', 143, NULL, 'TadB_TadC_N', 266457),
(447364, 'PF01132', NULL, 'Elongation factor P (EF-P) OB domain', 54, NULL, 'EFP', 266458),
(447365, 'PF03052', NULL, 'Adenoviral protein L1 52/55-kDa', 201, NULL, 'Adeno_52K', 266459),
(447366, 'PF14434', NULL, 'Immunity protein Imm6', 121, NULL, 'Imm6', 266460),
(447367, 'PF12585', NULL, 'Protein of unknown function (DUF3759)', 92, NULL, 'DUF3759', 266461),
(447368, 'PF16297', NULL, 'Domain of unknown function (DUF4939)', 112, NULL, 'DUF4939', 266462),
(447369, 'PF19722', NULL, 'Sentrin-specific protease 3/5 N-terminal', 575, NULL, 'SENP3_5_N', 266463),
(447370, 'PF19088', NULL, 'TUTase nucleotidyltransferase domain', 218, NULL, 'TUTase', 266464),
(447371, 'PF09424', NULL, 'Yqey-like protein', 143, NULL, 'YqeY', 266465),
(447372, 'PF09265', NULL, 'Cytokinin dehydrogenase 1, FAD and cytokinin binding', 281, NULL, 'Cytokin-bind', 266466),
(447373, 'PF01029', NULL, 'NusB family', 134, NULL, 'NusB', 266467),
(447374, 'PF12407', NULL, 'Homeobox protein', 24, NULL, 'Abdominal-A', 266468),
(447375, 'PF14117', NULL, 'Domain of unknown function (DUF4287)', 60, NULL, 'DUF4287', 266469),
(447376, 'PF04924', NULL, 'Poxvirus A6 protein', 370, NULL, 'Pox_A6', 266470),
(447377, 'PF14303', NULL, 'No apical meristem-associated C-terminal domain', 165, NULL, 'NAM-associated', 266471),
(447378, 'PF17299', NULL, 'Family of unknown function (DUF5350)', 57, NULL, 'DUF5350', 266472),
(447379, 'PF05293', NULL, 'African swine fever virus (ASFV) L11L protein', 78, NULL, 'ASFV_L11L', 266473);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(447380, 'PF14653', NULL, 'Insulin growth factor-like family', 83, NULL, 'IGFL', 266474),
(447381, 'PF17337', NULL, 'Galactose-inhibitable lectin 35 kDa subunit', 225, NULL, 'Gal_GalNac_35kD', 266475),
(447382, 'PF03399', NULL, 'SAC3/GANP family', 289, NULL, 'SAC3_GANP', 266476),
(447383, 'PF12204', NULL, 'Domain of unknown function (DUF3598)', 265, NULL, 'DUF3598', 266477),
(447384, 'PF16534', NULL, 'Ubiquitin-like oligomerisation domain of SATB', 109, NULL, 'ULD', 266478),
(447385, 'PF13207', NULL, 'AAA domain', 136, NULL, 'AAA_17', 266479),
(447386, 'PF10692', NULL, 'Protein of unknown function (DUF2498)', 79, NULL, 'DUF2498', 266480),
(447387, 'PF01659', NULL, 'Luteovirus putative VPg genome linked protein', 104, NULL, 'Luteo_Vpg', 266481),
(447388, 'PF19661', NULL, 'Family of unknown function (DUF6164)', 116, NULL, 'DUF6164', 266482),
(447389, 'PF00599', NULL, 'Influenza Matrix protein (M2)', 97, NULL, 'Flu_M2', 266483),
(447390, 'PF13698', NULL, 'Domain of unknown function (DUF4156)', 90, NULL, 'DUF4156', 266484),
(447391, 'PF16612', NULL, 'C-terminal unstructured region of RGS12', 146, NULL, 'RGS12_usC', 266485),
(447392, 'PF18995', NULL, 'Proteolysis_6 C-terminal', 456, NULL, 'PRT6_C', 266486),
(447393, 'PF04808', NULL, 'Citrus tristeza virus (CTV) P23 protein', 209, NULL, 'CTV_P23', 266487),
(447394, 'PF04194', NULL, 'Programmed cell death protein 2, C-terminal putative domain', 112, NULL, 'PDCD2_C', 266488),
(447395, 'PF12566', NULL, 'Protein of unknown function (DUF3748)', 123, NULL, 'DUF3748', 266489),
(447396, 'PF12897', NULL, 'Aspartate amino-transferase', 421, NULL, 'Asp_aminotransf', 266490),
(447397, 'PF09037', NULL, 'Stf0 sulphotransferase', 244, NULL, 'Sulphotransf', 266491),
(447398, 'PF01872', NULL, 'RibD C-terminal domain', 200, NULL, 'RibD_C', 266492),
(447399, 'PF05068', NULL, 'Mannitol repressor', 164, NULL, 'MtlR', 266493),
(447400, 'PF03850', NULL, 'Transcription factor Tfb4', 276, NULL, 'Tfb4', 266494),
(447401, 'PF01218', NULL, 'Coproporphyrinogen III oxidase', 303, NULL, 'Coprogen_oxidas', 266495),
(447402, 'PF04972', NULL, 'BON domain', 69, NULL, 'BON', 266496),
(447403, 'PF07541', NULL, 'Eukaryotic translation initiation factor 2 alpha subunit', 114, NULL, 'EIF_2_alpha', 266497),
(447404, 'PF11287', NULL, 'Protein of unknown function (DUF3088)', 112, NULL, 'DUF3088', 266498),
(447405, 'PF06422', NULL, 'CDR ABC transporter', 92, NULL, 'PDR_CDR', 266499),
(447406, 'PF14723', NULL, 'Sperm-specific antigen 2 C-terminus', 171, NULL, 'SSFA2_C', 266500),
(447407, 'PF16207', NULL, 'RAWUL domain RING finger- and  WD40-associated ubiquitin-like', 73, NULL, 'RAWUL', 266501),
(447408, 'PF14198', NULL, 'Transposon-encoded protein TnpV', 112, NULL, 'TnpV', 266502),
(447409, 'PF16291', NULL, 'Domain of unknown function (DUF4937', 89, NULL, 'DUF4937', 266503),
(447410, 'PF08430', NULL, 'Forkhead N-terminal region', 136, NULL, 'Forkhead_N', 266504),
(447411, 'PF18923', NULL, 'Domain of unknown function (DUF5673)', 66, NULL, 'DUF5673', 266505),
(447412, 'PF10702', NULL, 'Protein of unknown function (DUF2507)', 123, NULL, 'DUF2507', 266506),
(447413, 'PF15765', NULL, 'Domain of unknown function (DUF4694)', 155, NULL, 'DUF4694', 266507),
(447414, 'PF00674', NULL, 'DUP family', 103, NULL, 'DUP', 266508),
(447415, 'PF14187', NULL, 'Domain of unknown function (DUF4310)', 209, NULL, 'DUF4310', 266509),
(447416, 'PF00792', NULL, 'Phosphoinositide 3-kinase C2', 140, NULL, 'PI3K_C2', 266510),
(447417, 'PF07346', NULL, 'Protein of unknown function (DUF1477)', 118, NULL, 'DUF1477', 266511),
(447418, 'PF04448', NULL, 'Protein of unknown function (DUF551)', 69, NULL, 'DUF551', 266512),
(447419, 'PF07762', NULL, 'Protein of unknown function (DUF1618)', 137, NULL, 'DUF1618', 266513),
(447420, 'PF10453', NULL, 'Nuclear fragile X mental retardation-interacting protein 1 (NUFIP1)', 53, NULL, 'NUFIP1', 266514),
(447421, 'PF07671', NULL, 'Protein of unknown function (DUF1601)', 37, NULL, 'DUF1601', 266515),
(447422, 'PF09598', NULL, 'Stm1', 65, NULL, 'Stm1_N', 266516),
(447423, 'PF15338', NULL, 'p53-regulated apoptosis-inducing protein 1', 123, NULL, 'TPIP1', 266517); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(447424, 'PF19116', NULL, 'Domain of unknown function (DUF5801)', 154, NULL, 'DUF5801', 266518),
(447425, 'PF20488', NULL, 'Birnavirus RNA dependent RNA polymerase (VP1), thumb domain', 167, NULL, 'Birna_VP1_thumb', 266519),
(447426, 'PF05317', NULL, 'Thermopsin', 260, NULL, 'Thermopsin', 266520),
(447427, 'PF20469', NULL, 'Overcoming lysogenization defect protein-like, TOPRIM domain', 67, NULL, 'OLD-like_TOPRIM', 266521),
(447428, 'PF16050', NULL, 'Paf1 complex subunit CDC73 N-terminal', 301, NULL, 'CDC73_N', 266522),
(447429, 'PF04428', NULL, 'Choline kinase N terminus', 51, NULL, 'Choline_kin_N', 266523),
(447430, 'PF16223', NULL, 'Domain of unknown function (DUF4882)', 267, NULL, 'DUF4882', 266524),
(447431, 'PF06807', NULL, 'Pre-mRNA cleavage complex II protein Clp1', 117, NULL, 'Clp1', 266525),
(447432, 'PF07454', NULL, 'Stage II sporulation protein P (SpoIIP)', 264, NULL, 'SpoIIP', 266526),
(447433, 'PF05393', NULL, 'Human adenovirus early E3A glycoprotein', 100, NULL, 'Hum_adeno_E3A', 266527),
(447434, 'PF14272', NULL, 'Glycine-rich SFCGS', 114, NULL, 'Gly_rich_SFCGS', 266528),
(447435, 'PF04289', NULL, 'Protein of unknown function (DUF447)', 176, NULL, 'DUF447', 266529),
(447436, 'PF19963', NULL, 'vWA-MoxR associated protein middle region (VMAP-M) 1', 115, NULL, 'VMAP-M1', 266530),
(447437, 'PF15760', NULL, 'Leukemia-associated protein 7', 194, NULL, 'DLEU7', 266531),
(447438, 'PF16792', NULL, 'Phage tail base-plate attachment protein of Caudovirales ORF16', 372, NULL, 'Caudo_bapla16', 266532),
(447439, 'PF18845', NULL, 'Bacterial archaeo-eukaryotic release factor family 3', 167, NULL, 'baeRF_family3', 266533),
(447440, 'PF15161', NULL, 'Neuropeptide-like', 61, NULL, 'Neuropep_like', 266534),
(447441, 'PF15683', NULL, 'Testis development-related protein', 147, NULL, 'TDRP', 266535),
(447442, 'PF09550', NULL, 'Phage tail assembly chaperone protein, TAC', 58, NULL, 'Phage_TAC_6', 266536),
(447443, 'PF08673', NULL, 'Phosphoserine phosphatase RsbU, N-terminal domain', 75, NULL, 'RsbU_N', 266537),
(447444, 'PF19594', NULL, 'Family of unknown function (DUF6099)', 142, NULL, 'DUF6099', 266538),
(447445, 'PF00564', NULL, 'PB1 domain', 84, NULL, 'PB1', 266539),
(447446, 'PF06378', NULL, 'Protein of unknown function (DUF1071)', 151, NULL, 'DUF1071', 266540),
(447447, 'PF09256', NULL, 'BAFF-R, TALL-1 binding', 30, NULL, 'BaffR-Tall_bind', 266541),
(447448, 'PF07514', NULL, 'Putative helicase', 327, NULL, 'TraI_2', 266542),
(447449, 'PF20494', NULL, 'Lipoprotein YfjS/YafY domain', 113, NULL, 'YfjS_YafY', 266543),
(447450, 'PF17368', NULL, 'Spore morphogenesis and germination YwcE', 85, NULL, 'YwcE', 266544),
(447451, 'PF02321', NULL, 'Outer membrane efflux protein', 188, NULL, 'OEP', 266545),
(447452, 'PF06404', NULL, 'Phytosulfokine precursor protein (PSK)', 90, NULL, 'PSK', 266546),
(447453, 'PF19475', NULL, 'Family of unknown function (DUF6012)', 203, NULL, 'DUF6012', 266547),
(447454, 'PF17380', NULL, 'Family of unknown function (DUF5401)', 721, NULL, 'DUF5401', 266548),
(447455, 'PF13604', NULL, 'AAA domain', 192, NULL, 'AAA_30', 266549),
(447456, 'PF12846', NULL, 'AAA-like domain', 362, NULL, 'AAA_10', 266550),
(447457, 'PF09899', NULL, 'Putative amidoligase enzyme (DUF2126)', 821, NULL, 'DUF2126', 266551),
(447458, 'PF05839', NULL, 'Apc13p protein', 89, NULL, 'Apc13p', 266552),
(447459, 'PF04627', NULL, 'Mitochondrial ATP synthase epsilon chain', 49, NULL, 'ATP-synt_Eps', 266553),
(447460, 'PF13788', NULL, 'Domain of unknown function (DUF4180)', 112, NULL, 'DUF4180', 266554),
(447461, 'PF00402', NULL, 'Calponin family repeat', 25, NULL, 'Calponin', 266555),
(447462, 'PF11987', NULL, 'Translation-initiation factor 2', 116, NULL, 'IF-2', 266556),
(447463, 'PF13465', NULL, 'Zinc-finger double domain', 26, NULL, 'zf-H2C2_2', 266557),
(447464, 'PF20146', NULL, 'Nose resistant-to-fluoxetine protein, N-terminal domain', 123, NULL, 'NRF', 266558),
(447465, 'PF11125', NULL, 'Bacteriophage MS2, lysis protein', 54, NULL, 'Phage_MS2_lysis', 266559),
(447466, 'PF15364', NULL, 'PAXIP1-associated-protein-1 C term PTIP binding protein', 132, NULL, 'PAXIP1_C', 266560);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(447467, 'PF17541', NULL, 'Type VI secretion system, TssC, VipB', 430, NULL, 'TssC', 266561),
(447468, 'PF18576', NULL, 'Helix-turn-helix domain', 64, NULL, 'HTH_52', 266562),
(447469, 'PF12451', NULL, 'Vacuolar protein sorting protein 11 C terminal', 45, NULL, 'VPS11_C', 266563),
(447470, 'PF05681', NULL, 'Fumarate hydratase (Fumerase)', 269, NULL, 'Fumerase', 266564),
(447471, 'PF12851', NULL, 'Oxygenase domain of the 2OGFeDO superfamily', 335, NULL, 'Tet_JBP', 266565),
(447472, 'PF13352', NULL, 'Protein of unknown function (DUF4100)', 216, NULL, 'DUF4100', 266566),
(447473, 'PF13776', NULL, 'Domain of unknown function (DUF4172)', 82, NULL, 'DUF4172', 266567),
(447474, 'PF02671', NULL, 'Paired amphipathic helix repeat', 45, NULL, 'PAH', 266568),
(447475, 'PF15325', NULL, 'Modulator of retrovirus infection', 100, NULL, 'MRI', 266569),
(447476, 'PF15762', NULL, 'Domain of unknown function (DUF4691)', 179, NULL, 'DUF4691', 266570),
(447477, 'PF07314', NULL, 'Protein of unknown function (DUF1461)', 181, NULL, 'DUF1461', 266571),
(447478, 'PF18353', NULL, 'Phosphoglucose isomerase N-terminal domain', 112, NULL, 'PG_isomerase_N', 266572),
(447479, 'PF06488', NULL, 'Phage tail tube protein', 218, NULL, 'L_lac_phage_MSP', 266573),
(447480, 'PF09330', NULL, 'D-lactate dehydrogenase, membrane binding', 290, NULL, 'Lact-deh-memb', 266574),
(447481, 'PF00395', NULL, 'S-layer homology domain', 44, NULL, 'SLH', 266575),
(447482, 'PF03493', NULL, 'Calcium-activated BK potassium channel alpha subunit', 89, NULL, 'BK_channel_a', 266576),
(447483, 'PF11532', NULL, 'HnRNP M nuclear localisation signal', 30, NULL, 'HnRNP_M_NLS', 266577),
(447484, 'PF19035', NULL, 'CCN3 Nov like TSP1 domain', 44, NULL, 'TSP1_CCN', 266578),
(447485, 'PF09493', NULL, 'Tryptophan-rich protein (DUF2389)', 62, NULL, 'DUF2389', 266579),
(447486, 'PF10740', NULL, 'Domain of unknown function (DUF2529)', 170, NULL, 'DUF2529', 266580),
(447487, 'PF19573', NULL, 'Domain of unknown function (DUF6089)', 226, NULL, 'DUF6089', 266581),
(447488, 'PF00415', NULL, 'Regulator of chromosome condensation (RCC1) repeat', 50, NULL, 'RCC1', 266582),
(447489, 'PF02370', NULL, 'M protein repeat', 21, NULL, 'M', 266583),
(447490, 'PF01770', NULL, 'Reduced folate carrier', 412, NULL, 'Folate_carrier', 266584),
(447491, 'PF03500', NULL, 'Cellulose synthase subunit D', 144, NULL, 'Cellsynth_D', 266585),
(447492, 'PF00869', NULL, 'Flavivirus glycoprotein, central and dimerisation domains', 295, NULL, 'Flavi_glycoprot', 266586),
(447493, 'PF16107', NULL, 'Domain of unknown function (DUF4825)', 99, NULL, 'DUF4825', 266587),
(447494, 'PF08675', NULL, 'RNA binding domain', 79, NULL, 'RNA_bind', 266588),
(447495, 'PF01715', NULL, 'IPP transferase', 242, NULL, 'IPPT', 266589),
(447496, 'PF16951', NULL, 'Putative methionine and alanine importer, small subunit', 60, NULL, 'MaAIMP_sms', 266590),
(447497, 'PF16491', NULL, 'CAAX prenyl protease N-terminal, five membrane helices', 181, NULL, 'Peptidase_M48_N', 266591),
(447498, 'PF14747', NULL, 'Domain of unknown function (DUF4473)', 78, NULL, 'DUF4473', 266592),
(447499, 'PF10060', NULL, 'Uncharacterized membrane protein (DUF2298)', 500, NULL, 'DUF2298', 266593),
(447500, 'PF00460', NULL, 'Flagella basal body rod protein', 31, NULL, 'Flg_bb_rod', 266594),
(447501, 'PF06178', NULL, 'Oligogalacturonate-specific porin protein (KdgM)', 222, NULL, 'KdgM', 266595),
(447502, 'PF18417', NULL, 'L-lysine epsilon oxidase C-terminal domain', 148, NULL, 'LodA_C', 266596),
(447503, 'PF18061', NULL, 'CRISPR-Cas9 WED domain', 127, NULL, 'CRISPR_Cas9_WED', 266597),
(447504, 'PF13110', NULL, 'Protein of unknown function (DUF3966)', 42, NULL, 'DUF3966', 266598),
(447505, 'PF19359', NULL, 'Family of unknown function (DUF5936)', 141, NULL, 'DUF5936', 266599),
(447506, 'PF16308', NULL, 'Domain of unknown function (DUF4950)', 178, NULL, 'DUF4950', 266600),
(447507, 'PF03501', NULL, 'Plectin/S10 domain', 93, NULL, 'S10_plectin', 266601),
(447508, 'PF05044', NULL, 'Homeo-prospero domain', 154, NULL, 'HPD', 266602),
(447509, 'PF08041', NULL, 'PetM family of cytochrome b6f complex subunit 7', 30, NULL, 'PetM', 266603);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(447510, 'PF17200', NULL, 'Single Cache domain 2', 156, NULL, 'sCache_2', 266604),
(447511, 'PF10197', NULL, 'N-terminal domain of CBF1 interacting co-repressor CIR', 37, NULL, 'Cir_N', 266605),
(447512, 'PF04114', NULL, 'Gaa1-like, GPI transamidase component', 497, NULL, 'Gaa1', 266606),
(447513, 'PF06326', NULL, 'Vesiculovirus matrix protein', 222, NULL, 'Vesiculo_matrix', 266607),
(447514, 'PF08320', NULL, 'PIG-X / PBN1', 210, NULL, 'PIG-X', 266608),
(447515, 'PF08165', NULL, 'FerA (NUC095) domain', 65, NULL, 'FerA', 266609),
(447516, 'PF20536', NULL, 'Family of unknown function (DUF6751)', 113, NULL, 'DUF6751', 266610),
(447517, 'PF11293', NULL, 'Protein of unknown function (DUF3094)', 55, NULL, 'DUF3094', 266611),
(447518, 'PF01570', NULL, 'Flavivirus polyprotein propeptide', 85, NULL, 'Flavi_propep', 266612),
(447519, 'PF13087', NULL, 'AAA domain', 199, NULL, 'AAA_12', 266613),
(447520, 'PF06026', NULL, 'Ribose 5-phosphate isomerase A (phosphoriboisomerase A)', 173, NULL, 'Rib_5-P_isom_A', 266614),
(447521, 'PF16734', NULL, 'Type IV pilin-like G and H, putative', 113, NULL, 'Pilin_GH', 266615),
(447522, 'PF19609', NULL, 'Family of unknown function (DUF6114)', 106, NULL, 'DUF6114', 266616),
(447523, 'PF03513', NULL, 'Cloacin immunity protein', 80, NULL, 'Cloacin_immun', 266617),
(447524, 'PF15066', NULL, 'Cancer-associated gene protein 1 family', 528, NULL, 'CAGE1', 266618),
(447525, 'PF18792', NULL, 'Ubiquitous surface protein adhesin repeat', 13, NULL, 'UspA1_rep', 266619),
(447526, 'PF20189', NULL, 'Family of unknown function (DUF6552)', 78, NULL, 'DUF6552', 266620),
(447527, 'PF13372', NULL, 'Alginate export', 395, NULL, 'Alginate_exp', 266621),
(447528, 'PF15806', NULL, 'Domain of unknown function (DUF4707)', 433, NULL, 'DUF4707', 266622),
(447529, 'PF08284', NULL, 'Retroviral aspartyl protease', 136, NULL, 'RVP_2', 266623),
(447530, 'PF10856', NULL, 'Protein of unknown function (DUF2678)', 118, NULL, 'DUF2678', 266624),
(447531, 'PF04791', NULL, 'LMBR1-like membrane protein', 513, NULL, 'LMBR1', 266625),
(447532, 'PF16169', NULL, 'Domain of unknown function (DUF4872)', 174, NULL, 'DUF4872', 266626),
(447533, 'PF18603', NULL, 'L-amino acid ligase C-terminal domain 2', 78, NULL, 'LAL_C2', 266627),
(447534, 'PF18084', NULL, 'ARTD15 N-terminal domain', 84, NULL, 'ARTD15_N', 266628),
(447535, 'PF09813', NULL, 'Cytochrome c oxidase assembly factor 3', 48, NULL, 'Coa3_cc', 266629),
(447536, 'PF14756', NULL, 'Peptidase_C33-associated domain', 147, NULL, 'Pdase_C33_assoc', 266630),
(447537, 'PF03579', NULL, 'Small hydrophobic protein', 64, NULL, 'SHP', 266631),
(447538, 'PF02246', NULL, 'Protein L b1 domain', 69, NULL, 'B1', 266632),
(447539, 'PF08811', NULL, 'Protein of unknown function (DUF1800)', 432, NULL, 'DUF1800', 266633),
(447540, 'PF02271', NULL, 'Ubiquinol-cytochrome C reductase complex 14kD subunit', 100, NULL, 'UCR_14kD', 266634),
(447541, 'PF09164', NULL, 'Vitamin D binding protein, domain III', 65, NULL, 'VitD-bind_III', 266635),
(447542, 'PF09792', NULL, 'Ubiquitin 3 binding protein But2 C-terminal domain', 142, NULL, 'But2', 266636),
(447543, 'PF14249', NULL, 'Tocopherol cyclase', 336, NULL, 'Tocopherol_cycl', 266637),
(447544, 'PF11579', NULL, 'Protein of unknown function (DUF3238)', 193, NULL, 'DUF3238', 266638),
(447545, 'PF11284', NULL, 'Protein of unknown function (DUF3085)', 90, NULL, 'DUF3085', 266639),
(447546, 'PF14033', NULL, 'Protein of unknown function (DUF4246)', 453, NULL, 'DUF4246', 266640),
(447547, 'PF06151', NULL, 'Trehalose receptor', 411, NULL, 'Trehalose_recp', 266641),
(447548, 'PF06420', NULL, 'Mitochondrial genome maintenance MGM101', 170, NULL, 'Mgm101p', 266642),
(447549, 'PF14039', NULL, 'YusW-like protein', 92, NULL, 'YusW', 266643),
(447550, 'PF10635', NULL, 'DisA bacterial checkpoint controller linker region', 142, NULL, 'DisA-linker', 266644),
(447551, 'PF04343', NULL, 'Protein of unknown function, DUF488', 122, NULL, 'DUF488', 266645),
(447552, 'PF19848', NULL, 'Family of unknown function (DUF6323)', 127, NULL, 'DUF6323', 266646),
(447553, 'PF08514', NULL, 'STAG domain', 114, NULL, 'STAG', 266647);
INSERT INTO "PUBLIC"."MODEL" VALUES
(447554, 'PF06449', NULL, 'ATP synthase YMF19, C-terminal', 51, NULL, 'YMF19_C', 266648),
(447555, 'PF10435', NULL, 'Beta-galactosidase, domain 2', 179, NULL, 'BetaGal_dom2', 266649),
(447556, 'PF13341', NULL, 'RAG2 PHD domain', 78, NULL, 'RAG2_PHD', 266650),
(447557, 'PF16385', NULL, 'Domain of unknown function', 98, NULL, 'DUF4994', 266651),
(447558, 'PF03955', NULL, 'Adenovirus hexon-associated protein (IX)', 110, NULL, 'Adeno_PIX', 266652),
(447559, 'PF04151', NULL, 'Bacterial pre-peptidase C-terminal domain', 71, NULL, 'PPC', 266653),
(447560, 'PF18877', NULL, 'SSSPR-51 domain', 48, NULL, 'SSSPR-51', 266654),
(447561, 'PF19090', NULL, 'Family of unknown function (DUF5778)', 126, NULL, 'DUF5778', 266655),
(447562, 'PF03008', NULL, 'Archaea bacterial proteins of unknown function', 100, NULL, 'DUF234', 266656),
(447563, 'PF03344', NULL, 'Daxx N-terminal Rassf1C-interacting domain', 99, NULL, 'Daxx', 266657),
(447564, 'PF15650', NULL, 'Restriction endonuclease fold toxin 9', 88, NULL, 'Tox-REase-9', 266658),
(447565, 'PF11394', NULL, 'Protein of unknown function (DUF2875)', 456, NULL, 'DUF2875', 266659),
(447566, 'PF16807', NULL, 'Domain of unknown function (DUF5072)', 118, NULL, 'DUF5072', 266660),
(447567, 'PF08487', NULL, 'Vault protein inter-alpha-trypsin domain', 111, NULL, 'VIT', 266661),
(447568, 'PF02525', NULL, 'Flavodoxin-like fold', 198, NULL, 'Flavodoxin_2', 266662),
(447569, 'PF06469', NULL, 'Neurobeachin-like, DUF1088', 168, NULL, 'DUF1088', 266663),
(447570, 'PF18876', NULL, 'AF-4 proto-oncoprotein C-terminal region', 264, NULL, 'AF-4_C', 266664),
(447571, 'PF05587', NULL, 'Anthrax receptor extracellular domain', 102, NULL, 'Anth_Ig', 266665),
(447572, 'PF07782', NULL, 'DC-STAMP-like protein', 191, NULL, 'DC_STAMP', 266666),
(447573, 'PF03814', NULL, 'Potassium-transporting ATPase A subunit', 546, NULL, 'KdpA', 266667),
(447574, 'PF04820', NULL, 'Tryptophan halogenase', 454, NULL, 'Trp_halogenase', 266668),
(447575, 'PF03395', NULL, 'Poxvirus P4A protein', 882, NULL, 'Pox_P4A', 266669),
(447576, 'PF07953', NULL, 'Clostridium neurotoxin, N-terminal receptor binding', 195, NULL, 'Toxin_R_bind_N', 266670),
(447577, 'PF11082', NULL, 'Protein of unknown function (DUF2880)', 79, NULL, 'DUF2880', 266671),
(447578, 'PF20064', NULL, 'Family of unknown function (DUF6463)', 119, NULL, 'DUF6463', 266672),
(447579, 'PF20179', NULL, 'MSS51 C-terminal domain', 193, NULL, 'MSS51_C', 266673),
(447580, 'PF11024', NULL, 'Dispersed gene family protein 1 of Trypanosoma cruzi region 4', 78, NULL, 'DGF-1_4', 266674),
(447581, 'PF11266', NULL, 'Long-chain fatty aldehyde decarbonylase', 218, NULL, 'Ald_deCOase', 266675),
(447582, 'PF03889', NULL, 'Alternative ribosome-rescue factor A', 44, NULL, 'ArfA', 266676),
(447583, 'PF17557', NULL, 'I2-superfamily conotoxins', 38, NULL, 'Conotoxin_I2', 266677),
(447584, 'PF18721', NULL, 'CxC6 like cysteine cluster associated with KDZ transposases', 66, NULL, 'CxC6', 266678),
(447585, 'PF16684', NULL, 'Telomere resolvase', 274, NULL, 'Telomere_res', 266679),
(447586, 'PF15481', NULL, 'Chondroitin proteoglycan 4', 94, NULL, 'CPG4', 266680),
(447587, 'PF09137', NULL, 'Glucodextranase, domain N', 263, NULL, 'Glucodextran_N', 266681),
(447588, 'PF16101', NULL, 'Proline-rich membrane anchor 1', 122, NULL, 'PRIMA1', 266682),
(447589, 'PF08890', NULL, 'Phage XkdN-like tail assembly chaperone protein, TAC', 136, NULL, 'Phage_TAC_5', 266683),
(447590, 'PF03438', NULL, 'Pneumovirus NS1 protein', 136, NULL, 'Pneumo_NS1', 266684),
(447591, 'PF04592', NULL, 'Selenoprotein P, N terminal region', 233, NULL, 'SelP_N', 266685),
(447592, 'PF18311', NULL, 'Exosome complex exonuclease Rrp40 N-terminal domain', 48, NULL, 'Rrp40_N', 266686),
(447593, 'PF06015', NULL, 'Chordopoxvirus A30L protein', 71, NULL, 'Chordopox_A30L', 266687),
(447594, 'PF16548', NULL, 'Flagellar assembly protein T, N-terminal domain', 87, NULL, 'FlgT_N', 266688),
(447595, 'PF06177', NULL, 'QueT transporter', 139, NULL, 'QueT', 266689),
(447596, 'PF02196', NULL, 'Raf-like Ras-binding domain', 69, NULL, 'RBD', 266690); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(447597, 'PF03648', NULL, 'Glycosyl hydrolase family 67 N-terminus', 121, NULL, 'Glyco_hydro_67N', 266691),
(447598, 'PF09589', NULL, 'HrpA pilus formation protein', 96, NULL, 'HrpA_pilin', 266692),
(447599, 'PF18700', NULL, 'Cytosolic arginine sensor for mTORC1 subunit 1 N-terminal domain', 61, NULL, 'Castor1_N', 266693),
(447600, 'PF17231', NULL, 'Family of unknown function (DUF5305)', 216, NULL, 'DUF5305', 266694),
(447601, 'PF02068', NULL, 'Plant PEC family metallothionein', 75, NULL, 'Metallothio_PEC', 266695),
(447602, 'PF18675', NULL, 'Heparinase II C-terminal domain', 88, NULL, 'HepII_C', 266696),
(447603, 'PF07094', NULL, 'Protein of unknown function (DUF1357)', 223, NULL, 'DUF1357', 266697),
(447604, 'PF08732', NULL, 'HIM1', 169, NULL, 'HIM1', 266698),
(447605, 'PF02833', NULL, 'DHHA2 domain', 145, NULL, 'DHHA2', 266699),
(447606, 'PF02421', NULL, 'Ferrous iron transport protein B', 156, NULL, 'FeoB_N', 266700),
(447607, 'PF06639', NULL, 'Basal layer antifungal peptide (BAP)', 76, NULL, 'BAP', 266701),
(447608, 'PF17037', NULL, 'Cellulose biosynthesis protein BcsO', 201, NULL, 'CBP_BcsO', 266702),
(447609, 'PF03891', NULL, 'Domain of unknown function (DUF333)', 48, NULL, 'DUF333', 266703),
(447610, 'PF05964', NULL, 'F/Y-rich N-terminus', 51, NULL, 'FYRN', 266704),
(447611, 'PF18560', NULL, 'Lectin like domain', 157, NULL, 'Lectin_like', 266705),
(447612, 'PF08840', NULL, 'BAAT / Acyl-CoA thioester hydrolase C terminal', 211, NULL, 'BAAT_C', 266706),
(447613, 'PF09777', NULL, 'Osteopetrosis-associated transmembrane protein 1 precursor', 231, NULL, 'OSTMP1', 266707),
(447614, 'PF05552', NULL, 'Conserved TM helix', 50, NULL, 'TM_helix', 266708),
(447615, 'PF04677', NULL, 'Protein similar to CwfJ C-terminus 1', 122, NULL, 'CwfJ_C_1', 266709),
(447616, 'PF05005', NULL, 'Janus/Ocnus family (Ocnus)', 107, NULL, 'Ocnus', 266710),
(447617, 'PF13406', NULL, 'Transglycosylase SLT domain', 292, NULL, 'SLT_2', 266711),
(447618, 'PF19393', NULL, 'Family of unknown function (DUF5968)', 150, NULL, 'DUF5968', 266712),
(447619, 'PF15317', NULL, 'Cardiac transcription factor regulator, Developmental protein', 102, NULL, 'Lbh', 266713),
(447620, 'PF18980', NULL, 'Family of unknown function (DUF5716) C-terminal', 296, NULL, 'DUF5716_C', 266714),
(447621, 'PF00960', NULL, 'Neocarzinostatin family', 110, NULL, 'Neocarzinostat', 266715),
(447622, 'PF07753', NULL, 'Protein of unknown function (DUF1609)', 227, NULL, 'DUF1609', 266716),
(447623, 'PF06035', NULL, 'Bacterial transglutaminase-like cysteine proteinase BTLCP', 163, NULL, 'Peptidase_C93', 266717),
(447624, 'PF09179', NULL, 'TilS substrate binding domain', 67, NULL, 'TilS', 266718),
(447625, 'PF17856', NULL, 'TIP49 AAA-lid domain', 66, NULL, 'TIP49_C', 266719),
(447626, 'PF18394', NULL, 'TANK-binding kinase 1 coiled-coil domain 1', 256, NULL, 'TBK1_CCD1', 266720),
(447627, 'PF04290', NULL, 'Tripartite ATP-independent periplasmic transporters, DctQ component', 133, NULL, 'DctQ', 266721),
(447628, 'PF10321', NULL, 'Serpentine type 7TM GPCR chemoreceptor Srt', 313, NULL, '7TM_GPCR_Srt', 266722),
(447629, 'PF08461', NULL, 'Ribonuclease R winged-helix domain', 66, NULL, 'HTH_12', 266723),
(447630, 'PF10281', NULL, 'Putative nuclear envelope organisation protein', 37, NULL, 'Ish1', 266724),
(447631, 'PF12991', NULL, 'Domain of unknown function, B. Theta Gene description (DUF3875)', 53, NULL, 'DUF3875', 266725),
(447632, 'PF08733', NULL, 'PalH/RIM21', 330, NULL, 'PalH', 266726),
(447633, 'PF04326', NULL, 'Putative DNA-binding domain', 122, NULL, 'AlbA_2', 266727),
(447634, 'PF01737', NULL, 'YCF9', 58, NULL, 'Ycf9', 266728),
(447635, 'PF17487', NULL, 'Ribosomal protein S12', 87, NULL, 'Ribosomal_S12', 266729),
(447636, 'PF11545', NULL, 'Cell surface heme-binding protein Shp', 148, NULL, 'HemeBinding_Shp', 266730),
(447637, 'PF20396', NULL, 'Family of unknown function (DUF6689)', 275, NULL, 'DUF6689', 266731),
(447638, 'PF05711', NULL, 'Macrocin-O-methyltransferase (TylF)', 255, NULL, 'TylF', 266732),
(447639, 'PF17957', NULL, 'Bacterial Ig domain', 71, NULL, 'Big_7', 266733);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(447640, 'PF00832', NULL, 'Ribosomal L39 protein', 42, NULL, 'Ribosomal_L39', 266734),
(447641, 'PF13098', NULL, 'Thioredoxin-like domain', 109, NULL, 'Thioredoxin_2', 266735),
(447642, 'PF14416', NULL, 'PMR5 N terminal Domain', 54, NULL, 'PMR5N', 266736),
(447643, 'PF06455', NULL, 'NADH dehydrogenase subunit 5 C-terminus', 181, NULL, 'NADH5_C', 266737),
(447644, 'PF07261', NULL, 'Replication initiation and membrane attachment', 74, NULL, 'DnaB_2', 266738),
(447645, 'PF14609', NULL, 'gamma-Tubulin ring complex non-core subunit mod21', 618, NULL, 'GCP5-Mod21', 266739),
(447646, 'PF02281', NULL, 'Transposase Tn5 dimerisation domain', 99, NULL, 'Dimer_Tnp_Tn5', 266740),
(447647, 'PF15055', NULL, 'Domain of unknown function (DUF4536)', 47, NULL, 'DUF4536', 266741),
(447648, 'PF13050', NULL, 'Protein of unknown function (DUF3911)', 78, NULL, 'DUF3911', 266742),
(447649, 'PF05836', NULL, 'Chorion protein S16', 108, NULL, 'Chorion_S16', 266743),
(447650, 'PF18579', NULL, 'Rubisco accumulation factor 1 helix turn helix domain', 61, NULL, 'Raf1_HTH', 266744),
(447651, 'PF05685', NULL, 'Putative restriction endonuclease', 172, NULL, 'Uma2', 266745),
(447652, 'PF07606', NULL, 'Protein of unknown function (DUF1569)', 152, NULL, 'DUF1569', 266746),
(447653, 'PF15313', NULL, 'Hexamethylene bis-acetamide-inducible protein', 142, NULL, 'HEXIM', 266747),
(447654, 'PF06490', NULL, 'Flagellar regulatory protein FleQ', 109, NULL, 'FleQ', 266748),
(447655, 'PF01054', NULL, 'Mouse mammary tumour virus superantigen', 184, NULL, 'MMTV_SAg', 266749),
(447656, 'PF05560', NULL, 'Bacillus thuringiensis P21 molecular chaperone protein', 182, NULL, 'Bt_P21', 266750),
(447657, 'PF13832', NULL, 'PHD-zinc-finger like domain', 109, NULL, 'zf-HC5HC2H_2', 266751),
(447658, 'PF10884', NULL, 'Protein of unknown function (DUF2683)', 78, NULL, 'DUF2683', 266752),
(447659, 'PF01822', NULL, 'WSC domain', 82, NULL, 'WSC', 266753),
(447660, 'PF05508', NULL, 'RanGTP-binding protein', 310, NULL, 'Ran-binding', 266754),
(447661, 'PF08130', NULL, 'Type A lantibiotic family', 60, NULL, 'Antimicrobial18', 266755),
(447662, 'PF18071', NULL, 'HMW1C N-terminal', 143, NULL, 'HMW1C_N', 266756),
(447663, 'PF06003', NULL, 'Survival motor neuron protein (SMN)', 264, NULL, 'SMN', 266757),
(447664, 'PF15427', NULL, 'S100P-binding protein', 390, NULL, 'S100PBPR', 266758),
(447665, 'PF18747', NULL, 'P-loop Nucleotide Kinase2', 298, NULL, 'Ploopntkinase2', 266759),
(447666, 'PF12344', NULL, 'Ultra-violet resistance protein B', 43, NULL, 'UvrB', 266760),
(447667, 'PF12608', NULL, 'Type IVb secretion, IcmS, effector-recruitment', 93, NULL, 'T4bSS_IcmS', 266761),
(447668, 'PF16887', NULL, 'Domain of unknown function (DUF5081)', 231, NULL, 'DUF5081', 266762),
(447669, 'PF11667', NULL, 'Putative zincin peptidase', 108, NULL, 'DUF3267', 266763),
(447670, 'PF05427', NULL, 'Acidic fibroblast growth factor binding (FIBP)', 360, NULL, 'FIBP', 266764),
(447671, 'PF10090', NULL, 'Histidine phosphotransferase C-terminal domain', 123, NULL, 'HPTransfase', 266765),
(447672, 'PF04537', NULL, 'Herpesvirus UL55 protein', 164, NULL, 'Herpes_UL55', 266766),
(447673, 'PF01522', NULL, 'Polysaccharide deacetylase', 124, NULL, 'Polysacc_deac_1', 266767),
(447674, 'PF14006', NULL, 'YqzL-like protein', 45, NULL, 'YqzL', 266768),
(447675, 'PF12542', NULL, 'Pre-mRNA splicing factor', 101, NULL, 'CWC25', 266769),
(447676, 'PF03242', NULL, 'Late embryogenesis abundant protein', 93, NULL, 'LEA_3', 266770),
(447677, 'PF02599', NULL, 'Global regulator protein family', 53, NULL, 'CsrA', 266771),
(447678, 'PF14510', NULL, 'ABC-transporter N-terminal', 81, NULL, 'ABC_trans_N', 266772),
(447679, 'PF02772', NULL, 'S-adenosylmethionine synthetase, central domain', 120, NULL, 'S-AdoMet_synt_M', 266773),
(447680, 'PF19201', NULL, 'Family of unknown function (DUF5873)', 109, NULL, 'DUF5873', 266774),
(447681, 'PF12819', NULL, 'Malectin-like domain', 335, NULL, 'Malectin_like', 266775),
(447682, 'PF19586', NULL, 'Family of unknown function (DUF6093)', 117, NULL, 'DUF6093', 266776),
(447683, 'PF04068', NULL, 'Possible Fer4-like domain in RNase L inhibitor, RLI', 35, NULL, 'RLI', 266777);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(447684, 'PF09045', NULL, 'L27_2', 58, NULL, 'L27_2', 266778),
(447685, 'PF13561', NULL, 'Enoyl-(Acyl carrier protein) reductase', 234, NULL, 'adh_short_C2', 266779),
(447686, 'PF00777', NULL, 'Glycosyltransferase family 29 (sialyltransferase)', 274, NULL, 'Glyco_transf_29', 266780),
(447687, 'PF13429', NULL, 'Tetratricopeptide repeat', 280, NULL, 'TPR_15', 266781),
(447688, 'PF05346', NULL, 'Eukaryotic membrane protein family', 319, NULL, 'DUF747', 266782),
(447689, 'PF18279', NULL, 'Werner helicase-interacting protein 1 ubiquitin-binding domain', 21, NULL, 'zf-WRNIP1_ubi', 266783),
(447690, 'PF16323', NULL, 'Domain of unknown function (DUF4959)', 106, NULL, 'DUF4959', 266784),
(447691, 'PF00861', NULL, 'Ribosomal L18 of archaea, bacteria, mitoch. and chloroplast', 116, NULL, 'Ribosomal_L18p', 266785),
(447692, 'PF02529', NULL, 'Cytochrome B6-F complex subunit 5', 36, NULL, 'PetG', 266786),
(447693, 'PF01591', NULL, '6-phosphofructo-2-kinase', 223, NULL, '6PF2K', 266787),
(447694, 'PF01146', NULL, 'Caveolin', 133, NULL, 'Caveolin', 266788),
(447695, 'PF14831', NULL, 'Domain of unknown function (DUF4484)', 207, NULL, 'DUF4484', 266789),
(447696, 'PF14788', NULL, 'EF hand', 50, NULL, 'EF-hand_10', 266790),
(447697, 'PF10580', NULL, 'Gap junction protein N-terminal region', 31, NULL, 'Neuromodulin_N', 266791),
(447698, 'PF16232', NULL, 'Domain of unknown function (DUF4891)', 92, NULL, 'DUF4891', 266792),
(447699, 'PF18313', NULL, 'Thiolase-like protein type 1 additional C-terminal domain', 83, NULL, 'TLP1_add_C', 266793),
(447700, 'PF17818', NULL, 'Keratinocyte-associated gene product', 187, NULL, 'KCT2', 266794),
(447701, 'PF07154', NULL, 'Protein of unknown function (DUF1392)', 150, NULL, 'DUF1392', 266795),
(447702, 'PF07979', NULL, 'Intimin C-type lectin domain', 101, NULL, 'Intimin_C', 266796),
(447703, 'PF12059', NULL, 'Protein of unknown function (DUF3540)', 199, NULL, 'DUF3540', 266797),
(447704, 'PF16094', NULL, 'Proteasome assembly chaperone 4', 286, NULL, 'PAC1', 266798),
(447705, 'PF03521', NULL, 'Kv2 voltage-gated K+ channel', 288, NULL, 'Kv2channel', 266799),
(447706, 'PF17078', NULL, 'SWI5-dependent HO expression protein 3', 228, NULL, 'SHE3', 266800),
(447707, 'PF00660', NULL, 'Seripauperin and TIP1 family', 99, NULL, 'SRP1_TIP1', 266801),
(447708, 'PF08199', NULL, 'Bacteriophage E2-like protein', 37, NULL, 'E2', 266802),
(447709, 'PF16763', NULL, 'Major ampullate spidroin 1, spider silk protein 1, N-term', 125, NULL, 'Spidroin_N', 266803),
(447710, 'PF07821', NULL, 'Alpha-amylase C-terminal beta-sheet domain', 58, NULL, 'Alpha-amyl_C2', 266804),
(447711, 'PF09088', NULL, 'MIF4G like', 191, NULL, 'MIF4G_like', 266805),
(447712, 'PF07726', NULL, 'ATPase family associated with various cellular activities (AAA)', 131, NULL, 'AAA_3', 266806),
(447713, 'PF07167', NULL, 'Poly-beta-hydroxybutyrate polymerase (PhaC) N-terminus', 173, NULL, 'PhaC_N', 266807),
(447714, 'PF10246', NULL, 'Mitochondrial ribosomal protein MRP-S35', 105, NULL, 'MRP-S35', 266808),
(447715, 'PF02359', NULL, 'Cell division protein 48 (CDC48), N-terminal domain', 85, NULL, 'CDC48_N', 266809),
(447716, 'PF11262', NULL, 'Transcription factor/nuclear export subunit protein 2', 301, NULL, 'Tho2', 266810),
(447717, 'PF16003', NULL, 'Domain of unknown function (DUF4776)', 503, NULL, 'DUF4776', 266811),
(447718, 'PF08206', NULL, 'Ribonuclease B OB domain', 58, NULL, 'OB_RNB', 266812),
(447719, 'PF18701', NULL, 'Family of unknown function (DUF5641)', 94, NULL, 'DUF5641', 266813),
(447720, 'PF07377', NULL, 'Protein of unknown function (DUF1493)', 111, NULL, 'DUF1493', 266814),
(447721, 'PF02027', NULL, 'RolB/RolC glucosidase family', 184, NULL, 'RolB_RolC', 266815),
(447722, 'PF16293', NULL, 'C2H2 type zinc-finger (1 copy)', 59, NULL, 'zf-C2H2_9', 266816),
(447723, 'PF05706', NULL, 'Cyclin-dependent kinase inhibitor 3 (CDKN3)', 168, NULL, 'CDKN3', 266817),
(447724, 'PF06019', NULL, 'Phage GP30.8 protein', 123, NULL, 'Phage_30_8', 266818),
(447725, 'PF00702', NULL, 'haloacid dehalogenase-like hydrolase', 210, NULL, 'Hydrolase', 266819);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(447726, 'PF19642', NULL, 'Family of unknown function (DUF6145)', 119, NULL, 'DUF6145', 266820),
(447727, 'PF05096', NULL, 'Glutamine cyclotransferase', 248, NULL, 'Glu_cyclase_2', 266821),
(447728, 'PF00900', NULL, 'Ribosomal family S4e', 75, NULL, 'Ribosomal_S4e', 266822),
(447729, 'PF01652', NULL, 'Eukaryotic initiation factor 4E', 159, NULL, 'IF4E', 266823),
(447730, 'PF00228', NULL, 'Bowman-Birk serine protease inhibitor family', 25, NULL, 'Bowman-Birk_leg', 266824),
(447731, 'PF03517', NULL, 'Regulator of volume decrease after cellular swelling', 141, NULL, 'Voldacs', 266825),
(447732, 'PF18732', NULL, 'HEPN like, Abia C-terminal domain', 132, NULL, 'HEPN_AbiA_CTD', 266826),
(447733, 'PF06088', NULL, 'Nucleopolyhedrovirus telokin-like protein-20 (TLP20)', 169, NULL, 'TLP-20', 266827),
(447734, 'PF11465', NULL, 'Natural killer cell receptor 2B4', 108, NULL, 'Receptor_2B4', 266828),
(447735, 'PF15606', NULL, 'Bacterial toxin 34', 80, NULL, 'Ntox34', 266829),
(447736, 'PF11828', NULL, 'Protein of unknown function (DUF3348)', 247, NULL, 'DUF3348', 266830),
(447737, 'PF06883', NULL, 'RNA polymerase I, Rpa2 specific domain', 58, NULL, 'RNA_pol_Rpa2_4', 266831),
(447738, 'PF13727', NULL, 'CoA-binding domain', 175, NULL, 'CoA_binding_3', 266832),
(447739, 'PF19078', NULL, 'Bacterial Ig-like domain', 102, NULL, 'Big_12', 266833),
(447740, 'PF16707', NULL, 'Cag pathogenicity island protein S of Helicobacter pylori', 196, NULL, 'CagS', 266834),
(447741, 'PF10215', NULL, 'Oligosaccaryltransferase', 34, NULL, 'Ost4', 266835),
(447742, 'PF16150', NULL, 'Domain of unknown function (DUF4858)', 194, NULL, 'DUF4858', 266836),
(447743, 'PF01352', NULL, 'KRAB box', 42, NULL, 'KRAB', 266837),
(447744, 'PF17970', NULL, 'Bacterial Alpha-2-macroglobulin MG1 domain', 105, NULL, 'bMG1', 266838),
(447745, 'PF01095', NULL, 'Pectinesterase', 298, NULL, 'Pectinesterase', 266839),
(447746, 'PF17701', NULL, 'Family of unknown function (DUF5547)', 122, NULL, 'DUF5547', 266840),
(447747, 'PF04121', NULL, 'Nuclear pore protein 84 / 107', 730, NULL, 'Nup84_Nup100', 266841),
(447748, 'PF10735', NULL, 'Protein of unknown function (DUF2526)', 77, NULL, 'DUF2526', 266842),
(447749, 'PF17900', NULL, 'Peptidase M1 N-terminal domain', 186, NULL, 'Peptidase_M1_N', 266843),
(447750, 'PF04563', NULL, 'RNA polymerase beta subunit', 203, NULL, 'RNA_pol_Rpb2_1', 266844),
(447751, 'PF08646', NULL, 'Replication factor-A C terminal domain', 146, NULL, 'Rep_fac-A_C', 266845),
(447752, 'PF03700', NULL, 'Sorting nexin, N-terminal domain', 76, NULL, 'Sorting_nexin', 266846),
(447753, 'PF07083', NULL, 'Protein of unknown function (DUF1351)', 210, NULL, 'DUF1351', 266847),
(447754, 'PF16179', NULL, 'Rel homology dimerisation domain', 103, NULL, 'RHD_dimer', 266848),
(447755, 'PF04309', NULL, 'Glycerol-3-phosphate responsive antiterminator', 173, NULL, 'G3P_antiterm', 266849),
(447756, 'PF03355', NULL, 'Viral Trans-Activator Protein', 260, NULL, 'Pox_TAP', 266850),
(447757, 'PF07707', NULL, 'BTB And C-terminal Kelch', 103, NULL, 'BACK', 266851),
(447758, 'PF11971', NULL, 'CAMSAP CH domain', 85, NULL, 'CAMSAP_CH', 266852),
(447759, 'PF06426', NULL, 'Serine acetyltransferase, N-terminal', 105, NULL, 'SATase_N', 266853),
(447760, 'PF17643', NULL, 'Type VI secretion system, TssR', 746, NULL, 'TssR', 266854),
(447761, 'PF19511', NULL, 'Family of unknown function (DUF6045)', 289, NULL, 'DUF6045', 266855),
(447762, 'PF01434', NULL, 'Peptidase family M41', 191, NULL, 'Peptidase_M41', 266856),
(447763, 'PF01766', NULL, 'Birnavirus VP2 protein', 442, NULL, 'Birna_VP2', 266857),
(447764, 'PF02190', NULL, 'ATP-dependent protease La (LON) substrate-binding domain', 205, NULL, 'LON_substr_bdg', 266858),
(447765, 'PF05869', NULL, 'DNA N-6-adenine-methyltransferase (Dam)', 169, NULL, 'Dam', 266859),
(447766, 'PF11373', NULL, 'Protein of unknown function (DUF3175)', 86, NULL, 'DUF3175', 266860),
(447767, 'PF07778', NULL, 'Mis6', 515, NULL, 'CENP-I', 266861),
(447768, 'PF12645', NULL, 'Helix-turn-helix domain', 65, NULL, 'HTH_16', 266862),
(447769, 'PF19681', NULL, 'Family of unknown function (DUF6183)', 361, NULL, 'DUF6183', 266863);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(447770, 'PF10122', NULL, 'Mu-like prophage protein Com', 52, NULL, 'Mu-like_Com', 266864),
(447771, 'PF14556', NULL, 'AF2331-like', 91, NULL, 'AF2331-like', 266865),
(447772, 'PF14686', NULL, 'Polysaccharide lyase family 4, domain II', 75, NULL, 'fn3_3', 266866),
(447773, 'PF16443', NULL, 'Domain of unknown function (DUF5040)', 227, NULL, 'DUF5040', 266867),
(447774, 'PF04686', NULL, 'Streptomyces sporulation and cell division protein, SsgA', 98, NULL, 'SsgA', 266868),
(447775, 'PF07662', NULL, 'Na+ dependent nucleoside transporter C-terminus', 213, NULL, 'Nucleos_tra2_C', 266869),
(447776, 'PF08211', NULL, 'Cytidine and deoxycytidylate deaminase zinc-binding region', 135, NULL, 'dCMP_cyt_deam_2', 266870),
(447777, 'PF02526', NULL, 'Glycophorin-binding protein', 38, NULL, 'GBP_repeat', 266871),
(447778, 'PF00105', NULL, 'Zinc finger, C4 type (two domains)', 70, NULL, 'zf-C4', 266872),
(447779, 'PF13319', NULL, 'Protein of unknown function (DUF4090)', 84, NULL, 'DUF4090', 266873),
(447780, 'PF15102', NULL, 'TMEM154 protein family', 153, NULL, 'TMEM154', 266874),
(447781, 'PF16753', NULL, 'TNF-alpha-Inducing protein of Helicobacter', 151, NULL, 'Tipalpha', 266875),
(447782, 'PF01886', NULL, 'Protein of unknown function DUF61', 127, NULL, 'DUF61', 266876),
(447783, 'PF06541', NULL, 'Putative ABC-transporter type IV', 150, NULL, 'ABC_trans_CmpB', 266877),
(447784, 'PF14089', NULL, 'KinB-signalling pathway activation in sporulation', 179, NULL, 'KbaA', 266878),
(447785, 'PF16428', NULL, 'Domain of unknown function (DUF5025)', 158, NULL, 'DUF5025', 266879),
(447786, 'PF08622', NULL, 'Svf1-like N-terminal lipocalin domain', 163, NULL, 'Svf1', 266880),
(447787, 'PF05264', NULL, 'Choristoneura fumiferana antifreeze protein (CfAFP)', 137, NULL, 'CfAFP', 266881),
(447788, 'PF15092', NULL, 'Uncharacterised protein family UPF0728', 88, NULL, 'UPF0728', 266882),
(447789, 'PF20459', NULL, 'Family of unknown function (DUF6712)', 288, NULL, 'DUF6712', 266883),
(447790, 'PF09809', NULL, 'Mitochondrial ribosomal protein L27', 113, NULL, 'MRP-L27', 266884),
(447791, 'PF11781', NULL, 'Zinc-finger of RNA-polymerase I-specific TFIIB, Rrn7', 32, NULL, 'zf-RRN7', 266885),
(447792, 'PF06712', NULL, 'Protein of unknown function (DUF1199)', 52, NULL, 'DUF1199', 266886),
(447793, 'PF05461', NULL, 'Apolipoprotein L', 298, NULL, 'ApoL', 266887),
(447794, 'PF06645', NULL, 'Microsomal signal peptidase 12 kDa subunit (SPC12)', 71, NULL, 'SPC12', 266888),
(447795, 'PF14451', NULL, 'Mut7-C ubiquitin', 81, NULL, 'Ub-Mut7C', 266889),
(447796, 'PF15445', NULL, 'acidic terminal segments, variant surface antigen of PfEMP1', 446, NULL, 'ATS', 266890),
(447797, 'PF09009', NULL, 'Exotoxin A catalytic', 172, NULL, 'Exotox-A_cataly', 266891),
(447798, 'PF16519', NULL, 'Tetramerisation domain of TRPM', 56, NULL, 'TRPM_tetra', 266892),
(447799, 'PF00933', NULL, 'Glycosyl hydrolase family 3 N terminal domain', 319, NULL, 'Glyco_hydro_3', 266893),
(447800, 'PF19537', NULL, 'Family of unknown function (DUF6061)', 81, NULL, 'DUF6061', 266894),
(447801, 'PF01209', NULL, 'ubiE/COQ5 methyltransferase family', 233, NULL, 'Ubie_methyltran', 266895),
(447802, 'PF09812', NULL, 'Mitochondrial ribosomal protein L28', 157, NULL, 'MRP-L28', 266896),
(447803, 'PF11466', NULL, 'Prion-like protein Doppel', 30, NULL, 'Doppel', 266897),
(447804, 'PF03087', NULL, 'Protein BPS1', 236, NULL, 'BPS1', 266898),
(447805, 'PF09657', NULL, 'CRISPR-associated protein Csx8 (Cas_Csx8)', 489, NULL, 'Cas_Csx8', 266899),
(447806, 'PF15623', NULL, 'Cancer/testis gene family 47', 282, NULL, 'CT47', 266900),
(447807, 'PF00635', NULL, 'MSP (Major sperm protein) domain', 109, NULL, 'Motile_Sperm', 266901),
(447808, 'PF11235', NULL, 'Mediator complex subunit 25 synapsin 1', 157, NULL, 'Med25_SD1', 266902),
(447809, 'PF13517', NULL, 'FG-GAP-like repeat', 61, NULL, 'FG-GAP_3', 266903),
(447810, 'PF17121', NULL, 'Zinc finger, C3HC4 type (RING finger)', 51, NULL, 'zf-C3HC4_5', 266904),
(447811, 'PF06280', NULL, 'Fn3-like domain', 115, NULL, 'fn3_5', 266905),
(447812, 'PF14855', NULL, 'Pilus-assembly fibrillin subunit, chaperone', 187, NULL, 'PapJ', 266906);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(447813, 'PF07155', NULL, 'ECF-type riboflavin transporter, S component', 172, NULL, 'ECF-ribofla_trS', 266907),
(447814, 'PF10418', NULL, 'Iron-sulfur cluster binding domain of dihydroorotate dehydrogenase B', 42, NULL, 'DHODB_Fe-S_bind', 266908),
(447815, 'PF15776', NULL, 'Proline-rich protein family 22', 366, NULL, 'PRR22', 266909),
(447816, 'PF18118', NULL, 'Polycomb repressive complex 2 tri-helical domain', 101, NULL, 'PRC2_HTH_1', 266910),
(447817, 'PF11008', NULL, 'Protein of unknown function (DUF2846)', 92, NULL, 'DUF2846', 266911),
(447818, 'PF07290', NULL, 'Protein of unknown function (DUF1449)', 202, NULL, 'DUF1449', 266912),
(447819, 'PF00238', NULL, 'Ribosomal protein L14p/L23e', 122, NULL, 'Ribosomal_L14', 266913),
(447820, 'PF17021', NULL, 'Putative double-strand recombination repair-like', 118, NULL, 'Mei5_like', 266914),
(447821, 'PF17404', NULL, 'Nrap protein domain 3', 159, NULL, 'Nrap_D3', 266915),
(447822, 'PF17409', NULL, 'MoaF C-terminal domain', 113, NULL, 'MoaF_C', 266916),
(447823, 'PF01564', NULL, 'Spermine/spermidine synthase domain', 188, NULL, 'Spermine_synth', 266917),
(447824, 'PF13891', NULL, 'Potential DNA-binding domain', 62, NULL, 'zf-C3Hc3H', 266918),
(447825, 'PF17162', NULL, 'Domain of unknown function (DUF5118)', 50, NULL, 'DUF5118', 266919),
(447826, 'PF08351', NULL, 'tRNA(Met) cytidine acetyltransferase TmcA, N-terminal', 180, NULL, 'TmcA_N', 266920),
(447827, 'PF06417', NULL, 'Protein of unknown function (DUF1077)', 118, NULL, 'DUF1077', 266921),
(447828, 'PF06451', NULL, 'Moricin', 41, NULL, 'Moricin', 266922),
(447829, 'PF10264', NULL, 'Winged helix Storkhead-box1 domain', 79, NULL, 'Stork_head', 266923),
(447830, 'PF05314', NULL, 'Baculovirus occlusion-derived virus envelope protein EC27', 283, NULL, 'Baculo_ODV-E27', 266924),
(447831, 'PF12138', NULL, 'Spherulation-specific family 4', 240, NULL, 'Spherulin4', 266925),
(447832, 'PF04880', NULL, 'NUDE protein, C-terminal conserved region', 177, NULL, 'NUDE_C', 266926),
(447833, 'PF00917', NULL, 'MATH domain', 113, NULL, 'MATH', 266927),
(447834, 'PF08232', NULL, 'Striatin family', 155, NULL, 'Striatin', 266928),
(447835, 'PF18133', NULL, 'Hydrogen maturase F tetramerization domain', 118, NULL, 'HydF_tetramer', 266929),
(447836, 'PF04572', NULL, 'Alpha 1,4-glycosyltransferase conserved region', 131, NULL, 'Gb3_synth', 266930),
(447837, 'PF10459', NULL, 'Peptidase S46', 699, NULL, 'Peptidase_S46', 266931),
(447838, 'PF14808', NULL, 'TMEM164 family', 254, NULL, 'TMEM164', 266932),
(447839, 'PF02742', NULL, 'Iron dependent repressor, metal binding and dimerisation domain', 70, NULL, 'Fe_dep_repr_C', 266933),
(447840, 'PF18714', NULL, 'DNA polymerase II intein Domain IV', 150, NULL, 'PI-TkoII_IV', 266934),
(447841, 'PF19652', NULL, 'Family of unknown function (DUF6155)', 170, NULL, 'DUF6155', 266935),
(447842, 'PF19578', NULL, 'Family of unknown function (DUF6090)', 182, NULL, 'DUF6090', 266936),
(447843, 'PF17857', NULL, 'AAA+ lid domain', 100, NULL, 'AAA_lid_1', 266937),
(447844, 'PF18691', NULL, 'Cell division control protein 13, OB2 domain', 111, NULL, 'Cdc13_OB2', 266938),
(447845, 'PF04658', NULL, 'TAFII55 protein conserved region', 161, NULL, 'TAFII55_N', 266939),
(447846, 'PF14507', NULL, 'CppA C-terminal', 102, NULL, 'CppA_C', 266940),
(447847, 'PF06325', NULL, 'Ribosomal protein L11 methyltransferase (PrmA)', 295, NULL, 'PrmA', 266941),
(447848, 'PF11651', NULL, 'P22 coat protein - gene protein 5', 419, NULL, 'P22_CoatProtein', 266942),
(447849, 'PF11900', NULL, 'Domain of unknown function (DUF3420)', 47, NULL, 'DUF3420', 266943),
(447850, 'PF13082', NULL, 'Protein of unknown function (DUF3931)', 66, NULL, 'DUF3931', 266944),
(447851, 'PF03770', NULL, 'Inositol polyphosphate kinase', 198, NULL, 'IPK', 266945),
(447852, 'PF05812', NULL, 'Herpesvirus BLRF2 protein', 119, NULL, 'Herpes_BLRF2', 266946),
(447853, 'PF05306', NULL, 'Protein of unknown function (DUF733)', 87, NULL, 'DUF733', 266947),
(447854, 'PF10210', NULL, 'Mitochondrial 28S ribosomal protein S32', 93, NULL, 'MRP-S32', 266948);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(447855, 'PF00255', NULL, 'Glutathione peroxidase', 108, NULL, 'GSHPx', 266949),
(447856, 'PF14184', NULL, 'Regulatory protein YrvL', 127, NULL, 'YrvL', 266950),
(447857, 'PF04473', NULL, 'Transglutaminase-like domain', 154, NULL, 'DUF553', 266951),
(447858, 'PF10753', NULL, 'Toxin GhoT_OrtT', 55, NULL, 'Toxin_GhoT_OrtT', 266952),
(447859, 'PF12706', NULL, 'Beta-lactamase superfamily domain', 201, NULL, 'Lactamase_B_2', 266953),
(447860, 'PF12785', NULL, 'Variant erythrocyte surface antigen-1', 456, NULL, 'VESA1_N', 266954),
(447861, 'PF19906', NULL, 'Domain of unknown function (DUF6379)', 112, NULL, 'DUF6379', 266955),
(447862, 'PF19333', NULL, 'Failed axon connections homolog N-terminus', 104, NULL, 'FAXC_N', 266956),
(447863, 'PF11277', NULL, 'Mediator complex subunit 24 N-terminal', 998, NULL, 'Med24_N', 266957),
(447864, 'PF09385', NULL, 'Histidine kinase N terminal', 129, NULL, 'HisK_N', 266958),
(447865, 'PF19817', NULL, 'Family of unknown function (DUF6300)', 110, NULL, 'DUF6300', 266959),
(447866, 'PF16692', NULL, 'Folliculin C-terminal domain', 226, NULL, 'Folliculin_C', 266960),
(447867, 'PF15280', NULL, 'Protein aurora borealis N-terminus', 223, NULL, 'BORA_N', 266961),
(447868, 'PF06540', NULL, 'Galanin message associated peptide (GMAP)', 61, NULL, 'GMAP', 266962),
(447869, 'PF19032', NULL, 'Intu longin-like domain 2', 128, NULL, 'Intu_longin_2', 266963),
(447870, 'PF10862', NULL, 'FcoT-like thioesterase domain', 156, NULL, 'FcoT', 266964),
(447871, 'PF14110', NULL, 'Domain of unknown function (DUF4282)', 89, NULL, 'DUF4282', 266965),
(447872, 'PF18237', NULL, 'Tk-SP N-propeptide domain', 68, NULL, 'Tk-SP_N-pro', 266966),
(447873, 'PF08410', NULL, 'Domain of unknown function (DUF1737)', 53, NULL, 'DUF1737', 266967),
(447874, 'PF02386', NULL, 'Cation transport protein', 502, NULL, 'TrkH', 266968),
(447875, 'PF03481', NULL, 'Threonylcarbamoyl-AMP synthase, C-terminal domain', 135, NULL, 'Sua5_C', 266969),
(447876, 'PF13409', NULL, 'Glutathione S-transferase, N-terminal domain', 70, NULL, 'GST_N_2', 266970),
(447877, 'PF17020', NULL, 'Domain of unknown function (DUF5097)', 119, NULL, 'DUF5097', 266971),
(447878, 'PF02503', NULL, 'Polyphosphate kinase middle domain', 202, NULL, 'PP_kinase', 266972),
(447879, 'PF13252', NULL, 'Protein of unknown function (DUF4043)', 386, NULL, 'DUF4043', 266973),
(447880, 'PF04687', NULL, 'Microvirus H protein (pilot protein)', 310, NULL, 'Microvir_H', 266974),
(447881, 'PF05573', NULL, 'NosL', 131, NULL, 'NosL', 266975),
(447882, 'PF17596', NULL, 'Family of unknown function (DUF5492)', 80, NULL, 'DUF5492', 266976),
(447883, 'PF00619', NULL, 'Caspase recruitment domain', 85, NULL, 'CARD', 266977),
(447884, 'PF03426', NULL, 'Carbohydrate binding domain (family 15)', 163, NULL, 'CBM_15', 266978),
(447885, 'PF00918', NULL, 'Gastrin/cholecystokinin family', 127, NULL, 'Gastrin', 266979),
(447886, 'PF08585', NULL, 'RecQ mediated genome instability protein', 217, NULL, 'RMI1_N', 266980),
(447887, 'PF06624', NULL, 'Ribosome associated membrane protein RAMP4', 60, NULL, 'RAMP4', 266981),
(447888, 'PF05719', NULL, 'Golgi phosphoprotein 3 (GPP34)', 203, NULL, 'GPP34', 266982),
(447889, 'PF12365', NULL, 'Protein of unknown function (DUF3649)', 27, NULL, 'DUF3649', 266983),
(447890, 'PF12736', NULL, 'Cell-cycle sustaining, positive selection,', 282, NULL, 'CABIT', 266984),
(447891, 'PF18584', NULL, 'Synaptonemal complex 2 Spt16M-like domain', 112, NULL, 'SYCP2_SLD', 266985),
(447892, 'PF06872', NULL, 'EspG protein', 383, NULL, 'EspG', 266986),
(447893, 'PF11812', NULL, 'Domain of unknown function (DUF3333)', 152, NULL, 'DUF3333', 266987),
(447894, 'PF15888', NULL, 'Folded gastrulation N-terminus', 111, NULL, 'FOG_N', 266988),
(447895, 'PF19232', NULL, 'Family of unknown function (DUF5885)', 265, NULL, 'DUF5885', 266989),
(447896, 'PF11991', NULL, 'Tryptophan dimethylallyltransferase', 363, NULL, 'Trp_DMAT', 266990),
(447897, 'PF09292', NULL, 'Endonuclease VIII-like 1, DNA bind', 39, NULL, 'Neil1-DNA_bind', 266991),
(447898, 'PF06175', NULL, 'tRNA-(MS[2]IO[6]A)-hydroxylase (MiaE)', 240, NULL, 'MiaE', 266992);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(447899, 'PF09436', NULL, 'Domain of unknown function (DUF2016)', 72, NULL, 'DUF2016', 266993),
(447900, 'PF12293', NULL, 'Putative outer membrane core complex of type IVb secretion', 238, NULL, 'T4BSS_DotH_IcmK', 266994),
(447901, 'PF04023', NULL, 'FeoA domain', 74, NULL, 'FeoA', 266995),
(447902, 'PF05250', NULL, 'Uncharacterised protein family (UPF0193)', 216, NULL, 'UPF0193', 266996),
(447903, 'PF19450', NULL, 'Family of unknown function (DUF5988)', 70, NULL, 'DUF5988', 266997),
(447904, 'PF13916', NULL, 'PP1-regulatory protein, Phostensin N-terminal', 86, NULL, 'Phostensin_N', 266998),
(447905, 'PF02668', NULL, 'Taurine catabolism dioxygenase TauD, TfdA family', 268, NULL, 'TauD', 266999),
(447906, 'PF16499', NULL, 'Alpha galactosidase A', 284, NULL, 'Melibiase_2', 267000),
(447907, 'PF19940', NULL, 'Family of unknown function (DUF6402)', 281, NULL, 'DUF6402', 267001),
(447908, 'PF17315', NULL, 'Found in mitochondrial proteome', 118, NULL, 'FMP23', 267002),
(447909, 'PF07245', NULL, 'Phlebovirus glycoprotein G2 fusion domain', 325, NULL, 'Phlebovirus_G2', 267003),
(447910, 'PF06646', NULL, 'Extracytoplasmic thiamine-binding lipoprotein', 331, NULL, 'CypI', 267004),
(447911, 'PF06778', NULL, 'Chlorite dismutase', 194, NULL, 'Chlor_dismutase', 267005),
(447912, 'PF20180', NULL, 'Complex III assembly factor UQCC2/CBP6', 90, NULL, 'UQCC2_CBP6', 267006),
(447913, 'PF03498', NULL, 'Cytolethal distending toxin A/C domain', 150, NULL, 'CDtoxinA', 267007),
(447914, 'PF13733', NULL, 'N-terminal region of glycosyl transferase group 7', 134, NULL, 'Glyco_transf_7N', 267008),
(447915, 'PF13306', NULL, 'BspA type Leucine rich repeat region (6 copies)', 128, NULL, 'LRR_5', 267009),
(447916, 'PF06993', NULL, 'Protein of unknown function (DUF1304)', 110, NULL, 'DUF1304', 267010),
(447917, 'PF03832', NULL, 'WSK motif', 29, NULL, 'WSK', 267011),
(447918, 'PF09852', NULL, 'Predicted membrane protein (DUF2079)', 457, NULL, 'DUF2079', 267012),
(447919, 'PF05880', NULL, 'Fijivirus 64 kDa capsid protein', 554, NULL, 'Fiji_64_capsid', 267013),
(447920, 'PF06588', NULL, 'Muskelin N-terminus', 199, NULL, 'Muskelin_N', 267014),
(447921, 'PF01462', NULL, 'Leucine rich repeat N-terminal domain', 28, NULL, 'LRRNT', 267015),
(447922, 'PF01021', NULL, 'Ty transposon capsid protein', 384, NULL, 'TYA', 267016),
(447923, 'PF04866', NULL, 'Rotavirus non-structural protein 6', 92, NULL, 'Rota_NS6', 267017),
(447924, 'PF13836', NULL, 'Domain of unknown function (DUF4195)', 184, NULL, 'DUF4195', 267018),
(447925, 'PF08011', NULL, 'PD-(D/E)XK nuclease superfamily', 105, NULL, 'PDDEXK_9', 267019),
(447926, 'PF15187', NULL, 'Oesophageal cancer-related gene 4', 114, NULL, 'Augurin', 267020),
(447927, 'PF05955', NULL, 'Equine herpesvirus glycoprotein gp2', 226, NULL, 'Herpes_gp2', 267021),
(447928, 'PF09586', NULL, 'Bacterial membrane protein YfhO', 840, NULL, 'YfhO', 267022),
(447929, 'PF15348', NULL, 'Gemini of Cajal bodies-associated protein 8', 231, NULL, 'GEMIN8', 267023),
(447930, 'PF11784', NULL, 'Protein of unknown function (DUF3320)', 50, NULL, 'DUF3320', 267024),
(447931, 'PF16928', NULL, 'DNA/protein translocase of phage P22 injectosome', 218, NULL, 'Inj_translocase', 267025),
(447932, 'PF01556', NULL, 'DnaJ C terminal domain', 149, NULL, 'DnaJ_C', 267026),
(447933, 'PF14623', NULL, 'Hint-domain', 167, NULL, 'Vint', 267027),
(447934, 'PF18440', NULL, 'Putative GlcNAc-1 phosphotransferase regulatory domain', 88, NULL, 'GlcNAc-1_reg', 267028),
(447935, 'PF20332', NULL, 'Family of unknown function (DUF6627)', 125, NULL, 'DUF6627', 267029),
(447936, 'PF14844', NULL, 'PH domain associated with Beige/BEACH', 100, NULL, 'PH_BEACH', 267030),
(447937, 'PF17698', NULL, 'Family of unknown function (DUF5544)', 125, NULL, 'DUF5544', 267031),
(447938, 'PF18387', NULL, 'Zinc-fingers and homeoboxes C2H2 finger domain', 53, NULL, 'zf_C2H2_ZHX', 267032),
(447939, 'PF19502', NULL, 'Nucleotidyltransferase of unknown function (DUF6036)', 165, NULL, 'DUF6036', 267033),
(447940, 'PF15677', NULL, 'Cell cycle exit and neuronal differentiation protein 1', 147, NULL, 'CEND1', 267034);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(447941, 'PF02380', NULL, 'T-antigen specific domain', 93, NULL, 'Papo_T_antigen', 267035),
(447942, 'PF00928', NULL, 'Adaptor complexes medium subunit family', 264, NULL, 'Adap_comp_sub', 267036),
(447943, 'PF08307', NULL, 'Glycosyl hydrolase family 98 C-terminal domain', 260, NULL, 'Glyco_hydro_98C', 267037),
(447944, 'PF12636', NULL, 'Protein of unknown function (DUF3781)', 72, NULL, 'DUF3781', 267038),
(447945, 'PF19286', NULL, 'Domain of unknown function (DUF5909)', 82, NULL, 'DUF5909', 267039),
(447946, 'PF00366', NULL, 'Ribosomal protein S17', 68, NULL, 'Ribosomal_S17', 267040),
(447947, 'PF13616', NULL, 'PPIC-type PPIASE domain', 116, NULL, 'Rotamase_3', 267041),
(447948, 'PF05172', NULL, 'Nup53/35/40-type RNA recognition motif', 101, NULL, 'Nup35_RRM', 267042),
(447949, 'PF18789', NULL, 'Defence against restriction A C-terminal', 70, NULL, 'DarA_C', 267043),
(447950, 'PF17714', NULL, 'Family of unknown function (DUF5559)', 194, NULL, 'DUF5559', 267044),
(447951, 'PF04296', NULL, 'Protein of unknown function (DUF448)', 75, NULL, 'YlxR', 267045),
(447952, 'PF12981', NULL, 'Domain of Unknown Function with PDB structure (DUF3865)', 224, NULL, 'DUF3865', 267046),
(447953, 'PF19655', NULL, 'Family of unknown function (DUF6158)', 66, NULL, 'DUF6158', 267047),
(447954, 'PF18972', NULL, 'Cns1/TTC4 Wheel domain', 115, NULL, 'Wheel', 267048),
(447955, 'PF13212', NULL, 'Domain of unknown function (DUF4020)', 174, NULL, 'DUF4020', 267049),
(447956, 'PF14225', NULL, 'Cell morphogenesis C-terminal', 253, NULL, 'MOR2-PAG1_C', 267050),
(447957, 'PF05259', NULL, 'Herpesvirus glycoprotein L', 107, NULL, 'Herpes_UL1', 267051),
(447958, 'PF11652', NULL, 'FAM167', 84, NULL, 'FAM167', 267052),
(447959, 'PF13930', NULL, 'DNA/RNA non-specific endonuclease', 132, NULL, 'Endonuclea_NS_2', 267053),
(447960, 'PF14418', NULL, 'OST-HTH Associated domain', 77, NULL, 'OHA', 267054),
(447961, 'PF03578', NULL, 'HGWP repeat', 28, NULL, 'HGWP', 267055),
(447962, 'PF04297', NULL, 'Putative helix-turn-helix protein, YlxM / p13 like', 101, NULL, 'UPF0122', 267056),
(447963, 'PF08021', NULL, 'Siderophore-interacting FAD-binding domain', 121, NULL, 'FAD_binding_9', 267057),
(447964, 'PF17728', NULL, 'BsuBI/PstI restriction endonuclease HTH domain', 141, NULL, 'BsuBI_PstI_RE_N', 267058),
(447965, 'PF00687', NULL, 'Ribosomal protein L1p/L10e family', 204, NULL, 'Ribosomal_L1', 267059),
(447966, 'PF05477', NULL, 'Surfeit locus protein 2 (SURF2)', 242, NULL, 'SURF2', 267060),
(447967, 'PF02986', NULL, 'Fibronectin binding repeat', 38, NULL, 'Fn_bind', 267061),
(447968, 'PF01323', NULL, 'DSBA-like thioredoxin domain', 193, NULL, 'DSBA', 267062),
(447969, 'PF06127', NULL, '2-hydroxy-palmitic acid dioxygenase Mpo1-like', 95, NULL, 'Mpo1-like', 267063),
(447970, 'PF08503', NULL, 'Tetrahydrodipicolinate succinyltransferase N-terminal', 85, NULL, 'DapH_N', 267064),
(447971, 'PF12732', NULL, 'YtxH-like protein', 75, NULL, 'YtxH', 267065),
(447972, 'PF18187', NULL, 'TbRIF5 SNase domain 1', 161, NULL, 'RIF5_SNase_1', 267066),
(447973, 'PF09912', NULL, 'Uncharacterized protein conserved in bacteria (DUF2141)', 112, NULL, 'DUF2141', 267067),
(447974, 'PF18439', NULL, 'Ubiquitin-Binding Zinc Finger', 32, NULL, 'zf_UBZ', 267068),
(447975, 'PF07920', NULL, 'Protein of unknown function (DUF1684)', 141, NULL, 'DUF1684', 267069),
(447976, 'PF15241', NULL, 'Cylicin N-terminus', 107, NULL, 'Cylicin_N', 267070),
(447977, 'PF02731', NULL, 'SKIP/SNW domain', 159, NULL, 'SKIP_SNW', 267071),
(447978, 'PF03362', NULL, 'Herpesvirus UL47 protein', 454, NULL, 'Herpes_UL47', 267072),
(447979, 'PF01516', NULL, 'Orbivirus helicase VP6', 324, NULL, 'Orbi_VP6', 267073),
(447980, 'PF14136', NULL, 'Domain of unknown function (DUF4303)', 153, NULL, 'DUF4303', 267074),
(447981, 'PF02924', NULL, 'Bacteriophage lambda head decoration protein D', 116, NULL, 'HDPD', 267075),
(447982, 'PF02720', NULL, 'Domain of unknown function (DUF222)', 301, NULL, 'DUF222', 267076),
(447983, 'PF19677', NULL, 'Family of unknown function (DUF6179)', 272, NULL, 'DUF6179', 267077),
(447984, 'PF02790', NULL, 'Cytochrome C oxidase subunit II, transmembrane domain', 89, NULL, 'COX2_TM', 267078);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(447985, 'PF09233', NULL, 'Restriction endonuclease EcoRV', 244, NULL, 'Endonuc-EcoRV', 267079),
(447986, 'PF13738', NULL, 'Pyridine nucleotide-disulphide oxidoreductase', 305, NULL, 'Pyr_redox_3', 267080),
(447987, 'PF15533', NULL, 'Bacterial toxin 33', 65, NULL, 'Ntox33', 267081),
(447988, 'PF15749', NULL, 'MRN-interacting protein', 109, NULL, 'MRNIP', 267082),
(447989, 'PF08075', NULL, 'NOPS (NUC059) domain', 52, NULL, 'NOPS', 267083),
(447990, 'PF08913', NULL, 'Vinculin Binding Site', 125, NULL, 'VBS', 267084),
(447991, 'PF01837', NULL, 'Homocysteine biosynthesis enzyme, sulfur-incorporation', 347, NULL, 'HcyBio', 267085),
(447992, 'PF11219', NULL, 'Protein of unknown function (DUF3014)', 156, NULL, 'DUF3014', 267086),
(447993, 'PF16070', NULL, 'Transmembrane protein family 132', 344, NULL, 'TMEM132', 267087),
(447994, 'PF16879', NULL, 'C-terminal domain of Sin3a protein', 288, NULL, 'Sin3a_C', 267088),
(447995, 'PF05144', NULL, 'Phage replication protein CRI', 233, NULL, 'Phage_CRI', 267089),
(447996, 'PF20292', NULL, 'ABC-three component (ABC-3C) system Middle Component 7', 69, NULL, 'MC7', 267090),
(447997, 'PF12027', NULL, 'Protein of unknown function (DUF3514)', 256, NULL, 'DUF3514', 267091),
(447998, 'PF02323', NULL, 'Egg-laying hormone precursor', 255, NULL, 'ELH', 267092),
(447999, 'PF04913', NULL, 'Baculovirus Y142 protein', 440, NULL, 'Baculo_Y142', 267093),
(448000, 'PF09754', NULL, 'PAC2 family', 215, NULL, 'PAC2', 267094),
(448001, 'PF14291', NULL, 'Domain of unknown function (DUF4371)', 236, NULL, 'DUF4371', 267095),
(448002, 'PF20576', NULL, 'HEWD domain', 61, NULL, 'HEWD', 267096),
(448003, 'PF06910', NULL, 'Male enhanced antigen 1 (MEA1)', 125, NULL, 'MEA1', 267097),
(448004, 'PF09588', NULL, 'YqaJ-like viral recombinase domain', 148, NULL, 'YqaJ', 267098),
(448005, 'PF06792', NULL, 'Uncharacterised protein family (UPF0261)', 404, NULL, 'UPF0261', 267099),
(448006, 'PF03360', NULL, 'Glycosyltransferase family 43', 214, NULL, 'Glyco_transf_43', 267100),
(448007, 'PF16446', NULL, 'Domain of unknown function (DUF5043)', 155, NULL, 'DUF5043', 267101),
(448008, 'PF20040', NULL, 'Family of unknown function (DUF6442)', 102, NULL, 'DUF6442', 267102),
(448009, 'PF13027', NULL, 'Protein of unknown function (DUF3888)', 88, NULL, 'DUF3888', 267103),
(448010, 'PF01276', NULL, 'Orn/Lys/Arg decarboxylase, major domain', 417, NULL, 'OKR_DC_1', 267104),
(448011, 'PF01113', NULL, 'Dihydrodipicolinate reductase, N-terminus', 124, NULL, 'DapB_N', 267105),
(448012, 'PF16081', NULL, 'Mycobacterial 2 TMS Phage Holin (M2 Hol) Family', 121, NULL, 'Phage_holin_7_1', 267106),
(448013, 'PF01750', NULL, 'Hydrogenase maturation protease', 130, NULL, 'HycI', 267107),
(448014, 'PF01818', NULL, 'Bacteriophage translational regulator', 121, NULL, 'Translat_reg', 267108),
(448015, 'PF20111', NULL, 'Family of unknown function (DUF6501)', 67, NULL, 'DUF6501', 267109),
(448016, 'PF17202', NULL, 'Single cache domain 3', 107, NULL, 'sCache_3_3', 267110),
(448017, 'PF17730', NULL, 'Centrosomal C10orf90', 512, NULL, 'Centro_C10orf90', 267111),
(448018, 'PF02367', NULL, 'Threonylcarbamoyl adenosine biosynthesis protein TsaE', 129, NULL, 'TsaE', 267112),
(448019, 'PF18044', NULL, 'CCCH-type zinc finger', 22, NULL, 'zf-CCCH_4', 267113),
(448020, 'PF04136', NULL, 'Sec34-like family', 149, NULL, 'Sec34', 267114),
(448021, 'PF07831', NULL, 'Pyrimidine nucleoside phosphorylase C-terminal domain', 75, NULL, 'PYNP_C', 267115),
(448022, 'PF11659', NULL, 'Protein of unknown function (DUF3261)', 139, NULL, 'DUF3261', 267116),
(448023, 'PF05661', NULL, 'Protein of unknown function (DUF808)', 303, NULL, 'DUF808', 267117),
(448024, 'PF04180', NULL, 'Low temperature viability protein', 381, NULL, 'LTV', 267118),
(448025, 'PF09867', NULL, 'TagF N-terminal domain, Type VI secretion system-associated', 135, NULL, 'TagF_N', 267119),
(448026, 'PF00271', NULL, 'Helicase conserved C-terminal domain', 111, NULL, 'Helicase_C', 267120),
(448027, 'PF08648', NULL, 'U4/U6.U5 small nuclear ribonucleoproteins', 56, NULL, 'SNRNP27', 267121);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(448028, 'PF20350', NULL, 'Family of unknown function (DUF6645)', 119, NULL, 'DUF6645', 267122),
(448029, 'PF11506', NULL, 'Protein of unknown function (DUF3217)', 104, NULL, 'DUF3217', 267123),
(448030, 'PF09669', NULL, 'Phage regulatory protein Rha (Phage_pRha)', 90, NULL, 'Phage_pRha', 267124),
(448031, 'PF00303', NULL, 'Thymidylate synthase', 270, NULL, 'Thymidylat_synt', 267125),
(448032, 'PF19235', NULL, 'Family of unknown function (DUF5888)', 140, NULL, 'DUF5888', 267126),
(448033, 'PF09430', NULL, 'ER membrane protein complex subunit 7, beta-sandwich domain', 123, NULL, 'EMC7_beta-sandw', 267127),
(448034, 'PF17810', NULL, 'Arginine decarboxylase helical bundle domain', 84, NULL, 'Arg_decarb_HB', 267128),
(448035, 'PF02225', NULL, 'PA domain', 92, NULL, 'PA', 267129),
(448036, 'PF01726', NULL, 'LexA DNA binding domain', 65, NULL, 'LexA_DNA_bind', 267130),
(448037, 'PF14297', NULL, 'Domain of unknown function (DUF4373)', 95, NULL, 'DUF4373', 267131),
(448038, 'PF10816', NULL, 'Domain of unknown function (DUF2760)', 124, NULL, 'DUF2760', 267132),
(448039, 'PF11001', NULL, 'Protein of unknown function (DUF2841)', 124, NULL, 'DUF2841', 267133),
(448040, 'PF10525', NULL, 'Engrailed homeobox C-terminal signature domain', 31, NULL, 'Engrail_1_C_sig', 267134),
(448041, 'PF16521', NULL, 'Myosin VI cargo binding domain', 90, NULL, 'Myosin-VI_CBD', 267135),
(448042, 'PF00235', NULL, 'Profilin', 127, NULL, 'Profilin', 267136),
(448043, 'PF05847', NULL, 'Nucleopolyhedrovirus late expression factor 3 (LEF-3)', 364, NULL, 'Baculo_LEF-3', 267137),
(448044, 'PF12753', NULL, 'Nuclear pore complex subunit Nro1', 422, NULL, 'Nro1', 267138),
(448045, 'PF13583', NULL, 'Metallo-peptidase family M12B Reprolysin-like', 203, NULL, 'Reprolysin_4', 267139),
(448046, 'PF17042', NULL, 'Nucleotide-binding C-terminal domain', 170, NULL, 'NBD_C', 267140),
(448047, 'PF20043', NULL, 'Family of unknown function (DUF6445)', 224, NULL, 'DUF6445', 267141),
(448048, 'PF10710', NULL, 'Protein of unknown function (DUF2512)', 136, NULL, 'DUF2512', 267142),
(448049, 'PF13336', NULL, 'Acetyl-CoA hydrolase/transferase C-terminal domain', 154, NULL, 'AcetylCoA_hyd_C', 267143),
(448050, 'PF13129', NULL, 'Protein of unknown function (DUF3953)', 41, NULL, 'DUF3953', 267144),
(448051, 'PF07563', NULL, 'Protein of unknown function (DUF1541)', 52, NULL, 'DUF1541', 267145),
(448052, 'PF00535', NULL, 'Glycosyl transferase family 2', 170, NULL, 'Glycos_transf_2', 267146),
(448053, 'PF04209', NULL, 'Homogentisate 1,2-dioxygenase C-terminal', 153, NULL, 'HgmA_C', 267147),
(448054, 'PF07472', NULL, 'Fucose-binding lectin II (PA-IIL)', 107, NULL, 'PA-IIL', 267148),
(448055, 'PF11589', NULL, 'Domain of unknown function (DUF3244)', 101, NULL, 'DUF3244', 267149),
(448056, 'PF02867', NULL, 'Ribonucleotide reductase, barrel domain', 527, NULL, 'Ribonuc_red_lgC', 267150),
(448057, 'PF02499', NULL, 'Probable DNA packing protein, C-terminus', 349, NULL, 'DNA_pack_C', 267151),
(448058, 'PF09110', NULL, 'HAND', 112, NULL, 'HAND', 267152),
(448059, 'PF01959', NULL, '3-dehydroquinate synthase II', 347, NULL, 'DHQS', 267153),
(448060, 'PF19121', NULL, 'Family of unknown function (DUF5805)', 67, NULL, 'DUF5805', 267154),
(448061, 'PF01304', NULL, 'Gas vesicles protein GVPc repeated domain', 33, NULL, 'Gas_vesicle_C', 267155),
(448062, 'PF19991', NULL, 'Heavy metal associated domain 2', 154, NULL, 'HMA_2', 267156),
(448063, 'PF10627', NULL, 'Curli assembly protein CsgE', 105, NULL, 'CsgE', 267157),
(448064, 'PF10845', NULL, 'Protein of unknown function (DUF2576)', 48, NULL, 'DUF2576', 267158),
(448065, 'PF04079', NULL, 'Segregation and condensation complex subunit ScpB', 159, NULL, 'SMC_ScpB', 267159),
(448066, 'PF08548', NULL, 'Peptidase M10 serralysin C terminal', 193, NULL, 'Peptidase_M10_C', 267160),
(448067, 'PF10935', NULL, 'Protein of unknown function (DUF2637)', 161, NULL, 'DUF2637', 267161),
(448068, 'PF07657', NULL, 'N terminus of Notch ligand C2-like domain', 156, NULL, 'MNNL', 267162),
(448069, 'PF03883', NULL, 'Peroxide stress protein YaaA', 233, NULL, 'H2O2_YaaD', 267163);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(448070, 'PF15132', NULL, 'Domain of unknown function (DUF4568)', 175, NULL, 'DUF4568', 267164),
(448071, 'PF16353', NULL, 'Beta-galactosidase, domain 4', 87, NULL, 'LacZ_4', 267165),
(448072, 'PF05555', NULL, 'Coxiella burnetii protein of unknown function (DUF762)', 245, NULL, 'DUF762', 267166),
(448073, 'PF01028', NULL, 'Eukaryotic DNA topoisomerase I, catalytic core', 230, NULL, 'Topoisom_I', 267167),
(448074, 'PF03219', NULL, 'TLC ATP/ADP transporter', 491, NULL, 'TLC', 267168),
(448075, 'PF01126', NULL, 'Heme oxygenase', 205, NULL, 'Heme_oxygenase', 267169),
(448076, 'PF08451', NULL, 'Adenosine/AMP deaminase N-terminal', 95, NULL, 'A_deaminase_N', 267170),
(448077, 'PF05054', NULL, 'Autographa californica nuclear polyhedrosis virus (AcMNPV) protein', 390, NULL, 'AcMNPV_Ac109', 267171),
(448078, 'PF20539', NULL, 'Domain of unknown function (DUF6754)', 257, NULL, 'DUF6754', 267172),
(448079, 'PF01505', NULL, 'Major Vault Protein repeat domain', 43, NULL, 'Vault', 267173),
(448080, 'PF08795', NULL, 'Putative papain-like cysteine peptidase (DUF1796)', 161, NULL, 'DUF1796', 267174),
(448081, 'PF06345', NULL, 'DRF Autoregulatory Domain', 15, NULL, 'Drf_DAD', 267175),
(448082, 'PF08481', NULL, 'GBS Bsp-like repeat', 92, NULL, 'GBS_Bsp-like', 267176),
(448083, 'PF19356', NULL, 'Domain of unknown function (DUF5933)', 144, NULL, 'DUF5933', 267177),
(448084, 'PF05318', NULL, 'Tombusvirus movement protein', 68, NULL, 'Tombus_movement', 267178),
(448085, 'PF16588', NULL, 'C2H2 zinc-finger', 23, NULL, 'zf-C2H2_10', 267179),
(448086, 'PF14888', NULL, 'Penicillin-binding protein Tp47 domain C', 159, NULL, 'PBP-Tp47_c', 267180),
(448087, 'PF12149', NULL, 'Herpes simplex virus virion protein 16 C terminal', 30, NULL, 'HSV_VP16_C', 267181),
(448088, 'PF00349', NULL, 'Hexokinase', 200, NULL, 'Hexokinase_1', 267182),
(448089, 'PF13187', NULL, '4Fe-4S dicluster domain', 52, NULL, 'Fer4_9', 267183),
(448090, 'PF16592', NULL, 'REC lobe of CRISPR-associated endonuclease Cas9', 541, NULL, 'Cas9_REC', 267184),
(448091, 'PF13566', NULL, 'Domain of unknown function (DUF4130', 146, NULL, 'DUF4130', 267185),
(448092, 'PF13791', NULL, 'Sigma factor regulator C-terminal', 154, NULL, 'Sigma_reg_C', 267186),
(448093, 'PF17417', NULL, 'Herpesvirus Glycoprotein B PH-like domain', 97, NULL, 'Glycoprot_B_PH2', 267187),
(448094, 'PF10723', NULL, 'Replication regulatory protein RepB', 81, NULL, 'RepB-RCR_reg', 267188),
(448095, 'PF11313', NULL, 'Protein of unknown function (DUF3116)', 84, NULL, 'DUF3116', 267189),
(448096, 'PF17456', NULL, 'Toxin-coregulated pilus protein S', 152, NULL, 'TcpS', 267190),
(448097, 'PF17022', NULL, 'Polar tube protein 2 from Microsporidia', 217, NULL, 'PTP2', 267191),
(448098, 'PF17385', NULL, 'Lacto-N-biose phosphorylase central domain', 221, NULL, 'LBP_M', 267192),
(448099, 'PF15570', NULL, 'Immunity protein 43', 124, NULL, 'Imm43', 267193),
(448100, 'PF12150', NULL, 'Cytosolic motility protein', 343, NULL, 'MFP2b', 267194),
(448101, 'PF13518', NULL, 'Helix-turn-helix domain', 52, NULL, 'HTH_28', 267195),
(448102, 'PF19469', NULL, 'Family of unknown function (DUF6006)', 140, NULL, 'DUF6006', 267196),
(448103, 'PF02188', NULL, 'GoLoco motif', 22, NULL, 'GoLoco', 267197),
(448104, 'PF06821', NULL, 'Serine hydrolase', 171, NULL, 'Ser_hydrolase', 267198),
(448105, 'PF19134', NULL, 'Domain of unknown function (DUF5817)', 51, NULL, 'DUF5817', 267199),
(448106, 'PF19239', NULL, 'GIY-YIG domain-containing protein', 165, NULL, 'GIY_YIG_domain', 267200),
(448107, 'PF02402', NULL, 'Lysis protein', 49, NULL, 'Lysis_col', 267201),
(448108, 'PF07702', NULL, 'UTRA domain', 141, NULL, 'UTRA', 267202),
(448109, 'PF01088', NULL, 'Ubiquitin carboxyl-terminal hydrolase, family 1', 211, NULL, 'Peptidase_C12', 267203),
(448110, 'PF15473', NULL, 'PEST, proteolytic signal-containing nuclear protein family', 155, NULL, 'PCNP', 267204),
(448111, 'PF15041', NULL, 'Domain of unknown function (DUF4531)', 183, NULL, 'DUF4531', 267205),
(448112, 'PF10929', NULL, 'Protein of unknown function (DUF2811)', 57, NULL, 'DUF2811', 267206);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(448113, 'PF20079', NULL, 'Family of unknown function (DUF6474)', 214, NULL, 'DUF6474', 267207),
(448114, 'PF05904', NULL, 'Plant protein of unknown function (DUF863)', 931, NULL, 'DUF863', 267208),
(448115, 'PF18402', NULL, 'Thioredoxin-like domain', 253, NULL, 'Thioredoxin_14', 267209),
(448116, 'PF12205', NULL, 'G protein-coupled receptor kinase-interacting protein 1 C term', 111, NULL, 'GIT1_C', 267210),
(448117, 'PF11680', NULL, 'Protein of unknown function (DUF3276)', 129, NULL, 'DUF3276', 267211),
(448118, 'PF17684', NULL, 'PH domain of plant-specific actin-binding protein', 108, NULL, 'SCAB-PH', 267212),
(448119, 'PF16515', NULL, 'Clathrin-binding domain of Huntingtin-interacting protein 1', 99, NULL, 'HIP1_clath_bdg', 267213),
(448120, 'PF12758', NULL, 'Protein of unknown function (DUF3813)', 63, NULL, 'DUF3813', 267214),
(448121, 'PF12270', NULL, 'Cytochrome c oxidase subunit IV', 132, NULL, 'Cyt_c_ox_IV', 267215),
(448122, 'PF20588', NULL, 'Cyclin-D-binding Myb-like transcription factor 1 N-terminal', 72, NULL, 'DMTF1_N', 267216),
(448123, 'PF16102', NULL, 'ACTH-associated domain', 28, NULL, 'ACTH_assoc', 267217),
(448124, 'PF15141', NULL, 'Ubiquinol-cytochrome-c reductase complex assembly factor 3', 87, NULL, 'UQCC3', 267218),
(448125, 'PF04956', NULL, 'TrbC/VIRB2 pilin', 99, NULL, 'TrbC', 267219),
(448126, 'PF02376', NULL, 'CUT domain', 79, NULL, 'CUT', 267220),
(448127, 'PF05165', NULL, 'GTP cyclohydrolase III', 246, NULL, 'GCH_III', 267221),
(448128, 'PF10487', NULL, 'Nucleoporin subcomplex protein binding to Pom34', 928, NULL, 'Nup188', 267222),
(448129, 'PF12057', NULL, 'BCL2-associated athanogene 6', 115, NULL, 'BAG6', 267223),
(448130, 'PF01735', NULL, 'Lysophospholipase catalytic domain', 491, NULL, 'PLA2_B', 267224),
(448131, 'PF06884', NULL, 'Protein of unknown function (DUF1264)', 171, NULL, 'DUF1264', 267225),
(448132, 'PF08219', NULL, 'Outer membrane protein TOM13', 84, NULL, 'TOM13', 267226),
(448133, 'PF16316', NULL, 'Domain of unknown function (DUF4956)', 169, NULL, 'DUF4956', 267227),
(448134, 'PF02533', NULL, 'Photosystem II 4 kDa reaction centre component', 41, NULL, 'PsbK', 267228),
(448135, 'PF17940', NULL, 'Tetracyclin repressor-like, C-terminal domain', 107, NULL, 'TetR_C_31', 267229),
(448136, 'PF04432', NULL, 'Coenzyme F420 hydrogenase/dehydrogenase, beta subunit C terminus', 152, NULL, 'FrhB_FdhB_C', 267230),
(448137, 'PF07324', NULL, 'DiGeorge syndrome critical region 6 (DGCR6) protein', 194, NULL, 'DGCR6', 267231),
(448138, 'PF08998', NULL, 'Bacterial epsilon antitoxin', 89, NULL, 'Epsilon_antitox', 267232),
(448139, 'PF13717', NULL, 'zinc-ribbon domain', 36, NULL, 'zinc_ribbon_4', 267233),
(448140, 'PF10808', NULL, 'Protein of unknown function (DUF2542)', 79, NULL, 'DUF2542', 267234),
(448141, 'PF10918', NULL, 'Protein of unknown function (DUF2718)', 129, NULL, 'DUF2718', 267235),
(448142, 'PF19980', NULL, 'Family of unknown function (DUF6416)', 100, NULL, 'DUF6416', 267236),
(448143, 'PF06591', NULL, 'T4-like phage nuclear disruption protein (Ndd)', 152, NULL, 'Phage_T4_Ndd', 267237),
(448144, 'PF00457', NULL, 'Glycosyl hydrolases family 11', 178, NULL, 'Glyco_hydro_11', 267238),
(448145, 'PF11380', NULL, 'Stealth protein CR2, conserved region 2', 108, NULL, 'Stealth_CR2', 267239),
(448146, 'PF15061', NULL, 'Domain of unknown function (DUF4538)', 57, NULL, 'DUF4538', 267240),
(448147, 'PF16641', NULL, 'CLIP1 zinc knuckle', 17, NULL, 'CLIP1_ZNF', 267241),
(448148, 'PF01235', NULL, 'Sodium:alanine symporter family', 393, NULL, 'Na_Ala_symp', 267242),
(448149, 'PF11201', NULL, 'Protein of unknown function (DUF2982)', 151, NULL, 'DUF2982', 267243),
(448150, 'PF01306', NULL, 'LacY proton/sugar symporter', 413, NULL, 'LacY_symp', 267244),
(448151, 'PF19172', NULL, 'Family of unknown function (DUF5854)', 159, NULL, 'DUF5854', 267245),
(448152, 'PF20440', NULL, 'GvpD basic region 2', 254, NULL, 'GvpD_bR2', 267246),
(448153, 'PF01371', NULL, 'Trp repressor protein', 88, NULL, 'Trp_repressor', 267247),
(448154, 'PF17607', NULL, 'Family of unknown function (DUF5503)', 116, NULL, 'DUF5503', 267248);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(448155, 'PF01713', NULL, 'Smr domain', 80, NULL, 'Smr', 267249),
(448156, 'PF07586', NULL, 'Protein of unknown function (DUF1552)', 304, NULL, 'HXXSHH', 267250),
(448157, 'PF17556', NULL, 'MIT-like atracotoxin family', 68, NULL, 'MIT_LIKE_ACTX', 267251),
(448158, 'PF08614', NULL, 'Autophagy protein 16 (ATG16)', 201, NULL, 'ATG16', 267252),
(448159, 'PF10275', NULL, 'Peptidase C65 Otubain', 249, NULL, 'Peptidase_C65', 267253),
(448160, 'PF17291', NULL, 'N-terminal domain of M60-like peptidases', 107, NULL, 'M60-like_N', 267254),
(448161, 'PF00040', NULL, 'Fibronectin type II domain', 42, NULL, 'fn2', 267255),
(448162, 'PF13673', NULL, 'Acetyltransferase (GNAT) domain', 128, NULL, 'Acetyltransf_10', 267256),
(448163, 'PF05669', NULL, 'SOH1', 95, NULL, 'Med31', 267257),
(448164, 'PF02440', NULL, 'Adenovirus E3 region protein CR1', 95, NULL, 'Adeno_E3_CR1', 267258),
(448165, 'PF03272', NULL, 'Putative mucin or carbohydrate-binding module', 116, NULL, 'Mucin_bdg', 267259),
(448166, 'PF11470', NULL, 'TUG ubiquitin-like domain', 65, NULL, 'TUG-UBL1', 267260),
(448167, 'PF01459', NULL, 'Eukaryotic porin', 273, NULL, 'Porin_3', 267261),
(448168, 'PF09887', NULL, 'Uncharacterized protein conserved in archaea (DUF2114)', 449, NULL, 'DUF2114', 267262),
(448169, 'PF20068', NULL, 'Amphi-Trp domain', 95, NULL, 'Amphi-Trp', 267263),
(448170, 'PF16925', NULL, 'Tetracyclin repressor-like, C-terminal domain', 115, NULL, 'TetR_C_13', 267264),
(448171, 'PF17449', NULL, 'Uncharacterized YrzK-like', 54, NULL, 'YrzK', 267265),
(448172, 'PF16620', NULL, 'Unstructured linker between I-set domains 2 and 3 on MYLCK', 162, NULL, '23ISL', 267266),
(448173, 'PF10711', NULL, 'Hypothetical protein (DUF2513)', 101, NULL, 'DUF2513', 267267),
(448174, 'PF09105', NULL, 'Elongation factor SelB, winged helix', 61, NULL, 'SelB-wing_1', 267268),
(448175, 'PF05010', NULL, 'Transforming acidic coiled-coil-containing protein (TACC), C-terminal', 201, NULL, 'TACC_C', 267269),
(448176, 'PF18317', NULL, 'Shikimate 5''-dehydrogenase C-terminal domain', 31, NULL, 'SDH_C', 267270),
(448177, 'PF14975', NULL, 'Domain of unknown function (DUF4512)', 103, NULL, 'DUF4512', 267271),
(448178, 'PF04430', NULL, 'Protein of unknown function (DUF498/DUF598)', 110, NULL, 'DUF498', 267272),
(448179, 'PF15651', NULL, 'Salivary glad secreted protein domain toxin', 97, NULL, 'Tox-SGS', 267273),
(448180, 'PF00325', NULL, 'Bacterial regulatory proteins, crp family', 32, NULL, 'Crp', 267274),
(448181, 'PF07572', NULL, 'Bucentaur or craniofacial development', 75, NULL, 'BCNT', 267275),
(448182, 'PF09183', NULL, 'Domain of unknown function (DUF1947)', 66, NULL, 'DUF1947', 267276),
(448183, 'PF12809', NULL, 'Eukaryotic metallothionein', 69, NULL, 'Metallothi_Euk2', 267277),
(448184, 'PF10366', NULL, 'Vacuolar sorting protein 39 domain 1', 108, NULL, 'Vps39_1', 267278),
(448185, 'PF18136', NULL, 'DNA mitochondrial polymerase exonuclease domain', 282, NULL, 'DNApol_Exo', 267279),
(448186, 'PF00695', NULL, 'Major surface antigen from hepadnavirus', 400, NULL, 'vMSA', 267280),
(448187, 'PF00594', NULL, 'Vitamin K-dependent carboxylation/gamma-carboxyglutamic (GLA) domain', 41, NULL, 'Gla', 267281),
(448188, 'PF19600', NULL, 'Family of unknown function (DUF6105)', 110, NULL, 'DUF6105', 267282),
(448189, 'PF09029', NULL, '5-aminolevulinate synthase presequence', 114, NULL, 'Preseq_ALAS', 267283),
(448190, 'PF09461', NULL, 'Phytotoxin PcF protein', 45, NULL, 'PcF', 267284),
(448191, 'PF09369', NULL, 'MrfA Zn-binding domain', 83, NULL, 'MZB', 267285),
(448192, 'PF10167', NULL, 'BLOC-1-related complex sub-unit 8', 112, NULL, 'BORCS8', 267286),
(448193, 'PF03108', NULL, 'MuDR family transposase', 67, NULL, 'DBD_Tnp_Mut', 267287),
(448194, 'PF17745', NULL, 'Ydr279p protein triple barrel domain', 79, NULL, 'Ydr279_N', 267288),
(448195, 'PF08859', NULL, 'DGC domain', 106, NULL, 'DGC', 267289),
(448196, 'PF15156', NULL, 'Ceroid-lipofuscinosis neuronal protein 6', 280, NULL, 'CLN6', 267290),
(448197, 'PF18347', NULL, 'Domain of unknown function (DUF5606)', 46, NULL, 'DUF5606', 267291);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(448198, 'PF05149', NULL, 'Paraflagellar rod protein', 287, NULL, 'Flagellar_rod', 267292),
(448199, 'PF10851', NULL, 'Protein of unknown function (DUF2652)', 118, NULL, 'DUF2652', 267293),
(448200, 'PF12129', NULL, 'Homeodomain containing protein PHTF1/2, N-terminal', 156, NULL, 'PHTF1-2_N', 267294),
(448201, 'PF02443', NULL, 'Circovirus capsid protein', 235, NULL, 'Circo_capsid', 267295),
(448202, 'PF15404', NULL, 'Pleckstrin homology domain', 184, NULL, 'PH_4', 267296),
(448203, 'PF18919', NULL, 'Family of unknown function (DUF5670)', 43, NULL, 'DUF5670', 267297),
(448204, 'PF04278', NULL, 'Tic22-like family', 244, NULL, 'Tic22', 267298),
(448205, 'PF19163', NULL, 'Family of unknown function (DUF5845)', 80, NULL, 'DUF5845', 267299),
(448206, 'PF08867', NULL, 'FRG domain', 94, NULL, 'FRG', 267300),
(448207, 'PF02407', NULL, 'Putative viral replication protein', 82, NULL, 'Viral_Rep', 267301),
(448208, 'PF05120', NULL, 'Gas vesicle protein G', 80, NULL, 'GvpG', 267302),
(448209, 'PF07564', NULL, 'Domain of Unknown Function (DUF1542)', 77, NULL, 'DUF1542', 267303),
(448210, 'PF08220', NULL, 'DeoR-like helix-turn-helix domain', 57, NULL, 'HTH_DeoR', 267304),
(448211, 'PF10116', NULL, 'Protein required for attachment to host cells', 138, NULL, 'Host_attach', 267305),
(448212, 'PF14304', NULL, 'Transcription termination and cleavage factor C-terminal', 41, NULL, 'CSTF_C', 267306),
(448213, 'PF00004', NULL, 'ATPase family associated with various cellular activities (AAA)', 132, NULL, 'AAA', 267307),
(448214, 'PF04259', NULL, 'Small, acid-soluble spore protein, gamma-type', 84, NULL, 'SASP_gamma', 267308),
(448215, 'PF10170', NULL, 'Cysteine-rich domain', 95, NULL, 'C6_DPF', 267309),
(448216, 'PF11093', NULL, 'Mitochondrial export protein Som1', 93, NULL, 'Mitochondr_Som1', 267310),
(448217, 'PF00057', NULL, 'Low-density lipoprotein receptor domain class A', 37, NULL, 'Ldl_recept_a', 267311),
(448218, 'PF06163', NULL, 'Bacterial protein of unknown function (DUF977)', 127, NULL, 'DUF977', 267312),
(448219, 'PF03094', NULL, 'Mlo family', 482, NULL, 'Mlo', 267313),
(448220, 'PF03826', NULL, 'OAR motif', 19, NULL, 'OAR', 267314),
(448221, 'PF11296', NULL, 'Protein of unknown function (DUF3097)', 270, NULL, 'DUF3097', 267315),
(448222, 'PF12309', NULL, 'KIF-1 binding protein C terminal', 361, NULL, 'KBP_C', 267316),
(448223, 'PF19478', NULL, 'TrbL/VirB6 plasmid conjugal transfer like protein', 174, NULL, 'TrbL_2', 267317),
(448224, 'PF16504', NULL, 'Putative virion membrane protein of plant and insect virus', 147, NULL, 'SP24', 267318),
(448225, 'PF05742', NULL, 'Transport and Golgi organisation 2', 254, NULL, 'TANGO2', 267319),
(448226, 'PF00879', NULL, 'Defensin propeptide', 51, NULL, 'Defensin_propep', 267320),
(448227, 'PF13048', NULL, 'Protein of unknown function (DUF3908)', 131, NULL, 'DUF3908', 267321),
(448228, 'PF07359', NULL, 'Liver-expressed antimicrobial peptide 2 precursor (LEAP-2)', 77, NULL, 'LEAP-2', 267322),
(448229, 'PF15859', NULL, 'Deleted in esophageal cancer 1 family', 70, NULL, 'DEC1', 267323),
(448230, 'PF10801', NULL, 'Protein of unknown function (DUF2537)', 80, NULL, 'DUF2537', 267324),
(448231, 'PF05943', NULL, 'EvpB/VC_A0108, tail sheath N-terminal domain', 302, NULL, 'VipB', 267325),
(448232, 'PF14822', NULL, 'Vasohibin', 245, NULL, 'Vasohibin', 267326),
(448233, 'PF06798', NULL, 'PrkA serine protein kinase C-terminal domain', 257, NULL, 'PrkA', 267327),
(448234, 'PF01759', NULL, 'UNC-6/NTR/C345C module', 107, NULL, 'NTR', 267328),
(448235, 'PF02061', NULL, 'Lambda Phage CIII', 42, NULL, 'Lambda_CIII', 267329),
(448236, 'PF18540', NULL, 'Domain of unknown function (DUF5626)', 120, NULL, 'DUF5626', 267330),
(448237, 'PF18069', NULL, 'DR2241 stabilising domain', 111, NULL, 'DR2241', 267331),
(448238, 'PF20606', NULL, 'Domain of unknown function (DUF6799)', 63, NULL, 'DUF6799', 267332),
(448239, 'PF20566', NULL, 'eIF4E-associated protein', 154, NULL, 'Eap1', 267333),
(448240, 'PF05090', NULL, 'Vitamin K-dependent gamma-carboxylase', 435, NULL, 'VKG_Carbox', 267334),
(448241, 'PF05624', NULL, 'Lipolysis stimulated receptor (LSR)', 48, NULL, 'LSR', 267335);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(448242, 'PF03419', NULL, 'Sporulation factor SpoIIGA', 284, NULL, 'Peptidase_U4', 267336),
(448243, 'PF08948', NULL, 'Bacteriophage PRD1, P5, spike N-terminal', 126, NULL, 'PRD1_P5_spike_N', 267337),
(448244, 'PF01986', NULL, 'Domain of unknown function DUF123', 94, NULL, 'DUF123', 267338),
(448245, 'PF14537', NULL, 'Cytochrome c3', 81, NULL, 'Cytochrom_c3_2', 267339),
(448246, 'PF04606', NULL, 'Ogr/Delta-like zinc finger', 47, NULL, 'Ogr_Delta', 267340),
(448247, 'PF02327', NULL, 'Bacteriochlorophyll A protein', 354, NULL, 'BChl_A', 267341),
(448248, 'PF04987', NULL, 'Phosphatidylinositolglycan class N (PIG-N)', 451, NULL, 'PigN', 267342),
(448249, 'PF05195', NULL, 'Aminopeptidase P, N-terminal domain', 123, NULL, 'AMP_N', 267343),
(448250, 'PF04541', NULL, 'Herpesvirus virion protein U34', 202, NULL, 'Herpes_U34', 267344),
(448251, 'PF00668', NULL, 'Condensation domain', 457, NULL, 'Condensation', 267345),
(448252, 'PF09344', NULL, 'CT1975-like protein', 360, NULL, 'Cas_CT1975', 267346),
(448253, 'PF04821', NULL, 'Timeless protein', 277, NULL, 'TIMELESS', 267347),
(448254, 'PF19646', NULL, 'Family of unknown function (DUF6149)', 200, NULL, 'DUF6149', 267348),
(448255, 'PF08865', NULL, 'Domain of unknown function (DUF1830)', 66, NULL, 'DUF1830', 267349),
(448256, 'PF12354', NULL, 'Bacterial adhesion/invasion protein N terminal', 57, NULL, 'Internalin_N', 267350),
(448257, 'PF06958', NULL, 'S-type Pyocin', 139, NULL, 'Pyocin_S', 267351),
(448258, 'PF08347', NULL, 'N-terminal CTNNB1 binding', 209, NULL, 'CTNNB1_binding', 267352),
(448259, 'PF12761', NULL, 'Actin cytoskeleton-regulatory complex protein END3', 198, NULL, 'End3', 267353),
(448260, 'PF02633', NULL, 'Creatinine amidohydrolase', 238, NULL, 'Creatininase', 267354),
(448261, 'PF06011', NULL, 'Transient receptor potential (TRP) ion channel', 426, NULL, 'TRP', 267355),
(448262, 'PF02466', NULL, 'Tim17/Tim22/Tim23/Pmp24 family', 111, NULL, 'Tim17', 267356),
(448263, 'PF09905', NULL, 'DNA-binding protein VF530', 63, NULL, 'VF530', 267357),
(448264, 'PF05947', NULL, 'Type VI secretion system, TssF', 605, NULL, 'T6SS_TssF', 267358),
(448265, 'PF06135', NULL, 'IreB regulatory phosphoprotein', 78, NULL, 'IreB', 267359),
(448266, 'PF18716', NULL, 'Vms1-associating treble clef domain', 43, NULL, 'VATC', 267360),
(448267, 'PF04199', NULL, 'Putative cyclase', 135, NULL, 'Cyclase', 267361),
(448268, 'PF09724', NULL, 'Sister chromatid cohesion protein Dcc1', 336, NULL, 'Dcc1', 267362),
(448269, 'PF11897', NULL, 'Protein of unknown function (DUF3417)', 109, NULL, 'DUF3417', 267363),
(448270, 'PF04631', NULL, 'Per os infectivity factor 2', 372, NULL, 'PIF2', 267364),
(448271, 'PF02577', NULL, 'Bifunctional nuclease domain', 114, NULL, 'BFN_dom', 267365),
(448272, 'PF00234', NULL, 'Protease inhibitor/seed storage/LTP family', 87, NULL, 'Tryp_alpha_amyl', 267366),
(448273, 'PF03427', NULL, 'Carbohydrate binding domain (family 19)', 61, NULL, 'CBM_19', 267367),
(448274, 'PF15630', NULL, 'CENP-S protein', 76, NULL, 'CENP-S', 267368),
(448275, 'PF04566', NULL, 'RNA polymerase Rpb2, domain 4', 62, NULL, 'RNA_pol_Rpb2_4', 267369),
(448276, 'PF09611', NULL, 'CRISPR-associated protein (Cas_Csy1)', 378, NULL, 'Cas_Csy1', 267370),
(448277, 'PF00300', NULL, 'Histidine phosphatase superfamily (branch 1)', 194, NULL, 'His_Phos_1', 267371),
(448278, 'PF05996', NULL, 'Ferredoxin-dependent bilin reductase', 228, NULL, 'Fe_bilin_red', 267372),
(448279, 'PF18472', NULL, 'HP1451 C-terminal domain', 67, NULL, 'HP1451_C', 267373),
(448280, 'PF13754', NULL, 'Domain of unknown function', 105, NULL, 'Big_3_4', 267374),
(448281, 'PF01582', NULL, 'TIR domain', 176, NULL, 'TIR', 267375),
(448282, 'PF12151', NULL, 'Mannan-binding protein', 36, NULL, 'MVL', 267376),
(448283, 'PF17533', NULL, 'Family of unknown function (DUF5452)', 169, NULL, 'DUF5452', 267377),
(448284, 'PF02452', NULL, 'PemK-like, MazF-like toxin of type II toxin-antitoxin system', 111, NULL, 'PemK_toxin', 267378),
(448285, 'PF15424', NULL, 'Odontogenic ameloblast-associated family', 264, NULL, 'ODAM', 267379);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(448286, 'PF17331', NULL, 'GFD1 mRNA transport factor', 44, NULL, 'GFD1', 267380),
(448287, 'PF10996', NULL, 'Beta-Casp domain', 114, NULL, 'Beta-Casp', 267381),
(448288, 'PF16421', NULL, 'E2F transcription factor CC-MB domain', 95, NULL, 'E2F_CC-MB', 267382),
(448289, 'PF13574', NULL, 'Metallo-peptidase family M12B Reprolysin-like', 194, NULL, 'Reprolysin_2', 267383),
(448290, 'PF15999', NULL, 'Domain of unknown function (DUF4774)', 58, NULL, 'DUF4774', 267384),
(448291, 'PF14909', NULL, 'Spermatogenesis-assoc protein 6', 139, NULL, 'SPATA6', 267385),
(448292, 'PF16190', NULL, 'Ubiquitin-activating enzyme E1 FCCH domain', 70, NULL, 'E1_FCCH', 267386),
(448293, 'PF17407', NULL, 'Nrap protein domain 6', 133, NULL, 'Nrap_D6', 267387),
(448294, 'PF13123', NULL, 'Protein of unknown function (DUF3978)', 144, NULL, 'DUF3978', 267388),
(448295, 'PF03668', NULL, 'P-loop ATPase protein family', 284, NULL, 'ATP_bind_2', 267389),
(448296, 'PF08996', NULL, 'DNA Polymerase alpha zinc finger', 186, NULL, 'zf-DNA_Pol', 267390),
(448297, 'PF10715', NULL, 'T4-page Endoribonuclease RegB', 150, NULL, 'REGB_T4', 267391),
(448298, 'PF06446', NULL, 'Hepcidin', 53, NULL, 'Hepcidin', 267392),
(448299, 'PF00719', NULL, 'Inorganic pyrophosphatase', 160, NULL, 'Pyrophosphatase', 267393),
(448300, 'PF16493', NULL, 'N-terminal of Homeobox Meis and PKNOX1', 86, NULL, 'Meis_PKNOX_N', 267394),
(448301, 'PF19798', NULL, 'Sulfotransferase domain', 226, NULL, 'Sulfotransfer_5', 267395),
(448302, 'PF15093', NULL, 'Domain of unknown function (DUF4555)', 284, NULL, 'DUF4555', 267396),
(448303, 'PF12104', NULL, 'T cell CD4 receptor C terminal region', 28, NULL, 'Tcell_CD4_C', 267397),
(448304, 'PF09479', NULL, 'Listeria-Bacteroides repeat domain (List_Bact_rpt)', 65, NULL, 'Flg_new', 267398),
(448305, 'PF10984', NULL, 'Protein of unknown function (DUF2794)', 85, NULL, 'DUF2794', 267399),
(448306, 'PF14617', NULL, 'U3-containing 90S pre-ribosomal complex subunit', 252, NULL, 'CMS1', 267400),
(448307, 'PF05436', NULL, 'Mating factor alpha precursor N-terminus', 88, NULL, 'MF_alpha_N', 267401),
(448308, 'PF08912', NULL, 'Rho Binding', 69, NULL, 'Rho_Binding', 267402),
(448309, 'PF01349', NULL, 'Flavivirus non-structural protein NS4B', 244, NULL, 'Flavi_NS4B', 267403),
(448310, 'PF03784', NULL, 'Cyclotide family', 30, NULL, 'Cyclotide', 267404),
(448311, 'PF16771', NULL, 'Regulator of Ty1 transposition protein 107 BRCT domain', 114, NULL, 'RTT107_BRCT_6', 267405),
(448312, 'PF00183', NULL, 'Hsp90 protein', 518, NULL, 'HSP90', 267406),
(448313, 'PF11387', NULL, 'Protein of unknown function (DUF2795)', 44, NULL, 'DUF2795', 267407),
(448314, 'PF19726', NULL, 'Family of unknown function (DUF6218)', 229, NULL, 'DUF6218', 267408),
(448315, 'PF00176', NULL, 'SNF2-related domain', 318, NULL, 'SNF2-rel_dom', 267409),
(448316, 'PF15047', NULL, 'Protein of unknown function (DUF4533)', 225, NULL, 'DUF4533', 267410),
(448317, 'PF20005', NULL, 'FtsH ternary system domain X7', 421, NULL, 'fvmX7', 267411),
(448318, 'PF16437', NULL, 'Domain of unknown function (DUF5034)', 161, NULL, 'DUF5034', 267412),
(448319, 'PF07130', NULL, 'YebG protein', 74, NULL, 'YebG', 267413),
(448320, 'PF12855', NULL, 'ECL1/2/3 zinc binding proteins', 174, NULL, 'Ecl1', 267414),
(448321, 'PF10134', NULL, 'Replication initiator protein A', 229, NULL, 'RPA', 267415),
(448322, 'PF07002', NULL, 'Copine', 218, NULL, 'Copine', 267416),
(448323, 'PF00630', NULL, 'Filamin/ABP280 repeat', 103, NULL, 'Filamin', 267417),
(448324, 'PF20446', NULL, 'ATPase of the ABC class N-terminal', 163, NULL, 'ABC_N', 267418),
(448325, 'PF19859', NULL, 'Family of unknown function (DUF6333)', 234, NULL, 'DUF6333', 267419),
(448326, 'PF04663', NULL, 'Phenol hydroxylase conserved region', 66, NULL, 'Phenol_monoox', 267420),
(448327, 'PF19289', NULL, 'PmbA/TldA metallopeptidase C-terminal domain', 220, NULL, 'PmbA_TldD_C', 267421),
(448328, 'PF01286', NULL, 'XPA protein N-terminal', 32, NULL, 'XPA_N', 267422),
(448329, 'PF05123', NULL, 'S-layer like family, N-terminal region', 284, NULL, 'S_layer_N', 267423);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(448330, 'PF20341', NULL, 'Family of unknown function (DUF6636)', 140, NULL, 'DUF6636', 267424),
(448331, 'PF07499', NULL, 'RuvA, C-terminal domain', 47, NULL, 'RuvA_C', 267425),
(448332, 'PF12927', NULL, 'Domain of unknown function (DUF3835)', 78, NULL, 'DUF3835', 267426),
(448333, 'PF15950', NULL, 'Putative sperm flagellar membrane protein', 143, NULL, 'DUF4758', 267427),
(448334, 'PF14360', NULL, 'PAP2 superfamily C-terminal', 74, NULL, 'PAP2_C', 267428),
(448335, 'PF18216', NULL, 'N-formyltransferase dimerization C-terminal domain', 52, NULL, 'N_formyltrans_C', 267429),
(448336, 'PF20312', NULL, 'Family of unknown function (DUF6608)', 131, NULL, 'DUF6608', 267430),
(448337, 'PF14014', NULL, 'Protein of unknown function (DUF4230)', 143, NULL, 'DUF4230', 267431),
(448338, 'PF08389', NULL, 'Exportin 1-like protein', 149, NULL, 'Xpo1', 267432),
(448339, 'PF11663', NULL, 'Toxin with endonuclease activity, of toxin-antitoxin system', 138, NULL, 'Toxin_YhaV', 267433),
(448340, 'PF16325', NULL, 'Peptidase family U32 C-terminal domain', 82, NULL, 'Peptidase_U32_C', 267434),
(448341, 'PF12026', NULL, 'Crk-Associated Substrate C-terminal domain', 208, NULL, 'CAS_C', 267435),
(448342, 'PF03893', NULL, 'Lipase 3 N-terminal region', 76, NULL, 'Lipase3_N', 267436),
(448343, 'PF14693', NULL, 'Ribosomal protein TL5, C-terminal domain', 85, NULL, 'Ribosomal_TL5_C', 267437),
(448344, 'PF01301', NULL, 'Glycosyl hydrolases family 35', 316, NULL, 'Glyco_hydro_35', 267438),
(448345, 'PF10131', NULL, '6-pyruvoyl-tetrahydropterin synthase related domain; membrane protein', 621, NULL, 'PTPS_related', 267439),
(448346, 'PF18282', NULL, 'RAP80 N-terminal ubiquitin interaction motif', 57, NULL, 'RAP80_UIM', 267440),
(448347, 'PF14656', NULL, 'Rab3 GTPase-activating protein regulatory subunit C-terminus', 594, NULL, 'RAB3GAP2_C', 267441),
(448348, 'PF20421', NULL, 'DHR-2, Lobe C', 103, NULL, 'DHR-2_Lobe_C', 267442),
(448349, 'PF01464', NULL, 'Transglycosylase SLT domain', 117, NULL, 'SLT', 267443),
(448350, 'PF03728', NULL, 'Viral DNA-binding protein, zinc binding domain', 98, NULL, 'Viral_DNA_Zn_bi', 267444),
(448351, 'PF14384', NULL, 'BrnA antitoxin of type II toxin-antitoxin system', 69, NULL, 'BrnA_antitoxin', 267445),
(448352, 'PF09263', NULL, 'Peroxisome biogenesis factor 1, N-terminal', 83, NULL, 'PEX-2N', 267446),
(448353, 'PF07369', NULL, 'Protein of unknown function (DUF1488)', 82, NULL, 'DUF1488', 267447),
(448354, 'PF14034', NULL, 'Sporulation protein YtrH', 101, NULL, 'Spore_YtrH', 267448),
(448355, 'PF17725', NULL, 'YAP binding domain', 201, NULL, 'YBD', 267449),
(448356, 'PF09664', NULL, 'Protein of unknown function C-terminus (DUF2399)', 152, NULL, 'DUF2399', 267450),
(448357, 'PF05641', NULL, 'Agenet domain', 61, NULL, 'Agenet', 267451),
(448358, 'PF07120', NULL, 'Protein of unknown function (DUF1376)', 86, NULL, 'DUF1376', 267452),
(448359, 'PF14541', NULL, 'Xylanase inhibitor C-terminal', 161, NULL, 'TAXi_C', 267453),
(448360, 'PF03695', NULL, 'Uncharacterised protein family (UPF0149)', 177, NULL, 'UPF0149', 267454),
(448361, 'PF13639', NULL, 'Ring finger domain', 44, NULL, 'zf-RING_2', 267455),
(448362, 'PF16903', NULL, 'Major capsid protein N-terminus', 207, NULL, 'Capsid_N', 267456),
(448363, 'PF06083', NULL, 'Interleukin-17', 81, NULL, 'IL17', 267457),
(448364, 'PF06726', NULL, 'Bladder cancer-related protein BC10', 65, NULL, 'BC10', 267458),
(448365, 'PF11849', NULL, 'Domain of unknown function (DUF3369)', 168, NULL, 'DUF3369', 267459),
(448366, 'PF12752', NULL, 'SUZ domain', 59, NULL, 'SUZ', 267460),
(448367, 'PF08377', NULL, 'MAP2/Tau projection domain', 1134, NULL, 'MAP2_projctn', 267461),
(448368, 'PF10329', NULL, 'Region of unknown function (DUF2417)', 237, NULL, 'DUF2417', 267462),
(448369, 'PF20381', NULL, 'Family of unknown function (DUF6676)', 158, NULL, 'DUF6676', 267463),
(448370, 'PF02146', NULL, 'Sir2 family', 179, NULL, 'SIR2', 267464),
(448371, 'PF04844', NULL, 'Transcriptional repressor, ovate', 58, NULL, 'Ovate', 267465),
(448372, 'PF10045', NULL, 'Uncharacterized conserved protein (DUF2280)', 103, NULL, 'DUF2280', 267466);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(448373, 'PF10666', NULL, 'Phage tail assembly chaperone protein Gp14 ()A118', 140, NULL, 'Phage_TAC_8', 267467),
(448374, 'PF06282', NULL, 'Protein of unknown function (DUF1036)', 113, NULL, 'DUF1036', 267468),
(448375, 'PF16584', NULL, 'Outer membrane lipoprotein carrier protein LolA', 152, NULL, 'LolA_2', 267469),
(448376, 'PF07450', NULL, 'Formate hydrogenlyase maturation protein HycH', 129, NULL, 'HycH', 267470),
(448377, 'PF08298', NULL, 'PrkA AAA domain', 358, NULL, 'AAA_PrkA', 267471),
(448378, 'PF18889', NULL, 'Beta helix repeat', 20, NULL, 'Beta_helix_3', 267472),
(448379, 'PF14128', NULL, 'Domain of unknown function (DUF4295)', 47, NULL, 'DUF4295', 267473),
(448380, 'PF01123', NULL, 'Staphylococcal/Streptococcal toxin, OB-fold domain', 87, NULL, 'Stap_Strp_toxin', 267474),
(448381, 'PF11571', NULL, 'Mediator complex subunit 27', 86, NULL, 'Med27', 267475),
(448382, 'PF04889', NULL, 'Cwf15/Cwc15 cell cycle control protein', 247, NULL, 'Cwf_Cwc_15', 267476),
(448383, 'PF18774', NULL, 'APOBEC4-like -AID/APOBEC-deaminase', 132, NULL, 'APOBEC4_like', 267477),
(448384, 'PF04513', NULL, 'Baculovirus polyhedron envelope protein, PEP, C terminus', 140, NULL, 'Baculo_PEP_C', 267478),
(448385, 'PF20480', NULL, 'Family of unknown function (DUF6720)', 306, NULL, 'DUF6720', 267479),
(448386, 'PF13103', NULL, 'TonB C terminal', 85, NULL, 'TonB_2', 267480),
(448387, 'PF20573', NULL, 'Putative metallopeptidase family (DUF6782)', 241, NULL, 'DUF6782', 267481),
(448388, 'PF12179', NULL, 'I-kappa-kinase-beta NEMO binding domain', 37, NULL, 'IKKbetaNEMObind', 267482),
(448389, 'PF15983', NULL, 'Domain of unknown function (DUF4767)', 138, NULL, 'DUF4767', 267483),
(448390, 'PF05045', NULL, 'Rhamnan synthesis protein F', 503, NULL, 'RgpF', 267484),
(448391, 'PF15211', NULL, 'VEGF co-regulated chemokine 1', 89, NULL, 'CXCL17', 267485),
(448392, 'PF15193', NULL, 'FAM24 family', 69, NULL, 'FAM24', 267486),
(448393, 'PF05813', NULL, 'Orthopoxvirus F7 protein', 80, NULL, 'Orthopox_F7', 267487),
(448394, 'PF14792', NULL, 'DNA polymerase beta palm', 115, NULL, 'DNA_pol_B_palm', 267488),
(448395, 'PF15768', NULL, 'Coiled-coil domain-containing protein 190', 270, NULL, 'CC190', 267489),
(448396, 'PF17772', NULL, 'MYST family zinc finger domain', 55, NULL, 'zf-MYST', 267490),
(448397, 'PF08474', NULL, 'Myelin transcription factor 1', 240, NULL, 'MYT1', 267491),
(448398, 'PF17440', NULL, 'Thiol-activated cytolysin beta sandwich domain', 102, NULL, 'Thiol_cytolys_C', 267492),
(448399, 'PF11017', NULL, 'Protein of unknown function (DUF2855)', 346, NULL, 'DUF2855', 267493),
(448400, 'PF12488', NULL, 'Protein of unknown function (DUF3704)', 27, NULL, 'DUF3704', 267494),
(448401, 'PF04689', NULL, 'DNA binding protein S1FA', 66, NULL, 'S1FA', 267495),
(448402, 'PF17235', NULL, 'STD1/MTH1', 204, NULL, 'STD1', 267496),
(448403, 'PF00441', NULL, 'Acyl-CoA dehydrogenase, C-terminal domain', 150, NULL, 'Acyl-CoA_dh_1', 267497),
(448404, 'PF14017', NULL, 'Protein of unknown function (DUF4233)', 104, NULL, 'DUF4233', 267498),
(448405, 'PF11391', NULL, 'Protein of unknown function (DUF2798)', 59, NULL, 'DUF2798', 267499),
(448406, 'PF18082', NULL, 'N-acyltransferase N-terminal domain', 129, NULL, 'NAT_N', 267500),
(448407, 'PF05222', NULL, 'Alanine dehydrogenase/PNT, N-terminal domain', 135, NULL, 'AlaDh_PNT_N', 267501),
(448408, 'PF16263', NULL, 'Domain of unknown function (DUF4917)', 310, NULL, 'DUF4917', 267502),
(448409, 'PF11945', NULL, 'WAHD domain of WASH complex', 292, NULL, 'WASH_WAHD', 267503),
(448410, 'PF03413', NULL, 'Peptidase propeptide and YPEB domain', 63, NULL, 'PepSY', 267504),
(448411, 'PF18568', NULL, 'TRIM C-terminal subgroup One Signature domain', 52, NULL, 'COS', 267505),
(448412, 'PF16055', NULL, 'Domain of unknown function (DUF4798)', 100, NULL, 'DUF4798', 267506),
(448413, 'PF20320', NULL, 'Family of unknown function (DUF6615)', 290, NULL, 'DUF6615', 267507),
(448414, 'PF03217', NULL, 'Surface layer protein A domain', 54, NULL, 'SlpA', 267508),
(448415, 'PF12599', NULL, 'Protein of unknown function (DUF3768)', 83, NULL, 'DUF3768', 267509);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(448416, 'PF15845', NULL, 'Cysteine-rich C-terminal 1 family', 89, NULL, 'NICE-1', 267510),
(448417, 'PF07627', NULL, 'Protein of unknown function (DUF1588)', 98, NULL, 'PSCyt3', 267511),
(448418, 'PF00701', NULL, 'Dihydrodipicolinate synthetase family', 289, NULL, 'DHDPS', 267512),
(448419, 'PF04021', NULL, 'Class III signal peptide', 27, NULL, 'Class_IIIsignal', 267513),
(448420, 'PF15926', NULL, 'E3 ubiquitin-protein ligase RNF220', 248, NULL, 'RNF220', 267514),
(448421, 'PF01852', NULL, 'START domain', 209, NULL, 'START', 267515),
(448422, 'PF07363', NULL, 'Protein of unknown function (DUF1484)', 109, NULL, 'DUF1484', 267516),
(448423, 'PF06719', NULL, 'AraC-type transcriptional regulator N-terminus', 148, NULL, 'AraC_N', 267517),
(448424, 'PF20160', NULL, 'C-JID domain', 95, NULL, 'C-JID', 267518),
(448425, 'PF01839', NULL, 'FG-GAP repeat', 35, NULL, 'FG-GAP', 267519),
(448426, 'PF13353', NULL, '4Fe-4S single cluster domain', 137, NULL, 'Fer4_12', 267520),
(448427, 'PF08012', NULL, 'Protein of unknown function (DUF1702)', 319, NULL, 'DUF1702', 267521),
(448428, 'PF00388', NULL, 'Phosphatidylinositol-specific phospholipase C, X domain', 145, NULL, 'PI-PLC-X', 267522),
(448429, 'PF08276', NULL, 'PAN-like domain', 67, NULL, 'PAN_2', 267523),
(448430, 'PF03974', NULL, 'Ecotin', 122, NULL, 'Ecotin', 267524),
(448431, 'PF00680', NULL, 'Viral RNA-dependent RNA polymerase', 462, NULL, 'RdRP_1', 267525),
(448432, 'PF03415', NULL, 'Clostripain family', 360, NULL, 'Peptidase_C11', 267526),
(448433, 'PF00437', NULL, 'Type II/IV secretion system protein', 277, NULL, 'T2SSE', 267527),
(448434, 'PF03845', NULL, 'Spore germination protein', 321, NULL, 'Spore_permease', 267528),
(448435, 'PF11832', NULL, 'Protein of unknown function (DUF3352)', 541, NULL, 'DUF3352', 267529),
(448436, 'PF09506', NULL, 'Glucosylglycerol-phosphate phosphatase (Salt_tol_Pase)', 391, NULL, 'Salt_tol_Pase', 267530),
(448437, 'PF03106', NULL, 'WRKY DNA -binding domain', 60, NULL, 'WRKY', 267531),
(448438, 'PF00740', NULL, 'Parvovirus coat protein VP2', 542, NULL, 'Parvo_coat', 267532),
(448439, 'PF02002', NULL, 'TFIIE alpha subunit', 105, NULL, 'TFIIE_alpha', 267533),
(448440, 'PF03782', NULL, 'AMOP domain', 142, NULL, 'AMOP', 267534),
(448441, 'PF18532', NULL, 'Domain of unknown function (DUF5621)', 139, NULL, 'DUF5621', 267535),
(448442, 'PF19381', NULL, 'Family of unknown function (DUF5956)', 100, NULL, 'DUF5956', 267536),
(448443, 'PF02540', NULL, 'NAD synthase', 242, NULL, 'NAD_synthase', 267537),
(448444, 'PF09391', NULL, 'Protein of unknown function (DUF2000)', 133, NULL, 'DUF2000', 267538),
(448445, 'PF06897', NULL, 'Protein of unknown function (DUF1269)', 100, NULL, 'DUF1269', 267539),
(448446, 'PF12667', NULL, 'NigD-like N-terminal OB domain', 67, NULL, 'NigD_N', 267540),
(448447, 'PF18757', NULL, 'Nucleotide modification associated domain 5', 207, NULL, 'Nmad5', 267541),
(448448, 'PF20384', NULL, 'Family of unknown function (DUF6679)', 104, NULL, 'DUF6679', 267542),
(448449, 'PF16476', NULL, 'Domain of unknown function (DUF5053)', 59, NULL, 'DUF5053', 267543),
(448450, 'PF16983', NULL, 'Molybdate transporter of MFS superfamily', 111, NULL, 'MFS_MOT1', 267544),
(448451, 'PF01906', NULL, 'Putative heavy-metal-binding', 104, NULL, 'YbjQ_1', 267545),
(448452, 'PF18559', NULL, 'Galactose-binding domain-like', 155, NULL, 'Exop_C', 267546),
(448453, 'PF18571', NULL, 'von Willebrand factor type A C-terminal domain', 47, NULL, 'VWA_3_C', 267547),
(448454, 'PF16404', NULL, 'Domain of unknown function (DUF5012)', 125, NULL, 'DUF5012', 267548),
(448455, 'PF20155', NULL, 'Tape measure protein', 192, NULL, 'TMP_3', 267549),
(448456, 'PF02785', NULL, 'Biotin carboxylase C-terminal domain', 108, NULL, 'Biotin_carb_C', 267550),
(448457, 'PF09316', NULL, 'C-myb, C-terminal', 157, NULL, 'Cmyb_C', 267551),
(448458, 'PF16989', NULL, 'Type VI secretion, EvfE, EvfF, ImpA, BimE, VC_A0119, VasJ', 257, NULL, 'T6SS_VasJ', 267552),
(448459, 'PF09746', NULL, 'Tumour-associated protein', 389, NULL, 'Membralin', 267553),
(448460, 'PF15446', NULL, 'PHD/FYVE-zinc-finger like domain', 169, NULL, 'zf-PHD-like', 267554);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(448461, 'PF10634', NULL, 'Fe2+ transport protein', 150, NULL, 'Iron_transport', 267555),
(448462, 'PF15823', NULL, 'UPF0524 of C3orf70', 239, NULL, 'UPF0524', 267556),
(448463, 'PF02662', NULL, 'Methyl-viologen-reducing hydrogenase, delta subunit', 123, NULL, 'FlpD', 267557),
(448464, 'PF01895', NULL, 'PhoU domain', 89, NULL, 'PhoU', 267558),
(448465, 'PF19920', NULL, 'MoxR-vWA-beta-propeller ternary system domain bpX4', 202, NULL, 'bpX4', 267559),
(448466, 'PF16832', NULL, 'Erythroid krueppel-like transcription factor, transactivation 1', 27, NULL, 'EKLF_TAD1', 267560),
(448467, 'PF11406', NULL, 'Antimicrobial peptide tachystatin A', 44, NULL, 'Tachystatin_A', 267561),
(448468, 'PF15170', NULL, 'Calcium/calmodulin-dependent protein kinase II inhibitor', 79, NULL, 'CaM-KIIN', 267562),
(448469, 'PF06121', NULL, 'Domain of Unknown Function (DUF959)', 188, NULL, 'DUF959', 267563),
(448470, 'PF09312', NULL, 'SurA N-terminal domain', 118, NULL, 'SurA_N', 267564),
(448471, 'PF19643', NULL, 'Family of unknown function (DUF6146)', 133, NULL, 'DUF6146', 267565),
(448472, 'PF18050', NULL, 'Cyclophilin-like family', 115, NULL, 'Cyclophil_like2', 267566),
(448473, 'PF19008', NULL, 'Family of unknown function (DUF5737)', 99, NULL, 'DUF5737', 267567),
(448474, 'PF16452', NULL, 'Bacteriophage CI repressor C-terminal domain', 102, NULL, 'Phage_CI_C', 267568),
(448475, 'PF07303', NULL, 'Occludin homology domain', 101, NULL, 'Occludin_ELL', 267569),
(448476, 'PF16454', NULL, 'Phosphatidylinositol 3-kinase regulatory subunit P85 inter-SH2 domain', 161, NULL, 'PI3K_P85_iSH2', 267570),
(448477, 'PF10570', NULL, 'Myelin-PO cytoplasmic C-term p65 binding region', 65, NULL, 'Myelin-PO_C', 267571),
(448478, 'PF07011', NULL, 'Early Flowering 4 domain', 83, NULL, 'Elf4', 267572),
(448479, 'PF00089', NULL, 'Trypsin', 221, NULL, 'Trypsin', 267573),
(448480, 'PF18706', NULL, 'D-ribitol-5-phosphate cytidylyltransferase C-terminal domain', 169, NULL, 'ISPD_C', 267574),
(448481, 'PF02434', NULL, 'Fringe-like', 252, NULL, 'Fringe', 267575),
(448482, 'PF08149', NULL, 'BING4CT (NUC141) domain', 79, NULL, 'BING4CT', 267576),
(448483, 'PF05920', NULL, 'Homeobox KN domain', 40, NULL, 'Homeobox_KN', 267577),
(448484, 'PF19364', NULL, 'Family of unknown function (DUF5940)', 166, NULL, 'DUF5940', 267578),
(448485, 'PF20168', NULL, 'Sister chromatid cohesion protein PDS5 protein', 1055, NULL, 'PDS5', 267579),
(448486, 'PF18169', NULL, 'SMODS and SLOG-associating 2TM effector domain 6', 176, NULL, 'SLATT_6', 267580),
(448487, 'PF01017', NULL, 'STAT protein, all-alpha domain', 169, NULL, 'STAT_alpha', 267581),
(448488, 'PF03370', NULL, 'Carbohydrate/starch-binding module (family 21)', 113, NULL, 'CBM_21', 267582),
(448489, 'PF03626', NULL, 'Prokaryotic Cytochrome C oxidase subunit IV', 72, NULL, 'COX4_pro', 267583),
(448490, 'PF15428', NULL, 'Immunity protein 26', 106, NULL, 'Imm26', 267584),
(448491, 'PF01730', NULL, 'UreF', 133, NULL, 'UreF', 267585),
(448492, 'PF12100', NULL, 'Domain of unknown function (DUF3576)', 101, NULL, 'DUF3576', 267586),
(448493, 'PF09337', NULL, 'H2C2 zinc finger', 39, NULL, 'zf-H2C2', 267587),
(448494, 'PF11612', NULL, 'Type II secretion system (T2SS), protein J', 140, NULL, 'T2SSJ', 267588),
(448495, 'PF01608', NULL, 'I/LWEQ domain', 152, NULL, 'I_LWEQ', 267589),
(448496, 'PF09023', NULL, 'Staphostatin B', 105, NULL, 'Staphostatin_B', 267590),
(448497, 'PF09757', NULL, 'Arb2 domain', 259, NULL, 'Arb2', 267591),
(448498, 'PF19318', NULL, 'Family of unknown function (DUF5918)', 211, NULL, 'DUF5918', 267592),
(448499, 'PF18751', NULL, 'P-loop Nucleotide Kinase3', 184, NULL, 'Ploopntkinase3', 267593),
(448500, 'PF06228', NULL, 'Haem utilisation ChuX/HutX', 135, NULL, 'ChuX_HutX', 267594),
(448501, 'PF15536', NULL, 'Bacterial toxin 3', 133, NULL, 'Ntox3', 267595),
(448502, 'PF16290', NULL, 'Domain of unknown function (DUF4936)', 91, NULL, 'DUF4936', 267596),
(448503, 'PF03476', NULL, 'MOSC N-terminal beta barrel domain', 120, NULL, 'MOSC_N', 267597),
(448504, 'PF19585', NULL, 'Family of unknown function (DUF6092)', 86, NULL, 'DUF6092', 267598);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(448505, 'PF12985', NULL, 'Domain of unknown function (DUF3869)', 104, NULL, 'DUF3869', 267599),
(448506, 'PF07400', NULL, 'Interleukin 11', 170, NULL, 'IL11', 267600),
(448507, 'PF17056', NULL, 'Killer toxin-resistance protein 1', 66, NULL, 'KRE1', 267601),
(448508, 'PF18525', NULL, 'Cas9 C-terminal domain', 110, NULL, 'Cas9_C', 267602),
(448509, 'PF13732', NULL, 'Domain of unknown function (DUF4162)', 81, NULL, 'DUF4162', 267603),
(448510, 'PF14113', NULL, 'Type VI secretion system (T6SS), amidase effector protein 4', 121, NULL, 'Tae4', 267604),
(448511, 'PF14191', NULL, 'YodL-like', 100, NULL, 'YodL', 267605),
(448512, 'PF07925', NULL, 'Reovirus RNA-dependent RNA polymerase lambda 3', 1271, NULL, 'RdRP_5', 267606),
(448513, 'PF03140', NULL, 'Plant protein of unknown function', 404, NULL, 'DUF247', 267607),
(448514, 'PF12275', NULL, 'Protein of unknown function (DUF3616)', 327, NULL, 'DUF3616', 267608),
(448515, 'PF08951', NULL, 'Enterocin A Immunity', 73, NULL, 'EntA_Immun', 267609),
(448516, 'PF04621', NULL, 'PEA3 subfamily ETS-domain transcription factor N terminal domain', 348, NULL, 'ETS_PEA3_N', 267610),
(448517, 'PF15147', NULL, 'Domain of unknown function (DUF4578)', 126, NULL, 'DUF4578', 267611),
(448518, 'PF05046', NULL, 'Mitochondrial large subunit ribosomal protein (Img2)', 86, NULL, 'Img2', 267612),
(448519, 'PF13350', NULL, 'Tyrosine phosphatase family', 234, NULL, 'Y_phosphatase3', 267613),
(448520, 'PF08564', NULL, 'Cdc37 C terminal domain', 100, NULL, 'CDC37_C', 267614),
(448521, 'PF12304', NULL, 'Beta-casein like protein', 184, NULL, 'BCLP', 267615),
(448522, 'PF13104', NULL, 'Protein of unknown function (DUF3956)', 45, NULL, 'DUF3956', 267616),
(448523, 'PF02185', NULL, 'Hr1 repeat', 69, NULL, 'HR1', 267617),
(448524, 'PF16704', NULL, 'Rab binding domain', 66, NULL, 'Rab_bind', 267618),
(448525, 'PF16184', NULL, 'Cadherin-like', 111, NULL, 'Cadherin_3', 267619),
(448526, 'PF02137', NULL, 'Adenosine-deaminase (editase) domain', 327, NULL, 'A_deamin', 267620),
(448527, 'PF02214', NULL, 'BTB/POZ domain', 94, NULL, 'BTB_2', 267621),
(448528, 'PF08403', NULL, 'Amino acid permease N-terminal', 70, NULL, 'AA_permease_N', 267622),
(448529, 'PF06808', NULL, 'Tripartite ATP-independent periplasmic transporter, DctM component', 416, NULL, 'DctM', 267623),
(448530, 'PF02576', NULL, 'RimP N-terminal domain', 73, NULL, 'RimP_N', 267624),
(448531, 'PF14251', NULL, 'Domain of unknown function (DUF4346)', 118, NULL, 'DUF4346', 267625),
(448532, 'PF12969', NULL, 'Domain of Unknown Function with PDB structure (DUF3857)', 166, NULL, 'DUF3857', 267626),
(448533, 'PF20200', NULL, 'Family of unknown function (DUF6562)', 302, NULL, 'DUF6562', 267627),
(448534, 'PF13850', NULL, 'Endoplasmic Reticulum-Golgi Intermediate Compartment (ERGIC)', 91, NULL, 'ERGIC_N', 267628),
(448535, 'PF16201', NULL, 'Nucleolar pre-ribosomal-associated protein 1', 201, NULL, 'NopRA1', 267629),
(448536, 'PF05409', NULL, 'Coronavirus endopeptidase C30', 288, NULL, 'Peptidase_C30', 267630),
(448537, 'PF06529', NULL, 'Vertebrate interleukin-3 regulated transcription factor', 332, NULL, 'Vert_IL3-reg_TF', 267631),
(448538, 'PF13234', NULL, 'rRNA-processing arch domain', 270, NULL, 'rRNA_proc-arch', 267632),
(448539, 'PF02294', NULL, '7kD DNA-binding domain', 58, NULL, '7kD_DNA_binding', 267633),
(448540, 'PF15748', NULL, 'Centriole, cilia and spindle-associated', 260, NULL, 'CCSAP', 267634),
(448541, 'PF12253', NULL, 'Chromatin assembly factor 1 subunit A', 75, NULL, 'CAF1A', 267635),
(448542, 'PF13997', NULL, 'YqjK-like protein', 73, NULL, 'YqjK', 267636),
(448543, 'PF04830', NULL, 'Possible hemagglutinin (DUF637)', 168, NULL, 'DUF637', 267637),
(448544, 'PF15851', NULL, 'Domain of unknown function (DUF4723)', 82, NULL, 'DUF4723', 267638),
(448545, 'PF04639', NULL, 'Baculoviral E56 protein, specific to ODV envelope', 293, NULL, 'Baculo_E56', 267639),
(448546, 'PF14403', NULL, 'Circularly permuted ATP-grasp type 2', 375, NULL, 'CP_ATPgrasp_2', 267640),
(448547, 'PF15600', NULL, 'Immunity protein 64', 207, NULL, 'Imm64', 267641);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(448548, 'PF16240', NULL, 'Domain of unknown function (DUF4899)', 283, NULL, 'DUF4899', 267642),
(448549, 'PF15972', NULL, 'Unpaired protein', 273, NULL, 'Unpaired', 267643),
(448550, 'PF05849', NULL, 'Fibroin light chain (L-fibroin)', 239, NULL, 'L-fibroin', 267644),
(448551, 'PF11343', NULL, 'Protein of unknown function (DUF3145)', 156, NULL, 'DUF3145', 267645),
(448552, 'PF19629', NULL, 'Family of unknown function (DUF6133)', 63, NULL, 'DUF6133', 267646),
(448553, 'PF05823', NULL, 'Nematode fatty acid retinoid binding protein (Gp-FAR-1)', 149, NULL, 'Gp-FAR-1', 267647),
(448554, 'PF17675', NULL, 'Apg6 coiled-coil region', 132, NULL, 'APG6_N', 267648),
(448555, 'PF14364', NULL, 'Domain of unknown function (DUF4408)', 33, NULL, 'DUF4408', 267649),
(448556, 'PF17301', NULL, 'Putative lipoprotein LpqV', 114, NULL, 'LpqV', 267650),
(448557, 'PF12410', NULL, 'Poxvirus DNA dependent RNA polymerase 30kDa subunit', 135, NULL, 'rpo30_N', 267651),
(448558, 'PF19279', NULL, 'YegS C-terminal NAD kinase beta sandwich-like domain', 158, NULL, 'YegS_C', 267652),
(448559, 'PF11544', NULL, 'Spindle pole body component Spc42p', 75, NULL, 'Spc42p', 267653),
(448560, 'PF01055', NULL, 'Glycosyl hydrolases family 31', 444, NULL, 'Glyco_hydro_31', 267654),
(448561, 'PF05236', NULL, 'Transcription initiation factor TFIID component TAF4 family', 273, NULL, 'TAF4', 267655),
(448562, 'PF10057', NULL, 'Na+-translocating membrane potential-generating system (MpsC)', 111, NULL, 'MpsC', 267656),
(448563, 'PF01517', NULL, 'Hepatitis delta virus delta antigen', 179, NULL, 'HDV_ag', 267657),
(448564, 'PF10608', NULL, 'Polyubiquitination (PEST) N-terminal domain of MAGUK', 88, NULL, 'MAGUK_N_PEST', 267658),
(448565, 'PF02055', NULL, 'Glycosyl hydrolase family 30 TIM-barrel domain', 348, NULL, 'Glyco_hydro_30', 267659),
(448566, 'PF00848', NULL, 'Ring hydroxylating alpha subunit (catalytic domain)', 214, NULL, 'Ring_hydroxyl_A', 267660),
(448567, 'PF01233', NULL, 'Myristoyl-CoA:protein N-myristoyltransferase, N-terminal domain', 160, NULL, 'NMT', 267661),
(448568, 'PF05741', NULL, 'Nanos RNA binding domain', 54, NULL, 'zf-nanos', 267662),
(448569, 'PF10330', NULL, 'Putative Sin3 binding protein', 93, NULL, 'Stb3', 267663),
(448570, 'PF10662', NULL, 'Ethanolamine utilisation - propanediol utilisation', 143, NULL, 'PduV-EutP', 267664),
(448571, 'PF13382', NULL, 'Adenine deaminase C-terminal domain', 169, NULL, 'Adenine_deam_C', 267665),
(448572, 'PF18528', NULL, 'RNA editing 3'' terminal uridylyl transferase 2 middle domain', 93, NULL, 'Ret2_MD', 267666),
(448573, 'PF20385', NULL, 'Family of unknown function (DUF6680)', 170, NULL, 'DUF6680', 267667),
(448574, 'PF09358', NULL, 'Ubiquitin fold domain', 93, NULL, 'E1_UFD', 267668),
(448575, 'PF20055', NULL, 'Family of unknown function (DUF6454)', 292, NULL, 'DUF6454', 267669),
(448576, 'PF06382', NULL, 'Protamine and protamine like', 146, NULL, 'Protamine_like', 267670),
(448577, 'PF18309', NULL, 'Argonaute PAZ domain', 87, NULL, 'PAZ_3', 267671),
(448578, 'PF20622', NULL, 'Bacterial Ig domain (Big_16)', 81, NULL, 'Big_15', 267672),
(448579, 'PF04530', NULL, 'Viral Beta C/D like family', 123, NULL, 'Viral_Beta_CD', 267673),
(448580, 'PF15159', NULL, 'Phosphatidylinositol N-acetylglucosaminyltransferase subunit Y', 70, NULL, 'PIG-Y', 267674),
(448581, 'PF03657', NULL, 'UPF0113 PUA domain', 73, NULL, 'UPF0113', 267675),
(448582, 'PF20176', NULL, 'Family of unknown function (DUF6541)', 648, NULL, 'DUF6541', 267676),
(448583, 'PF12605', NULL, 'Casein kinase 1 gamma C terminal', 99, NULL, 'CK1gamma_C', 267677),
(448584, 'PF14179', NULL, 'YppG-like protein', 105, NULL, 'YppG', 267678),
(448585, 'PF15454', NULL, 'Late endosomal/lysosomal adaptor and MAPK and MTOR activator', 75, NULL, 'LAMTOR', 267679),
(448586, 'PF12245', NULL, 'Bacterial Ig-like domain', 125, NULL, 'Big_3_2', 267680),
(448587, 'PF00605', NULL, 'Interferon regulatory factor transcription factor', 106, NULL, 'IRF', 267681),
(448588, 'PF00196', NULL, 'Bacterial regulatory proteins, luxR family', 57, NULL, 'GerE', 267682);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(448589, 'PF01757', NULL, 'Acyltransferase family', 340, NULL, 'Acyl_transf_3', 267683),
(448590, 'PF12170', NULL, 'DNA polymerase III tau subunit V interacting with alpha', 142, NULL, 'DNA_pol3_tau_5', 267684),
(448591, 'PF19254', NULL, 'Family of unknown function (DUF5901)', 48, NULL, 'DUF5901', 267685),
(448592, 'PF01501', NULL, 'Glycosyl transferase family 8', 256, NULL, 'Glyco_transf_8', 267686),
(448593, 'PF06125', NULL, 'Bacterial protein of unknown function (DUF961)', 101, NULL, 'DUF961', 267687),
(448594, 'PF14849', NULL, 'YidC periplasmic domain', 283, NULL, 'YidC_periplas', 267688),
(448595, 'PF11261', NULL, 'Interferon regulatory factor 2-binding protein zinc finger', 52, NULL, 'IRF-2BP1_2', 267689),
(448596, 'PF01135', NULL, 'Protein-L-isoaspartate(D-aspartate) O-methyltransferase (PCMT)', 210, NULL, 'PCMT', 267690),
(448597, 'PF20083', NULL, 'Family of unknown function (DUF6477)', 97, NULL, 'DUF6477', 267691),
(448598, 'PF02187', NULL, 'Growth-Arrest-Specific Protein 2 Domain', 69, NULL, 'GAS2', 267692),
(448599, 'PF00736', NULL, 'EF-1 guanine nucleotide exchange domain', 90, NULL, 'EF1_GNE', 267693),
(448600, 'PF16189', NULL, 'Creatinase/Prolidase N-terminal domain', 161, NULL, 'Creatinase_N_2', 267694),
(448601, 'PF16191', NULL, 'Ubiquitin-activating enzyme E1 four-helix bundle', 71, NULL, 'E1_4HB', 267695),
(448602, 'PF14512', NULL, 'Putative TM nitroreductase', 215, NULL, 'TM1586_NiRdase', 267696),
(448603, 'PF07780', NULL, 'Spb1 C-terminal domain', 219, NULL, 'Spb1_C', 267697),
(448604, 'PF00689', NULL, 'Cation transporting ATPase, C-terminus', 182, NULL, 'Cation_ATPase_C', 267698),
(448605, 'PF09360', NULL, 'Iron-binding zinc finger CDGSH type', 48, NULL, 'zf-CDGSH', 267699),
(448606, 'PF10437', NULL, 'Bacterial lipoate protein ligase C-terminus', 85, NULL, 'Lip_prot_lig_C', 267700),
(448607, 'PF03777', NULL, 'ChpA-C', 57, NULL, 'ChpA-C', 267701),
(448608, 'PF04338', NULL, 'Protein of unknown function, DUF481', 211, NULL, 'DUF481', 267702),
(448609, 'PF18396', NULL, 'TANK binding kinase 1 ubiquitin-like domain', 88, NULL, 'TBK1_ULD', 267703),
(448610, 'PF07843', NULL, 'Protein of unknown function (DUF1634)', 102, NULL, 'DUF1634', 267704),
(448611, 'PF12729', NULL, 'Four helix bundle sensory module for signal transduction', 181, NULL, '4HB_MCP_1', 267705),
(448612, 'PF13653', NULL, 'Glycerophosphoryl diester phosphodiesterase family', 30, NULL, 'GDPD_2', 267706),
(448613, 'PF11477', NULL, 'Sialyltransferase PMO188', 385, NULL, 'PM0188', 267707),
(448614, 'PF12117', NULL, 'Parvovirus non-structural protein 1, C-terminal', 121, NULL, 'NS1_C', 267708),
(448615, 'PF07803', NULL, 'GSG1-like protein', 114, NULL, 'GSG-1', 267709),
(448616, 'PF08427', NULL, 'Armadillo-like helical domain-containing protein 3, C-terminal', 231, NULL, 'ARMH3_C', 267710),
(448617, 'PF12469', NULL, 'CRISPR-associated protein Cmr2, N-terminal', 111, NULL, 'Cmr2_N', 267711),
(448618, 'PF18835', NULL, 'Beta helix repeat of Inulin fructotransferase', 68, NULL, 'Beta_helix_2', 267712),
(448619, 'PF20487', NULL, 'Family of unknown function (DUF6726)', 58, NULL, 'DUF6726', 267713),
(448620, 'PF01125', NULL, 'G10 protein', 146, NULL, 'G10', 267714),
(448621, 'PF17266', NULL, 'Family of unknown function (DUF5332)', 150, NULL, 'DUF5332', 267715),
(448622, 'PF18918', NULL, 'Family of unknown function (DUF5669)', 76, NULL, 'DUF5669', 267716),
(448623, 'PF09692', NULL, 'Argonaute siRNA chaperone (ARC) complex subunit Arb1', 402, NULL, 'Arb1', 267717),
(448624, 'PF16549', NULL, 'Type II secretion system (T2SS) pilotin, S protein', 104, NULL, 'T2SSS_2', 267718),
(448625, 'PF07743', NULL, 'HSCB C-terminal oligomerisation domain', 75, NULL, 'HSCB_C', 267719),
(448626, 'PF13747', NULL, 'Domain of unknown function (DUF4164)', 89, NULL, 'DUF4164', 267720),
(448627, 'PF18263', NULL, 'MCM6 C-terminal winged-helix domain', 108, NULL, 'MCM6_C', 267721),
(448628, 'PF04772', NULL, 'Influenza B matrix protein 2 (BM2)', 109, NULL, 'Flu_B_M2', 267722),
(448629, 'PF10882', NULL, 'Bacterial PH domain', 100, NULL, 'bPH_5', 267723);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(448630, 'PF19902', NULL, 'Family of unknown function (DUF6375)', 134, NULL, 'DUF6375', 267724),
(448631, 'PF00625', NULL, 'Guanylate kinase', 182, NULL, 'Guanylate_kin', 267725),
(448632, 'PF14409', NULL, 'Ribosomally synthesized peptide in Herpetosiphon', 56, NULL, 'Herpeto_peptide', 267726),
(448633, 'PF06693', NULL, 'Protein of unknown function (DUF1190)', 163, NULL, 'DUF1190', 267727),
(448634, 'PF11696', NULL, 'Protein of unknown function (DUF3292)', 650, NULL, 'DUF3292', 267728),
(448635, 'PF10718', NULL, 'Hypothetical chloroplast protein Ycf34', 77, NULL, 'Ycf34', 267729),
(448636, 'PF14256', NULL, 'YwiC-like protein', 126, NULL, 'YwiC', 267730),
(448637, 'PF07488', NULL, 'Glycosyl hydrolase family 67 middle domain', 325, NULL, 'Glyco_hydro_67M', 267731),
(448638, 'PF19545', NULL, 'Family of unknown function (DUF6069)', 130, NULL, 'DUF6069', 267732),
(448639, 'PF20159', NULL, 'YidB-like protein', 143, NULL, 'YidB', 267733),
(448640, 'PF12549', NULL, 'Tyrosine hydroxylase N terminal', 25, NULL, 'TOH_N', 267734),
(448641, 'PF20388', NULL, 'Family of unknown function (DUF6683)', 253, NULL, 'DUF6683', 267735),
(448642, 'PF09865', NULL, 'Predicted periplasmic protein (DUF2092)', 212, NULL, 'DUF2092', 267736),
(448643, 'PF12648', NULL, 'TcpE family', 100, NULL, 'TcpE', 267737),
(448644, 'PF19176', NULL, 'Family of unknown function (DUF5858)', 61, NULL, 'DUF5858', 267738),
(448645, 'PF08842', NULL, 'Fimbrillin-A associated anchor proteins Mfa1 and Mfa2', 281, NULL, 'Mfa2', 267739),
(448646, 'PF10140', NULL, 'WXG100 protein secretion system (Wss), protein YukC', 357, NULL, 'YukC', 267740),
(448647, 'PF01390', NULL, 'SEA domain', 106, NULL, 'SEA', 267741),
(448648, 'PF10340', NULL, 'Steryl acetyl hydrolase', 374, NULL, 'Say1_Mug180', 267742),
(448649, 'PF10465', NULL, 'PinA peptidase inhibitor', 140, NULL, 'Inhibitor_I24', 267743),
(448650, 'PF19193', NULL, 'Tectonin domain', 214, NULL, 'Tectonin', 267744),
(448651, 'PF06245', NULL, 'Protein of unknown function (DUF1015)', 310, NULL, 'DUF1015', 267745),
(448652, 'PF15261', NULL, 'Jhy protein', 128, NULL, 'JHY', 267746),
(448653, 'PF16909', NULL, 'Vacuolar-sorting-associated 13 protein C-terminal', 176, NULL, 'VPS13_C', 267747),
(448654, 'PF15531', NULL, 'Bacterial toxin 27', 130, NULL, 'Ntox27', 267748),
(448655, 'PF10825', NULL, 'Protein of unknown function (DUF2752)', 49, NULL, 'DUF2752', 267749),
(448656, 'PF14726', NULL, 'Rotatin, an armadillo repeat protein, centriole functioning', 97, NULL, 'RTTN_N', 267750),
(448657, 'PF02781', NULL, 'Glucose-6-phosphate dehydrogenase, C-terminal domain', 296, NULL, 'G6PD_C', 267751),
(448658, 'PF02284', NULL, 'Cytochrome c oxidase subunit Va', 103, NULL, 'COX5A', 267752),
(448659, 'PF13310', NULL, 'Virulence protein RhuM family', 252, NULL, 'Virulence_RhuM', 267753),
(448660, 'PF18291', NULL, 'HU domain fused to wHTH, Ig, or Glycine-rich motif', 125, NULL, 'HU-HIG', 267754),
(448661, 'PF13498', NULL, 'Domain of unknown function (DUF4122)', 219, NULL, 'DUF4122', 267755),
(448662, 'PF20262', NULL, 'Protein UNC80 C-terminal region', 1079, NULL, 'UNC80_C', 267756),
(448663, 'PF14949', NULL, 'ARF7 effector protein C-terminus', 103, NULL, 'ARF7EP_C', 267757),
(448664, 'PF16469', NULL, 'Nematode polyprotein allergen ABA-1', 122, NULL, 'NPA', 267758),
(448665, 'PF00656', NULL, 'Caspase domain', 206, NULL, 'Peptidase_C14', 267759),
(448666, 'PF03446', NULL, 'NAD binding domain of 6-phosphogluconate dehydrogenase', 158, NULL, 'NAD_binding_2', 267760),
(448667, 'PF15648', NULL, 'Restriction endonuclease fold toxin 5', 95, NULL, 'Tox-REase-5', 267761),
(448668, 'PF15520', NULL, 'Novel toxin 10', 193, NULL, 'Ntox10', 267762),
(448669, 'PF08569', NULL, 'Mo25-like', 332, NULL, 'Mo25', 267763),
(448670, 'PF13002', NULL, 'Arrestin_N terminal like', 193, NULL, 'LDB19', 267764),
(448671, 'PF01744', NULL, 'GLTT repeat (6 copies)', 28, NULL, 'GLTT', 267765),
(448672, 'PF00499', NULL, 'NADH-ubiquinone/plastoquinone oxidoreductase chain 6', 144, NULL, 'Oxidored_q3', 267766),
(448673, 'PF16656', NULL, 'Purple acid Phosphatase, N-terminal domain', 94, NULL, 'Pur_ac_phosph_N', 267767);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(448674, 'PF10860', NULL, 'Protein of unknown function (DUF2661)', 113, NULL, 'DUF2661', 267768),
(448675, 'PF03839', NULL, 'Translocation protein Sec62', 192, NULL, 'Sec62', 267769),
(448676, 'PF19576', NULL, 'Acyltransferase', 266, NULL, 'Acyltransf_2', 267770),
(448677, 'PF17040', NULL, 'Cellulose-complementing protein A', 119, NULL, 'CBP_CCPA', 267771),
(448678, 'PF15581', NULL, 'Immunity protein 58', 109, NULL, 'Imm58', 267772),
(448679, 'PF03412', NULL, 'Peptidase C39 family', 133, NULL, 'Peptidase_C39', 267773),
(448680, 'PF10982', NULL, 'Protein of unknown function (DUF2789)', 75, NULL, 'DUF2789', 267774),
(448681, 'PF13457', NULL, 'GW (Gly-Tryp) dipeptide domain', 76, NULL, 'GW', 267775),
(448682, 'PF10642', NULL, 'Mitochondrial import receptor subunit or translocase', 46, NULL, 'Tom5', 267776),
(448683, 'PF06869', NULL, 'Protein of unknown function (DUF1258)', 253, NULL, 'DUF1258', 267777),
(448684, 'PF07390', NULL, 'Mycoplasma P30 protein', 150, NULL, 'P30', 267778),
(448685, 'PF11138', NULL, 'Protein of unknown function (DUF2911)', 145, NULL, 'DUF2911', 267779),
(448686, 'PF14047', NULL, 'Dppa2/4 conserved region', 67, NULL, 'DCR', 267780),
(448687, 'PF09450', NULL, 'Domain of unknown function (DUF2019)', 105, NULL, 'DUF2019', 267781),
(448688, 'PF19434', NULL, 'Dynamin-like GTPase OPA1 C-terminal', 345, NULL, 'OPA1_C', 267782),
(448689, 'PF15993', NULL, 'Fuseless', 299, NULL, 'Fuseless', 267783),
(448690, 'PF18553', NULL, 'PheRS DNA binding domain 3', 60, NULL, 'PheRS_DBD3', 267784),
(448691, 'PF01493', NULL, 'GXGXG motif', 190, NULL, 'GXGXG', 267785),
(448692, 'PF16765', NULL, 'Pesticin immunity protein', 91, NULL, 'Pim', 267786),
(448693, 'PF01264', NULL, 'Chorismate synthase', 328, NULL, 'Chorismate_synt', 267787),
(448694, 'PF17471', NULL, 'Gene product 63', 73, NULL, 'GP63', 267788),
(448695, 'PF04203', NULL, 'Sortase domain', 125, NULL, 'Sortase', 267789),
(448696, 'PF03101', NULL, 'FAR1 DNA-binding domain', 90, NULL, 'FAR1', 267790),
(448697, 'PF06758', NULL, 'Olduvai domain', 68, NULL, 'Olduvai', 267791),
(448698, 'PF12394', NULL, 'Protein FAM135', 68, NULL, 'DUF3657', 267792),
(448699, 'PF02646', NULL, 'RmuC family', 292, NULL, 'RmuC', 267793),
(448700, 'PF13770', NULL, 'Domain of unknown function (DUF4169)', 55, NULL, 'DUF4169', 267794),
(448701, 'PF03262', NULL, 'Coronavirus 6B/7B protein', 206, NULL, 'Corona_6B_7B', 267795),
(448702, 'PF06600', NULL, 'Protein of unknown function (DUF1140)', 99, NULL, 'DUF1140', 267796),
(448703, 'PF13441', NULL, 'YMGG-like Gly-zipper', 46, NULL, 'Gly-zipper_YMGG', 267797),
(448704, 'PF00775', NULL, 'Dioxygenase', 182, NULL, 'Dioxygenase_C', 267798),
(448705, 'PF20143', NULL, 'ATP-NAD kinase C-terminal domain', 126, NULL, 'NAD_kinase_C', 267799),
(448706, 'PF12328', NULL, 'Rpp20 subunit of nuclear RNase MRP and P', 137, NULL, 'Rpp20', 267800),
(448707, 'PF15257', NULL, 'Domain of unknown function (DUF4590)', 114, NULL, 'DUF4590', 267801),
(448708, 'PF01729', NULL, 'Quinolinate phosphoribosyl transferase, C-terminal domain', 169, NULL, 'QRPTase_C', 267802),
(448709, 'PF00273', NULL, 'Serum albumin family', 176, NULL, 'Serum_albumin', 267803),
(448710, 'PF18174', NULL, 'CCDC81-like prokaryotic HU domain 1', 59, NULL, 'HU-CCDC81_bac_1', 267804),
(448711, 'PF01844', NULL, 'HNH endonuclease', 47, NULL, 'HNH', 267805),
(448712, 'PF00236', NULL, 'Glycoprotein hormone', 96, NULL, 'Hormone_6', 267806),
(448713, 'PF09138', NULL, 'Urm1 (Ubiquitin related modifier)', 96, NULL, 'Urm1', 267807),
(448714, 'PF00151', NULL, 'Lipase', 336, NULL, 'Lipase', 267808),
(448715, 'PF17518', NULL, 'Family of unknown function (DUF5443)', 344, NULL, 'DUF5443', 267809),
(448716, 'PF08568', NULL, 'Uncharacterised protein family, YAP/Alf4/glomulin', 633, NULL, 'Kinetochor_Ybp2', 267810),
(448717, 'PF00411', NULL, 'Ribosomal protein S11', 110, NULL, 'Ribosomal_S11', 267811),
(448718, 'PF00514', NULL, 'Armadillo/beta-catenin-like repeat', 41, NULL, 'Arm', 267812),
(448719, 'PF07704', NULL, 'Rv0623-like transcription factor', 82, NULL, 'PSK_trans_fac', 267813),
(448720, 'PF11403', NULL, 'Yeast metallothionein', 39, NULL, 'Yeast_MT', 267814);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(448721, 'PF17340', NULL, 'Family of unknown function (DUF5370)', 63, NULL, 'DUF5370', 267815),
(448722, 'PF14626', NULL, 'Zc3h12a-like Ribonuclease NYN domain', 122, NULL, 'RNase_Zc3h12a_2', 267816),
(448723, 'PF00970', NULL, 'Oxidoreductase FAD-binding domain', 99, NULL, 'FAD_binding_6', 267817),
(448724, 'PF13396', NULL, 'Phospholipase_D-nuclease N-terminal', 42, NULL, 'PLDc_N', 267818),
(448725, 'PF00267', NULL, 'Gram-negative porin', 340, NULL, 'Porin_1', 267819),
(448726, 'PF04575', NULL, 'Surface lipoprotein assembly modifier', 288, NULL, 'SlipAM', 267820),
(448727, 'PF12764', NULL, 'Glycine-rich region of argonaut', 107, NULL, 'Gly-rich_Ago1', 267821),
(448728, 'PF08806', NULL, 'Sep15/SelM redox domain', 75, NULL, 'Sep15_SelM', 267822),
(448729, 'PF08861', NULL, 'Domain of unknown function DUF1828', 90, NULL, 'DUF1828', 267823),
(448730, 'PF14084', NULL, 'Protein of unknown function (DUF4264)', 52, NULL, 'DUF4264', 267824),
(448731, 'PF15033', NULL, 'Kinocilin protein', 123, NULL, 'Kinocilin', 267825),
(448732, 'PF05656', NULL, 'Protein of unknown function (DUF805)', 105, NULL, 'DUF805', 267826),
(448733, 'PF14446', NULL, 'Prokaryotic RING finger family 1', 54, NULL, 'Prok-RING_1', 267827),
(448734, 'PF01606', NULL, 'Arterivirus envelope protein', 214, NULL, 'Arteri_env', 267828),
(448735, 'PF03629', NULL, 'Carbohydrate esterase, sialic acid-specific acetylesterase', 226, NULL, 'SASA', 267829),
(448736, 'PF06070', NULL, 'Herpesvirus large structural phosphoprotein UL32', 1048, NULL, 'Herpes_UL32', 267830),
(448737, 'PF14883', NULL, 'Hypothetical glycosyl hydrolase family 13', 325, NULL, 'GHL13', 267831),
(448738, 'PF04767', NULL, 'DNA-binding 11 kDa phosphoprotein', 94, NULL, 'Pox_F17', 267832),
(448739, 'PF00264', NULL, 'Common central domain of tyrosinase', 222, NULL, 'Tyrosinase', 267833),
(448740, 'PF01840', NULL, 'TCL1/MTCP1 family', 116, NULL, 'TCL1_MTCP1', 267834),
(448741, 'PF06615', NULL, 'Circovirus 2, Orf1', 59, NULL, 'Circovir2_Orf1', 267835),
(448742, 'PF00419', NULL, 'Fimbrial protein', 155, NULL, 'Fimbrial', 267836),
(448743, 'PF13743', NULL, 'Thioredoxin', 186, NULL, 'Thioredoxin_5', 267837),
(448744, 'PF16285', NULL, 'Domain of unknown function (DUF4931)', 245, NULL, 'DUF4931', 267838),
(448745, 'PF08179', NULL, 'Small acid-soluble spore protein P family', 44, NULL, 'SspP', 267839),
(448746, 'PF14533', NULL, 'Ubiquitin-specific protease C-terminal', 209, NULL, 'USP7_C2', 267840),
(448747, 'PF16993', NULL, 'Accessory Sec system protein Asp1', 522, NULL, 'Asp1', 267841),
(448748, 'PF17498', NULL, 'Family of unknown function (DUF5433)', 67, NULL, 'DUF5433', 267842),
(448749, 'PF05892', NULL, 'Trichovirus coat protein', 197, NULL, 'Tricho_coat', 267843),
(448750, 'PF01910', NULL, 'Thiamine-binding protein', 92, NULL, 'Thiamine_BP', 267844),
(448751, 'PF12529', NULL, 'Xylosyltransferase C terminal', 182, NULL, 'Xylo_C', 267845),
(448752, 'PF02494', NULL, 'HYR domain', 81, NULL, 'HYR', 267846),
(448753, 'PF12404', NULL, 'Peptidase', 77, NULL, 'DUF3663', 267847),
(448754, 'PF14462', NULL, 'Prokaryotic E2 family E', 123, NULL, 'Prok-E2_E', 267848),
(448755, 'PF08586', NULL, 'RSC complex, Rsc14/Ldb7 subunit', 99, NULL, 'Rsc14', 267849),
(448756, 'PF18867', NULL, 'HEPN-like integron domain', 151, NULL, 'HEPN-like_int', 267850),
(448757, 'PF19466', NULL, 'Family of unknown function (DUF6003)', 140, NULL, 'DUF6003', 267851),
(448758, 'PF15759', NULL, 'TMEM108 family', 514, NULL, 'TMEM108', 267852),
(448759, 'PF20229', NULL, 'Protein ChrB, N-terminal', 159, NULL, 'ChrB_N', 267853),
(448760, 'PF18238', NULL, 'LnmK N-terminal Hot Dog Fold domain', 176, NULL, 'LnmK_N_HDF', 267854),
(448761, 'PF05875', NULL, 'Ceramidase', 258, NULL, 'Ceramidase', 267855),
(448762, 'PF15273', NULL, 'NHS-like', 622, NULL, 'NHS', 267856),
(448763, 'PF12075', NULL, 'KN motif', 39, NULL, 'KN_motif', 267857),
(448764, 'PF02666', NULL, 'Phosphatidylserine decarboxylase', 200, NULL, 'PS_Dcarbxylase', 267858),
(448765, 'PF04617', NULL, 'Hox9 activation region', 184, NULL, 'Hox9_act', 267859),
(448766, 'PF06744', NULL, 'Type VI secretion protein IcmF C2-like domain', 107, NULL, 'IcmF_C', 267860); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(448767, 'PF02552', NULL, 'CO dehydrogenase beta subunit/acetyl-CoA synthase epsilon subunit', 168, NULL, 'CO_dh', 267861),
(448768, 'PF09571', NULL, 'XcyI restriction endonuclease', 305, NULL, 'RE_XcyI', 267862),
(448769, 'PF10086', NULL, 'YhfC intramembrane metalloprotease', 223, NULL, 'YhfC', 267863),
(448770, 'PF11071', NULL, 'Nucleoside 2-deoxyribosyltransferase YtoQ', 140, NULL, 'Nuc_deoxyri_tr3', 267864),
(448771, 'PF00852', NULL, 'Glycosyltransferase family 10 (fucosyltransferase) C-term', 180, NULL, 'Glyco_transf_10', 267865),
(448772, 'PF07107', NULL, 'Wound-induced protein WI12', 109, NULL, 'WI12', 267866),
(448773, 'PF17479', NULL, 'Protein of unknown function (DUF3048) C-terminal domain', 112, NULL, 'DUF3048_C', 267867),
(448774, 'PF00977', NULL, 'Histidine biosynthesis protein', 228, NULL, 'His_biosynth', 267868),
(448775, 'PF10829', NULL, 'Protein of unknown function (DUF2554)', 76, NULL, 'DUF2554', 267869),
(448776, 'PF18860', NULL, 'AbiJ N-terminal domain 3', 167, NULL, 'AbiJ_NTD3', 267870),
(448777, 'PF13598', NULL, 'Domain of unknown function (DUF4139)', 205, NULL, 'DUF4139', 267871),
(448778, 'PF13628', NULL, 'Domain of unknown function (DUF4142)', 139, NULL, 'DUF4142', 267872),
(448779, 'PF14688', NULL, 'Domain of unknown function (DUF4461)', 308, NULL, 'DUF4461', 267873),
(448780, 'PF08061', NULL, 'P68HR (NUC004) repeat', 35, NULL, 'P68HR', 267874),
(448781, 'PF04785', NULL, 'Rhabdovirus matrix protein M2', 202, NULL, 'Rhabdo_M2', 267875),
(448782, 'PF18767', NULL, 'Activation induced deaminase', 90, NULL, 'AID', 267876),
(448783, 'PF01834', NULL, 'XRCC1 N terminal domain', 148, NULL, 'XRCC1_N', 267877),
(448784, 'PF05019', NULL, 'Coenzyme Q (ubiquinone) biosynthesis protein Coq4', 221, NULL, 'Coq4', 267878),
(448785, 'PF17690', NULL, 'Family of unknown function (DUF5537)', 160, NULL, 'DUF5537', 267879),
(448786, 'PF06376', NULL, 'Arabinogalactan peptide', 36, NULL, 'AGP', 267880),
(448787, 'PF15814', NULL, 'Protein family FAM199X', 322, NULL, 'FAM199X', 267881),
(448788, 'PF11974', NULL, 'Bacterial alpha-2-macroglobulin MG3 domain', 103, NULL, 'bMG3', 267882),
(448789, 'PF20583', NULL, 'Family of unknown function (DUF6786)', 376, NULL, 'DUF6786', 267883),
(448790, 'PF09127', NULL, 'Leukotriene A4 hydrolase, C-terminal', 112, NULL, 'Leuk-A4-hydro_C', 267884),
(448791, 'PF15232', NULL, 'Domain of unknown function (DUF4585)', 73, NULL, 'DUF4585', 267885),
(448792, 'PF18153', NULL, 'SMODS-associating 2TM, beta-strand rich effector domain', 180, NULL, 'S_2TMBeta', 267886),
(448793, 'PF03425', NULL, 'Carbohydrate binding domain (family 11)', 180, NULL, 'CBM_11', 267887),
(448794, 'PF06299', NULL, 'Protein of unknown function (DUF1045)', 159, NULL, 'DUF1045', 267888),
(448795, 'PF01725', NULL, 'Ham1 family', 187, NULL, 'Ham1p_like', 267889),
(448796, 'PF16151', NULL, 'Domain of unknown function (DUF4859)', 120, NULL, 'DUF4859', 267890),
(448797, 'PF17840', NULL, 'Tethering Ubl4a to BAGS domain', 47, NULL, 'Tugs', 267891),
(448798, 'PF09721', NULL, 'Transmembrane exosortase (Exosortase_EpsH)', 255, NULL, 'Exosortase_EpsH', 267892),
(448799, 'PF09753', NULL, 'Membrane fusion protein Use1', 245, NULL, 'Use1', 267893),
(448800, 'PF18770', NULL, 'Armadillo tether-repeat of vescicular transport factor', 61, NULL, 'Arm_vescicular', 267894),
(448801, 'PF13985', NULL, 'YbgS-like protein', 120, NULL, 'YbgS', 267895),
(448802, 'PF10049', NULL, 'Protein of unknown function (DUF2283)', 49, NULL, 'DUF2283', 267896),
(448803, 'PF10120', NULL, 'Thiamine-phosphate synthase', 165, NULL, 'ThiP_synth', 267897),
(448804, 'PF16522', NULL, 'Flagellar FLiS export co-chaperone, HP1076', 149, NULL, 'FliS_cochap', 267898),
(448805, 'PF04319', NULL, 'NifZ domain', 73, NULL, 'NifZ', 267899),
(448806, 'PF15825', NULL, 'FAM25 family', 65, NULL, 'FAM25', 267900),
(448807, 'PF09878', NULL, 'Predicted membrane protein (DUF2105)', 200, NULL, 'DUF2105', 267901),
(448808, 'PF02659', NULL, 'Putative manganese efflux pump', 152, NULL, 'Mntp', 267902),
(448809, 'PF13152', NULL, 'Protein of unknown function (DUF3967)', 33, NULL, 'DUF3967', 267903);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(448810, 'PF12620', NULL, 'Protein of unknown function (DUF3778)', 52, NULL, 'DUF3778', 267904),
(448811, 'PF08615', NULL, 'Ribonuclease H2 non-catalytic subunit (Ylr154p-like)', 141, NULL, 'RNase_H2_suC', 267905),
(448812, 'PF05579', NULL, 'Equine arteritis virus serine endopeptidase S32', 297, NULL, 'Peptidase_S32', 267906),
(448813, 'PF12539', NULL, 'Chromosome segregation protein Csm1/Pcs1', 84, NULL, 'Csm1', 267907),
(448814, 'PF04449', NULL, 'CS1 type fimbrial major subunit', 134, NULL, 'Fimbrial_CS1', 267908),
(448815, 'PF07549', NULL, 'SecD/SecF GG Motif', 28, NULL, 'Sec_GG', 267909),
(448816, 'PF08804', NULL, 'gp32 DNA binding protein like', 208, NULL, 'gp32', 267910),
(448817, 'PF01832', NULL, 'Mannosyl-glycoprotein endo-beta-N-acetylglucosaminidase', 86, NULL, 'Glucosaminidase', 267911),
(448818, 'PF00210', NULL, 'Ferritin-like domain', 142, NULL, 'Ferritin', 267912),
(448819, 'PF13428', NULL, 'Tetratricopeptide repeat', 44, NULL, 'TPR_14', 267913),
(448820, 'PF05826', NULL, 'Phospholipase A2', 97, NULL, 'Phospholip_A2_2', 267914),
(448821, 'PF03463', NULL, 'eRF1 domain 1', 129, NULL, 'eRF1_1', 267915),
(448822, 'PF18863', NULL, 'AbiJ N-terminal domain 4', 166, NULL, 'AbiJ_NTD4', 267916),
(448823, 'PF16655', NULL, 'PhoD-like phosphatase, N-terminal domain', 90, NULL, 'PhoD_N', 267917),
(448824, 'PF19101', NULL, 'Family of unknown function (DUF5788)', 131, NULL, 'DUF5788', 267918),
(448825, 'PF12680', NULL, 'SnoaL-like domain', 102, NULL, 'SnoaL_2', 267919),
(448826, 'PF14236', NULL, 'Domain of unknown function (DUF4338)', 230, NULL, 'DUF4338', 267920),
(448827, 'PF03623', NULL, 'Focal adhesion targeting region', 133, NULL, 'Focal_AT', 267921),
(448828, 'PF16609', NULL, 'SH3-RhoGEF linking unstructured region', 261, NULL, 'SH3-RhoG_link', 267922),
(448829, 'PF18946', NULL, 'GpV Apex motif', 23, NULL, 'Apex', 267923),
(448830, 'PF00179', NULL, 'Ubiquitin-conjugating enzyme', 140, NULL, 'UQ_con', 267924),
(448831, 'PF06341', NULL, 'Protein of unknown function (DUF1056)', 63, NULL, 'DUF1056', 267925),
(448832, 'PF11661', NULL, 'Protein of unknown function (DUF2986)', 43, NULL, 'DUF2986', 267926),
(448833, 'PF07122', NULL, 'Variable length PCR target protein (VLPT)', 30, NULL, 'VLPT', 267927),
(448834, 'PF15510', NULL, 'CENP-W protein', 88, NULL, 'CENP-W', 267928),
(448835, 'PF04057', NULL, 'Replication factor-A protein 1, N-terminal domain', 101, NULL, 'Rep-A_N', 267929),
(448836, 'PF14097', NULL, 'Stage V sporulation protein AE1', 180, NULL, 'SpoVAE', 267930),
(448837, 'PF19265', NULL, 'Family of unknown function (DUF5908)', 55, NULL, 'DUF5908', 267931),
(448838, 'PF14811', NULL, 'Protein of unknown function TPD sequence-motif', 138, NULL, 'TPD', 267932),
(448839, 'PF17492', NULL, 'Delta Ctenitoxins', 48, NULL, 'D_CNTX', 267933),
(448840, 'PF09737', NULL, 'De-etiolated protein 1 Det1', 412, NULL, 'Det1', 267934),
(448841, 'PF12450', NULL, 'von Willebrand factor', 94, NULL, 'vWF_A', 267935),
(448842, 'PF08195', NULL, 'TRI9 protein', 43, NULL, 'TRI9', 267936),
(448843, 'PF20302', NULL, 'HisK-N-like globin domain of the ASK signalosome', 133, NULL, 'HisK-N-like', 267937),
(448844, 'PF04182', NULL, 'B-block binding subunit of TFIIIC', 75, NULL, 'B-block_TFIIIC', 267938),
(448845, 'PF08375', NULL, 'Proteasome regulatory subunit C-terminal', 66, NULL, 'Rpn3_C', 267939),
(448846, 'PF15529', NULL, 'Bacterial toxin 24', 96, NULL, 'Ntox24', 267940),
(448847, 'PF06961', NULL, 'Protein of unknown function (DUF1294)', 55, NULL, 'DUF1294', 267941),
(448848, 'PF11037', NULL, 'Insulin-resistance promoting peptide in skeletal muscle', 133, NULL, 'Musclin', 267942),
(448849, 'PF09966', NULL, 'Uncharacterized protein conserved in bacteria (DUF2200)', 111, NULL, 'DUF2200', 267943),
(448850, 'PF08978', NULL, 'Reoviridae VP9', 280, NULL, 'Reoviridae_Vp9', 267944),
(448851, 'PF06892', NULL, 'Phage regulatory protein CII (CP76)', 144, NULL, 'Phage_CP76', 267945),
(448852, 'PF17227', NULL, 'Family of unknown function (DUF5302)', 52, NULL, 'DUF5302', 267946),
(448853, 'PF12990', NULL, 'Domain of unknonw function from B. Theta Gene description (DUF3874)', 71, NULL, 'DUF3874', 267947);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(448854, 'PF07236', NULL, 'Phytoreovirus S7 protein', 505, NULL, 'Phytoreo_S7', 267948),
(448855, 'PF07733', NULL, 'Bacterial DNA polymerase III alpha NTPase domain', 260, NULL, 'DNA_pol3_alpha', 267949),
(448856, 'PF14203', NULL, 'Putative transposon-transfer assisting protein', 62, NULL, 'TTRAP', 267950),
(448857, 'PF10440', NULL, 'Ubiquitin-binding WIYLD domain', 61, NULL, 'WIYLD', 267951),
(448858, 'PF05649', NULL, 'Peptidase family M13', 384, NULL, 'Peptidase_M13_N', 267952),
(448859, 'PF07643', NULL, 'Protein of unknown function (DUF1598)', 84, NULL, 'DUF1598', 267953),
(448860, 'PF11236', NULL, 'Protein of unknown function (DUF3037)', 118, NULL, 'DUF3037', 267954),
(448861, 'PF06214', NULL, 'Signaling lymphocytic activation molecule (SLAM) protein', 125, NULL, 'SLAM', 267955),
(448862, 'PF06908', NULL, 'YspA SLOG family', 168, NULL, 'YpsA', 267956),
(448863, 'PF10074', NULL, 'Uncharacterized conserved protein (DUF2285)', 107, NULL, 'DUF2285', 267957),
(448864, 'PF19911', NULL, 'Family of unknown function (DUF6384)', 308, NULL, 'DUF6384', 267958),
(448865, 'PF13940', NULL, 'Toxin Ldr, type I toxin-antitoxin system', 35, NULL, 'Ldr_toxin', 267959),
(448866, 'PF16312', NULL, 'Coiled-coil region of Oberon', 129, NULL, 'Oberon_cc', 267960),
(448867, 'PF05514', NULL, 'HR-like lesion-inducing', 138, NULL, 'HR_lesion', 267961),
(448868, 'PF08731', NULL, 'Transcription factor AFT', 111, NULL, 'AFT', 267962),
(448869, 'PF13739', NULL, 'Deacetylase PdaC', 95, NULL, 'PdaC', 267963),
(448870, 'PF11075', NULL, 'Protein of unknown function VcgC/VcgE (DUF2780)', 175, NULL, 'DUF2780', 267964),
(448871, 'PF05203', NULL, 'Hom_end-associated Hint', 228, NULL, 'Hom_end_hint', 267965),
(448872, 'PF03444', NULL, 'Winged helix-turn-helix transcription repressor, HrcA DNA-binding', 79, NULL, 'HrcA_DNA-bdg', 267966),
(448873, 'PF05117', NULL, 'Family of unknown function (DUF695)', 134, NULL, 'DUF695', 267967),
(448874, 'PF02824', NULL, 'TGS domain', 60, NULL, 'TGS', 267968),
(448875, 'PF09003', NULL, 'Bacteriophage lambda integrase, Arm DNA-binding domain', 74, NULL, 'Arm-DNA-bind_1', 267969),
(448876, 'PF06286', NULL, 'Coleoptericin', 143, NULL, 'Coleoptericin', 267970),
(448877, 'PF05737', NULL, 'Collagen binding domain', 131, NULL, 'Collagen_bind', 267971),
(448878, 'PF03717', NULL, 'Penicillin-binding Protein dimerisation domain', 181, NULL, 'PBP_dimer', 267972),
(448879, 'PF16457', NULL, 'Pleckstrin homology domain', 134, NULL, 'PH_12', 267973),
(448880, 'PF01936', NULL, 'NYN domain', 147, NULL, 'NYN', 267974),
(448881, 'PF06763', NULL, 'Prophage minor tail protein Z (GPZ)', 190, NULL, 'Minor_tail_Z', 267975),
(448882, 'PF08902', NULL, 'Domain of unknown function (DUF1848)', 266, NULL, 'DUF1848', 267976),
(448883, 'PF09338', NULL, 'Glycine/sarcosine/betaine reductase component B subunits', 426, NULL, 'Gly_reductase', 267977),
(448884, 'PF17850', NULL, 'CysA C-terminal regulatory domain', 43, NULL, 'CysA_C_terminal', 267978),
(448885, 'PF03201', NULL, 'H2-forming N5,N10-methylene-tetrahydromethanopterin dehydrogenase', 97, NULL, 'HMD', 267979),
(448886, 'PF02012', NULL, 'BNR/Asp-box repeat', 12, NULL, 'BNR', 267980),
(448887, 'PF11600', NULL, 'Chromatin assembly factor 1 complex p150 subunit, N-terminal', 164, NULL, 'CAF-1_p150', 267981),
(448888, 'PF19797', NULL, 'Family of unknown function (DUF6281)', 100, NULL, 'DUF6281', 267982),
(448889, 'PF06848', NULL, 'Disaggregatase related repeat', 180, NULL, 'Disaggr_repeat', 267983),
(448890, 'PF15470', NULL, 'Domain of unknown function (DUF4637)', 166, NULL, 'DUF4637', 267984),
(448891, 'PF15942', NULL, 'Domain of unknown function (DUF4751)', 121, NULL, 'DUF4751', 267985),
(448892, 'PF06103', NULL, 'Bacterial protein of unknown function (DUF948)', 89, NULL, 'DUF948', 267986),
(448893, 'PF17210', NULL, 'SdrD B-like domain', 112, NULL, 'SdrD_B', 267987),
(448894, 'PF04932', NULL, 'O-Antigen ligase', 154, NULL, 'Wzy_C', 267988),
(448895, 'PF04247', NULL, 'Invasion gene expression up-regulator, SirB', 121, NULL, 'SirB', 267989),
(448896, 'PF13533', NULL, 'Biotin-lipoyl like', 50, NULL, 'Biotin_lipoyl_2', 267990);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(448897, 'PF09060', NULL, 'L27_N', 48, NULL, 'L27_N', 267991),
(448898, 'PF03004', NULL, 'Plant transposase (Ptta/En/Spm family)', 142, NULL, 'Transposase_24', 267992),
(448899, 'PF00048', NULL, 'Small cytokines (intecrine/chemokine), interleukin-8 like', 60, NULL, 'IL8', 267993),
(448900, 'PF06685', NULL, 'Protein of unknown function (DUF1186)', 247, NULL, 'DUF1186', 267994),
(448901, 'PF12609', NULL, 'Wound-induced protein', 74, NULL, 'DUF3774', 267995),
(448902, 'PF00947', NULL, 'Picornavirus core protein 2A', 127, NULL, 'Pico_P2A', 267996),
(448903, 'PF01121', NULL, 'Dephospho-CoA kinase', 180, NULL, 'CoaE', 267997),
(448904, 'PF14903', NULL, 'WG containing repeat', 35, NULL, 'WG_beta_rep', 267998),
(448905, 'PF19083', NULL, 'Family of unknown function (DUF5774)', 126, NULL, 'DUF5774', 267999),
(448906, 'PF02714', NULL, 'Calcium-dependent channel, 7TM region, putative phosphate', 274, NULL, 'RSN1_7TM', 268000),
(448907, 'PF08854', NULL, 'Domain of unknown function (DUF1824)', 125, NULL, 'DUF1824', 268001),
(448908, 'PF07577', NULL, 'Domain of Unknown Function (DUF1547)', 60, NULL, 'DUF1547', 268002),
(448909, 'PF03025', NULL, 'Papillomavirus E5', 72, NULL, 'Papilloma_E5', 268003),
(448910, 'PF16851', NULL, 'Stomagen', 50, NULL, 'Stomagen', 268004),
(448911, 'PF10585', NULL, 'Ubiquitin-activating enzyme, SCCH domain', 256, NULL, 'UBA_E1_SCCH', 268005),
(448912, 'PF04551', NULL, 'GcpE protein', 352, NULL, 'GcpE', 268006),
(448913, 'PF19181', NULL, 'Family of unknown function (DUF5863)', 169, NULL, 'DUF5863', 268007),
(448914, 'PF18688', NULL, 'Family of unknown function (DUF5638)', 104, NULL, 'DUF5638', 268008),
(448915, 'PF20621', NULL, 'Family of unknown function (DUF6806)', 159, NULL, 'DUF6806', 268009),
(448916, 'PF00175', NULL, 'Oxidoreductase NAD-binding domain', 109, NULL, 'NAD_binding_1', 268010),
(448917, 'PF04650', NULL, 'YSIRK type signal peptide', 26, NULL, 'YSIRK_signal', 268011),
(448918, 'PF20376', NULL, 'Domain of unknown function (DUF6671)', 217, NULL, 'DUF6671', 268012),
(448919, 'PF06479', NULL, 'Ribonuclease 2-5A', 127, NULL, 'Ribonuc_2-5A', 268013),
(448920, 'PF08590', NULL, 'Domain of unknown function (DUF1771)', 64, NULL, 'DUF1771', 268014),
(448921, 'PF08706', NULL, 'D5 N terminal like', 151, NULL, 'D5_N', 268015),
(448922, 'PF02344', NULL, 'Myc leucine zipper domain', 31, NULL, 'Myc-LZ', 268016),
(448923, 'PF15366', NULL, 'Domain of unknown function (DUF4597)', 63, NULL, 'DUF4597', 268017),
(448924, 'PF16296', NULL, 'N-terminal of TM subunit in PBP-dependent ABC transporters', 84, NULL, 'TM_PBP2_N', 268018),
(448925, 'PF09853', NULL, 'Putative transposon-encoded protein (DUF2080)', 50, NULL, 'DUF2080', 268019),
(448926, 'PF06902', NULL, 'Divergent 4Fe-4S mono-cluster', 64, NULL, 'Fer4_19', 268020),
(448927, 'PF11558', NULL, 'Het-s 218-289', 65, NULL, 'HET-s_218-289', 268021),
(448928, 'PF07284', NULL, '2-vinyl bacteriochlorophyllide hydratase (BCHF)', 139, NULL, 'BCHF', 268022),
(448929, 'PF04848', NULL, 'Poxvirus A22 protein', 145, NULL, 'Pox_A22', 268023),
(448930, 'PF13000', NULL, 'Acetyl-coenzyme A transporter 1', 548, NULL, 'Acatn', 268024),
(448931, 'PF14976', NULL, 'FAM72 protein', 145, NULL, 'FAM72', 268025),
(448932, 'PF04595', NULL, 'Poxvirus I6-like family', 321, NULL, 'Pox_I6', 268026),
(448933, 'PF19633', NULL, 'Protein SET DOMAIN GROUP 2 C-terminal', 420, NULL, 'SDG2_C', 268027),
(448934, 'PF10878', NULL, 'Protein of unknown function (DUF2672)', 67, NULL, 'DUF2672', 268028),
(448935, 'PF17494', NULL, 'Family of unknown function (DUF5429)', 76, NULL, 'DUF5429', 268029),
(448936, 'PF07816', NULL, 'Protein of unknown function (DUF1645)', 191, NULL, 'DUF1645', 268030),
(448937, 'PF15363', NULL, 'Domain of unknown function (DUF4596)', 46, NULL, 'DUF4596', 268031),
(448938, 'PF12247', NULL, 'Temperature dependent protein affecting M2 dsRNA replication', 90, NULL, 'MKT1_N', 268032),
(448939, 'PF15961', NULL, 'Domain of unknown function (DUF4764)', 799, NULL, 'DUF4764', 268033),
(448940, 'PF01090', NULL, 'Ribosomal protein S19e', 137, NULL, 'Ribosomal_S19e', 268034); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(448941, 'PF11735', NULL, 'Cryptococcal mannosyltransferase 1', 240, NULL, 'CAP59_mtransfer', 268035),
(448942, 'PF17578', NULL, 'Family of unknown function (DUF5481)', 103, NULL, 'DUF5481', 268036),
(448943, 'PF20131', NULL, 'ABC-three component (ABC-3C) system Middle Component 3', 159, NULL, 'MC3', 268037),
(448944, 'PF14515', NULL, 'Haem-oxygenase-associated N-terminal helices', 93, NULL, 'HOASN', 268038),
(448945, 'PF00521', NULL, 'DNA gyrase/topoisomerase IV, subunit A', 426, NULL, 'DNA_topoisoIV', 268039),
(448946, 'PF01866', NULL, 'Putative diphthamide synthesis protein', 302, NULL, 'Diphthamide_syn', 268040),
(448947, 'PF03417', NULL, 'Acyl-coenzyme A:6-aminopenicillanic acid acyl-transferase', 227, NULL, 'AAT', 268041),
(448948, 'PF16789', NULL, 'YscO-like protein', 161, NULL, 'YscO-like', 268042),
(448949, 'PF05621', NULL, 'Bacterial TniB protein', 189, NULL, 'TniB', 268043),
(448950, 'PF17604', NULL, 'Family of unknown function (DUF5500)', 98, NULL, 'DUF5500', 268044),
(448951, 'PF12949', NULL, 'HeH/LEM domain', 35, NULL, 'HeH', 268045),
(448952, 'PF02148', NULL, 'Zn-finger in ubiquitin-hydrolases and other protein', 64, NULL, 'zf-UBP', 268046),
(448953, 'PF17359', NULL, 'Family of unknown function (DUF5385)', 222, NULL, 'DUF5385', 268047),
(448954, 'PF19017', NULL, 'Domain of unknown function (DUF5746)', 175, NULL, 'DUF5746', 268048),
(448955, 'PF01981', NULL, 'Peptidyl-tRNA hydrolase PTH2', 117, NULL, 'PTH2', 268049),
(448956, 'PF15168', NULL, 'Triple QxxK/R motif-containing protein family', 79, NULL, 'TRIQK', 268050),
(448957, 'PF20075', NULL, 'Domain of unknown function (DUF6471)', 65, NULL, 'DUF6471', 268051),
(448958, 'PF05524', NULL, 'PEP-utilising enzyme, N-terminal', 115, NULL, 'PEP-utilisers_N', 268052),
(448959, 'PF11584', NULL, 'Proteinaceous host-selective toxin ToxA', 117, NULL, 'Toxin_ToxA', 268053),
(448960, 'PF19634', NULL, 'Family of unknown function (DUF6137)', 82, NULL, 'DUF6137', 268054),
(448961, 'PF00133', NULL, 'tRNA synthetases class I (I, L, M and V)', 602, NULL, 'tRNA-synt_1', 268055),
(448962, 'PF01710', NULL, 'Transposase', 119, NULL, 'HTH_Tnp_IS630', 268056),
(448963, 'PF16235', NULL, 'Domain of unknown function (DUF4894)', 122, NULL, 'DUF4894', 268057),
(448964, 'PF19105', NULL, 'Family of unknown function (DUF5792)', 159, NULL, 'DUF5792', 268058),
(448965, 'PF19309', NULL, 'Frem protein N-terminal domain', 207, NULL, 'Frem_N', 268059),
(448966, 'PF18466', NULL, 'Glutamate--tRNA ligase N-terminal domain', 55, NULL, 'GluRS_N', 268060),
(448967, 'PF13965', NULL, 'dsRNA-gated channel SID-1', 601, NULL, 'SID-1_RNA_chan', 268061),
(448968, 'PF14467', NULL, 'Domain of unknown function (DUF4426)', 121, NULL, 'DUF4426', 268062),
(448969, 'PF09322', NULL, 'Domain of unknown function (DUF1979)', 58, NULL, 'DUF1979', 268063),
(448970, 'PF01361', NULL, 'Tautomerase enzyme', 60, NULL, 'Tautomerase', 268064),
(448971, 'PF15671', NULL, 'Proline-rich protein family 18', 266, NULL, 'PRR18', 268065),
(448972, 'PF15078', NULL, 'Domain of unknown function (DUF4545)', 465, NULL, 'DUF4545', 268066),
(448973, 'PF18981', NULL, 'Internalin K domain (D3/D4)', 75, NULL, 'InlK_D3', 268067),
(448974, 'PF15238', NULL, 'FAM181', 285, NULL, 'FAM181', 268068),
(448975, 'PF07428', NULL, '15-O-acetyltransferase Tri3', 413, NULL, 'Tri3', 268069),
(448976, 'PF19557', NULL, 'Family of unknown function (DUF6079)', 1238, NULL, 'DUF6079', 268070),
(448977, 'PF02390', NULL, 'Putative methyltransferase', 173, NULL, 'Methyltransf_4', 268071),
(448978, 'PF09193', NULL, 'Cholecystokinin A receptor, N-terminal', 47, NULL, 'CholecysA-Rec_N', 268072),
(448979, 'PF17705', NULL, 'Family of unknown function (DUF5551)', 155, NULL, 'DUF5551', 268073),
(448980, 'PF04144', NULL, 'SCAMP family', 173, NULL, 'SCAMP', 268074),
(448981, 'PF03503', NULL, 'Chlamydia cysteine-rich outer membrane protein 3', 54, NULL, 'Chlam_OMP3', 268075),
(448982, 'PF12561', NULL, 'ToxR activated gene A lipoprotein domain', 101, NULL, 'TagA', 268076),
(448983, 'PF04789', NULL, 'Protein of unknown function (DUF621)', 305, NULL, 'DUF621', 268077);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(448984, 'PF11411', NULL, 'DNA ligase IV', 34, NULL, 'DNA_ligase_IV', 268078),
(448985, 'PF04472', NULL, 'Cell division protein SepF', 72, NULL, 'SepF', 268079),
(448986, 'PF09697', NULL, 'Protein of unknown function (Porph_ging)', 83, NULL, 'Porph_ging', 268080),
(448987, 'PF03298', NULL, 'Stanniocalcin family', 200, NULL, 'Stanniocalcin', 268081),
(448988, 'PF02160', NULL, 'Cauliflower mosaic virus peptidase (A3)', 205, NULL, 'Peptidase_A3', 268082),
(448989, 'PF20255', NULL, 'Family of unknown function (DUF6606)', 267, NULL, 'DUF6606', 268083),
(448990, 'PF15056', NULL, 'Neuritin protein family', 89, NULL, 'NRN1', 268084),
(448991, 'PF18329', NULL, 'Surface glycan-binding protein B xyloglucan binding domain', 189, NULL, 'SGBP_B_XBD', 268085),
(448992, 'PF18900', NULL, 'Protein of unknown function (DUF5656)', 242, NULL, 'DUF5656', 268086),
(448993, 'PF16542', NULL, 'PNKP adenylyltransferase domain, ligase domain', 320, NULL, 'PNKP_ligase', 268087),
(448994, 'PF12686', NULL, 'Protein of unknown function (DUF3800)', 110, NULL, 'DUF3800', 268088),
(448995, 'PF15346', NULL, 'Arginine and glutamate-rich 1', 151, NULL, 'ARGLU', 268089),
(448996, 'PF00850', NULL, 'Histone deacetylase domain', 307, NULL, 'Hist_deacetyl', 268090),
(448997, 'PF09747', NULL, 'Coiled-coil domain containing protein 97-like, C-terminal', 195, NULL, 'CCD97-like_C', 268091),
(448998, 'PF00166', NULL, 'Chaperonin 10 Kd subunit', 93, NULL, 'Cpn10', 268092),
(448999, 'PF19372', NULL, 'Family of unknown function (DUF5947)', 179, NULL, 'DUF5947', 268093),
(449000, 'PF20372', NULL, 'Family of unknown function (DUF6667)', 252, NULL, 'DUF6667', 268094),
(449001, 'PF03740', NULL, 'Pyridoxal phosphate biosynthesis protein PdxJ', 234, NULL, 'PdxJ', 268095),
(449002, 'PF07667', NULL, 'Protein of unknown function (DUF1600)', 111, NULL, 'DUF1600', 268096),
(449003, 'PF14519', NULL, 'Macro-like domain', 275, NULL, 'Macro_2', 268097),
(449004, 'PF05952', NULL, 'Bacillus competence pheromone ComX', 55, NULL, 'ComX', 268098),
(449005, 'PF09504', NULL, 'Bsp6I restriction endonuclease', 179, NULL, 'RE_Bsp6I', 268099),
(449006, 'PF00893', NULL, 'Small Multidrug Resistance protein', 93, NULL, 'Multi_Drug_Res', 268100),
(449007, 'PF09519', NULL, 'HindVP restriction endonuclease', 332, NULL, 'RE_HindVP', 268101),
(449008, 'PF10180', NULL, 'WKF domain', 63, NULL, 'WKF', 268102),
(449009, 'PF13866', NULL, 'SAP30 zinc-finger', 72, NULL, 'zf-SAP30', 268103),
(449010, 'PF10961', NULL, 'Selenoprotein SelK_SelG', 86, NULL, 'SelK_SelG', 268104),
(449011, 'PF12776', NULL, 'Myb/SANT-like DNA-binding domain', 96, NULL, 'Myb_DNA-bind_3', 268105),
(449012, 'PF05895', NULL, 'Siphovirus protein of unknown function (DUF859)', 626, NULL, 'DUF859', 268106),
(449013, 'PF15705', NULL, 'Mature oligodendrocyte transmembrane protein, TMEM132D, N-term', 129, NULL, 'TMEM132D_N', 268107),
(449014, 'PF10670', NULL, 'Domain of unknown function (DUF4198)', 210, NULL, 'DUF4198', 268108),
(449015, 'PF17662', NULL, 'Family of unknown function (DUF5524)', 292, NULL, 'DUF5524', 268109),
(449016, 'PF13840', NULL, 'ACT domain', 65, NULL, 'ACT_7', 268110),
(449017, 'PF09413', NULL, 'Putative prokaryotic signal transducing protein', 67, NULL, 'DUF2007', 268111),
(449018, 'PF03296', NULL, 'Poxvirus poly(A) polymerase nucleotidyltransferase domain', 148, NULL, 'Pox_polyA_pol', 268112),
(449019, 'PF05385', NULL, 'Mastadenovirus early E4 13 kDa protein', 108, NULL, 'Adeno_E4', 268113),
(449020, 'PF16481', NULL, 'Domain of unknown function (DUF5058)', 222, NULL, 'DUF5058', 268114),
(449021, 'PF13861', NULL, 'FlgD Tudor-like domain', 58, NULL, 'FLgD_tudor', 268115),
(449022, 'PF19571', NULL, 'ACT domain pair', 141, NULL, 'ACT_8', 268116),
(449023, 'PF01590', NULL, 'GAF domain', 133, NULL, 'GAF', 268117),
(449024, 'PF17300', NULL, 'Filaments in between nuclei protein-1', 239, NULL, 'FIN1', 268118),
(449025, 'PF05101', NULL, 'Type IV secretory pathway, VirB3-like protein', 84, NULL, 'VirB3', 268119),
(449026, 'PF19772', NULL, 'Family of unknown function (DUF6258)', 136, NULL, 'DUF6258', 268120);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(449027, 'PF04685', NULL, 'Glycosyl-hydrolase family 116, catalytic region', 361, NULL, 'DUF608', 268121),
(449028, 'PF14612', NULL, 'IEC3 subunit of the Ino80 complex, chromatin re-modelling', 231, NULL, 'Ino80_Iec3', 268122),
(449029, 'PF18741', NULL, 'REase_MTES_1575', 96, NULL, 'MTES_1575', 268123),
(449030, 'PF05704', NULL, 'Capsular polysaccharide synthesis protein', 278, NULL, 'Caps_synth', 268124),
(449031, 'PF04147', NULL, 'Nop14-like family', 873, NULL, 'Nop14', 268125),
(449032, 'PF04936', NULL, 'Protein of unknown function (DUF658)', 186, NULL, 'DUF658', 268126),
(449033, 'PF12936', NULL, 'KRI1-like family C-terminal', 89, NULL, 'Kri1_C', 268127),
(449034, 'PF20212', NULL, 'Family of unknown function (DUF6572)', 107, NULL, 'DUF6572', 268128),
(449035, 'PF02532', NULL, 'Photosystem II reaction centre I protein (PSII 4.8 kDa protein)', 36, NULL, 'PsbI', 268129),
(449036, 'PF18323', NULL, 'Cop9 signalosome subunit 5 C-terminal domain', 89, NULL, 'CSN5_C', 268130),
(449037, 'PF17881', NULL, 'Domain of unknown function (DUF5590)', 45, NULL, 'DUF5590', 268131),
(449038, 'PF18759', NULL, 'Plavaka transposase', 325, NULL, 'Plavaka', 268132),
(449039, 'PF02825', NULL, 'WWE domain', 67, NULL, 'WWE', 268133),
(449040, 'PF05512', NULL, 'AWPM-19-like family', 142, NULL, 'AWPM-19', 268134),
(449041, 'PF16083', NULL, 'LydA holin phage, holin superfamily III', 78, NULL, 'Phage_holin_3_3', 268135),
(449042, 'PF11171', NULL, 'Protein of unknown function (DUF2958)', 111, NULL, 'DUF2958', 268136),
(449043, 'PF09649', NULL, 'Histone chaperone domain CHZ', 34, NULL, 'CHZ', 268137),
(449044, 'PF00479', NULL, 'Glucose-6-phosphate dehydrogenase, NAD binding domain', 180, NULL, 'G6PD_N', 268138),
(449045, 'PF08098', NULL, 'Anemonia sulcata toxin III family', 27, NULL, 'ATX_III', 268139),
(449046, 'PF06736', NULL, 'Endosomal/lysosomal potassium channel TMEM175', 88, NULL, 'TMEM175', 268140),
(449047, 'PF18859', NULL, 'Actinobacteria/chloroflexi VLRF1 release factor', 130, NULL, 'acVLRF1', 268141),
(449048, 'PF10477', NULL, 'Nucleocytoplasmic shuttling protein for mRNA cap-binding EIF4E', 659, NULL, 'EIF4E-T', 268142),
(449049, 'PF02956', NULL, 'TT viral orf 1', 525, NULL, 'TT_ORF1', 268143),
(449050, 'PF09278', NULL, 'MerR, DNA binding', 65, NULL, 'MerR-DNA-bind', 268144),
(449051, 'PF08531', NULL, 'Alpha-L-rhamnosidase N-terminal domain', 172, NULL, 'Bac_rhamnosid_N', 268145),
(449052, 'PF05606', NULL, 'Borrelia burgdorferi protein of unknown function (DUF777)', 135, NULL, 'DUF777', 268146),
(449053, 'PF15114', NULL, 'Uncharacterised protein family UPF0640', 67, NULL, 'UPF0640', 268147),
(449054, 'PF03798', NULL, 'TLC domain', 198, NULL, 'TRAM_LAG1_CLN8', 268148),
(449055, 'PF07556', NULL, 'Protein of unknown function (DUF1538)', 211, NULL, 'DUF1538', 268149),
(449056, 'PF00827', NULL, 'Ribosomal L15', 189, NULL, 'Ribosomal_L15e', 268150),
(449057, 'PF09582', NULL, 'Iron only nitrogenase protein AnfO (AnfO_nitrog)', 190, NULL, 'AnfO_nitrog', 268151),
(449058, 'PF08656', NULL, 'DASH complex subunit Dad3', 73, NULL, 'DASH_Dad3', 268152),
(449059, 'PF07342', NULL, 'Protein of unknown function (DUF1474)', 100, NULL, 'DUF1474', 268153),
(449060, 'PF18846', NULL, 'Bacterial archaeo-eukaryotic release factor family 5', 132, NULL, 'baeRF_family5', 268154),
(449061, 'PF00440', NULL, 'Bacterial regulatory proteins, tetR family', 47, NULL, 'TetR_N', 268155),
(449062, 'PF17074', NULL, 'Darcynin, domain of unknown function', 124, NULL, 'Darcynin', 268156),
(449063, 'PF18120', NULL, 'Domain of unknown function (DUF5597)', 133, NULL, 'DUF5597', 268157),
(449064, 'PF07471', NULL, 'Phage DNA packaging protein Nu1', 164, NULL, 'Phage_Nu1', 268158),
(449065, 'PF19390', NULL, 'Family of unknown function (DUF5965)', 74, NULL, 'DUF5965', 268159),
(449066, 'PF09831', NULL, 'Uncharacterized protein conserved in bacteria (DUF2058)', 174, NULL, 'DUF2058', 268160),
(449067, 'PF16142', NULL, 'Domain of unknown function (DUF4850)', 184, NULL, 'DUF4850', 268161),
(449068, 'PF11062', NULL, 'Protein of unknown function (DUF2863)', 398, NULL, 'DUF2863', 268162);
INSERT INTO "PUBLIC"."MODEL" VALUES
(449069, 'PF12166', NULL, 'Piezo non-specific cation channel, R-Ras-binding domain', 426, NULL, 'Piezo_RRas_bdg', 268163),
(449070, 'PF20354', NULL, 'Family of unknown function (DUF6649)', 227, NULL, 'DUF6649', 268164),
(449071, 'PF20532', NULL, 'Family of unknown function (DUF6747)', 55, NULL, 'DUF6747', 268165),
(449072, 'PF15027', NULL, 'Domain of unknown function (DUF4525)', 137, NULL, 'DUF4525', 268166),
(449073, 'PF15341', NULL, 'Ribosome biogenesis protein SLX9', 131, NULL, 'SLX9', 268167),
(449074, 'PF14022', NULL, 'Protein of unknown function (DUF4238)', 271, NULL, 'DUF4238', 268168),
(449075, 'PF16014', NULL, 'Histone deacetylase complex subunit SAP130 C-terminus', 406, NULL, 'SAP130_C', 268169),
(449076, 'PF03748', NULL, 'Flagellar basal body-associated protein FliL', 103, NULL, 'FliL', 268170),
(449077, 'PF15077', NULL, 'Membrane-anchored junction protein', 238, NULL, 'MAJIN', 268171),
(449078, 'PF06587', NULL, 'Protein of unknown function (DUF1137)', 117, NULL, 'DUF1137', 268172),
(449079, 'PF12745', NULL, 'Anticodon binding domain of tRNAs', 263, NULL, 'HGTP_anticodon2', 268173),
(449080, 'PF05210', NULL, 'Sprouty protein (Spry)', 116, NULL, 'Sprouty', 268174),
(449081, 'PF06631', NULL, 'Protein of unknown function (DUF1154)', 45, NULL, 'DUF1154', 268175),
(449082, 'PF01246', NULL, 'Ribosomal protein L24e', 66, NULL, 'Ribosomal_L24e', 268176),
(449083, 'PF00913', NULL, 'Trypanosome variant surface glycoprotein (A-type)', 367, NULL, 'Trypan_glycop', 268177),
(449084, 'PF07639', NULL, 'YTV', 43, NULL, 'YTV', 268178),
(449085, 'PF12062', NULL, 'heparan sulfate-N-deacetylase', 430, NULL, 'HSNSD', 268179),
(449086, 'PF15665', NULL, 'Family with sequence similarity 184, A and B', 211, NULL, 'FAM184', 268180),
(449087, 'PF06330', NULL, 'Trichodiene synthase (TRI5)', 362, NULL, 'TRI5', 268181),
(449088, 'PF14133', NULL, 'Domain of unknown function (DUF4300)', 252, NULL, 'DUF4300', 268182),
(449089, 'PF12070', NULL, 'Protein SCAI', 538, NULL, 'SCAI', 268183),
(449090, 'PF02496', NULL, 'ABA/WDS induced protein', 78, NULL, 'ABA_WDS', 268184),
(449091, 'PF00155', NULL, 'Aminotransferase class I and II', 363, NULL, 'Aminotran_1_2', 268185),
(449092, 'PF04552', NULL, 'Sigma-54, DNA binding domain', 160, NULL, 'Sigma54_DBD', 268186),
(449093, 'PF12901', NULL, 'SUZ-C motif', 33, NULL, 'SUZ-C', 268187),
(449094, 'PF13957', NULL, 'Toxin YafO, type II toxin-antitoxin system', 101, NULL, 'YafO_toxin', 268188),
(449095, 'PF14988', NULL, 'Domain of unknown function (DUF4515)', 206, NULL, 'DUF4515', 268189),
(449096, 'PF19776', NULL, 'Family of unknown function (DUF6262)', 110, NULL, 'DUF6262', 268190),
(449097, 'PF02586', NULL, 'SOS response associated peptidase (SRAP)', 220, NULL, 'SRAP', 268191),
(449098, 'PF11279', NULL, 'Protein of unknown function (DUF3080)', 315, NULL, 'DUF3080', 268192),
(449099, 'PF05550', NULL, 'Pestivirus Npro endopeptidase C53', 168, NULL, 'Peptidase_C53', 268193),
(449100, 'PF00772', NULL, 'DnaB-like helicase N terminal domain', 103, NULL, 'DnaB', 268194),
(449101, 'PF02300', NULL, 'Fumarate reductase subunit C', 127, NULL, 'Fumarate_red_C', 268195),
(449102, 'PF18802', NULL, 'CxC1 like cysteine cluster associated with KDZ transposases', 105, NULL, 'CxC1', 268196),
(449103, 'PF09255', NULL, 'Caf1 Capsule antigen', 136, NULL, 'Antig_Caf1', 268197),
(449104, 'PF09596', NULL, 'MamL-1 domain', 58, NULL, 'MamL-1', 268198),
(449105, 'PF05764', NULL, 'YL1 nuclear protein', 240, NULL, 'YL1', 268199),
(449106, 'PF05356', NULL, 'Inovirus Coat protein B', 56, NULL, 'Phage_Coat_B', 268200),
(449107, 'PF07828', NULL, 'PA-IL-like protein', 121, NULL, 'PA-IL', 268201),
(449108, 'PF13634', NULL, 'Nucleoporin FG repeat region', 93, NULL, 'Nucleoporin_FG', 268202),
(449109, 'PF04230', NULL, 'Polysaccharide pyruvyl transferase', 286, NULL, 'PS_pyruv_trans', 268203),
(449110, 'PF02117', NULL, 'Serpentine type 7TM GPCR chemoreceptor Sra', 328, NULL, '7TM_GPCR_Sra', 268204),
(449111, 'PF09427', NULL, 'Domain of unknown function (DUF2014)', 264, NULL, 'DUF2014', 268205),
(449112, 'PF07014', NULL, 'Hs1pro-1 protein C-terminus', 261, NULL, 'Hs1pro-1_C', 268206);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(449113, 'PF12471', NULL, 'GTP cyclohydrolase N terminal', 193, NULL, 'GTP_CH_N', 268207),
(449114, 'PF14999', NULL, 'Shadow of prion protein, neuroprotective', 133, NULL, 'Shadoo', 268208),
(449115, 'PF01596', NULL, 'O-methyltransferase', 204, NULL, 'Methyltransf_3', 268209),
(449116, 'PF02536', NULL, 'mTERF', 315, NULL, 'mTERF', 268210),
(449117, 'PF09799', NULL, 'Predicted membrane protein', 107, NULL, 'Transmemb_17', 268211),
(449118, 'PF11485', NULL, 'Protein of unknown function (DUF3211)', 136, NULL, 'DUF3211', 268212),
(449119, 'PF18231', NULL, 'Domain of unknown function (DUF5603)', 105, NULL, 'DUF5603', 268213),
(449120, 'PF20114', NULL, 'Family of unknown function (DUF6504)', 117, NULL, 'DUF6504', 268214),
(449121, 'PF10169', NULL, 'Learning-associated protein', 127, NULL, 'Laps', 268215),
(449122, 'PF03271', NULL, 'EB1-like C-terminal motif', 41, NULL, 'EB1', 268216),
(449123, 'PF03811', NULL, 'InsA N-terminal domain', 35, NULL, 'Zn_Tnp_IS1', 268217),
(449124, 'PF17877', NULL, 'DIS3-like exonuclease 2 C terminal', 87, NULL, 'Dis3l2_C_term', 268218),
(449125, 'PF08025', NULL, 'Spider antimicrobial peptide', 37, NULL, 'Antimicrobial_3', 268219),
(449126, 'PF10486', NULL, 'Phosphoinositide 3-kinase gamma adapter protein p101 subunit', 860, NULL, 'PI3K_1B_p101', 268220),
(449127, 'PF05082', NULL, 'Rop-like', 64, NULL, 'Rop-like', 268221),
(449128, 'PF08169', NULL, 'RBB1NT (NUC162) domain', 94, NULL, 'RBB1NT', 268222),
(449129, 'PF18904', NULL, 'Domain of unknown function (DUF5660)', 109, NULL, 'DUF5660', 268223),
(449130, 'PF09258', NULL, 'Glycosyl transferase family 64 domain', 245, NULL, 'Glyco_transf_64', 268224),
(449131, 'PF02358', NULL, 'Trehalose-phosphatase', 235, NULL, 'Trehalose_PPase', 268225),
(449132, 'PF15841', NULL, 'Transmembrane protein 239 family', 151, NULL, 'TMEM239', 268226),
(449133, 'PF15135', NULL, 'Uncharacterised protein UPF0515', 271, NULL, 'UPF0515', 268227),
(449134, 'PF11925', NULL, 'Protein of unknown function (DUF3443)', 370, NULL, 'DUF3443', 268228),
(449135, 'PF10607', NULL, 'CTLH/CRA C-terminal to LisH motif domain', 150, NULL, 'CTLH', 268229),
(449136, 'PF12719', NULL, 'Nuclear condensing complex subunits, C-term domain', 292, NULL, 'Cnd3', 268230),
(449137, 'PF16349', NULL, 'Domain of unknown function (DUF4978)', 172, NULL, 'DUF4978', 268231),
(449138, 'PF07890', NULL, 'Rrp15p', 134, NULL, 'Rrp15p', 268232),
(449139, 'PF15437', NULL, 'Plasminogen-binding protein pgbA C-terminal', 84, NULL, 'PGBA_C', 268233),
(449140, 'PF10042', NULL, 'Uncharacterized conserved protein (DUF2278)', 204, NULL, 'DUF2278', 268234),
(449141, 'PF00113', NULL, 'Enolase, C-terminal TIM barrel domain', 296, NULL, 'Enolase_C', 268235),
(449142, 'PF17180', NULL, 'Zinc-binding domain', 74, NULL, 'zf-3CxxC_2', 268236),
(449143, 'PF20047', NULL, 'Domain of unknown function (DUF6449)', 152, NULL, 'DUF6449', 268237),
(449144, 'PF08385', NULL, 'Dynein heavy chain, N-terminal region 1', 562, NULL, 'DHC_N1', 268238),
(449145, 'PF08489', NULL, 'Domain of unknown function (DUF1743)', 116, NULL, 'DUF1743', 268239),
(449146, 'PF08360', NULL, 'QacR-like protein, C-terminal region', 131, NULL, 'TetR_C_5', 268240),
(449147, 'PF06243', NULL, 'Phenylacetic acid degradation B', 89, NULL, 'PaaB', 268241),
(449148, 'PF02872', NULL, '5''-nucleotidase, C-terminal domain', 158, NULL, '5_nucleotid_C', 268242),
(449149, 'PF11815', NULL, 'Domain of unknown function (DUF3336)', 139, NULL, 'DUF3336', 268243),
(449150, 'PF02981', NULL, 'FokI, recognition domain, subdomain 1', 137, NULL, 'FokI_D1', 268244),
(449151, 'PF11390', NULL, 'NADH-dependant formate dehydrogenase delta subunit FdsD', 61, NULL, 'FdsD', 268245),
(449152, 'PF18602', NULL, 'Rap1a immunity proteins', 92, NULL, 'Rap1a', 268246),
(449153, 'PF04511', NULL, 'Der1-like family', 191, NULL, 'DER1', 268247),
(449154, 'PF01145', NULL, 'SPFH domain / Band 7 family', 180, NULL, 'Band_7', 268248),
(449155, 'PF01745', NULL, 'Isopentenyl transferase', 233, NULL, 'IPT', 268249),
(449156, 'PF04088', NULL, 'Peroxin 13, N-terminal region', 145, NULL, 'Peroxin-13_N', 268250);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(449157, 'PF14562', NULL, 'Restriction endonuclease BglI', 285, NULL, 'Endonuc_BglI', 268251),
(449158, 'PF17884', NULL, 'Domain of unknown function (DUF5591)', 152, NULL, 'DUF5591', 268252),
(449159, 'PF19597', NULL, 'Family of unknown function (DUF6102)', 278, NULL, 'DUF6102', 268253),
(449160, 'PF13977', NULL, 'BetI-type transcriptional repressor, C-terminal', 115, NULL, 'TetR_C_6', 268254),
(449161, 'PF19689', NULL, 'Family of unknown function (DUF6190)', 165, NULL, 'DUF6190', 268255),
(449162, 'PF12375', NULL, 'Phage protein', 66, NULL, 'DUF3653', 268256),
(449163, 'PF12299', NULL, 'Protein of unknown function (DUF3627)', 94, NULL, 'DUF3627', 268257),
(449164, 'PF02578', NULL, 'Multi-copper polyphenol oxidoreductase laccase', 236, NULL, 'Cu-oxidase_4', 268258),
(449165, 'PF18041', NULL, 'MapZ extracellular domain 1', 129, NULL, 'MapZ_EC1', 268259),
(449166, 'PF18810', NULL, 'phage-Barnase-EndoU-ColicinE5/D-RelE like nuclease2', 120, NULL, 'PBECR2', 268260),
(449167, 'PF19707', NULL, 'Family of unknown function (DUF6204)', 113, NULL, 'DUF6204', 268261),
(449168, 'PF19086', NULL, 'Terpene synthase family 2, C-terminal metal binding', 199, NULL, 'Terpene_syn_C_2', 268262),
(449169, 'PF02553', NULL, 'Cobalt transport protein component CbiN', 67, NULL, 'CbiN', 268263),
(449170, 'PF04443', NULL, 'Acyl-protein synthetase, LuxE', 375, NULL, 'LuxE', 268264),
(449171, 'PF06978', NULL, 'Ribonucleases P/MRP protein subunit POP1', 206, NULL, 'POP1', 268265),
(449172, 'PF09482', NULL, 'Bacterial type III secretion apparatus protein (OrgA_MxiK)', 181, NULL, 'OrgA_MxiK', 268266),
(449173, 'PF16183', NULL, 'Kinesin-associated', 179, NULL, 'Kinesin_assoc', 268267),
(449174, 'PF17070', NULL, '30S ribosomal protein Thx', 27, NULL, 'Thx', 268268),
(449175, 'PF12953', NULL, 'Domain of unknown function (DUF3842)', 130, NULL, 'DUF3842', 268269),
(449176, 'PF08814', NULL, 'XisH protein', 134, NULL, 'XisH', 268270),
(449177, 'PF11730', NULL, 'Protein of unknown function (DUF3297)', 71, NULL, 'DUF3297', 268271),
(449178, 'PF03285', NULL, 'Paralemmin', 333, NULL, 'Paralemmin', 268272),
(449179, 'PF07984', NULL, 'Nucleotidyltransferase', 321, NULL, 'NTP_transf_7', 268273),
(449180, 'PF16295', NULL, 'Tetracyclin repressor-like, C-terminal domain', 132, NULL, 'TetR_C_10', 268274),
(449181, 'PF15234', NULL, 'Linker for activation of T-cells', 236, NULL, 'LAT', 268275),
(449182, 'PF02799', NULL, 'Myristoyl-CoA:protein N-myristoyltransferase, C-terminal domain', 212, NULL, 'NMT_C', 268276),
(449183, 'PF01270', NULL, 'Glycosyl hydrolases family 8', 342, NULL, 'Glyco_hydro_8', 268277),
(449184, 'PF20132', NULL, 'Family of unknown function (DUF6522)', 88, NULL, 'DUF6522', 268278),
(449185, 'PF11368', NULL, 'Protein of unknown function (DUF3169)', 250, NULL, 'DUF3169', 268279),
(449186, 'PF16577', NULL, 'UBA domain', 62, NULL, 'UBA_5', 268280),
(449187, 'PF01071', NULL, 'Phosphoribosylglycinamide synthetase, ATP-grasp (A) domain', 194, NULL, 'GARS_A', 268281),
(449188, 'PF13756', NULL, 'Stimulus-sensing domain', 111, NULL, 'Stimulus_sens_1', 268282),
(449189, 'PF10638', NULL, 'Spindle body associated protein C-terminus', 103, NULL, 'Sfi1_C', 268283),
(449190, 'PF09371', NULL, 'Tex-like protein N-terminal domain', 184, NULL, 'Tex_N', 268284),
(449191, 'PF02654', NULL, 'Cobalamin-5-phosphate synthase', 205, NULL, 'CobS', 268285),
(449192, 'PF17549', NULL, 'Gene Product 17', 140, NULL, 'Phage_Gp17', 268286),
(449193, 'PF01111', NULL, 'Cyclin-dependent kinase regulatory subunit', 68, NULL, 'CKS', 268287),
(449194, 'PF14026', NULL, 'Protein of unknown function (DUF4242)', 76, NULL, 'DUF4242', 268288),
(449195, 'PF04546', NULL, 'Sigma-70, non-essential region', 205, NULL, 'Sigma70_ner', 268289),
(449196, 'PF12922', NULL, 'non-SMC mitotic condensation complex subunit 1, N-term', 166, NULL, 'Cnd1_N', 268290),
(449197, 'PF15461', NULL, 'Beta-carotene 15,15''-dioxygenase', 271, NULL, 'BCD', 268291),
(449198, 'PF04895', NULL, 'Archaeal Nre, C-terminal', 110, NULL, 'Nre_C', 268292),
(449199, 'PF13359', NULL, 'DDE superfamily endonuclease', 158, NULL, 'DDE_Tnp_4', 268293);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(449200, 'PF12372', NULL, 'Huntingtin protein region', 41, NULL, 'DUF3652', 268294),
(449201, 'PF00270', NULL, 'DEAD/DEAH box helicase', 176, NULL, 'DEAD', 268295),
(449202, 'PF10551', NULL, 'MULE transposase domain', 98, NULL, 'MULE', 268296),
(449203, 'PF14264', NULL, 'Glucosyl transferase GtrII', 294, NULL, 'Glucos_trans_II', 268297),
(449204, 'PF16038', NULL, 'TMIE protein', 85, NULL, 'TMIE', 268298),
(449205, 'PF10811', NULL, 'Protein of unknown function (DUF2532)', 158, NULL, 'DUF2532', 268299),
(449206, 'PF11572', NULL, 'Protein of unknown function (DUF3234)', 95, NULL, 'DUF3234', 268300),
(449207, 'PF03168', NULL, 'Late embryogenesis abundant protein', 101, NULL, 'LEA_2', 268301),
(449208, 'PF16708', NULL, 'Lipoprotein confined to pathogenic Mycobacterium', 153, NULL, 'LppA', 268302),
(449209, 'PF00292', NULL, '''Paired box'' domain', 125, NULL, 'PAX', 268303),
(449210, 'PF17654', NULL, 'Selenocysteine tRNA 1 associated proteins', 118, NULL, 'Trnau1ap', 268304),
(449211, 'PF08137', NULL, 'DVL family', 19, NULL, 'DVL', 268305),
(449212, 'PF04308', NULL, 'Ribonuclease H-like', 145, NULL, 'RNaseH_like', 268306),
(449213, 'PF16425', NULL, 'Domain of unknown function (DUF5022)', 279, NULL, 'DUF5022', 268307),
(449214, 'PF04745', NULL, 'VITF-3 subunit protein', 289, NULL, 'Pox_A8', 268308),
(449215, 'PF03807', NULL, 'NADP oxidoreductase coenzyme F420-dependent', 96, NULL, 'F420_oxidored', 268309),
(449216, 'PF10905', NULL, 'Protein of unknown function (DUF2695)', 53, NULL, 'DUF2695', 268310),
(449217, 'PF00427', NULL, 'Phycobilisome Linker polypeptide', 126, NULL, 'PBS_linker_poly', 268311),
(449218, 'PF09554', NULL, 'HaeII restriction endonuclease', 338, NULL, 'RE_HaeII', 268312),
(449219, 'PF14666', NULL, 'Rapamycin-insensitive companion of mTOR, middle domain', 104, NULL, 'RICTOR_M', 268313),
(449220, 'PF14380', NULL, 'Wall-associated receptor kinase C-terminal', 105, NULL, 'WAK_assoc', 268314),
(449221, 'PF14305', NULL, 'TupA-like ATPgrasp', 241, NULL, 'ATPgrasp_TupA', 268315),
(449222, 'PF05659', NULL, 'Arabidopsis broad-spectrum mildew resistance protein RPW8', 139, NULL, 'RPW8', 268316),
(449223, 'PF12681', NULL, 'Glyoxalase-like domain', 118, NULL, 'Glyoxalase_2', 268317),
(449224, 'PF11605', NULL, 'Vacuolar protein sorting protein 36 Vps36', 92, NULL, 'Vps36_ESCRT-II', 268318),
(449225, 'PF13935', NULL, 'Ead/Ea22-like protein', 139, NULL, 'Ead_Ea22', 268319),
(449226, 'PF00140', NULL, 'Sigma-70 factor, region 1.2', 34, NULL, 'Sigma70_r1_2', 268320),
(449227, 'PF18307', NULL, 'Transcription factor Tfb2 (p52) C-terminal domain', 68, NULL, 'Tfb2_C', 268321),
(449228, 'PF17254', NULL, 'Family of unknown function (DUF5321)', 160, NULL, 'DUF5321', 268322),
(449229, 'PF08186', NULL, 'Wound-inducible basic protein family', 44, NULL, 'Wound_ind', 268323),
(449230, 'PF00570', NULL, 'HRDC domain', 68, NULL, 'HRDC', 268324),
(449231, 'PF03232', NULL, 'Ubiquinone biosynthesis protein COQ7', 168, NULL, 'COQ7', 268325),
(449232, 'PF13502', NULL, 'AsmA-like C-terminal region', 226, NULL, 'AsmA_2', 268326),
(449233, 'PF13524', NULL, 'Glycosyl transferases group 1', 92, NULL, 'Glyco_trans_1_2', 268327),
(449234, 'PF17615', NULL, 'Family of unknown function', 158, NULL, 'C166', 268328),
(449235, 'PF04761', NULL, 'Lactococcus bacteriophage putative transcription regulator', 57, NULL, 'Phage_Treg', 268329),
(449236, 'PF12934', NULL, 'FTO C-terminal domain', 170, NULL, 'FTO_CTD', 268330),
(449237, 'PF14757', NULL, 'Immunogenic region of nsp2 protein of arterivirus polyprotein', 272, NULL, 'NSP2-B_epitope', 268331),
(449238, 'PF01120', NULL, 'Alpha-L-fucosidase', 350, NULL, 'Alpha_L_fucos', 268332),
(449239, 'PF19550', NULL, 'Family of unknown function (DUF6073)', 219, NULL, 'DUF6073', 268333),
(449240, 'PF16717', NULL, 'Ribosome-associated complex head domain', 98, NULL, 'RAC_head', 268334),
(449241, 'PF00964', NULL, 'Elicitin', 88, NULL, 'Elicitin', 268335),
(449242, 'PF08956', NULL, 'Domain of unknown function (DUF1869)', 59, NULL, 'DUF1869', 268336),
(449243, 'PF08887', NULL, 'GAD-like domain', 107, NULL, 'GAD-like', 268337);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(449244, 'PF14991', NULL, 'Protein melan-A', 117, NULL, 'MLANA', 268338),
(449245, 'PF08055', NULL, 'Tryptophan leader peptide', 18, NULL, 'Trp_leader1', 268339),
(449246, 'PF14736', NULL, 'Protein N-terminal asparagine amidohydrolase', 270, NULL, 'N_Asn_amidohyd', 268340),
(449247, 'PF18043', NULL, 'T4 RNA ligase 2 C-terminal', 82, NULL, 'T4_Rnl2_C', 268341),
(449248, 'PF04553', NULL, 'Tis11B like protein, N terminus', 122, NULL, 'Tis11B_N', 268342),
(449249, 'PF12943', NULL, 'Protein of unknown function (DUF3839)', 242, NULL, 'DUF3839', 268343),
(449250, 'PF16738', NULL, 'Starch-binding module 26', 69, NULL, 'CBM26', 268344),
(449251, 'PF03037', NULL, 'Kinetoplastid membrane protein 11', 90, NULL, 'KMP11', 268345),
(449252, 'PF00007', NULL, 'Cystine-knot domain', 105, NULL, 'Cys_knot', 268346),
(449253, 'PF01865', NULL, 'Protein of unknown function DUF47', 214, NULL, 'PhoU_div', 268347),
(449254, 'PF04081', NULL, 'DNA polymerase delta, subunit 4', 131, NULL, 'DNA_pol_delta_4', 268348),
(449255, 'PF15458', NULL, 'Nineteen complex-related protein 2', 225, NULL, 'NTR2', 268349),
(449256, 'PF01883', NULL, 'Iron-sulfur cluster assembly protein', 75, NULL, 'FeS_assembly_P', 268350),
(449257, 'PF11435', NULL, 'RNA binding protein She2p', 201, NULL, 'She2p', 268351),
(449258, 'PF07198', NULL, 'Protein of unknown function (DUF1410)', 61, NULL, 'DUF1410', 268352),
(449259, 'PF12337', NULL, 'Protein of unknown function (DUF3637)', 67, NULL, 'DUF3637', 268353),
(449260, 'PF02381', NULL, 'MraZ protein, putative antitoxin-like', 72, NULL, 'MraZ', 268354),
(449261, 'PF17033', NULL, 'Carboxypeptidase controlling helical cell shape catalytic', 267, NULL, 'Peptidase_M99', 268355),
(449262, 'PF13613', NULL, 'Helix-turn-helix of DDE superfamily endonuclease', 53, NULL, 'HTH_Tnp_4', 268356),
(449263, 'PF14965', NULL, 'Negative regulator of p53/TP53', 180, NULL, 'BRI3BP', 268357),
(449264, 'PF15696', NULL, 'RAD51 interacting motif', 39, NULL, 'RAD51_interact', 268358),
(449265, 'PF00553', NULL, 'Cellulose binding domain', 101, NULL, 'CBM_2', 268359),
(449266, 'PF13143', NULL, 'Protein of unknown function (DUF3986)', 87, NULL, 'DUF3986', 268360),
(449267, 'PF19072', NULL, 'Family of unknown function (DUF5768)', 123, NULL, 'DUF5768', 268361),
(449268, 'PF15770', NULL, 'Domain of unknown function (DUF4699)', 310, NULL, 'DUF4699', 268362),
(449269, 'PF18608', NULL, 'XIAP-associated factor 1 C-terminal domain', 54, NULL, 'XAF1_C', 268363),
(449270, 'PF05658', NULL, 'YadA head domain repeat (2 copies)', 27, NULL, 'YadA_head', 268364),
(449271, 'PF06502', NULL, 'Equine infectious anaemia virus S2 protein', 67, NULL, 'Equine_IAV_S2', 268365),
(449272, 'PF08263', NULL, 'Leucine rich repeat N-terminal domain', 41, NULL, 'LRRNT_2', 268366),
(449273, 'PF12281', NULL, 'Nucleotidyltransferase', 219, NULL, 'NTP_transf_8', 268367),
(449274, 'PF14955', NULL, 'Mitochondrial ribosome subunit S24', 135, NULL, 'MRP-S24', 268368),
(449275, 'PF16777', NULL, 'Transcriptional regulator, RHH-like, CopG', 73, NULL, 'RHH_7', 268369),
(449276, 'PF11921', NULL, 'Domain of unknown function (DUF3439)', 122, NULL, 'DUF3439', 268370),
(449277, 'PF17508', NULL, 'Microcin V bacteriocin', 104, NULL, 'MccV', 268371),
(449278, 'PF06473', NULL, 'FGF binding protein 1 (FGF-BP1)', 229, NULL, 'FGF-BP1', 268372),
(449279, 'PF16551', NULL, 'Putative nuclear localisation signal of quaking', 30, NULL, 'Quaking_NLS', 268373),
(449280, 'PF02782', NULL, 'FGGY family of carbohydrate kinases, C-terminal domain', 198, NULL, 'FGGY_C', 268374),
(449281, 'PF14273', NULL, 'Domain of unknown function (DUF4360)', 178, NULL, 'DUF4360', 268375),
(449282, 'PF08522', NULL, 'Domain of unknown function (DUF1735)', 123, NULL, 'DUF1735', 268376),
(449283, 'PF05011', NULL, 'Lariat debranching enzyme, C-terminal domain', 137, NULL, 'DBR1', 268377),
(449284, 'PF12186', NULL, 'Acyl-CoA dehydrogenase C terminal', 111, NULL, 'AcylCoA_dehyd_C', 268378),
(449285, 'PF17648', NULL, 'Family of unknown function (DUF5519)', 97, NULL, 'DUF5519', 268379),
(449286, 'PF07575', NULL, 'Nup85 Nucleoporin', 568, NULL, 'Nucleopor_Nup85', 268380);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(449287, 'PF04726', NULL, 'Microvirus J protein', 37, NULL, 'Microvir_J', 268381),
(449288, 'PF04882', NULL, 'Peroxin-3', 476, NULL, 'Peroxin-3', 268382),
(449289, 'PF09026', NULL, 'Centromere protein B dimerisation domain', 100, NULL, 'CENP-B_dimeris', 268383),
(449290, 'PF09985', NULL, 'C-terminal binding-module, SLH-like, of glucodextranase', 239, NULL, 'Glucodextran_C', 268384),
(449291, 'PF17140', NULL, 'Domain of unknown function (DUF5113)', 162, NULL, 'DUF5113', 268385),
(449292, 'PF03409', NULL, 'Transmembrane glycoprotein', 370, NULL, 'Glycoprotein', 268386),
(449293, 'PF19109', NULL, 'Family of unknown function (DUF5796)', 139, NULL, 'DUF5796', 268387),
(449294, 'PF16978', NULL, 'SAPK-interacting protein 1 (Sin1), middle CRIM domain', 139, NULL, 'CRIM', 268388),
(449295, 'PF05241', NULL, 'EXPERA (EXPanded EBP superfamily)', 115, NULL, 'EBP', 268389),
(449296, 'PF09021', NULL, 'HutP', 129, NULL, 'HutP', 268390),
(449297, 'PF04347', NULL, 'Flagellar biosynthesis protein, FliO', 89, NULL, 'FliO', 268391),
(449298, 'PF00136', NULL, 'DNA polymerase family B', 459, NULL, 'DNA_pol_B', 268392),
(449299, 'PF04846', NULL, 'Herpesvirus pp38 phosphoprotein', 63, NULL, 'Herpes_pp38', 268393),
(449300, 'PF14063', NULL, 'Protein of unknown function (DUF4254)', 144, NULL, 'DUF4254', 268394),
(449301, 'PF04092', NULL, 'SRS domain', 127, NULL, 'SAG', 268395),
(449302, 'PF18006', NULL, 'O-phosphoseryl-tRNA synthetase C-terminal domain', 31, NULL, 'SepRS_C', 268396),
(449303, 'PF09476', NULL, 'Pilus biogenesis CpaD protein (pilus_cpaD)', 200, NULL, 'Pilus_CpaD', 268397),
(449304, 'PF14146', NULL, 'Domain of unknown function (DUF4305)', 37, NULL, 'DUF4305', 268398),
(449305, 'PF06216', NULL, 'Rice tungro bacilliform virus P46 protein', 389, NULL, 'RTBV_P46', 268399),
(449306, 'PF09239', NULL, 'Topoisomerase VI B subunit, transducer', 159, NULL, 'Topo-VIb_trans', 268400),
(449307, 'PF15928', NULL, 'Domain of unknown function (DUF4746)', 300, NULL, 'DUF4746', 268401),
(449308, 'PF14704', NULL, 'Dermatopontin', 151, NULL, 'DERM', 268402),
(449309, 'PF15070', NULL, 'Putative golgin subfamily A member 2-like protein 5', 528, NULL, 'GOLGA2L5', 268403),
(449310, 'PF16767', NULL, 'Sensor domain of alginate biosynthesis sensor protein KinB', 122, NULL, 'KinB_sensor', 268404),
(449311, 'PF17319', NULL, 'Family of unknown function (DUF5362)', 94, NULL, 'DUF5362', 268405),
(449312, 'PF14948', NULL, 'RESP18 domain', 103, NULL, 'RESP18', 268406),
(449313, 'PF00127', NULL, 'Copper binding proteins, plastocyanin/azurin family', 99, NULL, 'Copper-bind', 268407),
(449314, 'PF02192', NULL, 'PI3-kinase family, p85-binding domain', 76, NULL, 'PI3K_p85B', 268408),
(449315, 'PF08191', NULL, 'LRR adjacent', 57, NULL, 'LRR_adjacent', 268409),
(449316, 'PF14430', NULL, 'Immunity protein Imm1', 126, NULL, 'Imm1', 268410),
(449317, 'PF15704', NULL, 'Mitochondrial ATP synthase subunit', 188, NULL, 'Mt_ATP_synt', 268411),
(449318, 'PF00867', NULL, 'XPG I-region', 91, NULL, 'XPG_I', 268412),
(449319, 'PF03250', NULL, 'Tropomodulin', 141, NULL, 'Tropomodulin', 268413),
(449320, 'PF09400', NULL, 'Protein of unknown function (DUF2002)', 110, NULL, 'DUF2002', 268414),
(449321, 'PF00784', NULL, 'MyTH4 domain', 108, NULL, 'MyTH4', 268415),
(449322, 'PF09641', NULL, 'Protein of unknown function (DUF2026)', 205, NULL, 'DUF2026', 268416),
(449323, 'PF11178', NULL, 'Protein of unknown function (DUF2963)', 51, NULL, 'DUF2963', 268417),
(449324, 'PF12425', NULL, 'Protein of unknown function (DUF3673)', 53, NULL, 'DUF3673', 268418),
(449325, 'PF08328', NULL, 'Adenylosuccinate lyase C-terminal', 115, NULL, 'ASL_C', 268419),
(449326, 'PF09266', NULL, 'Viral DNA topoisomerase I, N-terminal', 58, NULL, 'VirDNA-topo-I_N', 268420),
(449327, 'PF11547', NULL, 'E3 ubiquitin ligase EDD', 52, NULL, 'E3_UbLigase_EDD', 268421),
(449328, 'PF08788', NULL, 'NHR2 domain like', 67, NULL, 'NHR2', 268422),
(449329, 'PF19483', NULL, 'Family of unknown function (DUF6019)', 63, NULL, 'DUF6019', 268423),
(449330, 'PF10457', NULL, 'Cholesterol-capturing domain', 179, NULL, 'MENTAL', 268424);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(449331, 'PF05818', NULL, 'Enterobacterial TraT complement resistance protein', 214, NULL, 'TraT', 268425),
(449332, 'PF05843', NULL, 'Suppressor of forked protein (Suf)', 296, NULL, 'Suf', 268426),
(449333, 'PF17669', NULL, 'Family of unknown function (DUF5529)', 185, NULL, 'DUF5529', 268427),
(449334, 'PF00627', NULL, 'UBA/TS-N domain', 37, NULL, 'UBA', 268428),
(449335, 'PF19973', NULL, 'Ternary complex associated domain 7', 107, NULL, 'TCAD7', 268429),
(449336, 'PF03868', NULL, 'Ribosomal protein L6, N-terminal domain', 60, NULL, 'Ribosomal_L6e_N', 268430),
(449337, 'PF18052', NULL, 'Rx N-terminal domain', 93, NULL, 'Rx_N', 268431),
(449338, 'PF04256', NULL, 'Protein of unknown function (DUF434)', 56, NULL, 'DUF434', 268432),
(449339, 'PF19282', NULL, 'Exportin-T', 687, NULL, 'Exportin-T', 268433),
(449340, 'PF12312', NULL, 'Nepovirus subgroup A polyprotein', 258, NULL, 'NeA_P2', 268434),
(449341, 'PF05253', NULL, 'U11-48K-like CHHC zinc finger', 25, NULL, 'zf-U11-48K', 268435),
(449342, 'PF01507', NULL, 'Phosphoadenosine phosphosulfate reductase family', 174, NULL, 'PAPS_reduct', 268436),
(449343, 'PF15089', NULL, 'Domain of unknown function (DUF4552)', 425, NULL, 'DUF4552', 268437),
(449344, 'PF07607', NULL, 'Protein of unknown function (DUF1570)', 129, NULL, 'DUF1570', 268438),
(449345, 'PF08058', NULL, 'Nuclear pore complex component', 130, NULL, 'NPCC', 268439),
(449346, 'PF20296', NULL, 'Methylase-associated X1', 110, NULL, 'MTaX1', 268440),
(449347, 'PF00795', NULL, 'Carbon-nitrogen hydrolase', 261, NULL, 'CN_hydrolase', 268441),
(449348, 'PF12066', NULL, 'SERRATE/Ars2, N-terminal domain', 110, NULL, 'SERRATE_Ars2_N', 268442),
(449349, 'PF20556', NULL, 'Family of unknown function (DUF6768)', 123, NULL, 'DUF6768', 268443),
(449350, 'PF04500', NULL, 'FLYWCH zinc finger domain', 62, NULL, 'FLYWCH', 268444),
(449351, 'PF16894', NULL, 'Domain of unknown function (DUF5084)', 130, NULL, 'DUF5084', 268445),
(449352, 'PF00033', NULL, 'Cytochrome b/b6/petB', 189, NULL, 'Cytochrome_B', 268446),
(449353, 'PF12346', NULL, 'Holliday junction recognition protein-associated repeat', 115, NULL, 'HJURP_mid', 268447),
(449354, 'PF05749', NULL, 'Rubella membrane glycoprotein E2', 267, NULL, 'Rubella_E2', 268448),
(449355, 'PF13812', NULL, 'Pentatricopeptide repeat domain', 63, NULL, 'PPR_3', 268449),
(449356, 'PF18116', NULL, 'Sorting Nexin 17 FERM C-terminal domain', 109, NULL, 'SNX17_FERM_C', 268450),
(449357, 'PF03925', NULL, 'SeqA protein C-terminal domain', 111, NULL, 'SeqA', 268451),
(449358, 'PF11746', NULL, 'Domain of unknown function (DUF3303)', 92, NULL, 'DUF3303', 268452),
(449359, 'PF09406', NULL, 'Protein of unknown function (DUF2004)', 106, NULL, 'DUF2004', 268453),
(449360, 'PF09774', NULL, 'Intermembrane space protein MIX23', 160, NULL, 'MIX23', 268454),
(449361, 'PF16697', NULL, 'Inner membrane component of T3SS, cytoplasmic domain', 94, NULL, 'Yop-YscD_cpl', 268455),
(449362, 'PF09569', NULL, 'ScaI restriction endonuclease', 192, NULL, 'RE_ScaI', 268456),
(449363, 'PF07259', NULL, 'ProSAAS precursor', 269, NULL, 'ProSAAS', 268457),
(449364, 'PF12784', NULL, 'PD-(D/E)XK nuclease family transposase', 229, NULL, 'PDDEXK_2', 268458),
(449365, 'PF01827', NULL, 'FTH domain', 141, NULL, 'FTH', 268459),
(449366, 'PF03898', NULL, 'Satellite tobacco necrosis virus coat protein', 198, NULL, 'TNV_CP', 268460),
(449367, 'PF05861', NULL, 'Bacterial phosphonate metabolism protein (PhnI)', 346, NULL, 'PhnI', 268461),
(449368, 'PF10957', NULL, 'Sporulation protein Cse60', 60, NULL, 'Spore_Cse60', 268462),
(449369, 'PF01312', NULL, 'FlhB HrpN YscU SpaS Family', 330, NULL, 'Bac_export_2', 268463),
(449370, 'PF01536', NULL, 'Adenosylmethionine decarboxylase', 354, NULL, 'SAM_decarbox', 268464),
(449371, 'PF02492', NULL, 'CobW/HypB/UreG, nucleotide-binding domain', 179, NULL, 'cobW', 268465),
(449372, 'PF05958', NULL, 'tRNA (Uracil-5-)-methyltransferase', 352, NULL, 'tRNA_U5-meth_tr', 268466),
(449373, 'PF00326', NULL, 'Prolyl oligopeptidase family', 212, NULL, 'Peptidase_S9', 268467),
(449374, 'PF18009', NULL, '4Fe-4S iron-sulfur cluster binding domain', 82, NULL, 'Fer4_23', 268468);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(449375, 'PF20544', NULL, 'Family of unknown function (DUF6758)', 208, NULL, 'DUF6758', 268469),
(449376, 'PF07032', NULL, 'Protein of unknown function (DUF1322)', 73, NULL, 'DUF1322', 268470),
(449377, 'PF16417', NULL, 'CCR4-NOT transcription complex subunit 1 TTP binding domain', 189, NULL, 'CNOT1_TTP_bind', 268471),
(449378, 'PF20527', NULL, 'Domain of unknown function (DUF6742)', 43, NULL, 'DUF6742', 268472),
(449379, 'PF00182', NULL, 'Chitinase class I', 232, NULL, 'Glyco_hydro_19', 268473),
(449380, 'PF07239', NULL, 'Outer membrane protein OpcA', 250, NULL, 'OpcA', 268474),
(449381, 'PF14105', NULL, 'Domain of unknown function (DUF4278)', 56, NULL, 'DUF4278', 268475),
(449382, 'PF09981', NULL, 'Uncharacterized protein conserved in bacteria (DUF2218)', 88, NULL, 'DUF2218', 268476),
(449383, 'PF00768', NULL, 'D-alanyl-D-alanine carboxypeptidase', 239, NULL, 'Peptidase_S11', 268477),
(449384, 'PF07892', NULL, 'Protein of unknown function (DUF1667)', 82, NULL, 'DUF1667', 268478),
(449385, 'PF19326', NULL, 'AMP deaminase', 633, NULL, 'AMP_deaminase', 268479),
(449386, 'PF01851', NULL, 'Proteasome/cyclosome repeat', 35, NULL, 'PC_rep', 268480),
(449387, 'PF19268', NULL, 'Contractile injection system tape measure protein', 459, NULL, 'CIS_TMP', 268481),
(449388, 'PF06805', NULL, 'Bacteriophage lambda tail assembly protein I', 86, NULL, 'Lambda_tail_I', 268482),
(449389, 'PF16399', NULL, 'Intron-binding protein aquarius N-terminus', 798, NULL, 'Aquarius_N', 268483),
(449390, 'PF04850', NULL, 'Baculovirus E66 occlusion-derived virus envelope protein', 387, NULL, 'Baculo_E66', 268484),
(449391, 'PF07568', NULL, 'Histidine kinase', 76, NULL, 'HisKA_2', 268485),
(449392, 'PF10876', NULL, 'Phage tail assembly chaperone protein, TAC', 133, NULL, 'Phage_TAC_9', 268486),
(449393, 'PF00233', NULL, '3''5''-cyclic nucleotide phosphodiesterase', 238, NULL, 'PDEase_I', 268487),
(449394, 'PF15385', NULL, 'Specifically androgen-regulated gene protein', 568, NULL, 'SARG', 268488),
(449395, 'PF06907', NULL, 'Latexin', 217, NULL, 'Latexin', 268489),
(449396, 'PF15667', NULL, 'Protein of unknown function with motif GDWWSH', 249, NULL, 'GDWWSH', 268490),
(449397, 'PF03396', NULL, 'Poxvirus DNA-directed RNA polymerase, 35 kD subunit', 293, NULL, 'Pox_RNA_pol_35', 268491),
(449398, 'PF17339', NULL, 'PH domain', 107, NULL, 'PH_15', 268492),
(449399, 'PF10712', NULL, 'NAD-specific glutamate dehydrogenase', 576, NULL, 'NAD-GH', 268493),
(449400, 'PF13516', NULL, 'Leucine Rich repeat', 24, NULL, 'LRR_6', 268494),
(449401, 'PF17676', NULL, 'LD-carboxypeptidase C-terminal domain', 123, NULL, 'Peptidase_S66C', 268495),
(449402, 'PF04876', NULL, 'Tenuivirus major non-capsid protein', 173, NULL, 'Tenui_NCP', 268496),
(449403, 'PF05201', NULL, 'Glutamyl-tRNAGlu reductase, N-terminal domain', 146, NULL, 'GlutR_N', 268497),
(449404, 'PF00186', NULL, 'Dihydrofolate reductase', 160, NULL, 'DHFR_1', 268498),
(449405, 'PF12527', NULL, 'Protein of unknown function (DUF3727)', 97, NULL, 'DUF3727', 268499),
(449406, 'PF09118', NULL, 'Galactose oxidase-like, Early set domain', 98, NULL, 'GO-like_E_set', 268500),
(449407, 'PF16646', NULL, 'Axin-1 tankyrase binding domain', 72, NULL, 'AXIN1_TNKS_BD', 268501),
(449408, 'PF12962', NULL, 'Protein of unknown function (DUF3851)', 126, NULL, 'DUF3851', 268502),
(449409, 'PF08677', NULL, 'GP11 baseplate wedge protein', 227, NULL, 'GP11', 268503),
(449410, 'PF03990', NULL, 'G5-linked-Ubiquitin-like domain', 41, NULL, 'DUF348', 268504),
(449411, 'PF13456', NULL, 'Reverse transcriptase-like', 124, NULL, 'RVT_3', 268505),
(449412, 'PF13632', NULL, 'Glycosyl transferase family group 2', 194, NULL, 'Glyco_trans_2_3', 268506),
(449413, 'PF08494', NULL, 'DEAD/H associated', 191, NULL, 'DEAD_assoc', 268507),
(449414, 'PF05190', NULL, 'MutS family domain IV', 92, NULL, 'MutS_IV', 268508),
(449415, 'PF12251', NULL, 'snRNA-activating protein complex (SNAPc), subunit 3', 200, NULL, 'SNAPC3', 268509),
(449416, 'PF14346', NULL, 'Domain of unknown function (DUF4398)', 78, NULL, 'DUF4398', 268510),
(449417, 'PF06627', NULL, 'Protein of unknown function (DUF1153)', 87, NULL, 'DUF1153', 268511);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(449418, 'PF17941', NULL, 'Polyphosphate kinase C-terminal domain 1', 167, NULL, 'PP_kinase_C_1', 268512),
(449419, 'PF15868', NULL, 'Transcription activator MBF2', 90, NULL, 'MBF2', 268513),
(449420, 'PF17882', NULL, 'OAA-family lectin sugar binding domain', 77, NULL, 'SBD', 268514),
(449421, 'PF20506', NULL, 'Family of unknown function (DUF6732)', 72, NULL, 'DUF6732', 268515),
(449422, 'PF08850', NULL, 'Domain of unknown function (DUF1820)', 97, NULL, 'DUF1820', 268516),
(449423, 'PF01078', NULL, 'Magnesium chelatase, subunit ChlI', 207, NULL, 'Mg_chelatase', 268517),
(449424, 'PF18799', NULL, 'Large polyvalent protein-associated domain 5', 146, NULL, 'LPD5', 268518),
(449425, 'PF13303', NULL, 'Phosphotransferase system, EIIC', 331, NULL, 'PTS_EIIC_2', 268519),
(449426, 'PF15833', NULL, 'Domain of unknown function (DUF4714)', 149, NULL, 'DUF4714', 268520),
(449427, 'PF12790', NULL, 'Type VI secretion lipoprotein, VasD, EvfM, TssJ, VC_A0113', 120, NULL, 'T6SS-SciN', 268521),
(449428, 'PF12802', NULL, 'MarR family', 61, NULL, 'MarR_2', 268522),
(449429, 'PF07571', NULL, 'TAF6 C-terminal HEAT repeat domain', 90, NULL, 'TAF6_C', 268523),
(449430, 'PF17830', NULL, 'STI1 domain', 55, NULL, 'STI1', 268524),
(449431, 'PF09903', NULL, 'Uncharacterized protein conserved in bacteria (DUF2130)', 255, NULL, 'DUF2130', 268525),
(449432, 'PF17623', NULL, 'Domain of unknown function', 277, NULL, 'B277', 268526),
(449433, 'PF17636', NULL, 'Viral Unique Long protein 21a', 123, NULL, 'UL21a', 268527),
(449434, 'PF00610', NULL, 'Domain found in Dishevelled, Egl-10, and Pleckstrin (DEP)', 72, NULL, 'DEP', 268528),
(449435, 'PF07994', NULL, 'Myo-inositol-1-phosphate synthase', 322, NULL, 'NAD_binding_5', 268529),
(449436, 'PF02780', NULL, 'Transketolase, C-terminal domain', 124, NULL, 'Transketolase_C', 268530),
(449437, 'PF09980', NULL, 'Predicted membrane protein (DUF2214)', 147, NULL, 'DUF2214', 268531),
(449438, 'PF10324', NULL, 'Serpentine type 7TM GPCR chemoreceptor Srw', 319, NULL, '7TM_GPCR_Srw', 268532),
(449439, 'PF08502', NULL, 'LeuA allosteric (dimerisation) domain', 133, NULL, 'LeuA_dimer', 268533),
(449440, 'PF03072', NULL, 'Domain of unknown function (DUF237)', 138, NULL, 'DUF237', 268534),
(449441, 'PF06346', NULL, 'Formin Homology Region 1', 157, NULL, 'Drf_FH1', 268535),
(449442, 'PF03819', NULL, 'MazG nucleotide pyrophosphohydrolase domain', 74, NULL, 'MazG', 268536),
(449443, 'PF11761', NULL, 'Cobalamin biosynthesis central region', 84, NULL, 'CbiG_mid', 268537),
(449444, 'PF20123', NULL, 'Family of unknown function (DUF6513)', 86, NULL, 'DUF6513', 268538),
(449445, 'PF11884', NULL, 'Domain of unknown function (DUF3404)', 259, NULL, 'DUF3404', 268539),
(449446, 'PF02306', NULL, 'Major spike protein (G protein)', 175, NULL, 'Phage_G', 268540),
(449447, 'PF03993', NULL, 'Domain of Unknown Function (DUF349)', 75, NULL, 'DUF349', 268541),
(449448, 'PF18457', NULL, 'Up-Regulated in long-lived daf-2', 176, NULL, 'PUD1_2', 268542),
(449449, 'PF18935', NULL, 'Family of unknown function (DUF5683)', 151, NULL, 'DUF5683', 268543),
(449450, 'PF09458', NULL, 'H-type lectin domain', 67, NULL, 'H_lectin', 268544),
(449451, 'PF15175', NULL, 'Spermatogenesis-associated protein 24', 182, NULL, 'SPATA24', 268545),
(449452, 'PF10927', NULL, 'Protein of unknown function (DUF2738)', 236, NULL, 'DUF2738', 268546),
(449453, 'PF02706', NULL, 'Chain length determinant protein', 92, NULL, 'Wzz', 268547),
(449454, 'PF04055', NULL, 'Radical SAM superfamily', 167, NULL, 'Radical_SAM', 268548),
(449455, 'PF10665', NULL, 'Minor capsid protein', 105, NULL, 'Minor_capsid_1', 268549),
(449456, 'PF01716', NULL, 'Manganese-stabilising protein / photosystem II polypeptide', 242, NULL, 'MSP', 268550),
(449457, 'PF13990', NULL, 'YjcZ-like protein', 272, NULL, 'YjcZ', 268551),
(449458, 'PF11648', NULL, 'C-terminal domain of RIG-I', 117, NULL, 'RIG-I_C-RD', 268552),
(449459, 'PF14768', NULL, 'Replication protein A interacting C-terminal', 81, NULL, 'RPA_interact_C', 268553),
(449460, 'PF19536', NULL, 'POU domain, class 2, transcription factor 1 C-terminal', 284, NULL, 'POU2F1_C', 268554);
INSERT INTO "PUBLIC"."MODEL" VALUES
(449461, 'PF08394', NULL, 'Archaeal TRASH domain', 37, NULL, 'Arc_trans_TRASH', 268555),
(449462, 'PF04640', NULL, 'PLATZ transcription factor', 82, NULL, 'PLATZ', 268556),
(449463, 'PF11807', NULL, 'Mycotoxin biosynthesis protein UstYa', 220, NULL, 'UstYa', 268557),
(449464, 'PF15832', NULL, 'FAM27 D and E protein family', 92, NULL, 'FAM27', 268558),
(449465, 'PF16342', NULL, 'Domain of unknown function (DUF4972)', 128, NULL, 'DUF4972', 268559),
(449466, 'PF14580', NULL, 'Leucine-rich repeat', 175, NULL, 'LRR_9', 268560),
(449467, 'PF01576', NULL, 'Myosin tail', 1081, NULL, 'Myosin_tail_1', 268561),
(449468, 'PF01632', NULL, 'Ribosomal protein L35', 61, NULL, 'Ribosomal_L35p', 268562),
(449469, 'PF20393', NULL, 'Putative carbonic anhydrase', 125, NULL, 'Pro_CA_2', 268563),
(449470, 'PF19673', NULL, 'Family of unknown function (DUF6176)', 110, NULL, 'DUF6176', 268564),
(449471, 'PF20034', NULL, 'Peptidase S80 family', 245, NULL, 'Peptidase_S80', 268565),
(449472, 'PF15979', NULL, 'Glycosyl hydrolase family 115', 339, NULL, 'Glyco_hydro_115', 268566),
(449473, 'PF02624', NULL, 'YcaO cyclodehydratase, ATP-ad Mg2+-binding', 322, NULL, 'YcaO', 268567),
(449474, 'PF11817', NULL, 'Foie gras liver health family 1', 259, NULL, 'Foie-gras_1', 268568),
(449475, 'PF13810', NULL, 'Domain of unknown function (DUF4185)', 316, NULL, 'DUF4185', 268569),
(449476, 'PF16067', NULL, 'Domain of unknown function (DUF4809)', 130, NULL, 'DUF4809', 268570),
(449477, 'PF05388', NULL, 'Carboxypeptidase Y pro-peptide', 127, NULL, 'Carbpep_Y_N', 268571),
(449478, 'PF03460', NULL, 'Nitrite/Sulfite reductase ferredoxin-like half domain', 69, NULL, 'NIR_SIR_ferr', 268572),
(449479, 'PF12296', NULL, 'Hydrophobic surface binding protein A', 121, NULL, 'HsbA', 268573),
(449480, 'PF06668', NULL, 'Inter-alpha-trypsin inhibitor heavy chain C-terminus', 189, NULL, 'ITI_HC_C', 268574),
(449481, 'PF04463', NULL, '2-thiouracil desulfurase', 137, NULL, '2-thiour_desulf', 268575),
(449482, 'PF05423', NULL, 'Mycobacterium membrane protein', 139, NULL, 'Mycobact_memb', 268576),
(449483, 'PF07583', NULL, 'Protein of unknown function (DUF1549)', 209, NULL, 'PSCyt2', 268577),
(449484, 'PF11378', NULL, 'Protein of unknown function (DUF3181)', 90, NULL, 'DUF3181', 268578),
(449485, 'PF16687', NULL, 'beta-propeller of ELYS nucleoporin', 489, NULL, 'ELYS-bb', 268579),
(449486, 'PF10901', NULL, 'Protein of unknown function (DUF2690)', 93, NULL, 'DUF2690', 268580),
(449487, 'PF06322', NULL, 'Phage NinH protein', 60, NULL, 'Phage_NinH', 268581),
(449488, 'PF03024', NULL, 'Folate receptor family', 172, NULL, 'Folate_rec', 268582),
(449489, 'PF14847', NULL, 'Ras-binding domain of Byr2', 100, NULL, 'Ras_bdg_2', 268583),
(449490, 'PF13829', NULL, 'Domain of unknown function (DUF4191)', 219, NULL, 'DUF4191', 268584),
(449491, 'PF08275', NULL, 'DNA primase catalytic core, N-terminal domain', 128, NULL, 'Toprim_N', 268585),
(449492, 'PF08251', NULL, 'Mastoparan peptide', 14, NULL, 'Mastoparan_2', 268586),
(449493, 'PF17451', NULL, 'Glycosyl hydrolase 101 beta sandwich domain', 132, NULL, 'Glyco_hyd_101C', 268587),
(449494, 'PF02744', NULL, 'Galactose-1-phosphate uridyl transferase, C-terminal domain', 167, NULL, 'GalP_UDP_tr_C', 268588),
(449495, 'PF14388', NULL, 'Domain of unknown function (DUF4419)', 304, NULL, 'DUF4419', 268589),
(449496, 'PF19738', NULL, 'Family of unknown function (DUF6227)', 227, NULL, 'DUF6227', 268590),
(449497, 'PF20163', NULL, 'Family of unknown function (DUF6536)', 153, NULL, 'DUF6536', 268591),
(449498, 'PF20582', NULL, 'UPF0758 N-terminal', 78, NULL, 'UPF0758_N', 268592),
(449499, 'PF20510', NULL, 'Homogentisate 1,2-dioxygenase N-terminal', 273, NULL, 'HgmA_N', 268593),
(449500, 'PF20600', NULL, 'Exodeoxyribonuclease X-like C-terminal', 30, NULL, 'ExoX-like_C', 268594),
(449501, 'PF05494', NULL, 'MlaC protein', 166, NULL, 'MlaC', 268595),
(449502, 'PF09044', NULL, 'Kp4', 125, NULL, 'Kp4', 268596),
(449503, 'PF02691', NULL, 'Vacuolating cyotoxin', 981, NULL, 'VacA', 268597),
(449504, 'PF14545', NULL, 'Dof, BCAP, and BANK (DBB) motif,', 139, NULL, 'DBB', 268598);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(449505, 'PF20523', NULL, 'Domain of unknown function (DUF6738)', 85, NULL, 'DUF6738', 268599),
(449506, 'PF02234', NULL, 'Cyclin-dependent kinase inhibitor', 49, NULL, 'CDI', 268600),
(449507, 'PF11637', NULL, 'UvsW.1 domain', 56, NULL, 'UvsW-1', 268601),
(449508, 'PF03736', NULL, 'EPTP domain', 43, NULL, 'EPTP', 268602),
(449509, 'PF19944', NULL, 'Family of unknown function (DUF6406)', 84, NULL, 'DUF6406', 268603),
(449510, 'PF02941', NULL, 'Ferredoxin thioredoxin reductase variable alpha chain', 68, NULL, 'FeThRed_A', 268604),
(449511, 'PF19972', NULL, 'Ternary complex associated domain 3', 48, NULL, 'TCAD3', 268605),
(449512, 'PF18366', NULL, 'Zic proteins zinc finger domain', 46, NULL, 'zf_ZIC', 268606),
(449513, 'PF19185', NULL, 'Family of unknown function (DUF5867)', 274, NULL, 'DUF5867', 268607),
(449514, 'PF02329', NULL, 'Histidine carboxylase PI chain', 295, NULL, 'HDC', 268608),
(449515, 'PF06160', NULL, 'Septation ring formation regulator, EzrA', 557, NULL, 'EzrA', 268609),
(449516, 'PF01440', NULL, 'Geminivirus AL2 protein', 128, NULL, 'Gemini_AL2', 268610),
(449517, 'PF15467', NULL, 'Secretogranin-3', 449, NULL, 'SGIII', 268611),
(449518, 'PF13435', NULL, 'Cytochrome c554 and c-prime', 84, NULL, 'Cytochrome_C554', 268612),
(449519, 'PF12349', NULL, 'Sterol-sensing domain of SREBP cleavage-activation', 153, NULL, 'Sterol-sensing', 268613),
(449520, 'PF06179', NULL, 'Surfeit locus protein 5 subunit 22 of Mediator complex', 105, NULL, 'Med22', 268614),
(449521, 'PF12005', NULL, 'Protein of unknown function (DUF3499)', 124, NULL, 'DUF3499', 268615),
(449522, 'PF13053', NULL, 'Protein of unknown function (DUF3914)', 89, NULL, 'DUF3914', 268616),
(449523, 'PF09290', NULL, 'Prokaryotic acetaldehyde dehydrogenase, dimerisation', 138, NULL, 'AcetDehyd-dimer', 268617),
(449524, 'PF01035', NULL, '6-O-methylguanine DNA methyltransferase, DNA binding domain', 81, NULL, 'DNA_binding_1', 268618),
(449525, 'PF15125', NULL, 'TMEM238 protein family', 64, NULL, 'TMEM238', 268619),
(449526, 'PF12453', NULL, 'Protein tyrosine phosphatase N terminal', 26, NULL, 'PTP_N', 268620),
(449527, 'PF16827', NULL, 'zinc-finger', 67, NULL, 'zf-HC3', 268621),
(449528, 'PF19966', NULL, 'vWA-MoxR associated protein middle region (VMAP-M) 4', 107, NULL, 'VMAP-M4', 268622),
(449529, 'PF19205', NULL, 'Family of unknown function (DUF5877)', 611, NULL, 'DUF5877', 268623),
(449530, 'PF05978', NULL, 'Ion channel regulatory protein UNC-93', 379, NULL, 'UNC-93', 268624),
(449531, 'PF10225', NULL, 'NEMP family', 249, NULL, 'NEMP', 268625),
(449532, 'PF11179', NULL, 'Protein of unknown function (DUF2967)', 880, NULL, 'DUF2967', 268626),
(449533, 'PF00268', NULL, 'Ribonucleotide reductase, small chain', 280, NULL, 'Ribonuc_red_sm', 268627),
(449534, 'PF17545', NULL, 'Family of unknown function (DUF5461)', 93, NULL, 'DUF5461', 268628),
(449535, 'PF16400', NULL, 'Domain of unknown function (DUF5008)', 109, NULL, 'DUF5008', 268629),
(449536, 'PF10001', NULL, 'Uncharacterized protein conserved in bacteria (DUF2242)', 121, NULL, 'DUF2242', 268630),
(449537, 'PF07603', NULL, 'Protein of unknown function (DUF1566)', 116, NULL, 'DUF1566', 268631),
(449538, 'PF10776', NULL, 'Protein of unknown function (DUF2600)', 328, NULL, 'DUF2600', 268632),
(449539, 'PF18054', NULL, 'CEL-III C-terminal', 154, NULL, 'CEL_III_C', 268633),
(449540, 'PF10037', NULL, 'Mitochondrial 28S ribosomal protein S27', 393, NULL, 'MRP-S27', 268634),
(449541, 'PF00019', NULL, 'Transforming growth factor beta like domain', 102, NULL, 'TGF_beta', 268635),
(449542, 'PF14993', NULL, 'Neuropeptide S precursor protein', 65, NULL, 'Neuropeptide_S', 268636),
(449543, 'PF18099', NULL, 'DUF5010 C-terminal domain', 112, NULL, 'DUF5010_C', 268637),
(449544, 'PF15562', NULL, 'Immunity protein 17', 61, NULL, 'Imm17', 268638),
(449545, 'PF12994', NULL, 'Domain of unknown function, E. rectale Gene description (DUF3878)', 300, NULL, 'DUF3878', 268639),
(449546, 'PF18969', NULL, 'Family of unknown function (DUF5708)', 60, NULL, 'DUF5708', 268640),
(449547, 'PF01655', NULL, 'Ribosomal protein L32', 108, NULL, 'Ribosomal_L32e', 268641); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(449548, 'PF16912', NULL, 'Glucose dehydrogenase C-terminus', 212, NULL, 'Glu_dehyd_C', 268642),
(449549, 'PF12147', NULL, 'Putative methyltransferase', 309, NULL, 'Methyltransf_20', 268643),
(449550, 'PF10771', NULL, 'Winged helix-turn-helix domain (DUF2582)', 65, NULL, 'DUF2582', 268644),
(449551, 'PF11203', NULL, 'Putative type VII ESX secretion system translocon, EccE', 97, NULL, 'EccE', 268645),
(449552, 'PF18951', NULL, 'Family of unknown function (DUF5695)', 857, NULL, 'DUF5695', 268646),
(449553, 'PF00690', NULL, 'Cation transporter/ATPase, N-terminus', 69, NULL, 'Cation_ATPase_N', 268647),
(449554, 'PF02793', NULL, 'Hormone receptor domain', 65, NULL, 'HRM', 268648),
(449555, 'PF02948', NULL, 'Amelogenin', 175, NULL, 'Amelogenin', 268649),
(449556, 'PF19700', NULL, 'Family of unknown function (DUF6198)', 217, NULL, 'DUF6198', 268650),
(449557, 'PF19266', NULL, 'Contractile injection system tube protein', 162, NULL, 'CIS_tube', 268651),
(449558, 'PF04234', NULL, 'CopC domain', 92, NULL, 'CopC', 268652),
(449559, 'PF04698', NULL, 'Rab effector MyRIP/melanophilin C-terminus', 717, NULL, 'Rab_eff_C', 268653),
(449560, 'PF04540', NULL, 'Herpesvirus UL51 protein', 158, NULL, 'Herpes_UL51', 268654),
(449561, 'PF02779', NULL, 'Transketolase, pyrimidine binding domain', 178, NULL, 'Transket_pyr', 268655),
(449562, 'PF05754', NULL, 'Domain of unknown function (DUF834)', 52, NULL, 'DUF834', 268656),
(449563, 'PF12390', NULL, 'Selenocysteine synthase N terminal', 40, NULL, 'Se-cys_synth_N', 268657),
(449564, 'PF09366', NULL, 'Protein of unknown function (DUF1997)', 155, NULL, 'DUF1997', 268658),
(449565, 'PF07669', NULL, 'Eco57I restriction-modification methylase', 106, NULL, 'Eco57I', 268659),
(449566, 'PF06514', NULL, 'Photosystem II 12 kDa extrinsic protein (PsbU)', 93, NULL, 'PsbU', 268660),
(449567, 'PF18598', NULL, 'Tetracyclin repressor-like, C-terminal domain', 111, NULL, 'TetR_C_36', 268661),
(449568, 'PF20116', NULL, 'Family of unknown function (DUF6506)', 96, NULL, 'DUF6506', 268662),
(449569, 'PF08006', NULL, 'Protein of unknown function (DUF1700)', 181, NULL, 'DUF1700', 268663),
(449570, 'PF05300', NULL, 'MICOS complex subunit MIC19/MIC25', 233, NULL, 'MIC19_MIC25', 268664),
(449571, 'PF08862', NULL, 'Domain of unknown function DUF1829', 87, NULL, 'DUF1829', 268665),
(449572, 'PF17976', NULL, 'RING/Ubox like zinc-binding domain', 73, NULL, 'zf-RING_12', 268666),
(449573, 'PF16561', NULL, 'Glycogen recognition site of AMP-activated protein kinase', 85, NULL, 'AMPK1_CBM', 268667),
(449574, 'PF02312', NULL, 'Core binding factor beta subunit', 168, NULL, 'CBF_beta', 268668),
(449575, 'PF15743', NULL, 'Spermatogenesis-associated C-terminus', 152, NULL, 'SPATA1_C', 268669),
(449576, 'PF18499', NULL, 'Ubc7p-binding region of Cue1', 52, NULL, 'Cue1_U7BR', 268670),
(449577, 'PF03716', NULL, 'WCCH motif', 25, NULL, 'WCCH', 268671),
(449578, 'PF15742', NULL, 'Domain of unknown function (DUF4686)', 384, NULL, 'DUF4686', 268672),
(449579, 'PF18518', NULL, 'TcA receptor binding domain', 131, NULL, 'TcA_RBD', 268673),
(449580, 'PF06387', NULL, 'D1 dopamine receptor-interacting protein (calcyon)', 181, NULL, 'Calcyon', 268674),
(449581, 'PF11864', NULL, 'Domain of unknown function (DUF3384)', 481, NULL, 'DUF3384', 268675),
(449582, 'PF18674', NULL, 'TarS beta-glycosyltransferase C-terminal domain 1', 148, NULL, 'TarS_C1', 268676),
(449583, 'PF18538', NULL, 'Domain of unknown function (DUF5624)', 130, NULL, 'DUF5624', 268677),
(449584, 'PF08158', NULL, 'NUC130/3NT domain', 52, NULL, 'NUC130_3NT', 268678),
(449585, 'PF19059', NULL, 'Family of unknown function (DUF5755)', 92, NULL, 'DUF5755', 268679),
(449586, 'PF14494', NULL, 'Domain of unknown function (DUF4436)', 255, NULL, 'DUF4436', 268680),
(449587, 'PF11619', NULL, 'Transcription factor P53 - C terminal domain', 67, NULL, 'P53_C', 268681),
(449588, 'PF07931', NULL, 'Chloramphenicol phosphotransferase-like protein', 172, NULL, 'CPT', 268682),
(449589, 'PF10705', NULL, 'Chloroplast protein precursor Ycf15 putative', 86, NULL, 'Ycf15', 268683);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(449590, 'PF00782', NULL, 'Dual specificity phosphatase, catalytic domain', 133, NULL, 'DSPc', 268684),
(449591, 'PF01845', NULL, 'CcdB protein', 100, NULL, 'CcdB', 268685),
(449592, 'PF10156', NULL, 'Subunit 17 of Mediator complex', 461, NULL, 'Med17', 268686),
(449593, 'PF01625', NULL, 'Peptide methionine sulfoxide reductase', 153, NULL, 'PMSR', 268687),
(449594, 'PF08506', NULL, 'Cse1', 370, NULL, 'Cse1', 268688),
(449595, 'PF17784', NULL, 'Sulfotransferase domain', 216, NULL, 'Sulfotransfer_4', 268689),
(449596, 'PF18435', NULL, 'Esterase Ig-like N-terminal domain', 122, NULL, 'EstA_Ig_like', 268690),
(449597, 'PF19563', NULL, 'Family of unknown function (DUF6085)', 115, NULL, 'DUF6085', 268691),
(449598, 'PF05597', NULL, 'Poly(hydroxyalcanoate) granule associated protein (phasin)', 126, NULL, 'Phasin', 268692),
(449599, 'PF07283', NULL, 'Conjugal transfer protein TrbH', 126, NULL, 'TrbH', 268693),
(449600, 'PF10375', NULL, 'GRAB domain', 49, NULL, 'GRAB', 268694),
(449601, 'PF00026', NULL, 'Eukaryotic aspartyl protease', 315, NULL, 'Asp', 268695),
(449602, 'PF06989', NULL, 'BAALC N-terminus', 50, NULL, 'BAALC_N', 268696),
(449603, 'PF10367', NULL, 'Vacuolar sorting protein 39 domain 2', 109, NULL, 'Vps39_2', 268697),
(449604, 'PF03142', NULL, 'Chitin synthase', 527, NULL, 'Chitin_synth_2', 268698),
(449605, 'PF11117', NULL, 'Protein of unknown function (DUF2626)', 74, NULL, 'DUF2626', 268699),
(449606, 'PF01429', NULL, 'Methyl-CpG binding domain', 77, NULL, 'MBD', 268700),
(449607, 'PF03068', NULL, 'Protein-arginine deiminase (PAD)', 393, NULL, 'PAD', 268701),
(449608, 'PF04556', NULL, 'DpnII restriction endonuclease', 279, NULL, 'DpnII', 268702),
(449609, 'PF00562', NULL, 'RNA polymerase Rpb2, domain 6', 389, NULL, 'RNA_pol_Rpb2_6', 268703),
(449610, 'PF01687', NULL, 'Riboflavin kinase', 123, NULL, 'Flavokinase', 268704),
(449611, 'PF04355', NULL, 'SmpA / OmlA family', 71, NULL, 'SmpA_OmlA', 268705),
(449612, 'PF08039', NULL, 'Mitochondrial proteolipid', 60, NULL, 'Mit_proteolip', 268706),
(449613, 'PF08209', NULL, 'Sgf11 (transcriptional regulation protein)', 33, NULL, 'Sgf11', 268707),
(449614, 'PF18594', NULL, 'Sas6/XLF/XRCC4 coiled-coil domain', 30, NULL, 'Sas6_CC', 268708),
(449615, 'PF11783', NULL, 'Cytochrome c bacterial', 175, NULL, 'Cytochrome_cB', 268709),
(449616, 'PF17682', NULL, 'Tau95 Triple barrel domain', 127, NULL, 'Tau95_N', 268710),
(449617, 'PF19148', NULL, 'Family of unknown function (DUF5830)', 114, NULL, 'DUF5830', 268711),
(449618, 'PF13418', NULL, 'Galactose oxidase, central domain', 49, NULL, 'Kelch_4', 268712),
(449619, 'PF13043', NULL, 'Domain of unknown function (DUF3903)', 40, NULL, 'DUF3903', 268713),
(449620, 'PF03221', NULL, 'Tc5 transposase DNA-binding domain', 66, NULL, 'HTH_Tnp_Tc5', 268714),
(449621, 'PF11556', NULL, 'Erythrocyte binding antigen 175', 81, NULL, 'EBA-175_VI', 268715),
(449622, 'PF14209', NULL, 'Domain of unknown function (DUF4321)', 48, NULL, 'DUF4321', 268716),
(449623, 'PF07771', NULL, 'Tick salivary peptide group 1', 120, NULL, 'TSGP1', 268717),
(449624, 'PF03416', NULL, 'Peptidase family C54', 278, NULL, 'Peptidase_C54', 268718),
(449625, 'PF08634', NULL, 'Mitochondrial protein Pet127', 274, NULL, 'Pet127', 268719),
(449626, 'PF19343', NULL, 'Family of unknown function (DUF5923)', 630, NULL, 'DUF5923', 268720),
(449627, 'PF15965', NULL, 'TRAF-like zinc-finger', 93, NULL, 'zf-TRAF_2', 268721),
(449628, 'PF04694', NULL, 'Coronavirus ORF3 protein', 59, NULL, 'Corona_3', 268722),
(449629, 'PF12531', NULL, 'DNA-K related protein', 248, NULL, 'DUF3731', 268723),
(449630, 'PF02029', NULL, 'Caldesmon', 498, NULL, 'Caldesmon', 268724),
(449631, 'PF07894', NULL, 'FAM83 A-H', 275, NULL, 'FAM83', 268725),
(449632, 'PF12606', NULL, 'Tumour necrosis factor receptor superfamily member 19', 42, NULL, 'RELT', 268726),
(449633, 'PF06047', NULL, 'NF-kappa-B-activating protein C-terminal domain', 102, NULL, 'Nkap_C', 268727),
(449634, 'PF15443', NULL, 'Domain of unknown function (DUF4630)', 156, NULL, 'DUF4630', 268728),
(449635, 'PF10337', NULL, 'Putative ER transporter, 6TM, N-terminal', 471, NULL, 'ArAE_2_N', 268729);
INSERT INTO "PUBLIC"."MODEL" VALUES
(449636, 'PF18864', NULL, 'AbiTii', 188, NULL, 'AbiTii', 268730),
(449637, 'PF19812', NULL, 'Family of unknown function (DUF6295)', 87, NULL, 'DUF6295', 268731),
(449638, 'PF09148', NULL, 'Domain of unknown function (DUF1934)', 128, NULL, 'DUF1934', 268732),
(449639, 'PF18063', NULL, 'Beta barrel Pore-forming domain', 204, NULL, 'BB_PF', 268733),
(449640, 'PF00287', NULL, 'Sodium / potassium ATPase beta chain', 296, NULL, 'Na_K-ATPase', 268734),
(449641, 'PF08856', NULL, 'Protein of unknown function (DUF1826)', 203, NULL, 'DUF1826', 268735),
(449642, 'PF09776', NULL, 'Mitochondrial ribosomal protein L55', 116, NULL, 'Mitoc_L55', 268736),
(449643, 'PF13884', NULL, 'Chaperone of endosialidase', 58, NULL, 'Peptidase_S74', 268737),
(449644, 'PF08685', NULL, 'GON domain', 200, NULL, 'GON', 268738),
(449645, 'PF12156', NULL, 'Putative metal-binding domain of cation transport ATPase', 87, NULL, 'ATPase-cat_bd', 268739),
(449646, 'PF07157', NULL, 'DNA circularisation protein N-terminus', 88, NULL, 'DNA_circ_N', 268740),
(449647, 'PF10864', NULL, 'Protein of unknown function (DUF2663)', 127, NULL, 'DUF2663', 268741),
(449648, 'PF14447', NULL, 'Prokaryotic RING finger family 4', 46, NULL, 'Prok-RING_4', 268742),
(449649, 'PF17288', NULL, 'Terminase RNAseH like domain', 155, NULL, 'Terminase_3C', 268743),
(449650, 'PF12818', NULL, 'dsDNA viral tegument protein', 277, NULL, 'Tegument_dsDNA', 268744),
(449651, 'PF13567', NULL, 'Domain of unknown function (DUF4131)', 167, NULL, 'DUF4131', 268745),
(449652, 'PF20442', NULL, 'BREX system Lon protease-like protein BrxL N-terminal', 132, NULL, 'BrxL_N', 268746),
(449653, 'PF17255', NULL, 'EbsA-like protein', 133, NULL, 'EbsA', 268747),
(449654, 'PF13159', NULL, 'Domain of unknown function (DUF3994)', 99, NULL, 'DUF3994', 268748),
(449655, 'PF16380', NULL, 'Domain of unknown function', 142, NULL, 'DUF4990', 268749),
(449656, 'PF08589', NULL, 'Autophagy receptor ATG43', 99, NULL, 'ATG43', 268750),
(449657, 'PF00585', NULL, 'C-terminal regulatory domain of Threonine dehydratase', 91, NULL, 'Thr_dehydrat_C', 268751),
(449658, 'PF00343', NULL, 'Carbohydrate phosphorylase', 713, NULL, 'Phosphorylase', 268752),
(449659, 'PF17691', NULL, 'Contingent replication of cDNA 4', 132, NULL, 'Croc_4', 268753),
(449660, 'PF04336', NULL, 'Acyl carrier protein phosphodiesterase', 105, NULL, 'ACP_PD', 268754),
(449661, 'PF06515', NULL, 'Borna disease virus P10 protein', 87, NULL, 'BDV_P10', 268755),
(449662, 'PF03229', NULL, 'Alphavirus glycoprotein J', 126, NULL, 'Alpha_GJ', 268756),
(449663, 'PF03450', NULL, 'CO dehydrogenase flavoprotein C-terminal domain', 102, NULL, 'CO_deh_flav_C', 268757),
(449664, 'PF01599', NULL, 'Ribosomal protein S27a', 44, NULL, 'Ribosomal_S27', 268758),
(449665, 'PF01451', NULL, 'Low molecular weight phosphotyrosine protein phosphatase', 142, NULL, 'LMWPc', 268759),
(449666, 'PF14466', NULL, 'PLAT/LH2 and C2-like Ca2+-binding lipoprotein', 127, NULL, 'PLCC', 268760),
(449667, 'PF13323', NULL, 'N-terminal domain with HPIH motif', 156, NULL, 'HPIH', 268761),
(449668, 'PF16376', NULL, 'N-terminal domain of fragilysin', 144, NULL, 'fragilysinNterm', 268762),
(449669, 'PF11678', NULL, 'Protein of unknown function (DUF3274)', 286, NULL, 'DUF3274', 268763),
(449670, 'PF10795', NULL, 'Protein of unknown function (DUF2607)', 96, NULL, 'DUF2607', 268764),
(449671, 'PF19425', NULL, 'Csd3 second domain', 122, NULL, 'Csd3_N2', 268765),
(449672, 'PF02630', NULL, 'SCO1/SenC', 134, NULL, 'SCO1-SenC', 268766),
(449673, 'PF20283', NULL, 'C-terminal domain 7 of the ABC-three component (ABC-3C) systems', 126, NULL, 'CTD7', 268767),
(449674, 'PF05613', NULL, 'Human herpesvirus U15 protein', 110, NULL, 'Herpes_U15', 268768),
(449675, 'PF03619', NULL, 'Organic solute transporter Ostalpha', 243, NULL, 'Solute_trans_a', 268769),
(449676, 'PF10937', NULL, 'Ribosomal protein S36, mitochondrial', 115, NULL, 'S36_mt', 268770),
(449677, 'PF14131', NULL, 'Domain of unknown function (DUF4298)', 87, NULL, 'DUF4298', 268771),
(449678, 'PF08692', NULL, 'Mitochondrial protein Pet20', 132, NULL, 'Pet20', 268772);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(449679, 'PF01346', NULL, 'Domain amino terminal to FKBP-type peptidyl-prolyl isomerase', 97, NULL, 'FKBP_N', 268773),
(449680, 'PF11154', NULL, 'Protein of unknown function (DUF2934)', 37, NULL, 'DUF2934', 268774),
(449681, 'PF15249', NULL, 'Conserved region of unknown function on GLTSCR protein', 102, NULL, 'GLTSCR1', 268775),
(449682, 'PF01472', NULL, 'PUA domain', 74, NULL, 'PUA', 268776),
(449683, 'PF03393', NULL, 'Pneumovirus matrix protein', 252, NULL, 'Pneumo_matrix', 268777),
(449684, 'PF13452', NULL, 'N-terminal half of MaoC dehydratase', 132, NULL, 'MaoC_dehydrat_N', 268778),
(449685, 'PF16419', NULL, 'CCR4-NOT transcription complex subunit 1 HEAT repeat', 229, NULL, 'CNOT1_HEAT_N', 268779),
(449686, 'PF13368', NULL, 'Topoisomerase C-terminal repeat', 56, NULL, 'Toprim_C_rpt', 268780),
(449687, 'PF13582', NULL, 'Metallo-peptidase family M12B Reprolysin-like', 124, NULL, 'Reprolysin_3', 268781),
(449688, 'PF04699', NULL, 'ARP2/3 complex 16 kDa subunit (p16-Arc)', 150, NULL, 'P16-Arc', 268782),
(449689, 'PF13958', NULL, 'Toxin ToxN, type III toxin-antitoxin system', 159, NULL, 'ToxN_toxin', 268783),
(449690, 'PF20165', NULL, 'KBTB, W-type LIR motif', 12, NULL, 'KBTB_W-LIR', 268784),
(449691, 'PF00819', NULL, 'Myotoxin, crotamine', 43, NULL, 'Myotoxins', 268785),
(449692, 'PF08027', NULL, 'Albumin I chain b', 35, NULL, 'Albumin_I', 268786),
(449693, 'PF04659', NULL, 'Archaeal flagella protein', 96, NULL, 'Arch_fla_DE', 268787),
(449694, 'PF05926', NULL, 'Phage head completion protein (GPL)', 139, NULL, 'Phage_GPL', 268788),
(449695, 'PF16062', NULL, 'Domain of unknown function (DUF4804)', 448, NULL, 'DUF4804', 268789),
(449696, 'PF17092', NULL, 'Penicillin-binding protein OB-like domain', 112, NULL, 'PCB_OB', 268790),
(449697, 'PF05325', NULL, 'Protein of unknown function (DUF730)', 122, NULL, 'DUF730', 268791),
(449698, 'PF04800', NULL, 'NADH dehydrogenase ubiquinone Fe-S protein 4', 96, NULL, 'NDUS4', 268792),
(449699, 'PF11241', NULL, 'Protein of unknown function (DUF3043)', 171, NULL, 'DUF3043', 268793),
(449700, 'PF10238', NULL, 'E2F-associated phosphoprotein', 145, NULL, 'Eapp_C', 268794),
(449701, 'PF14138', NULL, 'Cytochrome c oxidase assembly protein COX16', 79, NULL, 'COX16', 268795),
(449702, 'PF16572', NULL, 'Long alpha hairpin domain of cation efflux system protein, CusB', 56, NULL, 'HlyD_D4', 268796),
(449703, 'PF10051', NULL, 'Uncharacterized protein conserved in archaea (DUF2286)', 138, NULL, 'DUF2286', 268797),
(449704, 'PF16471', NULL, 'JNK-interacting protein leucine zipper II', 71, NULL, 'JIP_LZII', 268798),
(449705, 'PF17277', NULL, 'Family of unknown function (DUF5342)', 69, NULL, 'DUF5342', 268799),
(449706, 'PF09951', NULL, 'Protein of unknown function (DUF2185)', 85, NULL, 'DUF2185', 268800),
(449707, 'PF01583', NULL, 'Adenylylsulphate kinase', 158, NULL, 'APS_kinase', 268801),
(449708, 'PF06614', NULL, 'Neuromodulin', 175, NULL, 'Neuromodulin', 268802),
(449709, 'PF17531', NULL, 'Spanin, outer lipoprotein subunit T7-like virus', 60, NULL, 'O_Spanin_T7', 268803),
(449710, 'PF13525', NULL, 'Outer membrane lipoprotein', 203, NULL, 'YfiO', 268804),
(449711, 'PF15343', NULL, 'Decidual protein induced by progesterone family', 188, NULL, 'DEPP', 268805),
(449712, 'PF00320', NULL, 'GATA zinc finger', 36, NULL, 'GATA', 268806),
(449713, 'PF15962', NULL, 'Domain of unknown function (DUF4765)', 1128, NULL, 'DUF4765', 268807),
(449714, 'PF00573', NULL, 'Ribosomal protein L4/L1 family', 192, NULL, 'Ribosomal_L4', 268808),
(449715, 'PF07189', NULL, 'Splicing factor 3B subunit 10 (SF3b10)', 78, NULL, 'SF3b10', 268809),
(449716, 'PF12439', NULL, 'Glycogen debranching enzyme N terminal', 219, NULL, 'GDE_N', 268810),
(449717, 'PF09326', NULL, 'NADH-ubiquinone oxidoreductase subunit G, C-terminal', 51, NULL, 'NADH_dhqG_C', 268811),
(449718, 'PF19965', NULL, 'vWA-MoxR associated protein middle region (VMAP-M) 2', 217, NULL, 'VMAP-M2', 268812),
(449719, 'PF03304', NULL, 'Mlp lipoprotein family', 152, NULL, 'Mlp', 268813),
(449720, 'PF07294', NULL, 'Fibroin P25', 196, NULL, 'Fibroin_P25', 268814);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(449721, 'PF15563', NULL, 'Immunity protein 19', 227, NULL, 'Imm19', 268815),
(449722, 'PF08080', NULL, 'RNPHF zinc finger', 36, NULL, 'zf-RNPHF', 268816),
(449723, 'PF01934', NULL, 'Ribonuclease HepT-like', 119, NULL, 'HepT-like', 268817),
(449724, 'PF14068', NULL, 'Putative membrane protein', 101, NULL, 'YuiB', 268818),
(449725, 'PF07114', NULL, 'Transmembrane protein 126', 181, NULL, 'TMEM126', 268819),
(449726, 'PF18404', NULL, 'Glucosyltransferase 24', 268, NULL, 'Glyco_transf_24', 268820),
(449727, 'PF19614', NULL, 'Family of unknown function (DUF6119)', 523, NULL, 'DUF6119', 268821),
(449728, 'PF02687', NULL, 'FtsX-like permease family', 121, NULL, 'FtsX', 268822),
(449729, 'PF12787', NULL, 'EcsC protein family', 245, NULL, 'EcsC', 268823),
(449730, 'PF06785', NULL, 'Uncharacterised protein family (UPF0242) N-terminus', 194, NULL, 'UPF0242', 268824),
(449731, 'PF12746', NULL, 'GNAT acetyltransferase', 243, NULL, 'GNAT_acetyltran', 268825),
(449732, 'PF18049', NULL, 'DNA polymerase nu pseudo-exo', 218, NULL, 'DNA_pol_P_Exo', 268826),
(449733, 'PF20559', NULL, 'Family of unknown function (DUF6770)', 520, NULL, 'DUF6770', 268827),
(449734, 'PF16555', NULL, 'Gram-positive pilin subunit D1, N-terminal domain', 161, NULL, 'GramPos_pilinD1', 268828),
(449735, 'PF02433', NULL, 'Cytochrome C oxidase, mono-heme subunit/FixO', 218, NULL, 'FixO', 268829),
(449736, 'PF12171', NULL, 'Zinc-finger double-stranded RNA-binding', 27, NULL, 'zf-C2H2_jaz', 268830),
(449737, 'PF16267', NULL, 'Domain of unknown function (DUF4920)', 87, NULL, 'DUF4920', 268831),
(449738, 'PF14023', NULL, 'Protein of unknown function (DUF4239)', 217, NULL, 'DUF4239', 268832),
(449739, 'PF15229', NULL, 'POM121 family', 226, NULL, 'POM121', 268833),
(449740, 'PF16237', NULL, 'Domain of unknown function (DUF4896)', 44, NULL, 'DUF4896', 268834),
(449741, 'PF06043', NULL, 'Reovirus P9-like family', 334, NULL, 'Reo_P9', 268835),
(449742, 'PF06517', NULL, 'Orthopoxvirus A43R protein', 195, NULL, 'Orthopox_A43R', 268836),
(449743, 'PF11675', NULL, 'Protein of unknown function (DUF3271)', 248, NULL, 'DUF3271', 268837),
(449744, 'PF12710', NULL, 'haloacid dehalogenase-like hydrolase', 188, NULL, 'HAD', 268838),
(449745, 'PF09723', NULL, 'Zinc ribbon domain', 40, NULL, 'Zn-ribbon_8', 268839),
(449746, 'PF20610', NULL, 'Thioester domain', 131, NULL, 'TED_2', 268840),
(449747, 'PF20608', NULL, 'Phage tail tube protein C-terminal domain', 82, NULL, 'Phage_tube_C', 268841),
(449748, 'PF18022', NULL, 'Ricin-type beta-trefoil lectin C-terminal domain', 102, NULL, 'Lectin_C_term', 268842),
(449749, 'PF20541', NULL, 'Family of unknown function (DUF6756)', 160, NULL, 'DUF6756', 268843),
(449750, 'PF19143', NULL, 'OMP85 superfamily', 351, NULL, 'Omp85_2', 268844),
(449751, 'PF12132', NULL, 'Protein of unknown function (DUF3587)', 201, NULL, 'DUF3587', 268845),
(449752, 'PF00568', NULL, 'WH1 domain', 111, NULL, 'WH1', 268846),
(449753, 'PF11493', NULL, 'Thylakoid soluble phosphoprotein TSP9', 81, NULL, 'TSP9', 268847),
(449754, 'PF17126', NULL, 'RsmF rRNA methyltransferase first C-terminal domain', 61, NULL, 'RsmF_methylt_CI', 268848),
(449755, 'PF13495', NULL, 'Phage integrase, N-terminal SAM-like domain', 85, NULL, 'Phage_int_SAM_4', 268849),
(449756, 'PF09584', NULL, 'Phage shock protein PspD (Phageshock_PspD)', 61, NULL, 'Phageshock_PspD', 268850),
(449757, 'PF01117', NULL, 'Aerolysin toxin', 365, NULL, 'Aerolysin', 268851),
(449758, 'PF03485', NULL, 'Arginyl tRNA synthetase N terminal domain', 85, NULL, 'Arg_tRNA_synt_N', 268852),
(449759, 'PF00128', NULL, 'Alpha amylase, catalytic domain', 336, NULL, 'Alpha-amylase', 268853),
(449760, 'PF03021', NULL, 'Influenza C virus M2 protein', 139, NULL, 'CM2', 268854),
(449761, 'PF18819', NULL, 'Phage MuF-C-terminal domain', 103, NULL, 'MuF_C', 268855),
(449762, 'PF01557', NULL, 'Fumarylacetoacetate (FAA) hydrolase family', 218, NULL, 'FAA_hydrolase', 268856),
(449763, 'PF19735', NULL, 'Family of unknown function (DUF6225)', 87, NULL, 'DUF6225', 268857),
(449764, 'PF14837', NULL, 'Integrator complex subunit 5 N-terminus', 211, NULL, 'INTS5_N', 268858);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(449765, 'PF18192', NULL, 'DNTTIP1 dimerisation domain', 69, NULL, 'DNTTIP1_dimer', 268859),
(449766, 'PF14114', NULL, 'Domain of unknown function (DUF4286)', 99, NULL, 'DUF4286', 268860),
(449767, 'PF19224', NULL, 'pATOM36 family', 270, NULL, 'pATOM36', 268861),
(449768, 'PF03044', NULL, 'Herpesvirus UL16/UL94 family', 337, NULL, 'Herpes_UL16', 268862),
(449769, 'PF16594', NULL, 'Putative AtpZ or ATP-synthase-associated', 53, NULL, 'ATP-synt_Z', 268863),
(449770, 'PF18511', NULL, 'F-box', 42, NULL, 'F-box_5', 268864),
(449771, 'PF14182', NULL, 'YgaB-like protein', 77, NULL, 'YgaB', 268865),
(449772, 'PF12338', NULL, 'Ribulose-1,5-bisphosphate carboxylase small subunit', 45, NULL, 'RbcS', 268866),
(449773, 'PF18643', NULL, 'BsaWI restriction endonuclease type 2', 105, NULL, 'RE_BsaWI', 268867),
(449774, 'PF04318', NULL, 'Protein of unknown function (DUF468)', 84, NULL, 'DUF468', 268868),
(449775, 'PF07881', NULL, 'L-fucose isomerase, first N-terminal domain', 169, NULL, 'Fucose_iso_N1', 268869),
(449776, 'PF17991', NULL, 'Thioredoxin like C-terminal domain', 142, NULL, 'Thioredoxin_10', 268870),
(449777, 'PF03761', NULL, 'Nematode trypsin-6-like family', 282, NULL, 'DUF316', 268871),
(449778, 'PF19187', NULL, 'PafC helix-turn-helix domain', 115, NULL, 'HTH_PafC', 268872),
(449779, 'PF19316', NULL, 'GPI ethanolamine phosphate transferase membrane region', 424, NULL, 'PIGO_PIGG', 268873),
(449780, 'PF00579', NULL, 'tRNA synthetases class I (W and Y)', 293, NULL, 'tRNA-synt_1b', 268874),
(449781, 'PF18986', NULL, 'Family of unknown function (DUF5719)', 319, NULL, 'DUF5719', 268875),
(449782, 'PF06373', NULL, 'Cocaine and amphetamine regulated transcript protein (CART)', 70, NULL, 'CART', 268876),
(449783, 'PF12926', NULL, 'Mitotic-spindle organizing gamma-tubulin ring associated', 90, NULL, 'MOZART2', 268877),
(449784, 'PF07243', NULL, 'Phlebovirus glycoprotein G1', 526, NULL, 'Phlebovirus_G1', 268878),
(449785, 'PF13335', NULL, 'Magnesium chelatase, subunit ChlI C-terminal', 94, NULL, 'Mg_chelatase_C', 268879),
(449786, 'PF13479', NULL, 'AAA domain', 196, NULL, 'AAA_24', 268880),
(449787, 'PF06762', NULL, 'Lipase maturation factor', 446, NULL, 'LMF1', 268881),
(449788, 'PF06849', NULL, 'Protein of unknown function (DUF1246)', 122, NULL, 'DUF1246', 268882),
(449789, 'PF07730', NULL, 'Histidine kinase', 68, NULL, 'HisKA_3', 268883),
(449790, 'PF20590', NULL, 'Domain of unknown function (DUF6791)', 149, NULL, 'DUF6791', 268884),
(449791, 'PF20206', NULL, 'Tra1 HEAT repeat ring region', 1691, NULL, 'Tra1_ring', 268885),
(449792, 'PF02639', NULL, 'Uncharacterized BCR, YaiI/YqxD family COG1671', 130, NULL, 'DUF188', 268886),
(449793, 'PF07010', NULL, 'Endomucin', 260, NULL, 'Endomucin', 268887),
(449794, 'PF07091', NULL, 'Ribosomal RNA methyltransferase (FmrO)', 252, NULL, 'FmrO', 268888),
(449795, 'PF10888', NULL, 'Protein of unknown function (DUF2742)', 97, NULL, 'DUF2742', 268889),
(449796, 'PF12716', NULL, 'Nuclear pore assembly and biogenesis', 54, NULL, 'Apq12', 268890),
(449797, 'PF10983', NULL, 'Protein of unknown function (DUF2793)', 87, NULL, 'DUF2793', 268891),
(449798, 'PF06626', NULL, 'Protein of unknown function (DUF1152)', 295, NULL, 'DUF1152', 268892),
(449799, 'PF16133', NULL, 'Domain of unknown function (DUF4844)', 117, NULL, 'DUF4844', 268893),
(449800, 'PF07200', NULL, 'Modifier of rudimentary (Mod(r)) protein', 146, NULL, 'Mod_r', 268894),
(449801, 'PF04532', NULL, 'Protein of unknown function (DUF587)', 220, NULL, 'DUF587', 268895),
(449802, 'PF17183', NULL, 'Get5 carboxyl domain', 51, NULL, 'Blt1_C', 268896),
(449803, 'PF19033', NULL, 'Intu longin-like domain 3', 101, NULL, 'Intu_longin_3', 268897),
(449804, 'PF00742', NULL, 'Homoserine dehydrogenase', 173, NULL, 'Homoserine_dh', 268898),
(449805, 'PF19110', NULL, 'Family of unknown function (DUF5797)', 163, NULL, 'DUF5797', 268899),
(449806, 'PF02378', NULL, 'Phosphotransferase system, EIIC', 324, NULL, 'PTS_EIIC', 268900),
(449807, 'PF04901', NULL, 'Receptor activity modifying family', 110, NULL, 'RAMP', 268901),
(449808, 'PF05632', NULL, 'Borrelia burgdorferi protein of unknown function (DUF792)', 184, NULL, 'DUF792', 268902);
INSERT INTO "PUBLIC"."MODEL" VALUES
(449809, 'PF15948', NULL, 'Domain of unknown function (DUF4756)', 158, NULL, 'DUF4756', 268903),
(449810, 'PF08845', NULL, 'Toxin SymE, type I toxin-antitoxin system', 54, NULL, 'SymE_toxin', 268904),
(449811, 'PF19106', NULL, 'Family of unknown function (DUF5793)', 157, NULL, 'DUF5793', 268905),
(449812, 'PF12537', NULL, 'The Golgi pH Regulator (GPHR) Family N-terminal', 68, NULL, 'GPHR_N', 268906),
(449813, 'PF19858', NULL, 'Bacterial oxidoreductases, C-terminal', 163, NULL, 'OxRdtase_C', 268907),
(449814, 'PF00692', NULL, 'dUTPase', 129, NULL, 'dUTPase', 268908),
(449815, 'PF00770', NULL, 'Adenovirus endoprotease', 179, NULL, 'Peptidase_C5', 268909),
(449816, 'PF07349', NULL, 'Protein of unknown function (DUF1478)', 161, NULL, 'DUF1478', 268910),
(449817, 'PF10126', NULL, 'Uncharacterized protein, homolog of nitrogen regulatory protein PII', 107, NULL, 'Nit_Regul_Hom', 268911),
(449818, 'PF08725', NULL, 'Integrin beta cytoplasmic domain', 44, NULL, 'Integrin_b_cyt', 268912),
(449819, 'PF01585', NULL, 'G-patch domain', 45, NULL, 'G-patch', 268913),
(449820, 'PF19155', NULL, 'Family of unknown function (DUF5837)', 61, NULL, 'DUF5837', 268914),
(449821, 'PF04352', NULL, 'ProQ/FINO family', 110, NULL, 'ProQ', 268915),
(449822, 'PF17455', NULL, 'Late transcription unit B', 79, NULL, 'LtuB', 268916),
(449823, 'PF05879', NULL, 'Root hair defective 3 GTP-binding protein (RHD3) GTPase domain', 245, NULL, 'RHD3_GTPase', 268917),
(449824, 'PF17888', NULL, 'Carmil pleckstrin homology domain', 94, NULL, 'Carm_PH', 268918),
(449825, 'PF02373', NULL, 'JmjC domain, hydroxylase', 114, NULL, 'JmjC', 268919),
(449826, 'PF07178', NULL, 'TraL protein', 90, NULL, 'TraL', 268920),
(449827, 'PF02366', NULL, 'Dolichyl-phosphate-mannose-protein mannosyltransferase', 245, NULL, 'PMT', 268921),
(449828, 'PF08620', NULL, 'RPAP1-like, C-terminal', 69, NULL, 'RPAP1_C', 268922),
(449829, 'PF18782', NULL, 'Novel AID APOBEC clade 2', 179, NULL, 'NAD2', 268923),
(449830, 'PF15224', NULL, 'Scrapie-responsive protein 1', 76, NULL, 'SCRG1', 268924),
(449831, 'PF12726', NULL, 'SEN1 N terminal', 749, NULL, 'SEN1_N', 268925),
(449832, 'PF18102', NULL, 'Deltex C-terminal domain', 133, NULL, 'DTC', 268926),
(449833, 'PF16626', NULL, 'Linking region between Kunitz_BPTI and I-set on papilin', 92, NULL, 'Papilin_u7', 268927),
(449834, 'PF06503', NULL, 'Protein of unknown function (DUF1101)', 360, NULL, 'DUF1101', 268928),
(449835, 'PF15304', NULL, 'A-kinase anchor protein 2 C-terminus', 341, NULL, 'AKAP2_C', 268929),
(449836, 'PF18121', NULL, 'TFA2 Winged helix domain 2', 62, NULL, 'TFA2_Winged_2', 268930),
(449837, 'PF02655', NULL, 'ATP-grasp domain', 161, NULL, 'ATP-grasp_3', 268931),
(449838, 'PF05166', NULL, 'YcgL domain', 73, NULL, 'YcgL', 268932),
(449839, 'PF11899', NULL, 'Protein of unknown function (DUF3419)', 385, NULL, 'DUF3419', 268933),
(449840, 'PF11325', NULL, 'Domain of unknown function (DUF3127)', 85, NULL, 'DUF3127', 268934),
(449841, 'PF09844', NULL, 'Uncharacterized conserved protein (COG2071)', 212, NULL, 'DUF2071', 268935),
(449842, 'PF18493', NULL, 'Domain of unknown function (DUF5617)', 96, NULL, 'DUF5617', 268936),
(449843, 'PF03211', NULL, 'Pectate lyase', 204, NULL, 'Pectate_lyase', 268937),
(449844, 'PF05748', NULL, 'Rubella membrane glycoprotein E1', 496, NULL, 'Rubella_E1', 268938),
(449845, 'PF12925', NULL, 'E2 domain of amyloid precursor protein', 190, NULL, 'APP_E2', 268939),
(449846, 'PF01537', NULL, 'Herpesvirus glycoprotein D/GG/GX domain', 124, NULL, 'Herpes_glycop_D', 268940),
(449847, 'PF11054', NULL, 'Sporozoite TA4 surface antigen', 207, NULL, 'Surface_antigen', 268941),
(449848, 'PF05856', NULL, 'ARP2/3 complex 20 kDa subunit (ARPC4)', 168, NULL, 'ARPC4', 268942),
(449849, 'PF08938', NULL, 'HBS1 N-terminus', 81, NULL, 'HBS1_N', 268943),
(449850, 'PF07986', NULL, 'Tubulin binding cofactor C', 120, NULL, 'TBCC', 268944),
(449851, 'PF12478', NULL, 'Ubiquitin-associated protein 2', 35, NULL, 'DUF3697', 268945),
(449852, 'PF16803', NULL, 'Fe-S cluster assembly protein DRE2 N-terminus', 131, NULL, 'DRE2_N', 268946);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(449853, 'PF02909', NULL, 'Tetracyclin repressor-like, C-terminal domain', 145, NULL, 'TetR_C_1', 268947),
(449854, 'PF08536', NULL, 'Whirly transcription factor', 137, NULL, 'Whirly', 268948),
(449855, 'PF20374', NULL, 'Family of unknown function (DUF6669)', 156, NULL, 'DUF6669', 268949),
(449856, 'PF09879', NULL, 'Predicted membrane protein (DUF2106)', 151, NULL, 'DUF2106', 268950),
(449857, 'PF11947', NULL, 'Photosynthesis affected mutant 68', 150, NULL, 'DUF3464', 268951),
(449858, 'PF17171', NULL, 'Glutathione S-transferase, C-terminal domain', 64, NULL, 'GST_C_6', 268952),
(449859, 'PF01052', NULL, 'Type III flagellar switch regulator (C-ring) FliN C-term', 73, NULL, 'FliMN_C', 268953),
(449860, 'PF13344', NULL, 'Haloacid dehalogenase-like hydrolase', 101, NULL, 'Hydrolase_6', 268954),
(449861, 'PF06155', NULL, 'Gamma-butyrobetaine hydroxylase-like, N-terminal', 85, NULL, 'GBBH-like_N', 268955),
(449862, 'PF06391', NULL, 'CDK-activating kinase assembly factor MAT1', 204, NULL, 'MAT1', 268956),
(449863, 'PF07725', NULL, 'Leucine Rich Repeat', 20, NULL, 'LRR_3', 268957),
(449864, 'PF00884', NULL, 'Sulfatase', 309, NULL, 'Sulfatase', 268958),
(449865, 'PF14338', NULL, 'Mrr N-terminal domain', 87, NULL, 'Mrr_N', 268959),
(449866, 'PF15090', NULL, 'Domain of unknown function (DUF4553)', 479, NULL, 'DUF4553', 268960),
(449867, 'PF16091', NULL, 'Domain of unknown function (DUF4820)', 230, NULL, 'DUF4820', 268961),
(449868, 'PF19320', NULL, 'Galactofuranosyltransferase-2, domain 3', 197, NULL, 'GlfT2_domain3', 268962),
(449869, 'PF04891', NULL, 'NifQ', 159, NULL, 'NifQ', 268963),
(449870, 'PF15388', NULL, 'Protein Family FAM117', 310, NULL, 'FAM117', 268964),
(449871, 'PF19365', NULL, 'Family of unknown function (DUF5941)', 207, NULL, 'DUF5941', 268965),
(449872, 'PF18321', NULL, '3-hydroxybutyryl-CoA dehydrogenase reduced Rossmann-fold domain', 69, NULL, '3HCDH_RFF', 268966),
(449873, 'PF20000', NULL, 'FtsH ternary system domain X2', 261, NULL, 'fvmX2', 268967),
(449874, 'PF04922', NULL, 'DIE2/ALG10 family', 395, NULL, 'DIE2_ALG10', 268968),
(449875, 'PF05290', NULL, 'Baculovirus immediate-early protein (IE-0)', 141, NULL, 'Baculo_IE-1', 268969),
(449876, 'PF17139', NULL, 'Domain of unknown function (DUF5112)', 266, NULL, 'DUF5112', 268970),
(449877, 'PF06663', NULL, 'Connector enhancer of kinase suppressor of ras 2/3 domain', 212, NULL, 'CNK2_3_dom', 268971),
(449878, 'PF18189', NULL, 'TbRIF5 SNase domain 2', 178, NULL, 'RIF5_SNase_2', 268972),
(449879, 'PF18977', NULL, 'Family of unknown function (DUF5713)', 107, NULL, 'DUF5713', 268973),
(449880, 'PF09295', NULL, 'ChAPs (Chs5p-Arf1p-binding proteins)', 395, NULL, 'ChAPs', 268974),
(449881, 'PF01080', NULL, 'Presenilin', 417, NULL, 'Presenilin', 268975),
(449882, 'PF11322', NULL, 'Protein of unknown function (DUF3124)', 123, NULL, 'DUF3124', 268976),
(449883, 'PF14530', NULL, 'Domain of unknown function (DUF4439)', 132, NULL, 'DUF4439', 268977),
(449884, 'PF20330', NULL, 'Family of unknown function (DUF6625)', 269, NULL, 'DUF6625', 268978),
(449885, 'PF09076', NULL, 'Beta/Gamma crystallin', 70, NULL, 'Crystall_2', 268979),
(449886, 'PF07918', NULL, 'CAP160 repeat', 27, NULL, 'CAP160', 268980),
(449887, 'PF09645', NULL, 'F-112 protein', 110, NULL, 'F-112', 268981),
(449888, 'PF03469', NULL, 'XH domain', 131, NULL, 'XH', 268982),
(449889, 'PF16582', NULL, 'Middle domain of thiamine pyrophosphate', 208, NULL, 'TPP_enzyme_M_2', 268983),
(449890, 'PF05417', NULL, 'Hepatitis E cysteine protease', 161, NULL, 'Peptidase_C41', 268984),
(449891, 'PF10384', NULL, 'Centromere protein Scm3', 54, NULL, 'Scm3', 268985),
(449892, 'PF08477', NULL, 'Ras of Complex, Roc, domain of DAPkinase', 119, NULL, 'Roc', 268986),
(449893, 'PF16231', NULL, 'Domain of unknown function (DUF4890)', 109, NULL, 'DUF4890', 268987),
(449894, 'PF03489', NULL, 'Saposin-like type B, region 2', 34, NULL, 'SapB_2', 268988),
(449895, 'PF04892', NULL, 'VanZ like family', 123, NULL, 'VanZ', 268989),
(449896, 'PF13795', NULL, 'HupE / UreJ protein', 154, NULL, 'HupE_UreJ_2', 268990);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(449897, 'PF18332', NULL, 'Exoribonuclease Xrn1 D1 domain', 192, NULL, 'XRN1_D1', 268991),
(449898, 'PF07082', NULL, 'Protein of unknown function (DUF1350)', 250, NULL, 'DUF1350', 268992),
(449899, 'PF05622', NULL, 'HOOK protein coiled-coil region', 527, NULL, 'HOOK', 268993),
(449900, 'PF17261', NULL, 'Family of unknown function (DUF5327)', 99, NULL, 'DUF5327', 268994),
(449901, 'PF19599', NULL, 'Family of unknown function (DUF6104)', 58, NULL, 'DUF6104', 268995),
(449902, 'PF08490', NULL, 'Domain of unknown function (DUF1744)', 401, NULL, 'DUF1744', 268996),
(449903, 'PF18250', NULL, 'Effector immunity protein Tgi2PP', 43, NULL, 'Tgi2PP', 268997),
(449904, 'PF03445', NULL, 'Putative nucleotidyltransferase DUF294', 138, NULL, 'DUF294', 268998),
(449905, 'PF17591', NULL, 'Herpesvirus UL41A', 78, NULL, 'UL41A', 268999),
(449906, 'PF03041', NULL, 'lef-2', 165, NULL, 'Baculo_LEF-2', 269000),
(449907, 'PF03200', NULL, 'Glycosyl hydrolase family 63 C-terminal domain', 491, NULL, 'Glyco_hydro_63', 269001),
(449908, 'PF14124', NULL, 'Domain of unknown function (DUF4291)', 180, NULL, 'DUF4291', 269002),
(449909, 'PF07389', NULL, 'Vaccinia B6 protein', 181, NULL, 'Pox_B6', 269003),
(449910, 'PF20519', NULL, 'Polycystin domain', 199, NULL, 'Polycystin_dom', 269004),
(449911, 'PF18056', NULL, 'Penicillin Binding Protein 3 Domain', 110, NULL, 'PBP3', 269005),
(449912, 'PF09624', NULL, 'Protein of unknown function (DUF2393)', 147, NULL, 'DUF2393', 269006),
(449913, 'PF19668', NULL, 'Family of unknown function (DUF6171)', 80, NULL, 'DUF6171', 269007),
(449914, 'PF16012', NULL, 'Domain of unknown function (DUF4780)', 177, NULL, 'DUF4780', 269008),
(449915, 'PF03007', NULL, 'Wax ester synthase-like Acyl-CoA acyltransferase domain', 264, NULL, 'WES_acyltransf', 269009),
(449916, 'PF12258', NULL, 'Microcephalin protein', 391, NULL, 'Microcephalin', 269010),
(449917, 'PF17178', NULL, 'Membrane-associated sensor', 192, NULL, 'MASE5', 269011),
(449918, 'PF18670', NULL, 'V-type ATPase subunit I, N-terminal domain', 90, NULL, 'V_ATPase_I_N', 269012),
(449919, 'PF03124', NULL, 'EXS family', 330, NULL, 'EXS', 269013),
(449920, 'PF09516', NULL, 'CfrBI restriction endonuclease', 250, NULL, 'RE_CfrBI', 269014),
(449921, 'PF10604', NULL, 'Polyketide cyclase / dehydrase and lipid transport', 142, NULL, 'Polyketide_cyc2', 269015),
(449922, 'PF18441', NULL, 'Hen1 La-motif C-terminal domain', 136, NULL, 'Hen1_Lam_C', 269016),
(449923, 'PF14806', NULL, 'Coatomer beta subunit appendage platform', 128, NULL, 'Coatomer_b_Cpla', 269017),
(449924, 'PF05985', NULL, 'Ethanolamine ammonia-lyase light chain (EutC)', 233, NULL, 'EutC', 269018),
(449925, 'PF09421', NULL, 'Frequency clock protein', 984, NULL, 'FRQ', 269019),
(449926, 'PF07096', NULL, 'Protein of unknown function (DUF1358)', 115, NULL, 'DUF1358', 269020),
(449927, 'PF12515', NULL, 'Ca2+-ATPase N terminal autoinhibitory domain', 45, NULL, 'CaATP_NAI', 269021),
(449928, 'PF09169', NULL, 'BRCA2, helical', 187, NULL, 'BRCA-2_helical', 269022),
(449929, 'PF08112', NULL, 'ATP synthase epsilon subunit', 56, NULL, 'ATP-synt_E_2', 269023),
(449930, 'PF01808', NULL, 'AICARFT/IMPCHase bienzyme', 310, NULL, 'AICARFT_IMPCHas', 269024),
(449931, 'PF12690', NULL, 'Intracellular proteinase inhibitor', 101, NULL, 'BsuPI', 269025),
(449932, 'PF17526', NULL, 'Family of unknown function (DUF5448)', 118, NULL, 'DUF5448', 269026),
(449933, 'PF00766', NULL, 'Electron transfer flavoprotein FAD-binding domain', 81, NULL, 'ETF_alpha', 269027),
(449934, 'PF02721', NULL, 'Domain of unknown function DUF223', 95, NULL, 'DUF223', 269028),
(449935, 'PF19659', NULL, 'Family of unknown function (DUF6162)', 240, NULL, 'DUF6162', 269029),
(449936, 'PF15449', NULL, 'Retinal protein', 1290, NULL, 'Retinal', 269030),
(449937, 'PF18206', NULL, 'Porphyranase catalytic subdomain 1', 105, NULL, 'Porphyrn_cat_1', 269031),
(449938, 'PF19509', NULL, 'Family of unknown function (DUF6043)', 314, NULL, 'DUF6043', 269032),
(449939, 'PF16116', NULL, 'Domain of unknown function (DUF4832)', 217, NULL, 'DUF4832', 269033);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(449940, 'PF17555', NULL, 'Type VI secretion system, TssN', 274, NULL, 'TssN', 269034),
(449941, 'PF17642', NULL, 'Hemolysin coregulated protein Hcp (TssD)', 128, NULL, 'TssD', 269035),
(449942, 'PF20395', NULL, 'C-terminal domain 3 of the ABC-three component (ABC-3C) systems', 162, NULL, 'CTD3', 269036),
(449943, 'PF16021', NULL, 'Programmed cell death protein 7', 306, NULL, 'PDCD7', 269037),
(449944, 'PF09585', NULL, 'Conserved hypothetical protein (Lin0512_fam)', 114, NULL, 'Lin0512_fam', 269038),
(449945, 'PF07323', NULL, 'Protein of unknown function (DUF1465)', 154, NULL, 'DUF1465', 269039),
(449946, 'PF12747', NULL, 'DdrB-like protein', 132, NULL, 'DdrB', 269040),
(449947, 'PF17986', NULL, 'EMP3-KAHRP-like N-terminal domain', 53, NULL, 'EKAL', 269041),
(449948, 'PF16865', NULL, 'Glutathione S-transferase, C-terminal domain', 108, NULL, 'GST_C_5', 269042),
(449949, 'PF18247', NULL, 'Flax-rust effector AvrM N-terminal domain', 65, NULL, 'AvrM_N', 269043),
(449950, 'PF03020', NULL, 'LEM domain', 40, NULL, 'LEM', 269044),
(449951, 'PF07784', NULL, 'Protein of unknown function (DUF1622)', 78, NULL, 'DUF1622', 269045),
(449952, 'PF12065', NULL, 'Protein of unknown function (DUF3545)', 59, NULL, 'DUF3545', 269046),
(449953, 'PF14601', NULL, 'DNA_binding protein, TFX, C-term', 83, NULL, 'TFX_C', 269047),
(449954, 'PF19915', NULL, 'MoxR-vWA-beta-propeller ternary system domain bpX0', 163, NULL, 'bpX0', 269048),
(449955, 'PF06611', NULL, 'Protein of unknown function (DUF1145)', 58, NULL, 'DUF1145', 269049),
(449956, 'PF14066', NULL, 'Protein of unknown function (DUF4256)', 173, NULL, 'DUF4256', 269050),
(449957, 'PF01210', NULL, 'NAD-dependent glycerol-3-phosphate dehydrogenase N-terminus', 157, NULL, 'NAD_Gly3P_dh_N', 269051),
(449958, 'PF13862', NULL, 'BCCIP', 209, NULL, 'BCCIP', 269052),
(449959, 'PF00578', NULL, 'AhpC/TSA family', 124, NULL, 'AhpC-TSA', 269053),
(449960, 'PF14890', NULL, 'Intein splicing domain', 155, NULL, 'Intein_splicing', 269054),
(449961, 'PF08476', NULL, 'Viral D10 N-terminal', 43, NULL, 'VD10_N', 269055),
(449962, 'PF15714', NULL, 'Stage V sporulation protein T C-terminal, transcription factor', 128, NULL, 'SpoVT_C', 269056),
(449963, 'PF08612', NULL, 'TATA-binding related factor (TRF) of subunit 20 of Mediator complex', 225, NULL, 'Med20', 269057),
(449964, 'PF15849', NULL, 'Domain of unknown function (DUF4722)', 167, NULL, 'DUF4722', 269058),
(449965, 'PF01192', NULL, 'RNA polymerase Rpb6', 52, NULL, 'RNA_pol_Rpb6', 269059),
(449966, 'PF16575', NULL, 'mRNA cleavage and polyadenylation factor CLP1 P-loop', 188, NULL, 'CLP1_P', 269060),
(449967, 'PF04185', NULL, 'Phosphoesterase family', 356, NULL, 'Phosphoesterase', 269061),
(449968, 'PF07972', NULL, 'NrdI Flavodoxin like', 120, NULL, 'Flavodoxin_NdrI', 269062),
(449969, 'PF17068', NULL, 'Required for respiratory growth protein 8 mitochondrial', 279, NULL, 'RRG8', 269063),
(449970, 'PF11860', NULL, 'N-acetylmuramidase', 175, NULL, 'Muramidase', 269064),
(449971, 'PF14481', NULL, 'Type 4 fimbrial biogenesis protein PilY2', 105, NULL, 'Fimbrial_PilY2', 269065),
(449972, 'PF08584', NULL, 'Ribonuclease P 40kDa (Rpp40) subunit', 288, NULL, 'Ribonuc_P_40', 269066),
(449973, 'PF13186', NULL, 'Iron-sulfur cluster-binding domain', 68, NULL, 'SPASM', 269067),
(449974, 'PF18831', NULL, 'Leucine-rich repeat', 29, NULL, 'LRR_11', 269068),
(449975, 'PF02153', NULL, 'Prephenate dehydrogenase, nucleotide-binding domain', 154, NULL, 'PDH_N', 269069),
(449976, 'PF13687', NULL, 'Domain of unknown function (DUF4153)', 373, NULL, 'DUF4153', 269070),
(449977, 'PF17403', NULL, 'Nrap protein PAP/OAS-like domain', 152, NULL, 'Nrap_D2', 269071),
(449978, 'PF12162', NULL, 'STAT1 TAZ2 binding domain', 23, NULL, 'STAT1_TAZ2bind', 269072),
(449979, 'PF13814', NULL, 'Replication-relaxation', 193, NULL, 'Replic_Relax', 269073),
(449980, 'PF18024', NULL, 'Helix-turn-helix domain', 50, NULL, 'HTH_50', 269074),
(449981, 'PF19808', NULL, 'Family of unknown function (DUF6291)', 79, NULL, 'DUF6291', 269075),
(449982, 'PF03573', NULL, 'outer membrane porin, OprD family', 394, NULL, 'OprD', 269076);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(449983, 'PF00764', NULL, 'Arginosuccinate synthase', 388, NULL, 'Arginosuc_synth', 269077),
(449984, 'PF10915', NULL, 'Protein of unknown function (DUF2709)', 237, NULL, 'DUF2709', 269078),
(449985, 'PF13041', NULL, 'PPR repeat family', 50, NULL, 'PPR_2', 269079),
(449986, 'PF03466', NULL, 'LysR substrate binding domain', 209, NULL, 'LysR_substrate', 269080),
(449987, 'PF13735', NULL, 'tRNA nucleotidyltransferase domain 2 putative', 149, NULL, 'tRNA_NucTran2_2', 269081),
(449988, 'PF10979', NULL, 'Protein of unknown function (DUF2786)', 40, NULL, 'DUF2786', 269082),
(449989, 'PF15462', NULL, 'Bartter syndrome, infantile, with sensorineural deafness (Barttin)', 223, NULL, 'Barttin', 269083),
(449990, 'PF14918', NULL, 'MDM2-binding', 254, NULL, 'MTBP_N', 269084),
(449991, 'PF01956', NULL, 'Integral membrane protein EMC3/TMCO1-like', 170, NULL, 'EMC3_TMCO1', 269085),
(449992, 'PF15357', NULL, 'Psoriasis susceptibility 1 candidate 1', 149, NULL, 'SEEK1', 269086),
(449993, 'PF15795', NULL, 'Ectodermal ciliogenesis protein', 85, NULL, 'Spec3', 269087),
(449994, 'PF11635', NULL, 'Mediator complex subunit 16', 758, NULL, 'Med16', 269088),
(449995, 'PF02362', NULL, 'B3 DNA binding domain', 101, NULL, 'B3', 269089),
(449996, 'PF05619', NULL, 'Borrelia burgdorferi protein of unknown function (DUF787)', 362, NULL, 'DUF787', 269090),
(449997, 'PF13188', NULL, 'PAS domain', 67, NULL, 'PAS_8', 269091),
(449998, 'PF09609', NULL, 'CRISPR-associated protein, GSU0054 family (Cas_GSU0054)', 534, NULL, 'Cas_GSU0054', 269092),
(449999, 'PF17700', NULL, 'Family of unknown function (DUF5546)', 135, NULL, 'DUF5546', 269093),
(450000, 'PF02881', NULL, 'SRP54-type protein, helical bundle domain', 75, NULL, 'SRP54_N', 269094),
(450001, 'PF02593', NULL, 'Domain of unknown function', 220, NULL, 'DUF166', 269095),
(450002, 'PF18543', NULL, 'Intracellular delivery domain', 53, NULL, 'ID', 269096),
(450003, 'PF16667', NULL, 'Unstructured region 10 on multiple PDZ protein', 65, NULL, 'MPDZ_u10', 269097),
(450004, 'PF04087', NULL, 'Domain of unknown function (DUF389)', 141, NULL, 'DUF389', 269098),
(450005, 'PF06064', NULL, 'Host-nuclease inhibitor protein Gam', 98, NULL, 'Gam', 269099),
(450006, 'PF18035', NULL, 'Bap31/Bap29 cytoplasmic coiled-coil domain', 52, NULL, 'Bap31_Bap29_C', 269100),
(450007, 'PF19607', NULL, 'Family of unknown function (DUF6112)', 88, NULL, 'DUF6112', 269101),
(450008, 'PF02626', NULL, 'Carboxyltransferase domain, subdomain A and B', 263, NULL, 'CT_A_B', 269102),
(450009, 'PF19132', NULL, 'Family of unknown function (DUF5815)', 155, NULL, 'DUF5815', 269103),
(450010, 'PF06206', NULL, 'CpeT/CpcT family (DUF1001)', 181, NULL, 'CpeT', 269104),
(450011, 'PF11495', NULL, 'Archaeal transcriptional regulator TrmB', 233, NULL, 'Regulator_TrmB', 269105),
(450012, 'PF07417', NULL, 'Sigma factor-binding transcriptional regulator Crl', 129, NULL, 'Crl', 269106),
(450013, 'PF03230', NULL, 'Antirestriction protein', 92, NULL, 'Antirestrict', 269107),
(450014, 'PF18244', NULL, 'Cellulose-binding protein CttA N-terminal domain', 71, NULL, 'CttA_N', 269108),
(450015, 'PF08445', NULL, 'FR47-like protein', 86, NULL, 'FR47', 269109),
(450016, 'PF19539', NULL, 'Family of unknown function (DUF6063)', 244, NULL, 'DUF6063', 269110),
(450017, 'PF00262', NULL, 'Calreticulin family', 370, NULL, 'Calreticulin', 269111),
(450018, 'PF15858', NULL, 'Late cornified envelope protein 6A family', 81, NULL, 'LCE6A', 269112),
(450019, 'PF14826', NULL, 'FACT complex subunit SPT16 N-terminal lobe domain', 161, NULL, 'FACT-Spt16_Nlob', 269113),
(450020, 'PF15921', NULL, 'Coiled-coil domain-containing protein 158', 1112, NULL, 'CCDC158', 269114),
(450021, 'PF02406', NULL, 'MmoB/DmpM family', 85, NULL, 'MmoB_DmpM', 269115),
(450022, 'PF05571', NULL, 'JNK1/MAPK8-associated membrane protein', 292, NULL, 'JAMP', 269116),
(450023, 'PF02316', NULL, 'Mu DNA-binding domain', 142, NULL, 'HTH_Tnp_Mu_1', 269117),
(450024, 'PF08769', NULL, 'Sporulation initiation factor Spo0A C terminal', 104, NULL, 'Spo0A_C', 269118),
(450025, 'PF20044', NULL, 'Family of unknown function (DUF6446)', 129, NULL, 'DUF6446', 269119);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(450026, 'PF08171', NULL, 'Mad3/BUB1 homology region 2', 68, NULL, 'Mad3_BUB1_II', 269120),
(450027, 'PF03788', NULL, 'LrgA family', 94, NULL, 'LrgA', 269121),
(450028, 'PF04833', NULL, 'COBRA-like protein', 165, NULL, 'COBRA', 269122),
(450029, 'PF09717', NULL, 'Plasmodium falciparum domain of unknown function (CPW_WPC)', 59, NULL, 'CPW_WPC', 269123),
(450030, 'PF02184', NULL, 'HAT (Half-A-TPR) repeat', 32, NULL, 'HAT', 269124),
(450031, 'PF01546', NULL, 'Peptidase family M20/M25/M40', 207, NULL, 'Peptidase_M20', 269125),
(450032, 'PF13206', NULL, 'Trypanosomal VSG domain', 353, NULL, 'VSG_B', 269126),
(450033, 'PF03970', NULL, 'Herpesvirus UL37 tegument protein', 267, NULL, 'Herpes_UL37_1', 269127),
(450034, 'PF11617', NULL, 'Putative metal-binding motif', 30, NULL, 'Cu-binding_MopE', 269128),
(450035, 'PF01784', NULL, 'NIF3 (NGG1p interacting factor 3)', 245, NULL, 'NIF3', 269129),
(450036, 'PF11456', NULL, 'Protein of unknown function (DUF3019)', 102, NULL, 'DUF3019', 269130),
(450037, 'PF16041', NULL, 'Domain of unknown function (DUF4793)', 108, NULL, 'DUF4793', 269131),
(450038, 'PF19907', NULL, 'Family of unknown function (DUF6380)', 47, NULL, 'DUF6380', 269132),
(450039, 'PF07853', NULL, 'Domain of unknown function (DUF1648)', 49, NULL, 'DUF1648', 269133),
(450040, 'PF08950', NULL, 'Protein of unknown function (DUF1861)', 296, NULL, 'DUF1861', 269134),
(450041, 'PF10061', NULL, 'Uncharacterized conserved protein (DUF2299)', 138, NULL, 'DUF2299', 269135),
(450042, 'PF18939', NULL, 'Family of unknown function (DUF5686)', 670, NULL, 'DUF5686', 269136),
(450043, 'PF06922', NULL, 'Citrus tristeza virus P13 protein', 119, NULL, 'CTV_P13', 269137),
(450044, 'PF07172', NULL, 'Glycine rich protein family', 95, NULL, 'GRP', 269138),
(450045, 'PF01257', NULL, 'Thioredoxin-like [2Fe-2S] ferredoxin', 145, NULL, '2Fe-2S_thioredx', 269139),
(450046, 'PF10719', NULL, 'Late competence development protein ComFB', 83, NULL, 'ComFB', 269140),
(450047, 'PF15118', NULL, 'Domain of unknown function (DUF4560)', 64, NULL, 'DUF4560', 269141),
(450048, 'PF02650', NULL, 'WhiA C-terminal HTH domain', 84, NULL, 'HTH_WhiA', 269142),
(450049, 'PF16372', NULL, 'Domain of unknown function (DUF4984)', 161, NULL, 'DUF4984', 269143),
(450050, 'PF08280', NULL, 'M protein trans-acting positive regulator (MGA) HTH domain', 60, NULL, 'HTH_Mga', 269144),
(450051, 'PF00018', NULL, 'SH3 domain', 48, NULL, 'SH3_1', 269145),
(450052, 'PF02936', NULL, 'Cytochrome c oxidase subunit IV', 141, NULL, 'COX4', 269146),
(450053, 'PF16731', NULL, 'Glutamic acid/alanine-rich protein of Trypanosoma', 193, NULL, 'GARP', 269147),
(450054, 'PF15625', NULL, 'CC2D2A N-terminal C2 domain', 174, NULL, 'CC2D2AN-C2', 269148),
(450055, 'PF10431', NULL, 'C-terminal, D2-small domain, of ClpB protein', 81, NULL, 'ClpB_D2-small', 269149),
(450056, 'PF16775', NULL, 'Target recognition domain of lytic exoenzyme', 106, NULL, 'ZoocinA_TRD', 269150),
(450057, 'PF15771', NULL, 'Interactor of HORMAD1 protein 1', 575, NULL, 'IHO1', 269151),
(450058, 'PF18113', NULL, 'Rubredoxin binding C-terminal domain', 71, NULL, 'Rbx_binding', 269152),
(450059, 'PF06436', NULL, 'Pneumovirus matrix protein 2 (M2)', 157, NULL, 'Pneumovirus_M2', 269153),
(450060, 'PF12893', NULL, 'Putative lumazine-binding', 116, NULL, 'Lumazine_bd_2', 269154),
(450061, 'PF07511', NULL, 'Protein of unknown function (DUF1525)', 114, NULL, 'DUF1525', 269155),
(450062, 'PF04115', NULL, 'Ureidoglycolate lyase', 190, NULL, 'Ureidogly_lyase', 269156),
(450063, 'PF10995', NULL, 'Cellulose biosynthesis GIL', 516, NULL, 'CBP_GIL', 269157),
(450064, 'PF14266', NULL, 'Putative component of ''biosynthetic module''', 483, NULL, 'YceG_bac', 269158),
(450065, 'PF03792', NULL, 'PBC domain', 181, NULL, 'PBC', 269159),
(450066, 'PF01281', NULL, 'Ribosomal protein L9, N-terminal domain', 47, NULL, 'Ribosomal_L9_N', 269160),
(450067, 'PF11717', NULL, 'RNA binding activity-knot of a chromodomain', 55, NULL, 'Tudor-knot', 269161),
(450068, 'PF07350', NULL, 'Protein of unknown function (DUF1479)', 414, NULL, 'DUF1479', 269162);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(450069, 'PF11657', NULL, 'Transcriptional activator TraM', 142, NULL, 'Activator-TraM', 269163),
(450070, 'PF00435', NULL, 'Spectrin repeat', 105, NULL, 'Spectrin', 269164),
(450071, 'PF15642', NULL, 'Toxin in Odyssella and Amoebophilus', 385, NULL, 'Tox-ODYAM1', 269165),
(450072, 'PF03923', NULL, 'Uncharacterized lipoprotein', 159, NULL, 'Lipoprotein_16', 269166),
(450073, 'PF13444', NULL, 'Acetyltransferase (GNAT) domain', 102, NULL, 'Acetyltransf_5', 269167),
(450074, 'PF08086', NULL, 'Ergtoxin family', 41, NULL, 'Toxin_17', 269168),
(450075, 'PF14942', NULL, 'Organelle biogenesis, Muted-like protein', 146, NULL, 'Muted', 269169),
(450076, 'PF00923', NULL, 'Transaldolase/Fructose-6-phosphate aldolase', 287, NULL, 'TAL_FSA', 269170),
(450077, 'PF01718', NULL, 'Orbivirus non-structural protein NS1, or hydrophobic tubular protein', 548, NULL, 'Orbi_NS1', 269171),
(450078, 'PF02009', NULL, 'Rifin', 327, NULL, 'RIFIN', 269172),
(450079, 'PF12042', NULL, 'Tubuliform egg casing silk strands structural domain', 168, NULL, 'RP1-2', 269173),
(450080, 'PF19770', NULL, 'Family of unknown function (DUF6256)', 110, NULL, 'DUF6256', 269174),
(450081, 'PF03310', NULL, 'Caulimovirus DNA-binding protein', 117, NULL, 'Cauli_DNA-bind', 269175),
(450082, 'PF02862', NULL, 'DDHD domain', 254, NULL, 'DDHD', 269176),
(450083, 'PF02868', NULL, 'Thermolysin metallopeptidase, alpha-helical domain', 168, NULL, 'Peptidase_M4_C', 269177),
(450084, 'PF06020', NULL, 'Drosophila roughex protein', 365, NULL, 'Roughex', 269178),
(450085, 'PF11599', NULL, 'RRNA methyltransferase AviRa', 232, NULL, 'AviRa', 269179),
(450086, 'PF18344', NULL, 'Carbohydrate binding module family 32', 64, NULL, 'CBM32', 269180),
(450087, 'PF02259', NULL, 'FAT domain', 346, NULL, 'FAT', 269181),
(450088, 'PF03502', NULL, 'Nucleoside-specific channel-forming protein, Tsx', 244, NULL, 'Channel_Tsx', 269182),
(450089, 'PF16629', NULL, 'Armadillo-associated region on APC', 293, NULL, 'Arm_APC_u3', 269183),
(450090, 'PF20018', NULL, 'vWA-MoxR associated protein middle region (VMAP-M) 14', 132, NULL, 'VMAP-M14', 269184),
(450091, 'PF08464', NULL, 'Geminivirus AC4/5 conserved region', 43, NULL, 'Gemini_AC4_5_2', 269185),
(450092, 'PF10726', NULL, 'Protein of function (DUF2518)', 145, NULL, 'DUF2518', 269186),
(450093, 'PF17979', NULL, 'Cysteine rich domain with multizinc binding regions', 159, NULL, 'zf-CRD', 269187),
(450094, 'PF07670', NULL, 'Nucleoside recognition', 112, NULL, 'Gate', 269188),
(450095, 'PF09087', NULL, 'Cyclomaltodextrinase, N-terminal', 88, NULL, 'Cyc-maltodext_N', 269189),
(450096, 'PF02469', NULL, 'Fasciclin domain', 128, NULL, 'Fasciclin', 269190),
(450097, 'PF19167', NULL, 'Family of unknown function (DUF5849)', 200, NULL, 'DUF5849', 269191),
(450098, 'PF04760', NULL, 'Translation initiation factor IF-2, N-terminal region', 52, NULL, 'IF2_N', 269192),
(450099, 'PF13026', NULL, 'Protein of unknown function (DUF3887)', 91, NULL, 'DUF3887', 269193),
(450100, 'PF16108', NULL, 'Domain of unknown function (DUF4826)', 129, NULL, 'DUF4826', 269194),
(450101, 'PF03547', NULL, 'Membrane transport protein', 387, NULL, 'Mem_trans', 269195),
(450102, 'PF01179', NULL, 'Copper amine oxidase, enzyme domain', 407, NULL, 'Cu_amine_oxid', 269196),
(450103, 'PF00509', NULL, 'Haemagglutinin', 550, NULL, 'Hemagglutinin', 269197),
(450104, 'PF14210', NULL, 'Domain of unknown function (DUF4322)', 66, NULL, 'DUF4322', 269198),
(450105, 'PF19243', NULL, 'Family of unknown function (DUF5892)', 327, NULL, 'DUF5892', 269199),
(450106, 'PF08364', NULL, 'Bacterial translation initiation factor IF-2 associated region', 39, NULL, 'IF2_assoc', 269200),
(450107, 'PF19467', NULL, 'Family of unknown function (DUF6004)', 400, NULL, 'DUF6004', 269201),
(450108, 'PF07416', NULL, 'Crinivirus P26 protein', 227, NULL, 'Crinivirus_P26', 269202),
(450109, 'PF18455', NULL, 'Gamma-aminobutyric acid type B receptor subunit 2 coiled-coil domain', 39, NULL, 'GBR2_CC', 269203),
(450110, 'PF01927', NULL, 'Mut7-C RNAse domain', 147, NULL, 'Mut7-C', 269204),
(450111, 'PF03288', NULL, 'Poxvirus D5 protein-like', 86, NULL, 'Pox_D5', 269205);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(450112, 'PF18083', NULL, 'Proline utilization A N-terminal domain', 113, NULL, 'PutA_N', 269206),
(450113, 'PF00439', NULL, 'Bromodomain', 84, NULL, 'Bromodomain', 269207),
(450114, 'PF05214', NULL, 'Baculovirus P33', 247, NULL, 'Baculo_p33', 269208),
(450115, 'PF07895', NULL, 'Protein of unknown function (DUF1673)', 207, NULL, 'DUF1673', 269209),
(450116, 'PF13440', NULL, 'Polysaccharide biosynthesis protein', 293, NULL, 'Polysacc_synt_3', 269210),
(450117, 'PF05707', NULL, 'Zonular occludens toxin (Zot)', 194, NULL, 'Zot', 269211),
(450118, 'PF19054', NULL, 'Domain of unknown function (DUF5753)', 180, NULL, 'DUF5753', 269212),
(450119, 'PF08826', NULL, 'DMPK coiled coil domain like', 61, NULL, 'DMPK_coil', 269213),
(450120, 'PF02369', NULL, 'Bacterial Ig-like domain (group 1)', 64, NULL, 'Big_1', 269214),
(450121, 'PF03063', NULL, 'Prismane/CO dehydrogenase family', 511, NULL, 'Prismane', 269215),
(450122, 'PF08135', NULL, 'Major transforming protein E5 family', 43, NULL, 'EPV_E5', 269216),
(450123, 'PF09073', NULL, 'BUD22', 435, NULL, 'BUD22', 269217),
(450124, 'PF10897', NULL, 'Protein of unknown function (DUF2713)', 235, NULL, 'DUF2713', 269218),
(450125, 'PF13008', NULL, 'Zinc-binding domain of Paramyxoviridae V protein', 45, NULL, 'zf-Paramyx-P', 269219),
(450126, 'PF09808', NULL, 'Small nuclear RNA activating complex (SNAPc), subunit 1', 192, NULL, 'SNAPC1', 269220),
(450127, 'PF18085', NULL, 'Maltokinase N-terminal cap domain', 88, NULL, 'Mak_N_cap', 269221),
(450128, 'PF20589', NULL, 'Family of unknown function (DUF6790)', 158, NULL, 'DUF6790', 269222),
(450129, 'PF00696', NULL, 'Amino acid kinase family', 241, NULL, 'AA_kinase', 269223),
(450130, 'PF00525', NULL, 'Alpha crystallin A chain, N terminal', 56, NULL, 'Crystallin', 269224),
(450131, 'PF01355', NULL, 'High potential iron-sulfur protein', 66, NULL, 'HIPIP', 269225),
(450132, 'PF02451', NULL, 'Nodulin', 188, NULL, 'Nodulin', 269226),
(450133, 'PF05387', NULL, 'Chorion family 3', 277, NULL, 'Chorion_3', 269227),
(450134, 'PF18870', NULL, 'HEPN/RES N-terminal domain 1', 131, NULL, 'HEPN_RES_NTD1', 269228),
(450135, 'PF04268', NULL, 'Sarcosine oxidase, gamma subunit family', 152, NULL, 'SoxG', 269229),
(450136, 'PF14166', NULL, 'YueH-like protein', 79, NULL, 'YueH', 269230),
(450137, 'PF11016', NULL, 'Protein of unknown function (DUF2854)', 146, NULL, 'DUF2854', 269231),
(450138, 'PF15559', NULL, 'Domain of unknown function (DUF4660)', 107, NULL, 'DUF4660', 269232),
(450139, 'PF16758', NULL, 'Herpes-like virus membrane glycoprotein UL141', 191, NULL, 'UL141', 269233),
(450140, 'PF19494', NULL, 'Family of unknown function (DUF6029)', 538, NULL, 'DUF6029', 269234),
(450141, 'PF14250', NULL, 'AbrB-like transcriptional regulator', 70, NULL, 'AbrB-like', 269235),
(450142, 'PF01106', NULL, 'NifU-like domain', 67, NULL, 'NifU', 269236),
(450143, 'PF17459', NULL, 'Family of unknown function (DUF5422)', 153, NULL, 'DUF5422', 269237),
(450144, 'PF19874', NULL, 'Family of unknown function (DUF6347)', 124, NULL, 'DUF6347', 269238),
(450145, 'PF06874', NULL, 'Firmicute fructose-1,6-bisphosphatase', 639, NULL, 'FBPase_2', 269239),
(450146, 'PF06951', NULL, 'Group XII secretory phospholipase A2 precursor (PLA2G12)', 186, NULL, 'PLA2G12', 269240),
(450147, 'PF09216', NULL, 'Pfg27', 174, NULL, 'Pfg27', 269241),
(450148, 'PF08578', NULL, 'Protein of unknown function (DUF1765)', 125, NULL, 'DUF1765', 269242),
(450149, 'PF09564', NULL, 'NgoBV restriction endonuclease', 238, NULL, 'RE_NgoBV', 269243),
(450150, 'PF05218', NULL, 'Protein of unknown function (DUF713)', 185, NULL, 'DUF713', 269244),
(450151, 'PF19715', NULL, 'Family of unknown function (DUF6210)', 117, NULL, 'DUF6210', 269245),
(450152, 'PF10295', NULL, 'Uncharacterised protein (DUF2406)', 63, NULL, 'DUF2406', 269246),
(450153, 'PF03864', NULL, 'Phage major capsid protein E', 330, NULL, 'Phage_cap_E', 269247),
(450154, 'PF01064', NULL, 'Activin types I and II receptor domain', 82, NULL, 'Activin_recp', 269248),
(450155, 'PF11723', NULL, 'Homotrimeric ring hydroxylase', 241, NULL, 'Aromatic_hydrox', 269249);
INSERT INTO "PUBLIC"."MODEL" VALUES
(450156, 'PF08849', NULL, 'BrxA', 184, NULL, 'BrxA', 269250),
(450157, 'PF09259', NULL, 'Fungal immunomodulatory protein Fve', 111, NULL, 'Fve', 269251),
(450158, 'PF14044', NULL, 'NETI protein', 56, NULL, 'NETI', 269252),
(450159, 'PF07449', NULL, 'Hydrogenase-1 expression protein HyaE', 108, NULL, 'HyaE', 269253),
(450160, 'PF05786', NULL, 'Condensin complex subunit 2', 776, NULL, 'Cnd2', 269254),
(450161, 'PF06482', NULL, 'Collagenase NC10 and Endostatin', 170, NULL, 'Endostatin', 269255),
(450162, 'PF05440', NULL, 'Tetrahydromethanopterin S-methyltransferase subunit B', 94, NULL, 'MtrB', 269256),
(450163, 'PF18449', NULL, 'Delta endotoxin', 63, NULL, 'Endotoxin_C2', 269257),
(450164, 'PF10228', NULL, 'Uncharacterised conserved protein (DUF2228)', 251, NULL, 'DUF2228', 269258),
(450165, 'PF01640', NULL, 'Peptidase C10 family', 194, NULL, 'Peptidase_C10', 269259),
(450166, 'PF04713', NULL, 'Poxvirus protein I5', 75, NULL, 'Pox_I5', 269260),
(450167, 'PF14463', NULL, 'E1 N-terminal domain', 151, NULL, 'E1-N', 269261),
(450168, 'PF07440', NULL, 'Caerin 1 protein', 24, NULL, 'Caerin_1', 269262),
(450169, 'PF14821', NULL, 'Threonine synthase N terminus', 79, NULL, 'Thr_synth_N', 269263),
(450170, 'PF03662', NULL, 'Glycosyl hydrolase family 79, N-terminal domain', 318, NULL, 'Glyco_hydro_79n', 269264),
(450171, 'PF18412', NULL, 'Outer-membrane lipoprotein Wza C-terminal domain', 30, NULL, 'Wza_C', 269265),
(450172, 'PF08361', NULL, 'MAATS-type transcriptional repressor, C-terminal region', 121, NULL, 'TetR_C_2', 269266),
(450173, 'PF09304', NULL, 'Cortexillin I, coiled coil', 107, NULL, 'Cortex-I_coil', 269267),
(450174, 'PF09579', NULL, 'Sporulation protein YtfJ (Spore_YtfJ)', 81, NULL, 'Spore_YtfJ', 269268),
(450175, 'PF03858', NULL, 'Crustacean neurohormone H', 41, NULL, 'Crust_neuro_H', 269269),
(450176, 'PF10576', NULL, 'Iron-sulfur binding domain of endonuclease III', 17, NULL, 'EndIII_4Fe-2S', 269270),
(450177, 'PF07361', NULL, 'Cytochrome b562', 102, NULL, 'Cytochrom_B562', 269271),
(450178, 'PF03615', NULL, 'GCM motif protein', 140, NULL, 'GCM', 269272),
(450179, 'PF07489', NULL, 'Translocated intimin receptor (Tir) C-terminus', 221, NULL, 'Tir_receptor_C', 269273),
(450180, 'PF01452', NULL, 'Rotavirus non structural protein', 173, NULL, 'Rota_NSP4', 269274),
(450181, 'PF13787', NULL, 'Protein of unknown function with HXXEE motif', 111, NULL, 'HXXEE', 269275),
(450182, 'PF01280', NULL, 'Ribosomal protein L19e', 144, NULL, 'Ribosomal_L19e', 269276),
(450183, 'PF10348', NULL, 'Domain of unknown function (DUF2427)', 105, NULL, 'DUF2427', 269277),
(450184, 'PF16430', NULL, 'Domain of unknown function (DUF5027)', 187, NULL, 'DUF5027', 269278),
(450185, 'PF01814', NULL, 'Hemerythrin HHE cation binding domain', 131, NULL, 'Hemerythrin', 269279),
(450186, 'PF09098', NULL, 'Quinohemoprotein amine dehydrogenase A, alpha subunit, haem binding', 167, NULL, 'Dehyd-heme_bind', 269280),
(450187, 'PF00372', NULL, 'Hemocyanin, copper containing domain', 270, NULL, 'Hemocyanin_M', 269281),
(450188, 'PF18966', NULL, 'Uncharacterised lipoprotein', 181, NULL, 'Lipoprotein_23', 269282),
(450189, 'PF16245', NULL, 'Domain of unknown function (DUF4902)', 118, NULL, 'DUF4902', 269283),
(450190, 'PF11434', NULL, 'Chemotaxis-inhibiting protein CHIPS', 91, NULL, 'CHIPS', 269284),
(450191, 'PF11527', NULL, 'The ARF-like 2 binding protein BART', 116, NULL, 'ARL2_Bind_BART', 269285),
(450192, 'PF08234', NULL, 'Chromosome segregation protein Spc25', 73, NULL, 'Spindle_Spc25', 269286),
(450193, 'PF01654', NULL, 'Cytochrome bd terminal oxidase subunit I', 419, NULL, 'Cyt_bd_oxida_I', 269287),
(450194, 'PF10177', NULL, 'Uncharacterised conserved protein (DUF2371)', 143, NULL, 'DUF2371', 269288),
(450195, 'PF12947', NULL, 'EGF domain', 36, NULL, 'EGF_3', 269289),
(450196, 'PF06542', NULL, 'Regulator protein PHA-1', 408, NULL, 'PHA-1', 269290),
(450197, 'PF15984', NULL, 'Bacterial collagen, middle region', 198, NULL, 'Collagen_mid', 269291),
(450198, 'PF00093', NULL, 'von Willebrand factor type C domain', 57, NULL, 'VWC', 269292); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(450199, 'PF10265', NULL, 'Mitoguardin', 539, NULL, 'Miga', 269293),
(450200, 'PF14076', NULL, 'Domain of unknown function (DUF4258)', 63, NULL, 'DUF4258', 269294),
(450201, 'PF18993', NULL, 'Rv0078B-related antitoxin', 63, NULL, 'Rv0078B', 269295),
(450202, 'PF05133', NULL, 'Phage portal protein, SPP1 Gp6-like', 420, NULL, 'Phage_prot_Gp6', 269296),
(450203, 'PF05242', NULL, 'Glycosylation-dependent cell adhesion molecule 1 (GlyCAM-1)', 135, NULL, 'GLYCAM-1', 269297),
(450204, 'PF16574', NULL, 'Coiled-coil region of centrosome protein CE290', 128, NULL, 'CEP209_CC5', 269298),
(450205, 'PF18324', NULL, 'Hypothetical protein TT1725', 110, NULL, 'TT1725', 269299),
(450206, 'PF13366', NULL, 'PD-(D/E)XK nuclease superfamily', 118, NULL, 'PDDEXK_3', 269300),
(450207, 'PF17764', NULL, '3''DNA-binding domain (3''BD)', 96, NULL, 'PriA_3primeBD', 269301),
(450208, 'PF04700', NULL, 'Structural glycoprotein p40/gp41 conserved region', 185, NULL, 'Baculo_gp41', 269302),
(450209, 'PF04020', NULL, 'Mycobacterial 4 TMS phage holin, superfamily IV', 105, NULL, 'Phage_holin_4_2', 269303),
(450210, 'PF07367', NULL, 'Fungal fruit body lectin', 140, NULL, 'FB_lectin', 269304),
(450211, 'PF12727', NULL, 'PBP superfamily domain', 193, NULL, 'PBP_like', 269305),
(450212, 'PF15423', NULL, 'FLYWCH-type zinc finger-containing protein', 107, NULL, 'FLYWCH_N', 269306),
(450213, 'PF03104', NULL, 'DNA polymerase family B, exonuclease domain', 337, NULL, 'DNA_pol_B_exo1', 269307),
(450214, 'PF04855', NULL, 'SNF5 / SMARCB1 / INI1', 236, NULL, 'SNF5', 269308),
(450215, 'PF16535', NULL, 'Type III cell invasion protein SipB', 155, NULL, 'T3SSipB', 269309),
(450216, 'PF00847', NULL, 'AP2 domain', 54, NULL, 'AP2', 269310),
(450217, 'PF09563', NULL, 'LlaJI restriction endonuclease', 365, NULL, 'RE_LlaJI', 269311),
(450218, 'PF14244', NULL, 'gag-polypeptide of LTR copia-type', 48, NULL, 'Retrotran_gag_3', 269312),
(450219, 'PF00243', NULL, 'Nerve growth factor family', 112, NULL, 'NGF', 269313),
(450220, 'PF14925', NULL, 'Domain of unknown function', 640, NULL, 'HPHLAWLY', 269314),
(450221, 'PF19834', NULL, 'Family of unknown function (DUF6314)', 134, NULL, 'DUF6314', 269315),
(450222, 'PF04077', NULL, 'DsrH like protein', 87, NULL, 'DsrH', 269316),
(450223, 'PF01300', NULL, 'Telomere recombination', 179, NULL, 'Sua5_yciO_yrdC', 269317),
(450224, 'PF07238', NULL, 'PilZ domain', 103, NULL, 'PilZ', 269318),
(450225, 'PF07941', NULL, 'Potassium channel Kv1.4 tandem inactivation domain', 74, NULL, 'K_channel_TID', 269319),
(450226, 'PF11238', NULL, 'Protein of unknown function (DUF3039)', 56, NULL, 'DUF3039', 269320),
(450227, 'PF15011', NULL, 'Casein Kinase 2 substrate', 161, NULL, 'CK2S', 269321),
(450228, 'PF15112', NULL, 'Domain of unknown function (DUF4559)', 311, NULL, 'DUF4559', 269322),
(450229, 'PF12794', NULL, 'Mechanosensitive ion channel inner membrane domain 1', 339, NULL, 'MscS_TM', 269323),
(450230, 'PF00203', NULL, 'Ribosomal protein S19', 81, NULL, 'Ribosomal_S19', 269324),
(450231, 'PF06844', NULL, 'Protein of unknown function (DUF1244)', 67, NULL, 'DUF1244', 269325),
(450232, 'PF00098', NULL, 'Zinc knuckle', 18, NULL, 'zf-CCHC', 269326),
(450233, 'PF05603', NULL, 'Protein of unknown function (DUF775)', 199, NULL, 'DUF775', 269327),
(450234, 'PF08710', NULL, 'Coronavirus replicase NSP9', 111, NULL, 'CoV_NSP9', 269328),
(450235, 'PF11687', NULL, 'Domain of unknown function (DUF3284)', 119, NULL, 'DUF3284', 269329),
(450236, 'PF18434', NULL, 'Kazal-type serine protease inhibitor domain', 50, NULL, 'Kazal_3', 269330),
(450237, 'PF17236', NULL, 'Family of unknown function (DUF5309)', 283, NULL, 'DUF5309', 269331),
(450238, 'PF06298', NULL, 'Photosystem II protein Y (PsbY)', 35, NULL, 'PsbY', 269332),
(450239, 'PF16746', NULL, 'BAR domain of APPL family', 238, NULL, 'BAR_3', 269333),
(450240, 'PF11288', NULL, 'Protein of unknown function (DUF3089)', 200, NULL, 'DUF3089', 269334),
(450241, 'PF18403', NULL, 'Thioredoxin-like domain', 213, NULL, 'Thioredoxin_15', 269335),
(450242, 'PF07381', NULL, 'Winged helix DNA-binding domain (DUF1495)', 90, NULL, 'DUF1495', 269336);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(450243, 'PF07660', NULL, 'Secretin and TonB N terminus short domain', 52, NULL, 'STN', 269337),
(450244, 'PF19400', NULL, 'Family of unknown function (DUF5975)', 125, NULL, 'DUF5975', 269338),
(450245, 'PF04205', NULL, 'FMN-binding domain', 70, NULL, 'FMN_bind', 269339),
(450246, 'PF09387', NULL, 'Mitochondrial RNA binding protein MRP', 219, NULL, 'MRP', 269340),
(450247, 'PF14604', NULL, 'Variant SH3 domain', 49, NULL, 'SH3_9', 269341),
(450248, 'PF01795', NULL, 'MraW methylase family', 309, NULL, 'Methyltransf_5', 269342),
(450249, 'PF05339', NULL, 'Protein of unknown function (DUF739)', 69, NULL, 'DUF739', 269343),
(450250, 'PF10823', NULL, 'Protein of unknown function (DUF2568)', 92, NULL, 'DUF2568', 269344),
(450251, 'PF17088', NULL, 'Uncharacterised protein family', 388, NULL, 'YCF90', 269345),
(450252, 'PF16019', NULL, 'Cysteine/serine-rich nuclear protein N-terminus', 219, NULL, 'CSRNP_N', 269346),
(450253, 'PF00978', NULL, 'RNA dependent RNA polymerase', 440, NULL, 'RdRP_2', 269347),
(450254, 'PF12209', NULL, 'Leucine permease transcriptional regulator helical domain', 77, NULL, 'SAC3', 269348),
(450255, 'PF16377', NULL, 'Domain of unknown function', 152, NULL, 'DUF4987', 269349),
(450256, 'PF18316', NULL, 'S-layer protein SbsC C-terminal domain', 86, NULL, 'S-l_SbsC_C', 269350),
(450257, 'PF02677', NULL, 'Epoxyqueuosine reductase QueH', 175, NULL, 'QueH', 269351),
(450258, 'PF08999', NULL, 'Surfactant protein C, N terminal propeptide', 96, NULL, 'SP_C-Propep', 269352),
(450259, 'PF09960', NULL, 'Uncharacterised protein conserved in bacteria (DUF2194)', 692, NULL, 'DUF2194', 269353),
(450260, 'PF14495', NULL, 'Cytochrome c-550 domain', 136, NULL, 'Cytochrom_C550', 269354),
(450261, 'PF01299', NULL, 'Lysosome-associated membrane glycoprotein (Lamp)', 148, NULL, 'Lamp', 269355),
(450262, 'PF13223', NULL, 'Protein of unknown function (DUF4031)', 79, NULL, 'DUF4031', 269356),
(450263, 'PF09203', NULL, 'MspA', 175, NULL, 'MspA', 269357),
(450264, 'PF03431', NULL, 'RNA replicase, beta-chain', 540, NULL, 'RNA_replicase_B', 269358),
(450265, 'PF16136', NULL, 'Putative nuclear localisation signal', 114, NULL, 'NINJA_B', 269359),
(450266, 'PF20149', NULL, 'Domain of unknown function (DUF6532)', 195, NULL, 'DUF6532', 269360),
(450267, 'PF03239', NULL, 'Iron permease FTR1 family', 306, NULL, 'FTR1', 269361),
(450268, 'PF03941', NULL, 'Inner centromere protein, ARK binding region', 55, NULL, 'INCENP_ARK-bind', 269362),
(450269, 'PF13202', NULL, 'EF hand', 25, NULL, 'EF-hand_5', 269363),
(450270, 'PF02326', NULL, 'Plant ATP synthase F0', 86, NULL, 'YMF19', 269364),
(450271, 'PF05399', NULL, 'Ectropic viral integration site 2A protein (EVI2A)', 232, NULL, 'EVI2A', 269365),
(450272, 'PF18191', NULL, 'Hydroquinone 1,2-dioxygenase large subunit N-terminal', 151, NULL, 'PnpCD_PnpD_N', 269366),
(450273, 'PF02664', NULL, 'S-Ribosylhomocysteinase (LuxS)', 154, NULL, 'LuxS', 269367),
(450274, 'PF06307', NULL, 'Herpesvirus IR6 protein', 214, NULL, 'Herpes_IR6', 269368),
(450275, 'PF09055', NULL, 'Nickel-containing superoxide dismutase', 127, NULL, 'Sod_Ni', 269369),
(450276, 'PF16124', NULL, 'RecQ zinc-binding', 66, NULL, 'RecQ_Zn_bind', 269370),
(450277, 'PF12401', NULL, 'FhaA, N-terminal domain', 115, NULL, 'FhaA_N', 269371),
(450278, 'PF13100', NULL, 'OstA-like protein', 158, NULL, 'OstA_2', 269372),
(450279, 'PF05433', NULL, 'Glycine zipper 2TM domain', 42, NULL, 'Rick_17kDa_Anti', 269373),
(450280, 'PF19476', NULL, 'Family of unknown function (DUF6013)', 184, NULL, 'DUF6013', 269374),
(450281, 'PF05986', NULL, 'ADAM-TS Spacer 1', 115, NULL, 'ADAMTS_spacer1', 269375),
(450282, 'PF17842', NULL, 'Double-stranded RNA binding domain 2', 147, NULL, 'dsRBD2', 269376),
(450283, 'PF18813', NULL, 'phage-Barnase-EndoU-ColicinE5/D-RelE like nuclease4', 186, NULL, 'PBECR4', 269377),
(450284, 'PF14857', NULL, 'TMEM151 family', 429, NULL, 'TMEM151', 269378),
(450285, 'PF16686', NULL, 'ssDNA-binding domain of telomere protection protein', 154, NULL, 'POT1PC', 269379),
(450286, 'PF11524', NULL, 'Selenium binding protein', 82, NULL, 'SeleniumBinding', 269380);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(450287, 'PF07757', NULL, 'Predicted AdoMet-dependent methyltransferase', 113, NULL, 'AdoMet_MTase', 269381),
(450288, 'PF13272', NULL, 'Putative 2/3 transmembrane domain holin', 106, NULL, 'Holin_2-3', 269382),
(450289, 'PF07521', NULL, 'Zn-dependent metallo-hydrolase RNA specificity domain', 63, NULL, 'RMMBL', 269383),
(450290, 'PF01791', NULL, 'DeoC/LacD family aldolase', 231, NULL, 'DeoC', 269384),
(450291, 'PF03585', NULL, 'Herpesvirus ICP4-like protein C-terminal region', 444, NULL, 'Herpes_ICP4_C', 269385),
(450292, 'PF18371', NULL, 'Flavin adenine dinucleotide (FAD)-dependent sulfhydryl oxidase', 104, NULL, 'FAD_SOX', 269386),
(450293, 'PF15189', NULL, 'Meiosis-specific coiled-coil domain-containing protein MEIOC', 166, NULL, 'MEIOC', 269387),
(450294, 'PF08555', NULL, 'FAM32A', 98, NULL, 'FAM32A', 269388),
(450295, 'PF17912', NULL, 'MalK OB fold domain', 53, NULL, 'OB_MalK', 269389),
(450296, 'PF05564', NULL, 'Dormancy/auxin associated protein', 118, NULL, 'Auxin_repressed', 269390),
(450297, 'PF00323', NULL, 'Mammalian defensin', 29, NULL, 'Defensin_1', 269391),
(450298, 'PF00510', NULL, 'Cytochrome c oxidase subunit III', 258, NULL, 'COX3', 269392),
(450299, 'PF11924', NULL, 'Inverse autotransporter, beta-domain', 280, NULL, 'IAT_beta', 269393),
(450300, 'PF03856', NULL, 'Beta-glucosidase (SUN family)', 245, NULL, 'SUN', 269394),
(450301, 'PF18513', NULL, 'Prodomain subtilisin 2', 88, NULL, 'Pro_sub2', 269395),
(450302, 'PF02005', NULL, 'N2,N2-dimethylguanosine tRNA methyltransferase', 376, NULL, 'TRM', 269396),
(450303, 'PF15524', NULL, 'Novel toxin 17', 94, NULL, 'Ntox17', 269397),
(450304, 'PF19510', NULL, 'Protein of unknown function (DUF6044)', 566, NULL, 'DUF6044', 269398),
(450305, 'PF13283', NULL, 'Bacteriophage N adsorption protein A C-term', 173, NULL, 'NfrA_C', 269399),
(450306, 'PF06953', NULL, 'Arsenical resistance operon protein ArsD', 123, NULL, 'ArsD', 269400),
(450307, 'PF06013', NULL, 'Proteins of 100 residues with WXG', 86, NULL, 'WXG100', 269401),
(450308, 'PF08738', NULL, 'Gon7 family', 108, NULL, 'Gon7', 269402),
(450309, 'PF17209', NULL, 'Hfq protein', 64, NULL, 'Hfq', 269403),
(450310, 'PF19023', NULL, 'Family of unknown function (DUF5749)', 78, NULL, 'DUF5749', 269404),
(450311, 'PF13167', NULL, 'GTP-binding GTPase N-terminal', 89, NULL, 'GTP-bdg_N', 269405),
(450312, 'PF08044', NULL, 'Domain of unknown function (DUF1707)', 53, NULL, 'DUF1707', 269406),
(450313, 'PF03449', NULL, 'Transcription elongation factor, N-terminal', 71, NULL, 'GreA_GreB_N', 269407),
(450314, 'PF17579', NULL, 'Family of unknown function (DUF5482)', 159, NULL, 'DUF5482', 269408),
(450315, 'PF13035', NULL, 'Protein of unknown function (DUF3896)', 61, NULL, 'DUF3896', 269409),
(450316, 'PF12418', NULL, 'Acyl-CoA dehydrogenase N terminal', 32, NULL, 'AcylCoA_DH_N', 269410),
(450317, 'PF10766', NULL, 'Multidrug efflux pump-associated protein AcrZ', 48, NULL, 'AcrZ', 269411),
(450318, 'PF03194', NULL, 'LUC7 N_terminus', 251, NULL, 'LUC7', 269412),
(450319, 'PF07980', NULL, 'SusD family', 299, NULL, 'SusD_RagB', 269413),
(450320, 'PF08020', NULL, 'Protein of unknown function (DUF1706)', 166, NULL, 'DUF1706', 269414),
(450321, 'PF18573', NULL, 'BclA C-terminal domain', 128, NULL, 'BclA_C', 269415),
(450322, 'PF01139', NULL, 'tRNA-splicing ligase RtcB', 413, NULL, 'RtcB', 269416),
(450323, 'PF05655', NULL, 'Pseudomonas avirulence D protein (AvrD)', 332, NULL, 'AvrD', 269417),
(450324, 'PF04184', NULL, 'ST7 protein', 532, NULL, 'ST7', 269418),
(450325, 'PF00649', NULL, 'Copper fist DNA binding domain', 39, NULL, 'Copper-fist', 269419),
(450326, 'PF09996', NULL, 'Uncharacterized protein conserved in bacteria (DUF2237)', 115, NULL, 'DUF2237', 269420),
(450327, 'PF06281', NULL, 'Structural protein VP1/VP3', 73, NULL, 'VP1_VP3', 269421),
(450328, 'PF14807', NULL, 'Adaptin AP4 complex epsilon appendage platform', 100, NULL, 'AP4E_app_platf', 269422),
(450329, 'PF01693', NULL, 'Caulimovirus viroplasmin', 44, NULL, 'Cauli_VI', 269423),
(450330, 'PF04750', NULL, 'FAR-17a/AIG1-like protein', 202, NULL, 'Far-17a_AIG1', 269424);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(450331, 'PF15250', NULL, 'Raftlin', 459, NULL, 'Raftlin', 269425),
(450332, 'PF03234', NULL, 'Cdc37 N terminal kinase binding', 130, NULL, 'CDC37_N', 269426),
(450333, 'PF18817', NULL, 'Repeat of uncharacterized protein PH0542', 45, NULL, 'HEAT_UF', 269427),
(450334, 'PF07532', NULL, 'Bacterial Ig-like domain (group 4)', 59, NULL, 'Big_4', 269428),
(450335, 'PF20010', NULL, 'Collagen trimerization domain', 49, NULL, 'Collagen_trimer', 269429),
(450336, 'PF06340', NULL, 'Vibrio cholerae toxin co-regulated pilus biosynthesis protein F', 317, NULL, 'TcpF', 269430),
(450337, 'PF10162', NULL, 'G8 domain', 122, NULL, 'G8', 269431),
(450338, 'PF04032', NULL, 'RNAse P Rpr2/Rpp21/SNM1 subunit domain', 90, NULL, 'Rpr2', 269432),
(450339, 'PF04133', NULL, 'Vacuolar protein sorting 55', 120, NULL, 'Vps55', 269433),
(450340, 'PF09119', NULL, 'SicP binding', 84, NULL, 'SicP-binding', 269434),
(450341, 'PF12154', NULL, 'Glycoprotein B N-terminal antigenic domain of HCMV', 36, NULL, 'HCMVantigenic_N', 269435),
(450342, 'PF13176', NULL, 'Tetratricopeptide repeat', 36, NULL, 'TPR_7', 269436),
(450343, 'PF10980', NULL, 'Protein of unknown function (DUF2787)', 130, NULL, 'DUF2787', 269437),
(450344, 'PF05311', NULL, 'Baculovirus 33KDa late protein (PP31)', 272, NULL, 'Baculo_PP31', 269438),
(450345, 'PF12278', NULL, 'Sex determination protein N terminal', 140, NULL, 'SDP_N', 269439),
(450346, 'PF09301', NULL, 'Domain of unknown function (DUF1970)', 112, NULL, 'DUF1970', 269440),
(450347, 'PF06365', NULL, 'CD34/Podocalyxin family', 211, NULL, 'CD34_antigen', 269441),
(450348, 'PF06733', NULL, 'DEAD_2', 175, NULL, 'DEAD_2', 269442),
(450349, 'PF09463', NULL, 'Opy2 protein', 35, NULL, 'Opy2', 269443),
(450350, 'PF10923', NULL, 'BREX system ATP-binding protein BrxC/D', 414, NULL, 'BrxC_BrxD', 269444),
(450351, 'PF10255', NULL, 'RNA polymerase I-associated factor PAF67', 402, NULL, 'Paf67', 269445),
(450352, 'PF08136', NULL, '30S ribosomal protein subunit S22 family', 46, NULL, 'Ribosomal_S22', 269446),
(450353, 'PF20222', NULL, 'Family of unknown function (DUF6581)', 411, NULL, 'DUF6581', 269447),
(450354, 'PF18479', NULL, 'PIN like domain', 118, NULL, 'PIN_11', 269448),
(450355, 'PF19098', NULL, 'Family of unknown function (DUF5785)', 98, NULL, 'DUF5785', 269449),
(450356, 'PF03828', NULL, 'Cid1 family poly A polymerase', 63, NULL, 'PAP_assoc', 269450),
(450357, 'PF14087', NULL, 'Domain of unknown function (DUF4267)', 112, NULL, 'DUF4267', 269451),
(450358, 'PF10789', NULL, 'Phage RNA polymerase binding, RpbA', 108, NULL, 'Phage_RpbA', 269452),
(450359, 'PF05503', NULL, 'Poxvirus G7-like', 367, NULL, 'Pox_G7', 269453),
(450360, 'PF09784', NULL, 'Mitochondrial ribosomal protein L31', 102, NULL, 'L31', 269454),
(450361, 'PF01983', NULL, 'Guanylyl transferase CofC like', 217, NULL, 'CofC', 269455),
(450362, 'PF10427', NULL, 'Argonaute hook', 169, NULL, 'Ago_hook', 269456),
(450363, 'PF13913', NULL, 'zinc-finger of a C2HC-type', 25, NULL, 'zf-C2HC_2', 269457),
(450364, 'PF18906', NULL, 'Phage tail tube protein', 270, NULL, 'Phage_tube_2', 269458),
(450365, 'PF00936', NULL, 'BMC domain', 74, NULL, 'BMC', 269459),
(450366, 'PF02866', NULL, 'lactate/malate dehydrogenase, alpha/beta C-terminal domain', 167, NULL, 'Ldh_1_C', 269460),
(450367, 'PF09375', NULL, 'Imelysin', 291, NULL, 'Peptidase_M75', 269461),
(450368, 'PF04062', NULL, 'ARP2/3 complex ARPC3 (21 kDa) subunit', 174, NULL, 'P21-Arc', 269462),
(450369, 'PF19883', NULL, 'Family of unknown function (DUF6356)', 64, NULL, 'DUF6356', 269463),
(450370, 'PF08173', NULL, 'Membrane bound YbgT-like protein', 27, NULL, 'YbgT_YccB', 269464),
(450371, 'PF14016', NULL, 'Protein of unknown function (DUF4232)', 129, NULL, 'DUF4232', 269465),
(450372, 'PF00837', NULL, 'Iodothyronine deiodinase', 237, NULL, 'T4_deiodinase', 269466),
(450373, 'PF19323', NULL, 'BTB/POZ domain-containing protein KCTD4 C-terminus', 122, NULL, 'KCTD4_C', 269467),
(450374, 'PF01203', NULL, 'Type II secretion system (T2SS), protein N', 211, NULL, 'T2SSN', 269468),
(450375, 'PF08516', NULL, 'ADAM cysteine-rich', 116, NULL, 'ADAM_CR', 269469);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(450376, 'PF13259', NULL, 'Protein of unknown function (DUF4050)', 183, NULL, 'DUF4050', 269470),
(450377, 'PF05180', NULL, 'DNL zinc finger', 64, NULL, 'zf-DNL', 269471),
(450378, 'PF06924', NULL, 'Protein of unknown function (DUF1281)', 179, NULL, 'DUF1281', 269472),
(450379, 'PF15397', NULL, 'Domain of unknown function (DUF4618)', 258, NULL, 'DUF4618', 269473),
(450380, 'PF20024', NULL, 'Family of unknown function (DUF6432)', 97, NULL, 'DUF6432', 269474),
(450381, 'PF19046', NULL, 'GM130 C-terminal binding motif', 46, NULL, 'GM130_C', 269475),
(450382, 'PF02610', NULL, 'L-arabinose isomerase', 356, NULL, 'Arabinose_Isome', 269476),
(450383, 'PF18639', NULL, 'Yeast longin domain', 161, NULL, 'Longin_2', 269477),
(450384, 'PF09313', NULL, 'Domain of unknown function (DUF1971)', 80, NULL, 'DUF1971', 269478),
(450385, 'PF12268', NULL, 'Protein of unknown function (DUF3612)', 176, NULL, 'DUF3612', 269479),
(450386, 'PF13297', NULL, 'Replication stress response SDE2 C-terminal', 82, NULL, 'SDE2_2C', 269480),
(450387, 'PF12200', NULL, 'Domain of unknown function (DUF3597)', 127, NULL, 'DUF3597', 269481),
(450388, 'PF00501', NULL, 'AMP-binding enzyme', 424, NULL, 'AMP-binding', 269482),
(450389, 'PF17505', NULL, 'Family of unknown function (DUF5437)', 60, NULL, 'DUF5437', 269483),
(450390, 'PF16408', NULL, 'Domain of unknown function (DUF5016)', 123, NULL, 'DUF5016', 269484),
(450391, 'PF03921', NULL, 'Intercellular adhesion molecule (ICAM), N-terminal domain', 91, NULL, 'ICAM_N', 269485),
(450392, 'PF15875', NULL, 'Domain of unknown function (DUF4731)', 75, NULL, 'DUF4731', 269486),
(450393, 'PF07797', NULL, 'Protein of unknown function (DUF1639)', 50, NULL, 'DUF1639', 269487),
(450394, 'PF11352', NULL, 'Protein of unknown function (DUF3155)', 88, NULL, 'DUF3155', 269488),
(450395, 'PF00154', NULL, 'recA bacterial DNA recombination protein', 262, NULL, 'RecA', 269489),
(450396, 'PF17809', NULL, 'UPA domain', 131, NULL, 'UPA_2', 269490),
(450397, 'PF01225', NULL, 'Mur ligase family, catalytic domain', 94, NULL, 'Mur_ligase', 269491),
(450398, 'PF06480', NULL, 'FtsH Extracellular', 109, NULL, 'FtsH_ext', 269492),
(450399, 'PF13968', NULL, 'Domain of unknown function (DUF4220)', 346, NULL, 'DUF4220', 269493),
(450400, 'PF00524', NULL, 'E1 Protein, N terminal domain', 121, NULL, 'PPV_E1_N', 269494),
(450401, 'PF12140', NULL, 'SLED domain', 112, NULL, 'SLED', 269495),
(450402, 'PF10967', NULL, 'Protein of unknown function (DUF2769)', 58, NULL, 'DUF2769', 269496),
(450403, 'PF01890', NULL, 'Cobalamin synthesis G C-terminus', 116, NULL, 'CbiG_C', 269497),
(450404, 'PF06443', NULL, 'SEF14-like adhesin', 165, NULL, 'SEF14_adhesin', 269498),
(450405, 'PF13737', NULL, 'Transposase DDE domain', 112, NULL, 'DDE_Tnp_1_5', 269499),
(450406, 'PF05155', NULL, 'Phage X family', 88, NULL, 'Phage_X', 269500),
(450407, 'PF15239', NULL, 'Domain of unknown function (DUF4586)', 302, NULL, 'DUF4586', 269501),
(450408, 'PF06050', NULL, '2-hydroxyglutaryl-CoA dehydratase, D-component', 324, NULL, 'HGD-D', 269502),
(450409, 'PF12673', NULL, 'Domain of unknown function (DUF3794)', 77, NULL, 'DUF3794', 269503),
(450410, 'PF18051', NULL, '26S proteasome non-ATPase regulatory subunit RPN1 C-terminal', 54, NULL, 'RPN1_C', 269504),
(450411, 'PF08409', NULL, 'Protein O-mannosyl-transferase TMTC, DUF1736', 75, NULL, 'TMTC_DUF1736', 269505),
(450412, 'PF16631', NULL, 'Unstructured region 4 on terminal uridylyltransferase 7', 88, NULL, 'TUTF7_u4', 269506),
(450413, 'PF06078', NULL, 'Bacterial protein of unknown function (DUF937)', 135, NULL, 'DUF937', 269507),
(450414, 'PF13199', NULL, 'Glycosyl hydrolase family 66', 553, NULL, 'Glyco_hydro_66', 269508),
(450415, 'PF09730', NULL, 'Microtubule-associated protein Bicaudal-D', 718, NULL, 'BicD', 269509),
(450416, 'PF05721', NULL, 'Phytanoyl-CoA dioxygenase (PhyH)', 211, NULL, 'PhyH', 269510),
(450417, 'PF04437', NULL, 'RINT-1 / TIP-1 family', 513, NULL, 'RINT1_TIP1', 269511),
(450418, 'PF15573', NULL, 'Immunity protein 47', 258, NULL, 'Imm47', 269512),
(450419, 'PF05420', NULL, 'Cellulose synthase operon protein C C-terminus (BCSC_C)', 339, NULL, 'BCSC_C', 269513);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(450420, 'PF15670', NULL, 'Spermatid maturation protein 1', 253, NULL, 'Spem1', 269514),
(450421, 'PF18202', NULL, 'T-Q ester bond containing domain', 131, NULL, 'TQ', 269515),
(450422, 'PF17256', NULL, 'Anaphase-promoting complex, subunit 16', 80, NULL, 'ANAPC16', 269516),
(450423, 'PF03076', NULL, 'Equine arteritis virus GP3', 160, NULL, 'GP3', 269517),
(450424, 'PF00162', NULL, 'Phosphoglycerate kinase', 382, NULL, 'PGK', 269518),
(450425, 'PF00110', NULL, 'wnt family', 309, NULL, 'wnt', 269519),
(450426, 'PF15937', NULL, 'prlF antitoxin for toxin YhaV_toxin', 99, NULL, 'PrlF_antitoxin', 269520),
(450427, 'PF01385', NULL, 'Probable transposase', 120, NULL, 'OrfB_IS605', 269521),
(450428, 'PF04527', NULL, 'Drosophila Retinin like protein', 63, NULL, 'Retinin_C', 269522),
(450429, 'PF12432', NULL, 'Protein of unknown function (DUF3677)', 82, NULL, 'DUF3677', 269523),
(450430, 'PF07233', NULL, 'Protein of unknown function (DUF1425)', 92, NULL, 'DUF1425', 269524),
(450431, 'PF14290', NULL, 'Succinate dehydrogenase subunit 5, mitochondrial', 237, NULL, 'SDH5_plant', 269525),
(450432, 'PF18103', NULL, 'Retroviral integrase C-terminal SH3 domain', 63, NULL, 'SH3_11', 269526),
(450433, 'PF15701', NULL, 'Domain of unknown function (DUF4668)', 162, NULL, 'DUF4668', 269527),
(450434, 'PF17090', NULL, 'YtcA family', 62, NULL, 'Ytca', 269528),
(450435, 'PF14713', NULL, 'Domain of unknown function (DUF4464)', 223, NULL, 'DUF4464', 269529),
(450436, 'PF04380', NULL, 'Membrane fusogenic activity', 77, NULL, 'BMFP', 269530),
(450437, 'PF00394', NULL, 'Multicopper oxidase', 159, NULL, 'Cu-oxidase', 269531),
(450438, 'PF09234', NULL, 'Domain of unknown function (DUF1963)', 214, NULL, 'DUF1963', 269532),
(450439, 'PF08204', NULL, 'CD47 immunoglobulin-like domain', 130, NULL, 'V-set_CD47', 269533),
(450440, 'PF14315', NULL, 'Domain of unknown function (DUF4380)', 295, NULL, 'DUF4380', 269534),
(450441, 'PF17230', NULL, 'Family of unknown function (DUF5304)', 149, NULL, 'DUF5304', 269535),
(450442, 'PF10973', NULL, 'Protein of unknown function (DUF2799)', 86, NULL, 'DUF2799', 269536),
(450443, 'PF16034', NULL, 'JAKMIP CC3 domain', 200, NULL, 'JAKMIP_CC3', 269537),
(450444, 'PF08944', NULL, 'NADPH oxidase subunit p47Phox, C terminal domain', 33, NULL, 'p47_phox_C', 269538),
(450445, 'PF15097', NULL, 'Immunoglobulin J chain', 134, NULL, 'Ig_J_chain', 269539),
(450446, 'PF03846', NULL, 'Cell division inhibitor SulA', 115, NULL, 'SulA', 269540),
(450447, 'PF13800', NULL, 'Sigma factor regulator N-terminal', 91, NULL, 'Sigma_reg_N', 269541),
(450448, 'PF02445', NULL, 'Quinolinate synthetase A protein', 299, NULL, 'NadA', 269542),
(450449, 'PF04140', NULL, 'Isoprenylcysteine carboxyl methyltransferase (ICMT) family', 95, NULL, 'ICMT', 269543),
(450450, 'PF17387', NULL, 'Glycosyl hydrolase family 59 central domain', 116, NULL, 'Glyco_hydro_59M', 269544),
(450451, 'PF00983', NULL, 'Tymovirus coat protein', 179, NULL, 'Tymo_coat', 269545),
(450452, 'PF14870', NULL, 'Photosynthesis system II assembly factor YCF48', 304, NULL, 'PSII_BNR', 269546),
(450453, 'PF06029', NULL, 'AlkA N-terminal domain', 116, NULL, 'AlkA_N', 269547),
(450454, 'PF06677', NULL, 'Sjogren''s syndrome/scleroderma autoantigen 1 (Autoantigen p27)', 40, NULL, 'Auto_anti-p27', 269548),
(450455, 'PF02154', NULL, 'Flagellar motor switch protein FliM', 192, NULL, 'FliM', 269549),
(450456, 'PF18475', NULL, 'PIN domain', 103, NULL, 'PIN7', 269550),
(450457, 'PF12216', NULL, 'Immune evasion protein', 272, NULL, 'm04gp34like', 269551),
(450458, 'PF04547', NULL, 'Calcium-activated chloride channel', 458, NULL, 'Anoctamin', 269552),
(450459, 'PF12334', NULL, 'Rickettsia outer membrane protein B', 223, NULL, 'rOmpB', 269553),
(450460, 'PF04557', NULL, 'Glutaminyl-tRNA synthetase, non-specific RNA binding region part 2', 94, NULL, 'tRNA_synt_1c_R2', 269554),
(450461, 'PF07029', NULL, 'CryBP1 protein', 164, NULL, 'CryBP1', 269555),
(450462, 'PF07531', NULL, 'NHR1 homology to TAF', 90, NULL, 'TAFH', 269556),
(450463, 'PF18807', NULL, 'Tripartite Tc toxins repeat', 45, NULL, 'TTc_toxin_rep', 269557);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(450464, 'PF07491', NULL, 'Protein phosphatase inhibitor', 60, NULL, 'PPI_Ypi1', 269558),
(450465, 'PF11032', NULL, 'ApoM domain', 188, NULL, 'ApoM', 269559),
(450466, 'PF00327', NULL, 'Ribosomal protein L30p/L7e', 51, NULL, 'Ribosomal_L30', 269560),
(450467, 'PF16257', NULL, 'tagaturonate epimerase', 475, NULL, 'UxaE', 269561),
(450468, 'PF16442', NULL, 'Domain of unknown function (DUF5039)', 203, NULL, 'DUF5039', 269562),
(450469, 'PF11722', NULL, 'CCCH zinc finger in TRM13 protein', 29, NULL, 'zf-TRM13_CCCH', 269563),
(450470, 'PF14994', NULL, 'Testis-specific gene 13 protein', 274, NULL, 'TSGA13', 269564),
(450471, 'PF13608', NULL, 'Protein P3 of Potyviral polyprotein', 452, NULL, 'Potyvirid-P3', 269565),
(450472, 'PF12999', NULL, 'Glucosidase II beta subunit-like', 176, NULL, 'PRKCSH-like', 269566),
(450473, 'PF02007', NULL, 'Tetrahydromethanopterin S-methyltransferase MtrH subunit', 299, NULL, 'MtrH', 269567),
(450474, 'PF10611', NULL, 'Protein of unknown function (DUF2469)', 100, NULL, 'DUF2469', 269568),
(450475, 'PF05801', NULL, 'Lagovirus protein of unknown function (DUF840)', 113, NULL, 'DUF840', 269569),
(450476, 'PF14982', NULL, 'UPF0731 family', 78, NULL, 'UPF0731', 269570),
(450477, 'PF08126', NULL, 'Propeptide_C25', 205, NULL, 'Propeptide_C25', 269571),
(450478, 'PF13971', NULL, 'Meiosis-specific protein Mei4', 339, NULL, 'Mei4', 269572),
(450479, 'PF09327', NULL, 'Domain of unknown function (DUF1983)', 81, NULL, 'DUF1983', 269573),
(450480, 'PF06865', NULL, 'Pyrimidine/purine nucleoside phosphorylase', 92, NULL, 'Ppnp', 269574),
(450481, 'PF02560', NULL, 'Cyanate lyase C-terminal domain', 69, NULL, 'Cyanate_lyase', 269575),
(450482, 'PF08765', NULL, 'Mor transcription activator family', 108, NULL, 'Mor', 269576),
(450483, 'PF18276', NULL, 'Tc toxin complex TcA C-terminal TcB-binding domain', 287, NULL, 'TcA_TcB_BD', 269577),
(450484, 'PF20329', NULL, 'Family of unknown function (DUF6624)', 173, NULL, 'DUF6624', 269578),
(450485, 'PF00147', NULL, 'Fibrinogen beta and gamma chains, C-terminal globular domain', 221, NULL, 'Fibrinogen_C', 269579),
(450486, 'PF10428', NULL, 'RAM signalling pathway protein', 504, NULL, 'SOG2', 269580),
(450487, 'PF05522', NULL, 'Metallothionein', 65, NULL, 'Metallothio_6', 269581),
(450488, 'PF16451', NULL, 'Betacoronavirus-like spike glycoprotein S1, N-terminal', 299, NULL, 'bCoV_S1_N', 269582),
(450489, 'PF18039', NULL, 'UBA-like domain', 42, NULL, 'UBA_6', 269583),
(450490, 'PF08970', NULL, 'Sporulation inhibitor A', 45, NULL, 'Sda', 269584),
(450491, 'PF08617', NULL, 'Kinase binding protein CGI-121', 163, NULL, 'CGI-121', 269585),
(450492, 'PF00886', NULL, 'Ribosomal protein S16', 62, NULL, 'Ribosomal_S16', 269586),
(450493, 'PF10985', NULL, 'Protein of unknown function (DUF2805)', 71, NULL, 'DUF2805', 269587),
(450494, 'PF14754', NULL, 'Papain-like auto-proteinase', 249, NULL, 'IFR3_antag', 269588),
(450495, 'PF13468', NULL, 'Glyoxalase-like domain', 176, NULL, 'Glyoxalase_3', 269589),
(450496, 'PF01609', NULL, 'Transposase DDE domain', 214, NULL, 'DDE_Tnp_1', 269590),
(450497, 'PF09739', NULL, 'Mini-chromosome maintenance replisome factor', 582, NULL, 'MCM_bind', 269591),
(450498, 'PF01198', NULL, 'Ribosomal protein L31e', 82, NULL, 'Ribosomal_L31e', 269592),
(450499, 'PF17925', NULL, 'Tetracyclin repressor-like, C-terminal domain', 107, NULL, 'TetR_C_20', 269593),
(450500, 'PF00694', NULL, 'Aconitase C-terminal domain', 131, NULL, 'Aconitase_C', 269594),
(450501, 'PF02932', NULL, 'Neurotransmitter-gated ion-channel transmembrane region', 238, NULL, 'Neur_chan_memb', 269595),
(450502, 'PF05263', NULL, 'Protein of unknown function (DUF722)', 134, NULL, 'DUF722', 269596),
(450503, 'PF15315', NULL, 'Facioscapulohumeral muscular dystrophy candidate 2', 183, NULL, 'FRG2', 269597),
(450504, 'PF05135', NULL, 'Phage gp6-like head-tail connector protein', 98, NULL, 'Phage_connect_1', 269598),
(450505, 'PF07064', NULL, 'RIC1', 251, NULL, 'RIC1', 269599),
(450506, 'PF12218', NULL, 'N terminal extension of bacteriophage endosialidase', 67, NULL, 'End_N_terminal', 269600);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(450507, 'PF06240', NULL, 'Carbon monoxide dehydrogenase subunit G (CoxG)', 140, NULL, 'COXG', 269601),
(450508, 'PF17395', NULL, 'Family of unknown function (DUF5403)', 96, NULL, 'DUF5403', 269602),
(450509, 'PF14897', NULL, 'EpsG family', 325, NULL, 'EpsG', 269603),
(450510, 'PF12433', NULL, 'Parvovirus non-structural protein 1', 82, NULL, 'PV_NSP1', 269604),
(450511, 'PF10637', NULL, 'Oxoglutarate and iron-dependent oxygenase degradation C-term', 255, NULL, 'Ofd1_CTDD', 269605),
(450512, 'PF02777', NULL, 'Iron/manganese superoxide dismutases, C-terminal domain', 101, NULL, 'Sod_Fe_C', 269606),
(450513, 'PF04818', NULL, 'CID domain', 121, NULL, 'CID', 269607),
(450514, 'PF10447', NULL, 'Exosome component EXOSC1/CSL4', 109, NULL, 'EXOSC1', 269608),
(450515, 'PF18359', NULL, 'Histone methyltransferase Tudor domain 1', 54, NULL, 'Tudor_5', 269609),
(450516, 'PF16289', NULL, 'PIN domain', 171, NULL, 'PIN_12', 269610),
(450517, 'PF09200', NULL, 'Monellin', 43, NULL, 'Monellin', 269611),
(450518, 'PF08343', NULL, 'Ribonucleotide reductase N-terminal', 82, NULL, 'RNR_N', 269612),
(450519, 'PF07101', NULL, 'Protein of unknown function (DUF1363)', 124, NULL, 'DUF1363', 269613),
(450520, 'PF11497', NULL, 'NADH-quinone oxidoreductase chain 15', 123, NULL, 'NADH_Oxid_Nqo15', 269614),
(450521, 'PF15756', NULL, 'Small Novel Rich in Cartilage', 96, NULL, 'DUF4690', 269615),
(450522, 'PF08649', NULL, 'DASH complex subunit Dad1', 55, NULL, 'DASH_Dad1', 269616),
(450523, 'PF13367', NULL, 'PrsW family intramembrane metalloprotease', 196, NULL, 'PrsW-protease', 269617),
(450524, 'PF16222', NULL, 'Domain of unknown function (DUF4881)', 174, NULL, 'DUF4881', 269618),
(450525, 'PF15951', NULL, 'MITF/TFEB/TFEC/TFE3 N-terminus', 152, NULL, 'MITF_TFEB_C_3_N', 269619),
(450526, 'PF19368', NULL, 'AraR C-terminal winged HTH domain', 82, NULL, 'AraR_C', 269620),
(450527, 'PF09959', NULL, 'Uncharacterized protein conserved in archaea (DUF2193)', 498, NULL, 'DUF2193', 269621),
(450528, 'PF11573', NULL, 'Mediator complex subunit 23', 1304, NULL, 'Med23', 269622),
(450529, 'PF07939', NULL, 'Protein of unknown function (DUF1685)', 61, NULL, 'DUF1685', 269623),
(450530, 'PF00390', NULL, 'Malic enzyme, N-terminal domain', 182, NULL, 'malic', 269624),
(450531, 'PF01826', NULL, 'Trypsin Inhibitor like cysteine rich domain', 55, NULL, 'TIL', 269625),
(450532, 'PF15452', NULL, 'Neuronal tyrosine-phosphorylated phosphoinositide-3-kinase adapter', 267, NULL, 'NYAP_C', 269626),
(450533, 'PF15586', NULL, 'Immunity protein 8', 114, NULL, 'Imm8', 269627),
(450534, 'PF05209', NULL, 'Septum formation inhibitor MinC, N-terminal domain', 73, NULL, 'MinC_N', 269628),
(450535, 'PF11647', NULL, 'Membrane Localization Domain', 81, NULL, 'MLD', 269629),
(450536, 'PF08240', NULL, 'Alcohol dehydrogenase GroES-like domain', 109, NULL, 'ADH_N', 269630),
(450537, 'PF17441', NULL, 'Family of unknown function (DUF5419)', 54, NULL, 'DUF5419', 269631),
(450538, 'PF03625', NULL, 'Domain of unknown function DUF302', 63, NULL, 'DUF302', 269632),
(450539, 'PF04616', NULL, 'Glycosyl hydrolases family 43', 288, NULL, 'Glyco_hydro_43', 269633),
(450540, 'PF10615', NULL, 'Domain of unknown function (DUF2470)', 77, NULL, 'DUF2470', 269634),
(450541, 'PF10798', NULL, 'Biofilm development protein YmgB/AriR', 59, NULL, 'YmgB', 269635),
(450542, 'PF17968', NULL, 'Toll-like receptor 3 trans-membrane domain', 33, NULL, 'Tlr3_TMD', 269636),
(450543, 'PF12203', NULL, 'Glutamine rich N terminal domain of histone deacetylase 4', 91, NULL, 'HDAC4_Gln', 269637),
(450544, 'PF12777', NULL, 'Microtubule-binding stalk of dynein motor', 344, NULL, 'MT', 269638),
(450545, 'PF00907', NULL, 'T-box', 185, NULL, 'T-box', 269639),
(450546, 'PF07356', NULL, 'Protein of unknown function (DUF1481)', 186, NULL, 'DUF1481', 269640),
(450547, 'PF15518', NULL, 'L protein N-terminus', 93, NULL, 'L_protein_N', 269641),
(450548, 'PF03430', NULL, 'Trans-activating transcriptional regulator', 575, NULL, 'TATR', 269642),
(450549, 'PF04567', NULL, 'RNA polymerase Rpb2, domain 5', 67, NULL, 'RNA_pol_Rpb2_5', 269643);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(450550, 'PF05422', NULL, 'Stress-activated map kinase interacting protein 1 (SIN1)', 141, NULL, 'SIN1', 269644),
(450551, 'PF06508', NULL, 'Queuosine biosynthesis protein QueC', 209, NULL, 'QueC', 269645),
(450552, 'PF14869', NULL, 'Domain of unknown function (DUF4488)', 123, NULL, 'DUF4488', 269646),
(450553, 'PF15440', NULL, 'THRAP3/BCLAF1 family', 662, NULL, 'THRAP3_BCLAF1', 269647),
(450554, 'PF18331', NULL, 'PKHD-type hydroxylase C-terminal domain', 43, NULL, 'PKHD_C', 269648),
(450555, 'PF07116', NULL, 'Protein of unknown function (DUF1372)', 104, NULL, 'DUF1372', 269649),
(450556, 'PF12950', NULL, 'TaqI-like C-terminal specificity domain', 120, NULL, 'TaqI_C', 269650),
(450557, 'PF12895', NULL, 'Anaphase-promoting complex, cyclosome, subunit 3', 82, NULL, 'ANAPC3', 269651),
(450558, 'PF04495', NULL, 'GRASP55/65 PDZ-like domain', 138, NULL, 'GRASP55_65', 269652),
(450559, 'PF00857', NULL, 'Isochorismatase family', 175, NULL, 'Isochorismatase', 269653),
(450560, 'PF12091', NULL, 'Protein of unknown function (DUF3567)', 89, NULL, 'DUF3567', 269654),
(450561, 'PF03402', NULL, 'Vomeronasal organ pheromone receptor family, V1R', 292, NULL, 'V1R', 269655),
(450562, 'PF12506', NULL, 'Protein of unknown function (DUF3713)', 116, NULL, 'DUF3713', 269656),
(450563, 'PF03712', NULL, 'Copper type II ascorbate-dependent monooxygenase, C-terminal domain', 157, NULL, 'Cu2_monoox_C', 269657),
(450564, 'PF16644', NULL, 'Regulatory region of Na+/H+ exchanger NHE binds to calmodulin', 109, NULL, 'NEXCaM_BD', 269658),
(450565, 'PF18940', NULL, 'Family of unknown function (DUF5687)', 484, NULL, 'DUF5687', 269659),
(450566, 'PF01656', NULL, 'CobQ/CobB/MinD/ParA nucleotide binding domain', 127, NULL, 'CbiA', 269660),
(450567, 'PF18261', NULL, 'Rpn9 C-terminal helix', 33, NULL, 'Rpn9_C', 269661),
(450568, 'PF01527', NULL, 'Transposase', 75, NULL, 'HTH_Tnp_1', 269662),
(450569, 'PF03622', NULL, 'IBV 3B protein', 64, NULL, 'IBV_3B', 269663),
(450570, 'PF06266', NULL, 'HrpF protein', 74, NULL, 'HrpF', 269664),
(450571, 'PF04619', NULL, 'Dr-family adhesin', 139, NULL, 'Adhesin_Dr', 269665),
(450572, 'PF14716', NULL, 'Helix-hairpin-helix domain', 68, NULL, 'HHH_8', 269666),
(450573, 'PF05640', NULL, 'Na,K-Atpase Interacting protein', 206, NULL, 'NKAIN', 269667),
(450574, 'PF11161', NULL, 'Protein of unknown function (DUF2946)', 185, NULL, 'DUF2944', 269668),
(450575, 'PF04991', NULL, 'LicD family', 228, NULL, 'LicD', 269669),
(450576, 'PF09125', NULL, 'Cytochrome C oxidase subunit II, transmembrane', 38, NULL, 'COX2-transmemb', 269670),
(450577, 'PF09744', NULL, 'JNK_SAPK-associated protein-1', 150, NULL, 'Jnk-SapK_ap_N', 269671),
(450578, 'PF20011', NULL, 'JAB N-terminal domain', 159, NULL, 'fvmJAB_N', 269672),
(450579, 'PF18209', NULL, 'Embryo surrounding factor 1', 56, NULL, 'ESF1', 269673),
(450580, 'PF17085', NULL, 'Unique cartilage matrix associated protein', 134, NULL, 'UCMA', 269674),
(450581, 'PF08683', NULL, 'Microtubule-binding calmodulin-regulated spectrin-associated', 119, NULL, 'CAMSAP_CKK', 269675),
(450582, 'PF12352', NULL, 'Snare region anchored in the vesicle membrane C-terminus', 66, NULL, 'V-SNARE_C', 269676),
(450583, 'PF14830', NULL, 'Haemocyanin beta-sandwich', 103, NULL, 'Haemocyan_bet_s', 269677),
(450584, 'PF09280', NULL, 'XPC-binding domain', 57, NULL, 'XPC-binding', 269678),
(450585, 'PF13249', NULL, 'Squalene-hopene cyclase N-terminal domain', 291, NULL, 'SQHop_cyclase_N', 269679),
(450586, 'PF09392', NULL, 'Type III secretion needle MxiH, YscF, SsaG, EprI, PscF, EscF', 71, NULL, 'T3SS_needle_F', 269680),
(450587, 'PF11577', NULL, 'NF-kappa-B essential modulator NEMO', 68, NULL, 'NEMO', 269681),
(450588, 'PF16473', NULL, '3''-5'' exoribonuclease Rv2179c-like domain', 166, NULL, 'Rv2179c-like', 269682),
(450589, 'PF09053', NULL, 'CagZ', 199, NULL, 'CagZ', 269683),
(450590, 'PF13790', NULL, 'SR1 protein', 37, NULL, 'SR1P', 269684),
(450591, 'PF15871', NULL, 'Junction-mediating and -regulatory protein', 357, NULL, 'JMY', 269685),
(450592, 'PF09046', NULL, 'AvrPtoB E3 ubiquitin ligase', 126, NULL, 'AvrPtoB-E3_ubiq', 269686);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(450593, 'PF06389', NULL, 'Filovirus membrane-associated protein VP24', 253, NULL, 'Filo_VP24', 269687),
(450594, 'PF10119', NULL, 'Predicted methyltransferase regulatory domain', 84, NULL, 'MethyTransf_Reg', 269688),
(450595, 'PF12694', NULL, 'Circularly permutated YpsA SLOG family', 146, NULL, 'cpYpsA', 269689),
(450596, 'PF08642', NULL, 'Histone deacetylation protein Rxt3', 114, NULL, 'Rxt3', 269690),
(450597, 'PF01670', NULL, 'Glycosyl hydrolase family 12', 214, NULL, 'Glyco_hydro_12', 269691),
(450598, 'PF17626', NULL, 'Inclusion membrane protein F', 104, NULL, 'IncF', 269692),
(450599, 'PF04916', NULL, 'Phospholipase B', 490, NULL, 'Phospholip_B', 269693),
(450600, 'PF17108', NULL, 'N-terminal small S protein of HET, non-prionic', 23, NULL, 'HET-S', 269694),
(450601, 'PF02852', NULL, 'Pyridine nucleotide-disulphide oxidoreductase, dimerisation domain', 110, NULL, 'Pyr_redox_dim', 269695),
(450602, 'PF13471', NULL, 'Transglutaminase-like superfamily', 117, NULL, 'Transglut_core3', 269696),
(450603, 'PF20574', NULL, 'Family of unknown function (DUF6783)', 60, NULL, 'DUF6783', 269697),
(450604, 'PF03287', NULL, 'Poxvirus C7/F8A protein', 148, NULL, 'Pox_C7_F8A', 269698),
(450605, 'PF03358', NULL, 'NADPH-dependent FMN reductase', 156, NULL, 'FMN_red', 269699),
(450606, 'PF13093', NULL, 'Kinetochore complex Fta4 of Sim4 subunit, or CENP-50', 202, NULL, 'FTA4', 269700),
(450607, 'PF19252', NULL, 'HIND motif', 25, NULL, 'HIND', 269701),
(450608, 'PF00756', NULL, 'Putative esterase', 251, NULL, 'Esterase', 269702),
(450609, 'PF01082', NULL, 'Copper type II ascorbate-dependent monooxygenase, N-terminal domain', 131, NULL, 'Cu2_monooxygen', 269703),
(450610, 'PF18908', NULL, 'Protein of unknown function (DUF5663)', 86, NULL, 'DUF5663', 269704),
(450611, 'PF16846', NULL, 'Centromere DNA-binding protein complex CBF3 subunit B', 511, NULL, 'Cep3', 269705),
(450612, 'PF14755', NULL, 'Nsp2, transmembrane domain', 148, NULL, 'Nsp2_AV', 269706),
(450613, 'PF04045', NULL, 'Arp2/3 complex, 34 kD subunit p34-Arc', 242, NULL, 'P34-Arc', 269707),
(450614, 'PF18481', NULL, 'Domain of unknown function (DUF5616)', 140, NULL, 'DUF5616', 269708),
(450615, 'PF10144', NULL, 'Bacterial virulence factor haemolysin', 159, NULL, 'SMP_2', 269709),
(450616, 'PF14328', NULL, 'Domain of unknown function (DUF4385)', 148, NULL, 'DUF4385', 269710),
(450617, 'PF15847', NULL, 'Major keratinocyte cell envelope protein', 312, NULL, 'Loricrin', 269711),
(450618, 'PF09534', NULL, 'Tryptophan-associated transmembrane protein (Trp_oprn_chp)', 180, NULL, 'Trp_oprn_chp', 269712),
(450619, 'PF06998', NULL, 'Protein of unknown function (DUF1307)', 123, NULL, 'DUF1307', 269713),
(450620, 'PF11103', NULL, 'Protein of unknown function (DUF2887)', 200, NULL, 'DUF2887', 269714),
(450621, 'PF00800', NULL, 'Prephenate dehydratase', 183, NULL, 'PDT', 269715),
(450622, 'PF19493', NULL, 'Trypsin-co-occurring domain 1', 100, NULL, 'Trypco1', 269716),
(450623, 'PF01428', NULL, 'AN1-like Zinc finger', 40, NULL, 'zf-AN1', 269717),
(450624, 'PF19345', NULL, 'Mycobacterial methylenetetrahydrofolate reductase', 295, NULL, 'MTHFR_2', 269718),
(450625, 'PF03515', NULL, 'Colicin-like bacteriocin tRNase domain', 277, NULL, 'Cloacin', 269719),
(450626, 'PF07220', NULL, 'Protein of unknown function (DUF1420)', 670, NULL, 'DUF1420', 269720),
(450627, 'PF16429', NULL, 'Domain of unknown function (DUF5026)', 82, NULL, 'DUF5026', 269721),
(450628, 'PF15217', NULL, 'TSC21 family', 170, NULL, 'TSC21', 269722),
(450629, 'PF02468', NULL, 'Photosystem II reaction centre N protein (psbN)', 43, NULL, 'PsbN', 269723),
(450630, 'PF07664', NULL, 'Ferrous iron transport protein B C terminus', 53, NULL, 'FeoB_C', 269724),
(450631, 'PF19727', NULL, 'Family of unknown function (DUF6219)', 69, NULL, 'DUF6219', 269725),
(450632, 'PF07043', NULL, 'Protein of unknown function (DUF1328)', 39, NULL, 'DUF1328', 269726),
(450633, 'PF10699', NULL, 'Male gamete fusion factor', 515, NULL, 'HAP2-GCS1', 269727),
(450634, 'PF08645', NULL, 'Polynucleotide kinase 3 phosphatase', 162, NULL, 'PNK3P', 269728);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(450635, 'PF17738', NULL, 'Family of unknown function (DUF5575)', 309, NULL, 'DUF5575', 269729),
(450636, 'PF17766', NULL, 'Fibronectin type-III domain', 99, NULL, 'fn3_6', 269730),
(450637, 'PF04223', NULL, 'Citrate lyase, alpha subunit (CitF)', 466, NULL, 'CitF', 269731),
(450638, 'PF05672', NULL, 'MAP7 (E-MAP-115) family', 157, NULL, 'MAP7', 269732),
(450639, 'PF13846', NULL, 'Domain of unknown function (DUF4196)', 112, NULL, 'DUF4196', 269733),
(450640, 'PF01940', NULL, 'Integral membrane protein DUF92', 236, NULL, 'DUF92', 269734),
(450641, 'PF16271', NULL, 'Domain of unknown function (DUF4924)', 179, NULL, 'DUF4924', 269735),
(450642, 'PF20276', NULL, 'C-terminal domain 1 of the ABC-three component (ABC-3C) systems', 243, NULL, 'CTD1', 269736),
(450643, 'PF10614', NULL, 'Type VIII secretion system (T8SS), CsgF protein', 132, NULL, 'CsgF', 269737),
(450644, 'PF16338', NULL, 'Alpha-glucosidase, N-terminal', 94, NULL, 'AGL_N', 269738),
(450645, 'PF07878', NULL, 'CopG-like RHH_1 or ribbon-helix-helix domain, RHH_5', 43, NULL, 'RHH_5', 269739),
(450646, 'PF03363', NULL, 'Herpesvirus leader protein', 174, NULL, 'Herpes_LP', 269740),
(450647, 'PF05918', NULL, 'Apoptosis inhibitory protein 5 (API5)', 534, NULL, 'API5', 269741),
(450648, 'PF12905', NULL, 'Endo-alpha-N-acetylgalactosaminidase', 273, NULL, 'Glyco_hydro_101', 269742),
(450649, 'PF07668', NULL, 'M penetrans paralogue family 1', 314, NULL, 'MpPF1', 269743),
(450650, 'PF12771', NULL, 'Starch-binding associating with outer membrane', 415, NULL, 'SusD-like_2', 269744),
(450651, 'PF15311', NULL, 'Hydrolethalus syndrome protein 1 C-terminus', 90, NULL, 'HYLS1_C', 269745),
(450652, 'PF15603', NULL, 'Immunity protein 74', 80, NULL, 'Imm74', 269746),
(450653, 'PF16438', NULL, 'Domain of unknown function (DUF5035)', 145, NULL, 'DUF5035', 269747),
(450654, 'PF02845', NULL, 'CUE domain', 42, NULL, 'CUE', 269748),
(450655, 'PF06291', NULL, 'Bor protein', 77, NULL, 'Lambda_Bor', 269749),
(450656, 'PF14102', NULL, 'Capsule biosynthesis CapC', 119, NULL, 'Caps_synth_CapC', 269750),
(450657, 'PF12214', NULL, 'Cell cycle regulated microtubule associated protein', 167, NULL, 'TPX2_importin', 269751),
(450658, 'PF02764', NULL, 'Diphtheria toxin, T domain', 161, NULL, 'Diphtheria_T', 269752),
(450659, 'PF07433', NULL, 'Protein of unknown function (DUF1513)', 304, NULL, 'DUF1513', 269753),
(450660, 'PF00534', NULL, 'Glycosyl transferases group 1', 172, NULL, 'Glycos_transf_1', 269754),
(450661, 'PF09380', NULL, 'FERM C-terminal PH-like domain', 94, NULL, 'FERM_C', 269755),
(450662, 'PF01206', NULL, 'Sulfurtransferase TusA', 70, NULL, 'TusA', 269756),
(450663, 'PF11340', NULL, 'Protein of unknown function (DUF3142)', 223, NULL, 'DUF3142', 269757),
(450664, 'PF03047', NULL, 'COMC family', 31, NULL, 'ComC', 269758),
(450665, 'PF05981', NULL, 'CreA protein', 131, NULL, 'CreA', 269759),
(450666, 'PF00201', NULL, 'UDP-glucoronosyl and UDP-glucosyl transferase', 499, NULL, 'UDPGT', 269760),
(450667, 'PF01803', NULL, 'LIM-domain binding protein', 242, NULL, 'LIM_bind', 269761),
(450668, 'PF02961', NULL, 'Barrier to autointegration factor', 88, NULL, 'BAF', 269762),
(450669, 'PF07698', NULL, '7TM receptor with intracellular HD hydrolase', 193, NULL, '7TM-7TMR_HD', 269763),
(450670, 'PF11823', NULL, 'Putative Se/S carrier protein-like', 69, NULL, 'Se_S_carrier', 269764),
(450671, 'PF12974', NULL, 'ABC transporter, phosphonate, periplasmic substrate-binding protein', 243, NULL, 'Phosphonate-bd', 269765),
(450672, 'PF07328', NULL, 'T-DNA border endonuclease VirD1', 142, NULL, 'VirD1', 269766),
(450673, 'PF01341', NULL, 'Glycosyl hydrolases family 6', 311, NULL, 'Glyco_hydro_6', 269767),
(450674, 'PF16825', NULL, 'IGP family C-type lectin domain', 173, NULL, 'DUF5075', 269768),
(450675, 'PF12408', NULL, 'Ribose-5-phosphate isomerase', 47, NULL, 'DUF3666', 269769),
(450676, 'PF16917', NULL, 'Biotin/lipoate A/B protein ligase family', 184, NULL, 'BPL_LplA_LipB_2', 269770),
(450677, 'PF04542', NULL, 'Sigma-70 region 2', 71, NULL, 'Sigma70_r2', 269771),
(450678, 'PF14354', NULL, 'Restriction alleviation protein Lar', 62, NULL, 'Lar_restr_allev', 269772);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(450679, 'PF12592', NULL, 'ATPase, RavA, C-terminal', 55, NULL, 'ATPase_RavA_C', 269773),
(450680, 'PF01153', NULL, 'Glypican', 555, NULL, 'Glypican', 269774),
(450681, 'PF04361', NULL, 'Protein of unknown function (DUF494)', 152, NULL, 'DUF494', 269775),
(450682, 'PF11375', NULL, 'Protein of unknown function (DUF3177)', 189, NULL, 'DUF3177', 269776),
(450683, 'PF00322', NULL, 'Endothelin family', 29, NULL, 'Endothelin', 269777),
(450684, 'PF07102', NULL, 'Putative nuclease YbcO', 92, NULL, 'YbcO', 269778),
(450685, 'PF12313', NULL, 'NPR1/NIM1 like defence protein C terminal', 205, NULL, 'NPR1_like_C', 269779),
(450686, 'PF12756', NULL, 'C2H2 type zinc-finger (2 copies)', 101, NULL, 'zf-C2H2_2', 269780),
(450687, 'PF19141', NULL, 'Family of unknown function (DUF5824)', 127, NULL, 'DUF5824', 269781),
(450688, 'PF06409', NULL, 'Nuclear pore complex interacting protein (NPIP)', 267, NULL, 'NPIP', 269782),
(450689, 'PF11706', NULL, 'CGNR zinc finger', 44, NULL, 'zf-CGNR', 269783),
(450690, 'PF15744', NULL, 'Uncharacterized protein family UPF0492', 371, NULL, 'UPF0492', 269784),
(450691, 'PF18773', NULL, 'Importin 13 repeat', 40, NULL, 'Importin_rep', 269785),
(450692, 'PF05893', NULL, 'Acyl-CoA reductase (LuxC)', 401, NULL, 'LuxC', 269786),
(450693, 'PF14008', NULL, 'Iron/zinc purple acid phosphatase-like protein C', 63, NULL, 'Metallophos_C', 269787),
(450694, 'PF08541', NULL, '3-Oxoacyl-[acyl-carrier-protein (ACP)] synthase III C terminal', 90, NULL, 'ACP_syn_III_C', 269788),
(450695, 'PF17394', NULL, 'Uncharacterized KleE stable inheritance protein', 108, NULL, 'KleE', 269789),
(450696, 'PF02554', NULL, 'Carbon starvation protein CstA', 377, NULL, 'CstA', 269790),
(450697, 'PF12037', NULL, 'ATPase family AAA domain-containing protein 3, N-terminal', 265, NULL, 'ATAD3_N', 269791),
(450698, 'PF04267', NULL, 'Sarcosine oxidase, delta subunit family', 82, NULL, 'SoxD', 269792),
(450699, 'PF20383', NULL, 'Family of unknown function (DUF6678)', 122, NULL, 'DUF6678', 269793),
(450700, 'PF00489', NULL, 'Interleukin-6/G-CSF/MGF family', 186, NULL, 'IL6', 269794),
(450701, 'PF10254', NULL, 'PACS-1 cytosolic sorting protein', 418, NULL, 'Pacs-1', 269795),
(450702, 'PF11684', NULL, 'Protein of unknown function (DUF2380)', 138, NULL, 'DUF3280', 269796),
(450703, 'PF00013', NULL, 'KH domain', 66, NULL, 'KH_1', 269797),
(450704, 'PF16015', NULL, 'Promethin', 106, NULL, 'Promethin', 269798),
(450705, 'PF12655', NULL, 'Domain of unknown function (DUF3787)', 52, NULL, 'DUF3787', 269799),
(450706, 'PF00041', NULL, 'Fibronectin type III domain', 85, NULL, 'fn3', 269800),
(450707, 'PF04382', NULL, 'SAB domain', 50, NULL, 'SAB', 269801),
(450708, 'PF14529', NULL, 'Endonuclease-reverse transcriptase', 119, NULL, 'Exo_endo_phos_2', 269802),
(450709, 'PF01256', NULL, 'Carbohydrate kinase', 244, NULL, 'Carb_kinase', 269803),
(450710, 'PF07872', NULL, 'Protein of unknown function (DUF1659)', 45, NULL, 'DUF1659', 269804),
(450711, 'PF14664', NULL, 'Rapamycin-insensitive companion of mTOR, N-term', 373, NULL, 'RICTOR_N', 269805),
(450712, 'PF07079', NULL, 'Protein of unknown function (DUF1347)', 546, NULL, 'DUF1347', 269806),
(450713, 'PF18917', NULL, 'Domain of unknown function (DUF5668)', 42, NULL, 'DUF5668', 269807),
(450714, 'PF08770', NULL, 'Sulphur oxidation protein SoxZ', 98, NULL, 'SoxZ', 269808),
(450715, 'PF19660', NULL, 'Family of unknown function (DUF6163)', 145, NULL, 'DUF6163', 269809),
(450716, 'PF01970', NULL, 'Tripartite tricarboxylate transporter TctA family', 409, NULL, 'TctA', 269810),
(450717, 'PF03612', NULL, 'Sorbitol phosphotransferase enzyme II N-terminus', 184, NULL, 'EIIBC-GUT_N', 269811),
(450718, 'PF00788', NULL, 'Ras association (RalGDS/AF-6) domain', 93, NULL, 'RA', 269812),
(450719, 'PF12845', NULL, 'TBD domain', 56, NULL, 'TBD', 269813),
(450720, 'PF09245', NULL, 'Mycoplasma arthritidis-derived mitogen', 214, NULL, 'MA-Mit', 269814),
(450721, 'PF11583', NULL, 'P-aminobenzoate N-oxygenase AurF', 283, NULL, 'AurF', 269815),
(450722, 'PF18029', NULL, 'Glyoxalase-like domain', 106, NULL, 'Glyoxalase_6', 269816);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(450723, 'PF16381', NULL, 'Coatomer subunit gamma-1 C-terminal appendage platform', 115, NULL, 'Coatomer_g_Cpla', 269817),
(450724, 'PF01988', NULL, 'VIT family', 215, NULL, 'VIT1', 269818),
(450725, 'PF03953', NULL, 'Tubulin C-terminal domain', 126, NULL, 'Tubulin_C', 269819),
(450726, 'PF03672', NULL, 'Uncharacterised protein family (UPF0154)', 60, NULL, 'UPF0154', 269820),
(450727, 'PF09715', NULL, 'Plasmodium protein of unknown function (Plasmod_dom_1)', 66, NULL, 'Plasmod_dom_1', 269821),
(450728, 'PF01743', NULL, 'Poly A polymerase head domain', 126, NULL, 'PolyA_pol', 269822),
(450729, 'PF04190', NULL, 'Golgi to ER traffic protein 4', 256, NULL, 'GET4', 269823),
(450730, 'PF13160', NULL, 'Protein of unknown function (DUF3995)', 125, NULL, 'DUF3995', 269824),
(450731, 'PF09041', NULL, 'Aurora-A binding', 68, NULL, 'Aurora-A_bind', 269825),
(450732, 'PF06741', NULL, 'LsmAD domain', 72, NULL, 'LsmAD', 269826),
(450733, 'PF16735', NULL, 'Unconventional myosin-X coiled coil domain', 52, NULL, 'MYO10_CC', 269827),
(450734, 'PF17716', NULL, 'Family of unknown function (DUF5561)', 255, NULL, 'DUF5561', 269828),
(450735, 'PF08458', NULL, 'Plant pleckstrin homology-like region', 105, NULL, 'PH_2', 269829),
(450736, 'PF12235', NULL, 'Fragile X-related 1 protein core C terminal', 129, NULL, 'FXMRP1_C_core', 269830),
(450737, 'PF09888', NULL, 'Uncharacterized protein conserved in archaea (DUF2115)', 163, NULL, 'DUF2115', 269831),
(450738, 'PF11986', NULL, 'Influenza A Proapoptotic protein', 87, NULL, 'PB1-F2', 269832),
(450739, 'PF19892', NULL, 'Family of unknown function (DUF6365)', 408, NULL, 'DUF6365', 269833),
(450740, 'PF08054', NULL, 'Leucine operon leader peptide', 28, NULL, 'Leu_leader', 269834),
(450741, 'PF15028', NULL, 'Pre-T-cell antigen receptor', 127, NULL, 'PTCRA', 269835),
(450742, 'PF20110', NULL, 'Family of unknown function (DUF6500)', 53, NULL, 'DUF6500', 269836),
(450743, 'PF03750', NULL, 'Csm2 Type III-A', 115, NULL, 'Csm2_III-A', 269837),
(450744, 'PF13420', NULL, 'Acetyltransferase (GNAT) domain', 155, NULL, 'Acetyltransf_4', 269838),
(450745, 'PF07661', NULL, 'MORN repeat variant', 22, NULL, 'MORN_2', 269839),
(450746, 'PF10930', NULL, 'Protein of unknown function (DUF2737)', 53, NULL, 'DUF2737', 269840),
(450747, 'PF10689', NULL, 'Protein of unknown function (DUF2496)', 43, NULL, 'DUF2496', 269841),
(450748, 'PF01746', NULL, 'tRNA (Guanine-1)-methyltransferase', 195, NULL, 'tRNA_m1G_MT', 269842),
(450749, 'PF05887', NULL, 'Procyclic acidic repetitive protein (PARP)', 134, NULL, 'Trypan_PARP', 269843),
(450750, 'PF13432', NULL, 'Tetratricopeptide repeat', 68, NULL, 'TPR_16', 269844),
(450751, 'PF08936', NULL, 'Carboxysome Shell Carbonic Anhydrase', 455, NULL, 'CsoSCA', 269845),
(450752, 'PF12191', NULL, 'Tumour necrosis factor receptor stn_TNFRSF12A_TNFR domain', 129, NULL, 'stn_TNFRSF12A', 269846),
(450753, 'PF20317', NULL, 'Helix-turn-helix domain', 140, NULL, 'HTH_60', 269847),
(450754, 'PF06760', NULL, 'Protein of unknown function (DUF1221)', 215, NULL, 'DUF1221', 269848),
(450755, 'PF11091', NULL, 'Tail-tube assembly protein', 342, NULL, 'T4_tail_cap', 269849),
(450756, 'PF11188', NULL, 'Protein of unknown function (DUF2975)', 131, NULL, 'DUF2975', 269850),
(450757, 'PF14712', NULL, 'Snapin/Pallidin', 90, NULL, 'Snapin_Pallidin', 269851),
(450758, 'PF17678', NULL, 'Glycosyl hydrolase family 92 N-terminal domain', 237, NULL, 'Glyco_hydro_92N', 269852),
(450759, 'PF08797', NULL, 'HIRAN domain', 96, NULL, 'HIRAN', 269853),
(450760, 'PF05337', NULL, 'Macrophage colony stimulating factor-1 (CSF-1)', 140, NULL, 'CSF-1', 269854),
(450761, 'PF15468', NULL, 'Domain of unknown function (DUF4636)', 243, NULL, 'DUF4636', 269855),
(450762, 'PF13705', NULL, 'TRC8 N-terminal domain', 489, NULL, 'TRC8_N', 269856),
(450763, 'PF06511', NULL, 'Type III secretion systems tip complex components', 355, NULL, 'T3SS_TC', 269857),
(450764, 'PF18339', NULL, 'RapA N-terminal Tudor like domain 1', 51, NULL, 'Tudor_1_RapA', 269858),
(450765, 'PF06711', NULL, 'Protein of unknown function (DUF1198)', 143, NULL, 'DUF1198', 269859);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(450766, 'PF10846', NULL, 'Protein of unknown function (DUF2722)', 471, NULL, 'DUF2722', 269860),
(450767, 'PF19540', NULL, 'Family of unknown function (DUF6064)', 210, NULL, 'DUF6064', 269861),
(450768, 'PF03332', NULL, 'Eukaryotic phosphomannomutase', 221, NULL, 'PMM', 269862),
(450769, 'PF12285', NULL, 'Astroviridae polyprotein 1', 171, NULL, 'Astrovir_pp_1', 269863),
(450770, 'PF13946', NULL, 'Domain of unknown function (DUF4214)', 72, NULL, 'DUF4214', 269864),
(450771, 'PF15143', NULL, 'Domain of unknown function (DUF4575)', 129, NULL, 'DUF4575', 269865),
(450772, 'PF10947', NULL, 'Protein of unknown function (DUF2628)', 93, NULL, 'DUF2628', 269866),
(450773, 'PF06592', NULL, 'Protein of unknown function (DUF1138)', 73, NULL, 'DUF1138', 269867),
(450774, 'PF15895', NULL, 'CAAX box cerebral protein 1', 209, NULL, 'CAAX_1', 269868),
(450775, 'PF10786', NULL, 'Glucose-6-phosphate 1-dehydrogenase (EC 1.1.1.49)', 213, NULL, 'G6PD_bact', 269869),
(450776, 'PF06863', NULL, 'Protein of unknown function (DUF1254)', 132, NULL, 'DUF1254', 269870),
(450777, 'PF02208', NULL, 'Sorbin homologous domain', 45, NULL, 'Sorb', 269871),
(450778, 'PF04468', NULL, 'PSP1 C-terminal conserved region', 86, NULL, 'PSP1', 269872),
(450779, 'PF19164', NULL, 'Family of unknown function (DUF5846)', 117, NULL, 'DUF5846', 269873),
(450780, 'PF02128', NULL, 'Fungalysin metallopeptidase (M36)', 372, NULL, 'Peptidase_M36', 269874),
(450781, 'PF09590', NULL, 'Lentivirus surface glycoprotein', 591, NULL, 'Env-gp36', 269875),
(450782, 'PF10407', NULL, 'Cdc14 phosphatase binding protein N-terminus', 71, NULL, 'Cytokin_check_N', 269876),
(450783, 'PF07830', NULL, 'Protein serine/threonine phosphatase 2C, C-terminal domain', 80, NULL, 'PP2C_C', 269877),
(450784, 'PF13964', NULL, 'Kelch motif', 50, NULL, 'Kelch_6', 269878),
(450785, 'PF01673', NULL, 'Herpesvirus putative major envelope glycoprotein', 530, NULL, 'Herpes_env', 269879),
(450786, 'PF09451', NULL, 'Autophagy-related protein 27', 262, NULL, 'ATG27', 269880),
(450787, 'PF17966', NULL, 'Muc B2-like domain', 65, NULL, 'Muc_B2', 269881),
(450788, 'PF16680', NULL, 'T-cell surface glycoprotein CD3 delta chain', 71, NULL, 'Ig_4', 269882),
(450789, 'PF04657', NULL, 'Putative inner membrane exporter, YdcZ', 140, NULL, 'DMT_YdcZ', 269883),
(450790, 'PF18655', NULL, 'SHIRT domain', 82, NULL, 'SHIRT', 269884),
(450791, 'PF05977', NULL, 'Transmembrane secretion effector', 524, NULL, 'MFS_3', 269885),
(450792, 'PF05982', NULL, 'Na+-dependent bicarbonate transporter superfamily', 308, NULL, 'Sbt_1', 269886),
(450793, 'PF13505', NULL, 'Outer membrane protein beta-barrel domain', 176, NULL, 'OMP_b-brl', 269887),
(450794, 'PF18278', NULL, 'Receptor activator of the NF-KB cysteine-rich repeat domain 2', 41, NULL, 'RANK_CRD_2', 269888),
(450795, 'PF19211', NULL, 'Coronavirus replicase NSP2, N-terminal', 201, NULL, 'CoV_NSP2_N', 269889),
(450796, 'PF02456', NULL, 'Adenovirus IVa2 protein', 370, NULL, 'Adeno_IVa2', 269890),
(450797, 'PF08777', NULL, 'RNA binding motif', 102, NULL, 'RRM_3', 269891),
(450798, 'PF16722', NULL, 'Pathogenicity island protein gp6 in Staphylococcus', 72, NULL, 'SAPIS-gp6', 269892),
(450799, 'PF06945', NULL, 'Protein of unknown function (DUF1289)', 48, NULL, 'DUF1289', 269893),
(450800, 'PF00260', NULL, 'Protamine P1', 49, NULL, 'Protamine_P1', 269894),
(450801, 'PF03526', NULL, 'Colicin E1 (microcin) immunity protein', 55, NULL, 'Microcin', 269895),
(450802, 'PF13214', NULL, 'Protein of unknown function (DUF4022)', 77, NULL, 'DUF4022', 269896),
(450803, 'PF00905', NULL, 'Penicillin binding protein transpeptidase domain', 306, NULL, 'Transpeptidase', 269897),
(450804, 'PF11334', NULL, 'Protein of unknown function (DUF3136)', 64, NULL, 'DUF3136', 269898),
(450805, 'PF13084', NULL, 'Domain of unknown function (DUF3943)', 108, NULL, 'DUF3943', 269899),
(450806, 'PF10259', NULL, 'Rogdi leucine zipper containing protein', 300, NULL, 'Rogdi_lz', 269900),
(450807, 'PF17203', NULL, 'Single cache domain 3', 137, NULL, 'sCache_3_2', 269901),
(450808, 'PF17548', NULL, 'Histone-like Protein p6', 76, NULL, 'p6', 269902);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(450809, 'PF09036', NULL, 'Bcr-Abl oncoprotein oligomerisation domain', 73, NULL, 'Bcr-Abl_Oligo', 269903),
(450810, 'PF20448', NULL, 'Family of unknown function (DUF6705)', 198, NULL, 'DUF6705', 269904),
(450811, 'PF11290', NULL, 'Protein of unknown function (DUF3090)', 171, NULL, 'DUF3090', 269905),
(450812, 'PF17474', NULL, 'Tegument protein UL11 homolog', 52, NULL, 'U71', 269906),
(450813, 'PF01887', NULL, 'SAM hydroxide adenosyltransferase N-terminal domain', 147, NULL, 'SAM_HAT_N', 269907),
(450814, 'PF19516', NULL, 'Family of unknown function (DUF6049)', 705, NULL, 'DUF6049', 269908),
(450815, 'PF17016', NULL, 'Domain of unknown function (DUF5095)', 241, NULL, 'DUF5095', 269909),
(450816, 'PF12973', NULL, 'ChrR Cupin-like domain', 91, NULL, 'Cupin_7', 269910),
(450817, 'PF01079', NULL, 'Hint module', 214, NULL, 'Hint', 269911),
(450818, 'PF16147', NULL, 'Domain of unknown function (DUF4855)', 315, NULL, 'DUF4855', 269912),
(450819, 'PF18840', NULL, 'Large polyvalent protein associated domain 25', 102, NULL, 'LPD25', 269913),
(450820, 'PF18916', NULL, 'Lycopene cyclase', 92, NULL, 'Lycopene_cyc', 269914),
(450821, 'PF12342', NULL, 'Protein of unknown function (DUF3640)', 26, NULL, 'DUF3640', 269915),
(450822, 'PF12822', NULL, 'ECF transporter, substrate-specific component', 174, NULL, 'ECF_trnsprt', 269916),
(450823, 'PF02864', NULL, 'STAT protein, DNA binding domain', 135, NULL, 'STAT_bind', 269917),
(450824, 'PF10645', NULL, 'Carbohydrate binding', 49, NULL, 'Carb_bind', 269918),
(450825, 'PF19202', NULL, 'Family of unknown function (DUF5874)', 74, NULL, 'DUF5874', 269919),
(450826, 'PF11940', NULL, 'Domain of unknown function (DUF3458) Ig-like fold', 95, NULL, 'DUF3458', 269920),
(450827, 'PF12388', NULL, 'Dual-action HEIGH metallo-peptidase', 212, NULL, 'Peptidase_M57', 269921),
(450828, 'PF18695', NULL, 'Cytosolic phospholipases A2 C2-domain', 112, NULL, 'cPLA2_C2', 269922),
(450829, 'PF14387', NULL, 'Domain of unknown function (DUF4418)', 119, NULL, 'DUF4418', 269923),
(450830, 'PF17271', NULL, 'TcfC Usher-like barrel domain', 420, NULL, 'Usher_TcfC', 269924),
(450831, 'PF16954', NULL, 'Haem-transporter, endosomal/lysosomal, haem-responsive gene', 52, NULL, 'HRG', 269925),
(450832, 'PF08056', NULL, 'Tryptophan operon leader peptide', 41, NULL, 'Trp_leader2', 269926),
(450833, 'PF14444', NULL, 'S1-like', 58, NULL, 'S1-like', 269927),
(450834, 'PF00520', NULL, 'Ion transport protein', 245, NULL, 'Ion_trans', 269928),
(450835, 'PF10005', NULL, 'zinc-ribbon domain', 93, NULL, 'zinc-ribbon_6', 269929),
(450836, 'PF07834', NULL, 'RanGAP1 C-terminal domain', 178, NULL, 'RanGAP1_C', 269930),
(450837, 'PF16891', NULL, 'Serine-threonine protein phosphatase N-terminal domain', 48, NULL, 'STPPase_N', 269931),
(450838, 'PF07711', NULL, 'Rab geranylgeranyl transferase alpha-subunit, insert domain', 101, NULL, 'RabGGT_insert', 269932),
(450839, 'PF09383', NULL, 'NIL domain', 73, NULL, 'NIL', 269933),
(450840, 'PF10761', NULL, 'Protein of unknown function (DUF2590)', 100, NULL, 'DUF2590', 269934),
(450841, 'PF00367', NULL, 'phosphotransferase system, EIIB', 34, NULL, 'PTS_EIIB', 269935),
(450842, 'PF14069', NULL, 'Stage VI sporulation protein F', 72, NULL, 'SpoVIF', 269936),
(450843, 'PF05558', NULL, 'DREPP plasma membrane polypeptide', 206, NULL, 'DREPP', 269937),
(450844, 'PF14587', NULL, 'O-Glycosyl hydrolase family 30', 364, NULL, 'Glyco_hydr_30_2', 269938),
(450845, 'PF08030', NULL, 'Ferric reductase NAD binding domain', 156, NULL, 'NAD_binding_6', 269939),
(450846, 'PF09510', NULL, 'Rtt102p-like transcription regulator protein', 132, NULL, 'Rtt102p', 269940),
(450847, 'PF17534', NULL, 'Family of unknown function (DUF5453)', 186, NULL, 'DUF5453', 269941),
(450848, 'PF15736', NULL, 'Domain of unknown function (DUF4684)', 458, NULL, 'DUF4684', 269942),
(450849, 'PF20063', NULL, 'Family of unknown function (DUF6462)', 51, NULL, 'DUF6462', 269943),
(450850, 'PF00559', NULL, 'Retroviral Vif (Viral infectivity) protein', 200, NULL, 'Vif', 269944),
(450851, 'PF03952', NULL, 'Enolase, N-terminal domain', 131, NULL, 'Enolase_N', 269945);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(450852, 'PF06119', NULL, 'Nidogen-like', 87, NULL, 'NIDO', 269946),
(450853, 'PF01094', NULL, 'Receptor family ligand binding region', 354, NULL, 'ANF_receptor', 269947),
(450854, 'PF14680', NULL, 'FANCI helical domain 2', 233, NULL, 'FANCI_HD2', 269948),
(450855, 'PF11814', NULL, 'Peptidase_C39 like family', 206, NULL, 'DUF3335', 269949),
(450856, 'PF02315', NULL, 'Methanol dehydrogenase beta subunit', 88, NULL, 'MDH', 269950),
(450857, 'PF13182', NULL, 'Protein of unknown function (DUF4007)', 287, NULL, 'DUF4007', 269951),
(450858, 'PF13475', NULL, 'Domain of unknown function (DUF4116)', 49, NULL, 'DUF4116', 269952),
(450859, 'PF14651', NULL, 'Lipocalin / cytosolic fatty-acid binding protein family', 128, NULL, 'Lipocalin_7', 269953),
(450860, 'PF15319', NULL, 'RAD9, RAD1, HUS1-interacting nuclear orphan protein', 248, NULL, 'RHINO', 269954),
(450861, 'PF09019', NULL, 'EcoRII C terminal', 165, NULL, 'EcoRII-C', 269955),
(450862, 'PF00662', NULL, 'NADH-Ubiquinone oxidoreductase (complex I), chain 5 N-terminus', 51, NULL, 'Proton_antipo_N', 269956),
(450863, 'PF01785', NULL, 'Closterovirus coat protein', 189, NULL, 'Closter_coat', 269957),
(450864, 'PF18042', NULL, 'ORF 12 gene product N-terminal', 94, NULL, 'ORF_12_N', 269958),
(450865, 'PF12112', NULL, 'Protein of unknown function (DUF3579)', 90, NULL, 'DUF3579', 269959),
(450866, 'PF17318', NULL, 'Family of unknown function (DUF5361)', 36, NULL, 'DUF5361', 269960),
(450867, 'PF12292', NULL, 'Protein of unknown function (DUF3624)', 76, NULL, 'DUF3624', 269961),
(450868, 'PF15297', NULL, 'Cytoskeleton-associated protein 2 C-terminus', 348, NULL, 'CKAP2_C', 269962),
(450869, 'PF07080', NULL, 'Protein of unknown function (DUF1348)', 130, NULL, 'DUF1348', 269963),
(450870, 'PF07538', NULL, 'Clostridial hydrophobic W', 35, NULL, 'ChW', 269964),
(450871, 'PF04718', NULL, 'Mitochondrial ATP synthase g subunit', 100, NULL, 'ATP-synt_G', 269965),
(450872, 'PF09106', NULL, 'Elongation factor SelB, winged helix', 57, NULL, 'SelB-wing_2', 269966),
(450873, 'PF20346', NULL, 'Family of unknown function (DUF6641)', 143, NULL, 'DUF6641', 269967),
(450874, 'PF19899', NULL, 'Family of unknown function (DUF6372)', 61, NULL, 'DUF6372', 269968),
(450875, 'PF07960', NULL, 'CBP4', 130, NULL, 'CBP4', 269969),
(450876, 'PF12720', NULL, 'Protein of unknown function (DUF3807)', 182, NULL, 'DUF3807', 269970),
(450877, 'PF03804', NULL, 'Viral proteins of unknown function', 73, NULL, 'DUF325', 269971),
(450878, 'PF19640', NULL, 'Family of unknown function (DUF6143)', 182, NULL, 'DUF6143', 269972),
(450879, 'PF18769', NULL, 'APOBEC1', 101, NULL, 'APOBEC1', 269973),
(450880, 'PF09250', NULL, 'Bifunctional DNA primase/polymerase, N-terminal', 158, NULL, 'Prim-Pol', 269974),
(450881, 'PF12244', NULL, 'Protein of unknown function (DUF3606)', 54, NULL, 'DUF3606', 269975),
(450882, 'PF00755', NULL, 'Choline/Carnitine o-acyltransferase', 568, NULL, 'Carn_acyltransf', 269976),
(450883, 'PF12524', NULL, 'dsDNA virus glycoprotein L C terminal', 65, NULL, 'GlyL_C', 269977),
(450884, 'PF04276', NULL, 'Protein of unknown function (DUF443)', 202, NULL, 'DUF443', 269978),
(450885, 'PF17671', NULL, 'Family of unknown function (DUF5531)', 152, NULL, 'DUF5531', 269979),
(450886, 'PF12584', NULL, 'Trafficking protein particle complex subunit 10, TRAPPC10', 152, NULL, 'TRAPPC10', 269980),
(450887, 'PF14190', NULL, 'Domain of unknown function (DUF4313)', 104, NULL, 'DUF4313', 269981),
(450888, 'PF00229', NULL, 'TNF(Tumour Necrosis Factor) family', 127, NULL, 'TNF', 269982),
(450889, 'PF11521', NULL, 'C-terminal general transcription factor TFIIE alpha', 86, NULL, 'TFIIE-A_C', 269983),
(450890, 'PF05035', NULL, '2-keto-3-deoxy-galactonokinase', 285, NULL, 'DGOK', 269984),
(450891, 'PF00515', NULL, 'Tetratricopeptide repeat', 34, NULL, 'TPR_1', 269985),
(450892, 'PF19415', NULL, 'Astrovirus transmembrane protein 1A', 244, NULL, 'Astro_1A', 269986),
(450893, 'PF12202', NULL, 'Oxidative-stress-responsive kinase 1 C-terminal domain', 63, NULL, 'OSR1_C', 269987),
(450894, 'PF19076', NULL, 'Surface adhesin CshA repetitive domain', 104, NULL, 'CshA_repeat', 269988);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(450895, 'PF19094', NULL, 'EMC6-arch', 87, NULL, 'EMC6_arch', 269989),
(450896, 'PF19443', NULL, 'DAHL domain', 222, NULL, 'DAHL', 269990),
(450897, 'PF07307', NULL, 'Heptaprenyl diphosphate synthase (HEPPP synthase) subunit 1', 211, NULL, 'HEPPP_synt_1', 269991),
(450898, 'PF06327', NULL, 'Adenylate cyclase, conserved domain', 100, NULL, 'Adcy_cons_dom', 269992),
(450899, 'PF10928', NULL, 'Protein of unknown function (DUF2810)', 53, NULL, 'DUF2810', 269993),
(450900, 'PF11559', NULL, 'Afadin- and alpha -actinin-Binding', 152, NULL, 'ADIP', 269994),
(450901, 'PF00641', NULL, 'Zn-finger in Ran binding protein and others', 30, NULL, 'zf-RanBP', 269995),
(450902, 'PF02413', NULL, 'Caudovirales tail fibre assembly protein, lambda gpK', 130, NULL, 'Caudo_TAP', 269996),
(450903, 'PF09736', NULL, 'Pre-mRNA-splicing factor of RES complex', 144, NULL, 'Bud13', 269997),
(450904, 'PF17865', NULL, 'Midasin AAA lid domain', 106, NULL, 'AAA_lid_5', 269998),
(450905, 'PF17473', NULL, 'Family of unknown function (DUF5426)', 137, NULL, 'DUF5426', 269999),
(450906, 'PF03356', NULL, 'Viral late protein H2', 188, NULL, 'Pox_LP_H2', 270000),
(450907, 'PF16836', NULL, 'Shu complex component Psy3, DNA-binding description', 216, NULL, 'PSY3', 270001),
(450908, 'PF11314', NULL, 'Protein of unknown function (DUF3117)', 50, NULL, 'DUF3117', 270002),
(450909, 'PF13542', NULL, 'Helix-turn-helix domain of transposase family ISL3', 52, NULL, 'HTH_Tnp_ISL3', 270003),
(450910, 'PF01099', NULL, 'Uteroglobin family', 90, NULL, 'Uteroglobin', 270004),
(450911, 'PF13061', NULL, 'Protein of unknown function (DUF3923)', 65, NULL, 'DUF3923', 270005),
(450912, 'PF20031', NULL, 'Family of unknown function (DUF6437)', 76, NULL, 'DUF6437', 270006),
(450913, 'PF12264', NULL, 'Waikavirus capsid protein 1', 197, NULL, 'Waikav_capsid_1', 270007),
(450914, 'PF10764', NULL, 'Inhibitor of sigma-G Gin', 45, NULL, 'Gin', 270008),
(450915, 'PF06963', NULL, 'Ferroportin1 (FPN1)', 435, NULL, 'FPN1', 270009),
(450916, 'PF06051', NULL, 'Domain of Unknown Function (DUF928)', 186, NULL, 'DUF928', 270010),
(450917, 'PF02342', NULL, 'TerD domain', 187, NULL, 'TerD', 270011),
(450918, 'PF01141', NULL, 'Gag polyprotein, inner coat protein p12', 85, NULL, 'Gag_p12', 270012),
(450919, 'PF04196', NULL, 'Bunyavirus RNA dependent RNA polymerase', 742, NULL, 'Bunya_RdRp', 270013),
(450920, 'PF18785', NULL, 'Invertebrate-AID/APOBEC-deaminase', 129, NULL, 'Inv-AAD', 270014),
(450921, 'PF03714', NULL, 'Bacterial pullanase-associated domain', 94, NULL, 'PUD', 270015),
(450922, 'PF10578', NULL, 'Seminal vesicle protein repeat', 12, NULL, 'SVS_QK', 270016),
(450923, 'PF05150', NULL, 'Legionella pneumophila major outer membrane protein precursor', 290, NULL, 'Legionella_OMP', 270017),
(450924, 'PF08257', NULL, 'Sulfakinin family', 9, NULL, 'Sulfakinin', 270018),
(450925, 'PF02776', NULL, 'Thiamine pyrophosphate enzyme, N-terminal TPP binding domain', 172, NULL, 'TPP_enzyme_N', 270019),
(450926, 'PF18090', NULL, 'Centromere-binding protein HTH domain', 75, NULL, 'SoPB_HTH', 270020),
(450927, 'PF10633', NULL, 'NPCBM-associated, NEW3 domain of alpha-galactosidase', 78, NULL, 'NPCBM_assoc', 270021),
(450928, 'PF09142', NULL, 'tRNA Pseudouridine synthase II, C terminal', 56, NULL, 'TruB_C', 270022),
(450929, 'PF11244', NULL, 'Mediator complex subunit 25 C-terminal NR box-containing', 90, NULL, 'Med25_NR-box', 270023),
(450930, 'PF13680', NULL, 'Protein of unknown function (DUF4152)', 225, NULL, 'DUF4152', 270024),
(450931, 'PF09592', NULL, 'Protein of unknown function (DUF2031)', 227, NULL, 'DUF2031', 270025),
(450932, 'PF00490', NULL, 'Delta-aminolevulinic acid dehydratase', 317, NULL, 'ALAD', 270026),
(450933, 'PF01807', NULL, 'CHC2 zinc finger', 98, NULL, 'zf-CHC2', 270027),
(450934, 'PF19405', NULL, 'Family of unknown function (DUF5978)', 73, NULL, 'DUF5978', 270028),
(450935, 'PF13156', NULL, 'Restriction endonuclease', 127, NULL, 'Mrr_cat_2', 270029),
(450936, 'PF05489', NULL, 'Phage Tail Protein X', 60, NULL, 'Phage_tail_X', 270030),
(450937, 'PF09241', NULL, 'Herpesviridae viral cyclin', 106, NULL, 'Herp-Cyclin', 270031);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(450938, 'PF02138', NULL, 'Beige/BEACH domain', 274, NULL, 'Beach', 270032),
(450939, 'PF10933', NULL, 'Protein of unknown function (DUF2827)', 362, NULL, 'DUF2827', 270033),
(450940, 'PF13966', NULL, 'zinc-binding in reverse transcriptase', 85, NULL, 'zf-RVT', 270034),
(450941, 'PF15490', NULL, 'Telomere-capping, CST complex subunit', 118, NULL, 'Ten1_2', 270035),
(450942, 'PF17878', NULL, 'Single-stranded DNA-binding protein', 72, NULL, 'ssDBP', 270036),
(450943, 'PF20520', NULL, 'V0 complex accessory subunit Ac45/VOA1 transmembrane domain', 39, NULL, 'Ac45-VOA1_TM', 270037),
(450944, 'PF14884', NULL, 'Type I membrane glycoproteins cell-cell fusogen', 467, NULL, 'EFF-AFF', 270038),
(450945, 'PF07587', NULL, 'Protein of unknown function (DUF1553)', 244, NULL, 'PSD1', 270039),
(450946, 'PF14336', NULL, 'Domain of unknown function (DUF4392)', 294, NULL, 'DUF4392', 270040),
(450947, 'PF19651', NULL, 'Family of unknown function (DUF6154)', 79, NULL, 'DUF6154', 270041),
(450948, 'PF00003', NULL, '7 transmembrane sweet-taste receptor of 3 GCPR', 243, NULL, '7tm_3', 270042),
(450949, 'PF07759', NULL, 'Protein of unknown function (DUF1615)', 320, NULL, 'DUF1615', 270043),
(450950, 'PF08813', NULL, 'Phage tail tube protein, TTP', 165, NULL, 'Phage_tail_3', 270044),
(450951, 'PF17204', NULL, 'Sid-5 family', 76, NULL, 'Sid-5', 270045),
(450952, 'PF19173', NULL, 'Family of unknown function (DUF5855)', 182, NULL, 'DUF5855', 270046),
(450953, 'PF13643', NULL, 'Domain of unknown function (DUF4145)', 88, NULL, 'DUF4145', 270047),
(450954, 'PF20404', NULL, 'Family of unknown function (DUF6694)', 106, NULL, 'DUF6694', 270048),
(450955, 'PF15254', NULL, 'Coiled-coil domain-containing protein 14', 882, NULL, 'CCDC14', 270049),
(450956, 'PF17111', NULL, 'Fungal N-terminal domain of STAND proteins', 209, NULL, 'Helo_like_N', 270050),
(450957, 'PF03401', NULL, 'Tripartite tricarboxylate transporter family receptor', 274, NULL, 'TctC', 270051),
(450958, 'PF07537', NULL, 'CamS sex pheromone cAM373 precursor', 316, NULL, 'CamS', 270052),
(450959, 'PF11339', NULL, 'Protein of unknown function (DUF3141)', 582, NULL, 'DUF3141', 270053),
(450960, 'PF13828', NULL, 'Domain of unknown function (DUF4190)', 62, NULL, 'DUF4190', 270054),
(450961, 'PF13149', NULL, 'Fimbrillin-like', 250, NULL, 'Mfa_like_1', 270055),
(450962, 'PF06973', NULL, 'Domain of unknown function (DUF1297)', 188, NULL, 'DUF1297', 270056),
(450963, 'PF07884', NULL, 'Vitamin K epoxide reductase family', 134, NULL, 'VKOR', 270057),
(450964, 'PF18079', NULL, 'Archaeal glycosylation protein B long peripheral domain', 92, NULL, 'AglB_L1', 270058),
(450965, 'PF10152', NULL, 'Subunit CCDC53 of WASH complex', 153, NULL, 'CCDC53', 270059),
(450966, 'PF01007', NULL, 'Inward rectifier potassium channel transmembrane domain', 141, NULL, 'IRK', 270060),
(450967, 'PF08159', NULL, 'NUC153 domain', 29, NULL, 'NUC153', 270061),
(450968, 'PF12374', NULL, 'Double-sex mab3 related transcription factor 1', 74, NULL, 'Dmrt1', 270062),
(450969, 'PF18589', NULL, 'Obesity receptor immunoglobulin like domain', 105, NULL, 'ObR_Ig', 270063),
(450970, 'PF04294', NULL, 'VanW like protein', 130, NULL, 'VanW', 270064),
(450971, 'PF07315', NULL, 'Protein of unknown function (DUF1462)', 93, NULL, 'DUF1462', 270065),
(450972, 'PF03817', NULL, 'Malonate transporter MadL subunit', 118, NULL, 'MadL', 270066),
(450973, 'PF15991', NULL, 'G-protein pathway suppressor', 276, NULL, 'G_path_suppress', 270067),
(450974, 'PF13390', NULL, 'Protein of unknown function (DUF4108)', 143, NULL, 'DUF4108', 270068),
(450975, 'PF09987', NULL, 'Uncharacterized protein conserved in archaea (DUF2226)', 297, NULL, 'DUF2226', 270069),
(450976, 'PF03825', NULL, 'Nucleoside H+ symporter', 400, NULL, 'Nuc_H_symport', 270070),
(450977, 'PF09206', NULL, 'Alpha-L-arabinofuranosidase B, catalytic', 316, NULL, 'ArabFuran-catal', 270071),
(450978, 'PF15214', NULL, 'Peroxisomal testis-specific protein 1', 51, NULL, 'PXT1', 270072),
(450979, 'PF19616', NULL, 'Family of unknown function (DUF6121)', 146, NULL, 'DUF6121', 270073);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(450980, 'PF04101', NULL, 'Glycosyltransferase family 28 C-terminal domain', 167, NULL, 'Glyco_tran_28_C', 270074),
(450981, 'PF11840', NULL, 'Protein of unknown function (DUF3360)', 485, NULL, 'DUF3360', 270075),
(450982, 'PF18601', NULL, 'EZH2 N-terminal domain', 79, NULL, 'EZH2_N', 270076),
(450983, 'PF10958', NULL, 'Protein of unknown function (DUF2759)', 51, NULL, 'DUF2759', 270077),
(450984, 'PF15080', NULL, 'Domain of unknown function (DUF4547)', 196, NULL, 'DUF4547', 270078),
(450985, 'PF19384', NULL, 'Family of unknown function (DUF5959)', 134, NULL, 'DUF5959', 270079),
(450986, 'PF15433', NULL, 'Mitochondrial 28S ribosomal protein S31', 311, NULL, 'MRP-S31', 270080),
(450987, 'PF16585', NULL, 'Lipocalin-like domain', 135, NULL, 'Lipocalin_8', 270081),
(450988, 'PF17269', NULL, 'Family of unknown function (DUF5335)', 110, NULL, 'DUF5335', 270082),
(450989, 'PF09796', NULL, 'Ubiquinol-cytochrome-c reductase complex subunit (QCR10)', 63, NULL, 'QCR10', 270083),
(450990, 'PF16690', NULL, 'Methylmalonic aciduria and homocystinuria type C family', 216, NULL, 'MMACHC', 270084),
(450991, 'PF04187', NULL, 'Haem-binding uptake, Tiki superfamily, ChaN', 213, NULL, 'Cofac_haem_bdg', 270085),
(450992, 'PF13731', NULL, 'WxL domain surface cell wall-binding', 213, NULL, 'WxL', 270086),
(450993, 'PF14536', NULL, 'Domain of unknown function (DUF4441)', 117, NULL, 'DUF4441', 270087),
(450994, 'PF01015', NULL, 'Ribosomal S3Ae family', 191, NULL, 'Ribosomal_S3Ae', 270088),
(450995, 'PF03199', NULL, 'Eukaryotic glutathione synthase', 107, NULL, 'GSH_synthase', 270089),
(450996, 'PF00831', NULL, 'Ribosomal L29 protein', 57, NULL, 'Ribosomal_L29', 270090),
(450997, 'PF04317', NULL, 'YcjX-like family, DUF463', 440, NULL, 'DUF463', 270091),
(450998, 'PF18368', NULL, 'Exo-beta-D-glucosaminidase Ig-fold domain', 105, NULL, 'Ig_GlcNase', 270092),
(450999, 'PF06549', NULL, 'Protein of unknown function (DUF1118)', 115, NULL, 'DUF1118', 270093),
(451000, 'PF08965', NULL, 'Domain of unknown function (DUF1870)', 118, NULL, 'DUF1870', 270094),
(451001, 'PF16252', NULL, 'Domain of unknown function (DUF4908)', 221, NULL, 'DUF4908', 270095),
(451002, 'PF06619', NULL, 'Protein of unknown function (DUF1149)', 125, NULL, 'DUF1149', 270096),
(451003, 'PF19860', NULL, 'Family of unknown function (DUF6334)', 125, NULL, 'DUF6334', 270097),
(451004, 'PF14703', NULL, 'Cytosolic domain of 10TM putative phosphate transporter', 176, NULL, 'PHM7_cyt', 270098),
(451005, 'PF16490', NULL, 'Putative oxidoreductase C terminal domain', 279, NULL, 'Oxidoreduct_C', 270099),
(451006, 'PF00549', NULL, 'CoA-ligase', 153, NULL, 'Ligase_CoA', 270100),
(451007, 'PF17124', NULL, 'ThiJ/PfpI family-like', 200, NULL, 'ThiJ_like', 270101),
(451008, 'PF07814', NULL, 'Wings apart-like protein regulation of heterochromatin', 355, NULL, 'WAPL', 270102),
(451009, 'PF20392', NULL, 'Family of unknown function (DUF6687)', 338, NULL, 'DUF6687', 270103),
(451010, 'PF08308', NULL, 'PEGA domain', 70, NULL, 'PEGA', 270104),
(451011, 'PF18241', NULL, 'Flax-rust effector AvrM-A', 147, NULL, 'AvrM-A', 270105),
(451012, 'PF17220', NULL, 'Protein of unknown function (DUF5137)', 85, NULL, 'DUF5137', 270106),
(451013, 'PF01530', NULL, 'Zinc finger, C2HC type', 29, NULL, 'zf-C2HC', 270107),
(451014, 'PF02159', NULL, 'Oestrogen receptor', 138, NULL, 'Oest_recep', 270108),
(451015, 'PF14650', NULL, 'FAM75 family', 382, NULL, 'FAM75', 270109),
(451016, 'PF01128', NULL, '2-C-methyl-D-erythritol 4-phosphate cytidylyltransferase', 221, NULL, 'IspD', 270110),
(451017, 'PF04753', NULL, 'Coronavirus non-structural protein NS12.7 family', 109, NULL, 'Corona_NS12-7', 270111),
(451018, 'PF14761', NULL, 'Hermansky-Pudlak syndrome 3', 212, NULL, 'HPS3_N', 270112),
(451019, 'PF04123', NULL, 'Domain of unknown function (DUF373)', 335, NULL, 'DUF373', 270113),
(451020, 'PF07149', NULL, 'Pes-10', 395, NULL, 'Pes-10', 270114),
(451021, 'PF05626', NULL, 'Protein of unknown function (DUF790)', 387, NULL, 'DUF790', 270115),
(451022, 'PF03698', NULL, 'Uncharacterised protein family (UPF0180)', 77, NULL, 'UPF0180', 270116);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(451023, 'PF12878', NULL, 'SICA extracellular beta domain', 172, NULL, 'SICA_beta', 270117),
(451024, 'PF19819', NULL, 'Family of unknown function (DUF6302)', 136, NULL, 'DUF6302', 270118),
(451025, 'PF02449', NULL, 'Beta-galactosidase', 374, NULL, 'Glyco_hydro_42', 270119),
(451026, 'PF09099', NULL, 'Quinohemoprotein amine dehydrogenase, alpha subunit domain III', 82, NULL, 'Qn_am_d_aIII', 270120),
(451027, 'PF19530', NULL, 'NAD(P)H-quinone oxidoreductase subunit 2 N-terminal', 100, NULL, 'Ndh2_N', 270121),
(451028, 'PF10251', NULL, 'Presenilin enhancer-2 subunit of gamma secretase', 93, NULL, 'PEN-2', 270122),
(451029, 'PF13376', NULL, 'Bacteriocin-protection, YdeI or OmpD-Associated', 60, NULL, 'OmdA', 270123),
(451030, 'PF03407', NULL, 'Nucleotide-diphospho-sugar transferase', 212, NULL, 'Nucleotid_trans', 270124),
(451031, 'PF11461', NULL, 'Rab interacting lysosomal protein', 69, NULL, 'RILP', 270125),
(451032, 'PF16972', NULL, 'Na+ channel auxiliary subunit TipE', 486, NULL, 'TipE', 270126),
(451033, 'PF07264', NULL, 'Etoposide-induced protein 2.4 (EI24)', 179, NULL, 'EI24', 270127),
(451034, 'PF13308', NULL, 'YARHG domain', 84, NULL, 'YARHG', 270128),
(451035, 'PF20607', NULL, 'Family of unknown function (DUF6800)', 43, NULL, 'DUF6800', 270129),
(451036, 'PF04217', NULL, 'Protein of unknown function, DUF412', 141, NULL, 'DUF412', 270130),
(451037, 'PF07332', NULL, 'Putative Actinobacterial Holin-X, holin superfamily III', 114, NULL, 'Phage_holin_3_6', 270131),
(451038, 'PF11297', NULL, 'Protein of unknown function (DUF3098)', 67, NULL, 'DUF3098', 270132),
(451039, 'PF20183', NULL, 'Family of unknown function (DUF6546)', 202, NULL, 'DUF6546', 270133),
(451040, 'PF08072', NULL, 'BDHCT (NUC031) domain', 41, NULL, 'BDHCT', 270134),
(451041, 'PF18677', NULL, 'Archaellum regulatory network B, C-terminal domain', 73, NULL, 'ArnB_C', 270135),
(451042, 'PF14534', NULL, 'Domain of unknown function (DUF4440)', 107, NULL, 'DUF4440', 270136),
(451043, 'PF18020', NULL, 'TIG domain found in plexin', 94, NULL, 'TIG_2', 270137),
(451044, 'PF02611', NULL, 'CDP-diacylglycerol pyrophosphatase', 224, NULL, 'CDH', 270138),
(451045, 'PF10364', NULL, 'Putative capsular polysaccharide synthesis protein', 139, NULL, 'NKWYS', 270139),
(451046, 'PF14196', NULL, 'L-2-amino-thiazoline-4-carboxylic acid hydrolase', 145, NULL, 'ATC_hydrolase', 270140),
(451047, 'PF19995', NULL, 'inactive STAND', 162, NULL, 'iSTAND', 270141),
(451048, 'PF03252', NULL, 'Herpesvirus UL21', 524, NULL, 'Herpes_UL21', 270142),
(451049, 'PF07688', NULL, 'KaiA C-terminal domain', 122, NULL, 'KaiA', 270143),
(451050, 'PF16665', NULL, 'Unstructured region on nuclear receptor coactivator protein', 119, NULL, 'NCOA_u2', 270144),
(451051, 'PF20272', NULL, 'Cysteine-rich domain, C-terminal to E2 domain', 129, NULL, 'E2-Crich', 270145),
(451052, 'PF19228', NULL, 'Family of unknown function (DUF5881)', 163, NULL, 'DUF5881', 270146),
(451053, 'PF05919', NULL, 'Mitovirus RNA-dependent RNA polymerase', 498, NULL, 'Mitovir_RNA_pol', 270147),
(451054, 'PF08399', NULL, 'VWA N-terminal', 124, NULL, 'VWA_N', 270148),
(451055, 'PF00865', NULL, 'Osteopontin', 290, NULL, 'Osteopontin', 270149),
(451056, 'PF04845', NULL, 'PurA ssDNA and RNA-binding protein', 219, NULL, 'PurA', 270150),
(451057, 'PF03266', NULL, 'NTPase', 169, NULL, 'NTPase_1', 270151),
(451058, 'PF02527', NULL, 'rRNA small subunit methyltransferase G', 184, NULL, 'GidB', 270152),
(451059, 'PF03448', NULL, 'MgtE intracellular N domain', 102, NULL, 'MgtE_N', 270153),
(451060, 'PF05878', NULL, 'Phytoreovirus nonstructural protein Pns9/Pns10', 319, NULL, 'Phyto_Pns9_10', 270154),
(451061, 'PF07033', NULL, 'Orthopoxvirus B11R protein', 71, NULL, 'Orthopox_B11R', 270155),
(451062, 'PF04976', NULL, 'DMSO reductase anchor subunit (DmsC)', 276, NULL, 'DmsC', 270156),
(451063, 'PF15415', NULL, 'Fimbrillin-like', 312, NULL, 'Mfa_like_2', 270157),
(451064, 'PF15721', NULL, 'Annexin-2 receptor', 190, NULL, 'ANXA2R', 270158),
(451065, 'PF04554', NULL, 'Extensin-like region', 58, NULL, 'Extensin_2', 270159);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(451066, 'PF13401', NULL, 'AAA domain', 137, NULL, 'AAA_22', 270160),
(451067, 'PF07168', NULL, 'Ureide permease', 361, NULL, 'Ureide_permease', 270161),
(451068, 'PF03184', NULL, 'DDE superfamily endonuclease', 175, NULL, 'DDE_1', 270162),
(451069, 'PF18037', NULL, 'Ubiquitin-like domain', 98, NULL, 'Ubiquitin_5', 270163),
(451070, 'PF19785', NULL, 'Family of unknown function (UPF0738)', 119, NULL, 'UPF0738', 270164),
(451071, 'PF04012', NULL, 'PspA/IM30 family', 221, NULL, 'PspA_IM30', 270165),
(451072, 'PF04759', NULL, 'Protein of unknown function, DUF617', 161, NULL, 'DUF617', 270166),
(451073, 'PF10446', NULL, 'Protein of unknown function (DUF2457)', 466, NULL, 'DUF2457', 270167),
(451074, 'PF11835', NULL, 'RRM-like domain', 89, NULL, 'RRM_8', 270168),
(451075, 'PF14401', NULL, 'RimK-like ATPgrasp N-terminal domain', 150, NULL, 'RLAN', 270169),
(451076, 'PF06147', NULL, 'Protein of unknown function (DUF968)', 171, NULL, 'DUF968', 270170),
(451077, 'PF01894', NULL, 'Uncharacterised protein family UPF0047', 115, NULL, 'UPF0047', 270171),
(451078, 'PF19451', NULL, 'Family of unknown function (DUF5989)', 49, NULL, 'DUF5989', 270172),
(451079, 'PF15803', NULL, 'Zinc-finger of sodium channel modifier 1', 27, NULL, 'zf-SCNM1', 270173),
(451080, 'PF05677', NULL, 'Chlamydia CHLPS protein (DUF818)', 365, NULL, 'DUF818', 270174),
(451081, 'PF13392', NULL, 'HNH endonuclease', 46, NULL, 'HNH_3', 270175),
(451082, 'PF12013', NULL, 'Orsellinic acid/F9775 biosynthesis cluster protein D', 114, NULL, 'OrsD', 270176),
(451083, 'PF00507', NULL, 'NADH-ubiquinone/plastoquinone oxidoreductase, chain 3', 99, NULL, 'Oxidored_q4', 270177),
(451084, 'PF19697', NULL, 'Atg11 middle domain', 79, NULL, 'Atg11_middle', 270178),
(451085, 'PF11773', NULL, 'Type II secretory pathway pseudopilin', 82, NULL, 'PulG', 270179),
(451086, 'PF15854', NULL, 'G-protein coupled receptor ligand 15', 80, NULL, 'GPR15L', 270180),
(451087, 'PF14307', NULL, 'Glycosyltransferase WbsX', 348, NULL, 'Glyco_tran_WbsX', 270181),
(451088, 'PF06489', NULL, 'Orthopoxvirus A49R protein', 162, NULL, 'Orthopox_A49R', 270182),
(451089, 'PF05794', NULL, 'T-complex protein 11', 447, NULL, 'Tcp11', 270183),
(451090, 'PF09244', NULL, 'Domain of unknown function (DUF1964)', 67, NULL, 'DUF1964', 270184),
(451091, 'PF04019', NULL, 'Protein of unknown function (DUF359)', 122, NULL, 'DUF359', 270185),
(451092, 'PF15990', NULL, 'UPF0767 family', 83, NULL, 'UPF0767', 270186),
(451093, 'PF18957', NULL, 'Long Rib domain', 96, NULL, 'RibLong', 270187),
(451094, 'PF00839', NULL, 'Cysteine rich repeat', 58, NULL, 'Cys_rich_FGFR', 270188),
(451095, 'PF08341', NULL, 'Thioester domain', 104, NULL, 'TED', 270189),
(451096, 'PF03747', NULL, 'ADP-ribosylglycohydrolase', 292, NULL, 'ADP_ribosyl_GH', 270190),
(451097, 'PF05822', NULL, 'Pyrimidine 5''-nucleotidase (UMPH-1)', 246, NULL, 'UMPH-1', 270191),
(451098, 'PF13700', NULL, 'Domain of unknown function (DUF4158)', 166, NULL, 'DUF4158', 270192),
(451099, 'PF10423', NULL, 'Bacterial AMP nucleoside phosphorylase N-terminus', 154, NULL, 'AMNp_N', 270193),
(451100, 'PF07608', NULL, 'Protein of unknown function (DUF1571)', 208, NULL, 'DUF1571', 270194),
(451101, 'PF16695', NULL, 'Type VI secretion system (T6SS), amidase immunity protein', 92, NULL, 'Tai4', 270195),
(451102, 'PF12972', NULL, 'Alpha-N-acetylglucosaminidase (NAGLU) C-terminal domain', 268, NULL, 'NAGLU_C', 270196),
(451103, 'PF18093', NULL, 'tRNA methyltransferase 5 N-terminal domain', 47, NULL, 'Trm5_N', 270197),
(451104, 'PF01134', NULL, 'Glucose inhibited division protein A', 392, NULL, 'GIDA', 270198),
(451105, 'PF13685', NULL, 'Iron-containing alcohol dehydrogenase', 251, NULL, 'Fe-ADH_2', 270199),
(451106, 'PF08271', NULL, 'TFIIB zinc-binding', 43, NULL, 'TF_Zn_Ribbon', 270200),
(451107, 'PF16932', NULL, 'Type IV secretory system, conjugal DNA-protein transfer', 213, NULL, 'T4SS_TraI', 270201),
(451108, 'PF13180', NULL, 'PDZ domain', 82, NULL, 'PDZ_2', 270202),
(451109, 'PF03824', NULL, 'High-affinity nickel-transport protein', 287, NULL, 'NicO', 270203);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(451110, 'PF03996', NULL, 'Hemagglutinin esterase', 238, NULL, 'Hema_esterase', 270204),
(451111, 'PF10433', NULL, 'Mono-functional DNA-alkylating methyl methanesulfonate N-term', 491, NULL, 'MMS1_N', 270205),
(451112, 'PF17196', NULL, 'Protein of unknown function (DUF5133)', 65, NULL, 'DUF5133', 270206),
(451113, 'PF12452', NULL, 'Protein of unknown function (DUF3685)', 192, NULL, 'DUF3685', 270207),
(451114, 'PF01457', NULL, 'Leishmanolysin', 529, NULL, 'Peptidase_M8', 270208),
(451115, 'PF17229', NULL, 'Serine/threonine-protein kinase SMG1 N-terminal', 106, NULL, 'SMG1_N', 270209),
(451116, 'PF02837', NULL, 'Glycosyl hydrolases family 2, sugar binding domain', 169, NULL, 'Glyco_hydro_2_N', 270210),
(451117, 'PF03773', NULL, 'Predicted permease', 294, NULL, 'ArsP_1', 270211),
(451118, 'PF05162', NULL, 'Ribosomal protein L41', 25, NULL, 'Ribosomal_L41', 270212),
(451119, 'PF17335', NULL, 'Ino80 complex subunit 5', 113, NULL, 'IES5', 270213),
(451120, 'PF14845', NULL, 'beta-acetyl hexosaminidase like', 135, NULL, 'Glycohydro_20b2', 270214),
(451121, 'PF11887', NULL, 'Cholesterol uptake porter CUP1 of Mce4, putative', 221, NULL, 'Mce4_CUP1', 270215),
(451122, 'PF10342', NULL, 'Kre9/KNH-like N-terminal Ig-like domain', 94, NULL, 'Kre9_KNH', 270216),
(451123, 'PF17758', NULL, 'Proteasomal ATPase OB N-terminal domain', 62, NULL, 'Prot_ATP_OB_N', 270217),
(451124, 'PF19947', NULL, 'Family of unknown function (DUF6409)', 121, NULL, 'DUF6409', 270218),
(451125, 'PF03871', NULL, 'RNA polymerase Rpb5, N-terminal domain', 89, NULL, 'RNA_pol_Rpb5_N', 270219),
(451126, 'PF00693', NULL, 'Thymidine kinase from herpesvirus', 280, NULL, 'Herpes_TK', 270220),
(451127, 'PF06770', NULL, 'Actin-rearrangement-inducing factor (Arif-1)', 205, NULL, 'Arif-1', 270221),
(451128, 'PF09706', NULL, 'CRISPR-associated protein (Cas_CXXC_CXXC)', 69, NULL, 'Cas_CXXC_CXXC', 270222),
(451129, 'PF04982', NULL, 'HPP family', 122, NULL, 'HPP', 270223),
(451130, 'PF01182', NULL, 'Glucosamine-6-phosphate isomerases/6-phosphogluconolactonase', 226, NULL, 'Glucosamine_iso', 270224),
(451131, 'PF03223', NULL, 'V-ATPase subunit C', 370, NULL, 'V-ATPase_C', 270225),
(451132, 'PF19331', NULL, 'Methylcrotonoyl-CoA carboxylase subunit alpha BT domain', 165, NULL, 'MCCA_BT', 270226),
(451133, 'PF13076', NULL, 'Fur-regulated basic protein A', 36, NULL, 'Fur_reg_FbpA', 270227),
(451134, 'PF02106', NULL, 'Fanconi anaemia group C protein', 560, NULL, 'Fanconi_C', 270228),
(451135, 'PF09228', NULL, 'Prokaryotic Transcriptional repressor TraM', 102, NULL, 'Prok-TraM', 270229),
(451136, 'PF03733', NULL, 'Inner membrane component domain', 51, NULL, 'YccF', 270230),
(451137, 'PF05229', NULL, 'Spore Coat Protein U domain', 139, NULL, 'SCPU', 270231),
(451138, 'PF04398', NULL, 'Protein of unknown function, DUF538', 112, NULL, 'DUF538', 270232),
(451139, 'PF12713', NULL, 'Domain of unknown function (DUF3806)', 86, NULL, 'DUF3806', 270233),
(451140, 'PF12823', NULL, 'Domain of unknown function (DUF3817)', 83, NULL, 'DUF3817', 270234),
(451141, 'PF17663', NULL, 'Family of unknown function (DUF5525)', 1023, NULL, 'DUF5525', 270235),
(451142, 'PF17762', NULL, 'HTH domain found in ParB protein', 52, NULL, 'HTH_ParB', 270236),
(451143, 'PF00379', NULL, 'Insect cuticle protein', 53, NULL, 'Chitin_bind_4', 270237),
(451144, 'PF15471', NULL, 'Transmembrane protein family 171', 320, NULL, 'TMEM171', 270238),
(451145, 'PF02939', NULL, 'UcrQ family', 78, NULL, 'UcrQ', 270239),
(451146, 'PF02882', NULL, 'Tetrahydrofolate dehydrogenase/cyclohydrolase, NAD(P)-binding domain', 161, NULL, 'THF_DHG_CYH_C', 270240),
(451147, 'PF20240', NULL, 'Domain of unknown function (DUF6597)', 105, NULL, 'DUF6597', 270241),
(451148, 'PF10432', NULL, 'Bacterial phospho-glucose isomerase C-terminal SIS domain', 152, NULL, 'bact-PGI_C', 270242),
(451149, 'PF17934', NULL, 'Tetracyclin repressor-like, C-terminal domain', 109, NULL, 'TetR_C_26', 270243),
(451150, 'PF17854', NULL, 'FtsK alpha domain', 101, NULL, 'FtsK_alpha', 270244),
(451151, 'PF16526', NULL, 'C-terminal leucine zipper domain of cyclic nucleotide-gated channels', 71, NULL, 'CLZ', 270245);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(451152, 'PF11965', NULL, 'Domain of unknown function (DUF3479)', 161, NULL, 'DUF3479', 270246),
(451153, 'PF18790', NULL, 'KfrB protein', 61, NULL, 'KfrB', 270247),
(451154, 'PF08358', NULL, 'Carlavirus coat', 52, NULL, 'Flexi_CP_N', 270248),
(451155, 'PF05771', NULL, 'Poxvirus A31 protein', 113, NULL, 'Pox_A31', 270249),
(451156, 'PF12107', NULL, 'Plasminogen (Pg) ligand in fibrinolytic pathway', 17, NULL, 'VEK-30', 270250),
(451157, 'PF10043', NULL, 'Predicted periplasmic lipoprotein (DUF2279)', 91, NULL, 'DUF2279', 270251),
(451158, 'PF18092', NULL, 'DraK Histidine Kinase N-terminal domain', 86, NULL, 'DraK_HK_N', 270252),
(451159, 'PF05561', NULL, 'Borrelia burgdorferi protein of unknown function (DUF764)', 180, NULL, 'DUF764', 270253),
(451160, 'PF06316', NULL, 'Enterobacterial Ail/Lom protein', 199, NULL, 'Ail_Lom', 270254),
(451161, 'PF03010', NULL, 'GP4', 152, NULL, 'GP4', 270255),
(451162, 'PF07959', NULL, 'L-fucokinase', 406, NULL, 'Fucokinase', 270256),
(451163, 'PF15534', NULL, 'Bacterial toxin 35', 77, NULL, 'Ntox35', 270257),
(451164, 'PF17478', NULL, 'Rotavirus VP4 helical domain', 292, NULL, 'VP4_helical', 270258),
(451165, 'PF11834', NULL, 'KHA, dimerisation domain of potassium ion channel', 68, NULL, 'KHA', 270259),
(451166, 'PF17238', NULL, 'Family of unknown function (DUF5311)', 194, NULL, 'DUF5311', 270260),
(451167, 'PF19093', NULL, 'Family of unknown function (DUF5781)', 243, NULL, 'DUF5781', 270261),
(451168, 'PF19833', NULL, 'ATP-dependent DNA helicase RecG, domain 3, C-terminal', 87, NULL, 'RecG_dom3_C', 270262),
(451169, 'PF18719', NULL, 'ArlS sensor domain', 128, NULL, 'ArlS_N', 270263),
(451170, 'PF16713', NULL, 'Enriched in aromatic and glycine Residues box', 34, NULL, 'EAGR_box', 270264),
(451171, 'PF02026', NULL, 'RyR domain', 91, NULL, 'RyR', 270265),
(451172, 'PF04730', NULL, 'Agrobacterium VirD5 protein', 671, NULL, 'Agro_virD5', 270266),
(451173, 'PF09049', NULL, 'Stannin transmembrane', 32, NULL, 'SNN_transmemb', 270267),
(451174, 'PF12473', NULL, 'Kinesin protein', 152, NULL, 'DUF3694', 270268),
(451175, 'PF12800', NULL, '4Fe-4S binding domain', 17, NULL, 'Fer4_4', 270269),
(451176, 'PF07859', NULL, 'alpha/beta hydrolase fold', 211, NULL, 'Abhydrolase_3', 270270),
(451177, 'PF05984', NULL, 'Cytomegalovirus UL20A protein', 103, NULL, 'Cytomega_UL20A', 270271),
(451178, 'PF12481', NULL, 'Aluminium induced protein', 228, NULL, 'DUF3700', 270272),
(451179, 'PF17285', NULL, 'PRMT5 TIM barrel domain', 256, NULL, 'PRMT5_TIM', 270273),
(451180, 'PF04383', NULL, 'KilA-N domain', 112, NULL, 'KilA-N', 270274),
(451181, 'PF05911', NULL, 'Filament-like plant protein, long coiled-coil', 868, NULL, 'FPP', 270275),
(451182, 'PF13823', NULL, 'Alcohol dehydrogenase GroES-associated', 23, NULL, 'ADH_N_assoc', 270276),
(451183, 'PF00483', NULL, 'Nucleotidyl transferase', 247, NULL, 'NTP_transferase', 270277),
(451184, 'PF16447', NULL, 'Domain of unknown function (DUF5044)', 178, NULL, 'DUF5044', 270278),
(451185, 'PF10746', NULL, 'Phage holin T7 family, holin superfamily II', 60, NULL, 'Phage_holin_2_2', 270279),
(451186, 'PF18335', NULL, 'ATP-dependent RecD-like DNA helicase SH3 domain', 65, NULL, 'SH3_13', 270280),
(451187, 'PF08324', NULL, 'PUL domain', 276, NULL, 'PUL', 270281),
(451188, 'PF10077', NULL, 'Uncharacterized protein conserved in bacteria (DUF2314)', 136, NULL, 'DUF2314', 270282),
(451189, 'PF02944', NULL, 'BESS motif', 35, NULL, 'BESS', 270283),
(451190, 'PF17065', NULL, 'Putative cytokine, C6ORF120', 185, NULL, 'UPF0669', 270284),
(451191, 'PF14341', NULL, 'PilX N-terminal', 51, NULL, 'PilX_N', 270285),
(451192, 'PF01815', NULL, 'Rop protein', 57, NULL, 'Rop', 270286),
(451193, 'PF08373', NULL, 'RAP domain', 58, NULL, 'RAP', 270287),
(451194, 'PF12986', NULL, 'Domain of unknown function (DUF3870)', 94, NULL, 'DUF3870', 270288),
(451195, 'PF08655', NULL, 'DASH complex subunit Ask1', 64, NULL, 'DASH_Ask1', 270289),
(451196, 'PF07482', NULL, 'Domain of Unknown Function (DUF1522)', 110, NULL, 'DUF1522', 270290),
(451197, 'PF12232', NULL, 'Myogenic determination factor 5', 71, NULL, 'Myf5', 270291); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(451198, 'PF17251', NULL, 'Protochlamydia outer membrane protein', 285, NULL, 'Pom', 270292),
(451199, 'PF04442', NULL, 'Cytochrome c oxidase assembly protein CtaG/Cox11', 149, NULL, 'CtaG_Cox11', 270293),
(451200, 'PF07579', NULL, 'Domain of Unknown Function (DUF1548)', 135, NULL, 'DUF1548', 270294),
(451201, 'PF10218', NULL, 'SREBP regulating gene protein', 131, NULL, 'SPRING1', 270295),
(451202, 'PF02088', NULL, 'Ornatin', 41, NULL, 'Ornatin', 270296),
(451203, 'PF19213', NULL, 'Coronavirus replicase NSP6', 267, NULL, 'CoV_NSP6', 270297),
(451204, 'PF05808', NULL, 'Podoplanin', 135, NULL, 'Podoplanin', 270298),
(451205, 'PF18684', NULL, 'Pleurotolysin B C-terminal domain', 173, NULL, 'PlyB_C', 270299),
(451206, 'PF18839', NULL, 'Large polyvalent protein associated domain 24', 70, NULL, 'LPD24', 270300),
(451207, 'PF00765', NULL, 'Autoinducer synthase', 183, NULL, 'Autoind_synth', 270301),
(451208, 'PF10253', NULL, 'Mitotic checkpoint regulator, MAD2B-interacting', 209, NULL, 'PRCC', 270302),
(451209, 'PF01763', NULL, 'Herpesvirus UL6 like', 563, NULL, 'Herpes_UL6', 270303),
(451210, 'PF19778', NULL, 'Endonuclease domain', 109, NULL, 'RE_endonuc', 270304),
(451211, 'PF12965', NULL, 'Domain of unknown function (DUF3854)', 130, NULL, 'DUF3854', 270305),
(451212, 'PF14926', NULL, 'Cilia- and flagella-associated protein 300', 246, NULL, 'CFAP300', 270306),
(451213, 'PF13834', NULL, 'Domain of unknown function (DUF4193)', 98, NULL, 'DUF4193', 270307),
(451214, 'PF18143', NULL, 'HAD domain in Swiss Army Knife RNA repair proteins', 141, NULL, 'HAD_SAK_2', 270308),
(451215, 'PF03471', NULL, 'Transporter associated domain', 81, NULL, 'CorC_HlyC', 270309),
(451216, 'PF19245', NULL, 'Family of unknown function (DUF5893)', 147, NULL, 'DUF5893', 270310),
(451217, 'PF00248', NULL, 'Aldo/keto reductase family', 292, NULL, 'Aldo_ket_red', 270311),
(451218, 'PF11072', NULL, 'Protein of unknown function (DUF2859)', 149, NULL, 'DUF2859', 270312),
(451219, 'PF08094', NULL, 'Conotoxin TVIIA/GS family', 33, NULL, 'Toxin_24', 270313),
(451220, 'PF11534', NULL, 'Hexameric tyrosine-coordinated heme protein (HTHP)', 72, NULL, 'HTHP', 270314),
(451221, 'PF06468', NULL, 'Spondin_N', 192, NULL, 'Spond_N', 270315),
(451222, 'PF18895', NULL, 'Type IV secretion system pilin', 71, NULL, 'T4SS_pilin', 270316),
(451223, 'PF11535', NULL, 'Calcium binding', 105, NULL, 'Calci_bind_CcbP', 270317),
(451224, 'PF00963', NULL, 'Cohesin domain', 139, NULL, 'Cohesin', 270318),
(451225, 'PF09683', NULL, 'Bacteriocin (Lactococcin_972)', 63, NULL, 'Lactococcin_972', 270319),
(451226, 'PF05605', NULL, 'Drought induced 19 protein (Di19), zinc-binding', 54, NULL, 'zf-Di19', 270320),
(451227, 'PF19523', NULL, 'Family of unknown function (DUF6053)', 34, NULL, 'DUF6053', 270321),
(451228, 'PF08838', NULL, 'Protein of unknown function (DUF1811)', 100, NULL, 'DUF1811', 270322),
(451229, 'PF07087', NULL, 'Protein of unknown function (DUF1353)', 91, NULL, 'DUF1353', 270323),
(451230, 'PF12056', NULL, 'Protein of unknown function (DUF3537)', 390, NULL, 'DUF3537', 270324),
(451231, 'PF20577', NULL, 'Phage ORF5 protein', 75, NULL, 'Phage_ORF5', 270325),
(451232, 'PF08823', NULL, 'Putative peptidoglycan binding domain', 74, NULL, 'PG_binding_2', 270326),
(451233, 'PF16685', NULL, 'zinc RING finger of MSL2', 70, NULL, 'zf-RING_10', 270327),
(451234, 'PF14679', NULL, 'FANCI helical domain 1', 86, NULL, 'FANCI_HD1', 270328),
(451235, 'PF15342', NULL, 'FAM212 family', 59, NULL, 'FAM212', 270329),
(451236, 'PF16849', NULL, 'Glycosyltransferase family 88', 423, NULL, 'Glyco_transf_88', 270330),
(451237, 'PF10838', NULL, 'Protein of unknown function (DUF2677)', 166, NULL, 'DUF2677', 270331),
(451238, 'PF13701', NULL, 'Transposase DDE domain group 1', 434, NULL, 'DDE_Tnp_1_4', 270332),
(451239, 'PF16666', NULL, 'Unstructured region on MAGI', 109, NULL, 'MAGI_u5', 270333),
(451240, 'PF02634', NULL, 'FdhD/NarQ family', 237, NULL, 'FdhD-NarQ', 270334),
(451241, 'PF15764', NULL, 'Domain of unknown function (DUF4693)', 285, NULL, 'DUF4693', 270335),
(451242, 'PF12578', NULL, 'Myotubularin-associated protein', 132, NULL, '3-PAP', 270336);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(451243, 'PF14177', NULL, 'YkyB-like protein', 116, NULL, 'YkyB', 270337),
(451244, 'PF14715', NULL, 'N-terminal domain of cytochrome oxidase-cbb3, FixP', 48, NULL, 'FixP_N', 270338),
(451245, 'PF10095', NULL, 'Uncharacterized protein conserved in bacteria (DUF2333)', 330, NULL, 'DUF2333', 270339),
(451246, 'PF18640', NULL, 'LepB N-terminal domain', 183, NULL, 'LepB_N', 270340),
(451247, 'PF06766', NULL, 'Fungal hydrophobin', 65, NULL, 'Hydrophobin_2', 270341),
(451248, 'PF05689', NULL, 'Adhesion domain', 136, NULL, 'InvE_AD', 270342),
(451249, 'PF12715', NULL, 'Abhydrolase family', 388, NULL, 'Abhydrolase_7', 270343),
(451250, 'PF19761', NULL, 'Family of unknown function (DUF6248)', 151, NULL, 'DUF6248', 270344),
(451251, 'PF19987', NULL, 'Family of unknown function (DUF6423)', 161, NULL, 'DUF6423', 270345),
(451252, 'PF15209', NULL, 'Interleukin 31', 132, NULL, 'IL31', 270346),
(451253, 'PF19592', NULL, 'Family of unknown function (DUF6097)', 152, NULL, 'DUF6097', 270347),
(451254, 'PF14025', NULL, 'Protein of unknown function (DUF4241)', 187, NULL, 'DUF4241', 270348),
(451255, 'PF05482', NULL, 'Serendipity locus alpha protein (SRY-A)', 541, NULL, 'Serendipity_A', 270349),
(451256, 'PF05631', NULL, 'Sugar-tranasporters, 12 TM', 354, NULL, 'MFS_5', 270350),
(451257, 'PF15855', NULL, 'Domain of unknown function (DUF4726)', 101, NULL, 'DUF4726', 270351),
(451258, 'PF19310', NULL, 'Neurolysin/Thimet oligopeptidase, N-terminal domain', 123, NULL, 'TOP_N', 270352),
(451259, 'PF15709', NULL, 'Domain of unknown function (DUF4670)', 516, NULL, 'DUF4670', 270353),
(451260, 'PF08805', NULL, 'PilS N terminal', 138, NULL, 'PilS', 270354),
(451261, 'PF18013', NULL, 'Phage tail lysozyme', 142, NULL, 'Phage_lysozyme2', 270355),
(451262, 'PF07899', NULL, 'Frigida-like protein', 289, NULL, 'Frigida', 270356),
(451263, 'PF06918', NULL, 'Protein of unknown function (DUF1280)', 221, NULL, 'DUF1280', 270357),
(451264, 'PF00999', NULL, 'Sodium/hydrogen exchanger family', 381, NULL, 'Na_H_Exchanger', 270358),
(451265, 'PF08108', NULL, 'Halocidin family', 15, NULL, 'Antimicrobial13', 270359),
(451266, 'PF04959', NULL, 'Arsenite-resistance protein 2', 195, NULL, 'ARS2', 270360),
(451267, 'PF01047', NULL, 'MarR family', 59, NULL, 'MarR', 270361),
(451268, 'PF05532', NULL, 'CsbD-like', 53, NULL, 'CsbD', 270362),
(451269, 'PF06424', NULL, 'PRP1 splicing factor, N-terminal', 144, NULL, 'PRP1_N', 270363),
(451270, 'PF08537', NULL, 'Fungal Nap binding protein NBP1', 339, NULL, 'NBP1', 270364),
(451271, 'PF11097', NULL, 'Protein of unknown function (DUF2883)', 75, NULL, 'DUF2883', 270365),
(451272, 'PF06661', NULL, 'VirE3', 312, NULL, 'VirE3', 270366),
(451273, 'PF19851', NULL, 'Family of unknown function (DUF6326)', 135, NULL, 'DUF6326', 270367),
(451274, 'PF04909', NULL, 'Amidohydrolase', 288, NULL, 'Amidohydro_2', 270368),
(451275, 'PF09949', NULL, 'Phosphatidate phosphatase APP1, catalytic domain', 155, NULL, 'APP1_cat', 270369),
(451276, 'PF18762', NULL, 'Serine/Threonine/Tyrosine Kinase found in polyvalent proteins', 160, NULL, 'Kinase-PolyVal', 270370),
(451277, 'PF01888', NULL, 'CbiD', 252, NULL, 'CbiD', 270371),
(451278, 'PF18100', NULL, 'Phosphodiesterase 4 upstream conserved regions (UCR)', 119, NULL, 'PDE4_UCR', 270372),
(451279, 'PF15384', NULL, 'PAXX, PAralog of XRCC4 and XLF, also called C9orf142', 194, NULL, 'PAXX', 270373),
(451280, 'PF10118', NULL, 'Predicted metal-dependent hydrolase', 244, NULL, 'Metal_hydrol', 270374),
(451281, 'PF08751', NULL, 'TrwC relaxase', 292, NULL, 'TrwC', 270375),
(451282, 'PF13515', NULL, 'Fusaric acid resistance protein-like', 126, NULL, 'FUSC_2', 270376),
(451283, 'PF13789', NULL, 'Domain of unknown function (DUF4181)', 108, NULL, 'DUF4181', 270377),
(451284, 'PF20192', NULL, 'Family of unknown function (DUF6555)', 74, NULL, 'DUF6555', 270378),
(451285, 'PF09667', NULL, 'Domain of unknown function (DUF2028)', 180, NULL, 'DUF2028', 270379),
(451286, 'PF05679', NULL, 'Chondroitin N-acetylgalactosaminyltransferase', 516, NULL, 'CHGN', 270380),
(451287, 'PF02224', NULL, 'Cytidylate kinase', 211, NULL, 'Cytidylate_kin', 270381);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(451288, 'PF06718', NULL, 'Protein of unknown function (DUF1203)', 116, NULL, 'DUF1203', 270382),
(451289, 'PF18591', NULL, 'Immune Mapped Protein 2 (IMP2) C-terminal domain', 63, NULL, 'IMP2_C', 270383),
(451290, 'PF20458', NULL, 'Family of unknown function (DUF6711)', 134, NULL, 'DUF6711', 270384),
(451291, 'PF11153', NULL, 'Protein of unknown function (DUF2931)', 182, NULL, 'DUF2931', 270385),
(451292, 'PF08576', NULL, 'Eukaryotic protein of unknown function (DUF1764)', 100, NULL, 'DUF1764', 270386),
(451293, 'PF06941', NULL, '5'' nucleotidase, deoxy (Pyrimidine), cytosolic type C protein (NT5C)', 180, NULL, 'NT5C', 270387),
(451294, 'PF06269', NULL, 'Protein of unknown function (DUF1029)', 53, NULL, 'DUF1029', 270388),
(451295, 'PF06234', NULL, 'Toluene-4-monooxygenase system protein B (TmoB)', 79, NULL, 'TmoB', 270389),
(451296, 'PF16633', NULL, 'Unstructured region on APC between 1st two creatine-rich regions', 89, NULL, 'APC_u9', 270390),
(451297, 'PF11164', NULL, 'Protein of unknown function (DUF2948)', 139, NULL, 'DUF2948', 270391),
(451298, 'PF03278', NULL, 'IpaB/EvcA family', 154, NULL, 'IpaB_EvcA', 270392),
(451299, 'PF07146', NULL, 'Protein of unknown function (DUF1389)', 314, NULL, 'DUF1389', 270393),
(451300, 'PF17468', NULL, 'Phage gene product 52', 61, NULL, 'GP52', 270394),
(451301, 'PF03771', NULL, 'Domain of unknown function (DUF317)', 62, NULL, 'SPDY', 270395),
(451302, 'PF10028', NULL, 'Predicted integral membrane protein (DUF2270)', 184, NULL, 'DUF2270', 270396),
(451303, 'PF09252', NULL, 'Allergen Fel d I-B chain', 67, NULL, 'Feld-I_B', 270397),
(451304, 'PF07750', NULL, 'GcrA cell cycle regulator', 162, NULL, 'GcrA', 270398),
(451305, 'PF12805', NULL, 'FUSC-like inner membrane protein yccS', 284, NULL, 'FUSC-like', 270399),
(451306, 'PF13023', NULL, 'HD domain', 165, NULL, 'HD_3', 270400),
(451307, 'PF03049', NULL, 'UL79 family', 254, NULL, 'Herpes_UL79', 270401),
(451308, 'PF14417', NULL, 'MEDS: MEthanogen/methylotroph, DcmR Sensory domain', 161, NULL, 'MEDS', 270402),
(451309, 'PF05745', NULL, 'Chlamydia 15 kDa cysteine-rich outer membrane protein (CRPA)', 150, NULL, 'CRPA', 270403),
(451310, 'PF15000', NULL, 'Tumour suppressor candidate 2', 112, NULL, 'TUSC2', 270404),
(451311, 'PF08892', NULL, 'YqcI/YcgG family', 211, NULL, 'YqcI_YcgG', 270405),
(451312, 'PF09787', NULL, 'Golgin subfamily A member 5', 305, NULL, 'Golgin_A5', 270406),
(451313, 'PF01383', NULL, 'CpcD/allophycocyanin linker domain', 55, NULL, 'CpcD', 270407),
(451314, 'PF00298', NULL, 'Ribosomal protein L11, RNA binding domain', 70, NULL, 'Ribosomal_L11', 270408),
(451315, 'PF05554', NULL, 'Viral hemorrhagic septicemia virus non-virion protein', 122, NULL, 'Novirhabdo_Nv', 270409),
(451316, 'PF14408', NULL, 'Ribosomally synthesised peptide in actinomycetes', 58, NULL, 'Actino_peptide', 270410),
(451317, 'PF04474', NULL, 'Protein of unknown function (DUF554)', 220, NULL, 'DUF554', 270411),
(451318, 'PF17664', NULL, 'Cilia- and flagella-associated protein HOATZ-like', 168, NULL, 'HOATZ-like', 270412),
(451319, 'PF04393', NULL, 'Protein of unknown function (DUF535)', 281, NULL, 'DUF535', 270413),
(451320, 'PF16071', NULL, 'Domain of unknown function (DUF4812)', 65, NULL, 'DUF4812', 270414),
(451321, 'PF19005', NULL, 'Family of unknown function (DUF5734)', 83, NULL, 'DUF5734', 270415),
(451322, 'PF04573', NULL, 'Signal peptidase subunit', 172, NULL, 'SPC22', 270416),
(451323, 'PF18593', NULL, 'CdiI immunity protein', 91, NULL, 'CdiI_2', 270417),
(451324, 'PF18620', NULL, 'Family of unknown function (DUF5627)', 136, NULL, 'DUF5627', 270418),
(451325, 'PF13257', NULL, 'Domain of unknown function (DUF4048)', 256, NULL, 'DUF4048', 270419),
(451326, 'PF17089', NULL, 'Uncharacterised protein family', 92, NULL, 'YjbT', 270420),
(451327, 'PF07331', NULL, 'Tripartite tricarboxylate transporter TctB family', 134, NULL, 'TctB', 270421),
(451328, 'PF09299', NULL, 'Mu transposase, C-terminal', 61, NULL, 'Mu-transpos_C', 270422),
(451329, 'PF14981', NULL, 'FAM165 family', 50, NULL, 'FAM165', 270423),
(451330, 'PF03345', NULL, 'Oligosaccharyltransferase 48 kDa subunit beta', 404, NULL, 'DDOST_48kD', 270424);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(451331, 'PF06028', NULL, 'Alpha/beta hydrolase of unknown function (DUF915)', 255, NULL, 'DUF915', 270425),
(451332, 'PF11189', NULL, 'Protein of unknown function (DUF2973)', 68, NULL, 'DUF2973', 270426),
(451333, 'PF16562', NULL, 'N-terminal domain of E3 ubiquitin-protein ligase HECW1 and 2', 120, NULL, 'HECW_N', 270427),
(451334, 'PF01356', NULL, 'Alpha amylase inhibitor', 68, NULL, 'A_amylase_inhib', 270428),
(451335, 'PF02897', NULL, 'Prolyl oligopeptidase, N-terminal beta-propeller domain', 414, NULL, 'Peptidase_S9_N', 270429),
(451336, 'PF03441', NULL, 'FAD binding domain of DNA photolyase', 203, NULL, 'FAD_binding_7', 270430),
(451337, 'PF12988', NULL, 'TraQ conjugal transfer protein', 133, NULL, 'TraQ_transposon', 270431),
(451338, 'PF03790', NULL, 'KNOX1 domain', 43, NULL, 'KNOX1', 270432),
(451339, 'PF13316', NULL, 'Protein of unknown function (DUF4087)', 98, NULL, 'DUF4087', 270433),
(451340, 'PF12284', NULL, 'Hox protein A13 N terminal', 119, NULL, 'HoxA13_N', 270434),
(451341, 'PF07744', NULL, 'SPOC domain', 151, NULL, 'SPOC', 270435),
(451342, 'PF10655', NULL, 'Hypothetical protein of unknown function (DUF2482)', 99, NULL, 'DUF2482', 270436),
(451343, 'PF19639', NULL, 'Family of unknown function (DUF6142)', 103, NULL, 'DUF6142', 270437),
(451344, 'PF01466', NULL, 'Skp1 family, dimerisation domain', 48, NULL, 'Skp1', 270438),
(451345, 'PF17370', NULL, 'Family of unknown function (DUF5392)', 139, NULL, 'DUF5392', 270439),
(451346, 'PF00012', NULL, 'Hsp70 protein', 599, NULL, 'HSP70', 270440),
(451347, 'PF14699', NULL, 'N-terminal domain from the human glycogen debranching enzyme', 92, NULL, 'hGDE_N', 270441),
(451348, 'PF07776', NULL, 'Zinc-finger associated domain (zf-AD)', 77, NULL, 'zf-AD', 270442),
(451349, 'PF01937', NULL, 'Damage-control phosphatase ARMT1-like domain', 353, NULL, 'ARMT1-like_dom', 270443),
(451350, 'PF04863', NULL, 'Alliinase EGF-like domain', 55, NULL, 'EGF_alliinase', 270444),
(451351, 'PF03706', NULL, 'Lysylphosphatidylglycerol synthase TM region', 300, NULL, 'LPG_synthase_TM', 270445),
(451352, 'PF08755', NULL, 'Hemimethylated DNA-binding protein YccV like', 101, NULL, 'YccV-like', 270446),
(451353, 'PF09941', NULL, 'Uncharacterized conserved protein (DUF2173)', 106, NULL, 'DUF2173', 270447),
(451354, 'PF20511', NULL, 'Phosphomannose isomerase type I, catalytic domain', 144, NULL, 'PMI_typeI_cat', 270448),
(451355, 'PF01033', NULL, 'Somatomedin B domain', 40, NULL, 'Somatomedin_B', 270449),
(451356, 'PF03799', NULL, 'Cell division protein FtsQ/DivIB, C-terminal', 114, NULL, 'FtsQ_DivIB_C', 270450),
(451357, 'PF00149', NULL, 'Calcineurin-like phosphoesterase', 205, NULL, 'Metallophos', 270451),
(451358, 'PF02318', NULL, 'FYVE-type zinc finger', 118, NULL, 'FYVE_2', 270452),
(451359, 'PF07949', NULL, 'YbbR-like protein', 82, NULL, 'YbbR', 270453),
(451360, 'PF16529', NULL, 'WD40 region of Ge1, enhancer of mRNA-decapping protein', 329, NULL, 'Ge1_WD40', 270454),
(451361, 'PF03988', NULL, 'Repeat of Unknown Function (DUF347)', 52, NULL, 'DUF347', 270455),
(451362, 'PF02151', NULL, 'UvrB/uvrC motif', 36, NULL, 'UVR', 270456),
(451363, 'PF07760', NULL, 'Protein of unknown function (DUF1616)', 303, NULL, 'DUF1616', 270457),
(451364, 'PF04739', NULL, '5''-AMP-activated protein kinase beta subunit, interaction domain', 75, NULL, 'AMPKBI', 270458),
(451365, 'PF08441', NULL, 'Integrin alpha', 465, NULL, 'Integrin_alpha2', 270459),
(451366, 'PF09544', NULL, 'Protein of unknown function (DUF2381)', 288, NULL, 'DUF2381', 270460),
(451367, 'PF05147', NULL, 'Lanthionine synthetase C-like protein', 352, NULL, 'LANC_like', 270461),
(451368, 'PF07187', NULL, 'Protein of unknown function (DUF1405)', 160, NULL, 'DUF1405', 270462),
(451369, 'PF14668', NULL, 'Rapamycin-insensitive companion of mTOR, domain 5', 71, NULL, 'RICTOR_V', 270463),
(451370, 'PF18234', NULL, 'Violacein biosynthetic enzyme VioE', 182, NULL, 'VioE', 270464),
(451371, 'PF01330', NULL, 'RuvA N terminal domain', 60, NULL, 'RuvA_N', 270465),
(451372, 'PF18803', NULL, 'CxC2 like cysteine cluster associated with KDZ transposases', 107, NULL, 'CxC2', 270466);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(451373, 'PF03331', NULL, 'UDP-3-O-acyl N-acetylglycosamine deacetylase', 268, NULL, 'LpxC', 270467),
(451374, 'PF00899', NULL, 'ThiF family', 219, NULL, 'ThiF', 270468),
(451375, 'PF10564', NULL, 'Sialic-acid binding micronemal adhesive repeat', 94, NULL, 'MAR_sialic_bdg', 270469),
(451376, 'PF16260', NULL, 'Domain of unknown function (DUF4914)', 612, NULL, 'DUF4914', 270470),
(451377, 'PF11933', NULL, 'Cytoplasmic domain of voltage-gated Na+ ion channel', 165, NULL, 'Na_trans_cytopl', 270471),
(451378, 'PF15591', NULL, 'Immunity protein 31', 73, NULL, 'Imm31', 270472),
(451379, 'PF01954', NULL, 'AF2212-like', 59, NULL, 'AF2212-like', 270473),
(451380, 'PF16527', NULL, 'Two-component sensor protein CpxA, periplasmic domain', 134, NULL, 'CpxA_peri', 270474),
(451381, 'PF10743', NULL, 'Regulatory phage protein cox', 87, NULL, 'Phage_Cox', 270475),
(451382, 'PF01147', NULL, 'Crustacean CHH/MIH/GIH neurohormone family', 67, NULL, 'Crust_neurohorm', 270476),
(451383, 'PF06196', NULL, 'Protein of unknown function (DUF997)', 77, NULL, 'DUF997', 270477),
(451384, 'PF19051', NULL, 'Oxidoreductase family, C-terminal alpha/beta domain', 254, NULL, 'GFO_IDH_MocA_C2', 270478),
(451385, 'PF20355', NULL, 'Family of unknown function (DUF6650)', 150, NULL, 'DUF6650', 270479),
(451386, 'PF09416', NULL, 'RNA helicase (UPF2 interacting domain)', 152, NULL, 'UPF1_Zn_bind', 270480),
(451387, 'PF13772', NULL, 'AIG2-like family', 83, NULL, 'AIG2_2', 270481),
(451388, 'PF17422', NULL, 'Family of unknown function (DUF5410)', 350, NULL, 'DUF5410', 270482),
(451389, 'PF04174', NULL, 'A circularly permuted ATPgrasp', 332, NULL, 'CP_ATPgrasp_1', 270483),
(451390, 'PF12848', NULL, 'ABC transporter', 85, NULL, 'ABC_tran_Xtn', 270484),
(451391, 'PF02767', NULL, 'DNA polymerase III beta subunit, central domain', 116, NULL, 'DNA_pol3_beta_2', 270485),
(451392, 'PF17823', NULL, 'Family of unknown function (DUF5585)', 477, NULL, 'DUF5585', 270486),
(451393, 'PF07260', NULL, 'Progressive ankylosis protein (ANKH)', 344, NULL, 'ANKH', 270487),
(451394, 'PF03238', NULL, 'ESAG protein', 227, NULL, 'ESAG1', 270488),
(451395, 'PF05551', NULL, 'Zinc-binding loop region of homing endonuclease', 131, NULL, 'zf-His_Me_endon', 270489),
(451396, 'PF03440', NULL, 'Aerolysin/Pertussis toxin (APT) domain', 87, NULL, 'APT', 270490),
(451397, 'PF15188', NULL, 'Coiled-coil domain-containing protein 167', 84, NULL, 'CCDC-167', 270491),
(451398, 'PF10070', NULL, 'Probable inorganic carbon transporter subunit DabA', 760, NULL, 'DabA', 270492),
(451399, 'PF00898', NULL, 'Orbivirus outer capsid protein VP2', 946, NULL, 'Orbi_VP2', 270493),
(451400, 'PF19803', NULL, 'Family of unknown function (DUF6286)', 104, NULL, 'DUF6286', 270494),
(451401, 'PF04255', NULL, 'Protein of unknown function (DUF433)', 56, NULL, 'DUF433', 270495),
(451402, 'PF05803', NULL, 'Chordopoxvirus L2 protein', 81, NULL, 'Chordopox_L2', 270496),
(451403, 'PF03039', NULL, 'Interleukin-12 alpha subunit', 214, NULL, 'IL12', 270497),
(451404, 'PF07218', NULL, 'Rhoptry-associated protein 1 (RAP-1)', 782, NULL, 'RAP1', 270498),
(451405, 'PF07729', NULL, 'FCD domain', 125, NULL, 'FCD', 270499),
(451406, 'PF09817', NULL, 'RZZ complex, subunit zwilch', 574, NULL, 'Zwilch', 270500),
(451407, 'PF19299', NULL, 'Domain of unknown function (DUF5914)', 187, NULL, 'DUF5914', 270501),
(451408, 'PF09572', NULL, 'XamI restriction endonuclease', 254, NULL, 'RE_XamI', 270502),
(451409, 'PF09561', NULL, 'HpaII restriction endonuclease', 357, NULL, 'RE_HpaII', 270503),
(451410, 'PF13635', NULL, 'Domain of unknown function (DUF4143)', 122, NULL, 'DUF4143', 270504),
(451411, 'PF03125', NULL, 'C. elegans Sre G protein-coupled chemoreceptor', 365, NULL, 'Sre', 270505),
(451412, 'PF03992', NULL, 'Antibiotic biosynthesis monooxygenase', 78, NULL, 'ABM', 270506),
(451413, 'PF08504', NULL, 'Runx inhibition domain', 99, NULL, 'RunxI', 270507),
(451414, 'PF17892', NULL, 'Cadherin-like domain', 98, NULL, 'Cadherin_5', 270508),
(451415, 'PF17959', NULL, 'EF-hand domain', 90, NULL, 'EF-hand_14', 270509),
(451416, 'PF12316', NULL, 'Segment polarity protein dishevelled (Dsh) C terminal', 211, NULL, 'Dsh_C', 270510);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(451417, 'PF12169', NULL, 'DNA polymerase III subunits gamma and tau domain III', 143, NULL, 'DNA_pol3_gamma3', 270511),
(451418, 'PF09412', NULL, 'Endoribonuclease XendoU', 263, NULL, 'XendoU', 270512),
(451419, 'PF00475', NULL, 'Imidazoleglycerol-phosphate dehydratase', 144, NULL, 'IGPD', 270513),
(451420, 'PF09880', NULL, 'Predicted membrane protein (DUF2107)', 73, NULL, 'DUF2107', 270514),
(451421, 'PF13052', NULL, 'Protein of unknown function (DUF3913)', 57, NULL, 'DUF3913', 270515),
(451422, 'PF02118', NULL, 'Srg family chemoreceptor', 275, NULL, 'Srg', 270516),
(451423, 'PF12552', NULL, 'Protein of unknown function (DUF3741)', 45, NULL, 'DUF3741', 270517),
(451424, 'PF14917', NULL, 'Coiled coil protein 74, C terminal', 124, NULL, 'CCDC74_C', 270518),
(451425, 'PF01496', NULL, 'V-type ATPase 116kDa subunit family', 816, NULL, 'V_ATPase_I', 270519),
(451426, 'PF12728', NULL, 'Helix-turn-helix domain', 51, NULL, 'HTH_17', 270520),
(451427, 'PF06648', NULL, 'Autographa californica nuclear polyhedrosis virus (AcMNPV), Ac75', 122, NULL, 'AcMNPV_Ac75', 270521),
(451428, 'PF00874', NULL, 'PRD domain', 90, NULL, 'PRD', 270522),
(451429, 'PF09156', NULL, 'Anthrax toxin lethal factor, middle domain', 287, NULL, 'Anthrax-tox_M', 270523),
(451430, 'PF09011', NULL, 'HMG-box domain', 73, NULL, 'HMG_box_2', 270524),
(451431, 'PF14535', NULL, 'AMP-binding enzyme C-terminal domain', 96, NULL, 'AMP-binding_C_2', 270525),
(451432, 'PF02890', NULL, 'Borrelia family of unknown function DUF226', 139, NULL, 'DUF226', 270526),
(451433, 'PF17572', NULL, 'Family of unknown function (DUF5478)', 86, NULL, 'DUF5478', 270527),
(451434, 'PF13718', NULL, 'GNAT acetyltransferase 2', 228, NULL, 'GNAT_acetyltr_2', 270528),
(451435, 'PF02832', NULL, 'Flavivirus glycoprotein, immunoglobulin-like domain', 97, NULL, 'Flavi_glycop_C', 270529),
(451436, 'PF12685', NULL, 'SpoIIIAH-like protein', 212, NULL, 'SpoIIIAH', 270530),
(451437, 'PF18519', NULL, 'SAGA-associated factor 11 N-terminal domain', 39, NULL, 'Sgf11_N', 270531),
(451438, 'PF14292', NULL, 'SusE outer membrane protein', 106, NULL, 'SusE', 270532),
(451439, 'PF01285', NULL, 'TEA/ATTS domain', 68, NULL, 'TEA', 270533),
(451440, 'PF16810', NULL, 'RXLR phytopathogen effector protein, Avirulence activity', 141, NULL, 'RXLR', 270534),
(451441, 'PF18328', NULL, 'Fatty acid synthase subunit PfaD N-terminal domain', 62, NULL, 'PfaD_N', 270535),
(451442, 'PF19091', NULL, 'Family of unknown function (DUF5779)', 96, NULL, 'DUF5779', 270536),
(451443, 'PF17945', NULL, 'Beta/Gamma crystallin', 90, NULL, 'Crystall_4', 270537),
(451444, 'PF13155', NULL, 'Toprim-like', 89, NULL, 'Toprim_2', 270538),
(451445, 'PF06664', NULL, 'Wnt-binding factor required for Wnt secretion', 294, NULL, 'MIG-14_Wnt-bd', 270539),
(451446, 'PF14051', NULL, 'DPF1-3, N-terminal', 72, NULL, 'DPF1-3_N', 270540),
(451447, 'PF05864', NULL, 'Chordopoxvirus DNA-directed RNA polymerase 7 kDa polypeptide (RPO7)', 63, NULL, 'Chordopox_RPO7', 270541),
(451448, 'PF19068', NULL, 'Family of unknown function (DUF5764)', 134, NULL, 'DUF5764', 270542),
(451449, 'PF10559', NULL, 'Plug domain of Sec61p', 35, NULL, 'Plug_translocon', 270543),
(451450, 'PF16401', NULL, 'Domain of unknown function (DUF5009)', 260, NULL, 'DUF5009', 270544),
(451451, 'PF07528', NULL, 'DZF domain', 248, NULL, 'DZF', 270545),
(451452, 'PF01373', NULL, 'Glycosyl hydrolase family 14', 402, NULL, 'Glyco_hydro_14', 270546),
(451453, 'PF18088', NULL, 'Glycoside Hydrolase 20C C-terminal domain', 194, NULL, 'Glyco_H_20C_C', 270547),
(451454, 'PF18671', NULL, '4-Hydroxyphenylacetate decarboxylase subunit gamma N-terminal', 31, NULL, '4HPAD_g_N', 270548),
(451455, 'PF15558', NULL, 'Domain of unknown function (DUF4659)', 374, NULL, 'DUF4659', 270549),
(451456, 'PF18367', NULL, 'Rv2175c C-terminal domain of unknown function', 56, NULL, 'Rv2175c_C', 270550),
(451457, 'PF04508', NULL, 'Viral A-type inclusion protein repeat', 23, NULL, 'Pox_A_type_inc', 270551),
(451458, 'PF16299', NULL, 'Domain of unknown function (DUF4941)', 265, NULL, 'DUF4941', 270552);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(451459, 'PF04406', NULL, 'Type IIB DNA topoisomerase', 62, NULL, 'TP6A_N', 270553),
(451460, 'PF08523', NULL, 'Multiprotein bridging factor 1', 72, NULL, 'MBF1', 270554),
(451461, 'PF14274', NULL, 'Domain of unknown function (DUF4361)', 140, NULL, 'DUF4361', 270555),
(451462, 'PF02741', NULL, 'FTR, proximal lobe', 149, NULL, 'FTR_C', 270556),
(451463, 'PF14474', NULL, 'RTC4-like domain', 121, NULL, 'RTC4', 270557),
(451464, 'PF14765', NULL, 'Polyketide synthase dehydratase', 297, NULL, 'PS-DH', 270558),
(451465, 'PF08521', NULL, 'Two-component sensor kinase N-terminal', 143, NULL, '2CSK_N', 270559),
(451466, 'PF11452', NULL, 'Protein of unknown function (DUF3000)', 175, NULL, 'DUF3000', 270560),
(451467, 'PF10631', NULL, 'Protein of unknown function (DUF2477)', 142, NULL, 'DUF2477', 270561),
(451468, 'PF12391', NULL, 'Protocatechuate 3,4-dioxygenase beta subunit N terminal', 34, NULL, 'PCDO_beta_N', 270562),
(451469, 'PF13389', NULL, 'Protein of unknown function (DUF4107)', 163, NULL, 'DUF4107', 270563),
(451470, 'PF00953', NULL, 'Glycosyl transferase family 4', 160, NULL, 'Glycos_transf_4', 270564),
(451471, 'PF19124', NULL, 'Family of unknown function (DUF5808)', 26, NULL, 'DUF5808', 270565),
(451472, 'PF08916', NULL, 'Phenylalanine zipper', 57, NULL, 'Phe_ZIP', 270566),
(451473, 'PF05862', NULL, 'Helicobacter pylori IceA2 protein', 59, NULL, 'IceA2', 270567),
(451474, 'PF00853', NULL, 'Runt domain', 129, NULL, 'Runt', 270568),
(451475, 'PF18448', NULL, 'Carbohydrate binding domain', 105, NULL, 'CBM46', 270569),
(451476, 'PF08052', NULL, 'PyrBI operon leader peptide', 44, NULL, 'PyrBI_leader', 270570),
(451477, 'PF12043', NULL, 'Domain of unknown function (DUF3527)', 355, NULL, 'DUF3527', 270571),
(451478, 'PF01396', NULL, 'Topoisomerase DNA binding C4 zinc finger', 39, NULL, 'zf-C4_Topoisom', 270572),
(451479, 'PF01661', NULL, 'Macro domain', 118, NULL, 'Macro', 270573),
(451480, 'PF18392', NULL, 'COP9 signalosome complex subunit 7a helix I domain', 50, NULL, 'CSN7a_helixI', 270574),
(451481, 'PF01623', NULL, 'Carlavirus putative nucleic acid binding protein', 91, NULL, 'Carla_C4', 270575),
(451482, 'PF05093', NULL, 'Cytokine-induced anti-apoptosis inhibitor 1, Fe-S biogenesis', 99, NULL, 'CIAPIN1', 270576),
(451483, 'PF02035', NULL, 'Coagulin', 174, NULL, 'Coagulin', 270577),
(451484, 'PF10943', NULL, 'Protein of unknown function (DUF2632)', 233, NULL, 'DUF2632', 270578),
(451485, 'PF16200', NULL, 'C-terminal region of band_7', 63, NULL, 'Band_7_C', 270579),
(451486, 'PF02481', NULL, 'DNA recombination-mediator protein A', 210, NULL, 'DNA_processg_A', 270580),
(451487, 'PF11384', NULL, 'Protein of unknown function (DUF3188)', 50, NULL, 'DUF3188', 270581),
(451488, 'PF07723', NULL, 'Leucine Rich Repeat', 26, NULL, 'LRR_2', 270582),
(451489, 'PF07310', NULL, 'PAS domain', 137, NULL, 'PAS_5', 270583),
(451490, 'PF09178', NULL, '4-alpha-glucanotransferase, C-terminal', 50, NULL, 'MGTA_C', 270584),
(451491, 'PF07354', NULL, 'Zona-pellucida-binding protein (Sp38)', 177, NULL, 'Sp38', 270585),
(451492, 'PF17376', NULL, 'Family of unknown function (DUF5398)', 80, NULL, 'DUF5398', 270586),
(451493, 'PF01873', NULL, 'Domain found in IF2B/IF5', 117, NULL, 'eIF-5_eIF-2B', 270587),
(451494, 'PF05676', NULL, 'NADH-ubiquinone oxidoreductase B18 subunit (NDUFB7)', 63, NULL, 'NDUF_B7', 270588),
(451495, 'PF05271', NULL, 'Tobravirus 2B protein', 117, NULL, 'Tobravirus_2B', 270589),
(451496, 'PF06537', NULL, 'Di-haem oxidoreductase, putative peroxidase', 486, NULL, 'DHOR', 270590),
(451497, 'PF12600', NULL, 'Protein of unknown function (DUF3769)', 444, NULL, 'DUF3769', 270591),
(451498, 'PF18791', NULL, 'Transport inhibitor response 1 protein domain', 47, NULL, 'Transp_inhibit', 270592),
(451499, 'PF17827', NULL, 'PrmC N-terminal domain', 71, NULL, 'PrmC_N', 270593),
(451500, 'PF10661', NULL, 'WXG100 protein secretion system (Wss), protein EssA', 148, NULL, 'EssA', 270594),
(451501, 'PF02759', NULL, 'RUN domain', 141, NULL, 'RUN', 270595),
(451502, 'PF00208', NULL, 'Glutamate/Leucine/Phenylalanine/Valine dehydrogenase', 243, NULL, 'ELFV_dehydrog', 270596);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(451503, 'PF13349', NULL, 'Putative adhesin', 249, NULL, 'DUF4097', 270597),
(451504, 'PF03592', NULL, 'Terminase small subunit', 140, NULL, 'Terminase_2', 270598),
(451505, 'PF10553', NULL, 'MSV199 domain', 132, NULL, 'MSV199', 270599),
(451506, 'PF15933', NULL, 'Antitoxin to bacterial toxin RNase LS or RnlA', 94, NULL, 'RnlB_antitoxin', 270600),
(451507, 'PF12792', NULL, 'CSS motif domain associated with EAL', 209, NULL, 'CSS-motif', 270601),
(451508, 'PF15738', NULL, 'Bacterial toxin of type II toxin-antitoxin system, YafQ', 88, NULL, 'YafQ_toxin', 270602),
(451509, 'PF19182', NULL, 'Family of unknown function (DUF5864)', 136, NULL, 'DUF5864', 270603),
(451510, 'PF05961', NULL, 'Chordopoxvirus A13L protein', 69, NULL, 'Chordopox_A13L', 270604),
(451511, 'PF13385', NULL, 'Concanavalin A-like lectin/glucanases superfamily', 151, NULL, 'Laminin_G_3', 270605),
(451512, 'PF16523', NULL, 'betaPIX coiled coil', 84, NULL, 'betaPIX_CC', 270606),
(451513, 'PF16357', NULL, 'Putative PepSY_TM-like', 197, NULL, 'PepSY_TM_like_2', 270607),
(451514, 'PF10950', NULL, 'Organ specific protein', 117, NULL, 'Organ_specific', 270608),
(451515, 'PF08969', NULL, 'USP8 dimerisation domain', 114, NULL, 'USP8_dimer', 270609),
(451516, 'PF09838', NULL, 'Uncharacterized protein conserved in bacteria (DUF2065)', 56, NULL, 'DUF2065', 270610),
(451517, 'PF11230', NULL, 'Protein of unknown function (DUF3029)', 485, NULL, 'DUF3029', 270611),
(451518, 'PF11239', NULL, 'Protein of unknown function (DUF3040)', 84, NULL, 'DUF3040', 270612),
(451519, 'PF10229', NULL, 'Methylmalonic aciduria and homocystinuria type D protein', 272, NULL, 'MMADHC', 270613),
(451520, 'PF06358', NULL, 'Beet necrotic yellow vein virus, movement protein TGB3', 111, NULL, 'BNYVV_TGB3', 270614),
(451521, 'PF14046', NULL, 'Nuclear receptor repeat', 49, NULL, 'NR_Repeat', 270615),
(451522, 'PF14725', NULL, 'Domain of unknown function (DUF4466)', 307, NULL, 'DUF4466', 270616),
(451523, 'PF03587', NULL, 'EMG1/NEP1 methyltransferase', 206, NULL, 'EMG1', 270617),
(451524, 'PF08698', NULL, 'Fcf2 pre-rRNA processing', 96, NULL, 'Fcf2', 270618),
(451525, 'PF00667', NULL, 'FAD binding domain', 222, NULL, 'FAD_binding_1', 270619),
(451526, 'PF03830', NULL, 'PTS system sorbose subfamily IIB component', 148, NULL, 'PTSIIB_sorb', 270620),
(451527, 'PF17190', NULL, 'RecG N-terminal helical domain', 89, NULL, 'RecG_N', 270621),
(451528, 'PF02875', NULL, 'Mur ligase family, glutamate ligase domain', 91, NULL, 'Mur_ligase_C', 270622),
(451529, 'PF10157', NULL, 'BLOC-1-related complex sub-unit 6 C-terminal helix', 101, NULL, 'BORCS6', 270623),
(451530, 'PF04584', NULL, 'Poxvirus A28 family', 140, NULL, 'Pox_A28', 270624),
(451531, 'PF08954', NULL, 'Trimerisation motif', 52, NULL, 'Trimer_CC', 270625),
(451532, 'PF04148', NULL, 'Transmembrane adaptor Erv26', 206, NULL, 'Erv26', 270626),
(451533, 'PF07992', NULL, 'Pyridine nucleotide-disulphide oxidoreductase', 295, NULL, 'Pyr_redox_2', 270627),
(451534, 'PF00001', NULL, '7 transmembrane receptor (rhodopsin family)', 264, NULL, '7tm_1', 270628),
(451535, 'PF17353', NULL, 'Family of unknown function (DUF5381)', 169, NULL, 'DUF5381', 270629),
(451536, 'PF11855', NULL, 'Protein of unknown function (DUF3375)', 475, NULL, 'DUF3375', 270630),
(451537, 'PF13716', NULL, 'Divergent CRAL/TRIO domain', 139, NULL, 'CRAL_TRIO_2', 270631),
(451538, 'PF15525', NULL, 'Domain of unknown function (DUF4652)', 194, NULL, 'DUF4652', 270632),
(451539, 'PF01127', NULL, 'Succinate dehydrogenase/Fumarate reductase transmembrane subunit', 121, NULL, 'Sdh_cyt', 270633),
(451540, 'PF04559', NULL, 'Herpesvirus UL17 protein', 540, NULL, 'Herpes_UL17', 270634),
(451541, 'PF02616', NULL, 'Segregation and condensation protein ScpA', 241, NULL, 'SMC_ScpA', 270635),
(451542, 'PF14486', NULL, 'Domain of unknown function (DUF4432)', 303, NULL, 'DUF4432', 270636),
(451543, 'PF15173', NULL, 'FAM180 family', 137, NULL, 'FAM180', 270637),
(451544, 'PF17412', NULL, 'Family of unknown function', 55, NULL, 'VraX', 270638),
(451545, 'PF12536', NULL, 'Patatin phospholipase', 106, NULL, 'DUF3734', 270639); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(451546, 'PF17345', NULL, 'Family of unknown function (DUF5375)', 106, NULL, 'DUF5375', 270640),
(451547, 'PF08411', NULL, 'Exonuclease C-terminal', 269, NULL, 'Exonuc_X-T_C', 270641),
(451548, 'PF03884', NULL, 'DNA gyrase inhibitor YacG', 52, NULL, 'YacG', 270642),
(451549, 'PF10195', NULL, 'DNA-binding nuclear phosphoprotein p8', 58, NULL, 'Phospho_p8', 270643),
(451550, 'PF10377', NULL, 'Autophagy-related protein 11', 129, NULL, 'ATG11', 270644),
(451551, 'PF11305', NULL, 'Protein of unknown function (DUF3107)', 73, NULL, 'DUF3107', 270645),
(451552, 'PF20550', NULL, 'Family of unknown function (DUF6764)', 164, NULL, 'DUF6764', 270646),
(451553, 'PF00308', NULL, 'Bacterial dnaA  protein', 219, NULL, 'Bac_DnaA', 270647),
(451554, 'PF04339', NULL, 'Peptidogalycan biosysnthesis/recognition', 370, NULL, 'FemAB_like', 270648),
(451555, 'PF17129', NULL, 'C-terminal domain of metallo-carboxypeptidase', 100, NULL, 'Peptidase_M99_C', 270649),
(451556, 'PF00251', NULL, 'Glycosyl hydrolases family 32 N-terminal domain', 305, NULL, 'Glyco_hydro_32N', 270650),
(451557, 'PF09431', NULL, 'SPIN90/Ldb17, leucine-rich domain', 139, NULL, 'SPIN90_LRD', 270651),
(451558, 'PF13266', NULL, 'Protein of unknown function (DUF4057)', 299, NULL, 'DUF4057', 270652),
(451559, 'PF16415', NULL, 'CCR4-NOT transcription complex subunit 1 CAF1-binding domain', 225, NULL, 'CNOT1_CAF1_bind', 270653),
(451560, 'PF19763', NULL, 'Domain of unknown function (DUF6250)', 167, NULL, 'DUF6250', 270654),
(451561, 'PF02878', NULL, 'Phosphoglucomutase/phosphomannomutase, alpha/beta/alpha domain I', 138, NULL, 'PGM_PMM_I', 270655),
(451562, 'PF13527', NULL, 'Acetyltransferase (GNAT) domain', 127, NULL, 'Acetyltransf_9', 270656),
(451563, 'PF10906', NULL, 'MIOREX complex component 7', 66, NULL, 'Mrx7', 270657),
(451564, 'PF18536', NULL, 'Domain of unknown function (DUF5623)', 126, NULL, 'DUF5623', 270658),
(451565, 'PF06185', NULL, 'YecM protein', 180, NULL, 'YecM', 270659),
(451566, 'PF11770', NULL, 'GRB2-binding adapter (GAPT)', 156, NULL, 'GAPT', 270660),
(451567, 'PF08779', NULL, 'Betacoronavirus NS7A protein', 107, NULL, 'bCoV_NS7A', 270661),
(451568, 'PF19623', NULL, 'Family of unknown function (DUF6128)', 113, NULL, 'DUF6128', 270662),
(451569, 'PF00226', NULL, 'DnaJ domain', 63, NULL, 'DnaJ', 270663),
(451570, 'PF09335', NULL, 'SNARE associated Golgi protein', 123, NULL, 'SNARE_assoc', 270664),
(451571, 'PF04529', NULL, 'Herpesvirus U59 protein', 367, NULL, 'Herpes_U59', 270665),
(451572, 'PF18781', NULL, 'Phage spike trimer', 78, NULL, 'Phage_spike_2', 270666),
(451573, 'PF07945', NULL, 'Janus-atracotoxin', 36, NULL, 'Toxin_16', 270667),
(451574, 'PF02891', NULL, 'MIZ/SP-RING zinc finger', 50, NULL, 'zf-MIZ', 270668),
(451575, 'PF18546', NULL, 'Methanogen output domain 1', 143, NULL, 'MetOD1', 270669),
(451576, 'PF01474', NULL, 'Class-II DAHP synthetase family', 437, NULL, 'DAHP_synth_2', 270670),
(451577, 'PF17182', NULL, 'OSK domain', 199, NULL, 'OSK', 270671),
(451578, 'PF09638', NULL, 'Ph1570 protein', 155, NULL, 'Ph1570', 270672),
(451579, 'PF03551', NULL, 'Transcriptional regulator PadR-like family', 75, NULL, 'PadR', 270673),
(451580, 'PF04407', NULL, 'Protein of unknown function (DUF531)', 170, NULL, 'DUF531', 270674),
(451581, 'PF02843', NULL, 'Phosphoribosylglycinamide synthetase, C domain', 92, NULL, 'GARS_C', 270675),
(451582, 'PF15005', NULL, 'Izumo sperm-egg fusion, Ig domain-associated', 143, NULL, 'IZUMO', 270676),
(451583, 'PF17397', NULL, 'Family of unknown function (DUF5404)', 145, NULL, 'DUF5404', 270677),
(451584, 'PF03494', NULL, 'Beta-amyloid peptide (beta-APP)', 39, NULL, 'Beta-APP', 270678),
(451585, 'PF00718', NULL, 'Polyomavirus coat protein', 293, NULL, 'Polyoma_coat', 270679),
(451586, 'PF16503', NULL, 'Zinc-ribbon', 32, NULL, 'zn-ribbon_14', 270680),
(451587, 'PF01284', NULL, 'Membrane-associating domain', 144, NULL, 'MARVEL', 270681),
(451588, 'PF03275', NULL, 'UDP-galactopyranose mutase', 204, NULL, 'GLF', 270682),
(451589, 'PF01526', NULL, 'Tn3 transposase DDE domain', 389, NULL, 'DDE_Tnp_Tn3', 270683); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(451590, 'PF16262', NULL, 'Domain of unknown function (DUF4916)', 170, NULL, 'DUF4916', 270684),
(451591, 'PF01446', NULL, 'Replication protein', 251, NULL, 'Rep_1', 270685),
(451592, 'PF02152', NULL, 'Dihydroneopterin aldolase', 111, NULL, 'FolB', 270686),
(451593, 'PF10382', NULL, 'Protein of unknown function (DUF2439)', 81, NULL, 'DUF2439', 270687),
(451594, 'PF09967', NULL, 'VWA-like domain (DUF2201)', 123, NULL, 'DUF2201', 270688),
(451595, 'PF16463', NULL, 'Phage tail tube protein family', 137, NULL, 'Phage_TTP_13', 270689),
(451596, 'PF04931', NULL, 'DNA polymerase phi', 767, NULL, 'DNA_pol_phi', 270690),
(451597, 'PF01050', NULL, 'Mannose-6-phosphate isomerase', 151, NULL, 'MannoseP_isomer', 270691),
(451598, 'PF12709', NULL, 'Fungal Transforming acidic coiled-coil (TACC) proteins', 77, NULL, 'Fungal_TACC', 270692),
(451599, 'PF00529', NULL, 'Cation efflux system protein CusB domain 1', 80, NULL, 'CusB_dom_1', 270693),
(451600, 'PF07525', NULL, 'SOCS box', 38, NULL, 'SOCS_box', 270694),
(451601, 'PF13765', NULL, 'SPRY-associated domain', 49, NULL, 'PRY', 270695),
(451602, 'PF05321', NULL, 'Haemolysin expression modulating protein', 57, NULL, 'HHA', 270696),
(451603, 'PF05113', NULL, 'Protein of unknown function (DUF693)', 311, NULL, 'DUF693', 270697),
(451604, 'PF20142', NULL, 'Scaffold domain', 140, NULL, 'Scaffold', 270698),
(451605, 'PF08287', NULL, 'Spc19', 155, NULL, 'DASH_Spc19', 270699),
(451606, 'PF04126', NULL, 'Cyclophilin-like', 119, NULL, 'Cyclophil_like', 270700),
(451607, 'PF17872', NULL, 'AAA lid domain', 99, NULL, 'AAA_lid_10', 270701),
(451608, 'PF04279', NULL, 'Intracellular septation protein A', 176, NULL, 'IspA', 270702),
(451609, 'PF14786', NULL, 'Tube Death domain', 146, NULL, 'Death_2', 270703),
(451610, 'PF18961', NULL, 'Domain of unknown function (DUF5703)', 287, NULL, 'DUF5703_N', 270704),
(451611, 'PF09560', NULL, 'Sporulation protein YunB (Spo_YunB)', 91, NULL, 'Spore_YunB', 270705),
(451612, 'PF09662', NULL, 'Phenylphosphate carboxylase gamma subunit (Phenyl_P_gamma)', 83, NULL, 'Phenyl_P_gamma', 270706),
(451613, 'PF20061', NULL, 'Domain of unknown function (DUF6460)', 36, NULL, 'DUF6460', 270707),
(451614, 'PF07935', NULL, 'ORF D-335-like protein', 67, NULL, 'SSV1_ORF_D-335', 270708),
(451615, 'PF20239', NULL, 'Family of unknown function (DUF6596)', 102, NULL, 'DUF6596', 270709),
(451616, 'PF04746', NULL, 'Protein of unknown function (DUF575)', 101, NULL, 'DUF575', 270710),
(451617, 'PF02683', NULL, 'Cytochrome C biogenesis protein transmembrane region', 213, NULL, 'DsbD', 270711),
(451618, 'PF04145', NULL, 'Ctr copper transporter family', 150, NULL, 'Ctr', 270712),
(451619, 'PF10941', NULL, 'Protein of unknown function DUF2620', 116, NULL, 'DUF2620', 270713),
(451620, 'PF01288', NULL, '7,8-dihydro-6-hydroxymethylpterin-pyrophosphokinase (HPPK)', 111, NULL, 'HPPK', 270714),
(451621, 'PF01699', NULL, 'Sodium/calcium exchanger protein', 151, NULL, 'Na_Ca_ex', 270715),
(451622, 'PF08682', NULL, 'Putative endonuclease, protein of unknown function (DUF1780)', 208, NULL, 'DUF1780', 270716),
(451623, 'PF00745', NULL, 'Glutamyl-tRNAGlu reductase, dimerisation domain', 98, NULL, 'GlutR_dimer', 270717),
(451624, 'PF06464', NULL, 'DMAP1-binding Domain', 111, NULL, 'DMAP_binding', 270718),
(451625, 'PF06939', NULL, 'Protein of unknown function (DUF1286)', 112, NULL, 'DUF1286', 270719),
(451626, 'PF15899', NULL, 'BNR-Asp box repeat', 14, NULL, 'BNR_6', 270720),
(451627, 'PF01107', NULL, 'Viral movement protein (MP)', 191, NULL, 'MP', 270721),
(451628, 'PF02482', NULL, 'Sigma 54 modulation protein / S30EA ribosomal protein', 86, NULL, 'Ribosomal_S30AE', 270722),
(451629, 'PF02942', NULL, 'Influenza B non-structural protein (NS1)', 247, NULL, 'Flu_B_NS1', 270723),
(451630, 'PF13071', NULL, 'Protein of unknown function (DUF3935)', 70, NULL, 'DUF3935', 270724),
(451631, 'PF19687', NULL, 'MARF1 LOTUS domain', 210, NULL, 'MARF1_LOTUS', 270725),
(451632, 'PF15867', NULL, 'Dynein attachment factor N-terminus', 68, NULL, 'Dynein_attach_N', 270726),
(451633, 'PF19014', NULL, 'Family of unknown function (DUF5743)', 186, NULL, 'DUF5743', 270727);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(451634, 'PF12490', NULL, 'Breast carcinoma amplified sequence 3', 240, NULL, 'BCAS3', 270728),
(451635, 'PF14013', NULL, 'MT0933-like antitoxin protein', 49, NULL, 'MT0933_antitox', 270729),
(451636, 'PF14676', NULL, 'FANCI solenoid 2', 159, NULL, 'FANCI_S2', 270730),
(451637, 'PF05316', NULL, 'Mitochondrial ribosomal protein (VAR1)', 197, NULL, 'VAR1', 270731),
(451638, 'PF06724', NULL, 'Domain of Unknown Function (DUF1206)', 70, NULL, 'DUF1206', 270732),
(451639, 'PF02454', NULL, 'Sigma 1s protein', 116, NULL, 'Sigma_1s', 270733),
(451640, 'PF11740', NULL, 'Plasmid replication region DNA-binding N-term', 114, NULL, 'KfrA_N', 270734),
(451641, 'PF19348', NULL, 'Family of unknown function (DUF5926)', 266, NULL, 'DUF5926', 270735),
(451642, 'PF09189', NULL, 'Domain of unknown function (DUF1952)', 73, NULL, 'DUF1952', 270736),
(451643, 'PF00646', NULL, 'F-box domain', 43, NULL, 'F-box', 270737),
(451644, 'PF05352', NULL, 'Phage Connector (GP10)', 281, NULL, 'Phage_connector', 270738),
(451645, 'PF06444', NULL, 'NADH dehydrogenase subunit 2 C-terminus', 55, NULL, 'NADH_dehy_S2_C', 270739),
(451646, 'PF09752', NULL, 'Alpha/beta hydrolase domain containing 18', 352, NULL, 'ABHD18', 270740),
(451647, 'PF03015', NULL, 'Male sterility protein', 93, NULL, 'Sterile', 270741),
(451648, 'PF10539', NULL, 'Development and cell death domain', 127, NULL, 'Dev_Cell_Death', 270742),
(451649, 'PF13999', NULL, 'MarB protein', 65, NULL, 'MarB', 270743),
(451650, 'PF12545', NULL, 'Filamentous haemagglutinin family outer membrane protein', 110, NULL, 'DUF3739', 270744),
(451651, 'PF01245', NULL, 'Ribosomal protein L19', 111, NULL, 'Ribosomal_L19', 270745),
(451652, 'PF12362', NULL, 'DNA polymerase III gamma and tau subunits C terminal', 114, NULL, 'DUF3646', 270746),
(451653, 'PF04464', NULL, 'CDP-Glycerol:Poly(glycerophosphate) glycerophosphotransferase', 367, NULL, 'Glyphos_transf', 270747),
(451654, 'PF05361', NULL, 'PKC-activated protein phosphatase-1 inhibitor', 141, NULL, 'PP1_inhibitor', 270748),
(451655, 'PF06405', NULL, 'Red chlorophyll catabolite reductase (RCC reductase)', 253, NULL, 'RCC_reductase', 270749),
(451656, 'PF13438', NULL, 'Domain of unknown function (DUF4113)', 51, NULL, 'DUF4113', 270750),
(451657, 'PF19077', NULL, 'Bacterial Ig-like domain', 102, NULL, 'Big_13', 270751),
(451658, 'PF20170', NULL, 'Plexin cytoplasmic RhoGTPase-binding domain', 113, NULL, 'Plexin_RBD', 270752),
(451659, 'PF00939', NULL, 'Sodium:sulfate symporter transmembrane region', 472, NULL, 'Na_sulph_symp', 270753),
(451660, 'PF05611', NULL, 'Caenorhabditis elegans protein of unknown function (DUF780)', 71, NULL, 'DUF780', 270754),
(451661, 'PF07399', NULL, 'Putative Na+/H+ antiporter', 419, NULL, 'Na_H_antiport_3', 270755),
(451662, 'PF13480', NULL, 'Acetyltransferase (GNAT) domain', 142, NULL, 'Acetyltransf_6', 270756),
(451663, 'PF12099', NULL, 'Protein of unknown function (DUF3575)', 176, NULL, 'DUF3575', 270757),
(451664, 'PF17829', NULL, 'Gylcosyl hydrolase family 115 C-terminal domain', 172, NULL, 'GH115_C', 270758),
(451665, 'PF06198', NULL, 'Protein of unknown function (DUF999)', 143, NULL, 'DUF999', 270759),
(451666, 'PF13369', NULL, 'Transglutaminase-like superfamily', 155, NULL, 'Transglut_core2', 270760),
(451667, 'PF02865', NULL, 'STAT protein, protein interaction domain', 119, NULL, 'STAT_int', 270761),
(451668, 'PF13949', NULL, 'ALIX V-shaped domain binding to HIV', 295, NULL, 'ALIX_LYPXL_bnd', 270762),
(451669, 'PF18325', NULL, 'Fatty acid synthase subunit alpha Acyl carrier domain', 162, NULL, 'Fas_alpha_ACP', 270763),
(451670, 'PF02465', NULL, 'Flagellar hook-associated protein 2 N-terminus', 97, NULL, 'FliD_N', 270764),
(451671, 'PF04839', NULL, 'Plastid and cyanobacterial ribosomal protein (PSRP-3 / Ycf65)', 48, NULL, 'PSRP-3_Ycf65', 270765),
(451672, 'PF06607', NULL, 'Prokineticin', 97, NULL, 'Prokineticin', 270766),
(451673, 'PF00436', NULL, 'Single-strand binding protein family', 104, NULL, 'SSB', 270767),
(451674, 'PF14106', NULL, 'Domain of unknown function (DUF4279)', 116, NULL, 'DUF4279', 270768);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(451675, 'PF15801', NULL, 'zf-MYND-like zinc finger, mRNA-binding', 47, NULL, 'zf-C6H2', 270769),
(451676, 'PF06250', NULL, 'YhcG PDDEXK nuclease domain', 155, NULL, 'YhcG_C', 270770),
(451677, 'PF16125', NULL, 'Domain of unknown function (DUF4837)', 295, NULL, 'DUF4837', 270771),
(451678, 'PF14065', NULL, 'Pvc16 N-terminal domain', 177, NULL, 'Pvc16_N', 270772),
(451679, 'PF05111', NULL, 'Ameloblastin precursor (Amelin)', 411, NULL, 'Amelin', 270773),
(451680, 'PF03159', NULL, 'XRN 5''-3'' exonuclease N-terminus', 251, NULL, 'XRN_N', 270774),
(451681, 'PF12224', NULL, 'Putative amidoligase enzyme', 250, NULL, 'Amidoligase_2', 270775),
(451682, 'PF13679', NULL, 'Methyltransferase domain', 158, NULL, 'Methyltransf_32', 270776),
(451683, 'PF15453', NULL, 'Protein incorporated later into Tight Junctions', 362, NULL, 'Pilt', 270777),
(451684, 'PF05718', NULL, 'Poxvirus intermediate transcription factor', 383, NULL, 'Pox_int_trans', 270778),
(451685, 'PF11018', NULL, 'Pupal cuticle protein C1', 182, NULL, 'Cuticle_3', 270779),
(451686, 'PF03161', NULL, 'LAGLIDADG DNA endonuclease family', 169, NULL, 'LAGLIDADG_2', 270780),
(451687, 'PF12937', NULL, 'F-box-like', 48, NULL, 'F-box-like', 270781),
(451688, 'PF15513', NULL, 'Domain of unknown function (DUF4651)', 61, NULL, 'DUF4651', 270782),
(451689, 'PF06703', NULL, 'Microsomal signal peptidase 25 kDa subunit (SPC25)', 161, NULL, 'SPC25', 270783),
(451690, 'PF09828', NULL, 'Chromate resistance exported protein', 132, NULL, 'Chrome_Resist', 270784),
(451691, 'PF11555', NULL, 'EGFR receptor inhibitor Mig-6', 74, NULL, 'Inhibitor_Mig-6', 270785),
(451692, 'PF05465', NULL, 'Halobacterial gas vesicle protein C (GVPC) repeat', 32, NULL, 'Halo_GVPC', 270786),
(451693, 'PF11967', NULL, 'Recombination protein O N terminal', 80, NULL, 'RecO_N', 270787),
(451694, 'PF14893', NULL, 'PNMA', 328, NULL, 'PNMA', 270788),
(451695, 'PF01907', NULL, 'Ribosomal protein L37e', 54, NULL, 'Ribosomal_L37e', 270789),
(451696, 'PF19959', NULL, 'Effector-associated domain 4', 123, NULL, 'EAD4', 270790),
(451697, 'PF12730', NULL, 'ABC-2 family transporter protein', 179, NULL, 'ABC2_membrane_4', 270791),
(451698, 'PF20147', NULL, 'Crinkler effector protein N-terminal domain', 106, NULL, 'Crinkler', 270792),
(451699, 'PF13802', NULL, 'Galactose mutarotase-like', 68, NULL, 'Gal_mutarotas_2', 270793),
(451700, 'PF01032', NULL, 'FecCD transport family', 312, NULL, 'FecCD', 270794),
(451701, 'PF20409', NULL, 'SnoaL-like domain', 118, NULL, 'SnoaL_5', 270795),
(451702, 'PF00141', NULL, 'Peroxidase', 229, NULL, 'peroxidase', 270796),
(451703, 'PF09171', NULL, 'N-glycosylase/DNA lyase', 248, NULL, 'AGOG', 270797),
(451704, 'PF08570', NULL, 'Protein of unknown function (DUF1761)', 125, NULL, 'DUF1761', 270798),
(451705, 'PF09521', NULL, 'NgoPII restriction endonuclease', 262, NULL, 'RE_NgoPII', 270799),
(451706, 'PF10597', NULL, 'U5-snRNA binding site 2 of PrP8', 134, NULL, 'U5_2-snRNA_bdg', 270800),
(451707, 'PF14478', NULL, 'Domain of unknown function (DUF4430)', 73, NULL, 'DUF4430', 270801),
(451708, 'PF20101', NULL, 'Family of unknown function (DUF6491)', 139, NULL, 'DUF6491', 270802),
(451709, 'PF10572', NULL, 'UPF0556 domain', 132, NULL, 'UPF0556', 270803),
(451710, 'PF16230', NULL, 'Domain of unknown function (DUF4889)', 71, NULL, 'DUF4889', 270804),
(451711, 'PF14204', NULL, 'Ribosomal L18 C-terminal region', 56, NULL, 'Ribosomal_L18_c', 270805),
(451712, 'PF03906', NULL, 'Phage T7 tail fibre protein', 157, NULL, 'Phage_T7_tail', 270806),
(451713, 'PF07402', NULL, 'Human herpesvirus U26 protein', 293, NULL, 'Herpes_U26', 270807),
(451714, 'PF06485', NULL, 'RNA-binding protein Tab2/Atab2 N terminal', 55, NULL, 'Tab2-like_N', 270808),
(451715, 'PF11964', NULL, 'SpoIIAA-like', 95, NULL, 'SpoIIAA-like', 270809),
(451716, 'PF01891', NULL, 'Cobalt uptake substrate-specific transmembrane region', 206, NULL, 'CbiM', 270810),
(451717, 'PF10799', NULL, 'Biofilm formation protein (YliH/bssR)', 126, NULL, 'YliH', 270811),
(451718, 'PF14368', NULL, 'Probable lipid transfer', 99, NULL, 'LTP_2', 270812);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(451719, 'PF08139', NULL, 'Prokaryotic membrane lipoprotein lipid attachment site', 18, NULL, 'LPAM_1', 270813),
(451720, 'PF16138', NULL, 'Domain of unknown function (4846)', 239, NULL, 'DUF4846', 270814),
(451721, 'PF04228', NULL, 'Putative neutral zinc metallopeptidase', 290, NULL, 'Zn_peptidase', 270815),
(451722, 'PF09402', NULL, 'Man1-Src1p-C-terminal domain', 338, NULL, 'MSC', 270816),
(451723, 'PF14283', NULL, 'Domain of unknown function (DUF4366)', 158, NULL, 'DUF4366', 270817),
(451724, 'PF10226', NULL, 'CCDC85 family', 192, NULL, 'CCDC85', 270818),
(451725, 'PF04076', NULL, 'Bacterial OB fold (BOF) protein', 103, NULL, 'BOF', 270819),
(451726, 'PF10054', NULL, 'Predicted periplasmic lipoprotein (DUF2291)', 199, NULL, 'DUF2291', 270820),
(451727, 'PF11307', NULL, 'Protein of unknown function (DUF3109)', 181, NULL, 'DUF3109', 270821),
(451728, 'PF05328', NULL, 'CybS, succinate dehydrogenase cytochrome B small subunit', 133, NULL, 'CybS', 270822),
(451729, 'PF00414', NULL, 'Neuraxin and MAP1B repeat', 17, NULL, 'MAP1B_neuraxin', 270823),
(451730, 'PF07177', NULL, 'Neuralized', 150, NULL, 'Neuralized', 270824),
(451731, 'PF19458', NULL, 'Family of unknown function (DUF5995)', 225, NULL, 'DUF5995', 270825),
(451732, 'PF00126', NULL, 'Bacterial regulatory helix-turn-helix protein, lysR family', 60, NULL, 'HTH_1', 270826),
(451733, 'PF19484', NULL, 'Family of unknown function (DUF6020)', 597, NULL, 'DUF6020', 270827),
(451734, 'PF02996', NULL, 'Prefoldin subunit', 120, NULL, 'Prefoldin', 270828),
(451735, 'PF05994', NULL, 'Cytoplasmic Fragile-X interacting family', 842, NULL, 'FragX_IP', 270829),
(451736, 'PF07071', NULL, 'KDGP aldolase', 218, NULL, 'KDGP_aldolase', 270830),
(451737, 'PF07158', NULL, 'Dicarboxylate carrier protein MatC N-terminus', 149, NULL, 'MatC_N', 270831),
(451738, 'PF12067', NULL, 'Sox 17/18 central domain', 49, NULL, 'Sox17_18_mid', 270832),
(451739, 'PF03293', NULL, 'Poxvirus DNA-directed RNA polymerase, 18 kD subunit', 160, NULL, 'Pox_RNA_pol', 270833),
(451740, 'PF08348', NULL, 'YheO-like PAS domain', 115, NULL, 'PAS_6', 270834),
(451741, 'PF03367', NULL, 'ZPR1 zinc-finger domain', 162, NULL, 'zf-ZPR1', 270835),
(451742, 'PF03563', NULL, 'Bunyavirus glycoprotein G2', 281, NULL, 'Bunya_G2', 270836),
(451743, 'PF00244', NULL, '14-3-3 protein', 222, NULL, '14-3-3', 270837),
(451744, 'PF11575', NULL, 'FhuF 2Fe-2S C-terminal domain', 21, NULL, 'FhuF_C', 270838),
(451745, 'PF03744', NULL, '6-carboxyhexanoate--CoA ligase', 241, NULL, 'BioW', 270839),
(451746, 'PF06431', NULL, 'Polyomavirus large T antigen C-terminus', 417, NULL, 'Polyoma_lg_T_C', 270840),
(451747, 'PF08368', NULL, 'FAST kinase-like protein, subdomain 2', 89, NULL, 'FAST_2', 270841),
(451748, 'PF18531', NULL, 'Polo box domain', 112, NULL, 'Polo_box_2', 270842),
(451749, 'PF12004', NULL, 'Domain of unknown function (DUF3498)', 516, NULL, 'DUF3498', 270843),
(451750, 'PF19184', NULL, 'Family of unknown function (DUF5866)', 74, NULL, 'DUF5866', 270844),
(451751, 'PF19325', NULL, 'E3 ubiquitin-protein ligase RNF152 C-terminus', 136, NULL, 'RNF152_C', 270845),
(451752, 'PF10566', NULL, 'Glycoside hydrolase 97', 280, NULL, 'Glyco_hydro_97', 270846),
(451753, 'PF13914', NULL, 'Phostensin PP1-binding and SH3-binding region', 142, NULL, 'Phostensin', 270847),
(451754, 'PF04937', NULL, 'Protein of unknown function (DUF 659)', 152, NULL, 'DUF659', 270848),
(451755, 'PF20321', NULL, 'Family of unknown function (DUF6616)', 111, NULL, 'DUF6616', 270849),
(451756, 'PF04176', NULL, 'TIP41-like family', 171, NULL, 'TIP41', 270850),
(451757, 'PF05244', NULL, 'Brucella outer membrane protein 2', 240, NULL, 'Brucella_OMP2', 270851),
(451758, 'PF02949', NULL, '7tm Odorant receptor', 313, NULL, '7tm_6', 270852),
(451759, 'PF16010', NULL, 'Cytochrome domain of cellobiose dehydrogenase', 182, NULL, 'CDH-cyt', 270853),
(451760, 'PF18616', NULL, 'CDI immunity proteins', 95, NULL, 'CdiI_3', 270854),
(451761, 'PF15302', NULL, 'P33 mono-oxygenase', 291, NULL, 'P33MONOX', 270855),
(451762, 'PF12696', NULL, 'TraM recognition site of TraD and TraG', 126, NULL, 'TraG-D_C', 270856);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(451763, 'PF09873', NULL, 'Uncharacterized protein conserved in archaea (DUF2100)', 217, NULL, 'DUF2100', 270857),
(451764, 'PF12586', NULL, 'Protein of unknown function (DUF3760)', 44, NULL, 'DUF3760', 270858),
(451765, 'PF13193', NULL, 'AMP-binding enzyme C-terminal domain', 76, NULL, 'AMP-binding_C', 270859),
(451766, 'PF03919', NULL, 'mRNA capping enzyme, C-terminal domain', 107, NULL, 'mRNA_cap_C', 270860),
(451767, 'PF03519', NULL, 'Invasion protein B family', 78, NULL, 'Invas_SpaK', 270861),
(451768, 'PF15634', NULL, 'HYE1 signature containing ADP-ribosyltransferase', 282, NULL, 'Tox-ART-HYE1', 270862),
(451769, 'PF18949', NULL, 'Family of unknown function (DUF5693)', 609, NULL, 'DUF5693', 270863),
(451770, 'PF15172', NULL, 'Prolactin-releasing peptide', 45, NULL, 'Prolactin_RP', 270864),
(451771, 'PF18512', NULL, 'Benzylsuccinate synthase beta subunit', 66, NULL, 'BssB_TutG', 270865),
(451772, 'PF17641', NULL, 'Ancylostoma-associated secreted protein related', 119, NULL, 'ASPRs', 270866),
(451773, 'PF11111', NULL, 'Centromere protein M (CENP-M)', 174, NULL, 'CENP-M', 270867),
(451774, 'PF00595', NULL, 'PDZ domain', 82, NULL, 'PDZ', 270868),
(451775, 'PF03455', NULL, 'dDENN domain', 48, NULL, 'dDENN', 270869),
(451776, 'PF12879', NULL, 'SICA C-terminal inner membrane domain', 144, NULL, 'SICA_C', 270870),
(451777, 'PF01571', NULL, 'Aminomethyltransferase folate-binding domain', 255, NULL, 'GCV_T', 270871),
(451778, 'PF02618', NULL, 'YceG-like family', 276, NULL, 'YceG', 270872),
(451779, 'PF10020', NULL, 'Uncharacterized protein conserved in bacteria (DUF2262)', 141, NULL, 'DUF2262', 270873),
(451780, 'PF11160', NULL, 'Hypervirulence associated proteins TUDOR domain', 59, NULL, 'Hva1_TUDOR', 270874),
(451781, 'PF00825', NULL, 'Ribonuclease P', 110, NULL, 'Ribonuclease_P', 270875),
(451782, 'PF00082', NULL, 'Subtilase family', 284, NULL, 'Peptidase_S8', 270876),
(451783, 'PF02213', NULL, 'GYF domain', 45, NULL, 'GYF', 270877),
(451784, 'PF16933', NULL, 'Putative exopolysaccharide Exporter (EPS-E)', 452, NULL, 'PelG', 270878),
(451785, 'PF01723', NULL, 'Chorion protein', 169, NULL, 'Chorion_1', 270879),
(451786, 'PF14891', NULL, 'Effector protein', 176, NULL, 'Peptidase_M91', 270880),
(451787, 'PF18945', NULL, 'EvpB/VC_A0108, tail sheath gpW/gp25-like domain', 112, NULL, 'VipB_2', 270881),
(451788, 'PF04624', NULL, 'Dec-1 repeat', 27, NULL, 'Dec-1', 270882),
(451789, 'PF02024', NULL, 'Leptin', 145, NULL, 'Leptin', 270883),
(451790, 'PF08798', NULL, 'CRISPR associated protein', 228, NULL, 'CRISPR_assoc', 270884),
(451791, 'PF12915', NULL, 'Protein of unknown function (DUF3833)', 163, NULL, 'DUF3833', 270885),
(451792, 'PF07975', NULL, 'TFIIH C1-like domain', 55, NULL, 'C1_4', 270886),
(451793, 'PF16343', NULL, 'Domain of unknown function (DUF4973)', 129, NULL, 'DUF4973', 270887),
(451794, 'PF07835', NULL, 'Bacterial aa3 type cytochrome c oxidase subunit IV', 46, NULL, 'COX4_pro_2', 270888),
(451795, 'PF19865', NULL, 'Family of unknown function (DUF6338)', 205, NULL, 'DUF6338', 270889),
(451796, 'PF15216', NULL, 'Thymic stromal lymphopoietin', 125, NULL, 'TSLP', 270890),
(451797, 'PF17270', NULL, 'Family of unknown function (DUF5336)', 115, NULL, 'DUF5336', 270891),
(451798, 'PF20524', NULL, 'Family of unknown function (DUF6739)', 691, NULL, 'DUF6739', 270892),
(451799, 'PF18491', NULL, 'SET and RING associated domain', 145, NULL, 'SRA', 270893),
(451800, 'PF17130', NULL, 'beta-barrel domain of carboxypeptidase M99', 73, NULL, 'Peptidase_M99_m', 270894),
(451801, 'PF03913', NULL, 'Ragweed group 5 pollen allergen', 44, NULL, 'Ragweed_pollen', 270895),
(451802, 'PF15514', NULL, 'Restriction endonuclease ThaI', 202, NULL, 'ThaI', 270896),
(451803, 'PF01789', NULL, 'PsbP', 156, NULL, 'PsbP', 270897),
(451804, 'PF05973', NULL, 'Phage derived protein Gp49-like (DUF891)', 90, NULL, 'Gp49', 270898),
(451805, 'PF08059', NULL, 'SEP domain', 74, NULL, 'SEP', 270899),
(451806, 'PF16858', NULL, 'Condensin II complex subunit CAP-H2 or CNDH2, C-term', 295, NULL, 'CNDH2_C', 270900),
(451807, 'PF03424', NULL, 'Carbohydrate binding domain (family 17/28)', 203, NULL, 'CBM_17_28', 270901);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(451808, 'PF15628', NULL, 'RRM in Demeter', 102, NULL, 'RRM_DME', 270902),
(451809, 'PF06045', NULL, 'Rhamnogalacturonate lyase family', 213, NULL, 'Rhamnogal_lyase', 270903),
(451810, 'PF13761', NULL, 'Domain of unknown function (DUF4166)', 181, NULL, 'DUF4166', 270904),
(451811, 'PF16123', NULL, 'Hydroxyacylglutathione hydrolase C-terminus', 82, NULL, 'HAGH_C', 270905),
(451812, 'PF00724', NULL, 'NADH:flavin oxidoreductase / NADH oxidase family', 342, NULL, 'Oxidored_FMN', 270906),
(451813, 'PF16073', NULL, 'Starter unit:ACP transacylase in aflatoxin biosynthesis', 240, NULL, 'SAT', 270907),
(451814, 'PF16706', NULL, 'Izumo-like Immunoglobulin domain', 88, NULL, 'Izumo-Ig', 270908),
(451815, 'PF01856', NULL, 'Helicobacter outer membrane protein', 158, NULL, 'HP_OMP', 270909),
(451816, 'PF08040', NULL, 'MNLL subunit', 58, NULL, 'NADH_oxidored', 270910),
(451817, 'PF02112', NULL, 'cAMP phosphodiesterases class-II', 338, NULL, 'PDEase_II', 270911),
(451818, 'PF06698', NULL, 'Protein of unknown function (DUF1192)', 58, NULL, 'DUF1192', 270912),
(451819, 'PF08566', NULL, 'Mitochondrial import protein Pam17', 165, NULL, 'Pam17', 270913),
(451820, 'PF00031', NULL, 'Cystatin domain', 92, NULL, 'Cystatin', 270914),
(451821, 'PF16053', NULL, 'Mitochondrial 28S ribosomal protein S34', 130, NULL, 'MRP-S34', 270915),
(451822, 'PF09276', NULL, 'Pertussis toxin S5 subunit', 97, NULL, 'Pertus-S5-tox', 270916),
(451823, 'PF20602', NULL, 'Putative adhesive domain (group 8)', 141, NULL, 'pAdhesive_8', 270917),
(451824, 'PF04642', NULL, 'Protein of unknown function, DUF601', 302, NULL, 'DUF601', 270918),
(451825, 'PF12523', NULL, 'Protein of unknown function (DUF3725)', 74, NULL, 'DUF3725', 270919),
(451826, 'PF03539', NULL, 'Spumavirus aspartic protease (A9)', 163, NULL, 'Spuma_A9PTase', 270920),
(451827, 'PF07457', NULL, 'Protein of unknown function (DUF1516)', 108, NULL, 'DUF1516', 270921),
(451828, 'PF16757', NULL, 'Alpha-L-fucosidase C-terminal domain', 90, NULL, 'Fucosidase_C', 270922),
(451829, 'PF15165', NULL, 'Meiotic recombination protein REC114-like', 240, NULL, 'REC114-like', 270923),
(451830, 'PF08919', NULL, 'F-actin binding', 112, NULL, 'F_actin_bind', 270924),
(451831, 'PF15728', NULL, 'Domain of unknown function (DUF4679)', 399, NULL, 'DUF4679', 270925),
(451832, 'PF09411', NULL, 'Lipid A 3-O-deacylase (PagL)', 134, NULL, 'PagL', 270926),
(451833, 'PF11246', NULL, 'Base plate wedge protein 53', 189, NULL, 'Phage_gp53', 270927),
(451834, 'PF18901', NULL, 'Family of unknown function (DUF5657)', 61, NULL, 'DUF5657', 270928),
(451835, 'PF11468', NULL, 'Aromatic prenyltransferase Orf2', 287, NULL, 'PTase_Orf2', 270929),
(451836, 'PF11915', NULL, 'Protein of unknown function (DUF3433)', 91, NULL, 'DUF3433', 270930),
(451837, 'PF13960', NULL, 'Domain of unknown function (DUF4218)', 113, NULL, 'DUF4218', 270931),
(451838, 'PF05527', NULL, 'Domain of unknown function (DUF758)', 181, NULL, 'DUF758', 270932),
(451839, 'PF16974', NULL, 'High-affinity nitrate transporter accessory, Ig-like domain', 143, NULL, 'NAR2', 270933),
(451840, 'PF19928', NULL, 'Domain of unknown function (DUF6391)', 134, NULL, 'DUF6391', 270934),
(451841, 'PF06917', NULL, 'Periplasmic pectate lyase', 556, NULL, 'Pectate_lyase_2', 270935),
(451842, 'PF08594', NULL, 'Uncharacterised protein family (UPF0300)', 212, NULL, 'UPF0300', 270936),
(451843, 'PF08775', NULL, 'ParB family', 125, NULL, 'ParB', 270937),
(451844, 'PF05179', NULL, 'RNA pol II accessory factor, Cdc73 family, C-terminal', 158, NULL, 'CDC73_C', 270938),
(451845, 'PF18139', NULL, 'SLOG in TRPM', 266, NULL, 'LSDAT_euk', 270939),
(451846, 'PF10479', NULL, 'Fragile site-associated protein C-terminus', 701, NULL, 'FSA_C', 270940),
(451847, 'PF16873', NULL, 'Putative abortive phage resistance protein AbiGii toxin', 397, NULL, 'AbiGii_2', 270941),
(451848, 'PF17786', NULL, 'Mannosidase Ig/CBM-like domain', 93, NULL, 'Mannosidase_ig', 270942),
(451849, 'PF19297', NULL, 'QcrA subunit N-terminal region', 221, NULL, 'QcrA_N', 270943),
(451850, 'PF10668', NULL, 'Phage terminase small subunit', 67, NULL, 'Phage_terminase', 270944);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(451851, 'PF10216', NULL, 'CO2 hydration protein (ChpXY)', 352, NULL, 'ChpXY', 270945),
(451852, 'PF00042', NULL, 'Globin', 118, NULL, 'Globin', 270946),
(451853, 'PF00198', NULL, '2-oxoacid dehydrogenases acyltransferase (catalytic domain)', 233, NULL, '2-oxoacid_dh', 270947),
(451854, 'PF19281', NULL, 'Phytanoyl-CoA hydroxylase-interacting protein C-terminus', 221, NULL, 'PHYHIP_C', 270948),
(451855, 'PF03631', NULL, 'Virulence factor BrkB', 258, NULL, 'Virul_fac_BrkB', 270949),
(451856, 'PF19160', NULL, 'SPARK', 163, NULL, 'SPARK', 270950),
(451857, 'PF06544', NULL, 'Protein of unknown function (DUF1115)', 144, NULL, 'DUF1115', 270951),
(451858, 'PF08077', NULL, 'Chloramphenicol resistance gene leader peptide', 17, NULL, 'Cm_res_leader', 270952),
(451859, 'PF06674', NULL, 'Protein of unknown function (DUF1176)', 327, NULL, 'DUF1176', 270953),
(451860, 'PF03496', NULL, 'ADP-ribosyltransferase exoenzyme', 197, NULL, 'ADPrib_exo_Tox', 270954),
(451861, 'PF06740', NULL, 'Protein of unknown function (DUF1213)', 34, NULL, 'DUF1213', 270955),
(451862, 'PF16420', NULL, 'Ubiquitin-like modifier-activating enzyme ATG7 N-terminus', 310, NULL, 'ATG7_N', 270956),
(451863, 'PF14628', NULL, 'Domain of unknown function (DUF4454)', 210, NULL, 'DUF4454', 270957),
(451864, 'PF17911', NULL, 'Ski2 N-terminal region', 135, NULL, 'Ski2_N', 270958),
(451865, 'PF20174', NULL, 'Family of unknown function (DUF6540)', 123, NULL, 'DUF6540', 270959),
(451866, 'PF02537', NULL, 'CrcB-like protein, Camphor Resistance (CrcB)', 93, NULL, 'CRCB', 270960),
(451867, 'PF10002', NULL, 'Predicted membrane protein (DUF2243)', 140, NULL, 'DUF2243', 270961),
(451868, 'PF15098', NULL, 'TMEM89 protein family', 134, NULL, 'TMEM89', 270962),
(451869, 'PF03330', NULL, 'Lytic transglycolase', 83, NULL, 'DPBB_1', 270963),
(451870, 'PF03034', NULL, 'Phosphatidyl serine synthase', 273, NULL, 'PSS', 270964),
(451871, 'PF18934', NULL, 'Family of unknown function (DUF5682)', 733, NULL, 'DUF5682', 270965),
(451872, 'PF18723', NULL, 'alpha-glutamyl/putrescinyl thymine pyrophosphorylase clade 1', 281, NULL, 'aGPT-Pplase1', 270966),
(451873, 'PF03888', NULL, 'MucB/RseB N-terminal domain', 178, NULL, 'MucB_RseB', 270967),
(451874, 'PF17527', NULL, 'Phage ALC protein', 167, NULL, 'ALC', 270968),
(451875, 'PF16462', NULL, 'Phage tail assembly chaperone protein, TAC', 113, NULL, 'Phage_TAC_14', 270969),
(451876, 'PF07793', NULL, 'Protein of unknown function (DUF1631)', 746, NULL, 'DUF1631', 270970),
(451877, 'PF01308', NULL, 'Chlamydia major outer membrane protein', 393, NULL, 'Chlam_OMP', 270971),
(451878, 'PF06878', NULL, 'Pkip-1 protein', 163, NULL, 'Pkip-1', 270972),
(451879, 'PF02479', NULL, 'Herpesvirus immediate early protein', 134, NULL, 'Herpes_IE68', 270973),
(451880, 'PF02149', NULL, 'Kinase associated domain 1', 45, NULL, 'KA1', 270974),
(451881, 'PF17544', NULL, 'Family of unknown function (DUF5460)', 375, NULL, 'DUF5460', 270975),
(451882, 'PF18340', NULL, 'DNA relaxase TraI 2B/2B-like domain', 79, NULL, 'TraI_2B', 270976),
(451883, 'PF11264', NULL, 'Thylakoid formation protein', 216, NULL, 'ThylakoidFormat', 270977),
(451884, 'PF08141', NULL, 'Small acid-soluble spore protein H family', 58, NULL, 'SspH', 270978),
(451885, 'PF08729', NULL, 'HPC2 and ubinuclein domain', 52, NULL, 'HUN', 270979),
(451886, 'PF15826', NULL, 'Bcl-2-binding component 3, p53 upregulated modulator of apoptosis', 189, NULL, 'PUMA', 270980),
(451887, 'PF10944', NULL, 'Protein of unknown function (DUF2630)', 80, NULL, 'DUF2630', 270981),
(451888, 'PF12012', NULL, 'Domain of unknown function (DUF3504)', 162, NULL, 'DUF3504', 270982),
(451889, 'PF11907', NULL, 'Domain of unknown function (DUF3427)', 284, NULL, 'DUF3427', 270983),
(451890, 'PF16984', NULL, 'Group 7 allergen', 180, NULL, 'Grp7_allergen', 270984),
(451891, 'PF01996', NULL, 'F420-0:Gamma-glutamyl ligase', 243, NULL, 'F420_ligase', 270985),
(451892, 'PF13740', NULL, 'ACT domain', 76, NULL, 'ACT_6', 270986),
(451893, 'PF16259', NULL, 'Domain of unknown function (DUF4913)', 104, NULL, 'DUF4913', 270987);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(451894, 'PF02625', NULL, 'XdhC and CoxI family', 68, NULL, 'XdhC_CoxI', 270988),
(451895, 'PF08372', NULL, 'Plant phosphoribosyltransferase C-terminal', 156, NULL, 'PRT_C', 270989),
(451896, 'PF12956', NULL, 'Domain of Unknown Function with PDB structure', 240, NULL, 'DUF3845', 270990),
(451897, 'PF08825', NULL, 'E2 binding domain', 82, NULL, 'E2_bind', 270991),
(451898, 'PF15215', NULL, 'Follicular dendritic cell secreted peptide', 69, NULL, 'FDC-SP', 270992),
(451899, 'PF11603', NULL, 'Sir1, ORC-binding domain', 120, NULL, 'Sir1', 270993),
(451900, 'PF17052', NULL, 'Cap associated factor', 159, NULL, 'CAF20', 270994),
(451901, 'PF17903', NULL, 'Krr1 KH1 domain', 81, NULL, 'KH_8', 270995),
(451902, 'PF19196', NULL, 'Family of unknown function (DUF5871)', 137, NULL, 'DUF5871', 270996),
(451903, 'PF01061', NULL, 'ABC-2 type transporter', 210, NULL, 'ABC2_membrane', 270997),
(451904, 'PF13696', NULL, 'Zinc knuckle', 21, NULL, 'zf-CCHC_2', 270998),
(451905, 'PF08092', NULL, 'Magi peptide toxin family', 38, NULL, 'Toxin_22', 270999),
(451906, 'PF15652', NULL, 'HNH/Endo VII superfamily toxin with a SHH signature', 99, NULL, 'Tox-SHH', 271000),
(451907, 'PF05105', NULL, 'Bacteriophage holin family', 114, NULL, 'Phage_holin_4_1', 271001),
(451908, 'PF11585', NULL, 'Insect antimicrobial peptide, stomoxyn', 40, NULL, 'Stomoxyn', 271002),
(451909, 'PF16812', NULL, 'C-terminal head domain of the fowl adenovirus type 1 long fibre', 201, NULL, 'AdHead_fibreRBD', 271003),
(451910, 'PF09675', NULL, 'Chlamydia-phage Chp2 scaffold (Chlamy_scaf)', 107, NULL, 'Chlamy_scaf', 271004),
(451911, 'PF02438', NULL, 'Late 100kD protein', 593, NULL, 'Adeno_100', 271005),
(451912, 'PF03342', NULL, 'Rhabdovirus M1 matrix protein (M1 polymerase-associated protein)', 227, NULL, 'Rhabdo_M1', 271006),
(451913, 'PF12051', NULL, 'Protein of unknown function (DUF3533)', 376, NULL, 'DUF3533', 271007),
(451914, 'PF11889', NULL, 'Capsid protein C, pestivirus', 56, NULL, 'Capsid_pestivir', 271008),
(451915, 'PF14175', NULL, 'YaaC-like Protein', 319, NULL, 'YaaC', 271009),
(451916, 'PF00616', NULL, 'GTPase-activator protein for Ras-like GTPase', 208, NULL, 'RasGAP', 271010),
(451917, 'PF03175', NULL, 'DNA polymerase type B, organellar and viral', 469, NULL, 'DNA_pol_B_2', 271011),
(451918, 'PF00373', NULL, 'FERM central domain', 116, NULL, 'FERM_M', 271012),
(451919, 'PF16045', NULL, 'LisH', 28, NULL, 'LisH_2', 271013),
(451920, 'PF07125', NULL, 'Protein of unknown function (DUF1378)', 59, NULL, 'DUF1378', 271014),
(451921, 'PF04354', NULL, 'ZipA, C-terminal FtsZ-binding domain', 128, NULL, 'ZipA_C', 271015),
(451922, 'PF13446', NULL, 'A repeated domain in UCH-protein', 59, NULL, 'RPT', 271016),
(451923, 'PF13826', NULL, 'Domain of unknown function (DUF4188)', 118, NULL, 'DUF4188', 271017),
(451924, 'PF11417', NULL, 'Loader and inhibitor of phage G40P', 66, NULL, 'Inhibitor_G39P', 271018),
(451925, 'PF11890', NULL, 'Domain of unknown function (DUF3410)', 81, NULL, 'DUF3410', 271019),
(451926, 'PF19204', NULL, 'Family of unknown function (DUF5876)', 561, NULL, 'DUF5876', 271020),
(451927, 'PF01112', NULL, 'Asparaginase', 309, NULL, 'Asparaginase_2', 271021),
(451928, 'PF11377', NULL, 'Protein of unknown function (DUF3180)', 135, NULL, 'DUF3180', 271022),
(451929, 'PF01938', NULL, 'TRAM domain', 62, NULL, 'TRAM', 271023),
(451930, 'PF06058', NULL, 'Dcp1-like decapping family', 117, NULL, 'DCP1', 271024),
(451931, 'PF20247', NULL, 'Domain of unknown function (DUF6602)', 106, NULL, 'DUF6602', 271025),
(451932, 'PF01902', NULL, 'Diphthamide synthase', 219, NULL, 'Diphthami_syn_2', 271026),
(451933, 'PF19625', NULL, 'Family of unknown function (DUF6130)', 139, NULL, 'DUF6130', 271027),
(451934, 'PF17369', NULL, 'Family of unknown function (DUF5391)', 135, NULL, 'DUF5391', 271028),
(451935, 'PF02694', NULL, 'Uncharacterised BCR, YnfA/UPF0060 family', 107, NULL, 'UPF0060', 271029),
(451936, 'PF13948', NULL, 'Domain of unknown function (DUF4215)', 47, NULL, 'DUF4215', 271030),
(451937, 'PF16703', NULL, 'Domain of unknown function (DUF5064)', 117, NULL, 'DUF5064', 271031);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(451938, 'PF05979', NULL, 'Bacterial protein of unknown function (DUF896)', 64, NULL, 'DUF896', 271032),
(451939, 'PF14189', NULL, 'Domain of unknown function (DUF4312)', 84, NULL, 'DUF4312', 271033),
(451940, 'PF18115', NULL, 'DNA repair protein Crb2 Tudor domain', 52, NULL, 'Tudor_3', 271034),
(451941, 'PF03561', NULL, 'Allantoicase repeat', 148, NULL, 'Allantoicase', 271035),
(451942, 'PF02389', NULL, 'Cornifin (SPRR) family', 135, NULL, 'Cornifin', 271036),
(451943, 'PF16212', NULL, 'Phospholipid-translocating P-type ATPase C-terminal', 249, NULL, 'PhoLip_ATPase_C', 271037),
(451944, 'PF02928', NULL, 'C5HC2 zinc finger', 53, NULL, 'zf-C5HC2', 271038),
(451945, 'PF01569', NULL, 'PAP2 superfamily', 136, NULL, 'PAP2', 271039),
(451946, 'PF16220', NULL, 'Domain of unknown function (DUF4880)', 43, NULL, 'DUF4880', 271040),
(451947, 'PF18753', NULL, 'Nucleotide modification associated domain 2', 201, NULL, 'Nmad2', 271041),
(451948, 'PF14472', NULL, 'Domain of unknown function (DUF4429)', 98, NULL, 'DUF4429', 271042),
(451949, 'PF17667', NULL, 'Fungal protein kinase', 405, NULL, 'Pkinase_fungal', 271043),
(451950, 'PF18168', NULL, 'Prim-pol family 5', 337, NULL, 'PPL5', 271044),
(451951, 'PF02037', NULL, 'SAP domain', 35, NULL, 'SAP', 271045),
(451952, 'PF15269', NULL, 'Zinc-finger', 54, NULL, 'zf-C2H2_7', 271046),
(451953, 'PF04777', NULL, 'Erv1 / Alr family', 97, NULL, 'Evr1_Alr', 271047),
(451954, 'PF14320', NULL, 'Phosphoprotein P region PNT disordered', 311, NULL, 'Paramyxo_PNT', 271048),
(451955, 'PF05003', NULL, 'Protein of unknown function (DUF668)', 89, NULL, 'DUF668', 271049),
(451956, 'PF11475', NULL, 'Virion protein N terminal domain', 32, NULL, 'VP_N-CPKC', 271050),
(451957, 'PF06999', NULL, 'Sucrase/ferredoxin-like', 195, NULL, 'Suc_Fer-like', 271051),
(451958, 'PF11127', NULL, 'Protein of unknown function (DUF2892)', 66, NULL, 'DUF2892', 271052),
(451959, 'PF09181', NULL, 'Prolyl-tRNA synthetase, C-terminal', 66, NULL, 'ProRS-C_2', 271053),
(451960, 'PF14176', NULL, 'YxiJ-like protein', 110, NULL, 'YxiJ', 271054),
(451961, 'PF15887', NULL, 'Putative zinc-binding metallo-peptidase', 235, NULL, 'Peptidase_Mx', 271055),
(451962, 'PF07566', NULL, 'Domain of Unknown Function (DUF1543)', 52, NULL, 'DUF1543', 271056),
(451963, 'PF18428', NULL, 'BRCA1 C Terminus (BRCT) domain', 102, NULL, 'BRCT_3', 271057),
(451964, 'PF17897', NULL, 'Vanadium chloroperoxidase N-terminal domain', 216, NULL, 'VCPO_N', 271058),
(451965, 'PF07901', NULL, 'Protein of unknown function (DUF1672)', 271, NULL, 'DUF1672', 271059),
(451966, 'PF05288', NULL, 'Poxvirus A3L Protein', 70, NULL, 'Pox_A3L', 271060),
(451967, 'PF00877', NULL, 'NlpC/P60 family', 105, NULL, 'NLPC_P60', 271061),
(451968, 'PF06940', NULL, 'Domain of unknown function (DUF1287)', 163, NULL, 'DUF1287', 271062),
(451969, 'PF19754', NULL, 'Family of unknown function (DUF6241)', 90, NULL, 'DUF6241', 271063),
(451970, 'PF07550', NULL, 'Protein of unknown function (DUF1533)', 60, NULL, 'DUF1533', 271064),
(451971, 'PF11519', NULL, 'Protein of unknown function (DUF3222)', 75, NULL, 'DUF3222', 271065),
(451972, 'PF06099', NULL, 'Phenol hydroxylase subunit', 57, NULL, 'Phenol_hyd_sub', 271066),
(451973, 'PF17008', NULL, 'Domain of unknown function (DUF5088)', 186, NULL, 'DUF5088', 271067),
(451974, 'PF02912', NULL, 'Aminoacyl tRNA synthetase class II, N-terminal domain', 69, NULL, 'Phe_tRNA-synt_N', 271068),
(451975, 'PF17601', NULL, 'Family of unknown function (DUF5497)', 89, NULL, 'DUF5497', 271069),
(451976, 'PF07788', NULL, 'PD-(D/E)XK nuclease superfamily', 74, NULL, 'PDDEXK_10', 271070),
(451977, 'PF00115', NULL, 'Cytochrome C and Quinol oxidase polypeptide I', 432, NULL, 'COX1', 271071),
(451978, 'PF07199', NULL, 'Protein of unknown function (DUF1411)', 194, NULL, 'DUF1411', 271072),
(451979, 'PF12547', NULL, 'Ataxin-1 like family', 540, NULL, 'ATXN-1_C', 271073),
(451980, 'PF20205', NULL, 'Family of unknown function (DUF6567)', 123, NULL, 'DUF6567', 271074),
(451981, 'PF01051', NULL, 'Initiator Replication protein', 222, NULL, 'Rep_3', 271075);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(451982, 'PF01602', NULL, 'Adaptin N terminal region', 524, NULL, 'Adaptin_N', 271076),
(451983, 'PF16017', NULL, 'BTB/POZ domain', 106, NULL, 'BTB_3', 271077),
(451984, 'PF10297', NULL, 'Minimal binding motif of Hap4 for binding to Hap2/3/5', 17, NULL, 'Hap4_Hap_bind', 271078),
(451985, 'PF01484', NULL, 'Nematode cuticle collagen N-terminal domain', 50, NULL, 'Col_cuticle_N', 271079),
(451986, 'PF03875', NULL, 'Statherin', 41, NULL, 'Statherin', 271080),
(451987, 'PF14048', NULL, 'C-terminal domain of methyl-CpG binding protein 2 and 3', 94, NULL, 'MBD_C', 271081),
(451988, 'PF03060', NULL, 'Nitronate monooxygenase', 331, NULL, 'NMO', 271082),
(451989, 'PF02486', NULL, 'Replication initiation factor', 203, NULL, 'Rep_trans', 271083),
(451990, 'PF13991', NULL, 'BssS protein family', 72, NULL, 'BssS', 271084),
(451991, 'PF18590', NULL, 'Immune Mapped Protein 2 (IMP2) N-terminal domain', 89, NULL, 'IMP2_N', 271085),
(451992, 'PF07431', NULL, 'Protein of unknown function (DUF1512)', 356, NULL, 'DUF1512', 271086),
(451993, 'PF02750', NULL, 'Synapsin, ATP binding domain', 203, NULL, 'Synapsin_C', 271087),
(451994, 'PF19867', NULL, 'Family of unknown function (DUF6340)', 258, NULL, 'DUF6340', 271088),
(451995, 'PF20587', NULL, 'Family of unknown function (DUF6789)', 148, NULL, 'DUF6789', 271089),
(451996, 'PF06289', NULL, 'Flagellar and Swarming motility proteins', 59, NULL, 'FlbD', 271090),
(451997, 'PF16784', NULL, 'Putative HNHc nuclease', 200, NULL, 'HNHc_6', 271091),
(451998, 'PF04812', NULL, 'Hepatocyte nuclear factor 1 (HNF-1), beta isoform C terminus', 258, NULL, 'HNF-1B_C', 271092),
(451999, 'PF02388', NULL, 'FemAB family', 408, NULL, 'FemAB', 271093),
(452000, 'PF02971', NULL, 'Formiminotransferase domain', 146, NULL, 'FTCD', 271094),
(452001, 'PF18938', NULL, 'Atypical Rib domain', 71, NULL, 'aRib', 271095),
(452002, 'PF05017', NULL, 'TMP repeat', 11, NULL, 'TMP', 271096),
(452003, 'PF17580', NULL, 'Group B Rotavirus Non-structural protein 5', 176, NULL, 'GBR_NSP5', 271097),
(452004, 'PF18477', NULL, 'PIN like domain', 116, NULL, 'PIN_9', 271098),
(452005, 'PF17302', NULL, 'Family of unknown function (DUF5351)', 29, NULL, 'DUF5351', 271099),
(452006, 'PF06136', NULL, 'Protein SOSEKI, plant', 383, NULL, 'SOK', 271100),
(452007, 'PF07666', NULL, 'M penetrans paralogue family 26', 75, NULL, 'MpPF26', 271101),
(452008, 'PF10898', NULL, 'Protein of unknown function (DUF2716)', 142, NULL, 'DUF2716', 271102),
(452009, 'PF03231', NULL, 'Bunyavirus non-structural protein NS-S', 444, NULL, 'Bunya_NS-S_2', 271103),
(452010, 'PF18190', NULL, 'Polo-like Kinase 4 Polo Box 1', 107, NULL, 'Plk4_PB1', 271104),
(452011, 'PF20565', NULL, 'Probable metallopeptidase family (DUF6775)', 258, NULL, 'DUF6775', 271105),
(452012, 'PF05662', NULL, 'Coiled stalk of trimeric autotransporter adhesin', 43, NULL, 'YadA_stalk', 271106),
(452013, 'PF14195', NULL, 'Domain of unknown function (DUF4316)', 44, NULL, 'DUF4316', 271107),
(452014, 'PF07265', NULL, 'Tapetum specific protein TAP35/TAP44', 119, NULL, 'TAP35_44', 271108),
(452015, 'PF04220', NULL, 'Der GTPase activator (YihI)', 155, NULL, 'YihI', 271109),
(452016, 'PF09187', NULL, 'RNA-directed DNA methylation 1', 119, NULL, 'RdDM_RDM1', 271110),
(452017, 'PF16563', NULL, 'Coiled-coil and interaction region of P66A and P66B with MBD2', 44, NULL, 'P66_CC', 271111),
(452018, 'PF03129', NULL, 'Anticodon binding domain', 94, NULL, 'HGTP_anticodon', 271112),
(452019, 'PF18645', NULL, 'Family of unknown function (DUF5631)', 96, NULL, 'DUF5631', 271113),
(452020, 'PF16862', NULL, 'Glycosyl hydrolase family 79 C-terminal beta domain', 103, NULL, 'Glyco_hydro_79C', 271114),
(452021, 'PF08886', NULL, 'Glutamate-cysteine ligase', 402, NULL, 'GshA', 271115),
(452022, 'PF19777', NULL, 'Family of unknown function (DUF6263)', 196, NULL, 'DUF6263', 271116),
(452023, 'PF01949', NULL, 'Protein of unknown function DUF99', 183, NULL, 'DUF99', 271117),
(452024, 'PF07447', NULL, 'Matrix protein VP40', 282, NULL, 'VP40', 271118),
(452025, 'PF17110', NULL, 'Subunit 11 of the general transcription factor TFIIH', 172, NULL, 'TFB6', 271119);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(452026, 'PF01185', NULL, 'Fungal hydrophobin', 80, NULL, 'Hydrophobin', 271120),
(452027, 'PF13607', NULL, 'Succinyl-CoA ligase like flavodoxin domain', 138, NULL, 'Succ_CoA_lig', 271121),
(452028, 'PF11061', NULL, 'Protein of unknown function (DUF2862)', 61, NULL, 'DUF2862', 271122),
(452029, 'PF19291', NULL, 'Trehalase-like, N-terminal', 212, NULL, 'TREH_N', 271123),
(452030, 'PF15919', NULL, 'HicB_like antitoxin of bacterial toxin-antitoxin system', 123, NULL, 'HicB_lk_antitox', 271124),
(452031, 'PF05041', NULL, 'Pecanex protein (C-terminus)', 228, NULL, 'Pecanex_C', 271125),
(452032, 'PF10104', NULL, 'Di-sulfide bridge nucleocytoplasmic transport domain', 133, NULL, 'Brr6_like_C_C', 271126),
(452033, 'PF14151', NULL, 'YfhD-like protein', 59, NULL, 'YfhD', 271127),
(452034, 'PF20249', NULL, 'VasX toxin N-terminal region', 161, NULL, 'VasX_N', 271128),
(452035, 'PF05354', NULL, 'Phage Head-Tail Attachment', 117, NULL, 'Phage_attach', 271129),
(452036, 'PF09339', NULL, 'IclR helix-turn-helix domain', 52, NULL, 'HTH_IclR', 271130),
(452037, 'PF05775', NULL, 'Enterobacteria AfaD invasin protein', 105, NULL, 'AfaD', 271131),
(452038, 'PF13934', NULL, 'Nuclear pore complex assembly', 221, NULL, 'ELYS', 271132),
(452039, 'PF08577', NULL, 'PI31 proteasome regulator', 79, NULL, 'PI31_Prot_C', 271133),
(452040, 'PF07893', NULL, 'Protein of unknown function (DUF1668)', 342, NULL, 'DUF1668', 271134),
(452041, 'PF13725', NULL, 'Possible tRNA binding domain', 235, NULL, 'tRNA_bind_2', 271135),
(452042, 'PF05841', NULL, 'Apc15p protein', 124, NULL, 'Apc15p', 271136),
(452043, 'PF07913', NULL, 'Protein of unknown function (DUF1678)', 196, NULL, 'DUF1678', 271137),
(452044, 'PF11439', NULL, 'Type III secretion system filament chaperone CesA', 95, NULL, 'T3SchapCesA', 271138),
(452045, 'PF00482', NULL, 'Type II secretion system (T2SS), protein F', 125, NULL, 'T2SSF', 271139),
(452046, 'PF19421', NULL, 'Furry protein C-terminal', 695, NULL, 'Fry_C', 271140),
(452047, 'PF09420', NULL, 'Ribosome biogenesis protein Nop16', 211, NULL, 'Nop16', 271141),
(452048, 'PF07023', NULL, 'Protein of unknown function (DUF1315)', 82, NULL, 'DUF1315', 271142),
(452049, 'PF14455', NULL, 'Predicted metal binding domain', 176, NULL, 'Metal_CEHH', 271143),
(452050, 'PF06039', NULL, 'Malate:quinone oxidoreductase (Mqo)', 489, NULL, 'Mqo', 271144),
(452051, 'PF01313', NULL, 'Bacterial export proteins, family 3', 74, NULL, 'Bac_export_3', 271145),
(452052, 'PF04149', NULL, 'Domain of unknown function (DUF397)', 54, NULL, 'DUF397', 271146),
(452053, 'PF07492', NULL, 'Neutral trehalase Ca2+ binding domain', 30, NULL, 'Trehalase_Ca-bi', 271147),
(452054, 'PF18722', NULL, 'MazG C-terminal domain', 190, NULL, 'MazG_C', 271148),
(452055, 'PF17157', NULL, 'Gammaproteobacterial periplasmic sensor domain', 98, NULL, 'GAPES4', 271149),
(452056, 'PF00565', NULL, 'Staphylococcal nuclease homologue', 108, NULL, 'SNase', 271150),
(452057, 'PF09356', NULL, 'Phage conserved hypothetical protein BR0599', 80, NULL, 'Phage_BR0599', 271151),
(452058, 'PF16866', NULL, 'PHD-finger', 68, NULL, 'PHD_4', 271152),
(452059, 'PF17618', NULL, 'Uncharacterized Strongylid L4 protein', 88, NULL, 'SL4P', 271153),
(452060, 'PF07153', NULL, 'Marek''s disease-like virus SORF3 protein', 253, NULL, 'Marek_SORF3', 271154),
(452061, 'PF05744', NULL, 'Benyvirus P25/P26 protein', 225, NULL, 'Benyvirus_P25', 271155),
(452062, 'PF13959', NULL, 'Domain of unknown function (DUF4217)', 63, NULL, 'DUF4217', 271156),
(452063, 'PF16966', NULL, 'Porin-like glycoporin RafY', 366, NULL, 'Porin_8', 271157),
(452064, 'PF04667', NULL, 'cAMP-regulated phosphoprotein/endosulfine conserved region', 80, NULL, 'Endosulfine', 271158),
(452065, 'PF08250', NULL, 'Sperm-activating peptides', 10, NULL, 'Sperm_act_pep', 271159),
(452066, 'PF14085', NULL, 'Domain of unknown function (DUF4265)', 115, NULL, 'DUF4265', 271160),
(452067, 'PF19060', NULL, 'DVNP family', 78, NULL, 'DVNP', 271161),
(452068, 'PF02253', NULL, 'Phospholipase A1', 257, NULL, 'PLA1', 271162),
(452069, 'PF00657', NULL, 'GDSL-like Lipase/Acylhydrolase', 245, NULL, 'Lipase_GDSL', 271163);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(452070, 'PF03892', NULL, 'Nitrate reductase cytochrome c-type subunit (NapB)', 127, NULL, 'NapB', 271164),
(452071, 'PF15087', NULL, 'Protein of unknown function (DUF4551)', 614, NULL, 'DUF4551', 271165),
(452072, 'PF04519', NULL, 'Polymer-forming cytoskeletal', 98, NULL, 'Bactofilin', 271166),
(452073, 'PF10146', NULL, 'Zinc finger-containing protein', 244, NULL, 'zf-C4H2', 271167),
(452074, 'PF10844', NULL, 'Protein of unknown function (DUF2577)', 98, NULL, 'DUF2577', 271168),
(452075, 'PF16410', NULL, 'Domain of unknown function (DUF5018)', 351, NULL, 'DUF5018', 271169),
(452076, 'PF19769', NULL, 'CPxCG-related zinc finger', 183, NULL, 'CPxCG_zf', 271170),
(452077, 'PF20066', NULL, 'Glyoxalase superfamily protein', 143, NULL, 'Glyoxalase_8', 271171),
(452078, 'PF16930', NULL, 'Putative porin', 532, NULL, 'Porin_5', 271172),
(452079, 'PF00097', NULL, 'Zinc finger, C3HC4 type (RING finger)', 41, NULL, 'zf-C3HC4', 271173),
(452080, 'PF03763', NULL, 'Remorin, C-terminal region', 107, NULL, 'Remorin_C', 271174),
(452081, 'PF03791', NULL, 'KNOX2 domain', 48, NULL, 'KNOX2', 271175),
(452082, 'PF01432', NULL, 'Peptidase family M3', 458, NULL, 'Peptidase_M3', 271176),
(452083, 'PF06113', NULL, 'Brain and reproductive organ-expressed protein (BRE)', 320, NULL, 'BRE', 271177),
(452084, 'PF07451', NULL, 'Stage V sporulation protein AD (SpoVAD)', 329, NULL, 'SpoVAD', 271178),
(452085, 'PF09968', NULL, 'Uncharacterized protein domain (DUF2202)', 162, NULL, 'DUF2202', 271179),
(452086, 'PF08192', NULL, 'Peptidase family S64', 697, NULL, 'Peptidase_S64', 271180),
(452087, 'PF05396', NULL, 'Phage T7 capsid assembly protein', 189, NULL, 'Phage_T7_Capsid', 271181),
(452088, 'PF15784', NULL, 'G-protein pathway suppressor 2-interacting domain', 89, NULL, 'GPS2_interact', 271182),
(452089, 'PF06550', NULL, 'Signal-peptide peptidase, presenilin aspartyl protease', 283, NULL, 'SPP', 271183),
(452090, 'PF03187', NULL, 'Corona nucleocapsid I protein', 207, NULL, 'Corona_I', 271184),
(452091, 'PF18171', NULL, 'SLOG in TRPM, prokaryote', 194, NULL, 'LSDAT_prok', 271185),
(452092, 'PF10664', NULL, 'Cyanobacterial and plastid NDH-1 subunit M', 107, NULL, 'NdhM', 271186),
(452093, 'PF08436', NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase C-terminal domain', 84, NULL, 'DXP_redisom_C', 271187),
(452094, 'PF10082', NULL, 'Putative beta-barrel porin 2', 378, NULL, 'BBP2_2', 271188),
(452095, 'PF07280', NULL, 'Per os infectivity factor AC110', 43, NULL, 'Ac110_PIF', 271189),
(452096, 'PF11162', NULL, 'Protein of unknown function (DUF2946)', 116, NULL, 'DUF2946', 271190),
(452097, 'PF02237', NULL, 'Biotin protein ligase C terminal domain', 48, NULL, 'BPL_C', 271191),
(452098, 'PF05415', NULL, 'Beet necrotic yellow vein furovirus-type papain-like endopeptidase', 104, NULL, 'Peptidase_C36', 271192),
(452099, 'PF05449', NULL, 'Putative 3TM holin, Phage_holin_3', 80, NULL, 'Phage_holin_3_7', 271193),
(452100, 'PF19147', NULL, 'Family of unknown function (DUF5829)', 266, NULL, 'DUF5829', 271194),
(452101, 'PF06189', NULL, '5''-nucleotidase', 266, NULL, '5-nucleotidase', 271195),
(452102, 'PF09305', NULL, 'TACI, cysteine-rich domain', 39, NULL, 'TACI-CRD2', 271196),
(452103, 'PF13329', NULL, 'Autophagy-related protein 2 CAD motif', 154, NULL, 'ATG2_CAD', 271197),
(452104, 'PF17009', NULL, 'Domain of unknown function (DUF5090)', 188, NULL, 'DUF5090', 271198),
(452105, 'PF18806', NULL, 'Importin 13 repeat', 75, NULL, 'Importin_rep_3', 271199),
(452106, 'PF00144', NULL, 'Beta-lactamase', 330, NULL, 'Beta-lactamase', 271200),
(452107, 'PF02951', NULL, 'Prokaryotic glutathione synthetase, N-terminal domain', 119, NULL, 'GSH-S_N', 271201),
(452108, 'PF19866', NULL, 'Family of unknown function (DUF6339)', 175, NULL, 'DUF6339', 271202),
(452109, 'PF03260', NULL, 'Lepidopteran low molecular weight (30 kD) lipoprotein', 231, NULL, 'Lipoprotein_11', 271203),
(452110, 'PF17484', NULL, 'N-Lobe handle Tf-binding protein B', 135, NULL, 'TbpB_A', 271204),
(452111, 'PF12011', NULL, 'RNA helicase NPH-II', 174, NULL, 'NPH-II', 271205),
(452112, 'PF18381', NULL, 'YcaO cyclodehydratase C-terminal domain', 172, NULL, 'YcaO_C', 271206);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(452113, 'PF15012', NULL, 'Domain of unknown function (DUF4519)', 56, NULL, 'DUF4519', 271207),
(452114, 'PF13890', NULL, 'Rab3 GTPase-activating protein catalytic subunit', 164, NULL, 'Rab3-GTPase_cat', 271208),
(452115, 'PF02966', NULL, 'Mitosis protein DIM1', 133, NULL, 'DIM1', 271209),
(452116, 'PF02738', NULL, 'Molybdopterin cofactor-binding domain', 244, NULL, 'MoCoBD_1', 271210),
(452117, 'PF05075', NULL, 'Protein of unknown function (DUF684)', 338, NULL, 'DUF684', 271211),
(452118, 'PF07921', NULL, 'Fibritin C-terminal region', 93, NULL, 'Fibritin_C', 271212),
(452119, 'PF17044', NULL, 'Borrelial persistence in ticks protein A', 191, NULL, 'BPTA', 271213),
(452120, 'PF20069', NULL, 'Family of unknown function (DUF6465)', 130, NULL, 'DUF6465', 271214),
(452121, 'PF12049', NULL, 'Protein of unknown function (DUF3531)', 143, NULL, 'DUF3531', 271215),
(452122, 'PF07117', NULL, 'Protein of unknown function (DUF1373)', 212, NULL, 'DUF1373', 271216),
(452123, 'PF15252', NULL, 'Domain of unknown function (DUF4589)', 242, NULL, 'DUF4589', 271217),
(452124, 'PF03522', NULL, 'Solute carrier family 12', 418, NULL, 'SLC12', 271218),
(452125, 'PF20505', NULL, 'Family of unknown function (DUF6731)', 294, NULL, 'DUF6731', 271219),
(452126, 'PF04288', NULL, 'MukE-like family', 229, NULL, 'MukE', 271220),
(452127, 'PF07386', NULL, 'Protein of unknown function (DUF1499)', 117, NULL, 'DUF1499', 271221),
(452128, 'PF19021', NULL, 'CRISPR system CMR subunit Cmr7 1', 197, NULL, 'Cmr7A', 271222),
(452129, 'PF18729', NULL, 'STY4199-like HEPN', 282, NULL, 'HEPN_STY4199', 271223),
(452130, 'PF19548', NULL, 'Chordin-like protein 1/2 C-terminal', 120, NULL, 'CHRDL_1_2_C', 271224),
(452131, 'PF09388', NULL, 'Spo0E like sporulation regulatory protein', 42, NULL, 'SpoOE-like', 271225),
(452132, 'PF16839', NULL, 'Nematode antimicrobial peptide', 54, NULL, 'Antimicrobial25', 271226),
(452133, 'PF00085', NULL, 'Thioredoxin', 103, NULL, 'Thioredoxin', 271227),
(452134, 'PF12484', NULL, 'PPE-SVP subfamily C-terminal region', 80, NULL, 'PPE-SVP', 271228),
(452135, 'PF02841', NULL, 'Guanylate-binding protein, C-terminal domain', 297, NULL, 'GBP_C', 271229),
(452136, 'PF02272', NULL, 'DHHA1 domain', 138, NULL, 'DHHA1', 271230),
(452137, 'PF03523', NULL, 'Macrophage scavenger receptor', 49, NULL, 'Macscav_rec', 271231),
(452138, 'PF20549', NULL, 'Family of unknown function (DUF6763)', 98, NULL, 'DUF6763', 271232),
(452139, 'PF20084', NULL, 'Conjugative transfer region protein TrbK', 109, NULL, 'TrbK', 271233),
(452140, 'PF16069', NULL, 'Domain of unknown function (DUF4811)', 155, NULL, 'DUF4811', 271234),
(452141, 'PF02010', NULL, 'REJ domain', 451, NULL, 'REJ', 271235),
(452142, 'PF10981', NULL, 'Protein of unknown function (DUF2788)', 51, NULL, 'DUF2788', 271236),
(452143, 'PF06790', NULL, 'Uncharacterised protein family (UPF0259)', 248, NULL, 'UPF0259', 271237),
(452144, 'PF18245', NULL, '5-3 exonuclease XRN1 DCP1-binding motif', 26, NULL, 'XRN1_DBM', 271238),
(452145, 'PF05989', NULL, 'Chordopoxvirus A35R protein', 174, NULL, 'Chordopox_A35R', 271239),
(452146, 'PF11291', NULL, 'Protein of unknown function (DUF3091)', 100, NULL, 'DUF3091', 271240),
(452147, 'PF12319', NULL, 'Tryptophan-Threonine-rich plasmodium antigen C terminal', 216, NULL, 'TryThrA_C', 271241),
(452148, 'PF04555', NULL, 'Restriction endonuclease XhoI', 191, NULL, 'XhoI', 271242),
(452149, 'PF02645', NULL, 'Uncharacterised protein, DegV family COG1307', 280, NULL, 'DegV', 271243),
(452150, 'PF05118', NULL, 'Aspartyl/Asparaginyl beta-hydroxylase', 156, NULL, 'Asp_Arg_Hydrox', 271244),
(452151, 'PF08659', NULL, 'KR domain', 180, NULL, 'KR', 271245),
(452152, 'PF18104', NULL, 'Jumonji domain-containing protein 2A Tudor domain', 35, NULL, 'Tudor_2', 271246),
(452153, 'PF02397', NULL, 'Bacterial sugar transferase', 184, NULL, 'Bac_transf', 271247),
(452154, 'PF13069', NULL, 'Protein of unknown function (DUF3933)', 52, NULL, 'DUF3933', 271248),
(452155, 'PF14964', NULL, 'Domain of unknown function (DUF4507)', 364, NULL, 'DUF4507', 271249),
(452156, 'PF18950', NULL, 'Family of unknown function (DUF5694)', 185, NULL, 'DUF5694', 271250);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(452157, 'PF19997', NULL, 'vWA domain found in the FtsH ternary systems', 252, NULL, 'ivWA', 271251),
(452158, 'PF01122', NULL, 'Eukaryotic cobalamin-binding protein', 318, NULL, 'Cobalamin_bind', 271252),
(452159, 'PF13133', NULL, 'Protein of unknown function (DUF3949)', 60, NULL, 'DUF3949', 271253),
(452160, 'PF09518', NULL, 'HindIII restriction endonuclease', 285, NULL, 'RE_HindIII', 271254),
(452161, 'PF08491', NULL, 'Squalene epoxidase', 276, NULL, 'SE', 271255),
(452162, 'PF12675', NULL, 'Protein of unknown function (DUF3795)', 85, NULL, 'DUF3795', 271256),
(452163, 'PF04202', NULL, 'Foot protein 3', 71, NULL, 'Mfp-3', 271257),
(452164, 'PF04862', NULL, 'Protein of unknown function (DUF642)', 157, NULL, 'DUF642', 271258),
(452165, 'PF07659', NULL, 'Nucleotide modification associated domain 1', 61, NULL, 'DUF1599', 271259),
(452166, 'PF00459', NULL, 'Inositol monophosphatase family', 272, NULL, 'Inositol_P', 271260),
(452167, 'PF10850', NULL, 'Protein of unknown function (DUF2653)', 88, NULL, 'DUF2653', 271261),
(452168, 'PF01993', NULL, 'methylene-5,6,7,8-tetrahydromethanopterin dehydrogenase', 274, NULL, 'MTD', 271262),
(452169, 'PF03823', NULL, 'Neurokinin B', 58, NULL, 'Neurokinin_B', 271263),
(452170, 'PF14740', NULL, 'Domain of unknown function (DUF4471)', 304, NULL, 'DUF4471', 271264),
(452171, 'PF11775', NULL, 'Cobalamin biosynthesis protein CobT VWA domain', 219, NULL, 'CobT_C', 271265),
(452172, 'PF03340', NULL, 'Poxvirus rifampicin resistance protein', 541, NULL, 'Pox_Rif', 271266),
(452173, 'PF06717', NULL, 'Protein of unknown function (DUF1202)', 307, NULL, 'DUF1202', 271267),
(452174, 'PF15694', NULL, 'Mediator complex subunit 26 middle domain', 255, NULL, 'Med26_M', 271268),
(452175, 'PF06292', NULL, 'MUN domain', 417, NULL, 'MUN', 271269),
(452176, 'PF20486', NULL, 'Family of unknown function (DUF6725)', 83, NULL, 'DUF6725', 271270),
(452177, 'PF05088', NULL, 'Bacterial NAD-glutamate dehydrogenase', 1530, NULL, 'Bac_GDH', 271271),
(452178, 'PF19752', NULL, 'Family of unknown function (DUF6239)', 179, NULL, 'DUF6239', 271272),
(452179, 'PF10390', NULL, 'RNA polymerase II elongation factor ELL', 277, NULL, 'ELL', 271273),
(452180, 'PF00060', NULL, 'Ligand-gated ion channel', 149, NULL, 'Lig_chan', 271274),
(452181, 'PF01644', NULL, 'Chitin synthase', 163, NULL, 'Chitin_synth_1', 271275),
(452182, 'PF03192', NULL, 'Pyrococcus protein of unknown function, DUF257', 205, NULL, 'DUF257', 271276),
(452183, 'PF06226', NULL, 'Protein of unknown function (DUF1007)', 210, NULL, 'DUF1007', 271277),
(452184, 'PF16192', NULL, 'C-terminal four TMM region of protein-O-mannosyltransferase', 200, NULL, 'PMT_4TMC', 271278),
(452185, 'PF01409', NULL, 'tRNA synthetases class II core domain (F)', 246, NULL, 'tRNA-synt_2d', 271279),
(452186, 'PF11641', NULL, 'Glycosylphosphatidylinositol-anchored merozoite surface protein', 224, NULL, 'Antigen_Bd37', 271280),
(452187, 'PF00572', NULL, 'Ribosomal protein L13', 119, NULL, 'Ribosomal_L13', 271281),
(452188, 'PF16327', NULL, 'Cytochrome c-type biogenesis protein CcmF C-terminal', 323, NULL, 'CcmF_C', 271282),
(452189, 'PF11984', NULL, 'Protein of unknown function (DUF3485)', 203, NULL, 'DUF3485', 271283),
(452190, 'PF00942', NULL, 'Cellulose binding domain', 82, NULL, 'CBM_3', 271284),
(452191, 'PF07907', NULL, 'YibE/F-like protein', 241, NULL, 'YibE_F', 271285),
(452192, 'PF05844', NULL, 'YopD protein', 297, NULL, 'YopD', 271286),
(452193, 'PF00664', NULL, 'ABC transporter transmembrane region', 274, NULL, 'ABC_membrane', 271287),
(452194, 'PF13463', NULL, 'Winged helix DNA-binding domain', 68, NULL, 'HTH_27', 271288),
(452195, 'PF14377', NULL, 'Ubiquitin binding region', 35, NULL, 'UBM', 271289),
(452196, 'PF06535', NULL, 'Repulsive guidance molecule (RGM) N-terminus', 166, NULL, 'RGM_N', 271290),
(452197, 'PF05060', NULL, 'N-acetylglucosaminyltransferase II (MGAT2)', 349, NULL, 'MGAT2', 271291),
(452198, 'PF08908', NULL, 'Putative oxygenase MesX', 323, NULL, 'MesX', 271292),
(452199, 'PF03118', NULL, 'Bacterial RNA polymerase, alpha chain C terminal domain', 67, NULL, 'RNA_pol_A_CTD', 271293);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(452200, 'PF08177', NULL, 'Small acid-soluble spore protein N family', 46, NULL, 'SspN', 271294),
(452201, 'PF15412', NULL, 'Binding domain of Nse4/EID3 to Nse3-MAGE', 57, NULL, 'Nse4-Nse3_bdg', 271295),
(452202, 'PF07874', NULL, 'Prophage protein (DUF1660)', 64, NULL, 'DUF1660', 271296),
(452203, 'PF04589', NULL, 'RFX1 transcription activation region', 161, NULL, 'RFX1_trans_act', 271297),
(452204, 'PF18913', NULL, 'Fructose-1-6-bisphosphatase, C-terminal domain', 131, NULL, 'FBPase_C', 271298),
(452205, 'PF03145', NULL, 'Seven in absentia protein family', 200, NULL, 'Sina', 271299),
(452206, 'PF14352', NULL, 'Domain of unknown function (DUF4402)', 129, NULL, 'DUF4402', 271300),
(452207, 'PF17629', NULL, 'Family of unknown function (DUF5510)', 62, NULL, 'DUF5510', 271301),
(452208, 'PF16394', NULL, 'Domain of unknown function (DUF5003)', 316, NULL, 'DUF5003', 271302),
(452209, 'PF17367', NULL, 'NiFe-hydrogenase-type-3 Eha complex subunit A', 94, NULL, 'NiFe_hyd_3_EhaA', 271303),
(452210, 'PF02641', NULL, 'Uncharacterized ACR, COG1993', 97, NULL, 'DUF190', 271304),
(452211, 'PF19349', NULL, 'Family of unknown function (DUF5927)', 300, NULL, 'DUF5927', 271305),
(452212, 'PF06320', NULL, 'GCN5-like protein 1 (GCN5L1)', 114, NULL, 'GCN5L1', 271306),
(452213, 'PF09300', NULL, 'Tectiviridae, minor capsid', 84, NULL, 'Tecti-min-caps', 271307),
(452214, 'PF10706', NULL, 'Aminoglycoside-2''''-adenylyltransferase', 174, NULL, 'Aminoglyc_resit', 271308),
(452215, 'PF12135', NULL, 'Plasmodium repeat family', 25, NULL, 'Plasmo_rep', 271309),
(452216, 'PF09418', NULL, 'Protein of unknown function (DUF2009)', 456, NULL, 'DUF2009', 271310),
(452217, 'PF02684', NULL, 'Lipid-A-disaccharide synthetase', 374, NULL, 'LpxB', 271311),
(452218, 'PF19914', NULL, 'Wolframin EF-hand domain', 88, NULL, 'WEF-hand', 271312),
(452219, 'PF03373', NULL, 'Octapeptide repeat', 8, NULL, 'Octapeptide', 271313),
(452220, 'PF17444', NULL, 'Uncharacterized YhdX-like', 33, NULL, 'YhdX', 271314),
(452221, 'PF06438', NULL, 'Heme-binding protein A (HasA)', 206, NULL, 'HasA', 271315),
(452222, 'PF03778', NULL, 'Protein of unknown function (DUF321)', 23, NULL, 'DUF321', 271316),
(452223, 'PF00291', NULL, 'Pyridoxal-phosphate dependent enzyme', 294, NULL, 'PALP', 271317),
(452224, 'PF05152', NULL, 'Protein of unknown function (DUF705)', 304, NULL, 'DUF705', 271318),
(452225, 'PF18963', NULL, 'Family of unknown function (DUF5703)', 51, NULL, 'DUF5703', 271319),
(452226, 'PF17707', NULL, 'Family of unknown function (DUF5553)', 223, NULL, 'DUF5553', 271320),
(452227, 'PF03899', NULL, 'ATP synthase I chain', 99, NULL, 'ATP-synt_I', 271321),
(452228, 'PF08694', NULL, 'Ubiquitin-fold modifier-conjugating enzyme 1', 155, NULL, 'UFC1', 271322),
(452229, 'PF17398', NULL, 'Nodulation protein NolB', 149, NULL, 'NolB', 271323),
(452230, 'PF11067', NULL, 'Protein of unknown function (DUF2868)', 327, NULL, 'DUF2868', 271324),
(452231, 'PF03678', NULL, 'Hexon, adenovirus major coat protein, C-terminal domain', 241, NULL, 'Adeno_hexon_C', 271325),
(452232, 'PF01309', NULL, 'Equine arteritis virus small envelope glycoprotein', 196, NULL, 'EAV_GS', 271326),
(452233, 'PF04074', NULL, 'YhcH/YjgK/YiaL', 148, NULL, 'DUF386', 271327),
(452234, 'PF16794', NULL, 'Fibronectin-III type domain', 103, NULL, 'fn3_4', 271328),
(452235, 'PF17259', NULL, 'Family of unknown function (DUF5325)', 61, NULL, 'DUF5325', 271329),
(452236, 'PF07103', NULL, 'Protein of unknown function (DUF1365)', 235, NULL, 'DUF1365', 271330),
(452237, 'PF05404', NULL, 'Translocon-associated protein, delta subunit precursor (TRAP-delta)', 162, NULL, 'TRAP-delta', 271331),
(452238, 'PF08726', NULL, 'Ca2+ insensitive EF hand', 70, NULL, 'EFhand_Ca_insen', 271332),
(452239, 'PF06255', NULL, 'Neisseria toxin MafB', 312, NULL, 'MafB', 271333),
(452240, 'PF11518', NULL, 'Protein of unknown function (DUF3221)', 82, NULL, 'DUF3221', 271334),
(452241, 'PF01075', NULL, 'Glycosyltransferase family 9 (heptosyltransferase)', 249, NULL, 'Glyco_transf_9', 271335),
(452242, 'PF15442', NULL, 'Domain of unknown function (DUF4629)', 150, NULL, 'DUF4629', 271336);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(452243, 'PF06312', NULL, 'Neurexophilin', 210, NULL, 'Neurexophilin', 271337),
(452244, 'PF17176', NULL, 'tRNA-binding domain', 119, NULL, 'tRNA_bind_3', 271338),
(452245, 'PF18476', NULL, 'PIN like domain', 227, NULL, 'PIN_8', 271339),
(452246, 'PF16033', NULL, 'Domain of unknown function (DUF4789)', 99, NULL, 'DUF4789', 271340),
(452247, 'PF00566', NULL, 'Rab-GTPase-TBC domain', 216, NULL, 'RabGAP-TBC', 271341),
(452248, 'PF06912', NULL, 'Protein of unknown function (DUF1275)', 191, NULL, 'DUF1275', 271342),
(452249, 'PF03806', NULL, 'AbgT putative transporter family', 502, NULL, 'ABG_transport', 271343),
(452250, 'PF14295', NULL, 'PAN domain', 51, NULL, 'PAN_4', 271344),
(452251, 'PF01754', NULL, 'A20-like zinc finger', 24, NULL, 'zf-A20', 271345),
(452252, 'PF01965', NULL, 'DJ-1/PfpI family', 165, NULL, 'DJ-1_PfpI', 271346),
(452253, 'PF14150', NULL, 'YesK-like protein', 81, NULL, 'YesK', 271347),
(452254, 'PF20595', NULL, 'Putative adhesive domain (group 6)', 165, NULL, 'pAdhesive_6', 271348),
(452255, 'PF16005', NULL, 'KH-like RNA-binding domain', 86, NULL, 'MOEP19', 271349),
(452256, 'PF19374', NULL, 'Family of unknown function (DUF5949)', 167, NULL, 'DUF5949', 271350),
(452257, 'PF19737', NULL, 'Fukutin N-terminal', 278, NULL, 'FKTN_N', 271351),
(452258, 'PF03914', NULL, 'CBF/Mak21 family', 170, NULL, 'CBF', 271352),
(452259, 'PF14078', NULL, 'Domain of unknown function (DUF4259)', 137, NULL, 'DUF4259', 271353),
(452260, 'PF18764', NULL, 'Nitrous oxide reductase propeller repeat', 71, NULL, 'nos_propeller', 271354),
(452261, 'PF01717', NULL, 'Cobalamin-independent synthase, Catalytic domain', 324, NULL, 'Meth_synt_2', 271355),
(452262, 'PF00904', NULL, 'Involucrin repeat', 10, NULL, 'Involucrin', 271356),
(452263, 'PF08989', NULL, 'Domain of unknown function (DUF1896)', 142, NULL, 'DUF1896', 271357),
(452264, 'PF05798', NULL, 'Bacteriophage FRD3 protein', 75, NULL, 'Phage_FRD3', 271358),
(452265, 'PF06454', NULL, 'THH1/TOM1/TOM3 domain', 273, NULL, 'THH1_TOM1-3_dom', 271359),
(452266, 'PF18987', NULL, 'Family of unknown function (DUF5720)', 100, NULL, 'DUF5720', 271360),
(452267, 'PF01216', NULL, 'Calsequestrin', 386, NULL, 'Calsequestrin', 271361),
(452268, 'PF09538', NULL, 'Protein of unknown function (FYDLN_acid)', 106, NULL, 'FYDLN_acid', 271362),
(452269, 'PF16681', NULL, 'Ig-like domain on T-cell surface glycoprotein CD3 epsilon chain', 83, NULL, 'Ig_5', 271363),
(452270, 'PF13600', NULL, 'N-terminal domain of unknown function (DUF4140)', 99, NULL, 'DUF4140', 271364),
(452271, 'PF07378', NULL, 'Flagellar protein FlbT', 125, NULL, 'FlbT', 271365),
(452272, 'PF08990', NULL, 'Erythronolide synthase docking domain', 29, NULL, 'Docking', 271366),
(452273, 'PF15048', NULL, 'Organic solute transporter subunit beta protein', 122, NULL, 'OSTbeta', 271367),
(452274, 'PF01912', NULL, 'eIF-6 family', 197, NULL, 'eIF-6', 271368),
(452275, 'PF09851', NULL, 'Short C-terminal domain', 28, NULL, 'SHOCT', 271369),
(452276, 'PF15699', NULL, 'NPR1 interacting', 110, NULL, 'NPR1_interact', 271370),
(452277, 'PF20456', NULL, 'Family of unknown function (DUF6709)', 335, NULL, 'DUF6709', 271371),
(452278, 'PF01998', NULL, 'Protein of unknown function DUF131', 64, NULL, 'DUF131', 271372),
(452279, 'PF08667', NULL, 'BetR domain', 148, NULL, 'BetR', 271373),
(452280, 'PF06348', NULL, 'Protein of unknown function (DUF1059)', 56, NULL, 'DUF1059', 271374),
(452281, 'PF03589', NULL, 'Antitermination protein', 87, NULL, 'Antiterm', 271375),
(452282, 'PF20157', NULL, 'Glycosyltransferase Maf N-terminal domain', 228, NULL, 'Maf_flag10_N', 271376),
(452283, 'PF18965', NULL, 'Outer capsid protein VP3-like', 1062, NULL, 'VP3-like', 271377),
(452284, 'PF12472', NULL, 'Phage related protein', 60, NULL, 'DUF3693', 271378),
(452285, 'PF00156', NULL, 'Phosphoribosyl transferase domain', 158, NULL, 'Pribosyltran', 271379),
(452286, 'PF11204', NULL, 'Protein of unknown function (DUF2985)', 78, NULL, 'DUF2985', 271380),
(452287, 'PF10076', NULL, 'Bacteriophage Mu-like, Gp48', 173, NULL, 'Phage_Mu_Gp48', 271381),
(452288, 'PF00574', NULL, 'Clp protease', 182, NULL, 'CLP_protease', 271382);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(452289, 'PF07952', NULL, 'Clostridium neurotoxin, Translocation domain', 322, NULL, 'Toxin_trans', 271383),
(452290, 'PF19795', NULL, 'Family of unknown function (DUF6279)', 195, NULL, 'DUF6279', 271384),
(452291, 'PF14930', NULL, 'Quinohemoprotein amine dehydrogenase, alpha subunit domain II', 107, NULL, 'Qn_am_d_aII', 271385),
(452292, 'PF08099', NULL, 'Scorpion calcine family', 33, NULL, 'Toxin_27', 271386),
(452293, 'PF12276', NULL, 'Protein of unknown function (DUF3617)', 109, NULL, 'DUF3617', 271387),
(452294, 'PF19591', NULL, 'Family of unknown function (DUF6096)', 130, NULL, 'DUF6096', 271388),
(452295, 'PF02398', NULL, 'Coronavirus protein 7', 101, NULL, 'Corona_7', 271389),
(452296, 'PF00829', NULL, 'Ribosomal prokaryotic L21 protein', 100, NULL, 'Ribosomal_L21p', 271390),
(452297, 'PF15883', NULL, 'Domain of unknown function (DUF4736)', 186, NULL, 'DUF4736', 271391),
(452298, 'PF03927', NULL, 'NapD protein', 76, NULL, 'NapD', 271392),
(452299, 'PF09114', NULL, 'Transcription factor MotA, activation domain', 95, NULL, 'MotA_activ', 271393),
(452300, 'PF19315', NULL, 'Mesaconyl-CoA hydratase', 353, NULL, 'MC_hydratase', 271394),
(452301, 'PF08201', NULL, 'BssC/TutF protein', 56, NULL, 'BssC_TutF', 271395),
(452302, 'PF16565', NULL, 'Phospholipase D-like domain at C-terminus of MIT', 141, NULL, 'MIT_C', 271396),
(452303, 'PF16911', NULL, 'Phthiocerol/phthiodiolone dimycocerosyl transferase C-terminus', 120, NULL, 'PapA_C', 271397),
(452304, 'PF02811', NULL, 'PHP domain', 172, NULL, 'PHP', 271398),
(452305, 'PF00294', NULL, 'pfkB family carbohydrate kinase', 302, NULL, 'PfkB', 271399),
(452306, 'PF12256', NULL, 'Insecticide toxin TcdB middle/N-terminal region', 181, NULL, 'TcdB_toxin_midN', 271400),
(452307, 'PF14093', NULL, 'Domain of unknown function (DUF4271)', 207, NULL, 'DUF4271', 271401),
(452308, 'PF14201', NULL, 'Domain of unknown function (DUF4318)', 75, NULL, 'DUF4318', 271402),
(452309, 'PF07037', NULL, 'Putative transcription regulator (DUF1323)', 122, NULL, 'DUF1323', 271403),
(452310, 'PF17972', NULL, 'Bacterial Alpha-2-macroglobulin MG5 domain', 127, NULL, 'bMG5', 271404),
(452311, 'PF02500', NULL, 'Probable DNA packing protein, N-terminus', 278, NULL, 'DNA_pack_N', 271405),
(452312, 'PF02638', NULL, 'Glycosyl hydrolase-like 10', 311, NULL, 'GHL10', 271406),
(452313, 'PF15617', NULL, 'C-C_Bond_Lyase of the TIM-Barrel fold', 335, NULL, 'C-C_Bond_Lyase', 271407),
(452314, 'PF09829', NULL, 'Uncharacterized protein conserved in bacteria (DUF2057)', 192, NULL, 'DUF2057', 271408),
(452315, 'PF11129', NULL, 'Rev protein of equine infectious anaemia virus', 134, NULL, 'EIAV_Rev', 271409),
(452316, 'PF06203', NULL, 'CCT motif', 44, NULL, 'CCT', 271410),
(452317, 'PF04351', NULL, 'Pilus assembly protein, PilP', 147, NULL, 'PilP', 271411),
(452318, 'PF04852', NULL, 'ALOG domain', 126, NULL, 'ALOG_dom', 271412),
(452319, 'PF08457', NULL, 'Sfi1 spindle body protein', 570, NULL, 'Sfi1', 271413),
(452320, 'PF10105', NULL, 'Uncharacterized protein conserved in bacteria (DUF2344)', 174, NULL, 'DUF2344', 271414),
(452321, 'PF04680', NULL, 'Opioid growth factor receptor repeat', 20, NULL, 'OGFr_III', 271415),
(452322, 'PF07301', NULL, 'CcdC protein', 145, NULL, 'DUF1453', 271416),
(452323, 'PF08015', NULL, 'Fungal mating-type pheromone', 69, NULL, 'Pheromone', 271417),
(452324, 'PF14603', NULL, 'Helically-extended SH3 domain', 89, NULL, 'hSH3', 271418),
(452325, 'PF20099', NULL, 'Family of unknown function (DUF6489)', 80, NULL, 'DUF6489', 271419),
(452326, 'PF03246', NULL, 'Pneumovirus nucleocapsid protein', 392, NULL, 'Pneumo_ncap', 271420),
(452327, 'PF19140', NULL, 'Family of unknown function (DUF5823)', 178, NULL, 'DUF5823', 271421),
(452328, 'PF08763', NULL, 'Voltage gated calcium channel IQ domain', 78, NULL, 'Ca_chan_IQ', 271422),
(452329, 'PF19260', NULL, 'Family of unknown function (DUF5903)', 129, NULL, 'DUF5903', 271423),
(452330, 'PF20557', NULL, 'Putative DnaT-like ssDNA binding protein', 168, NULL, 'DnaT_2', 271424),
(452331, 'PF09682', NULL, 'Bacteriophage holin of superfamily 6 (Holin_LLH)', 101, NULL, 'Phage_holin_6_1', 271425);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(452332, 'PF14697', NULL, '4Fe-4S dicluster domain', 59, NULL, 'Fer4_21', 271426),
(452333, 'PF17933', NULL, 'Tetracyclin repressor-like, C-terminal domain', 106, NULL, 'TetR_C_25', 271427),
(452334, 'PF15889', NULL, 'Domain of unknown function (DUF4738)', 146, NULL, 'DUF4738', 271428),
(452335, 'PF11882', NULL, 'Domain of unknown function (DUF3402)', 465, NULL, 'DUF3402', 271429),
(452336, 'PF09429', NULL, 'WW domain binding protein 11', 78, NULL, 'Wbp11', 271430),
(452337, 'PF17025', NULL, 'Domain of unknown function (DUF5099)', 109, NULL, 'DUF5099', 271431),
(452338, 'PF02176', NULL, 'TRAF-type zinc finger', 60, NULL, 'zf-TRAF', 271432),
(452339, 'PF15505', NULL, 'Vexin domain', 80, NULL, 'Vexin', 271433),
(452340, 'PF15228', NULL, 'Death-associated protein', 98, NULL, 'DAP', 271434),
(452341, 'PF08019', NULL, 'Phosphoethanolamine transferase EptA/EptB', 152, NULL, 'EptA_B_N', 271435),
(452342, 'PF20558', NULL, 'Family of unknown function (DUF6769)', 130, NULL, 'DUF6769', 271436),
(452343, 'PF09766', NULL, 'Fms-interacting protein/Thoc5', 363, NULL, 'FmiP_Thoc5', 271437),
(452344, 'PF10470', NULL, 'PKA-RI-RII subunit binding domain of A-kinase anchor protein', 57, NULL, 'AKAP7_RIRII_bdg', 271438),
(452345, 'PF10063', NULL, 'Uncharacterized integral membrane protein (DUF2301)', 135, NULL, 'DUF2301', 271439),
(452346, 'PF06784', NULL, 'Uncharacterised protein family (UPF0240)', 168, NULL, 'UPF0240', 271440),
(452347, 'PF20023', NULL, 'Wolframin Sel1-like repeat', 39, NULL, 'WSLR', 271441),
(452348, 'PF10680', NULL, 'RNA polymerase I specific transcription initiation factor', 69, NULL, 'RRN9', 271442),
(452349, 'PF06031', NULL, 'SERTA motif', 36, NULL, 'SERTA', 271443),
(452350, 'PF09061', NULL, 'Stirrup', 79, NULL, 'Stirrup', 271444),
(452351, 'PF13547', NULL, 'GTA TIM-barrel-like domain', 299, NULL, 'GTA_TIM', 271445),
(452352, 'PF18257', NULL, 'Disulfide isomerase DsbG N-terminal', 90, NULL, 'DsbG_N', 271446),
(452353, 'PF12464', NULL, 'Maltose acetyltransferase', 53, NULL, 'Mac', 271447),
(452354, 'PF10644', NULL, 'Misato Segment II tubulin-like domain', 118, NULL, 'Misat_Tub_SegII', 271448),
(452355, 'PF06824', NULL, 'Metal-independent alpha-mannosidase (GH125)', 418, NULL, 'Glyco_hydro_125', 271449),
(452356, 'PF13919', NULL, 'Asx homology domain', 139, NULL, 'ASXH', 271450),
(452357, 'PF15523', NULL, 'Novel toxin 16', 85, NULL, 'Ntox16', 271451),
(452358, 'PF16284', NULL, 'Domain of unknown function (DUF4930)', 136, NULL, 'DUF4930', 271452),
(452359, 'PF08065', NULL, 'KI67R (NUC007) repeat', 112, NULL, 'KI67R', 271453),
(452360, 'PF15340', NULL, 'Cooperator of PRMT5 family', 150, NULL, 'COPR5', 271454),
(452361, 'PF04412', NULL, 'Aconitase X', 401, NULL, 'AcnX', 271455),
(452362, 'PF18495', NULL, 'Antitoxin VbhA', 47, NULL, 'VbhA', 271456),
(452363, 'PF01003', NULL, 'Flavivirus capsid protein C', 117, NULL, 'Flavi_capsid', 271457),
(452364, 'PF06457', NULL, 'Ectatomin', 34, NULL, 'Ectatomin', 271458),
(452365, 'PF09790', NULL, 'Hyccin', 321, NULL, 'Hyccin', 271459),
(452366, 'PF16453', NULL, 'PH domain', 135, NULL, 'IQ_SEC7_PH', 271460),
(452367, 'PF11172', NULL, 'Protein of unknown function (DUF2959)', 190, NULL, 'DUF2959', 271461),
(452368, 'PF10052', NULL, 'Protein of unknown function (DUF2288)', 91, NULL, 'DUF2288', 271462),
(452369, 'PF13424', NULL, 'Tetratricopeptide repeat', 77, NULL, 'TPR_12', 271463),
(452370, 'PF13488', NULL, 'Glycine zipper', 46, NULL, 'Gly-zipper_Omp', 271464),
(452371, 'PF19632', NULL, 'Family of unknown function (DUF6136)', 356, NULL, 'DUF6136', 271465),
(452372, 'PF04273', NULL, 'Beta-lactamase hydrolase-like protein, phosphatase-like domain', 110, NULL, 'BLH_phosphatase', 271466),
(452373, 'PF10018', NULL, 'Vitamin-D-receptor interacting Mediator subunit 4', 194, NULL, 'Med4', 271467),
(452374, 'PF00202', NULL, 'Aminotransferase class-III', 403, NULL, 'Aminotran_3', 271468),
(452375, 'PF15751', NULL, 'FAAP20 FANCA interaction domain', 108, NULL, 'FANCA_interact', 271469),
(452376, 'PF14827', NULL, 'Double sensory domain of two-component sensor kinase', 238, NULL, 'dCache_3', 271470);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(452377, 'PF01565', NULL, 'FAD binding domain', 139, NULL, 'FAD_binding_4', 271471),
(452378, 'PF17069', NULL, 'Arginine/Serine-Rich protein 1', 299, NULL, 'RSRP', 271472),
(452379, 'PF03053', NULL, 'ORF3b coronavirus protein', 226, NULL, 'Corona_NS3b', 271473),
(452380, 'PF04170', NULL, 'NlpE N-terminal domain', 86, NULL, 'NlpE', 271474),
(452381, 'PF18157', NULL, 'MID domain of pPIWI_RE', 142, NULL, 'MID_pPIWI_RE', 271475),
(452382, 'PF19730', NULL, 'Family of unknown function (DUF6221)', 111, NULL, 'DUF6221', 271476),
(452383, 'PF05231', NULL, 'MASE1', 300, NULL, 'MASE1', 271477),
(452384, 'PF00094', NULL, 'von Willebrand factor type D domain', 157, NULL, 'VWD', 271478),
(452385, 'PF03611', NULL, 'PTS system sugar-specific permease component', 395, NULL, 'EIIC-GAT', 271479),
(452386, 'PF13317', NULL, 'Protein of unknown function (DUF4088)', 226, NULL, 'DUF4088', 271480),
(452387, 'PF01515', NULL, 'Phosphate acetyl/butaryl transferase', 319, NULL, 'PTA_PTB', 271481),
(452388, 'PF18032', NULL, 'Photoprotection regulator fluorescence recovery protein', 99, NULL, 'FRP', 271482),
(452389, 'PF09625', NULL, 'VP9 protein', 79, NULL, 'VP9', 271483),
(452390, 'PF00798', NULL, 'Arenavirus glycoprotein', 483, NULL, 'Arena_glycoprot', 271484),
(452391, 'PF19175', NULL, 'Family of unknown function (DUF5857)', 287, NULL, 'DUF5857', 271485),
(452392, 'PF05170', NULL, 'AsmA family', 608, NULL, 'AsmA', 271486),
(452393, 'PF06414', NULL, 'Zeta toxin', 201, NULL, 'Zeta_toxin', 271487),
(452394, 'PF07066', NULL, 'Lactococcus phage M3 protein', 159, NULL, 'DUF3882', 271488),
(452395, 'PF13034', NULL, 'Protein of unknown function (DUF3895)', 76, NULL, 'DUF3895', 271489),
(452396, 'PF02615', NULL, 'Malate/L-lactate dehydrogenase', 333, NULL, 'Ldh_2', 271490),
(452397, 'PF04781', NULL, 'Protein of unknown function (DUF627)', 108, NULL, 'DUF627', 271491),
(452398, 'PF18415', NULL, 'Histidine kinase receptor ArcB trans-membrane domain', 75, NULL, 'HKR_ArcB_TM', 271492),
(452399, 'PF13979', NULL, 'SopA-like catalytic domain', 168, NULL, 'SopA_C', 271493),
(452400, 'PF05953', NULL, 'Allatostatin', 11, NULL, 'Allatostatin', 271494),
(452401, 'PF17843', NULL, 'MycE methyltransferase N-terminal', 111, NULL, 'MycE_N', 271495),
(452402, 'PF13809', NULL, 'Tubulin like', 351, NULL, 'Tubulin_2', 271496),
(452403, 'PF18193', NULL, 'Fibrillin 1 unique N-terminal domain', 37, NULL, 'Fibrillin_U_N', 271497),
(452404, 'PF16205', NULL, 'Ribosomal_S17 N-terminal', 67, NULL, 'Ribosomal_S17_N', 271498),
(452405, 'PF10725', NULL, 'Protein of unknown function (DUF2517)', 61, NULL, 'DUF2517', 271499),
(452406, 'PF12754', NULL, 'Blt1 N-terminal domain', 150, NULL, 'Blt1', 271500),
(452407, 'PF01620', NULL, 'Ribonuclease (pollen allergen)', 155, NULL, 'Pollen_allerg_2', 271501),
(452408, 'PF11737', NULL, 'Protein of unknown function (DUF3300)', 229, NULL, 'DUF3300', 271502),
(452409, 'PF06087', NULL, 'Tyrosyl-DNA phosphodiesterase', 450, NULL, 'Tyr-DNA_phospho', 271503),
(452410, 'PF17652', NULL, 'Glycosyl hydrolase family 81 C-terminal domain', 349, NULL, 'Glyco_hydro81C', 271504),
(452411, 'PF16778', NULL, 'Phage tail assembly chaperone protein', 60, NULL, 'Phage_tail_APC', 271505),
(452412, 'PF18865', NULL, 'AbiJ N-terminal domain 5', 93, NULL, 'AbiJ_NTD5', 271506),
(452413, 'PF19030', NULL, 'Thrombospondin type 1 domain', 55, NULL, 'TSP1_ADAMTS', 271507),
(452414, 'PF01972', NULL, 'Serine dehydrogenase proteinase', 286, NULL, 'SDH_sah', 271508),
(452415, 'PF06881', NULL, 'RNA polymerase II transcription factor SIII (Elongin) subunit A', 105, NULL, 'Elongin_A', 271509),
(452416, 'PF11504', NULL, 'Colicin Ia', 72, NULL, 'Colicin_Ia', 271510),
(452417, 'PF10097', NULL, 'Predicted membrane protein (DUF2335)', 50, NULL, 'DUF2335', 271511),
(452418, 'PF06696', NULL, 'Streptococcal surface antigen repeat', 25, NULL, 'Strep_SA_rep', 271512),
(452419, 'PF11581', NULL, 'Antagonist of EGFR signalling, Argos', 129, NULL, 'Argos', 271513),
(452420, 'PF16607', NULL, 'Phosphorylation region of CYLD, unstructured', 165, NULL, 'CYLD_phos_site', 271514);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(452421, 'PF19019', NULL, 'Phlebovirus glycoprotein G2 C-terminal domain', 171, NULL, 'Phlebo_G2_C', 271515),
(452422, 'PF19275', NULL, 'HflX C-terminal domain', 102, NULL, 'HflX_C', 271516),
(452423, 'PF05585', NULL, 'Putative peptidase (DUF1758)', 164, NULL, 'DUF1758', 271517),
(452424, 'PF02290', NULL, 'Signal recognition particle 14kD protein', 109, NULL, 'SRP14', 271518),
(452425, 'PF16624', NULL, 'Unstructured region upstream of a zinc-finger', 97, NULL, 'zf-C2H2_assoc2', 271519),
(452426, 'PF02604', NULL, 'Antitoxin Phd_YefM, type II toxin-antitoxin system', 75, NULL, 'PhdYeFM_antitox', 271520),
(452427, 'PF15438', NULL, 'Antigenic membrane protein of phytoplasma', 195, NULL, 'Phyto-Amp', 271521),
(452428, 'PF05853', NULL, 'beta-keto acid cleavage enzyme', 274, NULL, 'BKACE', 271522),
(452429, 'PF14872', NULL, 'Hypothetical glycoside hydrolase 5', 802, NULL, 'GHL5', 271523),
(452430, 'PF01468', NULL, 'GA module', 55, NULL, 'GA', 271524),
(452431, 'PF04971', NULL, 'Bacteriophage P21 holin S', 64, NULL, 'Phage_holin_2_1', 271525),
(452432, 'PF04033', NULL, 'Domain of unknown function (DUF365)', 96, NULL, 'DUF365', 271526),
(452433, 'PF06342', NULL, 'Alpha/beta hydrolase of unknown function (DUF1057)', 297, NULL, 'DUF1057', 271527),
(452434, 'PF19084', NULL, 'Family of unknown function (DUF5775)', 81, NULL, 'DUF5775', 271528),
(452435, 'PF02020', NULL, 'eIF4-gamma/eIF5/eIF2-epsilon', 79, NULL, 'W2', 271529),
(452436, 'PF17981', NULL, 'Cysteine Rich ADD domain', 56, NULL, 'ADD_ATRX', 271530),
(452437, 'PF03805', NULL, 'Cytoadherence-linked asexual protein', 1286, NULL, 'CLAG', 271531),
(452438, 'PF20002', NULL, 'FtsH ternary system domain X3-analog', 89, NULL, 'fvmX3-analog', 271532),
(452439, 'PF11237', NULL, 'Protein of unknown function (DUF3038)', 168, NULL, 'DUF3038', 271533),
(452440, 'PF14589', NULL, 'Polysulfide reductase', 265, NULL, 'NrfD_2', 271534),
(452441, 'PF14024', NULL, 'Protein of unknown function (DUF4240)', 128, NULL, 'DUF4240', 271535),
(452442, 'PF14129', NULL, 'Domain of unknown function (DUF4296)', 87, NULL, 'DUF4296', 271536),
(452443, 'PF03709', NULL, 'Orn/Lys/Arg decarboxylase, N-terminal domain', 111, NULL, 'OKR_DC_1_N', 271537),
(452444, 'PF19166', NULL, 'Family of unknown function (DUF5848)', 64, NULL, 'DUF5848', 271538),
(452445, 'PF19721', NULL, 'Family of unknown function (DUF6215)', 135, NULL, 'DUF6215', 271539),
(452446, 'PF09881', NULL, 'Predicted membrane protein (DUF2108)', 70, NULL, 'DUF2108', 271540),
(452447, 'PF07298', NULL, 'NnrU protein', 210, NULL, 'NnrU', 271541),
(452448, 'PF00760', NULL, 'Cucumovirus coat protein', 170, NULL, 'Cucumo_coat', 271542),
(452449, 'PF14966', NULL, 'DNA repair REX1-B', 95, NULL, 'DNA_repr_REX1B', 271543),
(452450, 'PF01250', NULL, 'Ribosomal protein S6', 90, NULL, 'Ribosomal_S6', 271544),
(452451, 'PF13638', NULL, 'PIN domain', 131, NULL, 'PIN_4', 271545),
(452452, 'PF19908', NULL, 'Family of unknown function (DUF6381)', 62, NULL, 'DUF6381', 271546),
(452453, 'PF19199', NULL, 'Phage major coat protein, Gp8', 69, NULL, 'Phage_coatGP8', 271547),
(452454, 'PF10088', NULL, 'Uncharacterised protein conserved in bacteria (DUF2326)', 142, NULL, 'DUF2326', 271548),
(452455, 'PF16313', NULL, 'Met-zincin', 321, NULL, 'DUF4953', 271549),
(452456, 'PF02467', NULL, 'Transcription factor WhiB', 64, NULL, 'Whib', 271550),
(452457, 'PF08644', NULL, 'FACT complex subunit (SPT16/CDC68)', 151, NULL, 'SPT16', 271551),
(452458, 'PF19986', NULL, 'Family of unknown function (DUF6422)', 94, NULL, 'DUF6422', 271552),
(452459, 'PF09268', NULL, 'Clathrin, heavy-chain linker', 24, NULL, 'Clathrin-link', 271553),
(452460, 'PF09702', NULL, 'CRISPR-associated protein (Cas_Csa5)', 102, NULL, 'Cas_Csa5', 271554),
(452461, 'PF16854', NULL, 'Vacuolar protein sorting-associated protein 53 C-terminus', 203, NULL, 'VPS53_C', 271555),
(452462, 'PF14814', NULL, 'Bifunctional transglycosylase second domain', 85, NULL, 'UB2H', 271556),
(452463, 'PF19567', NULL, 'Capsular polysaccharide synthesis, CpsB/CapC', 234, NULL, 'CpsB_CapC', 271557),
(452464, 'PF00451', NULL, 'Scorpion short toxin, BmKK2', 32, NULL, 'Toxin_2', 271558);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(452465, 'PF08911', NULL, 'NUP50 (Nucleoporin 50 kDa)', 73, NULL, 'NUP50', 271559),
(452466, 'PF15133', NULL, 'TLR adaptor interacting with SLC15A4 on the lysosome', 304, NULL, 'TASL', 271560),
(452467, 'PF20162', NULL, 'Septation protein etd1', 98, NULL, 'Etd1', 271561),
(452468, 'PF02504', NULL, 'Fatty acid synthesis protein', 324, NULL, 'FA_synthesis', 271562),
(452469, 'PF10959', NULL, 'Protein of unknown function (DUF2761)', 94, NULL, 'DUF2761', 271563),
(452470, 'PF11232', NULL, 'Mediator complex subunit 25 PTOV activation and synapsin 2', 154, NULL, 'Med25', 271564),
(452471, 'PF16216', NULL, 'GxGYxY sequence motif in domain of unknown function N-terminal', 218, NULL, 'GxGYxYP_N', 271565),
(452472, 'PF01085', NULL, 'Hedgehog amino-terminal signalling domain', 161, NULL, 'HH_signal', 271566),
(452473, 'PF02180', NULL, 'Bcl-2 homology region 4', 26, NULL, 'BH4', 271567),
(452474, 'PF09000', NULL, 'Cytotoxic', 82, NULL, 'Cytotoxic', 271568),
(452475, 'PF19706', NULL, 'Family of unknown function (DUF6203)', 54, NULL, 'DUF6203', 271569),
(452476, 'PF17187', NULL, 'Svf1-like C-terminal lipocalin-like domain', 164, NULL, 'Svf1_C', 271570),
(452477, 'PF18484', NULL, 'Cadmium carbonic anhydrase repeat', 184, NULL, 'CDCA', 271571),
(452478, 'PF02263', NULL, 'Guanylate-binding protein, N-terminal domain', 260, NULL, 'GBP', 271572),
(452479, 'PF11272', NULL, 'Protein of unknown function (DUF3072)', 56, NULL, 'DUF3072', 271573),
(452480, 'PF20070', NULL, 'Family of unknown function (DUF6466)', 146, NULL, 'DUF6466', 271574),
(452481, 'PF03769', NULL, 'Attacin, C-terminal region', 120, NULL, 'Attacin_C', 271575),
(452482, 'PF00344', NULL, 'SecY', 308, NULL, 'SecY', 271576),
(452483, 'PF00433', NULL, 'Protein kinase C terminal domain', 46, NULL, 'Pkinase_C', 271577),
(452484, 'PF03136', NULL, 'Pup-ligase protein', 440, NULL, 'Pup_ligase', 271578),
(452485, 'PF16090', NULL, 'Domain of unknown function (DUF4819)', 85, NULL, 'DUF4819', 271579),
(452486, 'PF09782', NULL, 'NADH:ubiquinone oxidoreductase, NDUFB6/B17 subunit', 156, NULL, 'NDUF_B6', 271580),
(452487, 'PF11112', NULL, 'Pyocin activator protein PrtN', 74, NULL, 'PyocinActivator', 271581),
(452488, 'PF14000', NULL, 'DNA packaging protein FI', 131, NULL, 'Packaging_FI', 271582),
(452489, 'PF07675', NULL, 'Cleaved Adhesin Domain', 174, NULL, 'Cleaved_Adhesin', 271583),
(452490, 'PF00620', NULL, 'RhoGAP domain', 149, NULL, 'RhoGAP', 271584),
(452491, 'PF14823', NULL, 'Sirohaem biosynthesis protein C-terminal', 68, NULL, 'Sirohm_synth_C', 271585),
(452492, 'PF18045', NULL, 'ISP3 C-terminal', 110, NULL, 'ISP3_C', 271586),
(452493, 'PF06037', NULL, 'Bacterial protein of unknown function (DUF922)', 159, NULL, 'DUF922', 271587),
(452494, 'PF13612', NULL, 'Transposase DDE domain', 155, NULL, 'DDE_Tnp_1_3', 271588),
(452495, 'PF04773', NULL, 'FecR protein', 97, NULL, 'FecR', 271589),
(452496, 'PF04998', NULL, 'RNA polymerase Rpb1, domain 5', 267, NULL, 'RNA_pol_Rpb1_5', 271590),
(452497, 'PF01329', NULL, 'Pterin 4 alpha carbinolamine dehydratase', 92, NULL, 'Pterin_4a', 271591),
(452498, 'PF05815', NULL, 'Autographa californica nuclear polyhedrosis virus (AcMNPV), Orf101', 352, NULL, 'AcMNPV_Orf101', 271592),
(452499, 'PF00177', NULL, 'Ribosomal protein S7p/S5e', 149, NULL, 'Ribosomal_S7', 271593),
(452500, 'PF11962', NULL, 'Peptidase_G2, IMC autoproteolytic cleavage domain', 228, NULL, 'Peptidase_G2', 271594),
(452501, 'PF19221', NULL, 'MELT motif', 26, NULL, 'MELT', 271595),
(452502, 'PF17163', NULL, 'Domain of unknown function (DUF5125)', 188, NULL, 'DUF5125', 271596),
(452503, 'PF08038', NULL, 'TOM7 family', 41, NULL, 'Tom7', 271597),
(452504, 'PF13404', NULL, 'AsnC-type helix-turn-helix domain', 42, NULL, 'HTH_AsnC-type', 271598),
(452505, 'PF05335', NULL, 'Protein of unknown function (DUF745)', 183, NULL, 'DUF745', 271599),
(452506, 'PF16244', NULL, 'Domain of unknown function (DUF4901)', 228, NULL, 'DUF4901', 271600),
(452507, 'PF16990', NULL, 'Carbohydrate binding module (family 35)', 121, NULL, 'CBM_35', 271601),
(452508, 'PF00589', NULL, 'Phage integrase family', 172, NULL, 'Phage_integrase', 271602);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(452509, 'PF13898', NULL, 'Deubiquitinating enzyme MINDY-3/4, conserved domain', 352, NULL, 'MINDY-3_4_CD', 271603),
(452510, 'PF02222', NULL, 'ATP-grasp domain', 171, NULL, 'ATP-grasp', 271604),
(452511, 'PF09020', NULL, 'YopE, N terminal', 126, NULL, 'YopE_N', 271605),
(452512, 'PF10212', NULL, 'Predicted coiled-coil domain-containing protein', 523, NULL, 'TTKRSYEDQ', 271606),
(452513, 'PF16509', NULL, 'TrfB plasmid transcriptional repressor', 84, NULL, 'KORA', 271607),
(452514, 'PF08189', NULL, 'Meleagrin/Cygnin family', 38, NULL, 'Meleagrin', 271608),
(452515, 'PF19056', NULL, 'WD40 repeated domain', 489, NULL, 'WD40_2', 271609),
(452516, 'PF14429', NULL, 'C2 domain in Dock180 and Zizimin proteins', 188, NULL, 'DOCK-C2', 271610),
(452517, 'PF16830', NULL, 'Nucleotide-Binding Domain 94 of RH', 91, NULL, 'NBD94', 271611),
(452518, 'PF11566', NULL, 'PI31 proteasome regulator N-terminal', 163, NULL, 'PI31_Prot_N', 271612),
(452519, 'PF12725', NULL, 'Protein of unknown function (DUF3810)', 310, NULL, 'DUF3810', 271613),
(452520, 'PF20356', NULL, 'Family of unknown function (DUF6651)', 113, NULL, 'DUF6651', 271614),
(452521, 'PF04332', NULL, 'Protein of unknown function (DUF475)', 295, NULL, 'DUF475', 271615),
(452522, 'PF01562', NULL, 'Reprolysin family propeptide', 140, NULL, 'Pep_M12B_propep', 271616),
(452523, 'PF02262', NULL, 'CBL proto-oncogene N-terminal domain 1', 125, NULL, 'Cbl_N', 271617),
(452524, 'PF20451', NULL, 'Calmodulin binding protein central domain', 67, NULL, 'Calmod_bind_M', 271618),
(452525, 'PF13606', NULL, 'Ankyrin repeat', 31, NULL, 'Ank_3', 271619),
(452526, 'PF18612', NULL, 'Bacterial Alpha amylase C-terminal domain', 69, NULL, 'Bac_A_amyl_C', 271620),
(452527, 'PF11695', NULL, 'Domain of unknown function (DUF3291)', 139, NULL, 'DUF3291', 271621),
(452528, 'PF11116', NULL, 'Protein of unknown function (DUF2624)', 83, NULL, 'DUF2624', 271622),
(452529, 'PF20231', NULL, 'Family of unknown function (DUF6589)', 416, NULL, 'DUF6589', 271623),
(452530, 'PF04926', NULL, 'Poly(A) polymerase predicted RNA binding domain', 187, NULL, 'PAP_RNA-bind', 271624),
(452531, 'PF16712', NULL, 'Coiled-coil regions of plant-specific actin-binding protein', 168, NULL, 'SCAB_CC', 271625),
(452532, 'PF03491', NULL, 'Serotonin (5-HT) neurotransmitter transporter, N-terminus', 41, NULL, '5HT_transport_N', 271626),
(452533, 'PF14642', NULL, 'FAM47 family', 257, NULL, 'FAM47', 271627),
(452534, 'PF04091', NULL, 'Exocyst complex subunit Sec15-like', 316, NULL, 'Sec15', 271628),
(452535, 'PF02244', NULL, 'Carboxypeptidase activation peptide', 73, NULL, 'Propep_M14', 271629),
(452536, 'PF08728', NULL, 'CRT10', 712, NULL, 'CRT10', 271630),
(452537, 'PF18535', NULL, 'Gal11 activator-binding domain (ABD1)', 82, NULL, 'Gal11_ABD1', 271631),
(452538, 'PF15221', NULL, 'Lens epithelial cell protein LEP503', 63, NULL, 'LEP503', 271632),
(452539, 'PF11254', NULL, 'Protein of unknown function (DUF3053)', 220, NULL, 'DUF3053', 271633),
(452540, 'PF12987', NULL, 'Domain of unknown function, B. Theta Gene description (DUF3871)', 318, NULL, 'DUF3871', 271634),
(452541, 'PF08872', NULL, 'KGK domain', 119, NULL, 'KGK', 271635),
(452542, 'PF12866', NULL, 'Protein of unknown function (DUF3823) N-terminal domain', 93, NULL, 'DUF3823', 271636),
(452543, 'PF14275', NULL, 'Domain of unknown function (DUF4362)', 93, NULL, 'DUF4362', 271637),
(452544, 'PF06612', NULL, 'Protein of unknown function (DUF1146)', 48, NULL, 'DUF1146', 271638),
(452545, 'PF14394', NULL, 'Domain of unknown function (DUF4423)', 168, NULL, 'DUF4423', 271639),
(452546, 'PF10346', NULL, 'Conidiation protein 6', 34, NULL, 'Con-6', 271640),
(452547, 'PF18744', NULL, 'Secreted Novel AID/APOBEC-like Deaminase 1', 214, NULL, 'SNAD1', 271641),
(452548, 'PF13194', NULL, 'Domain of unknown function (DUF4010)', 210, NULL, 'DUF4010', 271642),
(452549, 'PF16096', NULL, 'Fragile X-related 1 protein C-terminal region 2', 76, NULL, 'FXR_C1', 271643),
(452550, 'PF05363', NULL, 'Herpesvirus US12 family', 86, NULL, 'Herpes_US12', 271644),
(452551, 'PF09349', NULL, 'OHCU decarboxylase', 156, NULL, 'OHCU_decarbox', 271645);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(452552, 'PF13114', NULL, 'RecO N terminal', 71, NULL, 'RecO_N_2', 271646),
(452553, 'PF12935', NULL, 'Vesicle coat trafficking protein Sec16 N-terminus', 238, NULL, 'Sec16_N', 271647),
(452554, 'PF10312', NULL, 'Conserved mid region of cactin', 192, NULL, 'Cactin_mid', 271648),
(452555, 'PF14075', NULL, 'Ubinuclein conserved middle domain', 212, NULL, 'UBN_AB', 271649),
(452556, 'PF17105', NULL, 'C-terminal domain of bromodomain protein 4', 44, NULL, 'BRD4_CDT', 271650),
(452557, 'PF17637', NULL, 'Family of unknown function (DUF5516)', 37, NULL, 'DUF5516', 271651),
(452558, 'PF16896', NULL, 'Phosphogluconate dehydrogenase (decarboxylating) C-term', 155, NULL, 'PGDH_C', 271652),
(452559, 'PF16828', NULL, 'GAG-binding domain on surface antigen', 152, NULL, 'GAGBD', 271653),
(452560, 'PF04970', NULL, 'Lecithin retinol acyltransferase', 127, NULL, 'LRAT', 271654),
(452561, 'PF13597', NULL, 'Anaerobic ribonucleoside-triphosphate reductase', 566, NULL, 'NRDD', 271655),
(452562, 'PF09627', NULL, 'PrgU-like protein', 106, NULL, 'PrgU', 271656),
(452563, 'PF06757', NULL, 'Insect allergen related repeat, nitrile-specifier detoxification', 183, NULL, 'Ins_allergen_rp', 271657),
(452564, 'PF02765', NULL, 'Telomeric single stranded DNA binding POT1/CDC13', 143, NULL, 'POT1', 271658),
(452565, 'PF07515', NULL, 'Putative conjugal transfer nickase/helicase TraI C-term', 123, NULL, 'TraI_2_C', 271659),
(452566, 'PF13904', NULL, 'Coiled-coil domain-containing protein 3', 220, NULL, 'CCDC34', 271660),
(452567, 'PF06277', NULL, 'Ethanolamine utilisation protein EutA', 475, NULL, 'EutA', 271661),
(452568, 'PF08654', NULL, 'DASH complex subunit Dad2', 99, NULL, 'DASH_Dad2', 271662),
(452569, 'PF10656', NULL, 'Hypothetical protein of unknown function (DUF2483)', 72, NULL, 'DUF2483', 271663),
(452570, 'PF06803', NULL, 'Protein of unknown function (DUF1232)', 37, NULL, 'DUF1232', 271664),
(452571, 'PF05518', NULL, 'Totivirus coat protein', 759, NULL, 'Totivirus_coat', 271665),
(452572, 'PF00306', NULL, 'ATP synthase alpha/beta chain, C terminal domain', 126, NULL, 'ATP-synt_ab_C', 271666),
(452573, 'PF07864', NULL, 'Protein of unknown function (DUF1651)', 74, NULL, 'DUF1651', 271667),
(452574, 'PF14366', NULL, 'Domain of unknown function (DUF4410)', 134, NULL, 'DUF4410', 271668),
(452575, 'PF10890', NULL, 'Cytochrome b-c1 complex subunit 8', 72, NULL, 'Cyt_b-c1_8', 271669),
(452576, 'PF00809', NULL, 'Pterin binding enzyme', 244, NULL, 'Pterin_bind', 271670),
(452577, 'PF12772', NULL, 'Growth hormone receptor binding', 305, NULL, 'GHBP', 271671),
(452578, 'PF07896', NULL, 'Protein of unknown function (DUF1674)', 50, NULL, 'DUF1674', 271672),
(452579, 'PF09655', NULL, 'Conserved nitrate reductase-associated protein (Nitr_red_assoc)', 144, NULL, 'Nitr_red_assoc', 271673),
(452580, 'PF03432', NULL, 'Relaxase/Mobilisation nuclease domain', 242, NULL, 'Relaxase', 271674),
(452581, 'PF08666', NULL, 'SAF domain', 63, NULL, 'SAF', 271675),
(452582, 'PF14061', NULL, 'Polycomb-like MTF2 factor 2', 48, NULL, 'Mtf2_C', 271676),
(452583, 'PF19061', NULL, 'Family of unknown function (DUF5757)', 96, NULL, 'DUF5757', 271677),
(452584, 'PF00237', NULL, 'Ribosomal protein L22p/L17e', 103, NULL, 'Ribosomal_L22', 271678),
(452585, 'PF14123', NULL, 'Domain of unknown function (DUF4290)', 174, NULL, 'DUF4290', 271679),
(452586, 'PF20092', NULL, 'Family of unknown function (DUF6483)', 122, NULL, 'DUF6483', 271680),
(452587, 'PF15375', NULL, 'Domain of unknown function (DUF4602)', 133, NULL, 'DUF4602', 271681),
(452588, 'PF03148', NULL, 'Tektin family', 383, NULL, 'Tektin', 271682),
(452589, 'PF17638', NULL, 'HCMV UL42', 125, NULL, 'UL42', 271683),
(452590, 'PF05460', NULL, 'Origin recognition complex subunit 6 (ORC6)', 357, NULL, 'ORC6', 271684),
(452591, 'PF01427', NULL, 'D-ala-D-ala dipeptidase', 201, NULL, 'Peptidase_M15', 271685),
(452592, 'PF04673', NULL, 'Polyketide synthesis cyclase', 104, NULL, 'Cyclase_polyket', 271686),
(452593, 'PF05159', NULL, 'Capsule polysaccharide biosynthesis protein', 310, NULL, 'Capsule_synth', 271687);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(452594, 'PF12436', NULL, 'ICP0-binding domain of Ubiquitin-specific protease 7', 243, NULL, 'USP7_ICP0_bdg', 271688),
(452595, 'PF12098', NULL, 'Protein of unknown function (DUF3574)', 103, NULL, 'DUF3574', 271689),
(452596, 'PF14585', NULL, 'CagY type 1 repeat', 65, NULL, 'CagY_I', 271690),
(452597, 'PF15494', NULL, 'Scavenger receptor cysteine-rich domain', 99, NULL, 'SRCR_2', 271691),
(452598, 'PF16254', NULL, 'Domain of unknown function (DUF4910)', 246, NULL, 'DUF4910', 271692),
(452599, 'PF19006', NULL, 'Family of unknown function (DUF5735)', 138, NULL, 'DUF5735', 271693),
(452600, 'PF03040', NULL, 'CemA family', 229, NULL, 'CemA', 271694),
(452601, 'PF17867', NULL, 'Midasin AAA lid domain', 107, NULL, 'AAA_lid_7', 271695),
(452602, 'PF18697', NULL, 'Murine leukemia virus (MLV) integrase (IN) C-terminal domain', 84, NULL, 'MLVIN_C', 271696),
(452603, 'PF16524', NULL, 'Periplasmic domain of Sensor histidine kinase RisS', 107, NULL, 'RisS_PPD', 271697),
(452604, 'PF03916', NULL, 'Polysulphide reductase, NrfD', 313, NULL, 'NrfD', 271698),
(452605, 'PF01063', NULL, 'Amino-transferase class IV', 223, NULL, 'Aminotran_4', 271699),
(452606, 'PF14281', NULL, 'PD-(D/E)XK nuclease superfamily', 186, NULL, 'PDDEXK_4', 271700),
(452607, 'PF20013', NULL, 'GTPase-associated protein 1, N-terminal domain type 2', 137, NULL, 'GAP1-N2', 271701),
(452608, 'PF00153', NULL, 'Mitochondrial carrier protein', 97, NULL, 'Mito_carr', 271702),
(452609, 'PF10452', NULL, 'TORC1 subunit TCO89', 596, NULL, 'TCO89', 271703),
(452610, 'PF00885', NULL, '6,7-dimethyl-8-ribityllumazine synthase', 141, NULL, 'DMRL_synthase', 271704),
(452611, 'PF16273', NULL, 'Nuclear distribution C domain', 66, NULL, 'NuDC', 271705),
(452612, 'PF08896', NULL, 'Domain of unknown function (DUF1842)', 113, NULL, 'DUF1842', 271706),
(452613, 'PF06842', NULL, 'Protein of unknown function (DUF1242)', 35, NULL, 'DUF1242', 271707),
(452614, 'PF16211', NULL, 'C-terminus of histone H2A', 35, NULL, 'Histone_H2A_C', 271708),
(452615, 'PF02893', NULL, 'GRAM domain', 114, NULL, 'GRAM', 271709),
(452616, 'PF01401', NULL, 'Angiotensin-converting enzyme', 581, NULL, 'Peptidase_M2', 271710),
(452617, 'PF16761', NULL, 'Transcription-silencing protein, cryptic loci regulator Clr2', 68, NULL, 'Clr2_transil', 271711),
(452618, 'PF01786', NULL, 'Alternative oxidase', 216, NULL, 'AOX', 271712),
(452619, 'PF15792', NULL, 'Lung adenoma susceptibility protein 2', 74, NULL, 'LAS2', 271713),
(452620, 'PF13710', NULL, 'ACT domain', 62, NULL, 'ACT_5', 271714),
(452621, 'PF13681', NULL, 'Type IV pilus assembly protein PilX C-term', 88, NULL, 'PilX', 271715),
(452622, 'PF03779', NULL, 'SPW repeat', 48, NULL, 'SPW', 271716),
(452623, 'PF09064', NULL, 'Thrombomodulin like fifth domain, EGF-like', 34, NULL, 'Tme5_EGF_like', 271717),
(452624, 'PF18505', NULL, 'Domain of unknown function (DUF5619)', 85, NULL, 'DUF5619', 271718),
(452625, 'PF13817', NULL, 'IS66 C-terminal element', 39, NULL, 'DDE_Tnp_IS66_C', 271719),
(452626, 'PF15793', NULL, 'Protein family FAM35, C-terminal', 176, NULL, 'FAM35_C', 271720),
(452627, 'PF06994', NULL, 'Involucrin', 41, NULL, 'Involucrin2', 271721),
(452628, 'PF06903', NULL, 'VirK protein', 98, NULL, 'VirK', 271722),
(452629, 'PF15316', NULL, 'MyoD family inhibitor', 171, NULL, 'MDFI', 271723),
(452630, 'PF19615', NULL, 'Family of unknown function (DUF6120)', 92, NULL, 'DUF6120', 271724),
(452631, 'PF04490', NULL, 'Poxvirus T4 protein, C terminus', 146, NULL, 'Pox_T4_C', 271725),
(452632, 'PF13724', NULL, 'DNA-binding domain', 47, NULL, 'DNA_binding_2', 271726),
(452633, 'PF16797', NULL, 'Fungal kinase associated-1 domain', 117, NULL, 'Fungal_KA1', 271727),
(452634, 'PF08434', NULL, 'Calcium-activated chloride channel N terminal', 266, NULL, 'CLCA', 271728),
(452635, 'PF14956', NULL, 'Domain of unknown function (DUF4505)', 178, NULL, 'DUF4505', 271729),
(452636, 'PF19131', NULL, 'Family of unknown function (DUF5814)', 148, NULL, 'DUF5814', 271730),
(452637, 'PF10093', NULL, 'Elongation-Factor P (EF-P) rhamnosyltransferase EarP', 373, NULL, 'EarP', 271731);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(452638, 'PF15698', NULL, 'Phosphatase', 256, NULL, 'Phosphatase', 271732),
(452639, 'PF13903', NULL, 'PMP-22/EMP/MP20/Claudin tight junction', 193, NULL, 'Claudin_2', 271733),
(452640, 'PF02978', NULL, 'Signal peptide binding domain', 101, NULL, 'SRP_SPB', 271734),
(452641, 'PF15537', NULL, 'Bacterial toxin 43', 123, NULL, 'Ntox43', 271735),
(452642, 'PF19547', NULL, 'Family of unknown function (DUF6071)', 223, NULL, 'DUF6071', 271736),
(452643, 'PF02934', NULL, 'GatB/GatE catalytic domain', 273, NULL, 'GatB_N', 271737),
(452644, 'PF04856', NULL, 'Securin sister-chromatid separation inhibitor', 232, NULL, 'Securin', 271738),
(452645, 'PF08122', NULL, 'NADH-ubiquinone oxidoreductase B12 subunit family', 55, NULL, 'NDUF_B12', 271739),
(452646, 'PF11654', NULL, 'Non-classical export protein 1', 45, NULL, 'NCE101', 271740),
(452647, 'PF18761', NULL, 'Heliorhodopsin', 242, NULL, 'Heliorhodopsin', 271741),
(452648, 'PF08472', NULL, 'Sucrose-6-phosphate phosphohydrolase C-terminal', 133, NULL, 'S6PP_C', 271742),
(452649, 'PF06256', NULL, 'Nucleopolyhedrovirus LEF-12 protein', 173, NULL, 'Nucleo_LEF-12', 271743),
(452650, 'PF07295', NULL, 'Zinc-ribbon containing domain', 147, NULL, 'DUF1451', 271744),
(452651, 'PF05050', NULL, 'Methyltransferase FkbM domain', 173, NULL, 'Methyltransf_21', 271745),
(452652, 'PF06618', NULL, 'Protein of unknown function (DUF1148)', 114, NULL, 'DUF1148', 271746),
(452653, 'PF11856', NULL, 'Protein of unknown function (DUF3376)', 499, NULL, 'DUF3376', 271747),
(452654, 'PF11428', NULL, 'Protein of unknown function (DUF3196)', 285, NULL, 'DUF3196', 271748),
(452655, 'PF13116', NULL, 'Protein of unknown function', 289, NULL, 'DUF3971', 271749),
(452656, 'PF09997', NULL, 'Predicted membrane protein (DUF2238)', 140, NULL, 'DUF2238', 271750),
(452657, 'PF09150', NULL, 'Orange carotenoid protein, N-terminal', 151, NULL, 'Carot_N', 271751),
(452658, 'PF03808', NULL, 'Glycosyl transferase WecG/TagA/CpsF family', 168, NULL, 'Glyco_tran_WecG', 271752),
(452659, 'PF10179', NULL, 'Neuron-derived neurotrophic factor, first Fn(III) domain', 132, NULL, 'NDNF', 271753),
(452660, 'PF14200', NULL, 'Ricin-type beta-trefoil lectin domain-like', 89, NULL, 'RicinB_lectin_2', 271754),
(452661, 'PF14614', NULL, 'Domain of unknown function (DUF4450)', 216, NULL, 'DUF4450', 271755),
(452662, 'PF00392', NULL, 'Bacterial regulatory proteins, gntR family', 64, NULL, 'GntR', 271756),
(452663, 'PF01470', NULL, 'Pyroglutamyl peptidase', 204, NULL, 'Peptidase_C15', 271757),
(452664, 'PF11227', NULL, 'Protein of unknown function (DUF3025)', 210, NULL, 'DUF3025', 271758),
(452665, 'PF17813', NULL, 'RET Cadherin like domain 4', 105, NULL, 'RET_CLD4', 271759),
(452666, 'PF17507', NULL, 'Family of unknown function (DUF5439)', 75, NULL, 'DUF5439', 271760),
(452667, 'PF02729', NULL, 'Aspartate/ornithine carbamoyltransferase, carbamoyl-P binding domain', 146, NULL, 'OTCace_N', 271761),
(452668, 'PF00143', NULL, 'Interferon alpha/beta domain', 160, NULL, 'Interferon', 271762),
(452669, 'PF11500', NULL, 'Cut12 conserved domain', 146, NULL, 'Cut12', 271763),
(452670, 'PF16177', NULL, 'Acetyl-coenzyme A synthetase N-terminus', 55, NULL, 'ACAS_N', 271764),
(452671, 'PF04602', NULL, 'Mycobacterial cell wall arabinan synthesis protein', 459, NULL, 'Arabinose_trans', 271765),
(452672, 'PF04031', NULL, 'Las1-like', 149, NULL, 'Las1', 271766),
(452673, 'PF01669', NULL, 'Myelin basic protein', 147, NULL, 'Myelin_MBP', 271767),
(452674, 'PF01705', NULL, 'CX module', 59, NULL, 'CX', 271768),
(452675, 'PF18811', NULL, 'Dipeptidyl peptidase IV (DPP IV) low complexity region', 21, NULL, 'DPPIV_rep', 271769),
(452676, 'PF20533', NULL, 'Domain of unknown function (DUF6748)', 199, NULL, 'DUF6748', 271770),
(452677, 'PF05254', NULL, 'Uncharacterised protein family (UPF0203)', 69, NULL, 'UPF0203', 271771),
(452678, 'PF14243', NULL, 'ATP-grasp domain, R2K clade family 3', 201, NULL, 'R2K_3', 271772),
(452679, 'PF05310', NULL, 'Tenuivirus movement protein', 186, NULL, 'Tenui_NS3', 271773),
(452680, 'PF17513', NULL, 'Family of unknown function (DUF5441)', 189, NULL, 'DUF5441', 271774);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(452681, 'PF03212', NULL, 'Pertactin', 121, NULL, 'Pertactin', 271775),
(452682, 'PF19411', NULL, 'Cell cycle link protein Clink', 141, NULL, 'Clink', 271776),
(452683, 'PF00471', NULL, 'Ribosomal protein L33', 47, NULL, 'Ribosomal_L33', 271777),
(452684, 'PF06689', NULL, 'ClpX C4-type zinc finger', 39, NULL, 'zf-C4_ClpX', 271778),
(452685, 'PF20293', NULL, 'ABC-three component (ABC-3C) system Middle Component 6', 76, NULL, 'MC6', 271779),
(452686, 'PF14224', NULL, 'Domain of unknown function (DUF4331)', 416, NULL, 'DUF4331', 271780),
(452687, 'PF08488', NULL, 'Wall-associated kinase', 103, NULL, 'WAK', 271781),
(452688, 'PF19413', NULL, 'YaiO membrane beta barrel domain', 173, NULL, 'YaiO', 271782),
(452689, 'PF00717', NULL, 'Peptidase S24-like', 116, NULL, 'Peptidase_S24', 271783),
(452690, 'PF05830', NULL, 'Nodulation protein Z (NodZ)', 320, NULL, 'NodZ', 271784),
(452691, 'PF12327', NULL, 'FtsZ family, C-terminal domain', 95, NULL, 'FtsZ_C', 271785),
(452692, 'PF08468', NULL, 'Methyltransferase small domain N-terminal', 157, NULL, 'MTS_N', 271786),
(452693, 'PF19156', NULL, 'Family of unknown function (DUF5838)', 289, NULL, 'DUF5838', 271787),
(452694, 'PF07217', NULL, 'Heterokaryon incompatibility protein Het-C', 561, NULL, 'Het-C', 271788),
(452695, 'PF07536', NULL, 'HWE histidine kinase', 83, NULL, 'HWE_HK', 271789),
(452696, 'PF00836', NULL, 'Stathmin family', 136, NULL, 'Stathmin', 271790),
(452697, 'PF08980', NULL, 'Domain of unknown function (DUF1883)', 89, NULL, 'DUF1883', 271791),
(452698, 'PF16360', NULL, 'GTP-binding GTPase Middle Region', 79, NULL, 'GTP-bdg_M', 271792),
(452699, 'PF16330', NULL, 'MukB hinge domain', 167, NULL, 'MukB_hinge', 271793),
(452700, 'PF04008', NULL, 'Adenosine specific kinase', 154, NULL, 'Adenosine_kin', 271794),
(452701, 'PF08301', NULL, 'Hepatitis C virus non-structural 5a domain 1b', 102, NULL, 'HCV_NS5a_1b', 271795),
(452702, 'PF02447', NULL, 'GntP family permease', 440, NULL, 'GntP_permease', 271796),
(452703, 'PF03998', NULL, 'Utp11 protein', 247, NULL, 'Utp11', 271797),
(452704, 'PF16675', NULL, 'KIX-binding domain of forkhead box O, CR2', 81, NULL, 'FOXO_KIX_bdg', 271798),
(452705, 'PF11622', NULL, 'Protein of unknown function (DUF3251)', 165, NULL, 'DUF3251', 271799),
(452706, 'PF16525', NULL, 'Haemophore, haem-binding', 77, NULL, 'MHB', 271800),
(452707, 'PF15947', NULL, 'Domain of unknown function (DUF4755)', 128, NULL, 'DUF4755', 271801),
(452708, 'PF12306', NULL, 'Inclusion body protein', 165, NULL, 'PixA', 271802),
(452709, 'PF19229', NULL, 'Family of unknown function (DUF5882)', 198, NULL, 'DUF5882', 271803),
(452710, 'PF17453', NULL, 'Sigma-M inhibitor', 96, NULL, 'Sigma_M_inh', 271804),
(452711, 'PF13078', NULL, 'Protein of unknown function (DUF3942)', 137, NULL, 'DUF3942', 271805),
(452712, 'PF00854', NULL, 'POT family', 397, NULL, 'PTR2', 271806),
(452713, 'PF16269', NULL, 'Domain of unknown function (DUF4922)', 146, NULL, 'DUF4922', 271807),
(452714, 'PF00921', NULL, 'Borrelia lipoprotein', 296, NULL, 'Lipoprotein_2', 271808),
(452715, 'PF01964', NULL, 'Radical SAM ThiC family', 418, NULL, 'ThiC_Rad_SAM', 271809),
(452716, 'PF09261', NULL, 'Alpha mannosidase middle domain', 96, NULL, 'Alpha-mann_mid', 271810),
(452717, 'PF07794', NULL, 'Protein of unknown function (DUF1633)', 790, NULL, 'DUF1633', 271811),
(452718, 'PF12480', NULL, 'Protein of unknown function (DUF3699)', 71, NULL, 'DUF3699', 271812),
(452719, 'PF00830', NULL, 'Ribosomal L28 family', 60, NULL, 'Ribosomal_L28', 271813),
(452720, 'PF15327', NULL, 'Tankyrase binding protein C terminal domain', 171, NULL, 'Tankyrase_bdg_C', 271814),
(452721, 'PF01366', NULL, 'Herpesvirus processing and transport protein', 659, NULL, 'PRTP', 271815),
(452722, 'PF07405', NULL, 'Protein of unknown function (DUF1506)', 127, NULL, 'DUF1506', 271816),
(452723, 'PF01835', NULL, 'MG2 domain', 96, NULL, 'MG2', 271817),
(452724, 'PF20615', NULL, 'Family of unknown function (DUF6802)', 102, NULL, 'DUF6802', 271818),
(452725, 'PF10863', NULL, 'Nucleolar protein 19', 142, NULL, 'NOP19', 271819);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(452726, 'PF00027', NULL, 'Cyclic nucleotide-binding domain', 89, NULL, 'cNMP_binding', 271820),
(452727, 'PF10653', NULL, 'Protein gp45 of Bacteriophage A118', 62, NULL, 'Phage-A118_gp45', 271821),
(452728, 'PF10078', NULL, 'Uncharacterized protein conserved in bacteria (DUF2316)', 89, NULL, 'DUF2316', 271822),
(452729, 'PF13893', NULL, 'RNA recognition motif. (a.k.a. RRM, RBD, or RNP domain)', 125, NULL, 'RRM_5', 271823),
(452730, 'PF16365', NULL, 'Ethanolamine utilization protein EutK C-terminus', 55, NULL, 'EutK_C', 271824),
(452731, 'PF19684', NULL, 'Family of unknown function (DUF6186)', 37, NULL, 'DUF6186', 271825),
(452732, 'PF03428', NULL, 'Replication protein C N-terminal domain', 175, NULL, 'RP-C', 271826),
(452733, 'PF04997', NULL, 'RNA polymerase Rpb1, domain 1', 312, NULL, 'RNA_pol_Rpb1_1', 271827),
(452734, 'PF11780', NULL, 'Protein of unknown function (DUF3318)', 143, NULL, 'DUF3318', 271828),
(452735, 'PF18941', NULL, 'Family of unknown function (DUF5688)', 290, NULL, 'DUF5688', 271829),
(452736, 'PF13627', NULL, 'Prokaryotic lipoprotein-attachment site', 23, NULL, 'LPAM_2', 271830),
(452737, 'PF19092', NULL, 'Family of unknown function (DUF5780)', 111, NULL, 'DUF5780', 271831),
(452738, 'PF05124', NULL, 'S-layer like family, C-terminal region', 220, NULL, 'S_layer_C', 271832),
(452739, 'PF17433', NULL, 'Glycosyl hydrolase family 49 N-terminal Ig-like domain', 188, NULL, 'Glyco_hydro_49N', 271833),
(452740, 'PF01154', NULL, 'Hydroxymethylglutaryl-coenzyme A synthase N terminal', 174, NULL, 'HMG_CoA_synt_N', 271834),
(452741, 'PF10841', NULL, 'Protein of unknown function (DUF2644)', 59, NULL, 'DUF2644', 271835),
(452742, 'PF15797', NULL, 'Domain of unknown function (DUF4706)', 107, NULL, 'DUF4706', 271836),
(452743, 'PF20504', NULL, 'Integrator complex subunit 14, alpha-helical domain', 104, NULL, 'IntS14_C', 271837),
(452744, 'PF11805', NULL, 'Protein of unknown function (DUF3326)', 337, NULL, 'DUF3326', 271838),
(452745, 'PF12873', NULL, 'Domain of unknown function (DUF3825)', 240, NULL, 'DUF3825', 271839),
(452746, 'PF04769', NULL, 'Mating-type protein MAT alpha 1 HMG-box', 194, NULL, 'MATalpha_HMGbox', 271840),
(452747, 'PF08828', NULL, 'Doublesex dimerisation domain', 49, NULL, 'DSX_dimer', 271841),
(452748, 'PF13878', NULL, 'zinc-finger of acetyl-transferase ESCO', 40, NULL, 'zf-C2H2_3', 271842),
(452749, 'PF19698', NULL, 'Family of unknown function (DUF6197)', 143, NULL, 'DUF6197', 271843),
(452750, 'PF18881', NULL, 'Family of unknown function (DUF5646)', 69, NULL, 'DUF5646', 271844),
(452751, 'PF04258', NULL, 'Signal peptide peptidase', 284, NULL, 'Peptidase_A22B', 271845),
(452752, 'PF13683', NULL, 'Integrase core domain', 67, NULL, 'rve_3', 271846),
(452753, 'PF06875', NULL, 'Plethodontid receptivity factor PRF', 214, NULL, 'PRF', 271847),
(452754, 'PF13436', NULL, 'Glycine-zipper domain', 44, NULL, 'Gly-zipper_OmpA', 271848),
(452755, 'PF15783', NULL, 'Fibrous sheath-interacting protein 2', 875, NULL, 'FSIP2', 271849),
(452756, 'PF14452', NULL, 'Multiubiquitin', 69, NULL, 'Multi_ubiq', 271850),
(452757, 'PF00129', NULL, 'Class I Histocompatibility antigen, domains alpha 1 and 2', 179, NULL, 'MHC_I', 271851),
(452758, 'PF00146', NULL, 'NADH dehydrogenase', 299, NULL, 'NADHdh', 271852),
(452759, 'PF05125', NULL, 'Phage major capsid protein, P2 family', 327, NULL, 'Phage_cap_P2', 271853),
(452760, 'PF18978', NULL, 'Family of unknown function (DUF5714)', 174, NULL, 'DUF5714', 271854),
(452761, 'PF13360', NULL, 'PQQ-like domain', 237, NULL, 'PQQ_2', 271855),
(452762, 'PF08653', NULL, 'DASH complex subunit Dam1', 56, NULL, 'DASH_Dam1', 271856),
(452763, 'PF15345', NULL, 'Transmembrane protein 51', 238, NULL, 'TMEM51', 271857),
(452764, 'PF00909', NULL, 'Ammonium Transporter Family', 399, NULL, 'Ammonium_transp', 271858),
(452765, 'PF04424', NULL, 'MINDY deubiquitinase', 117, NULL, 'MINDY_DUB', 271859),
(452766, 'PF09733', NULL, 'VEFS-Box of polycomb protein', 137, NULL, 'VEFS-Box', 271860),
(452767, 'PF05069', NULL, 'Phage virion morphogenesis family', 148, NULL, 'Phage_tail_S', 271861);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(452768, 'PF08968', NULL, 'Domain of unknown function (DUF1885)', 132, NULL, 'DUF1885', 271862),
(452769, 'PF11440', NULL, 'DNA alpha-glucosyltransferase', 355, NULL, 'AGT', 271863),
(452770, 'PF05598', NULL, 'Transposase domain (DUF772)', 73, NULL, 'DUF772', 271864),
(452771, 'PF01492', NULL, 'Geminivirus C4 protein', 84, NULL, 'Gemini_C4', 271865),
(452772, 'PF15912', NULL, 'Virilizer, N-terminal', 265, NULL, 'VIR_N', 271866),
(452773, 'PF03642', NULL, 'MAP domain', 88, NULL, 'MAP', 271867),
(452774, 'PF04037', NULL, 'Domain of unknown function (DUF382)', 127, NULL, 'DUF382', 271868),
(452775, 'PF17228', NULL, 'Sulphur globule protein', 97, NULL, 'SGP', 271869),
(452776, 'PF11282', NULL, 'Protein of unknown function (DUF3082)', 80, NULL, 'DUF3082', 271870),
(452777, 'PF19820', NULL, 'Family of unknown function (DUF6303)', 93, NULL, 'DUF6303', 271871),
(452778, 'PF02343', NULL, 'TRA-1 regulated protein R03H10.4', 130, NULL, 'TRA-1_regulated', 271872),
(452779, 'PF18358', NULL, 'Histone methyltransferase Tudor domain', 50, NULL, 'Tudor_4', 271873),
(452780, 'PF09307', NULL, 'CLIP, MHC2 interacting', 109, NULL, 'MHC2-interact', 271874),
(452781, 'PF02064', NULL, 'MAS20 protein import receptor', 132, NULL, 'MAS20', 271875),
(452782, 'PF00618', NULL, 'RasGEF N-terminal motif', 105, NULL, 'RasGEF_N', 271876),
(452783, 'PF16156', NULL, 'Domain of unknown function (DUF4864)', 101, NULL, 'DUF4864', 271877),
(452784, 'PF11903', NULL, 'ParD-like antitoxin of type II bacterial toxin-antitoxin system', 73, NULL, 'ParD_like', 271878),
(452785, 'PF00609', NULL, 'Diacylglycerol kinase accessory domain', 160, NULL, 'DAGK_acc', 271879),
(452786, 'PF13845', NULL, 'Septum formation', 226, NULL, 'Septum_form', 271880),
(452787, 'PF09311', NULL, 'Rabaptin-like protein', 307, NULL, 'Rab5-bind', 271881),
(452788, 'PF03997', NULL, 'VPS28 protein', 190, NULL, 'VPS28', 271882),
(452789, 'PF12090', NULL, 'Spt20 family', 183, NULL, 'Spt20', 271883),
(452790, 'PF01775', NULL, 'Ribosomal proteins 50S-L18Ae/60S-L20/60S-L18A', 121, NULL, 'Ribosomal_L18A', 271884),
(452791, 'PF09700', NULL, 'CRISPR-associated protein (Cas_Cmr3)', 372, NULL, 'Cas_Cmr3', 271885),
(452792, 'PF05628', NULL, 'Borrelia membrane protein P13', 138, NULL, 'Borrelia_P13', 271886),
(452793, 'PF14867', NULL, 'Lantibiotic alpha', 29, NULL, 'Lantibiotic_a', 271887),
(452794, 'PF13010', NULL, 'Primase helical domain', 136, NULL, 'pRN1_helical', 271888),
(452795, 'PF16013', NULL, 'Domain of unknown function (DUF4781)', 310, NULL, 'DUF4781', 271889),
(452796, 'PF17195', NULL, 'Protein of unknown function (DUF5132)', 47, NULL, 'DUF5132', 271890),
(452797, 'PF14901', NULL, 'Cleavage inducing molecular chaperone', 93, NULL, 'Jiv90', 271891),
(452798, 'PF15538', NULL, 'Bacterial toxin 46', 157, NULL, 'Ntox46', 271892),
(452799, 'PF07250', NULL, 'Glyoxal oxidase N-terminus', 243, NULL, 'Glyoxal_oxid_N', 271893),
(452800, 'PF16431', NULL, 'Domain of unknown function (DUF5028)', 166, NULL, 'DUF5028', 271894),
(452801, 'PF19875', NULL, 'Family of unknown function (DUF6348)', 194, NULL, 'DUF6348', 271895),
(452802, 'PF17493', NULL, 'Family of unknown function (DUF5428)', 63, NULL, 'DUF5428', 271896),
(452803, 'PF10115', NULL, 'Transcriptional activator HlyU', 91, NULL, 'HlyU', 271897),
(452804, 'PF17260', NULL, 'Family of unknown function (DUF5326)', 70, NULL, 'DUF5326', 271898),
(452805, 'PF07971', NULL, 'Glycosyl hydrolase family 92', 462, NULL, 'Glyco_hydro_92', 271899),
(452806, 'PF12741', NULL, 'Susd and RagB outer membrane lipoprotein', 496, NULL, 'SusD-like', 271900),
(452807, 'PF19139', NULL, 'Family of unknown function (DUF5822)', 38, NULL, 'DUF5822', 271901),
(452808, 'PF07467', NULL, 'Beta-lactamase inhibitor (BLIP)', 123, NULL, 'BLIP', 271902),
(452809, 'PF19916', NULL, 'vWA-MoxR associated protein middle region 0', 104, NULL, 'VMAP-M0', 271903),
(452810, 'PF13558', NULL, 'SbcC/RAD50-like, Walker B motif', 90, NULL, 'SbcC_Walker_B', 271904),
(452811, 'PF11676', NULL, 'Protein of unknown function (DUF3272)', 61, NULL, 'DUF3272', 271905),
(452812, 'PF00954', NULL, 'S-locus glycoprotein domain', 111, NULL, 'S_locus_glycop', 271906);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(452813, 'PF16305', NULL, 'Domain of unknown function (DUF4947)', 167, NULL, 'DUF4947', 271907),
(452814, 'PF09686', NULL, 'Plasmid protein of unknown function (Plasmid_RAQPRD)', 76, NULL, 'Plasmid_RAQPRD', 271908),
(452815, 'PF14661', NULL, 'HAUS augmin-like complex subunit 6 N-terminus', 234, NULL, 'HAUS6_N', 271909),
(452816, 'PF08660', NULL, 'Oligosaccharide biosynthesis protein Alg14 like', 175, NULL, 'Alg14', 271910),
(452817, 'PF07319', NULL, 'Primosomal protein DnaI N-terminus', 94, NULL, 'DnaI_N', 271911),
(452818, 'PF15111', NULL, 'TMEM101 protein family', 249, NULL, 'TMEM101', 271912),
(452819, 'PF01688', NULL, 'Alphaherpesvirus glycoprotein I', 155, NULL, 'Herpes_gI', 271913),
(452820, 'PF11790', NULL, 'Glycosyl hydrolase catalytic core', 239, NULL, 'Glyco_hydro_cc', 271914),
(452821, 'PF12778', NULL, 'PXPV repeat (3 copies)', 22, NULL, 'PXPV', 271915),
(452822, 'PF15572', NULL, 'Immunity protein 45', 100, NULL, 'Imm45', 271916),
(452823, 'PF05341', NULL, 'Per os infectivity factor 6', 106, NULL, 'PIF6', 271917),
(452824, 'PF05220', NULL, 'MgpC adhesin', 226, NULL, 'MgpC', 271918),
(452825, 'PF03834', NULL, 'Binding domain of DNA repair protein Ercc1 (rad10/Swi10)', 116, NULL, 'Rad10', 271919),
(452826, 'PF20449', NULL, 'Family of unknown function (DUF6706)', 108, NULL, 'DUF6706', 271920),
(452827, 'PF05323', NULL, 'Poxvirus A21 Protein', 111, NULL, 'Pox_A21', 271921),
(452828, 'PF14950', NULL, 'Domain of unknown function (DUF4502)', 382, NULL, 'DUF4502', 271922),
(452829, 'PF18794', NULL, 'DNA mismatch repair protein HSM3, C terminal domain', 177, NULL, 'HSM3_C', 271923),
(452830, 'PF19517', NULL, 'Family of unknown function (DUF6050)', 116, NULL, 'DUF6050', 271924),
(452831, 'PF19744', NULL, 'Family of unknown function (DUF6232)', 117, NULL, 'DUF6232', 271925),
(452832, 'PF00398', NULL, 'Ribosomal RNA adenine dimethylase', 265, NULL, 'RrnaAD', 271926),
(452833, 'PF08014', NULL, 'Domain of unknown function (DUF1704)', 365, NULL, 'DUF1704', 271927),
(452834, 'PF04900', NULL, 'Fcf1', 99, NULL, 'Fcf1', 271928),
(452835, 'PF07815', NULL, 'Abl-interactor HHR', 77, NULL, 'Abi_HHR', 271929),
(452836, 'PF18221', NULL, 'Mutator 2 Fork head associated domain', 94, NULL, 'MU2_FHA', 271930),
(452837, 'PF16484', NULL, 'Carnitine O-palmitoyltransferase N-terminus', 47, NULL, 'CPT_N', 271931),
(452838, 'PF20297', NULL, 'MutS2 and Smr-associated SH3 domain', 42, NULL, 'MSSS', 271932),
(452839, 'PF09298', NULL, 'Fumarylacetoacetase N-terminal', 106, NULL, 'FAA_hydrolase_N', 271933),
(452840, 'PF00661', NULL, 'Viral matrix protein', 340, NULL, 'Matrix', 271934),
(452841, 'PF02256', NULL, 'Iron hydrogenase small subunit', 56, NULL, 'Fe_hyd_SSU', 271935),
(452842, 'PF20347', NULL, 'Family of unknown function (DUF6642)', 188, NULL, 'DUF6642', 271936),
(452843, 'PF16543', NULL, 'DRG Family Regulatory Proteins, Tma46', 89, NULL, 'DFRP_C', 271937),
(452844, 'PF09439', NULL, 'Signal recognition particle receptor beta subunit', 181, NULL, 'SRPRB', 271938),
(452845, 'PF19606', NULL, 'Family of unknown function (DUF6111)', 87, NULL, 'DUF6111', 271939),
(452846, 'PF08049', NULL, 'IlvB leader peptide', 32, NULL, 'IlvB_leader', 271940),
(452847, 'PF14499', NULL, 'Domain of unknown function (DUF4437)', 250, NULL, 'DUF4437', 271941),
(452848, 'PF19259', NULL, 'Ty3 transposon capsid-like protein', 198, NULL, 'Ty3_capsid', 271942),
(452849, 'PF18760', NULL, 'ADP-Ribosyltransferase in polyvalent proteins', 140, NULL, 'ART-PolyVal', 271943),
(452850, 'PF14330', NULL, 'Domain of unknown function (DUF4387)', 98, NULL, 'DUF4387', 271944),
(452851, 'PF07697', NULL, '7TM-HD extracellular', 220, NULL, '7TMR-HDED', 271945),
(452852, 'PF13889', NULL, 'Chromosome segregation during meiosis', 55, NULL, 'Chromosome_seg', 271946),
(452853, 'PF12978', NULL, 'Domain of Unknown Function with PDB structure (DUF3862)', 159, NULL, 'DUF3862', 271947),
(452854, 'PF01041', NULL, 'DegT/DnrJ/EryC1/StrS aminotransferase family', 360, NULL, 'DegT_DnrJ_EryC1', 271948),
(452855, 'PF09112', NULL, 'Peptide-N-glycosidase F, N terminal', 173, NULL, 'N-glycanase_N', 271949);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(452856, 'PF14980', NULL, 'TIP39 peptide', 51, NULL, 'TIP39', 271950),
(452857, 'PF16409', NULL, 'Domain of unknown function (DUF5017)', 182, NULL, 'DUF5017', 271951),
(452858, 'PF10150', NULL, 'Ribonuclease E/G family', 270, NULL, 'RNase_E_G', 271952),
(452859, 'PF12712', NULL, 'Domain of unknown function (DUF3805)', 152, NULL, 'DUF3805', 271953),
(452860, 'PF00353', NULL, 'RTX calcium-binding nonapeptide repeat (4 copies)', 36, NULL, 'HemolysinCabind', 271954),
(452861, 'PF11151', NULL, 'Protein of unknown function (DUF2929)', 56, NULL, 'DUF2929', 271955),
(452862, 'PF14036', NULL, 'YlaH-like protein', 76, NULL, 'YlaH', 271956),
(452863, 'PF09222', NULL, 'Fimbrial adhesin F17-AG, lectin domain', 171, NULL, 'Fim-adh_lectin', 271957),
(452864, 'PF17215', NULL, 'S1 domain', 89, NULL, 'Rrp44_S1', 271958),
(452865, 'PF15737', NULL, 'Domain of unknown function (DUF4685)', 125, NULL, 'DUF4685', 271959),
(452866, 'PF17127', NULL, 'Domain of unknown function (DUF5106)', 153, NULL, 'DUF5106', 271960),
(452867, 'PF07137', NULL, 'VDE lipocalin domain', 237, NULL, 'VDE', 271961),
(452868, 'PF16278', NULL, 'C2HE / C2H2 / C2HC zinc-binding finger', 63, NULL, 'zf-C2HE', 271962),
(452869, 'PF08254', NULL, 'Threonine leader peptide', 22, NULL, 'Leader_Thr', 271963),
(452870, 'PF00383', NULL, 'Cytidine and deoxycytidylate deaminase zinc-binding region', 101, NULL, 'dCMP_cyt_deam_1', 271964),
(452871, 'PF08482', NULL, 'ATP-dependent helicase C-terminal', 134, NULL, 'HrpB_C', 271965),
(452872, 'PF08109', NULL, 'Lactocin 705 family', 31, NULL, 'Antimicrobial14', 271966),
(452873, 'PF19468', NULL, 'Family of unknown function (DUF6005)', 327, NULL, 'DUF6005', 271967),
(452874, 'PF03641', NULL, 'Possible lysine decarboxylase', 132, NULL, 'Lysine_decarbox', 271968),
(452875, 'PF02431', NULL, 'Chalcone-flavanone isomerase', 203, NULL, 'Chalcone', 271969),
(452876, 'PF05359', NULL, 'Domain of Unknown Function (DUF748)', 152, NULL, 'DUF748', 271970),
(452877, 'PF17283', NULL, 'SprT-like zinc ribbon domain', 38, NULL, 'Zn_ribbon_SprT', 271971),
(452878, 'PF06356', NULL, 'Protein of unknown function (DUF1064)', 117, NULL, 'DUF1064', 271972),
(452879, 'PF08421', NULL, 'Putative zinc binding domain', 62, NULL, 'Methyltransf_13', 271973),
(452880, 'PF13324', NULL, 'Grap2 and cyclin-D-interacting', 263, NULL, 'GCIP', 271974),
(452881, 'PF11015', NULL, 'Protein of unknown function (DUF2853)', 101, NULL, 'DUF2853', 271975),
(452882, 'PF12116', NULL, 'Stage III sporulation protein D', 82, NULL, 'SpoIIID', 271976),
(452883, 'PF19954', NULL, 'Effector-associated domain 10', 77, NULL, 'EAD10', 271977),
(452884, 'PF09065', NULL, 'Haemadin', 27, NULL, 'Haemadin', 271978),
(452885, 'PF09318', NULL, 'Glycosyl transferase 1 domain A', 199, NULL, 'Glyco_trans_A_1', 271979),
(452886, 'PF04155', NULL, 'Ground-like domain', 73, NULL, 'Ground-like', 271980),
(452887, 'PF09043', NULL, 'D-Lysine 5,6-aminomutase TIM-barrel domain of alpha subunit', 508, NULL, 'Lys-AminoMut_A', 271981),
(452888, 'PF13980', NULL, 'Uncharacterised protein family (UPF0370)', 61, NULL, 'UPF0370', 271982),
(452889, 'PF16475', NULL, 'Domain of unknown function (DUF5052)', 199, NULL, 'DUF5052', 271983),
(452890, 'PF10069', NULL, 'Sensory domain in DIguanylate Cyclases and Two-component system', 129, NULL, 'DICT', 271984),
(452891, 'PF08780', NULL, 'Nucleotidyltransferase substrate binding protein like', 125, NULL, 'NTase_sub_bind', 271985),
(452892, 'PF12032', NULL, 'Regulatory CLIP domain of proteinases', 55, NULL, 'CLIP', 271986),
(452893, 'PF04172', NULL, 'LrgB-like family', 214, NULL, 'LrgB', 271987),
(452894, 'PF05531', NULL, 'Nucleopolyhedrovirus P10 protein', 75, NULL, 'NPV_P10', 271988),
(452895, 'PF10854', NULL, 'Protein of unknown function (DUF2649)', 67, NULL, 'DUF2649', 271989),
(452896, 'PF17674', NULL, 'HHH domain', 70, NULL, 'HHH_9', 271990),
(452897, 'PF03653', NULL, 'Uncharacterised protein family (UPF0093)', 146, NULL, 'UPF0093', 271991),
(452898, 'PF14197', NULL, 'Centrosome localisation domain of PPC89', 67, NULL, 'Cep57_CLD_2', 271992),
(452899, 'PF06042', NULL, 'Nucleotidyltransferase', 159, NULL, 'NTP_transf_6', 271993);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(452900, 'PF17465', NULL, 'Chemokine-like protein, HHV-6 U83 gene product', 97, NULL, 'U83', 271994),
(452901, 'PF20108', NULL, 'Family of unknown function (DUF6498)', 210, NULL, 'DUF6498', 271995),
(452902, 'PF11258', NULL, 'Protein of unknown function (DUF3048) N-terminal domain', 147, NULL, 'DUF3048', 271996),
(452903, 'PF07081', NULL, 'Protein of unknown function (DUF1349)', 179, NULL, 'DUF1349', 271997),
(452904, 'PF09122', NULL, 'Domain of unknown function (DUF1930)', 68, NULL, 'DUF1930', 271998),
(452905, 'PF13326', NULL, 'Photosystem II Pbs27', 141, NULL, 'PSII_Pbs27', 271999),
(452906, 'PF10217', NULL, 'Uncharacterized conserved protein (DUF2039)', 89, NULL, 'DUF2039', 272000),
(452907, 'PF14448', NULL, 'Nuclease N terminal', 58, NULL, 'Nuc_N', 272001),
(452908, 'PF05730', NULL, 'CFEM domain', 66, NULL, 'CFEM', 272002),
(452909, 'PF17565', NULL, 'Family of unknown function (DUF5471)', 70, NULL, 'DUF5471', 272003),
(452910, 'PF05857', NULL, 'TraX protein', 218, NULL, 'TraX', 272004),
(452911, 'PF01979', NULL, 'Amidohydrolase family', 348, NULL, 'Amidohydro_1', 272005),
(452912, 'PF07364', NULL, 'Metallopeptidase family M81', 289, NULL, 'DUF1485', 272006),
(452913, 'PF12769', NULL, '4TM region of pyridine nucleotide transhydrogenase, mitoch', 86, NULL, 'PNTB_4TM', 272007),
(452914, 'PF18305', NULL, '3'' to 5'' exonuclease C-terminal domain', 87, NULL, 'DNA_pol_A_exoN', 272008),
(452915, 'PF03383', NULL, 'Caenorhabditis serpentine receptor-like protein, class xa', 153, NULL, 'Serpentine_r_xa', 272009),
(452916, 'PF01642', NULL, 'Methylmalonyl-CoA mutase', 514, NULL, 'MM_CoA_mutase', 272010),
(452917, 'PF16637', NULL, 'Putative zinc-finger between two C2H2 zinc-fingers on Patz', 85, NULL, 'zf-C2H2_assoc3', 272011),
(452918, 'PF14286', NULL, 'DHHW protein', 382, NULL, 'DHHW', 272012),
(452919, 'PF09637', NULL, 'Med18 protein', 249, NULL, 'Med18', 272013),
(452920, 'PF14477', NULL, 'Membrane-polarising domain of Mso1', 63, NULL, 'Mso1_C', 272014),
(452921, 'PF19728', NULL, 'Family of unknown function (DUF6220)', 66, NULL, 'DUF6220', 272015),
(452922, 'PF09539', NULL, 'Protein of unknown function (DUF2385)', 96, NULL, 'DUF2385', 272016),
(452923, 'PF02350', NULL, 'UDP-N-acetylglucosamine 2-epimerase', 346, NULL, 'Epimerase_2', 272017),
(452924, 'PF15350', NULL, 'Ewing''s tumour-associated antigen 1 homologue', 820, NULL, 'ETAA1', 272018),
(452925, 'PF06931', NULL, 'Mastadenovirus E4 ORF3 protein', 113, NULL, 'Adeno_E4_ORF3', 272019),
(452926, 'PF07961', NULL, 'MBA1-like protein', 235, NULL, 'MBA1', 272020),
(452927, 'PF20398', NULL, 'Family of unknown function (DUF6691)', 142, NULL, 'DUF6691', 272021),
(452928, 'PF03160', NULL, 'Calx-beta domain', 100, NULL, 'Calx-beta', 272022),
(452929, 'PF02461', NULL, 'Ammonia monooxygenase', 238, NULL, 'AMO', 272023),
(452930, 'PF02174', NULL, 'PTB domain (IRS-1 type)', 100, NULL, 'IRS', 272024),
(452931, 'PF11121', NULL, 'Protein of unknown function (DUF2639)', 38, NULL, 'DUF2639', 272025),
(452932, 'PF08650', NULL, 'DASH complex subunit Dad4', 71, NULL, 'DASH_Dad4', 272026),
(452933, 'PF16785', NULL, 'Small metal-binding protein', 111, NULL, 'SMBP', 272027),
(452934, 'PF18131', NULL, 'KN17 SH3-like C-terminal domain', 53, NULL, 'KN17_SH3', 272028),
(452935, 'PF14423', NULL, 'Immunity protein Imm5', 185, NULL, 'Imm5', 272029),
(452936, 'PF13508', NULL, 'Acetyltransferase (GNAT) domain', 80, NULL, 'Acetyltransf_7', 272030),
(452937, 'PF14028', NULL, 'Lantibiotic biosynthesis dehydratase C-term', 288, NULL, 'Lant_dehydr_C', 272031),
(452938, 'PF00157', NULL, 'Pou domain - N-terminal to homeobox domain', 72, NULL, 'Pou', 272032),
(452939, 'PF07007', NULL, 'Lysozyme inhibitor LprI', 95, NULL, 'LprI', 272033),
(452940, 'PF17243', NULL, 'POTRA domain TamA domain 1', 77, NULL, 'POTRA_TamA_1', 272034),
(452941, 'PF07652', NULL, 'Flavivirus DEAD domain', 148, NULL, 'Flavi_DEAD', 272035),
(452942, 'PF11193', NULL, 'Protein of unknown function (DUF2812)', 110, NULL, 'DUF2812', 272036),
(452943, 'PF12607', NULL, 'Protein of unknown function (DUF3772)', 63, NULL, 'DUF3772', 272037);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(452944, 'PF16413', NULL, 'DNA mismatch repair protein Mlh1 C-terminus', 268, NULL, 'Mlh1_C', 272038),
(452945, 'PF12849', NULL, 'PBP superfamily domain', 282, NULL, 'PBP_like_2', 272039),
(452946, 'PF02894', NULL, 'Oxidoreductase family, C-terminal alpha/beta domain', 220, NULL, 'GFO_IDH_MocA_C', 272040),
(452947, 'PF00340', NULL, 'Interleukin-1 / 18', 119, NULL, 'IL1', 272041),
(452948, 'PF13331', NULL, 'Domain of unknown function (DUF4093)', 83, NULL, 'DUF4093', 272042),
(452949, 'PF12626', NULL, 'Polymerase A arginine-rich C-terminus', 120, NULL, 'PolyA_pol_arg_C', 272043),
(452950, 'PF10172', NULL, 'Det1 complexing ubiquitin ligase', 66, NULL, 'DDA1', 272044),
(452951, 'PF13623', NULL, 'SurA N-terminal domain', 145, NULL, 'SurA_N_2', 272045),
(452952, 'PF02399', NULL, 'Origin of replication binding protein', 820, NULL, 'Herpes_ori_bp', 272046),
(452953, 'PF09306', NULL, 'Bacteriophage, scaffolding protein', 303, NULL, 'Phage-scaffold', 272047),
(452954, 'PF07678', NULL, 'A-macroglobulin TED domain', 313, NULL, 'TED_complement', 272048),
(452955, 'PF08920', NULL, 'Splicing factor 3B subunit 1', 131, NULL, 'SF3b1', 272049),
(452956, 'PF01336', NULL, 'OB-fold nucleic acid binding domain', 76, NULL, 'tRNA_anti-codon', 272050),
(452957, 'PF15842', NULL, 'Domain of unknown function (DUF4718)', 184, NULL, 'DUF4718', 272051),
(452958, 'PF02820', NULL, 'mbt repeat', 69, NULL, 'MBT', 272052),
(452959, 'PF11998', NULL, 'Low psii accumulation1 / Rep27', 79, NULL, 'DUF3493', 272053),
(452960, 'PF02762', NULL, 'CBL proto-oncogene N-terminus, SH2-like domain', 86, NULL, 'Cbl_N3', 272054),
(452961, 'PF15753', NULL, 'Biogenesis of lysosome-related organelles complex 1 subunit 3', 181, NULL, 'BLOC1S3', 272055),
(452962, 'PF20107', NULL, 'Family of unknown function (DUF6497)', 114, NULL, 'DUF6497', 272056),
(452963, 'PF20029', NULL, 'Domain of unknown function (DUF6436)', 59, NULL, 'DUF6436', 272057),
(452964, 'PF01219', NULL, 'Prokaryotic diacylglycerol kinase', 102, NULL, 'DAGK_prokar', 272058),
(452965, 'PF03946', NULL, 'Ribosomal protein L11, N-terminal domain', 58, NULL, 'Ribosomal_L11_N', 272059),
(452966, 'PF01165', NULL, 'Ribosomal protein S21', 55, NULL, 'Ribosomal_S21', 272060),
(452967, 'PF01494', NULL, 'FAD binding domain', 349, NULL, 'FAD_binding_3', 272061),
(452968, 'PF03172', NULL, 'HSR domain', 99, NULL, 'HSR', 272062),
(452969, 'PF03841', NULL, 'L-seryl-tRNA selenium transferase', 367, NULL, 'SelA', 272063),
(452970, 'PF09976', NULL, 'Tetratricopeptide repeat-like domain', 193, NULL, 'TPR_21', 272064),
(452971, 'PF01896', NULL, 'DNA primase small subunit', 182, NULL, 'DNA_primase_S', 272065),
(452972, 'PF04692', NULL, 'Platelet-derived growth factor, N terminal region', 78, NULL, 'PDGF_N', 272066),
(452973, 'PF16441', NULL, 'Domain of unknown function (DUF5038)', 144, NULL, 'DUF5038', 272067),
(452974, 'PF03050', NULL, 'Transposase IS66 family', 281, NULL, 'DDE_Tnp_IS66', 272068),
(452975, 'PF08928', NULL, 'Domain of unknown function (DUF1910)', 117, NULL, 'DUF1910', 272069),
(452976, 'PF07073', NULL, 'Modulator of Rho-dependent transcription termination (ROF)', 80, NULL, 'ROF', 272070),
(452977, 'PF11677', NULL, 'Protein of unknown function (DUF3273)', 265, NULL, 'DUF3273', 272071),
(452978, 'PF13017', NULL, 'piRNA pathway germ-plasm component', 216, NULL, 'Maelstrom', 272072),
(452979, 'PF17150', NULL, 'C-terminal domain of two-partite extracellular sensor domain', 81, NULL, 'CHASE6_C', 272073),
(452980, 'PF00822', NULL, 'PMP-22/EMP/MP20/Claudin family', 166, NULL, 'PMP22_Claudin', 272074),
(452981, 'PF04872', NULL, 'Poxvirus L5 protein family', 79, NULL, 'Pox_L5', 272075),
(452982, 'PF13692', NULL, 'Glycosyl transferases group 1', 135, NULL, 'Glyco_trans_1_4', 272076),
(452983, 'PF17276', NULL, 'Family of unknown function (DUF5341)', 161, NULL, 'DUF5341', 272077),
(452984, 'PF03708', NULL, 'Avian retrovirus envelope protein, gp85', 246, NULL, 'Avian_gp85', 272078),
(452985, 'PF16185', NULL, 'Mitochondrial ABC-transporter N-terminal five TM region', 244, NULL, 'MTABC_N', 272079),
(452986, 'PF20300', NULL, 'Prokaryotic STING domain', 139, NULL, 'prok_STING', 272080);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(452987, 'PF20517', NULL, 'Transmembrane protein 127', 113, NULL, 'TMEM127', 272081),
(452988, 'PF06980', NULL, 'Protein of unknown function (DUF1302)', 540, NULL, 'DUF1302', 272082),
(452989, 'PF09566', NULL, 'SacI restriction endonuclease', 273, NULL, 'RE_SacI', 272083),
(452990, 'PF11904', NULL, 'GPCR-chaperone', 307, NULL, 'GPCR_chapero_1', 272084),
(452991, 'PF08212', NULL, 'Lipocalin-like domain', 143, NULL, 'Lipocalin_2', 272085),
(452992, 'PF02157', NULL, 'Mannose-6-phosphate receptor', 254, NULL, 'Man-6-P_recep', 272086),
(452993, 'PF19253', NULL, 'Family of unknown function (DUF5900)', 101, NULL, 'DUF5900', 272087),
(452994, 'PF14863', NULL, 'Alkyl sulfatase dimerisation', 139, NULL, 'Alkyl_sulf_dimr', 272088),
(452995, 'PF18894', NULL, 'Putative phage metallopeptidase', 142, NULL, 'PhageMetallopep', 272089),
(452996, 'PF17769', NULL, 'Phosphoribosylaminoimidazole carboxylase C-terminal domain', 56, NULL, 'PurK_C', 272090),
(452997, 'PF16432', NULL, 'Domain of unknown function (DUF5029)', 210, NULL, 'DUF5029', 272091),
(452998, 'PF11240', NULL, 'Protein of unknown function (DUF3042)', 54, NULL, 'DUF3042', 272092),
(452999, 'PF07557', NULL, 'Shugoshin C terminus', 24, NULL, 'Shugoshin_C', 272093),
(453000, 'PF11130', NULL, 'TraC protein', 232, NULL, 'TraC_F_IV', 272094),
(453001, 'PF15892', NULL, 'BNR repeat-containing family member', 272, NULL, 'BNR_4', 272095),
(453002, 'PF07469', NULL, 'Nuclear receptor coactivator, DUF1518', 58, NULL, 'DUF1518', 272096),
(453003, 'PF11670', NULL, 'Major surface protein 1a (MSP1a)', 252, NULL, 'MSP1a', 272097),
(453004, 'PF06418', NULL, 'CTP synthase N-terminus', 266, NULL, 'CTP_synth_N', 272098),
(453005, 'PF14551', NULL, 'MCM N-terminal domain', 105, NULL, 'MCM_N', 272099),
(453006, 'PF01347', NULL, 'Lipoprotein amino terminal region', 622, NULL, 'Vitellogenin_N', 272100),
(453007, 'PF15626', NULL, 'single CXXC unit', 58, NULL, 'mono-CXXC', 272101),
(453008, 'PF17595', NULL, 'Family of unknown function (DUF5491)', 68, NULL, 'DUF5491', 272102),
(453009, 'PF05430', NULL, 'S-adenosyl-L-methionine-dependent methyltransferase', 124, NULL, 'Methyltransf_30', 272103),
(453010, 'PF16061', NULL, 'Domain of unknown function (DUF4803)', 255, NULL, 'DUF4803', 272104),
(453011, 'PF07584', NULL, 'Aerotolerance regulator N-terminal', 77, NULL, 'BatA', 272105),
(453012, 'PF00582', NULL, 'Universal stress protein family', 141, NULL, 'Usp', 272106),
(453013, 'PF00511', NULL, 'E2 (early) protein, C terminal', 80, NULL, 'PPV_E2_C', 272107),
(453014, 'PF05391', NULL, 'Lsm interaction motif', 19, NULL, 'Lsm_interact', 272108),
(453015, 'PF16378', NULL, 'Domain of unknown function', 182, NULL, 'DUF4988', 272109),
(453016, 'PF18652', NULL, 'Adhesin P1 N-terminal domain', 106, NULL, 'Adhesin_P1_N', 272110),
(453017, 'PF15207', NULL, 'TMEM240 family', 174, NULL, 'TMEM240', 272111),
(453018, 'PF00513', NULL, 'Late Protein L2', 525, NULL, 'Late_protein_L2', 272112),
(453019, 'PF09668', NULL, 'Aspartyl protease', 124, NULL, 'Asp_protease', 272113),
(453020, 'PF17390', NULL, 'Bacterial alpha-L-rhamnosidase C-terminal domain', 78, NULL, 'Bac_rhamnosid_C', 272114),
(453021, 'PF16242', NULL, 'Pyridoxamine 5''-phosphate oxidase like', 149, NULL, 'Pyrid_ox_like', 272115),
(453022, 'PF17425', NULL, 'Arylsulfotransferase Ig-like domain', 89, NULL, 'Arylsulfotran_N', 272116),
(453023, 'PF12653', NULL, 'Protein of unknown function (DUF3785)', 136, NULL, 'DUF3785', 272117),
(453024, 'PF04919', NULL, 'Protein of unknown function (DUF655)', 181, NULL, 'DUF655', 272118),
(453025, 'PF20391', NULL, 'Family of unknown function (DUF6686)', 117, NULL, 'DUF6686', 272119),
(453026, 'PF06360', NULL, 'Euplotes raikovi mating pheromone', 36, NULL, 'E_raikovi_mat', 272120),
(453027, 'PF11453', NULL, 'Protein of unknown function (DUF2950)', 273, NULL, 'DUF2950', 272121),
(453028, 'PF08264', NULL, 'Anticodon-binding domain of tRNA ligase', 152, NULL, 'Anticodon_1', 272122),
(453029, 'PF04721', NULL, 'PNGase C-terminal domain, mannose-binding module PAW', 198, NULL, 'PAW', 272123),
(453030, 'PF11865', NULL, 'Domain of unknown function (DUF3385)', 161, NULL, 'DUF3385', 272124);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(453031, 'PF17462', NULL, 'Family of unknown function (DUF5424)', 174, NULL, 'DUF5424', 272125),
(453032, 'PF04569', NULL, 'Protein of unknown function', 51, NULL, 'DUF591', 272126),
(453033, 'PF10968', NULL, 'Protein of unknown function (DUF2770)', 36, NULL, 'DUF2770', 272127),
(453034, 'PF16949', NULL, 'Putative ATP-binding cassette', 542, NULL, 'ABC_tran_2', 272128),
(453035, 'PF18752', NULL, 'Dictyosteliid AID/APOBEC-like Deaminase', 291, NULL, 'DAAD', 272129),
(453036, 'PF09906', NULL, 'Uncharacterized protein conserved in bacteria (DUF2135)', 52, NULL, 'DUF2135', 272130),
(453037, 'PF06683', NULL, 'Protein of unknown function (DUF1184)', 203, NULL, 'DUF1184', 272131),
(453038, 'PF05434', NULL, 'TMEM9', 145, NULL, 'Tmemb_9', 272132),
(453039, 'PF20382', NULL, 'Family of unknown function (DUF6677)', 145, NULL, 'DUF6677', 272133),
(453040, 'PF07580', NULL, 'M26 IgA1-specific Metallo-endopeptidase C-terminal region', 734, NULL, 'Peptidase_M26_C', 272134),
(453041, 'PF17977', NULL, 'RING/Ubox like zinc-binding domain', 68, NULL, 'zf-RING_13', 272135),
(453042, 'PF19993', NULL, 'Double-GTPase 2', 227, NULL, 'DO-GTPase2', 272136),
(453043, 'PF12795', NULL, 'Mechanosensitive ion channel porin domain', 238, NULL, 'MscS_porin', 272137),
(453044, 'PF16025', NULL, 'Calcium-dependent calmodulin binding', 79, NULL, 'CaM_bind', 272138),
(453045, 'PF00319', NULL, 'SRF-type transcription factor (DNA-binding and dimerisation domain)', 48, NULL, 'SRF-TF', 272139),
(453046, 'PF18065', NULL, 'PatG C-terminal', 115, NULL, 'PatG_C', 272140),
(453047, 'PF02656', NULL, 'Domain of unknown function (DUF202)', 68, NULL, 'DUF202', 272141),
(453048, 'PF03397', NULL, 'Rhabdovirus matrix protein', 168, NULL, 'Rhabdo_matrix', 272142),
(453049, 'PF13247', NULL, '4Fe-4S dicluster domain', 100, NULL, 'Fer4_11', 272143),
(453050, 'PF12248', NULL, 'Farnesoic acid 0-methyl transferase', 104, NULL, 'Methyltransf_FA', 272144),
(453051, 'PF10148', NULL, 'Schwannomin-interacting protein 1', 248, NULL, 'SCHIP-1', 272145),
(453052, 'PF17521', NULL, 'Honey bee peptides', 45, NULL, 'Secapin', 272146),
(453053, 'PF10371', NULL, 'Domain of unknown function', 57, NULL, 'EKR', 272147),
(453054, 'PF13548', NULL, 'Domain of unknown function (DUF4126)', 175, NULL, 'DUF4126', 272148),
(453055, 'PF00024', NULL, 'PAN domain', 79, NULL, 'PAN_1', 272149),
(453056, 'PF05034', NULL, 'Methylaspartate ammonia-lyase N-terminus', 159, NULL, 'MAAL_N', 272150),
(453057, 'PF15321', NULL, 'ATPase family AAA domain containing 4', 98, NULL, 'ATAD4', 272151),
(453058, 'PF01227', NULL, 'GTP cyclohydrolase I', 179, NULL, 'GTP_cyclohydroI', 272152),
(453059, 'PF00284', NULL, 'Lumenal portion of Cytochrome b559, alpha (gene psbE) subunit', 39, NULL, 'Cytochrom_B559a', 272153),
(453060, 'PF10257', NULL, 'Retinoic acid induced 16-like protein', 360, NULL, 'RAI16-like', 272154),
(453061, 'PF19648', NULL, 'Family of unknown function (DUF6151)', 188, NULL, 'DUF6151', 272155),
(453062, 'PF10880', NULL, 'Protein of unknown function (DUF2673)', 82, NULL, 'DUF2673', 272156),
(453063, 'PF11342', NULL, 'Protein of unknown function (DUF3144)', 77, NULL, 'DUF3144', 272157),
(453064, 'PF09775', NULL, 'Keratinocyte-associated protein 2', 129, NULL, 'Keratin_assoc', 272158),
(453065, 'PF11330', NULL, 'C-Terminal of 30K viral movement proteins', 242, NULL, '30K_MP_C_Ter', 272159),
(453066, 'PF03905', NULL, 'Coronavirus non-structural protein NS4', 45, NULL, 'Corona_NS4', 272160),
(453067, 'PF18304', NULL, 'SabA N-terminal extracellular adhesion domain', 299, NULL, 'SabA_adhesion', 272161),
(453068, 'PF06395', NULL, 'CDC24 Calponin', 89, NULL, 'CDC24', 272162),
(453069, 'PF12131', NULL, 'Protein of unknown function (DUF3586)', 75, NULL, 'DUF3586', 272163),
(453070, 'PF16537', NULL, 'Type II secretion system protein B', 60, NULL, 'T2SSB', 272164),
(453071, 'PF04106', NULL, 'Autophagy protein Apg5', 219, NULL, 'APG5', 272165),
(453072, 'PF01388', NULL, 'ARID/BRIGHT DNA binding domain', 90, NULL, 'ARID', 272166),
(453073, 'PF06822', NULL, 'Protein of unknown function (DUF1235)', 261, NULL, 'DUF1235', 272167);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(453074, 'PF13215', NULL, 'Protein of unknown function (DUF4023)', 38, NULL, 'DUF4023', 272168),
(453075, 'PF15354', NULL, 'Kidney-associated antigen 1', 84, NULL, 'KAAG1', 272169),
(453076, 'PF12688', NULL, 'Tetratrico peptide repeat', 119, NULL, 'TPR_5', 272170),
(453077, 'PF15447', NULL, 'N-terminal segments of PfEMP1', 37, NULL, 'NTS', 272171),
(453078, 'PF17806', NULL, 'Sarcosine oxidase A3 domain', 87, NULL, 'SO_alpha_A3', 272172),
(453079, 'PF03598', NULL, 'CO dehydrogenase/acetyl-CoA synthase complex beta subunit', 155, NULL, 'CdhC', 272173),
(453080, 'PF09673', NULL, 'Type-F conjugative transfer system pilin assembly protein', 112, NULL, 'TrbC_Ftype', 272174),
(453081, 'PF01174', NULL, 'SNO glutamine amidotransferase family', 188, NULL, 'SNO', 272175),
(453082, 'PF03006', NULL, 'Haemolysin-III related', 224, NULL, 'HlyIII', 272176),
(453083, 'PF07145', NULL, 'Ataxin-2 C-terminal region', 18, NULL, 'PAM2', 272177),
(453084, 'PF04618', NULL, 'HD-ZIP protein N terminus', 110, NULL, 'HD-ZIP_N', 272178),
(453085, 'PF11715', NULL, 'Nucleoporin Nup120/160', 547, NULL, 'Nup160', 272179),
(453086, 'PF08174', NULL, 'Cell division protein anillin', 141, NULL, 'Anillin', 272180),
(453087, 'PF10541', NULL, 'Nuclear envelope localisation domain', 58, NULL, 'KASH', 272181),
(453088, 'PF13473', NULL, 'Cupredoxin-like domain', 104, NULL, 'Cupredoxin_1', 272182),
(453089, 'PF09890', NULL, 'Uncharacterized protein conserved in archaea (DUF2117)', 330, NULL, 'DUF2117', 272183),
(453090, 'PF19556', NULL, 'PRTRC system protein E', 175, NULL, 'PRTRC_E', 272184),
(453091, 'PF11114', NULL, 'Minor capsid protein', 114, NULL, 'Minor_capsid_2', 272185),
(453092, 'PF02228', NULL, 'Major core protein p19', 92, NULL, 'Gag_p19', 272186),
(453093, 'PF09282', NULL, 'Mago binding', 27, NULL, 'Mago-bind', 272187),
(453094, 'PF14015', NULL, 'Protein of unknown function (DUF4231)', 105, NULL, 'DUF4231', 272188),
(453095, 'PF02216', NULL, 'B domain', 53, NULL, 'B', 272189),
(453096, 'PF14667', NULL, 'Polysaccharide biosynthesis C-terminal domain', 143, NULL, 'Polysacc_synt_C', 272190),
(453097, 'PF03311', NULL, 'Cornichon protein', 122, NULL, 'Cornichon', 272191),
(453098, 'PF07502', NULL, 'MANEC domain', 90, NULL, 'MANEC', 272192),
(453099, 'PF10071', NULL, 'Zn-ribbon-containing, possibly nucleic-acid-binding protein (DUF2310)', 255, NULL, 'DUF2310', 272193),
(453100, 'PF17013', NULL, 'Putative acetyl-transferase', 210, NULL, 'Acetyltransf_15', 272194),
(453101, 'PF19657', NULL, 'Family of unknown function (DUF6160)', 320, NULL, 'DUF6160', 272195),
(453102, 'PF04441', NULL, 'Poxvirus early transcription factor (VETF), large subunit', 697, NULL, 'Pox_VERT_large', 272196),
(453103, 'PF12632', NULL, 'Mysoin-binding motif of peroxisomes', 282, NULL, 'Vezatin', 272197),
(453104, 'PF14816', NULL, 'Coiled-coil and Nse Interacting (CANIN) domain', 377, NULL, 'CANIN', 272198),
(453105, 'PF12910', NULL, 'Antitoxin of toxin-antitoxin, RelE / RelB, TA system', 145, NULL, 'PHD_like', 272199),
(453106, 'PF13575', NULL, 'Domain of unknown function (DUF4135)', 377, NULL, 'DUF4135', 272200),
(453107, 'PF14770', NULL, 'Transmembrane protein 18', 118, NULL, 'TMEM18', 272201),
(453108, 'PF10421', NULL, '2''-5''-oligoadenylate synthetase 1, domain 2, C-terminus', 189, NULL, 'OAS1_C', 272202),
(453109, 'PF16219', NULL, 'Domain of unknown function (DUF4879)', 124, NULL, 'DUF4879', 272203),
(453110, 'PF09487', NULL, 'Bacterial type III secretion protein (HrpB2)', 114, NULL, 'HrpB2', 272204),
(453111, 'PF03458', NULL, 'Glycine transporter', 78, NULL, 'Gly_transporter', 272205),
(453112, 'PF18641', NULL, 'LidA long coiled-coil domain', 177, NULL, 'LidA_Long_CC', 272206),
(453113, 'PF02412', NULL, 'Thrombospondin type 3 repeat', 36, NULL, 'TSP_3', 272207),
(453114, 'PF19532', NULL, 'Transmembrane protein 131-like', 1430, NULL, 'TMEM131_like', 272208),
(453115, 'PF14216', NULL, 'Domain of unknown function (DUF4326)', 83, NULL, 'DUF4326', 272209),
(453116, 'PF02028', NULL, 'BCCT, betaine/carnitine/choline family transporter', 485, NULL, 'BCCT', 272210);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(453117, 'PF11333', NULL, 'Protein of unknown function (DUF3135)', 81, NULL, 'DUF3135', 272211),
(453118, 'PF20515', NULL, 'Tet-like 2OG-Fe(II) oxygenase superfamily', 212, NULL, '2OG-FeII_Oxy_6', 272212),
(453119, 'PF12479', NULL, 'Protein of unknown function (DUF3698)', 107, NULL, 'DUF3698', 272213),
(453120, 'PF04341', NULL, 'Protein of unknown function, DUF485', 89, NULL, 'DUF485', 272214),
(453121, 'PF17561', NULL, 'Type VI secretion system, TssO', 148, NULL, 'TssO', 272215),
(453122, 'PF16867', NULL, 'Dimethlysulfonioproprionate lyase', 161, NULL, 'DMSP_lyase', 272216),
(453123, 'PF17978', NULL, 'RING/Ubox like zinc-binding domain', 91, NULL, 'zf-RING_14', 272217),
(453124, 'PF15167', NULL, 'Domain of unknown function (DUF4581)', 130, NULL, 'DUF4581', 272218),
(453125, 'PF03581', NULL, 'Herpesvirus UL33-like protein', 72, NULL, 'Herpes_UL33', 272219),
(453126, 'PF17773', NULL, 'UPF0176 acylphosphatase like domain', 92, NULL, 'UPF0176_N', 272220),
(453127, 'PF20477', NULL, 'Family of unknown function (DUF6719)', 78, NULL, 'DUF6719', 272221),
(453128, 'PF07545', NULL, 'Vestigial/Tondu family', 31, NULL, 'Vg_Tdu', 272222),
(453129, 'PF18220', NULL, 'Adhesin BspA variable domain', 150, NULL, 'BspA_v', 272223),
(453130, 'PF16898', NULL, 'C-terminal associated domain of TOPRIM', 128, NULL, 'TOPRIM_C', 272224),
(453131, 'PF18059', NULL, 'Csd3 N-terminal', 83, NULL, 'Csd3_N', 272225),
(453132, 'PF02605', NULL, 'Photosystem I reaction centre subunit XI', 150, NULL, 'PsaL', 272226),
(453133, 'PF03894', NULL, 'D-xylulose 5-phosphate/D-fructose 6-phosphate phosphoketolase', 176, NULL, 'XFP', 272227),
(453134, 'PF06990', NULL, 'Galactose-3-O-sulfotransferase', 402, NULL, 'Gal-3-0_sulfotr', 272228),
(453135, 'PF10794', NULL, 'Protein of unknown function (DUF2606)', 130, NULL, 'DUF2606', 272229),
(453136, 'PF12167', NULL, 'Arm DNA-binding domain', 65, NULL, 'Arm-DNA-bind_2', 272230),
(453137, 'PF07387', NULL, 'Seadornavirus VP7', 308, NULL, 'Seadorna_VP7', 272231),
(453138, 'PF14990', NULL, 'Domain of unknown function (DUF4516)', 46, NULL, 'DUF4516', 272232),
(453139, 'PF20338', NULL, 'Family of unknown function (DUF6633)', 105, NULL, 'DUF6633', 272233),
(453140, 'PF12528', NULL, 'Type II secretion prepilin peptidase dependent protein C', 82, NULL, 'T2SSppdC', 272234),
(453141, 'PF08138', NULL, 'Sex peptide (SP) family', 55, NULL, 'Sex_peptide', 272235),
(453142, 'PF15025', NULL, 'Domain of unknown function (DUF4524)', 145, NULL, 'DUF4524', 272236),
(453143, 'PF00828', NULL, 'Ribosomal proteins 50S-L15, 50S-L18e, 60S-L27A', 118, NULL, 'Ribosomal_L27A', 272237),
(453144, 'PF18800', NULL, 'Attenuator of Hedgehog', 141, NULL, 'Atthog', 272238),
(453145, 'PF11765', NULL, 'Hyphally regulated cell wall protein N-terminal', 328, NULL, 'Hyphal_reg_CWP', 272239),
(453146, 'PF07811', NULL, 'TadE-like protein', 43, NULL, 'TadE', 272240),
(453147, 'PF20148', NULL, 'Domain of unknown function (DUF6531)', 74, NULL, 'DUF6531', 272241),
(453148, 'PF10370', NULL, 'Domain of unknown function (DUF2437)', 50, NULL, 'DUF2437', 272242),
(453149, 'PF14011', NULL, 'EspG family', 245, NULL, 'ESX-1_EspG', 272243),
(453150, 'PF15330', NULL, 'SHP2-interacting transmembrane adaptor protein, SIT', 114, NULL, 'SIT', 272244),
(453151, 'PF11351', NULL, 'Holin of 3TMs, for gene-transfer release', 123, NULL, 'GTA_holin_3TM', 272245),
(453152, 'PF16672', NULL, 'Ragulator complex protein LAMTOR5', 88, NULL, 'LAMTOR5', 272246),
(453153, 'PF07909', NULL, 'Protein of unknown function (DUF1663)', 497, NULL, 'DUF1663', 272247),
(453154, 'PF14358', NULL, 'Domain of unknown function (DUF4405)', 66, NULL, 'DUF4405', 272248),
(453155, 'PF20441', NULL, 'Terminase large subunit, endonuclease domain', 286, NULL, 'TerL_nuclease', 272249),
(453156, 'PF18497', NULL, 'Ribonuclease III N-terminal domain', 95, NULL, 'RNase_3_N', 272250),
(453157, 'PF07292', NULL, 'Nmi/IFP 35 domain (NID)', 91, NULL, 'NID', 272251),
(453158, 'PF02265', NULL, 'S1/P1 Nuclease', 255, NULL, 'S1-P1_nuclease', 272252),
(453159, 'PF00360', NULL, 'Phytochrome region', 183, NULL, 'PHY', 272253);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(453160, 'PF06839', NULL, 'GRF zinc finger', 45, NULL, 'zf-GRF', 272254),
(453161, 'PF13647', NULL, 'Glycosyl hydrolase family 80 of chitosanase A', 308, NULL, 'Glyco_hydro_80', 272255),
(453162, 'PF13994', NULL, 'PgaD-like protein', 148, NULL, 'PgaD', 272256),
(453163, 'PF03058', NULL, 'Sar8.2 family', 93, NULL, 'Sar8_2', 272257),
(453164, 'PF17984', NULL, 'Telomerase reverse transcriptase thumb DNA binding domain', 191, NULL, 'TERT_thumb', 272258),
(453165, 'PF13844', NULL, 'Glycosyl transferase family 41', 543, NULL, 'Glyco_transf_41', 272259),
(453166, 'PF10969', NULL, 'Protein of unknown function (DUF2771)', 127, NULL, 'DUF2771', 272260),
(453167, 'PF09472', NULL, 'Tetrahydromethanopterin S-methyltransferase, F subunit (MtrF)', 62, NULL, 'MtrF', 272261),
(453168, 'PF10765', NULL, 'Bacteriophage P22, NinX', 114, NULL, 'Phage_P22_NinX', 272262),
(453169, 'PF16198', NULL, 'tRNA pseudouridylate synthase B C-terminal domain', 64, NULL, 'TruB_C_2', 272263),
(453170, 'PF02392', NULL, 'Ycf4', 178, NULL, 'Ycf4', 272264),
(453171, 'PF03434', NULL, 'DUF276', 290, NULL, 'DUF276', 272265),
(453172, 'PF03472', NULL, 'Autoinducer binding domain', 149, NULL, 'Autoind_bind', 272266),
(453173, 'PF17776', NULL, 'NLRC4 helical domain HD2', 126, NULL, 'NLRC4_HD2', 272267),
(453174, 'PF14525', NULL, 'AraC-binding-like domain', 173, NULL, 'AraC_binding_2', 272268),
(453175, 'PF06836', NULL, 'Protein of unknown function (DUF1240)', 95, NULL, 'DUF1240', 272269),
(453176, 'PF13560', NULL, 'Helix-turn-helix domain', 64, NULL, 'HTH_31', 272270),
(453177, 'PF10249', NULL, 'NADH-ubiquinone oxidoreductase subunit 10', 126, NULL, 'NDUFB10', 272271),
(453178, 'PF14868', NULL, 'Domain of unknown function (DUF4487)', 574, NULL, 'DUF4487', 272272),
(453179, 'PF10581', NULL, 'Synapsin N-terminal', 32, NULL, 'Synapsin_N', 272273),
(453180, 'PF06559', NULL, '2''-deoxycytidine 5''-triphosphate deaminase (DCD)', 361, NULL, 'DCD', 272274),
(453181, 'PF07351', NULL, 'Protein of unknown function (DUF1480)', 78, NULL, 'DUF1480', 272275),
(453182, 'PF11898', NULL, 'Domain of unknown function (DUF3418)', 583, NULL, 'DUF3418', 272276),
(453183, 'PF13941', NULL, 'MutL protein', 453, NULL, 'MutL', 272277),
(453184, 'PF00124', NULL, 'Photosynthetic reaction centre protein', 260, NULL, 'Photo_RC', 272278),
(453185, 'PF02989', NULL, 'Lyme disease proteins of unknown function', 183, NULL, 'DUF228', 272279),
(453186, 'PF07530', NULL, 'Associated with zinc fingers', 68, NULL, 'PRE_C2HC', 272280),
(453187, 'PF12185', NULL, 'Nup358/RanBP2 E3 ligase domain', 60, NULL, 'IR1-M', 272281),
(453188, 'PF20223', NULL, 'Family of unknown function (DUF6582)', 83, NULL, 'DUF6582', 272282),
(453189, 'PF11520', NULL, 'Chromatin protein Cren7', 58, NULL, 'Cren7', 272283),
(453190, 'PF11120', NULL, 'Cellulose biosynthesis protein BcsF', 60, NULL, 'CBP_BcsF', 272284),
(453191, 'PF19399', NULL, 'Family of unknown function (DUF5974)', 38, NULL, 'DUF5974', 272285),
(453192, 'PF00009', NULL, 'Elongation factor Tu GTP binding domain', 195, NULL, 'GTP_EFTU', 272286),
(453193, 'PF17325', NULL, 'Stationary phase protein 4', 109, NULL, 'SPG4', 272287),
(453194, 'PF08387', NULL, 'FBD', 46, NULL, 'FBD', 272288),
(453195, 'PF20623', NULL, 'Sgo0707 N2 domain', 141, NULL, 'Sgo0707_N2', 272289),
(453196, 'PF03766', NULL, 'Remorin, N-terminal region', 54, NULL, 'Remorin_N', 272290),
(453197, 'PF14002', NULL, 'YniB-like protein', 166, NULL, 'YniB', 272291),
(453198, 'PF06523', NULL, 'Protein of unknown function (DUF1106)', 91, NULL, 'DUF1106', 272292),
(453199, 'PF19157', NULL, 'Family of unknown function (DUF5839)', 83, NULL, 'DUF5839', 272293),
(453200, 'PF09277', NULL, 'Erythronolide synthase, docking', 58, NULL, 'Erythro-docking', 272294),
(453201, 'PF05816', NULL, 'Toxic anion resistance protein (TelA)', 331, NULL, 'TelA', 272295),
(453202, 'PF16328', NULL, 'Domain of unknown function (DUF4961)', 312, NULL, 'DUF4961', 272296),
(453203, 'PF15673', NULL, 'Circadian-associated transcriptional repressor', 278, NULL, 'Ciart', 272297),
(453204, 'PF18910', NULL, 'Domain of unknown function (DUF5665)', 56, NULL, 'DUF5665', 272298);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(453205, 'PF11563', NULL, 'Protoglobin', 158, NULL, 'Protoglobin', 272299),
(453206, 'PF18647', NULL, 'Alpha-galactosyl-binding fungal lectin', 102, NULL, 'Fungal_lectin_2', 272300),
(453207, 'PF04672', NULL, 'S-adenosyl methyltransferase', 268, NULL, 'Methyltransf_19', 272301),
(453208, 'PF16268', NULL, 'Domain of unknown function (DUF4921)', 425, NULL, 'DUF4921', 272302),
(453209, 'PF18564', NULL, 'Glycoside hydrolase family 5 C-terminal domain', 87, NULL, 'Glyco_hydro_5_C', 272303),
(453210, 'PF05788', NULL, 'Orbivirus RNA-dependent RNA polymerase (VP1)', 1297, NULL, 'Orbi_VP1', 272304),
(453211, 'PF03932', NULL, 'CutC family', 202, NULL, 'CutC', 272305),
(453212, 'PF12564', NULL, 'Type III restriction/modification enzyme methylation subunit', 56, NULL, 'TypeIII_RM_meth', 272306),
(453213, 'PF09500', NULL, 'Putative thioesterase (yiiD_Cterm)', 144, NULL, 'YiiD_C', 272307),
(453214, 'PF19099', NULL, 'Family of unknown function (DUF5786)', 55, NULL, 'DUF5786', 272308),
(453215, 'PF15488', NULL, 'Domain of unknown function (DUF4645)', 294, NULL, 'DUF4645', 272309),
(453216, 'PF00397', NULL, 'WW domain', 31, NULL, 'WW', 272310),
(453217, 'PF19292', NULL, 'Phosphorylase b kinase C-terminal domain', 238, NULL, 'KPBB_C', 272311),
(453218, 'PF16132', NULL, 'Domain of unknown function (DUF4843)', 166, NULL, 'DUF4843', 272312),
(453219, 'PF11028', NULL, 'Protein of unknown function (DUF2723)', 179, NULL, 'DUF2723', 272313),
(453220, 'PF05078', NULL, 'Protein of unknown function (DUF679)', 163, NULL, 'DUF679', 272314),
(453221, 'PF17699', NULL, 'Family of unknown function (DUF5545)', 212, NULL, 'DUF5545', 272315),
(453222, 'PF15134', NULL, 'Domain of unknown function (DUF4570)', 110, NULL, 'DUF4570', 272316),
(453223, 'PF00293', NULL, 'NUDIX domain', 131, NULL, 'NUDIX', 272317),
(453224, 'PF16547', NULL, 'Proteasome-substrate-size regulator, N-terminal', 81, NULL, 'BLM10_N', 272318),
(453225, 'PF17913', NULL, 'FHA domain', 97, NULL, 'FHA_2', 272319),
(453226, 'PF05549', NULL, 'Allexivirus 40kDa protein', 271, NULL, 'Allexi_40kDa', 272320),
(453227, 'PF06181', NULL, 'Urate oxidase N-terminal', 297, NULL, 'Urate_ox_N', 272321),
(453228, 'PF06558', NULL, 'Secretion monitor precursor protein (SecM)', 147, NULL, 'SecM', 272322),
(453229, 'PF00846', NULL, 'Hantavirus nucleocapsid protein', 429, NULL, 'Hanta_nucleocap', 272323),
(453230, 'PF09057', NULL, 'Second Mitochondria-derived Activator of Caspases', 231, NULL, 'Smac_DIABLO', 272324),
(453231, 'PF14622', NULL, 'Ribonuclease-III-like', 128, NULL, 'Ribonucleas_3_3', 272325),
(453232, 'PF17205', NULL, 'Integrin plexin domain', 46, NULL, 'PSI_integrin', 272326),
(453233, 'PF08618', NULL, 'Transcription factor Opi1', 420, NULL, 'Opi1', 272327),
(453234, 'PF07749', NULL, 'Endoplasmic reticulum protein ERp29, C-terminal domain', 96, NULL, 'ERp29', 272328),
(453235, 'PF00242', NULL, 'DNA polymerase (viral) N-terminal domain', 353, NULL, 'DNA_pol_viral_N', 272329),
(453236, 'PF17316', NULL, 'Perilipin protein', 253, NULL, 'Perilipin_2', 272330),
(453237, 'PF08433', NULL, 'Chromatin associated protein KTI12', 272, NULL, 'KTI12', 272331),
(453238, 'PF14555', NULL, 'UBA-like domain', 43, NULL, 'UBA_4', 272332),
(453239, 'PF09199', NULL, 'Staphylococcal superantigen-like OB-fold domain', 84, NULL, 'SSL_OB', 272333),
(453240, 'PF07365', NULL, 'Alpha conotoxin precursor', 50, NULL, 'Toxin_8', 272334),
(453241, 'PF19555', NULL, 'Family of unknown function (DUF6078)', 145, NULL, 'DUF6078', 272335),
(453242, 'PF03647', NULL, 'Transmembrane proteins 14C', 92, NULL, 'Tmemb_14', 272336),
(453243, 'PF07882', NULL, 'L-fucose isomerase, second N-terminal domain', 180, NULL, 'Fucose_iso_N2', 272337),
(453244, 'PF16074', NULL, 'Type IV Pilus-assembly protein W', 126, NULL, 'PilW', 272338),
(453245, 'PF16725', NULL, 'Nucleolin binding domain', 70, NULL, 'Nucleolin_bd', 272339),
(453246, 'PF18091', NULL, 'E3 Ubiquitin Ligase RBR C-terminal domain', 92, NULL, 'E3_UbLigase_RBR', 272340),
(453247, 'PF07139', NULL, 'Protein of unknown function (DUF1387)', 307, NULL, 'DUF1387', 272341);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(453248, 'PF19736', NULL, 'Family of unknown function (DUF6226)', 197, NULL, 'DUF6226', 272342),
(453249, 'PF06335', NULL, 'Protein of unknown function (DUF1054)', 198, NULL, 'DUF1054', 272343),
(453250, 'PF09231', NULL, 'Rice dwarf virus p3', 965, NULL, 'RDV-p3', 272344),
(453251, 'PF12573', NULL, '2-oxoisovalerate dehydrogenase E1 alpha subunit N terminal', 41, NULL, 'OxoDH_E1alpha_N', 272345),
(453252, 'PF00753', NULL, 'Metallo-beta-lactamase superfamily', 197, NULL, 'Lactamase_B', 272346),
(453253, 'PF07044', NULL, 'Protein of unknown function (DUF1329)', 365, NULL, 'DUF1329', 272347),
(453254, 'PF18214', NULL, 'STATa Immunoglobulin-like domain', 122, NULL, 'STATa_Ig', 272348),
(453255, 'PF10012', NULL, 'Uncharacterized protein conserved in bacteria (DUF2255)', 115, NULL, 'DUF2255', 272349),
(453256, 'PF15985', NULL, 'KH domain', 50, NULL, 'KH_6', 272350),
(453257, 'PF03314', NULL, 'Protein of unknown function, DUF273', 219, NULL, 'DUF273', 272351),
(453258, 'PF00161', NULL, 'Ribosome inactivating protein', 196, NULL, 'RIP', 272352),
(453259, 'PF17950', NULL, 'S-adenosylmethionine decarboxylase N -terminal', 96, NULL, 'SpmSyn_N', 272353),
(453260, 'PF11209', NULL, 'LmeA-like phospholipid-binding', 219, NULL, 'LmeA', 272354),
(453261, 'PF05848', NULL, 'CtsR N-terminal HTH domain', 72, NULL, 'CtsR', 272355),
(453262, 'PF10643', NULL, 'Photosystem P840 reaction-centre cytochrome c-551', 213, NULL, 'Cytochrome-c551', 272356),
(453263, 'PF12262', NULL, 'Bacterial virulence factor lipase N-terminal', 237, NULL, 'Lipase_bact_N', 272357),
(453264, 'PF19226', NULL, 'DisA glycoprotein', 368, NULL, 'DisA', 272358),
(453265, 'PF14169', NULL, 'Cold-inducible protein YdjO', 59, NULL, 'YdjO', 272359),
(453266, 'PF04124', NULL, 'Dor1-like family', 336, NULL, 'Dor1', 272360),
(453267, 'PF11542', NULL, 'Mitochondrial division protein 1', 49, NULL, 'Mdv1', 272361),
(453268, 'PF02353', NULL, 'Mycolic acid cyclopropane synthetase', 273, NULL, 'CMAS', 272362),
(453269, 'PF09621', NULL, 'Type III secretion system regulator (LcrR)', 138, NULL, 'LcrR', 272363),
(453270, 'PF14746', NULL, 'WASH complex subunit 7, C-terminal', 175, NULL, 'WASH-7_C', 272364),
(453271, 'PF06236', NULL, 'Tyrosinase co-factor MelC1', 115, NULL, 'MelC1', 272365),
(453272, 'PF18478', NULL, 'PIN like domain', 84, NULL, 'PIN_10', 272366),
(453273, 'PF07825', NULL, 'Excisionase-like protein', 77, NULL, 'Exc', 272367),
(453274, 'PF18638', NULL, 'Cysteine-Rich Protective Antigen 6 bladed domain', 315, NULL, 'CyRPA', 272368),
(453275, 'PF06650', NULL, 'SHR-binding domain of vacuolar-sorting associated protein 13', 271, NULL, 'SHR-BD', 272369),
(453276, 'PF15515', NULL, 'MvaI/BcnI restriction endonuclease family', 231, NULL, 'MvaI_BcnI', 272370),
(453277, 'PF00941', NULL, 'FAD binding domain in molybdopterin dehydrogenase', 171, NULL, 'FAD_binding_5', 272371),
(453278, 'PF10087', NULL, 'Uncharacterized protein conserved in bacteria (DUF2325)', 94, NULL, 'DUF2325', 272372),
(453279, 'PF17943', NULL, 'Homeobox-cysteine loop-homeobox', 120, NULL, 'HOCHOB', 272373),
(453280, 'PF00995', NULL, 'Sec1 family', 577, NULL, 'Sec1', 272374),
(453281, 'PF08469', NULL, 'Nucleoside triphosphatase I C-terminal', 148, NULL, 'NPHI_C', 272375),
(453282, 'PF06617', NULL, 'M-phase inducer phosphatase', 274, NULL, 'M-inducer_phosp', 272376),
(453283, 'PF04702', NULL, 'Vicilin N terminal region', 147, NULL, 'Vicilin_N', 272377),
(453284, 'PF06938', NULL, 'Protein of unknown function (DUF1285)', 146, NULL, 'DUF1285', 272378),
(453285, 'PF17061', NULL, 'PARM', 297, NULL, 'PARM', 272379),
(453286, 'PF11142', NULL, 'Protein of unknown function (DUF2917)', 59, NULL, 'DUF2917', 272380),
(453287, 'PF06364', NULL, 'Protein of unknown function (DUF1068)', 167, NULL, 'DUF1068', 272381),
(453288, 'PF06023', NULL, 'CRISPR-associated exonuclease Csa1', 292, NULL, 'Csa1', 272382),
(453289, 'PF07193', NULL, 'Protein of unknown function (DUF1408)', 71, NULL, 'DUF1408', 272383),
(453290, 'PF08157', NULL, 'NUC129 domain', 63, NULL, 'NUC129', 272384),
(453291, 'PF10952', NULL, 'Protein of unknown function (DUF2753)', 140, NULL, 'DUF2753', 272385);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(453292, 'PF11199', NULL, 'Protein of unknown function (DUF2891)', 325, NULL, 'DUF2891', 272386),
(453293, 'PF17461', NULL, 'Family of unknown function (DUF5423)', 348, NULL, 'DUF5423', 272387),
(453294, 'PF05424', NULL, 'Duffy binding domain', 182, NULL, 'Duffy_binding', 272388),
(453295, 'PF18775', NULL, 'APOBEC4', 74, NULL, 'APOBEC4', 272389),
(453296, 'PF06370', NULL, 'Protein of unknown function (DUF1069)', 206, NULL, 'DUF1069', 272390),
(453297, 'PF20422', NULL, 'DHR-2, Lobe B', 78, NULL, 'DHR-2_Lobe_B', 272391),
(453298, 'PF16817', NULL, 'Domain of unknown function (DUF5073)', 121, NULL, 'DUF5073', 272392),
(453299, 'PF15925', NULL, 'SOSS complex subunit C', 101, NULL, 'SOSSC', 272393),
(453300, 'PF07438', NULL, 'Protein of unknown function (DUF1514)', 62, NULL, 'DUF1514', 272394),
(453301, 'PF16916', NULL, 'Dimerisation domain of Zinc Transporter', 79, NULL, 'ZT_dimer', 272395),
(453302, 'PF12633', NULL, 'Adenylate cyclase NT domain', 199, NULL, 'Adenyl_cycl_N', 272396),
(453303, 'PF04819', NULL, 'Family of unknown function (DUF716)', 138, NULL, 'DUF716', 272397),
(453304, 'PF04965', NULL, 'Baseplate wedge protein gp25', 95, NULL, 'GPW_gp25', 272398),
(453305, 'PF01068', NULL, 'ATP dependent DNA ligase domain', 204, NULL, 'DNA_ligase_A_M', 272399),
(453306, 'PF06220', NULL, 'U1 zinc finger', 38, NULL, 'zf-U1', 272400),
(453307, 'PF17929', NULL, 'Tetracyclin repressor-like, C-terminal domain', 120, NULL, 'TetR_C_34', 272401),
(453308, 'PF18108', NULL, 'QSOX Trx-like domain', 108, NULL, 'QSOX_Trx1', 272402),
(453309, 'PF20016', NULL, 'Domain of unknown function (DUF6430)', 184, NULL, 'DUF6430', 272403),
(453310, 'PF05307', NULL, 'Bundlin', 151, NULL, 'Bundlin', 272404),
(453311, 'PF15717', NULL, 'Pericentriolar material 1 C terminus', 616, NULL, 'PCM1_C', 272405),
(453312, 'PF08509', NULL, 'Adenylate cyclase G-alpha binding domain', 49, NULL, 'Ad_cyc_g-alpha', 272406),
(453313, 'PF14989', NULL, 'Coiled-coil domain containing 32', 150, NULL, 'CCDC32', 272407),
(453314, 'PF12789', NULL, 'Phage tail repeat like', 60, NULL, 'PTR', 272408),
(453315, 'PF01788', NULL, 'PsbJ', 39, NULL, 'PsbJ', 272409),
(453316, 'PF17883', NULL, 'MBG domain', 101, NULL, 'MBG', 272410),
(453317, 'PF06543', NULL, 'Lactococcus bacteriophage repressor', 49, NULL, 'Lac_bphage_repr', 272411),
(453318, 'PF08132', NULL, 'S-adenosyl-l-methionine decarboxylase leader peptide', 51, NULL, 'AdoMetDC_leader', 272412),
(453319, 'PF14399', NULL, 'Butirosin biosynthesis protein H, N-terminal', 134, NULL, 'BtrH_N', 272413),
(453320, 'PF07045', NULL, 'Domain of unknown function (DUF1330)', 94, NULL, 'DUF1330', 272414),
(453321, 'PF01049', NULL, 'Cadherin, Y-type LIR-motif', 60, NULL, 'CADH_Y-type_LIR', 272415),
(453322, 'PF06771', NULL, 'Viral Desmoplakin N-terminus', 90, NULL, 'Desmo_N', 272416),
(453323, 'PF10021', NULL, 'Uncharacterized protein conserved in bacteria (DUF2263)', 146, NULL, 'DUF2263', 272417),
(453324, 'PF19165', NULL, 'Family of unknown function (DUF5847)', 409, NULL, 'DUF5847', 272418),
(453325, 'PF09262', NULL, 'Peroxisome biogenesis factor 1, N-terminal', 77, NULL, 'PEX-1N', 272419),
(453326, 'PF07012', NULL, 'Curlin associated repeat', 34, NULL, 'Curlin_rpt', 272420),
(453327, 'PF17906', NULL, 'HTH domain in Mos1 transposase', 50, NULL, 'HTH_48', 272421),
(453328, 'PF07617', NULL, 'Protein of unknown function (DUF1579)', 155, NULL, 'DUF1579', 272422),
(453329, 'PF20314', NULL, 'Family of unknown function (DUF6610)', 198, NULL, 'DUF6610', 272423),
(453330, 'PF03105', NULL, 'SPX domain', 378, NULL, 'SPX', 272424),
(453331, 'PF02556', NULL, 'Preprotein translocase subunit SecB', 143, NULL, 'SecB', 272425),
(453332, 'PF11000', NULL, 'Protein of unknown function (DUF2840)', 148, NULL, 'DUF2840', 272426),
(453333, 'PF19849', NULL, 'Family of unknown function (DUF6324)', 60, NULL, 'DUF6324', 272427),
(453334, 'PF08839', NULL, 'DNA replication factor CDT1 like', 178, NULL, 'CDT1', 272428),
(453335, 'PF14791', NULL, 'DNA polymerase beta thumb', 68, NULL, 'DNA_pol_B_thumb', 272429),
(453336, 'PF19392', NULL, 'Family of unknown function (DUF5967)', 43, NULL, 'DUF5967', 272430);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(453337, 'PF08282', NULL, 'haloacid dehalogenase-like hydrolase', 255, NULL, 'Hydrolase_3', 272431),
(453338, 'PF07787', NULL, 'Transmembrane protein 43', 252, NULL, 'TMEM43', 272432),
(453339, 'PF05296', NULL, 'Taste receptor protein (TAS2R)', 303, NULL, 'TAS2R', 272433),
(453340, 'PF04874', NULL, 'Mak16 protein C-terminal region', 100, NULL, 'Mak16', 272434),
(453341, 'PF17418', NULL, 'Sporulation delaying protein SdpA', 142, NULL, 'SdpA', 272435),
(453342, 'PF18642', NULL, 'Immunomodulating metalloprotease helical domain', 109, NULL, 'IMPa_helical', 272436),
(453343, 'PF06702', NULL, 'Golgi casein kinase, C-terminal, Fam20', 218, NULL, 'Fam20C', 272437),
(453344, 'PF20019', NULL, 'vWA-MoxR associated protein middle region 20', 129, NULL, 'VMAP-M20', 272438),
(453345, 'PF01056', NULL, 'Myc amino-terminal region', 340, NULL, 'Myc_N', 272439),
(453346, 'PF10279', NULL, 'Latarcin precursor', 81, NULL, 'Latarcin', 272440),
(453347, 'PF02163', NULL, 'Peptidase family M50', 328, NULL, 'Peptidase_M50', 272441),
(453348, 'PF16306', NULL, 'Domain of unknown function (DUF4948)', 171, NULL, 'DUF4948', 272442),
(453349, 'PF10268', NULL, 'Predicted transmembrane protein 161AB', 481, NULL, 'Tmemb_161AB', 272443),
(453350, 'PF16085', NULL, 'Bacteriophage holin Hol, superfamily III', 113, NULL, 'Phage_holin_3_5', 272444),
(453351, 'PF03384', NULL, 'Drosophila protein of unknown function, DUF287', 55, NULL, 'DUF287', 272445),
(453352, 'PF17382', NULL, 'Uncharacterized Ycf70-like', 89, NULL, 'Ycf70', 272446),
(453353, 'PF18492', NULL, 'Open reading frame 2 N-terminal domain', 121, NULL, 'ORF_2_N', 272447),
(453354, 'PF17311', NULL, 'Family of unknown function (DUF5358)', 161, NULL, 'DUF5358', 272448),
(453355, 'PF19357', NULL, 'Family of unknown function (DUF5934)', 172, NULL, 'DUF5934', 272449),
(453356, 'PF16166', NULL, 'Chloroplast import apparatus Tic20-like', 181, NULL, 'TIC20', 272450),
(453357, 'PF18030', NULL, 'RimK PreATP-grasp domain', 94, NULL, 'Rimk_N', 272451),
(453358, 'PF16040', NULL, 'Domain of unknown function (DUF4792)', 71, NULL, 'DUF4792', 272452),
(453359, 'PF19237', NULL, 'Family of unknown function (DUF5889)', 115, NULL, 'DUF5889', 272453),
(453360, 'PF12009', NULL, 'Telomerase ribonucleoprotein complex - RNA binding domain', 134, NULL, 'Telomerase_RBD', 272454),
(453361, 'PF18357', NULL, 'Diphteria toxin repressor SH3 domain', 79, NULL, 'DtxR', 272455),
(453362, 'PF12544', NULL, 'Lysine-2,3-aminomutase', 127, NULL, 'LAM_C', 272456),
(453363, 'PF05081', NULL, 'Autographa californica nuclear polyhedrosis virus (AcMNPV), P18', 157, NULL, 'AcMNPV_P18', 272457),
(453364, 'PF00614', NULL, 'Phospholipase D Active site motif', 28, NULL, 'PLDc', 272458),
(453365, 'PF13351', NULL, 'Protein of unknown function (DUF4099)', 82, NULL, 'DUF4099', 272459),
(453366, 'PF07373', NULL, 'CAMP factor (Cfa)', 219, NULL, 'CAMP_factor', 272460),
(453367, 'PF12263', NULL, 'Protein of unknown function (DUF3611)', 175, NULL, 'DUF3611', 272461),
(453368, 'PF04301', NULL, 'Protein of unknown function (DUF452)', 213, NULL, 'DUF452', 272462),
(453369, 'PF18897', NULL, 'Recombination directionality factor-like', 198, NULL, 'Gp3-like', 272463),
(453370, 'PF00072', NULL, 'Response regulator receiver domain', 112, NULL, 'Response_reg', 272464),
(453371, 'PF14772', NULL, 'Sperm tail', 102, NULL, 'NYD-SP28', 272465),
(453372, 'PF18748', NULL, 'P-loop Nucleotide Kinase1', 196, NULL, 'Ploopntkinase1', 272466),
(453373, 'PF00517', NULL, 'Retroviral envelope protein', 197, NULL, 'GP41', 272467),
(453374, 'PF19344', NULL, 'Tetracyclin repressor-like, C-terminal domain', 139, NULL, 'TetR_C_32', 272468),
(453375, 'PF19584', NULL, 'MCAfunc domain', 143, NULL, 'MCAfunc', 272469),
(453376, 'PF01500', NULL, 'Keratin, high sulfur B2 protein', 164, NULL, 'Keratin_B2', 272470),
(453377, 'PF08676', NULL, 'MutL C terminal dimerisation domain', 146, NULL, 'MutL_C', 272471),
(453378, 'PF19884', NULL, 'Family of unknown function (DUF6357)', 417, NULL, 'DUF6357', 272472),
(453379, 'PF07376', NULL, 'Prosystemin', 202, NULL, 'Prosystemin', 272473);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(453380, 'PF00103', NULL, 'Somatotropin hormone family', 215, NULL, 'Hormone_1', 272474),
(453381, 'PF04647', NULL, 'Accessory gene regulator B', 183, NULL, 'AgrB', 272475),
(453382, 'PF15800', NULL, 'Clock interacting protein circadian', 338, NULL, 'CiPC', 272476),
(453383, 'PF18844', NULL, 'Bacterial archaeo-eukaryotic release factor family 2', 149, NULL, 'baeRF_family2', 272477),
(453384, 'PF01195', NULL, 'Peptidyl-tRNA hydrolase', 183, NULL, 'Pept_tRNA_hydro', 272478),
(453385, 'PF01639', NULL, 'Viral family 110', 104, NULL, 'v110', 272479),
(453386, 'PF03745', NULL, 'Domain of unknown function (DUF309)', 59, NULL, 'DUF309', 272480),
(453387, 'PF05389', NULL, 'Negative regulator of genetic competence (MecA)', 227, NULL, 'MecA', 272481),
(453388, 'PF18224', NULL, 'ToxB N-terminal domain', 61, NULL, 'ToxB_N', 272482),
(453389, 'PF10977', NULL, 'Protein of unknown function (DUF2797)', 233, NULL, 'DUF2797', 272483),
(453390, 'PF14681', NULL, 'Uracil phosphoribosyltransferase', 207, NULL, 'UPRTase', 272484),
(453391, 'PF01782', NULL, 'RimM N-terminal domain', 84, NULL, 'RimM', 272485),
(453392, 'PF04526', NULL, 'Protein of unknown function (DUF568)', 101, NULL, 'DUF568', 272486),
(453393, 'PF14528', NULL, 'LAGLIDADG-like domain', 83, NULL, 'LAGLIDADG_3', 272487),
(453394, 'PF00246', NULL, 'Zinc carboxypeptidase', 287, NULL, 'Peptidase_M14', 272488),
(453395, 'PF10288', NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', 111, NULL, 'CTU2', 272489),
(453396, 'PF13992', NULL, 'YecR-like lipoprotein', 73, NULL, 'YecR', 272490),
(453397, 'PF13576', NULL, 'Pentapeptide repeats (9 copies)', 48, NULL, 'Pentapeptide_3', 272491),
(453398, 'PF01417', NULL, 'ENTH domain', 125, NULL, 'ENTH', 272492),
(453399, 'PF01490', NULL, 'Transmembrane amino acid transporter protein', 409, NULL, 'Aa_trans', 272493),
(453400, 'PF11060', NULL, 'Protein of unknown function (DUF2861)', 260, NULL, 'DUF2861', 272494),
(453401, 'PF13631', NULL, 'Cytochrome b(N-terminal)/b6/petB', 169, NULL, 'Cytochrom_B_N_2', 272495),
(453402, 'PF10320', NULL, 'Serpentine type 7TM GPCR chemoreceptor Srsx', 257, NULL, '7TM_GPCR_Srsx', 272496),
(453403, 'PF02787', NULL, 'Carbamoyl-phosphate synthetase large chain, oligomerisation domain', 81, NULL, 'CPSase_L_D3', 272497),
(453404, 'PF06932', NULL, 'Protein of unknown function (DUF1283)', 83, NULL, 'DUF1283', 272498),
(453405, 'PF00791', NULL, 'ZU5 domain', 97, NULL, 'ZU5', 272499),
(453406, 'PF15535', NULL, 'Bacterial toxin 37', 64, NULL, 'Ntox37', 272500),
(453407, 'PF04898', NULL, 'Glutamate synthase central domain', 279, NULL, 'Glu_syn_central', 272501),
(453408, 'PF00815', NULL, 'Histidinol dehydrogenase', 409, NULL, 'Histidinol_dh', 272502),
(453409, 'PF04328', NULL, 'Selenoprotein, putative', 62, NULL, 'Sel_put', 272503),
(453410, 'PF05950', NULL, 'Orthopoxvirus A36R protein', 158, NULL, 'Orthopox_A36R', 272504),
(453411, 'PF15039', NULL, 'Domain of unknown function (DUF4530)', 113, NULL, 'DUF4530', 272505),
(453412, 'PF08470', NULL, 'Nontoxic nonhaemagglutinin C-terminal', 162, NULL, 'NTNH_C', 272506),
(453413, 'PF04175', NULL, 'Protein of unknown function (DUF406)', 92, NULL, 'DUF406', 272507),
(453414, 'PF09897', NULL, 'Uncharacterized protein conserved in archaea (DUF2124)', 141, NULL, 'DUF2124', 272508),
(453415, 'PF00405', NULL, 'Transferrin', 329, NULL, 'Transferrin', 272509),
(453416, 'PF14675', NULL, 'FANCI solenoid 1', 221, NULL, 'FANCI_S1', 272510),
(453417, 'PF20534', NULL, 'Domain of unknown function (DUF6749)', 139, NULL, 'DUF6749', 272511),
(453418, 'PF10481', NULL, 'Cenp-F N-terminal domain', 304, NULL, 'CENP-F_N', 272512),
(453419, 'PF12588', NULL, 'Phophatidylserine decarboxylase', 140, NULL, 'PSDC', 272513),
(453420, 'PF20243', NULL, 'MbnP', 195, NULL, 'MbnP', 272514),
(453421, 'PF10504', NULL, 'Protein of unknown function (DUF2452)', 156, NULL, 'DUF2452', 272515),
(453422, 'PF00290', NULL, 'Tryptophan synthase alpha chain', 259, NULL, 'Trp_syntA', 272516),
(453423, 'PF10138', NULL, 'vWA found in TerF C terminus', 200, NULL, 'vWA-TerF-like', 272517),
(453424, 'PF12900', NULL, 'Pyridoxamine 5''-phosphate oxidase', 142, NULL, 'Pyridox_ox_2', 272518);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(453425, 'PF13460', NULL, 'NAD(P)H-binding', 184, NULL, 'NAD_binding_10', 272519),
(453426, 'PF00922', NULL, 'Vesiculovirus phosphoprotein', 204, NULL, 'Phosphoprotein', 272520),
(453427, 'PF11396', NULL, 'Putative beta-lactamase-inhibitor-like, PepSY-like', 86, NULL, 'PepSY_like', 272521),
(453428, 'PF12383', NULL, 'Severe acute respiratory syndrome coronavirus 3b protein', 153, NULL, 'SARS_3b', 272522),
(453429, 'PF08226', NULL, 'Domain of unknown function (DUF1720)', 75, NULL, 'DUF1720', 272523),
(453430, 'PF01421', NULL, 'Reprolysin (M12B) family zinc metalloprotease', 200, NULL, 'Reprolysin', 272524),
(453431, 'PF18666', NULL, 'Carbohydrate-binding module 64', 74, NULL, 'CBM64', 272525),
(453432, 'PF15339', NULL, 'Acrosome formation-associated factor', 198, NULL, 'Afaf', 272526),
(453433, 'PF17142', NULL, 'Domain of unknown function (DUF5115)', 271, NULL, 'DUF5115', 272527),
(453434, 'PF01367', NULL, '5''-3'' exonuclease, C-terminal SAM fold', 97, NULL, '5_3_exonuc', 272528),
(453435, 'PF01739', NULL, 'CheR methyltransferase, SAM binding domain', 195, NULL, 'CheR', 272529),
(453436, 'PF19070', NULL, 'Family of unknown function (DUF5766)', 77, NULL, 'DUF5766', 272530),
(453437, 'PF03555', NULL, 'Influenza C non-structural protein (NS2)', 57, NULL, 'Flu_C_NS2', 272531),
(453438, 'PF04816', NULL, 'tRNA (adenine(22)-N(1))-methyltransferase', 205, NULL, 'TrmK', 272532),
(453439, 'PF12445', NULL, 'Flagellin protein', 129, NULL, 'FliC', 272533),
(453440, 'PF12579', NULL, 'Protein of unknown function (DUF3755)', 34, NULL, 'DUF3755', 272534),
(453441, 'PF05923', NULL, 'APC repeat', 24, NULL, 'APC_r', 272535),
(453442, 'PF18610', NULL, 'Periplasmic binding protein domain', 71, NULL, 'Peripla_BP_7', 272536),
(453443, 'PF08761', NULL, 'dUTPase', 164, NULL, 'dUTPase_2', 272537),
(453444, 'PF09167', NULL, 'Domain of unknown function (DUF1942)', 123, NULL, 'DUF1942', 272538),
(453445, 'PF09961', NULL, 'Uncharacterized protein conserved in bacteria (DUF2195)', 117, NULL, 'DUF2195', 272539),
(453446, 'PF05444', NULL, 'Protein of unknown function (DUF753)', 148, NULL, 'DUF753', 272540),
(453447, 'PF13088', NULL, 'BNR repeat-like domain', 275, NULL, 'BNR_2', 272541),
(453448, 'PF01848', NULL, 'Hok/gef family', 42, NULL, 'HOK_GEF', 272542),
(453449, 'PF02839', NULL, 'Carbohydrate binding domain', 25, NULL, 'CBM_5_12', 272543),
(453450, 'PF19683', NULL, 'Family of unknown function (DUF6185)', 810, NULL, 'DUF6185', 272544),
(453451, 'PF00307', NULL, 'Calponin homology (CH) domain', 109, NULL, 'CH', 272545),
(453452, 'PF03588', NULL, 'Leucyl/phenylalanyl-tRNA protein transferase', 169, NULL, 'Leu_Phe_trans', 272546),
(453453, 'PF17514', NULL, 'Family of unknown function (DUF5442)', 107, NULL, 'DUF5442', 272547),
(453454, 'PF03177', NULL, 'Non-repetitive/WGA-negative nucleoporin C-terminal', 597, NULL, 'Nucleoporin_C', 272548),
(453455, 'PF14174', NULL, 'YycC-like protein', 51, NULL, 'YycC', 272549),
(453456, 'PF11308', NULL, 'Glycosyl hydrolases related to GH101 family, GH129', 324, NULL, 'Glyco_hydro_129', 272550),
(453457, 'PF14900', NULL, 'Domain of unknown function (DUF4493)', 226, NULL, 'DUF4493', 272551),
(453458, 'PF14441', NULL, 'OTT_1508-like deaminase', 63, NULL, 'OTT_1508_deam', 272552),
(453459, 'PF01756', NULL, 'Acyl-CoA oxidase', 181, NULL, 'ACOX', 272553),
(453460, 'PF10544', NULL, 'T5orf172 domain', 104, NULL, 'T5orf172', 272554),
(453461, 'PF11385', NULL, 'Protein of unknown function (DUF3189)', 147, NULL, 'DUF3189', 272555),
(453462, 'PF14906', NULL, 'Domain of unknown function (DUF4495)', 318, NULL, 'DUF4495', 272556),
(453463, 'PF01342', NULL, 'SAND domain', 77, NULL, 'SAND', 272557),
(453464, 'PF07569', NULL, 'TUP1-like enhancer of split', 221, NULL, 'Hira', 272558),
(453465, 'PF20313', NULL, 'Family of unknown function (DUF6609)', 176, NULL, 'DUF6609', 272559),
(453466, 'PF10814', NULL, 'Cell wall synthesis protein CwsA', 133, NULL, 'CwsA', 272560),
(453467, 'PF16691', NULL, 'Domain of unknown function (DUF5062)', 83, NULL, 'DUF5062', 272561),
(453468, 'PF19112', NULL, 'Vanillate O-demethylase oxygenase C-terminal domain', 195, NULL, 'VanA_C', 272562);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(453469, 'PF15401', NULL, 'Tryptophan-ring motif of head of Trimeric autotransporter adhesin', 65, NULL, 'TAA-Trp-ring', 272563),
(453470, 'PF01864', NULL, 'CDP-archaeol synthase', 175, NULL, 'CarS-like', 272564),
(453471, 'PF13165', NULL, 'Six-cysteine peptide SCIFF', 44, NULL, 'SCIFF', 272565),
(453472, 'PF14043', NULL, 'WVELL protein', 74, NULL, 'WVELL', 272566),
(453473, 'PF03048', NULL, 'UL92 family', 191, NULL, 'Herpes_UL92', 272567),
(453474, 'PF06795', NULL, 'Erythrovirus X protein', 81, NULL, 'Erythrovirus_X', 272568),
(453475, 'PF12724', NULL, 'Flavodoxin domain', 144, NULL, 'Flavodoxin_5', 272569),
(453476, 'PF17148', NULL, 'Domain of unknown function (DUF5117)', 189, NULL, 'DUF5117', 272570),
(453477, 'PF01869', NULL, 'BadF/BadG/BcrA/BcrD ATPase family', 267, NULL, 'BcrAD_BadFG', 272571),
(453478, 'PF03115', NULL, 'Astrovirus capsid protein precursor', 400, NULL, 'Astro_capsid_N', 272572),
(453479, 'PF09837', NULL, 'Uncharacterized protein conserved in bacteria (DUF2064)', 123, NULL, 'DUF2064', 272573),
(453480, 'PF19409', NULL, 'Thiopeptide-type bacteriocin precursor', 36, NULL, 'Thiopep_pre', 272574),
(453481, 'PF12311', NULL, 'Protein of unknown function (DUF3632)', 175, NULL, 'DUF3632', 272575),
(453482, 'PF15587', NULL, 'Immunity protein 9', 149, NULL, 'Imm9', 272576),
(453483, 'PF18040', NULL, 'beta porphyranase A C-terminal', 95, NULL, 'BPA_C', 272577),
(453484, 'PF04711', NULL, 'Apolipoprotein A-II (ApoA-II)', 99, NULL, 'ApoA-II', 272578),
(453485, 'PF18646', NULL, 'Family of unknown function (DUF5632)', 81, NULL, 'DUF5632', 272579),
(453486, 'PF17731', NULL, 'Family of unknown function (DUF5570)', 123, NULL, 'DUF5570', 272580),
(453487, 'PF12380', NULL, 'Gill-associated viral 3C-like peptidase', 284, NULL, 'Peptidase_C62', 272581),
(453488, 'PF20238', NULL, 'Family of unknown function (DUF6595)', 144, NULL, 'DUF6595', 272582),
(453489, 'PF11685', NULL, 'Protein of unknown function (DUF3281)', 267, NULL, 'DUF3281', 272583),
(453490, 'PF15270', NULL, 'Metallo-carboxypeptidase inhibitor', 65, NULL, 'ACI44', 272584),
(453491, 'PF11430', NULL, 'Programmed cell death activator EGL-1', 20, NULL, 'EGL-1', 272585),
(453492, 'PF17870', NULL, 'Insulin receptor trans-membrane segment', 47, NULL, 'Insulin_TMD', 272586),
(453493, 'PF10482', NULL, 'Tumour-suppressor protein CtIP N-terminal domain', 120, NULL, 'CtIP_N', 272587),
(453494, 'PF13543', NULL, 'SAM like domain present in kinase suppressor RAS 1', 70, NULL, 'SAM_KSR1', 272588),
(453495, 'PF05969', NULL, 'Photosystem II complex subunit Ycf12', 33, NULL, 'PSII_Ycf12', 272589),
(453496, 'PF18979', NULL, 'Family of unknown function (DUF5715)', 170, NULL, 'DUF5715', 272590),
(453497, 'PF01575', NULL, 'MaoC like domain', 123, NULL, 'MaoC_dehydratas', 272591),
(453498, 'PF15086', NULL, 'Uncharacterised protein family UPF0542', 68, NULL, 'UPF0542', 272592),
(453499, 'PF13611', NULL, 'Serine peptidase of plant viral polyprotein, P1', 121, NULL, 'Peptidase_S76', 272593),
(453500, 'PF14983', NULL, 'Domain of unknown function (DUF4513)', 138, NULL, 'DUF4513', 272594),
(453501, 'PF07498', NULL, 'Rho termination factor, N-terminal domain', 43, NULL, 'Rho_N', 272595),
(453502, 'PF12702', NULL, 'Lipocalin-like', 94, NULL, 'Lipocalin_3', 272596),
(453503, 'PF19459', NULL, 'Family of unknown function (DUF5996)', 296, NULL, 'DUF5996', 272597),
(453504, 'PF03086', NULL, 'Domain of unknown function (DUF240)', 119, NULL, 'DUF240', 272598),
(453505, 'PF13051', NULL, 'Protein of unknown function (DUF3912)', 84, NULL, 'DUF3912', 272599),
(453506, 'PF14954', NULL, 'Limb expression 1', 249, NULL, 'LIX1', 272600),
(453507, 'PF03279', NULL, 'Bacterial lipid A biosynthesis acyltransferase', 295, NULL, 'Lip_A_acyltrans', 272601),
(453508, 'PF09005', NULL, 'Domain of unknown function (DUF1897)', 36, NULL, 'DUF1897', 272602),
(453509, 'PF19996', NULL, 'N-terminal helical region fused to the FtsH ternary system vWA domain', 258, NULL, 'ivWA-helical_N', 272603),
(453510, 'PF20463', NULL, 'Prephenate dehydrogenase, dimerization domain', 102, NULL, 'PDH_C', 272604);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(453511, 'PF01092', NULL, 'Ribosomal protein S6e', 124, NULL, 'Ribosomal_S6e', 272605),
(453512, 'PF15821', NULL, 'Domain of unknown function (DUF4709)', 110, NULL, 'DUF4709', 272606),
(453513, 'PF19802', NULL, 'Domain of unknown function (DUF6285)', 91, NULL, 'DUF6285', 272607),
(453514, 'PF01091', NULL, 'PTN/MK heparin-binding protein family, C-terminal domain', 65, NULL, 'PTN_MK_C', 272608),
(453515, 'PF08543', NULL, 'Phosphomethylpyrimidine kinase', 247, NULL, 'Phos_pyr_kin', 272609),
(453516, 'PF02030', NULL, 'Hypothetical lipoprotein (MG045 family)', 493, NULL, 'Lipoprotein_8', 272610),
(453517, 'PF03813', NULL, 'Nrap protein domain 1', 151, NULL, 'Nrap', 272611),
(453518, 'PF09357', NULL, 'RteC protein', 219, NULL, 'RteC', 272612),
(453519, 'PF17072', NULL, 'Torovirinae spike glycoprotein', 1291, NULL, 'Spike_torovirin', 272613),
(453520, 'PF18597', NULL, 'Myosin X N-terminal SH3 domain', 52, NULL, 'SH3_19', 272614),
(453521, 'PF00575', NULL, 'S1 RNA binding domain', 75, NULL, 'S1', 272615),
(453522, 'PF08051', NULL, 'Erythromycin resistance leader peptide', 15, NULL, 'Ery_res_leader1', 272616),
(453523, 'PF05513', NULL, 'TraA', 120, NULL, 'TraA', 272617),
(453524, 'PF13678', NULL, 'NFkB-p65-degrading zinc protease', 251, NULL, 'Peptidase_M85', 272618),
(453525, 'PF07785', NULL, 'Protein of unknown function (DUF1623)', 90, NULL, 'DUF1623', 272619),
(453526, 'PF19538', NULL, 'Family of unknown function (DUF6062)', 244, NULL, 'DUF6062', 272620),
(453527, 'PF03741', NULL, 'Integral membrane protein TerC family', 179, NULL, 'TerC', 272621),
(453528, 'PF04877', NULL, 'HrpZ', 308, NULL, 'Harpin', 272622),
(453529, 'PF11255', NULL, 'Protein of unknown function (DUF3054)', 114, NULL, 'DUF3054', 272623),
(453530, 'PF07933', NULL, 'Protein of unknown function (DUF1681)', 156, NULL, 'DUF1681', 272624),
(453531, 'PF07463', NULL, 'NUMOD4 motif', 50, NULL, 'NUMOD4', 272625),
(453532, 'PF12734', NULL, 'Cysteine-rich TM module stress tolerance', 42, NULL, 'CYSTM', 272626),
(453533, 'PF14921', NULL, 'Adenomatosis polyposis coli down-regulated 1', 236, NULL, 'APCDDC', 272627),
(453534, 'PF03574', NULL, 'Peptidase family S48', 149, NULL, 'Peptidase_S48', 272628),
(453535, 'PF09615', NULL, 'CRISPR-associated protein (Cas_Csy3)', 328, NULL, 'Cas_Csy3', 272629),
(453536, 'PF17958', NULL, 'EF-hand domain', 90, NULL, 'EF-hand_13', 272630),
(453537, 'PF09694', NULL, 'Bacterial protein of unknown function (Gcw_chp)', 230, NULL, 'Gcw_chp', 272631),
(453538, 'PF05497', NULL, 'Destabilase', 118, NULL, 'Destabilase', 272632),
(453539, 'PF09522', NULL, 'R.Pab1 restriction endonuclease', 119, NULL, 'RE_R_Pab1', 272633),
(453540, 'PF16344', NULL, 'Domain of unknown function (DUF4974)', 70, NULL, 'DUF4974', 272634),
(453541, 'PF17997', NULL, 'Insecticidal delta-endotoxin CryIA(c) domain 5', 173, NULL, 'Cry1Ac_D5', 272635),
(453542, 'PF13821', NULL, 'Domain of unknown function (DUF4187)', 54, NULL, 'DUF4187', 272636),
(453543, 'PF20618', NULL, 'Bacterial GPD, NAD-dependent C-terminal', 66, NULL, 'GPD_NAD_C_bact', 272637),
(453544, 'PF11992', NULL, 'TgpA N-terminal domain', 339, NULL, 'TgpA_N', 272638),
(453545, 'PF16109', NULL, 'Domain of unknown function (DUF4827)', 184, NULL, 'DUF4827', 272639),
(453546, 'PF02252', NULL, 'Proteasome activator pa28 beta subunit', 145, NULL, 'PA28_beta', 272640),
(453547, 'PF08639', NULL, 'DNA replication regulator SLD3', 539, NULL, 'SLD3', 272641),
(453548, 'PF13827', NULL, 'Domain of unknown function (DUF4189)', 97, NULL, 'DUF4189', 272642),
(453549, 'PF10922', NULL, 'Bacteriophage T7-like, gene 1.2', 85, NULL, 'T7-like_gp12', 272643),
(453550, 'PF15730', NULL, 'Domain of unknown function (DUF4680)', 144, NULL, 'DUF4680', 272644),
(453551, 'PF03567', NULL, 'Sulfotransferase family', 246, NULL, 'Sulfotransfer_2', 272645),
(453552, 'PF04504', NULL, 'Protein of unknown function, DUF573', 95, NULL, 'DUF573', 272646),
(453553, 'PF06653', NULL, 'Tight junction protein, Claudin-like', 165, NULL, 'Claudin_3', 272647),
(453554, 'PF13775', NULL, 'Domain of unknown function (DUF4171)', 125, NULL, 'DUF4171', 272648);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(453555, 'PF17538', NULL, 'DNA Binding Domain (C-terminal) Leafy/Floricaula', 169, NULL, 'C_LFY_FLO', 272649),
(453556, 'PF08921', NULL, 'Domain of unknown function (DUF1904)', 108, NULL, 'DUF1904', 272650),
(453557, 'PF04457', NULL, 'MJ1316 RNA cyclic group end recognition domain', 75, NULL, 'MJ1316', 272651),
(453558, 'PF19197', NULL, 'Family of unknown function (DUF5872)', 116, NULL, 'DUF5872', 272652),
(453559, 'PF17031', NULL, 'Domain of unknown function (DUF5101)', 99, NULL, 'DUF5101', 272653),
(453560, 'PF12628', NULL, 'Falstatin, cysteine peptidase inhibitor', 173, NULL, 'Inhibitor_I71', 272654),
(453561, 'PF10003', NULL, 'Integral membrane protein (DUF2244)', 139, NULL, 'DUF2244', 272655),
(453562, 'PF15943', NULL, 'Putative antitoxin of bacterial toxin-antitoxin system, YdaS/YdaT', 65, NULL, 'YdaS_antitoxin', 272656),
(453563, 'PF00581', NULL, 'Rhodanese-like domain', 107, NULL, 'Rhodanese', 272657),
(453564, 'PF12697', NULL, 'Alpha/beta hydrolase family', 220, NULL, 'Abhydrolase_6', 272658),
(453565, 'PF16386', NULL, 'Domain of unknown function', 73, NULL, 'DUF4995', 272659),
(453566, 'PF03257', NULL, 'Mycoplasma adhesin P1, C-terminal', 116, NULL, 'Adhesin_P1_C', 272660),
(453567, 'PF05505', NULL, 'Ebola nucleoprotein', 716, NULL, 'Ebola_NP', 272661),
(453568, 'PF16600', NULL, 'Caskin1 CASK-interaction domain', 59, NULL, 'Caskin1-CID', 272662),
(453569, 'PF06675', NULL, 'Protein of unknown function (DUF1177)', 272, NULL, 'DUF1177', 272663),
(453570, 'PF15809', NULL, 'Simian taste bud-specific gene product family', 238, NULL, 'STG', 272664),
(453571, 'PF18812', NULL, 'phage-Barnase-EndoU-ColicinE5/D-RelE like nuclease3', 115, NULL, 'PBECR3', 272665),
(453572, 'PF16727', NULL, 'DNA repair protein REV1 C-terminal domain', 92, NULL, 'REV1_C', 272666),
(453573, 'PF19580', NULL, 'Endonuclease/Exonuclease/phosphatase family', 311, NULL, 'Exo_endo_phos_3', 272667),
(453574, 'PF00814', NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', 271, NULL, 'TsaD', 272668),
(453575, 'PF11447', NULL, 'Protein of unknown function (DUF3201)', 151, NULL, 'DUF3201', 272669),
(453576, 'PF03527', NULL, 'RHS protein', 38, NULL, 'RHS', 272670),
(453577, 'PF10779', NULL, 'Haemolysin XhlA', 67, NULL, 'XhlA', 272671),
(453578, 'PF09872', NULL, 'Uncharacterized protein conserved in archaea (DUF2099)', 257, NULL, 'DUF2099', 272672),
(453579, 'PF05928', NULL, 'Zea mays MURB-like protein (MuDR)', 207, NULL, 'Zea_mays_MuDR', 272673),
(453580, 'PF14937', NULL, 'Domain of unknown function (DUF4500)', 81, NULL, 'DUF4500', 272674),
(453581, 'PF16270', NULL, 'Lipocalin-like domain (DUF4923)', 176, NULL, 'DUF4923', 272675),
(453582, 'PF03099', NULL, 'Biotin/lipoate A/B protein ligase family', 133, NULL, 'BPL_LplA_LipB', 272676),
(453583, 'PF04478', NULL, 'Mid2 like cell wall stress sensor', 150, NULL, 'Mid2', 272677),
(453584, 'PF14440', NULL, 'Xanthomonas XOO_2897-like deaminase', 101, NULL, 'XOO_2897-deam', 272678),
(453585, 'PF03173', NULL, 'Putative carbohydrate binding domain', 159, NULL, 'CHB_HEX', 272679),
(453586, 'PF01629', NULL, 'Domain of unknown function DUF22', 106, NULL, 'DUF22', 272680),
(453587, 'PF03873', NULL, 'Anti sigma-E protein RseA, C-terminal domain', 55, NULL, 'RseA_C', 272681),
(453588, 'PF16748', NULL, 'Inscuteable LGN-binding domain', 47, NULL, 'INSC_LBD', 272682),
(453589, 'PF11698', NULL, 'V-ATPase subunit H', 117, NULL, 'V-ATPase_H_C', 272683),
(453590, 'PF14706', NULL, 'Transposase DNA-binding', 58, NULL, 'Tnp_DNA_bind', 272684),
(453591, 'PF01777', NULL, 'Ribosomal L27e protein family', 85, NULL, 'Ribosomal_L27e', 272685),
(453592, 'PF13158', NULL, 'Protein of unknown function (DUF3993)', 118, NULL, 'DUF3993', 272686),
(453593, 'PF07004', NULL, 'Sperm-tail PG-rich repeat', 31, NULL, 'SHIPPO-rpt', 272687),
(453594, 'PF17207', NULL, 'MCM OB domain', 126, NULL, 'MCM_OB', 272688),
(453595, 'PF04038', NULL, 'Dihydroneopterin aldolase', 108, NULL, 'DHNA', 272689),
(453596, 'PF00981', NULL, 'Rotavirus RNA-binding Protein 53 (NS53)', 488, NULL, 'Rota_NS53', 272690),
(453597, 'PF08889', NULL, 'WbqC-like protein family', 218, NULL, 'WbqC', 272691);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(453598, 'PF09795', NULL, 'Autophagy-related protein 31', 158, NULL, 'ATG31', 272692),
(453599, 'PF00434', NULL, 'Glycoprotein VP7', 323, NULL, 'VP7', 272693),
(453600, 'PF18572', NULL, 'Trehalose-6-phosphate phosphatase N-terminal helical bundle domain', 100, NULL, 'T6PP_N', 272694),
(453601, 'PF01649', NULL, 'Ribosomal protein S20', 82, NULL, 'Ribosomal_S20p', 272695),
(453602, 'PF06161', NULL, 'Protein of unknown function (DUF975)', 243, NULL, 'DUF975', 272696),
(453603, 'PF03583', NULL, 'Secretory lipase', 286, NULL, 'LIP', 272697),
(453604, 'PF09423', NULL, 'PhoD-like phosphatase', 350, NULL, 'PhoD', 272698),
(453605, 'PF08110', NULL, 'Ocellatin family', 19, NULL, 'Antimicrobial15', 272699),
(453606, 'PF13251', NULL, 'Domain of unknown function (DUF4042)', 182, NULL, 'DUF4042', 272700),
(453607, 'PF08756', NULL, 'YfkB-like domain', 151, NULL, 'YfkB', 272701),
(453608, 'PF10521', NULL, 'Tti2 family', 281, NULL, 'Tti2', 272702),
(453609, 'PF12898', NULL, 'Stc1 domain', 85, NULL, 'Stc1', 272703),
(453610, 'PF11505', NULL, 'Protein of unknown function (DUF3216)', 91, NULL, 'DUF3216', 272704),
(453611, 'PF16039', NULL, 'Domain of unknown function (DUF4791)', 164, NULL, 'DUF4791', 272705),
(453612, 'PF13691', NULL, 'tRNase Z endonuclease', 63, NULL, 'Lactamase_B_4', 272706),
(453613, 'PF15429', NULL, 'Domain of unknown function (DUF4628)', 273, NULL, 'DUF4628', 272707),
(453614, 'PF15551', NULL, 'Domain of unknown function (DUF4656)', 361, NULL, 'DUF4656', 272708),
(453615, 'PF05827', NULL, 'V-type proton ATPase subunit S1, luminal domain', 140, NULL, 'VAS1_LD', 272709),
(453616, 'PF07166', NULL, 'Protein of unknown function (DUF1398)', 119, NULL, 'DUF1398', 272710),
(453617, 'PF08958', NULL, 'Domain of unknown function (DUF1871)', 77, NULL, 'DUF1871', 272711),
(453618, 'PF01097', NULL, 'Arthropod defensin', 34, NULL, 'Defensin_2', 272712),
(453619, 'PF10714', NULL, 'Late embryogenesis abundant protein 18', 75, NULL, 'LEA_6', 272713),
(453620, 'PF10373', NULL, 'Est1 DNA/RNA binding domain', 285, NULL, 'EST1_DNA_bind', 272714),
(453621, 'PF15654', NULL, 'Toxin with a conserved tryptophan and TIP tripeptide motif', 67, NULL, 'Tox-WTIP', 272715),
(453622, 'PF15978', NULL, 'Tn7-like transposition protein D', 360, NULL, 'TnsD', 272716),
(453623, 'PF09773', NULL, 'Meckelin (Transmembrane protein 67)', 826, NULL, 'Meckelin', 272717),
(453624, 'PF07088', NULL, 'GvpD gas vesicle protein, P-loop domain', 189, NULL, 'GvpD_P-loop', 272718),
(453625, 'PF01320', NULL, 'Colicin immunity protein / pyocin immunity protein', 82, NULL, 'Colicin_Pyocin', 272719),
(453626, 'PF05176', NULL, 'ATP10 protein', 257, NULL, 'ATP-synt_10', 272720),
(453627, 'PF18173', NULL, 'Bacterial HORMA domain 2', 166, NULL, 'bacHORMA_2', 272721),
(453628, 'PF04357', NULL, 'TamB, inner membrane protein subunit of TAM complex', 383, NULL, 'TamB', 272722),
(453629, 'PF18146', NULL, 'Damage-inducible protein CinA KH domain', 73, NULL, 'CinA_KH', 272723),
(453630, 'PF09772', NULL, 'Transmembrane protein 26', 285, NULL, 'Tmem26', 272724),
(453631, 'PF12409', NULL, 'P5-type ATPase cation transporter', 126, NULL, 'P5-ATPase', 272725),
(453632, 'PF18078', NULL, 'Thioredoxin-like SNTX domain', 126, NULL, 'Thioredoxin_11', 272726),
(453633, 'PF01096', NULL, 'Transcription factor S-II (TFIIS)', 39, NULL, 'TFIIS_C', 272727),
(453634, 'PF04107', NULL, 'Glutamate-cysteine ligase family 2(GCS2)', 291, NULL, 'GCS2', 272728),
(453635, 'PF09699', NULL, 'Doubled CXXCH motif (Paired_CXXCH_1)', 42, NULL, 'Paired_CXXCH_1', 272729),
(453636, 'PF12941', NULL, 'HCV NS5a protein C-terminal region', 242, NULL, 'HCV_NS5a_C', 272730),
(453637, 'PF02565', NULL, 'Recombination protein O C terminal', 157, NULL, 'RecO_C', 272731),
(453638, 'PF15994', NULL, 'Domain of unknown function (DUF4770)', 182, NULL, 'DUF4770', 272732),
(453639, 'PF10697', NULL, 'Protein of unknown function (DUF2502)', 90, NULL, 'DUF2502', 272733),
(453640, 'PF18293', NULL, 'Caprin-1 dimerization domain', 116, NULL, 'Caprin-1_dimer', 272734),
(453641, 'PF02375', NULL, 'jmjN domain', 34, NULL, 'JmjN', 272735);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(453642, 'PF08794', NULL, 'Lipoprotein GNA1870 C terminal like', 155, NULL, 'Lipoprot_C', 272736),
(453643, 'PF13388', NULL, 'Protein of unknown function (DUF4106)', 420, NULL, 'DUF4106', 272737),
(453644, 'PF18363', NULL, 'Phosphoinositide phosphatase insertion domain', 97, NULL, 'PI_PP_I', 272738),
(453645, 'PF03102', NULL, 'NeuB family', 241, NULL, 'NeuB', 272739),
(453646, 'PF06183', NULL, 'DinI-like family', 63, NULL, 'DinI', 272740),
(453647, 'PF07705', NULL, 'CARDB', 102, NULL, 'CARDB', 272741),
(453648, 'PF18229', NULL, 'N-acetyl-beta-D-glucosaminidase N-terminal domain', 78, NULL, 'GcnA_N', 272742),
(453649, 'PF19850', NULL, 'Family of unknown function (DUF6325)', 141, NULL, 'DUF6325', 272743),
(453650, 'PF00206', NULL, 'Lyase', 312, NULL, 'Lyase_1', 272744),
(453651, 'PF00961', NULL, 'LAGLIDADG endonuclease', 102, NULL, 'LAGLIDADG_1', 272745),
(453652, 'PF20284', NULL, 'C-terminal domain 8 of the ABC-three component (ABC-3C) systems', 127, NULL, 'CTD8', 272746),
(453653, 'PF11464', NULL, 'Rabenosyn Rab binding domain', 42, NULL, 'Rbsn', 272747),
(453654, 'PF17252', NULL, 'Family of unknown function (DUF5319)', 121, NULL, 'DUF5319', 272748),
(453655, 'PF03320', NULL, 'Bacterial fructose-1,6-bisphosphatase, glpX-encoded', 308, NULL, 'FBPase_glpX', 272749),
(453656, 'PF00329', NULL, 'Respiratory-chain NADH dehydrogenase, 30 Kd subunit', 121, NULL, 'Complex1_30kDa', 272750),
(453657, 'PF12144', NULL, 'Eukaryotic Mediator 12 catenin-binding domain', 210, NULL, 'Med12-PQL', 272751),
(453658, 'PF16977', NULL, 'C-terminal domain of apextrin', 207, NULL, 'ApeC', 272752),
(453659, 'PF16011', NULL, 'Carbohydrate-binding family 9', 199, NULL, 'CBM9_2', 272753),
(453660, 'PF14492', NULL, 'Elongation Factor G, domain III', 75, NULL, 'EFG_III', 272754),
(453661, 'PF13025', NULL, 'Protein of unknown function (DUF3886)', 68, NULL, 'DUF3886', 272755),
(453662, 'PF09438', NULL, 'Domain of unknown function (DUF2017)', 177, NULL, 'DUF2017', 272756),
(453663, 'PF07062', NULL, 'Clc-like', 212, NULL, 'Clc-like', 272757),
(453664, 'PF14935', NULL, 'Transmembrane protein 138', 119, NULL, 'TMEM138', 272758),
(453665, 'PF03597', NULL, 'Cytochrome oxidase maturation protein cbb3-type', 44, NULL, 'FixS', 272759),
(453666, 'PF01712', NULL, 'Deoxynucleoside kinase', 204, NULL, 'dNK', 272760),
(453667, 'PF09652', NULL, 'Putative CRISPR-associated protein (Cas_VVA1548)', 91, NULL, 'Cas_VVA1548', 272761),
(453668, 'PF01867', NULL, 'CRISPR associated protein Cas1', 283, NULL, 'Cas_Cas1', 272762),
(453669, 'PF06098', NULL, 'Radial spoke protein 3', 286, NULL, 'Radial_spoke_3', 272763),
(453670, 'PF05616', NULL, 'Neisseria meningitidis TspB protein', 517, NULL, 'Neisseria_TspB', 272764),
(453671, 'PF02257', NULL, 'RFX DNA-binding domain', 79, NULL, 'RFX_DNA_binding', 272765),
(453672, 'PF06991', NULL, 'Microfibril-associated/Pre-mRNA processing', 221, NULL, 'MFAP1', 272766),
(453673, 'PF04792', NULL, 'V antigen (LcrV) protein', 323, NULL, 'LcrV', 272767),
(453674, 'PF05294', NULL, 'Scorpion short toxin', 32, NULL, 'Toxin_5', 272768),
(453675, 'PF11149', NULL, 'Protein of unknown function (DUF2924)', 135, NULL, 'DUF2924', 272769),
(453676, 'PF17156', NULL, 'Gammaproteobacterial periplasmic sensor domain', 204, NULL, 'GAPES2', 272770),
(453677, 'PF06331', NULL, 'Transcription factor TFIIH complex subunit Tfb5', 68, NULL, 'Tfb5', 272771),
(453678, 'PF13906', NULL, 'C-terminus of AA_permease', 51, NULL, 'AA_permease_C', 272772),
(453679, 'PF01149', NULL, 'Formamidopyrimidine-DNA glycosylase N-terminal domain', 119, NULL, 'Fapy_DNA_glyco', 272773),
(453680, 'PF08237', NULL, 'PE-PPE domain', 227, NULL, 'PE-PPE', 272774),
(453681, 'PF07445', NULL, 'Primosomal replication protein priC', 174, NULL, 'PriC', 272775),
(453682, 'PF00596', NULL, 'Class II Aldolase and Adducin N-terminal domain', 186, NULL, 'Aldolase_II', 272776),
(453683, 'PF18418', NULL, 'Ankyrin ubiquitin-binding domain', 97, NULL, 'AnkUBD', 272777),
(453684, 'PF07719', NULL, 'Tetratricopeptide repeat', 34, NULL, 'TPR_2', 272778),
(453685, 'PF05338', NULL, 'Protein of unknown function (DUF717)', 55, NULL, 'DUF717', 272779);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(453686, 'PF00378', NULL, 'Enoyl-CoA hydratase/isomerase', 251, NULL, 'ECH_1', 272780),
(453687, 'PF12530', NULL, 'Focadhesin/RST1, DUF3730', 229, NULL, 'DUF3730', 272781),
(453688, 'PF18577', NULL, 'Astrotactin-2 C-terminal beta-hairpin domain', 47, NULL, 'ASTN_2_hairpin', 272782),
(453689, 'PF04824', NULL, 'Conserved region of Rad21 / Rec8 like protein', 55, NULL, 'Rad21_Rec8', 272783),
(453690, 'PF19762', NULL, 'Domain of unknown function (DUF6249)', 104, NULL, 'DUF6249', 272784),
(453691, 'PF16456', NULL, 'YmgD protein', 82, NULL, 'YmgD', 272785),
(453692, 'PF01415', NULL, 'Interleukin 7', 134, NULL, 'IL7', 272786),
(453693, 'PF14086', NULL, 'Domain of unknown function (DUF4266)', 50, NULL, 'DUF4266', 272787),
(453694, 'PF17506', NULL, 'Family of unknown function (DUF5438)', 71, NULL, 'DUF5438', 272788),
(453695, 'PF05644', NULL, 'Mitochondrial and peroxisomal fission factor Mff', 292, NULL, 'Miff', 272789),
(453696, 'PF08633', NULL, 'Rox3 mediator complex subunit', 204, NULL, 'Rox3', 272790),
(453697, 'PF12360', NULL, 'Paired box protein 7', 45, NULL, 'Pax7', 272791),
(453698, 'PF10062', NULL, 'Predicted secreted protein (DUF2300)', 127, NULL, 'DUF2300', 272792),
(453699, 'PF14208', NULL, 'Domain of unknown function (DUF4320)', 118, NULL, 'DUF4320', 272793),
(453700, 'PF19452', NULL, 'Family of unknown function (DUF5990)', 141, NULL, 'DUF5990', 272794),
(453701, 'PF12565', NULL, 'Protein of unknown function (DUF3747)', 175, NULL, 'DUF3747', 272795),
(453702, 'PF05599', NULL, 'Deltaretrovirus Tax protein', 87, NULL, 'Deltaretro_Tax', 272796),
(453703, 'PF00645', NULL, 'Poly(ADP-ribose) polymerase and DNA-Ligase Zn-finger region', 82, NULL, 'zf-PARP', 272797),
(453704, 'PF11948', NULL, 'Protein of unknown function (DUF3465)', 124, NULL, 'DUF3465', 272798),
(453705, 'PF11787', NULL, 'Aft1 HRR domain', 71, NULL, 'Aft1_HRR', 272799),
(453706, 'PF17610', NULL, 'Family of unknown function (DUF5505)', 156, NULL, 'DUF5505', 272800),
(453707, 'PF18837', NULL, 'Leucine-rich repeat', 30, NULL, 'LRR_12', 272801),
(453708, 'PF18702', NULL, 'Domain of unknown function (DUF5642)', 186, NULL, 'DUF5642', 272802),
(453709, 'PF05604', NULL, 'Protein of unknown function (DUF776)', 182, NULL, 'DUF776', 272803),
(453710, 'PF01958', NULL, 'Aspartate dehydrogenase, C-terminal', 89, NULL, 'Asp_DH_C', 272804),
(453711, 'PF08750', NULL, 'CNP1-like family', 135, NULL, 'CNP1', 272805),
(453712, 'PF11803', NULL, 'UDP-glucuronate decarboxylase N-terminal', 75, NULL, 'UXS1_N', 272806),
(453713, 'PF16139', NULL, 'Domain of unknown function (DUF4847)', 147, NULL, 'DUF4847', 272807),
(453714, 'PF08327', NULL, 'Activator of Hsp90 ATPase homolog 1-like protein', 126, NULL, 'AHSA1', 272808),
(453715, 'PF17144', NULL, 'Ribosomal large subunit proteins 60S L5, and 50S L18', 163, NULL, 'Ribosomal_L5e', 272809),
(453716, 'PF17724', NULL, 'Family of unknown function (DUF5568)', 185, NULL, 'DUF5568', 272810),
(453717, 'PF18742', NULL, 'REase_DpnII-MboI', 150, NULL, 'DpnII-MboI', 272811),
(453718, 'PF04865', NULL, 'Baseplate J-like protein', 254, NULL, 'Baseplate_J', 272812),
(453719, 'PF14055', NULL, 'NVEALA protein', 65, NULL, 'NVEALA', 272813),
(453720, 'PF17767', NULL, 'Nicotinate phosphoribosyltransferase (NAPRTase) N-terminal domain', 125, NULL, 'NAPRTase_N', 272814),
(453721, 'PF18861', NULL, 'TM proximal of protein tyrosine phosphatase, receptor type J', 126, NULL, 'PTP_tm', 272815),
(453722, 'PF12396', NULL, 'Protein of unknown function (DUF3659)', 61, NULL, 'DUF3659', 272816),
(453723, 'PF16781', NULL, 'Domain of unknown function (DUF5068)', 187, NULL, 'DUF5068', 272817),
(453724, 'PF04453', NULL, 'LPS transport system D', 387, NULL, 'LptD', 272818),
(453725, 'PF09933', NULL, 'Predicted small integral membrane protein (DUF2165)', 157, NULL, 'DUF2165', 272819),
(453726, 'PF12416', NULL, 'Cep120 protein', 226, NULL, 'DUF3668', 272820),
(453727, 'PF18003', NULL, 'Domain of unknown function (DUF3823_C)', 106, NULL, 'DUF3823_C', 272821),
(453728, 'PF07410', NULL, 'Streptococcus thermophilus bacteriophage Gp111 protein', 117, NULL, 'Phage_Gp111', 272822);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(453729, 'PF10369', NULL, 'Small subunit of acetolactate synthase', 74, NULL, 'ALS_ss_C', 272823),
(453730, 'PF05565', NULL, 'Siphovirus Gp157', 163, NULL, 'Sipho_Gp157', 272824),
(453731, 'PF12903', NULL, 'Protein of unknown function (DUF3830)', 144, NULL, 'DUF3830', 272825),
(453732, 'PF00218', NULL, 'Indole-3-glycerol phosphate synthase', 254, NULL, 'IGPS', 272826),
(453733, 'PF04571', NULL, 'lipin, N-terminal conserved region', 103, NULL, 'Lipin_N', 272827),
(453734, 'PF13932', NULL, 'tRNA modifying enzyme MnmG/GidA C-terminal domain', 210, NULL, 'GIDA_C', 272828),
(453735, 'PF16110', NULL, 'Domain of unknown function (DUF4828)', 79, NULL, 'DUF4828', 272829),
(453736, 'PF12652', NULL, 'CotJB protein', 76, NULL, 'CotJB', 272830),
(453737, 'PF00640', NULL, 'Phosphotyrosine interaction domain (PTB/PID)', 140, NULL, 'PID', 272831),
(453738, 'PF00789', NULL, 'UBX domain', 81, NULL, 'UBX', 272832),
(453739, 'PF01734', NULL, 'Patatin-like phospholipase', 204, NULL, 'Patatin', 272833),
(453740, 'PF01491', NULL, 'Frataxin-like domain', 109, NULL, 'Frataxin_Cyay', 272834),
(453741, 'PF00209', NULL, 'Sodium:neurotransmitter symporter family', 523, NULL, 'SNF', 272835),
(453742, 'PF19994', NULL, 'GTPase-associated system helical domain', 377, NULL, 'GASH', 272836),
(453743, 'PF15576', NULL, 'Domain of unknown function (DUF4661)', 253, NULL, 'DUF4661', 272837),
(453744, 'PF12219', NULL, 'Catalytic domain of bacteriophage endosialidase', 160, NULL, 'End_tail_spike', 272838),
(453745, 'PF11324', NULL, 'Protein of unknown function (DUF3126)', 63, NULL, 'DUF3126', 272839),
(453746, 'PF16314', NULL, 'Domain of unknown function (DUF4954)', 655, NULL, 'DUF4954', 272840),
(453747, 'PF02735', NULL, 'Ku70/Ku80 beta-barrel domain', 204, NULL, 'Ku', 272841),
(453748, 'PF18254', NULL, 'HMW1 domain 2', 88, NULL, 'HMw1_D2', 272842),
(453749, 'PF04993', NULL, 'TfoX N-terminal domain', 91, NULL, 'TfoX_N', 272843),
(453750, 'PF11273', NULL, 'Protein of unknown function (DUF3073)', 63, NULL, 'DUF3073', 272844),
(453751, 'PF12886', NULL, 'Transducer of regulated CREB activity, C terminus', 75, NULL, 'TORC_C', 272845),
(453752, 'PF17917', NULL, 'RNase H-like domain found in reverse transcriptase', 105, NULL, 'RT_RNaseH', 272846),
(453753, 'PF08255', NULL, 'Trp-operon Leader Peptide', 14, NULL, 'Leader_Trp', 272847),
(453754, 'PF17573', NULL, 'GA-like domain', 50, NULL, 'GA-like', 272848),
(453755, 'PF00734', NULL, 'Fungal cellulose binding domain', 29, NULL, 'CBM_1', 272849),
(453756, 'PF12551', NULL, 'Poly-beta-hydroxybutyrate polymerase N terminal', 43, NULL, 'PHBC_N', 272850),
(453757, 'PF04564', NULL, 'U-box domain', 73, NULL, 'U-box', 272851),
(453758, 'PF00935', NULL, 'Ribosomal protein L44', 76, NULL, 'Ribosomal_L44', 272852),
(453759, 'PF17218', NULL, 'CBX family C-terminal motif', 34, NULL, 'CBX7_C', 272853),
(453760, 'PF18373', NULL, 'Spectrin like domain', 78, NULL, 'Spectrin_like', 272854),
(453761, 'PF17996', NULL, 'Carbohydrate esterase 2 N-terminal', 110, NULL, 'CE2_N', 272855),
(453762, 'PF00189', NULL, 'Ribosomal protein S3, C-terminal domain', 83, NULL, 'Ribosomal_S3_C', 272856),
(453763, 'PF07418', NULL, 'Acidic phosphoprotein precursor PCEMA1', 294, NULL, 'PCEMA1', 272857),
(453764, 'PF10053', NULL, 'Uncharacterized conserved protein (DUF2290)', 195, NULL, 'DUF2290', 272858),
(453765, 'PF00763', NULL, 'Tetrahydrofolate dehydrogenase/cyclohydrolase, catalytic domain', 114, NULL, 'THF_DHG_CYH', 272859),
(453766, 'PF05936', NULL, 'Bacterial Type VI secretion, VC_A0110, EvfL, ImpJ, VasE', 429, NULL, 'T6SS_VasE', 272860),
(453767, 'PF12629', NULL, 'Poxvirus poly(A) polymerase C-terminal domain', 201, NULL, 'Pox_polyA_pol_C', 272861),
(453768, 'PF17692', NULL, 'Family of unknown function (DUF5538)', 130, NULL, 'DUF5538', 272862),
(453769, 'PF18218', NULL, 'Lantibiotic immunity protein Spa1 C-terminal domain', 99, NULL, 'Spa1_C', 272863),
(453770, 'PF07819', NULL, 'PGAP1-like protein', 231, NULL, 'PGAP1', 272864),
(453771, 'PF10622', NULL, 'Energy-converting hydrogenase B subunit P (EhbP)', 77, NULL, 'Ehbp', 272865);
INSERT INTO "PUBLIC"."MODEL" VALUES
(453772, 'PF01118', NULL, 'Semialdehyde dehydrogenase, NAD binding domain', 121, NULL, 'Semialdhyde_dh', 272866),
(453773, 'PF03348', NULL, 'Serine incorporator (Serinc)', 435, NULL, 'Serinc', 272867),
(453774, 'PF04981', NULL, 'NMD3 family', 243, NULL, 'NMD3', 272868),
(453775, 'PF02332', NULL, 'Methane/Phenol/Toluene Hydroxylase', 230, NULL, 'Phenol_Hydrox', 272869),
(453776, 'PF06564', NULL, 'Cellulose biosynthesis protein BcsQ', 234, NULL, 'CBP_BcsQ', 272870),
(453777, 'PF20253', NULL, 'Family of unknown function (DUF6604)', 250, NULL, 'DUF6604', 272871),
(453778, 'PF01921', NULL, 'tRNA synthetases class I (K)', 361, NULL, 'tRNA-synt_1f', 272872),
(453779, 'PF10756', NULL, 'Bacterial PH domain', 73, NULL, 'bPH_6', 272873),
(453780, 'PF12499', NULL, 'Pherophorin', 143, NULL, 'DUF3707', 272874),
(453781, 'PF04163', NULL, 'Tht1-like nuclear fusion protein', 544, NULL, 'Tht1', 272875),
(453782, 'PF19811', NULL, 'Family of unknown function (DUF6294)', 89, NULL, 'DUF6294', 272876),
(453783, 'PF07593', NULL, 'ASPIC and UnbV', 68, NULL, 'UnbV_ASPIC', 272877),
(453784, 'PF14523', NULL, 'Syntaxin-like protein', 101, NULL, 'Syntaxin_2', 272878),
(453785, 'PF10865', NULL, 'Domain of unknown function (DUF2703)', 120, NULL, 'DUF2703', 272879),
(453786, 'PF20191', NULL, 'Family of unknown function (DUF6554)', 106, NULL, 'DUF6554', 272880),
(453787, 'PF09350', NULL, 'DnaJ homologue, subfamily C, member 28, conserved domain', 70, NULL, 'DJC28_CD', 272881),
(453788, 'PF06191', NULL, 'Protein of unknown function (DUF995)', 140, NULL, 'DUF995', 272882),
(453789, 'PF13762', NULL, 'Mitochondrial splicing apparatus component', 150, NULL, 'MNE1', 272883),
(453790, 'PF16937', NULL, 'Type III secretion system translocator protein, HrpF', 256, NULL, 'T3SS_HrpK1', 272884),
(453791, 'PF06219', NULL, 'Protein of unknown function (DUF1005)', 437, NULL, 'DUF1005', 272885),
(453792, 'PF15201', NULL, 'Progressive rod-cone degeneration', 54, NULL, 'Rod_cone_degen', 272886),
(453793, 'PF20093', NULL, 'Domain of unknown function (DUF6484)', 61, NULL, 'DUF6484', 272887),
(453794, 'PF13270', NULL, 'Coiled-coil domain-containing protein 28', 88, NULL, 'CCDC28', 272888),
(453795, 'PF19123', NULL, 'Family of unknown function (DUF5807)', 106, NULL, 'DUF5807', 272889),
(453796, 'PF09742', NULL, 'Dyggve-Melchior-Clausen syndrome protein', 688, NULL, 'Dymeclin', 272890),
(453797, 'PF13910', NULL, 'Domain of unknown function (DUF4209)', 89, NULL, 'DUF4209', 272891),
(453798, 'PF06081', NULL, 'Aromatic acid exporter family member 1', 141, NULL, 'ArAE_1', 272892),
(453799, 'PF17952', NULL, 'Cas6 N-terminal domain', 114, NULL, 'Cas6_N', 272893),
(453800, 'PF14168', NULL, 'YjzC-like protein', 55, NULL, 'YjzC', 272894),
(453801, 'PF05340', NULL, 'Protein of unknown function (DUF740)', 625, NULL, 'DUF740', 272895),
(453802, 'PF11176', NULL, 'Translation machinery-associated protein 16', 146, NULL, 'Tma16', 272896),
(453803, 'PF16501', NULL, 'S phase cyclin A-associated protein in the endoplasmic reticulum', 98, NULL, 'SCAPER_N', 272897),
(453804, 'PF18694', NULL, 'Transactive response DNA-binding protein N-terminal domain', 74, NULL, 'TDP43_N', 272898),
(453805, 'PF15886', NULL, 'Carbohydrate binding domain (family 32)', 108, NULL, 'CBM39', 272899),
(453806, 'PF16117', NULL, 'Domain of unknown function (DUF4833)', 138, NULL, 'DUF4833', 272900),
(453807, 'PF18838', NULL, 'Large polyvalent protein associated domain 23', 58, NULL, 'LPD23', 272901),
(453808, 'PF16769', NULL, 'MCM3AP domain of GANP', 717, NULL, 'MCM3AP_GANP', 272902),
(453809, 'PF19508', NULL, 'Family of unknown function (DUF6042)', 232, NULL, 'DUF6042', 272903),
(453810, 'PF16174', NULL, 'Intracellular hyaluronan-binding protein 4 N-terminal', 152, NULL, 'IHABP4_N', 272904),
(453811, 'PF02690', NULL, 'Na+/Pi-cotransporter', 137, NULL, 'Na_Pi_cotrans', 272905),
(453812, 'PF07879', NULL, 'PHB/PHA accumulation regulator DNA-binding domain', 61, NULL, 'PHB_acc_N', 272906),
(453813, 'PF18468', NULL, 'Phosphofructokinase N-terminal domain yeast', 98, NULL, 'Pfk_N', 272907),
(453814, 'PF19284', NULL, 'Arc MA domain', 108, NULL, 'Arc_MA', 272908);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(453815, 'PF11609', NULL, 'Protein of unknown function (DUF3248)', 63, NULL, 'DUF3248', 272909),
(453816, 'PF11789', NULL, 'Zinc-finger of the MIZ type in Nse subunit', 58, NULL, 'zf-Nse', 272910),
(453817, 'PF18204', NULL, 'PGF-CTERM motif', 23, NULL, 'PGF-CTERM', 272911),
(453818, 'PF19230', NULL, 'Family of unknown function (DUF5883)', 120, NULL, 'DUF5883', 272912),
(453819, 'PF18144', NULL, 'Second Messenger Oligonucleotide or Dinucleotide Synthetase domain', 164, NULL, 'SMODS', 272913),
(453820, 'PF06597', NULL, 'Clostridium P-47 protein', 461, NULL, 'Clostridium_P47', 272914),
(453821, 'PF14914', NULL, 'LRRC37A/B like protein 1 C-terminal domain', 147, NULL, 'LRRC37AB_C', 272915),
(453822, 'PF16650', NULL, 'Unstructured region on SPEG complex protein', 57, NULL, 'SPEG_u2', 272916),
(453823, 'PF01416', NULL, 'tRNA pseudouridine synthase', 108, NULL, 'PseudoU_synth_1', 272917),
(453824, 'PF01645', NULL, 'Conserved region in glutamate synthase', 368, NULL, 'Glu_synthase', 272918),
(453825, 'PF09143', NULL, 'AvrPphF-ORF-2', 175, NULL, 'AvrPphF-ORF-2', 272919),
(453826, 'PF11632', NULL, 'Lactococcin G-beta', 61, NULL, 'LcnG-beta', 272920),
(453827, 'PF01430', NULL, 'Hsp33 protein', 267, NULL, 'HSP33', 272921),
(453828, 'PF06278', NULL, 'Condensin II complex subunit CAP-H2 or CNDH2, N-terminal', 117, NULL, 'CNDH2_N', 272922),
(453829, 'PF14427', NULL, 'Pput_2613-like deaminase', 118, NULL, 'Pput2613-deam', 272923),
(453830, 'PF15124', NULL, 'FANCD2 opposite strand protein', 175, NULL, 'FANCD2OS', 272924),
(453831, 'PF01115', NULL, 'F-actin capping protein, beta subunit', 238, NULL, 'F_actin_cap_B', 272925),
(453832, 'PF20331', NULL, 'Family of unknown function (DUF6626)', 96, NULL, 'DUF6626', 272926),
(453833, 'PF20134', NULL, 'Family of unknown function (DUF6524)', 131, NULL, 'DUF6524', 272927),
(453834, 'PF03911', NULL, 'Sec61beta family', 41, NULL, 'Sec61_beta', 272928),
(453835, 'PF18964', NULL, 'Family of unknown function (DUF5704)', 185, NULL, 'DUF5704', 272929),
(453836, 'PF06782', NULL, 'Uncharacterised protein family (UPF0236)', 479, NULL, 'UPF0236', 272930),
(453837, 'PF09990', NULL, 'Predicted membrane protein (DUF2231)', 140, NULL, 'DUF2231', 272931),
(453838, 'PF14485', NULL, 'Domain of unknown function (DUF4431)', 48, NULL, 'DUF4431', 272932),
(453839, 'PF07865', NULL, 'Protein of unknown function (DUF1652)', 67, NULL, 'DUF1652', 272933),
(453840, 'PF07159', NULL, 'CYRIA/CYRIB Rac1 binding domain', 301, NULL, 'CYRIA-B_Rac1-bd', 272934),
(453841, 'PF18888', NULL, 'Repeat of unknown function (DUF5650)', 55, NULL, 'DUF5650', 272935),
(453842, 'PF20263', NULL, 'LYR motif-containing protein 2-like', 86, NULL, 'LYRM2-like', 272936),
(453843, 'PF16550', NULL, 'UCH-binding domain', 112, NULL, 'RPN13_C', 272937),
(453844, 'PF13128', NULL, 'Protein of unknown function (DUF3954)', 49, NULL, 'DUF3954', 272938),
(453845, 'PF03157', NULL, 'High molecular weight glutenin subunit', 786, NULL, 'Glutenin_hmw', 272939),
(453846, 'PF10469', NULL, 'AKAP7 2''5'' RNA ligase-like domain', 207, NULL, 'AKAP7_NLS', 272940),
(453847, 'PF04661', NULL, 'Poxvirus I3 ssDNA-binding protein', 262, NULL, 'Pox_I3', 272941),
(453848, 'PF11457', NULL, 'Protein of unknown function (DUF3021)', 130, NULL, 'DUF3021', 272942),
(453849, 'PF15320', NULL, 'mRNA cap methylation, RNMT-activating mini protein', 86, NULL, 'RAM', 272943),
(453850, 'PF05308', NULL, 'Mitochondrial fission regulator', 248, NULL, 'Mito_fiss_reg', 272944),
(453851, 'PF06579', NULL, 'Caenorhabditis elegans ly-6-related protein', 125, NULL, 'Ly-6_related', 272945),
(453852, 'PF03934', NULL, 'Type II secretion system (T2SS), protein K', 280, NULL, 'T2SSK', 272946),
(453853, 'PF17134', NULL, 'Domain of unknown function (DUF5109)', 114, NULL, 'DUF5109', 272947),
(453854, 'PF02374', NULL, 'Anion-transporting ATPase', 305, NULL, 'ArsA_ATPase', 272948),
(453855, 'PF20485', NULL, 'Family of unknown function (DUF6724)', 64, NULL, 'DUF6724', 272949),
(453856, 'PF11686', NULL, 'Protein of unknown function (DUF3283)', 61, NULL, 'DUF3283', 272950),
(453857, 'PF00984', NULL, 'UDP-glucose/GDP-mannose dehydrogenase family, central domain', 94, NULL, 'UDPG_MGDP_dh', 272951);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(453858, 'PF02589', NULL, 'LUD domain', 189, NULL, 'LUD_dom', 272952),
(453859, 'PF09509', NULL, 'Protein of unknown function (Hypoth_ymh)', 119, NULL, 'Hypoth_Ymh', 272953),
(453860, 'PF04841', NULL, 'Vps16, N-terminal region', 410, NULL, 'Vps16_N', 272954),
(453861, 'PF05048', NULL, 'Periplasmic copper-binding protein (NosD)', 210, NULL, 'NosD', 272955),
(453862, 'PF02718', NULL, 'Herpesvirus UL31-like protein', 254, NULL, 'Herpes_UL31', 272956),
(453863, 'PF18841', NULL, 'Beta solenoid repeat from Dextranase', 33, NULL, 'B_solenoid_dext', 272957),
(453864, 'PF16489', NULL, 'GPCR-Autoproteolysis INducing (GAIN) domain', 210, NULL, 'GAIN', 272958),
(453865, 'PF06962', NULL, 'Putative rRNA methylase', 137, NULL, 'rRNA_methylase', 272959),
(453866, 'PF11711', NULL, 'Inner membrane protein import complex subunit Tim54', 374, NULL, 'Tim54', 272960),
(453867, 'PF13922', NULL, 'PHD domain of transcriptional enhancer, Asx', 69, NULL, 'PHD_3', 272961),
(453868, 'PF14619', NULL, 'Snf2-ATP coupling, chromatin remodelling complex', 73, NULL, 'SnAC', 272962),
(453869, 'PF03827', NULL, 'Orexin receptor type 2', 57, NULL, 'Orexin_rec2', 272963),
(453870, 'PF01238', NULL, 'Phosphomannose isomerase type I C-terminal', 48, NULL, 'PMI_typeI_C', 272964),
(453871, 'PF06510', NULL, 'Protein of unknown function (DUF1102)', 141, NULL, 'DUF1102', 272965),
(453872, 'PF13493', NULL, 'Domain of unknown function (DUF4118)', 107, NULL, 'DUF4118', 272966),
(453873, 'PF19524', NULL, 'Family of unknown function (DUF6054)', 111, NULL, 'DUF6054', 272967),
(453874, 'PF00997', NULL, 'Kappa casein', 160, NULL, 'Casein_kappa', 272968),
(453875, 'PF15977', NULL, 'Winged helix-turn-helix DNA binding', 68, NULL, 'HTH_46', 272969),
(453876, 'PF19705', NULL, 'Family of unknown function (DUF6202)', 274, NULL, 'DUF6202', 272970),
(453877, 'PF17413', NULL, 'Outer membrane lipoprotein virB7', 35, NULL, 'VirB7', 272971),
(453878, 'PF11710', NULL, 'G protein-coupled glucose receptor regulating Gpa2', 202, NULL, 'Git3', 272972),
(453879, 'PF10940', NULL, 'Leader peptide SpeFL', 40, NULL, 'SpeFL', 272973),
(453880, 'PF17803', NULL, 'Bacterial cadherin-like domain', 72, NULL, 'Cadherin_4', 272974),
(453881, 'PF20045', NULL, 'Family of unknown function (DUF6447)', 75, NULL, 'DUF6447', 272975),
(453882, 'PF02014', NULL, 'Reeler domain', 129, NULL, 'Reeler', 272976),
(453883, 'PF04579', NULL, 'Keratin, high-sulphur matrix protein', 96, NULL, 'Keratin_matx', 272977),
(453884, 'PF04484', NULL, 'QWRF family', 301, NULL, 'QWRF', 272978),
(453885, 'PF04708', NULL, 'Poxvirus F16 protein', 215, NULL, 'Pox_F16', 272979),
(453886, 'PF08424', NULL, 'NRDE-2, necessary for RNA interference', 328, NULL, 'NRDE-2', 272980),
(453887, 'PF03261', NULL, 'Cyclin-dependent kinase 5 activator protein', 336, NULL, 'CDK5_activator', 272981),
(453888, 'PF13086', NULL, 'AAA domain', 261, NULL, 'AAA_11', 272982),
(453889, 'PF18956', NULL, 'Family of unknown function (DUF5699)', 61, NULL, 'DUF5699', 272983),
(453890, 'PF06551', NULL, 'Protein of unknown function (DUF1120)', 116, NULL, 'DUF1120', 272984),
(453891, 'PF10419', NULL, 'TFIIIC subunit triple barrel domain', 103, NULL, 'TFIIIC_sub6', 272985),
(453892, 'PF15277', NULL, 'Exocyst complex component SEC3 N-terminal PIP2 binding PH', 90, NULL, 'Sec3-PIP2_bind', 272986),
(453893, 'PF09846', NULL, 'Uncharacterized protein conserved in archaea (DUF2073)', 105, NULL, 'DUF2073', 272987),
(453894, 'PF06557', NULL, 'Protein of unknown function (DUF1122)', 176, NULL, 'DUF1122', 272988),
(453895, 'PF07751', NULL, 'Abi-like protein', 180, NULL, 'Abi_2', 272989),
(453896, 'PF09097', NULL, 'Baseplate structural protein, domain 1', 196, NULL, 'Phage-tail_1', 272990),
(453897, 'PF07213', NULL, 'DAP10 membrane protein', 79, NULL, 'DAP10', 272991),
(453898, 'PF08712', NULL, 'Scaffold protein Nfu/NifU N terminal', 88, NULL, 'Nfu_N', 272992),
(453899, 'PF13783', NULL, 'Domain of unknown function (DUF4177)', 65, NULL, 'DUF4177', 272993),
(453900, 'PF05464', NULL, 'Phi-29-like late genes activator (early protein GP4)', 125, NULL, 'Phi-29_GP4', 272994);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(453901, 'PF10110', NULL, 'Membrane domain of glycerophosphoryl diester phosphodiesterase', 324, NULL, 'GPDPase_memb', 272995),
(453902, 'PF16210', NULL, 'Keratin type II cytoskeletal 1 tail', 136, NULL, 'Keratin_2_tail', 272996),
(453903, 'PF05829', NULL, 'Adenovirus late L2 mu core protein (Protein X)', 42, NULL, 'Adeno_PX', 272997),
(453904, 'PF11620', NULL, 'GA-binding protein alpha chain', 85, NULL, 'GABP-alpha', 272998),
(453905, 'PF11331', NULL, 'Probable zinc-ribbon domain', 45, NULL, 'zinc_ribbon_12', 272999),
(453906, 'PF10030', NULL, 'Uncharacterized protein conserved in bacteria (DUF2272)', 191, NULL, 'DUF2272', 273000),
(453907, 'PF16089', NULL, 'Domain of unknown function (DUF4818)', 116, NULL, 'DUF4818', 273001),
(453908, 'PF03127', NULL, 'GAT domain', 77, NULL, 'GAT', 273002),
(453909, 'PF12356', NULL, 'Baculoviral IAP repeat-containing protein 6', 162, NULL, 'BIRC6', 273003),
(453910, 'PF04766', NULL, 'Nucleopolyhedrovirus p26 protein', 234, NULL, 'Baculo_p26', 273004),
(453911, 'PF12647', NULL, 'RNHCP domain', 90, NULL, 'RNHCP', 273005),
(453912, 'PF05620', NULL, 'SRP-independent targeting protein 2/TMEM208', 168, NULL, 'TMEM208_SND2', 273006),
(453913, 'PF17434', NULL, 'Family of unknown function (DUF5413)', 133, NULL, 'DUF5413', 273007),
(453914, 'PF06625', NULL, 'Protein of unknown function (DUF1151)', 111, NULL, 'DUF1151', 273008),
(453915, 'PF16450', NULL, 'Proteasomal ATPase OB C-terminal domain', 56, NULL, 'Prot_ATP_ID_OB', 273009),
(453916, 'PF17303', NULL, 'Family of unknown function (DUF5352)', 165, NULL, 'DUF5352', 273010),
(453917, 'PF03273', NULL, 'Baculovirus gp64 envelope glycoprotein family', 494, NULL, 'Baculo_gp64', 273011),
(453918, 'PF01406', NULL, 'tRNA synthetases class I (C) catalytic domain', 301, NULL, 'tRNA-synt_1e', 273012),
(453919, 'PF09490', NULL, 'Probable cobalt transporter subunit (CbtA)', 241, NULL, 'CbtA', 273013),
(453920, 'PF00066', NULL, 'LNR domain', 36, NULL, 'Notch', 273014),
(453921, 'PF07322', NULL, 'Seadornavirus Vp10', 241, NULL, 'Seadorna_Vp10', 273015),
(453922, 'PF00280', NULL, 'Potato inhibitor I family', 64, NULL, 'potato_inhibit', 273016),
(453923, 'PF13355', NULL, 'ARC6-like, IMS domain', 117, NULL, 'ARC6-like_IMS', 273017),
(453924, 'PF03608', NULL, 'PTS system enzyme II sorbitol-specific factor', 167, NULL, 'EII-GUT', 273018),
(453925, 'PF13865', NULL, 'C-terminal duplication domain of Friend of PRMT1', 81, NULL, 'FoP_duplication', 273019),
(453926, 'PF05602', NULL, 'Cleft lip and palate transmembrane protein 1 (CLPTM1)', 435, NULL, 'CLPTM1', 273020),
(453927, 'PF15477', NULL, 'Small acidic protein family', 79, NULL, 'SMAP', 273021),
(453928, 'PF12440', NULL, 'Melanoma associated antigen family N terminal', 92, NULL, 'MAGE_N', 273022),
(453929, 'PF12964', NULL, 'Protein of unknown function (DUF3853)', 97, NULL, 'DUF3853', 273023),
(453930, 'PF08016', NULL, 'Polycystin cation channel', 225, NULL, 'PKD_channel', 273024),
(453931, 'PF09581', NULL, 'Stage III sporulation protein AF (Spore_III_AF)', 190, NULL, 'Spore_III_AF', 273025),
(453932, 'PF11405', NULL, 'Bromelain inhibitor VI', 41, NULL, 'Inhibitor_I67', 273026),
(453933, 'PF08289', NULL, 'Influenza Matrix protein (M1) C-terminal domain', 95, NULL, 'Flu_M1_C', 273027),
(453934, 'PF02046', NULL, 'Cytochrome c oxidase subunit VIa', 112, NULL, 'COX6A', 273028),
(453935, 'PF16180', NULL, 'RelB leucine zipper', 84, NULL, 'RelB_leu_zip', 273029),
(453936, 'PF19151', NULL, 'Sublancin', 57, NULL, 'Sublancin', 273030),
(453937, 'PF05197', NULL, 'TRIC channel', 193, NULL, 'TRIC', 273031),
(453938, 'PF06477', NULL, 'Protein of unknown function (DUF1091)', 82, NULL, 'DUF1091', 273032),
(453939, 'PF07687', NULL, 'Peptidase dimerisation domain', 109, NULL, 'M20_dimer', 273033),
(453940, 'PF08668', NULL, 'HDOD domain', 196, NULL, 'HDOD', 273034),
(453941, 'PF09765', NULL, 'FANCL UBC-like domain 1', 89, NULL, 'FANCL_d1', 273035),
(453942, 'PF13746', NULL, '4Fe-4S dicluster domain', 114, NULL, 'Fer4_18', 273036),
(453943, 'PF07745', NULL, 'Glycosyl hydrolase family 53', 340, NULL, 'Glyco_hydro_53', 273037);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(453944, 'PF20125', NULL, 'Family of unknown function (DUF6515)', 179, NULL, 'DUF6515', 273038),
(453945, 'PF09527', NULL, 'Putative F0F1-ATPase subunit Ca2+/Mg2+ transporter', 54, NULL, 'ATPase_gene1', 273039),
(453946, 'PF16275', NULL, 'Splicing factor 1 helix-hairpin domain', 114, NULL, 'SF1-HH', 273040),
(453947, 'PF05756', NULL, 'S-antigen protein', 92, NULL, 'S-antigen', 273041),
(453948, 'PF11490', NULL, 'DNA polymerase III polC-type N-terminus II', 117, NULL, 'DNA_pol3_a_NII', 273042),
(453949, 'PF06030', NULL, 'Bacterial protein of unknown function (DUF916)', 121, NULL, 'DUF916', 273043),
(453950, 'PF15767', NULL, 'Armadillo-like helical domain-containing protein 4', 583, NULL, 'ARMH4', 273044),
(453951, 'PF09630', NULL, 'Domain of unknown function (DUF2024)', 81, NULL, 'DUF2024', 273045),
(453952, 'PF11098', NULL, 'Chlorosome envelope protein C', 139, NULL, 'Chlorosome_CsmC', 273046),
(453953, 'PF20037', NULL, 'Family of unknown function (DUF6440)', 53, NULL, 'DUF6440', 273047),
(453954, 'PF09457', NULL, 'FIP domain', 41, NULL, 'RBD-FIP', 273048),
(453955, 'PF13986', NULL, 'Domain of unknown function (DUF4224)', 45, NULL, 'DUF4224', 273049),
(453956, 'PF00119', NULL, 'ATP synthase A chain', 214, NULL, 'ATP-synt_A', 273050),
(453957, 'PF11932', NULL, 'Protein of unknown function (DUF3450)', 241, NULL, 'DUF3450', 273051),
(453958, 'PF13258', NULL, 'Domain of unknown function (DUF4049)', 324, NULL, 'DUF4049', 273052),
(453959, 'PF11187', NULL, 'Mbeg1-like', 224, NULL, 'Mbeg1-like', 273053),
(453960, 'PF00974', NULL, 'Rhabdovirus spike glycoprotein', 502, NULL, 'Rhabdo_glycop', 273054),
(453961, 'PF07535', NULL, 'DBF zinc finger', 45, NULL, 'zf-DBF', 273055),
(453962, 'PF08223', NULL, 'PaaX-like protein C-terminal domain', 99, NULL, 'PaaX_C', 273056),
(453963, 'PF01455', NULL, 'HupF/HypC family', 65, NULL, 'HupF_HypC', 273057),
(453964, 'PF16747', NULL, 'Surface-adhesin protein E', 125, NULL, 'Adhesin_E', 273058),
(453965, 'PF00150', NULL, 'Cellulase (glycosyl hydrolase family 5)', 281, NULL, 'Cellulase', 273059),
(453966, 'PF11045', NULL, 'Putative inner membrane protein of Enterobacteriaceae', 117, NULL, 'YbjM', 273060),
(453967, 'PF11914', NULL, 'Domain of unknown function (DUF3432)', 98, NULL, 'DUF3432', 273061),
(453968, 'PF16402', NULL, 'Domain of unknown function (DUF5010)', 341, NULL, 'DUF5010', 273062),
(453969, 'PF02309', NULL, 'AUX/IAA family', 240, NULL, 'AUX_IAA', 273063),
(453970, 'PF15416', NULL, 'Domain of unknown function (DUF4623)', 448, NULL, 'DUF4623', 273064),
(453971, 'PF20502', NULL, 'DNA-dependent protein kinase catalytic subunit, CC1/2', 809, NULL, 'DNAPKcs_CC1-2', 273065),
(453972, 'PF13584', NULL, 'BatD DUF11 like domain', 91, NULL, 'BatD', 273066),
(453973, 'PF16683', NULL, 'Transglutaminase elicitor', 361, NULL, 'TGase_elicitor', 273067),
(453974, 'PF10290', NULL, 'Cell wall protein YJL171C/Tos1, N-terminal', 63, NULL, 'YJL171C_Tos1_N', 273068),
(453975, 'PF12916', NULL, 'Protein of unknown function (DUF3834)', 201, NULL, 'DUF3834', 273069),
(453976, 'PF02460', NULL, 'Patched family', 811, NULL, 'Patched', 273070),
(453977, 'PF02911', NULL, 'Formyl transferase, C-terminal domain', 100, NULL, 'Formyl_trans_C', 273071),
(453978, 'PF03753', NULL, 'Human herpesvirus 6 immediate early protein', 1078, NULL, 'HHV6-IE', 273072),
(453979, 'PF06797', NULL, 'Protein of unknown function (DUF1229)', 139, NULL, 'DUF1229', 273073),
(453980, 'PF17574', NULL, 'Inhibitor of toxin/antitoxin system (Gp4.5)', 89, NULL, 'TA_inhibitor', 273074),
(453981, 'PF00612', NULL, 'IQ calmodulin-binding motif', 21, NULL, 'IQ', 273075),
(453982, 'PF19666', NULL, 'Family of unknown function (DUF6169)', 91, NULL, 'DUF6169', 273076),
(453983, 'PF09126', NULL, 'Restriction endonuclease NaeI', 288, NULL, 'NaeI', 273077),
(453984, 'PF04786', NULL, 'ssDNA binding protein', 248, NULL, 'Baculo_DNA_bind', 273078),
(453985, 'PF12277', NULL, 'Protein of unknown function (DUF3618)', 47, NULL, 'DUF3618', 273079),
(453986, 'PF14527', NULL, 'WhiA LAGLIDADG-like domain', 93, NULL, 'LAGLIDADG_WhiA', 273080);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(453987, 'PF04612', NULL, 'Type II secretion system (T2SS), protein M', 160, NULL, 'T2SSM', 273081),
(453988, 'PF16121', NULL, '40S ribosomal protein S4 C-terminus', 48, NULL, '40S_S4_C', 273082),
(453989, 'PF09079', NULL, 'CDC6, C terminal winged helix domain', 84, NULL, 'Cdc6_C', 273083),
(453990, 'PF11753', NULL, 'Protein of unknwon function (DUF3310)', 60, NULL, 'DUF3310', 273084),
(453991, 'PF17880', NULL, 'Yos9 dimerzation domain', 128, NULL, 'Yos9_DD', 273085),
(453992, 'PF04771', NULL, 'Chicken anaemia virus VP-3 protein', 121, NULL, 'CAV_VP3', 273086),
(453993, 'PF07653', NULL, 'Variant SH3 domain', 57, NULL, 'SH3_2', 273087),
(453994, 'PF12510', NULL, 'Smoothelin cytoskeleton protein', 50, NULL, 'Smoothelin', 273088),
(453995, 'PF05061', NULL, 'Poxvirus A11 Protein', 315, NULL, 'Pox_A11', 273089),
(453996, 'PF13094', NULL, 'CENP-Q, a CENPA-CAD centromere complex subunit', 171, NULL, 'CENP-Q', 273090),
(453997, 'PF13661', NULL, '2OG-Fe(II) oxygenase superfamily', 98, NULL, '2OG-FeII_Oxy_4', 273091),
(453998, 'PF00480', NULL, 'ROK family', 294, NULL, 'ROK', 273092),
(453999, 'PF03945', NULL, 'delta endotoxin, N-terminal domain', 223, NULL, 'Endotoxin_N', 273093),
(454000, 'PF10263', NULL, 'SprT-like family', 116, NULL, 'SprT-like', 273094),
(454001, 'PF01442', NULL, 'Apolipoprotein A1/A4/E domain', 190, NULL, 'Apolipoprotein', 273095),
(454002, 'PF04238', NULL, 'Protein of unknown function (DUF420)', 131, NULL, 'DUF420', 273096),
(454003, 'PF17990', NULL, 'L-Lysine epsilon oxidase N-terminal', 223, NULL, 'LodA_N', 273097),
(454004, 'PF19383', NULL, 'Family of unknown function (DUF5958)', 125, NULL, 'DUF5958', 273098),
(454005, 'PF02810', NULL, 'SEC-C motif', 19, NULL, 'SEC-C', 273099),
(454006, 'PF01876', NULL, 'RNase P subunit p30', 215, NULL, 'RNase_P_p30', 273100),
(454007, 'PF07758', NULL, 'Protein of unknown function (DUF1614)', 171, NULL, 'DUF1614', 273101),
(454008, 'PF10698', NULL, 'Protein of unknown function (DUF2505)', 158, NULL, 'DUF2505', 273102),
(454009, 'PF11658', NULL, 'Cellulose biosynthesis protein BcsG', 516, NULL, 'CBP_BcsG', 273103),
(454010, 'PF18797', NULL, 'Adenomatous polyposis coli (APC) repeat', 76, NULL, 'APC_rep', 273104),
(454011, 'PF00632', NULL, 'HECT-domain (ubiquitin-transferase)', 306, NULL, 'HECT', 273105),
(454012, 'PF02341', NULL, 'RbcX protein', 111, NULL, 'RbcX', 273106),
(454013, 'PF10247', NULL, 'Reactive mitochondrial oxygen species modulator 1', 66, NULL, 'Romo1', 273107),
(454014, 'PF15391', NULL, 'Domain of unknown function (DUF4614)', 182, NULL, 'DUF4614', 273108),
(454015, 'PF16292', NULL, 'Domain of unknown function (DUF4938)', 302, NULL, 'DUF4938', 273109),
(454016, 'PF09709', NULL, 'CRISPR-associated protein (Cas_Csd1)', 555, NULL, 'Cas_Csd1', 273110),
(454017, 'PF19366', NULL, 'Domain of unknown function (DUF5942)', 191, NULL, 'DUF5942', 273111),
(454018, 'PF15798', NULL, 'Proline-rich AKT1 substrate 1', 123, NULL, 'PRAS', 273112),
(454019, 'PF02230', NULL, 'Phospholipase/Carboxylesterase', 217, NULL, 'Abhydrolase_2', 273113),
(454020, 'PF20246', NULL, 'Family of unknown function (DUF6601)', 241, NULL, 'DUF6601', 273114),
(454021, 'PF13794', NULL, 'tRNA-(MS[2]IO[6]A)-hydroxylase (MiaE)-like', 185, NULL, 'MiaE_2', 273115),
(454022, 'PF09376', NULL, 'NurA domain', 243, NULL, 'NurA', 273116),
(454023, 'PF16994', NULL, 'Glycosyl-transferase family 4', 172, NULL, 'Glyco_trans_4_5', 273117),
(454024, 'PF04709', NULL, 'Anti-Mullerian hormone, N terminal region', 392, NULL, 'AMH_N', 273118),
(454025, 'PF16164', NULL, 'VWA N-terminal', 79, NULL, 'VWA_N2', 273119),
(454026, 'PF11104', NULL, 'Type IV pilus assembly protein PilM;', 340, NULL, 'PilM_2', 273120),
(454027, 'PF05766', NULL, 'Bacteriophage Lambda NinG protein', 195, NULL, 'NinG', 273121),
(454028, 'PF00681', NULL, 'Plectin repeat', 39, NULL, 'Plectin', 273122),
(454029, 'PF04358', NULL, 'DsrC like protein', 107, NULL, 'DsrC', 273123),
(454030, 'PF18554', NULL, 'PheRS DNA binding domain 2', 33, NULL, 'PheRS_DBD2', 273124),
(454031, 'PF13670', NULL, 'Peptidase propeptide and YPEB domain', 84, NULL, 'PepSY_2', 273125);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(454032, 'PF10548', NULL, 'P22AR C-terminal domain', 73, NULL, 'P22_AR_C', 273126),
(454033, 'PF20156', NULL, 'Flagellin glycosyltransferase Maf helical bundle domain', 122, NULL, 'Maf_C', 273127),
(454034, 'PF03017', NULL, 'TNP1/EN/SPM transposase', 66, NULL, 'Transposase_23', 273128),
(454035, 'PF13721', NULL, 'SecD export protein N-terminal TM region', 103, NULL, 'SecD-TM1', 273129),
(454036, 'PF00527', NULL, 'E7 protein, Early protein', 93, NULL, 'E7', 273130),
(454037, 'PF05886', NULL, 'Orthopoxvirus F8 protein', 65, NULL, 'Orthopox_F8', 273131),
(454038, 'PF19930', NULL, 'Family of unknown function (DUF6393)', 96, NULL, 'DUF6393', 273132),
(454039, 'PF03829', NULL, 'PTS system glucitol/sorbitol-specific IIA component', 113, NULL, 'PTSIIA_gutA', 273133),
(454040, 'PF00269', NULL, 'Small, acid-soluble spore proteins, alpha/beta type', 60, NULL, 'SASP', 273134),
(454041, 'PF00512', NULL, 'His Kinase A (phospho-acceptor) domain', 67, NULL, 'HisKA', 273135),
(454042, 'PF17649', NULL, 'Vacuolar protein sorting 38', 424, NULL, 'VPS38', 273136),
(454043, 'PF02826', NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase, NAD binding domain', 178, NULL, '2-Hacid_dh_C', 273137),
(454044, 'PF04935', NULL, 'Surfeit locus protein 6', 202, NULL, 'SURF6', 273138),
(454045, 'PF12806', NULL, 'Acetyl-CoA dehydrogenase C-terminal like', 124, NULL, 'Acyl-CoA_dh_C', 273139),
(454046, 'PF19115', NULL, 'Family of unknown function (DUF5800)', 64, NULL, 'DUF5800', 273140),
(454047, 'PF14760', NULL, 'Rnk N-terminus', 41, NULL, 'Rnk_N', 273141),
(454048, 'PF10149', NULL, 'Transmembrane protein 231', 301, NULL, 'TM231', 273142),
(454049, 'PF09437', NULL, 'Pombe specific 5TM protein', 256, NULL, 'Pombe_5TM', 273143),
(454050, 'PF07051', NULL, 'Ovarian carcinoma immunoreactive antigen (OCIA)', 87, NULL, 'OCIA', 273144),
(454051, 'PF07609', NULL, 'Protein of unknown function (DUF1572)', 163, NULL, 'DUF1572', 273145),
(454052, 'PF16673', NULL, 'TNF receptor-associated factor BIRC3 binding domain', 64, NULL, 'TRAF_BIRC3_bd', 273146),
(454053, 'PF06002', NULL, 'Alpha-2,3-sialyltransferase (CST-I)', 293, NULL, 'CST-I', 273147),
(454054, 'PF14094', NULL, 'Domain of unknown function (DUF4272)', 207, NULL, 'DUF4272', 273148),
(454055, 'PF01378', NULL, 'B domain', 68, NULL, 'IgG_binding_B', 273149),
(454056, 'PF17066', NULL, 'RBPJ-interacting and tubulin associated protein', 268, NULL, 'RITA', 273150),
(454057, 'PF19922', NULL, 'MoxR-vWA-beta-propeller ternary system domain bpX6', 169, NULL, 'bpX6', 273151),
(454058, 'PF00843', NULL, 'Arenavirus nucleocapsid N-terminal domain', 334, NULL, 'Arena_nucleocap', 273152),
(454059, 'PF09755', NULL, 'Uncharacterized conserved protein H4 (DUF2046)', 304, NULL, 'DUF2046', 273153),
(454060, 'PF07996', NULL, 'Type IV secretion system proteins', 197, NULL, 'T4SS', 273154),
(454061, 'PF13920', NULL, 'Zinc finger, C3HC4 type (RING finger)', 50, NULL, 'zf-C3HC4_3', 273155),
(454062, 'PF15334', NULL, 'Aurora kinase A and ninein interacting protein', 324, NULL, 'AIB', 273156),
(454063, 'PF06788', NULL, 'Uncharacterised protein family (UPF0257)', 235, NULL, 'UPF0257', 273157),
(454064, 'PF01110', NULL, 'Ciliary neurotrophic factor', 194, NULL, 'CNTF', 273158),
(454065, 'PF03051', NULL, 'Peptidase C1-like family', 438, NULL, 'Peptidase_C1_2', 273159),
(454066, 'PF08818', NULL, 'Domain of unknown function (DU1801)', 85, NULL, 'DUF1801', 273160),
(454067, 'PF11829', NULL, 'Protein of unknown function (DUF3349)', 95, NULL, 'DUF3349', 273161),
(454068, 'PF17787', NULL, 'PH domain', 131, NULL, 'PH_14', 273162),
(454069, 'PF16881', NULL, 'N-terminal domain of lipoyl synthase of Radical_SAM family', 108, NULL, 'LIAS_N', 273163),
(454070, 'PF07084', NULL, 'Thyroid hormone-inducible hepatic protein Spot 14', 153, NULL, 'Spot_14', 273164),
(454071, 'PF07634', NULL, 'RtxA repeat', 18, NULL, 'RtxA', 273165),
(454072, 'PF13744', NULL, 'Helix-turn-helix domain', 80, NULL, 'HTH_37', 273166),
(454073, 'PF07461', NULL, 'Nicotine adenine dinucleotide glycohydrolase (NADase)', 446, NULL, 'NADase_NGA', 273167),
(454074, 'PF11397', NULL, 'Glycosyltransferase (GlcNAc)', 352, NULL, 'GlcNAc', 273168);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(454075, 'PF03315', NULL, 'Serine dehydratase beta chain', 155, NULL, 'SDH_beta', 273169),
(454076, 'PF12554', NULL, 'Mitotic-spindle organizing gamma-tubulin ring associated', 47, NULL, 'MOZART1', 273170),
(454077, 'PF00263', NULL, 'Bacterial type II and III secretion system protein', 168, NULL, 'Secretin', 273171),
(454078, 'PF00888', NULL, 'Cullin family', 620, NULL, 'Cullin', 273172),
(454079, 'PF13510', NULL, '2Fe-2S iron-sulfur cluster binding domain', 82, NULL, 'Fer2_4', 273173),
(454080, 'PF11745', NULL, 'Protein of unknown function (DUF3304)', 104, NULL, 'DUF3304', 273174),
(454081, 'PF12557', NULL, 'Cob(I)alamin adenosyltransferase N terminal', 26, NULL, 'Co_AT_N', 273175),
(454082, 'PF02669', NULL, 'K+-transporting ATPase, c chain', 182, NULL, 'KdpC', 273176),
(454083, 'PF12594', NULL, 'Protein of unknown function (DUF3764)', 89, NULL, 'DUF3764', 273177),
(454084, 'PF16530', NULL, 'Infectious hypodermal and haematopoietic necrosis virus, capsid', 323, NULL, 'IHHNV_capsid', 273178),
(454085, 'PF07887', NULL, 'Calmodulin binding protein-like N-terminal domain', 148, NULL, 'Calmodulin_bind', 273179),
(454086, 'PF14238', NULL, 'Domain of unknown function (DUF4340)', 184, NULL, 'DUF4340', 273180),
(454087, 'PF05806', NULL, 'Noggin', 216, NULL, 'Noggin', 273181),
(454088, 'PF17421', NULL, 'Family of unknown function (DUF5409)', 88, NULL, 'DUF5409', 273182),
(454089, 'PF08574', NULL, 'Transcription factor Iwr1', 74, NULL, 'Iwr1', 273183),
(454090, 'PF04963', NULL, 'Sigma-54 factor, core binding domain', 180, NULL, 'Sigma54_CBD', 273184),
(454091, 'PF01733', NULL, 'Nucleoside transporter', 309, NULL, 'Nucleoside_tran', 273185),
(454092, 'PF16783', NULL, 'FANCM to MHF binding domain', 116, NULL, 'FANCM-MHF_bd', 273186),
(454093, 'PF19460', NULL, 'Family of unknown function (DUF5997)', 108, NULL, 'DUF5997', 273187),
(454094, 'PF04415', NULL, 'Protein of unknown function (DUF515)', 449, NULL, 'DUF515', 273188),
(454095, 'PF14969', NULL, 'Domain of unknown function (DUF4508)', 97, NULL, 'DUF4508', 273189),
(454096, 'PF12634', NULL, 'Inheritance of peroxisomes protein 1', 137, NULL, 'Inp1', 273190),
(454097, 'PF13722', NULL, '5TM C-terminal transporter carbon starvation CstA', 117, NULL, 'CstA_5TM', 273191),
(454098, 'PF09308', NULL, 'LuxQ, periplasmic', 239, NULL, 'LuxQ-periplasm', 273192),
(454099, 'PF11847', NULL, 'Alpha-(1->3)-arabinofuranosyltransferase', 664, NULL, 'DUF3367', 273193),
(454100, 'PF09188', NULL, 'Domain of unknown function (DUF1951)', 128, NULL, 'DUF1951', 273194),
(454101, 'PF01508', NULL, 'Paramecium surface antigen domain', 63, NULL, 'Paramecium_SA', 273195),
(454102, 'PF00020', NULL, 'TNFR/NGFR cysteine-rich region', 39, NULL, 'TNFR_c6', 273196),
(454103, 'PF02060', NULL, 'Slow voltage-gated potassium channel', 126, NULL, 'ISK_Channel', 273197),
(454104, 'PF11163', NULL, 'Protein of unknown function (DUF2947)', 152, NULL, 'DUF2947', 273198),
(454105, 'PF11349', NULL, 'Protein of unknown function (DUF3151)', 127, NULL, 'DUF3151', 273199),
(454106, 'PF10861', NULL, 'Protein of Unknown function (DUF2784)', 112, NULL, 'DUF2784', 273200),
(454107, 'PF16261', NULL, 'Domain of unknown function (DUF4915)', 315, NULL, 'DUF4915', 273201),
(454108, 'PF09393', NULL, 'Phage tail tube protein', 139, NULL, 'DUF2001', 273202),
(454109, 'PF13472', NULL, 'GDSL-like Lipase/Acylhydrolase family', 179, NULL, 'Lipase_GDSL_2', 273203),
(454110, 'PF10716', NULL, 'NADH dehydrogenase transmembrane subunit', 76, NULL, 'NdhL', 273204),
(454111, 'PF11089', NULL, 'Exopolysaccharide production repressor', 38, NULL, 'SyrA', 273205),
(454112, 'PF18194', NULL, 'Exoribonuclease 1 Domain-3', 71, NULL, 'Xrn1_D3', 273206),
(454113, 'PF18507', NULL, 'WW domain', 27, NULL, 'WW_1', 273207),
(454114, 'PF19641', NULL, 'Family of unknown function (DUF6144)', 181, NULL, 'DUF6144', 273208),
(454115, 'PF03665', NULL, 'Uncharacterised protein family (UPF0172)', 193, NULL, 'UPF0172', 273209),
(454116, 'PF13688', NULL, 'Metallo-peptidase family M12', 196, NULL, 'Reprolysin_5', 273210),
(454117, 'PF14031', NULL, 'Putative serine dehydratase domain', 97, NULL, 'D-ser_dehydrat', 273211);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(454118, 'PF03991', NULL, 'Copper binding octapeptide repeat', 8, NULL, 'Prion_octapep', 273212),
(454119, 'PF04669', NULL, 'Polysaccharide biosynthesis', 190, NULL, 'Polysacc_synt_4', 273213),
(454120, 'PF12651', NULL, 'Ribbon-helix-helix domain', 44, NULL, 'RHH_3', 273214),
(454121, 'PF20543', NULL, 'N2-fixation sustaining protein CowN', 94, NULL, 'CowN', 273215),
(454122, 'PF18874', NULL, 'QPE domain', 44, NULL, 'QPE', 273216),
(454123, 'PF19624', NULL, 'Family of unknown function (DUF6129)', 53, NULL, 'DUF6129', 273217),
(454124, 'PF03123', NULL, 'CAT RNA binding domain', 57, NULL, 'CAT_RBD', 273218),
(454125, 'PF05175', NULL, 'Methyltransferase small domain', 170, NULL, 'MTS', 273219),
(454126, 'PF00462', NULL, 'Glutaredoxin', 60, NULL, 'Glutaredoxin', 273220),
(454127, 'PF14663', NULL, 'Rapamycin-insensitive companion of mTOR RasGEF_N domain', 108, NULL, 'RasGEF_N_2', 273221),
(454128, 'PF04084', NULL, 'Origin recognition complex subunit 2', 334, NULL, 'ORC2', 273222),
(454129, 'PF05569', NULL, 'BlaR1 peptidase M56', 299, NULL, 'Peptidase_M56', 273223),
(454130, 'PF06697', NULL, 'Protein of unknown function (DUF1191)', 184, NULL, 'DUF1191', 273224),
(454131, 'PF14386', NULL, 'Domain of unknown function (DUF4417)', 189, NULL, 'DUF4417', 273225),
(454132, 'PF04264', NULL, 'YceI-like domain', 146, NULL, 'YceI', 273226),
(454133, 'PF12996', NULL, 'DUF based on E. rectale Gene description (DUF3880)', 78, NULL, 'DUF3880', 273227),
(454134, 'PF08935', NULL, 'Viral protein VP4 subunit', 84, NULL, 'VP4_2', 273228),
(454135, 'PF07849', NULL, 'Protein of unknown function (DUF1641)', 39, NULL, 'DUF1641', 273229),
(454136, 'PF19729', NULL, 'F-box/LRR-repeat protein 18, LRR', 592, NULL, 'FBXL18_LRR', 273230),
(454137, 'PF03170', NULL, 'Bacterial cellulose synthase subunit', 600, NULL, 'BcsB', 273231),
(454138, 'PF09575', NULL, 'Small spore protein J (Spore_SspJ)', 46, NULL, 'Spore_SspJ', 273232),
(454139, 'PF18657', NULL, 'YDG domain', 85, NULL, 'YDG', 273233),
(454140, 'PF15856', NULL, 'Domain of unknown function (DUF4727)', 216, NULL, 'DUF4727', 273234),
(454141, 'PF02980', NULL, 'FokI, recognition domain, subdomain 2', 136, NULL, 'FokI_dom_2', 273235),
(454142, 'PF19946', NULL, 'Family of unknown function (DUF6408)', 42, NULL, 'DUF6408', 273236),
(454143, 'PF08326', NULL, 'Acetyl-CoA carboxylase, central region', 726, NULL, 'ACC_central', 273237),
(454144, 'PF02288', NULL, 'Dehydratase medium subunit', 110, NULL, 'Dehydratase_MU', 273238),
(454145, 'PF11376', NULL, 'Protein of unknown function (DUF3179)', 287, NULL, 'DUF3179', 273239),
(454146, 'PF14978', NULL, 'Mitochondrial ribosome protein 63', 92, NULL, 'MRP-63', 273240),
(454147, 'PF16168', NULL, 'Adhesin of bacterial autotransporter system, probable stalk', 63, NULL, 'AIDA', 273241),
(454148, 'PF19203', NULL, 'Family of unknown function (DUF5875)', 228, NULL, 'DUF5875', 273242),
(454149, 'PF08473', NULL, 'Neuronal voltage-dependent calcium channel alpha 2acd', 431, NULL, 'VGCC_alpha2', 273243),
(454150, 'PF11489', NULL, 'Altered inheritance of mitochondria protein 21', 725, NULL, 'Aim21', 273244),
(454151, 'PF09217', NULL, 'Restriction endonuclease EcoRII, N-terminal', 154, NULL, 'EcoRII-N', 273245),
(454152, 'PF15081', NULL, 'Domain of unknown function (DUF4548)', 167, NULL, 'DUF4548', 273246),
(454153, 'PF06227', NULL, 'Poxvirus Bcl-2-like proteins', 173, NULL, 'Poxv_Bcl-2-like', 273247),
(454154, 'PF02070', NULL, 'Neuromedin U', 25, NULL, 'NMU', 273248),
(454155, 'PF00652', NULL, 'Ricin-type beta-trefoil lectin domain', 127, NULL, 'Ricin_B_lectin', 273249),
(454156, 'PF11529', NULL, 'Melampsora lini avirulence protein AvrL567-A', 127, NULL, 'AvrL567-A', 273250),
(454157, 'PF17346', NULL, 'Family of unknown function (DUF5376)', 134, NULL, 'DUF5376', 273251),
(454158, 'PF04505', NULL, 'Interferon-induced transmembrane protein', 68, NULL, 'CD225', 273252),
(454159, 'PF15635', NULL, 'GHH signature containing HNH/Endo VII superfamily nuclease toxin  2', 122, NULL, 'Tox-GHH2', 273253),
(454160, 'PF02395', NULL, 'Immunoglobulin A1 protease', 833, NULL, 'Peptidase_S6', 273254);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(454161, 'PF06294', NULL, 'CH-like domain in sperm protein', 96, NULL, 'CH_2', 273255),
(454162, 'PF08550', NULL, 'Fungal protein of unknown function (DUF1752)', 28, NULL, 'DUF1752', 273256),
(454163, 'PF19419', NULL, 'Family of unknown function (DUF5983)', 162, NULL, 'DUF5983', 273257),
(454164, 'PF13333', NULL, 'Integrase core domain', 52, NULL, 'rve_2', 273258),
(454165, 'PF16395', NULL, 'Domain of unknown function (DUF5004)', 145, NULL, 'DUF5004', 273259),
(454166, 'PF05692', NULL, 'Mycoplasma haemagglutinin', 429, NULL, 'Myco_haema', 273260),
(454167, 'PF02773', NULL, 'S-adenosylmethionine synthetase, C-terminal domain', 138, NULL, 'S-AdoMet_synt_C', 273261),
(454168, 'PF17005', NULL, 'WD40-like domain', 301, NULL, 'WD40_like', 273262),
(454169, 'PF08910', NULL, 'Aida N-terminus', 103, NULL, 'Aida_N', 273263),
(454170, 'PF10524', NULL, 'Nuclear factor I protein pre-N-terminus', 41, NULL, 'NfI_DNAbd_pre-N', 273264),
(454171, 'PF18724', NULL, 'Alpha-glutamyl/putrescinyl thymine pyrophosphorylase clade 2', 231, NULL, 'aGPT-Pplase2', 273265),
(454172, 'PF11059', NULL, 'Protein of unknown function (DUF2860)', 297, NULL, 'DUF2860', 273266),
(454173, 'PF03575', NULL, 'Peptidase family S51', 206, NULL, 'Peptidase_S51', 273267),
(454174, 'PF11141', NULL, 'Protein of unknown function (DUF2914)', 63, NULL, 'DUF2914', 273268),
(454175, 'PF00611', NULL, 'Fes/CIP4, and EFC/F-BAR homology domain', 79, NULL, 'FCH', 273269),
(454176, 'PF02628', NULL, 'Cytochrome oxidase assembly protein', 323, NULL, 'COX15-CtaA', 273270),
(454177, 'PF06100', NULL, 'MCRA family', 495, NULL, 'MCRA', 273271),
(454178, 'PF02745', NULL, 'Methyl-coenzyme M reductase alpha subunit, N-terminal domain', 269, NULL, 'MCR_alpha_N', 273272),
(454179, 'PF02623', NULL, 'FliW protein', 121, NULL, 'FliW', 273273),
(454180, 'PF15275', NULL, 'PEHE domain', 133, NULL, 'PEHE', 273274),
(454181, 'PF10327', NULL, 'Serpentine type 7TM GPCR chemoreceptor Sri', 303, NULL, '7TM_GPCR_Sri', 273275),
(454182, 'PF19406', NULL, 'PKD-like domain', 95, NULL, 'PKD_5', 273276),
(454183, 'PF20322', NULL, 'Family of unknown function (DUF6617)', 316, NULL, 'DUF6617', 273277),
(454184, 'PF11714', NULL, 'Thrombin inhibitor Madanin', 78, NULL, 'Inhibitor_I53', 273278),
(454185, 'PF12454', NULL, 'GPI-anchored cell wall organization protein', 40, NULL, 'Ecm33', 273279),
(454186, 'PF01694', NULL, 'Rhomboid family', 150, NULL, 'Rhomboid', 273280),
(454187, 'PF07974', NULL, 'EGF-like domain', 32, NULL, 'EGF_2', 273281),
(454188, 'PF19826', NULL, 'Family of unknown function (DUF6307)', 43, NULL, 'DUF6307', 273282),
(454189, 'PF18007', NULL, 'Domain of unknown function (DUF5593)', 95, NULL, 'DUF5593', 273283),
(454190, 'PF02789', NULL, 'Cytosol aminopeptidase family, N-terminal domain', 126, NULL, 'Peptidase_M17_N', 273284),
(454191, 'PF04198', NULL, 'Putative sugar-binding domain', 257, NULL, 'Sugar-bind', 273285),
(454192, 'PF16634', NULL, 'Unstructured region on APC between APC_crr and SAMP', 54, NULL, 'APC_u13', 273286),
(454193, 'PF02877', NULL, 'Poly(ADP-ribose) polymerase, regulatory domain', 136, NULL, 'PARP_reg', 273287),
(454194, 'PF04315', NULL, 'Elongation factor P hydroxylase', 163, NULL, 'EpmC', 273288),
(454195, 'PF01525', NULL, 'Rotavirus NS26', 198, NULL, 'Rota_NS26', 273289),
(454196, 'PF09830', NULL, 'ATP adenylyltransferase C-terminal domain', 93, NULL, 'ATP_transf', 273290),
(454197, 'PF12657', NULL, 'Transcription factor IIIC subunit delta N-term', 184, NULL, 'TFIIIC_delta', 273291),
(454198, 'PF02873', NULL, 'UDP-N-acetylenolpyruvoylglucosamine reductase, C-terminal domain', 115, NULL, 'MurB_C', 273292),
(454199, 'PF11999', NULL, 'Ice-binding-like', 209, NULL, 'Ice_binding', 273293),
(454200, 'PF14005', NULL, 'YpjP-like protein', 134, NULL, 'YpjP', 273294),
(454201, 'PF19713', NULL, 'Family of unknown function (DUF6208)', 316, NULL, 'DUF6208', 273295),
(454202, 'PF02757', NULL, 'YLP motif', 9, NULL, 'YLP', 273296),
(454203, 'PF09606', NULL, 'ARC105 or Med15 subunit of Mediator complex non-fungal', 780, NULL, 'Med15', 273297),
(454204, 'PF20471', NULL, 'Putative glycosyltransferase (DUF6716)', 342, NULL, 'DUF6716', 273298);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(454205, 'PF07720', NULL, 'Tetratricopeptide repeat', 36, NULL, 'TPR_3', 273299),
(454206, 'PF04438', NULL, 'HIT zinc finger', 30, NULL, 'zf-HIT', 273300),
(454207, 'PF18482', NULL, 'Fungal Pih1 CS domain', 90, NULL, 'Pih1_fungal_CS', 273301),
(454208, 'PF10758', NULL, 'Protein of unknown function (DUF2586)', 397, NULL, 'DUF2586', 273302),
(454209, 'PF16578', NULL, 'Interleukin 17 receptor D', 105, NULL, 'IL17R_fnIII_D2', 273303),
(454210, 'PF03731', NULL, 'Ku70/Ku80 N-terminal alpha/beta domain', 220, NULL, 'Ku_N', 273304),
(454211, 'PF19692', NULL, 'Family of unknown function (DUF6193)', 112, NULL, 'DUF6193', 273305),
(454212, 'PF07855', NULL, 'Autophagy-related protein 101', 153, NULL, 'ATG101', 273306),
(454213, 'PF16980', NULL, 'Putative citrate transport', 448, NULL, 'CitMHS_2', 273307),
(454214, 'PF00725', NULL, '3-hydroxyacyl-CoA dehydrogenase, C-terminal domain', 97, NULL, '3HCDH', 273308),
(454215, 'PF07123', NULL, 'Photosystem II reaction centre W protein (PsbW)', 132, NULL, 'PsbW', 273309),
(454216, 'PF01976', NULL, 'Protein of unknown function DUF116', 155, NULL, 'DUF116', 273310),
(454217, 'PF14771', NULL, 'Domain of unknown function (DUF4476)', 91, NULL, 'DUF4476', 273311),
(454218, 'PF07436', NULL, 'Curtovirus V3 protein', 87, NULL, 'Curto_V3', 273312),
(454219, 'PF07216', NULL, 'LcrG protein', 91, NULL, 'LcrG', 273313),
(454220, 'PF03789', NULL, 'ELK domain', 22, NULL, 'ELK', 273314),
(454221, 'PF08869', NULL, 'XisI protein', 110, NULL, 'XisI', 273315),
(454222, 'PF02663', NULL, 'FmdE, Molybdenum formylmethanofuran dehydrogenase operon', 131, NULL, 'FmdE', 273316),
(454223, 'PF06638', NULL, 'Strabismus protein', 504, NULL, 'Strabismus', 273317),
(454224, 'PF16352', NULL, 'Domain of unknown function (DUF4980)', 108, NULL, 'DUF4980', 273318),
(454225, 'PF02792', NULL, 'Mago nashi protein', 142, NULL, 'Mago_nashi', 273319),
(454226, 'PF07610', NULL, 'Protein of unknown function (DUF1573)', 98, NULL, 'DUF1573', 273320),
(454227, 'PF03568', NULL, 'Peptidase family C50', 403, NULL, 'Peptidase_C50', 273321),
(454228, 'PF04628', NULL, 'Sedlin, N-terminal conserved region', 131, NULL, 'Sedlin_N', 273322),
(454229, 'PF15549', NULL, 'PGC7/Stella/Dppa3 domain', 161, NULL, 'PGC7_Stella', 273323),
(454230, 'PF00324', NULL, 'Amino acid permease', 479, NULL, 'AA_permease', 273324),
(454231, 'PF09517', NULL, 'Eco29kI restriction endonuclease', 164, NULL, 'RE_Eco29kI', 273325),
(454232, 'PF14376', NULL, 'Haem-binding domain', 133, NULL, 'Haem_bd', 273326),
(454233, 'PF19053', NULL, 'EccD-like transmembrane domain', 392, NULL, 'EccD', 273327),
(454234, 'PF11822', NULL, 'SANT and BTB domain regulator of CSR, BTB domain', 97, NULL, 'SANBR_BTB', 273328),
(454235, 'PF08008', NULL, 'Viral cysteine rich', 83, NULL, 'Viral_cys_rich', 273329),
(454236, 'PF08408', NULL, 'DNA polymerase family B viral insert', 128, NULL, 'DNA_pol_B_3', 273330),
(454237, 'PF04113', NULL, 'Gpi16 subunit, GPI transamidase component', 559, NULL, 'Gpi16', 273331),
(454238, 'PF03374', NULL, 'Phage antirepressor protein KilAC domain', 108, NULL, 'ANT', 273332),
(454239, 'PF16640', NULL, 'Bacterial Ig-like domain (group 3)', 90, NULL, 'Big_3_5', 273333),
(454240, 'PF09033', NULL, 'DNA Fragmentation factor 45kDa, C terminal domain', 165, NULL, 'DFF-C', 273334),
(454241, 'PF10640', NULL, 'mRNA capping enzyme N-terminal, ATPase and guanylyltransferase', 312, NULL, 'Pox_ATPase-GT', 273335),
(454242, 'PF18731', NULL, 'Swt1-like HEPN', 116, NULL, 'HEPN_Swt1', 273336),
(454243, 'PF03465', NULL, 'eRF1 domain 3', 113, NULL, 'eRF1_3', 273337),
(454244, 'PF02087', NULL, 'Nitrophorin', 178, NULL, 'Nitrophorin', 273338),
(454245, 'PF04704', NULL, 'Zfx / Zfy transcription activation region', 328, NULL, 'Zfx_Zfy_act', 273339),
(454246, 'PF09877', NULL, 'Energy-converting hydrogenase subunit EhaL', 99, NULL, 'EhaL', 273340),
(454247, 'PF02476', NULL, 'US2 family', 126, NULL, 'US2', 273341),
(454248, 'PF11510', NULL, 'Fanconi Anaemia group E protein FANCE', 262, NULL, 'FA_FANCE', 273342),
(454249, 'PF01053', NULL, 'Cys/Met metabolism PLP-dependent enzyme', 382, NULL, 'Cys_Met_Meta_PP', 273343);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(454250, 'PF05732', NULL, 'Firmicute plasmid replication protein (RepL)', 164, NULL, 'RepL', 273344),
(454251, 'PF12291', NULL, 'Protein of unknown function (DUF3623)', 256, NULL, 'DUF3623', 273345),
(454252, 'PF11228', NULL, 'Protein of unknown function (DUF3027)', 193, NULL, 'DUF3027', 273346),
(454253, 'PF18925', NULL, 'Family of unknown function (DUF5675)', 112, NULL, 'DUF5675', 273347),
(454254, 'PF09180', NULL, 'Prolyl-tRNA synthetase, C-terminal', 70, NULL, 'ProRS-C_1', 273348),
(454255, 'PF03572', NULL, 'Peptidase family S41', 166, NULL, 'Peptidase_S41', 273349),
(454256, 'PF10492', NULL, 'Nrf1 activator activation site binding domain', 80, NULL, 'Nrf1_activ_bdg', 273350),
(454257, 'PF00716', NULL, 'Assemblin (Peptidase family S21)', 337, NULL, 'Peptidase_S21', 273351),
(454258, 'PF00945', NULL, 'Rhabdovirus nucleocapsid protein', 410, NULL, 'Rhabdo_ncap', 273352),
(454259, 'PF18625', NULL, 'ESX-1 secreted protein B PE domain', 78, NULL, 'EspB_PE', 273353),
(454260, 'PF13042', NULL, 'Protein of unknown function (DUF3902)', 161, NULL, 'DUF3902', 273354),
(454261, 'PF02973', NULL, 'Sialidase, N-terminal domain', 189, NULL, 'Sialidase', 273355),
(454262, 'PF02422', NULL, 'Keratin', 89, NULL, 'Keratin', 273356),
(454263, 'PF03606', NULL, 'C4-dicarboxylate anaerobic carrier', 461, NULL, 'DcuC', 273357),
(454264, 'PF06122', NULL, 'Conjugative relaxosome accessory transposon protein', 358, NULL, 'TraH', 273358),
(454265, 'PF14521', NULL, 'Lysine-specific metallo-endopeptidase', 142, NULL, 'Aspzincin_M35', 273359),
(454266, 'PF06008', NULL, 'Laminin Domain I', 259, NULL, 'Laminin_I', 273360),
(454267, 'PF17602', NULL, 'Family of unknown function (DUF5498)', 96, NULL, 'DUF5498', 273361),
(454268, 'PF00224', NULL, 'Pyruvate kinase, barrel domain', 348, NULL, 'PK', 273362),
(454269, 'PF10626', NULL, 'Conjugative transposon protein TraO', 168, NULL, 'TraO', 273363),
(454270, 'PF02519', NULL, 'Auxin responsive protein', 90, NULL, 'Auxin_inducible', 273364),
(454271, 'PF11247', NULL, 'Bacteriophage T7, gene 5.5', 99, NULL, 'Phage_T7_55', 273365),
(454272, 'PF16593', NULL, 'Bridge helix of CRISPR-associated endonuclease Cas9', 33, NULL, 'Cas9-BH', 273366),
(454273, 'PF18281', NULL, 'BILBO1 N-terminal domain', 92, NULL, 'BILBO1_N', 273367),
(454274, 'PF15235', NULL, 'G protein-regulated inducer of neurite outgrowth C-terminus', 133, NULL, 'GRIN_C', 273368),
(454275, 'PF08553', NULL, 'VID27 C-terminal WD40-like domain', 356, NULL, 'VID27', 273369),
(454276, 'PF12717', NULL, 'non-SMC mitotic condensation complex subunit 1', 162, NULL, 'Cnd1', 273370),
(454277, 'PF15310', NULL, 'Vitamin A-deficiency (VAD) rat model signalling', 249, NULL, 'VAD1-2', 273371),
(454278, 'PF19085', NULL, 'Choline-binding repeat', 38, NULL, 'Choline_bind_2', 273372),
(454279, 'PF18127', NULL, 'Nicotinamide phosphoribosyltransferase, N-terminal domain', 98, NULL, 'NAMPT_N', 273373),
(454280, 'PF11662', NULL, 'Protein of unknown function (DUF3263)', 74, NULL, 'DUF3263', 273374),
(454281, 'PF02427', NULL, 'Photosystem I reaction centre subunit IV / PsaE', 60, NULL, 'PSI_PsaE', 273375),
(454282, 'PF15018', NULL, 'TRP-interacting helix', 35, NULL, 'InaF-motif', 273376),
(454283, 'PF17737', NULL, 'Ig domain in C19orf38 (HIDE1)', 91, NULL, 'Ig_C19orf38', 273377),
(454284, 'PF06691', NULL, 'Protein of unknown function (DUF1189)', 244, NULL, 'DUF1189', 273378),
(454285, 'PF13963', NULL, 'Transposase-associated domain', 74, NULL, 'Transpos_assoc', 273379),
(454286, 'PF10913', NULL, 'Protein of unknown function (DUF2706)', 59, NULL, 'DUF2706', 273380),
(454287, 'PF16602', NULL, 'Linker region of USP19 deubiquitinase', 121, NULL, 'USP19_linker', 273381),
(454288, 'PF17475', NULL, 'Clostridial binary toxin B/anthrax toxin PA domain 2', 218, NULL, 'Binary_toxB_2', 273382),
(454289, 'PF16590', NULL, 'Exocrine gland-secreting peptide', 91, NULL, 'ESP', 273383),
(454290, 'PF16835', NULL, 'Pre-mRNA-splicing factor SF3a complex subunit 2 (Prp11)', 96, NULL, 'SF3A2', 273384),
(454291, 'PF19117', NULL, 'Mitochondrial import 2', 45, NULL, 'Mim2', 273385);
INSERT INTO "PUBLIC"."MODEL" VALUES
(454292, 'PF20365', NULL, 'Family of unknown function (DUF6660)', 102, NULL, 'DUF6660', 273386),
(454293, 'PF06474', NULL, 'MltD lipid attachment motif', 34, NULL, 'MLTD_N', 273387),
(454294, 'PF13956', NULL, 'Toxin Ibs, type I toxin-antitoxin system', 19, NULL, 'Ibs_toxin', 273388),
(454295, 'PF12691', NULL, 'Bacteriophage minor capsid protein', 118, NULL, 'Minor_capsid_3', 273389),
(454296, 'PF02331', NULL, 'Apoptosis preventing protein', 296, NULL, 'P35', 273390),
(454297, 'PF12850', NULL, 'Calcineurin-like phosphoesterase superfamily domain', 160, NULL, 'Metallophos_2', 273391),
(454298, 'PF18259', NULL, 'Carbohydrate binding module 65 domain 1', 111, NULL, 'CBM65_1', 273392),
(454299, 'PF10464', NULL, 'Peptidase U40', 212, NULL, 'Peptidase_U40', 273393),
(454300, 'PF18720', NULL, 'Tenascin EGF domain', 29, NULL, 'EGF_Tenascin', 273394),
(454301, 'PF11978', NULL, 'Shoulder domain', 118, NULL, 'MVP_shoulder', 273395),
(454302, 'PF15053', NULL, 'Mjmu-R1-like protein family', 352, NULL, 'Njmu-R1', 273396),
(454303, 'PF11173', NULL, 'Protein of unknown function (DUF2960)', 79, NULL, 'DUF2960', 273397),
(454304, 'PF06729', NULL, 'Kinetochore component, CENP-R', 138, NULL, 'CENP-R', 273398),
(454305, 'PF19069', NULL, 'Family of unknown function (DUF5765)', 91, NULL, 'DUF5765', 273399),
(454306, 'PF05322', NULL, 'NINE Protein', 58, NULL, 'NinE', 273400),
(454307, 'PF03452', NULL, 'Anp1', 264, NULL, 'Anp1', 273401),
(454308, 'PF20214', NULL, 'Family of unknown function (DUF6574)', 258, NULL, 'DUF6574', 273402),
(454309, 'PF17172', NULL, 'Glutathione S-transferase N-terminal domain', 99, NULL, 'GST_N_4', 273403),
(454310, 'PF16702', NULL, 'Domain of unknown function (DUF5063)', 165, NULL, 'DUF5063', 273404),
(454311, 'PF15272', NULL, 'Spindle pole body component BBP1, C-terminal', 190, NULL, 'BBP1_C', 273405),
(454312, 'PF20525', NULL, 'Family of unknown function (DUF6740)', 532, NULL, 'DUF6740', 273406),
(454313, 'PF01170', NULL, 'Putative RNA methylase family UPF0020', 197, NULL, 'UPF0020', 273407),
(454314, 'PF05814', NULL, 'Orf76 (Ac76)', 83, NULL, 'Ac76', 273408),
(454315, 'PF18319', NULL, 'PriA DNA helicase Cys-rich region (CRR) domain', 27, NULL, 'PriA_CRR', 273409),
(454316, 'PF19786', NULL, 'Family of unknown function (DUF6270)', 221, NULL, 'DUF6270', 273410),
(454317, 'PF03638', NULL, 'Tesmin/TSO1-like CXC domain, cysteine-rich domain', 38, NULL, 'TCR', 273411),
(454318, 'PF05357', NULL, 'Phage Coat Protein A', 63, NULL, 'Phage_Coat_A', 273412),
(454319, 'PF05874', NULL, 'Pheromone biosynthesis activating neuropeptide (PBAN)', 184, NULL, 'PBAN', 273413),
(454320, 'PF11799', NULL, 'impB/mucB/samB family C-terminal domain', 113, NULL, 'IMS_C', 273414),
(454321, 'PF00053', NULL, 'Laminin EGF domain', 49, NULL, 'Laminin_EGF', 273415),
(454322, 'PF12198', NULL, 'Tuberculin-active protein', 83, NULL, 'Tuberculin', 273416),
(454323, 'PF09710', NULL, 'Treponema clustered lipoprotein (Trep_dent_lipo)', 397, NULL, 'Trep_dent_lipo', 273417),
(454324, 'PF17855', NULL, 'MCM AAA-lid domain', 87, NULL, 'MCM_lid', 273418),
(454325, 'PF03000', NULL, 'NPH3 family', 256, NULL, 'NPH3', 273419),
(454326, 'PF15266', NULL, 'Domain of unknown function (DUF4594)', 177, NULL, 'DUF4594', 273420),
(454327, 'PF16653', NULL, 'Saccharopine dehydrogenase C-terminal domain', 267, NULL, 'Sacchrp_dh_C', 273421),
(454328, 'PF07888', NULL, 'Calcium binding and coiled-coil domain (CALCOCO1) like', 496, NULL, 'CALCOCO1', 273422),
(454329, 'PF07274', NULL, 'Protein of unknown function (DUF1440)', 135, NULL, 'DUF1440', 273423),
(454330, 'PF12598', NULL, 'T-box transcription factor', 81, NULL, 'TBX', 273424),
(454331, 'PF09643', NULL, 'YopX protein', 129, NULL, 'YopX', 273425),
(454332, 'PF11231', NULL, 'Protein of unknown function (DUF3034)', 257, NULL, 'DUF3034', 273426),
(454333, 'PF08513', NULL, 'LisH', 27, NULL, 'LisH', 273427),
(454334, 'PF18275', NULL, 'His-Me finger endonuclease beta4-alpha2 domain', 52, NULL, 'His_Me_b4a2', 273428),
(454335, 'PF03507', NULL, 'CagA exotoxin phosphopeptide substrate mimic region', 39, NULL, 'CagA', 273429);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(454336, 'PF04498', NULL, 'Poxvirus nucleic acid binding protein VP8/L4R', 217, NULL, 'Pox_VP8_L4R', 273430),
(454337, 'PF18622', NULL, 'RctB helix turn helix domain', 107, NULL, 'HTH_55', 273431),
(454338, 'PF07914', NULL, 'Uncharacterized oxidoreductase dhs-27', 414, NULL, 'DUF1679', 273432),
(454339, 'PF13506', NULL, 'Glycosyl transferase family 21', 173, NULL, 'Glyco_transf_21', 273433),
(454340, 'PF14037', NULL, 'YoqO-like protein', 116, NULL, 'YoqO', 273434),
(454341, 'PF18161', NULL, 'ISP1 C-terminal', 107, NULL, 'ISP1_C', 273435),
(454342, 'PF02907', NULL, 'Hepatitis C virus NS3 protease', 149, NULL, 'Peptidase_S29', 273436),
(454343, 'PF09347', NULL, 'Domain of unknown function (DUF1989)', 167, NULL, 'DUF1989', 273437),
(454344, 'PF13715', NULL, 'CarboxypepD_reg-like domain', 88, NULL, 'CarbopepD_reg_2', 273438),
(454345, 'PF06145', NULL, 'Coronavirus nonstructural protein NS1', 29, NULL, 'Corona_NS1', 273439),
(454346, 'PF19962', NULL, 'Effector-associated domain 9', 62, NULL, 'EAD9', 273440),
(454347, 'PF11724', NULL, 'YvbH-like oligomerisation region', 61, NULL, 'YvbH_ext', 273441),
(454348, 'PF14188', NULL, 'Domain of unknown function (DUF4311)', 212, NULL, 'DUF4311', 273442),
(454349, 'PF04586', NULL, 'Caudovirus prohead serine protease', 163, NULL, 'Peptidase_S78', 273443),
(454350, 'PF15920', NULL, 'N-terminal of Junction-mediating and WASP homolog-associated', 50, NULL, 'WHAMM-JMY_N', 273444),
(454351, 'PF03693', NULL, 'Bacterial antitoxin of ParD toxin-antitoxin type II system and RHH', 81, NULL, 'ParD_antitoxin', 273445),
(454352, 'PF06783', NULL, 'Uncharacterised protein family (UPF0239)', 88, NULL, 'UPF0239', 273446),
(454353, 'PF20551', NULL, 'Family of unknown function (DUF6765)', 326, NULL, 'DUF6765', 273447),
(454354, 'PF05576', NULL, 'PS-10 peptidase S37', 448, NULL, 'Peptidase_S37', 273448),
(454355, 'PF19107', NULL, 'Family of unknown function (DUF5794)', 128, NULL, 'DUF5794', 273449),
(454356, 'PF04254', NULL, 'Protein of unknown function (DUF432)', 123, NULL, 'DUF432', 273450),
(454357, 'PF07990', NULL, 'Nucleic acid binding protein NABP', 388, NULL, 'NABP', 273451),
(454358, 'PF08407', NULL, 'Chitin synthase N-terminal', 73, NULL, 'Chitin_synth_1N', 273452),
(454359, 'PF19015', NULL, 'Family of unknown function (DUF5744)', 81, NULL, 'DUF5744', 273453),
(454360, 'PF16100', NULL, 'RecQ-mediated genome instability protein 2', 135, NULL, 'RMI2', 273454),
(454361, 'PF04875', NULL, 'Protein of unknown function, DUF645', 59, NULL, 'DUF645', 273455),
(454362, 'PF05789', NULL, 'Baculovirus VP1054 protein', 350, NULL, 'Baculo_VP1054', 273456),
(454363, 'PF03354', NULL, 'Terminase large subunit, ATPase domain', 178, NULL, 'TerL_ATPase', 273457),
(454364, 'PF18727', NULL, 'Alstrom syndrome repeat', 47, NULL, 'ALMS_repeat', 273458),
(454365, 'PF01398', NULL, 'JAB1/Mov34/MPN/PAD-1 ubiquitin protease', 118, NULL, 'JAB', 273459),
(454366, 'PF10617', NULL, 'Protein of unknown function (DUF2474)', 39, NULL, 'DUF2474', 273460),
(454367, 'PF13490', NULL, 'Putative zinc-finger', 35, NULL, 'zf-HC2', 273461),
(454368, 'PF18818', NULL, 'Zincin-like metallopeptidase', 126, NULL, 'MPTase-PolyVal', 273462),
(454369, 'PF02559', NULL, 'CarD-like/TRCF domain', 97, NULL, 'CarD_CdnL_TRCF', 273463),
(454370, 'PF17352', NULL, 'Male Flower Specific protein 18', 105, NULL, 'MFS18', 273464),
(454371, 'PF09325', NULL, 'Vps5 C terminal like', 236, NULL, 'Vps5', 273465),
(454372, 'PF14998', NULL, 'Transcription Regulator', 84, NULL, 'Ripply', 273466),
(454373, 'PF00077', NULL, 'Retroviral aspartyl protease', 101, NULL, 'RVP', 273467),
(454374, 'PF13070', NULL, 'Protein of unknown function (DUF3934)', 40, NULL, 'DUF3934', 273468),
(454375, 'PF01296', NULL, 'Galanin', 29, NULL, 'Galanin', 273469),
(454376, 'PF17170', NULL, '6-bladed beta-propeller', 321, NULL, 'DUF5128', 273470),
(454377, 'PF20299', NULL, 'Nucleotidyltransferase-Associated Rossmannoid Fold', 115, NULL, 'NARF', 273471),
(454378, 'PF00396', NULL, 'Granulin', 42, NULL, 'Granulin', 273472),
(454379, 'PF04515', NULL, 'Plasma-membrane choline transporter', 325, NULL, 'Choline_transpo', 273473);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(454380, 'PF00561', NULL, 'alpha/beta hydrolase fold', 257, NULL, 'Abhydrolase_1', 273474),
(454381, 'PF03876', NULL, 'SHS2 domain found in N terminus of Rpb7p/Rpc25p/MJ0397', 57, NULL, 'SHS2_Rpb7-N', 273475),
(454382, 'PF12111', NULL, 'Polyribonucleotide phosphorylase C terminal', 37, NULL, 'PNPase_C', 273476),
(454383, 'PF16467', NULL, 'Domain of unknown function (DUF5048)', 102, NULL, 'DUF5048', 273477),
(454384, 'PF15493', NULL, 'Domain of unknown function, YrpD', 216, NULL, 'YrpD', 273478),
(454385, 'PF03719', NULL, 'Ribosomal protein S5, C-terminal domain', 71, NULL, 'Ribosomal_S5_C', 273479),
(454386, 'PF01016', NULL, 'Ribosomal L27 protein', 79, NULL, 'Ribosomal_L27', 273480),
(454387, 'PF01002', NULL, 'Flavivirus non-structural protein NS2B', 127, NULL, 'Flavi_NS2B', 273481),
(454388, 'PF16000', NULL, 'CARMIL C-terminus', 300, NULL, 'CARMIL_C', 273482),
(454389, 'PF17354', NULL, 'Family of unknown function (DUF5382)', 418, NULL, 'DUF5382', 273483),
(454390, 'PF05476', NULL, 'PET122', 261, NULL, 'PET122', 273484),
(454391, 'PF20498', NULL, 'Family of unknown function (DUF6728)', 55, NULL, 'DUF6728', 273485),
(454392, 'PF07072', NULL, 'Cell division protein', 210, NULL, 'ZapD', 273486),
(454393, 'PF12397', NULL, 'U3 small nucleolar RNA-associated protein 10', 116, NULL, 'U3snoRNP10', 273487),
(454394, 'PF09793', NULL, 'Anticodon-binding domain', 90, NULL, 'AD', 273488),
(454395, 'PF00967', NULL, 'Barwin family', 119, NULL, 'Barwin', 273489),
(454396, 'PF05553', NULL, 'Cotton fibre expressed protein', 36, NULL, 'DUF761', 273490),
(454397, 'PF01592', NULL, 'NifU-like N terminal domain', 129, NULL, 'NifU_N', 273491),
(454398, 'PF17630', NULL, 'Family of unknown function (DUF5511)', 69, NULL, 'DUF5511', 273492),
(454399, 'PF02211', NULL, 'Nitrile hydratase beta subunit', 219, NULL, 'NHase_beta', 273493),
(454400, 'PF00313', NULL, '''Cold-shock'' DNA-binding domain', 66, NULL, 'CSD', 273494),
(454401, 'PF00474', NULL, 'Sodium:solute symporter family', 406, NULL, 'SSF', 273495),
(454402, 'PF08480', NULL, 'Disaggregatase related', 189, NULL, 'Disaggr_assoc', 273496),
(454403, 'PF16253', NULL, 'Domain of unknown function (DUF4909)', 127, NULL, 'DUF4909', 273497),
(454404, 'PF10305', NULL, 'RNA pol II promoter Fmp27 protein domain', 103, NULL, 'Fmp27_SW', 273498),
(454405, 'PF16228', NULL, 'Domain of unknown function (DUF4887)', 172, NULL, 'DUF4887', 273499),
(454406, 'PF02218', NULL, 'Repeat in HS1/Cortactin', 36, NULL, 'HS1_rep', 273500),
(454407, 'PF04514', NULL, 'Bluetongue virus non-structural protein NS2', 349, NULL, 'BTV_NS2', 273501),
(454408, 'PF13150', NULL, 'Conjugative transposon protein TraL', 86, NULL, 'TraL_transposon', 273502),
(454409, 'PF16614', NULL, 'Unstructured region two on RhoGEF 6 and 7', 99, NULL, 'RhoGEF67_u2', 273503),
(454410, 'PF18948', NULL, 'Family of unknown function (DUF5692)', 305, NULL, 'DUF5692', 273504),
(454411, 'PF13192', NULL, 'Thioredoxin domain', 76, NULL, 'Thioredoxin_3', 273505),
(454412, 'PF16140', NULL, 'Domain of unknown function (DUF4848)', 216, NULL, 'DUF4848', 273506),
(454413, 'PF18416', NULL, 'N-acetylglucosamine binding protein domain 2', 101, NULL, 'GbpA_2', 273507),
(454414, 'PF04487', NULL, 'CITED', 213, NULL, 'CITED', 273508),
(454415, 'PF17011', NULL, 'Domain of unknown function (DUF5093)', 131, NULL, 'DUF5093', 273509),
(454416, 'PF09432', NULL, 'Tho complex subunit THP2', 129, NULL, 'THP2', 273510),
(454417, 'PF14473', NULL, 'RD3 protein', 129, NULL, 'RD3', 273511),
(454418, 'PF16921', NULL, 'Tex protein YqgF-like domain', 126, NULL, 'Tex_YqgF', 273512),
(454419, 'PF00938', NULL, 'Lipoprotein', 86, NULL, 'Lipoprotein_3', 273513),
(454420, 'PF16335', NULL, 'Domain of unknown function (DUF4965)', 174, NULL, 'DUF4965', 273514),
(454421, 'PF17831', NULL, 'Pyruvate dehydrogenase E1 component middle domain', 229, NULL, 'PDH_E1_M', 273515),
(454422, 'PF14895', NULL, 'Protein phosphatase 1 inhibitor', 346, NULL, 'PPPI_inhib', 273516),
(454423, 'PF00811', NULL, 'Ependymin', 127, NULL, 'Ependymin', 273517),
(454424, 'PF09320', NULL, 'Domain of unknown function (DUF1977)', 106, NULL, 'DUF1977', 273518);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(454425, 'PF14107', NULL, 'Domain of unknown function (DUF4280)', 108, NULL, 'DUF4280', 273519),
(454426, 'PF08187', NULL, 'Myoactive tetradecapeptides family', 14, NULL, 'Tetradecapep', 273520),
(454427, 'PF08903', NULL, 'Domain of unknown function (DUF1846)', 489, NULL, 'DUF1846', 273521),
(454428, 'PF04654', NULL, 'Protein of unknown function, DUF599', 210, NULL, 'DUF599', 273522),
(454429, 'PF19244', NULL, 'Poly(A) polymerase catalytic subunit', 131, NULL, 'Poly_A_pol_cat', 273523),
(454430, 'PF03077', NULL, 'Putative vacuolating cytotoxin', 60, NULL, 'VacA2', 273524),
(454431, 'PF05834', NULL, 'Lycopene cyclase protein', 380, NULL, 'Lycopene_cycl', 273525),
(454432, 'PF05462', NULL, 'Slime mold cyclic AMP receptor', 305, NULL, 'Dicty_CAR', 273526),
(454433, 'PF15663', NULL, 'Zinc-finger containing family', 111, NULL, 'zf-CCCH_3', 273527),
(454434, 'PF00095', NULL, 'WAP-type (Whey Acidic Protein) ''four-disulfide core''', 43, NULL, 'WAP', 273528),
(454435, 'PF19485', NULL, 'Family of unknown function (DUF6021)', 64, NULL, 'DUF6021', 273529),
(454436, 'PF09511', NULL, 'RNA ligase', 223, NULL, 'RNA_lig_T4_1', 273530),
(454437, 'PF19564', NULL, 'Family of unknown function (DUF6086)', 119, NULL, 'DUF6086', 273531),
(454438, 'PF14267', NULL, 'Domain of unknown function (DUF4357)', 54, NULL, 'DUF4357', 273532),
(454439, 'PF14977', NULL, 'FAM194 protein', 203, NULL, 'FAM194', 273533),
(454440, 'PF12514', NULL, 'Protein of unknown function (DUF3718)', 66, NULL, 'DUF3718', 273534),
(454441, 'PF02484', NULL, 'Rhabdovirus Non-virion protein', 111, NULL, 'Rhabdo_NV', 273535),
(454442, 'PF00073', NULL, 'picornavirus capsid protein', 171, NULL, 'Rhv', 273536),
(454443, 'PF17824', NULL, 'Family of unknown function (DUF5586)', 404, NULL, 'DUF5586', 273537),
(454444, 'PF15627', NULL, 'CEP76 C2 domain', 155, NULL, 'CEP76-C2', 273538),
(454445, 'PF05390', NULL, 'Yeast cell wall synthesis protein KRE9/KNH1 C-terminal', 102, NULL, 'Kre9_KNH1_C', 273539),
(454446, 'PF13267', NULL, 'Protein of unknown function (DUF4058)', 254, NULL, 'DUF4058', 273540),
(454447, 'PF05559', NULL, 'Protein of unknown function (DUF763)', 320, NULL, 'DUF763', 273541),
(454448, 'PF18711', NULL, 'Toxoflavin-degrading enzyme', 55, NULL, 'TxDE', 273542),
(454449, 'PF15020', NULL, 'Cation channel sperm-associated protein subunit delta', 729, NULL, 'CATSPERD', 273543),
(454450, 'PF05944', NULL, 'Phage small terminase subunit', 130, NULL, 'Phage_term_smal', 273544),
(454451, 'PF11306', NULL, 'Protein of unknown function (DUF3108)', 225, NULL, 'DUF3108', 273545),
(454452, 'PF16474', NULL, 'Kinase non-catalytic C-lobe domain', 192, NULL, 'KIND', 273546),
(454453, 'PF05535', NULL, 'Chromadorea ALT protein', 80, NULL, 'Chromadorea_ALT', 273547),
(454454, 'PF00600', NULL, 'Influenza non-structural protein (NS1)', 217, NULL, 'Flu_NS1', 273548),
(454455, 'PF03780', NULL, 'Asp23 family, cell envelope-related function', 108, NULL, 'Asp23', 273549),
(454456, 'PF07497', NULL, 'Rho termination factor, RNA-binding domain', 73, NULL, 'Rho_RNA_bind', 273550),
(454457, 'PF12587', NULL, 'Protein of unknown function (DUF3761)', 88, NULL, 'DUF3761', 273551),
(454458, 'PF20298', NULL, 'Prokaryotic E2 domain', 109, NULL, 'E2-ntca', 273552),
(454459, 'PF13183', NULL, '4Fe-4S dicluster domain', 65, NULL, 'Fer4_8', 273553),
(454460, 'PF00673', NULL, 'ribosomal L5P family C-terminus', 94, NULL, 'Ribosomal_L5_C', 273554),
(454461, 'PF08193', NULL, 'INO80 complex subunit Ies4', 239, NULL, 'INO80_Ies4', 273555),
(454462, 'PF08757', NULL, 'CotH kinase protein', 321, NULL, 'CotH', 273556),
(454463, 'PF07968', NULL, 'Leukocidin/Hemolysin toxin family', 250, NULL, 'Leukocidin', 273557),
(454464, 'PF18255', NULL, 'DNA processing protein A sterile alpha motif domain', 62, NULL, 'SAM_DrpA', 273558),
(454465, 'PF16662', NULL, 'FLYWCH-type zinc finger-containing protein 1', 62, NULL, 'FLYWCH_u', 273559),
(454466, 'PF18683', NULL, 'Chitinase W immunoglobulin-like domain', 106, NULL, 'ChiW_Ig_like', 273560),
(454467, 'PF05221', NULL, 'S-adenosyl-L-homocysteine hydrolase', 299, NULL, 'AdoHcyase', 273561);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(454468, 'PF12955', NULL, 'Domain of unknown function (DUF3844)', 106, NULL, 'DUF3844', 273562),
(454469, 'PF16579', NULL, 'Adenylate sensor of SNF1-like protein kinase', 118, NULL, 'AdenylateSensor', 273563),
(454470, 'PF00121', NULL, 'Triosephosphate isomerase', 245, NULL, 'TIM', 273564),
(454471, 'PF00737', NULL, 'Photosystem II 10 kDa phosphoprotein', 52, NULL, 'PsbH', 273565),
(454472, 'PF05233', NULL, 'PHB accumulation regulatory domain', 40, NULL, 'PHB_acc', 273566),
(454473, 'PF08057', NULL, 'Erythromycin resistance leader peptide', 14, NULL, 'Ery_res_leader2', 273567),
(454474, 'PF05734', NULL, 'Herpesvirus protein of unknown function (DUF832)', 228, NULL, 'DUF832', 273568),
(454475, 'PF19350', NULL, 'Family of unknown function (DUF5928)', 256, NULL, 'DUF5928', 273569),
(454476, 'PF03216', NULL, 'Rhabdovirus nucleoprotein', 295, NULL, 'Rhabdo_ncap_2', 273570),
(454477, 'PF09197', NULL, 'Rap1, DNA-binding', 108, NULL, 'Rap1-DNA-bind', 273571),
(454478, 'PF16926', NULL, 'Archaeal 4TM region of histidine kinase', 130, NULL, 'HisKA_4TM', 273572),
(454479, 'PF11906', NULL, 'Protein of unknown function (DUF3426)', 146, NULL, 'DUF3426', 273573),
(454480, 'PF01394', NULL, 'Clathrin propeller repeat', 37, NULL, 'Clathrin_propel', 273574),
(454481, 'PF19900', NULL, 'Family of unknown function (DUF6373)', 54, NULL, 'DUF6373', 273575),
(454482, 'PF13089', NULL, 'Polyphosphate kinase N-terminal domain', 107, NULL, 'PP_kinase_N', 273576),
(454483, 'PF06168', NULL, 'Protein of unknown function (DUF981)', 187, NULL, 'DUF981', 273577),
(454484, 'PF05281', NULL, 'Neuroendocrine protein 7B2 precursor (Secretogranin V)', 227, NULL, 'Secretogranin_V', 273578),
(454485, 'PF10609', NULL, 'NUBPL iron-transfer P-loop NTPase', 246, NULL, 'ParA', 273579),
(454486, 'PF17268', NULL, 'Family of unknown function (DUF5334)', 71, NULL, 'DUF5334', 273580),
(454487, 'PF16914', NULL, 'Bacterial transcriptional repressor C-terminal', 105, NULL, 'TetR_C_12', 273581),
(454488, 'PF16545', NULL, 'Cerebral cavernous malformation protein, harmonin-homology', 101, NULL, 'CCM2_C', 273582),
(454489, 'PF06072', NULL, 'Alphaherpesvirus tegument protein US9', 61, NULL, 'Herpes_US9', 273583),
(454490, 'PF08812', NULL, 'YtxC-like family', 217, NULL, 'YtxC', 273584),
(454491, 'PF05965', NULL, 'F/Y rich C-terminus', 84, NULL, 'FYRC', 273585),
(454492, 'PF10351', NULL, 'Golgi-body localisation protein domain', 476, NULL, 'Apt1', 273586),
(454493, 'PF08843', NULL, 'Nucleotidyl transferase AbiEii toxin, Type IV TA system', 239, NULL, 'AbiEii', 273587),
(454494, 'PF01853', NULL, 'MOZ/SAS family', 180, NULL, 'MOZ_SAS', 273588),
(454495, 'PF02592', NULL, 'Putative vitamin uptake transporter', 151, NULL, 'Vut_1', 273589),
(454496, 'PF06092', NULL, 'Enterobacterial putative membrane protein (DUF943)', 151, NULL, 'DUF943', 273590),
(454497, 'PF14769', NULL, 'Flagellar C1a complex subunit C1a-32', 99, NULL, 'CLAMP', 273591),
(454498, 'PF13060', NULL, 'Protein of unknown function (DUF3921)', 58, NULL, 'DUF3921', 273592),
(454499, 'PF05273', NULL, 'Poxvirus RNA polymerase 22 kDa subunit', 184, NULL, 'Pox_RNA_Pol_22', 273593),
(454500, 'PF18902', NULL, 'Domain of unknown function (DUF5658)', 82, NULL, 'DUF5658', 273594),
(454501, 'PF19929', NULL, 'Family of unknown function (DUF6392)', 151, NULL, 'DUF6392', 273595),
(454502, 'PF05157', NULL, 'Type II secretion system (T2SS), protein E, N-terminal domain', 111, NULL, 'T2SSE_N', 273596),
(454503, 'PF04716', NULL, 'ETC complex I subunit conserved region', 67, NULL, 'ETC_C1_NDUFA5', 273597),
(454504, 'PF05804', NULL, 'Kinesin-associated protein (KAP)', 708, NULL, 'KAP', 273598),
(454505, 'PF08496', NULL, 'Peptidase family S49 N-terminal', 147, NULL, 'Peptidase_S49_N', 273599),
(454506, 'PF12034', NULL, 'Domain of unknown function (DUF3520)', 185, NULL, 'DUF3520', 273600),
(454507, 'PF13961', NULL, 'Domain of unknown function (DUF4219)', 27, NULL, 'DUF4219', 273601),
(454508, 'PF02977', NULL, 'Carboxypeptidase A inhibitor', 46, NULL, 'CarbpepA_inh', 273602),
(454509, 'PF20407', NULL, 'Domain of unknown function (DUF1583_N)', 150, NULL, 'DUF1583_N', 273603); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(454510, 'PF16840', NULL, 'Actin-like protein 7A N-terminus', 65, NULL, 'ACTL7A_N', 273604),
(454511, 'TRANSMEMBRANE', NULL, 'Region of a membrane-bound protein predicted to be embedded in the membrane.', NULL, NULL, 'Transmembrane region', 273605),
(454512, 'SIGNAL_PEPTIDE_C_REGION', NULL, 'C-terminal region of a signal peptide.', NULL, NULL, 'Signal peptide C-region', 273606),
(454513, 'SIGNAL_PEPTIDE_H_REGION', NULL, 'Hydrophobic region of a signal peptide.', NULL, NULL, 'Signal peptide H-region', 273607),
(454514, 'NON_CYTOPLASMIC_DOMAIN', NULL, 'Region of a membrane-bound protein predicted to be outside the membrane, in the extracellular region.', NULL, NULL, 'Non cytoplasmic domain', 273608),
(454515, 'SIGNAL_PEPTIDE_N_REGION', NULL, 'N-terminal region of a signal peptide.', NULL, NULL, 'Signal peptide N-region', 273609),
(454516, 'SIGNAL_PEPTIDE', NULL, 'Signal peptide region', NULL, NULL, 'Signal Peptide', 273610),
(454517, 'CYTOPLASMIC_DOMAIN', NULL, 'Region of a membrane-bound protein predicted to be outside the membrane, in the cytoplasm.', NULL, NULL, 'Cytoplasmic domain', 273611),
(454518, 'PIRSF026508', NULL, NULL, 376, NULL, 'TelA', 273612),
(454519, 'PIRSF031737', NULL, NULL, 294, NULL, 'TM_LytTR', 273613),
(454520, 'PIRSF000354', NULL, NULL, 2194, NULL, 'Factors_V_VIII', 273614),
(454521, 'PIRSF036958', NULL, NULL, 615, NULL, 'mRNA_capping_HCE', 273615),
(454522, 'PIRSF005227', NULL, NULL, 269, NULL, 'Asp_dh_NAD_syn', 273616),
(454523, 'PIRSF015736', NULL, NULL, 252, NULL, 'MI', 273617),
(454524, 'PIRSF002004', NULL, NULL, 1275, NULL, 'Leukocyte_common_antigen', 273618),
(454525, 'PIRSF004633', NULL, NULL, 182, NULL, 'UCP_PLP_oxd', 273619),
(454526, 'PIRSF007663', NULL, NULL, 796, NULL, 'UCP007663', 273620),
(454527, 'PIRSF030092', NULL, NULL, 128, NULL, 'UCP030092', 273621),
(454528, 'PIRSF037647', NULL, NULL, 443, NULL, 'LisH', 273622),
(454529, 'PIRSF500139', NULL, NULL, 480, NULL, 'AE', 273623),
(454530, 'PIRSF028200', NULL, NULL, 283, NULL, 'UCP028200', 273624),
(454531, 'PIRSF036618', NULL, NULL, 598, NULL, 'MobB_MoeA', 273625),
(454532, 'PIRSF017932', NULL, NULL, 388, NULL, 'Conjugal_TraB', 273626),
(454533, 'PIRSF037266', NULL, NULL, 98, NULL, 'UCP037266', 273627),
(454534, 'PIRSF005590', NULL, NULL, 182, NULL, 'RPL10a_RPL10e', 273628),
(454535, 'PIRSF000490', NULL, NULL, 560, NULL, 'Diphtheria_toxin', 273629),
(454536, 'PIRSF001705', NULL, NULL, 430, NULL, 'Myc_protein', 273630),
(454537, 'PIRSF001199', NULL, NULL, 1034, NULL, 'BMP1', 273631),
(454538, 'PIRSF015578', NULL, NULL, 431, NULL, 'Myoinositol-ppht_synth', 273632),
(454539, 'PIRSF003336', NULL, NULL, 230, NULL, 'RadB', 273633),
(454540, 'PIRSF005751', NULL, NULL, 350, NULL, 'Acet_citr_lig', 273634),
(454541, 'PIRSF037093', NULL, NULL, 904, NULL, 'Gamma-COP', 273635),
(454542, 'PIRSF006533', NULL, NULL, 174, NULL, 'UCP006533', 273636),
(454543, 'PIRSF011355', NULL, NULL, 251, NULL, 'VP24', 273637),
(454544, 'PIRSF004323', NULL, NULL, 67, NULL, 'Xis-Tn', 273638),
(454545, 'PIRSF038120', NULL, NULL, 326, NULL, 'Uch', 273639),
(454546, 'PIRSF006591', NULL, NULL, 213, NULL, 'UCP_CBS_MJ1004', 273640),
(454547, 'PIRSF036613', NULL, NULL, 214, NULL, 'LytTR', 273641),
(454548, 'PIRSF015957', NULL, NULL, 242, NULL, 'UCP015957', 273642),
(454549, 'PIRSF009141', NULL, NULL, 268, NULL, 'UCP009141', 273643),
(454550, 'PIRSF006540', NULL, NULL, 258, NULL, 'Nop17p', 273644),
(454551, 'PIRSF000343', NULL, NULL, 252, NULL, 'HMX1', 273645),
(454552, 'PIRSF015852', NULL, NULL, 263, NULL, 'RRNA_mtase_Grm', 273646),
(454553, 'PIRSF019108', NULL, NULL, 108, NULL, 'Txn_reg_CopG', 273647),
(454554, 'PIRSF019422', NULL, NULL, 415, NULL, 'MltA', 273648),
(454555, 'PIRSF010340', NULL, NULL, 5052, NULL, 'Midasin', 273649),
(454556, 'PIRSF013286', NULL, NULL, 256, NULL, 'MED6_fungi', 273650),
(454557, 'PIRSF003958', NULL, NULL, 447, NULL, 'NS-S_TospoV', 273651),
(454558, 'PIRSF028680', NULL, NULL, 152, NULL, 'UCP028680', 273652),
(454559, 'PIRSF020513', NULL, NULL, 329, NULL, '6alphaFUT_NodZ', 273653),
(454560, 'PIRSF029389', NULL, NULL, 590, NULL, 'Subtilisin_rel_PA1242', 273654);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(454561, 'PIRSF002191', NULL, NULL, 151, NULL, 'Ribosomal_L19', 273655),
(454562, 'PIRSF022993', NULL, NULL, 166, NULL, 'Profilin_api', 273656),
(454563, 'PIRSF012524', NULL, NULL, 290, NULL, 'YitL_S1', 273657),
(454564, 'PIRSF019251', NULL, NULL, 477, NULL, 'Rv0465c', 273658),
(454565, 'PIRSF001369', NULL, NULL, 383, NULL, 'Citrate_synth', 273659),
(454566, 'PIRSF033634', NULL, NULL, 211, NULL, 'UCP033634', 273660),
(454567, 'PIRSF036431', NULL, NULL, 628, NULL, 'HK_DctB', 273661),
(454568, 'PIRSF016394', NULL, NULL, 95, NULL, 'Lsm2', 273662),
(454569, 'PIRSF004548', NULL, NULL, 462, NULL, 'CreD', 273663),
(454570, 'PIRSF001340', NULL, NULL, 561, NULL, 'AIRC', 273664),
(454571, 'PIRSF037433', NULL, NULL, 491, NULL, 'HK_STH3221', 273665),
(454572, 'PIRSF036956', NULL, NULL, 727, NULL, 'Hrs_Vps27', 273666),
(454573, 'PIRSF035805', NULL, NULL, 197, NULL, 'Tdk', 273667),
(454574, 'PIRSF001456', NULL, NULL, 373, NULL, 'Chorismate_synth', 273668),
(454575, 'PIRSF031854', NULL, NULL, 346, NULL, 'UCP031854', 273669),
(454576, 'PIRSF016660', NULL, NULL, 307, NULL, 'YedI', 273670),
(454577, 'PIRSF037001', NULL, NULL, 989, NULL, 'RNA_ed_MP81', 273671),
(454578, 'PIRSF003028', NULL, NULL, 408, NULL, 'Txn_fact_GATA_4/5/6', 273672),
(454579, 'PIRSF001620', NULL, NULL, 275, NULL, 'TFPI', 273673),
(454580, 'PIRSF500134', NULL, NULL, 440, NULL, 'UDPglc_DH_bac', 273674),
(454581, 'PIRSF037778', NULL, NULL, 186, NULL, 'UCP037778_transp_RibU', 273675),
(454582, 'PIRSF006779', NULL, NULL, 271, NULL, 'UCP006779', 273676),
(454583, 'PIRSF018357', NULL, NULL, 253, NULL, 'Trans_reg_ArsR', 273677),
(454584, 'PIRSF002026', NULL, NULL, 160, NULL, 'Nematode_globin', 273678),
(454585, 'PIRSF009120', NULL, NULL, 250, NULL, 'UCP009120_prtse', 273679),
(454586, 'PIRSF032806', NULL, NULL, 465, NULL, 'UCP032806', 273680),
(454587, 'PIRSF039085', NULL, NULL, 252, NULL, 'ABC_ATPase_HisP', 273681),
(454588, 'PIRSF001013', NULL, NULL, 154, NULL, 'RNAse_Ba', 273682),
(454589, 'PIRSF002181', NULL, NULL, 176, NULL, 'RPL13p_RPL13Aa_RPL16e_RPL13o', 273683),
(454590, 'PIRSF037714', NULL, NULL, 462, NULL, 'TolR', 273684),
(454591, 'PIRSF000187', NULL, NULL, 2135, NULL, 'GOGAT', 273685),
(454592, 'PIRSF000887', NULL, NULL, 239, NULL, 'Pesterase_MJ0037', 273686),
(454593, 'PIRSF007212', NULL, NULL, 712, NULL, 'Capsid_P70', 273687),
(454594, 'PIRSF003169', NULL, NULL, 387, NULL, 'HK_DegS', 273688),
(454595, 'PIRSF018649', NULL, NULL, 698, NULL, 'UCP018649', 273689),
(454596, 'PIRSF006005', NULL, NULL, 500, NULL, 'GalT_BS', 273690),
(454597, 'PIRSF031773', NULL, NULL, 392, NULL, 'ABC_31773', 273691),
(454598, 'PIRSF036873', NULL, NULL, 2925, NULL, 'L_TenuV', 273692),
(454599, 'PIRSF005713', NULL, NULL, 402, NULL, 'P2X_purinoceptor', 273693),
(454600, 'PIRSF029288', NULL, NULL, 274, NULL, 'SciE_ImpE', 273694),
(454601, 'PIRSF000235', NULL, NULL, 348, NULL, 'GMP_reductase', 273695),
(454602, 'PIRSF019311', NULL, NULL, 172, NULL, 'Mb_md_hydr_PF0129', 273696),
(454603, 'PIRSF002033', NULL, NULL, 118, NULL, 'Hemerythrin_euk', 273697),
(454604, 'PIRSF030013', NULL, NULL, 241, NULL, 'ThuA_PalA', 273698),
(454605, 'PIRSF029745', NULL, NULL, 577, NULL, 'FhaC', 273699),
(454606, 'PIRSF036538', NULL, NULL, 84, NULL, 'EhaK', 273700),
(454607, 'PIRSF027936', NULL, NULL, 271, NULL, 'UCP027936', 273701),
(454608, 'PIRSF001703', NULL, NULL, 436, NULL, 'GABP_alpha', 273702),
(454609, 'PIRSF028732', NULL, NULL, 92, NULL, 'Alba', 273703),
(454610, 'PIRSF017835', NULL, NULL, 102, NULL, 'ATP-synth_g_mitoch_animal', 273704),
(454611, 'PIRSF017292', NULL, NULL, 108, NULL, 'UCP017292_zn', 273705),
(454612, 'PIRSF000349', NULL, NULL, 232, NULL, 'MnSOD_FeSOD', 273706),
(454613, 'PIRSF002520', NULL, NULL, 618, NULL, 'ALB', 273707),
(454614, 'PIRSF036947', NULL, NULL, 1473, NULL, 'Spt6', 273708),
(454615, 'PIRSF036639', NULL, NULL, 188, NULL, 'PMK_anim', 273709),
(454616, 'PIRSF000378', NULL, NULL, 124, NULL, 'Gly_radicl_YfiD', 273710),
(454617, 'PIRSF012318', NULL, NULL, 282, NULL, 'UCP012318', 273711),
(454618, 'PIRSF038056', NULL, NULL, 616, NULL, 'BP10_SPAN', 273712);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(454619, 'PIRSF028135', NULL, NULL, 445, NULL, 'UCP028135_HipA-like', 273713),
(454620, 'PIRSF038171', NULL, NULL, 467, NULL, 'MAPKKK8', 273714),
(454621, 'PIRSF015278', NULL, NULL, 170, NULL, 'UCP015278', 273715),
(454622, 'PIRSF001866', NULL, NULL, 177, NULL, 'Mating_factor_alpha', 273716),
(454623, 'PIRSF037260', NULL, NULL, 92, NULL, 'UCP037260', 273717),
(454624, 'PIRSF001956', NULL, NULL, 898, NULL, 'IL3R_beta_c', 273718),
(454625, 'PIRSF018814', NULL, NULL, 218, NULL, 'UCP018814', 273719),
(454626, 'PIRSF001434', NULL, NULL, 406, NULL, 'CGS', 273720),
(454627, 'PIRSF021898', NULL, NULL, 291, NULL, 'UCP021898', 273721),
(454628, 'PIRSF037402', NULL, NULL, 367, NULL, 'Lefty', 273722),
(454629, 'PIRSF002724', NULL, NULL, 90, NULL, 'Actobindin', 273723),
(454630, 'PIRSF019876', NULL, NULL, 205, NULL, 'HasA', 273724),
(454631, 'PIRSF006748', NULL, NULL, 488, NULL, 'MDM_2/4', 273725),
(454632, 'PIRSF020653', NULL, NULL, 137, NULL, 'UCP020653', 273726),
(454633, 'PIRSF000170', NULL, NULL, 206, NULL, 'Succ_dh_cyt_b558', 273727),
(454634, 'PIRSF002030', NULL, NULL, 130, NULL, 'Globin_Protozoa_Cyanob', 273728),
(454635, 'PIRSF020893', NULL, NULL, 177, NULL, 'UCP020893', 273729),
(454636, 'PIRSF038921', NULL, NULL, 261, NULL, 'P14a', 273730),
(454637, 'PIRSF036055', NULL, NULL, 158, NULL, 'UCP036055', 273731),
(454638, 'PIRSF032442', NULL, NULL, 245, NULL, 'UCP032442', 273732),
(454639, 'PIRSF028865', NULL, NULL, 216, NULL, 'Membrin-2', 273733),
(454640, 'PIRSF003509', NULL, NULL, 173, NULL, 'UL45_HPV', 273734),
(454641, 'PIRSF000676', NULL, NULL, 316, NULL, 'Homoser_kin', 273735),
(454642, 'PIRSF019072', NULL, NULL, 102, NULL, 'UCP019072', 273736),
(454643, 'PIRSF037980', NULL, NULL, 1002, NULL, 'Sarcos_oxid_alpha', 273737),
(454644, 'PIRSF016408', NULL, NULL, 561, NULL, 'PAGM', 273738),
(454645, 'PIRSF002397', NULL, NULL, 3374, NULL, 'BRCA2', 273739),
(454646, 'PIRSF011407', NULL, NULL, 324, NULL, 'OmpS_Legionella', 273740),
(454647, 'PIRSF016089', NULL, NULL, 186, NULL, 'SPC3', 273741),
(454648, 'PIRSF027174', NULL, NULL, 446, NULL, 'YMR209C', 273742),
(454649, 'PIRSF036758', NULL, NULL, 400, NULL, 'Aden_M_ParB', 273743),
(454650, 'PIRSF034754', NULL, NULL, 117, NULL, 'SigE', 273744),
(454651, 'PIRSF029658', NULL, NULL, 274, NULL, 'UCP029658_TPR', 273745),
(454652, 'PIRSF034409', NULL, NULL, 778, NULL, 'Oligosach_lyase', 273746),
(454653, 'PIRSF016150', NULL, NULL, 459, NULL, 'FucT_helico', 273747),
(454654, 'PIRSF020514', NULL, NULL, 168, NULL, 'NolB', 273748),
(454655, 'PIRSF002686', NULL, NULL, 443, NULL, 'SLG', 273749),
(454656, 'PIRSF012611', NULL, NULL, 346, NULL, 'UCP012611', 273750),
(454657, 'PIRSF005651', NULL, NULL, 307, NULL, 'HflC', 273751),
(454658, 'PIRSF001111', NULL, NULL, 293, NULL, 'Isochorismatase', 273752),
(454659, 'PIRSF033913', NULL, NULL, 174, NULL, 'S-S_format_DsbB', 273753),
(454660, 'PIRSF000777', NULL, NULL, 260, NULL, 'RNA_pol_RPC31', 273754),
(454661, 'PIRSF037119', NULL, NULL, 787, NULL, 'HK_PgtB', 273755),
(454662, 'PIRSF018468', NULL, NULL, 909, NULL, 'Rep_DICDI', 273756),
(454663, 'PIRSF028139', NULL, NULL, 114, NULL, 'DOPA-diox_rel_Mll2280', 273757),
(454664, 'PIRSF037213', NULL, NULL, 175, NULL, 'UCP037213', 273758),
(454665, 'PIRSF000476', NULL, NULL, 470, NULL, 'EGT', 273759),
(454666, 'PIRSF005956', NULL, NULL, 270, NULL, 'BtpA', 273760),
(454667, 'PIRSF012563', NULL, NULL, 285, NULL, 'YtxC', 273761),
(454668, 'PIRSF003383', NULL, NULL, 622, NULL, 'E1_PLV', 273762),
(454669, 'PIRSF004803', NULL, NULL, 561, NULL, 'RnjA', 273763),
(454670, 'PIRSF021350', NULL, NULL, 349, NULL, 'UCP021350', 273764),
(454671, 'PIRSF014899', NULL, NULL, 281, NULL, 'UCP014899', 273765),
(454672, 'PIRSF022788', NULL, NULL, 267, NULL, 'UCP022788', 273766),
(454673, 'PIRSF037595', NULL, NULL, 802, NULL, 'Toll-like_receptor', 273767),
(454674, 'PIRSF002031', NULL, NULL, 1431, NULL, 'Poly_globin', 273768),
(454675, 'PIRSF033318', NULL, NULL, 188, NULL, 'GFA', 273769),
(454676, 'PIRSF015696', NULL, NULL, 96, NULL, 'VAC_E10R', 273770),
(454677, 'PIRSF016400', NULL, NULL, 190, NULL, 'TRAP-beta', 273771);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(454678, 'PIRSF500687', NULL, NULL, 134, NULL, 'MTase_demethylubiq_bact', 273772),
(454679, 'PIRSF039099', NULL, NULL, 534, NULL, 'APP-BP1', 273773),
(454680, 'PIRSF038061', NULL, NULL, 321, NULL, 'K(+)', 273774),
(454681, 'PIRSF001146', NULL, NULL, 592, NULL, 'Factor_XII_HGFA', 273775),
(454682, 'PIRSF032146', NULL, NULL, 160, NULL, 'UCP032146', 273776),
(454683, 'PIRSF006241', NULL, NULL, 264, NULL, 'HyI', 273777),
(454684, 'PIRSF019404', NULL, NULL, 148, NULL, 'FliJ', 273778),
(454685, 'PIRSF001143', NULL, NULL, 441, NULL, 'Coagul_factor_X', 273779),
(454686, 'PIRSF006530', NULL, NULL, 266, NULL, 'MtrC', 273780),
(454687, 'PIRSF015894', NULL, NULL, 664, NULL, 'PRMT5', 273781),
(454688, 'PIRSF017269', NULL, NULL, 273, NULL, 'GCD14', 273782),
(454689, 'PIRSF039090', NULL, NULL, 135, NULL, 'Flis', 273783),
(454690, 'PIRSF000551', NULL, NULL, 724, NULL, 'PKC_delta', 273784),
(454691, 'PIRSF004029', NULL, NULL, 562, NULL, 'N_ArenaV', 273785),
(454692, 'PIRSF037755', NULL, NULL, 319, NULL, 'Mettl2', 273786),
(454693, 'PIRSF030042', NULL, NULL, 136, NULL, 'UCP030042', 273787),
(454694, 'PIRSF037442', NULL, NULL, 294, NULL, 'UCP037442_abhydr', 273788),
(454695, 'PIRSF026622', NULL, NULL, 235, NULL, 'UCP026622_CAAX', 273789),
(454696, 'PIRSF500682', NULL, NULL, 706, NULL, 'Serotransferrin', 273790),
(454697, 'PIRSF036200', NULL, NULL, 237, NULL, 'UCP_TEII', 273791),
(454698, 'PIRSF009343', NULL, NULL, 485, NULL, 'SUV39_HMTase_SET', 273792),
(454699, 'PIRSF021377', NULL, NULL, 155, NULL, 'YtfJ', 273793),
(454700, 'PIRSF027386', NULL, NULL, 337, NULL, 'UCP027386_ABC_sbc_TM0202', 273794),
(454701, 'PIRSF013212', NULL, NULL, 762, NULL, 'PRDM1_SET', 273795),
(454702, 'PIRSF037004', NULL, NULL, 319, NULL, 'UCP037004', 273796),
(454703, 'PIRSF500181', NULL, NULL, 761, NULL, 'Complement_B', 273797),
(454704, 'PIRSF037239', NULL, NULL, 995, NULL, 'Exonuclease_Xrn2', 273798),
(454705, 'PIRSF038881', NULL, NULL, 89, NULL, 'RNAbp_HP1423', 273799),
(454706, 'PIRSF012281', NULL, NULL, 266, NULL, 'UCP012281', 273800),
(454707, 'PIRSF025737', NULL, NULL, 268, NULL, 'Cyco1', 273801),
(454708, 'PIRSF000858', NULL, NULL, 523, NULL, 'SCOT-t', 273802),
(454709, 'PIRSF006287', NULL, NULL, 122, NULL, 'UCP006287', 273803),
(454710, 'PIRSF015689', NULL, NULL, 296, NULL, 'Actaldh_dh_actylatng', 273804),
(454711, 'PIRSF037215', NULL, NULL, 411, NULL, 'Peptidase_T', 273805),
(454712, 'PIRSF037907', NULL, NULL, 654, NULL, 'Subtilisin_rel_TK1689', 273806),
(454713, 'PIRSF021700', NULL, NULL, 159, NULL, '3-demethylubiquinone_Mtase', 273807),
(454714, 'PIRSF036488', NULL, NULL, 148, NULL, 'Myoglobin_tremt', 273808),
(454715, 'PIRSF006603', NULL, NULL, 462, NULL, 'DinF', 273809),
(454716, 'PIRSF000962', NULL, NULL, 368, NULL, '3_5-cyc_nuc_Pdiesterase', 273810),
(454717, 'PIRSF000617', NULL, NULL, 1406, NULL, 'TyrPK_HGF-R', 273811),
(454718, 'PIRSF000939', NULL, NULL, 373, NULL, 'MAPK_Ptase', 273812),
(454719, 'PIRSF029775', NULL, NULL, 104, NULL, 'Isochor_pyr_lyas', 273813),
(454720, 'PIRSF038005', NULL, NULL, 545, NULL, 'MBD4', 273814),
(454721, 'PIRSF006091', NULL, NULL, 211, NULL, 'E_trnsport_RnfG', 273815),
(454722, 'PIRSF039050', NULL, NULL, 1090, NULL, 'Ade_cyc', 273816),
(454723, 'PIRSF029143', NULL, NULL, 105, NULL, 'UCP029143', 273817),
(454724, 'PIRSF029570', NULL, NULL, 948, NULL, 'UCP029570', 273818),
(454725, 'PIRSF001549', NULL, NULL, 439, NULL, 'His-tRNA_synth', 273819),
(454726, 'PIRSF020357', NULL, NULL, 408, NULL, 'UCP020357', 273820),
(454727, 'PIRSF038128', NULL, NULL, 329, NULL, 'CORI1', 273821),
(454728, 'PIRSF004930', NULL, NULL, 346, NULL, 'Tln_factor_SUA5', 273822),
(454729, 'PIRSF005883', NULL, NULL, 422, NULL, 'Carbohydrate_ST', 273823),
(454730, 'PIRSF037228', NULL, NULL, 987, NULL, 'Lan_mod_RumM', 273824),
(454731, 'PIRSF000477', NULL, NULL, 280, NULL, 'PurNPase', 273825),
(454732, 'PIRSF000543', NULL, NULL, 391, NULL, 'NDUAA', 273826),
(454733, 'PIRSF001341', NULL, NULL, 321, NULL, 'His_decarboxylas', 273827),
(454734, 'PIRSF000022', NULL, NULL, 118, NULL, 'Bc1_14K', 273828),
(454735, 'PIRSF016527', NULL, NULL, 261, NULL, 'TNF_CD40', 273829);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(454736, 'PIRSF034781', NULL, NULL, 247, NULL, 'GEF_SopE', 273830),
(454737, 'PIRSF026534', NULL, NULL, 335, NULL, 'ABN', 273831),
(454738, 'PIRSF028415', NULL, NULL, 368, NULL, 'UCP028415', 273832),
(454739, 'PIRSF000310', NULL, NULL, 355, NULL, 'Upt_hd_small', 273833),
(454740, 'PIRSF005276', NULL, NULL, 147, NULL, 'SspB', 273834),
(454741, 'PIRSF003137', NULL, NULL, 204, NULL, 'CoM_red_McrC', 273835),
(454742, 'PIRSF006337', NULL, NULL, 600, NULL, 'Glycosyltrehalos_trehalohydrls', 273836),
(454743, 'PIRSF038027', NULL, NULL, 95, NULL, 'Ufm1', 273837),
(454744, 'PIRSF004576', NULL, NULL, 247, NULL, 'Resolvase_Rsv', 273838),
(454745, 'PIRSF038455', NULL, NULL, 274, NULL, 'SoxA', 273839),
(454746, 'PIRSF006529', NULL, NULL, 216, NULL, 'UCP006529_dinclt', 273840),
(454747, 'PIRSF038980', NULL, NULL, 1639, NULL, 'A2M_bac', 273841),
(454748, 'PIRSF038072', NULL, NULL, 414, NULL, 'Na(+)/PI_cotransporter', 273842),
(454749, 'PIRSF015692', NULL, NULL, 737, NULL, 'VAC_E2L', 273843),
(454750, 'PIRSF004952', NULL, NULL, 121, NULL, 'RNase_P_2', 273844),
(454751, 'PIRSF026546', NULL, NULL, 209, NULL, 'UCP_CBS_YqzB', 273845),
(454752, 'PIRSF012702', NULL, NULL, 501, NULL, 'MlrC', 273846),
(454753, 'PIRSF029342', NULL, NULL, 384, NULL, 'UCP029342_Bll4150', 273847),
(454754, 'PIRSF036542', NULL, NULL, 409, NULL, 'SpmA_SpmB', 273848),
(454755, 'PIRSF001021', NULL, NULL, 510, NULL, 'Alph-amls_thrmst', 273849),
(454756, 'PIRSF016533', NULL, NULL, 150, NULL, 'Sp17', 273850),
(454757, 'PIRSF019587', NULL, NULL, 165, NULL, 'PGPase', 273851),
(454758, 'PIRSF015162', NULL, NULL, 197, NULL, 'IL-18', 273852),
(454759, 'PIRSF028043', NULL, NULL, 721, NULL, 'PP2A_B56', 273853),
(454760, 'PIRSF025218', NULL, NULL, 556, NULL, 'UCP025218', 273854),
(454761, 'PIRSF018783', NULL, NULL, 330, NULL, 'UCP018783', 273855),
(454762, 'PIRSF004897', NULL, NULL, 167, NULL, 'UCP004897_ACT', 273856),
(454763, 'PIRSF036959', NULL, NULL, 433, NULL, 'mRNA_cap_alpha', 273857),
(454764, 'PIRSF000846', NULL, NULL, 308, NULL, 'ATP_adenylyltr', 273858),
(454765, 'PIRSF030811', NULL, NULL, 338, NULL, 'UCP030811', 273859),
(454766, 'PIRSF018148', NULL, NULL, 528, NULL, 'UCP_CBS_YBR214w', 273860),
(454767, 'PIRSF009160', NULL, NULL, 250, NULL, 'UCP009160', 273861),
(454768, 'PIRSF026587', NULL, NULL, 328, NULL, 'Epsilon_toxin', 273862),
(454769, 'PIRSF000309', NULL, NULL, 236, NULL, 'HoxU', 273863),
(454770, 'PIRSF037490', NULL, NULL, 360, NULL, 'UCP037490_NIF3', 273864),
(454771, 'PIRSF000370', NULL, NULL, 220, NULL, 'QueE', 273865),
(454772, 'PIRSF037799', NULL, NULL, 78, NULL, 'Tautomer_YdcE', 273866),
(454773, 'PIRSF500683', NULL, NULL, 708, NULL, 'Lactotransferrin', 273867),
(454774, 'PIRSF016719', NULL, NULL, 419, NULL, 'UCP016719', 273868),
(454775, 'PIRSF037863', NULL, NULL, 455, NULL, 'SLP_lactobac', 273869),
(454776, 'PIRSF001294', NULL, NULL, 565, NULL, 'H/K_exch_ATPase_A', 273870),
(454777, 'PIRSF036597', NULL, NULL, 995, NULL, 'Protse_InhA_rel', 273871),
(454778, 'PIRSF011409', NULL, NULL, 735, NULL, '3HB_olig_hydr', 273872),
(454779, 'PIRSF004789', NULL, NULL, 268, NULL, 'DR1281', 273873),
(454780, 'PIRSF016134', NULL, NULL, 111, NULL, 'UCP016134', 273874),
(454781, 'PIRSF015013', NULL, NULL, 303, NULL, 'UCP015013', 273875),
(454782, 'PIRSF006468', NULL, NULL, 370, NULL, 'BCAT1', 273876),
(454783, 'PIRSF031503', NULL, NULL, 260, NULL, 'UCP031503_mp', 273877),
(454784, 'PIRSF036684', NULL, NULL, 760, NULL, 'ME_PTA', 273878),
(454785, 'PIRSF037472', NULL, NULL, 804, NULL, 'DHPS_Mtase', 273879),
(454786, 'PIRSF000862', NULL, NULL, 408, NULL, 'Steryl_ester_lip', 273880),
(454787, 'PIRSF001522', NULL, NULL, 315, NULL, 'OmpP', 273881),
(454788, 'PIRSF028177', NULL, NULL, 271, NULL, 'TcmP', 273882),
(454789, 'PIRSF000806', NULL, NULL, 493, NULL, 'UDPGP', 273883),
(454790, 'PIRSF002211', NULL, NULL, 61, NULL, 'RPL30p', 273884),
(454791, 'PIRSF038321', NULL, NULL, 181, NULL, 'PTS_glc_srb_IIC', 273885),
(454792, 'PIRSF000410', NULL, NULL, 290, NULL, 'CheR', 273886),
(454793, 'PIRSF038092', NULL, NULL, 114, NULL, 'NPSF_NPFF_NPAF', 273887);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(454794, 'PIRSF002859', NULL, NULL, 245, NULL, 'Lipo_traT', 273888),
(454795, 'PIRSF001134', NULL, NULL, 385, NULL, 'Streptogrisin', 273889),
(454796, 'PIRSF028810', NULL, NULL, 465, NULL, 'Alg10', 273890),
(454797, 'PIRSF002574', NULL, NULL, 666, NULL, 'SPRL1', 273891),
(454798, 'PIRSF016094', NULL, NULL, 202, NULL, 'VirC2', 273892),
(454799, 'PIRSF007783', NULL, NULL, 185, NULL, 'YHR121w', 273893),
(454800, 'PIRSF003639', NULL, NULL, 675, NULL, 'Capsid_P80/P87', 273894),
(454801, 'PIRSF007951', NULL, NULL, 141, NULL, 'Hemolysin_aeg', 273895),
(454802, 'PIRSF037945', NULL, NULL, 200, NULL, 'PGRP-S', 273896),
(454803, 'PIRSF037748', NULL, NULL, 308, NULL, 'RNase_HIII', 273897),
(454804, 'PIRSF005449', NULL, NULL, 374, NULL, 'TRAM', 273898),
(454805, 'PIRSF018637', NULL, NULL, 232, NULL, 'TrmK', 273899),
(454806, 'PIRSF038017', NULL, NULL, 309, NULL, 'GTP-BP_GEM', 273900),
(454807, 'PIRSF005295', NULL, NULL, 255, NULL, 'UCP005295_hydrolase', 273901),
(454808, 'PIRSF036551', NULL, NULL, 291, NULL, 'Chitosanase', 273902),
(454809, 'PIRSF002023', NULL, NULL, 202, NULL, 'PA2_inhib_alpha/gamma', 273903),
(454810, 'PIRSF002162', NULL, NULL, 185, NULL, 'RPL6p_RPL6a_RPL9e_RPL9o', 273904),
(454811, 'PIRSF037949', NULL, NULL, 287, NULL, 'Transl_init_eIF-3_RNA-bind', 273905),
(454812, 'PIRSF000628', NULL, NULL, 815, NULL, 'FGFR', 273906),
(454813, 'PIRSF000422', NULL, NULL, 803, NULL, 'NAT_A', 273907),
(454814, 'PIRSF003688', NULL, NULL, 101, NULL, 'VAC_PP', 273908),
(454815, 'PIRSF005624', NULL, NULL, 230, NULL, 'Ni-bind_GTPase', 273909),
(454816, 'PIRSF020275', NULL, NULL, 246, NULL, 'RadSAM_TM0948', 273910),
(454817, 'PIRSF004117', NULL, NULL, 82, NULL, 'Phage_coat_B', 273911),
(454818, 'PIRSF005290', NULL, NULL, 818, NULL, 'NOT_su_3_5', 273912),
(454819, 'PIRSF015665', NULL, NULL, 388, NULL, 'CHOPT', 273913),
(454820, 'PIRSF001427', NULL, NULL, 226, NULL, 'NHase_beta', 273914),
(454821, 'PIRSF022909', NULL, NULL, 125, NULL, 'UCP022909', 273915),
(454822, 'PIRSF000497', NULL, NULL, 389, NULL, 'MAT', 273916),
(454823, 'PIRSF011860', NULL, NULL, 177, NULL, 'NRIF3', 273917),
(454824, 'PIRSF003085', NULL, NULL, 412, NULL, 'CmaB', 273918),
(454825, 'PIRSF009449', NULL, NULL, 504, NULL, 'DNA_primase_large', 273919),
(454826, 'PIRSF016439', NULL, NULL, 184, NULL, 'UP2', 273920),
(454827, 'PIRSF034300', NULL, NULL, 128, NULL, 'UCP034300', 273921),
(454828, 'PIRSF024051', NULL, NULL, 177, NULL, 'UCP024051', 273922),
(454829, 'PIRSF022704', NULL, NULL, 198, NULL, 'UCP022704', 273923),
(454830, 'PIRSF006392', NULL, NULL, 414, NULL, 'IPGAM_arch', 273924),
(454831, 'PIRSF037969', NULL, NULL, 186, NULL, 'U1-C', 273925),
(454832, 'PIRSF004878', NULL, NULL, 109, NULL, 'RNase_P_4', 273926),
(454833, 'PIRSF036289', NULL, NULL, 786, NULL, 'Glycosyl_hydrolase_malt_phosph', 273927),
(454834, 'PIRSF033905', NULL, NULL, 332, NULL, 'UCP033905', 273928),
(454835, 'PIRSF000149', NULL, NULL, 341, NULL, 'GAPDH', 273929),
(454836, 'PIRSF005719', NULL, NULL, 1196, NULL, 'SMC', 273930),
(454837, 'PIRSF018636', NULL, NULL, 472, NULL, 'CbiX_N-term', 273931),
(454838, 'PIRSF005572', NULL, NULL, 382, NULL, 'NifS', 273932),
(454839, 'PIRSF003229', NULL, NULL, 64, NULL, 'ROM', 273933),
(454840, 'PIRSF005690', NULL, NULL, 491, NULL, 'GerBA', 273934),
(454841, 'PIRSF036466', NULL, NULL, 55, NULL, 'UCP036466', 273935),
(454842, 'PIRSF000707', NULL, NULL, 320, NULL, 'Hygromycin-B_kin', 273936),
(454843, 'PIRSF000804', NULL, NULL, 372, NULL, 'DNA_pol_III_b', 273937),
(454844, 'PIRSF004699', NULL, NULL, 265, NULL, 'UCP_CBS_ParB', 273938),
(454845, 'PIRSF000026', NULL, NULL, 556, NULL, 'Cytochrome_cc3', 273939),
(454846, 'PIRSF018660', NULL, NULL, 184, NULL, 'Archl_flaC', 273940),
(454847, 'PIRSF500722', NULL, NULL, 427, NULL, 'TEF-3', 273941),
(454848, 'PIRSF004131', NULL, NULL, 670, NULL, 'RNA_pol_P2', 273942),
(454849, 'PIRSF019302', NULL, NULL, 105, NULL, 'UCP019302', 273943),
(454850, 'PIRSF038135', NULL, NULL, 496, NULL, 'WD_rpt_23', 273944),
(454851, 'PIRSF003944', NULL, NULL, 1436, NULL, 'M_poly_OrthobunV', 273945),
(454852, 'PIRSF029063', NULL, NULL, 457, NULL, 'IV_sec_VirJ', 273946);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(454853, 'PIRSF005063', NULL, NULL, 298, NULL, 'UCP_CBS_MJ1232', 273947),
(454854, 'PIRSF020606', NULL, NULL, 205, NULL, 'UCP020606', 273948),
(454855, 'PIRSF016571', NULL, NULL, 168, NULL, 'C/EBPzeta_CHOP_DDIT3', 273949),
(454856, 'PIRSF016766', NULL, NULL, 326, NULL, 'UCP016766_ATPgrasp', 273950),
(454857, 'PIRSF019543', NULL, NULL, 336, NULL, 'Clavaminate_syn', 273951),
(454858, 'PIRSF007487', NULL, NULL, 346, NULL, 'CoiA', 273952),
(454859, 'PIRSF029548', NULL, NULL, 160, NULL, 'UCP029548', 273953),
(454860, 'PIRSF037798', NULL, NULL, 293, NULL, 'Hsp31', 273954),
(454861, 'PIRSF038934', NULL, NULL, 134, NULL, 'HyaE_HupG', 273955),
(454862, 'PIRSF008835', NULL, NULL, 154, NULL, 'TPR_repeat_11_Fis1', 273956),
(454863, 'PIRSF037469', NULL, NULL, 586, NULL, 'Chc_related', 273957),
(454864, 'PIRSF000114', NULL, NULL, 346, NULL, 'Glycerol-3-P_dh', 273958),
(454865, 'PIRSF002849', NULL, NULL, 338, NULL, 'MoxR', 273959),
(454866, 'PIRSF016396', NULL, NULL, 192, NULL, 'Prefoldin_3', 273960),
(454867, 'PIRSF004270', NULL, NULL, 108, NULL, 'UCP004270', 273961),
(454868, 'PIRSF037281', NULL, NULL, 587, NULL, 'Wee1_like_PK', 273962),
(454869, 'PIRSF002741', NULL, NULL, 538, NULL, 'MppA', 273963),
(454870, 'PIRSF004380', NULL, NULL, 110, NULL, 'GroES_Gp31_phage', 273964),
(454871, 'PIRSF037911', NULL, NULL, 1056, NULL, 'HDAC_II_euk', 273965),
(454872, 'PIRSF002527', NULL, NULL, 523, NULL, 'ER-like_NR', 273966),
(454873, 'PIRSF016548', NULL, NULL, 160, NULL, 'Rsd_AlgQ', 273967),
(454874, 'PIRSF030210', NULL, NULL, 365, NULL, 'UCP030210', 273968),
(454875, 'PIRSF028175', NULL, NULL, 516, NULL, 'UCP028175', 273969),
(454876, 'PIRSF500154', NULL, NULL, 137, NULL, 'RPB6', 273970),
(454877, 'PIRSF009279', NULL, NULL, 324, NULL, 'CRF-BP', 273971),
(454878, 'PIRSF012939', NULL, NULL, 209, NULL, 'NAR2', 273972),
(454879, 'PIRSF029056', NULL, NULL, 593, NULL, 'UCP029056', 273973),
(454880, 'PIRSF036424', NULL, NULL, 708, NULL, 'Transl_init_eIF3b', 273974),
(454881, 'PIRSF036511', NULL, NULL, 1100, NULL, 'ATP_citrt_syn', 273975),
(454882, 'PIRSF037309', NULL, NULL, 456, NULL, 'PPA2_B55', 273976),
(454883, 'PIRSF037961', NULL, NULL, 217, NULL, 'FGF-19_FGF-21', 273977),
(454884, 'PIRSF036427', NULL, NULL, 240, NULL, 'Precrrn-2_mtase', 273978),
(454885, 'PIRSF001400', NULL, NULL, 429, NULL, 'Enolase', 273979),
(454886, 'PIRSF037733', NULL, NULL, 189, NULL, 'Txn_fact_FapR', 273980),
(454887, 'PIRSF011362', NULL, NULL, 279, NULL, 'DevR', 273981),
(454888, 'PIRSF000495', NULL, NULL, 211, NULL, 'Amidotransf_HisH', 273982),
(454889, 'PIRSF038010', NULL, NULL, 389, NULL, 'VASP', 273983),
(454890, 'PIRSF018968', NULL, NULL, 633, NULL, 'ABC_permease_BceB', 273984),
(454891, 'PIRSF026426', NULL, NULL, 152, NULL, 'UCP026426', 273985),
(454892, 'PIRSF004499', NULL, NULL, 115, NULL, 'Transl_init_SUI1_Euk', 273986),
(454893, 'PIRSF005648', NULL, NULL, 90, NULL, 'UCP005648_Ca_binding', 273987),
(454894, 'PIRSF011789', NULL, NULL, 405, NULL, 'tRNA_endo_SEN2', 273988),
(454895, 'PIRSF002892', NULL, NULL, 345, NULL, 'Flagellin_A', 273989),
(454896, 'PIRSF018267', NULL, NULL, 147, NULL, 'VSR_endonuc', 273990),
(454897, 'PIRSF039131', NULL, NULL, 366, NULL, 'Parvin', 273991),
(454898, 'PIRSF019262', NULL, NULL, 293, NULL, 'UCP019262', 273992),
(454899, 'PIRSF037274', NULL, NULL, 792, NULL, 'PIP5K_plant', 273993),
(454900, 'PIRSF002155', NULL, NULL, 234, NULL, 'RPL1p_RPL1a_RPL10e_RPL1o', 273994),
(454901, 'PIRSF029950', NULL, NULL, 227, NULL, 'UCP029950', 273995),
(454902, 'PIRSF039003', NULL, NULL, 64, NULL, 'IscX', 273996),
(454903, 'PIRSF000729', NULL, NULL, 374, NULL, 'GK', 273997),
(454904, 'PIRSF005989', NULL, NULL, 37, NULL, 'Ectatomin', 273998),
(454905, 'PIRSF027982', NULL, NULL, 485, NULL, 'EryCV', 273999),
(454906, 'PIRSF017393', NULL, NULL, 275, NULL, 'MTase_SAV2177', 274000),
(454907, 'PIRSF000238', NULL, NULL, 520, NULL, 'AhpF', 274001),
(454908, 'PIRSF036482', NULL, NULL, 420, NULL, 'PPi_PFK_TM0289', 274002),
(454909, 'PIRSF004362', NULL, NULL, 147, NULL, 'Endo_II_phage_DenA', 274003),
(454910, 'PIRSF005512', NULL, NULL, 362, NULL, 'UCP005512', 274004);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(454911, 'PIRSF034586', NULL, NULL, 888, NULL, 'SfrC', 274005),
(454912, 'PIRSF030771', NULL, NULL, 107, NULL, 'UCP030771', 274006),
(454913, 'PIRSF004950', NULL, NULL, 617, NULL, 'Mmb_sulf_HI0842', 274007),
(454914, 'PIRSF006421', NULL, NULL, 257, NULL, 'UCP006421', 274008),
(454915, 'PIRSF036666', NULL, NULL, 545, NULL, 'G6S', 274009),
(454916, 'PIRSF000375', NULL, NULL, 286, NULL, 'NifU', 274010),
(454917, 'PIRSF004567', NULL, NULL, 534, NULL, 'TnsE', 274011),
(454918, 'PIRSF500138', NULL, NULL, 395, NULL, 'GPI8', 274012),
(454919, 'PIRSF001788', NULL, NULL, 141, NULL, 'GMF-beta', 274013),
(454920, 'PIRSF037382', NULL, NULL, 231, NULL, 'CCT_LicC', 274014),
(454921, 'PIRSF029766', NULL, NULL, 444, NULL, 'UCP029766', 274015),
(454922, 'PIRSF008210', NULL, NULL, 147, NULL, 'UCP008210', 274016),
(454923, 'PIRSF034110', NULL, NULL, 159, NULL, 'UCP034110', 274017),
(454924, 'PIRSF037637', NULL, NULL, 149, NULL, 'SAP18', 274018),
(454925, 'PIRSF011443', NULL, NULL, 180, NULL, 'YgjV', 274019),
(454926, 'PIRSF026610', NULL, NULL, 183, NULL, 'UCP026610', 274020),
(454927, 'PIRSF038996', NULL, NULL, 173, NULL, 'FldA', 274021),
(454928, 'PIRSF022699', NULL, NULL, 372, NULL, 'MND2', 274022),
(454929, 'PIRSF001500', NULL, NULL, 362, NULL, 'Chor_mut_pdt_Ppr', 274023),
(454930, 'PIRSF001767', NULL, NULL, 562, NULL, 'Cdc6', 274024),
(454931, 'PIRSF006170', NULL, NULL, 215, NULL, 'YfgM', 274025),
(454932, 'PIRSF018063', NULL, NULL, 168, NULL, 'Ferrtn_UCP018063', 274026),
(454933, 'PIRSF019078', NULL, NULL, 584, NULL, 'UCP019078', 274027),
(454934, 'PIRSF011575', NULL, NULL, 290, NULL, 'YabG', 274028),
(454935, 'PIRSF038196', NULL, NULL, 314, NULL, 'IRF-1_IRF-2', 274029),
(454936, 'PIRSF004690', NULL, NULL, 207, NULL, 'DmsD', 274030),
(454937, 'PIRSF500947', NULL, NULL, 986, NULL, 'CSF-1_receptor', 274031),
(454938, 'PIRSF004539', NULL, NULL, 438, NULL, 'Anaerob_C4-dicrbxlt_transp', 274032),
(454939, 'PIRSF004810', NULL, NULL, 410, NULL, 'ChrA', 274033),
(454940, 'PIRSF003775', NULL, NULL, 240, NULL, 'E3_ub_ligase_p28', 274034),
(454941, 'PIRSF000848', NULL, NULL, 225, NULL, 'CDP_diag_ino_3_P', 274035),
(454942, 'PIRSF016325', NULL, NULL, 373, NULL, 'PTPA', 274036),
(454943, 'PIRSF500133', NULL, NULL, 477, NULL, 'UDPglc_DH_euk', 274037),
(454944, 'PIRSF005895', NULL, NULL, 358, NULL, 'UCP005895_mtase', 274038),
(454945, 'PIRSF037395', NULL, NULL, 260, NULL, 'UCP037395_ABCper', 274039),
(454946, 'PIRSF002379', NULL, NULL, 175, NULL, 'Coagulogen', 274040),
(454947, 'PIRSF032676', NULL, NULL, 301, NULL, 'PQQC_032676', 274041),
(454948, 'PIRSF037861', NULL, NULL, 340, NULL, 'Prion_URE2', 274042),
(454949, 'PIRSF006386', NULL, NULL, 211, NULL, 'HCCAis_GSTk', 274043),
(454950, 'PIRSF000005', NULL, NULL, 215, NULL, 'Cytochrome_c4', 274044),
(454951, 'PIRSF028583', NULL, NULL, 211, NULL, 'UCP028583', 274045),
(454952, 'PIRSF019115', NULL, NULL, 160, NULL, 'UCP019115', 274046),
(454953, 'PIRSF000027', NULL, NULL, 142, NULL, 'Cytochrome_c_prime', 274047),
(454954, 'PIRSF012359', NULL, NULL, 146, NULL, 'UCP012359', 274048),
(454955, 'PIRSF036939', NULL, NULL, 782, NULL, 'PanK_long', 274049),
(454956, 'PIRSF001390', NULL, NULL, 197, NULL, 'Dipicolinate_synth_subunit_B', 274050),
(454957, 'PIRSF005962', NULL, NULL, 398, NULL, 'Amidohydrol_AmhX', 274051),
(454958, 'PIRSF500813', NULL, NULL, 314, NULL, 'PP1_PTG', 274052),
(454959, 'PIRSF004776', NULL, NULL, 408, NULL, 'NadR_NMNAT/RNK', 274053),
(454960, 'PIRSF006006', NULL, NULL, 182, NULL, 'UCP006006', 274054),
(454961, 'PIRSF018957', NULL, NULL, 191, NULL, 'UCP018957', 274055),
(454962, 'PIRSF021505', NULL, NULL, 411, NULL, 'O_gly_hdrol', 274056),
(454963, 'PIRSF031684', NULL, NULL, 362, NULL, 'Txn_reg_031684', 274057),
(454964, 'PIRSF037989', NULL, NULL, 566, NULL, 'UCP037989', 274058),
(454965, 'PIRSF034452', NULL, NULL, 277, NULL, 'TIM-br_sig_trnsd', 274059),
(454966, 'PIRSF006743', NULL, NULL, 1521, NULL, 'Exonuclease_Xnr1', 274060),
(454967, 'PIRSF033143', NULL, NULL, 112, NULL, 'LytTR_solo', 274061),
(454968, 'PIRSF002903', NULL, NULL, 80, NULL, 'CmsA/CmsE', 274062);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(454969, 'PIRSF039088', NULL, NULL, 511, NULL, 'F_ATPase_subunit_alpha', 274063),
(454970, 'PIRSF034456', NULL, NULL, 106, NULL, 'UCP034456', 274064),
(454971, 'PIRSF017681', NULL, NULL, 287, NULL, '3-HAO', 274065),
(454972, 'PIRSF000980', NULL, NULL, 1112, NULL, 'RecC', 274066),
(454973, 'PIRSF023956', NULL, NULL, 215, NULL, 'TPMT', 274067),
(454974, 'PIRSF001332', NULL, NULL, 245, NULL, 'Acetolac_decarb', 274068),
(454975, 'PIRSF026343', NULL, NULL, 341, NULL, 'NlpB', 274069),
(454976, 'PIRSF004925', NULL, NULL, 391, NULL, 'HcaT', 274070),
(454977, 'PIRSF001002', NULL, NULL, 283, NULL, 'EcoRI', 274071),
(454978, 'PIRSF037345', NULL, NULL, 758, NULL, 'ALG8_EndoV', 274072),
(454979, 'PIRSF038984', NULL, NULL, 534, NULL, 'FAD_binding_protein', 274073),
(454980, 'PIRSF006692', NULL, NULL, 264, NULL, 'Txn_reg_HTH_AF0396', 274074),
(454981, 'PIRSF000443', NULL, NULL, 398, NULL, 'Homoser_Ac_trans', 274075),
(454982, 'PIRSF009414', NULL, NULL, 480, NULL, 'LuxC', 274076),
(454983, 'PIRSF002811', NULL, NULL, 594, NULL, 'DnaG', 274077),
(454984, 'PIRSF019549', NULL, NULL, 364, NULL, 'Gpr', 274078),
(454985, 'PIRSF000044', NULL, NULL, 410, NULL, 'Cis_Diol_DH_RD', 274079),
(454986, 'PIRSF015974', NULL, NULL, 413, NULL, 'CLN3_BTN1', 274080),
(454987, 'PIRSF015753', NULL, NULL, 318, NULL, 'GST', 274081),
(454988, 'PIRSF005303', NULL, NULL, 326, NULL, 'Thiam_monoph_kin', 274082),
(454989, 'PIRSF004006', NULL, NULL, 212, NULL, 'Minor_cap_RTV', 274083),
(454990, 'PIRSF004509', NULL, NULL, 86, NULL, 'UCP004509_Rem', 274084),
(454991, 'PIRSF037347', NULL, NULL, 783, NULL, 'HK_CHASE2_PAS', 274085),
(454992, 'PIRSF037854', NULL, NULL, 1106, NULL, 'DhpA', 274086),
(454993, 'PIRSF019254', NULL, NULL, 267, NULL, 'CFP29', 274087),
(454994, 'PIRSF004853', NULL, NULL, 255, NULL, 'UCP004853', 274088),
(454995, 'PIRSF037225', NULL, NULL, 62, NULL, 'UCP037225', 274089),
(454996, 'PIRSF006171', NULL, NULL, 230, NULL, 'RR_citrat_malat', 274090),
(454997, 'PIRSF036158', NULL, NULL, 199, NULL, 'UCP036158_MarR', 274091),
(454998, 'PIRSF006809', NULL, NULL, 422, NULL, 'GTP-binding_hflX', 274092),
(454999, 'PIRSF016495', NULL, NULL, 375, NULL, 'UCP016495', 274093),
(455000, 'PIRSF028431', NULL, NULL, 452, NULL, 'UCP028431', 274094),
(455001, 'PIRSF010372', NULL, NULL, 209, NULL, 'PaiB', 274095),
(455002, 'PIRSF000851', NULL, NULL, 245, NULL, 'PcS', 274096),
(455003, 'PIRSF011716', NULL, NULL, 713, NULL, 'Endoprotease_Ssy5', 274097),
(455004, 'PIRSF006181', NULL, NULL, 160, NULL, 'EbsC_YbaK', 274098),
(455005, 'PIRSF000745', NULL, NULL, 259, NULL, 'VAC_RPO30', 274099),
(455006, 'PIRSF037387', NULL, NULL, 686, NULL, 'JP', 274100),
(455007, 'PIRSF002450', NULL, NULL, 968, NULL, 'K+_transpter_TRK', 274101),
(455008, 'PIRSF037902', NULL, NULL, 1454, NULL, 'Subtilisin_rel_Ava_4226', 274102),
(455009, 'PIRSF003726', NULL, NULL, 309, NULL, 'Vaccinia_VP39', 274103),
(455010, 'PIRSF007027', NULL, NULL, 258, NULL, 'UCP007027', 274104),
(455011, 'PIRSF037320', NULL, NULL, 1267, NULL, 'Sac3', 274105),
(455012, 'PIRSF006755', NULL, NULL, 235, NULL, 'DTB_synth', 274106),
(455013, 'PIRSF005225', NULL, NULL, 380, NULL, 'LAG1_LAC1', 274107),
(455014, 'PIRSF037379', NULL, NULL, 100, NULL, 'Urm1', 274108),
(455015, 'PIRSF000241', NULL, NULL, 309, NULL, 'Urate_oxidase', 274109),
(455016, 'PIRSF000900', NULL, NULL, 610, NULL, 'Acid_Ptase_Asper', 274110),
(455017, 'PIRSF039097', NULL, NULL, 273, NULL, 'MoSto_subunit', 274111),
(455018, 'PIRSF037431', NULL, NULL, 349, NULL, 'HK_LiaS', 274112),
(455019, 'PIRSF003888', NULL, NULL, 407, NULL, 'NCAP_CRV', 274113),
(455020, 'PIRSF036365', NULL, NULL, 612, NULL, 'Nematode_astacin', 274114),
(455021, 'PIRSF007807', NULL, NULL, 350, NULL, 'CDC123', 274115),
(455022, 'PIRSF006806', NULL, NULL, 192, NULL, '5_FTHF', 274116),
(455023, 'PIRSF030780', NULL, NULL, 199, NULL, 'Md_memb_hyd', 274117),
(455024, 'PIRSF025624', NULL, NULL, 151, NULL, 'ACT_PheB', 274118),
(455025, 'PIRSF017875', NULL, NULL, 337, NULL, 'Photosystem_II_Ycf48-like', 274119),
(455026, 'PIRSF029692', NULL, NULL, 432, NULL, 'UCP029692', 274120);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(455027, 'PIRSF030840', NULL, NULL, 182, NULL, 'ShuX', 274121),
(455028, 'PIRSF500793', NULL, NULL, 509, NULL, 'Folate_transporter_1', 274122),
(455029, 'PIRSF008459', NULL, NULL, 129, NULL, 'UCP008459', 274123),
(455030, 'PIRSF022062', NULL, NULL, 174, NULL, 'UCP022062', 274124),
(455031, 'PIRSF032436', NULL, NULL, 177, NULL, 'UCP032436', 274125),
(455032, 'PIRSF018259', NULL, NULL, 283, NULL, 'CAML', 274126),
(455033, 'PIRSF004681', NULL, NULL, 140, NULL, 'UCP004681', 274127),
(455034, 'PIRSF012608', NULL, NULL, 353, NULL, 'UCP012608', 274128),
(455035, 'PIRSF036628', NULL, NULL, 272, NULL, 'IolB', 274129),
(455036, 'PIRSF500060', NULL, NULL, 520, NULL, 'UCP500060', 274130),
(455037, 'PIRSF000203', NULL, NULL, 511, NULL, 'NADP_transhydrogenase_alpha', 274131),
(455038, 'PIRSF038038', NULL, NULL, 253, NULL, 'Gemin-2', 274132),
(455039, 'PIRSF001438', NULL, NULL, 339, NULL, 'PBGD', 274133),
(455040, 'PIRSF029215', NULL, NULL, 389, NULL, 'UCP029215', 274134),
(455041, 'PIRSF027682', NULL, NULL, 369, NULL, 'UCP027682_CUB_vWA', 274135),
(455042, 'PIRSF036409', NULL, NULL, 146, NULL, 'EutP_PduV', 274136),
(455043, 'PIRSF011356', NULL, NULL, 287, NULL, 'VP30_FiloV', 274137),
(455044, 'PIRSF018567', NULL, NULL, 346, NULL, 'AcoX', 274138),
(455045, 'PIRSF004962', NULL, NULL, 156, NULL, 'UCP004962', 274139),
(455046, 'PIRSF007352', NULL, NULL, 138, NULL, 'OapB', 274140),
(455047, 'PIRSF007797', NULL, NULL, 713, NULL, 'RSM22', 274141),
(455048, 'PIRSF015614', NULL, NULL, 495, NULL, 'TRAF', 274142),
(455049, 'PIRSF038122', NULL, NULL, 450, NULL, 'COBRA', 274143),
(455050, 'PIRSF038100', NULL, NULL, 410, NULL, 'TEX28', 274144),
(455051, 'PIRSF037732', NULL, NULL, 163, NULL, 'YlbP', 274145),
(455052, 'PIRSF000103', NULL, NULL, 299, NULL, 'HIBADH', 274146),
(455053, 'PIRSF004417', NULL, NULL, 229, NULL, 'Anti_term_Q', 274147),
(455054, 'PIRSF028921', NULL, NULL, 923, NULL, 'Vps41', 274148),
(455055, 'PIRSF005814', NULL, NULL, 773, NULL, 'MutS_YshD', 274149),
(455056, 'PIRSF000169', NULL, NULL, 115, NULL, 'SDH_D', 274150),
(455057, 'PIRSF038051', NULL, NULL, 839, NULL, 'Lys-Histone-de-mtase', 274151),
(455058, 'PIRSF000741', NULL, NULL, 758, NULL, 'FasBCD', 274152),
(455059, 'PIRSF001491', NULL, NULL, 404, NULL, 'Ppentomutase', 274153),
(455060, 'PIRSF033563', NULL, NULL, 409, NULL, 'UCP033563', 274154),
(455061, 'PIRSF028704', NULL, NULL, 409, NULL, 'UCP028704', 274155),
(455062, 'PIRSF003259', NULL, NULL, 101, NULL, 'TraL', 274156),
(455063, 'PIRSF037242', NULL, NULL, 482, NULL, 'CNDP_dipeptidase', 274157),
(455064, 'PIRSF001251', NULL, NULL, 808, NULL, 'AMP_deaminase', 274158),
(455065, 'PIRSF005409', NULL, NULL, 113, NULL, 'VAMP-5_synaptobrevin', 274159),
(455066, 'PIRSF016202', NULL, NULL, 333, NULL, 'PH1107', 274160),
(455067, 'PIRSF006595', NULL, NULL, 148, NULL, 'UCP006595', 274161),
(455068, 'PIRSF029827', NULL, NULL, 90, NULL, 'Fe_traffic_YggX', 274162),
(455069, 'PIRSF036805', NULL, NULL, 481, NULL, '26S_protsm_s5a', 274163),
(455070, 'PIRSF036392', NULL, NULL, 606, NULL, 'RR_ARR_type-B', 274164),
(455071, 'PIRSF037091', NULL, NULL, 953, NULL, 'AP2_alpha', 274165),
(455072, 'PIRSF500063', NULL, NULL, 680, NULL, 'DHAPAT', 274166),
(455073, 'PIRSF011515', NULL, NULL, 392, NULL, 'EspG/VirA', 274167),
(455074, 'PIRSF034445', NULL, NULL, 167, NULL, 'CpxP_Spy', 274168),
(455075, 'PIRSF002111', NULL, NULL, 533, NULL, 'RpsA', 274169),
(455076, 'PIRSF037226', NULL, NULL, 399, NULL, 'Amidohydrolase_ACY1L2', 274170),
(455077, 'PIRSF015883', NULL, NULL, 462, NULL, 'ADP-Pfk_glckin', 274171),
(455078, 'PIRSF015582', NULL, NULL, 320, NULL, 'Cit_lyase_B', 274172),
(455079, 'PIRSF037793', NULL, NULL, 81, NULL, 'EsaB', 274173),
(455080, 'PIRSF038601', NULL, NULL, 414, NULL, 'UCP038601', 274174),
(455081, 'PIRSF001028', NULL, NULL, 426, NULL, 'Alpha-amylase_plant', 274175),
(455082, 'PIRSF011911', NULL, NULL, 505, NULL, 'Minor_capsid_gp61', 274176),
(455083, 'PIRSF000498', NULL, NULL, 213, NULL, 'Riboflavin_syn_A', 274177),
(455084, 'PIRSF027893', NULL, NULL, 334, NULL, 'UCP027893', 274178),
(455085, 'PIRSF033541', NULL, NULL, 266, NULL, 'ORF25P_Sir2', 274179);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(455086, 'PIRSF006685', NULL, NULL, 195, NULL, 'UCP_006685', 274180),
(455087, 'PIRSF003913', NULL, NULL, 191, NULL, 'M2_paramyxovir', 274181),
(455088, 'PIRSF006865', NULL, NULL, 163, NULL, 'Ecotin', 274182),
(455089, 'PIRSF028099', NULL, NULL, 482, NULL, 'Thiol_oxidored', 274183),
(455090, 'PIRSF018507', NULL, NULL, 554, NULL, 'Prpndl_dhdrts_lg', 274184),
(455091, 'PIRSF016934', NULL, NULL, 122, NULL, 'UCP016934', 274185),
(455092, 'PIRSF015840', NULL, NULL, 358, NULL, 'Lem3/Cdc50', 274186),
(455093, 'PIRSF002131', NULL, NULL, 133, NULL, 'RPS11p_RPS11a_RPS14e_RPS11o', 274187),
(455094, 'PIRSF017207', NULL, NULL, 189, NULL, 'UCP017207_Tmem85', 274188),
(455095, 'PIRSF011649', NULL, NULL, 339, NULL, 'MtTFB', 274189),
(455096, 'PIRSF036912', NULL, NULL, 64, NULL, 'Sac7', 274190),
(455097, 'PIRSF016725', NULL, NULL, 130, NULL, 'UCP016725', 274191),
(455098, 'PIRSF015947', NULL, NULL, 977, NULL, '26S_protsm_Rpn2', 274192),
(455099, 'PIRSF014995', NULL, NULL, 171, NULL, 'UCP014995', 274193),
(455100, 'PIRSF006402', NULL, NULL, 716, NULL, 'UCP006402_thioredoxin', 274194),
(455101, 'PIRSF036484', NULL, NULL, 403, NULL, 'PPi-PFK_SMc01852', 274195),
(455102, 'PIRSF016599', NULL, NULL, 486, NULL, 'Xaa-His_dipept', 274196),
(455103, 'PIRSF039033', NULL, NULL, 224, NULL, 'START_dom', 274197),
(455104, 'PIRSF036226', NULL, NULL, 209, NULL, 'UCP036226', 274198),
(455105, 'PIRSF005901', NULL, NULL, 187, NULL, 'EF-P', 274199),
(455106, 'PIRSF006158', NULL, NULL, 210, NULL, 'UCP006158_SH3', 274200),
(455107, 'PIRSF000714', NULL, NULL, 143, NULL, 'HIT', 274201),
(455108, 'PIRSF009452', NULL, NULL, 240, NULL, 'MtrA_MtxA', 274202),
(455109, 'PIRSF037956', NULL, NULL, 323, NULL, 'ZRANB2', 274203),
(455110, 'PIRSF017962', NULL, NULL, 256, NULL, 'UCP017962', 274204),
(455111, 'PIRSF001658', NULL, NULL, 109, NULL, 'Amylase_inhib', 274205),
(455112, 'PIRSF005879', NULL, NULL, 317, NULL, 'C/EBP', 274206),
(455113, 'PIRSF001196', NULL, NULL, 709, NULL, 'Meprin', 274207),
(455114, 'PIRSF001828', NULL, NULL, 44, NULL, 'Thymosin_beta', 274208),
(455115, 'PIRSF031601', NULL, NULL, 683, NULL, 'UCP031601', 274209),
(455116, 'PIRSF000868', NULL, NULL, 246, NULL, '14-3-3', 274210),
(455117, 'PIRSF017215', NULL, NULL, 250, NULL, 'ESCRT2_Vps22', 274211),
(455118, 'PIRSF036361', NULL, NULL, 458, NULL, 'YunD', 274212),
(455119, 'PIRSF021964', NULL, NULL, 157, NULL, 'UCP921964', 274213),
(455120, 'PIRSF000112', NULL, NULL, 367, NULL, 'Glycerol_dh', 274214),
(455121, 'PIRSF032756', NULL, NULL, 144, NULL, 'UCP032756', 274215),
(455122, 'PIRSF006598', NULL, NULL, 371, NULL, 'UCP006598', 274216),
(455123, 'PIRSF500166', NULL, NULL, 343, NULL, 'HMDII_III', 274217),
(455124, 'PIRSF010361', NULL, NULL, 447, NULL, 'UCP010361', 274218),
(455125, 'PIRSF007059', NULL, NULL, 137, NULL, 'ComD', 274219),
(455126, 'PIRSF028160', NULL, NULL, 235, NULL, 'UCP028160', 274220),
(455127, 'PIRSF029091', NULL, NULL, 118, NULL, 'RstB1_B2', 274221),
(455128, 'PIRSF021265', NULL, NULL, 123, NULL, 'ManO', 274222),
(455129, 'PIRSF027744', NULL, NULL, 579, NULL, 'Snx9', 274223),
(455130, 'PIRSF005637', NULL, NULL, 110, NULL, 'UCP005637', 274224),
(455131, 'PIRSF028762', NULL, NULL, 412, NULL, 'ABD1', 274225),
(455132, 'PIRSF032968', NULL, NULL, 359, NULL, 'UCP032968', 274226),
(455133, 'PIRSF001235', NULL, NULL, 420, NULL, 'Amidase_hyd_carb', 274227),
(455134, 'PIRSF034405', NULL, NULL, 249, NULL, 'UCP034405', 274228),
(455135, 'PIRSF037657', NULL, NULL, 57, NULL, 'Lipopeptide_LppL', 274229),
(455136, 'PIRSF005644', NULL, NULL, 338, NULL, 'Hdrgns_mtr_HypE', 274230),
(455137, 'PIRSF000609', NULL, NULL, 534, NULL, 'STPK_YKL116c', 274231),
(455138, 'PIRSF016937', NULL, NULL, 486, NULL, 'UCP016937', 274232),
(455139, 'PIRSF004161', NULL, NULL, 25, NULL, 'DNA-bp_J_Microviridae', 274233),
(455140, 'PIRSF028408', NULL, NULL, 382, NULL, 'UCP028408', 274234),
(455141, 'PIRSF009375', NULL, NULL, 858, NULL, 'Retromer_Vps35', 274235),
(455142, 'PIRSF016398', NULL, NULL, 296, NULL, 'TFIIE-beta', 274236),
(455143, 'PIRSF026986', NULL, NULL, 455, NULL, 'MET_SET', 274237);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(455144, 'PIRSF002816', NULL, NULL, 336, NULL, 'AraF', 274238),
(455145, 'PIRSF037289', NULL, NULL, 1472, NULL, 'SARA/endofin', 274239),
(455146, 'PIRSF006846', NULL, NULL, 166, NULL, 'UL5', 274240),
(455147, 'PIRSF010130', NULL, NULL, 215, NULL, 'PduL', 274241),
(455148, 'PIRSF000116', NULL, NULL, 490, NULL, 'IlvC_gammaproteo', 274242),
(455149, 'PIRSF030802', NULL, NULL, 257, NULL, 'UCP030802', 274243),
(455150, 'PIRSF037730', NULL, NULL, 291, NULL, 'CWA_LytH', 274244),
(455151, 'PIRSF009867', NULL, NULL, 132, NULL, 'Rrn10', 274245),
(455152, 'PIRSF036920', NULL, NULL, 412, NULL, 'X4Y4', 274246),
(455153, 'PIRSF000119', NULL, NULL, 401, NULL, 'Ilv5_fungal', 274247),
(455154, 'PIRSF024851', NULL, NULL, 193, NULL, 'SCD1', 274248),
(455155, 'PIRSF036429', NULL, NULL, 772, NULL, 'P5C_synthetase', 274249),
(455156, 'PIRSF000331', NULL, NULL, 493, NULL, 'HpaA_HpaB', 274250),
(455157, 'PIRSF000927', NULL, NULL, 927, NULL, 'PTPN3_PTPN4', 274251),
(455158, 'PIRSF006281', NULL, NULL, 535, NULL, 'MdoG', 274252),
(455159, 'PIRSF016158', NULL, NULL, 333, NULL, 'HMD', 274253),
(455160, 'PIRSF038186', NULL, NULL, 323, NULL, 'ITPK', 274254),
(455161, 'PIRSF001467', NULL, NULL, 178, NULL, 'Peptidylpro_ismrse', 274255),
(455162, 'PIRSF002297', NULL, NULL, 2332, NULL, 'Spectrin_beta', 274256),
(455163, 'PIRSF029477', NULL, NULL, 151, NULL, 'UCP029477', 274257),
(455164, 'PIRSF001640', NULL, NULL, 72, NULL, 'Hirudin', 274258),
(455165, 'PIRSF033132', NULL, NULL, 494, NULL, 'UCP033132', 274259),
(455166, 'PIRSF016907', NULL, NULL, 368, NULL, 'Kin_ATP-NAD', 274260),
(455167, 'PIRSF000431', NULL, NULL, 456, NULL, 'G3POAT', 274261),
(455168, 'PIRSF032522', NULL, NULL, 462, NULL, 'TcaA', 274262),
(455169, 'PIRSF002369', NULL, NULL, 106, NULL, 'Apovitellenin_I', 274263),
(455170, 'PIRSF036568', NULL, NULL, 862, NULL, 'CYTH_CHAD_HD', 274264),
(455171, 'PIRSF004793', NULL, NULL, 260, NULL, 'UCP004793', 274265),
(455172, 'PIRSF026544', NULL, NULL, 124, NULL, 'DksA_homolog', 274266),
(455173, 'PIRSF000743', NULL, NULL, 170, NULL, 'RPO19', 274267),
(455174, 'PIRSF034303', NULL, NULL, 149, NULL, 'UCP034303', 274268),
(455175, 'PIRSF034455', NULL, NULL, 164, NULL, 'UCP034455', 274269),
(455176, 'PIRSF003165', NULL, NULL, 163, NULL, 'Chaper_prot_SicA', 274270),
(455177, 'PIRSF028141', NULL, NULL, 121, NULL, 'C-di-GMP_BP_PA4608', 274271),
(455178, 'PIRSF006728', NULL, NULL, 419, NULL, 'CinA', 274272),
(455179, 'PIRSF018786', NULL, NULL, 163, NULL, 'UCP018786', 274273),
(455180, 'PIRSF004869', NULL, NULL, 315, NULL, 'PflX', 274274),
(455181, 'PIRSF017318', NULL, NULL, 261, NULL, 'Chor_mut_AroQ_eu', 274275),
(455182, 'PIRSF038096', NULL, NULL, 172, NULL, 'CD27BP', 274276),
(455183, 'PIRSF036961', NULL, NULL, 452, NULL, 'Kremen', 274277),
(455184, 'PIRSF003867', NULL, NULL, 149, NULL, 'Rev_lenti-OC', 274278),
(455185, 'PIRSF014422', NULL, NULL, 153, NULL, 'UCP014422', 274279),
(455186, 'PIRSF016383', NULL, NULL, 316, NULL, 'UCP016383', 274280),
(455187, 'PIRSF001373', NULL, NULL, 527, NULL, 'TrpE', 274281),
(455188, 'PIRSF028458', NULL, NULL, 351, NULL, 'UCP028458', 274282),
(455189, 'PIRSF011791', NULL, NULL, 565, NULL, 'Retromer_Vps17', 274283),
(455190, 'PIRSF037270', NULL, NULL, 587, NULL, 'MIS', 274284),
(455191, 'PIRSF009407', NULL, NULL, 743, NULL, 'IDH_monmr', 274285),
(455192, 'PIRSF026671', NULL, NULL, 226, NULL, 'AA_dipeptidase', 274286),
(455193, 'PIRSF027833', NULL, NULL, 425, NULL, 'MtTFB2', 274287),
(455194, 'PIRSF034285', NULL, NULL, 271, NULL, 'UCP034285', 274288),
(455195, 'PIRSF003954', NULL, NULL, 95, NULL, 'NS-S_OrthobunV', 274289),
(455196, 'PIRSF032900', NULL, NULL, 455, NULL, 'MALP', 274290),
(455197, 'PIRSF037318', NULL, NULL, 265, NULL, 'RfaP', 274291),
(455198, 'PIRSF000647', NULL, NULL, 530, NULL, 'STPK_SpkB', 274292),
(455199, 'PIRSF017706', NULL, NULL, 845, NULL, 'TFIP11', 274293),
(455200, 'PIRSF001191', NULL, NULL, 533, NULL, 'MMP_stromelysin', 274294),
(455201, 'PIRSF036670', NULL, NULL, 274, NULL, 'ATPase_UCP036670', 274295),
(455202, 'PIRSF019554', NULL, NULL, 123, NULL, 'LT-IIA', 274296);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(455203, 'PIRSF000388', NULL, NULL, 275, NULL, 'PanB', 274297),
(455204, 'PIRSF005965', NULL, NULL, 125, NULL, 'Chor_mut_AroH', 274298),
(455205, 'PIRSF010636', NULL, NULL, 103, NULL, 'ANTAR_solo', 274299),
(455206, 'PIRSF027807', NULL, NULL, 254, NULL, 'Cerberus', 274300),
(455207, 'PIRSF000456', NULL, NULL, 266, NULL, 'UDP-GlcNAc_acltr', 274301),
(455208, 'PIRSF037006', NULL, NULL, 355, NULL, 'Wax_synthase', 274302),
(455209, 'PIRSF028069', NULL, NULL, 255, NULL, 'UCP028069', 274303),
(455210, 'PIRSF006373', NULL, NULL, 176, NULL, 'TFE_archaea', 274304),
(455211, 'PIRSF004177', NULL, NULL, 97, NULL, 'gp1_phi29', 274305),
(455212, 'PIRSF017607', NULL, NULL, 617, NULL, 'Numb_numb_like', 274306),
(455213, 'PIRSF036989', NULL, NULL, 671, NULL, 'Zeaxanthin_epoxidase', 274307),
(455214, 'PIRSF000445', NULL, NULL, 433, NULL, 'GluTR', 274308),
(455215, 'PIRSF002799', NULL, NULL, 778, NULL, 'PBP1b', 274309),
(455216, 'PIRSF001771', NULL, NULL, 461, NULL, 'Cyclin_A_B_D_E', 274310),
(455217, 'PIRSF019847', NULL, NULL, 217, NULL, 'Tri6', 274311),
(455218, 'PIRSF000177', NULL, NULL, 259, NULL, 'Fumar_rd_cyt_b', 274312),
(455219, 'PIRSF026673', NULL, NULL, 483, NULL, 'UCP026673_ion_chan', 274313),
(455220, 'PIRSF035427', NULL, NULL, 371, NULL, 'All2852', 274314),
(455221, 'PIRSF036561', NULL, NULL, 224, NULL, 'ThTPase', 274315),
(455222, 'PIRSF037785', NULL, NULL, 181, NULL, 'RecU', 274316),
(455223, 'PIRSF016238', NULL, NULL, 241, NULL, 'Gdnf', 274317),
(455224, 'PIRSF001382', NULL, NULL, 783, NULL, 'TrpG-trpC-trpF', 274318),
(455225, 'PIRSF000905', NULL, NULL, 353, NULL, 'G6Pase', 274319),
(455226, 'PIRSF000414', NULL, NULL, 526, NULL, 'PurH', 274320),
(455227, 'PIRSF029008', NULL, NULL, 229, NULL, 'MecA', 274321),
(455228, 'PIRSF000208', NULL, NULL, 695, NULL, 'P450R', 274322),
(455229, 'PIRSF011521', NULL, NULL, 544, NULL, 'VieB', 274323),
(455230, 'PIRSF005261', NULL, NULL, 299, NULL, 'HSP33', 274324),
(455231, 'PIRSF000239', NULL, NULL, 209, NULL, 'AHPC', 274325),
(455232, 'PIRSF004602', NULL, NULL, 364, NULL, 'ATPgrasp_PurP', 274326),
(455233, 'PIRSF031066', NULL, NULL, 409, NULL, 'SPF45', 274327),
(455234, 'PIRSF007778', NULL, NULL, 453, NULL, 'UCP007778', 274328),
(455235, 'PIRSF015750', NULL, NULL, 156, NULL, 'Riboflv_synth_arch', 274329),
(455236, 'PIRSF006324', NULL, NULL, 213, NULL, 'LeuE', 274330),
(455237, 'PIRSF013022', NULL, NULL, 589, NULL, 'UCP013022', 274331),
(455238, 'PIRSF016429', NULL, NULL, 349, NULL, 'UPTG', 274332),
(455239, 'PIRSF016184', NULL, NULL, 292, NULL, 'Ismrse_PhzF', 274333),
(455240, 'PIRSF015679', NULL, NULL, 598, NULL, 'VAC_mptidase_G1L', 274334),
(455241, 'PIRSF022996', NULL, NULL, 187, NULL, 'SAG2', 274335),
(455242, 'PIRSF013329', NULL, NULL, 211, NULL, 'UCP013329', 274336),
(455243, 'PIRSF036478', NULL, NULL, 423, NULL, 'Uropor_mtas_plnt', 274337),
(455244, 'PIRSF038127', NULL, NULL, 269, NULL, 'UCP038127_LOB', 274338),
(455245, 'PIRSF039012', NULL, NULL, 337, NULL, 'ASP', 274339),
(455246, 'PIRSF036428', NULL, NULL, 412, NULL, 'CobL_MTase', 274340),
(455247, 'PIRSF012443', NULL, NULL, 275, NULL, 'UCP012443', 274341),
(455248, 'PIRSF002486', NULL, NULL, 359, NULL, 'CIP_VAC_C3L', 274342),
(455249, 'PIRSF029720', NULL, NULL, 132, NULL, 'UCP029720', 274343),
(455250, 'PIRSF027133', NULL, NULL, 520, NULL, 'Rrn11', 274344),
(455251, 'PIRSF000385', NULL, NULL, 295, NULL, 'Gly_N-mtase', 274345),
(455252, 'PIRSF005784', NULL, NULL, 189, NULL, 'RnfB', 274346),
(455253, 'PIRSF002498', NULL, NULL, 292, NULL, 'TF_factor_3', 274347),
(455254, 'PIRSF000029', NULL, NULL, 128, NULL, 'Cytochrome_b562', 274348),
(455255, 'PIRSF036575', NULL, NULL, 292, NULL, 'CM_nematode', 274349),
(455256, 'PIRSF001486', NULL, NULL, 94, NULL, 'CatC', 274350),
(455257, 'PIRSF028137', NULL, NULL, 232, NULL, 'UCP028137', 274351),
(455258, 'PIRSF028744', NULL, NULL, 107, NULL, 'UCP028744_Gp-49', 274352),
(455259, 'PIRSF031804', NULL, NULL, 127, NULL, 'UCP031804', 274353),
(455260, 'PIRSF038165', NULL, NULL, 917, NULL, 'MAPKKK12_MAPKKK13', 274354),
(455261, 'PIRSF017804', NULL, NULL, 484, NULL, 'Secretion_EccD1', 274355); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(455262, 'PIRSF000744', NULL, NULL, 185, NULL, 'RPO22', 274356),
(455263, 'PIRSF037232', NULL, NULL, 1472, NULL, 'Tricalbin', 274357),
(455264, 'PIRSF001174', NULL, NULL, 777, NULL, 'Lon_proteas', 274358),
(455265, 'PIRSF016616', NULL, NULL, 292, NULL, 'HNMT', 274359),
(455266, 'PIRSF021603', NULL, NULL, 285, NULL, 'UCP21603_Ac_t', 274360),
(455267, 'PIRSF500206', NULL, NULL, 319, NULL, 'MtrH', 274361),
(455268, 'PIRSF003841', NULL, NULL, 517, NULL, 'Gypsy_env', 274362),
(455269, 'PIRSF027124', NULL, NULL, 433, NULL, 'HAT_Rtt109', 274363),
(455270, 'PIRSF015647', NULL, NULL, 375, NULL, 'FBPtase_archl', 274364),
(455271, 'PIRSF036432', NULL, NULL, 262, NULL, 'Diphthine_synth', 274365),
(455272, 'PIRSF020785', NULL, NULL, 178, NULL, 'ComB', 274366),
(455273, 'PIRSF036586', NULL, NULL, 474, NULL, 'CDP-ribitol_syn', 274367),
(455274, 'PIRSF016570', NULL, NULL, 709, NULL, 'Ku80', 274368),
(455275, 'PIRSF021424', NULL, NULL, 122, NULL, 'RTP', 274369),
(455276, 'PIRSF005646', NULL, NULL, 433, NULL, 'FwdB', 274370),
(455277, 'PIRSF036762', NULL, NULL, 639, NULL, 'GAA1', 274371),
(455278, 'PIRSF037432', NULL, NULL, 344, NULL, 'HK_NreB', 274372),
(455279, 'PIRSF037475', NULL, NULL, 883, NULL, 'BLOC2_Hps5', 274373),
(455280, 'PIRSF000459', NULL, NULL, 688, NULL, 'TGM_EBP42', 274374),
(455281, 'PIRSF036437', NULL, NULL, 984, NULL, 'HK_TorS', 274375),
(455282, 'PIRSF037512', NULL, NULL, 1248, NULL, 'PxSR', 274376),
(455283, 'PIRSF016516', NULL, NULL, 349, NULL, 'Allantoicase', 274377),
(455284, 'PIRSF037506', NULL, NULL, 626, NULL, 'NTP_gondii', 274378),
(455285, 'PIRSF000447', NULL, NULL, 416, NULL, 'KAS_II', 274379),
(455286, 'PIRSF018293', NULL, NULL, 186, NULL, 'TRAPP_1_Bet3', 274380),
(455287, 'PIRSF004631', NULL, NULL, 511, NULL, 'Retroelement_env', 274381),
(455288, 'PIRSF037664', NULL, NULL, 111, NULL, 'MmoD', 274382),
(455289, 'PIRSF020479', NULL, NULL, 333, NULL, 'UCP020479_CheW', 274383),
(455290, 'PIRSF037504', NULL, NULL, 231, NULL, 'GRA6', 274384),
(455291, 'PIRSF004911', NULL, NULL, 404, NULL, 'L-lysine_2_3-aminomutase', 274385),
(455292, 'PIRSF000361', NULL, NULL, 371, NULL, 'Frd-NADP+_RD', 274386),
(455293, 'PIRSF000033', NULL, NULL, 160, NULL, 'Cytochrome_b6f_IV', 274387),
(455294, 'PIRSF036407', NULL, NULL, 347, NULL, 'SelenoP_synth', 274388),
(455295, 'PIRSF038133', NULL, NULL, 314, NULL, 'EAF3_MRG15', 274389),
(455296, 'PIRSF029271', NULL, NULL, 300, NULL, 'Pdx1', 274390),
(455297, 'PIRSF019265', NULL, NULL, 258, NULL, 'UCP019265', 274391),
(455298, 'PIRSF000087', NULL, NULL, 125, NULL, 'PYP', 274392),
(455299, 'PIRSF000632', NULL, NULL, 824, NULL, 'TyrPK_fps', 274393),
(455300, 'PIRSF037201', NULL, NULL, 927, NULL, 'Ub_ligase_E6AP', 274394),
(455301, 'PIRSF003764', NULL, NULL, 149, NULL, 'VAC_K7R', 274395),
(455302, 'PIRSF028288', NULL, NULL, 206, NULL, 'UCP028288', 274396),
(455303, 'PIRSF001492', NULL, NULL, 517, NULL, 'IPGAM', 274397),
(455304, 'PIRSF007764', NULL, NULL, 227, NULL, 'GINS_Sld5', 274398),
(455305, 'PIRSF036363', NULL, NULL, 912, NULL, 'STPPP_BSU1', 274399),
(455306, 'PIRSF034565', NULL, NULL, 361, NULL, 'UCP034565', 274400),
(455307, 'PIRSF037847', NULL, NULL, 171, NULL, 'NiaR', 274401),
(455308, 'PIRSF027153', NULL, NULL, 198, NULL, 'NNF1', 274402),
(455309, 'PIRSF036490', NULL, NULL, 797, NULL, 'Aldedh_dupl', 274403),
(455310, 'PIRSF033736', NULL, NULL, 142, NULL, 'UCP033763', 274404),
(455311, 'PIRSF038925', NULL, NULL, 370, NULL, 'AMP-prot_trans', 274405),
(455312, 'PIRSF028226', NULL, NULL, 115, NULL, 'PhaP', 274406),
(455313, 'PIRSF001553', NULL, NULL, 296, NULL, 'SucCS_alpha', 274407),
(455314, 'PIRSF029171', NULL, NULL, 412, NULL, 'Esterase_LipA', 274408),
(455315, 'PIRSF015694', NULL, NULL, 158, NULL, 'VAC_F15L', 274409),
(455316, 'PIRSF032582', NULL, NULL, 96, NULL, 'Cas2', 274410),
(455317, 'PIRSF016624', NULL, NULL, 365, NULL, 'Mu_prophg_I', 274411),
(455318, 'PIRSF039144', NULL, NULL, 112, NULL, 'GlnB', 274412),
(455319, 'PIRSF005763', NULL, NULL, 264, NULL, 'Txn_reg_ModE', 274413),
(455320, 'PIRSF000822', NULL, NULL, 1444, NULL, 'RdRPol_RDV', 274414);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(455321, 'PIRSF000037', NULL, NULL, 44, NULL, 'Cytochrome_PsbF', 274415),
(455322, 'PIRSF002374', NULL, NULL, 182, NULL, 'Kappa-casein', 274416),
(455323, 'PIRSF038154', NULL, NULL, 369, NULL, 'GTE6', 274417),
(455324, 'PIRSF018427', NULL, NULL, 217, NULL, 'Isopentenyldiphpt_isom', 274418),
(455325, 'PIRSF000450', NULL, NULL, 309, NULL, 'HTS', 274419),
(455326, 'PIRSF029598', NULL, NULL, 140, NULL, 'PsiE', 274420),
(455327, 'PIRSF037492', NULL, NULL, 462, NULL, 'UCP037492_HAD', 274421),
(455328, 'PIRSF014669', NULL, NULL, 370, NULL, 'UCP014669', 274422),
(455329, 'PIRSF038931', NULL, NULL, 180, NULL, 'GerQ', 274423),
(455330, 'PIRSF038885', NULL, NULL, 403, NULL, 'COB', 274424),
(455331, 'PIRSF036461', NULL, NULL, 397, NULL, 'Chmtx_methlestr', 274425),
(455332, 'PIRSF009264', NULL, NULL, 430, NULL, 'TagBP_ald_acces_AgaZ', 274426),
(455333, 'PIRSF010076', NULL, NULL, 283, NULL, 'PAC1', 274427),
(455334, 'PIRSF032341', NULL, NULL, 557, NULL, 'UCP032341_glycerophostrnsf', 274428),
(455335, 'PIRSF016502', NULL, NULL, 343, NULL, 'Urea_transporter', 274429),
(455336, 'PIRSF001263', NULL, NULL, 154, NULL, 'Cyanate_hydratas', 274430),
(455337, 'PIRSF008955', NULL, NULL, 250, NULL, 'AGOG', 274431),
(455338, 'PIRSF000098', NULL, NULL, 433, NULL, 'Homoser_dh', 274432),
(455339, 'PIRSF000193', NULL, NULL, 269, NULL, 'P5CR', 274433),
(455340, 'PIRSF500742', NULL, NULL, 965, NULL, 'MAPKKK13', 274434),
(455341, 'PIRSF001814', NULL, NULL, 112, NULL, 'Somatostatin', 274435),
(455342, 'PIRSF018100', NULL, NULL, 110, NULL, 'CsgC', 274436),
(455343, 'PIRSF036410', NULL, NULL, 470, NULL, 'EutE_PduP', 274437),
(455344, 'PIRSF000505', NULL, NULL, 440, NULL, 'EPSPS', 274438),
(455345, 'PIRSF003961', NULL, NULL, 1194, NULL, 'M_poly_PhleboV', 274439),
(455346, 'PIRSF028035', NULL, NULL, 984, NULL, 'UCP028035', 274440),
(455347, 'PIRSF037710', NULL, NULL, 115, NULL, 'COX7A2L', 274441),
(455348, 'PIRSF000423', NULL, NULL, 446, NULL, 'ArgA', 274442),
(455349, 'PIRSF016308', NULL, NULL, 806, NULL, 'UBP', 274443),
(455350, 'PIRSF000538', NULL, NULL, 499, NULL, 'GlpK', 274444),
(455351, 'PIRSF011844', NULL, NULL, 466, NULL, 'Sufu', 274445),
(455352, 'PIRSF005536', NULL, NULL, 734, NULL, 'Agal', 274446),
(455353, 'PIRSF001439', NULL, NULL, 338, NULL, 'CryM', 274447),
(455354, 'PIRSF003153', NULL, NULL, 484, NULL, 'ATF2_CRE-BP1', 274448),
(455355, 'PIRSF005419', NULL, NULL, 693, NULL, 'FlhA', 274449),
(455356, 'PIRSF014979', NULL, NULL, 176, NULL, 'UCP014979', 274450),
(455357, 'PIRSF000013', NULL, NULL, 204, NULL, '4_hem_cytochrm_NapC', 274451),
(455358, 'PIRSF001458', NULL, NULL, 211, NULL, 'MerB', 274452),
(455359, 'PIRSF000566', NULL, NULL, 381, NULL, 'STPK_Sbk1', 274453),
(455360, 'PIRSF002017', NULL, NULL, 374, NULL, 'CD14', 274454),
(455361, 'PIRSF002291', NULL, NULL, 744, NULL, 'Beta_adaptin', 274455),
(455362, 'PIRSF006276', NULL, NULL, 142, NULL, 'UspA', 274456),
(455363, 'PIRSF001205', NULL, NULL, 484, NULL, 'Serralysin', 274457),
(455364, 'PIRSF036922', NULL, NULL, 378, NULL, 'RNaseH_PGAM', 274458),
(455365, 'PIRSF015695', NULL, NULL, 452, NULL, 'STPK_F10L', 274459),
(455366, 'PIRSF029505', NULL, NULL, 176, NULL, 'UCP029505', 274460),
(455367, 'PIRSF500125', NULL, NULL, 519, NULL, '4_HPA_large', 274461),
(455368, 'PIRSF011131', NULL, NULL, 1610, NULL, 'SAC', 274462),
(455369, 'PIRSF001569', NULL, NULL, 842, NULL, 'E3_ub_ligase_SMURF1', 274463),
(455370, 'PIRSF020419', NULL, NULL, 297, NULL, 'Fe_uptake_reg_CjrA', 274464),
(455371, 'PIRSF000068', NULL, NULL, 144, NULL, 'Zn_Fdx_Sulfol', 274465),
(455372, 'PIRSF500231', NULL, NULL, 544, NULL, 'Oat_dag', 274466),
(455373, 'PIRSF036558', NULL, NULL, 1286, NULL, 'Ntrrd_NNDBI_PRT', 274467),
(455374, 'PIRSF017085', NULL, NULL, 404, NULL, 'Glycosyltransf_RedA', 274468),
(455375, 'PIRSF029938', NULL, NULL, 112, NULL, 'UCP029938', 274469),
(455376, 'PIRSF005894', NULL, NULL, 111, NULL, 'Monothiol_GRX', 274470),
(455377, 'PIRSF022995', NULL, NULL, 568, NULL, 'ROP2', 274471),
(455378, 'PIRSF001363', NULL, NULL, 537, NULL, 'Malate_synth', 274472),
(455379, 'PIRSF000563', NULL, NULL, 321, NULL, 'Homeobox_Pitx/Unc30', 274473);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(455380, 'PIRSF038119', NULL, NULL, 326, NULL, 'NUP53', 274474),
(455381, 'PIRSF029611', NULL, NULL, 117, NULL, 'UCP029611', 274475),
(455382, 'PIRSF028841', NULL, NULL, 192, NULL, 'APC10', 274476),
(455383, 'PIRSF017184', NULL, NULL, 507, NULL, 'Nnr', 274477),
(455384, 'PIRSF037825', NULL, NULL, 155, NULL, 'GMP-Pdiesterase_delta', 274478),
(455385, 'PIRSF005700', NULL, NULL, 455, NULL, 'PepC', 274479),
(455386, 'PIRSF002736', NULL, NULL, 97, NULL, 'Citrt_lyas_gamma', 274480),
(455387, 'PIRSF500720', NULL, NULL, 435, NULL, 'TEF-5', 274481),
(455388, 'PIRSF009292', NULL, NULL, 186, NULL, 'BLIP', 274482),
(455389, 'PIRSF037394', NULL, NULL, 198, NULL, 'ABC_permease_YkoE', 274483),
(455390, 'PIRSF029254', NULL, NULL, 635, NULL, 'MutS_C_archaeal', 274484),
(455391, 'PIRSF003496', NULL, NULL, 99, NULL, 'Myristoylat_tegument_UL11', 274485),
(455392, 'PIRSF037497', NULL, NULL, 170, NULL, 'MreD_Clostridium/Treponema', 274486),
(455393, 'PIRSF037726', NULL, NULL, 179, NULL, 'IL-22', 274487),
(455394, 'PIRSF032899', NULL, NULL, 897, NULL, 'UCP032899', 274488),
(455395, 'PIRSF036458', NULL, NULL, 356, NULL, 'Butyrate_kin', 274489),
(455396, 'PIRSF000995', NULL, NULL, 261, NULL, 'RE_EcoRV', 274490),
(455397, 'PIRSF000556', NULL, NULL, 992, NULL, 'MAPKKK9_MAPKKK10_MAPKKK11', 274491),
(455398, 'PIRSF018296', NULL, NULL, 307, NULL, 'Format_dh_formtn_FdhE', 274492),
(455399, 'PIRSF000489', NULL, NULL, 1001, NULL, 'NAD_ADPRT', 274493),
(455400, 'PIRSF004440', NULL, NULL, 363, NULL, 'GpP', 274494),
(455401, 'PIRSF037113', NULL, NULL, 380, NULL, 'Yin_yang', 274495),
(455402, 'PIRSF001338', NULL, NULL, 164, NULL, 'AIR_carboxylase', 274496),
(455403, 'PIRSF003267', NULL, NULL, 227, NULL, 'TraJ_F', 274497),
(455404, 'PIRSF037109', NULL, NULL, 270, NULL, 'Hox9', 274498),
(455405, 'PIRSF001109', NULL, NULL, 438, NULL, 'SAHH', 274499),
(455406, 'PIRSF037880', NULL, NULL, 456, NULL, 'Parkin', 274500),
(455407, 'PIRSF000724', NULL, NULL, 411, NULL, 'Pgk', 274501),
(455408, 'PIRSF017565', NULL, NULL, 401, NULL, 'Kin_ATP-NAD_euk', 274502),
(455409, 'PIRSF027081', NULL, NULL, 249, NULL, 'RPP29', 274503),
(455410, 'PIRSF038172', NULL, NULL, 839, NULL, 'MAPKKKK', 274504),
(455411, 'PIRSF001892', NULL, NULL, 486, NULL, 'CyaE', 274505),
(455412, 'PIRSF001554', NULL, NULL, 382, NULL, 'SucCS_beta', 274506),
(455413, 'PIRSF037167', NULL, NULL, 310, NULL, 'Mtase_YfcB', 274507),
(455414, 'PIRSF033725', NULL, NULL, 127, NULL, 'UCP033725', 274508),
(455415, 'PIRSF036685', NULL, NULL, 501, NULL, 'BacLeuNPeptidase', 274509),
(455416, 'PIRSF038093', NULL, NULL, 367, NULL, 'ARPC1', 274510),
(455417, 'PIRSF036946', NULL, NULL, 675, NULL, 'Arg_N-mtase', 274511),
(455418, 'PIRSF012755', NULL, NULL, 101, NULL, 'UCP012755', 274512),
(455419, 'PIRSF038146', NULL, NULL, 527, NULL, 'STPK_RIO3', 274513),
(455420, 'PIRSF002984', NULL, NULL, 266, NULL, 'Opacity_prot', 274514),
(455421, 'PIRSF037870', NULL, NULL, 402, NULL, 'Doublin', 274515),
(455422, 'PIRSF005096', NULL, NULL, 355, NULL, 'GALM', 274516),
(455423, 'PIRSF035261', NULL, NULL, 689, NULL, 'UCP035261', 274517),
(455424, 'PIRSF018774', NULL, NULL, 374, NULL, 'GOGAT_lg_dom1', 274518),
(455425, 'PIRSF037666', NULL, NULL, 59, NULL, 'GerPD', 274519),
(455426, 'PIRSF038085', NULL, NULL, 151, NULL, 'ChM-II', 274520),
(455427, 'PIRSF009445', NULL, NULL, 456, NULL, 'Cyc_PG_syn', 274521),
(455428, 'PIRSF036522', NULL, NULL, 103, NULL, 'UCP036522_pph', 274522),
(455429, 'PIRSF038075', NULL, NULL, 89, NULL, 'Env_UL49A', 274523),
(455430, 'PIRSF001222', NULL, NULL, 838, NULL, 'Urease', 274524),
(455431, 'PIRSF015921', NULL, NULL, 472, NULL, 'FA_sphingolip_des', 274525),
(455432, 'PIRSF021980', NULL, NULL, 207, NULL, 'UCP021980_RNA-bind', 274526),
(455433, 'PIRSF000865', NULL, NULL, 485, NULL, 'LPL_LIPH', 274527),
(455434, 'PIRSF019711', NULL, NULL, 194, NULL, 'Memb_prtease_arc', 274528),
(455435, 'PIRSF022613', NULL, NULL, 277, NULL, 'MBA1', 274529),
(455436, 'PIRSF035905', NULL, NULL, 918, NULL, 'UCP035905_mp', 274530),
(455437, 'PIRSF007939', NULL, NULL, 900, NULL, 'RRN6', 274531),
(455438, 'PIRSF003182', NULL, NULL, 781, NULL, 'HK_hybr_ArcB', 274532);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(455439, 'PIRSF005632', NULL, NULL, 361, NULL, 'Met_synth_catalytic', 274533),
(455440, 'PIRSF002549', NULL, NULL, 709, NULL, 'Transferrin', 274534),
(455441, 'PIRSF000903', NULL, NULL, 275, NULL, 'B5n-ttraPtase_sm', 274535),
(455442, 'PIRSF016522', NULL, NULL, 247, NULL, 'MOG', 274536),
(455443, 'PIRSF036426', NULL, NULL, 468, NULL, 'Sirohaem_synth', 274537),
(455444, 'PIRSF000926', NULL, NULL, 432, NULL, 'PTPN1_PTPN2', 274538),
(455445, 'PIRSF039102', NULL, NULL, 366, NULL, 'Ddl/VanB', 274539),
(455446, 'PIRSF015380', NULL, NULL, 687, NULL, 'Site-sp_rcmb', 274540),
(455447, 'PIRSF017632', NULL, NULL, 380, NULL, 'Ceramidase', 274541),
(455448, 'PIRSF022536', NULL, NULL, 136, NULL, 'A612L_SET', 274542),
(455449, 'PIRSF038207', NULL, NULL, 326, NULL, 'PP1_GT_animal', 274543),
(455450, 'PIRSF009416', NULL, NULL, 307, NULL, 'LuxD', 274544),
(455451, 'PIRSF003716', NULL, NULL, 537, NULL, 'VAC_F3L', 274545),
(455452, 'PIRSF017107', NULL, NULL, 413, NULL, 'MAAL', 274546),
(455453, 'PIRSF015952', NULL, NULL, 256, NULL, 'U3snoRNP11', 274547),
(455454, 'PIRSF020588', NULL, NULL, 335, NULL, 'Flk', 274548),
(455455, 'PIRSF033303', NULL, NULL, 212, NULL, 'UCP033303', 274549),
(455456, 'PIRSF003960', NULL, NULL, 1127, NULL, 'M_poly_TospoV', 274550),
(455457, 'PIRSF005727', NULL, NULL, 961, NULL, 'Beta-COP', 274551),
(455458, 'PIRSF004866', NULL, NULL, 200, NULL, 'IMP_cclhdr_arch', 274552),
(455459, 'PIRSF036950', NULL, NULL, 371, NULL, 'UCP036950', 274553),
(455460, 'PIRSF037656', NULL, NULL, 95, NULL, 'UCP037656_ESAT_EsxN', 274554),
(455461, 'PIRSF004764', NULL, NULL, 85, NULL, 'YmfJ', 274555),
(455462, 'PIRSF005215', NULL, NULL, 289, NULL, 'TehB', 274556),
(455463, 'PIRSF036688', NULL, NULL, 614, NULL, 'CmuA', 274557),
(455464, 'PIRSF006232', NULL, NULL, 287, NULL, 'Pirin', 274558),
(455465, 'PIRSF029703', NULL, NULL, 298, NULL, 'Mig-14', 274559),
(455466, 'PIRSF501104', NULL, NULL, 676, NULL, 'Protein_kin_C_delta', 274560),
(455467, 'PIRSF011474', NULL, NULL, 159, NULL, 'GutM', 274561),
(455468, 'PIRSF009360', NULL, NULL, 520, NULL, 'UCP009360', 274562),
(455469, 'PIRSF019364', NULL, NULL, 135, NULL, 'RapGH', 274563),
(455470, 'PIRSF002490', NULL, NULL, 372, NULL, 'SLRP_I', 274564),
(455471, 'PIRSF025926', NULL, NULL, 198, NULL, 'UCP025926', 274565),
(455472, 'PIRSF002882', NULL, NULL, 95, NULL, 'VapD', 274566),
(455473, 'PIRSF036535', NULL, NULL, 87, NULL, 'EhaE', 274567),
(455474, 'PIRSF037052', NULL, NULL, 176, NULL, 'UCP037052', 274568),
(455475, 'PIRSF037919', NULL, NULL, 741, NULL, 'HDAC_II_yeast', 274569),
(455476, 'PIRSF001948', NULL, NULL, 555, NULL, 'MCSF', 274570),
(455477, 'PIRSF004485', NULL, NULL, 147, NULL, 'T7_18-5', 274571),
(455478, 'PIRSF004960', NULL, NULL, 316, NULL, 'MtrH_MtxH', 274572),
(455479, 'PIRSF001327', NULL, NULL, 589, NULL, 'ArsAB_ATPase', 274573),
(455480, 'PIRSF037895', NULL, NULL, 1601, NULL, 'Subtilisin_rel_Sama_2696', 274574),
(455481, 'PIRSF028774', NULL, NULL, 359, NULL, 'UCP028774', 274575),
(455482, 'PIRSF501032', NULL, NULL, 473, NULL, 'C-ets-2', 274576),
(455483, 'PIRSF006298', NULL, NULL, 124, NULL, 'GtrA', 274577),
(455484, 'PIRSF038071', NULL, NULL, 464, NULL, 'GFR-alpha', 274578),
(455485, 'PIRSF501176', NULL, NULL, 496, NULL, 'DNApol_mu', 274579),
(455486, 'PIRSF006425', NULL, NULL, 616, NULL, 'UCP006425_WD40', 274580),
(455487, 'PIRSF038959', NULL, NULL, 215, NULL, 'SdpI', 274581),
(455488, 'PIRSF017901', NULL, NULL, 451, NULL, 'GCL', 274582),
(455489, 'PIRSF028980', NULL, NULL, 270, NULL, 'tRNAHis_guanlltr', 274583),
(455490, 'PIRSF000296', NULL, NULL, 334, NULL, 'SrpA', 274584),
(455491, 'PIRSF011794', NULL, NULL, 533, NULL, 'Rhamnogalacturonase_B', 274585),
(455492, 'PIRSF000183', NULL, NULL, 371, NULL, 'Alanine_dh', 274586),
(455493, 'PIRSF038800', NULL, NULL, 425, NULL, 'KYNU', 274587),
(455494, 'PIRSF026326', NULL, NULL, 240, NULL, 'InaA', 274588),
(455495, 'PIRSF020738', NULL, NULL, 336, NULL, 'InvJ', 274589),
(455496, 'PIRSF037217', NULL, NULL, 590, NULL, 'Carboxypeptdase_S', 274590),
(455497, 'PIRSF000383', NULL, NULL, 884, NULL, 'PEAMT', 274591);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(455498, 'PIRSF017811', NULL, NULL, 197, NULL, 'CKI_KRP_plant', 274592),
(455499, 'PIRSF037548', NULL, NULL, 2213, NULL, 'L_Filoviridae', 274593),
(455500, 'PIRSF001787', NULL, NULL, 386, NULL, 'TGF-beta', 274594),
(455501, 'PIRSF037579', NULL, NULL, 1457, NULL, 'MAPKK_SSK22', 274595),
(455502, 'PIRSF000337', NULL, NULL, 447, NULL, 'NTA_MOA', 274596),
(455503, 'PIRSF028103', NULL, NULL, 176, NULL, 'GcvR', 274597),
(455504, 'PIRSF000799', NULL, NULL, 537, NULL, 'DNA_pol_epsilon_2', 274598),
(455505, 'PIRSF037850', NULL, NULL, 1492, NULL, 'Subtilase_Euglen', 274599),
(455506, 'PIRSF009533', NULL, NULL, 145, NULL, 'FlbT', 274600),
(455507, 'PIRSF003377', NULL, NULL, 351, NULL, 'VP2_VP3_PPV', 274601),
(455508, 'PIRSF008153', NULL, NULL, 1274, NULL, 'CYFIP', 274602),
(455509, 'PIRSF500103', NULL, NULL, 138, NULL, 'EndoV', 274603),
(455510, 'PIRSF037947', NULL, NULL, 363, NULL, 'XRP2', 274604),
(455511, 'PIRSF029122', NULL, NULL, 331, NULL, 'UCP029122', 274605),
(455512, 'PIRSF005412', NULL, NULL, 687, NULL, 'UCP005412_abhydr', 274606),
(455513, 'PIRSF037035', NULL, NULL, 99, NULL, 'StpC', 274607),
(455514, 'PIRSF036516', NULL, NULL, 235, NULL, 'CDT_A', 274608),
(455515, 'PIRSF006625', NULL, NULL, 276, NULL, 'KduI', 274609),
(455516, 'PIRSF027352', NULL, NULL, 257, NULL, 'ERp29', 274610),
(455517, 'PIRSF000389', NULL, NULL, 526, NULL, 'DHFR-TS', 274611),
(455518, 'PIRSF036767', NULL, NULL, 447, NULL, 'ASM-like_Pdiesterase', 274612),
(455519, 'PIRSF025414', NULL, NULL, 356, NULL, 'Alpha-N-AFase', 274613),
(455520, 'PIRSF013171', NULL, NULL, 364, NULL, 'Pur_nuclsid_perm', 274614),
(455521, 'PIRSF009393', NULL, NULL, 745, NULL, 'Orn_decarb', 274615),
(455522, 'PIRSF037227', NULL, NULL, 480, NULL, 'AbgB', 274616),
(455523, 'PIRSF000547', NULL, NULL, 369, NULL, 'Prot_kinase_T7', 274617),
(455524, 'PIRSF000727', NULL, NULL, 817, NULL, 'ThrA', 274618),
(455525, 'PIRSF029594', NULL, NULL, 337, NULL, 'UCP029594', 274619),
(455526, 'PIRSF036888', NULL, NULL, 466, NULL, 'HDGYPm_UCP036888', 274620),
(455527, 'PIRSF021290', NULL, NULL, 179, NULL, 'UCP021290', 274621),
(455528, 'PIRSF006630', NULL, NULL, 586, NULL, 'NADS_GAT', 274622),
(455529, 'PIRSF026649', NULL, NULL, 307, NULL, 'MsbB', 274623),
(455530, 'PIRSF038131', NULL, NULL, 64, NULL, 'CX5C1', 274624),
(455531, 'PIRSF036525', NULL, NULL, 255, NULL, 'CobF', 274625),
(455532, 'PIRSF017267', NULL, NULL, 129, NULL, 'Sulfiredoxin', 274626),
(455533, 'PIRSF000747', NULL, NULL, 210, NULL, 'RPB5', 274627),
(455534, 'PIRSF031551', NULL, NULL, 173, NULL, 'UCP031551', 274628),
(455535, 'PIRSF011368', NULL, NULL, 175, NULL, 'LPP20', 274629),
(455536, 'PIRSF004491', NULL, NULL, 316, NULL, 'RibF_RibC', 274630),
(455537, 'PIRSF004982', NULL, NULL, 190, NULL, 'SlP', 274631),
(455538, 'PIRSF038025', NULL, NULL, 419, NULL, 'PTEN', 274632),
(455539, 'PIRSF027158', NULL, NULL, 436, NULL, 'Lys_MTase_YDR198C', 274633),
(455540, 'PIRSF022280', NULL, NULL, 266, NULL, 'UCP022280', 274634),
(455541, 'PIRSF004348', NULL, NULL, 64, NULL, 'RNA_pol_inhibit', 274635),
(455542, 'PIRSF035609', NULL, NULL, 127, NULL, 'UCP035609_HNH_endo', 274636),
(455543, 'PIRSF004611', NULL, NULL, 630, NULL, 'CBP2', 274637),
(455544, 'PIRSF013899', NULL, NULL, 295, NULL, 'UCP013899', 274638),
(455545, 'PIRSF010052', NULL, NULL, 577, NULL, 'Polyub_prc_Npl4', 274639),
(455546, 'PIRSF015892', NULL, NULL, 427, NULL, 'N-myristl_transf', 274640),
(455547, 'PIRSF016702', NULL, NULL, 143, NULL, 'DNA_bp_PD1', 274641),
(455548, 'PIRSF016477', NULL, NULL, 129, NULL, 'Prefoldin_4', 274642),
(455549, 'PIRSF036638', NULL, NULL, 644, NULL, 'M_m6A_StsI', 274643),
(455550, 'PIRSF008130', NULL, NULL, 106, NULL, 'UCP008130', 274644),
(455551, 'PIRSF037514', NULL, NULL, 554, NULL, 'Rab_ger_ger_transf_A_fungal', 274645),
(455552, 'PIRSF000141', NULL, NULL, 427, NULL, 'Anaerobic_G3P_dh', 274646),
(455553, 'PIRSF005642', NULL, NULL, 148, NULL, 'UCP005642', 274647),
(455554, 'PIRSF018454', NULL, NULL, 170, NULL, 'TRL10', 274648),
(455555, 'PIRSF003575', NULL, NULL, 304, NULL, 'MSA-2', 274649),
(455556, 'PIRSF020906', NULL, NULL, 162, NULL, 'Anti_s_fact_PmgA', 274650);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(455557, 'PIRSF037631', NULL, NULL, 136, NULL, 'Snapin', 274651),
(455558, 'PIRSF029904', NULL, NULL, 111, NULL, 'UCP029904_pph', 274652),
(455559, 'PIRSF028570', NULL, NULL, 161, NULL, 'UCP028570', 274653),
(455560, 'PIRSF006031', NULL, NULL, 144, NULL, 'UCP006031', 274654),
(455561, 'PIRSF036555', NULL, NULL, 593, NULL, 'SUMT_yeast', 274655),
(455562, 'PIRSF000460', NULL, NULL, 774, NULL, 'Glucan_phosphorylase_GlgP', 274656),
(455563, 'PIRSF005859', NULL, NULL, 162, NULL, 'PBR', 274657),
(455564, 'PIRSF014972', NULL, NULL, 137, NULL, 'FlK', 274658),
(455565, 'PIRSF006621', NULL, NULL, 334, NULL, 'Dus', 274659),
(455566, 'PIRSF000827', NULL, NULL, 727, NULL, 'RdRPol_OMV', 274660),
(455567, 'PIRSF032126', NULL, NULL, 124, NULL, 'F0F1_ATP_synth_I', 274661),
(455568, 'PIRSF015797', NULL, NULL, 132, NULL, 'Virion_core', 274662),
(455569, 'PIRSF001227', NULL, NULL, 800, NULL, 'Pen_acylase', 274663),
(455570, 'PIRSF019635', NULL, NULL, 188, NULL, 'Cytochrome_b245_alpha', 274664),
(455571, 'PIRSF030837', NULL, NULL, 155, NULL, 'TerW', 274665),
(455572, 'PIRSF000243', NULL, NULL, 520, NULL, 'NrfA', 274666),
(455573, 'PIRSF007828', NULL, NULL, 703, NULL, 'Dipeptidyl-peptidase_III', 274667),
(455574, 'PIRSF007138', NULL, NULL, 261, NULL, 'FIG1', 274668),
(455575, 'PIRSF008502', NULL, NULL, 180, NULL, 'UCP008502', 274669),
(455576, 'PIRSF039089', NULL, NULL, 310, NULL, 'ATP_synthase_gamma', 274670),
(455577, 'PIRSF001149', NULL, NULL, 617, NULL, 'Thrombin', 274671),
(455578, 'PIRSF005943', NULL, NULL, 481, NULL, 'NMPRT', 274672),
(455579, 'PIRSF037638', NULL, NULL, 97, NULL, 'B144_protein', 274673),
(455580, 'PIRSF005546', NULL, NULL, 615, NULL, 'Ifb-2', 274674),
(455581, 'PIRSF005604', NULL, NULL, 306, NULL, 'EndGlu_transf', 274675),
(455582, 'PIRSF016128', NULL, NULL, 140, NULL, 'UCP016128', 274676),
(455583, 'PIRSF029691', NULL, NULL, 257, NULL, 'UCP029691', 274677),
(455584, 'PIRSF004976', NULL, NULL, 314, NULL, 'ATPase_YdaO', 274678),
(455585, 'PIRSF026509', NULL, NULL, 183, NULL, 'UCP026509', 274679),
(455586, 'PIRSF036446', NULL, NULL, 226, NULL, 'Phosphoesterase_HI0762', 274680),
(455587, 'PIRSF006593', NULL, NULL, 294, NULL, 'UCP006593', 274681),
(455588, 'PIRSF007991', NULL, NULL, 535, NULL, 'Vang-like', 274682),
(455589, 'PIRSF000463', NULL, NULL, 718, NULL, 'GlgB', 274683),
(455590, 'PIRSF003268', NULL, NULL, 228, NULL, 'TraJ_R1', 274684),
(455591, 'PIRSF020623', NULL, NULL, 306, NULL, 'PaaX', 274685),
(455592, 'PIRSF033239', NULL, NULL, 209, NULL, 'ExoD', 274686),
(455593, 'PIRSF000156', NULL, NULL, 893, NULL, 'Pyruvate_dh_E1', 274687),
(455594, 'PIRSF037099', NULL, NULL, 895, NULL, 'Stonin', 274688),
(455595, 'PIRSF032840', NULL, NULL, 107, NULL, 'UCP032840', 274689),
(455596, 'PIRSF005647', NULL, NULL, 250, NULL, 'CooC', 274690),
(455597, 'PIRSF007542', NULL, NULL, 588, NULL, 'UCP007542', 274691),
(455598, 'PIRSF026802', NULL, NULL, 283, NULL, 'UCP026802', 274692),
(455599, 'PIRSF000124', NULL, NULL, 438, NULL, 'UDPglc_GDPman_dh', 274693),
(455600, 'PIRSF014753', NULL, NULL, 612, NULL, 'UCP014753', 274694),
(455601, 'PIRSF001225', NULL, NULL, 230, NULL, 'Urease_gammabeta', 274695),
(455602, 'PIRSF037599', NULL, NULL, 152, NULL, 'GDPMH', 274696),
(455603, 'PIRSF038973', NULL, NULL, 212, NULL, 'SpoIIM', 274697),
(455604, 'PIRSF006549', NULL, NULL, 453, NULL, 'PDH_arog_dh_reg', 274698),
(455605, 'PIRSF001359', NULL, NULL, 289, NULL, 'F_bP_aldolase_II', 274699),
(455606, 'PIRSF002094', NULL, NULL, 170, NULL, 'OMP26_Skp', 274700),
(455607, 'PIRSF010260', NULL, NULL, 189, NULL, 'UCP010260', 274701),
(455608, 'PIRSF003956', NULL, NULL, 271, NULL, 'NS-S_PhleboV', 274702),
(455609, 'PIRSF016988', NULL, NULL, 410, NULL, 'UCP016988', 274703),
(455610, 'PIRSF028754', NULL, NULL, 301, NULL, 'UCP028754', 274704),
(455611, 'PIRSF001789', NULL, NULL, 253, NULL, 'NGFB', 274705),
(455612, 'PIRSF036881', NULL, NULL, 423, NULL, 'PAT', 274706),
(455613, 'PIRSF016817', NULL, NULL, 393, NULL, 'UCP016817_carboligase', 274707),
(455614, 'PIRSF501175', NULL, NULL, 505, NULL, 'TDT', 274708),
(455615, 'PIRSF020370', NULL, NULL, 257, NULL, 'Oms28', 274709);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(455616, 'PIRSF002825', NULL, NULL, 356, NULL, 'CfbpA', 274710),
(455617, 'PIRSF037081', NULL, NULL, 184, NULL, 'P-loop_All4644', 274711),
(455618, 'PIRSF016302', NULL, NULL, 453, NULL, 'Man_a_manosd', 274712),
(455619, 'PIRSF000882', NULL, NULL, 680, NULL, 'DSB_repair_MRE11', 274713),
(455620, 'PIRSF006247', NULL, NULL, 486, NULL, 'TrkH', 274714),
(455621, 'PIRSF004884', NULL, NULL, 330, NULL, 'Sugar_kin_arch', 274715),
(455622, 'PIRSF000550', NULL, NULL, 674, NULL, 'PKC_alpha', 274716),
(455623, 'PIRSF019625', NULL, NULL, 232, NULL, 'EVI2A', 274717),
(455624, 'PIRSF001882', NULL, NULL, 37, NULL, 'Insect_neurot_curtatoxin', 274718),
(455625, 'PIRSF016557', NULL, NULL, 256, NULL, 'CpsB', 274719),
(455626, 'PIRSF037322', NULL, NULL, 212, NULL, 'CDKN3', 274720),
(455627, 'PIRSF000047', NULL, NULL, 504, NULL, 'Cytochrome_CYPVIIA1', 274721),
(455628, 'PIRSF006380', NULL, NULL, 200, NULL, 'UCP006380', 274722),
(455629, 'PIRSF017570', NULL, NULL, 569, NULL, 'H3K79_H-MTase_fungal', 274723),
(455630, 'PIRSF001100', NULL, NULL, 427, NULL, 'Cellulase', 274724),
(455631, 'PIRSF000941', NULL, NULL, 343, NULL, 'DUSP12', 274725),
(455632, 'PIRSF036456', NULL, NULL, 624, NULL, 'ASAL_AGS', 274726),
(455633, 'PIRSF000232', NULL, NULL, 192, NULL, 'YdjA', 274727),
(455634, 'PIRSF026584', NULL, NULL, 290, NULL, 'Delta_tox', 274728),
(455635, 'PIRSF032620', NULL, NULL, 284, NULL, 'UCP032620', 274729),
(455636, 'PIRSF022057', NULL, NULL, 170, NULL, 'UCP022057', 274730),
(455637, 'PIRSF029163', NULL, NULL, 94, NULL, 'MDH2', 274731),
(455638, 'PIRSF006581', NULL, NULL, 85, NULL, 'EhaD', 274732),
(455639, 'PIRSF006607', NULL, NULL, 254, NULL, 'RNAmts_UCP006607', 274733),
(455640, 'PIRSF038018', NULL, NULL, 195, NULL, 'BIO', 274734),
(455641, 'PIRSF016070', NULL, NULL, 264, NULL, 'Vir_PGP3-D_Chlamydiae', 274735),
(455642, 'PIRSF018005', NULL, NULL, 331, NULL, 'UCP018005', 274736),
(455643, 'PIRSF037682', NULL, NULL, 262, NULL, 'Saliv_gland_allergen_Aed3', 274737),
(455644, 'PIRSF000190', NULL, NULL, 225, NULL, 'Pyd_amn-ph_oxd', 274738),
(455645, 'PIRSF029636', NULL, NULL, 240, NULL, 'UCP029636', 274739),
(455646, 'PIRSF036440', NULL, NULL, 881, NULL, 'ARG5-6', 274740),
(455647, 'PIRSF036962', NULL, NULL, 320, NULL, 'UCP036962_SignTr_Ycf55', 274741),
(455648, 'PIRSF016183', NULL, NULL, 178, NULL, 'UCP016183', 274742),
(455649, 'PIRSF005514', NULL, NULL, 171, NULL, 'Mitoh_ATP-synt_D', 274743),
(455650, 'PIRSF039117', NULL, NULL, 485, NULL, 'KaiC', 274744),
(455651, 'PIRSF002889', NULL, NULL, 136, NULL, 'Rod_FlgB', 274745),
(455652, 'PIRSF000930', NULL, NULL, 807, NULL, 'PTPN8_PTPN22', 274746),
(455653, 'PIRSF037208', NULL, NULL, 249, NULL, 'ATE_prok', 274747),
(455654, 'PIRSF004015', NULL, NULL, 829, NULL, 'LigT_rotavirus', 274748),
(455655, 'PIRSF001558', NULL, NULL, 486, NULL, 'GSHase', 274749),
(455656, 'PIRSF019381', NULL, NULL, 476, NULL, 'YcjX', 274750),
(455657, 'PIRSF006553', NULL, NULL, 545, NULL, 'TopoVI-B', 274751),
(455658, 'PIRSF037464', NULL, NULL, 687, NULL, 'UCP037464_APP1', 274752),
(455659, 'PIRSF036401', NULL, NULL, 529, NULL, 'Gcp_STYKS', 274753),
(455660, 'PIRSF002595', NULL, NULL, 582, NULL, 'RR_SKN7', 274754),
(455661, 'PIRSF001399', NULL, NULL, 147, NULL, 'DHQase_2', 274755),
(455662, 'PIRSF004959', NULL, NULL, 165, NULL, 'UCP004959', 274756),
(455663, 'PIRSF006278', NULL, NULL, 356, NULL, 'ACCD_DCysDesulf', 274757),
(455664, 'PIRSF007892', NULL, NULL, 546, NULL, 'NAGS_fungal', 274758),
(455665, 'PIRSF038189', NULL, NULL, 477, NULL, 'IRAK4', 274759),
(455666, 'PIRSF038971', NULL, NULL, 379, NULL, 'PhnM', 274760),
(455667, 'PIRSF016578', NULL, NULL, 397, NULL, 'PIGM', 274761),
(455668, 'PIRSF016666', NULL, NULL, 488, NULL, 'UCP016666', 274762),
(455669, 'PIRSF005216', NULL, NULL, 162, NULL, 'PvlArgDC', 274763),
(455670, 'PIRSF012467', NULL, NULL, 1320, NULL, 'UCP012467', 274764),
(455671, 'PIRSF037204', NULL, NULL, 613, NULL, 'UCP037204', 274765),
(455672, 'PIRSF029037', NULL, NULL, 258, NULL, 'UCP029037_Zn_ribbon', 274766),
(455673, 'PIRSF000728', NULL, NULL, 278, NULL, 'NAGK', 274767),
(455674, 'PIRSF000408', NULL, NULL, 188, NULL, 'Alkyltransferas_AdaA', 274768);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(455675, 'PIRSF031796', NULL, NULL, 163, NULL, 'UCP031796', 274769),
(455676, 'PIRSF001529', NULL, NULL, 427, NULL, 'Ser-tRNA_ligase', 274770),
(455677, 'PIRSF037032', NULL, NULL, 296, NULL, 'BiliverdinRD_A', 274771),
(455678, 'PIRSF006413', NULL, NULL, 224, NULL, 'Transl_init_IF-6', 274772),
(455679, 'PIRSF000824', NULL, NULL, 2256, NULL, 'L_OrthobunV', 274773),
(455680, 'PIRSF000179', NULL, NULL, 120, NULL, 'FrdD', 274774),
(455681, 'PIRSF030829', NULL, NULL, 489, NULL, 'DAG_kinase_plant', 274775),
(455682, 'PIRSF035865', NULL, NULL, 384, NULL, 'UCP035865', 274776),
(455683, 'PIRSF019370', NULL, NULL, 317, NULL, 'EhaR', 274777),
(455684, 'PIRSF000168', NULL, NULL, 692, NULL, 'Acyl-CoA_oxidase', 274778),
(455685, 'PIRSF038073', NULL, NULL, 373, NULL, 'B-acetylglucosaminyltrns_Rfng', 274779),
(455686, 'PIRSF002854', NULL, NULL, 278, NULL, 'MetQ', 274780),
(455687, 'PIRSF020772', NULL, NULL, 152, NULL, 'UCP020772', 274781),
(455688, 'PIRSF017316', NULL, NULL, 608, NULL, 'Pesterase_C1039', 274782),
(455689, 'PIRSF017998', NULL, NULL, 198, NULL, 'UCP017998', 274783),
(455690, 'PIRSF002417', NULL, NULL, 478, NULL, 'Lipid_binding_protein', 274784),
(455691, 'PIRSF029886', NULL, NULL, 198, NULL, 'KBAA', 274785),
(455692, 'PIRSF018933', NULL, NULL, 202, NULL, 'UCP018933', 274786),
(455693, 'PIRSF007972', NULL, NULL, 211, NULL, 'Gra2', 274787),
(455694, 'PIRSF026713', NULL, NULL, 571, NULL, 'PMI_Firm_long', 274788),
(455695, 'PIRSF500175', NULL, NULL, 419, NULL, 'Glu_ADT_D', 274789),
(455696, 'PIRSF000509', NULL, NULL, 448, NULL, 'Trp_DMAT', 274790),
(455697, 'PIRSF037824', NULL, NULL, 131, NULL, 'Orexin', 274791),
(455698, 'PIRSF016275', NULL, NULL, 1109, NULL, 'DNA_pol_II_DP2', 274792),
(455699, 'PIRSF032623', NULL, NULL, 1218, NULL, 'Protease_SSO2181', 274793),
(455700, 'PIRSF036668', NULL, NULL, 275, NULL, 'ATPase_UCP036668', 274794),
(455701, 'PIRSF004966', NULL, NULL, 135, NULL, 'Aconts_X_swiv', 274795),
(455702, 'PIRSF006169', NULL, NULL, 76, NULL, 'UCP006169', 274796),
(455703, 'PIRSF037750', NULL, NULL, 233, NULL, 'TIR_Tirap', 274797),
(455704, 'PIRSF005384', NULL, NULL, 148, NULL, 'RpiB_LacA_B', 274798),
(455705, 'PIRSF033579', NULL, NULL, 271, NULL, 'Anaer_Co_chel_CbiK', 274799),
(455706, 'PIRSF001979', NULL, NULL, 504, NULL, 'Alpha_1B_glycoprot', 274800),
(455707, 'PIRSF004553', NULL, NULL, 187, NULL, 'Methylase_YhhF', 274801),
(455708, 'PIRSF037992', NULL, NULL, 294, NULL, 'HnRNP_C_Raly', 274802),
(455709, 'PIRSF001617', NULL, NULL, 1391, NULL, 'Alpha-AR', 274803),
(455710, 'PIRSF037935', NULL, NULL, 581, NULL, 'TMPRSS13', 274804),
(455711, 'PIRSF008159', NULL, NULL, 218, NULL, 'UCP008159_ABC', 274805),
(455712, 'PIRSF002496', NULL, NULL, 945, NULL, 'Chordin', 274806),
(455713, 'PIRSF037882', NULL, NULL, 726, NULL, 'Subtilisin_rel_fervidolysin', 274807),
(455714, 'PIRSF006288', NULL, NULL, 882, NULL, 'PII_uridyltransf', 274808),
(455715, 'PIRSF000847', NULL, NULL, 187, NULL, 'Phos_ph_gly_syn', 274809),
(455716, 'PIRSF000909', NULL, NULL, 562, NULL, 'STPPPtase_PPZ', 274810),
(455717, 'PIRSF000525', NULL, NULL, 369, NULL, 'SerC', 274811),
(455718, 'PIRSF016933', NULL, NULL, 228, NULL, 'PrsW', 274812),
(455719, 'PIRSF002855', NULL, NULL, 79, NULL, 'Murein-lipo', 274813),
(455720, 'PIRSF015792', NULL, NULL, 226, NULL, 'VAC_F16L', 274814),
(455721, 'PIRSF038886', NULL, NULL, 440, NULL, 'Pellino', 274815),
(455722, 'PIRSF018644', NULL, NULL, 462, NULL, 'FAU-1', 274816),
(455723, 'PIRSF033887', NULL, NULL, 299, NULL, 'PduX', 274817),
(455724, 'PIRSF017529', NULL, NULL, 271, NULL, 'Aquaporin-11_12', 274818),
(455725, 'PIRSF007050', NULL, NULL, 139, NULL, 'UCP007050', 274819),
(455726, 'PIRSF038145', NULL, NULL, 2055, NULL, 'STPK_citron', 274820),
(455727, 'PIRSF037511', NULL, NULL, 118, NULL, 'Transl_init_SUI1_prok', 274821),
(455728, 'PIRSF004919', NULL, NULL, 464, NULL, 'TldD', 274822),
(455729, 'PIRSF020763', NULL, NULL, 338, NULL, 'TcpF', 274823),
(455730, 'PIRSF001741', NULL, NULL, 831, NULL, 'MAGUK_DLGH', 274824),
(455731, 'PIRSF000819', NULL, NULL, 252, NULL, 'Streptomycin_3-adenylyltransf', 274825);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(455732, 'PIRSF001223', NULL, NULL, 100, NULL, 'Urease_gamma', 274826),
(455733, 'PIRSF037676', NULL, NULL, 69, NULL, 'UCP037676', 274827),
(455734, 'PIRSF016498', NULL, NULL, 120, NULL, 'UCP016498', 274828),
(455735, 'PIRSF001365', NULL, NULL, 307, NULL, 'DHDPS', 274829),
(455736, 'PIRSF034247', NULL, NULL, 213, NULL, 'RCAS1', 274830),
(455737, 'PIRSF009285', NULL, NULL, 236, NULL, 'GAMT', 274831),
(455738, 'PIRSF028688', NULL, NULL, 212, NULL, 'UCP028688', 274832),
(455739, 'PIRSF500784', NULL, NULL, 291, NULL, 'TAG1', 274833),
(455740, 'PIRSF001594', NULL, NULL, 1147, NULL, 'PCB', 274834),
(455741, 'PIRSF001150', NULL, NULL, 810, NULL, 'Plasmin', 274835),
(455742, 'PIRSF000264', NULL, NULL, 265, NULL, 'Meth_CoM_rd_gama', 274836),
(455743, 'PIRSF015950', NULL, NULL, 340, NULL, 'Mev_P_decrbx', 274837),
(455744, 'PIRSF033924', NULL, NULL, 202, NULL, 'UCP033924', 274838),
(455745, 'PIRSF028188', NULL, NULL, 320, NULL, 'Amdntrnsf_FN0238', 274839),
(455746, 'PIRSF500204', NULL, NULL, 196, NULL, 'RBP_purpurin', 274840),
(455747, 'PIRSF016632', NULL, NULL, 307, NULL, 'PLD_actino_fungi', 274841),
(455748, 'PIRSF017117', NULL, NULL, 110, NULL, 'YscY', 274842),
(455749, 'PIRSF009564', NULL, NULL, 107, NULL, 'HdeA', 274843),
(455750, 'PIRSF010044', NULL, NULL, 265, NULL, 'UCP010044', 274844),
(455751, 'PIRSF017324', NULL, NULL, 154, NULL, 'UCP017324', 274845),
(455752, 'PIRSF028983', NULL, NULL, 308, NULL, 'BCP1', 274846),
(455753, 'PIRSF000690', NULL, NULL, 500, NULL, 'Phosphotransf_FPr', 274847),
(455754, 'PIRSF001220', NULL, NULL, 331, NULL, 'L-ASNase_gatD', 274848),
(455755, 'PIRSF037546', NULL, NULL, 2109, NULL, 'RNA_pol_L_Rhabdo_sub', 274849),
(455756, 'PIRSF037445', NULL, NULL, 412, NULL, 'UCP037445_abhydr', 274850),
(455757, 'PIRSF015040', NULL, NULL, 838, NULL, 'ATPase_SAG2001', 274851),
(455758, 'PIRSF000929', NULL, NULL, 599, NULL, 'PTPN6_PTPN11', 274852),
(455759, 'PIRSF039014', NULL, NULL, 507, NULL, 'OTR_cyc', 274853),
(455760, 'PIRSF001218', NULL, NULL, 204, NULL, 'Protease_ADV', 274854),
(455761, 'PIRSF006187', NULL, NULL, 154, NULL, 'UCP006187', 274855),
(455762, 'PIRSF038981', NULL, NULL, 448, NULL, 'GRP', 274856),
(455763, 'PIRSF001060', NULL, NULL, 299, NULL, 'Endochitinase', 274857),
(455764, 'PIRSF001883', NULL, NULL, 289, NULL, 'TxP_I', 274858),
(455765, 'PIRSF015693', NULL, NULL, 570, NULL, 'VAC-48L_nuct', 274859),
(455766, 'PIRSF003760', NULL, NULL, 88, NULL, 'VAC_K3L_Serpin', 274860),
(455767, 'PIRSF036444', NULL, NULL, 1361, NULL, 'Pesterase_YvnB', 274861),
(455768, 'PIRSF501106', NULL, NULL, 737, NULL, 'Protein_kin_C_epsilon', 274862),
(455769, 'PIRSF024658', NULL, NULL, 172, NULL, 'FlaF_archaea', 274863),
(455770, 'PIRSF028335', NULL, NULL, 933, NULL, 'OppA', 274864),
(455771, 'PIRSF000549', NULL, NULL, 645, NULL, 'Ser_prot_kin', 274865),
(455772, 'PIRSF001716', NULL, NULL, 638, NULL, 'Dorsal', 274866),
(455773, 'PIRSF005669', NULL, NULL, 542, NULL, 'HAT_Elp3', 274867),
(455774, 'PIRSF000534', NULL, NULL, 449, NULL, 'ATP_PFK_TP0108', 274868),
(455775, 'PIRSF001939', NULL, NULL, 152, NULL, 'IL-3', 274869),
(455776, 'PIRSF021287', NULL, NULL, 123, NULL, 'YmcA', 274870),
(455777, 'PIRSF007165', NULL, NULL, 183, NULL, 'UCP007165', 274871),
(455778, 'PIRSF036978', NULL, NULL, 340, NULL, 'UCP036978_PHPhdr', 274872),
(455779, 'PIRSF500101', NULL, NULL, 618, NULL, 'ER-a', 274873),
(455780, 'PIRSF028445', NULL, NULL, 218, NULL, 'UCP028445', 274874),
(455781, 'PIRSF005023', NULL, NULL, 636, NULL, 'CODH', 274875),
(455782, 'PIRSF009467', NULL, NULL, 224, NULL, 'Urease_acces_UreF', 274876),
(455783, 'PIRSF016939', NULL, NULL, 357, NULL, 'ADP_ribosylarg_hydrolase', 274877),
(455784, 'PIRSF027391', NULL, NULL, 178, NULL, 'Hpre_diP_synt_I', 274878),
(455785, 'PIRSF028477', NULL, NULL, 290, NULL, 'UCP028477', 274879),
(455786, 'PIRSF016323', NULL, NULL, 318, NULL, 'tRNA_m1G_Mtase_euk', 274880),
(455787, 'PIRSF038940', NULL, NULL, 347, NULL, 'Low_specificity_LTA', 274881),
(455788, 'PIRSF001906', NULL, NULL, 31, NULL, 'ATX_III', 274882),
(455789, 'PIRSF036603', NULL, NULL, 709, NULL, 'DNA_pol_eta', 274883);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(455790, 'PIRSF016573', NULL, NULL, 228, NULL, 'Snapalysin', 274884),
(455791, 'PIRSF036536', NULL, NULL, 221, NULL, 'EhaH', 274885),
(455792, 'PIRSF038919', NULL, NULL, 655, NULL, 'NOG1', 274886),
(455793, 'PIRSF030333', NULL, NULL, 152, NULL, 'UCP030333_Alba', 274887),
(455794, 'PIRSF001293', NULL, NULL, 837, NULL, 'ATP6V0A1', 274888),
(455795, 'PIRSF000428', NULL, NULL, 322, NULL, 'P_Ac_trans', 274889),
(455796, 'PIRSF039072', NULL, NULL, 553, NULL, 'ATPase_subunit_beta', 274890),
(455797, 'PIRSF020967', NULL, NULL, 380, NULL, 'UCP020967', 274891),
(455798, 'PIRSF017199', NULL, NULL, 142, NULL, 'Dim1', 274892),
(455799, 'PIRSF002744', NULL, NULL, 477, NULL, 'Pur-cyt_permease', 274893),
(455800, 'PIRSF009265', NULL, NULL, 251, NULL, 'GCH3', 274894),
(455801, 'PIRSF016441', NULL, NULL, 961, NULL, 'GTF2I', 274895),
(455802, 'PIRSF037404', NULL, NULL, 1599, NULL, 'DNMT1', 274896),
(455803, 'PIRSF000105', NULL, NULL, 322, NULL, 'HCDH', 274897),
(455804, 'PIRSF006257', NULL, NULL, 108, NULL, 'UCP006257', 274898),
(455805, 'PIRSF029218', NULL, NULL, 98, NULL, 'ParE', 274899),
(455806, 'PIRSF037663', NULL, NULL, 159, NULL, 'Acetyltransf_GNAT', 274900),
(455807, 'PIRSF018586', NULL, NULL, 191, NULL, 'FADD', 274901),
(455808, 'PIRSF026396', NULL, NULL, 341, NULL, 'UCP026396_dh', 274902),
(455809, 'PIRSF500627', NULL, NULL, 501, NULL, 'Cytochrome_CYP8B1', 274903),
(455810, 'PIRSF501105', NULL, NULL, 707, NULL, 'Protein_kin_C_theta', 274904),
(455811, 'PIRSF019464', NULL, NULL, 196, NULL, 'UCP019464', 274905),
(455812, 'PIRSF003003', NULL, NULL, 175, NULL, 'Colicin_imm', 274906),
(455813, 'PIRSF007056', NULL, NULL, 527, NULL, 'UCP007056', 274907),
(455814, 'PIRSF037048', NULL, NULL, 475, NULL, 'PNPOx_plant', 274908),
(455815, 'PIRSF000188', NULL, NULL, 354, NULL, 'Phe_leu_dh', 274909),
(455816, 'PIRSF005378', NULL, NULL, 363, NULL, 'RNA_3-term_P_cyclase', 274910),
(455817, 'PIRSF021485', NULL, NULL, 256, NULL, 'UCP021485', 274911),
(455818, 'PIRSF000118', NULL, NULL, 591, NULL, 'Ilv5_plant', 274912),
(455819, 'PIRSF000605', NULL, NULL, 523, NULL, 'RPS6_kin_1', 274913),
(455820, 'PIRSF028291', NULL, NULL, 104, NULL, 'UCP028291', 274914),
(455821, 'PIRSF038006', NULL, NULL, 482, NULL, 'MeCP2', 274915),
(455822, 'PIRSF029557', NULL, NULL, 206, NULL, 'UCP029557', 274916),
(455823, 'PIRSF002190', NULL, NULL, 173, NULL, 'Ribosomal_L18a', 274917),
(455824, 'PIRSF006609', NULL, NULL, 86, NULL, 'snRNP_SmF', 274918),
(455825, 'PIRSF028440', NULL, NULL, 107, NULL, 'UCP_LAB_N', 274919),
(455826, 'PIRSF038130', NULL, NULL, 330, NULL, 'WRKY_txn_fact_IIc', 274920),
(455827, 'PIRSF036487', NULL, NULL, 490, NULL, 'Hydroxylase_rubr', 274921),
(455828, 'PIRSF036632', NULL, NULL, 657, NULL, 'GOGAT_lg_1_3', 274922),
(455829, 'PIRSF004929', NULL, NULL, 287, NULL, 'UCP004929', 274923),
(455830, 'PIRSF000502', NULL, NULL, 298, NULL, 'Spermidine_synth', 274924),
(455831, 'PIRSF006107', NULL, NULL, 714, NULL, 'PTA_proteo', 274925),
(455832, 'PIRSF037237', NULL, NULL, 899, NULL, 'Peptidase_WD_repeats_DUG2', 274926),
(455833, 'PIRSF017385', NULL, NULL, 132, NULL, 'CtaF', 274927),
(455834, 'PIRSF037671', NULL, NULL, 453, NULL, 'Chloroquine_res_transporter', 274928),
(455835, 'PIRSF000076', NULL, NULL, 549, NULL, 'HCP', 274929),
(455836, 'PIRSF029033', NULL, NULL, 242, NULL, 'UCP029033', 274930),
(455837, 'PIRSF032064', NULL, NULL, 182, NULL, 'UCP032064', 274931),
(455838, 'PIRSF029928', NULL, NULL, 109, NULL, 'ComGC', 274932),
(455839, 'PIRSF006639', NULL, NULL, 114, NULL, 'UCP006639_pph', 274933),
(455840, 'PIRSF000580', NULL, NULL, 1054, NULL, 'STPK_ULK1', 274934),
(455841, 'PIRSF010751', NULL, NULL, 606, NULL, 'HOP1_fungal', 274935),
(455842, 'PIRSF037713', NULL, NULL, 188, NULL, 'BT_exbB-like_prot_1', 274936),
(455843, 'PIRSF001265', NULL, NULL, 716, NULL, 'H+-PPtase', 274937),
(455844, 'PIRSF003170', NULL, NULL, 228, NULL, 'Pet18p', 274938),
(455845, 'PIRSF028513', NULL, NULL, 186, NULL, 'LptC', 274939),
(455846, 'PIRSF036314', NULL, NULL, 1623, NULL, 'LDLR-rel_5_6', 274940),
(455847, 'PIRSF033535', NULL, NULL, 219, NULL, 'UCP033535_plp', 274941); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(455848, 'PIRSF007747', NULL, NULL, 482, NULL, 'RIT1', 274942),
(455849, 'PIRSF037993', NULL, NULL, 404, NULL, 'STPK_Pim-1', 274943),
(455850, 'PIRSF006294', NULL, NULL, 532, NULL, 'PEP_crbxkin', 274944),
(455851, 'PIRSF004028', NULL, NULL, 486, NULL, 'GPC_ArenaV', 274945),
(455852, 'PIRSF031402', NULL, NULL, 158, NULL, 'SYS1_homolog', 274946),
(455853, 'PIRSF011444', NULL, NULL, 203, NULL, 'UCP011444', 274947),
(455854, 'PIRSF028770', NULL, NULL, 126, NULL, 'UCP028770', 274948),
(455855, 'PIRSF005822', NULL, NULL, 103, NULL, 'NDUA2', 274949),
(455856, 'PIRSF016550', NULL, NULL, 596, NULL, 'Rab_ger_ger_transf_A_euk', 274950),
(455857, 'PIRSF016580', NULL, NULL, 374, NULL, 'Acylprotsyn_LuxE', 274951),
(455858, 'PIRSF006004', NULL, NULL, 358, NULL, 'Cfr', 274952),
(455859, 'PIRSF015971', NULL, NULL, 226, NULL, 'VAC_F1L', 274953),
(455860, 'PIRSF019325', NULL, NULL, 207, NULL, 'GPI', 274954),
(455861, 'PIRSF017066', NULL, NULL, 415, NULL, 'FlaD_arch', 274955),
(455862, 'PIRSF015417', NULL, NULL, 645, NULL, 'T31B5_30_vWA', 274956),
(455863, 'PIRSF038958', NULL, NULL, 517, NULL, 'PG_synth_SpoVB', 274957),
(455864, 'PIRSF000852', NULL, NULL, 240, NULL, 'Phosphatidylserin_synth_fung', 274958),
(455865, 'PIRSF025479', NULL, NULL, 185, NULL, 'UCP025479', 274959),
(455866, 'PIRSF017849', NULL, NULL, 123, NULL, 'TraD', 274960),
(455867, 'PIRSF005019', NULL, NULL, 94, NULL, 'EhaA', 274961),
(455868, 'PIRSF028234', NULL, NULL, 235, NULL, 'UCP028234', 274962),
(455869, 'PIRSF005011', NULL, NULL, 248, NULL, 'SanA', 274963),
(455870, 'PIRSF036354', NULL, NULL, 733, NULL, 'NosR', 274964),
(455871, 'PIRSF016493', NULL, NULL, 581, NULL, 'Glycyl_aminpptds', 274965),
(455872, 'PIRSF011861', NULL, NULL, 533, NULL, 'Biotinidase', 274966),
(455873, 'PIRSF035042', NULL, NULL, 317, NULL, 'UCP035042_thirdx', 274967),
(455874, 'PIRSF037328', NULL, NULL, 361, NULL, 'Inhibin_alpha', 274968),
(455875, 'PIRSF037356', NULL, NULL, 78, NULL, 'UCP037356', 274969),
(455876, 'PIRSF016255', NULL, NULL, 440, NULL, 'Transl_init_eIF3e', 274970),
(455877, 'PIRSF029187', NULL, NULL, 204, NULL, 'SHR3', 274971),
(455878, 'PIRSF037984', NULL, NULL, 230, NULL, 'Met_synth_TM0269', 274972),
(455879, 'PIRSF002305', NULL, NULL, 590, NULL, 'ERM', 274973),
(455880, 'PIRSF003269', NULL, NULL, 115, NULL, 'TrbA', 274974),
(455881, 'PIRSF006280', NULL, NULL, 379, NULL, 'YfiF', 274975),
(455882, 'PIRSF001336', NULL, NULL, 644, NULL, 'ARGDC', 274976),
(455883, 'PIRSF037932', NULL, NULL, 382, NULL, 'A2BP1', 274977),
(455884, 'PIRSF005588', NULL, NULL, 140, NULL, 'DAD1_Ost2', 274978),
(455885, 'PIRSF036313', NULL, NULL, 697, NULL, 'Fibulin-1', 274979),
(455886, 'PIRSF010244', NULL, NULL, 183, NULL, 'UCP010244_imp', 274980),
(455887, 'PIRSF037487', NULL, NULL, 219, NULL, 'Sulfite_red_assimil', 274981),
(455888, 'PIRSF006439', NULL, NULL, 618, NULL, 'Indolepyruvate_ferr_oxidored', 274982),
(455889, 'PIRSF029172', NULL, NULL, 399, NULL, 'UCP029172_ABC_sbc_YnjB', 274983),
(455890, 'PIRSF003696', NULL, NULL, 249, NULL, 'VAC_C23L', 274984),
(455891, 'PIRSF033101', NULL, NULL, 262, NULL, 'UCP033101', 274985),
(455892, 'PIRSF006320', NULL, NULL, 217, NULL, 'Elb2', 274986),
(455893, 'PIRSF029287', NULL, NULL, 223, NULL, 'UCP029287', 274987),
(455894, 'PIRSF006443', NULL, NULL, 170, NULL, 'MoaB', 274988),
(455895, 'PIRSF038170', NULL, NULL, 448, NULL, 'TRM6', 274989),
(455896, 'PIRSF006113', NULL, NULL, 122, NULL, 'PTP_synth', 274990),
(455897, 'PIRSF037188', NULL, NULL, 115, NULL, 'Lsm7', 274991),
(455898, 'PIRSF004882', NULL, NULL, 155, NULL, 'GTP_bind_MJ1339', 274992),
(455899, 'PIRSF032184', NULL, NULL, 455, NULL, 'V-ATP_synth_H', 274993),
(455900, 'PIRSF010354', NULL, NULL, 3841, NULL, 'Trx_SET', 274994),
(455901, 'PIRSF015268', NULL, NULL, 343, NULL, 'Virulence_RhuM', 274995),
(455902, 'PIRSF001837', NULL, NULL, 167, NULL, 'Leptin', 274996),
(455903, 'PIRSF006398', NULL, NULL, 91, NULL, 'Sec61_beta', 274997),
(455904, 'PIRSF036389', NULL, NULL, 732, NULL, 'IOR_B', 274998),
(455905, 'PIRSF016788', NULL, NULL, 295, NULL, 'RR_Fis', 274999),
(455906, 'PIRSF036594', NULL, NULL, 319, NULL, 'MoaC_MogA', 275000);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(455907, 'PIRSF002495', NULL, NULL, 2813, NULL, 'VWF', 275001),
(455908, 'PIRSF017321', NULL, NULL, 456, NULL, 'PIG-W', 275002),
(455909, 'PIRSF009290', NULL, NULL, 333, NULL, 'FrlB', 275003),
(455910, 'PIRSF036495', NULL, NULL, 350, NULL, 'IGFBP_rP_CNN', 275004),
(455911, 'PIRSF000825', NULL, NULL, 2152, NULL, 'L_HantaV', 275005),
(455912, 'PIRSF018297', NULL, NULL, 129, NULL, 'Doc', 275006),
(455913, 'PIRSF032862', NULL, NULL, 627, NULL, 'UCP032862_Fe-S', 275007),
(455914, 'PIRSF012508', NULL, NULL, 102, NULL, 'YerC', 275008),
(455915, 'PIRSF028655', NULL, NULL, 332, NULL, 'NMP1', 275009),
(455916, 'PIRSF007023', NULL, NULL, 343, NULL, 'UDP-Galf_transf', 275010),
(455917, 'PIRSF031780', NULL, NULL, 107, NULL, 'UCP031780', 275011),
(455918, 'PIRSF001875', NULL, NULL, 94, NULL, 'Alpha_defensin', 275012),
(455919, 'PIRSF025023', NULL, NULL, 115, NULL, 'Spt4', 275013),
(455920, 'PIRSF002096', NULL, NULL, 133, NULL, 'HnS', 275014),
(455921, 'PIRSF016958', NULL, NULL, 244, NULL, 'Mtase_AD-003', 275015),
(455922, 'PIRSF006577', NULL, NULL, 103, NULL, 'UCP006577', 275016),
(455923, 'PIRSF004761', NULL, NULL, 118, NULL, 'Hydrgn_mat_HypA', 275017),
(455924, 'PIRSF018506', NULL, NULL, 224, NULL, 'Prpndl_dhdrts_md', 275018),
(455925, 'PIRSF010611', NULL, NULL, 113, NULL, 'UCP010611', 275019),
(455926, 'PIRSF004008', NULL, NULL, 187, NULL, 'VAC_E3L', 275020),
(455927, 'PIRSF037162', NULL, NULL, 565, NULL, 'PRDM', 275021),
(455928, 'PIRSF004505', NULL, NULL, 160, NULL, 'MT_bac', 275022),
(455929, 'PIRSF018571', NULL, NULL, 300, NULL, 'SpoIIGA', 275023),
(455930, 'PIRSF003109', NULL, NULL, 348, NULL, 'RE_McrC', 275024),
(455931, 'PIRSF016315', NULL, NULL, 175, NULL, 'p21-ARC', 275025),
(455932, 'PIRSF001589', NULL, NULL, 608, NULL, 'Asn_synthetase_glu-h', 275026),
(455933, 'PIRSF037112', NULL, NULL, 321, NULL, 'ArdC', 275027),
(455934, 'PIRSF002845', NULL, NULL, 490, NULL, 'Ttrprl_mtas_MazG', 275028),
(455935, 'PIRSF036990', NULL, NULL, 233, NULL, 'UCP_CBS_BON', 275029),
(455936, 'PIRSF009324', NULL, NULL, 331, NULL, 'Cdk5_activator', 275030),
(455937, 'PIRSF006102', NULL, NULL, 210, NULL, 'NQR_DE', 275031),
(455938, 'PIRSF003135', NULL, NULL, 108, NULL, 'Primosomal_n', 275032),
(455939, 'PIRSF000381', NULL, NULL, 1200, NULL, 'Met_synth_MetH', 275033),
(455940, 'PIRSF036376', NULL, NULL, 1113, NULL, 'Corin', 275034),
(455941, 'PIRSF001043', NULL, NULL, 555, NULL, 'EG-B', 275035),
(455942, 'PIRSF031639', NULL, NULL, 523, NULL, 'Ccs4', 275036),
(455943, 'PIRSF037933', NULL, NULL, 849, NULL, 'Polyserase-2', 275037),
(455944, 'PIRSF005018', NULL, NULL, 156, NULL, 'UCP005018', 275038),
(455945, 'PIRSF005522', NULL, NULL, 483, NULL, 'UCP005522', 275039),
(455946, 'PIRSF030820', NULL, NULL, 172, NULL, 'UCP030820', 275040),
(455947, 'PIRSF038214', NULL, NULL, 188, NULL, 'ESCRT1_Vps37_fungi', 275041),
(455948, 'PIRSF031679', NULL, NULL, 275, NULL, 'Mtase_Alr7345', 275042),
(455949, 'PIRSF000127', NULL, NULL, 1331, NULL, 'Xanthine_dh', 275043),
(455950, 'PIRSF000938', NULL, NULL, 362, NULL, 'PTPN1_yeast', 275044),
(455951, 'PIRSF000409', NULL, NULL, 361, NULL, 'Ada', 275045),
(455952, 'PIRSF029509', NULL, NULL, 150, NULL, 'UCP029509', 275046),
(455953, 'PIRSF037256', NULL, NULL, 114, NULL, 'UCP037256', 275047),
(455954, 'PIRSF004977', NULL, NULL, 118, NULL, 'UCP004977', 275048),
(455955, 'PIRSF015730', NULL, NULL, 132, NULL, 'TFAR19', 275049),
(455956, 'PIRSF016821', NULL, NULL, 127, NULL, 'HSP15', 275050),
(455957, 'PIRSF000282', NULL, NULL, 62, NULL, 'COX7', 275051),
(455958, 'PIRSF034934', NULL, NULL, 318, NULL, 'AbiF_AbiD', 275052),
(455959, 'PIRSF035859', NULL, NULL, 583, NULL, 'ABC_tp_sb', 275053),
(455960, 'PIRSF031900', NULL, NULL, 342, NULL, 'UCP031900', 275054),
(455961, 'PIRSF002457', NULL, NULL, 481, NULL, 'DASS', 275055),
(455962, 'PIRSF037943', NULL, NULL, 238, NULL, 'SPAG7', 275056),
(455963, 'PIRSF028937', NULL, NULL, 729, NULL, 'Lg_Ch_AO', 275057),
(455964, 'PIRSF039087', NULL, NULL, 314, NULL, 'L10E', 275058),
(455965, 'PIRSF002412', NULL, NULL, 489, NULL, 'MA_DBI', 275059),
(455966, 'PIRSF010309', NULL, NULL, 174, NULL, 'Cyc-rich_prot', 275060);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(455967, 'PIRSF006230', NULL, NULL, 289, NULL, 'MG442', 275061),
(455968, 'PIRSF021288', NULL, NULL, 262, NULL, 'YmfK_ACT', 275062),
(455969, 'PIRSF005240', NULL, NULL, 603, NULL, 'CcmF', 275063),
(455970, 'PIRSF028438', NULL, NULL, 236, NULL, 'UCP028438', 275064),
(455971, 'PIRSF037692', NULL, NULL, 71, NULL, 'UCP037692', 275065),
(455972, 'PIRSF017205', NULL, NULL, 510, NULL, 'ERO', 275066),
(455973, 'PIRSF009151', NULL, NULL, 135, NULL, 'UCP009151', 275067),
(455974, 'PIRSF028153', NULL, NULL, 483, NULL, 'MshI', 275068),
(455975, 'PIRSF021292', NULL, NULL, 143, NULL, 'ComGD', 275069),
(455976, 'PIRSF007061', NULL, NULL, 107, NULL, 'UCP007061', 275070),
(455977, 'PIRSF036504', NULL, NULL, 212, NULL, 'NDK_H5', 275071),
(455978, 'PIRSF027887', NULL, NULL, 358, NULL, 'Amidohyd_027887', 275072),
(455979, 'PIRSF001430', NULL, NULL, 268, NULL, 'PSU-A', 275073),
(455980, 'PIRSF008881', NULL, NULL, 220, NULL, 'Fhx_P25', 275074),
(455981, 'PIRSF000138', NULL, NULL, 380, NULL, 'Al-hdrx_acd_dh', 275075),
(455982, 'PIRSF000094', NULL, NULL, 260, NULL, 'Enoyl-ACP_rdct', 275076),
(455983, 'PIRSF000071', NULL, NULL, 64, NULL, 'Rubredoxin', 275077),
(455984, 'PIRSF000294', NULL, NULL, 340, NULL, 'Cytochrome-c_peroxidase', 275078),
(455985, 'PIRSF003108', NULL, NULL, 89, NULL, 'DinJ', 275079),
(455986, 'PIRSF020196', NULL, NULL, 275, NULL, 'NS2', 275080),
(455987, 'PIRSF012150', NULL, NULL, 276, NULL, 'UCP012150', 275081),
(455988, 'PIRSF036893', NULL, NULL, 199, NULL, 'Lipocalin_ApoD', 275082),
(455989, 'PIRSF000897', NULL, NULL, 266, NULL, 'Acid_Ptase_ClsA', 275083),
(455990, 'PIRSF002590', NULL, NULL, 120, NULL, 'HSP9_HSP12', 275084),
(455991, 'PIRSF019217', NULL, NULL, 166, NULL, 'AcxC', 275085),
(455992, 'PIRSF000821', NULL, NULL, 1304, NULL, 'RdRPol', 275086),
(455993, 'PIRSF018978', NULL, NULL, 370, NULL, 'tRNA_m1G_Mtase_archaea', 275087),
(455994, 'PIRSF037375', NULL, NULL, 616, NULL, 'EstA', 275088),
(455995, 'PIRSF006268', NULL, NULL, 343, NULL, 'ApbE', 275089),
(455996, 'PIRSF016080', NULL, NULL, 288, NULL, 'RE_MboI', 275090),
(455997, 'PIRSF024492', NULL, NULL, 181, NULL, 'UCP024492', 275091),
(455998, 'PIRSF028836', NULL, NULL, 422, NULL, 'ISN1', 275092),
(455999, 'PIRSF000636', NULL, NULL, 1128, NULL, 'TyrPK_Jak', 275093),
(456000, 'PIRSF004395', NULL, NULL, 185, NULL, 'Tail_Z', 275094),
(456001, 'PIRSF004800', NULL, NULL, 1830, NULL, 'Hmw2', 275095),
(456002, 'PIRSF030962', NULL, NULL, 123, NULL, 'Dehydrase', 275096),
(456003, 'PIRSF000994', NULL, NULL, 246, NULL, 'RE_XhoI', 275097),
(456004, 'PIRSF011561', NULL, NULL, 178, NULL, 'PAD', 275098),
(456005, 'PIRSF003948', NULL, NULL, 270, NULL, 'N_TospoV', 275099),
(456006, 'PIRSF006643', NULL, NULL, 121, NULL, 'NDUA6', 275100),
(456007, 'PIRSF011503', NULL, NULL, 116, NULL, 'DdrB_PduH', 275101),
(456008, 'PIRSF006493', NULL, NULL, 290, NULL, 'Prok_Ku', 275102),
(456009, 'PIRSF002565', NULL, NULL, 61, NULL, 'Statherin', 275103),
(456010, 'PIRSF036514', NULL, NULL, 193, NULL, 'Sm_HSP_B1', 275104),
(456011, 'PIRSF006092', NULL, NULL, 161, NULL, 'GreA_GreB', 275105),
(456012, 'PIRSF016565', NULL, NULL, 459, NULL, 'PucC', 275106),
(456013, 'PIRSF032025', NULL, NULL, 144, NULL, 'UCP032025', 275107),
(456014, 'PIRSF038003', NULL, NULL, 337, NULL, 'PINCH', 275108),
(456015, 'PIRSF000660', NULL, NULL, 1665, NULL, 'STPK_GCN2', 275109),
(456016, 'PIRSF003230', NULL, NULL, 146, NULL, 'YbgC', 275110),
(456017, 'PIRSF017689', NULL, NULL, 486, NULL, 'SepSecS', 275111),
(456018, 'PIRSF003767', NULL, NULL, 269, NULL, 'VAC_I3L', 275112),
(456019, 'PIRSF501177', NULL, NULL, 418, NULL, 'BoxA', 275113),
(456020, 'PIRSF036612', NULL, NULL, 342, NULL, 'ABC_ATP_LytTR', 275114),
(456021, 'PIRSF028520', NULL, NULL, 171, NULL, 'UCP028520', 275115),
(456022, 'PIRSF030748', NULL, NULL, 234, NULL, 'Autotransporter_YhjY', 275116),
(456023, 'PIRSF018781', NULL, NULL, 154, NULL, 'UCP018781', 275117),
(456024, 'PIRSF029416', NULL, NULL, 109, NULL, 'UCP029416_PTP', 275118),
(456025, 'PIRSF016013', NULL, NULL, 192, NULL, 'AtER_Rer1p', 275119),
(456026, 'PIRSF003265', NULL, NULL, 97, NULL, 'TraQ', 275120);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(456027, 'PIRSF016753', NULL, NULL, 282, NULL, 'P_lipid/glycerol_ac_tran', 275121),
(456028, 'PIRSF015415', NULL, NULL, 591, NULL, 'COG8', 275122),
(456029, 'PIRSF001475', NULL, NULL, 302, NULL, 'Cyclophilin_E', 275123),
(456030, 'PIRSF002421', NULL, NULL, 372, NULL, 'L-selectin', 275124),
(456031, 'PIRSF037430', NULL, NULL, 177, NULL, 'Ribotoxin_alpha-sarcin', 275125),
(456032, 'PIRSF037561', NULL, NULL, 33, NULL, 'Pardaxin', 275126),
(456033, 'PIRSF021171', NULL, NULL, 143, NULL, 'UCP022271', 275127),
(456034, 'PIRSF028756', NULL, NULL, 284, NULL, 'PPK2', 275128),
(456035, 'PIRSF011386', NULL, NULL, 161, NULL, 'FixH', 275129),
(456036, 'PIRSF500313', NULL, NULL, 90, NULL, 'Bombyxin_B', 275130),
(456037, 'PIRSF003249', NULL, NULL, 44, NULL, 'PyrBI_leader_pep', 275131),
(456038, 'PIRSF000767', NULL, NULL, 575, NULL, 'Sigma_factor_SigC', 275132),
(456039, 'PIRSF007798', NULL, NULL, 223, NULL, 'UCP007798', 275133),
(456040, 'PIRSF001221', NULL, NULL, 547, NULL, 'Amidase_fungi', 275134),
(456041, 'PIRSF006716', NULL, NULL, 161, NULL, 'Spore_CotF', 275135),
(456042, 'PIRSF017222', NULL, NULL, 586, NULL, 'Transl_init_eIF2A', 275136),
(456043, 'PIRSF006470', NULL, NULL, 335, NULL, 'DctB', 275137),
(456044, 'PIRSF026389', NULL, NULL, 773, NULL, 'Ethylen_sen_hybr_HK', 275138),
(456045, 'PIRSF020565', NULL, NULL, 161, NULL, '3Ho_Ac_ACP_DH', 275139),
(456046, 'PIRSF000260', NULL, NULL, 120, NULL, 'FTRc', 275140),
(456047, 'PIRSF005355', NULL, NULL, 304, NULL, 'UBIAD1', 275141),
(456048, 'PIRSF029047', NULL, NULL, 244, NULL, 'KMTS', 275142),
(456049, 'PIRSF037923', NULL, NULL, 1129, NULL, 'UCP037923', 275143),
(456050, 'PIRSF002116', NULL, NULL, 244, NULL, 'RPS4a_RPS4e', 275144),
(456051, 'PIRSF037948', NULL, NULL, 442, NULL, 'ZMYND10', 275145),
(456052, 'PIRSF016509', NULL, NULL, 294, NULL, 'MtrE', 275146),
(456053, 'PIRSF011452', NULL, NULL, 384, NULL, 'UCP011452_HNH', 275147),
(456054, 'PIRSF017127', NULL, NULL, 1347, NULL, 'Condensin_D2', 275148),
(456055, 'PIRSF000574', NULL, NULL, 1145, NULL, 'STPK_PknK', 275149),
(456056, 'PIRSF000615', NULL, NULL, 990, NULL, 'TyrPK_CSF1-R', 275150),
(456057, 'PIRSF006305', NULL, NULL, 210, NULL, 'Maf', 275151),
(456058, 'PIRSF015625', NULL, NULL, 313, NULL, 'VAC_I1L', 275152),
(456059, 'PIRSF037900', NULL, NULL, 602, NULL, 'Subtilisin_rel_PfSUB_1', 275153),
(456060, 'PIRSF004546', NULL, NULL, 186, NULL, 'UCP004546', 275154),
(456061, 'PIRSF017209', NULL, NULL, 859, NULL, 'Memb_At2g17000', 275155),
(456062, 'PIRSF000797', NULL, NULL, 1186, NULL, 'DNA_pol_mitochondrial', 275156),
(456063, 'PIRSF005353', NULL, NULL, 446, NULL, 'PbuG', 275157),
(456064, 'PIRSF004857', NULL, NULL, 212, NULL, 'Kin_aa_kin', 275158),
(456065, 'PIRSF018168', NULL, NULL, 369, NULL, 'Beta-mannanase', 275159),
(456066, 'PIRSF037479', NULL, NULL, 458, NULL, 'Pg_GlcNAc_deacet', 275160),
(456067, 'PIRSF017190', NULL, NULL, 181, NULL, 'NIP7', 275161),
(456068, 'PIRSF500795', NULL, NULL, 478, NULL, 'Thiamine_transporter_2', 275162),
(456069, 'PIRSF017290', NULL, NULL, 249, NULL, 'ROT1', 275163),
(456070, 'PIRSF037844', NULL, NULL, 1408, NULL, 'Vpr-related_protease', 275164),
(456071, 'PIRSF007936', NULL, NULL, 122, NULL, 'SRB6', 275165),
(456072, 'PIRSF030283', NULL, NULL, 248, NULL, 'Small_HSP_plant', 275166),
(456073, 'PIRSF012565', NULL, NULL, 207, NULL, 'UCP012565', 275167),
(456074, 'PIRSF034005', NULL, NULL, 180, NULL, 'Omp19', 275168),
(456075, 'PIRSF009437', NULL, NULL, 263, NULL, 'NQR-1_subunit_C', 275169),
(456076, 'PIRSF037196', NULL, NULL, 334, NULL, 'PvcA', 275170),
(456077, 'PIRSF002773', NULL, NULL, 740, NULL, 'ABC_prm/ATPase_B', 275171),
(456078, 'PIRSF000830', NULL, NULL, 2210, NULL, 'L_ParamyxoV', 275172),
(456079, 'PIRSF005978', NULL, NULL, 171, NULL, 'HTH_MJ0621', 275173),
(456080, 'PIRSF006488', NULL, NULL, 84, NULL, 'ExoVII_small', 275174),
(456081, 'PIRSF036464', NULL, NULL, 703, NULL, 'Ser_ala_racem', 275175),
(456082, 'PIRSF022080', NULL, NULL, 102, NULL, 'UCP022080', 275176),
(456083, 'PIRSF002216', NULL, NULL, 110, NULL, 'MRPL31', 275177),
(456084, 'PIRSF038126', NULL, NULL, 408, NULL, 'SWI_SNF', 275178);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(456085, 'PIRSF007510', NULL, NULL, 182, NULL, 'UCP007510', 275179),
(456086, 'PIRSF500144', NULL, NULL, 266, NULL, 'IODI_III', 275180),
(456087, 'PIRSF027093', NULL, NULL, 629, NULL, 'EndopolyPtase_N1', 275181),
(456088, 'PIRSF007313', NULL, NULL, 370, NULL, 'PhnI', 275182),
(456089, 'PIRSF031982', NULL, NULL, 344, NULL, 'UCP031982_abhydr', 275183),
(456090, 'PIRSF015980', NULL, NULL, 669, NULL, 'VAC_O1L', 275184),
(456091, 'PIRSF037263', NULL, NULL, 66, NULL, 'UCP037263', 275185),
(456092, 'PIRSF000178', NULL, NULL, 140, NULL, 'SDH_cyt_b560', 275186),
(456093, 'PIRSF003950', NULL, NULL, 483, NULL, 'N_NairoV', 275187),
(456094, 'PIRSF036503', NULL, NULL, 376, NULL, 'NDK7', 275188),
(456095, 'PIRSF003953', NULL, NULL, 245, NULL, 'N_PhelboV', 275189),
(456096, 'PIRSF038034', NULL, NULL, 269, NULL, 'RFXANK', 275190),
(456097, 'PIRSF019239', NULL, NULL, 172, NULL, 'MrpE', 275191),
(456098, 'PIRSF000524', NULL, NULL, 394, NULL, 'SPT', 275192),
(456099, 'PIRSF037899', NULL, NULL, 1293, NULL, 'Subtilisin_rel_Moth_2364', 275193),
(456100, 'PIRSF037037', NULL, NULL, 585, NULL, 'Kelch_gigaxonin', 275194),
(456101, 'PIRSF003027', NULL, NULL, 461, NULL, 'Txn_fact_GATA-1/2/3', 275195),
(456102, 'PIRSF005053', NULL, NULL, 113, NULL, 'RNAP_F_arch', 275196),
(456103, 'PIRSF000277', NULL, NULL, 115, NULL, 'COX_VIa', 275197),
(456104, 'PIRSF005250', NULL, NULL, 1068, NULL, 'UCP005250', 275198),
(456105, 'PIRSF001587', NULL, NULL, 742, NULL, 'FGAM_synthase_II', 275199),
(456106, 'PIRSF018497', NULL, NULL, 349, NULL, 'V-ATP_synth_D', 275200),
(456107, 'PIRSF029407', NULL, NULL, 416, NULL, 'UCP029407', 275201),
(456108, 'PIRSF018300', NULL, NULL, 622, NULL, 'DNA_pol_alpha_2', 275202),
(456109, 'PIRSF034367', NULL, NULL, 341, NULL, 'UCP034367', 275203),
(456110, 'PIRSF006557', NULL, NULL, 128, NULL, 'UCP006557_sign', 275204),
(456111, 'PIRSF004338', NULL, NULL, 104, NULL, 'Integrase', 275205),
(456112, 'PIRSF038076', NULL, NULL, 159, NULL, 'US8A', 275206),
(456113, 'PIRSF020431', NULL, NULL, 117, NULL, 'NapD_delta/epsilon', 275207),
(456114, 'PIRSF037707', NULL, NULL, 175, NULL, 'TOM20', 275208),
(456115, 'PIRSF036578', NULL, NULL, 962, NULL, 'RFC1', 275209),
(456116, 'PIRSF000836', NULL, NULL, 2219, NULL, 'L_ArenaV', 275210),
(456117, 'PIRSF039096', NULL, NULL, 156, NULL, 'p16-ARC', 275211),
(456118, 'PIRSF023577', NULL, NULL, 304, NULL, 'NOSIP', 275212),
(456119, 'PIRSF037210', NULL, NULL, 417, NULL, 'TGM_prok', 275213),
(456120, 'PIRSF009471', NULL, NULL, 194, NULL, 'UCP009471', 275214),
(456121, 'PIRSF017854', NULL, NULL, 89, NULL, 'TrbD', 275215),
(456122, 'PIRSF007319', NULL, NULL, 263, NULL, 'UCP007319', 275216),
(456123, 'PIRSF021328', NULL, NULL, 138, NULL, 'UCP021328', 275217),
(456124, 'PIRSF035009', NULL, NULL, 359, NULL, 'UCP035009_HSDR_N', 275218),
(456125, 'PIRSF037187', NULL, NULL, 240, NULL, 'SmB_SmN', 275219),
(456126, 'PIRSF038095', NULL, NULL, 71, NULL, 'NDUA1', 275220),
(456127, 'PIRSF038134', NULL, NULL, 309, NULL, 'Toc33/toc34', 275221),
(456128, 'PIRSF500814', NULL, NULL, 285, NULL, 'PP1_GL', 275222),
(456129, 'PIRSF036599', NULL, NULL, 505, NULL, 'AtpPhos', 275223),
(456130, 'PIRSF032079', NULL, NULL, 179, NULL, 'UCP032079', 275224),
(456131, 'PIRSF002603', NULL, NULL, 443, NULL, 'TEF', 275225),
(456132, 'PIRSF018193', NULL, NULL, 139, NULL, 'UCP018193', 275226),
(456133, 'PIRSF016553', NULL, NULL, 784, NULL, 'BIGH3_OSF2', 275227),
(456134, 'PIRSF017233', NULL, NULL, 1279, NULL, 'IKAP', 275228),
(456135, 'PIRSF037118', NULL, NULL, 407, NULL, 'TerA', 275229),
(456136, 'PIRSF002279', NULL, NULL, 2507, NULL, 'Notch', 275230),
(456137, 'PIRSF000144', NULL, NULL, 770, NULL, 'CbbBc', 275231),
(456138, 'PIRSF009158', NULL, NULL, 158, NULL, 'UCP009158', 275232),
(456139, 'PIRSF015868', NULL, NULL, 383, NULL, 'HP0120', 275233),
(456140, 'PIRSF037392', NULL, NULL, 571, NULL, 'AMHRII', 275234),
(456141, 'PIRSF037565', NULL, NULL, 377, NULL, 'RRNA_m2G_Mtase_RsmD', 275235),
(456142, 'PIRSF037249', NULL, NULL, 373, NULL, 'Histone_Mtase_SET', 275236),
(456143, 'PIRSF030823', NULL, NULL, 645, NULL, 'UCP030823_PK_HhH', 275237); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(456144, 'PIRSF001072', NULL, NULL, 575, NULL, 'HN_paramyxo', 275238),
(456145, 'PIRSF000932', NULL, NULL, 698, NULL, 'PTPN12', 275239),
(456146, 'PIRSF000083', NULL, NULL, 67, NULL, 'Allophyco_linker', 275240),
(456147, 'PIRSF037205', NULL, NULL, 52, NULL, 'UCP037205', 275241),
(456148, 'PIRSF037852', NULL, NULL, 1246, NULL, 'Subtilisin_rel_SAV5721', 275242),
(456149, 'PIRSF033399', NULL, NULL, 121, NULL, 'UCP033399', 275243),
(456150, 'PIRSF038175', NULL, NULL, 948, NULL, 'MAPKKK14', 275244),
(456151, 'PIRSF002867', NULL, NULL, 317, NULL, 'CheV', 275245),
(456152, 'PIRSF000491', NULL, NULL, 681, NULL, 'Alt_phage', 275246),
(456153, 'PIRSF000471', NULL, NULL, 400, NULL, 'Alpha_GT', 275247),
(456154, 'PIRSF000102', NULL, NULL, 330, NULL, 'Lac_mal_DH', 275248),
(456155, 'PIRSF020467', NULL, NULL, 260, NULL, 'RE_Tsp45I', 275249),
(456156, 'PIRSF019260', NULL, NULL, 463, NULL, 'PBSX_XkdE', 275250),
(456157, 'PIRSF033722', NULL, NULL, 329, NULL, 'DnaD_CA_C3587', 275251),
(456158, 'PIRSF000025', NULL, NULL, 119, NULL, 'Cytochrome_Bsub_c550', 275252),
(456159, 'PIRSF002341', NULL, NULL, 3657, NULL, 'Dystrophin_utrophin', 275253),
(456160, 'PIRSF036979', NULL, NULL, 302, NULL, 'Arginase', 275254),
(456161, 'PIRSF006606', NULL, NULL, 125, NULL, 'UCP006606', 275255),
(456162, 'PIRSF037087', NULL, NULL, 148, NULL, 'UCP037087', 275256),
(456163, 'PIRSF016567', NULL, NULL, 561, NULL, 'IFNAR1', 275257),
(456164, 'PIRSF001024', NULL, NULL, 502, NULL, 'Alph-amyl_fung', 275258),
(456165, 'PIRSF005028', NULL, NULL, 165, NULL, 'KhtT', 275259),
(456166, 'PIRSF000732', NULL, NULL, 582, NULL, 'PTS_enzyme_I', 275260),
(456167, 'PIRSF037293', NULL, NULL, 791, NULL, 'ERdj5', 275261),
(456168, 'PIRSF000850', NULL, NULL, 452, NULL, 'PLD_PSS', 275262),
(456169, 'PIRSF004078', NULL, NULL, 219, NULL, 'Coat_ilarvirus', 275263),
(456170, 'PIRSF038928', NULL, NULL, 491, NULL, 'Catalase_clade1-3', 275264),
(456171, 'PIRSF029394', NULL, NULL, 133, NULL, 'UCP029394', 275265),
(456172, 'PIRSF037314', NULL, NULL, 468, NULL, 'HK_MctS', 275266),
(456173, 'PIRSF037097', NULL, NULL, 1110, NULL, 'AP4_epsilon', 275267),
(456174, 'PIRSF037744', NULL, NULL, 717, NULL, 'TIR_Ticam', 275268),
(456175, 'PIRSF028763', NULL, NULL, 311, NULL, 'RNAP3_C34/C39', 275269),
(456176, 'PIRSF002401', NULL, NULL, 381, NULL, 'GTP-binding_obg', 275270),
(456177, 'PIRSF022936', NULL, NULL, 199, NULL, 'RAD59_fungi', 275271),
(456178, 'PIRSF009325', NULL, NULL, 206, NULL, 'PTPRC-associated_protein', 275272),
(456179, 'PIRSF037816', NULL, NULL, 257, NULL, 'Viral_cyclin', 275273),
(456180, 'PIRSF006363', NULL, NULL, 218, NULL, 'UCP006363_ACT', 275274),
(456181, 'PIRSF036773', NULL, NULL, 247, NULL, 'HIRIP5', 275275),
(456182, 'PIRSF000384', NULL, NULL, 263, NULL, 'PNMTase', 275276),
(456183, 'PIRSF036406', NULL, NULL, 343, NULL, 'Hept_kin', 275277),
(456184, 'PIRSF015703', NULL, NULL, 229, NULL, 'UCP015703', 275278),
(456185, 'PIRSF011570', NULL, NULL, 335, NULL, 'SpoVAD', 275279),
(456186, 'PIRSF004862', NULL, NULL, 540, NULL, 'FliF', 275280),
(456187, 'PIRSF037332', NULL, NULL, 486, NULL, 'FucT_metazoa', 275281),
(456188, 'PIRSF000110', NULL, NULL, 501, NULL, 'G6PD', 275282),
(456189, 'PIRSF003107', NULL, NULL, 221, NULL, 'PhoU', 275283),
(456190, 'PIRSF005539', NULL, NULL, 301, NULL, 'F1_peptds', 275284),
(456191, 'PIRSF038896', NULL, NULL, 367, NULL, 'NAPE-PLD', 275285),
(456192, 'PIRSF001361', NULL, NULL, 360, NULL, 'DAHP_synthase', 275286),
(456193, 'PIRSF018266', NULL, NULL, 328, NULL, 'FecR', 275287),
(456194, 'PIRSF002371', NULL, NULL, 204, NULL, 'Alpha-s2-casein', 275288),
(456195, 'PIRSF003376', NULL, NULL, 366, NULL, 'VP1_PMV', 275289),
(456196, 'PIRSF004749', NULL, NULL, 221, NULL, 'Pep_def', 275290),
(456197, 'PIRSF031057', NULL, NULL, 286, NULL, 'TPK1', 275291),
(456198, 'PIRSF036539', NULL, NULL, 457, NULL, 'CmaT_thioesters', 275292),
(456199, 'PIRSF036641', NULL, NULL, 574, NULL, 'IMPase_NAD_kin', 275293),
(456200, 'PIRSF000075', NULL, NULL, 41, NULL, 'Desulforedoxin', 275294),
(456201, 'PIRSF007004', NULL, NULL, 125, NULL, 'UCP007004', 275295);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(456202, 'PIRSF007635', NULL, NULL, 642, NULL, 'Mmp_autolysin', 275296),
(456203, 'PIRSF037898', NULL, NULL, 1285, NULL, 'Subtilisin_rel_Sputw3181_3341', 275297),
(456204, 'PIRSF022145', NULL, NULL, 210, NULL, 'Sulfocyanin', 275298),
(456205, 'PIRSF007036', NULL, NULL, 111, NULL, 'Elb1', 275299),
(456206, 'PIRSF020408', NULL, NULL, 104, NULL, 'UCP020408', 275300),
(456207, 'PIRSF036557', NULL, NULL, 488, NULL, 'XdhA_RC', 275301),
(456208, 'PIRSF037834', NULL, NULL, 256, NULL, 'PaaC', 275302),
(456209, 'PIRSF009935', NULL, NULL, 102, NULL, 'TCTA', 275303),
(456210, 'PIRSF037354', NULL, NULL, 532, NULL, 'RtcR', 275304),
(456211, 'PIRSF009998', NULL, NULL, 97, NULL, 'DLC7', 275305),
(456212, 'PIRSF038151', NULL, NULL, 97, NULL, 'TOM9-2_plant', 275306),
(456213, 'PIRSF029895', NULL, NULL, 400, NULL, 'SpoIV', 275307),
(456214, 'PIRSF003097', NULL, NULL, 301, NULL, 'FtsX', 275308),
(456215, 'PIRSF000532', NULL, NULL, 333, NULL, 'ATP_PFK_prok', 275309),
(456216, 'PIRSF000036', NULL, NULL, 83, NULL, 'Cytochrome_PsbE', 275310),
(456217, 'PIRSF006291', NULL, NULL, 164, NULL, 'GspM', 275311),
(456218, 'PIRSF033860', NULL, NULL, 153, NULL, 'UCP033860', 275312),
(456219, 'PIRSF029727', NULL, NULL, 353, NULL, 'UCP029727', 275313),
(456220, 'PIRSF036636', NULL, NULL, 255, NULL, 'QcrC', 275314),
(456221, 'PIRSF005520', NULL, NULL, 136, NULL, 'UCP005520', 275315),
(456222, 'PIRSF028840', NULL, NULL, 402, NULL, 'MMP37', 275316),
(456223, 'PIRSF029958', NULL, NULL, 300, NULL, 'Necrosis-inducing_protein', 275317),
(456224, 'PIRSF000894', NULL, NULL, 450, NULL, 'Acid_Ptase', 275318),
(456225, 'PIRSF009288', NULL, NULL, 189, NULL, 'NDUB8', 275319),
(456226, 'PIRSF011489', NULL, NULL, 196, NULL, 'UCP011489', 275320),
(456227, 'PIRSF003093', NULL, NULL, 168, NULL, 'SulA', 275321),
(456228, 'PIRSF004555', NULL, NULL, 107, NULL, 'UCP004555', 275322),
(456229, 'PIRSF018867', NULL, NULL, 115, NULL, 'Na_decarb_PF0672', 275323),
(456230, 'PIRSF005198', NULL, NULL, 1195, NULL, 'SKI2', 275324),
(456231, 'PIRSF003278', NULL, NULL, 89, NULL, 'SopC', 275325),
(456232, 'PIRSF016021', NULL, NULL, 286, NULL, 'ESCAROLA', 275326),
(456233, 'PIRSF038023', NULL, NULL, 487, NULL, 'ANTXR2', 275327),
(456234, 'PIRSF027019', NULL, NULL, 357, NULL, 'Euk_LigT', 275328),
(456235, 'PIRSF000184', NULL, NULL, 1044, NULL, 'GDH_NAD', 275329),
(456236, 'PIRSF002356', NULL, NULL, 407, NULL, 'Calreticulin', 275330),
(456237, 'PIRSF018169', NULL, NULL, 514, NULL, 'PAF_acetylhydrolase', 275331),
(456238, 'PIRSF018503', NULL, NULL, 168, NULL, 'BMOH_MMO_gamma', 275332),
(456239, 'PIRSF000521', NULL, NULL, 483, NULL, 'Transaminase_4ab_Lys_Orn', 275333),
(456240, 'PIRSF016433', NULL, NULL, 234, NULL, 'Viral_DNA_prim', 275334),
(456241, 'PIRSF023925', NULL, NULL, 103, NULL, 'G0S2', 275335),
(456242, 'PIRSF028944', NULL, NULL, 815, NULL, 'Beta_gluc_GBA2', 275336),
(456243, 'PIRSF019663', NULL, NULL, 473, NULL, 'Legumain', 275337),
(456244, 'PIRSF038016', NULL, NULL, 427, NULL, 'Pin2_TRF1', 275338),
(456245, 'PIRSF000332', NULL, NULL, 533, NULL, 'FMO', 275339),
(456246, 'PIRSF000363', NULL, NULL, 278, NULL, 'Nitrogenase_iron', 275340),
(456247, 'PIRSF006821', NULL, NULL, 112, NULL, 'UCP006821', 275341),
(456248, 'PIRSF011312', NULL, NULL, 281, NULL, 'HUS1', 275342),
(456249, 'PIRSF036983', NULL, NULL, 387, NULL, 'UCP_2CBS_MJ1404', 275343),
(456250, 'PIRSF002869', NULL, NULL, 516, NULL, 'MviN', 275344),
(456251, 'PIRSF018747', NULL, NULL, 197, NULL, 'UCP018747', 275345),
(456252, 'PIRSF028538', NULL, NULL, 108, NULL, 'UCP028538', 275346),
(456253, 'PIRSF002629', NULL, NULL, 430, NULL, 'Txn_fact_POU_BRN', 275347),
(456254, 'PIRSF017479', NULL, NULL, 234, NULL, 'TRAPP_1_Trs31', 275348),
(456255, 'PIRSF028758', NULL, NULL, 260, NULL, 'Cyclin_C_H_G', 275349),
(456256, 'PIRSF029129', NULL, NULL, 344, NULL, 'UCP029129', 275350),
(456257, 'PIRSF026568', NULL, NULL, 126, NULL, 'UCP026568', 275351),
(456258, 'PIRSF008765', NULL, NULL, 140, NULL, 'PIG-P_GPI19', 275352),
(456259, 'PIRSF020728', NULL, NULL, 166, NULL, 'Fimbrin_SefA', 275353),
(456260, 'PIRSF000209', NULL, NULL, 1064, NULL, 'Bifunctional_P450_P450R', 275354);
INSERT INTO "PUBLIC"."MODEL" VALUES
(456261, 'PIRSF032370', NULL, NULL, 121, NULL, 'VraR', 275355),
(456262, 'PIRSF003338', NULL, NULL, 317, NULL, 'MAT1', 275356),
(456263, 'PIRSF000654', NULL, NULL, 461, NULL, 'ILK', 275357),
(456264, 'PIRSF031653', NULL, NULL, 95, NULL, 'UCP031653', 275358),
(456265, 'PIRSF011544', NULL, NULL, 134, NULL, 'NuiA', 275359),
(456266, 'PIRSF026567', NULL, NULL, 333, NULL, 'Adenine_mtase_bact', 275360),
(456267, 'PIRSF009180', NULL, NULL, 241, NULL, 'UCP009180', 275361),
(456268, 'PIRSF015200', NULL, NULL, 232, NULL, 'Cyclin_WDSV', 275362),
(456269, 'PIRSF006600', NULL, NULL, 152, NULL, 'UCP006600', 275363),
(456270, 'PIRSF036633', NULL, NULL, 400, NULL, 'FmdC_D', 275364),
(456271, 'PIRSF006105', NULL, NULL, 156, NULL, 'NapB', 275365),
(456272, 'PIRSF037258', NULL, NULL, 87, NULL, 'UCP037258', 275366),
(456273, 'PIRSF002937', NULL, NULL, 270, NULL, 'Res_reg_Spo0A', 275367),
(456274, 'PIRSF000567', NULL, NULL, 552, NULL, 'TYPK_Myt1', 275368),
(456275, 'PIRSF003314', NULL, NULL, 353, NULL, 'IPP_isomerase_FMN-dep', 275369),
(456276, 'PIRSF000006', NULL, NULL, 303, NULL, 'Cbb3-Cox_fixP', 275370),
(456277, 'PIRSF038097', NULL, NULL, 85, NULL, 'V-ATP_synth_e1/e2', 275371),
(456278, 'PIRSF034217', NULL, NULL, 144, NULL, 'UCP_Mll2898', 275372),
(456279, 'PIRSF037299', NULL, NULL, 443, NULL, 'CRH1', 275373),
(456280, 'PIRSF021940', NULL, NULL, 131, NULL, 'UCP021940', 275374),
(456281, 'PIRSF013370', NULL, NULL, 170, NULL, 'ACPS', 275375),
(456282, 'PIRSF021361', NULL, NULL, 150, NULL, 'UCP021361', 275376),
(456283, 'PIRSF026166', NULL, NULL, 340, NULL, 'UCP026166', 275377),
(456284, 'PIRSF000032', NULL, NULL, 215, NULL, 'Cytochrome_b6', 275378),
(456285, 'PIRSF037903', NULL, NULL, 458, NULL, 'Subtilisin_rel_GFO_2223', 275379),
(456286, 'PIRSF001815', NULL, NULL, 156, NULL, 'Vasopressin_oxytocin', 275380),
(456287, 'PIRSF005715', NULL, NULL, 582, NULL, 'VPS45_Sec1', 275381),
(456288, 'PIRSF029811', NULL, NULL, 197, NULL, 'UCP029811', 275382),
(456289, 'PIRSF006594', NULL, NULL, 215, NULL, 'UCP006594', 275383),
(456290, 'PIRSF001770', NULL, NULL, 515, NULL, 'Cyclin_CLN', 275384),
(456291, 'PIRSF018326', NULL, NULL, 329, NULL, 'VP35_FiloV', 275385),
(456292, 'PIRSF005211', NULL, NULL, 434, NULL, 'Ab_hydro_YheT', 275386),
(456293, 'PIRSF005586', NULL, NULL, 114, NULL, 'RNApol_RpoM', 275387),
(456294, 'PIRSF008455', NULL, NULL, 163, NULL, 'UCP008455', 275388),
(456295, 'PIRSF001355', NULL, NULL, 353, NULL, 'SAM_decarbox_euk', 275389),
(456296, 'PIRSF005052', NULL, NULL, 288, NULL, 'P-loop_kin_YhbJ', 275390),
(456297, 'PIRSF001959', NULL, NULL, 508, NULL, 'EPO_receptor', 275391),
(456298, 'PIRSF036960', NULL, NULL, 922, NULL, 'Neuropilin', 275392),
(456299, 'PIRSF036531', NULL, NULL, 142, NULL, 'Tpp15', 275393),
(456300, 'PIRSF037532', NULL, NULL, 739, NULL, 'HK_NtrY', 275394),
(456301, 'PIRSF000883', NULL, NULL, 242, NULL, 'Pesterase_MJ0912', 275395),
(456302, 'PIRSF003048', NULL, NULL, 827, NULL, 'Hist_acetylase_PCAF', 275396),
(456303, 'PIRSF017834', NULL, NULL, 119, NULL, 'NDUC2', 275397),
(456304, 'PIRSF003025', NULL, NULL, 157, NULL, 'Transl_init_eIF5A', 275398),
(456305, 'PIRSF037125', NULL, NULL, 461, NULL, 'Nob1', 275399),
(456306, 'PIRSF500939', NULL, NULL, 440, NULL, 'ERR1-2-3', 275400),
(456307, 'PIRSF038083', NULL, NULL, 326, NULL, 'UCP038083_GIPC', 275401),
(456308, 'PIRSF037403', NULL, NULL, 449, NULL, 'BMP3/GDF10', 275402),
(456309, 'PIRSF035823', NULL, NULL, 841, NULL, 'VirD5_Agrobacterium', 275403),
(456310, 'PIRSF026583', NULL, NULL, 659, NULL, 'YybT', 275404),
(456311, 'PIRSF038945', NULL, NULL, 360, NULL, 'Thr_synthase', 275405),
(456312, 'PIRSF016551', NULL, NULL, 231, NULL, 'SAS5/TFIID_14', 275406),
(456313, 'PIRSF033328', NULL, NULL, 237, NULL, 'Phest_Mll4975', 275407),
(456314, 'PIRSF006078', NULL, NULL, 380, NULL, 'GlxK', 275408),
(456315, 'PIRSF035836', NULL, NULL, 275, NULL, 'UCP035836', 275409),
(456316, 'PIRSF029693', NULL, NULL, 356, NULL, 'UCP029693', 275410),
(456317, 'PIRSF009310', NULL, NULL, 205, NULL, 'Mtase_NodS', 275411),
(456318, 'PIRSF005557', NULL, NULL, 384, NULL, 'Sialyl_trans', 275412);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(456319, 'PIRSF002674', NULL, NULL, 265, NULL, 'VSP', 275413),
(456320, 'PIRSF022207', NULL, NULL, 158, NULL, 'UCP022207', 275414),
(456321, 'PIRSF038193', NULL, NULL, 526, NULL, 'Hyaluronidase', 275415),
(456322, 'PIRSF004357', NULL, NULL, 301, NULL, 'MCP_bIL170', 275416),
(456323, 'PIRSF029256', NULL, NULL, 155, NULL, 'SpoU_TrmH', 275417),
(456324, 'PIRSF037677', NULL, NULL, 1246, NULL, 'Msh6', 275418),
(456325, 'PIRSF019455', NULL, NULL, 134, NULL, 'CopR_AtkY', 275419),
(456326, 'PIRSF018417', NULL, NULL, 559, NULL, 'FACC_protein', 275420),
(456327, 'PIRSF005790', NULL, NULL, 111, NULL, 'Nitrogenase_stabiliz_NifW', 275421),
(456328, 'PIRSF019307', NULL, NULL, 173, NULL, 'UCP019307', 275422),
(456329, 'PIRSF024534', NULL, NULL, 165, NULL, 'ThiW', 275423),
(456330, 'PIRSF004983', NULL, NULL, 578, NULL, 'MenD', 275424),
(456331, 'PIRSF026532', NULL, NULL, 292, NULL, 'Mtx2_tox', 275425),
(456332, 'PIRSF033729', NULL, NULL, 209, NULL, 'UCP033729', 275426),
(456333, 'PIRSF036918', NULL, NULL, 607, NULL, 'Maltodextrin_glucosidase', 275427),
(456334, 'PIRSF005091', NULL, NULL, 637, NULL, 'Mmb_sulf_HI1246', 275428),
(456335, 'PIRSF028788', NULL, NULL, 213, NULL, 'TfoX_Sxy', 275429),
(456336, 'PIRSF028973', NULL, NULL, 319, NULL, 'DcpS', 275430),
(456337, 'PIRSF032817', NULL, NULL, 242, NULL, 'UCP032817', 275431),
(456338, 'PIRSF003271', NULL, NULL, 125, NULL, 'TrbF', 275432),
(456339, 'PIRSF016210', NULL, NULL, 268, NULL, 'UCP016210', 275433),
(456340, 'PIRSF006223', NULL, NULL, 109, NULL, 'DsrC_TusE', 275434),
(456341, 'PIRSF000554', NULL, NULL, 593, NULL, 'PKC_zeta', 275435),
(456342, 'PIRSF009374', NULL, NULL, 453, NULL, 'RUNX_CBFa', 275436),
(456343, 'PIRSF005457', NULL, NULL, 259, NULL, 'Glx', 275437),
(456344, 'PIRSF001488', NULL, NULL, 206, NULL, 'Tdi_protein', 275438),
(456345, 'PIRSF003167', NULL, NULL, 630, NULL, 'HK_NarX/NarQ', 275439),
(456346, 'PIRSF018953', NULL, NULL, 410, NULL, 'UCP018953', 275440),
(456347, 'PIRSF000233', NULL, NULL, 903, NULL, 'Nitr_rd_NADH', 275441),
(456348, 'PIRSF014774', NULL, NULL, 316, NULL, 'YdgH', 275442),
(456349, 'PIRSF000779', NULL, NULL, 149, NULL, 'RPB8', 275443),
(456350, 'PIRSF024009', NULL, NULL, 236, NULL, 'UCP024009', 275444),
(456351, 'PIRSF001924', NULL, NULL, 314, NULL, 'Shigella_toxin', 275445),
(456352, 'PIRSF002583', NULL, NULL, 717, NULL, 'HSP90_HTPG', 275446),
(456353, 'PIRSF012293', NULL, NULL, 477, NULL, 'EutA', 275447),
(456354, 'PIRSF001092', NULL, NULL, 475, NULL, 'Alpha-L-fucosidase', 275448),
(456355, 'PIRSF018505', NULL, NULL, 168, NULL, 'Prpndl_dhdrts_sm', 275449),
(456356, 'PIRSF000657', NULL, NULL, 299, NULL, 'STPK_ASFV', 275450),
(456357, 'PIRSF037930', NULL, NULL, 678, NULL, 'K_endopeptidase', 275451),
(456358, 'PIRSF026169', NULL, NULL, 219, NULL, 'UCP026169', 275452),
(456359, 'PIRSF037875', NULL, NULL, 479, NULL, 'EpiP_NisP_MutP', 275453),
(456360, 'PIRSF036696', NULL, NULL, 402, NULL, 'ACY-1', 275454),
(456361, 'PIRSF000106', NULL, NULL, 572, NULL, 'ME', 275455),
(456362, 'PIRSF038157', NULL, NULL, 254, NULL, 'Cpn21', 275456),
(456363, 'PIRSF036105', NULL, NULL, 642, NULL, 'VirE3_Rhizobiaceae', 275457),
(456364, 'PIRSF000474', NULL, NULL, 528, NULL, 'GM2_GD2_synthase', 275458),
(456365, 'PIRSF030219', NULL, NULL, 297, NULL, 'Heme_oxygenase_decyc_plant', 275459),
(456366, 'PIRSF004954', NULL, NULL, 357, NULL, 'Radical_SAM', 275460),
(456367, 'PIRSF005518', NULL, NULL, 108, NULL, 'MtrB', 275461),
(456368, 'PIRSF001604', NULL, NULL, 681, NULL, 'LigA', 275462),
(456369, 'PIRSF034077', NULL, NULL, 128, NULL, 'UCP034077', 275463),
(456370, 'PIRSF000007', NULL, NULL, 279, NULL, 'Ubiq_cycred_cyc', 275464),
(456371, 'PIRSF036565', NULL, NULL, 568, NULL, 'Pyruvt_ip_decrb', 275465),
(456372, 'PIRSF019709', NULL, NULL, 241, NULL, 'MtxX', 275466),
(456373, 'PIRSF038098', NULL, NULL, 385, NULL, 'SOX-12/11/4a', 275467),
(456374, 'PIRSF009226', NULL, NULL, 286, NULL, 'UCP009226_DNArpr', 275468),
(456375, 'PIRSF002148', NULL, NULL, 87, NULL, 'RPS21e', 275469),
(456376, 'PIRSF037756', NULL, NULL, 292, NULL, 'MyD88', 275470),
(456377, 'PIRSF005785', NULL, NULL, 184, NULL, 'Zn-prot_arch', 275471);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(456378, 'PIRSF009103', NULL, NULL, 155, NULL, 'Ivy', 275472),
(456379, 'PIRSF012622', NULL, NULL, 179, NULL, 'UCP012622', 275473),
(456380, 'PIRSF016481', NULL, NULL, 171, NULL, 'PilP_PilQ', 275474),
(456381, 'PIRSF018654', NULL, NULL, 364, NULL, 'Fe-S_or_NB_arc', 275475),
(456382, 'PIRSF033018', NULL, NULL, 380, NULL, 'EspD', 275476),
(456383, 'PIRSF038148', NULL, NULL, 403, NULL, 'Rmt2', 275477),
(456384, 'PIRSF036874', NULL, NULL, 682, NULL, 'GPC_FiloV', 275478),
(456385, 'PIRSF016195', NULL, NULL, 173, NULL, 'UCP016195', 275479),
(456386, 'PIRSF005413', NULL, NULL, 200, NULL, 'COX11', 275480),
(456387, 'PIRSF011859', NULL, NULL, 185, NULL, 'TNFR_17_CD269', 275481),
(456388, 'PIRSF000699', NULL, NULL, 110, NULL, 'PTS_IILac_III', 275482),
(456389, 'PIRSF001555', NULL, NULL, 329, NULL, 'Asp_ammon_ligase', 275483),
(456390, 'PIRSF000207', NULL, NULL, 609, NULL, 'SiR-FP_CysJ', 275484),
(456391, 'PIRSF003407', NULL, NULL, 102, NULL, 'Trans_E7_PLV', 275485),
(456392, 'PIRSF017434', NULL, NULL, 488, NULL, 'NT5C2', 275486),
(456393, 'PIRSF037473', NULL, NULL, 1003, NULL, 'BLOC2_Hps3', 275487),
(456394, 'PIRSF037839', NULL, NULL, 205, NULL, 'RNase_H', 275488),
(456395, 'PIRSF037759', NULL, NULL, 281, NULL, 'Asf1', 275489),
(456396, 'PIRSF038927', NULL, NULL, 701, NULL, 'Catalase_clade2', 275490),
(456397, 'PIRSF017029', NULL, NULL, 86, NULL, 'SRP9', 275491),
(456398, 'PIRSF023381', NULL, NULL, 258, NULL, 'Mpdu1', 275492),
(456399, 'PIRSF038153', NULL, NULL, 430, NULL, 'WRKY_txn_fact_IIe', 275493),
(456400, 'PIRSF001495', NULL, NULL, 483, NULL, 'Met_asp_mut_epsi', 275494),
(456401, 'PIRSF036402', NULL, NULL, 158, NULL, 'Ureas_acces_UreE', 275495),
(456402, 'PIRSF000077', NULL, NULL, 107, NULL, 'Thioredoxin', 275496),
(456403, 'PIRSF000972', NULL, NULL, 613, NULL, 'Arylsulf_plant', 275497),
(456404, 'PIRSF011237', NULL, NULL, 281, NULL, 'GpU', 275498),
(456405, 'PIRSF007312', NULL, NULL, 149, NULL, 'Inner_mem_YidI', 275499),
(456406, 'PIRSF036592', NULL, NULL, 396, NULL, 'Methlestr_CheB', 275500),
(456407, 'PIRSF004729', NULL, NULL, 459, NULL, 'MutL', 275501),
(456408, 'PIRSF001426', NULL, NULL, 207, NULL, 'NHase_alpha', 275502),
(456409, 'PIRSF032162', NULL, NULL, 171, NULL, 'UCP032162_imp', 275503),
(456410, 'PIRSF000009', NULL, NULL, 206, NULL, 'Cytochrome_c551', 275504),
(456411, 'PIRSF019454', NULL, NULL, 165, NULL, 'UCP019454_CBS_PAB0389', 275505),
(456412, 'PIRSF039073', NULL, NULL, 2149, NULL, 'BRR2', 275506),
(456413, 'PIRSF003401', NULL, NULL, 44, NULL, 'Trans_E5_PLV', 275507),
(456414, 'PIRSF037149', NULL, NULL, 840, NULL, 'NirB', 275508),
(456415, 'PIRSF006334', NULL, NULL, 288, NULL, 'Cdd_plus_pseudo', 275509),
(456416, 'PIRSF008716', NULL, NULL, 165, NULL, 'Ufc1', 275510),
(456417, 'PIRSF031088', NULL, NULL, 544, NULL, 'UCP031088_abhydr', 275511),
(456418, 'PIRSF038995', NULL, NULL, 602, NULL, 'SRP68', 275512),
(456419, 'PIRSF005799', NULL, NULL, 376, NULL, 'UDP-gal_transpt', 275513),
(456420, 'PIRSF006503', NULL, NULL, 189, NULL, 'UCP006503', 275514),
(456421, 'PIRSF005636', NULL, NULL, 160, NULL, 'McrD', 275515),
(456422, 'PIRSF037575', NULL, NULL, 143, NULL, 'SBP', 275516),
(456423, 'PIRSF000853', NULL, NULL, 883, NULL, 'PPDK', 275517),
(456424, 'PIRSF000774', NULL, NULL, 466, NULL, 'RpoN', 275518),
(456425, 'PIRSF006336', NULL, NULL, 645, NULL, 'B-gal', 275519),
(456426, 'PIRSF000803', NULL, NULL, 537, NULL, 'DNA_pol_II_small_arch', 275520),
(456427, 'PIRSF002133', NULL, NULL, 126, NULL, 'RPS12p_RPS12a_RPS23e_RPS12o', 275521),
(456428, 'PIRSF015558', NULL, NULL, 296, NULL, 'Txn_reg_DeoR', 275522),
(456429, 'PIRSF032656', NULL, NULL, 902, NULL, 'Glycosylhydrolase_', 275523),
(456430, 'PIRSF000157', NULL, NULL, 947, NULL, 'Oxoglu_dh_E1', 275524),
(456431, 'PIRSF015982', NULL, NULL, 225, NULL, 'VAC_M2L', 275525),
(456432, 'PIRSF006483', NULL, NULL, 293, NULL, 'Membrane_protein_YitT', 275526),
(456433, 'PIRSF006704', NULL, NULL, 320, NULL, 'TFIIS', 275527),
(456434, 'PIRSF011576', NULL, NULL, 102, NULL, 'YabP', 275528),
(456435, 'PIRSF036836', NULL, NULL, 335, NULL, 'SBP1_RNase_bind', 275529);
INSERT INTO "PUBLIC"."MODEL" VALUES
(456436, 'PIRSF009427', NULL, NULL, 948, NULL, 'UCP009427_DNAmts', 275530),
(456437, 'PIRSF036298', NULL, NULL, 305, NULL, 'FDH_4Fe4S', 275531),
(456438, 'PIRSF002572', NULL, NULL, 147, NULL, 'PIP-GCDFP-15', 275532),
(456439, 'PIRSF030150', NULL, NULL, 249, NULL, 'SrtB', 275533),
(456440, 'PIRSF000194', NULL, NULL, 170, NULL, 'DHFR', 275534),
(456441, 'PIRSF037369', NULL, NULL, 850, NULL, 'STPK_unc51', 275535),
(456442, 'PIRSF006614', NULL, NULL, 144, NULL, 'Methylglyox_syn', 275536),
(456443, 'PIRSF000196', NULL, NULL, 306, NULL, 'Pro_dehydrog', 275537),
(456444, 'PIRSF001152', NULL, NULL, 714, NULL, 'HGF_MST1', 275538),
(456445, 'PIRSF022260', NULL, NULL, 361, NULL, 'UCP022260', 275539),
(456446, 'PIRSF000376', NULL, NULL, 467, NULL, 'ACDS_gamma', 275540),
(456447, 'PIRSF002756', NULL, NULL, 370, NULL, 'PstS', 275541),
(456448, 'PIRSF018249', NULL, NULL, 282, NULL, 'MyrA', 275542),
(456449, 'PIRSF011769', NULL, NULL, 401, NULL, 'RAD17', 275543),
(456450, 'PIRSF017349', NULL, NULL, 137, NULL, 'UCP017349', 275544),
(456451, 'PIRSF006118', NULL, NULL, 176, NULL, 'KDO8-P_Ptase', 275545),
(456452, 'PIRSF010631', NULL, NULL, 926, NULL, 'A-rhamnsds', 275546),
(456453, 'PIRSF005508', NULL, NULL, 359, NULL, 'Arsen_res_ArsB', 275547),
(456454, 'PIRSF036949', NULL, NULL, 272, NULL, 'RPA32', 275548),
(456455, 'PIRSF001786', NULL, NULL, 171, NULL, 'StpA_StpB', 275549),
(456456, 'PIRSF012943', NULL, NULL, 321, NULL, 'UCP012943', 275550),
(456457, 'PIRSF006453', NULL, NULL, 570, NULL, 'FwdA', 275551),
(456458, 'PIRSF028977', NULL, NULL, 746, NULL, 'Noc3', 275552),
(456459, 'PIRSF001997', NULL, NULL, 550, NULL, 'PTPRR', 275553),
(456460, 'PIRSF037254', NULL, NULL, 177, NULL, 'Gremlin', 275554),
(456461, 'PIRSF037712', NULL, NULL, 124, NULL, 'TIP-1', 275555),
(456462, 'PIRSF018982', NULL, NULL, 263, NULL, 'EutC', 275556),
(456463, 'PIRSF028345', NULL, NULL, 180, NULL, 'UCP028345', 275557),
(456464, 'PIRSF001653', NULL, NULL, 211, NULL, 'API-B', 275558),
(456465, 'PIRSF000705', NULL, NULL, 226, NULL, 'DNK', 275559),
(456466, 'PIRSF016104', NULL, NULL, 297, NULL, 'PIG-C', 275560),
(456467, 'PIRSF009400', NULL, NULL, 411, NULL, 'Hedgehog', 275561),
(456468, 'PIRSF012296', NULL, NULL, 116, NULL, 'EutS_PduU', 275562),
(456469, 'PIRSF029195', NULL, NULL, 259, NULL, 'UCP029195_PTS_EIIA2', 275563),
(456470, 'PIRSF037429', NULL, NULL, 284, NULL, 'UCP037429', 275564),
(456471, 'PIRSF017020', NULL, NULL, 345, NULL, 'ASTE', 275565),
(456472, 'PIRSF036704', NULL, NULL, 69, NULL, 'UCP036704', 275566),
(456473, 'PIRSF019205', NULL, NULL, 354, NULL, 'UCP019205_transporter', 275567),
(456474, 'PIRSF013684', NULL, NULL, 721, NULL, 'BBS2', 275568),
(456475, 'PIRSF035040', NULL, NULL, 211, NULL, 'UCP_CBS_Lmo0553', 275569),
(456476, 'PIRSF030791', NULL, NULL, 170, NULL, 'UCP030791', 275570),
(456477, 'PIRSF039026', NULL, NULL, 360, NULL, 'SiaP', 275571),
(456478, 'PIRSF006588', NULL, NULL, 349, NULL, 'TyrRS_arch_euk', 275572),
(456479, 'PIRSF012637', NULL, NULL, 215, NULL, 'UCP012637', 275573),
(456480, 'PIRSF017246', NULL, NULL, 187, NULL, 'TFIID_TAF10', 275574),
(456481, 'PIRSF004155', NULL, NULL, 84, NULL, 'Phage_C', 275575),
(456482, 'PIRSF001775', NULL, NULL, 578, NULL, 'Thrombomodulin', 275576),
(456483, 'PIRSF004532', NULL, NULL, 321, NULL, 'GlpX', 275577),
(456484, 'PIRSF000788', NULL, NULL, 1056, NULL, 'DNA_pol_ADV', 275578),
(456485, 'PIRSF002551', NULL, NULL, 440, NULL, 'Hemopexin', 275579),
(456486, 'PIRSF037343', NULL, NULL, 616, NULL, 'PTSIIBC_sugar', 275580),
(456487, 'PIRSF036659', NULL, NULL, 144, NULL, 'BdbC', 275581),
(456488, 'PIRSF036687', NULL, NULL, 861, NULL, 'AcnB', 275582),
(456489, 'PIRSF005758', NULL, NULL, 283, NULL, 'Shikimt_kin_arch', 275583),
(456490, 'PIRSF001123', NULL, NULL, 359, NULL, 'PepA_GA', 275584),
(456491, 'PIRSF001213', NULL, NULL, 263, NULL, 'MCP', 275585),
(456492, 'PIRSF500216', NULL, NULL, 391, NULL, 'DltB', 275586),
(456493, 'PIRSF003962', NULL, NULL, 1684, NULL, 'M_poly_NairoV', 275587),
(456494, 'PIRSF038992', NULL, NULL, 271, NULL, 'Aldolase_Ia', 275588),
(456495, 'PIRSF000611', NULL, NULL, 790, NULL, 'STPK_MPS1', 275589);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(456496, 'PIRSF011124', NULL, NULL, 104, NULL, 'MRP63', 275590),
(456497, 'PIRSF018327', NULL, NULL, 326, NULL, 'VP40_FiloV', 275591),
(456498, 'PIRSF002466', NULL, NULL, 145, NULL, 'Glycophorin', 275592),
(456499, 'PIRSF020634', NULL, NULL, 206, NULL, 'TerY_vWA', 275593),
(456500, 'PIRSF000185', NULL, NULL, 419, NULL, 'Glu_DH', 275594),
(456501, 'PIRSF005243', NULL, NULL, 404, NULL, 'ROO', 275595),
(456502, 'PIRSF015629', NULL, NULL, 566, NULL, 'VAC_E6R', 275596),
(456503, 'PIRSF005902', NULL, NULL, 337, NULL, 'DNase_TatD', 275597),
(456504, 'PIRSF023869', NULL, NULL, 246, NULL, 'MED6_meta/plant', 275598),
(456505, 'PIRSF003113', NULL, NULL, 125, NULL, 'BolA', 275599),
(456506, 'PIRSF038163', NULL, NULL, 547, NULL, 'ITPK_unchar_domain', 275600),
(456507, 'PIRSF019678', NULL, NULL, 184, NULL, 'UCP019678', 275601),
(456508, 'PIRSF000081', NULL, NULL, 166, NULL, 'Phycocyanin', 275602),
(456509, 'PIRSF004923', NULL, NULL, 156, NULL, 'RseC', 275603),
(456510, 'PIRSF016938', NULL, NULL, 199, NULL, 'RseA', 275604),
(456511, 'PIRSF036577', NULL, NULL, 308, NULL, 'PDH_ADH_plant', 275605),
(456512, 'PIRSF037350', NULL, NULL, 480, NULL, 'Mtase_ZK1128', 275606),
(456513, 'PIRSF003945', NULL, NULL, 1139, NULL, 'M_poly_HantaV', 275607),
(456514, 'PIRSF003092', NULL, NULL, 286, NULL, 'MinD', 275608),
(456515, 'PIRSF018688', NULL, NULL, 302, NULL, 'UCP018688', 275609),
(456516, 'PIRSF008757', NULL, NULL, 168, NULL, 'UCP008757', 275610),
(456517, 'PIRSF000711', NULL, NULL, 408, NULL, 'PFK27', 275611),
(456518, 'PIRSF007858', NULL, NULL, 432, NULL, 'ORC4', 275612),
(456519, 'PIRSF038084', NULL, NULL, 433, NULL, 'HAT1', 275613),
(456520, 'PIRSF004572', NULL, NULL, 170, NULL, 'SecM', 275614),
(456521, 'PIRSF036951', NULL, NULL, 430, NULL, 'Mas1', 275615),
(456522, 'PIRSF019169', NULL, NULL, 357, NULL, 'Tfp_PilM', 275616),
(456523, 'PIRSF010386', NULL, NULL, 558, NULL, 'RocB', 275617),
(456524, 'PIRSF036572', NULL, NULL, 140, NULL, 'RPP20', 275618),
(456525, 'PIRSF000952', NULL, NULL, 1275, NULL, 'PLC-gamma', 275619),
(456526, 'PIRSF012569', NULL, NULL, 362, NULL, 'UCP012569', 275620),
(456527, 'PIRSF500207', NULL, NULL, 240, NULL, 'MtrA', 275621),
(456528, 'PIRSF037881', NULL, NULL, 411, NULL, 'Leupaxin', 275622),
(456529, 'PIRSF000137', NULL, NULL, 612, NULL, 'Alcohol_oxidase', 275623),
(456530, 'PIRSF038001', NULL, NULL, 417, NULL, 'Caspase_ICE', 275624),
(456531, 'PIRSF005067', NULL, NULL, 221, NULL, 'Tma_RNA-bind', 275625),
(456532, 'PIRSF005788', NULL, NULL, 158, NULL, 'NifK', 275626),
(456533, 'PIRSF005229', NULL, NULL, 351, NULL, 'AO', 275627),
(456534, 'PIRSF015697', NULL, NULL, 202, NULL, 'UCP015697', 275628),
(456535, 'PIRSF000242', NULL, NULL, 570, NULL, 'HAO', 275629),
(456536, 'PIRSF037635', NULL, NULL, 92, NULL, 'BID3', 275630),
(456537, 'PIRSF002721', NULL, NULL, 156, NULL, 'Surface_antigen_Rickettsia', 275631),
(456538, 'PIRSF004094', NULL, NULL, 198, NULL, 'Coat_SV', 275632),
(456539, 'PIRSF000812', NULL, NULL, 285, NULL, 'AAD', 275633),
(456540, 'PIRSF001356', NULL, NULL, 267, NULL, 'SAM_decarboxylas', 275634),
(456541, 'PIRSF007580', NULL, NULL, 295, NULL, 'UCP07580', 275635),
(456542, 'PIRSF019574', NULL, NULL, 361, NULL, 'Periplasmic_polyamine_BP', 275636),
(456543, 'PIRSF005897', NULL, NULL, 390, NULL, 'RR_PatA', 275637),
(456544, 'PIRSF028304', NULL, NULL, 622, NULL, 'UCP028304', 275638),
(456545, 'PIRSF010521', NULL, NULL, 203, NULL, 'Secr_Zn_protease', 275639),
(456546, 'PIRSF027717', NULL, NULL, 289, NULL, 'H4K20_HMTase', 275640),
(456547, 'PIRSF014405', NULL, NULL, 129, NULL, 'UCP014405', 275641),
(456548, 'PIRSF000948', NULL, NULL, 641, NULL, 'Sphingomyelin_Pdiesterase', 275642),
(456549, 'PIRSF032437', NULL, NULL, 175, NULL, 'UCP032437', 275643),
(456550, 'PIRSF011468', NULL, NULL, 291, NULL, 'PhnJ', 275644),
(456551, 'PIRSF001257', NULL, NULL, 864, NULL, 'HIS4', 275645),
(456552, 'PIRSF015626', NULL, NULL, 276, NULL, 'FdhD', 275646),
(456553, 'PIRSF036585', NULL, NULL, 125, NULL, 'EchD', 275647),
(456554, 'PIRSF006523', NULL, NULL, 73, NULL, 'MtrF', 275648),
(456555, 'PIRSF038142', NULL, NULL, 262, NULL, 'Rhodopsin_bac', 275649);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(456556, 'PIRSF033271', NULL, NULL, 402, NULL, 'UCP033271', 275650),
(456557, 'PIRSF011572', NULL, NULL, 258, NULL, 'CodY', 275651),
(456558, 'PIRSF001455', NULL, NULL, 365, NULL, '3dhq_synth', 275652),
(456559, 'PIRSF036872', NULL, NULL, 2873, NULL, 'L_TospoV', 275653),
(456560, 'PIRSF015592', NULL, NULL, 215, NULL, 'Pyrrolidone-crbxlat_pptds', 275654),
(456561, 'PIRSF006815', NULL, NULL, 446, NULL, 'GcvPA', 275655),
(456562, 'PIRSF038054', NULL, NULL, 403, NULL, 'Nas7_nas8', 275656),
(456563, 'PIRSF031802', NULL, NULL, 533, NULL, 'UCP031802', 275657),
(456564, 'PIRSF006066', NULL, NULL, 427, NULL, 'HI0050', 275658),
(456565, 'PIRSF005673', NULL, NULL, 526, NULL, 'Importin_alpha', 275659),
(456566, 'PIRSF000666', NULL, NULL, 1000, NULL, 'TyrPK_ephrin_receptor', 275660),
(456567, 'PIRSF002697', NULL, NULL, 67, NULL, 'AmbtV', 275661),
(456568, 'PIRSF018412', NULL, NULL, 388, NULL, 'TEBP_beta', 275662),
(456569, 'PIRSF006351', NULL, NULL, 435, NULL, 'PTS_EIIC-Cellobiose', 275663),
(456570, 'PIRSF013232', NULL, NULL, 118, NULL, 'UCP013232', 275664),
(456571, 'PIRSF037002', NULL, NULL, 592, NULL, 'RNA_ed_MP63', 275665),
(456572, 'PIRSF005054', NULL, NULL, 255, NULL, 'PF1131', 275666),
(456573, 'PIRSF037000', NULL, NULL, 164, NULL, 'RNA_ed_MP18', 275667),
(456574, 'PIRSF037653', NULL, NULL, 224, NULL, 'SRY', 275668),
(456575, 'PIRSF037724', NULL, NULL, 243, NULL, 'Txn_reg_HTH_MJ1545', 275669),
(456576, 'PIRSF007531', NULL, NULL, 209, NULL, 'CPT', 275670),
(456577, 'PIRSF000719', NULL, NULL, 577, NULL, 'AceK', 275671),
(456578, 'PIRSF039114', NULL, NULL, 471, NULL, 'V-ATPsynth_beta/V-ATPase_B', 275672),
(456579, 'PIRSF500950', NULL, NULL, 1081, NULL, 'Alpha-PDGF_receptor', 275673),
(456580, 'PIRSF037894', NULL, NULL, 572, NULL, 'Subtilisin_rel_CspABC', 275674),
(456581, 'PIRSF000535', NULL, NULL, 313, NULL, '1PFK/6PFK/LacC', 275675),
(456582, 'PIRSF009554', NULL, NULL, 146, NULL, 'UCP009554', 275676),
(456583, 'PIRSF037014', NULL, NULL, 808, NULL, 'SNF1LK_vert', 275677),
(456584, 'PIRSF037334', NULL, NULL, 408, NULL, 'FucT_plant', 275678),
(456585, 'PIRSF000084', NULL, NULL, 1126, NULL, 'Phytochrome_conventional', 275679),
(456586, 'PIRSF000808', NULL, NULL, 349, NULL, 'GalT', 275680),
(456587, 'PIRSF001386', NULL, NULL, 458, NULL, 'Trpase', 275681),
(456588, 'PIRSF006173', NULL, NULL, 150, NULL, 'UCP006173', 275682),
(456589, 'PIRSF036397', NULL, NULL, 851, NULL, 'Bacteriophytochrome_rec', 275683),
(456590, 'PIRSF036698', NULL, NULL, 56, NULL, 'UCP036698', 275684),
(456591, 'PIRSF022603', NULL, NULL, 193, NULL, 'UCP022603', 275685),
(456592, 'PIRSF010376', NULL, NULL, 293, NULL, 'IspE', 275686),
(456593, 'PIRSF038159', NULL, NULL, 541, NULL, 'PP1_16AB', 275687),
(456594, 'PIRSF000485', NULL, NULL, 472, NULL, 'Pur1', 275688),
(456595, 'PIRSF008142', NULL, NULL, 103, NULL, 'SH3-bind_E-rich_L', 275689),
(456596, 'PIRSF021573', NULL, NULL, 216, NULL, 'UCP021573', 275690),
(456597, 'PIRSF006993', NULL, NULL, 232, NULL, 'UCP006993', 275691),
(456598, 'PIRSF500185', NULL, NULL, 708, NULL, 'MSP_HGFL', 275692),
(456599, 'PIRSF006769', NULL, NULL, 373, NULL, 'RibD', 275693),
(456600, 'PIRSF006910', NULL, NULL, 150, NULL, 'NA_bind_Rv2694c', 275694),
(456601, 'PIRSF031043', NULL, NULL, 433, NULL, 'UCP031043', 275695),
(456602, 'PIRSF037290', NULL, NULL, 220, NULL, 'UCP037290', 275696),
(456603, 'PIRSF036899', NULL, NULL, 204, NULL, 'AGP', 275697),
(456604, 'PIRSF000039', NULL, NULL, 92, NULL, 'Phenol_monooxy_K', 275698),
(456605, 'PIRSF007519', NULL, NULL, 781, NULL, 'Protease_InhA', 275699),
(456606, 'PIRSF001103', NULL, NULL, 320, NULL, 'Endo-b-N-acetylglucosaminidase', 275700),
(456607, 'PIRSF001773', NULL, NULL, 456, NULL, 'COX10', 275701),
(456608, 'PIRSF009597', NULL, NULL, 117, NULL, 'UCP009597', 275702),
(456609, 'PIRSF500217', NULL, NULL, 486, NULL, 'AlgI', 275703),
(456610, 'PIRSF004846', NULL, NULL, 264, NULL, 'ModA', 275704),
(456611, 'PIRSF027377', NULL, NULL, 141, NULL, 'Nitrile_oxidored_QueF', 275705),
(456612, 'PIRSF003783', NULL, NULL, 212, NULL, 'VAC_C1L', 275706),
(456613, 'PIRSF016020', NULL, NULL, 313, NULL, 'PHexose_mutarotase', 275707);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(456614, 'PIRSF018788', NULL, NULL, 460, NULL, 'EutB', 275708),
(456615, 'PIRSF006019', NULL, NULL, 159, NULL, 'dCMP_deaminase', 275709),
(456616, 'PIRSF002472', NULL, NULL, 123, NULL, 'Amyloid_prot_SAA', 275710),
(456617, 'PIRSF001357', NULL, NULL, 234, NULL, 'DeoC', 275711),
(456618, 'PIRSF004178', NULL, NULL, 572, NULL, 'DNA_pol_Bac_phage', 275712),
(456619, 'PIRSF031644', NULL, NULL, 213, NULL, 'UCP031644', 275713),
(456620, 'PIRSF005992', NULL, NULL, 482, NULL, 'AP_complex_mu', 275714),
(456621, 'PIRSF026991', NULL, NULL, 208, NULL, 'MND1', 275715),
(456622, 'PIRSF028846', NULL, NULL, 432, NULL, 'UCP028846', 275716),
(456623, 'PIRSF037158', NULL, NULL, 130, NULL, 'UCP037158', 275717),
(456624, 'PIRSF036399', NULL, NULL, 1039, NULL, 'Gal_kin_glcsltr', 275718),
(456625, 'PIRSF000478', NULL, NULL, 435, NULL, 'TP_PyNP', 275719),
(456626, 'PIRSF002304', NULL, NULL, 804, NULL, 'Band_41', 275720),
(456627, 'PIRSF037632', NULL, NULL, 276, NULL, 'Rep-8_protein', 275721),
(456628, 'PIRSF038181', NULL, NULL, 1435, NULL, 'NCoA', 275722),
(456629, 'PIRSF015855', NULL, NULL, 654, NULL, 'TypeIII_Mtase_mKpnI', 275723),
(456630, 'PIRSF000014', NULL, NULL, 389, NULL, 'Cytochrome_c_torY_torC', 275724),
(456631, 'PIRSF001667', NULL, NULL, 71, NULL, 'PKI', 275725),
(456632, 'PIRSF016478', NULL, NULL, 297, NULL, 'Epsilon-COP', 275726),
(456633, 'PIRSF029543', NULL, NULL, 133, NULL, 'UCP029543', 275727),
(456634, 'PIRSF012535', NULL, NULL, 540, NULL, 'UCP012535', 275728),
(456635, 'PIRSF021591', NULL, NULL, 155, NULL, 'UCP021591', 275729),
(456636, 'PIRSF008315', NULL, NULL, 464, NULL, 'UCP008315', 275730),
(456637, 'PIRSF014897', NULL, NULL, 752, NULL, 'UCP014897', 275731),
(456638, 'PIRSF036382', NULL, NULL, 201, NULL, 'RR_antiterminator', 275732),
(456639, 'PIRSF038144', NULL, NULL, 510, NULL, 'Ladinin-1', 275733),
(456640, 'PIRSF036852', NULL, NULL, 277, NULL, 'RNase_H1_euk', 275734),
(456641, 'PIRSF001415', NULL, NULL, 333, NULL, 'Porphbilin_synth', 275735),
(456642, 'PIRSF018432', NULL, NULL, 286, NULL, 'WbeT', 275736),
(456643, 'PIRSF037236', NULL, NULL, 421, NULL, 'TaqI', 275737),
(456644, 'PIRSF000915', NULL, NULL, 314, NULL, 'PGP-type_phosphatase', 275738),
(456645, 'PIRSF039101', NULL, NULL, 576, NULL, 'LysRS2', 275739),
(456646, 'PIRSF500824', NULL, NULL, 437, NULL, 'TrpB_prok', 275740),
(456647, 'PIRSF012509', NULL, NULL, 389, NULL, 'CamS', 275741),
(456648, 'PIRSF015848', NULL, NULL, 468, NULL, 'TEBP_alpha', 275742),
(456649, 'PIRSF036497', NULL, NULL, 341, NULL, 'HDH_short', 275743),
(456650, 'PIRSF037673', NULL, NULL, 129, NULL, 'UCP037673', 275744),
(456651, 'PIRSF020372', NULL, NULL, 160, NULL, 'Rev_Borrelia', 275745),
(456652, 'PIRSF037031', NULL, NULL, 78, NULL, 'Redox_disulf_2', 275746),
(456653, 'PIRSF000970', NULL, NULL, 420, NULL, '2_3-cyc_nuc_Pdiesterase', 275747),
(456654, 'PIRSF002144', NULL, NULL, 110, NULL, 'RPS19p_RPS19a_RPS15e_RPS19o', 275748),
(456655, 'PIRSF030786', NULL, NULL, 71, NULL, 'Lysis_prot_S', 275749),
(456656, 'PIRSF029208', NULL, NULL, 150, NULL, 'Tail_GPU', 275750),
(456657, 'PIRSF003180', NULL, NULL, 407, NULL, 'DiGMP_Pdiesterase_YuxH', 275751),
(456658, 'PIRSF030850', NULL, NULL, 290, NULL, 'UCP030850', 275752),
(456659, 'PIRSF036802', NULL, NULL, 412, NULL, 'Tau55_TFC7', 275753),
(456660, 'PIRSF000530', NULL, NULL, 415, NULL, 'Galactokinase', 275754),
(456661, 'PIRSF027202', NULL, NULL, 571, NULL, 'Ced_4', 275755),
(456662, 'PIRSF015945', NULL, NULL, 121, NULL, 'V-ATP_synth_F', 275756),
(456663, 'PIRSF019015', NULL, NULL, 463, NULL, 'P60_peptidase_YkfC', 275757),
(456664, 'PIRSF012159', NULL, NULL, 235, NULL, 'Inh_gp21', 275758),
(456665, 'PIRSF019714', NULL, NULL, 260, NULL, 'NLBH', 275759),
(456666, 'PIRSF001296', NULL, NULL, 193, NULL, 'H/K_exch_ATPase_C', 275760),
(456667, 'PIRSF017245', NULL, NULL, 808, NULL, 'Phosphoketolase', 275761),
(456668, 'PIRSF037950', NULL, NULL, 534, NULL, 'E3_ub_ligase_RNF8', 275762),
(456669, 'PIRSF037489', NULL, NULL, 370, NULL, 'NIF3_YqfO', 275763),
(456670, 'PIRSF037307', NULL, NULL, 939, NULL, 'Lhr-like_helic', 275764);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(456671, 'PIRSF013217', NULL, NULL, 315, NULL, 'UCP013217_Opy1', 275765),
(456672, 'PIRSF038079', NULL, NULL, 339, NULL, 'Torsin-2A', 275766),
(456673, 'PIRSF029681', NULL, NULL, 184, NULL, 'PagL', 275767),
(456674, 'PIRSF001942', NULL, NULL, 176, NULL, 'IL-7', 275768),
(456675, 'PIRSF001836', NULL, NULL, 104, NULL, 'Neuroparsin', 275769),
(456676, 'PIRSF019373', NULL, NULL, 163, NULL, 'EhaF', 275770),
(456677, 'PIRSF019548', NULL, NULL, 234, NULL, 'TNF_CD30L', 275771),
(456678, 'PIRSF007349', NULL, NULL, 490, NULL, 'Tsp_L', 275772),
(456679, 'PIRSF039123', NULL, NULL, 240, NULL, 'Diphthamide_synthase', 275773),
(456680, 'PIRSF022079', NULL, NULL, 196, NULL, 'UCP022079', 275774),
(456681, 'PIRSF025798', NULL, NULL, 571, NULL, 'Cables', 275775),
(456682, 'PIRSF016055', NULL, NULL, 405, NULL, 'NqrB', 275776),
(456683, 'PIRSF003095', NULL, NULL, 452, NULL, 'Trigger_factor', 275777),
(456684, 'PIRSF019466', NULL, NULL, 371, NULL, 'EutH', 275778),
(456685, 'PIRSF028470', NULL, NULL, 161, NULL, 'UCP028470', 275779),
(456686, 'PIRSF002431', NULL, NULL, 523, NULL, 'Saposin', 275780),
(456687, 'PIRSF001936', NULL, NULL, 166, NULL, 'Interferon_gamma', 275781),
(456688, 'PIRSF037610', NULL, NULL, 176, NULL, 'BLOC-1_mut', 275782),
(456689, 'PIRSF001238', NULL, NULL, 388, NULL, 'IadA', 275783),
(456690, 'PIRSF028111', NULL, NULL, 232, NULL, 'UCP028111', 275784),
(456691, 'PIRSF017126', NULL, NULL, 732, NULL, 'Condensin_H', 275785),
(456692, 'PIRSF027109', NULL, NULL, 224, NULL, 'Golgi_SNARE', 275786),
(456693, 'PIRSF036883', NULL, NULL, 380, NULL, 'RR_HD-GYP_mod', 275787),
(456694, 'PIRSF038991', NULL, NULL, 359, NULL, 'Protein_AbrB', 275788),
(456695, 'PIRSF026492', NULL, NULL, 558, NULL, 'Dig_cycl_CHASE', 275789),
(456696, 'PIRSF037559', NULL, NULL, 513, NULL, 'Gly_redC_beta', 275790),
(456697, 'PIRSF037259', NULL, NULL, 407, NULL, 'ABC_permease_EcsB', 275791),
(456698, 'PIRSF000906', NULL, NULL, 649, NULL, 'FBPtase_Bacill', 275792),
(456699, 'PIRSF006517', NULL, NULL, 1017, NULL, 'DNA_pol_mt_plasmid', 275793),
(456700, 'PIRSF018863', NULL, NULL, 415, NULL, 'UCP018863', 275794),
(456701, 'PIRSF031279', NULL, NULL, 172, NULL, 'UCP031279', 275795),
(456702, 'PIRSF007802', NULL, NULL, 160, NULL, 'ATG10', 275796),
(456703, 'PIRSF029730', NULL, NULL, 260, NULL, 'UCP029730', 275797),
(456704, 'PIRSF031509', NULL, NULL, 239, NULL, 'LiaF_YvqF', 275798),
(456705, 'PIRSF030250', NULL, NULL, 355, NULL, 'Ptase_At2g46880', 275799),
(456706, 'PIRSF500136', NULL, NULL, 445, NULL, 'UDP_ManNAc_DH', 275800),
(456707, 'PIRSF021362', NULL, NULL, 191, NULL, 'UCP021362_HAD', 275801),
(456708, 'PIRSF012335', NULL, NULL, 154, NULL, 'UCP012335', 275802),
(456709, 'PIRSF011132', NULL, NULL, 278, NULL, 'TIG1_latexin_ovocalyxin-32', 275803),
(456710, 'PIRSF012560', NULL, NULL, 309, NULL, 'UCP012560', 275804),
(456711, 'PIRSF005087', NULL, NULL, 139, NULL, 'NrdI', 275805),
(456712, 'PIRSF017930', NULL, NULL, 102, NULL, 'TraM', 275806),
(456713, 'PIRSF036692', NULL, NULL, 220, NULL, 'SDH_B', 275807),
(456714, 'PIRSF005499', NULL, NULL, 727, NULL, 'PNPase', 275808),
(456715, 'PIRSF002383', NULL, NULL, 186, NULL, 'NSG_calcyon', 275809),
(456716, 'PIRSF001388', NULL, NULL, 382, NULL, 'Trichodiene_synth', 275810),
(456717, 'PIRSF038192', NULL, NULL, 358, NULL, 'Txn_reg_BtrU', 275811),
(456718, 'PIRSF005650', NULL, NULL, 249, NULL, 'Uridylate_kin', 275812),
(456719, 'PIRSF028498', NULL, NULL, 132, NULL, 'UCP028498', 275813),
(456720, 'PIRSF037038', NULL, NULL, 93, NULL, 'Bombyxin', 275814),
(456721, 'PIRSF005898', NULL, NULL, 265, NULL, 'CpeC_CpcI', 275815),
(456722, 'PIRSF006615', NULL, NULL, 503, NULL, 'Zn_crbxpep_Taq', 275816),
(456723, 'PIRSF036752', NULL, NULL, 210, NULL, 'TSase_MJ051', 275817),
(456724, 'PIRSF000545', NULL, NULL, 317, NULL, 'Pantothenate_kin', 275818),
(456725, 'PIRSF004160', NULL, NULL, 328, NULL, 'Minor_spike_H', 275819),
(456726, 'PIRSF006076', NULL, NULL, 792, NULL, 'Omp85', 275820),
(456727, 'PIRSF020555', NULL, NULL, 122, NULL, 'UCP020555', 275821),
(456728, 'PIRSF009451', NULL, NULL, 514, NULL, 'Citrt_lyas_alpha', 275822);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(456729, 'PIRSF034834', NULL, NULL, 183, NULL, 'PduT', 275823),
(456730, 'PIRSF021389', NULL, NULL, 129, NULL, 'UCP021389', 275824),
(456731, 'PIRSF030561', NULL, NULL, 112, NULL, 'UCP030561', 275825),
(456732, 'PIRSF001747', NULL, NULL, 827, NULL, 'Red1', 275826),
(456733, 'PIRSF501178', NULL, NULL, 377, NULL, 'FNR-PetH', 275827),
(456734, 'PIRSF006431', NULL, NULL, 318, NULL, 'Pro_iminopeptidase', 275828),
(456735, 'PIRSF002264', NULL, NULL, 119, NULL, 'Lamprin', 275829),
(456736, 'PIRSF037567', NULL, NULL, 1301, NULL, 'Mtase_MttB', 275830),
(456737, 'PIRSF001413', NULL, NULL, 411, NULL, 'Trp_syn_beta', 275831),
(456738, 'PIRSF002285', NULL, NULL, 177, NULL, 'Op18_SCG10', 275832),
(456739, 'PIRSF015897', NULL, NULL, 274, NULL, 'PRIB5', 275833),
(456740, 'PIRSF028739', NULL, NULL, 469, NULL, 'Folate/thiamine_transporter', 275834),
(456741, 'PIRSF000018', NULL, NULL, 448, NULL, 'Mb_ADH_cytochrome_c', 275835),
(456742, 'PIRSF001141', NULL, NULL, 422, NULL, 'Acrosin', 275836),
(456743, 'PIRSF029595', NULL, NULL, 114, NULL, 'LecB', 275837),
(456744, 'PIRSF036643', NULL, NULL, 938, NULL, 'FDH_alpha', 275838),
(456745, 'PIRSF037435', NULL, NULL, 595, NULL, 'Hybr_HK_BC3207', 275839),
(456746, 'PIRSF034515', NULL, NULL, 1042, NULL, 'Chondroitinase', 275840),
(456747, 'PIRSF033096', NULL, NULL, 485, NULL, 'PPPtase_5', 275841),
(456748, 'PIRSF004985', NULL, NULL, 139, NULL, 'Hlld_jn_rslvs_ar', 275842),
(456749, 'PIRSF036569', NULL, NULL, 3843, NULL, 'Hml', 275843),
(456750, 'PIRSF037016', NULL, NULL, 687, NULL, 'Pseudouridin_synth_euk', 275844),
(456751, 'PIRSF001619', NULL, NULL, 339, NULL, 'Biotin_synth', 275845),
(456752, 'PIRSF021513', NULL, NULL, 168, NULL, 'GrhN_RubW', 275846),
(456753, 'PIRSF006563', NULL, NULL, 285, NULL, 'UCP006563', 275847),
(456754, 'PIRSF002483', NULL, NULL, 96, NULL, 'Plasminogen-related', 275848),
(456755, 'PIRSF000319', NULL, NULL, 752, NULL, 'Trp_2-mono_O2ase', 275849),
(456756, 'PIRSF012876', NULL, NULL, 321, NULL, 'Txn_rg_UCP012876', 275850),
(456757, 'PIRSF037251', NULL, NULL, 404, NULL, 'AADAC', 275851),
(456758, 'PIRSF000192', NULL, NULL, 188, NULL, 'Amine_dh_beta', 275852),
(456759, 'PIRSF004916', NULL, NULL, 108, NULL, 'UCP004916', 275853),
(456760, 'PIRSF035652', NULL, NULL, 120, NULL, 'UCP035652', 275854),
(456761, 'PIRSF037116', NULL, NULL, 265, NULL, 'PhnK', 275855),
(456762, 'PIRSF001859', NULL, NULL, 88, NULL, 'Eclosion_hormone', 275856),
(456763, 'PIRSF002161', NULL, NULL, 193, NULL, 'RPL5p_RPL5a_RPL11e_RPL5o', 275857),
(456764, 'PIRSF001065', NULL, NULL, 185, NULL, 'Lysozyme_g', 275858),
(456765, 'PIRSF007945', NULL, NULL, 213, NULL, 'SRB2', 275859),
(456766, 'PIRSF002395', NULL, NULL, 1718, NULL, 'RIZ_SET', 275860),
(456767, 'PIRSF005610', NULL, NULL, 122, NULL, 'UCP005610', 275861),
(456768, 'PIRSF015161', NULL, NULL, 453, NULL, 'TAFI48', 275862),
(456769, 'PIRSF036508', NULL, NULL, 1373, NULL, 'Condns_HCP-6', 275863),
(456770, 'PIRSF037159', NULL, NULL, 69, NULL, 'UCP037159', 275864),
(456771, 'PIRSF025007', NULL, NULL, 805, NULL, 'Sec15', 275865),
(456772, 'PIRSF003354', NULL, NULL, 1218, NULL, 'Alpha-COP', 275866),
(456773, 'PIRSF000151', NULL, NULL, 421, NULL, 'GPR', 275867),
(456774, 'PIRSF031853', NULL, NULL, 337, NULL, 'UCP031853', 275868),
(456775, 'PIRSF001432', NULL, NULL, 562, NULL, 'Pect_lyase', 275869),
(456776, 'PIRSF005264', NULL, NULL, 139, NULL, 'UCP005264', 275870),
(456777, 'PIRSF014735', NULL, NULL, 187, NULL, 'UCP014735', 275871),
(456778, 'PIRSF000350', NULL, NULL, 550, NULL, 'Hg-II_reductase_MerA', 275872),
(456779, 'PIRSF006648', NULL, NULL, 273, NULL, 'DrrB', 275873),
(456780, 'PIRSF006707', NULL, NULL, 186, NULL, 'MJ1563', 275874),
(456781, 'PIRSF006521', NULL, NULL, 88, NULL, 'TEF-1-beta_archaea', 275875),
(456782, 'PIRSF037672', NULL, NULL, 96, NULL, 'UCP037672', 275876),
(456783, 'PIRSF029764', NULL, NULL, 262, NULL, 'RSM25', 275877),
(456784, 'PIRSF036915', NULL, NULL, 378, NULL, 'Trnald_Bac_Plnt', 275878),
(456785, 'PIRSF006698', NULL, NULL, 435, NULL, 'Septin', 275879),
(456786, 'PIRSF018472', NULL, NULL, 163, NULL, 'MreD_proteobac', 275880);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(456787, 'PIRSF037303', NULL, NULL, 791, NULL, 'APC4', 275881),
(456788, 'PIRSF031074', NULL, NULL, 228, NULL, 'UCP031074', 275882),
(456789, 'PIRSF000263', NULL, NULL, 443, NULL, 'Meth_CoM_rd_beta', 275883),
(456790, 'PIRSF033091', NULL, NULL, 418, NULL, 'Pesterase_YhaO', 275884),
(456791, 'PIRSF000446', NULL, NULL, 311, NULL, 'Mct', 275885),
(456792, 'PIRSF001093', NULL, NULL, 570, NULL, 'B-hxosamndse_ab_euk_', 275886),
(456793, 'PIRSF002512', NULL, NULL, 802, NULL, 'Integrin_B', 275887),
(456794, 'PIRSF003692', NULL, NULL, 190, NULL, 'VAC_C14L', 275888),
(456795, 'PIRSF000216', NULL, NULL, 233, NULL, 'NDH-1_E', 275889),
(456796, 'PIRSF016838', NULL, NULL, 324, NULL, 'PafC', 275890),
(456797, 'PIRSF011271', NULL, NULL, 118, NULL, 'SycE', 275891),
(456798, 'PIRSF029347', NULL, NULL, 381, NULL, 'RecF', 275892),
(456799, 'PIRSF004377', NULL, NULL, 142, NULL, 'Ph_proh_core', 275893),
(456800, 'PIRSF006429', NULL, NULL, 537, NULL, 'GOGAT_lg_2', 275894),
(456801, 'PIRSF015658', NULL, NULL, 376, NULL, 'MmdB_OadB', 275895),
(456802, 'PIRSF001247', NULL, NULL, 664, NULL, 'Prot-Arg_deiminase', 275896),
(456803, 'PIRSF001863', NULL, NULL, 197, NULL, 'MAT_Alpha1', 275897),
(456804, 'PIRSF004953', NULL, NULL, 108, NULL, 'EhaL', 275898),
(456805, 'PIRSF037706', NULL, NULL, 93, NULL, 'MRP10', 275899),
(456806, 'PIRSF018077', NULL, NULL, 503, NULL, 'UCP018077', 275900),
(456807, 'PIRSF037840', NULL, NULL, 295, NULL, 'Aldolase_YihT', 275901),
(456808, 'PIRSF038155', NULL, NULL, 315, NULL, 'AS2', 275902),
(456809, 'PIRSF018282', NULL, NULL, 440, NULL, 'MukF', 275903),
(456810, 'PIRSF037135', NULL, NULL, 802, NULL, 'Matriptase-2', 275904),
(456811, 'PIRSF004669', NULL, NULL, 89, NULL, 'FliQ', 275905),
(456812, 'PIRSF032748', NULL, NULL, 206, NULL, 'UCP032748', 275906),
(456813, 'PIRSF019736', NULL, NULL, 398, NULL, 'dTMP_TKRP1', 275907),
(456814, 'PIRSF032543', NULL, NULL, 254, NULL, 'UCP032543_ParB', 275908),
(456815, 'PIRSF000346', NULL, NULL, 379, NULL, 'Dlt9_acylACP_des', 275909),
(456816, 'PIRSF031505', NULL, NULL, 261, NULL, 'GalT_short', 275910),
(456817, 'PIRSF039133', NULL, NULL, 610, NULL, 'SUMO_E1B', 275911),
(456818, 'PIRSF036408', NULL, NULL, 443, NULL, 'PduS', 275912),
(456819, 'PIRSF006356', NULL, NULL, 419, NULL, 'ADI', 275913),
(456820, 'PIRSF032441', NULL, NULL, 128, NULL, 'UCP032441', 275914),
(456821, 'PIRSF016379', NULL, NULL, 447, NULL, 'ENT', 275915),
(456822, 'PIRSF038147', NULL, NULL, 561, NULL, 'STPK_RIO1', 275916),
(456823, 'PIRSF006135', NULL, NULL, 184, NULL, 'CobU', 275917),
(456824, 'PIRSF006160', NULL, NULL, 160, NULL, 'AI2', 275918),
(456825, 'PIRSF029120', NULL, NULL, 354, NULL, 'UCP029120', 275919),
(456826, 'PIRSF032209', NULL, NULL, 163, NULL, 'UCP032209', 275920),
(456827, 'PIRSF036498', NULL, NULL, 966, NULL, 'Kaurene_synth_fungi', 275921),
(456828, 'PIRSF030175', NULL, NULL, 261, NULL, 'UCP030175', 275922),
(456829, 'PIRSF016636', NULL, NULL, 485, NULL, 'AlgI_DltB', 275923),
(456830, 'PIRSF500741', NULL, NULL, 897, NULL, 'MAPKKK12', 275924),
(456831, 'PIRSF004808', NULL, NULL, 249, NULL, 'LasT', 275925),
(456832, 'PIRSF018494', NULL, NULL, 353, NULL, 'PBSX_VPQ', 275926),
(456833, 'PIRSF016511', NULL, NULL, 307, NULL, 'Cyclin_Pcl', 275927),
(456834, 'PIRSF018239', NULL, NULL, 287, NULL, 'IGFBP_rP_mac25', 275928),
(456835, 'PIRSF029755', NULL, NULL, 268, NULL, 'UCP029755', 275929),
(456836, 'PIRSF000956', NULL, NULL, 1158, NULL, 'PLC-beta', 275930),
(456837, 'PIRSF001461', NULL, NULL, 228, NULL, 'RPE', 275931),
(456838, 'PIRSF021320', NULL, NULL, 150, NULL, 'UCP021320', 275932),
(456839, 'PIRSF007320', NULL, NULL, 195, NULL, 'Fimbrillin_MatB', 275933),
(456840, 'PIRSF000382', NULL, NULL, 767, NULL, 'Met_synth_MetE', 275934),
(456841, 'PIRSF038286', NULL, NULL, 475, NULL, 'PRAME', 275935),
(456842, 'PIRSF002455', NULL, NULL, 107, NULL, 'ATP_synth_F6', 275936),
(456843, 'PIRSF031512', NULL, NULL, 300, NULL, 'EpsL', 275937),
(456844, 'PIRSF037476', NULL, NULL, 809, NULL, 'BLOC2_Hps6', 275938),
(456845, 'PIRSF021525', NULL, NULL, 242, NULL, 'UCP021525', 275939),
(456846, 'PIRSF000451', NULL, NULL, 377, NULL, 'PKS_III', 275940);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(456847, 'PIRSF009320', NULL, NULL, 224, NULL, 'Nuc_binding_HP_1000', 275941),
(456848, 'PIRSF030140', NULL, NULL, 164, NULL, 'UCP030140', 275942),
(456849, 'PIRSF013674', NULL, NULL, 219, NULL, 'PXMP4', 275943),
(456850, 'PIRSF003923', NULL, NULL, 57, NULL, 'SH_protein_mumps', 275944),
(456851, 'PIRSF038861', NULL, NULL, 1155, NULL, 'UCP038861', 275945),
(456852, 'PIRSF005653', NULL, NULL, 73, NULL, 'RpoN_RPB10', 275946),
(456853, 'PIRSF006221', NULL, NULL, 294, NULL, 'KT3K', 275947),
(456854, 'PIRSF036654', NULL, NULL, 551, NULL, 'Fum_suc_asp_HD', 275948),
(456855, 'PIRSF000034', NULL, NULL, 37, NULL, 'Cytochrome_b6f_V/PetG', 275949),
(456856, 'PIRSF000161', NULL, NULL, 261, NULL, 'DHPR', 275950),
(456857, 'PIRSF000548', NULL, NULL, 408, NULL, 'PK_regulatory', 275951),
(456858, 'PIRSF037094', NULL, NULL, 828, NULL, 'AP1_gamma', 275952),
(456859, 'PIRSF019164', NULL, NULL, 310, NULL, 'UCP019164', 275953),
(456860, 'PIRSF034961', NULL, NULL, 118, NULL, 'UCP034961_SH3_2', 275954),
(456861, 'PIRSF000770', NULL, NULL, 269, NULL, 'SigK_SigE', 275955),
(456862, 'PIRSF006060', NULL, NULL, 498, NULL, 'AA_transporter', 275956),
(456863, 'PIRSF021308', NULL, NULL, 198, NULL, 'UCP021308', 275957),
(456864, 'PIRSF020945', NULL, NULL, 406, NULL, 'GGP', 275958),
(456865, 'PIRSF000857', NULL, NULL, 248, NULL, 'PAPS_reductase', 275959),
(456866, 'PIRSF003938', NULL, NULL, 281, NULL, 'NS1_influenza_B', 275960),
(456867, 'PIRSF038065', NULL, NULL, 401, NULL, 'TNFR_11B', 275961),
(456868, 'PIRSF002764', NULL, NULL, 225, NULL, 'CcmB', 275962),
(456869, 'PIRSF033199', NULL, NULL, 116, NULL, 'UCP033199', 275963),
(456870, 'PIRSF020979', NULL, NULL, 361, NULL, 'UCP020979', 275964),
(456871, 'PIRSF015919', NULL, NULL, 426, NULL, 'TFIIH_SSL1', 275965),
(456872, 'PIRSF011018', NULL, NULL, 561, NULL, 'Nicalin', 275966),
(456873, 'PIRSF036417', NULL, NULL, 498, NULL, 'Very_long_ch_3-ktacl-CoA_syn', 275967),
(456874, 'PIRSF010045', NULL, NULL, 263, NULL, 'TMP_111', 275968),
(456875, 'PIRSF016123', NULL, NULL, 178, NULL, 'UCP016123', 275969),
(456876, 'PIRSF006834', NULL, NULL, 254, NULL, 'UCP006834', 275970),
(456877, 'PIRSF000726', NULL, NULL, 461, NULL, 'Asp_kin', 275971),
(456878, 'PIRSF003281', NULL, NULL, 217, NULL, 'ExcA', 275972),
(456879, 'PIRSF002912', NULL, NULL, 146, NULL, 'PsaK', 275973),
(456880, 'PIRSF005919', NULL, NULL, 200, NULL, 'UCP005919', 275974),
(456881, 'PIRSF000008', NULL, NULL, 188, NULL, 'Cytochrome_c551i', 275975),
(456882, 'PIRSF028991', NULL, NULL, 510, NULL, 'Glycl_rad_HI0521', 275976),
(456883, 'PIRSF037987', NULL, NULL, 1006, NULL, 'UCP037987', 275977),
(456884, 'PIRSF005348', NULL, NULL, 440, NULL, 'YxkH', 275978),
(456885, 'PIRSF019029', NULL, NULL, 462, NULL, 'Txn_fac_bZIP_E4BP4', 275979),
(456886, 'PIRSF037235', NULL, NULL, 3149, NULL, 'Vps13_fungi', 275980),
(456887, 'PIRSF016487', NULL, NULL, 161, NULL, 'CYTH_UCP016487', 275981),
(456888, 'PIRSF002786', NULL, NULL, 317, NULL, 'XcpX', 275982),
(456889, 'PIRSF006677', NULL, NULL, 506, NULL, 'AtPEPC', 275983),
(456890, 'PIRSF037905', NULL, NULL, 1098, NULL, 'Subtilisin_rel_CJE1557', 275984),
(456891, 'PIRSF004179', NULL, NULL, 266, NULL, 'DNAterm_GP3', 275985),
(456892, 'PIRSF036510', NULL, NULL, 441, NULL, 'PDH_fung', 275986),
(456893, 'PIRSF030471', NULL, NULL, 242, NULL, 'STR_Vng0742h', 275987),
(456894, 'PIRSF033622', NULL, NULL, 390, NULL, 'UCP033622_transglutaminase', 275988),
(456895, 'PIRSF038143', NULL, NULL, 525, NULL, 'Podoclyxn-like_1', 275989),
(456896, 'PIRSF017250', NULL, NULL, 296, NULL, 'tRNA_endo_SEN34', 275990),
(456897, 'PIRSF012337', NULL, NULL, 207, NULL, 'gp45', 275991),
(456898, 'PIRSF015195', NULL, NULL, 179, NULL, 'UCP015195', 275992),
(456899, 'PIRSF015477', NULL, NULL, 1433, NULL, 'Bpr', 275993),
(456900, 'PIRSF004649', NULL, NULL, 212, NULL, 'MlaC', 275994),
(456901, 'PIRSF000988', NULL, NULL, 284, NULL, 'DNase_I', 275995),
(456902, 'PIRSF019375', NULL, NULL, 505, NULL, 'UCP019375', 275996),
(456903, 'PIRSF032086', NULL, NULL, 234, NULL, 'UCP032086', 275997),
(456904, 'PIRSF037851', NULL, NULL, 596, NULL, 'Subtilisin_cyano', 275998);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(456905, 'PIRSF005496', NULL, NULL, 829, NULL, 'ATP_hel_HrpB', 275999),
(456906, 'PIRSF033367', NULL, NULL, 122, NULL, 'UCP033367_VanZ', 276000),
(456907, 'PIRSF004848', NULL, NULL, 242, NULL, 'YBL036c_PLPDEIII', 276001),
(456908, 'PIRSF003073', NULL, NULL, 255, NULL, 'DNAC_TnpB_IstB', 276002),
(456909, 'PIRSF002905', NULL, NULL, 751, NULL, 'PSI_A', 276003),
(456910, 'PIRSF021239', NULL, NULL, 114, NULL, 'UCP021239', 276004),
(456911, 'PIRSF015588', NULL, NULL, 152, NULL, 'AP_complex_sigma', 276005),
(456912, 'PIRSF030125', NULL, NULL, 271, NULL, 'UCP030125', 276006),
(456913, 'PIRSF037892', NULL, NULL, 558, NULL, 'Subtilisin_rel_SRU_0565', 276007),
(456914, 'PIRSF011588', NULL, NULL, 428, NULL, 'Gly_sarc_betain_reduct_a_b', 276008),
(456915, 'PIRSF037336', NULL, NULL, 703, NULL, 'IspG_partdup', 276009),
(456916, 'PIRSF019435', NULL, NULL, 434, NULL, 'UCP019435', 276010),
(456917, 'PIRSF017300', NULL, NULL, 637, NULL, 'snoRNP_Mpp10', 276011),
(456918, 'PIRSF000099', NULL, NULL, 432, NULL, 'Histidinol_dh', 276012),
(456919, 'PIRSF033595', NULL, NULL, 119, NULL, 'UCP033595', 276013),
(456920, 'PIRSF003326', NULL, NULL, 288, NULL, 'PET111', 276014),
(456921, 'PIRSF016154', NULL, NULL, 149, NULL, 'Nucl_a_bind_PIN_PH0500', 276015),
(456922, 'PIRSF038013', NULL, NULL, 298, NULL, 'TNF10_TNF11', 276016),
(456923, 'PIRSF036620', NULL, NULL, 490, NULL, 'MPTbdFAD', 276017),
(456924, 'PIRSF016496', NULL, NULL, 266, NULL, 'Kin_FomA', 276018),
(456925, 'PIRSF029502', NULL, NULL, 124, NULL, 'UCP029502', 276019),
(456926, 'PIRSF036054', NULL, NULL, 310, NULL, 'UCP036054', 276020),
(456927, 'PIRSF028205', NULL, NULL, 253, NULL, 'UCP028205', 276021),
(456928, 'PIRSF002599', NULL, NULL, 196, NULL, 'Cold_shock_A', 276022),
(456929, 'PIRSF000355', NULL, NULL, 349, NULL, 'NrdB', 276023),
(456930, 'PIRSF004961', NULL, NULL, 285, NULL, 'UCP004961_hydrolase', 276024),
(456931, 'PIRSF037104', NULL, NULL, 1062, NULL, 'H3K4_HMTase_Set1_fungi', 276025),
(456932, 'PIRSF006655', NULL, NULL, 378, NULL, 'DHQS_altern', 276026),
(456933, 'PIRSF021331', NULL, NULL, 196, NULL, 'YkoF', 276027),
(456934, 'PIRSF500156', NULL, NULL, 440, NULL, 'GalT_Corynebac', 276028),
(456935, 'PIRSF039110', NULL, NULL, 458, NULL, 'IPP_transferase', 276029),
(456936, 'PIRSF000778', NULL, NULL, 137, NULL, 'RpoK/RPB6', 276030),
(456937, 'PIRSF002808', NULL, NULL, 451, NULL, 'Hexose_phosphate_transp', 276031),
(456938, 'PIRSF001657', NULL, NULL, 158, NULL, 'Alpha-amyl_inhib_seed_allergen', 276032),
(456939, 'PIRSF038994', NULL, NULL, 391, NULL, 'NagA', 276033),
(456940, 'PIRSF038169', NULL, NULL, 371, NULL, 'WD_rpt_55', 276034),
(456941, 'PIRSF001418', NULL, NULL, 766, NULL, 'ACN', 276035),
(456942, 'PIRSF015849', NULL, NULL, 265, NULL, 'TFIIF-beta', 276036),
(456943, 'PIRSF016661', NULL, NULL, 194, NULL, 'BioY', 276037),
(456944, 'PIRSF037913', NULL, NULL, 456, NULL, 'HDAC_I_euk', 276038),
(456945, 'PIRSF000977', NULL, NULL, 483, NULL, 'Exodeoxyribonuclease_I', 276039),
(456946, 'PIRSF020736', NULL, NULL, 207, NULL, 'MiaE', 276040),
(456947, 'PIRSF004523', NULL, NULL, 403, NULL, 'ABC_peripl_P37', 276041),
(456948, 'PIRSF001423', NULL, NULL, 565, NULL, 'Urocanate_hydrat', 276042),
(456949, 'PIRSF000379', NULL, NULL, 747, NULL, 'For_Ac_trans_1', 276043),
(456950, 'PIRSF014728', NULL, NULL, 495, NULL, 'PqaA', 276044),
(456951, 'PIRSF020485', NULL, NULL, 122, NULL, 'PA-IL', 276045),
(456952, 'PIRSF037250', NULL, NULL, 663, NULL, 'CcmM', 276046),
(456953, 'PIRSF036177', NULL, NULL, 200, NULL, 'HsdS', 276047),
(456954, 'PIRSF037181', NULL, NULL, 143, NULL, 'UCP037181', 276048),
(456955, 'PIRSF035808', NULL, NULL, 285, NULL, 'Pdiesterase_Brain_239', 276049),
(456956, 'PIRSF038471', NULL, NULL, 284, NULL, 'MreC', 276050),
(456957, 'PIRSF004750', NULL, NULL, 279, NULL, 'Nitrile_oxidored_YqcD', 276051),
(456958, 'PIRSF037383', NULL, NULL, 602, NULL, 'LicCA', 276052),
(456959, 'PIRSF029285', NULL, NULL, 369, NULL, 'Aminopept', 276053),
(456960, 'PIRSF015604', NULL, NULL, 166, NULL, 'OBP_PBP_Ditrysia', 276054),
(456961, 'PIRSF036442', NULL, NULL, 534, NULL, 'NAGS_animal', 276055);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(456962, 'PIRSF015981', NULL, NULL, 354, NULL, 'VAC_F11L', 276056),
(456963, 'PIRSF037257', NULL, NULL, 87, NULL, 'UCP037257_Veg', 276057),
(456964, 'PIRSF009303', NULL, NULL, 415, NULL, 'RAD9', 276058),
(456965, 'PIRSF036625', NULL, NULL, 246, NULL, 'GAF_ANTAR', 276059),
(456966, 'PIRSF000262', NULL, NULL, 555, NULL, 'MCR_alpha', 276060),
(456967, 'PIRSF026631', NULL, NULL, 498, NULL, 'UCP026631', 276061),
(456968, 'PIRSF008756', NULL, NULL, 193, NULL, 'P_tr_PHO88', 276062),
(456969, 'PIRSF000189', NULL, NULL, 361, NULL, 'D-aa_oxidase', 276063),
(456970, 'PIRSF033094', NULL, NULL, 233, NULL, 'Pesterase_CT488', 276064),
(456971, 'PIRSF005963', NULL, NULL, 365, NULL, 'Lipoyl_synth', 276065),
(456972, 'PIRSF019317', NULL, NULL, 725, NULL, 'UCP019317', 276066),
(456973, 'PIRSF022348', NULL, NULL, 278, NULL, 'UCP022348', 276067),
(456974, 'PIRSF036999', NULL, NULL, 401, NULL, 'RNA_ed_MP42', 276068),
(456975, 'PIRSF003047', NULL, NULL, 1887, NULL, 'TFIID_TAF1_animal', 276069),
(456976, 'PIRSF037185', NULL, NULL, 497, NULL, 'Cetp', 276070),
(456977, 'PIRSF006404', NULL, NULL, 364, NULL, 'UCP_M50_CBS', 276071),
(456978, 'PIRSF000199', NULL, NULL, 78, NULL, 'Dhfr_type_II', 276072),
(456979, 'PIRSF037995', NULL, NULL, 467, NULL, 'CB-R', 276073),
(456980, 'PIRSF027779', NULL, NULL, 163, NULL, 'UCP207779', 276074),
(456981, 'PIRSF002695', NULL, NULL, 87, NULL, 'A-agglutinin', 276075),
(456982, 'PIRSF002703', NULL, NULL, 761, NULL, 'PR5', 276076),
(456983, 'PIRSF006864', NULL, NULL, 161, NULL, 'UCP006864', 276077),
(456984, 'PIRSF003778', NULL, NULL, 177, NULL, 'VAC_C8L', 276078),
(456985, 'PIRSF026412', NULL, NULL, 325, NULL, 'Streptogrm_lyase', 276079),
(456986, 'PIRSF019853', NULL, NULL, 127, NULL, 'UCP019853', 276080),
(456987, 'PIRSF036917', NULL, NULL, 691, NULL, 'Alph_amls_MalS', 276081),
(456988, 'PIRSF015034', NULL, NULL, 176, NULL, 'YacH', 276082),
(456989, 'PIRSF036900', NULL, NULL, 3945, NULL, 'Rd_RNA_pol_NRV', 276083),
(456990, 'PIRSF037186', NULL, NULL, 484, NULL, 'LPLUNC', 276084),
(456991, 'PIRSF004697', NULL, NULL, 204, NULL, 'UCP_CBS_CP12', 276085),
(456992, 'PIRSF031143', NULL, NULL, 149, NULL, 'UCP031143', 276086),
(456993, 'PIRSF001779', NULL, NULL, 140, NULL, 'GF_C11R', 276087),
(456994, 'PIRSF018156', NULL, NULL, 347, NULL, 'MRPL51_fungal', 276088),
(456995, 'PIRSF004305', NULL, NULL, 81, NULL, 'Imm', 276089),
(456996, 'PIRSF036500', NULL, NULL, 327, NULL, 'GMP_red_Firmic', 276090),
(456997, 'PIRSF005954', NULL, NULL, 211, NULL, 'Thrmst_ogg', 276091),
(456998, 'PIRSF034653', NULL, NULL, 248, NULL, 'Mtase_yjhp', 276092),
(456999, 'PIRSF000097', NULL, NULL, 321, NULL, 'AKR', 276093),
(457000, 'PIRSF008711', NULL, NULL, 125, NULL, 'UCP008711', 276094),
(457001, 'PIRSF001693', NULL, NULL, 553, NULL, 'Txn_fact_GAMYB', 276095),
(457002, 'PIRSF005925', NULL, NULL, 748, NULL, 'Dos', 276096),
(457003, 'PIRSF003101', NULL, NULL, 422, NULL, 'FtsA', 276097),
(457004, 'PIRSF010072', NULL, NULL, 362, NULL, 'BBS5_fem-3', 276098),
(457005, 'PIRSF037736', NULL, NULL, 291, NULL, 'SCO1', 276099),
(457006, 'PIRSF016482', NULL, NULL, 215, NULL, 'PilO', 276100),
(457007, 'PIRSF032762', NULL, NULL, 450, NULL, 'UCP032762', 276101),
(457008, 'PIRSF036301', NULL, NULL, 182, NULL, 'Cripto_growth_factor', 276102),
(457009, 'PIRSF000845', NULL, NULL, 1293, NULL, 'mRNA_capping_reovirus', 276103),
(457010, 'PIRSF017818', NULL, NULL, 238, NULL, 'Acid_Ptase_B', 276104),
(457011, 'PIRSF011360', NULL, NULL, 833, NULL, 'PVC2', 276105),
(457012, 'PIRSF006205', NULL, NULL, 392, NULL, 'Dxp_reductoisomrs', 276106),
(457013, 'PIRSF000167', NULL, NULL, 449, NULL, 'HemN', 276107),
(457014, 'PIRSF004604', NULL, NULL, 103, NULL, 'UCP004604', 276108),
(457015, 'PIRSF037327', NULL, NULL, 590, NULL, 'TFIIIB_Bdp1_fungal', 276109),
(457016, 'PIRSF002900', NULL, NULL, 55, NULL, 'LH-2', 276110),
(457017, 'PIRSF031924', NULL, NULL, 537, NULL, 'Pi-irrepressible_AP', 276111),
(457018, 'PIRSF020079', NULL, NULL, 138, NULL, 'UCP020079', 276112),
(457019, 'PIRSF500126', NULL, NULL, 421, NULL, 'Pgk_euglenozoa', 276113),
(457020, 'PIRSF003161', NULL, NULL, 338, NULL, 'FliG', 276114);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(457021, 'PIRSF004374', NULL, NULL, 215, NULL, 'Gp59', 276115),
(457022, 'PIRSF038215', NULL, NULL, 251, NULL, 'Cripto-3_rel', 276116),
(457023, 'PIRSF037536', NULL, NULL, 1178, NULL, 'WD35', 276117),
(457024, 'PIRSF000439', NULL, NULL, 537, NULL, 'Oat_ACAT_DAG_ARE', 276118),
(457025, 'PIRSF000934', NULL, NULL, 1180, NULL, 'PTPN14_PTPN21', 276119),
(457026, 'PIRSF013220', NULL, NULL, 590, NULL, 'UCP013220', 276120),
(457027, 'PIRSF001137', NULL, NULL, 347, NULL, 'Haptoglobin', 276121),
(457028, 'PIRSF022941', NULL, NULL, 406, NULL, 'ORC6_fungal', 276122),
(457029, 'PIRSF014300', NULL, NULL, 196, NULL, 'Protoglobin', 276123),
(457030, 'PIRSF018269', NULL, NULL, 436, NULL, 'CDP-DAG_synth_e', 276124),
(457031, 'PIRSF007949', NULL, NULL, 848, NULL, 'Vps16', 276125),
(457032, 'PIRSF012294', NULL, NULL, 256, NULL, 'ATR_EutT', 276126),
(457033, 'PIRSF003796', NULL, NULL, 233, NULL, 'M-T4_MXV', 276127),
(457034, 'PIRSF006035', NULL, NULL, 174, NULL, 'CO_dh_b_ACDS_e', 276128),
(457035, 'PIRSF012526', NULL, NULL, 193, NULL, 'CYTH_UCP012526', 276129),
(457036, 'PIRSF036936', NULL, NULL, 546, NULL, 'IGPS_HisHF', 276130),
(457037, 'PIRSF037867', NULL, NULL, 417, NULL, 'CD261_antigen', 276131),
(457038, 'PIRSF009221', NULL, NULL, 187, NULL, 'VAP_Rhodococcus_equi', 276132),
(457039, 'PIRSF034852', NULL, NULL, 97, NULL, 'UCP034852', 276133),
(457040, 'PIRSF037891', NULL, NULL, 31, NULL, 'Cycloviolacin', 276134),
(457041, 'PIRSF006250', NULL, NULL, 284, NULL, 'NadC_ModD', 276135),
(457042, 'PIRSF008381', NULL, NULL, 707, NULL, 'TP0020_vWA', 276136),
(457043, 'PIRSF014470', NULL, NULL, 322, NULL, 'UCP014470', 276137),
(457044, 'PIRSF037630', NULL, NULL, 198, NULL, 'Blos3', 276138),
(457045, 'PIRSF016305', NULL, NULL, 332, NULL, 'LCMT', 276139),
(457046, 'PIRSF001790', NULL, NULL, 326, NULL, 'TNF_C22L', 276140),
(457047, 'PIRSF031878', NULL, NULL, 210, NULL, 'UCP031878', 276141),
(457048, 'PIRSF005444', NULL, NULL, 208, NULL, 'PEMT_MPLS', 276142),
(457049, 'PIRSF018425', NULL, NULL, 596, NULL, 'PolyA_polymerase', 276143),
(457050, 'PIRSF031890', NULL, NULL, 229, NULL, 'UCP031890_transporter_Tim44', 276144),
(457051, 'PIRSF037708', NULL, NULL, 150, NULL, 'Protein_FYV7', 276145),
(457052, 'PIRSF004762', NULL, NULL, 389, NULL, 'COFH', 276146),
(457053, 'PIRSF039100', NULL, NULL, 170, NULL, 'ARPC4', 276147),
(457054, 'PIRSF000139', NULL, NULL, 424, NULL, 'Glc_ox_4Fe-4S', 276148),
(457055, 'PIRSF005900', NULL, NULL, 170, NULL, 'Dps', 276149),
(457056, 'PIRSF016896', NULL, NULL, 280, NULL, 'GHMP_arc_MJ0969', 276150),
(457057, 'PIRSF032908', NULL, NULL, 369, NULL, 'UCP032908', 276151),
(457058, 'PIRSF028784', NULL, NULL, 95, NULL, 'MrpF', 276152),
(457059, 'PIRSF014543', NULL, NULL, 125, NULL, 'UCP014543', 276153),
(457060, 'PIRSF004698', NULL, NULL, 500, NULL, 'UCP_CBS_MJ0100', 276154),
(457061, 'PIRSF001394', NULL, NULL, 522, NULL, 'Fe_dep_fumar_hy', 276155),
(457062, 'PIRSF007808', NULL, NULL, 1450, NULL, 'Mms22p', 276156),
(457063, 'PIRSF014484', NULL, NULL, 251, NULL, 'UCP014484', 276157),
(457064, 'PIRSF031501', NULL, NULL, 166, NULL, 'QueT', 276158),
(457065, 'PIRSF038168', NULL, NULL, 599, NULL, 'MAPKKK7', 276159),
(457066, 'PIRSF002122', NULL, NULL, 224, NULL, 'RPS7p_RPS7a_RPS5e_RPS7o', 276160),
(457067, 'PIRSF005928', NULL, NULL, 226, NULL, 'Nucleotidltrnsf', 276161),
(457068, 'PIRSF036794', NULL, NULL, 438, NULL, 'UCP_erythr_ester', 276162),
(457069, 'PIRSF037240', NULL, NULL, 269, NULL, 'MAF1', 276163),
(457070, 'PIRSF008546', NULL, NULL, 143, NULL, 'UCP008546', 276164),
(457071, 'PIRSF007028', NULL, NULL, 118, NULL, 'UCP007028', 276165),
(457072, 'PIRSF010606', NULL, NULL, 89, NULL, 'CotJB', 276166),
(457073, 'PIRSF022950', NULL, NULL, 373, NULL, 'Pptase_methylesteras', 276167),
(457074, 'PIRSF007860', NULL, NULL, 974, NULL, 'Vps11', 276168),
(457075, 'PIRSF003779', NULL, NULL, 158, NULL, 'VAC_C7L', 276169),
(457076, 'PIRSF036517', NULL, NULL, 147, NULL, 'Ext_hemo', 276170),
(457077, 'PIRSF017259', NULL, NULL, 454, NULL, 'tRNA_Mtase_TRM11', 276171),
(457078, 'PIRSF028101', NULL, NULL, 363, NULL, 'UCP028101', 276172);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(457079, 'PIRSF031767', NULL, NULL, 305, NULL, 'MHYE_LytTR', 276173),
(457080, 'PIRSF037866', NULL, NULL, 354, NULL, 'EBP50', 276174),
(457081, 'PIRSF036540', NULL, NULL, 327, NULL, 'UCP036540_AIR', 276175),
(457082, 'PIRSF035170', NULL, NULL, 228, NULL, 'HD_phosphohydro', 276176),
(457083, 'PIRSF000813', NULL, NULL, 409, NULL, 'CCA_bact', 276177),
(457084, 'PIRSF038205', NULL, NULL, 954, NULL, 'DRP2', 276178),
(457085, 'PIRSF016792', NULL, NULL, 129, NULL, 'UCP016792', 276179),
(457086, 'PIRSF037938', NULL, NULL, 358, NULL, 'SIR2_euk', 276180),
(457087, 'PIRSF001941', NULL, NULL, 145, NULL, 'IL-4', 276181),
(457088, 'PIRSF037966', NULL, NULL, 246, NULL, 'BZLF1', 276182),
(457089, 'PIRSF023322', NULL, NULL, 190, NULL, 'UCP023322_TM_coiled-coil', 276183),
(457090, 'PIRSF005917', NULL, NULL, 287, NULL, 'MTase_YraL', 276184),
(457091, 'PIRSF015873', NULL, NULL, 127, NULL, 'FwdD', 276185),
(457092, 'PIRSF019401', NULL, NULL, 206, NULL, 'SeqA', 276186),
(457093, 'PIRSF005427', NULL, NULL, 334, NULL, 'RseB', 276187),
(457094, 'PIRSF031032', NULL, NULL, 170, NULL, 'TMP_97', 276188),
(457095, 'PIRSF001698', NULL, NULL, 474, NULL, 'C-ETS', 276189),
(457096, 'PIRSF037207', NULL, NULL, 530, NULL, 'ATE1_euk', 276190),
(457097, 'PIRSF037373', NULL, NULL, 124, NULL, 'UCP037373_trxn_reg', 276191),
(457098, 'PIRSF029883', NULL, NULL, 112, NULL, 'KdgF', 276192),
(457099, 'PIRSF021439', NULL, NULL, 113, NULL, 'YabA', 276193),
(457100, 'PIRSF031578', NULL, NULL, 379, NULL, 'UCP0310578_VanZ', 276194),
(457101, 'PIRSF037123', NULL, NULL, 1678, NULL, 'H3K79_HMTase_animal', 276195),
(457102, 'PIRSF003959', NULL, NULL, 302, NULL, 'NS-M_TospoV', 276196),
(457103, 'PIRSF036626', NULL, NULL, 536, NULL, 'MPTBd_MobAlike', 276197),
(457104, 'PIRSF036940', NULL, NULL, 271, NULL, 'PanK_bac_aCoA', 276198),
(457105, 'PIRSF500951', NULL, NULL, 965, NULL, 'SCGF_recepter', 276199),
(457106, 'PIRSF000706', NULL, NULL, 264, NULL, 'Kanamycin_kin', 276200),
(457107, 'PIRSF004075', NULL, NULL, 197, NULL, 'Coat_Flexivir', 276201),
(457108, 'PIRSF016465', NULL, NULL, 573, NULL, 'Kapp', 276202),
(457109, 'PIRSF018579', NULL, NULL, 113, NULL, 'Sbp', 276203),
(457110, 'PIRSF036480', NULL, NULL, 286, NULL, 'FormyFH4_hydr', 276204),
(457111, 'PIRSF037846', NULL, NULL, 445, NULL, 'Autolysin_YrvJ', 276205),
(457112, 'PIRSF030066', NULL, NULL, 151, NULL, 'UCP030066', 276206),
(457113, 'PIRSF019634', NULL, NULL, 832, NULL, 'tRNA_lig_yeast', 276207),
(457114, 'PIRSF029826', NULL, NULL, 123, NULL, 'UCP029826_pph', 276208),
(457115, 'PIRSF031568', NULL, NULL, 127, NULL, 'UCP031568', 276209),
(457116, 'PIRSF038015', NULL, NULL, 457, NULL, 'N-chimaerin', 276210),
(457117, 'PIRSF004682', NULL, NULL, 192, NULL, 'GmhB', 276211),
(457118, 'PIRSF001112', NULL, NULL, 449, NULL, 'Epoxide_hydro', 276212),
(457119, 'PIRSF001155', NULL, NULL, 706, NULL, 'C1r_C1s_MASP', 276213),
(457120, 'PIRSF038901', NULL, NULL, 1431, NULL, 'AQR_cwf11', 276214),
(457121, 'PIRSF006188', NULL, NULL, 72, NULL, 'UCP006188', 276215),
(457122, 'PIRSF030158', NULL, NULL, 379, NULL, 'UCP030158', 276216),
(457123, 'PIRSF028235', NULL, NULL, 310, NULL, 'UCP028235', 276217),
(457124, 'PIRSF020269', NULL, NULL, 214, NULL, 'UCP020269', 276218),
(457125, 'PIRSF030218', NULL, NULL, 575, NULL, 'Mannosyltr_MA4085', 276219),
(457126, 'PIRSF037378', NULL, NULL, 1302, NULL, 'EIN2', 276220),
(457127, 'PIRSF006325', NULL, NULL, 245, NULL, 'Mtase_YecO', 276221),
(457128, 'PIRSF037942', NULL, NULL, 372, NULL, 'MH2A1', 276222),
(457129, 'PIRSF003159', NULL, NULL, 181, NULL, 'FlhC', 276223),
(457130, 'PIRSF037390', NULL, NULL, 345, NULL, 'DoxA_doxD', 276224),
(457131, 'PIRSF039004', NULL, NULL, 396, NULL, 'ADE_EF_0837', 276225),
(457132, 'PIRSF037163', NULL, NULL, 355, NULL, 'PRDM12', 276226),
(457133, 'PIRSF000283', NULL, NULL, 60, NULL, 'COX9', 276227),
(457134, 'PIRSF001031', NULL, NULL, 614, NULL, 'Glu-a-glcsd_SBD', 276228),
(457135, 'PIRSF003368', NULL, NULL, 636, NULL, 'Large_T_antigen_PPV', 276229),
(457136, 'PIRSF036615', NULL, NULL, 402, NULL, 'MHYT_LytTR', 276230),
(457137, 'PIRSF014677', NULL, NULL, 528, NULL, 'UCP014677', 276231);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(457138, 'PIRSF038150', NULL, NULL, 325, NULL, 'Metaxin', 276232),
(457139, 'PIRSF004640', NULL, NULL, 363, NULL, 'IspG', 276233),
(457140, 'PIRSF000454', NULL, NULL, 1843, NULL, 'FAS_yeast_alpha', 276234),
(457141, 'PIRSF019073', NULL, NULL, 299, NULL, 'UCP019073', 276235),
(457142, 'PIRSF019225', NULL, NULL, 374, NULL, 'Cyt_c1_Campylob', 276236),
(457143, 'PIRSF000904', NULL, NULL, 331, NULL, 'FBPtase_SBPase', 276237),
(457144, 'PIRSF000484', NULL, NULL, 456, NULL, 'NAPRT', 276238),
(457145, 'PIRSF028170', NULL, NULL, 156, NULL, 'UCP028170', 276239),
(457146, 'PIRSF017179', NULL, NULL, 901, NULL, 'RISC-Tudor-SN', 276240),
(457147, 'PIRSF037818', NULL, NULL, 227, NULL, 'Glucagon', 276241),
(457148, 'PIRSF037023', NULL, NULL, 672, NULL, 'Api_ROM4_ROM5', 276242),
(457149, 'PIRSF005246', NULL, NULL, 1487, NULL, 'MukB', 276243),
(457150, 'PIRSF016281', NULL, NULL, 553, NULL, 'Transl_init_eIF3d', 276244),
(457151, 'PIRSF031051', NULL, NULL, 258, NULL, 'PLP_phosphatas_PHOSPHO2', 276245),
(457152, 'PIRSF029038', NULL, NULL, 322, NULL, 'Mtase_YbiN', 276246),
(457153, 'PIRSF017016', NULL, NULL, 167, NULL, 'NDUA8', 276247),
(457154, 'PIRSF011771', NULL, NULL, 475, NULL, 'RMS1_SET', 276248),
(457155, 'PIRSF016662', NULL, NULL, 295, NULL, 'UCP016662_Toprim', 276249),
(457156, 'PIRSF000089', NULL, NULL, 328, NULL, 'Electra_flavoP_a', 276250),
(457157, 'PIRSF011484', NULL, NULL, 180, NULL, 'YaeQ', 276251),
(457158, 'PIRSF003698', NULL, NULL, 357, NULL, 'VAC_C10L', 276252),
(457159, 'PIRSF022944', NULL, NULL, 215, NULL, 'MRP8', 276253),
(457160, 'PIRSF036996', NULL, NULL, 456, NULL, 'RSM23', 276254),
(457161, 'PIRSF038204', NULL, NULL, 645, NULL, 'Distrobrevin', 276255),
(457162, 'PIRSF010312', NULL, NULL, 158, NULL, 'SoxY', 276256),
(457163, 'PIRSF034081', NULL, NULL, 502, NULL, 'ATPase_Atu1862', 276257),
(457164, 'PIRSF037437', NULL, NULL, 691, NULL, 'Atp22', 276258),
(457165, 'PIRSF018136', NULL, NULL, 441, NULL, 'L_lectin_yeast', 276259),
(457166, 'PIRSF011773', NULL, NULL, 116, NULL, 'RFA3_yeast', 276260),
(457167, 'PIRSF018875', NULL, NULL, 499, NULL, 'UCP018875_ABC_perm', 276261),
(457168, 'PIRSF005047', NULL, NULL, 575, NULL, 'UCP005047_PHP', 276262),
(457169, 'PIRSF019236', NULL, NULL, 320, NULL, 'UCP019236', 276263),
(457170, 'PIRSF036665', NULL, NULL, 878, NULL, 'Sulf1', 276264),
(457171, 'PIRSF001563', NULL, NULL, 440, NULL, 'Folylpolyglu_synth', 276265),
(457172, 'PIRSF006485', NULL, NULL, 443, NULL, 'EngA', 276266),
(457173, 'PIRSF000606', NULL, NULL, 777, NULL, 'RPS6_kin_2', 276267),
(457174, 'PIRSF017903', NULL, NULL, 196, NULL, 'CPDase_plant', 276268),
(457175, 'PIRSF037988', NULL, NULL, 379, NULL, 'UCP037988', 276269),
(457176, 'PIRSF001110', NULL, NULL, 152, NULL, 'ADOMetase', 276270),
(457177, 'PIRSF009309', NULL, NULL, 213, NULL, 'RE_BamHI', 276271),
(457178, 'PIRSF031475', NULL, NULL, 265, NULL, 'UCP031475', 276272),
(457179, 'PIRSF000101', NULL, NULL, 567, NULL, 'D-lactate_dh', 276273),
(457180, 'PIRSF000517', NULL, NULL, 453, NULL, 'Tyr_transaminase', 276274),
(457181, 'PIRSF016992', NULL, NULL, 273, NULL, 'Txn_fac_GATA_plant', 276275),
(457182, 'PIRSF000267', NULL, NULL, 351, NULL, 'Cyt_oxidse_sub2', 276276),
(457183, 'PIRSF000912', NULL, NULL, 664, NULL, 'PPEF', 276277),
(457184, 'PIRSF026633', NULL, NULL, 497, NULL, 'UCP026633_TfuA-like', 276278),
(457185, 'PIRSF022976', NULL, NULL, 187, NULL, 'NADH_Oxi_21kDa', 276279),
(457186, 'PIRSF029900', NULL, NULL, 719, NULL, 'Alpha-glucuronds', 276280),
(457187, 'PIRSF036541', NULL, NULL, 302, NULL, 'UCP036541_AIR', 276281),
(457188, 'PIRSF002541', NULL, NULL, 132, NULL, 'SP_pAIF', 276282),
(457189, 'PIRSF036750', NULL, NULL, 246, NULL, 'dCMP_HMase', 276283),
(457190, 'PIRSF002290', NULL, NULL, 1688, NULL, 'CHC', 276284),
(457191, 'PIRSF005677', NULL, NULL, 557, NULL, 'PPi_PFK_PfpB', 276285),
(457192, 'PIRSF016951', NULL, NULL, 251, NULL, 'MADP_ribosyltransf_Edin', 276286),
(457193, 'PIRSF000437', NULL, NULL, 796, NULL, 'GPAT_DHAPAT', 276287),
(457194, 'PIRSF015596', NULL, NULL, 262, NULL, '5_alpha-SR2', 276288),
(457195, 'PIRSF032131', NULL, NULL, 142, NULL, 'UCP032131', 276289);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(457196, 'PIRSF000513', NULL, NULL, 263, NULL, 'Thz_kinase', 276290),
(457197, 'PIRSF500230', NULL, NULL, 550, NULL, 'Sterol_acyltranf_ACAT', 276291),
(457198, 'PIRSF000019', NULL, NULL, 85, NULL, 'Bc1_11K', 276292),
(457199, 'PIRSF019240', NULL, NULL, 143, NULL, 'UCP019240_SpoVT/AbrB-related', 276293),
(457200, 'PIRSF039020', NULL, NULL, 122, NULL, 'EhpR', 276294),
(457201, 'PIRSF018634', NULL, NULL, 124, NULL, 'UCP018634', 276295),
(457202, 'PIRSF016521', NULL, NULL, 419, NULL, 'Acyl-CoA_hydro', 276296),
(457203, 'PIRSF032675', NULL, NULL, 466, NULL, 'UCP032675', 276297),
(457204, 'PIRSF000501', NULL, NULL, 380, NULL, 'DHPS_Campy', 276298),
(457205, 'PIRSF016393', NULL, NULL, 104, NULL, 'Enhancer_rudimentary', 276299),
(457206, 'PIRSF008129', NULL, NULL, 228, NULL, 'Noggin', 276300),
(457207, 'PIRSF016897', NULL, NULL, 190, NULL, 'GlpP', 276301),
(457208, 'PIRSF018871', NULL, NULL, 441, NULL, 'UCP018871', 276302),
(457209, 'PIRSF037253', NULL, NULL, 186, NULL, 'HTH_CBS', 276303),
(457210, 'PIRSF000204', NULL, NULL, 468, NULL, 'PNTB', 276304),
(457211, 'PIRSF009562', NULL, NULL, 129, NULL, 'PerB', 276305),
(457212, 'PIRSF037828', NULL, NULL, 110, NULL, 'SAP', 276306),
(457213, 'PIRSF003900', NULL, NULL, 738, NULL, 'N_FiloV', 276307),
(457214, 'PIRSF006641', NULL, NULL, 371, NULL, 'EngD', 276308),
(457215, 'PIRSF029644', NULL, NULL, 528, NULL, 'UCP029644', 276309),
(457216, 'PIRSF005578', NULL, NULL, 265, NULL, 'TlyA', 276310),
(457217, 'PIRSF016839', NULL, NULL, 308, NULL, 'PhP', 276311),
(457218, 'PIRSF014439', NULL, NULL, 222, NULL, 'APE1894_ACT', 276312),
(457219, 'PIRSF028503', NULL, NULL, 550, NULL, 'UCP028503', 276313),
(457220, 'PIRSF021441', NULL, NULL, 163, NULL, 'CcdC', 276314),
(457221, 'PIRSF500700', NULL, NULL, 478, NULL, 'MDM2', 276315),
(457222, 'PIRSF006446', NULL, NULL, 461, NULL, 'Cyt_quinol_oxidase_1', 276316),
(457223, 'PIRSF000336', NULL, NULL, 484, NULL, 'TH', 276317),
(457224, 'PIRSF036521', NULL, NULL, 107, NULL, 'UCP036521_pph', 276318),
(457225, 'PIRSF002513', NULL, NULL, 1822, NULL, 'Integrin_B4', 276319),
(457226, 'PIRSF000398', NULL, NULL, 287, NULL, 'M_m6A_EcoRV', 276320),
(457227, 'PIRSF022393', NULL, NULL, 187, NULL, 'HAP', 276321),
(457228, 'PIRSF036388', NULL, NULL, 431, NULL, 'Ctsl_amnpptdse_B', 276322),
(457229, 'PIRSF028687', NULL, NULL, 148, NULL, 'UCP028687', 276323),
(457230, 'PIRSF036934', NULL, NULL, 730, NULL, 'TrpE-G', 276324),
(457231, 'PIRSF000333', NULL, NULL, 1200, NULL, 'INOS', 276325),
(457232, 'PIRSF011416', NULL, NULL, 203, NULL, 'Ais-TraG-AfrS', 276326),
(457233, 'PIRSF038039', NULL, NULL, 246, NULL, 'UCP038039_Lin-7_homol', 276327),
(457234, 'PIRSF007398', NULL, NULL, 735, NULL, 'Sll0148_casp', 276328),
(457235, 'PIRSF037871', NULL, NULL, 439, NULL, 'TIM44', 276329),
(457236, 'PIRSF036862', NULL, NULL, 638, NULL, 'ERp72', 276330),
(457237, 'PIRSF018748', NULL, NULL, 177, NULL, 'UCP018748', 276331),
(457238, 'PIRSF005627', NULL, NULL, 276, NULL, 'MTD', 276332),
(457239, 'PIRSF037393', NULL, NULL, 561, NULL, 'TGFRII', 276333),
(457240, 'PIRSF037505', NULL, NULL, 363, NULL, 'BHMT', 276334),
(457241, 'PIRSF035918', NULL, NULL, 324, NULL, 'UCP035918', 276335),
(457242, 'PIRSF016789', NULL, NULL, 123, NULL, 'UCP016789', 276336),
(457243, 'PIRSF005658', NULL, NULL, 376, NULL, 'FwdF', 276337),
(457244, 'PIRSF001473', NULL, NULL, 437, NULL, 'FK506-bp_FPR3', 276338),
(457245, 'PIRSF021524', NULL, NULL, 315, NULL, 'MSH_acetyltransferase', 276339),
(457246, 'PIRSF006054', NULL, NULL, 428, NULL, 'UCP006054', 276340),
(457247, 'PIRSF038972', NULL, NULL, 433, NULL, 'Trm12', 276341),
(457248, 'PIRSF037470', NULL, NULL, 346, NULL, 'RRP', 276342),
(457249, 'PIRSF009283', NULL, NULL, 377, NULL, '4HPP_dioxygenase', 276343),
(457250, 'PIRSF000631', NULL, NULL, 1112, NULL, 'TyrPK_receptor_Ret', 276344),
(457251, 'PIRSF035875', NULL, NULL, 306, NULL, 'RNase_BN', 276345),
(457252, 'PIRSF001832', NULL, NULL, 115, NULL, 'PTH', 276346),
(457253, 'PIRSF500061', NULL, NULL, 482, NULL, 'GOGAT_lg2_archl', 276347),
(457254, 'PIRSF028777', NULL, NULL, 131, NULL, 'UCP028777', 276348);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(457255, 'PIRSF036312', NULL, NULL, 2873, NULL, 'Fibrillin', 276349),
(457256, 'PIRSF037010', NULL, NULL, 86, NULL, 'SF3B5', 276350),
(457257, 'PIRSF000401', NULL, NULL, 314, NULL, 'RPL11_MTase', 276351),
(457258, 'PIRSF019322', NULL, NULL, 243, NULL, 'UCP019322', 276352),
(457259, 'PIRSF002560', NULL, NULL, 157, NULL, 'Bacterioferritin', 276353),
(457260, 'PIRSF006500', NULL, NULL, 75, NULL, 'MtrG', 276354),
(457261, 'PIRSF028757', NULL, NULL, 310, NULL, 'LD-carboxypeptidase', 276355),
(457262, 'PIRSF500135', NULL, NULL, 436, NULL, 'GDPman_DH', 276356),
(457263, 'PIRSF037660', NULL, NULL, 146, NULL, 'HA-17', 276357),
(457264, 'PIRSF000148', NULL, NULL, 343, NULL, 'ASA_dh', 276358),
(457265, 'PIRSF000610', NULL, NULL, 870, NULL, 'STPK_YKL171w', 276359),
(457266, 'PIRSF036924', NULL, NULL, 405, NULL, 'Snx5_Snx6', 276360),
(457267, 'PIRSF007043', NULL, NULL, 182, NULL, 'YopQ', 276361),
(457268, 'PIRSF003174', NULL, NULL, 165, NULL, 'CreA', 276362),
(457269, 'PIRSF017340', NULL, NULL, 174, NULL, 'Nudix_hydro', 276363),
(457270, 'PIRSF037029', NULL, NULL, 212, NULL, 'BAG_1', 276364),
(457271, 'PIRSF036573', NULL, NULL, 1025, NULL, 'REV1', 276365),
(457272, 'PIRSF005485', NULL, NULL, 347, NULL, 'HrcA', 276366),
(457273, 'PIRSF001822', NULL, NULL, 72, NULL, 'Dermaseptin_prec', 276367),
(457274, 'PIRSF007103', NULL, NULL, 109, NULL, 'UCP007103', 276368),
(457275, 'PIRSF000723', NULL, NULL, 312, NULL, 'Carbamate_kin', 276369),
(457276, 'PIRSF005357', NULL, NULL, 350, NULL, 'UCP005357', 276370),
(457277, 'PIRSF000587', NULL, NULL, 874, NULL, 'PI3K_Vps34', 276371),
(457278, 'PIRSF038118', NULL, NULL, 470, NULL, 'MBP_jacalin', 276372),
(457279, 'PIRSF001843', NULL, NULL, 126, NULL, 'NKB', 276373),
(457280, 'PIRSF003890', NULL, NULL, 263, NULL, 'LigT_coronavirus', 276374),
(457281, 'PIRSF019271', NULL, NULL, 282, NULL, 'Acid_Ptase_C', 276375),
(457282, 'PIRSF019883', NULL, NULL, 102, NULL, 'UCP019883', 276376),
(457283, 'PIRSF033095', NULL, NULL, 743, NULL, '5NTD_SA0022', 276377),
(457284, 'PIRSF036421', NULL, NULL, 1060, NULL, 'Tricorn_protease', 276378),
(457285, 'PIRSF001480', NULL, NULL, 425, NULL, 'PMI', 276379),
(457286, 'PIRSF030798', NULL, NULL, 126, NULL, 'UCP030798', 276380),
(457287, 'PIRSF002158', NULL, NULL, 267, NULL, 'RPL2p_RPL2a_RPL8e_RPL2o', 276381),
(457288, 'PIRSF004944', NULL, NULL, 308, NULL, 'UCP004944_hydrls', 276382),
(457289, 'PIRSF000898', NULL, NULL, 333, NULL, 'Acid_Ptase_5', 276383),
(457290, 'PIRSF001084', NULL, NULL, 669, NULL, 'B-galactosidase', 276384),
(457291, 'PIRSF006456', NULL, NULL, 128, NULL, 'UCP006456', 276385),
(457292, 'PIRSF005562', NULL, NULL, 2059, NULL, 'FAS_yeast_beta', 276386),
(457293, 'PIRSF037609', NULL, NULL, 170, NULL, 'BLOC-1_pldn', 276387),
(457294, 'PIRSF018461', NULL, NULL, 283, NULL, 'Phage_rep_C1', 276388),
(457295, 'PIRSF000386', NULL, NULL, 250, NULL, 'tRNA_mtase', 276389),
(457296, 'PIRSF032888', NULL, NULL, 377, NULL, 'UCP032888', 276390),
(457297, 'PIRSF036580', NULL, NULL, 518, NULL, 'Cyclin_L', 276391),
(457298, 'PIRSF000559', NULL, NULL, 746, NULL, 'cGMP-dep_kinase', 276392),
(457299, 'PIRSF036441', NULL, NULL, 426, NULL, 'NAGK_DUF619', 276393),
(457300, 'PIRSF003949', NULL, NULL, 430, NULL, 'N_HantaV', 276394),
(457301, 'PIRSF007407', NULL, NULL, 853, NULL, 'UCP007407_Abi', 276395),
(457302, 'PIRSF037434', NULL, NULL, 412, NULL, 'HK_ChrS', 276396),
(457303, 'PIRSF037409', NULL, NULL, 235, NULL, 'UCP037409_transporter', 276397),
(457304, 'PIRSF001831', NULL, NULL, 2770, NULL, 'Thyroglobulin', 276398),
(457305, 'PIRSF036370', NULL, NULL, 855, NULL, 'ST14', 276399),
(457306, 'PIRSF021332', NULL, NULL, 206, NULL, 'UCP021332', 276400),
(457307, 'PIRSF003196', NULL, NULL, 101, NULL, 'Trp_repressor', 276401),
(457308, 'PIRSF006318', NULL, NULL, 141, NULL, 'YhcB', 276402),
(457309, 'PIRSF037874', NULL, NULL, 378, NULL, 'NCK', 276403),
(457310, 'PIRSF037495', NULL, NULL, 476, NULL, 'OoxA/HcnB', 276404),
(457311, 'PIRSF026478', NULL, NULL, 553, NULL, 'UCP026478_dh', 276405),
(457312, 'PIRSF000017', NULL, NULL, 348, NULL, 'RC_cytochrome', 276406);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(457313, 'PIRSF001951', NULL, NULL, 195, NULL, 'EPO', 276407),
(457314, 'PIRSF006157', NULL, NULL, 266, NULL, 'Doxgns_DODA', 276408),
(457315, 'PIRSF009433', NULL, NULL, 365, NULL, 'UCP009433', 276409),
(457316, 'PIRSF029876', NULL, NULL, 110, NULL, 'UCP029876', 276410),
(457317, 'PIRSF037137', NULL, NULL, 434, NULL, 'HPS_DMK', 276411),
(457318, 'PIRSF000371', NULL, NULL, 308, NULL, 'PFLA_YjjW', 276412),
(457319, 'PIRSF006601', NULL, NULL, 260, NULL, 'ATPase_UCP006601', 276413),
(457320, 'PIRSF033093', NULL, NULL, 381, NULL, 'UCP_ML1119', 276414),
(457321, 'PIRSF001905', NULL, NULL, 48, NULL, 'Sea_anemon_toxin', 276415),
(457322, 'PIRSF036948', NULL, NULL, 471, NULL, 'TOM1', 276416),
(457323, 'PIRSF002134', NULL, NULL, 131, NULL, 'RPS13p_RPS13a_RPS18e_RPS13o', 276417),
(457324, 'PIRSF006578', NULL, NULL, 210, NULL, 'FwdE', 276418),
(457325, 'PIRSF031134', NULL, NULL, 404, NULL, 'MTRK', 276419),
(457326, 'PIRSF036543', NULL, NULL, 286, NULL, 'YdrC_chlamyd', 276420),
(457327, 'PIRSF037238', NULL, NULL, 381, NULL, 'Carboxypeptidase_G2', 276421),
(457328, 'PIRSF500773', NULL, NULL, 519, NULL, 'Hyaluronidase_PH20_Hyal5', 276422),
(457329, 'PIRSF037991', NULL, NULL, 457, NULL, 'UCP037991_UBX_2_7', 276423),
(457330, 'PIRSF028729', NULL, NULL, 178, NULL, 'SCF_Skp', 276424),
(457331, 'PIRSF028743', NULL, NULL, 123, NULL, 'GvpO_protein', 276425),
(457332, 'PIRSF019083', NULL, NULL, 171, NULL, 'UCP019083_VanZ', 276426),
(457333, 'PIRSF032178', NULL, NULL, 379, NULL, 'UCP032178', 276427),
(457334, 'PIRSF004638', NULL, NULL, 150, NULL, 'UCP004638', 276428),
(457335, 'PIRSF001348', NULL, NULL, 612, NULL, 'PEP_carboxykin_GTP', 276429),
(457336, 'PIRSF000111', NULL, NULL, 875, NULL, 'ALDH_ADH', 276430),
(457337, 'PIRSF001499', NULL, NULL, 375, NULL, 'Chor_mut_pdh_Tpr', 276431),
(457338, 'PIRSF019693', NULL, NULL, 265, NULL, 'VAMP_assoc_prot', 276432),
(457339, 'PIRSF006272', NULL, NULL, 166, NULL, 'UCP006272', 276433),
(457340, 'PIRSF000933', NULL, NULL, 2487, NULL, 'PTPN13', 276434),
(457341, 'PIRSF036470', NULL, NULL, 824, NULL, 'PLD_plant', 276435),
(457342, 'PIRSF016262', NULL, NULL, 230, NULL, 'LPLase', 276436),
(457343, 'PIRSF033053', NULL, NULL, 411, NULL, 'UCP033503_fimbr', 276437),
(457344, 'PIRSF012562', NULL, NULL, 267, NULL, 'UCP012562', 276438),
(457345, 'PIRSF037471', NULL, NULL, 396, NULL, 'UCP037471', 276439),
(457346, 'PIRSF000090', NULL, NULL, 268, NULL, 'Beta-ETF', 276440),
(457347, 'PIRSF037568', NULL, NULL, 1385, NULL, 'ROCK', 276441),
(457348, 'PIRSF038036', NULL, NULL, 214, NULL, 'Cdc42ep2', 276442),
(457349, 'PIRSF038132', NULL, NULL, 302, NULL, 'NUDIX_AtNUDT22', 276443),
(457350, 'PIRSF010056', NULL, NULL, 188, NULL, 'UCP010056', 276444),
(457351, 'PIRSF032572', NULL, NULL, 123, NULL, 'MUB', 276445),
(457352, 'PIRSF016175', NULL, NULL, 277, NULL, 'UCP016175', 276446),
(457353, 'PIRSF500948', NULL, NULL, 1098, NULL, 'Beta-PDGF_receptor', 276447),
(457354, 'PIRSF003854', NULL, NULL, 198, NULL, 'Vif_BLV', 276448),
(457355, 'PIRSF037931', NULL, NULL, 1065, NULL, 'TMPRSS9_polyserase-1', 276449),
(457356, 'PIRSF007248', NULL, NULL, 103, NULL, 'UCP007248', 276450),
(457357, 'PIRSF000440', NULL, NULL, 215, NULL, 'CAT', 276451),
(457358, 'PIRSF015000', NULL, NULL, 240, NULL, 'UCP01500', 276452),
(457359, 'PIRSF038156', NULL, NULL, 165, NULL, 'RNA_polymII_KELP', 276453),
(457360, 'PIRSF036593', NULL, NULL, 383, NULL, 'GrdD', 276454),
(457361, 'PIRSF009404', NULL, NULL, 353, NULL, 'Txn_factor_DP', 276455),
(457362, 'PIRSF002129', NULL, NULL, 247, NULL, 'RPS6e', 276456),
(457363, 'PIRSF017388', NULL, NULL, 248, NULL, 'Esterase_lipase', 276457),
(457364, 'PIRSF028299', NULL, NULL, 123, NULL, 'UCP028299', 276458),
(457365, 'PIRSF037178', NULL, NULL, 325, NULL, 'TTR-like', 276459),
(457366, 'PIRSF000164', NULL, NULL, 349, NULL, 'DHO_oxidase', 276460),
(457367, 'PIRSF037136', NULL, NULL, 595, NULL, 'RKM1', 276461),
(457368, 'PIRSF031277', NULL, NULL, 357, NULL, 'UCP031277', 276462),
(457369, 'PIRSF038953', NULL, NULL, 253, NULL, 'SigI', 276463),
(457370, 'PIRSF000162', NULL, NULL, 429, NULL, 'P_chlorophyll_rd', 276464);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(457371, 'PIRSF038149', NULL, NULL, 430, NULL, 'Pyruvate_Pi_dikinase_reg', 276465),
(457372, 'PIRSF000303', NULL, NULL, 191, NULL, 'Glutathion_perox', 276466),
(457373, 'PIRSF023803', NULL, NULL, 162, NULL, 'RNase_P', 276467),
(457374, 'PIRSF039008', NULL, NULL, 66, NULL, 'YjbJ', 276468),
(457375, 'PIRSF037219', NULL, NULL, 369, NULL, 'NOS_oxygenase', 276469),
(457376, 'PIRSF001330', NULL, NULL, 261, NULL, 'IOD', 276470),
(457377, 'PIRSF007871', NULL, NULL, 193, NULL, 'Cox20', 276471),
(457378, 'PIRSF012320', NULL, NULL, 156, NULL, 'Prplsmic_HI0178', 276472),
(457379, 'PIRSF036911', NULL, NULL, 220, NULL, 'CREG', 276473),
(457380, 'PIRSF000533', NULL, NULL, 889, NULL, 'ATP_PFK_euk', 276474),
(457381, 'PIRSF010219', NULL, NULL, 227, NULL, 'UCP010219', 276475),
(457382, 'PIRSF017288', NULL, NULL, 459, NULL, 'PMK_GHMP_euk', 276476),
(457383, 'PIRSF016138', NULL, NULL, 190, NULL, 'UCP016138', 276477),
(457384, 'PIRSF029962', NULL, NULL, 93, NULL, 'UCP029962', 276478),
(457385, 'PIRSF028561', NULL, NULL, 323, NULL, 'Ac_Trasf', 276479),
(457386, 'PIRSF037955', NULL, NULL, 341, NULL, 'Snurportin-1', 276480),
(457387, 'PIRSF015875', NULL, NULL, 148, NULL, 'UCP015875', 276481),
(457388, 'PIRSF036548', NULL, NULL, 96, NULL, 'Fdx_FixX', 276482),
(457389, 'PIRSF037865', NULL, NULL, 320, NULL, 'DFF_alpha', 276483),
(457390, 'PIRSF000412', NULL, NULL, 450, NULL, 'SHMT', 276484),
(457391, 'PIRSF037971', NULL, NULL, 364, NULL, 'TLX_CD46', 276485),
(457392, 'PIRSF500808', NULL, NULL, 820, NULL, 'PTPR_alpha', 276486),
(457393, 'PIRSF011609', NULL, NULL, 308, NULL, 'DRT102', 276487),
(457394, 'PIRSF026434', NULL, NULL, 567, NULL, 'RR_ycf55', 276488),
(457395, 'PIRSF011282', NULL, NULL, 236, NULL, 'Synaptogyrin', 276489),
(457396, 'PIRSF037420', NULL, NULL, 377, NULL, 'PqqE', 276490),
(457397, 'PIRSF001665', NULL, NULL, 52, NULL, 'PLB', 276491),
(457398, 'PIRSF003766', NULL, NULL, 75, NULL, 'VAC_I2L', 276492),
(457399, 'PIRSF036630', NULL, NULL, 566, NULL, 'Aconts_X_fused', 276493),
(457400, 'PIRSF032067', NULL, NULL, 509, NULL, 'Cyanophycinase', 276494),
(457401, 'PIRSF000171', NULL, NULL, 586, NULL, 'SDHA_APRA_LASPO', 276495),
(457402, 'PIRSF017228', NULL, NULL, 338, NULL, 'Sphnglp_dlt4_des', 276496),
(457403, 'PIRSF012641', NULL, NULL, 349, NULL, 'UCP012641', 276497),
(457404, 'PIRSF000180', NULL, NULL, 129, NULL, 'FrdC', 276498),
(457405, 'PIRSF011091', NULL, NULL, 720, NULL, 'BBS7', 276499),
(457406, 'PIRSF037709', NULL, NULL, 120, NULL, 'DOV-IR', 276500),
(457407, 'PIRSF004030', NULL, NULL, 95, NULL, 'Z_ArenaV', 276501),
(457408, 'PIRSF008292', NULL, NULL, 235, NULL, 'UCP008292', 276502),
(457409, 'PIRSF006162', NULL, NULL, 173, NULL, 'PgpA', 276503),
(457410, 'PIRSF020217', NULL, NULL, 116, NULL, 'UCP020217', 276504),
(457411, 'PIRSF021719', NULL, NULL, 205, NULL, 'UCP021719', 276505),
(457412, 'PIRSF003669', NULL, NULL, 256, NULL, 'Aden_E1A', 276506),
(457413, 'PIRSF028609', NULL, NULL, 103, NULL, 'UCP028609', 276507),
(457414, 'PIRSF000181', NULL, NULL, 158, NULL, 'Grc_selenoprot_A', 276508),
(457415, 'PIRSF016095', NULL, NULL, 445, NULL, 'VirD2', 276509),
(457416, 'PIRSF005426', NULL, NULL, 249, NULL, 'Frp', 276510),
(457417, 'PIRSF026449', NULL, NULL, 462, NULL, 'UCP026449', 276511),
(457418, 'PIRSF037465', NULL, NULL, 75, NULL, 'UCP037465_Zn', 276512),
(457419, 'PIRSF020481', NULL, NULL, 295, NULL, 'BAP', 276513),
(457420, 'PIRSF500183', NULL, NULL, 728, NULL, 'Hepatocyte_GF', 276514),
(457421, 'PIRSF033909', NULL, NULL, 377, NULL, 'UCP033909', 276515),
(457422, 'PIRSF031715', NULL, NULL, 623, NULL, 'CobT_chel', 276516),
(457423, 'PIRSF036945', NULL, NULL, 1090, NULL, 'Spt5', 276517),
(457424, 'PIRSF028934', NULL, NULL, 390, NULL, 'Cyclin_CG14939', 276518),
(457425, 'PIRSF003768', NULL, NULL, 79, NULL, 'VAC_I5L', 276519),
(457426, 'PIRSF003784', NULL, NULL, 117, NULL, 'VAC_N1L', 276520),
(457427, 'PIRSF016552', NULL, NULL, 230, NULL, 'MtrD', 276521),
(457428, 'PIRSF028162', NULL, NULL, 239, NULL, 'BcbE', 276522),
(457429, 'PIRSF038021', NULL, NULL, 302, NULL, 'UCP038021_RWDD2', 276523),
(457430, 'PIRSF029225', NULL, NULL, 131, NULL, 'DNA_pol_III_psi', 276524);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(457431, 'PIRSF006661', NULL, NULL, 274, NULL, 'UCP006661_PP-loop', 276525),
(457432, 'PIRSF028065', NULL, NULL, 149, NULL, 'UCP028065', 276526),
(457433, 'PIRSF004574', NULL, NULL, 128, NULL, 'RepA4', 276527),
(457434, 'PIRSF000661', NULL, NULL, 798, NULL, 'STPK_RAD53', 276528),
(457435, 'PIRSF036489', NULL, NULL, 904, NULL, '10-FTHFDH', 276529),
(457436, 'PIRSF038922', NULL, NULL, 662, NULL, 'SRP72', 276530),
(457437, 'PIRSF001145', NULL, NULL, 563, NULL, 'Tissue_plasm_act', 276531),
(457438, 'PIRSF028773', NULL, NULL, 111, NULL, 'UCP028773', 276532),
(457439, 'PIRSF005813', NULL, NULL, 923, NULL, 'MSH2', 276533),
(457440, 'PIRSF011869', NULL, NULL, 786, NULL, 'Nibrin_animal', 276534),
(457441, 'PIRSF001237', NULL, NULL, 349, NULL, 'Dihydroorotase', 276535),
(457442, 'PIRSF000876', NULL, NULL, 358, NULL, 'RR_chemtxs_CheB', 276536),
(457443, 'PIRSF500794', NULL, NULL, 454, NULL, 'Thiamine_transporter_1', 276537),
(457444, 'PIRSF030989', NULL, NULL, 468, NULL, 'Glycoporin_RafY', 276538),
(457445, 'PIRSF017535', NULL, NULL, 218, NULL, 'ESCRT1_Vps28', 276539),
(457446, 'PIRSF038141', NULL, NULL, 976, NULL, 'PP1_12ABC_vert', 276540),
(457447, 'PIRSF017023', NULL, NULL, 572, NULL, 'KNR4', 276541),
(457448, 'PIRSF020818', NULL, NULL, 424, NULL, 'PHB_depoly', 276542),
(457449, 'PIRSF001273', NULL, NULL, 253, NULL, 'CDH', 276543),
(457450, 'PIRSF037578', NULL, NULL, 1191, NULL, 'MAPKKK_STE11_Cryp', 276544),
(457451, 'PIRSF021497', NULL, NULL, 254, NULL, 'Sulfotransf_LpsS', 276545),
(457452, 'PIRSF036400', NULL, NULL, 264, NULL, 'RR_Ctr_UCP036400', 276546),
(457453, 'PIRSF037246', NULL, NULL, 77, NULL, 'UCP037246', 276547),
(457454, 'PIRSF001849', NULL, NULL, 114, NULL, 'Guanylin', 276548),
(457455, 'PIRSF005149', NULL, NULL, 367, NULL, 'IPC-B_HD', 276549),
(457456, 'PIRSF004654', NULL, NULL, 307, NULL, 'NlpI', 276550),
(457457, 'PIRSF005825', NULL, NULL, 73, NULL, 'PufQ', 276551),
(457458, 'PIRSF017371', NULL, NULL, 145, NULL, 'UCP017371', 276552),
(457459, 'PIRSF000040', NULL, NULL, 344, NULL, 'MMOH_comp', 276553),
(457460, 'PIRSF002070', NULL, NULL, 160, NULL, 'SSB', 276554),
(457461, 'PIRSF004955', NULL, NULL, 266, NULL, 'HTH_arch', 276555),
(457462, 'PIRSF026760', NULL, NULL, 353, NULL, 'UCP026760', 276556),
(457463, 'PIRSF024622', NULL, NULL, 185, NULL, 'Tfp_FimT', 276557),
(457464, 'PIRSF003059', NULL, NULL, 549, NULL, 'GtfA', 276558),
(457465, 'PIRSF000390', NULL, NULL, 381, NULL, 'PLP_StrS', 276559),
(457466, 'PIRSF003273', NULL, NULL, 589, NULL, 'Mobilization_A', 276560),
(457467, 'PIRSF011491', NULL, NULL, 225, NULL, 'Mtase_YbcY', 276561),
(457468, 'PIRSF026640', NULL, NULL, 191, NULL, 'Peripl_chor_mut', 276562),
(457469, 'PIRSF009415', NULL, NULL, 108, NULL, 'TFIIA_gamma_hum', 276563),
(457470, 'PIRSF002936', NULL, NULL, 302, NULL, 'SAT_2', 276564),
(457471, 'PIRSF024608', NULL, NULL, 209, NULL, 'UCP024608', 276565),
(457472, 'PIRSF037646', NULL, NULL, 1252, NULL, 'Apaf_1', 276566),
(457473, 'PIRSF001007', NULL, NULL, 121, NULL, 'RusA', 276567),
(457474, 'PIRSF000641', NULL, NULL, 855, NULL, 'SRK', 276568),
(457475, 'PIRSF034659', NULL, NULL, 179, NULL, 'Vir_TviA', 276569),
(457476, 'PIRSF037827', NULL, NULL, 194, NULL, 'Bcl-2-like_11', 276570),
(457477, 'PIRSF005856', NULL, NULL, 326, NULL, 'Rad51', 276571),
(457478, 'PIRSF025560', NULL, NULL, 113, NULL, 'UCP025560', 276572),
(457479, 'PIRSF000817', NULL, NULL, 507, NULL, 'Nucleotidyltrnsf', 276573),
(457480, 'PIRSF002884', NULL, NULL, 225, NULL, 'CheZ', 276574),
(457481, 'PIRSF018539', NULL, NULL, 271, NULL, 'CDT_B', 276575),
(457482, 'PIRSF009530', NULL, NULL, 122, NULL, 'Nvp', 276576),
(457483, 'PIRSF029393', NULL, NULL, 174, NULL, 'UCP029393', 276577),
(457484, 'PIRSF004692', NULL, NULL, 330, NULL, 'KdsD_KpsF', 276578),
(457485, 'PIRSF000624', NULL, NULL, 860, NULL, 'TyrPK_TMrec_ROR', 276579),
(457486, 'PIRSF001478', NULL, NULL, 499, NULL, 'L-ara_isomerase', 276580),
(457487, 'PIRSF005852', NULL, NULL, 510, NULL, 'UCP005852', 276581),
(457488, 'PIRSF003203', NULL, NULL, 109, NULL, 'AzlD', 276582),
(457489, 'PIRSF021774', NULL, NULL, 132, NULL, 'UCP021774', 276583);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(457490, 'PIRSF011221', NULL, NULL, 250, NULL, 'Chloropl_CC', 276584),
(457491, 'PIRSF001259', NULL, NULL, 407, NULL, 'RibA', 276585),
(457492, 'PIRSF005639', NULL, NULL, 203, NULL, 'Glut_amidoT_SNO', 276586),
(457493, 'PIRSF015965', NULL, NULL, 925, NULL, '26S_protsm_Rpn1', 276587),
(457494, 'PIRSF004486', NULL, NULL, 308, NULL, 'MraW', 276588),
(457495, 'PIRSF014872', NULL, NULL, 527, NULL, 'UCP014872', 276589),
(457496, 'PIRSF015853', NULL, NULL, 274, NULL, 'Pep_DppA', 276590),
(457497, 'PIRSF002888', NULL, NULL, 339, NULL, 'FliM', 276591),
(457498, 'PIRSF026579', NULL, NULL, 183, NULL, 'SpoVT', 276592),
(457499, 'PIRSF037338', NULL, NULL, 605, NULL, 'Spastin', 276593),
(457500, 'PIRSF033111', NULL, NULL, 230, NULL, 'UCP033111', 276594),
(457501, 'PIRSF010603', NULL, NULL, 106, NULL, 'UCP010603', 276595),
(457502, 'PIRSF017888', NULL, NULL, 230, NULL, 'CPSF-25', 276596),
(457503, 'PIRSF018250', NULL, NULL, 369, NULL, 'Saccharopine_DH_Lys', 276597),
(457504, 'PIRSF500625', NULL, NULL, 510, NULL, 'Cytochrome_CYP7A1', 276598),
(457505, 'PIRSF004967', NULL, NULL, 366, NULL, 'DPH1', 276599),
(457506, 'PIRSF009193', NULL, NULL, 187, NULL, 'UCP009193', 276600),
(457507, 'PIRSF006444', NULL, NULL, 439, NULL, 'PaaK', 276601),
(457508, 'PIRSF500165', NULL, NULL, 344, NULL, 'HMDI', 276602),
(457509, 'PIRSF020632', NULL, NULL, 110, NULL, 'YeaR', 276603),
(457510, 'PIRSF018234', NULL, NULL, 521, NULL, 'Pp1_interacting', 276604),
(457511, 'PIRSF038055', NULL, NULL, 553, NULL, 'Nas9_nas10_nas11', 276605),
(457512, 'PIRSF000292', NULL, NULL, 312, NULL, 'Ubiqnol_oxid_II', 276606),
(457513, 'PIRSF500064', NULL, NULL, 820, NULL, 'GPAT', 276607),
(457514, 'PIRSF037488', NULL, NULL, 645, NULL, 'Miro', 276608),
(457515, 'PIRSF036894', NULL, NULL, 316, NULL, 'PMI_Firm_short', 276609),
(457516, 'PIRSF013503', NULL, NULL, 267, NULL, 'OTUB', 276610),
(457517, 'PIRSF038941', NULL, NULL, 381, NULL, 'NspC', 276611),
(457518, 'PIRSF028998', NULL, NULL, 217, NULL, 'GINS_PSF2', 276612),
(457519, 'PIRSF000159', NULL, NULL, 1183, NULL, 'NifJ', 276613),
(457520, 'PIRSF006816', NULL, NULL, 260, NULL, 'Cyc3_hyd_g', 276614),
(457521, 'PIRSF018072', NULL, NULL, 151, NULL, 'UCP018072', 276615),
(457522, 'PIRSF002746', NULL, NULL, 458, NULL, 'Gluconate_transporter', 276616),
(457523, 'PIRSF028340', NULL, NULL, 137, NULL, 'UCP028340', 276617),
(457524, 'PIRSF036506', NULL, NULL, 660, NULL, 'MtRNA_frt_NDPSE', 276618),
(457525, 'PIRSF033490', NULL, NULL, 115, NULL, 'MazF', 276619),
(457526, 'PIRSF000126', NULL, NULL, 311, NULL, '11-beta-HSD1', 276620),
(457527, 'PIRSF029669', NULL, NULL, 206, NULL, 'UCP029669', 276621),
(457528, 'PIRSF000108', NULL, NULL, 428, NULL, 'IDH_NADP', 276622),
(457529, 'PIRSF016602', NULL, NULL, 139, NULL, 'CurC', 276623),
(457530, 'PIRSF000722', NULL, NULL, 404, NULL, 'Acetate_prop_kin', 276624),
(457531, 'PIRSF007010', NULL, NULL, 134, NULL, 'UCP007010', 276625),
(457532, 'PIRSF005682', NULL, NULL, 491, NULL, 'Fascin', 276626),
(457533, 'PIRSF500699', NULL, NULL, 491, NULL, 'MDM4', 276627),
(457534, 'PIRSF037893', NULL, NULL, 851, NULL, 'Subtilisin_rel_Maqu_2796', 276628),
(457535, 'PIRSF039032', NULL, NULL, 113, NULL, 'HigB-2', 276629),
(457536, 'PIRSF006515', NULL, NULL, 355, NULL, 'KRR1', 276630),
(457537, 'PIRSF000552', NULL, NULL, 905, NULL, 'PKC_mu_nu_D2', 276631),
(457538, 'PIRSF000619', NULL, NULL, 1277, NULL, 'TyrPK_EGF-R', 276632),
(457539, 'PIRSF004159', NULL, NULL, 179, NULL, 'VGG', 276633),
(457540, 'PIRSF036459', NULL, NULL, 869, NULL, 'DAP_dec_asp_kin', 276634),
(457541, 'PIRSF011396', NULL, NULL, 507, NULL, 'Trp_halogenase', 276635),
(457542, 'PIRSF003781', NULL, NULL, 199, NULL, 'VAC_C5L', 276636),
(457543, 'PIRSF000969', NULL, NULL, 87, NULL, '3_5-cGMP_Pdiesterase_gamma', 276637),
(457544, 'PIRSF001069', NULL, NULL, 149, NULL, 'Lytic_enz_p15', 276638),
(457545, 'PIRSF005567', NULL, NULL, 883, NULL, 'Beta''-COP', 276639),
(457546, 'PIRSF037053', NULL, NULL, 99, NULL, 'UCP037053', 276640),
(457547, 'PIRSF007466', NULL, NULL, 492, NULL, 'SpoIVA', 276641),
(457548, 'PIRSF017018', NULL, NULL, 185, NULL, 'Tp34', 276642);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(457549, 'PIRSF000507', NULL, NULL, 243, NULL, 'IPT', 276643),
(457550, 'PIRSF000514', NULL, NULL, 1575, NULL, 'Pentafunct_AroM', 276644),
(457551, 'PIRSF000604', NULL, NULL, 615, NULL, 'TyrPK_SYK', 276645),
(457552, 'PIRSF006787', NULL, NULL, 579, NULL, 'Hydrgn_mat_HoxX', 276646),
(457553, 'PIRSF000368', NULL, NULL, 177, NULL, 'Anaer_RNR_III_small', 276647),
(457554, 'PIRSF002690', NULL, NULL, 267, NULL, 'Plant_L_lectin', 276648),
(457555, 'PIRSF021435', NULL, NULL, 172, NULL, 'SpoIIIAB', 276649),
(457556, 'PIRSF018147', NULL, NULL, 218, NULL, 'ORM1', 276650),
(457557, 'PIRSF018153', NULL, NULL, 442, NULL, 'Glycolip_mannosyltransf_fung', 276651),
(457558, 'PIRSF036411', NULL, NULL, 331, NULL, 'ATR_PduO', 276652),
(457559, 'PIRSF037090', NULL, NULL, 950, NULL, 'IGluLR_plant', 276653),
(457560, 'PIRSF008505', NULL, NULL, 160, NULL, 'UCP008505', 276654),
(457561, 'PIRSF036640', NULL, NULL, 594, NULL, 'FPGT', 276655),
(457562, 'PIRSF001362', NULL, NULL, 431, NULL, 'ICL', 276656),
(457563, 'PIRSF001586', NULL, NULL, 243, NULL, 'FGAM_synth_I', 276657),
(457564, 'PIRSF004932', NULL, NULL, 145, NULL, 'DNA_bp_Tfx', 276658),
(457565, 'PIRSF038057', NULL, NULL, 496, NULL, 'Hatching_uvs2', 276659),
(457566, 'PIRSF003299', NULL, NULL, 224, NULL, 'VirB8_PtlE', 276660),
(457567, 'PIRSF026782', NULL, NULL, 361, NULL, 'CbiD', 276661),
(457568, 'PIRSF028696', NULL, NULL, 336, NULL, 'UCP028696', 276662),
(457569, 'PIRSF001097', NULL, NULL, 290, NULL, 'Agarase', 276663),
(457570, 'PIRSF037738', NULL, NULL, 239, NULL, 'UCP037738', 276664),
(457571, 'PIRSF015793', NULL, NULL, 648, NULL, 'VAC_EEV', 276665),
(457572, 'PIRSF009431', NULL, NULL, 608, NULL, 'UCP009431', 276666),
(457573, 'PIRSF012666', NULL, NULL, 500, NULL, 'UCP012666', 276667),
(457574, 'PIRSF021383', NULL, NULL, 239, NULL, 'YunB', 276668),
(457575, 'PIRSF001444', NULL, NULL, 854, NULL, 'Adenylate_cycl', 276669),
(457576, 'PIRSF002465', NULL, NULL, 341, NULL, 'Phsphlp_syn_PlsX', 276670),
(457577, 'PIRSF010256', NULL, NULL, 395, NULL, 'CoxE_vWa', 276671),
(457578, 'PIRSF021494', NULL, NULL, 345, NULL, 'Rv0216', 276672),
(457579, 'PIRSF032474', NULL, NULL, 166, NULL, 'Rot', 276673),
(457580, 'PIRSF000163', NULL, NULL, 495, NULL, 'ChlB', 276674),
(457581, 'PIRSF006519', NULL, NULL, 234, NULL, 'GOGAT_dom3', 276675),
(457582, 'PIRSF037161', NULL, NULL, 789, NULL, 'PRDM4', 276676),
(457583, 'PIRSF037262', NULL, NULL, 73, NULL, 'UCP037262', 276677),
(457584, 'PIRSF000278', NULL, NULL, 84, NULL, 'COX_VIb', 276678),
(457585, 'PIRSF500628', NULL, NULL, 500, NULL, 'PTGIS', 276679),
(457586, 'PIRSF020687', NULL, NULL, 152, NULL, 'UCP020687', 276680),
(457587, 'PIRSF018938', NULL, NULL, 139, NULL, 'UCP018938', 276681),
(457588, 'PIRSF015601', NULL, NULL, 244, NULL, 'MTase_slr0722', 276682),
(457589, 'PIRSF018431', NULL, NULL, 138, NULL, 'Molluscan_insulin_rel_peptide', 276683),
(457590, 'PIRSF005850', NULL, NULL, 454, NULL, 'UCP005850', 276684),
(457591, 'PIRSF037618', NULL, NULL, 726, NULL, 'RNA_Mtase_bacterial', 276685),
(457592, 'PIRSF015244', NULL, NULL, 436, NULL, 'UCP015244', 276686),
(457593, 'PIRSF500102', NULL, NULL, 574, NULL, 'ER-b', 276687),
(457594, 'PIRSF036537', NULL, NULL, 74, NULL, 'EhaI', 276688),
(457595, 'PIRSF019136', NULL, NULL, 226, NULL, 'EhaG', 276689),
(457596, 'PIRSF036436', NULL, NULL, 394, NULL, 'UCP036436_permease', 276690),
(457597, 'PIRSF006909', NULL, NULL, 103, NULL, 'UCP006909', 276691),
(457598, 'PIRSF037901', NULL, NULL, 603, NULL, 'Subtilisin_rel_Nmul_A1891', 276692),
(457599, 'PIRSF017617', NULL, NULL, 362, NULL, 'Thr_aldolase', 276693),
(457600, 'PIRSF000290', NULL, NULL, 602, NULL, 'PPO_plant', 276694),
(457601, 'PIRSF018162', NULL, NULL, 356, NULL, 'TRAMP_AIR', 276695),
(457602, 'PIRSF038895', NULL, NULL, 513, NULL, 'FPGS', 276696),
(457603, 'PIRSF009376', NULL, NULL, 1146, NULL, 'PLD_euk', 276697),
(457604, 'PIRSF021697', NULL, NULL, 156, NULL, 'UCP021697', 276698),
(457605, 'PIRSF027923', NULL, NULL, 325, NULL, 'Rubrer_027923', 276699),
(457606, 'PIRSF007948', NULL, NULL, 105, NULL, 'Wun1', 276700),
(457607, 'PIRSF015557', NULL, NULL, 386, NULL, 'UCP015557', 276701);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(457608, 'PIRSF015283', NULL, NULL, 346, NULL, 'RpfE', 276702),
(457609, 'PIRSF038007', NULL, NULL, 333, NULL, 'IL-12B', 276703),
(457610, 'PIRSF016564', NULL, NULL, 125, NULL, 'NDUS6', 276704),
(457611, 'PIRSF029792', NULL, NULL, 335, NULL, 'Pro_racemase', 276705),
(457612, 'PIRSF028301', NULL, NULL, 176, NULL, 'UCP028301', 276706),
(457613, 'PIRSF005461', NULL, NULL, 222, NULL, '23S_rRNA_mtase', 276707),
(457614, 'PIRSF011502', NULL, NULL, 609, NULL, 'DdrA_PduG', 276708),
(457615, 'PIRSF020680', NULL, NULL, 202, NULL, 'PhnH', 276709),
(457616, 'PIRSF019423', NULL, NULL, 325, NULL, 'NMN_biosyn', 276710),
(457617, 'PIRSF002097', NULL, NULL, 99, NULL, 'DNA-bp_Fis', 276711),
(457618, 'PIRSF012290', NULL, NULL, 235, NULL, 'EutL_PduB', 276712),
(457619, 'PIRSF004525', NULL, NULL, 194, NULL, 'Pilin_peptidase-dep_B', 276713),
(457620, 'PIRSF032038', NULL, NULL, 180, NULL, 'UCP023238', 276714),
(457621, 'PIRSF036931', NULL, NULL, 400, NULL, 'Doc2', 276715),
(457622, 'PIRSF017302', NULL, NULL, 455, NULL, 'Gltscr2', 276716),
(457623, 'PIRSF018001', NULL, NULL, 319, NULL, 'Aspartoacylase', 276717),
(457624, 'PIRSF007159', NULL, NULL, 273, NULL, 'Protease_ASVF', 276718),
(457625, 'PIRSF020870', NULL, NULL, 361, NULL, 'Radical_SAM_bac', 276719),
(457626, 'PIRSF016049', NULL, NULL, 388, NULL, 'Mann_dehydr_UxuA', 276720),
(457627, 'PIRSF008109', NULL, NULL, 108, NULL, 'RFamide_ACEP-1', 276721),
(457628, 'PIRSF006487', NULL, NULL, 791, NULL, 'GCST', 276722),
(457629, 'PIRSF000452', NULL, NULL, 152, NULL, '6-N-acetyltransf', 276723),
(457630, 'PIRSF030200', NULL, NULL, 99, NULL, 'PaaB', 276724),
(457631, 'PIRSF018868', NULL, NULL, 193, NULL, 'UCP018868', 276725),
(457632, 'PIRSF003352', NULL, NULL, 298, NULL, 'MAK16', 276726),
(457633, 'PIRSF037291', NULL, NULL, 87, NULL, 'UCP037291_gluthr', 276727),
(457634, 'PIRSF002939', NULL, NULL, 216, NULL, 'IF_sigma_H', 276728),
(457635, 'PIRSF005285', NULL, NULL, 166, NULL, 'tRNA_splic_endonuc_archaea', 276729),
(457636, 'PIRSF018455', NULL, NULL, 307, NULL, 'MepA', 276730),
(457637, 'PIRSF003817', NULL, NULL, 3416, NULL, 'Gen_Poly_FLV', 276731),
(457638, 'PIRSF000854', NULL, NULL, 796, NULL, 'PEP_synthase', 276732),
(457639, 'PIRSF000429', NULL, NULL, 401, NULL, 'Ac-CoA_Ac_transf', 276733),
(457640, 'PIRSF031611', NULL, NULL, 152, NULL, 'ComGF', 276734),
(457641, 'PIRSF011560', NULL, NULL, 190, NULL, 'ComK', 276735),
(457642, 'PIRSF025725', NULL, NULL, 287, NULL, 'UCP025725', 276736),
(457643, 'PIRSF000512', NULL, NULL, 349, NULL, 'TMP_PPase_Cyanobac', 276737),
(457644, 'PIRSF001625', NULL, NULL, 145, NULL, 'Prot_inhib_pacifastin', 276738),
(457645, 'PIRSF000620', NULL, NULL, 1378, NULL, 'Insulin_receptor', 276739),
(457646, 'PIRSF033949', NULL, NULL, 258, NULL, 'Phosest_Mlr3352', 276740),
(457647, 'PIRSF002394', NULL, NULL, 357, NULL, 'GNBP_B', 276741),
(457648, 'PIRSF004311', NULL, NULL, 236, NULL, 'SSB_T7', 276742),
(457649, 'PIRSF037941', NULL, NULL, 421, NULL, 'TMPRSS11ABCDE', 276743),
(457650, 'PIRSF010252', NULL, NULL, 180, NULL, 'ZapC', 276744),
(457651, 'PIRSF002530', NULL, NULL, 515, NULL, 'FTZ-F1', 276745),
(457652, 'PIRSF018557', NULL, NULL, 177, NULL, 'DAN', 276746),
(457653, 'PIRSF037634', NULL, NULL, 284, NULL, 'HS1-bp', 276747),
(457654, 'PIRSF019313', NULL, NULL, 125, NULL, 'UCP019313', 276748),
(457655, 'PIRSF003033', NULL, NULL, 621, NULL, 'Ku70', 276749),
(457656, 'PIRSF019202', NULL, NULL, 232, NULL, 'UCP019202', 276750),
(457657, 'PIRSF016919', NULL, NULL, 194, NULL, 'HupE_UreJ', 276751),
(457658, 'PIRSF000880', NULL, NULL, 408, NULL, 'Eryth_est', 276752),
(457659, 'PIRSF004108', NULL, NULL, 317, NULL, 'Coat_Tenuivirus', 276753),
(457660, 'PIRSF001138', NULL, NULL, 1034, NULL, 'Enteropeptidase', 276754),
(457661, 'PIRSF034585', NULL, NULL, 1011, NULL, 'SrfB', 276755),
(457662, 'PIRSF037096', NULL, NULL, 1088, NULL, 'AP3_beta', 276756),
(457663, 'PIRSF037999', NULL, NULL, 435, NULL, 'TNFR_3_LTBR', 276757),
(457664, 'PIRSF005622', NULL, NULL, 368, NULL, 'Hydrgn_mat_hypD', 276758),
(457665, 'PIRSF015618', NULL, NULL, 349, NULL, 'BHLH_neuroD', 276759);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(457666, 'PIRSF017494', NULL, NULL, 357, NULL, 'Thiazolinyl_imide_reduct_YbtU', 276760),
(457667, 'PIRSF000130', NULL, NULL, 493, NULL, 'IMPDH', 276761),
(457668, 'PIRSF003078', NULL, NULL, 216, NULL, 'GidB', 276762),
(457669, 'PIRSF017306', NULL, NULL, 160, NULL, 'Ureidoglycolate_hydrolase', 276763),
(457670, 'PIRSF015589', NULL, NULL, 708, NULL, 'PPK_bact', 276764),
(457671, 'PIRSF015691', NULL, NULL, 343, NULL, 'VAC_E5R', 276765),
(457672, 'PIRSF001600', NULL, NULL, 341, NULL, 'DNA_ligase_T3', 276766),
(457673, 'PIRSF015877', NULL, NULL, 208, NULL, 'UCP015877', 276767),
(457674, 'PIRSF036778', NULL, NULL, 273, NULL, 'UCP036778', 276768),
(457675, 'PIRSF006346', NULL, NULL, 447, NULL, 'Ni_metllenz_mat', 276769),
(457676, 'PIRSF002368', NULL, NULL, 448, NULL, 'Clusterin', 276770),
(457677, 'PIRSF015901', NULL, NULL, 186, NULL, 'NAC_alpha', 276771),
(457678, 'PIRSF021438', NULL, NULL, 392, NULL, 'DltD', 276772),
(457679, 'PIRSF501107', NULL, NULL, 683, NULL, 'Protein_kin_C_eta', 276773),
(457680, 'PIRSF038166', NULL, NULL, 227, NULL, 'DMRL_synth_chloropl', 276774),
(457681, 'PIRSF024865', NULL, NULL, 175, NULL, 'UCP024865', 276775),
(457682, 'PIRSF030959', NULL, NULL, 249, NULL, 'UCP030959', 276776),
(457683, 'PIRSF004557', NULL, NULL, 453, NULL, 'SecY_Sec61alpha', 276777),
(457684, 'PIRSF015690', NULL, NULL, 272, NULL, 'VAC_E8R', 276778),
(457685, 'PIRSF015761', NULL, NULL, 388, NULL, 'Protein_L', 276779),
(457686, 'PIRSF500176', NULL, NULL, 330, NULL, 'L_ASNase', 276780),
(457687, 'PIRSF004874', NULL, NULL, 479, NULL, 'Prcrn_mtase_isom', 276781),
(457688, 'PIRSF034789', NULL, NULL, 121, NULL, 'Type_III_secr_syst_SsaM', 276782),
(457689, 'PIRSF030365', NULL, NULL, 544, NULL, 'UCP030365', 276783),
(457690, 'PIRSF000826', NULL, NULL, 2098, NULL, 'L_PhleboV', 276784),
(457691, 'PIRSF003217', NULL, NULL, 66, NULL, 'Cro_protein', 276785),
(457692, 'PIRSF037177', NULL, NULL, 268, NULL, 'COMT_euk', 276786),
(457693, 'PIRSF021278', NULL, NULL, 209, NULL, 'AcuA', 276787),
(457694, 'PIRSF039093', NULL, NULL, 181, NULL, 'HslV', 276788),
(457695, 'PIRSF017082', NULL, NULL, 333, NULL, 'YflP', 276789),
(457696, 'PIRSF001734', NULL, NULL, 1802, NULL, 'BRCA1', 276790),
(457697, 'PIRSF037062', NULL, NULL, 189, NULL, 'INSL6', 276791),
(457698, 'PIRSF038019', NULL, NULL, 266, NULL, 'Neurexophilin', 276792),
(457699, 'PIRSF003947', NULL, NULL, 233, NULL, 'N_OrthobunV', 276793),
(457700, 'PIRSF015599', NULL, NULL, 279, NULL, 'KIT_ligand_MCF', 276794),
(457701, 'PIRSF032285', NULL, NULL, 165, NULL, 'UCP032285', 276795),
(457702, 'PIRSF000136', NULL, NULL, 463, NULL, 'LGO_GLO', 276796),
(457703, 'PIRSF025024', NULL, NULL, 474, NULL, 'Txn_adaptor_ADA2', 276797),
(457704, 'PIRSF033642', NULL, NULL, 279, NULL, 'UCP033642', 276798),
(457705, 'PIRSF005890', NULL, NULL, 170, NULL, 'Phot_II_cyt_c550', 276799),
(457706, 'PIRSF038139', NULL, NULL, 724, NULL, 'EF-2_kin', 276800),
(457707, 'PIRSF001435', NULL, NULL, 225, NULL, 'Nth', 276801),
(457708, 'PIRSF005739', NULL, NULL, 372, NULL, 'O-mtase', 276802),
(457709, 'PIRSF034981', NULL, NULL, 188, NULL, 'Mtase_firmicutes', 276803),
(457710, 'PIRSF001795', NULL, NULL, 251, NULL, 'TRH', 276804),
(457711, 'PIRSF002419', NULL, NULL, 251, NULL, 'Tetraspanin', 276805),
(457712, 'PIRSF004990', NULL, NULL, 63, NULL, 'UCP004990', 276806),
(457713, 'PIRSF011668', NULL, NULL, 675, NULL, 'Ccz1p', 276807),
(457714, 'PIRSF036710', NULL, NULL, 203, NULL, 'YphA_Bacsu', 276808),
(457715, 'PIRSF038074', NULL, NULL, 351, NULL, 'Peroxin-12', 276809),
(457716, 'PIRSF025550', NULL, NULL, 173, NULL, 'UCP025550_lpd_carrier', 276810),
(457717, 'PIRSF037139', NULL, NULL, 326, NULL, 'UCP037139', 276811),
(457718, 'PIRSF036292', NULL, NULL, 515, NULL, 'Prenylcysteine_oxidase', 276812),
(457719, 'PIRSF005993', NULL, NULL, 502, NULL, 'Occludin', 276813),
(457720, 'PIRSF000441', NULL, NULL, 200, NULL, 'CysE', 276814),
(457721, 'PIRSF028451', NULL, NULL, 227, NULL, 'UCP028451', 276815),
(457722, 'PIRSF001992', NULL, NULL, 269, NULL, 'CD74_antigen', 276816),
(457723, 'PIRSF002967', NULL, NULL, 181, NULL, 'Fimbr_prot_A', 276817); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(457724, 'PIRSF009328', NULL, NULL, 494, NULL, 'RMT_SET', 276818),
(457725, 'PIRSF028589', NULL, NULL, 253, NULL, 'UCP028589', 276819),
(457726, 'PIRSF002372', NULL, NULL, 232, NULL, 'Beta-casein', 276820),
(457727, 'PIRSF001267', NULL, NULL, 504, NULL, 'Pyrophosphatase_GppA_Ppx', 276821),
(457728, 'PIRSF008633', NULL, NULL, 125, NULL, 'BEX', 276822),
(457729, 'PIRSF019075', NULL, NULL, 186, NULL, 'UCP019075', 276823),
(457730, 'PIRSF500312', NULL, NULL, 92, NULL, 'Bombyxin_A', 276824),
(457731, 'PIRSF010607', NULL, NULL, 156, NULL, 'Txn_repr_CtsR', 276825),
(457732, 'PIRSF026306', NULL, NULL, 1156, NULL, 'UCP026306', 276826),
(457733, 'PIRSF036483', NULL, NULL, 417, NULL, 'PFK_XF0274', 276827),
(457734, 'PIRSF037214', NULL, NULL, 164, NULL, 'UCP037214', 276828),
(457735, 'PIRSF006293', NULL, NULL, 225, NULL, 'ExsB', 276829),
(457736, 'PIRSF000340', NULL, NULL, 579, NULL, 'MPO_fungal', 276830),
(457737, 'PIRSF037527', NULL, NULL, 275, NULL, 'GTPase_Tem1', 276831),
(457738, 'PIRSF006256', NULL, NULL, 773, NULL, 'CMP_trnsf_HypF', 276832),
(457739, 'PIRSF000362', NULL, NULL, 472, NULL, 'FNR', 276833),
(457740, 'PIRSF005465', NULL, NULL, 409, NULL, 'GIRK_kir', 276834),
(457741, 'PIRSF001935', NULL, NULL, 211, NULL, 'IL-6', 276835),
(457742, 'PIRSF036995', NULL, NULL, 313, NULL, 'RSM24', 276836),
(457743, 'PIRSF006304', NULL, NULL, 453, NULL, 'GatC', 276837),
(457744, 'PIRSF009136', NULL, NULL, 269, NULL, 'MDUP_MalA', 276838),
(457745, 'PIRSF026317', NULL, NULL, 254, NULL, 'UCP026317_WGR', 276839),
(457746, 'PIRSF012886', NULL, NULL, 307, NULL, 'UCP012886', 276840),
(457747, 'PIRSF500776', NULL, NULL, 417, NULL, 'Hyaluronidase_3', 276841),
(457748, 'PIRSF005335', NULL, NULL, 443, NULL, 'CCA_arch', 276842),
(457749, 'PIRSF000472', NULL, NULL, 564, NULL, 'Alpha1_6FUT_euk', 276843),
(457750, 'PIRSF001000', NULL, NULL, 139, NULL, 'PDG_ENDV', 276844),
(457751, 'PIRSF006414', NULL, NULL, 296, NULL, 'Ftr_formyl_trnsf', 276845),
(457752, 'PIRSF018008', NULL, NULL, 264, NULL, 'UCP018008', 276846),
(457753, 'PIRSF000345', NULL, NULL, 485, NULL, 'OLE1', 276847),
(457754, 'PIRSF018671', NULL, NULL, 298, NULL, 'UCP018671', 276848),
(457755, 'PIRSF037092', NULL, NULL, 963, NULL, 'AP3_delta', 276849),
(457756, 'PIRSF000746', NULL, NULL, 302, NULL, 'RPO35', 276850),
(457757, 'PIRSF000095', NULL, NULL, 313, NULL, '17beta-HSD', 276851),
(457758, 'PIRSF030050', NULL, NULL, 307, NULL, 'UCP030050_HTH', 276852),
(457759, 'PIRSF000109', NULL, NULL, 484, NULL, '6PGD', 276853),
(457760, 'PIRSF001217', NULL, NULL, 612, NULL, 'Protease_4_SppA', 276854),
(457761, 'PIRSF036492', NULL, NULL, 499, NULL, 'ALDH', 276855),
(457762, 'PIRSF003128', NULL, NULL, 554, NULL, 'RecN', 276856),
(457763, 'PIRSF016468', NULL, NULL, 112, NULL, 'RDS3p', 276857),
(457764, 'PIRSF028063', NULL, NULL, 221, NULL, 'UCP028063', 276858),
(457765, 'PIRSF000197', NULL, NULL, 1213, NULL, 'Bifunct_PutA', 276859),
(457766, 'PIRSF025648', NULL, NULL, 326, NULL, 'DDH', 276860),
(457767, 'PIRSF036761', NULL, NULL, 1612, NULL, 'GDH_Mll4104', 276861),
(457768, 'PIRSF000166', NULL, NULL, 347, NULL, 'Coproporphyri_ox', 276862),
(457769, 'PIRSF038123', NULL, NULL, 257, NULL, 'PTI6', 276863),
(457770, 'PIRSF500210', NULL, NULL, 332, NULL, 'FBPtase', 276864),
(457771, 'PIRSF036534', NULL, NULL, 88, NULL, 'EhaC', 276865),
(457772, 'PIRSF037221', NULL, NULL, 337, NULL, 'UCP037221', 276866),
(457773, 'PIRSF022632', NULL, NULL, 156, NULL, 'UCP022632', 276867),
(457774, 'PIRSF029688', NULL, NULL, 115, NULL, 'UCP29688_pentapep', 276868),
(457775, 'PIRSF016179', NULL, NULL, 229, NULL, 'UCP016179', 276869),
(457776, 'PIRSF032673', NULL, NULL, 136, NULL, 'UCP032673', 276870),
(457777, 'PIRSF006156', NULL, NULL, 92, NULL, 'YafQ', 276871),
(457778, 'PIRSF001154', NULL, NULL, 779, NULL, 'Compl_C2_B', 276872),
(457779, 'PIRSF027110', NULL, NULL, 221, NULL, 'PREG', 276873),
(457780, 'PIRSF001778', NULL, NULL, 1200, NULL, 'Pro-EGF', 276874),
(457781, 'PIRSF036238', NULL, NULL, 107, NULL, 'UCP036238', 276875),
(457782, 'PIRSF029202', NULL, NULL, 311, NULL, 'UCP029202', 276876);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(457783, 'PIRSF006246', NULL, NULL, 131, NULL, 'ADC', 276877),
(457784, 'PIRSF034039', NULL, NULL, 1252, NULL, 'UCP034039', 276878),
(457785, 'PIRSF037921', NULL, NULL, 567, NULL, 'STPK_RIP2', 276879),
(457786, 'PIRSF034890', NULL, NULL, 443, NULL, 'Pesteras_lmo2642', 276880),
(457787, 'PIRSF016642', NULL, NULL, 272, NULL, 'UCP016642', 276881),
(457788, 'PIRSF000709', NULL, NULL, 636, NULL, '6PFK_fruc_bisph_Ptase', 276882),
(457789, 'PIRSF001535', NULL, NULL, 572, NULL, 'ProRS_1', 276883),
(457790, 'PIRSF019706', NULL, NULL, 168, NULL, 'EhaB', 276884),
(457791, 'PIRSF002006', NULL, NULL, 790, NULL, 'PTPR_alpha_epsilon', 276885),
(457792, 'PIRSF019345', NULL, NULL, 216, NULL, 'SCPB', 276886),
(457793, 'PIRSF034888', NULL, NULL, 387, NULL, 'P-loop_UCP034888', 276887),
(457794, 'PIRSF039137', NULL, NULL, 239, NULL, 'ABC_branched_ATPase', 276888),
(457795, 'PIRSF005278', NULL, NULL, 247, NULL, 'UCP005278', 276889),
(457796, 'PIRSF015617', NULL, NULL, 204, NULL, 'Adenosyltransferase_CobA', 276890),
(457797, 'PIRSF024484', NULL, NULL, 138, NULL, 'UCP024484', 276891),
(457798, 'PIRSF005765', NULL, NULL, 264, NULL, 'Fib-L', 276892),
(457799, 'PIRSF003440', NULL, NULL, 311, NULL, 'UCP003440', 276893),
(457800, 'PIRSF037456', NULL, NULL, 258, NULL, 'BAMBI', 276894),
(457801, 'PIRSR004682-3', NULL, NULL, 186, NULL, 'PIRSR004682-3', 276895),
(457802, 'PIRSR628707-1', NULL, NULL, 263, NULL, 'PIRSR628707-1', 276896),
(457803, 'PIRSR000005-2', NULL, NULL, 183, NULL, 'PIRSR000005-2', 276897),
(457804, 'PIRSR005713-3', NULL, NULL, 390, NULL, 'PIRSR005713-3', 276898),
(457805, 'PIRSR036918-50', NULL, NULL, 605, NULL, 'PIRSR036918-50', 276899),
(457806, 'PIRSR015582-2', NULL, NULL, 258, NULL, 'PIRSR015582-2', 276900),
(457807, 'PIRSR038193-1', NULL, NULL, 455, NULL, 'PIRSR038193-1', 276901),
(457808, 'PIRSR001154-1', NULL, NULL, 640, NULL, 'PIRSR001154-1', 276902),
(457809, 'PIRSR001488-1', NULL, NULL, 206, NULL, 'PIRSR001488-1', 276903),
(457810, 'PIRSR000149-2', NULL, NULL, 341, NULL, 'PIRSR000149-2', 276904),
(457811, 'PIRSR039026-2', NULL, NULL, 246, NULL, 'PIRSR039026-2', 276905),
(457812, 'PIRSR000460-1', NULL, NULL, 348, NULL, 'PIRSR000460-1', 276906),
(457813, 'PIRSR606118-50', NULL, NULL, 362, NULL, 'PIRSR606118-50', 276907),
(457814, 'PIRSR000099-1', NULL, NULL, 362, NULL, 'PIRSR000099-1', 276908),
(457815, 'PIRSR633508-2', NULL, NULL, 950, NULL, 'PIRSR633508-2', 276909),
(457816, 'PIRSR028973-2', NULL, NULL, 291, NULL, 'PIRSR028973-2', 276910),
(457817, 'PIRSR000238-2', NULL, NULL, 520, NULL, 'PIRSR000238-2', 276911),
(457818, 'PIRSR000631-4', NULL, NULL, 1114, NULL, 'PIRSR000631-4', 276912),
(457819, 'PIRSR605468-50', NULL, NULL, 150, NULL, 'PIRSR605468-50', 276913),
(457820, 'PIRSR629511-2', NULL, NULL, 279, NULL, 'PIRSR629511-2', 276914),
(457821, 'PIRSR039050-51', NULL, NULL, 1101, NULL, 'PIRSR039050-51', 276915),
(457822, 'PIRSR001430-2', NULL, NULL, 204, NULL, 'PIRSR001430-2', 276916),
(457823, 'PIRSR634603-3', NULL, NULL, 359, NULL, 'PIRSR634603-3', 276917),
(457824, 'PIRSR028937-2', NULL, NULL, 748, NULL, 'PIRSR028937-2', 276918),
(457825, 'PIRSR000262-2', NULL, NULL, 555, NULL, 'PIRSR000262-2', 276919),
(457826, 'PIRSR001461-2', NULL, NULL, 213, NULL, 'PIRSR001461-2', 276920),
(457827, 'PIRSR016527-1', NULL, NULL, 261, NULL, 'PIRSR016527-1', 276921),
(457828, 'PIRSR024851-50', NULL, NULL, 169, NULL, 'PIRSR024851-50', 276922),
(457829, 'PIRSR037242-1', NULL, NULL, 480, NULL, 'PIRSR037242-1', 276923),
(457830, 'PIRSR000988-2', NULL, NULL, 259, NULL, 'PIRSR000988-2', 276924),
(457831, 'PIRSR037599-2', NULL, NULL, 159, NULL, 'PIRSR037599-2', 276925),
(457832, 'PIRSR633528-4', NULL, NULL, 947, NULL, 'PIRSR633528-4', 276926),
(457833, 'PIRSR602506-52', NULL, NULL, 213, NULL, 'PIRSR602506-52', 276927),
(457834, 'PIRSR002520-3', NULL, NULL, 609, NULL, 'PIRSR002520-3', 276928),
(457835, 'PIRSR005384-2', NULL, NULL, 151, NULL, 'PIRSR005384-2', 276929),
(457836, 'PIRSR500135-3', NULL, NULL, 438, NULL, 'PIRSR500135-3', 276930),
(457837, 'PIRSR617653-2', NULL, NULL, 446, NULL, 'PIRSR617653-2', 276931);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(457838, 'PIRSR036497-1', NULL, NULL, 236, NULL, 'PIRSR036497-1', 276932),
(457839, 'PIRSR038061-1', NULL, NULL, 284, NULL, 'PIRSR038061-1', 276933),
(457840, 'PIRSR628651-51', NULL, NULL, 274, NULL, 'PIRSR628651-51', 276934),
(457841, 'PIRSR038895-1', NULL, NULL, 528, NULL, 'PIRSR038895-1', 276935),
(457842, 'PIRSR003047-1', NULL, NULL, 1891, NULL, 'PIRSR003047-1', 276936),
(457843, 'PIRSR618044-2', NULL, NULL, 391, NULL, 'PIRSR618044-2', 276937),
(457844, 'PIRSR002490-1', NULL, NULL, 368, NULL, 'PIRSR002490-1', 276938),
(457845, 'PIRSR037891-1', NULL, NULL, 31, NULL, 'PIRSR037891-1', 276939),
(457846, 'PIRSR036687-1', NULL, NULL, 756, NULL, 'PIRSR036687-1', 276940),
(457847, 'PIRSR037249-1', NULL, NULL, 373, NULL, 'PIRSR037249-1', 276941),
(457848, 'PIRSR000102-1', NULL, NULL, 327, NULL, 'PIRSR000102-1', 276942),
(457849, 'PIRSR037568-2', NULL, NULL, 1182, NULL, 'PIRSR037568-2', 276943),
(457850, 'PIRSR631098-51', NULL, NULL, 125, NULL, 'PIRSR631098-51', 276944),
(457851, 'PIRSR000808-2', NULL, NULL, 352, NULL, 'PIRSR000808-2', 276945),
(457852, 'PIRSR600936-1', NULL, NULL, 1264, NULL, 'PIRSR600936-1', 276946),
(457853, 'PIRSR000905-1', NULL, NULL, 353, NULL, 'PIRSR000905-1', 276947),
(457854, 'PIRSR001065-1', NULL, NULL, 200, NULL, 'PIRSR001065-1', 276948),
(457855, 'PIRSR000235-3', NULL, NULL, 348, NULL, 'PIRSR000235-3', 276949),
(457856, 'PIRSR001341-2', NULL, NULL, 316, NULL, 'PIRSR001341-2', 276950),
(457857, 'PIRSR617512-1', NULL, NULL, 726, NULL, 'PIRSR617512-1', 276951),
(457858, 'PIRSR621573-2', NULL, NULL, 2292, NULL, 'PIRSR621573-2', 276952),
(457859, 'PIRSR001837-1', NULL, NULL, 167, NULL, 'PIRSR001837-1', 276953),
(457860, 'PIRSR036900-50', NULL, NULL, 3945, NULL, 'PIRSR036900-50', 276954),
(457861, 'PIRSR037242-4', NULL, NULL, 480, NULL, 'PIRSR037242-4', 276955),
(457862, 'PIRSR000185-2', NULL, NULL, 401, NULL, 'PIRSR000185-2', 276956),
(457863, 'PIRSR628391-2', NULL, NULL, 778, NULL, 'PIRSR628391-2', 276957),
(457864, 'PIRSR602717-51', NULL, NULL, 482, NULL, 'PIRSR602717-51', 276958),
(457865, 'PIRSR004869-50', NULL, NULL, 319, NULL, 'PIRSR004869-50', 276959),
(457866, 'PIRSR026389-3', NULL, NULL, 740, NULL, 'PIRSR026389-3', 276960),
(457867, 'PIRSR037913-1', NULL, NULL, 365, NULL, 'PIRSR037913-1', 276961),
(457868, 'PIRSR500951-2', NULL, NULL, 874, NULL, 'PIRSR500951-2', 276962),
(457869, 'PIRSR605428-51', NULL, NULL, 472, NULL, 'PIRSR605428-51', 276963),
(457870, 'PIRSR633560-50', NULL, NULL, 572, NULL, 'PIRSR633560-50', 276964),
(457871, 'PIRSR000929-1', NULL, NULL, 540, NULL, 'PIRSR000929-1', 276965),
(457872, 'PIRSR003059-1', NULL, NULL, 490, NULL, 'PIRSR003059-1', 276966),
(457873, 'PIRSR000666-2', NULL, NULL, 899, NULL, 'PIRSR000666-2', 276967),
(457874, 'PIRSR036665-51', NULL, NULL, 881, NULL, 'PIRSR036665-51', 276968),
(457875, 'PIRSR000118-2', NULL, NULL, 592, NULL, 'PIRSR000118-2', 276969),
(457876, 'PIRSR001399-1', NULL, NULL, 149, NULL, 'PIRSR001399-1', 276970),
(457877, 'PIRSR038945-2', NULL, NULL, 300, NULL, 'PIRSR038945-2', 276971),
(457878, 'PIRSR018153-1', NULL, NULL, 423, NULL, 'PIRSR018153-1', 276972),
(457879, 'PIRSR622314-4', NULL, NULL, 522, NULL, 'PIRSR622314-4', 276973),
(457880, 'PIRSR006268-2', NULL, NULL, 341, NULL, 'PIRSR006268-2', 276974),
(457881, 'PIRSR000290-3', NULL, NULL, 489, NULL, 'PIRSR000290-3', 276975),
(457882, 'PIRSR633040-1', NULL, NULL, 260, NULL, 'PIRSR633040-1', 276976),
(457883, 'PIRSR000169-1', NULL, NULL, 115, NULL, 'PIRSR000169-1', 276977),
(457884, 'PIRSR036370-1', NULL, NULL, 843, NULL, 'PIRSR036370-1', 276978),
(457885, 'PIRSR611612-52', NULL, NULL, 570, NULL, 'PIRSR611612-52', 276979),
(457886, 'PIRSR631084-1', NULL, NULL, 538, NULL, 'PIRSR631084-1', 276980),
(457887, 'PIRSR000724-2', NULL, NULL, 315, NULL, 'PIRSR000724-2', 276981),
(457888, 'PIRSR001558-1', NULL, NULL, 320, NULL, 'PIRSR001558-1', 276982),
(457889, 'PIRSR038065-2', NULL, NULL, 401, NULL, 'PIRSR038065-2', 276983),
(457890, 'PIRSR036489-2', NULL, NULL, 902, NULL, 'PIRSR036489-2', 276984),
(457891, 'PIRSR005639-2', NULL, NULL, 195, NULL, 'PIRSR005639-2', 276985);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(457892, 'PIRSR610300-50', NULL, NULL, 204, NULL, 'PIRSR610300-50', 276986),
(457893, 'PIRSR001500-2', NULL, NULL, 363, NULL, 'PIRSR001500-2', 276987),
(457894, 'PIRSR000159-50', NULL, NULL, 1183, NULL, 'PIRSR000159-50', 276988),
(457895, 'PIRSR018001-2', NULL, NULL, 313, NULL, 'PIRSR018001-2', 276989),
(457896, 'PIRSR001149-1', NULL, NULL, 619, NULL, 'PIRSR001149-1', 276990),
(457897, 'PIRSR000498-1', NULL, NULL, 198, NULL, 'PIRSR000498-1', 276991),
(457898, 'PIRSR038165-51', NULL, NULL, 965, NULL, 'PIRSR038165-51', 276992),
(457899, 'PIRSR000168-2', NULL, NULL, 573, NULL, 'PIRSR000168-2', 276993),
(457900, 'PIRSR038073-1', NULL, NULL, 297, NULL, 'PIRSR038073-1', 276994),
(457901, 'PIRSR005784-1', NULL, NULL, 168, NULL, 'PIRSR005784-1', 276995),
(457902, 'PIRSR033579-3', NULL, NULL, 271, NULL, 'PIRSR033579-3', 276996),
(457903, 'PIRSR037215-2', NULL, NULL, 411, NULL, 'PIRSR037215-2', 276997),
(457904, 'PIRSR605437-50', NULL, NULL, 473, NULL, 'PIRSR605437-50', 276998),
(457905, 'PIRSR001426-1', NULL, NULL, 187, NULL, 'PIRSR001426-1', 276999),
(457906, 'PIRSR000409-2', NULL, NULL, 338, NULL, 'PIRSR000409-2', 277000),
(457907, 'PIRSR001948-50', NULL, NULL, 555, NULL, 'PIRSR001948-50', 277001),
(457908, 'PIRSR001492-2', NULL, NULL, 514, NULL, 'PIRSR001492-2', 277002),
(457909, 'PIRSR036958-2', NULL, NULL, 602, NULL, 'PIRSR036958-2', 277003),
(457910, 'PIRSR622314-1', NULL, NULL, 522, NULL, 'PIRSR622314-1', 277004),
(457911, 'PIRSR006661-1', NULL, NULL, 229, NULL, 'PIRSR006661-1', 277005),
(457912, 'PIRSR001238-1', NULL, NULL, 390, NULL, 'PIRSR001238-1', 277006),
(457913, 'PIRSR617774-1', NULL, NULL, 397, NULL, 'PIRSR617774-1', 277007),
(457914, 'PIRSR000551-51', NULL, NULL, 719, NULL, 'PIRSR000551-51', 277008),
(457915, 'PIRSR006156-1', NULL, NULL, 90, NULL, 'PIRSR006156-1', 277009),
(457916, 'PIRSR004789-50', NULL, NULL, 266, NULL, 'PIRSR004789-50', 277010),
(457917, 'PIRSR006019-1', NULL, NULL, 159, NULL, 'PIRSR006019-1', 277011),
(457918, 'PIRSR036639-1', NULL, NULL, 185, NULL, 'PIRSR036639-1', 277012),
(457919, 'PIRSR037634-1', NULL, NULL, 279, NULL, 'PIRSR037634-1', 277013),
(457920, 'PIRSR001522-1', NULL, NULL, 315, NULL, 'PIRSR001522-1', 277014),
(457921, 'PIRSR621573-5', NULL, NULL, 2292, NULL, 'PIRSR621573-5', 277015),
(457922, 'PIRSR000605-51', NULL, NULL, 517, NULL, 'PIRSR000605-51', 277016),
(457923, 'PIRSR002006-2', NULL, NULL, 662, NULL, 'PIRSR002006-2', 277017),
(457924, 'PIRSR037217-2', NULL, NULL, 568, NULL, 'PIRSR037217-2', 277018),
(457925, 'PIRSR037932-1', NULL, NULL, 278, NULL, 'PIRSR037932-1', 277019),
(457926, 'PIRSR635711-50', NULL, NULL, 1653, NULL, 'PIRSR635711-50', 277020),
(457927, 'PIRSR009103-2', NULL, NULL, 156, NULL, 'PIRSR009103-2', 277021),
(457928, 'PIRSR000190-2', NULL, NULL, 218, NULL, 'PIRSR000190-2', 277022),
(457929, 'PIRSR000068-1', NULL, NULL, 104, NULL, 'PIRSR000068-1', 277023),
(457930, 'PIRSR036894-1', NULL, NULL, 315, NULL, 'PIRSR036894-1', 277024),
(457931, 'PIRSR622230-4', NULL, NULL, 3175, NULL, 'PIRSR622230-4', 277025),
(457932, 'PIRSR000075-1', NULL, NULL, 41, NULL, 'PIRSR000075-1', 277026),
(457933, 'PIRSR005700-1', NULL, NULL, 437, NULL, 'PIRSR005700-1', 277027),
(457934, 'PIRSR633528-1', NULL, NULL, 947, NULL, 'PIRSR633528-1', 277028),
(457935, 'PIRSR017269-1', NULL, NULL, 208, NULL, 'PIRSR017269-1', 277029),
(457936, 'PIRSR000296-1', NULL, NULL, 293, NULL, 'PIRSR000296-1', 277030),
(457937, 'PIRSR001084-1', NULL, NULL, 673, NULL, 'PIRSR001084-1', 277031),
(457938, 'PIRSR500134-1', NULL, NULL, 434, NULL, 'PIRSR500134-1', 277032),
(457939, 'PIRSR006404-1', NULL, NULL, 322, NULL, 'PIRSR006404-1', 277033),
(457940, 'PIRSR631038-2', NULL, NULL, 333, NULL, 'PIRSR631038-2', 277034),
(457941, 'PIRSR030150-1', NULL, NULL, 246, NULL, 'PIRSR030150-1', 277035),
(457942, 'PIRSR000550-3', NULL, NULL, 608, NULL, 'PIRSR000550-3', 277036),
(457943, 'PIRSR000933-51', NULL, NULL, 2487, NULL, 'PIRSR000933-51', 277037),
(457944, 'PIRSR039004-3', NULL, NULL, 372, NULL, 'PIRSR039004-3', 277038),
(457945, 'PIRSR000429-1', NULL, NULL, 330, NULL, 'PIRSR000429-1', 277039);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(457946, 'PIRSR630294-1', NULL, NULL, 306, NULL, 'PIRSR630294-1', 277040),
(457947, 'PIRSR028980-2', NULL, NULL, 211, NULL, 'PIRSR028980-2', 277041),
(457948, 'PIRSR625650-2', NULL, NULL, 644, NULL, 'PIRSR625650-2', 277042),
(457949, 'PIRSR038455-1', NULL, NULL, 228, NULL, 'PIRSR038455-1', 277043),
(457950, 'PIRSR038085-1', NULL, NULL, 151, NULL, 'PIRSR038085-1', 277044),
(457951, 'PIRSR000948-1', NULL, NULL, 631, NULL, 'PIRSR000948-1', 277045),
(457952, 'PIRSR001072-1', NULL, NULL, 568, NULL, 'PIRSR001072-1', 277046),
(457953, 'PIRSR002026-1', NULL, NULL, 165, NULL, 'PIRSR002026-1', 277047),
(457954, 'PIRSR002512-1', NULL, NULL, 799, NULL, 'PIRSR002512-1', 277048),
(457955, 'PIRSR001031-2', NULL, NULL, 616, NULL, 'PIRSR001031-2', 277049),
(457956, 'PIRSR005604-1', NULL, NULL, 302, NULL, 'PIRSR005604-1', 277050),
(457957, 'PIRSR038941-1', NULL, NULL, 337, NULL, 'PIRSR038941-1', 277051),
(457958, 'PIRSR000008-1', NULL, NULL, 181, NULL, 'PIRSR000008-1', 277052),
(457959, 'PIRSR633144-3', NULL, NULL, 410, NULL, 'PIRSR633144-3', 277053),
(457960, 'PIRSR001205-1', NULL, NULL, 484, NULL, 'PIRSR001205-1', 277054),
(457961, 'PIRSR000109-1', NULL, NULL, 469, NULL, 'PIRSR000109-1', 277055),
(457962, 'PIRSR604061-50', NULL, NULL, 382, NULL, 'PIRSR604061-50', 277056),
(457963, 'PIRSR000894-2', NULL, NULL, 392, NULL, 'PIRSR000894-2', 277057),
(457964, 'PIRSR001341-5', NULL, NULL, 316, NULL, 'PIRSR001341-5', 277058),
(457965, 'PIRSR629576-1', NULL, NULL, 604, NULL, 'PIRSR629576-1', 277059),
(457966, 'PIRSR037404-3', NULL, NULL, 1614, NULL, 'PIRSR037404-3', 277060),
(457967, 'PIRSR000188-1', NULL, NULL, 326, NULL, 'PIRSR000188-1', 277061),
(457968, 'PIRSR031051-1', NULL, NULL, 247, NULL, 'PIRSR031051-1', 277062),
(457969, 'PIRSR029792-2', NULL, NULL, 335, NULL, 'PIRSR029792-2', 277063),
(457970, 'PIRSR036684-2', NULL, NULL, 760, NULL, 'PIRSR036684-2', 277064),
(457971, 'PIRSR000385-1', NULL, NULL, 271, NULL, 'PIRSR000385-1', 277065),
(457972, 'PIRSR005993-1', NULL, NULL, 515, NULL, 'PIRSR005993-1', 277066),
(457973, 'PIRSR000926-2', NULL, NULL, 298, NULL, 'PIRSR000926-2', 277067),
(457974, 'PIRSR037010-50', NULL, NULL, 85, NULL, 'PIRSR037010-50', 277068),
(457975, 'PIRSR605856-50', NULL, NULL, 316, NULL, 'PIRSR605856-50', 277069),
(457976, 'PIRSR038084-2', NULL, NULL, 419, NULL, 'PIRSR038084-2', 277070),
(457977, 'PIRSR001594-1', NULL, NULL, 1106, NULL, 'PIRSR001594-1', 277071),
(457978, 'PIRSR604809-50', NULL, NULL, 456, NULL, 'PIRSR604809-50', 277072),
(457979, 'PIRSR600823-4', NULL, NULL, 331, NULL, 'PIRSR600823-4', 277073),
(457980, 'PIRSR000705-2', NULL, NULL, 198, NULL, 'PIRSR000705-2', 277074),
(457981, 'PIRSR001373-1', NULL, NULL, 527, NULL, 'PIRSR001373-1', 277075),
(457982, 'PIRSR036636-50', NULL, NULL, 255, NULL, 'PIRSR036636-50', 277076),
(457983, 'PIRSR036959-1', NULL, NULL, 352, NULL, 'PIRSR036959-1', 277077),
(457984, 'PIRSR000130-2', NULL, NULL, 473, NULL, 'PIRSR000130-2', 277078),
(457985, 'PIRSR037393-1', NULL, NULL, 548, NULL, 'PIRSR037393-1', 277079),
(457986, 'PIRSR016262-2', NULL, NULL, 216, NULL, 'PIRSR016262-2', 277080),
(457987, 'PIRSR018136-1', NULL, NULL, 441, NULL, 'PIRSR018136-1', 277081),
(457988, 'PIRSR000232-1', NULL, NULL, 148, NULL, 'PIRSR000232-1', 277082),
(457989, 'PIRSR620777-50', NULL, NULL, 817, NULL, 'PIRSR620777-50', 277083),
(457990, 'PIRSR001024-5', NULL, NULL, 477, NULL, 'PIRSR001024-5', 277084),
(457991, 'PIRSR036893-51', NULL, NULL, 201, NULL, 'PIRSR036893-51', 277085),
(457992, 'PIRSR006615-1', NULL, NULL, 503, NULL, 'PIRSR006615-1', 277086),
(457993, 'PIRSR017388-2', NULL, NULL, 245, NULL, 'PIRSR017388-2', 277087),
(457994, 'PIRSR038159-50', NULL, NULL, 541, NULL, 'PIRSR038159-50', 277088),
(457995, 'PIRSR000094-1', NULL, NULL, 260, NULL, 'PIRSR000094-1', 277089),
(457996, 'PIRSR000606-51', NULL, NULL, 738, NULL, 'PIRSR000606-51', 277090),
(457997, 'PIRSR620023-2', NULL, NULL, 276, NULL, 'PIRSR620023-2', 277091),
(457998, 'PIRSR036685-1', NULL, NULL, 392, NULL, 'PIRSR036685-1', 277092),
(457999, 'PIRSR031924-51', NULL, NULL, 537, NULL, 'PIRSR031924-51', 277093);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(458000, 'PIRSR036874-51', NULL, NULL, 681, NULL, 'PIRSR036874-51', 277094),
(458001, 'PIRSR015894-3', NULL, NULL, 456, NULL, 'PIRSR015894-3', 277095),
(458002, 'PIRSR039133-4', NULL, NULL, 649, NULL, 'PIRSR039133-4', 277096),
(458003, 'PIRSR601621-4', NULL, NULL, 370, NULL, 'PIRSR601621-4', 277097),
(458004, 'PIRSR000349-1', NULL, NULL, 201, NULL, 'PIRSR000349-1', 277098),
(458005, 'PIRSR001028-2', NULL, NULL, 427, NULL, 'PIRSR001028-2', 277099),
(458006, 'PIRSR002937-1', NULL, NULL, 269, NULL, 'PIRSR002937-1', 277100),
(458007, 'PIRSR600917-51', NULL, NULL, 562, NULL, 'PIRSR600917-51', 277101),
(458008, 'PIRSR000127-3', NULL, NULL, 1342, NULL, 'PIRSR000127-3', 277102),
(458009, 'PIRSR626945-2', NULL, NULL, 379, NULL, 'PIRSR626945-2', 277103),
(458010, 'PIRSR000260-2', NULL, NULL, 96, NULL, 'PIRSR000260-2', 277104),
(458011, 'PIRSR006809-2', NULL, NULL, 341, NULL, 'PIRSR006809-2', 277105),
(458012, 'PIRSR006278-1', NULL, NULL, 260, NULL, 'PIRSR006278-1', 277106),
(458013, 'PIRSR017434-2', NULL, NULL, 424, NULL, 'PIRSR017434-2', 277107),
(458014, 'PIRSR036917-3', NULL, NULL, 684, NULL, 'PIRSR036917-3', 277108),
(458015, 'PIRSR622230-1', NULL, NULL, 3175, NULL, 'PIRSR622230-1', 277109),
(458016, 'PIRSR629609-3', NULL, NULL, 719, NULL, 'PIRSR629609-3', 277110),
(458017, 'PIRSR000006-1', NULL, NULL, 277, NULL, 'PIRSR000006-1', 277111),
(458018, 'PIRSR017107-3', NULL, NULL, 415, NULL, 'PIRSR017107-3', 277112),
(458019, 'PIRSR629601-1', NULL, NULL, 1866, NULL, 'PIRSR629601-1', 277113),
(458020, 'PIRSR021331-1', NULL, NULL, 195, NULL, 'PIRSR021331-1', 277114),
(458021, 'PIRSR001217-1', NULL, NULL, 613, NULL, 'PIRSR001217-1', 277115),
(458022, 'PIRSR629576-4', NULL, NULL, 604, NULL, 'PIRSR629576-4', 277116),
(458023, 'PIRSR026534-2', NULL, NULL, 324, NULL, 'PIRSR026534-2', 277117),
(458024, 'PIRSR632916-1', NULL, NULL, 393, NULL, 'PIRSR632916-1', 277118),
(458025, 'PIRSR602129-50', NULL, NULL, 431, NULL, 'PIRSR602129-50', 277119),
(458026, 'PIRSR000485-3', NULL, NULL, 468, NULL, 'PIRSR000485-3', 277120),
(458027, 'PIRSR500133-3', NULL, NULL, 474, NULL, 'PIRSR500133-3', 277121),
(458028, 'PIRSR003085-1', NULL, NULL, 327, NULL, 'PIRSR003085-1', 277122),
(458029, 'PIRSR038147-2', NULL, NULL, 556, NULL, 'PIRSR038147-2', 277123),
(458030, 'PIRSR000192-5', NULL, NULL, 188, NULL, 'PIRSR000192-5', 277124),
(458031, 'PIRSR634183-1', NULL, NULL, 424, NULL, 'PIRSR634183-1', 277125),
(458032, 'PIRSR036289-51', NULL, NULL, 785, NULL, 'PIRSR036289-51', 277126),
(458033, 'PIRSR001959-2', NULL, NULL, 508, NULL, 'PIRSR001959-2', 277127),
(458034, 'PIRSR000604-2', NULL, NULL, 615, NULL, 'PIRSR000604-2', 277128),
(458035, 'PIRSR003888-1', NULL, NULL, 417, NULL, 'PIRSR003888-1', 277129),
(458036, 'PIRSR000239-1', NULL, NULL, 194, NULL, 'PIRSR000239-1', 277130),
(458037, 'PIRSR003033-1', NULL, NULL, 630, NULL, 'PIRSR003033-1', 277131),
(458038, 'PIRSR000934-1', NULL, NULL, 1179, NULL, 'PIRSR000934-1', 277132),
(458039, 'PIRSR037250-51', NULL, NULL, 663, NULL, 'PIRSR037250-51', 277133),
(458040, 'PIRSR037023-1', NULL, NULL, 663, NULL, 'PIRSR037023-1', 277134),
(458041, 'PIRSR017570-1', NULL, NULL, 374, NULL, 'PIRSR017570-1', 277135),
(458042, 'PIRSR002884-1', NULL, NULL, 199, NULL, 'PIRSR002884-1', 277136),
(458043, 'PIRSR629609-6', NULL, NULL, 719, NULL, 'PIRSR629609-6', 277137),
(458044, 'PIRSR000628-1', NULL, NULL, 744, NULL, 'PIRSR000628-1', 277138),
(458045, 'PIRSR039102-3', NULL, NULL, 350, NULL, 'PIRSR039102-3', 277139),
(458046, 'PIRSR005539-1', NULL, NULL, 290, NULL, 'PIRSR005539-1', 277140),
(458047, 'PIRSR038186-1', NULL, NULL, 236, NULL, 'PIRSR038186-1', 277141),
(458048, 'PIRSR006698-2', NULL, NULL, 286, NULL, 'PIRSR006698-2', 277142),
(458049, 'PIRSR037177-1', NULL, NULL, 271, NULL, 'PIRSR037177-1', 277143),
(458050, 'PIRSR603739-50', NULL, NULL, 413, NULL, 'PIRSR603739-50', 277144),
(458051, 'PIRSR000898-3', NULL, NULL, 327, NULL, 'PIRSR000898-3', 277145),
(458052, 'PIRSR001959-1', NULL, NULL, 508, NULL, 'PIRSR001959-1', 277146),
(458053, 'PIRSR005536-1', NULL, NULL, 723, NULL, 'PIRSR005536-1', 277147);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(458054, 'PIRSR634598-2', NULL, NULL, 446, NULL, 'PIRSR634598-2', 277148),
(458055, 'PIRSR000027-1', NULL, NULL, 127, NULL, 'PIRSR000027-1', 277149),
(458056, 'PIRSR036565-1', NULL, NULL, 519, NULL, 'PIRSR036565-1', 277150),
(458057, 'PIRSR039133-1', NULL, NULL, 649, NULL, 'PIRSR039133-1', 277151),
(458058, 'PIRSR000183-1', NULL, NULL, 372, NULL, 'PIRSR000183-1', 277152),
(458059, 'PIRSR037907-2', NULL, NULL, 664, NULL, 'PIRSR037907-2', 277153),
(458060, 'PIRSR640198-1', NULL, NULL, 477, NULL, 'PIRSR640198-1', 277154),
(458061, 'PIRSR001357-50', NULL, NULL, 238, NULL, 'PIRSR001357-50', 277155),
(458062, 'PIRSR018427-1', NULL, NULL, 195, NULL, 'PIRSR018427-1', 277156),
(458063, 'PIRSR021497-1', NULL, NULL, 267, NULL, 'PIRSR021497-1', 277157),
(458064, 'PIRSR600877-50', NULL, NULL, 226, NULL, 'PIRSR600877-50', 277158),
(458065, 'PIRSR002855-2', NULL, NULL, 78, NULL, 'PIRSR002855-2', 277159),
(458066, 'PIRSR000554-1', NULL, NULL, 589, NULL, 'PIRSR000554-1', 277160),
(458067, 'PIRSR016238-1', NULL, NULL, 218, NULL, 'PIRSR016238-1', 277161),
(458068, 'PIRSR007828-2', NULL, NULL, 598, NULL, 'PIRSR007828-2', 277162),
(458069, 'PIRSR004131-1', NULL, NULL, 712, NULL, 'PIRSR004131-1', 277163),
(458070, 'PIRSR000853-3', NULL, NULL, 833, NULL, 'PIRSR000853-3', 277164),
(458071, 'PIRSR002572-1', NULL, NULL, 146, NULL, 'PIRSR002572-1', 277165),
(458072, 'PIRSR633197-2', NULL, NULL, 285, NULL, 'PIRSR633197-2', 277166),
(458073, 'PIRSR001141-2', NULL, NULL, 327, NULL, 'PIRSR001141-2', 277167),
(458074, 'PIRSR006336-1', NULL, NULL, 645, NULL, 'PIRSR006336-1', 277168),
(458075, 'PIRSR029928-50', NULL, NULL, 102, NULL, 'PIRSR029928-50', 277169),
(458076, 'PIRSR016573-3', NULL, NULL, 161, NULL, 'PIRSR016573-3', 277170),
(458077, 'PIRSR000606-50', NULL, NULL, 738, NULL, 'PIRSR000606-50', 277171),
(458078, 'PIRSR000381-1', NULL, NULL, 1218, NULL, 'PIRSR000381-1', 277172),
(458079, 'PIRSR000183-4', NULL, NULL, 372, NULL, 'PIRSR000183-4', 277173),
(458080, 'PIRSR000806-1', NULL, NULL, 492, NULL, 'PIRSR000806-1', 277174),
(458081, 'PIRSR000732-1', NULL, NULL, 473, NULL, 'PIRSR000732-1', 277175),
(458082, 'PIRSR002421-1', NULL, NULL, 372, NULL, 'PIRSR002421-1', 277176),
(458083, 'PIRSR025737-2', NULL, NULL, 280, NULL, 'PIRSR025737-2', 277177),
(458084, 'PIRSR000178-1', NULL, NULL, 112, NULL, 'PIRSR000178-1', 277178),
(458085, 'PIRSR011588-50', NULL, NULL, 428, NULL, 'PIRSR011588-50', 277179),
(458086, 'PIRSR001024-2', NULL, NULL, 477, NULL, 'PIRSR001024-2', 277180),
(458087, 'PIRSR006246-2', NULL, NULL, 118, NULL, 'PIRSR006246-2', 277181),
(458088, 'PIRSR600239-51', NULL, NULL, 597, NULL, 'PIRSR600239-51', 277182),
(458089, 'PIRSR608356-50', NULL, NULL, 562, NULL, 'PIRSR608356-50', 277183),
(458090, 'PIRSR001789-1', NULL, NULL, 247, NULL, 'PIRSR001789-1', 277184),
(458091, 'PIRSR600246-1', NULL, NULL, 336, NULL, 'PIRSR600246-1', 277185),
(458092, 'PIRSR600823-1', NULL, NULL, 331, NULL, 'PIRSR600823-1', 277186),
(458093, 'PIRSR000192-2', NULL, NULL, 178, NULL, 'PIRSR000192-2', 277187),
(458094, 'PIRSR627620-3', NULL, NULL, 1242, NULL, 'PIRSR627620-3', 277188),
(458095, 'PIRSR640198-4', NULL, NULL, 477, NULL, 'PIRSR640198-4', 277189),
(458096, 'PIRSR000112-1', NULL, NULL, 367, NULL, 'PIRSR000112-1', 277190),
(458097, 'PIRSR001359-3', NULL, NULL, 260, NULL, 'PIRSR001359-3', 277191),
(458098, 'PIRSR000454-2', NULL, NULL, 1844, NULL, 'PIRSR000454-2', 277192),
(458099, 'PIRSR001553-1', NULL, NULL, 254, NULL, 'PIRSR001553-1', 277193),
(458100, 'PIRSR000094-4', NULL, NULL, 260, NULL, 'PIRSR000094-4', 277194),
(458101, 'PIRSR036750-1', NULL, NULL, 204, NULL, 'PIRSR036750-1', 277195),
(458102, 'PIRSR000632-2', NULL, NULL, 831, NULL, 'PIRSR000632-2', 277196),
(458103, 'PIRSR500950-52', NULL, NULL, 1088, NULL, 'PIRSR500950-52', 277197),
(458104, 'PIRSR629727-2', NULL, NULL, 750, NULL, 'PIRSR629727-2', 277198),
(458105, 'PIRSR037318-50', NULL, NULL, 265, NULL, 'PIRSR037318-50', 277199),
(458106, 'PIRSR606285-1', NULL, NULL, 643, NULL, 'PIRSR606285-1', 277200),
(458107, 'PIRSR617736-1', NULL, NULL, 452, NULL, 'PIRSR617736-1', 277201);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(458108, 'PIRSR001111-50', NULL, NULL, 292, NULL, 'PIRSR001111-50', 277202),
(458109, 'PIRSR006816-2', NULL, NULL, 207, NULL, 'PIRSR006816-2', 277203),
(458110, 'PIRSR018249-1', NULL, NULL, 210, NULL, 'PIRSR018249-1', 277204),
(458111, 'PIRSR015477-1', NULL, NULL, 1442, NULL, 'PIRSR015477-1', 277205),
(458112, 'PIRSR634178-1', NULL, NULL, 415, NULL, 'PIRSR634178-1', 277206),
(458113, 'PIRSR000636-1', NULL, NULL, 1129, NULL, 'PIRSR000636-1', 277207),
(458114, 'PIRSR630560-2', NULL, NULL, 579, NULL, 'PIRSR630560-2', 277208),
(458115, 'PIRSR006247-1', NULL, NULL, 485, NULL, 'PIRSR006247-1', 277209),
(458116, 'PIRSR006105-2', NULL, NULL, 157, NULL, 'PIRSR006105-2', 277210),
(458117, 'PIRSR610059-50', NULL, NULL, 309, NULL, 'PIRSR610059-50', 277211),
(458118, 'PIRSR013503-1', NULL, NULL, 215, NULL, 'PIRSR013503-1', 277212),
(458119, 'PIRSR630295-50', NULL, NULL, 292, NULL, 'PIRSR630295-50', 277213),
(458120, 'PIRSR037432-51', NULL, NULL, 344, NULL, 'PIRSR037432-51', 277214),
(458121, 'PIRSR015894-2', NULL, NULL, 456, NULL, 'PIRSR015894-2', 277215),
(458122, 'PIRSR634015-2', NULL, NULL, 617, NULL, 'PIRSR634015-2', 277216),
(458123, 'PIRSR620777-51', NULL, NULL, 817, NULL, 'PIRSR620777-51', 277217),
(458124, 'PIRSR000865-2', NULL, NULL, 462, NULL, 'PIRSR000865-2', 277218),
(458125, 'PIRSR034515-2', NULL, NULL, 993, NULL, 'PIRSR034515-2', 277219),
(458126, 'PIRSR039004-2', NULL, NULL, 372, NULL, 'PIRSR039004-2', 277220),
(458127, 'PIRSR000097-1', NULL, NULL, 236, NULL, 'PIRSR000097-1', 277221),
(458128, 'PIRSR001021-2', NULL, NULL, 473, NULL, 'PIRSR001021-2', 277222),
(458129, 'PIRSR028762-1', NULL, NULL, 389, NULL, 'PIRSR028762-1', 277223),
(458130, 'PIRSR000410-1', NULL, NULL, 228, NULL, 'PIRSR000410-1', 277224),
(458131, 'PIRSR005096-1', NULL, NULL, 289, NULL, 'PIRSR005096-1', 277225),
(458132, 'PIRSR038142-50', NULL, NULL, 258, NULL, 'PIRSR038142-50', 277226),
(458133, 'PIRSR038455-2', NULL, NULL, 228, NULL, 'PIRSR038455-2', 277227),
(458134, 'PIRSR601233-2', NULL, NULL, 495, NULL, 'PIRSR601233-2', 277228),
(458135, 'PIRSR617711-2', NULL, NULL, 277, NULL, 'PIRSR617711-2', 277229),
(458136, 'PIRSR007802-1', NULL, NULL, 157, NULL, 'PIRSR007802-1', 277230),
(458137, 'PIRSR600823-5', NULL, NULL, 331, NULL, 'PIRSR600823-5', 277231),
(458138, 'PIRSR036298-50', NULL, NULL, 305, NULL, 'PIRSR036298-50', 277232),
(458139, 'PIRSR036421-1', NULL, NULL, 1083, NULL, 'PIRSR036421-1', 277233),
(458140, 'PIRSR037430-1', NULL, NULL, 177, NULL, 'PIRSR037430-1', 277234),
(458141, 'PIRSR002374-1', NULL, NULL, 182, NULL, 'PIRSR002374-1', 277235),
(458142, 'PIRSR601559-50', NULL, NULL, 305, NULL, 'PIRSR601559-50', 277236),
(458143, 'PIRSR016429-51', NULL, NULL, 357, NULL, 'PIRSR016429-51', 277237),
(458144, 'PIRSR006337-3', NULL, NULL, 599, NULL, 'PIRSR006337-3', 277238),
(458145, 'PIRSR623088-2', NULL, NULL, 333, NULL, 'PIRSR623088-2', 277239),
(458146, 'PIRSR621573-6', NULL, NULL, 2292, NULL, 'PIRSR621573-6', 277240),
(458147, 'PIRSR000350-4', NULL, NULL, 478, NULL, 'PIRSR000350-4', 277241),
(458148, 'PIRSR029271-50', NULL, NULL, 301, NULL, 'PIRSR029271-50', 277242),
(458149, 'PIRSR037938-2', NULL, NULL, 252, NULL, 'PIRSR037938-2', 277243),
(458150, 'PIRSR038994-1', NULL, NULL, 286, NULL, 'PIRSR038994-1', 277244),
(458151, 'PIRSR000013-1', NULL, NULL, 137, NULL, 'PIRSR000013-1', 277245),
(458152, 'PIRSR036442-1', NULL, NULL, 527, NULL, 'PIRSR036442-1', 277246),
(458153, 'PIRSR001134-2', NULL, NULL, 348, NULL, 'PIRSR001134-2', 277247),
(458154, 'PIRSR001149-4', NULL, NULL, 619, NULL, 'PIRSR001149-4', 277248),
(458155, 'PIRSR500948-2', NULL, NULL, 1098, NULL, 'PIRSR500948-2', 277249),
(458156, 'PIRSR001060-2', NULL, NULL, 320, NULL, 'PIRSR001060-2', 277250),
(458157, 'PIRSR039144-50', NULL, NULL, 112, NULL, 'PIRSR039144-50', 277251),
(458158, 'PIRSR629890-2', NULL, NULL, 908, NULL, 'PIRSR629890-2', 277252),
(458159, 'PIRSR004692-2', NULL, NULL, 314, NULL, 'PIRSR004692-2', 277253),
(458160, 'PIRSR631048-51', NULL, NULL, 611, NULL, 'PIRSR631048-51', 277254),
(458161, 'PIRSR000941-50', NULL, NULL, 330, NULL, 'PIRSR000941-50', 277255);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(458162, 'PIRSR005943-1', NULL, NULL, 481, NULL, 'PIRSR005943-1', 277256),
(458163, 'PIRSR038927-1', NULL, NULL, 631, NULL, 'PIRSR038927-1', 277257),
(458164, 'PIRSR628788-2', NULL, NULL, 326, NULL, 'PIRSR628788-2', 277258),
(458165, 'PIRSR016020-1', NULL, NULL, 257, NULL, 'PIRSR016020-1', 277259),
(458166, 'PIRSR006113-1', NULL, NULL, 130, NULL, 'PIRSR006113-1', 277260),
(458167, 'PIRSR627057-2', NULL, NULL, 439, NULL, 'PIRSR627057-2', 277261),
(458168, 'PIRSR037393-2', NULL, NULL, 548, NULL, 'PIRSR037393-2', 277262),
(458169, 'PIRSR627185-50', NULL, NULL, 785, NULL, 'PIRSR627185-50', 277263),
(458170, 'PIRSR006246-5', NULL, NULL, 128, NULL, 'PIRSR006246-5', 277264),
(458171, 'PIRSR018001-3', NULL, NULL, 313, NULL, 'PIRSR018001-3', 277265),
(458172, 'PIRSR025737-1', NULL, NULL, 280, NULL, 'PIRSR025737-1', 277266),
(458173, 'PIRSR006105-1', NULL, NULL, 157, NULL, 'PIRSR006105-1', 277267),
(458174, 'PIRSR006241-50', NULL, NULL, 267, NULL, 'PIRSR006241-50', 277268),
(458175, 'PIRSR037322-1', NULL, NULL, 166, NULL, 'PIRSR037322-1', 277269),
(458176, 'PIRSR606225-1', NULL, NULL, 248, NULL, 'PIRSR606225-1', 277270),
(458177, 'PIRSR031051-3', NULL, NULL, 247, NULL, 'PIRSR031051-3', 277271),
(458178, 'PIRSR001149-2', NULL, NULL, 619, NULL, 'PIRSR001149-2', 277272),
(458179, 'PIRSR000197-1', NULL, NULL, 1202, NULL, 'PIRSR000197-1', 277273),
(458180, 'PIRSR000029-1', NULL, NULL, 128, NULL, 'PIRSR000029-1', 277274),
(458181, 'PIRSR015919-1', NULL, NULL, 403, NULL, 'PIRSR015919-1', 277275),
(458182, 'PIRSR006230-1', NULL, NULL, 289, NULL, 'PIRSR006230-1', 277276),
(458183, 'PIRSR016567-50', NULL, NULL, 562, NULL, 'PIRSR016567-50', 277277),
(458184, 'PIRSR613307-50', NULL, NULL, 242, NULL, 'PIRSR613307-50', 277278),
(458185, 'PIRSR001084-2', NULL, NULL, 673, NULL, 'PIRSR001084-2', 277279),
(458186, 'PIRSR017689-1', NULL, NULL, 502, NULL, 'PIRSR017689-1', 277280),
(458187, 'PIRSR002495-50', NULL, NULL, 2813, NULL, 'PIRSR002495-50', 277281),
(458188, 'PIRSR000926-1', NULL, NULL, 298, NULL, 'PIRSR000926-1', 277282),
(458189, 'PIRSR036441-50', NULL, NULL, 443, NULL, 'PIRSR036441-50', 277283),
(458190, 'PIRSR037506-1', NULL, NULL, 628, NULL, 'PIRSR037506-1', 277284),
(458191, 'PIRSR018168-1', NULL, NULL, 365, NULL, 'PIRSR018168-1', 277285),
(458192, 'PIRSR002006-3', NULL, NULL, 662, NULL, 'PIRSR002006-3', 277286),
(458193, 'PIRSR017818-1', NULL, NULL, 223, NULL, 'PIRSR017818-1', 277287),
(458194, 'PIRSR622350-50', NULL, NULL, 150, NULL, 'PIRSR622350-50', 277288),
(458195, 'PIRSR634180-3', NULL, NULL, 421, NULL, 'PIRSR634180-3', 277289),
(458196, 'PIRSR038994-3', NULL, NULL, 286, NULL, 'PIRSR038994-3', 277290),
(458197, 'PIRSR001415-5', NULL, NULL, 309, NULL, 'PIRSR001415-5', 277291),
(458198, 'PIRSR000118-1', NULL, NULL, 592, NULL, 'PIRSR000118-1', 277292),
(458199, 'PIRSR018250-1', NULL, NULL, 371, NULL, 'PIRSR018250-1', 277293),
(458200, 'PIRSR631048-50', NULL, NULL, 611, NULL, 'PIRSR631048-50', 277294),
(458201, 'PIRSR000071-1', NULL, NULL, 53, NULL, 'PIRSR000071-1', 277295),
(458202, 'PIRSR000617-1', NULL, NULL, 1428, NULL, 'PIRSR000617-1', 277296),
(458203, 'PIRSR006356-1', NULL, NULL, 402, NULL, 'PIRSR006356-1', 277297),
(458204, 'PIRSR001492-3', NULL, NULL, 514, NULL, 'PIRSR001492-3', 277298),
(458205, 'PIRSR002825-1', NULL, NULL, 346, NULL, 'PIRSR002825-1', 277299),
(458206, 'PIRSR025648-1', NULL, NULL, 245, NULL, 'PIRSR025648-1', 277300),
(458207, 'PIRSR000556-2', NULL, NULL, 548, NULL, 'PIRSR000556-2', 277301),
(458208, 'PIRSR622312-50', NULL, NULL, 334, NULL, 'PIRSR622312-50', 277302),
(458209, 'PIRSR604677-50', NULL, NULL, 536, NULL, 'PIRSR604677-50', 277303),
(458210, 'PIRSR001341-1', NULL, NULL, 316, NULL, 'PIRSR001341-1', 277304),
(458211, 'PIRSR037941-1', NULL, NULL, 348, NULL, 'PIRSR037941-1', 277305),
(458212, 'PIRSR002855-1', NULL, NULL, 78, NULL, 'PIRSR002855-1', 277306),
(458213, 'PIRSR005739-1', NULL, NULL, 292, NULL, 'PIRSR005739-1', 277307),
(458214, 'PIRSR038927-3', NULL, NULL, 631, NULL, 'PIRSR038927-3', 277308),
(458215, 'PIRSR036497-2', NULL, NULL, 340, NULL, 'PIRSR036497-2', 277309);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(458216, 'PIRSR001092-1', NULL, NULL, 462, NULL, 'PIRSR001092-1', 277310),
(458217, 'PIRSR038065-1', NULL, NULL, 401, NULL, 'PIRSR038065-1', 277311),
(458218, 'PIRSR600821-52', NULL, NULL, 377, NULL, 'PIRSR600821-52', 277312),
(458219, 'PIRSR001924-3', NULL, NULL, 315, NULL, 'PIRSR001924-3', 277313),
(458220, 'PIRSR000097-3', NULL, NULL, 236, NULL, 'PIRSR000097-3', 277314),
(458221, 'PIRSR036489-3', NULL, NULL, 902, NULL, 'PIRSR036489-3', 277315),
(458222, 'PIRSR000550-2', NULL, NULL, 608, NULL, 'PIRSR000550-2', 277316),
(458223, 'PIRSR000127-2', NULL, NULL, 1342, NULL, 'PIRSR000127-2', 277317),
(458224, 'PIRSR634603-2', NULL, NULL, 359, NULL, 'PIRSR634603-2', 277318),
(458225, 'PIRSR001145-1', NULL, NULL, 563, NULL, 'PIRSR001145-1', 277319),
(458226, 'PIRSR000732-3', NULL, NULL, 473, NULL, 'PIRSR000732-3', 277320),
(458227, 'PIRSR622314-3', NULL, NULL, 522, NULL, 'PIRSR622314-3', 277321),
(458228, 'PIRSR000207-1', NULL, NULL, 547, NULL, 'PIRSR000207-1', 277322),
(458229, 'PIRSR000620-2', NULL, NULL, 306, NULL, 'PIRSR000620-2', 277323),
(458230, 'PIRSR036936-2', NULL, NULL, 491, NULL, 'PIRSR036936-2', 277324),
(458231, 'PIRSR629727-3', NULL, NULL, 750, NULL, 'PIRSR629727-3', 277325),
(458232, 'PIRSR003817-3', NULL, NULL, 3418, NULL, 'PIRSR003817-3', 277326),
(458233, 'PIRSR000445-1', NULL, NULL, 428, NULL, 'PIRSR000445-1', 277327),
(458234, 'PIRSR000027-2', NULL, NULL, 127, NULL, 'PIRSR000027-2', 277328),
(458235, 'PIRSR617821-2', NULL, NULL, 501, NULL, 'PIRSR617821-2', 277329),
(458236, 'PIRSR036432-1', NULL, NULL, 207, NULL, 'PIRSR036432-1', 277330),
(458237, 'PIRSR001658-50', NULL, NULL, 78, NULL, 'PIRSR001658-50', 277331),
(458238, 'PIRSR005669-1', NULL, NULL, 548, NULL, 'PIRSR005669-1', 277332),
(458239, 'PIRSR000260-1', NULL, NULL, 96, NULL, 'PIRSR000260-1', 277333),
(458240, 'PIRSR633573-1', NULL, NULL, 383, NULL, 'PIRSR633573-1', 277334),
(458241, 'PIRSR008129-1', NULL, NULL, 226, NULL, 'PIRSR008129-1', 277335),
(458242, 'PIRSR016308-2', NULL, NULL, 824, NULL, 'PIRSR016308-2', 277336),
(458243, 'PIRSR600250-50', NULL, NULL, 256, NULL, 'PIRSR600250-50', 277337),
(458244, 'PIRSR000149-1', NULL, NULL, 341, NULL, 'PIRSR000149-1', 277338),
(458245, 'PIRSR036376-50', NULL, NULL, 1088, NULL, 'PIRSR036376-50', 277339),
(458246, 'PIRSR029681-2', NULL, NULL, 181, NULL, 'PIRSR029681-2', 277340),
(458247, 'PIRSR004682-2', NULL, NULL, 186, NULL, 'PIRSR004682-2', 277341),
(458248, 'PIRSR000927-1', NULL, NULL, 927, NULL, 'PIRSR000927-1', 277342),
(458249, 'PIRSR037911-3', NULL, NULL, 660, NULL, 'PIRSR037911-3', 277343),
(458250, 'PIRSR631245-4', NULL, NULL, 760, NULL, 'PIRSR631245-4', 277344),
(458251, 'PIRSR000094-2', NULL, NULL, 260, NULL, 'PIRSR000094-2', 277345),
(458252, 'PIRSR000241-2', NULL, NULL, 289, NULL, 'PIRSR000241-2', 277346),
(458253, 'PIRSR038013-50', NULL, NULL, 293, NULL, 'PIRSR038013-50', 277347),
(458254, 'PIRSR001000-1', NULL, NULL, 139, NULL, 'PIRSR001000-1', 277348),
(458255, 'PIRSR000988-1', NULL, NULL, 259, NULL, 'PIRSR000988-1', 277349),
(458256, 'PIRSR001430-1', NULL, NULL, 204, NULL, 'PIRSR001430-1', 277350),
(458257, 'PIRSR011356-1', NULL, NULL, 287, NULL, 'PIRSR011356-1', 277351),
(458258, 'PIRSR000431-2', NULL, NULL, 457, NULL, 'PIRSR000431-2', 277352),
(458259, 'PIRSR019634-50', NULL, NULL, 809, NULL, 'PIRSR019634-50', 277353),
(458260, 'PIRSR005639-1', NULL, NULL, 195, NULL, 'PIRSR005639-1', 277354),
(458261, 'PIRSR000102-2', NULL, NULL, 327, NULL, 'PIRSR000102-2', 277355),
(458262, 'PIRSR001093-1', NULL, NULL, 570, NULL, 'PIRSR001093-1', 277356),
(458263, 'PIRSR002421-3', NULL, NULL, 372, NULL, 'PIRSR002421-3', 277357),
(458264, 'PIRSR037568-1', NULL, NULL, 1182, NULL, 'PIRSR037568-1', 277358),
(458265, 'PIRSR500133-2', NULL, NULL, 474, NULL, 'PIRSR500133-2', 277359),
(458266, 'PIRSR001942-1', NULL, NULL, 176, NULL, 'PIRSR001942-1', 277360),
(458267, 'PIRSR005965-1', NULL, NULL, 124, NULL, 'PIRSR005965-1', 277361),
(458268, 'PIRSR024851-51', NULL, NULL, 169, NULL, 'PIRSR024851-51', 277362),
(458269, 'PIRSR000361-1', NULL, NULL, 373, NULL, 'PIRSR000361-1', 277363);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(458270, 'PIRSR633528-5', NULL, NULL, 947, NULL, 'PIRSR633528-5', 277364),
(458271, 'PIRSR037599-3', NULL, NULL, 159, NULL, 'PIRSR037599-3', 277365),
(458272, 'PIRSR629580-5', NULL, NULL, 600, NULL, 'PIRSR629580-5', 277366),
(458273, 'PIRSR002017-1', NULL, NULL, 374, NULL, 'PIRSR002017-1', 277367),
(458274, 'PIRSR633195-1', NULL, NULL, 423, NULL, 'PIRSR633195-1', 277368),
(458275, 'PIRSR018571-1', NULL, NULL, 301, NULL, 'PIRSR018571-1', 277369),
(458276, 'PIRSR019663-1', NULL, NULL, 426, NULL, 'PIRSR019663-1', 277370),
(458277, 'PIRSR038885-1', NULL, NULL, 389, NULL, 'PIRSR038885-1', 277371),
(458278, 'PIRSR001146-1', NULL, NULL, 460, NULL, 'PIRSR001146-1', 277372),
(458279, 'PIRSR633560-51', NULL, NULL, 572, NULL, 'PIRSR633560-51', 277373),
(458280, 'PIRSR000090-1', NULL, NULL, 258, NULL, 'PIRSR000090-1', 277374),
(458281, 'PIRSR036665-52', NULL, NULL, 881, NULL, 'PIRSR036665-52', 277375),
(458282, 'PIRSR000862-1', NULL, NULL, 365, NULL, 'PIRSR000862-1', 277376),
(458283, 'PIRSR500947-50', NULL, NULL, 987, NULL, 'PIRSR500947-50', 277377),
(458284, 'PIRSR600269-51', NULL, NULL, 742, NULL, 'PIRSR600269-51', 277378),
(458285, 'PIRSR011861-1', NULL, NULL, 511, NULL, 'PIRSR011861-1', 277379),
(458286, 'PIRSR001109-1', NULL, NULL, 421, NULL, 'PIRSR001109-1', 277380),
(458287, 'PIRSR005096-2', NULL, NULL, 289, NULL, 'PIRSR005096-2', 277381),
(458288, 'PIRSR005149-50', NULL, NULL, 369, NULL, 'PIRSR005149-50', 277382),
(458289, 'PIRSR037479-3', NULL, NULL, 472, NULL, 'PIRSR037479-3', 277383),
(458290, 'PIRSR015853-2', NULL, NULL, 187, NULL, 'PIRSR015853-2', 277384),
(458291, 'PIRSR001569-1', NULL, NULL, 469, NULL, 'PIRSR001569-1', 277385),
(458292, 'PIRSR037913-2', NULL, NULL, 365, NULL, 'PIRSR037913-2', 277386),
(458293, 'PIRSR611612-50', NULL, NULL, 570, NULL, 'PIRSR611612-50', 277387),
(458294, 'PIRSR036488-1', NULL, NULL, 149, NULL, 'PIRSR036488-1', 277388),
(458295, 'PIRSR617711-1', NULL, NULL, 277, NULL, 'PIRSR617711-1', 277389),
(458296, 'PIRSR010354-50', NULL, NULL, 3808, NULL, 'PIRSR010354-50', 277390),
(458297, 'PIRSR001619-1', NULL, NULL, 296, NULL, 'PIRSR001619-1', 277391),
(458298, 'PIRSR037479-1', NULL, NULL, 472, NULL, 'PIRSR037479-1', 277392),
(458299, 'PIRSR627053-2', NULL, NULL, 749, NULL, 'PIRSR627053-2', 277393),
(458300, 'PIRSR000350-3', NULL, NULL, 478, NULL, 'PIRSR000350-3', 277394),
(458301, 'PIRSR000355-1', NULL, NULL, 342, NULL, 'PIRSR000355-1', 277395),
(458302, 'PIRSR026389-2', NULL, NULL, 740, NULL, 'PIRSR026389-2', 277396),
(458303, 'PIRSR000706-1', NULL, NULL, 264, NULL, 'PIRSR000706-1', 277397),
(458304, 'PIRSR002900-1', NULL, NULL, 55, NULL, 'PIRSR002900-1', 277398),
(458305, 'PIRSR000915-1', NULL, NULL, 269, NULL, 'PIRSR000915-1', 277399),
(458306, 'PIRSR000454-3', NULL, NULL, 1844, NULL, 'PIRSR000454-3', 277400),
(458307, 'PIRSR028757-1', NULL, NULL, 235, NULL, 'PIRSR028757-1', 277401),
(458308, 'PIRSR611778-50', NULL, NULL, 500, NULL, 'PIRSR611778-50', 277402),
(458309, 'PIRSR000185-1', NULL, NULL, 401, NULL, 'PIRSR000185-1', 277403),
(458310, 'PIRSR001430-3', NULL, NULL, 204, NULL, 'PIRSR001430-3', 277404),
(458311, 'PIRSR006431-1', NULL, NULL, 300, NULL, 'PIRSR006431-1', 277405),
(458312, 'PIRSR037947-1', NULL, NULL, 357, NULL, 'PIRSR037947-1', 277406),
(458313, 'PIRSR000013-2', NULL, NULL, 137, NULL, 'PIRSR000013-2', 277407),
(458314, 'PIRSR000808-3', NULL, NULL, 353, NULL, 'PIRSR000808-3', 277408),
(458315, 'PIRSR000007-51', NULL, NULL, 276, NULL, 'PIRSR000007-51', 277409),
(458316, 'PIRSR000905-2', NULL, NULL, 353, NULL, 'PIRSR000905-2', 277410),
(458317, 'PIRSR016150-51', NULL, NULL, 459, NULL, 'PIRSR016150-51', 277411),
(458318, 'PIRSR629609-2', NULL, NULL, 719, NULL, 'PIRSR629609-2', 277412),
(458319, 'PIRSR018249-2', NULL, NULL, 210, NULL, 'PIRSR018249-2', 277413),
(458320, 'PIRSR006337-2', NULL, NULL, 599, NULL, 'PIRSR006337-2', 277414),
(458321, 'PIRSR026534-3', NULL, NULL, 324, NULL, 'PIRSR026534-3', 277415),
(458322, 'PIRSR000459-1', NULL, NULL, 673, NULL, 'PIRSR000459-1', 277416),
(458323, 'PIRSR001589-2', NULL, NULL, 535, NULL, 'PIRSR001589-2', 277417);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(458324, 'PIRSR001222-51', NULL, NULL, 837, NULL, 'PIRSR001222-51', 277418),
(458325, 'PIRSR001355-3', NULL, NULL, 358, NULL, 'PIRSR001355-3', 277419),
(458326, 'PIRSR002736-50', NULL, NULL, 97, NULL, 'PIRSR002736-50', 277420),
(458327, 'PIRSR037242-2', NULL, NULL, 480, NULL, 'PIRSR037242-2', 277421),
(458328, 'PIRSR628391-4', NULL, NULL, 778, NULL, 'PIRSR628391-4', 277422),
(458329, 'PIRSR001235-1', NULL, NULL, 415, NULL, 'PIRSR001235-1', 277423),
(458330, 'PIRSR601191-2', NULL, NULL, 342, NULL, 'PIRSR601191-2', 277424),
(458331, 'PIRSR028774-2', NULL, NULL, 358, NULL, 'PIRSR028774-2', 277425),
(458332, 'PIRSR635711-52', NULL, NULL, 1653, NULL, 'PIRSR635711-52', 277426),
(458333, 'PIRSR036551-1', NULL, NULL, 236, NULL, 'PIRSR036551-1', 277427),
(458334, 'PIRSR000238-1', NULL, NULL, 520, NULL, 'PIRSR000238-1', 277428),
(458335, 'PIRSR004682-4', NULL, NULL, 186, NULL, 'PIRSR004682-4', 277429),
(458336, 'PIRSR016958-1', NULL, NULL, 200, NULL, 'PIRSR016958-1', 277430),
(458337, 'PIRSR000509-1', NULL, NULL, 415, NULL, 'PIRSR000509-1', 277431),
(458338, 'PIRSR000108-2', NULL, NULL, 358, NULL, 'PIRSR000108-2', 277432),
(458339, 'PIRSR600983-52', NULL, NULL, 151, NULL, 'PIRSR600983-52', 277433),
(458340, 'PIRSR000192-3', NULL, NULL, 188, NULL, 'PIRSR000192-3', 277434),
(458341, 'PIRSR005822-1', NULL, NULL, 93, NULL, 'PIRSR005822-1', 277435),
(458342, 'PIRSR037935-1', NULL, NULL, 567, NULL, 'PIRSR037935-1', 277436),
(458343, 'PIRSR006468-1', NULL, NULL, 357, NULL, 'PIRSR006468-1', 277437),
(458344, 'PIRSR631245-5', NULL, NULL, 760, NULL, 'PIRSR631245-5', 277438),
(458345, 'PIRSR037303-2', NULL, NULL, 808, NULL, 'PIRSR037303-2', 277439),
(458346, 'PIRSR608356-51', NULL, NULL, 562, NULL, 'PIRSR608356-51', 277440),
(458347, 'PIRSR633508-4', NULL, NULL, 950, NULL, 'PIRSR633508-4', 277441),
(458348, 'PIRSR000409-3', NULL, NULL, 338, NULL, 'PIRSR000409-3', 277442),
(458349, 'PIRSR000732-2', NULL, NULL, 473, NULL, 'PIRSR000732-2', 277443),
(458350, 'PIRSR001227-2', NULL, NULL, 808, NULL, 'PIRSR001227-2', 277444),
(458351, 'PIRSR017205-3', NULL, NULL, 404, NULL, 'PIRSR017205-3', 277445),
(458352, 'PIRSR002279-2', NULL, NULL, 2340, NULL, 'PIRSR002279-2', 277446),
(458353, 'PIRSR000169-2', NULL, NULL, 115, NULL, 'PIRSR000169-2', 277447),
(458354, 'PIRSR002033-1', NULL, NULL, 119, NULL, 'PIRSR002033-1', 277448),
(458355, 'PIRSR634015-1', NULL, NULL, 617, NULL, 'PIRSR634015-1', 277449),
(458356, 'PIRSR623237-1', NULL, NULL, 352, NULL, 'PIRSR623237-1', 277450),
(458357, 'PIRSR017818-3', NULL, NULL, 223, NULL, 'PIRSR017818-3', 277451),
(458358, 'PIRSR018063-50', NULL, NULL, 171, NULL, 'PIRSR018063-50', 277452),
(458359, 'PIRSR009407-1', NULL, NULL, 742, NULL, 'PIRSR009407-1', 277453),
(458360, 'PIRSR017617-1', NULL, NULL, 276, NULL, 'PIRSR017617-1', 277454),
(458361, 'PIRSR628788-1', NULL, NULL, 326, NULL, 'PIRSR628788-1', 277455),
(458362, 'PIRSR003817-4', NULL, NULL, 3418, NULL, 'PIRSR003817-4', 277456),
(458363, 'PIRSR000445-3', NULL, NULL, 428, NULL, 'PIRSR000445-3', 277457),
(458364, 'PIRSR005536-2', NULL, NULL, 723, NULL, 'PIRSR005536-2', 277458),
(458365, 'PIRSR602325-50', NULL, NULL, 319, NULL, 'PIRSR602325-50', 277459),
(458366, 'PIRSR009343-2', NULL, NULL, 258, NULL, 'PIRSR009343-2', 277460),
(458367, 'PIRSR006621-1', NULL, NULL, 299, NULL, 'PIRSR006621-1', 277461),
(458368, 'PIRSR009103-1', NULL, NULL, 156, NULL, 'PIRSR009103-1', 277462),
(458369, 'PIRSR012565-1', NULL, NULL, 111, NULL, 'PIRSR012565-1', 277463),
(458370, 'PIRSR623088-3', NULL, NULL, 333, NULL, 'PIRSR623088-3', 277464),
(458371, 'PIRSR038025-50', NULL, NULL, 401, NULL, 'PIRSR038025-50', 277465),
(458372, 'PIRSR038079-1', NULL, NULL, 332, NULL, 'PIRSR038079-1', 277466),
(458373, 'PIRSR001134-1', NULL, NULL, 254, NULL, 'PIRSR001134-1', 277467),
(458374, 'PIRSR006250-1', NULL, NULL, 282, NULL, 'PIRSR006250-1', 277468),
(458375, 'PIRSR016308-1', NULL, NULL, 824, NULL, 'PIRSR016308-1', 277469),
(458376, 'PIRSR600990-52', NULL, NULL, 671, NULL, 'PIRSR600990-52', 277470),
(458377, 'PIRSR639901-2', NULL, NULL, 430, NULL, 'PIRSR639901-2', 277471);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(458378, 'PIRSR000177-1', NULL, NULL, 252, NULL, 'PIRSR000177-1', 277472),
(458379, 'PIRSR001196-2', NULL, NULL, 707, NULL, 'PIRSR001196-2', 277473),
(458380, 'PIRSR011789-1', NULL, NULL, 400, NULL, 'PIRSR011789-1', 277474),
(458381, 'PIRSR621573-8', NULL, NULL, 2292, NULL, 'PIRSR621573-8', 277475),
(458382, 'PIRSR600542-1', NULL, NULL, 630, NULL, 'PIRSR600542-1', 277476),
(458383, 'PIRSR006246-3', NULL, NULL, 118, NULL, 'PIRSR006246-3', 277477),
(458384, 'PIRSR000548-1', NULL, NULL, 270, NULL, 'PIRSR000548-1', 277478),
(458385, 'PIRSR023956-1', NULL, NULL, 211, NULL, 'PIRSR023956-1', 277479),
(458386, 'PIRSR038085-2', NULL, NULL, 151, NULL, 'PIRSR038085-2', 277480),
(458387, 'PIRSR037281-2', NULL, NULL, 480, NULL, 'PIRSR037281-2', 277481),
(458388, 'PIRSR038023-1', NULL, NULL, 411, NULL, 'PIRSR038023-1', 277482),
(458389, 'PIRSR630297-1', NULL, NULL, 223, NULL, 'PIRSR630297-1', 277483),
(458390, 'PIRSR000846-2', NULL, NULL, 298, NULL, 'PIRSR000846-2', 277484),
(458391, 'PIRSR001814-1', NULL, NULL, 113, NULL, 'PIRSR001814-1', 277485),
(458392, 'PIRSR621573-1', NULL, NULL, 2292, NULL, 'PIRSR621573-1', 277486),
(458393, 'PIRSR001199-2', NULL, NULL, 1005, NULL, 'PIRSR001199-2', 277487),
(458394, 'PIRSR600888-1', NULL, NULL, 164, NULL, 'PIRSR600888-1', 277488),
(458395, 'PIRSR016305-1', NULL, NULL, 271, NULL, 'PIRSR016305-1', 277489),
(458396, 'PIRSR002030-1', NULL, NULL, 130, NULL, 'PIRSR002030-1', 277490),
(458397, 'PIRSR037250-50', NULL, NULL, 663, NULL, 'PIRSR037250-50', 277491),
(458398, 'PIRSR000495-1', NULL, NULL, 208, NULL, 'PIRSR000495-1', 277492),
(458399, 'PIRSR633144-1', NULL, NULL, 410, NULL, 'PIRSR633144-1', 277493),
(458400, 'PIRSR000105-3', NULL, NULL, 286, NULL, 'PIRSR000105-3', 277494),
(458401, 'PIRSR001341-3', NULL, NULL, 316, NULL, 'PIRSR001341-3', 277495),
(458402, 'PIRSR001199-1', NULL, NULL, 1005, NULL, 'PIRSR001199-1', 277496),
(458403, 'PIRSR001787-1', NULL, NULL, 392, NULL, 'PIRSR001787-1', 277497),
(458404, 'PIRSR611612-51', NULL, NULL, 570, NULL, 'PIRSR611612-51', 277498),
(458405, 'PIRSR000336-1', NULL, NULL, 441, NULL, 'PIRSR000336-1', 277499),
(458406, 'PIRSR036936-1', NULL, NULL, 549, NULL, 'PIRSR036936-1', 277500),
(458407, 'PIRSR001480-2', NULL, NULL, 403, NULL, 'PIRSR001480-2', 277501),
(458408, 'PIRSR018168-3', NULL, NULL, 365, NULL, 'PIRSR018168-3', 277502),
(458409, 'PIRSR601559-52', NULL, NULL, 305, NULL, 'PIRSR601559-52', 277503),
(458410, 'PIRSR005096-3', NULL, NULL, 289, NULL, 'PIRSR005096-3', 277504),
(458411, 'PIRSR001174-2', NULL, NULL, 760, NULL, 'PIRSR001174-2', 277505),
(458412, 'PIRSR000333-1', NULL, NULL, 1095, NULL, 'PIRSR000333-1', 277506),
(458413, 'PIRSR001112-1', NULL, NULL, 458, NULL, 'PIRSR001112-1', 277507),
(458414, 'PIRSR606710-1', NULL, NULL, 322, NULL, 'PIRSR606710-1', 277508),
(458415, 'PIRSR001667-1', NULL, NULL, 75, NULL, 'PIRSR001667-1', 277509),
(458416, 'PIRSR001951-1', NULL, NULL, 193, NULL, 'PIRSR001951-1', 277510),
(458417, 'PIRSR634603-1', NULL, NULL, 359, NULL, 'PIRSR634603-1', 277511),
(458418, 'PIRSR000699-2', NULL, NULL, 103, NULL, 'PIRSR000699-2', 277512),
(458419, 'PIRSR002560-1', NULL, NULL, 158, NULL, 'PIRSR002560-1', 277513),
(458420, 'PIRSR015852-1', NULL, NULL, 262, NULL, 'PIRSR015852-1', 277514),
(458421, 'PIRSR016573-1', NULL, NULL, 161, NULL, 'PIRSR016573-1', 277515),
(458422, 'PIRSR000550-1', NULL, NULL, 608, NULL, 'PIRSR000550-1', 277516),
(458423, 'PIRSR001480-1', NULL, NULL, 403, NULL, 'PIRSR001480-1', 277517),
(458424, 'PIRSR037921-1', NULL, NULL, 405, NULL, 'PIRSR037921-1', 277518),
(458425, 'PIRSR037032-1', NULL, NULL, 296, NULL, 'PIRSR037032-1', 277519),
(458426, 'PIRSR603051-50', NULL, NULL, 415, NULL, 'PIRSR603051-50', 277520),
(458427, 'PIRSR000241-1', NULL, NULL, 289, NULL, 'PIRSR000241-1', 277521),
(458428, 'PIRSR018168-2', NULL, NULL, 365, NULL, 'PIRSR018168-2', 277522),
(458429, 'PIRSR037799-1', NULL, NULL, 76, NULL, 'PIRSR037799-1', 277523),
(458430, 'PIRSR002279-1', NULL, NULL, 2340, NULL, 'PIRSR002279-1', 277524),
(458431, 'PIRSR633528-6', NULL, NULL, 947, NULL, 'PIRSR633528-6', 277525),
(458432, 'PIRSR037403-1', NULL, NULL, 453, NULL, 'PIRSR037403-1', 277526);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(458433, 'PIRSR037031-51', NULL, NULL, 78, NULL, 'PIRSR037031-51', 277527),
(458434, 'PIRSR605428-50', NULL, NULL, 472, NULL, 'PIRSR605428-50', 277528),
(458435, 'PIRSR037350-1', NULL, NULL, 239, NULL, 'PIRSR037350-1', 277529),
(458436, 'PIRSR001218-1', NULL, NULL, 203, NULL, 'PIRSR001218-1', 277530),
(458437, 'PIRSR000450-1', NULL, NULL, 301, NULL, 'PIRSR000450-1', 277531),
(458438, 'PIRSR609451-50', NULL, NULL, 407, NULL, 'PIRSR609451-50', 277532),
(458439, 'PIRSR000192-4', NULL, NULL, 188, NULL, 'PIRSR000192-4', 277533),
(458440, 'PIRSR015604-1', NULL, NULL, 160, NULL, 'PIRSR015604-1', 277534),
(458441, 'PIRSR002412-1', NULL, NULL, 509, NULL, 'PIRSR002412-1', 277535),
(458442, 'PIRSR006769-1', NULL, NULL, 324, NULL, 'PIRSR006769-1', 277536),
(458443, 'PIRSR000386-1', NULL, NULL, 216, NULL, 'PIRSR000386-1', 277537),
(458444, 'PIRSR037091-1', NULL, NULL, 576, NULL, 'PIRSR037091-1', 277538),
(458445, 'PIRSR038128-50', NULL, NULL, 330, NULL, 'PIRSR038128-50', 277539),
(458446, 'PIRSR028774-1', NULL, NULL, 358, NULL, 'PIRSR028774-1', 277540),
(458447, 'PIRSR015582-1', NULL, NULL, 258, NULL, 'PIRSR015582-1', 277541),
(458448, 'PIRSR000882-1', NULL, NULL, 686, NULL, 'PIRSR000882-1', 277542),
(458449, 'PIRSR031051-2', NULL, NULL, 247, NULL, 'PIRSR031051-2', 277543),
(458450, 'PIRSR007531-1', NULL, NULL, 214, NULL, 'PIRSR007531-1', 277544),
(458451, 'PIRSR022993-1', NULL, NULL, 154, NULL, 'PIRSR022993-1', 277545),
(458452, 'PIRSR019543-2', NULL, NULL, 164, NULL, 'PIRSR019543-2', 277546),
(458453, 'PIRSR000108-3', NULL, NULL, 358, NULL, 'PIRSR000108-3', 277547),
(458454, 'PIRSR037281-3', NULL, NULL, 480, NULL, 'PIRSR037281-3', 277548),
(458455, 'PIRSR001222-50', NULL, NULL, 837, NULL, 'PIRSR001222-50', 277549),
(458456, 'PIRSR604329-50', NULL, NULL, 151, NULL, 'PIRSR604329-50', 277550),
(458457, 'PIRSR001363-1', NULL, NULL, 537, NULL, 'PIRSR001363-1', 277551),
(458458, 'PIRSR634183-2', NULL, NULL, 424, NULL, 'PIRSR634183-2', 277552),
(458459, 'PIRSR000130-3', NULL, NULL, 473, NULL, 'PIRSR000130-3', 277553),
(458460, 'PIRSR001196-1', NULL, NULL, 707, NULL, 'PIRSR001196-1', 277554),
(458461, 'PIRSR001979-1', NULL, NULL, 503, NULL, 'PIRSR001979-1', 277555),
(458462, 'PIRSR003047-2', NULL, NULL, 1893, NULL, 'PIRSR003047-2', 277556),
(458463, 'PIRSR001024-4', NULL, NULL, 477, NULL, 'PIRSR001024-4', 277557),
(458464, 'PIRSR033579-1', NULL, NULL, 271, NULL, 'PIRSR033579-1', 277558),
(458465, 'PIRSR000445-2', NULL, NULL, 428, NULL, 'PIRSR000445-2', 277559),
(458466, 'PIRSR617653-1', NULL, NULL, 446, NULL, 'PIRSR617653-1', 277560),
(458467, 'PIRSR000972-50', NULL, NULL, 594, NULL, 'PIRSR000972-50', 277561),
(458468, 'PIRSR600917-52', NULL, NULL, 562, NULL, 'PIRSR600917-52', 277562),
(458469, 'PIRSR036421-3', NULL, NULL, 1083, NULL, 'PIRSR036421-3', 277563),
(458470, 'PIRSR039050-50', NULL, NULL, 1101, NULL, 'PIRSR039050-50', 277564),
(458471, 'PIRSR629511-1', NULL, NULL, 279, NULL, 'PIRSR629511-1', 277565),
(458472, 'PIRSR617512-4', NULL, NULL, 726, NULL, 'PIRSR617512-4', 277566),
(458473, 'PIRSR634598-1', NULL, NULL, 445, NULL, 'PIRSR634598-1', 277567),
(458474, 'PIRSR001461-3', NULL, NULL, 213, NULL, 'PIRSR001461-3', 277568),
(458475, 'PIRSR604550-50', NULL, NULL, 352, NULL, 'PIRSR604550-50', 277569),
(458476, 'PIRSR000350-2', NULL, NULL, 478, NULL, 'PIRSR000350-2', 277570),
(458477, 'PIRSR002549-1', NULL, NULL, 708, NULL, 'PIRSR002549-1', 277571),
(458478, 'PIRSR627053-1', NULL, NULL, 749, NULL, 'PIRSR627053-1', 277572),
(458479, 'PIRSR000294-1', NULL, NULL, 340, NULL, 'PIRSR000294-1', 277573),
(458480, 'PIRSR006337-1', NULL, NULL, 599, NULL, 'PIRSR006337-1', 277574),
(458481, 'PIRSR009449-1', NULL, NULL, 437, NULL, 'PIRSR009449-1', 277575),
(458482, 'PIRSR036426-1', NULL, NULL, 232, NULL, 'PIRSR036426-1', 277576),
(458483, 'PIRSR609662-50', NULL, NULL, 103, NULL, 'PIRSR609662-50', 277577),
(458484, 'PIRSR038096-1', NULL, NULL, 175, NULL, 'PIRSR038096-1', 277578),
(458485, 'PIRSR000183-2', NULL, NULL, 372, NULL, 'PIRSR000183-2', 277579),
(458486, 'PIRSR011794-1', NULL, NULL, 528, NULL, 'PIRSR011794-1', 277580);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(458487, 'PIRSR036489-4', NULL, NULL, 902, NULL, 'PIRSR036489-4', 277581),
(458488, 'PIRSR005229-1', NULL, NULL, 228, NULL, 'PIRSR005229-1', 277582),
(458489, 'PIRSR000517-1', NULL, NULL, 404, NULL, 'PIRSR000517-1', 277583),
(458490, 'PIRSR000933-50', NULL, NULL, 2487, NULL, 'PIRSR000933-50', 277584),
(458491, 'PIRSR037479-2', NULL, NULL, 472, NULL, 'PIRSR037479-2', 277585),
(458492, 'PIRSR015599-1', NULL, NULL, 279, NULL, 'PIRSR015599-1', 277586),
(458493, 'PIRSR037955-1', NULL, NULL, 340, NULL, 'PIRSR037955-1', 277587),
(458494, 'PIRSR011396-2', NULL, NULL, 308, NULL, 'PIRSR011396-2', 277588),
(458495, 'PIRSR032067-1', NULL, NULL, 271, NULL, 'PIRSR032067-1', 277589),
(458496, 'PIRSR006404-2', NULL, NULL, 322, NULL, 'PIRSR006404-2', 277590),
(458497, 'PIRSR602187-50', NULL, NULL, 115, NULL, 'PIRSR602187-50', 277591),
(458498, 'PIRSR000439-1', NULL, NULL, 236, NULL, 'PIRSR000439-1', 277592),
(458499, 'PIRSR028980-1', NULL, NULL, 211, NULL, 'PIRSR028980-1', 277593),
(458500, 'PIRSR027744-1', NULL, NULL, 567, NULL, 'PIRSR027744-1', 277594),
(458501, 'PIRSR000559-1', NULL, NULL, 597, NULL, 'PIRSR000559-1', 277595),
(458502, 'PIRSR016150-50', NULL, NULL, 459, NULL, 'PIRSR016150-50', 277596),
(458503, 'PIRSR037038-1', NULL, NULL, 93, NULL, 'PIRSR037038-1', 277597),
(458504, 'PIRSR001235-2', NULL, NULL, 415, NULL, 'PIRSR001235-2', 277598),
(458505, 'PIRSR001355-2', NULL, NULL, 358, NULL, 'PIRSR001355-2', 277599),
(458506, 'PIRSR622230-3', NULL, NULL, 3175, NULL, 'PIRSR622230-3', 277600),
(458507, 'PIRSR500947-51', NULL, NULL, 987, NULL, 'PIRSR500947-51', 277601),
(458508, 'PIRSR600269-50', NULL, NULL, 742, NULL, 'PIRSR600269-50', 277602),
(458509, 'PIRSR000389-1', NULL, NULL, 524, NULL, 'PIRSR000389-1', 277603),
(458510, 'PIRSR036666-50', NULL, NULL, 519, NULL, 'PIRSR036666-50', 277604),
(458511, 'PIRSR000726-1', NULL, NULL, 354, NULL, 'PIRSR000726-1', 277605),
(458512, 'PIRSR037242-3', NULL, NULL, 480, NULL, 'PIRSR037242-3', 277606),
(458513, 'PIRSR001123-1', NULL, NULL, 341, NULL, 'PIRSR001123-1', 277607),
(458514, 'PIRSR038051-1', NULL, NULL, 523, NULL, 'PIRSR038051-1', 277608),
(458515, 'PIRSR017107-2', NULL, NULL, 415, NULL, 'PIRSR017107-2', 277609),
(458516, 'PIRSR001093-2', NULL, NULL, 535, NULL, 'PIRSR001093-2', 277610),
(458517, 'PIRSR001589-1', NULL, NULL, 535, NULL, 'PIRSR001589-1', 277611),
(458518, 'PIRSR000556-1', NULL, NULL, 548, NULL, 'PIRSR000556-1', 277612),
(458519, 'PIRSR006429-1', NULL, NULL, 505, NULL, 'PIRSR006429-1', 277613),
(458520, 'PIRSR000459-2', NULL, NULL, 673, NULL, 'PIRSR000459-2', 277614),
(458521, 'PIRSR038885-2', NULL, NULL, 389, NULL, 'PIRSR038885-2', 277615),
(458522, 'PIRSR000808-4', NULL, NULL, 353, NULL, 'PIRSR000808-4', 277616),
(458523, 'PIRSR036917-2', NULL, NULL, 684, NULL, 'PIRSR036917-2', 277617),
(458524, 'PIRSR037947-2', NULL, NULL, 357, NULL, 'PIRSR037947-2', 277618),
(458525, 'PIRSR629609-1', NULL, NULL, 719, NULL, 'PIRSR629609-1', 277619),
(458526, 'PIRSR634180-2', NULL, NULL, 421, NULL, 'PIRSR634180-2', 277620),
(458527, 'PIRSR629601-3', NULL, NULL, 1866, NULL, 'PIRSR629601-3', 277621),
(458528, 'PIRSR000631-1', NULL, NULL, 1114, NULL, 'PIRSR000631-1', 277622),
(458529, 'PIRSR017199-1', NULL, NULL, 112, NULL, 'PIRSR017199-1', 277623),
(458530, 'PIRSR028729-50', NULL, NULL, 163, NULL, 'PIRSR028729-50', 277624),
(458531, 'PIRSR500950-50', NULL, NULL, 1088, NULL, 'PIRSR500950-50', 277625),
(458532, 'PIRSR000138-1', NULL, NULL, 369, NULL, 'PIRSR000138-1', 277626),
(458533, 'PIRSR000454-4', NULL, NULL, 1844, NULL, 'PIRSR000454-4', 277627),
(458534, 'PIRSR001238-2', NULL, NULL, 390, NULL, 'PIRSR001238-2', 277628),
(458535, 'PIRSR001031-1', NULL, NULL, 616, NULL, 'PIRSR001031-1', 277629),
(458536, 'PIRSR607724-2', NULL, NULL, 433, NULL, 'PIRSR607724-2', 277630),
(458537, 'PIRSR629576-2', NULL, NULL, 604, NULL, 'PIRSR629576-2', 277631),
(458538, 'PIRSR000977-1', NULL, NULL, 480, NULL, 'PIRSR000977-1', 277632),
(458539, 'PIRSR001336-50', NULL, NULL, 644, NULL, 'PIRSR001336-50', 277633),
(458540, 'PIRSR001362-1', NULL, NULL, 540, NULL, 'PIRSR001362-1', 277634);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(458541, 'PIRSR500133-1', NULL, NULL, 474, NULL, 'PIRSR500133-1', 277635),
(458542, 'PIRSR017267-2', NULL, NULL, 106, NULL, 'PIRSR017267-2', 277636),
(458543, 'PIRSR600250-51', NULL, NULL, 282, NULL, 'PIRSR600250-51', 277637),
(458544, 'PIRSR618319-50', NULL, NULL, 462, NULL, 'PIRSR618319-50', 277638),
(458545, 'PIRSR029681-1', NULL, NULL, 181, NULL, 'PIRSR029681-1', 277639),
(458546, 'PIRSR600997-1', NULL, NULL, 604, NULL, 'PIRSR600997-1', 277640),
(458547, 'PIRSR016502-1', NULL, NULL, 326, NULL, 'PIRSR016502-1', 277641),
(458548, 'PIRSR000636-2', NULL, NULL, 1129, NULL, 'PIRSR000636-2', 277642),
(458549, 'PIRSR013503-2', NULL, NULL, 215, NULL, 'PIRSR013503-2', 277643),
(458550, 'PIRSR016308-3', NULL, NULL, 824, NULL, 'PIRSR016308-3', 277644),
(458551, 'PIRSR016573-2', NULL, NULL, 161, NULL, 'PIRSR016573-2', 277645),
(458552, 'PIRSR631245-3', NULL, NULL, 760, NULL, 'PIRSR631245-3', 277646),
(458553, 'PIRSR002816-1', NULL, NULL, 335, NULL, 'PIRSR002816-1', 277647),
(458554, 'PIRSR617821-1', NULL, NULL, 501, NULL, 'PIRSR617821-1', 277648),
(458555, 'PIRSR036565-2', NULL, NULL, 519, NULL, 'PIRSR036565-2', 277649),
(458556, 'PIRSR620777-52', NULL, NULL, 817, NULL, 'PIRSR620777-52', 277650),
(458557, 'PIRSR037861-1', NULL, NULL, 208, NULL, 'PIRSR037861-1', 277651),
(458558, 'PIRSR000183-3', NULL, NULL, 372, NULL, 'PIRSR000183-3', 277652),
(458559, 'PIRSR000381-2', NULL, NULL, 1218, NULL, 'PIRSR000381-2', 277653),
(458560, 'PIRSR015894-1', NULL, NULL, 456, NULL, 'PIRSR015894-1', 277654),
(458561, 'PIRSR037123-1', NULL, NULL, 1249, NULL, 'PIRSR037123-1', 277655),
(458562, 'PIRSR601191-1', NULL, NULL, 342, NULL, 'PIRSR601191-1', 277656),
(458563, 'PIRSR623088-1', NULL, NULL, 333, NULL, 'PIRSR623088-1', 277657),
(458564, 'PIRSR601621-2', NULL, NULL, 370, NULL, 'PIRSR601621-2', 277658),
(458565, 'PIRSR607724-1', NULL, NULL, 433, NULL, 'PIRSR607724-1', 277659),
(458566, 'PIRSR037736-1', NULL, NULL, 146, NULL, 'PIRSR037736-1', 277660),
(458567, 'PIRSR633197-1', NULL, NULL, 285, NULL, 'PIRSR633197-1', 277661),
(458568, 'PIRSR037470-50', NULL, NULL, 346, NULL, 'PIRSR037470-50', 277662),
(458569, 'PIRSR001338-1', NULL, NULL, 151, NULL, 'PIRSR001338-1', 277663),
(458570, 'PIRSR037911-2', NULL, NULL, 660, NULL, 'PIRSR037911-2', 277664),
(458571, 'PIRSR000007-50', NULL, NULL, 276, NULL, 'PIRSR000007-50', 277665),
(458572, 'PIRSR037938-1', NULL, NULL, 252, NULL, 'PIRSR037938-1', 277666),
(458573, 'PIRSR000108-4', NULL, NULL, 358, NULL, 'PIRSR000108-4', 277667),
(458574, 'PIRSR004776-1', NULL, NULL, 411, NULL, 'PIRSR004776-1', 277668),
(458575, 'PIRSR000112-2', NULL, NULL, 367, NULL, 'PIRSR000112-2', 277669),
(458576, 'PIRSR000632-1', NULL, NULL, 831, NULL, 'PIRSR000632-1', 277670),
(458577, 'PIRSR000927-2', NULL, NULL, 927, NULL, 'PIRSR000927-2', 277671),
(458578, 'PIRSR640198-3', NULL, NULL, 477, NULL, 'PIRSR640198-3', 277672),
(458579, 'PIRSR000915-2', NULL, NULL, 269, NULL, 'PIRSR000915-2', 277673),
(458580, 'PIRSR001369-1', NULL, NULL, 361, NULL, 'PIRSR001369-1', 277674),
(458581, 'PIRSR001024-3', NULL, NULL, 477, NULL, 'PIRSR001024-3', 277675),
(458582, 'PIRSR009285-1', NULL, NULL, 234, NULL, 'PIRSR009285-1', 277676),
(458583, 'PIRSR000097-2', NULL, NULL, 236, NULL, 'PIRSR000097-2', 277677),
(458584, 'PIRSR601559-51', NULL, NULL, 305, NULL, 'PIRSR601559-51', 277678),
(458585, 'PIRSR038120-1', NULL, NULL, 177, NULL, 'PIRSR038120-1', 277679),
(458586, 'PIRSR002530-1', NULL, NULL, 435, NULL, 'PIRSR002530-1', 277680),
(458587, 'PIRSR038023-2', NULL, NULL, 411, NULL, 'PIRSR038023-2', 277681),
(458588, 'PIRSR000216-1', NULL, NULL, 155, NULL, 'PIRSR000216-1', 277682),
(458589, 'PIRSR000477-2', NULL, NULL, 282, NULL, 'PIRSR000477-2', 277683),
(458590, 'PIRSR600888-2', NULL, NULL, 164, NULL, 'PIRSR600888-2', 277684),
(458591, 'PIRSR037038-2', NULL, NULL, 93, NULL, 'PIRSR037038-2', 277685),
(458592, 'PIRSR001400-2', NULL, NULL, 315, NULL, 'PIRSR001400-2', 277686),
(458593, 'PIRSR037014-2', NULL, NULL, 921, NULL, 'PIRSR037014-2', 277687),
(458594, 'PIRSR617736-2', NULL, NULL, 452, NULL, 'PIRSR617736-2', 277688);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(458595, 'PIRSR601233-3', NULL, NULL, 495, NULL, 'PIRSR601233-3', 277689),
(458596, 'PIRSR001141-1', NULL, NULL, 327, NULL, 'PIRSR001141-1', 277690),
(458597, 'PIRSR017107-4', NULL, NULL, 415, NULL, 'PIRSR017107-4', 277691),
(458598, 'PIRSR003817-2', NULL, NULL, 668, NULL, 'PIRSR003817-2', 277692),
(458599, 'PIRSR000699-1', NULL, NULL, 103, NULL, 'PIRSR000699-1', 277693),
(458600, 'PIRSR000846-1', NULL, NULL, 298, NULL, 'PIRSR000846-1', 277694),
(458601, 'PIRSR629609-4', NULL, NULL, 719, NULL, 'PIRSR629609-4', 277695),
(458602, 'PIRSR009343-1', NULL, NULL, 258, NULL, 'PIRSR009343-1', 277696),
(458603, 'PIRSR000127-1', NULL, NULL, 1342, NULL, 'PIRSR000127-1', 277697),
(458604, 'PIRSR039004-1', NULL, NULL, 372, NULL, 'PIRSR039004-1', 277698),
(458605, 'PIRSR037907-1', NULL, NULL, 660, NULL, 'PIRSR037907-1', 277699),
(458606, 'PIRSR629580-1', NULL, NULL, 600, NULL, 'PIRSR629580-1', 277700),
(458607, 'PIRSR036561-1', NULL, NULL, 224, NULL, 'PIRSR036561-1', 277701),
(458608, 'PIRSR001859-50', NULL, NULL, 92, NULL, 'PIRSR001859-50', 277702),
(458609, 'PIRSR039133-2', NULL, NULL, 649, NULL, 'PIRSR039133-2', 277703),
(458610, 'PIRSR629576-6', NULL, NULL, 604, NULL, 'PIRSR629576-6', 277704),
(458611, 'PIRSR003182-50', NULL, NULL, 781, NULL, 'PIRSR003182-50', 277705),
(458612, 'PIRSR000454-1', NULL, NULL, 1844, NULL, 'PIRSR000454-1', 277706),
(458613, 'PIRSR000094-3', NULL, NULL, 260, NULL, 'PIRSR000094-3', 277707),
(458614, 'PIRSR006816-1', NULL, NULL, 207, NULL, 'PIRSR006816-1', 277708),
(458615, 'PIRSR627620-1', NULL, NULL, 1242, NULL, 'PIRSR627620-1', 277709),
(458616, 'PIRSR037219-1', NULL, NULL, 369, NULL, 'PIRSR037219-1', 277710),
(458617, 'PIRSR627185-54', NULL, NULL, 785, NULL, 'PIRSR627185-54', 277711),
(458618, 'PIRSR002421-2', NULL, NULL, 372, NULL, 'PIRSR002421-2', 277712),
(458619, 'PIRSR004911-1', NULL, NULL, 289, NULL, 'PIRSR004911-1', 277713),
(458620, 'PIRSR017818-2', NULL, NULL, 223, NULL, 'PIRSR017818-2', 277714),
(458621, 'PIRSR625650-4', NULL, NULL, 644, NULL, 'PIRSR625650-4', 277715),
(458622, 'PIRSR000624-2', NULL, NULL, 942, NULL, 'PIRSR000624-2', 277716),
(458623, 'PIRSR605212-50', NULL, NULL, 465, NULL, 'PIRSR605212-50', 277717),
(458624, 'PIRSR617763-1', NULL, NULL, 146, NULL, 'PIRSR617763-1', 277718),
(458625, 'PIRSR006118-2', NULL, NULL, 176, NULL, 'PIRSR006118-2', 277719),
(458626, 'PIRSR000014-1', NULL, NULL, 390, NULL, 'PIRSR000014-1', 277720),
(458627, 'PIRSR001191-1', NULL, NULL, 464, NULL, 'PIRSR001191-1', 277721),
(458628, 'PIRSR620023-1', NULL, NULL, 276, NULL, 'PIRSR620023-1', 277722),
(458629, 'PIRSR000853-1', NULL, NULL, 833, NULL, 'PIRSR000853-1', 277723),
(458630, 'PIRSR037393-3', NULL, NULL, 548, NULL, 'PIRSR037393-3', 277724),
(458631, 'PIRSR500134-3', NULL, NULL, 434, NULL, 'PIRSR500134-3', 277725),
(458632, 'PIRSR630220-2', NULL, NULL, 1040, NULL, 'PIRSR630220-2', 277726),
(458633, 'PIRSR036289-50', NULL, NULL, 785, NULL, 'PIRSR036289-50', 277727),
(458634, 'PIRSR009393-1', NULL, NULL, 623, NULL, 'PIRSR009393-1', 277728),
(458635, 'PIRSR016055-50', NULL, NULL, 406, NULL, 'PIRSR016055-50', 277729),
(458636, 'PIRSR001145-2', NULL, NULL, 563, NULL, 'PIRSR001145-2', 277730),
(458637, 'PIRSR629727-4', NULL, NULL, 750, NULL, 'PIRSR629727-4', 277731),
(458638, 'PIRSR002498-1', NULL, NULL, 293, NULL, 'PIRSR002498-1', 277732),
(458639, 'PIRSR600514-1', NULL, NULL, 518, NULL, 'PIRSR600514-1', 277733),
(458640, 'PIRSR600542-2', NULL, NULL, 630, NULL, 'PIRSR600542-2', 277734),
(458641, 'PIRSR038147-3', NULL, NULL, 556, NULL, 'PIRSR038147-3', 277735),
(458642, 'PIRSR001238-3', NULL, NULL, 390, NULL, 'PIRSR001238-3', 277736),
(458643, 'PIRSR000233-1', NULL, NULL, 903, NULL, 'PIRSR000233-1', 277737),
(458644, 'PIRSR621573-7', NULL, NULL, 2292, NULL, 'PIRSR621573-7', 277738),
(458645, 'PIRSR000817-1', NULL, NULL, 508, NULL, 'PIRSR000817-1', 277739),
(458646, 'PIRSR002572-2', NULL, NULL, 146, NULL, 'PIRSR002572-2', 277740),
(458647, 'PIRSR026534-1', NULL, NULL, 324, NULL, 'PIRSR026534-1', 277741),
(458648, 'PIRSR038896-50', NULL, NULL, 381, NULL, 'PIRSR038896-50', 277742);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(458649, 'PIRSR604241-50', NULL, NULL, 117, NULL, 'PIRSR604241-50', 277743),
(458650, 'PIRSR038928-1', NULL, NULL, 489, NULL, 'PIRSR038928-1', 277744),
(458651, 'PIRSR000554-2', NULL, NULL, 589, NULL, 'PIRSR000554-2', 277745),
(458652, 'PIRSR001149-3', NULL, NULL, 619, NULL, 'PIRSR001149-3', 277746),
(458653, 'PIRSR000105-2', NULL, NULL, 286, NULL, 'PIRSR000105-2', 277747),
(458654, 'PIRSR000260-3', NULL, NULL, 96, NULL, 'PIRSR000260-3', 277748),
(458655, 'PIRSR017388-1', NULL, NULL, 245, NULL, 'PIRSR017388-1', 277749),
(458656, 'PIRSR022950-1', NULL, NULL, 371, NULL, 'PIRSR022950-1', 277750),
(458657, 'PIRSR628131-1', NULL, NULL, 360, NULL, 'PIRSR628131-1', 277751),
(458658, 'PIRSR000620-1', NULL, NULL, 306, NULL, 'PIRSR000620-1', 277752),
(458659, 'PIRSR009407-2', NULL, NULL, 742, NULL, 'PIRSR009407-2', 277753),
(458660, 'PIRSR016408-1', NULL, NULL, 479, NULL, 'PIRSR016408-1', 277754),
(458661, 'PIRSR037375-1', NULL, NULL, 497, NULL, 'PIRSR037375-1', 277755),
(458662, 'PIRSR000194-1', NULL, NULL, 164, NULL, 'PIRSR000194-1', 277756),
(458663, 'PIRSR000346-1', NULL, NULL, 389, NULL, 'PIRSR000346-1', 277757),
(458664, 'PIRSR038455-3', NULL, NULL, 228, NULL, 'PIRSR038455-3', 277758),
(458665, 'PIRSR000977-2', NULL, NULL, 480, NULL, 'PIRSR000977-2', 277759),
(458666, 'PIRSR006439-50', NULL, NULL, 618, NULL, 'PIRSR006439-50', 277760),
(458667, 'PIRSR500947-52', NULL, NULL, 987, NULL, 'PIRSR500947-52', 277761),
(458668, 'PIRSR001939-1', NULL, NULL, 166, NULL, 'PIRSR001939-1', 277762),
(458669, 'PIRSR037993-1', NULL, NULL, 318, NULL, 'PIRSR037993-1', 277763),
(458670, 'PIRSR038927-2', NULL, NULL, 631, NULL, 'PIRSR038927-2', 277764),
(458671, 'PIRSR000138-2', NULL, NULL, 369, NULL, 'PIRSR000138-2', 277765),
(458672, 'PIRSR036960-1', NULL, NULL, 930, NULL, 'PIRSR036960-1', 277766),
(458673, 'PIRSR002417-50', NULL, NULL, 476, NULL, 'PIRSR002417-50', 277767),
(458674, 'PIRSR016487-1', NULL, NULL, 157, NULL, 'PIRSR016487-1', 277768),
(458675, 'PIRSR011396-1', NULL, NULL, 308, NULL, 'PIRSR011396-1', 277769),
(458676, 'PIRSR029900-1', NULL, NULL, 690, NULL, 'PIRSR029900-1', 277770),
(458677, 'PIRSR629576-3', NULL, NULL, 604, NULL, 'PIRSR629576-3', 277771),
(458678, 'PIRSR036917-1', NULL, NULL, 684, NULL, 'PIRSR036917-1', 277772),
(458679, 'PIRSR629539-1', NULL, NULL, 700, NULL, 'PIRSR629539-1', 277773),
(458680, 'PIRSR006113-2', NULL, NULL, 130, NULL, 'PIRSR006113-2', 277774),
(458681, 'PIRSR000235-1', NULL, NULL, 348, NULL, 'PIRSR000235-1', 277775),
(458682, 'PIRSR000865-1', NULL, NULL, 384, NULL, 'PIRSR000865-1', 277776),
(458683, 'PIRSR000952-1', NULL, NULL, 1281, NULL, 'PIRSR000952-1', 277777),
(458684, 'PIRSR034515-3', NULL, NULL, 1021, NULL, 'PIRSR034515-3', 277778),
(458685, 'PIRSR037250-52', NULL, NULL, 663, NULL, 'PIRSR037250-52', 277779),
(458686, 'PIRSR627057-1', NULL, NULL, 439, NULL, 'PIRSR627057-1', 277780),
(458687, 'PIRSR037432-50', NULL, NULL, 344, NULL, 'PIRSR037432-50', 277781),
(458688, 'PIRSR000199-50', NULL, NULL, 78, NULL, 'PIRSR000199-50', 277782),
(458689, 'PIRSR001657-50', NULL, NULL, 158, NULL, 'PIRSR001657-50', 277783),
(458690, 'PIRSR500950-51', NULL, NULL, 1088, NULL, 'PIRSR500950-51', 277784),
(458691, 'PIRSR634015-3', NULL, NULL, 617, NULL, 'PIRSR634015-3', 277785),
(458692, 'PIRSR634183-3', NULL, NULL, 424, NULL, 'PIRSR634183-3', 277786),
(458693, 'PIRSR001084-3', NULL, NULL, 673, NULL, 'PIRSR001084-3', 277787),
(458694, 'PIRSR038994-2', NULL, NULL, 286, NULL, 'PIRSR038994-2', 277788),
(458695, 'PIRSR500948-1', NULL, NULL, 1098, NULL, 'PIRSR500948-1', 277789),
(458696, 'PIRSR000447-1', NULL, NULL, 427, NULL, 'PIRSR000447-1', 277790),
(458697, 'PIRSR001143-1', NULL, NULL, 291, NULL, 'PIRSR001143-1', 277791),
(458698, 'PIRSR016429-50', NULL, NULL, 357, NULL, 'PIRSR016429-50', 277792),
(458699, 'PIRSR629890-1', NULL, NULL, 908, NULL, 'PIRSR629890-1', 277793),
(458700, 'PIRSR634180-1', NULL, NULL, 421, NULL, 'PIRSR634180-1', 277794),
(458701, 'PIRSR000559-2', NULL, NULL, 597, NULL, 'PIRSR000559-2', 277795),
(458702, 'PIRSR006246-1', NULL, NULL, 126, NULL, 'PIRSR006246-1', 277796);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(458703, 'PIRSR007531-2', NULL, NULL, 214, NULL, 'PIRSR007531-2', 277797),
(458704, 'PIRSR017107-1', NULL, NULL, 415, NULL, 'PIRSR017107-1', 277798),
(458705, 'PIRSR629601-2', NULL, NULL, 1866, NULL, 'PIRSR629601-2', 277799),
(458706, 'PIRSR004692-1', NULL, NULL, 314, NULL, 'PIRSR004692-1', 277800),
(458707, 'PIRSR029775-1', NULL, NULL, 91, NULL, 'PIRSR029775-1', 277801),
(458708, 'PIRSR009374-1', NULL, NULL, 148, NULL, 'PIRSR009374-1', 277802),
(458709, 'PIRSR605428-53', NULL, NULL, 509, NULL, 'PIRSR605428-53', 277803),
(458710, 'PIRSR004930-1', NULL, NULL, 342, NULL, 'PIRSR004930-1', 277804),
(458711, 'PIRSR002486-1', NULL, NULL, 239, NULL, 'PIRSR002486-1', 277805),
(458712, 'PIRSR637571-53', NULL, NULL, 686, NULL, 'PIRSR637571-53', 277806),
(458713, 'PIRSR002703-1', NULL, NULL, 253, NULL, 'PIRSR002703-1', 277807),
(458714, 'PIRSR002356-2', NULL, NULL, 410, NULL, 'PIRSR002356-2', 277808),
(458715, 'PIRSR000101-1', NULL, NULL, 567, NULL, 'PIRSR000101-1', 277809),
(458716, 'PIRSR006809-1', NULL, NULL, 341, NULL, 'PIRSR006809-1', 277810),
(458717, 'PIRSR603912-52', NULL, NULL, 419, NULL, 'PIRSR603912-52', 277811),
(458718, 'PIRSR001359-2', NULL, NULL, 260, NULL, 'PIRSR001359-2', 277812),
(458719, 'PIRSR037430-2', NULL, NULL, 177, NULL, 'PIRSR037430-2', 277813),
(458720, 'PIRSR036421-2', NULL, NULL, 1083, NULL, 'PIRSR036421-2', 277814),
(458721, 'PIRSR000310-1', NULL, NULL, 299, NULL, 'PIRSR000310-1', 277815),
(458722, 'PIRSR004846-1', NULL, NULL, 209, NULL, 'PIRSR004846-1', 277816),
(458723, 'PIRSR622230-2', NULL, NULL, 3175, NULL, 'PIRSR622230-2', 277817),
(458724, 'PIRSR627185-51', NULL, NULL, 785, NULL, 'PIRSR627185-51', 277818),
(458725, 'PIRSR038189-1', NULL, NULL, 332, NULL, 'PIRSR038189-1', 277819),
(458726, 'PIRSR008129-2', NULL, NULL, 226, NULL, 'PIRSR008129-2', 277820),
(458727, 'PIRSR004848-1', NULL, NULL, 192, NULL, 'PIRSR004848-1', 277821),
(458728, 'PIRSR036958-1', NULL, NULL, 602, NULL, 'PIRSR036958-1', 277822),
(458729, 'PIRSR002756-1', NULL, NULL, 348, NULL, 'PIRSR002756-1', 277823),
(458730, 'PIRSR002431-1', NULL, NULL, 524, NULL, 'PIRSR002431-1', 277824),
(458731, 'PIRSR038073-2', NULL, NULL, 297, NULL, 'PIRSR038073-2', 277825),
(458732, 'PIRSR607702-2', NULL, NULL, 140, NULL, 'PIRSR607702-2', 277826),
(458733, 'PIRSR000168-1', NULL, NULL, 573, NULL, 'PIRSR000168-1', 277827),
(458734, 'PIRSR001492-1', NULL, NULL, 514, NULL, 'PIRSR001492-1', 277828),
(458735, 'PIRSR627179-50', NULL, NULL, 75, NULL, 'PIRSR627179-50', 277829),
(458736, 'PIRSR630564-2', NULL, NULL, 519, NULL, 'PIRSR630564-2', 277830),
(458737, 'PIRSR019543-1', NULL, NULL, 164, NULL, 'PIRSR019543-1', 277831),
(458738, 'PIRSR000524-50', NULL, NULL, 390, NULL, 'PIRSR000524-50', 277832),
(458739, 'PIRSR000605-50', NULL, NULL, 517, NULL, 'PIRSR000605-50', 277833),
(458740, 'PIRSR000009-1', NULL, NULL, 213, NULL, 'PIRSR000009-1', 277834),
(458741, 'PIRSR005713-1', NULL, NULL, 390, NULL, 'PIRSR005713-1', 277835),
(458742, 'PIRSR014972-1', NULL, NULL, 134, NULL, 'PIRSR014972-1', 277836),
(458743, 'PIRSR001594-2', NULL, NULL, 1106, NULL, 'PIRSR001594-2', 277837),
(458744, 'PIRSR002551-2', NULL, NULL, 458, NULL, 'PIRSR002551-2', 277838),
(458745, 'PIRSR036894-2', NULL, NULL, 315, NULL, 'PIRSR036894-2', 277839),
(458746, 'PIRSR000242-2', NULL, NULL, 566, NULL, 'PIRSR000242-2', 277840),
(458747, 'PIRSR000294-2', NULL, NULL, 340, NULL, 'PIRSR000294-2', 277841),
(458748, 'PIRSR001558-2', NULL, NULL, 320, NULL, 'PIRSR001558-2', 277842),
(458749, 'PIRSR037210-1', NULL, NULL, 417, NULL, 'PIRSR037210-1', 277843),
(458750, 'PIRSR005557-1', NULL, NULL, 369, NULL, 'PIRSR005557-1', 277844),
(458751, 'PIRSR629727-1', NULL, NULL, 750, NULL, 'PIRSR629727-1', 277845),
(458752, 'PIRSR635711-51', NULL, NULL, 1653, NULL, 'PIRSR635711-51', 277846),
(458753, 'PIRSR036636-51', NULL, NULL, 255, NULL, 'PIRSR036636-51', 277847),
(458754, 'PIRSR630056-2', NULL, NULL, 147, NULL, 'PIRSR630056-2', 277848),
(458755, 'PIRSR016567-52', NULL, NULL, 562, NULL, 'PIRSR016567-52', 277849),
(458756, 'PIRSR617774-2', NULL, NULL, 397, NULL, 'PIRSR617774-2', 277850);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(458757, 'PIRSR002811-1', NULL, NULL, 592, NULL, 'PIRSR002811-1', 277851),
(458758, 'PIRSR001174-1', NULL, NULL, 760, NULL, 'PIRSR001174-1', 277852),
(458759, 'PIRSR000331-2', NULL, NULL, 468, NULL, 'PIRSR000331-2', 277853),
(458760, 'PIRSR006019-2', NULL, NULL, 159, NULL, 'PIRSR006019-2', 277854),
(458761, 'PIRSR035805-1', NULL, NULL, 207, NULL, 'PIRSR035805-1', 277855),
(458762, 'PIRSR001238-50', NULL, NULL, 388, NULL, 'PIRSR001238-50', 277856),
(458763, 'PIRSR037575-1', NULL, NULL, 89, NULL, 'PIRSR037575-1', 277857),
(458764, 'PIRSR500951-3', NULL, NULL, 874, NULL, 'PIRSR500951-3', 277858),
(458765, 'PIRSR000130-4', NULL, NULL, 473, NULL, 'PIRSR000130-4', 277859),
(458766, 'PIRSR001589-3', NULL, NULL, 535, NULL, 'PIRSR001589-3', 277860),
(458767, 'PIRSR015693-50', NULL, NULL, 470, NULL, 'PIRSR015693-50', 277861),
(458768, 'PIRSR622314-2', NULL, NULL, 522, NULL, 'PIRSR622314-2', 277862),
(458769, 'PIRSR633478-1', NULL, NULL, 790, NULL, 'PIRSR633478-1', 277863),
(458770, 'PIRSR000398-1', NULL, NULL, 197, NULL, 'PIRSR000398-1', 277864),
(458771, 'PIRSR627086-1', NULL, NULL, 723, NULL, 'PIRSR627086-1', 277865),
(458772, 'PIRSR600239-50', NULL, NULL, 597, NULL, 'PIRSR600239-50', 277866),
(458773, 'PIRSR000929-2', NULL, NULL, 540, NULL, 'PIRSR000929-2', 277867),
(458774, 'PIRSR001355-1', NULL, NULL, 358, NULL, 'PIRSR001355-1', 277868),
(458775, 'PIRSR001220-2', NULL, NULL, 255, NULL, 'PIRSR001220-2', 277869),
(458776, 'PIRSR026389-4', NULL, NULL, 740, NULL, 'PIRSR026389-4', 277870),
(458777, 'PIRSR633144-2', NULL, NULL, 410, NULL, 'PIRSR633144-2', 277871),
(458778, 'PIRSR001123-2', NULL, NULL, 341, NULL, 'PIRSR001123-2', 277872),
(458779, 'PIRSR006470-1', NULL, NULL, 331, NULL, 'PIRSR006470-1', 277873),
(458780, 'PIRSR000114-3', NULL, NULL, 344, NULL, 'PIRSR000114-3', 277874),
(458781, 'PIRSR001220-1', NULL, NULL, 255, NULL, 'PIRSR001220-1', 277875),
(458782, 'PIRSR037875-50', NULL, NULL, 471, NULL, 'PIRSR037875-50', 277876),
(458783, 'PIRSR000303-1', NULL, NULL, 179, NULL, 'PIRSR000303-1', 277877),
(458784, 'PIRSR005461-1', NULL, NULL, 207, NULL, 'PIRSR005461-1', 277878),
(458785, 'PIRSR000114-2', NULL, NULL, 344, NULL, 'PIRSR000114-2', 277879),
(458786, 'PIRSR617512-3', NULL, NULL, 726, NULL, 'PIRSR617512-3', 277880),
(458787, 'PIRSR000109-3', NULL, NULL, 469, NULL, 'PIRSR000109-3', 277881),
(458788, 'PIRSR000472-52', NULL, NULL, 570, NULL, 'PIRSR000472-52', 277882),
(458789, 'PIRSR037031-50', NULL, NULL, 78, NULL, 'PIRSR037031-50', 277883),
(458790, 'PIRSR600990-51', NULL, NULL, 425, NULL, 'PIRSR600990-51', 277884),
(458791, 'PIRSR019574-1', NULL, NULL, 353, NULL, 'PIRSR019574-1', 277885),
(458792, 'PIRSR001103-1', NULL, NULL, 321, NULL, 'PIRSR001103-1', 277886),
(458793, 'PIRSR001415-4', NULL, NULL, 327, NULL, 'PIRSR001415-4', 277887),
(458794, 'PIRSR001600-50', NULL, NULL, 339, NULL, 'PIRSR001600-50', 277888),
(458795, 'PIRSR037880-1', NULL, NULL, 357, NULL, 'PIRSR037880-1', 277889),
(458796, 'PIRSR001100-1', NULL, NULL, 290, NULL, 'PIRSR001100-1', 277890),
(458797, 'PIRSR003726-1', NULL, NULL, 295, NULL, 'PIRSR003726-1', 277891),
(458798, 'PIRSR000106-3', NULL, NULL, 515, NULL, 'PIRSR000106-3', 277892),
(458799, 'PIRSR600877-51', NULL, NULL, 226, NULL, 'PIRSR600877-51', 277893),
(458800, 'PIRSR631098-50', NULL, NULL, 126, NULL, 'PIRSR631098-50', 277894),
(458801, 'PIRSR011502-2', NULL, NULL, 602, NULL, 'PIRSR011502-2', 277895),
(458802, 'PIRSR005023-1', NULL, NULL, 625, NULL, 'PIRSR005023-1', 277896),
(458803, 'PIRSR003726-2', NULL, NULL, 295, NULL, 'PIRSR003726-2', 277897),
(458804, 'PIRSR006769-2', NULL, NULL, 324, NULL, 'PIRSR006769-2', 277898),
(458805, 'PIRSR617653-3', NULL, NULL, 446, NULL, 'PIRSR617653-3', 277899),
(458806, 'PIRSR002551-1', NULL, NULL, 458, NULL, 'PIRSR002551-1', 277900),
(458807, 'PIRSR000278-1', NULL, NULL, 83, NULL, 'PIRSR000278-1', 277901),
(458808, 'PIRSR001399-2', NULL, NULL, 149, NULL, 'PIRSR001399-2', 277902),
(458809, 'PIRSR004682-1', NULL, NULL, 186, NULL, 'PIRSR004682-1', 277903),
(458810, 'PIRSR037933-1', NULL, NULL, 856, NULL, 'PIRSR037933-1', 277904);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(458811, 'PIRSR000858-1', NULL, NULL, 429, NULL, 'PIRSR000858-1', 277905),
(458812, 'PIRSR037177-2', NULL, NULL, 271, NULL, 'PIRSR037177-2', 277906),
(458813, 'PIRSR017205-2', NULL, NULL, 404, NULL, 'PIRSR017205-2', 277907),
(458814, 'PIRSR036441-51', NULL, NULL, 443, NULL, 'PIRSR036441-51', 277908),
(458815, 'PIRSR001028-1', NULL, NULL, 427, NULL, 'PIRSR001028-1', 277909),
(458816, 'PIRSR033579-2', NULL, NULL, 271, NULL, 'PIRSR033579-2', 277910),
(458817, 'PIRSR005465-1', NULL, NULL, 409, NULL, 'PIRSR005465-1', 277911),
(458818, 'PIRSR038186-2', NULL, NULL, 236, NULL, 'PIRSR038186-2', 277912),
(458819, 'PIRSR017340-1', NULL, NULL, 176, NULL, 'PIRSR017340-1', 277913),
(458820, 'PIRSR000019-1', NULL, NULL, 69, NULL, 'PIRSR000019-1', 277914),
(458821, 'PIRSR005992-1', NULL, NULL, 430, NULL, 'PIRSR005992-1', 277915),
(458822, 'PIRSR637571-50', NULL, NULL, 686, NULL, 'PIRSR637571-50', 277916),
(458823, 'PIRSR002395-1', NULL, NULL, 1694, NULL, 'PIRSR002395-1', 277917),
(458824, 'PIRSR036874-50', NULL, NULL, 681, NULL, 'PIRSR036874-50', 277918),
(458825, 'PIRSR610300-51', NULL, NULL, 204, NULL, 'PIRSR610300-51', 277919),
(458826, 'PIRSR000130-1', NULL, NULL, 473, NULL, 'PIRSR000130-1', 277920),
(458827, 'PIRSR000631-3', NULL, NULL, 1114, NULL, 'PIRSR000631-3', 277921),
(458828, 'PIRSR036685-2', NULL, NULL, 392, NULL, 'PIRSR036685-2', 277922),
(458829, 'PIRSR630564-1', NULL, NULL, 519, NULL, 'PIRSR630564-1', 277923),
(458830, 'PIRSR628707-2', NULL, NULL, 263, NULL, 'PIRSR628707-2', 277924),
(458831, 'PIRSR016262-3', NULL, NULL, 216, NULL, 'PIRSR016262-3', 277925),
(458832, 'PIRSR038189-2', NULL, NULL, 332, NULL, 'PIRSR038189-2', 277926),
(458833, 'PIRSR001227-1', NULL, NULL, 808, NULL, 'PIRSR001227-1', 277927),
(458834, 'PIRSR000617-2', NULL, NULL, 1428, NULL, 'PIRSR000617-2', 277928),
(458835, 'PIRSR000047-2', NULL, NULL, 501, NULL, 'PIRSR000047-2', 277929),
(458836, 'PIRSR006223-50', NULL, NULL, 109, NULL, 'PIRSR006223-50', 277930),
(458837, 'PIRSR038193-2', NULL, NULL, 455, NULL, 'PIRSR038193-2', 277931),
(458838, 'PIRSR630297-2', NULL, NULL, 223, NULL, 'PIRSR630297-2', 277932),
(458839, 'PIRSR000661-50', NULL, NULL, 805, NULL, 'PIRSR000661-50', 277933),
(458840, 'PIRSR000188-2', NULL, NULL, 326, NULL, 'PIRSR000188-2', 277934),
(458841, 'PIRSR029792-1', NULL, NULL, 335, NULL, 'PIRSR029792-1', 277935),
(458842, 'PIRSR000705-3', NULL, NULL, 198, NULL, 'PIRSR000705-3', 277936),
(458843, 'PIRSR627173-50', NULL, NULL, 905, NULL, 'PIRSR627173-50', 277937),
(458844, 'PIRSR036917-4', NULL, NULL, 684, NULL, 'PIRSR036917-4', 277938),
(458845, 'PIRSR037281-1', NULL, NULL, 480, NULL, 'PIRSR037281-1', 277939),
(458846, 'PIRSR000362-2', NULL, NULL, 352, NULL, 'PIRSR000362-2', 277940),
(458847, 'PIRSR606710-2', NULL, NULL, 322, NULL, 'PIRSR606710-2', 277941),
(458848, 'PIRSR000108-1', NULL, NULL, 358, NULL, 'PIRSR000108-1', 277942),
(458849, 'PIRSR608127-53', NULL, NULL, 455, NULL, 'PIRSR608127-53', 277943),
(458850, 'PIRSR630056-3', NULL, NULL, 147, NULL, 'PIRSR630056-3', 277944),
(458851, 'PIRSR602506-51', NULL, NULL, 213, NULL, 'PIRSR602506-51', 277945),
(458852, 'PIRSR036684-3', NULL, NULL, 760, NULL, 'PIRSR036684-3', 277946),
(458853, 'PIRSR016323-2', NULL, NULL, 285, NULL, 'PIRSR016323-2', 277947),
(458854, 'PIRSR605428-52', NULL, NULL, 472, NULL, 'PIRSR605428-52', 277948),
(458855, 'PIRSR037921-2', NULL, NULL, 405, NULL, 'PIRSR037921-2', 277949),
(458856, 'PIRSR016496-2', NULL, NULL, 260, NULL, 'PIRSR016496-2', 277950),
(458857, 'PIRSR001355-4', NULL, NULL, 358, NULL, 'PIRSR001355-4', 277951),
(458858, 'PIRSR000099-2', NULL, NULL, 362, NULL, 'PIRSR000099-2', 277952),
(458859, 'PIRSR626945-1', NULL, NULL, 379, NULL, 'PIRSR626945-1', 277953),
(458860, 'PIRSR001341-4', NULL, NULL, 316, NULL, 'PIRSR001341-4', 277954),
(458861, 'PIRSR000196-1', NULL, NULL, 307, NULL, 'PIRSR000196-1', 277955),
(458862, 'PIRSR633508-3', NULL, NULL, 950, NULL, 'PIRSR633508-3', 277956),
(458863, 'PIRSR000189-1', NULL, NULL, 348, NULL, 'PIRSR000189-1', 277957),
(458864, 'PIRSR000706-2', NULL, NULL, 264, NULL, 'PIRSR000706-2', 277958);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(458865, 'PIRSR006268-1', NULL, NULL, 341, NULL, 'PIRSR006268-1', 277959),
(458866, 'PIRSR036767-51', NULL, NULL, 445, NULL, 'PIRSR036767-51', 277960),
(458867, 'PIRSR001992-1', NULL, NULL, 272, NULL, 'PIRSR001992-1', 277961),
(458868, 'PIRSR629881-4', NULL, NULL, 875, NULL, 'PIRSR629881-4', 277962),
(458869, 'PIRSR038945-1', NULL, NULL, 300, NULL, 'PIRSR038945-1', 277963),
(458870, 'PIRSR623237-2', NULL, NULL, 352, NULL, 'PIRSR623237-2', 277964),
(458871, 'PIRSR037479-4', NULL, NULL, 472, NULL, 'PIRSR037479-4', 277965),
(458872, 'PIRSR037913-3', NULL, NULL, 365, NULL, 'PIRSR037913-3', 277966),
(458873, 'PIRSR630294-2', NULL, NULL, 306, NULL, 'PIRSR630294-2', 277967),
(458874, 'PIRSR005091-3', NULL, NULL, 553, NULL, 'PIRSR005091-3', 277968),
(458875, 'PIRSR037125-1', NULL, NULL, 146, NULL, 'PIRSR037125-1', 277969),
(458876, 'PIRSR038172-2', NULL, NULL, 788, NULL, 'PIRSR038172-2', 277970),
(458877, 'PIRSR030150-2', NULL, NULL, 246, NULL, 'PIRSR030150-2', 277971),
(458878, 'PIRSR621116-50', NULL, NULL, 139, NULL, 'PIRSR621116-50', 277972),
(458879, 'PIRSR625650-1', NULL, NULL, 644, NULL, 'PIRSR625650-1', 277973),
(458880, 'PIRSR000384-1', NULL, NULL, 232, NULL, 'PIRSR000384-1', 277974),
(458881, 'PIRSR605977-50', NULL, NULL, 278, NULL, 'PIRSR605977-50', 277975),
(458882, 'PIRSR003059-2', NULL, NULL, 490, NULL, 'PIRSR003059-2', 277976),
(458883, 'PIRSR001415-1', NULL, NULL, 314, NULL, 'PIRSR001415-1', 277977),
(458884, 'PIRSR639901-1', NULL, NULL, 430, NULL, 'PIRSR639901-1', 277978),
(458885, 'PIRSR000018-50', NULL, NULL, 448, NULL, 'PIRSR000018-50', 277979),
(458886, 'PIRSR000452-1', NULL, NULL, 151, NULL, 'PIRSR000452-1', 277980),
(458887, 'PIRSR628391-3', NULL, NULL, 778, NULL, 'PIRSR628391-3', 277981),
(458888, 'PIRSR000429-2', NULL, NULL, 330, NULL, 'PIRSR000429-2', 277982),
(458889, 'PIRSR015853-1', NULL, NULL, 187, NULL, 'PIRSR015853-1', 277983),
(458890, 'PIRSR627053-3', NULL, NULL, 749, NULL, 'PIRSR627053-3', 277984),
(458891, 'PIRSR633697-1', NULL, NULL, 232, NULL, 'PIRSR633697-1', 277985),
(458892, 'PIRSR029163-50', NULL, NULL, 95, NULL, 'PIRSR029163-50', 277986),
(458893, 'PIRSR006325-1', NULL, NULL, 235, NULL, 'PIRSR006325-1', 277987),
(458894, 'PIRSR619502-2', NULL, NULL, 913, NULL, 'PIRSR619502-2', 277988),
(458895, 'PIRSR003170-2', NULL, NULL, 223, NULL, 'PIRSR003170-2', 277989),
(458896, 'PIRSR038084-1', NULL, NULL, 419, NULL, 'PIRSR038084-1', 277990),
(458897, 'PIRSR038134-1', NULL, NULL, 285, NULL, 'PIRSR038134-1', 277991),
(458898, 'PIRSR036417-1', NULL, NULL, 453, NULL, 'PIRSR036417-1', 277992),
(458899, 'PIRSR036503-50', NULL, NULL, 377, NULL, 'PIRSR036503-50', 277993),
(458900, 'PIRSR001138-1', NULL, NULL, 1034, NULL, 'PIRSR001138-1', 277994),
(458901, 'PIRSR005378-2', NULL, NULL, 353, NULL, 'PIRSR005378-2', 277995),
(458902, 'PIRSR002356-1', NULL, NULL, 410, NULL, 'PIRSR002356-1', 277996),
(458903, 'PIRSR618044-1', NULL, NULL, 391, NULL, 'PIRSR618044-1', 277997),
(458904, 'PIRSR001205-2', NULL, NULL, 484, NULL, 'PIRSR001205-2', 277998),
(458905, 'PIRSR629580-4', NULL, NULL, 600, NULL, 'PIRSR629580-4', 277999),
(458906, 'PIRSR037238-1', NULL, NULL, 381, NULL, 'PIRSR037238-1', 278000),
(458907, 'PIRSR037599-4', NULL, NULL, 152, NULL, 'PIRSR037599-4', 278001),
(458908, 'PIRSR000445-4', NULL, NULL, 428, NULL, 'PIRSR000445-4', 278002),
(458909, 'PIRSR000376-2', NULL, NULL, 467, NULL, 'PIRSR000376-2', 278003),
(458910, 'PIRSR000660-2', NULL, NULL, 1658, NULL, 'PIRSR000660-2', 278004),
(458911, 'PIRSR000105-1', NULL, NULL, 286, NULL, 'PIRSR000105-1', 278005),
(458912, 'PIRSR000167-2', NULL, NULL, 293, NULL, 'PIRSR000167-2', 278006),
(458913, 'PIRSR039026-1', NULL, NULL, 246, NULL, 'PIRSR039026-1', 278007),
(458914, 'PIRSR010354-51', NULL, NULL, 3808, NULL, 'PIRSR010354-51', 278008),
(458915, 'PIRSR001461-1', NULL, NULL, 213, NULL, 'PIRSR001461-1', 278009),
(458916, 'PIRSR000008-2', NULL, NULL, 181, NULL, 'PIRSR000008-2', 278010),
(458917, 'PIRSR002006-1', NULL, NULL, 662, NULL, 'PIRSR002006-1', 278011),
(458918, 'PIRSR500135-1', NULL, NULL, 438, NULL, 'PIRSR500135-1', 278012);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(458919, 'PIRSR000355-2', NULL, NULL, 322, NULL, 'PIRSR000355-2', 278013),
(458920, 'PIRSR002520-1', NULL, NULL, 609, NULL, 'PIRSR002520-1', 278014),
(458921, 'PIRSR037847-1', NULL, NULL, 160, NULL, 'PIRSR037847-1', 278015),
(458922, 'PIRSR037217-1', NULL, NULL, 568, NULL, 'PIRSR037217-1', 278016),
(458923, 'PIRSR038165-50', NULL, NULL, 965, NULL, 'PIRSR038165-50', 278017),
(458924, 'PIRSR000409-1', NULL, NULL, 338, NULL, 'PIRSR000409-1', 278018),
(458925, 'PIRSR000894-1', NULL, NULL, 392, NULL, 'PIRSR000894-1', 278019),
(458926, 'PIRSR026389-1', NULL, NULL, 740, NULL, 'PIRSR026389-1', 278020),
(458927, 'PIRSR005054-1', NULL, NULL, 239, NULL, 'PIRSR005054-1', 278021),
(458928, 'PIRSR002004-1', NULL, NULL, 1276, NULL, 'PIRSR002004-1', 278022),
(458929, 'PIRSR000552-1', NULL, NULL, 888, NULL, 'PIRSR000552-1', 278023),
(458930, 'PIRSR600407-2', NULL, NULL, 518, NULL, 'PIRSR600407-2', 278024),
(458931, 'PIRSR001640-50', NULL, NULL, 65, NULL, 'PIRSR001640-50', 278025),
(458932, 'PIRSR006779-1', NULL, NULL, 242, NULL, 'PIRSR006779-1', 278026),
(458933, 'PIRSR000014-2', NULL, NULL, 390, NULL, 'PIRSR000014-2', 278027),
(458934, 'PIRSR015753-1', NULL, NULL, 323, NULL, 'PIRSR015753-1', 278028),
(458935, 'PIRSR017205-1', NULL, NULL, 404, NULL, 'PIRSR017205-1', 278029),
(458936, 'PIRSR637571-51', NULL, NULL, 686, NULL, 'PIRSR637571-51', 278030),
(458937, 'PIRSR603437-50', NULL, NULL, 966, NULL, 'PIRSR603437-50', 278031),
(458938, 'PIRSR000047-1', NULL, NULL, 504, NULL, 'PIRSR000047-1', 278032),
(458939, 'PIRSR002498-2', NULL, NULL, 293, NULL, 'PIRSR002498-2', 278033),
(458940, 'PIRSR001941-1', NULL, NULL, 144, NULL, 'PIRSR001941-1', 278034),
(458941, 'PIRSR009407-3', NULL, NULL, 742, NULL, 'PIRSR009407-3', 278035),
(458942, 'PIRSR011502-1', NULL, NULL, 602, NULL, 'PIRSR011502-1', 278036),
(458943, 'PIRSR000853-2', NULL, NULL, 833, NULL, 'PIRSR000853-2', 278037),
(458944, 'PIRSR500134-2', NULL, NULL, 434, NULL, 'PIRSR500134-2', 278038),
(458945, 'PIRSR007828-1', NULL, NULL, 598, NULL, 'PIRSR007828-1', 278039),
(458946, 'PIRSR001500-1', NULL, NULL, 363, NULL, 'PIRSR001500-1', 278040),
(458947, 'PIRSR608734-50', NULL, NULL, 1207, NULL, 'PIRSR608734-50', 278041),
(458948, 'PIRSR605792-51', NULL, NULL, 516, NULL, 'PIRSR605792-51', 278042),
(458949, 'PIRSR633865-1', NULL, NULL, 268, NULL, 'PIRSR633865-1', 278043),
(458950, 'PIRSR638639-51', NULL, NULL, 479, NULL, 'PIRSR638639-51', 278044),
(458951, 'PIRSR003048-2', NULL, NULL, 824, NULL, 'PIRSR003048-2', 278045),
(458952, 'PIRSR000463-1', NULL, NULL, 638, NULL, 'PIRSR000463-1', 278046),
(458953, 'PIRSR000103-2', NULL, NULL, 272, NULL, 'PIRSR000103-2', 278047),
(458954, 'PIRSR000190-1', NULL, NULL, 218, NULL, 'PIRSR000190-1', 278048),
(458955, 'PIRSR000451-1', NULL, NULL, 341, NULL, 'PIRSR000451-1', 278049),
(458956, 'PIRSR000724-1', NULL, NULL, 315, NULL, 'PIRSR000724-1', 278050),
(458957, 'PIRSR623612-1', NULL, NULL, 532, NULL, 'PIRSR623612-1', 278051),
(458958, 'PIRSR037177-3', NULL, NULL, 271, NULL, 'PIRSR037177-3', 278052),
(458959, 'PIRSR000077-4', NULL, NULL, 106, NULL, 'PIRSR000077-4', 278053),
(458960, 'PIRSR611166-50', NULL, NULL, 459, NULL, 'PIRSR611166-50', 278054),
(458961, 'PIRSR629881-1', NULL, NULL, 875, NULL, 'PIRSR629881-1', 278055),
(458962, 'PIRSR001013-1', NULL, NULL, 106, NULL, 'PIRSR001013-1', 278056),
(458963, 'PIRSR000977-3', NULL, NULL, 480, NULL, 'PIRSR000977-3', 278057),
(458964, 'PIRSR001373-3', NULL, NULL, 527, NULL, 'PIRSR001373-3', 278058),
(458965, 'PIRSR000390-2', NULL, NULL, 333, NULL, 'PIRSR000390-2', 278059),
(458966, 'PIRSR005378-1', NULL, NULL, 353, NULL, 'PIRSR005378-1', 278060),
(458967, 'PIRSR001935-1', NULL, NULL, 212, NULL, 'PIRSR001935-1', 278061),
(458968, 'PIRSR601681-50', NULL, NULL, 439, NULL, 'PIRSR601681-50', 278062),
(458969, 'PIRSR600823-2', NULL, NULL, 331, NULL, 'PIRSR600823-2', 278063),
(458970, 'PIRSR628391-1', NULL, NULL, 778, NULL, 'PIRSR628391-1', 278064),
(458971, 'PIRSR619502-1', NULL, NULL, 913, NULL, 'PIRSR619502-1', 278065),
(458972, 'PIRSR500951-1', NULL, NULL, 874, NULL, 'PIRSR500951-1', 278066);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(458973, 'PIRSR000087-50', NULL, NULL, 125, NULL, 'PIRSR000087-50', 278067),
(458974, 'PIRSR600243-1', NULL, NULL, 246, NULL, 'PIRSR600243-1', 278068),
(458975, 'PIRSR018774-1', NULL, NULL, 365, NULL, 'PIRSR018774-1', 278069),
(458976, 'PIRSR617512-2', NULL, NULL, 726, NULL, 'PIRSR617512-2', 278070),
(458977, 'PIRSR621573-3', NULL, NULL, 2292, NULL, 'PIRSR621573-3', 278071),
(458978, 'PIRSR001415-2', NULL, NULL, 314, NULL, 'PIRSR001415-2', 278072),
(458979, 'PIRSR000666-1', NULL, NULL, 899, NULL, 'PIRSR000666-1', 278073),
(458980, 'PIRSR038120-2', NULL, NULL, 177, NULL, 'PIRSR038120-2', 278074),
(458981, 'PIRSR600888-3', NULL, NULL, 164, NULL, 'PIRSR600888-3', 278075),
(458982, 'PIRSR608256-1', NULL, NULL, 238, NULL, 'PIRSR608256-1', 278076),
(458983, 'PIRSR625650-3', NULL, NULL, 644, NULL, 'PIRSR625650-3', 278077),
(458984, 'PIRSR006118-1', NULL, NULL, 176, NULL, 'PIRSR006118-1', 278078),
(458985, 'PIRSR038895-2', NULL, NULL, 528, NULL, 'PIRSR038895-2', 278079),
(458986, 'PIRSR000604-1', NULL, NULL, 615, NULL, 'PIRSR000604-1', 278080),
(458987, 'PIRSR017901-50', NULL, NULL, 455, NULL, 'PIRSR017901-50', 278081),
(458988, 'PIRSR001467-1', NULL, NULL, 176, NULL, 'PIRSR001467-1', 278082),
(458989, 'PIRSR005054-50', NULL, NULL, 239, NULL, 'PIRSR005054-50', 278083),
(458990, 'PIRSR016408-2', NULL, NULL, 486, NULL, 'PIRSR016408-2', 278084),
(458991, 'PIRSR029256-1', NULL, NULL, 141, NULL, 'PIRSR029256-1', 278085),
(458992, 'PIRSR631038-1', NULL, NULL, 333, NULL, 'PIRSR631038-1', 278086),
(458993, 'PIRSR038945-3', NULL, NULL, 300, NULL, 'PIRSR038945-3', 278087),
(458994, 'PIRSR000260-4', NULL, NULL, 96, NULL, 'PIRSR000260-4', 278088),
(458995, 'PIRSR002520-4', NULL, NULL, 609, NULL, 'PIRSR002520-4', 278089),
(458996, 'PIRSR605626-50', NULL, NULL, 470, NULL, 'PIRSR605626-50', 278090),
(458997, 'PIRSR620004-3', NULL, NULL, 722, NULL, 'PIRSR620004-3', 278091),
(458998, 'PIRSR006386-1', NULL, NULL, 214, NULL, 'PIRSR006386-1', 278092),
(458999, 'PIRSR000192-6', NULL, NULL, 188, NULL, 'PIRSR000192-6', 278093),
(459000, 'PIRSR036561-2', NULL, NULL, 224, NULL, 'PIRSR036561-2', 278094),
(459001, 'PIRSR607702-1', NULL, NULL, 140, NULL, 'PIRSR607702-1', 278095),
(459002, 'PIRSR000095-1', NULL, NULL, 268, NULL, 'PIRSR000095-1', 278096),
(459003, 'PIRSR000661-51', NULL, NULL, 805, NULL, 'PIRSR000661-51', 278097),
(459004, 'PIRSR002096-1', NULL, NULL, 135, NULL, 'PIRSR002096-1', 278098),
(459005, 'PIRSR038925-1', NULL, NULL, 233, NULL, 'PIRSR038925-1', 278099),
(459006, 'PIRSR629609-5', NULL, NULL, 719, NULL, 'PIRSR629609-5', 278100),
(459007, 'PIRSR001150-1', NULL, NULL, 810, NULL, 'PIRSR001150-1', 278101),
(459008, 'PIRSR037215-1', NULL, NULL, 411, NULL, 'PIRSR037215-1', 278102),
(459009, 'PIRSR000362-1', NULL, NULL, 352, NULL, 'PIRSR000362-1', 278103),
(459010, 'PIRSR028973-1', NULL, NULL, 291, NULL, 'PIRSR028973-1', 278104),
(459011, 'PIRSR600990-50', NULL, NULL, 425, NULL, 'PIRSR600990-50', 278105),
(459012, 'PIRSR006615-2', NULL, NULL, 503, NULL, 'PIRSR006615-2', 278106),
(459013, 'PIRSR017388-3', NULL, NULL, 245, NULL, 'PIRSR017388-3', 278107),
(459014, 'PIRSR037471-1', NULL, NULL, 400, NULL, 'PIRSR037471-1', 278108),
(459015, 'PIRSR000412-50', NULL, NULL, 429, NULL, 'PIRSR000412-50', 278109),
(459016, 'PIRSR038073-3', NULL, NULL, 297, NULL, 'PIRSR038073-3', 278110),
(459017, 'PIRSR000159-2', NULL, NULL, 921, NULL, 'PIRSR000159-2', 278111),
(459018, 'PIRSR036918-51', NULL, NULL, 605, NULL, 'PIRSR036918-51', 278112),
(459019, 'PIRSR005713-2', NULL, NULL, 390, NULL, 'PIRSR005713-2', 278113),
(459020, 'PIRSR601286-50', NULL, NULL, 680, NULL, 'PIRSR601286-50', 278114),
(459021, 'PIRSR009328-1', NULL, NULL, 416, NULL, 'PIRSR009328-1', 278115),
(459022, 'PIRSR600246-3', NULL, NULL, 336, NULL, 'PIRSR600246-3', 278116),
(459023, 'PIRSR621537-50', NULL, NULL, 796, NULL, 'PIRSR621537-50', 278117),
(459024, 'PIRSR017632-2', NULL, NULL, 395, NULL, 'PIRSR017632-2', 278118),
(459025, 'PIRSR000106-1', NULL, NULL, 483, NULL, 'PIRSR000106-1', 278119),
(459026, 'PIRSR001620-1', NULL, NULL, 275, NULL, 'PIRSR001620-1', 278120);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(459027, 'PIRSR038147-1', NULL, NULL, 556, NULL, 'PIRSR038147-1', 278121),
(459028, 'PIRSR000005-1', NULL, NULL, 183, NULL, 'PIRSR000005-1', 278122),
(459029, 'PIRSR037646-50', NULL, NULL, 1252, NULL, 'PIRSR037646-50', 278123),
(459030, 'PIRSR001997-1', NULL, NULL, 583, NULL, 'PIRSR001997-1', 278124),
(459031, 'PIRSR634598-3', NULL, NULL, 446, NULL, 'PIRSR634598-3', 278125),
(459032, 'PIRSR006769-3', NULL, NULL, 324, NULL, 'PIRSR006769-3', 278126),
(459033, 'PIRSR003085-2', NULL, NULL, 327, NULL, 'PIRSR003085-2', 278127),
(459034, 'PIRSR000084-50', NULL, NULL, 1129, NULL, 'PIRSR000084-50', 278128),
(459035, 'PIRSR000388-3', NULL, NULL, 244, NULL, 'PIRSR000388-3', 278129),
(459036, 'PIRSR006806-1', NULL, NULL, 175, NULL, 'PIRSR006806-1', 278130),
(459037, 'PIRSR002520-2', NULL, NULL, 609, NULL, 'PIRSR002520-2', 278131),
(459038, 'PIRSR037911-1', NULL, NULL, 660, NULL, 'PIRSR037911-1', 278132),
(459039, 'PIRSR016527-2', NULL, NULL, 261, NULL, 'PIRSR016527-2', 278133),
(459040, 'PIRSR628829-1', NULL, NULL, 888, NULL, 'PIRSR628829-1', 278134),
(459041, 'PIRSR000485-2', NULL, NULL, 468, NULL, 'PIRSR000485-2', 278135),
(459042, 'PIRSR000660-1', NULL, NULL, 1658, NULL, 'PIRSR000660-1', 278136),
(459043, 'PIRSR500135-2', NULL, NULL, 438, NULL, 'PIRSR500135-2', 278137),
(459044, 'PIRSR000009-2', NULL, NULL, 213, NULL, 'PIRSR000009-2', 278138),
(459045, 'PIRSR006135-1', NULL, NULL, 184, NULL, 'PIRSR006135-1', 278139),
(459046, 'PIRSR000242-1', NULL, NULL, 566, NULL, 'PIRSR000242-1', 278140),
(459047, 'PIRSR006278-2', NULL, NULL, 260, NULL, 'PIRSR006278-2', 278141),
(459048, 'PIRSR004532-2', NULL, NULL, 311, NULL, 'PIRSR004532-2', 278142),
(459049, 'PIRSR038142-1', NULL, NULL, 262, NULL, 'PIRSR038142-1', 278143),
(459050, 'PIRSR627185-53', NULL, NULL, 785, NULL, 'PIRSR627185-53', 278144),
(459051, 'PIRSR001558-3', NULL, NULL, 320, NULL, 'PIRSR001558-3', 278145),
(459052, 'PIRSR004692-3', NULL, NULL, 314, NULL, 'PIRSR004692-3', 278146),
(459053, 'PIRSR005894-1', NULL, NULL, 108, NULL, 'PIRSR005894-1', 278147),
(459054, 'PIRSR036593-50', NULL, NULL, 383, NULL, 'PIRSR036593-50', 278148),
(459055, 'PIRSR601621-3', NULL, NULL, 370, NULL, 'PIRSR601621-3', 278149),
(459056, 'PIRSR000137-1', NULL, NULL, 578, NULL, 'PIRSR000137-1', 278150),
(459057, 'PIRSR001594-3', NULL, NULL, 1106, NULL, 'PIRSR001594-3', 278151),
(459058, 'PIRSR037404-1', NULL, NULL, 1614, NULL, 'PIRSR037404-1', 278152),
(459059, 'PIRSR036503-51', NULL, NULL, 377, NULL, 'PIRSR036503-51', 278153),
(459060, 'PIRSR039133-3', NULL, NULL, 649, NULL, 'PIRSR039133-3', 278154),
(459061, 'PIRSR627053-4', NULL, NULL, 749, NULL, 'PIRSR627053-4', 278155),
(459062, 'PIRSR037756-1', NULL, NULL, 297, NULL, 'PIRSR037756-1', 278156),
(459063, 'PIRSR038172-1', NULL, NULL, 788, NULL, 'PIRSR038172-1', 278157),
(459064, 'PIRSR000472-50', NULL, NULL, 570, NULL, 'PIRSR000472-50', 278158),
(459065, 'PIRSR004803-2', NULL, NULL, 558, NULL, 'PIRSR004803-2', 278159),
(459066, 'PIRSR026583-50', NULL, NULL, 661, NULL, 'PIRSR026583-50', 278160),
(459067, 'PIRSR630294-3', NULL, NULL, 306, NULL, 'PIRSR630294-3', 278161),
(459068, 'PIRSR016616-2', NULL, NULL, 293, NULL, 'PIRSR016616-2', 278162),
(459069, 'PIRSR018250-4', NULL, NULL, 371, NULL, 'PIRSR018250-4', 278163),
(459070, 'PIRSR001434-2', NULL, NULL, 299, NULL, 'PIRSR001434-2', 278164),
(459071, 'PIRSR034515-1', NULL, NULL, 1021, NULL, 'PIRSR034515-1', 278165),
(459072, 'PIRSR630295-51', NULL, NULL, 298, NULL, 'PIRSR630295-51', 278166),
(459073, 'PIRSR037299-2', NULL, NULL, 338, NULL, 'PIRSR037299-2', 278167),
(459074, 'PIRSR601233-1', NULL, NULL, 495, NULL, 'PIRSR601233-1', 278168),
(459075, 'PIRSR036687-2', NULL, NULL, 756, NULL, 'PIRSR036687-2', 278169),
(459076, 'PIRSR000898-1', NULL, NULL, 327, NULL, 'PIRSR000898-1', 278170),
(459077, 'PIRSR001924-1', NULL, NULL, 315, NULL, 'PIRSR001924-1', 278171),
(459078, 'PIRSR016496-1', NULL, NULL, 260, NULL, 'PIRSR016496-1', 278172),
(459079, 'PIRSR036492-1', NULL, NULL, 479, NULL, 'PIRSR036492-1', 278173),
(459080, 'PIRSR000290-1', NULL, NULL, 489, NULL, 'PIRSR000290-1', 278174);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(459081, 'PIRSR000388-1', NULL, NULL, 244, NULL, 'PIRSR000388-1', 278175),
(459082, 'PIRSR037839-1', NULL, NULL, 168, NULL, 'PIRSR037839-1', 278176),
(459083, 'PIRSR005091-2', NULL, NULL, 553, NULL, 'PIRSR005091-2', 278177),
(459084, 'PIRSR620443-50', NULL, NULL, 168, NULL, 'PIRSR620443-50', 278178),
(459085, 'PIRSR629881-3', NULL, NULL, 875, NULL, 'PIRSR629881-3', 278179),
(459086, 'PIRSR631048-52', NULL, NULL, 611, NULL, 'PIRSR631048-52', 278180),
(459087, 'PIRSR029271-51', NULL, NULL, 301, NULL, 'PIRSR029271-51', 278181),
(459088, 'PIRSR037938-3', NULL, NULL, 252, NULL, 'PIRSR037938-3', 278182),
(459089, 'PIRSR000167-1', NULL, NULL, 293, NULL, 'PIRSR000167-1', 278183),
(459090, 'PIRSR633567-1', NULL, NULL, 302, NULL, 'PIRSR633567-1', 278184),
(459091, 'PIRSR000137-3', NULL, NULL, 578, NULL, 'PIRSR000137-3', 278185),
(459092, 'PIRSR000099-3', NULL, NULL, 362, NULL, 'PIRSR000099-3', 278186),
(459093, 'PIRSR000149-3', NULL, NULL, 341, NULL, 'PIRSR000149-3', 278187),
(459094, 'PIRSR005384-1', NULL, NULL, 151, NULL, 'PIRSR005384-1', 278188),
(459095, 'PIRSR629580-3', NULL, NULL, 600, NULL, 'PIRSR629580-3', 278189),
(459096, 'PIRSR633528-3', NULL, NULL, 947, NULL, 'PIRSR633528-3', 278190),
(459097, 'PIRSR000376-1', NULL, NULL, 468, NULL, 'PIRSR000376-1', 278191),
(459098, 'PIRSR604450-51', NULL, NULL, 480, NULL, 'PIRSR604450-51', 278192),
(459099, 'PIRSR001247-1', NULL, NULL, 664, NULL, 'PIRSR001247-1', 278193),
(459100, 'PIRSR000196-2', NULL, NULL, 307, NULL, 'PIRSR000196-2', 278194),
(459101, 'PIRSR000988-3', NULL, NULL, 259, NULL, 'PIRSR000988-3', 278195),
(459102, 'PIRSR017250-50', NULL, NULL, 294, NULL, 'PIRSR017250-50', 278196),
(459103, 'PIRSR003170-1', NULL, NULL, 223, NULL, 'PIRSR003170-1', 278197),
(459104, 'PIRSR018425-2', NULL, NULL, 546, NULL, 'PIRSR018425-2', 278198),
(459105, 'PIRSR038134-2', NULL, NULL, 285, NULL, 'PIRSR038134-2', 278199),
(459106, 'PIRSR639314-50', NULL, NULL, 106, NULL, 'PIRSR639314-50', 278200),
(459107, 'PIRSR000331-1', NULL, NULL, 468, NULL, 'PIRSR000331-1', 278201),
(459108, 'PIRSR000343-1', NULL, NULL, 272, NULL, 'PIRSR000343-1', 278202),
(459109, 'PIRSR028762-2', NULL, NULL, 389, NULL, 'PIRSR028762-2', 278203),
(459110, 'PIRSR002023-50', NULL, NULL, 181, NULL, 'PIRSR002023-50', 278204),
(459111, 'PIRSR608127-52', NULL, NULL, 455, NULL, 'PIRSR608127-52', 278205),
(459112, 'PIRSR628472-1', NULL, NULL, 565, NULL, 'PIRSR628472-1', 278206),
(459113, 'PIRSR633199-2', NULL, NULL, 265, NULL, 'PIRSR633199-2', 278207),
(459114, 'PIRSR617453-50', NULL, NULL, 130, NULL, 'PIRSR617453-50', 278208),
(459115, 'PIRSR601621-1', NULL, NULL, 370, NULL, 'PIRSR601621-1', 278209),
(459116, 'PIRSR000939-1', NULL, NULL, 395, NULL, 'PIRSR000939-1', 278210),
(459117, 'PIRSR000017-1', NULL, NULL, 341, NULL, 'PIRSR000017-1', 278211),
(459118, 'PIRSR000025-2', NULL, NULL, 119, NULL, 'PIRSR000025-2', 278212),
(459119, 'PIRSR630220-1', NULL, NULL, 1040, NULL, 'PIRSR630220-1', 278213),
(459120, 'PIRSR620004-1', NULL, NULL, 722, NULL, 'PIRSR620004-1', 278214),
(459121, 'PIRSR618191-1', NULL, NULL, 62, NULL, 'PIRSR618191-1', 278215),
(459122, 'PIRSR000187-2', NULL, NULL, 2115, NULL, 'PIRSR000187-2', 278216),
(459123, 'PIRSR011588-51', NULL, NULL, 428, NULL, 'PIRSR011588-51', 278217),
(459124, 'PIRSR605856-51', NULL, NULL, 316, NULL, 'PIRSR605856-51', 278218),
(459125, 'PIRSR017632-1', NULL, NULL, 395, NULL, 'PIRSR017632-1', 278219),
(459126, 'PIRSR000095-2', NULL, NULL, 268, NULL, 'PIRSR000095-2', 278220),
(459127, 'PIRSR001815-50', NULL, NULL, 155, NULL, 'PIRSR001815-50', 278221),
(459128, 'PIRSR002799-1', NULL, NULL, 711, NULL, 'PIRSR002799-1', 278222),
(459129, 'PIRSR036517-1', NULL, NULL, 145, NULL, 'PIRSR036517-1', 278223),
(459130, 'PIRSR600246-2', NULL, NULL, 336, NULL, 'PIRSR600246-2', 278224),
(459131, 'PIRSR000159-1', NULL, NULL, 921, NULL, 'PIRSR000159-1', 278225),
(459132, 'PIRSR018001-1', NULL, NULL, 313, NULL, 'PIRSR018001-1', 278226),
(459133, 'PIRSR001362-3', NULL, NULL, 540, NULL, 'PIRSR001362-3', 278227),
(459134, 'PIRSR000970-1', NULL, NULL, 420, NULL, 'PIRSR000970-1', 278228); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(459135, 'PIRSR001060-1', NULL, NULL, 320, NULL, 'PIRSR001060-1', 278229),
(459136, 'PIRSR627185-52', NULL, NULL, 785, NULL, 'PIRSR627185-52', 278230),
(459137, 'PIRSR004532-1', NULL, NULL, 311, NULL, 'PIRSR004532-1', 278231),
(459138, 'PIRSR015957-1', NULL, NULL, 236, NULL, 'PIRSR015957-1', 278232),
(459139, 'PIRSR610059-51', NULL, NULL, 309, NULL, 'PIRSR610059-51', 278233),
(459140, 'PIRSR015244-50', NULL, NULL, 435, NULL, 'PIRSR015244-50', 278234),
(459141, 'PIRSR016020-2', NULL, NULL, 257, NULL, 'PIRSR016020-2', 278235),
(459142, 'PIRSR000343-2', NULL, NULL, 272, NULL, 'PIRSR000343-2', 278236),
(459143, 'PIRSR000440-1', NULL, NULL, 205, NULL, 'PIRSR000440-1', 278237),
(459144, 'PIRSR631245-1', NULL, NULL, 760, NULL, 'PIRSR631245-1', 278238),
(459145, 'PIRSR633199-1', NULL, NULL, 265, NULL, 'PIRSR633199-1', 278239),
(459146, 'PIRSR001355-5', NULL, NULL, 358, NULL, 'PIRSR001355-5', 278240),
(459147, 'PIRSR002854-1', NULL, NULL, 269, NULL, 'PIRSR002854-1', 278241),
(459148, 'PIRSR629890-3', NULL, NULL, 908, NULL, 'PIRSR629890-3', 278242),
(459149, 'PIRSR021497-2', NULL, NULL, 267, NULL, 'PIRSR021497-2', 278243),
(459150, 'PIRSR016323-1', NULL, NULL, 285, NULL, 'PIRSR016323-1', 278244),
(459151, 'PIRSR621573-4', NULL, NULL, 2292, NULL, 'PIRSR621573-4', 278245),
(459152, 'PIRSR000192-1', NULL, NULL, 178, NULL, 'PIRSR000192-1', 278246),
(459153, 'PIRSR630616-1', NULL, NULL, 349, NULL, 'PIRSR630616-1', 278247),
(459154, 'PIRSR633040-2', NULL, NULL, 260, NULL, 'PIRSR633040-2', 278248),
(459155, 'PIRSR627173-51', NULL, NULL, 905, NULL, 'PIRSR627173-51', 278249),
(459156, 'PIRSR000806-2', NULL, NULL, 499, NULL, 'PIRSR000806-2', 278250),
(459157, 'PIRSR008716-1', NULL, NULL, 165, NULL, 'PIRSR008716-1', 278251),
(459158, 'PIRSR627620-2', NULL, NULL, 1242, NULL, 'PIRSR627620-2', 278252),
(459159, 'PIRSR000898-2', NULL, NULL, 327, NULL, 'PIRSR000898-2', 278253),
(459160, 'PIRSR038193-3', NULL, NULL, 455, NULL, 'PIRSR038193-3', 278254),
(459161, 'PIRSR629580-2', NULL, NULL, 600, NULL, 'PIRSR629580-2', 278255),
(459162, 'PIRSR036514-1', NULL, NULL, 176, NULL, 'PIRSR036514-1', 278256),
(459163, 'PIRSR001145-3', NULL, NULL, 563, NULL, 'PIRSR001145-3', 278257),
(459164, 'PIRSR009400-1', NULL, NULL, 411, NULL, 'PIRSR009400-1', 278258),
(459165, 'PIRSR039020-50', NULL, NULL, 122, NULL, 'PIRSR039020-50', 278259),
(459166, 'PIRSR000156-1', NULL, NULL, 860, NULL, 'PIRSR000156-1', 278260),
(459167, 'PIRSR000185-3', NULL, NULL, 401, NULL, 'PIRSR000185-3', 278261),
(459168, 'PIRSR602137-50', NULL, NULL, 270, NULL, 'PIRSR602137-50', 278262),
(459169, 'PIRSR000619-1', NULL, NULL, 1262, NULL, 'PIRSR000619-1', 278263),
(459170, 'PIRSR001415-3', NULL, NULL, 314, NULL, 'PIRSR001415-3', 278264),
(459171, 'PIRSR620405-1', NULL, NULL, 201, NULL, 'PIRSR620405-1', 278265),
(459172, 'PIRSR000337-1', NULL, NULL, 442, NULL, 'PIRSR000337-1', 278266),
(459173, 'PIRSR037014-1', NULL, NULL, 921, NULL, 'PIRSR037014-1', 278267),
(459174, 'PIRSR000018-51', NULL, NULL, 448, NULL, 'PIRSR000018-51', 278268),
(459175, 'PIRSR001400-1', NULL, NULL, 315, NULL, 'PIRSR001400-1', 278269),
(459176, 'PIRSR001399-3', NULL, NULL, 149, NULL, 'PIRSR001399-3', 278270),
(459177, 'PIRSR037945-1', NULL, NULL, 200, NULL, 'PIRSR037945-1', 278271),
(459178, 'PIRSR000624-1', NULL, NULL, 942, NULL, 'PIRSR000624-1', 278272),
(459179, 'PIRSR000808-1', NULL, NULL, 352, NULL, 'PIRSR000808-1', 278273),
(459180, 'PIRSR000865-3', NULL, NULL, 462, NULL, 'PIRSR000865-3', 278274),
(459181, 'PIRSR036489-1', NULL, NULL, 902, NULL, 'PIRSR036489-1', 278275),
(459182, 'PIRSR037299-1', NULL, NULL, 338, NULL, 'PIRSR037299-1', 278276),
(459183, 'PIRSR005562-1', NULL, NULL, 2069, NULL, 'PIRSR005562-1', 278277),
(459184, 'PIRSR627053-5', NULL, NULL, 749, NULL, 'PIRSR627053-5', 278278),
(459185, 'PIRSR000098-1', NULL, NULL, 434, NULL, 'PIRSR000098-1', 278279),
(459186, 'PIRSR001021-1', NULL, NULL, 472, NULL, 'PIRSR001021-1', 278280),
(459187, 'PIRSR633197-3', NULL, NULL, 285, NULL, 'PIRSR633197-3', 278281),
(459188, 'PIRSR001150-2', NULL, NULL, 810, NULL, 'PIRSR001150-2', 278282);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(459189, 'PIRSR037942-1', NULL, NULL, 357, NULL, 'PIRSR037942-1', 278283),
(459190, 'PIRSR005894-2', NULL, NULL, 108, NULL, 'PIRSR005894-2', 278284),
(459191, 'PIRSR006135-2', NULL, NULL, 184, NULL, 'PIRSR006135-2', 278285),
(459192, 'PIRSR629576-5', NULL, NULL, 604, NULL, 'PIRSR629576-5', 278286),
(459193, 'PIRSR000118-3', NULL, NULL, 580, NULL, 'PIRSR000118-3', 278287),
(459194, 'PIRSR000551-50', NULL, NULL, 719, NULL, 'PIRSR000551-50', 278288),
(459195, 'PIRSR006386-2', NULL, NULL, 214, NULL, 'PIRSR006386-2', 278289),
(459196, 'PIRSR630560-1', NULL, NULL, 579, NULL, 'PIRSR630560-1', 278290),
(459197, 'PIRSR038928-2', NULL, NULL, 489, NULL, 'PIRSR038928-2', 278291),
(459198, 'PIRSR036511-1', NULL, NULL, 1100, NULL, 'PIRSR036511-1', 278292),
(459199, 'PIRSR001024-1', NULL, NULL, 477, NULL, 'PIRSR001024-1', 278293),
(459200, 'PIRSR619342-50', NULL, NULL, 104, NULL, 'PIRSR619342-50', 278294),
(459201, 'PIRSR000262-1', NULL, NULL, 555, NULL, 'PIRSR000262-1', 278295),
(459202, 'PIRSR016408-3', NULL, NULL, 486, NULL, 'PIRSR016408-3', 278296),
(459203, 'PIRSR000619-2', NULL, NULL, 1262, NULL, 'PIRSR000619-2', 278297),
(459204, 'PIRSR001362-2', NULL, NULL, 540, NULL, 'PIRSR001362-2', 278298),
(459205, 'PIRSR637641-50', NULL, NULL, 303, NULL, 'PIRSR637641-50', 278299),
(459206, 'PIRSR000098-2', NULL, NULL, 434, NULL, 'PIRSR000098-2', 278300),
(459207, 'PIRSR018077-1', NULL, NULL, 455, NULL, 'PIRSR018077-1', 278301),
(459208, 'PIRSR000103-1', NULL, NULL, 272, NULL, 'PIRSR000103-1', 278302),
(459209, 'PIRSR036665-50', NULL, NULL, 881, NULL, 'PIRSR036665-50', 278303),
(459210, 'PIRSR605468-51', NULL, NULL, 148, NULL, 'PIRSR605468-51', 278304),
(459211, 'PIRSR000006-2', NULL, NULL, 277, NULL, 'PIRSR000006-2', 278305),
(459212, 'PIRSR628472-2', NULL, NULL, 565, NULL, 'PIRSR628472-2', 278306),
(459213, 'PIRSR000187-1', NULL, NULL, 2115, NULL, 'PIRSR000187-1', 278307),
(459214, 'PIRSR016308-4', NULL, NULL, 824, NULL, 'PIRSR016308-4', 278308),
(459215, 'PIRSR000209-1', NULL, NULL, 1059, NULL, 'PIRSR000209-1', 278309),
(459216, 'PIRSR036517-2', NULL, NULL, 145, NULL, 'PIRSR036517-2', 278310),
(459217, 'PIRSR000552-2', NULL, NULL, 888, NULL, 'PIRSR000552-2', 278311),
(459218, 'PIRSR009407-4', NULL, NULL, 742, NULL, 'PIRSR009407-4', 278312),
(459219, 'PIRSR017267-1', NULL, NULL, 106, NULL, 'PIRSR017267-1', 278313),
(459220, 'PIRSR036893-50', NULL, NULL, 201, NULL, 'PIRSR036893-50', 278314),
(459221, 'PIRSR002305-1', NULL, NULL, 580, NULL, 'PIRSR002305-1', 278315),
(459222, 'PIRSR031924-50', NULL, NULL, 537, NULL, 'PIRSR031924-50', 278316),
(459223, 'PIRSR014972-2', NULL, NULL, 134, NULL, 'PIRSR014972-2', 278317),
(459224, 'PIRSR620004-2', NULL, NULL, 722, NULL, 'PIRSR620004-2', 278318),
(459225, 'PIRSR001137-50', NULL, NULL, 347, NULL, 'PIRSR001137-50', 278319),
(459226, 'PIRSR600407-1', NULL, NULL, 518, NULL, 'PIRSR600407-1', 278320),
(459227, 'PIRSR016521-1', NULL, NULL, 391, NULL, 'PIRSR016521-1', 278321),
(459228, 'PIRSR640198-2', NULL, NULL, 477, NULL, 'PIRSR640198-2', 278322),
(459229, 'PIRSR000112-3', NULL, NULL, 367, NULL, 'PIRSR000112-3', 278323),
(459230, 'PIRSR016184-1', NULL, NULL, 278, NULL, 'PIRSR016184-1', 278324),
(459231, 'PIRSR000390-1', NULL, NULL, 333, NULL, 'PIRSR000390-1', 278325),
(459232, 'PIRSR629890-4', NULL, NULL, 908, NULL, 'PIRSR629890-4', 278326),
(459233, 'PIRSR639036-50', NULL, NULL, 610, NULL, 'PIRSR639036-50', 278327),
(459234, 'PIRSR018169-1', NULL, NULL, 370, NULL, 'PIRSR018169-1', 278328),
(459235, 'PIRSR009400-2', NULL, NULL, 411, NULL, 'PIRSR009400-2', 278329),
(459236, 'PIRSR000354-1', NULL, NULL, 2186, NULL, 'PIRSR000354-1', 278330),
(459237, 'PIRSR037249-2', NULL, NULL, 373, NULL, 'PIRSR037249-2', 278331),
(459238, 'PIRSR001359-1', NULL, NULL, 260, NULL, 'PIRSR001359-1', 278332),
(459239, 'PIRSR001373-2', NULL, NULL, 527, NULL, 'PIRSR001373-2', 278333),
(459240, 'PIRSR000290-2', NULL, NULL, 489, NULL, 'PIRSR000290-2', 278334),
(459241, 'PIRSR017689-50', NULL, NULL, 487, NULL, 'PIRSR017689-50', 278335),
(459242, 'PIRSR601465-50', NULL, NULL, 578, NULL, 'PIRSR601465-50', 278336);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(459243, 'PIRSR017434-1', NULL, NULL, 424, NULL, 'PIRSR017434-1', 278337),
(459244, 'PIRSR037907-3', NULL, NULL, 660, NULL, 'PIRSR037907-3', 278338),
(459245, 'PIRSR009283-1', NULL, NULL, 318, NULL, 'PIRSR009283-1', 278339),
(459246, 'PIRSR600223-1', NULL, NULL, 249, NULL, 'PIRSR600223-1', 278340),
(459247, 'PIRSR000705-1', NULL, NULL, 198, NULL, 'PIRSR000705-1', 278341),
(459248, 'PIRSR000385-2', NULL, NULL, 271, NULL, 'PIRSR000385-2', 278342),
(459249, 'PIRSR600821-50', NULL, NULL, 377, NULL, 'PIRSR600821-50', 278343),
(459250, 'PIRSR614186-1', NULL, NULL, 281, NULL, 'PIRSR614186-1', 278344),
(459251, 'PIRSR620443-51', NULL, NULL, 177, NULL, 'PIRSR620443-51', 278345),
(459252, 'PIRSR003726-3', NULL, NULL, 295, NULL, 'PIRSR003726-3', 278346),
(459253, 'PIRSR004030-1', NULL, NULL, 95, NULL, 'PIRSR004030-1', 278347),
(459254, 'PIRSR003817-1', NULL, NULL, 3418, NULL, 'PIRSR003817-1', 278348),
(459255, 'PIRSR005557-2', NULL, NULL, 369, NULL, 'PIRSR005557-2', 278349),
(459256, 'PIRSR000109-2', NULL, NULL, 469, NULL, 'PIRSR000109-2', 278350),
(459257, 'PIRSR000617-4', NULL, NULL, 1428, NULL, 'PIRSR000617-4', 278351),
(459258, 'PIRSR631245-2', NULL, NULL, 760, NULL, 'PIRSR631245-2', 278352),
(459259, 'PIRSR005091-1', NULL, NULL, 553, NULL, 'PIRSR005091-1', 278353),
(459260, 'PIRSR037254-1', NULL, NULL, 182, NULL, 'PIRSR037254-1', 278354),
(459261, 'PIRSR002551-3', NULL, NULL, 458, NULL, 'PIRSR002551-3', 278355),
(459262, 'PIRSR000970-2', NULL, NULL, 420, NULL, 'PIRSR000970-2', 278356),
(459263, 'PIRSR000446-1', NULL, NULL, 310, NULL, 'PIRSR000446-1', 278357),
(459264, 'PIRSR000948-2', NULL, NULL, 631, NULL, 'PIRSR000948-2', 278358),
(459265, 'PIRSR036960-2', NULL, NULL, 930, NULL, 'PIRSR036960-2', 278359),
(459266, 'PIRSR037505-2', NULL, NULL, 406, NULL, 'PIRSR037505-2', 278360),
(459267, 'PIRSR604723-51', NULL, NULL, 395, NULL, 'PIRSR604723-51', 278361),
(459268, 'PIRSR037993-2', NULL, NULL, 318, NULL, 'PIRSR037993-2', 278362),
(459269, 'PIRSR037293-1', NULL, NULL, 794, NULL, 'PIRSR037293-1', 278363),
(459270, 'PIRSR000017-2', NULL, NULL, 341, NULL, 'PIRSR000017-2', 278364),
(459271, 'PIRSR633019-50', NULL, NULL, 799, NULL, 'PIRSR633019-50', 278365),
(459272, 'PIRSR628651-50', NULL, NULL, 274, NULL, 'PIRSR628651-50', 278366),
(459273, 'PIRSR019876-1', NULL, NULL, 207, NULL, 'PIRSR019876-1', 278367),
(459274, 'PIRSR000443-1', NULL, NULL, 376, NULL, 'PIRSR000443-1', 278368),
(459275, 'PIRSR000472-51', NULL, NULL, 570, NULL, 'PIRSR000472-51', 278369),
(459276, 'PIRSR018250-3', NULL, NULL, 371, NULL, 'PIRSR018250-3', 278370),
(459277, 'PIRSR633478-2', NULL, NULL, 790, NULL, 'PIRSR633478-2', 278371),
(459278, 'PIRSR633528-2', NULL, NULL, 947, NULL, 'PIRSR633528-2', 278372),
(459279, 'PIRSR000137-2', NULL, NULL, 578, NULL, 'PIRSR000137-2', 278373),
(459280, 'PIRSR004789-51', NULL, NULL, 266, NULL, 'PIRSR004789-51', 278374),
(459281, 'PIRSR633567-2', NULL, NULL, 302, NULL, 'PIRSR633567-2', 278375),
(459282, 'PIRSR000114-1', NULL, NULL, 344, NULL, 'PIRSR000114-1', 278376),
(459283, 'PIRSR002356-3', NULL, NULL, 410, NULL, 'PIRSR002356-3', 278377),
(459284, 'PIRSR608127-51', NULL, NULL, 455, NULL, 'PIRSR608127-51', 278378),
(459285, 'PIRSR018425-1', NULL, NULL, 546, NULL, 'PIRSR018425-1', 278379),
(459286, 'PIRSR000296-2', NULL, NULL, 293, NULL, 'PIRSR000296-2', 278380),
(459287, 'PIRSR000025-1', NULL, NULL, 119, NULL, 'PIRSR000025-1', 278381),
(459288, 'PIRSR038084-3', NULL, NULL, 419, NULL, 'PIRSR038084-3', 278382),
(459289, 'PIRSR600823-3', NULL, NULL, 331, NULL, 'PIRSR600823-3', 278383),
(459290, 'PIRSR001097-50', NULL, NULL, 309, NULL, 'PIRSR001097-50', 278384),
(459291, 'PIRSR000099-4', NULL, NULL, 362, NULL, 'PIRSR000099-4', 278385),
(459292, 'PIRSR000149-4', NULL, NULL, 341, NULL, 'PIRSR000149-4', 278386),
(459293, 'PIRSR028937-1', NULL, NULL, 748, NULL, 'PIRSR028937-1', 278387),
(459294, 'PIRSR006614-1', NULL, NULL, 116, NULL, 'PIRSR006614-1', 278388),
(459295, 'PIRSR004576-50', NULL, NULL, 246, NULL, 'PIRSR004576-50', 278389),
(459296, 'PIRSR036684-1', NULL, NULL, 760, NULL, 'PIRSR036684-1', 278390);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(459297, 'PIRSR629881-2', NULL, NULL, 875, NULL, 'PIRSR629881-2', 278391),
(459298, 'PIRSR000956-1', NULL, NULL, 1191, NULL, 'PIRSR000956-1', 278392),
(459299, 'PIRSR037251-1', NULL, NULL, 398, NULL, 'PIRSR037251-1', 278393),
(459300, 'PIRSR000485-1', NULL, NULL, 468, NULL, 'PIRSR000485-1', 278394),
(459301, 'PIRSR036958-3', NULL, NULL, 602, NULL, 'PIRSR036958-3', 278395),
(459302, 'PIRSR037250-53', NULL, NULL, 663, NULL, 'PIRSR037250-53', 278396),
(459303, 'PIRSR005604-2', NULL, NULL, 302, NULL, 'PIRSR005604-2', 278397),
(459304, 'PIRSR638639-50', NULL, NULL, 479, NULL, 'PIRSR638639-50', 278398),
(459305, 'PIRSR633508-1', NULL, NULL, 950, NULL, 'PIRSR633508-1', 278399),
(459306, 'PIRSR000388-2', NULL, NULL, 244, NULL, 'PIRSR000388-2', 278400),
(459307, 'PIRSR003048-1', NULL, NULL, 824, NULL, 'PIRSR003048-1', 278401),
(459308, 'PIRSR630056-1', NULL, NULL, 147, NULL, 'PIRSR630056-1', 278402),
(459309, 'PIRSR016262-1', NULL, NULL, 216, NULL, 'PIRSR016262-1', 278403),
(459310, 'PIRSR016616-1', NULL, NULL, 293, NULL, 'PIRSR016616-1', 278404),
(459311, 'PR00316', NULL, 'Enterobacterial virulence outer membrane protein signature', NULL, NULL, 'ENTEROVIROMP', 278405),
(459312, 'PR00148', NULL, 'Enolase signature', NULL, NULL, 'ENOLASE', 278406),
(459313, 'PR00144', NULL, 'Delta-aminolevulinic acid dehydratase signature', NULL, NULL, 'DALDHYDRTASE', 278407),
(459314, 'PR01852', NULL, 'Streptococcal non-M secreted SibA protein signature', NULL, NULL, 'SIBAPROTEIN', 278408),
(459315, 'PR01749', NULL, 'Transcription factor AP-2 alpha signature', NULL, NULL, 'AP2ATNSCPFCT', 278409),
(459316, 'PR00361', NULL, 'Calcitonin receptor signature', NULL, NULL, 'CALCITONINR', 278410),
(459317, 'PR01984', NULL, 'Neurogenic locus Notch protein 1 signature', NULL, NULL, 'NOTCH1', 278411),
(459318, 'PR01104', NULL, 'Anaphylatoxin chemotactic receptor signature', NULL, NULL, 'ANPHYLATOXNR', 278412),
(459319, 'PR00843', NULL, 'Glycosyl hydrolase family 30 signature', NULL, NULL, 'GLHYDRLASE30', 278413),
(459320, 'PR00152', NULL, 'RuBisCO small subunit signature', NULL, NULL, 'RUBISCOSMALL', 278414),
(459321, 'PR02020', NULL, 'Aquaporin-8 signature', NULL, NULL, 'AQUAPORIN8', 278415),
(459322, 'PR00506', NULL, 'D21 class N6 adenine-specific DNA methyltransferase signature', NULL, NULL, 'D21N6MTFRASE', 278416),
(459323, 'PR01667', NULL, 'Voltage-gated Na+ channel alpha 8 subunit signature', NULL, NULL, 'NACHANNEL8', 278417),
(459324, 'PR00060', NULL, 'Ribosomal protein L16 signature', NULL, NULL, 'RIBOSOMALL16', 278418),
(459325, 'PR01918', NULL, 'Tumour necrosis factor receptor 1A signature', NULL, NULL, 'TNFACTORR1A', 278419),
(459326, 'PR01270', NULL, 'Histone deacetylase superfamily signature', NULL, NULL, 'HDASUPER', 278420),
(459327, 'PR02109', NULL, 'Mas-related G protein-coupled receptor A signature', NULL, NULL, 'MRGPCRA', 278421),
(459328, 'PR01990', NULL, 'H-2 class II histocompatibility antigen gamma chain (CD74 antigen) signature', NULL, NULL, 'CD74ANTIGEN', 278422),
(459329, 'PR01778', NULL, 'KIM-containing protein tyrosine phosphatase signature', NULL, NULL, 'KIMPTPASE', 278423),
(459330, 'PR00717', NULL, 'GPCR kinase signature', NULL, NULL, 'GPCRKINASE', 278424),
(459331, 'PR01639', NULL, 'Mammal profilin signature', NULL, NULL, 'PROFILINMAML', 278425),
(459332, 'PR00725', NULL, 'D-Ala-D-Ala carboxypeptidase 1 (S11) family signature', NULL, NULL, 'DADACBPTASE1', 278426),
(459333, 'PR01629', NULL, 'T-type voltage-dependent calcium channel alpha-1 subunit signature', NULL, NULL, 'TVDCCALPHA1', 278427),
(459334, 'PR00226', NULL, 'Geminivirus MSV 27kDa coat protein signature', NULL, NULL, 'GEMCOATMSV', 278428),
(459335, 'PR00356', NULL, 'Type II antifreeze protein signature', NULL, NULL, 'ANTIFREEZEII', 278429),
(459336, 'PR01178', NULL, 'Metabotropic gamma-aminobutyric acid type B2 receptor signature', NULL, NULL, 'GABAB2RECPTR', 278430),
(459337, 'PR00018', NULL, 'Kringle domain signature', NULL, NULL, 'KRINGLE', 278431),
(459338, 'PR00823', NULL, 'Pancreatic lipase signature', NULL, NULL, 'PANCLIPASE', 278432);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(459339, 'PR01508', NULL, 'Kv1.1 voltage-gated K+ channel signature', NULL, NULL, 'KV11CHANNEL', 278433),
(459340, 'PR01444', NULL, 'Latrophilin receptor signature', NULL, NULL, 'LATROPHILIN', 278434),
(459341, 'PR01229', NULL, 'Green fluorescent protein signature', NULL, NULL, 'GFLUORESCENT', 278435),
(459342, 'PR02063', NULL, 'DNA damage checkpoint protein 1 signature', NULL, NULL, 'DNADAMAGECP1', 278436),
(459343, 'PR01781', NULL, 'Linker for activation of T cells (LAT) signature', NULL, NULL, 'LATPROTEIN', 278437),
(459344, 'PR00847', NULL, 'Bee venom hyaluronidase signature', NULL, NULL, 'HYALURONDASE', 278438),
(459345, 'PR01431', NULL, 'Tuberin signature', NULL, NULL, 'TUBERIN', 278439),
(459346, 'PR00690', NULL, 'Adhesin family signature', NULL, NULL, 'ADHESNFAMILY', 278440),
(459347, 'PR01119', NULL, 'CLC-K chloride channel family signature', NULL, NULL, 'CLCHANNELKDY', 278441),
(459348, 'PR01500', NULL, 'Tropoelastin signature', NULL, NULL, 'TROPOELASTIN', 278442),
(459349, 'PR00472', NULL, 'Casein kinase II regulatory subunit family signature', NULL, NULL, 'CASNKINASEII', 278443),
(459350, 'PR00285', NULL, 'Scorpion toxin signature', NULL, NULL, 'SCORPNTOXIN', 278444),
(459351, 'PR01535', NULL, 'Vomeronasal type 2 receptor family signature', NULL, NULL, 'VOMERONASL2R', 278445),
(459352, 'PR00636', NULL, 'AT2 angiotensin II receptor signature', NULL, NULL, 'ANGIOTENSN2R', 278446),
(459353, 'PR01596', NULL, 'Gram-negative bacterial type III secretion SycE chaperone signature', NULL, NULL, 'SYCECHAPRONE', 278447),
(459354, 'PR00247', NULL, 'cAMP-type GPCR signature', NULL, NULL, 'GPCRCAMP', 278448),
(459355, 'PR02057', NULL, 'Protein family FAM105B signature', NULL, NULL, 'PROTEINF105B', 278449),
(459356, 'PR00786', NULL, 'Neprilysin metalloprotease (M13) family signature', NULL, NULL, 'NEPRILYSIN', 278450),
(459357, 'PR01133', NULL, 'Gap junction alpha-3 protein signature', NULL, NULL, 'CONNEXINA3', 278451),
(459358, 'PR00702', NULL, 'Acriflavin resistance protein family signature', NULL, NULL, 'ACRIFLAVINRP', 278452),
(459359, 'PR01003', NULL, 'Flagellar assembly protein FliH signature', NULL, NULL, 'FLGFLIH', 278453),
(459360, 'PR01259', NULL, 'Na+/Ca2+ exchanger signature', NULL, NULL, 'NACAEXCHNGR', 278454),
(459361, 'PR00991', NULL, '6-phosphofructo-2-kinase family signature', NULL, NULL, '6PFRUCTKNASE', 278455),
(459362, 'PR01677', NULL, 'Glycine receptor beta subunit signature', NULL, NULL, 'GLYRBETA', 278456),
(459363, 'PR00405', NULL, 'HIV Rev interacting protein signature', NULL, NULL, 'REVINTRACTNG', 278457),
(459364, 'PR01775', NULL, 'Bacterial glucose-fructose oxidoreductase signature', NULL, NULL, 'GLFROXRDTASE', 278458),
(459365, 'PR00830', NULL, 'Endopeptidase La (Lon) serine protease (S16) signature', NULL, NULL, 'ENDOLAPTASE', 278459),
(459366, 'PR00526', NULL, 'Formyl-methionyl peptide receptor signature', NULL, NULL, 'FMETLEUPHER', 278460),
(459367, 'PR00781', NULL, 'Lipoprotein signal peptidase family (A8) signature', NULL, NULL, 'LIPOSIGPTASE', 278461),
(459368, 'PR00320', NULL, 'G protein beta WD-40 repeat signature', NULL, NULL, 'GPROTEINBRPT', 278462),
(459369, 'PR01000', NULL, 'Sterol regulatory element binding protein site 2 protease (M50) signature', NULL, NULL, 'SREBPS2PTASE', 278463),
(459370, 'PR01583', NULL, 'Kv3.4 voltage-gated K+ channel signature', NULL, NULL, 'KV34CHANNEL', 278464),
(459371, 'PR00206', NULL, 'Connexin signature', NULL, NULL, 'CONNEXIN', 278465),
(459372, 'PR01329', NULL, 'Kir3.3 inward rectifier K+ channel signature', NULL, NULL, 'KIR33CHANNEL', 278466),
(459373, 'PR00490', NULL, 'Secretin receptor signature', NULL, NULL, 'SECRETINR', 278467),
(459374, 'PR01397', NULL, '2,3-dihydro-2,3-dihydroxybenzoate dehydrogenase signature', NULL, NULL, 'DHBDHDRGNASE', 278468),
(459375, 'PR01782', NULL, 'Mycobacterial cell entry (MCE) protein signature', NULL, NULL, 'MCEVIRFACTOR', 278469),
(459376, 'PR01497', NULL, 'Shal voltage-gated K+ channel family signature', NULL, NULL, 'SHALCHANNEL', 278470),
(459377, 'PR01017', NULL, 'Neuropeptide Y6 receptor signature', NULL, NULL, 'NRPEPTIDEY6R', 278471);
INSERT INTO "PUBLIC"."MODEL" VALUES
(459378, 'PR00009', NULL, 'Type I EGF signature', NULL, NULL, 'EGFTGF', 278472),
(459379, 'PR00117', NULL, 'Barnase signature', NULL, NULL, 'BARNASE', 278473),
(459380, 'PR00736', NULL, 'Glycosyl hydrolase family 15 signature', NULL, NULL, 'GLHYDRLASE15', 278474),
(459381, 'PR00790', NULL, 'Peptidyl-glycine alpha-amidating monooxygenase signature', NULL, NULL, 'PAMONOXGNASE', 278475),
(459382, 'PR00262', NULL, 'IL1/HBGF family signature', NULL, NULL, 'IL1HBGF', 278476),
(459383, 'PR01313', NULL, 'P2X6 purinoceptor signature', NULL, NULL, 'P2X6RECEPTOR', 278477),
(459384, 'PR00454', NULL, 'ETS domain signature', NULL, NULL, 'ETSDOMAIN', 278478),
(459385, 'PR00794', NULL, 'Pancreatic ribonuclease family signature', NULL, NULL, 'RIBONUCLEASE', 278479),
(459386, 'PR00219', NULL, 'Synaptobrevin signature', NULL, NULL, 'SYNAPTOBREVN', 278480),
(459387, 'PR00533', NULL, 'Mas oncogene signature', NULL, NULL, 'MASONCOGENE', 278481),
(459388, 'PR01368', NULL, 'Synapsin signature', NULL, NULL, 'SYNAPSIN', 278482),
(459389, 'PR00115', NULL, 'Fructose-1,6-bisphosphatase signature', NULL, NULL, 'F16BPHPHTASE', 278483),
(459390, 'PR00276', NULL, 'Insulin family signature', NULL, NULL, 'INSULINFAMLY', 278484),
(459391, 'PR00612', NULL, 'Alpha haemoglobin signature', NULL, NULL, 'ALPHAHAEM', 278485),
(459392, 'PR00228', NULL, 'Geminivirus CLV AL1 coat protein signature', NULL, NULL, 'GEMCOATCLVL1', 278486),
(459393, 'PR00158', NULL, 'Rusticyanin signature', NULL, NULL, 'RUSTICYANIN', 278487),
(459394, 'PR01483', NULL, 'Fatty acid synthase signature', NULL, NULL, 'FASYNTHASE', 278488),
(459395, 'PR00293', NULL, 'Squash serine protease inhibitor signature', NULL, NULL, 'SQUASHINHBTR', 278489),
(459396, 'PR01170', NULL, 'Alcohol dehydrogenase related protein signature', NULL, NULL, 'ADHRELATED', 278490),
(459397, 'PR01404', NULL, 'DATP pyrophosphohydrolase signature', NULL, NULL, 'NPPPHYDRLASE', 278491),
(459398, 'PR01938', NULL, 'Interleukin-34 signature', NULL, NULL, 'INTRLEUKIN34', 278492),
(459399, 'PR01640', NULL, 'Plant profilin signature', NULL, NULL, 'PROFILINPLNT', 278493),
(459400, 'PR01055', NULL, 'Metabotropic glutamate receptor 5 signature', NULL, NULL, 'MTABOTROPC5R', 278494),
(459401, 'PR00519', NULL, '5-hydroxytryptamine 5B receptor signature', NULL, NULL, '5HT5BRECEPTR', 278495),
(459402, 'PR00750', NULL, 'Beta-amylase (glycosyl hydrolase family 14) signature', NULL, NULL, 'BETAAMYLASE', 278496),
(459403, 'PR01147', NULL, 'GPR4 sphingosylphosphorylcholine and lysophosphatidylcholine receptor signature', NULL, NULL, 'GPR4RECEPTOR', 278497),
(459404, 'PR00191', NULL, 'F-actin capping protein alpha subunit signature', NULL, NULL, 'FACTINCAPA', 278498),
(459405, 'PR01956', NULL, 'Tumour necrosis factor receptor 10 signature', NULL, NULL, 'TNFACTORR10', 278499),
(459406, 'PR01635', NULL, 'Voltage-dependent L-type calcium channel alpha-1C subunit signature', NULL, NULL, 'LVDCCALPHA1C', 278500),
(459407, 'PR00039', NULL, 'LysR bacterial regulatory protein HTH signature', NULL, NULL, 'HTHLYSR', 278501),
(459408, 'PR01787', NULL, 'Paraoxonase 2 signature', NULL, NULL, 'PARAOXONASE2', 278502),
(459409, 'PR01173', NULL, 'Odour binding protein signature', NULL, NULL, 'ODORANTBNDNG', 278503),
(459410, 'PR01600', NULL, 'Zona occludens protein ZO-3 signature', NULL, NULL, 'ZONOCCLUDNS3', 278504),
(459411, 'PR01647', NULL, 'Transient receptor potential channel 6 signature', NULL, NULL, 'TRPCHANNEL6', 278505),
(459412, 'PR00026', NULL, 'Engrailed homeodomain signature', NULL, NULL, 'ENGRAILED', 278506),
(459413, 'PR01853', NULL, 'Bacterial YajC preprotein translocase signature', NULL, NULL, 'YAJCTRNLCASE', 278507),
(459414, 'PR00199', NULL, 'Annexin type III signature', NULL, NULL, 'ANNEXINIII', 278508),
(459415, 'PR00974', NULL, 'Ribosomal protein S18 family signature', NULL, NULL, 'RIBOSOMALS18', 278509),
(459416, 'PR01454', NULL, 'Epithelial membrane protein EMP-1 signature', NULL, NULL, 'EPMEMPROT1', 278510),
(459417, 'PR00377', NULL, 'Inositol monophosphatase superfamily signature', NULL, NULL, 'IMPHPHTASES', 278511);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(459418, 'PR01516', NULL, 'Kv4.1 voltage-gated K+ channel signature', NULL, NULL, 'KV41CHANNEL', 278512),
(459419, 'PR00548', NULL, 'Hyperglycemic hormone type 1 signature', NULL, NULL, 'HYPRGLYCEMC1', 278513),
(459420, 'PR01605', NULL, 'KCNE voltage-gated K+ channel subfamily E2 signature', NULL, NULL, 'KCNE2CHANNEL', 278514),
(459421, 'PR01531', NULL, 'C-C chemokine receptor type 9 signature', NULL, NULL, 'CHEMOKINER9', 278515),
(459422, 'PR00724', NULL, 'Carboxypeptidase C serine protease (S10) family signature', NULL, NULL, 'CRBOXYPTASEC', 278516),
(459423, 'PR00534', NULL, 'Melanocortin receptor family signature', NULL, NULL, 'MCRFAMILY', 278517),
(459424, 'PR00166', NULL, 'Aromatic amino acid permease signature', NULL, NULL, 'AROAAPRMEASE', 278518),
(459425, 'PR00010', NULL, 'Type II EGF-like signature', NULL, NULL, 'EGFBLOOD', 278519),
(459426, 'PR00238', NULL, 'Opsin signature', NULL, NULL, 'OPSIN', 278520),
(459427, 'PR01116', NULL, 'CLC-5 chloride channel signature', NULL, NULL, 'CLCHANNEL5', 278521),
(459428, 'PR01238', NULL, 'CC24 mitochondrial P450 signature', NULL, NULL, 'MITP450CC24', 278522),
(459429, 'PR01094', NULL, 'Sulphonylurea receptor type 2 family signature', NULL, NULL, 'SULFNYLUR2', 278523),
(459430, 'PR00048', NULL, 'C2H2-type zinc finger signature', NULL, NULL, 'ZINCFINGER', 278524),
(459431, 'PR00354', NULL, '7Fe ferredoxin signature', NULL, NULL, '7FE8SFRDOXIN', 278525),
(459432, 'PR00593', NULL, 'Metabotropic glutamate receptor signature', NULL, NULL, 'MTABOTROPICR', 278526),
(459433, 'PR01591', NULL, 'DNA-binding protein FIS signature', NULL, NULL, 'DNABINDNGFIS', 278527),
(459434, 'PR00134', NULL, 'Glycosyl hydrolase family 10 signature', NULL, NULL, 'GLHYDRLASE10', 278528),
(459435, 'PR01427', NULL, 'Transforming growth factor beta 4 precursor signature', NULL, NULL, 'TGFBETA4', 278529),
(459436, 'PR00996', NULL, 'Glutamate methyltransferase family signature', NULL, NULL, 'CHERMTFRASE', 278530),
(459437, 'PR00027', NULL, 'Paired box signature', NULL, NULL, 'PAIREDBOX', 278531),
(459438, 'PR01110', NULL, 'C-C chemokine receptor type 5 signature', NULL, NULL, 'CHEMOKINER5', 278532),
(459439, 'PR00369', NULL, 'Flavodoxin signature', NULL, NULL, 'FLAVODOXIN', 278533),
(459440, 'PR01965', NULL, 'Tumour necrosis factor receptor 14 signature', NULL, NULL, 'TNFACTORR14', 278534),
(459441, 'PR00132', NULL, 'Glycosyl hydrolase family 2 signature', NULL, NULL, 'GLHYDRLASE2', 278535),
(459442, 'PR00137', NULL, 'Lysozyme signature', NULL, NULL, 'LYSOZYME', 278536),
(459443, 'PR01701', NULL, 'CD164 antigen signature', NULL, NULL, 'CD164ANTIGEN', 278537),
(459444, 'PR00184', NULL, 'Neisseria sp. porin signature', NULL, NULL, 'NEISSPPORIN', 278538),
(459445, 'PR01932', NULL, 'Interleukin-17 signature', NULL, NULL, 'INTRLEUKIN17', 278539),
(459446, 'PR00734', NULL, 'Glycosyl hydrolase family 7 signature', NULL, NULL, 'GLHYDRLASE7', 278540),
(459447, 'PR00602', NULL, 'Barwin domain signature', NULL, NULL, 'BARWIN', 278541),
(459448, 'PR01181', NULL, 'Diaminopimelate decarboxylase signature', NULL, NULL, 'DAPDCRBXLASE', 278542),
(459449, 'PR01390', NULL, 'Clostridial binary toxin A signature', NULL, NULL, 'BINARYTOXINA', 278543),
(459450, 'PR00211', NULL, 'Glutelin signature', NULL, NULL, 'GLUTELIN', 278544),
(459451, 'PR00764', NULL, 'Complement C9 signature', NULL, NULL, 'COMPLEMENTC9', 278545),
(459452, 'PR01143', NULL, 'Follicle stimulating hormone receptor precursor signature', NULL, NULL, 'FSHRECEPTOR', 278546),
(459453, 'PR00167', NULL, 'Calcium channel signature', NULL, NULL, 'CACHANNEL', 278547),
(459454, 'PR01877', NULL, 'Myeloid transforming gene related protein-1 (MTGR1) family signature', NULL, NULL, 'MTGR1PROTEIN', 278548),
(459455, 'PR00418', NULL, 'DNA topoisomerase II family signature', NULL, NULL, 'TPI2FAMILY', 278549),
(459456, 'PR00450', NULL, 'Recoverin family signature', NULL, NULL, 'RECOVERIN', 278550),
(459457, 'PR00856', NULL, 'Prostacyclin (prostanoid IP) receptor signature', NULL, NULL, 'PRSTNOIDIPR', 278551),
(459458, 'PR01489', NULL, 'Gram-negative bacterial RTX toxin-activating protein C signature', NULL, NULL, 'RTXTOXINC', 278552);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(459459, 'PR01769', NULL, 'Vanilloid receptor-like 2 protein (VRL-2) family signature', NULL, NULL, 'VRL2RECEPTOR', 278553),
(459460, 'PR01502', NULL, 'Ubiquitously expressed transcript protein signature', NULL, NULL, 'UXTPROTEIN', 278554),
(459461, 'PR00859', NULL, 'Prokaryote metallothionein signature', NULL, NULL, 'MTPROKARYOTE', 278555),
(459462, 'PR01449', NULL, 'Calcium-activated BK potassium channel alpha subunit signature', NULL, NULL, 'BKCHANNELA', 278556),
(459463, 'PR00884', NULL, 'Ribosomal protein HS6 signature', NULL, NULL, 'RIBOSOMALHS6', 278557),
(459464, 'PR02102', NULL, 'Inhibitor of CDK interacting with cyclin A1 protein signature', NULL, NULL, 'PROTEININCA1', 278558),
(459465, 'PR00977', NULL, 'Scytalidopepsin B aspartic protease (A4) signature', NULL, NULL, 'SCYTLDPTASE', 278559),
(459466, 'PR01503', NULL, 'Treacher Collins syndrome protein Treacle signature', NULL, NULL, 'TREACLE', 278560),
(459467, 'PR00796', NULL, 'Viral spike glycoprotein precursor signature', NULL, NULL, 'SPIKEPROTEIN', 278561),
(459468, 'PR00710', NULL, 'Natriuretic peptide family signature', NULL, NULL, 'NATPEPTIDES', 278562),
(459469, 'PR00567', NULL, 'Dopamine D2 receptor signature', NULL, NULL, 'DOPAMINED2R', 278563),
(459470, 'PR00330', NULL, 'Haemagglutinin HA1 chain signature', NULL, NULL, 'HEMAGGLUTN1', 278564),
(459471, 'PR01736', NULL, 'Phosphoenolpyruvate-protein phosphotransferase signature', NULL, NULL, 'PHPHTRNFRASE', 278565),
(459472, 'PR02035', NULL, 'FPRL1/chemotaxis inhibitory protein signature', NULL, NULL, 'FLIPRCHIPS', 278566),
(459473, 'PR01068', NULL, 'P2Y6 purinoceptor signature', NULL, NULL, 'P2Y6PRNOCPTR', 278567),
(459474, 'PR01607', NULL, 'Apyrase family signature', NULL, NULL, 'APYRASEFAMLY', 278568),
(459475, 'PR02030', NULL, 'Autophagy-related protein 14 signature', NULL, NULL, 'AUTOPHGYRP14', 278569),
(459476, 'PR00015', NULL, 'Gram-positive coccus surface protein anchor signature', NULL, NULL, 'GPOSANCHOR', 278570),
(459477, 'PR02100', NULL, 'Radiation-inducible immediate-early gene IEX-1 signature', NULL, NULL, 'GENEIEX1', 278571),
(459478, 'PR00955', NULL, 'Flagellar motor switch protein FliM signature', NULL, NULL, 'FLGMOTORFLIM', 278572),
(459479, 'PR00899', NULL, 'Fungal pheromone STE3 GPCR signature', NULL, NULL, 'GPCRSTE3', 278573),
(459480, 'PR01062', NULL, 'Melanocortin 4 receptor signature', NULL, NULL, 'MELNOCORTN4R', 278574),
(459481, 'PR00363', NULL, 'Cytochrome B5 signature', NULL, NULL, 'CYTOCHROMEB5', 278575),
(459482, 'PR01363', NULL, 'Viral protein D9 signature', NULL, NULL, 'VD09PROTEIN', 278576),
(459483, 'PR00957', NULL, 'Gene 66 (IR5) protein signature', NULL, NULL, 'GENE66', 278577),
(459484, 'PR00778', NULL, 'Bacterial regulatory protein ArsR family signature', NULL, NULL, 'HTHARSR', 278578),
(459485, 'PR00933', NULL, 'B-lytic metalloendopeptidase (M23) signature', NULL, NULL, 'BLYTICPTASE', 278579),
(459486, 'PR00326', NULL, 'GTP1/OBG GTP-binding protein family signature', NULL, NULL, 'GTP1OBG', 278580),
(459487, 'PR01248', NULL, 'Type I keratin signature', NULL, NULL, 'TYPE1KERATIN', 278581),
(459488, 'PR01340', NULL, 'Salmonella virulence plasmid 28.1kDa A protein signature', NULL, NULL, 'SALSPVAPROT', 278582),
(459489, 'PR00909', NULL, 'Bacterial periplasmic spermidine/putrescine-binding protein signature', NULL, NULL, 'SPERMDNBNDNG', 278583),
(459490, 'PR01476', NULL, 'Leukotriene B4 receptor signature', NULL, NULL, 'LTBRECEPTOR', 278584),
(459491, 'PR01113', NULL, 'CLC-2 chloride channel signature', NULL, NULL, 'CLCHANNEL2', 278585),
(459492, 'PR01138', NULL, 'Gap junction beta-1 protein (Cx32) signature', NULL, NULL, 'CONNEXINB1', 278586),
(459493, 'PR01661', NULL, 'Mini-chromosome maintenance (MCM) protein 5 signature', NULL, NULL, 'MCMPROTEIN5', 278587),
(459494, 'PR01100', NULL, 'Shikimate kinase family signature', NULL, NULL, 'SHIKIMTKNASE', 278588),
(459495, 'PR01527', NULL, 'Lysophosphatidic acid receptor family signature', NULL, NULL, 'LPARECEPTOR', 278589),
(459496, 'PR00810', NULL, 'Bacterial general secretion pathway protein C signature', NULL, NULL, 'BCTERIALGSPC', 278590);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(459497, 'PR01562', NULL, 'Fractalkine receptor signature', NULL, NULL, 'FRACTALKINER', 278591),
(459498, 'PR00250', NULL, 'Fungal pheromone mating factor STE2 GPCR signature', NULL, NULL, 'GPCRSTE2', 278592),
(459499, 'PR01764', NULL, 'MAP kinase phosphatase signature', NULL, NULL, 'MAPKPHPHTASE', 278593),
(459500, 'PR00894', NULL, 'Yeast Mrs6p protein signature', NULL, NULL, 'YEASTMRS6P', 278594),
(459501, 'PR01168', NULL, 'Insect alcohol dehydrogenase signature', NULL, NULL, 'ALCDHDRGNASE', 278595),
(459502, 'PR00146', NULL, 'Dihydrodipicolinate synthase signature', NULL, NULL, 'DHPICSNTHASE', 278596),
(459503, 'PR00916', NULL, '2C endopeptidase (C24) cysteine protease family signature', NULL, NULL, '2CENDOPTASE', 278597),
(459504, 'PR00196', NULL, 'Annexin family signature', NULL, NULL, 'ANNEXIN', 278598),
(459505, 'PR00046', NULL, 'Major sigma-70 factor signature', NULL, NULL, 'SIGMA70FCT', 278599),
(459506, 'PR01001', NULL, 'FAD-dependent glycerol-3-phosphate dehydrogenase family signature', NULL, NULL, 'FADG3PDH', 278600),
(459507, 'PR00021', NULL, 'Small proline-rich protein signature', NULL, NULL, 'PRORICH', 278601),
(459508, 'PR00738', NULL, 'Glycosyl hydrolase family 20 signature', NULL, NULL, 'GLHYDRLASE20', 278602),
(459509, 'PR00805', NULL, 'Alpha-catenin signature', NULL, NULL, 'ALPHACATENIN', 278603),
(459510, 'PR00349', NULL, 'Virion infectivity factor signature', NULL, NULL, 'VIRIONINFFCT', 278604),
(459511, 'PR01434', NULL, 'NADH-ubiquinone oxidoreductase chain 5 signature', NULL, NULL, 'NADHDHGNASE5', 278605),
(459512, 'PR00705', NULL, 'Papain cysteine protease (C1) family signature', NULL, NULL, 'PAPAIN', 278606),
(459513, 'PR01487', NULL, 'Bacterial autoinducer-2 (AI-2) production protein LuxS signature', NULL, NULL, 'LUXSPROTEIN', 278607),
(459514, 'PR01894', NULL, 'Wnt-14 protein signature', NULL, NULL, 'WNT14PROTEIN', 278608),
(459515, 'PR01830', NULL, 'Trace amine receptor signature', NULL, NULL, 'TRACEAMINER', 278609),
(459516, 'PR00699', NULL, 'C.elegans integral membrane protein Srb signature', NULL, NULL, 'TMPROTEINSRB', 278610),
(459517, 'PR00787', NULL, 'Streptomyces extracellular neutral proteinase (M7) family signature', NULL, NULL, 'NEUTRALPTASE', 278611),
(459518, 'PR01550', NULL, 'DNA topoisomerase VI subunit A family signature', NULL, NULL, 'TOP6AFAMILY', 278612),
(459519, 'PR01844', NULL, 'Wnt-4 protein signature', NULL, NULL, 'WNT4PROTEIN', 278613),
(459520, 'PR00992', NULL, 'Alanine racemase signature', NULL, NULL, 'ALARACEMASE', 278614),
(459521, 'PR01424', NULL, 'Transforming growth factor beta 1 precursor signature', NULL, NULL, 'TGFBETA1', 278615),
(459522, 'PR00253', NULL, 'Gamma-aminobutyric acid A (GABAA) receptor signature', NULL, NULL, 'GABAARECEPTR', 278616),
(459523, 'PR00462', NULL, 'Fungal lignin peroxidase family signature', NULL, NULL, 'LIGNINASE', 278617),
(459524, 'PR01225', NULL, 'Expansin/Lol pI family signature', NULL, NULL, 'EXPANSNFAMLY', 278618),
(459525, 'PR01187', NULL, 'Anion exchanger isoform 1 signature', NULL, NULL, 'ANIONEXHNGR1', 278619),
(459526, 'PR01771', NULL, 'ERK3/4 MAP kinase signature', NULL, NULL, 'ERK3ERK4MAPK', 278620),
(459527, 'PR01670', NULL, 'Gamma-aminobutyric-acid A (GABAA) receptor rho subunit signature', NULL, NULL, 'GABAARRHO', 278621),
(459528, 'PR00618', NULL, 'DksA/TraR zinc finger signature', NULL, NULL, 'DKSAZNFINGER', 278622),
(459529, 'PR02034', NULL, 'Liver X receptor signature', NULL, NULL, 'LIVERXRECPTR', 278623),
(459530, 'PR01974', NULL, 'Tumour necrosis factor receptor 11A signature', NULL, NULL, 'TNFACTORR11A', 278624),
(459531, 'PR01987', NULL, 'Neurogenic locus Notch protein 4 signature', NULL, NULL, 'NOTCH4', 278625),
(459532, 'PR00617', NULL, 'Copper fist domain signature', NULL, NULL, 'COPPERFIST', 278626),
(459533, 'PR00837', NULL, 'Allergen V5/Tpx-1 family signature', NULL, NULL, 'V5TPXLIKE', 278627),
(459534, 'PR00912', NULL, 'Luteovirus ORF5 VPG protein signature', NULL, NULL, 'LVIRUSORF5', 278628),
(459535, 'PR01976', NULL, 'Insulin-like growth factor-binding protein family signature', NULL, NULL, 'IGFBPFAMILY', 278629);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(459536, 'PR01106', NULL, 'C-C chemokine receptor type 1 signature', NULL, NULL, 'CHEMOKINER1', 278630),
(459537, 'PR01342', NULL, 'Salmonella virulence-associated 28kDa protein signature', NULL, NULL, 'SALVRPPROT', 278631),
(459538, 'PR01522', NULL, 'Orexin receptor type 2 signature', NULL, NULL, 'OREXIN2R', 278632),
(459539, 'PR01247', NULL, 'Rec1 exonuclease signature', NULL, NULL, 'RECEXONCLASE', 278633),
(459540, 'PR00552', NULL, 'Adenosine A1 receptor signature', NULL, NULL, 'ADENOSINEA1R', 278634),
(459541, 'PR00722', NULL, 'Chymotrypsin serine protease family (S1) signature', NULL, NULL, 'CHYMOTRYPSIN', 278635),
(459542, 'PR01579', NULL, 'KCNAB voltage-gated K+ channel beta-2 subunit signature', NULL, NULL, 'KCNAB2CHANEL', 278636),
(459543, 'PR01102', NULL, '5-hydroxytryptamine 6 receptor signature', NULL, NULL, '5HT6RECEPTR', 278637),
(459544, 'PR00806', NULL, 'Vinculin signature', NULL, NULL, 'VINCULIN', 278638),
(459545, 'PR01687', NULL, 'CYP2E P450 family signature', NULL, NULL, 'EP450ICYP2E', 278639),
(459546, 'PR01383', NULL, 'Claudin-10 signature', NULL, NULL, 'CLAUDIN10', 278640),
(459547, 'PR01824', NULL, 'Janus kinase 1 (JAK1) signature', NULL, NULL, 'JANUSKINASE1', 278641),
(459548, 'PR00149', NULL, 'Fumarate lyase superfamily signature', NULL, NULL, 'FUMRATELYASE', 278642),
(459549, 'PR01929', NULL, 'Interleukin-13 signature', NULL, NULL, 'INTRLEUKIN13', 278643),
(459550, 'PR00124', NULL, 'ATP synthase C subunit signature', NULL, NULL, 'ATPASEC', 278644),
(459551, 'PR00793', NULL, 'Prolyl aminopeptidase (S33) family signature', NULL, NULL, 'PROAMNOPTASE', 278645),
(459552, 'PR00440', NULL, 'G protein alpha subunit group 12 signature', NULL, NULL, 'GPROTEINA12', 278646),
(459553, 'PR02043', NULL, 'Cancer susceptibility candidate protein 1 signature', NULL, NULL, 'CANCERSCCP1', 278647),
(459554, 'PR00907', NULL, 'Thrombomodulin signature', NULL, NULL, 'THRMBOMODULN', 278648),
(459555, 'PR01046', NULL, 'Prolyl-tRNA synthetase signature', NULL, NULL, 'TRNASYNTHPRO', 278649),
(459556, 'PR01765', NULL, 'Epithelial calcium channel (ECAC) family signature', NULL, NULL, 'ECACCHANNEL', 278650),
(459557, 'PR00792', NULL, 'Pepsin (A1) aspartic protease family signature', NULL, NULL, 'PEPSIN', 278651),
(459558, 'PR00673', NULL, 'Light harvesting protein A chain signature', NULL, NULL, 'LIGHTHARVSTA', 278652),
(459559, 'PR01136', NULL, 'Gap junction alpha-6 protein (Cx45) signature', NULL, NULL, 'CONNEXINA6', 278653),
(459560, 'PR00588', NULL, 'Somatostatin receptor type 2 signature', NULL, NULL, 'SOMATOSTTN2R', 278654),
(459561, 'PR01803', NULL, 'Trypanosome sialidase signature', NULL, NULL, 'TCSIALIDASE', 278655),
(459562, 'PR01553', NULL, 'Type IV secretion system CagA exotoxin signature', NULL, NULL, 'TYPE4SSCAGA', 278656),
(459563, 'PR00340', NULL, 'P-II protein signature', NULL, NULL, 'PIIGLNB', 278657),
(459564, 'PR00459', NULL, 'Plant ascorbate peroxidase signature', NULL, NULL, 'ASPEROXIDASE', 278658),
(459565, 'PR01865', NULL, 'Bcl-W apoptosis regulator protein signature', NULL, NULL, 'APOPREGBCLW', 278659),
(459566, 'PR01199', NULL, 'Creatine transporter signature', NULL, NULL, 'CRTTRANSPORT', 278660),
(459567, 'PR00826', NULL, 'Fanconi anaemia group A protein signature', NULL, NULL, 'FANCONIAGENE', 278661),
(459568, 'PR01019', NULL, 'LPP20 lipoprotein precursor signature', NULL, NULL, 'LIPOLPP20', 278662),
(459569, 'PR01906', NULL, 'Lamprey and hagfish globin signature', NULL, NULL, 'FISHGLOBIN', 278663),
(459570, 'PR00557', NULL, 'Alpha-1A adrenergic receptor signature', NULL, NULL, 'ADRENRGCA1AR', 278664),
(459571, 'PR01510', NULL, 'Kv1.3 voltage-gated K+ channel signature', NULL, NULL, 'KV13CHANNEL', 278665),
(459572, 'PR01805', NULL, 'VacJ lipoprotein signature', NULL, NULL, 'VACJLIPOPROT', 278666),
(459573, 'PR01319', NULL, 'Glial cell line-derived neurotrophic factor receptor alpha 3 signature', NULL, NULL, 'GDNFRALPHA3', 278667),
(459574, 'PR01797', NULL, 'Saposin signature', NULL, NULL, 'SAPOSIN', 278668),
(459575, 'PR00052', NULL, 'Fibrillarin signature', NULL, NULL, 'FIBRILLARIN', 278669);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(459576, 'PR00998', NULL, 'Carboxypeptidase Taq (M32) metallopeptidase signature', NULL, NULL, 'CRBOXYPTASET', 278670),
(459577, 'PR00772', NULL, 'Heat labile enterotoxin B chain signature', NULL, NULL, 'ENTEROTOXINB', 278671),
(459578, 'PR00708', NULL, 'Alpha-1-acid glycoprotein signature', NULL, NULL, 'A1AGLPROTEIN', 278672),
(459579, 'PR00135', NULL, 'Lysozyme/alpha-lactalbumin superfamily signature', NULL, NULL, 'LYZLACT', 278673),
(459580, 'PR00642', NULL, 'EDG-1 sphingosine 1-phosphate receptor signature', NULL, NULL, 'EDG1RECEPTOR', 278674),
(459581, 'PR01223', NULL, 'Bride of sevenless protein signature', NULL, NULL, 'BRIDEOF7LESS', 278675),
(459582, 'PR02096', NULL, 'Hydroxyacyl-thioester dehydratase type 2 (mitochondrial) signature', NULL, NULL, 'HTDHYDRTASE2', 278676),
(459583, 'PR01524', NULL, 'EDG-3 sphingosine 1-phosphate receptor signature', NULL, NULL, 'EDG3RECEPTOR', 278677),
(459584, 'PR00994', NULL, 'B2 bradykinin receptor signature', NULL, NULL, 'BRADYKINNB2R', 278678),
(459585, 'PR02088', NULL, 'HAUS augmin-like complex subunit 2 signature', NULL, NULL, 'HAUSAUGMINL2', 278679),
(459586, 'PR02008', NULL, 'RNA (C5-cytosine) methyltransferase signature', NULL, NULL, 'RCMTFAMILY', 278680),
(459587, 'PR00742', NULL, 'Glycosyl hydrolase family 35 signature', NULL, NULL, 'GLHYDRLASE35', 278681),
(459588, 'PR02098', NULL, 'Hydrolethalus syndrome protein 1 signature', NULL, NULL, 'HYLETHALUSS1', 278682),
(459589, 'PR01332', NULL, 'Kir6.2 inward rectifier K+ channel signature', NULL, NULL, 'KIR62CHANNEL', 278683),
(459590, 'PR01945', NULL, 'Interleukin-11A signature', NULL, NULL, 'IL11AFISH', 278684),
(459591, 'PR01004', NULL, 'Flagellar FliJ protein signature', NULL, NULL, 'FLGFLIJ', 278685),
(459592, 'PR00662', NULL, 'Glucose-6-phosphate isomerase signature', NULL, NULL, 'G6PISOMERASE', 278686),
(459593, 'PR00086', NULL, 'L-lactate dehydrogenase signature', NULL, NULL, 'LLDHDRGNASE', 278687),
(459594, 'PR00509', NULL, 'Phosphoglucomutase/phosphomannomutase family signature', NULL, NULL, 'PGMPMM', 278688),
(459595, 'PR00815', NULL, 'Pi haemoglobin signature', NULL, NULL, 'PIHAEM', 278689),
(459596, 'PR00164', NULL, 'ABC-2 type transport system membrane protein signature', NULL, NULL, 'ABC2TRNSPORT', 278690),
(459597, 'PR00616', NULL, 'CCAAT-binding transcription factor subunit B signature', NULL, NULL, 'CCAATSUBUNTB', 278691),
(459598, 'PR00473', NULL, 'Galactokinase signature', NULL, NULL, 'GALCTOKINASE', 278692),
(459599, 'PR00883', NULL, 'High mobility group-like nuclear protein signature', NULL, NULL, 'NUCLEARHMG', 278693),
(459600, 'PR01777', NULL, 'Interferon-gamma receptor alpha chain signature', NULL, NULL, 'INTERFERONGR', 278694),
(459601, 'PR00343', NULL, 'Selectin superfamily complement-binding repeat signature', NULL, NULL, 'SELECTIN', 278695),
(459602, 'PR00508', NULL, 'S21 class N4 adenine-specific DNA methyltransferase signature', NULL, NULL, 'S21N4MTFRASE', 278696),
(459603, 'PR01264', NULL, 'Bacterial mechano-sensitive ion channel signature', NULL, NULL, 'MECHCHANNEL', 278697),
(459604, 'PR00821', NULL, 'Triacylglycerol lipase family signature', NULL, NULL, 'TAGLIPASE', 278698),
(459605, 'PR01341', NULL, 'Salmonella virulence plasmid 65kDa B protein signature', NULL, NULL, 'SALSPVBPROT', 278699),
(459606, 'PR01741', NULL, 'Septin 3 signature', NULL, NULL, 'SEPTIN3', 278700),
(459607, 'PR01546', NULL, 'Saccharomyces cerevisiae 73.5kDa hypothetical protein signature', NULL, NULL, 'YEAST73DUF', 278701),
(459608, 'PR00784', NULL, 'Mitochondrial brown fat uncoupling protein signature', NULL, NULL, 'MTUNCOUPLING', 278702),
(459609, 'PR00876', NULL, 'Nematode metallothionein signature', NULL, NULL, 'MTNEMATODE', 278703),
(459610, 'PR02031', NULL, 'Cysteine/serine-rich nuclear protein (CSRNP) family signature', NULL, NULL, 'CYSSERRICHNP', 278704),
(459611, 'PR00236', NULL, 'Herpesvirus capsid protein P40 signature', NULL, NULL, 'HSVCAPSIDP40', 278705),
(459612, 'PR01779', NULL, 'Lantibiotic leader peptide processing protein signature', NULL, NULL, 'LANTIPROCESS', 278706);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(459613, 'PR01652', NULL, 'Bacterial cell shape determinant MreB/Mbl protein signature', NULL, NULL, 'SHAPEPROTEIN', 278707),
(459614, 'PR01841', NULL, 'Wnt-1 protein signature', NULL, NULL, 'WNT1PROTEIN', 278708),
(459615, 'PR00731', NULL, 'Cauliflower mosaic virus peptidase (A3) signature', NULL, NULL, 'CAULIMOPTASE', 278709),
(459616, 'PR01137', NULL, 'Gap junction alpha-8 protein (Cx50) signature', NULL, NULL, 'CONNEXINA8', 278710),
(459617, 'PR01464', NULL, 'EAG potassium channel signature', NULL, NULL, 'EAGCHANNEL', 278711),
(459618, 'PR01132', NULL, 'Gap junction alpha-1 protein (Cx43) signature', NULL, NULL, 'CONNEXINA1', 278712),
(459619, 'PR00693', NULL, 'Granulocyte-macrophage colony-stimulating factor signature', NULL, NULL, 'GMCSFACTOR', 278713),
(459620, 'PR01324', NULL, 'Kir2.1 inward rectifier K+ channel signature', NULL, NULL, 'KIR21CHANNEL', 278714),
(459621, 'PR01179', NULL, 'Ornithine/diaminopimelate/arginine (ODA) decarboxylase family signature', NULL, NULL, 'ODADCRBXLASE', 278715),
(459622, 'PR01761', NULL, 'Dishevelled-1 protein signature', NULL, NULL, 'DISHEVELLED1', 278716),
(459623, 'PR01618', NULL, 'Gamma-aminobutyric-acid A receptor alpha 5 subunit signature', NULL, NULL, 'GABAARALPHA5', 278717),
(459624, 'PR01254', NULL, 'Prostaglandin D synthase signature', NULL, NULL, 'PGNDSYNTHASE', 278718),
(459625, 'PR00782', NULL, 'Leishmanolysin (M8) metalloprotease family signature', NULL, NULL, 'LSHMANOLYSIN', 278719),
(459626, 'PR01625', NULL, 'Omega-class glutathione S-transferase signature', NULL, NULL, 'GSTRNSFRASEO', 278720),
(459627, 'PR00336', NULL, 'Lysosome-associated membrane glycoprotein signature', NULL, NULL, 'LYSASSOCTDMP', 278721),
(459628, 'PR00396', NULL, 'Ribosome inactivating protein family signature', NULL, NULL, 'SHIGARICIN', 278722),
(459629, 'PR02006', NULL, 'Insulin-like growth factor II signature', NULL, NULL, 'INSLNLIKEGF2', 278723),
(459630, 'PR02078', NULL, 'GATS-like protein family signature', NULL, NULL, 'GATSLIKEFMLY', 278724),
(459631, 'PR01969', NULL, 'Tumour necrosis factor receptor 19 signature', NULL, NULL, 'TNFACTORR19', 278725),
(459632, 'PR00666', NULL, 'Pineal opsin signature', NULL, NULL, 'PINOPSIN', 278726),
(459633, 'PR01293', NULL, 'Nuclear receptor ROR family signature', NULL, NULL, 'RORNUCRECPTR', 278727),
(459634, 'PR01288', NULL, 'Peroxisome proliferator-activated receptor (1C nuclear receptor) signature', NULL, NULL, 'PROXISOMEPAR', 278728),
(459635, 'PR01672', NULL, 'Gamma-aminobutyric-acid A (GABAA) receptor rho 2 subunit signature', NULL, NULL, 'GABAARRHO2', 278729),
(459636, 'PR00812', NULL, 'Bacterial general secretion pathway protein F signature', NULL, NULL, 'BCTERIALGSPF', 278730),
(459637, 'PR01505', NULL, 'Prothrombin signature', NULL, NULL, 'PROTHROMBIN', 278731),
(459638, 'PR01669', NULL, 'Tapasin signature', NULL, NULL, 'TAPASIN', 278732),
(459639, 'PR00359', NULL, 'B-class P450 signature', NULL, NULL, 'BP450', 278733),
(459640, 'PR00938', NULL, 'Brachyury protein family signature', NULL, NULL, 'BRACHYURY', 278734),
(459641, 'PR01678', NULL, 'Kir5 inward rectifier K+ channel signature', NULL, NULL, 'KIR5CHANNEL', 278735),
(459642, 'PR01957', NULL, 'CYP2F P450 family signature', NULL, NULL, 'EP450ICYP2F', 278736),
(459643, 'PR01079', NULL, 'Gamma-aminobutyric-acid A receptor alpha subunit signature', NULL, NULL, 'GABAARALPHA', 278737),
(459644, 'PR00220', NULL, 'Synaptophysin/synaptoporin family signature', NULL, NULL, 'SYNAPTOPHYSN', 278738),
(459645, 'PR00573', NULL, 'Interleukin 8B receptor signature', NULL, NULL, 'INTRLEUKN8BR', 278739),
(459646, 'PR02012', NULL, 'RNA (C5-cytosine) methyltransferase NOP2 subfamily signature', NULL, NULL, 'RCMTNOP2', 278740),
(459647, 'PR01194', NULL, 'Fructose transporter (GLUT5) signature', NULL, NULL, 'GLUCTRSPORT5', 278741),
(459648, 'PR02110', NULL, 'Mas-related G protein-coupled receptor D signature', NULL, NULL, 'MRGPCRD', 278742),
(459649, 'PR01412', NULL, 'Cytochrome c-type biogenesis protein CcbS signature', NULL, NULL, 'CCBSBIOGNSIS', 278743),
(459650, 'PR00979', NULL, 'Tafazzin signature', NULL, NULL, 'TAFAZZIN', 278744);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(459651, 'PR02007', NULL, 'Pheromone-binding protein Gp-9 signature', NULL, NULL, 'ODORANTBPGP9', 278745),
(459652, 'PR00351', NULL, 'MAS20 (TOM20) import receptor subunit signature', NULL, NULL, 'OM20RECEPTOR', 278746),
(459653, 'PR02013', NULL, 'Aquaporin-1 signature', NULL, NULL, 'AQUAPORIN1', 278747),
(459654, 'PR00846', NULL, 'Glycosyl hydrolase family 56 signature', NULL, NULL, 'GLHYDRLASE56', 278748),
(459655, 'PR00768', NULL, 'Deuterolysin metalloprotease (M35) family signature', NULL, NULL, 'DEUTEROLYSIN', 278749),
(459656, 'PR01049', NULL, 'Phosphorylase kinase family signature', NULL, NULL, 'PHOSPHBKNASE', 278750),
(459657, 'PR01848', NULL, 'U2 auxiliary factor small subunit signature', NULL, NULL, 'U2AUXFACTOR', 278751),
(459658, 'PR01766', NULL, 'Epithelial calcium channel 1 (ECAC1) family signature', NULL, NULL, 'ECACCHANNEL1', 278752),
(459659, 'PR00623', NULL, 'Histone H4 signature', NULL, NULL, 'HISTONEH4', 278753),
(459660, 'PR01123', NULL, 'Flavin-containing monooxygenase (FMO) 3 signature', NULL, NULL, 'FMOXYGENASE3', 278754),
(459661, 'PR01488', NULL, 'Gram-negative bacterial RTX toxin determinant A family signature', NULL, NULL, 'RTXTOXINA', 278755),
(459662, 'PR02101', NULL, 'Immunogenic miracidial antigen 8I'' signature', NULL, NULL, 'A8IMIRACIDIA', 278756),
(459663, 'PR01711', NULL, 'Autoimmune regulator (AIRE) signature', NULL, NULL, 'AIREGULATOR', 278757),
(459664, 'PR01858', NULL, 'ADAM-TS1 protein signature', NULL, NULL, 'ADAMTS1', 278758),
(459665, 'PR00848', NULL, 'Sperm surface protein PH20 signature', NULL, NULL, 'SPERMPH20', 278759),
(459666, 'PR00309', NULL, 'Arrestin signature', NULL, NULL, 'ARRESTIN', 278760),
(459667, 'PR02040', NULL, 'Cyclin-dependent kinase 2-interacting protein signature', NULL, NULL, 'CDK2IP', 278761),
(459668, 'PR00120', NULL, 'H+-transporting ATPase (proton pump) signature', NULL, NULL, 'HATPASE', 278762),
(459669, 'PR01035', NULL, 'Tetracycline resistance protein signature', NULL, NULL, 'TCRTETA', 278763),
(459670, 'PR01355', NULL, 'Glucagon-like peptide 1 receptor signature', NULL, NULL, 'GLUCAGNLIKER', 278764),
(459671, 'PR01443', NULL, 'Transcription initiation factor TFIID 23-30kDa subunit signature', NULL, NULL, 'TFIID30KDSUB', 278765),
(459672, 'PR00012', NULL, 'Fibronectin type I repeat signature', NULL, NULL, 'FNTYPEI', 278766),
(459673, 'PR00209', NULL, 'Alpha/beta gliadin family signature', NULL, NULL, 'GLIADIN', 278767),
(459674, 'PR00595', NULL, 'P2Y1 purinoceptor signature', NULL, NULL, 'P2Y1PRNOCPTR', 278768),
(459675, 'PR01995', NULL, 'UPF0595 uncharacterised protein signature', NULL, NULL, 'UPF0595', 278769),
(459676, 'PR01584', NULL, 'TASK-1 K+ channel signature', NULL, NULL, 'TASK1CHANNEL', 278770),
(459677, 'PR00761', NULL, 'Bindin precursor signature', NULL, NULL, 'BINDIN', 278771),
(459678, 'PR02064', NULL, 'Downstream neighbour of Son (DONSON) protein signature', NULL, NULL, 'DONSON', 278772),
(459679, 'PR00555', NULL, 'Adenosine A3 receptor signature', NULL, NULL, 'ADENOSINEA3R', 278773),
(459680, 'PR01653', NULL, 'Translationally controlled tumour protein signature', NULL, NULL, 'TCTPROTEIN', 278774),
(459681, 'PR00034', NULL, 'CRP bacterial regulatory protein HTH signature', NULL, NULL, 'HTHCRP', 278775),
(459682, 'PR01075', NULL, 'C.elegans Sel-12 (presenilin) signature', NULL, NULL, 'PRESENILNSEL', 278776),
(459683, 'PR01728', NULL, 'KiSS-1 peptide receptor signature', NULL, NULL, 'KISS1RECEPTR', 278777),
(459684, 'PR00095', NULL, 'Anthranilate synthase component I signature', NULL, NULL, 'ANTSNTHASEI', 278778),
(459685, 'PR01382', NULL, 'Claudin-9 signature', NULL, NULL, 'CLAUDIN9', 278779),
(459686, 'PR00054', NULL, 'Fungal Zn-Cys binuclear cluster signature', NULL, NULL, 'FUNGALZNCYS', 278780),
(459687, 'PR00769', NULL, 'Diphtheria toxin signature', NULL, NULL, 'DPTHRIATOXIN', 278781),
(459688, 'PR01291', NULL, 'Peroxisome proliferator-activated receptor gamma signature', NULL, NULL, 'PROXISOMPAGR', 278782),
(459689, 'PR01091', NULL, 'Prepro-orexin signature', NULL, NULL, 'OREXINPP', 278783),
(459690, 'PR00076', NULL, '6-phosphogluconate dehydrogenase signature', NULL, NULL, '6PGDHDRGNASE', 278784);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(459691, 'PR01182', NULL, 'Ornithine decarboxylase signature', NULL, NULL, 'ORNDCRBXLASE', 278785),
(459692, 'PR00817', NULL, 'Beta-type calcitonin signature', NULL, NULL, 'CALCITONINB', 278786),
(459693, 'PR01493', NULL, 'Kv8 potassium channel alpha subunit signature', NULL, NULL, 'KV8CHANNEL', 278787),
(459694, 'PR01730', NULL, 'Macrophage infectivity potentiator signature', NULL, NULL, 'INFPOTNTIATR', 278788),
(459695, 'PR01192', NULL, 'Glucose transporter type 3 (GLUT3) signature', NULL, NULL, 'GLUCTRSPORT3', 278789),
(459696, 'PR00580', NULL, 'Prostanoid EP1 receptor signature', NULL, NULL, 'PRSTNOIDEP1R', 278790),
(459697, 'PR01760', NULL, 'Dishevelled protein signature', NULL, NULL, 'DISHEVELLED', 278791),
(459698, 'PR01021', NULL, 'OMPA domain signature', NULL, NULL, 'OMPADOMAIN', 278792),
(459699, 'PR00126', NULL, 'ATP synthase gamma subunit signature', NULL, NULL, 'ATPASEGAMMA', 278793),
(459700, 'PR00648', NULL, 'GPR3 orphan receptor signature', NULL, NULL, 'GPR3ORPHANR', 278794),
(459701, 'PR00976', NULL, 'Ribosomal protein S21 family signature', NULL, NULL, 'RIBOSOMALS21', 278795),
(459702, 'PR01705', NULL, 'Thrombospondin type 1 repeat signature', NULL, NULL, 'TSP1REPEAT', 278796),
(459703, 'PR01882', NULL, 'Lysin signature', NULL, NULL, 'LYSIN', 278797),
(459704, 'PR01810', NULL, 'Annexin type XI signature', NULL, NULL, 'ANNEXINXI', 278798),
(459705, 'PR01389', NULL, 'Cytolethal distending toxin C signature', NULL, NULL, 'CDTOXINC', 278799),
(459706, 'PR01422', NULL, 'GPR56 orphan receptor signature', NULL, NULL, 'GPR56ORPHANR', 278800),
(459707, 'PR01086', NULL, 'Na+/H+ exchanger isoform 2 (NHE2) signature', NULL, NULL, 'NAHEXCHNGR2', 278801),
(459708, 'PR01460', NULL, 'KCNQ1 voltage-gated potassium channel signature', NULL, NULL, 'KCNQ1CHANNEL', 278802),
(459709, 'PR01756', NULL, 'Yersinia outer membrane adhesin signature', NULL, NULL, 'OMADHESIN', 278803),
(459710, 'PR00109', NULL, 'Tyrosine kinase catalytic domain signature', NULL, NULL, 'TYRKINASE', 278804),
(459711, 'PR01811', NULL, 'Annexin type XIII signature', NULL, NULL, 'ANNEXINXIII', 278805),
(459712, 'PR00688', NULL, 'Xylose isomerase signature', NULL, NULL, 'XYLOSISMRASE', 278806),
(459713, 'PR01272', NULL, 'Acetoin utilisation ACUC protein signature', NULL, NULL, 'ACUCPROTEIN', 278807),
(459714, 'PR01459', NULL, 'KCNQ voltage-gated potassium channel family signature', NULL, NULL, 'KCNQCHANNEL', 278808),
(459715, 'PR01336', NULL, 'Chlamydia cysteine-rich outer membrane protein 6 signature', NULL, NULL, 'CHLAMIDIAOM6', 278809),
(459716, 'PR00551', NULL, '2-S globulin family signature', NULL, NULL, '2SGLOBULIN', 278810),
(459717, 'PR00503', NULL, 'Bromodomain signature', NULL, NULL, 'BROMODOMAIN', 278811),
(459718, 'PR01052', NULL, 'Metabotropic glutamate receptor 2 signature', NULL, NULL, 'MTABOTROPC2R', 278812),
(459719, 'PR01902', NULL, 'Cysteinyl leukotriene receptor 1 signature', NULL, NULL, 'CYSLT1RECPTR', 278813),
(459720, 'PR01208', NULL, 'Na-K-Cl co-transporter 1 signature', NULL, NULL, 'NAKCLTRSPRT1', 278814),
(459721, 'PR00594', NULL, 'P2Y2 purinoceptor signature', NULL, NULL, 'P2Y2PRNOCPTR', 278815),
(459722, 'PR00387', NULL, '3''5''-cyclic nucleotide phosphodiesterase signature', NULL, NULL, 'PDIESTERASE1', 278816),
(459723, 'PR01715', NULL, 'Ferrichrome-binding periplasmic protein signature', NULL, NULL, 'FERRIBNDNGPP', 278817),
(459724, 'PR01249', NULL, 'Ribosomal protein L31 signature', NULL, NULL, 'RIBOSOMALL31', 278818),
(459725, 'PR00867', NULL, 'DNA-polymerase gamma (family A) signature', NULL, NULL, 'DNAPOLG', 278819),
(459726, 'PR01041', NULL, 'Methionyl-tRNA synthetase signature', NULL, NULL, 'TRNASYNTHMET', 278820),
(459727, 'PR01601', NULL, 'Voltage-dependent calcium channel gamma-1 subunit signature', NULL, NULL, 'VDCCGAMMA1', 278821),
(459728, 'PR01780', NULL, 'Lantibiotic regulatory protein signature', NULL, NULL, 'LANTIREGPROT', 278822),
(459729, 'PR01064', NULL, 'Orexin receptor signature', NULL, NULL, 'OREXINR', 278823),
(459730, 'PR02111', NULL, 'Mas-related G protein-coupled receptor E signature', NULL, NULL, 'MRGPCRE', 278824);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(459731, 'PR01186', NULL, 'Integrin beta subunit signature', NULL, NULL, 'INTEGRINB', 278825),
(459732, 'PR01214', NULL, 'Gamma-synuclein signature', NULL, NULL, 'GSYNUCLEIN', 278826),
(459733, 'PR01477', NULL, 'Leukotriene B4 type 1 receptor signature', NULL, NULL, 'LTB1RECEPTOR', 278827),
(459734, 'PR00842', NULL, 'Plant beta-amylase signature', NULL, NULL, 'GLHYDLASE14B', 278828),
(459735, 'PR01724', NULL, 'Gamma-aminobutyric-acid A receptor pi subunit signature', NULL, NULL, 'GABAARPI', 278829),
(459736, 'PR00545', NULL, 'Retinoid X receptor signature', NULL, NULL, 'RETINOIDXR', 278830),
(459737, 'PR00319', NULL, 'Beta G protein (transducin) signature', NULL, NULL, 'GPROTEINB', 278831),
(459738, 'PR00001', NULL, 'Coagulation factor GLA domain signature', NULL, NULL, 'GLABLOOD', 278832),
(459739, 'PR00483', NULL, 'Bacterial acid phosphatase class A signature', NULL, NULL, 'BACPHPHTASE', 278833),
(459740, 'PR00420', NULL, 'Aromatic-ring hydroxylase (flavoprotein monooxygenase) signature', NULL, NULL, 'RNGMNOXGNASE', 278834),
(459741, 'PR01608', NULL, 'Salmonella/Shigella invasin protein C signature', NULL, NULL, 'BACINVASINC', 278835),
(459742, 'PR01131', NULL, 'Connexin36 (Cx36) signature', NULL, NULL, 'CONNEXIN36', 278836),
(459743, 'PR00289', NULL, 'Disintegrin signature', NULL, NULL, 'DISINTEGRIN', 278837),
(459744, 'PR00416', NULL, 'Eukaryotic DNA topoisomerase I signature', NULL, NULL, 'EUTPISMRASEI', 278838),
(459745, 'PR00948', NULL, 'Elicitin signature', NULL, NULL, 'ELICITIN', 278839),
(459746, 'PR00607', NULL, 'Class IE cytochrome C signature', NULL, NULL, 'CYTCHROMECIE', 278840),
(459747, 'PR00111', NULL, 'Alpha/beta hydrolase fold signature', NULL, NULL, 'ABHYDROLASE', 278841),
(459748, 'PR01067', NULL, 'P2Y5 orphan receptor signature', NULL, NULL, 'P2Y5ORPHANR', 278842),
(459749, 'PR00203', NULL, 'Amyloid A4 protein precursor signature', NULL, NULL, 'AMYLOIDA4', 278843),
(459750, 'PR01994', NULL, 'Antirepressor protein ANT signature', NULL, NULL, 'ANTIREPRESSR', 278844),
(459751, 'PR00334', NULL, 'HMW kininogen signature', NULL, NULL, 'KININOGEN', 278845),
(459752, 'PR01619', NULL, 'Gamma-aminobutyric-acid A receptor alpha 6 subunit signature', NULL, NULL, 'GABAARALPHA6', 278846),
(459753, 'PR00414', NULL, 'Palmitoyl protein thioesterase signature', NULL, NULL, 'PPTHIESTRASE', 278847),
(459754, 'PR01910', NULL, 'Atypical dual specificity phosphatase subfamily B signature', NULL, NULL, 'ADSPHPHTASEB', 278848),
(459755, 'PR00621', NULL, 'Histone H2B signature', NULL, NULL, 'HISTONEH2B', 278849),
(459756, 'PR01145', NULL, 'Thyrotropin receptor precursor signature', NULL, NULL, 'TSHRECEPTOR', 278850),
(459757, 'PR00888', NULL, 'Smooth muscle protein/calponin family signature', NULL, NULL, 'SM22CALPONIN', 278851),
(459758, 'PR00005', NULL, 'Apple domain signature', NULL, NULL, 'APPLEDOMAIN', 278852),
(459759, 'PR00546', NULL, 'Thyroid hormone receptor (1D nuclear receptor) signature', NULL, NULL, 'THYROIDHORMR', 278853),
(459760, 'PR00370', NULL, 'Flavin-containing monooxygenase (FMO) signature', NULL, NULL, 'FMOXYGENASE', 278854),
(459761, 'PR01008', NULL, 'Flagellar L-ring protein signature', NULL, NULL, 'FLGLRINGFLGH', 278855),
(459762, 'PR00393', NULL, 'Parathyroid hormone receptor signature', NULL, NULL, 'PTRHORMONER', 278856),
(459763, 'PR00701', NULL, '60kDa inner membrane protein signature', NULL, NULL, '60KDINNERMP', 278857),
(459764, 'PR00954', NULL, 'Flagellar motor switch protein FliG signature', NULL, NULL, 'FLGMOTORFLIG', 278858),
(459765, 'PR00159', NULL, '2Fe-2S ferredoxin signature', NULL, NULL, '2FE2SFRDOXIN', 278859),
(459766, 'PR00327', NULL, 'Ice nucleation protein signature', NULL, NULL, 'ICENUCLEATN', 278860),
(459767, 'PR00774', NULL, 'Guanylin precursor signature', NULL, NULL, 'GUANYLIN', 278861),
(459768, 'PR00719', NULL, 'LMW phosphotyrosine protein phosphatase signature', NULL, NULL, 'LMWPTPASE', 278862),
(459769, 'PR01164', NULL, 'Gamma-tubulin signature', NULL, NULL, 'GAMMATUBULIN', 278863),
(459770, 'PR00476', NULL, 'ATP-dependent phosphofructokinase family signature', NULL, NULL, 'PHFRCTKINASE', 278864); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(459771, 'PR01408', NULL, 'Macrophage scavenger receptor signature', NULL, NULL, 'MACSCAVRCPTR', 278865),
(459772, 'PR00123', NULL, 'ATP synthase A subunit signature', NULL, NULL, 'ATPASEA', 278866),
(459773, 'PR01361', NULL, 'Apical membrane antigen 1 signature', NULL, NULL, 'MEROZOITESA', 278867),
(459774, 'PR00372', NULL, 'Biopterin-dependent aromatic amino acid hydroxylase signature', NULL, NULL, 'FYWHYDRXLASE', 278868),
(459775, 'PR01833', NULL, 'Vascular endothelial growth factor receptor type 1 signature', NULL, NULL, 'VEGFRECEPTR1', 278869),
(459776, 'PR00257', NULL, 'Plant photosystem I psaA and psaB protein signature', NULL, NULL, 'PHOTSYSPSAAB', 278870),
(459777, 'PR01228', NULL, 'Eggshell protein signature', NULL, NULL, 'EGGSHELL', 278871),
(459778, 'PR00919', NULL, 'Thermophilic metalloprotease (M29) signature', NULL, NULL, 'THERMOPTASE', 278872),
(459779, 'PR01258', NULL, 'Occludin signature', NULL, NULL, 'OCCLUDIN', 278873),
(459780, 'PR00051', NULL, 'Bacterial chromosomal replication initiator (DNAA) signature', NULL, NULL, 'DNAA', 278874),
(459781, 'PR00328', NULL, 'GTP-binding SAR1 protein signature', NULL, NULL, 'SAR1GTPBP', 278875),
(459782, 'PR01302', NULL, 'Type III secretion system inner membrane P protein family signature', NULL, NULL, 'TYPE3IMPPROT', 278876),
(459783, 'PR00104', NULL, 'cGMP-dependent protein kinase signature', NULL, NULL, 'CGMPKINASE', 278877),
(459784, 'PR00818', NULL, 'Islet amyloid protein (amylin) signature', NULL, NULL, 'ISLETAMYLOID', 278878),
(459785, 'PR02042', NULL, 'Cattle cerebrum and skeletal muscle-specific protein 1 signature', NULL, NULL, 'CCSMST1', 278879),
(459786, 'PR01099', NULL, 'Hydroxyethylthiazole kinase family signature', NULL, NULL, 'HYETHTZKNASE', 278880),
(459787, 'PR01726', NULL, 'Histamine H4 receptor signature', NULL, NULL, 'HISTAMINEH4R', 278881),
(459788, 'PR01232', NULL, 'Na+/HCO3- co-transporter signature', NULL, NULL, 'NAHCO3TRSPRT', 278882),
(459789, 'PR01762', NULL, 'Dishevelled-2 protein signature', NULL, NULL, 'DISHEVELLED2', 278883),
(459790, 'PR01558', NULL, 'C-C chemokine receptor type 11 signature', NULL, NULL, 'CHEMOKINER11', 278884),
(459791, 'PR00036', NULL, 'LacI bacterial regulatory protein HTH signature', NULL, NULL, 'HTHLACI', 278885),
(459792, 'PR01204', NULL, 'Glycine neurotransmitter transporter type 1 (GLYT-1) signature', NULL, NULL, 'GLY1TRNSPORT', 278886),
(459793, 'PR01301', NULL, 'Regulator of G protein signalling (RGS) protein signature', NULL, NULL, 'RGSPROTEIN', 278887),
(459794, 'PR00415', NULL, 'Aconitase family signature', NULL, NULL, 'ACONITASE', 278888),
(459795, 'PR00650', NULL, 'GPR12 orphan receptor signature', NULL, NULL, 'GPR12ORPHANR', 278889),
(459796, 'PR01572', NULL, 'Type 2 neuropeptide FF receptor signature', NULL, NULL, 'NPFFRECEPTR2', 278890),
(459797, 'PR01580', NULL, 'KCNAB voltage-gated K+ channel beta-3 subunit signature', NULL, NULL, 'KCNAB3CHANEL', 278891),
(459798, 'PR00223', NULL, 'Geminivirus AR1/BR1 coat protein signature', NULL, NULL, 'GEMCOATARBR1', 278892),
(459799, 'PR01815', NULL, 'Beta-site APP cleaving enzyme (BACE) family signature', NULL, NULL, 'BACEFAMILY', 278893),
(459800, 'PR00496', NULL, 'Napin signature', NULL, NULL, 'NAPIN', 278894),
(459801, 'PR00075', NULL, 'Fatty acid desaturase family 1 signature', NULL, NULL, 'FACDDSATRASE', 278895),
(459802, 'PR01271', NULL, 'Histone deacetylase signature', NULL, NULL, 'HISDACETLASE', 278896),
(459803, 'PR00004', NULL, 'Anaphylatoxin domain signature', NULL, NULL, 'ANAPHYLATOXN', 278897),
(459804, 'PR00003', NULL, '4-disulphide core signature', NULL, NULL, '4DISULPHCORE', 278898),
(459805, 'PR00380', NULL, 'Kinesin heavy chain signature', NULL, NULL, 'KINESINHEAVY', 278899),
(459806, 'PR02027', NULL, 'Activity-regulated cytoskeleton-associated protein signature', NULL, NULL, 'ARCARG31', 278900),
(459807, 'PR00456', NULL, 'Ribosomal protein P2 signature', NULL, NULL, 'RIBOSOMALP2', 278901),
(459808, 'PR00398', NULL, 'Steroid hormone receptor signature', NULL, NULL, 'STRDHORMONER', 278902),
(459809, 'PR01651', NULL, 'Protein-export SecG membrane protein signature', NULL, NULL, 'SECGEXPORT', 278903);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(459810, 'PR01691', NULL, 'TRAAK K+ channel signature', NULL, NULL, 'TRAAKCHANNEL', 278904),
(459811, 'PR00480', NULL, 'Astacin family signature', NULL, NULL, 'ASTACIN', 278905),
(459812, 'PR01442', NULL, 'Cellulose synthase subunit D signature', NULL, NULL, 'CELLSNTHASED', 278906),
(459813, 'PR00765', NULL, 'Carboxypeptidase A metalloprotease (M14) family signature', NULL, NULL, 'CRBOXYPTASEA', 278907),
(459814, 'PR00345', NULL, 'Stathmin family signature', NULL, NULL, 'STATHMIN', 278908),
(459815, 'PR00930', NULL, 'High mobility group protein (HMGY) signature', NULL, NULL, 'HIGHMOBLTYIY', 278909),
(459816, 'PR00646', NULL, 'RDC1 orphan receptor signature', NULL, NULL, 'RDC1ORPHANR', 278910),
(459817, 'PR02093', NULL, 'HDA1 complex subunit 3 signature', NULL, NULL, 'HDA1SUBUNIT3', 278911),
(459818, 'PR01540', NULL, 'Interleukin-1 binding protein precursor signature', NULL, NULL, 'INTRLEUKN1BP', 278912),
(459819, 'PR01961', NULL, 'Tumour necrosis factor receptor 11 signature', NULL, NULL, 'TNFACTORR11', 278913),
(459820, 'PR00322', NULL, 'G10 protein signature', NULL, NULL, 'G10', 278914),
(459821, 'PR00439', NULL, '11-S seed storage protein family signature', NULL, NULL, '11SGLOBULIN', 278915),
(459822, 'PR00626', NULL, 'Calreticulin signature', NULL, NULL, 'CALRETICULIN', 278916),
(459823, 'PR01367', NULL, 'Beta- and gamma-crystallin family signature', NULL, NULL, 'BGCRYSTALLIN', 278917),
(459824, 'PR01410', NULL, 'Cytochrome c-type biogenesis protein signature', NULL, NULL, 'CCBIOGENESIS', 278918),
(459825, 'PR00541', NULL, 'Muscarinic M4 receptor signature', NULL, NULL, 'MUSCRINICM4R', 278919),
(459826, 'PR01140', NULL, 'Gap junction beta-3 protein (Cx31) signature', NULL, NULL, 'CONNEXINB3', 278920),
(459827, 'PR00098', NULL, 'Carbamoyl-phosphate synthase protein CPSase domain signature', NULL, NULL, 'CPSASE', 278921),
(459828, 'PR01630', NULL, 'L-type voltage-dependent calcium channel alpha-1 subunit signature', NULL, NULL, 'LVDCCALPHA1', 278922),
(459829, 'PR01751', NULL, 'Transcription factor AP-2 gamma signature', NULL, NULL, 'AP2CTNSCPFCT', 278923),
(459830, 'PR00757', NULL, 'Flavin-containing amine oxidase signature', NULL, NULL, 'AMINEOXDASEF', 278924),
(459831, 'PR00031', NULL, 'Lambda-repressor HTH signature', NULL, NULL, 'HTHREPRESSR', 278925),
(459832, 'PR00482', NULL, 'Omptin serine protease signature', NULL, NULL, 'OMPTIN', 278926),
(459833, 'PR00011', NULL, 'Type III EGF-like signature', NULL, NULL, 'EGFLAMININ', 278927),
(459834, 'PR01195', NULL, 'GAT-1 GABA neurotransmitter transporter signature', NULL, NULL, 'GAT1TRNSPORT', 278928),
(459835, 'PR01694', NULL, 'Brain-specific angiogenesis inhibitor precursor signature', NULL, NULL, 'BAIPRECURSOR', 278929),
(459836, 'PR01392', NULL, 'Anthrax toxin LF subunit signature', NULL, NULL, 'ANTHRAXTOXNA', 278930),
(459837, 'PR01873', NULL, 'Cytochrome c oxidase subunit IV signature', NULL, NULL, 'CYTCOXIDASE4', 278931),
(459838, 'PR00475', NULL, 'Hexokinase family signature', NULL, NULL, 'HEXOKINASE', 278932),
(459839, 'PR00712', NULL, 'Brain natriuretic peptide signature', NULL, NULL, 'BNATPEPTIDE', 278933),
(459840, 'PR00435', NULL, 'Interleukin-7 signature', NULL, NULL, 'INTERLEUKIN7', 278934),
(459841, 'PR01023', NULL, 'Sodium-type flagellar protein MotY precursor signature', NULL, NULL, 'NAFLGMOTY', 278935),
(459842, 'PR01679', NULL, 'Kir7 inward rectifier K+ channel signature', NULL, NULL, 'KIR7CHANNEL', 278936),
(459843, 'PR00886', NULL, 'High mobility group (HMG1/HMG2) protein signature', NULL, NULL, 'HIGHMOBLTY12', 278937),
(459844, 'PR01485', NULL, 'Thrombopoietin signature', NULL, NULL, 'THROMBOPTN', 278938),
(459845, 'PR01159', NULL, 'DNA gyrase subunit B signature', NULL, NULL, 'DNAGYRASEB', 278939),
(459846, 'PR00866', NULL, 'RNA-dependent DNA-polymerase (msDNA) signature', NULL, NULL, 'RNADNAPOLMS', 278940),
(459847, 'PR00831', NULL, 'Neurohypophysial hormone signature', NULL, NULL, 'NEUROPHYSIN', 278941),
(459848, 'PR00982', NULL, 'Lysyl-tRNA synthetase signature', NULL, NULL, 'TRNASYNTHLYS', 278942),
(459849, 'PR00749', NULL, 'Lysozyme G signature', NULL, NULL, 'LYSOZYMEG', 278943);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(459850, 'PR00325', NULL, 'Germin signature', NULL, NULL, 'GERMIN', 278944),
(459851, 'PR01796', NULL, 'Voltage-dependent calcium channel gamma-8 subunit signature', NULL, NULL, 'VDCCGAMMA8', 278945),
(459852, 'PR01160', NULL, 'Gamma-aminobutyric-acid A receptor beta subunit signature', NULL, NULL, 'GABAARBETA', 278946),
(459853, 'PR01915', NULL, 'Neurotrophin-4 signature', NULL, NULL, 'NEUROTROPHN4', 278947),
(459854, 'PR00464', NULL, 'Group II E-class P450 signature', NULL, NULL, 'EP450II', 278948),
(459855, 'PR00987', NULL, 'Glutamyl-tRNA synthetase signature', NULL, NULL, 'TRNASYNTHGLU', 278949),
(459856, 'PR00896', NULL, 'Vasopressin receptor signature', NULL, NULL, 'VASOPRESSINR', 278950),
(459857, 'PR02062', NULL, '78 kDa centrosomal protein signature', NULL, NULL, 'CENTROSOME78', 278951),
(459858, 'PR01693', NULL, 'Cyanase signature', NULL, NULL, 'CYANASE', 278952),
(459859, 'PR00507', NULL, 'N12 class N6 adenine-specific DNA methyltransferase signature', NULL, NULL, 'N12N6MTFRASE', 278953),
(459860, 'PR01683', NULL, 'CYP1A P450 family signature', NULL, NULL, 'EP450ICYP1A', 278954),
(459861, 'PR00441', NULL, 'G protein alpha subunit group I signature', NULL, NULL, 'GPROTEINAI', 278955),
(459862, 'PR00100', NULL, 'Aspartate/ornithine carbamoyltransferase superfamily signature', NULL, NULL, 'AOTCASE', 278956),
(459863, 'PR00249', NULL, 'Secretin-like GPCR superfamily signature', NULL, NULL, 'GPCRSECRETIN', 278957),
(459864, 'PR02104', NULL, 'Inheritance of peroxisomes protein 2 signature', NULL, NULL, 'INPROXISOME2', 278958),
(459865, 'PR02107', NULL, 'Inositol 1,4,5-trisphosphate receptor-interacting protein signature', NULL, NULL, 'INOS145TPRIP', 278959),
(459866, 'PR00275', NULL, 'Glucagon polypeptide hormone superfamily signature', NULL, NULL, 'GLUCAGON', 278960),
(459867, 'PR01285', NULL, 'Orphan nuclear receptor HMR signature', NULL, NULL, 'HMRNUCRECPTR', 278961),
(459868, 'PR00680', NULL, 'P-type trefoil domain signature', NULL, NULL, 'PTREFOIL', 278962),
(459869, 'PR00386', NULL, 'P53 tumour supressor signature', NULL, NULL, 'P53SUPPRESSR', 278963),
(459870, 'PR01604', NULL, 'KCNE voltage-gated K+ channel subfamily E1 signature', NULL, NULL, 'KCNE1CHANNEL', 278964),
(459871, 'PR00373', NULL, 'Glycoprotein hormone receptor signature', NULL, NULL, 'GLYCHORMONER', 278965),
(459872, 'PR00037', NULL, 'LacR bacterial regulatory protein HTH signature', NULL, NULL, 'HTHLACR', 278966),
(459873, 'PR01864', NULL, 'Bcl-X apoptosis regulator protein signature', NULL, NULL, 'APOPREGBCLX', 278967),
(459874, 'PR00234', NULL, 'HIV-1 matrix protein signature', NULL, NULL, 'HIV1MATRIX', 278968),
(459875, 'PR01384', NULL, 'Claudin-11 signature', NULL, NULL, 'CLAUDIN11', 278969),
(459876, 'PR01870', NULL, 'T-cell surface CD2 antigen signature', NULL, NULL, 'CD2ANTIGEN', 278970),
(459877, 'PR01428', NULL, 'Protease activated receptor precursor signature', NULL, NULL, 'PROTEASEAR', 278971),
(459878, 'PR01095', NULL, 'TASK K+ channel signature', NULL, NULL, 'TASKCHANNEL', 278972),
(459879, 'PR00040', NULL, 'MerR bacterial regulatory protein HTH signature', NULL, NULL, 'HTHMERR', 278973),
(459880, 'PR02028', NULL, 'C-Myc-binding protein signature', NULL, NULL, 'CMYCBINDINGP', 278974),
(459881, 'PR01480', NULL, 'Neurotensin type 1 receptor signature', NULL, NULL, 'NEUROTENSN1R', 278975),
(459882, 'PR00583', NULL, 'Prostanoid EP3 receptor type 1 signature', NULL, NULL, 'PRSTNOIDE31R', 278976),
(459883, 'PR00360', NULL, 'C2 domain signature', NULL, NULL, 'C2DOMAIN', 278977),
(459884, 'PR01971', NULL, 'Tumour necrosis factor receptor 21 signature', NULL, NULL, 'TNFACTORR21', 278978),
(459885, 'PR00358', NULL, 'Bombesin receptor signature', NULL, NULL, 'BOMBESINR', 278979),
(459886, 'PR00433', NULL, 'Interleukin-6/G-CSF/MGF family signature', NULL, NULL, 'IL6GCSFMGF', 278980),
(459887, 'PR00045', NULL, 'Sigma-54 factor signature', NULL, NULL, 'SIGMA54FCT', 278981),
(459888, 'PR00687', NULL, 'Tryptophan RNA-binding attenuator protein signature', NULL, NULL, 'TRPRNAAP', 278982),
(459889, 'PR01089', NULL, 'Neuregulin family signature', NULL, NULL, 'NEUREGULIN', 278983);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(459890, 'PR00960', NULL, 'LmbP protein signature', NULL, NULL, 'LMBPPROTEIN', 278984),
(459891, 'PR00047', NULL, 'C4-type steroid receptor zinc finger signature', NULL, NULL, 'STROIDFINGER', 278985),
(459892, 'PR01520', NULL, 'Zeta-tubulin signature', NULL, NULL, 'ZETATUBULIN', 278986),
(459893, 'PR00068', NULL, 'Cu-Zn-superoxide dismutase family signature', NULL, NULL, 'CUZNDISMTASE', 278987),
(459894, 'PR00980', NULL, 'Alanyl-tRNA synthetase signature', NULL, NULL, 'TRNASYNTHALA', 278988),
(459895, 'PR01750', NULL, 'Transcription factor AP-2 beta signature', NULL, NULL, 'AP2BTNSCPFCT', 278989),
(459896, 'PR00634', NULL, 'Major pollen allergen Bet V1 signature', NULL, NULL, 'BETALLERGEN', 278990),
(459897, 'PR01754', NULL, 'Streptothricin acetyltransferase signature', NULL, NULL, 'SACTRNSFRASE', 278991),
(459898, 'PR00255', NULL, 'Natriuretic peptide receptor signature', NULL, NULL, 'NATPEPTIDER', 278992),
(459899, 'PR00744', NULL, 'Glycosyl hydrolase family 37 signature', NULL, NULL, 'GLHYDRLASE37', 278993),
(459900, 'PR00692', NULL, 'T-cell surface glycoprotein CD4 signature', NULL, NULL, 'CD4TCANTIGEN', 278994),
(459901, 'PR01831', NULL, 'Trace amine receptor 1 signature', NULL, NULL, 'TRACEAMINE1R', 278995),
(459902, 'PR00669', NULL, 'Inhibin alpha chain signature', NULL, NULL, 'INHIBINA', 278996),
(459903, 'PR01880', NULL, 'Fibritin signature', NULL, NULL, 'FIBRITIN', 278997),
(459904, 'PR02090', NULL, 'HAUS augmin-like complex subunit 4 signature', NULL, NULL, 'HAUSAUGMINL4', 278998),
(459905, 'PR01913', NULL, 'Nerve growth factor beta subunit signature', NULL, NULL, 'NGFBETA', 278999),
(459906, 'PR00317', NULL, 'Ependymin signature', NULL, NULL, 'EPENDYMIN', 279000),
(459907, 'PR00804', NULL, 'Vitamin D-binding protein signature', NULL, NULL, 'VITAMNDBNDNG', 279001),
(459908, 'PR00237', NULL, 'Rhodopsin-like GPCR superfamily signature', NULL, NULL, 'GPCRRHODOPSN', 279002),
(459909, 'PR01244', NULL, 'Peropsin signature', NULL, NULL, 'PEROPSIN', 279003),
(459910, 'PR01111', NULL, 'CLC-0 chloride channel signature', NULL, NULL, 'CLCHANNEL0', 279004),
(459911, 'PR01212', NULL, 'Alpha-synuclein signature', NULL, NULL, 'ASYNUCLEIN', 279005),
(459912, 'PR00242', NULL, 'Dopamine receptor signature', NULL, NULL, 'DOPAMINER', 279006),
(459913, 'PR01386', NULL, 'Cytochrome c-type biogenesis protein CcmC signature', NULL, NULL, 'CCMCBIOGNSIS', 279007),
(459914, 'PR02051', NULL, 'Protein family FAM175 signature', NULL, NULL, 'PROTEINF175', 279008),
(459915, 'PR01944', NULL, 'Fish interleukin-11 signature', NULL, NULL, 'INTLKN11FISH', 279009),
(459916, 'PR00295', NULL, 'Stefin A signature', NULL, NULL, 'STEFINA', 279010),
(459917, 'PR00891', NULL, 'Rab GDI/REP protein family signature', NULL, NULL, 'RABGDIREP', 279011),
(459918, 'PR01620', NULL, 'Gamma-aminobutyric-acid A receptor gamma subunit signature', NULL, NULL, 'GABAARGAMMA', 279012),
(459919, 'PR00119', NULL, 'P-type cation-transporting ATPase superfamily signature', NULL, NULL, 'CATATPASE', 279013),
(459920, 'PR01351', NULL, 'Calcitonin gene-related peptide type 1 receptor signature', NULL, NULL, 'CGRPRECEPTOR', 279014),
(459921, 'PR01188', NULL, 'Anion exchanger isoform 2 signature', NULL, NULL, 'ANIONEXHNGR2', 279015),
(459922, 'PR00972', NULL, 'Ribosomal protein S12E family signature', NULL, NULL, 'RIBSOMALS12E', 279016),
(459923, 'PR01834', NULL, 'Vascular endothelial growth factor receptor type 2 signature', NULL, NULL, 'VEGFRECEPTR2', 279017),
(459924, 'PR00922', NULL, 'D-Ala-D-Ala carboxypeptidase 3 (S13) family signature', NULL, NULL, 'DADACBPTASE3', 279018),
(459925, 'PR00008', NULL, 'Diacylglycerol/phorbol-ester binding signature', NULL, NULL, 'DAGPEDOMAIN', 279019),
(459926, 'PR00605', NULL, 'Class IC cytochrome C signature', NULL, NULL, 'CYTCHROMECIC', 279020),
(459927, 'PR01642', NULL, 'Transient receptor potential channel 1 signature', NULL, NULL, 'TRPCHANNEL1', 279021),
(459928, 'PR01757', NULL, 'Amelogenin signature', NULL, NULL, 'AMELOGENIN', 279022),
(459929, 'PR00072', NULL, 'Malic enzyme signature', NULL, NULL, 'MALOXRDTASE', 279023);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(459930, 'PR01595', NULL, 'Gram-negative bacterial type III secretion SycD chaperone signature', NULL, NULL, 'SYCDCHAPRONE', 279024),
(459931, 'PR00569', NULL, 'Dopamine D4 receptor signature', NULL, NULL, 'DOPAMINED4R', 279025),
(459932, 'PR01673', NULL, 'Glycine receptor alpha subunit signature', NULL, NULL, 'GLYRALPHA', 279026),
(459933, 'PR01826', NULL, 'Janus kinase 3 (JAK3) signature', NULL, NULL, 'JANUSKINASE3', 279027),
(459934, 'PR02079', NULL, 'Probable serine/threonine-protein kinase GDT family signature', NULL, NULL, 'STKINASEGDT', 279028),
(459935, 'PR00338', NULL, 'Transcription termination factor NUSG signature', NULL, NULL, 'NUSGTNSCPFCT', 279029),
(459936, 'PR01450', NULL, 'Calcium-activated BK potassium channel beta subunit signature', NULL, NULL, 'BKCHANNELB', 279030),
(459937, 'PR00779', NULL, 'Inositol 1,4,5-trisphosphate-binding protein receptor signature', NULL, NULL, 'INSP3RECEPTR', 279031),
(459938, 'PR00613', NULL, 'Myoglobin signature', NULL, NULL, 'MYOGLOBIN', 279032),
(459939, 'PR00408', NULL, 'Mitochondrial P450 clan signature', NULL, NULL, 'MITP450', 279033),
(459940, 'PR02087', NULL, 'HAUS augmin-like complex subunit 1 signature', NULL, NULL, 'HAUSAUGMINL1', 279034),
(459941, 'PR01469', NULL, 'Bacterial carbamate kinase signature', NULL, NULL, 'CARBMTKINASE', 279035),
(459942, 'PR02053', NULL, 'BRISC complex subunit Abro1 signature', NULL, NULL, 'BRISCABRO1', 279036),
(459943, 'PR01306', NULL, 'Salmonella invasion protein InvJ signature', NULL, NULL, 'SSPANPROTEIN', 279037),
(459944, 'PR00685', NULL, 'Transcription initiation factor IIB signature', NULL, NULL, 'TIFACTORIIB', 279038),
(459945, 'PR02095', NULL, 'Haem transporter HRG signature', NULL, NULL, 'TRNSPORTRHRG', 279039),
(459946, 'PR02052', NULL, 'BRCA1-A complex subunit Abraxas signature', NULL, NULL, 'ABRAXAS', 279040),
(459947, 'PR00881', NULL, 'Ribosomal protein L7A/RS6 family signature', NULL, NULL, 'L7ARS6FAMILY', 279041),
(459948, 'PR02015', NULL, 'Aquaporin-3 signature', NULL, NULL, 'AQUAPORIN3', 279042),
(459949, 'PR00070', NULL, 'Dihydrofolate reductase signature', NULL, NULL, 'DHFR', 279043),
(459950, 'PR01759', NULL, 'Capsule biosynthesis protein CapC signature', NULL, NULL, 'CAPSULEPROTC', 279044),
(459951, 'PR01885', NULL, 'Macromomycin family signature', NULL, NULL, 'MACROMOMYCIN', 279045),
(459952, 'PR00654', NULL, 'Angiotensinogen signature', NULL, NULL, 'ANGIOTENSNGN', 279046),
(459953, 'PR00096', NULL, 'Glutamine amidotransferase superfamily signature', NULL, NULL, 'GATASE', 279047),
(459954, 'PR00494', NULL, 'Fanconi anaemia group C protein signature', NULL, NULL, 'FANCONICGENE', 279048),
(459955, 'PR00537', NULL, 'Mu opioid receptor signature', NULL, NULL, 'MUOPIOIDR', 279049),
(459956, 'PR01641', NULL, 'Pre-pro melanin-concentrating hormone signature', NULL, NULL, 'PROMCHFAMILY', 279050),
(459957, 'PR01967', NULL, 'Tumour necrosis factor receptor 17 signature', NULL, NULL, 'TNFACTORR17', 279051),
(459958, 'PR01504', NULL, 'Pancreatitis-associated protein signature', NULL, NULL, 'PNCREATITSAP', 279052),
(459959, 'PR00807', NULL, 'Pollen allergen Amb family signature', NULL, NULL, 'AMBALLERGEN', 279053),
(459960, 'PR00700', NULL, 'Protein tyrosine phosphatase signature', NULL, NULL, 'PRTYPHPHTASE', 279054),
(459961, 'PR00434', NULL, 'Interleukin-6 signature', NULL, NULL, 'INTERLEUKIN6', 279055),
(459962, 'PR00892', NULL, 'Rab GDI protein signature', NULL, NULL, 'RABGDI', 279056),
(459963, 'PR01645', NULL, 'Transient receptor potential channel 4 signature', NULL, NULL, 'TRPCHANNEL4', 279057),
(459964, 'PR00485', NULL, 'Mealworm beetle B protein signature', NULL, NULL, 'MEALWORMBTLB', 279058),
(459965, 'PR01396', NULL, 'Bordetella pertussis toxin B subunit signature', NULL, NULL, 'BORPETOXINB', 279059),
(459966, 'PR00608', NULL, 'Class II cytochrome C signature', NULL, NULL, 'CYTCHROMECII', 279060),
(459967, 'PR00873', NULL, 'Echinoidea (sea urchin) metallothionein signature', NULL, NULL, 'MTECHINOIDEA', 279061),
(459968, 'PR01256', NULL, 'Otx1 transcription factor signature', NULL, NULL, 'OTX1HOMEOBOX', 279062);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(459969, 'PR01713', NULL, 'Nucleotide sugar epimerase signature', NULL, NULL, 'NUCEPIMERASE', 279063),
(459970, 'PR00771', NULL, 'Heat-labile enterotoxin A chain signature', NULL, NULL, 'ENTEROTOXINA', 279064),
(459971, 'PR01860', NULL, 'ADAM-TS5 protein signature', NULL, NULL, 'ADAMTS5', 279065),
(459972, 'PR00270', NULL, 'Alpha-type calcitonin signature', NULL, NULL, 'CALCITONINA', 279066),
(459973, 'PR00641', NULL, 'C-C chemokine receptor type 7 signature', NULL, NULL, 'CHEMOKINER7', 279067),
(459974, 'PR01482', NULL, 'Pertactin signature', NULL, NULL, 'PERTACTIN', 279068),
(459975, 'PR01868', NULL, 'ABC transporter family E signature', NULL, NULL, 'ABCEFAMILY', 279069),
(459976, 'PR01092', NULL, 'Sulphonylurea receptor family signature', NULL, NULL, 'SULFNYLUREAR', 279070),
(459977, 'PR01650', NULL, 'Bacterial translocase SecE signature', NULL, NULL, 'SECETRNLCASE', 279071),
(459978, 'PR01845', NULL, 'Wnt-6 protein signature', NULL, NULL, 'WNT6PROTEIN', 279072),
(459979, 'PR00153', NULL, 'Cyclophilin peptidyl-prolyl cis-trans isomerase signature', NULL, NULL, 'CSAPPISMRASE', 279073),
(459980, 'PR01665', NULL, 'Voltage-gated Na+ channel alpha 4 subunit signature', NULL, NULL, 'NACHANNEL4', 279074),
(459981, 'PR00872', NULL, 'Diptera (Drosophila) metallothionein signature', NULL, NULL, 'MTDIPTERA', 279075),
(459982, 'PR01316', NULL, 'Glial cell line-derived neurotrophic factor receptor family signature', NULL, NULL, 'GDNFRECEPTOR', 279076),
(459983, 'PR01659', NULL, 'Mini-chromosome maintenance (MCM) protein 3 signature', NULL, NULL, 'MCMPROTEIN3', 279077),
(459984, 'PR00732', NULL, 'Glycosyl hydrolase family 4 signature', NULL, NULL, 'GLHYDRLASE4', 279078),
(459985, 'PR01284', NULL, 'Orphan nuclear receptor (4A nuclear receptor) family signature', NULL, NULL, 'NUCLEARECPTR', 279079),
(459986, 'PR00479', NULL, 'Prokaryotic zinc-dependent phospholipase C signature', NULL, NULL, 'PRPHPHLPASEC', 279080),
(459987, 'PR00963', NULL, 'MARCKS family signature', NULL, NULL, 'MARCKS', 279081),
(459988, 'PR01125', NULL, 'Flavin-containing monooxygenase (FMO) 5 signature', NULL, NULL, 'FMOXYGENASE5', 279082),
(459989, 'PR00799', NULL, 'Aspartate aminotransferase signature', NULL, NULL, 'TRANSAMINASE', 279083),
(459990, 'PR01517', NULL, 'Kv4.2 voltage-gated K+ channel signature', NULL, NULL, 'KV42CHANNEL', 279084),
(459991, 'PR00676', NULL, 'Maspin signature', NULL, NULL, 'MASPIN', 279085),
(459992, 'PR01399', NULL, 'Enterobactin synthetase component D signature', NULL, NULL, 'ENTSNTHTASED', 279086),
(459993, 'PR00797', NULL, 'Streptopain (C10) cysteine protease family signature', NULL, NULL, 'STREPTOPAIN', 279087),
(459994, 'PR01819', NULL, 'Desmoglein signature', NULL, NULL, 'DESMOGLEIN', 279088),
(459995, 'PR01575', NULL, 'Formyltetrahydrofolate deformylase signature', NULL, NULL, 'FFH4HYDRLASE', 279089),
(459996, 'PR01654', NULL, 'Thyrotropin-releasing hormone receptor 2 signature', NULL, NULL, 'TRHRECEPTOR2', 279090),
(459997, 'PR01042', NULL, 'Aspartyl-tRNA synthetase signature', NULL, NULL, 'TRNASYNTHASP', 279091),
(459998, 'PR01712', NULL, 'Alpha giardin signature', NULL, NULL, 'ALPHAGIARDIN', 279092),
(459999, 'PR00307', NULL, 'Adenovirus fibre protein signature', NULL, NULL, 'ADENOVSFIBRE', 279093),
(460000, 'PR01331', NULL, 'Kir6.1 inward rectifier K+ channel signature', NULL, NULL, 'KIR61CHANNEL', 279094),
(460001, 'PR00477', NULL, 'Phosphoglycerate kinase family signature', NULL, NULL, 'PHGLYCKINASE', 279095),
(460002, 'PR01871', NULL, 'Annexin type VII signature', NULL, NULL, 'ANNEXINVII', 279096),
(460003, 'PR00800', NULL, 'Aromatic-L-amino-acid decarboxylase signature', NULL, NULL, 'YHDCRBOXLASE', 279097),
(460004, 'PR00460', NULL, 'Bacterial haem catalase-peroxidase signature', NULL, NULL, 'BPEROXIDASE', 279098),
(460005, 'PR01794', NULL, 'Voltage-dependent calcium channel gamma-6 subunit signature', NULL, NULL, 'VDCCGAMMA6', 279099),
(460006, 'PR01511', NULL, 'Kv1.4 voltage-gated K+ channel signature', NULL, NULL, 'KV14CHANNEL', 279100),
(460007, 'PR00082', NULL, 'Glutamate/leucine/phenylalanine/valine dehydrogenase signature', NULL, NULL, 'GLFDHDRGNASE', 279101);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(460008, 'PR00966', NULL, 'Potyvirus nuclear inclusion A cysteine protease (C4) signature', NULL, NULL, 'NIAPOTYPTASE', 279102),
(460009, 'PR00283', NULL, 'Myotoxin signature', NULL, NULL, 'MYOTOXIN', 279103),
(460010, 'PR00176', NULL, 'Sodium/chloride neurotransmitter symporter signature', NULL, NULL, 'NANEUSMPORT', 279104),
(460011, 'PR00504', NULL, 'Chromodomain signature', NULL, NULL, 'CHROMODOMAIN', 279105),
(460012, 'PR01039', NULL, 'Tryptophanyl-tRNA synthetase signature', NULL, NULL, 'TRNASYNTHTRP', 279106),
(460013, 'PR00180', NULL, 'Cellular retinaldehyde-binding protein signature', NULL, NULL, 'CRETINALDHBP', 279107),
(460014, 'PR01281', NULL, 'Corticotropin releasing factor type 2 receptor signature', NULL, NULL, 'CRFRECEPTOR2', 279108),
(460015, 'PR00875', NULL, 'Mollusc metallothionein signature', NULL, NULL, 'MTMOLLUSC', 279109),
(460016, 'PR01381', NULL, 'Claudin-7 signature', NULL, NULL, 'CLAUDIN7', 279110),
(460017, 'PR00988', NULL, 'Uridine kinase signature', NULL, NULL, 'URIDINKINASE', 279111),
(460018, 'PR01564', NULL, 'OGR1 sphingosylphosphorylcholine receptor signature', NULL, NULL, 'OGR1RECEPTOR', 279112),
(460019, 'PR01394', NULL, 'Clostridium enterotoxin signature', NULL, NULL, 'CLENTEROTOXN', 279113),
(460020, 'PR01946', NULL, 'Interleukin-11B signature', NULL, NULL, 'IL11BFISH', 279114),
(460021, 'PR00564', NULL, 'C-X-C chemokine receptor type 5 signature', NULL, NULL, 'CXCCHMKINER5', 279115),
(460022, 'PR01613', NULL, 'Escherichia coli P pili tip fibrillum PapF protein signature', NULL, NULL, 'FIMBRIALPAPF', 279116),
(460023, 'PR00169', NULL, 'Potassium channel signature', NULL, NULL, 'KCHANNEL', 279117),
(460024, 'PR00663', NULL, 'Galanin receptor signature', NULL, NULL, 'GALANINR', 279118),
(460025, 'PR01986', NULL, 'Neurogenic locus Notch protein 3 signature', NULL, NULL, 'NOTCH3', 279119),
(460026, 'PR00619', NULL, 'Transcription factor GATA zinc finger signature', NULL, NULL, 'GATAZNFINGER', 279120),
(460027, 'PR01855', NULL, 'Neuropeptide W receptor family signature', NULL, NULL, 'NRPEPTIDEWR', 279121),
(460028, 'PR01321', NULL, 'Kir1.1 inward rectifier K+ channel signature', NULL, NULL, 'KIR11CHANNEL', 279122),
(460029, 'PR01266', NULL, 'Alpha-class glutathione S-transferase signature', NULL, NULL, 'GSTRNSFRASEA', 279123),
(460030, 'PR01398', NULL, 'Isochorismatase signature', NULL, NULL, 'ISCHRISMTASE', 279124),
(460031, 'PR01277', NULL, 'Nucleoside-specific channel-forming protein Tsx signature', NULL, NULL, 'CHANNELTSX', 279125),
(460032, 'PR00753', NULL, '1-aminocyclopropane-1-carboxylate synthase signature', NULL, NULL, 'ACCSYNTHASE', 279126),
(460033, 'PR01446', NULL, 'Claudin-8 signature', NULL, NULL, 'CLAUDIN8', 279127),
(460034, 'PR00614', NULL, 'Ni-Fe hydrogenase small subunit signature', NULL, NULL, 'NIHGNASESMLL', 279128),
(460035, 'PR01940', NULL, 'Neurotrophic tyrosine kinase receptor type 1 signature', NULL, NULL, 'NTKRECEPTOR1', 279129),
(460036, 'PR01452', NULL, 'LIN-12/notch repeat (LNR) signature', NULL, NULL, 'LNOTCHREPEAT', 279130),
(460037, 'PR01176', NULL, 'Metabotropic gamma-aminobutyric acid type B receptor signature', NULL, NULL, 'GABABRECEPTR', 279131),
(460038, 'PR02077', NULL, 'Protein GAPT signature', NULL, NULL, 'PROTEINGAPT', 279132),
(460039, 'PR00417', NULL, 'Prokaryotic DNA topoisomerase I signature', NULL, NULL, 'PRTPISMRASEI', 279133),
(460040, 'PR01800', NULL, 'Staphylococcus aureus exotoxin signature', NULL, NULL, 'STAPHEXOTOXN', 279134),
(460041, 'PR01753', NULL, 'Streptococcus streptokinase protein signature', NULL, NULL, 'STREPKINASE', 279135),
(460042, 'PR00067', NULL, 'Catalase signature', NULL, NULL, 'CATALASE', 279136),
(460043, 'PR01896', NULL, 'ABC transporter family B2 signature', NULL, NULL, 'TAP1PROTEIN', 279137),
(460044, 'PR01850', NULL, 'Groucho/transducin-like enhancer protein signature', NULL, NULL, 'GROUCHOFAMLY', 279138),
(460045, 'PR01958', NULL, 'Sedoheptulose-1,7-bisphosphatase family signature', NULL, NULL, 'S17BPHPHTASE', 279139),
(460046, 'PR01026', NULL, 'Neurokinin NK3 receptor signature', NULL, NULL, 'NEUROKININ3R', 279140);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(460047, 'PR01441', NULL, 'Cellulose synthase subunit C signature', NULL, NULL, 'CELLSNTHASEC', 279141),
(460048, 'PR01205', NULL, 'Inebriated neurotransmitter transporter signature', NULL, NULL, 'INEBRIATED', 279142),
(460049, 'PR00578', NULL, 'Lateral eye opsin signature', NULL, NULL, 'OPSINLTRLEYE', 279143),
(460050, 'PR01286', NULL, 'Orphan nuclear receptor NOR1 signature', NULL, NULL, 'NORNUCRECPTR', 279144),
(460051, 'PR01013', NULL, 'Neuropeptide Y1 receptor signature', NULL, NULL, 'NRPEPTIDEY1R', 279145),
(460052, 'PR00375', NULL, 'Huntingtin signature', NULL, NULL, 'HUNTINGTIN', 279146),
(460053, 'PR01373', NULL, 'Yersinia serine/threonine protein kinase signature', NULL, NULL, 'YERSSTKINASE', 279147),
(460054, 'PR01662', NULL, 'Mini-chromosome maintenance (MCM) protein 6 signature', NULL, NULL, 'MCMPROTEIN6', 279148),
(460055, 'PR00425', NULL, 'Bradykinin receptor signature', NULL, NULL, 'BRADYKININR', 279149),
(460056, 'PR01352', NULL, 'Growth hormone-releasing hormone receptor signature', NULL, NULL, 'GHRHRECEPTOR', 279150),
(460057, 'PR01862', NULL, 'Bcl-2 apoptosis regulator protein family signature', NULL, NULL, 'BCL2FAMILY', 279151),
(460058, 'PR01688', NULL, 'CYP2J P450 family signature', NULL, NULL, 'EP450ICYP2J', 279152),
(460059, 'PR00861', NULL, 'Alpha-lytic endopeptidase serine protease (S2A) signature', NULL, NULL, 'ALYTICPTASE', 279153),
(460060, 'PR00063', NULL, 'Ribosomal protein L27 signature', NULL, NULL, 'RIBOSOMALL27', 279154),
(460061, 'PR00746', NULL, 'Glycosyl hydrolase family 41 signature', NULL, NULL, 'GLHYDRLASE41', 279155),
(460062, 'PR01012', NULL, 'Neuropeptide Y receptor signature', NULL, NULL, 'NRPEPTIDEYR', 279156),
(460063, 'PR01155', NULL, 'Vasoactive intestinal peptide receptor 2 signature', NULL, NULL, 'VIP2RECEPTOR', 279157),
(460064, 'PR00093', NULL, 'Uricase signature', NULL, NULL, 'URICASE', 279158),
(460065, 'PR01676', NULL, 'Glycine receptor alpha 3 subunit signature', NULL, NULL, 'GLYRALPHA3', 279159),
(460066, 'PR00644', NULL, 'GPR orphan receptor signature', NULL, NULL, 'GPRORPHANR', 279160),
(460067, 'PR00720', NULL, 'Mammalian LMW phosphotyrosine protein phosphatase signature', NULL, NULL, 'MAMMALPTPASE', 279161),
(460068, 'PR00240', NULL, 'Alpha-1D adrenergic receptor signature', NULL, NULL, 'ADRENRGCA1DR', 279162),
(460069, 'PR00600', NULL, 'Protein phosphatase PP2A 55kDa regulatory subunit signature', NULL, NULL, 'PP2APR55', 279163),
(460070, 'PR01265', NULL, 'Link module signature', NULL, NULL, 'LINKMODULE', 279164),
(460071, 'PR00733', NULL, 'Glycosyl hydrolase family 6 signature', NULL, NULL, 'GLHYDRLASE6', 279165),
(460072, 'PR01219', NULL, 'Apolipoprotein D signature', NULL, NULL, 'APOLIPOPROTD', 279166),
(460073, 'PR01813', NULL, 'Fungal annexin type XIV signature', NULL, NULL, 'ANNEXINFUNGI', 279167),
(460074, 'PR01923', NULL, 'Tumour necrosis factor receptor 8 signature', NULL, NULL, 'TNFACTORR8', 279168),
(460075, 'PR00213', NULL, 'Myelin P0 protein signature', NULL, NULL, 'MYELINP0', 279169),
(460076, 'PR02094', NULL, 'Protein HEXIM1/HEXIM2 family signature', NULL, NULL, 'HEXIMFAMILY', 279170),
(460077, 'PR01992', NULL, 'GP153 7TM protein signature', NULL, NULL, 'GPR153', 279171),
(460078, 'PR00059', NULL, 'Ribosomal protein L6 signature', NULL, NULL, 'RIBOSOMALL6', 279172),
(460079, 'PR01242', NULL, 'Plant G protein alpha subunit signature', NULL, NULL, 'GPROTEINAPLT', 279173),
(460080, 'PR01597', NULL, 'Zona occludens protein family signature', NULL, NULL, 'ZONOCCLUDNS', 279174),
(460081, 'PR02097', NULL, 'HTLV-1 basic zipper factor signature', NULL, NULL, 'HTLV1ZIPPER', 279175),
(460082, 'PR01892', NULL, 'Wnt-8 protein signature', NULL, NULL, 'WNT8PROTEIN', 279176),
(460083, 'PR00713', NULL, 'C-type natriuretic peptide signature', NULL, NULL, 'CNATPEPTIDE', 279177),
(460084, 'PR01953', NULL, 'Subtilin biosynthesis protein SpaC signature', NULL, NULL, 'SPACPROTEIN', 279178),
(460085, 'PR00025', NULL, 'Homeotic antennapedia protein signature', NULL, NULL, 'ANTENNAPEDIA', 279179),
(460086, 'PR00851', NULL, 'Xeroderma pigmentosum group B protein signature', NULL, NULL, 'XRODRMPGMNTB', 279180);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(460087, 'PR02082', NULL, 'GLC7-interacting protein 4 signature', NULL, NULL, 'GLC7IP4', 279181),
(460088, 'PR01103', NULL, 'Adrenergic receptor signature', NULL, NULL, 'ADRENERGICR', 279182),
(460089, 'PR00451', NULL, 'Chitin-binding domain signature', NULL, NULL, 'CHITINBINDNG', 279183),
(460090, 'PR00421', NULL, 'Thioredoxin family signature', NULL, NULL, 'THIOREDOXIN', 279184),
(460091, 'PR01162', NULL, 'Alpha-tubulin signature', NULL, NULL, 'ALPHATUBULIN', 279185),
(460092, 'PR00647', NULL, 'Urotensin II receptor signature', NULL, NULL, 'UROTENSIN2R', 279186),
(460093, 'PR00989', NULL, 'Adenosine kinase signature', NULL, NULL, 'ADENOKINASE', 279187),
(460094, 'PR02032', NULL, 'Dexamethasone-induced protein signature', NULL, NULL, 'DEXMETHSNEIP', 279188),
(460095, 'PR01742', NULL, 'Septin 7 signature', NULL, NULL, 'SEPTIN7', 279189),
(460096, 'PR01298', NULL, 'Colicin E1 (microcin) immunity protein signature', NULL, NULL, 'MICROCIN', 279190),
(460097, 'PR01120', NULL, 'Plant CLC chloride channel signature', NULL, NULL, 'CLCHANNELPLT', 279191),
(460098, 'PR00110', NULL, 'Alpha-amylase signature', NULL, NULL, 'ALPHAAMYLASE', 279192),
(460099, 'PR01646', NULL, 'Transient receptor potential channel 5 signature', NULL, NULL, 'TRPCHANNEL5', 279193),
(460100, 'PR01458', NULL, 'Peripheral myelin protein PMP22 signature', NULL, NULL, 'PMYELIN22', 279194),
(460101, 'PR01484', NULL, 'Pertactin virulence factor family signature', NULL, NULL, 'PRTACTNFAMLY', 279195),
(460102, 'PR00902', NULL, 'VP6 blue-tongue virus inner capsid protein signature', NULL, NULL, 'VP6CAPSID', 279196),
(460103, 'PR02047', NULL, 'Brefeldin A-sensitivity protein 4 signature', NULL, NULL, 'BREFELDNASP4', 279197),
(460104, 'PR01838', NULL, 'Neural cell adhesion molecule signature', NULL, NULL, 'NCAMFAMILY', 279198),
(460105, 'PR01997', NULL, 'Phage major tail protein 2 family signature', NULL, NULL, 'MTP2FAMILY', 279199),
(460106, 'PR01085', NULL, 'Na+/H+ exchanger isoform 1 (NHE1) signature', NULL, NULL, 'NAHEXCHNGR1', 279200),
(460107, 'PR01881', NULL, 'Limb-bud-and-heart protein signature', NULL, NULL, 'LBHPROTEIN', 279201),
(460108, 'PR00939', NULL, 'C2HC-type zinc-finger signature', NULL, NULL, 'C2HCZNFINGER', 279202),
(460109, 'PR01966', NULL, 'Tumour necrosis factor receptor 16 signature', NULL, NULL, 'TNFACTORR16', 279203),
(460110, 'PR00133', NULL, 'Glycosyl hydrolase family 3 signature', NULL, NULL, 'GLHYDRLASE3', 279204),
(460111, 'PR00638', NULL, 'Type 4 bombesin receptor signature', NULL, NULL, 'BOMBESIN4R', 279205),
(460112, 'PR00057', NULL, 'Transcription factor NF-KB signature', NULL, NULL, 'NFKBTNSCPFCT', 279206),
(460113, 'PR01656', NULL, 'Helicobacter pylori vacuolating cytotoxin signature', NULL, NULL, 'VACCYTOTOXIN', 279207),
(460114, 'PR00529', NULL, 'Gonadotrophin releasing hormone receptor signature', NULL, NULL, 'GNADOTRPHINR', 279208),
(460115, 'PR01196', NULL, 'GAT-2 GABA neurotransmitter transporter signature', NULL, NULL, 'GAT2TRNSPORT', 279209),
(460116, 'PR00055', NULL, 'HIV TAT domain signature', NULL, NULL, 'HIVTATDOMAIN', 279210),
(460117, 'PR01268', NULL, 'Pi-class glutathione S-transferase signature', NULL, NULL, 'GSTRNSFRASEP', 279211),
(460118, 'PR00374', NULL, 'High potential iron sulphur protein signature', NULL, NULL, 'HIPIPFRDOXIN', 279212),
(460119, 'PR01210', NULL, 'Gamma-glutamyltranspeptidase signature', NULL, NULL, 'GGTRANSPTASE', 279213),
(460120, 'PR01025', NULL, 'Neurokinin NK2 receptor signature', NULL, NULL, 'NEUROKININ2R', 279214),
(460121, 'PR02075', NULL, 'Fibrous sheath-interacting protein 1 signature', NULL, NULL, 'FIBSHEATHIP1', 279215),
(460122, 'PR02016', NULL, 'Aquaporin-4 signature', NULL, NULL, 'AQUAPORIN4', 279216),
(460123, 'PR01666', NULL, 'Voltage-gated Na+ channel alpha 5 subunit signature', NULL, NULL, 'NACHANNEL5', 279217),
(460124, 'PR01875', NULL, 'Eight-Twenty-One (ETO) family signature', NULL, NULL, 'ETOFAMILY', 279218),
(460125, 'PR01172', NULL, 'Beta-lactoglobulin signature', NULL, NULL, 'BLCTOGLOBULN', 279219),
(460126, 'PR01191', NULL, 'Glucose transporter type 2 (GLUT2) signature', NULL, NULL, 'GLUCTRSPORT2', 279220);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(460127, 'PR00941', NULL, 'Cadmium-transporting ATPase signature', NULL, NULL, 'CDATPASE', 279221),
(460128, 'PR00367', NULL, 'Ethylene responsive element binding protein signature', NULL, NULL, 'ETHRSPELEMNT', 279222),
(460129, 'PR01437', NULL, 'NADH-ubiquinone oxidoreductase subunit 4 signature', NULL, NULL, 'NUOXDRDTASE4', 279223),
(460130, 'PR01246', NULL, 'Rad1 repair protein signature', NULL, NULL, 'RAD1REPAIR', 279224),
(460131, 'PR01545', NULL, 'Thermotoga maritima hypothetical protein TM1410 signature', NULL, NULL, 'THEMAYE10DUF', 279225),
(460132, 'PR01972', NULL, 'Tumour necrosis factor receptor 25 signature', NULL, NULL, 'TNFACTORR25', 279226),
(460133, 'PR00898', NULL, 'Vasopressin V2 receptor signature', NULL, NULL, 'VASOPRSNV2R', 279227),
(460134, 'PR01612', NULL, 'Corticotropin-releasing factor family signature', NULL, NULL, 'CRFFAMILY', 279228),
(460135, 'PR00521', NULL, 'Androgen receptor (3C nuclear receptor) signature', NULL, NULL, 'ANDROGENR', 279229),
(460136, 'PR01425', NULL, 'Transforming growth factor beta 2 precursor signature', NULL, NULL, 'TGFBETA2', 279230),
(460137, 'PR00558', NULL, 'Alpha-2A adrenergic receptor signature', NULL, NULL, 'ADRENRGCA2AR', 279231),
(460138, 'PR01184', NULL, 'Ornatin signature', NULL, NULL, 'ORNATIN', 279232),
(460139, 'PR00773', NULL, 'GrpE protein signature', NULL, NULL, 'GRPEPROTEIN', 279233),
(460140, 'PR00468', NULL, 'Plant lipoxygenase signature', NULL, NULL, 'PLTLPOXGNASE', 279234),
(460141, 'PR01453', NULL, 'Epithelial membrane protein (EMP/PMP22/LMIP) family signature', NULL, NULL, 'EPMEMFAMILY', 279235),
(460142, 'PR01435', NULL, 'NADH-plastoquinone oxidoreductase chain 5 signature', NULL, NULL, 'NPOXDRDTASE5', 279236),
(460143, 'PR00789', NULL, 'O-sialoglycoprotein endopeptidase (M22) metallo-protease family signature', NULL, NULL, 'OSIALOPTASE', 279237),
(460144, 'PR00819', NULL, 'CbxX/CfqX superfamily signature', NULL, NULL, 'CBXCFQXSUPER', 279238),
(460145, 'PR01692', NULL, 'Lipocalin-1 interacting membrane receptor signature', NULL, NULL, 'LIPOCALINIMR', 279239),
(460146, 'PR01734', NULL, 'Type III secretion system outer membrane B protein family signature', NULL, NULL, 'TYPE3OMBPROT', 279240),
(460147, 'PR01959', NULL, 'SuhB family inositol monophosphatase signature', NULL, NULL, 'SBIMPHPHTASE', 279241),
(460148, 'PR00394', NULL, 'RHS protein signature', NULL, NULL, 'RHSPROTEIN', 279242),
(460149, 'PR01235', NULL, 'Tumour necrosis factor alpha (cachectin) signature', NULL, NULL, 'TNFALPHA', 279243),
(460150, 'PR01802', NULL, 'Synembryn family signature', NULL, NULL, 'SYNEMBRYN', 279244),
(460151, 'PR00849', NULL, 'Glycosyl hydrolase family 58 signature', NULL, NULL, 'GLHYDRLASE58', 279245),
(460152, 'PR01594', NULL, 'Bacterial protein-transport SecB chaperone protein signature', NULL, NULL, 'SECBCHAPRONE', 279246),
(460153, 'PR01814', NULL, 'Plant annexin signature', NULL, NULL, 'ANNEXINPLANT', 279247),
(460154, 'PR01018', NULL, 'Prolactin-releasing peptide receptor signature', NULL, NULL, 'PRPRECEPTOR', 279248),
(460155, 'PR01663', NULL, 'Mini-chromosome maintenance (MCM) protein 7 signature', NULL, NULL, 'MCMPROTEIN7', 279249),
(460156, 'PR00997', NULL, 'Fragilysin metallopeptidase (M10C) enterotoxin signature', NULL, NULL, 'FRAGILYSIN', 279250),
(460157, 'PR00809', NULL, 'Rice seed allergenic protein RAG signature', NULL, NULL, 'RAGALLERGEN', 279251),
(460158, 'PR00113', NULL, 'Alkaline phosphatase signature', NULL, NULL, 'ALKPHPHTASE', 279252),
(460159, 'PR00915', NULL, 'Luteovirus group 1 coat protein signature', NULL, NULL, 'LUTEOGP1COAT', 279253),
(460160, 'PR00102', NULL, 'Ornithine carbamoyltransferase signature', NULL, NULL, 'OTCASE', 279254),
(460161, 'PR01353', NULL, 'Glucagon family receptor signature', NULL, NULL, 'GLUCAGNFAMLY', 279255),
(460162, 'PR01344', NULL, 'Salmonella/Shigella invasion protein E (InvE) signature', NULL, NULL, 'INVEPROTEIN', 279256),
(460163, 'PR00118', NULL, 'Beta-lactamase class A signature', NULL, NULL, 'BLACTAMASEA', 279257),
(460164, 'PR00056', NULL, 'Heat shock factor (HSF) domain signature', NULL, NULL, 'HSFDOMAIN', 279258);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(460165, 'PR01255', NULL, 'Otx transcription factor signature', NULL, NULL, 'OTXHOMEOBOX', 279259),
(460166, 'PR02024', NULL, 'Aquaporin-11 signature', NULL, NULL, 'AQUAPORIN11', 279260),
(460167, 'PR00315', NULL, 'GTP-binding elongation factor signature', NULL, NULL, 'ELONGATNFCT', 279261),
(460168, 'PR01294', NULL, 'Interleukin-10 signature', NULL, NULL, 'INTRLEUKIN10', 279262),
(460169, 'PR01788', NULL, 'Prostanoid receptor signature', NULL, NULL, 'PROSTANOIDR', 279263),
(460170, 'PR01887', NULL, 'Spectrin alpha chain signature', NULL, NULL, 'SPECTRNALPHA', 279264),
(460171, 'PR01009', NULL, 'Flagellar M-ring protein signature', NULL, NULL, 'FLGMRINGFLIF', 279265),
(460172, 'PR00639', NULL, 'Neuromedin B receptor signature', NULL, NULL, 'NEUROMEDINBR', 279266),
(460173, 'PR00382', NULL, 'Plant phospholipid transfer protein signature', NULL, NULL, 'LIPIDTRNSFER', 279267),
(460174, 'PR00832', NULL, 'Paxillin signature', NULL, NULL, 'PAXILLIN', 279268),
(460175, 'PR00983', NULL, 'Cysteinyl-tRNA synthetase signature', NULL, NULL, 'TRNASYNTHCYS', 279269),
(460176, 'PR01954', NULL, 'Epidermin biosynthesis protein EpiC signature', NULL, NULL, 'EPICPROTEIN', 279270),
(460177, 'PR01911', NULL, 'Plant and fungal dual specificity phosphatase signature', NULL, NULL, 'PFDSPHPHTASE', 279271),
(460178, 'PR00181', NULL, 'Maltose binding protein signature', NULL, NULL, 'MALTOSEBP', 279272),
(460179, 'PR01028', NULL, 'Opioid neuropeptide precursor signature', NULL, NULL, 'OPIOIDPRCRSR', 279273),
(460180, 'PR01222', NULL, 'Atrophin signature', NULL, NULL, 'ATROPHIN', 279274),
(460181, 'PR02106', NULL, 'Integrator complex subunit 10 signature', NULL, NULL, 'INTSUBUNIT10', 279275),
(460182, 'PR01169', NULL, 'Ceratitis capitata alcohol dehydrogenase signature', NULL, NULL, 'CERATITISADH', 279276),
(460183, 'PR00984', NULL, 'Isoleucyl-tRNA synthetase signature', NULL, NULL, 'TRNASYNTHILE', 279277),
(460184, 'PR01643', NULL, 'Transient receptor potential channel 2 signature', NULL, NULL, 'TRPCHANNEL2', 279278),
(460185, 'PR01440', NULL, 'Cellulose synthase subunit B signature', NULL, NULL, 'CELLSNTHASEB', 279279),
(460186, 'PR00448', NULL, 'NSF attachment protein signature', NULL, NULL, 'NSFATTACHMNT', 279280),
(460187, 'PR01722', NULL, 'Gamma-aminobutyric-acid A receptor delta subunit signature', NULL, NULL, 'GABAARDELTA', 279281),
(460188, 'PR00514', NULL, '5-hydroxytryptamine 1D receptor signature', NULL, NULL, '5HT1DRECEPTR', 279282),
(460189, 'PR02113', NULL, 'Mas-related G protein-coupled receptor H signature', NULL, NULL, 'MRGPCRH', 279283),
(460190, 'PR00999', NULL, 'Fungalysin metallopeptidase (M36) signature', NULL, NULL, 'FUNGALYSIN', 279284),
(460191, 'PR00348', NULL, 'Ubiquitin signature', NULL, NULL, 'UBIQUITIN', 279285),
(460192, 'PR01758', NULL, 'Capsule biosynthesis protein CapB signature', NULL, NULL, 'CAPSULEPROTB', 279286),
(460193, 'PR01998', NULL, 'Staphylococcal phage major tail protein signature', NULL, NULL, 'MTP2STAPHYLO', 279287),
(460194, 'PR00953', NULL, 'Type III secretion system inner membrane R protein family signature', NULL, NULL, 'TYPE3IMRPROT', 279288),
(460195, 'PR01719', NULL, 'MHC class II transactivator signature', NULL, NULL, 'MHCIIACTVATR', 279289),
(460196, 'PR02026', NULL, 'YtrC/YtrD probable ABC transporter permease signature', NULL, NULL, 'YTRCYTRDABC', 279290),
(460197, 'PR01541', NULL, 'Gonadoliberin I precursor signature', NULL, NULL, 'GONADOLIBRNI', 279291),
(460198, 'PR00854', NULL, 'Prostaglandin D receptor signature', NULL, NULL, 'PRSTNOIDDPR', 279292),
(460199, 'PR00002', NULL, 'Bone matrix GLA domain signature', NULL, NULL, 'GLABONE', 279293),
(460200, 'PR00879', NULL, 'Fish acetylcholinesterase signature', NULL, NULL, 'ACHEFISH', 279294),
(460201, 'PR00224', NULL, 'Geminivirus AR1 coat protein signature', NULL, NULL, 'GEMCOATAR1', 279295),
(460202, 'PR00006', NULL, 'Cofilin/destrin family signature', NULL, NULL, 'COFILIN', 279296),
(460203, 'PR00783', NULL, 'Major intrinsic protein family signature', NULL, NULL, 'MINTRINSICP', 279297),
(460204, 'PR01861', NULL, 'ADAM-TS8 protein signature', NULL, NULL, 'ADAMTS8', 279298);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(460205, 'PR01231', NULL, 'HCO3- transporter superfamily signature', NULL, NULL, 'HCO3TRNSPORT', 279299),
(460206, 'PR02080', NULL, 'Toxin Pg family signature', NULL, NULL, 'TOXINPGFAMLY', 279300),
(460207, 'PR00079', NULL, 'Glucose-6-phosphate dehydrogenase signature', NULL, NULL, 'G6PDHDRGNASE', 279301),
(460208, 'PR00077', NULL, 'NAD-dependent glycerol-3-phosphate dehydrogenase signature', NULL, NULL, 'GPDHDRGNASE', 279302),
(460209, 'PR00474', NULL, 'Glutamate 5-kinase family signature', NULL, NULL, 'GLU5KINASE', 279303),
(460210, 'PR00261', NULL, 'Low density lipoprotein (LDL) receptor signature', NULL, NULL, 'LDLRECEPTOR', 279304),
(460211, 'PR00389', NULL, 'Phospholipase A2 signature', NULL, NULL, 'PHPHLIPASEA2', 279305),
(460212, 'PR01466', NULL, 'Bacterial arginine deiminase signature', NULL, NULL, 'ARGDEIMINASE', 279306),
(460213, 'PR01912', NULL, 'Brain derived neurotrophic factor signature', NULL, NULL, 'BDNFACTOR', 279307),
(460214, 'PR02019', NULL, 'Aquaporin-7 signature', NULL, NULL, 'AQUAPORIN7', 279308),
(460215, 'PR00517', NULL, '5-hydroxytryptamine 2C receptor signature', NULL, NULL, '5HT2CRECEPTR', 279309),
(460216, 'PR00342', NULL, 'Rhesus blood group protein signature', NULL, NULL, 'RHESUSRHD', 279310),
(460217, 'PR00478', NULL, 'Phosphoribulokinase family signature', NULL, NULL, 'PHRIBLKINASE', 279311),
(460218, 'PR01310', NULL, 'P2X3 purinoceptor signature', NULL, NULL, 'P2X3RECEPTOR', 279312),
(460219, 'PR00362', NULL, 'Cannabinoid receptor signature', NULL, NULL, 'CANNABINOIDR', 279313),
(460220, 'PR02037', NULL, 'FPRL1 inhibitory protein signature', NULL, NULL, 'FLIPR', 279314),
(460221, 'PR01189', NULL, 'Anion exchanger isoform 3 signature', NULL, NULL, 'ANIONEXHNGR3', 279315),
(460222, 'PR01407', NULL, 'Butyrophylin C-terminal DUF signature', NULL, NULL, 'BUTYPHLNCDUF', 279316),
(460223, 'PR02089', NULL, 'HAUS augmin-like complex subunit 3 signature', NULL, NULL, 'HAUSAUGMINL3', 279317),
(460224, 'PR00143', NULL, 'Citrate synthase signature', NULL, NULL, 'CITRTSNTHASE', 279318),
(460225, 'PR00985', NULL, 'Leucyl-tRNA synthetase signature', NULL, NULL, 'TRNASYNTHLEU', 279319),
(460226, 'PR00893', NULL, 'Rab escort (choroideraemia) protein signature', NULL, NULL, 'RABESCORT', 279320),
(460227, 'PR01964', NULL, 'Tumour necrosis factor receptor 13C signature', NULL, NULL, 'TNFACTORR13C', 279321),
(460228, 'PR01674', NULL, 'Glycine receptor alpha 1 subunit signature', NULL, NULL, 'GLYRALPHA1', 279322),
(460229, 'PR00216', NULL, 'Osteopontin signature', NULL, NULL, 'OSTEOPONTIN', 279323),
(460230, 'PR00324', NULL, 'Nisin signature', NULL, NULL, 'NISIN', 279324),
(460231, 'PR00422', NULL, 'Transferrin signature', NULL, NULL, 'TRANSFERRIN', 279325),
(460232, 'PR01221', NULL, 'Rodent urinary protein signature', NULL, NULL, 'MAJORURINARY', 279326),
(460233, 'PR01739', NULL, 'Relaxin receptor family signature', NULL, NULL, 'RELAXINR', 279327),
(460234, 'PR01783', NULL, 'Melanin-concentrating hormone receptor family signature', NULL, NULL, 'MCHRECEPTOR', 279328),
(460235, 'PR01020', NULL, 'Lipopolysaccharide core biosynthesis protein signature', NULL, NULL, 'LPSBIOSNTHSS', 279329),
(460236, 'PR00590', NULL, 'Somatostatin receptor type 4 signature', NULL, NULL, 'SOMATOSTTN4R', 279330),
(460237, 'PR00743', NULL, 'Glycosyl hydrolase family 36 signature', NULL, NULL, 'GLHYDRLASE36', 279331),
(460238, 'PR00523', NULL, 'Cannabinoid receptor type 2 signature', NULL, NULL, 'CANABINOID2R', 279332),
(460239, 'PR00611', NULL, 'Erythrocruorin family signature', NULL, NULL, 'ERYTHCRUORIN', 279333),
(460240, 'PR00020', NULL, 'MAM domain signature', NULL, NULL, 'MAMDOMAIN', 279334),
(460241, 'PR01840', NULL, 'Bacterial Sec-independent translocation TatC protein family signature', NULL, NULL, 'TATCFAMILY', 279335),
(460242, 'PR01996', NULL, 'Phage major tail protein 1 family signature', NULL, NULL, 'MTP1FAMILY', 279336),
(460243, 'PR02044', NULL, 'Fibrosin-1-like protein family signature', NULL, NULL, 'FIBROSIN1LPF', 279337),
(460244, 'PR00081', NULL, 'Glucose/ribitol dehydrogenase family signature', NULL, NULL, 'GDHRDH', 279338);
INSERT INTO "PUBLIC"."MODEL" VALUES
(460245, 'PR00903', NULL, 'VP7 core protein signature', NULL, NULL, 'VP7CAPSID', 279339),
(460246, 'PR01436', NULL, 'NADH-ubiquinone oxidoreductase chain 2 signature', NULL, NULL, 'NADHDHGNASE2', 279340),
(460247, 'PR01999', NULL, 'Lactococcal phage major tail protein signature', NULL, NULL, 'MTP2LACTO', 279341),
(460248, 'PR01058', NULL, 'Metabotropic glutamate receptor 8 signature', NULL, NULL, 'MTABOTROPC8R', 279342),
(460249, 'PR02085', NULL, 'DNA-directed RNA polymerase II subunit GRINL1 signature', NULL, NULL, 'POLR2GRINL1', 279343),
(460250, 'PR00233', NULL, 'Icosahedral viral capsid protein signature', NULL, NULL, 'ICOSAHEDRAL', 279344),
(460251, 'PR00366', NULL, 'Endothelin receptor signature', NULL, NULL, 'ENDOTHELINR', 279345),
(460252, 'PR02055', NULL, 'Protein family FAM105 signature', NULL, NULL, 'PROTEINF105', 279346),
(460253, 'PR01615', NULL, 'Gamma-aminobutyric-acid A receptor alpha 2 subunit signature', NULL, NULL, 'GABAARALPHA2', 279347),
(460254, 'PR01358', NULL, 'Interleukin-1 alpha precursor signature', NULL, NULL, 'INTRLEUKIN1A', 279348),
(460255, 'PR00379', NULL, 'Intein signature', NULL, NULL, 'INTEIN', 279349),
(460256, 'PR00880', NULL, 'Insect acetylcholinesterase signature', NULL, NULL, 'ACHEINSECT', 279350),
(460257, 'PR01051', NULL, 'Metabotropic glutamate receptor 1 signature', NULL, NULL, 'MTABOTROPC1R', 279351),
(460258, 'PR01776', NULL, 'Helicobacter pylori outer membrane protein family signature', NULL, NULL, 'HPOMPFAMILY', 279352),
(460259, 'PR00298', NULL, '60kDa chaperonin signature', NULL, NULL, 'CHAPERONIN60', 279353),
(460260, 'PR00629', NULL, 'SHC phosphotyrosine interaction domain signature', NULL, NULL, 'SHCPIDOMAIN', 279354),
(460261, 'PR00971', NULL, 'Ribosomal protein S10 family signature', NULL, NULL, 'RIBOSOMALS10', 279355),
(460262, 'PR00967', NULL, 'Acute myeloid leukemia 1 protein signature', NULL, NULL, 'ONCOGENEAML1', 279356),
(460263, 'PR00409', NULL, 'Phthalate dioxygenase reductase family signature', NULL, NULL, 'PHDIOXRDTASE', 279357),
(460264, 'PR00014', NULL, 'Fibronectin type III repeat signature', NULL, NULL, 'FNTYPEIII', 279358),
(460265, 'PR00672', NULL, 'Inhibin beta C chain signature', NULL, NULL, 'INHIBINBC', 279359),
(460266, 'PR01515', NULL, 'Kv2.2 voltage-gated K+ channel signature', NULL, NULL, 'KV22CHANNEL', 279360),
(460267, 'PR00696', NULL, 'Crossover junction endodeoxyribonuclease RUVC signature', NULL, NULL, 'RSOLVASERUVC', 279361),
(460268, 'PR00157', NULL, 'Plastocyanin signature', NULL, NULL, 'PLASTOCYANIN', 279362),
(460269, 'PR01529', NULL, 'C-C chemokine receptor type 6 signature', NULL, NULL, 'CHEMOKINER6', 279363),
(460270, 'PR01816', NULL, 'Beta-site APP cleaving enzyme 1 (BACE1) signature', NULL, NULL, 'BACE1', 279364),
(460271, 'PR01955', NULL, 'Frankia sp. LanC-like protein signature', NULL, NULL, 'LANCFRANKIA', 279365),
(460272, 'PR00488', NULL, 'Five-lipoxygenase activating protein signature', NULL, NULL, '5LPOXGNASEAP', 279366),
(460273, 'PR00814', NULL, 'Beta haemoglobin signature', NULL, NULL, 'BETAHAEM', 279367),
(460274, 'PR00453', NULL, 'Von Willebrand factor type A domain signature', NULL, NULL, 'VWFADOMAIN', 279368),
(460275, 'PR00565', NULL, 'Dopamine 1A receptor signature', NULL, NULL, 'DOPAMINED1AR', 279369),
(460276, 'PR01943', NULL, 'Mammalian interleukin-11 signature', NULL, NULL, 'INTLKN11MAML', 279370),
(460277, 'PR01167', NULL, 'Insect alcohol dehydrogenase family signature', NULL, NULL, 'INSADHFAMILY', 279371),
(460278, 'PR00248', NULL, 'Metabotropic glutamate GPCR signature', NULL, NULL, 'GPCRMGR', 279372),
(460279, 'PR00397', NULL, 'Sirohaem Fe-binding site signature', NULL, NULL, 'SIROHAEM', 279373),
(460280, 'PR01874', NULL, 'DNA repair protein radA signature', NULL, NULL, 'DNAREPAIRADA', 279374),
(460281, 'PR01034', NULL, 'Ribosomal protein S12 signature', NULL, NULL, 'RIBOSOMALS12', 279375),
(460282, 'PR00287', NULL, 'Plant thionin signature', NULL, NULL, 'THIONIN', 279376),
(460283, 'PR01738', NULL, 'RNA binding motif protein 8 family signature', NULL, NULL, 'RNABINDINGM8', 279377);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(460284, 'PR01697', NULL, 'Parvalbumin signature', NULL, NULL, 'PARVALBUMIN', 279378),
(460285, 'PR01467', NULL, 'Bacterial arginine repressor signature', NULL, NULL, 'ARGREPRESSOR', 279379),
(460286, 'PR00834', NULL, 'HtrA/DegQ protease family signature', NULL, NULL, 'PROTEASES2C', 279380),
(460287, 'PR00306', NULL, 'Serum amyloid A protein signature', NULL, NULL, 'SERUMAMYLOID', 279381),
(460288, 'PR00714', NULL, 'Phosphomannose isomerase type I signature', NULL, NULL, 'MAN6PISMRASE', 279382),
(460289, 'PR00801', NULL, 'Adrenomedullin signature', NULL, NULL, 'ADRENOMEDULN', 279383),
(460290, 'PR00347', NULL, 'Pathogenesis-related protein signature', NULL, NULL, 'THAUMATIN', 279384),
(460291, 'PR01372', NULL, 'Yersinia virulence determinant YopE protein signature', NULL, NULL, 'YERSINIAYOPE', 279385),
(460292, 'PR00259', NULL, 'Transmembrane four family signature', NULL, NULL, 'TMFOUR', 279386),
(460293, 'PR00284', NULL, 'Toxin signature', NULL, NULL, 'TOXIN', 279387),
(460294, 'PR02076', NULL, 'Protein FYV8 signature', NULL, NULL, 'PROTEINFYV8', 279388),
(460295, 'PR00449', NULL, 'Transforming protein P21 ras signature', NULL, NULL, 'RASTRNSFRMNG', 279389),
(460296, 'PR02018', NULL, 'Aquaporin-6 signature', NULL, NULL, 'AQUAPORIN6', 279390),
(460297, 'PR00549', NULL, 'Hyperglycemic hormone type 2 signature', NULL, NULL, 'HYPRGLYCEMC2', 279391),
(460298, 'PR00728', NULL, 'Eukaryotic signal peptidase (S26B) family signature', NULL, NULL, 'SIGNALPTASE', 279392),
(460299, 'PR00156', NULL, 'Type I copper blue protein family signature', NULL, NULL, 'COPPERBLUE', 279393),
(460300, 'PR00177', NULL, 'NMDA receptor signature', NULL, NULL, 'NMDARECEPTOR', 279394),
(460301, 'PR01616', NULL, 'Gamma-aminobutyric-acid A receptor alpha 3 subunit signature', NULL, NULL, 'GABAARALPHA3', 279395),
(460302, 'PR00553', NULL, 'Adenosine A2A receptor signature', NULL, NULL, 'ADENOSINA2AR', 279396),
(460303, 'PR01626', NULL, 'L-type calcium channel beta subunit signature', NULL, NULL, 'LCACHANNELB', 279397),
(460304, 'PR00767', NULL, 'Dopamine-beta-monooxygenase signature', NULL, NULL, 'DBMONOXGNASE', 279398),
(460305, 'PR01216', NULL, 'Adhesive plaque protein signature', NULL, NULL, 'ADHESIVEI', 279399),
(460306, 'PR00718', NULL, 'Phospholipase D signature', NULL, NULL, 'PHPHLIPASED', 279400),
(460307, 'PR00222', NULL, 'Cucumovirus coat protein signature', NULL, NULL, 'CUCUMOCOAT', 279401),
(460308, 'PR00677', NULL, 'Phosducin signature', NULL, NULL, 'PHOSDUCIN', 279402),
(460309, 'PR00499', NULL, 'Neutrophil cytosol factor 2 signature', NULL, NULL, 'P67PHOX', 279403),
(460310, 'PR01721', NULL, 'Fractalkine/neurotactin precursor signature', NULL, NULL, 'FRACTALKINE', 279404),
(460311, 'PR01716', NULL, 'Death associated protein 3 family signature', NULL, NULL, 'DEATHASSOCP3', 279405),
(460312, 'PR01215', NULL, 'Alpha-1-microglobulin signature', NULL, NULL, 'A1MCGLOBULIN', 279406),
(460313, 'PR01556', NULL, 'Type IV secretion system CagX conjugation protein signature', NULL, NULL, 'TYPE4SSCAGX', 279407),
(460314, 'PR02108', NULL, 'Mas-related G-protein coupled receptor family signature', NULL, NULL, 'MRGPCRFAMILY', 279408),
(460315, 'PR01951', NULL, 'Eukaryotic LanC-like protein family signature', NULL, NULL, 'LANCEUKARYTE', 279409),
(460316, 'PR00029', NULL, 'Octamer-binding transcription factor signature', NULL, NULL, 'OCTAMER', 279410),
(460317, 'PR01278', NULL, 'CD97 protein signature', NULL, NULL, 'CD97PROTEIN', 279411),
(460318, 'PR01784', NULL, 'Melanin-concentrating hormone 2 receptor signature', NULL, NULL, 'MCH2RECEPTOR', 279412),
(460319, 'PR01793', NULL, 'Voltage-dependent calcium channel gamma-5 subunit signature', NULL, NULL, 'VDCCGAMMA5', 279413),
(460320, 'PR01157', NULL, 'P2Y purinoceptor signature', NULL, NULL, 'P2YPURNOCPTR', 279414),
(460321, 'PR01773', NULL, 'P38 MAP kinase signature', NULL, NULL, 'P38MAPKINASE', 279415),
(460322, 'PR00735', NULL, 'Glycosyl hydrolase family 8 signature', NULL, NULL, 'GLHYDRLASE8', 279416),
(460323, 'PR00937', NULL, 'T-Box domain signature', NULL, NULL, 'TBOX', 279417); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(460324, 'PR00484', NULL, 'Pheromone/general odorant binding protein signature', NULL, NULL, 'PBPGOBP', 279418),
(460325, 'PR01884', NULL, 'Myelin and lymphocyte protein family', NULL, NULL, 'MALPROTEIN', 279419),
(460326, 'PR00505', NULL, 'D12 class N6 adenine-specific DNA methyltransferase signature', NULL, NULL, 'D12N6MTFRASE', 279420),
(460327, 'PR00649', NULL, 'GPR6 orphan receptor signature', NULL, NULL, 'GPR6ORPHANR', 279421),
(460328, 'PR00935', NULL, 'Band 4.1 protein family signature', NULL, NULL, 'BAND41', 279422),
(460329, 'PR00917', NULL, 'Small round structured virus (C37) cysteine protease family signature', NULL, NULL, 'SRSVCYSPTASE', 279423),
(460330, 'PR00065', NULL, 'TEA domain signature', NULL, NULL, 'TEADOMAIN', 279424),
(460331, 'PR01413', NULL, 'Cytochrome c-type biogenesis protein NrfE signature', NULL, NULL, 'NRFEBIOGNSIS', 279425),
(460332, 'PR01549', NULL, 'Autoinducer synthesis protein signature', NULL, NULL, 'AUTOINDCRSYN', 279426),
(460333, 'PR01735', NULL, 'P2Y13 purinoceptor signature', NULL, NULL, 'P2Y13PRNCPTR', 279427),
(460334, 'PR01280', NULL, 'Corticotropin releasing factor type 1 receptor signature', NULL, NULL, 'CRFRECEPTOR1', 279428),
(460335, 'PR01985', NULL, 'Neurogenic locus Notch protein 2 signature', NULL, NULL, 'NOTCH2', 279429),
(460336, 'PR00308', NULL, 'Type I antifreeze protein signature', NULL, NULL, 'ANTIFREEZEI', 279430),
(460337, 'PR01770', NULL, 'ERK1/2 MAP kinase signature', NULL, NULL, 'ERK1ERK2MAPK', 279431),
(460338, 'PR01948', NULL, 'Avian interleukin-15 signature', NULL, NULL, 'INTLKN15BIRD', 279432),
(460339, 'PR00691', NULL, 'Adhesin B signature', NULL, NULL, 'ADHESINB', 279433),
(460340, 'PR01970', NULL, 'Tumour necrosis factor receptor 19-like signature', NULL, NULL, 'TNFACTORR19L', 279434),
(460341, 'PR01426', NULL, 'Transforming growth factor beta 3 precursor signature', NULL, NULL, 'TGFBETA3', 279435),
(460342, 'PR02025', NULL, 'Aquaporin-12 signature', NULL, NULL, 'AQUAPORIN12', 279436),
(460343, 'PR01325', NULL, 'Kir2.2 inward rectifier K+ channel signature', NULL, NULL, 'KIR22CHANNEL', 279437),
(460344, 'PR00195', NULL, 'Dynamin signature', NULL, NULL, 'DYNAMIN', 279438),
(460345, 'PR00520', NULL, 'Adrenocorticotrophin receptor signature', NULL, NULL, 'ACTROPHINR', 279439),
(460346, 'PR00926', NULL, 'Mitochondrial carrier protein signature', NULL, NULL, 'MITOCARRIER', 279440),
(460347, 'PR01152', NULL, 'Protease activated receptor 2 precursor signature', NULL, NULL, 'PROTEASEAR2', 279441),
(460348, 'PR00671', NULL, 'Inhibin beta B chain signature', NULL, NULL, 'INHIBINBB', 279442),
(460349, 'PR01829', NULL, 'Protachykinin 1 precursor signature', NULL, NULL, 'PROTACHYKNIN', 279443),
(460350, 'PR01495', NULL, 'Shab voltage-gated K+ channel family signature', NULL, NULL, 'SHABCHANNEL', 279444),
(460351, 'PR01395', NULL, 'Bordetella pertussis toxin A subunit signature', NULL, NULL, 'BORPETOXINA', 279445),
(460352, 'PR00868', NULL, 'DNA-polymerase family A (pol I) signature', NULL, NULL, 'DNAPOLI', 279446),
(460353, 'PR02021', NULL, 'Aquaporin-9 signature', NULL, NULL, 'AQUAPORIN9', 279447),
(460354, 'PR01644', NULL, 'Transient receptor potential channel 3 signature', NULL, NULL, 'TRPCHANNEL3', 279448),
(460355, 'PR00853', NULL, 'Xeroderma pigmentosum group G/yeast RAD superfamily signature', NULL, NULL, 'XPGRADSUPER', 279449),
(460356, 'PR00530', NULL, 'Histamine H1 receptor signature', NULL, NULL, 'HISTAMINEH1R', 279450),
(460357, 'PR01925', NULL, 'Mammalian nerve growth factor beta subunit signature', NULL, NULL, 'MAMLNGFBETA', 279451),
(460358, 'PR01856', NULL, 'Basigin signature', NULL, NULL, 'BASIGIN', 279452),
(460359, 'PR00243', NULL, 'Muscarinic acetylcholine receptor signature', NULL, NULL, 'MUSCARINICR', 279453),
(460360, 'PR01731', NULL, 'Lymphotactin precursor signature', NULL, NULL, 'LYMPHOTACTIN', 279454),
(460361, 'PR00066', NULL, 'Xeroderma pigmentosum group G protein signature', NULL, NULL, 'XRODRMPGMNTG', 279455),
(460362, 'PR01423', NULL, 'Transforming growth factor beta precursor signature', NULL, NULL, 'TGFBETA', 279456);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(460363, 'PR00044', NULL, 'Myc proto-oncogene signature', NULL, NULL, 'LEUZIPPRMYC', 279457),
(460364, 'PR00516', NULL, '5-hydroxytryptamine 2A receptor signature', NULL, NULL, '5HT2ARECEPTR', 279458),
(460365, 'PR00498', NULL, 'Neutrophil cytosol factor 1 signature', NULL, NULL, 'P47PHOX', 279459),
(460366, 'PR01789', NULL, 'Nuclear factor of activated T cells (NFAT) signature', NULL, NULL, 'NUCFACTORATC', 279460),
(460367, 'PR01346', NULL, 'Helicobacter neutrophil-activating protein A family signature', NULL, NULL, 'HELNAPAPROT', 279461),
(460368, 'PR01941', NULL, 'Neurotrophic tyrosine kinase receptor type 2 signature', NULL, NULL, 'NTKRECEPTOR2', 279462),
(460369, 'PR00399', NULL, 'Synaptotagmin signature', NULL, NULL, 'SYNAPTOTAGMN', 279463),
(460370, 'PR00225', NULL, 'Geminivirus BR1 coat protein signature', NULL, NULL, 'GEMCOATBR1', 279464),
(460371, 'PR00141', NULL, 'Proteasome component signature', NULL, NULL, 'PROTEASOME', 279465),
(460372, 'PR01786', NULL, 'Paraoxonase 1 signature', NULL, NULL, 'PARAOXONASE1', 279466),
(460373, 'PR00501', NULL, 'Kelch repeat signature', NULL, NULL, 'KELCHREPEAT', 279467),
(460374, 'PR01411', NULL, 'Cytochrome c-type biogenesis protein CcmF signature', NULL, NULL, 'CCMFBIOGNSIS', 279468),
(460375, 'PR00286', NULL, 'Charybdotoxin signature', NULL, NULL, 'CHARYBDTOXIN', 279469),
(460376, 'PR01817', NULL, 'Beta-site APP cleaving enzyme 2 (BACE2) signature', NULL, NULL, 'BACE2', 279470),
(460377, 'PR00395', NULL, 'Ribosomal protein S2 signature', NULL, NULL, 'RIBOSOMALS2', 279471),
(460378, 'PR01348', NULL, 'Nucleotide-sensitive chloride conductance regulator (ICln) signature', NULL, NULL, 'ICLNCHANNEL', 279472),
(460379, 'PR00920', NULL, 'Spumavirus aspartic protease (A9) signature', NULL, NULL, 'SPUMVIRPTASE', 279473),
(460380, 'PR00383', NULL, 'Pro-opiomelanocortin signature', NULL, NULL, 'MELANOCORTIN', 279474),
(460381, 'PR00833', NULL, 'Pollen allergen Poa pI signature', NULL, NULL, 'POAALLERGEN', 279475),
(460382, 'PR01963', NULL, 'Tumour necrosis factor receptor 13B signature', NULL, NULL, 'TNFACTORR13B', 279476),
(460383, 'PR00513', NULL, '5-hydroxytryptamine 1B receptor signature', NULL, NULL, '5HT1BRECEPTR', 279477),
(460384, 'PR01129', NULL, 'Gastric inhibitory polypeptide receptor precursor signature', NULL, NULL, 'GIPRECEPTOR', 279478),
(460385, 'PR01359', NULL, 'Interleukin-1 beta precursor signature', NULL, NULL, 'INTRLEUKIN1B', 279479),
(460386, 'PR01631', NULL, 'N-type voltage-dependent calcium channel alpha-1 subunit signature', NULL, NULL, 'NVDCCALPHA1', 279480),
(460387, 'PR00535', NULL, 'Melanocortin receptor signature', NULL, NULL, 'MELNOCORTINR', 279481),
(460388, 'PR00682', NULL, 'Isopenicillin N synthase signature', NULL, NULL, 'IPNSYNTHASE', 279482),
(460389, 'PR01725', NULL, 'Gamma-aminobutyric-acid A receptor theta subunit signature', NULL, NULL, 'GABAARTHETA', 279483),
(460390, 'PR00515', NULL, '5-hydroxytryptamine 1F receptor signature', NULL, NULL, '5HT1FRECEPTR', 279484),
(460391, 'PR01038', NULL, 'Arginyl-tRNA synthetase signature', NULL, NULL, 'TRNASYNTHARG', 279485),
(460392, 'PR00798', NULL, 'Togavirin (S3) serine protease family signature', NULL, NULL, 'TOGAVIRIN', 279486),
(460393, 'PR01010', NULL, 'Flagellar P-ring protein signature', NULL, NULL, 'FLGPRINGFLGI', 279487),
(460394, 'PR00103', NULL, 'cAMP-dependent protein kinase signature', NULL, NULL, 'CAMPKINASE', 279488),
(460395, 'PR00940', NULL, 'Cation-transporting P-type ATPase A signature', NULL, NULL, 'CATPATPASEA', 279489),
(460396, 'PR02010', NULL, 'RNA (C5-cytosine) methyltransferase subfamily 9 signature', NULL, NULL, 'RCMT9', 279490),
(460397, 'PR01767', NULL, 'Epithelial calcium channel 2 (ECAC2) family signature', NULL, NULL, 'ECACCHANNEL2', 279491),
(460398, 'PR00512', NULL, '5-hydroxytryptamine 1A receptor signature', NULL, NULL, '5HT1ARECEPTR', 279492),
(460399, 'PR00371', NULL, 'Flavoprotein pyridine nucleotide cytochrome reductase signature', NULL, NULL, 'FPNCR', 279493),
(460400, 'PR00652', NULL, '5-hydroxytryptamine 7 receptor signature', NULL, NULL, '5HT7RECEPTR', 279494);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(460401, 'PR00763', NULL, 'Coagulin signature', NULL, NULL, 'COAGULIN', 279495),
(460402, 'PR00172', NULL, 'Mammalian facilitated glucose transporter family signature', NULL, NULL, 'GLUCTRNSPORT', 279496),
(460403, 'PR00950', NULL, 'Type III secretion system inner membrane S protein family signature', NULL, NULL, 'TYPE3IMSPROT', 279497),
(460404, 'PR00838', NULL, 'Venom allergen 5 signature', NULL, NULL, 'V5ALLERGEN', 279498),
(460405, 'PR02039', NULL, 'Pre-mRNA-splicing factor BRR1 signature', NULL, NULL, 'SPLICEFRBRR1', 279499),
(460406, 'PR00670', NULL, 'Inhibin beta A chain signature', NULL, NULL, 'INHIBINBA', 279500),
(460407, 'PR01263', NULL, 'Intracellular chloride (Cl-) channel signature', NULL, NULL, 'INTCLCHANNEL', 279501),
(460408, 'PR00986', NULL, 'Valyl-tRNA synthetase signature', NULL, NULL, 'TRNASYNTHVAL', 279502),
(460409, 'PR00087', NULL, 'Lipoxygenase signature', NULL, NULL, 'LIPOXYGENASE', 279503),
(460410, 'PR01624', NULL, 'Preproghrelin peptide signature', NULL, NULL, 'GHRELIN', 279504),
(460411, 'PR01193', NULL, 'Glucose transporter type 4 (GLUT4) signature', NULL, NULL, 'GLUCTRSPORT4', 279505),
(460412, 'PR01839', NULL, 'DNA repair protein Rad23 signature', NULL, NULL, 'RAD23PROTEIN', 279506),
(460413, 'PR00353', NULL, '4Fe-4S ferredoxin signature', NULL, NULL, '4FE4SFRDOXIN', 279507),
(460414, 'PR01059', NULL, '5-hydroxytryptamine 4 receptor signature', NULL, NULL, '5HT4RECEPTR', 279508),
(460415, 'PR00756', NULL, 'Membrane alanyl dipeptidase (M1) family signature', NULL, NULL, 'ALADIPTASE', 279509),
(460416, 'PR00788', NULL, 'Nitrophorin signature', NULL, NULL, 'NITROPHORIN', 279510),
(460417, 'PR00760', NULL, 'Bontoxilysin signature', NULL, NULL, 'BONTOXILYSIN', 279511),
(460418, 'PR01239', NULL, 'CYP52 P450 protein signature', NULL, NULL, 'EP450IICYP52', 279512),
(460419, 'PR01334', NULL, 'Chlamydia major outer membrane protein signature', NULL, NULL, 'CHLAMIDIAOMP', 279513),
(460420, 'PR01866', NULL, 'MCL1 (myeloid cell leukaemia 1) apoptosis regulator protein signature', NULL, NULL, 'APOPREGMCL1', 279514),
(460421, 'PR01962', NULL, 'Tumour necrosis factor receptor 12 signature', NULL, NULL, 'TNFACTORR12', 279515),
(460422, 'PR00741', NULL, 'Glycosyl hydrolase family 29 signature', NULL, NULL, 'GLHYDRLASE29', 279516),
(460423, 'PR01415', NULL, 'Ankyrin repeat signature', NULL, NULL, 'ANKYRIN', 279517),
(460424, 'PR01297', NULL, 'Colicin lysis protein signature', NULL, NULL, 'LYSISCOLICIN', 279518),
(460425, 'PR01924', NULL, 'Tumour necrosis factor receptor 9 signature', NULL, NULL, 'TNFACTORR9', 279519),
(460426, 'PR00258', NULL, 'Speract receptor signature', NULL, NULL, 'SPERACTRCPTR', 279520),
(460427, 'PR01362', NULL, 'Flagellar calcium-binding protein (calflagin) signature', NULL, NULL, 'CALFLAGIN', 279521),
(460428, 'PR01617', NULL, 'Gamma-aminobutyric-acid A receptor alpha 4 subunit signature', NULL, NULL, 'GABAARALPHA4', 279522),
(460429, 'PR01989', NULL, 'Metazoan eukaryotic MAS20 (TOM20) import receptor subunit signature', NULL, NULL, 'EUOM20RECPTR', 279523),
(460430, 'PR00658', NULL, 'CD44 antigen precursor signature', NULL, NULL, 'CD44', 279524),
(460431, 'PR00217', NULL, '43kDa postsynaptic protein signature', NULL, NULL, 'POSTSYNAPTIC', 279525),
(460432, 'PR01376', NULL, 'Yersinia/Haemophilus virulence surface antigen signature', NULL, NULL, 'BACSURFANTGN', 279526),
(460433, 'PR01569', NULL, 'P2Y12 purinoceptor signature', NULL, NULL, 'P2Y12PRNCPTR', 279527),
(460434, 'PR00174', NULL, 'LacY proton/sugar symporter family signature', NULL, NULL, 'LACYSMPORT', 279528),
(460435, 'PR00229', NULL, 'Geminivirus MSV AL1 coat protein signature', NULL, NULL, 'GEMCOATMSVL1', 279529),
(460436, 'PR01066', NULL, 'P2Y4 purinoceptor signature', NULL, NULL, 'P2Y4PRNOCPTR', 279530),
(460437, 'PR01559', NULL, 'Duffy antigen/chemokine receptor signature', NULL, NULL, 'DUFFYANTIGEN', 279531),
(460438, 'PR00310', NULL, 'Anti-proliferative protein BTG1 family signature', NULL, NULL, 'ANTIPRLFBTG1', 279532),
(460439, 'PR00272', NULL, 'Erythropoietin signature', NULL, NULL, 'ERYTHROPTN', 279533);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(460440, 'PR01506', NULL, 'Bacterial sec-independent translocation TatB protein signature', NULL, NULL, 'TATBPROTEIN', 279534),
(460441, 'PR00878', NULL, 'Cholinesterase signature', NULL, NULL, 'CHOLNESTRASE', 279535),
(460442, 'PR00271', NULL, 'Defensin signature', NULL, NULL, 'DEFENSIN', 279536),
(460443, 'PR00559', NULL, 'Alpha-2B adrenergic receptor signature', NULL, NULL, 'ADRENRGCA2BR', 279537),
(460444, 'PR00538', NULL, 'Muscarinic M1 receptor signature', NULL, NULL, 'MUSCRINICM1R', 279538),
(460445, 'PR01897', NULL, 'ABC transporter family B3 signature', NULL, NULL, 'TAP2PROTEIN', 279539),
(460446, 'PR01130', NULL, 'Delayed-early response protein/equilibrative nucleoside transporter signature', NULL, NULL, 'DERENTRNSPRT', 279540),
(460447, 'PR01740', NULL, 'Septin 2 signature', NULL, NULL, 'SEPTIN2', 279541),
(460448, 'PR01908', NULL, 'Atypical dual specificity phosphatase family signature', NULL, NULL, 'ADSPHPHTASE', 279542),
(460449, 'PR00266', NULL, 'Interferon alpha and beta subunit signature', NULL, NULL, 'INTERFERONAB', 279543),
(460450, 'PR01857', NULL, 'ADAM-TS family signature', NULL, NULL, 'ADAMTSFAMILY', 279544),
(460451, 'PR01806', NULL, 'Virulence factor MviN signature', NULL, NULL, 'VIRFACTRMVIN', 279545),
(460452, 'PR01703', NULL, 'Manganese superoxide dismutase signature', NULL, NULL, 'MNSODISMTASE', 279546),
(460453, 'PR00825', NULL, 'Vespid venom allergen phospholipase A1 signature', NULL, NULL, 'DOLALLERGEN', 279547),
(460454, 'PR00657', NULL, 'Chemokine receptor signature', NULL, NULL, 'CCCHEMOKINER', 279548),
(460455, 'PR01202', NULL, 'Dopamine neurotransmitter transporter signature', NULL, NULL, 'DOPTRANSPORT', 279549),
(460456, 'PR00645', NULL, 'C-X-C chemokine receptor type 4 signature', NULL, NULL, 'CXCCHMKINER4', 279550),
(460457, 'PR00813', NULL, 'Bacterial general secretion pathway protein G signature', NULL, NULL, 'BCTERIALGSPG', 279551),
(460458, 'PR01445', NULL, 'Claudin-6 signature', NULL, NULL, 'CLAUDIN6', 279552),
(460459, 'PR01675', NULL, 'Glycine receptor alpha 2 subunit signature', NULL, NULL, 'GLYRALPHA2', 279553),
(460460, 'PR00928', NULL, 'Graves disease carrier protein signature', NULL, NULL, 'GRAVESDC', 279554),
(460461, 'PR01354', NULL, 'Glucagon receptor signature', NULL, NULL, 'GLUCAGONR', 279555),
(460462, 'PR00857', NULL, 'Melatonin receptor signature', NULL, NULL, 'MELATONINR', 279556),
(460463, 'PR01576', NULL, 'Peptide deformylase signature', NULL, NULL, 'PDEFORMYLASE', 279557),
(460464, 'PR00292', NULL, 'Potato inhibitor I signature', NULL, NULL, 'POTATOINHBTR', 279558),
(460465, 'PR01837', NULL, 'MgtC/SapB protein signature', NULL, NULL, 'MGTCSAPBPROT', 279559),
(460466, 'PR00198', NULL, 'Annexin type II signature', NULL, NULL, 'ANNEXINII', 279560),
(460467, 'PR01448', NULL, 'Claudin-18 signature', NULL, NULL, 'CLAUDIN18', 279561),
(460468, 'PR01621', NULL, 'Gamma-aminobutyric-acid A receptor gamma 1 subunit signature', NULL, NULL, 'GABAARGAMMA1', 279562),
(460469, 'PR00887', NULL, 'Structure-specific recognition protein signature', NULL, NULL, 'SSRCOGNITION', 279563),
(460470, 'PR02046', NULL, 'Retina-specific protein F379 family signature', NULL, NULL, 'FAM138ABCDF', 279564),
(460471, 'PR01022', NULL, 'Outer membrane protein A signature', NULL, NULL, 'OUTRMMBRANEA', 279565),
(460472, 'PR01555', NULL, 'Escherichia coli P pili tip fibrillum papE protein signature', NULL, NULL, 'FIMBRIALPAPE', 279566),
(460473, 'PR01745', NULL, 'Dense granule Gra2 protein signature', NULL, NULL, 'DENSEGRNULE2', 279567),
(460474, 'PR00841', NULL, 'Bacterial beta-amylase signature', NULL, NULL, 'GLHYDLASE14A', 279568),
(460475, 'PR00466', NULL, 'Cytochrome B-245 heavy chain signature', NULL, NULL, 'GP91PHOX', 279569),
(460476, 'PR01101', NULL, '5-hydroxytryptamine receptor signature', NULL, NULL, '5HTRECEPTOR', 279570),
(460477, 'PR01380', NULL, 'Claudin-5 signature', NULL, NULL, 'CLAUDIN5', 279571),
(460478, 'PR00337', NULL, 'Leu/Ile/Val-binding protein family signature', NULL, NULL, 'LEUILEVALBP', 279572),
(460479, 'PR00706', NULL, 'Pyroglutamyl peptidase I (C15) family signature', NULL, NULL, 'PYROGLUPTASE', 279573);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(460480, 'PR01598', NULL, 'Zona occludens protein ZO-1 signature', NULL, NULL, 'ZONOCCLUDNS1', 279574),
(460481, 'PR01790', NULL, 'Senescence marker protein-30 (SMP30) family signature', NULL, NULL, 'SMP30FAMILY', 279575),
(460482, 'PR01795', NULL, 'Voltage-dependent calcium channel gamma-7 subunit signature', NULL, NULL, 'VDCCGAMMA7', 279576),
(460483, 'PR01072', NULL, 'Presenilin family signature', NULL, NULL, 'PRESENILIN', 279577),
(460484, 'PR00908', NULL, 'Thrombin receptor signature', NULL, NULL, 'THROMBINR', 279578),
(460485, 'PR01257', NULL, 'Otx2 transcription factor signature', NULL, NULL, 'OTX2HOMEOBOX', 279579),
(460486, 'PR01973', NULL, 'Tumour necrosis factor receptor 27 signature', NULL, NULL, 'TNFACTORR27', 279580),
(460487, 'PR00510', NULL, 'Nebulin signature', NULL, NULL, 'NEBULIN', 279581),
(460488, 'PR01304', NULL, 'Norrie disease protein signature', NULL, NULL, 'NORRIEDSEASE', 279582),
(460489, 'PR01827', NULL, 'Non-receptor tyrosine-protein kinase TYK2 signature', NULL, NULL, 'YKINASETYK2', 279583),
(460490, 'PR00536', NULL, 'Melanocyte stimulating hormone receptor signature', NULL, NULL, 'MELNOCYTESHR', 279584),
(460491, 'PR00727', NULL, 'Bacterial leader peptidase 1 (S26A) family signature', NULL, NULL, 'LEADERPTASE', 279585),
(460492, 'PR00391', NULL, 'Phosphatidylinositol transfer protein signature', NULL, NULL, 'PITRANSFER', 279586),
(460493, 'PR00042', NULL, 'Fos transforming protein signature', NULL, NULL, 'LEUZIPPRFOS', 279587),
(460494, 'PR01849', NULL, 'Ubiquitin-activating enzyme E1 signature', NULL, NULL, 'UBIQUITINACT', 279588),
(460495, 'PR00355', NULL, 'Adrenodoxin signature', NULL, NULL, 'ADRENODOXIN', 279589),
(460496, 'PR00210', NULL, 'High molecular weight glutenin signature', NULL, NULL, 'GLUTENIN', 279590),
(460497, 'PR01592', NULL, 'Low calcium response V antigen signature', NULL, NULL, 'LCRVANTIGEN', 279591),
(460498, 'PR01295', NULL, 'Cloacin signature', NULL, NULL, 'CLOACIN', 279592),
(460499, 'PR02112', NULL, 'Mas-related G protein-coupled receptor F signature', NULL, NULL, 'MRGPCRF', 279593),
(460500, 'PR02048', NULL, 'Protein family FAM25 signature', NULL, NULL, 'PROTEINF25', 279594),
(460501, 'PR01657', NULL, 'Mini-chromosome maintenance (MCM) protein family signature', NULL, NULL, 'MCMFAMILY', 279595),
(460502, 'PR00585', NULL, 'Prostanoid EP3 receptor type 3 signature', NULL, NULL, 'PRSTNOIDE33R', 279596),
(460503, 'PR01942', NULL, 'Neurotrophic tyrosine kinase receptor type 3 signature', NULL, NULL, 'NTKRECEPTOR3', 279597),
(460504, 'PR02067', NULL, 'Chromatin modification-related protein EAF5 signature', NULL, NULL, 'PROTEINEAF5', 279598),
(460505, 'PR00827', NULL, 'Major allergen Fel Di signature', NULL, NULL, 'FELALLERGEN', 279599),
(460506, 'PR00038', NULL, 'LuxR bacterial regulatory protein HTH signature', NULL, NULL, 'HTHLUXR', 279600),
(460507, 'PR00952', NULL, 'Type III secretion system inner membrane Q protein family signature', NULL, NULL, 'TYPE3IMQPROT', 279601),
(460508, 'PR00069', NULL, 'Aldo-keto reductase signature', NULL, NULL, 'ALDKETRDTASE', 279602),
(460509, 'PR01082', NULL, 'K-Cl co-transporter type 1 (KCC1) signature', NULL, NULL, 'KCLTRNSPORT1', 279603),
(460510, 'PR00542', NULL, 'Muscarinic M5 receptor signature', NULL, NULL, 'MUSCRINICM5R', 279604),
(460511, 'PR02073', NULL, 'Folliculin-interacting protein 1 signature', NULL, NULL, 'FOLLICULNIP1', 279605),
(460512, 'PR00822', NULL, 'Lipoprotein lipase signature', NULL, NULL, 'LIPOLIPASE', 279606),
(460513, 'PR02105', NULL, 'Integrator complex subunit 2 signature', NULL, NULL, 'INTSUBUNIT2', 279607),
(460514, 'PR00282', NULL, 'Snake cytotoxin signature', NULL, NULL, 'CYTOTOXIN', 279608),
(460515, 'PR01190', NULL, 'Glucose transporter type 1 (GLUT1) signature', NULL, NULL, 'GLUCTRSPORT1', 279609),
(460516, 'PR00486', NULL, 'Uteroglobin signature', NULL, NULL, 'UTEROGLOBIN', 279610),
(460517, 'PR01960', NULL, 'Tumour necrosis factor receptor 7 signature', NULL, NULL, 'TNFACTORR7', 279611),
(460518, 'PR01832', NULL, 'Vascular endothelial growth factor receptor signature', NULL, NULL, 'VEGFRECEPTOR', 279612); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(460519, 'PR00586', NULL, 'Prostanoid EP4 receptor signature', NULL, NULL, 'PRSTNOIDEP4R', 279613),
(460520, 'PR00263', NULL, 'Heparin binding growth factor family signature', NULL, NULL, 'HBGFFGF', 279614),
(460521, 'PR00136', NULL, 'Lactalbumin signature', NULL, NULL, 'LACTALBUMIN', 279615),
(460522, 'PR00869', NULL, 'DNA-polymerase family X signature', NULL, NULL, 'DNAPOLX', 279616),
(460523, 'PR02086', NULL, 'Putative nuclease HARBI1 signature', NULL, NULL, 'PUTNUCHARBI1', 279617),
(460524, 'PR00785', NULL, 'Nuclear translocator signature', NULL, NULL, 'NCTRNSLOCATR', 279618),
(460525, 'PR02017', NULL, 'Aquaporin-5 signature', NULL, NULL, 'AQUAPORIN5', 279619),
(460526, 'PR02000', NULL, 'Putative plant GPCR, GCR1, signature', NULL, NULL, 'GCR1PLANT', 279620),
(460527, 'PR01774', NULL, 'Exfoliative toxin signature', NULL, NULL, 'EXFOLTOXIN', 279621),
(460528, 'PR00901', NULL, 'Pheromone B alpha-1 receptor signature', NULL, NULL, 'PHEROMONEBAR', 279622),
(460529, 'PR00651', NULL, '5-hydroxytryptamine 2B receptor signature', NULL, NULL, '5HT2BRECEPTR', 279623),
(460530, 'PR00078', NULL, 'Glyceraldehyde-3-phosphate dehydrogenase signature', NULL, NULL, 'G3PDHDRGNASE', 279624),
(460531, 'PR01475', NULL, 'Parkin signature', NULL, NULL, 'PARKIN', 279625),
(460532, 'PR01200', NULL, 'Taurine transporter signature', NULL, NULL, 'TAUTRANSPORT', 279626),
(460533, 'PR00403', NULL, 'WW domain signature', NULL, NULL, 'WWDOMAIN', 279627),
(460534, 'PR00958', NULL, 'Homoserine kinase signature', NULL, NULL, 'HOMSERKINASE', 279628),
(460535, 'PR00161', NULL, 'Nickel-dependent hydrogenase/B-type cytochrome signature', NULL, NULL, 'NIHGNASECYTB', 279629),
(460536, 'PR00019', NULL, 'Leucine-rich repeat signature', NULL, NULL, 'LEURICHRPT', 279630),
(460537, 'PR01491', NULL, 'Voltage-gated potassium channel family signature', NULL, NULL, 'KVCHANNEL', 279631),
(460538, 'PR01936', NULL, 'Interleukin-22 signature', NULL, NULL, 'INTRLEUKIN22', 279632),
(460539, 'PR01144', NULL, 'Lutropin-choriogonadotropic hormone receptor precursor signature', NULL, NULL, 'LSHRECEPTOR', 279633),
(460540, 'PR01043', NULL, 'Glycyl-tRNA synthetase signature', NULL, NULL, 'TRNASYNTHGLY', 279634),
(460541, 'PR01071', NULL, 'Acetyl-CoA biotin carboxyl carrier protein signature', NULL, NULL, 'ACOABIOTINCC', 279635),
(460542, 'PR00589', NULL, 'Somatostatin receptor type 3 signature', NULL, NULL, 'SOMATOSTTN3R', 279636),
(460543, 'PR01799', NULL, 'SF-assemblin signature', NULL, NULL, 'SFASSEMBLIN', 279637),
(460544, 'PR00525', NULL, 'Delta opioid receptor signature', NULL, NULL, 'DELTAOPIOIDR', 279638),
(460545, 'PR01011', NULL, 'Glutathione peroxidase family signature', NULL, NULL, 'GLUTPROXDASE', 279639),
(460546, 'PR01755', NULL, 'Bacterial translocase SecF protein signature', NULL, NULL, 'SECFTRNLCASE', 279640),
(460547, 'PR00624', NULL, 'Histone H5 signature', NULL, NULL, 'HISTONEH5', 279641),
(460548, 'PR00235', NULL, 'Herpesvirus major capsid protein (MCP) signature', NULL, NULL, 'HSVCAPSIDMCP', 279642),
(460549, 'PR01655', NULL, 'UDP-glucose receptor signature', NULL, NULL, 'UDPGLUCOSER', 279643),
(460550, 'PR00911', NULL, 'Glycosyl hydrolase family 11 signature', NULL, NULL, 'GLHYDRLASE11', 279644),
(460551, 'PR01537', NULL, 'Interleukin-1 receptor type I family signature', NULL, NULL, 'INTRLKN1R1F', 279645),
(460552, 'PR01590', NULL, 'FIS bacterial regulatory protein HTH signature', NULL, NULL, 'HTHFIS', 279646),
(460553, 'PR01377', NULL, 'Claudin-1 signature', NULL, NULL, 'CLAUDIN1', 279647),
(460554, 'PR00864', NULL, 'Type IV prepilin cysteine protease (C20) family signature', NULL, NULL, 'PREPILNPTASE', 279648),
(460555, 'PR01217', NULL, 'Proline rich extensin signature', NULL, NULL, 'PRICHEXTENSN', 279649),
(460556, 'PR00024', NULL, 'Homeobox signature', NULL, NULL, 'HOMEOBOX', 279650),
(460557, 'PR01804', NULL, 'Ubiquitous surface protein signature', NULL, NULL, 'UBIQUITOUSSP', 279651),
(460558, 'PR02059', NULL, 'Jagged/Serrate protein family signature', NULL, NULL, 'JAGGEDFAMILY', 279652),
(460559, 'PR00990', NULL, 'Ribokinase signature', NULL, NULL, 'RIBOKINASE', 279653);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(460560, 'PR01891', NULL, 'Wnt-7 protein signature', NULL, NULL, 'WNT7PROTEIN', 279654),
(460561, 'PR01468', NULL, 'Staphylococcal bi-component toxin signature', NULL, NULL, 'BICOMPNTOXIN', 279655),
(460562, 'PR00186', NULL, 'Hemerythrin signature', NULL, NULL, 'HEMERYTHRIN', 279656),
(460563, 'PR01098', NULL, 'Topoisomerase IV subunit B signature', NULL, NULL, 'TOPISMRASE4B', 279657),
(460564, 'PR01772', NULL, 'JNK MAP kinase signature', NULL, NULL, 'JNKMAPKINASE', 279658),
(460565, 'PR01261', NULL, 'Tau protein signature', NULL, NULL, 'TAUPROTEIN', 279659),
(460566, 'PR01869', NULL, 'Beta-catenin family signature', NULL, NULL, 'BCATNINFAMLY', 279660),
(460567, 'PR01388', NULL, 'Cytolethal distending toxin B signature', NULL, NULL, 'CDTOXINB', 279661),
(460568, 'PR00436', NULL, 'Interleukin-8 signature', NULL, NULL, 'INTERLEUKIN8', 279662),
(460569, 'PR01567', NULL, 'Neuromedin U type 2 receptor signature', NULL, NULL, 'NEUROMEDNU2R', 279663),
(460570, 'PR01714', NULL, 'Ferric iron reductase signature', NULL, NULL, '2FE2SRDCTASE', 279664),
(460571, 'PR01401', NULL, 'Mutator MutT protein signature', NULL, NULL, 'MUTATORMUTT', 279665),
(460572, 'PR00643', NULL, 'G10D orphan receptor signature', NULL, NULL, 'G10DORPHANR', 279666),
(460573, 'PR01335', NULL, 'Chlamydia cysteine-rich outer membrane protein 3 signature', NULL, NULL, 'CHLAMIDIAOM3', 279667),
(460574, 'PR00251', NULL, 'Bacterial opsin signature', NULL, NULL, 'BACTRLOPSIN', 279668),
(460575, 'PR00860', NULL, 'Vertebrate metallothionein signature', NULL, NULL, 'MTVERTEBRATE', 279669),
(460576, 'PR01207', NULL, 'Na-K-Cl co-transporter family signature', NULL, NULL, 'NAKCLTRNSPRT', 279670),
(460577, 'PR00934', NULL, 'X-His dipeptidase (M25) signature', NULL, NULL, 'XHISDIPTASE', 279671),
(460578, 'PR00346', NULL, 'Tissue factor signature', NULL, NULL, 'TISSUEFACTOR', 279672),
(460579, 'PR00524', NULL, 'Cholecystokinin type A receptor signature', NULL, NULL, 'CCYSTOKNINAR', 279673),
(460580, 'PR01681', NULL, 'Fas antigen ligand signature', NULL, NULL, 'FASLIGAND', 279674),
(460581, 'PR01473', NULL, 'Intercellular adhesion molecule (ICAM) family signature', NULL, NULL, 'ICAM', 279675),
(460582, 'PR00041', NULL, 'cAMP response element binding (CREB) protein signature', NULL, NULL, 'LEUZIPPRCREB', 279676),
(460583, 'PR02050', NULL, 'Beta-1,4-galactosyltransferase family signature', NULL, NULL, 'B14GALTRFASE', 279677),
(460584, 'PR00150', NULL, 'Phosphoenolpyruvate carboxylase signature', NULL, NULL, 'PEPCARBXLASE', 279678),
(460585, 'PR02070', NULL, 'N-glycosylation protein EOS1 signature', NULL, NULL, 'NGLYCOSEOS1', 279679),
(460586, 'PR01791', NULL, 'Regucalcin signature', NULL, NULL, 'REGUCALCIN', 279680),
(460587, 'PR01472', NULL, 'Intercellular adhesion molecule/vascular cell adhesion molecule-1 signature', NULL, NULL, 'ICAMVCAM1', 279681),
(460588, 'PR00889', NULL, 'Calponin signature', NULL, NULL, 'CALPONIN', 279682),
(460589, 'PR01876', NULL, 'Myeloid transforming gene on chromosome 8 (MTG8) protein signature', NULL, NULL, 'MTG8PROTEIN', 279683),
(460590, 'PR01752', NULL, 'Urea amidohydrolase (urease) protein signature', NULL, NULL, 'UREASE', 279684),
(460591, 'PR00664', NULL, 'Octopamine receptor signature', NULL, NULL, 'OCTOPAMINER', 279685),
(460592, 'PR00597', NULL, 'Gelsolin family signature', NULL, NULL, 'GELSOLIN', 279686),
(460593, 'PR01501', NULL, 'Staphylococcal toxic shock syndrome toxin signature', NULL, NULL, 'TOXICSSTOXIN', 279687),
(460594, 'PR00147', NULL, 'DNA photolyase signature', NULL, NULL, 'DNAPHOTLYASE', 279688),
(460595, 'PR01492', NULL, 'Kv6 potassium channel alpha subunit signature', NULL, NULL, 'KV6CHANNEL', 279689),
(460596, 'PR00563', NULL, 'Beta-3 adrenergic receptor signature', NULL, NULL, 'ADRENRGCB3AR', 279690),
(460597, 'PR02091', NULL, 'HAUS augmin-like complex subunit 5 signature', NULL, NULL, 'HAUSAUGMINL5', 279691),
(460598, 'PR00339', NULL, 'Proliferating cell nuclear antigen (cyclin) signature', NULL, NULL, 'PCNACYCLIN', 279692),
(460599, 'PR00267', NULL, 'Interferon regulatory factor signature', NULL, NULL, 'INTFRNREGFCT', 279693); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(460600, 'PR01586', NULL, 'TWIK-1/TWIK-2 K+ channel family signature', NULL, NULL, 'TWIKCHANNEL', 279694),
(460601, 'PR00560', NULL, 'Alpha-2C adrenergic receptor signature', NULL, NULL, 'ADRENRGCA2CR', 279695),
(460602, 'PR00145', NULL, 'Argininosuccinate lyase family signature', NULL, NULL, 'ARGSUCLYASE', 279696),
(460603, 'PR00125', NULL, 'ATP synthase delta subunit signature', NULL, NULL, 'ATPASEDELTA', 279697),
(460604, 'PR00106', NULL, 'DNA-directed DNA-polymerase family B signature', NULL, NULL, 'DNAPOLB', 279698),
(460605, 'PR00874', NULL, 'Fungi-IV metallothionein signature', NULL, NULL, 'MTFUNGIIV', 279699),
(460606, 'PR00511', NULL, 'Tektin signature', NULL, NULL, 'TEKTIN', 279700),
(460607, 'PR01084', NULL, 'Na+/H+ exchanger signature', NULL, NULL, 'NAHEXCHNGR', 279701),
(460608, 'PR01234', NULL, 'Tumour necrosis factor family signature', NULL, NULL, 'TNECROSISFCT', 279702),
(460609, 'PR01237', NULL, 'Tumour necrosis factor c (lymphotoxin-beta) signature', NULL, NULL, 'TNFC', 279703),
(460610, 'PR00432', NULL, 'Interleukin-5 signature', NULL, NULL, 'INTERLEUKIN5', 279704),
(460611, 'PR00193', NULL, 'Myosin heavy chain signature', NULL, NULL, 'MYOSINHEAVY', 279705),
(460612, 'PR01061', NULL, 'Melanocortin 3 receptor signature', NULL, NULL, 'MELNOCORTN3R', 279706),
(460613, 'PR01044', NULL, 'Glycyl-tRNA synthetase alpha subunit signature', NULL, NULL, 'TRNASYNTHGA', 279707),
(460614, 'PR00218', NULL, 'Peripherin (RDS)/ROM-1 family signature', NULL, NULL, 'PERIPHERNRDS', 279708),
(460615, 'PR01577', NULL, 'KCNAB voltage-gated K+ channel beta subunit family signature', NULL, NULL, 'KCNABCHANNEL', 279709),
(460616, 'PR00302', NULL, 'Lupus La protein signature', NULL, NULL, 'LUPUSLA', 279710),
(460617, 'PR00572', NULL, 'Interleukin 8A receptor signature', NULL, NULL, 'INTRLEUKN8AR', 279711),
(460618, 'PR00502', NULL, 'NUDIX hydrolase family signature', NULL, NULL, 'NUDIXFAMILY', 279712),
(460619, 'PR00162', NULL, 'Rieske 2Fe-2S subunit signature', NULL, NULL, 'RIESKE', 279713),
(460620, 'PR01610', NULL, 'Adhesion molecule CD36 signature', NULL, NULL, 'CD36ANTIGEN', 279714),
(460621, 'PR01405', NULL, 'Bis(5''-nucleosyl)-tetraphosphatase signature', NULL, NULL, 'TETRPHPHTASE', 279715),
(460622, 'PR00803', NULL, 'Alpha-fetoprotein signature', NULL, NULL, 'AFETOPROTEIN', 279716),
(460623, 'PR00906', NULL, 'SecA protein signature', NULL, NULL, 'SECA', 279717),
(460624, 'PR01835', NULL, 'Vascular endothelial growth factor receptor type 3 signature', NULL, NULL, 'VEGFRECEPTR3', 279718),
(460625, 'PR00582', NULL, 'Prostanoid EP3 receptor signature', NULL, NULL, 'PRSTNOIDEP3R', 279719),
(460626, 'PR00709', NULL, 'Avidin signature', NULL, NULL, 'AVIDIN', 279720),
(460627, 'PR00471', NULL, 'Acetate kinase family signature', NULL, NULL, 'ACETATEKNASE', 279721),
(460628, 'PR01198', NULL, 'Betaine transporter signature', NULL, NULL, 'BETTRANSPORT', 279722),
(460629, 'PR02058', NULL, 'Vertebrate apolipoprotein D signature', NULL, NULL, 'APODVERTBRTE', 279723),
(460630, 'PR00163', NULL, 'Rubredoxin signature', NULL, NULL, 'RUBREDOXIN', 279724),
(460631, 'PR00446', NULL, 'Hydrogen uptake protein signature', NULL, NULL, 'HYDRGNUPTAKE', 279725),
(460632, 'PR01983', NULL, 'Neurogenic locus Notch protein signature', NULL, NULL, 'NOTCH', 279726),
(460633, 'PR01275', NULL, 'Neutrophil gelatinase lipocalin signature', NULL, NULL, 'NGELATINASE', 279727),
(460634, 'PR01292', NULL, 'Retinoic acid receptor (1B nuclear receptor) signature', NULL, NULL, 'RETNOICACIDR', 279728),
(460635, 'PR00314', NULL, 'Clathrin coat assembly protein signature', NULL, NULL, 'CLATHRINADPT', 279729),
(460636, 'PR01478', NULL, 'Leukotriene B4 type 2 receptor signature', NULL, NULL, 'LTB2RECEPTOR', 279730),
(460637, 'PR00155', NULL, 'Amicyanin family signature', NULL, NULL, 'AMICYANIN', 279731),
(460638, 'PR01149', NULL, 'Melatonin 1A receptor signature', NULL, NULL, 'MELATONIN1AR', 279732),
(460639, 'PR00627', NULL, 'GTP-binding nuclear protein Ran/Tc4 family signature', NULL, NULL, 'GTPRANTC4', 279733),
(460640, 'PR00858', NULL, 'Crustacean metallothionein signature', NULL, NULL, 'MTCRUSTACEAN', 279734);
INSERT INTO "PUBLIC"."MODEL" VALUES
(460641, 'PR01512', NULL, 'Kv1.5 voltage-gated K+ channel signature', NULL, NULL, 'KV15CHANNEL', 279735),
(460642, 'PR01543', NULL, 'Arylamine N-acetyltransferase signature', NULL, NULL, 'ANATRNSFRASE', 279736),
(460643, 'PR01561', NULL, 'EDG-8 sphingosine 1-phosphate receptor signature', NULL, NULL, 'EDG8RECEPTOR', 279737),
(460644, 'PR01127', NULL, 'Diuretic hormone receptor signature', NULL, NULL, 'DIUHORMONER', 279738),
(460645, 'PR00231', NULL, 'Geminivirus AL3 coat protein signature', NULL, NULL, 'GEMCOATAL3', 279739),
(460646, 'PR01690', NULL, 'TASK-5 K+ channel signature', NULL, NULL, 'TASK5CHANNEL', 279740),
(460647, 'PR01949', NULL, 'Fish interleukin-15 signature', NULL, NULL, 'INTLKN15FISH', 279741),
(460648, 'PR01801', NULL, 'Protozoan surface antigen signature', NULL, NULL, 'SURFCEANTIGN', 279742),
(460649, 'PR01269', NULL, 'S-crystallin signature', NULL, NULL, 'SCRYSTALLIN', 279743),
(460650, 'PR00112', NULL, 'Acylphosphatase signature', NULL, NULL, 'ACYLPHPHTASE', 279744),
(460651, 'PR00437', NULL, 'Small CXC cytokine family signature', NULL, NULL, 'SMALLCYTKCXC', 279745),
(460652, 'PR01036', NULL, 'Tetracycline resistance protein TetB signature', NULL, NULL, 'TCRTETB', 279746),
(460653, 'PR00332', NULL, 'Histidine triad family signature', NULL, NULL, 'HISTRIAD', 279747),
(460654, 'PR00762', NULL, 'Chloride channel signature', NULL, NULL, 'CLCHANNEL', 279748),
(460655, 'PR00378', NULL, 'Lithium-sensitive myo-inositol monophosphatase family signature', NULL, NULL, 'LIIMPHPHTASE', 279749),
(460656, 'PR01658', NULL, 'Mini-chromosome maintenance (MCM) protein 2 signature', NULL, NULL, 'MCMPROTEIN2', 279750),
(460657, 'PR02099', NULL, 'Protein IBD2 signature', NULL, NULL, 'PROTEINIBD2', 279751),
(460658, 'PR00032', NULL, 'AraC bacterial regulatory protein HTH signature', NULL, NULL, 'HTHARAC', 279752),
(460659, 'PR01548', NULL, 'Meiotic recombination protein rec114 signature', NULL, NULL, 'MEIOTICR114', 279753),
(460660, 'PR00968', NULL, 'Outer surface protein signature', NULL, NULL, 'OUTRSURFACE', 279754),
(460661, 'PR00304', NULL, 'Tailless complex polypeptide 1 (chaperone) signature', NULL, NULL, 'TCOMPLEXTCP1', 279755),
(460662, 'PR00049', NULL, 'Wilm''s tumour protein signature', NULL, NULL, 'WILMSTUMOUR', 279756),
(460663, 'PR00667', NULL, 'Retinal pigment epithelium-retinal GPCR signature', NULL, NULL, 'RPERETINALR', 279757),
(460664, 'PR01585', NULL, 'TASK-3 K+ channel signature', NULL, NULL, 'TASK3CHANNEL', 279758),
(460665, 'PR01299', NULL, 'Colicin E2 (pyocin) immunity protein signature', NULL, NULL, 'PYOCIN', 279759),
(460666, 'PR00264', NULL, 'Interleukin-1 precursor family signature', NULL, NULL, 'INTERLEUKIN1', 279760),
(460667, 'PR01014', NULL, 'Neuropeptide Y2 receptor signature', NULL, NULL, 'NRPEPTIDEY2R', 279761),
(460668, 'PR01185', NULL, 'Integrin alpha subunit signature', NULL, NULL, 'INTEGRINA', 279762),
(460669, 'PR01614', NULL, 'Gamma-aminobutyric-acid A receptor alpha 1 subunit signature', NULL, NULL, 'GABAARALPHA1', 279763),
(460670, 'PR01030', NULL, 'Proenkephalin B precursor signature', NULL, NULL, 'PENKBPRCRSR', 279764),
(460671, 'PR01560', NULL, 'EDG-7 lysophosphatidic acid receptor signature', NULL, NULL, 'EDG7RECEPTOR', 279765),
(460672, 'PR01991', NULL, 'GP153/GP162 7TM protein family signature', NULL, NULL, 'GPR153GPR162', 279766),
(460673, 'PR02029', NULL, 'Active regulator of SIRT1 signature', NULL, NULL, 'ACTREGSIRT1', 279767),
(460674, 'PR00598', NULL, 'Bacterial regulatory protein MarR family signature', NULL, NULL, 'HTHMARR', 279768),
(460675, 'PR00341', NULL, 'Prion protein signature', NULL, NULL, 'PRION', 279769),
(460676, 'PR00944', NULL, 'Copper ion binding protein signature', NULL, NULL, 'CUEXPORT', 279770),
(460677, 'PR01825', NULL, 'Janus kinase 2 (JAK2) signature', NULL, NULL, 'JANUSKINASE2', 279771),
(460678, 'PR01686', NULL, 'CYP2D P450 family signature', NULL, NULL, 'EP450ICYP2D', 279772),
(460679, 'PR00064', NULL, 'Ribosomal protein L35 signature', NULL, NULL, 'RIBOSOMALL35', 279773),
(460680, 'PR01315', NULL, 'CLN3 Batten''s disease protein (battenin) signature', NULL, NULL, 'BATTENIN', 279774);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(460681, 'PR00852', NULL, 'Xeroderma pigmentosum group D protein signature', NULL, NULL, 'XRODRMPGMNTD', 279775),
(460682, 'PR01118', NULL, 'CLC-7 chloride channel signature', NULL, NULL, 'CLCHANNEL7', 279776),
(460683, 'PR00829', NULL, 'Major pollen allergen Lol pI signature', NULL, NULL, 'LOLP1ALLERGN', 279777),
(460684, 'PR00970', NULL, 'Arginine ADP-ribosyltransferase signature', NULL, NULL, 'RIBTRNSFRASE', 279778),
(460685, 'PR00160', NULL, 'Glutaredoxin signature', NULL, NULL, 'GLUTAREDOXIN', 279779),
(460686, 'PR00871', NULL, 'DNA nucleotidylexotransferase (TDT) signature', NULL, NULL, 'DNAPOLXTDT', 279780),
(460687, 'PR01379', NULL, 'Claudin-4 signature', NULL, NULL, 'CLAUDIN4', 279781),
(460688, 'PR00661', NULL, 'ERM family signature', NULL, NULL, 'ERMFAMILY', 279782),
(460689, 'PR00745', NULL, 'Glycosyl hydrolase family 39 signature', NULL, NULL, 'GLHYDRLASE39', 279783),
(460690, 'PR00599', NULL, 'Methionine aminopeptidase-1 signature', NULL, NULL, 'MAPEPTIDASE', 279784),
(460691, 'PR01565', NULL, 'Neuromedin U receptor family signature', NULL, NULL, 'NEUROMEDINUR', 279785),
(460692, 'PR01696', NULL, 'L-type calcium channel beta-3 subunit signature', NULL, NULL, 'LCACHANNELB3', 279786),
(460693, 'PR00344', NULL, 'Bacterial sensor protein C-terminal signature', NULL, NULL, 'BCTRLSENSOR', 279787),
(460694, 'PR01409', NULL, 'T-cell surface glycoprotein CD5 signature', NULL, NULL, 'TCELLCD5', 279788),
(460695, 'PR01056', NULL, 'Metabotropic glutamate receptor 6 signature', NULL, NULL, 'MTABOTROPC6R', 279789),
(460696, 'PR00544', NULL, 'Progesterone receptor (3C nuclear receptor) signature', NULL, NULL, 'PROGESTRONER', 279790),
(460697, 'PR00737', NULL, 'Glycosyl hydrolase family 16 signature', NULL, NULL, 'GLHYDRLASE16', 279791),
(460698, 'PR00400', NULL, 'Tetracycline repressor protein signature', NULL, NULL, 'TETREPRESSOR', 279792),
(460699, 'PR01374', NULL, 'Gram-negative bacterial tonB protein signature', NULL, NULL, 'TONBPROTEIN', 279793),
(460700, 'PR01843', NULL, 'Wnt-3 protein signature', NULL, NULL, 'WNT3PROTEIN', 279794),
(460701, 'PR01307', NULL, 'P2X purinoceptor family signature', NULL, NULL, 'P2XRECEPTOR', 279795),
(460702, 'PR01201', NULL, 'Noradrenaline neurotransmitter transporter signature', NULL, NULL, 'NORTRANSPORT', 279796),
(460703, 'PR01309', NULL, 'P2X2 purinoceptor signature', NULL, NULL, 'P2X2RECEPTOR', 279797),
(460704, 'PR01587', NULL, 'TWIK-2 K+ channel signature', NULL, NULL, 'TWIK2CHANNEL', 279798),
(460705, 'PR01040', NULL, 'Tyrosyl-tRNA synthetase signature', NULL, NULL, 'TRNASYNTHTYR', 279799),
(460706, 'PR00752', NULL, 'Vasopressin V1A receptor signature', NULL, NULL, 'VASOPRSNV1AR', 279800),
(460707, 'PR01525', NULL, 'EDG-5 sphingosine 1-phosphate receptor signature', NULL, NULL, 'EDG5RECEPTOR', 279801),
(460708, 'PR01718', NULL, 'Claudin-15 signature', NULL, NULL, 'CLAUDIN15', 279802),
(460709, 'PR00951', NULL, 'Flagellar biosynthetic protein FliP signature', NULL, NULL, 'FLGBIOSNFLIP', 279803),
(460710, 'PR00084', NULL, 'Mannitol dehydrogenase signature', NULL, NULL, 'MTLDHDRGNASE', 279804),
(460711, 'PR00455', NULL, 'TetR bacterial regulatory protein HTH signature', NULL, NULL, 'HTHTETR', 279805),
(460712, 'PR00212', NULL, 'Myelin basic protein signature', NULL, NULL, 'MYELINMBP', 279806),
(460713, 'PR01707', NULL, 'Rickettsia 56kDa type-specific antigen protein signature', NULL, NULL, '56KDTSANTIGN', 279807),
(460714, 'PR00547', NULL, 'X opioid receptor signature', NULL, NULL, 'XOPIOIDR', 279808),
(460715, 'PR00637', NULL, 'Type 3 bombesin receptor signature', NULL, NULL, 'BOMBESIN3R', 279809),
(460716, 'PR01939', NULL, 'Neurotrophic tyrosine kinase receptor family signature', NULL, NULL, 'NTKRECEPTOR', 279810),
(460717, 'PR00185', NULL, 'Eukaryotic porin signature', NULL, NULL, 'EUKARYTPORIN', 279811),
(460718, 'PR01792', NULL, 'Voltage-dependent calcium channel gamma subunit signature', NULL, NULL, 'VDCCGAMMA', 279812),
(460719, 'PR00239', NULL, 'Molluscan rhodopsin C-terminal tail signature', NULL, NULL, 'RHODOPSNTAIL', 279813),
(460720, 'PR00116', NULL, 'Arginase signature', NULL, NULL, 'ARGINASE', 279814);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(460721, 'PR00412', NULL, 'Epoxide hydrolase signature', NULL, NULL, 'EPOXHYDRLASE', 279815),
(460722, 'PR00481', NULL, 'Cytosol aminopeptidase signature', NULL, NULL, 'LAMNOPPTDASE', 279816),
(460723, 'PR01260', NULL, 'Na+/Ca2+ exchanger isoform 1 signature', NULL, NULL, 'NACAEXCHNGR1', 279817),
(460724, 'PR01698', NULL, 'Cytoplasmic fragile X mental retardation protein interacting protein signature', NULL, NULL, 'CYTOFMRPINTP', 279818),
(460725, 'PR00716', NULL, 'M-phase inducer phosphatase signature', NULL, NULL, 'MPIPHPHTASE', 279819),
(460726, 'PR01846', NULL, 'Thyrotropin-releasing hormone receptor family signature', NULL, NULL, 'TRHRFAMILY', 279820),
(460727, 'PR02074', NULL, 'Protein FRG2 signature', NULL, NULL, 'PROTEINFRG2', 279821),
(460728, 'PR01320', NULL, 'Inward rectifier K+ channel superfamily signature', NULL, NULL, 'KIRCHANNEL', 279822),
(460729, 'PR00088', NULL, 'Haem oxygenase signature', NULL, NULL, 'HAEMOXYGNASE', 279823),
(460730, 'PR00107', NULL, 'Phosphocarrier protein signature', NULL, NULL, 'PHOSPHOCPHPR', 279824),
(460731, 'PR01148', NULL, 'EDG-2 lysophosphatidic acid receptor signature', NULL, NULL, 'EDG2RECEPTOR', 279825),
(460732, 'PR01570', NULL, 'Neuropeptide FF receptor family signature', NULL, NULL, 'NPFFRECEPTOR', 279826),
(460733, 'PR00368', NULL, 'FAD-dependent pyridine nucleotide reductase signature', NULL, NULL, 'FADPNR', 279827),
(460734, 'PR00740', NULL, 'Glycosyl hydrolase family 27 signature', NULL, NULL, 'GLHYDRLASE27', 279828),
(460735, 'PR00388', NULL, '3''5''-cyclic nucleotide class II phosphodiesterase signature', NULL, NULL, 'PDIESTERASE2', 279829),
(460736, 'PR00587', NULL, 'Somatostatin receptor type 1 signature', NULL, NULL, 'SOMATOSTTN1R', 279830),
(460737, 'PR01836', NULL, 'Magnesium-transporting ATPase signature', NULL, NULL, 'MGATPASE', 279831),
(460738, 'PR02103', NULL, 'Inheritance of peroxisomes protein 1 signature', NULL, NULL, 'INPROXISOME1', 279832),
(460739, 'PR00543', NULL, 'Oestrogen receptor signature', NULL, NULL, 'OESTROGENR', 279833),
(460740, 'PR01289', NULL, 'Peroxisome proliferator-activated receptor alpha signature', NULL, NULL, 'PROXISOMPAAR', 279834),
(460741, 'PR00419', NULL, 'Adrenodoxin reductase family signature', NULL, NULL, 'ADXRDTASE', 279835),
(460742, 'PR01054', NULL, 'Metabotropic glutamate receptor 4 signature', NULL, NULL, 'MTABOTROPC4R', 279836),
(460743, 'PR00918', NULL, 'Calicivirus non-structural polyprotein family signature', NULL, NULL, 'CALICVIRUSNS', 279837),
(460744, 'PR00173', NULL, 'Glutamate-aspartate symporter signature', NULL, NULL, 'EDTRNSPORT', 279838),
(460745, 'PR00201', NULL, 'Annexin type V signature', NULL, NULL, 'ANNEXINV', 279839),
(460746, 'PR00640', NULL, 'Gastrin-releasing peptide receptor signature', NULL, NULL, 'GASTRINRELPR', 279840),
(460747, 'PR00073', NULL, 'Coprogen oxidase signature', NULL, NULL, 'COPRGNOXDASE', 279841),
(460748, 'PR01699', NULL, 'Organomercurial lyase signature', NULL, NULL, 'ORGNOHGLYASE', 279842),
(460749, 'PR01744', NULL, 'MIC1 microneme protein signature', NULL, NULL, 'MIC1MICRNEME', 279843),
(460750, 'PR00895', NULL, 'Pentaxin signature', NULL, NULL, 'PENTAXIN', 279844),
(460751, 'PR01602', NULL, 'Voltage-dependent calcium channel gamma-2 subunit signature', NULL, NULL, 'VDCCGAMMA2', 279845),
(460752, 'PR01391', NULL, 'Binary toxin B family signature', NULL, NULL, 'BINARYTOXINB', 279846),
(460753, 'PR01213', NULL, 'Beta-synuclein signature', NULL, NULL, 'BSYNUCLEIN', 279847),
(460754, 'PR01322', NULL, 'Kir1.2 inward rectifier K+ channel signature', NULL, NULL, 'KIR12CHANNEL', 279848),
(460755, 'PR00244', NULL, 'Neurokinin receptor signature', NULL, NULL, 'NEUROKININR', 279849),
(460756, 'PR01578', NULL, 'KCNAB voltage-gated K+ channel beta-1 subunit signature', NULL, NULL, 'KCNAB1CHANEL', 279850),
(460757, 'PR01551', NULL, 'SPO11 homologue signature', NULL, NULL, 'SPO11HOMOLOG', 279851),
(460758, 'PR00978', NULL, 'Steroidogenic acute regulatory protein signature', NULL, NULL, 'STARPROTEIN', 279852),
(460759, 'PR00299', NULL, 'Alpha crystallin signature', NULL, NULL, 'ACRYSTALLIN', 279853);
INSERT INTO "PUBLIC"."MODEL" VALUES
(460760, 'PR01333', NULL, 'Two pore domain K+ channel signature', NULL, NULL, '2POREKCHANEL', 279854),
(460761, 'PR00254', NULL, 'Nicotinic acetylcholine receptor signature', NULL, NULL, 'NICOTINICR', 279855),
(460762, 'PR00352', NULL, '3Fe-4S ferredoxin signature', NULL, NULL, '3FE4SFRDOXIN', 279856),
(460763, 'PR01421', NULL, 'GPR37 orphan receptor signature', NULL, NULL, 'GPR37ORPHANR', 279857),
(460764, 'PR00028', NULL, 'POU domain signature', NULL, NULL, 'POUDOMAIN', 279858),
(460765, 'PR01432', NULL, 'Rabaptin signature', NULL, NULL, 'RABAPTIN', 279859),
(460766, 'PR01919', NULL, 'Tumour necrosis factor receptor 1B signature', NULL, NULL, 'TNFACTORR1B', 279860),
(460767, 'PR00568', NULL, 'Dopamine D3 receptor signature', NULL, NULL, 'DOPAMINED3R', 279861),
(460768, 'PR00392', NULL, 'Profilin signature', NULL, NULL, 'PROFILIN', 279862),
(460769, 'PR01573', NULL, 'Tubby superfamily signature', NULL, NULL, 'SUPERTUBBY', 279863),
(460770, 'PR01914', NULL, 'Neurotrophin-3 signature', NULL, NULL, 'NEUROTROPHN3', 279864),
(460771, 'PR01709', NULL, '5-hydroxytryptamine 3 receptor A subunit signature', NULL, NULL, '5HT3ARECEPTR', 279865),
(460772, 'PR01904', NULL, 'GPR40-related receptor family signature', NULL, NULL, 'GPR40FAMILY', 279866),
(460773, 'PR01419', NULL, 'Galanin 2 receptor signature', NULL, NULL, 'GALANIN2R', 279867),
(460774, 'PR01720', NULL, 'Cytotoxic T-lymphocyte antigen 4 signature', NULL, NULL, 'CTLANTIGEN4', 279868),
(460775, 'PR00635', NULL, 'AT1 angiotensin II receptor signature', NULL, NULL, 'ANGIOTENSN1R', 279869),
(460776, 'PR01514', NULL, 'Kv2.1 voltage-gated K+ channel signature', NULL, NULL, 'KV21CHANNEL', 279870),
(460777, 'PR01462', NULL, 'KCNQ3 voltage-gated potassium channel signature', NULL, NULL, 'KCNQ3CHANNEL', 279871),
(460778, 'PR02004', NULL, 'Relaxin signature', NULL, NULL, 'RELAXIN', 279872),
(460779, 'PR00467', NULL, 'Mammalian lipoxygenase signature', NULL, NULL, 'MAMLPOXGNASE', 279873),
(460780, 'PR00949', NULL, 'Type III secretion system inner membrane A protein family signature', NULL, NULL, 'TYPE3IMAPROT', 279874),
(460781, 'PR00401', NULL, 'SH2 domain signature', NULL, NULL, 'SH2DOMAIN', 279875),
(460782, 'PR01854', NULL, 'BR22 protein signature', NULL, NULL, 'BR22PROTEIN', 279876),
(460783, 'PR01710', NULL, '5-hydroxytryptamine 3 receptor B subunit signature', NULL, NULL, '5HT3BRECEPTR', 279877),
(460784, 'PR00561', NULL, 'Beta-1 adrenergic receptor signature', NULL, NULL, 'ADRENRGCB1AR', 279878),
(460785, 'PR00844', NULL, 'Glycosyl hydrolase family 48 signature', NULL, NULL, 'GLHYDRLASE48', 279879),
(460786, 'PR01124', NULL, 'Flavin-containing monooxygenase (FMO) 4 signature', NULL, NULL, 'FMOXYGENASE4', 279880),
(460787, 'PR00022', NULL, 'Somatomedin B signature', NULL, NULL, 'SOMATOMEDINB', 279881),
(460788, 'PR00890', NULL, 'Smooth muscle protein 22-alpha (transgelin) signature', NULL, NULL, 'TRANSGELIN', 279882),
(460789, 'PR01872', NULL, 'Claudin-12 signature', NULL, NULL, 'CLAUDIN12', 279883),
(460790, 'PR00426', NULL, 'C5A-anaphylatoxin receptor signature', NULL, NULL, 'C5ANPHYLTXNR', 279884),
(460791, 'PR01141', NULL, 'Gap junction beta-4 protein (Cx31.1) signature', NULL, NULL, 'CONNEXINB4', 279885),
(460792, 'PR01930', NULL, 'Interleukin-15 signature', NULL, NULL, 'INTRLEUKIN15', 279886),
(460793, 'PR00214', NULL, 'Myelin proteolipid protein (PLP) signature', NULL, NULL, 'MYELINPLP', 279887),
(460794, 'PR01403', NULL, '7,8-dihydro-8-oxoguanine triphosphatase signature', NULL, NULL, '8OXTPHPHTASE', 279888),
(460795, 'PR00424', NULL, 'Adenosine receptor signature', NULL, NULL, 'ADENOSINER', 279889),
(460796, 'PR00775', NULL, '90kDa heat shock protein signature', NULL, NULL, 'HEATSHOCK90', 279890),
(460797, 'PR01206', NULL, 'Orphan neurotransmitter transporter signature', NULL, NULL, 'ORPHTRNSPORT', 279891),
(460798, 'PR01907', NULL, 'Worm globin signature', NULL, NULL, 'WORMGLOBIN', 279892),
(460799, 'PR00575', NULL, 'Red/green-sensitive opsin signature', NULL, NULL, 'OPSINREDGRN', 279893),
(460800, 'PR02092', NULL, 'Hepatitis B virus X-interacting protein signature', NULL, NULL, 'HEPBVIRUSXIP', 279894);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(460801, 'PR00942', NULL, 'Copper-transporting ATPase 1 signature', NULL, NULL, 'CUATPASEI', 279895),
(460802, 'PR01158', NULL, 'Topoisomerase II signature', NULL, NULL, 'TOPISMRASEII', 279896),
(460803, 'PR00681', NULL, 'Ribosomal protein S1 signature', NULL, NULL, 'RIBOSOMALS1', 279897),
(460804, 'PR01733', NULL, 'Mycoplasma P48 major surface lipoprotein signature', NULL, NULL, 'LIPPROTEIN48', 279898),
(460805, 'PR01883', NULL, 'Leukaemia inhibitory factor signature', NULL, NULL, 'LEUKAEMIAIF', 279899),
(460806, 'PR01636', NULL, 'Voltage-dependent L-type calcium channel alpha-1D subunit signature', NULL, NULL, 'LVDCCALPHA1D', 279900),
(460807, 'PR01988', NULL, 'Putative bacilysin exporter bacE signature', NULL, NULL, 'EXPORTERBACE', 279901),
(460808, 'PR00357', NULL, 'Type III antifreeze protein signature', NULL, NULL, 'ANTIFREEZIII', 279902),
(460809, 'PR00493', NULL, 'Breast cancer type I susceptibility protein signature', NULL, NULL, 'BRSTCANCERI', 279903),
(460810, 'PR00127', NULL, 'Clp protease catalytic subunit P signature', NULL, NULL, 'CLPPROTEASEP', 279904),
(460811, 'PR00695', NULL, 'Copper containing nitrite reductase signature', NULL, NULL, 'CUNO2RDTASE', 279905),
(460812, 'PR00491', NULL, 'Vasoactive intestinal peptide receptor signature', NULL, NULL, 'VASOACTVEIPR', 279906),
(460813, 'PR01547', NULL, 'Saccharomyces cerevisiae 175.8kDa hypothetical protein signature', NULL, NULL, 'YEAST176DUF', 279907),
(460814, 'PR01470', NULL, 'ERG potassium channel family signature', NULL, NULL, 'ERGCHANNEL', 279908),
(460815, 'PR01029', NULL, 'Proenkephalin A precursor signature', NULL, NULL, 'PENKAPRCRSR', 279909),
(460816, 'PR00770', NULL, 'Eosinophil major basic protein signature', NULL, NULL, 'EMAJORBASICP', 279910),
(460817, 'PR01867', NULL, 'Bcl-2-related protein A1 signature', NULL, NULL, 'BCL2RLATEDA1', 279911),
(460818, 'PR01287', NULL, 'Orphan nuclear receptor NURR signature', NULL, NULL, 'NURRNUCRCPTR', 279912),
(460819, 'PR02005', NULL, 'Insulin-like growth factor I signature', NULL, NULL, 'INSLNLIKEGF1', 279913),
(460820, 'PR00058', NULL, 'Ribosomal protein L5 signature', NULL, NULL, 'RIBOSOMALL5', 279914),
(460821, 'PR00885', NULL, 'Bacterial general secretion pathway protein H signature', NULL, NULL, 'BCTERIALGSPH', 279915),
(460822, 'PR01859', NULL, 'ADAM-TS2 protein signature', NULL, NULL, 'ADAMTS2', 279916),
(460823, 'PR01563', NULL, 'G2A lysophosphatidylcholine receptor signature', NULL, NULL, 'G2ARECEPTOR', 279917),
(460824, 'PR00445', NULL, 'HupF/HypC hydrogenase expression/synthesis family signature', NULL, NULL, 'HUPFHYPC', 279918),
(460825, 'PR00182', NULL, 'E.coli/Neisseria porin superfamily signature', NULL, NULL, 'ECOLNEIPORIN', 279919),
(460826, 'PR01076', NULL, 'Caldesmon signature', NULL, NULL, 'CALDESMON', 279920),
(460827, 'PR01326', NULL, 'Kir2.3 inward rectifier K+ channel signature', NULL, NULL, 'KIR23CHANNEL', 279921),
(460828, 'PR00194', NULL, 'Tropomyosin signature', NULL, NULL, 'TROPOMYOSIN', 279922),
(460829, 'PR01823', NULL, 'Janus kinase family signature', NULL, NULL, 'JANUSKINASE', 279923),
(460830, 'PR01016', NULL, 'Neuropeptide Y5 receptor signature', NULL, NULL, 'NRPEPTIDEY5R', 279924),
(460831, 'PR00562', NULL, 'Beta-2 adrenergic receptor signature', NULL, NULL, 'ADRENRGCB2AR', 279925),
(460832, 'PR01886', NULL, 'Protein Associated with Small Stress protein 1 (PASS1) signature', NULL, NULL, 'PASS1', 279926),
(460833, 'PR02033', NULL, 'Placentin signature', NULL, NULL, 'PLACENTIN', 279927),
(460834, 'PR02014', NULL, 'Aquaporin-2 signature', NULL, NULL, 'AQUAPORIN2', 279928),
(460835, 'PR00122', NULL, 'Vacuolar ATP synthase 16kDa subunit signature', NULL, NULL, 'VACATPASE', 279929),
(460836, 'PR00628', NULL, 'Insulin receptor substrate-1 PTB domain signature', NULL, NULL, 'INSULINRSI', 279930),
(460837, 'PR01851', NULL, 'Cystic fibrosis transmembrane conductance regulator signature', NULL, NULL, 'CYSFIBREGLTR', 279931),
(460838, 'PR01311', NULL, 'P2X4 purinoceptor signature', NULL, NULL, 'P2X4RECEPTOR', 279932),
(460839, 'PR02038', NULL, 'Aurora borealis protein signature', NULL, NULL, 'AURORABORA', 279933);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(460840, 'PR00665', NULL, 'Oxytocin receptor signature', NULL, NULL, 'OXYTOCINR', 279934),
(460841, 'PR01763', NULL, 'Dishevelled-3 protein signature', NULL, NULL, 'DISHEVELLED3', 279935),
(460842, 'PR00946', NULL, 'Mercury scavenger protein signature', NULL, NULL, 'HGSCAVENGER', 279936),
(460843, 'PR01648', NULL, 'Transient receptor potential channel 7 signature', NULL, NULL, 'TRPCHANNEL7', 279937),
(460844, 'PR00758', NULL, 'Arsenical pump membrane protein signature', NULL, NULL, 'ARSENICPUMP', 279938),
(460845, 'PR01032', NULL, 'Gene IV protein signature', NULL, NULL, 'PHAGEIV', 279939),
(460846, 'PR00839', NULL, 'V8 serine protease family signature', NULL, NULL, 'V8PROTEASE', 279940),
(460847, 'PR00404', NULL, 'MADS domain signature', NULL, NULL, 'MADSDOMAIN', 279941),
(460848, 'PR00428', NULL, 'Prostaglandin receptor signature', NULL, NULL, 'PROSTAGLNDNR', 279942),
(460849, 'PR01069', NULL, 'Acetyl-CoA carboxylase carboxyl transferase alpha subunit signature', NULL, NULL, 'ACCCTRFRASEA', 279943),
(460850, 'PR00190', NULL, 'Actin signature', NULL, NULL, 'ACTIN', 279944),
(460851, 'PR01276', NULL, 'Type II keratin signature', NULL, NULL, 'TYPE2KERATIN', 279945),
(460852, 'PR00085', NULL, 'Tetrahydrofolate dehydrogenase/cyclohydrolase family signature', NULL, NULL, 'THFDHDRGNASE', 279946),
(460853, 'PR00381', NULL, 'Kinesin light chain signature', NULL, NULL, 'KINESINLIGHT', 279947),
(460854, 'PR00924', NULL, 'Alphaherpesvirus alkaline exonuclease signature', NULL, NULL, 'ALKEXNUCLASE', 279948),
(460855, 'PR01112', NULL, 'CLC-1 chloride channel signature', NULL, NULL, 'CLCHANNEL1', 279949),
(460856, 'PR00458', NULL, 'Haem peroxidase superfamily signature', NULL, NULL, 'PEROXIDASE', 279950),
(460857, 'PR00579', NULL, 'Rhodopsin signature', NULL, NULL, 'RHODOPSIN', 279951),
(460858, 'PR01627', NULL, 'L-type calcium channel beta-1 subunit signature', NULL, NULL, 'LCACHANNELB1', 279952),
(460859, 'PR00897', NULL, 'Vasopressin V1B receptor signature', NULL, NULL, 'VASOPRSNV1BR', 279953),
(460860, 'PR01893', NULL, 'Wnt-10 protein signature', NULL, NULL, 'WNT10PROTEIN', 279954),
(460861, 'PR00487', NULL, 'Filaggrin signature', NULL, NULL, 'FILAGGRIN', 279955),
(460862, 'PR00766', NULL, 'Amiloride-sensitive amine oxidase signature', NULL, NULL, 'CUDAOXIDASE', 279956),
(460863, 'PR00850', NULL, 'Glycosyl hydrolase family 59 signature', NULL, NULL, 'GLHYDRLASE59', 279957),
(460864, 'PR01523', NULL, 'Sphingosine 1-phosphate receptor family signature', NULL, NULL, 'S1PRECEPTOR', 279958),
(460865, 'PR00260', NULL, 'Bacterial chemotaxis sensory transducer signature', NULL, NULL, 'CHEMTRNSDUCR', 279959),
(460866, 'PR00294', NULL, 'Streptomyces subtilisin inhibitor signature', NULL, NULL, 'SSBTLNINHBTR', 279960),
(460867, 'PR00606', NULL, 'Class ID cytochrome C signature', NULL, NULL, 'CYTCHROMECID', 279961),
(460868, 'PR01279', NULL, 'Corticotropin releasing factor receptor signature', NULL, NULL, 'CRFRECEPTOR', 279962),
(460869, 'PR01593', NULL, 'Salmonella type III secretion SopE effector protein signature', NULL, NULL, 'SOPEPROTEIN', 279963),
(460870, 'PR01937', NULL, 'Interleukin-24 signature', NULL, NULL, 'INTRLEUKIN24', 279964),
(460871, 'PR00492', NULL, 'RHO protein GDP dissociation inhibitor signature', NULL, NULL, 'RHOGDI', 279965),
(460872, 'PR00281', NULL, 'Hok/Gef cell toxic protein family signature', NULL, NULL, 'HOKGEFTOXIC', 279966),
(460873, 'PR01031', NULL, 'Nociceptin precursor signature', NULL, NULL, 'ORPHNNPRCRSR', 279967),
(460874, 'PR01078', NULL, 'Amiloride-sensitive sodium channel alpha-subunit signature', NULL, NULL, 'AMINACHANNEL', 279968),
(460875, 'PR00489', NULL, 'Frizzled protein signature', NULL, NULL, 'FRIZZLED', 279969),
(460876, 'PR01105', NULL, 'C-X-C chemokine receptor type 6 signature', NULL, NULL, 'CXCCHMKINER6', 279970),
(460877, 'PR01822', NULL, 'Cholecystokinin receptor family signature', NULL, NULL, 'CCYSTOKININR', 279971),
(460878, 'PR00531', NULL, 'Histamine H2 receptor signature', NULL, NULL, 'HISTAMINEH2R', 279972),
(460879, 'PR00615', NULL, 'CCAAT-binding transcription factor subunit A signature', NULL, NULL, 'CCAATSUBUNTA', 279973);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(460880, 'PR00071', NULL, 'Hydroxymethylglutaryl-coenzyme A reductase signature', NULL, NULL, 'HMGCOARDTASE', 279974),
(460881, 'PR01093', NULL, 'Sulphonylurea receptor type 1 family signature', NULL, NULL, 'SULFNYLUR1', 279975),
(460882, 'PR01250', NULL, 'Ribosomal protein L34 signature', NULL, NULL, 'RIBOSOMALL34', 279976),
(460883, 'PR00816', NULL, 'Zeta haemoglobin signature', NULL, NULL, 'ZETAHAEM', 279977),
(460884, 'PR01420', NULL, 'Galanin 3 receptor signature', NULL, NULL, 'GALANIN3R', 279978),
(460885, 'PR01002', NULL, 'Flagellar protein FlgJ signature', NULL, NULL, 'FLGFLGJ', 279979),
(460886, 'PR00318', NULL, 'Alpha G protein (transducin) signature', NULL, NULL, 'GPROTEINA', 279980),
(460887, 'PR01743', NULL, 'Single-strand DNA-binding protein signature', NULL, NULL, 'SSDNABINDING', 279981),
(460888, 'PR01863', NULL, 'Bcl-2 apoptosis regulator protein signature', NULL, NULL, 'APOPREGBCL2', 279982),
(460889, 'PR00497', NULL, 'Neutrophil cytosol factor P40 signature', NULL, NULL, 'P40PHOX', 279983),
(460890, 'PR00591', NULL, 'Somatostatin receptor type 5 signature', NULL, NULL, 'SOMATOSTTN5R', 279984),
(460891, 'PR00033', NULL, 'AsnC bacterial regulatory protein HTH signature', NULL, NULL, 'HTHASNC', 279985),
(460892, 'PR01660', NULL, 'Mini-chromosome maintenance (MCM) protein 4 signature', NULL, NULL, 'MCMPROTEIN4', 279986),
(460893, 'PR00522', NULL, 'Cannabinoid receptor type 1 signature', NULL, NULL, 'CANABINOID1R', 279987),
(460894, 'PR01798', NULL, 'Succinyl-CoA synthase signature', NULL, NULL, 'SCOASYNTHASE', 279988),
(460895, 'PR00668', NULL, 'Glycoprotein C signature', NULL, NULL, 'GLYCPROTEINC', 279989),
(460896, 'PR00577', NULL, 'Opsin RH3/RH4 signature', NULL, NULL, 'OPSINRH3RH4', 279990),
(460897, 'PR00300', NULL, 'ATP-dependent Clp protease ATP-binding subunit signature', NULL, NULL, 'CLPPROTEASEA', 279991),
(460898, 'PR01414', NULL, 'Cytochrome c-type biogenesis protein CcmB signature', NULL, NULL, 'CCMBBIOGNSIS', 279992),
(460899, 'PR01439', NULL, 'Cellulose synthase subunit A signature', NULL, NULL, 'CELLSNTHASEA', 279993),
(460900, 'PR01968', NULL, 'Tumour necrosis factor receptor 18 signature', NULL, NULL, 'TNFACTORR18', 279994),
(460901, 'PR00973', NULL, 'Ribosomal protein S17 family signature', NULL, NULL, 'RIBOSOMALS17', 279995),
(460902, 'PR00943', NULL, 'Copper-transporting ATPase signature', NULL, NULL, 'CUATPASE', 279996),
(460903, 'PR00131', NULL, 'Glycosyl hydrolase family 1 signature', NULL, NULL, 'GLHYDRLASE1', 279997),
(460904, 'PR01126', NULL, 'DEZ orphan receptor signature', NULL, NULL, 'DEZORPHANR', 279998),
(460905, 'PR00092', NULL, 'Tyrosinase copper-binding domain signature', NULL, NULL, 'TYROSINASE', 279999),
(460906, 'PR00877', NULL, 'Plant PEC family metallothionein signature', NULL, NULL, 'MTPLANTPEC', 280000),
(460907, 'PR01087', NULL, 'Na+/H+ exchanger isoform 3 (NHE3) signature', NULL, NULL, 'NAHEXCHNGR3', 280001),
(460908, 'PR01417', NULL, 'Growth hormone secretagogue receptor type 1 signature', NULL, NULL, 'GHSRECEPTOR', 280002),
(460909, 'PR02060', NULL, 'Wolframin family signature', NULL, NULL, 'WOLFFAMILY', 280003),
(460910, 'PR00965', NULL, 'Ocular albinism type 1 protein signature', NULL, NULL, 'OCULARALBNSM', 280004),
(460911, 'PR01317', NULL, 'Glial cell line-derived neurotrophic factor receptor alpha 1 signature', NULL, NULL, 'GDNFRALPHA1', 280005),
(460912, 'PR00959', NULL, 'Mevalonate kinase family signature', NULL, NULL, 'MEVGALKINASE', 280006),
(460913, 'PR00138', NULL, 'Matrixin signature', NULL, NULL, 'MATRIXIN', 280007),
(460914, 'PR01429', NULL, 'Protease activated receptor 3 precursor signature', NULL, NULL, 'PROTEASEAR3', 280008),
(460915, 'PR01574', NULL, 'Tubby protein signature', NULL, NULL, 'TUBBYPROTEIN', 280009),
(460916, 'PR01649', NULL, 'Psychosine receptor signature', NULL, NULL, 'PSYCHOSINER', 280010),
(460917, 'PR01290', NULL, 'Peroxisome proliferator-activated receptor beta signature', NULL, NULL, 'PROXISOMPABR', 280011),
(460918, 'PR01183', NULL, 'Ribonucleotide reductase large chain signature', NULL, NULL, 'RIBORDTASEM1', 280012);
INSERT INTO "PUBLIC"."MODEL" VALUES
(460919, 'PR01300', NULL, 'Pyocin S killer protein signature', NULL, NULL, 'PYOCINKILLER', 280013),
(460920, 'PR00904', NULL, 'Frataxin signature', NULL, NULL, 'FRATAXIN', 280014),
(460921, 'PR01218', NULL, 'Pistil-specific extensin-like signature', NULL, NULL, 'PSTLEXTENSIN', 280015),
(460922, 'PR01952', NULL, 'Nisin biosynthesis protein NisC signature', NULL, NULL, 'NISCPROTEIN', 280016),
(460923, 'PR00721', NULL, 'Stomatin signature', NULL, NULL, 'STOMATIN', 280017),
(460924, 'PR01150', NULL, 'Melatonin 1C receptor signature', NULL, NULL, 'MELATONIN1CR', 280018),
(460925, 'PR00707', NULL, 'Ubiquitin C-terminal hydrolase (C12) family signature', NULL, NULL, 'UBCTHYDRLASE', 280019),
(460926, 'PR00323', NULL, 'Gallidermin signature', NULL, NULL, 'GALLIDERMIN', 280020),
(460927, 'PR01568', NULL, 'Lymphotactin receptor signature', NULL, NULL, 'LYMPHOTACTNR', 280021),
(460928, 'PR02083', NULL, 'G kinase-anchoring protein 1 signature', NULL, NULL, 'GKINASEAP1', 280022),
(460929, 'PR00921', NULL, 'IgA-specific serine endopeptidase (S6) signature', NULL, NULL, 'IGASERPTASE', 280023),
(460930, 'PR00443', NULL, 'G protein alpha subunit group S signature', NULL, NULL, 'GPROTEINAS', 280024),
(460931, 'PR00030', NULL, 'Cro repressor HTH signature', NULL, NULL, 'HTHCRO', 280025),
(460932, 'PR01057', NULL, 'Metabotropic glutamate receptor 7 signature', NULL, NULL, 'MTABOTROPC7R', 280026),
(460933, 'PR02072', NULL, 'Four-jointed box protein 1 signature', NULL, NULL, '4JOINTEDBOX1', 280027),
(460934, 'PR01542', NULL, 'Foot-and-mouth disease virus VP1 coat protein signature', NULL, NULL, 'FMDVP1COAT', 280028),
(460935, 'PR01070', NULL, 'Acetyl-CoA carboxylase carboxyl transferase beta subunit signature', NULL, NULL, 'ACCCTRFRASEB', 280029),
(460936, 'PR00609', NULL, 'Class III cytochrome C signature', NULL, NULL, 'CYTOCHROMEC3', 280030),
(460937, 'PR01305', NULL, 'Invasion protein B family signature', NULL, NULL, 'SSPAKPROTEIN', 280031),
(460938, 'PR01097', NULL, 'Transient receptor potential family signature', NULL, NULL, 'TRNSRECEPTRP', 280032),
(460939, 'PR01171', NULL, 'Bacterial lipocalin signature', NULL, NULL, 'BCTLIPOCALIN', 280033),
(460940, 'PR00101', NULL, 'Aspartate carbamoyltransferase signature', NULL, NULL, 'ATCASE', 280034),
(460941, 'PR01628', NULL, 'L-type calcium channel beta-2 subunit signature', NULL, NULL, 'LCACHANNELB2', 280035),
(460942, 'PR01603', NULL, 'Voltage-dependent calcium channel gamma-4 subunit signature', NULL, NULL, 'VDCCGAMMA4', 280036),
(460943, 'PR00288', NULL, 'Purothionin signature', NULL, NULL, 'PUROTHIONIN', 280037),
(460944, 'PR00074', NULL, 'Protein-lysine 6-oxidase precursor signature', NULL, NULL, 'LYSYLOXIDASE', 280038),
(460945, 'PR00402', NULL, 'Tec/Btk domain signature', NULL, NULL, 'TECBTKDOMAIN', 280039),
(460946, 'PR00927', NULL, 'Adenine nucleotide translocator signature', NULL, NULL, 'ADPTRNSLCASE', 280040),
(460947, 'PR01330', NULL, 'Kir3.4 inward rectifier K+ channel signature', NULL, NULL, 'KIR34CHANNEL', 280041),
(460948, 'PR00751', NULL, 'Thyrotrophin-releasing hormone receptor signature', NULL, NULL, 'THYROLIBRINR', 280042),
(460949, 'PR00385', NULL, 'P450 superfamily signature', NULL, NULL, 'P450', 280043),
(460950, 'PR01240', NULL, 'Filoviridae VP35 signature', NULL, NULL, 'FILOVP35', 280044),
(460951, 'PR01230', NULL, 'Thiazide-sensitive Na-Cl co-transporter signature', NULL, NULL, 'NACLTRNSPORT', 280045),
(460952, 'PR00291', NULL, 'Soybean trypsin inhibitor (Kunitz-type) signature', NULL, NULL, 'KUNITZINHBTR', 280046),
(460953, 'PR01507', NULL, 'Melanin-concentrating hormone 1 receptor signature', NULL, NULL, 'MCH1RECEPTOR', 280047),
(460954, 'PR01552', NULL, 'DNA topoisomerase VI subunit A (TOP6A) signature', NULL, NULL, 'TPISMRASE6A', 280048),
(460955, 'PR01737', NULL, 'Porphyromonas gingivalis fimbrillin protein signature', NULL, NULL, 'FIMBRILLIN', 280049),
(460956, 'PR01785', NULL, 'Paraoxonase family signature', NULL, NULL, 'PARAOXONASE', 280050),
(460957, 'PR01060', NULL, 'C3A-anaphylatoxin receptor signature', NULL, NULL, 'C3ANPHYLTXNR', 280051);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(460958, 'PR00678', NULL, 'PI3 kinase P85 regulatory subunit signature', NULL, NULL, 'PI3KINASEP85', 280052),
(460959, 'PR00142', NULL, 'RecA protein signature', NULL, NULL, 'RECA', 280053),
(460960, 'PR00170', NULL, 'Voltage-gated Na+ channel alpha subunit signature', NULL, NULL, 'NACHANNEL', 280054),
(460961, 'PR00518', NULL, '5-hydroxytryptamine 5A receptor signature', NULL, NULL, '5HT5ARECEPTR', 280055),
(460962, 'PR01114', NULL, 'CLC-3 chloride channel signature', NULL, NULL, 'CLCHANNEL3', 280056),
(460963, 'PR01065', NULL, 'P2Y3 purinoceptor signature', NULL, NULL, 'P2Y3PRNOCPTR', 280057),
(460964, 'PR00171', NULL, 'Sugar transporter signature', NULL, NULL, 'SUGRTRNSPORT', 280058),
(460965, 'PR01283', NULL, 'Ecdysteroid receptor (1H nuclear receptor) signature', NULL, NULL, 'ECDYSTEROIDR', 280059),
(460966, 'PR01903', NULL, 'Cysteinyl leukotriene receptor 2 signature', NULL, NULL, 'CYSLT2RECPTR', 280060),
(460967, 'PR00622', NULL, 'Histone H3 signature', NULL, NULL, 'HISTONEH3', 280061),
(460968, 'PR00845', NULL, 'Glycosyl hydrolase family 52 signature', NULL, NULL, 'GLHYDRLASE52', 280062),
(460969, 'PR00431', NULL, 'Interleukin-4 signature', NULL, NULL, 'INTERLEUKIN4', 280063),
(460970, 'PR00230', NULL, 'Geminivirus AL2 coat protein signature', NULL, NULL, 'GEMCOATAL2', 280064),
(460971, 'PR00232', NULL, 'Potex and carlavirus coat protein signature', NULL, NULL, 'POTXCARLCOAT', 280065),
(460972, 'PR00365', NULL, 'Endothelin signature', NULL, NULL, 'ENDOTHELIN', 280066),
(460973, 'PR00205', NULL, 'Cadherin signature', NULL, NULL, 'CADHERIN', 280067),
(460974, 'PR00755', NULL, 'Aflatoxin biosynthesis regulatory protein signature', NULL, NULL, 'AFLATOXINBRP', 280068),
(460975, 'PR01456', NULL, 'Epithelial membrane protein EMP-3 signature', NULL, NULL, 'EPMEMPROT3', 280069),
(460976, 'PR00099', NULL, 'Carbamoyl-phosphate synthase protein GATase domain signature', NULL, NULL, 'CPSGATASE', 280070),
(460977, 'PR01905', NULL, 'Fatty acid receptor GPR40 signature', NULL, NULL, 'FATTYACIDR', 280071),
(460978, 'PR00603', NULL, 'Cytochrome C1 signature', NULL, NULL, 'CYTOCHROMEC1', 280072),
(460979, 'PR01227', NULL, 'Salmonella surface presentation of antigen gene type M signature', NULL, NULL, 'SSPAMPROTEIN', 280073),
(460980, 'PR00791', NULL, 'Peptidyl-dipeptidase A (M2) metalloprotease family signature', NULL, NULL, 'PEPDIPTASEA', 280074),
(460981, 'PR00207', NULL, 'Flagellin signature', NULL, NULL, 'FLAGELLIN', 280075),
(460982, 'PR01220', NULL, 'Tick histamine binding protein signature', NULL, NULL, 'HISBINDING', 280076),
(460983, 'PR01108', NULL, 'C-C chemokine receptor type 3 signature', NULL, NULL, 'CHEMOKINER3', 280077),
(460984, 'PR00227', NULL, 'Geminivirus AL1 coat protein signature', NULL, NULL, 'GEMCOATAL1', 280078),
(460985, 'PR00423', NULL, 'Cell division protein FtsZ signature', NULL, NULL, 'CELLDVISFTSZ', 280079),
(460986, 'PR01314', NULL, 'P2X7 purinoceptor signature', NULL, NULL, 'P2X7RECEPTOR', 280080),
(460987, 'PR01387', NULL, 'Cytolethal distending toxin A signature', NULL, NULL, 'CDTOXINA', 280081),
(460988, 'PR00698', NULL, 'C.elegans Srg family integral membrane protein signature', NULL, NULL, 'TMPROTEINSRG', 280082),
(460989, 'PR01689', NULL, 'CYP3A P450 family signature', NULL, NULL, 'EP450IICYP3A', 280083),
(460990, 'PR01671', NULL, 'Gamma-aminobutyric-acid A (GABAA) receptor rho 1 subunit signature', NULL, NULL, 'GABAARRHO1', 280084),
(460991, 'PR01357', NULL, 'Interleukin-1 alpha/beta precursor family signature', NULL, NULL, 'INTRLEUKN1AB', 280085),
(460992, 'PR00956', NULL, 'Flagellar motor switch protein FliN signature', NULL, NULL, 'FLGMOTORFLIN', 280086),
(460993, 'PR01090', NULL, 'Neuroligin signature', NULL, NULL, 'NEUROLIGIN', 280087),
(460994, 'PR01350', NULL, 'Calcitonin receptor family signature', NULL, NULL, 'CTRFAMILY', 280088),
(460995, 'PR00183', NULL, 'E.coli/Salmonella-type porin signature', NULL, NULL, 'ECOLIPORIN', 280089),
(460996, 'PR01418', NULL, 'Galanin 1 receptor signature', NULL, NULL, 'GALANIN1R', 280090),
(460997, 'PR01122', NULL, 'Flavin-containing monooxygenase (FMO) 2 signature', NULL, NULL, 'FMOXYGENASE2', 280091);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(460998, 'PR01328', NULL, 'Kir3.2 inward rectifier K+ channel signature', NULL, NULL, 'KIR32CHANNEL', 280092),
(460999, 'PR01927', NULL, 'Interleukin-11 signature', NULL, NULL, 'INTRLEUKIN11', 280093),
(461000, 'PR00905', NULL, 'Uncharacterised MG045 lipoprotein family signature', NULL, NULL, 'MG045FAMILY', 280094),
(461001, 'PR01139', NULL, 'Gap junction beta-2 protein (Cx26) signature', NULL, NULL, 'CONNEXINB2', 280095),
(461002, 'PR01747', NULL, 'Dense granule Gra7 protein signature', NULL, NULL, 'DENSEGRNULE7', 280096),
(461003, 'PR01479', NULL, 'Neurotensin receptor signature', NULL, NULL, 'NEUROTENSINR', 280097),
(461004, 'PR01582', NULL, 'Kv3.3 voltage-gated K+ channel signature', NULL, NULL, 'KV33CHANNEL', 280098),
(461005, 'PR01209', NULL, 'Na-K-Cl co-transporter 2 signature', NULL, NULL, 'NAKCLTRSPRT2', 280099),
(461006, 'PR02069', NULL, 'Endothelial cell-specific chemotaxis regulator signature', NULL, NULL, 'ECCREGULATOR', 280100),
(461007, 'PR01347', NULL, 'Ephrin signature', NULL, NULL, 'EPHRIN', 280101),
(461008, 'PR00554', NULL, 'Adenosine A2B receptor signature', NULL, NULL, 'ADENOSINA2BR', 280102),
(461009, 'PR00969', NULL, 'Pili chaperone signature', NULL, NULL, 'CHAPERONPILI', 280103),
(461010, 'PR01623', NULL, 'Gamma-aminobutyric-acid A receptor gamma 3 subunit signature', NULL, NULL, 'GABAARGAMMA3', 280104),
(461011, 'PR00303', NULL, 'Preprotein translocase SecY subunit signature', NULL, NULL, 'SECYTRNLCASE', 280105),
(461012, 'PR01400', NULL, 'Bacterial thiol-activated pore-forming cytolysin signature', NULL, NULL, 'TACYTOLYSIN', 280106),
(461013, 'PR00808', NULL, 'Cereal trypsin/alpha-amylase inhibitor family signature', NULL, NULL, 'AMLASEINHBTR', 280107),
(461014, 'PR00931', NULL, 'Microbial collagenase metalloprotease (M9) signature', NULL, NULL, 'MICOLLPTASE', 280108),
(461015, 'PR00945', NULL, 'Mercuric reductase class II signature', NULL, NULL, 'HGRDTASE', 280109),
(461016, 'PR01606', NULL, 'KCNE voltage-gated K+ channel subfamily E3 signature', NULL, NULL, 'KCNE3CHANNEL', 280110),
(461017, 'PR01498', NULL, 'Shaw voltage-gated K+ channel family signature', NULL, NULL, 'SHAWCHANNEL', 280111),
(461018, 'PR01156', NULL, 'Pituitary adenylate cyclase activating polypeptide type 1 receptor signature', NULL, NULL, 'PACAPRECEPTR', 280112),
(461019, 'PR01433', NULL, 'Polycystic kidney disease type 2 protein (PKD2) signature', NULL, NULL, 'POLYCYSTIN2', 280113),
(461020, 'PR01490', NULL, 'Gram-negative bacterial RTX secretion protein D signature', NULL, NULL, 'RTXTOXIND', 280114),
(461021, 'PR01571', NULL, 'Type 1 neuropeptide FF receptor signature', NULL, NULL, 'NPFFRECEPTR1', 280115),
(461022, 'PR01589', NULL, 'Claudin-2 signature', NULL, NULL, 'CLAUDIN2', 280116),
(461023, 'PR01634', NULL, 'Voltage-dependent L-type calcium channel alpha-1S subunit signature', NULL, NULL, 'LVDCCALPHA1S', 280117),
(461024, 'PR01081', NULL, 'K-Cl co-transporter signature', NULL, NULL, 'KCLTRNSPORT', 280118),
(461025, 'PR01847', NULL, 'Viral fusion protein signature', NULL, NULL, 'VIRALFUSION', 280119),
(461026, 'PR01536', NULL, 'Interleukin-1 receptor type I and type II family signature', NULL, NULL, 'INTRLKN1R12F', 280120),
(461027, 'PR01267', NULL, 'Mu-class glutathione S-transferase signature', NULL, NULL, 'GSTRNSFRASEM', 280121),
(461028, 'PR00121', NULL, 'Sodium/potassium-transporting ATPase signature', NULL, NULL, 'NAKATPASE', 280122),
(461029, 'PR00175', NULL, 'Sodium/alanine symporter signature', NULL, NULL, 'NAALASMPORT', 280123),
(461030, 'PR00962', NULL, 'Lethal(2) giant larvae protein signature', NULL, NULL, 'LETHAL2GIANT', 280124),
(461031, 'PR00197', NULL, 'Annexin type I signature', NULL, NULL, 'ANNEXINI', 280125),
(461032, 'PR01360', NULL, 'Interleukin-1 receptor antagonist precursor IL-1RA signature', NULL, NULL, 'INTRLEUKIN1X', 280126),
(461033, 'PR00407', NULL, 'Eukaryotic molybdopterin domain signature', NULL, NULL, 'EUMOPTERIN', 280127),
(461034, 'PR00090', NULL, 'Ring hydroxylating dioxygenase alpha-subunit signature', NULL, NULL, 'RNGDIOXGNASE', 280128),
(461035, 'PR01050', NULL, 'Pyruvate kinase family signature', NULL, NULL, 'PYRUVTKNASE', 280129);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(461036, 'PR01928', NULL, 'Interleukin-12 beta subunit signature', NULL, NULL, 'INTRLEUKN12B', 280130),
(461037, 'PR00168', NULL, 'KCNE voltage-gated K+ channel family E signature', NULL, NULL, 'KCNECHANNEL', 280131),
(461038, 'PR01153', NULL, 'Platelet activating factor receptor signature', NULL, NULL, 'PAFRECEPTOR', 280132),
(461039, 'PR01241', NULL, 'Fungal G protein alpha subunit signature', NULL, NULL, 'GPROTEINAFNG', 280133),
(461040, 'PR00674', NULL, 'Light harvesting protein B chain signature', NULL, NULL, 'LIGHTHARVSTB', 280134),
(461041, 'PR01680', NULL, 'Tumour necrosis factor receptor 6 signature', NULL, NULL, 'TNFACTORR6', 280135),
(461042, 'PR01343', NULL, 'Yeast eukaryotic release factor signature', NULL, NULL, 'YEASTERF', 280136),
(461043, 'PR01809', NULL, 'Annexin type A10 signature', NULL, NULL, 'ANNEXINX', 280137),
(461044, 'PR00442', NULL, 'G protein alpha subunit group Q signature', NULL, NULL, 'GPROTEINAQ', 280138),
(461045, 'PR00265', NULL, 'Interleukin-2 signature', NULL, NULL, 'INTERLEUKIN2', 280139),
(461046, 'PR00178', NULL, 'Fatty acid-binding protein signature', NULL, NULL, 'FATTYACIDBP', 280140),
(461047, 'PR00632', NULL, 'Sonic hedgehog protein signature', NULL, NULL, 'SONICHHOG', 280141),
(461048, 'PR00910', NULL, 'Luteovirus ORF6 protein signature', NULL, NULL, 'LVIRUSORF6', 280142),
(461049, 'PR00280', NULL, 'Channel forming colicin signature', NULL, NULL, 'CHANLCOLICIN', 280143),
(461050, 'PR02049', NULL, 'Protein family FAM36A signature', NULL, NULL, 'PROTEINF36A', 280144),
(461051, 'PR00855', NULL, 'Prostaglandin F receptor signature', NULL, NULL, 'PRSTNOIDFPR', 280145),
(461052, 'PR00780', NULL, 'Leuserpin 2 signature', NULL, NULL, 'LEUSERPINII', 280146),
(461053, 'PR01532', NULL, 'C-X-C chemokine receptor type 3 signature', NULL, NULL, 'CXCCHMKINER3', 280147),
(461054, 'PR01922', NULL, 'Tumour necrosis factor receptor 5 signature', NULL, NULL, 'TNFACTORR5', 280148),
(461055, 'PR00333', NULL, 'Herpsevirus integral membrane protein signature', NULL, NULL, 'HSVINTEGRLMP', 280149),
(461056, 'PR01063', NULL, 'Melanocortin 5 receptor signature', NULL, NULL, 'MELNOCORTN5R', 280150),
(461057, 'PR01096', NULL, 'TWIK-1 K+ channel signature', NULL, NULL, 'TWIK1CHANNEL', 280151),
(461058, 'PR01318', NULL, 'Glial cell line-derived neurotrophic factor receptor alpha 2 signature', NULL, NULL, 'GDNFRALPHA2', 280152),
(461059, 'PR01378', NULL, 'Claudin-3 signature', NULL, NULL, 'CLAUDIN3', 280153),
(461060, 'PR00252', NULL, 'Neurotransmitter-gated ion channel family signature', NULL, NULL, 'NRIONCHANNEL', 280154),
(461061, 'PR01975', NULL, 'Tumour necrosis factor receptor 11B signature', NULL, NULL, 'TNFACTORR11B', 280155),
(461062, 'PR00571', NULL, 'Endothelin-B receptor signature', NULL, NULL, 'ENDOTHELINBR', 280156),
(461063, 'PR00256', NULL, 'Bacterial photosynthetic reaction centre signature', NULL, NULL, 'REACTNCENTRE', 280157),
(461064, 'PR00470', NULL, 'Trypanothione reductase signature', NULL, NULL, 'TRYPANRDTASE', 280158),
(461065, 'PR01599', NULL, 'Zona occludens protein ZO-2 signature', NULL, NULL, 'ZONOCCLUDNS2', 280159),
(461066, 'PR01950', NULL, 'LanC-like protein superfamily signature', NULL, NULL, 'LANCSUPER', 280160),
(461067, 'PR01430', NULL, 'Protease activated receptor 2 precursor signature', NULL, NULL, 'PROTEASEAR4', 280161),
(461068, 'PR01345', NULL, 'C.elegans hypothetical protein (pol-like reverse transciptase) signature', NULL, NULL, 'CERVTRCPTASE', 280162),
(461069, 'PR01180', NULL, 'Arginine decarboxylase signature', NULL, NULL, 'ARGDCRBXLASE', 280163),
(461070, 'PR00204', NULL, 'Beta-amyloid peptide (beta-APP) signature', NULL, NULL, 'BETAAMYLOID', 280164),
(461071, 'PR01496', NULL, 'Shaker voltage-gated K+ channel family signature', NULL, NULL, 'SHAKERCHANEL', 280165),
(461072, 'PR00729', NULL, 'Cattle diarrhoea virus endopeptidase P80 (S31) signature', NULL, NULL, 'CDVENDOPTASE', 280166),
(461073, 'PR01982', NULL, 'Insulin-like growth factor-binding protein 6 signature', NULL, NULL, 'IGFBPFAMILY6', 280167),
(461074, 'PR00776', NULL, 'Hemoglobinase (C13) cysteine protease signature', NULL, NULL, 'HEMOGLOBNASE', 280168);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(461075, 'PR01312', NULL, 'P2X5 purinoceptor signature', NULL, NULL, 'P2X5RECEPTOR', 280169),
(461076, 'PR00406', NULL, 'Cytochrome B5 reductase signature', NULL, NULL, 'CYTB5RDTASE', 280170),
(461077, 'PR00748', NULL, 'Melibiase signature', NULL, NULL, 'MELIBIASE', 280171),
(461078, 'PR00187', NULL, 'Arthropod haemocyanin signature', NULL, NULL, 'HAEMOCYANIN', 280172),
(461079, 'PR01406', NULL, 'B-box zinc finger signature', NULL, NULL, 'BBOXZNFINGER', 280173),
(461080, 'PR01175', NULL, 'Von Ebner''s gland protein signature', NULL, NULL, 'VNEBNERGLAND', 280174),
(461081, 'PR01900', NULL, 'YidC translocation/secretion protein signature', NULL, NULL, 'YIDCPROTEIN', 280175),
(461082, 'PR02009', NULL, 'Viridiplantae FMU-related RCMT signature', NULL, NULL, 'RCMTFMUVIRPL', 280176),
(461083, 'PR02071', NULL, 'Pancreatic progenitor cell differentiation & proliferation factor signature', NULL, NULL, 'PPDPFACTOR', 280177),
(461084, 'PR01934', NULL, 'Interleukin-19 signature', NULL, NULL, 'INTRLEUKIN19', 280178),
(461085, 'PR00129', NULL, 'Cutinase signature', NULL, NULL, 'CUTINASE', 280179),
(461086, 'PR01047', NULL, 'Threonyl-tRNA synthetase signature', NULL, NULL, 'TRNASYNTHTHR', 280180),
(461087, 'PR02068', NULL, 'Vesicular, over-expressed in cancer, pro-survival protein 1 signature', NULL, NULL, 'VOPPROTEIN1', 280181),
(461088, 'PR02045', NULL, 'FAM138 N-terminal domain signature', NULL, NULL, 'F138DOMAIN', 280182),
(461089, 'PR00601', NULL, 'Bacterioferritin signature', NULL, NULL, 'BACFERRITIN', 280183),
(461090, 'PR00080', NULL, 'Short-chain dehydrogenase/reductase (SDR) superfamily signature', NULL, NULL, 'SDRFAMILY', 280184),
(461091, 'PR01006', NULL, 'Flagellar hook-basal body complex protein FliE signature', NULL, NULL, 'FLGHOOKFLIE', 280185),
(461092, 'PR00711', NULL, 'Atrial natriuretic peptide signature', NULL, NULL, 'ANATPEPTIDE', 280186),
(461093, 'PR00747', NULL, 'Glycosyl hydrolase family 47 signature', NULL, NULL, 'GLYHDRLASE47', 280187),
(461094, 'PR01609', NULL, 'Adhesion molecule CD36 family signature', NULL, NULL, 'CD36FAMILY', 280188),
(461095, 'PR00659', NULL, 'Chromogranin signature', NULL, NULL, 'CHROMOGRANIN', 280189),
(461096, 'PR00961', NULL, 'Paraneoplastic encephalomyelitis antigen family signature', NULL, NULL, 'HUDSXLRNA', 280190),
(461097, 'PR00570', NULL, 'Endothelin-A receptor signature', NULL, NULL, 'ENDOTHELINAR', 280191),
(461098, 'PR00929', NULL, 'AT-hook-like domain signature', NULL, NULL, 'ATHOOK', 280192),
(461099, 'PR02041', NULL, 'Protein family FAM153 signature', NULL, NULL, 'PROTEINF153', 280193),
(461100, 'PR00269', NULL, 'Pleiotrophin/midkine family signature', NULL, NULL, 'PTNMIDKINE', 280194),
(461101, 'PR00795', NULL, 'Ryanodine receptor signature', NULL, NULL, 'RYANODINER', 280195),
(461102, 'PR01557', NULL, 'C-C chemokine receptor type 10 signature', NULL, NULL, 'CHEMOKINER10', 280196),
(461103, 'PR00364', NULL, 'Disease resistance protein signature', NULL, NULL, 'DISEASERSIST', 280197),
(461104, 'PR00461', NULL, 'Plant peroxidase signature', NULL, NULL, 'PLPEROXIDASE', 280198),
(461105, 'PR01706', NULL, 'Antistasin signature', NULL, NULL, 'ANTISTASIN', 280199),
(461106, 'PR00447', NULL, 'Natural resistance-associated macrophage protein signature', NULL, NULL, 'NATRESASSCMP', 280200),
(461107, 'PR01528', NULL, 'EDG-4 lysophosphatidic acid receptor signature', NULL, NULL, 'EDG4RECEPTOR', 280201),
(461108, 'PR01611', NULL, 'Lysosome membrane protein II (LIMP II) signature', NULL, NULL, 'LIMPII', 280202),
(461109, 'PR00350', NULL, 'Vitamin D receptor signature', NULL, NULL, 'VITAMINDR', 280203),
(461110, 'PR01917', NULL, 'Venom nerve growth factor signature', NULL, NULL, 'VENOMNGF', 280204),
(461111, 'PR01935', NULL, 'Interleukin-20 signature', NULL, NULL, 'INTRLEUKIN20', 280205),
(461112, 'PR00914', NULL, 'Luteovirus (ORF3) RNA-directed RNA-polymerase signature', NULL, NULL, 'LVIRUSRNAPOL', 280206),
(461113, 'PR00528', NULL, 'Glucocorticoid receptor (3C nuclear receptor) signature', NULL, NULL, 'GLCORTICOIDR', 280207),
(461114, 'PR00566', NULL, 'Dopamine 1B receptor signature', NULL, NULL, 'DOPAMINED1BR', 280208);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(461115, 'PR01274', NULL, 'Metalloprotease inhibitor signature', NULL, NULL, 'MPTASEINHBTR', 280209),
(461116, 'PR00704', NULL, 'Calpain cysteine protease (C2) family signature', NULL, NULL, 'CALPAIN', 280210),
(461117, 'PR00684', NULL, 'Phage T4 lysozyme signature', NULL, NULL, 'T4LYSOZYME', 280211),
(461118, 'PR01077', NULL, 'Claudin family signature', NULL, NULL, 'CLAUDIN', 280212),
(461119, 'PR02084', NULL, 'Golgi membrane protein 1/Cancer susceptibility candidate gene 4 signature', NULL, NULL, 'GOLM1CASC4', 280213),
(461120, 'PR01818', NULL, 'Desmosomal cadherin signature', NULL, NULL, 'DESMOCADHERN', 280214),
(461121, 'PR00200', NULL, 'Annexin type IV signature', NULL, NULL, 'ANNEXINIV', 280215),
(461122, 'PR01727', NULL, 'Prokaryotic integration host factor signature', NULL, NULL, 'DNABINDINGHU', 280216),
(461123, 'PR01349', NULL, 'Wnt protein signature', NULL, NULL, 'WNTPROTEIN', 280217),
(461124, 'PR00824', NULL, 'Hepatic lipase signature', NULL, NULL, 'HEPLIPASE', 280218),
(461125, 'PR02023', NULL, 'Invertebrate aquaporin-10 signature', NULL, NULL, 'AQUAPORIN10I', 280219),
(461126, 'PR00811', NULL, 'Bacterial general secretion pathway protein D signature', NULL, NULL, 'BCTERIALGSPD', 280220),
(461127, 'PR01438', NULL, 'Universal stress protein signature', NULL, NULL, 'UNVRSLSTRESS', 280221),
(461128, 'PR00828', NULL, 'Formin signature', NULL, NULL, 'FORMIN', 280222),
(461129, 'PR00862', NULL, 'Prolyl oligopeptidase serine protease (S9A) signature', NULL, NULL, 'PROLIGOPTASE', 280223),
(461130, 'PR02081', NULL, 'Protein GIGANTEA signature', NULL, NULL, 'GIGANTEA', 280224),
(461131, 'PR00188', NULL, 'Plant globin signature', NULL, NULL, 'PLANTGLOBIN', 280225),
(461132, 'PR01142', NULL, 'Gap junction beta-5 protein (Cx30.3) signature', NULL, NULL, 'CONNEXINB5', 280226),
(461133, 'PR02011', NULL, 'RNA (C5-cytosine) methyltransferase NCL1 subfamily signature', NULL, NULL, 'RCMTNCL1', 280227),
(461134, 'PR00241', NULL, 'Angiotensin II receptor signature', NULL, NULL, 'ANGIOTENSINR', 280228),
(461135, 'PR01820', NULL, 'Desmocollin signature', NULL, NULL, 'DESMOCOLLIN', 280229),
(461136, 'PR01451', NULL, 'Calcium-activated SK potassium channel signature', NULL, NULL, 'SKCHANNEL', 280230),
(461137, 'PR00620', NULL, 'Histone H2A signature', NULL, NULL, 'HISTONEH2A', 280231),
(461138, 'PR00305', NULL, '14-3-3 protein zeta signature', NULL, NULL, '1433ZETA', 280232),
(461139, 'PR00947', NULL, 'Insect cuticle protein signature', NULL, NULL, 'CUTICLE', 280233),
(461140, 'PR01931', NULL, 'Interleukin-16 signature', NULL, NULL, 'INTRLEUKIN16', 280234),
(461141, 'PR01356', NULL, 'Anti-sense to fibroblast growth factor protein GFG signature', NULL, NULL, 'GFGPROTEIN', 280235),
(461142, 'PR01588', NULL, 'THIK K+ channel signature', NULL, NULL, 'THIKCHANNEL', 280236),
(461143, 'PR01519', NULL, 'Epsilon-tubulin signature', NULL, NULL, 'EPSLNTUBULIN', 280237),
(461144, 'PR01979', NULL, 'Insulin-like growth factor-binding protein 3 signature', NULL, NULL, 'IGFBPFAMILY3', 280238),
(461145, 'PR00726', NULL, 'Repressor LexA serine protease (S24) family signature', NULL, NULL, 'LEXASERPTASE', 280239),
(461146, 'PR00290', NULL, 'Kazal-type serine protease inhibitor signature', NULL, NULL, 'KAZALINHBTR', 280240),
(461147, 'PR01668', NULL, 'Neurotensin/neuromedin N precursor signature', NULL, NULL, 'NEUROTENSIN', 280241),
(461148, 'PR01685', NULL, 'CYP2B P450 family signature', NULL, NULL, 'EP450ICYP2B', 280242),
(461149, 'PR01174', NULL, 'Retinol binding protein signature', NULL, NULL, 'RETINOLBNDNG', 280243),
(461150, 'PR01638', NULL, 'MHC class I signature', NULL, NULL, 'MHCCLASSI', 280244),
(461151, 'PR01768', NULL, 'Vanilloid receptor (TRPV) family signature', NULL, NULL, 'TRPVRECEPTOR', 280245),
(461152, 'PR00581', NULL, 'Prostanoid EP2 receptor signature', NULL, NULL, 'PRSTNOIDEP2R', 280246),
(461153, 'PR00154', NULL, 'AMP-binding signature', NULL, NULL, 'AMPBINDING', 280247),
(461154, 'PR01702', NULL, 'CD40 ligand/CD154 antigen signature', NULL, NULL, 'CD40LIGAND', 280248),
(461155, 'PR00061', NULL, 'Ribosomal protein L19 signature', NULL, NULL, 'RIBOSOMALL19', 280249);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(461156, 'PR00050', NULL, 'Cold shock protein signature', NULL, NULL, 'COLDSHOCK', 280250),
(461157, 'PR00840', NULL, 'MG067/MG068/MG395 hypothetical protein family signature', NULL, NULL, 'Y06768FAMILY', 280251),
(461158, 'PR00633', NULL, 'Chromosome condensation regulator RCC1 signature', NULL, NULL, 'RCCNDNSATION', 280252),
(461159, 'PR00592', NULL, 'Extracellular calcium-sensing receptor signature', NULL, NULL, 'CASENSINGR', 280253),
(461160, 'PR01509', NULL, 'Kv1.2 voltage-gated K+ channel signature', NULL, NULL, 'KV12CHANNEL', 280254),
(461161, 'PR01117', NULL, 'CLC-6 chloride channel signature', NULL, NULL, 'CLCHANNEL6', 280255),
(461162, 'PR00313', NULL, 'NodO calcium binding signature', NULL, NULL, 'CABNDNGRPT', 280256),
(461163, 'PR01474', NULL, 'Vascular cell adhesion molecule-1 (VCAM-1) signature', NULL, NULL, 'VCAM1', 280257),
(461164, 'PR00975', NULL, 'Ribosomal protein S19 family signature', NULL, NULL, 'RIBOSOMALS19', 280258),
(461165, 'PR01128', NULL, 'EMR1 hormone receptor signature', NULL, NULL, 'EMR1HORMONER', 280259),
(461166, 'PR01538', NULL, 'Interleukin-1 receptor type I precursor signature', NULL, NULL, 'INTRLEUKN1R1', 280260),
(461167, 'PR00697', NULL, 'C.elegans Sra family integral membrane protein signature', NULL, NULL, 'TMPROTEINSRA', 280261),
(461168, 'PR01416', NULL, 'APJ receptor signature', NULL, NULL, 'APJRECEPTOR', 280262),
(461169, 'PR01581', NULL, 'Kv3.1 voltage-gated K+ channel signature', NULL, NULL, 'KV31CHANNEL', 280263),
(461170, 'PR01704', NULL, 'Fungal allergen ribonucleotoxin signature', NULL, NULL, 'FUNRIBOTOXIN', 280264),
(461171, 'PR00279', NULL, 'Bacterial toxin signature', NULL, NULL, 'BACTRLTOXIN', 280265),
(461172, 'PR00923', NULL, 'Lactococcus X-Pro dipeptidyl-peptidase (S15) family signature', NULL, NULL, 'LACTOPTASE', 280266),
(461173, 'PR01901', NULL, 'Wnt inhibitory factor (WIF)-1 protein signature', NULL, NULL, 'WIFPROTEIN', 280267),
(461174, 'PR00463', NULL, 'E-class P450 group I signature', NULL, NULL, 'EP450I', 280268),
(461175, 'PR01513', NULL, 'Kv1.6 voltage-gated K+ channel signature', NULL, NULL, 'KV16CHANNEL', 280269),
(461176, 'PR00192', NULL, 'F-actin capping protein beta subunit signature', NULL, NULL, 'FACTINCAPB', 280270),
(461177, 'PR00410', NULL, 'Phenol hydroxylase reductase family signature', NULL, NULL, 'PHEHYDRXLASE', 280271),
(461178, 'PR00013', NULL, 'Fibronectin type II repeat signature', NULL, NULL, 'FNTYPEII', 280272),
(461179, 'PR00202', NULL, 'Annexin type VI signature', NULL, NULL, 'ANNEXINVI', 280273),
(461180, 'PR00675', NULL, 'Marek''s disease glycoprotein A signature', NULL, NULL, 'MAREKSGPA', 280274),
(461181, 'PR01828', NULL, 'Neurokinin B precursor signature', NULL, NULL, 'NEUROKININB', 280275),
(461182, 'PR00035', NULL, 'GntR bacterial regulatory protein HTH signature', NULL, NULL, 'HTHGNTR', 280276),
(461183, 'PR01622', NULL, 'Gamma-aminobutyric-acid A receptor gamma 2 subunit signature', NULL, NULL, 'GABAARGAMMA2', 280277),
(461184, 'PR00411', NULL, 'Pyridine nucleotide disulphide reductase class-I signature', NULL, NULL, 'PNDRDTASEI', 280278),
(461185, 'PR02022', NULL, 'Mammalian aquaporin-10 signature', NULL, NULL, 'AQUAPORIN10M', 280279),
(461186, 'PR00189', NULL, 'Transthyretin signature', NULL, NULL, 'TRNSTHYRETIN', 280280),
(461187, 'PR01165', NULL, 'Cytochrome c oxidase subunit I signature', NULL, NULL, 'CYCOXIDASEI', 280281),
(461188, 'PR01251', NULL, 'Amphiphysin signature', NULL, NULL, 'AMPHIPHYSIN', 280282),
(461189, 'PR01481', NULL, 'Neurotensin type 2 receptor signature', NULL, NULL, 'NEUROTENSN2R', 280283),
(461190, 'PR01526', NULL, 'EDG-6 sphingosine 1-phosphate receptor signature', NULL, NULL, 'EDG6RECEPTOR', 280284),
(461191, 'PR00429', NULL, 'Thromboxane receptor signature', NULL, NULL, 'THROMBOXANER', 280285),
(461192, 'PR01370', NULL, 'Translocated intimin receptor (Tir) signature', NULL, NULL, 'TRNSINTIMINR', 280286),
(461193, 'PR00277', NULL, 'Insulin signature', NULL, NULL, 'INSULIN', 280287),
(461194, 'PR01980', NULL, 'Insulin-like growth factor-binding protein 4 signature', NULL, NULL, 'IGFBPFAMILY4', 280288);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(461195, 'PR01916', NULL, 'Neurotrophin-6 signature', NULL, NULL, 'NEUROTROPHN6', 280289),
(461196, 'PR00660', NULL, 'ER lumen protein retaining receptor signature', NULL, NULL, 'ERLUMENR', 280290),
(461197, 'PR01729', NULL, 'Lactobacillus surface layer protein signature', NULL, NULL, 'SURFACELAYER', 280291),
(461198, 'PR00465', NULL, 'E-class P450 group IV signature', NULL, NULL, 'EP450IV', 280292),
(461199, 'PR00936', NULL, 'Lambda phage regulatory protein CIII signature', NULL, NULL, 'BPLRPCIII', 280293),
(461200, 'PR01717', NULL, 'CD28 antigen signature', NULL, NULL, 'CD28ANTIGEN', 280294),
(461201, 'PR00584', NULL, 'Prostanoid EP3 receptor type 2 signature', NULL, NULL, 'PRSTNOIDE32R', 280295),
(461202, 'PR01109', NULL, 'C-C chemokine receptor type 4 signature', NULL, NULL, 'CHEMOKINER4', 280296),
(461203, 'PR01842', NULL, 'Wnt-2 protein signature', NULL, NULL, 'WNT2PROTEIN', 280297),
(461204, 'PR01920', NULL, 'Tumour necrosis factor receptor 3 signature', NULL, NULL, 'TNFACTORR3', 280298),
(461205, 'PR01748', NULL, 'Transcription factor AP-2 signature', NULL, NULL, 'AP2TNSCPFCT', 280299),
(461206, 'PR01993', NULL, 'GP162 7TM protein signature', NULL, NULL, 'GPR162', 280300),
(461207, 'PR01544', NULL, 'Arabidopsis thaliana 130.7kDa hypothetical protein signature', NULL, NULL, 'ARATH130DUF', 280301),
(461208, 'PR01465', NULL, 'ELK potassium channel family signature', NULL, NULL, 'ELKCHANNEL', 280302),
(461209, 'PR01732', NULL, 'Neisseria meningitidis adhesin MafB signature', NULL, NULL, 'ADHESINMAFB', 280303),
(461210, 'PR01898', NULL, 'Bacterial superantigen superfamily signature', NULL, NULL, 'SAGSUPRFAMLY', 280304),
(461211, 'PR00653', NULL, 'Activin type II receptor signature', NULL, NULL, 'ACTIVIN2R', 280305),
(461212, 'PR00723', NULL, 'Subtilisin serine protease family (S8) signature', NULL, NULL, 'SUBTILISIN', 280306),
(461213, 'PR00094', NULL, 'Adenylate kinase signature', NULL, NULL, 'ADENYLTKNASE', 280307),
(461214, 'PR01253', NULL, 'Amphiphysin isoform 2 signature', NULL, NULL, 'AMPHIPHYSIN2', 280308),
(461215, 'PR01637', NULL, 'Pollen allergen Lol p2 signature', NULL, NULL, 'LOLP2ALLERGN', 280309),
(461216, 'PR00321', NULL, 'Gamma G protein (transducin) signature', NULL, NULL, 'GPROTEING', 280310),
(461217, 'PR01074', NULL, 'Presenilin 2 signature', NULL, NULL, 'PRESENILIN2', 280311),
(461218, 'PR01366', NULL, 'Major royal jelly protein family signature', NULL, NULL, 'ROYALJELLY', 280312),
(461219, 'PR01024', NULL, 'Neurokinin NK1 receptor signature', NULL, NULL, 'NEUROKININ1R', 280313),
(461220, 'PR01447', NULL, 'Claudin-16 signature', NULL, NULL, 'CLAUDIN16', 280314),
(461221, 'PR01909', NULL, 'Atypical dual specificity phosphatase subfamily A signature', NULL, NULL, 'ADSPHPHTASEA', 280315),
(461222, 'PR00820', NULL, 'CbxX/CfqX protein signature', NULL, NULL, 'CBXXCFQX', 280316),
(461223, 'PR01533', NULL, 'Cysteinyl leukotriene receptor family signature', NULL, NULL, 'CYSLTRECPTR', 280317),
(461224, 'PR00043', NULL, 'Jun transcription factor signature', NULL, NULL, 'LEUZIPPRJUN', 280318),
(461225, 'PR01977', NULL, 'Insulin-like growth factor-binding protein 1 signature', NULL, NULL, 'IGFBPFAMILY1', 280319),
(461226, 'PR00630', NULL, 'Monellin A chain signature', NULL, NULL, 'MONELLINA', 280320),
(461227, 'PR00083', NULL, 'Histidinol dehydrogenase signature', NULL, NULL, 'HOLDHDRGNASE', 280321),
(461228, 'PR00993', NULL, 'B1 bradykinin receptor signature', NULL, NULL, 'BRADYKINNB1R', 280322),
(461229, 'PR01308', NULL, 'P2X1 purinoceptor signature', NULL, NULL, 'P2X1RECEPTOR', 280323),
(461230, 'PR00655', NULL, 'Auxin binding protein signature', NULL, NULL, 'AUXINBINDNGP', 280324),
(461231, 'PR00384', NULL, 'Opioid receptor signature', NULL, NULL, 'OPIOIDR', 280325),
(461232, 'PR01632', NULL, 'P/Q-type voltage-dependent calcium channel alpha-1 subunit signature', NULL, NULL, 'PQVDCCALPHA1', 280326),
(461233, 'PR01371', NULL, 'Salmonella/Yersinia modular tyrosine phosphatase signature', NULL, NULL, 'BACYPHPHTASE', 280327),
(461234, 'PR00730', NULL, 'Thermolysin metalloprotease (M4) family signature', NULL, NULL, 'THERMOLYSIN', 280328);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(461235, 'PR01233', NULL, 'Josephin signature', NULL, NULL, 'JOSEPHIN', 280329),
(461236, 'PR02061', NULL, 'Wolframin signature', NULL, NULL, 'WOLFRAMIN', 280330),
(461237, 'PR00331', NULL, 'Haemagglutinin HA2 chain signature', NULL, NULL, 'HEMAGGLUTN2', 280331),
(461238, 'PR00995', NULL, '36kDa capillovirus serine protease (S35) signature', NULL, NULL, 'CAPILLOPTASE', 280332),
(461239, 'PR01027', NULL, 'OMS28 porin signature', NULL, NULL, 'OMS28PORIN', 280333),
(461240, 'PR00376', NULL, 'Interleukin-1B converting enzyme signature', NULL, NULL, 'IL1BCENZYME', 280334),
(461241, 'PR01048', NULL, 'Hypothetical protein Y414 family signature', NULL, NULL, 'Y414FAMILY', 280335),
(461242, 'PR01746', NULL, 'Dense granule Gra6 protein signature', NULL, NULL, 'DENSEGRNULE6', 280336),
(461243, 'PR00532', NULL, 'Kappa opioid receptor signature', NULL, NULL, 'KAPPAOPIOIDR', 280337),
(461244, 'PR00900', NULL, 'Pheromone A receptor signature', NULL, NULL, 'PHEROMONEAR', 280338),
(461245, 'PR01463', NULL, 'EAG/ELK/ERG potassium channel family signature', NULL, NULL, 'EAGCHANLFMLY', 280339),
(461246, 'PR01224', NULL, 'Delta-tubulin signature', NULL, NULL, 'DELTATUBULIN', 280340),
(461247, 'PR00296', NULL, 'Cyclin-dependent kinase regulatory subunit signature', NULL, NULL, 'CYCLINKINASE', 280341),
(461248, 'PR00836', NULL, 'Somatotropin hormone family signature', NULL, NULL, 'SOMATOTROPIN', 280342),
(461249, 'PR01211', NULL, 'Synuclein signature', NULL, NULL, 'SYNUCLEIN', 280343),
(461250, 'PR01146', NULL, 'GPR1 orphan receptor signature', NULL, NULL, 'GPR1ORPHANR', 280344),
(461251, 'PR00679', NULL, 'Prohibitin signature', NULL, NULL, 'PROHIBITIN', 280345),
(461252, 'PR00329', NULL, 'Haemagglutinin HA1/HA2 chain signature', NULL, NULL, 'HEMAGGLUTN12', 280346),
(461253, 'PR00215', NULL, 'Neuromodulin signature', NULL, NULL, 'NEUROMODULIN', 280347),
(461254, 'PR00245', NULL, 'Olfactory receptor signature', NULL, NULL, 'OLFACTORYR', 280348),
(461255, 'PR00469', NULL, 'Pyridine nucleotide disulphide reductase class-II signature', NULL, NULL, 'PNDRDTASEII', 280349),
(461256, 'PR01323', NULL, 'Kir1.3 inward rectifer K+ channel signature', NULL, NULL, 'KIR13CHANNEL', 280350),
(461257, 'PR01695', NULL, 'Ig-hepta receptor signature', NULL, NULL, 'IGHEPTARCPTR', 280351),
(461258, 'PR01539', NULL, 'Interleukin-1 receptor type II precursor signature', NULL, NULL, 'INTRLEUKN1R2', 280352),
(461259, 'PR01337', NULL, 'Type III secretion system outer membrane G protein family signature', NULL, NULL, 'TYPE3OMGPROT', 280353),
(461260, 'PR01005', NULL, 'Flagellar hook-associated protein signature', NULL, NULL, 'FLGHOOKAP1', 280354),
(461261, 'PR01521', NULL, 'Orexin receptor type 1 signature', NULL, NULL, 'OREXIN1R', 280355),
(461262, 'PR00062', NULL, 'Ribosomal protein L20 signature', NULL, NULL, 'RIBOSOMALL20', 280356),
(461263, 'PR00139', NULL, 'Asparaginase/glutaminase family signature', NULL, NULL, 'ASNGLNASE', 280357),
(461264, 'PR01364', NULL, 'Viral protein D10 signature', NULL, NULL, 'VD10PROTEIN', 280358),
(461265, 'PR01895', NULL, 'Wnt-16 protein signature', NULL, NULL, 'WNT16PROTEIN', 280359),
(461266, 'PR00925', NULL, 'Nonhistone chromosomal protein HMG17 family signature', NULL, NULL, 'NONHISHMG17', 280360),
(461267, 'PR00335', NULL, 'TrkA potassium uptake protein signature', NULL, NULL, 'KUPTAKETRKA', 280361),
(461268, 'PR00273', NULL, 'Galanin signature', NULL, NULL, 'GALANIN', 280362),
(461269, 'PR01236', NULL, 'Tumour necrosis factor beta (lymphotoxin-alpha) signature', NULL, NULL, 'TNFBETA', 280363),
(461270, 'PR01807', NULL, 'Angiomotin family signature', NULL, NULL, 'ANGIOMOTIN', 280364),
(461271, 'PR00835', NULL, 'Regulatory protein Rop signature', NULL, NULL, 'ROPREGULATRY', 280365),
(461272, 'PR01486', NULL, 'Bacterial phospholipase A1 protein signature', NULL, NULL, 'PHPHLIPASEA1', 280366),
(461273, 'PR01461', NULL, 'KCNQ2 voltage-gated potassium channel signature', NULL, NULL, 'KCNQ2CHANNEL', 280367),
(461274, 'PR00091', NULL, 'Nitrogenase component II signature', NULL, NULL, 'NITROGNASEII', 280368);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(461275, 'PR01045', NULL, 'Glycyl-tRNA synthetase beta subunit signature', NULL, NULL, 'TRNASYNTHGB', 280369),
(461276, 'PR01033', NULL, 'Phytochrome signature', NULL, NULL, 'PHYTOCHROME', 280370),
(461277, 'PR01534', NULL, 'Vomeronasal type 1 receptor family signature', NULL, NULL, 'VOMERONASL1R', 280371),
(461278, 'PR00539', NULL, 'Muscarinic M2 receptor signature', NULL, NULL, 'MUSCRINICM2R', 280372),
(461279, 'PR01518', NULL, 'Kv4.3 voltage-gated K+ channel signature', NULL, NULL, 'KV43CHANNEL', 280373),
(461280, 'PR00686', NULL, 'Transcription initiation factor TFIID signature', NULL, NULL, 'TIFACTORIID', 280374),
(461281, 'PR01402', NULL, 'Mutator MutX protein signature', NULL, NULL, 'MUTATORMUTX', 280375),
(461282, 'PR01166', NULL, 'Cytochrome c oxidase subunit II signature', NULL, NULL, 'CYCOXIDASEII', 280376),
(461283, 'PR01821', NULL, 'DAPIT signature', NULL, NULL, 'DAPIT', 280377),
(461284, 'PR00105', NULL, 'Cytosine-specific DNA methyltransferase signature', NULL, NULL, 'C5METTRFRASE', 280378),
(461285, 'PR01151', NULL, 'Melatonin-related 1X receptor signature', NULL, NULL, 'MELATONIN1XR', 280379),
(461286, 'PR00863', NULL, 'Nodavirus coat precursor endopeptidase (A6) aspartic protease signature', NULL, NULL, 'NODAVIRPTASE', 280380),
(461287, 'PR01197', NULL, 'GAT-3 GABA neurotransmitter transporter signature', NULL, NULL, 'GAT3TRNSPORT', 280381),
(461288, 'PR01161', NULL, 'Tubulin signature', NULL, NULL, 'TUBULIN', 280382),
(461289, 'PR01554', NULL, 'Escherichia coli P pili regulatory PapB protein signature', NULL, NULL, 'FIMREGULATRY', 280383),
(461290, 'PR00165', NULL, 'Anion exchanger family signature', NULL, NULL, 'ANIONEXCHNGR', 280384),
(461291, 'PR01080', NULL, 'Hypoxia-inducible factor-1 alpha signature', NULL, NULL, 'HYPOXIAIF1A', 280385),
(461292, 'PR02001', NULL, 'GCR1-cAMP receptor family signature', NULL, NULL, 'GCR1CAMPR', 280386),
(461293, 'PR00278', NULL, 'Pancreatic hormone signature', NULL, NULL, 'PANCHORMONE', 280387),
(461294, 'PR01252', NULL, 'Amphiphysin isoform 1 signature', NULL, NULL, 'AMPHIPHYSIN1', 280388),
(461295, 'PR00495', NULL, 'Obesity factor (leptin) signature', NULL, NULL, 'LEPTIN', 280389),
(461296, 'PR00151', NULL, 'Porphobilinogen deaminase signature', NULL, NULL, 'PORPHBDMNASE', 280390),
(461297, 'PR01664', NULL, 'Voltage-gated Na+ channel alpha 1 subunit signature', NULL, NULL, 'NACHANNEL1', 280391),
(461298, 'PR00089', NULL, 'Bacterial luciferase signature', NULL, NULL, 'LUCIFERASE', 280392),
(461299, 'PR00390', NULL, 'Phospholipase C signature', NULL, NULL, 'PHPHLIPASEC', 280393),
(461300, 'PR01888', NULL, 'Neuropeptide B/W family signature', NULL, NULL, 'NROPEPTIDEBW', 280394),
(461301, 'PR01889', NULL, 'Neuropeptide B precursor signature', NULL, NULL, 'PPNRPEPTIDEB', 280395),
(461302, 'PR01203', NULL, 'Serotonin (5-HT) neurotransmitter transporter signature', NULL, NULL, '5HTTRANSPORT', 280396),
(461303, 'PR01890', NULL, 'Neuropeptide W precursor signature', NULL, NULL, 'PPNRPEPTIDEW', 280397),
(461304, 'PR01494', NULL, 'Kv9 potassium channel alpha subunit signature', NULL, NULL, 'KV9CHANNEL', 280398),
(461305, 'PR01499', NULL, 'Trek K+ channel signature', NULL, NULL, 'TREKCHANNEL', 280399),
(461306, 'PR00179', NULL, 'Lipocalin signature', NULL, NULL, 'LIPOCALIN', 280400),
(461307, 'PR00114', NULL, 'Serine/threonine phosphatase family signature', NULL, NULL, 'STPHPHTASE', 280401),
(461308, 'PR00500', NULL, 'Polycystic kidney disease type 1 protein (PKD1) signature', NULL, NULL, 'POLYCYSTIN1', 280402),
(461309, 'PR01245', NULL, 'Repair protein Rad1/Rec1 family signature', NULL, NULL, 'RAD1REC1', 280403),
(461310, 'PR00932', NULL, 'Aminopeptidase I zinc metalloprotease (M18) signature', NULL, NULL, 'AMINO1PTASE', 280404),
(461311, 'PR00128', NULL, 'Colipase signature', NULL, NULL, 'COLIPASE', 280405),
(461312, 'PR01978', NULL, 'Insulin-like growth factor-binding protein 2 signature', NULL, NULL, 'IGFBPFAMILY2', 280406),
(461313, 'PR01808', NULL, 'Annexin type VIII signature', NULL, NULL, 'ANNEXINVIII', 280407),
(461314, 'PR01073', NULL, 'Presenilin 1 signature', NULL, NULL, 'PRESENILIN1', 280408);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(461315, 'PR01154', NULL, 'Vasoactive intestinal peptide receptor 1 signature', NULL, NULL, 'VIP1RECEPTOR', 280409),
(461316, 'PR01226', NULL, 'Expansin signature', NULL, NULL, 'EXPANSIN', 280410),
(461317, 'PR01088', NULL, 'Na+/H+ exchanger isoform 6 (NHE6) signature', NULL, NULL, 'NAHEXCHNGR6', 280411),
(461318, 'PR00739', NULL, 'Glycosyl hydrolase family 26 signature', NULL, NULL, 'GLHYDRLASE26', 280412),
(461319, 'PR01015', NULL, 'Neuropeptide Y4 receptor signature', NULL, NULL, 'NRPEPTIDEY4R', 280413),
(461320, 'PR01135', NULL, 'Gap junction alpha-5 protein (Cx40) signature', NULL, NULL, 'CONNEXINA5', 280414),
(461321, 'PR00413', NULL, 'Haloacid dehalogenase/epoxide hydrolase family signature', NULL, NULL, 'HADHALOGNASE', 280415),
(461322, 'PR00097', NULL, 'Anthranilate synthase component II signature', NULL, NULL, 'ANTSNTHASEII', 280416),
(461323, 'PR00130', NULL, 'DNase I signature', NULL, NULL, 'DNASEI', 280417),
(461324, 'PR01682', NULL, 'FMRFamide-related peptide precursor signature', NULL, NULL, 'FMRFAMIDEPEP', 280418),
(461325, 'PR01327', NULL, 'Kir3.1 inward rectifier K+ channel signature', NULL, NULL, 'KIR31CHANNEL', 280419),
(461326, 'PR00913', NULL, 'Luteovirus ORF2 putative replicase 1 signature', NULL, NULL, 'LVIRUSORF2', 280420),
(461327, 'PR02054', NULL, 'Plant protein family FAM175 signature', NULL, NULL, 'FAM175PLANT', 280421),
(461328, 'PR00221', NULL, 'Caulimovirus coat protein signature', NULL, NULL, 'CAULIMOCOAT', 280422),
(461329, 'PR01566', NULL, 'Neuromedin U type 1 receptor signature', NULL, NULL, 'NEUROMEDNU1R', 280423),
(461330, 'PR01134', NULL, 'Gap junction alpha-4 protein (Connexin37) signature', NULL, NULL, 'CONNEXINA4', 280424),
(461331, 'PR01338', NULL, 'Type III secretion system outer membrane K protein family signature', NULL, NULL, 'TYPE3OMKPROT', 280425),
(461332, 'PR00882', NULL, 'Ribosomal protein L7A family signature', NULL, NULL, 'RIBOSOMALL7A', 280426),
(461333, 'PR01879', NULL, 'Nervy protein signature', NULL, NULL, 'NERVYPROTEIN', 280427),
(461334, 'PR00802', NULL, 'Serum albumin family signature', NULL, NULL, 'SERUMALBUMIN', 280428),
(461335, 'PR02056', NULL, 'Protein family FAM105A signature', NULL, NULL, 'PROTEINF105A', 280429),
(461336, 'PR00870', NULL, 'DNA-polymerase family X pol beta-like signature', NULL, NULL, 'DNAPOLXBETA', 280430),
(461337, 'PR00981', NULL, 'Seryl-tRNA synthetase signature', NULL, NULL, 'TRNASYNTHSER', 280431),
(461338, 'PR01262', NULL, 'Innexin signature', NULL, NULL, 'INNEXIN', 280432),
(461339, 'PR00777', NULL, 'Hirudin signature', NULL, NULL, 'HIRUDIN', 280433),
(461340, 'PR01633', NULL, 'R-type voltage-dependent calcium channel alpha-1 subunit signature', NULL, NULL, 'RVDCCALPHA1', 280434),
(461341, 'PR01684', NULL, 'CYP2A P450 family signature', NULL, NULL, 'EP450ICYP2A', 280435),
(461342, 'PR01375', NULL, 'Salmonella/Shigella invasin protein B signature', NULL, NULL, 'BACINVASINB', 280436),
(461343, 'PR01339', NULL, 'Type III secretion system outer membrane O protein family signature', NULL, NULL, 'TYPE3OMOPROT', 280437),
(461344, 'PR00715', NULL, 'Cation-dependent mannose-6-phosphate receptor signature', NULL, NULL, 'MAN6PRECEPTR', 280438),
(461345, 'PR00427', NULL, 'Interleukin-8 receptor signature', NULL, NULL, 'INTRLEUKIN8R', 280439),
(461346, 'PR00311', NULL, 'Bleomycin resistance protein signature', NULL, NULL, 'BLEOMYCINRST', 280440),
(461347, 'PR00312', NULL, 'Calsequestrin signature', NULL, NULL, 'CALSEQUESTRN', 280441),
(461348, 'PR00023', NULL, 'Zona pellucida sperm-binding protein signature', NULL, NULL, 'ZPELLUCIDA', 280442),
(461349, 'PR00576', NULL, 'Opsin RH1/RH2 signature', NULL, NULL, 'OPSINRH1RH2', 280443),
(461350, 'PR01365', NULL, 'Telomere reverse transcriptase signature', NULL, NULL, 'TELOMERASERT', 280444),
(461351, 'PR01007', NULL, 'Flagellar hook-length control protein signature', NULL, NULL, 'FLGHOOKFLIK', 280445),
(461352, 'PR00108', NULL, 'Thymidylate synthase family signature', NULL, NULL, 'THYMDSNTHASE', 280446),
(461353, 'PR01273', NULL, 'Invertebrate colouration protein signature', NULL, NULL, 'INVTBRTCOLOR', 280447);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(461354, 'PR01107', NULL, 'C-C chemokine receptor type 2 signature', NULL, NULL, 'CHEMOKINER2', 280448),
(461355, 'PR01700', NULL, 'CD34 antigen signature', NULL, NULL, 'CD34ANTIGEN', 280449),
(461356, 'PR01177', NULL, 'Metabotropic gamma-aminobutyric acid type B1 receptor signature', NULL, NULL, 'GABAB1RECPTR', 280450),
(461357, 'PR01282', NULL, 'COUP transcription factor (2F nuclear receptor) family signature', NULL, NULL, 'COUPTNFACTOR', 280451),
(461358, 'PR00610', NULL, 'Cytochrome F signature', NULL, NULL, 'CYTOCHROMEF', 280452),
(461359, 'PR00656', NULL, 'Bacteriochlorophyll C binding protein signature', NULL, NULL, 'BCHLROPHYLLC', 280453),
(461360, 'PR00208', NULL, 'Gliadin and LMW glutenin superfamily signature', NULL, NULL, 'GLIADGLUTEN', 280454),
(461361, 'PR02036', NULL, 'Chemotaxis inhibitory protein signature', NULL, NULL, 'CHEMOTAXISIP', 280455),
(461362, 'PR01457', NULL, 'Lens fibre membrane intrinsic protein (LMIP) signature', NULL, NULL, 'LENSMEMPROT', 280456),
(461363, 'PR02066', NULL, 'Daughter-specific expression protein 2 signature', NULL, NULL, 'DSEPROTEIN2', 280457),
(461364, 'PR01708', NULL, '5-hydroxytryptamine 3 receptor signature', NULL, NULL, '5HT3RECEPTOR', 280458),
(461365, 'PR00631', NULL, 'Monellin B chain signature', NULL, NULL, 'MONELLINB', 280459),
(461366, 'PR01037', NULL, 'Tetracycline resistance protein TetO/TetQ/TetM family signature', NULL, NULL, 'TCRTETOQM', 280460),
(461367, 'PR00457', NULL, 'Animal haem peroxidase signature', NULL, NULL, 'ANPEROXIDASE', 280461),
(461368, 'PR00452', NULL, 'SH3 domain signature', NULL, NULL, 'SH3DOMAIN', 280462),
(461369, 'PR01878', NULL, 'Myeloid transforming gene on chromosome 16 (MTG16) protein signature', NULL, NULL, 'MTG16PROTEIN', 280463),
(461370, 'PR01121', NULL, 'Flavin-containing monooxygenase (FMO) 1 signature', NULL, NULL, 'FMOXYGENASE1', 280464),
(461371, 'PR00430', NULL, 'Interleukin-3 signature', NULL, NULL, 'INTERLEUKIN3', 280465),
(461372, 'PR00301', NULL, '70kDa heat shock protein signature', NULL, NULL, 'HEATSHOCK70', 280466),
(461373, 'PR00703', NULL, 'Adenovirus endopeptidase (C5) family signature', NULL, NULL, 'ADVENDOPTASE', 280467),
(461374, 'PR01947', NULL, 'Mammalian interleukin-15 signature', NULL, NULL, 'INTLKN15MAML', 280468),
(461375, 'PR00438', NULL, 'Growth factor cystine knot domain signature', NULL, NULL, 'GFCYSKNOT', 280469),
(461376, 'PR01933', NULL, 'Interleukin-18 signature', NULL, NULL, 'INTRLEUKIN18', 280470),
(461377, 'PR01471', NULL, 'Histamine H3 receptor signature', NULL, NULL, 'HISTAMINEH3R', 280471),
(461378, 'PR00865', NULL, 'Papillomavirus major capsid protein L1 signature', NULL, NULL, 'HPVCAPSIDL1', 280472),
(461379, 'PR00540', NULL, 'Muscarinic M3 receptor signature', NULL, NULL, 'MUSCRINICM3R', 280473),
(461380, 'PR02065', NULL, 'Protein DPCD signature', NULL, NULL, 'PROTEINDPCD', 280474),
(461381, 'PR00556', NULL, 'Alpha-1B adrenergic receptor signature', NULL, NULL, 'ADRENRGCA1BR', 280475),
(461382, 'PR00683', NULL, 'Spectrin pleckstrin homology domain signature', NULL, NULL, 'SPECTRINPH', 280476),
(461383, 'PR00625', NULL, 'DnaJ domain signature', NULL, NULL, 'JDOMAIN', 280477),
(461384, 'PR01723', NULL, 'Gamma-aminobutyric-acid A receptor epsilon subunit signature', NULL, NULL, 'GABAAREPSLON', 280478),
(461385, 'PR00246', NULL, 'Somatostatin receptor signature', NULL, NULL, 'SOMATOSTATNR', 280479),
(461386, 'PR01083', NULL, 'Lymphocyte-specific protein signature', NULL, NULL, 'LYMPHSPCIFIC', 280480),
(461387, 'PR00550', NULL, 'Hyperglycemic hormone signature', NULL, NULL, 'HYPRGLYCEMIC', 280481),
(461388, 'PR00007', NULL, 'Complement C1Q domain signature', NULL, NULL, 'COMPLEMNTC1Q', 280482),
(461389, 'PR01981', NULL, 'Insulin-like growth factor-binding protein 5 signature', NULL, NULL, 'IGFBPFAMILY5', 280483),
(461390, 'PR01812', NULL, 'Annexin type XXXI signature', NULL, NULL, 'ANNEXINXXXI', 280484),
(461391, 'PR00754', NULL, 'Aerolysin signature', NULL, NULL, 'AEROLYSIN', 280485),
(461392, 'PR01455', NULL, 'Epithelial membrane protein EMP-2 signature', NULL, NULL, 'EPMEMPROT2', 280486);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(461393, 'PR01303', NULL, 'Plasmodium circumsporozoite protein signature', NULL, NULL, 'CRCMSPRZOITE', 280487),
(461394, 'PR01369', NULL, 'Intimin signature', NULL, NULL, 'INTIMIN', 280488),
(461395, 'PR00274', NULL, 'Glycoprotein hormone alpha chain signature', NULL, NULL, 'GLYCOHORMONE', 280489),
(461396, 'PR01163', NULL, 'Beta-tubulin signature', NULL, NULL, 'BETATUBULIN', 280490),
(461397, 'PR00574', NULL, 'Blue-sensitive opsin signature', NULL, NULL, 'OPSINBLUE', 280491),
(461398, 'PR01530', NULL, 'C-C chemokine receptor type 8 signature', NULL, NULL, 'CHEMOKINER8', 280492),
(461399, 'PR00444', NULL, 'HIV R-ORF/X-ORF protein signature', NULL, NULL, 'HIVVPRVPX', 280493),
(461400, 'PR01296', NULL, 'Cloacin immunity protein signature', NULL, NULL, 'CLOACNIMMNTY', 280494),
(461401, 'PR02003', NULL, 'Bombyxin signature', NULL, NULL, 'BOMBYXIN', 280495),
(461402, 'PR00527', NULL, 'Gastrin receptor signature', NULL, NULL, 'GASTRINR', 280496),
(461403, 'PR00759', NULL, 'Basic protease (Kunitz-type) inhibitor family signature', NULL, NULL, 'BASICPTASE', 280497),
(461404, 'PR01921', NULL, 'Tumour necrosis factor receptor 4 signature', NULL, NULL, 'TNFACTORR4', 280498),
(461405, 'PR00053', NULL, 'Fork head domain signature', NULL, NULL, 'FORKHEAD', 280499),
(461406, 'PR00268', NULL, 'Nerve growth factor signature', NULL, NULL, 'NGF', 280500),
(461407, 'PR00297', NULL, '10kDa chaperonin signature', NULL, NULL, 'CHAPERONIN10', 280501),
(461408, 'PR01926', NULL, 'Interleukin-9 signature', NULL, NULL, 'INTERLEUKIN9', 280502),
(461409, 'PR02002', NULL, 'Insulin-like growth factor signature', NULL, NULL, 'INSLNLIKEGF', 280503),
(461410, 'PR01243', NULL, 'Nucleoside diphosphate kinase signature', NULL, NULL, 'NUCDPKINASE', 280504),
(461411, 'PR00964', NULL, 'Movement protein signature', NULL, NULL, 'MOVEMENT', 280505),
(461412, 'PR01115', NULL, 'CLC-4 chloride channel signature', NULL, NULL, 'CLCHANNEL4', 280506),
(461413, 'PR00604', NULL, 'Class IA and IB cytochrome C signature', NULL, NULL, 'CYTCHRMECIAB', 280507),
(461414, 'PR01053', NULL, 'Metabotropic glutamate receptor 3 signature', NULL, NULL, 'MTABOTROPC3R', 280508),
(461415, 'PR00689', NULL, 'Acyl-coA-binding protein signature', NULL, NULL, 'ACOABINDINGP', 280509),
(461416, 'PR01385', NULL, 'Claudin-14 signature', NULL, NULL, 'CLAUDIN14', 280510),
(461417, 'PS00143', NULL, 'Insulinase family, zinc-binding region signature.', NULL, NULL, 'INSULINASE', 280511),
(461418, 'PS01295', NULL, '4-diphosphocytidyl-2C-methyl-D-erythritol synthase signature.', NULL, NULL, 'ISPD', 280512),
(461419, 'PS01173', NULL, 'Lipolytic enzymes "G-D-X-G" family, putative histidine active site.', NULL, NULL, 'LIPASE_GDXG_HIS', 280513),
(461420, 'PS00128', NULL, 'Glycosyl hydrolases family 22 (GH22) domain signature.', NULL, NULL, 'GLYCOSYL_HYDROL_F22_1', 280514),
(461421, 'PS00834', NULL, 'Aspartyl proteases, omptin family signature 1.', NULL, NULL, 'OMPTIN_1', 280515),
(461422, 'PS00324', NULL, 'Aspartokinase signature.', NULL, NULL, 'ASPARTOKINASE', 280516),
(461423, 'PS01144', NULL, 'Ribosomal protein L31e signature.', NULL, NULL, 'RIBOSOMAL_L31E', 280517),
(461424, 'PS01084', NULL, 'DNA photolyases class 2 signature 2.', NULL, NULL, 'DNA_PHOTOLYASES_2_2', 280518),
(461425, 'PS00761', NULL, 'Signal peptidases I signature 3.', NULL, NULL, 'SPASE_I_3', 280519),
(461426, 'PS00026', NULL, 'Chitin recognition or binding domain signature.', NULL, NULL, 'CHIT_BIND_I_1', 280520),
(461427, 'PS00321', NULL, 'recA signature.', NULL, NULL, 'RECA_1', 280521),
(461428, 'PS00252', NULL, 'Interferon alpha, beta and delta family signature.', NULL, NULL, 'INTERFERON_A_B_D', 280522),
(461429, 'PS00493', NULL, 'Clusterin signature 2.', NULL, NULL, 'CLUSTERIN_2', 280523),
(461430, 'PS00633', NULL, 'Bromodomain signature.', NULL, NULL, 'BROMODOMAIN_1', 280524),
(461431, 'PS00209', NULL, 'Arthropod hemocyanins / insect LSPs signature 1.', NULL, NULL, 'HEMOCYANIN_1', 280525),
(461432, 'PS00787', NULL, 'Chorismate synthase signature 1.', NULL, NULL, 'CHORISMATE_SYNTHASE_1', 280526),
(461433, 'PS00603', NULL, 'Thymidine kinase cellular-type signature.', NULL, NULL, 'TK_CELLULAR_TYPE', 280527);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(461434, 'PS00907', NULL, 'Uroporphyrinogen decarboxylase signature 2.', NULL, NULL, 'UROD_2', 280528),
(461435, 'PS00984', NULL, 'Urotensin II signature.', NULL, NULL, 'UROTENSIN_II', 280529),
(461436, 'PS00162', NULL, 'Alpha-carbonic anhydrases signature.', NULL, NULL, 'ALPHA_CA_1', 280530),
(461437, 'PS01277', NULL, 'Ribonuclease PH signature.', NULL, NULL, 'RIBONUCLEASE_PH', 280531),
(461438, 'PS00630', NULL, 'Inositol monophosphatase family signature 2.', NULL, NULL, 'IMP_2', 280532),
(461439, 'PS01332', NULL, 'Rrf2-type HTH domain signature.', NULL, NULL, 'HTH_RRF2_1', 280533),
(461440, 'PS00168', NULL, 'Tryptophan synthase beta chain pyridoxal-phosphate attachment site.', NULL, NULL, 'TRP_SYNTHASE_BETA', 280534),
(461441, 'PS00495', NULL, 'Apple domain.', NULL, NULL, 'APPLE', 280535),
(461442, 'PS00579', NULL, 'Ribosomal protein L29 signature.', NULL, NULL, 'RIBOSOMAL_L29', 280536),
(461443, 'PS01320', NULL, 'Uncharacterized protein family UPF0067 signature.', NULL, NULL, 'UPF0067', 280537),
(461444, 'PS00827', NULL, 'MARCKS family phosphorylation site domain.', NULL, NULL, 'MARCKS_2', 280538),
(461445, 'PS01003', NULL, 'Translationally controlled tumor protein (TCTP) domain signature 2.', NULL, NULL, 'TCTP_2', 280539),
(461446, 'PS01139', NULL, 'Bacterial microcompartment (BMC) domain signature.', NULL, NULL, 'BMC_1', 280540),
(461447, 'PS01153', NULL, 'NOL1/NOP2/sun family signature.', NULL, NULL, 'NOL1_NOP2_SUN', 280541),
(461448, 'PS00318', NULL, 'Hydroxymethylglutaryl-coenzyme A reductases signature 2.', NULL, NULL, 'HMG_COA_REDUCTASE_2', 280542),
(461449, 'PS00859', NULL, 'GTP cyclohydrolase I signature 1.', NULL, NULL, 'GTP_CYCLOHYDROL_1_1', 280543),
(461450, 'PS00502', NULL, 'Polygalacturonase active site.', NULL, NULL, 'POLYGALACTURONASE', 280544),
(461451, 'PS00868', NULL, 'Cys/Met metabolism enzymes pyridoxal-phosphate attachment site.', NULL, NULL, 'CYS_MET_METAB_PP', 280545),
(461452, 'PS60026', NULL, 'Ergtoxin family signature.', NULL, NULL, 'ERGTX', 280546),
(461453, 'PS01056', NULL, 'NAD-dependent DNA ligase signature 2.', NULL, NULL, 'DNA_LIGASE_N2', 280547),
(461454, 'PS01189', NULL, 'Ribosomal protein S12e signature.', NULL, NULL, 'RIBOSOMAL_S12E', 280548),
(461455, 'PS00457', NULL, 'Sodium:solute symporter family signature 2.', NULL, NULL, 'NA_SOLUT_SYMP_2', 280549),
(461456, 'PS00291', NULL, 'Prion protein signature 1.', NULL, NULL, 'PRION_1', 280550),
(461457, 'PS01106', NULL, 'Ribosomal protein L18e signature.', NULL, NULL, 'RIBOSOMAL_L18E', 280551),
(461458, 'PS00045', NULL, 'Bacterial histone-like DNA-binding proteins signature.', NULL, NULL, 'HISTONE_LIKE', 280552),
(461459, 'PS00517', NULL, 'Ribonuclease III family signature.', NULL, NULL, 'RNASE_3_1', 280553),
(461460, 'PS00900', NULL, 'Bacteriophage-type RNA polymerase family active site signature 1.', NULL, NULL, 'RNA_POL_PHAGE_1', 280554),
(461461, 'PS00112', NULL, 'Phosphagen kinase active site signature.', NULL, NULL, 'PHOSPHAGEN_KINASE', 280555),
(461462, 'PS00077', NULL, 'Heme-copper oxidase catalytic subunit, copper B binding region signature.', NULL, NULL, 'COX1_CUB', 280556),
(461463, 'PS00234', NULL, 'Gas vesicles protein GVPa signature 1.', NULL, NULL, 'GAS_VESICLE_A_1', 280557),
(461464, 'PS00915', NULL, 'Phosphatidylinositol 3- and 4-kinases signature 1.', NULL, NULL, 'PI3_4_KINASE_1', 280558),
(461465, 'PS01052', NULL, 'Calponin-like repeat signature.', NULL, NULL, 'CALPONIN_1', 280559),
(461466, 'PS00354', NULL, 'HMG-I and HMG-Y DNA-binding domain (A+T-hook).', NULL, NULL, 'HMGI_Y', 280560),
(461467, 'PS00267', NULL, 'Tachykinin family signature.', NULL, NULL, 'TACHYKININ', 280561),
(461468, 'PS00956', NULL, 'Fungal hydrophobins signature.', NULL, NULL, 'HYDROPHOBIN', 280562),
(461469, 'PS00539', NULL, 'Pyrokinins signature.', NULL, NULL, 'PYROKININ', 280563),
(461470, 'PS00375', NULL, 'UDP-glycosyltransferases signature.', NULL, NULL, 'UDPGT', 280564),
(461471, 'PS01205', NULL, 'Iodothyronine deiodinases active site.', NULL, NULL, 'T4_DEIODINASE', 280565),
(461472, 'PS00120', NULL, 'Lipases, serine active site.', NULL, NULL, 'LIPASE_SER', 280566);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(461473, 'PS00232', NULL, 'Cadherin domain signature.', NULL, NULL, 'CADHERIN_1', 280567),
(461474, 'PS00822', NULL, 'Cytochrome c and c1 heme lyases signature 2.', NULL, NULL, 'CYTO_HEME_LYASE_2', 280568),
(461475, 'PS00078', NULL, 'CO II and nitrous oxide reductase dinuclear copper centers signature.', NULL, NULL, 'COX2', 280569),
(461476, 'PS00110', NULL, 'Pyruvate kinase active site signature.', NULL, NULL, 'PYRUVATE_KINASE', 280570),
(461477, 'PS00451', NULL, 'Pathogenesis-related proteins Bet v I family signature.', NULL, NULL, 'PATHOGENESIS_BETVI', 280571),
(461478, 'PS60016', NULL, 'Omega-atracotoxin (ACTX) type 1 family signature.', NULL, NULL, 'OMEGA_ACTX_1', 280572),
(461479, 'PS00152', NULL, 'ATP synthase alpha and beta subunits signature.', NULL, NULL, 'ATPASE_ALPHA_BETA', 280573),
(461480, 'PS00463', NULL, 'Zn(2)-C6 fungal-type DNA-binding domain signature.', NULL, NULL, 'ZN2_CY6_FUNGAL_1', 280574),
(461481, 'PS00776', NULL, 'Glycosyl hydrolases family 11 (GH11) active site signature 1.', NULL, NULL, 'GH11_1', 280575),
(461482, 'PS01013', NULL, 'Oxysterol-binding protein family signature.', NULL, NULL, 'OSBP', 280576),
(461483, 'PS01025', NULL, 'Protein phosphatase 2A regulatory subunit PR55 signature 2.', NULL, NULL, 'PR55_2', 280577),
(461484, 'PS01035', NULL, 'PTS EIIB domains cysteine phosphorylation site signature.', NULL, NULL, 'PTS_EIIB_TYPE_1_CYS', 280578),
(461485, 'PS00118', NULL, 'Phospholipase A2 histidine active site.', NULL, NULL, 'PA2_HIS', 280579),
(461486, 'PS00367', NULL, 'Biopterin-dependent aromatic amino acid hydroxylases signature.', NULL, NULL, 'BH4_AAA_HYDROXYL_1', 280580),
(461487, 'PS00348', NULL, 'p53 family signature.', NULL, NULL, 'P53', 280581),
(461488, 'PS01333', NULL, 'Pyrrolidone-carboxylate peptidase glutamic acid active site.', NULL, NULL, 'PYRASE_GLU', 280582),
(461489, 'PS00083', NULL, 'Intradiol ring-cleavage dioxygenases signature.', NULL, NULL, 'INTRADIOL_DIOXYGENAS', 280583),
(461490, 'PS00380', NULL, 'Rhodanese signature 1.', NULL, NULL, 'RHODANESE_1', 280584),
(461491, 'PS00966', NULL, 'Phosphomannose isomerase type I signature 2.', NULL, NULL, 'PMI_I_2', 280585),
(461492, 'PS00873', NULL, 'Sodium:alanine symporter family signature.', NULL, NULL, 'NA_ALANINE_SYMP', 280586),
(461493, 'PS00739', NULL, 'S-adenosyl-L-homocysteine hydrolase signature 2.', NULL, NULL, 'ADOHCYASE_2', 280587),
(461494, 'PS00547', NULL, 'Transglutaminases active site.', NULL, NULL, 'TRANSGLUTAMINASES', 280588),
(461495, 'PS01263', NULL, 'Uncharacterized protein family UPF0021 signature.', NULL, NULL, 'UPF0021', 280589),
(461496, 'PS00065', NULL, 'D-isomer specific 2-hydroxyacid dehydrogenases NAD-binding signature.', NULL, NULL, 'D_2_HYDROXYACID_DH_1', 280590),
(461497, 'PS01077', NULL, 'Ribosomal protein L37e signature.', NULL, NULL, 'RIBOSOMAL_L37E', 280591),
(461498, 'PS00131', NULL, 'Serine carboxypeptidases, serine active site.', NULL, NULL, 'CARBOXYPEPT_SER_SER', 280592),
(461499, 'PS01142', NULL, 'Bacterial type II secretion system protein N signature.', NULL, NULL, 'T2SP_N', 280593),
(461500, 'PS00756', NULL, 'Protein secY signature 2.', NULL, NULL, 'SECY_2', 280594),
(461501, 'PS00802', NULL, 'Transketolase signature 2.', NULL, NULL, 'TRANSKETOLASE_2', 280595),
(461502, 'PS00644', NULL, 'Respiratory-chain NADH dehydrogenase 51 Kd subunit signature 1.', NULL, NULL, 'COMPLEX1_51K_1', 280596),
(461503, 'PS00327', NULL, 'Bacterial rhodopsins retinal binding site.', NULL, NULL, 'BACTERIAL_OPSIN_RET', 280597),
(461504, 'PS00925', NULL, 'Pollen proteins Ole e I family signature.', NULL, NULL, 'OLEEI', 280598),
(461505, 'PS01296', NULL, 'RsmI AdoMet-dependent methyltransferase protein family signature.', NULL, NULL, 'RSMI', 280599),
(461506, 'PS01255', NULL, 'Fetuin family signature 2.', NULL, NULL, 'FETUIN_2', 280600),
(461507, 'PS00158', NULL, 'Fructose-bisphosphate aldolase class-I active site.', NULL, NULL, 'ALDOLASE_CLASS_I', 280601),
(461508, 'PS00170', NULL, 'Cyclophilin-type peptidyl-prolyl cis-trans isomerase signature.', NULL, NULL, 'CSA_PPIASE_1', 280602); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(461509, 'PS00887', NULL, 'Dihydroxy-acid and 6-phosphogluconate dehydratases signature 2.', NULL, NULL, 'ILVD_EDD_2', 280603),
(461510, 'PS00236', NULL, 'Neurotransmitter-gated ion-channels signature.', NULL, NULL, 'NEUROTR_ION_CHANNEL', 280604),
(461511, 'PS01195', NULL, 'Peptidyl-tRNA hydrolase signature 1.', NULL, NULL, 'PEPT_TRNA_HYDROL_1', 280605),
(461512, 'PS01269', NULL, 'Uncharacterized protein family UPF0025 signature.', NULL, NULL, 'UPF0025', 280606),
(461513, 'PS00263', NULL, 'Natriuretic peptides signature.', NULL, NULL, 'NATRIURETIC_PEPTIDE', 280607),
(461514, 'PS01081', NULL, 'TetR-type HTH domain signature.', NULL, NULL, 'HTH_TETR_1', 280608),
(461515, 'PS00228', NULL, 'Tubulin-beta mRNA autoregulation signal.', NULL, NULL, 'TUBULIN_B_AUTOREG', 280609),
(461516, 'PS00558', NULL, 'Eukaryotic mitochondrial porin signature.', NULL, NULL, 'EUKARYOTIC_PORIN', 280610),
(461517, 'PS00238', NULL, 'Visual pigments (opsins) retinal binding site.', NULL, NULL, 'OPSIN', 280611),
(461518, 'PS00548', NULL, 'Ribosomal protein S3 signature.', NULL, NULL, 'RIBOSOMAL_S3', 280612),
(461519, 'PS00636', NULL, 'Nt-dnaJ domain signature.', NULL, NULL, 'DNAJ_1', 280613),
(461520, 'PS00648', NULL, 'Bacterial ribonuclease P protein component signature.', NULL, NULL, 'RIBONUCLEASE_P', 280614),
(461521, 'PS00872', NULL, 'Sodium:galactoside symporter family signature.', NULL, NULL, 'NA_GALACTOSIDE_SYMP', 280615),
(461522, 'PS00329', NULL, 'Heat shock hsp70 proteins family signature 2.', NULL, NULL, 'HSP70_2', 280616),
(461523, 'PS01108', NULL, 'Ribosomal protein L24 signature.', NULL, NULL, 'RIBOSOMAL_L24', 280617),
(461524, 'PS01292', NULL, 'Uncharacterized protein family UPF0036 signature.', NULL, NULL, 'UPF0036', 280618),
(461525, 'PS00302', NULL, 'Eukaryotic initiation factor 5A hypusine signature.', NULL, NULL, 'IF5A_HYPUSINE', 280619),
(461526, 'PS00568', NULL, 'Myelin P0 protein signature.', NULL, NULL, 'MYELIN_P0', 280620),
(461527, 'PS01310', NULL, 'FXYD family signature.', NULL, NULL, 'FXYD', 280621),
(461528, 'PS00146', NULL, 'Beta-lactamase class-A active site.', NULL, NULL, 'BETA_LACTAMASE_A', 280622),
(461529, 'PS00351', NULL, 'Transcription factor TFIID repeat signature.', NULL, NULL, 'TFIID', 280623),
(461530, 'PS00590', NULL, 'LIF / OSM family signature.', NULL, NULL, 'LIF_OSM', 280624),
(461531, 'PS00842', NULL, 'XPG protein signature 2.', NULL, NULL, 'XPG_2', 280625),
(461532, 'PS00032', NULL, '''Homeobox'' antennapedia-type protein signature.', NULL, NULL, 'ANTENNAPEDIA', 280626),
(461533, 'PS01152', NULL, 'Hypothetical hesB/yadR/yfhF family signature.', NULL, NULL, 'HESB', 280627),
(461534, 'PS00950', NULL, 'Bacterial rhodopsins signature 1.', NULL, NULL, 'BACTERIAL_OPSIN_1', 280628),
(461535, 'PS01023', NULL, 'PTR2 family proton/oligopeptide symporters signature 2.', NULL, NULL, 'PTR2_2', 280629),
(461536, 'PS00184', NULL, 'Phosphoribosylglycinamide synthetase signature.', NULL, NULL, 'GARS', 280630),
(461537, 'PS00141', NULL, 'Eukaryotic and viral aspartyl proteases active site.', NULL, NULL, 'ASP_PROTEASE', 280631),
(461538, 'PS00991', NULL, 'Clathrin adaptor complexes medium chain signature 2.', NULL, NULL, 'CLAT_ADAPTOR_M_2', 280632),
(461539, 'PS01207', NULL, 'Glypicans signature.', NULL, NULL, 'GLYPICAN', 280633),
(461540, 'PS01094', NULL, 'Uncharacterized protein family UPF0076 signature.', NULL, NULL, 'UPF0076', 280634),
(461541, 'PS00572', NULL, 'Glycosyl hydrolases family 1 active site.', NULL, NULL, 'GLYCOSYL_HYDROL_F1_1', 280635),
(461542, 'PS00995', NULL, 'Chaperonins TCP-1 signature 3.', NULL, NULL, 'TCP1_3', 280636),
(461543, 'PS00081', NULL, 'Lipoxygenases iron-binding region signature 2.', NULL, NULL, 'LIPOXYGENASE_2', 280637),
(461544, 'PS00185', NULL, 'Isopenicillin N synthase signature 1.', NULL, NULL, 'IPNS_1', 280638),
(461545, 'PS00936', NULL, 'Ribosomal protein L35 signature.', NULL, NULL, 'RIBOSOMAL_L35', 280639),
(461546, 'PS00917', NULL, 'Asparaginase / glutaminase active site signature 2.', NULL, NULL, 'ASN_GLN_ASE_2', 280640),
(461547, 'PS01241', NULL, 'Link domain signature.', NULL, NULL, 'LINK_1', 280641); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(461548, 'PS00981', NULL, 'G-protein coupled receptors family 3 signature 3.', NULL, NULL, 'G_PROTEIN_RECEP_F3_3', 280642),
(461549, 'PS01235', NULL, 'PdxS/SNZ family signature.', NULL, NULL, 'PDXS_SNZ_1', 280643),
(461550, 'PS01074', NULL, 'Terpene synthases signature.', NULL, NULL, 'TERPENE_SYNTHASES', 280644),
(461551, 'PS01285', NULL, 'Coagulation factors 5/8 type C domain (FA58C) signature 1.', NULL, NULL, 'FA58C_1', 280645),
(461552, 'PS00014', NULL, 'Endoplasmic reticulum targeting sequence.', NULL, NULL, 'ER_TARGET', 280646),
(461553, 'PS00911', NULL, 'Dihydroorotate dehydrogenase signature 1.', NULL, NULL, 'DHODEHASE_1', 280647),
(461554, 'PS00116', NULL, 'DNA polymerase family B signature.', NULL, NULL, 'DNA_POLYMERASE_B', 280648),
(461555, 'PS00989', NULL, 'Clathrin adaptor complexes small chain signature.', NULL, NULL, 'CLAT_ADAPTOR_S', 280649),
(461556, 'PS00243', NULL, 'Integrins beta chain cysteine-rich domain signature.', NULL, NULL, 'INTEGRIN_BETA', 280650),
(461557, 'PS00382', NULL, 'Endopeptidase Clp histidine active site.', NULL, NULL, 'CLP_PROTEASE_HIS', 280651),
(461558, 'PS00564', NULL, 'Argininosuccinate synthase signature 1.', NULL, NULL, 'ARGININOSUCCIN_SYN_1', 280652),
(461559, 'PS01297', NULL, 'FLAP/GST2/LTC4S family signature.', NULL, NULL, 'FLAP_GST2_LTC4S', 280653),
(461560, 'PS60010', NULL, 'Assassin bug toxin signature.', NULL, NULL, 'ASSASSIN_BUG_TOXIN', 280654),
(461561, 'PS01158', NULL, 'Macrophage migration inhibitory factor family signature.', NULL, NULL, 'MIF', 280655),
(461562, 'PS00600', NULL, 'Aminotransferases class-III pyridoxal-phosphate attachment site.', NULL, NULL, 'AA_TRANSFER_CLASS_3', 280656),
(461563, 'PS01226', NULL, 'Hydroxymethylglutaryl-coenzyme A synthase active site.', NULL, NULL, 'HMG_COA_SYNTHASE', 280657),
(461564, 'PS00233', NULL, 'Chitin-binding type R&R domain signature.', NULL, NULL, 'CHIT_BIND_RR_1', 280658),
(461565, 'PS00943', NULL, 'UbiA prenyltransferase family signature.', NULL, NULL, 'UBIA', 280659),
(461566, 'PS00455', NULL, 'Putative AMP-binding domain signature.', NULL, NULL, 'AMP_BINDING', 280660),
(461567, 'PS00154', NULL, 'E1-E2 ATPases phosphorylation site.', NULL, NULL, 'ATPASE_E1_E2', 280661),
(461568, 'PS01166', NULL, 'RNA polymerases beta chain signature.', NULL, NULL, 'RNA_POL_BETA', 280662),
(461569, 'PS01093', NULL, 'Adenylate cyclase class-I signature 2.', NULL, NULL, 'ADENYLATE_CYCLASE_1_2', 280663),
(461570, 'PS01304', NULL, 'ubiH/COQ6 monooxygenase family signature.', NULL, NULL, 'UBIH', 280664),
(461571, 'PS00396', NULL, 'Prokaryotic DNA topoisomerase I active site.', NULL, NULL, 'TOPOISOMERASE_I_PROK', 280665),
(461572, 'PS00746', NULL, 'NifH/frxC family signature 1.', NULL, NULL, 'NIFH_FRXC_1', 280666),
(461573, 'PS60011', NULL, 'Plant C6 type antimicrobial peptide (AMP) signature.', NULL, NULL, 'PLANT_C6_AMP', 280667),
(461574, 'PS00518', NULL, 'Zinc finger RING-type signature.', NULL, NULL, 'ZF_RING_1', 280668),
(461575, 'PS00701', NULL, 'Ribosomal protein L16 signature 2.', NULL, NULL, 'RIBOSOMAL_L16_2', 280669),
(461576, 'PS01336', NULL, 'S-adenosylmethionine decarboxylase signature.', NULL, NULL, 'ADOMETDC', 280670),
(461577, 'PS00409', NULL, 'Prokaryotic N-terminal methylation site.', NULL, NULL, 'PROKAR_NTER_METHYL', 280671),
(461578, 'PS01303', NULL, 'BCCT family of transporters signature.', NULL, NULL, 'BCCT', 280672),
(461579, 'PS00588', NULL, 'Flagella basal body rod proteins signature.', NULL, NULL, 'FLAGELLA_BB_ROD', 280673),
(461580, 'PS00114', NULL, 'Phosphoribosyl pyrophosphate synthase signature.', NULL, NULL, 'PRPP_SYNTHASE', 280674),
(461581, 'PS00472', NULL, 'Small cytokines (intercrine/chemokine) C-C subfamily signature.', NULL, NULL, 'SMALL_CYTOKINES_CC', 280675),
(461582, 'PS00516', NULL, 'Alkylbase DNA glycosidases alkA family signature.', NULL, NULL, 'ALKYLBASE_DNA_GLYCOS', 280676),
(461583, 'PS00920', NULL, 'Nitrilases / cyanide hydratase signature 1.', NULL, NULL, 'NITRIL_CHT_1', 280677),
(461584, 'PS00631', NULL, 'Cytosol aminopeptidase signature.', NULL, NULL, 'CYTOSOL_AP', 280678);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(461585, 'PS00937', NULL, 'Ribosomal protein L20 signature.', NULL, NULL, 'RIBOSOMAL_L20', 280679),
(461586, 'PS01150', NULL, 'Respiratory-chain NADH dehydrogenase 20 Kd subunit signature.', NULL, NULL, 'COMPLEX1_20K', 280680),
(461587, 'PS00924', NULL, 'Aspartate and glutamate racemases signature 2.', NULL, NULL, 'ASP_GLU_RACEMASE_2', 280681),
(461588, 'PS00670', NULL, 'D-isomer specific 2-hydroxyacid dehydrogenases signature 2.', NULL, NULL, 'D_2_HYDROXYACID_DH_2', 280682),
(461589, 'PS00972', NULL, 'Ubiquitin specific protease (USP) domain signature 1.', NULL, NULL, 'USP_1', 280683),
(461590, 'PS00437', NULL, 'Catalase proximal heme-ligand signature.', NULL, NULL, 'CATALASE_1', 280684),
(461591, 'PS01359', NULL, 'Zinc finger PHD-type signature.', NULL, NULL, 'ZF_PHD_1', 280685),
(461592, 'PS00240', NULL, 'Receptor tyrosine kinase class III signature.', NULL, NULL, 'RECEPTOR_TYR_KIN_III', 280686),
(461593, 'PS00947', NULL, 'Cathelicidins signature 2.', NULL, NULL, 'CATHELICIDINS_2', 280687),
(461594, 'PS00531', NULL, 'Ribonuclease T2 family histidine active site 2.', NULL, NULL, 'RNASE_T2_2', 280688),
(461595, 'PS00514', NULL, 'Fibrinogen C-terminal domain signature.', NULL, NULL, 'FIBRINOGEN_C_1', 280689),
(461596, 'PS00553', NULL, 'Lambdoid phages regulatory protein CIII signature.', NULL, NULL, 'LAMBDA_PHAGE_CIII', 280690),
(461597, 'PS01182', NULL, 'Glycosyl hydrolases family 35 putative active site.', NULL, NULL, 'GLYCOSYL_HYDROL_F35', 280691),
(461598, 'PS00347', NULL, 'Poly(ADP-ribose) polymerase zinc finger domain signature.', NULL, NULL, 'PARP_ZN_FINGER_1', 280692),
(461599, 'PS00361', NULL, 'Ribosomal protein S10 signature.', NULL, NULL, 'RIBOSOMAL_S10', 280693),
(461600, 'PS00642', NULL, 'Respiratory-chain NADH dehydrogenase 75 Kd subunit signature 2.', NULL, NULL, 'COMPLEX1_75K_2', 280694),
(461601, 'PS01048', NULL, 'Ribosomal protein S6 signature.', NULL, NULL, 'RIBOSOMAL_S6', 280695),
(461602, 'PS01128', NULL, 'Shikimate kinase signature.', NULL, NULL, 'SHIKIMATE_KINASE', 280696),
(461603, 'PS00803', NULL, 'Calreticulin family signature 1.', NULL, NULL, 'CALRETICULIN_1', 280697),
(461604, 'PS00977', NULL, 'FAD-dependent glycerol-3-phosphate dehydrogenase signature 1.', NULL, NULL, 'FAD_G3PDH_1', 280698),
(461605, 'PS00298', NULL, 'Heat shock hsp90 proteins family signature.', NULL, NULL, 'HSP90', 280699),
(461606, 'PS00016', NULL, 'Cell attachment sequence.', NULL, NULL, 'RGD', 280700),
(461607, 'PS00161', NULL, 'Isocitrate lyase signature.', NULL, NULL, 'ISOCITRATE_LYASE', 280701),
(461608, 'PS00406', NULL, 'Actins signature 1.', NULL, NULL, 'ACTINS_1', 280702),
(461609, 'PS00315', NULL, 'Dehydrins signature 1.', NULL, NULL, 'DEHYDRIN_1', 280703),
(461610, 'PS00909', NULL, 'Mandelate racemase / muconate lactonizing enzyme family signature 2.', NULL, NULL, 'MR_MLE_2', 280704),
(461611, 'PS01064', NULL, 'Pyridoxamine 5''-phosphate oxidase signature.', NULL, NULL, 'PYRIDOX_OXIDASE', 280705),
(461612, 'PS01070', NULL, 'DNA/RNA non-specific endonucleases active site.', NULL, NULL, 'NUCLEASE_NON_SPEC', 280706),
(461613, 'PS00619', NULL, 'PTN/MK heparin-binding protein family signature 1.', NULL, NULL, 'PTN_MK_1', 280707),
(461614, 'PS01104', NULL, 'Ribosomal protein L13e signature.', NULL, NULL, 'RIBOSOMAL_L13E', 280708),
(461615, 'PS00073', NULL, 'Acyl-CoA dehydrogenases signature 2.', NULL, NULL, 'ACYL_COA_DH_2', 280709),
(461616, 'PS00962', NULL, 'Ribosomal protein S2 signature 1.', NULL, NULL, 'RIBOSOMAL_S2_1', 280710),
(461617, 'PS00708', NULL, 'Prolyl endopeptidase family serine active site.', NULL, NULL, 'PRO_ENDOPEP_SER', 280711),
(461618, 'PS01317', NULL, 'SsrA-binding protein.', NULL, NULL, 'SSRP', 280712),
(461619, 'PS00665', NULL, 'Dihydrodipicolinate synthase signature 1.', NULL, NULL, 'DHDPS_1', 280713),
(461620, 'PS00781', NULL, 'Phosphoenolpyruvate carboxylase active site 1.', NULL, NULL, 'PEPCASE_1', 280714),
(461621, 'PS01041', NULL, 'Stathmin family signature 2.', NULL, NULL, 'STATHMIN_2', 280715),
(461622, 'PS01271', NULL, 'Sodium:sulfate symporter family signature.', NULL, NULL, 'NA_SULFATE', 280716);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(461623, 'PS00222', NULL, 'Insulin-like growth factor-binding protein (IGFBP) N-terminal domain signature.', NULL, NULL, 'IGFBP_N_1', 280717),
(461624, 'PS00297', NULL, 'Heat shock hsp70 proteins family signature 1.', NULL, NULL, 'HSP70_1', 280718),
(461625, 'PS00392', NULL, 'DDC / GAD / HDC / TyrDC pyridoxal-phosphate attachment site.', NULL, NULL, 'DDC_GAD_HDC_YDC', 280719),
(461626, 'PS00422', NULL, 'Granins signature 1.', NULL, NULL, 'GRANINS_1', 280720),
(461627, 'PS00139', NULL, 'Eukaryotic thiol (cysteine) proteases cysteine active site.', NULL, NULL, 'THIOL_PROTEASE_CYS', 280721),
(461628, 'PS00140', NULL, 'Ubiquitin carboxyl-terminal hydrolase family 1 cysteine active-site.', NULL, NULL, 'UCH_1', 280722),
(461629, 'PS00322', NULL, 'Histone H3 signature 1.', NULL, NULL, 'HISTONE_H3_1', 280723),
(461630, 'PS00245', NULL, 'Phytochrome chromophore attachment site signature.', NULL, NULL, 'PHYTOCHROME_1', 280724),
(461631, 'PS00639', NULL, 'Eukaryotic thiol (cysteine) proteases histidine active site.', NULL, NULL, 'THIOL_PROTEASE_HIS', 280725),
(461632, 'PS00541', NULL, 'Nuclear transition protein 1 signature.', NULL, NULL, 'TP1', 280726),
(461633, 'PS60022', NULL, 'Huwentoxin-2 family signature.', NULL, NULL, 'HWTX_2', 280727),
(461634, 'PS01054', NULL, 'Transaldolase signature 1.', NULL, NULL, 'TRANSALDOLASE_1', 280728),
(461635, 'PS00301', NULL, 'Translational (tr)-type guanine nucleotide-binding (G) domain signature.', NULL, NULL, 'G_TR_1', 280729),
(461636, 'PS00919', NULL, 'Deoxyribonuclease I signature 1.', NULL, NULL, 'DNASE_I_1', 280730),
(461637, 'PS00955', NULL, 'Imidazoleglycerol-phosphate dehydratase signature 2.', NULL, NULL, 'IGP_DEHYDRATASE_2', 280731),
(461638, 'PS01212', NULL, 'ATP P2X receptors signature.', NULL, NULL, 'P2X_RECEPTOR', 280732),
(461639, 'PS00757', NULL, 'Prokaryotic sulfate-binding proteins signature 2.', NULL, NULL, 'PROK_SULFATE_BIND_2', 280733),
(461640, 'PS01086', NULL, 'Ribulose-phosphate 3-epimerase family signature 2.', NULL, NULL, 'RIBUL_P_3_EPIMER_2', 280734),
(461641, 'PS01258', NULL, 'Apoptosis regulator, Bcl-2 family BH2 motif signature.', NULL, NULL, 'BH2', 280735),
(461642, 'PS01063', NULL, 'Sigma-70 factors ECF subfamily signature.', NULL, NULL, 'SIGMA70_ECF', 280736),
(461643, 'PS01185', NULL, 'C-terminal cystine knot signature.', NULL, NULL, 'CTCK_1', 280737),
(461644, 'PS00119', NULL, 'Phospholipase A2 aspartic acid active site.', NULL, NULL, 'PA2_ASP', 280738),
(461645, 'PS00885', NULL, 'EPSP synthase signature 2.', NULL, NULL, 'EPSP_SYNTHASE_2', 280739),
(461646, 'PS01194', NULL, 'Ribosomal protein L15e signature.', NULL, NULL, 'RIBOSOMAL_L15E', 280740),
(461647, 'PS00795', NULL, 'Involucrin signature.', NULL, NULL, 'INVOLUCRIN', 280741),
(461648, 'PS00876', NULL, 'Indoleamine 2,3-dioxygenase signature 1.', NULL, NULL, 'IDO_1', 280742),
(461649, 'PS00176', NULL, 'Eukaryotic DNA topoisomerase I active site.', NULL, NULL, 'TOPOISOMERASE_I_EUK', 280743),
(461650, 'PS00330', NULL, 'Hemolysin-type calcium-binding region signature.', NULL, NULL, 'HEMOLYSIN_CALCIUM', 280744),
(461651, 'PS00047', NULL, 'Histone H4 signature.', NULL, NULL, 'HISTONE_H4', 280745),
(461652, 'PS00794', NULL, '7,8-dihydro-6-hydroxymethylpterin-pyrophosphokinase signature.', NULL, NULL, 'HPPK', 280746),
(461653, 'PS00153', NULL, 'ATP synthase gamma subunit signature.', NULL, NULL, 'ATPASE_GAMMA', 280747),
(461654, 'PS01208', NULL, 'VWFC domain signature.', NULL, NULL, 'VWFC_1', 280748),
(461655, 'PS01125', NULL, 'ROK family signature.', NULL, NULL, 'ROK', 280749),
(461656, 'PS00729', NULL, 'AP endonucleases family 2 signature 1.', NULL, NULL, 'AP_NUCLEASE_F2_1', 280750),
(461657, 'PS60002', NULL, 'Phosphoketolase signature 1.', NULL, NULL, 'PHOSPHOKETOLASE_1', 280751),
(461658, 'PS00021', NULL, 'Kringle domain signature.', NULL, NULL, 'KRINGLE_1', 280752),
(461659, 'PS00060', NULL, 'Iron-containing alcohol dehydrogenases signature 2.', NULL, NULL, 'ADH_IRON_2', 280753),
(461660, 'PS00709', NULL, 'Ribosomal protein L30e signature 1.', NULL, NULL, 'RIBOSOMAL_L30E_1', 280754);
INSERT INTO "PUBLIC"."MODEL" VALUES
(461661, 'PS00082', NULL, 'Extradiol ring-cleavage dioxygenases signature.', NULL, NULL, 'EXTRADIOL_DIOXYGENAS', 280755),
(461662, 'PS00393', NULL, 'Phosphoenolpyruvate carboxylase active site 2.', NULL, NULL, 'PEPCASE_2', 280756),
(461663, 'PS01192', NULL, 'Hydroxymethylglutaryl-coenzyme A reductases signature 3.', NULL, NULL, 'HMG_COA_REDUCTASE_3', 280757),
(461664, 'PS00017', NULL, 'ATP/GTP-binding site motif A (P-loop).', NULL, NULL, 'ATP_GTP_A', 280758),
(461665, 'PS00231', NULL, 'F-actin capping protein beta subunit signature.', NULL, NULL, 'F_ACTIN_CAPPING_BETA', 280759),
(461666, 'PS01057', NULL, 'SAICAR synthetase signature 1.', NULL, NULL, 'SAICAR_SYNTHETASE_1', 280760),
(461667, 'PS00304', NULL, 'Small, acid-soluble spore proteins, alpha/beta type, signature 1.', NULL, NULL, 'SASP_1', 280761),
(461668, 'PS00946', NULL, 'Cathelicidins signature 1.', NULL, NULL, 'CATHELICIDINS_1', 280762),
(461669, 'PS00824', NULL, 'Elongation factor 1 beta/beta''/delta chain signature 1.', NULL, NULL, 'EF1BD_1', 280763),
(461670, 'PS00608', NULL, 'Glycosyl hydrolases family 2 acid/base catalyst.', NULL, NULL, 'GLYCOSYL_HYDROL_F2_2', 280764),
(461671, 'PS00928', NULL, 'Trehalase signature 2.', NULL, NULL, 'TREHALASE_2', 280765),
(461672, 'PS60004', NULL, 'Omega-conotoxin family signature.', NULL, NULL, 'OMEGA_CONOTOXIN', 280766),
(461673, 'PS00583', NULL, 'pfkB family of carbohydrate kinases signature 1.', NULL, NULL, 'PFKB_KINASES_1', 280767),
(461674, 'PS01045', NULL, 'Squalene and phytoene synthases signature 2.', NULL, NULL, 'SQUALEN_PHYTOEN_SYN_2', 280768),
(461675, 'PS01291', NULL, 'NAD:arginine ADP-ribosyltransferases signature.', NULL, NULL, 'ART', 280769),
(461676, 'PS00058', NULL, 'DNA mismatch repair proteins mutL / hexB / PMS1 signature.', NULL, NULL, 'DNA_MISMATCH_REPAIR_1', 280770),
(461677, 'PS00099', NULL, 'Thiolases active site.', NULL, NULL, 'THIOLASE_3', 280771),
(461678, 'PS00484', NULL, 'Thyroglobulin type-1 repeat signature.', NULL, NULL, 'THYROGLOBULIN_1_1', 280772),
(461679, 'PS00356', NULL, 'LacI-type HTH domain signature.', NULL, NULL, 'HTH_LACI_1', 280773),
(461680, 'PS00722', NULL, 'Formate--tetrahydrofolate ligase signature 2.', NULL, NULL, 'FTHFS_2', 280774),
(461681, 'PS00247', NULL, 'HBGF/FGF family signature.', NULL, NULL, 'HBGF_FGF', 280775),
(461682, 'PS00818', NULL, 'Dps protein family signature 1.', NULL, NULL, 'DPS_1', 280776),
(461683, 'PS00474', NULL, 'Ribosomal protein L3 signature.', NULL, NULL, 'RIBOSOMAL_L3', 280777),
(461684, 'PS01001', NULL, 'Succinate dehydrogenase cytochrome b subunit signature 2.', NULL, NULL, 'SDH_CYT_2', 280778),
(461685, 'PS01313', NULL, 'Lipoate-protein ligase B signature.', NULL, NULL, 'LIPB', 280779),
(461686, 'PS00306', NULL, 'Caseins alpha/beta signature.', NULL, NULL, 'CASEIN_ALPHA_BETA', 280780),
(461687, 'PS00275', NULL, 'Shiga/ricin ribosomal inactivating toxins active site signature.', NULL, NULL, 'SHIGA_RICIN', 280781),
(461688, 'PS00650', NULL, 'G-protein coupled receptors family 2 signature 2.', NULL, NULL, 'G_PROTEIN_RECEP_F2_2', 280782),
(461689, 'PS01110', NULL, 'RNA polymerases H / 23 Kd subunits signature.', NULL, NULL, 'RNA_POL_H_23KD', 280783),
(461690, 'PS01322', NULL, 'Phosphotriesterase family signature 1.', NULL, NULL, 'PHOSPHOTRIESTERASE_1', 280784),
(461691, 'PS00765', NULL, 'Phosphoglucose isomerase signature 1.', NULL, NULL, 'P_GLUCOSE_ISOMERASE_1', 280785),
(461692, 'PS00412', NULL, 'Neuromodulin (GAP-43) signature 1.', NULL, NULL, 'NEUROMODULIN_1', 280786),
(461693, 'PS00806', NULL, 'Fructose-bisphosphate aldolase class-II signature 2.', NULL, NULL, 'ALDOLASE_CLASS_II_2', 280787),
(461694, 'PS01331', NULL, 'Thymidylate kinase signature.', NULL, NULL, 'THYMIDYLATE_KINASE', 280788),
(461695, 'PS01120', NULL, 'Urease nickel ligands signature.', NULL, NULL, 'UREASE_1', 280789),
(461696, 'PS00090', NULL, 'Nitrogenases component 1 alpha and beta subunits signature 2.', NULL, NULL, 'NITROGENASE_1_2', 280790),
(461697, 'PS00580', NULL, 'Ribosomal protein L32e signature.', NULL, NULL, 'RIBOSOMAL_L32E', 280791);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(461698, 'PS60027', NULL, 'Contryphan family signature.', NULL, NULL, 'CONTRYPHAN', 280792),
(461699, 'PS00133', NULL, 'Zinc carboxypeptidases, zinc-binding region 2 signature.', NULL, NULL, 'CARBOXYPEPT_ZN_2', 280793),
(461700, 'PS00489', NULL, 'Bacteriophage-type RNA polymerase family active site signature 2.', NULL, NULL, 'RNA_POL_PHAGE_2', 280794),
(461701, 'PS00659', NULL, 'Glycosyl hydrolases family 5 signature.', NULL, NULL, 'GLYCOSYL_HYDROL_F5', 280795),
(461702, 'PS60008', NULL, 'Cyclotides bracelet subfamily signature.', NULL, NULL, 'CYCLOTIDE_BRACELET', 280796),
(461703, 'PS01335', NULL, 'Methylglyoxal synthase active site.', NULL, NULL, 'METHYLGLYOXAL_SYNTH', 280797),
(461704, 'PS00808', NULL, 'ADP-glucose pyrophosphorylase signature 1.', NULL, NULL, 'ADP_GLC_PYROPHOSPH_1', 280798),
(461705, 'PS00934', NULL, 'Glyoxalase I signature 1.', NULL, NULL, 'GLYOXALASE_I_1', 280799),
(461706, 'PS01082', NULL, 'Ribosomal protein L7Ae signature.', NULL, NULL, 'RIBOSOMAL_L7AE', 280800),
(461707, 'PS00905', NULL, 'GTP1/OBG family signature.', NULL, NULL, 'GTP1_OBG', 280801),
(461708, 'PS01164', NULL, 'Copper amine oxidase topaquinone signature.', NULL, NULL, 'COPPER_AMINE_OXID_1', 280802),
(461709, 'PS01027', NULL, 'Glycosyl hydrolases family 39 active site.', NULL, NULL, 'GLYCOSYL_HYDROL_F39', 280803),
(461710, 'PS00268', NULL, 'Cecropin family signature.', NULL, NULL, 'CECROPIN', 280804),
(461711, 'PS01330', NULL, 'Polyamine biosynthesis (PABS) domain signature.', NULL, NULL, 'PABS_1', 280805),
(461712, 'PS00615', NULL, 'C-type lectin domain signature.', NULL, NULL, 'C_TYPE_LECTIN_1', 280806),
(461713, 'PS00390', NULL, 'Sodium and potassium ATPases beta subunits signature 1.', NULL, NULL, 'ATPASE_NA_K_BETA_1', 280807),
(461714, 'PS00438', NULL, 'Catalase proximal active site signature.', NULL, NULL, 'CATALASE_2', 280808),
(461715, 'PS00445', NULL, 'FGGY family of carbohydrate kinases signature 2.', NULL, NULL, 'FGGY_KINASES_2', 280809),
(461716, 'PS01109', NULL, 'Ribosomal protein L10 signature.', NULL, NULL, 'RIBOSOMAL_L10', 280810),
(461717, 'PS00952', NULL, 'ER lumen protein retaining receptor signature 2.', NULL, NULL, 'ER_LUMEN_RECEPTOR_2', 280811),
(461718, 'PS01065', NULL, 'Electron transfer flavoprotein beta-subunit signature.', NULL, NULL, 'ETF_BETA', 280812),
(461719, 'PS01042', NULL, 'Homoserine dehydrogenase signature.', NULL, NULL, 'HOMOSER_DHGENASE', 280813),
(461720, 'PS01112', NULL, 'RNA polymerases N / 8 Kd subunits signature.', NULL, NULL, 'RNA_POL_N_8KD', 280814),
(461721, 'PS00546', NULL, 'Matrixins cysteine switch.', NULL, NULL, 'CYSTEINE_SWITCH', 280815),
(461722, 'PS00753', NULL, 'XPA protein signature 2.', NULL, NULL, 'XPA_2', 280816),
(461723, 'PS00771', NULL, 'Barwin domain signature 1.', NULL, NULL, 'BARWIN_1', 280817),
(461724, 'PS00142', NULL, 'Neutral zinc metallopeptidases, zinc-binding region signature.', NULL, NULL, 'ZINC_PROTEASE', 280818),
(461725, 'PS00718', NULL, 'Sigma-54 factors family signature 2.', NULL, NULL, 'SIGMA54_2', 280819),
(461726, 'PS00507', NULL, 'Nickel-dependent hydrogenases large subunit signature 1.', NULL, NULL, 'NI_HGENASE_L_1', 280820),
(461727, 'PS00610', NULL, 'Sodium:neurotransmitter symporter family signature 1.', NULL, NULL, 'NA_NEUROTRAN_SYMP_1', 280821),
(461728, 'PS00762', NULL, 'WHEP-TRS domain signature.', NULL, NULL, 'WHEP_TRS_1', 280822),
(461729, 'PS00836', NULL, 'Alanine dehydrogenase & pyridine nucleotide transhydrogenase signature 1.', NULL, NULL, 'ALADH_PNT_1', 280823),
(461730, 'PS00586', NULL, 'Ribosomal protein L16 signature 1.', NULL, NULL, 'RIBOSOMAL_L16_1', 280824),
(461731, 'PS01355', NULL, 'Short hematopoietin receptor family 1 signature.', NULL, NULL, 'HEMATOPO_REC_S_F1', 280825),
(461732, 'PS00869', NULL, 'Renal dipeptidase active site.', NULL, NULL, 'RENAL_DIPEPTIDASE_1', 280826),
(461733, 'PS00959', NULL, 'Histone H3 signature 2.', NULL, NULL, 'HISTONE_H3_2', 280827),
(461734, 'PS00049', NULL, 'Ribosomal protein L14 signature.', NULL, NULL, 'RIBOSOMAL_L14', 280828),
(461735, 'PS01006', NULL, 'Formate and nitrite transporters signature 2.', NULL, NULL, 'FORMATE_NITRITE_TP_2', 280829);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(461736, 'PS00282', NULL, 'Kazal serine protease inhibitors family signature.', NULL, NULL, 'KAZAL_1', 280830),
(461737, 'PS00657', NULL, 'Fork head domain signature 1.', NULL, NULL, 'FORK_HEAD_1', 280831),
(461738, 'PS01114', NULL, 'GPR1/FUN34/yaaH family signature.', NULL, NULL, 'GPR1_FUN34_YAAH', 280832),
(461739, 'PS00433', NULL, 'Phosphofructokinase signature.', NULL, NULL, 'PHOSPHOFRUCTOKINASE', 280833),
(461740, 'PS00913', NULL, 'Iron-containing alcohol dehydrogenases signature 1.', NULL, NULL, 'ADH_IRON_1', 280834),
(461741, 'PS01030', NULL, 'RNA polymerases M / 15 Kd subunits signature.', NULL, NULL, 'RNA_POL_M_15KD', 280835),
(461742, 'PS00791', NULL, 'Receptor tyrosine kinase class V signature 2.', NULL, NULL, 'RECEPTOR_TYR_KIN_V_2', 280836),
(461743, 'PS00850', NULL, 'Glycine radical domain signature.', NULL, NULL, 'GLY_RADICAL_1', 280837),
(461744, 'PS00248', NULL, 'Nerve growth factor family signature.', NULL, NULL, 'NGF_1', 280838),
(461745, 'PS00385', NULL, 'Alpha-L-fucosidase putative active site.', NULL, NULL, 'ALPHA_L_FUCOSIDASE', 280839),
(461746, 'PS00106', NULL, 'Galactokinase signature.', NULL, NULL, 'GALACTOKINASE', 280840),
(461747, 'PS00578', NULL, 'Ribosomal protein S6e signature.', NULL, NULL, 'RIBOSOMAL_S6E', 280841),
(461748, 'PS01004', NULL, 'Myelin proteolipid protein signature 2.', NULL, NULL, 'MYELIN_PLP_2', 280842),
(461749, 'PS00662', NULL, 'Bacterial type II secretion system protein E signature.', NULL, NULL, 'T2SP_E', 280843),
(461750, 'PS00349', NULL, 'CTF/NF-I DNA-binding domain signature.', NULL, NULL, 'CTF_NFI_1', 280844),
(461751, 'PS01216', NULL, 'ATP-citrate lyase / succinyl-CoA ligases family signature 1.', NULL, NULL, 'SUCCINYL_COA_LIG_1', 280845),
(461752, 'PS01183', NULL, 'ubiE/COQ5 methyltransferase family signature 1.', NULL, NULL, 'UBIE_1', 280846),
(461753, 'PS60032', NULL, 'Glycosyl hydrolases family 9 (GH9) active site signature 1.', NULL, NULL, 'GH9_1', 280847),
(461754, 'PS00458', NULL, 'Natriuretic peptides receptors signature.', NULL, NULL, 'ANF_RECEPTORS', 280848),
(461755, 'PS00560', NULL, 'Serine carboxypeptidases, histidine active site.', NULL, NULL, 'CARBOXYPEPT_SER_HIS', 280849),
(461756, 'PS01275', NULL, 'Elongation factor P signature.', NULL, NULL, 'EFP', 280850),
(461757, 'PS00372', NULL, 'PTS EIIA domains phosphorylation site signature 2.', NULL, NULL, 'PTS_EIIA_TYPE_2_HIS', 280851),
(461758, 'PS00973', NULL, 'Ubiquitin specific protease (USP) domain signature 2.', NULL, NULL, 'USP_2', 280852),
(461759, 'PS00323', NULL, 'Ribosomal protein S19 signature.', NULL, NULL, 'RIBOSOMAL_S19', 280853),
(461760, 'PS00093', NULL, 'N-4 cytosine-specific DNA methylases signature.', NULL, NULL, 'N4_MTASE', 280854),
(461761, 'PS00089', NULL, 'Ribonucleotide reductase large subunit signature.', NULL, NULL, 'RIBORED_LARGE', 280855),
(461762, 'PS01011', NULL, 'Folylpolyglutamate synthase signature 1.', NULL, NULL, 'FOLYLPOLYGLU_SYNT_1', 280856),
(461763, 'PS01058', NULL, 'SAICAR synthetase signature 2.', NULL, NULL, 'SAICAR_SYNTHETASE_2', 280857),
(461764, 'PS00923', NULL, 'Aspartate and glutamate racemases signature 1.', NULL, NULL, 'ASP_GLU_RACEMASE_1', 280858),
(461765, 'PS00064', NULL, 'L-lactate dehydrogenase active site.', NULL, NULL, 'L_LDH', 280859),
(461766, 'PS01254', NULL, 'Fetuin family signature 1.', NULL, NULL, 'FETUIN_1', 280860),
(461767, 'PS01257', NULL, 'Ribosomal protein L10e signature.', NULL, NULL, 'RIBOSOMAL_L10E', 280861),
(461768, 'PS00703', NULL, 'Orn/Lys/Arg decarboxylases family 1 pyridoxal-P attachment site.', NULL, NULL, 'OKR_DC_1', 280862),
(461769, 'PS00004', NULL, 'cAMP- and cGMP-dependent protein kinase phosphorylation site.', NULL, NULL, 'CAMP_PHOSPHO_SITE', 280863),
(461770, 'PS00401', NULL, 'Prokaryotic sulfate-binding proteins signature 1.', NULL, NULL, 'PROK_SULFATE_BIND_1', 280864),
(461771, 'PS00424', NULL, 'Interleukin-2 signature.', NULL, NULL, 'INTERLEUKIN_2', 280865),
(461772, 'PS00244', NULL, 'Photosynthetic reaction center proteins signature.', NULL, NULL, 'REACTION_CENTER', 280866),
(461773, 'PS00183', NULL, 'Ubiquitin-conjugating (UBC) active site signature.', NULL, NULL, 'UBC_1', 280867);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(461774, 'PS00820', NULL, 'Glucoamylase active site region signature.', NULL, NULL, 'GLUCOAMYLASE', 280868),
(461775, 'PS00312', NULL, 'Glycophorin A signature.', NULL, NULL, 'GLYCOPHORIN_A', 280869),
(461776, 'PS00769', NULL, 'Transthyretin signature 2.', NULL, NULL, 'TRANSTHYRETIN_2', 280870),
(461777, 'PS01220', NULL, 'Phosphatidylethanolamine-binding protein family signature.', NULL, NULL, 'PBP', 280871),
(461778, 'PS01352', NULL, 'Long hematopoietin receptor, single chain family signature.', NULL, NULL, 'HEMATOPO_REC_L_F1', 280872),
(461779, 'PS00838', NULL, 'Interleukins -4 and -13 signature.', NULL, NULL, 'INTERLEUKIN_4_13', 280873),
(461780, 'PS00117', NULL, 'Galactose-1-phosphate uridyl transferase family 1 active site signature.', NULL, NULL, 'GAL_P_UDP_TRANSF_I', 280874),
(461781, 'PS01283', NULL, 'T-box domain signature 1.', NULL, NULL, 'TBOX_1', 280875),
(461782, 'PS00976', NULL, 'Myristoyl-CoA:protein N-myristoyltransferase signature 2.', NULL, NULL, 'NMT_2', 280876),
(461783, 'PS00087', NULL, 'Copper/Zinc superoxide dismutase signature 1.', NULL, NULL, 'SOD_CU_ZN_1', 280877),
(461784, 'PS00287', NULL, 'Cysteine proteases inhibitors signature.', NULL, NULL, 'CYSTATIN', 280878),
(461785, 'PS01098', NULL, 'Lipolytic enzymes "G-D-S-L" family, serine active site.', NULL, NULL, 'LIPASE_GDSL_SER', 280879),
(461786, 'PS01046', NULL, 'ATP-dependent serine proteases, lon family, serine active site.', NULL, NULL, 'LON_SER', 280880),
(461787, 'PS00254', NULL, 'Interleukin-6 / G-CSF / MGF signature.', NULL, NULL, 'INTERLEUKIN_6', 280881),
(461788, 'PS01026', NULL, 'Photosystem I psaG and psaK proteins signature.', NULL, NULL, 'PHOTOSYSTEM_I_PSAGK', 280882),
(461789, 'PS01288', NULL, 'Uncharacterized protein family UPF0027 signature.', NULL, NULL, 'UPF0027', 280883),
(461790, 'PS00477', NULL, 'Alpha-2-macroglobulin family thiolester region signature.', NULL, NULL, 'ALPHA_2_MACROGLOBULIN', 280884),
(461791, 'PS00690', NULL, 'DEAH-box subfamily ATP-dependent helicases signature.', NULL, NULL, 'DEAH_ATP_HELICASE', 280885),
(461792, 'PS00167', NULL, 'Tryptophan synthase alpha chain signature.', NULL, NULL, 'TRP_SYNTHASE_ALPHA', 280886),
(461793, 'PS01274', NULL, 'Coenzyme A transferases signature 2.', NULL, NULL, 'COA_TRANSF_2', 280887),
(461794, 'PS00533', NULL, 'Porphobilinogen deaminase cofactor-binding site.', NULL, NULL, 'PORPHOBILINOGEN_DEAM', 280888),
(461795, 'PS01174', NULL, 'Lipolytic enzymes "G-D-X-G" family, putative serine active site.', NULL, NULL, 'LIPASE_GDXG_SER', 280889),
(461796, 'PS60028', NULL, 'Scorpion calcine family signature.', NULL, NULL, 'SCORPION_CALCINE', 280890),
(461797, 'PS00075', NULL, 'Dihydrofolate reductase (DHFR) domain signature.', NULL, NULL, 'DHFR_1', 280891),
(461798, 'PS00994', NULL, 'Bacterial export FHIPEP family signature.', NULL, NULL, 'FHIPEP', 280892),
(461799, 'PS01047', NULL, 'Heavy-metal-associated domain.', NULL, NULL, 'HMA_1', 280893),
(461800, 'PS00954', NULL, 'Imidazoleglycerol-phosphate dehydratase signature 1.', NULL, NULL, 'IGP_DEHYDRATASE_1', 280894),
(461801, 'PS01162', NULL, 'Quinone oxidoreductase / zeta-crystallin signature.', NULL, NULL, 'QOR_ZETA_CRYSTAL', 280895),
(461802, 'PS00515', NULL, 'Seminal vesicle protein II repeats signature.', NULL, NULL, 'SVP_II', 280896),
(461803, 'PS00576', NULL, 'General diffusion Gram-negative porins signature.', NULL, NULL, 'GRAM_NEG_PORIN', 280897),
(461804, 'PS01126', NULL, 'Elongation factor Ts signature 1.', NULL, NULL, 'EF_TS_1', 280898),
(461805, 'PS01088', NULL, 'CAP protein signature 1.', NULL, NULL, 'CAP_1', 280899),
(461806, 'PS00364', NULL, 'Bacterial quinoprotein dehydrogenases signature 2.', NULL, NULL, 'BACTERIAL_PQQ_2', 280900),
(461807, 'PS01170', NULL, 'Ribosomal protein L6e signature.', NULL, NULL, 'RIBOSOMAL_L6E', 280901),
(461808, 'PS01204', NULL, 'NF-kappa-B/Rel/dorsal domain signature.', NULL, NULL, 'REL_1', 280902),
(461809, 'PS01016', NULL, 'Glycoprotease family signature.', NULL, NULL, 'GLYCOPROTEASE', 280903),
(461810, 'PS01287', NULL, 'RNA 3''-terminal phosphate cyclase signature.', NULL, NULL, 'RTC', 280904);
INSERT INTO "PUBLIC"."MODEL" VALUES
(461811, 'PS00369', NULL, 'PTS HPR domain histidine phosphorylation site signature.', NULL, NULL, 'PTS_HPR_HIS', 280905),
(461812, 'PS00814', NULL, 'Adrenodoxin family, iron-sulfur binding region signature.', NULL, NULL, 'ADX', 280906),
(461813, 'PS01357', NULL, 'Zinc finger ZZ-type signature.', NULL, NULL, 'ZF_ZZ_1', 280907),
(461814, 'PS00151', NULL, 'Acylphosphatase signature 2.', NULL, NULL, 'ACYLPHOSPHATASE_2', 280908),
(461815, 'PS00335', NULL, 'Parathyroid hormone family signature.', NULL, NULL, 'PARATHYROID', 280909),
(461816, 'PS01156', NULL, 'TonB-dependent receptor proteins signature 2.', NULL, NULL, 'TONB_DEPENDENT_REC_2', 280910),
(461817, 'PS01286', NULL, 'Coagulation factors 5/8 type C domain (FA58C) signature 2.', NULL, NULL, 'FA58C_2', 280911),
(461818, 'PS00786', NULL, '5''-nucleotidase signature 2.', NULL, NULL, '5_NUCLEOTIDASE_2', 280912),
(461819, 'PS00686', NULL, 'NF-YA/HAP2 subunit signature.', NULL, NULL, 'NFYA_HAP2_1', 280913),
(461820, 'PS00754', NULL, 'Sodium:neurotransmitter symporter family signature 2.', NULL, NULL, 'NA_NEUROTRAN_SYMP_2', 280914),
(461821, 'PS00725', NULL, 'Germin family signature.', NULL, NULL, 'GERMIN', 280915),
(461822, 'PS00777', NULL, 'Glycosyl hydrolases family 11 (GH11) active site signature 2.', NULL, NULL, 'GH11_2', 280916),
(461823, 'PS01231', NULL, 'RNA methyltransferase trmA family signature 2.', NULL, NULL, 'TRMA_2', 280917),
(461824, 'PS00062', NULL, 'Aldo/keto reductase family signature 2.', NULL, NULL, 'ALDOKETO_REDUCTASE_2', 280918),
(461825, 'PS00300', NULL, 'SRP54-type proteins GTP-binding domain signature.', NULL, NULL, 'SRP54', 280919),
(461826, 'PS00331', NULL, 'Malic enzymes signature.', NULL, NULL, 'MALIC_ENZYMES', 280920),
(461827, 'PS00160', NULL, 'KDPG and KHG aldolases Schiff-base forming residue.', NULL, NULL, 'ALDOLASE_KDPG_KHG_2', 280921),
(461828, 'PS00417', NULL, 'Synaptobrevin signature.', NULL, NULL, 'SYNAPTOBREVIN', 280922),
(461829, 'PS00745', NULL, 'Prokaryotic-type class I peptide chain release factors signature.', NULL, NULL, 'RF_PROK_I', 280923),
(461830, 'PS00071', NULL, 'Glyceraldehyde 3-phosphate dehydrogenase active site.', NULL, NULL, 'GAPDH', 280924),
(461831, 'PS00473', NULL, 'Gonadotropin-releasing hormones signature.', NULL, NULL, 'GNRH', 280925),
(461832, 'PS00889', NULL, 'Cyclic nucleotide-binding domain signature 2.', NULL, NULL, 'CNMP_BINDING_2', 280926),
(461833, 'PS00219', NULL, 'Anion exchangers family signature 1.', NULL, NULL, 'ANION_EXCHANGER_1', 280927),
(461834, 'PS00613', NULL, 'Osteonectin domain signature 2.', NULL, NULL, 'OSTEONECTIN_2', 280928),
(461835, 'PS01085', NULL, 'Ribulose-phosphate 3-epimerase family signature 1.', NULL, NULL, 'RIBUL_P_3_EPIMER_1', 280929),
(461836, 'PS00875', NULL, 'Bacterial type II secretion system protein D signature.', NULL, NULL, 'T2SP_D', 280930),
(461837, 'PS60017', NULL, 'Omega-atracotoxin (ACTX) type 2 family signature.', NULL, NULL, 'OMEGA_ACTX_2', 280931),
(461838, 'PS00357', NULL, 'Histone H2B signature.', NULL, NULL, 'HISTONE_H2B', 280932),
(461839, 'PS01036', NULL, 'Heat shock hsp70 proteins family signature 3.', NULL, NULL, 'HSP70_3', 280933),
(461840, 'PS00816', NULL, 'Alpha-isopropylmalate and homocitrate synthases signature 2.', NULL, NULL, 'AIPM_HOMOCIT_SYNTH_2', 280934),
(461841, 'PS00784', NULL, 'Ribosomal protein L34 signature.', NULL, NULL, 'RIBOSOMAL_L34', 280935),
(461842, 'PS01290', NULL, 'Enhancer of rudimentary signature.', NULL, NULL, 'ER', 280936),
(461843, 'PS00831', NULL, 'Ribosomal protein L27 signature.', NULL, NULL, 'RIBOSOMAL_L27', 280937),
(461844, 'PS01029', NULL, 'Dehydroquinase class II signature.', NULL, NULL, 'DEHYDROQUINASE_II', 280938),
(461845, 'PS00967', NULL, 'Neuromedin U signature.', NULL, NULL, 'NMU', 280939),
(461846, 'PS00488', NULL, 'Phenylalanine and histidine ammonia-lyases signature.', NULL, NULL, 'PAL_HISTIDASE', 280940),
(461847, 'PS00048', NULL, 'Protamine P1 signature.', NULL, NULL, 'PROTAMINE_P1', 280941),
(461848, 'PS00986', NULL, 'Spermadhesins family signature 2.', NULL, NULL, 'SPERMADHESIN_2', 280942);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(461849, 'PS01083', NULL, 'DNA photolyases class 2 signature 1.', NULL, NULL, 'DNA_PHOTOLYASES_2_1', 280943),
(461850, 'PS00277', NULL, 'Staphylococcal enterotoxin/Streptococcal pyrogenic exotoxin signature 1.', NULL, NULL, 'STAPH_STREP_TOXIN_1', 280944),
(461851, 'PS00799', NULL, 'Granulins signature.', NULL, NULL, 'GRANULINS', 280945),
(461852, 'PS00996', NULL, 'Ribosomal protein S21e signature.', NULL, NULL, 'RIBOSOMAL_S21E', 280946),
(461853, 'PS00121', NULL, 'Colipase signature.', NULL, NULL, 'COLIPASE_1', 280947),
(461854, 'PS00801', NULL, 'Transketolase signature 1.', NULL, NULL, 'TRANSKETOLASE_1', 280948),
(461855, 'PS01267', NULL, 'Uncharacterized protein family UPF0023 signature.', NULL, NULL, 'UPF0023', 280949),
(461856, 'PS00707', NULL, 'Glycosyl hydrolases family 31 signature 2.', NULL, NULL, 'GLYCOSYL_HYDROL_F31_2', 280950),
(461857, 'PS00944', NULL, 'Cyclin-dependent kinases regulatory subunits signature 1.', NULL, NULL, 'CKS_1', 280951),
(461858, 'PS00211', NULL, 'ABC transporters family signature.', NULL, NULL, 'ABC_TRANSPORTER_1', 280952),
(461859, 'PS00338', NULL, 'Somatotropin, prolactin and related hormones signature 2.', NULL, NULL, 'SOMATOTROPIN_2', 280953),
(461860, 'PS01055', NULL, 'NAD-dependent DNA ligase signature 1.', NULL, NULL, 'DNA_LIGASE_N1', 280954),
(461861, 'PS00377', NULL, 'S-adenosylmethionine synthase signature 2.', NULL, NULL, 'ADOMET_SYNTHASE_2', 280955),
(461862, 'PS00713', NULL, 'Sodium:dicarboxylate symporter family signature 1.', NULL, NULL, 'NA_DICARBOXYL_SYMP_1', 280956),
(461863, 'PS00758', NULL, 'ArgE / dapE / ACY1 / CPG2 / yscS family signature 1.', NULL, NULL, 'ARGE_DAPE_CPG2_1', 280957),
(461864, 'PS00125', NULL, 'Serine/threonine specific protein phosphatases signature.', NULL, NULL, 'SER_THR_PHOSPHATASE', 280958),
(461865, 'PS01102', NULL, 'Prokaryotic dksA C4-type zinc finger.', NULL, NULL, 'ZF_DKSA_1', 280959),
(461866, 'PS01154', NULL, 'RNA polymerases L / 13 to 16 Kd subunits signature.', NULL, NULL, 'RNA_POL_L_13KD', 280960),
(461867, 'PS00581', NULL, 'Clathrin light chain signature 2.', NULL, NULL, 'CLATHRIN_LIGHT_CHN_2', 280961),
(461868, 'PS00542', NULL, 'Respiratory chain NADH dehydrogenase 30 Kd subunit signature.', NULL, NULL, 'COMPLEX1_30K', 280962),
(461869, 'PS01075', NULL, 'Acetate and butyrate kinases family signature 1.', NULL, NULL, 'ACETATE_KINASE_1', 280963),
(461870, 'PS00373', NULL, 'Phosphoribosylglycinamide formyltransferase active site.', NULL, NULL, 'GART', 280964),
(461871, 'PS00492', NULL, 'Clusterin signature 1.', NULL, NULL, 'CLUSTERIN_1', 280965),
(461872, 'PS01101', NULL, 'Casein kinase II regulatory subunit signature.', NULL, NULL, 'CK2_BETA', 280966),
(461873, 'PS00749', NULL, 'F-actin capping protein alpha subunit signature 2.', NULL, NULL, 'F_ACTIN_CAPPING_A_2', 280967),
(461874, 'PS00587', NULL, 'Glycosyl hydrolases family 17 signature.', NULL, NULL, 'GLYCOSYL_HYDROL_F17', 280968),
(461875, 'PS00641', NULL, 'Respiratory-chain NADH dehydrogenase 75 Kd subunit signature 1.', NULL, NULL, 'COMPLEX1_75K_1', 280969),
(461876, 'PS01329', NULL, 'Cytochrome c oxidase subunit VIa signature.', NULL, NULL, 'COX6A', 280970),
(461877, 'PS00256', NULL, 'Adipokinetic hormone family signature.', NULL, NULL, 'AKH', 280971),
(461878, 'PS00005', NULL, 'Protein kinase C phosphorylation site.', NULL, NULL, 'PKC_PHOSPHO_SITE', 280972),
(461879, 'PS00812', NULL, 'Glycosyl hydrolases family 8 signature.', NULL, NULL, 'GLYCOSYL_HYDROL_F8', 280973),
(461880, 'PS00050', NULL, 'Ribosomal protein L23 signature.', NULL, NULL, 'RIBOSOMAL_L23', 280974),
(461881, 'PS00149', NULL, 'Sulfatases signature 2.', NULL, NULL, 'SULFATASE_2', 280975),
(461882, 'PS00389', NULL, 'ATP synthase delta (OSCP) subunit signature.', NULL, NULL, 'ATPASE_DELTA', 280976),
(461883, 'PS00832', NULL, '2''-5''-oligoadenylate synthases signature 1.', NULL, NULL, '25A_SYNTH_1', 280977),
(461884, 'PS00535', NULL, 'Respiratory chain NADH dehydrogenase 49 Kd subunit signature.', NULL, NULL, 'COMPLEX1_49K', 280978),
(461885, 'PS00775', NULL, 'Glycosyl hydrolases family 3 active site.', NULL, NULL, 'GLYCOSYL_HYDROL_F3', 280979);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(461886, 'PS00519', NULL, 'AsnC-type HTH domain signature.', NULL, NULL, 'HTH_ASNC_1', 280980),
(461887, 'PS01249', NULL, 'Hydrogenases expression/synthesis hypA family signature.', NULL, NULL, 'HYPA', 280981),
(461888, 'PS00592', NULL, 'Glycosyl hydrolases family 9 (GH9) active site signature 2.', NULL, NULL, 'GH9_2', 280982),
(461889, 'PS00883', NULL, 'Nickel-dependent hydrogenases b-type cytochrome subunit signature 2.', NULL, NULL, 'NI_HGENASE_CYTB_2', 280983),
(461890, 'PS00525', NULL, 'Ribosomal protein L6 signature 1.', NULL, NULL, 'RIBOSOMAL_L6_1', 280984),
(461891, 'PS00618', NULL, 'RecF protein signature 2.', NULL, NULL, 'RECF_2', 280985),
(461892, 'PS00683', NULL, 'Rhodanese C-terminal signature.', NULL, NULL, 'RHODANESE_2', 280986),
(461893, 'PS00035', NULL, 'POU-specific (POUs) domain signature 1.', NULL, NULL, 'POU_1', 280987),
(461894, 'PS01266', NULL, 'Adenylosuccinate synthetase GTP-binding site.', NULL, NULL, 'ADENYLOSUCCIN_SYN_1', 280988),
(461895, 'PS00863', NULL, 'Calsequestrin signature 1.', NULL, NULL, 'CALSEQUESTRIN_1', 280989),
(461896, 'PS00135', NULL, 'Serine proteases, trypsin family, serine active site.', NULL, NULL, 'TRYPSIN_SER', 280990),
(461897, 'PS00358', NULL, 'Ribosomal protein L5 signature.', NULL, NULL, 'RIBOSOMAL_L5', 280991),
(461898, 'PS00346', NULL, 'Ets-domain signature 2.', NULL, NULL, 'ETS_DOMAIN_2', 280992),
(461899, 'PS00418', NULL, 'Potexviruses and carlaviruses coat protein signature.', NULL, NULL, 'POTEX_CARLAVIRUS_COAT', 280993),
(461900, 'PS00391', NULL, 'Sodium and potassium ATPases beta subunits signature 2.', NULL, NULL, 'ATPASE_NA_K_BETA_2', 280994),
(461901, 'PS00677', NULL, 'D-amino acid oxidases signature.', NULL, NULL, 'DAO', 280995),
(461902, 'PS00567', NULL, 'Phosphoribulokinase signature.', NULL, NULL, 'PHOSPHORIBULOKINASE', 280996),
(461903, 'PS01201', NULL, 'Tub family signature 2.', NULL, NULL, 'TUB_2', 280997),
(461904, 'PS01218', NULL, 'TatC family signature.', NULL, NULL, 'TATC', 280998),
(461905, 'PS00508', NULL, 'Nickel-dependent hydrogenases large subunit signature 2.', NULL, NULL, 'NI_HGENASE_L_2', 280999),
(461906, 'PS00825', NULL, 'Elongation factor 1 beta/beta''/delta chain signature 2.', NULL, NULL, 'EF1BD_2', 281000),
(461907, 'PS00299', NULL, 'Ubiquitin domain signature.', NULL, NULL, 'UBIQUITIN_1', 281001),
(461908, 'PS00311', NULL, 'LAMP glycoproteins transmembrane and cytoplasmic domain signature.', NULL, NULL, 'LAMP_2', 281002),
(461909, 'PS00175', NULL, 'Phosphoglycerate mutase family phosphohistidine signature.', NULL, NULL, 'PG_MUTASE', 281003),
(461910, 'PS01061', NULL, 'Flagella transport protein fliP family signature 2.', NULL, NULL, 'FLIP_2', 281004),
(461911, 'PS00165', NULL, 'Serine/threonine dehydratases pyridoxal-phosphate attachment site.', NULL, NULL, 'DEHYDRATASE_SER_THR', 281005),
(461912, 'PS01319', NULL, 'Ribosome-binding factor A signature.', NULL, NULL, 'RBFA', 281006),
(461913, 'PS00237', NULL, 'G-protein coupled receptors family 1 signature.', NULL, NULL, 'G_PROTEIN_RECEP_F1_1', 281007),
(461914, 'PS00684', NULL, 'Small, acid-soluble spore proteins, alpha/beta type, signature 2.', NULL, NULL, 'SASP_2', 281008),
(461915, 'PS00819', NULL, 'Dps protein family signature 2.', NULL, NULL, 'DPS_2', 281009),
(461916, 'PS01268', NULL, 'Uncharacterized protein family UPF0024 signature.', NULL, NULL, 'UPF0024', 281010),
(461917, 'PS00164', NULL, 'Enolase signature.', NULL, NULL, 'ENOLASE', 281011),
(461918, 'PS00985', NULL, 'Spermadhesins family signature 1.', NULL, NULL, 'SPERMADHESIN_1', 281012),
(461919, 'PS00103', NULL, 'Purine/pyrimidine phosphoribosyl transferases signature.', NULL, NULL, 'PUR_PYR_PR_TRANSFER', 281013),
(461920, 'PS00480', NULL, 'Citrate synthase signature.', NULL, NULL, 'CITRATE_SYNTHASE', 281014),
(461921, 'PS01354', NULL, 'Long hematopoietin receptor, soluble alpha chains family signature.', NULL, NULL, 'HEMATOPO_REC_L_F3', 281015),
(461922, 'PS00999', NULL, 'Streptomyces subtilisin-type inhibitors signature.', NULL, NULL, 'SSI', 281016),
(461923, 'PS01314', NULL, 'Uncharacterized protein family UPF0047 signature.', NULL, NULL, 'UPF0047', 281017);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(461924, 'PS00208', NULL, 'Plant hemoglobins signature.', NULL, NULL, 'PLANT_GLOBIN', 281018),
(461925, 'PS60029', NULL, 'Spider toxin CSTX family signature.', NULL, NULL, 'SPIDER_CSTX', 281019),
(461926, 'PS00399', NULL, 'ATP-citrate lyase / succinyl-CoA ligases family active site.', NULL, NULL, 'SUCCINYL_COA_LIG_2', 281020),
(461927, 'PS00767', NULL, 'Tetrahydrofolate dehydrogenase/cyclohydrolase signature 2.', NULL, NULL, 'THF_DHG_CYH_2', 281021),
(461928, 'PS00115', NULL, 'Eukaryotic RNA polymerase II heptapeptide repeat.', NULL, NULL, 'RNA_POL_II_REPEAT', 281022),
(461929, 'PS00295', NULL, 'Arrestins signature.', NULL, NULL, 'ARRESTINS', 281023),
(461930, 'PS00866', NULL, 'Carbamoyl-phosphate synthase subdomain signature 1.', NULL, NULL, 'CPSASE_1', 281024),
(461931, 'PS01131', NULL, 'Ribosomal RNA adenine dimethylases signature.', NULL, NULL, 'RRNA_A_DIMETH', 281025),
(461932, 'PS00450', NULL, 'Aconitase family signature 1.', NULL, NULL, 'ACONITASE_1', 281026),
(461933, 'PS00679', NULL, 'Beta-amylase active site 2.', NULL, NULL, 'BETA_AMYLASE_2', 281027),
(461934, 'PS00813', NULL, 'Eukaryotic initiation factor 4E signature.', NULL, NULL, 'IF4E', 281028),
(461935, 'PS00059', NULL, 'Zinc-containing alcohol dehydrogenases signature.', NULL, NULL, 'ADH_ZINC', 281029),
(461936, 'PS01103', NULL, 'Aspartate-semialdehyde dehydrogenase signature.', NULL, NULL, 'ASD', 281030),
(461937, 'PS00527', NULL, 'Ribosomal protein S14 signature.', NULL, NULL, 'RIBOSOMAL_S14', 281031),
(461938, 'PS00926', NULL, 'Lysyl oxidase putative copper-binding region signature.', NULL, NULL, 'LYSYL_OXIDASE', 281032),
(461939, 'PS00837', NULL, 'Alanine dehydrogenase & pyridine nucleotide transhydrogenase signature 2.', NULL, NULL, 'ALADH_PNT_2', 281033),
(461940, 'PS00965', NULL, 'Phosphomannose isomerase type I signature 1.', NULL, NULL, 'PMI_I_1', 281034),
(461941, 'PS00779', NULL, 'Glycoprotein hormones alpha chain signature 1.', NULL, NULL, 'GLYCO_HORMONE_ALPHA_1', 281035),
(461942, 'PS01119', NULL, 'Copper-fist DNA-binding domain signature.', NULL, NULL, 'COPPER_FIST_1', 281036),
(461943, 'PS01000', NULL, 'Succinate dehydrogenase cytochrome b subunit signature 1.', NULL, NULL, 'SDH_CYT_1', 281037),
(461944, 'PS01089', NULL, 'CAP protein signature 2.', NULL, NULL, 'CAP_2', 281038),
(461945, 'PS00810', NULL, 'ADP-glucose pyrophosphorylase signature 3.', NULL, NULL, 'ADP_GLC_PYROPHOSPH_3', 281039),
(461946, 'PS00557', NULL, 'FMN-dependent alpha-hydroxy acid dehydrogenases active site.', NULL, NULL, 'FMN_HYDROXY_ACID_DH_1', 281040),
(461947, 'PS01168', NULL, 'Ribosomal protein S27e signature.', NULL, NULL, 'RIBOSOMAL_S27E', 281041),
(461948, 'PS01230', NULL, 'RNA methyltransferase trmA family signature 1.', NULL, NULL, 'TRMA_1', 281042),
(461949, 'PS00601', NULL, 'IRF tryptophan pentad repeat DNA-binding domain signature.', NULL, NULL, 'IRF_1', 281043),
(461950, 'PS01062', NULL, 'Hydroxymethylglutaryl-coenzyme A lyase active site.', NULL, NULL, 'HMG_COA_LYASE', 281044),
(461951, 'PS00521', NULL, 'Delta 1-pyrroline-5-carboxylate reductase signature.', NULL, NULL, 'P5CR', 281045),
(461952, 'PS01141', NULL, 'Bacterial type II secretion system protein C signature.', NULL, NULL, 'T2SP_C', 281046),
(461953, 'PS01224', NULL, 'N-acetyl-gamma-glutamyl-phosphate reductase active site.', NULL, NULL, 'ARGC', 281047),
(461954, 'PS00933', NULL, 'FGGY family of carbohydrate kinases signature 1.', NULL, NULL, 'FGGY_KINASES_1', 281048),
(461955, 'PS00717', NULL, 'Sigma-54 factors family signature 1.', NULL, NULL, 'SIGMA54_1', 281049),
(461956, 'PS00792', NULL, 'Dihydropteroate synthase signature 1.', NULL, NULL, 'DHPS_1', 281050),
(461957, 'PS00280', NULL, 'Pancreatic trypsin inhibitor (Kunitz) family signature.', NULL, NULL, 'BPTI_KUNITZ_1', 281051),
(461958, 'PS01049', NULL, 'YjeF C-terminal domain signature 1.', NULL, NULL, 'YJEF_C_1', 281052),
(461959, 'PS00466', NULL, 'Zinc finger TFIIS-type signature.', NULL, NULL, 'ZF_TFIIS_1', 281053),
(461960, 'PS00066', NULL, 'Hydroxymethylglutaryl-coenzyme A reductases signature 1.', NULL, NULL, 'HMG_COA_REDUCTASE_1', 281054);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(461961, 'PS00098', NULL, 'Thiolases acyl-enzyme intermediate signature.', NULL, NULL, 'THIOLASE_1', 281055),
(461962, 'PS01159', NULL, 'WW/rsp5/WWP domain signature.', NULL, NULL, 'WW_DOMAIN_1', 281056),
(461963, 'PS00938', NULL, 'Initiation factor 3 signature.', NULL, NULL, 'IF3', 281057),
(461964, 'PS01349', NULL, 'Nodulation protein nodA signature.', NULL, NULL, 'NODA', 281058),
(461965, 'PS00381', NULL, 'Endopeptidase Clp serine active site.', NULL, NULL, 'CLP_PROTEASE_SER', 281059),
(461966, 'PS01242', NULL, 'Zinc finger FPG-type signature.', NULL, NULL, 'ZF_FPG_1', 281060),
(461967, 'PS00635', NULL, 'Gram-negative pili assembly chaperone signature.', NULL, NULL, 'PILI_CHAPERONE', 281061),
(461968, 'PS01252', NULL, 'Endogenous opioids neuropeptides precursors signature.', NULL, NULL, 'OPIOIDS_PRECURSOR', 281062),
(461969, 'PS00629', NULL, 'Inositol monophosphatase family signature 1.', NULL, NULL, 'IMP_1', 281063),
(461970, 'PS00726', NULL, 'AP endonucleases family 1 signature 1.', NULL, NULL, 'AP_NUCLEASE_F1_1', 281064),
(461971, 'PS01148', NULL, 'Uncharacterized protein family UPF0033 signature.', NULL, NULL, 'UPF0033', 281065),
(461972, 'PS00764', NULL, 'Endonuclease III iron-sulfur binding region signature.', NULL, NULL, 'ENDONUCLEASE_III_1', 281066),
(461973, 'PS00782', NULL, 'Transcription factor TFIIB repeat signature.', NULL, NULL, 'TFIIB', 281067),
(461974, 'PS00407', NULL, 'Connexins signature 1.', NULL, NULL, 'CONNEXINS_1', 281068),
(461975, 'PS00793', NULL, 'Dihydropteroate synthase signature 2.', NULL, NULL, 'DHPS_2', 281069),
(461976, 'PS00932', NULL, 'Prokaryotic molybdopterin oxidoreductases signature 3.', NULL, NULL, 'MOLYBDOPTERIN_PROK_3', 281070),
(461977, 'PS01351', NULL, 'MAP kinase signature.', NULL, NULL, 'MAPK', 281071),
(461978, 'PS00416', NULL, 'Synapsins signature 2.', NULL, NULL, 'SYNAPSIN_2', 281072),
(461979, 'PS00645', NULL, 'Respiratory-chain NADH dehydrogenase 51 Kd subunit signature 2.', NULL, NULL, 'COMPLEX1_51K_2', 281073),
(461980, 'PS00612', NULL, 'Osteonectin domain signature 1.', NULL, NULL, 'OSTEONECTIN_1', 281074),
(461981, 'PS01079', NULL, 'Molybdenum cofactor biosynthesis proteins signature 2.', NULL, NULL, 'MOCF_BIOSYNTHESIS_2', 281075),
(461982, 'PS01337', NULL, 'Ornithine decarboxylase antizyme signature.', NULL, NULL, 'ODC_AZ', 281076),
(461983, 'PS00916', NULL, 'Phosphatidylinositol 3- and 4-kinases signature 2.', NULL, NULL, 'PI3_4_KINASE_2', 281077),
(461984, 'PS00993', NULL, 'Ribosomal protein L30e signature 2.', NULL, NULL, 'RIBOSOMAL_L30E_2', 281078),
(461985, 'PS00706', NULL, 'Prion protein signature 2.', NULL, NULL, 'PRION_2', 281079),
(461986, 'PS00124', NULL, 'Fructose-1-6-bisphosphatase active site.', NULL, NULL, 'FBPASE', 281080),
(461987, 'PS00979', NULL, 'G-protein coupled receptors family 3 signature 1.', NULL, NULL, 'G_PROTEIN_RECEP_F3_1', 281081),
(461988, 'PS00376', NULL, 'S-adenosylmethionine synthase signature 1.', NULL, NULL, 'ADOMET_SYNTHASE_1', 281082),
(461989, 'PS00743', NULL, 'Beta-lactamases class B signature 1.', NULL, NULL, 'BETA_LACTAMASE_B_1', 281083),
(461990, 'PS00333', NULL, 'ATP-dependent DNA ligase signature 2.', NULL, NULL, 'DNA_LIGASE_A2', 281084),
(461991, 'PS00371', NULL, 'PTS EIIA domains phosphorylation site signature 1.', NULL, NULL, 'PTS_EIIA_TYPE_1_HIS', 281085),
(461992, 'PS01214', NULL, 'Uncharacterized protein family UPF0016 signature.', NULL, NULL, 'UPF0016', 281086),
(461993, 'PS01151', NULL, 'Fimbrial biogenesis outer membrane usher protein signature.', NULL, NULL, 'FIMBRIAL_USHER', 281087),
(461994, 'PS00007', NULL, 'Tyrosine kinase phosphorylation site 1.', NULL, NULL, 'TYR_PHOSPHO_SITE_1', 281088),
(461995, 'PS00246', NULL, 'Wnt-1 family signature.', NULL, NULL, 'WNT1', 281089),
(461996, 'PS00150', NULL, 'Acylphosphatase signature 1.', NULL, NULL, 'ACYLPHOSPHATASE_1', 281090),
(461997, 'PS00258', NULL, 'Calcitonin / CGRP / IAPP family signature.', NULL, NULL, 'CALCITONIN', 281091),
(461998, 'PS01203', NULL, 'BTG family signature 2.', NULL, NULL, 'BTG_2', 281092),
(461999, 'PS60015', NULL, 'Mu-agatoxin family signature.', NULL, NULL, 'MU_AGATOXIN', 281093); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(462000, 'PS00108', NULL, 'Serine/Threonine protein kinases active-site signature.', NULL, NULL, 'PROTEIN_KINASE_ST', 281094),
(462001, 'PS00355', NULL, 'HMG14 and HMG17 signature.', NULL, NULL, 'HMG14_17', 281095),
(462002, 'PS01130', NULL, 'SLC26A transporters signature.', NULL, NULL, 'SLC26A', 281096),
(462003, 'PS00204', NULL, 'Ferritin iron-binding regions signature 2.', NULL, NULL, 'FERRITIN_2', 281097),
(462004, 'PS00918', NULL, 'Deoxyribonuclease I signature 2.', NULL, NULL, 'DNASE_I_2', 281098),
(462005, 'PS01306', NULL, 'Uncharacterized protein family UPF0054 signature.', NULL, NULL, 'UPF0054', 281099),
(462006, 'PS00461', NULL, '6-phosphogluconate dehydrogenase signature.', NULL, NULL, '6PGD', 281100),
(462007, 'PS00129', NULL, 'Glycosyl hydrolases family 31 active site.', NULL, NULL, 'GLYCOSYL_HYDROL_F31_1', 281101),
(462008, 'PS00646', NULL, 'Ribosomal protein S13 signature.', NULL, NULL, 'RIBOSOMAL_S13_1', 281102),
(462009, 'PS00897', NULL, 'LacY family proton/sugar symporters signature 2.', NULL, NULL, 'LACY_2', 281103),
(462010, 'PS01327', NULL, 'Large-conductance mechanosensitive channels mscL family signature.', NULL, NULL, 'MSCL', 281104),
(462011, 'PS00462', NULL, 'Gamma-glutamyltranspeptidase signature.', NULL, NULL, 'G_GLU_TRANSPEPTIDASE', 281105),
(462012, 'PS00826', NULL, 'MARCKS family signature 1.', NULL, NULL, 'MARCKS_1', 281106),
(462013, 'PS01122', NULL, 'Caspase family cysteine active site.', NULL, NULL, 'CASPASE_CYS', 281107),
(462014, 'PS01099', NULL, 'Respiratory-chain NADH dehydrogenase 24 Kd subunit signature.', NULL, NULL, 'COMPLEX1_24K', 281108),
(462015, 'PS01358', NULL, 'Zinc finger RanBP2-type signature.', NULL, NULL, 'ZF_RANBP2_1', 281109),
(462016, 'PS00893', NULL, 'Nudix box signature.', NULL, NULL, 'NUDIX_BOX', 281110),
(462017, 'PS00723', NULL, 'Polyprenyl synthases signature 1.', NULL, NULL, 'POLYPRENYL_SYNTHASE_1', 281111),
(462018, 'PS00080', NULL, 'Multicopper oxidases signature 2.', NULL, NULL, 'MULTICOPPER_OXIDASE2', 281112),
(462019, 'PS00778', NULL, 'Histidine acid phosphatases active site signature.', NULL, NULL, 'HIS_ACID_PHOSPHAT_2', 281113),
(462020, 'PS01034', NULL, 'Glycosyl hydrolases family 16 active sites.', NULL, NULL, 'GH16_1', 281114),
(462021, 'PS00345', NULL, 'Ets-domain signature 1.', NULL, NULL, 'ETS_DOMAIN_1', 281115),
(462022, 'PS00877', NULL, 'Indoleamine 2,3-dioxygenase signature 2.', NULL, NULL, 'IDO_2', 281116),
(462023, 'PS00930', NULL, 'Peripherin / rom-1 signature.', NULL, NULL, 'RDS_ROM1', 281117),
(462024, 'PS01321', NULL, 'Crossover junction endodeoxyribonuclease ruvC signature.', NULL, NULL, 'RUVC', 281118),
(462025, 'PS00556', NULL, 'Hok/gef family cell toxic proteins signature.', NULL, NULL, 'HOK_GEF', 281119),
(462026, 'PS00823', NULL, 'Dehydrins signature 2.', NULL, NULL, 'DEHYDRIN_2', 281120),
(462027, 'PS00210', NULL, 'Arthropod hemocyanins / insect LSPs signature 2.', NULL, NULL, 'HEMOCYANIN_2', 281121),
(462028, 'PS00273', NULL, 'Heat-stable enterotoxins signature.', NULL, NULL, 'ENTEROTOXIN_H_STABLE', 281122),
(462029, 'PS00475', NULL, 'Ribosomal protein L15 signature.', NULL, NULL, 'RIBOSOMAL_L15', 281123),
(462030, 'PS00978', NULL, 'FAD-dependent glycerol-3-phosphate dehydrogenase signature 2.', NULL, NULL, 'FAD_G3PDH_2', 281124),
(462031, 'PS01293', NULL, 'Nudix CoA signature.', NULL, NULL, 'NUDIX_COA', 281125),
(462032, 'PS00213', NULL, 'Lipocalin signature.', NULL, NULL, 'LIPOCALIN', 281126),
(462033, 'PS60020', NULL, 'Janus-faced atracotoxin (J-ACTX) family signature.', NULL, NULL, 'J_ACTX', 281127),
(462034, 'PS01145', NULL, 'Ribosomal protein L34e signature.', NULL, NULL, 'RIBOSOMAL_L34E', 281128),
(462035, 'PS00448', NULL, 'Clostridium cellulosome enzymes repeated domain signature.', NULL, NULL, 'CLOS_CELLULOSOME_RPT', 281129),
(462036, 'PS00867', NULL, 'Carbamoyl-phosphate synthase subdomain signature 2.', NULL, NULL, 'CPSASE_2', 281130),
(462037, 'PS01353', NULL, 'Long hematopoietin receptor, gp130 family signature.', NULL, NULL, 'HEMATOPO_REC_L_F2', 281131),
(462038, 'PS00214', NULL, 'Cytosolic fatty-acid binding proteins signature.', NULL, NULL, 'FABP', 281132);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(462039, 'PS00174', NULL, 'Phosphoglucose isomerase signature 2.', NULL, NULL, 'P_GLUCOSE_ISOMERASE_2', 281133),
(462040, 'PS00607', NULL, 'cAMP phosphodiesterases class-II signature.', NULL, NULL, 'PDEASE_II', 281134),
(462041, 'PS00622', NULL, 'LuxR-type HTH domain signature.', NULL, NULL, 'HTH_LUXR_1', 281135),
(462042, 'PS01344', NULL, 'Frataxin family signature.', NULL, NULL, 'FRATAXIN_1', 281136),
(462043, 'PS00294', NULL, 'Prenyl group binding site (CAAX box).', NULL, NULL, 'PRENYLATION', 281137),
(462044, 'PS00510', NULL, 'Malate synthase signature.', NULL, NULL, 'MALATE_SYNTHASE', 281138),
(462045, 'PS00624', NULL, 'GMC oxidoreductases signature 2.', NULL, NULL, 'GMC_OXRED_2', 281139),
(462046, 'PS00182', NULL, 'Glutamine synthetase class-I adenylation site.', NULL, NULL, 'GLNA_ADENYLATION', 281140),
(462047, 'PS00319', NULL, 'Amyloid precursor protein (APP) copper-binding (CuBD) domain signature.', NULL, NULL, 'APP_CUBD', 281141),
(462048, 'PS00405', NULL, '43 Kd postsynaptic protein signature.', NULL, NULL, '43_KD_POSTSYNAPTIC', 281142),
(462049, 'PS00565', NULL, 'Argininosuccinate synthase signature 2.', NULL, NULL, 'ARGININOSUCCIN_SYN_2', 281143),
(462050, 'PS00022', NULL, 'EGF-like domain signature 1.', NULL, NULL, 'EGF_1', 281144),
(462051, 'PS00387', NULL, 'Inorganic pyrophosphatase signature.', NULL, NULL, 'PPASE', 281145),
(462052, 'PS01138', NULL, 'Scorpion short toxins signature.', NULL, NULL, 'SCORP_SHORT_TOXIN', 281146),
(462053, 'PS01345', NULL, 'COE family signature.', NULL, NULL, 'COE', 281147),
(462054, 'PS00426', NULL, 'Cereal trypsin/alpha-amylase inhibitors family signature.', NULL, NULL, 'CEREAL_TRYP_AMYL_INH', 281148),
(462055, 'PS00006', NULL, 'Casein kinase II phosphorylation site.', NULL, NULL, 'CK2_PHOSPHO_SITE', 281149),
(462056, 'PS00122', NULL, 'Carboxylesterases type-B serine active site.', NULL, NULL, 'CARBOXYLESTERASE_B_1', 281150),
(462057, 'PS01100', NULL, 'NNMT/PNMT/TEMT family of methyltransferases signature.', NULL, NULL, 'NNMT_PNMT_TEMT', 281151),
(462058, 'PS00439', NULL, 'Acyltransferases ChoActase / COT / CPT family signature 1.', NULL, NULL, 'ACYLTRANSF_C_1', 281152),
(462059, 'PS00748', NULL, 'F-actin capping protein alpha subunit signature 1.', NULL, NULL, 'F_ACTIN_CAPPING_A_1', 281153),
(462060, 'PS01246', NULL, 'Uncharacterized protein family UPF0003 signature.', NULL, NULL, 'UPF0003', 281154),
(462061, 'PS01339', NULL, 'SURF4 family signature.', NULL, NULL, 'SURF4', 281155),
(462062, 'PS00856', NULL, 'Guanylate kinase-like signature.', NULL, NULL, 'GUANYLATE_KINASE_1', 281156),
(462063, 'PS00034', NULL, 'Paired DNA-binding domain signature.', NULL, NULL, 'PAIRED_1', 281157),
(462064, 'PS00434', NULL, 'HSF-type DNA-binding domain signature.', NULL, NULL, 'HSF_DOMAIN', 281158),
(462065, 'PS01157', NULL, 'Class A bacterial acid phosphatases signature.', NULL, NULL, 'ACID_PHOSPH_CL_A', 281159),
(462066, 'PS01245', NULL, 'RIO1/ZK632.3/MJ0444 family signature.', NULL, NULL, 'RIO1', 281160),
(462067, 'PS00235', NULL, 'Gas vesicles protein GVPc repeated domain signature.', NULL, NULL, 'GAS_VESICLE_C', 281161),
(462068, 'PS00561', NULL, 'CBM2a (carbohydrate-binding type-2) domain signature.', NULL, NULL, 'CBM2_A', 281162),
(462069, 'PS01328', NULL, '4-hydroxybenzoyl-CoA thioesterase family active site.', NULL, NULL, '4HBCOA_THIOESTERASE', 281163),
(462070, 'PS00714', NULL, 'Sodium:dicarboxylate symporter family signature 2.', NULL, NULL, 'NA_DICARBOXYL_SYMP_2', 281164),
(462071, 'PS01256', NULL, 'Cullin family signature.', NULL, NULL, 'CULLIN_1', 281165),
(462072, 'PS00732', NULL, 'Ribosomal protein S16 signature.', NULL, NULL, 'RIBOSOMAL_S16', 281166),
(462073, 'PS00864', NULL, 'Calsequestrin signature 2.', NULL, NULL, 'CALSEQUESTRIN_2', 281167),
(462074, 'PS00990', NULL, 'Clathrin adaptor complexes medium chain signature 1.', NULL, NULL, 'CLAT_ADAPTOR_M_1', 281168),
(462075, 'PS00020', NULL, 'Actinin-type actin-binding domain signature 2.', NULL, NULL, 'ACTININ_2', 281169),
(462076, 'PS00914', NULL, 'Syntaxin / epimorphin family signature.', NULL, NULL, 'SYNTAXIN', 281170);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(462077, 'PS00342', NULL, 'Microbodies C-terminal targeting signal.', NULL, NULL, 'MICROBODIES_CTER', 281171),
(462078, 'PS00137', NULL, 'Serine proteases, subtilase family, histidine active site.', NULL, NULL, 'SUBTILASE_HIS', 281172),
(462079, 'PS00284', NULL, 'Serpins signature.', NULL, NULL, 'SERPIN', 281173),
(462080, 'PS00552', NULL, 'MerR-type HTH domain signature.', NULL, NULL, 'HTH_MERR_1', 281174),
(462081, 'PS00845', NULL, 'CAP-Gly domain signature.', NULL, NULL, 'CAP_GLY_1', 281175),
(462082, 'PS00912', NULL, 'Dihydroorotate dehydrogenase signature 2.', NULL, NULL, 'DHODEHASE_2', 281176),
(462083, 'PS01008', NULL, 'DnaA protein signature.', NULL, NULL, 'DNAA', 281177),
(462084, 'PS00522', NULL, 'DNA polymerase family X signature.', NULL, NULL, 'DNA_POLYMERASE_X', 281178),
(462085, 'PS01227', NULL, 'Uncharacterized protein family UPF0012 signature.', NULL, NULL, 'UPF0012', 281179),
(462086, 'PS01278', NULL, 'Methylthiotransferase radical SAM domain signature.', NULL, NULL, 'MTTASE_RADICAL', 281180),
(462087, 'PS00270', NULL, 'Endothelin family signature.', NULL, NULL, 'ENDOTHELIN', 281181),
(462088, 'PS00668', NULL, 'Respiratory-chain NADH dehydrogenase subunit 1 signature 2.', NULL, NULL, 'COMPLEX1_ND1_2', 281182),
(462089, 'PS00894', NULL, 'DeoR-type HTH domain signature.', NULL, NULL, 'HTH_DEOR_1', 281183),
(462090, 'PS00352', NULL, 'Cold-shock (CSD) domain signature.', NULL, NULL, 'CSD_1', 281184),
(462091, 'PS00467', NULL, 'Ribosomal protein L2 signature.', NULL, NULL, 'RIBOSOMAL_L2', 281185),
(462092, 'PS01037', NULL, 'Bacterial extracellular solute-binding proteins, family 1 signature.', NULL, NULL, 'SBP_BACTERIAL_1', 281186),
(462093, 'PS00649', NULL, 'G-protein coupled receptors family 2 signature 1.', NULL, NULL, 'G_PROTEIN_RECEP_F2_1', 281187),
(462094, 'PS00638', NULL, 'P-II protein C-terminal region signature.', NULL, NULL, 'PII_GLNB_CTER', 281188),
(462095, 'PS00260', NULL, 'Glucagon / GIP / secretin / VIP family signature.', NULL, NULL, 'GLUCAGON', 281189),
(462096, 'PS00501', NULL, 'Signal peptidases I serine active site.', NULL, NULL, 'SPASE_I_1', 281190),
(462097, 'PS00113', NULL, 'Adenylate kinase signature.', NULL, NULL, 'ADENYLATE_KINASE', 281191),
(462098, 'PS00741', NULL, 'Dbl homology (DH) domain signature.', NULL, NULL, 'DH_1', 281192),
(462099, 'PS00599', NULL, 'Aminotransferases class-II pyridoxal-phosphate attachment site.', NULL, NULL, 'AA_TRANSFER_CLASS_2', 281193),
(462100, 'PS00265', NULL, 'Pancreatic hormone family signature.', NULL, NULL, 'PANCREATIC_HORMONE_1', 281194),
(462101, 'PS00550', NULL, 'Hemerythrin family signature.', NULL, NULL, 'HEMERYTHRINS', 281195),
(462102, 'PS00296', NULL, 'Chaperonins cpn60 signature.', NULL, NULL, 'CHAPERONINS_CPN60', 281196),
(462103, 'PS00998', NULL, 'G10 protein signature 2.', NULL, NULL, 'G10_2', 281197),
(462104, 'PS00095', NULL, 'C-5 cytosine-specific DNA methylases C-terminal signature.', NULL, NULL, 'C5_MTASE_2', 281198),
(462105, 'PS00731', NULL, 'AP endonucleases family 2 signature 3.', NULL, NULL, 'AP_NUCLEASE_F2_3', 281199),
(462106, 'PS00783', NULL, 'Ribosomal protein L13 signature.', NULL, NULL, 'RIBOSOMAL_L13', 281200),
(462107, 'PS00896', NULL, 'LacY family proton/sugar symporters signature 1.', NULL, NULL, 'LACY_1', 281201),
(462108, 'PS00395', NULL, 'Alanine racemase pyridoxal-phosphate attachment site.', NULL, NULL, 'ALANINE_RACEMASE', 281202),
(462109, 'PS00253', NULL, 'Interleukin-1 signature.', NULL, NULL, 'INTERLEUKIN_1', 281203),
(462110, 'PS00420', NULL, 'SRCR domain signature.', NULL, NULL, 'SRCR_1', 281204),
(462111, 'PS00871', NULL, 'Chaperonins clpA/B signature 2.', NULL, NULL, 'CLPAB_2', 281205),
(462112, 'PS00759', NULL, 'ArgE / dapE / ACY1 / CPG2 / yscS family signature 2.', NULL, NULL, 'ARGE_DAPE_CPG2_2', 281206),
(462113, 'PS00009', NULL, 'Amidation site.', NULL, NULL, 'AMIDATION', 281207),
(462114, 'PS01140', NULL, 'Glycosyl hydrolases family 45 active site.', NULL, NULL, 'GLYCOSYL_HYDROL_F45', 281208),
(462115, 'PS00408', NULL, 'Connexins signature 2.', NULL, NULL, 'CONNEXINS_2', 281209);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(462116, 'PS00969', NULL, 'Antenna complexes beta subunits signature.', NULL, NULL, 'ANTENNA_COMP_BETA', 281210),
(462117, 'PS01087', NULL, 'Radical activating enzymes signature.', NULL, NULL, 'RADICAL_ACTIVATING', 281211),
(462118, 'PS00532', NULL, 'Phosphoenolpyruvate carboxykinase (ATP) signature.', NULL, NULL, 'PEPCK_ATP', 281212),
(462119, 'PS00229', NULL, 'Tau and MAP proteins tubulin-binding repeat signature.', NULL, NULL, 'TAU_MAP_1', 281213),
(462120, 'PS00674', NULL, 'AAA-protein family signature.', NULL, NULL, 'AAA', 281214),
(462121, 'PS00785', NULL, '5''-nucleotidase signature 1.', NULL, NULL, '5_NUCLEOTIDASE_1', 281215),
(462122, 'PS00733', NULL, 'Ribosomal protein S26e signature.', NULL, NULL, 'RIBOSOMAL_S26E', 281216),
(462123, 'PS00559', NULL, 'Eukaryotic molybdopterin oxidoreductases signature.', NULL, NULL, 'MOLYBDOPTERIN_EUK', 281217),
(462124, 'PS00092', NULL, 'N-6 Adenine-specific DNA methylases signature.', NULL, NULL, 'N6_MTASE', 281218),
(462125, 'PS00313', NULL, 'Seminal vesicle protein I repeats signature.', NULL, NULL, 'SVP_I', 281219),
(462126, 'PS00528', NULL, 'Ribosomal protein S4e signature.', NULL, NULL, 'RIBOSOMAL_S4E', 281220),
(462127, 'PS01169', NULL, 'Ribosomal protein L21 signature.', NULL, NULL, 'RIBOSOMAL_L21', 281221),
(462128, 'PS01010', NULL, 'CRISP family signature 2.', NULL, NULL, 'CRISP_2', 281222),
(462129, 'PS00138', NULL, 'Serine proteases, subtilase family, serine active site.', NULL, NULL, 'SUBTILASE_SER', 281223),
(462130, 'PS00181', NULL, 'Glutamine synthetase putative ATP-binding region signature.', NULL, NULL, 'GLNA_ATP', 281224),
(462131, 'PS00286', NULL, 'Squash family of serine protease inhibitors signature.', NULL, NULL, 'SQUASH_INHIBITOR', 281225),
(462132, 'PS00109', NULL, 'Tyrosine protein kinases specific active-site signature.', NULL, NULL, 'PROTEIN_KINASE_TYR', 281226),
(462133, 'PS00353', NULL, 'HMG box A DNA-binding domain signature.', NULL, NULL, 'HMG_BOX_1', 281227),
(462134, 'PS00623', NULL, 'GMC oxidoreductases signature 1.', NULL, NULL, 'GMC_OXRED_1', 281228),
(462135, 'PS00051', NULL, 'Ribosomal protein L39e signature.', NULL, NULL, 'RIBOSOMAL_L39E', 281229),
(462136, 'PS00459', NULL, 'Myotoxins signature.', NULL, NULL, 'MYOTOXINS_1', 281230),
(462137, 'PS00136', NULL, 'Serine proteases, subtilase family, aspartic acid active site.', NULL, NULL, 'SUBTILASE_ASP', 281231),
(462138, 'PS00134', NULL, 'Serine proteases, trypsin family, histidine active site.', NULL, NULL, 'TRYPSIN_HIS', 281232),
(462139, 'PS01078', NULL, 'Molybdenum cofactor biosynthesis proteins signature 1.', NULL, NULL, 'MOCF_BIOSYNTHESIS_1', 281233),
(462140, 'PS00308', NULL, 'Legume lectins alpha-chain signature.', NULL, NULL, 'LECTIN_LEGUME_ALPHA', 281234),
(462141, 'PS00332', NULL, 'Copper/Zinc superoxide dismutase signature 2.', NULL, NULL, 'SOD_CU_ZN_2', 281235),
(462142, 'PS00449', NULL, 'ATP synthase a subunit signature.', NULL, NULL, 'ATPASE_A', 281236),
(462143, 'PS00157', NULL, 'Ribulose bisphosphate carboxylase large chain active site.', NULL, NULL, 'RUBISCO_LARGE', 281237),
(462144, 'PS00833', NULL, '2''-5''-oligoadenylate synthases signature 2.', NULL, NULL, '25A_SYNTH_2', 281238),
(462145, 'PS60000', NULL, 'Chitosanases families 46 and 80 active sites signature.', NULL, NULL, 'CHITOSANASE_46_80', 281239),
(462146, 'PS60003', NULL, 'Phosphoketolase signature 2.', NULL, NULL, 'PHOSPHOKETOLASE_2', 281240),
(462147, 'PS00647', NULL, 'Thymidine and pyrimidine-nucleoside phosphorylases signature.', NULL, NULL, 'THYMID_PHOSPHORYLASE', 281241),
(462148, 'PS00188', NULL, 'Biotin-requiring enzymes attachment site.', NULL, NULL, 'BIOTIN', 281242),
(462149, 'PS01175', NULL, 'Ribonuclease II family signature.', NULL, NULL, 'RIBONUCLEASE_II', 281243),
(462150, 'PS00899', NULL, 'Ependymins signature 2.', NULL, NULL, 'EPENDYMIN_2', 281244),
(462151, 'PS00427', NULL, 'Disintegrins signature.', NULL, NULL, 'DISINTEGRIN_1', 281245),
(462152, 'PS00107', NULL, 'Protein kinases ATP-binding region signature.', NULL, NULL, 'PROTEIN_KINASE_ATP', 281246),
(462153, 'PS00378', NULL, 'Hexokinase domain signature.', NULL, NULL, 'HEXOKINASE_1', 281247);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(462154, 'PS00724', NULL, 'Stress-induced proteins SRP1/TIP1 family signature.', NULL, NULL, 'SRP1_TIP1', 281248),
(462155, 'PS00970', NULL, 'Nuclear transition protein 2 signature 1.', NULL, NULL, 'TP2_1', 281249),
(462156, 'PS00259', NULL, 'Gastrin / cholecystokinin family signature.', NULL, NULL, 'GASTRIN', 281250),
(462157, 'PS00545', NULL, 'Aldose 1-epimerase putative active site.', NULL, NULL, 'ALDOSE_1_EPIMERASE', 281251),
(462158, 'PS60018', NULL, 'Delta-atracotoxin (ACTX) family signature.', NULL, NULL, 'DELTA_ACTX', 281252),
(462159, 'PS01360', NULL, 'Zinc finger MYND-type signature.', NULL, NULL, 'ZF_MYND_1', 281253),
(462160, 'PS00278', NULL, 'Staphyloccocal enterotoxin/Streptococcal pyrogenic exotoxin signature 2.', NULL, NULL, 'STAPH_STREP_TOXIN_2', 281254),
(462161, 'PS00892', NULL, 'HIT domain signature.', NULL, NULL, 'HIT_1', 281255),
(462162, 'PS01177', NULL, 'Anaphylatoxin domain signature.', NULL, NULL, 'ANAPHYLATOXIN_1', 281256),
(462163, 'PS00397', NULL, 'Site-specific recombinases active site.', NULL, NULL, 'RECOMBINASES_1', 281257),
(462164, 'PS00476', NULL, 'Fatty acid desaturases family 1 signature.', NULL, NULL, 'FATTY_ACID_DESATUR_1', 281258),
(462165, 'PS00710', NULL, 'Phosphoglucomutase and phosphomannomutase phosphoserine signature.', NULL, NULL, 'PGM_PMM', 281259),
(462166, 'PS00212', NULL, 'Albumin domain signature.', NULL, NULL, 'ALBUMIN_1', 281260),
(462167, 'PS00964', NULL, 'Syndecans signature.', NULL, NULL, 'SYNDECAN', 281261),
(462168, 'PS01244', NULL, 'Aconitase family signature 2.', NULL, NULL, 'ACONITASE_2', 281262),
(462169, 'PS00719', NULL, 'Glycosyl hydrolases family 2 signature 1.', NULL, NULL, 'GLYCOSYL_HYDROL_F2_1', 281263),
(462170, 'PS00239', NULL, 'Receptor tyrosine kinase class II signature.', NULL, NULL, 'RECEPTOR_TYR_KIN_II', 281264),
(462171, 'PS00945', NULL, 'Cyclin-dependent kinases regulatory subunits signature 2.', NULL, NULL, 'CKS_2', 281265),
(462172, 'PS01260', NULL, 'Apoptosis regulator, Bcl-2 family BH4 motif signature.', NULL, NULL, 'BH4_1', 281266),
(462173, 'PS01012', NULL, 'Folylpolyglutamate synthase signature 2.', NULL, NULL, 'FOLYLPOLYGLU_SYNT_2', 281267),
(462174, 'PS00643', NULL, 'Respiratory-chain NADH dehydrogenase 75 Kd subunit signature 3.', NULL, NULL, 'COMPLEX1_75K_3', 281268),
(462175, 'PS00798', NULL, 'Aldo/keto reductase family signature 1.', NULL, NULL, 'ALDOKETO_REDUCTASE_1', 281269),
(462176, 'PS00012', NULL, 'Phosphopantetheine attachment site.', NULL, NULL, 'PHOSPHOPANTETHEINE', 281270),
(462177, 'PS01060', NULL, 'Flagella transport protein fliP family signature 1.', NULL, NULL, 'FLIP_1', 281271),
(462178, 'PS00250', NULL, 'TGF-beta family signature.', NULL, NULL, 'TGF_BETA_1', 281272),
(462179, 'PS00383', NULL, 'Tyrosine specific protein phosphatases active site.', NULL, NULL, 'TYR_PHOSPHATASE_1', 281273),
(462180, 'PS01253', NULL, 'Fibronectin type-I domain signature.', NULL, NULL, 'FN1_1', 281274),
(462181, 'PS00468', NULL, 'Eukaryotic cobalamin-binding proteins signature.', NULL, NULL, 'COBALAMIN_BINDING', 281275),
(462182, 'PS00530', NULL, 'Ribonuclease T2 family histidine active site 1.', NULL, NULL, 'RNASE_T2_1', 281276),
(462183, 'PS00673', NULL, 'Serine proteases, V8 family, serine active site.', NULL, NULL, 'V8_SER', 281277),
(462184, 'PS00177', NULL, 'DNA topoisomerase II signature.', NULL, NULL, 'TOPOISOMERASE_II', 281278),
(462185, 'PS00653', NULL, 'Glycosyl hydrolases family 1 N-terminal signature.', NULL, NULL, 'GLYCOSYL_HYDROL_F1_2', 281279),
(462186, 'PS00908', NULL, 'Mandelate racemase / muconate lactonizing enzyme family signature 1.', NULL, NULL, 'MR_MLE_1', 281280),
(462187, 'PS00790', NULL, 'Receptor tyrosine kinase class V signature 1.', NULL, NULL, 'RECEPTOR_TYR_KIN_V_1', 281281),
(462188, 'PS00963', NULL, 'Ribosomal protein S2 signature 2.', NULL, NULL, 'RIBOSOMAL_S2_2', 281282),
(462189, 'PS00337', NULL, 'Beta-lactamase class-D active site.', NULL, NULL, 'BETA_LACTAMASE_D', 281283),
(462190, 'PS01184', NULL, 'ubiE/COQ5 methyltransferase family signature 2.', NULL, NULL, 'UBIE_2', 281284); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(462191, 'PS00888', NULL, 'Cyclic nucleotide-binding domain signature 1.', NULL, NULL, 'CNMP_BINDING_1', 281285),
(462192, 'PS00191', NULL, 'Cytochrome b5 family, heme-binding domain signature.', NULL, NULL, 'CYTOCHROME_B5_1', 281286),
(462193, 'PS01305', NULL, 'moaA / nifB / pqqE family signature.', NULL, NULL, 'MOAA_NIFB_PQQE', 281287),
(462194, 'PS01219', NULL, 'Ammonium transporters signature.', NULL, NULL, 'AMMONIUM_TRANSP', 281288),
(462195, 'PS01284', NULL, 'Thermonuclease family signature 2.', NULL, NULL, 'TNASE_2', 281289),
(462196, 'PS01040', NULL, 'Bacterial extracellular solute-binding proteins, family 5 signature.', NULL, NULL, 'SBP_BACTERIAL_5', 281290),
(462197, 'PS00975', NULL, 'Myristoyl-CoA:protein N-myristoyltransferase signature 1.', NULL, NULL, 'NMT_1', 281291),
(462198, 'PS00429', NULL, 'Staphylocoagulase repeat signature.', NULL, NULL, 'STAPHYLOCOAGULASE', 281292),
(462199, 'PS00432', NULL, 'Actins signature 2.', NULL, NULL, 'ACTINS_2', 281293),
(462200, 'PS00054', NULL, 'Ribosomal protein S11 signature.', NULL, NULL, 'RIBOSOMAL_S11', 281294),
(462201, 'PS00740', NULL, 'MAM domain signature.', NULL, NULL, 'MAM_1', 281295),
(462202, 'PS00763', NULL, 'Glutathione peroxidases signature 2.', NULL, NULL, 'GLUTATHIONE_PEROXID_2', 281296),
(462203, 'PS00189', NULL, '2-oxo acid dehydrogenases acyltransferase component lipoyl binding site.', NULL, NULL, 'LIPOYL', 281297),
(462204, 'PS00654', NULL, 'PRD domain signature.', NULL, NULL, 'PRD_1', 281298),
(462205, 'PS00024', NULL, 'Hemopexin domain signature.', NULL, NULL, 'HEMOPEXIN', 281299),
(462206, 'PS00384', NULL, 'Prokaryotic zinc-dependent phospholipase C signature.', NULL, NULL, 'PROKAR_ZN_DEPEND_PLPC_1', 281300),
(462207, 'PS01091', NULL, 'TatD deoxyribonuclease family signature 3.', NULL, NULL, 'TATD_3', 281301),
(462208, 'PS00839', NULL, 'Uroporphyrin-III C-methyltransferase signature 1.', NULL, NULL, 'SUMT_1', 281302),
(462209, 'PS00523', NULL, 'Sulfatases signature 1.', NULL, NULL, 'SULFATASE_1', 281303),
(462210, 'PS00513', NULL, 'Adenylosuccinate synthetase active site.', NULL, NULL, 'ADENYLOSUCCIN_SYN_2', 281304),
(462211, 'PS00272', NULL, 'Snake toxins signature.', NULL, NULL, 'SNAKE_TOXIN', 281305),
(462212, 'PS00577', NULL, 'Avidin-like domain signature.', NULL, NULL, 'AVIDIN_1', 281306),
(462213, 'PS00415', NULL, 'Synapsins signature 1.', NULL, NULL, 'SYNAPSIN_1', 281307),
(462214, 'PS00500', NULL, 'Thymosin beta-4 family signature.', NULL, NULL, 'THYMOSIN_B4', 281308),
(462215, 'PS00750', NULL, 'Chaperonins TCP-1 signature 1.', NULL, NULL, 'TCP1_1', 281309),
(462216, 'PS00197', NULL, '2Fe-2S ferredoxin-type iron-sulfur binding region signature.', NULL, NULL, '2FE2S_FER_1', 281310),
(462217, 'PS00086', NULL, 'Cytochrome P450 cysteine heme-iron ligand signature.', NULL, NULL, 'CYTOCHROME_P450', 281311),
(462218, 'PS01181', NULL, 'Ribosomal protein S21 signature.', NULL, NULL, 'RIBOSOMAL_S21', 281312),
(462219, 'PS01188', NULL, 'ELO family signature.', NULL, NULL, 'ELO', 281313),
(462220, 'PS01021', NULL, 'Coproporphyrinogen III oxidase signature.', NULL, NULL, 'COPROGEN_OXIDASE', 281314),
(462221, 'PS00691', NULL, 'DNA photolyases class 1 signature 2.', NULL, NULL, 'DNA_PHOTOLYASES_1_2', 281315),
(462222, 'PS00350', NULL, 'MADS-box domain signature.', NULL, NULL, 'MADS_BOX_1', 281316),
(462223, 'PS00604', NULL, 'Synaptophysin / synaptoporin signature.', NULL, NULL, 'SYNAPTOP', 281317),
(462224, 'PS00884', NULL, 'Osteopontin signature.', NULL, NULL, 'OSTEOPONTIN', 281318),
(462225, 'PS00627', NULL, 'GHMP kinases putative ATP-binding domain.', NULL, NULL, 'GHMP_KINASES_ATP', 281319),
(462226, 'PS00666', NULL, 'Dihydrodipicolinate synthase signature 2.', NULL, NULL, 'DHDPS_2', 281320),
(462227, 'PS00436', NULL, 'Peroxidases active site signature.', NULL, NULL, 'PEROXIDASE_2', 281321),
(462228, 'PS00687', NULL, 'Aldehyde dehydrogenases glutamic acid active site.', NULL, NULL, 'ALDEHYDE_DEHYDR_GLU', 281322),
(462229, 'PS00102', NULL, 'Phosphorylase pyridoxal-phosphate attachment site.', NULL, NULL, 'PHOSPHORYLASE', 281323);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(462230, 'PS00441', NULL, 'Chalcone and stilbene synthases active site.', NULL, NULL, 'CHALCONE_SYNTH', 281324),
(462231, 'PS00780', NULL, 'Glycoprotein hormones alpha chain signature 2.', NULL, NULL, 'GLYCO_HORMONE_ALPHA_2', 281325),
(462232, 'PS01356', NULL, 'Short hematopoietin receptor family 2 signature.', NULL, NULL, 'HEMATOPO_REC_S_F2', 281326),
(462233, 'PS00752', NULL, 'XPA protein signature 1.', NULL, NULL, 'XPA_1', 281327),
(462234, 'PS00582', NULL, 'Ribosomal protein L33 signature.', NULL, NULL, 'RIBOSOMAL_L33', 281328),
(462235, 'PS00447', NULL, 'DNA polymerase family A signature.', NULL, NULL, 'DNA_POLYMERASE_A', 281329),
(462236, 'PS01129', NULL, 'Rlu family of pseudouridine synthase signature.', NULL, NULL, 'PSI_RLU', 281330),
(462237, 'PS01105', NULL, 'Ribosomal protein L35Ae signature.', NULL, NULL, 'RIBOSOMAL_L35AE', 281331),
(462238, 'PS00942', NULL, 'glpT family of transporters signature.', NULL, NULL, 'GLPT', 281332),
(462239, 'PS00983', NULL, 'Ly-6 / u-PAR domain signature.', NULL, NULL, 'LY6_UPAR', 281333),
(462240, 'PS00651', NULL, 'Ribosomal protein L9 signature.', NULL, NULL, 'RIBOSOMAL_L9', 281334),
(462241, 'PS00036', NULL, 'Basic-leucine zipper (bZIP) domain signature.', NULL, NULL, 'BZIP_BASIC', 281335),
(462242, 'PS00057', NULL, 'Ribosomal protein S18 signature.', NULL, NULL, 'RIBOSOMAL_S18', 281336),
(462243, 'PS00483', NULL, 'Dihydroorotase signature 2.', NULL, NULL, 'DIHYDROOROTASE_2', 281337),
(462244, 'PS00951', NULL, 'ER lumen protein retaining receptor signature 1.', NULL, NULL, 'ER_LUMEN_RECEPTOR_1', 281338),
(462245, 'PS00201', NULL, 'Flavodoxin signature.', NULL, NULL, 'FLAVODOXIN', 281339),
(462246, 'PS01107', NULL, 'Ribosomal protein L27e signature.', NULL, NULL, 'RIBOSOMAL_L27E', 281340),
(462247, 'PS60001', NULL, 'Nitric oxide synthase (NOS) signature.', NULL, NULL, 'NOS', 281341),
(462248, 'PS00554', NULL, 'TEA domain signature.', NULL, NULL, 'TEA_1', 281342),
(462249, 'PS00902', NULL, 'Glutamate 5-kinase signature.', NULL, NULL, 'GLUTAMATE_5_KINASE', 281343),
(462250, 'PS00948', NULL, 'Ribosomal protein S7e signature.', NULL, NULL, 'RIBOSOMAL_S7E', 281344),
(462251, 'PS60007', NULL, 'Tyrosine kinase phosphorylation site 2.', NULL, NULL, 'TYR_PHOSPHO_SITE_2', 281345),
(462252, 'PS00370', NULL, 'PEP-utilizing enzymes phosphorylation site signature.', NULL, NULL, 'PEP_ENZYMES_PHOS_SITE', 281346),
(462253, 'PS00511', NULL, 'Corticotropin-releasing factor family signature.', NULL, NULL, 'CRF', 281347),
(462254, 'PS00534', NULL, 'Ferrochelatase signature.', NULL, NULL, 'FERROCHELATASE', 281348),
(462255, 'PS00085', NULL, 'Copper type II, ascorbate-dependent monooxygenases signature 2.', NULL, NULL, 'CU2_MONOOXYGENASE_2', 281349),
(462256, 'PS00503', NULL, 'Pectinesterase signature 2.', NULL, NULL, 'PECTINESTERASE_2', 281350),
(462257, 'PS00584', NULL, 'pfkB family of carbohydrate kinases signature 2.', NULL, NULL, 'PFKB_KINASES_2', 281351),
(462258, 'PS00283', NULL, 'Soybean trypsin inhibitor (Kunitz) protease inhibitors family signature.', NULL, NULL, 'SOYBEAN_KUNITZ', 281352),
(462259, 'PS00766', NULL, 'Tetrahydrofolate dehydrogenase/cyclohydrolase signature 1.', NULL, NULL, 'THF_DHG_CYH_1', 281353),
(462260, 'PS00809', NULL, 'ADP-glucose pyrophosphorylase signature 2.', NULL, NULL, 'ADP_GLC_PYROPHOSPH_2', 281354),
(462261, 'PS01334', NULL, 'Pyrrolidone-carboxylate peptidase cysteine active site.', NULL, NULL, 'PYRASE_CYS', 281355),
(462262, 'PS00362', NULL, 'Ribosomal protein S15 signature.', NULL, NULL, 'RIBOSOMAL_S15', 281356),
(462263, 'PS00755', NULL, 'Protein secY signature 1.', NULL, NULL, 'SECY_1', 281357),
(462264, 'PS01222', NULL, 'PMP-22 / EMP / MP20 family signature 2.', NULL, NULL, 'PMP22_2', 281358),
(462265, 'PS60013', NULL, 'Mu-conotoxin family signature.', NULL, NULL, 'MU_CONOTOXIN', 281359),
(462266, 'PS00326', NULL, 'Tropomyosins signature.', NULL, NULL, 'TROPOMYOSIN', 281360),
(462267, 'PS00430', NULL, 'TonB-dependent receptor proteins signature 1.', NULL, NULL, 'TONB_DEPENDENT_REC_1', 281361),
(462268, 'PS00046', NULL, 'Histone H2A signature.', NULL, NULL, 'HISTONE_H2A', 281362);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(462269, 'PS00910', NULL, 'Uncharacterized protein family UPF0029 signature.', NULL, NULL, 'UPF0029', 281363),
(462270, 'PS00716', NULL, 'Sigma-70 factors family signature 2.', NULL, NULL, 'SIGMA70_2', 281364),
(462271, 'PS00901', NULL, 'Cysteine synthase/cystathionine beta-synthase P-phosphate attachment site.', NULL, NULL, 'CYS_SYNTHASE', 281365),
(462272, 'PS00968', NULL, 'Antenna complexes alpha subunits signature.', NULL, NULL, 'ANTENNA_COMP_ALPHA', 281366),
(462273, 'PS01361', NULL, 'Zinc finger Dof-type signature.', NULL, NULL, 'ZF_DOF_1', 281367),
(462274, 'PS00196', NULL, 'Type-1 copper (blue) proteins signature.', NULL, NULL, 'COPPER_BLUE', 281368),
(462275, 'PS01136', NULL, 'Uncharacterized protein family UPF0034 signature.', NULL, NULL, 'UPF0034', 281369),
(462276, 'PS00257', NULL, 'Bombesin-like peptides family signature.', NULL, NULL, 'BOMBESIN', 281370),
(462277, 'PS01187', NULL, 'Calcium-binding EGF-like domain signature.', NULL, NULL, 'EGF_CA', 281371),
(462278, 'PS00310', NULL, 'Lysosome-associated membrane glycoproteins duplicated domain signature.', NULL, NULL, 'LAMP_1', 281372),
(462279, 'PS00440', NULL, 'Acyltransferases ChoActase / COT / CPT family signature 2.', NULL, NULL, 'ACYLTRANSF_C_2', 281373),
(462280, 'PS00815', NULL, 'Alpha-isopropylmalate and homocitrate synthases signature 1.', NULL, NULL, 'AIPM_HOMOCIT_SYNTH_1', 281374),
(462281, 'PS00828', NULL, 'Ribosomal protein L36 signature.', NULL, NULL, 'RIBOSOMAL_L36', 281375),
(462282, 'PS01073', NULL, 'Ribosomal protein L24e signature.', NULL, NULL, 'RIBOSOMAL_L24E', 281376),
(462283, 'PS00328', NULL, 'HCP repeats signature.', NULL, NULL, 'HCP', 281377),
(462284, 'PS01022', NULL, 'PTR2 family proton/oligopeptide symporters signature 1.', NULL, NULL, 'PTR2_1', 281378),
(462285, 'PS00744', NULL, 'Beta-lactamases class B signature 2.', NULL, NULL, 'BETA_LACTAMASE_B_2', 281379),
(462286, 'PS01281', NULL, 'Glucose inhibited division protein A family signature 2.', NULL, NULL, 'GIDA_2', 281380),
(462287, 'PS00145', NULL, 'Urease active site.', NULL, NULL, 'UREASE_2', 281381),
(462288, 'PS01276', NULL, 'Peptidase family U32 signature.', NULL, NULL, 'PEPTIDASE_U32', 281382),
(462289, 'PS00374', NULL, 'Methylated-DNA--protein-cysteine methyltransferase active site.', NULL, NULL, 'MGMT', 281383),
(462290, 'PS00921', NULL, 'Nitrilases / cyanide hydratase active site signature.', NULL, NULL, 'NITRIL_CHT_2', 281384),
(462291, 'PS00692', NULL, 'NifH/frxC family signature 2.', NULL, NULL, 'NIFH_FRXC_2', 281385),
(462292, 'PS00689', NULL, 'Glycoprotein hormones beta chain signature 2.', NULL, NULL, 'GLYCO_HORMONE_BETA_2', 281386),
(462293, 'PS00509', NULL, 'Ras GTPase-activating proteins domain signature.', NULL, NULL, 'RAS_GTPASE_ACTIV_1', 281387),
(462294, 'PS00479', NULL, 'Zinc finger phorbol-ester/DAG-type signature.', NULL, NULL, 'ZF_DAG_PE_1', 281388),
(462295, 'PS00293', NULL, 'Proliferating cell nuclear antigen signature 2.', NULL, NULL, 'PCNA_2', 281389),
(462296, 'PS00074', NULL, 'Glu / Leu / Phe / Val dehydrogenases active site.', NULL, NULL, 'GLFV_DEHYDROGENASE', 281390),
(462297, 'PS00276', NULL, 'Channel forming colicins signature.', NULL, NULL, 'CHANNEL_COLICIN', 281391),
(462298, 'PS01171', NULL, 'Ribosomal protein L21e signature.', NULL, NULL, 'RIBOSOMAL_L21E', 281392),
(462299, 'PS01127', NULL, 'Elongation factor Ts signature 2.', NULL, NULL, 'EF_TS_2', 281393),
(462300, 'PS00575', NULL, 'Myelin proteolipid protein signature 1.', NULL, NULL, 'MYELIN_PLP_1', 281394),
(462301, 'PS00194', NULL, 'Thioredoxin family active site.', NULL, NULL, 'THIOREDOXIN_1', 281395),
(462302, 'PS00549', NULL, 'Bacterioferritin signature.', NULL, NULL, 'BACTERIOFERRITIN', 281396),
(462303, 'PS01243', NULL, 'Bax inhibitor-1 family signature.', NULL, NULL, 'BI1', 281397),
(462304, 'PS01325', NULL, 'Lysyl hydroxylase signature.', NULL, NULL, 'LYS_HYDROXYLASE', 281398),
(462305, 'PS00360', NULL, 'Ribosomal protein S9 signature.', NULL, NULL, 'RIBOSOMAL_S9', 281399),
(462306, 'PS00570', NULL, 'Bacterial ring hydroxylating dioxygenases alpha-subunit signature.', NULL, NULL, 'RING_HYDROXYL_ALPHA', 281400);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(462307, 'PS00070', NULL, 'Aldehyde dehydrogenases cysteine active site.', NULL, NULL, 'ALDEHYDE_DEHYDR_CYS', 281401),
(462308, 'PS00505', NULL, 'Phosphoenolpyruvate carboxykinase (GTP) signature.', NULL, NULL, 'PEPCK_GTP', 281402),
(462309, 'PS00033', NULL, '''Homeobox'' engrailed-type protein signature.', NULL, NULL, 'ENGRAILED', 281403),
(462310, 'PS00290', NULL, 'Immunoglobulins and major histocompatibility complex proteins signature.', NULL, NULL, 'IG_MHC', 281404),
(462311, 'PS00464', NULL, 'Ribosomal protein L22 signature.', NULL, NULL, 'RIBOSOMAL_L22', 281405),
(462312, 'PS00288', NULL, 'Tissue inhibitors of metalloproteinases signature.', NULL, NULL, 'TIMP', 281406),
(462313, 'PS00274', NULL, 'Aerolysin type toxins signature.', NULL, NULL, 'AEROLYSIN', 281407),
(462314, 'PS60030', NULL, 'Bacteriocin class IIa family signature.', NULL, NULL, 'BACTERIOCIN_IIA', 281408),
(462315, 'PS00031', NULL, 'Nuclear hormones receptors DNA-binding region signature.', NULL, NULL, 'NUCLEAR_REC_DBD_1', 281409),
(462316, 'PS01264', NULL, 'T-box domain signature 2.', NULL, NULL, 'TBOX_2', 281410),
(462317, 'PS00498', NULL, 'Tyrosinase and hemocyanins CuB-binding region signature.', NULL, NULL, 'TYROSINASE_2', 281411),
(462318, 'PS01024', NULL, 'Protein phosphatase 2A regulatory subunit PR55 signature 1.', NULL, NULL, 'PR55_1', 281412),
(462319, 'PS00940', NULL, 'Gamma-thionins family signature.', NULL, NULL, 'GAMMA_THIONIN', 281413),
(462320, 'PS00091', NULL, 'Thymidylate synthase active site.', NULL, NULL, 'THYMIDYLATE_SYNTHASE', 281414),
(462321, 'PS00696', NULL, 'Electron transfer flavoprotein alpha-subunit signature.', NULL, NULL, 'ETF_ALPHA', 281415),
(462322, 'PS01028', NULL, 'Dehydroquinase class I active site.', NULL, NULL, 'DEHYDROQUINASE_I', 281416),
(462323, 'PS00526', NULL, 'Ribosomal protein L19e signature.', NULL, NULL, 'RIBOSOMAL_L19E', 281417),
(462324, 'PS00001', NULL, 'N-glycosylation site.', NULL, NULL, 'ASN_GLYCOSYLATION', 281418),
(462325, 'PS00804', NULL, 'Calreticulin family signature 2.', NULL, NULL, 'CALRETICULIN_2', 281419),
(462326, 'PS01282', NULL, 'BIR repeat.', NULL, NULL, 'BIR_REPEAT_1', 281420),
(462327, 'PS00068', NULL, 'Malate dehydrogenase active site signature.', NULL, NULL, 'MDH', 281421),
(462328, 'PS01318', NULL, 'TsaA-like domain signature.', NULL, NULL, 'TSAA_1', 281422),
(462329, 'PS01302', NULL, 'Uncharacterized protein family UPF0758 signature.', NULL, NULL, 'UPF0758', 281423),
(462330, 'PS00363', NULL, 'Bacterial quinoprotein dehydrogenases signature 1.', NULL, NULL, 'BACTERIAL_PQQ_1', 281424),
(462331, 'PS00052', NULL, 'Ribosomal protein S7 signature.', NULL, NULL, 'RIBOSOMAL_S7', 281425),
(462332, 'PS00490', NULL, 'Prokaryotic molybdopterin oxidoreductases signature 2.', NULL, NULL, 'MOLYBDOPTERIN_PROK_2', 281426),
(462333, 'PS01123', NULL, 'Thermonuclease family signature 1.', NULL, NULL, 'TNASE_1', 281427),
(462334, 'PS00854', NULL, 'Proteasome beta-type subunits signature.', NULL, NULL, 'PROTEASOME_BETA_1', 281428),
(462335, 'PS00774', NULL, 'Chitinases family 19 signature 2.', NULL, NULL, 'CHITINASE_19_2', 281429),
(462336, 'PS01221', NULL, 'PMP-22 / EMP / MP20 family signature 1.', NULL, NULL, 'PMP22_1', 281430),
(462337, 'PS00207', NULL, 'Transferrin-like domain signature 3.', NULL, NULL, 'TRANSFERRIN_LIKE_3', 281431),
(462338, 'PS00218', NULL, 'Amino acid permeases signature.', NULL, NULL, 'AMINO_ACID_PERMEASE_1', 281432),
(462339, 'PS01160', NULL, 'Kinesin light chain repeat.', NULL, NULL, 'KINESIN_LIGHT', 281433),
(462340, 'PS00368', NULL, 'Ribonucleotide reductase small subunit signature.', NULL, NULL, 'RIBORED_SMALL', 281434),
(462341, 'PS00796', NULL, '14-3-3 proteins signature 1.', NULL, NULL, '1433_1', 281435),
(462342, 'PS00494', NULL, 'Bacterial luciferase subunits signature.', NULL, NULL, 'BACTERIAL_LUCIFERASE', 281436),
(462343, 'PS00949', NULL, 'Autoinducer synthase family signature.', NULL, NULL, 'AUTOINDUCER_SYNTH_1', 281437),
(462344, 'PS00230', NULL, 'Neuraxin and MAP1B proteins repeated region signature.', NULL, NULL, 'MAP1B_NEURAXIN', 281438);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(462345, 'PS01307', NULL, 'Flagellar motor protein motA family signature.', NULL, NULL, 'MOTA', 281439),
(462346, 'PS00303', NULL, 'S-100/ICaBP type calcium binding protein signature.', NULL, NULL, 'S100_CABP', 281440),
(462347, 'PS00620', NULL, 'PTN/MK heparin-binding protein family signature 2.', NULL, NULL, 'PTN_MK_2', 281441),
(462348, 'PS00621', NULL, 'Tissue factor signature.', NULL, NULL, 'TISSUE_FACTOR', 281442),
(462349, 'PS00720', NULL, 'Ras Guanine-nucleotide exchange factors domain signature.', NULL, NULL, 'RASGEF', 281443),
(462350, 'PS01209', NULL, 'LDL-receptor class A (LDLRA) domain signature.', NULL, NULL, 'LDLRA_1', 281444),
(462351, 'PS00537', NULL, 'Cytochrome b559 subunits heme-binding site signature.', NULL, NULL, 'CYTOCHROME_B559', 281445),
(462352, 'PS00617', NULL, 'RecF protein signature 1.', NULL, NULL, 'RECF_1', 281446),
(462353, 'PS00800', NULL, 'Pectinesterase signature 1.', NULL, NULL, 'PECTINESTERASE_1', 281447),
(462354, 'PS00512', NULL, 'Alpha-galactosidase signature.', NULL, NULL, 'ALPHA_GALACTOSIDASE', 281448),
(462355, 'PS00063', NULL, 'Aldo/keto reductase family putative active site signature.', NULL, NULL, 'ALDOKETO_REDUCTASE_3', 281449),
(462356, 'PS00571', NULL, 'Amidases signature.', NULL, NULL, 'AMIDASES', 281450),
(462357, 'PS01161', NULL, 'Glucosamine/galactosamine-6-phosphate isomerases signature.', NULL, NULL, 'GLC_GALNAC_ISOMERASE', 281451),
(462358, 'PS01200', NULL, 'Tub family signature 1.', NULL, NULL, 'TUB_1', 281452),
(462359, 'PS00958', NULL, 'Transaldolase active site.', NULL, NULL, 'TRANSALDOLASE_2', 281453),
(462360, 'PS60031', NULL, 'Glutamic acid-rich protein 2 (GARP2) signature.', NULL, NULL, 'GARP2', 281454),
(462361, 'PS00988', NULL, '6-pyruvoyl tetrahydropterin synthase signature 2.', NULL, NULL, 'PTPS_2', 281455),
(462362, 'PS01133', NULL, 'Uncharacterized protein family UPF0017 signature.', NULL, NULL, 'UPF0017', 281456),
(462363, 'PS00159', NULL, 'KDPG and KHG aldolases active site.', NULL, NULL, 'ALDOLASE_KDPG_KHG_1', 281457),
(462364, 'PS00178', NULL, 'Aminoacyl-transfer RNA synthetases class-I signature.', NULL, NULL, 'AA_TRNA_LIGASE_I', 281458),
(462365, 'PS00365', NULL, 'Nitrite and sulfite reductases iron-sulfur/siroheme-binding site.', NULL, NULL, 'NIR_SIR', 281459),
(462366, 'PS00061', NULL, 'Short-chain dehydrogenases/reductases family signature.', NULL, NULL, 'ADH_SHORT', 281460),
(462367, 'PS00166', NULL, 'Enoyl-CoA hydratase/isomerase signature.', NULL, NULL, 'ENOYL_COA_HYDRATASE', 281461),
(462368, 'PS00879', NULL, 'Orn/DAP/Arg decarboxylases family 2 signature 2.', NULL, NULL, 'ODR_DC_2_2', 281462),
(462369, 'PS01111', NULL, 'RNA polymerases K / 14 to 18 Kd subunits signature.', NULL, NULL, 'RNA_POL_K_14KD', 281463),
(462370, 'PS01186', NULL, 'EGF-like domain signature 2.', NULL, NULL, 'EGF_2', 281464),
(462371, 'PS00727', NULL, 'AP endonucleases family 1 signature 2.', NULL, NULL, 'AP_NUCLEASE_F1_2', 281465),
(462372, 'PS01017', NULL, 'Sterol reductase family signature 1.', NULL, NULL, 'STEROL_REDUCT_1', 281466),
(462373, 'PS00469', NULL, 'Nucleoside diphosphate kinases active site.', NULL, NULL, 'NDP_KINASES', 281467),
(462374, 'PS00860', NULL, 'GTP cyclohydrolase I signature 2.', NULL, NULL, 'GTP_CYCLOHYDROL_1_2', 281468),
(462375, 'PS01068', NULL, 'OmpA-like domain.', NULL, NULL, 'OMPA_1', 281469),
(462376, 'PS00882', NULL, 'Nickel-dependent hydrogenases b-type cytochrome subunit signature 1.', NULL, NULL, 'NI_HGENASE_CYTB_1', 281470),
(462377, 'PS01273', NULL, 'Coenzyme A transferases signature 1.', NULL, NULL, 'COA_TRANSF_1', 281471),
(462378, 'PS00307', NULL, 'Legume lectins beta-chain signature.', NULL, NULL, 'LECTIN_LEGUME_BETA', 281472),
(462379, 'PS00264', NULL, 'Neurohypophysial hormones signature.', NULL, NULL, 'NEUROHYPOPHYS_HORM', 281473),
(462380, 'PS00594', NULL, 'Aromatic amino acids permeases signature.', NULL, NULL, 'AROMATIC_AA_PERMEASE_1', 281474),
(462381, 'PS00953', NULL, 'Glycosyl hydrolases family 25 active site signature.', NULL, NULL, 'GLYCOSYL_HYDROL_F25_1', 281475),
(462382, 'PS01076', NULL, 'Acetate and butyrate kinases family signature 2.', NULL, NULL, 'ACETATE_KINASE_2', 281476);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(462383, 'PS60014', NULL, 'Alpha-conotoxin family signature.', NULL, NULL, 'ALPHA_CONOTOXIN', 281477),
(462384, 'PS00830', NULL, 'Prokaryotic transcription elongation factors signature 2.', NULL, NULL, 'GREAB_2', 281478),
(462385, 'PS01223', NULL, 'Gamma-glutamyl phosphate reductase signature.', NULL, NULL, 'PROA', 281479),
(462386, 'PS00931', NULL, 'Cutinase, aspartate and histidine active sites.', NULL, NULL, 'CUTINASE_2', 281480),
(462387, 'PS01206', NULL, 'Amiloride-sensitive sodium channels signature.', NULL, NULL, 'ASC', 281481),
(462388, 'PS00456', NULL, 'Sodium:solute symporter family signature 1.', NULL, NULL, 'NA_SOLUT_SYMP_1', 281482),
(462389, 'PS01199', NULL, 'Ribosomal protein L1 signature.', NULL, NULL, 'RIBOSOMAL_L1', 281483),
(462390, 'PS01191', NULL, 'Ribosomal protein S3Ae signature.', NULL, NULL, 'RIBOSOMAL_S3AE', 281484),
(462391, 'PS60009', NULL, 'Cyclotides Moebius subfamily signature.', NULL, NULL, 'CYCLOTIDE_MOEBIUS', 281485),
(462392, 'PS01032', NULL, 'PPM-type phosphatase domain signature.', NULL, NULL, 'PPM_1', 281486),
(462393, 'PS01050', NULL, 'YjeF C-terminal domain signature 2.', NULL, NULL, 'YJEF_C_2', 281487),
(462394, 'PS00660', NULL, 'FERM domain signature 1.', NULL, NULL, 'FERM_1', 281488),
(462395, 'PS01092', NULL, 'Adenylate cyclase class-I signature 1.', NULL, NULL, 'ADENYLATE_CYCLASE_1_1', 281489),
(462396, 'PS01117', NULL, 'MarR-type HTH domain signature.', NULL, NULL, 'HTH_MARR_1', 281490),
(462397, 'PS00520', NULL, 'Interleukin-10 family signature.', NULL, NULL, 'INTERLEUKIN_10', 281491),
(462398, 'PS01236', NULL, 'PdxT/SNO family family signature.', NULL, NULL, 'PDXT_SNO_1', 281492),
(462399, 'PS01002', NULL, 'Translationally controlled tumor protein (TCTP) domain signature 1.', NULL, NULL, 'TCTP_1', 281493),
(462400, 'PS00316', NULL, 'Thaumatin family signature.', NULL, NULL, 'THAUMATIN_1', 281494),
(462401, 'PS00180', NULL, 'Glutamine synthetase signature 1.', NULL, NULL, 'GLNA_1', 281495),
(462402, 'PS60024', NULL, 'Agouti domain signature.', NULL, NULL, 'AGOUTI_1', 281496),
(462403, 'PS00292', NULL, 'Cyclins signature.', NULL, NULL, 'CYCLINS', 281497),
(462404, 'PS00699', NULL, 'Nitrogenases component 1 alpha and beta subunits signature 1.', NULL, NULL, 'NITROGENASE_1_1', 281498),
(462405, 'PS00768', NULL, 'Transthyretin signature 1.', NULL, NULL, 'TRANSTHYRETIN_1', 281499),
(462406, 'PS00841', NULL, 'XPG protein signature 1.', NULL, NULL, 'XPG_1', 281500),
(462407, 'PS00652', NULL, 'TNFR/NGFR family cysteine-rich region signature.', NULL, NULL, 'TNFR_NGFR_1', 281501),
(462408, 'PS00922', NULL, 'Prokaryotic transglycosylases signature.', NULL, NULL, 'TRANSGLYCOSYLASE', 281502),
(462409, 'PS00435', NULL, 'Peroxidases proximal heme-ligand signature.', NULL, NULL, 'PEROXIDASE_1', 281503),
(462410, 'PS00886', NULL, 'Dihydroxy-acid and 6-phosphogluconate dehydratases signature 1.', NULL, NULL, 'ILVD_EDD_1', 281504),
(462411, 'PS00084', NULL, 'Copper type II, ascorbate-dependent monooxygenases signature 1.', NULL, NULL, 'CU2_MONOOXYGENASE_1', 281505),
(462412, 'PS00155', NULL, 'Cutinase, serine active site.', NULL, NULL, 'CUTINASE_1', 281506),
(462413, 'PS00223', NULL, 'Annexin repeat signature.', NULL, NULL, 'ANNEXIN_1', 281507),
(462414, 'PS00008', NULL, 'N-myristoylation site.', NULL, NULL, 'MYRISTYL', 281508),
(462415, 'PS00563', NULL, 'Stathmin family signature 1.', NULL, NULL, 'STATHMIN_1', 281509),
(462416, 'PS00186', NULL, 'Isopenicillin N synthase signature 2.', NULL, NULL, 'IPNS_2', 281510),
(462417, 'PS00861', NULL, 'Galanin signature.', NULL, NULL, 'GALANIN', 281511),
(462418, 'PS01202', NULL, 'Methionine aminopeptidase subfamily 2 signature.', NULL, NULL, 'MAP_2', 281512),
(462419, 'PS01196', NULL, 'Peptidyl-tRNA hydrolase signature 2.', NULL, NULL, 'PEPT_TRNA_HYDROL_2', 281513),
(462420, 'PS01137', NULL, 'TatD deoxyribonuclease family signature 1.', NULL, NULL, 'TATD_1', 281514),
(462421, 'PS00536', NULL, 'Ubiquitin-activating enzyme signature 1.', NULL, NULL, 'UBIQUITIN_ACTIVAT_1', 281515),
(462422, 'PS00675', NULL, 'Sigma-54 interaction domain ATP-binding region A signature.', NULL, NULL, 'SIGMA54_INTERACT_1', 281516);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(462423, 'PS00394', NULL, 'DNA photolyases class 1 signature 1.', NULL, NULL, 'DNA_PHOTOLYASES_1_1', 281517),
(462424, 'PS00980', NULL, 'G-protein coupled receptors family 3 signature 2.', NULL, NULL, 'G_PROTEIN_RECEP_F3_2', 281518),
(462425, 'PS00262', NULL, 'Insulin family signature.', NULL, NULL, 'INSULIN', 281519),
(462426, 'PS00413', NULL, 'Neuromodulin (GAP-43) signature 2.', NULL, NULL, 'NEUROMODULIN_2', 281520),
(462427, 'PS00605', NULL, 'ATP synthase c subunit signature.', NULL, NULL, 'ATPASE_C', 281521),
(462428, 'PS00289', NULL, 'Pentraxin domain signature.', NULL, NULL, 'PTX_1', 281522),
(462429, 'PS00742', NULL, 'PEP-utilizing enzymes signature 2.', NULL, NULL, 'PEP_ENZYMES_2', 281523),
(462430, 'PS00079', NULL, 'Multicopper oxidases signature 1.', NULL, NULL, 'MULTICOPPER_OXIDASE1', 281524),
(462431, 'PS01300', NULL, 'RecR protein signature.', NULL, NULL, 'RECR', 281525),
(462432, 'PS00305', NULL, '11-S plant seed storage proteins signature.', NULL, NULL, '11S_SEED_STORAGE', 281526),
(462433, 'PS00195', NULL, 'Glutaredoxin active site.', NULL, NULL, 'GLUTAREDOXIN_1', 281527),
(462434, 'PS00419', NULL, 'Photosystem I psaA and psaB proteins signature.', NULL, NULL, 'PHOTOSYSTEM_I_PSAAB', 281528),
(462435, 'PS01251', NULL, 'Proliferating cell nuclear antigen signature 1.', NULL, NULL, 'PCNA_1', 281529),
(462436, 'PS00428', NULL, 'Cell cycle proteins ftsW / rodA / spoVE signature.', NULL, NULL, 'FTSW_RODA_SPOVE', 281530),
(462437, 'PS00589', NULL, 'PTS HPR domain serine phosphorylation site signature.', NULL, NULL, 'PTS_HPR_SER', 281531),
(462438, 'PS00598', NULL, 'Chromo domain signature.', NULL, NULL, 'CHROMO_1', 281532),
(462439, 'PS00543', NULL, 'HlyD family secretion proteins signature.', NULL, NULL, 'HLYD_FAMILY', 281533),
(462440, 'PS00927', NULL, 'Trehalase signature 1.', NULL, NULL, 'TREHALASE_1', 281534),
(462441, 'PS00025', NULL, 'P-type ''Trefoil'' domain signature.', NULL, NULL, 'P_TREFOIL_1', 281535),
(462442, 'PS00465', NULL, 'POU-specific (POUs) domain signature 2.', NULL, NULL, 'POU_2', 281536),
(462443, 'PS01326', NULL, 'Diaminopimelate epimerase signature.', NULL, NULL, 'DAP_EPIMERASE', 281537),
(462444, 'PS00705', NULL, 'Prokaryotic-type carbonic anhydrases signature 2.', NULL, NULL, 'PROK_CO2_ANHYDRASE_2', 281538),
(462445, 'PS00848', NULL, 'Cytochrome c oxidase subunit Vb, zinc binding region signature.', NULL, NULL, 'COX5B_1', 281539),
(462446, 'PS01346', NULL, 'Claudin family signature.', NULL, NULL, 'CLAUDIN', 281540),
(462447, 'PS00506', NULL, 'Beta-amylase active site 1.', NULL, NULL, 'BETA_AMYLASE_1', 281541),
(462448, 'PS00855', NULL, 'Signal peptidases II signature.', NULL, NULL, 'SPASE_II', 281542),
(462449, 'PS00320', NULL, 'Amyloid precursor protein (APP) intracellular domain signature.', NULL, NULL, 'APP_INTRA', 281543),
(462450, 'PS01298', NULL, 'Dihydrodipicolinate reductase signature.', NULL, NULL, 'DAPB', 281544),
(462451, 'PS60019', NULL, 'I-superfamily conotoxin signature.', NULL, NULL, 'I_CONOTOXIN', 281545),
(462452, 'PS00544', NULL, 'Methylmalonyl-CoA mutase signature.', NULL, NULL, 'METMALONYL_COA_MUTASE', 281546),
(462453, 'PS60021', NULL, 'Huwentoxin-1 family signature.', NULL, NULL, 'HWTX_1', 281547),
(462454, 'PS00169', NULL, 'Delta-aminolevulinic acid dehydratase active site.', NULL, NULL, 'D_ALA_DEHYDRATASE', 281548),
(462455, 'PS00251', NULL, 'TNF family signature.', NULL, NULL, 'TNF_1', 281549),
(462456, 'PS00843', NULL, 'D-alanine--D-alanine ligase signature 1.', NULL, NULL, 'DALA_DALA_LIGASE_1', 281550),
(462457, 'PS00144', NULL, 'Asparaginase / glutaminase active site signature 1.', NULL, NULL, 'ASN_GLN_ASE_1', 281551),
(462458, 'PS01238', NULL, 'GDA1/CD39 family of nucleoside phosphatases signature.', NULL, NULL, 'GDA1_CD39_NTPASE', 281552),
(462459, 'PS00751', NULL, 'Chaperonins TCP-1 signature 2.', NULL, NULL, 'TCP1_2', 281553),
(462460, 'PS00738', NULL, 'S-adenosyl-L-homocysteine hydrolase signature 1.', NULL, NULL, 'ADOHCYASE_1', 281554),
(462461, 'PS00821', NULL, 'Cytochrome c and c1 heme lyases signature 1.', NULL, NULL, 'CYTO_HEME_LYASE_1', 281555);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(462462, 'PS01262', NULL, 'Eukaryotic initiation factor 1A signature.', NULL, NULL, 'IF1A', 281556),
(462463, 'PS00611', NULL, 'Histidinol dehydrogenase signature.', NULL, NULL, 'HISOL_DEHYDROGENASE', 281557),
(462464, 'PS00992', NULL, 'Serum amyloid A proteins signature.', NULL, NULL, 'SAA', 281558),
(462465, 'PS01240', NULL, 'Purine and other phosphorylases family 2 signature.', NULL, NULL, 'PNP_MTAP_2', 281559),
(462466, 'PS01095', NULL, 'Glycosyl hydrolases family 18 (GH18) active site signature.', NULL, NULL, 'GH18_1', 281560),
(462467, 'PS00010', NULL, 'Aspartic acid and asparagine hydroxylation site.', NULL, NULL, 'ASX_HYDROXYL', 281561),
(462468, 'PS00562', NULL, 'CBM1 (carbohydrate binding type-1) domain signature.', NULL, NULL, 'CBM1_1', 281562),
(462469, 'PS01067', NULL, 'Protein secE/sec61-gamma signature.', NULL, NULL, 'SECE_SEC61G', 281563),
(462470, 'PS00452', NULL, 'Guanylate cyclase signature.', NULL, NULL, 'GUANYLATE_CYCLASE_1', 281564),
(462471, 'PS00961', NULL, 'Ribosomal protein S28e signature.', NULL, NULL, 'RIBOSOMAL_S28E', 281565),
(462472, 'PS01116', NULL, 'Xanthine/uracil permeases family signature.', NULL, NULL, 'XANTH_URACIL_PERMASE', 281566),
(462473, 'PS01090', NULL, 'TatD deoxyribonuclease family signature 2.', NULL, NULL, 'TATD_2', 281567),
(462474, 'PS00271', NULL, 'Plant thionins signature.', NULL, NULL, 'THIONIN', 281568),
(462475, 'PS00255', NULL, 'Interleukin-7 and -9 signature.', NULL, NULL, 'INTERLEUKIN_7_9', 281569),
(462476, 'PS00971', NULL, 'Nuclear transition protein 2 signature 2.', NULL, NULL, 'TP2_2', 281570),
(462477, 'PS00504', NULL, 'Fumarate reductase / succinate dehydrogenase FAD-binding site.', NULL, NULL, 'FRD_SDH_FAD_BINDING', 281571),
(462478, 'PS01211', NULL, 'Uncharacterized protein family UPF0001 signature.', NULL, NULL, 'UPF0001', 281572),
(462479, 'PS01167', NULL, 'Ribosomal protein L17 signature.', NULL, NULL, 'RIBOSOMAL_L17', 281573),
(462480, 'PS01248', NULL, 'Laminin-type EGF-like (LE) domain signature.', NULL, NULL, 'EGF_LAM_1', 281574),
(462481, 'PS00039', NULL, 'DEAD-box subfamily ATP-dependent helicases signature.', NULL, NULL, 'DEAD_ATP_HELICASE', 281575),
(462482, 'PS00898', NULL, 'Ependymins signature 1.', NULL, NULL, 'EPENDYMIN_1', 281576),
(462483, 'PS00616', NULL, 'Histidine acid phosphatases phosphohistidine signature.', NULL, NULL, 'HIS_ACID_PHOSPHAT_1', 281577),
(462484, 'PS00634', NULL, 'Ribosomal protein L30 signature.', NULL, NULL, 'RIBOSOMAL_L30', 281578),
(462485, 'PS01193', NULL, 'Ribosomal protein S8e signature.', NULL, NULL, 'RIBOSOMAL_S8E', 281579),
(462486, 'PS01233', NULL, 'Urocanase signature.', NULL, NULL, 'UROCANASE', 281580),
(462487, 'PS00524', NULL, 'Somatomedin B domain (SMB) signature.', NULL, NULL, 'SMB_1', 281581),
(462488, 'PS00632', NULL, 'Ribosomal protein S4 signature.', NULL, NULL, 'RIBOSOMAL_S4', 281582),
(462489, 'PS00788', NULL, 'Chorismate synthase signature 2.', NULL, NULL, 'CHORISMATE_SYNTHASE_2', 281583),
(462490, 'PS01340', NULL, 'Cornichon family signature.', NULL, NULL, 'CORNICHON', 281584),
(462491, 'PS00529', NULL, 'Ribosomal protein S24e signature.', NULL, NULL, 'RIBOSOMAL_S24E', 281585),
(462492, 'PS00997', NULL, 'G10 protein signature 1.', NULL, NULL, 'G10_1', 281586),
(462493, 'PS00156', NULL, 'Orotidine 5''-phosphate decarboxylase active site.', NULL, NULL, 'OMPDECASE', 281587),
(462494, 'PS00540', NULL, 'Ferritin iron-binding regions signature 1.', NULL, NULL, 'FERRITIN_1', 281588),
(462495, 'PS01009', NULL, 'CRISP family signature 1.', NULL, NULL, 'CRISP_1', 281589),
(462496, 'PS01311', NULL, 'Prolipoprotein diacylglyceryl transferase signature.', NULL, NULL, 'LGT', 281590),
(462497, 'PS00835', NULL, 'Aspartyl proteases, omptin family signature 2.', NULL, NULL, 'OMPTIN_2', 281591),
(462498, 'PS00829', NULL, 'Prokaryotic transcription elongation factors signature 1.', NULL, NULL, 'GREAB_1', 281592),
(462499, 'PS01071', NULL, 'grpE protein signature.', NULL, NULL, 'GRPE', 281593),
(462500, 'PS01217', NULL, 'ATP-citrate lyase / succinyl-CoA ligases family signature 3.', NULL, NULL, 'SUCCINYL_COA_LIG_3', 281594);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(462501, 'PS00130', NULL, 'Uracil-DNA glycosylase signature.', NULL, NULL, 'U_DNA_GLYCOSYLASE', 281595),
(462502, 'PS01299', NULL, 'Ephrin receptor-binding (ephrin RBD) domain signature.', NULL, NULL, 'EPHRIN_RBD_1', 281596),
(462503, 'PS00398', NULL, 'Site-specific recombinases signature 2.', NULL, NULL, 'RECOMBINASES_2', 281597),
(462504, 'PS00658', NULL, 'Fork head domain signature 2.', NULL, NULL, 'FORK_HEAD_2', 281598),
(462505, 'PS00585', NULL, 'Ribosomal protein S5 signature.', NULL, NULL, 'RIBOSOMAL_S5', 281599),
(462506, 'PS00747', NULL, 'Glutamyl-tRNA reductase signature.', NULL, NULL, 'GLUTR', 281600),
(462507, 'PS00067', NULL, '3-hydroxyacyl-CoA dehydrogenase signature.', NULL, NULL, '3HCDH', 281601),
(462508, 'PS00226', NULL, 'Intermediate filament (IF) rod domain signature.', NULL, NULL, 'IF_ROD_1', 281602),
(462509, 'PS00487', NULL, 'IMP dehydrogenase / GMP reductase signature.', NULL, NULL, 'IMP_DH_GMP_RED', 281603),
(462510, 'PS00711', NULL, 'Lipoxygenases iron-binding region signature 1.', NULL, NULL, 'LIPOXYGENASE_1', 281604),
(462511, 'PS00041', NULL, 'Bacterial regulatory proteins, araC family signature.', NULL, NULL, 'HTH_ARAC_FAMILY_1', 281605),
(462512, 'PS00715', NULL, 'Sigma-70 factors family signature 1.', NULL, NULL, 'SIGMA70_1', 281606),
(462513, 'PS00101', NULL, 'Hexapeptide-repeat containing-transferases signature.', NULL, NULL, 'HEXAPEP_TRANSFERASES', 281607),
(462514, 'PS00111', NULL, 'Phosphoglycerate kinase signature.', NULL, NULL, 'PGLYCERATE_KINASE', 281608),
(462515, 'PS00205', NULL, 'Transferrin-like domain signature 1.', NULL, NULL, 'TRANSFERRIN_LIKE_1', 281609),
(462516, 'PS60025', NULL, 'Conantokin family signature.', NULL, NULL, 'CONANTOKIN', 281610),
(462517, 'PS00486', NULL, 'DNA mismatch repair proteins mutS family signature.', NULL, NULL, 'DNA_MISMATCH_REPAIR_2', 281611),
(462518, 'PS00770', NULL, 'Aminotransferases class-IV signature.', NULL, NULL, 'AA_TRANSFER_CLASS_4', 281612),
(462519, 'PS01096', NULL, 'PpiC-type peptidyl-prolyl cis-trans isomerase signature.', NULL, NULL, 'PPIC_PPIASE_1', 281613),
(462520, 'PS00628', NULL, 'Ribosomal protein S19e signature.', NULL, NULL, 'RIBOSOMAL_S19E', 281614),
(462521, 'PS01097', NULL, 'Hydrogenases expression/synthesis hupF/hypC family signature.', NULL, NULL, 'HUPF_HYPC', 281615),
(462522, 'PS00019', NULL, 'Actinin-type actin-binding domain signature 1.', NULL, NULL, 'ACTININ_1', 281616),
(462523, 'PS00929', NULL, 'Yeast PIR proteins repeats signature.', NULL, NULL, 'PIR_REPEAT_1', 281617),
(462524, 'PS00285', NULL, 'Potato inhibitor I family signature.', NULL, NULL, 'POTATO_INHIBITOR', 281618),
(462525, 'PS00216', NULL, 'Sugar transport proteins signature 1.', NULL, NULL, 'SUGAR_TRANSPORT_1', 281619),
(462526, 'PS00862', NULL, 'Oxygen oxidoreductases covalent FAD-binding site.', NULL, NULL, 'OX2_COVAL_FAD', 281620),
(462527, 'PS01213', NULL, 'Protozoan/cyanobacterial globins signature.', NULL, NULL, 'GLOBIN_FAM_2', 281621),
(462528, 'PS00470', NULL, 'Isocitrate and isopropylmalate dehydrogenases signature.', NULL, NULL, 'IDH_IMDH', 281622),
(462529, 'PS01135', NULL, 'FtsZ protein signature 2.', NULL, NULL, 'FTSZ_2', 281623),
(462530, 'PS01324', NULL, 'Glycosyl hydrolases family 4 signature.', NULL, NULL, 'GLYCOSYL_HYDROL_F4', 281624),
(462531, 'PS00935', NULL, 'Glyoxalase I signature 2.', NULL, NULL, 'GLYOXALASE_I_2', 281625),
(462532, 'PS00097', NULL, 'Aspartate and ornithine carbamoyltransferases signature.', NULL, NULL, 'CARBAMOYLTRANSFERASE', 281626),
(462533, 'PS01239', NULL, 'Dynein light chain type 1 signature.', NULL, NULL, 'DYNEIN_LIGHT_1', 281627),
(462534, 'PS01229', NULL, 'Hypothetical cof family signature 2.', NULL, NULL, 'COF_2', 281628),
(462535, 'PS00027', NULL, '''Homeobox'' domain signature.', NULL, NULL, 'HOMEOBOX_1', 281629),
(462536, 'PS00602', NULL, 'Fructose-bisphosphate aldolase class-II signature 1.', NULL, NULL, 'ALDOLASE_CLASS_II_1', 281630),
(462537, 'PS00478', NULL, 'LIM zinc-binding domain signature.', NULL, NULL, 'LIM_DOMAIN_1', 281631),
(462538, 'PS00625', NULL, 'Regulator of chromosome condensation (RCC1) signature 1.', NULL, NULL, 'RCC1_1', 281632);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(462539, 'PS00695', NULL, 'Enterobacterial virulence outer membrane protein signature 2.', NULL, NULL, 'ENT_VIR_OMP_2', 281633),
(462540, 'PS00681', NULL, 'Chaperonins cpn10 signature.', NULL, NULL, 'CHAPERONINS_CPN10', 281634),
(462541, 'PS00496', NULL, 'P-II protein uridylation site.', NULL, NULL, 'PII_GLNB_UMP', 281635),
(462542, 'PS00906', NULL, 'Uroporphyrinogen decarboxylase signature 1.', NULL, NULL, 'UROD_1', 281636),
(462543, 'PS01005', NULL, 'Formate and nitrite transporters signature 1.', NULL, NULL, 'FORMATE_NITRITE_TP_1', 281637),
(462544, 'PS00941', NULL, 'Carboxylesterases type-B signature 2.', NULL, NULL, 'CARBOXYLESTERASE_B_2', 281638),
(462545, 'PS00018', NULL, 'EF-hand calcium-binding domain.', NULL, NULL, 'EF_HAND_1', 281639),
(462546, 'PS00410', NULL, 'Dynamin-type guanine nucleotide-binding (G) domain signature.', NULL, NULL, 'G_DYNAMIN_1', 281640),
(462547, 'PS01261', NULL, 'Uncharacterized protein family UPF0020 signature.', NULL, NULL, 'UPF0020', 281641),
(462548, 'PS01347', NULL, 'MraY family signature 1.', NULL, NULL, 'MRAY_1', 281642),
(462549, 'PS01069', NULL, 'Prokaryotic diacylglycerol kinase signature.', NULL, NULL, 'DAGK_PROKAR', 281643),
(462550, 'PS01080', NULL, 'Apoptosis regulator, Bcl-2 family BH1 motif signature.', NULL, NULL, 'BH1', 281644),
(462551, 'PS01165', NULL, 'Copper amine oxidase copper-binding site signature.', NULL, NULL, 'COPPER_AMINE_OXID_2', 281645),
(462552, 'PS00591', NULL, 'Glycosyl hydrolases family 10 (GH10) active site.', NULL, NULL, 'GH10_1', 281646),
(462553, 'PS00606', NULL, 'Beta-ketoacyl synthases active site.', NULL, NULL, 'B_KETOACYL_SYNTHASE', 281647),
(462554, 'PS00721', NULL, 'Formate--tetrahydrofolate ligase signature 1.', NULL, NULL, 'FTHFS_1', 281648),
(462555, 'PS00772', NULL, 'Barwin domain signature 2.', NULL, NULL, 'BARWIN_2', 281649),
(462556, 'PS00728', NULL, 'AP endonucleases family 1 signature 3.', NULL, NULL, 'AP_NUCLEASE_F1_3', 281650),
(462557, 'PS01176', NULL, 'Initiation factor 2 signature.', NULL, NULL, 'IF2', 281651),
(462558, 'PS00672', NULL, 'Serine proteases, V8 family, histidine active site.', NULL, NULL, 'V8_HIS', 281652),
(462559, 'PS00011', NULL, 'Vitamin K-dependent carboxylation domain.', NULL, NULL, 'GLA_1', 281653),
(462560, 'PS00242', NULL, 'Integrins alpha chain signature.', NULL, NULL, 'INTEGRIN_ALPHA', 281654),
(462561, 'PS00664', NULL, 'Vinculin repeated domain signature.', NULL, NULL, 'VINCULIN_2', 281655),
(462562, 'PS00104', NULL, 'EPSP synthase signature 1.', NULL, NULL, 'EPSP_SYNTHASE_1', 281656),
(462563, 'PS00203', NULL, 'Vertebrate metallothioneins signature.', NULL, NULL, 'METALLOTHIONEIN_VRT', 281657),
(462564, 'PS01143', NULL, 'Ribosomal protein L31 signature.', NULL, NULL, 'RIBOSOMAL_L31', 281658),
(462565, 'PS01234', NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit B signature.', NULL, NULL, 'GATB', 281659),
(462566, 'PS00817', NULL, 'Erythropoietin / thrombopoeitin signature.', NULL, NULL, 'EPO_TPO', 281660),
(462567, 'PS00982', NULL, 'Bacterial-type phytoene dehydrogenase signature.', NULL, NULL, 'PHYTOENE_DH', 281661),
(462568, 'PS00336', NULL, 'Beta-lactamase class-C active site.', NULL, NULL, 'BETA_LACTAMASE_C', 281662),
(462569, 'PS00773', NULL, 'Chitinases family 19 signature 1.', NULL, NULL, 'CHITINASE_19_1', 281663),
(462570, 'PS00269', NULL, 'Mammalian defensins signature.', NULL, NULL, 'DEFENSIN', 281664),
(462571, 'PS00421', NULL, 'Transmembrane 4 family signature.', NULL, NULL, 'TM4_1', 281665),
(462572, 'PS00206', NULL, 'Transferrin-like domain signature 2.', NULL, NULL, 'TRANSFERRIN_LIKE_2', 281666),
(462573, 'PS00698', NULL, 'Glycosyl hydrolases family 9 (GH9) active site signature 3.', NULL, NULL, 'GH9_3', 281667),
(462574, 'PS00344', NULL, 'GATA-type zinc finger domain.', NULL, NULL, 'GATA_ZN_FINGER_1', 281668),
(462575, 'PS00846', NULL, 'Bacterial regulatory proteins, arsR family signature.', NULL, NULL, 'HTH_ARSR_1', 281669),
(462576, 'PS00840', NULL, 'Uroporphyrin-III C-methyltransferase signature 2.', NULL, NULL, 'SUMT_2', 281670),
(462577, 'PS01247', NULL, 'Inosine-uridine preferring nucleoside hydrolase family signature.', NULL, NULL, 'IUNH', 281671);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(462578, 'PS01039', NULL, 'Bacterial extracellular solute-binding proteins, family 3 signature.', NULL, NULL, 'SBP_BACTERIAL_3', 281672),
(462579, 'PS00789', NULL, 'Chorismate synthase signature 3.', NULL, NULL, 'CHORISMATE_SYNTHASE_3', 281673),
(462580, 'PS01163', NULL, 'Galactose-1-phosphate uridyl transferase family 2 signature.', NULL, NULL, 'GAL_P_UDP_TRANSF_II', 281674),
(462581, 'PS00957', NULL, 'NAD-dependent glycerol-3-phosphate dehydrogenase signature.', NULL, NULL, 'NAD_G3PDH', 281675),
(462582, 'PS00640', NULL, 'Eukaryotic thiol (cysteine) proteases asparagine active site.', NULL, NULL, 'THIOL_PROTEASE_ASN', 281676),
(462583, 'PS01121', NULL, 'Caspase family histidine active site.', NULL, NULL, 'CASPASE_HIS', 281677),
(462584, 'PS00566', NULL, 'Fibrillarin signature.', NULL, NULL, 'FIBRILLARIN', 281678),
(462585, 'PS01155', NULL, 'Endonuclease III family signature.', NULL, NULL, 'ENDONUCLEASE_III_2', 281679),
(462586, 'PS00069', NULL, 'Glucose-6-phosphate dehydrogenase active site.', NULL, NULL, 'G6P_DEHYDROGENASE', 281680),
(462587, 'PS00987', NULL, '6-pyruvoyl tetrahydropterin synthase signature 1.', NULL, NULL, 'PTPS_1', 281681),
(462588, 'PS00132', NULL, 'Zinc carboxypeptidases, zinc-binding region 1 signature.', NULL, NULL, 'CARBOXYPEPT_ZN_1', 281682),
(462589, 'PS00865', NULL, 'Ubiquitin-activating enzyme active site.', NULL, NULL, 'UBIQUITIN_ACTIVAT_2', 281683),
(462590, 'PS00805', NULL, 'Calreticulin family repeated motif signature.', NULL, NULL, 'CALRETICULIN_REPEAT', 281684),
(462591, 'PS00053', NULL, 'Ribosomal protein S8 signature.', NULL, NULL, 'RIBOSOMAL_S8', 281685),
(462592, 'PS00100', NULL, 'Chloramphenicol acetyltransferase active site.', NULL, NULL, 'CAT', 281686),
(462593, 'PS00123', NULL, 'Alkaline phosphatase active site.', NULL, NULL, 'ALKALINE_PHOSPHATASE', 281687),
(462594, 'PS00227', NULL, 'Tubulin subunits alpha, beta, and gamma signature.', NULL, NULL, 'TUBULIN', 281688),
(462595, 'PS00023', NULL, 'Fibronectin type-II collagen-binding domain signature.', NULL, NULL, 'FN2_1', 281689),
(462596, 'PS00858', NULL, 'Prephenate dehydratase signature 2.', NULL, NULL, 'PREPHENATE_DEHYDR_2', 281690),
(462597, 'PS01265', NULL, 'Tpx family signature.', NULL, NULL, 'TPX', 281691),
(462598, 'PS00055', NULL, 'Ribosomal protein S12 signature.', NULL, NULL, 'RIBOSOMAL_S12', 281692),
(462599, 'PS01190', NULL, 'Ribosomal protein L36e signature.', NULL, NULL, 'RIBOSOMAL_L36E', 281693),
(462600, 'PS00056', NULL, 'Ribosomal protein S17 signature.', NULL, NULL, 'RIBOSOMAL_S17', 281694),
(462601, 'PS00661', NULL, 'FERM domain signature 2.', NULL, NULL, 'FERM_2', 281695),
(462602, 'PS00669', NULL, 'Gas vesicles protein GVPa signature 2.', NULL, NULL, 'GAS_VESICLE_A_2', 281696),
(462603, 'PS01014', NULL, 'Transcription termination factor nusG signature.', NULL, NULL, 'NUSG', 281697),
(462604, 'PS01043', NULL, 'Transposases, IS30 family, signature.', NULL, NULL, 'TRANSPOSASE_IS30', 281698),
(462605, 'PS01309', NULL, 'Uncharacterized protein family UPF0057 signature.', NULL, NULL, 'UPF0057', 281699),
(462606, 'PS01250', NULL, 'Arthropod CHH/MIH/GIH neurohormones family signature.', NULL, NULL, 'CHH_MIH_GIH', 281700),
(462607, 'PS40000', NULL, 'DM DNA-binding domain signature.', NULL, NULL, 'DM_1', 281701),
(462608, 'PS00279', NULL, 'Membrane attack complex/perforin (MACPF) domain signature.', NULL, NULL, 'MACPF_1', 281702),
(462609, 'PS00482', NULL, 'Dihydroorotase signature 1.', NULL, NULL, 'DIHYDROOROTASE_1', 281703),
(462610, 'PS01272', NULL, 'Glucokinase regulatory protein family signature.', NULL, NULL, 'GCKR', 281704),
(462611, 'PS00797', NULL, '14-3-3 proteins signature 2.', NULL, NULL, '1433_2', 281705),
(462612, 'PS00702', NULL, 'Granulocyte-macrophage colony-stimulating factor signature.', NULL, NULL, 'GM_CSF', 281706),
(462613, 'PS00880', NULL, 'Acyl-CoA-binding (ACB) domain signature.', NULL, NULL, 'ACB_1', 281707),
(462614, 'PS01210', NULL, 'Caveolins signature.', NULL, NULL, 'CAVEOLIN', 281708),
(462615, 'PS00655', NULL, 'Glycosyl hydrolases family 6 signature 1.', NULL, NULL, 'GLYCOSYL_HYDROL_F6_1', 281709);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(462616, 'PS00656', NULL, 'Glycosyl hydrolases family 6 signature 2.', NULL, NULL, 'GLYCOSYL_HYDROL_F6_2', 281710),
(462617, 'PS00811', NULL, 'Oleosins signature.', NULL, NULL, 'OLEOSINS', 281711),
(462618, 'PS00431', NULL, 'Small hydrophilic plant seed proteins signature.', NULL, NULL, 'SMALL_HYDR_PLANT_SEED', 281712),
(462619, 'PS00844', NULL, 'D-alanine--D-alanine ligase signature 2.', NULL, NULL, 'DALA_DALA_LIGASE_2', 281713),
(462620, 'PS00680', NULL, 'Methionine aminopeptidase subfamily 1 signature.', NULL, NULL, 'MAP_1', 281714),
(462621, 'PS00088', NULL, 'Manganese and iron superoxide dismutases signature.', NULL, NULL, 'SOD_MN', 281715),
(462622, 'PS00423', NULL, 'Granins signature 2.', NULL, NULL, 'GRANINS_2', 281716),
(462623, 'PS00939', NULL, 'Ribosomal protein L1e signature.', NULL, NULL, 'RIBOSOMAL_L1E', 281717),
(462624, 'PS01066', NULL, 'Undecaprenyl pyrophosphate synthase family signature.', NULL, NULL, 'UPP_SYNTHASE', 281718),
(462625, 'PS00595', NULL, 'Aminotransferases class-V pyridoxal-phosphate attachment site.', NULL, NULL, 'AA_TRANSFER_CLASS_5', 281719),
(462626, 'PS00878', NULL, 'Orn/DAP/Arg decarboxylases family 2 pyridoxal-P attachment site.', NULL, NULL, 'ODR_DC_2_1', 281720),
(462627, 'PS00202', NULL, 'Rubredoxin signature.', NULL, NULL, 'RUBREDOXIN', 281721),
(462628, 'PS00870', NULL, 'Chaperonins clpA/B signature 1.', NULL, NULL, 'CLPAB_1', 281722),
(462629, 'PS01018', NULL, 'Sterol reductase family signature 2.', NULL, NULL, 'STEROL_REDUCT_2', 281723),
(462630, 'PS01007', NULL, 'Transposases, Mutator family, signature.', NULL, NULL, 'TRANSPOSASE_MUTATOR', 281724),
(462631, 'PS00042', NULL, 'Crp-type HTH domain signature.', NULL, NULL, 'HTH_CRP_1', 281725),
(462632, 'PS01350', NULL, '2C-methyl-D-erythritol 2,4-cyclodiphosphate synthase signature.', NULL, NULL, 'ISPF', 281726),
(462633, 'PS01015', NULL, 'Ribosomal protein L19 signature.', NULL, NULL, 'RIBOSOMAL_L19', 281727),
(462634, 'PS01312', NULL, 'SecA family signature.', NULL, NULL, 'SECA', 281728),
(462635, 'PS00678', NULL, 'Trp-Asp (WD) repeats signature.', NULL, NULL, 'WD_REPEATS_1', 281729),
(462636, 'PS00497', NULL, 'Tyrosinase CuA-binding region signature.', NULL, NULL, 'TYROSINASE_1', 281730),
(462637, 'PS00974', NULL, 'Mannitol dehydrogenases signature.', NULL, NULL, 'MANNITOL_DHGENASE', 281731),
(462638, 'PS00597', NULL, 'Plant lipid transfer proteins signature.', NULL, NULL, 'PLANT_LTP', 281732),
(462639, 'PS00895', NULL, '3-hydroxyisobutyrate dehydrogenase signature.', NULL, NULL, '3_HYDROXYISOBUT_DH', 281733),
(462640, 'PS00126', NULL, '3''5''-cyclic nucleotide phosphodiesterase domain signature.', NULL, NULL, 'PDEASE_I_1', 281734),
(462641, 'PS00171', NULL, 'Triosephosphate isomerase active site.', NULL, NULL, 'TIM_1', 281735),
(462642, 'PS00960', NULL, 'BTG family signature 1.', NULL, NULL, 'BTG_1', 281736),
(462643, 'PS00366', NULL, 'Uricase signature.', NULL, NULL, 'URICASE', 281737),
(462644, 'PS01132', NULL, 'Actins and actin-related proteins signature.', NULL, NULL, 'ACTINS_ACT_LIKE', 281738),
(462645, 'PS00029', NULL, 'Leucine zipper pattern.', NULL, NULL, 'LEUCINE_ZIPPER', 281739),
(462646, 'PS00359', NULL, 'Ribosomal protein L11 signature.', NULL, NULL, 'RIBOSOMAL_L11', 281740),
(462647, 'PS00676', NULL, 'Sigma-54 interaction domain ATP-binding region B signature.', NULL, NULL, 'SIGMA54_INTERACT_2', 281741),
(462648, 'PS00551', NULL, 'Prokaryotic molybdopterin oxidoreductases signature 1.', NULL, NULL, 'MOLYBDOPTERIN_PROK_1', 281742),
(462649, 'PS00874', NULL, 'Bacterial type II secretion system protein F signature.', NULL, NULL, 'T2SP_F', 281743),
(462650, 'PS01044', NULL, 'Squalene and phytoene synthases signature 1.', NULL, NULL, 'SQUALEN_PHYTOEN_SYN_1', 281744),
(462651, 'PS00444', NULL, 'Polyprenyl synthases signature 2.', NULL, NULL, 'POLYPRENYL_SYNTHASE_2', 281745),
(462652, 'PS00688', NULL, 'Sigma-54 interaction domain C-terminal part signature.', NULL, NULL, 'SIGMA54_INTERACT_3', 281746),
(462653, 'PS00555', NULL, 'Plant viruses icosahedral capsid proteins ''S'' region signature.', NULL, NULL, 'ICOSAH_VIR_COAT_S', 281747);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(462654, 'PS00847', NULL, 'MCM family signature.', NULL, NULL, 'MCM_1', 281748),
(462655, 'PS00096', NULL, 'Serine hydroxymethyltransferase pyridoxal-phosphate attachment site.', NULL, NULL, 'SHMT', 281749),
(462656, 'PS00704', NULL, 'Prokaryotic-type carbonic anhydrases signature 1.', NULL, NULL, 'PROK_CO2_ANHYDRASE_1', 281750),
(462657, 'PS00281', NULL, 'Bowman-Birk serine protease inhibitors family signature.', NULL, NULL, 'BOWMAN_BIRK', 281751),
(462658, 'PS00574', NULL, 'Fatty acid desaturases family 2 signature.', NULL, NULL, 'FATTY_ACID_DESATUR_2', 281752),
(462659, 'PS00485', NULL, 'Adenosine and AMP deaminase signature.', NULL, NULL, 'A_DEAMINASE', 281753),
(462660, 'PS00667', NULL, 'Respiratory-chain NADH dehydrogenase subunit 1 signature 1.', NULL, NULL, 'COMPLEX1_ND1_1', 281754),
(462661, 'PS00388', NULL, 'Proteasome alpha-type subunits signature.', NULL, NULL, 'PROTEASOME_ALPHA_1', 281755),
(462662, 'PS60023', NULL, 'Omega-agatoxin type II and III signature.', NULL, NULL, 'OMEGA_AGA_II_III', 281756),
(462663, 'PS00737', NULL, 'Thiolases signature 2.', NULL, NULL, 'THIOLASE_2', 281757),
(462664, 'PS00903', NULL, 'Cytidine and deoxycytidylate deaminases zinc-binding region signature.', NULL, NULL, 'CYT_DCMP_DEAMINASES_1', 281758),
(462665, 'PS00094', NULL, 'C-5 cytosine-specific DNA methylases active site.', NULL, NULL, 'C5_MTASE_1', 281759),
(462666, 'PS00471', NULL, 'Small cytokines (intercrine/chemokine) C-x-C subfamily signature.', NULL, NULL, 'SMALL_CYTOKINES_CXC', 281760),
(462667, 'PS01237', NULL, 'Uncharacterized protein family UPF0028 signature.', NULL, NULL, 'UPF0028', 281761),
(462668, 'PS00853', NULL, 'Beta-eliminating lyases pyridoxal-phosphate attachment site.', NULL, NULL, 'BETA_ELIM_LYASE', 281762),
(462669, 'PS00682', NULL, 'ZP domain signature.', NULL, NULL, 'ZP_1', 281763),
(462670, 'PS00685', NULL, 'NF-YB/HAP3 subunit signature.', NULL, NULL, 'NFYB_HAP3', 281764),
(462671, 'PS00593', NULL, 'Heme oxygenase signature.', NULL, NULL, 'HEME_OXYGENASE', 281765),
(462672, 'PS00671', NULL, 'D-isomer specific 2-hydroxyacid dehydrogenases signature 3.', NULL, NULL, 'D_2_HYDROXYACID_DH_3', 281766),
(462673, 'PS00224', NULL, 'Clathrin light chain signature 1.', NULL, NULL, 'CLATHRIN_LIGHT_CHN_1', 281767),
(462674, 'PS00614', NULL, 'Indole-3-glycerol phosphate synthase signature.', NULL, NULL, 'IGPS', 281768),
(462675, 'PS00072', NULL, 'Acyl-CoA dehydrogenases signature 1.', NULL, NULL, 'ACYL_COA_DH_1', 281769),
(462676, 'PS00266', NULL, 'Somatotropin, prolactin and related hormones signature 1.', NULL, NULL, 'SOMATOTROPIN_1', 281770),
(462677, 'PS01270', NULL, 'Band 7 protein family signature.', NULL, NULL, 'BAND_7', 281771),
(462678, 'PS00857', NULL, 'Prephenate dehydratase signature 1.', NULL, NULL, 'PREPHENATE_DEHYDR_1', 281772),
(462679, 'PS01149', NULL, 'Rsu family of pseudouridine synthase signature.', NULL, NULL, 'PSI_RSU', 281773),
(462680, 'PS01280', NULL, 'Glucose inhibited division protein A family signature 1.', NULL, NULL, 'GIDA_1', 281774),
(462681, 'PS00730', NULL, 'AP endonucleases family 2 signature 2.', NULL, NULL, 'AP_NUCLEASE_F2_2', 281775),
(462682, 'PS00127', NULL, 'Pancreatic ribonuclease family signature.', NULL, NULL, 'RNASE_PANCREATIC', 281776),
(462683, 'PS00220', NULL, 'Anion exchangers family signature 2.', NULL, NULL, 'ANION_EXCHANGER_2', 281777),
(462684, 'PS00400', NULL, 'LBP / BPI / CETP family signature.', NULL, NULL, 'LBP_BPI_CETP', 281778),
(462685, 'PS00700', NULL, 'Ribosomal protein L6 signature 2.', NULL, NULL, 'RIBOSOMAL_L6_2', 281779),
(462686, 'PS00314', NULL, 'Bacterial ice-nucleation proteins octamer repeat.', NULL, NULL, 'ICE_NUCLEATION', 281780),
(462687, 'PS00694', NULL, 'Enterobacterial virulence outer membrane protein signature 1.', NULL, NULL, 'ENT_VIR_OMP_1', 281781),
(462688, 'PS01215', NULL, 'Mrp family signature.', NULL, NULL, 'MRP', 281782),
(462689, 'PS00760', NULL, 'Signal peptidases I lysine active site.', NULL, NULL, 'SPASE_I_2', 281783),
(462690, 'PS01259', NULL, 'Apoptosis regulator, Bcl-2 family BH3 motif signature.', NULL, NULL, 'BH3', 281784);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(462691, 'PS00481', NULL, 'Thiol-activated cytolysins signature.', NULL, NULL, 'THIOL_CYTOLYSINS', 281785),
(462692, 'PS00712', NULL, 'Ribosomal protein S17e signature.', NULL, NULL, 'RIBOSOMAL_S17E', 281786),
(462693, 'PS00379', NULL, 'CDP-alcohol phosphatidyltransferases signature.', NULL, NULL, 'CDP_ALCOHOL_P_TRANSF', 281787),
(462694, 'PS00569', NULL, 'Myelin basic protein signature.', NULL, NULL, 'MYELIN_MBP', 281788),
(462695, 'PS00076', NULL, 'Pyridine nucleotide-disulphide oxidoreductases class-I active site.', NULL, NULL, 'PYRIDINE_REDOX_1', 281789),
(462696, 'PS00261', NULL, 'Glycoprotein hormones beta chain signature 1.', NULL, NULL, 'GLYCO_HORMONE_BETA_1', 281790),
(462697, 'PS00460', NULL, 'Glutathione peroxidases active site.', NULL, NULL, 'GLUTATHIONE_PEROXID_1', 281791),
(462698, 'PS00491', NULL, 'Aminopeptidase P and proline dipeptidase signature.', NULL, NULL, 'PROLINE_PEPTIDASE', 281792),
(462699, 'PS01053', NULL, 'Arginase family signature.', NULL, NULL, 'ARGINASE_1', 281793),
(462700, 'PS00217', NULL, 'Sugar transport proteins signature 2.', NULL, NULL, 'SUGAR_TRANSPORT_2', 281794),
(462701, 'PS00538', NULL, 'Bacterial chemotaxis sensory transducers signature.', NULL, NULL, 'CHEMOTAXIS_TRANSDUC_1', 281795),
(462702, 'PS01134', NULL, 'FtsZ protein signature 1.', NULL, NULL, 'FTSZ_1', 281796),
(462703, 'PS00341', NULL, 'Surfactant associated polypeptide SP-C palmitoylation sites.', NULL, NULL, 'SURFACT_PALMITOYL', 281797),
(462704, 'PS01316', NULL, 'ATP phosphoribosyltransferase signature.', NULL, NULL, 'ATP_P_PHORIBOSYLTR', 281798),
(462705, 'PS00411', NULL, 'Kinesin motor domain signature.', NULL, NULL, 'KINESIN_MOTOR_1', 281799),
(462706, 'PS60005', NULL, 'Delta-conotoxin family signature.', NULL, NULL, 'DELTA_CONOTOXIN', 281800),
(462707, 'PS00198', NULL, '4Fe-4S ferredoxin-type iron-sulfur binding region signature.', NULL, NULL, '4FE4S_FER_1', 281801),
(462708, 'PS00663', NULL, 'Vinculin family talin-binding region signature.', NULL, NULL, 'VINCULIN_1', 281802),
(462709, 'PS01172', NULL, 'Ribosomal protein L44e signature.', NULL, NULL, 'RIBOSOMAL_L44E', 281803),
(462710, 'PS01348', NULL, 'MraY family signature 2.', NULL, NULL, 'MRAY_2', 281804),
(462711, 'PS00446', NULL, 'RNA polymerases D / 30 to 40 Kd subunits signature.', NULL, NULL, 'RNA_POL_D_30KD', 281805),
(462712, 'PS00105', NULL, 'Aminotransferases class-I pyridoxal-phosphate attachment site.', NULL, NULL, 'AA_TRANSFER_CLASS_1', 281806),
(462713, 'PS00573', NULL, 'Pyridine nucleotide-disulphide oxidoreductases class-II active site.', NULL, NULL, 'PYRIDINE_REDOX_2', 281807),
(462714, 'PS00221', NULL, 'MIP family signature.', NULL, NULL, 'MIP', 281808),
(462715, 'PS00609', NULL, 'Glycosyl hydrolases family 32 active site.', NULL, NULL, 'GLYCOSYL_HYDROL_F32', 281809),
(462716, 'PS00163', NULL, 'Fumarate lyases signature.', NULL, NULL, 'FUMARATE_LYASES', 281810),
(462717, 'PS01315', NULL, 'Phosphatidate cytidylyltransferase signature.', NULL, NULL, 'CDS', 281811),
(462718, 'PS01228', NULL, 'Hypothetical cof family signature 1.', NULL, NULL, 'COF_1', 281812),
(462719, 'PS01232', NULL, 'Purine and other phosphorylases family 1 signature.', NULL, NULL, 'PNP_UDP_1', 281813),
(462720, 'PS01279', NULL, 'Protein-L-isoaspartate(D-aspartate) O-methyltransferase signature.', NULL, NULL, 'PCMT', 281814),
(462721, 'PS00414', NULL, 'Profilin signature.', NULL, NULL, 'PROFILIN', 281815),
(462722, 'PS00249', NULL, 'Platelet-derived growth factor (PDGF) family signature.', NULL, NULL, 'PDGF_1', 281816),
(462723, 'PS01289', NULL, 'TSC-22 / dip / bun family signature.', NULL, NULL, 'TSC22', 281817),
(462724, 'PS00028', NULL, 'Zinc finger C2H2 type domain signature.', NULL, NULL, 'ZINC_FINGER_C2H2_1', 281818),
(462725, 'PS00626', NULL, 'Regulator of chromosome condensation (RCC1) signature 2.', NULL, NULL, 'RCC1_2', 281819),
(462726, 'PS00697', NULL, 'ATP-dependent DNA ligase AMP-binding site.', NULL, NULL, 'DNA_LIGASE_A1', 281820),
(462727, 'PS00187', NULL, 'Thiamine pyrophosphate enzymes signature.', NULL, NULL, 'TPP_ENZYMES', 281821);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(462728, 'PS51135', NULL, 'CIDE-N domain profile.', NULL, NULL, 'CIDE_N', 281822),
(462729, 'PS51900', NULL, 'Core-binding (CB) domain profile.', NULL, NULL, 'CB', 281823),
(462730, 'PS50929', NULL, 'ABC transporter integral membrane type-1 fused domain profile.', NULL, NULL, 'ABC_TM1F', 281824),
(462731, 'PS51645', NULL, 'Photolyase/cryptochrome alpha/beta domain profile.', NULL, NULL, 'PHR_CRY_ALPHA_BETA', 281825),
(462732, 'PS51223', NULL, 'MAP repeat profile.', NULL, NULL, 'MAP', 281826),
(462733, 'PS51240', NULL, 'Nod factors export ATP-binding protein I nodI family profile.', NULL, NULL, 'NODI', 281827),
(462734, 'PS51833', NULL, 'HD-related output (HDOD) domain profile.', NULL, NULL, 'HDOD', 281828),
(462735, 'PS51297', NULL, 'K-box domain profile.', NULL, NULL, 'K_BOX', 281829),
(462736, 'PS51581', NULL, 'SAM-dependent methyltransferase gamma-tocopherol (gTMT)-type family profile.', NULL, NULL, 'SAM_GTMT', 281830),
(462737, 'PS51642', NULL, 'Hemopexin repeat profile.', NULL, NULL, 'HEMOPEXIN_2', 281831),
(462738, 'PS51438', NULL, 'Albumin domain profile.', NULL, NULL, 'ALBUMIN_2', 281832),
(462739, 'PS50109', NULL, 'Histidine kinase domain profile.', NULL, NULL, 'HIS_KIN', 281833),
(462740, 'PS51290', NULL, 'CRIC domain profile.', NULL, NULL, 'CRIC', 281834),
(462741, 'PS51763', NULL, 'CBM10 (carbohydrate-binding type-10) domain profile.', NULL, NULL, 'CBM10', 281835),
(462742, 'PS50054', NULL, 'Dual specificity protein phosphatase domain profile.', NULL, NULL, 'TYR_PHOSPHATASE_DUAL', 281836),
(462743, 'PS50062', NULL, 'BCL2-like apoptosis inhibitors family profile.', NULL, NULL, 'BCL2_FAMILY', 281837),
(462744, 'PS51366', NULL, 'MI domain profile.', NULL, NULL, 'MI', 281838),
(462745, 'PS51145', NULL, 'ZU5 domain profile.', NULL, NULL, 'ZU5', 281839),
(462746, 'PS51302', NULL, 'Single-minded C-terminal domain profile.', NULL, NULL, 'SIM_C', 281840),
(462747, 'PS51718', NULL, 'Dynamin-type guanine nucleotide-binding (G) domain profile.', NULL, NULL, 'G_DYNAMIN_2', 281841),
(462748, 'PS51401', NULL, 'CHORD domain profile.', NULL, NULL, 'CHORD', 281842),
(462749, 'PS50283', NULL, 'Sodium:solute symporter family profile.', NULL, NULL, 'NA_SOLUT_SYMP_3', 281843),
(462750, 'PS50089', NULL, 'Zinc finger RING-type profile.', NULL, NULL, 'ZF_RING_2', 281844),
(462751, 'PS51096', NULL, 'PTS_EIIA type-4 domain profile.', NULL, NULL, 'PTS_EIIA_TYPE_4', 281845),
(462752, 'PS51881', NULL, 'Obg C-terminal (OCT) domain profile.', NULL, NULL, 'OCT', 281846),
(462753, 'PS01225', NULL, 'C-terminal cystine knot domain profile.', NULL, NULL, 'CTCK_2', 281847),
(462754, 'PS51543', NULL, 'FYR domain FYRC motif profile.', NULL, NULL, 'FYRC', 281848),
(462755, 'PS50957', NULL, 'Josephin domain profile.', NULL, NULL, 'JOSEPHIN', 281849),
(462756, 'PS51192', NULL, 'Superfamilies 1 and 2 helicase ATP-binding type-1 domain profile.', NULL, NULL, 'HELICASE_ATP_BIND_1', 281850),
(462757, 'PS50315', NULL, 'Glycine-rich region profile.', NULL, NULL, 'GLY_RICH', 281851),
(462758, 'PS51562', NULL, 'mRNA (guanine-N(7)-)-methyltransferase (EC 2.1.1.56) domain profile.', NULL, NULL, 'RNA_CAP0_MT', 281852),
(462759, 'PS51746', NULL, 'PPM-type phosphatase domain profile.', NULL, NULL, 'PPM_2', 281853),
(462760, 'PS50865', NULL, 'Zinc finger MYND-type profile.', NULL, NULL, 'ZF_MYND_2', 281854),
(462761, 'PS51441', NULL, 'CpcD-like domain profile.', NULL, NULL, 'CPCD_LIKE', 281855),
(462762, 'PS51293', NULL, 'SANT domain profile.', NULL, NULL, 'SANT', 281856),
(462763, 'PS51859', NULL, 'Rho-binding (RhoBD) domain profile.', NULL, NULL, 'RHO_BD', 281857),
(462764, 'PS50821', NULL, 'PAZ domain profile.', NULL, NULL, 'PAZ', 281858),
(462765, 'PS51902', NULL, 'ClpX zinc binding (ZB) domain profile.', NULL, NULL, 'CLPX_ZB', 281859),
(462766, 'PS50949', NULL, 'GntR-type HTH domain profile.', NULL, NULL, 'HTH_GNTR', 281860),
(462767, 'PS50068', NULL, 'LDL-receptor class A (LDLRA) domain profile.', NULL, NULL, 'LDLRA_2', 281861),
(462768, 'PS51011', NULL, 'ARID domain profile.', NULL, NULL, 'ARID', 281862),
(462769, 'PS51106', NULL, 'PTS_EIIC type-4 domain profile.', NULL, NULL, 'PTS_EIIC_TYPE_4', 281863);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(462770, 'PS51876', NULL, 'Pestivirus N-terminal protease Npro domain profile.', NULL, NULL, 'PV_NPRO', 281864),
(462771, 'PS50099', NULL, 'Proline-rich region profile.', NULL, NULL, 'PRO_RICH', 281865),
(462772, 'PS50858', NULL, 'BSD domain profile.', NULL, NULL, 'BSD', 281866),
(462773, 'PS50954', NULL, 'LEM domain profile.', NULL, NULL, 'LEM', 281867),
(462774, 'PS51058', NULL, 'Zinc finger CXXC-type profile.', NULL, NULL, 'ZF_CXXC', 281868),
(462775, 'PS50020', NULL, 'WW/rsp5/WWP domain profile.', NULL, NULL, 'WW_DOMAIN_2', 281869),
(462776, 'PS50999', NULL, 'Cytochrome oxidase subunit II transmembrane region profile.', NULL, NULL, 'COX2_TM', 281870),
(462777, 'PS51837', NULL, 'LITAF domain profile.', NULL, NULL, 'LITAF', 281871),
(462778, 'PS51647', NULL, 'Kininogen-type cystatin domain profile.', NULL, NULL, 'CYSTATIN_KININOGEN', 281872),
(462779, 'PS51213', NULL, 'ELK domain profile.', NULL, NULL, 'ELK', 281873),
(462780, 'PS51698', NULL, 'U-box domain profile.', NULL, NULL, 'U_BOX', 281874),
(462781, 'PS50844', NULL, 'Antifreeze protein-like domain profile.', NULL, NULL, 'AFP_LIKE', 281875),
(462782, 'PS51012', NULL, 'ABC transporter integral membrane type-2 domain profile.', NULL, NULL, 'ABC_TM2', 281876),
(462783, 'PS51176', NULL, 'Prephenate/arogenate dehydrogenase domain profile.', NULL, NULL, 'PDH_ADH', 281877),
(462784, 'PS50007', NULL, 'Phosphatidylinositol-specific phospholipase X-box domain profile.', NULL, NULL, 'PIPLC_X_DOMAIN', 281878),
(462785, 'PS50162', NULL, 'RecA family profile 1.', NULL, NULL, 'RECA_2', 281879),
(462786, 'PS51592', NULL, 'mRNA (2''-O-methyladenosine-N(6)-)-methyltransferase-like (MT-A70-like) family profile.', NULL, NULL, 'SAM_MTA70L_2', 281880),
(462787, 'PS51220', NULL, 'NIDO domain profile.', NULL, NULL, 'NIDO', 281881),
(462788, 'PS51178', NULL, 'PASTA domain profile.', NULL, NULL, 'PASTA', 281882),
(462789, 'PS51869', NULL, 'Amyloid precursor protein (APP) E1 domain profile.', NULL, NULL, 'APP_E1', 281883),
(462790, 'PS51625', NULL, 'SAM-dependent methyltransferase TRMB-type domain profile.', NULL, NULL, 'SAM_MT_TRMB', 281884),
(462791, 'PS51644', NULL, 'OST-type HTH domain profile.', NULL, NULL, 'HTH_OST', 281885),
(462792, 'PS51258', NULL, 'Munc13-homology domain 1 (MHD1) profile.', NULL, NULL, 'MHD1', 281886),
(462793, 'PS51710', NULL, 'OBG-type guanine nucleotide-binding (G) domain profile.', NULL, NULL, 'G_OBG', 281887),
(462794, 'PS51608', NULL, 'UbiE family SAM-binding methyltransferase profile.', NULL, NULL, 'SAM_MT_UBIE', 281888),
(462795, 'PS51684', NULL, 'SAM-dependent methyltransferase TRM5/TYW2-type domain profile.', NULL, NULL, 'SAM_MT_TRM5_TYW2', 281889),
(462796, 'PS51078', NULL, 'IclR effector binding domain profile.', NULL, NULL, 'ICLR_ED', 281890),
(462797, 'PS51732', NULL, 'Asparaginase / glutaminase domain profile.', NULL, NULL, 'ASN_GLN_ASE_3', 281891),
(462798, 'PS51570', NULL, 'Histone-lysine N-methyltransferase (EC 2.1.1.43) family profile.', NULL, NULL, 'SAM_MT43_SUVAR420_2', 281892),
(462799, 'PS51492', NULL, 'Peptidase family C23 domain profile.', NULL, NULL, 'PEPTIDASE_C23', 281893),
(462800, 'PS51866', NULL, 'Mop domain profile.', NULL, NULL, 'MOP', 281894),
(462801, 'PS50993', NULL, 'Nidogen G2 beta-barrel domain profile.', NULL, NULL, 'NIDOGEN_G2', 281895),
(462802, 'PS50931', NULL, 'LysR-type HTH domain profile.', NULL, NULL, 'HTH_LYSR', 281896),
(462803, 'PS51379', NULL, '4Fe-4S ferredoxin-type iron-sulfur binding domain profile.', NULL, NULL, '4FE4S_FER_2', 281897),
(462804, 'PS51316', NULL, 'Olduvai (ODV) domain profile.', NULL, NULL, 'ODV', 281898),
(462805, 'PS51190', NULL, 'FATC domain profile.', NULL, NULL, 'FATC', 281899),
(462806, 'PS51166', NULL, 'CBM20 (carbohydrate binding type-20) domain profile.', NULL, NULL, 'CBM20', 281900),
(462807, 'PS50112', NULL, 'PAS repeat profile.', NULL, NULL, 'PAS', 281901),
(462808, 'PS51068', NULL, 'Formamidopyrimidine-DNA glycosylase catalytic domain profile.', NULL, NULL, 'FPG_CAT', 281902),
(462809, 'PS51386', NULL, 'RINT1/TIP20 domain profile.', NULL, NULL, 'RINT1_TIP20', 281903);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(462810, 'PS50966', NULL, 'Zinc finger SWIM-type profile.', NULL, NULL, 'ZF_SWIM', 281904),
(462811, 'PS50936', NULL, 'EngC GTPase domain profile.', NULL, NULL, 'ENGC_GTPASE', 281905),
(462812, 'PS51984', NULL, 'Cryptic Polo-Box 1 (CPB1) domain profile.', NULL, NULL, 'CPB1', 281906),
(462813, 'PS50207', NULL, 'Caspase family p10 domain profile.', NULL, NULL, 'CASPASE_P10', 281907),
(462814, 'PS50905', NULL, 'Ferritin-like diiron domain profile.', NULL, NULL, 'FERRITIN_LIKE', 281908),
(462815, 'PS51576', NULL, 'Histone-lysine N-methyltransferase (EC 2.1.1.43) family profile.', NULL, NULL, 'SAM_MT43_EZ', 281909),
(462816, 'PS51685', NULL, 'SAM-dependent methyltransferase Erg6/SMT-type domain profile.', NULL, NULL, 'SAM_MT_ERG6_SMT', 281910),
(462817, 'PS51567', NULL, 'Histone-lysine N-methyltransferase (EC 2.1.1.43) family profile.', NULL, NULL, 'SAM_MT43_SUVAR420_1', 281911),
(462818, 'PS51800', NULL, 'Zinc finger CHHC U11-48K-type profile.', NULL, NULL, 'ZF_CHHC_U11_48K', 281912),
(462819, 'PS51263', NULL, 'ADF-H domain profile.', NULL, NULL, 'ADF_H', 281913),
(462820, 'PS50822', NULL, 'Piwi domain profile.', NULL, NULL, 'PIWI', 281914),
(462821, 'PS51054', NULL, 'Orange domain profile.', NULL, NULL, 'ORANGE', 281915),
(462822, 'PS51721', NULL, 'Circularly permuted (CP)-type guanine nucleotide-binding (G) domain profile.', NULL, NULL, 'G_CP', 281916),
(462823, 'PS51277', NULL, 'BURP domain profile.', NULL, NULL, 'BURP', 281917),
(462824, 'PS50901', NULL, 'FtsK domain profile.', NULL, NULL, 'FTSK', 281918),
(462825, 'PS50968', NULL, 'Biotinyl/lipoyl domain profile.', NULL, NULL, 'BIOTINYL_LIPOYL', 281919),
(462826, 'PS51666', NULL, 'QLQ domain profile.', NULL, NULL, 'QLQ', 281920),
(462827, 'PS51530', NULL, 'Fetuin-B-type cystatin domain profile.', NULL, NULL, 'CYSTATIN_FETUIN_B', 281921),
(462828, 'PS51891', NULL, 'CENP-V/GFA domain profile.', NULL, NULL, 'CENP_V_GFA', 281922),
(462829, 'PS51554', NULL, 'Pyruvate formate-lyase domain profile.', NULL, NULL, 'PFL', 281923),
(462830, 'PS51758', NULL, 'Letm1 ribosome-binding (RBD) domain profile.', NULL, NULL, 'LETM1_RBD', 281924),
(462831, 'PS50906', NULL, 'Nitrate and nitrite sensing (NIT) domain profile.', NULL, NULL, 'NIT', 281925),
(462832, 'PS51483', NULL, 'B5 domain profile.', NULL, NULL, 'B5', 281926),
(462833, 'PS51880', NULL, 'TGS domain profile.', NULL, NULL, 'TGS', 281927),
(462834, 'PS50302', NULL, 'Pumilio RNA-binding repeat profile.', NULL, NULL, 'PUM', 281928),
(462835, 'PS51329', NULL, 'C-CAP/cofactor C-like domain profile.', NULL, NULL, 'C_CAP_COFACTOR_C', 281929),
(462836, 'PS51635', NULL, 'Patatin-like phospholipase (PNPLA) domain profile.', NULL, NULL, 'PNPLA', 281930),
(462837, 'PS50135', NULL, 'Zinc finger ZZ-type profile.', NULL, NULL, 'ZF_ZZ_2', 281931),
(462838, 'PS50197', NULL, 'BEACH domain profile.', NULL, NULL, 'BEACH', 281932),
(462839, 'PS50948', NULL, 'PAN/Apple domain profile.', NULL, NULL, 'PAN', 281933),
(462840, 'PS51534', NULL, 'SEFIR domain profile.', NULL, NULL, 'SEFIR', 281934),
(462841, 'PS51465', NULL, 'Kazal domain profile.', NULL, NULL, 'KAZAL_2', 281935),
(462842, 'PS51790', NULL, 'Methionine-R-sulfoxide reductase (MsrB) domain profile.', NULL, NULL, 'MSRB', 281936),
(462843, 'PS51688', NULL, 'Intramolecular chaperone auto-processing (ICA) domain profile.', NULL, NULL, 'ICA', 281937),
(462844, 'PS51687', NULL, 'SAM-dependent methyltransferase RNA m(5)U-type domain profile.', NULL, NULL, 'SAM_MT_RNA_M5U', 281938),
(462845, 'PS51432', NULL, 'AP endonucleases family 2 profile.', NULL, NULL, 'AP_NUCLEASE_F2_4', 281939),
(462846, 'PS51745', NULL, 'PB1 domain profile.', NULL, NULL, 'PB1', 281940),
(462847, 'PS50184', NULL, 'VWFC domain profile.', NULL, NULL, 'VWFC_2', 281941),
(462848, 'PS50190', NULL, 'SEC7 domain profile.', NULL, NULL, 'SEC7', 281942),
(462849, 'PS51537', NULL, 'Norovirus 3C-like protease (NV 3CLpro) domain profile.', NULL, NULL, 'NV_3CL_PRO', 281943),
(462850, 'PS51950', NULL, 'Coronavirus RNA-dependent RNA polymerase (RdRp) Nsp8 cofactor domain profile.', NULL, NULL, 'COV_NSP8', 281944);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(462851, 'PS50841', NULL, 'DIX domain profile.', NULL, NULL, 'DIX', 281945),
(462852, 'PS51656', NULL, '4Fe-4S domain profile.', NULL, NULL, '4FE4S', 281946),
(462853, 'PS51743', NULL, 'Alphavirus-like methyltransferase (MT) domain profile.', NULL, NULL, 'ALPHAVIRUS_MT', 281947),
(462854, 'PS51909', NULL, 'Invertebrate (I)-type lysozyme domain profile.', NULL, NULL, 'LYSOZYME_I', 281948),
(462855, 'PS51723', NULL, 'Peptidase family M60 domain profile.', NULL, NULL, 'PEPTIDASE_M60', 281949),
(462856, 'PS51839', NULL, 'His(Cys)3-ligated-type [4Fe-4S] domain profile.', NULL, NULL, '4FE4S_HC3', 281950),
(462857, 'PS50118', NULL, 'HMG boxes A and B DNA-binding domains profile.', NULL, NULL, 'HMG_BOX_2', 281951),
(462858, 'PS50914', NULL, 'BON domain profile.', NULL, NULL, 'BON', 281952),
(462859, 'PS51466', NULL, 'PINIT domain profile.', NULL, NULL, 'PINIT', 281953),
(462860, 'PS51420', NULL, 'small GTPase Rho family profile.', NULL, NULL, 'RHO', 281954),
(462861, 'PS51340', NULL, 'MOSC domain profile.', NULL, NULL, 'MOSC', 281955),
(462862, 'PS50830', NULL, 'Thermonuclease domain profile.', NULL, NULL, 'TNASE_3', 281956),
(462863, 'PS51486', NULL, 'REKLES domain profile.', NULL, NULL, 'REKLES', 281957),
(462864, 'PS51298', NULL, 'Zinc import ATP-binding protein znuC family profile.', NULL, NULL, 'ZNUC', 281958),
(462865, 'PS51548', NULL, 'Birnavirus VP4 protease domain profile.', NULL, NULL, 'BIRNAVIRUS_VP4_PRO', 281959),
(462866, 'PS51381', NULL, 'C2 B9-type domain profile.', NULL, NULL, 'C2_B9', 281960),
(462867, 'PS51457', NULL, 'BEN domain profile.', NULL, NULL, 'BEN', 281961),
(462868, 'PS51514', NULL, 'BRX domain profile.', NULL, NULL, 'BRX', 281962),
(462869, 'PS51155', NULL, 'Chitin-binding type R&R domain profile.', NULL, NULL, 'CHIT_BIND_RR_2', 281963),
(462870, 'PS50043', NULL, 'LuxR-type HTH domain profile.', NULL, NULL, 'HTH_LUXR_2', 281964),
(462871, 'PS51933', NULL, 'EutK-Ctail domain profile.', NULL, NULL, 'EUTK_C', 281965),
(462872, 'PS51389', NULL, 'Xin repeat profile.', NULL, NULL, 'XIN', 281966),
(462873, 'PS51162', NULL, 'Thyroglobulin type-1 domain profile.', NULL, NULL, 'THYROGLOBULIN_1_2', 281967),
(462874, 'PS50227', NULL, 'G-protein coupled receptors family 2 profile 1.', NULL, NULL, 'G_PROTEIN_RECEP_F2_3', 281968),
(462875, 'PS01180', NULL, 'CUB domain profile.', NULL, NULL, 'CUB', 281969),
(462876, 'PS51431', NULL, 'KaiA C-terminal domain profile.', NULL, NULL, 'KAIA_C', 281970),
(462877, 'PS50256', NULL, 'Yeast PIR proteins repeats profile.', NULL, NULL, 'PIR_REPEAT_2', 281971),
(462878, 'PS51081', NULL, 'Zinc finger SIAH-type profile.', NULL, NULL, 'ZF_SIAH', 281972),
(462879, 'PS51121', NULL, 'NtA (N-terminal agrin) domain profile.', NULL, NULL, 'NTA', 281973),
(462880, 'PS50846', NULL, 'Heavy-metal-associated domain profile.', NULL, NULL, 'HMA_2', 281974),
(462881, 'PS51847', NULL, 'Synaptotagmin-like mitochondrial lipid-binding proteins (SMP) domain profile.', NULL, NULL, 'SMP', 281975),
(462882, 'PS50986', NULL, 'MANSC domain profile.', NULL, NULL, 'MANSC', 281976),
(462883, 'PS51885', NULL, 'Neprilysin-like (M13) protease domain profile.', NULL, NULL, 'NEPRILYSIN', 281977),
(462884, 'PS50935', NULL, 'Single-strand binding (SSB) domain profile.', NULL, NULL, 'SSB', 281978),
(462885, 'PS51175', NULL, 'CBM6 (carbohydrate binding type-6) domain profile.', NULL, NULL, 'CBM6', 281979),
(462886, 'PS50033', NULL, 'UBX domain profile.', NULL, NULL, 'UBX', 281980),
(462887, 'PS51437', NULL, 'CG-1 DNA-binding domain profile.', NULL, NULL, 'CG_1', 281981),
(462888, 'PS51860', NULL, 'REM-1 domain profile.', NULL, NULL, 'REM_1', 281982),
(462889, 'PS51821', NULL, 'Velvet domain profile.', NULL, NULL, 'VELVET', 281983),
(462890, 'PS51057', NULL, 'Paired DNA-binding domain profile.', NULL, NULL, 'PAIRED_2', 281984),
(462891, 'PS50908', NULL, 'RWD domain profile.', NULL, NULL, 'RWD', 281985),
(462892, 'PS51414', NULL, 'HSR domain profile.', NULL, NULL, 'HSR', 281986),
(462893, 'PS50119', NULL, 'Zinc finger B-box type profile.', NULL, NULL, 'ZF_BBOX', 281987),
(462894, 'PS50145', NULL, 'Zinc finger TRAF-type profile.', NULL, NULL, 'ZF_TRAF', 281988);
INSERT INTO "PUBLIC"."MODEL" VALUES
(462895, 'PS50177', NULL, 'Nuclear transport factor 2 domain profile.', NULL, NULL, 'NTF2_DOMAIN', 281989),
(462896, 'PS51783', NULL, 'BEACH-type PH domain profile.', NULL, NULL, 'PH_BEACH', 281990),
(462897, 'PS51168', NULL, 'Chorismate mutase domain profile.', NULL, NULL, 'CHORISMATE_MUT_2', 281991),
(462898, 'PS51680', NULL, 'SAM-dependent methyltransferase DRM-type domain profile.', NULL, NULL, 'SAM_MT_DRM', 281992),
(462899, 'PS51958', NULL, 'Nidoviral uridylate-specific endoribonuclease (NendoU) domain profile.', NULL, NULL, 'NENDOU', 281993),
(462900, 'PS51301', NULL, 'KilA-N domain profile.', NULL, NULL, 'KILA_N', 281994),
(462901, 'PS51025', NULL, 'PWI domain profile.', NULL, NULL, 'PWI', 281995),
(462902, 'PS51623', NULL, 'tRNA guanosine-2''-O-methyltransferase (EC 2.1.1.34) family profile.', NULL, NULL, 'SAM_MT_TRMH_1', 281996),
(462903, 'PS51968', NULL, 'Grh/CP2 DNA-binding (DB) domain profile.', NULL, NULL, 'GRH_CP2_DB', 281997),
(462904, 'PS51382', NULL, 'SPX domain profile.', NULL, NULL, 'SPX', 281998),
(462905, 'PS51851', NULL, 'KARI C-terminal domain profile.', NULL, NULL, 'KARI_C', 281999),
(462906, 'PS50828', NULL, 'Smr domain profile.', NULL, NULL, 'SMR', 282000),
(462907, 'PS51650', NULL, 'C2 DOCK-type domain profile.', NULL, NULL, 'C2_DOCK', 282001),
(462908, 'PS50903', NULL, 'Rubredoxin-like domain profile.', NULL, NULL, 'RUBREDOXIN_LIKE', 282002),
(462909, 'PS50955', NULL, 'LEM-like domain profile.', NULL, NULL, 'LEM_LIKE', 282003),
(462910, 'PS51422', NULL, 'small GTPase SAR1 family profile.', NULL, NULL, 'SAR1', 282004),
(462911, 'PS51565', NULL, 'SETD3 actin-histidine N-methyltransferase (EC 2.1.1.85) family profile.', NULL, NULL, 'SAM_MT85_SETD3', 282005),
(462912, 'PS51829', NULL, 'P/Homo B domain profile.', NULL, NULL, 'P_HOMO_B', 282006),
(462913, 'PS51591', NULL, 'mRNA cap 0 and cap 1 methyltransferase (EC 2.1.1.56 and EC 2.1.1.57) domain profile.', NULL, NULL, 'RNA_CAP01_NS5_MT', 282007),
(462914, 'PS51695', NULL, 'Sedolisin domain profile.', NULL, NULL, 'SEDOLISIN', 282008),
(462915, 'PS50221', NULL, 'GPS domain profile.', NULL, NULL, 'GPS', 282009),
(462916, 'PS50820', NULL, 'LCCL domain profile.', NULL, NULL, 'LCCL', 282010),
(462917, 'PS51691', NULL, 'Peptidase family S6 domain profile.', NULL, NULL, 'PEPTIDASE_S6', 282011),
(462918, 'PS51516', NULL, 'Sox C-terminal domain profile.', NULL, NULL, 'SOX_C', 282012),
(462919, 'PS51906', NULL, 'Zinc finger UBZ2-type profile.', NULL, NULL, 'ZF_UBZ2', 282013),
(462920, 'PS50826', NULL, 'RUN domain profile.', NULL, NULL, 'RUN', 282014),
(462921, 'PS51390', NULL, 'WAP-type ''four-disulfide core'' domain profile.', NULL, NULL, 'WAP', 282015),
(462922, 'PS50969', NULL, 'FCP1 homology domain profile.', NULL, NULL, 'FCP1', 282016),
(462923, 'PS51073', NULL, 'RPEL repeat profile.', NULL, NULL, 'RPEL', 282017),
(462924, 'PS51550', NULL, 'Eph receptor ligand-binding domain profile.', NULL, NULL, 'EPH_LBD', 282018),
(462925, 'PS50134', NULL, 'Zinc finger TAZ-type profile.', NULL, NULL, 'ZF_TAZ', 282019),
(462926, 'PS51555', NULL, 'Methionine S-methyltransferase (EC 2.1.1.12) family profile.', NULL, NULL, 'SAM_MT12', 282020),
(462927, 'PS51936', NULL, 'POU-specific (POUs) atypical domain profile.', NULL, NULL, 'POU_4', 282021),
(462928, 'PS51988', NULL, 'Herpesviridae UL32 packaging protein family profile.', NULL, NULL, 'HERPESVIRUS_UL32', 282022),
(462929, 'PS51214', NULL, 'IBB domain profile.', NULL, NULL, 'IBB', 282023),
(462930, 'PS51285', NULL, 'AGC-kinase C-terminal domain profile.', NULL, NULL, 'AGC_KINASE_CTER', 282024),
(462931, 'PS51784', NULL, 'Exonuclease I (ExoI) SH3-like domain profile.', NULL, NULL, 'EXOI_SH3', 282025),
(462932, 'PS01178', NULL, 'Anaphylatoxin domain profile.', NULL, NULL, 'ANAPHYLATOXIN_2', 282026),
(462933, 'PS50056', NULL, 'Tyrosine specific protein phosphatases domain profile.', NULL, NULL, 'TYR_PHOSPHATASE_2', 282027),
(462934, 'PS51846', NULL, 'CNNM transmembrane domain profile.', NULL, NULL, 'CNNM', 282028),
(462935, 'PS51871', NULL, 'Potyviridae P1 protease domain profile.', NULL, NULL, 'PV_P1_PRO', 282029);
INSERT INTO "PUBLIC"."MODEL" VALUES
(462936, 'PS50032', NULL, 'Kinase associated domain 1 (KA1) profile.', NULL, NULL, 'KA1', 282030),
(462937, 'PS51227', NULL, 'Sprouty (SPR) domain profile.', NULL, NULL, 'SPR', 282031),
(462938, 'PS50258', NULL, 'LNR (Lin-12/Notch) repeat profile.', NULL, NULL, 'LNR', 282032),
(462939, 'PS51419', NULL, 'small GTPase Rab1 family profile.', NULL, NULL, 'RAB', 282033),
(462940, 'PS51399', NULL, 'SEP domain profile.', NULL, NULL, 'SEP', 282034),
(462941, 'PS51076', NULL, 'MAD homology domain 2 (MH2) profile.', NULL, NULL, 'MH2', 282035),
(462942, 'PS50212', NULL, 'Ras guanine-nucleotide exchange factors N-terminal domain profile.', NULL, NULL, 'RASGEF_NTER', 282036),
(462943, 'PS50880', NULL, 'Toprim domain profile.', NULL, NULL, 'TOPRIM', 282037),
(462944, 'PS51811', NULL, 'Zinc finger CCHC HIVEP-type profile.', NULL, NULL, 'ZF_CCHC_HIVEP', 282038),
(462945, 'PS51396', NULL, 'PUL domain profile.', NULL, NULL, 'PUL', 282039),
(462946, 'PS51612', NULL, 'Poxvirus/kinetoplastid-type ribose 2''-O-methyltransferase (EC 2.1.1.57) family profile.', NULL, NULL, 'SAM_MT_2O_PK', 282040),
(462947, 'PS51622', NULL, 'tRNA (uracil-5-)-methyltransferase (EC 2.1.1.35) family profile.', NULL, NULL, 'SAM_MT_RNA_M5U_2', 282041),
(462948, 'PS51863', NULL, 'LCN-type cysteine-stabilized alpha/beta (CS-alpha/beta) domain profile.', NULL, NULL, 'LCN_CSAB', 282042),
(462949, 'PS50110', NULL, 'Response regulatory domain profile.', NULL, NULL, 'RESPONSE_REGULATORY', 282043),
(462950, 'PS51963', NULL, 'Betacoronavirus (BetaCoV) Nsp1 C-terminal domain profile.', NULL, NULL, 'BCOV_NSP1_C', 282044),
(462951, 'PS50884', NULL, 'Zinc finger Dof-type profile.', NULL, NULL, 'ZF_DOF_2', 282045),
(462952, 'PS51773', NULL, 'Orange carotenoid protein (OCP) N-terminal domain profile.', NULL, NULL, 'OCP_N', 282046),
(462953, 'PS51019', NULL, 'Reelin domain profile.', NULL, NULL, 'REELIN', 282047),
(462954, 'PS50253', NULL, 'Heme-copper oxidase subunit III family profile.', NULL, NULL, 'COX3', 282048),
(462955, 'PS50827', NULL, 'DDT domain profile.', NULL, NULL, 'DDT', 282049),
(462956, 'PS51174', NULL, 'Barwin domain profile.', NULL, NULL, 'BARWIN_3', 282050),
(462957, 'PS50199', NULL, 'Zinc finger RanBP2 type profile.', NULL, NULL, 'ZF_RANBP2_2', 282051),
(462958, 'PS51482', NULL, 'DegV domain profile.', NULL, NULL, 'DEGV', 282052),
(462959, 'PS50215', NULL, 'ADAM type metalloprotease domain profile.', NULL, NULL, 'ADAM_MEPRO', 282053),
(462960, 'PS51256', NULL, 'GS domain profile.', NULL, NULL, 'GS', 282054),
(462961, 'PS51415', NULL, 'Xylose isomerase family profile.', NULL, NULL, 'XYLOSE_ISOMERASE', 282055),
(462962, 'PS50151', NULL, 'UVR domain profile.', NULL, NULL, 'UVR', 282056),
(462963, 'PS51919', NULL, 'X4e domain profile.', NULL, NULL, 'X4E', 282057),
(462964, 'PS51101', NULL, 'PTS_EIIB type-4 domain profile.', NULL, NULL, 'PTS_EIIB_TYPE_4', 282058),
(462965, 'PS51830', NULL, 'FIIND domain profile.', NULL, NULL, 'FIIND', 282059),
(462966, 'PS51969', NULL, 'CBM39 (carbohydrate binding type-39) domain profile.', NULL, NULL, 'CBM39', 282060),
(462967, 'PS51172', NULL, 'CBM3 (carbohydrate binding type-3) domain profile.', NULL, NULL, 'CBM3', 282061),
(462968, 'PS51410', NULL, 'Biopterin-dependent aromatic amino acid hydroxylase family profile.', NULL, NULL, 'BH4_AAA_HYDROXYL_2', 282062),
(462969, 'PS51621', NULL, 'tRNA (uracil-5-)-methyltransferase (EC 2.1.1.35) family profile.', NULL, NULL, 'SAM_MT_RNA_M5U_1', 282063),
(462970, 'PS50853', NULL, 'Fibronectin type-III domain profile.', NULL, NULL, 'FN3', 282064),
(462971, 'PS51035', NULL, 'BAG domain profile.', NULL, NULL, 'BAG', 282065),
(462972, 'PS51146', NULL, 'KaiC domain profile.', NULL, NULL, 'KAIC', 282066),
(462973, 'PS51236', NULL, 'Thrombospondin C-terminal domain profile.', NULL, NULL, 'TSP_CTER', 282067),
(462974, 'PS51232', NULL, 'Rho GTPase-binding/formin homology 3 (GBD/FH3) domain profile.', NULL, NULL, 'GBD_FH3', 282068),
(462975, 'PS50888', NULL, 'Myc-type, basic helix-loop-helix (bHLH) domain profile.', NULL, NULL, 'BHLH', 282069),
(462976, 'PS50011', NULL, 'Protein kinase domain profile.', NULL, NULL, 'PROTEIN_KINASE_DOM', 282070);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(462977, 'PS51246', NULL, 'Cobalt import ATP-binding protein cbiO.', NULL, NULL, 'CBIO', 282071),
(462978, 'PS51489', NULL, 'BUB1 N-terminal domain profile.', NULL, NULL, 'BUB1_N', 282072),
(462979, 'PS50015', NULL, 'Saposin B type domain profile.', NULL, NULL, 'SAP_B', 282073),
(462980, 'PS50106', NULL, 'PDZ domain profile.', NULL, NULL, 'PDZ', 282074),
(462981, 'PS51831', NULL, 'HD domain profile.', NULL, NULL, 'HD', 282075),
(462982, 'PS50093', NULL, 'Polycystic kidney disease (PKD) domain profile.', NULL, NULL, 'PKD', 282076),
(462983, 'PS51683', NULL, 'SAM-dependent O-methyltransferase class II-type profile.', NULL, NULL, 'SAM_OMT_II', 282077),
(462984, 'PS51791', NULL, 'hSac2 domain profile.', NULL, NULL, 'HSAC2', 282078),
(462985, 'PS51436', NULL, 'Potyvirus NIa protease (NIa-pro) domain profile.', NULL, NULL, 'POTYVIRUS_NIA_PRO', 282079),
(462986, 'PS51835', NULL, 'Tripartite DENN C9ORF72-type domain profile.', NULL, NULL, 'DENN_C9ORF72', 282080),
(462987, 'PS50311', NULL, 'Cysteine-rich region profile.', NULL, NULL, 'CYS_RICH', 282081),
(462988, 'PS51446', NULL, 'Pacifastin domain profile.', NULL, NULL, 'PACIFASTIN', 282082),
(462989, 'PS51742', NULL, 'PPC domain profile profile.', NULL, NULL, 'PPC', 282083),
(462990, 'PS51569', NULL, 'Histone-lysine N-methyltransferase DOT1 (EC 2.1.1.43) domain profile.', NULL, NULL, 'DOT1', 282084),
(462991, 'PS51158', NULL, 'Alpha-type protein kinase domain profile.', NULL, NULL, 'ALPHA_KINASE', 282085),
(462992, 'PS51196', NULL, 'SecA family profile.', NULL, NULL, 'SECA_MOTOR_DEAD', 282086),
(462993, 'PS51434', NULL, 'NUP C-terminal domain profile.', NULL, NULL, 'NUP_C', 282087),
(462994, 'PS51720', NULL, 'AIG1-type G domain profile.', NULL, NULL, 'G_AIG1', 282088),
(462995, 'PS51733', NULL, 'Biotinyl protein ligase (BPL) and lipoyl protein ligase (LPL) catalytic domain profile.', NULL, NULL, 'BPL_LPL_CATALYTIC', 282089),
(462996, 'PS51038', NULL, 'BAH domain profile.', NULL, NULL, 'BAH', 282090),
(462997, 'PS51905', NULL, 'Zinc finger UBZ1-type profile.', NULL, NULL, 'ZF_UBZ1', 282091),
(462998, 'PS51311', NULL, 'Secretoglobin (SCGB) family profile.', NULL, NULL, 'SCGB', 282092),
(462999, 'PS51826', NULL, 'Peripheral subunit-binding (PSBD) domain profile.', NULL, NULL, 'PSBD', 282093),
(463000, 'PS50171', NULL, 'Zinc finger matrin-type profile.', NULL, NULL, 'ZF_MATRIN', 282094),
(463001, 'PS51864', NULL, 'Astacin-like domain profile.', NULL, NULL, 'ASTACIN', 282095),
(463002, 'PS50046', NULL, 'Phytochrome chromophore attachment site domain profile.', NULL, NULL, 'PHYTOCHROME_2', 282096),
(463003, 'PS51503', NULL, 'HIG1 domain profile.', NULL, NULL, 'HIG1', 282097),
(463004, 'PS50294', NULL, 'Trp-Asp (WD) repeats circular profile.', NULL, NULL, 'WD_REPEATS_REGION', 282098),
(463005, 'PS51197', NULL, 'Rrf2-type HTH domain profile.', NULL, NULL, 'HTH_RRF2_2', 282099),
(463006, 'PS51268', NULL, 'Arabinose import ATP-binding protein araG family profile.', NULL, NULL, 'ARAG', 282100),
(463007, 'PS51085', NULL, '2Fe-2S ferredoxin-type iron-sulfur binding domain profile.', NULL, NULL, '2FE2S_FER_2', 282101),
(463008, 'PS51865', NULL, 'GRASP-type PDZ domain profile.', NULL, NULL, 'PDZ_GRASP', 282102),
(463009, 'PS50856', NULL, 'AMOP domain profile.', NULL, NULL, 'AMOP', 282103),
(463010, 'PS51854', NULL, 'CSPG repeat profile.', NULL, NULL, 'CSPG', 282104),
(463011, 'PS51818', NULL, 'Homeo-Prospero domain profile.', NULL, NULL, 'HOMEO_PROSPERO', 282105),
(463012, 'PS51093', NULL, 'PTS_EIIA type-1 domain profile.', NULL, NULL, 'PTS_EIIA_TYPE_1', 282106),
(463013, 'PS50850', NULL, 'Major facilitator superfamily (MFS) profile.', NULL, NULL, 'MFS', 282107),
(463014, 'PS51521', NULL, 'Herpesvirus tegument ubiquitin-specific protease (htUSP) domain profile.', NULL, NULL, 'HTUSP', 282108),
(463015, 'PS51156', NULL, 'ELM2 domain profile.', NULL, NULL, 'ELM2', 282109),
(463016, 'PS51375', NULL, 'Pentatricopeptide (PPR) repeat profile.', NULL, NULL, 'PPR', 282110),
(463017, 'PS51136', NULL, 'WAC domain profile.', NULL, NULL, 'WAC', 282111),
(463018, 'PS51947', NULL, 'Nidovirus RdRp-associated nucleotidyl transferase (NiRAN) domain profile.', NULL, NULL, 'NIRAN', 282112);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(463019, 'PS50137', NULL, 'Double stranded RNA-binding domain (dsRBD) profile.', NULL, NULL, 'DS_RBD', 282113),
(463020, 'PS51207', NULL, 'PXA domain profile.', NULL, NULL, 'PXA', 282114),
(463021, 'PS51177', NULL, 'Riboflavin synthase alpha chain lumazine-binding repeat profile.', NULL, NULL, 'LUMAZINE_BIND', 282115),
(463022, 'PS51318', NULL, 'Twin arginine translocation (Tat) signal profile.', NULL, NULL, 'TAT', 282116),
(463023, 'PS51271', NULL, 'WAPL domain profile.', NULL, NULL, 'WAPL', 282117),
(463024, 'PS51071', NULL, 'RpiR-type HTH domain profile.', NULL, NULL, 'HTH_RPIR', 282118),
(463025, 'PS51875', NULL, 'Hypovirus-associated virus (HAV) papain-like protease p48 domain profile.', NULL, NULL, 'HAV_P48_PRO', 282119),
(463026, 'PS51590', NULL, 'Mononegavirus L protein 2''-O-ribose methyltransferase domain profile.', NULL, NULL, 'SAM_MT_MNV_L', 282120),
(463027, 'PS51480', NULL, 'DhaL domain profile.', NULL, NULL, 'DHAL', 282121),
(463028, 'PS51253', NULL, 'CENPB-type HTH domain profile.', NULL, NULL, 'HTH_CENPB', 282122),
(463029, 'PS51782', NULL, 'LysM domain profile.', NULL, NULL, 'LYSM', 282123),
(463030, 'PS51003', NULL, 'Cytochrome b/b6 C-terminal region profile.', NULL, NULL, 'CYTB_CTER', 282124),
(463031, 'PS51755', NULL, 'OmpR/PhoB-type DNA-binding domain profile.', NULL, NULL, 'OMPR_PHOB', 282125),
(463032, 'PS50898', NULL, 'Ras-binding domain (RBD) profile.', NULL, NULL, 'RBD', 282126),
(463033, 'PS51170', NULL, 'Cell wall-binding repeat profile.', NULL, NULL, 'CW', 282127),
(463034, 'PS51309', NULL, 'Poly(A)-binding protein C-terminal (PABC) domain profile.', NULL, NULL, 'PABC', 282128),
(463035, 'PS50014', NULL, 'Bromodomain profile.', NULL, NULL, 'BROMODOMAIN_2', 282129),
(463036, 'PS51931', NULL, 'Bacterial microcompartment (BMC) circularly permuted domain profile.', NULL, NULL, 'BMC_CP', 282130),
(463037, 'PS51788', NULL, 'CULT domain profile.', NULL, NULL, 'CULT', 282131),
(463038, 'PS50262', NULL, 'G-protein coupled receptors family 1 profile.', NULL, NULL, 'G_PROTEIN_RECEP_F1_2', 282132),
(463039, 'PS50943', NULL, 'Cro/C1-type HTH domain profile.', NULL, NULL, 'HTH_CROC1', 282133),
(463040, 'PS50861', NULL, 'Heterodimeric glycyl-transfer RNA synthetases family profile.', NULL, NULL, 'AA_TRNA_LIGASE_II_GLYAB', 282134),
(463041, 'PS51341', NULL, 'Zinc finger large T-antigen (T-ag) D1-type profile.', NULL, NULL, 'ZF_LTAG_D1', 282135),
(463042, 'PS51464', NULL, 'SIS domain profile.', NULL, NULL, 'SIS', 282136),
(463043, 'PS51962', NULL, 'Coronavirus (CoV) Nsp1 globular domain profile.', NULL, NULL, 'COV_NSP1', 282137),
(463044, 'PS51257', NULL, 'Prokaryotic membrane lipoprotein lipid attachment site profile.', NULL, NULL, 'PROKAR_LIPOPROTEIN', 282138),
(463045, 'PS51702', NULL, 'Mu-type HTH domain profile.', NULL, NULL, 'HTH_MU', 282139),
(463046, 'PS50229', NULL, 'WH1 domain profile.', NULL, NULL, 'WH1', 282140),
(463047, 'PS51216', NULL, 'Nebulin repeat profile.', NULL, NULL, 'NEBULIN', 282141),
(463048, 'PS50017', NULL, 'Death domain profile.', NULL, NULL, 'DEATH_DOMAIN', 282142),
(463049, 'PS51703', NULL, 'DZF domain profile.', NULL, NULL, 'DZF', 282143),
(463050, 'PS51050', NULL, 'Zinc finger CW-type profile.', NULL, NULL, 'ZF_CW', 282144),
(463051, 'PS51980', NULL, 'Occludin/ELL (OCEL) domain profile.', NULL, NULL, 'OCEL', 282145),
(463052, 'PS50326', NULL, 'Valine-rich region profile.', NULL, NULL, 'VAL_RICH', 282146),
(463053, 'PS51171', NULL, 'Prephenate dehydratase domain profile.', NULL, NULL, 'PREPHENATE_DEHYDR_3', 282147),
(463054, 'PS51462', NULL, 'Nudix hydrolase domain profile.', NULL, NULL, 'NUDIX', 282148),
(463055, 'PS51713', NULL, 'Era-type guanine nucleotide-binding (G) domain profile.', NULL, NULL, 'G_ERA', 282149),
(463056, 'PS51119', NULL, 'TAFH/NHR1 domain profile.', NULL, NULL, 'TAFH', 282150),
(463057, 'PS51149', NULL, 'Glycine radical domain profile.', NULL, NULL, 'GLY_RADICAL_2', 282151),
(463058, 'PS50061', NULL, 'Ets-domain profile.', NULL, NULL, 'ETS_DOMAIN_3', 282152),
(463059, 'PS50305', NULL, 'Sirtuin catalytic domain profile.', NULL, NULL, 'SIRTUIN', 282153);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(463060, 'PS50103', NULL, 'Zinc finger C3H1-type profile.', NULL, NULL, 'ZF_C3H1', 282154),
(463061, 'PS50188', NULL, 'B30.2/SPRY domain profile.', NULL, NULL, 'B302_SPRY', 282155),
(463062, 'PS51494', NULL, 'SpoIVB peptidase domain profile.', NULL, NULL, 'SPOIVB', 282156),
(463063, 'PS51892', NULL, 'Serine proteases, subtilase domain profile.', NULL, NULL, 'SUBTILASE', 282157),
(463064, 'PS51099', NULL, 'PTS_EIIB type-2 domain profile.', NULL, NULL, 'PTS_EIIB_TYPE_2', 282158),
(463065, 'PS50891', NULL, 'LOB domain profile.', NULL, NULL, 'LOB', 282159),
(463066, 'PS50889', NULL, 'S4 RNA-binding domain profile.', NULL, NULL, 'S4', 282160),
(463067, 'PS51266', NULL, 'Zinc finger CHY-type profile.', NULL, NULL, 'ZF_CHY', 282161),
(463068, 'PS50531', NULL, 'IS21 transposase-type HTH domain profile.', NULL, NULL, 'HTH_IS21', 282162),
(463069, 'PS50817', NULL, 'Intein N-terminal splicing motif profile.', NULL, NULL, 'INTEIN_N_TER', 282163),
(463070, 'PS51409', NULL, 'Arginase family profile.', NULL, NULL, 'ARGINASE_2', 282164),
(463071, 'PS51903', NULL, 'Clp repeat (R) domain profile.', NULL, NULL, 'CLP_R', 282165),
(463072, 'PS51260', NULL, 'Galactose/methyl galactoside import ATP-binding protein mglA family profile.', NULL, NULL, 'MGLA', 282166),
(463073, 'PS51681', NULL, 'SAM-dependent methyltransferase NNMT/PNMT/TEMT-type profile.', NULL, NULL, 'SAM_MT_NNMT_PNMT_TEMT', 282167),
(463074, 'PS51699', NULL, 'DG-type SEA domain profile.', NULL, NULL, 'SEA_DG', 282168),
(463075, 'PS50524', NULL, 'RdRp of Birnaviridae dsRNA viruses catalytic domain profile.', NULL, NULL, 'RDRP_DSRNA_BIR', 282169),
(463076, 'PS51313', NULL, 'VPS28 N-terminal domain profile.', NULL, NULL, 'VPS28_N', 282170),
(463077, 'PS50984', NULL, 'TRUD domain profile.', NULL, NULL, 'TRUD', 282171),
(463078, 'PS51153', NULL, 'RPW8 domain profile.', NULL, NULL, 'RPW8', 282172),
(463079, 'PS51131', NULL, 'Rad50 zinc-hook domain profile.', NULL, NULL, 'ZN_HOOK', 282173),
(463080, 'PS51142', NULL, 'Nicotianamine synthase (NAS)-like family profile.', NULL, NULL, 'NAS', 282174),
(463081, 'PS51506', NULL, 'Cbl-type phosphotyrosine-binding (Cbl-PTB) domain profile.', NULL, NULL, 'CBL_PTB', 282175),
(463082, 'PS51549', NULL, 'DM13 domain profile.', NULL, NULL, 'DM13', 282176),
(463083, 'PS50278', NULL, 'Platelet-derived growth factor (PDGF) family profile.', NULL, NULL, 'PDGF_2', 282177),
(463084, 'PS51270', NULL, 'Zinc finger CTCHY-type profile.', NULL, NULL, 'ZF_CTCHY', 282178),
(463085, 'PS51597', NULL, 'Histamine N-methyltransferase (EC 2.1.1.8) family profile.', NULL, NULL, 'SAM_HNMT', 282179),
(463086, 'PS50805', NULL, 'Krueppel-associated box (KRAB) profile.', NULL, NULL, 'KRAB', 282180),
(463087, 'PS50809', NULL, 'DM DNA-binding domain profile.', NULL, NULL, 'DM_2', 282181),
(463088, 'PS51392', NULL, 'KEN domain profile.', NULL, NULL, 'KEN', 282182),
(463089, 'PS50180', NULL, 'Gamma-adaptin ear (GAE) domain profile.', NULL, NULL, 'GAE', 282183),
(463090, 'PS50189', NULL, 'NTR domain profile.', NULL, NULL, 'NTR', 282184),
(463091, 'PS51039', NULL, 'Zinc finger AN1-type profile.', NULL, NULL, 'ZF_AN1', 282185),
(463092, 'PS50203', NULL, 'Cysteine proteinase, calpain-type, catalytic domain profile.', NULL, NULL, 'CALPAIN_CAT', 282186),
(463093, 'PS51055', NULL, 'ITAM motif mammalian type profile.', NULL, NULL, 'ITAM_1', 282187),
(463094, 'PS51262', NULL, 'COS domain profile.', NULL, NULL, 'COS', 282188),
(463095, 'PS51278', NULL, 'Glutamine amidotransferase type 2 domain profile.', NULL, NULL, 'GATASE_TYPE_2', 282189),
(463096, 'PS50186', NULL, 'DEP domain profile.', NULL, NULL, 'DEP', 282190),
(463097, 'PS51511', NULL, 'FIP-RBD domain profile.', NULL, NULL, 'FIP_RBD', 282191),
(463098, 'PS51889', NULL, 'Rubella virus (RUBV) nonstructural (NS) protease domain profile.', NULL, NULL, 'RUBV_NS_PRO', 282192),
(463099, 'PS51448', NULL, 'P-type ''Trefoil'' domain profile.', NULL, NULL, 'P_TREFOIL_2', 282193),
(463100, 'PS50144', NULL, 'MATH/TRAF domain profile.', NULL, NULL, 'MATH', 282194),
(463101, 'PS50816', NULL, 'NAF domain profile.', NULL, NULL, 'NAF', 282195);
INSERT INTO "PUBLIC"."MODEL" VALUES
(463102, 'PS50216', NULL, 'DHHC domain profile.', NULL, NULL, 'DHHC', 282196),
(463103, 'PS50990', NULL, 'Peptidase family C39 domain profile.', NULL, NULL, 'PEPTIDASE_C39', 282197),
(463104, 'PS51517', NULL, 'NDT80 DNA-binding domain profile.', NULL, NULL, 'NDT80', 282198),
(463105, 'PS51487', NULL, 'NBD domain profile.', NULL, NULL, 'NBD', 282199),
(463106, 'PS51447', NULL, 'Ferredoxin-fold anticodon binding (FDX-ACB) domain profile.', NULL, NULL, 'FDX_ACB', 282200),
(463107, 'PS51016', NULL, 'MyTH4 domain profile.', NULL, NULL, 'MYTH4', 282201),
(463108, 'PS50847', NULL, 'Gram-positive cocci surface proteins LPxTG motif profile.', NULL, NULL, 'GRAM_POS_ANCHORING', 282202),
(463109, 'PS51421', NULL, 'small GTPase Ras family profile.', NULL, NULL, 'RAS', 282203),
(463110, 'PS51206', NULL, 'Superfamily 3 helicase of DNA viruses domain profile.', NULL, NULL, 'SF3_HELICASE_1', 282204),
(463111, 'PS51291', NULL, 'Aliphatic sulfonate import ATP-binding protein ssuB family profile.', NULL, NULL, 'SSUB', 282205),
(463112, 'PS51752', NULL, 'Jacalin-type lectin domain profile.', NULL, NULL, 'JACALIN_LECTIN', 282206),
(463113, 'PS51476', NULL, 'Proteasome beta-type subunit profile.', NULL, NULL, 'PROTEASOME_BETA_2', 282207),
(463114, 'PS51949', NULL, 'Coronavirus RNA-dependent RNA polymerase (RdRp) Nsp7 cofactor domain profile.', NULL, NULL, 'COV_NSP7', 282208),
(463115, 'PS50871', NULL, 'C1q domain profile.', NULL, NULL, 'C1Q', 282209),
(463116, 'PS51218', NULL, 'Superfamily 3 helicase of positive ssRNA viruses domain profile.', NULL, NULL, 'SF3_HELICASE_2', 282210),
(463117, 'PS51640', NULL, 'MRG domain profile.', NULL, NULL, 'MRG', 282211),
(463118, 'PS50010', NULL, 'Dbl homology (DH) domain profile.', NULL, NULL, 'DH_2', 282212),
(463119, 'PS51201', NULL, 'RCK N-terminal domain profile.', NULL, NULL, 'RCK_N', 282213),
(463120, 'PS50839', NULL, 'CHASE domain profile.', NULL, NULL, 'CHASE', 282214),
(463121, 'PS51339', NULL, 'Myotubularin phosphatase domain.', NULL, NULL, 'PPASE_MYOTUBULARIN', 282215),
(463122, 'PS51544', NULL, 'Phosphatidylinositol 3-kinase adaptor-binding (PI3K ABD) domain profile.', NULL, NULL, 'PI3K_ABD', 282216),
(463123, 'PS51805', NULL, 'Extended PHD (ePHD) domain profile.', NULL, NULL, 'EPHD', 282217),
(463124, 'PS51770', NULL, 'Hotdog acyl-CoA thioesterase (ACOT)-type domain profile.', NULL, NULL, 'HOTDOG_ACOT', 282218),
(463125, 'PS50975', NULL, 'ATP-grasp fold profile.', NULL, NULL, 'ATP_GRASP', 282219),
(463126, 'PS51042', NULL, 'CUT domain profile.', NULL, NULL, 'CUT', 282220),
(463127, 'PS51095', NULL, 'PTS_EIIA type-3 domain profile.', NULL, NULL, 'PTS_EIIA_TYPE_3', 282221),
(463128, 'PS51331', NULL, 'Flavin-dependent thymidylate synthase (thyX) domain profile.', NULL, NULL, 'THYX', 282222),
(463129, 'PS51072', NULL, 'Mu homology domain (MHD) profile.', NULL, NULL, 'MHD', 282223),
(463130, 'PS51141', NULL, 'Zinc finger SBP-type profile.', NULL, NULL, 'ZF_SBP', 282224),
(463131, 'PS50021', NULL, 'Calponin homology (CH) domain profile.', NULL, NULL, 'CH', 282225),
(463132, 'PS50122', NULL, 'CheB-type methylesterase domain profile.', NULL, NULL, 'CHEB', 282226),
(463133, 'PS50857', NULL, 'Cytochrome oxidase subunit II copper A binding domain profile.', NULL, NULL, 'COX2_CUA', 282227),
(463134, 'PS51194', NULL, 'Superfamilies 1 and 2 helicase C-terminal domain profile.', NULL, NULL, 'HELICASE_CTER', 282228),
(463135, 'PS51365', NULL, 'Renal dipeptidase family profile.', NULL, NULL, 'RENAL_DIPEPTIDASE_2', 282229),
(463136, 'PS51418', NULL, 'small GTPase Ran family profile.', NULL, NULL, 'RAN', 282230),
(463137, 'PS51330', NULL, 'Dihydrofolate reductase (DHFR) domain profile.', NULL, NULL, 'DHFR_2', 282231),
(463138, 'PS50838', NULL, 'MAGE conserved domain profile.', NULL, NULL, 'MAGE', 282232),
(463139, 'PS51515', NULL, 'Bin3-type S-adenosyl-L-methionine (SAM) domain profile.', NULL, NULL, 'BIN3_SAM', 282233),
(463140, 'PS51021', NULL, 'BAR domain profile.', NULL, NULL, 'BAR', 282234),
(463141, 'PS51344', NULL, 'TFE/IIEalpha-type HTH domain profile.', NULL, NULL, 'HTH_TFE_IIE', 282235);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(463142, 'PS51320', NULL, 'Tify domain profile.', NULL, NULL, 'TIFY', 282236),
(463143, 'PS51712', NULL, 'EngA-type guanine nucleotide-binding (G) domain profile.', NULL, NULL, 'G_ENGA', 282237),
(463144, 'PS51911', NULL, 'C2 Aida-type domain profile.', NULL, NULL, 'C2_AIDA', 282238),
(463145, 'PS51987', NULL, 'Glutamine synthetase (GS) catalytic domain profile.', NULL, NULL, 'GS_CATALYTIC', 282239),
(463146, 'PS51801', NULL, 'Zinc finger CCHC NOA-type profile.', NULL, NULL, 'ZF_CCHC_NOA', 282240),
(463147, 'PS50320', NULL, 'Methionine-rich region profile.', NULL, NULL, 'MET_RICH', 282241),
(463148, 'PS50173', NULL, 'UmuC domain profile.', NULL, NULL, 'UMUC', 282242),
(463149, 'PS50507', NULL, 'RdRp of positive ssRNA viruses catalytic domain profile.', NULL, NULL, 'RDRP_SSRNA_POS', 282243),
(463150, 'PS50831', NULL, 'SoHo domain profile.', NULL, NULL, 'SOHO', 282244),
(463151, 'PS50869', NULL, 'BRICHOS domain profile.', NULL, NULL, 'BRICHOS', 282245),
(463152, 'PS51413', NULL, 'DBINO domain profile.', NULL, NULL, 'DBINO', 282246),
(463153, 'PS50960', NULL, 'Psq-type HTH domain profile.', NULL, NULL, 'HTH_PSQ', 282247),
(463154, 'PS51546', NULL, 'Phosphatidylinositol 3-kinase Ras-binding (PI3K RBD) domain profile.', NULL, NULL, 'PI3K_RBD', 282248),
(463155, 'PS51729', NULL, 'Yjdj-type Gcn5-related N-acetyltransferase (GNAT) domain profile.', NULL, NULL, 'GNAT_YJDJ', 282249),
(463156, 'PS51929', NULL, 'Coronavirus nucleocapsid (CoV N) protein C-terminal (CTD) domain profile.', NULL, NULL, 'COV_N_CTD', 282250),
(463157, 'PS50842', NULL, 'Expansin, family-45 endoglucanase-like domain profile.', NULL, NULL, 'EXPANSIN_EG45', 282251),
(463158, 'PS51015', NULL, 'YDG domain profile.', NULL, NULL, 'YDG', 282252),
(463159, 'PS50965', NULL, 'NERD domain profile.', NULL, NULL, 'NERD', 282253),
(463160, 'PS51711', NULL, 'FeoB-type guanine nucleotide-binding (G) domain profile.', NULL, NULL, 'G_FEOB', 282254),
(463161, 'PS51979', NULL, 'YebF/Cmi domain profile.', NULL, NULL, 'YEBF_CMI', 282255),
(463162, 'PS51507', NULL, 'IRF tryptophan pentad repeat DNA-binding domain profile.', NULL, NULL, 'IRF_2', 282256),
(463163, 'PS51053', NULL, 'SERTA domain profile.', NULL, NULL, 'SERTA', 282257),
(463164, 'PS50526', NULL, 'RdRp of negative ssRNA viruses with non-segmented genomes catalytic domain profile.', NULL, NULL, 'RDRP_SSRNA_NEG_NONSEG', 282258),
(463165, 'PS51417', NULL, 'small GTPase Arf family profile.', NULL, NULL, 'ARF', 282259),
(463166, 'PS50912', NULL, 'EAR repeat profile.', NULL, NULL, 'EAR', 282260),
(463167, 'PS50317', NULL, 'Isoleucine-rich region profile.', NULL, NULL, 'ILE_RICH', 282261),
(463168, 'PS51556', NULL, 'Magnesium protoporphyrin IX methyltransferase (EC 2.1.1.11) family profile.', NULL, NULL, 'SAM_MT_MG_PIX', 282262),
(463169, 'PS51754', NULL, 'OVATE domain profile.', NULL, NULL, 'OVATE', 282263),
(463170, 'PS50323', NULL, 'Arginine-rich region profile.', NULL, NULL, 'ARG_RICH', 282264),
(463171, 'PS51766', NULL, 'Dockerin domain profile.', NULL, NULL, 'DOCKERIN', 282265),
(463172, 'PS51248', NULL, 'Nickel import ATP-binding protein nikE.', NULL, NULL, 'NIKE', 282266),
(463173, 'PS50079', NULL, 'Bipartite nuclear localization signal profile.', NULL, NULL, 'NLS_BP', 282267),
(463174, 'PS51624', NULL, 'RNA methyltransferase TRMH family profile.', NULL, NULL, 'SAM_MT_TRMH_2', 282268),
(463175, 'PS51653', NULL, 'Coronaviridae zinc-binding (CV ZBD) domain profile.', NULL, NULL, 'CV_ZBD', 282269),
(463176, 'PS50920', NULL, 'Solute carrier (Solcar) repeat profile.', NULL, NULL, 'SOLCAR', 282270),
(463177, 'PS51738', NULL, 'Peptidase family C21 domain profile.', NULL, NULL, 'PEPTIDASE_C21', 282271),
(463178, 'PS50176', NULL, 'Armadillo/plakoglobin ARM repeat profile.', NULL, NULL, 'ARM_REPEAT', 282272),
(463179, 'PS50979', NULL, 'Biotin carboxylation domain profile.', NULL, NULL, 'BC', 282273),
(463180, 'PS50927', NULL, 'Bulb-type lectin domain profile.', NULL, NULL, 'BULB_LECTIN', 282274),
(463181, 'PS50835', NULL, 'Ig-like domain profile.', NULL, NULL, 'IG_LIKE', 282275),
(463182, 'PS51165', NULL, 'THUMP domain profile.', NULL, NULL, 'THUMP', 282276);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(463183, 'PS51672', NULL, 'ACT-like domain profile.', NULL, NULL, 'ACT_LIKE', 282277),
(463184, 'PS51678', NULL, 'SAM-dependent methyltransferase PRMT-type domain profile.', NULL, NULL, 'SAM_MT_PRMT', 282278),
(463185, 'PS51932', NULL, 'Bacterial microcompartment vertex (BMV) domain profile.', NULL, NULL, 'BMV', 282279),
(463186, 'PS51938', NULL, 'SUZ-C domain profile.', NULL, NULL, 'SUZ_C', 282280),
(463187, 'PS01179', NULL, 'Phosphotyrosine interaction domain (PID) profile.', NULL, NULL, 'PID', 282281),
(463188, 'PS50886', NULL, 'tRNA-binding domain profile.', NULL, NULL, 'TRBD', 282282),
(463189, 'PS51046', NULL, 'GON domain profile.', NULL, NULL, 'GON', 282283),
(463190, 'PS51827', NULL, 'XRN2-binding (XTBD) domain profile.', NULL, NULL, 'XTBD', 282284),
(463191, 'PS50217', NULL, 'Basic-leucine zipper (bZIP) domain profile.', NULL, NULL, 'BZIP', 282285),
(463192, 'PS50937', NULL, 'MerR-type HTH domain profile.', NULL, NULL, 'HTH_MERR_2', 282286),
(463193, 'PS50081', NULL, 'Zinc finger phorbol-ester/DAG-type profile.', NULL, NULL, 'ZF_DAG_PE_2', 282287),
(463194, 'PS51682', NULL, 'SAM-dependent O-methyltransferase class I-type profile.', NULL, NULL, 'SAM_OMT_I', 282288),
(463195, 'PS51844', NULL, 'Myosin N-terminal SH3-like domain profile.', NULL, NULL, 'SH3_LIKE', 282289),
(463196, 'PS51391', NULL, 'CID domain profile.', NULL, NULL, 'CID', 282290),
(463197, 'PS51526', NULL, 'RFX-type winged-helix DNA-binding domain profile.', NULL, NULL, 'RFX_DBD', 282291),
(463198, 'PS51840', NULL, 'C2 NT-type domain profile.', NULL, NULL, 'C2_NT', 282292),
(463199, 'PS50213', NULL, 'FAS1/BIgH3 domain profile.', NULL, NULL, 'FAS1', 282293),
(463200, 'PS51536', NULL, 'TFG box profile.', NULL, NULL, 'TFG', 282294),
(463201, 'PS51832', NULL, 'HD-GYP domain profile.', NULL, NULL, 'HD_GYP', 282295),
(463202, 'PS51475', NULL, 'Proteasome alpha-type subunit profile.', NULL, NULL, 'PROTEASOME_ALPHA_2', 282296),
(463203, 'PS51020', NULL, 'Spondin domain profile.', NULL, NULL, 'SPONDIN', 282297),
(463204, 'PS51079', NULL, 'MBT repeat profile.', NULL, NULL, 'MBT', 282298),
(463205, 'PS50002', NULL, 'Src homology 3 (SH3) domain profile.', NULL, NULL, 'SH3', 282299),
(463206, 'PS50076', NULL, 'dnaJ domain profile.', NULL, NULL, 'DNAJ_2', 282300),
(463207, 'PS51343', NULL, 'P-II protein family profile.', NULL, NULL, 'PII_GLNB_DOM', 282301),
(463208, 'PS51626', NULL, 'Trm1 methyltransferase domain profile.', NULL, NULL, 'SAM_MT_TRM1', 282302),
(463209, 'PS50063', NULL, 'Apoptosis regulator, Bcl-2 family BH4 motif profile.', NULL, NULL, 'BH4_2', 282303),
(463210, 'PS51895', NULL, 'Alt a 1 (AA1)-like domain profile.', NULL, NULL, 'AA1', 282304),
(463211, 'PS50073', NULL, 'Copper-fist DNA-binding domain profile.', NULL, NULL, 'COPPER_FIST_2', 282305),
(463212, 'PS51151', NULL, 'NAC A/B domain profile.', NULL, NULL, 'NAC_AB', 282306),
(463213, 'PS51082', NULL, 'WH2 domain profile.', NULL, NULL, 'WH2', 282307),
(463214, 'PS51663', NULL, 'Stathmin-like (SLD) domain profile.', NULL, NULL, 'STATHMIN_3', 282308),
(463215, 'PS51749', NULL, 'Cas9-type HNH domain profile.', NULL, NULL, 'HNH_CAS9', 282309),
(463216, 'PS50108', NULL, 'CRIB domain profile.', NULL, NULL, 'CRIB', 282310),
(463217, 'PS51540', NULL, 'Arterivirus papain-like cysteine protease beta (PCPbeta) domain profile.', NULL, NULL, 'AV_PCP_BETA', 282311),
(463218, 'PS51585', NULL, 'Thiopurine or thiol or thiocyanate S-methyltransferase (TPMT) family profile.', NULL, NULL, 'SAM_MT_TPMT', 282312),
(463219, 'PS50878', NULL, 'Reverse transcriptase (RT) catalytic domain profile.', NULL, NULL, 'RT_POL', 282313),
(463220, 'PS51416', NULL, 'MIB/HERC2 domain profile.', NULL, NULL, 'MIB_HERC2', 282314),
(463221, 'PS51461', NULL, 'Fibrillar collagen C-terminal non-collagenous (NC1) domain profile.', NULL, NULL, 'NC1_FIB', 282315),
(463222, 'PS50313', NULL, 'Glutamic acid-rich region profile.', NULL, NULL, 'GLU_RICH', 282316),
(463223, 'PS51061', NULL, 'R3H domain profile.', NULL, NULL, 'R3H', 282317),
(463224, 'PS51765', NULL, 'Zinc finger RAG1-type profile.', NULL, NULL, 'ZF_RAG1', 282318);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(463225, 'PS50951', NULL, 'SARAH domain profile.', NULL, NULL, 'SARAH', 282319),
(463226, 'PS51910', NULL, 'Glycosyl hydrolases family 18 (GH18) domain profile.', NULL, NULL, 'GH18_2', 282320),
(463227, 'PS51852', NULL, 'pG1 pseudoGTPase domain profile.', NULL, NULL, 'PG1', 282321),
(463228, 'PS50067', NULL, 'Kinesin motor domain profile.', NULL, NULL, 'KINESIN_MOTOR_2', 282322),
(463229, 'PS51426', NULL, 'ABL domain profile.', NULL, NULL, 'ABL', 282323),
(463230, 'PS51355', NULL, 'Glutathione peroxidase profile.', NULL, NULL, 'GLUTATHIONE_PEROXID_3', 282324),
(463231, 'PS51751', NULL, 'EXPERA domain profile.', NULL, NULL, 'EXPERA', 282325),
(463232, 'PS51481', NULL, 'DhaK domain profile.', NULL, NULL, 'DHAK', 282326),
(463233, 'PS50532', NULL, 'IS408 transposase-type HTH domain profile.', NULL, NULL, 'HTH_IS408', 282327),
(463234, 'PS51116', NULL, 'Laminin IV type A domain profile.', NULL, NULL, 'LAMININ_IVB', 282328),
(463235, 'PS51804', NULL, 'Zinc finger C2HC LYAR-type profile.', NULL, NULL, 'ZF_C2HC_LYAR', 282329),
(463236, 'PS51184', NULL, 'JmjC domain profile.', NULL, NULL, 'JMJC', 282330),
(463237, 'PS50115', NULL, 'ARF GTPase-activating proteins domain profile.', NULL, NULL, 'ARFGAP', 282331),
(463238, 'PS51144', NULL, 'Alpha-carbonic anhydrases profile.', NULL, NULL, 'ALPHA_CA_2', 282332),
(463239, 'PS51615', NULL, 'Putrescine N-methyltransferase (EC 2.1.1.53) family profile.', NULL, NULL, 'SAM_MT_PUTRESCINE', 282333),
(463240, 'PS50172', NULL, 'BRCT domain profile.', NULL, NULL, 'BRCT', 282334),
(463241, 'PS50982', NULL, 'Methyl-CpG-binding domain (MBD) profile.', NULL, NULL, 'MBD', 282335),
(463242, 'PS51324', NULL, 'ERV/ALR sulfhydryl oxidase domain profile.', NULL, NULL, 'ERV_ALR', 282336),
(463243, 'PS51281', NULL, 'TAP C-terminal (TAP-C) domain profile.', NULL, NULL, 'TAP_C', 282337),
(463244, 'PS51727', NULL, 'CBP/p300-type histone acetyltransferase (HAT) domain profile.', NULL, NULL, 'CBP_P300_HAT', 282338),
(463245, 'PS51519', NULL, 'RWP-RK domain profile.', NULL, NULL, 'RWP_RK', 282339),
(463246, 'PS51886', NULL, 'TLDc domain profile.', NULL, NULL, 'TLDC', 282340),
(463247, 'PS50051', NULL, 'MCM family domain profile.', NULL, NULL, 'MCM_2', 282341),
(463248, 'PS51113', NULL, 'Zinc finger Btk-type profile.', NULL, NULL, 'ZF_BTK', 282342),
(463249, 'PS51951', NULL, 'Coronavirus Nsp9 single-stranded RNA (ssRNA)-binding domain profile.', NULL, NULL, 'COV_NSP9_SSRNA_BD', 282343),
(463250, 'PS50923', NULL, 'Sushi/CCP/SCR domain profile.', NULL, NULL, 'SUSHI', 282344),
(463251, 'PS51241', NULL, 'Molybdenum import ATP-binding protein modC family profile.', NULL, NULL, 'MODC', 282345),
(463252, 'PS50922', NULL, 'TLC domain profile.', NULL, NULL, 'TLC', 282346),
(463253, 'PS50027', NULL, 'Laminin-type EGF-like (LE) domain profile.', NULL, NULL, 'EGF_LAM_2', 282347),
(463254, 'PS51942', NULL, 'Betacoronavirus Nsp3c-C domain profile.', NULL, NULL, 'BCOV_NSP3C_C', 282348),
(463255, 'PS50804', NULL, 'SCAN box profile.', NULL, NULL, 'SCAN_BOX', 282349),
(463256, 'PS51319', NULL, 'TFIIS N-terminal domain profile.', NULL, NULL, 'TFIIS_N', 282350),
(463257, 'PS51730', NULL, 'Alpha-tubulin Gcn5-related N-acetyltransferase (GNAT) domain profile.', NULL, NULL, 'GNAT_ATAT', 282351),
(463258, 'PS51731', NULL, 'Vertebrate-like NAGS Gcn5-related N-acetyltransferase (GNAT) domain profile.', NULL, NULL, 'GNAT_NAGS', 282352),
(463259, 'PS51307', NULL, 'ASD2 domain profile.', NULL, NULL, 'ASD2', 282353),
(463260, 'PS51346', NULL, 'Prokaryotic zinc-dependent phospholipase C domain profile.', NULL, NULL, 'PROKAR_ZN_DEPEND_PLPC_2', 282354),
(463261, 'PS51736', NULL, 'Resolvase/invertase-type recombinase catalytic domain profile.', NULL, NULL, 'RECOMBINASES_3', 282355),
(463262, 'PS51460', NULL, 'GAR domain profile.', NULL, NULL, 'GAR', 282356),
(463263, 'PS51185', NULL, 'WHEP-TRS domain profile.', NULL, NULL, 'WHEP_TRS_2', 282357),
(463264, 'PS50940', NULL, 'Chitin-binding type-2 domain profile.', NULL, NULL, 'CHIT_BIND_II', 282358),
(463265, 'PS51425', NULL, 'Stromalin conservative (SCD) domain profile.', NULL, NULL, 'SCD', 282359);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(463266, 'PS51918', NULL, 'Radical SAM core domain profile.', NULL, NULL, 'RADICAL_SAM', 282360),
(463267, 'PS51380', NULL, 'EXS domain profile.', NULL, NULL, 'EXS', 282361),
(463268, 'PS51397', NULL, 'WLM domain profile.', NULL, NULL, 'WLM', 282362),
(463269, 'PS51490', NULL, 'KHA domain profile.', NULL, NULL, 'KHA', 282363),
(463270, 'PS51761', NULL, 'Glycosyl hydrolases family 11 (GH11) domain profile.', NULL, NULL, 'GH11_3', 282364),
(463271, 'PS51250', NULL, 'Taurine import ATP-binding protein tauB.', NULL, NULL, 'TAUB', 282365),
(463272, 'PS51923', NULL, 'Coronavirus spike (S) glycoprotein S2 subunit heptad repeat 1 (HR1) region profile.', NULL, NULL, 'COV_S2_HR1', 282366),
(463273, 'PS50209', NULL, 'CARD caspase recruitment domain profile.', NULL, NULL, 'CARD', 282367),
(463274, 'PS51107', NULL, 'PTS_EIIC type-5 domain profile.', NULL, NULL, 'PTS_EIIC_TYPE_5', 282368),
(463275, 'PS51139', NULL, 'GTF2I-like repeat profile.', NULL, NULL, 'GTF2I', 282369),
(463276, 'PS50803', NULL, 'OAR domain profile.', NULL, NULL, 'OAR', 282370),
(463277, 'PS51056', NULL, 'ITAM motif hantavirus type profile.', NULL, NULL, 'ITAM_2', 282371),
(463278, 'PS51154', NULL, 'Macro domain profile.', NULL, NULL, 'MACRO', 282372),
(463279, 'PS51946', NULL, 'Coronavirus Nsp4 C-terminal (Nsp4C) domain profile.', NULL, NULL, 'COV_NSP4C', 282373),
(463280, 'PS51387', NULL, 'PCMH-type FAD-binding domain profile.', NULL, NULL, 'FAD_PCMH', 282374),
(463281, 'PS50071', NULL, '''Homeobox'' domain profile.', NULL, NULL, 'HOMEOBOX_2', 282375),
(463282, 'PS51288', NULL, 'Thiamine import ATP-binding protein thiQ family profile.', NULL, NULL, 'THIQ', 282376),
(463283, 'PS51572', NULL, 'Histone-lysine N-methyltransferase (EC 2.1.1.43) family profile.', NULL, NULL, 'SAM_MT43_1', 282377),
(463284, 'PS50159', NULL, 'Ribosomal protein S13 family profile.', NULL, NULL, 'RIBOSOMAL_S13_2', 282378),
(463285, 'PS51917', NULL, 'Pru (pleckstrin-like receptor for ubiquitin) domain profile.', NULL, NULL, 'PRU', 282379),
(463286, 'PS50075', NULL, 'Carrier protein (CP) domain profile.', NULL, NULL, 'CARRIER', 282380),
(463287, 'PS50998', NULL, 'Gla domain profile.', NULL, NULL, 'GLA_2', 282381),
(463288, 'PS51930', NULL, 'Bacterial microcompartment (BMC) domain profile.', NULL, NULL, 'BMC_2', 282382),
(463289, 'PS51559', NULL, 'Arginine and arginine-like N-methyltransferase domain profile.', NULL, NULL, 'SAM_RMT2', 282383),
(463290, 'PS50881', NULL, 'S5 double stranded RNA-binding domain profile.', NULL, NULL, 'S5_DSRBD', 282384),
(463291, 'PS51376', NULL, 'DBB domain profile.', NULL, NULL, 'DBB', 282385),
(463292, 'PS51598', NULL, 'Phosphatidylethanolamine N-methyltransferase (EC 2.1.1.17) family profile.', NULL, NULL, 'SAM_CHO2', 282386),
(463293, 'PS51890', NULL, 'DAZ domain profile.', NULL, NULL, 'DAZ', 282387),
(463294, 'PS51882', NULL, 'G-alpha domain profile.', NULL, NULL, 'G_ALPHA', 282388),
(463295, 'PS50095', NULL, 'PLAT domain profile.', NULL, NULL, 'PLAT', 282389),
(463296, 'PS51128', NULL, 'Prokaryotic dksA C4-type zinc finger profiles.', NULL, NULL, 'ZF_DKSA_2', 282390),
(463297, 'PS51315', NULL, 'sn-glycerol-3-phosphate import ATP-binding protein ugpC family profile.', NULL, NULL, 'UGPC', 282391),
(463298, 'PS51094', NULL, 'PTS_EIIA type-2 domain profile.', NULL, NULL, 'PTS_EIIA_TYPE_2', 282392),
(463299, 'PS51842', NULL, 'Intermediate filament (IF) rod domain profile.', NULL, NULL, 'IF_ROD_2', 282393),
(463300, 'PS51921', NULL, 'Betacoronavirus spike (S) glycoprotein S1 subunit C-terminal (CTD) domain profile.', NULL, NULL, 'BCOV_S1_CTD', 282394),
(463301, 'PS50045', NULL, 'Sigma-54 interaction domain profile.', NULL, NULL, 'SIGMA54_INTERACT_4', 282395),
(463302, 'PS51022', NULL, 'L27 domain profile.', NULL, NULL, 'L27', 282396),
(463303, 'PS51406', NULL, 'Fibrinogen C-terminal domain profile.', NULL, NULL, 'FIBRINOGEN_C_2', 282397),
(463304, 'PS50900', NULL, 'PLAC domain profile.', NULL, NULL, 'PLAC', 282398),
(463305, 'PS51306', NULL, 'ASD1 domain profile.', NULL, NULL, 'ASD1', 282399),
(463306, 'PS51575', NULL, 'Histone-lysine N-methyltransferase (EC 2.1.1.43) family profile.', NULL, NULL, 'SAM_MT43_SUVAR39_2', 282400);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(463307, 'PS51849', NULL, 'RsgI N-terminal anti-sigma domain profile.', NULL, NULL, 'RSGI_N', 282401),
(463308, 'PS51700', NULL, 'SEPARIN core domain profile.', NULL, NULL, 'SEPARIN', 282402),
(463309, 'PS51304', NULL, 'Galactoside-binding lectin (galectin) domain profile.', NULL, NULL, 'GALECTIN', 282403),
(463310, 'PS50003', NULL, 'PH domain profile.', NULL, NULL, 'PH_DOMAIN', 282404),
(463311, 'PS50953', NULL, 'KID domain profile.', NULL, NULL, 'KID', 282405),
(463312, 'PS51087', NULL, 'ApaG domain profile.', NULL, NULL, 'APAG', 282406),
(463313, 'PS51459', NULL, 'Fido domain profile.', NULL, NULL, 'FIDO', 282407),
(463314, 'PS50303', NULL, 'Pumilio homology domain (PUM-HD) profile.', NULL, NULL, 'PUM_HD', 282408),
(463315, 'PS51716', NULL, 'IRG-type guanine nucleotide-binding (G) domain profile.', NULL, NULL, 'G_IRG', 282409),
(463316, 'PS51358', NULL, 'Nop domain profile.', NULL, NULL, 'NOP', 282410),
(463317, 'PS51527', NULL, 'Flavivirus NS2B domain profile.', NULL, NULL, 'FLAVIVIRUS_NS2B', 282411),
(463318, 'PS51756', NULL, 'LXG domain profile.', NULL, NULL, 'LXG', 282412),
(463319, 'PS51841', NULL, 'Lamin-tail (LTD) domain profile.', NULL, NULL, 'LTD', 282413),
(463320, 'PS51573', NULL, 'Histone-lysine N-methyltransferase (EC 2.1.1.43) family profile.', NULL, NULL, 'SAM_MT43_SUVAR39_1', 282414),
(463321, 'PS51098', NULL, 'PTS_EIIB type-1 domain profile.', NULL, NULL, 'PTS_EIIB_TYPE_1', 282415),
(463322, 'PS51455', NULL, 'Phosphatidylinositol phosphate kinase (PIPK) domain profile.', NULL, NULL, 'PIPK', 282416),
(463323, 'PS51115', NULL, 'Laminin IV type A domain profile.', NULL, NULL, 'LAMININ_IVA', 282417),
(463324, 'PS50096', NULL, 'IQ motif profile.', NULL, NULL, 'IQ', 282418),
(463325, 'PS51915', NULL, 'ZAD domain profile.', NULL, NULL, 'ZAD', 282419),
(463326, 'PS50322', NULL, 'Glutamine-rich region profile.', NULL, NULL, 'GLN_RICH', 282420),
(463327, 'PS51443', NULL, 'Phytochelatin synthase (PCS) domain profile.', NULL, NULL, 'PCS', 282421),
(463328, 'PS51806', NULL, 'DOG1 domain profile.', NULL, NULL, 'DOG1', 282422),
(463329, 'PS51359', NULL, 'Cytochrome c oxidase subunit Vb, zinc binding domain profile.', NULL, NULL, 'COX5B_2', 282423),
(463330, 'PS50892', NULL, 'v-SNARE coiled-coil homology domain profile.', NULL, NULL, 'V_SNARE', 282424),
(463331, 'PS51883', NULL, 'Obg domain profile.', NULL, NULL, 'OBG', 282425),
(463332, 'PS51133', NULL, 'Zinc finger TFIIS-type profile.', NULL, NULL, 'ZF_TFIIS_2', 282426),
(463333, 'PS51937', NULL, 'HNF-1 dimerization (HNF-p1) domain profile.', NULL, NULL, 'HNF_P1', 282427),
(463334, 'PS51518', NULL, 'SGF29 C-terminal domain profile.', NULL, NULL, 'SGF29_C', 282428),
(463335, 'PS50058', NULL, 'G-protein gamma subunit domain profile.', NULL, NULL, 'G_PROTEIN_GAMMA', 282429),
(463336, 'PS51748', NULL, 'Hexokinase domain profile.', NULL, NULL, 'HEXOKINASE_2', 282430),
(463337, 'PS50293', NULL, 'TPR repeat region circular profile.', NULL, NULL, 'TPR_REGION', 282431),
(463338, 'PS50041', NULL, 'C-type lectin domain profile.', NULL, NULL, 'C_TYPE_LECTIN_2', 282432),
(463339, 'PS50280', NULL, 'SET domain profile.', NULL, NULL, 'SET', 282433),
(463340, 'PS50138', NULL, 'BRCA2 repeat profile.', NULL, NULL, 'BRCA2_REPEAT', 282434),
(463341, 'PS51894', NULL, 'Caliciviridae (CV) 3C-like protein profile.', NULL, NULL, 'CV_3CL_PRO', 282435),
(463342, 'PS50202', NULL, 'Major sperm protein (MSP) domain profile.', NULL, NULL, 'MSP', 282436),
(463343, 'PS51125', NULL, 'NHL repeat profile.', NULL, NULL, 'NHL', 282437),
(463344, 'PS51780', NULL, 'GW domain profile.', NULL, NULL, 'GW', 282438),
(463345, 'PS51722', NULL, 'Translational (tr)-type guanine nucleotide-binding (G) domain profile.', NULL, NULL, 'G_TR_2', 282439),
(463346, 'PS51512', NULL, 'DFDF domain profile.', NULL, NULL, 'DFDF', 282440),
(463347, 'PS51819', NULL, 'Vicinal oxygen chelate (VOC) domain profile.', NULL, NULL, 'VOC', 282441),
(463348, 'PS51610', NULL, 'Calmodulin-lysine N-methyltransferase (EC 2.1.1.60) family profile.', NULL, NULL, 'SAM_CLNMT', 282442),
(463349, 'PS51043', NULL, 'DDHD domain profile.', NULL, NULL, 'DDHD', 282443);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(463350, 'PS51129', NULL, 'PdxS/SNZ family profile.', NULL, NULL, 'PDXS_SNZ_2', 282444),
(463351, 'PS51473', NULL, 'Gnk2-homologous domain profile.', NULL, NULL, 'GNK2', 282445),
(463352, 'PS51499', NULL, 'APO domain profile.', NULL, NULL, 'APO', 282446),
(463353, 'PS51274', NULL, 'CobBQ-type GATase domain profile.', NULL, NULL, 'GATASE_COBBQ', 282447),
(463354, 'PS51786', NULL, 'Lon proteolytic domain profile.', NULL, NULL, 'LON_PROTEOLYTIC', 282448),
(463355, 'PS50219', NULL, 'Citron homology (CNH) domain profile.', NULL, NULL, 'CNH', 282449),
(463356, 'PS50845', NULL, 'Reticulon domain profile.', NULL, NULL, 'RETICULON', 282450),
(463357, 'PS50031', NULL, 'EH domain profile.', NULL, NULL, 'EH', 282451),
(463358, 'PS51013', NULL, 'Pannexin family profile.', NULL, NULL, 'PANNEXIN', 282452),
(463359, 'PS51706', NULL, 'EngB-type guanine nucleotide-binding (G) domain profile.', NULL, NULL, 'G_ENGB', 282453),
(463360, 'PS50877', NULL, 'GoLoco/GPR motif profile.', NULL, NULL, 'GOLOCO', 282454),
(463361, 'PS50038', NULL, 'Frizzled (fz) domain profile.', NULL, NULL, 'FZ', 282455),
(463362, 'PS50318', NULL, 'Lysine-rich region profile.', NULL, NULL, 'LYS_RICH', 282456),
(463363, 'PS51229', NULL, 'DCUN1 domain profile.', NULL, NULL, 'DCUN1', 282457),
(463364, 'PS51259', NULL, 'Munc13-homology domain 2 (MHD2) profile.', NULL, NULL, 'MHD2', 282458),
(463365, 'PS51578', NULL, 'Histone-lysine N-methyltransferase (EC 2.1.1.43) family profile.', NULL, NULL, 'SAM_MT43_SET2_2', 282459),
(463366, 'PS51191', NULL, 'FemABX peptidyl transferase family profile.', NULL, NULL, 'FEMABX', 282460),
(463367, 'PS51371', NULL, 'CBS domain profile.', NULL, NULL, 'CBS', 282461),
(463368, 'PS51411', NULL, 'PSP1 C-terminal domain profile.', NULL, NULL, 'PSP1_C', 282462),
(463369, 'PS51269', NULL, 'COMM domain profile.', NULL, NULL, 'COMM', 282463),
(463370, 'PS51497', NULL, 'UMA domain profile.', NULL, NULL, 'UMA', 282464),
(463371, 'PS51579', NULL, 'Histone-lysine N-methyltransferase (EC 2.1.1.43) family profile.', NULL, NULL, 'SAM_MT43_SUVAR39_3', 282465),
(463372, 'PS51244', NULL, 'Lipoprotein release ATP-binding protein lolD family profile.', NULL, NULL, 'LOLD', 282466),
(463373, 'PS50978', NULL, 'NEAT domain profile.', NULL, NULL, 'NEAT', 282467),
(463374, 'PS51545', NULL, 'PIK helical domain profile.', NULL, NULL, 'PIK_HELICAL', 282468),
(463375, 'PS50156', NULL, 'Sterol-sensing domain (SSD) profile.', NULL, NULL, 'SSD', 282469),
(463376, 'PS50312', NULL, 'Aspartic acid-rich region profile.', NULL, NULL, 'ASP_RICH', 282470),
(463377, 'PS51243', NULL, 'Cytochrome C biogenesis export ATP-binding protein ccmA family profile.', NULL, NULL, 'CCMA', 282471),
(463378, 'PS51535', NULL, 'Pestivirus NS3 protease (NS3pro) domain profile.', NULL, NULL, 'PESTIVIRUS_NS3PRO', 282472),
(463379, 'PS50974', NULL, 'AdoMet activation domain profile.', NULL, NULL, 'ADOMET_ACTIVATION', 282473),
(463380, 'PS50196', NULL, 'Ran binding domain type 1 profile.', NULL, NULL, 'RANBD1', 282474),
(463381, 'PS51471', NULL, 'Fe(2+) 2-oxoglutarate dioxygenase domain profile.', NULL, NULL, 'FE2OG_OXY', 282475),
(463382, 'PS50276', NULL, 'Pancreatic hormone family profile.', NULL, NULL, 'PANCREATIC_HORMONE_2', 282476),
(463383, 'PS50523', NULL, 'RdRp of Reoviridae dsRNA viruses catalytic domain profile.', NULL, NULL, 'RDRP_DSRNA_REO', 282477),
(463384, 'PS51468', NULL, 'VIT domain profile.', NULL, NULL, 'VIT', 282478),
(463385, 'PS51504', NULL, 'Linker histone H1/H5 globular (H15) domain profile.', NULL, NULL, 'H15', 282479),
(463386, 'PS51195', NULL, 'DEAD-box RNA helicase Q motif profile.', NULL, NULL, 'Q_MOTIF', 282480),
(463387, 'PS51383', NULL, 'YjeF C-terminal domain profile.', NULL, NULL, 'YJEF_C_3', 282481),
(463388, 'PS51734', NULL, 'MPBQ/MBSQ family SAM-binding methyltransferase profile.', NULL, NULL, 'SAM_MPBQ_MSBQ_MT', 282482),
(463389, 'PS51648', NULL, 'YcgL domain profile.', NULL, NULL, 'YCGL', 282483),
(463390, 'PS51228', NULL, 'Acyl-CoA-binding (ACB) domain profile.', NULL, NULL, 'ACB_2', 282484),
(463391, 'PS51169', NULL, 'Chorismate mutase domain profile.', NULL, NULL, 'CHORISMATE_MUT_3', 282485);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(463392, 'PS50267', NULL, 'Sodium:neurotransmitter symporter family profile.', NULL, NULL, 'NA_NEUROTRAN_SYMP_3', 282486),
(463393, 'PS50918', NULL, 'WWE domain profile.', NULL, NULL, 'WWE', 282487),
(463394, 'PS51328', NULL, 'L-type lectin-like (leguminous) domain profile.', NULL, NULL, 'L_LECTIN_LIKE', 282488),
(463395, 'PS51985', NULL, 'Cryptic Polo-Box 2 (CPB2) domain profile.', NULL, NULL, 'CPB2', 282489),
(463396, 'PS51059', NULL, 'PARP catalytic domain profile.', NULL, NULL, 'PARP_CATALYTIC', 282490),
(463397, 'PS50200', NULL, 'Ras-associating (RA) domain profile.', NULL, NULL, 'RA', 282491),
(463398, 'PS50879', NULL, 'RNase H type-1 domain profile.', NULL, NULL, 'RNASE_H_1', 282492),
(463399, 'PS51254', NULL, 'Ribose import ATP-binding protein rbsA family profile.', NULL, NULL, 'RBSA', 282493),
(463400, 'PS51861', NULL, 'Oxytoxin-type inhibitor cystine knot (ICK) domain profile.', NULL, NULL, 'OXYTX_ICK', 282494),
(463401, 'PS50818', NULL, 'Intein C-terminal splicing motif profile.', NULL, NULL, 'INTEIN_C_TER', 282495),
(463402, 'PS51983', NULL, 'CUT repeat-like (CUTL) domain profile.', NULL, NULL, 'CUTL', 282496),
(463403, 'PS51493', NULL, 'Arterivirus nsp4 proteinase domain profile.', NULL, NULL, 'AV_NSP4_PRO', 282497),
(463404, 'PS50009', NULL, 'Ras guanine-nucleotide exchange factors catalytic domain profile.', NULL, NULL, 'RASGEF_CAT', 282498),
(463405, 'PS50240', NULL, 'Serine proteases, trypsin domain profile.', NULL, NULL, 'TRYPSIN_DOM', 282499),
(463406, 'PS51760', NULL, 'Glycosyl hydrolases family 10 (GH10) domain profile.', NULL, NULL, 'GH10_2', 282500),
(463407, 'PS50928', NULL, 'ABC transporter integral membrane type-1 domain profile.', NULL, NULL, 'ABC_TM1', 282501),
(463408, 'PS51867', NULL, 'Gid-type RING finger profile.', NULL, NULL, 'ZF_RING_GID', 282502),
(463409, 'PS51887', NULL, 'Aphthovirus leader protease (L(pro)) domain profile.', NULL, NULL, 'APHTHOVIRUS_LPRO', 282503),
(463410, 'PS50866', NULL, 'GOLD domain profile.', NULL, NULL, 'GOLD', 282504),
(463411, 'PS51568', NULL, 'Histone-lysine N-methyltransferase (EC 2.1.1.43) family profile.', NULL, NULL, 'SAM_MT43_SET2_1', 282505),
(463412, 'PS50983', NULL, 'Iron siderophore/cobalamin periplasmic-binding domain profile.', NULL, NULL, 'FE_B12_PBP', 282506),
(463413, 'PS50214', NULL, 'Disintegrin domain profile.', NULL, NULL, 'DISINTEGRIN_2', 282507),
(463414, 'PS51264', NULL, 'Methionine import ATP-binding protein metN family profile.', NULL, NULL, 'METN', 282508),
(463415, 'PS50022', NULL, 'Coagulation factors 5/8 type C domain (FA58C) profile.', NULL, NULL, 'FA58C_3', 282509),
(463416, 'PS51967', NULL, 'Coronavirus (CoV) 3a-like viroporin cytosolic (CD) domain profile.', NULL, NULL, 'COV_VIROPORIN_3A_CD', 282510),
(463417, 'PS51222', NULL, 'DCD domain profile.', NULL, NULL, 'DCD', 282511),
(463418, 'PS50250', NULL, 'PCI domain profile.', NULL, NULL, 'PCI', 282512),
(463419, 'PS51117', NULL, 'Laminin N-terminal domain profile.', NULL, NULL, 'LAMININ_NTER', 282513),
(463420, 'PS51912', NULL, 'DMAP1-binding domain profile.', NULL, NULL, 'DMAP1_BIND', 282514),
(463421, 'PS51157', NULL, 'Zinc finger UBR-type profile.', NULL, NULL, 'ZF_UBR', 282515),
(463422, 'PS51150', NULL, 'Agouti domain profile.', NULL, NULL, 'AGOUTI_2', 282516),
(463423, 'PS51822', NULL, 'Hepacivirus/Pegivirus NS3 protease domain profile.', NULL, NULL, 'HV_PV_NS3_PRO', 282517),
(463424, 'PS51676', NULL, 'FF domain profile.', NULL, NULL, 'FF', 282518),
(463425, 'PS51792', NULL, 'Yippee domain profile.', NULL, NULL, 'YIPPEE', 282519),
(463426, 'PS51007', NULL, 'Cytochrome c family profile.', NULL, NULL, 'CYTC', 282520),
(463427, 'PS51775', NULL, 'GTD-binding domain profile.', NULL, NULL, 'GTD_BINDING', 282521),
(463428, 'PS50160', NULL, 'ATP-dependent DNA ligase family profile.', NULL, NULL, 'DNA_LIGASE_A3', 282522),
(463429, 'PS51112', NULL, 'AMMECR1 domain profile.', NULL, NULL, 'AMMECR1', 282523),
(463430, 'PS51345', NULL, 'Myotoxins family profile.', NULL, NULL, 'MYOTOXINS_2', 282524),
(463431, 'PS51336', NULL, 'DM10 domain profile.', NULL, NULL, 'DM10', 282525);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(463432, 'PS51982', NULL, 'Ubiquitin-like (ULD) domain profile.', NULL, NULL, 'ULD', 282526),
(463433, 'PS51707', NULL, 'CYTH domain profile.', NULL, NULL, 'CYTH', 282527),
(463434, 'PS51126', NULL, 'Dilute domain profile.', NULL, NULL, 'DILUTE', 282528),
(463435, 'PS51317', NULL, 'Beta-(1-->2)glucan export ATP-binding/permease protein ndvA family profile.', NULL, NULL, 'NDVA', 282529),
(463436, 'PS51778', NULL, 'VASt domain profile.', NULL, NULL, 'VAST', 282530),
(463437, 'PS50018', NULL, 'Ras GTPase-activating proteins profile.', NULL, NULL, 'RAS_GTPASE_ACTIV_2', 282531),
(463438, 'PS51966', NULL, 'Coronavirus (CoV) 3a-like viroporin trans-membrane (TM) domain profile.', NULL, NULL, 'COV_VIROPORIN_3A_TM', 282532),
(463439, 'PS51472', NULL, 'RNA-recognition motif (RRM) Nup35-type domain profile.', NULL, NULL, 'RRM_NUP35', 282533),
(463440, 'PS51899', NULL, 'Flp-type tyrosine recombinase domain profile.', NULL, NULL, 'TYR_RECOMBINASE_FLP', 282534),
(463441, 'PS50825', NULL, 'HYR domain profile.', NULL, NULL, 'HYR', 282535),
(463442, 'PS51280', NULL, 'Xylose import ATP-binding protein xylG family profile.', NULL, NULL, 'XYLG', 282536),
(463443, 'PS51384', NULL, 'Ferredoxin reductase-type FAD binding domain profile.', NULL, NULL, 'FAD_FR', 282537),
(463444, 'PS51188', NULL, 'Zinc finger CR-type profile.', NULL, NULL, 'ZF_CR', 282538),
(463445, 'PS51582', NULL, 'Phosphoethanolamine N-methyltransferase (PEAMT) (EC 2.1.1.103) family profile.', NULL, NULL, 'SAM_PEAMT', 282539),
(463446, 'PS51862', NULL, 'BetaSPN-type cysteine-stabilized alpha/beta (CS-alpha/beta) domain profile.', NULL, NULL, 'BSPN_CSAB', 282540),
(463447, 'PS50066', NULL, 'MADS-box domain profile.', NULL, NULL, 'MADS_BOX_2', 282541),
(463448, 'PS50297', NULL, 'Ankyrin repeat region circular profile.', NULL, NULL, 'ANK_REP_REGION', 282542),
(463449, 'PS50902', NULL, 'Flavodoxin-like domain profile.', NULL, NULL, 'FLAVODOXIN_LIKE', 282543),
(463450, 'PS50942', NULL, 'ENTH domain profile.', NULL, NULL, 'ENTH', 282544),
(463451, 'PS51924', NULL, 'Coronavirus spike (S) glycoprotein S2 subunit heptad repeat 2 (HR2) region profile.', NULL, NULL, 'COV_S2_HR2', 282545),
(463452, 'PS51523', NULL, 'Zinc-finger ZF-HD dimerization-type profile.', NULL, NULL, 'ZF_HD_DIMER', 282546),
(463453, 'PS51488', NULL, 'KBD domain profile.', NULL, NULL, 'KBD', 282547),
(463454, 'PS50030', NULL, 'Ubiquitin-associated domain (UBA) profile.', NULL, NULL, 'UBA', 282548),
(463455, 'PS51725', NULL, 'ABM domain profile.', NULL, NULL, 'ABM', 282549),
(463456, 'PS51037', NULL, 'YEATS domain profile.', NULL, NULL, 'YEATS', 282550),
(463457, 'PS51102', NULL, 'PTS_EIIB type-5 domain profile.', NULL, NULL, 'PTS_EIIB_TYPE_5', 282551),
(463458, 'PS50181', NULL, 'F-box domain profile.', NULL, NULL, 'FBOX', 282552),
(463459, 'PS51182', NULL, 'C2 tensin-type domain profile.', NULL, NULL, 'C2_TENSIN', 282553),
(463460, 'PS51412', NULL, 'Membrane attack complex/perforin (MACPF) domain profile.', NULL, NULL, 'MACPF_2', 282554),
(463461, 'PS50211', NULL, 'Tripartite DENN domain profile.', NULL, NULL, 'DENN', 282555),
(463462, 'PS51108', NULL, 'PTS_EIID domain profile.', NULL, NULL, 'PTS_EIID', 282556),
(463463, 'PS51186', NULL, 'Gcn5-related N-acetyltransferase (GNAT) domain profile.', NULL, NULL, 'GNAT', 282557),
(463464, 'PS50837', NULL, 'NACHT-NTPase domain profile.', NULL, NULL, 'NACHT', 282558),
(463465, 'PS51957', NULL, 'LIM interaction domain (LID) domain profile.', NULL, NULL, 'LID', 282559),
(463466, 'PS50909', NULL, 'GAT domain profile.', NULL, NULL, 'GAT', 282560),
(463467, 'PS50970', NULL, 'Homocysteine-binding domain profile.', NULL, NULL, 'HCY', 282561),
(463468, 'PS51208', NULL, 'Autotransporter beta-domain profile.', NULL, NULL, 'AUTOTRANSPORTER', 282562),
(463469, 'PS51083', NULL, 'Zinc finger HIT-type profile.', NULL, NULL, 'ZF_HIT', 282563),
(463470, 'PS51502', NULL, 'Stress-response A/B barrel domain profile.', NULL, NULL, 'S_R_A_B_BARREL', 282564),
(463471, 'PS51577', NULL, 'Histone-lysine N-methyltransferase (EC 2.1.1.43) family profile.', NULL, NULL, 'SAM_MT43_SET7', 282565);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(463472, 'PS51901', NULL, 'Archaeal CBS proteins (ACP)-type metal binding (MB) domain profile.', NULL, NULL, 'ACP_MB', 282566),
(463473, 'PS51926', NULL, 'Coronavirus envelope (CoV E) protein profile.', NULL, NULL, 'COV_E', 282567),
(463474, 'PS51403', NULL, 'Collagen IV carboxyl-terminal non-collagenous (NC1) domain profile.', NULL, NULL, 'NC1_IV', 282568),
(463475, 'PS51600', NULL, 'Glycine N-methyltransferase (EC 2.1.1.20 and EC 2.1.1.156) family profile.', NULL, NULL, 'SAM_GNMT', 282569),
(463476, 'PS51338', NULL, 'IMD domain profile.', NULL, NULL, 'IMD', 282570),
(463477, 'PS50225', NULL, 'SOCS box domain profile.', NULL, NULL, 'SOCS', 282571),
(463478, 'PS51697', NULL, 'ALOG domain profile.', NULL, NULL, 'ALOG', 282572),
(463479, 'PS50939', NULL, 'Cytochrome b561 domain profile.', NULL, NULL, 'CYTOCHROME_B561', 282573),
(463480, 'PS51062', NULL, 'Runt domain profile.', NULL, NULL, 'RUNT', 282574),
(463481, 'PS51928', NULL, 'Coronavirus nucleocapsid (CoV N) protein N-terminal (NTD) domain profile.', NULL, NULL, 'COV_N_NTD', 282575),
(463482, 'PS51776', NULL, 'RH1 domain profile.', NULL, NULL, 'RH1', 282576),
(463483, 'PS50324', NULL, 'Serine-rich region profile.', NULL, NULL, 'SER_RICH', 282577),
(463484, 'PS50600', NULL, 'Ubiquitin-like protease family profile.', NULL, NULL, 'ULP_PROTEASE', 282578),
(463485, 'PS51364', NULL, 'TGF-beta binding (TB) domain profile.', NULL, NULL, 'TB', 282579),
(463486, 'PS51402', NULL, 'catalase family profile.', NULL, NULL, 'CATALASE_3', 282580),
(463487, 'PS51574', NULL, 'Histone-lysine N-methyltransferase (EC 2.1.1.43) family profile.', NULL, NULL, 'SAM_MT43_2', 282581),
(463488, 'PS50016', NULL, 'Zinc finger PHD-type profile.', NULL, NULL, 'ZF_PHD_2', 282582),
(463489, 'PS51130', NULL, 'PdxT/SNO family profile.', NULL, NULL, 'PDXT_SNO_2', 282583),
(463490, 'PS50404', NULL, 'Soluble glutathione S-transferase N-terminal domain profile.', NULL, NULL, 'GST_NTER', 282584),
(463491, 'PS51090', NULL, 'Cortactin repeat profile.', NULL, NULL, 'CORTACTIN', 282585),
(463492, 'PS51122', NULL, 'Calponin-like repeat profile.', NULL, NULL, 'CALPONIN_2', 282586),
(463493, 'PS51310', NULL, 'VPS28 C-terminal domain profile.', NULL, NULL, 'VPS28_C', 282587),
(463494, 'PS50236', NULL, 'Clathrin heavy-chain (CHCR) repeat profile.', NULL, NULL, 'CHCR', 282588),
(463495, 'PS50013', NULL, 'Chromo and chromo shadow domain profile.', NULL, NULL, 'CHROMO_2', 282589),
(463496, 'PS51836', NULL, 'Tripartite DENN FNIP1/2-type domain profile.', NULL, NULL, 'DENN_FNIP12', 282590),
(463497, 'PS50863', NULL, 'B3 DNA-binding domain profile.', NULL, NULL, 'B3', 282591),
(463498, 'PS50972', NULL, 'Pterin-binding domain profile.', NULL, NULL, 'PTERIN_BINDING', 282592),
(463499, 'PS50004', NULL, 'C2 domain profile.', NULL, NULL, 'C2', 282593),
(463500, 'PS51943', NULL, 'Coronavirus Nsp3a Ubl domain profile.', NULL, NULL, 'COV_NSP3A_UBL', 282594),
(463501, 'PS51934', NULL, 'LRAT domain profile.', NULL, NULL, 'LRAT', 282595),
(463502, 'PS50934', NULL, 'SWIRM domain profile.', NULL, NULL, 'SWIRM', 282596),
(463503, 'PS50141', NULL, 'Adenosine to inosine editase domain profile.', NULL, NULL, 'A_DEAMIN_EDITASE', 282597),
(463504, 'PS51551', NULL, 'Ephrin receptor-binding (ephrin RBD) domain profile.', NULL, NULL, 'EPHRIN_RBD_2', 282598),
(463505, 'PS50314', NULL, 'Phenylalanine-rich region profile.', NULL, NULL, 'PHE_RICH', 282599),
(463506, 'PS51010', NULL, 'Cytochrome f family profile.', NULL, NULL, 'CYTF', 282600),
(463507, 'PS50168', NULL, 'Death effector domain (DED) profile.', NULL, NULL, 'DED', 282601),
(463508, 'PS50277', NULL, 'Glycoprotein hormones alpha chain family profile.', NULL, NULL, 'GLYCO_HORMONE_ALPHA_3', 282602),
(463509, 'PS51542', NULL, 'FYR domain FYRN motif profile.', NULL, NULL, 'FYRN', 282603),
(463510, 'PS50802', NULL, 'OTU domain profile.', NULL, NULL, 'OTU', 282604),
(463511, 'PS51981', NULL, 'Zinc finger RZ-type profile.', NULL, NULL, 'ZF_RZ', 282605),
(463512, 'PS51495', NULL, 'GLUE domain profile.', NULL, NULL, 'GLUE', 282606),
(463513, 'PS51750', NULL, 'Bro-N domain profile.', NULL, NULL, 'BRO_N', 282607);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(463514, 'PS51939', NULL, 'xRRM domain profile.', NULL, NULL, 'XRRM', 282608),
(463515, 'PS50810', NULL, 'Frataxin family profile.', NULL, NULL, 'FRATAXIN_2', 282609),
(463516, 'PS50885', NULL, 'HAMP domain profile.', NULL, NULL, 'HAMP', 282610),
(463517, 'PS51671', NULL, 'ACT domain profile.', NULL, NULL, 'ACT', 282611),
(463518, 'PS51913', NULL, 'HARE-type HTH domain profile.', NULL, NULL, 'HTH_HARE', 282612),
(463519, 'PS51134', NULL, 'Zinc finger TFIIB-type profile.', NULL, NULL, 'ZF_TFIIB', 282613),
(463520, 'PS51203', NULL, 'CS domain profile.', NULL, NULL, 'CS', 282614),
(463521, 'PS51148', NULL, 'AXH domain profile.', NULL, NULL, 'AXH', 282615),
(463522, 'PS50024', NULL, 'SEA domain profile.', NULL, NULL, 'SEA', 282616),
(463523, 'PS50152', NULL, '2''-5''-oligoadenylate synthase N-terminal region profile.', NULL, NULL, '25A_SYNTH_3', 282617),
(463524, 'PS51704', NULL, 'GP-PDE domain profile.', NULL, NULL, 'GP_PDE', 282618),
(463525, 'PS51496', NULL, 'CVC domain profile.', NULL, NULL, 'CVC', 282619),
(463526, 'PS51850', NULL, 'KARI N-terminal domain profile.', NULL, NULL, 'KARI_N', 282620),
(463527, 'PS50987', NULL, 'ArsR-type HTH domain profile.', NULL, NULL, 'HTH_ARSR_2', 282621),
(463528, 'PS51088', NULL, 'TEA domain profile.', NULL, NULL, 'TEA_2', 282622),
(463529, 'PS51091', NULL, 'Fibronectin type-I domain profile.', NULL, NULL, 'FN1_2', 282623),
(463530, 'PS01124', NULL, 'Bacterial regulatory proteins, araC family DNA-binding domain profile.', NULL, NULL, 'HTH_ARAC_FAMILY_2', 282624),
(463531, 'PS50064', NULL, 'Poly(ADP-ribose) polymerase zinc finger domain profile.', NULL, NULL, 'PARP_ZN_FINGER_2', 282625),
(463532, 'PS51063', NULL, 'Crp-type HTH domain profile.', NULL, NULL, 'HTH_CRP_2', 282626),
(463533, 'PS51120', NULL, 'LDL-receptor class B (LDLRB) repeat profile.', NULL, NULL, 'LDLRB', 282627),
(463534, 'PS50895', NULL, 'SURF1 family profile.', NULL, NULL, 'SURF1', 282628),
(463535, 'PS51709', NULL, 'TrmE-type guanine nucleotide-binding (G) domain profile.', NULL, NULL, 'G_TRME', 282629),
(463536, 'PS51757', NULL, 'Class I myosin tail homology (TH1) domain profile.', NULL, NULL, 'TH1', 282630),
(463537, 'PS50191', NULL, 'CRAL-TRIO lipid binding domain profile.', NULL, NULL, 'CRAL_TRIO', 282631),
(463538, 'PS51470', NULL, 'FG-GAP repeat profile.', NULL, NULL, 'FG_GAP', 282632),
(463539, 'PS51111', NULL, 'REJ domain profile.', NULL, NULL, 'REJ', 282633),
(463540, 'PS51828', NULL, 'Pentraxin (PTX) domain profile.', NULL, NULL, 'PTX_2', 282634),
(463541, 'PS51152', NULL, 'NF-YA/HAP2 family profile.', NULL, NULL, 'NFYA_HAP2_2', 282635),
(463542, 'PS50980', NULL, 'Acetyl-coenzyme A (CoA) carboxyltransferase N-terminal domain profile.', NULL, NULL, 'COA_CT_NTER', 282636),
(463543, 'PS51407', NULL, 'Lysosome-associated membrane glycoprotein family profile.', NULL, NULL, 'LAMP_3', 282637),
(463544, 'PS50862', NULL, 'Aminoacyl-transfer RNA synthetases class-II family profile.', NULL, NULL, 'AA_TRNA_LIGASE_II', 282638),
(463545, 'PS51838', NULL, 'Hepatitis delta antigen (HDAg) domain profile.', NULL, NULL, 'HDAG', 282639),
(463546, 'PS51074', NULL, 'DPH-type metal-binding (MB) domain profile.', NULL, NULL, 'DPH_MB', 282640),
(463547, 'PS51634', NULL, 'CRC domain profile.', NULL, NULL, 'CRC', 282641),
(463548, 'PS51217', NULL, 'UvrD-like DNA helicase C-terminal domain profile.', NULL, NULL, 'UVRD_HELICASE_CTER', 282642),
(463549, 'PS50085', NULL, 'Rap GTPase activating proteins domain profile.', NULL, NULL, 'RAPGAP', 282643),
(463550, 'PS50157', NULL, 'Zinc finger C2H2 type domain profile.', NULL, NULL, 'ZINC_FINGER_C2H2_2', 282644),
(463551, 'PS51104', NULL, 'PTS_EIIC type-2 domain profile.', NULL, NULL, 'PTS_EIIC_TYPE_2', 282645),
(463552, 'PS51004', NULL, 'Sema domain profile.', NULL, NULL, 'SEMA', 282646),
(463553, 'PS51484', NULL, 'G8 domain profile.', NULL, NULL, 'G8', 282647),
(463554, 'PS50327', NULL, 'Tryptophan-rich region profile.', NULL, NULL, 'TRP_RICH', 282648),
(463555, 'PS51267', NULL, 'Macrolide export ATP-binding/permease protein macB family profile.', NULL, NULL, 'MACB', 282649);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(463556, 'PS51161', NULL, 'ATP-cone domain profile.', NULL, NULL, 'ATP_CONE', 282650),
(463557, 'PS51796', NULL, 'MSS4 domain profile.', NULL, NULL, 'MSS4', 282651),
(463558, 'PS51321', NULL, 'TFIIS central domain profile.', NULL, NULL, 'TFIIS_CENTRAL', 282652),
(463559, 'PS51858', NULL, 'PPPDE domain profile.', NULL, NULL, 'PPPDE', 282653),
(463560, 'PS51485', NULL, 'Phytocyanin domain profile.', NULL, NULL, 'PHYTOCYANIN', 282654),
(463561, 'PS51325', NULL, 'Alpha box DNA-binding domain profile.', NULL, NULL, 'ALPHA_BOX', 282655),
(463562, 'PS51705', NULL, 'HflX-type guanine nucleotide-binding (G) domain profile.', NULL, NULL, 'G_HFLX', 282656),
(463563, 'PS51941', NULL, 'Betacoronavirus Nsp3c-M domain profile.', NULL, NULL, 'BCOV_NSP3C_M', 282657),
(463564, 'PS51668', NULL, 'TsaA-like domain profile.', NULL, NULL, 'TSAA_2', 282658),
(463565, 'PS50026', NULL, 'EGF-like domain profile.', NULL, NULL, 'EGF_3', 282659),
(463566, 'PS51893', NULL, 'A kinase-anchoring proteins AKAP-5 and AKAP-12 calmodulin (CaM)-binding motif profile.', NULL, NULL, 'AKAP_CAM_BD', 282660),
(463567, 'PS51817', NULL, 'Peptidase family A3B domain profile.', NULL, NULL, 'PEPTIDASE_A3B', 282661),
(463568, 'PS50882', NULL, 'YTH domain profile.', NULL, NULL, 'YTH', 282662),
(463569, 'PS50958', NULL, 'Somatomedin B (SMB) domain profile.', NULL, NULL, 'SMB_2', 282663),
(463570, 'PS50967', NULL, 'HRDC domain profile.', NULL, NULL, 'HRDC', 282664),
(463571, 'PS51036', NULL, 'Zinc finger A20-type profile.', NULL, NULL, 'ZF_A20', 282665),
(463572, 'PS51198', NULL, 'UvrD-like DNA helicase ATP-binding domain profile.', NULL, NULL, 'UVRD_HELICASE_ATP_BIND', 282666),
(463573, 'PS51327', NULL, 'Dicer double-stranded RNA-binding fold domain profile.', NULL, NULL, 'DICER_DSRBF', 282667),
(463574, 'PS51204', NULL, 'HSA domain profile.', NULL, NULL, 'HSA', 282668),
(463575, 'PS51029', NULL, 'MADF domain profile.', NULL, NULL, 'MADF', 282669),
(463576, 'PS50078', NULL, 'POLO box domain profile.', NULL, NULL, 'POLO_BOX', 282670),
(463577, 'PS50166', NULL, 'Importin-beta N-terminal domain profile.', NULL, NULL, 'IMPORTIN_B_NT', 282671),
(463578, 'PS51314', NULL, 'VPS37 C-terminal domain profile.', NULL, NULL, 'VPS37_C', 282672),
(463579, 'PS50146', NULL, 'DAG-kinase catalytic (DAGKc) domain profile.', NULL, NULL, 'DAGK', 282673),
(463580, 'PS51273', NULL, 'Glutamine amidotransferase type 1 domain profile.', NULL, NULL, 'GATASE_TYPE_1', 282674),
(463581, 'PS51449', NULL, 'Methylthiotransferase N-terminal domain profile.', NULL, NULL, 'MTTASE_N', 282675),
(463582, 'PS50851', NULL, 'CheW-like domain profile.', NULL, NULL, 'CHEW', 282676),
(463583, 'PS51230', NULL, 'EB1-C terminal (EB1-C) domain profile.', NULL, NULL, 'EB1_C', 282677),
(463584, 'PS51794', NULL, 'Diadenylate cyclase (DAC) domain profile.', NULL, NULL, 'DAC', 282678),
(463585, 'PS51408', NULL, 'Transferrin-like domain profile.', NULL, NULL, 'TRANSFERRIN_LIKE_4', 282679),
(463586, 'PS50126', NULL, 'S1 domain profile.', NULL, NULL, 'S1', 282680),
(463587, 'PS51566', NULL, 'Histone-lysine N-methyltransferase (EC 2.1.1.43) family profile.', NULL, NULL, 'SAM_MT43_TRX_MLL', 282681),
(463588, 'PS51008', NULL, 'Multiheme cytochrome c family profile.', NULL, NULL, 'MULTIHEME_CYTC', 282682),
(463589, 'PS51948', NULL, 'Coronavirus Nsp12 RNA-dependent RNA polymerase (RdRp) domain profile.', NULL, NULL, 'COV_NSP12_RDRP', 282683),
(463590, 'PS50405', NULL, 'Soluble glutathione S-transferase C-terminal domain profile.', NULL, NULL, 'GST_CTER', 282684),
(463591, 'PS50055', NULL, 'PTP type protein phosphatase domain profile.', NULL, NULL, 'TYR_PHOSPHATASE_PTP', 282685),
(463592, 'PS51160', NULL, 'Acylphosphatase-like domain profile.', NULL, NULL, 'ACYLPHOSPHATASE_3', 282686),
(463593, 'PS51215', NULL, 'AWS domain profile.', NULL, NULL, 'AWS', 282687),
(463594, 'PS50259', NULL, 'G-protein coupled receptors family 3 profile.', NULL, NULL, 'G_PROTEIN_RECEP_F3_4', 282688),
(463595, 'PS51275', NULL, 'Gamma-glutamyl hydrolase domain profile.', NULL, NULL, 'PEPTIDASE_C26_GGH', 282689),
(463596, 'PS50163', NULL, 'RecA family profile 2.', NULL, NULL, 'RECA_3', 282690);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(463597, 'PS51183', NULL, 'JmjN domain profile.', NULL, NULL, 'JMJN', 282691),
(463598, 'PS51856', NULL, 'Rho RNA-binding domain profile.', NULL, NULL, 'RHO_RNA_BD', 282692),
(463599, 'PS50316', NULL, 'Histidine-rich region profile.', NULL, NULL, 'HIS_RICH', 282693),
(463600, 'PS51349', NULL, 'FMN-dependent alpha-hydroxy acid dehydrogenase domain profile.', NULL, NULL, 'FMN_HYDROXY_ACID_DH_2', 282694),
(463601, 'PS51211', NULL, 'Vitellogenin domain profile.', NULL, NULL, 'VITELLOGENIN', 282695),
(463602, 'PS51651', NULL, 'DOCKER domain profile.', NULL, NULL, 'DOCKER', 282696),
(463603, 'PS50072', NULL, 'Cyclophilin-type peptidyl-prolyl cis-trans isomerase domain profile.', NULL, NULL, 'CSA_PPIASE_2', 282697),
(463604, 'PS50023', NULL, 'LIM domain profile.', NULL, NULL, 'LIM_DOMAIN_2', 282698),
(463605, 'PS51717', NULL, 'Very large inducible GTPASE (VLIG)-type guanine nucleotide-binding (G) domain profile.', NULL, NULL, 'G_VLIG', 282699),
(463606, 'PS51774', NULL, 'Networked (NET) actin-binding (NAB) domain profile.', NULL, NULL, 'NAB', 282700),
(463607, 'PS50070', NULL, 'Kringle domain profile.', NULL, NULL, 'KRINGLE_2', 282701),
(463608, 'PS51189', NULL, 'FAT domain profile.', NULL, NULL, 'FAT', 282702),
(463609, 'PS51305', NULL, 'Spermidine/putrescine import ATP-binding protein potA family profile.', NULL, NULL, 'POTA', 282703),
(463610, 'PS51233', NULL, 'VWFD domain profile.', NULL, NULL, 'VWFD', 282704),
(463611, 'PS51265', NULL, 'Zinc finger DBF4-type profile.', NULL, NULL, 'ZF_DBF4', 282705),
(463612, 'PS51430', NULL, 'KaiA N-terminal domain profile.', NULL, NULL, 'KAIA_N', 282706),
(463613, 'PS51744', NULL, 'Helper-component proteinase (HC-Pro) cysteine protease (CPD) domain profile.', NULL, NULL, 'HC_PRO_CPD', 282707),
(463614, 'PS51873', NULL, 'TRIAD supradomain profile.', NULL, NULL, 'TRIAD', 282708),
(463615, 'PS51326', NULL, 'Avidin-like domain profile.', NULL, NULL, 'AVIDIN_2', 282709),
(463616, 'PS50102', NULL, 'Eukaryotic RNA Recognition Motif (RRM) profile.', NULL, NULL, 'RRM', 282710),
(463617, 'PS51353', NULL, 'ArsC family profile.', NULL, NULL, 'ARSC', 282711),
(463618, 'PS50328', NULL, 'Tyrosine-rich region profile.', NULL, NULL, 'TYR_RICH', 282712),
(463619, 'PS50873', NULL, 'Plant heme peroxidase family profile.', NULL, NULL, 'PEROXIDASE_4', 282713),
(463620, 'PS51221', NULL, 'TTL domain profile.', NULL, NULL, 'TTL', 282714),
(463621, 'PS51513', NULL, 'FFD box profile.', NULL, NULL, 'FFD', 282715),
(463622, 'PS51547', NULL, 'C2 phosphatidylinositol 3-kinase (PI3K)-type domain profile.', NULL, NULL, 'C2_PI3K', 282716),
(463623, 'PS50025', NULL, 'Laminin G domain profile.', NULL, NULL, 'LAM_G_DOMAIN', 282717),
(463624, 'PS50330', NULL, 'Ubiquitin-interacting motif (UIM) domain profile.', NULL, NULL, 'UIM', 282718),
(463625, 'PS50883', NULL, 'EAL domain profile.', NULL, NULL, 'EAL', 282719),
(463626, 'PS51944', NULL, 'Coronavirus Nsp3d Ubl domain profile.', NULL, NULL, 'COV_NSP3D_UBL', 282720),
(463627, 'PS51509', NULL, 'Phosphagen kinase N-terminal domain profile.', NULL, NULL, 'PHOSPHAGEN_KINASE_N', 282721),
(463628, 'PS51925', NULL, 'SWIB/MDM2 domain profile.', NULL, NULL, 'SWIB_MDM2', 282722),
(463629, 'PS50044', NULL, 'Sigma-54 factors family profile.', NULL, NULL, 'SIGMA54_3', 282723),
(463630, 'PS50261', NULL, 'G-protein coupled receptors family 2 profile 2.', NULL, NULL, 'G_PROTEIN_RECEP_F2_4', 282724),
(463631, 'PS50059', NULL, 'FKBP-type peptidyl-prolyl cis-trans isomerase domain profile.', NULL, NULL, 'FKBP_PPIASE', 282725),
(463632, 'PS51247', NULL, 'Nickel import ATP-binding protein nikD.', NULL, NULL, 'NIKD', 282726),
(463633, 'PS51299', NULL, 'APSES-type HTH DNA-binding domain profile.', NULL, NULL, 'HTH_APSES', 282727),
(463634, 'PS51564', NULL, 'Protein-S-isoprenylcysteine O-methyltransferase (EC 2.1.1.100) family profile.', NULL, NULL, 'SAM_ICMT', 282728),
(463635, 'PS51138', NULL, 'EMSY N-terminal (ENT) domain profile.', NULL, NULL, 'ENT', 282729),
(463636, 'PS51677', NULL, 'NodB homology domain profile.', NULL, NULL, 'NODB', 282730),
(463637, 'PS50097', NULL, 'BTB domain profile.', NULL, NULL, 'BTB', 282731);
INSERT INTO "PUBLIC"."MODEL" VALUES
(463638, 'PS50919', NULL, 'MIR domain profile.', NULL, NULL, 'MIR', 282732),
(463639, 'PS51296', NULL, 'Rieske [2Fe-2S] iron-sulfur domain profile.', NULL, NULL, 'RIESKE', 282733),
(463640, 'PS51224', NULL, 'MVP (vault) repeat profile.', NULL, NULL, 'MVP', 282734),
(463641, 'PS51294', NULL, 'Myb-type HTH DNA-binding domain profile.', NULL, NULL, 'HTH_MYB', 282735),
(463642, 'PS51164', NULL, 'CBM1 (carbohydrate binding type-1) domain profile.', NULL, NULL, 'CBM1_2', 282736),
(463643, 'PS51354', NULL, 'Glutaredoxin domain profile.', NULL, NULL, 'GLUTAREDOXIN_2', 282737),
(463644, 'PS50238', NULL, 'Rho GTPase-activating proteins domain profile.', NULL, NULL, 'RHOGAP', 282738),
(463645, 'PS51231', NULL, 'Diaphanous autoregulatory domain (DAD) profile.', NULL, NULL, 'DAD', 282739),
(463646, 'PS51080', NULL, 'CTF/NF-I DNA-binding domain profile.', NULL, NULL, 'CTF_NFI_2', 282740),
(463647, 'PS50104', NULL, 'TIR domain profile.', NULL, NULL, 'TIR', 282741),
(463648, 'PS51048', NULL, 'SGS domain profile.', NULL, NULL, 'SGS', 282742),
(463649, 'PS51538', NULL, 'Arterivirus nsp2 cysteine protease (AV CP) domain profile.', NULL, NULL, 'AV_CP', 282743),
(463650, 'PS51219', NULL, 'Dephospho-CoA kinase (DPCK) domain profile.', NULL, NULL, 'DPCK', 282744),
(463651, 'PS51272', NULL, 'S-layer homology (SLH) domain profile.', NULL, NULL, 'SLH', 282745),
(463652, 'PS51124', NULL, 'Peptidase family C16 domain profile.', NULL, NULL, 'PEPTIDASE_C16', 282746),
(463653, 'PS51287', NULL, 'Large T-antigen (T-ag) origin-binding domain (OBD) profile.', NULL, NULL, 'T_AG_OBD', 282747),
(463654, 'PS51922', NULL, 'Betacoronavirus spike (S) glycoprotein S1 subunit N-terminal (NTD) domain profile.', NULL, NULL, 'BCOV_S1_NTD', 282748),
(463655, 'PS51014', NULL, 'Precorrin-6x reductase domain profile.', NULL, NULL, 'COBK_CBIJ', 282749),
(463656, 'PS51210', NULL, 'PLA2c domain profile.', NULL, NULL, 'PLA2C', 282750),
(463657, 'PS51498', NULL, 'MABP domain profile.', NULL, NULL, 'MABP', 282751),
(463658, 'PS50977', NULL, 'TetR-type HTH domain profile.', NULL, NULL, 'HTH_TETR_2', 282752),
(463659, 'PS51759', NULL, 'Carbohydrate-binding module 15 (CBM15) domain profile.', NULL, NULL, 'CBM15', 282753),
(463660, 'PS50084', NULL, 'Type-1 KH domain profile.', NULL, NULL, 'KH_TYPE_1', 282754),
(463661, 'PS51825', NULL, 'DIPSY domain profile.', NULL, NULL, 'DIPSY', 282755),
(463662, 'PS51159', NULL, 'CBM21 (carbohydrate binding type-21) domain profile.', NULL, NULL, 'CBM21', 282756),
(463663, 'PS50231', NULL, 'Lectin domain of ricin B chain profile.', NULL, NULL, 'RICIN_B_LECTIN', 282757),
(463664, 'PS51002', NULL, 'Cytochrome b/b6 N-terminal region profile.', NULL, NULL, 'CYTB_NTER', 282758),
(463665, 'PS50876', NULL, 'Zinc finger integrase-type profile.', NULL, NULL, 'ZF_INTEGRASE', 282759),
(463666, 'PS51522', NULL, 'Zinc finger nanos-type profile.', NULL, NULL, 'ZF_NANOS', 282760),
(463667, 'PS51456', NULL, 'Myosin motor domain profile.', NULL, NULL, 'MYOSIN_MOTOR', 282761),
(463668, 'PS51005', NULL, 'NAC domain profile.', NULL, NULL, 'NAC', 282762),
(463669, 'PS51052', NULL, 'Cyclotides profile.', NULL, NULL, 'CYCLOTIDE', 282763),
(463670, 'PS50961', NULL, 'La-type HTH domain profile.', NULL, NULL, 'HTH_LA', 282764),
(463671, 'PS51041', NULL, 'EMI domain profile.', NULL, NULL, 'EMI', 282765),
(463672, 'PS51393', NULL, 'Lipoxygenase iron-binding catalytic domain profile.', NULL, NULL, 'LIPOXYGENASE_3', 282766),
(463673, 'PS51690', NULL, 'Alphavirus core protein (CP) domain profile.', NULL, NULL, 'ALPHAVIRUS_CP', 282767),
(463674, 'PS51361', NULL, 'Teneurin N-terminal domain profile.', NULL, NULL, 'TENEURIN_N', 282768),
(463675, 'PS51463', NULL, 'Glucose-6-phosphate isomerase family profile.', NULL, NULL, 'P_GLUCOSE_ISOMERASE_3', 282769),
(463676, 'PS51066', NULL, 'Zinc finger FPG-type profile.', NULL, NULL, 'ZF_FPG_2', 282770),
(463677, 'PS50194', NULL, 'Filamin/ABP280 repeat profile.', NULL, NULL, 'FILAMIN_REPEAT', 282771),
(463678, 'PS51300', NULL, 'NADH-nitrite reductase subunit D family profile.', NULL, NULL, 'NIRD', 282772);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(463679, 'PS51714', NULL, 'Bms1-type guanine nucleotide-binding (G) domain profile.', NULL, NULL, 'G_BMS1', 282773),
(463680, 'PS51735', NULL, 'Filoviruses VP35 interferon inhibitory domain profile.', NULL, NULL, 'VP35_IID', 282774),
(463681, 'PS50234', NULL, 'VWFA domain profile.', NULL, NULL, 'VWFA', 282775),
(463682, 'PS51560', NULL, 'Nicotinamide N-methyltransferase (EC 2.1.1.1) family profile.', NULL, NULL, 'SAM_MT_NNT1', 282776),
(463683, 'PS51824', NULL, 'Flocculin 11 (Flo11) domain profile.', NULL, NULL, 'FLO11', 282777),
(463684, 'PS50304', NULL, 'Tudor domain profile.', NULL, NULL, 'TUDOR', 282778),
(463685, 'PS51659', NULL, 'Glycosyltransferase family 23 (GT23) domain profile.', NULL, NULL, 'GT23', 282779),
(463686, 'PS51719', NULL, 'Septin-type guanine nucleotide-binding (G) domain profile.', NULL, NULL, 'G_SEPTIN', 282780),
(463687, 'PS51212', NULL, 'WSC domain profile.', NULL, NULL, 'WSC', 282781),
(463688, 'PS51242', NULL, 'Ferric cations import ATP-binding protein fbpC family profile.', NULL, NULL, 'FBPC', 282782),
(463689, 'PS51652', NULL, 'Arteriviridae zinc-binding (AV ZBD) domain profile.', NULL, NULL, 'AV_ZBD', 282783),
(463690, 'PS51348', NULL, 'Glycosyl hydrolases family 22 (GH22) domain profile.', NULL, NULL, 'GLYCOSYL_HYDROL_F22_2', 282784),
(463691, 'PS51261', NULL, 'Hemin import ATP-Binding protein hmuV family profile.', NULL, NULL, 'HMUV', 282785),
(463692, 'PS51225', NULL, 'MARVEL domain profile.', NULL, NULL, 'MARVEL', 282786),
(463693, 'PS50127', NULL, 'Ubiquitin-conjugating (UBC) core domain profile.', NULL, NULL, 'UBC_2', 282787),
(463694, 'PS51789', NULL, 'RIG-I-like receptor (RLR) C-terminal regulatory (CTR) domain profile.', NULL, NULL, 'RLR_CTR', 282788),
(463695, 'PS51167', NULL, 'Chorismate mutase domain profile.', NULL, NULL, 'CHORISMATE_MUT_1', 282789),
(463696, 'PS51132', NULL, 'Olfactomedin-like domain profile.', NULL, NULL, 'OLF', 282790),
(463697, 'PS51179', NULL, 'POU-specific (POUs) domain profile.', NULL, NULL, 'POU_3', 282791),
(463698, 'PS50057', NULL, 'FERM domain profile.', NULL, NULL, 'FERM_3', 282792),
(463699, 'PS50296', NULL, 'Translation initiation factor SUI1 family profile.', NULL, NULL, 'SUI1', 282793),
(463700, 'PS50271', NULL, 'Zinc finger UBP-type profile.', NULL, NULL, 'ZF_UBP', 282794),
(463701, 'PS50208', NULL, 'Caspase family p20 domain profile.', NULL, NULL, 'CASPASE_P20', 282795),
(463702, 'PS51853', NULL, 'pG2 pseudoGTPase domain profile.', NULL, NULL, 'PG2', 282796),
(463703, 'PS51940', NULL, 'Sarbecovirus Nsp3c-N domain profile.', NULL, NULL, 'SARS_NSP3C_N', 282797),
(463704, 'PS51279', NULL, 'Bucentaur C-terminal (BCNT-C) domain profile.', NULL, NULL, 'BCNT_C', 282798),
(463705, 'PS51388', NULL, 'GED domain profile.', NULL, NULL, 'GED', 282799),
(463706, 'PS51026', NULL, 'NIFH_FRXC family profile.', NULL, NULL, 'NIFH_FRXC_3', 282800),
(463707, 'PS51032', NULL, 'AP2/ERF domain profile.', NULL, NULL, 'AP2_ERF', 282801),
(463708, 'PS50915', NULL, 'Crystallins beta and gamma ''Greek key'' motif profile.', NULL, NULL, 'CRYSTALLIN_BETA_GAMMA', 282802),
(463709, 'PS51372', NULL, 'PRD domain profile.', NULL, NULL, 'PRD_2', 282803),
(463710, 'PS51614', NULL, 'Adrift-type ribose 2''-O-methyltransferase (EC 2.1.1.-) domain profile.', NULL, NULL, 'SAM_MT_ADRIFT', 282804),
(463711, 'PS51954', NULL, 'Coronavirus (CoV) guanine-N7-methyltransferase (N7-MTase) domain profile.', NULL, NULL, 'COV_N7_MTASE', 282805),
(463712, 'PS50128', NULL, 'SURP motif repeat profile.', NULL, NULL, 'SURP', 282806),
(463713, 'PS50989', NULL, 'Acetyl-coenzyme A (CoA) carboxyltransferase C-terminal domain profile.', NULL, NULL, 'COA_CT_CTER', 282807),
(463714, 'PS51105', NULL, 'PTS_EIIC type-3 domain profile.', NULL, NULL, 'PTS_EIIC_TYPE_3', 282808),
(463715, 'PS51884', NULL, 'Chaplin domain profile.', NULL, NULL, 'CHAPLIN', 282809),
(463716, 'PS50812', NULL, 'PWWP domain profile.', NULL, NULL, 'PWWP', 282810),
(463717, 'PS51193', NULL, 'Superfamilies 1 and 2 helicase ATP-binding type-2 domain profile.', NULL, NULL, 'HELICASE_ATP_BIND_2', 282811),
(463718, 'PS51611', NULL, '[Cytochrome c]-lysine N-methyltransferase (EC 2.1.1.59) family profile.', NULL, NULL, 'SAM_MT59', 282812);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(463719, 'PS51797', NULL, 'Translationally controlled tumor protein (TCTP) domain profile.', NULL, NULL, 'TCTP_3', 282813),
(463720, 'PS51118', NULL, 'HxlR-type HTH domain profile.', NULL, NULL, 'HTH_HXLR', 282814),
(463721, 'PS50252', NULL, 'T-box domain profile.', NULL, NULL, 'TBOX_3', 282815),
(463722, 'PS51450', NULL, 'Leucine-rich repeat profile.', NULL, NULL, 'LRR', 282816),
(463723, 'PS51747', NULL, 'Cytidine and deoxycytidylate deaminases domain profile.', NULL, NULL, 'CYT_DCMP_DEAMINASES_2', 282817),
(463724, 'PS51779', NULL, 'POTRA domain profile.', NULL, NULL, 'POTRA', 282818),
(463725, 'PS50868', NULL, 'Post-SET domain profile.', NULL, NULL, 'POST_SET', 282819),
(463726, 'PS51879', NULL, 'RST domain profile.', NULL, NULL, 'RST', 282820),
(463727, 'PS51065', NULL, 'Neuralized homology repeat (NHR) domain profile.', NULL, NULL, 'NHR', 282821),
(463728, 'PS50132', NULL, 'RGS domain profile.', NULL, NULL, 'RGS', 282822),
(463729, 'PS50814', NULL, 'WIF domain profile.', NULL, NULL, 'WIF', 282823),
(463730, 'PS50843', NULL, 'Expansin, Cellulose-binding-like domain profile.', NULL, NULL, 'EXPANSIN_CBD', 282824),
(463731, 'PS51205', NULL, 'VPS9 domain profile.', NULL, NULL, 'VPS9', 282825),
(463732, 'PS51467', NULL, 'HARP domain profile.', NULL, NULL, 'HARP', 282826),
(463733, 'PS51673', NULL, 'SUZ domain profile.', NULL, NULL, 'SUZ', 282827),
(463734, 'PS50222', NULL, 'EF-hand calcium-binding domain profile.', NULL, NULL, 'EF_HAND_2', 282828),
(463735, 'PS50195', NULL, 'PX domain profile.', NULL, NULL, 'PX', 282829),
(463736, 'PS50001', NULL, 'Src homology 2 (SH2) domain profile.', NULL, NULL, 'SH2', 282830),
(463737, 'PS51362', NULL, 'TGF-beta family profile.', NULL, NULL, 'TGF_BETA_2', 282831),
(463738, 'PS51143', NULL, 'MT-A70-like family profile.', NULL, NULL, 'MT_A70', 282832),
(463739, 'PS51877', NULL, 'Hypovirulence-associated virus (HAV) papain-like protease p29 domain profile.', NULL, NULL, 'HAV_P29_PRO', 282833),
(463740, 'PS51251', NULL, 'Teichoic acids export ATP-binding protein tagH.', NULL, NULL, 'TAGH', 282834),
(463741, 'PS51323', NULL, 'Insulin-like growth factor-binding protein (IGFBP) N-terminal domain profile.', NULL, NULL, 'IGFBP_N_2', 282835),
(463742, 'PS51238', NULL, 'Phosphate import ATP-binding protein pstB family profile.', NULL, NULL, 'PSTB', 282836),
(463743, 'PS51955', NULL, 'Nidovirus 2''-O-methyltransferase (2''-O-MTase) domain profile.', NULL, NULL, 'NIV_2_O_MTASE', 282837),
(463744, 'PS51077', NULL, 'IclR-type HTH domain profile.', NULL, NULL, 'HTH_ICLR', 282838),
(463745, 'PS51961', NULL, 'Arterivirus Nsp11 N-terminal/coronavirus NSP15 middle (AV-Nsp11N/CoV-Nsp15M) domain profile.', NULL, NULL, 'AV_NSP11N_COV_NSP15M', 282839),
(463746, 'PS51715', NULL, 'GB1/RHD3-type guanine nucleotide-binding (G) domain profile.', NULL, NULL, 'G_GB1_RHD3', 282840),
(463747, 'PS51283', NULL, 'DUSP domain profile.', NULL, NULL, 'DUSP', 282841),
(463748, 'PS51284', NULL, 'DOC domain profile.', NULL, NULL, 'DOC', 282842),
(463749, 'PS51888', NULL, 'Clip domain profile.', NULL, NULL, 'CLIP', 282843),
(463750, 'PS51532', NULL, 'PITH domain profile.', NULL, NULL, 'PITH', 282844),
(463751, 'PS51741', NULL, 'F-BAR domain profile.', NULL, NULL, 'F_BAR', 282845),
(463752, 'PS50832', NULL, 'S1 domain IF1 type profile.', NULL, NULL, 'S1_IF1_TYPE', 282846),
(463753, 'PS51793', NULL, 'Mis18 domain profile.', NULL, NULL, 'MIS18', 282847),
(463754, 'PS50069', NULL, 'Cullin family profile.', NULL, NULL, 'CULLIN_2', 282848),
(463755, 'PS50930', NULL, 'LytTR-type HTH domain profile.', NULL, NULL, 'HTH_LYTTR', 282849),
(463756, 'PS50950', NULL, 'Zinc finger THAP-type profile', NULL, NULL, 'ZF_THAP', 282850),
(463757, 'PS51679', NULL, 'C-5 cytosine-specific DNA methylase (Dnmt) domain profile.', NULL, NULL, 'SAM_MT_C5', 282851),
(463758, 'PS50833', NULL, 'Brix domain profile.', NULL, NULL, 'BRIX', 282852),
(463759, 'PS51802', NULL, 'Zinc finger CCHHC-type profile.', NULL, NULL, 'ZF_CCHHC', 282853),
(463760, 'PS51477', NULL, 'PAH domain profile.', NULL, NULL, 'PAH', 282854),
(463761, 'PS51799', NULL, 'Zinc finger C2H2 AKAP95-type profile.', NULL, NULL, 'ZF_C2H2_AKAP95', 282855);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(463762, 'PS51350', NULL, 'PTS HPR domain profile.', NULL, NULL, 'PTS_HPR_DOM', 282856),
(463763, 'PS50206', NULL, 'Rhodanese domain profile.', NULL, NULL, 'RHODANESE_3', 282857),
(463764, 'PS51444', NULL, 'Formin homology-2 (FH2) domain profile.', NULL, NULL, 'FH2', 282858),
(463765, 'PS51669', NULL, 'Prokaryotic molybdopterin oxidoreductases 4Fe-4S domain profile.', NULL, NULL, '4FE4S_MOW_BIS_MGD', 282859),
(463766, 'PS51787', NULL, 'Lon N-terminal domain profile.', NULL, NULL, 'LON_N', 282860),
(463767, 'PS50105', NULL, 'SAM domain profile.', NULL, NULL, 'SAM_DOMAIN', 282861),
(463768, 'PS50925', NULL, 'BLUF domain profile.', NULL, NULL, 'BLUF', 282862),
(463769, 'PS51292', NULL, 'Zinc finger RING-CH-type profile.', NULL, NULL, 'ZF_RING_CH', 282863),
(463770, 'PS51525', NULL, 'NET domain profile.', NULL, NULL, 'NET', 282864),
(463771, 'PS51965', NULL, 'Streptococcus antigen I/II alanine-rich (Ag I/II A) repeat profile.', NULL, NULL, 'AG_I_II_AR', 282865),
(463772, 'PS50123', NULL, 'CheR-type methyltransferase domain profile.', NULL, NULL, 'CHER', 282866),
(463773, 'PS51808', NULL, 'Coiled coil-helix-coiled coil-helix (CHCH) domain profile.', NULL, NULL, 'CHCH', 282867),
(463774, 'PS51070', NULL, 'Stonin homology domain (SHD) profile.', NULL, NULL, 'SHD', 282868),
(463775, 'PS51908', NULL, 'Zinc finger UBZ4-type profile.', NULL, NULL, 'ZF_UBZ4', 282869),
(463776, 'PS50142', NULL, 'Ribonuclease III family domain profile.', NULL, NULL, 'RNASE_3_2', 282870),
(463777, 'PS51501', NULL, 'Zinc finger DNL-type profile.', NULL, NULL, 'ZF_DNL', 282871),
(463778, 'PS51978', NULL, 'PBC domain profile.', NULL, NULL, 'PBC', 282872),
(463779, 'PS51693', NULL, 'Hepacivirus nonstructural protein 2 (NS2) protease domain profile.', NULL, NULL, 'HCV_NS2_PRO', 282873),
(463780, 'PS50893', NULL, 'ATP-binding cassette, ABC transporter-type domain profile.', NULL, NULL, 'ABC_TRANSPORTER_2', 282874),
(463781, 'PS01033', NULL, 'Globin family profile.', NULL, NULL, 'GLOBIN', 282875),
(463782, 'PS51137', NULL, 'VM domain profile.', NULL, NULL, 'VM', 282876),
(463783, 'PS51034', NULL, 'ZP domain profile.', NULL, NULL, 'ZP_2', 282877),
(463784, 'PS51202', NULL, 'RCK C-terminal domain profile.', NULL, NULL, 'RCK_C', 282878),
(463785, 'PS50065', NULL, 'Hydroxymethylglutaryl-coenzyme A reductases family profile.', NULL, NULL, 'HMG_COA_REDUCTASE_4', 282879),
(463786, 'PS51613', NULL, 'RrmJ-type ribose 2''-O-methyltransferase (EC 2.1.1.57) domain profile.', NULL, NULL, 'SAM_MT_RRMJ', 282880),
(463787, 'PS50244', NULL, 'Steroid 5-alpha reductase C-terminal domain profile.', NULL, NULL, 'S5A_REDUCTASE', 282881),
(463788, 'PS50917', NULL, 'SPOC domain profile.', NULL, NULL, 'SPOC', 282882),
(463789, 'PS50321', NULL, 'Asparagine-rich region profile.', NULL, NULL, 'ASN_RICH', 282883),
(463790, 'PS51377', NULL, 'KIND domain profile.', NULL, NULL, 'KIND', 282884),
(463791, 'PS51006', NULL, 'Polyamine biosynthesis (PABS) domain profile.', NULL, NULL, 'PABS_2', 282885),
(463792, 'PS50111', NULL, 'Bacterial chemotaxis sensory transducers domain profile.', NULL, NULL, 'CHEMOTAXIS_TRANSDUC_2', 282886),
(463793, 'PS51351', NULL, 'TFIIE beta central core DNA-binding domain profile.', NULL, NULL, 'TFIIE_BETA_C', 282887),
(463794, 'PS51986', NULL, 'Glutamine synthetase (GS) beta-grasp domain profile.', NULL, NULL, 'GS_BETA_GRASP', 282888),
(463795, 'PS50039', NULL, 'Fork head domain profile.', NULL, NULL, 'FORK_HEAD_3', 282889),
(463796, 'PS50985', NULL, 'GRAS family profile.', NULL, NULL, 'GRAS', 282890),
(463797, 'PS51914', NULL, 'MRH domain profile.', NULL, NULL, 'MRH', 282891),
(463798, 'PS50806', NULL, 'KRAB-related domain profile.', NULL, NULL, 'KRAB_RELATED', 282892),
(463799, 'PS50913', NULL, 'GRIP domain profile.', NULL, NULL, 'GRIP', 282893),
(463800, 'PS50088', NULL, 'Ankyrin repeat profile.', NULL, NULL, 'ANK_REPEAT', 282894),
(463801, 'PS50921', NULL, 'ANTAR domain profile.', NULL, NULL, 'ANTAR', 282895),
(463802, 'PS50040', NULL, 'Elongation factor 1 (EF-1) gamma C-terminal domain profile.', NULL, NULL, 'EF1G_C', 282896);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(463803, 'PS51945', NULL, 'Betacoronavirus Nsp3e nucleic acid-binding (NAB) domain profile.', NULL, NULL, 'BCOV_NSP3E_NAB', 282897),
(463804, 'PS51728', NULL, 'Rtt109-type histone acetyltransferase (HAT) domain profile.', NULL, NULL, 'RTT109_HAT', 282898),
(463805, 'PS51060', NULL, 'PARP alpha-helical domain profile.', NULL, NULL, 'PARP_ALPHA_HD', 282899),
(463806, 'PS50815', NULL, 'HORMA domain profile.', NULL, NULL, 'HORMA', 282900),
(463807, 'PS51857', NULL, 'Cold-shock (CSD) domain profile.', NULL, NULL, 'CSD_2', 282901),
(463808, 'PS51508', NULL, 'CKK domain profile.', NULL, NULL, 'CKK', 282902),
(463809, 'PS51670', NULL, 'ShKT domain profile.', NULL, NULL, 'SHKT', 282903),
(463810, 'PS51904', NULL, 'Glycosyl hydrolase family 25 (GH25) domain profile.', NULL, NULL, 'GLYCOSYL_HYDROL_F25_2', 282904),
(463811, 'PS51686', NULL, 'SAM-dependent MTase RsmB/NOP-type domain profile.', NULL, NULL, 'SAM_MT_RSMB_NOP', 282905),
(463812, 'PS51953', NULL, 'Nidovirus 3''-5'' exoribonuclease (ExoN) domain profile.', NULL, NULL, 'NIV_EXON', 282906),
(463813, 'PS51332', NULL, 'B12-binding domain profile.', NULL, NULL, 'B12_BINDING', 282907),
(463814, 'PS50956', NULL, 'AsnC-type HTH domain profile.', NULL, NULL, 'HTH_ASNC_2', 282908),
(463815, 'PS51845', NULL, '3''5''-cyclic nucleotide phosphodiesterase domain profile.', NULL, NULL, 'PDEASE_I_2', 282909),
(463816, 'PS50178', NULL, 'Zinc finger FYVE/FYVE-related type profile.', NULL, NULL, 'ZF_FYVE', 282910),
(463817, 'PS50198', NULL, 'PpiC-type peptidyl-prolyl cis-trans isomerase family profile.', NULL, NULL, 'PPIC_PPIASE_2', 282911),
(463818, 'PS51445', NULL, 'Phycobilisome (PBS) linker domain profile.', NULL, NULL, 'PBS_LINKER', 282912),
(463819, 'PS50904', NULL, 'PRELI/MSF1 domain profile.', NULL, NULL, 'PRELI_MSF1', 282913),
(463820, 'PS51226', NULL, 'TEP1 N-terminal repeat profile.', NULL, NULL, 'TEP1_N', 282914),
(463821, 'PS51312', NULL, 'Steadiness box (SB) domain profile.', NULL, NULL, 'SB', 282915),
(463822, 'PS51708', NULL, 'CHAD domain profile.', NULL, NULL, 'CHAD', 282916),
(463823, 'PS51960', NULL, 'Coronavirus (CoV) Nsp15 N-terminal oligomerization domain profile.', NULL, NULL, 'COV_NSP15_NTD', 282917),
(463824, 'PS51977', NULL, 'WGR domain profile.', NULL, NULL, 'WGR', 282918),
(463825, 'PS51367', NULL, 'Thaumatin family profile.', NULL, NULL, 'THAUMATIN_2', 282919),
(463826, 'PS51807', NULL, 'Zinc finger C2HC baculovirus (BV)-type profile.', NULL, NULL, 'ZF_C2HC_BV', 282920),
(463827, 'PS51553', NULL, 'GMP synthetase ATP pyrophosphatase (GMPS ATP-PPase) domain profile.', NULL, NULL, 'GMPS_ATP_PPASE', 282921),
(463828, 'PS51664', NULL, 'YcaO domain profile.', NULL, NULL, 'YCAO', 282922),
(463829, 'PS50090', NULL, 'Myb-like domain profile.', NULL, NULL, 'MYB_LIKE', 282923),
(463830, 'PS50823', NULL, 'Type-2 KH domain profile.', NULL, NULL, 'KH_TYPE_2', 282924),
(463831, 'PS51533', NULL, 'ADD domain profile.', NULL, NULL, 'ADD', 282925),
(463832, 'PS50932', NULL, 'LacI-type HTH domain profile.', NULL, NULL, 'HTH_LACI_2', 282926),
(463833, 'PS50249', NULL, 'MPN domain profile.', NULL, NULL, 'MPN', 282927),
(463834, 'PS50916', NULL, 'Rab-binding domain profile.', NULL, NULL, 'RABBD', 282928),
(463835, 'PS51649', NULL, 'NPH3 domain profile.', NULL, NULL, 'NPH3', 282929),
(463836, 'PS51199', NULL, 'Superfamily 4 helicase domain profile.', NULL, NULL, 'SF4_HELICASE', 282930),
(463837, 'PS50924', NULL, 'MHYT domain profile.', NULL, NULL, 'MHYT', 282931),
(463838, 'PS50143', NULL, 'BIR repeat profile.', NULL, NULL, 'BIR_REPEAT_2', 282932),
(463839, 'PS51385', NULL, 'YjeF N-terminal domain profile.', NULL, NULL, 'YJEF_N', 282933),
(463840, 'PS51633', NULL, 'CXC domain profile.', NULL, NULL, 'CXC', 282934),
(463841, 'PS51753', NULL, 'HBM domain profile.', NULL, NULL, 'HBM', 282935),
(463842, 'PS50834', NULL, 'HIN-200 A and B domains profile.', NULL, NULL, 'HIN_200', 282936),
(463843, 'PS51394', NULL, 'PFU domain profile.', NULL, NULL, 'PFU', 282937),
(463844, 'PS50325', NULL, 'Threonine-rich region profile.', NULL, NULL, 'THR_RICH', 282938),
(463845, 'PS51303', NULL, 'PET domain profile.', NULL, NULL, 'PET', 282939);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(463846, 'PS51959', NULL, 'Eukaryotic uridylate-specific endoribonuclease (EndoU) domain profile.', NULL, NULL, 'ENDOU', 282940),
(463847, 'PS51234', NULL, 'Thrombospondin type-3 (TSP3) repeat profile.', NULL, NULL, 'TSP3', 282941),
(463848, 'PS51127', NULL, 'Big-1 (bacterial Ig-like domain 1) domain profile.', NULL, NULL, 'BIG1', 282942),
(463849, 'PS50952', NULL, 'KIX domain profile.', NULL, NULL, 'KIX', 282943),
(463850, 'PS51777', NULL, 'RH2 domain profile.', NULL, NULL, 'RH2', 282944),
(463851, 'PS51898', NULL, 'Tyrosine recombinase domain profile.', NULL, NULL, 'TYR_RECOMBINASE', 282945),
(463852, 'PS50235', NULL, 'Ubiquitin specific protease (USP) domain profile.', NULL, NULL, 'USP_3', 282946),
(463853, 'PS51599', NULL, 'Phospholipid methyltransferases (EC 2.1.1.17 and EC=2.1.1.71) family profile.', NULL, NULL, 'SAM_PEMT_PEM2', 282947),
(463854, 'PS51916', NULL, 'DEUBAD (DEUBiquitinase ADaptor) domain profile.', NULL, NULL, 'DEUBAD', 282948),
(463855, 'PS51335', NULL, 'ELMO domain profile.', NULL, NULL, 'ELMO', 282949),
(463856, 'PS51295', NULL, 'CRM domain profile.', NULL, NULL, 'CRM', 282950),
(463857, 'PS51368', NULL, 'Urease domain profile.', NULL, NULL, 'UREASE_3', 282951),
(463858, 'PS50836', NULL, 'DOMON domain profile.', NULL, NULL, 'DOMON', 282952),
(463859, 'PS50179', NULL, 'VHS domain profile.', NULL, NULL, 'VHS', 282953),
(463860, 'PS50859', NULL, 'Longin domain profile.', NULL, NULL, 'LONGIN', 282954),
(463861, 'PS50988', NULL, 'TROVE domain profile.', NULL, NULL, 'TROVE', 282955),
(463862, 'PS51964', NULL, 'SARS ORF8 accessory protein immunoglobulin (Ig)-like domain profile.', NULL, NULL, 'SARS_ORF8_IG', 282956),
(463863, 'PS51163', NULL, 'YrdC-like domain profile.', NULL, NULL, 'YRDC', 282957),
(463864, 'PS50279', NULL, 'Pancreatic trypsin inhibitor (Kunitz) family profile.', NULL, NULL, 'BPTI_KUNITZ_2', 282958),
(463865, 'PS51109', NULL, 'G5 domain profile.', NULL, NULL, 'G5', 282959),
(463866, 'PS51785', NULL, 'Exonuclease I (ExoI) C-terminal domain profile.', NULL, NULL, 'EXOI_C', 282960),
(463867, 'PS51855', NULL, 'MGS-like domain profile.', NULL, NULL, 'MGS', 282961),
(463868, 'PS51342', NULL, 'Colipase family profile.', NULL, NULL, 'COLIPASE_2', 282962),
(463869, 'PS51689', NULL, 'rRNA adenine N(6)-methyltransferase family profile.', NULL, NULL, 'SAM_RNA_A_N6_MT', 282963),
(463870, 'PS51520', NULL, 'Alphavirus nsp2 protease (nsp2pro) domain profile.', NULL, NULL, 'NSP2PRO', 282964),
(463871, 'PS50092', NULL, 'Thrombospondin type-1 (TSP1) repeat profile.', NULL, NULL, 'TSP1', 282965),
(463872, 'PS50911', NULL, 'CHAP domain profile.', NULL, NULL, 'CHAP', 282966),
(463873, 'PS51252', NULL, 'Antistasin-like domain profile.', NULL, NULL, 'ANTISTASIN', 282967),
(463874, 'PS51920', NULL, 'Sarbecovirus 9b domain profile.', NULL, NULL, 'SARS_9B', 282968),
(463875, 'PS51927', NULL, 'Coronavirus membrane (Cov-M) protein profile.', NULL, NULL, 'COV_M', 282969),
(463876, 'PS51049', NULL, 'KASH domain profile.', NULL, NULL, 'KASH', 282970),
(463877, 'PS51874', NULL, 'Picornavirales 3C/3C-like protease domain profile.', NULL, NULL, 'PCV_3C_PRO', 282971),
(463878, 'PS51563', NULL, 'mRNA (2''-O-methyladenosine-N(6)-)-methyltransferase (EC 2.1.1.62) family profile.', NULL, NULL, 'SAM_MTA70L_1', 282972),
(463879, 'PS50887', NULL, 'GGDEF domain profile.', NULL, NULL, 'GGDEF', 282973),
(463880, 'PS51069', NULL, 'GBP repeat profile.', NULL, NULL, 'GBP', 282974),
(463881, 'PS50082', NULL, 'Trp-Asp (WD) repeats profile.', NULL, NULL, 'WD_REPEATS_2', 282975),
(463882, 'PS51823', NULL, 'Clueless (Clu) domain profile.', NULL, NULL, 'CLU', 282976),
(463883, 'PS50525', NULL, 'RdRp of negative ssRNA viruses with segmented genomes catalytic domain profile.', NULL, NULL, 'RDRP_SSRNA_NEG_SEG', 282977),
(463884, 'PS51479', NULL, 'RTR1-type zinc finger.', NULL, NULL, 'ZF_RTR1', 282978),
(463885, 'PS51658', NULL, 'Bifunctional nuclease (BFN) domain profile.', NULL, NULL, 'BFN', 282979),
(463886, 'PS50164', NULL, 'GIY-YIG domain profile.', NULL, NULL, 'GIY_YIG', 282980),
(463887, 'PS51024', NULL, 'Zinc finger FCS-type profile.', NULL, NULL, 'ZF_FCS', 282981);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(463888, 'PS50867', NULL, 'Pre-SET domain profile.', NULL, NULL, 'PRE_SET', 282982),
(463889, 'PS50290', NULL, 'Phosphatidylinositol 3- and 4-kinases catalytic domain profile.', NULL, NULL, 'PI3_4_KINASE_3', 282983),
(463890, 'PS50807', NULL, 'GCM domain profile.', NULL, NULL, 'GCM', 282984),
(463891, 'PS50268', NULL, 'Cadherins domain profile.', NULL, NULL, 'CADHERIN_2', 282985),
(463892, 'PS50270', NULL, 'Nerve growth factor family profile.', NULL, NULL, 'NGF_2', 282986),
(463893, 'PS50060', NULL, 'MAM domain profile.', NULL, NULL, 'MAM_2', 282987),
(463894, 'PS50053', NULL, 'Ubiquitin domain profile.', NULL, NULL, 'UBIQUITIN_2', 282988),
(463895, 'PS50005', NULL, 'TPR repeat profile.', NULL, NULL, 'TPR', 282989),
(463896, 'PS50254', NULL, 'NF-kappa-B/Rel/dorsal domain profile.', NULL, NULL, 'REL_2', 282990),
(463897, 'PS51097', NULL, 'PTS_EIIA type-5 domain profile.', NULL, NULL, 'PTS_EIIA_TYPE_5', 282991),
(463898, 'PS51337', NULL, 'B12-binding N-terminal domain profile.', NULL, NULL, 'B12_BINDING_NTER', 282992),
(463899, 'PS51870', NULL, 'Amyloid precursor protein (APP) E2 domain profile.', NULL, NULL, 'APP_E2', 282993),
(463900, 'PS51084', NULL, 'HIT domain profile.', NULL, NULL, 'HIT_2', 282994),
(463901, 'PS51334', NULL, 'PRONE domain profile.', NULL, NULL, 'PRONE', 282995),
(463902, 'PS51500', NULL, 'Sin domain profile.', NULL, NULL, 'SIN', 282996),
(463903, 'PS51662', NULL, 'Beta-propeller phytase (BPP) domain profile.', NULL, NULL, 'BP_PHYTASE', 282997),
(463904, 'PS51772', NULL, 'Actin cross-linking (ACD) domain profile.', NULL, NULL, 'ACD', 282998),
(463905, 'PS50245', NULL, 'CAP-Gly domain profile.', NULL, NULL, 'CAP_GLY_2', 282999),
(463906, 'PS51051', NULL, 'DSL domain profile.', NULL, NULL, 'DSL', 283000),
(463907, 'PS51404', NULL, 'DyP-type peroxidase family.', NULL, NULL, 'DYP_PEROXIDASE', 283001),
(463908, 'PS51187', NULL, 'Autoinducer synthase family profile.', NULL, NULL, 'AUTOINDUCER_SYNTH_2', 283002),
(463909, 'PS51363', NULL, 'W2 domain profile.', NULL, NULL, 'W2', 283003),
(463910, 'PS51737', NULL, 'DNA-binding recombinase domain profile.', NULL, NULL, 'RECOMBINASE_DNA_BIND', 283004),
(463911, 'PS50077', NULL, 'HEAT repeat profile.', NULL, NULL, 'HEAT_REPEAT', 283005),
(463912, 'PS50275', NULL, 'Sac phosphatase domain profile.', NULL, NULL, 'SAC', 283006),
(463913, 'PS51571', NULL, 'Histone-lysine N-methyltransferase (EC 2.1.1.43) family profile.', NULL, NULL, 'SAM_MT43_PR_SET', 283007),
(463914, 'PS50086', NULL, 'TBC/rab GAP domain profile.', NULL, NULL, 'TBC_RABGAP', 283008),
(463915, 'PS50522', NULL, 'RdRp of RNA-containing bacteriophages catalytic domain profile.', NULL, NULL, 'RDRP_PHAGE', 283009),
(463916, 'PS51675', NULL, 'SAM-dependent methyltransferase TRM10-type domain profile.', NULL, NULL, 'SAM_MT_TRM10', 283010),
(463917, 'PS50926', NULL, 'TRAM domain profile.', NULL, NULL, 'TRAM', 283011),
(463918, 'PS50864', NULL, 'SAND domain profile.', NULL, NULL, 'SAND', 283012),
(463919, 'PS50995', NULL, 'MarR-type HTH domain profile.', NULL, NULL, 'HTH_MARR_2', 283013),
(463920, 'PS51064', NULL, 'IRS-type PTB domain profile.', NULL, NULL, 'IRS_PTB', 283014),
(463921, 'PS51239', NULL, 'Lipid A export ATP-binding/permease protein msbA family profile.', NULL, NULL, 'MSBA', 283015),
(463922, 'PS50848', NULL, 'START domain profile.', NULL, NULL, 'START', 283016),
(463923, 'PS51092', NULL, 'Fibronectin type-II collagen-binding domain profile.', NULL, NULL, 'FN2_2', 283017),
(463924, 'PS51282', NULL, 'DWNN domain profile.', NULL, NULL, 'DWNN', 283018),
(463925, 'PS50263', NULL, 'Carbon-nitrogen hydrolase domain profile.', NULL, NULL, 'CN_HYDROLASE', 283019),
(463926, 'PS51701', NULL, '6-Cysteine (6-Cys) domain profile.', NULL, NULL, '6_CYS', 283020),
(463927, 'PS51529', NULL, 'Fetuin-A-type cystatin domain profile.', NULL, NULL, 'CYSTATIN_FETUIN_A', 283021),
(463928, 'PS51423', NULL, 'Miro domain profile.', NULL, NULL, 'MIRO', 283022),
(463929, 'PS50012', NULL, 'Regulator of chromosome condensation (RCC1) repeat profile.', NULL, NULL, 'RCC1_3', 283023),
(463930, 'PS50139', NULL, 'Z-binding domain profile.', NULL, NULL, 'Z_BINDING', 283024); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(463931, 'PS50228', NULL, 'SUEL-type lectin domain profile.', NULL, NULL, 'SUEL_LECTIN', 283025),
(463932, 'PS50192', NULL, 't-SNARE coiled-coil homology domain profile.', NULL, NULL, 'T_SNARE', 283026),
(463933, 'PS50910', NULL, 'HEPN domain profile.', NULL, NULL, 'HEPN', 283027),
(463934, 'PS51245', NULL, 'Maltose/Maltodextrin import ATP-binding protein malK family profile.', NULL, NULL, 'MALK', 283028),
(463935, 'PS50829', NULL, 'GYF domain profile.', NULL, NULL, 'GYF', 283029),
(463936, 'PS51868', NULL, 'Peptidase family S39 domain profile.', NULL, NULL, 'PEPTIDASE_S39', 283030),
(463937, 'PS51000', NULL, 'DeoR-type HTH domain profile.', NULL, NULL, 'HTH_DEOR_2', 283031),
(463938, 'PS51641', NULL, 'Agenet-like domain profile.', NULL, NULL, 'AGENET_LIKE', 283032),
(463939, 'PS51510', NULL, 'Phosphagen kinase C-terminal domain profile.', NULL, NULL, 'PHOSPHAGEN_KINASE_C', 283033),
(463940, 'PS51322', NULL, 'UEV domain profile.', NULL, NULL, 'UEV', 283034),
(463941, 'PS50255', NULL, 'Cytochrome b5 family, heme-binding domain profile.', NULL, NULL, 'CYTOCHROME_B5_2', 283035),
(463942, 'PS51352', NULL, 'Thioredoxin domain profile.', NULL, NULL, 'THIOREDOXIN_2', 283036),
(463943, 'PS51843', NULL, 'Nuclear receptor (NR) ligand-binding (LBD) domain profile.', NULL, NULL, 'NR_LBD', 283037),
(463944, 'PS51180', NULL, 'BRO1 domain profile.', NULL, NULL, 'BRO1', 283038),
(463945, 'PS51369', NULL, 'TCP domain profile.', NULL, NULL, 'TCP', 283039),
(463946, 'PS50991', NULL, 'Pyruvate carboxyltransferase domain.', NULL, NULL, 'PYR_CT', 283040),
(463947, 'PS51378', NULL, 'Invertebrate defensins family profile.', NULL, NULL, 'INVERT_DEFENSINS', 283041),
(463948, 'PS51469', NULL, 'SUN domain profile.', NULL, NULL, 'SUN', 283042),
(463949, 'PS51114', NULL, 'F-box-associated (FBA) domain profile.', NULL, NULL, 'FBA', 283043),
(463950, 'PS50941', NULL, 'Chitin-binding type-1 domain profile.', NULL, NULL, 'CHIT_BIND_I_2', 283044),
(463951, 'PS51781', NULL, 'SH3b domain profile.', NULL, NULL, 'SH3B', 283045),
(463952, 'PS51100', NULL, 'PTS_EIIB type-3 domain profile.', NULL, NULL, 'PTS_EIIB_TYPE_3', 283046),
(463953, 'PS51834', NULL, 'Tripartite DENN FLCN/SMCR8-type domain profile.', NULL, NULL, 'DENN_FLCN_SMCR8', 283047),
(463954, 'PS50035', NULL, 'Phospholipase D phosphodiesterase active site profile.', NULL, NULL, 'PLD', 283048),
(463955, 'PS51237', NULL, 'Sulfate/thiosulfate import ATP-binding protein cysA family profile.', NULL, NULL, 'CYSA', 283049),
(463956, 'PS51276', NULL, 'PfpI endopeptidase domain profile.', NULL, NULL, 'PEPTIDASE_C56_PFPI', 283050),
(463957, 'PS51589', NULL, 'Viral protein 3 containing mRNA (guanine-N(7)-)-methyltransferase family profile.', NULL, NULL, 'SAM_MT56_VP3', 283051),
(463958, 'PS50894', NULL, 'Histidine-containing phosphotransfer (HPt) domain profile.', NULL, NULL, 'HPT', 283052),
(463959, 'PS50896', NULL, 'LIS1 homology (LisH) motif profile.', NULL, NULL, 'LISH', 283053),
(463960, 'PS51872', NULL, 'Zinc finger ZBR-type profile.', NULL, NULL, 'ZF_ZBR', 283054),
(463961, 'PS51031', NULL, 'BESS domain profile.', NULL, NULL, 'BESS', 283055),
(463962, 'PS51620', NULL, 'tRNA (adenine(57)-N(1)/adenine(58)-N(1) or adenine(58)-N(1)) (EC 2.1.1.219 or EC 2.1.1.220) family profile.', NULL, NULL, 'SAM_TRM61', 283056),
(463963, 'PS50292', NULL, 'Animal heme peroxidase superfamily profile.', NULL, NULL, 'PEROXIDASE_3', 283057),
(463964, 'PS51505', NULL, 'SCA7 domain profile.', NULL, NULL, 'SCA7', 283058),
(463965, 'PS51089', NULL, 'Headpiece (HP) domain profile.', NULL, NULL, 'HP', 283059),
(463966, 'PS51491', NULL, 'Tau and MAP proteins tubulin-binding repeat profile.', NULL, NULL, 'TAU_MAP_2', 283060),
(463967, 'PS51370', NULL, 'R domain profile.', NULL, NULL, 'R', 283061),
(463968, 'PS51667', NULL, 'WRC domain profile.', NULL, NULL, 'WRC', 283062),
(463969, 'PS51373', NULL, 'High potential iron-sulfur proteins family profile.', NULL, NULL, 'HIPIP', 283063),
(463970, 'PS50944', NULL, 'DtxR-type HTH domain profile.', NULL, NULL, 'HTH_DTXR', 283064),
(463971, 'PS51657', NULL, '(+)RNA virus helicase core domain profile.', NULL, NULL, 'PSRV_HELICASE', 283065);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(463972, 'PS51665', NULL, 'Enkurin domain profile.', NULL, NULL, 'ENKURIN', 283066),
(463973, 'PS51044', NULL, 'Zinc finger SP-RING-type profile.', NULL, NULL, 'ZF_SP_RING', 283067),
(463974, 'PS50049', NULL, 'TNF family profile.', NULL, NULL, 'TNF_2', 283068),
(463975, 'PS51531', NULL, 'Foamy virus protease (FV PR) domain profile.', NULL, NULL, 'FV_PR', 283069),
(463976, 'PS51935', NULL, 'NlpC/P60 domain profile.', NULL, NULL, 'NLPC_P60', 283070),
(463977, 'PS50237', NULL, 'HECT domain profile.', NULL, NULL, 'HECT', 283071),
(463978, 'PS51975', NULL, 'Ribonuclease (RNase) H type-2 domain profile.', NULL, NULL, 'RNASE_H_2', 283072),
(463979, 'PS51123', NULL, 'OmpA-like domain profile.', NULL, NULL, 'OMPA_2', 283073),
(463980, 'PS51740', NULL, 'SpoVT-AbrB domain profile.', NULL, NULL, 'SPOVT_ABRB', 283074),
(463981, 'PS50174', NULL, 'G-patch domain profile.', NULL, NULL, 'G_PATCH', 283075),
(463982, 'PS50855', NULL, 'Cytochrome oxidase subunit I  profile.', NULL, NULL, 'COX1', 283076),
(463983, 'PS50113', NULL, 'PAC domain profile.', NULL, NULL, 'PAC', 283077),
(463984, 'PS50008', NULL, 'Phosphatidylinositol-specific phospholipase Y-box domain profile.', NULL, NULL, 'PIPLC_Y_DOMAIN', 283078),
(463985, 'PS51405', NULL, 'Heme haloperoxidase family profile.', NULL, NULL, 'HEME_HALOPEROXIDASE', 283079),
(463986, 'PS51424', NULL, 'Roc domain profile.', NULL, NULL, 'ROC', 283080),
(463987, 'PS50808', NULL, 'Zinc finger BED-type profile.', NULL, NULL, 'ZF_BED', 283081),
(463988, 'PS51820', NULL, 'PA14 domain profile.', NULL, NULL, 'PA14', 283082),
(463989, 'PS51181', NULL, 'Phosphatase tensin-type domain profile.', NULL, NULL, 'PPASE_TENSIN', 283083),
(463990, 'PS51580', NULL, 'Histone-lysine N-methyltransferase (EC 2.1.1.43) family profile.', NULL, NULL, 'SAM_MT43_3', 283084),
(463991, 'PS51771', NULL, 'CGT/MARTX cysteine protease (CPD) domain profile.', NULL, NULL, 'CGT_MARTX_CPD', 283085),
(463992, 'PS50309', NULL, 'Doublecortin domain profile.', NULL, NULL, 'DC', 283086),
(463993, 'PS50310', NULL, 'Alanine-rich region profile.', NULL, NULL, 'ALA_RICH', 283087),
(463994, 'PS51439', NULL, 'MENTAL domain profile.', NULL, NULL, 'MENTAL', 283088),
(463995, 'PS50042', NULL, 'cAMP/cGMP binding motif profile.', NULL, NULL, 'CNMP_BINDING_3', 283089),
(463996, 'PS50870', NULL, 'Arfaptin homology (AH) domain profile.', NULL, NULL, 'AH', 283090),
(463997, 'PS51583', NULL, 'Plant LSMT protein-lysine methyltransferase family profile.', NULL, NULL, 'SAM_MT127', 283091),
(463998, 'PS50824', NULL, 'DAPIN domain profile.', NULL, NULL, 'DAPIN', 283092),
(463999, 'PS50933', NULL, 'CHRD domain profile.', NULL, NULL, 'CHRD', 283093),
(464000, 'PS51200', NULL, 'Scorpion short toxin chloride channel inhibitor subfamily profile.', NULL, NULL, 'SHORT_SCORPION_CHLORIDE', 283094),
(464001, 'PS51286', NULL, 'RAP domain profile.', NULL, NULL, 'RAP', 283095),
(464002, 'PS51030', NULL, 'Nuclear hormone receptors DNA-binding domain profile.', NULL, NULL, 'NUCLEAR_REC_DBD_2', 283096),
(464003, 'PS51103', NULL, 'PTS_EIIC type-1 domain profile.', NULL, NULL, 'PTS_EIIC_TYPE_1', 283097),
(464004, 'PS51347', NULL, 'Phosphotriesterase family profile.', NULL, NULL, 'PHOSPHOTRIESTERASE_2', 283098),
(464005, 'PS50319', NULL, 'Leucine-rich region profile.', NULL, NULL, 'LEU_RICH', 283099),
(464006, 'PS50994', NULL, 'Integrase catalytic domain profile.', NULL, NULL, 'INTEGRASE', 283100),
(464007, 'PS51627', NULL, 'tRNA methyltransferase 11 (TRM11) (EC 2.1.1.-) family profile.', NULL, NULL, 'SAM_MT_TRM11', 283101),
(464008, 'PS51795', NULL, 'Zinc finger FLZ-type profile.', NULL, NULL, 'ZF_FLZ', 283102),
(464009, 'PS50175', NULL, 'Aspartyl protease, retroviral-type family profile.', NULL, NULL, 'ASP_PROT_RETROV', 283103),
(464010, 'PS50819', NULL, 'Intein DOD-type homing endonuclease domain profile.', NULL, NULL, 'INTEIN_ENDONUCLEASE', 283104),
(464011, 'PS51764', NULL, 'Glycosyl hydrolases family 26 (GH26) domain profile.', NULL, NULL, 'GH26', 283105),
(464012, 'PS51027', NULL, 'Integrase DNA binding domain profile.', NULL, NULL, 'INTEGRASE_DBD', 283106);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(464013, 'PS51440', NULL, 'Triosephosphate isomerase (TIM) family profile.', NULL, NULL, 'TIM_2', 283107),
(464014, 'PS51694', NULL, 'Peptidase family M66 domain profile.', NULL, NULL, 'PEPTIDASE_M66', 283108),
(464015, 'PS51952', NULL, 'Coronavirus (CoV) ExoN/MTase coactivator domain profile.', NULL, NULL, 'COV_EXON_MTASE_COACT', 283109),
(464016, 'PS51140', NULL, 'CUE domain profile.', NULL, NULL, 'CUE', 283110),
(464017, 'PS50052', NULL, 'Guanylate kinase-like domain profile.', NULL, NULL, 'GUANYLATE_KINASE_2', 283111),
(464018, 'PS51433', NULL, 'Pointed (PNT) domain profile.', NULL, NULL, 'PNT', 283112),
(464019, 'PS51249', NULL, 'Phosphonate import ATP-binding protein phnC.', NULL, NULL, 'PHNC', 283113),
(464020, 'PS51803', NULL, 'Zinc finger C2HC RNF-type profile.', NULL, NULL, 'ZF_C2HC_RNF', 283114),
(464021, 'PS51173', NULL, 'CBM2 (Carbohydrate-binding type-2) domain profile.', NULL, NULL, 'CBM2', 283115),
(464022, 'PS51767', NULL, 'Peptidase family A1 domain profile.', NULL, NULL, 'PEPTIDASE_A1', 283116),
(464023, 'PS51896', NULL, 'Zinc finger C4H2-type profile.', NULL, NULL, 'ZF_C4H2', 283117),
(464024, 'PS51398', NULL, 'PAW domain profile.', NULL, NULL, 'PAW', 283118),
(464025, 'PS50048', NULL, 'Zn(2)-C6 fungal-type DNA-binding domain profile.', NULL, NULL, 'ZN2_CY6_FUNGAL_2', 283119),
(464026, 'PS51435', NULL, 'AP endonucleases family 1 profile.', NULL, NULL, 'AP_NUCLEASE_F1_4', 283120),
(464027, 'PS51075', NULL, 'MAD homology domain 1 (MH1) profile.', NULL, NULL, 'MH1', 283121),
(464028, 'PS50287', NULL, 'SRCR domain profile.', NULL, NULL, 'SRCR_2', 283122),
(464029, 'PS51810', NULL, 'Zinc finger CCHC FOG-type profile.', NULL, NULL, 'ZF_CCHC_FOG', 283123),
(464030, 'PS50897', NULL, 'C-terminal to LisH (CTLH) motif profile.', NULL, NULL, 'CTLH', 283124),
(464031, 'PS01031', NULL, 'Small heat shock protein (sHSP) domain profile.', NULL, NULL, 'SHSP', 283125),
(464032, 'PS51289', NULL, 'Cysteine-rich GLG1 repeat profile.', NULL, NULL, 'GLG1_C_RICH', 283126),
(464033, 'PS50945', NULL, 'I/LWEQ domain profile.', NULL, NULL, 'I_LWEQ', 283127),
(464034, 'PS51692', NULL, 'Pestivirus nonstructural protein 2 (NS2) protease domain profile.', NULL, NULL, 'PESTIVIRUS_NS2_PRO', 283128),
(464035, 'PS50114', NULL, 'GATA-type zinc finger domain profile.', NULL, NULL, 'GATA_ZN_FINGER_2', 283129),
(464036, 'PS50158', NULL, 'Zinc finger CCHC-type profile.', NULL, NULL, 'ZF_CCHC', 283130),
(464037, 'PS50811', NULL, 'WRKY domain profile.', NULL, NULL, 'WRKY', 283131),
(464038, 'PS50801', NULL, 'STAS domain profile.', NULL, NULL, 'STAS', 283132),
(464039, 'PS51724', NULL, 'SPOR domain profile.', NULL, NULL, 'SPOR', 283133),
(464040, 'PS51009', NULL, 'Cytochrome c class II profile.', NULL, NULL, 'CYTCII', 283134),
(464041, 'PS51360', NULL, 'Plus3 domain profile.', NULL, NULL, 'PLUS3', 283135),
(464042, 'PS50165', NULL, 'UvrC family, homology region profile.', NULL, NULL, 'UVRC', 283136),
(464043, 'PS51255', NULL, 'ADP-dependent kinase (ADPK) domain profile.', NULL, NULL, 'ADPK', 283137),
(464044, 'PS50006', NULL, 'Forkhead-associated (FHA) domain profile.', NULL, NULL, 'FHA_DOMAIN', 283138),
(464045, 'PS50125', NULL, 'Guanylate cyclase domain profile.', NULL, NULL, 'GUANYLATE_CYCLASE_2', 283139),
(464046, 'PS51539', NULL, 'Arterivirus papain-like cysteine protease alpha (PCPalpha) domain profile.', NULL, NULL, 'AV_PCP_ALPHA', 283140),
(464047, 'PS51674', NULL, '4Fe-4S WhiB-like (Wbl)-type iron-sulfur binding domain profile.', NULL, NULL, '4FE4S_WBL', 283141),
(464048, 'PS51643', NULL, 'HD Cas3-type domain profile.', NULL, NULL, 'HD_CAS3', 283142),
(464049, 'PS50890', NULL, 'PUA domain profile.', NULL, NULL, 'PUA', 283143),
(464050, 'PS51762', NULL, 'Glycosyl hydrolases family 16 (GH16) domain profile.', NULL, NULL, 'GH16_2', 283144),
(464051, 'PS51442', NULL, 'Coronavirus main protease (M-pro) domain profile.', NULL, NULL, 'M_PRO', 283145),
(464052, 'PS51017', NULL, 'CCT domain profile.', NULL, NULL, 'CCT', 283146),
(464053, 'PS51147', NULL, 'Protein prenyltransferases alpha subunit repeat profile.', NULL, NULL, 'PFTA', 283147);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(464054, 'PS51907', NULL, 'Zinc finger UBZ3-type profile.', NULL, NULL, 'ZF_UBZ3', 283148),
(464055, 'PS50860', NULL, 'Alanyl-transfer RNA synthetases family profile.', NULL, NULL, 'AA_TRNA_LIGASE_II_ALA', 283149),
(464056, 'PS51528', NULL, 'Flavivirus NS3 protease (NS3pro) domain profile.', NULL, NULL, 'FLAVIVIRUS_NS3PRO', 283150),
(464057, 'PS51726', NULL, 'MYST-type histone acetyltransferase (HAT) domain profile.', NULL, NULL, 'MYST_HAT', 283151),
(464058, 'PS51110', NULL, 'Saposin A-type domain profile.', NULL, NULL, 'SAP_A', 283152),
(464059, 'PS50800', NULL, 'SAP motif profile.', NULL, NULL, 'SAP', 283153),
(464060, 'PS50050', NULL, 'TNFR/NGFR family cysteine-rich region domain profile.', NULL, NULL, 'TNFR_NGFR_2', 283154),
(464061, 'PS50963', NULL, 'Link domain profile.', NULL, NULL, 'LINK_2', 283155),
(464062, 'PS51848', NULL, 'bMERB domain profile.', NULL, NULL, 'BMERB', 283156),
(464063, 'PS51897', NULL, 'Annexin repeat profile.', NULL, NULL, 'ANNEXIN_2', 283157),
(464064, 'SFLDG01116', NULL, 'DesII-like', 485, NULL, 'DesII-like', 283158),
(464065, 'SFLDF00270', NULL, 'L-galactonate dehydratase', 450, NULL, 'L-galactonate_dehydratase', 283159),
(464066, 'SFLDF00111', NULL, 'L-fuconate dehydratase', 434, NULL, 'L-fuconate_dehydratase', 283160),
(464067, 'SFLDF00552', NULL, 'xylonate dehydratase 1', 393, NULL, 'xylonate_dehydratase_1', 283161),
(464068, 'SFLDS00057', NULL, 'Glutaminase/Asparaginase', 343, NULL, 'Glutaminase/Asparaginase', 283162),
(464069, 'SFLDG01091', NULL, 'uncharacterized CHP01210-like', 312, NULL, 'uncharacterized_CHP01210-like', 283163),
(464070, 'SFLDF00516', NULL, 'thurincin H (ThnB-like)', 462, NULL, 'thurincin_H_(ThnB-like)', 283164),
(464071, 'SFLDF00412', NULL, 'spore photoproduct lyase 2', 340, NULL, 'spore_photoproduct_lyase_2', 283165),
(464072, 'SFLDF00562', NULL, 'HemN-like, clustered with heat shock genes', 380, NULL, 'HemN-like,_clustered_with_hea', 283166),
(464073, 'SFLDF00379', NULL, 'Phosphonate metabolism (PhnJ)', 275, NULL, 'Phosphonate_metabolism_(PhnJ)', 283167),
(464074, 'SFLDF00445', NULL, 'alpha-phosphomannomutase', 246, NULL, 'alpha-phosphomannomutase', 283168),
(464075, 'SFLDG01082', NULL, 'B12-binding domain containing', 460, NULL, 'B12-binding_domain_containing', 283169),
(464076, 'SFLDG00179', NULL, 'mandelate racemase', 376, NULL, 'mandelate_racemase', 283170),
(464077, 'SFLDG01143', NULL, 'C2.B.3: Phosphomannomutase Like', 256, NULL, 'C2.B.3:_Phosphomannomutase_Li', 283171),
(464078, 'SFLDG01201', NULL, 'SUF2.1', 119, NULL, 'SUF2.1', 283172),
(464079, 'SFLDG01084', NULL, 'Uncharacterised Radical SAM Subgroup 2', 289, NULL, 'Uncharacterised_Radical_SAM_S', 283173),
(464080, 'SFLDG01278', NULL, 'biotin synthase like', 330, NULL, 'biotin_synthase_like', 283174),
(464081, 'SFLDG01137', NULL, 'C1.6.1: Phosphoserine Phosphatase Like', 209, NULL, 'C1.6.1:_Phosphoserine_Phospha', 283175),
(464082, 'SFLDF00300', NULL, '7-carboxy-7-deazaguanine synthase, Cx3CxxC type', 241, NULL, '7-carboxy-7-deazaguanine_synt', 283176),
(464083, 'SFLDF00466', NULL, 'Pyruvoyl-dependent histidine decarboxylase', 311, NULL, 'Pyruvoyl-dependent_histidine_', 283177),
(464084, 'SFLDF00348', NULL, '[FeFe] hydrogenase maturase (HydE-like)', 323, NULL, '[FeFe]_hydrogenase_maturase_(', 283178),
(464085, 'SFLDS00070', NULL, 'SPOUT Methyltransferase', 306, NULL, 'SPOUT_Methyltransferase', 283179),
(464086, 'SFLDG01123', NULL, 'methyltransferase (Class B)', 468, NULL, 'methyltransferase_(Class_B)', 283180),
(464087, 'SFLDG01180', NULL, 'SUF1', 238, NULL, 'SUF1', 283181),
(464088, 'SFLDF00154', NULL, 'N-succinylamino acid racemase 2', 369, NULL, 'N-succinylamino_acid_racemase', 283182),
(464089, 'SFLDF00162', NULL, 'galactarate dehydratase 2', 391, NULL, 'galactarate_dehydratase_2', 283183),
(464090, 'SFLDG01144', NULL, 'C2.B.4: PGP Like', 264, NULL, 'C2.B.4:_PGP_Like', 283184),
(464091, 'SFLDG01388', NULL, '7,8-didemethyl-8-hydroxy-5-deazariboflavin synthase', 352, NULL, '7,8-didemethyl-8-hydroxy-5-de', 283185),
(464092, 'SFLDF00006', NULL, 'rhamnonate dehydratase', 404, NULL, 'rhamnonate_dehydratase', 283186);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(464093, 'SFLDS00001', NULL, 'Enolase', 371, NULL, 'Enolase', 283187),
(464094, 'SFLDF00407', NULL, 'phosphomethylpyrimidine synthase (ThiC)', 418, NULL, 'phosphomethylpyrimidine_synth', 283188),
(464095, 'SFLDF00553', NULL, 'galactarolactone cycloisomerase', 378, NULL, 'galactarolactone_cycloisomera', 283189),
(464096, 'SFLDF00276', NULL, 'cyclic pyranopterin phosphate synthase (MoaA-like)', 340, NULL, 'cyclic_pyranopterin_phosphate', 283190),
(464097, 'SFLDF00414', NULL, 'bacteriochlorophyll C12 methyltransferase', 469, NULL, 'bacteriochlorophyll_C12_methy', 283191),
(464098, 'SFLDG01142', NULL, 'C2.B.2: Mannosyl-3-phosphoglycerate Phosphatase Like', 269, NULL, 'C2.B.2:_Mannosyl-3-phosphogly', 283192),
(464099, 'SFLDG01387', NULL, 'BtrN-like SPASM domain containing', 340, NULL, 'BtrN-like_SPASM_domain_contai', 283193),
(464100, 'SFLDF00291', NULL, 'arginine 2,3-aminomutase', 381, NULL, 'arginine_2,3-aminomutase', 283194),
(464101, 'SFLDF00347', NULL, 'KxxxW cyclic peptide maturase (StrB-like)', 439, NULL, 'KxxxW_cyclic_peptide_maturase', 283195),
(464102, 'SFLDG01015', NULL, 'Prenyltransferase Like 1', 326, NULL, 'Prenyltransferase_Like_1', 283196),
(464103, 'SFLDG00055', NULL, 'glucarate dehydratase', 445, NULL, 'glucarate_dehydratase', 283197),
(464104, 'SFLDG01018', NULL, 'Squalene/Phytoene Synthase Like', 280, NULL, 'Squalene/Phytoene_Synthase_Li', 283198),
(464105, 'SFLDG01052', NULL, 'RuBisCO', 453, NULL, 'RuBisCO', 283199),
(464106, 'SFLDF00563', NULL, 'galactarate dehydratase 3', 393, NULL, 'galactarate_dehydratase_3', 283200),
(464107, 'SFLDG01130', NULL, 'C1.5.1: Epoxide Hydrolase Phosphatase Like', 209, NULL, 'C1.5.1:_Epoxide_Hydrolase_Pho', 283201),
(464108, 'SFLDG00301', NULL, 'RuBisCO-like proteins', 415, NULL, 'RuBisCO-like_proteins', 283202),
(464109, 'SFLDF00036', NULL, 'deoxy-d-mannose-octulosonate 8-phosphate phosphatase', 174, NULL, 'deoxy-d-mannose-octulosonate_', 283203),
(464110, 'SFLDF00555', NULL, 'cis-3-hydroxy-L-proline dehydratase', 368, NULL, 'cis-3-hydroxy-L-proline_dehyd', 283204),
(464111, 'SFLDF00438', NULL, 'pactamycin methyltransferase (PctO-like)', 578, NULL, 'pactamycin_methyltransferase_', 283205),
(464112, 'SFLDG01140', NULL, 'C2.B: Phosphomannomutase and Phosphatase Like', 260, NULL, 'C2.B:_Phosphomannomutase_and_', 283206),
(464113, 'SFLDG01203', NULL, 'Prostaglandin E synthase like.1', 320, NULL, 'Prostaglandin_E_synthase_like', 283207),
(464114, 'SFLDF00408', NULL, 'Diphthamide biosynthesis family (Dph2)', 505, NULL, 'Diphthamide_biosynthesis_fami', 283208),
(464115, 'SFLDF00556', NULL, '4R-hydroxyproline betaine 2-epimerase', 368, NULL, '4R-hydroxyproline_betaine_2-e', 283209),
(464116, 'SFLDF00557', NULL, '3,6-anhydro-alpha-L-galactonate cycloisomerase', 364, NULL, '3,6-anhydro-alpha-L-galactona', 283210),
(464117, 'SFLDG00358', NULL, 'Main (cytGST)', 196, NULL, 'Main_(cytGST)', 283211),
(464118, 'SFLDF00302', NULL, 'anaerobic magnesium-protoporphyrin-IX monomethyl ester cyclase', 535, NULL, 'anaerobic_magnesium-protoporp', 283212),
(464119, 'SFLDF00425', NULL, 'dTDP-4-amino-4,6-dideoxy-D-glucose ammonia-lyase (DesII-like)', 485, NULL, 'dTDP-4-amino-4,6-dideoxy-D-gl', 283213),
(464120, 'SFLDG00151', NULL, 'methylaspartate ammonia-lyase', 413, NULL, 'methylaspartate_ammonia-lyase', 283214),
(464121, 'SFLDG01063', NULL, 'activating enzymes, group 1', 169, NULL, 'activating_enzymes,_group_1', 283215),
(464122, 'SFLDF00430', NULL, 'OxsB-like', 744, NULL, 'OxsB-like', 283216),
(464123, 'SFLDF00342', NULL, 'cyclic dehypoxanthine futalosine synthase (mqnC-like)', 358, NULL, 'cyclic_dehypoxanthine_futalos', 283217),
(464124, 'SFLDG01135', NULL, 'C1.5.6: HAD, Beta-PGM, Phosphatase Like', 222, NULL, 'C1.5.6:_HAD,_Beta-PGM,_Phosph', 283218),
(464125, 'SFLDF00464', NULL, 'Ferric/cupric reductase', 603, NULL, 'Ferric/cupric_reductase', 283219),
(464126, 'SFLDG00180', NULL, 'muconate cycloisomerase', 360, NULL, 'muconate_cycloisomerase', 283220),
(464127, 'SFLDF00043', NULL, 'sucrose-phosphatase', 262, NULL, 'sucrose-phosphatase', 283221),
(464128, 'SFLDG01071', NULL, 'tRNA wybutosine-synthesizing', 316, NULL, 'tRNA_wybutosine-synthesizing', 283222);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(464129, 'SFLDG01170', NULL, 'Pyruvoyl-dependent arginine decarboxylase', 170, NULL, 'Pyruvoyl-dependent_arginine_d', 283223),
(464130, 'SFLDF00421', NULL, 'avilamycin epimerase', 397, NULL, 'avilamycin_epimerase', 283224),
(464131, 'SFLDG01107', NULL, 'Uncharacterised Radical SAM Subgroup 20', 364, NULL, 'Uncharacterised_Radical_SAM_S', 283225),
(464132, 'SFLDF00343', NULL, 'aminofutalosine synthase (mqnE-like)', 364, NULL, 'aminofutalosine_synthase_(mqn', 283226),
(464133, 'SFLDF00277', NULL, 'oxygen-independent coproporphyrinogen-III oxidase 1 (HemN-like)', 456, NULL, 'oxygen-independent_coproporph', 283227),
(464134, 'SFLDG01069', NULL, 'UPF0313', 661, NULL, 'UPF0313', 283228),
(464135, 'SFLDG01200', NULL, 'SUF1.1', 238, NULL, 'SUF1.1', 283229),
(464136, 'SFLDF00001', NULL, 'mannonate dehydratase', 403, NULL, 'mannonate_dehydratase', 283230),
(464137, 'SFLDG01171', NULL, 'Pyruvoyl-dependent histidine decarboxylase', 312, NULL, 'Pyruvoyl-dependent_histidine_', 283231),
(464138, 'SFLDF00158', NULL, '5-methylthio-D-ribulose 1-phosphate isomerase', 375, NULL, '5-methylthio-D-ribulose_1-pho', 283232),
(464139, 'SFLDF00517', NULL, 'cytosylglucuronate decarboxylase', 333, NULL, 'cytosylglucuronate_decarboxyl', 283233),
(464140, 'SFLDG01124', NULL, 'C0.1: RNA Pol CTD Phosphatase Like', 183, NULL, 'C0.1:_RNA_Pol_CTD_Phosphatase', 283234),
(464141, 'SFLDF00003', NULL, 'D-galactonate dehydratase', 369, NULL, 'D-galactonate_dehydratase', 283235),
(464142, 'SFLDF00004', NULL, 'mandelate racemase', 394, NULL, 'mandelate_racemase', 283236),
(464143, 'SFLDF00280', NULL, 'coenzyme PQQ synthesis protein E (PqqE-like)', 377, NULL, 'coenzyme_PQQ_synthesis_protei', 283237),
(464144, 'SFLDF00545', NULL, 'cyclopropanase', 464, NULL, 'cyclopropanase', 283238),
(464145, 'SFLDS00052', NULL, 'Ferric Reductase Domain', 548, NULL, 'Ferric_Reductase_Domain', 283239),
(464146, 'SFLDF00413', NULL, 'CDK5RAP1', 460, NULL, 'CDK5RAP1', 283240),
(464147, 'SFLDG01182', NULL, 'Prostaglandin E synthase like', 325, NULL, 'Prostaglandin_E_synthase_like', 283241),
(464148, 'SFLDF00542', NULL, 'alternative heme biosynthesis D (AhbD-like)', 362, NULL, 'alternative_heme_biosynthesis', 283242),
(464149, 'SFLDF00402', NULL, 'carbapenem intermediate methyltransferase (ThnP-like)', 484, NULL, 'carbapenem_intermediate_methy', 283243),
(464150, 'SFLDS00033', NULL, 'Radical SAM Phosphonate Metabolism', 299, NULL, 'Radical_SAM_Phosphonate_Metab', 283244),
(464151, 'SFLDG01100', NULL, 'methyltransferase (Class D)', 471, NULL, 'methyltransferase_(Class_D)', 283245),
(464152, 'SFLDF00008', NULL, 'gluconate dehydratase', 393, NULL, 'gluconate_dehydratase', 283246),
(464153, 'SFLDF00349', NULL, '3-methylornithine synthase (PylB-like)', 350, NULL, '3-methylornithine_synthase_(P', 283247),
(464154, 'SFLDG01067', NULL, 'SPASM/twitch domain containing', 337, NULL, 'SPASM/twitch_domain_containin', 283248),
(464155, 'SFLDF00423', NULL, 'chondrochloren A methyltransferase (CndI-like)', 696, NULL, 'chondrochloren_A_methyltransf', 283249),
(464156, 'SFLDS00014', NULL, 'RuBisCO', 415, NULL, 'RuBisCO', 283250),
(464157, 'SFLDS00003', NULL, 'Haloacid Dehalogenase', 221, NULL, 'Haloacid_Dehalogenase', 283251),
(464158, 'SFLDF00118', NULL, 'D-tartrate dehydratase', 387, NULL, 'D-tartrate_dehydratase', 283252),
(464159, 'SFLDF00403', NULL, 'phosphonoacetaldehyde methylase (fom3-like)', 534, NULL, 'phosphonoacetaldehyde_methyla', 283253),
(464160, 'SFLDG01095', NULL, 'Uncharacterised Radical SAM Subgroup 7', 293, NULL, 'Uncharacterised_Radical_SAM_S', 283254),
(464161, 'SFLDF00306', NULL, 'carbapenem intermediate methyltransferase (ThnL-like)', 467, NULL, 'carbapenem_intermediate_methy', 283255),
(464162, 'SFLDG01129', NULL, 'C1.5: HAD, Beta-PGM, Phosphatase Like', 220, NULL, 'C1.5:_HAD,_Beta-PGM,_Phosphat', 283256),
(464163, 'SFLDG01280', NULL, 'HydE/PylB-like', 346, NULL, 'HydE/PylB-like', 283257),
(464164, 'SFLDF00392', NULL, 'YjjI activase', 288, NULL, 'YjjI_activase', 283258),
(464165, 'SFLDG01146', NULL, 'C1.2.2', 179, NULL, 'C1.2.2', 283259),
(464166, 'SFLDF00404', NULL, 'hopanetetrol cyclitol ether synthase', 479, NULL, 'hopanetetrol_cyclitol_ether_s', 283260);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(464167, 'SFLDG01181', NULL, 'SUF2', 241, NULL, 'SUF2', 283261),
(464168, 'SFLDG00010', NULL, 'C1.8: polynucleotide 5''-hydroxyl-kinase c-terminal phosphatase like', 149, NULL, 'C1.8:_polynucleotide_5''-hydro', 283262),
(464169, 'SFLDF00424', NULL, '2-deoxy-scyllo-inosamine dehydrogenase (BtrN-like)', 250, NULL, '2-deoxy-scyllo-inosamine_dehy', 283263),
(464170, 'SFLDF00272', NULL, 'biotin synthase', 329, NULL, 'biotin_synthase', 283264),
(464171, 'SFLDG01102', NULL, 'Uncharacterised Radical SAM Subgroup 15', 414, NULL, 'Uncharacterised_Radical_SAM_S', 283265),
(464172, 'SFLDF00416', NULL, 'fortimicin-like methyltransferase', 553, NULL, 'fortimicin-like_methyltransfe', 283266),
(464173, 'SFLDG01061', NULL, 'methylthiotransferase', 434, NULL, 'methylthiotransferase', 283267),
(464174, 'SFLDF00157', NULL, '2,3-diketo-5-methylthiopentyl-1-phosphate enolase', 407, NULL, '2,3-diketo-5-methylthiopentyl', 283268),
(464175, 'SFLDF00285', NULL, 'anaerobic Ser-type sulfatase-maturating enzyme', 411, NULL, 'anaerobic_Ser-type_sulfatase-', 283269),
(464176, 'SFLDG01064', NULL, 'F420, menaquinone cofactor biosynthesis', 362, NULL, 'F420,_menaquinone_cofactor_bi', 283270),
(464177, 'SFLDG01019', NULL, 'Terpene Cyclase Like 1 C Terminal Domain', 325, NULL, 'Terpene_Cyclase_Like_1_C_Term', 283271),
(464178, 'SFLDS00113', NULL, 'Radical SAM Phosphomethylpyrimidine Synthase', 592, NULL, 'Radical_SAM_Phosphomethylpyri', 283272),
(464179, 'SFLDF00040', NULL, 'epoxide hydrolase n-terminal phosphatase', 227, NULL, 'epoxide_hydrolase_n-terminal_', 283273),
(464180, 'SFLDF00279', NULL, '4-hydroxyphenylacetate decarboxylase activase', 316, NULL, '4-hydroxyphenylacetate_decarb', 283274),
(464181, 'SFLDG01113', NULL, 'Uncharacterised Radical SAM Subgroup 4', 293, NULL, 'Uncharacterised_Radical_SAM_S', 283275),
(464182, 'SFLDF00045', NULL, '2-haloacid dehalogenase', 228, NULL, '2-haloacid_dehalogenase', 283276),
(464183, 'SFLDG01060', NULL, 'BATS domain containing', 303, NULL, 'BATS_domain_containing', 283277),
(464184, 'SFLDF00554', NULL, 'L-lyxonate dehydratase', 390, NULL, 'L-lyxonate_dehydratase', 283278),
(464185, 'SFLDG01110', NULL, 'Uncharacterised Radical SAM Subgroup 8', 371, NULL, 'Uncharacterised_Radical_SAM_S', 283279),
(464186, 'SFLDF00035', NULL, 'phosphoglycolate phosphatase', 239, NULL, 'phosphoglycolate_phosphatase', 283280),
(464187, 'SFLDG01058', NULL, 'lipoyl synthase like', 301, NULL, 'lipoyl_synthase_like', 283281),
(464188, 'SFLDF00284', NULL, 'tRNA wybutosine-synthesizing', 315, NULL, 'tRNA_wybutosine-synthesizing', 283282),
(464189, 'SFLDF00432', NULL, 'pyrimidine ring methyltransferase (bleomycin-like antibiotic biosynthesis)', 424, NULL, 'pyrimidine_ring_methyltransfe', 283283),
(464190, 'SFLDF00329', NULL, 'gentamicin-like N-methyltransferase  (GntE-like)', 659, NULL, 'gentamicin-like_N-methyltrans', 283284),
(464191, 'SFLDF00546', NULL, 'neomycin C-like epimerase', 299, NULL, 'neomycin_C-like_epimerase', 283285),
(464192, 'SFLDF00365', NULL, 'thuricin CD (TrnCD-like)', 292, NULL, 'thuricin_CD_(TrnCD-like)', 283286),
(464193, 'SFLDF00439', NULL, 'methylation of yatakemycin (YTK)', 461, NULL, 'methylation_of_yatakemycin_(Y', 283287),
(464194, 'SFLDF00336', NULL, 'quinohemoprotein amine dehydrogenase maturation protein (QhpD-like)', 483, NULL, 'quinohemoprotein_amine_dehydr', 283288),
(464195, 'SFLDF00046', NULL, 'beta-phosphoglucomutase', 219, NULL, 'beta-phosphoglucomutase', 283289),
(464196, 'SFLDF00155', NULL, 'muconate cycloisomerase (anti)', 367, NULL, 'muconate_cycloisomerase_(anti', 283290),
(464197, 'SFLDG01114', NULL, 'phosphomethylpyrimidine synthase (ThiC)', 571, NULL, 'phosphomethylpyrimidine_synth', 283291),
(464198, 'SFLDG01072', NULL, 'dehydrogenase like', 371, NULL, 'dehydrogenase_like', 283292),
(464199, 'SFLDG01217', NULL, 'B12-binding methylthiotransferase like', 437, NULL, 'B12-binding_methylthiotransfe', 283293),
(464200, 'SFLDF00044', NULL, 'enolase-phosphatase', 233, NULL, 'enolase-phosphatase', 283294),
(464201, 'SFLDF00314', NULL, 'L-lysine 2,3-aminomutase (yjeK like)', 336, NULL, 'L-lysine_2,3-aminomutase_(yje', 283295);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(464202, 'SFLDF00116', NULL, 'N-succinylamino acid racemase', 371, NULL, 'N-succinylamino_acid_racemase', 283296),
(464203, 'SFLDF00463', NULL, 'AIM14', 551, NULL, 'AIM14', 283297),
(464204, 'SFLDG01099', NULL, 'Uncharacterised Radical SAM Subgroup 12', 304, NULL, 'Uncharacterised_Radical_SAM_S', 283298),
(464205, 'SFLDG01205', NULL, 'AMPS.1', 203, NULL, 'AMPS.1', 283299),
(464206, 'SFLDF00042', NULL, 'mannosyl-3-phosphoglycerate phosphatase', 243, NULL, 'mannosyl-3-phosphoglycerate_p', 283300),
(464207, 'SFLDG01122', NULL, 'methyltransferase (class C)', 397, NULL, 'methyltransferase_(class_C)', 283301),
(464208, 'SFLDF00429', NULL, 'UDP-N-acetyl-tunicamine-uracil synthase (TunB-like)', 338, NULL, 'UDP-N-acetyl-tunicamine-uraci', 283302),
(464209, 'SFLDG01109', NULL, 'Uncharacterised Radical SAM Subgroup 22', 429, NULL, 'Uncharacterised_Radical_SAM_S', 283303),
(464210, 'SFLDF00298', NULL, 'glycerol dehydratase activase', 304, NULL, 'glycerol_dehydratase_activase', 283304),
(464211, 'SFLDF00002', NULL, 'enolase', 418, NULL, 'enolase', 283305),
(464212, 'SFLDF00318', NULL, 'Viperin', 323, NULL, 'Viperin', 283306),
(464213, 'SFLDF00397', NULL, 'adenosyl-hopene transferase', 337, NULL, 'adenosyl-hopene_transferase', 283307),
(464214, 'SFLDG01103', NULL, 'Uncharacterised Radical SAM Subgroup 16', 365, NULL, 'Uncharacterised_Radical_SAM_S', 283308),
(464215, 'SFLDF00299', NULL, 'anaerobic ribonucleoside-triphosphate reductase activase', 159, NULL, 'anaerobic_ribonucleoside-trip', 283309),
(464216, 'SFLDF00446', NULL, 'phosphoglycolate phosphatase 3', 232, NULL, 'phosphoglycolate_phosphatase_', 283310),
(464217, 'SFLDF00271', NULL, 'lipoyl synthase', 301, NULL, 'lipoyl_synthase', 283311),
(464218, 'SFLDF00005', NULL, 'glucarate dehydratase', 451, NULL, 'glucarate_dehydratase', 283312),
(464219, 'SFLDG00178', NULL, 'enolase', 418, NULL, 'enolase', 283313),
(464220, 'SFLDG01145', NULL, 'C1.2.1', 187, NULL, 'C1.2.1', 283314),
(464221, 'SFLDF00281', NULL, 'FeMo cofactor biosynthesis protein (nifB-like)', 407, NULL, 'FeMo_cofactor_biosynthesis_pr', 283315),
(464222, 'SFLDF00434', NULL, '3-methyl-2-indolic acid methyltransferase (NocN/NosN like)', 420, NULL, '3-methyl-2-indolic_acid_methy', 283316),
(464223, 'SFLDF00565', NULL, 'hopanoid C3-methyltransferase (HpnR-like)', 513, NULL, 'hopanoid_C3-methyltransferase', 283317),
(464224, 'SFLDF00275', NULL, 'adenosine C2 methyltransferase (RlmN-like)', 357, NULL, 'adenosine_C2_methyltransferas', 283318),
(464225, 'SFLDF00418', NULL, 'pactamycin C-methyltransferase (PctN-like)', 575, NULL, 'pactamycin_C-methyltransferas', 283319),
(464226, 'SFLDG01020', NULL, 'Terpene Cyclase Like 2', 314, NULL, 'Terpene_Cyclase_Like_2', 283320),
(464227, 'SFLDF00303', NULL, 'hopanoid C2-methyltransferase (HpnP-like)', 516, NULL, 'hopanoid_C2-methyltransferase', 283321),
(464228, 'SFLDF00037', NULL, 'glycerol-3-phosphate phosphatase', 271, NULL, 'glycerol-3-phosphate_phosphat', 283322),
(464229, 'SFLDG01141', NULL, 'C2.B.1: Sucrose Phosphatase Like', 261, NULL, 'C2.B.1:_Sucrose_Phosphatase_L', 283323),
(464230, 'SFLDG00002', NULL, 'C1.7: P-type atpase like', 309, NULL, 'C1.7:_P-type_atpase_like', 283324),
(464231, 'SFLDG01125', NULL, 'C1.1: Acid Phosphatase Like', 232, NULL, 'C1.1:_Acid_Phosphatase_Like', 283325),
(464232, 'SFLDG01154', NULL, 'Main.5: Phi-like', 214, NULL, 'Main.5:_Phi-like', 283326),
(464233, 'SFLDF00009', NULL, 'o-succinylbenzoate synthase', 319, NULL, 'o-succinylbenzoate_synthase', 283327),
(464234, 'SFLDF00039', NULL, 'phosphoglycolate phosphatase 2', 323, NULL, 'phosphoglycolate_phosphatase_', 283328),
(464235, 'SFLDF00010', NULL, 'dipeptide epimerase', 323, NULL, 'dipeptide_epimerase', 283329),
(464236, 'SFLDF00344', NULL, 'ELP3-like', 509, NULL, 'ELP3-like', 283330),
(464237, 'SFLDG01062', NULL, 'methyltransferase (Class A)', 356, NULL, 'methyltransferase_(Class_A)', 283331),
(464238, 'SFLDG01153', NULL, 'Main.4: Theta-like', 218, NULL, 'Main.4:_Theta-like', 283332),
(464239, 'SFLDG01133', NULL, 'C1.5.4: Enolase-phosphatase Like', 232, NULL, 'C1.5.4:_Enolase-phosphatase_L', 283333);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(464240, 'SFLDF00420', NULL, 'spectinomycin biosynthesis (SpcY-like)', 302, NULL, 'spectinomycin_biosynthesis_(S', 283334),
(464241, 'SFLDG01169', NULL, 'NADPH oxidase subgroup (NOX)', 3378, NULL, 'NADPH_oxidase_subgroup_(NOX)', 283335),
(464242, 'SFLDF00316', NULL, 'C-terminal tyrosine decarboxylase (MftC-like)', 353, NULL, 'C-terminal_tyrosine_decarboxy', 283336),
(464243, 'SFLDG01014', NULL, 'Terpene Cyclase Like 1 N-term', 447, NULL, 'Terpene_Cyclase_Like_1_N-term', 283337),
(464244, 'SFLDF00007', NULL, 'methylaspartate ammonia-lyase', 413, NULL, 'methylaspartate_ammonia-lyase', 283338),
(464245, 'SFLDS00029', NULL, 'Radical SAM', 166, NULL, 'Radical_SAM', 283339),
(464246, 'SFLDG00033', NULL, 'mannonate dehydratase', 403, NULL, 'mannonate_dehydratase', 283340),
(464247, 'SFLDF00296', NULL, 'adenosine C8 methyltransferase (Cfr-like)', 346, NULL, 'adenosine_C8_methyltransferas', 283341),
(464248, 'SFLDF00301', NULL, '2-iminoacetate synthase (ThiH)', 374, NULL, '2-iminoacetate_synthase_(ThiH', 283342),
(464249, 'SFLDG01127', NULL, 'C1.3: Acid Phosphatase Like', 238, NULL, 'C1.3:_Acid_Phosphatase_Like', 283343),
(464250, 'SFLDF00330', NULL, 'HMD cofactor maturase (HmdB-like)', 342, NULL, 'HMD_cofactor_maturase_(HmdB-l', 283344),
(464251, 'SFLDG01216', NULL, 'thioether bond formation requiring one auxiliary iron-sulfur cluster', 461, NULL, 'thioether_bond_formation_requ', 283345),
(464252, 'SFLDF00393', NULL, 'heme D1 biosynthesis (NirJ-like)', 388, NULL, 'heme_D1_biosynthesis_(NirJ-li', 283346),
(464253, 'SFLDF00385', NULL, '7,8-dihydro-6-hydroxymethylpterin dimethylase', 517, NULL, '7,8-dihydro-6-hydroxymethylpt', 283347),
(464254, 'SFLDG01131', NULL, 'C1.5.2: MDP Like', 190, NULL, 'C1.5.2:_MDP_Like', 283348),
(464255, 'SFLDG01163', NULL, 'II', 307, NULL, 'II', 283349),
(464256, 'SFLDF00376', NULL, '7-carboxy-7-deazaguanine synthase, Cx14CxxC type', 211, NULL, '7-carboxy-7-deazaguanine_synt', 283350),
(464257, 'SFLDG01139', NULL, 'C2.A: Pyridoxal Phosphate Phosphatase Like', 255, NULL, 'C2.A:_Pyridoxal_Phosphate_Pho', 283351),
(464258, 'SFLDF00422', NULL, 'valine cyclopropanase', 613, NULL, 'valine_cyclopropanase', 283352),
(464259, 'SFLDG01118', NULL, 'activating enzymes, group 2', 303, NULL, 'activating_enzymes,_group_2', 283353),
(464260, 'SFLDG01162', NULL, 'I', 427, NULL, 'I_', 283354),
(464261, 'SFLDG01212', NULL, 'Phytoene synthase like', 281, NULL, 'Phytoene_synthase_like', 283355),
(464262, 'SFLDF00543', NULL, 'alternative heme biosynthesis C (AhbC-like)', 392, NULL, 'alternative_heme_biosynthesis', 283356),
(464263, 'SFLDF00435', NULL, 'carbapenem intermediate methyltransferase (ThnK-like)', 680, NULL, 'carbapenem_intermediate_methy', 283357),
(464264, 'SFLDG01132', NULL, 'C1.5.3: 5''-Nucleotidase Like', 225, NULL, 'C1.5.3:_5''-Nucleotidase_Like', 283358),
(464265, 'SFLDS00032', NULL, 'Radical SAM 3-amino-3-carboxypropyl Radical Forming', 1715, NULL, 'Radical_SAM_3-amino-3-carboxy', 283359),
(464266, 'SFLDG01081', NULL, 'cleavage of the Ca-Cb bond in aromatic amino acids', 379, NULL, 'cleavage_of_the_Ca-Cb_bond_in', 283360),
(464267, 'SFLDF00419', NULL, '3-methyl-2-indolic acid synthase (NosL)', 397, NULL, '3-methyl-2-indolic_acid_synth', 283361),
(464268, 'SFLDG01115', NULL, 'Phosphonate metabolism (PhnJ)', 298, NULL, 'Phosphonate_metabolism_(PhnJ)', 283362),
(464269, 'SFLDG01202', NULL, 'SUF2.2', 252, NULL, 'SUF2.2', 283363),
(464270, 'SFLDG01383', NULL, 'cyclic pyranopterin phosphate synthase (MoaA-like)', 324, NULL, 'cyclic_pyranopterin_phosphate', 283364),
(464271, 'SFLDF00283', NULL, 'L-lysine 2,3-aminomutase (LAM-like)', 413, NULL, 'L-lysine_2,3-aminomutase_(LAM', 283365),
(464272, 'SFLDG01121', NULL, 'Diphthamide biosynthesis', 490, NULL, 'Diphthamide_biosynthesis', 283366),
(464273, 'SFLDF00028', NULL, 'histidinol-phosphatase', 201, NULL, 'histidinol-phosphatase', 283367),
(464274, 'SFLDF00417', NULL, 'gentamicin C-6'' methyltransferase (GenK-like)', 638, NULL, 'gentamicin_C-6''_methyltransfe', 283368),
(464275, 'SFLDG01066', NULL, 'organic radical-activating enzymes', 243, NULL, 'organic_radical-activating_en', 283369);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(464276, 'SFLDG01098', NULL, 'Uncharacterised Radical SAM Subgroup 11', 324, NULL, 'Uncharacterised_Radical_SAM_S', 283370),
(464277, 'SFLDF00038', NULL, 'phosphonoacetaldehyde hydrolase', 269, NULL, 'phosphonoacetaldehyde_hydrola', 283371),
(464278, 'SFLDF00307', NULL, 'bacteriochlorophyll C8 methyltransferase', 468, NULL, 'bacteriochlorophyll_C8_methyl', 283372),
(464279, 'SFLDF00322', NULL, 'tryptophan 2-C-methyltransferase', 574, NULL, 'tryptophan_2-C-methyltransfer', 283373),
(464280, 'SFLDF00290', NULL, 'glutamate 2,3-aminomutase', 414, NULL, 'glutamate_2,3-aminomutase', 283374),
(464281, 'SFLDF00027', NULL, 'p-type atpase', 309, NULL, 'p-type_atpase', 283375),
(464282, 'SFLDG01168', NULL, 'Ferric reductase subgroup (FRE)', 619, NULL, 'Ferric_reductase_subgroup_(FR', 283376),
(464283, 'SFLDG01128', NULL, 'C1.4: 5''-Nucleotidase Like', 296, NULL, 'C1.4:_5''-Nucleotidase_Like', 283377),
(464284, 'SFLDG01386', NULL, 'main SPASM domain-containing', 349, NULL, 'main_SPASM_domain-containing', 283378),
(464285, 'SFLDG01150', NULL, 'Main.1: Beta-like', 210, NULL, 'Main.1:_Beta-like', 283379),
(464286, 'SFLDG01206', NULL, 'Xi.1', 327, NULL, 'Xi.1', 283380),
(464287, 'SFLDF00357', NULL, 'ExsD-like', 241, NULL, 'ExsD-like', 283381),
(464288, 'SFLDF00568', NULL, 'paromamine deoxygenase', 456, NULL, 'paromamine_deoxygenase', 283382),
(464289, 'SFLDF00041', NULL, 'mdp-1', 176, NULL, 'mdp-1', 283383),
(464290, 'SFLDG01017', NULL, 'Polyprenyl Transferase Like', 294, NULL, 'Polyprenyl_Transferase_Like', 283384),
(464291, 'SFLDF00317', NULL, 'thioacetal methlytransferase (Swb9-like)', 679, NULL, 'thioacetal_methlytransferase_', 283385),
(464292, 'SFLDG01021', NULL, 'Trichodiene Synthase Like', 308, NULL, 'Trichodiene_Synthase_Like', 283386),
(464293, 'SFLDF00295', NULL, 'threonylcarbamoyladenosine tRNA methylthiotransferase', 448, NULL, 'threonylcarbamoyladenosine_tR', 283387),
(464294, 'SFLDG01152', NULL, 'Main.3: Omega- and Tau-like', 226, NULL, 'Main.3:_Omega-_and_Tau-like_', 283388),
(464295, 'SFLDF00294', NULL, '7,8-didemethyl-8-hydroxy-5-deazariboflavin synthase (CofG-like)', 337, NULL, '7,8-didemethyl-8-hydroxy-5-de', 283389),
(464296, 'SFLDF00278', NULL, 'pyruvate formate-lyase activase', 250, NULL, 'pyruvate_formate-lyase_activa', 283390),
(464297, 'SFLDG01088', NULL, 'antiviral proteins', 282, NULL, 'antiviral_proteins', 283391),
(464298, 'SFLDG01385', NULL, 'heme carboxy lyase like', 393, NULL, 'heme_carboxy_lyase_like', 283392),
(464299, 'SFLDS00055', NULL, 'Pyruvoyl-Dependent Histidine/Arginine Decarboxylase', 166, NULL, 'Pyruvoyl-Dependent_Histidine/', 283393),
(464300, 'SFLDF00515', NULL, 'sporulation killing factor protein (SkfB-like)', 411, NULL, 'sporulation_killing_factor_pr', 283394),
(464301, 'SFLDF00415', NULL, 'ladderane biosynthesis', 493, NULL, 'ladderane_biosynthesis', 283395),
(464302, 'SFLDF00156', NULL, 'D-arabinonate dehydratase', 373, NULL, 'D-arabinonate_dehydratase', 283396),
(464303, 'SFLDG01104', NULL, 'Uncharacterised Radical SAM Subgroup 17', 357, NULL, 'Uncharacterised_Radical_SAM_S', 283397),
(464304, 'SFLDF00297', NULL, 'benzylsuccinate synthase activase', 351, NULL, 'benzylsuccinate_synthase_acti', 283398),
(464305, 'SFLDG01111', NULL, 'Uncharacterised Radical SAM Subgroup 5', 202, NULL, 'Uncharacterised_Radical_SAM_S', 283399),
(464306, 'SFLDG01101', NULL, 'Uncharacterised Radical SAM Subgroup 14', 336, NULL, 'Uncharacterised_Radical_SAM_S', 283400),
(464307, 'SFLDF00029', NULL, 'phosphoserine phosphatase', 222, NULL, 'phosphoserine_phosphatase', 283401),
(464308, 'SFLDG01148', NULL, 'Xi (cytGST)', 327, NULL, 'Xi_(cytGST)', 283402),
(464309, 'SFLDF00289', NULL, 'anaerobic Cys-type sulfatase-maturating enzyme', 372, NULL, 'anaerobic_Cys-type_sulfatase-', 283403),
(464310, 'SFLDF00031', NULL, '2-deoxyglucose-6-phosphatase', 256, NULL, '2-deoxyglucose-6-phosphatase', 283404),
(464311, 'SFLDF00569', NULL, 'pcfB-like', 349, NULL, 'pcfB-like', 283405),
(464312, 'SFLDS00019', NULL, 'Glutathione Transferase (cytosolic)', 200, NULL, 'Glutathione_Transferase_(cyto', 283406);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(464313, 'SFLDF00032', NULL, 'trehalose-phosphatase', 267, NULL, 'trehalose-phosphatase', 283407),
(464314, 'SFLDS00036', NULL, 'Aromatic Prenyltransferase', 308, NULL, 'Aromatic_Prenyltransferase', 283408),
(464315, 'SFLDF00273', NULL, '(dimethylallyl)adenosine tRNA methylthiotransferase (MiaB-like)', 445, NULL, '(dimethylallyl)adenosine_tRNA', 283409),
(464316, 'SFLDG01258', NULL, '(chloro)muconate cycloisomerase (syn) like', 376, NULL, '(chloro)muconate_cycloisomera', 283410),
(464317, 'SFLDG00309', NULL, 'galactarate dehydratase', 391, NULL, 'galactarate_dehydratase', 283411),
(464318, 'SFLDF00471', NULL, 'Pyruvoyl-dependent arginine decarboxylase', 155, NULL, 'Pyruvoyl-dependent_arginine_d', 283412),
(464319, 'SFLDG01384', NULL, 'thioether bond formation requiring two auxiliary iron-sulfur clusters', 377, NULL, 'thioether_bond_formation_requ', 283413),
(464320, 'SFLDF00319', NULL, '[Fe] hydrogenase maturase (HydG-like)', 474, NULL, '[Fe]_hydrogenase_maturase_(Hy', 283414),
(464321, 'SFLDG01065', NULL, 'anaerobic coproporphyrinogen-III oxidase like', 364, NULL, 'anaerobic_coproporphyrinogen-', 283415),
(464322, 'SFLDG01138', NULL, 'C1.6.2: Deoxy-d-mannose-octulosonate 8-phosphate Phosphatase Like', 163, NULL, 'C1.6.2:_Deoxy-d-mannose-octul', 283416),
(464323, 'SFLDF00274', NULL, 'ribosomal protein S12 methylthiotransferase (RimO-like)', 443, NULL, 'ribosomal_protein_S12_methylt', 283417),
(464324, 'SFLDG01097', NULL, 'Uncharacterised Radical SAM Subgroup 10', 375, NULL, 'Uncharacterised_Radical_SAM_S', 283418),
(464325, 'SFLDF00288', NULL, 'HemN-like, clustered with nucleoside-triphosphate RdgB', 384, NULL, 'HemN-like,_clustered_with_nuc', 283419),
(464326, 'SFLDF00326', NULL, '5''''-pyrrole methytransferase', 571, NULL, '5''''-pyrrole_methytransferase', 283420),
(464327, 'SFLDG01094', NULL, 'Uncharacterised Radical SAM Subgroup 6', 231, NULL, 'Uncharacterised_Radical_SAM_S', 283421),
(464328, 'SFLDG01108', NULL, 'Uncharacterised Radical SAM Subgroup 21', 352, NULL, 'Uncharacterised_Radical_SAM_S', 283422),
(464329, 'SFLDF00134', NULL, 'L-talarate/galactarate dehydratase', 377, NULL, 'L-talarate/galactarate_dehydr', 283423),
(464330, 'SFLDG01604', NULL, 'Terpene Cyclase Like 1 C Terminal Domain - Enzymatic', 329, NULL, 'Terpene_Cyclase_Like_1_C_Term', 283424),
(464331, 'SFLDG01605', NULL, 'Terpene Cyclase Like 1 N-term - Enzymatic', 431, NULL, 'Terpene_Cyclase_Like_1_N-term', 283425),
(464332, 'SFLDG01016', NULL, 'Prenyltransferase Like 2', 646, NULL, 'Prenyltransferase_Like_2', 283426),
(464333, 'SFLDG01079', NULL, 'spore photoproduct lyase like', 341, NULL, 'spore_photoproduct_lyase_like', 283427),
(464334, 'SFLDG01279', NULL, 'HMD cofactor maturase (HmdB-like)', 342, NULL, 'HMD_cofactor_maturase_(HmdB-l', 283428),
(464335, 'SFLDF00571', NULL, 'Tte1186a maturase', 469, NULL, 'Tte1186a_maturase', 283429),
(464336, 'SFLDG01389', NULL, 'menaquinone synthsis involved', 364, NULL, 'menaquinone_synthsis_involved', 283430),
(464337, 'SFLDS00028', NULL, 'Proline Racemase', 336, NULL, 'Proline_Racemase', 283431),
(464338, 'SFLDF00311', NULL, 'heme degradation proteins (HutW/ChuW-like)', 453, NULL, 'heme_degradation_proteins_(Hu', 283432),
(464339, 'SFLDF00292', NULL, 'spore photoproduct lyase 1', 342, NULL, 'spore_photoproduct_lyase_1', 283433),
(464340, 'SFLDG01117', NULL, 'AviX12-like', 440, NULL, 'AviX12-like', 283434),
(464341, 'SFLDG01183', NULL, 'Grx2-like', 215, NULL, 'Grx2-like', 283435),
(464342, 'SFLDG01126', NULL, 'C1.2: Nucleotidase Like', 195, NULL, 'C1.2:_Nucleotidase_Like', 283436),
(464343, 'SFLDF00570', NULL, 'tungsten cofactor oxidoreducase radical SAM maturase', 373, NULL, 'tungsten_cofactor_oxidoreduca', 283437),
(464344, 'SFLDS00005', NULL, 'Isoprenoid Synthase Type I', 271, NULL, 'Isoprenoid_Synthase_Type_I', 283438),
(464345, 'SFLDG01136', NULL, 'C1.6: Phosphoserine Phosphatase Like', 162, NULL, 'C1.6:_Phosphoserine_Phosphata', 283439),
(464346, 'SFLDG01086', NULL, 'elongater protein-like', 303, NULL, 'elongater_protein-like', 283440),
(464347, 'SFLDG01119', NULL, 'spectinomycin biosynthesis (SpcY-like)', 304, NULL, 'spectinomycin_biosynthesis_(S', 283441);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(464348, 'SFLDG01179', NULL, 'Complement C3/C4 Like', 304, NULL, 'Complement_C3/C4_Like', 283442),
(464349, 'SFLDG01151', NULL, 'Main.2: Nu-like', 210, NULL, 'Main.2:_Nu-like', 283443),
(464350, 'SFLDF00564', NULL, 'xylonate dehydratase 2', 413, NULL, 'xylonate_dehydratase_2', 283444),
(464351, 'SFLDG01070', NULL, 'PLP-dependent', 373, NULL, 'PLP-dependent', 283445),
(464352, 'SFLDG01134', NULL, 'C1.5.5: Heptose Bisphosphate Phosphatase Like', 187, NULL, 'C1.5.5:_Heptose_Bisphosphate_', 283446),
(464353, 'SFLDF00324', NULL, 'bacteriocin maturation', 647, NULL, 'bacteriocin_maturation', 283447),
(464354, 'SFLDG01068', NULL, 'FeMo cofactor biosynthesis protein', 492, NULL, 'FeMo_cofactor_biosynthesis_pr', 283448),
(464355, 'SFLDG01211', NULL, 'Competence Regulatory Protein ComQ', 305, NULL, 'Competence_Regulatory_Protein', 283449),
(464356, 'SFLDG00363', NULL, 'AMPS (cytGST): Alpha-, Mu-, Pi-, and Sigma-like', 196, NULL, 'AMPS_(cytGST):_Alpha-,_Mu-,_P', 283450),
(464357, 'SFLDG01083', NULL, 'Uncharacterised Radical SAM Subgroup 1', 303, NULL, 'Uncharacterised_Radical_SAM_S', 283451),
(464358, 'SFLDF00436', NULL, 'pactamycin C-methyltransferase (PctJ-like)', 614, NULL, 'pactamycin_C-methyltransferas', 283452),
(464359, 'SFLDF00310', NULL, 'oxygen-independent coproporphyrinogen-III oxidase 2 (HemZ-like)', 421, NULL, 'oxygen-independent_coproporph', 283453),
(464360, 'SFLDG01204', NULL, 'Grx2-like.1', 215, NULL, 'Grx2-like.1', 283454),
(464361, 'SFLDF00293', NULL, '((2,3,4,5-tetrahydroxypentyl)amino)dihydropyrimidine-2,4-dione synthase (CofH-like)', 365, NULL, '((2,3,4,5-tetrahydroxypentyl)', 283455),
(464362, 'SFLDF00315', NULL, 'antilisterial bacteriocin subtilosin biosynthesis protein (AlbA-like)', 448, NULL, 'antilisterial_bacteriocin_sub', 283456),
(464363, 'SignalP-TM', NULL, NULL, NULL, NULL, 'SignalP-TM', 283457),
(464364, 'SignalP-noTM', NULL, NULL, NULL, NULL, 'SignalP-noTM', 283458),
(464365, 'SignalP-TM', NULL, NULL, NULL, NULL, 'SignalP-TM', 283459),
(464366, 'SignalP-noTM', NULL, NULL, NULL, NULL, 'SignalP-noTM', 283460),
(464367, 'SignalP-TM', NULL, NULL, NULL, NULL, 'SignalP-TM', 283461),
(464368, 'SignalP-noTM', NULL, NULL, NULL, NULL, 'SignalP-noTM', 283462),
(464369, 'SM01346', NULL, NULL, 169, NULL, 'DUF3385_3', 283463),
(464370, 'SM00913', NULL, NULL, 87, NULL, 'IBN_N_2', 283464),
(464371, 'SM00551', NULL, NULL, 102, NULL, 'TAZ_2', 283465),
(464372, 'SM01255', NULL, NULL, 46, NULL, 'KNOX1_2', 283466),
(464373, 'SM00084', NULL, NULL, 25, NULL, 'nmu2', 283467),
(464374, 'SM00843', NULL, NULL, 66, NULL, 'FtsK_gamma_2', 283468),
(464375, 'SM01388', NULL, NULL, 204, NULL, 'Mob1_phocein_2', 283469),
(464376, 'SM00824', NULL, 'Thioesterase', 219, NULL, 'PKS_TE', 283470),
(464377, 'SM01314', NULL, NULL, 76, NULL, 'SnAC_2', 283471),
(464378, 'SM00548', NULL, NULL, 18, NULL, 'irx_3', 283472),
(464379, 'SM01115', NULL, NULL, 54, NULL, 'cwf21_2', 283473),
(464380, 'SM00085', NULL, NULL, 122, NULL, 'PA-fin', 283474),
(464381, 'SM00329', NULL, NULL, 218, NULL, 'bpi2_2', 283475),
(464382, 'SM01347', NULL, NULL, 221, NULL, 'Mre11_DNA_bind_2', 283476),
(464383, 'SM00998', NULL, NULL, 89, NULL, 'ADSL_C_2', 283477),
(464384, 'SM01084', NULL, NULL, 79, NULL, 'CKS_2', 283478),
(464385, 'SM00301', NULL, NULL, 58, NULL, 'DM_3', 283479),
(464386, 'SM00733', NULL, NULL, 32, NULL, 'mt_12', 283480),
(464387, 'SM00297', NULL, NULL, 118, NULL, 'bromo_6', 283481),
(464388, 'SM00869', NULL, NULL, 309, NULL, 'Autotransporter_2', 283482),
(464389, 'SM00148', NULL, NULL, 182, NULL, 'plcx_3', 283483),
(464390, 'SM00061', NULL, NULL, 123, NULL, 'math_3', 283484),
(464391, 'SM00976', NULL, NULL, 161, NULL, 'Telo_bind_a_2', 283485),
(464392, 'SM00279', NULL, NULL, 37, NULL, 'HhH_4', 283486),
(464393, 'SM00404', NULL, NULL, 92, NULL, 'ptp_7', 283487),
(464394, 'SM00576', NULL, NULL, 83, NULL, '17neu3', 283488),
(464395, 'SM00273', NULL, NULL, 137, NULL, 'enth_2', 283489),
(464396, 'SM00017', NULL, NULL, 309, NULL, 'osteo', 283490),
(464397, 'SM01304', NULL, NULL, 128, NULL, 'Ras_bdg_2_2', 283491),
(464398, 'SM00773', NULL, NULL, 86, NULL, 'WGR_cls', 283492);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(464399, 'SM01193', NULL, NULL, 142, NULL, 'Enolase_N_3', 283493),
(464400, 'SM00905', NULL, NULL, 130, NULL, 'FolB_2', 283494),
(464401, 'SM01124', NULL, NULL, 198, NULL, 'DBR1_2', 283495),
(464402, 'SM00105', NULL, NULL, 139, NULL, 'arf_gap_3', 283496),
(464403, 'SM01212', NULL, NULL, 146, NULL, 'Fib_alpha_2', 283497),
(464404, 'SM01404', NULL, NULL, 182, NULL, 'CIMR_2', 283498),
(464405, 'SM00214', NULL, NULL, 75, NULL, 'vwc', 283499),
(464406, 'SM00947', NULL, NULL, 140, NULL, 'Pro_CA_2', 283500),
(464407, 'SM01192', NULL, NULL, 320, NULL, 'Enolase_C_3', 283501),
(464408, 'SM00828', NULL, 'Methyltransferase  in polyketide synthase (PKS) enzymes.', 275, NULL, 'PKS_MT', 283502),
(464409, 'SM01089', NULL, NULL, 70, NULL, 'Connexin_CCC_2', 283503),
(464410, 'SM00228', NULL, NULL, 80, NULL, 'pdz_new', 283504),
(464411, 'SM00505', NULL, NULL, 59, NULL, 'gth_4', 283505),
(464412, 'SM01003', NULL, NULL, 142, NULL, 'AlaDh_PNT_N_2', 283506),
(464413, 'SM01065', NULL, NULL, 120, NULL, 'CBM_20_2', 283507),
(464414, 'SM01219', NULL, NULL, 113, NULL, 'Frataxin_Cyay_2', 283508),
(464415, 'SM00870', NULL, NULL, 408, NULL, 'Asparaginase_2', 283509),
(464416, 'SM00164', NULL, NULL, 310, NULL, 'tbc_4', 283510),
(464417, 'SM01122', NULL, NULL, 139, NULL, 'DBC1_2', 283511),
(464418, 'SM00261', NULL, NULL, 48, NULL, 'furin_3', 283512),
(464419, 'SM01287', NULL, NULL, 113, NULL, 'Rtt106_2', 283513),
(464420, 'SM01129', NULL, NULL, 75, NULL, 'DELLA_2', 283514),
(464421, 'SM00149', NULL, NULL, 119, NULL, 'plcy_3', 283515),
(464422, 'SM00956', NULL, NULL, 127, NULL, 'RQC_2', 283516),
(464423, 'SM00991', NULL, NULL, 63, NULL, 'WHEP_TRS_a_2_a_3_a', 283517),
(464424, 'SM00961', NULL, NULL, 100, NULL, 'RuBisCO_small_2_a', 283518),
(464425, 'SM00695', NULL, NULL, 114, NULL, 'dusp', 283519),
(464426, 'SM01167', NULL, NULL, 140, NULL, 'DUF1900_2', 283520),
(464427, 'SM00546', NULL, NULL, 43, NULL, 'cue_7', 283521),
(464428, 'SM00568', NULL, NULL, 80, NULL, 'gram2001c', 283522),
(464429, 'SM00293', NULL, NULL, 84, NULL, 'PWWP_4', 283523),
(464430, 'SM00951', NULL, NULL, 38, NULL, 'QLQ_2', 283524),
(464431, 'SM01191', NULL, NULL, 75, NULL, 'ENT_2', 283525),
(464432, 'SM01214', NULL, NULL, 170, NULL, 'Fmp27_GFWDK_2', 283526),
(464433, 'SM01169', NULL, NULL, 333, NULL, 'DUF1943_3', 283527),
(464434, 'SM00365', NULL, NULL, 22, NULL, 'LRR_sd22_2', 283528),
(464435, 'SM01002', NULL, NULL, 196, NULL, 'AlaDh_PNT_C_2', 283529),
(464436, 'SM00768', NULL, NULL, 103, NULL, 'X8_cls', 283530),
(464437, 'SM01225', NULL, NULL, 139, NULL, 'G8_2', 283531),
(464438, 'SM00767', NULL, NULL, 138, NULL, 'dcd', 283532),
(464439, 'SM00744', NULL, NULL, 55, NULL, 'ringv_2', 283533),
(464440, 'SM00809', NULL, NULL, 124, NULL, 'alpha_adaptinc2', 283534),
(464441, 'SM00670', NULL, NULL, 146, NULL, 'PIN_9', 283535),
(464442, 'SM00506', NULL, NULL, 156, NULL, 'YBR022w_8', 283536),
(464443, 'SM01103', NULL, NULL, 86, NULL, 'CRS1_YhbY_2', 283537),
(464444, 'SM00478', NULL, NULL, 179, NULL, 'endo3end', 283538),
(464445, 'SM01231', NULL, NULL, 87, NULL, 'H_kinase_dim_2', 283539),
(464446, 'SM00706', NULL, NULL, 43, NULL, 'tecpr', 283540),
(464447, 'SM00174', NULL, NULL, 180, NULL, 'rho_sub_3', 283541),
(464448, 'SM00644', NULL, NULL, 181, NULL, 'ami_2', 283542),
(464449, 'SM00904', NULL, NULL, 137, NULL, 'Flavokinase_2', 283543),
(464450, 'SM01286', NULL, NULL, 173, NULL, 'SPT16_2', 283544),
(464451, 'SM00604', NULL, NULL, 172, NULL, 'md', 283545),
(464452, 'SM00448', NULL, NULL, 150, NULL, 'REC_2', 283546),
(464453, 'SM01120', NULL, NULL, 186, NULL, 'Dak2_2', 283547),
(464454, 'SM00247', NULL, NULL, 84, NULL, 'XTALbg_4', 283548),
(464455, 'SM00115', NULL, NULL, 282, NULL, 'caspase_2', 283549),
(464456, 'SM01349', NULL, NULL, 319, NULL, 'TOG_3', 283550),
(464457, 'SM00575', NULL, NULL, 28, NULL, '26again6', 283551),
(464458, 'SM01027', NULL, NULL, 163, NULL, 'Beta_Casp_2', 283552),
(464459, 'SM01320', NULL, NULL, 190, NULL, 'TRP_N_2', 283553),
(464460, 'SM01323', NULL, NULL, 87, NULL, 'YajC_2', 283554),
(464461, 'SM00995', NULL, NULL, 95, NULL, 'AD_2', 283555);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(464462, 'SM01101', NULL, NULL, 262, NULL, 'CRISPR_assoc_2', 283556),
(464463, 'SM01278', NULL, NULL, 125, NULL, 'MAPKK1_Int_3', 283557),
(464464, 'SM00664', NULL, NULL, 112, NULL, 'DOMON_3', 283558),
(464465, 'SM01411', NULL, NULL, 96, NULL, 'GCC2_GCC3_2', 283559),
(464466, 'SM00304', NULL, NULL, 53, NULL, 'HAMP_11', 283560),
(464467, 'SM00076', NULL, NULL, 120, NULL, 'inter3_nr', 283561),
(464468, 'SM00129', NULL, NULL, 404, NULL, 'kinesin_4', 283562),
(464469, 'SM01340', NULL, NULL, 161, NULL, 'DNA_mis_repair_2', 283563),
(464470, 'SM01150', NULL, NULL, 436, NULL, 'DUF1338_2', 283564),
(464471, 'SM00392', NULL, NULL, 171, NULL, 'prof_2', 283565),
(464472, 'SM00763', NULL, NULL, 416, NULL, 'aaa_prka2seq5', 283566),
(464473, 'SM00685', NULL, NULL, 59, NULL, 'dm14', 283567),
(464474, 'SM01170', NULL, NULL, 168, NULL, 'DUF1944_2', 283568),
(464475, 'SM00573', NULL, NULL, 73, NULL, 'bromneu2', 283569),
(464476, 'SM00863', NULL, NULL, 69, NULL, 'tRNA_SAD_4', 283570),
(464477, 'SM00201', NULL, NULL, 53, NULL, 'SO_2', 283571),
(464478, 'SM01028', NULL, NULL, 40, NULL, 'Beta-TrCP_D_2', 283572),
(464479, 'SM00458', NULL, NULL, 135, NULL, 'ricin_3', 283573),
(464480, 'SM00142', NULL, NULL, 133, NULL, 'pi3k_hr3_6', 283574),
(464481, 'SM01351', NULL, NULL, 194, NULL, 'Aspzincin_M35_2', 283575),
(464482, 'SM01292', NULL, NULL, 331, NULL, 'N1221_2', 283576),
(464483, 'SM00417', NULL, NULL, 62, NULL, 'h44', 283577),
(464484, 'SM00910', NULL, NULL, 131, NULL, 'HIRAN_2', 283578),
(464485, 'SM00131', NULL, NULL, 56, NULL, 'KU_2', 283579),
(464486, 'SM01157', NULL, NULL, 250, NULL, 'DUF1719_2', 283580),
(464487, 'SM00209', NULL, NULL, 66, NULL, 'TSP1_2', 283581),
(464488, 'SM00218', NULL, NULL, 115, NULL, 'zu_1', 283582),
(464489, 'SM00211', NULL, NULL, 58, NULL, 'TY_2', 283583),
(464490, 'SM01331', NULL, NULL, 102, NULL, 'DUF3635_2', 283584),
(464491, 'SM01202', NULL, NULL, 80, NULL, 'FerI_2', 283585),
(464492, 'SM00533', NULL, NULL, 335, NULL, 'DNAend', 283586),
(464493, 'SM01205', NULL, NULL, 123, NULL, 'FKS1_dom1_2', 283587),
(464494, 'SM01235', NULL, NULL, 142, NULL, 'Haem_bd_2', 283588),
(464495, 'SM01217', NULL, NULL, 108, NULL, 'Fn3_like_2', 283589),
(464496, 'SM00042', NULL, NULL, 144, NULL, 'CUB_2', 283590),
(464497, 'SM00419', NULL, NULL, 50, NULL, 'crpmeuga4', 283591),
(464498, 'SM00765', NULL, NULL, 116, NULL, 'manec2seq9d', 283592),
(464499, 'SM01334', NULL, NULL, 65, NULL, 'DUF3454_2', 283593),
(464500, 'SM00077', NULL, NULL, 21, NULL, 'itam_5', 283594),
(464501, 'SM00925', NULL, NULL, 179, NULL, 'MltA_2', 283595),
(464502, 'SM00613', NULL, NULL, 98, NULL, 'cppneu5', 283596),
(464503, 'SM01220', NULL, NULL, 716, NULL, 'FSA_C_2', 283597),
(464504, 'SM01240', NULL, NULL, 495, NULL, 'IMPDH_2', 283598),
(464505, 'SM01415', NULL, NULL, 248, NULL, 'DUF106_2', 283599),
(464506, 'SM00503', NULL, NULL, 127, NULL, 'SynN_4', 283600),
(464507, 'SM00436', NULL, NULL, 92, NULL, 'topIban2', 283601),
(464508, 'SM01353', NULL, NULL, 140, NULL, 'AIF_C_2', 283602),
(464509, 'SM00888', NULL, NULL, 92, NULL, 'EF1_GNE_2', 283603),
(464510, 'SM00398', NULL, NULL, 71, NULL, 'hmgende2', 283604),
(464511, 'SM00959', NULL, NULL, 43, NULL, 'Rho_N_2_a', 283605),
(464512, 'SM00574', NULL, NULL, 148, NULL, 'prehox3', 283606),
(464513, 'SM01393', NULL, NULL, 108, NULL, 'Ribosomal_L32e_2', 283607),
(464514, 'SM00572', NULL, NULL, 263, NULL, 'rich3', 283608),
(464515, 'SM00853', NULL, NULL, 176, NULL, 'MutL_C_2', 283609),
(464516, 'SM00491', NULL, NULL, 160, NULL, 'Cxpdneu3', 283610),
(464517, 'SM01311', NULL, NULL, 364, NULL, 'RPOL_N_2', 283611),
(464518, 'SM00920', NULL, NULL, 90, NULL, 'MHC_II_alpha_2', 283612),
(464519, 'SM00571', NULL, NULL, 65, NULL, 'testlast3', 283613),
(464520, 'SM01119', NULL, NULL, 114, NULL, 'D_ser_dehydrat_2', 283614),
(464521, 'SM01140', NULL, NULL, 244, NULL, 'Drf_GBD_2', 283615),
(464522, 'SM00429', NULL, NULL, 111, NULL, 'iptmega2', 283616),
(464523, 'SM00194', NULL, NULL, 308, NULL, 'PTPc_3', 283617),
(464524, 'SM00743', NULL, NULL, 73, NULL, 'agenet_At_2', 283618),
(464525, 'SM01269', NULL, NULL, 39, NULL, 'Lipid_DES_2', 283619);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(464526, 'SM00756', NULL, NULL, 170, NULL, 'vkor_5', 283620),
(464527, 'SM01275', NULL, NULL, 61, NULL, 'MamL_1_2', 283621),
(464528, 'SM00825', NULL, 'Beta-ketoacyl synthase', 535, NULL, 'PKS_KS', 283622),
(464529, 'SM01029', NULL, NULL, 195, NULL, 'BetaGal_dom2_2', 283623),
(464530, 'SM01047', NULL, NULL, 68, NULL, 'C1_4_2', 283624),
(464531, 'SM01321', NULL, NULL, 152, NULL, 'Y1_Tnp_2', 283625),
(464532, 'SM01237', NULL, NULL, 312, NULL, 'ICA69_2', 283626),
(464533, 'SM01256', NULL, NULL, 56, NULL, 'KNOX2_2', 283627),
(464534, 'SM00111', NULL, NULL, 116, NULL, 'C4_2', 283628),
(464535, 'SM01399', NULL, NULL, 272, NULL, 'Sybindin_2', 283629),
(464536, 'SM00264', NULL, NULL, 91, NULL, 'BAG_1', 283630),
(464537, 'SM00542', NULL, NULL, 97, NULL, 'fyrc_3', 283631),
(464538, 'SM00984', NULL, NULL, 141, NULL, 'UDPG_MGDP_dh_C_a_2_a', 283632),
(464539, 'SM00760', NULL, NULL, 70, NULL, 'bac_dnaa_c7seqb', 283633),
(464540, 'SM01049', NULL, NULL, 104, NULL, 'Cache_2_2', 283634),
(464541, 'SM00884', NULL, NULL, 69, NULL, 'Cullin_Nedd8_2', 283635),
(464542, 'SM00792', NULL, NULL, 144, NULL, 'agouti', 283636),
(464543, 'SM00703', NULL, NULL, 178, NULL, 'nrf', 283637),
(464544, 'SM01137', NULL, NULL, 125, NULL, 'DMAP_binding_2', 283638),
(464545, 'SM00396', NULL, NULL, 79, NULL, 'push_1', 283639),
(464546, 'SM01312', NULL, NULL, 135, NULL, 'RTC4_2', 283640),
(464547, 'SM00313', NULL, NULL, 226, NULL, 'PXA_3', 283641),
(464548, 'SM00928', NULL, NULL, 46, NULL, 'NADH_4Fe_4S_2', 283642),
(464549, 'SM00607', NULL, NULL, 155, NULL, 'ftp', 283643),
(464550, 'SM00833', NULL, NULL, 122, NULL, 'CobW_C_3', 283644),
(464551, 'SM00182', NULL, NULL, 159, NULL, 'cul_2', 283645),
(464552, 'SM01109', NULL, NULL, 88, NULL, 'CUT_2', 283646),
(464553, 'SM00842', NULL, NULL, 195, NULL, 'FtsA._2', 283647),
(464554, 'SM00316', NULL, NULL, 72, NULL, 'S1_6', 283648),
(464555, 'SM00474', NULL, NULL, 202, NULL, '35exoneu6', 283649),
(464556, 'SM00816', NULL, NULL, 44, NULL, 'amb_v_allergen', 283650),
(464557, 'SM01131', NULL, NULL, 140, NULL, 'DHHA2_2', 283651),
(464558, 'SM01303', NULL, NULL, 130, NULL, 'RasGEF_N_2_2', 283652),
(464559, 'SM00595', NULL, NULL, 98, NULL, '118neu2', 283653),
(464560, 'SM00323', NULL, NULL, 390, NULL, 'RasGAP_2', 283654),
(464561, 'SM00494', NULL, NULL, 66, NULL, 'chi_10', 283655),
(464562, 'SM00353', NULL, NULL, 61, NULL, 'finulus', 283656),
(464563, 'SM00987', NULL, NULL, 125, NULL, 'UDG_2_a', 283657),
(464564, 'SM00321', NULL, NULL, 103, NULL, 'SLG_2', 283658),
(464565, 'SM00499', NULL, NULL, 64, NULL, 'aai_6', 283659),
(464566, 'SM00748', NULL, NULL, 123, NULL, '2HEPN', 283660),
(464567, 'SM01024', NULL, NULL, 235, NULL, 'BCS1_N_2', 283661),
(464568, 'SM01043', NULL, NULL, 151, NULL, 'BTAD_2', 283662),
(464569, 'SM01025', NULL, NULL, 91, NULL, 'BEN_2', 283663),
(464570, 'SM00614', NULL, NULL, 57, NULL, 'bed5', 283664),
(464571, 'SM00896', NULL, NULL, 116, NULL, 'FDX_ACB_2', 283665),
(464572, 'SM00242', NULL, NULL, 771, NULL, 'MYSc_2a', 283666),
(464573, 'SM01012', NULL, NULL, 56, NULL, 'ANTAR_2', 283667),
(464574, 'SM00753', NULL, 'motif in proteasome subunits, Int-6, Nip-1 and TRIP-15', 92, NULL, 'PINT', 283668),
(464575, 'SM00040', NULL, NULL, 121, NULL, 'CSF2_1', 283669),
(464576, 'SM01077', NULL, NULL, 125, NULL, 'Cg6151_P_2', 283670),
(464577, 'SM00231', NULL, NULL, 199, NULL, 'disc_4', 283671),
(464578, 'SM01305', NULL, NULL, 110, NULL, 'RESP18_2', 283672),
(464579, 'SM00927', NULL, NULL, 109, NULL, 'MutH_2', 283673),
(464580, 'SM00230', NULL, NULL, 384, NULL, 'cys_prot_2', 283674),
(464581, 'SM01325', NULL, NULL, 765, NULL, 'DUF3160_2', 283675),
(464582, 'SM00865', NULL, NULL, 178, NULL, 'Tubulin_C_4', 283676),
(464583, 'SM00440', NULL, NULL, 40, NULL, 'Cys4_2', 283677),
(464584, 'SM00080', NULL, NULL, 179, NULL, 'ultra', 283678),
(464585, 'SM00993', NULL, NULL, 30, NULL, 'YL1_C_2', 283679),
(464586, 'SM01178', NULL, NULL, 71, NULL, 'DUF4217_3', 283680),
(464587, 'SM00801', NULL, NULL, 84, NULL, 'dDENN_cls', 283681),
(464588, 'SM00789', NULL, NULL, 57, NULL, 'ad_cyc_g_alpha', 283682);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(464589, 'SM00966', NULL, NULL, 47, NULL, 'SpoVT_AbrB_2_a', 283683),
(464590, 'SM00140', NULL, NULL, 131, NULL, 'NGF_2', 283684),
(464591, 'SM00355', NULL, NULL, 23, NULL, 'c2h2final6', 283685),
(464592, 'SM00206', NULL, NULL, 184, NULL, 'NTR_2', 283686),
(464593, 'SM00558', NULL, NULL, 214, NULL, 'cupin_9', 283687),
(464594, 'SM00431', NULL, NULL, 113, NULL, 'ler4', 283688),
(464595, 'SM00525', NULL, NULL, 21, NULL, 'ccc3', 283689),
(464596, 'SM01020', NULL, NULL, 125, NULL, 'B2_adapt_app_C_2', 283690),
(464597, 'SM00836', NULL, NULL, 133, NULL, 'dalr_1_4', 283691),
(464598, 'SM01258', NULL, NULL, 45, NULL, 'KRBA1_2', 283692),
(464599, 'SM01175', NULL, NULL, 215, NULL, 'DUF4206_2', 283693),
(464600, 'SM00082', NULL, NULL, 55, NULL, 'lrrct1', 283694),
(464601, 'SM00335', NULL, NULL, 53, NULL, 'annex3', 283695),
(464602, 'SM00428', NULL, NULL, 105, NULL, 'h35', 283696),
(464603, 'SM00642', NULL, NULL, 547, NULL, 'aamy', 283697),
(464604, 'SM01377', NULL, NULL, 53, NULL, 'Ribosomal_L40e_3', 283698),
(464605, 'SM01189', NULL, NULL, 95, NULL, 'ELM2_2', 283699),
(464606, 'SM00348', NULL, NULL, 118, NULL, 'irfvirus2', 283700),
(464607, 'SM00933', NULL, NULL, 286, NULL, 'NurA_2_a', 283701),
(464608, 'SM01328', NULL, NULL, 114, NULL, 'zf_3CxxC_2', 283702),
(464609, 'SM00740', NULL, NULL, 67, NULL, '2pasta', 283703),
(464610, 'SM01056', NULL, NULL, 266, NULL, 'Candida_ALS_N_2', 283704),
(464611, 'SM00071', NULL, NULL, 104, NULL, 'galanin', 283705),
(464612, 'SM01384', NULL, NULL, 194, NULL, 'Ribosomal_L15e_2', 283706),
(464613, 'SM01013', NULL, NULL, 63, NULL, 'APC2_2', 283707),
(464614, 'SM00100', NULL, NULL, 123, NULL, 'cnmp_10', 283708),
(464615, 'SM00890', NULL, NULL, 63, NULL, 'EKR_2', 283709),
(464616, 'SM01051', NULL, NULL, 144, NULL, 'CAMSAP_CKK_2', 283710),
(464617, 'SM00710', NULL, NULL, 22, NULL, 'pbh1', 283711),
(464618, 'SM00766', NULL, NULL, 136, NULL, 'dnag_dnab_bind_seq8d', 283712),
(464619, 'SM00391', NULL, NULL, 87, NULL, 'TAM_2', 283713),
(464620, 'SM01291', NULL, NULL, 178, NULL, 'N_SET_2', 283714),
(464621, 'SM00466', NULL, NULL, 179, NULL, 'G9a_1', 283715),
(464622, 'SM01271', NULL, NULL, 108, NULL, 'LSM14_2', 283716),
(464623, 'SM01380', NULL, NULL, 91, NULL, 'Ribosomal_L31e_2', 283717),
(464624, 'SM01230', NULL, NULL, 336, NULL, 'Gln_synt_C_2', 283718),
(464625, 'SM00386', NULL, NULL, 34, NULL, 'hat_new_1', 283719),
(464626, 'SM00549', NULL, NULL, 94, NULL, 'nervy_1', 283720),
(464627, 'SM01022', NULL, NULL, 143, NULL, 'ASCH_2', 283721),
(464628, 'SM01413', NULL, NULL, 142, NULL, 'Ribosomal_S19e_2', 283722),
(464629, 'SM00031', NULL, NULL, 83, NULL, 'ded_6', 283723),
(464630, 'SM00813', NULL, NULL, 226, NULL, 'alpha_l_af_c', 283724),
(464631, 'SM01050', NULL, NULL, 153, NULL, 'CactinC_cactus_3', 283725),
(464632, 'SM01173', NULL, NULL, 57, NULL, 'DUF4187_2', 283726),
(464633, 'SM01197', NULL, NULL, 78, NULL, 'FANCL_C_2', 283727),
(464634, 'SM01354', NULL, NULL, 181, NULL, 'BLVR_2', 283728),
(464635, 'SM00543', NULL, NULL, 227, NULL, 'if4_15', 283729),
(464636, 'SM00287', NULL, NULL, 69, NULL, 'sh3_bac_9', 283730),
(464637, 'SM00427', NULL, NULL, 97, NULL, 'h2b3', 283731),
(464638, 'SM00266', NULL, NULL, 76, NULL, 'CAD_1', 283732),
(464639, 'SM01093', NULL, NULL, 72, NULL, 'CP12_2', 283733),
(464640, 'SM00205', NULL, NULL, 224, NULL, 'tha2', 283734),
(464641, 'SM00382', NULL, NULL, 92, NULL, 'AAA_5', 283735),
(464642, 'SM01125', NULL, NULL, 87, NULL, 'DCP2_2', 283736),
(464643, 'SM00430', NULL, NULL, 158, NULL, 'holi', 283737),
(464644, 'SM00577', NULL, NULL, 173, NULL, 'forpap2', 283738),
(464645, 'SM00692', NULL, NULL, 69, NULL, 'dm3', 283739),
(464646, 'SM00902', NULL, NULL, 64, NULL, 'Fe_hyd_SSU_2', 283740),
(464647, 'SM00895', NULL, NULL, 107, NULL, 'FCD_2', 283741),
(464648, 'SM00589', NULL, NULL, 56, NULL, '2212neu4', 283742),
(464649, 'SM01204', NULL, NULL, 173, NULL, 'FIST_C_2', 283743),
(464650, 'SM00470', NULL, NULL, 104, NULL, 'ParB_7', 283744),
(464651, 'SM00086', NULL, NULL, 43, NULL, 'pac_2', 283745),
(464652, 'SM00063', NULL, NULL, 130, NULL, 'FRI_4', 283746);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(464653, 'SM00708', NULL, NULL, 119, NULL, 'phbp', 283747),
(464654, 'SM00449', NULL, NULL, 145, NULL, 'SPRY_3', 283748),
(464655, 'SM01366', NULL, NULL, 31, NULL, 'c_clamp_2', 283749),
(464656, 'SM00026', NULL, NULL, 196, NULL, 'ependymin2', 283750),
(464657, 'SM00814', NULL, NULL, 368, NULL, 'alpha_tif', 283751),
(464658, 'SM00358', NULL, NULL, 68, NULL, 'DRBM_3', 283752),
(464659, 'SM01301', NULL, NULL, 175, NULL, 'PTPlike_phytase_2', 283753),
(464660, 'SM01336', NULL, NULL, 88, NULL, 'zf_PARP_3', 283754),
(464661, 'SM00225', NULL, NULL, 114, NULL, 'BTB_4', 283755),
(464662, 'SM00532', NULL, NULL, 459, NULL, 'ligaN3', 283756),
(464663, 'SM00879', NULL, NULL, 301, NULL, 'Brix_2', 283757),
(464664, 'SM00343', NULL, NULL, 17, NULL, 'c2hcfinal6', 283758),
(464665, 'SM01186', NULL, NULL, 136, NULL, 'eIF3_N_2', 283759),
(464666, 'SM01289', NULL, NULL, 85, NULL, 'PYRIN_2', 283760),
(464667, 'SM00222', NULL, NULL, 226, NULL, 'sec7_5', 283761),
(464668, 'SM00630', NULL, NULL, 532, NULL, 'sema', 283762),
(464669, 'SM00400', NULL, NULL, 55, NULL, 'primzinc3', 283763),
(464670, 'SM00778', NULL, NULL, 41, NULL, 'prim_zn_ribbon', 283764),
(464671, 'SM00667', NULL, NULL, 33, NULL, 'Lish', 283765),
(464672, 'SM00999', NULL, NULL, 387, NULL, 'Aerolysin_2', 283766),
(464673, 'SM00553', NULL, NULL, 96, NULL, 'faf_3', 283767),
(464674, 'SM00127', NULL, NULL, 146, NULL, 'IL7_1', 283768),
(464675, 'SM00437', NULL, NULL, 309, NULL, 'topIaneu2', 283769),
(464676, 'SM00899', NULL, NULL, 90, NULL, 'FeoA_2', 283770),
(464677, 'SM00349', NULL, NULL, 62, NULL, 'krabfinus', 283771),
(464678, 'SM00098', NULL, NULL, 541, NULL, 'alk_phosph_2', 283772),
(464679, 'SM00454', NULL, NULL, 67, NULL, 'SAM_4', 283773),
(464680, 'SM01216', NULL, NULL, 533, NULL, 'Fmp27_WPPW_2', 283774),
(464681, 'SM00883', NULL, NULL, 103, NULL, 'Cpn10_2', 283775),
(464682, 'SM00034', NULL, NULL, 141, NULL, 'CLECT_2', 283776),
(464683, 'SM00715', NULL, NULL, 92, NULL, 'la', 283777),
(464684, 'SM00696', NULL, NULL, 73, NULL, 'dm9', 283778),
(464685, 'SM00903', NULL, NULL, 182, NULL, 'Flavin_Reduct_2', 283779),
(464686, 'SM00797', NULL, NULL, 284, NULL, 'ahs2', 283780),
(464687, 'SM00640', NULL, NULL, 583, NULL, 'glyco_32', 283781),
(464688, 'SM01272', NULL, NULL, 74, NULL, 'LsmAD_2', 283782),
(464689, 'SM00980', NULL, NULL, 89, NULL, 'THAP_2', 283783),
(464690, 'SM01257', NULL, NULL, 189, NULL, 'KRAP_IP3R_bind_2', 283784),
(464691, 'SM01085', NULL, NULL, 237, NULL, 'CK_II_beta_2', 283785),
(464692, 'SM01324', NULL, NULL, 89, NULL, 'YARHG_2', 283786),
(464693, 'SM00658', NULL, NULL, 163, NULL, 'rpol8neu', 283787),
(464694, 'SM00830', NULL, NULL, 90, NULL, 'CM_2_4', 283788),
(464695, 'SM00954', NULL, NULL, 132, NULL, 'RelA_SpoT_2', 283789),
(464696, 'SM00914', NULL, NULL, 37, NULL, 'IDEAL_2', 283790),
(464697, 'SM01306', NULL, NULL, 219, NULL, 'RFX5_DNA_bdg_2', 283791),
(464698, 'SM00898', NULL, NULL, 209, NULL, 'Fapy_DNA_glyco_2', 283792),
(464699, 'SM00880', NULL, NULL, 281, NULL, 'CHAD_3', 283793),
(464700, 'SM00139', NULL, NULL, 166, NULL, 'MyTH4_1', 283794),
(464701, 'SM00095', NULL, NULL, 121, NULL, 'transthy-fin', 283795),
(464702, 'SM00656', NULL, NULL, 267, NULL, 'amb_all', 283796),
(464703, 'SM01385', NULL, NULL, 61, NULL, 'DSS1_SEM1_2', 283797),
(464704, 'SM00714', NULL, NULL, 77, NULL, 'litaf', 283798),
(464705, 'SM00725', NULL, NULL, 133, NULL, 'neat', 283799),
(464706, 'SM00146', NULL, NULL, 336, NULL, 'pi3k_hr1_6', 283800),
(464707, 'SM01149', NULL, NULL, 438, NULL, 'DUF1237_2a', 283801),
(464708, 'SM00539', NULL, NULL, 185, NULL, 'ylk_9', 283802),
(464709, 'SM00963', NULL, NULL, 95, NULL, 'SRP54_N_2', 283803),
(464710, 'SM00700', NULL, NULL, 243, NULL, 'jhbp', 283804),
(464711, 'SM00020', NULL, NULL, 226, NULL, 'trypsin_2', 283805),
(464712, 'SM01030', NULL, NULL, 61, NULL, 'BHD_1_2', 283806),
(464713, 'SM00949', NULL, NULL, 159, NULL, 'PAZ_2_a_3', 283807),
(464714, 'SM00407', NULL, NULL, 78, NULL, 'igc1_4', 283808),
(464715, 'SM01005', NULL, NULL, 137, NULL, 'Ala_racemase_C_2', 283809),
(464716, 'SM01210', NULL, NULL, 109, NULL, 'GARS_C_2', 283810);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(464717, 'SM00541', NULL, NULL, 46, NULL, 'fyrn_3', 283811),
(464718, 'SM00662', NULL, NULL, 298, NULL, 'rpoldneu2', 283812),
(464719, 'SM00408', NULL, NULL, 56, NULL, 'igc2_5', 283813),
(464720, 'SM00047', NULL, NULL, 184, NULL, 'Lysozyme_4', 283814),
(464721, 'SM00064', NULL, NULL, 81, NULL, 'fyve_4', 283815),
(464722, 'SM00881', NULL, NULL, 125, NULL, 'CoA_binding_2', 283816),
(464723, 'SM01063', NULL, NULL, 96, NULL, 'CBM49_2', 283817),
(464724, 'SM00066', NULL, NULL, 45, NULL, 'gal4_2', 283818),
(464725, 'SM00240', NULL, NULL, 49, NULL, 'FHA_2', 283819),
(464726, 'SM00488', NULL, NULL, 447, NULL, 'deadxpd', 283820),
(464727, 'SM00023', NULL, NULL, 95, NULL, 'colipase2', 283821),
(464728, 'SM01243', NULL, NULL, 187, NULL, 'IRF_3_2', 283822),
(464729, 'SM00091', NULL, NULL, 68, NULL, 'pas_2', 283823),
(464730, 'SM00456', NULL, NULL, 34, NULL, 'ww_5', 283824),
(464731, 'SM00893', NULL, NULL, 231, NULL, 'ETF_2', 283825),
(464732, 'SM00141', NULL, NULL, 91, NULL, 'PDGF_2', 283826),
(464733, 'SM00394', NULL, NULL, 39, NULL, 'akam_3', 283827),
(464734, 'SM00088', NULL, NULL, 92, NULL, 'PINT_4', 283828),
(464735, 'SM01375', NULL, NULL, 107, NULL, 'Dynein_light_2', 283829),
(464736, 'SM00291', NULL, NULL, 46, NULL, 'zz_5', 283830),
(464737, 'SM01281', NULL, NULL, 64, NULL, 'Med12_2', 283831),
(464738, 'SM00193', NULL, NULL, 80, NULL, 'PTN_2', 283832),
(464739, 'SM01229', NULL, NULL, 52, NULL, 'GluR_Homer_bdg_2', 283833),
(464740, 'SM01144', NULL, NULL, 218, NULL, 'DTW_2a', 283834),
(464741, 'SM01280', NULL, NULL, 399, NULL, 'Mcm10_2', 283835),
(464742, 'SM00544', NULL, NULL, 117, NULL, 'ma3_7', 283836),
(464743, 'SM01339', NULL, NULL, 64, NULL, 'NODP_2', 283837),
(464744, 'SM00985', NULL, NULL, 146, NULL, 'UBA_e1_C_a_2', 283838),
(464745, 'SM01309', NULL, NULL, 119, NULL, 'RICTOR_phospho_2', 283839),
(464746, 'SM00320', NULL, NULL, 46, NULL, 'WD40_4', 283840),
(464747, 'SM01121', NULL, NULL, 333, NULL, 'Dak1_2_2', 283841),
(464748, 'SM00183', NULL, NULL, 24, NULL, 'natb', 283842),
(464749, 'SM00861', NULL, NULL, 265, NULL, 'Transket_pyr_3', 283843),
(464750, 'SM00258', NULL, NULL, 76, NULL, 'SAND_2', 283844),
(464751, 'SM01294', NULL, NULL, 67, NULL, '17clusters_betabranch_W', 283845),
(464752, 'SM00022', NULL, NULL, 626, NULL, 'pla2_6', 283846),
(464753, 'SM00515', NULL, NULL, 92, NULL, '542_3', 283847),
(464754, 'SM00344', NULL, NULL, 112, NULL, 'asnc', 283848),
(464755, 'SM00299', NULL, NULL, 161, NULL, 'CLH_2', 283849),
(464756, 'SM00099', NULL, NULL, 110, NULL, 'btg1_nr', 283850),
(464757, 'SM00906', NULL, NULL, 59, NULL, 'Fungal_trans_2', 283851),
(464758, 'SM00357', NULL, NULL, 70, NULL, 'csp_8', 283852),
(464759, 'SM00523', NULL, NULL, 124, NULL, 'dwAneu5', 283853),
(464760, 'SM00818', NULL, NULL, 187, NULL, 'amelogenin', 283854),
(464761, 'SM00281', NULL, NULL, 144, NULL, 'LamB_3a', 283855),
(464762, 'SM00785', NULL, NULL, 89, NULL, 'aarp2cn2', 283856),
(464763, 'SM01011', NULL, NULL, 171, NULL, 'AMP_N_2', 283857),
(464764, 'SM00495', NULL, NULL, 52, NULL, 'chi_5', 283858),
(464765, 'SM01069', NULL, NULL, 118, NULL, 'CDC37_C_2', 283859),
(464766, 'SM00203', NULL, NULL, 11, NULL, 'tach2_nr', 283860),
(464767, 'SM00606', NULL, NULL, 155, NULL, 'cbd', 283861),
(464768, 'SM00750', NULL, NULL, 242, NULL, 'kind', 283862),
(464769, 'SM00810', NULL, NULL, 62, NULL, 'alpha-amyl_c2', 283863),
(464770, 'SM00444', NULL, NULL, 59, NULL, 'gyf_5', 283864),
(464771, 'SM01379', NULL, NULL, 115, NULL, 'GAGE_2', 283865),
(464772, 'SM00755', NULL, NULL, 50, NULL, '1grip', 283866),
(464773, 'SM00415', NULL, NULL, 115, NULL, 'hsfneu3', 283867),
(464774, 'SM00351', NULL, NULL, 125, NULL, 'pax3', 283868),
(464775, 'SM00199', NULL, NULL, 65, NULL, 'SCY_2', 283869),
(464776, 'SM00580', NULL, NULL, 66, NULL, 'PGNneu', 283870),
(464777, 'SM00186', NULL, NULL, 262, NULL, 'FBG_2', 283871),
(464778, 'SM00730', NULL, NULL, 348, NULL, 'psh_8', 283872),
(464779, 'SM00037', NULL, NULL, 34, NULL, 'CNX_2', 283873),
(464780, 'SM00941', NULL, NULL, 75, NULL, 'PYNP_C_2', 283874),
(464781, 'SM00314', NULL, NULL, 102, NULL, 'RA_5', 283875);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(464782, 'SM00770', NULL, NULL, 338, NULL, 'Zn_dep_PLPC_cls', 283876),
(464783, 'SM00807', NULL, NULL, 971, NULL, 'akap_110', 283877),
(464784, 'SM00401', NULL, NULL, 54, NULL, 'GATA_3', 283878),
(464785, 'SM00464', NULL, NULL, 241, NULL, 'lon_5', 283879),
(464786, 'SM01397', NULL, NULL, 213, NULL, 'Ribosomal_S3Ae_2', 283880),
(464787, 'SM00338', NULL, NULL, 65, NULL, 'brlzneu', 283881),
(464788, 'SM01259', NULL, NULL, 72, NULL, 'LAB_N_2', 283882),
(464789, 'SM00364', NULL, NULL, 20, NULL, 'LRR_bac_2', 283883),
(464790, 'SM00924', NULL, NULL, 106, NULL, 'MgtE_N_2', 283884),
(464791, 'SM00749', NULL, NULL, 64, NULL, 'bon', 283885),
(464792, 'SM00911', NULL, NULL, 87, NULL, 'HWE_HK_2', 283886),
(464793, 'SM01021', NULL, NULL, 252, NULL, 'Bac_rhodopsin_2', 283887),
(464794, 'SM00005', NULL, NULL, 108, NULL, 'DEATH_4', 283888),
(464795, 'SM00742', NULL, NULL, 71, NULL, 'hr1_7', 283889),
(464796, 'SM00341', NULL, NULL, 81, NULL, 'hrdc7', 283890),
(464797, 'SM00952', NULL, NULL, 60, NULL, 'RAP_3', 283891),
(464798, 'SM00520', NULL, NULL, 111, NULL, 'basic', 283892),
(464799, 'SM00945', NULL, NULL, 118, NULL, 'ProQ_a_2', 283893),
(464800, 'SM00265', NULL, NULL, 27, NULL, 'bh4_2', 283894),
(464801, 'SM00516', NULL, NULL, 184, NULL, 'sec14_4', 283895),
(464802, 'SM01250', NULL, NULL, 340, NULL, 'KAT11_2', 283896),
(464803, 'SM00583', NULL, NULL, 118, NULL, 'backtest2', 283897),
(464804, 'SM00097', NULL, NULL, 345, NULL, 'wnt1_3', 283898),
(464805, 'SM00502', NULL, NULL, 132, NULL, 'RAD_5', 283899),
(464806, 'SM00422', NULL, NULL, 72, NULL, 'merrmega3', 283900),
(464807, 'SM00136', NULL, NULL, 282, NULL, 'LamNT_2', 283901),
(464808, 'SM01358', NULL, NULL, 270, NULL, 'HBM_sequencesselection_2', 283902),
(464809, 'SM00858', NULL, NULL, 101, NULL, 'SAF_3', 283903),
(464810, 'SM00439', NULL, NULL, 163, NULL, 'BAH_4', 283904),
(464811, 'SM00094', NULL, NULL, 383, NULL, 'transfer-fin', 283905),
(464812, 'SM00188', NULL, NULL, 137, NULL, 'int10', 283906),
(464813, 'SM00450', NULL, NULL, 94, NULL, 'rhod_4', 283907),
(464814, 'SM01224', NULL, NULL, 87, NULL, 'G_gamma_2', 283908),
(464815, 'SM00657', NULL, NULL, 136, NULL, 'rpol4neu2', 283909),
(464816, 'SM00289', NULL, NULL, 48, NULL, 'WR1_2', 283910),
(464817, 'SM01023', NULL, NULL, 89, NULL, 'BAF_2', 283911),
(464818, 'SM00215', NULL, NULL, 105, NULL, 'vwc2', 283912),
(464819, 'SM01096', NULL, NULL, 124, NULL, 'CPSase_L_D3_2', 283913),
(464820, 'SM00596', NULL, NULL, 92, NULL, '115neu5', 283914),
(464821, 'SM00460', NULL, NULL, 90, NULL, 'TG_5', 283915),
(464822, 'SM01008', NULL, NULL, 136, NULL, 'Ald_Xan_dh_C_2', 283916),
(464823, 'SM01044', NULL, NULL, 150, NULL, 'Btz_2', 283917),
(464824, 'SM00184', NULL, NULL, 23, NULL, 'ring_2', 283918),
(464825, 'SM00227', NULL, NULL, 31, NULL, 'nebu_4', 283919),
(464826, 'SM01161', NULL, NULL, 98, NULL, 'DUF1767_2', 283920),
(464827, 'SM01073', NULL, NULL, 98, NULL, 'CDC48_N_2', 283921),
(464828, 'SM00874', NULL, NULL, 106, NULL, 'B5_2', 283922),
(464829, 'SM00128', NULL, NULL, 435, NULL, 'i5p_5', 283923),
(464830, 'SM00823', NULL, 'Phosphopantetheine attachment site', 146, NULL, 'PKS_PP', 283924),
(464831, 'SM00524', NULL, NULL, 212, NULL, 'dwBultra2', 283925),
(464832, 'SM00359', NULL, NULL, 86, NULL, 'pua_5', 283926),
(464833, 'SM00632', NULL, NULL, 96, NULL, 'Aamy_c', 283927),
(464834, 'SM01238', NULL, NULL, 61, NULL, 'IGR_2', 283928),
(464835, 'SM00562', NULL, NULL, 142, NULL, 'ndk_5', 283929),
(464836, 'SM00019', NULL, NULL, 191, NULL, 'surpal', 283930),
(464837, 'SM00442', NULL, NULL, 138, NULL, 'FGF_2', 283931),
(464838, 'SM00834', NULL, NULL, 45, NULL, 'CxxC_CXXC_SSSS_2', 283932),
(464839, 'SM00864', NULL, NULL, 232, NULL, 'Tubulin_4', 283933),
(464840, 'SM00540', NULL, NULL, 44, NULL, 'lem_2', 283934),
(464841, 'SM00354', NULL, NULL, 72, NULL, 'laci3', 283935),
(464842, 'SM00950', NULL, NULL, 356, NULL, 'Piwi_a_2', 283936),
(464843, 'SM00253', NULL, NULL, 46, NULL, 'socs_2', 283937),
(464844, 'SM00940', NULL, NULL, 160, NULL, 'PepX_N_2', 283938),
(464845, 'SM00717', NULL, NULL, 53, NULL, 'sant', 283939);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(464846, 'SM01080', NULL, NULL, 338, NULL, 'CHASE2_2', 283940),
(464847, 'SM01006', NULL, NULL, 52, NULL, 'AlcB_2', 283941),
(464848, 'SM01187', NULL, NULL, 98, NULL, 'Elicitin_2', 283942),
(464849, 'SM00459', NULL, NULL, 55, NULL, 'sorbin_1', 283943),
(464850, 'SM00424', NULL, NULL, 111, NULL, 'ste', 283944),
(464851, 'SM01282', NULL, NULL, 144, NULL, 'DBB_2', 283945),
(464852, 'SM01242', NULL, NULL, 98, NULL, 'Integrin_B_tail_2', 283946),
(464853, 'SM00288', NULL, NULL, 145, NULL, 'VHS_2', 283947),
(464854, 'SM00303', NULL, NULL, 51, NULL, 'GPS_3', 283948),
(464855, 'SM00108', NULL, NULL, 126, NULL, 'blect_4', 283949),
(464856, 'SM00179', NULL, NULL, 34, NULL, 'egfca_6', 283950),
(464857, 'SM00101', NULL, NULL, 249, NULL, '1433_4', 283951),
(464858, 'SM00684', NULL, NULL, 42, NULL, 'dm15', 283952),
(464859, 'SM00030', NULL, NULL, 219, NULL, 'clus1b', 283953),
(464860, 'SM01042', NULL, NULL, 138, NULL, 'Brr6_like_C_C_2', 283954),
(464861, 'SM00276', NULL, NULL, 138, NULL, 'galectin_3', 283955),
(464862, 'SM00079', NULL, NULL, 296, NULL, 'GluR_14', 283956),
(464863, 'SM00560', NULL, NULL, 197, NULL, 'LamGL_3', 283957),
(464864, 'SM01249', NULL, NULL, 59, NULL, 'KASH_2', 283958),
(464865, 'SM00509', NULL, NULL, 82, NULL, 'TFS2_5', 283959),
(464866, 'SM00652', NULL, NULL, 92, NULL, 'eIF1neu4', 283960),
(464867, 'SM01045', NULL, NULL, 232, NULL, 'BURP_2', 283961),
(464868, 'SM00526', NULL, NULL, 70, NULL, 'h15plus2', 283962),
(464869, 'SM00530', NULL, NULL, 56, NULL, 'mbf_short4', 283963),
(464870, 'SM01284', NULL, NULL, 130, NULL, 'ECIST_Cterm_2', 283964),
(464871, 'SM00978', NULL, NULL, 167, NULL, 'Tim44_a_2', 283965),
(464872, 'SM01370', NULL, NULL, 173, NULL, 'TAFII55_N_2', 283966),
(464873, 'SM01221', NULL, NULL, 148, NULL, 'FTCD_2', 283967),
(464874, 'SM00015', NULL, NULL, 23, NULL, 'iq_5', 283968),
(464875, 'SM01369', NULL, NULL, 157, NULL, 'Rb_C_2', 283969),
(464876, 'SM00339', NULL, NULL, 99, NULL, 'forkneu4', 283970),
(464877, 'SM01026', NULL, NULL, 304, NULL, 'Beach_2', 283971),
(464878, 'SM01206', NULL, NULL, 243, NULL, 'Fibrillarin_2', 283972),
(464879, 'SM00412', NULL, NULL, 40, NULL, 'copper1', 283973),
(464880, 'SM00689', NULL, NULL, 171, NULL, 'dm6', 283974),
(464881, 'SM01326', NULL, NULL, 170, NULL, 'PTEN_C2_2', 283975),
(464882, 'SM00173', NULL, NULL, 167, NULL, 'ras_sub_4', 283976),
(464883, 'SM00676', NULL, NULL, 126, NULL, 'dm10', 283977),
(464884, 'SM00638', NULL, NULL, 791, NULL, 'lpd_n', 283978),
(464885, 'SM01048', NULL, NULL, 112, NULL, 'C6_2', 283979),
(464886, 'SM00728', NULL, NULL, 46, NULL, 'chw', 283980),
(464887, 'SM01067', NULL, NULL, 99, NULL, 'CBM_3_2', 283981),
(464888, 'SM01329', NULL, NULL, 432, NULL, 'Iso_dh_2', 283982),
(464889, 'SM01268', NULL, NULL, 249, NULL, 'BTD_2', 283983),
(464890, 'SM01060', NULL, NULL, 392, NULL, 'Catalase_2', 283984),
(464891, 'SM00534', NULL, NULL, 199, NULL, 'mutATP5', 283985),
(464892, 'SM00986', NULL, NULL, 125, NULL, 'UDG_2', 283986),
(464893, 'SM00935', NULL, NULL, 157, NULL, 'OmpH_2', 283987),
(464894, 'SM00310', NULL, NULL, 109, NULL, 'PTBI_2', 283988),
(464895, 'SM00216', NULL, NULL, 185, NULL, 'VWD_2', 283989),
(464896, 'SM01290', NULL, NULL, 210, NULL, 'N_glycanase_N_2', 283990),
(464897, 'SM01373', NULL, NULL, 195, NULL, 'MAGE_2', 283991),
(464898, 'SM01001', NULL, NULL, 154, NULL, 'AIRC_2', 283992),
(464899, 'SM00132', NULL, NULL, 52, NULL, 'lim_4', 283993),
(464900, 'SM00777', NULL, NULL, 133, NULL, 'mad3_bub1_i', 283994),
(464901, 'SM00832', NULL, NULL, 78, NULL, 'c8_a', 283995),
(464902, 'SM00787', NULL, NULL, 335, NULL, 'spc73', 283996),
(464903, 'SM00028', NULL, NULL, 34, NULL, 'tpr_5', 283997),
(464904, 'SM00237', NULL, NULL, 106, NULL, 'NIbeta_1', 283998),
(464905, 'SM00762', NULL, NULL, 377, NULL, 'cog4.2seq4', 283999),
(464906, 'SM01416', NULL, NULL, 144, NULL, 'Ribosomal_L19e_2', 284000),
(464907, 'SM00282', NULL, NULL, 137, NULL, 'LamG_3', 284001),
(464908, 'SM00719', NULL, NULL, 120, NULL, 'rtf1', 284002),
(464909, 'SM00845', NULL, NULL, 154, NULL, 'gatb_yqey_2', 284003),
(464910, 'SM00327', NULL, NULL, 193, NULL, 'VWA_4', 284004);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(464911, 'SM01091', NULL, NULL, 110, NULL, 'CorC_HlyC_2', 284005),
(464912, 'SM01148', NULL, NULL, 73, NULL, 'DUF1220_2', 284006),
(464913, 'SM00582', NULL, NULL, 146, NULL, '558neu5', 284007),
(464914, 'SM00075', NULL, NULL, 98, NULL, 'hydro', 284008),
(464915, 'SM00936', NULL, NULL, 107, NULL, 'PBP5_C_2', 284009),
(464916, 'SM00693', NULL, NULL, 73, NULL, 'dysfn', 284010),
(464917, 'SM00250', NULL, NULL, 39, NULL, 'plec_5', 284011),
(464918, 'SM00213', NULL, NULL, 72, NULL, 'ubq_7', 284012),
(464919, 'SM00602', NULL, NULL, 735, NULL, 'vps10', 284013),
(464920, 'SM00764', NULL, NULL, 188, NULL, 'citrate_ly_lig5', 284014),
(464921, 'SM01246', NULL, NULL, 192, NULL, 'Josephin_2', 284015),
(464922, 'SM00479', NULL, NULL, 196, NULL, 'exoiiiendus', 284016),
(464923, 'SM00815', NULL, NULL, 536, NULL, 'ama_1', 284017),
(464924, 'SM00979', NULL, NULL, 36, NULL, 'tify_2', 284018),
(464925, 'SM00390', NULL, NULL, 23, NULL, 'LGN_4', 284019),
(464926, 'SM00165', NULL, NULL, 38, NULL, 'uba_6', 284020),
(464927, 'SM00521', NULL, NULL, 62, NULL, 'cbf3', 284021),
(464928, 'SM00181', NULL, NULL, 32, NULL, 'egf_5', 284022),
(464929, 'SM01389', NULL, NULL, 81, NULL, 'Spt4_2', 284023),
(464930, 'SM00393', NULL, NULL, 83, NULL, 'R3H_4', 284024),
(464931, 'SM01163', NULL, NULL, 46, NULL, 'DUF1785_2', 284025),
(464932, 'SM00894', NULL, NULL, 38, NULL, 'Excalibur_2', 284026),
(464933, 'SM00812', NULL, NULL, 443, NULL, 'alpha_l_fucos', 284027),
(464934, 'SM00529', NULL, NULL, 101, NULL, 'dtx3', 284028),
(464935, 'SM00204', NULL, NULL, 102, NULL, 'TGFB_2', 284029),
(464936, 'SM01099', NULL, NULL, 72, NULL, 'CPW_WPC_2', 284030),
(464937, 'SM01174', NULL, NULL, 438, NULL, 'DUF4205_3', 284031),
(464938, 'SM00788', NULL, NULL, 422, NULL, 'adenylsucc_synt', 284032),
(464939, 'SM00328', NULL, NULL, 261, NULL, 'bpi1_3', 284033),
(464940, 'SM00286', NULL, NULL, 29, NULL, 'PTI_1', 284034),
(464941, 'SM00839', NULL, NULL, 265, NULL, 'ELFV_dehydrog_3', 284035),
(464942, 'SM00643', NULL, NULL, 124, NULL, 'c345c', 284036),
(464943, 'SM00432', NULL, NULL, 60, NULL, 'madsneu2', 284037),
(464944, 'SM01038', NULL, NULL, 308, NULL, 'Bgal_small_N_2', 284038),
(464945, 'SM00156', NULL, NULL, 321, NULL, 'pp2a_7', 284039),
(464946, 'SM00930', NULL, NULL, 85, NULL, 'NIL_2', 284040),
(464947, 'SM01139', NULL, NULL, 257, NULL, 'Drf_FH3_2', 284041),
(464948, 'SM00471', NULL, NULL, 59, NULL, 'hd_13', 284042),
(464949, 'SM00835', NULL, NULL, 162, NULL, 'Cupin_1_3', 284043),
(464950, 'SM00593', NULL, NULL, 68, NULL, '893paper3', 284044),
(464951, 'SM01098', NULL, NULL, 267, NULL, 'CPSF73_100_C_2', 284045),
(464952, 'SM00312', NULL, NULL, 142, NULL, 'PX_2', 284046),
(464953, 'SM01203', NULL, NULL, 163, NULL, 'DUF3585_4', 284047),
(464954, 'SM01241', NULL, NULL, 49, NULL, 'Integrin_b_cyt_2', 284048),
(464955, 'SM01083', NULL, NULL, 37, NULL, 'Cir_N_3', 284049),
(464956, 'SM00679', NULL, NULL, 32, NULL, 'ctns', 284050),
(464957, 'SM00508', NULL, NULL, 17, NULL, 'PostSET_3', 284051),
(464958, 'SM01061', NULL, NULL, 59, NULL, 'CAT_RBD_2', 284052),
(464959, 'SM01076', NULL, NULL, 124, NULL, 'CG_1_2', 284053),
(464960, 'SM01222', NULL, NULL, 192, NULL, 'FTCD_N_2', 284054),
(464961, 'SM00680', NULL, NULL, 62, NULL, 'clip', 284055),
(464962, 'SM01261', NULL, NULL, 49, NULL, 'Thymopoietin_2', 284056),
(464963, 'SM00587', NULL, NULL, 203, NULL, '121neu2hmm', 284057),
(464964, 'SM00536', NULL, NULL, 133, NULL, 'toby4', 284058),
(464965, 'SM00191', NULL, NULL, 56, NULL, 'int_alpha_rpt', 284059),
(464966, 'SM01414', NULL, NULL, 36, NULL, 'P68HR_2', 284060),
(464967, 'SM00827', NULL, 'Acyl transferase domain in polyketide synthase (PKS) enzymes.', 382, NULL, 'PKS_AT', 284061),
(464968, 'SM00418', NULL, NULL, 79, NULL, 'arsrmega2', 284062),
(464969, 'SM00665', NULL, NULL, 142, NULL, '561_7', 284063),
(464970, 'SM01359', NULL, NULL, 209, NULL, 'A2M_N_2_2', 284064),
(464971, 'SM01362', NULL, NULL, 306, NULL, 'DUF663_2', 284065),
(464972, 'SM00159', NULL, NULL, 213, NULL, 'PTX_2', 284066),
(464973, 'SM00513', NULL, NULL, 35, NULL, 'sap_9', 284067),
(464974, 'SM00190', NULL, NULL, 148, NULL, 'il4b_nr', 284068);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(464975, 'SM00256', NULL, NULL, 41, NULL, 'fbox_2', 284069),
(464976, 'SM01410', NULL, NULL, 135, NULL, 'DIM1_2', 284070),
(464977, 'SM01211', NULL, NULL, 300, NULL, 'GATase_5_2', 284071),
(464978, 'SM01134', NULL, NULL, 163, NULL, 'DeoRC_2', 284072),
(464979, 'SM00545', NULL, NULL, 45, NULL, 'JmjN_1', 284073),
(464980, 'SM01341', NULL, NULL, 42, NULL, 'Tower_2', 284074),
(464981, 'SM01218', NULL, NULL, 94, NULL, 'FoP_duplication_2', 284075),
(464982, 'SM00561', NULL, NULL, 121, NULL, 'l3mbt_4', 284076),
(464983, 'SM00875', NULL, NULL, 133, NULL, 'BACK_2', 284077),
(464984, 'SM00919', NULL, NULL, 300, NULL, 'Malic_M_2', 284078),
(464985, 'SM01371', NULL, NULL, 466, NULL, 'TFIIA_2', 284079),
(464986, 'SM00795', NULL, NULL, 783, NULL, 'agro_vird5', 284080),
(464987, 'SM00962', NULL, NULL, 257, NULL, 'SRP54_3', 284081),
(464988, 'SM00817', NULL, NULL, 422, NULL, 'amelin', 284082),
(464989, 'SM00317', NULL, NULL, 114, NULL, 'set_7', 284083),
(464990, 'SM00942', NULL, NULL, 71, NULL, 'PriCT_1_2', 284084),
(464991, 'SM00897', NULL, NULL, 191, NULL, 'FIST_2', 284085),
(464992, 'SM01016', NULL, NULL, 97, NULL, 'Arg_tRNA_synt_N_2', 284086),
(464993, 'SM01017', NULL, NULL, 139, NULL, 'Arrestin_C_2', 284087),
(464994, 'SM00308', NULL, NULL, 157, NULL, 'LH2_4', 284088),
(464995, 'SM00876', NULL, NULL, 123, NULL, 'BATS_2', 284089),
(464996, 'SM00674', NULL, NULL, 72, NULL, 'cenpb', 284090),
(464997, 'SM01296', NULL, NULL, 358, NULL, 'N2227_2', 284091),
(464998, 'SM00212', NULL, NULL, 144, NULL, 'ubc_7', 284092),
(464999, 'SM00120', NULL, NULL, 51, NULL, 'HX_rpt_3', 284093),
(465000, 'SM01190', NULL, NULL, 267, NULL, 'EMP24_GP25L_2', 284094),
(465001, 'SM01151', NULL, NULL, 64, NULL, 'DUF1518_2', 284095),
(465002, 'SM00712', NULL, NULL, 69, NULL, 'pur', 284096),
(465003, 'SM00873', NULL, NULL, 222, NULL, 'B3_4_2', 284097),
(465004, 'SM00200', NULL, NULL, 130, NULL, 'SEA_3', 284098),
(465005, 'SM00294', NULL, NULL, 19, NULL, '4.1m_4', 284099),
(465006, 'SM00274', NULL, NULL, 25, NULL, 'FOLN_3', 284100),
(465007, 'SM00841', NULL, NULL, 57, NULL, 'Elong_fact_P_C_2', 284101),
(465008, 'SM01316', NULL, NULL, 68, NULL, 'Spo7_2_N_2', 284102),
(465009, 'SM01177', NULL, NULL, 75, NULL, 'DUF4210_2', 284103),
(465010, 'SM00838', NULL, NULL, 88, NULL, 'EFG_C_a', 284104),
(465011, 'SM01355', NULL, NULL, 169, NULL, 'AP3B1_C_2', 284105),
(465012, 'SM00938', NULL, NULL, 117, NULL, 'P_II_3', 284106),
(465013, 'SM00569', NULL, NULL, 62, NULL, 'L27_neu3', 284107),
(465014, 'SM00350', NULL, NULL, 591, NULL, 'mcm', 284108),
(465015, 'SM00125', NULL, NULL, 149, NULL, 'IL1_2', 284109),
(465016, 'SM00732', NULL, NULL, 117, NULL, 'rnase_8s', 284110),
(465017, 'SM01390', NULL, NULL, 145, NULL, 'Ribosomal_S4_2', 284111),
(465018, 'SM00271', NULL, NULL, 72, NULL, 'dnaj_3', 284112),
(465019, 'SM01209', NULL, NULL, 210, NULL, 'GARS_A_3', 284113),
(465020, 'SM00759', NULL, NULL, 95, NULL, 'flu_m1_c2seq2', 284114),
(465021, 'SM00724', NULL, NULL, 230, NULL, 'lag1_27', 284115),
(465022, 'SM00322', NULL, NULL, 63, NULL, 'kh_6', 284116),
(465023, 'SM01407', NULL, NULL, 60, NULL, 'NAC_2', 284117),
(465024, 'SM01074', NULL, NULL, 87, NULL, 'Cdc6_C_2', 284118),
(465025, 'SM00550', NULL, NULL, 72, NULL, '1qbj_4', 284119),
(465026, 'SM00104', NULL, NULL, 37, NULL, 'ANATO_2', 284120),
(465027, 'SM00413', NULL, NULL, 90, NULL, 'etsneu2', 284121),
(465028, 'SM01285', NULL, NULL, 180, NULL, 'FACT_Spt16_Nlob_2', 284122),
(465029, 'SM00783', NULL, NULL, 70, NULL, 'a_amylase_inhib2', 284123),
(465030, 'SM01248', NULL, NULL, 83, NULL, 'KaiB_2', 284124),
(465031, 'SM00872', NULL, NULL, 90, NULL, 'Alpha_mann_mid_2', 284125),
(465032, 'SM00340', NULL, NULL, 44, NULL, 'halz', 284126),
(465033, 'SM00052', NULL, NULL, 255, NULL, 'duf2_2', 284127),
(465034, 'SM01055', NULL, NULL, 93, NULL, 'Cadherin_pro_2', 284128),
(465035, 'SM00487', NULL, NULL, 219, NULL, 'ultradead3', 284129),
(465036, 'SM00887', NULL, NULL, 355, NULL, 'EB_dh_2', 284130),
(465037, 'SM00697', NULL, NULL, 96, NULL, 'dm8', 284131),
(465038, 'SM01123', NULL, NULL, 70, NULL, 'DBP10CT_2', 284132);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(465039, 'SM00527', NULL, NULL, 102, NULL, 'hmg17neu4', 284133),
(465040, 'SM01215', NULL, NULL, 106, NULL, 'Fmp27_SW_2', 284134),
(465041, 'SM00636', NULL, NULL, 521, NULL, '2g34', 284135),
(465042, 'SM00921', NULL, NULL, 80, NULL, 'MHC_II_beta_2', 284136),
(465043, 'SM00217', NULL, NULL, 51, NULL, 'wap2', 284137),
(465044, 'SM00445', NULL, NULL, 107, NULL, 'LINK_2', 284138),
(465045, 'SM01234', NULL, NULL, 75, NULL, 'Haemolytic_2', 284139),
(465046, 'SM01386', NULL, NULL, 59, NULL, 'Ribosomal_S13_N_2', 284140),
(465047, 'SM00006', NULL, NULL, 180, NULL, 'A4_EXTRA_3', 284141),
(465048, 'SM00948', NULL, NULL, 23, NULL, 'Proteasome_A_N_2', 284142),
(465049, 'SM00698', NULL, NULL, 22, NULL, 'morn', 284143),
(465050, 'SM00688', NULL, NULL, 102, NULL, 'dm7', 284144),
(465051, 'SM00705', NULL, NULL, 20, NULL, 'theg', 284145),
(465052, 'SM00992', NULL, NULL, 126, NULL, 'YccV_like_2_a', 284146),
(465053, 'SM01279', NULL, NULL, 51, NULL, 'Matrilin_ccoil_2', 284147),
(465054, 'SM00798', NULL, NULL, 328, NULL, 'aicarft_impchas', 284148),
(465055, 'SM00485', NULL, NULL, 111, NULL, 'xpgn3', 284149),
(465056, 'SM00452', NULL, NULL, 198, NULL, 'kul_2', 284150),
(465057, 'SM00255', NULL, NULL, 147, NULL, 'till_3', 284151),
(465058, 'SM00806', NULL, NULL, 476, NULL, 'aip3', 284152),
(465059, 'SM00050', NULL, NULL, 81, NULL, 'DISIN_2', 284153),
(465060, 'SM01394', NULL, NULL, 43, NULL, 'S_100_2', 284154),
(465061, 'SM00268', NULL, NULL, 487, NULL, 'actin_3', 284155),
(465062, 'SM00994', NULL, NULL, 43, NULL, 'zf_C4_ClpX_2', 284156),
(465063, 'SM00848', NULL, NULL, 67, NULL, 'Inhibitor_I29_2', 284157),
(465064, 'SM01360', NULL, NULL, 113, NULL, 'A2M_2', 284158),
(465065, 'SM00065', NULL, NULL, 142, NULL, 'gaf_1', 284159),
(465066, 'SM01273', NULL, NULL, 27, NULL, 'Mago_bind_2', 284160),
(465067, 'SM00780', NULL, NULL, 237, NULL, 'pig_x_1', 284161),
(465068, 'SM01082', NULL, NULL, 39, NULL, 'CHZ_2', 284162),
(465069, 'SM00363', NULL, NULL, 63, NULL, 's4_6', 284163),
(465070, 'SM00851', NULL, NULL, 137, NULL, 'MGS_2a', 284164),
(465071, 'SM00866', NULL, NULL, 179, NULL, 'UTRA_2', 284165),
(465072, 'SM01086', NULL, NULL, 102, NULL, 'ClpB_D2_small_2', 284166),
(465073, 'SM01196', NULL, NULL, 124, NULL, 'FERM_C_3', 284167),
(465074, 'SM00968', NULL, NULL, 105, NULL, 'SMC_hinge_2', 284168),
(465075, 'SM00473', NULL, NULL, 85, NULL, 'ntp_6', 284169),
(465076, 'SM01295', NULL, NULL, 113, NULL, 'K167R_2', 284170),
(465077, 'SM00270', NULL, NULL, 43, NULL, 'ChitinBD_3', 284171),
(465078, 'SM01252', NULL, NULL, 148, NULL, 'KilA_N_2', 284172),
(465079, 'SM00041', NULL, NULL, 94, NULL, 'CT_3', 284173),
(465080, 'SM00799', NULL, NULL, 204, NULL, 'DENN_cls', 284174),
(465081, 'SM00232', NULL, NULL, 156, NULL, 'pad1_6', 284175),
(465082, 'SM01365', NULL, NULL, 31, NULL, 'Op_neuropeptide_2', 284176),
(465083, 'SM00707', NULL, NULL, 26, NULL, 'rpel', 284177),
(465084, 'SM01207', NULL, NULL, 192, NULL, 'G3P_acyltransf_2', 284178),
(465085, 'SM00054', NULL, NULL, 29, NULL, 'efh_1', 284179),
(465086, 'SM00176', NULL, NULL, 202, NULL, 'ran_sub_2', 284180),
(465087, 'SM00049', NULL, NULL, 90, NULL, 'DEP_3', 284181),
(465088, 'SM00826', NULL, NULL, 244, NULL, 'PKS_DH', 284182),
(465089, 'SM00702', NULL, NULL, 220, NULL, 'p4hc', 284183),
(465090, 'SM00244', NULL, NULL, 179, NULL, 'PHB_4', 284184),
(465091, 'SM00711', NULL, NULL, 16, NULL, 'tdu', 284185),
(465092, 'SM00497', NULL, NULL, 53, NULL, 'intein_16', 284186),
(465093, 'SM01247', NULL, NULL, 301, NULL, 'KaiA_2', 284187),
(465094, 'SM00784', NULL, NULL, 131, NULL, 'spt2', 284188),
(465095, 'SM00208', NULL, NULL, 50, NULL, 'TNFR_3', 284189),
(465096, 'SM00185', NULL, NULL, 38, NULL, 'arm_5', 284190),
(465097, 'SM01078', NULL, NULL, 120, NULL, 'CGGC_2', 284191),
(465098, 'SM00713', NULL, NULL, 18, NULL, 'gyr', 284192),
(465099, 'SM01368', NULL, NULL, 216, NULL, 'RB_A_2', 284193),
(465100, 'SM00157', NULL, NULL, 221, NULL, 'PRP_2', 284194),
(465101, 'SM00033', NULL, NULL, 100, NULL, 'ch_5', 284195),
(465102, 'SM00635', NULL, NULL, 86, NULL, 'bid_2', 284196),
(465103, 'SM01010', NULL, NULL, 134, NULL, 'AMPKBI_2', 284197);
INSERT INTO "PUBLIC"."MODEL" VALUES
(465104, 'SM00923', NULL, NULL, 53, NULL, 'MbtH_2', 284198),
(465105, 'SM00166', NULL, NULL, 97, NULL, 'ubx_3', 284199),
(465106, 'SM01036', NULL, NULL, 186, NULL, 'BP28CT_2', 284200),
(465107, 'SM01343', NULL, NULL, 33, NULL, 'FATC_2', 284201),
(465108, 'SM00057', NULL, NULL, 78, NULL, 'fimac2', 284202),
(465109, 'SM01094', NULL, NULL, 58, NULL, 'CpcD_2', 284203),
(465110, 'SM00480', NULL, NULL, 367, NULL, 'pol35', 284204),
(465111, 'SM01357', NULL, NULL, 33, NULL, 'Antimicrobial21_2', 284205),
(465112, 'SM00973', NULL, NULL, 409, NULL, 'Sec63_2', 284206),
(465113, 'SM00958', NULL, NULL, 143, NULL, 'SecA_PP_bind_2', 284207),
(465114, 'SM01367', NULL, NULL, 175, NULL, 'DUF3452_2', 284208),
(465115, 'SM00347', NULL, NULL, 101, NULL, 'marrlong4', 284209),
(465116, 'SM00229', NULL, NULL, 172, NULL, 'rasgefn_5', 284210),
(465117, 'SM00877', NULL, NULL, 85, NULL, 'BMC_2', 284211),
(465118, 'SM00969', NULL, NULL, 49, NULL, 'SOCS_box_2', 284212),
(465119, 'SM00189', NULL, NULL, 169, NULL, 'int2_nr', 284213),
(465120, 'SM01141', NULL, NULL, 146, NULL, 'DRY_EERY_2', 284214),
(465121, 'SM00302', NULL, NULL, 97, NULL, 'GED_2', 284215),
(465122, 'SM00761', NULL, NULL, 103, NULL, 'hdac_interact2seq4b', 284216),
(465123, 'SM00178', NULL, NULL, 199, NULL, 'sar_sub_1', 284217),
(465124, 'SM00426', NULL, NULL, 72, NULL, 'tea2', 284218),
(465125, 'SM00223', NULL, NULL, 87, NULL, 'APPLE_7', 284219),
(465126, 'SM00013', NULL, NULL, 38, NULL, 'lrrnt1', 284220),
(465127, 'SM01133', NULL, NULL, 291, NULL, 'DeoC_2', 284221),
(465128, 'SM01227', NULL, NULL, 78, NULL, 'GCK_2', 284222),
(465129, 'SM00207', NULL, NULL, 165, NULL, 'TNF_2', 284223),
(465130, 'SM00160', NULL, NULL, 143, NULL, 'ranbd_3', 284224),
(465131, 'SM00552', NULL, NULL, 451, NULL, 'adara_8', 284225),
(465132, 'SM00110', NULL, NULL, 146, NULL, 'C1Q_2', 284226),
(465133, 'SM01068', NULL, NULL, 68, NULL, 'CBM_X_2', 284227),
(465134, 'SM00330', NULL, NULL, 438, NULL, 'PIPK_2', 284228),
(465135, 'SM00518', NULL, NULL, 299, NULL, 'ap2real3', 284229),
(465136, 'SM00967', NULL, NULL, 96, NULL, 'SpoU_sub_bind_2', 284230),
(465137, 'SM01000', NULL, NULL, 160, NULL, 'Aha1_N_2', 284231),
(465138, 'SM00849', NULL, NULL, 246, NULL, 'Lactamase_B_5a', 284232),
(465139, 'SM00453', NULL, NULL, 72, NULL, 'wsn_4', 284233),
(465140, 'SM01172', NULL, NULL, 231, NULL, 'DUF3700_2', 284234),
(465141, 'SM00073', NULL, NULL, 100, NULL, 'hpt_2', 284235),
(465142, 'SM00559', NULL, NULL, 155, NULL, 'ku_4', 284236),
(465143, 'SM00234', NULL, NULL, 248, NULL, 'START_1', 284237),
(465144, 'SM00796', NULL, NULL, 225, NULL, 'ahs1', 284238),
(465145, 'SM01034', NULL, NULL, 96, NULL, 'BLUF_2', 284239),
(465146, 'SM01145', NULL, NULL, 104, NULL, 'DUF1041_2a', 284240),
(465147, 'SM01396', NULL, NULL, 69, NULL, 'BC10_2', 284241),
(465148, 'SM01266', NULL, NULL, 65, NULL, 'Mac_2', 284242),
(465149, 'SM00067', NULL, NULL, 87, NULL, 'GHA_2', 284243),
(465150, 'SM00425', NULL, NULL, 206, NULL, 'tbox5', 284244),
(465151, 'SM01188', NULL, NULL, 22, NULL, 'ELK_2', 284245),
(465152, 'SM00709', NULL, NULL, 166, NULL, 'zpr1', 284246),
(465153, 'SM01104', NULL, NULL, 171, NULL, 'CTD_2', 284247),
(465154, 'SM01180', NULL, NULL, 80, NULL, 'DWNN_2', 284248),
(465155, 'SM00399', NULL, NULL, 72, NULL, 'c4gold', 284249),
(465156, 'SM00121', NULL, NULL, 95, NULL, 'IB_2', 284250),
(465157, 'SM01015', NULL, NULL, 258, NULL, 'Arfaptin_2', 284251),
(465158, 'SM01052', NULL, NULL, 87, NULL, 'CAP_GLY_2', 284252),
(465159, 'SM00754', NULL, NULL, 149, NULL, 'chrd_5', 284253),
(465160, 'SM00069', NULL, NULL, 66, NULL, 'gla_3', 284254),
(465161, 'SM00352', NULL, NULL, 78, NULL, 'pou', 284255),
(465162, 'SM00254', NULL, NULL, 48, NULL, 'ShkT_1', 284256),
(465163, 'SM01126', NULL, NULL, 164, NULL, 'DDE_Tnp_IS1595_2', 284257),
(465164, 'SM01156', NULL, NULL, 115, NULL, 'DUF1716_2', 284258),
(465165, 'SM00283', NULL, NULL, 275, NULL, 'MA_2', 284259),
(465166, 'SM01412', NULL, NULL, 285, NULL, 'Pro_rich_2', 284260),
(465167, 'SM00720', NULL, NULL, 160, NULL, '2cal', 284261),
(465168, 'SM00970', NULL, NULL, 140, NULL, 's48_45_2', 284262);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(465169, 'SM01041', NULL, NULL, 447, NULL, 'BRO1_2', 284263),
(465170, 'SM00591', NULL, NULL, 128, NULL, 'RWD2001b', 284264),
(465171, 'SM00555', NULL, NULL, 31, NULL, 'spa2_6', 284265),
(465172, 'SM00434', NULL, NULL, 516, NULL, 'topIV4', 284266),
(465173, 'SM00137', NULL, NULL, 192, NULL, 'MAM_2', 284267),
(465174, 'SM00144', NULL, NULL, 116, NULL, 'pi3k_ras_2', 284268),
(465175, 'SM00406', NULL, NULL, 76, NULL, 'igv1_8', 284269),
(465176, 'SM01072', NULL, NULL, 71, NULL, 'CDC48_2_2', 284270),
(465177, 'SM00646', NULL, NULL, 163, NULL, 'ami_3', 284271),
(465178, 'SM00269', NULL, NULL, 60, NULL, 'BoBi_2', 284272),
(465179, 'SM00059', NULL, NULL, 49, NULL, 'FN2_2', 284273),
(465180, 'SM00387', NULL, NULL, 130, NULL, 'HKATPase_4', 284274),
(465181, 'SM01040', NULL, NULL, 104, NULL, 'Bro_N_2', 284275),
(465182, 'SM00300', NULL, NULL, 73, NULL, 'ChS_2', 284276),
(465183, 'SM00496', NULL, NULL, 17, NULL, 'seet_6', 284277),
(465184, 'SM01337', NULL, NULL, 174, NULL, 'APC10_2', 284278),
(465185, 'SM00039', NULL, NULL, 44, NULL, 'clf2', 284279),
(465186, 'SM00044', NULL, NULL, 231, NULL, 'cyc_6', 284280),
(465187, 'SM01071', NULL, NULL, 202, NULL, 'CDC37_N_2', 284281),
(465188, 'SM00511', NULL, NULL, 47, NULL, 'orange_5', 284282),
(465189, 'SM00808', NULL, NULL, 153, NULL, 'fabda', 284283),
(465190, 'SM01095', NULL, NULL, 42, NULL, 'Cpl_7_2', 284284),
(465191, 'SM00603', NULL, NULL, 95, NULL, 'lcc', 284285),
(465192, 'SM00752', NULL, NULL, 317, NULL, 'EBI_submitted', 284286),
(465193, 'SM00109', NULL, NULL, 61, NULL, 'c1_12', 284287),
(465194, 'SM00739', NULL, NULL, 28, NULL, 'kow_9', 284288),
(465195, 'SM00133', NULL, NULL, 79, NULL, 'pkinase_C_6', 284289),
(465196, 'SM00068', NULL, NULL, 109, NULL, 'GHB_2', 284290),
(465197, 'SM00922', NULL, NULL, 121, NULL, 'MR_MLE_2', 284291),
(465198, 'SM00477', NULL, NULL, 262, NULL, 'endoplus', 284292),
(465199, 'SM00195', NULL, NULL, 172, NULL, 'dsp_5', 284293),
(465200, 'SM00336', NULL, NULL, 51, NULL, 'bboxneu5', 284294),
(465201, 'SM01376', NULL, NULL, 76, NULL, 'eIF_5a_2', 284295),
(465202, 'SM00113', NULL, NULL, 43, NULL, 'calci3_nr', 284296),
(465203, 'SM01244', NULL, NULL, 113, NULL, 'IRS_2', 284297),
(465204, 'SM00736', NULL, NULL, 108, NULL, 'cadg_13', 284298),
(465205, 'SM00484', NULL, NULL, 80, NULL, 'xpgineu', 284299),
(465206, 'SM00694', NULL, NULL, 42, NULL, 'dysfc', 284300),
(465207, 'SM00605', NULL, NULL, 159, NULL, 'cw', 284301),
(465208, 'SM01199', NULL, NULL, 126, NULL, 'FDF_2', 284302),
(465209, 'SM01233', NULL, NULL, 109, NULL, 'HABP4_PAI_RBP1_2', 284303),
(465210, 'SM01267', NULL, NULL, 202, NULL, 'LAG1_DNAbind_2', 284304),
(465211, 'SM00145', NULL, NULL, 232, NULL, 'pi3k_hr2_4', 284305),
(465212, 'SM01075', NULL, NULL, 206, NULL, 'CDT1_2', 284306),
(465213, 'SM01251', NULL, NULL, 184, NULL, 'KbaA_2', 284307),
(465214, 'SM00003', NULL, NULL, 79, NULL, 'NH_2', 284308),
(465215, 'SM00594', NULL, NULL, 158, NULL, '45neu3', 284309),
(465216, 'SM00929', NULL, NULL, 43, NULL, 'NADH_G_4Fe_4S_3_2', 284310),
(465217, 'SM00953', NULL, NULL, 162, NULL, 'RES_2', 284311),
(465218, 'SM01307', NULL, NULL, 244, NULL, 'RICTOR_M_2', 284312),
(465219, 'SM00597', NULL, NULL, 117, NULL, '2118neu4', 284313),
(465220, 'SM01391', NULL, NULL, 393, NULL, 'Filament_2', 284314),
(465221, 'SM00782', NULL, NULL, 47, NULL, 'phnA_zn_ribbon', 284315),
(465222, 'SM00972', NULL, NULL, 64, NULL, 'SCPU_a_2_a', 284316),
(465223, 'SM00462', NULL, NULL, 156, NULL, 'PTB_9', 284317),
(465224, 'SM00356', NULL, NULL, 31, NULL, 'c3hfinal6', 284318),
(465225, 'SM00134', NULL, NULL, 103, NULL, 'LU_2', 284319),
(465226, 'SM00988', NULL, NULL, 70, NULL, 'UreE_n_2_a', 284320),
(465227, 'SM00641', NULL, NULL, 123, NULL, 'glyco_25', 284321),
(465228, 'SM00746', NULL, NULL, 41, NULL, '4TRASH', 284322),
(465229, 'SM00014', NULL, NULL, 161, NULL, 'acid_phosph_2', 284323),
(465230, 'SM01100', NULL, NULL, 26, NULL, 'CRAL_TRIO_N_2', 284324),
(465231, 'SM00187', NULL, NULL, 447, NULL, 'INB_2', 284325),
(465232, 'SM00236', NULL, NULL, 34, NULL, 'fcbd_2', 284326),
(465233, 'SM00180', NULL, NULL, 42, NULL, 'lamegf_3', 284327);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(465234, 'SM00647', NULL, NULL, 78, NULL, 'ibrneu5', 284328),
(465235, 'SM00721', NULL, NULL, 260, NULL, '5bar', 284329),
(465236, 'SM01058', NULL, NULL, 124, NULL, 'CarD_TRCF_2', 284330),
(465237, 'SM00055', NULL, NULL, 103, NULL, 'fch_2', 284331),
(465238, 'SM00944', NULL, NULL, 147, NULL, 'Pro_kuma_activ_2', 284332),
(465239, 'SM00802', NULL, NULL, 115, NULL, 'UME_cls', 284333),
(465240, 'SM00441', NULL, NULL, 64, NULL, 'FF_2', 284334),
(465241, 'SM01102', NULL, NULL, 377, NULL, 'CRM1_C_2', 284335),
(465242, 'SM01114', NULL, NULL, 42, NULL, 'CXC_2', 284336),
(465243, 'SM01182', NULL, NULL, 28, NULL, 'EF-1_beta_acid_2', 284337),
(465244, 'SM00130', NULL, NULL, 90, NULL, 'KR_2', 284338),
(465245, 'SM00346', NULL, NULL, 91, NULL, 'iclrneu', 284339),
(465246, 'SM00025', NULL, NULL, 39, NULL, 'pum_5', 284340),
(465247, 'SM00878', NULL, NULL, 143, NULL, 'Biotin_carb_C_2', 284341),
(465248, 'SM00915', NULL, NULL, 151, NULL, 'Jacalin_2', 284342),
(465249, 'SM00734', NULL, NULL, 27, NULL, 'c2hc_5', 284343),
(465250, 'SM00538', NULL, NULL, 99, NULL, 'pop4_2', 284344),
(465251, 'SM01348', NULL, NULL, 66, NULL, 'Nbs1_C_2', 284345),
(465252, 'SM00649', NULL, NULL, 135, NULL, 'rl11c', 284346),
(465253, 'SM01158', NULL, NULL, 244, NULL, 'DUF1741_2', 284347),
(465254, 'SM00389', NULL, NULL, 63, NULL, 'HOX_1', 284348),
(465255, 'SM01111', NULL, NULL, 135, NULL, 'CVNH_2', 284349),
(465256, 'SM00337', NULL, NULL, 120, NULL, 'bclneu2', 284350),
(465257, 'SM00666', NULL, NULL, 95, NULL, 'PB1_new', 284351),
(465258, 'SM00326', NULL, NULL, 58, NULL, 'SH3_2', 284352),
(465259, 'SM01297', NULL, NULL, 835, NULL, 'KAP_2', 284353),
(465260, 'SM00510', NULL, NULL, 118, NULL, 'mid_6', 284354),
(465261, 'SM00856', NULL, NULL, 162, NULL, 'PMEI_2', 284355),
(465262, 'SM00651', NULL, NULL, 66, NULL, 'Sm3', 284356),
(465263, 'SM00053', NULL, NULL, 246, NULL, 'dynamin_3', 284357),
(465264, 'SM01213', NULL, NULL, 163, NULL, 'Flo11_2', 284358),
(465265, 'SM00345', NULL, NULL, 60, NULL, 'gntr3', 284359),
(465266, 'SM00409', NULL, NULL, 58, NULL, 'IG_3c', 284360),
(465267, 'SM00367', NULL, NULL, 26, NULL, 'LRR_CC_2', 284361),
(465268, 'SM00043', NULL, NULL, 129, NULL, 'CY_4', 284362),
(465269, 'SM01153', NULL, NULL, 366, NULL, 'DUF1693_2', 284363),
(465270, 'SM00210', NULL, NULL, 218, NULL, 'TSPN_2', 284364),
(465271, 'SM00433', NULL, NULL, 639, NULL, 'topII5', 284365),
(465272, 'SM01253', NULL, NULL, 132, NULL, 'Kin17_mid_2', 284366),
(465273, 'SM01116', NULL, NULL, 74, NULL, 'Cyanate_lyase_2', 284367),
(465274, 'SM01308', NULL, NULL, 414, NULL, 'RICTOR_N_3', 284368),
(465275, 'SM01232', NULL, NULL, 119, NULL, 'H2TH_2', 284369),
(465276, 'SM00032', NULL, NULL, 79, NULL, 'CCP_2', 284370),
(465277, 'SM00284', NULL, NULL, 349, NULL, 'olf_2', 284371),
(465278, 'SM00965', NULL, NULL, 58, NULL, 'STN_2', 284372),
(465279, 'SM01322', NULL, NULL, 182, NULL, 'YaeQ_2', 284373),
(465280, 'SM00476', NULL, NULL, 300, NULL, 'dnai3', 284374),
(465281, 'SM00885', NULL, NULL, 194, NULL, 'D5_N_2', 284375),
(465282, 'SM00002', NULL, NULL, 63, NULL, 'myelin-fin', 284376),
(465283, 'SM00038', NULL, NULL, 240, NULL, 'COLFI_2', 284377),
(465284, 'SM01166', NULL, NULL, 67, NULL, 'DUF1899_3', 284378),
(465285, 'SM00800', NULL, NULL, 114, NULL, 'uDENN_cls', 284379),
(465286, 'SM01059', NULL, NULL, 210, NULL, 'CAT_2a', 284380),
(465287, 'SM00257', NULL, NULL, 45, NULL, 'LysM_2', 284381),
(465288, 'SM00974', NULL, NULL, 104, NULL, 'T5orf172_2', 284382),
(465289, 'SM01228', NULL, NULL, 72, NULL, 'GIDA_assoc_3_2', 284383),
(465290, 'SM00438', NULL, NULL, 21, NULL, 'znfxneu3', 284384),
(465291, 'SM00369', NULL, NULL, 24, NULL, 'LRR_typ_2', 284385),
(465292, 'SM00908', NULL, NULL, 143, NULL, 'Gal_bind_lectin_2', 284386),
(465293, 'SM00637', NULL, NULL, 103, NULL, 'cbd_2', 284387),
(465294, 'SM00295', NULL, NULL, 232, NULL, 'B41_5', 284388),
(465295, 'SM00547', NULL, NULL, 25, NULL, 'zf_4', 284389),
(465296, 'SM01097', NULL, NULL, 151, NULL, 'CPSase_sm_chain_2', 284390),
(465297, 'SM01092', NULL, NULL, 118, NULL, 'CO_deh_flav_C_2', 284391),
(465298, 'SM01313', NULL, NULL, 107, NULL, 'Sec3_PIP2_bind_2', 284392);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(465299, 'SM00769', NULL, NULL, 121, NULL, 'why', 284393),
(465300, 'SM00654', NULL, NULL, 205, NULL, 'eIF6neu2', 284394),
(465301, 'SM00468', NULL, NULL, 124, NULL, 'preset_2', 284395),
(465302, 'SM00790', NULL, NULL, 216, NULL, 'afor_n', 284396),
(465303, 'SM00143', NULL, NULL, 80, NULL, 'pi3k_nt_2', 284397),
(465304, 'SM00202', NULL, NULL, 118, NULL, 'SR_3', 284398),
(465305, 'SM01007', NULL, NULL, 283, NULL, 'Aldolase_II_2', 284399),
(465306, 'SM01236', NULL, NULL, 107, NULL, 'Haem_oxygenas_2_2', 284400),
(465307, 'SM01277', NULL, NULL, 119, NULL, 'MAGUK_N_PEST_2', 284401),
(465308, 'SM01406', NULL, NULL, 100, NULL, 'PAPA_1_2', 284402),
(465309, 'SM00198', NULL, NULL, 190, NULL, 'SCP_3', 284403),
(465310, 'SM01319', NULL, NULL, 192, NULL, 'Tankyrase_bdg_C_2', 284404),
(465311, 'SM00704', NULL, NULL, 39, NULL, 'znf_cdgsh', 284405),
(465312, 'SM01162', NULL, NULL, 69, NULL, 'DUF1771_2', 284406),
(465313, 'SM01062', NULL, NULL, 35, NULL, 'Ca_chan_IQ_2', 284407),
(465314, 'SM00298', NULL, NULL, 63, NULL, 'chromo_7', 284408),
(465315, 'SM00331', NULL, NULL, 250, NULL, 'PP2C_SIG_2', 284409),
(465316, 'SM00368', NULL, NULL, 28, NULL, 'LRR_RI_2', 284410),
(465317, 'SM01372', NULL, NULL, 102, NULL, 'E2F_TDP_2', 284411),
(465318, 'SM01018', NULL, NULL, 84, NULL, 'B12_binding_2_2', 284412),
(465319, 'SM01283', NULL, NULL, 82, NULL, 'Costars_2', 284413),
(465320, 'SM00751', NULL, NULL, 56, NULL, 'wurzfinal6', 284414),
(465321, 'SM01037', NULL, NULL, 152, NULL, 'Bet_v_1_2', 284415),
(465322, 'SM01276', NULL, NULL, 342, NULL, 'M60_like_2', 284416),
(465323, 'SM01239', NULL, NULL, 38, NULL, 'IKKbetaNEMObind_2', 284417),
(465324, 'SM00975', NULL, NULL, 147, NULL, 'Telomerase_RBD_2', 284418),
(465325, 'SM00892', NULL, NULL, 332, NULL, 'Endonuclease_NS_2', 284419),
(465326, 'SM00238', NULL, NULL, 81, NULL, 'bir_2', 284420),
(465327, 'SM00029', NULL, NULL, 14, NULL, 'gastr3', 284421),
(465328, 'SM00996', NULL, NULL, 469, NULL, 'AdoHcyase_2', 284422),
(465329, 'SM00467', NULL, NULL, 31, NULL, 'GS_4', 284423),
(465330, 'SM00926', NULL, NULL, 99, NULL, 'Molybdop_Fe4S4_2', 284424),
(465331, 'SM01402', NULL, NULL, 49, NULL, 'Ribosomal_S27_2', 284425),
(465332, 'SM00332', NULL, NULL, 338, NULL, 'PP2C_4', 284426),
(465333, 'SM00735', NULL, NULL, 26, NULL, 'zasp_3', 284427),
(465334, 'SM00249', NULL, NULL, 39, NULL, 'PHD_3', 284428),
(465335, 'SM00092', NULL, NULL, 140, NULL, 'rnase-fin', 284429),
(465336, 'SM00070', NULL, NULL, 27, NULL, 'gluca', 284430),
(465337, 'SM00062', NULL, NULL, 244, NULL, 'AABind_6', 284431),
(465338, 'SM01046', NULL, NULL, 97, NULL, 'c_SKI_SMAD_bind_2', 284432),
(465339, 'SM00251', NULL, NULL, 90, NULL, 'SAM2_3', 284433),
(465340, 'SM00731', NULL, NULL, 182, NULL, 'sprt_6', 284434),
(465341, 'SM01254', NULL, NULL, 114, NULL, 'KLRAQ_2', 284435),
(465342, 'SM01274', NULL, NULL, 183, NULL, 'malic_2', 284436),
(465343, 'SM01263', NULL, NULL, 161, NULL, 'Leuk_A4_hydro_C_2', 284437),
(465344, 'SM01260', NULL, NULL, 406, NULL, 'LANC_like_2', 284438),
(465345, 'SM00311', NULL, NULL, 78, NULL, 'pwi_2', 284439),
(465346, 'SM00570', NULL, NULL, 62, NULL, 'shorttest3', 284440),
(465347, 'SM00058', NULL, NULL, 46, NULL, 'FN1_2', 284441),
(465348, 'SM00588', NULL, NULL, 128, NULL, '27b', 284442),
(465349, 'SM01299', NULL, NULL, 174, NULL, 'PIP49_N_2', 284443),
(465350, 'SM01264', NULL, NULL, 271, NULL, 'M16C_assoc_2', 284444),
(465351, 'SM00901', NULL, NULL, 125, NULL, 'FRG_2', 284445),
(465352, 'SM00272', NULL, NULL, 22, NULL, 'END_2', 284446),
(465353, 'SM00507', NULL, NULL, 74, NULL, 'HNH_5', 284447),
(465354, 'SM01160', NULL, NULL, 107, NULL, 'DUF1751_2', 284448),
(465355, 'SM00119', NULL, NULL, 407, NULL, 'hect_3', 284449),
(465356, 'SM00112', NULL, NULL, 121, NULL, 'CA_2', 284450),
(465357, 'SM00793', NULL, NULL, 194, NULL, 'agrb', 284451),
(465358, 'SM01014', NULL, NULL, 97, NULL, 'ARID_2', 284452),
(465359, 'SM01327', NULL, NULL, 53, NULL, 'Zds_C_2', 284453),
(465360, 'SM01070', NULL, NULL, 203, NULL, 'CDC37_M_2', 284454),
(465361, 'SM00457', NULL, NULL, 232, NULL, 'MACPF_8', 284455),
(465362, 'SM00917', NULL, NULL, 135, NULL, 'LeuA_dimer_2', 284456);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(465363, 'SM00946', NULL, NULL, 78, NULL, 'ProRS_C_1_2', 284457),
(465364, 'SM00867', NULL, NULL, 228, NULL, 'YceI_2', 284458),
(465365, 'SM00414', NULL, NULL, 124, NULL, 'h2a4', 284459),
(465366, 'SM01293', NULL, NULL, 452, NULL, 'DUF3402_2', 284460),
(465367, 'SM00960', NULL, NULL, 100, NULL, 'Robl_LC7_a_2', 284461),
(465368, 'SM00757', NULL, NULL, 119, NULL, 'toby_final6', 284462),
(465369, 'SM01168', NULL, NULL, 293, NULL, 'DUF1907_2', 284463),
(465370, 'SM01117', NULL, NULL, 126, NULL, 'Cyt_b5_2', 284464),
(465371, 'SM01245', NULL, NULL, 56, NULL, 'Jag_N_2', 284465),
(465372, 'SM00446', NULL, NULL, 19, NULL, 'LRRcap_2', 284466),
(465373, 'SM00455', NULL, NULL, 76, NULL, 'RBD_5', 284467),
(465374, 'SM01405', NULL, NULL, 136, NULL, 'Ribosomal_S6e_2', 284468),
(465375, 'SM00275', NULL, NULL, 400, NULL, 'galpha_1', 284469),
(465376, 'SM00319', NULL, NULL, 142, NULL, 'TAR_3', 284470),
(465377, 'SM01364', NULL, NULL, 45, NULL, 'NPP_2', 284471),
(465378, 'SM00219', NULL, NULL, 280, NULL, 'tyrkin_6', 284472),
(465379, 'SM00267', NULL, NULL, 176, NULL, 'duf1_3', 284473),
(465380, 'SM00786', NULL, NULL, 221, NULL, 'shr3_chaperone2', 284474),
(465381, 'SM00465', NULL, NULL, 102, NULL, 'uri_9', 284475),
(465382, 'SM01179', NULL, NULL, 198, NULL, 'DUF862_2a', 284476),
(465383, 'SM00955', NULL, NULL, 477, NULL, 'RNB_2', 284477),
(465384, 'SM00932', NULL, NULL, 96, NULL, 'Nfu_N_3a', 284478),
(465385, 'SM00528', NULL, NULL, 48, NULL, 'hnsneu2', 284479),
(465386, 'SM00235', NULL, NULL, 204, NULL, 'col_5', 284480),
(465387, 'SM00263', NULL, NULL, 129, NULL, 'lysozyme-fin', 284481),
(465388, 'SM01265', NULL, NULL, 351, NULL, 'Mab_21_2', 284482),
(465389, 'SM00916', NULL, NULL, 82, NULL, 'L51_S25_CI_B8_2', 284483),
(465390, 'SM01300', NULL, NULL, 166, NULL, 'PEHE_2', 284484),
(465391, 'SM00615', NULL, NULL, 184, NULL, 'eph', 284485),
(465392, 'SM00648', NULL, NULL, 54, NULL, 'surpneu2', 284486),
(465393, 'SM00153', NULL, NULL, 36, NULL, 'VHP_1', 284487),
(465394, 'SM00690', NULL, NULL, 106, NULL, 'dm5', 284488),
(465395, 'SM01152', NULL, NULL, 84, NULL, 'DUF167_2', 284489),
(465396, 'SM00609', NULL, NULL, 132, NULL, 'vit', 284490),
(465397, 'SM01081', NULL, NULL, 179, NULL, 'CHB_HEX_2', 284491),
(465398, 'SM01201', NULL, NULL, 82, NULL, 'FerB_2', 284492),
(465399, 'SM00004', NULL, NULL, 42, NULL, 'NL_2', 284493),
(465400, 'SM01352', NULL, NULL, 252, NULL, 'APCDDC_2', 284494),
(465401, 'SM01262', NULL, NULL, 94, NULL, 'LAMTOR_2', 284495),
(465402, 'SM00220', NULL, NULL, 231, NULL, 'serkin_6', 284496),
(465403, 'SM00114', NULL, NULL, 96, NULL, 'card_3', 284497),
(465404, 'SM00135', NULL, NULL, 51, NULL, 'LY_2', 284498),
(465405, 'SM00957', NULL, NULL, 457, NULL, 'SecA_DEAD_2', 284499),
(465406, 'SM00490', NULL, NULL, 86, NULL, 'helicmild6', 284500),
(465407, 'SM00862', NULL, NULL, 113, NULL, 'Trans_reg_C_3', 284501),
(465408, 'SM00889', NULL, NULL, 142, NULL, 'EFG_IV_2', 284502),
(465409, 'SM00776', NULL, NULL, 167, NULL, 'npcbm', 284503),
(465410, 'SM01088', NULL, NULL, 53, NULL, 'Col_cuticle_N_2', 284504),
(465411, 'SM00361', NULL, NULL, 91, NULL, 'rrm2_1', 284505),
(465412, 'SM01395', NULL, NULL, 68, NULL, 'Tbf5_2', 284506),
(465413, 'SM00682', NULL, NULL, 258, NULL, '1g2_nido', 284507),
(465414, 'SM00093', NULL, NULL, 372, NULL, 'serpin2', 284508),
(465415, 'SM01039', NULL, NULL, 106, NULL, 'BRICHOS_2', 284509),
(465416, 'SM01136', NULL, NULL, 59, NULL, 'DKCLD_2', 284510),
(465417, 'SM00147', NULL, NULL, 261, NULL, 'RasGEF_3', 284511),
(465418, 'SM00150', NULL, NULL, 104, NULL, 'SPEC_4', 284512),
(465419, 'SM00305', NULL, NULL, 49, NULL, 'HINTC_6', 284513),
(465420, 'SM01164', NULL, NULL, 51, NULL, 'DUF1856_2', 284514),
(465421, 'SM00983', NULL, NULL, 74, NULL, 'TPK_B1_binding_a_2_a', 284515),
(465422, 'SM00891', NULL, NULL, 137, NULL, 'ERCC4_2', 284516),
(465423, 'SM01350', NULL, NULL, 306, NULL, '6PGD_2', 284517),
(465424, 'SM00831', NULL, NULL, 75, NULL, 'Cation_ATPase_N_a_2', 284518),
(465425, 'SM01345', NULL, NULL, 106, NULL, 'Rapamycin_bind_3', 284519),
(465426, 'SM01335', NULL, NULL, 61, NULL, 'PADR1_2', 284520);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(465427, 'SM01317', NULL, NULL, 121, NULL, 'SPOB_ab_2', 284521),
(465428, 'SM00175', NULL, NULL, 172, NULL, 'rab_sub_5', 284522),
(465429, 'SM00829', NULL, NULL, 348, NULL, 'PKS_ER_names_mod', 284523),
(465430, 'SM00977', NULL, NULL, 86, NULL, 'TilS_C_a_2_a', 284524),
(465431, 'SM00096', NULL, NULL, 70, NULL, 'utero2', 284525),
(465432, 'SM01198', NULL, NULL, 216, NULL, 'FBA_2', 284526),
(465433, 'SM00990', NULL, NULL, 132, NULL, 'VRR_NUC_a_2', 284527),
(465434, 'SM01409', NULL, NULL, 39, NULL, 'RNA_pol_Rpb6_2', 284528),
(465435, 'SM00918', NULL, NULL, 72, NULL, 'Lig_chan_Glu_bd_2', 284529),
(465436, 'SM00486', NULL, NULL, 531, NULL, 'polmehr3', 284530),
(465437, 'SM00775', NULL, NULL, 159, NULL, 'lns2', 284531),
(465438, 'SM01208', NULL, NULL, 79, NULL, 'G5_2', 284532),
(465439, 'SM00278', NULL, NULL, 20, NULL, 'HhH1_4', 284533),
(465440, 'SM00563', NULL, NULL, 135, NULL, 'plsc_2', 284534),
(465441, 'SM00738', NULL, NULL, 119, NULL, 'nusgn_4', 284535),
(465442, 'SM01387', NULL, NULL, 93, NULL, 'Ribosomal_S15_2', 284536),
(465443, 'SM01031', NULL, NULL, 65, NULL, 'BHD_2_2', 284537),
(465444, 'SM01035', NULL, NULL, 284, NULL, 'BOP1NT_2', 284538),
(465445, 'SM00036', NULL, NULL, 375, NULL, 'nik_2', 284539),
(465446, 'SM00557', NULL, NULL, 119, NULL, 'flmn_3', 284540),
(465447, 'SM01143', NULL, NULL, 62, NULL, 'DSX_dimer_2', 284541),
(465448, 'SM00850', NULL, NULL, 115, NULL, 'LytTR_3', 284542),
(465449, 'SM01223', NULL, NULL, 306, NULL, 'FTO_NTD_2', 284543),
(465450, 'SM01135', NULL, NULL, 113, NULL, 'DIRP_2', 284544),
(465451, 'SM00411', NULL, NULL, 97, NULL, 'bhlneu', 284545),
(465452, 'SM00745', NULL, NULL, 81, NULL, 'smart', 284546),
(465453, 'SM00469', NULL, NULL, 146, NULL, 'WIF_1', 284547),
(465454, 'SM00608', NULL, NULL, 152, NULL, 'acr', 284548),
(465455, 'SM00027', NULL, NULL, 98, NULL, 'eh_3', 284549),
(465456, 'SM01057', NULL, NULL, 293, NULL, 'Carb_anhydrase_2a', 284550),
(465457, 'SM00197', NULL, NULL, 110, NULL, 'SAA_2', 284551),
(465458, 'SM00008', NULL, NULL, 89, NULL, 'HormR_1', 284552),
(465459, 'SM01344', NULL, NULL, 437, NULL, 'NUC194_2', 284553),
(465460, 'SM00794', NULL, NULL, 45, NULL, 'agrd', 284554),
(465461, 'SM01181', NULL, NULL, 95, NULL, 'E2_bind_2', 284555),
(465462, 'SM01128', NULL, NULL, 215, NULL, 'DDRGK_2', 284556),
(465463, 'SM00384', NULL, NULL, 13, NULL, 'AT_hook_2', 284557),
(465464, 'SM00579', NULL, NULL, 93, NULL, '9598neu4hmm', 284558),
(465465, 'SM00260', NULL, NULL, 152, NULL, 'chew_2', 284559),
(465466, 'SM00982', NULL, NULL, 104, NULL, 'TRCF_a_2_a', 284560),
(465467, 'SM00192', NULL, NULL, 47, NULL, 'LDLa_2', 284561),
(465468, 'SM01079', NULL, NULL, 211, NULL, 'CHASE_2', 284562),
(465469, 'SM00882', NULL, NULL, 261, NULL, 'CoA_trans_3', 284563),
(465470, 'SM01066', NULL, NULL, 96, NULL, 'CBM_25_3', 284564),
(465471, 'SM00554', NULL, NULL, 122, NULL, 'fasc_3', 284565),
(465472, 'SM00668', NULL, NULL, 60, NULL, 'ctlh', 284566),
(465473, 'SM00672', NULL, NULL, 334, NULL, 'cap10', 284567),
(465474, 'SM00900', NULL, NULL, 138, NULL, 'FMN_bind_2', 284568),
(465475, 'SM00934', NULL, NULL, 268, NULL, 'OMPdecase_2', 284569),
(465476, 'SM00177', NULL, NULL, 181, NULL, 'arf_sub_2', 284570),
(465477, 'SM00421', NULL, NULL, 57, NULL, 'luxrmega5', 284571),
(465478, 'SM00997', NULL, NULL, 170, NULL, 'AdoHcyase_NAD_2', 284572),
(465479, 'SM00852', NULL, NULL, 201, NULL, 'MoCF_biosynth_3a', 284573),
(465480, 'SM00912', NULL, NULL, 146, NULL, 'Haemagg_act_2a', 284574),
(465481, 'SM00461', NULL, NULL, 124, NULL, 'WH1_2', 284575),
(465482, 'SM00584', NULL, NULL, 261, NULL, '109ultra', 284576),
(465483, 'SM00758', NULL, NULL, 170, NULL, 'pa14_novel', 284577),
(465484, 'SM00663', NULL, NULL, 316, NULL, 'rpolaneu7', 284578),
(465485, 'SM00482', NULL, NULL, 247, NULL, 'polaultra3', 284579),
(465486, 'SM00018', NULL, NULL, 54, NULL, 'P_2', 284580),
(465487, 'SM00451', NULL, NULL, 37, NULL, 'ZnF_U1_5', 284581),
(465488, 'SM01019', NULL, NULL, 100, NULL, 'B3_2', 284582),
(465489, 'SM00774', NULL, NULL, 64, NULL, 'WRKY_cls', 284583),
(465490, 'SM00741', NULL, NULL, 84, NULL, 'sapb_4', 284584);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(465491, 'SM00634', NULL, NULL, 97, NULL, 'big_1', 284585),
(465492, 'SM00722', NULL, NULL, 218, NULL, 'complete', 284586),
(465493, 'SM00501', NULL, NULL, 95, NULL, 'bright_3', 284587),
(465494, 'SM01146', NULL, NULL, 173, NULL, 'DUF1086_2', 284588),
(465495, 'SM00675', NULL, NULL, 165, NULL, 'dm11', 284589),
(465496, 'SM00939', NULL, NULL, 363, NULL, 'PepX_C_2', 284590),
(465497, 'SM01142', NULL, NULL, 187, NULL, 'DSHCT_2', 284591),
(465498, 'SM00423', NULL, NULL, 56, NULL, 'psinew7', 284592),
(465499, 'SM01054', NULL, NULL, 123, NULL, 'CaM_binding_2', 284593),
(465500, 'SM00931', NULL, NULL, 53, NULL, 'NOSIC_2', 284594),
(465501, 'SM00306', NULL, NULL, 113, NULL, 'hint_7', 284595),
(465502, 'SM00886', NULL, NULL, 117, NULL, 'Dabb_2', 284596),
(465503, 'SM00107', NULL, NULL, 37, NULL, 'ph_extension_3', 284597),
(465504, 'SM00126', NULL, NULL, 156, NULL, 'IL6_2', 284598),
(465505, 'SM00285', NULL, NULL, 38, NULL, 'PBD_5', 284599),
(465506, 'SM00804', NULL, NULL, 64, NULL, 'TAP_C_cls', 284600),
(465507, 'SM00971', NULL, NULL, 105, NULL, 'SATase_N_2_a', 284601),
(465508, 'SM00678', NULL, NULL, 84, NULL, 'deltex', 284602),
(465509, 'SM00388', NULL, NULL, 89, NULL, 'HisKA_10', 284603),
(465510, 'SM00493', NULL, NULL, 139, NULL, 'toprim5', 284604),
(465511, 'SM01127', NULL, NULL, 332, NULL, 'DDHD_2a', 284605),
(465512, 'SM01361', NULL, NULL, 98, NULL, 'A2M_recep_2', 284606),
(465513, 'SM01118', NULL, NULL, 131, NULL, 'CYTH_2', 284607),
(465514, 'SM00723', NULL, NULL, 205, NULL, 'amop', 284608),
(465515, 'SM00592', NULL, NULL, 50, NULL, '122neu5', 284609),
(465516, 'SM00747', NULL, NULL, 77, NULL, '2CFEM', 284610),
(465517, 'SM00840', NULL, NULL, 61, NULL, 'dalr_2_4', 284611),
(465518, 'SM00907', NULL, NULL, 89, NULL, 'GDNF_2', 284612),
(465519, 'SM00262', NULL, NULL, 102, NULL, 'VILL_6', 284613),
(465520, 'SM01310', NULL, NULL, 75, NULL, 'RICTOR_V_2', 284614),
(465521, 'SM00463', NULL, NULL, 94, NULL, 'SMR_2', 284615),
(465522, 'SM00822', NULL, 'This enzymatic domain is part of bacterial polyketide synthases and catalyses the first step in the reductive modification of the beta-carbonyl centres in the growing polyketide chain. It uses NADPH to reduce the keto group to a hydroxy group.', 839, NULL, 'PKS_KR', 284616),
(465523, 'SM00631', NULL, NULL, 324, NULL, 'zn_carb', 284617),
(465524, 'SM01155', NULL, NULL, 34, NULL, 'DUF1713_2', 284618),
(465525, 'SM00847', NULL, NULL, 202, NULL, 'ha2_5', 284619),
(465526, 'SM00854', NULL, NULL, 274, NULL, 'PGA_cap_3', 284620),
(465527, 'SM01383', NULL, NULL, 94, NULL, 'Ribosomal_L2_2', 284621),
(465528, 'SM01378', NULL, NULL, 67, NULL, 'Romo1_2', 284622),
(465529, 'SM00567', NULL, 'E-Z type HEAT repeats', 30, NULL, 'EZ_HEAT', 284623),
(465530, 'SM00309', NULL, NULL, 37, NULL, 'PAH_1', 284624),
(465531, 'SM00653', NULL, NULL, 115, NULL, 'eIF2Bneu4', 284625),
(465532, 'SM00981', NULL, NULL, 117, NULL, 'THUMP_a_2', 284626),
(465533, 'SM00380', NULL, NULL, 66, NULL, 'rav1_2', 284627),
(465534, 'SM01330', NULL, NULL, 337, NULL, 'Frizzled_2', 284628),
(465535, 'SM01338', NULL, NULL, 57, NULL, 'NOD_2', 284629),
(465536, 'SM00072', NULL, NULL, 203, NULL, 'gk_7', 284630),
(465537, 'SM00483', NULL, NULL, 410, NULL, 'polxneu3', 284631),
(465538, 'SM00154', NULL, NULL, 43, NULL, 'AN1_Zf_4', 284632),
(465539, 'SM01288', NULL, NULL, 73, NULL, 'FISNA_2', 284633),
(465540, 'SM01398', NULL, NULL, 152, NULL, 'Cornichon_2', 284634),
(465541, 'SM00639', NULL, NULL, 93, NULL, 'psa', 284635),
(465542, 'SM00500', NULL, NULL, 53, NULL, 'pr04_2', 284636),
(465543, 'SM00385', NULL, NULL, 90, NULL, 'cyclin_7', 284637),
(465544, 'SM00307', NULL, NULL, 207, NULL, 'ILWEQ_1', 284638),
(465545, 'SM00964', NULL, NULL, 129, NULL, 'STAT_int_2', 284639),
(465546, 'SM00233', NULL, NULL, 82, NULL, 'PH_update', 284640),
(465547, 'SM01270', NULL, NULL, 104, NULL, 'Longin_2', 284641),
(465548, 'SM00729', NULL, NULL, 246, NULL, 'MiaB', 284642),
(465549, 'SM00155', NULL, NULL, 30, NULL, 'pld_4', 284643),
(465550, 'SM00226', NULL, NULL, 155, NULL, 'LMWPc_2', 284644),
(465551, 'SM00252', NULL, NULL, 87, NULL, 'SH2_5', 284645);
INSERT INTO "PUBLIC"."MODEL" VALUES
(465552, 'SM00844', NULL, NULL, 60, NULL, 'GA_2', 284646),
(465553, 'SM00855', NULL, NULL, 73, NULL, 'PGAM_5', 284647),
(465554, 'SM00475', NULL, NULL, 276, NULL, '53exo3', 284648),
(465555, 'SM00683', NULL, NULL, 55, NULL, 'dm16', 284649),
(465556, 'SM00871', NULL, NULL, 212, NULL, 'AraC_E_bind_2', 284650),
(465557, 'SM01356', NULL, NULL, 114, NULL, 'AP4E_app_platf_2', 284651),
(465558, 'SM00045', NULL, NULL, 195, NULL, 'dagk_c4b_2', 284652),
(465559, 'SM01165', NULL, NULL, 150, NULL, 'DUF1866_2', 284653),
(465560, 'SM01298', NULL, NULL, 113, NULL, 'KapB_2', 284654),
(465561, 'SM00324', NULL, NULL, 193, NULL, 'RhoGAP_3', 284655),
(465562, 'SM00512', NULL, NULL, 126, NULL, 'skp1_3', 284656),
(465563, 'SM00860', NULL, NULL, 60, NULL, 'SMI1_KNR4_3', 284657),
(465564, 'SM00718', NULL, NULL, 117, NULL, 'dm4_12', 284658),
(465565, 'SM00138', NULL, NULL, 276, NULL, 'methyl_trans_3', 284659),
(465566, 'SM01183', NULL, NULL, 113, NULL, 'EF1G_2', 284660),
(465567, 'SM00089', NULL, NULL, 91, NULL, 'PKD_9', 284661),
(465568, 'SM00241', NULL, NULL, 296, NULL, 'zp_4', 284662),
(465569, 'SM00859', NULL, NULL, 174, NULL, 'Semialdhyde_dh_3', 284663),
(465570, 'SM00245', NULL, NULL, 209, NULL, 'tsp_4', 284664),
(465571, 'SM00102', NULL, NULL, 145, NULL, 'adf_2', 284665),
(465572, 'SM00612', NULL, NULL, 55, NULL, 'kelc_smart', 284666),
(465573, 'SM01318', NULL, NULL, 74, NULL, 'SVWC_2', 284667),
(465574, 'SM01064', NULL, NULL, 34, NULL, 'CBM_10_2', 284668),
(465575, 'SM00701', NULL, NULL, 151, NULL, 'pgrp', 284669),
(465576, 'SM00078', NULL, NULL, 71, NULL, 'IlGF_1', 284670),
(465577, 'SM00726', NULL, NULL, 20, NULL, 'uim', 284671),
(465578, 'SM01302', NULL, NULL, 172, NULL, 'Raptor_N_2', 284672),
(465579, 'SM00650', NULL, NULL, 170, NULL, 'rADcneu6', 284673),
(465580, 'SM00686', NULL, NULL, 117, NULL, 'dm13', 284674),
(465581, 'SM01332', NULL, NULL, 139, NULL, 'Cyclin_C_2', 284675),
(465582, 'SM01138', NULL, NULL, 172, NULL, 'DP_2', 284676),
(465583, 'SM00259', NULL, NULL, 26, NULL, 'A20_3', 284677),
(465584, 'SM00342', NULL, NULL, 84, NULL, 'aracneu4', 284678),
(465585, 'SM00837', NULL, NULL, 89, NULL, 'dpbb_1', 284679),
(465586, 'SM01132', NULL, NULL, 122, NULL, 'DIL_2', 284680),
(465587, 'SM00051', NULL, NULL, 66, NULL, 'dsl11', 284681),
(465588, 'SM00645', NULL, NULL, 340, NULL, 'pept_c1', 284682),
(465589, 'SM01401', NULL, NULL, 306, NULL, 'Sds3_2', 284683),
(465590, 'SM01110', NULL, NULL, 236, NULL, 'Cutinase_3', 284684),
(465591, 'SM00420', NULL, NULL, 53, NULL, 'deor2', 284685),
(465592, 'SM00315', NULL, NULL, 121, NULL, 'RGS_3', 284686),
(465593, 'SM00243', NULL, 'Growth-Arrest-Specific Protein 2 Domain', 76, NULL, 'GAS2', 284687),
(465594, 'SM00564', NULL, NULL, 33, NULL, 'ire1_9', 284688),
(465595, 'SM01087', NULL, NULL, 751, NULL, 'COG6_2', 284689),
(465596, 'SM00248', NULL, NULL, 30, NULL, 'ANK_2a', 284690),
(465597, 'SM00517', NULL, NULL, 66, NULL, 'poly_2', 284691),
(465598, 'SM00360', NULL, NULL, 121, NULL, 'rrm1_1', 284692),
(465599, 'SM00116', NULL, NULL, 47, NULL, 'cbs_1', 284693),
(465600, 'SM00087', NULL, NULL, 36, NULL, 'para4', 284694),
(465601, 'SM00397', NULL, NULL, 68, NULL, 'tSNARE_6', 284695),
(465602, 'SM00504', NULL, NULL, 72, NULL, 'Ubox_2', 284696),
(465603, 'SM00280', NULL, NULL, 58, NULL, 'kazal_3', 284697),
(465604, 'SM00737', NULL, NULL, 121, NULL, 'pgtp_13', 284698),
(465605, 'SM00498', NULL, NULL, 499, NULL, 'it6_source', 284699),
(465606, 'SM00989', NULL, NULL, 67, NULL, 'V4R_2_a', 284700),
(465607, 'SM00292', NULL, NULL, 93, NULL, 'BRCT_7', 284701),
(465608, 'SM00791', NULL, NULL, 156, NULL, 'agglutinin', 284702),
(465609, 'SM00318', NULL, NULL, 153, NULL, 'SNASE_2', 284703),
(465610, 'SM00103', NULL, NULL, 195, NULL, 'albumin-fin', 284704),
(465611, 'SM01004', NULL, NULL, 325, NULL, 'ALAD_2', 284705),
(465612, 'SM01342', NULL, NULL, 173, NULL, 'TAN_2', 284706),
(465613, 'SM01333', NULL, NULL, 809, NULL, 'Tet_JBP_2', 284707),
(465614, 'SM00162', NULL, NULL, 34, NULL, 'sapA_2', 284708),
(465615, 'SM00633', NULL, NULL, 335, NULL, 'glyco_10', 284709),
(465616, 'SM00035', NULL, NULL, 229, NULL, 'clus1a', 284710);
INSERT INTO "PUBLIC"."MODEL" VALUES
(465617, 'SM00246', NULL, NULL, 19, NULL, 'wh2_8', 284711),
(465618, 'SM01226', NULL, NULL, 348, NULL, 'GAGA_bind_2', 284712),
(465619, 'SM01154', NULL, NULL, 388, NULL, 'DUF1704_2', 284713),
(465620, 'SM01194', NULL, NULL, 158, NULL, 'eRF1_1_2', 284714),
(465621, 'SM01392', NULL, NULL, 132, NULL, 'MAGE_N_2', 284715),
(465622, 'SM00531', NULL, NULL, 178, NULL, 'tfiie3', 284716),
(465623, 'SM01195', NULL, NULL, 50, NULL, 'FA_2', 284717),
(465624, 'SM01200', NULL, NULL, 70, NULL, 'FerA_2', 284718),
(465625, 'SM00435', NULL, NULL, 480, NULL, 'topeu', 284719),
(465626, 'SM00805', NULL, NULL, 170, NULL, 'agtrap2', 284720),
(465627, 'SM00581', NULL, NULL, 62, NULL, 'testneu', 284721),
(465628, 'SM00803', NULL, NULL, 68, NULL, 'TAF_cls', 284722),
(465629, 'SM00167', NULL, NULL, 120, NULL, 'vps9_2', 284723),
(465630, 'SM01159', NULL, NULL, 422, NULL, 'DUF1744_2', 284724),
(465631, 'SM00048', NULL, NULL, 34, NULL, 'DEFSN_4', 284725),
(465632, 'SM00661', NULL, NULL, 54, NULL, 'rpol9cneu', 284726),
(465633, 'SM00671', NULL, NULL, 43, NULL, 'sel1', 284727),
(465634, 'SM00046', NULL, NULL, 157, NULL, 'dagk_c4a_7', 284728),
(465635, 'SM00868', NULL, NULL, 33, NULL, 'zf_AD_2', 284729),
(465636, 'SM00277', NULL, NULL, 58, NULL, 'GRAN_2', 284730),
(465637, 'SM00481', NULL, NULL, 75, NULL, 'npolultra', 284731),
(465638, 'SM00937', NULL, NULL, 138, NULL, 'PCRF_a_2', 284732),
(465639, 'SM00021', NULL, NULL, 86, NULL, 'dax_2', 284733),
(465640, 'SM00771', NULL, NULL, 135, NULL, 'ZipA_C_cls', 284734),
(465641, 'SM00224', NULL, NULL, 65, NULL, 'GGL_4', 284735),
(465642, 'SM00673', NULL, NULL, 38, NULL, 'carp', 284736),
(465643, 'SM00443', NULL, NULL, 48, NULL, 'G-patch_5', 284737),
(465644, 'SM01408', NULL, NULL, 87, NULL, 'ING_2', 284738),
(465645, 'SM01315', NULL, NULL, 998, NULL, 'Spc7_N_2', 284739),
(465646, 'SM00290', NULL, NULL, 61, NULL, 'Zf_UBP_1', 284740),
(465647, 'SM01090', NULL, NULL, 40, NULL, 'Copper_fist_2', 284741),
(465648, 'SM00090', NULL, NULL, 253, NULL, 'rio_2', 284742),
(465649, 'SM01009', NULL, NULL, 128, NULL, 'AlkA_N_2', 284743),
(465650, 'SM00586', NULL, NULL, 49, NULL, '3039neu', 284744),
(465651, 'SM01184', NULL, NULL, 70, NULL, 'efhand_Ca_insen_2', 284745),
(465652, 'SM01363', NULL, NULL, 39, NULL, 'ACTH_domain_2', 284746),
(465653, 'SM00846', NULL, NULL, 183, NULL, 'gp_dh_n_7', 284747),
(465654, 'SM01130', NULL, NULL, 378, NULL, 'DHDPS_2', 284748),
(465655, 'SM00537', NULL, NULL, 96, NULL, 'doub1_11', 284749),
(465656, 'SM01032', NULL, NULL, 89, NULL, 'BHD_3_2', 284750),
(465657, 'SM01033', NULL, NULL, 81, NULL, 'BING4CT_2', 284751),
(465658, 'SM01053', NULL, NULL, 79, NULL, 'CaMBD_2', 284752),
(465659, 'SM01147', NULL, NULL, 69, NULL, 'DUF1087_2', 284753),
(465660, 'SM00535', NULL, NULL, 140, NULL, 'riboneu5', 284754),
(465661, 'SM00857', NULL, NULL, 186, NULL, 'resolvase_6', 284755),
(465662, 'SM00659', NULL, NULL, 46, NULL, 'rpolcxc3', 284756),
(465663, 'SM00811', NULL, NULL, 255, NULL, 'alpha_kinase', 284757),
(465664, 'SM01382', NULL, NULL, 155, NULL, 'Ribosomal_L2_C_2', 284758),
(465665, 'SM00333', NULL, NULL, 60, NULL, 'TUDOR_7', 284759),
(465666, 'SM01176', NULL, NULL, 110, NULL, 'DUF4208_2', 284760),
(465667, 'SM00909', NULL, NULL, 100, NULL, 'Germane_2', 284761),
(465668, 'SM01374', NULL, NULL, 146, NULL, 'Ribosomal_L14_2', 284762),
(465669, 'SM00151', NULL, NULL, 83, NULL, 'swib_2', 284763),
(465670, 'SM00060', NULL, NULL, 69, NULL, 'FN3_2', 284764),
(465671, 'SM01381', NULL, NULL, 284, NULL, '7TM_GPCR_Srsx_2', 284765),
(465672, 'SM01400', NULL, NULL, 153, NULL, 'Pribosyltran_N_2', 284766),
(465673, 'SM00943', NULL, NULL, 220, NULL, 'Prim_Pol_2_a', 284767),
(465674, 'SM00727', NULL, NULL, 46, NULL, 'CBM', 284768),
(465675, 'SM01185', NULL, NULL, 59, NULL, 'EFP_2', 284769),
(465676, 'SM01403', NULL, NULL, 110, NULL, 'Ribosomal_S10_2', 284770),
(465677, 'SM00472', NULL, NULL, 79, NULL, 'mir_2', 284771),
(465678, 'SM00239', NULL, NULL, 92, NULL, 'C2_3c', 284772),
(465679, 'SM00325', NULL, NULL, 211, NULL, 'RhoGEF_3', 284773),
(465680, 'SM00152', NULL, NULL, 37, NULL, 'THY_2', 284774); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(465681, '0053409', NULL, NULL, 114, NULL, 'Multimerization domain of the phosphoprotein from sendai virus', 284775),
(465682, '0054533', NULL, NULL, 220, NULL, 'HIT-like', 284776),
(465683, '0054376', NULL, NULL, 139, NULL, 'HIT-like', 284776),
(465684, '0049287', NULL, NULL, 114, NULL, 'HIT-like', 284776),
(465685, '0051185', NULL, NULL, 139, NULL, 'HIT-like', 284776),
(465686, '0051525', NULL, NULL, 156, NULL, 'HIT-like', 284776),
(465687, '0037605', NULL, NULL, 146, NULL, 'HIT-like', 284776),
(465688, '0051524', NULL, NULL, 173, NULL, 'HIT-like', 284776),
(465689, '0037089', NULL, NULL, 160, NULL, 'HIT-like', 284776),
(465690, '0043746', NULL, NULL, 192, NULL, 'HIT-like', 284776),
(465691, '0038272', NULL, NULL, 176, NULL, 'HIT-like', 284776),
(465692, '0038273', NULL, NULL, 171, NULL, 'HIT-like', 284776),
(465693, '0044881', NULL, NULL, 192, NULL, 'HIT-like', 284776),
(465694, '0051072', NULL, NULL, 113, NULL, 'HIT-like', 284776),
(465695, '0053970', NULL, NULL, 112, NULL, 'NSP3A-like', 284777),
(465696, '0051282', NULL, NULL, 66, NULL, 'TFB5-like', 284778),
(465697, '0054950', NULL, NULL, 120, NULL, 'BTG domain-like', 284779),
(465698, '0054756', NULL, NULL, 117, NULL, 'BTG domain-like', 284779),
(465699, '0041454', NULL, NULL, 254, NULL, 'FabD/lysophospholipase-like', 284780),
(465700, '0048184', NULL, NULL, 236, NULL, 'FabD/lysophospholipase-like', 284780),
(465701, '0036023', NULL, NULL, 580, NULL, 'FabD/lysophospholipase-like', 284780),
(465702, '0048659', NULL, NULL, 360, NULL, 'FabD/lysophospholipase-like', 284780),
(465703, '0048912', NULL, NULL, 128, NULL, 'TT1751-like', 284781),
(465704, '0047505', NULL, NULL, 127, NULL, 'TT1751-like', 284781),
(465705, '0049554', NULL, NULL, 678, NULL, 'L-aspartase-like', 284782),
(465706, '0045086', NULL, NULL, 459, NULL, 'L-aspartase-like', 284782),
(465707, '0038817', NULL, NULL, 453, NULL, 'L-aspartase-like', 284782),
(465708, '0035400', NULL, NULL, 509, NULL, 'L-aspartase-like', 284782),
(465709, '0039747', NULL, NULL, 459, NULL, 'L-aspartase-like', 284782),
(465710, '0036521', NULL, NULL, 402, NULL, 'L-aspartase-like', 284782),
(465711, '0039358', NULL, NULL, 462, NULL, 'L-aspartase-like', 284782),
(465712, '0035216', NULL, NULL, 447, NULL, 'L-aspartase-like', 284782),
(465713, '0035831', NULL, NULL, 429, NULL, 'L-aspartase-like', 284782),
(465714, '0037788', NULL, NULL, 456, NULL, 'L-aspartase-like', 284782),
(465715, '0050346', NULL, NULL, 692, NULL, 'L-aspartase-like', 284782),
(465716, '0037332', NULL, NULL, 408, NULL, 'L-aspartase-like', 284782),
(465717, '0043207', NULL, NULL, 448, NULL, 'L-aspartase-like', 284782),
(465718, '0042625', NULL, NULL, 444, NULL, 'L-aspartase-like', 284782),
(465719, '0035142', NULL, NULL, 443, NULL, 'L-aspartase-like', 284782),
(465720, '0038780', NULL, NULL, 447, NULL, 'L-aspartase-like', 284782),
(465721, '0044708', NULL, NULL, 460, NULL, 'L-aspartase-like', 284782),
(465722, '0049643', NULL, NULL, 455, NULL, 'L-aspartase-like', 284782),
(465723, '0043518', NULL, NULL, 106, NULL, 'Multidrug resistance efflux transporter EmrE', 284783),
(465724, '0044724', NULL, NULL, 37, NULL, 'Cytochrome f subunit of the cytochrome b6f complex, transmembrane anchor', 284784),
(465725, '0042665', NULL, NULL, 45, NULL, 'Cytochrome f subunit of the cytochrome b6f complex, transmembrane anchor', 284784),
(465726, '0051881', NULL, NULL, 101, NULL, 'Atu1913-like', 284785),
(465727, '0051606', NULL, NULL, 124, NULL, 'HisI-like', 284786),
(465728, '0049964', NULL, NULL, 64, NULL, 'Bubble protein', 284787),
(465729, '0048561', NULL, NULL, 312, NULL, 'Fucose-specific lectin', 284788),
(465730, '0047452', NULL, NULL, 132, NULL, 'SEA domain', 284789),
(465731, '0042633', NULL, NULL, 107, NULL, 'KaiA/RbsU domain', 284790),
(465732, '0044943', NULL, NULL, 84, NULL, 'KaiA/RbsU domain', 284790),
(465733, '0043173', NULL, NULL, 106, NULL, 'KaiA/RbsU domain', 284790),
(465734, '0044598', NULL, NULL, 106, NULL, 'KaiA/RbsU domain', 284790),
(465735, '0043138', NULL, NULL, 98, NULL, 'KaiA/RbsU domain', 284790),
(465736, '0039342', NULL, NULL, 333, NULL, 'Nicotinate mononucleotide:5,6-dimethylbenzimidazole phosphoribosyltransferase (CobT)', 284791);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(465737, '0036226', NULL, NULL, 346, NULL, 'Nicotinate mononucleotide:5,6-dimethylbenzimidazole phosphoribosyltransferase (CobT)', 284791),
(465738, '0037883', NULL, NULL, 162, NULL, 'Ganglioside M2 (gm2) activator', 284792),
(465739, '0039461', NULL, NULL, 31, NULL, 'Subunit XII of photosystem I reaction centre, PsaM', 284793),
(465740, '0048383', NULL, NULL, 65, NULL, 'GLA-domain', 284794),
(465741, '0042600', NULL, NULL, 34, NULL, 'GLA-domain', 284794),
(465742, '0048382', NULL, NULL, 45, NULL, 'GLA-domain', 284794),
(465743, '0042658', NULL, NULL, 37, NULL, 'GLA-domain', 284794),
(465744, '0042111', NULL, NULL, 47, NULL, 'GLA-domain', 284794),
(465745, '0042296', NULL, NULL, 46, NULL, 'GLA-domain', 284794),
(465746, '0047402', NULL, NULL, 44, NULL, 'GLA-domain', 284794),
(465747, '0036323', NULL, NULL, 48, NULL, 'GLA-domain', 284794),
(465748, '0040622', NULL, NULL, 33, NULL, 'GLA-domain', 284794),
(465749, '0051441', NULL, NULL, 77, NULL, 'MIT domain', 284795),
(465750, '0052227', NULL, NULL, 104, NULL, 'MIT domain', 284795),
(465751, '0050489', NULL, NULL, 93, NULL, 'MIT domain', 284795),
(465752, '0050981', NULL, NULL, 381, NULL, 'Nucleoporin domain', 284796),
(465753, '0051008', NULL, NULL, 403, NULL, 'Nucleoporin domain', 284796),
(465754, '0054259', NULL, NULL, 62, NULL, 'YegP-like', 284797),
(465755, '0054252', NULL, NULL, 58, NULL, 'YegP-like', 284797),
(465756, '0054261', NULL, NULL, 52, NULL, 'YegP-like', 284797),
(465757, '0054251', NULL, NULL, 52, NULL, 'YegP-like', 284797),
(465758, '0054260', NULL, NULL, 58, NULL, 'YegP-like', 284797),
(465759, '0054832', NULL, NULL, 56, NULL, 'YegP-like', 284797),
(465760, '0046769', NULL, NULL, 186, NULL, 'Translational machinery components', 284798),
(465761, '0054610', NULL, NULL, 117, NULL, 'Translational machinery components', 284798),
(465762, '0048651', NULL, NULL, 97, NULL, 'Translational machinery components', 284798),
(465763, '0054783', NULL, NULL, 104, NULL, 'Translational machinery components', 284798),
(465764, '0054002', NULL, NULL, 113, NULL, 'Translational machinery components', 284798),
(465765, '0047384', NULL, NULL, 90, NULL, 'Translational machinery components', 284798),
(465766, '0046396', NULL, NULL, 134, NULL, 'Translational machinery components', 284798),
(465767, '0054592', NULL, NULL, 117, NULL, 'Translational machinery components', 284798),
(465768, '0054716', NULL, NULL, 142, NULL, 'Translational machinery components', 284798),
(465769, '0046799', NULL, NULL, 119, NULL, 'Translational machinery components', 284798),
(465770, '0050673', NULL, NULL, 249, NULL, 'Heme oxygenase-like', 284799),
(465771, '0048277', NULL, NULL, 214, NULL, 'Heme oxygenase-like', 284799),
(465772, '0047453', NULL, NULL, 207, NULL, 'Heme oxygenase-like', 284799),
(465773, '0049145', NULL, NULL, 213, NULL, 'Heme oxygenase-like', 284799),
(465774, '0051692', NULL, NULL, 231, NULL, 'Heme oxygenase-like', 284799),
(465775, '0052581', NULL, NULL, 215, NULL, 'Heme oxygenase-like', 284799),
(465776, '0052925', NULL, NULL, 211, NULL, 'Heme oxygenase-like', 284799),
(465777, '0050457', NULL, NULL, 222, NULL, 'Heme oxygenase-like', 284799),
(465778, '0051513', NULL, NULL, 217, NULL, 'Heme oxygenase-like', 284799),
(465779, '0050729', NULL, NULL, 180, NULL, 'Heme oxygenase-like', 284799),
(465780, '0044286', NULL, NULL, 215, NULL, 'Heme oxygenase-like', 284799),
(465781, '0044069', NULL, NULL, 225, NULL, 'Heme oxygenase-like', 284799),
(465782, '0043377', NULL, NULL, 206, NULL, 'Heme oxygenase-like', 284799),
(465783, '0047524', NULL, NULL, 200, NULL, 'Heme oxygenase-like', 284799),
(465784, '0048646', NULL, NULL, 254, NULL, 'Heme oxygenase-like', 284799),
(465785, '0043643', NULL, NULL, 187, NULL, 'Heme oxygenase-like', 284799),
(465786, '0046404', NULL, NULL, 214, NULL, 'Heme oxygenase-like', 284799),
(465787, '0051501', NULL, NULL, 129, NULL, 'YidB-like', 284800),
(465788, '0040390', NULL, NULL, 490, NULL, 'Aconitase iron-sulfur domain', 284801),
(465789, '0051895', NULL, NULL, 629, NULL, 'Aconitase iron-sulfur domain', 284801),
(465790, '0034996', NULL, NULL, 527, NULL, 'Aconitase iron-sulfur domain', 284801);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(465791, '0054510', NULL, NULL, 256, NULL, 'PSTPO5379-like', 284802),
(465792, '0047063', NULL, NULL, 67, NULL, 'MOP-like', 284803),
(465793, '0050043', NULL, NULL, 70, NULL, 'MOP-like', 284803),
(465794, '0047155', NULL, NULL, 77, NULL, 'MOP-like', 284803),
(465795, '0047156', NULL, NULL, 62, NULL, 'MOP-like', 284803),
(465796, '0047153', NULL, NULL, 73, NULL, 'MOP-like', 284803),
(465797, '0050042', NULL, NULL, 54, NULL, 'MOP-like', 284803),
(465798, '0047154', NULL, NULL, 68, NULL, 'MOP-like', 284803),
(465799, '0054916', NULL, NULL, 119, NULL, 'MOP-like', 284803),
(465800, '0046847', NULL, NULL, 67, NULL, 'MOP-like', 284803),
(465801, '0046904', NULL, NULL, 61, NULL, 'MOP-like', 284803),
(465802, '0046905', NULL, NULL, 71, NULL, 'MOP-like', 284803),
(465803, '0048857', NULL, NULL, 135, NULL, 'MOP-like', 284803),
(465804, '0048658', NULL, NULL, 110, NULL, 'MOP-like', 284803),
(465805, '0052783', NULL, NULL, 42, NULL, 'HIT/MYND zinc finger-like', 284804),
(465806, '0050816', NULL, NULL, 46, NULL, 'HIT/MYND zinc finger-like', 284804),
(465807, '0052447', NULL, NULL, 47, NULL, 'HIT/MYND zinc finger-like', 284804),
(465808, '0052402', NULL, NULL, 57, NULL, 'HIT/MYND zinc finger-like', 284804),
(465809, '0054034', NULL, NULL, 60, NULL, 'XkdW-like', 284805),
(465810, '0041345', NULL, NULL, 129, NULL, 'Fumarate reductase respiratory complex transmembrane subunits', 284806),
(465811, '0052036', NULL, NULL, 254, NULL, 'Fumarate reductase respiratory complex transmembrane subunits', 284806),
(465812, '0040054', NULL, NULL, 119, NULL, 'Fumarate reductase respiratory complex transmembrane subunits', 284806),
(465813, '0040053', NULL, NULL, 130, NULL, 'Fumarate reductase respiratory complex transmembrane subunits', 284806),
(465814, '0048347', NULL, NULL, 113, NULL, 'Fumarate reductase respiratory complex transmembrane subunits', 284806),
(465815, '0054345', NULL, NULL, 225, NULL, 'AGR C 984p-like', 284807),
(465816, '0051391', NULL, NULL, 55, NULL, 'Calcyclin-binding protein-like', 284808),
(465817, '0051689', NULL, NULL, 47, NULL, 'Calcyclin-binding protein-like', 284808),
(465818, '0054534', NULL, NULL, 107, NULL, 'TAFH domain-like', 284809),
(465819, '0054472', NULL, NULL, 97, NULL, 'TAFH domain-like', 284809),
(465820, '0049042', NULL, NULL, 127, NULL, 'YjgF-like', 284810),
(465821, '0052332', NULL, NULL, 116, NULL, 'YjgF-like', 284810),
(465822, '0052530', NULL, NULL, 120, NULL, 'YjgF-like', 284810),
(465823, '0047562', NULL, NULL, 126, NULL, 'YjgF-like', 284810),
(465824, '0051889', NULL, NULL, 126, NULL, 'YjgF-like', 284810),
(465825, '0042282', NULL, NULL, 130, NULL, 'YjgF-like', 284810),
(465826, '0050777', NULL, NULL, 124, NULL, 'YjgF-like', 284810),
(465827, '0036333', NULL, NULL, 127, NULL, 'YjgF-like', 284810),
(465828, '0052325', NULL, NULL, 124, NULL, 'YjgF-like', 284810),
(465829, '0054414', NULL, NULL, 152, NULL, 'YjgF-like', 284810),
(465830, '0048608', NULL, NULL, 136, NULL, 'YjgF-like', 284810),
(465831, '0044338', NULL, NULL, 121, NULL, 'YjgF-like', 284810),
(465832, '0047528', NULL, NULL, 130, NULL, 'YjgF-like', 284810),
(465833, '0048914', NULL, NULL, 132, NULL, 'YjgF-like', 284810),
(465834, '0050969', NULL, NULL, 112, NULL, 'YjgF-like', 284810),
(465835, '0048930', NULL, NULL, 124, NULL, 'YjgF-like', 284810),
(465836, '0051080', NULL, NULL, 125, NULL, 'YjgF-like', 284810),
(465837, '0048417', NULL, NULL, 133, NULL, 'YjgF-like', 284810),
(465838, '0043318', NULL, NULL, 258, NULL, 'Alpha-2,3/8-sialyltransferase CstII', 284811),
(465839, '0042622', NULL, NULL, 156, NULL, 'Pili subunits', 284812),
(465840, '0041982', NULL, NULL, 144, NULL, 'Pili subunits', 284812),
(465841, '0041981', NULL, NULL, 171, NULL, 'Pili subunits', 284812),
(465842, '0054671', NULL, NULL, 166, NULL, 'Pili subunits', 284812),
(465843, '0054891', NULL, NULL, 107, NULL, 'Pili subunits', 284812),
(465844, '0052938', NULL, NULL, 101, NULL, 'Pili subunits', 284812),
(465845, '0054670', NULL, NULL, 81, NULL, 'Pili subunits', 284812),
(465846, '0038669', NULL, NULL, 129, NULL, 'Pili subunits', 284812),
(465847, '0049569', NULL, NULL, 108, NULL, 'Pili subunits', 284812);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(465848, '0045412', NULL, NULL, 158, NULL, 'Pili subunits', 284812),
(465849, '0054888', NULL, NULL, 154, NULL, 'Pili subunits', 284812),
(465850, '0054887', NULL, NULL, 84, NULL, 'Pili subunits', 284812),
(465851, '0049131', NULL, NULL, 187, NULL, 'Typo IV secretion system protein TraC', 284813),
(465852, '0050748', NULL, NULL, 161, NULL, 'Hypothetical protein ST1625', 284814),
(465853, '0050107', NULL, NULL, 101, NULL, 'MAST3 pre-PK domain-like', 284815),
(465854, '0043146', NULL, NULL, 295, NULL, 'Virulence-associated V antigen', 284816),
(465855, '0049440', NULL, NULL, 393, NULL, 'WD40 repeat-like', 284817),
(465856, '0054424', NULL, NULL, 342, NULL, 'WD40 repeat-like', 284817),
(465857, '0048681', NULL, NULL, 293, NULL, 'WD40 repeat-like', 284817),
(465858, '0048420', NULL, NULL, 311, NULL, 'WD40 repeat-like', 284817),
(465859, '0047024', NULL, NULL, 339, NULL, 'WD40 repeat-like', 284817),
(465860, '0047761', NULL, NULL, 371, NULL, 'WD40 repeat-like', 284817),
(465861, '0048421', NULL, NULL, 299, NULL, 'WD40 repeat-like', 284817),
(465862, '0049784', NULL, NULL, 340, NULL, 'WD40 repeat-like', 284817),
(465863, '0047077', NULL, NULL, 337, NULL, 'WD40 repeat-like', 284817),
(465864, '0048760', NULL, NULL, 287, NULL, 'WD40 repeat-like', 284817),
(465865, '0053623', NULL, NULL, 317, NULL, 'WD40 repeat-like', 284817),
(465866, '0046612', NULL, NULL, 388, NULL, 'WD40 repeat-like', 284817),
(465867, '0048759', NULL, NULL, 325, NULL, 'WD40 repeat-like', 284817),
(465868, '0048349', NULL, NULL, 355, NULL, 'WD40 repeat-like', 284817),
(465869, '0050930', NULL, NULL, 105, NULL, 'PPK N-terminal domain-like', 284818),
(465870, '0053237', NULL, NULL, 109, NULL, 'PPK N-terminal domain-like', 284818),
(465871, '0039454', NULL, NULL, 138, NULL, 'Photosystem I subunit PsaD', 284819),
(465872, '0054890', NULL, NULL, 110, NULL, 'GspK insert domain-like', 284820),
(465873, '0054889', NULL, NULL, 71, NULL, 'GspK insert domain-like', 284820),
(465874, '0039086', NULL, NULL, 107, NULL, 'Ribosome binding protein Y (YfiA homologue)', 284821),
(465875, '0040382', NULL, NULL, 112, NULL, 'Ribosome binding protein Y (YfiA homologue)', 284821),
(465876, '0054749', NULL, NULL, 95, NULL, 'Ribosome binding protein Y (YfiA homologue)', 284821),
(465877, '0039652', NULL, NULL, 157, NULL, 'IpsF-like', 284822),
(465878, '0039813', NULL, NULL, 155, NULL, 'IpsF-like', 284822),
(465879, '0039216', NULL, NULL, 150, NULL, 'IpsF-like', 284822),
(465880, '0050367', NULL, NULL, 163, NULL, 'IpsF-like', 284822),
(465881, '0049504', NULL, NULL, 158, NULL, 'IpsF-like', 284822),
(465882, '0035847', NULL, NULL, 161, NULL, 'Ornithine decarboxylase C-terminal domain', 284823),
(465883, '0049471', NULL, NULL, 115, NULL, 'Calcium ATPase, transduction domain A', 284824),
(465884, '0036891', NULL, NULL, 41, NULL, 'Peripheral subunit-binding domain of 2-oxo acid dehydrogenase complex', 284825),
(465885, '0035432', NULL, NULL, 51, NULL, 'Peripheral subunit-binding domain of 2-oxo acid dehydrogenase complex', 284825),
(465886, '0041586', NULL, NULL, 47, NULL, 'Transcription factor IIA (TFIIA), beta-barrel domain', 284826),
(465887, '0048359', NULL, NULL, 59, NULL, 'Transcription factor IIA (TFIIA), beta-barrel domain', 284826),
(465888, '0041588', NULL, NULL, 46, NULL, 'Transcription factor IIA (TFIIA), beta-barrel domain', 284826),
(465889, '0045106', NULL, NULL, 65, NULL, 'Transcription factor IIA (TFIIA), beta-barrel domain', 284826),
(465890, '0040509', NULL, NULL, 177, NULL, 'Globin-like', 284827),
(465891, '0040508', NULL, NULL, 164, NULL, 'Globin-like', 284827),
(465892, '0035399', NULL, NULL, 177, NULL, 'Globin-like', 284827),
(465893, '0035398', NULL, NULL, 164, NULL, 'Globin-like', 284827),
(465894, '0037451', NULL, NULL, 172, NULL, 'Globin-like', 284827),
(465895, '0042778', NULL, NULL, 175, NULL, 'Globin-like', 284827),
(465896, '0037450', NULL, NULL, 162, NULL, 'Globin-like', 284827),
(465897, '0048236', NULL, NULL, 123, NULL, 'Globin-like', 284827),
(465898, '0048357', NULL, NULL, 126, NULL, 'Globin-like', 284827),
(465899, '0046853', NULL, NULL, 143, NULL, 'Globin-like', 284827);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(465900, '0040873', NULL, NULL, 146, NULL, 'Globin-like', 284827),
(465901, '0035426', NULL, NULL, 146, NULL, 'Globin-like', 284827),
(465902, '0039501', NULL, NULL, 143, NULL, 'Globin-like', 284827),
(465903, '0035425', NULL, NULL, 142, NULL, 'Globin-like', 284827),
(465904, '0036117', NULL, NULL, 150, NULL, 'Globin-like', 284827),
(465905, '0039500', NULL, NULL, 141, NULL, 'Globin-like', 284827),
(465906, '0039186', NULL, NULL, 146, NULL, 'Globin-like', 284827),
(465907, '0038097', NULL, NULL, 162, NULL, 'Globin-like', 284827),
(465908, '0038098', NULL, NULL, 172, NULL, 'Globin-like', 284827),
(465909, '0038490', NULL, NULL, 147, NULL, 'Globin-like', 284827),
(465910, '0047432', NULL, NULL, 141, NULL, 'Globin-like', 284827),
(465911, '0049698', NULL, NULL, 131, NULL, 'Globin-like', 284827),
(465912, '0034966', NULL, NULL, 145, NULL, 'Globin-like', 284827),
(465913, '0047160', NULL, NULL, 141, NULL, 'Globin-like', 284827),
(465914, '0052870', NULL, NULL, 153, NULL, 'Globin-like', 284827),
(465915, '0048134', NULL, NULL, 153, NULL, 'Globin-like', 284827),
(465916, '0039611', NULL, NULL, 147, NULL, 'Globin-like', 284827),
(465917, '0042036', NULL, NULL, 146, NULL, 'Globin-like', 284827),
(465918, '0046518', NULL, NULL, 136, NULL, 'Globin-like', 284827),
(465919, '0042035', NULL, NULL, 142, NULL, 'Globin-like', 284827),
(465920, '0045308', NULL, NULL, 147, NULL, 'Globin-like', 284827),
(465921, '0042318', NULL, NULL, 162, NULL, 'Globin-like', 284827),
(465922, '0044617', NULL, NULL, 143, NULL, 'Globin-like', 284827),
(465923, '0036100', NULL, NULL, 172, NULL, 'Globin-like', 284827),
(465924, '0037272', NULL, NULL, 164, NULL, 'Globin-like', 284827),
(465925, '0042319', NULL, NULL, 172, NULL, 'Globin-like', 284827),
(465926, '0044618', NULL, NULL, 146, NULL, 'Globin-like', 284827),
(465927, '0037273', NULL, NULL, 177, NULL, 'Globin-like', 284827),
(465928, '0047201', NULL, NULL, 158, NULL, 'Globin-like', 284827),
(465929, '0035092', NULL, NULL, 161, NULL, 'Globin-like', 284827),
(465930, '0046359', NULL, NULL, 121, NULL, 'Globin-like', 284827),
(465931, '0035091', NULL, NULL, 160, NULL, 'Globin-like', 284827),
(465932, '0041985', NULL, NULL, 169, NULL, 'Globin-like', 284827),
(465933, '0038916', NULL, NULL, 162, NULL, 'Globin-like', 284827),
(465934, '0038917', NULL, NULL, 172, NULL, 'Globin-like', 284827),
(465935, '0053691', NULL, NULL, 146, NULL, 'Globin-like', 284827),
(465936, '0042568', NULL, NULL, 148, NULL, 'Globin-like', 284827),
(465937, '0041879', NULL, NULL, 147, NULL, 'Globin-like', 284827),
(465938, '0047975', NULL, NULL, 153, NULL, 'Globin-like', 284827),
(465939, '0041116', NULL, NULL, 153, NULL, 'Globin-like', 284827),
(465940, '0053188', NULL, NULL, 153, NULL, 'Globin-like', 284827),
(465941, '0050879', NULL, NULL, 147, NULL, 'Globin-like', 284827),
(465942, '0038624', NULL, NULL, 157, NULL, 'Globin-like', 284827),
(465943, '0045725', NULL, NULL, 151, NULL, 'Globin-like', 284827),
(465944, '0040157', NULL, NULL, 161, NULL, 'Globin-like', 284827),
(465945, '0040156', NULL, NULL, 160, NULL, 'Globin-like', 284827),
(465946, '0038983', NULL, NULL, 127, NULL, 'Globin-like', 284827),
(465947, '0047863', NULL, NULL, 110, NULL, 'Globin-like', 284827),
(465948, '0046411', NULL, NULL, 152, NULL, 'Globin-like', 284827),
(465949, '0037094', NULL, NULL, 153, NULL, 'Globin-like', 284827),
(465950, '0044752', NULL, NULL, 144, NULL, 'Globin-like', 284827),
(465951, '0044511', NULL, NULL, 154, NULL, 'Globin-like', 284827),
(465952, '0045566', NULL, NULL, 145, NULL, 'Globin-like', 284827),
(465953, '0050880', NULL, NULL, 145, NULL, 'Globin-like', 284827),
(465954, '0050882', NULL, NULL, 140, NULL, 'Globin-like', 284827),
(465955, '0050881', NULL, NULL, 149, NULL, 'Globin-like', 284827),
(465956, '0035981', NULL, NULL, 146, NULL, 'Globin-like', 284827),
(465957, '0047071', NULL, NULL, 146, NULL, 'Globin-like', 284827),
(465958, '0044646', NULL, NULL, 141, NULL, 'Globin-like', 284827),
(465959, '0044647', NULL, NULL, 142, NULL, 'Globin-like', 284827),
(465960, '0043838', NULL, NULL, 142, NULL, 'Globin-like', 284827);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(465961, '0035185', NULL, NULL, 147, NULL, 'Globin-like', 284827),
(465962, '0043839', NULL, NULL, 146, NULL, 'Globin-like', 284827),
(465963, '0043550', NULL, NULL, 149, NULL, 'Globin-like', 284827),
(465964, '0043551', NULL, NULL, 150, NULL, 'Globin-like', 284827),
(465965, '0051063', NULL, NULL, 146, NULL, 'Globin-like', 284827),
(465966, '0051062', NULL, NULL, 142, NULL, 'Globin-like', 284827),
(465967, '0035972', NULL, NULL, 141, NULL, 'Globin-like', 284827),
(465968, '0035971', NULL, NULL, 141, NULL, 'Globin-like', 284827),
(465969, '0050016', NULL, NULL, 119, NULL, 'Globin-like', 284827),
(465970, '0041146', NULL, NULL, 146, NULL, 'Globin-like', 284827),
(465971, '0035292', NULL, NULL, 142, NULL, 'Globin-like', 284827),
(465972, '0038560', NULL, NULL, 141, NULL, 'Globin-like', 284827),
(465973, '0038561', NULL, NULL, 145, NULL, 'Globin-like', 284827),
(465974, '0045349', NULL, NULL, 149, NULL, 'Globin-like', 284827),
(465975, '0038959', NULL, NULL, 146, NULL, 'Globin-like', 284827),
(465976, '0046284', NULL, NULL, 165, NULL, 'Globin-like', 284827),
(465977, '0049399', NULL, NULL, 146, NULL, 'Globin-like', 284827),
(465978, '0035323', NULL, NULL, 161, NULL, 'Globin-like', 284827),
(465979, '0050304', NULL, NULL, 147, NULL, 'Globin-like', 284827),
(465980, '0034870', NULL, NULL, 141, NULL, 'Globin-like', 284827),
(465981, '0035322', NULL, NULL, 160, NULL, 'Globin-like', 284827),
(465982, '0037868', NULL, NULL, 141, NULL, 'Globin-like', 284827),
(465983, '0034871', NULL, NULL, 146, NULL, 'Globin-like', 284827),
(465984, '0037869', NULL, NULL, 145, NULL, 'Globin-like', 284827),
(465985, '0038958', NULL, NULL, 141, NULL, 'Globin-like', 284827),
(465986, '0037587', NULL, NULL, 141, NULL, 'Globin-like', 284827),
(465987, '0037588', NULL, NULL, 146, NULL, 'Globin-like', 284827),
(465988, '0037501', NULL, NULL, 146, NULL, 'Globin-like', 284827),
(465989, '0036492', NULL, NULL, 116, NULL, 'Globin-like', 284827),
(465990, '0037223', NULL, NULL, 137, NULL, 'Globin-like', 284827),
(465991, '0042244', NULL, NULL, 146, NULL, 'Globin-like', 284827),
(465992, '0042922', NULL, NULL, 141, NULL, 'Globin-like', 284827),
(465993, '0042923', NULL, NULL, 146, NULL, 'Globin-like', 284827),
(465994, '0036099', NULL, NULL, 162, NULL, 'Globin-like', 284827),
(465995, '0046962', NULL, NULL, 136, NULL, 'Globin-like', 284827),
(465996, '0046961', NULL, NULL, 140, NULL, 'Globin-like', 284827),
(465997, '0043695', NULL, NULL, 143, NULL, 'Globin-like', 284827),
(465998, '0043696', NULL, NULL, 147, NULL, 'Globin-like', 284827),
(465999, '0044268', NULL, NULL, 149, NULL, 'Globin-like', 284827),
(466000, '0038562', NULL, NULL, 135, NULL, 'Bacterial GAP domain', 284828),
(466001, '0038782', NULL, NULL, 120, NULL, 'Bacterial GAP domain', 284828),
(466002, '0037933', NULL, NULL, 130, NULL, 'Bacterial GAP domain', 284828),
(466003, '0041787', NULL, NULL, 47, NULL, 'Mitochondrial cytochrome c oxidase subunit VIIc (aka VIIIa)', 284829),
(466004, '0045989', NULL, NULL, 298, NULL, 'LigB-like', 284830),
(466005, '0054554', NULL, NULL, 258, NULL, 'LigB-like', 284830),
(466006, '0036012', NULL, NULL, 223, NULL, 'delta-Endotoxin (insectocide), N-terminal domain', 284831),
(466007, '0036485', NULL, NULL, 229, NULL, 'delta-Endotoxin (insectocide), N-terminal domain', 284831),
(466008, '0039561', NULL, NULL, 227, NULL, 'delta-Endotoxin (insectocide), N-terminal domain', 284831),
(466009, '0038888', NULL, NULL, 263, NULL, 'delta-Endotoxin (insectocide), N-terminal domain', 284831),
(466010, '0051364', NULL, NULL, 307, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466011, '0050178', NULL, NULL, 246, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466012, '0053760', NULL, NULL, 542, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466013, '0050195', NULL, NULL, 255, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466014, '0038427', NULL, NULL, 290, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466015, '0054718', NULL, NULL, 540, NULL, 'Nucleotide-diphospho-sugar transferases', 284832);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(466016, '0038005', NULL, NULL, 250, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466017, '0038743', NULL, NULL, 248, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466018, '0052019', NULL, NULL, 381, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466019, '0038881', NULL, NULL, 225, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466020, '0046659', NULL, NULL, 224, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466021, '0047707', NULL, NULL, 229, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466022, '0038003', NULL, NULL, 277, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466023, '0040693', NULL, NULL, 295, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466024, '0042758', NULL, NULL, 255, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466025, '0038020', NULL, NULL, 282, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466026, '0037570', NULL, NULL, 261, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466027, '0053839', NULL, NULL, 231, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466028, '0038462', NULL, NULL, 245, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466029, '0040712', NULL, NULL, 283, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466030, '0048137', NULL, NULL, 291, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466031, '0047989', NULL, NULL, 263, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466032, '0047689', NULL, NULL, 501, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466033, '0046778', NULL, NULL, 272, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466034, '0046833', NULL, NULL, 343, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466035, '0046877', NULL, NULL, 292, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466036, '0044656', NULL, NULL, 252, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466037, '0054091', NULL, NULL, 208, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466038, '0050266', NULL, NULL, 221, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466039, '0050387', NULL, NULL, 226, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466040, '0047373', NULL, NULL, 289, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466041, '0049057', NULL, NULL, 228, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466042, '0043493', NULL, NULL, 339, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466043, '0053791', NULL, NULL, 268, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466044, '0050249', NULL, NULL, 516, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466045, '0050366', NULL, NULL, 205, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466046, '0050959', NULL, NULL, 328, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466047, '0054719', NULL, NULL, 542, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466048, '0053095', NULL, NULL, 378, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466049, '0046466', NULL, NULL, 188, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466050, '0044168', NULL, NULL, 259, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466051, '0048604', NULL, NULL, 265, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466052, '0044743', NULL, NULL, 226, NULL, 'Nucleotide-diphospho-sugar transferases', 284832),
(466053, '0050258', NULL, NULL, 163, NULL, 'Vitelline membrane outer protein-I (VMO-I)', 284833),
(466054, '0053605', NULL, NULL, 87, NULL, 'Kix domain of CBP (creb binding protein)', 284834),
(466055, '0053823', NULL, NULL, 73, NULL, 'Mib/herc2 domain-like', 284835),
(466056, '0054197', NULL, NULL, 34, NULL, 'Apical membrane antigen 1', 284836),
(466057, '0038645', NULL, NULL, 110, NULL, 'Apical membrane antigen 1', 284836),
(466058, '0041339', NULL, NULL, 60, NULL, 'Hypothetical protein YoaG', 284837),
(466059, '0041413', NULL, NULL, 95, NULL, 'Hypothetical protein YjiA, C-terminal domain', 284838);
INSERT INTO "PUBLIC"."MODEL" VALUES
(466060, '0048065', NULL, NULL, 109, NULL, 'PapD-like', 284839),
(466061, '0053784', NULL, NULL, 128, NULL, 'PapD-like', 284839),
(466062, '0047045', NULL, NULL, 124, NULL, 'PapD-like', 284839),
(466063, '0042924', NULL, NULL, 124, NULL, 'PapD-like', 284839),
(466064, '0050581', NULL, NULL, 152, NULL, 'PapD-like', 284839),
(466065, '0049045', NULL, NULL, 121, NULL, 'PapD-like', 284839),
(466066, '0049221', NULL, NULL, 107, NULL, 'PapD-like', 284839),
(466067, '0048701', NULL, NULL, 141, NULL, 'PapD-like', 284839),
(466068, '0047932', NULL, NULL, 120, NULL, 'PapD-like', 284839),
(466069, '0048218', NULL, NULL, 124, NULL, 'PapD-like', 284839),
(466070, '0053991', NULL, NULL, 79, NULL, 'Ribosomal protein S19', 284840),
(466071, '0037627', NULL, NULL, 84, NULL, 'Ribosomal protein S19', 284840),
(466072, '0043738', NULL, NULL, 122, NULL, 'YAP1 redox domain', 284841),
(466073, '0036462', NULL, NULL, 173, NULL, 'Heme-binding protein A (HasA)', 284842),
(466074, '0044713', NULL, NULL, 143, NULL, 'Hut operon positive regulatory protein HutP', 284843),
(466075, '0054753', NULL, NULL, 350, NULL, 'Cysteine proteinases', 284844),
(466076, '0050793', NULL, NULL, 320, NULL, 'Cysteine proteinases', 284844),
(466077, '0054476', NULL, NULL, 334, NULL, 'Cysteine proteinases', 284844),
(466078, '0051162', NULL, NULL, 291, NULL, 'Cysteine proteinases', 284844),
(466079, '0047662', NULL, NULL, 235, NULL, 'Cysteine proteinases', 284844),
(466080, '0036721', NULL, NULL, 274, NULL, 'Cysteine proteinases', 284844),
(466081, '0053901', NULL, NULL, 287, NULL, 'Cysteine proteinases', 284844),
(466082, '0050999', NULL, NULL, 302, NULL, 'Cysteine proteinases', 284844),
(466083, '0053622', NULL, NULL, 215, NULL, 'Cysteine proteinases', 284844),
(466084, '0036163', NULL, NULL, 173, NULL, 'Cysteine proteinases', 284844),
(466085, '0040275', NULL, NULL, 323, NULL, 'Cysteine proteinases', 284844),
(466086, '0043989', NULL, NULL, 228, NULL, 'Cysteine proteinases', 284844),
(466087, '0035230', NULL, NULL, 204, NULL, 'Cysteine proteinases', 284844),
(466088, '0048477', NULL, NULL, 208, NULL, 'Cysteine proteinases', 284844),
(466089, '0048830', NULL, NULL, 368, NULL, 'Cysteine proteinases', 284844),
(466090, '0045204', NULL, NULL, 453, NULL, 'Cysteine proteinases', 284844),
(466091, '0040950', NULL, NULL, 313, NULL, 'Cysteine proteinases', 284844),
(466092, '0050362', NULL, NULL, 277, NULL, 'Cysteine proteinases', 284844),
(466093, '0051256', NULL, NULL, 218, NULL, 'Cysteine proteinases', 284844),
(466094, '0054201', NULL, NULL, 232, NULL, 'Cysteine proteinases', 284844),
(466095, '0046780', NULL, NULL, 221, NULL, 'Cysteine proteinases', 284844),
(466096, '0051855', NULL, NULL, 383, NULL, 'Cysteine proteinases', 284844),
(466097, '0050922', NULL, NULL, 229, NULL, 'Cysteine proteinases', 284844),
(466098, '0051417', NULL, NULL, 241, NULL, 'Cysteine proteinases', 284844),
(466099, '0053877', NULL, NULL, 192, NULL, 'Cysteine proteinases', 284844),
(466100, '0037324', NULL, NULL, 325, NULL, 'Cysteine proteinases', 284844),
(466101, '0053117', NULL, NULL, 305, NULL, 'Cysteine proteinases', 284844),
(466102, '0036392', NULL, NULL, 354, NULL, 'Cysteine proteinases', 284844),
(466103, '0037200', NULL, NULL, 221, NULL, 'Cysteine proteinases', 284844),
(466104, '0044406', NULL, NULL, 188, NULL, 'Cysteine proteinases', 284844),
(466105, '0042902', NULL, NULL, 173, NULL, 'Cysteine proteinases', 284844),
(466106, '0035021', NULL, NULL, 218, NULL, 'Cysteine proteinases', 284844),
(466107, '0041295', NULL, NULL, 347, NULL, 'Cysteine proteinases', 284844),
(466108, '0052181', NULL, NULL, 225, NULL, 'Cysteine proteinases', 284844),
(466109, '0044004', NULL, NULL, 226, NULL, 'Cysteine proteinases', 284844),
(466110, '0054137', NULL, NULL, 138, NULL, 'Cysteine proteinases', 284844),
(466111, '0049065', NULL, NULL, 354, NULL, 'Cysteine proteinases', 284844),
(466112, '0054133', NULL, NULL, 182, NULL, 'Cysteine proteinases', 284844),
(466113, '0053121', NULL, NULL, 191, NULL, 'Cysteine proteinases', 284844),
(466114, '0046199', NULL, NULL, 216, NULL, 'Cysteine proteinases', 284844);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(466115, '0051581', NULL, NULL, 310, NULL, 'Cysteine proteinases', 284844),
(466116, '0051746', NULL, NULL, 218, NULL, 'Cysteine proteinases', 284844),
(466117, '0052516', NULL, NULL, 223, NULL, 'Cysteine proteinases', 284844),
(466118, '0037874', NULL, NULL, 321, NULL, 'Cysteine proteinases', 284844),
(466119, '0044814', NULL, NULL, 397, NULL, 'Cysteine proteinases', 284844),
(466120, '0036067', NULL, NULL, 229, NULL, 'Cysteine proteinases', 284844),
(466121, '0047807', NULL, NULL, 212, NULL, 'Cysteine proteinases', 284844),
(466122, '0045662', NULL, NULL, 229, NULL, 'Cysteine proteinases', 284844),
(466123, '0054051', NULL, NULL, 202, NULL, 'Cysteine proteinases', 284844),
(466124, '0048736', NULL, NULL, 311, NULL, 'Cysteine proteinases', 284844),
(466125, '0045544', NULL, NULL, 317, NULL, 'Cysteine proteinases', 284844),
(466126, '0046317', NULL, NULL, 275, NULL, 'Cysteine proteinases', 284844),
(466127, '0042510', NULL, NULL, 183, NULL, 'Cysteine proteinases', 284844),
(466128, '0048933', NULL, NULL, 253, NULL, 'Cysteine proteinases', 284844),
(466129, '0052048', NULL, NULL, 210, NULL, 'Cysteine proteinases', 284844),
(466130, '0051992', NULL, NULL, 212, NULL, 'Cysteine proteinases', 284844),
(466131, '0054026', NULL, NULL, 336, NULL, 'Cysteine proteinases', 284844),
(466132, '0052043', NULL, NULL, 270, NULL, 'Cysteine proteinases', 284844),
(466133, '0047010', NULL, NULL, 217, NULL, 'Cysteine proteinases', 284844),
(466134, '0052526', NULL, NULL, 148, NULL, 'Cysteine proteinases', 284844),
(466135, '0052887', NULL, NULL, 348, NULL, 'Cysteine proteinases', 284844),
(466136, '0051557', NULL, NULL, 321, NULL, 'Cysteine proteinases', 284844),
(466137, '0046209', NULL, NULL, 316, NULL, 'Cysteine proteinases', 284844),
(466138, '0046968', NULL, NULL, 216, NULL, 'Cysteine proteinases', 284844),
(466139, '0039200', NULL, NULL, 331, NULL, 'Cysteine proteinases', 284844),
(466140, '0045515', NULL, NULL, 458, NULL, 'Cysteine proteinases', 284844),
(466141, '0038312', NULL, NULL, 276, NULL, 'Cysteine proteinases', 284844),
(466142, '0040066', NULL, NULL, 354, NULL, 'Cysteine proteinases', 284844),
(466143, '0039241', NULL, NULL, 215, NULL, 'Cysteine proteinases', 284844),
(466144, '0040429', NULL, NULL, 320, NULL, 'Cysteine proteinases', 284844),
(466145, '0048105', NULL, NULL, 214, NULL, 'Cysteine proteinases', 284844),
(466146, '0043495', NULL, NULL, 224, NULL, 'Cysteine proteinases', 284844),
(466147, '0053371', NULL, NULL, 314, NULL, 'Cysteine proteinases', 284844),
(466148, '0047735', NULL, NULL, 234, NULL, 'Cysteine proteinases', 284844),
(466149, '0046688', NULL, NULL, 215, NULL, 'Cysteine proteinases', 284844),
(466150, '0048493', NULL, NULL, 210, NULL, 'PRTase-like', 284845),
(466151, '0052113', NULL, NULL, 160, NULL, 'PRTase-like', 284845),
(466152, '0052114', NULL, NULL, 184, NULL, 'PRTase-like', 284845),
(466153, '0046350', NULL, NULL, 150, NULL, 'PRTase-like', 284845),
(466154, '0046155', NULL, NULL, 228, NULL, 'PRTase-like', 284845),
(466155, '0050151', NULL, NULL, 153, NULL, 'PRTase-like', 284845),
(466156, '0051163', NULL, NULL, 191, NULL, 'PRTase-like', 284845),
(466157, '0046909', NULL, NULL, 178, NULL, 'PRTase-like', 284845),
(466158, '0038588', NULL, NULL, 173, NULL, 'PRTase-like', 284845),
(466159, '0050136', NULL, NULL, 174, NULL, 'PRTase-like', 284845),
(466160, '0036900', NULL, NULL, 243, NULL, 'PRTase-like', 284845),
(466161, '0051301', NULL, NULL, 178, NULL, 'PRTase-like', 284845),
(466162, '0050435', NULL, NULL, 208, NULL, 'PRTase-like', 284845),
(466163, '0051105', NULL, NULL, 215, NULL, 'PRTase-like', 284845),
(466164, '0042536', NULL, NULL, 183, NULL, 'PRTase-like', 284845),
(466165, '0047309', NULL, NULL, 208, NULL, 'PRTase-like', 284845),
(466166, '0035791', NULL, NULL, 214, NULL, 'PRTase-like', 284845),
(466167, '0036560', NULL, NULL, 230, NULL, 'PRTase-like', 284845),
(466168, '0048919', NULL, NULL, 236, NULL, 'PRTase-like', 284845),
(466169, '0048678', NULL, NULL, 210, NULL, 'PRTase-like', 284845),
(466170, '0046852', NULL, NULL, 233, NULL, 'PRTase-like', 284845);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(466171, '0044334', NULL, NULL, 178, NULL, 'PRTase-like', 284845),
(466172, '0040356', NULL, NULL, 181, NULL, 'PRTase-like', 284845),
(466173, '0041489', NULL, NULL, 179, NULL, 'PRTase-like', 284845),
(466174, '0041687', NULL, NULL, 202, NULL, 'PRTase-like', 284845),
(466175, '0047030', NULL, NULL, 231, NULL, 'PRTase-like', 284845),
(466176, '0050349', NULL, NULL, 182, NULL, 'PRTase-like', 284845),
(466177, '0034851', NULL, NULL, 178, NULL, 'PRTase-like', 284845),
(466178, '0038017', NULL, NULL, 177, NULL, 'PRTase-like', 284845),
(466179, '0050105', NULL, NULL, 208, NULL, 'PRTase-like', 284845),
(466180, '0051755', NULL, NULL, 208, NULL, 'PRTase-like', 284845),
(466181, '0035468', NULL, NULL, 224, NULL, 'PRTase-like', 284845),
(466182, '0041576', NULL, NULL, 150, NULL, 'PRTase-like', 284845),
(466183, '0041991', NULL, NULL, 179, NULL, 'PRTase-like', 284845),
(466184, '0036475', NULL, NULL, 159, NULL, 'PRTase-like', 284845),
(466185, '0049833', NULL, NULL, 129, NULL, 'PRTase-like', 284845),
(466186, '0048249', NULL, NULL, 216, NULL, 'PRTase-like', 284845),
(466187, '0049832', NULL, NULL, 155, NULL, 'PRTase-like', 284845),
(466188, '0041997', NULL, NULL, 213, NULL, 'PRTase-like', 284845),
(466189, '0053775', NULL, NULL, 115, NULL, 'Nucleocapsid protein dimerization domain', 284846),
(466190, '0052130', NULL, NULL, 109, NULL, 'Nucleocapsid protein dimerization domain', 284846),
(466191, '0054110', NULL, NULL, 56, NULL, 'Nucleocapsid protein dimerization domain', 284846),
(466192, '0042173', NULL, NULL, 57, NULL, 'Nucleocapsid protein dimerization domain', 284846),
(466193, '0052875', NULL, NULL, 107, NULL, 'Nucleocapsid protein dimerization domain', 284846),
(466194, '0053706', NULL, NULL, 156, NULL, 'FlhC-like', 284847),
(466195, '0041800', NULL, NULL, 158, NULL, 'GCM domain', 284848),
(466196, '0049448', NULL, NULL, 114, NULL, 'Heme chaperone CcmE', 284849),
(466197, '0047520', NULL, NULL, 100, NULL, 'Heme chaperone CcmE', 284849),
(466198, '0039459', NULL, NULL, 58, NULL, 'Photosystem I reaction center subunit X, PsaK', 284850),
(466199, '0049362', NULL, NULL, 233, NULL, 'CoA-dependent acyltransferases', 284851),
(466200, '0051016', NULL, NULL, 218, NULL, 'CoA-dependent acyltransferases', 284851),
(466201, '0051015', NULL, NULL, 382, NULL, 'CoA-dependent acyltransferases', 284851),
(466202, '0047935', NULL, NULL, 174, NULL, 'CoA-dependent acyltransferases', 284851),
(466203, '0047936', NULL, NULL, 250, NULL, 'CoA-dependent acyltransferases', 284851),
(466204, '0041485', NULL, NULL, 213, NULL, 'CoA-dependent acyltransferases', 284851),
(466205, '0042636', NULL, NULL, 384, NULL, 'CoA-dependent acyltransferases', 284851),
(466206, '0036871', NULL, NULL, 243, NULL, 'CoA-dependent acyltransferases', 284851),
(466207, '0042637', NULL, NULL, 216, NULL, 'CoA-dependent acyltransferases', 284851),
(466208, '0035361', NULL, NULL, 242, NULL, 'CoA-dependent acyltransferases', 284851),
(466209, '0041319', NULL, NULL, 220, NULL, 'CoA-dependent acyltransferases', 284851),
(466210, '0041318', NULL, NULL, 376, NULL, 'CoA-dependent acyltransferases', 284851),
(466211, '0041459', NULL, NULL, 214, NULL, 'CoA-dependent acyltransferases', 284851),
(466212, '0041458', NULL, NULL, 377, NULL, 'CoA-dependent acyltransferases', 284851),
(466213, '0045500', NULL, NULL, 213, NULL, 'CoA-dependent acyltransferases', 284851),
(466214, '0042676', NULL, NULL, 175, NULL, 'CoA-dependent acyltransferases', 284851),
(466215, '0048911', NULL, NULL, 238, NULL, 'CoA-dependent acyltransferases', 284851),
(466216, '0052287', NULL, NULL, 132, NULL, 'SMAD/FHA domain', 284852),
(466217, '0049041', NULL, NULL, 182, NULL, 'SMAD/FHA domain', 284852),
(466218, '0050650', NULL, NULL, 107, NULL, 'SMAD/FHA domain', 284852),
(466219, '0037914', NULL, NULL, 164, NULL, 'SMAD/FHA domain', 284852),
(466220, '0052671', NULL, NULL, 99, NULL, 'SMAD/FHA domain', 284852),
(466221, '0043096', NULL, NULL, 100, NULL, 'SMAD/FHA domain', 284852),
(466222, '0040092', NULL, NULL, 198, NULL, 'SMAD/FHA domain', 284852),
(466223, '0038313', NULL, NULL, 116, NULL, 'SMAD/FHA domain', 284852);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(466224, '0052821', NULL, NULL, 102, NULL, 'SMAD/FHA domain', 284852),
(466225, '0052027', NULL, NULL, 101, NULL, 'SMAD/FHA domain', 284852),
(466226, '0036359', NULL, NULL, 261, NULL, 'SMAD/FHA domain', 284852),
(466227, '0050719', NULL, NULL, 108, NULL, 'SMAD/FHA domain', 284852),
(466228, '0040495', NULL, NULL, 113, NULL, 'SMAD/FHA domain', 284852),
(466229, '0041155', NULL, NULL, 122, NULL, 'SMAD/FHA domain', 284852),
(466230, '0050718', NULL, NULL, 78, NULL, 'SMAD/FHA domain', 284852),
(466231, '0043024', NULL, NULL, 239, NULL, 'SMAD/FHA domain', 284852),
(466232, '0044400', NULL, NULL, 119, NULL, 'SMAD/FHA domain', 284852),
(466233, '0047810', NULL, NULL, 203, NULL, 'SMAD/FHA domain', 284852),
(466234, '0044369', NULL, NULL, 118, NULL, 'SMAD/FHA domain', 284852),
(466235, '0051399', NULL, NULL, 101, NULL, 'Rhodanese/Cell cycle control phosphatase', 284853),
(466236, '0050551', NULL, NULL, 157, NULL, 'Rhodanese/Cell cycle control phosphatase', 284853),
(466237, '0051398', NULL, NULL, 136, NULL, 'Rhodanese/Cell cycle control phosphatase', 284853),
(466238, '0049169', NULL, NULL, 144, NULL, 'Rhodanese/Cell cycle control phosphatase', 284853),
(466239, '0046064', NULL, NULL, 161, NULL, 'Rhodanese/Cell cycle control phosphatase', 284853),
(466240, '0049168', NULL, NULL, 149, NULL, 'Rhodanese/Cell cycle control phosphatase', 284853),
(466241, '0044085', NULL, NULL, 119, NULL, 'Rhodanese/Cell cycle control phosphatase', 284853),
(466242, '0044241', NULL, NULL, 143, NULL, 'Rhodanese/Cell cycle control phosphatase', 284853),
(466243, '0049980', NULL, NULL, 120, NULL, 'Rhodanese/Cell cycle control phosphatase', 284853),
(466244, '0051401', NULL, NULL, 130, NULL, 'Rhodanese/Cell cycle control phosphatase', 284853),
(466245, '0051400', NULL, NULL, 157, NULL, 'Rhodanese/Cell cycle control phosphatase', 284853),
(466246, '0038810', NULL, NULL, 154, NULL, 'Rhodanese/Cell cycle control phosphatase', 284853),
(466247, '0046432', NULL, NULL, 135, NULL, 'Rhodanese/Cell cycle control phosphatase', 284853),
(466248, '0042691', NULL, NULL, 178, NULL, 'Rhodanese/Cell cycle control phosphatase', 284853),
(466249, '0043033', NULL, NULL, 137, NULL, 'Rhodanese/Cell cycle control phosphatase', 284853),
(466250, '0038171', NULL, NULL, 108, NULL, 'Rhodanese/Cell cycle control phosphatase', 284853),
(466251, '0046433', NULL, NULL, 136, NULL, 'Rhodanese/Cell cycle control phosphatase', 284853),
(466252, '0049841', NULL, NULL, 141, NULL, 'Rhodanese/Cell cycle control phosphatase', 284853),
(466253, '0049979', NULL, NULL, 147, NULL, 'Rhodanese/Cell cycle control phosphatase', 284853),
(466254, '0041897', NULL, NULL, 139, NULL, 'Rhodanese/Cell cycle control phosphatase', 284853),
(466255, '0041896', NULL, NULL, 156, NULL, 'Rhodanese/Cell cycle control phosphatase', 284853),
(466256, '0043853', NULL, NULL, 132, NULL, 'Rhodanese/Cell cycle control phosphatase', 284853),
(466257, '0043881', NULL, NULL, 58, NULL, 'Mollusk pheromone', 284854),
(466258, '0037130', NULL, NULL, 189, NULL, 'Mog1p/PsbP-like', 284855),
(466259, '0044594', NULL, NULL, 171, NULL, 'Mog1p/PsbP-like', 284855),
(466260, '0044116', NULL, NULL, 144, NULL, 'Mog1p/PsbP-like', 284855),
(466261, '0054107', NULL, NULL, 147, NULL, 'Mog1p/PsbP-like', 284855),
(466262, '0042721', NULL, NULL, 422, NULL, 'ADC synthase', 284856),
(466263, '0052520', NULL, NULL, 428, NULL, 'ADC synthase', 284856),
(466264, '0038839', NULL, NULL, 512, NULL, 'ADC synthase', 284856),
(466265, '0052838', NULL, NULL, 435, NULL, 'ADC synthase', 284856),
(466266, '0039827', NULL, NULL, 453, NULL, 'ADC synthase', 284856),
(466267, '0038914', NULL, NULL, 517, NULL, 'ADC synthase', 284856),
(466268, '0052723', NULL, NULL, 433, NULL, 'ADC synthase', 284856),
(466269, '0051857', NULL, NULL, 301, NULL, 'NAP-like', 284857),
(466270, '0053864', NULL, NULL, 222, NULL, 'NAP-like', 284857),
(466271, '0052768', NULL, NULL, 243, NULL, 'Nqo1 FMN-binding domain-like', 284858),
(466272, '0054655', NULL, NULL, 235, NULL, 'Glutathione synthetase ATP-binding domain-like', 284859),
(466273, '0054653', NULL, NULL, 238, NULL, 'Glutathione synthetase ATP-binding domain-like', 284859);
INSERT INTO "PUBLIC"."MODEL" VALUES
(466274, '0044272', NULL, NULL, 192, NULL, 'Glutathione synthetase ATP-binding domain-like', 284859),
(466275, '0053122', NULL, NULL, 298, NULL, 'Glutathione synthetase ATP-binding domain-like', 284859),
(466276, '0054495', NULL, NULL, 213, NULL, 'Glutathione synthetase ATP-binding domain-like', 284859),
(466277, '0035376', NULL, NULL, 198, NULL, 'Glutathione synthetase ATP-binding domain-like', 284859),
(466278, '0035215', NULL, NULL, 204, NULL, 'Glutathione synthetase ATP-binding domain-like', 284859),
(466279, '0038243', NULL, NULL, 192, NULL, 'Glutathione synthetase ATP-binding domain-like', 284859),
(466280, '0047408', NULL, NULL, 210, NULL, 'Glutathione synthetase ATP-binding domain-like', 284859),
(466281, '0050408', NULL, NULL, 267, NULL, 'Glutathione synthetase ATP-binding domain-like', 284859),
(466282, '0046632', NULL, NULL, 246, NULL, 'Glutathione synthetase ATP-binding domain-like', 284859),
(466283, '0047322', NULL, NULL, 206, NULL, 'Glutathione synthetase ATP-binding domain-like', 284859),
(466284, '0046656', NULL, NULL, 206, NULL, 'Glutathione synthetase ATP-binding domain-like', 284859),
(466285, '0046457', NULL, NULL, 211, NULL, 'Glutathione synthetase ATP-binding domain-like', 284859),
(466286, '0044434', NULL, NULL, 214, NULL, 'Glutathione synthetase ATP-binding domain-like', 284859),
(466287, '0044852', NULL, NULL, 220, NULL, 'Glutathione synthetase ATP-binding domain-like', 284859),
(466288, '0045447', NULL, NULL, 238, NULL, 'Glutathione synthetase ATP-binding domain-like', 284859),
(466289, '0036618', NULL, NULL, 216, NULL, 'Glutathione synthetase ATP-binding domain-like', 284859),
(466290, '0034972', NULL, NULL, 244, NULL, 'Glutathione synthetase ATP-binding domain-like', 284859),
(466291, '0037006', NULL, NULL, 228, NULL, 'Glutathione synthetase ATP-binding domain-like', 284859),
(466292, '0050127', NULL, NULL, 380, NULL, 'Glutathione synthetase ATP-binding domain-like', 284859),
(466293, '0038251', NULL, NULL, 224, NULL, 'Glutathione synthetase ATP-binding domain-like', 284859),
(466294, '0047135', NULL, NULL, 405, NULL, 'Glutathione synthetase ATP-binding domain-like', 284859),
(466295, '0040724', NULL, NULL, 374, NULL, 'Glutathione synthetase ATP-binding domain-like', 284859),
(466296, '0045751', NULL, NULL, 275, NULL, 'Glutathione synthetase ATP-binding domain-like', 284859),
(466297, '0047779', NULL, NULL, 375, NULL, 'Glutathione synthetase ATP-binding domain-like', 284859),
(466298, '0045315', NULL, NULL, 371, NULL, 'Glutathione synthetase ATP-binding domain-like', 284859),
(466299, '0053837', NULL, NULL, 70, NULL, 'FF domain', 284860),
(466300, '0053838', NULL, NULL, 72, NULL, 'FF domain', 284860),
(466301, '0044575', NULL, NULL, 69, NULL, 'FF domain', 284860),
(466302, '0053836', NULL, NULL, 69, NULL, 'FF domain', 284860),
(466303, '0053732', NULL, NULL, 56, NULL, 'FF domain', 284860),
(466304, '0052247', NULL, NULL, 64, NULL, 'FF domain', 284860),
(466305, '0037084', NULL, NULL, 110, NULL, 'DNA polymerase III psi subunit', 284861),
(466306, '0036828', NULL, NULL, 60, NULL, 'Kringle-like', 284862),
(466307, '0047144', NULL, NULL, 42, NULL, 'Kringle-like', 284862),
(466308, '0035938', NULL, NULL, 80, NULL, 'Kringle-like', 284862),
(466309, '0036829', NULL, NULL, 59, NULL, 'Kringle-like', 284862),
(466310, '0042382', NULL, NULL, 86, NULL, 'Kringle-like', 284862),
(466311, '0036026', NULL, NULL, 58, NULL, 'Kringle-like', 284862),
(466312, '0039409', NULL, NULL, 60, NULL, 'Kringle-like', 284862),
(466313, '0036025', NULL, NULL, 61, NULL, 'Kringle-like', 284862),
(466314, '0035559', NULL, NULL, 84, NULL, 'Kringle-like', 284862),
(466315, '0039525', NULL, NULL, 119, NULL, 'Kringle-like', 284862),
(466316, '0040397', NULL, NULL, 59, NULL, 'Kringle-like', 284862),
(466317, '0045529', NULL, NULL, 79, NULL, 'Kringle-like', 284862),
(466318, '0040396', NULL, NULL, 57, NULL, 'Kringle-like', 284862),
(466319, '0038481', NULL, NULL, 46, NULL, 'Kringle-like', 284862),
(466320, '0040395', NULL, NULL, 59, NULL, 'Kringle-like', 284862),
(466321, '0040097', NULL, NULL, 83, NULL, 'Kringle-like', 284862);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(466322, '0045618', NULL, NULL, 84, NULL, 'Kringle-like', 284862),
(466323, '0040096', NULL, NULL, 87, NULL, 'Kringle-like', 284862),
(466324, '0034809', NULL, NULL, 109, NULL, 'Kringle-like', 284862),
(466325, '0040228', NULL, NULL, 59, NULL, 'Kringle-like', 284862),
(466326, '0053081', NULL, NULL, 83, NULL, 'Kringle-like', 284862),
(466327, '0045401', NULL, NULL, 91, NULL, 'Kringle-like', 284862),
(466328, '0040225', NULL, NULL, 79, NULL, 'Kringle-like', 284862),
(466329, '0045327', NULL, NULL, 79, NULL, 'Kringle-like', 284862),
(466330, '0054457', NULL, NULL, 197, NULL, 'PG1388-like', 284863),
(466331, '0048750', NULL, NULL, 94, NULL, 'Aspartate carbamoyltransferase, Regulatory-chain, N-terminal domain', 284864),
(466332, '0046242', NULL, NULL, 100, NULL, 'Aspartate carbamoyltransferase, Regulatory-chain, N-terminal domain', 284864),
(466333, '0051828', NULL, NULL, 100, NULL, 'Aspartate carbamoyltransferase, Regulatory-chain, N-terminal domain', 284864),
(466334, '0047498', NULL, NULL, 98, NULL, 'Hypothetical protein TT1725', 284865),
(466335, '0037152', NULL, NULL, 151, NULL, 'EV matrix protein', 284866),
(466336, '0037153', NULL, NULL, 121, NULL, 'EV matrix protein', 284866),
(466337, '0054347', NULL, NULL, 187, NULL, 'GAF domain-like', 284867),
(466338, '0054864', NULL, NULL, 192, NULL, 'GAF domain-like', 284867),
(466339, '0054399', NULL, NULL, 194, NULL, 'GAF domain-like', 284867),
(466340, '0048178', NULL, NULL, 171, NULL, 'GAF domain-like', 284867),
(466341, '0050183', NULL, NULL, 159, NULL, 'GAF domain-like', 284867),
(466342, '0048135', NULL, NULL, 187, NULL, 'GAF domain-like', 284867),
(466343, '0049595', NULL, NULL, 179, NULL, 'GAF domain-like', 284867),
(466344, '0054713', NULL, NULL, 188, NULL, 'GAF domain-like', 284867),
(466345, '0054249', NULL, NULL, 170, NULL, 'GAF domain-like', 284867),
(466346, '0054712', NULL, NULL, 196, NULL, 'GAF domain-like', 284867),
(466347, '0054865', NULL, NULL, 185, NULL, 'GAF domain-like', 284867),
(466348, '0049608', NULL, NULL, 184, NULL, 'GAF domain-like', 284867),
(466349, '0043759', NULL, NULL, 236, NULL, 'GAF domain-like', 284867),
(466350, '0048136', NULL, NULL, 154, NULL, 'GAF domain-like', 284867),
(466351, '0046710', NULL, NULL, 176, NULL, 'GAF domain-like', 284867),
(466352, '0042776', NULL, NULL, 76, NULL, 'Non-globular alpha+beta subunits of globular proteins', 284868),
(466353, '0042777', NULL, NULL, 67, NULL, 'Non-globular alpha+beta subunits of globular proteins', 284868),
(466354, '0040341', NULL, NULL, 57, NULL, 'Non-globular alpha+beta subunits of globular proteins', 284868),
(466355, '0039818', NULL, NULL, 102, NULL, 'Non-globular alpha+beta subunits of globular proteins', 284868),
(466356, '0042417', NULL, NULL, 47, NULL, 'Non-globular alpha+beta subunits of globular proteins', 284868),
(466357, '0049297', NULL, NULL, 107, NULL, 'POZ domain', 284869),
(466358, '0043834', NULL, NULL, 100, NULL, 'POZ domain', 284869),
(466359, '0040560', NULL, NULL, 96, NULL, 'POZ domain', 284869),
(466360, '0041351', NULL, NULL, 72, NULL, 'POZ domain', 284869),
(466361, '0042727', NULL, NULL, 99, NULL, 'POZ domain', 284869),
(466362, '0037241', NULL, NULL, 91, NULL, 'POZ domain', 284869),
(466363, '0035720', NULL, NULL, 121, NULL, 'POZ domain', 284869),
(466364, '0043098', NULL, NULL, 122, NULL, 'POZ domain', 284869),
(466365, '0045530', NULL, NULL, 103, NULL, 'POZ domain', 284869),
(466366, '0038738', NULL, NULL, 99, NULL, 'POZ domain', 284869),
(466367, '0037753', NULL, NULL, 61, NULL, 'POZ domain', 284869),
(466368, '0041467', NULL, NULL, 105, NULL, 'POZ domain', 284869),
(466369, '0053722', NULL, NULL, 62, NULL, 'PsbZ-like', 284870),
(466370, '0035029', NULL, NULL, 51, NULL, 'Antifungal protein (AGAFP)', 284871),
(466371, '0044756', NULL, NULL, 157, NULL, 'Hedgehog/DD-peptidase', 284872),
(466372, '0053084', NULL, NULL, 149, NULL, 'Hedgehog/DD-peptidase', 284872),
(466373, '0054728', NULL, NULL, 148, NULL, 'Hedgehog/DD-peptidase', 284872),
(466374, '0043112', NULL, NULL, 202, NULL, 'Hedgehog/DD-peptidase', 284872),
(466375, '0044169', NULL, NULL, 255, NULL, 'Hedgehog/DD-peptidase', 284872);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(466376, '0047953', NULL, NULL, 130, NULL, 'Hedgehog/DD-peptidase', 284872),
(466377, '0042723', NULL, NULL, 104, NULL, 'Saposin', 284873),
(466378, '0041232', NULL, NULL, 78, NULL, 'Saposin', 284873),
(466379, '0040726', NULL, NULL, 84, NULL, 'Saposin', 284873),
(466380, '0041824', NULL, NULL, 77, NULL, 'Saposin', 284873),
(466381, '0040425', NULL, NULL, 74, NULL, 'Saposin', 284873),
(466382, '0041435', NULL, NULL, 78, NULL, 'Saposin', 284873),
(466383, '0043766', NULL, NULL, 633, NULL, 'Prismane protein-like', 284874),
(466384, '0038175', NULL, NULL, 543, NULL, 'Prismane protein-like', 284874),
(466385, '0040966', NULL, NULL, 728, NULL, 'Prismane protein-like', 284874),
(466386, '0040965', NULL, NULL, 672, NULL, 'Prismane protein-like', 284874),
(466387, '0039702', NULL, NULL, 610, NULL, 'Prismane protein-like', 284874),
(466388, '0043379', NULL, NULL, 728, NULL, 'Prismane protein-like', 284874),
(466389, '0036722', NULL, NULL, 553, NULL, 'Prismane protein-like', 284874),
(466390, '0050154', NULL, NULL, 226, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466391, '0047386', NULL, NULL, 225, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466392, '0052693', NULL, NULL, 182, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466393, '0049442', NULL, NULL, 284, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466394, '0054473', NULL, NULL, 225, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466395, '0051885', NULL, NULL, 312, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466396, '0051884', NULL, NULL, 324, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466397, '0050038', NULL, NULL, 297, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466398, '0041444', NULL, NULL, 245, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466399, '0040196', NULL, NULL, 285, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466400, '0046696', NULL, NULL, 321, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466401, '0044550', NULL, NULL, 358, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466402, '0047303', NULL, NULL, 322, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466403, '0047945', NULL, NULL, 261, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466404, '0041326', NULL, NULL, 197, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466405, '0052982', NULL, NULL, 250, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466406, '0054520', NULL, NULL, 252, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466407, '0035026', NULL, NULL, 193, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466408, '0051657', NULL, NULL, 229, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466409, '0052749', NULL, NULL, 260, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466410, '0049171', NULL, NULL, 252, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466411, '0051930', NULL, NULL, 317, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466412, '0048805', NULL, NULL, 226, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466413, '0052618', NULL, NULL, 328, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466414, '0052739', NULL, NULL, 183, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466415, '0047676', NULL, NULL, 207, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466416, '0052182', NULL, NULL, 214, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466417, '0048524', NULL, NULL, 249, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466418, '0046744', NULL, NULL, 230, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(466419, '0044689', NULL, NULL, 224, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466420, '0050693', NULL, NULL, 171, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466421, '0049186', NULL, NULL, 328, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466422, '0051143', NULL, NULL, 234, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466423, '0052510', NULL, NULL, 152, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466424, '0054378', NULL, NULL, 425, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466425, '0052992', NULL, NULL, 190, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466426, '0051261', NULL, NULL, 250, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466427, '0049069', NULL, NULL, 252, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466428, '0043085', NULL, NULL, 223, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466429, '0051823', NULL, NULL, 324, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466430, '0051944', NULL, NULL, 293, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466431, '0048490', NULL, NULL, 266, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466432, '0037952', NULL, NULL, 256, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466433, '0051816', NULL, NULL, 524, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466434, '0041580', NULL, NULL, 271, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466435, '0046354', NULL, NULL, 213, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466436, '0048774', NULL, NULL, 201, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466437, '0047329', NULL, NULL, 264, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466438, '0052001', NULL, NULL, 232, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466439, '0049074', NULL, NULL, 256, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466440, '0047211', NULL, NULL, 261, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466441, '0052484', NULL, NULL, 275, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466442, '0049474', NULL, NULL, 227, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466443, '0050745', NULL, NULL, 318, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466444, '0052649', NULL, NULL, 204, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466445, '0036610', NULL, NULL, 194, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466446, '0051679', NULL, NULL, 257, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466447, '0050988', NULL, NULL, 290, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466448, '0053855', NULL, NULL, 375, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466449, '0036976', NULL, NULL, 279, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466450, '0046923', NULL, NULL, 343, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466451, '0049915', NULL, NULL, 312, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466452, '0041593', NULL, NULL, 328, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466453, '0052084', NULL, NULL, 229, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466454, '0042682', NULL, NULL, 235, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466455, '0047851', NULL, NULL, 291, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466456, '0047580', NULL, NULL, 215, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(466457, '0052894', NULL, NULL, 281, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466458, '0054432', NULL, NULL, 250, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466459, '0040829', NULL, NULL, 193, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466460, '0049122', NULL, NULL, 289, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466461, '0051449', NULL, NULL, 204, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466462, '0053107', NULL, NULL, 183, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466463, '0050234', NULL, NULL, 231, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466464, '0051840', NULL, NULL, 219, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466465, '0052536', NULL, NULL, 222, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466466, '0053229', NULL, NULL, 285, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466467, '0051842', NULL, NULL, 246, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466468, '0054557', NULL, NULL, 395, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466469, '0050749', NULL, NULL, 201, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466470, '0052807', NULL, NULL, 311, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466471, '0047465', NULL, NULL, 313, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466472, '0047862', NULL, NULL, 218, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466473, '0049885', NULL, NULL, 254, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466474, '0054391', NULL, NULL, 271, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466475, '0046931', NULL, NULL, 328, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466476, '0048438', NULL, NULL, 209, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466477, '0050242', NULL, NULL, 208, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466478, '0047471', NULL, NULL, 274, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466479, '0054686', NULL, NULL, 297, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466480, '0049532', NULL, NULL, 274, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466481, '0053077', NULL, NULL, 198, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466482, '0053110', NULL, NULL, 309, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466483, '0050762', NULL, NULL, 251, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466484, '0050919', NULL, NULL, 229, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466485, '0047919', NULL, NULL, 272, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466486, '0050519', NULL, NULL, 183, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466487, '0049778', NULL, NULL, 406, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466488, '0040327', NULL, NULL, 243, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466489, '0040964', NULL, NULL, 276, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466490, '0046303', NULL, NULL, 324, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466491, '0045060', NULL, NULL, 292, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466492, '0054332', NULL, NULL, 282, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466493, '0053087', NULL, NULL, 223, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466494, '0051588', NULL, NULL, 365, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(466495, '0051103', NULL, NULL, 254, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466496, '0045109', NULL, NULL, 245, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466497, '0045988', NULL, NULL, 320, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466498, '0046838', NULL, NULL, 244, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466499, '0051617', NULL, NULL, 278, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466500, '0052709', NULL, NULL, 280, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466501, '0042197', NULL, NULL, 268, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466502, '0052949', NULL, NULL, 194, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466503, '0039093', NULL, NULL, 295, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466504, '0047923', NULL, NULL, 186, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466505, '0048856', NULL, NULL, 259, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466506, '0049671', NULL, NULL, 285, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466507, '0051239', NULL, NULL, 246, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466508, '0049719', NULL, NULL, 253, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466509, '0037982', NULL, NULL, 227, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466510, '0048629', NULL, NULL, 316, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466511, '0050935', NULL, NULL, 239, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466512, '0048106', NULL, NULL, 359, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466513, '0046840', NULL, NULL, 244, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466514, '0046568', NULL, NULL, 180, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466515, '0045633', NULL, NULL, 327, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466516, '0047656', NULL, NULL, 280, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', 284875),
(466517, '0046703', NULL, NULL, 139, NULL, 'Cell-division protein ZipA, C-terminal domain', 284876),
(466518, '0036518', NULL, NULL, 259, NULL, 'Aminoacid dehydrogenase-like, N-terminal domain', 284877),
(466519, '0036929', NULL, NULL, 146, NULL, 'Aminoacid dehydrogenase-like, N-terminal domain', 284877),
(466520, '0035544', NULL, NULL, 194, NULL, 'Aminoacid dehydrogenase-like, N-terminal domain', 284877),
(466521, '0041590', NULL, NULL, 110, NULL, 'Aminoacid dehydrogenase-like, N-terminal domain', 284877),
(466522, '0034873', NULL, NULL, 125, NULL, 'Aminoacid dehydrogenase-like, N-terminal domain', 284877),
(466523, '0042181', NULL, NULL, 101, NULL, 'Aminoacid dehydrogenase-like, N-terminal domain', 284877),
(466524, '0035317', NULL, NULL, 175, NULL, 'Aminoacid dehydrogenase-like, N-terminal domain', 284877),
(466525, '0035734', NULL, NULL, 178, NULL, 'Aminoacid dehydrogenase-like, N-terminal domain', 284877),
(466526, '0035811', NULL, NULL, 148, NULL, 'Aminoacid dehydrogenase-like, N-terminal domain', 284877),
(466527, '0037204', NULL, NULL, 177, NULL, 'Aminoacid dehydrogenase-like, N-terminal domain', 284877),
(466528, '0050104', NULL, NULL, 176, NULL, 'Aminoacid dehydrogenase-like, N-terminal domain', 284877),
(466529, '0038223', NULL, NULL, 257, NULL, 'Aminoacid dehydrogenase-like, N-terminal domain', 284877),
(466530, '0038762', NULL, NULL, 208, NULL, 'Aminoacid dehydrogenase-like, N-terminal domain', 284877),
(466531, '0040474', NULL, NULL, 134, NULL, 'Aminoacid dehydrogenase-like, N-terminal domain', 284877),
(466532, '0035291', NULL, NULL, 121, NULL, 'Aminoacid dehydrogenase-like, N-terminal domain', 284877),
(466533, '0044859', NULL, NULL, 154, NULL, 'Aminoacid dehydrogenase-like, N-terminal domain', 284877);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(466534, '0040549', NULL, NULL, 294, NULL, 'Aminoacid dehydrogenase-like, N-terminal domain', 284877),
(466535, '0041638', NULL, NULL, 101, NULL, 'Aminoacid dehydrogenase-like, N-terminal domain', 284877),
(466536, '0041505', NULL, NULL, 106, NULL, 'Aminoacid dehydrogenase-like, N-terminal domain', 284877),
(466537, '0038260', NULL, NULL, 178, NULL, 'Aminoacid dehydrogenase-like, N-terminal domain', 284877),
(466538, '0040667', NULL, NULL, 96, NULL, 'Aminoacid dehydrogenase-like, N-terminal domain', 284877),
(466539, '0041513', NULL, NULL, 102, NULL, 'Aminoacid dehydrogenase-like, N-terminal domain', 284877),
(466540, '0044548', NULL, NULL, 554, NULL, 'Urocanase', 284878),
(466541, '0050872', NULL, NULL, 545, NULL, 'Urocanase', 284878),
(466542, '0051308', NULL, NULL, 135, NULL, 'Serine metabolism enzymes domain', 284879),
(466543, '0053082', NULL, NULL, 145, NULL, 'Serine metabolism enzymes domain', 284879),
(466544, '0049121', NULL, NULL, 66, NULL, 'Ribosomal protein L29 (L29p)', 284880),
(466545, '0054038', NULL, NULL, 67, NULL, 'Ribosomal protein L29 (L29p)', 284880),
(466546, '0054793', NULL, NULL, 66, NULL, 'Ribosomal protein L29 (L29p)', 284880),
(466547, '0046772', NULL, NULL, 65, NULL, 'Ribosomal protein L29 (L29p)', 284880),
(466548, '0052976', NULL, NULL, 60, NULL, 'Ribosomal protein L29 (L29p)', 284880),
(466549, '0049531', NULL, NULL, 134, NULL, 'DNA primase DnaG, C-terminal domain', 284881),
(466550, '0052630', NULL, NULL, 158, NULL, 'Chorismate lyase-like', 284882),
(466551, '0037809', NULL, NULL, 164, NULL, 'Chorismate lyase-like', 284882),
(466552, '0054302', NULL, NULL, 160, NULL, 'Chorismate lyase-like', 284882),
(466553, '0054662', NULL, NULL, 180, NULL, 'Chorismate lyase-like', 284882),
(466554, '0054142', NULL, NULL, 153, NULL, 'Chorismate lyase-like', 284882),
(466555, '0054396', NULL, NULL, 161, NULL, 'Chorismate lyase-like', 284882),
(466556, '0054451', NULL, NULL, 148, NULL, 'Chorismate lyase-like', 284882),
(466557, '0054370', NULL, NULL, 144, NULL, 'Chorismate lyase-like', 284882),
(466558, '0054517', NULL, NULL, 141, NULL, 'Chorismate lyase-like', 284882),
(466559, '0054846', NULL, NULL, 145, NULL, 'Chorismate lyase-like', 284882),
(466560, '0054899', NULL, NULL, 162, NULL, 'Chorismate lyase-like', 284882),
(466561, '0054931', NULL, NULL, 143, NULL, 'Chorismate lyase-like', 284882),
(466562, '0044905', NULL, NULL, 45, NULL, 'HIV-1 VPU cytoplasmic domain', 284883),
(466563, '0045259', NULL, NULL, 137, NULL, 'T4 endonuclease V', 284884),
(466564, '0051452', NULL, NULL, 83, NULL, 'RuvA domain 2-like', 284885),
(466565, '0054853', NULL, NULL, 73, NULL, 'RuvA domain 2-like', 284885),
(466566, '0054852', NULL, NULL, 90, NULL, 'RuvA domain 2-like', 284885),
(466567, '0051684', NULL, NULL, 78, NULL, 'RuvA domain 2-like', 284885),
(466568, '0052274', NULL, NULL, 55, NULL, 'RuvA domain 2-like', 284885),
(466569, '0047794', NULL, NULL, 56, NULL, 'RuvA domain 2-like', 284885),
(466570, '0052275', NULL, NULL, 55, NULL, 'RuvA domain 2-like', 284885),
(466571, '0053881', NULL, NULL, 91, NULL, 'RuvA domain 2-like', 284885),
(466572, '0052272', NULL, NULL, 59, NULL, 'RuvA domain 2-like', 284885),
(466573, '0052273', NULL, NULL, 57, NULL, 'RuvA domain 2-like', 284885),
(466574, '0035731', NULL, NULL, 71, NULL, 'RuvA domain 2-like', 284885),
(466575, '0050778', NULL, NULL, 68, NULL, 'RuvA domain 2-like', 284885),
(466576, '0051966', NULL, NULL, 70, NULL, 'RuvA domain 2-like', 284885),
(466577, '0036422', NULL, NULL, 181, NULL, 'RuvA domain 2-like', 284885),
(466578, '0036157', NULL, NULL, 78, NULL, 'RuvA domain 2-like', 284885),
(466579, '0053856', NULL, NULL, 65, NULL, 'RuvA domain 2-like', 284885),
(466580, '0039263', NULL, NULL, 73, NULL, 'RuvA domain 2-like', 284885),
(466581, '0054324', NULL, NULL, 197, NULL, 'Virus attachment protein globular domain', 284886),
(466582, '0042800', NULL, NULL, 195, NULL, 'Virus attachment protein globular domain', 284886),
(466583, '0039994', NULL, NULL, 185, NULL, 'Virus attachment protein globular domain', 284886),
(466584, '0038471', NULL, NULL, 191, NULL, 'Virus attachment protein globular domain', 284886);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(466585, '0040161', NULL, NULL, 186, NULL, 'Virus attachment protein globular domain', 284886),
(466586, '0054187', NULL, NULL, 182, NULL, 'Virus attachment protein globular domain', 284886),
(466587, '0051626', NULL, NULL, 103, NULL, 'Virus attachment protein globular domain', 284886),
(466588, '0052557', NULL, NULL, 101, NULL, 'Virus attachment protein globular domain', 284886),
(466589, '0040127', NULL, NULL, 143, NULL, 'Virus attachment protein globular domain', 284886),
(466590, '0044557', NULL, NULL, 185, NULL, 'Virus attachment protein globular domain', 284886),
(466591, '0049734', NULL, NULL, 64, NULL, 'EB1 dimerisation domain-like', 284887),
(466592, '0040352', NULL, NULL, 721, NULL, 'PFL-like glycyl radical enzymes', 284888),
(466593, '0042277', NULL, NULL, 525, NULL, 'PFL-like glycyl radical enzymes', 284888),
(466594, '0054023', NULL, NULL, 440, NULL, 'PFL-like glycyl radical enzymes', 284888),
(466595, '0049134', NULL, NULL, 786, NULL, 'PFL-like glycyl radical enzymes', 284888),
(466596, '0046178', NULL, NULL, 759, NULL, 'PFL-like glycyl radical enzymes', 284888),
(466597, '0047139', NULL, NULL, 562, NULL, 'PFL-like glycyl radical enzymes', 284888),
(466598, '0043302', NULL, NULL, 525, NULL, 'PFL-like glycyl radical enzymes', 284888),
(466599, '0052572', NULL, NULL, 75, NULL, 'GreA transcript cleavage protein, N-terminal domain', 284889),
(466600, '0047044', NULL, NULL, 78, NULL, 'GreA transcript cleavage protein, N-terminal domain', 284889),
(466601, '0053963', NULL, NULL, 72, NULL, 'MbtH-like', 284890),
(466602, '0035610', NULL, NULL, 161, NULL, 'PTS IIb component', 284891),
(466603, '0041536', NULL, NULL, 163, NULL, 'PTS IIb component', 284891),
(466604, '0040441', NULL, NULL, 228, NULL, 'Uracil-DNA glycosylase-like', 284892),
(466605, '0054565', NULL, NULL, 150, NULL, 'Uracil-DNA glycosylase-like', 284892),
(466606, '0041089', NULL, NULL, 165, NULL, 'Uracil-DNA glycosylase-like', 284892),
(466607, '0041892', NULL, NULL, 223, NULL, 'Uracil-DNA glycosylase-like', 284892),
(466608, '0054202', NULL, NULL, 230, NULL, 'Uracil-DNA glycosylase-like', 284892),
(466609, '0045509', NULL, NULL, 225, NULL, 'Uracil-DNA glycosylase-like', 284892),
(466610, '0049909', NULL, NULL, 192, NULL, 'Uracil-DNA glycosylase-like', 284892),
(466611, '0053053', NULL, NULL, 223, NULL, 'Uracil-DNA glycosylase-like', 284892),
(466612, '0040423', NULL, NULL, 191, NULL, 'Uracil-DNA glycosylase-like', 284892),
(466613, '0048547', NULL, NULL, 245, NULL, 'Uracil-DNA glycosylase-like', 284892),
(466614, '0037042', NULL, NULL, 101, NULL, 'Urease, beta-subunit', 284893),
(466615, '0053351', NULL, NULL, 122, NULL, 'Urease, beta-subunit', 284893),
(466616, '0046498', NULL, NULL, 133, NULL, 'Urease, beta-subunit', 284893),
(466617, '0053896', NULL, NULL, 280, NULL, 'Lipase chaperone-like', 284894),
(466618, '0053123', NULL, NULL, 178, NULL, 'FumA C-terminal domain-like', 284895),
(466619, '0049840', NULL, NULL, 131, NULL, 'TIMP-like', 284896),
(466620, '0049872', NULL, NULL, 181, NULL, 'TIMP-like', 284896),
(466621, '0051130', NULL, NULL, 151, NULL, 'TIMP-like', 284896),
(466622, '0046002', NULL, NULL, 182, NULL, 'TIMP-like', 284896),
(466623, '0047553', NULL, NULL, 127, NULL, 'TIMP-like', 284896),
(466624, '0045996', NULL, NULL, 184, NULL, 'TIMP-like', 284896),
(466625, '0042524', NULL, NULL, 104, NULL, 'Anticodon-binding domain of PheRS', 284897),
(466626, '0039002', NULL, NULL, 169, NULL, 'Thiamin pyrophosphokinase, catalytic domain', 284898),
(466627, '0039000', NULL, NULL, 221, NULL, 'Thiamin pyrophosphokinase, catalytic domain', 284898),
(466628, '0040431', NULL, NULL, 143, NULL, 'Rotavirus NSP2 fragment, N-terminal domain', 284899),
(466629, '0044483', NULL, NULL, 58, NULL, 'GRIP domain', 284900),
(466630, '0039174', NULL, NULL, 185, NULL, 'Ribosome recycling factor, RRF', 284901),
(466631, '0038065', NULL, NULL, 184, NULL, 'Ribosome recycling factor, RRF', 284901),
(466632, '0036362', NULL, NULL, 184, NULL, 'Ribosome recycling factor, RRF', 284901),
(466633, '0053629', NULL, NULL, 183, NULL, 'Ribosome recycling factor, RRF', 284901);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(466634, '0050587', NULL, NULL, 84, NULL, 'Ribosome recycling factor, RRF', 284901),
(466635, '0036999', NULL, NULL, 185, NULL, 'Ribosome recycling factor, RRF', 284901),
(466636, '0037049', NULL, NULL, 185, NULL, 'Ribosome recycling factor, RRF', 284901),
(466637, '0047480', NULL, NULL, 132, NULL, 'GroES-like', 284902),
(466638, '0046252', NULL, NULL, 198, NULL, 'GroES-like', 284902),
(466639, '0049685', NULL, NULL, 163, NULL, 'GroES-like', 284902),
(466640, '0051263', NULL, NULL, 151, NULL, 'GroES-like', 284902),
(466641, '0048672', NULL, NULL, 199, NULL, 'GroES-like', 284902),
(466642, '0036743', NULL, NULL, 227, NULL, 'GroES-like', 284902),
(466643, '0042905', NULL, NULL, 148, NULL, 'GroES-like', 284902),
(466644, '0035135', NULL, NULL, 97, NULL, 'GroES-like', 284902),
(466645, '0037912', NULL, NULL, 107, NULL, 'GroES-like', 284902),
(466646, '0047181', NULL, NULL, 199, NULL, 'GroES-like', 284902),
(466647, '0039779', NULL, NULL, 178, NULL, 'GroES-like', 284902),
(466648, '0040476', NULL, NULL, 99, NULL, 'GroES-like', 284902),
(466649, '0038267', NULL, NULL, 176, NULL, 'GroES-like', 284902),
(466650, '0046113', NULL, NULL, 200, NULL, 'GroES-like', 284902),
(466651, '0047104', NULL, NULL, 172, NULL, 'GroES-like', 284902),
(466652, '0046314', NULL, NULL, 199, NULL, 'GroES-like', 284902),
(466653, '0047846', NULL, NULL, 202, NULL, 'GroES-like', 284902),
(466654, '0042138', NULL, NULL, 99, NULL, 'GroES-like', 284902),
(466655, '0045092', NULL, NULL, 189, NULL, 'GroES-like', 284902),
(466656, '0050001', NULL, NULL, 180, NULL, 'GroES-like', 284902),
(466657, '0047232', NULL, NULL, 199, NULL, 'GroES-like', 284902),
(466658, '0040817', NULL, NULL, 198, NULL, 'GroES-like', 284902),
(466659, '0053618', NULL, NULL, 167, NULL, 'GroES-like', 284902),
(466660, '0050889', NULL, NULL, 153, NULL, 'GroES-like', 284902),
(466661, '0050202', NULL, NULL, 185, NULL, 'GroES-like', 284902),
(466662, '0044605', NULL, NULL, 148, NULL, 'GroES-like', 284902),
(466663, '0044967', NULL, NULL, 96, NULL, 'GroES-like', 284902),
(466664, '0047654', NULL, NULL, 178, NULL, 'GroES-like', 284902),
(466665, '0041738', NULL, NULL, 147, NULL, 'GroES-like', 284902),
(466666, '0043275', NULL, NULL, 172, NULL, 'GroES-like', 284902),
(466667, '0048862', NULL, NULL, 193, NULL, 'GroES-like', 284902),
(466668, '0047235', NULL, NULL, 199, NULL, 'GroES-like', 284902),
(466669, '0047994', NULL, NULL, 176, NULL, 'GroES-like', 284902),
(466670, '0042365', NULL, NULL, 186, NULL, 'GroES-like', 284902),
(466671, '0046449', NULL, NULL, 179, NULL, 'GroES-like', 284902),
(466672, '0046724', NULL, NULL, 195, NULL, 'GroES-like', 284902),
(466673, '0054041', NULL, NULL, 149, NULL, 'DsbB-like', 284903),
(466674, '0050033', NULL, NULL, 83, NULL, 'Thioredoxin-like', 284904),
(466675, '0052730', NULL, NULL, 87, NULL, 'Thioredoxin-like', 284904),
(466676, '0052452', NULL, NULL, 133, NULL, 'Thioredoxin-like', 284904),
(466677, '0050672', NULL, NULL, 119, NULL, 'Thioredoxin-like', 284904),
(466678, '0051123', NULL, NULL, 166, NULL, 'Thioredoxin-like', 284904),
(466679, '0049048', NULL, NULL, 105, NULL, 'Thioredoxin-like', 284904),
(466680, '0052692', NULL, NULL, 80, NULL, 'Thioredoxin-like', 284904),
(466681, '0046295', NULL, NULL, 107, NULL, 'Thioredoxin-like', 284904),
(466682, '0052451', NULL, NULL, 116, NULL, 'Thioredoxin-like', 284904),
(466683, '0046694', NULL, NULL, 79, NULL, 'Thioredoxin-like', 284904),
(466684, '0048594', NULL, NULL, 85, NULL, 'Thioredoxin-like', 284904),
(466685, '0048990', NULL, NULL, 197, NULL, 'Thioredoxin-like', 284904),
(466686, '0051483', NULL, NULL, 114, NULL, 'Thioredoxin-like', 284904),
(466687, '0038306', NULL, NULL, 83, NULL, 'Thioredoxin-like', 284904),
(466688, '0051129', NULL, NULL, 111, NULL, 'Thioredoxin-like', 284904),
(466689, '0052617', NULL, NULL, 184, NULL, 'Thioredoxin-like', 284904),
(466690, '0051923', NULL, NULL, 143, NULL, 'Thioredoxin-like', 284904),
(466691, '0037972', NULL, NULL, 75, NULL, 'Thioredoxin-like', 284904),
(466692, '0050950', NULL, NULL, 114, NULL, 'Thioredoxin-like', 284904),
(466693, '0051125', NULL, NULL, 153, NULL, 'Thioredoxin-like', 284904);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(466694, '0037970', NULL, NULL, 122, NULL, 'Thioredoxin-like', 284904),
(466695, '0051914', NULL, NULL, 119, NULL, 'Thioredoxin-like', 284904),
(466696, '0039073', NULL, NULL, 77, NULL, 'Thioredoxin-like', 284904),
(466697, '0049720', NULL, NULL, 77, NULL, 'Thioredoxin-like', 284904),
(466698, '0046733', NULL, NULL, 112, NULL, 'Thioredoxin-like', 284904),
(466699, '0045523', NULL, NULL, 84, NULL, 'Thioredoxin-like', 284904),
(466700, '0041722', NULL, NULL, 144, NULL, 'Thioredoxin-like', 284904),
(466701, '0042775', NULL, NULL, 137, NULL, 'Thioredoxin-like', 284904),
(466702, '0052983', NULL, NULL, 170, NULL, 'Thioredoxin-like', 284904),
(466703, '0051497', NULL, NULL, 136, NULL, 'Thioredoxin-like', 284904),
(466704, '0053311', NULL, NULL, 217, NULL, 'Thioredoxin-like', 284904),
(466705, '0049697', NULL, NULL, 77, NULL, 'Thioredoxin-like', 284904),
(466706, '0052340', NULL, NULL, 160, NULL, 'Thioredoxin-like', 284904),
(466707, '0047310', NULL, NULL, 144, NULL, 'Thioredoxin-like', 284904),
(466708, '0048366', NULL, NULL, 75, NULL, 'Thioredoxin-like', 284904),
(466709, '0048363', NULL, NULL, 85, NULL, 'Thioredoxin-like', 284904),
(466710, '0050680', NULL, NULL, 133, NULL, 'Thioredoxin-like', 284904),
(466711, '0052504', NULL, NULL, 119, NULL, 'Thioredoxin-like', 284904),
(466712, '0053833', NULL, NULL, 147, NULL, 'Thioredoxin-like', 284904),
(466713, '0051532', NULL, NULL, 113, NULL, 'Thioredoxin-like', 284904),
(466714, '0051931', NULL, NULL, 169, NULL, 'Thioredoxin-like', 284904),
(466715, '0048529', NULL, NULL, 122, NULL, 'Thioredoxin-like', 284904),
(466716, '0048804', NULL, NULL, 220, NULL, 'Thioredoxin-like', 284904),
(466717, '0042825', NULL, NULL, 143, NULL, 'Thioredoxin-like', 284904),
(466718, '0050957', NULL, NULL, 111, NULL, 'Thioredoxin-like', 284904),
(466719, '0046982', NULL, NULL, 107, NULL, 'Thioredoxin-like', 284904),
(466720, '0042387', NULL, NULL, 80, NULL, 'Thioredoxin-like', 284904),
(466721, '0047714', NULL, NULL, 86, NULL, 'Thioredoxin-like', 284904),
(466722, '0043753', NULL, NULL, 137, NULL, 'Thioredoxin-like', 284904),
(466723, '0049857', NULL, NULL, 124, NULL, 'Thioredoxin-like', 284904),
(466724, '0045810', NULL, NULL, 76, NULL, 'Thioredoxin-like', 284904),
(466725, '0041456', NULL, NULL, 74, NULL, 'Thioredoxin-like', 284904),
(466726, '0052631', NULL, NULL, 86, NULL, 'Thioredoxin-like', 284904),
(466727, '0052112', NULL, NULL, 84, NULL, 'Thioredoxin-like', 284904),
(466728, '0047046', NULL, NULL, 85, NULL, 'Thioredoxin-like', 284904),
(466729, '0049102', NULL, NULL, 221, NULL, 'Thioredoxin-like', 284904),
(466730, '0053320', NULL, NULL, 84, NULL, 'Thioredoxin-like', 284904),
(466731, '0039616', NULL, NULL, 84, NULL, 'Thioredoxin-like', 284904),
(466732, '0034961', NULL, NULL, 119, NULL, 'Thioredoxin-like', 284904),
(466733, '0035499', NULL, NULL, 181, NULL, 'Thioredoxin-like', 284904),
(466734, '0051701', NULL, NULL, 117, NULL, 'Thioredoxin-like', 284904),
(466735, '0039618', NULL, NULL, 90, NULL, 'Thioredoxin-like', 284904),
(466736, '0051703', NULL, NULL, 156, NULL, 'Thioredoxin-like', 284904),
(466737, '0037710', NULL, NULL, 201, NULL, 'Thioredoxin-like', 284904),
(466738, '0051667', NULL, NULL, 158, NULL, 'Thioredoxin-like', 284904),
(466739, '0037799', NULL, NULL, 188, NULL, 'Thioredoxin-like', 284904),
(466740, '0038800', NULL, NULL, 96, NULL, 'Thioredoxin-like', 284904),
(466741, '0050456', NULL, NULL, 166, NULL, 'Thioredoxin-like', 284904),
(466742, '0044619', NULL, NULL, 169, NULL, 'Thioredoxin-like', 284904),
(466743, '0035251', NULL, NULL, 80, NULL, 'Thioredoxin-like', 284904),
(466744, '0042395', NULL, NULL, 83, NULL, 'Thioredoxin-like', 284904),
(466745, '0047048', NULL, NULL, 79, NULL, 'Thioredoxin-like', 284904),
(466746, '0044455', NULL, NULL, 195, NULL, 'Thioredoxin-like', 284904),
(466747, '0045302', NULL, NULL, 75, NULL, 'Thioredoxin-like', 284904),
(466748, '0040257', NULL, NULL, 105, NULL, 'Thioredoxin-like', 284904),
(466749, '0048812', NULL, NULL, 163, NULL, 'Thioredoxin-like', 284904),
(466750, '0047173', NULL, NULL, 161, NULL, 'Thioredoxin-like', 284904);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(466751, '0051671', NULL, NULL, 134, NULL, 'Thioredoxin-like', 284904),
(466752, '0047050', NULL, NULL, 84, NULL, 'Thioredoxin-like', 284904),
(466753, '0047056', NULL, NULL, 84, NULL, 'Thioredoxin-like', 284904),
(466754, '0048146', NULL, NULL, 120, NULL, 'Thioredoxin-like', 284904),
(466755, '0048388', NULL, NULL, 163, NULL, 'Thioredoxin-like', 284904),
(466756, '0043130', NULL, NULL, 85, NULL, 'Thioredoxin-like', 284904),
(466757, '0037704', NULL, NULL, 85, NULL, 'Thioredoxin-like', 284904),
(466758, '0050108', NULL, NULL, 130, NULL, 'Thioredoxin-like', 284904),
(466759, '0052802', NULL, NULL, 143, NULL, 'Thioredoxin-like', 284904),
(466760, '0050985', NULL, NULL, 179, NULL, 'Thioredoxin-like', 284904),
(466761, '0042047', NULL, NULL, 122, NULL, 'Thioredoxin-like', 284904),
(466762, '0050617', NULL, NULL, 100, NULL, 'Thioredoxin-like', 284904),
(466763, '0038196', NULL, NULL, 185, NULL, 'Thioredoxin-like', 284904),
(466764, '0048664', NULL, NULL, 84, NULL, 'Thioredoxin-like', 284904),
(466765, '0049633', NULL, NULL, 113, NULL, 'Thioredoxin-like', 284904),
(466766, '0049632', NULL, NULL, 108, NULL, 'Thioredoxin-like', 284904),
(466767, '0043137', NULL, NULL, 90, NULL, 'Thioredoxin-like', 284904),
(466768, '0036606', NULL, NULL, 80, NULL, 'Thioredoxin-like', 284904),
(466769, '0052012', NULL, NULL, 169, NULL, 'Thioredoxin-like', 284904),
(466770, '0047062', NULL, NULL, 77, NULL, 'Thioredoxin-like', 284904),
(466771, '0052893', NULL, NULL, 160, NULL, 'Thioredoxin-like', 284904),
(466772, '0049125', NULL, NULL, 74, NULL, 'Thioredoxin-like', 284904),
(466773, '0050590', NULL, NULL, 109, NULL, 'Thioredoxin-like', 284904),
(466774, '0047981', NULL, NULL, 79, NULL, 'Thioredoxin-like', 284904),
(466775, '0052770', NULL, NULL, 178, NULL, 'Thioredoxin-like', 284904),
(466776, '0048033', NULL, NULL, 134, NULL, 'Thioredoxin-like', 284904),
(466777, '0049089', NULL, NULL, 113, NULL, 'Thioredoxin-like', 284904),
(466778, '0051602', NULL, NULL, 170, NULL, 'Thioredoxin-like', 284904),
(466779, '0035238', NULL, NULL, 81, NULL, 'Thioredoxin-like', 284904),
(466780, '0053106', NULL, NULL, 105, NULL, 'Thioredoxin-like', 284904),
(466781, '0035590', NULL, NULL, 110, NULL, 'Thioredoxin-like', 284904),
(466782, '0039431', NULL, NULL, 138, NULL, 'Thioredoxin-like', 284904),
(466783, '0049249', NULL, NULL, 114, NULL, 'Thioredoxin-like', 284904),
(466784, '0044115', NULL, NULL, 75, NULL, 'Thioredoxin-like', 284904),
(466785, '0049009', NULL, NULL, 173, NULL, 'Thioredoxin-like', 284904),
(466786, '0051694', NULL, NULL, 120, NULL, 'Thioredoxin-like', 284904),
(466787, '0050002', NULL, NULL, 194, NULL, 'Thioredoxin-like', 284904),
(466788, '0051850', NULL, NULL, 225, NULL, 'Thioredoxin-like', 284904),
(466789, '0045690', NULL, NULL, 218, NULL, 'Thioredoxin-like', 284904),
(466790, '0049377', NULL, NULL, 135, NULL, 'Thioredoxin-like', 284904),
(466791, '0047472', NULL, NULL, 74, NULL, 'Thioredoxin-like', 284904),
(466792, '0040838', NULL, NULL, 107, NULL, 'Thioredoxin-like', 284904),
(466793, '0043030', NULL, NULL, 164, NULL, 'Thioredoxin-like', 284904),
(466794, '0037807', NULL, NULL, 83, NULL, 'Thioredoxin-like', 284904),
(466795, '0041805', NULL, NULL, 81, NULL, 'Thioredoxin-like', 284904),
(466796, '0049496', NULL, NULL, 103, NULL, 'Thioredoxin-like', 284904),
(466797, '0035346', NULL, NULL, 78, NULL, 'Thioredoxin-like', 284904),
(466798, '0039826', NULL, NULL, 102, NULL, 'Thioredoxin-like', 284904),
(466799, '0052945', NULL, NULL, 76, NULL, 'Thioredoxin-like', 284904),
(466800, '0038457', NULL, NULL, 76, NULL, 'Thioredoxin-like', 284904),
(466801, '0039303', NULL, NULL, 100, NULL, 'Thioredoxin-like', 284904),
(466802, '0037363', NULL, NULL, 109, NULL, 'Thioredoxin-like', 284904),
(466803, '0039300', NULL, NULL, 118, NULL, 'Thioredoxin-like', 284904),
(466804, '0038178', NULL, NULL, 84, NULL, 'Thioredoxin-like', 284904),
(466805, '0039301', NULL, NULL, 107, NULL, 'Thioredoxin-like', 284904),
(466806, '0045739', NULL, NULL, 119, NULL, 'Thioredoxin-like', 284904),
(466807, '0040163', NULL, NULL, 144, NULL, 'Thioredoxin-like', 284904);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(466808, '0036792', NULL, NULL, 80, NULL, 'Thioredoxin-like', 284904),
(466809, '0050915', NULL, NULL, 219, NULL, 'Thioredoxin-like', 284904),
(466810, '0046783', NULL, NULL, 80, NULL, 'Thioredoxin-like', 284904),
(466811, '0041935', NULL, NULL, 174, NULL, 'Thioredoxin-like', 284904),
(466812, '0050770', NULL, NULL, 241, NULL, 'Thioredoxin-like', 284904),
(466813, '0048057', NULL, NULL, 76, NULL, 'Thioredoxin-like', 284904),
(466814, '0034808', NULL, NULL, 80, NULL, 'Thioredoxin-like', 284904),
(466815, '0048298', NULL, NULL, 186, NULL, 'Thioredoxin-like', 284904),
(466816, '0051504', NULL, NULL, 166, NULL, 'Thioredoxin-like', 284904),
(466817, '0036940', NULL, NULL, 98, NULL, 'Thioredoxin-like', 284904),
(466818, '0051503', NULL, NULL, 172, NULL, 'Thioredoxin-like', 284904),
(466819, '0046836', NULL, NULL, 82, NULL, 'Thioredoxin-like', 284904),
(466820, '0037474', NULL, NULL, 104, NULL, 'Thioredoxin-like', 284904),
(466821, '0043845', NULL, NULL, 150, NULL, 'Thioredoxin-like', 284904),
(466822, '0037350', NULL, NULL, 80, NULL, 'Thioredoxin-like', 284904),
(466823, '0049305', NULL, NULL, 85, NULL, 'Thioredoxin-like', 284904),
(466824, '0049667', NULL, NULL, 162, NULL, 'Thioredoxin-like', 284904),
(466825, '0045740', NULL, NULL, 107, NULL, 'Thioredoxin-like', 284904),
(466826, '0049544', NULL, NULL, 105, NULL, 'Thioredoxin-like', 284904),
(466827, '0045743', NULL, NULL, 124, NULL, 'Thioredoxin-like', 284904),
(466828, '0045744', NULL, NULL, 102, NULL, 'Thioredoxin-like', 284904),
(466829, '0051595', NULL, NULL, 115, NULL, 'Thioredoxin-like', 284904),
(466830, '0052322', NULL, NULL, 187, NULL, 'Thioredoxin-like', 284904),
(466831, '0036937', NULL, NULL, 156, NULL, 'Thioredoxin-like', 284904),
(466832, '0053013', NULL, NULL, 132, NULL, 'Thioredoxin-like', 284904),
(466833, '0048740', NULL, NULL, 75, NULL, 'Thioredoxin-like', 284904),
(466834, '0047011', NULL, NULL, 78, NULL, 'Thioredoxin-like', 284904),
(466835, '0051911', NULL, NULL, 140, NULL, 'Thioredoxin-like', 284904),
(466836, '0039527', NULL, NULL, 176, NULL, 'Thioredoxin-like', 284904),
(466837, '0051913', NULL, NULL, 125, NULL, 'Thioredoxin-like', 284904),
(466838, '0051912', NULL, NULL, 98, NULL, 'Thioredoxin-like', 284904),
(466839, '0038799', NULL, NULL, 102, NULL, 'Thioredoxin-like', 284904),
(466840, '0045879', NULL, NULL, 105, NULL, 'Thioredoxin-like', 284904),
(466841, '0048908', NULL, NULL, 164, NULL, 'Thioredoxin-like', 284904),
(466842, '0046445', NULL, NULL, 167, NULL, 'Thioredoxin-like', 284904),
(466843, '0045754', NULL, NULL, 87, NULL, 'Thioredoxin-like', 284904),
(466844, '0046603', NULL, NULL, 112, NULL, 'Thioredoxin-like', 284904),
(466845, '0047167', NULL, NULL, 118, NULL, 'Actin-crosslinking proteins', 284905),
(466846, '0046322', NULL, NULL, 119, NULL, 'Actin-crosslinking proteins', 284905),
(466847, '0046321', NULL, NULL, 133, NULL, 'Actin-crosslinking proteins', 284905),
(466848, '0046324', NULL, NULL, 111, NULL, 'Actin-crosslinking proteins', 284905),
(466849, '0046323', NULL, NULL, 123, NULL, 'Actin-crosslinking proteins', 284905),
(466850, '0041307', NULL, NULL, 116, NULL, 'Hypothetical protein TM1070', 284906),
(466851, '0052285', NULL, NULL, 161, NULL, 'Succinyl-CoA synthetase domains', 284907),
(466852, '0053297', NULL, NULL, 165, NULL, 'Succinyl-CoA synthetase domains', 284907),
(466853, '0048575', NULL, NULL, 167, NULL, 'Succinyl-CoA synthetase domains', 284907),
(466854, '0052286', NULL, NULL, 163, NULL, 'Succinyl-CoA synthetase domains', 284907),
(466855, '0053298', NULL, NULL, 147, NULL, 'Succinyl-CoA synthetase domains', 284907),
(466856, '0046630', NULL, NULL, 176, NULL, 'Succinyl-CoA synthetase domains', 284907),
(466857, '0046631', NULL, NULL, 148, NULL, 'Succinyl-CoA synthetase domains', 284907),
(466858, '0042212', NULL, NULL, 85, NULL, 'FYSH domain', 284908),
(466859, '0041627', NULL, NULL, 111, NULL, 'FYSH domain', 284908),
(466860, '0050483', NULL, NULL, 118, NULL, 'Prokaryotic type KH domain (KH-domain type II)', 284909),
(466861, '0047716', NULL, NULL, 79, NULL, 'Prokaryotic type KH domain (KH-domain type II)', 284909);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(466862, '0047188', NULL, NULL, 78, NULL, 'Prokaryotic type KH domain (KH-domain type II)', 284909),
(466863, '0054585', NULL, NULL, 105, NULL, 'Prokaryotic type KH domain (KH-domain type II)', 284909),
(466864, '0038592', NULL, NULL, 68, NULL, 'Prokaryotic type KH domain (KH-domain type II)', 284909),
(466865, '0046552', NULL, NULL, 113, NULL, 'Prokaryotic type KH domain (KH-domain type II)', 284909),
(466866, '0046797', NULL, NULL, 105, NULL, 'Prokaryotic type KH domain (KH-domain type II)', 284909),
(466867, '0050549', NULL, NULL, 92, NULL, 'Prokaryotic type KH domain (KH-domain type II)', 284909),
(466868, '0036740', NULL, NULL, 54, NULL, 'Prokaryotic type KH domain (KH-domain type II)', 284909),
(466869, '0039833', NULL, NULL, 67, NULL, 'Prokaryotic type KH domain (KH-domain type II)', 284909),
(466870, '0053790', NULL, NULL, 67, NULL, 'Guanosine diphospho-D-mannose pyrophosphorylase/mannose-6-phosphate isomerase linker domain', 284910),
(466871, '0054125', NULL, NULL, 158, NULL, 'SMI1/KNR4-like', 284911),
(466872, '0054487', NULL, NULL, 135, NULL, 'SMI1/KNR4-like', 284911),
(466873, '0054541', NULL, NULL, 152, NULL, 'SMI1/KNR4-like', 284911),
(466874, '0036684', NULL, NULL, 139, NULL, 'Eukaryotic RPB5 N-terminal domain', 284912),
(466875, '0050320', NULL, NULL, 88, NULL, 'Superoxide reductase-like', 284913),
(466876, '0046384', NULL, NULL, 124, NULL, 'Superoxide reductase-like', 284913),
(466877, '0046328', NULL, NULL, 89, NULL, 'Superoxide reductase-like', 284913),
(466878, '0043809', NULL, NULL, 147, NULL, 'Her-1', 284914),
(466879, '0049393', NULL, NULL, 139, NULL, 'Hypothetical protein c14orf129, hspc210', 284915),
(466880, '0038329', NULL, NULL, 62, NULL, 'GYF domain', 284916),
(466881, '0050542', NULL, NULL, 78, NULL, 'GYF domain', 284916),
(466882, '0047803', NULL, NULL, 264, NULL, 'Nucleoside phosphorylase/phosphoribosyltransferase catalytic domain', 284917),
(466883, '0053310', NULL, NULL, 265, NULL, 'Nucleoside phosphorylase/phosphoribosyltransferase catalytic domain', 284917),
(466884, '0048481', NULL, NULL, 273, NULL, 'Nucleoside phosphorylase/phosphoribosyltransferase catalytic domain', 284917),
(466885, '0046005', NULL, NULL, 260, NULL, 'Nucleoside phosphorylase/phosphoribosyltransferase catalytic domain', 284917),
(466886, '0049963', NULL, NULL, 273, NULL, 'Nucleoside phosphorylase/phosphoribosyltransferase catalytic domain', 284917),
(466887, '0050093', NULL, NULL, 264, NULL, 'Nucleoside phosphorylase/phosphoribosyltransferase catalytic domain', 284917),
(466888, '0050343', NULL, NULL, 162, NULL, 'Nucleotide cyclase', 284918),
(466889, '0045849', NULL, NULL, 190, NULL, 'Nucleotide cyclase', 284918),
(466890, '0046870', NULL, NULL, 235, NULL, 'Nucleotide cyclase', 284918),
(466891, '0046871', NULL, NULL, 231, NULL, 'Nucleotide cyclase', 284918),
(466892, '0050428', NULL, NULL, 199, NULL, 'Nucleotide cyclase', 284918),
(466893, '0045850', NULL, NULL, 199, NULL, 'Nucleotide cyclase', 284918),
(466894, '0045208', NULL, NULL, 131, NULL, 'N-terminal domain of cbl (N-cbl)', 284919),
(466895, '0035381', NULL, NULL, 147, NULL, 'Aspartate/glutamate racemase', 284920),
(466896, '0045890', NULL, NULL, 105, NULL, 'Aspartate/glutamate racemase', 284920),
(466897, '0047575', NULL, NULL, 115, NULL, 'Aspartate/glutamate racemase', 284920),
(466898, '0047576', NULL, NULL, 113, NULL, 'Aspartate/glutamate racemase', 284920),
(466899, '0047438', NULL, NULL, 111, NULL, 'Aspartate/glutamate racemase', 284920),
(466900, '0047596', NULL, NULL, 105, NULL, 'beta-Barrel protease inhibitors', 284921),
(466901, '0049425', NULL, NULL, 100, NULL, 'beta-Barrel protease inhibitors', 284921),
(466902, '0041624', NULL, NULL, 111, NULL, 'beta-Barrel protease inhibitors', 284921),
(466903, '0041854', NULL, NULL, 109, NULL, 'beta-Barrel protease inhibitors', 284921),
(466904, '0050931', NULL, NULL, 208, NULL, 'PHP14-like', 284922),
(466905, '0053050', NULL, NULL, 118, NULL, 'PHP14-like', 284922),
(466906, '0053238', NULL, NULL, 205, NULL, 'PHP14-like', 284922),
(466907, '0044805', NULL, NULL, 151, NULL, 'Hypothetical protein TM0160', 284923);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(466908, '0052201', NULL, NULL, 66, NULL, 'NOB1 zinc finger-like', 284924),
(466909, '0040173', NULL, NULL, 157, NULL, 'NSP3 homodimer', 284925),
(466910, '0046144', NULL, NULL, 188, NULL, 'Cytochrome f, large domain', 284926),
(466911, '0053609', NULL, NULL, 189, NULL, 'Cytochrome f, large domain', 284926),
(466912, '0046443', NULL, NULL, 188, NULL, 'Cytochrome f, large domain', 284926),
(466913, '0047170', NULL, NULL, 188, NULL, 'Cytochrome f, large domain', 284926),
(466914, '0044722', NULL, NULL, 188, NULL, 'Cytochrome f, large domain', 284926),
(466915, '0054563', NULL, NULL, 133, NULL, 'SO1590-like', 284927),
(466916, '0054397', NULL, NULL, 133, NULL, 'SO1590-like', 284927),
(466917, '0053771', NULL, NULL, 59, NULL, 'Type I dockerin domain', 284928),
(466918, '0051906', NULL, NULL, 60, NULL, 'Type I dockerin domain', 284928),
(466919, '0036328', NULL, NULL, 71, NULL, 'Type I dockerin domain', 284928),
(466920, '0038543', NULL, NULL, 94, NULL, 'Penicillin-binding protein associated domain', 284929),
(466921, '0051054', NULL, NULL, 93, NULL, 'Penicillin-binding protein associated domain', 284929),
(466922, '0044133', NULL, NULL, 68, NULL, 'Penicillin-binding protein associated domain', 284929),
(466923, '0053583', NULL, NULL, 263, NULL, 'Di-copper centre-containing domain', 284930),
(466924, '0040538', NULL, NULL, 270, NULL, 'Di-copper centre-containing domain', 284930),
(466925, '0040577', NULL, NULL, 307, NULL, 'Di-copper centre-containing domain', 284930),
(466926, '0035699', NULL, NULL, 341, NULL, 'Di-copper centre-containing domain', 284930),
(466927, '0039734', NULL, NULL, 289, NULL, 'Di-copper centre-containing domain', 284930),
(466928, '0049116', NULL, NULL, 205, NULL, 'Putative cyclase', 284931),
(466929, '0051869', NULL, NULL, 186, NULL, 'Putative cyclase', 284931),
(466930, '0048372', NULL, NULL, 328, NULL, 'Carbohydrate phosphatase', 284932),
(466931, '0047396', NULL, NULL, 400, NULL, 'Carbohydrate phosphatase', 284932),
(466932, '0037769', NULL, NULL, 327, NULL, 'Carbohydrate phosphatase', 284932),
(466933, '0036465', NULL, NULL, 252, NULL, 'Carbohydrate phosphatase', 284932),
(466934, '0037748', NULL, NULL, 327, NULL, 'Carbohydrate phosphatase', 284932),
(466935, '0050973', NULL, NULL, 249, NULL, 'Carbohydrate phosphatase', 284932),
(466936, '0039685', NULL, NULL, 304, NULL, 'Carbohydrate phosphatase', 284932),
(466937, '0044712', NULL, NULL, 253, NULL, 'Carbohydrate phosphatase', 284932),
(466938, '0042779', NULL, NULL, 354, NULL, 'Carbohydrate phosphatase', 284932),
(466939, '0035592', NULL, NULL, 332, NULL, 'Carbohydrate phosphatase', 284932),
(466940, '0046304', NULL, NULL, 346, NULL, 'Carbohydrate phosphatase', 284932),
(466941, '0045316', NULL, NULL, 272, NULL, 'Carbohydrate phosphatase', 284932),
(466942, '0047954', NULL, NULL, 252, NULL, 'Carbohydrate phosphatase', 284932),
(466943, '0049438', NULL, NULL, 353, NULL, 'Carbohydrate phosphatase', 284932),
(466944, '0037032', NULL, NULL, 107, NULL, 'Wiscott-Aldrich syndrome protein, WASP, C-terminal domain', 284933),
(466945, '0054063', NULL, NULL, 147, NULL, 'Smr-associated domain-like', 284934),
(466946, '0046680', NULL, NULL, 162, NULL, 'Outer surface protein C (OspC)', 284935),
(466947, '0046927', NULL, NULL, 164, NULL, 'Outer surface protein C (OspC)', 284935),
(466948, '0046981', NULL, NULL, 162, NULL, 'Outer surface protein C (OspC)', 284935),
(466949, '0043359', NULL, NULL, 385, NULL, 'Dehydroquinate synthase-like', 284936),
(466950, '0041672', NULL, NULL, 359, NULL, 'Dehydroquinate synthase-like', 284936),
(466951, '0048580', NULL, NULL, 390, NULL, 'Dehydroquinate synthase-like', 284936),
(466952, '0044392', NULL, NULL, 347, NULL, 'Dehydroquinate synthase-like', 284936),
(466953, '0036562', NULL, NULL, 388, NULL, 'Dehydroquinate synthase-like', 284936),
(466954, '0050240', NULL, NULL, 398, NULL, 'Dehydroquinate synthase-like', 284936),
(466955, '0047653', NULL, NULL, 366, NULL, 'Dehydroquinate synthase-like', 284936),
(466956, '0047854', NULL, NULL, 364, NULL, 'Dehydroquinate synthase-like', 284936),
(466957, '0049296', NULL, NULL, 399, NULL, 'Cytochrome P450', 284937);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(466958, '0044092', NULL, NULL, 472, NULL, 'Cytochrome P450', 284937),
(466959, '0036859', NULL, NULL, 449, NULL, 'Cytochrome P450', 284937),
(466960, '0038307', NULL, NULL, 403, NULL, 'Cytochrome P450', 284937),
(466961, '0036587', NULL, NULL, 460, NULL, 'Cytochrome P450', 284937),
(466962, '0054912', NULL, NULL, 463, NULL, 'Cytochrome P450', 284937),
(466963, '0037346', NULL, NULL, 399, NULL, 'Cytochrome P450', 284937),
(466964, '0035710', NULL, NULL, 455, NULL, 'Cytochrome P450', 284937),
(466965, '0036106', NULL, NULL, 412, NULL, 'Cytochrome P450', 284937),
(466966, '0041213', NULL, NULL, 395, NULL, 'Cytochrome P450', 284937),
(466967, '0039101', NULL, NULL, 366, NULL, 'Cytochrome P450', 284937),
(466968, '0039299', NULL, NULL, 411, NULL, 'Cytochrome P450', 284937),
(466969, '0040482', NULL, NULL, 394, NULL, 'Cytochrome P450', 284937),
(466970, '0036682', NULL, NULL, 404, NULL, 'Cytochrome P450', 284937),
(466971, '0041273', NULL, NULL, 385, NULL, 'Cytochrome P450', 284937),
(466972, '0041837', NULL, NULL, 462, NULL, 'Cytochrome P450', 284937),
(466973, '0044298', NULL, NULL, 367, NULL, 'Cytochrome P450', 284937),
(466974, '0041802', NULL, NULL, 401, NULL, 'Cytochrome P450', 284937),
(466975, '0046634', NULL, NULL, 403, NULL, 'Cytochrome P450', 284937),
(466976, '0042421', NULL, NULL, 463, NULL, 'Cytochrome P450', 284937),
(466977, '0042400', NULL, NULL, 465, NULL, 'Cytochrome P450', 284937),
(466978, '0042621', NULL, NULL, 401, NULL, 'Cytochrome P450', 284937),
(466979, '0044304', NULL, NULL, 403, NULL, 'Cytochrome P450', 284937),
(466980, '0044510', NULL, NULL, 142, NULL, 'Activator of Hsp90 ATPase, Aha1', 284938),
(466981, '0049154', NULL, NULL, 213, NULL, 'eIF4e-like', 284939),
(466982, '0051640', NULL, NULL, 234, NULL, 'eIF4e-like', 284939),
(466983, '0039118', NULL, NULL, 191, NULL, 'eIF4e-like', 284939),
(466984, '0053577', NULL, NULL, 325, NULL, 'Clostridium neurotoxins, "coiled-coil" domain', 284940),
(466985, '0053509', NULL, NULL, 328, NULL, 'Clostridium neurotoxins, "coiled-coil" domain', 284940),
(466986, '0050254', NULL, NULL, 83, NULL, 'all-alpha NTP pyrophosphatases', 284941),
(466987, '0051724', NULL, NULL, 91, NULL, 'all-alpha NTP pyrophosphatases', 284941),
(466988, '0052946', NULL, NULL, 110, NULL, 'all-alpha NTP pyrophosphatases', 284941),
(466989, '0053260', NULL, NULL, 84, NULL, 'all-alpha NTP pyrophosphatases', 284941),
(466990, '0050348', NULL, NULL, 229, NULL, 'all-alpha NTP pyrophosphatases', 284941),
(466991, '0051426', NULL, NULL, 92, NULL, 'all-alpha NTP pyrophosphatases', 284941),
(466992, '0051439', NULL, NULL, 88, NULL, 'all-alpha NTP pyrophosphatases', 284941),
(466993, '0051698', NULL, NULL, 113, NULL, 'all-alpha NTP pyrophosphatases', 284941),
(466994, '0041843', NULL, NULL, 270, NULL, 'all-alpha NTP pyrophosphatases', 284941),
(466995, '0051216', NULL, NULL, 87, NULL, 'all-alpha NTP pyrophosphatases', 284941),
(466996, '0050888', NULL, NULL, 182, NULL, 'DNA mismatch repair protein MutL', 284942),
(466997, '0053048', NULL, NULL, 190, NULL, 'Probable bacterial effector-binding domain', 284943),
(466998, '0035649', NULL, NULL, 158, NULL, 'Probable bacterial effector-binding domain', 284943),
(466999, '0036288', NULL, NULL, 173, NULL, 'Probable bacterial effector-binding domain', 284943),
(467000, '0039814', NULL, NULL, 155, NULL, 'Probable bacterial effector-binding domain', 284943),
(467001, '0047017', NULL, NULL, 68, NULL, 'Urease metallochaperone UreE, C-terminal domain', 284944),
(467002, '0046510', NULL, NULL, 68, NULL, 'Urease metallochaperone UreE, C-terminal domain', 284944),
(467003, '0040364', NULL, NULL, 61, NULL, 'F1F0 ATP synthase subunit B, membrane domain', 284945),
(467004, '0051772', NULL, NULL, 89, NULL, 'eIF-2-alpha, C-terminal domain', 284946),
(467005, '0042661', NULL, NULL, 117, NULL, 'eIF-2-alpha, C-terminal domain', 284946),
(467006, '0037023', NULL, NULL, 72, NULL, 'Double-stranded DNA-binding domain', 284947),
(467007, '0052265', NULL, NULL, 105, NULL, 'Double-stranded DNA-binding domain', 284947),
(467008, '0040635', NULL, NULL, 65, NULL, 'tRNA-binding arm', 284948); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(467009, '0043575', NULL, NULL, 110, NULL, 'tRNA-binding arm', 284948),
(467010, '0039226', NULL, NULL, 66, NULL, 'tRNA-binding arm', 284948),
(467011, '0037028', NULL, NULL, 79, NULL, 'tRNA-binding arm', 284948),
(467012, '0052505', NULL, NULL, 97, NULL, 'YoaC-like', 284949),
(467013, '0051374', NULL, NULL, 101, NULL, 'MTH1187/YkoF-like', 284950),
(467014, '0050222', NULL, NULL, 93, NULL, 'MTH1187/YkoF-like', 284950),
(467015, '0043519', NULL, NULL, 186, NULL, 'MTH1187/YkoF-like', 284950),
(467016, '0053086', NULL, NULL, 90, NULL, 'MTH1187/YkoF-like', 284950),
(467017, '0048048', NULL, NULL, 104, NULL, 'MTH1187/YkoF-like', 284950),
(467018, '0048049', NULL, NULL, 99, NULL, 'MTH1187/YkoF-like', 284950),
(467019, '0052453', NULL, NULL, 95, NULL, 'Fibronectin type III', 284951),
(467020, '0050832', NULL, NULL, 98, NULL, 'Fibronectin type III', 284951),
(467021, '0037851', NULL, NULL, 98, NULL, 'Fibronectin type III', 284951),
(467022, '0050831', NULL, NULL, 111, NULL, 'Fibronectin type III', 284951),
(467023, '0051920', NULL, NULL, 96, NULL, 'Fibronectin type III', 284951),
(467024, '0050830', NULL, NULL, 100, NULL, 'Fibronectin type III', 284951),
(467025, '0051919', NULL, NULL, 95, NULL, 'Fibronectin type III', 284951),
(467026, '0041201', NULL, NULL, 104, NULL, 'Fibronectin type III', 284951),
(467027, '0050829', NULL, NULL, 113, NULL, 'Fibronectin type III', 284951),
(467028, '0051918', NULL, NULL, 104, NULL, 'Fibronectin type III', 284951),
(467029, '0041200', NULL, NULL, 102, NULL, 'Fibronectin type III', 284951),
(467030, '0050826', NULL, NULL, 107, NULL, 'Fibronectin type III', 284951),
(467031, '0035671', NULL, NULL, 115, NULL, 'Fibronectin type III', 284951),
(467032, '0050825', NULL, NULL, 94, NULL, 'Fibronectin type III', 284951),
(467033, '0035670', NULL, NULL, 95, NULL, 'Fibronectin type III', 284951),
(467034, '0050828', NULL, NULL, 119, NULL, 'Fibronectin type III', 284951),
(467035, '0051917', NULL, NULL, 98, NULL, 'Fibronectin type III', 284951),
(467036, '0050827', NULL, NULL, 103, NULL, 'Fibronectin type III', 284951),
(467037, '0049605', NULL, NULL, 90, NULL, 'Fibronectin type III', 284951),
(467038, '0050844', NULL, NULL, 102, NULL, 'Fibronectin type III', 284951),
(467039, '0050843', NULL, NULL, 98, NULL, 'Fibronectin type III', 284951),
(467040, '0050842', NULL, NULL, 96, NULL, 'Fibronectin type III', 284951),
(467041, '0037682', NULL, NULL, 90, NULL, 'Fibronectin type III', 284951),
(467042, '0037683', NULL, NULL, 89, NULL, 'Fibronectin type III', 284951),
(467043, '0046984', NULL, NULL, 114, NULL, 'Fibronectin type III', 284951),
(467044, '0049856', NULL, NULL, 109, NULL, 'Fibronectin type III', 284951),
(467045, '0047287', NULL, NULL, 100, NULL, 'Fibronectin type III', 284951),
(467046, '0052473', NULL, NULL, 94, NULL, 'Fibronectin type III', 284951),
(467047, '0050052', NULL, NULL, 108, NULL, 'Fibronectin type III', 284951),
(467048, '0037679', NULL, NULL, 91, NULL, 'Fibronectin type III', 284951),
(467049, '0053849', NULL, NULL, 102, NULL, 'Fibronectin type III', 284951),
(467050, '0035255', NULL, NULL, 106, NULL, 'Fibronectin type III', 284951),
(467051, '0035651', NULL, NULL, 104, NULL, 'Fibronectin type III', 284951),
(467052, '0052997', NULL, NULL, 101, NULL, 'Fibronectin type III', 284951),
(467053, '0035650', NULL, NULL, 99, NULL, 'Fibronectin type III', 284951),
(467054, '0050606', NULL, NULL, 117, NULL, 'Fibronectin type III', 284951),
(467055, '0048655', NULL, NULL, 93, NULL, 'Fibronectin type III', 284951),
(467056, '0034836', NULL, NULL, 103, NULL, 'Fibronectin type III', 284951),
(467057, '0053851', NULL, NULL, 125, NULL, 'Fibronectin type III', 284951),
(467058, '0053850', NULL, NULL, 196, NULL, 'Fibronectin type III', 284951),
(467059, '0050505', NULL, NULL, 123, NULL, 'Fibronectin type III', 284951),
(467060, '0035922', NULL, NULL, 106, NULL, 'Fibronectin type III', 284951),
(467061, '0035921', NULL, NULL, 107, NULL, 'Fibronectin type III', 284951),
(467062, '0050500', NULL, NULL, 117, NULL, 'Fibronectin type III', 284951),
(467063, '0048948', NULL, NULL, 103, NULL, 'Fibronectin type III', 284951);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(467064, '0045838', NULL, NULL, 99, NULL, 'Fibronectin type III', 284951),
(467065, '0049877', NULL, NULL, 127, NULL, 'Fibronectin type III', 284951),
(467066, '0047336', NULL, NULL, 96, NULL, 'Fibronectin type III', 284951),
(467067, '0049875', NULL, NULL, 125, NULL, 'Fibronectin type III', 284951),
(467068, '0045312', NULL, NULL, 106, NULL, 'Fibronectin type III', 284951),
(467069, '0037380', NULL, NULL, 95, NULL, 'Fibronectin type III', 284951),
(467070, '0040701', NULL, NULL, 96, NULL, 'Fibronectin type III', 284951),
(467071, '0049599', NULL, NULL, 92, NULL, 'Fibronectin type III', 284951),
(467072, '0049874', NULL, NULL, 117, NULL, 'Fibronectin type III', 284951),
(467073, '0046886', NULL, NULL, 114, NULL, 'Fibronectin type III', 284951),
(467074, '0045313', NULL, NULL, 112, NULL, 'Fibronectin type III', 284951),
(467075, '0047337', NULL, NULL, 101, NULL, 'Fibronectin type III', 284951),
(467076, '0041236', NULL, NULL, 109, NULL, 'Fibronectin type III', 284951),
(467077, '0052410', NULL, NULL, 105, NULL, 'Fibronectin type III', 284951),
(467078, '0052411', NULL, NULL, 107, NULL, 'Fibronectin type III', 284951),
(467079, '0045282', NULL, NULL, 95, NULL, 'Fibronectin type III', 284951),
(467080, '0046131', NULL, NULL, 100, NULL, 'Fibronectin type III', 284951),
(467081, '0053185', NULL, NULL, 92, NULL, 'Fibronectin type III', 284951),
(467082, '0046132', NULL, NULL, 105, NULL, 'Fibronectin type III', 284951),
(467083, '0037415', NULL, NULL, 96, NULL, 'Fibronectin type III', 284951),
(467084, '0037416', NULL, NULL, 103, NULL, 'Fibronectin type III', 284951),
(467085, '0050634', NULL, NULL, 137, NULL, 'Fibronectin type III', 284951),
(467086, '0038104', NULL, NULL, 99, NULL, 'Fibronectin type III', 284951),
(467087, '0050597', NULL, NULL, 111, NULL, 'Fibronectin type III', 284951),
(467088, '0050115', NULL, NULL, 109, NULL, 'Fibronectin type III', 284951),
(467089, '0038102', NULL, NULL, 103, NULL, 'Fibronectin type III', 284951),
(467090, '0039951', NULL, NULL, 88, NULL, 'Fibronectin type III', 284951),
(467091, '0046817', NULL, NULL, 91, NULL, 'Fibronectin type III', 284951),
(467092, '0050506', NULL, NULL, 120, NULL, 'Fibronectin type III', 284951),
(467093, '0046819', NULL, NULL, 94, NULL, 'Fibronectin type III', 284951),
(467094, '0053184', NULL, NULL, 92, NULL, 'Fibronectin type III', 284951),
(467095, '0046532', NULL, NULL, 104, NULL, 'Fibronectin type III', 284951),
(467096, '0049925', NULL, NULL, 120, NULL, 'Fibronectin type III', 284951),
(467097, '0050484', NULL, NULL, 108, NULL, 'Fibronectin type III', 284951),
(467098, '0052266', NULL, NULL, 97, NULL, 'Fibronectin type III', 284951),
(467099, '0052262', NULL, NULL, 107, NULL, 'Fibronectin type III', 284951),
(467100, '0043954', NULL, NULL, 86, NULL, 'Fibronectin type III', 284951),
(467101, '0045698', NULL, NULL, 102, NULL, 'Fibronectin type III', 284951),
(467102, '0046820', NULL, NULL, 89, NULL, 'Fibronectin type III', 284951),
(467103, '0046701', NULL, NULL, 124, NULL, 'Fibronectin type III', 284951),
(467104, '0046822', NULL, NULL, 90, NULL, 'Fibronectin type III', 284951),
(467105, '0043952', NULL, NULL, 93, NULL, 'Fibronectin type III', 284951),
(467106, '0052311', NULL, NULL, 101, NULL, 'Fibronectin type III', 284951),
(467107, '0052310', NULL, NULL, 102, NULL, 'Fibronectin type III', 284951),
(467108, '0049024', NULL, NULL, 88, NULL, 'Fibronectin type III', 284951),
(467109, '0049023', NULL, NULL, 87, NULL, 'Fibronectin type III', 284951),
(467110, '0050499', NULL, NULL, 106, NULL, 'Fibronectin type III', 284951),
(467111, '0036944', NULL, NULL, 109, NULL, 'Fibronectin type III', 284951),
(467112, '0053765', NULL, NULL, 116, NULL, 'Fibronectin type III', 284951),
(467113, '0039415', NULL, NULL, 106, NULL, 'Fibronectin type III', 284951),
(467114, '0048290', NULL, NULL, 103, NULL, 'Fibronectin type III', 284951),
(467115, '0052314', NULL, NULL, 93, NULL, 'Fibronectin type III', 284951),
(467116, '0042755', NULL, NULL, 92, NULL, 'Fibronectin type III', 284951),
(467117, '0046555', NULL, NULL, 101, NULL, 'Fibronectin type III', 284951);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(467118, '0042595', NULL, NULL, 89, NULL, 'Fibronectin type III', 284951),
(467119, '0053083', NULL, NULL, 95, NULL, 'Fibronectin type III', 284951),
(467120, '0052283', NULL, NULL, 117, NULL, 'Fibronectin type III', 284951),
(467121, '0054903', NULL, NULL, 93, NULL, 'Fibronectin type III', 284951),
(467122, '0050785', NULL, NULL, 105, NULL, 'Fibronectin type III', 284951),
(467123, '0050820', NULL, NULL, 108, NULL, 'Fibronectin type III', 284951),
(467124, '0050819', NULL, NULL, 101, NULL, 'Fibronectin type III', 284951),
(467125, '0050818', NULL, NULL, 93, NULL, 'Fibronectin type III', 284951),
(467126, '0045991', NULL, NULL, 104, NULL, 'Fibronectin type III', 284951),
(467127, '0047532', NULL, NULL, 99, NULL, 'Fibronectin type III', 284951),
(467128, '0047536', NULL, NULL, 94, NULL, 'Fibronectin type III', 284951),
(467129, '0053090', NULL, NULL, 107, NULL, 'Fibronectin type III', 284951),
(467130, '0050175', NULL, NULL, 161, NULL, 'Ta1353-like', 284952),
(467131, '0043297', NULL, NULL, 151, NULL, 'Ta1353-like', 284952),
(467132, '0038382', NULL, NULL, 267, NULL, 'HydA/Nqo6-like', 284953),
(467133, '0035907', NULL, NULL, 278, NULL, 'HydA/Nqo6-like', 284953),
(467134, '0045287', NULL, NULL, 261, NULL, 'HydA/Nqo6-like', 284953),
(467135, '0037747', NULL, NULL, 261, NULL, 'HydA/Nqo6-like', 284953),
(467136, '0052777', NULL, NULL, 161, NULL, 'HydA/Nqo6-like', 284953),
(467137, '0036735', NULL, NULL, 262, NULL, 'HydA/Nqo6-like', 284953),
(467138, '0036952', NULL, NULL, 55, NULL, 'RNA polymerase subunit RPB10', 284954),
(467139, '0047307', NULL, NULL, 65, NULL, 'RNA polymerase subunit RPB10', 284954),
(467140, '0041691', NULL, NULL, 200, NULL, 'Methenyltetrahydrofolate cyclohydrolase-like', 284955),
(467141, '0054458', NULL, NULL, 461, NULL, 'VPA0735-like', 284956),
(467142, '0049341', NULL, NULL, 121, NULL, 'Phospholipase A2, PLA2', 284957),
(467143, '0035718', NULL, NULL, 120, NULL, 'Phospholipase A2, PLA2', 284957),
(467144, '0044450', NULL, NULL, 122, NULL, 'Phospholipase A2, PLA2', 284957),
(467145, '0042095', NULL, NULL, 120, NULL, 'Phospholipase A2, PLA2', 284957),
(467146, '0036549', NULL, NULL, 118, NULL, 'Phospholipase A2, PLA2', 284957),
(467147, '0035019', NULL, NULL, 119, NULL, 'Phospholipase A2, PLA2', 284957),
(467148, '0040575', NULL, NULL, 119, NULL, 'Phospholipase A2, PLA2', 284957),
(467149, '0042413', NULL, NULL, 122, NULL, 'Phospholipase A2, PLA2', 284957),
(467150, '0043502', NULL, NULL, 119, NULL, 'Phospholipase A2, PLA2', 284957),
(467151, '0045405', NULL, NULL, 124, NULL, 'Phospholipase A2, PLA2', 284957),
(467152, '0042058', NULL, NULL, 118, NULL, 'Phospholipase A2, PLA2', 284957),
(467153, '0041980', NULL, NULL, 122, NULL, 'Phospholipase A2, PLA2', 284957),
(467154, '0042057', NULL, NULL, 118, NULL, 'Phospholipase A2, PLA2', 284957),
(467155, '0035133', NULL, NULL, 122, NULL, 'Phospholipase A2, PLA2', 284957),
(467156, '0038185', NULL, NULL, 121, NULL, 'Phospholipase A2, PLA2', 284957),
(467157, '0039053', NULL, NULL, 123, NULL, 'Phospholipase A2, PLA2', 284957),
(467158, '0040470', NULL, NULL, 123, NULL, 'Phospholipase A2, PLA2', 284957),
(467159, '0036043', NULL, NULL, 121, NULL, 'Phospholipase A2, PLA2', 284957),
(467160, '0037472', NULL, NULL, 122, NULL, 'Phospholipase A2, PLA2', 284957),
(467161, '0046918', NULL, NULL, 123, NULL, 'Phospholipase A2, PLA2', 284957),
(467162, '0047620', NULL, NULL, 122, NULL, 'Phospholipase A2, PLA2', 284957),
(467163, '0048119', NULL, NULL, 124, NULL, 'Phospholipase A2, PLA2', 284957),
(467164, '0043501', NULL, NULL, 119, NULL, 'Phospholipase A2, PLA2', 284957),
(467165, '0045390', NULL, NULL, 119, NULL, 'Phospholipase A2, PLA2', 284957),
(467166, '0037909', NULL, NULL, 118, NULL, 'Phospholipase A2, PLA2', 284957),
(467167, '0037507', NULL, NULL, 118, NULL, 'Phospholipase A2, PLA2', 284957),
(467168, '0037880', NULL, NULL, 118, NULL, 'Phospholipase A2, PLA2', 284957),
(467169, '0042104', NULL, NULL, 121, NULL, 'Phospholipase A2, PLA2', 284957),
(467170, '0042402', NULL, NULL, 118, NULL, 'Phospholipase A2, PLA2', 284957),
(467171, '0040288', NULL, NULL, 124, NULL, 'Phospholipase A2, PLA2', 284957);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(467172, '0042403', NULL, NULL, 134, NULL, 'Phospholipase A2, PLA2', 284957),
(467173, '0040881', NULL, NULL, 122, NULL, 'Phospholipase A2, PLA2', 284957),
(467174, '0039565', NULL, NULL, 122, NULL, 'Phospholipase A2, PLA2', 284957),
(467175, '0035584', NULL, NULL, 122, NULL, 'Phospholipase A2, PLA2', 284957),
(467176, '0042187', NULL, NULL, 124, NULL, 'Phospholipase A2, PLA2', 284957),
(467177, '0042848', NULL, NULL, 121, NULL, 'Phospholipase A2, PLA2', 284957),
(467178, '0038198', NULL, NULL, 124, NULL, 'Phospholipase A2, PLA2', 284957),
(467179, '0040924', NULL, NULL, 119, NULL, 'Phospholipase A2, PLA2', 284957),
(467180, '0040846', NULL, NULL, 119, NULL, 'Phospholipase A2, PLA2', 284957),
(467181, '0041979', NULL, NULL, 122, NULL, 'Phospholipase A2, PLA2', 284957),
(467182, '0040922', NULL, NULL, 119, NULL, 'Phospholipase A2, PLA2', 284957),
(467183, '0038172', NULL, NULL, 122, NULL, 'Phospholipase A2, PLA2', 284957),
(467184, '0040921', NULL, NULL, 119, NULL, 'Phospholipase A2, PLA2', 284957),
(467185, '0044685', NULL, NULL, 123, NULL, 'Phospholipase A2, PLA2', 284957),
(467186, '0042401', NULL, NULL, 118, NULL, 'Phospholipase A2, PLA2', 284957),
(467187, '0044788', NULL, NULL, 121, NULL, 'Phospholipase A2, PLA2', 284957),
(467188, '0052014', NULL, NULL, 456, NULL, 'RNI-like', 284958),
(467189, '0037738', NULL, NULL, 286, NULL, 'RNI-like', 284958),
(467190, '0039098', NULL, NULL, 166, NULL, 'RNI-like', 284958),
(467191, '0048761', NULL, NULL, 167, NULL, 'RNI-like', 284958),
(467192, '0045099', NULL, NULL, 343, NULL, 'RNI-like', 284958),
(467193, '0045711', NULL, NULL, 460, NULL, 'RNI-like', 284958),
(467194, '0037671', NULL, NULL, 206, NULL, 'Formyltransferase', 284959),
(467195, '0051571', NULL, NULL, 164, NULL, 'Formyltransferase', 284959),
(467196, '0052063', NULL, NULL, 203, NULL, 'Formyltransferase', 284959),
(467197, '0043482', NULL, NULL, 203, NULL, 'Formyltransferase', 284959),
(467198, '0040902', NULL, NULL, 205, NULL, 'Formyltransferase', 284959),
(467199, '0051998', NULL, NULL, 203, NULL, 'Formyltransferase', 284959),
(467200, '0047614', NULL, NULL, 209, NULL, 'Formyltransferase', 284959),
(467201, '0036841', NULL, NULL, 50, NULL, 'Type X cellulose binding domain, CBDX', 284960),
(467202, '0040205', NULL, NULL, 216, NULL, 'Thymidylate synthase-complementing protein Thy1', 284961),
(467203, '0049123', NULL, NULL, 408, NULL, 'Family 10 polysaccharide lyase', 284962),
(467204, '0038318', NULL, NULL, 324, NULL, 'Family 10 polysaccharide lyase', 284962),
(467205, '0053506', NULL, NULL, 33, NULL, 'Proline/betaine transporter ProP, C-terminal cytoplasmic domain', 284963),
(467206, '0039754', NULL, NULL, 165, NULL, 'beta-lactamase-inhibitor protein, BLIP', 284964),
(467207, '0054595', NULL, NULL, 55, NULL, 'Ribosomal protein S18', 284965),
(467208, '0038930', NULL, NULL, 82, NULL, 'Ribosomal protein S18', 284965),
(467209, '0043655', NULL, NULL, 270, NULL, 'VP4 membrane interaction domain', 284966),
(467210, '0052059', NULL, NULL, 361, NULL, 'Glycosyl hydrolases family 6, cellulases', 284967),
(467211, '0052024', NULL, NULL, 285, NULL, 'Glycosyl hydrolases family 6, cellulases', 284967),
(467212, '0048971', NULL, NULL, 362, NULL, 'Glycosyl hydrolases family 6, cellulases', 284967),
(467213, '0049965', NULL, NULL, 301, NULL, 'Glycosyl hydrolases family 6, cellulases', 284967),
(467214, '0046426', NULL, NULL, 345, NULL, 'Glycosyl hydrolases family 6, cellulases', 284967),
(467215, '0045082', NULL, NULL, 63, NULL, 'SH3-domain', 284968),
(467216, '0048550', NULL, NULL, 59, NULL, 'SH3-domain', 284968),
(467217, '0049882', NULL, NULL, 93, NULL, 'SH3-domain', 284968),
(467218, '0053627', NULL, NULL, 66, NULL, 'SH3-domain', 284968),
(467219, '0052732', NULL, NULL, 63, NULL, 'SH3-domain', 284968),
(467220, '0047748', NULL, NULL, 62, NULL, 'SH3-domain', 284968),
(467221, '0047507', NULL, NULL, 74, NULL, 'SH3-domain', 284968),
(467222, '0049926', NULL, NULL, 76, NULL, 'SH3-domain', 284968),
(467223, '0044915', NULL, NULL, 136, NULL, 'SH3-domain', 284968),
(467224, '0044917', NULL, NULL, 145, NULL, 'SH3-domain', 284968);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(467225, '0050508', NULL, NULL, 74, NULL, 'SH3-domain', 284968),
(467226, '0047146', NULL, NULL, 63, NULL, 'SH3-domain', 284968),
(467227, '0047663', NULL, NULL, 79, NULL, 'SH3-domain', 284968),
(467228, '0045920', NULL, NULL, 83, NULL, 'SH3-domain', 284968),
(467229, '0050000', NULL, NULL, 57, NULL, 'SH3-domain', 284968),
(467230, '0049175', NULL, NULL, 77, NULL, 'SH3-domain', 284968),
(467231, '0049890', NULL, NULL, 92, NULL, 'SH3-domain', 284968),
(467232, '0051651', NULL, NULL, 56, NULL, 'SH3-domain', 284968),
(467233, '0047233', NULL, NULL, 71, NULL, 'SH3-domain', 284968),
(467234, '0049376', NULL, NULL, 58, NULL, 'SH3-domain', 284968),
(467235, '0044361', NULL, NULL, 79, NULL, 'SH3-domain', 284968),
(467236, '0036795', NULL, NULL, 61, NULL, 'SH3-domain', 284968),
(467237, '0052588', NULL, NULL, 59, NULL, 'SH3-domain', 284968),
(467238, '0045813', NULL, NULL, 60, NULL, 'SH3-domain', 284968),
(467239, '0036794', NULL, NULL, 59, NULL, 'SH3-domain', 284968),
(467240, '0046906', NULL, NULL, 62, NULL, 'SH3-domain', 284968),
(467241, '0041374', NULL, NULL, 118, NULL, 'SH3-domain', 284968),
(467242, '0042705', NULL, NULL, 65, NULL, 'SH3-domain', 284968),
(467243, '0041338', NULL, NULL, 65, NULL, 'SH3-domain', 284968),
(467244, '0047043', NULL, NULL, 61, NULL, 'SH3-domain', 284968),
(467245, '0036029', NULL, NULL, 57, NULL, 'SH3-domain', 284968),
(467246, '0046957', NULL, NULL, 74, NULL, 'SH3-domain', 284968),
(467247, '0048617', NULL, NULL, 58, NULL, 'SH3-domain', 284968),
(467248, '0049905', NULL, NULL, 69, NULL, 'SH3-domain', 284968),
(467249, '0047765', NULL, NULL, 71, NULL, 'SH3-domain', 284968),
(467250, '0049700', NULL, NULL, 61, NULL, 'SH3-domain', 284968),
(467251, '0047642', NULL, NULL, 58, NULL, 'SH3-domain', 284968),
(467252, '0047724', NULL, NULL, 78, NULL, 'SH3-domain', 284968),
(467253, '0047008', NULL, NULL, 67, NULL, 'SH3-domain', 284968),
(467254, '0042039', NULL, NULL, 65, NULL, 'SH3-domain', 284968),
(467255, '0049867', NULL, NULL, 98, NULL, 'SH3-domain', 284968),
(467256, '0049900', NULL, NULL, 72, NULL, 'SH3-domain', 284968),
(467257, '0050583', NULL, NULL, 96, NULL, 'SH3-domain', 284968),
(467258, '0038838', NULL, NULL, 106, NULL, 'SH3-domain', 284968),
(467259, '0049871', NULL, NULL, 80, NULL, 'SH3-domain', 284968),
(467260, '0053615', NULL, NULL, 71, NULL, 'SH3-domain', 284968),
(467261, '0038478', NULL, NULL, 57, NULL, 'SH3-domain', 284968),
(467262, '0037667', NULL, NULL, 64, NULL, 'SH3-domain', 284968),
(467263, '0045835', NULL, NULL, 67, NULL, 'SH3-domain', 284968),
(467264, '0043854', NULL, NULL, 107, NULL, 'SH3-domain', 284968),
(467265, '0049918', NULL, NULL, 58, NULL, 'SH3-domain', 284968),
(467266, '0045834', NULL, NULL, 77, NULL, 'SH3-domain', 284968),
(467267, '0043613', NULL, NULL, 59, NULL, 'SH3-domain', 284968),
(467268, '0047819', NULL, NULL, 96, NULL, 'SH3-domain', 284968),
(467269, '0046960', NULL, NULL, 69, NULL, 'SH3-domain', 284968),
(467270, '0042323', NULL, NULL, 83, NULL, 'SH3-domain', 284968),
(467271, '0049439', NULL, NULL, 72, NULL, 'SH3-domain', 284968),
(467272, '0045799', NULL, NULL, 60, NULL, 'SH3-domain', 284968),
(467273, '0047698', NULL, NULL, 200, NULL, 'Casein kinase II beta subunit', 284969),
(467274, '0052513', NULL, NULL, 149, NULL, 'LemA-like', 284970),
(467275, '0048156', NULL, NULL, 65, NULL, 'Immunoglobulin-binding domains', 284971),
(467276, '0048762', NULL, NULL, 70, NULL, 'Immunoglobulin-binding domains', 284971),
(467277, '0048155', NULL, NULL, 63, NULL, 'Immunoglobulin-binding domains', 284971),
(467278, '0053109', NULL, NULL, 64, NULL, 'Immunoglobulin-binding domains', 284971),
(467279, '0047628', NULL, NULL, 72, NULL, 'Immunoglobulin-binding domains', 284971),
(467280, '0047749', NULL, NULL, 72, NULL, 'Immunoglobulin-binding domains', 284971),
(467281, '0048754', NULL, NULL, 56, NULL, 'Immunoglobulin-binding domains', 284971),
(467282, '0046588', NULL, NULL, 56, NULL, 'Immunoglobulin-binding domains', 284971),
(467283, '0048158', NULL, NULL, 61, NULL, 'Immunoglobulin-binding domains', 284971),
(467284, '0053281', NULL, NULL, 78, NULL, 'Immunoglobulin-binding domains', 284971); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(467285, '0046754', NULL, NULL, 56, NULL, 'Immunoglobulin-binding domains', 284971),
(467286, '0046757', NULL, NULL, 57, NULL, 'Immunoglobulin-binding domains', 284971),
(467287, '0046955', NULL, NULL, 57, NULL, 'Immunoglobulin-binding domains', 284971),
(467288, '0047800', NULL, NULL, 65, NULL, 'Immunoglobulin-binding domains', 284971),
(467289, '0048229', NULL, NULL, 56, NULL, 'Immunoglobulin-binding domains', 284971),
(467290, '0038703', NULL, NULL, 109, NULL, 'Uridine diphospho-N-Acetylenolpyruvylglucosamine reductase, MurB, C-terminal domain', 284972),
(467291, '0044562', NULL, NULL, 142, NULL, 'Uridine diphospho-N-Acetylenolpyruvylglucosamine reductase, MurB, C-terminal domain', 284972),
(467292, '0037281', NULL, NULL, 82, NULL, 'Insect cysteine-rich antifreeze protein', 284973),
(467293, '0054787', NULL, NULL, 127, NULL, 'Ribosomal protein L22', 284974),
(467294, '0035758', NULL, NULL, 110, NULL, 'Ribosomal protein L22', 284974),
(467295, '0054004', NULL, NULL, 106, NULL, 'Ribosomal protein L22', 284974),
(467296, '0037543', NULL, NULL, 150, NULL, 'Ribosomal protein L22', 284974),
(467297, '0039894', NULL, NULL, 113, NULL, 'Type III secretory system chaperone-like', 284975),
(467298, '0043414', NULL, NULL, 133, NULL, 'Type III secretory system chaperone-like', 284975),
(467299, '0054523', NULL, NULL, 152, NULL, 'Type III secretory system chaperone-like', 284975),
(467300, '0040365', NULL, NULL, 57, NULL, 'Type III secretory system chaperone-like', 284975),
(467301, '0047737', NULL, NULL, 146, NULL, 'Type III secretory system chaperone-like', 284975),
(467302, '0047708', NULL, NULL, 130, NULL, 'Type III secretory system chaperone-like', 284975),
(467303, '0049694', NULL, NULL, 118, NULL, 'Type III secretory system chaperone-like', 284975),
(467304, '0043472', NULL, NULL, 130, NULL, 'Type III secretory system chaperone-like', 284975),
(467305, '0052716', NULL, NULL, 134, NULL, 'Type III secretory system chaperone-like', 284975),
(467306, '0047757', NULL, NULL, 130, NULL, 'Type III secretory system chaperone-like', 284975),
(467307, '0051005', NULL, NULL, 126, NULL, 'Type III secretory system chaperone-like', 284975),
(467308, '0051004', NULL, NULL, 121, NULL, 'Type III secretory system chaperone-like', 284975),
(467309, '0050562', NULL, NULL, 124, NULL, 'R3H domain', 284976),
(467310, '0049895', NULL, NULL, 87, NULL, 'R3H domain', 284976),
(467311, '0048219', NULL, NULL, 62, NULL, 'R3H domain', 284976),
(467312, '0049475', NULL, NULL, 225, NULL, 'PhoU-like', 284977),
(467313, '0050141', NULL, NULL, 99, NULL, 'PhoU-like', 284977),
(467314, '0051131', NULL, NULL, 212, NULL, 'PhoU-like', 284977),
(467315, '0049559', NULL, NULL, 215, NULL, 'PhoU-like', 284977),
(467316, '0038576', NULL, NULL, 88, NULL, 'Fe-only hydrogenase smaller subunit', 284978),
(467317, '0043282', NULL, NULL, 36, NULL, 'Oligosaccharyltransferase subunit ost4p', 284979),
(467318, '0043888', NULL, NULL, 301, NULL, 'ADP-ribosylglycohydrolase', 284980),
(467319, '0054840', NULL, NULL, 91, NULL, 'MTH889-like', 284981),
(467320, '0054663', NULL, NULL, 93, NULL, 'MTH889-like', 284981),
(467321, '0051178', NULL, NULL, 80, NULL, 'N-terminal, heterodimerisation domain of RBP7 (RpoE)', 284982),
(467322, '0038182', NULL, NULL, 78, NULL, 'N-terminal, heterodimerisation domain of RBP7 (RpoE)', 284982),
(467323, '0052108', NULL, NULL, 77, NULL, 'N-terminal, heterodimerisation domain of RBP7 (RpoE)', 284982),
(467324, '0050099', NULL, NULL, 292, NULL, 'FAD-linked oxidoreductase', 284983),
(467325, '0047760', NULL, NULL, 351, NULL, 'FAD-linked oxidoreductase', 284983),
(467326, '0045882', NULL, NULL, 275, NULL, 'FAD-linked oxidoreductase', 284983),
(467327, '0053405', NULL, NULL, 101, NULL, 'Coiled-coil domain of nucleotide exchange factor GrpE', 284984),
(467328, '0044680', NULL, NULL, 39, NULL, 'LDL receptor-like module', 284985),
(467329, '0037404', NULL, NULL, 41, NULL, 'LDL receptor-like module', 284985),
(467330, '0036124', NULL, NULL, 42, NULL, 'LDL receptor-like module', 284985),
(467331, '0052956', NULL, NULL, 41, NULL, 'LDL receptor-like module', 284985);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(467332, '0052954', NULL, NULL, 41, NULL, 'LDL receptor-like module', 284985),
(467333, '0037446', NULL, NULL, 39, NULL, 'LDL receptor-like module', 284985),
(467334, '0052952', NULL, NULL, 42, NULL, 'LDL receptor-like module', 284985),
(467335, '0039420', NULL, NULL, 44, NULL, 'LDL receptor-like module', 284985),
(467336, '0040464', NULL, NULL, 46, NULL, 'LDL receptor-like module', 284985),
(467337, '0039720', NULL, NULL, 47, NULL, 'LDL receptor-like module', 284985),
(467338, '0041242', NULL, NULL, 44, NULL, 'LDL receptor-like module', 284985),
(467339, '0036243', NULL, NULL, 45, NULL, 'LDL receptor-like module', 284985),
(467340, '0041241', NULL, NULL, 50, NULL, 'LDL receptor-like module', 284985),
(467341, '0041240', NULL, NULL, 41, NULL, 'LDL receptor-like module', 284985),
(467342, '0035070', NULL, NULL, 37, NULL, 'LDL receptor-like module', 284985),
(467343, '0042656', NULL, NULL, 308, NULL, 'Nucleoside hydrolase', 284986),
(467344, '0037284', NULL, NULL, 312, NULL, 'Nucleoside hydrolase', 284986),
(467345, '0038660', NULL, NULL, 328, NULL, 'Nucleoside hydrolase', 284986),
(467346, '0045355', NULL, NULL, 313, NULL, 'Nucleoside hydrolase', 284986),
(467347, '0053779', NULL, NULL, 120, NULL, 'ATP synthase D chain-like', 284987),
(467348, '0050665', NULL, NULL, 127, NULL, 'TTHA1528-like', 284988),
(467349, '0050142', NULL, NULL, 94, NULL, 'TrkA C-terminal domain-like', 284989),
(467350, '0052804', NULL, NULL, 92, NULL, 'TrkA C-terminal domain-like', 284989),
(467351, '0054344', NULL, NULL, 220, NULL, '14-3-3 protein', 284990),
(467352, '0054960', NULL, NULL, 223, NULL, '14-3-3 protein', 284990),
(467353, '0048523', NULL, NULL, 236, NULL, '14-3-3 protein', 284990),
(467354, '0048967', NULL, NULL, 232, NULL, '14-3-3 protein', 284990),
(467355, '0053448', NULL, NULL, 242, NULL, 'C-terminal domain of PLC-beta', 284991),
(467356, '0037297', NULL, NULL, 74, NULL, 'Non-heme 11 kDa protein of cytochrome bc1 complex (Ubiquinol-cytochrome c reductase)', 284992),
(467357, '0040340', NULL, NULL, 78, NULL, 'Non-heme 11 kDa protein of cytochrome bc1 complex (Ubiquinol-cytochrome c reductase)', 284992),
(467358, '0045701', NULL, NULL, 220, NULL, 'Pyrrolidone carboxyl peptidase (pyroglutamate aminopeptidase)', 284993),
(467359, '0045822', NULL, NULL, 210, NULL, 'Pyrrolidone carboxyl peptidase (pyroglutamate aminopeptidase)', 284993),
(467360, '0047403', NULL, NULL, 208, NULL, 'Pyrrolidone carboxyl peptidase (pyroglutamate aminopeptidase)', 284993),
(467361, '0047437', NULL, NULL, 206, NULL, 'Pyrrolidone carboxyl peptidase (pyroglutamate aminopeptidase)', 284993),
(467362, '0037298', NULL, NULL, 55, NULL, 'Subunit X (non-heme 7 kDa protein) of cytochrome bc1 complex (Ubiquinol-cytochrome c reductase)', 284994),
(467363, '0048797', NULL, NULL, 62, NULL, 'Subunit X (non-heme 7 kDa protein) of cytochrome bc1 complex (Ubiquinol-cytochrome c reductase)', 284994),
(467364, '0048028', NULL, NULL, 361, NULL, 'Homocysteine S-methyltransferase', 284995),
(467365, '0049954', NULL, NULL, 390, NULL, 'Homocysteine S-methyltransferase', 284995),
(467366, '0048902', NULL, NULL, 300, NULL, 'Homocysteine S-methyltransferase', 284995),
(467367, '0048929', NULL, NULL, 254, NULL, 'Outer membrane phospholipase A (OMPLA)', 284996),
(467368, '0053660', NULL, NULL, 152, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467369, '0039919', NULL, NULL, 152, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467370, '0054518', NULL, NULL, 176, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467371, '0050955', NULL, NULL, 257, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467372, '0035316', NULL, NULL, 234, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467373, '0051006', NULL, NULL, 272, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467374, '0042534', NULL, NULL, 154, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467375, '0043507', NULL, NULL, 169, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467376, '0038022', NULL, NULL, 167, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(467377, '0046574', NULL, NULL, 346, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467378, '0048755', NULL, NULL, 178, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467379, '0045243', NULL, NULL, 197, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467380, '0040910', NULL, NULL, 255, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467381, '0043068', NULL, NULL, 151, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467382, '0048516', NULL, NULL, 177, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467383, '0048757', NULL, NULL, 176, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467384, '0049845', NULL, NULL, 241, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467385, '0049966', NULL, NULL, 161, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467386, '0053794', NULL, NULL, 173, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467387, '0049730', NULL, NULL, 180, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467388, '0050040', NULL, NULL, 182, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467389, '0051491', NULL, NULL, 347, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467390, '0047550', NULL, NULL, 212, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467391, '0035543', NULL, NULL, 255, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467392, '0038814', NULL, NULL, 241, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467393, '0050967', NULL, NULL, 274, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467394, '0038379', NULL, NULL, 172, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467395, '0035305', NULL, NULL, 254, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467396, '0050721', NULL, NULL, 355, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467397, '0036194', NULL, NULL, 242, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467398, '0048409', NULL, NULL, 182, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467399, '0041692', NULL, NULL, 234, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467400, '0042429', NULL, NULL, 244, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467401, '0051925', NULL, NULL, 312, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467402, '0044044', NULL, NULL, 167, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467403, '0044840', NULL, NULL, 398, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467404, '0051264', NULL, NULL, 174, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467405, '0046472', NULL, NULL, 315, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467406, '0046592', NULL, NULL, 297, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467407, '0051260', NULL, NULL, 244, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467408, '0047681', NULL, NULL, 285, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467409, '0054099', NULL, NULL, 153, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467410, '0051702', NULL, NULL, 241, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467411, '0036746', NULL, NULL, 163, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467412, '0051147', NULL, NULL, 182, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467413, '0035535', NULL, NULL, 184, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467414, '0036744', NULL, NULL, 150, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467415, '0052116', NULL, NULL, 363, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467416, '0037278', NULL, NULL, 146, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467417, '0048414', NULL, NULL, 181, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467418, '0046357', NULL, NULL, 196, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467419, '0047443', NULL, NULL, 136, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467420, '0049864', NULL, NULL, 338, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467421, '0046114', NULL, NULL, 175, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997);
INSERT INTO "PUBLIC"."MODEL" VALUES
(467422, '0048533', NULL, NULL, 171, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467423, '0044853', NULL, NULL, 281, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467424, '0048416', NULL, NULL, 167, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467425, '0049198', NULL, NULL, 356, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467426, '0046483', NULL, NULL, 284, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467427, '0045153', NULL, NULL, 259, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467428, '0051955', NULL, NULL, 240, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467429, '0052803', NULL, NULL, 129, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467430, '0035405', NULL, NULL, 156, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467431, '0051279', NULL, NULL, 250, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467432, '0052368', NULL, NULL, 248, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467433, '0053216', NULL, NULL, 238, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467434, '0038232', NULL, NULL, 244, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467435, '0041596', NULL, NULL, 148, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467436, '0049519', NULL, NULL, 347, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467437, '0045718', NULL, NULL, 140, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467438, '0046123', NULL, NULL, 148, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467439, '0046367', NULL, NULL, 294, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467440, '0042207', NULL, NULL, 137, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467441, '0046801', NULL, NULL, 257, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467442, '0048673', NULL, NULL, 174, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467443, '0054552', NULL, NULL, 152, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467444, '0051285', NULL, NULL, 185, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467445, '0046253', NULL, NULL, 176, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467446, '0051965', NULL, NULL, 268, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467447, '0039314', NULL, NULL, 169, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467448, '0039438', NULL, NULL, 259, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467449, '0038342', NULL, NULL, 302, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467450, '0041366', NULL, NULL, 244, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467451, '0047909', NULL, NULL, 150, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467452, '0050869', NULL, NULL, 340, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467453, '0047346', NULL, NULL, 153, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467454, '0048799', NULL, NULL, 183, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467455, '0049766', NULL, NULL, 288, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467456, '0041129', NULL, NULL, 193, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467457, '0047470', NULL, NULL, 258, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467458, '0053356', NULL, NULL, 160, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467459, '0052382', NULL, NULL, 139, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467460, '0037128', NULL, NULL, 307, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467461, '0043678', NULL, NULL, 248, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467462, '0044526', NULL, NULL, 168, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467463, '0039780', NULL, NULL, 144, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467464, '0040043', NULL, NULL, 346, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467465, '0052818', NULL, NULL, 180, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467466, '0042340', NULL, NULL, 168, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997);
INSERT INTO "PUBLIC"."MODEL" VALUES
(467467, '0042342', NULL, NULL, 113, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467468, '0047481', NULL, NULL, 171, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467469, '0050890', NULL, NULL, 176, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467470, '0053363', NULL, NULL, 160, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467471, '0048454', NULL, NULL, 158, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467472, '0051183', NULL, NULL, 342, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467473, '0046034', NULL, NULL, 350, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467474, '0042906', NULL, NULL, 130, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467475, '0052837', NULL, NULL, 171, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467476, '0038324', NULL, NULL, 383, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467477, '0038567', NULL, NULL, 176, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467478, '0035733', NULL, NULL, 238, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467479, '0050655', NULL, NULL, 275, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467480, '0050776', NULL, NULL, 260, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467481, '0039650', NULL, NULL, 172, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467482, '0050090', NULL, NULL, 163, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467483, '0047124', NULL, NULL, 260, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467484, '0048455', NULL, NULL, 177, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467485, '0035290', NULL, NULL, 166, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467486, '0045621', NULL, NULL, 154, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467487, '0049428', NULL, NULL, 248, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467488, '0051991', NULL, NULL, 232, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467489, '0048585', NULL, NULL, 142, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467490, '0048102', NULL, NULL, 189, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467491, '0041828', NULL, NULL, 220, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467492, '0045076', NULL, NULL, 270, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467493, '0052284', NULL, NULL, 129, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467494, '0034872', NULL, NULL, 170, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467495, '0038559', NULL, NULL, 236, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467496, '0051511', NULL, NULL, 257, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467497, '0052722', NULL, NULL, 230, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467498, '0053019', NULL, NULL, 145, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467499, '0051873', NULL, NULL, 242, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467500, '0051996', NULL, NULL, 342, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467501, '0043337', NULL, NULL, 321, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467502, '0045516', NULL, NULL, 171, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467503, '0046725', NULL, NULL, 174, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467504, '0040868', NULL, NULL, 148, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467505, '0048227', NULL, NULL, 202, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467506, '0048469', NULL, NULL, 170, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467507, '0045873', NULL, NULL, 163, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467508, '0042366', NULL, NULL, 171, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467509, '0048107', NULL, NULL, 176, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467510, '0036806', NULL, NULL, 255, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467511, '0046291', NULL, NULL, 357, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997);
INSERT INTO "PUBLIC"."MODEL" VALUES
(467512, '0053266', NULL, NULL, 274, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467513, '0049686', NULL, NULL, 167, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467514, '0047263', NULL, NULL, 146, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467515, '0053383', NULL, NULL, 159, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467516, '0052978', NULL, NULL, 155, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467517, '0036922', NULL, NULL, 244, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467518, '0038545', NULL, NULL, 253, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467519, '0051763', NULL, NULL, 245, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467520, '0054911', NULL, NULL, 162, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467521, '0035952', NULL, NULL, 172, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467522, '0036007', NULL, NULL, 182, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467523, '0038547', NULL, NULL, 170, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467524, '0039871', NULL, NULL, 256, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467525, '0044559', NULL, NULL, 142, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467526, '0038784', NULL, NULL, 145, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467527, '0042131', NULL, NULL, 284, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467528, '0046059', NULL, NULL, 201, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467529, '0045645', NULL, NULL, 175, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467530, '0048361', NULL, NULL, 290, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467531, '0035945', NULL, NULL, 170, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467532, '0047276', NULL, NULL, 160, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467533, '0047032', NULL, NULL, 159, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467534, '0048243', NULL, NULL, 266, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467535, '0052988', NULL, NULL, 268, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467536, '0052744', NULL, NULL, 259, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467537, '0050443', NULL, NULL, 186, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467538, '0052745', NULL, NULL, 209, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467539, '0050204', NULL, NULL, 187, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467540, '0050203', NULL, NULL, 182, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467541, '0046629', NULL, NULL, 130, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467542, '0048808', NULL, NULL, 188, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467543, '0038770', NULL, NULL, 253, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467544, '0052183', NULL, NULL, 145, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467545, '0047278', NULL, NULL, 159, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467546, '0045894', NULL, NULL, 179, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467547, '0051093', NULL, NULL, 274, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467548, '0047955', NULL, NULL, 173, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467549, '0041610', NULL, NULL, 251, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467550, '0052873', NULL, NULL, 254, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467551, '0051542', NULL, NULL, 302, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467552, '0047040', NULL, NULL, 298, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467553, '0053286', NULL, NULL, 259, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467554, '0053287', NULL, NULL, 252, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467555, '0044691', NULL, NULL, 170, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467556, '0037437', NULL, NULL, 183, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997);
INSERT INTO "PUBLIC"."MODEL" VALUES
(467557, '0051305', NULL, NULL, 184, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467558, '0050212', NULL, NULL, 193, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467559, '0035018', NULL, NULL, 258, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467560, '0038761', NULL, NULL, 293, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467561, '0040651', NULL, NULL, 134, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467562, '0047847', NULL, NULL, 195, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467563, '0038087', NULL, NULL, 190, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467564, '0047963', NULL, NULL, 148, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467565, '0041868', NULL, NULL, 121, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467566, '0049902', NULL, NULL, 329, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467567, '0046635', NULL, NULL, 239, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467568, '0047965', NULL, NULL, 230, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467569, '0047294', NULL, NULL, 152, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467570, '0047178', NULL, NULL, 205, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467571, '0047054', NULL, NULL, 239, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467572, '0052085', NULL, NULL, 251, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467573, '0050228', NULL, NULL, 177, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467574, '0052529', NULL, NULL, 247, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467575, '0050103', NULL, NULL, 242, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467576, '0051797', NULL, NULL, 152, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467577, '0039600', NULL, NULL, 411, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467578, '0036579', NULL, NULL, 170, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467579, '0048949', NULL, NULL, 257, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467580, '0037662', NULL, NULL, 255, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467581, '0047979', NULL, NULL, 286, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467582, '0040540', NULL, NULL, 149, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467583, '0046529', NULL, NULL, 171, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467584, '0045319', NULL, NULL, 142, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467585, '0053172', NULL, NULL, 159, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467586, '0049117', NULL, NULL, 322, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467587, '0047059', NULL, NULL, 189, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467588, '0048027', NULL, NULL, 132, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467589, '0041757', NULL, NULL, 259, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467590, '0041999', NULL, NULL, 338, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467591, '0049357', NULL, NULL, 341, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467592, '0051440', NULL, NULL, 297, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467593, '0048035', NULL, NULL, 191, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467594, '0047066', NULL, NULL, 142, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467595, '0035477', NULL, NULL, 155, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467596, '0051327', NULL, NULL, 174, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467597, '0050235', NULL, NULL, 222, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467598, '0051203', NULL, NULL, 265, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467599, '0048270', NULL, NULL, 298, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467600, '0052415', NULL, NULL, 171, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467601, '0050237', NULL, NULL, 251, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997);
INSERT INTO "PUBLIC"."MODEL" VALUES
(467602, '0051568', NULL, NULL, 260, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467603, '0038068', NULL, NULL, 255, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467604, '0047869', NULL, NULL, 167, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467605, '0040551', NULL, NULL, 166, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467606, '0043703', NULL, NULL, 264, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467607, '0035471', NULL, NULL, 276, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467608, '0047742', NULL, NULL, 191, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467609, '0049007', NULL, NULL, 181, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467610, '0045444', NULL, NULL, 121, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467611, '0046897', NULL, NULL, 352, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467612, '0050241', NULL, NULL, 321, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467613, '0050365', NULL, NULL, 259, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467614, '0051575', NULL, NULL, 182, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467615, '0051696', NULL, NULL, 212, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467616, '0047992', NULL, NULL, 143, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467617, '0048286', NULL, NULL, 288, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467618, '0042180', NULL, NULL, 171, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467619, '0036438', NULL, NULL, 163, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467620, '0038853', NULL, NULL, 190, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467621, '0051213', NULL, NULL, 142, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467622, '0050247', NULL, NULL, 129, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467623, '0038057', NULL, NULL, 191, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467624, '0042866', NULL, NULL, 226, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467625, '0041770', NULL, NULL, 174, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467626, '0042505', NULL, NULL, 252, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467627, '0050914', NULL, NULL, 126, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467628, '0053195', NULL, NULL, 188, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467629, '0038050', NULL, NULL, 172, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467630, '0047993', NULL, NULL, 305, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467631, '0043276', NULL, NULL, 168, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467632, '0047510', NULL, NULL, 197, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467633, '0047516', NULL, NULL, 133, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467634, '0048293', NULL, NULL, 339, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467635, '0049026', NULL, NULL, 390, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467636, '0043041', NULL, NULL, 307, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467637, '0043042', NULL, NULL, 312, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467638, '0039935', NULL, NULL, 350, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467639, '0044808', NULL, NULL, 276, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467640, '0036664', NULL, NULL, 199, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467641, '0036785', NULL, NULL, 183, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467642, '0036542', NULL, NULL, 196, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467643, '0051109', NULL, NULL, 269, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467644, '0051901', NULL, NULL, 167, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467645, '0038042', NULL, NULL, 261, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467646, '0048974', NULL, NULL, 204, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997);
INSERT INTO "PUBLIC"."MODEL" VALUES
(467647, '0049943', NULL, NULL, 256, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467648, '0046673', NULL, NULL, 192, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467649, '0049942', NULL, NULL, 242, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467650, '0038281', NULL, NULL, 142, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467651, '0049820', NULL, NULL, 170, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467652, '0049824', NULL, NULL, 167, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467653, '0048614', NULL, NULL, 235, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467654, '0050022', NULL, NULL, 237, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467655, '0048186', NULL, NULL, 144, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467656, '0052565', NULL, NULL, 165, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467657, '0051355', NULL, NULL, 250, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467658, '0050383', NULL, NULL, 294, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467659, '0052329', NULL, NULL, 156, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467660, '0052326', NULL, NULL, 184, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467661, '0051235', NULL, NULL, 116, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467662, '0038711', NULL, NULL, 150, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467663, '0050269', NULL, NULL, 161, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467664, '0036892', NULL, NULL, 169, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467665, '0050938', NULL, NULL, 168, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467666, '0035680', NULL, NULL, 147, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467667, '0047655', NULL, NULL, 174, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467668, '0048863', NULL, NULL, 168, NULL, 'NAD(P)-binding Rossmann-fold domains', 284997),
(467669, '0052135', NULL, NULL, 65, NULL, 'Endosomal sorting complex assembly domain', 284998),
(467670, '0052134', NULL, NULL, 101, NULL, 'Endosomal sorting complex assembly domain', 284998),
(467671, '0052607', NULL, NULL, 104, NULL, 'Endosomal sorting complex assembly domain', 284998),
(467672, '0052606', NULL, NULL, 64, NULL, 'Endosomal sorting complex assembly domain', 284998),
(467673, '0052603', NULL, NULL, 65, NULL, 'Endosomal sorting complex assembly domain', 284998),
(467674, '0053727', NULL, NULL, 344, NULL, 'Release factor', 284999),
(467675, '0043341', NULL, NULL, 333, NULL, 'Release factor', 284999),
(467676, '0038227', NULL, NULL, 362, NULL, 'Release factor', 284999),
(467677, '0045181', NULL, NULL, 355, NULL, 'YVTN repeat-like/Quinoprotein amine dehydrogenase', 285000),
(467678, '0047606', NULL, NULL, 337, NULL, 'YVTN repeat-like/Quinoprotein amine dehydrogenase', 285000),
(467679, '0047917', NULL, NULL, 301, NULL, 'YVTN repeat-like/Quinoprotein amine dehydrogenase', 285000),
(467680, '0048144', NULL, NULL, 368, NULL, 'YVTN repeat-like/Quinoprotein amine dehydrogenase', 285000),
(467681, '0039648', NULL, NULL, 346, NULL, 'YVTN repeat-like/Quinoprotein amine dehydrogenase', 285000),
(467682, '0053180', NULL, NULL, 373, NULL, 'YVTN repeat-like/Quinoprotein amine dehydrogenase', 285000),
(467683, '0050891', NULL, NULL, 246, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467684, '0050370', NULL, NULL, 458, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467685, '0053342', NULL, NULL, 256, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467686, '0046452', NULL, NULL, 243, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467687, '0048110', NULL, NULL, 251, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467688, '0052119', NULL, NULL, 385, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467689, '0046070', NULL, NULL, 358, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467690, '0038744', NULL, NULL, 346, NULL, 'beta-lactamase/transpeptidase-like', 285001);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(467691, '0051964', NULL, NULL, 453, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467692, '0052534', NULL, NULL, 456, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467693, '0046615', NULL, NULL, 260, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467694, '0047727', NULL, NULL, 368, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467695, '0046014', NULL, NULL, 265, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467696, '0040978', NULL, NULL, 328, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467697, '0038040', NULL, NULL, 364, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467698, '0048511', NULL, NULL, 267, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467699, '0049225', NULL, NULL, 368, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467700, '0044213', NULL, NULL, 309, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467701, '0046438', NULL, NULL, 278, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467702, '0051055', NULL, NULL, 269, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467703, '0052144', NULL, NULL, 262, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467704, '0052485', NULL, NULL, 362, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467705, '0050287', NULL, NULL, 341, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467706, '0047175', NULL, NULL, 260, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467707, '0045791', NULL, NULL, 263, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467708, '0054384', NULL, NULL, 400, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467709, '0053815', NULL, NULL, 388, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467710, '0037741', NULL, NULL, 361, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467711, '0050388', NULL, NULL, 467, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467712, '0048080', NULL, NULL, 263, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467713, '0038811', NULL, NULL, 264, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467714, '0046929', NULL, NULL, 266, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467715, '0048985', NULL, NULL, 357, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467716, '0049712', NULL, NULL, 301, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467717, '0046343', NULL, NULL, 258, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467718, '0047476', NULL, NULL, 261, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467719, '0046147', NULL, NULL, 377, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467720, '0046422', NULL, NULL, 267, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467721, '0046565', NULL, NULL, 333, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467722, '0048423', NULL, NULL, 246, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467723, '0047733', NULL, NULL, 241, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467724, '0048305', NULL, NULL, 265, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467725, '0046008', NULL, NULL, 266, NULL, 'beta-lactamase/transpeptidase-like', 285001),
(467726, '0048894', NULL, NULL, 99, NULL, 'GTF2I-like repeat', 285002),
(467727, '0051782', NULL, NULL, 328, NULL, 'FucI/AraA N-terminal and middle domains', 285003),
(467728, '0037785', NULL, NULL, 355, NULL, 'FucI/AraA N-terminal and middle domains', 285003),
(467729, '0039344', NULL, NULL, 142, NULL, 'Ribosomal protein L13', 285004),
(467730, '0054000', NULL, NULL, 140, NULL, 'Ribosomal protein L13', 285004),
(467731, '0054181', NULL, NULL, 139, NULL, 'Ribosomal protein L13', 285004),
(467732, '0054778', NULL, NULL, 142, NULL, 'Ribosomal protein L13', 285004),
(467733, '0037535', NULL, NULL, 142, NULL, 'Ribosomal protein L13', 285004),
(467734, '0045702', NULL, NULL, 147, NULL, 'Satellite viruses', 285005),
(467735, '0052051', NULL, NULL, 184, NULL, 'Satellite viruses', 285005),
(467736, '0049467', NULL, NULL, 141, NULL, 'Satellite viruses', 285005),
(467737, '0054033', NULL, NULL, 106, NULL, 'PA1123-like', 285006);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(467738, '0037387', NULL, NULL, 60, NULL, 'ROP protein', 285007),
(467739, '0041431', NULL, NULL, 59, NULL, 'ROP protein', 285007),
(467740, '0047055', NULL, NULL, 62, NULL, 'ROP protein', 285007),
(467741, '0053209', NULL, NULL, 189, NULL, 'Rhomboid-like', 285008),
(467742, '0053091', NULL, NULL, 182, NULL, 'Rhomboid-like', 285008),
(467743, '0050884', NULL, NULL, 272, NULL, 'ATP-dependent DNA ligase DNA-binding domain', 285009),
(467744, '0049484', NULL, NULL, 108, NULL, 'RuBisCO, small subunit', 285010),
(467745, '0043190', NULL, NULL, 109, NULL, 'RuBisCO, small subunit', 285010),
(467746, '0035748', NULL, NULL, 138, NULL, 'RuBisCO, small subunit', 285010),
(467747, '0039144', NULL, NULL, 140, NULL, 'RuBisCO, small subunit', 285010),
(467748, '0039143', NULL, NULL, 123, NULL, 'RuBisCO, small subunit', 285010),
(467749, '0035764', NULL, NULL, 129, NULL, 'RuBisCO, small subunit', 285010),
(467750, '0050439', NULL, NULL, 122, NULL, 'RuBisCO, small subunit', 285010),
(467751, '0045565', NULL, NULL, 123, NULL, 'RuBisCO, small subunit', 285010),
(467752, '0053616', NULL, NULL, 134, NULL, 'RuBisCO, small subunit', 285010),
(467753, '0045666', NULL, NULL, 123, NULL, 'RuBisCO, small subunit', 285010),
(467754, '0047914', NULL, NULL, 153, NULL, 'BRCT domain', 285011),
(467755, '0050485', NULL, NULL, 132, NULL, 'BRCT domain', 285011),
(467756, '0040406', NULL, NULL, 92, NULL, 'BRCT domain', 285011),
(467757, '0040339', NULL, NULL, 97, NULL, 'BRCT domain', 285011),
(467758, '0040338', NULL, NULL, 112, NULL, 'BRCT domain', 285011),
(467759, '0039090', NULL, NULL, 88, NULL, 'BRCT domain', 285011),
(467760, '0035932', NULL, NULL, 96, NULL, 'BRCT domain', 285011),
(467761, '0039669', NULL, NULL, 102, NULL, 'BRCT domain', 285011),
(467762, '0047091', NULL, NULL, 106, NULL, 'BRCT domain', 285011),
(467763, '0039668', NULL, NULL, 109, NULL, 'BRCT domain', 285011),
(467764, '0041605', NULL, NULL, 124, NULL, 'Hypothetical protein MTH393', 285012),
(467765, '0042261', NULL, NULL, 54, NULL, 'Nonstructural protein ns2, Nep, M1-binding domain', 285013),
(467766, '0053464', NULL, NULL, 53, NULL, 'Outer membrane lipoprotein', 285014),
(467767, '0053520', NULL, NULL, 51, NULL, 'Outer membrane lipoprotein', 285014),
(467768, '0053450', NULL, NULL, 52, NULL, 'Outer membrane lipoprotein', 285014),
(467769, '0053408', NULL, NULL, 56, NULL, 'Outer membrane lipoprotein', 285014),
(467770, '0053449', NULL, NULL, 51, NULL, 'Outer membrane lipoprotein', 285014),
(467771, '0053568', NULL, NULL, 56, NULL, 'Outer membrane lipoprotein', 285014),
(467772, '0051286', NULL, NULL, 171, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467773, '0045240', NULL, NULL, 150, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467774, '0053020', NULL, NULL, 190, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467775, '0052979', NULL, NULL, 202, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467776, '0054519', NULL, NULL, 164, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467777, '0039315', NULL, NULL, 164, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467778, '0035953', NULL, NULL, 165, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467779, '0038023', NULL, NULL, 164, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467780, '0046978', NULL, NULL, 169, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467781, '0035390', NULL, NULL, 162, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467782, '0048557', NULL, NULL, 162, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467783, '0035946', NULL, NULL, 162, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467784, '0036439', NULL, NULL, 110, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(467785, '0037521', NULL, NULL, 267, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467786, '0051576', NULL, NULL, 144, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467787, '0044889', NULL, NULL, 86, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467788, '0041771', NULL, NULL, 162, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467789, '0052819', NULL, NULL, 155, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467790, '0044045', NULL, NULL, 140, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467791, '0038051', NULL, NULL, 163, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467792, '0044841', NULL, NULL, 114, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467793, '0047635', NULL, NULL, 163, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467794, '0047085', NULL, NULL, 169, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467795, '0052355', NULL, NULL, 162, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467796, '0042828', NULL, NULL, 298, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467797, '0044809', NULL, NULL, 107, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467798, '0036543', NULL, NULL, 291, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467799, '0051902', NULL, NULL, 166, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467800, '0051148', NULL, NULL, 164, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467801, '0039377', NULL, NULL, 103, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467802, '0036580', NULL, NULL, 164, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467803, '0039896', NULL, NULL, 169, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467804, '0041584', NULL, NULL, 155, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467805, '0038044', NULL, NULL, 118, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467806, '0049076', NULL, NULL, 138, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467807, '0047176', NULL, NULL, 163, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467808, '0050229', NULL, NULL, 163, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467809, '0039601', NULL, NULL, 115, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467810, '0039920', NULL, NULL, 149, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467811, '0053217', NULL, NULL, 219, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467812, '0052327', NULL, NULL, 165, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467813, '0038233', NULL, NULL, 111, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467814, '0041597', NULL, NULL, 224, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467815, '0050939', NULL, NULL, 144, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467816, '0045517', NULL, NULL, 164, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467817, '0036893', NULL, NULL, 190, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467818, '0046003', NULL, NULL, 221, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(467819, '0040869', NULL, NULL, 222, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467820, '0044188', NULL, NULL, 105, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467821, '0042208', NULL, NULL, 109, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', 285015),
(467822, '0047431', NULL, NULL, 267, NULL, 'Acyl-CoA dehydrogenase NM domain-like', 285016),
(467823, '0050327', NULL, NULL, 271, NULL, 'Acyl-CoA dehydrogenase NM domain-like', 285016),
(467824, '0036988', NULL, NULL, 232, NULL, 'Acyl-CoA dehydrogenase NM domain-like', 285016),
(467825, '0039701', NULL, NULL, 231, NULL, 'Acyl-CoA dehydrogenase NM domain-like', 285016),
(467826, '0049822', NULL, NULL, 275, NULL, 'Acyl-CoA dehydrogenase NM domain-like', 285016),
(467827, '0049932', NULL, NULL, 227, NULL, 'Acyl-CoA dehydrogenase NM domain-like', 285016),
(467828, '0046013', NULL, NULL, 232, NULL, 'Acyl-CoA dehydrogenase NM domain-like', 285016),
(467829, '0052370', NULL, NULL, 233, NULL, 'Acyl-CoA dehydrogenase NM domain-like', 285016),
(467830, '0045540', NULL, NULL, 231, NULL, 'Acyl-CoA dehydrogenase NM domain-like', 285016),
(467831, '0049259', NULL, NULL, 231, NULL, 'Acyl-CoA dehydrogenase NM domain-like', 285016),
(467832, '0043102', NULL, NULL, 210, NULL, 'Acyl-CoA dehydrogenase NM domain-like', 285016),
(467833, '0052090', NULL, NULL, 259, NULL, 'Acyl-CoA dehydrogenase NM domain-like', 285016),
(467834, '0049407', NULL, NULL, 236, NULL, 'Acyl-CoA dehydrogenase NM domain-like', 285016),
(467835, '0047447', NULL, NULL, 236, NULL, 'Acyl-CoA dehydrogenase NM domain-like', 285016),
(467836, '0048483', NULL, NULL, 77, NULL, 'Glucose permease domain IIB', 285017),
(467837, '0054246', NULL, NULL, 78, NULL, 'RplX-like', 285018),
(467838, '0049285', NULL, NULL, 57, NULL, 'PsbU/PolX domain-like', 285019),
(467839, '0047630', NULL, NULL, 60, NULL, 'PsbU/PolX domain-like', 285019),
(467840, '0045993', NULL, NULL, 57, NULL, 'PsbU/PolX domain-like', 285019),
(467841, '0047636', NULL, NULL, 58, NULL, 'PsbU/PolX domain-like', 285019),
(467842, '0053721', NULL, NULL, 98, NULL, 'PsbU/PolX domain-like', 285019),
(467843, '0047690', NULL, NULL, 160, NULL, 'Integrin domains', 285020),
(467844, '0047691', NULL, NULL, 139, NULL, 'Integrin domains', 285020),
(467845, '0047692', NULL, NULL, 219, NULL, 'Integrin domains', 285020),
(467846, '0053612', NULL, NULL, 136, NULL, 'Integrin domains', 285020),
(467847, '0051561', NULL, NULL, 136, NULL, 'PF0523-like', 285021),
(467848, '0045362', NULL, NULL, 118, NULL, 'Hemerythrin-like', 285022),
(467849, '0045324', NULL, NULL, 113, NULL, 'Hemerythrin-like', 285022),
(467850, '0047227', NULL, NULL, 113, NULL, 'Hemerythrin-like', 285022),
(467851, '0047304', NULL, NULL, 113, NULL, 'Hemerythrin-like', 285022),
(467852, '0041052', NULL, NULL, 97, NULL, 'SAND domain-like', 285023),
(467853, '0044332', NULL, NULL, 94, NULL, 'SAND domain-like', 285023),
(467854, '0038425', NULL, NULL, 95, NULL, 'SAND domain-like', 285023),
(467855, '0041973', NULL, NULL, 90, NULL, 'SAND domain-like', 285023),
(467856, '0050230', NULL, NULL, 372, NULL, 'Pentein', 285024),
(467857, '0052532', NULL, NULL, 369, NULL, 'Pentein', 285024),
(467858, '0051002', NULL, NULL, 353, NULL, 'Pentein', 285024),
(467859, '0047563', NULL, NULL, 360, NULL, 'Pentein', 285024),
(467860, '0051350', NULL, NULL, 440, NULL, 'Pentein', 285024),
(467861, '0053780', NULL, NULL, 330, NULL, 'Pentein', 285024),
(467862, '0054220', NULL, NULL, 364, NULL, 'Pentein', 285024),
(467863, '0035742', NULL, NULL, 348, NULL, 'Pentein', 285024),
(467864, '0037954', NULL, NULL, 224, NULL, 'Pentein', 285024),
(467865, '0051543', NULL, NULL, 339, NULL, 'Pentein', 285024),
(467866, '0037953', NULL, NULL, 225, NULL, 'Pentein', 285024),
(467867, '0044954', NULL, NULL, 370, NULL, 'Pentein', 285024),
(467868, '0043408', NULL, NULL, 412, NULL, 'Pentein', 285024),
(467869, '0047136', NULL, NULL, 255, NULL, 'Pentein', 285024),
(467870, '0043530', NULL, NULL, 409, NULL, 'Pentein', 285024),
(467871, '0049645', NULL, NULL, 104, NULL, 'DnaK suppressor protein DksA, alpha-hairpin domain', 285025);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(467872, '0040915', NULL, NULL, 97, NULL, 'Microbial ribonucleases', 285026),
(467873, '0037789', NULL, NULL, 106, NULL, 'Microbial ribonucleases', 285026),
(467874, '0034843', NULL, NULL, 108, NULL, 'Microbial ribonucleases', 285026),
(467875, '0038822', NULL, NULL, 104, NULL, 'Microbial ribonucleases', 285026),
(467876, '0046308', NULL, NULL, 150, NULL, 'Microbial ribonucleases', 285026),
(467877, '0042517', NULL, NULL, 96, NULL, 'Microbial ribonucleases', 285026),
(467878, '0049216', NULL, NULL, 105, NULL, 'Microbial ribonucleases', 285026),
(467879, '0038193', NULL, NULL, 109, NULL, 'Microbial ribonucleases', 285026),
(467880, '0043375', NULL, NULL, 114, NULL, 'Microbial ribonucleases', 285026),
(467881, '0045433', NULL, NULL, 108, NULL, 'Microbial ribonucleases', 285026),
(467882, '0049104', NULL, NULL, 136, NULL, 'Microbial ribonucleases', 285026),
(467883, '0043224', NULL, NULL, 96, NULL, 'Microbial ribonucleases', 285026),
(467884, '0045811', NULL, NULL, 149, NULL, 'Microbial ribonucleases', 285026),
(467885, '0047134', NULL, NULL, 132, NULL, 'Phosphohistidine domain', 285027),
(467886, '0051669', NULL, NULL, 125, NULL, 'Phosphohistidine domain', 285027),
(467887, '0047778', NULL, NULL, 133, NULL, 'Phosphohistidine domain', 285027),
(467888, '0050126', NULL, NULL, 135, NULL, 'Phosphohistidine domain', 285027),
(467889, '0051298', NULL, NULL, 51, NULL, 'AbrB/MazE/MraZ-like', 285028),
(467890, '0048250', NULL, NULL, 141, NULL, 'AbrB/MazE/MraZ-like', 285028),
(467891, '0049850', NULL, NULL, 75, NULL, 'AbrB/MazE/MraZ-like', 285028),
(467892, '0053927', NULL, NULL, 54, NULL, 'AbrB/MazE/MraZ-like', 285028),
(467893, '0038399', NULL, NULL, 142, NULL, 'Histone H3 K4-specific methyltransferase SET7/9 N-terminal domain', 285029),
(467894, '0034869', NULL, NULL, 488, NULL, 'Heme-dependent catalase-like', 285030),
(467895, '0043623', NULL, NULL, 474, NULL, 'Heme-dependent catalase-like', 285030),
(467896, '0036848', NULL, NULL, 476, NULL, 'Heme-dependent catalase-like', 285030),
(467897, '0040837', NULL, NULL, 484, NULL, 'Heme-dependent catalase-like', 285030),
(467898, '0036413', NULL, NULL, 497, NULL, 'Heme-dependent catalase-like', 285030),
(467899, '0043021', NULL, NULL, 491, NULL, 'Heme-dependent catalase-like', 285030),
(467900, '0045585', NULL, NULL, 499, NULL, 'Heme-dependent catalase-like', 285030),
(467901, '0035960', NULL, NULL, 571, NULL, 'Heme-dependent catalase-like', 285030),
(467902, '0038517', NULL, NULL, 498, NULL, 'Heme-dependent catalase-like', 285030),
(467903, '0049798', NULL, NULL, 366, NULL, 'Heme-dependent catalase-like', 285030),
(467904, '0053651', NULL, NULL, 125, NULL, 'ATPase domain of HSP90 chaperone/DNA topoisomerase II/histidine kinase', 285031),
(467905, '0051393', NULL, NULL, 148, NULL, 'ATPase domain of HSP90 chaperone/DNA topoisomerase II/histidine kinase', 285031),
(467906, '0048223', NULL, NULL, 219, NULL, 'ATPase domain of HSP90 chaperone/DNA topoisomerase II/histidine kinase', 285031),
(467907, '0053133', NULL, NULL, 213, NULL, 'ATPase domain of HSP90 chaperone/DNA topoisomerase II/histidine kinase', 285031),
(467908, '0042491', NULL, NULL, 239, NULL, 'ATPase domain of HSP90 chaperone/DNA topoisomerase II/histidine kinase', 285031),
(467909, '0046033', NULL, NULL, 161, NULL, 'ATPase domain of HSP90 chaperone/DNA topoisomerase II/histidine kinase', 285031),
(467910, '0052097', NULL, NULL, 161, NULL, 'ATPase domain of HSP90 chaperone/DNA topoisomerase II/histidine kinase', 285031),
(467911, '0043939', NULL, NULL, 225, NULL, 'ATPase domain of HSP90 chaperone/DNA topoisomerase II/histidine kinase', 285031),
(467912, '0035784', NULL, NULL, 213, NULL, 'ATPase domain of HSP90 chaperone/DNA topoisomerase II/histidine kinase', 285031),
(467913, '0035339', NULL, NULL, 185, NULL, 'ATPase domain of HSP90 chaperone/DNA topoisomerase II/histidine kinase', 285031),
(467914, '0037015', NULL, NULL, 219, NULL, 'ATPase domain of HSP90 chaperone/DNA topoisomerase II/histidine kinase', 285031),
(467915, '0038974', NULL, NULL, 146, NULL, 'ATPase domain of HSP90 chaperone/DNA topoisomerase II/histidine kinase', 285031);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(467916, '0039624', NULL, NULL, 190, NULL, 'ATPase domain of HSP90 chaperone/DNA topoisomerase II/histidine kinase', 285031),
(467917, '0040344', NULL, NULL, 141, NULL, 'ATPase domain of HSP90 chaperone/DNA topoisomerase II/histidine kinase', 285031),
(467918, '0038146', NULL, NULL, 193, NULL, 'ATPase domain of HSP90 chaperone/DNA topoisomerase II/histidine kinase', 285031),
(467919, '0038465', NULL, NULL, 203, NULL, 'ATPase domain of HSP90 chaperone/DNA topoisomerase II/histidine kinase', 285031),
(467920, '0035364', NULL, NULL, 218, NULL, 'ATPase domain of HSP90 chaperone/DNA topoisomerase II/histidine kinase', 285031),
(467921, '0043142', NULL, NULL, 156, NULL, 'ATPase domain of HSP90 chaperone/DNA topoisomerase II/histidine kinase', 285031),
(467922, '0043462', NULL, NULL, 168, NULL, 'ATPase domain of HSP90 chaperone/DNA topoisomerase II/histidine kinase', 285031),
(467923, '0043464', NULL, NULL, 213, NULL, 'ATPase domain of HSP90 chaperone/DNA topoisomerase II/histidine kinase', 285031),
(467924, '0040105', NULL, NULL, 212, NULL, 'ATPase domain of HSP90 chaperone/DNA topoisomerase II/histidine kinase', 285031),
(467925, '0044566', NULL, NULL, 211, NULL, 'ATPase domain of HSP90 chaperone/DNA topoisomerase II/histidine kinase', 285031),
(467926, '0043038', NULL, NULL, 266, NULL, 'ATPase domain of HSP90 chaperone/DNA topoisomerase II/histidine kinase', 285031),
(467927, '0054786', NULL, NULL, 94, NULL, 'L21p-like', 285032),
(467928, '0054185', NULL, NULL, 101, NULL, 'L21p-like', 285032),
(467929, '0053072', NULL, NULL, 103, NULL, 'L21p-like', 285032),
(467930, '0048181', NULL, NULL, 81, NULL, 'Probable GTPase Der, C-terminal domain', 285033),
(467931, '0051101', NULL, NULL, 116, NULL, 'PX domain', 285034),
(467932, '0047856', NULL, NULL, 140, NULL, 'PX domain', 285034),
(467933, '0041789', NULL, NULL, 132, NULL, 'PX domain', 285034),
(467934, '0040149', NULL, NULL, 117, NULL, 'PX domain', 285034),
(467935, '0038437', NULL, NULL, 143, NULL, 'PX domain', 285034),
(467936, '0046364', NULL, NULL, 200, NULL, 'Cryptochrome/photolyase, N-terminal domain', 285035),
(467937, '0049782', NULL, NULL, 185, NULL, 'Cryptochrome/photolyase, N-terminal domain', 285035),
(467938, '0047421', NULL, NULL, 170, NULL, 'Cryptochrome/photolyase, N-terminal domain', 285035),
(467939, '0048411', NULL, NULL, 204, NULL, 'Cryptochrome/photolyase, N-terminal domain', 285035),
(467940, '0048654', NULL, NULL, 202, NULL, 'Cryptochrome/photolyase, N-terminal domain', 285035),
(467941, '0053882', NULL, NULL, 247, NULL, 'N-(deoxy)ribosyltransferase-like', 285036),
(467942, '0039181', NULL, NULL, 250, NULL, 'N-(deoxy)ribosyltransferase-like', 285036),
(467943, '0046731', NULL, NULL, 156, NULL, 'N-(deoxy)ribosyltransferase-like', 285036),
(467944, '0043475', NULL, NULL, 167, NULL, 'N-(deoxy)ribosyltransferase-like', 285036),
(467945, '0049517', NULL, NULL, 119, NULL, 'N-(deoxy)ribosyltransferase-like', 285036),
(467946, '0052602', NULL, NULL, 152, NULL, 'N-(deoxy)ribosyltransferase-like', 285036),
(467947, '0040444', NULL, NULL, 250, NULL, 'N-(deoxy)ribosyltransferase-like', 285036),
(467948, '0034922', NULL, NULL, 207, NULL, 'PIN domain-like', 285037),
(467949, '0050398', NULL, NULL, 155, NULL, 'PIN domain-like', 285037),
(467950, '0050100', NULL, NULL, 148, NULL, 'PIN domain-like', 285037),
(467951, '0052662', NULL, NULL, 130, NULL, 'PIN domain-like', 285037),
(467952, '0045055', NULL, NULL, 167, NULL, 'PIN domain-like', 285037),
(467953, '0049265', NULL, NULL, 217, NULL, 'PIN domain-like', 285037),
(467954, '0050096', NULL, NULL, 132, NULL, 'PIN domain-like', 285037),
(467955, '0051236', NULL, NULL, 147, NULL, 'PIN domain-like', 285037),
(467956, '0035546', NULL, NULL, 173, NULL, 'PIN domain-like', 285037),
(467957, '0052984', NULL, NULL, 138, NULL, 'PIN domain-like', 285037),
(467958, '0041679', NULL, NULL, 125, NULL, 'PIN domain-like', 285037),
(467959, '0049616', NULL, NULL, 169, NULL, 'PIN domain-like', 285037),
(467960, '0049935', NULL, NULL, 216, NULL, 'PIN domain-like', 285037),
(467961, '0040885', NULL, NULL, 219, NULL, 'PIN domain-like', 285037);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(467962, '0045876', NULL, NULL, 219, NULL, 'PIN domain-like', 285037),
(467963, '0052652', NULL, NULL, 178, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467964, '0035638', NULL, NULL, 315, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467965, '0049884', NULL, NULL, 155, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467966, '0048674', NULL, NULL, 308, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467967, '0049641', NULL, NULL, 173, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467968, '0046177', NULL, NULL, 163, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467969, '0054076', NULL, NULL, 291, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467970, '0052858', NULL, NULL, 182, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467971, '0048390', NULL, NULL, 227, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467972, '0054438', NULL, NULL, 283, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467973, '0051326', NULL, NULL, 198, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467974, '0051248', NULL, NULL, 152, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467975, '0051600', NULL, NULL, 126, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467976, '0051915', NULL, NULL, 167, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467977, '0048876', NULL, NULL, 140, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467978, '0040636', NULL, NULL, 165, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467979, '0048433', NULL, NULL, 180, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467980, '0049804', NULL, NULL, 189, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467981, '0051375', NULL, NULL, 163, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467982, '0052664', NULL, NULL, 156, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467983, '0048084', NULL, NULL, 181, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467984, '0051377', NULL, NULL, 183, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467985, '0052342', NULL, NULL, 232, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467986, '0051492', NULL, NULL, 150, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467987, '0051252', NULL, NULL, 140, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467988, '0051493', NULL, NULL, 162, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467989, '0053076', NULL, NULL, 160, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467990, '0052704', NULL, NULL, 156, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467991, '0052701', NULL, NULL, 157, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467992, '0051777', NULL, NULL, 118, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467993, '0051336', NULL, NULL, 338, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467994, '0052347', NULL, NULL, 174, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467995, '0043712', NULL, NULL, 297, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467996, '0049338', NULL, NULL, 174, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467997, '0047911', NULL, NULL, 210, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467998, '0045896', NULL, NULL, 181, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(467999, '0046988', NULL, NULL, 170, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468000, '0049219', NULL, NULL, 197, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468001, '0048174', NULL, NULL, 157, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468002, '0049263', NULL, NULL, 201, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468003, '0049262', NULL, NULL, 141, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468004, '0051421', NULL, NULL, 169, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468005, '0051420', NULL, NULL, 152, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468006, '0054056', NULL, NULL, 134, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468007, '0054055', NULL, NULL, 164, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038);
INSERT INTO "PUBLIC"."MODEL" VALUES
(468008, '0050733', NULL, NULL, 157, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468009, '0052713', NULL, NULL, 146, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468010, '0053800', NULL, NULL, 130, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468011, '0047280', NULL, NULL, 157, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468012, '0052874', NULL, NULL, 164, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468013, '0051028', NULL, NULL, 95, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468014, '0051303', NULL, NULL, 164, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468015, '0052754', NULL, NULL, 164, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468016, '0043128', NULL, NULL, 102, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468017, '0051819', NULL, NULL, 196, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468018, '0041464', NULL, NULL, 165, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468019, '0052908', NULL, NULL, 271, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468020, '0052829', NULL, NULL, 137, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468021, '0045389', NULL, NULL, 237, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468022, '0046158', NULL, NULL, 166, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468023, '0045388', NULL, NULL, 185, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468024, '0045986', NULL, NULL, 137, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468025, '0051232', NULL, NULL, 133, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468026, '0049032', NULL, NULL, 160, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468027, '0049031', NULL, NULL, 150, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468028, '0051751', NULL, NULL, 161, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468029, '0048343', NULL, NULL, 164, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468030, '0048344', NULL, NULL, 171, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468031, '0049311', NULL, NULL, 147, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468032, '0050185', NULL, NULL, 165, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468033, '0054065', NULL, NULL, 285, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468034, '0048023', NULL, NULL, 183, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468035, '0051437', NULL, NULL, 151, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468036, '0051830', NULL, NULL, 137, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468037, '0050223', NULL, NULL, 149, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468038, '0052522', NULL, NULL, 153, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468039, '0053259', NULL, NULL, 270, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468040, '0050940', NULL, NULL, 149, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468041, '0046883', NULL, NULL, 273, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468042, '0052040', NULL, NULL, 145, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468043, '0053292', NULL, NULL, 167, NULL, 'Acyl-CoA N-acyltransferases (Nat)', 285038),
(468044, '0035491', NULL, NULL, 69, NULL, 'ISP transmembrane anchor', 285039),
(468045, '0044726', NULL, NULL, 34, NULL, 'ISP transmembrane anchor', 285039),
(468046, '0037294', NULL, NULL, 56, NULL, 'ISP transmembrane anchor', 285039),
(468047, '0035456', NULL, NULL, 69, NULL, 'ISP transmembrane anchor', 285039),
(468048, '0042673', NULL, NULL, 39, NULL, 'ISP transmembrane anchor', 285039),
(468049, '0047383', NULL, NULL, 212, NULL, 'ADP-ribosylation', 285040),
(468050, '0048582', NULL, NULL, 212, NULL, 'ADP-ribosylation', 285040),
(468051, '0049098', NULL, NULL, 201, NULL, 'ADP-ribosylation', 285040),
(468052, '0049322', NULL, NULL, 235, NULL, 'ADP-ribosylation', 285040),
(468053, '0043470', NULL, NULL, 176, NULL, 'ADP-ribosylation', 285040),
(468054, '0044021', NULL, NULL, 224, NULL, 'ADP-ribosylation', 285040),
(468055, '0053230', NULL, NULL, 113, NULL, 'ADP-ribosylation', 285040);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(468056, '0034840', NULL, NULL, 216, NULL, 'ADP-ribosylation', 285040),
(468057, '0051835', NULL, NULL, 194, NULL, 'ADP-ribosylation', 285040),
(468058, '0037313', NULL, NULL, 187, NULL, 'ADP-ribosylation', 285040),
(468059, '0038116', NULL, NULL, 207, NULL, 'ADP-ribosylation', 285040),
(468060, '0038322', NULL, NULL, 223, NULL, 'ADP-ribosylation', 285040),
(468061, '0049927', NULL, NULL, 213, NULL, 'ADP-ribosylation', 285040),
(468062, '0037894', NULL, NULL, 211, NULL, 'ADP-ribosylation', 285040),
(468063, '0042967', NULL, NULL, 205, NULL, 'ADP-ribosylation', 285040),
(468064, '0038240', NULL, NULL, 217, NULL, 'ADP-ribosylation', 285040),
(468065, '0050509', NULL, NULL, 180, NULL, 'ADP-ribosylation', 285040),
(468066, '0040659', NULL, NULL, 227, NULL, 'ADP-ribosylation', 285040),
(468067, '0049029', NULL, NULL, 197, NULL, 'ADP-ribosylation', 285040),
(468068, '0047531', NULL, NULL, 287, NULL, 'ADP-ribosylation', 285040),
(468069, '0046994', NULL, NULL, 204, NULL, 'ADP-ribosylation', 285040),
(468070, '0042433', NULL, NULL, 234, NULL, 'ADP-ribosylation', 285040),
(468071, '0051283', NULL, NULL, 169, NULL, 'At5g01610-like', 285041),
(468072, '0041278', NULL, NULL, 146, NULL, 'Amine oxidase N-terminal region', 285042),
(468073, '0040243', NULL, NULL, 108, NULL, 'Amine oxidase N-terminal region', 285042),
(468074, '0041277', NULL, NULL, 129, NULL, 'Amine oxidase N-terminal region', 285042),
(468075, '0037058', NULL, NULL, 121, NULL, 'Amine oxidase N-terminal region', 285042),
(468076, '0041760', NULL, NULL, 115, NULL, 'Amine oxidase N-terminal region', 285042),
(468077, '0047870', NULL, NULL, 93, NULL, 'Amine oxidase N-terminal region', 285042),
(468078, '0041759', NULL, NULL, 95, NULL, 'Amine oxidase N-terminal region', 285042),
(468079, '0046576', NULL, NULL, 99, NULL, 'Amine oxidase N-terminal region', 285042),
(468080, '0050378', NULL, NULL, 115, NULL, 'Amine oxidase N-terminal region', 285042),
(468081, '0050377', NULL, NULL, 88, NULL, 'Amine oxidase N-terminal region', 285042),
(468082, '0041523', NULL, NULL, 122, NULL, 'DNA-binding protein Tfx', 285043),
(468083, '0051779', NULL, NULL, 346, NULL, 'Pseudo ankyrin repeat-like', 285044),
(468084, '0053396', NULL, NULL, 39, NULL, 'Trimerization domain of TRAF', 285045),
(468085, '0053414', NULL, NULL, 50, NULL, 'Trimerization domain of TRAF', 285045),
(468086, '0048630', NULL, NULL, 126, NULL, 'Flagellar export chaperone FliS', 285046),
(468087, '0044750', NULL, NULL, 102, NULL, 'Flagellar export chaperone FliS', 285046),
(468088, '0047456', NULL, NULL, 97, NULL, 'Multidrug efflux transporter AcrB pore domain; PN1, PN2, PC1 and PC2 subdomains', 285047),
(468089, '0047457', NULL, NULL, 105, NULL, 'Multidrug efflux transporter AcrB pore domain; PN1, PN2, PC1 and PC2 subdomains', 285047),
(468090, '0047458', NULL, NULL, 107, NULL, 'Multidrug efflux transporter AcrB pore domain; PN1, PN2, PC1 and PC2 subdomains', 285047),
(468091, '0047459', NULL, NULL, 99, NULL, 'Multidrug efflux transporter AcrB pore domain; PN1, PN2, PC1 and PC2 subdomains', 285047),
(468092, '0034914', NULL, NULL, 295, NULL, 'PP2C-like', 285048),
(468093, '0049733', NULL, NULL, 235, NULL, 'PP2C-like', 285048),
(468094, '0053582', NULL, NULL, 131, NULL, 'Hemocyanin, N-terminal domain', 285049),
(468095, '0040537', NULL, NULL, 108, NULL, 'Hemocyanin, N-terminal domain', 285049),
(468096, '0035050', NULL, NULL, 245, NULL, 'Phospholipase C/P1 nuclease', 285050),
(468097, '0040089', NULL, NULL, 249, NULL, 'Phospholipase C/P1 nuclease', 285050),
(468098, '0035890', NULL, NULL, 249, NULL, 'Phospholipase C/P1 nuclease', 285050),
(468099, '0045784', NULL, NULL, 264, NULL, 'Phospholipase C/P1 nuclease', 285050),
(468100, '0041911', NULL, NULL, 249, NULL, 'Phospholipase C/P1 nuclease', 285050),
(468101, '0048020', NULL, NULL, 98, NULL, 'Fungal elicitin', 285051),
(468102, '0040519', NULL, NULL, 98, NULL, 'Fungal elicitin', 285051),
(468103, '0049371', NULL, NULL, 83, NULL, 'DNA polymerase III theta subunit-like', 285052),
(468104, '0036602', NULL, NULL, 76, NULL, 'DNA polymerase III theta subunit-like', 285052);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(468105, '0048131', NULL, NULL, 130, NULL, 'Calponin-homology domain, CH-domain', 285053),
(468106, '0035604', NULL, NULL, 108, NULL, 'Calponin-homology domain, CH-domain', 285053),
(468107, '0043370', NULL, NULL, 505, NULL, 'Calponin-homology domain, CH-domain', 285053),
(468108, '0044393', NULL, NULL, 144, NULL, 'Calponin-homology domain, CH-domain', 285053),
(468109, '0048132', NULL, NULL, 113, NULL, 'Calponin-homology domain, CH-domain', 285053),
(468110, '0035125', NULL, NULL, 116, NULL, 'Calponin-homology domain, CH-domain', 285053),
(468111, '0035124', NULL, NULL, 131, NULL, 'Calponin-homology domain, CH-domain', 285053),
(468112, '0050621', NULL, NULL, 124, NULL, 'Calponin-homology domain, CH-domain', 285053),
(468113, '0042512', NULL, NULL, 500, NULL, 'Calponin-homology domain, CH-domain', 285053),
(468114, '0038432', NULL, NULL, 108, NULL, 'Calponin-homology domain, CH-domain', 285053),
(468115, '0046419', NULL, NULL, 111, NULL, 'Calponin-homology domain, CH-domain', 285053),
(468116, '0035551', NULL, NULL, 108, NULL, 'Calponin-homology domain, CH-domain', 285053),
(468117, '0048721', NULL, NULL, 130, NULL, 'Calponin-homology domain, CH-domain', 285053),
(468118, '0046420', NULL, NULL, 127, NULL, 'Calponin-homology domain, CH-domain', 285053),
(468119, '0048700', NULL, NULL, 159, NULL, 'Calponin-homology domain, CH-domain', 285053),
(468120, '0048913', NULL, NULL, 121, NULL, 'Calponin-homology domain, CH-domain', 285053),
(468121, '0044622', NULL, NULL, 115, NULL, 'Calponin-homology domain, CH-domain', 285053),
(468122, '0042419', NULL, NULL, 156, NULL, 'Peridinin-chlorophyll protein', 285054),
(468123, '0042420', NULL, NULL, 156, NULL, 'Peridinin-chlorophyll protein', 285054),
(468124, '0040728', NULL, NULL, 651, NULL, 'L-A virus major coat protein', 285055),
(468125, '0052935', NULL, NULL, 418, NULL, 'IlvD/EDD N-terminal domain-like', 285056),
(468126, '0039511', NULL, NULL, 281, NULL, 'SPOC domain-like', 285057),
(468127, '0042053', NULL, NULL, 170, NULL, 'SPOC domain-like', 285057),
(468128, '0039513', NULL, NULL, 304, NULL, 'SPOC domain-like', 285057),
(468129, '0054080', NULL, NULL, 129, NULL, 'MG296-like', 285058),
(468130, '0049750', NULL, NULL, 112, NULL, 'Heat shock protein 70kD (HSP70), C-terminal subdomain', 285059),
(468131, '0036477', NULL, NULL, 97, NULL, 'Heat shock protein 70kD (HSP70), C-terminal subdomain', 285059),
(468132, '0044279', NULL, NULL, 84, NULL, 'Heat shock protein 70kD (HSP70), C-terminal subdomain', 285059),
(468133, '0041671', NULL, NULL, 149, NULL, 'Hypothetical protein TM0875', 285060),
(468134, '0050582', NULL, NULL, 117, NULL, 'DNA-binding pseudobarrel domain', 285061),
(468135, '0048310', NULL, NULL, 175, NULL, 'DNA-binding pseudobarrel domain', 285061),
(468136, '0051290', NULL, NULL, 102, NULL, 'DNA-binding pseudobarrel domain', 285061),
(468137, '0053587', NULL, NULL, 69, NULL, 'Interleukin 8-like chemokines', 285062),
(468138, '0052499', NULL, NULL, 74, NULL, 'Interleukin 8-like chemokines', 285062),
(468139, '0038729', NULL, NULL, 69, NULL, 'Interleukin 8-like chemokines', 285062),
(468140, '0036523', NULL, NULL, 72, NULL, 'Interleukin 8-like chemokines', 285062),
(468141, '0035356', NULL, NULL, 69, NULL, 'Interleukin 8-like chemokines', 285062),
(468142, '0038505', NULL, NULL, 70, NULL, 'Interleukin 8-like chemokines', 285062),
(468143, '0035332', NULL, NULL, 67, NULL, 'Interleukin 8-like chemokines', 285062),
(468144, '0035635', NULL, NULL, 76, NULL, 'Interleukin 8-like chemokines', 285062),
(468145, '0037458', NULL, NULL, 65, NULL, 'Interleukin 8-like chemokines', 285062),
(468146, '0042732', NULL, NULL, 71, NULL, 'Interleukin 8-like chemokines', 285062),
(468147, '0038002', NULL, NULL, 77, NULL, 'Interleukin 8-like chemokines', 285062),
(468148, '0036062', NULL, NULL, 68, NULL, 'Interleukin 8-like chemokines', 285062),
(468149, '0039434', NULL, NULL, 93, NULL, 'Interleukin 8-like chemokines', 285062),
(468150, '0045309', NULL, NULL, 66, NULL, 'Interleukin 8-like chemokines', 285062),
(468151, '0043321', NULL, NULL, 72, NULL, 'Interleukin 8-like chemokines', 285062);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(468152, '0041524', NULL, NULL, 67, NULL, 'Interleukin 8-like chemokines', 285062),
(468153, '0046734', NULL, NULL, 81, NULL, 'Interleukin 8-like chemokines', 285062),
(468154, '0037908', NULL, NULL, 71, NULL, 'Interleukin 8-like chemokines', 285062),
(468155, '0034819', NULL, NULL, 67, NULL, 'Interleukin 8-like chemokines', 285062),
(468156, '0040916', NULL, NULL, 73, NULL, 'Interleukin 8-like chemokines', 285062),
(468157, '0043273', NULL, NULL, 73, NULL, 'Interleukin 8-like chemokines', 285062),
(468158, '0037022', NULL, NULL, 73, NULL, 'Interleukin 8-like chemokines', 285062),
(468159, '0037165', NULL, NULL, 76, NULL, 'Interleukin 8-like chemokines', 285062),
(468160, '0042369', NULL, NULL, 63, NULL, 'Interleukin 8-like chemokines', 285062),
(468161, '0042289', NULL, NULL, 68, NULL, 'Interleukin 8-like chemokines', 285062),
(468162, '0035320', NULL, NULL, 77, NULL, 'Interleukin 8-like chemokines', 285062),
(468163, '0037065', NULL, NULL, 74, NULL, 'Interleukin 8-like chemokines', 285062),
(468164, '0041737', NULL, NULL, 75, NULL, 'Interleukin 8-like chemokines', 285062),
(468165, '0040844', NULL, NULL, 61, NULL, 'Interleukin 8-like chemokines', 285062),
(468166, '0040943', NULL, NULL, 73, NULL, 'Interleukin 8-like chemokines', 285062),
(468167, '0042883', NULL, NULL, 69, NULL, 'Interleukin 8-like chemokines', 285062),
(468168, '0051012', NULL, NULL, 91, NULL, 'Type III secretion system domain', 285063),
(468169, '0051003', NULL, NULL, 197, NULL, 'Type III secretion system domain', 285063),
(468170, '0051469', NULL, NULL, 104, NULL, 'Type III secretion system domain', 285063),
(468171, '0042463', NULL, NULL, 91, NULL, 'Hypothetical protein MTH677', 285064),
(468172, '0046281', NULL, NULL, 323, NULL, 'Protein prenylyltransferase', 285065),
(468173, '0046296', NULL, NULL, 335, NULL, 'Protein prenylyltransferase', 285065),
(468174, '0036951', NULL, NULL, 90, NULL, 'Moesin tail domain', 285066),
(468175, '0042145', NULL, NULL, 183, NULL, 'Homo-oligomeric flavin-containing Cys decarboxylases, HFCD', 285067),
(468176, '0037949', NULL, NULL, 174, NULL, 'Homo-oligomeric flavin-containing Cys decarboxylases, HFCD', 285067),
(468177, '0049358', NULL, NULL, 186, NULL, 'Homo-oligomeric flavin-containing Cys decarboxylases, HFCD', 285067),
(468178, '0043058', NULL, NULL, 181, NULL, 'Homo-oligomeric flavin-containing Cys decarboxylases, HFCD', 285067),
(468179, '0036713', NULL, NULL, 185, NULL, 'Homo-oligomeric flavin-containing Cys decarboxylases, HFCD', 285067),
(468180, '0054606', NULL, NULL, 204, NULL, 'Cation efflux protein transmembrane domain-like', 285068),
(468181, '0036926', NULL, NULL, 265, NULL, '(Trans)glycosidases', 285069),
(468182, '0050431', NULL, NULL, 462, NULL, '(Trans)glycosidases', 285069),
(468183, '0049162', NULL, NULL, 370, NULL, '(Trans)glycosidases', 285069),
(468184, '0048992', NULL, NULL, 344, NULL, '(Trans)glycosidases', 285069),
(468185, '0051481', NULL, NULL, 403, NULL, '(Trans)glycosidases', 285069),
(468186, '0052173', NULL, NULL, 274, NULL, '(Trans)glycosidases', 285069),
(468187, '0046176', NULL, NULL, 345, NULL, '(Trans)glycosidases', 285069),
(468188, '0053948', NULL, NULL, 362, NULL, '(Trans)glycosidases', 285069),
(468189, '0035310', NULL, NULL, 500, NULL, '(Trans)glycosidases', 285069),
(468190, '0045806', NULL, NULL, 306, NULL, '(Trans)glycosidases', 285069),
(468191, '0047545', NULL, NULL, 378, NULL, '(Trans)glycosidases', 285069),
(468192, '0048117', NULL, NULL, 396, NULL, '(Trans)glycosidases', 285069),
(468193, '0047025', NULL, NULL, 489, NULL, '(Trans)glycosidases', 285069),
(468194, '0047542', NULL, NULL, 376, NULL, '(Trans)glycosidases', 285069),
(468195, '0048598', NULL, NULL, 274, NULL, '(Trans)glycosidases', 285069),
(468196, '0049842', NULL, NULL, 273, NULL, '(Trans)glycosidases', 285069),
(468197, '0046455', NULL, NULL, 393, NULL, '(Trans)glycosidases', 285069),
(468198, '0046336', NULL, NULL, 403, NULL, '(Trans)glycosidases', 285069),
(468199, '0043588', NULL, NULL, 213, NULL, '(Trans)glycosidases', 285069),
(468200, '0049054', NULL, NULL, 367, NULL, '(Trans)glycosidases', 285069);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(468201, '0050167', NULL, NULL, 423, NULL, '(Trans)glycosidases', 285069),
(468202, '0044281', NULL, NULL, 390, NULL, '(Trans)glycosidases', 285069),
(468203, '0052585', NULL, NULL, 338, NULL, '(Trans)glycosidases', 285069),
(468204, '0046186', NULL, NULL, 283, NULL, '(Trans)glycosidases', 285069),
(468205, '0051370', NULL, NULL, 297, NULL, '(Trans)glycosidases', 285069),
(468206, '0046463', NULL, NULL, 492, NULL, '(Trans)glycosidases', 285069),
(468207, '0048242', NULL, NULL, 361, NULL, '(Trans)glycosidases', 285069),
(468208, '0050447', NULL, NULL, 490, NULL, '(Trans)glycosidases', 285069),
(468209, '0049050', NULL, NULL, 481, NULL, '(Trans)glycosidases', 285069),
(468210, '0046505', NULL, NULL, 382, NULL, '(Trans)glycosidases', 285069),
(468211, '0036198', NULL, NULL, 402, NULL, '(Trans)glycosidases', 285069),
(468212, '0046102', NULL, NULL, 490, NULL, '(Trans)glycosidases', 285069),
(468213, '0048402', NULL, NULL, 277, NULL, '(Trans)glycosidases', 285069),
(468214, '0049976', NULL, NULL, 350, NULL, '(Trans)glycosidases', 285069),
(468215, '0052061', NULL, NULL, 366, NULL, '(Trans)glycosidases', 285069),
(468216, '0048920', NULL, NULL, 443, NULL, '(Trans)glycosidases', 285069),
(468217, '0047795', NULL, NULL, 375, NULL, '(Trans)glycosidases', 285069),
(468218, '0046229', NULL, NULL, 500, NULL, '(Trans)glycosidases', 285069),
(468219, '0047436', NULL, NULL, 348, NULL, '(Trans)glycosidases', 285069),
(468220, '0040522', NULL, NULL, 294, NULL, '(Trans)glycosidases', 285069),
(468221, '0048404', NULL, NULL, 353, NULL, '(Trans)glycosidases', 285069),
(468222, '0040488', NULL, NULL, 298, NULL, '(Trans)glycosidases', 285069),
(468223, '0049977', NULL, NULL, 387, NULL, '(Trans)glycosidases', 285069),
(468224, '0047041', NULL, NULL, 561, NULL, '(Trans)glycosidases', 285069),
(468225, '0053049', NULL, NULL, 273, NULL, '(Trans)glycosidases', 285069),
(468226, '0046470', NULL, NULL, 358, NULL, '(Trans)glycosidases', 285069),
(468227, '0051146', NULL, NULL, 303, NULL, '(Trans)glycosidases', 285069),
(468228, '0048530', NULL, NULL, 391, NULL, '(Trans)glycosidases', 285069),
(468229, '0046471', NULL, NULL, 499, NULL, '(Trans)glycosidases', 285069),
(468230, '0052352', NULL, NULL, 312, NULL, '(Trans)glycosidases', 285069),
(468231, '0046595', NULL, NULL, 282, NULL, '(Trans)glycosidases', 285069),
(468232, '0052913', NULL, NULL, 394, NULL, '(Trans)glycosidases', 285069),
(468233, '0051664', NULL, NULL, 348, NULL, '(Trans)glycosidases', 285069),
(468234, '0039218', NULL, NULL, 653, NULL, '(Trans)glycosidases', 285069),
(468235, '0050215', NULL, NULL, 325, NULL, '(Trans)glycosidases', 285069),
(468236, '0043920', NULL, NULL, 301, NULL, '(Trans)glycosidases', 285069),
(468237, '0038123', NULL, NULL, 572, NULL, '(Trans)glycosidases', 285069),
(468238, '0045947', NULL, NULL, 475, NULL, '(Trans)glycosidases', 285069),
(468239, '0045828', NULL, NULL, 346, NULL, '(Trans)glycosidases', 285069),
(468240, '0049908', NULL, NULL, 346, NULL, '(Trans)glycosidases', 285069),
(468241, '0046993', NULL, NULL, 306, NULL, '(Trans)glycosidases', 285069),
(468242, '0049502', NULL, NULL, 314, NULL, '(Trans)glycosidases', 285069),
(468243, '0049744', NULL, NULL, 485, NULL, '(Trans)glycosidases', 285069),
(468244, '0049986', NULL, NULL, 364, NULL, '(Trans)glycosidases', 285069),
(468245, '0049622', NULL, NULL, 354, NULL, '(Trans)glycosidases', 285069),
(468246, '0046755', NULL, NULL, 321, NULL, '(Trans)glycosidases', 285069),
(468247, '0048418', NULL, NULL, 302, NULL, '(Trans)glycosidases', 285069),
(468248, '0052125', NULL, NULL, 370, NULL, '(Trans)glycosidases', 285069),
(468249, '0046122', NULL, NULL, 340, NULL, '(Trans)glycosidases', 285069),
(468250, '0037707', NULL, NULL, 334, NULL, '(Trans)glycosidases', 285069),
(468251, '0044581', NULL, NULL, 484, NULL, '(Trans)glycosidases', 285069),
(468252, '0051153', NULL, NULL, 320, NULL, '(Trans)glycosidases', 285069),
(468253, '0052086', NULL, NULL, 350, NULL, '(Trans)glycosidases', 285069),
(468254, '0051312', NULL, NULL, 344, NULL, '(Trans)glycosidases', 285069),
(468255, '0045956', NULL, NULL, 302, NULL, '(Trans)glycosidases', 285069);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(468256, '0046528', NULL, NULL, 359, NULL, '(Trans)glycosidases', 285069),
(468257, '0046924', NULL, NULL, 554, NULL, '(Trans)glycosidases', 285069),
(468258, '0047578', NULL, NULL, 217, NULL, '(Trans)glycosidases', 285069),
(468259, '0046643', NULL, NULL, 388, NULL, '(Trans)glycosidases', 285069),
(468260, '0040789', NULL, NULL, 478, NULL, '(Trans)glycosidases', 285069),
(468261, '0040700', NULL, NULL, 391, NULL, '(Trans)glycosidases', 285069),
(468262, '0046523', NULL, NULL, 380, NULL, '(Trans)glycosidases', 285069),
(468263, '0047217', NULL, NULL, 356, NULL, '(Trans)glycosidases', 285069),
(468264, '0044469', NULL, NULL, 479, NULL, '(Trans)glycosidases', 285069),
(468265, '0050870', NULL, NULL, 244, NULL, '(Trans)glycosidases', 285069),
(468266, '0052376', NULL, NULL, 394, NULL, '(Trans)glycosidases', 285069),
(468267, '0049124', NULL, NULL, 434, NULL, '(Trans)glycosidases', 285069),
(468268, '0052495', NULL, NULL, 285, NULL, '(Trans)glycosidases', 285069),
(468269, '0046891', NULL, NULL, 358, NULL, '(Trans)glycosidases', 285069),
(468270, '0052139', NULL, NULL, 317, NULL, '(Trans)glycosidases', 285069),
(468271, '0048959', NULL, NULL, 407, NULL, '(Trans)glycosidases', 285069),
(468272, '0046256', NULL, NULL, 331, NULL, '(Trans)glycosidases', 285069),
(468273, '0048314', NULL, NULL, 289, NULL, '(Trans)glycosidases', 285069),
(468274, '0046497', NULL, NULL, 303, NULL, '(Trans)glycosidases', 285069),
(468275, '0050071', NULL, NULL, 316, NULL, '(Trans)glycosidases', 285069),
(468276, '0045960', NULL, NULL, 447, NULL, '(Trans)glycosidases', 285069),
(468277, '0046139', NULL, NULL, 406, NULL, '(Trans)glycosidases', 285069),
(468278, '0045965', NULL, NULL, 304, NULL, '(Trans)glycosidases', 285069),
(468279, '0047591', NULL, NULL, 432, NULL, '(Trans)glycosidases', 285069),
(468280, '0049099', NULL, NULL, 292, NULL, '(Trans)glycosidases', 285069),
(468281, '0050760', NULL, NULL, 409, NULL, '(Trans)glycosidases', 285069),
(468282, '0049894', NULL, NULL, 426, NULL, '(Trans)glycosidases', 285069),
(468283, '0046023', NULL, NULL, 382, NULL, '(Trans)glycosidases', 285069),
(468284, '0046782', NULL, NULL, 312, NULL, '(Trans)glycosidases', 285069),
(468285, '0047198', NULL, NULL, 350, NULL, '(Trans)glycosidases', 285069),
(468286, '0050404', NULL, NULL, 347, NULL, '(Trans)glycosidases', 285069),
(468287, '0051737', NULL, NULL, 285, NULL, '(Trans)glycosidases', 285069),
(468288, '0050004', NULL, NULL, 410, NULL, '(Trans)glycosidases', 285069),
(468289, '0051733', NULL, NULL, 381, NULL, '(Trans)glycosidases', 285069),
(468290, '0051975', NULL, NULL, 420, NULL, '(Trans)glycosidases', 285069),
(468291, '0047190', NULL, NULL, 375, NULL, '(Trans)glycosidases', 285069),
(468292, '0050643', NULL, NULL, 297, NULL, '(Trans)glycosidases', 285069),
(468293, '0042224', NULL, NULL, 406, NULL, '(Trans)glycosidases', 285069),
(468294, '0046948', NULL, NULL, 354, NULL, '(Trans)glycosidases', 285069),
(468295, '0038179', NULL, NULL, 464, NULL, '(Trans)glycosidases', 285069),
(468296, '0047236', NULL, NULL, 347, NULL, '(Trans)glycosidases', 285069),
(468297, '0046266', NULL, NULL, 406, NULL, '(Trans)glycosidases', 285069),
(468298, '0047754', NULL, NULL, 302, NULL, '(Trans)glycosidases', 285069),
(468299, '0047875', NULL, NULL, 293, NULL, '(Trans)glycosidases', 285069),
(468300, '0048565', NULL, NULL, 354, NULL, '(Trans)glycosidases', 285069),
(468301, '0047637', NULL, NULL, 328, NULL, '(Trans)glycosidases', 285069),
(468302, '0047117', NULL, NULL, 422, NULL, '(Trans)glycosidases', 285069),
(468303, '0048295', NULL, NULL, 330, NULL, '(Trans)glycosidases', 285069),
(468304, '0053367', NULL, NULL, 300, NULL, '(Trans)glycosidases', 285069),
(468305, '0047122', NULL, NULL, 408, NULL, '(Trans)glycosidases', 285069),
(468306, '0038607', NULL, NULL, 332, NULL, '(Trans)glycosidases', 285069),
(468307, '0046152', NULL, NULL, 406, NULL, '(Trans)glycosidases', 285069),
(468308, '0038608', NULL, NULL, 295, NULL, '(Trans)glycosidases', 285069),
(468309, '0050130', NULL, NULL, 324, NULL, '(Trans)glycosidases', 285069),
(468310, '0038605', NULL, NULL, 332, NULL, '(Trans)glycosidases', 285069);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(468311, '0050774', NULL, NULL, 523, NULL, '(Trans)glycosidases', 285069),
(468312, '0054219', NULL, NULL, 348, NULL, '(Trans)glycosidases', 285069),
(468313, '0050412', NULL, NULL, 334, NULL, '(Trans)glycosidases', 285069),
(468314, '0042235', NULL, NULL, 468, NULL, '(Trans)glycosidases', 285069),
(468315, '0042911', NULL, NULL, 449, NULL, '(Trans)glycosidases', 285069),
(468316, '0053918', NULL, NULL, 563, NULL, '(Trans)glycosidases', 285069),
(468317, '0049424', NULL, NULL, 382, NULL, '(Trans)glycosidases', 285069),
(468318, '0047246', NULL, NULL, 393, NULL, '(Trans)glycosidases', 285069),
(468319, '0049705', NULL, NULL, 301, NULL, '(Trans)glycosidases', 285069),
(468320, '0046556', NULL, NULL, 291, NULL, '(Trans)glycosidases', 285069),
(468321, '0046559', NULL, NULL, 400, NULL, '(Trans)glycosidases', 285069),
(468322, '0047766', NULL, NULL, 537, NULL, '(Trans)glycosidases', 285069),
(468323, '0052168', NULL, NULL, 310, NULL, '(Trans)glycosidases', 285069),
(468324, '0047094', NULL, NULL, 189, NULL, '(Trans)glycosidases', 285069),
(468325, '0047491', NULL, NULL, 382, NULL, '(Trans)glycosidases', 285069),
(468326, '0054740', NULL, NULL, 339, NULL, '(Trans)glycosidases', 285069),
(468327, '0047099', NULL, NULL, 305, NULL, '(Trans)glycosidases', 285069),
(468328, '0036899', NULL, NULL, 358, NULL, '(Trans)glycosidases', 285069),
(468329, '0050028', NULL, NULL, 302, NULL, '(Trans)glycosidases', 285069),
(468330, '0052962', NULL, NULL, 381, NULL, '(Trans)glycosidases', 285069),
(468331, '0036535', NULL, NULL, 292, NULL, '(Trans)glycosidases', 285069),
(468332, '0046607', NULL, NULL, 394, NULL, '(Trans)glycosidases', 285069),
(468333, '0037464', NULL, NULL, 498, NULL, '(Trans)glycosidases', 285069),
(468334, '0045913', NULL, NULL, 417, NULL, '(Trans)glycosidases', 285069),
(468335, '0041792', NULL, NULL, 443, NULL, '(Trans)glycosidases', 285069),
(468336, '0047897', NULL, NULL, 393, NULL, '(Trans)glycosidases', 285069),
(468337, '0049678', NULL, NULL, 330, NULL, '(Trans)glycosidases', 285069),
(468338, '0045994', NULL, NULL, 302, NULL, '(Trans)glycosidases', 285069),
(468339, '0049716', NULL, NULL, 293, NULL, '(Trans)glycosidases', 285069),
(468340, '0046963', NULL, NULL, 357, NULL, '(Trans)glycosidases', 285069),
(468341, '0049836', NULL, NULL, 344, NULL, '(Trans)glycosidases', 285069),
(468342, '0054571', NULL, NULL, 176, NULL, 'Sec63 N-terminal domain-like', 285070),
(468343, '0054469', NULL, NULL, 198, NULL, 'Sec63 N-terminal domain-like', 285070),
(468344, '0039253', NULL, NULL, 184, NULL, 'B12-dependent dehydatase associated subunit', 285071),
(468345, '0052361', NULL, NULL, 108, NULL, 'B12-dependent dehydatase associated subunit', 285071),
(468346, '0048324', NULL, NULL, 113, NULL, 'B12-dependent dehydatase associated subunit', 285071),
(468347, '0046534', NULL, NULL, 178, NULL, 'B12-dependent dehydatase associated subunit', 285071),
(468348, '0043580', NULL, NULL, 118, NULL, 'Hypothetical protein YfhH', 285072),
(468349, '0054830', NULL, NULL, 184, NULL, 'post-AAA+ oligomerization domain-like', 285073),
(468350, '0034889', NULL, NULL, 123, NULL, 'post-AAA+ oligomerization domain-like', 285073),
(468351, '0054660', NULL, NULL, 186, NULL, 'post-AAA+ oligomerization domain-like', 285073),
(468352, '0039710', NULL, NULL, 126, NULL, 'post-AAA+ oligomerization domain-like', 285073),
(468353, '0039712', NULL, NULL, 127, NULL, 'post-AAA+ oligomerization domain-like', 285073),
(468354, '0052930', NULL, NULL, 98, NULL, 'post-AAA+ oligomerization domain-like', 285073),
(468355, '0039135', NULL, NULL, 95, NULL, 'post-AAA+ oligomerization domain-like', 285073),
(468356, '0043789', NULL, NULL, 146, NULL, 'post-AAA+ oligomerization domain-like', 285073),
(468357, '0054907', NULL, NULL, 163, NULL, 'post-AAA+ oligomerization domain-like', 285073),
(468358, '0043791', NULL, NULL, 93, NULL, 'post-AAA+ oligomerization domain-like', 285073),
(468359, '0043793', NULL, NULL, 95, NULL, 'post-AAA+ oligomerization domain-like', 285073),
(468360, '0043795', NULL, NULL, 91, NULL, 'post-AAA+ oligomerization domain-like', 285073);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(468361, '0043797', NULL, NULL, 99, NULL, 'post-AAA+ oligomerization domain-like', 285073),
(468362, '0053962', NULL, NULL, 61, NULL, 'Efb C-domain-like', 285074),
(468363, '0054285', NULL, NULL, 58, NULL, 'Efb C-domain-like', 285074),
(468364, '0054031', NULL, NULL, 85, NULL, 'NE1680-like', 285075),
(468365, '0042132', NULL, NULL, 299, NULL, 'Baculovirus p35 protein', 285076),
(468366, '0050767', NULL, NULL, 100, NULL, 'RGC domain-like', 285077),
(468367, '0045636', NULL, NULL, 52, NULL, 'Insulin-like', 285078),
(468368, '0034928', NULL, NULL, 51, NULL, 'Insulin-like', 285078),
(468369, '0036101', NULL, NULL, 52, NULL, 'Insulin-like', 285078),
(468370, '0040150', NULL, NULL, 52, NULL, 'Insulin-like', 285078),
(468371, '0036960', NULL, NULL, 60, NULL, 'Insulin-like', 285078),
(468372, '0038727', NULL, NULL, 51, NULL, 'Insulin-like', 285078),
(468373, '0039009', NULL, NULL, 67, NULL, 'Insulin-like', 285078),
(468374, '0049626', NULL, NULL, 52, NULL, 'Insulin-like', 285078),
(468375, '0035644', NULL, NULL, 49, NULL, 'Insulin-like', 285078),
(468376, '0045117', NULL, NULL, 53, NULL, 'Insulin-like', 285078),
(468377, '0045535', NULL, NULL, 83, NULL, 'Insulin-like', 285078),
(468378, '0047997', NULL, NULL, 131, NULL, 'Antigen MPT63/MPB63 (immunoprotective extracellular protein)', 285079),
(468379, '0050300', NULL, NULL, 130, NULL, 'TM1622-like', 285080),
(468380, '0046391', NULL, NULL, 323, NULL, 'Clavaminate synthase-like', 285081),
(468381, '0052278', NULL, NULL, 417, NULL, 'Clavaminate synthase-like', 285081),
(468382, '0054820', NULL, NULL, 109, NULL, 'Clavaminate synthase-like', 285081),
(468383, '0051173', NULL, NULL, 327, NULL, 'Clavaminate synthase-like', 285081),
(468384, '0050415', NULL, NULL, 307, NULL, 'Clavaminate synthase-like', 285081),
(468385, '0054938', NULL, NULL, 96, NULL, 'Clavaminate synthase-like', 285081),
(468386, '0047081', NULL, NULL, 279, NULL, 'Clavaminate synthase-like', 285081),
(468387, '0051687', NULL, NULL, 296, NULL, 'Clavaminate synthase-like', 285081),
(468388, '0052657', NULL, NULL, 200, NULL, 'Clavaminate synthase-like', 285081),
(468389, '0050303', NULL, NULL, 319, NULL, 'Clavaminate synthase-like', 285081),
(468390, '0052654', NULL, NULL, 308, NULL, 'Clavaminate synthase-like', 285081),
(468391, '0053127', NULL, NULL, 210, NULL, 'Clavaminate synthase-like', 285081),
(468392, '0041871', NULL, NULL, 288, NULL, 'Clavaminate synthase-like', 285081),
(468393, '0047027', NULL, NULL, 349, NULL, 'Clavaminate synthase-like', 285081),
(468394, '0047105', NULL, NULL, 335, NULL, 'Clavaminate synthase-like', 285081),
(468395, '0047666', NULL, NULL, 311, NULL, 'Clavaminate synthase-like', 285081),
(468396, '0046302', NULL, NULL, 311, NULL, 'Clavaminate synthase-like', 285081),
(468397, '0046468', NULL, NULL, 290, NULL, 'Clavaminate synthase-like', 285081),
(468398, '0041601', NULL, NULL, 271, NULL, 'Clavaminate synthase-like', 285081),
(468399, '0048968', NULL, NULL, 327, NULL, 'Clavaminate synthase-like', 285081),
(468400, '0047646', NULL, NULL, 155, NULL, 'Clavaminate synthase-like', 285081),
(468401, '0038400', NULL, NULL, 75, NULL, 'Sigma2 domain of RNA polymerase sigma factors', 285082),
(468402, '0043329', NULL, NULL, 87, NULL, 'Sigma2 domain of RNA polymerase sigma factors', 285082),
(468403, '0047881', NULL, NULL, 180, NULL, 'Sigma2 domain of RNA polymerase sigma factors', 285082),
(468404, '0039240', NULL, NULL, 184, NULL, 'Sigma2 domain of RNA polymerase sigma factors', 285082),
(468405, '0041988', NULL, NULL, 113, NULL, 'Sigma2 domain of RNA polymerase sigma factors', 285082),
(468406, '0049406', NULL, NULL, 334, NULL, 'Sigma2 domain of RNA polymerase sigma factors', 285082),
(468407, '0037374', NULL, NULL, 118, NULL, 'Rap30/74 interaction domains', 285083),
(468408, '0037375', NULL, NULL, 162, NULL, 'Rap30/74 interaction domains', 285083),
(468409, '0054506', NULL, NULL, 84, NULL, 'PH0987 N-terminal domain-like', 285084),
(468410, '0050314', NULL, NULL, 111, NULL, 'Phosphoprotein M1, C-terminal domain', 285085),
(468411, '0043235', NULL, NULL, 422, NULL, 'Preprotein translocase SecY subunit', 285086);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(468412, '0045548', NULL, NULL, 319, NULL, 'Phosphofructokinase', 285087),
(468413, '0042288', NULL, NULL, 320, NULL, 'Phosphofructokinase', 285087),
(468414, '0047912', NULL, NULL, 550, NULL, 'Phosphofructokinase', 285087),
(468415, '0041581', NULL, NULL, 51, NULL, 'post-HMGL domain-like', 285088),
(468416, '0049233', NULL, NULL, 168, NULL, 'post-HMGL domain-like', 285088),
(468417, '0049452', NULL, NULL, 55, NULL, 'post-HMGL domain-like', 285088),
(468418, '0042655', NULL, NULL, 108, NULL, 'GDNF receptor-like', 285089),
(468419, '0051546', NULL, NULL, 129, NULL, 'ORC1-binding domain', 285090),
(468420, '0053114', NULL, NULL, 148, NULL, 'Cytokine', 285091),
(468421, '0048450', NULL, NULL, 139, NULL, 'Cytokine', 285091),
(468422, '0049015', NULL, NULL, 132, NULL, 'Cytokine', 285091),
(468423, '0049267', NULL, NULL, 151, NULL, 'Cytokine', 285091),
(468424, '0047494', NULL, NULL, 157, NULL, 'Cytokine', 285091),
(468425, '0053912', NULL, NULL, 147, NULL, 'Cytokine', 285091),
(468426, '0045978', NULL, NULL, 155, NULL, 'Cytokine', 285091),
(468427, '0046816', NULL, NULL, 132, NULL, 'Cytokine', 285091),
(468428, '0040892', NULL, NULL, 154, NULL, 'Cytokine', 285091),
(468429, '0045918', NULL, NULL, 127, NULL, 'Cytokine', 285091),
(468430, '0047368', NULL, NULL, 157, NULL, 'Cytokine', 285091),
(468431, '0047379', NULL, NULL, 128, NULL, 'Cytokine', 285091),
(468432, '0045661', NULL, NULL, 146, NULL, 'Cytokine', 285091),
(468433, '0039074', NULL, NULL, 145, NULL, 'Cytokine', 285091),
(468434, '0049016', NULL, NULL, 131, NULL, 'Cytokine', 285091),
(468435, '0047922', NULL, NULL, 149, NULL, 'Cytokine', 285091),
(468436, '0048836', NULL, NULL, 136, NULL, 'Cytokine', 285091),
(468437, '0048867', NULL, NULL, 138, NULL, 'Cytokine', 285091),
(468438, '0048185', NULL, NULL, 70, NULL, 'Probable ACP-binding domain of malonyl-CoA ACP transacylase', 285092),
(468439, '0048387', NULL, NULL, 62, NULL, 'Probable ACP-binding domain of malonyl-CoA ACP transacylase', 285092),
(468440, '0035156', NULL, NULL, 74, NULL, 'TB module/8-cys domain', 285093),
(468441, '0040247', NULL, NULL, 75, NULL, 'TB module/8-cys domain', 285093),
(468442, '0044578', NULL, NULL, 76, NULL, 'TB module/8-cys domain', 285093),
(468443, '0053983', NULL, NULL, 122, NULL, 'tRNA-intron endonuclease catalytic domain-like', 285094),
(468444, '0045728', NULL, NULL, 97, NULL, 'tRNA-intron endonuclease catalytic domain-like', 285094),
(468445, '0049079', NULL, NULL, 91, NULL, 'tRNA-intron endonuclease catalytic domain-like', 285094),
(468446, '0049078', NULL, NULL, 78, NULL, 'tRNA-intron endonuclease catalytic domain-like', 285094),
(468447, '0036294', NULL, NULL, 609, NULL, 'Prokaryotic type I DNA topoisomerase', 285095),
(468448, '0038143', NULL, NULL, 556, NULL, 'Prokaryotic type I DNA topoisomerase', 285095),
(468449, '0048235', NULL, NULL, 591, NULL, 'Prokaryotic type I DNA topoisomerase', 285095),
(468450, '0035022', NULL, NULL, 153, NULL, 'Apolipophorin-III', 285096),
(468451, '0037127', NULL, NULL, 166, NULL, 'Apolipophorin-III', 285096),
(468452, '0054042', NULL, NULL, 180, NULL, 'SP0830-like', 285097),
(468453, '0054485', NULL, NULL, 137, NULL, 'Ribosomal protein L16p/L10e', 285098),
(468454, '0054781', NULL, NULL, 136, NULL, 'Ribosomal protein L16p/L10e', 285098),
(468455, '0047597', NULL, NULL, 167, NULL, 'Ribosomal protein L16p/L10e', 285098),
(468456, '0050637', NULL, NULL, 141, NULL, 'Ribosomal protein L16p/L10e', 285098),
(468457, '0037534', NULL, NULL, 157, NULL, 'Ribosomal protein L16p/L10e', 285098),
(468458, '0052973', NULL, NULL, 131, NULL, 'Ribosomal protein L16p/L10e', 285098),
(468459, '0043512', NULL, NULL, 171, NULL, 'Ribosomal protein L16p/L10e', 285098),
(468460, '0050231', NULL, NULL, 97, NULL, 'PTS system IIB component-like', 285099),
(468461, '0054644', NULL, NULL, 103, NULL, 'PTS system IIB component-like', 285099),
(468462, '0054642', NULL, NULL, 103, NULL, 'PTS system IIB component-like', 285099),
(468463, '0039042', NULL, NULL, 103, NULL, 'PTS system IIB component-like', 285099),
(468464, '0052556', NULL, NULL, 82, NULL, 'YdhA-like', 285100);
INSERT INTO "PUBLIC"."MODEL" VALUES
(468465, '0053189', NULL, NULL, 227, NULL, 'Enolase C-terminal domain-like', 285101),
(468466, '0052871', NULL, NULL, 256, NULL, 'Enolase C-terminal domain-like', 285101),
(468467, '0046496', NULL, NULL, 291, NULL, 'Enolase C-terminal domain-like', 285101),
(468468, '0041817', NULL, NULL, 291, NULL, 'Enolase C-terminal domain-like', 285101),
(468469, '0041937', NULL, NULL, 295, NULL, 'Enolase C-terminal domain-like', 285101),
(468470, '0042271', NULL, NULL, 294, NULL, 'Enolase C-terminal domain-like', 285101),
(468471, '0050711', NULL, NULL, 244, NULL, 'Enolase C-terminal domain-like', 285101),
(468472, '0050709', NULL, NULL, 241, NULL, 'Enolase C-terminal domain-like', 285101),
(468473, '0046516', NULL, NULL, 309, NULL, 'Enolase C-terminal domain-like', 285101),
(468474, '0047649', NULL, NULL, 208, NULL, 'Enolase C-terminal domain-like', 285101),
(468475, '0047825', NULL, NULL, 251, NULL, 'Enolase C-terminal domain-like', 285101),
(468476, '0047786', NULL, NULL, 253, NULL, 'Enolase C-terminal domain-like', 285101),
(468477, '0049248', NULL, NULL, 255, NULL, 'Enolase C-terminal domain-like', 285101),
(468478, '0052170', NULL, NULL, 244, NULL, 'Enolase C-terminal domain-like', 285101),
(468479, '0043960', NULL, NULL, 294, NULL, 'Enolase C-terminal domain-like', 285101),
(468480, '0049748', NULL, NULL, 247, NULL, 'Enolase C-terminal domain-like', 285101),
(468481, '0049077', NULL, NULL, 243, NULL, 'Enolase C-terminal domain-like', 285101),
(468482, '0049411', NULL, NULL, 242, NULL, 'Enolase C-terminal domain-like', 285101),
(468483, '0050381', NULL, NULL, 296, NULL, 'Enolase C-terminal domain-like', 285101),
(468484, '0047651', NULL, NULL, 234, NULL, 'Enolase C-terminal domain-like', 285101),
(468485, '0035662', NULL, NULL, 279, NULL, 'Enolase C-terminal domain-like', 285101),
(468486, '0052917', NULL, NULL, 278, NULL, 'Enolase C-terminal domain-like', 285101),
(468487, '0047478', NULL, NULL, 295, NULL, 'Enolase C-terminal domain-like', 285101),
(468488, '0046786', NULL, NULL, 221, NULL, 'Enolase C-terminal domain-like', 285101),
(468489, '0048224', NULL, NULL, 242, NULL, 'Enolase C-terminal domain-like', 285101),
(468490, '0051292', NULL, NULL, 252, NULL, 'Enolase C-terminal domain-like', 285101),
(468491, '0048445', NULL, NULL, 243, NULL, 'Enolase C-terminal domain-like', 285101),
(468492, '0048018', NULL, NULL, 81, NULL, 'RAP domain-like', 285102),
(468493, '0052758', NULL, NULL, 118, NULL, 'RAP domain-like', 285102),
(468494, '0054848', NULL, NULL, 82, NULL, 'Cation efflux protein cytoplasmic domain-like', 285103),
(468495, '0054605', NULL, NULL, 82, NULL, 'Cation efflux protein cytoplasmic domain-like', 285103),
(468496, '0053808', NULL, NULL, 83, NULL, 'SMR domain-like', 285104),
(468497, '0049295', NULL, NULL, 317, NULL, 'Apyrase', 285105),
(468498, '0053571', NULL, NULL, 54, NULL, 'Eferin C-derminal domain-like', 285106),
(468499, '0053569', NULL, NULL, 35, NULL, 'Eferin C-derminal domain-like', 285106),
(468500, '0047905', NULL, NULL, 108, NULL, 'Chemosensory protein Csp2', 285107),
(468501, '0037541', NULL, NULL, 143, NULL, 'Ribosomal protein L19 (L19e)', 285108),
(468502, '0046371', NULL, NULL, 352, NULL, 'Periplasmic binding protein-like II', 285109),
(468503, '0051520', NULL, NULL, 204, NULL, 'Periplasmic binding protein-like II', 285109),
(468504, '0046370', NULL, NULL, 334, NULL, 'Periplasmic binding protein-like II', 285109),
(468505, '0048393', NULL, NULL, 308, NULL, 'Periplasmic binding protein-like II', 285109),
(468506, '0050155', NULL, NULL, 206, NULL, 'Periplasmic binding protein-like II', 285109),
(468507, '0051046', NULL, NULL, 504, NULL, 'Periplasmic binding protein-like II', 285109),
(468508, '0047464', NULL, NULL, 321, NULL, 'Periplasmic binding protein-like II', 285109),
(468509, '0043183', NULL, NULL, 309, NULL, 'Periplasmic binding protein-like II', 285109),
(468510, '0049487', NULL, NULL, 270, NULL, 'Periplasmic binding protein-like II', 285109),
(468511, '0052374', NULL, NULL, 352, NULL, 'Periplasmic binding protein-like II', 285109),
(468512, '0047462', NULL, NULL, 205, NULL, 'Periplasmic binding protein-like II', 285109);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(468513, '0038704', NULL, NULL, 238, NULL, 'Periplasmic binding protein-like II', 285109),
(468514, '0051126', NULL, NULL, 311, NULL, 'Periplasmic binding protein-like II', 285109),
(468515, '0036601', NULL, NULL, 356, NULL, 'Periplasmic binding protein-like II', 285109),
(468516, '0051127', NULL, NULL, 307, NULL, 'Periplasmic binding protein-like II', 285109),
(468517, '0046857', NULL, NULL, 262, NULL, 'Periplasmic binding protein-like II', 285109),
(468518, '0052806', NULL, NULL, 220, NULL, 'Periplasmic binding protein-like II', 285109),
(468519, '0046378', NULL, NULL, 507, NULL, 'Periplasmic binding protein-like II', 285109),
(468520, '0043543', NULL, NULL, 309, NULL, 'Periplasmic binding protein-like II', 285109),
(468521, '0049726', NULL, NULL, 249, NULL, 'Periplasmic binding protein-like II', 285109),
(468522, '0051099', NULL, NULL, 248, NULL, 'Periplasmic binding protein-like II', 285109),
(468523, '0054445', NULL, NULL, 136, NULL, 'Periplasmic binding protein-like II', 285109),
(468524, '0047112', NULL, NULL, 220, NULL, 'Periplasmic binding protein-like II', 285109),
(468525, '0054440', NULL, NULL, 228, NULL, 'Periplasmic binding protein-like II', 285109),
(468526, '0051251', NULL, NULL, 318, NULL, 'Periplasmic binding protein-like II', 285109),
(468527, '0051539', NULL, NULL, 260, NULL, 'Periplasmic binding protein-like II', 285109),
(468528, '0050446', NULL, NULL, 223, NULL, 'Periplasmic binding protein-like II', 285109),
(468529, '0052589', NULL, NULL, 247, NULL, 'Periplasmic binding protein-like II', 285109),
(468530, '0046627', NULL, NULL, 407, NULL, 'Periplasmic binding protein-like II', 285109),
(468531, '0045538', NULL, NULL, 370, NULL, 'Periplasmic binding protein-like II', 285109),
(468532, '0048727', NULL, NULL, 289, NULL, 'Periplasmic binding protein-like II', 285109),
(468533, '0047639', NULL, NULL, 332, NULL, 'Periplasmic binding protein-like II', 285109),
(468534, '0039785', NULL, NULL, 333, NULL, 'Periplasmic binding protein-like II', 285109),
(468535, '0045817', NULL, NULL, 231, NULL, 'Periplasmic binding protein-like II', 285109),
(468536, '0042263', NULL, NULL, 217, NULL, 'Periplasmic binding protein-like II', 285109),
(468537, '0047313', NULL, NULL, 212, NULL, 'Periplasmic binding protein-like II', 285109),
(468538, '0049612', NULL, NULL, 329, NULL, 'Periplasmic binding protein-like II', 285109),
(468539, '0044486', NULL, NULL, 487, NULL, 'Periplasmic binding protein-like II', 285109),
(468540, '0045575', NULL, NULL, 362, NULL, 'Periplasmic binding protein-like II', 285109),
(468541, '0051090', NULL, NULL, 240, NULL, 'Periplasmic binding protein-like II', 285109),
(468542, '0050299', NULL, NULL, 535, NULL, 'Periplasmic binding protein-like II', 285109),
(468543, '0048497', NULL, NULL, 203, NULL, 'Periplasmic binding protein-like II', 285109),
(468544, '0054694', NULL, NULL, 376, NULL, 'Periplasmic binding protein-like II', 285109),
(468545, '0054618', NULL, NULL, 184, NULL, 'Periplasmic binding protein-like II', 285109),
(468546, '0035894', NULL, NULL, 357, NULL, 'Periplasmic binding protein-like II', 285109),
(468547, '0039658', NULL, NULL, 342, NULL, 'Periplasmic binding protein-like II', 285109),
(468548, '0052357', NULL, NULL, 270, NULL, 'Periplasmic binding protein-like II', 285109),
(468549, '0052996', NULL, NULL, 325, NULL, 'Periplasmic binding protein-like II', 285109),
(468550, '0040650', NULL, NULL, 239, NULL, 'Periplasmic binding protein-like II', 285109),
(468551, '0041385', NULL, NULL, 210, NULL, 'Periplasmic binding protein-like II', 285109),
(468552, '0052509', NULL, NULL, 212, NULL, 'Periplasmic binding protein-like II', 285109),
(468553, '0049987', NULL, NULL, 298, NULL, 'Periplasmic binding protein-like II', 285109),
(468554, '0046398', NULL, NULL, 333, NULL, 'Periplasmic binding protein-like II', 285109),
(468555, '0037070', NULL, NULL, 380, NULL, 'Periplasmic binding protein-like II', 285109),
(468556, '0047567', NULL, NULL, 517, NULL, 'Periplasmic binding protein-like II', 285109),
(468557, '0048733', NULL, NULL, 333, NULL, 'Periplasmic binding protein-like II', 285109);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(468558, '0044496', NULL, NULL, 367, NULL, 'Periplasmic binding protein-like II', 285109),
(468559, '0042594', NULL, NULL, 318, NULL, 'Periplasmic binding protein-like II', 285109),
(468560, '0054095', NULL, NULL, 272, NULL, 'Periplasmic binding protein-like II', 285109),
(468561, '0045864', NULL, NULL, 356, NULL, 'Periplasmic binding protein-like II', 285109),
(468562, '0046117', NULL, NULL, 333, NULL, 'Periplasmic binding protein-like II', 285109),
(468563, '0046557', NULL, NULL, 324, NULL, 'Periplasmic binding protein-like II', 285109),
(468564, '0045863', NULL, NULL, 333, NULL, 'Periplasmic binding protein-like II', 285109),
(468565, '0045745', NULL, NULL, 341, NULL, 'Periplasmic binding protein-like II', 285109),
(468566, '0046118', NULL, NULL, 356, NULL, 'Periplasmic binding protein-like II', 285109),
(468567, '0047371', NULL, NULL, 226, NULL, 'Periplasmic binding protein-like II', 285109),
(468568, '0054389', NULL, NULL, 311, NULL, 'Periplasmic binding protein-like II', 285109),
(468569, '0045790', NULL, NULL, 237, NULL, 'Periplasmic binding protein-like II', 285109),
(468570, '0051197', NULL, NULL, 317, NULL, 'Periplasmic binding protein-like II', 285109),
(468571, '0049271', NULL, NULL, 324, NULL, 'Periplasmic binding protein-like II', 285109),
(468572, '0054307', NULL, NULL, 277, NULL, 'Periplasmic binding protein-like II', 285109),
(468573, '0042201', NULL, NULL, 255, NULL, 'Periplasmic binding protein-like II', 285109),
(468574, '0049916', NULL, NULL, 496, NULL, 'Periplasmic binding protein-like II', 285109),
(468575, '0051706', NULL, NULL, 278, NULL, 'Periplasmic binding protein-like II', 285109),
(468576, '0042407', NULL, NULL, 322, NULL, 'Periplasmic binding protein-like II', 285109),
(468577, '0046289', NULL, NULL, 309, NULL, 'Periplasmic binding protein-like II', 285109),
(468578, '0047137', NULL, NULL, 331, NULL, 'Periplasmic binding protein-like II', 285109),
(468579, '0049998', NULL, NULL, 219, NULL, 'Periplasmic binding protein-like II', 285109),
(468580, '0051191', NULL, NULL, 490, NULL, 'Periplasmic binding protein-like II', 285109),
(468581, '0045793', NULL, NULL, 231, NULL, 'Periplasmic binding protein-like II', 285109),
(468582, '0047138', NULL, NULL, 346, NULL, 'Periplasmic binding protein-like II', 285109),
(468583, '0049318', NULL, NULL, 257, NULL, 'Periplasmic binding protein-like II', 285109),
(468584, '0047899', NULL, NULL, 492, NULL, 'Periplasmic binding protein-like II', 285109),
(468585, '0052762', NULL, NULL, 59, NULL, 'Kinetochore globular domain', 285110),
(468586, '0052761', NULL, NULL, 89, NULL, 'Kinetochore globular domain', 285110),
(468587, '0048590', NULL, NULL, 91, NULL, 'gamma-Crystallin-like', 285111),
(468588, '0048591', NULL, NULL, 92, NULL, 'gamma-Crystallin-like', 285111),
(468589, '0047120', NULL, NULL, 88, NULL, 'gamma-Crystallin-like', 285111),
(468590, '0034883', NULL, NULL, 84, NULL, 'gamma-Crystallin-like', 285111),
(468591, '0038504', NULL, NULL, 87, NULL, 'gamma-Crystallin-like', 285111),
(468592, '0034884', NULL, NULL, 89, NULL, 'gamma-Crystallin-like', 285111),
(468593, '0038408', NULL, NULL, 85, NULL, 'gamma-Crystallin-like', 285111),
(468594, '0051406', NULL, NULL, 90, NULL, 'gamma-Crystallin-like', 285111),
(468595, '0038546', NULL, NULL, 100, NULL, 'gamma-Crystallin-like', 285111),
(468596, '0038100', NULL, NULL, 87, NULL, 'gamma-Crystallin-like', 285111),
(468597, '0045707', NULL, NULL, 89, NULL, 'gamma-Crystallin-like', 285111),
(468598, '0035792', NULL, NULL, 76, NULL, 'gamma-Crystallin-like', 285111),
(468599, '0037390', NULL, NULL, 84, NULL, 'gamma-Crystallin-like', 285111),
(468600, '0042432', NULL, NULL, 83, NULL, 'gamma-Crystallin-like', 285111),
(468601, '0048120', NULL, NULL, 85, NULL, 'gamma-Crystallin-like', 285111),
(468602, '0046582', NULL, NULL, 88, NULL, 'gamma-Crystallin-like', 285111),
(468603, '0046581', NULL, NULL, 85, NULL, 'gamma-Crystallin-like', 285111),
(468604, '0035104', NULL, NULL, 85, NULL, 'gamma-Crystallin-like', 285111),
(468605, '0035469', NULL, NULL, 176, NULL, 'gamma-Crystallin-like', 285111);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(468606, '0034930', NULL, NULL, 86, NULL, 'gamma-Crystallin-like', 285111),
(468607, '0035105', NULL, NULL, 89, NULL, 'gamma-Crystallin-like', 285111),
(468608, '0041510', NULL, NULL, 88, NULL, 'gamma-Crystallin-like', 285111),
(468609, '0035560', NULL, NULL, 102, NULL, 'gamma-Crystallin-like', 285111),
(468610, '0040847', NULL, NULL, 88, NULL, 'gamma-Crystallin-like', 285111),
(468611, '0044983', NULL, NULL, 88, NULL, 'gamma-Crystallin-like', 285111),
(468612, '0052146', NULL, NULL, 140, NULL, 'Carbohydrate-binding domain', 285112),
(468613, '0049741', NULL, NULL, 170, NULL, 'Carbohydrate-binding domain', 285112),
(468614, '0037927', NULL, NULL, 160, NULL, 'Carbohydrate-binding domain', 285112),
(468615, '0051999', NULL, NULL, 162, NULL, 'Carbohydrate-binding domain', 285112),
(468616, '0054727', NULL, NULL, 136, NULL, 'Carbohydrate-binding domain', 285112),
(468617, '0047180', NULL, NULL, 88, NULL, 'Carbohydrate-binding domain', 285112),
(468618, '0054439', NULL, NULL, 133, NULL, 'Carbohydrate-binding domain', 285112),
(468619, '0046648', NULL, NULL, 110, NULL, 'Carbohydrate-binding domain', 285112),
(468620, '0037981', NULL, NULL, 158, NULL, 'Carbohydrate-binding domain', 285112),
(468621, '0035131', NULL, NULL, 143, NULL, 'Carbohydrate-binding domain', 285112),
(468622, '0041294', NULL, NULL, 155, NULL, 'Carbohydrate-binding domain', 285112),
(468623, '0046464', NULL, NULL, 87, NULL, 'Carbohydrate-binding domain', 285112),
(468624, '0043055', NULL, NULL, 171, NULL, 'Carbohydrate-binding domain', 285112),
(468625, '0043980', NULL, NULL, 145, NULL, 'Carbohydrate-binding domain', 285112),
(468626, '0046898', NULL, NULL, 143, NULL, 'Carbohydrate-binding domain', 285112),
(468627, '0042696', NULL, NULL, 173, NULL, 'Carbohydrate-binding domain', 285112),
(468628, '0047370', NULL, NULL, 323, NULL, 'PEP carboxykinase-like', 285113),
(468629, '0053253', NULL, NULL, 313, NULL, 'PEP carboxykinase-like', 285113),
(468630, '0047552', NULL, NULL, 173, NULL, 'PEP carboxykinase-like', 285113),
(468631, '0047841', NULL, NULL, 177, NULL, 'PEP carboxykinase-like', 285113),
(468632, '0047801', NULL, NULL, 363, NULL, 'PEP carboxykinase-like', 285113),
(468633, '0047503', NULL, NULL, 318, NULL, 'PEP carboxykinase-like', 285113),
(468634, '0047844', NULL, NULL, 169, NULL, 'PEP carboxykinase-like', 285113),
(468635, '0047274', NULL, NULL, 110, NULL, 'Actinoxanthin-like', 285114),
(468636, '0045761', NULL, NULL, 108, NULL, 'Actinoxanthin-like', 285114),
(468637, '0053181', NULL, NULL, 112, NULL, 'Actinoxanthin-like', 285114),
(468638, '0048401', NULL, NULL, 113, NULL, 'Actinoxanthin-like', 285114),
(468639, '0045787', NULL, NULL, 114, NULL, 'Actinoxanthin-like', 285114),
(468640, '0053924', NULL, NULL, 183, NULL, 'PhnH-like', 285115),
(468641, '0054169', NULL, NULL, 44, NULL, 'SOCS box-like', 285116),
(468642, '0053768', NULL, NULL, 50, NULL, 'SOCS box-like', 285116),
(468643, '0049817', NULL, NULL, 81, NULL, 'YugE-like', 285117),
(468644, '0043093', NULL, NULL, 140, NULL, 'OmpA-like', 285118),
(468645, '0041764', NULL, NULL, 108, NULL, 'OmpA-like', 285118),
(468646, '0051776', NULL, NULL, 134, NULL, 'OmpA-like', 285118),
(468647, '0054312', NULL, NULL, 349, NULL, 'UDP-Glycosyltransferase/glycogen phosphorylase', 285119),
(468648, '0035835', NULL, NULL, 351, NULL, 'UDP-Glycosyltransferase/glycogen phosphorylase', 285119),
(468649, '0051981', NULL, NULL, 437, NULL, 'UDP-Glycosyltransferase/glycogen phosphorylase', 285119),
(468650, '0053762', NULL, NULL, 450, NULL, 'UDP-Glycosyltransferase/glycogen phosphorylase', 285119),
(468651, '0047375', NULL, NULL, 401, NULL, 'UDP-Glycosyltransferase/glycogen phosphorylase', 285119),
(468652, '0053693', NULL, NULL, 461, NULL, 'UDP-Glycosyltransferase/glycogen phosphorylase', 285119),
(468653, '0042392', NULL, NULL, 391, NULL, 'UDP-Glycosyltransferase/glycogen phosphorylase', 285119),
(468654, '0053131', NULL, NULL, 370, NULL, 'UDP-Glycosyltransferase/glycogen phosphorylase', 285119),
(468655, '0052623', NULL, NULL, 166, NULL, 'UDP-Glycosyltransferase/glycogen phosphorylase', 285119);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(468656, '0054538', NULL, NULL, 473, NULL, 'UDP-Glycosyltransferase/glycogen phosphorylase', 285119),
(468657, '0052910', NULL, NULL, 824, NULL, 'UDP-Glycosyltransferase/glycogen phosphorylase', 285119),
(468658, '0051304', NULL, NULL, 876, NULL, 'UDP-Glycosyltransferase/glycogen phosphorylase', 285119),
(468659, '0052533', NULL, NULL, 387, NULL, 'UDP-Glycosyltransferase/glycogen phosphorylase', 285119),
(468660, '0054711', NULL, NULL, 471, NULL, 'UDP-Glycosyltransferase/glycogen phosphorylase', 285119),
(468661, '0046716', NULL, NULL, 376, NULL, 'UDP-Glycosyltransferase/glycogen phosphorylase', 285119),
(468662, '0044616', NULL, NULL, 373, NULL, 'UDP-Glycosyltransferase/glycogen phosphorylase', 285119),
(468663, '0038341', NULL, NULL, 456, NULL, 'UDP-Glycosyltransferase/glycogen phosphorylase', 285119),
(468664, '0049238', NULL, NULL, 401, NULL, 'UDP-Glycosyltransferase/glycogen phosphorylase', 285119),
(468665, '0048983', NULL, NULL, 796, NULL, 'UDP-Glycosyltransferase/glycogen phosphorylase', 285119),
(468666, '0043452', NULL, NULL, 477, NULL, 'UDP-Glycosyltransferase/glycogen phosphorylase', 285119),
(468667, '0046587', NULL, NULL, 809, NULL, 'UDP-Glycosyltransferase/glycogen phosphorylase', 285119),
(468668, '0048500', NULL, NULL, 377, NULL, 'UDP-Glycosyltransferase/glycogen phosphorylase', 285119),
(468669, '0048814', NULL, NULL, 348, NULL, 'UDP-Glycosyltransferase/glycogen phosphorylase', 285119),
(468670, '0046669', NULL, NULL, 351, NULL, 'UDP-Glycosyltransferase/glycogen phosphorylase', 285119),
(468671, '0049693', NULL, NULL, 107, NULL, 'SWIB/MDM2 domain', 285120),
(468672, '0045079', NULL, NULL, 85, NULL, 'SWIB/MDM2 domain', 285120),
(468673, '0044367', NULL, NULL, 93, NULL, 'SWIB/MDM2 domain', 285120),
(468674, '0044599', NULL, NULL, 93, NULL, 'SWIB/MDM2 domain', 285120),
(468675, '0044600', NULL, NULL, 101, NULL, 'SWIB/MDM2 domain', 285120),
(468676, '0048068', NULL, NULL, 75, NULL, 'Zn-finger domain of Sec23/24', 285121),
(468677, '0048072', NULL, NULL, 85, NULL, 'Zn-finger domain of Sec23/24', 285121),
(468678, '0053697', NULL, NULL, 115, NULL, 'L30e-like', 285122),
(468679, '0054611', NULL, NULL, 95, NULL, 'L30e-like', 285122),
(468680, '0053753', NULL, NULL, 100, NULL, 'L30e-like', 285122),
(468681, '0046480', NULL, NULL, 125, NULL, 'L30e-like', 285122),
(468682, '0049200', NULL, NULL, 113, NULL, 'L30e-like', 285122),
(468683, '0036589', NULL, NULL, 146, NULL, 'L30e-like', 285122),
(468684, '0038339', NULL, NULL, 87, NULL, 'L30e-like', 285122),
(468685, '0053639', NULL, NULL, 111, NULL, 'L30e-like', 285122),
(468686, '0054717', NULL, NULL, 104, NULL, 'L30e-like', 285122),
(468687, '0053703', NULL, NULL, 126, NULL, 'L30e-like', 285122),
(468688, '0039117', NULL, NULL, 105, NULL, 'L30e-like', 285122),
(468689, '0037533', NULL, NULL, 118, NULL, 'L30e-like', 285122),
(468690, '0038463', NULL, NULL, 99, NULL, 'L30e-like', 285122),
(468691, '0049508', NULL, NULL, 97, NULL, 'L30e-like', 285122),
(468692, '0053907', NULL, NULL, 124, NULL, 'L30e-like', 285122),
(468693, '0043564', NULL, NULL, 115, NULL, 'L30e-like', 285122),
(468694, '0043511', NULL, NULL, 119, NULL, 'L30e-like', 285122),
(468695, '0042511', NULL, NULL, 128, NULL, 'L30e-like', 285122),
(468696, '0051778', NULL, NULL, 148, NULL, 'BH3618-like', 285123),
(468697, '0050286', NULL, NULL, 189, NULL, 'Penicillin binding protein dimerisation domain', 285124),
(468698, '0039858', NULL, NULL, 197, NULL, 'Penicillin binding protein dimerisation domain', 285124),
(468699, '0042863', NULL, NULL, 193, NULL, 'Penicillin binding protein dimerisation domain', 285124),
(468700, '0051436', NULL, NULL, 74, NULL, 'PA2021-like', 285125),
(468701, '0046394', NULL, NULL, 198, NULL, 'Outer arm dynein light chain 1', 285126),
(468702, '0039790', NULL, NULL, 114, NULL, 'N-terminal domain of DnaB helicase', 285127),
(468703, '0054600', NULL, NULL, 120, NULL, 'Prokaryotic ribosomal protein L17', 285128),
(468704, '0054782', NULL, NULL, 113, NULL, 'Prokaryotic ribosomal protein L17', 285128),
(468705, '0038055', NULL, NULL, 105, NULL, 'Prokaryotic ribosomal protein L17', 285128);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(468706, '0053787', NULL, NULL, 109, NULL, 'Prokaryotic ribosomal protein L17', 285128),
(468707, '0034803', NULL, NULL, 63, NULL, 'HLH, helix-loop-helix DNA-binding domain', 285129),
(468708, '0041452', NULL, NULL, 79, NULL, 'HLH, helix-loop-helix DNA-binding domain', 285129),
(468709, '0038629', NULL, NULL, 80, NULL, 'HLH, helix-loop-helix DNA-binding domain', 285129),
(468710, '0044409', NULL, NULL, 61, NULL, 'HLH, helix-loop-helix DNA-binding domain', 285129),
(468711, '0043065', NULL, NULL, 87, NULL, 'HLH, helix-loop-helix DNA-binding domain', 285129),
(468712, '0035113', NULL, NULL, 65, NULL, 'HLH, helix-loop-helix DNA-binding domain', 285129),
(468713, '0035101', NULL, NULL, 80, NULL, 'HLH, helix-loop-helix DNA-binding domain', 285129),
(468714, '0035112', NULL, NULL, 86, NULL, 'HLH, helix-loop-helix DNA-binding domain', 285129),
(468715, '0040898', NULL, NULL, 68, NULL, 'HLH, helix-loop-helix DNA-binding domain', 285129),
(468716, '0041437', NULL, NULL, 88, NULL, 'HLH, helix-loop-helix DNA-binding domain', 285129),
(468717, '0052432', NULL, NULL, 202, NULL, 'FtsH protease domain-like', 285130),
(468718, '0052154', NULL, NULL, 193, NULL, 'FtsH protease domain-like', 285130),
(468719, '0043151', NULL, NULL, 80, NULL, 'Flavivirus capsid protein C', 285131),
(468720, '0043584', NULL, NULL, 73, NULL, 'Flavivirus capsid protein C', 285131),
(468721, '0041114', NULL, NULL, 220, NULL, 'YebC-like', 285132),
(468722, '0040484', NULL, NULL, 243, NULL, 'YebC-like', 285132),
(468723, '0040186', NULL, NULL, 244, NULL, 'YebC-like', 285132),
(468724, '0053177', NULL, NULL, 157, NULL, 'Aspartate receptor, ligand-binding domain', 285133),
(468725, '0045165', NULL, NULL, 142, NULL, 'Aspartate receptor, ligand-binding domain', 285133),
(468726, '0044172', NULL, NULL, 322, NULL, 'PAZ domain', 285134),
(468727, '0049101', NULL, NULL, 168, NULL, 'PAZ domain', 285134),
(468728, '0043154', NULL, NULL, 126, NULL, 'PAZ domain', 285134),
(468729, '0043841', NULL, NULL, 123, NULL, 'PAZ domain', 285134),
(468730, '0049405', NULL, NULL, 126, NULL, 'PAZ domain', 285134),
(468731, '0051424', NULL, NULL, 311, NULL, 'PAZ domain', 285134),
(468732, '0048197', NULL, NULL, 66, NULL, 'Ribbon-helix-helix', 285135),
(468733, '0051088', NULL, NULL, 35, NULL, 'Ribbon-helix-helix', 285135),
(468734, '0035318', NULL, NULL, 53, NULL, 'Ribbon-helix-helix', 285135),
(468735, '0053641', NULL, NULL, 43, NULL, 'Ribbon-helix-helix', 285135),
(468736, '0054674', NULL, NULL, 121, NULL, 'Ribbon-helix-helix', 285135),
(468737, '0052220', NULL, NULL, 43, NULL, 'Ribbon-helix-helix', 285135),
(468738, '0051658', NULL, NULL, 86, NULL, 'Ribbon-helix-helix', 285135),
(468739, '0051246', NULL, NULL, 81, NULL, 'Ribbon-helix-helix', 285135),
(468740, '0053724', NULL, NULL, 43, NULL, 'Ribbon-helix-helix', 285135),
(468741, '0051983', NULL, NULL, 50, NULL, 'Ribbon-helix-helix', 285135),
(468742, '0053886', NULL, NULL, 82, NULL, 'Ribbon-helix-helix', 285135),
(468743, '0052039', NULL, NULL, 69, NULL, 'Ribbon-helix-helix', 285135),
(468744, '0035481', NULL, NULL, 52, NULL, 'Ribbon-helix-helix', 285135),
(468745, '0036063', NULL, NULL, 104, NULL, 'Ribbon-helix-helix', 285135),
(468746, '0039155', NULL, NULL, 48, NULL, 'Ribbon-helix-helix', 285135),
(468747, '0042628', NULL, NULL, 48, NULL, 'Ribbon-helix-helix', 285135),
(468748, '0048714', NULL, NULL, 76, NULL, 'Ribbon-helix-helix', 285135),
(468749, '0041785', NULL, NULL, 58, NULL, 'Mitochondrial cytochrome c oxidase subunit VIIa', 285136),
(468750, '0049388', NULL, NULL, 75, NULL, 'ChaB-like', 285137),
(468751, '0053243', NULL, NULL, 101, NULL, 'Mechanosensitive channel protein MscS (YggB), C-terminal domain', 285138),
(468752, '0047926', NULL, NULL, 100, NULL, 'Cadherin-like', 285139),
(468753, '0047927', NULL, NULL, 113, NULL, 'Cadherin-like', 285139),
(468754, '0041310', NULL, NULL, 114, NULL, 'Cadherin-like', 285139),
(468755, '0048618', NULL, NULL, 136, NULL, 'Cadherin-like', 285139),
(468756, '0049774', NULL, NULL, 103, NULL, 'Cadherin-like', 285139),
(468757, '0036919', NULL, NULL, 112, NULL, 'Cadherin-like', 285139);
INSERT INTO "PUBLIC"."MODEL" VALUES
(468758, '0047928', NULL, NULL, 113, NULL, 'Cadherin-like', 285139),
(468759, '0047929', NULL, NULL, 107, NULL, 'Cadherin-like', 285139),
(468760, '0047930', NULL, NULL, 107, NULL, 'Cadherin-like', 285139),
(468761, '0048502', NULL, NULL, 105, NULL, 'Cadherin-like', 285139),
(468762, '0046524', NULL, NULL, 99, NULL, 'Cadherin-like', 285139),
(468763, '0048328', NULL, NULL, 102, NULL, 'Cadherin-like', 285139),
(468764, '0036455', NULL, NULL, 79, NULL, 'Protein HNS-dependent expression A; HdeA', 285140),
(468765, '0054309', NULL, NULL, 270, NULL, 'TTHA0583/YokD-like', 285141),
(468766, '0044664', NULL, NULL, 193, NULL, 'TTHA0583/YokD-like', 285141),
(468767, '0047174', NULL, NULL, 275, NULL, 'DNase I-like', 285142),
(468768, '0049450', NULL, NULL, 261, NULL, 'DNase I-like', 285142),
(468769, '0052422', NULL, NULL, 299, NULL, 'DNase I-like', 285142),
(468770, '0050453', NULL, NULL, 228, NULL, 'DNase I-like', 285142),
(468771, '0052475', NULL, NULL, 260, NULL, 'DNase I-like', 285142),
(468772, '0047330', NULL, NULL, 345, NULL, 'DNase I-like', 285142),
(468773, '0048441', NULL, NULL, 280, NULL, 'DNase I-like', 285142),
(468774, '0035081', NULL, NULL, 268, NULL, 'DNase I-like', 285142),
(468775, '0050312', NULL, NULL, 236, NULL, 'DNase I-like', 285142),
(468776, '0052568', NULL, NULL, 250, NULL, 'DNase I-like', 285142),
(468777, '0051655', NULL, NULL, 293, NULL, 'DNase I-like', 285142),
(468778, '0053543', NULL, NULL, 140, NULL, 'Synuclein', 285143),
(468779, '0038596', NULL, NULL, 101, NULL, 'P-domain of calnexin/calreticulin', 285144),
(468780, '0047588', NULL, NULL, 142, NULL, 'P-domain of calnexin/calreticulin', 285144),
(468781, '0039035', NULL, NULL, 52, NULL, 'DNA-binding domain of retroviral integrase', 285145),
(468782, '0035801', NULL, NULL, 53, NULL, 'DNA-binding domain of retroviral integrase', 285145),
(468783, '0035866', NULL, NULL, 55, NULL, 'DNA-binding domain of retroviral integrase', 285145),
(468784, '0046646', NULL, NULL, 48, NULL, 'DNA-binding domain of retroviral integrase', 285145),
(468785, '0043700', NULL, NULL, 109, NULL, 'Spermadhesin, CUB domain', 285146),
(468786, '0054622', NULL, NULL, 108, NULL, 'Spermadhesin, CUB domain', 285146),
(468787, '0043701', NULL, NULL, 112, NULL, 'Spermadhesin, CUB domain', 285146),
(468788, '0043807', NULL, NULL, 121, NULL, 'Spermadhesin, CUB domain', 285146),
(468789, '0041549', NULL, NULL, 114, NULL, 'Spermadhesin, CUB domain', 285146),
(468790, '0041548', NULL, NULL, 115, NULL, 'Spermadhesin, CUB domain', 285146),
(468791, '0043586', NULL, NULL, 111, NULL, 'Spermadhesin, CUB domain', 285146),
(468792, '0041645', NULL, NULL, 117, NULL, 'Spermadhesin, CUB domain', 285146),
(468793, '0044952', NULL, NULL, 181, NULL, 'Peptidylarginine deiminase Pad4, middle domain', 285147),
(468794, '0039274', NULL, NULL, 36, NULL, 'Invertebrate chitin-binding proteins', 285148),
(468795, '0036556', NULL, NULL, 73, NULL, 'Invertebrate chitin-binding proteins', 285148),
(468796, '0049142', NULL, NULL, 164, NULL, 'PR-1-like', 285149),
(468797, '0042890', NULL, NULL, 209, NULL, 'PR-1-like', 285149),
(468798, '0043663', NULL, NULL, 149, NULL, 'PR-1-like', 285149),
(468799, '0035964', NULL, NULL, 135, NULL, 'PR-1-like', 285149),
(468800, '0053302', NULL, NULL, 196, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468801, '0051761', NULL, NULL, 213, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468802, '0053267', NULL, NULL, 232, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468803, '0046331', NULL, NULL, 237, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468804, '0048232', NULL, NULL, 236, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468805, '0048870', NULL, NULL, 434, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468806, '0038386', NULL, NULL, 191, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468807, '0037694', NULL, NULL, 237, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468808, '0037454', NULL, NULL, 234, NULL, 'Concanavalin A-like lectins/glucanases', 285150);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(468809, '0040231', NULL, NULL, 223, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468810, '0040472', NULL, NULL, 243, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468811, '0040591', NULL, NULL, 227, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468812, '0041680', NULL, NULL, 270, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468813, '0052728', NULL, NULL, 217, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468814, '0041968', NULL, NULL, 223, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468815, '0046337', NULL, NULL, 204, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468816, '0042498', NULL, NULL, 194, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468817, '0044555', NULL, NULL, 216, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468818, '0044950', NULL, NULL, 319, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468819, '0048910', NULL, NULL, 435, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468820, '0045095', NULL, NULL, 194, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468821, '0049971', NULL, NULL, 266, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468822, '0052187', NULL, NULL, 237, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468823, '0053316', NULL, NULL, 207, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468824, '0052500', NULL, NULL, 206, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468825, '0041211', NULL, NULL, 241, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468826, '0039065', NULL, NULL, 250, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468827, '0047399', NULL, NULL, 228, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468828, '0048488', NULL, NULL, 295, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468829, '0043474', NULL, NULL, 206, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468830, '0044686', NULL, NULL, 222, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468831, '0042784', NULL, NULL, 207, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468832, '0044568', NULL, NULL, 138, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468833, '0046195', NULL, NULL, 214, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468834, '0050332', NULL, NULL, 192, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468835, '0035813', NULL, NULL, 135, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468836, '0053201', NULL, NULL, 137, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468837, '0046076', NULL, NULL, 180, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468838, '0051382', NULL, NULL, 205, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468839, '0048891', NULL, NULL, 195, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468840, '0052639', NULL, NULL, 188, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468841, '0050333', NULL, NULL, 197, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468842, '0038008', NULL, NULL, 251, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468843, '0038486', NULL, NULL, 218, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468844, '0039178', NULL, NULL, 134, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468845, '0041102', NULL, NULL, 243, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468846, '0041068', NULL, NULL, 224, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468847, '0038367', NULL, NULL, 191, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468848, '0045829', NULL, NULL, 226, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468849, '0037395', NULL, NULL, 199, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468850, '0045783', NULL, NULL, 212, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468851, '0046872', NULL, NULL, 240, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468852, '0045387', NULL, NULL, 222, NULL, 'Concanavalin A-like lectins/glucanases', 285150);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(468853, '0045782', NULL, NULL, 214, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468854, '0045543', NULL, NULL, 400, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468855, '0047966', NULL, NULL, 229, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468856, '0049350', NULL, NULL, 204, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468857, '0053179', NULL, NULL, 230, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468858, '0048386', NULL, NULL, 237, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468859, '0052129', NULL, NULL, 163, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468860, '0036338', NULL, NULL, 239, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468861, '0051315', NULL, NULL, 209, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468862, '0036975', NULL, NULL, 371, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468863, '0043656', NULL, NULL, 133, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468864, '0039321', NULL, NULL, 228, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468865, '0038356', NULL, NULL, 227, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468866, '0038351', NULL, NULL, 134, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468867, '0041195', NULL, NULL, 222, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468868, '0051707', NULL, NULL, 239, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468869, '0041913', NULL, NULL, 224, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468870, '0041755', NULL, NULL, 222, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468871, '0041754', NULL, NULL, 218, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468872, '0040785', NULL, NULL, 197, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468873, '0048032', NULL, NULL, 253, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468874, '0048278', NULL, NULL, 233, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468875, '0052538', NULL, NULL, 211, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468876, '0046937', NULL, NULL, 253, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468877, '0051717', NULL, NULL, 218, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468878, '0046938', NULL, NULL, 141, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468879, '0051718', NULL, NULL, 221, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468880, '0047109', NULL, NULL, 218, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468881, '0044236', NULL, NULL, 223, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468882, '0052421', NULL, NULL, 185, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468883, '0046260', NULL, NULL, 170, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468884, '0047199', NULL, NULL, 129, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468885, '0045053', NULL, NULL, 190, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468886, '0054164', NULL, NULL, 179, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468887, '0039549', NULL, NULL, 250, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468888, '0036674', NULL, NULL, 271, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468889, '0051853', NULL, NULL, 214, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468890, '0045737', NULL, NULL, 247, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468891, '0043956', NULL, NULL, 190, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468892, '0042869', NULL, NULL, 132, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468893, '0036671', NULL, NULL, 398, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468894, '0046423', NULL, NULL, 189, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468895, '0045853', NULL, NULL, 206, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468896, '0046424', NULL, NULL, 185, NULL, 'Concanavalin A-like lectins/glucanases', 285150);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(468897, '0048847', NULL, NULL, 195, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468898, '0046944', NULL, NULL, 233, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468899, '0051221', NULL, NULL, 210, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468900, '0034923', NULL, NULL, 134, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468901, '0047089', NULL, NULL, 239, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468902, '0045066', NULL, NULL, 178, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468903, '0038204', NULL, NULL, 431, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468904, '0038601', NULL, NULL, 185, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468905, '0038287', NULL, NULL, 228, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468906, '0046956', NULL, NULL, 214, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468907, '0039013', NULL, NULL, 205, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468908, '0040215', NULL, NULL, 160, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468909, '0035606', NULL, NULL, 135, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468910, '0051198', NULL, NULL, 164, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468911, '0049553', NULL, NULL, 182, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468912, '0050427', NULL, NULL, 237, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468913, '0038677', NULL, NULL, 236, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468914, '0046605', NULL, NULL, 218, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468915, '0037101', NULL, NULL, 190, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468916, '0042889', NULL, NULL, 237, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468917, '0051193', NULL, NULL, 204, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468918, '0048987', NULL, NULL, 231, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468919, '0044424', NULL, NULL, 150, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468920, '0049955', NULL, NULL, 267, NULL, 'Concanavalin A-like lectins/glucanases', 285150),
(468921, '0037035', NULL, NULL, 419, NULL, 'EPT/RTPC-like', 285151),
(468922, '0042868', NULL, NULL, 240, NULL, 'EPT/RTPC-like', 285151),
(468923, '0044235', NULL, NULL, 418, NULL, 'EPT/RTPC-like', 285151),
(468924, '0037963', NULL, NULL, 427, NULL, 'EPT/RTPC-like', 285151),
(468925, '0043215', NULL, NULL, 427, NULL, 'EPT/RTPC-like', 285151),
(468926, '0044170', NULL, NULL, 141, NULL, 'NusB-like', 285152),
(468927, '0048904', NULL, NULL, 140, NULL, 'NusB-like', 285152),
(468928, '0037270', NULL, NULL, 131, NULL, 'NusB-like', 285152),
(468929, '0037257', NULL, NULL, 139, NULL, 'NusB-like', 285152),
(468930, '0043710', NULL, NULL, 140, NULL, 'NusB-like', 285152),
(468931, '0054423', NULL, NULL, 102, NULL, 'F-box domain', 285153),
(468932, '0041352', NULL, NULL, 100, NULL, 'F-box domain', 285153),
(468933, '0042120', NULL, NULL, 118, NULL, 'F-box domain', 285153),
(468934, '0037737', NULL, NULL, 39, NULL, 'F-box domain', 285153),
(468935, '0037752', NULL, NULL, 41, NULL, 'F-box domain', 285153),
(468936, '0035299', NULL, NULL, 253, NULL, 'Pyruvate-ferredoxin oxidoreductase, PFOR, domain III', 285154),
(468937, '0040976', NULL, NULL, 371, NULL, 'Viral chemokine binding protein m3', 285155),
(468938, '0042276', NULL, NULL, 162, NULL, 'R1 subunit of ribonucleotide reductase, N-terminal domain', 285156),
(468939, '0049204', NULL, NULL, 212, NULL, 'R1 subunit of ribonucleotide reductase, N-terminal domain', 285156),
(468940, '0053846', NULL, NULL, 80, NULL, 'TTHA1013/TTHA0281-like', 285157),
(468941, '0050720', NULL, NULL, 71, NULL, 'TTHA1013/TTHA0281-like', 285157),
(468942, '0051342', NULL, NULL, 81, NULL, 'Aminopeptidase/glucanase lid domain', 285158),
(468943, '0051223', NULL, NULL, 133, NULL, 'Aminopeptidase/glucanase lid domain', 285158),
(468944, '0052939', NULL, NULL, 113, NULL, 'Aminopeptidase/glucanase lid domain', 285158);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(468945, '0044761', NULL, NULL, 83, NULL, 'Aminopeptidase/glucanase lid domain', 285158),
(468946, '0051171', NULL, NULL, 91, NULL, 'Aminopeptidase/glucanase lid domain', 285158),
(468947, '0044754', NULL, NULL, 90, NULL, 'Aminopeptidase/glucanase lid domain', 285158),
(468948, '0052786', NULL, NULL, 84, NULL, 'Aminopeptidase/glucanase lid domain', 285158),
(468949, '0053256', NULL, NULL, 157, NULL, 'Transferrin receptor-like dimerisation domain', 285159),
(468950, '0036379', NULL, NULL, 148, NULL, 'Transferrin receptor-like dimerisation domain', 285159),
(468951, '0044514', NULL, NULL, 166, NULL, 'NAC domain', 285160),
(468952, '0036849', NULL, NULL, 174, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468953, '0039157', NULL, NULL, 217, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468954, '0039872', NULL, NULL, 292, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468955, '0043425', NULL, NULL, 250, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468956, '0039156', NULL, NULL, 213, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468957, '0043426', NULL, NULL, 244, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468958, '0039159', NULL, NULL, 233, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468959, '0039158', NULL, NULL, 244, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468960, '0043428', NULL, NULL, 242, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468961, '0043429', NULL, NULL, 233, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468962, '0050948', NULL, NULL, 238, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468963, '0049601', NULL, NULL, 253, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468964, '0046214', NULL, NULL, 192, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468965, '0047427', NULL, NULL, 220, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468966, '0042377', NULL, NULL, 221, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468967, '0043422', NULL, NULL, 222, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468968, '0043423', NULL, NULL, 233, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468969, '0047426', NULL, NULL, 243, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468970, '0040554', NULL, NULL, 422, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468971, '0043424', NULL, NULL, 243, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468972, '0047031', NULL, NULL, 234, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468973, '0054762', NULL, NULL, 180, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468974, '0053199', NULL, NULL, 537, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468975, '0052428', NULL, NULL, 542, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468976, '0042626', NULL, NULL, 227, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468977, '0042627', NULL, NULL, 268, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468978, '0053074', NULL, NULL, 516, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468979, '0043430', NULL, NULL, 244, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468980, '0043431', NULL, NULL, 205, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468981, '0043433', NULL, NULL, 204, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468982, '0043434', NULL, NULL, 198, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(468983, '0043435', NULL, NULL, 212, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468984, '0047001', NULL, NULL, 766, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468985, '0037916', NULL, NULL, 173, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468986, '0039539', NULL, NULL, 206, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468987, '0053208', NULL, NULL, 534, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468988, '0036865', NULL, NULL, 422, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468989, '0046519', NULL, NULL, 249, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468990, '0039335', NULL, NULL, 202, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468991, '0039334', NULL, NULL, 243, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468992, '0042559', NULL, NULL, 204, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468993, '0045668', NULL, NULL, 294, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468994, '0049273', NULL, NULL, 222, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468995, '0049272', NULL, NULL, 241, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468996, '0054144', NULL, NULL, 229, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468997, '0048784', NULL, NULL, 203, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468998, '0035162', NULL, NULL, 303, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(468999, '0036097', NULL, NULL, 751, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(469000, '0039168', NULL, NULL, 199, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(469001, '0039167', NULL, NULL, 204, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(469002, '0039169', NULL, NULL, 201, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(469003, '0039164', NULL, NULL, 245, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(469004, '0039163', NULL, NULL, 238, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(469005, '0039165', NULL, NULL, 202, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(469006, '0039160', NULL, NULL, 250, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(469007, '0045430', NULL, NULL, 342, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(469008, '0039162', NULL, NULL, 234, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(469009, '0048627', NULL, NULL, 675, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(469010, '0040786', NULL, NULL, 171, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', 285161),
(469011, '0043813', NULL, NULL, 64, NULL, 'Rad51 N-terminal domain-like', 285162),
(469012, '0049536', NULL, NULL, 60, NULL, 'Rad51 N-terminal domain-like', 285162),
(469013, '0048851', NULL, NULL, 61, NULL, 'Rad51 N-terminal domain-like', 285162),
(469014, '0049831', NULL, NULL, 68, NULL, 'Rad51 N-terminal domain-like', 285162),
(469015, '0045865', NULL, NULL, 70, NULL, 'Rad51 N-terminal domain-like', 285162),
(469016, '0051237', NULL, NULL, 59, NULL, 'Rad51 N-terminal domain-like', 285162),
(469017, '0053125', NULL, NULL, 277, NULL, 'CorA soluble domain-like', 285163),
(469018, '0050321', NULL, NULL, 37, NULL, 'Rubredoxin-like', 285164),
(469019, '0052486', NULL, NULL, 52, NULL, 'Rubredoxin-like', 285164),
(469020, '0048398', NULL, NULL, 37, NULL, 'Rubredoxin-like', 285164),
(469021, '0045396', NULL, NULL, 98, NULL, 'Rubredoxin-like', 285164),
(469022, '0043471', NULL, NULL, 56, NULL, 'Rubredoxin-like', 285164),
(469023, '0035679', NULL, NULL, 53, NULL, 'Rubredoxin-like', 285164);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(469024, '0051414', NULL, NULL, 36, NULL, 'Rubredoxin-like', 285164),
(469025, '0036623', NULL, NULL, 44, NULL, 'Rubredoxin-like', 285164),
(469026, '0039201', NULL, NULL, 51, NULL, 'Rubredoxin-like', 285164),
(469027, '0045637', NULL, NULL, 45, NULL, 'Rubredoxin-like', 285164),
(469028, '0046329', NULL, NULL, 36, NULL, 'Rubredoxin-like', 285164),
(469029, '0042711', NULL, NULL, 53, NULL, 'Rubredoxin-like', 285164),
(469030, '0039154', NULL, NULL, 53, NULL, 'Rubredoxin-like', 285164),
(469031, '0043187', NULL, NULL, 52, NULL, 'Rubredoxin-like', 285164),
(469032, '0045630', NULL, NULL, 54, NULL, 'Rubredoxin-like', 285164),
(469033, '0045435', NULL, NULL, 52, NULL, 'Rubredoxin-like', 285164),
(469034, '0046413', NULL, NULL, 70, NULL, 'Rubredoxin-like', 285164),
(469035, '0046415', NULL, NULL, 36, NULL, 'Rubredoxin-like', 285164),
(469036, '0043870', NULL, NULL, 92, NULL, 'Cell division protein ZapA-like', 285165),
(469037, '0042209', NULL, NULL, 290, NULL, 'CoaB-like', 285166),
(469038, '0049815', NULL, NULL, 223, NULL, 'CoaB-like', 285166),
(469039, '0052850', NULL, NULL, 225, NULL, 'HAD-like', 285167),
(469040, '0054355', NULL, NULL, 122, NULL, 'HAD-like', 285167),
(469041, '0047540', NULL, NULL, 210, NULL, 'HAD-like', 285167),
(469042, '0048396', NULL, NULL, 217, NULL, 'HAD-like', 285167),
(469043, '0051120', NULL, NULL, 232, NULL, 'HAD-like', 285167),
(469044, '0046572', NULL, NULL, 222, NULL, 'HAD-like', 285167),
(469045, '0051800', NULL, NULL, 243, NULL, 'HAD-like', 285167),
(469046, '0051888', NULL, NULL, 283, NULL, 'HAD-like', 285167),
(469047, '0042929', NULL, NULL, 245, NULL, 'HAD-like', 285167),
(469048, '0052933', NULL, NULL, 204, NULL, 'HAD-like', 285167),
(469049, '0051324', NULL, NULL, 195, NULL, 'HAD-like', 285167),
(469050, '0051764', NULL, NULL, 210, NULL, 'HAD-like', 285167),
(469051, '0052698', NULL, NULL, 187, NULL, 'HAD-like', 285167),
(469052, '0050797', NULL, NULL, 230, NULL, 'HAD-like', 285167),
(469053, '0053744', NULL, NULL, 291, NULL, 'HAD-like', 285167),
(469054, '0049203', NULL, NULL, 269, NULL, 'HAD-like', 285167),
(469055, '0051280', NULL, NULL, 253, NULL, 'HAD-like', 285167),
(469056, '0044796', NULL, NULL, 226, NULL, 'HAD-like', 285167),
(469057, '0052740', NULL, NULL, 161, NULL, 'HAD-like', 285167),
(469058, '0051495', NULL, NULL, 208, NULL, 'HAD-like', 285167),
(469059, '0050761', NULL, NULL, 243, NULL, 'HAD-like', 285167),
(469060, '0051058', NULL, NULL, 124, NULL, 'HAD-like', 285167),
(469061, '0052186', NULL, NULL, 273, NULL, 'HAD-like', 285167),
(469062, '0052660', NULL, NULL, 222, NULL, 'HAD-like', 285167),
(469063, '0054320', NULL, NULL, 209, NULL, 'HAD-like', 285167),
(469064, '0045131', NULL, NULL, 220, NULL, 'HAD-like', 285167),
(469065, '0050723', NULL, NULL, 253, NULL, 'HAD-like', 285167),
(469066, '0051416', NULL, NULL, 253, NULL, 'HAD-like', 285167),
(469067, '0053956', NULL, NULL, 182, NULL, 'HAD-like', 285167),
(469068, '0052665', NULL, NULL, 226, NULL, 'HAD-like', 285167),
(469069, '0040685', NULL, NULL, 221, NULL, 'HAD-like', 285167),
(469070, '0043957', NULL, NULL, 218, NULL, 'HAD-like', 285167),
(469071, '0049579', NULL, NULL, 181, NULL, 'HAD-like', 285167),
(469072, '0049814', NULL, NULL, 164, NULL, 'HAD-like', 285167),
(469073, '0050211', NULL, NULL, 261, NULL, 'HAD-like', 285167),
(469074, '0044171', NULL, NULL, 229, NULL, 'HAD-like', 285167),
(469075, '0051387', NULL, NULL, 253, NULL, 'HAD-like', 285167),
(469076, '0053003', NULL, NULL, 228, NULL, 'HAD-like', 285167),
(469077, '0037518', NULL, NULL, 256, NULL, 'HAD-like', 285167),
(469078, '0040925', NULL, NULL, 194, NULL, 'HAD-like', 285167),
(469079, '0049067', NULL, NULL, 380, NULL, 'HAD-like', 285167),
(469080, '0043284', NULL, NULL, 271, NULL, 'HAD-like', 285167),
(469081, '0050690', NULL, NULL, 230, NULL, 'HAD-like', 285167),
(469082, '0053649', NULL, NULL, 308, NULL, 'HAD-like', 285167),
(469083, '0051348', NULL, NULL, 260, NULL, 'HAD-like', 285167),
(469084, '0052115', NULL, NULL, 250, NULL, 'HAD-like', 285167),
(469085, '0053006', NULL, NULL, 207, NULL, 'HAD-like', 285167);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(469086, '0051937', NULL, NULL, 136, NULL, 'HAD-like', 285167),
(469087, '0047721', NULL, NULL, 177, NULL, 'HAD-like', 285167),
(469088, '0053041', NULL, NULL, 224, NULL, 'HAD-like', 285167),
(469089, '0040657', NULL, NULL, 149, NULL, 'HAD-like', 285167),
(469090, '0049302', NULL, NULL, 244, NULL, 'HAD-like', 285167),
(469091, '0043763', NULL, NULL, 169, NULL, 'HAD-like', 285167),
(469092, '0051870', NULL, NULL, 197, NULL, 'HAD-like', 285167),
(469093, '0049197', NULL, NULL, 206, NULL, 'HAD-like', 285167),
(469094, '0052884', NULL, NULL, 247, NULL, 'HAD-like', 285167),
(469095, '0048300', NULL, NULL, 209, NULL, 'HAD-like', 285167),
(469096, '0051956', NULL, NULL, 458, NULL, 'HAD-like', 285167),
(469097, '0051632', NULL, NULL, 253, NULL, 'HAD-like', 285167),
(469098, '0052765', NULL, NULL, 244, NULL, 'HAD-like', 285167),
(469099, '0041356', NULL, NULL, 267, NULL, 'HAD-like', 285167),
(469100, '0047938', NULL, NULL, 225, NULL, 'HAD-like', 285167),
(469101, '0048428', NULL, NULL, 285, NULL, 'HAD-like', 285167),
(469102, '0052023', NULL, NULL, 94, NULL, 'Protease propeptides/inhibitors', 285168),
(469103, '0049360', NULL, NULL, 71, NULL, 'Protease propeptides/inhibitors', 285168),
(469104, '0048431', NULL, NULL, 89, NULL, 'Protease propeptides/inhibitors', 285168),
(469105, '0047836', NULL, NULL, 73, NULL, 'Protease propeptides/inhibitors', 285168),
(469106, '0047902', NULL, NULL, 95, NULL, 'Protease propeptides/inhibitors', 285168),
(469107, '0048728', NULL, NULL, 81, NULL, 'Protease propeptides/inhibitors', 285168),
(469108, '0049437', NULL, NULL, 71, NULL, 'Protease propeptides/inhibitors', 285168),
(469109, '0047433', NULL, NULL, 77, NULL, 'Protease propeptides/inhibitors', 285168),
(469110, '0047658', NULL, NULL, 92, NULL, 'Protease propeptides/inhibitors', 285168),
(469111, '0045841', NULL, NULL, 94, NULL, 'Protease propeptides/inhibitors', 285168),
(469112, '0048734', NULL, NULL, 94, NULL, 'Protease propeptides/inhibitors', 285168),
(469113, '0049516', NULL, NULL, 179, NULL, 'Protease propeptides/inhibitors', 285168),
(469114, '0048845', NULL, NULL, 94, NULL, 'Protease propeptides/inhibitors', 285168),
(469115, '0037564', NULL, NULL, 110, NULL, 'CO dehydrogenase flavoprotein C-terminal domain-like', 285169),
(469116, '0037701', NULL, NULL, 117, NULL, 'CO dehydrogenase flavoprotein C-terminal domain-like', 285169),
(469117, '0039726', NULL, NULL, 117, NULL, 'CO dehydrogenase flavoprotein C-terminal domain-like', 285169),
(469118, '0041228', NULL, NULL, 109, NULL, 'CO dehydrogenase flavoprotein C-terminal domain-like', 285169),
(469119, '0043861', NULL, NULL, 109, NULL, 'CO dehydrogenase flavoprotein C-terminal domain-like', 285169),
(469120, '0049207', NULL, NULL, 107, NULL, 'CO dehydrogenase flavoprotein C-terminal domain-like', 285169),
(469121, '0041813', NULL, NULL, 260, NULL, 'Neurotransmitter-gated ion-channel transmembrane pore', 285170),
(469122, '0041812', NULL, NULL, 260, NULL, 'Neurotransmitter-gated ion-channel transmembrane pore', 285170),
(469123, '0041811', NULL, NULL, 250, NULL, 'Neurotransmitter-gated ion-channel transmembrane pore', 285170),
(469124, '0041810', NULL, NULL, 227, NULL, 'Neurotransmitter-gated ion-channel transmembrane pore', 285170),
(469125, '0049682', NULL, NULL, 98, NULL, 'Rof/RNase P subunit-like', 285171),
(469126, '0050077', NULL, NULL, 92, NULL, 'Rof/RNase P subunit-like', 285171),
(469127, '0049387', NULL, NULL, 86, NULL, 'Rof/RNase P subunit-like', 285171),
(469128, '0041974', NULL, NULL, 78, NULL, 'Rof/RNase P subunit-like', 285171),
(469129, '0053161', NULL, NULL, 115, NULL, 'STIV B116-like', 285172),
(469130, '0053160', NULL, NULL, 109, NULL, 'STIV B116-like', 285172),
(469131, '0034847', NULL, NULL, 174, NULL, 'Cyclophilin-like', 285173),
(469132, '0051660', NULL, NULL, 124, NULL, 'Cyclophilin-like', 285173),
(469133, '0052158', NULL, NULL, 162, NULL, 'Cyclophilin-like', 285173),
(469134, '0051982', NULL, NULL, 164, NULL, 'Cyclophilin-like', 285173),
(469135, '0051043', NULL, NULL, 166, NULL, 'Cyclophilin-like', 285173),
(469136, '0045440', NULL, NULL, 182, NULL, 'Cyclophilin-like', 285173);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(469137, '0054659', NULL, NULL, 161, NULL, 'Cyclophilin-like', 285173),
(469138, '0050399', NULL, NULL, 165, NULL, 'Cyclophilin-like', 285173),
(469139, '0051587', NULL, NULL, 178, NULL, 'Cyclophilin-like', 285173),
(469140, '0051149', NULL, NULL, 160, NULL, 'Cyclophilin-like', 285173),
(469141, '0051523', NULL, NULL, 186, NULL, 'Cyclophilin-like', 285173),
(469142, '0036200', NULL, NULL, 178, NULL, 'Cyclophilin-like', 285173),
(469143, '0042879', NULL, NULL, 170, NULL, 'Cyclophilin-like', 285173),
(469144, '0040592', NULL, NULL, 164, NULL, 'Cyclophilin-like', 285173),
(469145, '0038362', NULL, NULL, 182, NULL, 'Cyclophilin-like', 285173),
(469146, '0051132', NULL, NULL, 166, NULL, 'Cyclophilin-like', 285173),
(469147, '0051693', NULL, NULL, 164, NULL, 'Cyclophilin-like', 285173),
(469148, '0052763', NULL, NULL, 155, NULL, 'Cyclophilin-like', 285173),
(469149, '0050386', NULL, NULL, 171, NULL, 'Cyclophilin-like', 285173),
(469150, '0050106', NULL, NULL, 166, NULL, 'Cyclophilin-like', 285173),
(469151, '0052507', NULL, NULL, 181, NULL, 'Cyclophilin-like', 285173),
(469152, '0052109', NULL, NULL, 171, NULL, 'Cyclophilin-like', 285173),
(469153, '0054505', NULL, NULL, 132, NULL, 'Cyclophilin-like', 285173),
(469154, '0036678', NULL, NULL, 172, NULL, 'Cyclophilin-like', 285173),
(469155, '0039026', NULL, NULL, 195, NULL, 'Cyclophilin-like', 285173),
(469156, '0042900', NULL, NULL, 173, NULL, 'Cyclophilin-like', 285173),
(469157, '0051928', NULL, NULL, 169, NULL, 'Cyclophilin-like', 285173),
(469158, '0045013', NULL, NULL, 117, NULL, 'Cyclophilin-like', 285173),
(469159, '0039184', NULL, NULL, 161, NULL, 'Cyclophilin-like', 285173),
(469160, '0054223', NULL, NULL, 223, NULL, 'CYTH-like phosphatases', 285174),
(469161, '0051291', NULL, NULL, 163, NULL, 'CYTH-like phosphatases', 285174),
(469162, '0036307', NULL, NULL, 301, NULL, 'CYTH-like phosphatases', 285174),
(469163, '0052645', NULL, NULL, 150, NULL, 'CYTH-like phosphatases', 285174),
(469164, '0051744', NULL, NULL, 174, NULL, 'CYTH-like phosphatases', 285174),
(469165, '0052089', NULL, NULL, 170, NULL, 'Acyl-CoA dehydrogenase C-terminal domain-like', 285175),
(469166, '0047430', NULL, NULL, 181, NULL, 'Acyl-CoA dehydrogenase C-terminal domain-like', 285175),
(469167, '0039219', NULL, NULL, 151, NULL, 'Acyl-CoA dehydrogenase C-terminal domain-like', 285175),
(469168, '0050326', NULL, NULL, 198, NULL, 'Acyl-CoA dehydrogenase C-terminal domain-like', 285175),
(469169, '0035713', NULL, NULL, 151, NULL, 'Acyl-CoA dehydrogenase C-terminal domain-like', 285175),
(469170, '0039700', NULL, NULL, 153, NULL, 'Acyl-CoA dehydrogenase C-terminal domain-like', 285175),
(469171, '0036987', NULL, NULL, 155, NULL, 'Acyl-CoA dehydrogenase C-terminal domain-like', 285175),
(469172, '0050325', NULL, NULL, 189, NULL, 'Acyl-CoA dehydrogenase C-terminal domain-like', 285175),
(469173, '0052369', NULL, NULL, 153, NULL, 'Acyl-CoA dehydrogenase C-terminal domain-like', 285175),
(469174, '0045539', NULL, NULL, 154, NULL, 'Acyl-CoA dehydrogenase C-terminal domain-like', 285175),
(469175, '0039175', NULL, NULL, 189, NULL, 'Acyl-CoA dehydrogenase C-terminal domain-like', 285175),
(469176, '0043628', NULL, NULL, 154, NULL, 'Acyl-CoA dehydrogenase C-terminal domain-like', 285175),
(469177, '0049821', NULL, NULL, 215, NULL, 'Acyl-CoA dehydrogenase C-terminal domain-like', 285175),
(469178, '0049931', NULL, NULL, 152, NULL, 'Acyl-CoA dehydrogenase C-terminal domain-like', 285175),
(469179, '0043101', NULL, NULL, 153, NULL, 'Acyl-CoA dehydrogenase C-terminal domain-like', 285175),
(469180, '0043402', NULL, NULL, 153, NULL, 'Acyl-CoA dehydrogenase C-terminal domain-like', 285175),
(469181, '0039877', NULL, NULL, 366, NULL, 'Glycerol-3-phosphate (1)-acyltransferase', 285176),
(469182, '0042821', NULL, NULL, 102, NULL, 'Guanido kinase N-terminal domain', 285177),
(469183, '0050308', NULL, NULL, 91, NULL, 'Guanido kinase N-terminal domain', 285177),
(469184, '0038818', NULL, NULL, 95, NULL, 'Guanido kinase N-terminal domain', 285177),
(469185, '0036127', NULL, NULL, 98, NULL, 'Guanido kinase N-terminal domain', 285177); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(469186, '0042781', NULL, NULL, 101, NULL, 'Guanido kinase N-terminal domain', 285177),
(469187, '0048060', NULL, NULL, 94, NULL, 'Guanido kinase N-terminal domain', 285177),
(469188, '0045228', NULL, NULL, 95, NULL, 'Guanido kinase N-terminal domain', 285177),
(469189, '0037876', NULL, NULL, 101, NULL, 'Guanido kinase N-terminal domain', 285177),
(469190, '0053828', NULL, NULL, 74, NULL, 'CHY zinc finger-like', 285178),
(469191, '0048394', NULL, NULL, 293, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469192, '0046052', NULL, NULL, 347, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469193, '0050375', NULL, NULL, 216, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469194, '0050295', NULL, NULL, 241, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469195, '0047165', NULL, NULL, 272, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469196, '0052835', NULL, NULL, 290, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469197, '0049183', NULL, NULL, 236, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469198, '0053767', NULL, NULL, 256, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469199, '0046638', NULL, NULL, 291, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469200, '0041422', NULL, NULL, 265, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469201, '0035194', NULL, NULL, 394, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469202, '0051519', NULL, NULL, 318, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469203, '0040152', NULL, NULL, 322, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469204, '0050706', NULL, NULL, 327, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469205, '0046597', NULL, NULL, 353, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469206, '0041426', NULL, NULL, 268, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469207, '0048934', NULL, NULL, 325, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469208, '0046437', NULL, NULL, 342, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469209, '0054444', NULL, NULL, 269, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469210, '0037947', NULL, NULL, 290, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469211, '0049378', NULL, NULL, 311, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469212, '0049994', NULL, NULL, 275, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469213, '0054461', NULL, NULL, 265, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469214, '0035005', NULL, NULL, 324, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469215, '0035444', NULL, NULL, 342, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469216, '0050689', NULL, NULL, 188, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469217, '0053816', NULL, NULL, 188, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469218, '0053636', NULL, NULL, 246, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469219, '0035568', NULL, NULL, 207, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469220, '0035382', NULL, NULL, 331, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469221, '0048309', NULL, NULL, 304, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469222, '0042525', NULL, NULL, 207, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469223, '0039382', NULL, NULL, 281, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469224, '0045676', NULL, NULL, 327, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469225, '0041634', NULL, NULL, 291, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469226, '0042520', NULL, NULL, 266, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469227, '0045899', NULL, NULL, 335, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469228, '0046922', NULL, NULL, 357, NULL, 'Class II aaRS and biotin synthetases', 285179),
(469229, '0038084', NULL, NULL, 98, NULL, 'MurE/MurF N-terminal domain', 285180),
(469230, '0036832', NULL, NULL, 101, NULL, 'MurE/MurF N-terminal domain', 285180);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(469231, '0053542', NULL, NULL, 107, NULL, 'occludin/ELL-like', 285181),
(469232, '0049709', NULL, NULL, 327, NULL, 'Radical SAM enzymes', 285182),
(469233, '0048596', NULL, NULL, 441, NULL, 'Radical SAM enzymes', 285182),
(469234, '0043105', NULL, NULL, 312, NULL, 'Radical SAM enzymes', 285182),
(469235, '0039326', NULL, NULL, 112, NULL, 'Peptidyl-tRNA hydrolase domain-like', 285183),
(469236, '0047486', NULL, NULL, 163, NULL, 'An anticodon-binding domain of class I aminoacyl-tRNA synthetases', 285184),
(469237, '0039170', NULL, NULL, 204, NULL, 'An anticodon-binding domain of class I aminoacyl-tRNA synthetases', 285184),
(469238, '0036512', NULL, NULL, 269, NULL, 'Cryptochrome/photolyase FAD-binding domain', 285185),
(469239, '0044199', NULL, NULL, 300, NULL, 'Cryptochrome/photolyase FAD-binding domain', 285185),
(469240, '0048653', NULL, NULL, 271, NULL, 'Cryptochrome/photolyase FAD-binding domain', 285185),
(469241, '0039138', NULL, NULL, 245, NULL, 'Cryptochrome/photolyase FAD-binding domain', 285185),
(469242, '0041500', NULL, NULL, 279, NULL, 'Cryptochrome/photolyase FAD-binding domain', 285185),
(469243, '0049472', NULL, NULL, 239, NULL, 'Metal cation-transporting ATPase, ATP-binding domain N', 285186),
(469244, '0041020', NULL, NULL, 213, NULL, 'Metal cation-transporting ATPase, ATP-binding domain N', 285186),
(469245, '0051938', NULL, NULL, 113, NULL, 'Metal cation-transporting ATPase, ATP-binding domain N', 285186),
(469246, '0044221', NULL, NULL, 136, NULL, 'Metal cation-transporting ATPase, ATP-binding domain N', 285186),
(469247, '0042598', NULL, NULL, 214, NULL, 'Metal cation-transporting ATPase, ATP-binding domain N', 285186),
(469248, '0051628', NULL, NULL, 139, NULL, 'Bacteriophage trimeric proteins domain', 285187),
(469249, '0051407', NULL, NULL, 166, NULL, 'Bacteriophage trimeric proteins domain', 285187),
(469250, '0051597', NULL, NULL, 218, NULL, 'BB1717-like', 285188),
(469251, '0051959', NULL, NULL, 217, NULL, 'BB1717-like', 285188),
(469252, '0051756', NULL, NULL, 243, NULL, 'BB1717-like', 285188),
(469253, '0052569', NULL, NULL, 231, NULL, 'BB1717-like', 285188),
(469254, '0037550', NULL, NULL, 143, NULL, 'Ribosomal protein L32e', 285189),
(469255, '0049230', NULL, NULL, 107, NULL, 'Tubulin C-terminal domain-like', 285190),
(469256, '0050372', NULL, NULL, 121, NULL, 'Tubulin C-terminal domain-like', 285190),
(469257, '0044121', NULL, NULL, 195, NULL, 'Tubulin C-terminal domain-like', 285190),
(469258, '0044123', NULL, NULL, 184, NULL, 'Tubulin C-terminal domain-like', 285190),
(469259, '0053758', NULL, NULL, 180, NULL, 'Tubulin C-terminal domain-like', 285190),
(469260, '0050369', NULL, NULL, 123, NULL, 'Tubulin C-terminal domain-like', 285190),
(469261, '0048559', NULL, NULL, 109, NULL, 'Tubulin C-terminal domain-like', 285190),
(469262, '0048002', NULL, NULL, 98, NULL, 'YhbY-like', 285191),
(469263, '0049232', NULL, NULL, 96, NULL, 'YhbY-like', 285191),
(469264, '0047641', NULL, NULL, 97, NULL, 'YhbY-like', 285191),
(469265, '0054139', NULL, NULL, 280, NULL, 'Api92-like', 285192),
(469266, '0049043', NULL, NULL, 197, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469267, '0035715', NULL, NULL, 197, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469268, '0047260', NULL, NULL, 168, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469269, '0053341', NULL, NULL, 201, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469270, '0035598', NULL, NULL, 255, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469271, '0036884', NULL, NULL, 177, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469272, '0039592', NULL, NULL, 158, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469273, '0042098', NULL, NULL, 141, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469274, '0035790', NULL, NULL, 165, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469275, '0053382', NULL, NULL, 316, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(469276, '0043540', NULL, NULL, 243, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469277, '0046136', NULL, NULL, 168, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469278, '0048517', NULL, NULL, 579, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469279, '0041006', NULL, NULL, 166, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469280, '0049097', NULL, NULL, 597, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469281, '0038739', NULL, NULL, 162, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469282, '0048880', NULL, NULL, 159, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469283, '0049211', NULL, NULL, 169, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469284, '0045495', NULL, NULL, 546, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469285, '0036710', NULL, NULL, 409, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469286, '0037125', NULL, NULL, 533, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469287, '0035666', NULL, NULL, 174, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469288, '0039943', NULL, NULL, 241, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469289, '0039343', NULL, NULL, 598, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469290, '0037882', NULL, NULL, 167, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469291, '0040001', NULL, NULL, 246, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469292, '0038697', NULL, NULL, 252, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469293, '0035660', NULL, NULL, 301, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469294, '0046509', NULL, NULL, 169, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469295, '0038130', NULL, NULL, 159, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469296, '0038010', NULL, NULL, 242, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469297, '0045818', NULL, NULL, 200, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469298, '0040568', NULL, NULL, 475, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469299, '0046743', NULL, NULL, 172, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469300, '0049785', NULL, NULL, 298, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469301, '0047882', NULL, NULL, 201, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469302, '0048333', NULL, NULL, 202, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469303, '0047285', NULL, NULL, 665, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469304, '0051020', NULL, NULL, 152, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469305, '0036505', NULL, NULL, 696, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469306, '0053887', NULL, NULL, 107, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469307, '0054898', NULL, NULL, 346, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469308, '0047529', NULL, NULL, 237, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469309, '0043847', NULL, NULL, 411, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469310, '0046234', NULL, NULL, 164, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469311, '0048413', NULL, NULL, 317, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469312, '0049107', NULL, NULL, 203, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469313, '0047769', NULL, NULL, 497, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469314, '0053376', NULL, NULL, 168, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469315, '0047530', NULL, NULL, 223, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(469316, '0046088', NULL, NULL, 132, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469317, '0050667', NULL, NULL, 198, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469318, '0054944', NULL, NULL, 113, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469319, '0047333', NULL, NULL, 200, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469320, '0049313', NULL, NULL, 654, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469321, '0049714', NULL, NULL, 150, NULL, 'Metalloproteases ("zincins"), catalytic domain', 285193),
(469322, '0038461', NULL, NULL, 103, NULL, 'Tubulin chaperone cofactor A', 285194),
(469323, '0042971', NULL, NULL, 102, NULL, 'Tubulin chaperone cofactor A', 285194),
(469324, '0049030', NULL, NULL, 450, NULL, 'Bacterial muramidases', 285195),
(469325, '0050035', NULL, NULL, 118, NULL, 'Gamma-glutamyl cyclotransferase-like', 285196),
(469326, '0050970', NULL, NULL, 113, NULL, 'Gamma-glutamyl cyclotransferase-like', 285196),
(469327, '0044830', NULL, NULL, 151, NULL, 'Gamma-glutamyl cyclotransferase-like', 285196),
(469328, '0040672', NULL, NULL, 71, NULL, 'beta-catenin-interacting protein ICAT', 285197),
(469329, '0040729', NULL, NULL, 70, NULL, 'beta-catenin-interacting protein ICAT', 285197),
(469330, '0050681', NULL, NULL, 336, NULL, 'Isocitrate/Isopropylmalate dehydrogenase-like', 285198),
(469331, '0050255', NULL, NULL, 329, NULL, 'Isocitrate/Isopropylmalate dehydrogenase-like', 285198),
(469332, '0047222', NULL, NULL, 423, NULL, 'Isocitrate/Isopropylmalate dehydrogenase-like', 285198),
(469333, '0049112', NULL, NULL, 329, NULL, 'Isocitrate/Isopropylmalate dehydrogenase-like', 285198),
(469334, '0046187', NULL, NULL, 363, NULL, 'Isocitrate/Isopropylmalate dehydrogenase-like', 285198),
(469335, '0043174', NULL, NULL, 327, NULL, 'Isocitrate/Isopropylmalate dehydrogenase-like', 285198),
(469336, '0051856', NULL, NULL, 356, NULL, 'Isocitrate/Isopropylmalate dehydrogenase-like', 285198),
(469337, '0050238', NULL, NULL, 362, NULL, 'Isocitrate/Isopropylmalate dehydrogenase-like', 285198),
(469338, '0050920', NULL, NULL, 324, NULL, 'Isocitrate/Isopropylmalate dehydrogenase-like', 285198),
(469339, '0050329', NULL, NULL, 337, NULL, 'Isocitrate/Isopropylmalate dehydrogenase-like', 285198),
(469340, '0050895', NULL, NULL, 345, NULL, 'Isocitrate/Isopropylmalate dehydrogenase-like', 285198),
(469341, '0049072', NULL, NULL, 332, NULL, 'Isocitrate/Isopropylmalate dehydrogenase-like', 285198),
(469342, '0050896', NULL, NULL, 345, NULL, 'Isocitrate/Isopropylmalate dehydrogenase-like', 285198),
(469343, '0049509', NULL, NULL, 414, NULL, 'Isocitrate/Isopropylmalate dehydrogenase-like', 285198),
(469344, '0048816', NULL, NULL, 329, NULL, 'Isocitrate/Isopropylmalate dehydrogenase-like', 285198),
(469345, '0046179', NULL, NULL, 363, NULL, 'Isocitrate/Isopropylmalate dehydrogenase-like', 285198),
(469346, '0039193', NULL, NULL, 740, NULL, 'Isocitrate/Isopropylmalate dehydrogenase-like', 285198),
(469347, '0050190', NULL, NULL, 334, NULL, 'Isocitrate/Isopropylmalate dehydrogenase-like', 285198),
(469348, '0045683', NULL, NULL, 357, NULL, 'Isocitrate/Isopropylmalate dehydrogenase-like', 285198),
(469349, '0040698', NULL, NULL, 413, NULL, 'Isocitrate/Isopropylmalate dehydrogenase-like', 285198),
(469350, '0049813', NULL, NULL, 329, NULL, 'Isocitrate/Isopropylmalate dehydrogenase-like', 285198),
(469351, '0048724', NULL, NULL, 416, NULL, 'Isocitrate/Isopropylmalate dehydrogenase-like', 285198),
(469352, '0035935', NULL, NULL, 54, NULL, 'Plant proteinase inhibitors', 285199),
(469353, '0045605', NULL, NULL, 51, NULL, 'Plant proteinase inhibitors', 285199),
(469354, '0042086', NULL, NULL, 116, NULL, 'Plant proteinase inhibitors', 285199),
(469355, '0037844', NULL, NULL, 55, NULL, 'Plant proteinase inhibitors', 285199),
(469356, '0037845', NULL, NULL, 56, NULL, 'Plant proteinase inhibitors', 285199),
(469357, '0042780', NULL, NULL, 47, NULL, 'Plant proteinase inhibitors', 285199),
(469358, '0042346', NULL, NULL, 57, NULL, 'Plant proteinase inhibitors', 285199);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(469359, '0054455', NULL, NULL, 153, NULL, 'Gam-like', 285200),
(469360, '0053920', NULL, NULL, 116, NULL, 'ENT-like', 285201),
(469361, '0048096', NULL, NULL, 174, NULL, 'Triger factor/SurA peptide-binding domain-like', 285202),
(469362, '0050344', NULL, NULL, 185, NULL, 'Triger factor/SurA peptide-binding domain-like', 285202),
(469363, '0043830', NULL, NULL, 129, NULL, 'Triger factor/SurA peptide-binding domain-like', 285202),
(469364, '0041453', NULL, NULL, 104, NULL, 'Group V grass pollen allergen', 285203),
(469365, '0040372', NULL, NULL, 102, NULL, 'Group V grass pollen allergen', 285203),
(469366, '0054258', NULL, NULL, 108, NULL, 'BC4932-like', 285204),
(469367, '0054257', NULL, NULL, 96, NULL, 'BC4932-like', 285204),
(469368, '0046277', NULL, NULL, 186, NULL, 'CBD9-like', 285205),
(469369, '0049898', NULL, NULL, 245, NULL, 'CBD9-like', 285205),
(469370, '0047326', NULL, NULL, 189, NULL, 'CBD9-like', 285205),
(469371, '0054477', NULL, NULL, 133, NULL, 'YopX-like', 285206),
(469372, '0054429', NULL, NULL, 143, NULL, 'YopX-like', 285206),
(469373, '0054082', NULL, NULL, 134, NULL, 'YopX-like', 285206),
(469374, '0048576', NULL, NULL, 24, NULL, 'DPY module', 285207),
(469375, '0052540', NULL, NULL, 128, NULL, 'MOSC N-terminal domain-like', 285208),
(469376, '0053652', NULL, NULL, 228, NULL, 'Proteasome activator', 285209),
(469377, '0035229', NULL, NULL, 201, NULL, 'Proteasome activator', 285209),
(469378, '0048509', NULL, NULL, 96, NULL, 'Families 57/38 glycoside transferase middle domain', 285210),
(469379, '0051909', NULL, NULL, 114, NULL, 'Families 57/38 glycoside transferase middle domain', 285210),
(469380, '0039849', NULL, NULL, 74, NULL, 'Families 57/38 glycoside transferase middle domain', 285210),
(469381, '0044322', NULL, NULL, 105, NULL, 'Families 57/38 glycoside transferase middle domain', 285210),
(469382, '0047239', NULL, NULL, 111, NULL, 'Families 57/38 glycoside transferase middle domain', 285210),
(469383, '0040283', NULL, NULL, 141, NULL, 'Yeast killer toxins', 285211),
(469384, '0040202', NULL, NULL, 105, NULL, 'Yeast killer toxins', 285211),
(469385, '0051346', NULL, NULL, 100, NULL, 'GK1464-like', 285212),
(469386, '0049021', NULL, NULL, 35, NULL, 'Methionyl-tRNA synthetase (MetRS), Zn-domain', 285213),
(469387, '0048145', NULL, NULL, 28, NULL, 'Methionyl-tRNA synthetase (MetRS), Zn-domain', 285213),
(469388, '0049234', NULL, NULL, 35, NULL, 'Methionyl-tRNA synthetase (MetRS), Zn-domain', 285213),
(469389, '0051809', NULL, NULL, 149, NULL, 'PG0816-like', 285214),
(469390, '0051079', NULL, NULL, 52, NULL, 'Light-harvesting complex subunits', 285215),
(469391, '0040493', NULL, NULL, 43, NULL, 'Light-harvesting complex subunits', 285215),
(469392, '0040492', NULL, NULL, 56, NULL, 'Light-harvesting complex subunits', 285215),
(469393, '0039052', NULL, NULL, 40, NULL, 'Light-harvesting complex subunits', 285215),
(469394, '0039051', NULL, NULL, 46, NULL, 'Light-harvesting complex subunits', 285215),
(469395, '0040337', NULL, NULL, 41, NULL, 'Light-harvesting complex subunits', 285215),
(469396, '0036645', NULL, NULL, 48, NULL, 'Light-harvesting complex subunits', 285215),
(469397, '0041445', NULL, NULL, 53, NULL, 'Light-harvesting complex subunits', 285215),
(469398, '0052651', NULL, NULL, 114, NULL, 'Toprim domain', 285216),
(469399, '0043902', NULL, NULL, 108, NULL, 'Toprim domain', 285216),
(469400, '0041761', NULL, NULL, 86, NULL, 'Copper amine oxidase, domain N', 285217),
(469401, '0047913', NULL, NULL, 129, NULL, 'Major surface antigen p30, SAG1', 285218),
(469402, '0040336', NULL, NULL, 124, NULL, 'Major surface antigen p30, SAG1', 285218),
(469403, '0050145', NULL, NULL, 62, NULL, 'Zinc beta-ribbon', 285219),
(469404, '0049068', NULL, NULL, 57, NULL, 'Zinc beta-ribbon', 285219),
(469405, '0050588', NULL, NULL, 85, NULL, 'Zinc beta-ribbon', 285219),
(469406, '0051787', NULL, NULL, 38, NULL, 'Zinc beta-ribbon', 285219),
(469407, '0045108', NULL, NULL, 57, NULL, 'Zinc beta-ribbon', 285219),
(469408, '0041574', NULL, NULL, 54, NULL, 'Zinc beta-ribbon', 285219);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(469409, '0048749', NULL, NULL, 50, NULL, 'Zinc beta-ribbon', 285219),
(469410, '0046355', NULL, NULL, 58, NULL, 'Zinc beta-ribbon', 285219),
(469411, '0049613', NULL, NULL, 50, NULL, 'Zinc beta-ribbon', 285219),
(469412, '0046246', NULL, NULL, 102, NULL, 'Zinc beta-ribbon', 285219),
(469413, '0047306', NULL, NULL, 73, NULL, 'Zinc beta-ribbon', 285219),
(469414, '0045107', NULL, NULL, 65, NULL, 'Zinc beta-ribbon', 285219),
(469415, '0047305', NULL, NULL, 49, NULL, 'Zinc beta-ribbon', 285219),
(469416, '0036064', NULL, NULL, 85, NULL, 'DLC', 285220),
(469417, '0043208', NULL, NULL, 94, NULL, 'DLC', 285220),
(469418, '0053565', NULL, NULL, 51, NULL, 'Heterotrimerisation domain of extracellular hemoglobin linker subunits', 285221),
(469419, '0053566', NULL, NULL, 51, NULL, 'Heterotrimerisation domain of extracellular hemoglobin linker subunits', 285221),
(469420, '0053567', NULL, NULL, 52, NULL, 'Heterotrimerisation domain of extracellular hemoglobin linker subunits', 285221),
(469421, '0046146', NULL, NULL, 89, NULL, 'Barrier-to-autointegration factor, BAF', 285222),
(469422, '0054654', NULL, NULL, 99, NULL, 'PreATP-grasp domain', 285223),
(469423, '0050232', NULL, NULL, 90, NULL, 'PreATP-grasp domain', 285223),
(469424, '0053014', NULL, NULL, 102, NULL, 'PreATP-grasp domain', 285223),
(469425, '0054652', NULL, NULL, 123, NULL, 'PreATP-grasp domain', 285223),
(469426, '0047321', NULL, NULL, 102, NULL, 'PreATP-grasp domain', 285223),
(469427, '0048058', NULL, NULL, 108, NULL, 'PreATP-grasp domain', 285223),
(469428, '0046561', NULL, NULL, 132, NULL, 'PreATP-grasp domain', 285223),
(469429, '0053120', NULL, NULL, 118, NULL, 'PreATP-grasp domain', 285223),
(469430, '0054494', NULL, NULL, 96, NULL, 'PreATP-grasp domain', 285223),
(469431, '0037275', NULL, NULL, 111, NULL, 'PreATP-grasp domain', 285223),
(469432, '0045749', NULL, NULL, 127, NULL, 'PreATP-grasp domain', 285223),
(469433, '0045826', NULL, NULL, 102, NULL, 'PreATP-grasp domain', 285223),
(469434, '0047407', NULL, NULL, 96, NULL, 'PreATP-grasp domain', 285223),
(469435, '0050407', NULL, NULL, 170, NULL, 'PreATP-grasp domain', 285223),
(469436, '0045750', NULL, NULL, 121, NULL, 'PreATP-grasp domain', 285223),
(469437, '0047049', NULL, NULL, 105, NULL, 'PreATP-grasp domain', 285223),
(469438, '0046456', NULL, NULL, 130, NULL, 'PreATP-grasp domain', 285223),
(469439, '0047047', NULL, NULL, 122, NULL, 'PreATP-grasp domain', 285223),
(469440, '0046403', NULL, NULL, 114, NULL, 'PreATP-grasp domain', 285223),
(469441, '0049858', NULL, NULL, 88, NULL, 'PreATP-grasp domain', 285223),
(469442, '0049945', NULL, NULL, 114, NULL, 'PreATP-grasp domain', 285223),
(469443, '0045887', NULL, NULL, 78, NULL, 'PreATP-grasp domain', 285223),
(469444, '0047002', NULL, NULL, 120, NULL, 'Transthyretin (synonym: prealbumin)', 285224),
(469445, '0049687', NULL, NULL, 127, NULL, 'Transthyretin (synonym: prealbumin)', 285224),
(469446, '0048613', NULL, NULL, 116, NULL, 'Transthyretin (synonym: prealbumin)', 285224),
(469447, '0049615', NULL, NULL, 114, NULL, 'Transthyretin (synonym: prealbumin)', 285224),
(469448, '0053200', NULL, NULL, 100, NULL, 'ERH-like', 285225),
(469449, '0044093', NULL, NULL, 216, NULL, 'Thiolase-like', 285226),
(469450, '0044094', NULL, NULL, 205, NULL, 'Thiolase-like', 285226),
(469451, '0044095', NULL, NULL, 208, NULL, 'Thiolase-like', 285226),
(469452, '0049763', NULL, NULL, 156, NULL, 'Thiolase-like', 285226),
(469453, '0052890', NULL, NULL, 250, NULL, 'Thiolase-like', 285226),
(469454, '0049762', NULL, NULL, 233, NULL, 'Thiolase-like', 285226),
(469455, '0052891', NULL, NULL, 161, NULL, 'Thiolase-like', 285226),
(469456, '0039354', NULL, NULL, 159, NULL, 'Thiolase-like', 285226),
(469457, '0047209', NULL, NULL, 174, NULL, 'Thiolase-like', 285226),
(469458, '0036365', NULL, NULL, 153, NULL, 'Thiolase-like', 285226),
(469459, '0036783', NULL, NULL, 161, NULL, 'Thiolase-like', 285226),
(469460, '0035033', NULL, NULL, 124, NULL, 'Thiolase-like', 285226),
(469461, '0036364', NULL, NULL, 253, NULL, 'Thiolase-like', 285226),
(469462, '0036782', NULL, NULL, 250, NULL, 'Thiolase-like', 285226);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(469463, '0035032', NULL, NULL, 269, NULL, 'Thiolase-like', 285226),
(469464, '0039353', NULL, NULL, 249, NULL, 'Thiolase-like', 285226),
(469465, '0049764', NULL, NULL, 225, NULL, 'Thiolase-like', 285226),
(469466, '0044256', NULL, NULL, 172, NULL, 'Thiolase-like', 285226),
(469467, '0049940', NULL, NULL, 125, NULL, 'Thiolase-like', 285226),
(469468, '0044257', NULL, NULL, 149, NULL, 'Thiolase-like', 285226),
(469469, '0049604', NULL, NULL, 372, NULL, 'Thiolase-like', 285226),
(469470, '0044181', NULL, NULL, 200, NULL, 'Thiolase-like', 285226),
(469471, '0053134', NULL, NULL, 270, NULL, 'Thiolase-like', 285226),
(469472, '0044182', NULL, NULL, 148, NULL, 'Thiolase-like', 285226),
(469473, '0053135', NULL, NULL, 161, NULL, 'Thiolase-like', 285226),
(469474, '0047210', NULL, NULL, 143, NULL, 'Thiolase-like', 285226),
(469475, '0036930', NULL, NULL, 216, NULL, 'Thiolase-like', 285226),
(469476, '0038812', NULL, NULL, 184, NULL, 'Thiolase-like', 285226),
(469477, '0042063', NULL, NULL, 158, NULL, 'Thiolase-like', 285226),
(469478, '0038813', NULL, NULL, 148, NULL, 'Thiolase-like', 285226),
(469479, '0042062', NULL, NULL, 256, NULL, 'Thiolase-like', 285226),
(469480, '0035564', NULL, NULL, 154, NULL, 'Thiolase-like', 285226),
(469481, '0035563', NULL, NULL, 235, NULL, 'Thiolase-like', 285226),
(469482, '0036931', NULL, NULL, 160, NULL, 'Thiolase-like', 285226),
(469483, '0050445', NULL, NULL, 262, NULL, 'Thiolase-like', 285226),
(469484, '0049939', NULL, NULL, 273, NULL, 'Thiolase-like', 285226),
(469485, '0042745', NULL, NULL, 124, NULL, 'Thiolase-like', 285226),
(469486, '0049718', NULL, NULL, 221, NULL, 'Thiolase-like', 285226),
(469487, '0049717', NULL, NULL, 166, NULL, 'Thiolase-like', 285226),
(469488, '0041154', NULL, NULL, 153, NULL, 'Thiolase-like', 285226),
(469489, '0041153', NULL, NULL, 181, NULL, 'Thiolase-like', 285226),
(469490, '0049676', NULL, NULL, 194, NULL, 'Thiolase-like', 285226),
(469491, '0044962', NULL, NULL, 128, NULL, 'Thiolase-like', 285226),
(469492, '0048944', NULL, NULL, 265, NULL, 'Thiolase-like', 285226),
(469493, '0048729', NULL, NULL, 68, NULL, 'Bowman-Birk inhibitor, BBI', 285227),
(469494, '0049581', NULL, NULL, 62, NULL, 'Bowman-Birk inhibitor, BBI', 285227),
(469495, '0054641', NULL, NULL, 57, NULL, 'Bowman-Birk inhibitor, BBI', 285227),
(469496, '0047111', NULL, NULL, 57, NULL, 'Bowman-Birk inhibitor, BBI', 285227),
(469497, '0048233', NULL, NULL, 62, NULL, 'Bowman-Birk inhibitor, BBI', 285227),
(469498, '0046067', NULL, NULL, 59, NULL, 'Bowman-Birk inhibitor, BBI', 285227),
(469499, '0046320', NULL, NULL, 72, NULL, 'Bowman-Birk inhibitor, BBI', 285227),
(469500, '0053938', NULL, NULL, 56, NULL, 'Bowman-Birk inhibitor, BBI', 285227),
(469501, '0046066', NULL, NULL, 61, NULL, 'Bowman-Birk inhibitor, BBI', 285227),
(469502, '0048766', NULL, NULL, 61, NULL, 'Bowman-Birk inhibitor, BBI', 285227),
(469503, '0051950', NULL, NULL, 71, NULL, 'Bowman-Birk inhibitor, BBI', 285227),
(469504, '0046020', NULL, NULL, 56, NULL, 'DNA helicase RuvA subunit, C-terminal domain', 285228),
(469505, '0047467', NULL, NULL, 50, NULL, 'DNA helicase RuvA subunit, C-terminal domain', 285228),
(469506, '0046216', NULL, NULL, 48, NULL, 'DNA helicase RuvA subunit, C-terminal domain', 285228),
(469507, '0049791', NULL, NULL, 157, NULL, 'ArfGap/RecO-like zinc finger', 285229),
(469508, '0036355', NULL, NULL, 122, NULL, 'ArfGap/RecO-like zinc finger', 285229),
(469509, '0049182', NULL, NULL, 221, NULL, 'Putative anticodon-binding domain of alanyl-tRNA synthetase (AlaRS)', 285230),
(469510, '0048570', NULL, NULL, 172, NULL, 'Bcl-2 inhibitors of programmed cell death', 285231),
(469511, '0051740', NULL, NULL, 131, NULL, 'Bcl-2 inhibitors of programmed cell death', 285231),
(469512, '0048173', NULL, NULL, 178, NULL, 'Bcl-2 inhibitors of programmed cell death', 285231),
(469513, '0053168', NULL, NULL, 162, NULL, 'Bcl-2 inhibitors of programmed cell death', 285231),
(469514, '0051392', NULL, NULL, 173, NULL, 'Bcl-2 inhibitors of programmed cell death', 285231),
(469515, '0036367', NULL, NULL, 195, NULL, 'Bcl-2 inhibitors of programmed cell death', 285231);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(469516, '0045190', NULL, NULL, 197, NULL, 'Bcl-2 inhibitors of programmed cell death', 285231),
(469517, '0037326', NULL, NULL, 192, NULL, 'Bcl-2 inhibitors of programmed cell death', 285231),
(469518, '0046925', NULL, NULL, 164, NULL, 'Bcl-2 inhibitors of programmed cell death', 285231),
(469519, '0039890', NULL, NULL, 146, NULL, 'Bcl-2 inhibitors of programmed cell death', 285231),
(469520, '0048479', NULL, NULL, 188, NULL, 'Bcl-2 inhibitors of programmed cell death', 285231),
(469521, '0046035', NULL, NULL, 221, NULL, 'Bcl-2 inhibitors of programmed cell death', 285231),
(469522, '0042620', NULL, NULL, 172, NULL, 'Bcl-2 inhibitors of programmed cell death', 285231),
(469523, '0044041', NULL, NULL, 189, NULL, 'SSo0622-like', 285232),
(469524, '0054589', NULL, NULL, 100, NULL, 'Ribosomal protein S6', 285233),
(469525, '0054199', NULL, NULL, 106, NULL, 'Ribosomal protein S6', 285233),
(469526, '0050251', NULL, NULL, 107, NULL, 'Ribosomal protein S6', 285233),
(469527, '0046201', NULL, NULL, 98, NULL, 'Ribosomal protein S6', 285233),
(469528, '0049114', NULL, NULL, 132, NULL, 'Connexin43', 285234),
(469529, '0044404', NULL, NULL, 111, NULL, 'BAG domain', 285235),
(469530, '0047251', NULL, NULL, 112, NULL, 'BAG domain', 285235),
(469531, '0049563', NULL, NULL, 129, NULL, 'BAG domain', 285235),
(469532, '0048100', NULL, NULL, 87, NULL, 'BAG domain', 285235),
(469533, '0044355', NULL, NULL, 99, NULL, 'BAG domain', 285235),
(469534, '0047318', NULL, NULL, 135, NULL, 'BAG domain', 285235),
(469535, '0035173', NULL, NULL, 85, NULL, 'Epsilon subunit of F1F0-ATP synthase N-terminal domain', 285236),
(469536, '0036818', NULL, NULL, 86, NULL, 'Epsilon subunit of F1F0-ATP synthase N-terminal domain', 285236),
(469537, '0052769', NULL, NULL, 84, NULL, 'Nqo1 middle domain-like', 285237),
(469538, '0043316', NULL, NULL, 210, NULL, 'Prim-pol domain', 285238),
(469539, '0037965', NULL, NULL, 344, NULL, 'Prim-pol domain', 285238),
(469540, '0051636', NULL, NULL, 327, NULL, 'Prim-pol domain', 285238),
(469541, '0051833', NULL, NULL, 176, NULL, 'Prim-pol domain', 285238),
(469542, '0044601', NULL, NULL, 346, NULL, 'Prim-pol domain', 285238),
(469543, '0039346', NULL, NULL, 210, NULL, 'PEP carboxykinase N-terminal domain', 285239),
(469544, '0039037', NULL, NULL, 199, NULL, 'PEP carboxykinase N-terminal domain', 285239),
(469545, '0053254', NULL, NULL, 222, NULL, 'PEP carboxykinase N-terminal domain', 285239),
(469546, '0040081', NULL, NULL, 250, NULL, 'PEP carboxykinase N-terminal domain', 285239),
(469547, '0051373', NULL, NULL, 182, NULL, 'Mitochondrial glycoprotein MAM33-like', 285240),
(469548, '0042130', NULL, NULL, 209, NULL, 'Mitochondrial glycoprotein MAM33-like', 285240),
(469549, '0036819', NULL, NULL, 47, NULL, 'Epsilon subunit of mitochondrial F1F0-ATP synthase', 285241),
(469550, '0046197', NULL, NULL, 68, NULL, 'HMA, heavy metal-associated domain', 285242),
(469551, '0049356', NULL, NULL, 64, NULL, 'HMA, heavy metal-associated domain', 285242),
(469552, '0049047', NULL, NULL, 72, NULL, 'HMA, heavy metal-associated domain', 285242),
(469553, '0047891', NULL, NULL, 79, NULL, 'HMA, heavy metal-associated domain', 285242),
(469554, '0045769', NULL, NULL, 72, NULL, 'HMA, heavy metal-associated domain', 285242),
(469555, '0046759', NULL, NULL, 66, NULL, 'HMA, heavy metal-associated domain', 285242),
(469556, '0047718', NULL, NULL, 73, NULL, 'HMA, heavy metal-associated domain', 285242),
(469557, '0048906', NULL, NULL, 84, NULL, 'HMA, heavy metal-associated domain', 285242),
(469558, '0048621', NULL, NULL, 76, NULL, 'HMA, heavy metal-associated domain', 285242),
(469559, '0048637', NULL, NULL, 72, NULL, 'HMA, heavy metal-associated domain', 285242),
(469560, '0046867', NULL, NULL, 72, NULL, 'HMA, heavy metal-associated domain', 285242),
(469561, '0047700', NULL, NULL, 80, NULL, 'HMA, heavy metal-associated domain', 285242),
(469562, '0048239', NULL, NULL, 73, NULL, 'HMA, heavy metal-associated domain', 285242),
(469563, '0045832', NULL, NULL, 72, NULL, 'HMA, heavy metal-associated domain', 285242),
(469564, '0046107', NULL, NULL, 72, NULL, 'HMA, heavy metal-associated domain', 285242);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(469565, '0051360', NULL, NULL, 426, NULL, 'Activating enzymes of the ubiquitin-like proteins', 285243),
(469566, '0047696', NULL, NULL, 247, NULL, 'Activating enzymes of the ubiquitin-like proteins', 285243),
(469567, '0051359', NULL, NULL, 529, NULL, 'Activating enzymes of the ubiquitin-like proteins', 285243),
(469568, '0043232', NULL, NULL, 303, NULL, 'Cloacin translocation domain', 285244),
(469569, '0039480', NULL, NULL, 232, NULL, 'Cloacin translocation domain', 285244),
(469570, '0048095', NULL, NULL, 161, NULL, 'Homing endonucleases', 285245),
(469571, '0035313', NULL, NULL, 80, NULL, 'Homing endonucleases', 285245),
(469572, '0035312', NULL, NULL, 93, NULL, 'Homing endonucleases', 285245),
(469573, '0042194', NULL, NULL, 125, NULL, 'Homing endonucleases', 285245),
(469574, '0035652', NULL, NULL, 152, NULL, 'Homing endonucleases', 285245),
(469575, '0036553', NULL, NULL, 109, NULL, 'Homing endonucleases', 285245),
(469576, '0036398', NULL, NULL, 117, NULL, 'Homing endonucleases', 285245),
(469577, '0036552', NULL, NULL, 98, NULL, 'Homing endonucleases', 285245),
(469578, '0036397', NULL, NULL, 118, NULL, 'Homing endonucleases', 285245),
(469579, '0041030', NULL, NULL, 153, NULL, 'Homing endonucleases', 285245),
(469580, '0049127', NULL, NULL, 205, NULL, 'Homing endonucleases', 285245),
(469581, '0049126', NULL, NULL, 118, NULL, 'Homing endonucleases', 285245),
(469582, '0048712', NULL, NULL, 129, NULL, 'Homing endonucleases', 285245),
(469583, '0044461', NULL, NULL, 35, NULL, 'VHP, Villin headpiece domain', 285246),
(469584, '0042949', NULL, NULL, 67, NULL, 'VHP, Villin headpiece domain', 285246),
(469585, '0044396', NULL, NULL, 88, NULL, 'VHP, Villin headpiece domain', 285246),
(469586, '0044462', NULL, NULL, 36, NULL, 'VHP, Villin headpiece domain', 285246),
(469587, '0043056', NULL, NULL, 68, NULL, 'VHP, Villin headpiece domain', 285246),
(469588, '0043251', NULL, NULL, 65, NULL, 'Preprotein translocase SecE subunit', 285247),
(469589, '0037983', NULL, NULL, 98, NULL, 'Flagellar transcriptional activator FlhD', 285248),
(469590, '0047814', NULL, NULL, 193, NULL, 'GroEL apical domain-like', 285249),
(469591, '0045814', NULL, NULL, 152, NULL, 'GroEL apical domain-like', 285249),
(469592, '0047016', NULL, NULL, 168, NULL, 'GroEL apical domain-like', 285249),
(469593, '0049414', NULL, NULL, 184, NULL, 'GroEL apical domain-like', 285249),
(469594, '0050458', NULL, NULL, 184, NULL, 'GroEL apical domain-like', 285249),
(469595, '0048884', NULL, NULL, 153, NULL, 'GroEL apical domain-like', 285249),
(469596, '0047405', NULL, NULL, 176, NULL, 'GroEL apical domain-like', 285249),
(469597, '0045723', NULL, NULL, 152, NULL, 'GroEL apical domain-like', 285249),
(469598, '0037220', NULL, NULL, 479, NULL, 'Alkaline phosphatase-like', 285250),
(469599, '0042147', NULL, NULL, 553, NULL, 'Alkaline phosphatase-like', 285250),
(469600, '0047177', NULL, NULL, 525, NULL, 'Alkaline phosphatase-like', 285250),
(469601, '0037019', NULL, NULL, 406, NULL, 'Alkaline phosphatase-like', 285250),
(469602, '0053063', NULL, NULL, 284, NULL, 'Alkaline phosphatase-like', 285250),
(469603, '0046522', NULL, NULL, 449, NULL, 'Alkaline phosphatase-like', 285250),
(469604, '0035207', NULL, NULL, 485, NULL, 'Alkaline phosphatase-like', 285250),
(469605, '0037136', NULL, NULL, 275, NULL, 'Alkaline phosphatase-like', 285250),
(469606, '0037763', NULL, NULL, 492, NULL, 'Alkaline phosphatase-like', 285250),
(469607, '0039941', NULL, NULL, 476, NULL, 'Alkaline phosphatase-like', 285250),
(469608, '0052776', NULL, NULL, 196, NULL, 'Nqo5-like', 285251),
(469609, '0053035', NULL, NULL, 176, NULL, 'Heme iron utilization protein-like', 285252),
(469610, '0053145', NULL, NULL, 338, NULL, 'Heme iron utilization protein-like', 285252),
(469611, '0053032', NULL, NULL, 337, NULL, 'Heme iron utilization protein-like', 285252),
(469612, '0052169', NULL, NULL, 122, NULL, 'beta-N-acetylhexosaminidase-like domain', 285253),
(469613, '0038663', NULL, NULL, 143, NULL, 'beta-N-acetylhexosaminidase-like domain', 285253),
(469614, '0052140', NULL, NULL, 138, NULL, 'beta-N-acetylhexosaminidase-like domain', 285253);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(469615, '0053949', NULL, NULL, 144, NULL, 'beta-N-acetylhexosaminidase-like domain', 285253),
(469616, '0038229', NULL, NULL, 147, NULL, 'beta-N-acetylhexosaminidase-like domain', 285253),
(469617, '0047767', NULL, NULL, 138, NULL, 'beta-N-acetylhexosaminidase-like domain', 285253),
(469618, '0048405', NULL, NULL, 145, NULL, 'beta-N-acetylhexosaminidase-like domain', 285253),
(469619, '0042698', NULL, NULL, 137, NULL, 'beta-N-acetylhexosaminidase-like domain', 285253),
(469620, '0054591', NULL, NULL, 98, NULL, 'Ribosomal protein S10', 285254),
(469621, '0046798', NULL, NULL, 98, NULL, 'Ribosomal protein S10', 285254),
(469622, '0041248', NULL, NULL, 328, NULL, 'Baseplate structural protein gp8', 285255),
(469623, '0048321', NULL, NULL, 165, NULL, 'Swiveling domain of dehydratase reactivase alpha subunit', 285256),
(469624, '0052358', NULL, NULL, 162, NULL, 'Swiveling domain of dehydratase reactivase alpha subunit', 285256),
(469625, '0051187', NULL, NULL, 109, NULL, 'YbjQ-like', 285257),
(469626, '0050298', NULL, NULL, 103, NULL, 'YbjQ-like', 285257),
(469627, '0054053', NULL, NULL, 126, NULL, 'NosL/MerB-like', 285258),
(469628, '0053604', NULL, NULL, 132, NULL, 'NosL/MerB-like', 285258),
(469629, '0053473', NULL, NULL, 76, NULL, 'Apolipoprotein A-II', 285259),
(469630, '0039251', NULL, NULL, 177, NULL, 'Prokaryotic lipoproteins and lipoprotein localization factors', 285260),
(469631, '0039250', NULL, NULL, 182, NULL, 'Prokaryotic lipoproteins and lipoprotein localization factors', 285260),
(469632, '0052080', NULL, NULL, 188, NULL, 'Prokaryotic lipoproteins and lipoprotein localization factors', 285260),
(469633, '0054382', NULL, NULL, 122, NULL, 'PG0775 C-terminal domain-like', 285261),
(469634, '0051108', NULL, NULL, 80, NULL, 'Variant surface glycoprotein MITAT 1.2, VSG 221, C-terminal domain', 285262),
(469635, '0052653', NULL, NULL, 157, NULL, 'Nucleotidyltransferase', 285263),
(469636, '0051344', NULL, NULL, 90, NULL, 'Nucleotidyltransferase', 285263),
(469637, '0051960', NULL, NULL, 203, NULL, 'Nucleotidyltransferase', 285263),
(469638, '0054333', NULL, NULL, 113, NULL, 'Nucleotidyltransferase', 285263),
(469639, '0039639', NULL, NULL, 208, NULL, 'Nucleotidyltransferase', 285263),
(469640, '0035658', NULL, NULL, 187, NULL, 'Nucleotidyltransferase', 285263),
(469641, '0044735', NULL, NULL, 136, NULL, 'Nucleotidyltransferase', 285263),
(469642, '0039654', NULL, NULL, 187, NULL, 'Nucleotidyltransferase', 285263),
(469643, '0048838', NULL, NULL, 200, NULL, 'Nucleotidyltransferase', 285263),
(469644, '0037394', NULL, NULL, 195, NULL, 'Nucleotidyltransferase', 285263),
(469645, '0041481', NULL, NULL, 100, NULL, 'Nucleotidyltransferase', 285263),
(469646, '0042031', NULL, NULL, 152, NULL, 'Nucleotidyltransferase', 285263),
(469647, '0040957', NULL, NULL, 139, NULL, 'Nucleotidyltransferase', 285263),
(469648, '0047842', NULL, NULL, 125, NULL, 'Nucleotidyltransferase', 285263),
(469649, '0054492', NULL, NULL, 135, NULL, 'Nucleotidyltransferase', 285263),
(469650, '0045003', NULL, NULL, 98, NULL, 'Nucleotidyltransferase', 285263),
(469651, '0054293', NULL, NULL, 167, NULL, 'Nucleotidyltransferase', 285263),
(469652, '0043168', NULL, NULL, 142, NULL, 'Nucleotidyltransferase', 285263),
(469653, '0044611', NULL, NULL, 285, NULL, 'Nucleotidyltransferase', 285263),
(469654, '0044799', NULL, NULL, 175, NULL, 'Nucleotidyltransferase', 285263),
(469655, '0054128', NULL, NULL, 120, NULL, 'Nucleotidyltransferase', 285263),
(469656, '0037463', NULL, NULL, 199, NULL, 'Nucleotidyltransferase', 285263),
(469657, '0039444', NULL, NULL, 174, NULL, 'Nucleotidyltransferase', 285263),
(469658, '0051904', NULL, NULL, 259, NULL, 'Nucleotidyltransferase', 285263),
(469659, '0043451', NULL, NULL, 190, NULL, 'Nucleotidyltransferase', 285263),
(469660, '0036077', NULL, NULL, 42, NULL, 'Zinc domain conserved in yeast copper-regulated transcription factors', 285264),
(469661, '0049583', NULL, NULL, 68, NULL, 'Histone-fold', 285265),
(469662, '0052078', NULL, NULL, 72, NULL, 'Histone-fold', 285265),
(469663, '0052079', NULL, NULL, 89, NULL, 'Histone-fold', 285265);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(469664, '0049584', NULL, NULL, 70, NULL, 'Histone-fold', 285265),
(469665, '0037139', NULL, NULL, 125, NULL, 'Histone-fold', 285265),
(469666, '0038404', NULL, NULL, 50, NULL, 'Histone-fold', 285265),
(469667, '0047904', NULL, NULL, 122, NULL, 'Histone-fold', 285265),
(469668, '0037410', NULL, NULL, 103, NULL, 'Histone-fold', 285265),
(469669, '0047903', NULL, NULL, 102, NULL, 'Histone-fold', 285265),
(469670, '0035550', NULL, NULL, 89, NULL, 'Histone-fold', 285265),
(469671, '0050728', NULL, NULL, 148, NULL, 'Histone-fold', 285265),
(469672, '0043120', NULL, NULL, 151, NULL, 'Histone-fold', 285265),
(469673, '0046611', NULL, NULL, 108, NULL, 'Histone-fold', 285265),
(469674, '0047348', NULL, NULL, 97, NULL, 'Histone-fold', 285265),
(469675, '0042675', NULL, NULL, 172, NULL, 'Histone-fold', 285265),
(469676, '0047349', NULL, NULL, 93, NULL, 'Histone-fold', 285265),
(469677, '0035549', NULL, NULL, 45, NULL, 'Histone-fold', 285265),
(469678, '0054243', NULL, NULL, 97, NULL, 'Histone-fold', 285265),
(469679, '0047574', NULL, NULL, 66, NULL, 'Histone-fold', 285265),
(469680, '0034938', NULL, NULL, 68, NULL, 'Histone-fold', 285265),
(469681, '0035368', NULL, NULL, 68, NULL, 'Histone-fold', 285265),
(469682, '0037328', NULL, NULL, 151, NULL, 'Histone-fold', 285265),
(469683, '0038978', NULL, NULL, 79, NULL, 'Histone-fold', 285265),
(469684, '0038979', NULL, NULL, 110, NULL, 'Histone-fold', 285265),
(469685, '0041191', NULL, NULL, 78, NULL, 'Histone-fold', 285265),
(469686, '0041190', NULL, NULL, 87, NULL, 'Histone-fold', 285265),
(469687, '0039520', NULL, NULL, 135, NULL, 'Histone-fold', 285265),
(469688, '0040265', NULL, NULL, 66, NULL, 'Histone-fold', 285265),
(469689, '0040306', NULL, NULL, 128, NULL, 'Histone-fold', 285265),
(469690, '0040304', NULL, NULL, 135, NULL, 'Histone-fold', 285265),
(469691, '0047118', NULL, NULL, 74, NULL, 'Histone-fold', 285265),
(469692, '0049779', NULL, NULL, 106, NULL, 'Histone-fold', 285265),
(469693, '0054237', NULL, NULL, 77, NULL, 'CPE0013-like', 285266),
(469694, '0052073', NULL, NULL, 132, NULL, 'Coronavirus RNA-binding domain', 285267),
(469695, '0052876', NULL, NULL, 138, NULL, 'Coronavirus RNA-binding domain', 285267),
(469696, '0043741', NULL, NULL, 158, NULL, 'Coronavirus RNA-binding domain', 285267),
(469697, '0041157', NULL, NULL, 217, NULL, 'Ribosomal protein L1', 285268),
(469698, '0035002', NULL, NULL, 224, NULL, 'Ribosomal protein L1', 285268),
(469699, '0036641', NULL, NULL, 213, NULL, 'Ribosomal protein L1', 285268),
(469700, '0036019', NULL, NULL, 213, NULL, 'Ribosomal protein L1', 285268),
(469701, '0051818', NULL, NULL, 161, NULL, 'Regulatory protein AraC', 285269),
(469702, '0046360', NULL, NULL, 309, NULL, 'Aromatic compound dioxygenase', 285270),
(469703, '0046593', NULL, NULL, 202, NULL, 'Aromatic compound dioxygenase', 285270),
(469704, '0049344', NULL, NULL, 256, NULL, 'Aromatic compound dioxygenase', 285270),
(469705, '0046594', NULL, NULL, 238, NULL, 'Aromatic compound dioxygenase', 285270),
(469706, '0053327', NULL, NULL, 236, NULL, 'Aromatic compound dioxygenase', 285270),
(469707, '0053326', NULL, NULL, 200, NULL, 'Aromatic compound dioxygenase', 285270),
(469708, '0054121', NULL, NULL, 113, NULL, 'Lp2179-like', 285271),
(469709, '0048578', NULL, NULL, 82, NULL, 'CRAL/TRIO N-terminal domain', 285272),
(469710, '0048503', NULL, NULL, 75, NULL, 'CRAL/TRIO N-terminal domain', 285272),
(469711, '0045821', NULL, NULL, 93, NULL, 'CRAL/TRIO N-terminal domain', 285272),
(469712, '0052576', NULL, NULL, 290, NULL, 'Glutamine synthetase/guanido kinase', 285273),
(469713, '0043170', NULL, NULL, 368, NULL, 'Glutamine synthetase/guanido kinase', 285273),
(469714, '0038718', NULL, NULL, 374, NULL, 'Glutamine synthetase/guanido kinase', 285273),
(469715, '0037877', NULL, NULL, 279, NULL, 'Glutamine synthetase/guanido kinase', 285273),
(469716, '0051614', NULL, NULL, 322, NULL, 'Glutamine synthetase/guanido kinase', 285273),
(469717, '0048061', NULL, NULL, 262, NULL, 'Glutamine synthetase/guanido kinase', 285273),
(469718, '0050113', NULL, NULL, 515, NULL, 'Glutamine synthetase/guanido kinase', 285273);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(469719, '0036128', NULL, NULL, 282, NULL, 'Glutamine synthetase/guanido kinase', 285273),
(469720, '0044108', NULL, NULL, 366, NULL, 'Glutamine synthetase/guanido kinase', 285273),
(469721, '0045229', NULL, NULL, 279, NULL, 'Glutamine synthetase/guanido kinase', 285273),
(469722, '0042822', NULL, NULL, 277, NULL, 'Glutamine synthetase/guanido kinase', 285273),
(469723, '0046708', NULL, NULL, 368, NULL, 'Glutamine synthetase/guanido kinase', 285273),
(469724, '0050309', NULL, NULL, 279, NULL, 'Glutamine synthetase/guanido kinase', 285273),
(469725, '0052392', NULL, NULL, 320, NULL, 'Glutamine synthetase/guanido kinase', 285273),
(469726, '0042782', NULL, NULL, 279, NULL, 'Glutamine synthetase/guanido kinase', 285273),
(469727, '0053163', NULL, NULL, 94, NULL, 'VPS28 C-terminal domain-like', 285274),
(469728, '0046078', NULL, NULL, 350, NULL, 'Hect, E3 ligase catalytic domain', 285275),
(469729, '0048334', NULL, NULL, 374, NULL, 'Hect, E3 ligase catalytic domain', 285275),
(469730, '0044556', NULL, NULL, 124, NULL, 'TSP type-3 repeat', 285276),
(469731, '0043579', NULL, NULL, 115, NULL, 'HSP90 C-terminal domain', 285277),
(469732, '0054741', NULL, NULL, 139, NULL, 'CobE/GbiG C-terminal domain-like', 285278),
(469733, '0054847', NULL, NULL, 123, NULL, 'CobE/GbiG C-terminal domain-like', 285278),
(469734, '0054955', NULL, NULL, 121, NULL, 'CobE/GbiG C-terminal domain-like', 285278),
(469735, '0053715', NULL, NULL, 34, NULL, 'Photosystem II reaction center protein J, PsbJ', 285279),
(469736, '0050434', NULL, NULL, 162, NULL, 'AbfB domain', 285280),
(469737, '0054553', NULL, NULL, 184, NULL, 'Jann2411-like', 285281),
(469738, '0041595', NULL, NULL, 101, NULL, 'HesB-like domain', 285282),
(469739, '0054454', NULL, NULL, 118, NULL, 'HesB-like domain', 285282),
(469740, '0043177', NULL, NULL, 97, NULL, 'HesB-like domain', 285282),
(469741, '0037056', NULL, NULL, 436, NULL, 'Amine oxidase catalytic domain', 285283),
(469742, '0050376', NULL, NULL, 417, NULL, 'Amine oxidase catalytic domain', 285283),
(469743, '0041276', NULL, NULL, 460, NULL, 'Amine oxidase catalytic domain', 285283),
(469744, '0040241', NULL, NULL, 441, NULL, 'Amine oxidase catalytic domain', 285283),
(469745, '0041758', NULL, NULL, 424, NULL, 'Amine oxidase catalytic domain', 285283),
(469746, '0034911', NULL, NULL, 150, NULL, 'Phoshotransferase/anion transport protein', 285284),
(469747, '0038790', NULL, NULL, 293, NULL, 'Phoshotransferase/anion transport protein', 285284),
(469748, '0034850', NULL, NULL, 145, NULL, 'Phoshotransferase/anion transport protein', 285284),
(469749, '0050986', NULL, NULL, 155, NULL, 'Phoshotransferase/anion transport protein', 285284),
(469750, '0042689', NULL, NULL, 316, NULL, 'Substrate-binding domain of HMG-CoA reductase', 285285),
(469751, '0038756', NULL, NULL, 305, NULL, 'Substrate-binding domain of HMG-CoA reductase', 285285),
(469752, '0046764', NULL, NULL, 173, NULL, 'Smac/diablo', 285286),
(469753, '0037967', NULL, NULL, 157, NULL, 'Smac/diablo', 285286),
(469754, '0040421', NULL, NULL, 322, NULL, 'Variable surface antigen VlsE', 285287),
(469755, '0046814', NULL, NULL, 137, NULL, 'Cobalamin (vitamin B12)-binding domain', 285288),
(469756, '0053374', NULL, NULL, 163, NULL, 'Cobalamin (vitamin B12)-binding domain', 285288),
(469757, '0051084', NULL, NULL, 160, NULL, 'Cobalamin (vitamin B12)-binding domain', 285288),
(469758, '0046110', NULL, NULL, 137, NULL, 'Cobalamin (vitamin B12)-binding domain', 285288),
(469759, '0045651', NULL, NULL, 168, NULL, 'Cobalamin (vitamin B12)-binding domain', 285288),
(469760, '0035625', NULL, NULL, 156, NULL, 'Cobalamin (vitamin B12)-binding domain', 285288),
(469761, '0044965', NULL, NULL, 256, NULL, 'GroEL equatorial domain-like', 285289),
(469762, '0042602', NULL, NULL, 259, NULL, 'GroEL equatorial domain-like', 285289),
(469763, '0034906', NULL, NULL, 244, NULL, 'GroEL equatorial domain-like', 285289),
(469764, '0034904', NULL, NULL, 246, NULL, 'GroEL equatorial domain-like', 285289),
(469765, '0041815', NULL, NULL, 252, NULL, 'GroEL equatorial domain-like', 285289);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(469766, '0049413', NULL, NULL, 181, NULL, 'GroEL equatorial domain-like', 285289),
(469767, '0047404', NULL, NULL, 253, NULL, 'GroEL equatorial domain-like', 285289),
(469768, '0051085', NULL, NULL, 52, NULL, 'D-lysine 5,6-aminomutase beta subunit KamE, N-terminal domain', 285290),
(469769, '0053555', NULL, NULL, 83, NULL, 'Coronavirus S2 glycoprotein', 285291),
(469770, '0053563', NULL, NULL, 54, NULL, 'Coronavirus S2 glycoprotein', 285291),
(469771, '0053550', NULL, NULL, 75, NULL, 'Coronavirus S2 glycoprotein', 285291),
(469772, '0053538', NULL, NULL, 110, NULL, 'Coronavirus S2 glycoprotein', 285291),
(469773, '0053549', NULL, NULL, 85, NULL, 'Coronavirus S2 glycoprotein', 285291),
(469774, '0053539', NULL, NULL, 127, NULL, 'Coronavirus S2 glycoprotein', 285291),
(469775, '0053536', NULL, NULL, 93, NULL, 'Coronavirus S2 glycoprotein', 285291),
(469776, '0053535', NULL, NULL, 92, NULL, 'Coronavirus S2 glycoprotein', 285291),
(469777, '0037224', NULL, NULL, 217, NULL, 'Bactericidal permeability-increasing protein, BPI', 285292),
(469778, '0037225', NULL, NULL, 239, NULL, 'Bactericidal permeability-increasing protein, BPI', 285292),
(469779, '0047995', NULL, NULL, 268, NULL, 'Alpha subunit of glutamate synthase, C-terminal domain', 285293),
(469780, '0046500', NULL, NULL, 270, NULL, 'Alpha subunit of glutamate synthase, C-terminal domain', 285293),
(469781, '0051199', NULL, NULL, 353, NULL, 'Arabinanase/levansucrase/invertase', 285294),
(469782, '0047083', NULL, NULL, 318, NULL, 'Arabinanase/levansucrase/invertase', 285294),
(469783, '0051222', NULL, NULL, 321, NULL, 'Arabinanase/levansucrase/invertase', 285294),
(469784, '0048662', NULL, NULL, 440, NULL, 'Arabinanase/levansucrase/invertase', 285294),
(469785, '0050020', NULL, NULL, 294, NULL, 'Arabinanase/levansucrase/invertase', 285294),
(469786, '0051383', NULL, NULL, 317, NULL, 'Arabinanase/levansucrase/invertase', 285294),
(469787, '0051905', NULL, NULL, 310, NULL, 'Arabinanase/levansucrase/invertase', 285294),
(469788, '0052539', NULL, NULL, 322, NULL, 'Arabinanase/levansucrase/invertase', 285294),
(469789, '0050007', NULL, NULL, 291, NULL, 'Arabinanase/levansucrase/invertase', 285294),
(469790, '0051316', NULL, NULL, 323, NULL, 'Arabinanase/levansucrase/invertase', 285294),
(469791, '0050224', NULL, NULL, 327, NULL, 'Arabinanase/levansucrase/invertase', 285294),
(469792, '0050644', NULL, NULL, 312, NULL, 'Arabinanase/levansucrase/invertase', 285294),
(469793, '0050168', NULL, NULL, 92, NULL, 'Vanabin-like', 285295),
(469794, '0049351', NULL, NULL, 217, NULL, 'FAH', 285296),
(469795, '0038911', NULL, NULL, 216, NULL, 'FAH', 285296),
(469796, '0047268', NULL, NULL, 298, NULL, 'FAH', 285296),
(469797, '0041438', NULL, NULL, 257, NULL, 'FAH', 285296),
(469798, '0041525', NULL, NULL, 221, NULL, 'FAH', 285296),
(469799, '0043774', NULL, NULL, 261, NULL, 'FAH', 285296),
(469800, '0038910', NULL, NULL, 213, NULL, 'FAH', 285296),
(469801, '0053792', NULL, NULL, 63, NULL, 'MoaD/ThiS', 285297),
(469802, '0049256', NULL, NULL, 68, NULL, 'MoaD/ThiS', 285297),
(469803, '0049740', NULL, NULL, 65, NULL, 'MoaD/ThiS', 285297),
(469804, '0050209', NULL, NULL, 88, NULL, 'MoaD/ThiS', 285297),
(469805, '0054043', NULL, NULL, 77, NULL, 'MoaD/ThiS', 285297),
(469806, '0046674', NULL, NULL, 66, NULL, 'MoaD/ThiS', 285297),
(469807, '0050525', NULL, NULL, 114, NULL, 'MoaD/ThiS', 285297),
(469808, '0050092', NULL, NULL, 87, NULL, 'MoaD/ThiS', 285297),
(469809, '0046810', NULL, NULL, 81, NULL, 'MoaD/ThiS', 285297),
(469810, '0049270', NULL, NULL, 70, NULL, 'MoaD/ThiS', 285297),
(469811, '0039385', NULL, NULL, 107, NULL, 'Putative transcriptional regulator TM1602, C-terminal domain', 285298),
(469812, '0047647', NULL, NULL, 149, NULL, 'Staphylococcal nuclease', 285299),
(469813, '0037234', NULL, NULL, 90, NULL, 'An insect antifreeze protein', 285300),
(469814, '0048118', NULL, NULL, 120, NULL, 'An insect antifreeze protein', 285300),
(469815, '0053797', NULL, NULL, 104, NULL, 'AtpF-like', 285301),
(469816, '0054087', NULL, NULL, 76, NULL, 'AtpF-like', 285301);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(469817, '0034868', NULL, NULL, 135, NULL, 'PK C-terminal domain-like', 285302),
(469818, '0050265', NULL, NULL, 190, NULL, 'PK C-terminal domain-like', 285302),
(469819, '0049547', NULL, NULL, 186, NULL, 'PK C-terminal domain-like', 285302),
(469820, '0034860', NULL, NULL, 134, NULL, 'PK C-terminal domain-like', 285302),
(469821, '0040514', NULL, NULL, 134, NULL, 'PK C-terminal domain-like', 285302),
(469822, '0036702', NULL, NULL, 117, NULL, 'PK C-terminal domain-like', 285302),
(469823, '0042357', NULL, NULL, 141, NULL, 'PK C-terminal domain-like', 285302),
(469824, '0051806', NULL, NULL, 185, NULL, 'MW0975(SA0943)-like', 285303),
(469825, '0044742', NULL, NULL, 55, NULL, 'Heparin-binding domain from vascular endothelial growth factor', 285304),
(469826, '0039043', NULL, NULL, 75, NULL, 'Class II MHC-associated invariant chain ectoplasmic trimerization domain', 285305),
(469827, '0049739', NULL, NULL, 242, NULL, 'ThiG-like', 285306),
(469828, '0050717', NULL, NULL, 243, NULL, 'ThiG-like', 285306),
(469829, '0035809', NULL, NULL, 171, NULL, 'F1F0 ATP synthase subunit A', 285307),
(469830, '0038871', NULL, NULL, 1449, NULL, 'beta and beta-prime subunits of DNA dependent RNA-polymerase', 285308),
(469831, '0038872', NULL, NULL, 1207, NULL, 'beta and beta-prime subunits of DNA dependent RNA-polymerase', 285308),
(469832, '0039236', NULL, NULL, 1504, NULL, 'beta and beta-prime subunits of DNA dependent RNA-polymerase', 285308),
(469833, '0039235', NULL, NULL, 1119, NULL, 'beta and beta-prime subunits of DNA dependent RNA-polymerase', 285308),
(469834, '0053657', NULL, NULL, 1238, NULL, 'beta and beta-prime subunits of DNA dependent RNA-polymerase', 285308),
(469835, '0038897', NULL, NULL, 1113, NULL, 'beta and beta-prime subunits of DNA dependent RNA-polymerase', 285308),
(469836, '0038898', NULL, NULL, 1234, NULL, 'beta and beta-prime subunits of DNA dependent RNA-polymerase', 285308),
(469837, '0051385', NULL, NULL, 106, NULL, 'C-terminal effector domain of the bipartite response regulators', 285309),
(469838, '0048684', NULL, NULL, 97, NULL, 'C-terminal effector domain of the bipartite response regulators', 285309),
(469839, '0049014', NULL, NULL, 104, NULL, 'C-terminal effector domain of the bipartite response regulators', 285309),
(469840, '0045681', NULL, NULL, 67, NULL, 'C-terminal effector domain of the bipartite response regulators', 285309),
(469841, '0048012', NULL, NULL, 115, NULL, 'C-terminal effector domain of the bipartite response regulators', 285309),
(469842, '0048694', NULL, NULL, 87, NULL, 'C-terminal effector domain of the bipartite response regulators', 285309),
(469843, '0051317', NULL, NULL, 70, NULL, 'C-terminal effector domain of the bipartite response regulators', 285309),
(469844, '0052669', NULL, NULL, 95, NULL, 'C-terminal effector domain of the bipartite response regulators', 285309),
(469845, '0048619', NULL, NULL, 99, NULL, 'C-terminal effector domain of the bipartite response regulators', 285309),
(469846, '0047924', NULL, NULL, 65, NULL, 'C-terminal effector domain of the bipartite response regulators', 285309),
(469847, '0047798', NULL, NULL, 102, NULL, 'C-terminal effector domain of the bipartite response regulators', 285309),
(469848, '0046851', NULL, NULL, 67, NULL, 'C-terminal effector domain of the bipartite response regulators', 285309),
(469849, '0046746', NULL, NULL, 119, NULL, 'C-terminal effector domain of the bipartite response regulators', 285309),
(469850, '0046071', NULL, NULL, 145, NULL, 'Mannose-binding lectins', 285310),
(469851, '0039368', NULL, NULL, 149, NULL, 'Mannose-binding lectins', 285310),
(469852, '0039681', NULL, NULL, 150, NULL, 'Mannose-binding lectins', 285310),
(469853, '0052959', NULL, NULL, 121, NULL, 'Mannose-binding lectins', 285310),
(469854, '0048649', NULL, NULL, 151, NULL, 'Mannose-binding lectins', 285310),
(469855, '0049901', NULL, NULL, 149, NULL, 'Mannose-binding lectins', 285310),
(469856, '0036592', NULL, NULL, 61, NULL, 'Carboxypeptidase inhibitor', 285311),
(469857, '0053692', NULL, NULL, 59, NULL, 'Carboxypeptidase inhibitor', 285311);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(469858, '0043634', NULL, NULL, 167, NULL, 'A middle domain of Talin 1', 285312),
(469859, '0050561', NULL, NULL, 99, NULL, 'dsRNA-binding domain-like', 285313),
(469860, '0052443', NULL, NULL, 73, NULL, 'dsRNA-binding domain-like', 285313),
(469861, '0050560', NULL, NULL, 128, NULL, 'dsRNA-binding domain-like', 285313),
(469862, '0052224', NULL, NULL, 76, NULL, 'dsRNA-binding domain-like', 285313),
(469863, '0054588', NULL, NULL, 69, NULL, 'dsRNA-binding domain-like', 285313),
(469864, '0043193', NULL, NULL, 70, NULL, 'dsRNA-binding domain-like', 285313),
(469865, '0052472', NULL, NULL, 84, NULL, 'dsRNA-binding domain-like', 285313),
(469866, '0037618', NULL, NULL, 69, NULL, 'dsRNA-binding domain-like', 285313),
(469867, '0049542', NULL, NULL, 88, NULL, 'dsRNA-binding domain-like', 285313),
(469868, '0049541', NULL, NULL, 90, NULL, 'dsRNA-binding domain-like', 285313),
(469869, '0050800', NULL, NULL, 76, NULL, 'dsRNA-binding domain-like', 285313),
(469870, '0050799', NULL, NULL, 85, NULL, 'dsRNA-binding domain-like', 285313),
(469871, '0051935', NULL, NULL, 71, NULL, 'dsRNA-binding domain-like', 285313),
(469872, '0050801', NULL, NULL, 85, NULL, 'dsRNA-binding domain-like', 285313),
(469873, '0051934', NULL, NULL, 73, NULL, 'dsRNA-binding domain-like', 285313),
(469874, '0036436', NULL, NULL, 69, NULL, 'dsRNA-binding domain-like', 285313),
(469875, '0042985', NULL, NULL, 90, NULL, 'dsRNA-binding domain-like', 285313),
(469876, '0042986', NULL, NULL, 89, NULL, 'dsRNA-binding domain-like', 285313),
(469877, '0040155', NULL, NULL, 184, NULL, 'dsRNA-binding domain-like', 285313),
(469878, '0037064', NULL, NULL, 76, NULL, 'dsRNA-binding domain-like', 285313),
(469879, '0042361', NULL, NULL, 74, NULL, 'dsRNA-binding domain-like', 285313),
(469880, '0044374', NULL, NULL, 89, NULL, 'dsRNA-binding domain-like', 285313),
(469881, '0049914', NULL, NULL, 113, NULL, 'dsRNA-binding domain-like', 285313),
(469882, '0041656', NULL, NULL, 69, NULL, 'dsRNA-binding domain-like', 285313),
(469883, '0052773', NULL, NULL, 95, NULL, '2Fe-2S ferredoxin-like', 285314),
(469884, '0050692', NULL, NULL, 93, NULL, '2Fe-2S ferredoxin-like', 285314),
(469885, '0052035', NULL, NULL, 106, NULL, '2Fe-2S ferredoxin-like', 285314),
(469886, '0052178', NULL, NULL, 97, NULL, '2Fe-2S ferredoxin-like', 285314),
(469887, '0038906', NULL, NULL, 109, NULL, '2Fe-2S ferredoxin-like', 285314),
(469888, '0040391', NULL, NULL, 93, NULL, '2Fe-2S ferredoxin-like', 285314),
(469889, '0036522', NULL, NULL, 128, NULL, '2Fe-2S ferredoxin-like', 285314),
(469890, '0036703', NULL, NULL, 128, NULL, '2Fe-2S ferredoxin-like', 285314),
(469891, '0037830', NULL, NULL, 96, NULL, '2Fe-2S ferredoxin-like', 285314),
(469892, '0037699', NULL, NULL, 90, NULL, '2Fe-2S ferredoxin-like', 285314),
(469893, '0041344', NULL, NULL, 106, NULL, '2Fe-2S ferredoxin-like', 285314),
(469894, '0038026', NULL, NULL, 98, NULL, '2Fe-2S ferredoxin-like', 285314),
(469895, '0040052', NULL, NULL, 105, NULL, '2Fe-2S ferredoxin-like', 285314),
(469896, '0039693', NULL, NULL, 98, NULL, '2Fe-2S ferredoxin-like', 285314),
(469897, '0048556', NULL, NULL, 95, NULL, '2Fe-2S ferredoxin-like', 285314),
(469898, '0041225', NULL, NULL, 79, NULL, '2Fe-2S ferredoxin-like', 285314),
(469899, '0046241', NULL, NULL, 98, NULL, '2Fe-2S ferredoxin-like', 285314),
(469900, '0037749', NULL, NULL, 95, NULL, '2Fe-2S ferredoxin-like', 285314),
(469901, '0034918', NULL, NULL, 97, NULL, '2Fe-2S ferredoxin-like', 285314),
(469902, '0045591', NULL, NULL, 98, NULL, '2Fe-2S ferredoxin-like', 285314),
(469903, '0049210', NULL, NULL, 81, NULL, '2Fe-2S ferredoxin-like', 285314),
(469904, '0039725', NULL, NULL, 84, NULL, '2Fe-2S ferredoxin-like', 285314),
(469905, '0036856', NULL, NULL, 106, NULL, '2Fe-2S ferredoxin-like', 285314),
(469906, '0039204', NULL, NULL, 98, NULL, '2Fe-2S ferredoxin-like', 285314),
(469907, '0036415', NULL, NULL, 80, NULL, '2Fe-2S ferredoxin-like', 285314),
(469908, '0051017', NULL, NULL, 106, NULL, '2Fe-2S ferredoxin-like', 285314),
(469909, '0035261', NULL, NULL, 103, NULL, '2Fe-2S ferredoxin-like', 285314);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(469910, '0037561', NULL, NULL, 79, NULL, '2Fe-2S ferredoxin-like', 285314),
(469911, '0040223', NULL, NULL, 104, NULL, '2Fe-2S ferredoxin-like', 285314),
(469912, '0045911', NULL, NULL, 105, NULL, '2Fe-2S ferredoxin-like', 285314),
(469913, '0046849', NULL, NULL, 98, NULL, '2Fe-2S ferredoxin-like', 285314),
(469914, '0043858', NULL, NULL, 81, NULL, '2Fe-2S ferredoxin-like', 285314),
(469915, '0035241', NULL, NULL, 94, NULL, '2Fe-2S ferredoxin-like', 285314),
(469916, '0042285', NULL, NULL, 96, NULL, '2Fe-2S ferredoxin-like', 285314),
(469917, '0046762', NULL, NULL, 126, NULL, '2Fe-2S ferredoxin-like', 285314),
(469918, '0045410', NULL, NULL, 98, NULL, '2Fe-2S ferredoxin-like', 285314),
(469919, '0044864', NULL, NULL, 80, NULL, '2Fe-2S ferredoxin-like', 285314),
(469920, '0047925', NULL, NULL, 168, NULL, 'Pheromone-binding domain of LuxR-like quorum-sensing transcription factors', 285315),
(469921, '0054400', NULL, NULL, 114, NULL, 'PYP-like sensor domain (PAS domain)', 285316),
(469922, '0046045', NULL, NULL, 110, NULL, 'PYP-like sensor domain (PAS domain)', 285316),
(469923, '0037219', NULL, NULL, 130, NULL, 'PYP-like sensor domain (PAS domain)', 285316),
(469924, '0050109', NULL, NULL, 113, NULL, 'PYP-like sensor domain (PAS domain)', 285316),
(469925, '0054714', NULL, NULL, 127, NULL, 'PYP-like sensor domain (PAS domain)', 285316),
(469926, '0054866', NULL, NULL, 113, NULL, 'PYP-like sensor domain (PAS domain)', 285316),
(469927, '0054348', NULL, NULL, 127, NULL, 'PYP-like sensor domain (PAS domain)', 285316),
(469928, '0041279', NULL, NULL, 109, NULL, 'PYP-like sensor domain (PAS domain)', 285316),
(469929, '0046903', NULL, NULL, 104, NULL, 'PYP-like sensor domain (PAS domain)', 285316),
(469930, '0046377', NULL, NULL, 116, NULL, 'PYP-like sensor domain (PAS domain)', 285316),
(469931, '0048248', NULL, NULL, 110, NULL, 'PYP-like sensor domain (PAS domain)', 285316),
(469932, '0048644', NULL, NULL, 105, NULL, 'PYP-like sensor domain (PAS domain)', 285316),
(469933, '0048579', NULL, NULL, 109, NULL, 'PYP-like sensor domain (PAS domain)', 285316),
(469934, '0040536', NULL, NULL, 114, NULL, 'PYP-like sensor domain (PAS domain)', 285316),
(469935, '0048715', NULL, NULL, 114, NULL, 'PYP-like sensor domain (PAS domain)', 285316),
(469936, '0048459', NULL, NULL, 125, NULL, 'PYP-like sensor domain (PAS domain)', 285316),
(469937, '0034957', NULL, NULL, 221, NULL, 'Tetrahydrobiopterin biosynthesis enzymes-like', 285317),
(469938, '0050120', NULL, NULL, 131, NULL, 'Tetrahydrobiopterin biosynthesis enzymes-like', 285317),
(469939, '0052840', NULL, NULL, 139, NULL, 'Tetrahydrobiopterin biosynthesis enzymes-like', 285317),
(469940, '0035418', NULL, NULL, 119, NULL, 'Tetrahydrobiopterin biosynthesis enzymes-like', 285317),
(469941, '0051175', NULL, NULL, 163, NULL, 'Tetrahydrobiopterin biosynthesis enzymes-like', 285317),
(469942, '0039329', NULL, NULL, 154, NULL, 'Tetrahydrobiopterin biosynthesis enzymes-like', 285317),
(469943, '0050119', NULL, NULL, 156, NULL, 'Tetrahydrobiopterin biosynthesis enzymes-like', 285317),
(469944, '0050713', NULL, NULL, 185, NULL, 'Tetrahydrobiopterin biosynthesis enzymes-like', 285317),
(469945, '0051676', NULL, NULL, 163, NULL, 'Tetrahydrobiopterin biosynthesis enzymes-like', 285317),
(469946, '0037473', NULL, NULL, 196, NULL, 'Tetrahydrobiopterin biosynthesis enzymes-like', 285317),
(469947, '0041300', NULL, NULL, 118, NULL, 'Tetrahydrobiopterin biosynthesis enzymes-like', 285317),
(469948, '0036431', NULL, NULL, 121, NULL, 'Tetrahydrobiopterin biosynthesis enzymes-like', 285317),
(469949, '0043717', NULL, NULL, 120, NULL, 'Tetrahydrobiopterin biosynthesis enzymes-like', 285317),
(469950, '0049106', NULL, NULL, 160, NULL, 'Tetrahydrobiopterin biosynthesis enzymes-like', 285317),
(469951, '0045884', NULL, NULL, 138, NULL, 'Tetrahydrobiopterin biosynthesis enzymes-like', 285317),
(469952, '0049105', NULL, NULL, 136, NULL, 'Tetrahydrobiopterin biosynthesis enzymes-like', 285317),
(469953, '0047499', NULL, NULL, 152, NULL, 'Tetrahydrobiopterin biosynthesis enzymes-like', 285317);
INSERT INTO "PUBLIC"."MODEL" VALUES
(469954, '0048917', NULL, NULL, 327, NULL, 'PLC-like phosphodiesterases', 285318),
(469955, '0053275', NULL, NULL, 274, NULL, 'PLC-like phosphodiesterases', 285318),
(469956, '0049567', NULL, NULL, 328, NULL, 'PLC-like phosphodiesterases', 285318),
(469957, '0053280', NULL, NULL, 296, NULL, 'PLC-like phosphodiesterases', 285318),
(469958, '0041669', NULL, NULL, 226, NULL, 'PLC-like phosphodiesterases', 285318),
(469959, '0050147', NULL, NULL, 217, NULL, 'PLC-like phosphodiesterases', 285318),
(469960, '0051554', NULL, NULL, 240, NULL, 'PLC-like phosphodiesterases', 285318),
(469961, '0054800', NULL, NULL, 349, NULL, 'PLC-like phosphodiesterases', 285318),
(469962, '0050244', NULL, NULL, 266, NULL, 'Nicotinate/Quinolinate PRTase C-terminal domain-like', 285319),
(469963, '0048915', NULL, NULL, 167, NULL, 'Nicotinate/Quinolinate PRTase C-terminal domain-like', 285319),
(469964, '0051266', NULL, NULL, 266, NULL, 'Nicotinate/Quinolinate PRTase C-terminal domain-like', 285319),
(469965, '0053067', NULL, NULL, 279, NULL, 'Nicotinate/Quinolinate PRTase C-terminal domain-like', 285319),
(469966, '0048485', NULL, NULL, 170, NULL, 'Nicotinate/Quinolinate PRTase C-terminal domain-like', 285319),
(469967, '0049008', NULL, NULL, 169, NULL, 'Nicotinate/Quinolinate PRTase C-terminal domain-like', 285319),
(469968, '0051319', NULL, NULL, 255, NULL, 'Nicotinate/Quinolinate PRTase C-terminal domain-like', 285319),
(469969, '0052613', NULL, NULL, 345, NULL, 'Nicotinate/Quinolinate PRTase C-terminal domain-like', 285319),
(469970, '0051403', NULL, NULL, 270, NULL, 'Nicotinate/Quinolinate PRTase C-terminal domain-like', 285319),
(469971, '0049473', NULL, NULL, 474, NULL, 'Calcium ATPase, transmembrane domain M', 285320),
(469972, '0051485', NULL, NULL, 346, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(469973, '0050274', NULL, NULL, 238, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(469974, '0051486', NULL, NULL, 298, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(469975, '0052691', NULL, NULL, 207, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(469976, '0038144', NULL, NULL, 186, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(469977, '0043986', NULL, NULL, 242, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(469978, '0041443', NULL, NULL, 219, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(469979, '0041442', NULL, NULL, 289, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(469980, '0044714', NULL, NULL, 206, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(469981, '0039472', NULL, NULL, 195, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(469982, '0038141', NULL, NULL, 250, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(469983, '0038142', NULL, NULL, 248, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(469984, '0040239', NULL, NULL, 165, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(469985, '0040238', NULL, NULL, 319, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(469986, '0040237', NULL, NULL, 269, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(469987, '0050044', NULL, NULL, 239, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(469988, '0049053', NULL, NULL, 387, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(469989, '0051498', NULL, NULL, 244, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(469990, '0051376', NULL, NULL, 244, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(469991, '0045809', NULL, NULL, 288, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(469992, '0049292', NULL, NULL, 196, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(469993, '0051499', NULL, NULL, 230, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(469994, '0052346', NULL, NULL, 184, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(469995, '0051138', NULL, NULL, 141, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(469996, '0053315', NULL, NULL, 194, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(469997, '0037045', NULL, NULL, 170, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(469998, '0040121', NULL, NULL, 195, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(469999, '0037163', NULL, NULL, 311, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470000, '0053686', NULL, NULL, 277, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470001, '0051025', NULL, NULL, 284, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470002, '0046913', NULL, NULL, 237, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470003, '0043887', NULL, NULL, 168, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470004, '0042557', NULL, NULL, 232, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470005, '0043648', NULL, NULL, 276, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470006, '0046916', NULL, NULL, 208, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470007, '0042553', NULL, NULL, 209, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470008, '0052003', NULL, NULL, 136, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470009, '0052004', NULL, NULL, 305, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470010, '0051156', NULL, NULL, 160, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470011, '0052002', NULL, NULL, 174, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470012, '0050061', NULL, NULL, 258, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470013, '0049190', NULL, NULL, 173, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470014, '0049073', NULL, NULL, 207, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470015, '0052005', NULL, NULL, 175, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470016, '0037385', NULL, NULL, 278, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470017, '0041234', NULL, NULL, 167, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470018, '0042202', NULL, NULL, 424, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470019, '0045717', NULL, NULL, 207, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470020, '0037384', NULL, NULL, 296, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470021, '0043651', NULL, NULL, 274, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470022, '0044740', NULL, NULL, 184, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470023, '0045954', NULL, NULL, 323, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470024, '0051289', NULL, NULL, 178, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470025, '0050194', NULL, NULL, 161, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470026, '0049080', NULL, NULL, 281, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470027, '0042214', NULL, NULL, 401, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470028, '0046815', NULL, NULL, 342, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470029, '0046936', NULL, NULL, 227, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470030, '0039672', NULL, NULL, 224, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470031, '0044990', NULL, NULL, 174, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(470032, '0051056', NULL, NULL, 268, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470033, '0053350', NULL, NULL, 210, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470034, '0043790', NULL, NULL, 254, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470035, '0036279', NULL, NULL, 162, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470036, '0037248', NULL, NULL, 210, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470037, '0046945', NULL, NULL, 262, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470038, '0046826', NULL, NULL, 276, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470039, '0036155', NULL, NULL, 306, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470040, '0036153', NULL, NULL, 166, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470041, '0045970', NULL, NULL, 213, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470042, '0053591', NULL, NULL, 177, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470043, '0043792', NULL, NULL, 224, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470044, '0043794', NULL, NULL, 227, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470045, '0045731', NULL, NULL, 288, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470046, '0046941', NULL, NULL, 122, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470047, '0042345', NULL, NULL, 333, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470048, '0043798', NULL, NULL, 252, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470049, '0053247', NULL, NULL, 241, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470050, '0052155', NULL, NULL, 253, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470051, '0050095', NULL, NULL, 362, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470052, '0044416', NULL, NULL, 204, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470053, '0037230', NULL, NULL, 224, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470054, '0047808', NULL, NULL, 190, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470055, '0045860', NULL, NULL, 258, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470056, '0042471', NULL, NULL, 273, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470057, '0043440', NULL, NULL, 198, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470058, '0044893', NULL, NULL, 213, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470059, '0046711', NULL, NULL, 277, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470060, '0054467', NULL, NULL, 327, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470061, '0038794', NULL, NULL, 232, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470062, '0035281', NULL, NULL, 224, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470063, '0038674', NULL, NULL, 238, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470064, '0043218', NULL, NULL, 172, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470065, '0041032', NULL, NULL, 182, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470066, '0047933', NULL, NULL, 165, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470067, '0046842', NULL, NULL, 289, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470068, '0047813', NULL, NULL, 191, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470069, '0042008', NULL, NULL, 331, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(470070, '0053147', NULL, NULL, 168, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470071, '0053146', NULL, NULL, 222, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470072, '0052054', NULL, NULL, 276, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470073, '0039999', NULL, NULL, 167, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470074, '0035392', NULL, NULL, 784, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470075, '0044438', NULL, NULL, 364, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470076, '0036121', NULL, NULL, 277, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470077, '0054471', NULL, NULL, 201, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470078, '0047820', NULL, NULL, 199, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470079, '0054470', NULL, NULL, 202, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470080, '0042496', NULL, NULL, 289, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470081, '0046735', NULL, NULL, 342, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470082, '0047701', NULL, NULL, 306, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470083, '0043468', NULL, NULL, 266, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470084, '0041170', NULL, NULL, 341, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470085, '0036239', NULL, NULL, 196, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470086, '0046869', NULL, NULL, 280, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470087, '0038892', NULL, NULL, 364, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470088, '0047839', NULL, NULL, 171, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470089, '0041053', NULL, NULL, 177, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470090, '0046860', NULL, NULL, 211, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470091, '0047607', NULL, NULL, 205, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470092, '0048939', NULL, NULL, 194, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470093, '0048819', NULL, NULL, 188, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470094, '0045785', NULL, NULL, 191, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470095, '0045788', NULL, NULL, 181, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470096, '0053059', NULL, NULL, 255, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470097, '0054387', NULL, NULL, 240, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470098, '0036699', NULL, NULL, 173, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470099, '0042280', NULL, NULL, 244, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470100, '0037787', NULL, NULL, 162, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470101, '0045559', NULL, NULL, 169, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470102, '0048706', NULL, NULL, 333, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470103, '0036452', NULL, NULL, 432, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470104, '0036451', NULL, NULL, 429, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470105, '0049919', NULL, NULL, 213, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470106, '0043012', NULL, NULL, 315, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470107, '0043133', NULL, NULL, 245, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(470108, '0053170', NULL, NULL, 339, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470109, '0043258', NULL, NULL, 282, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470110, '0048702', NULL, NULL, 241, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470111, '0052098', NULL, NULL, 175, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470112, '0039715', NULL, NULL, 138, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470113, '0037412', NULL, NULL, 186, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470114, '0039713', NULL, NULL, 211, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470115, '0037898', NULL, NULL, 240, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470116, '0046539', NULL, NULL, 283, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470117, '0050906', NULL, NULL, 133, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470118, '0038740', NULL, NULL, 208, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470119, '0038741', NULL, NULL, 155, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470120, '0044233', NULL, NULL, 173, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470121, '0046895', NULL, NULL, 269, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470122, '0047988', NULL, NULL, 684, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470123, '0048956', NULL, NULL, 626, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470124, '0048957', NULL, NULL, 222, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470125, '0044482', NULL, NULL, 169, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470126, '0053196', NULL, NULL, 191, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470127, '0037407', NULL, NULL, 239, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470128, '0036318', NULL, NULL, 181, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470129, '0037884', NULL, NULL, 166, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470130, '0038731', NULL, NULL, 164, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470131, '0036317', NULL, NULL, 413, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470132, '0038732', NULL, NULL, 180, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470133, '0036790', NULL, NULL, 308, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470134, '0048963', NULL, NULL, 178, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470135, '0044125', NULL, NULL, 205, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470136, '0046548', NULL, NULL, 549, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470137, '0047756', NULL, NULL, 213, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470138, '0049933', NULL, NULL, 196, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470139, '0046551', NULL, NULL, 179, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470140, '0038720', NULL, NULL, 158, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470141, '0042070', NULL, NULL, 242, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470142, '0037996', NULL, NULL, 333, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470143, '0048852', NULL, NULL, 254, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470144, '0046315', NULL, NULL, 241, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470145, '0047406', NULL, NULL, 243, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(470146, '0049825', NULL, NULL, 263, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470147, '0047772', NULL, NULL, 169, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470148, '0046441', NULL, NULL, 210, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470149, '0050943', NULL, NULL, 330, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470150, '0037862', NULL, NULL, 176, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470151, '0049838', NULL, NULL, 333, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470152, '0042089', NULL, NULL, 200, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470153, '0042088', NULL, NULL, 206, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470154, '0043054', NULL, NULL, 94, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470155, '0046442', NULL, NULL, 329, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470156, '0047537', NULL, NULL, 211, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470157, '0048868', NULL, NULL, 294, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470158, '0049837', NULL, NULL, 306, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470159, '0047538', NULL, NULL, 195, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470160, '0047420', NULL, NULL, 231, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470161, '0046693', NULL, NULL, 293, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470162, '0042094', NULL, NULL, 293, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470163, '0047665', NULL, NULL, 240, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470164, '0046697', NULL, NULL, 232, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470165, '0049606', NULL, NULL, 194, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470166, '0046459', NULL, NULL, 180, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470167, '0047547', NULL, NULL, 278, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470168, '0035786', NULL, NULL, 202, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470169, '0037960', NULL, NULL, 323, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470170, '0051927', NULL, NULL, 174, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470171, '0047797', NULL, NULL, 178, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470172, '0045376', NULL, NULL, 795, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470173, '0049611', NULL, NULL, 242, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470174, '0049853', NULL, NULL, 266, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470175, '0048885', NULL, NULL, 320, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470176, '0054084', NULL, NULL, 189, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470177, '0046105', NULL, NULL, 180, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470178, '0036748', NULL, NULL, 234, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470179, '0037958', NULL, NULL, 254, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470180, '0045383', NULL, NULL, 368, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470181, '0048410', NULL, NULL, 170, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470182, '0037955', NULL, NULL, 190, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470183, '0052914', NULL, NULL, 168, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(470184, '0051704', NULL, NULL, 173, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470185, '0035779', NULL, NULL, 224, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470186, '0051942', NULL, NULL, 139, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470187, '0049503', NULL, NULL, 251, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470188, '0046478', NULL, NULL, 285, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470189, '0046479', NULL, NULL, 276, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470190, '0049506', NULL, NULL, 219, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470191, '0049868', NULL, NULL, 180, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470192, '0046001', NULL, NULL, 710, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470193, '0035641', NULL, NULL, 225, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470194, '0050989', NULL, NULL, 165, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470195, '0036850', NULL, NULL, 443, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470196, '0050867', NULL, NULL, 195, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470197, '0036857', NULL, NULL, 433, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470198, '0050741', NULL, NULL, 319, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470199, '0051832', NULL, NULL, 185, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470200, '0051831', NULL, NULL, 168, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470201, '0051952', NULL, NULL, 201, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470202, '0048545', NULL, NULL, 286, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470203, '0045157', NULL, NULL, 190, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470204, '0048549', NULL, NULL, 733, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470205, '0046248', NULL, NULL, 713, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470206, '0049759', NULL, NULL, 225, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470207, '0048426', NULL, NULL, 209, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470208, '0049757', NULL, NULL, 267, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470209, '0036729', NULL, NULL, 258, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470210, '0037818', NULL, NULL, 276, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470211, '0040826', NULL, NULL, 175, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470212, '0049881', NULL, NULL, 191, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470213, '0052815', NULL, NULL, 338, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470214, '0051604', NULL, NULL, 176, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470215, '0052931', NULL, NULL, 198, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470216, '0051958', NULL, NULL, 176, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470217, '0049404', NULL, NULL, 202, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470218, '0047589', NULL, NULL, 240, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470219, '0048436', NULL, NULL, 301, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470220, '0046258', NULL, NULL, 246, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470221, '0036958', NULL, NULL, 197, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(470222, '0037926', NULL, NULL, 443, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470223, '0044086', NULL, NULL, 400, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470224, '0052823', NULL, NULL, 168, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470225, '0051851', NULL, NULL, 164, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470226, '0047599', NULL, NULL, 251, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470227, '0049657', NULL, NULL, 214, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470228, '0048689', NULL, NULL, 178, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470229, '0049537', NULL, NULL, 258, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470230, '0048692', NULL, NULL, 181, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470231, '0046392', NULL, NULL, 181, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470232, '0049301', NULL, NULL, 171, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470233, '0049300', NULL, NULL, 206, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470234, '0046276', NULL, NULL, 203, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470235, '0052832', NULL, NULL, 172, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470236, '0050775', NULL, NULL, 169, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470237, '0046157', NULL, NULL, 286, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470238, '0047127', NULL, NULL, 257, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470239, '0049306', NULL, NULL, 183, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470240, '0035849', NULL, NULL, 174, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470241, '0035848', NULL, NULL, 408, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470242, '0047372', NULL, NULL, 350, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470243, '0046162', NULL, NULL, 225, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470244, '0048220', NULL, NULL, 241, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470245, '0052726', NULL, NULL, 283, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470246, '0052724', NULL, NULL, 173, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470247, '0051510', NULL, NULL, 175, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470248, '0052841', NULL, NULL, 170, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470249, '0050423', NULL, NULL, 179, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470250, '0048226', NULL, NULL, 242, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470251, '0047259', NULL, NULL, 289, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470252, '0040747', NULL, NULL, 167, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470253, '0041834', NULL, NULL, 119, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470254, '0040984', NULL, NULL, 186, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470255, '0041830', NULL, NULL, 309, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470256, '0049317', NULL, NULL, 183, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470257, '0050792', NULL, NULL, 177, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470258, '0048593', NULL, NULL, 207, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470259, '0047023', NULL, NULL, 218, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(470260, '0048113', NULL, NULL, 179, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470261, '0048111', NULL, NULL, 274, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470262, '0050316', NULL, NULL, 187, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470263, '0052859', NULL, NULL, 186, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470264, '0052735', NULL, NULL, 169, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470265, '0050317', NULL, NULL, 187, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470266, '0051648', NULL, NULL, 222, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470267, '0051769', NULL, NULL, 205, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470268, '0052615', NULL, NULL, 186, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470269, '0052855', NULL, NULL, 218, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470270, '0050677', NULL, NULL, 286, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470271, '0050676', NULL, NULL, 200, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470272, '0043901', NULL, NULL, 207, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470273, '0047394', NULL, NULL, 238, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470274, '0052625', NULL, NULL, 175, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470275, '0050449', NULL, NULL, 267, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470276, '0052502', NULL, NULL, 171, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470277, '0051535', NULL, NULL, 190, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470278, '0052501', NULL, NULL, 171, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470279, '0043912', NULL, NULL, 271, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470280, '0054917', NULL, NULL, 229, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470281, '0041617', NULL, NULL, 247, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470282, '0049577', NULL, NULL, 231, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470283, '0049582', NULL, NULL, 196, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470284, '0035814', NULL, NULL, 167, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470285, '0051784', NULL, NULL, 299, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470286, '0048255', NULL, NULL, 242, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470287, '0049343', NULL, NULL, 205, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470288, '0050691', NULL, NULL, 238, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470289, '0050337', NULL, NULL, 427, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470290, '0052879', NULL, NULL, 173, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470291, '0054935', NULL, NULL, 240, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470292, '0054811', NULL, NULL, 253, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470293, '0040410', NULL, NULL, 231, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470294, '0051551', NULL, NULL, 197, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470295, '0051793', NULL, NULL, 165, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470296, '0048381', NULL, NULL, 194, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470297, '0051553', NULL, NULL, 201, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(470298, '0048266', NULL, NULL, 362, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470299, '0048025', NULL, NULL, 207, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470300, '0040419', NULL, NULL, 213, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470301, '0052528', NULL, NULL, 171, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470302, '0050227', NULL, NULL, 258, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470303, '0034832', NULL, NULL, 136, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470304, '0034833', NULL, NULL, 299, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470305, '0047291', NULL, NULL, 183, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470306, '0052764', NULL, NULL, 173, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470307, '0042605', NULL, NULL, 223, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470308, '0039041', NULL, NULL, 370, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470309, '0048026', NULL, NULL, 288, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470310, '0042720', NULL, NULL, 212, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470311, '0051562', NULL, NULL, 164, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470312, '0050351', NULL, NULL, 395, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470313, '0050354', NULL, NULL, 470, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470314, '0048272', NULL, NULL, 204, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470315, '0050353', NULL, NULL, 347, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470316, '0048154', NULL, NULL, 183, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470317, '0050350', NULL, NULL, 485, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470318, '0049485', NULL, NULL, 195, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470319, '0051206', NULL, NULL, 174, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470320, '0051448', NULL, NULL, 168, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470321, '0050356', NULL, NULL, 359, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470322, '0050357', NULL, NULL, 246, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470323, '0051325', NULL, NULL, 172, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470324, '0038188', NULL, NULL, 354, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470325, '0041400', NULL, NULL, 296, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470326, '0042735', NULL, NULL, 431, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470327, '0054829', NULL, NULL, 285, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470328, '0039270', NULL, NULL, 247, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470329, '0049369', NULL, NULL, 364, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470330, '0040315', NULL, NULL, 175, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470331, '0040678', NULL, NULL, 256, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470332, '0051331', NULL, NULL, 140, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470333, '0052785', NULL, NULL, 181, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470334, '0047073', NULL, NULL, 273, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470335, '0051332', NULL, NULL, 299, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(470336, '0048047', NULL, NULL, 192, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470337, '0048044', NULL, NULL, 190, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470338, '0050361', NULL, NULL, 321, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470339, '0050482', NULL, NULL, 178, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470340, '0051450', NULL, NULL, 164, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470341, '0051459', NULL, NULL, 167, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470342, '0052548', NULL, NULL, 347, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470343, '0052549', NULL, NULL, 211, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470344, '0054726', NULL, NULL, 273, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470345, '0049491', NULL, NULL, 237, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470346, '0052546', NULL, NULL, 117, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470347, '0052547', NULL, NULL, 233, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470348, '0051458', NULL, NULL, 165, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470349, '0041412', NULL, NULL, 222, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470350, '0050374', NULL, NULL, 287, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470351, '0052795', NULL, NULL, 200, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470352, '0051462', NULL, NULL, 167, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470353, '0052796', NULL, NULL, 234, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470354, '0051580', NULL, NULL, 183, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470355, '0049266', NULL, NULL, 330, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470356, '0051461', NULL, NULL, 166, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470357, '0051582', NULL, NULL, 177, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470358, '0051460', NULL, NULL, 169, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470359, '0054616', NULL, NULL, 323, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470360, '0051104', NULL, NULL, 167, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470361, '0048050', NULL, NULL, 152, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470362, '0038162', NULL, NULL, 264, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470363, '0038163', NULL, NULL, 206, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470364, '0043607', NULL, NULL, 200, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470365, '0049269', NULL, NULL, 203, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470366, '0049398', NULL, NULL, 173, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470367, '0051472', NULL, NULL, 179, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470368, '0051471', NULL, NULL, 164, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470369, '0052680', NULL, NULL, 165, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470370, '0048180', NULL, NULL, 171, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470371, '0051116', NULL, NULL, 293, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470372, '0039366', NULL, NULL, 432, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470373, '0036095', NULL, NULL, 269, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(470374, '0038151', NULL, NULL, 249, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470375, '0040588', NULL, NULL, 185, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470376, '0043974', NULL, NULL, 265, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470377, '0044700', NULL, NULL, 272, NULL, 'P-loop containing nucleoside triphosphate hydrolases', 285321),
(470378, '0040368', NULL, NULL, 123, NULL, 'DNA-binding domain of Mlu1-box binding protein MBP1', 285322),
(470379, '0049052', NULL, NULL, 145, NULL, 'Double Clp-N motif', 285323),
(470380, '0047755', NULL, NULL, 142, NULL, 'Double Clp-N motif', 285323),
(470381, '0047811', NULL, NULL, 139, NULL, 'Double Clp-N motif', 285323),
(470382, '0049086', NULL, NULL, 128, NULL, 'Cupredoxins', 285324),
(470383, '0036726', NULL, NULL, 153, NULL, 'Cupredoxins', 285324),
(470384, '0049367', NULL, NULL, 139, NULL, 'Cupredoxins', 285324),
(470385, '0047343', NULL, NULL, 112, NULL, 'Cupredoxins', 285324),
(470386, '0049366', NULL, NULL, 67, NULL, 'Cupredoxins', 285324),
(470387, '0052176', NULL, NULL, 105, NULL, 'Cupredoxins', 285324),
(470388, '0047780', NULL, NULL, 151, NULL, 'Cupredoxins', 285324),
(470389, '0049365', NULL, NULL, 116, NULL, 'Cupredoxins', 285324),
(470390, '0049364', NULL, NULL, 180, NULL, 'Cupredoxins', 285324),
(470391, '0041161', NULL, NULL, 153, NULL, 'Cupredoxins', 285324),
(470392, '0045919', NULL, NULL, 105, NULL, 'Cupredoxins', 285324),
(470393, '0035035', NULL, NULL, 99, NULL, 'Cupredoxins', 285324),
(470394, '0037814', NULL, NULL, 132, NULL, 'Cupredoxins', 285324),
(470395, '0040278', NULL, NULL, 165, NULL, 'Cupredoxins', 285324),
(470396, '0036161', NULL, NULL, 129, NULL, 'Cupredoxins', 285324),
(470397, '0038300', NULL, NULL, 216, NULL, 'Cupredoxins', 285324),
(470398, '0045803', NULL, NULL, 209, NULL, 'Cupredoxins', 285324),
(470399, '0035275', NULL, NULL, 129, NULL, 'Cupredoxins', 285324),
(470400, '0041162', NULL, NULL, 178, NULL, 'Cupredoxins', 285324),
(470401, '0047347', NULL, NULL, 106, NULL, 'Cupredoxins', 285324),
(470402, '0047784', NULL, NULL, 146, NULL, 'Cupredoxins', 285324),
(470403, '0045721', NULL, NULL, 131, NULL, 'Cupredoxins', 285324),
(470404, '0041325', NULL, NULL, 159, NULL, 'Cupredoxins', 285324),
(470405, '0044953', NULL, NULL, 109, NULL, 'Cupredoxins', 285324),
(470406, '0045766', NULL, NULL, 123, NULL, 'Cupredoxins', 285324),
(470407, '0040037', NULL, NULL, 102, NULL, 'Cupredoxins', 285324),
(470408, '0047074', NULL, NULL, 162, NULL, 'Cupredoxins', 285324),
(470409, '0053158', NULL, NULL, 179, NULL, 'Cupredoxins', 285324),
(470410, '0053159', NULL, NULL, 149, NULL, 'Cupredoxins', 285324),
(470411, '0052067', NULL, NULL, 173, NULL, 'Cupredoxins', 285324),
(470412, '0053156', NULL, NULL, 145, NULL, 'Cupredoxins', 285324),
(470413, '0053157', NULL, NULL, 207, NULL, 'Cupredoxins', 285324),
(470414, '0045174', NULL, NULL, 128, NULL, 'Cupredoxins', 285324),
(470415, '0039509', NULL, NULL, 110, NULL, 'Cupredoxins', 285324),
(470416, '0052066', NULL, NULL, 157, NULL, 'Cupredoxins', 285324),
(470417, '0053155', NULL, NULL, 192, NULL, 'Cupredoxins', 285324),
(470418, '0051890', NULL, NULL, 97, NULL, 'Cupredoxins', 285324),
(470419, '0048089', NULL, NULL, 160, NULL, 'Cupredoxins', 285324),
(470420, '0035148', NULL, NULL, 214, NULL, 'Cupredoxins', 285324),
(470421, '0035665', NULL, NULL, 124, NULL, 'Cupredoxins', 285324),
(470422, '0035146', NULL, NULL, 129, NULL, 'Cupredoxins', 285324),
(470423, '0035783', NULL, NULL, 99, NULL, 'Cupredoxins', 285324),
(470424, '0051775', NULL, NULL, 120, NULL, 'Cupredoxins', 285324),
(470425, '0034896', NULL, NULL, 172, NULL, 'Cupredoxins', 285324),
(470426, '0034897', NULL, NULL, 201, NULL, 'Cupredoxins', 285324),
(470427, '0040322', NULL, NULL, 199, NULL, 'Cupredoxins', 285324),
(470428, '0045417', NULL, NULL, 98, NULL, 'Cupredoxins', 285324),
(470429, '0038299', NULL, NULL, 181, NULL, 'Cupredoxins', 285324),
(470430, '0040321', NULL, NULL, 170, NULL, 'Cupredoxins', 285324),
(470431, '0040320', NULL, NULL, 130, NULL, 'Cupredoxins', 285324);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(470432, '0039064', NULL, NULL, 141, NULL, 'Cupredoxins', 285324),
(470433, '0045210', NULL, NULL, 96, NULL, 'Cupredoxins', 285324),
(470434, '0046621', NULL, NULL, 163, NULL, 'Cupredoxins', 285324),
(470435, '0049379', NULL, NULL, 105, NULL, 'Cupredoxins', 285324),
(470436, '0046106', NULL, NULL, 130, NULL, 'Cupredoxins', 285324),
(470437, '0046622', NULL, NULL, 176, NULL, 'Cupredoxins', 285324),
(470438, '0046427', NULL, NULL, 129, NULL, 'Cupredoxins', 285324),
(470439, '0042227', NULL, NULL, 120, NULL, 'Cupredoxins', 285324),
(470440, '0050694', NULL, NULL, 104, NULL, 'Cupredoxins', 285324),
(470441, '0038328', NULL, NULL, 199, NULL, 'Cupredoxins', 285324),
(470442, '0035179', NULL, NULL, 145, NULL, 'Cupredoxins', 285324),
(470443, '0038247', NULL, NULL, 174, NULL, 'Cupredoxins', 285324),
(470444, '0038248', NULL, NULL, 154, NULL, 'Cupredoxins', 285324),
(470445, '0047082', NULL, NULL, 170, NULL, 'Cupredoxins', 285324),
(470446, '0038326', NULL, NULL, 130, NULL, 'Cupredoxins', 285324),
(470447, '0037557', NULL, NULL, 166, NULL, 'Cupredoxins', 285324),
(470448, '0040014', NULL, NULL, 151, NULL, 'Cupredoxins', 285324),
(470449, '0039214', NULL, NULL, 98, NULL, 'Cupredoxins', 285324),
(470450, '0038246', NULL, NULL, 181, NULL, 'Cupredoxins', 285324),
(470451, '0048739', NULL, NULL, 98, NULL, 'Cupredoxins', 285324),
(470452, '0048336', NULL, NULL, 156, NULL, 'Cupredoxins', 285324),
(470453, '0048457', NULL, NULL, 128, NULL, 'Cupredoxins', 285324),
(470454, '0048337', NULL, NULL, 174, NULL, 'Cupredoxins', 285324),
(470455, '0046038', NULL, NULL, 91, NULL, 'Cupredoxins', 285324),
(470456, '0037391', NULL, NULL, 91, NULL, 'Cupredoxins', 285324),
(470457, '0047645', NULL, NULL, 128, NULL, 'Cupredoxins', 285324),
(470458, '0047887', NULL, NULL, 140, NULL, 'Cupredoxins', 285324),
(470459, '0042796', NULL, NULL, 139, NULL, 'Cupredoxins', 285324),
(470460, '0047888', NULL, NULL, 181, NULL, 'Cupredoxins', 285324),
(470461, '0048779', NULL, NULL, 97, NULL, 'Cupredoxins', 285324),
(470462, '0045393', NULL, NULL, 137, NULL, 'Cupredoxins', 285324),
(470463, '0053372', NULL, NULL, 98, NULL, 'Cupredoxins', 285324),
(470464, '0045671', NULL, NULL, 99, NULL, 'Cupredoxins', 285324),
(470465, '0049194', NULL, NULL, 129, NULL, 'Cupredoxins', 285324),
(470466, '0043618', NULL, NULL, 138, NULL, 'Cupredoxins', 285324),
(470467, '0048546', NULL, NULL, 177, NULL, 'Cupredoxins', 285324),
(470468, '0048788', NULL, NULL, 123, NULL, 'Cupredoxins', 285324),
(470469, '0044584', NULL, NULL, 136, NULL, 'Cupredoxins', 285324),
(470470, '0042880', NULL, NULL, 131, NULL, 'Cupredoxins', 285324),
(470471, '0044585', NULL, NULL, 168, NULL, 'Cupredoxins', 285324),
(470472, '0044586', NULL, NULL, 190, NULL, 'Cupredoxins', 285324),
(470473, '0045236', NULL, NULL, 135, NULL, 'Cupredoxins', 285324),
(470474, '0042368', NULL, NULL, 99, NULL, 'Cupredoxins', 285324),
(470475, '0053477', NULL, NULL, 55, NULL, 'Fibrinogen coiled-coil and central regions', 285325),
(470476, '0053478', NULL, NULL, 99, NULL, 'Fibrinogen coiled-coil and central regions', 285325),
(470477, '0053476', NULL, NULL, 56, NULL, 'Fibrinogen coiled-coil and central regions', 285325),
(470478, '0053460', NULL, NULL, 47, NULL, 'Fibrinogen coiled-coil and central regions', 285325),
(470479, '0053417', NULL, NULL, 52, NULL, 'Fibrinogen coiled-coil and central regions', 285325),
(470480, '0053418', NULL, NULL, 81, NULL, 'Fibrinogen coiled-coil and central regions', 285325),
(470481, '0053459', NULL, NULL, 51, NULL, 'Fibrinogen coiled-coil and central regions', 285325),
(470482, '0053503', NULL, NULL, 42, NULL, 'Fibrinogen coiled-coil and central regions', 285325),
(470483, '0053416', NULL, NULL, 54, NULL, 'Fibrinogen coiled-coil and central regions', 285325),
(470484, '0053504', NULL, NULL, 44, NULL, 'Fibrinogen coiled-coil and central regions', 285325),
(470485, '0053479', NULL, NULL, 192, NULL, 'Fibrinogen coiled-coil and central regions', 285325),
(470486, '0053458', NULL, NULL, 43, NULL, 'Fibrinogen coiled-coil and central regions', 285325),
(470487, '0053502', NULL, NULL, 50, NULL, 'Fibrinogen coiled-coil and central regions', 285325);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(470488, '0053480', NULL, NULL, 138, NULL, 'Fibrinogen coiled-coil and central regions', 285325),
(470489, '0053481', NULL, NULL, 137, NULL, 'Fibrinogen coiled-coil and central regions', 285325),
(470490, '0053142', NULL, NULL, 55, NULL, 'L9 N-domain-like', 285326),
(470491, '0042790', NULL, NULL, 47, NULL, 'L9 N-domain-like', 285326),
(470492, '0053578', NULL, NULL, 56, NULL, 'L9 N-domain-like', 285326),
(470493, '0053997', NULL, NULL, 58, NULL, 'L9 N-domain-like', 285326),
(470494, '0044910', NULL, NULL, 158, NULL, 'TMV-like viral coat proteins', 285327),
(470495, '0049217', NULL, NULL, 156, NULL, 'TMV-like viral coat proteins', 285327),
(470496, '0046566', NULL, NULL, 158, NULL, 'TMV-like viral coat proteins', 285327),
(470497, '0035976', NULL, NULL, 160, NULL, 'TMV-like viral coat proteins', 285327),
(470498, '0046205', NULL, NULL, 134, NULL, 'TolB, N-terminal domain', 285328),
(470499, '0049264', NULL, NULL, 105, NULL, '5'' to 3'' exonuclease, C-terminal subdomain', 285329),
(470500, '0045727', NULL, NULL, 108, NULL, '5'' to 3'' exonuclease, C-terminal subdomain', 285329),
(470501, '0051042', NULL, NULL, 105, NULL, '5'' to 3'' exonuclease, C-terminal subdomain', 285329),
(470502, '0048139', NULL, NULL, 112, NULL, '5'' to 3'' exonuclease, C-terminal subdomain', 285329),
(470503, '0045961', NULL, NULL, 116, NULL, '5'' to 3'' exonuclease, C-terminal subdomain', 285329),
(470504, '0045875', NULL, NULL, 120, NULL, '5'' to 3'' exonuclease, C-terminal subdomain', 285329),
(470505, '0043994', NULL, NULL, 123, NULL, '5'' to 3'' exonuclease, C-terminal subdomain', 285329),
(470506, '0049934', NULL, NULL, 140, NULL, '5'' to 3'' exonuclease, C-terminal subdomain', 285329),
(470507, '0037050', NULL, NULL, 428, NULL, 'Outer membrane efflux proteins (OEP)', 285330),
(470508, '0050674', NULL, NULL, 456, NULL, 'Outer membrane efflux proteins (OEP)', 285330),
(470509, '0049242', NULL, NULL, 184, NULL, 'RmlC-like cupins', 285331),
(470510, '0053268', NULL, NULL, 200, NULL, 'RmlC-like cupins', 285331),
(470511, '0053269', NULL, NULL, 162, NULL, 'RmlC-like cupins', 285331),
(470512, '0050871', NULL, NULL, 190, NULL, 'RmlC-like cupins', 285331),
(470513, '0054433', NULL, NULL, 93, NULL, 'RmlC-like cupins', 285331),
(470514, '0050074', NULL, NULL, 105, NULL, 'RmlC-like cupins', 285331),
(470515, '0036688', NULL, NULL, 183, NULL, 'RmlC-like cupins', 285331),
(470516, '0039319', NULL, NULL, 288, NULL, 'RmlC-like cupins', 285331),
(470517, '0037258', NULL, NULL, 439, NULL, 'RmlC-like cupins', 285331),
(470518, '0054317', NULL, NULL, 144, NULL, 'RmlC-like cupins', 285331),
(470519, '0052017', NULL, NULL, 122, NULL, 'RmlC-like cupins', 285331),
(470520, '0047506', NULL, NULL, 187, NULL, 'RmlC-like cupins', 285331),
(470521, '0043706', NULL, NULL, 273, NULL, 'RmlC-like cupins', 285331),
(470522, '0051916', NULL, NULL, 186, NULL, 'RmlC-like cupins', 285331),
(470523, '0046333', NULL, NULL, 169, NULL, 'RmlC-like cupins', 285331),
(470524, '0043023', NULL, NULL, 315, NULL, 'RmlC-like cupins', 285331),
(470525, '0046334', NULL, NULL, 178, NULL, 'RmlC-like cupins', 285331),
(470526, '0043585', NULL, NULL, 245, NULL, 'RmlC-like cupins', 285331),
(470527, '0049969', NULL, NULL, 201, NULL, 'RmlC-like cupins', 285331),
(470528, '0048558', NULL, NULL, 202, NULL, 'RmlC-like cupins', 285331),
(470529, '0049374', NULL, NULL, 250, NULL, 'RmlC-like cupins', 285331),
(470530, '0051410', NULL, NULL, 158, NULL, 'RmlC-like cupins', 285331),
(470531, '0054124', NULL, NULL, 185, NULL, 'RmlC-like cupins', 285331),
(470532, '0043192', NULL, NULL, 253, NULL, 'RmlC-like cupins', 285331),
(470533, '0051250', NULL, NULL, 99, NULL, 'RmlC-like cupins', 285331),
(470534, '0054486', NULL, NULL, 135, NULL, 'RmlC-like cupins', 285331),
(470535, '0051095', NULL, NULL, 160, NULL, 'RmlC-like cupins', 285331),
(470536, '0041608', NULL, NULL, 194, NULL, 'RmlC-like cupins', 285331),
(470537, '0048484', NULL, NULL, 115, NULL, 'RmlC-like cupins', 285331),
(470538, '0042381', NULL, NULL, 440, NULL, 'RmlC-like cupins', 285331),
(470539, '0054560', NULL, NULL, 128, NULL, 'RmlC-like cupins', 285331);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(470540, '0051339', NULL, NULL, 195, NULL, 'RmlC-like cupins', 285331),
(470541, '0050205', NULL, NULL, 114, NULL, 'RmlC-like cupins', 285331),
(470542, '0051659', NULL, NULL, 299, NULL, 'RmlC-like cupins', 285331),
(470543, '0053679', NULL, NULL, 175, NULL, 'RmlC-like cupins', 285331),
(470544, '0037841', NULL, NULL, 239, NULL, 'RmlC-like cupins', 285331),
(470545, '0053952', NULL, NULL, 192, NULL, 'RmlC-like cupins', 285331),
(470546, '0054844', NULL, NULL, 355, NULL, 'RmlC-like cupins', 285331),
(470547, '0053799', NULL, NULL, 308, NULL, 'RmlC-like cupins', 285331),
(470548, '0047515', NULL, NULL, 372, NULL, 'RmlC-like cupins', 285331),
(470549, '0046787', NULL, NULL, 201, NULL, 'RmlC-like cupins', 285331),
(470550, '0045016', NULL, NULL, 267, NULL, 'RmlC-like cupins', 285331),
(470551, '0050297', NULL, NULL, 179, NULL, 'RmlC-like cupins', 285331),
(470552, '0051300', NULL, NULL, 174, NULL, 'RmlC-like cupins', 285331),
(470553, '0052595', NULL, NULL, 134, NULL, 'RmlC-like cupins', 285331),
(470554, '0051625', NULL, NULL, 179, NULL, 'RmlC-like cupins', 285331),
(470555, '0050652', NULL, NULL, 176, NULL, 'RmlC-like cupins', 285331),
(470556, '0040530', NULL, NULL, 89, NULL, 'RmlC-like cupins', 285331),
(470557, '0051939', NULL, NULL, 108, NULL, 'RmlC-like cupins', 285331),
(470558, '0046598', NULL, NULL, 183, NULL, 'RmlC-like cupins', 285331),
(470559, '0047686', NULL, NULL, 348, NULL, 'RmlC-like cupins', 285331),
(470560, '0048019', NULL, NULL, 160, NULL, 'RmlC-like cupins', 285331),
(470561, '0051311', NULL, NULL, 112, NULL, 'RmlC-like cupins', 285331),
(470562, '0051431', NULL, NULL, 260, NULL, 'RmlC-like cupins', 285331),
(470563, '0052088', NULL, NULL, 190, NULL, 'RmlC-like cupins', 285331),
(470564, '0049672', NULL, NULL, 231, NULL, 'RmlC-like cupins', 285331),
(470565, '0051957', NULL, NULL, 166, NULL, 'RmlC-like cupins', 285331),
(470566, '0054507', NULL, NULL, 351, NULL, 'RmlC-like cupins', 285331),
(470567, '0051599', NULL, NULL, 140, NULL, 'RmlC-like cupins', 285331),
(470568, '0041796', NULL, NULL, 245, NULL, 'RmlC-like cupins', 285331),
(470569, '0050937', NULL, NULL, 194, NULL, 'RmlC-like cupins', 285331),
(470570, '0046882', NULL, NULL, 174, NULL, 'RmlC-like cupins', 285331),
(470571, '0047410', NULL, NULL, 168, NULL, 'RmlC-like cupins', 285331),
(470572, '0048543', NULL, NULL, 173, NULL, 'RmlC-like cupins', 285331),
(470573, '0047411', NULL, NULL, 211, NULL, 'RmlC-like cupins', 285331),
(470574, '0051192', NULL, NULL, 330, NULL, 'RmlC-like cupins', 285331),
(470575, '0049913', NULL, NULL, 185, NULL, 'RmlC-like cupins', 285331),
(470576, '0049912', NULL, NULL, 203, NULL, 'RmlC-like cupins', 285331),
(470577, '0039597', NULL, NULL, 145, NULL, 'DTD-like', 285332),
(470578, '0043938', NULL, NULL, 187, NULL, 'DTD-like', 285332),
(470579, '0039406', NULL, NULL, 144, NULL, 'DTD-like', 285332),
(470580, '0040850', NULL, NULL, 174, NULL, 'Orange carotenoid protein, N-terminal domain', 285333),
(470581, '0038932', NULL, NULL, 205, NULL, 'Nicotinic receptor ligand binding domain-like', 285334),
(470582, '0050098', NULL, NULL, 386, NULL, 'Tryptophan synthase beta subunit-like PLP-dependent enzymes', 285335),
(470583, '0050156', NULL, NULL, 310, NULL, 'Tryptophan synthase beta subunit-like PLP-dependent enzymes', 285335),
(470584, '0050122', NULL, NULL, 428, NULL, 'Tryptophan synthase beta subunit-like PLP-dependent enzymes', 285335),
(470585, '0050075', NULL, NULL, 318, NULL, 'Tryptophan synthase beta subunit-like PLP-dependent enzymes', 285335),
(470586, '0050152', NULL, NULL, 302, NULL, 'Tryptophan synthase beta subunit-like PLP-dependent enzymes', 285335),
(470587, '0051225', NULL, NULL, 310, NULL, 'Tryptophan synthase beta subunit-like PLP-dependent enzymes', 285335),
(470588, '0051522', NULL, NULL, 320, NULL, 'Tryptophan synthase beta subunit-like PLP-dependent enzymes', 285335),
(470589, '0050641', NULL, NULL, 382, NULL, 'Tryptophan synthase beta subunit-like PLP-dependent enzymes', 285335),
(470590, '0051972', NULL, NULL, 292, NULL, 'Tryptophan synthase beta subunit-like PLP-dependent enzymes', 285335); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(470591, '0036788', NULL, NULL, 477, NULL, 'Tryptophan synthase beta subunit-like PLP-dependent enzymes', 285335),
(470592, '0037348', NULL, NULL, 341, NULL, 'Tryptophan synthase beta subunit-like PLP-dependent enzymes', 285335),
(470593, '0040135', NULL, NULL, 511, NULL, 'Tryptophan synthase beta subunit-like PLP-dependent enzymes', 285335),
(470594, '0039302', NULL, NULL, 325, NULL, 'Tryptophan synthase beta subunit-like PLP-dependent enzymes', 285335),
(470595, '0048837', NULL, NULL, 327, NULL, 'Tryptophan synthase beta subunit-like PLP-dependent enzymes', 285335),
(470596, '0039474', NULL, NULL, 355, NULL, 'Tryptophan synthase beta subunit-like PLP-dependent enzymes', 285335),
(470597, '0043948', NULL, NULL, 331, NULL, 'Tryptophan synthase beta subunit-like PLP-dependent enzymes', 285335),
(470598, '0037494', NULL, NULL, 302, NULL, 'Tryptophan synthase beta subunit-like PLP-dependent enzymes', 285335),
(470599, '0042904', NULL, NULL, 390, NULL, 'Tryptophan synthase beta subunit-like PLP-dependent enzymes', 285335),
(470600, '0048698', NULL, NULL, 319, NULL, 'Tryptophan synthase beta subunit-like PLP-dependent enzymes', 285335),
(470601, '0043354', NULL, NULL, 338, NULL, 'Tryptophan synthase beta subunit-like PLP-dependent enzymes', 285335),
(470602, '0050081', NULL, NULL, 351, NULL, 'Tryptophan synthase beta subunit-like PLP-dependent enzymes', 285335),
(470603, '0041688', NULL, NULL, 293, NULL, 'Tryptophan synthase beta subunit-like PLP-dependent enzymes', 285335),
(470604, '0050991', NULL, NULL, 62, NULL, 'HSP33 redox switch-like', 285336),
(470605, '0050282', NULL, NULL, 57, NULL, 'HSP33 redox switch-like', 285336),
(470606, '0050324', NULL, NULL, 57, NULL, 'HSP33 redox switch-like', 285336),
(470607, '0050992', NULL, NULL, 147, NULL, 'SufE/NifU', 285337),
(470608, '0042614', NULL, NULL, 134, NULL, 'SufE/NifU', 285337),
(470609, '0041151', NULL, NULL, 144, NULL, 'SufE/NifU', 285337),
(470610, '0050294', NULL, NULL, 88, NULL, 'SufE/NifU', 285337),
(470611, '0041407', NULL, NULL, 149, NULL, 'SufE/NifU', 285337),
(470612, '0043760', NULL, NULL, 136, NULL, 'SufE/NifU', 285337),
(470613, '0053635', NULL, NULL, 91, NULL, 'SufE/NifU', 285337),
(470614, '0050511', NULL, NULL, 130, NULL, 'SufE/NifU', 285337),
(470615, '0054406', NULL, NULL, 103, NULL, 'HIN-2000 domain-like', 285338),
(470616, '0054405', NULL, NULL, 88, NULL, 'HIN-2000 domain-like', 285338),
(470617, '0038452', NULL, NULL, 82, NULL, 'Phage fibre proteins', 285339),
(470618, '0039861', NULL, NULL, 223, NULL, 'Phage fibre proteins', 285339),
(470619, '0053764', NULL, NULL, 330, NULL, 'Phage fibre proteins', 285339),
(470620, '0051627', NULL, NULL, 21, NULL, 'Phage fibre proteins', 285339),
(470621, '0052558', NULL, NULL, 46, NULL, 'Phage fibre proteins', 285339),
(470622, '0050027', NULL, NULL, 150, NULL, 'Phage fibre proteins', 285339),
(470623, '0045582', NULL, NULL, 69, NULL, 'Methanol dehydrogenase subunit', 285340),
(470624, '0038412', NULL, NULL, 73, NULL, 'Methanol dehydrogenase subunit', 285340),
(470625, '0040633', NULL, NULL, 83, NULL, 'Methanol dehydrogenase subunit', 285340),
(470626, '0042164', NULL, NULL, 427, NULL, 'CoA-transferase family III (CaiB/BaiF)', 285341),
(470627, '0050868', NULL, NULL, 359, NULL, 'CoA-transferase family III (CaiB/BaiF)', 285341),
(470628, '0042642', NULL, NULL, 417, NULL, 'CoA-transferase family III (CaiB/BaiF)', 285341),
(470629, '0050996', NULL, NULL, 402, NULL, 'CoA-transferase family III (CaiB/BaiF)', 285341),
(470630, '0043932', NULL, NULL, 66, NULL, 'Cysteine-rich domain', 285342),
(470631, '0050054', NULL, NULL, 89, NULL, 'Cysteine-rich domain', 285342),
(470632, '0053663', NULL, NULL, 59, NULL, 'Cysteine-rich domain', 285342),
(470633, '0043160', NULL, NULL, 84, NULL, 'Cysteine-rich domain', 285342),
(470634, '0037470', NULL, NULL, 52, NULL, 'Cysteine-rich domain', 285342),
(470635, '0047776', NULL, NULL, 49, NULL, 'Cysteine-rich domain', 285342),
(470636, '0042462', NULL, NULL, 50, NULL, 'Cysteine-rich domain', 285342),
(470637, '0050894', NULL, NULL, 62, NULL, 'Cysteine-rich domain', 285342);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(470638, '0053393', NULL, NULL, 201, NULL, 'Apolipoprotein A-I', 285343),
(470639, '0051287', NULL, NULL, 193, NULL, 'DNA methylase specificity domain', 285344),
(470640, '0051288', NULL, NULL, 181, NULL, 'DNA methylase specificity domain', 285344),
(470641, '0053088', NULL, NULL, 170, NULL, 'DNA methylase specificity domain', 285344),
(470642, '0051296', NULL, NULL, 205, NULL, 'DNA methylase specificity domain', 285344),
(470643, '0051295', NULL, NULL, 220, NULL, 'DNA methylase specificity domain', 285344),
(470644, '0053716', NULL, NULL, 37, NULL, 'Photosystem II reaction center protein K, PsbK', 285345),
(470645, '0034973', NULL, NULL, 151, NULL, 'Carbamoyl phosphate synthetase, small subunit N-terminal domain', 285346),
(470646, '0044451', NULL, NULL, 128, NULL, 'Polo-box domain', 285347),
(470647, '0049953', NULL, NULL, 95, NULL, 'Polo-box domain', 285347),
(470648, '0040878', NULL, NULL, 75, NULL, 'Polo-box domain', 285347),
(470649, '0052131', NULL, NULL, 59, NULL, 'MxiH-like', 285348),
(470650, '0052816', NULL, NULL, 84, NULL, 'MxiH-like', 285348),
(470651, '0047381', NULL, NULL, 113, NULL, 'E set domains', 285349),
(470652, '0051882', NULL, NULL, 148, NULL, 'E set domains', 285349),
(470653, '0047387', NULL, NULL, 101, NULL, 'E set domains', 285349),
(470654, '0053661', NULL, NULL, 87, NULL, 'E set domains', 285349),
(470655, '0047385', NULL, NULL, 95, NULL, 'E set domains', 285349),
(470656, '0035950', NULL, NULL, 173, NULL, 'E set domains', 285349),
(470657, '0052458', NULL, NULL, 89, NULL, 'E set domains', 285349),
(470658, '0047946', NULL, NULL, 140, NULL, 'E set domains', 285349),
(470659, '0048116', NULL, NULL, 110, NULL, 'E set domains', 285349),
(470660, '0046854', NULL, NULL, 138, NULL, 'E set domains', 285349),
(470661, '0049329', NULL, NULL, 115, NULL, 'E set domains', 285349),
(470662, '0052345', NULL, NULL, 82, NULL, 'E set domains', 285349),
(470663, '0049691', NULL, NULL, 119, NULL, 'E set domains', 285349),
(470664, '0051013', NULL, NULL, 161, NULL, 'E set domains', 285349),
(470665, '0051134', NULL, NULL, 129, NULL, 'E set domains', 285349),
(470666, '0048082', NULL, NULL, 102, NULL, 'E set domains', 285349),
(470667, '0052467', NULL, NULL, 111, NULL, 'E set domains', 285349),
(470668, '0052468', NULL, NULL, 103, NULL, 'E set domains', 285349),
(470669, '0036195', NULL, NULL, 83, NULL, 'E set domains', 285349),
(470670, '0040240', NULL, NULL, 149, NULL, 'E set domains', 285349),
(470671, '0046222', NULL, NULL, 82, NULL, 'E set domains', 285349),
(470672, '0049731', NULL, NULL, 115, NULL, 'E set domains', 285349),
(470673, '0052060', NULL, NULL, 94, NULL, 'E set domains', 285349),
(470674, '0047834', NULL, NULL, 138, NULL, 'E set domains', 285349),
(470675, '0046503', NULL, NULL, 121, NULL, 'E set domains', 285349),
(470676, '0048773', NULL, NULL, 111, NULL, 'E set domains', 285349),
(470677, '0045945', NULL, NULL, 162, NULL, 'E set domains', 285349),
(470678, '0045704', NULL, NULL, 101, NULL, 'E set domains', 285349),
(470679, '0046919', NULL, NULL, 171, NULL, 'E set domains', 285349),
(470680, '0047603', NULL, NULL, 78, NULL, 'E set domains', 285349),
(470681, '0046996', NULL, NULL, 100, NULL, 'E set domains', 285349),
(470682, '0047604', NULL, NULL, 138, NULL, 'E set domains', 285349),
(470683, '0034795', NULL, NULL, 102, NULL, 'E set domains', 285349),
(470684, '0047739', NULL, NULL, 102, NULL, 'E set domains', 285349),
(470685, '0046527', NULL, NULL, 109, NULL, 'E set domains', 285349),
(470686, '0048708', NULL, NULL, 158, NULL, 'E set domains', 285349),
(470687, '0048941', NULL, NULL, 104, NULL, 'E set domains', 285349),
(470688, '0048942', NULL, NULL, 108, NULL, 'E set domains', 285349),
(470689, '0046368', NULL, NULL, 200, NULL, 'E set domains', 285349),
(470690, '0049996', NULL, NULL, 98, NULL, 'E set domains', 285349),
(470691, '0046920', NULL, NULL, 218, NULL, 'E set domains', 285349),
(470692, '0046127', NULL, NULL, 211, NULL, 'E set domains', 285349),
(470693, '0048306', NULL, NULL, 202, NULL, 'E set domains', 285349),
(470694, '0053584', NULL, NULL, 255, NULL, 'E set domains', 285349);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(470695, '0046892', NULL, NULL, 135, NULL, 'E set domains', 285349),
(470696, '0049480', NULL, NULL, 93, NULL, 'E set domains', 285349),
(470697, '0051961', NULL, NULL, 170, NULL, 'E set domains', 285349),
(470698, '0048958', NULL, NULL, 81, NULL, 'E set domains', 285349),
(470699, '0046137', NULL, NULL, 85, NULL, 'E set domains', 285349),
(470700, '0044234', NULL, NULL, 92, NULL, 'E set domains', 285349),
(470701, '0042695', NULL, NULL, 105, NULL, 'E set domains', 285349),
(470702, '0052025', NULL, NULL, 92, NULL, 'E set domains', 285349),
(470703, '0047072', NULL, NULL, 123, NULL, 'E set domains', 285349),
(470704, '0047590', NULL, NULL, 122, NULL, 'E set domains', 285349),
(470705, '0046021', NULL, NULL, 120, NULL, 'E set domains', 285349),
(470706, '0048564', NULL, NULL, 127, NULL, 'E set domains', 285349),
(470707, '0046264', NULL, NULL, 87, NULL, 'E set domains', 285349),
(470708, '0047990', NULL, NULL, 249, NULL, 'E set domains', 285349),
(470709, '0053914', NULL, NULL, 115, NULL, 'E set domains', 285349),
(470710, '0053915', NULL, NULL, 125, NULL, 'E set domains', 285349),
(470711, '0050647', NULL, NULL, 101, NULL, 'E set domains', 285349),
(470712, '0050400', NULL, NULL, 103, NULL, 'E set domains', 285349),
(470713, '0051973', NULL, NULL, 97, NULL, 'E set domains', 285349),
(470714, '0054967', NULL, NULL, 118, NULL, 'E set domains', 285349),
(470715, '0052028', NULL, NULL, 93, NULL, 'E set domains', 285349),
(470716, '0047116', NULL, NULL, 93, NULL, 'E set domains', 285349),
(470717, '0047633', NULL, NULL, 131, NULL, 'E set domains', 285349),
(470718, '0048722', NULL, NULL, 86, NULL, 'E set domains', 285349),
(470719, '0049897', NULL, NULL, 89, NULL, 'E set domains', 285349),
(470720, '0047877', NULL, NULL, 129, NULL, 'E set domains', 285349),
(470721, '0052399', NULL, NULL, 98, NULL, 'E set domains', 285349),
(470722, '0052433', NULL, NULL, 98, NULL, 'E set domains', 285349),
(470723, '0046393', NULL, NULL, 179, NULL, 'E set domains', 285349),
(470724, '0052397', NULL, NULL, 98, NULL, 'E set domains', 285349),
(470725, '0046150', NULL, NULL, 83, NULL, 'E set domains', 285349),
(470726, '0048052', NULL, NULL, 104, NULL, 'E set domains', 285349),
(470727, '0052398', NULL, NULL, 99, NULL, 'E set domains', 285349),
(470728, '0052395', NULL, NULL, 102, NULL, 'E set domains', 285349),
(470729, '0050094', NULL, NULL, 106, NULL, 'E set domains', 285349),
(470730, '0052396', NULL, NULL, 80, NULL, 'E set domains', 285349),
(470731, '0054572', NULL, NULL, 114, NULL, 'E set domains', 285349),
(470732, '0051500', NULL, NULL, 93, NULL, 'E set domains', 285349),
(470733, '0052436', NULL, NULL, 115, NULL, 'E set domains', 285349),
(470734, '0052437', NULL, NULL, 98, NULL, 'E set domains', 285349),
(470735, '0054614', NULL, NULL, 87, NULL, 'E set domains', 285349),
(470736, '0052434', NULL, NULL, 118, NULL, 'E set domains', 285349),
(470737, '0052435', NULL, NULL, 100, NULL, 'E set domains', 285349),
(470738, '0042075', NULL, NULL, 135, NULL, 'E set domains', 285349),
(470739, '0047489', NULL, NULL, 123, NULL, 'E set domains', 285349),
(470740, '0046675', NULL, NULL, 186, NULL, 'E set domains', 285349),
(470741, '0047884', NULL, NULL, 131, NULL, 'E set domains', 285349),
(470742, '0046558', NULL, NULL, 90, NULL, 'E set domains', 285349),
(470743, '0047130', NULL, NULL, 81, NULL, 'E set domains', 285349),
(470744, '0049153', NULL, NULL, 99, NULL, 'E set domains', 285349),
(470745, '0052444', NULL, NULL, 101, NULL, 'E set domains', 285349),
(470746, '0050024', NULL, NULL, 96, NULL, 'E set domains', 285349),
(470747, '0046681', NULL, NULL, 78, NULL, 'E set domains', 285349),
(470748, '0049432', NULL, NULL, 123, NULL, 'E set domains', 285349),
(470749, '0054189', NULL, NULL, 88, NULL, 'E set domains', 285349),
(470750, '0047131', NULL, NULL, 81, NULL, 'E set domains', 285349),
(470751, '0039645', NULL, NULL, 82, NULL, 'E set domains', 285349),
(470752, '0053899', NULL, NULL, 89, NULL, 'E set domains', 285349),
(470753, '0048589', NULL, NULL, 97, NULL, 'E set domains', 285349),
(470754, '0046167', NULL, NULL, 100, NULL, 'E set domains', 285349);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(470755, '0046563', NULL, NULL, 94, NULL, 'E set domains', 285349),
(470756, '0048348', NULL, NULL, 130, NULL, 'E set domains', 285349),
(470757, '0048504', NULL, NULL, 80, NULL, 'E set domains', 285349),
(470758, '0046072', NULL, NULL, 108, NULL, 'Insect pheromone/odorant-binding proteins', 285350),
(470759, '0046382', NULL, NULL, 137, NULL, 'Insect pheromone/odorant-binding proteins', 285350),
(470760, '0049113', NULL, NULL, 117, NULL, 'Insect pheromone/odorant-binding proteins', 285350),
(470761, '0048683', NULL, NULL, 119, NULL, 'Insect pheromone/odorant-binding proteins', 285350),
(470762, '0048615', NULL, NULL, 126, NULL, 'Insect pheromone/odorant-binding proteins', 285350),
(470763, '0049060', NULL, NULL, 142, NULL, 'Insect pheromone/odorant-binding proteins', 285350),
(470764, '0036470', NULL, NULL, 59, NULL, 'Head domain of nucleotide exchange factor GrpE', 285351),
(470765, '0053432', NULL, NULL, 100, NULL, 'Mitotic arrest deficient-like 1, Mad1', 285352),
(470766, '0049596', NULL, NULL, 286, NULL, 'Hypothetical protein MPN330', 285353),
(470767, '0053203', NULL, NULL, 112, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470768, '0051586', NULL, NULL, 105, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470769, '0054158', NULL, NULL, 109, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470770, '0053066', NULL, NULL, 116, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470771, '0054375', NULL, NULL, 130, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470772, '0052394', NULL, NULL, 118, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470773, '0052878', NULL, NULL, 118, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470774, '0051467', NULL, NULL, 149, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470775, '0052656', NULL, NULL, 104, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470776, '0052799', NULL, NULL, 122, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470777, '0052831', NULL, NULL, 116, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470778, '0053205', NULL, NULL, 118, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470779, '0043601', NULL, NULL, 111, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470780, '0043843', NULL, NULL, 132, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470781, '0052849', NULL, NULL, 116, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470782, '0049546', NULL, NULL, 120, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470783, '0054073', NULL, NULL, 118, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470784, '0054049', NULL, NULL, 121, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470785, '0053236', NULL, NULL, 141, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470786, '0049196', NULL, NULL, 123, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470787, '0050189', NULL, NULL, 117, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470788, '0054861', NULL, NULL, 146, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470789, '0054342', NULL, NULL, 110, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470790, '0053097', NULL, NULL, 123, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470791, '0051515', NULL, NULL, 125, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470792, '0052648', NULL, NULL, 134, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470793, '0052846', NULL, NULL, 144, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470794, '0052844', NULL, NULL, 132, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470795, '0052743', NULL, NULL, 115, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470796, '0052886', NULL, NULL, 119, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(470797, '0050080', NULL, NULL, 101, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470798, '0048726', NULL, NULL, 126, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470799, '0047678', NULL, NULL, 115, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470800, '0049911', NULL, NULL, 133, NULL, 'Tetracyclin repressor-like, C-terminal domain', 285354),
(470801, '0042290', NULL, NULL, 471, NULL, 'Perfringolysin', 285355),
(470802, '0051484', NULL, NULL, 67, NULL, 'C-terminal domain of RNA polymerase alpha subunit', 285356),
(470803, '0046189', NULL, NULL, 81, NULL, 'C-terminal domain of RNA polymerase alpha subunit', 285356),
(470804, '0046369', NULL, NULL, 69, NULL, 'C-terminal domain of RNA polymerase alpha subunit', 285356),
(470805, '0050695', NULL, NULL, 225, NULL, 'AMMECR1-like', 285357),
(470806, '0050117', NULL, NULL, 203, NULL, 'AMMECR1-like', 285357),
(470807, '0051616', NULL, NULL, 199, NULL, 'AMMECR1-like', 285357),
(470808, '0044472', NULL, NULL, 105, NULL, 'Pyrimidine nucleoside phosphorylase C-terminal domain', 285358),
(470809, '0035686', NULL, NULL, 103, NULL, 'Pyrimidine nucleoside phosphorylase C-terminal domain', 285358),
(470810, '0045474', NULL, NULL, 105, NULL, 'Pyrimidine nucleoside phosphorylase C-terminal domain', 285358),
(470811, '0051536', NULL, NULL, 128, NULL, 'L,D-transpeptidase catalytic domain-like', 285359),
(470812, '0051226', NULL, NULL, 116, NULL, 'L,D-transpeptidase catalytic domain-like', 285359),
(470813, '0048568', NULL, NULL, 281, NULL, 'Major capsid protein gp5', 285360),
(470814, '0039373', NULL, NULL, 143, NULL, 'Nuclease A inhibitor (NuiA)', 285361),
(470815, '0053902', NULL, NULL, 92, NULL, 'TrmB C-terminal domain-like', 285362),
(470816, '0039662', NULL, NULL, 101, NULL, 'Oncogene products', 285363),
(470817, '0039742', NULL, NULL, 111, NULL, 'Oncogene products', 285363),
(470818, '0034835', NULL, NULL, 106, NULL, 'Oncogene products', 285363),
(470819, '0050521', NULL, NULL, 70, NULL, 'CSL zinc finger', 285364),
(470820, '0051433', NULL, NULL, 82, NULL, 'CSL zinc finger', 285364),
(470821, '0053717', NULL, NULL, 37, NULL, 'Photosystem II reaction center protein L, PsbL', 285365),
(470822, '0052343', NULL, NULL, 167, NULL, 'RUN domain-like', 285366),
(470823, '0053741', NULL, NULL, 114, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470824, '0054112', NULL, NULL, 110, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470825, '0052759', NULL, NULL, 151, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470826, '0039933', NULL, NULL, 104, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470827, '0053644', NULL, NULL, 113, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470828, '0054657', NULL, NULL, 103, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470829, '0041367', NULL, NULL, 128, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470830, '0040031', NULL, NULL, 143, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470831, '0047005', NULL, NULL, 127, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470832, '0054393', NULL, NULL, 141, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470833, '0048114', NULL, NULL, 61, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470834, '0046499', NULL, NULL, 181, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470835, '0047004', NULL, NULL, 124, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470836, '0040833', NULL, NULL, 55, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470837, '0044456', NULL, NULL, 92, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470838, '0054567', NULL, NULL, 104, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470839, '0051352', NULL, NULL, 128, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470840, '0054687', NULL, NULL, 132, NULL, 'Composite domain of metallo-dependent hydrolases', 285367);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(470841, '0054488', NULL, NULL, 140, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470842, '0054147', NULL, NULL, 78, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470843, '0053352', NULL, NULL, 181, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470844, '0041948', NULL, NULL, 106, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470845, '0054483', NULL, NULL, 119, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470846, '0054627', NULL, NULL, 97, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470847, '0054825', NULL, NULL, 96, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470848, '0052788', NULL, NULL, 157, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470849, '0051378', NULL, NULL, 86, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470850, '0054548', NULL, NULL, 104, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470851, '0047518', NULL, NULL, 127, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470852, '0037043', NULL, NULL, 182, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470853, '0053590', NULL, NULL, 129, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470854, '0041659', NULL, NULL, 77, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470855, '0053092', NULL, NULL, 102, NULL, 'Composite domain of metallo-dependent hydrolases', 285367),
(470856, '0035728', NULL, NULL, 134, NULL, 'Viral protein domain', 285368),
(470857, '0053089', NULL, NULL, 321, NULL, 'Viral protein domain', 285368),
(470858, '0043382', NULL, NULL, 324, NULL, 'Viral protein domain', 285368),
(470859, '0039739', NULL, NULL, 317, NULL, 'Viral protein domain', 285368),
(470860, '0039743', NULL, NULL, 321, NULL, 'Viral protein domain', 285368),
(470861, '0037645', NULL, NULL, 156, NULL, 'Viral protein domain', 285368),
(470862, '0042787', NULL, NULL, 184, NULL, 'Viral protein domain', 285368),
(470863, '0044318', NULL, NULL, 153, NULL, 'Viral protein domain', 285368),
(470864, '0035056', NULL, NULL, 126, NULL, 'Viral protein domain', 285368),
(470865, '0045488', NULL, NULL, 320, NULL, 'Viral protein domain', 285368),
(470866, '0043200', NULL, NULL, 328, NULL, 'Viral protein domain', 285368),
(470867, '0043388', NULL, NULL, 323, NULL, 'Viral protein domain', 285368),
(470868, '0041049', NULL, NULL, 318, NULL, 'Viral protein domain', 285368),
(470869, '0049636', NULL, NULL, 314, NULL, 'Viral protein domain', 285368),
(470870, '0035539', NULL, NULL, 124, NULL, 'Transcription factor STAT-4 N-domain', 285369),
(470871, '0047890', NULL, NULL, 560, NULL, 'Quinoprotein alcohol dehydrogenase-like', 285370),
(470872, '0048022', NULL, NULL, 600, NULL, 'Quinoprotein alcohol dehydrogenase-like', 285370),
(470873, '0046808', NULL, NULL, 582, NULL, 'Quinoprotein alcohol dehydrogenase-like', 285370),
(470874, '0047121', NULL, NULL, 595, NULL, 'Quinoprotein alcohol dehydrogenase-like', 285370),
(470875, '0047775', NULL, NULL, 573, NULL, 'Quinoprotein alcohol dehydrogenase-like', 285370),
(470876, '0046933', NULL, NULL, 571, NULL, 'Quinoprotein alcohol dehydrogenase-like', 285370),
(470877, '0049033', NULL, NULL, 387, NULL, 'Xylose isomerase-like', 285371),
(470878, '0046032', NULL, NULL, 387, NULL, 'Xylose isomerase-like', 285371),
(470879, '0046285', NULL, NULL, 416, NULL, 'Xylose isomerase-like', 285371),
(470880, '0046031', NULL, NULL, 387, NULL, 'Xylose isomerase-like', 285371),
(470881, '0054562', NULL, NULL, 271, NULL, 'Xylose isomerase-like', 285371),
(470882, '0053353', NULL, NULL, 393, NULL, 'Xylose isomerase-like', 285371),
(470883, '0034805', NULL, NULL, 437, NULL, 'Xylose isomerase-like', 285371),
(470884, '0051053', NULL, NULL, 297, NULL, 'Xylose isomerase-like', 285371),
(470885, '0051438', NULL, NULL, 250, NULL, 'Xylose isomerase-like', 285371),
(470886, '0049040', NULL, NULL, 285, NULL, 'Xylose isomerase-like', 285371),
(470887, '0052921', NULL, NULL, 387, NULL, 'Xylose isomerase-like', 285371);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(470888, '0047759', NULL, NULL, 260, NULL, 'Xylose isomerase-like', 285371),
(470889, '0036651', NULL, NULL, 388, NULL, 'Xylose isomerase-like', 285371),
(470890, '0050979', NULL, NULL, 392, NULL, 'Xylose isomerase-like', 285371),
(470891, '0052817', NULL, NULL, 275, NULL, 'Xylose isomerase-like', 285371),
(470892, '0045684', NULL, NULL, 437, NULL, 'Xylose isomerase-like', 285371),
(470893, '0049745', NULL, NULL, 353, NULL, 'Xylose isomerase-like', 285371),
(470894, '0045685', NULL, NULL, 443, NULL, 'Xylose isomerase-like', 285371),
(470895, '0047312', NULL, NULL, 278, NULL, 'Xylose isomerase-like', 285371),
(470896, '0054963', NULL, NULL, 127, NULL, 'BT0923-like', 285372),
(470897, '0054942', NULL, NULL, 126, NULL, 'BT0923-like', 285372),
(470898, '0047485', NULL, NULL, 270, NULL, 'Subunits of heterodimeric actin filament capping protein Capz', 285373),
(470899, '0039297', NULL, NULL, 275, NULL, 'Subunits of heterodimeric actin filament capping protein Capz', 285373),
(470900, '0050724', NULL, NULL, 86, NULL, 'Expressed protein At2g23090/F21P24.15', 285374),
(470901, '0053270', NULL, NULL, 248, NULL, 'CofE-like', 285375),
(470902, '0037069', NULL, NULL, 208, NULL, 'Baseplate structural protein gp11', 285376),
(470903, '0052476', NULL, NULL, 66, NULL, 'Chromo domain-like', 285377),
(470904, '0050791', NULL, NULL, 55, NULL, 'Chromo domain-like', 285377),
(470905, '0052477', NULL, NULL, 52, NULL, 'Chromo domain-like', 285377),
(470906, '0050782', NULL, NULL, 45, NULL, 'Chromo domain-like', 285377),
(470907, '0047065', NULL, NULL, 73, NULL, 'Chromo domain-like', 285377),
(470908, '0050790', NULL, NULL, 54, NULL, 'Chromo domain-like', 285377),
(470909, '0051887', NULL, NULL, 95, NULL, 'Chromo domain-like', 285377),
(470910, '0052049', NULL, NULL, 88, NULL, 'Chromo domain-like', 285377),
(470911, '0052489', NULL, NULL, 81, NULL, 'Chromo domain-like', 285377),
(470912, '0052599', NULL, NULL, 83, NULL, 'Chromo domain-like', 285377),
(470913, '0052720', NULL, NULL, 68, NULL, 'Chromo domain-like', 285377),
(470914, '0050533', NULL, NULL, 133, NULL, 'Chromo domain-like', 285377),
(470915, '0051886', NULL, NULL, 80, NULL, 'Chromo domain-like', 285377),
(470916, '0036680', NULL, NULL, 70, NULL, 'Chromo domain-like', 285377),
(470917, '0045848', NULL, NULL, 66, NULL, 'Chromo domain-like', 285377),
(470918, '0047837', NULL, NULL, 52, NULL, 'Chromo domain-like', 285377),
(470919, '0045948', NULL, NULL, 63, NULL, 'Chromo domain-like', 285377),
(470920, '0052490', NULL, NULL, 69, NULL, 'Chromo domain-like', 285377),
(470921, '0046431', NULL, NULL, 61, NULL, 'Chromo domain-like', 285377),
(470922, '0046932', NULL, NULL, 70, NULL, 'Chromo domain-like', 285377),
(470923, '0048746', NULL, NULL, 55, NULL, 'Chromo domain-like', 285377),
(470924, '0035437', NULL, NULL, 71, NULL, 'DNA-binding domain', 285378),
(470925, '0038039', NULL, NULL, 63, NULL, 'DNA-binding domain', 285378),
(470926, '0049847', NULL, NULL, 125, NULL, 'DNA-binding domain', 285378),
(470927, '0036316', NULL, NULL, 75, NULL, 'DNA-binding domain', 285378),
(470928, '0040114', NULL, NULL, 49, NULL, 'DNA-binding domain', 285378),
(470929, '0038145', NULL, NULL, 148, NULL, 'alpha-ketoacid dehydrogenase kinase, N-terminal domain', 285379),
(470930, '0053650', NULL, NULL, 164, NULL, 'alpha-ketoacid dehydrogenase kinase, N-terminal domain', 285379),
(470931, '0039623', NULL, NULL, 167, NULL, 'alpha-ketoacid dehydrogenase kinase, N-terminal domain', 285379),
(470932, '0052674', NULL, NULL, 78, NULL, 'YkuJ-like', 285380),
(470933, '0043645', NULL, NULL, 64, NULL, 'Hypothetical protein D-63', 285381),
(470934, '0046450', NULL, NULL, 153, NULL, 'DNA repair protein MutS, domain II', 285382),
(470935, '0046642', NULL, NULL, 146, NULL, 'DNA repair protein MutS, domain II', 285382),
(470936, '0040642', NULL, NULL, 336, NULL, 'Lipovitellin-phosvitin complex, superhelical domain', 285383),
(470937, '0035826', NULL, NULL, 155, NULL, 'Lumazine synthase', 285384),
(470938, '0037034', NULL, NULL, 168, NULL, 'Lumazine synthase', 285384),
(470939, '0035841', NULL, NULL, 195, NULL, 'Lumazine synthase', 285384);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(470940, '0036434', NULL, NULL, 148, NULL, 'Lumazine synthase', 285384),
(470941, '0040328', NULL, NULL, 150, NULL, 'Lumazine synthase', 285384),
(470942, '0043387', NULL, NULL, 154, NULL, 'Lumazine synthase', 285384),
(470943, '0038676', NULL, NULL, 154, NULL, 'Lumazine synthase', 285384),
(470944, '0054040', NULL, NULL, 127, NULL, 'YdfO-like', 285385),
(470945, '0040211', NULL, NULL, 45, NULL, 'Iron-sulfur subunit of formate dehydrogenase N, transmembrane anchor', 285386),
(470946, '0043844', NULL, NULL, 179, NULL, 'MCP/YpsA-like', 285387),
(470947, '0050464', NULL, NULL, 171, NULL, 'MCP/YpsA-like', 285387),
(470948, '0053289', NULL, NULL, 184, NULL, 'MCP/YpsA-like', 285387),
(470949, '0043198', NULL, NULL, 170, NULL, 'MCP/YpsA-like', 285387),
(470950, '0053291', NULL, NULL, 183, NULL, 'MCP/YpsA-like', 285387),
(470951, '0050465', NULL, NULL, 208, NULL, 'MCP/YpsA-like', 285387),
(470952, '0054305', NULL, NULL, 177, NULL, 'MCP/YpsA-like', 285387),
(470953, '0038801', NULL, NULL, 58, NULL, 'Head-to-tail joining protein W, gpW', 285388),
(470954, '0049518', NULL, NULL, 93, NULL, 'Chromosomal protein MC1', 285389),
(470955, '0036935', NULL, NULL, 121, NULL, 'N-terminal domain of MutM-like DNA repair proteins', 285390),
(470956, '0043946', NULL, NULL, 130, NULL, 'N-terminal domain of MutM-like DNA repair proteins', 285390),
(470957, '0039949', NULL, NULL, 128, NULL, 'N-terminal domain of MutM-like DNA repair proteins', 285390),
(470958, '0041472', NULL, NULL, 131, NULL, 'N-terminal domain of MutM-like DNA repair proteins', 285390),
(470959, '0040360', NULL, NULL, 133, NULL, 'N-terminal domain of MutM-like DNA repair proteins', 285390),
(470960, '0039899', NULL, NULL, 124, NULL, 'N-terminal domain of MutM-like DNA repair proteins', 285390),
(470961, '0053930', NULL, NULL, 409, NULL, 'LanC-like', 285391),
(470962, '0042746', NULL, NULL, 430, NULL, 'Peptidase/esterase ''gauge'' domain', 285392),
(470963, '0053044', NULL, NULL, 313, NULL, 'Peptidase/esterase ''gauge'' domain', 285392),
(470964, '0040558', NULL, NULL, 240, NULL, 'Plakin repeat', 285393),
(470965, '0040556', NULL, NULL, 196, NULL, 'Plakin repeat', 285393),
(470966, '0043181', NULL, NULL, 196, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470967, '0046130', NULL, NULL, 156, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470968, '0047286', NULL, NULL, 192, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470969, '0042074', NULL, NULL, 221, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470970, '0051742', NULL, NULL, 218, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470971, '0050138', NULL, NULL, 250, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470972, '0047949', NULL, NULL, 288, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470973, '0049828', NULL, NULL, 221, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470974, '0051738', NULL, NULL, 195, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470975, '0042273', NULL, NULL, 187, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470976, '0047324', NULL, NULL, 192, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470977, '0049505', NULL, NULL, 240, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470978, '0049527', NULL, NULL, 262, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470979, '0048482', NULL, NULL, 230, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470980, '0049495', NULL, NULL, 184, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470981, '0053950', NULL, NULL, 246, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470982, '0048285', NULL, NULL, 279, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470983, '0037903', NULL, NULL, 166, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470984, '0047771', NULL, NULL, 195, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470985, '0053594', NULL, NULL, 170, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470986, '0049298', NULL, NULL, 258, NULL, 'Class I glutamine amidotransferase-like', 285394);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(470987, '0051592', NULL, NULL, 167, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470988, '0050645', NULL, NULL, 188, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470989, '0052900', NULL, NULL, 281, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470990, '0051730', NULL, NULL, 196, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470991, '0052668', NULL, NULL, 188, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470992, '0039988', NULL, NULL, 200, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470993, '0038211', NULL, NULL, 205, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470994, '0042722', NULL, NULL, 195, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470995, '0042648', NULL, NULL, 202, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470996, '0039782', NULL, NULL, 232, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470997, '0045752', NULL, NULL, 228, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470998, '0046884', NULL, NULL, 229, NULL, 'Class I glutamine amidotransferase-like', 285394),
(470999, '0043013', NULL, NULL, 236, NULL, 'Class I glutamine amidotransferase-like', 285394),
(471000, '0047898', NULL, NULL, 197, NULL, 'Class I glutamine amidotransferase-like', 285394),
(471001, '0052863', NULL, NULL, 82, NULL, 'EF2458-like', 285395),
(471002, '0041119', NULL, NULL, 96, NULL, 'A heparin-binding domain', 285396),
(471003, '0054214', NULL, NULL, 69, NULL, 'Eukaryotic type KH-domain (KH-domain type I)', 285397),
(471004, '0052298', NULL, NULL, 91, NULL, 'Eukaryotic type KH-domain (KH-domain type I)', 285397),
(471005, '0054278', NULL, NULL, 80, NULL, 'Eukaryotic type KH-domain (KH-domain type I)', 285397),
(471006, '0052299', NULL, NULL, 84, NULL, 'Eukaryotic type KH-domain (KH-domain type I)', 285397),
(471007, '0052297', NULL, NULL, 82, NULL, 'Eukaryotic type KH-domain (KH-domain type I)', 285397),
(471008, '0050196', NULL, NULL, 71, NULL, 'Eukaryotic type KH-domain (KH-domain type I)', 285397),
(471009, '0052294', NULL, NULL, 81, NULL, 'Eukaryotic type KH-domain (KH-domain type I)', 285397),
(471010, '0052295', NULL, NULL, 90, NULL, 'Eukaryotic type KH-domain (KH-domain type I)', 285397),
(471011, '0036586', NULL, NULL, 73, NULL, 'Eukaryotic type KH-domain (KH-domain type I)', 285397),
(471012, '0054755', NULL, NULL, 87, NULL, 'Eukaryotic type KH-domain (KH-domain type I)', 285397),
(471013, '0047806', NULL, NULL, 89, NULL, 'Eukaryotic type KH-domain (KH-domain type I)', 285397),
(471014, '0044119', NULL, NULL, 104, NULL, 'Eukaryotic type KH-domain (KH-domain type I)', 285397),
(471015, '0046515', NULL, NULL, 87, NULL, 'Eukaryotic type KH-domain (KH-domain type I)', 285397),
(471016, '0052300', NULL, NULL, 81, NULL, 'Eukaryotic type KH-domain (KH-domain type I)', 285397),
(471017, '0050461', NULL, NULL, 104, NULL, 'Eukaryotic type KH-domain (KH-domain type I)', 285397),
(471018, '0050725', NULL, NULL, 70, NULL, 'Eukaryotic type KH-domain (KH-domain type I)', 285397),
(471019, '0053736', NULL, NULL, 84, NULL, 'Eukaryotic type KH-domain (KH-domain type I)', 285397),
(471020, '0051852', NULL, NULL, 71, NULL, 'Eukaryotic type KH-domain (KH-domain type I)', 285397),
(471021, '0051994', NULL, NULL, 134, NULL, 'Eukaryotic type KH-domain (KH-domain type I)', 285397),
(471022, '0039845', NULL, NULL, 122, NULL, 'Eukaryotic type KH-domain (KH-domain type I)', 285397),
(471023, '0052225', NULL, NULL, 78, NULL, 'Eukaryotic type KH-domain (KH-domain type I)', 285397),
(471024, '0052721', NULL, NULL, 65, NULL, 'Eukaryotic type KH-domain (KH-domain type I)', 285397),
(471025, '0054206', NULL, NULL, 85, NULL, 'Eukaryotic type KH-domain (KH-domain type I)', 285397),
(471026, '0050815', NULL, NULL, 79, NULL, 'Eukaryotic type KH-domain (KH-domain type I)', 285397),
(471027, '0050814', NULL, NULL, 81, NULL, 'Eukaryotic type KH-domain (KH-domain type I)', 285397),
(471028, '0047512', NULL, NULL, 74, NULL, 'Eukaryotic type KH-domain (KH-domain type I)', 285397),
(471029, '0049699', NULL, NULL, 84, NULL, 'Eukaryotic type KH-domain (KH-domain type I)', 285397);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(471030, '0054281', NULL, NULL, 126, NULL, 'Eukaryotic type KH-domain (KH-domain type I)', 285397),
(471031, '0047513', NULL, NULL, 71, NULL, 'Eukaryotic type KH-domain (KH-domain type I)', 285397),
(471032, '0041622', NULL, NULL, 94, NULL, 'Antibiotic binding domain of TipA-like multidrug resistance regulators', 285398),
(471033, '0053895', NULL, NULL, 53, NULL, 'Kazal-type serine protease inhibitors', 285399),
(471034, '0053900', NULL, NULL, 46, NULL, 'Kazal-type serine protease inhibitors', 285399),
(471035, '0038668', NULL, NULL, 56, NULL, 'Kazal-type serine protease inhibitors', 285399),
(471036, '0038364', NULL, NULL, 68, NULL, 'Kazal-type serine protease inhibitors', 285399),
(471037, '0038552', NULL, NULL, 55, NULL, 'Kazal-type serine protease inhibitors', 285399),
(471038, '0043933', NULL, NULL, 51, NULL, 'Kazal-type serine protease inhibitors', 285399),
(471039, '0043934', NULL, NULL, 52, NULL, 'Kazal-type serine protease inhibitors', 285399),
(471040, '0041571', NULL, NULL, 58, NULL, 'Kazal-type serine protease inhibitors', 285399),
(471041, '0051518', NULL, NULL, 62, NULL, 'Kazal-type serine protease inhibitors', 285399),
(471042, '0039232', NULL, NULL, 55, NULL, 'Kazal-type serine protease inhibitors', 285399),
(471043, '0042251', NULL, NULL, 60, NULL, 'Kazal-type serine protease inhibitors', 285399),
(471044, '0040627', NULL, NULL, 48, NULL, 'Kazal-type serine protease inhibitors', 285399),
(471045, '0046016', NULL, NULL, 57, NULL, 'Kazal-type serine protease inhibitors', 285399),
(471046, '0044002', NULL, NULL, 56, NULL, 'Kazal-type serine protease inhibitors', 285399),
(471047, '0045399', NULL, NULL, 56, NULL, 'Kazal-type serine protease inhibitors', 285399),
(471048, '0045542', NULL, NULL, 56, NULL, 'Kazal-type serine protease inhibitors', 285399),
(471049, '0040469', NULL, NULL, 46, NULL, 'Kazal-type serine protease inhibitors', 285399),
(471050, '0040148', NULL, NULL, 55, NULL, 'Kazal-type serine protease inhibitors', 285399),
(471051, '0052537', NULL, NULL, 72, NULL, 'NfeD domain-like', 285400),
(471052, '0047061', NULL, NULL, 140, NULL, 'GST C-terminal domain-like', 285401),
(471053, '0047221', NULL, NULL, 154, NULL, 'GST C-terminal domain-like', 285401),
(471054, '0044592', NULL, NULL, 125, NULL, 'GST C-terminal domain-like', 285401),
(471055, '0035237', NULL, NULL, 135, NULL, 'GST C-terminal domain-like', 285401),
(471056, '0038305', NULL, NULL, 138, NULL, 'GST C-terminal domain-like', 285401),
(471057, '0039277', NULL, NULL, 124, NULL, 'GST C-terminal domain-like', 285401),
(471058, '0037971', NULL, NULL, 140, NULL, 'GST C-terminal domain-like', 285401),
(471059, '0035352', NULL, NULL, 133, NULL, 'GST C-terminal domain-like', 285401),
(471060, '0038264', NULL, NULL, 133, NULL, 'GST C-terminal domain-like', 285401),
(471061, '0052729', NULL, NULL, 149, NULL, 'GST C-terminal domain-like', 285401),
(471062, '0041804', NULL, NULL, 123, NULL, 'GST C-terminal domain-like', 285401),
(471063, '0045522', NULL, NULL, 140, NULL, 'GST C-terminal domain-like', 285401),
(471064, '0042259', NULL, NULL, 124, NULL, 'GST C-terminal domain-like', 285401),
(471065, '0051531', NULL, NULL, 161, NULL, 'GST C-terminal domain-like', 285401),
(471066, '0039829', NULL, NULL, 149, NULL, 'GST C-terminal domain-like', 285401),
(471067, '0049696', NULL, NULL, 131, NULL, 'GST C-terminal domain-like', 285401),
(471068, '0037806', NULL, NULL, 125, NULL, 'GST C-terminal domain-like', 285401),
(471069, '0035345', NULL, NULL, 143, NULL, 'GST C-terminal domain-like', 285401),
(471070, '0052944', NULL, NULL, 131, NULL, 'GST C-terminal domain-like', 285401),
(471071, '0038177', NULL, NULL, 126, NULL, 'GST C-terminal domain-like', 285401),
(471072, '0040520', NULL, NULL, 165, NULL, 'GST C-terminal domain-like', 285401),
(471073, '0037365', NULL, NULL, 143, NULL, 'GST C-terminal domain-like', 285401),
(471074, '0038252', NULL, NULL, 133, NULL, 'GST C-terminal domain-like', 285401),
(471075, '0036791', NULL, NULL, 133, NULL, 'GST C-terminal domain-like', 285401),
(471076, '0052111', NULL, NULL, 133, NULL, 'GST C-terminal domain-like', 285401);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(471077, '0054058', NULL, NULL, 118, NULL, 'GST C-terminal domain-like', 285401),
(471078, '0034807', NULL, NULL, 121, NULL, 'GST C-terminal domain-like', 285401),
(471079, '0048056', NULL, NULL, 127, NULL, 'GST C-terminal domain-like', 285401),
(471080, '0035412', NULL, NULL, 180, NULL, 'GST C-terminal domain-like', 285401),
(471081, '0035533', NULL, NULL, 174, NULL, 'GST C-terminal domain-like', 285401),
(471082, '0039615', NULL, NULL, 123, NULL, 'GST C-terminal domain-like', 285401),
(471083, '0039617', NULL, NULL, 127, NULL, 'GST C-terminal domain-like', 285401),
(471084, '0035250', NULL, NULL, 129, NULL, 'GST C-terminal domain-like', 285401),
(471085, '0046637', NULL, NULL, 143, NULL, 'GST C-terminal domain-like', 285401),
(471086, '0038244', NULL, NULL, 142, NULL, 'GST C-terminal domain-like', 285401),
(471087, '0043129', NULL, NULL, 129, NULL, 'GST C-terminal domain-like', 285401),
(471088, '0035175', NULL, NULL, 133, NULL, 'GST C-terminal domain-like', 285401),
(471089, '0042394', NULL, NULL, 126, NULL, 'GST C-terminal domain-like', 285401),
(471090, '0045301', NULL, NULL, 127, NULL, 'GST C-terminal domain-like', 285401),
(471091, '0045305', NULL, NULL, 133, NULL, 'GST C-terminal domain-like', 285401),
(471092, '0041907', NULL, NULL, 126, NULL, 'GST C-terminal domain-like', 285401),
(471093, '0048663', NULL, NULL, 145, NULL, 'GST C-terminal domain-like', 285401),
(471094, '0044141', NULL, NULL, 129, NULL, 'GST C-terminal domain-like', 285401),
(471095, '0036939', NULL, NULL, 139, NULL, 'GST C-terminal domain-like', 285401),
(471096, '0045593', NULL, NULL, 133, NULL, 'GST C-terminal domain-like', 285401),
(471097, '0037349', NULL, NULL, 121, NULL, 'GST C-terminal domain-like', 285401),
(471098, '0037583', NULL, NULL, 134, NULL, 'GST C-terminal domain-like', 285401),
(471099, '0038156', NULL, NULL, 131, NULL, 'GST C-terminal domain-like', 285401),
(471100, '0041395', NULL, NULL, 144, NULL, 'GST C-terminal domain-like', 285401),
(471101, '0048787', NULL, NULL, 121, NULL, 'GST C-terminal domain-like', 285401),
(471102, '0040989', NULL, NULL, 142, NULL, 'GST C-terminal domain-like', 285401),
(471103, '0045279', NULL, NULL, 136, NULL, 'GST C-terminal domain-like', 285401),
(471104, '0038169', NULL, NULL, 70, NULL, 'Urease metallochaperone UreE, N-terminal domain', 285402),
(471105, '0036879', NULL, NULL, 74, NULL, 'Urease metallochaperone UreE, N-terminal domain', 285402),
(471106, '0051463', NULL, NULL, 51, NULL, 'Rabenosyn-5 Rab-binding domain-like', 285403),
(471107, '0051464', NULL, NULL, 61, NULL, 'Rabenosyn-5 Rab-binding domain-like', 285403),
(471108, '0038574', NULL, NULL, 312, NULL, 'Fe-only hydrogenase', 285404),
(471109, '0037511', NULL, NULL, 365, NULL, 'Fe-only hydrogenase', 285404),
(471110, '0043420', NULL, NULL, 69, NULL, 'Hypothetical protein YjbJ', 285405),
(471111, '0053274', NULL, NULL, 94, NULL, 'Hypothetical protein PF0899', 285406),
(471112, '0054174', NULL, NULL, 64, NULL, 'L35p-like', 285407),
(471113, '0054769', NULL, NULL, 63, NULL, 'L35p-like', 285407),
(471114, '0053070', NULL, NULL, 64, NULL, 'L35p-like', 285407),
(471115, '0041271', NULL, NULL, 108, NULL, 'YggU-like', 285408),
(471116, '0039723', NULL, NULL, 104, NULL, 'YggU-like', 285408),
(471117, '0039460', NULL, NULL, 151, NULL, 'Photosystem I reaction center subunit XI, PsaL', 285409),
(471118, '0046728', NULL, NULL, 144, NULL, 'Lipase/lipooxygenase domain (PLAT/LH2 domain)', 285410),
(471119, '0040594', NULL, NULL, 111, NULL, 'Lipase/lipooxygenase domain (PLAT/LH2 domain)', 285410),
(471120, '0035891', NULL, NULL, 121, NULL, 'Lipase/lipooxygenase domain (PLAT/LH2 domain)', 285410),
(471121, '0037174', NULL, NULL, 112, NULL, 'Lipase/lipooxygenase domain (PLAT/LH2 domain)', 285410),
(471122, '0041262', NULL, NULL, 159, NULL, 'Lipase/lipooxygenase domain (PLAT/LH2 domain)', 285410),
(471123, '0038208', NULL, NULL, 112, NULL, 'Lipase/lipooxygenase domain (PLAT/LH2 domain)', 285410),
(471124, '0041912', NULL, NULL, 121, NULL, 'Lipase/lipooxygenase domain (PLAT/LH2 domain)', 285410),
(471125, '0040090', NULL, NULL, 121, NULL, 'Lipase/lipooxygenase domain (PLAT/LH2 domain)', 285410);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(471126, '0047219', NULL, NULL, 112, NULL, 'Lipase/lipooxygenase domain (PLAT/LH2 domain)', 285410),
(471127, '0035711', NULL, NULL, 114, NULL, 'Lipase/lipooxygenase domain (PLAT/LH2 domain)', 285410),
(471128, '0043325', NULL, NULL, 111, NULL, 'Lipase/lipooxygenase domain (PLAT/LH2 domain)', 285410),
(471129, '0054559', NULL, NULL, 113, NULL, 'Jann4075-like', 285411),
(471130, '0040791', NULL, NULL, 547, NULL, 'Cytochrome c oxidase subunit I-like', 285412),
(471131, '0041780', NULL, NULL, 514, NULL, 'Cytochrome c oxidase subunit I-like', 285412),
(471132, '0035178', NULL, NULL, 529, NULL, 'Cytochrome c oxidase subunit I-like', 285412),
(471133, '0037556', NULL, NULL, 501, NULL, 'Cytochrome c oxidase subunit I-like', 285412),
(471134, '0037007', NULL, NULL, 549, NULL, 'Cytochrome c oxidase subunit I-like', 285412),
(471135, '0049792', NULL, NULL, 107, NULL, 'Prion-like', 285413),
(471136, '0051189', NULL, NULL, 113, NULL, 'Prion-like', 285413),
(471137, '0037705', NULL, NULL, 107, NULL, 'Prion-like', 285413),
(471138, '0051151', NULL, NULL, 111, NULL, 'Prion-like', 285413),
(471139, '0051150', NULL, NULL, 111, NULL, 'Prion-like', 285413),
(471140, '0038829', NULL, NULL, 107, NULL, 'Prion-like', 285413),
(471141, '0049783', NULL, NULL, 117, NULL, 'Prion-like', 285413),
(471142, '0051152', NULL, NULL, 112, NULL, 'Prion-like', 285413),
(471143, '0040490', NULL, NULL, 99, NULL, 'Prion-like', 285413),
(471144, '0051106', NULL, NULL, 102, NULL, 'Prion-like', 285413),
(471145, '0035303', NULL, NULL, 104, NULL, 'Prion-like', 285413),
(471146, '0038866', NULL, NULL, 108, NULL, 'Prion-like', 285413),
(471147, '0049477', NULL, NULL, 304, NULL, 'GyrA/ParC C-terminal domain-like', 285414),
(471148, '0050675', NULL, NULL, 323, NULL, 'GyrA/ParC C-terminal domain-like', 285414),
(471149, '0045001', NULL, NULL, 83, NULL, 'Aminomethyltransferase beta-barrel domain', 285415),
(471150, '0050059', NULL, NULL, 89, NULL, 'Aminomethyltransferase beta-barrel domain', 285415),
(471151, '0048427', NULL, NULL, 82, NULL, 'Aminomethyltransferase beta-barrel domain', 285415),
(471152, '0042335', NULL, NULL, 88, NULL, 'Aminomethyltransferase beta-barrel domain', 285415),
(471153, '0044876', NULL, NULL, 100, NULL, 'Aminomethyltransferase beta-barrel domain', 285415),
(471154, '0036538', NULL, NULL, 31, NULL, 'Proteinase A inhibitor IA3', 285416),
(471155, '0048260', NULL, NULL, 138, NULL, 'Bacterial adhesins', 285417),
(471156, '0049261', NULL, NULL, 143, NULL, 'Bacterial adhesins', 285417),
(471157, '0054685', NULL, NULL, 154, NULL, 'Bacterial adhesins', 285417),
(471158, '0054188', NULL, NULL, 150, NULL, 'Bacterial adhesins', 285417),
(471159, '0048289', NULL, NULL, 191, NULL, 'Bacterial adhesins', 285417),
(471160, '0043084', NULL, NULL, 172, NULL, 'Bacterial adhesins', 285417),
(471161, '0049046', NULL, NULL, 121, NULL, 'Bacterial adhesins', 285417),
(471162, '0042171', NULL, NULL, 136, NULL, 'Bacterial adhesins', 285417),
(471163, '0039425', NULL, NULL, 196, NULL, 'Bacterial adhesins', 285417),
(471164, '0053723', NULL, NULL, 121, NULL, 'Bacterial adhesins', 285417),
(471165, '0049082', NULL, NULL, 149, NULL, 'Bacterial adhesins', 285417),
(471166, '0042997', NULL, NULL, 158, NULL, 'Bacterial adhesins', 285417),
(471167, '0035111', NULL, NULL, 150, NULL, 'Bacterial adhesins', 285417),
(471168, '0041230', NULL, NULL, 141, NULL, 'Bacterial adhesins', 285417),
(471169, '0048741', NULL, NULL, 149, NULL, 'Bacterial adhesins', 285417),
(471170, '0048577', NULL, NULL, 178, NULL, 'Bacterial adhesins', 285417),
(471171, '0052190', NULL, NULL, 133, NULL, 'Bacterial adhesins', 285417),
(471172, '0044512', NULL, NULL, 140, NULL, 'Bacterial adhesins', 285417),
(471173, '0048526', NULL, NULL, 176, NULL, 'Bacterial adhesins', 285417),
(471174, '0044420', NULL, NULL, 81, NULL, 'SBT domain', 285418),
(471175, '0044421', NULL, NULL, 86, NULL, 'SBT domain', 285418),
(471176, '0050603', NULL, NULL, 58, NULL, 'SBT domain', 285418),
(471177, '0046727', NULL, NULL, 690, NULL, 'Lipoxigenase', 285419),
(471178, '0040593', NULL, NULL, 551, NULL, 'Lipoxigenase', 285419);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(471179, '0041261', NULL, NULL, 690, NULL, 'Lipoxigenase', 285419),
(471180, '0040199', NULL, NULL, 430, NULL, 'Clc chloride channel', 285420),
(471181, '0040198', NULL, NULL, 450, NULL, 'Clc chloride channel', 285420),
(471182, '0035816', NULL, NULL, 83, NULL, 'Complement control module/SCR domain', 285421),
(471183, '0049044', NULL, NULL, 60, NULL, 'Complement control module/SCR domain', 285421),
(471184, '0051584', NULL, NULL, 53, NULL, 'Complement control module/SCR domain', 285421),
(471185, '0046991', NULL, NULL, 66, NULL, 'Complement control module/SCR domain', 285421),
(471186, '0051922', NULL, NULL, 63, NULL, 'Complement control module/SCR domain', 285421),
(471187, '0051921', NULL, NULL, 64, NULL, 'Complement control module/SCR domain', 285421),
(471188, '0053600', NULL, NULL, 68, NULL, 'Complement control module/SCR domain', 285421),
(471189, '0038525', NULL, NULL, 59, NULL, 'Complement control module/SCR domain', 285421),
(471190, '0037078', NULL, NULL, 68, NULL, 'Complement control module/SCR domain', 285421),
(471191, '0046917', NULL, NULL, 62, NULL, 'Complement control module/SCR domain', 285421),
(471192, '0038220', NULL, NULL, 68, NULL, 'Complement control module/SCR domain', 285421),
(471193, '0046992', NULL, NULL, 68, NULL, 'Complement control module/SCR domain', 285421),
(471194, '0042990', NULL, NULL, 58, NULL, 'Complement control module/SCR domain', 285421),
(471195, '0042991', NULL, NULL, 63, NULL, 'Complement control module/SCR domain', 285421),
(471196, '0054544', NULL, NULL, 69, NULL, 'Complement control module/SCR domain', 285421),
(471197, '0054764', NULL, NULL, 78, NULL, 'Complement control module/SCR domain', 285421),
(471198, '0037925', NULL, NULL, 59, NULL, 'Complement control module/SCR domain', 285421),
(471199, '0053251', NULL, NULL, 61, NULL, 'Complement control module/SCR domain', 285421),
(471200, '0053252', NULL, NULL, 68, NULL, 'Complement control module/SCR domain', 285421),
(471201, '0037922', NULL, NULL, 64, NULL, 'Complement control module/SCR domain', 285421),
(471202, '0037924', NULL, NULL, 58, NULL, 'Complement control module/SCR domain', 285421),
(471203, '0038577', NULL, NULL, 62, NULL, 'Complement control module/SCR domain', 285421),
(471204, '0038353', NULL, NULL, 63, NULL, 'Complement control module/SCR domain', 285421),
(471205, '0038134', NULL, NULL, 64, NULL, 'Complement control module/SCR domain', 285421),
(471206, '0041891', NULL, NULL, 64, NULL, 'Complement control module/SCR domain', 285421),
(471207, '0042989', NULL, NULL, 62, NULL, 'Complement control module/SCR domain', 285421),
(471208, '0036033', NULL, NULL, 64, NULL, 'Complement control module/SCR domain', 285421),
(471209, '0036032', NULL, NULL, 62, NULL, 'Complement control module/SCR domain', 285421),
(471210, '0038132', NULL, NULL, 70, NULL, 'Complement control module/SCR domain', 285421),
(471211, '0038352', NULL, NULL, 62, NULL, 'Complement control module/SCR domain', 285421),
(471212, '0042607', NULL, NULL, 75, NULL, 'Complement control module/SCR domain', 285421),
(471213, '0047039', NULL, NULL, 76, NULL, 'Complement control module/SCR domain', 285421),
(471214, '0049458', NULL, NULL, 68, NULL, 'Complement control module/SCR domain', 285421),
(471215, '0053250', NULL, NULL, 62, NULL, 'Complement control module/SCR domain', 285421),
(471216, '0041599', NULL, NULL, 67, NULL, 'Complement control module/SCR domain', 285421),
(471217, '0040394', NULL, NULL, 77, NULL, 'PGBD-like', 285422),
(471218, '0036027', NULL, NULL, 77, NULL, 'PGBD-like', 285422),
(471219, '0049469', NULL, NULL, 67, NULL, 'PGBD-like', 285422),
(471220, '0051968', NULL, NULL, 81, NULL, 'PGBD-like', 285422),
(471221, '0040446', NULL, NULL, 83, NULL, 'PGBD-like', 285422),
(471222, '0043654', NULL, NULL, 65, NULL, 'PGBD-like', 285422),
(471223, '0052738', NULL, NULL, 214, NULL, 'YwmB-like', 285423),
(471224, '0050281', NULL, NULL, 230, NULL, 'Hsp33 domain', 285424),
(471225, '0050323', NULL, NULL, 233, NULL, 'Hsp33 domain', 285424),
(471226, '0038755', NULL, NULL, 229, NULL, 'Hsp33 domain', 285424),
(471227, '0050221', NULL, NULL, 29, NULL, 'NADH pyrophosphatase intervening domain', 285425);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(471228, '0053921', NULL, NULL, 63, NULL, 'Lag-3 N-terminal region', 285426),
(471229, '0046715', NULL, NULL, 103, NULL, 'Bromodomain', 285427),
(471230, '0046609', NULL, NULL, 128, NULL, 'Bromodomain', 285427),
(471231, '0046608', NULL, NULL, 139, NULL, 'Bromodomain', 285427),
(471232, '0047674', NULL, NULL, 121, NULL, 'Bromodomain', 285427),
(471233, '0046469', NULL, NULL, 111, NULL, 'Bromodomain', 285427),
(471234, '0048291', NULL, NULL, 115, NULL, 'Bromodomain', 285427),
(471235, '0041336', NULL, NULL, 98, NULL, 'Translation initiation factor 2 beta, aIF2beta, N-terminal domain', 285428),
(471236, '0039954', NULL, NULL, 52, NULL, 'Translation initiation factor 2 beta, aIF2beta, N-terminal domain', 285428),
(471237, '0043206', NULL, NULL, 221, NULL, 'Sec7 domain', 285429),
(471238, '0045924', NULL, NULL, 200, NULL, 'Sec7 domain', 285429),
(471239, '0042242', NULL, NULL, 195, NULL, 'Sec7 domain', 285429),
(471240, '0047880', NULL, NULL, 211, NULL, 'Sec7 domain', 285429),
(471241, '0051097', NULL, NULL, 197, NULL, 'Sec7 domain', 285429),
(471242, '0054637', NULL, NULL, 188, NULL, 'Sec7 domain', 285429),
(471243, '0052542', NULL, NULL, 245, NULL, 'Pseudouridine synthase', 285430),
(471244, '0043107', NULL, NULL, 228, NULL, 'Pseudouridine synthase', 285430),
(471245, '0050199', NULL, NULL, 174, NULL, 'Pseudouridine synthase', 285430),
(471246, '0043606', NULL, NULL, 233, NULL, 'Pseudouridine synthase', 285430),
(471247, '0043816', NULL, NULL, 341, NULL, 'Pseudouridine synthase', 285430),
(471248, '0036450', NULL, NULL, 264, NULL, 'Pseudouridine synthase', 285430),
(471249, '0051811', NULL, NULL, 230, NULL, 'Pseudouridine synthase', 285430),
(471250, '0047872', NULL, NULL, 172, NULL, 'Pseudouridine synthase', 285430),
(471251, '0042443', NULL, NULL, 252, NULL, 'Pseudouridine synthase', 285430),
(471252, '0050102', NULL, NULL, 227, NULL, 'Pseudouridine synthase', 285430),
(471253, '0039976', NULL, NULL, 242, NULL, 'Pseudouridine synthase', 285430),
(471254, '0048123', NULL, NULL, 75, NULL, 'Prokaryotic SH3-related domain', 285431),
(471255, '0048124', NULL, NULL, 86, NULL, 'Prokaryotic SH3-related domain', 285431),
(471256, '0048125', NULL, NULL, 78, NULL, 'Prokaryotic SH3-related domain', 285431),
(471257, '0051050', NULL, NULL, 134, NULL, 'Prokaryotic SH3-related domain', 285431),
(471258, '0051786', NULL, NULL, 74, NULL, 'Prokaryotic SH3-related domain', 285431),
(471259, '0051785', NULL, NULL, 72, NULL, 'Prokaryotic SH3-related domain', 285431),
(471260, '0052525', NULL, NULL, 74, NULL, 'Prokaryotic SH3-related domain', 285431),
(471261, '0048362', NULL, NULL, 143, NULL, 'Nucleoside diphosphate kinase, NDK', 285432),
(471262, '0051068', NULL, NULL, 182, NULL, 'Nucleoside diphosphate kinase, NDK', 285432),
(471263, '0050392', NULL, NULL, 151, NULL, 'Nucleoside diphosphate kinase, NDK', 285432),
(471264, '0046562', NULL, NULL, 143, NULL, 'Nucleoside diphosphate kinase, NDK', 285432),
(471265, '0050982', NULL, NULL, 149, NULL, 'Nucleoside diphosphate kinase, NDK', 285432),
(471266, '0051631', NULL, NULL, 152, NULL, 'Nucleoside diphosphate kinase, NDK', 285432),
(471267, '0051862', NULL, NULL, 152, NULL, 'Nucleoside diphosphate kinase, NDK', 285432),
(471268, '0051941', NULL, NULL, 128, NULL, 'Nucleoside diphosphate kinase, NDK', 285432),
(471269, '0047706', NULL, NULL, 149, NULL, 'Nucleoside diphosphate kinase, NDK', 285432),
(471270, '0050638', NULL, NULL, 137, NULL, 'Nucleoside diphosphate kinase, NDK', 285432),
(471271, '0045939', NULL, NULL, 151, NULL, 'Nucleoside diphosphate kinase, NDK', 285432),
(471272, '0048435', NULL, NULL, 152, NULL, 'Nucleoside diphosphate kinase, NDK', 285432),
(471273, '0047204', NULL, NULL, 150, NULL, 'Nucleoside diphosphate kinase, NDK', 285432),
(471274, '0052491', NULL, NULL, 153, NULL, 'Nucleoside diphosphate kinase, NDK', 285432),
(471275, '0047746', NULL, NULL, 135, NULL, 'Nucleoside diphosphate kinase, NDK', 285432),
(471276, '0049319', NULL, NULL, 153, NULL, 'Nucleoside diphosphate kinase, NDK', 285432),
(471277, '0048316', NULL, NULL, 149, NULL, 'Nucleoside diphosphate kinase, NDK', 285432);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(471278, '0048448', NULL, NULL, 151, NULL, 'Nucleoside diphosphate kinase, NDK', 285432),
(471279, '0048778', NULL, NULL, 148, NULL, 'Nucleoside diphosphate kinase, NDK', 285432),
(471280, '0049823', NULL, NULL, 149, NULL, 'Nucleoside diphosphate kinase, NDK', 285432),
(471281, '0051451', NULL, NULL, 412, NULL, 'YgbK-like', 285433),
(471282, '0048592', NULL, NULL, 106, NULL, 'Actin-like ATPase domain', 285434),
(471283, '0050671', NULL, NULL, 124, NULL, 'Actin-like ATPase domain', 285434),
(471284, '0050670', NULL, NULL, 129, NULL, 'Actin-like ATPase domain', 285434),
(471285, '0046054', NULL, NULL, 229, NULL, 'Actin-like ATPase domain', 285434),
(471286, '0046053', NULL, NULL, 146, NULL, 'Actin-like ATPase domain', 285434),
(471287, '0036765', NULL, NULL, 191, NULL, 'Actin-like ATPase domain', 285434),
(471288, '0036764', NULL, NULL, 193, NULL, 'Actin-like ATPase domain', 285434),
(471289, '0053028', NULL, NULL, 169, NULL, 'Actin-like ATPase domain', 285434),
(471290, '0053029', NULL, NULL, 128, NULL, 'Actin-like ATPase domain', 285434),
(471291, '0039478', NULL, NULL, 140, NULL, 'Actin-like ATPase domain', 285434),
(471292, '0048237', NULL, NULL, 157, NULL, 'Actin-like ATPase domain', 285434),
(471293, '0048238', NULL, NULL, 163, NULL, 'Actin-like ATPase domain', 285434),
(471294, '0051254', NULL, NULL, 229, NULL, 'Actin-like ATPase domain', 285434),
(471295, '0035709', NULL, NULL, 246, NULL, 'Actin-like ATPase domain', 285434),
(471296, '0052627', NULL, NULL, 114, NULL, 'Actin-like ATPase domain', 285434),
(471297, '0052626', NULL, NULL, 134, NULL, 'Actin-like ATPase domain', 285434),
(471298, '0050049', NULL, NULL, 205, NULL, 'Actin-like ATPase domain', 285434),
(471299, '0045934', NULL, NULL, 208, NULL, 'Actin-like ATPase domain', 285434),
(471300, '0037166', NULL, NULL, 141, NULL, 'Actin-like ATPase domain', 285434),
(471301, '0037167', NULL, NULL, 229, NULL, 'Actin-like ATPase domain', 285434),
(471302, '0051805', NULL, NULL, 117, NULL, 'Actin-like ATPase domain', 285434),
(471303, '0051804', NULL, NULL, 186, NULL, 'Actin-like ATPase domain', 285434),
(471304, '0046348', NULL, NULL, 198, NULL, 'Actin-like ATPase domain', 285434),
(471305, '0047559', NULL, NULL, 196, NULL, 'Actin-like ATPase domain', 285434),
(471306, '0046347', NULL, NULL, 183, NULL, 'Actin-like ATPase domain', 285434),
(471307, '0051661', NULL, NULL, 104, NULL, 'Actin-like ATPase domain', 285434),
(471308, '0052751', NULL, NULL, 161, NULL, 'Actin-like ATPase domain', 285434),
(471309, '0052752', NULL, NULL, 164, NULL, 'Actin-like ATPase domain', 285434),
(471310, '0051662', NULL, NULL, 174, NULL, 'Actin-like ATPase domain', 285434),
(471311, '0050050', NULL, NULL, 243, NULL, 'Actin-like ATPase domain', 285434),
(471312, '0051548', NULL, NULL, 114, NULL, 'Actin-like ATPase domain', 285434),
(471313, '0035531', NULL, NULL, 241, NULL, 'Actin-like ATPase domain', 285434),
(471314, '0035530', NULL, NULL, 206, NULL, 'Actin-like ATPase domain', 285434),
(471315, '0051549', NULL, NULL, 171, NULL, 'Actin-like ATPase domain', 285434),
(471316, '0051544', NULL, NULL, 176, NULL, 'Actin-like ATPase domain', 285434),
(471317, '0052359', NULL, NULL, 242, NULL, 'Actin-like ATPase domain', 285434),
(471318, '0038006', NULL, NULL, 156, NULL, 'Actin-like ATPase domain', 285434),
(471319, '0038007', NULL, NULL, 242, NULL, 'Actin-like ATPase domain', 285434),
(471320, '0051545', NULL, NULL, 107, NULL, 'Actin-like ATPase domain', 285434),
(471321, '0041902', NULL, NULL, 110, NULL, 'Actin-like ATPase domain', 285434),
(471322, '0046238', NULL, NULL, 243, NULL, 'Actin-like ATPase domain', 285434),
(471323, '0049109', NULL, NULL, 235, NULL, 'Actin-like ATPase domain', 285434),
(471324, '0046239', NULL, NULL, 205, NULL, 'Actin-like ATPase domain', 285434),
(471325, '0049108', NULL, NULL, 252, NULL, 'Actin-like ATPase domain', 285434),
(471326, '0049352', NULL, NULL, 172, NULL, 'Actin-like ATPase domain', 285434),
(471327, '0035529', NULL, NULL, 243, NULL, 'Actin-like ATPase domain', 285434),
(471328, '0053211', NULL, NULL, 126, NULL, 'Actin-like ATPase domain', 285434);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(471329, '0046240', NULL, NULL, 243, NULL, 'Actin-like ATPase domain', 285434),
(471330, '0053210', NULL, NULL, 82, NULL, 'Actin-like ATPase domain', 285434),
(471331, '0052360', NULL, NULL, 203, NULL, 'Actin-like ATPase domain', 285434),
(471332, '0049353', NULL, NULL, 203, NULL, 'Actin-like ATPase domain', 285434),
(471333, '0039964', NULL, NULL, 190, NULL, 'Actin-like ATPase domain', 285434),
(471334, '0039963', NULL, NULL, 258, NULL, 'Actin-like ATPase domain', 285434),
(471335, '0051710', NULL, NULL, 90, NULL, 'Actin-like ATPase domain', 285434),
(471336, '0045955', NULL, NULL, 222, NULL, 'Actin-like ATPase domain', 285434),
(471337, '0051709', NULL, NULL, 103, NULL, 'Actin-like ATPase domain', 285434),
(471338, '0039962', NULL, NULL, 158, NULL, 'Actin-like ATPase domain', 285434),
(471339, '0046011', NULL, NULL, 251, NULL, 'Actin-like ATPase domain', 285434),
(471340, '0036203', NULL, NULL, 207, NULL, 'Actin-like ATPase domain', 285434),
(471341, '0035476', NULL, NULL, 237, NULL, 'Actin-like ATPase domain', 285434),
(471342, '0050912', NULL, NULL, 176, NULL, 'Actin-like ATPase domain', 285434),
(471343, '0050911', NULL, NULL, 118, NULL, 'Actin-like ATPase domain', 285434),
(471344, '0049808', NULL, NULL, 177, NULL, 'Actin-like ATPase domain', 285434),
(471345, '0049807', NULL, NULL, 124, NULL, 'Actin-like ATPase domain', 285434),
(471346, '0046015', NULL, NULL, 185, NULL, 'Actin-like ATPase domain', 285434),
(471347, '0051971', NULL, NULL, 144, NULL, 'Actin-like ATPase domain', 285434),
(471348, '0051970', NULL, NULL, 94, NULL, 'Actin-like ATPase domain', 285434),
(471349, '0048322', NULL, NULL, 240, NULL, 'Actin-like ATPase domain', 285434),
(471350, '0049498', NULL, NULL, 319, NULL, 'Actin-like ATPase domain', 285434),
(471351, '0052947', NULL, NULL, 118, NULL, 'Actin-like ATPase domain', 285434),
(471352, '0051456', NULL, NULL, 197, NULL, 'Actin-like ATPase domain', 285434),
(471353, '0051731', NULL, NULL, 119, NULL, 'Actin-like ATPase domain', 285434),
(471354, '0047192', NULL, NULL, 186, NULL, 'Actin-like ATPase domain', 285434),
(471355, '0051457', NULL, NULL, 128, NULL, 'Actin-like ATPase domain', 285434),
(471356, '0051732', NULL, NULL, 170, NULL, 'Actin-like ATPase domain', 285434),
(471357, '0048323', NULL, NULL, 202, NULL, 'Actin-like ATPase domain', 285434),
(471358, '0047359', NULL, NULL, 207, NULL, 'Actin-like ATPase domain', 285434),
(471359, '0047243', NULL, NULL, 259, NULL, 'Actin-like ATPase domain', 285434),
(471360, '0038604', NULL, NULL, 194, NULL, 'Actin-like ATPase domain', 285434),
(471361, '0052948', NULL, NULL, 127, NULL, 'Actin-like ATPase domain', 285434),
(471362, '0052960', NULL, NULL, 114, NULL, 'Actin-like ATPase domain', 285434),
(471363, '0045070', NULL, NULL, 143, NULL, 'Actin-like ATPase domain', 285434),
(471364, '0052961', NULL, NULL, 175, NULL, 'Actin-like ATPase domain', 285434),
(471365, '0052166', NULL, NULL, 117, NULL, 'Actin-like ATPase domain', 285434),
(471366, '0054102', NULL, NULL, 212, NULL, 'Actin-like ATPase domain', 285434),
(471367, '0054103', NULL, NULL, 141, NULL, 'Actin-like ATPase domain', 285434),
(471368, '0054100', NULL, NULL, 146, NULL, 'Actin-like ATPase domain', 285434),
(471369, '0052165', NULL, NULL, 227, NULL, 'Actin-like ATPase domain', 285434),
(471370, '0054101', NULL, NULL, 212, NULL, 'Actin-like ATPase domain', 285434),
(471371, '0049552', NULL, NULL, 180, NULL, 'Actin-like ATPase domain', 285434),
(471372, '0045198', NULL, NULL, 229, NULL, 'Actin-like ATPase domain', 285434),
(471373, '0049551', NULL, NULL, 126, NULL, 'Actin-like ATPase domain', 285434),
(471374, '0050789', NULL, NULL, 189, NULL, 'Actin-like ATPase domain', 285434),
(471375, '0050788', NULL, NULL, 205, NULL, 'Actin-like ATPase domain', 285434),
(471376, '0039007', NULL, NULL, 262, NULL, 'Actin-like ATPase domain', 285434),
(471377, '0035722', NULL, NULL, 193, NULL, 'Actin-like ATPase domain', 285434),
(471378, '0053898', NULL, NULL, 267, NULL, 'Actin-like ATPase domain', 285434),
(471379, '0051508', NULL, NULL, 129, NULL, 'Actin-like ATPase domain', 285434);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(471380, '0051509', NULL, NULL, 196, NULL, 'Actin-like ATPase domain', 285434),
(471381, '0051430', NULL, NULL, 28, NULL, 'WW domain', 285435),
(471382, '0052454', NULL, NULL, 38, NULL, 'WW domain', 285435),
(471383, '0053863', NULL, NULL, 50, NULL, 'WW domain', 285435),
(471384, '0036979', NULL, NULL, 38, NULL, 'WW domain', 285435),
(471385, '0041718', NULL, NULL, 46, NULL, 'WW domain', 285435),
(471386, '0041717', NULL, NULL, 29, NULL, 'WW domain', 285435),
(471387, '0052570', NULL, NULL, 30, NULL, 'WW domain', 285435),
(471388, '0036698', NULL, NULL, 27, NULL, 'WW domain', 285435),
(471389, '0036697', NULL, NULL, 37, NULL, 'WW domain', 285435),
(471390, '0037434', NULL, NULL, 42, NULL, 'WW domain', 285435),
(471391, '0048391', NULL, NULL, 44, NULL, 'WW domain', 285435),
(471392, '0051620', NULL, NULL, 28, NULL, 'WW domain', 285435),
(471393, '0039636', NULL, NULL, 46, NULL, 'WW domain', 285435),
(471394, '0054744', NULL, NULL, 26, NULL, 'WW domain', 285435),
(471395, '0038884', NULL, NULL, 50, NULL, 'WW domain', 285435),
(471396, '0044033', NULL, NULL, 45, NULL, 'WW domain', 285435),
(471397, '0049648', NULL, NULL, 43, NULL, 'WW domain', 285435),
(471398, '0038955', NULL, NULL, 90, NULL, 'YhbC-like, N-terminal domain', 285436),
(471399, '0045453', NULL, NULL, 107, NULL, 'Subtilisin inhibitor', 285437),
(471400, '0054120', NULL, NULL, 92, NULL, 'SpoVG-like', 285438),
(471401, '0054117', NULL, NULL, 84, NULL, 'SpoVG-like', 285438),
(471402, '0053402', NULL, NULL, 54, NULL, 'N-terminal coiled coil domain from apc', 285439),
(471403, '0036903', NULL, NULL, 34, NULL, 'Ectatomin subunits', 285440),
(471404, '0036902', NULL, NULL, 37, NULL, 'Ectatomin subunits', 285440),
(471405, '0045428', NULL, NULL, 193, NULL, 'Peptidyl-tRNA hydrolase-like', 285441),
(471406, '0043416', NULL, NULL, 191, NULL, 'Peptidyl-tRNA hydrolase-like', 285441),
(471407, '0045758', NULL, NULL, 125, NULL, 'Profilin (actin-binding protein)', 285442),
(471408, '0048791', NULL, NULL, 139, NULL, 'Profilin (actin-binding protein)', 285442),
(471409, '0053324', NULL, NULL, 130, NULL, 'Profilin (actin-binding protein)', 285442),
(471410, '0046250', NULL, NULL, 138, NULL, 'Profilin (actin-binding protein)', 285442),
(471411, '0046690', NULL, NULL, 125, NULL, 'Profilin (actin-binding protein)', 285442),
(471412, '0046926', NULL, NULL, 130, NULL, 'Profilin (actin-binding protein)', 285442),
(471413, '0046791', NULL, NULL, 139, NULL, 'Profilin (actin-binding protein)', 285442),
(471414, '0045097', NULL, NULL, 125, NULL, 'Profilin (actin-binding protein)', 285442),
(471415, '0046198', NULL, NULL, 132, NULL, 'Profilin (actin-binding protein)', 285442),
(471416, '0050397', NULL, NULL, 192, NULL, 'L domain-like', 285443),
(471417, '0046297', NULL, NULL, 124, NULL, 'L domain-like', 285443),
(471418, '0053646', NULL, NULL, 242, NULL, 'L domain-like', 285443),
(471419, '0053105', NULL, NULL, 156, NULL, 'L domain-like', 285443),
(471420, '0039014', NULL, NULL, 149, NULL, 'L domain-like', 285443),
(471421, '0041268', NULL, NULL, 166, NULL, 'L domain-like', 285443),
(471422, '0045746', NULL, NULL, 162, NULL, 'L domain-like', 285443),
(471423, '0041267', NULL, NULL, 165, NULL, 'L domain-like', 285443),
(471424, '0039015', NULL, NULL, 179, NULL, 'L domain-like', 285443),
(471425, '0041264', NULL, NULL, 166, NULL, 'L domain-like', 285443),
(471426, '0041263', NULL, NULL, 165, NULL, 'L domain-like', 285443),
(471427, '0041848', NULL, NULL, 313, NULL, 'L domain-like', 285443),
(471428, '0046830', NULL, NULL, 160, NULL, 'L domain-like', 285443),
(471429, '0048059', NULL, NULL, 266, NULL, 'L domain-like', 285443),
(471430, '0040812', NULL, NULL, 169, NULL, 'L domain-like', 285443),
(471431, '0040811', NULL, NULL, 158, NULL, 'L domain-like', 285443),
(471432, '0053852', NULL, NULL, 153, NULL, 'L domain-like', 285443),
(471433, '0051010', NULL, NULL, 305, NULL, 'L domain-like', 285443),
(471434, '0047132', NULL, NULL, 227, NULL, 'L domain-like', 285443),
(471435, '0053853', NULL, NULL, 156, NULL, 'L domain-like', 285443),
(471436, '0039223', NULL, NULL, 169, NULL, 'L domain-like', 285443);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(471437, '0039222', NULL, NULL, 161, NULL, 'L domain-like', 285443),
(471438, '0047619', NULL, NULL, 353, NULL, 'L domain-like', 285443),
(471439, '0042103', NULL, NULL, 284, NULL, 'L domain-like', 285443),
(471440, '0046244', NULL, NULL, 207, NULL, 'L domain-like', 285443),
(471441, '0048505', NULL, NULL, 384, NULL, 'L domain-like', 285443),
(471442, '0038752', NULL, NULL, 152, NULL, 'GntR ligand-binding domain-like', 285444),
(471443, '0054060', NULL, NULL, 138, NULL, 'GntR ligand-binding domain-like', 285444),
(471444, '0049231', NULL, NULL, 62, NULL, 'Rps17e-like', 285445),
(471445, '0051565', NULL, NULL, 301, NULL, 'Prenyltransferase-like', 285446),
(471446, '0051760', NULL, NULL, 333, NULL, 'Ribokinase-like', 285447),
(471447, '0052553', NULL, NULL, 313, NULL, 'Ribokinase-like', 285447),
(471448, '0046030', NULL, NULL, 342, NULL, 'Ribokinase-like', 285447),
(471449, '0050193', NULL, NULL, 288, NULL, 'Ribokinase-like', 285447),
(471450, '0044196', NULL, NULL, 450, NULL, 'Ribokinase-like', 285447),
(471451, '0051780', NULL, NULL, 319, NULL, 'Ribokinase-like', 285447),
(471452, '0044230', NULL, NULL, 454, NULL, 'Ribokinase-like', 285447),
(471453, '0050218', NULL, NULL, 288, NULL, 'Ribokinase-like', 285447),
(471454, '0051846', NULL, NULL, 278, NULL, 'Ribokinase-like', 285447),
(471455, '0051741', NULL, NULL, 306, NULL, 'Ribokinase-like', 285447),
(471456, '0047705', NULL, NULL, 266, NULL, 'Ribokinase-like', 285447),
(471457, '0047908', NULL, NULL, 275, NULL, 'Ribokinase-like', 285447),
(471458, '0046332', NULL, NULL, 354, NULL, 'Ribokinase-like', 285447),
(471459, '0046577', NULL, NULL, 269, NULL, 'Ribokinase-like', 285447),
(471460, '0049742', NULL, NULL, 304, NULL, 'Ribokinase-like', 285447),
(471461, '0049846', NULL, NULL, 258, NULL, 'Ribokinase-like', 285447),
(471462, '0052784', NULL, NULL, 308, NULL, 'Ribokinase-like', 285447),
(471463, '0052420', NULL, NULL, 308, NULL, 'Ribokinase-like', 285447),
(471464, '0050248', NULL, NULL, 299, NULL, 'Ribokinase-like', 285447),
(471465, '0038035', NULL, NULL, 467, NULL, 'Ribokinase-like', 285447),
(471466, '0040362', NULL, NULL, 451, NULL, 'Ribokinase-like', 285447),
(471467, '0044661', NULL, NULL, 264, NULL, 'Ribokinase-like', 285447),
(471468, '0043278', NULL, NULL, 306, NULL, 'Ribokinase-like', 285447),
(471469, '0044587', NULL, NULL, 302, NULL, 'Ribokinase-like', 285447),
(471470, '0040500', NULL, NULL, 309, NULL, 'Ribokinase-like', 285447),
(471471, '0049866', NULL, NULL, 51, NULL, 'Elafin-like', 285448),
(471472, '0053294', NULL, NULL, 57, NULL, 'Elafin-like', 285448),
(471473, '0036816', NULL, NULL, 272, NULL, 'ATP synthase (F1-ATPase), gamma subunit', 285449),
(471474, '0037751', NULL, NULL, 230, NULL, 'ATP synthase (F1-ATPase), gamma subunit', 285449),
(471475, '0040865', NULL, NULL, 270, NULL, 'ATP synthase (F1-ATPase), gamma subunit', 285449),
(471476, '0047240', NULL, NULL, 522, NULL, 'Galactose mutarotase-like', 285450),
(471477, '0048040', NULL, NULL, 329, NULL, 'Galactose mutarotase-like', 285450),
(471478, '0051663', NULL, NULL, 177, NULL, 'Galactose mutarotase-like', 285450),
(471479, '0052583', NULL, NULL, 247, NULL, 'Galactose mutarotase-like', 285450),
(471480, '0043394', NULL, NULL, 272, NULL, 'Galactose mutarotase-like', 285450),
(471481, '0036995', NULL, NULL, 274, NULL, 'Galactose mutarotase-like', 285450),
(471482, '0038644', NULL, NULL, 281, NULL, 'Galactose mutarotase-like', 285450),
(471483, '0037336', NULL, NULL, 300, NULL, 'Galactose mutarotase-like', 285450),
(471484, '0035897', NULL, NULL, 264, NULL, 'Galactose mutarotase-like', 285450),
(471485, '0051369', NULL, NULL, 302, NULL, 'Galactose mutarotase-like', 285450),
(471486, '0039850', NULL, NULL, 275, NULL, 'Galactose mutarotase-like', 285450),
(471487, '0044349', NULL, NULL, 272, NULL, 'Galactose mutarotase-like', 285450),
(471488, '0039310', NULL, NULL, 273, NULL, 'Galactose mutarotase-like', 285450),
(471489, '0038422', NULL, NULL, 268, NULL, 'Galactose mutarotase-like', 285450),
(471490, '0039682', NULL, NULL, 269, NULL, 'Galactose mutarotase-like', 285450);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(471491, '0040407', NULL, NULL, 339, NULL, 'Galactose mutarotase-like', 285450),
(471492, '0046376', NULL, NULL, 293, NULL, 'Galactose mutarotase-like', 285450),
(471493, '0044155', NULL, NULL, 374, NULL, 'Galactose mutarotase-like', 285450),
(471494, '0048510', NULL, NULL, 492, NULL, 'Galactose mutarotase-like', 285450),
(471495, '0051490', NULL, NULL, 342, NULL, 'Galactose mutarotase-like', 285450),
(471496, '0049429', NULL, NULL, 344, NULL, 'Galactose mutarotase-like', 285450),
(471497, '0044654', NULL, NULL, 270, NULL, 'Galactose mutarotase-like', 285450),
(471498, '0040478', NULL, NULL, 277, NULL, 'Galactose mutarotase-like', 285450),
(471499, '0041434', NULL, NULL, 250, NULL, 'Galactose mutarotase-like', 285450),
(471500, '0054691', NULL, NULL, 87, NULL, 'BRK domain-like', 285451),
(471501, '0054690', NULL, NULL, 55, NULL, 'BRK domain-like', 285451),
(471502, '0053776', NULL, NULL, 60, NULL, 'BRK domain-like', 285451),
(471503, '0053831', NULL, NULL, 70, NULL, 'BRK domain-like', 285451),
(471504, '0036649', NULL, NULL, 150, NULL, 'Aspartate/ornithine carbamoyltransferase', 285452),
(471505, '0036611', NULL, NULL, 150, NULL, 'Aspartate/ornithine carbamoyltransferase', 285452),
(471506, '0048182', NULL, NULL, 157, NULL, 'Aspartate/ornithine carbamoyltransferase', 285452),
(471507, '0036612', NULL, NULL, 183, NULL, 'Aspartate/ornithine carbamoyltransferase', 285452),
(471508, '0039730', NULL, NULL, 163, NULL, 'Aspartate/ornithine carbamoyltransferase', 285452),
(471509, '0042024', NULL, NULL, 170, NULL, 'Aspartate/ornithine carbamoyltransferase', 285452),
(471510, '0042299', NULL, NULL, 146, NULL, 'Aspartate/ornithine carbamoyltransferase', 285452),
(471511, '0042023', NULL, NULL, 151, NULL, 'Aspartate/ornithine carbamoyltransferase', 285452),
(471512, '0051827', NULL, NULL, 151, NULL, 'Aspartate/ornithine carbamoyltransferase', 285452),
(471513, '0036650', NULL, NULL, 185, NULL, 'Aspartate/ornithine carbamoyltransferase', 285452),
(471514, '0051826', NULL, NULL, 144, NULL, 'Aspartate/ornithine carbamoyltransferase', 285452),
(471515, '0049701', NULL, NULL, 311, NULL, 'Aspartate/ornithine carbamoyltransferase', 285452),
(471516, '0040987', NULL, NULL, 150, NULL, 'Aspartate/ornithine carbamoyltransferase', 285452),
(471517, '0045168', NULL, NULL, 155, NULL, 'Aspartate/ornithine carbamoyltransferase', 285452),
(471518, '0047669', NULL, NULL, 161, NULL, 'Aspartate/ornithine carbamoyltransferase', 285452),
(471519, '0044884', NULL, NULL, 152, NULL, 'Aspartate/ornithine carbamoyltransferase', 285452),
(471520, '0042300', NULL, NULL, 153, NULL, 'Aspartate/ornithine carbamoyltransferase', 285452),
(471521, '0044885', NULL, NULL, 161, NULL, 'Aspartate/ornithine carbamoyltransferase', 285452),
(471522, '0048833', NULL, NULL, 150, NULL, 'Aspartate/ornithine carbamoyltransferase', 285452),
(471523, '0048834', NULL, NULL, 163, NULL, 'Aspartate/ornithine carbamoyltransferase', 285452),
(471524, '0034989', NULL, NULL, 105, NULL, 'N-terminal domain of the delta subunit of the F1F0-ATP synthase', 285453),
(471525, '0054516', NULL, NULL, 80, NULL, 'T-antigen specific domain-like', 285454),
(471526, '0044921', NULL, NULL, 383, NULL, 'DmpA/ArgJ-like', 285455),
(471527, '0035366', NULL, NULL, 367, NULL, 'DmpA/ArgJ-like', 285455),
(471528, '0039312', NULL, NULL, 78, NULL, 'Crustacean CHH/MIH/GIH neurohormone', 285456),
(471529, '0054390', NULL, NULL, 75, NULL, 'AF1782-like', 285457),
(471530, '0054527', NULL, NULL, 75, NULL, 'AF1782-like', 285457),
(471531, '0042478', NULL, NULL, 46, NULL, 'Sporulation inhibitor Sda', 285458),
(471532, '0049921', NULL, NULL, 64, NULL, 'IscX-like', 285459),
(471533, '0050441', NULL, NULL, 344, NULL, 'QueA-like', 285460),
(471534, '0044849', NULL, NULL, 332, NULL, 'QueA-like', 285460),
(471535, '0052218', NULL, NULL, 101, NULL, 'RNA-binding domain, RBD', 285461),
(471536, '0050834', NULL, NULL, 101, NULL, 'RNA-binding domain, RBD', 285461),
(471537, '0052219', NULL, NULL, 85, NULL, 'RNA-binding domain, RBD', 285461),
(471538, '0052217', NULL, NULL, 86, NULL, 'RNA-binding domain, RBD', 285461);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(471539, '0049843', NULL, NULL, 77, NULL, 'RNA-binding domain, RBD', 285461),
(471540, '0047422', NULL, NULL, 75, NULL, 'RNA-binding domain, RBD', 285461),
(471541, '0052223', NULL, NULL, 86, NULL, 'RNA-binding domain, RBD', 285461),
(471542, '0053313', NULL, NULL, 85, NULL, 'RNA-binding domain, RBD', 285461),
(471543, '0052221', NULL, NULL, 94, NULL, 'RNA-binding domain, RBD', 285461),
(471544, '0052222', NULL, NULL, 89, NULL, 'RNA-binding domain, RBD', 285461),
(471545, '0049334', NULL, NULL, 103, NULL, 'RNA-binding domain, RBD', 285461),
(471546, '0046220', NULL, NULL, 80, NULL, 'RNA-binding domain, RBD', 285461),
(471547, '0045373', NULL, NULL, 75, NULL, 'RNA-binding domain, RBD', 285461),
(471548, '0050568', NULL, NULL, 97, NULL, 'RNA-binding domain, RBD', 285461),
(471549, '0052229', NULL, NULL, 102, NULL, 'RNA-binding domain, RBD', 285461),
(471550, '0050565', NULL, NULL, 100, NULL, 'RNA-binding domain, RBD', 285461),
(471551, '0050567', NULL, NULL, 111, NULL, 'RNA-binding domain, RBD', 285461),
(471552, '0050566', NULL, NULL, 99, NULL, 'RNA-binding domain, RBD', 285461),
(471553, '0052622', NULL, NULL, 114, NULL, 'RNA-binding domain, RBD', 285461),
(471554, '0050837', NULL, NULL, 90, NULL, 'RNA-binding domain, RBD', 285461),
(471555, '0050839', NULL, NULL, 93, NULL, 'RNA-binding domain, RBD', 285461),
(471556, '0050838', NULL, NULL, 83, NULL, 'RNA-binding domain, RBD', 285461),
(471557, '0045893', NULL, NULL, 82, NULL, 'RNA-binding domain, RBD', 285461),
(471558, '0048400', NULL, NULL, 78, NULL, 'RNA-binding domain, RBD', 285461),
(471559, '0052234', NULL, NULL, 101, NULL, 'RNA-binding domain, RBD', 285461),
(471560, '0052235', NULL, NULL, 93, NULL, 'RNA-binding domain, RBD', 285461),
(471561, '0052232', NULL, NULL, 90, NULL, 'RNA-binding domain, RBD', 285461),
(471562, '0052233', NULL, NULL, 88, NULL, 'RNA-binding domain, RBD', 285461),
(471563, '0052230', NULL, NULL, 103, NULL, 'RNA-binding domain, RBD', 285461),
(471564, '0052231', NULL, NULL, 102, NULL, 'RNA-binding domain, RBD', 285461),
(471565, '0037834', NULL, NULL, 85, NULL, 'RNA-binding domain, RBD', 285461),
(471566, '0053726', NULL, NULL, 83, NULL, 'RNA-binding domain, RBD', 285461),
(471567, '0050576', NULL, NULL, 75, NULL, 'RNA-binding domain, RBD', 285461),
(471568, '0052238', NULL, NULL, 89, NULL, 'RNA-binding domain, RBD', 285461),
(471569, '0052239', NULL, NULL, 83, NULL, 'RNA-binding domain, RBD', 285461),
(471570, '0052236', NULL, NULL, 101, NULL, 'RNA-binding domain, RBD', 285461),
(471571, '0050577', NULL, NULL, 104, NULL, 'RNA-binding domain, RBD', 285461),
(471572, '0050727', NULL, NULL, 81, NULL, 'RNA-binding domain, RBD', 285461),
(471573, '0054250', NULL, NULL, 104, NULL, 'RNA-binding domain, RBD', 285461),
(471574, '0046876', NULL, NULL, 82, NULL, 'RNA-binding domain, RBD', 285461),
(471575, '0047845', NULL, NULL, 96, NULL, 'RNA-binding domain, RBD', 285461),
(471576, '0052245', NULL, NULL, 90, NULL, 'RNA-binding domain, RBD', 285461),
(471577, '0052243', NULL, NULL, 90, NULL, 'RNA-binding domain, RBD', 285461),
(471578, '0047172', NULL, NULL, 75, NULL, 'RNA-binding domain, RBD', 285461),
(471579, '0052244', NULL, NULL, 80, NULL, 'RNA-binding domain, RBD', 285461),
(471580, '0052240', NULL, NULL, 103, NULL, 'RNA-binding domain, RBD', 285461),
(471581, '0050466', NULL, NULL, 112, NULL, 'RNA-binding domain, RBD', 285461),
(471582, '0052248', NULL, NULL, 86, NULL, 'RNA-binding domain, RBD', 285461),
(471583, '0052082', NULL, NULL, 79, NULL, 'RNA-binding domain, RBD', 285461),
(471584, '0053862', NULL, NULL, 85, NULL, 'RNA-binding domain, RBD', 285461),
(471585, '0050514', NULL, NULL, 98, NULL, 'RNA-binding domain, RBD', 285461),
(471586, '0050515', NULL, NULL, 104, NULL, 'RNA-binding domain, RBD', 285461),
(471587, '0050477', NULL, NULL, 104, NULL, 'RNA-binding domain, RBD', 285461),
(471588, '0052898', NULL, NULL, 75, NULL, 'RNA-binding domain, RBD', 285461),
(471589, '0050476', NULL, NULL, 104, NULL, 'RNA-binding domain, RBD', 285461),
(471590, '0052899', NULL, NULL, 86, NULL, 'RNA-binding domain, RBD', 285461);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(471591, '0050479', NULL, NULL, 88, NULL, 'RNA-binding domain, RBD', 285461),
(471592, '0050512', NULL, NULL, 88, NULL, 'RNA-binding domain, RBD', 285461),
(471593, '0050478', NULL, NULL, 102, NULL, 'RNA-binding domain, RBD', 285461),
(471594, '0052897', NULL, NULL, 81, NULL, 'RNA-binding domain, RBD', 285461),
(471595, '0036165', NULL, NULL, 89, NULL, 'RNA-binding domain, RBD', 285461),
(471596, '0049888', NULL, NULL, 95, NULL, 'RNA-binding domain, RBD', 285461),
(471597, '0047108', NULL, NULL, 146, NULL, 'RNA-binding domain, RBD', 285461),
(471598, '0049769', NULL, NULL, 183, NULL, 'RNA-binding domain, RBD', 285461),
(471599, '0049801', NULL, NULL, 139, NULL, 'RNA-binding domain, RBD', 285461),
(471600, '0048680', NULL, NULL, 104, NULL, 'RNA-binding domain, RBD', 285461),
(471601, '0049492', NULL, NULL, 97, NULL, 'RNA-binding domain, RBD', 285461),
(471602, '0050480', NULL, NULL, 110, NULL, 'RNA-binding domain, RBD', 285461),
(471603, '0047197', NULL, NULL, 143, NULL, 'RNA-binding domain, RBD', 285461),
(471604, '0048682', NULL, NULL, 92, NULL, 'RNA-binding domain, RBD', 285461),
(471605, '0050481', NULL, NULL, 98, NULL, 'RNA-binding domain, RBD', 285461),
(471606, '0052429', NULL, NULL, 73, NULL, 'RNA-binding domain, RBD', 285461),
(471607, '0042061', NULL, NULL, 113, NULL, 'RNA-binding domain, RBD', 285461),
(471608, '0050802', NULL, NULL, 95, NULL, 'RNA-binding domain, RBD', 285461),
(471609, '0041653', NULL, NULL, 104, NULL, 'RNA-binding domain, RBD', 285461),
(471610, '0046785', NULL, NULL, 116, NULL, 'RNA-binding domain, RBD', 285461),
(471611, '0047631', NULL, NULL, 104, NULL, 'RNA-binding domain, RBD', 285461),
(471612, '0049775', NULL, NULL, 90, NULL, 'RNA-binding domain, RBD', 285461),
(471613, '0042860', NULL, NULL, 88, NULL, 'RNA-binding domain, RBD', 285461),
(471614, '0049416', NULL, NULL, 108, NULL, 'RNA-binding domain, RBD', 285461),
(471615, '0051748', NULL, NULL, 98, NULL, 'RNA-binding domain, RBD', 285461),
(471616, '0045747', NULL, NULL, 94, NULL, 'RNA-binding domain, RBD', 285461),
(471617, '0050808', NULL, NULL, 96, NULL, 'RNA-binding domain, RBD', 285461),
(471618, '0050807', NULL, NULL, 99, NULL, 'RNA-binding domain, RBD', 285461),
(471619, '0050809', NULL, NULL, 98, NULL, 'RNA-binding domain, RBD', 285461),
(471620, '0050804', NULL, NULL, 95, NULL, 'RNA-binding domain, RBD', 285461),
(471621, '0050803', NULL, NULL, 103, NULL, 'RNA-binding domain, RBD', 285461),
(471622, '0050806', NULL, NULL, 72, NULL, 'RNA-binding domain, RBD', 285461),
(471623, '0050805', NULL, NULL, 89, NULL, 'RNA-binding domain, RBD', 285461),
(471624, '0046795', NULL, NULL, 96, NULL, 'RNA-binding domain, RBD', 285461),
(471625, '0046794', NULL, NULL, 101, NULL, 'RNA-binding domain, RBD', 285461),
(471626, '0052441', NULL, NULL, 96, NULL, 'RNA-binding domain, RBD', 285461),
(471627, '0052442', NULL, NULL, 99, NULL, 'RNA-binding domain, RBD', 285461),
(471628, '0046287', NULL, NULL, 85, NULL, 'RNA-binding domain, RBD', 285461),
(471629, '0046286', NULL, NULL, 89, NULL, 'RNA-binding domain, RBD', 285461),
(471630, '0048984', NULL, NULL, 110, NULL, 'RNA-binding domain, RBD', 285461),
(471631, '0044542', NULL, NULL, 91, NULL, 'RNA-binding domain, RBD', 285461),
(471632, '0045479', NULL, NULL, 88, NULL, 'RNA-binding domain, RBD', 285461),
(471633, '0039753', NULL, NULL, 273, NULL, 'RCC1/BLIP-II', 285462),
(471634, '0045691', NULL, NULL, 401, NULL, 'RCC1/BLIP-II', 285462),
(471635, '0053278', NULL, NULL, 301, NULL, 'Porins', 285463),
(471636, '0034817', NULL, NULL, 413, NULL, 'Porins', 285463),
(471637, '0046462', NULL, NULL, 332, NULL, 'Porins', 285463),
(471638, '0053328', NULL, NULL, 289, NULL, 'Porins', 285463),
(471639, '0045768', NULL, NULL, 421, NULL, 'Porins', 285463),
(471640, '0043833', NULL, NULL, 427, NULL, 'Porins', 285463),
(471641, '0047258', NULL, NULL, 340, NULL, 'Porins', 285463),
(471642, '0041517', NULL, NULL, 589, NULL, 'Porins', 285463),
(471643, '0046763', NULL, NULL, 714, NULL, 'Porins', 285463),
(471644, '0048764', NULL, NULL, 330, NULL, 'Porins', 285463),
(471645, '0053190', NULL, NULL, 427, NULL, 'Porins', 285463);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(471646, '0046039', NULL, NULL, 697, NULL, 'Porins', 285463),
(471647, '0048638', NULL, NULL, 342, NULL, 'Porins', 285463),
(471648, '0047833', NULL, NULL, 661, NULL, 'Porins', 285463),
(471649, '0053113', NULL, NULL, 145, NULL, 'TTHA0068-like', 285464),
(471650, '0052336', NULL, NULL, 94, NULL, 'TTHA0068-like', 285464),
(471651, '0051443', NULL, NULL, 357, NULL, 'Heme-dependent peroxidases', 285465),
(471652, '0052494', NULL, NULL, 336, NULL, 'Heme-dependent peroxidases', 285465),
(471653, '0044250', NULL, NULL, 406, NULL, 'Heme-dependent peroxidases', 285465),
(471654, '0044251', NULL, NULL, 294, NULL, 'Heme-dependent peroxidases', 285465),
(471655, '0035393', NULL, NULL, 349, NULL, 'Heme-dependent peroxidases', 285465),
(471656, '0041762', NULL, NULL, 250, NULL, 'Heme-dependent peroxidases', 285465),
(471657, '0043547', NULL, NULL, 294, NULL, 'Heme-dependent peroxidases', 285465),
(471658, '0041122', NULL, NULL, 308, NULL, 'Heme-dependent peroxidases', 285465),
(471659, '0041121', NULL, NULL, 406, NULL, 'Heme-dependent peroxidases', 285465),
(471660, '0045642', NULL, NULL, 305, NULL, 'Heme-dependent peroxidases', 285465),
(471661, '0042217', NULL, NULL, 306, NULL, 'Heme-dependent peroxidases', 285465),
(471662, '0042916', NULL, NULL, 344, NULL, 'Heme-dependent peroxidases', 285465),
(471663, '0035542', NULL, NULL, 309, NULL, 'Heme-dependent peroxidases', 285465),
(471664, '0052523', NULL, NULL, 291, NULL, 'Heme-dependent peroxidases', 285465),
(471665, '0035161', NULL, NULL, 249, NULL, 'Heme-dependent peroxidases', 285465),
(471666, '0039189', NULL, NULL, 308, NULL, 'Heme-dependent peroxidases', 285465),
(471667, '0042766', NULL, NULL, 300, NULL, 'Heme-dependent peroxidases', 285465),
(471668, '0037585', NULL, NULL, 304, NULL, 'Heme-dependent peroxidases', 285465),
(471669, '0039285', NULL, NULL, 275, NULL, 'Heme-dependent peroxidases', 285465),
(471670, '0039188', NULL, NULL, 406, NULL, 'Heme-dependent peroxidases', 285465),
(471671, '0046223', NULL, NULL, 511, NULL, 'Heme-dependent peroxidases', 285465),
(471672, '0046200', NULL, NULL, 510, NULL, 'Heme-dependent peroxidases', 285465),
(471673, '0046365', NULL, NULL, 571, NULL, 'Heme-dependent peroxidases', 285465),
(471674, '0049776', NULL, NULL, 292, NULL, 'Heme-dependent peroxidases', 285465),
(471675, '0040547', NULL, NULL, 343, NULL, 'Heme-dependent peroxidases', 285465),
(471676, '0043632', NULL, NULL, 412, NULL, 'Heme-dependent peroxidases', 285465),
(471677, '0043633', NULL, NULL, 285, NULL, 'Heme-dependent peroxidases', 285465),
(471678, '0054556', NULL, NULL, 114, NULL, 'YugN-like', 285466),
(471679, '0053959', NULL, NULL, 172, NULL, 'FLJ32549 domain-like', 285467),
(471680, '0036109', NULL, NULL, 224, NULL, 'Soluble secreted chemokine inhibitor, VCCI', 285468),
(471681, '0050518', NULL, NULL, 98, NULL, 'Putative methyltransferase TM0872, insert domain', 285469),
(471682, '0040828', NULL, NULL, 101, NULL, 'Putative methyltransferase TM0872, insert domain', 285469),
(471683, '0044049', NULL, NULL, 137, NULL, 'Hypothetical protein MG354', 285470),
(471684, '0053394', NULL, NULL, 68, NULL, 'Fibritin', 285471),
(471685, '0053492', NULL, NULL, 108, NULL, 'Fibritin', 285471),
(471686, '0053391', NULL, NULL, 113, NULL, 'Fibritin', 285471),
(471687, '0039001', NULL, NULL, 85, NULL, 'Thiamin pyrophosphokinase, substrate-binding domain', 285472),
(471688, '0047356', NULL, NULL, 96, NULL, 'Thiamin pyrophosphokinase, substrate-binding domain', 285472),
(471689, '0037997', NULL, NULL, 90, NULL, 'Tetraspanin', 285473),
(471690, '0042580', NULL, NULL, 70, NULL, 'DEK C-terminal domain', 285474),
(471691, '0044946', NULL, NULL, 68, NULL, 'TRAP-like', 285475),
(471692, '0051361', NULL, NULL, 240, NULL, 'TRAP-like', 285475),
(471693, '0048752', NULL, NULL, 227, NULL, 'TRAP-like', 285475),
(471694, '0035888', NULL, NULL, 69, NULL, 'TRAP-like', 285475),
(471695, '0037364', NULL, NULL, 101, NULL, 'LexA/Signal peptidase', 285476),
(471696, '0044449', NULL, NULL, 105, NULL, 'LexA/Signal peptidase', 285476),
(471697, '0039545', NULL, NULL, 126, NULL, 'LexA/Signal peptidase', 285476);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(471698, '0035304', NULL, NULL, 247, NULL, 'LexA/Signal peptidase', 285476),
(471699, '0049172', NULL, NULL, 333, NULL, 'Putative isomerase YbhE', 285477),
(471700, '0037362', NULL, NULL, 162, NULL, 'Olfactory marker protein', 285478),
(471701, '0053401', NULL, NULL, 101, NULL, 'Coiled-coil dimerization domain from cortexillin I', 285479),
(471702, '0053493', NULL, NULL, 29, NULL, 'Coiled-coil dimerization domain from cortexillin I', 285479),
(471703, '0045471', NULL, NULL, 226, NULL, 'Thiamin phosphate synthase', 285480),
(471704, '0045046', NULL, NULL, 206, NULL, 'Thiamin phosphate synthase', 285480),
(471705, '0038852', NULL, NULL, 277, NULL, 'Second domain of Mu2 adaptin subunit (ap50) of ap2 adaptor', 285481),
(471706, '0053829', NULL, NULL, 56, NULL, 'Zinc hairpin stack', 285482),
(471707, '0054227', NULL, NULL, 96, NULL, 'YkvR-like', 285483),
(471708, '0052861', NULL, NULL, 142, NULL, 'cAMP-binding domain-like', 285484),
(471709, '0054435', NULL, NULL, 134, NULL, 'cAMP-binding domain-like', 285484),
(471710, '0048340', NULL, NULL, 132, NULL, 'cAMP-binding domain-like', 285484),
(471711, '0050263', NULL, NULL, 133, NULL, 'cAMP-binding domain-like', 285484),
(471712, '0054017', NULL, NULL, 129, NULL, 'cAMP-binding domain-like', 285484),
(471713, '0050530', NULL, NULL, 137, NULL, 'cAMP-binding domain-like', 285484),
(471714, '0052199', NULL, NULL, 112, NULL, 'cAMP-binding domain-like', 285484),
(471715, '0048492', NULL, NULL, 129, NULL, 'cAMP-binding domain-like', 285484),
(471716, '0048882', NULL, NULL, 193, NULL, 'cAMP-binding domain-like', 285484),
(471717, '0046232', NULL, NULL, 147, NULL, 'cAMP-binding domain-like', 285484),
(471718, '0046231', NULL, NULL, 136, NULL, 'cAMP-binding domain-like', 285484),
(471719, '0054946', NULL, NULL, 139, NULL, 'cAMP-binding domain-like', 285484),
(471720, '0051666', NULL, NULL, 147, NULL, 'cAMP-binding domain-like', 285484),
(471721, '0048512', NULL, NULL, 155, NULL, 'cAMP-binding domain-like', 285484),
(471722, '0048600', NULL, NULL, 133, NULL, 'cAMP-binding domain-like', 285484),
(471723, '0047248', NULL, NULL, 137, NULL, 'cAMP-binding domain-like', 285484),
(471724, '0048513', NULL, NULL, 124, NULL, 'cAMP-binding domain-like', 285484),
(471725, '0046856', NULL, NULL, 132, NULL, 'cAMP-binding domain-like', 285484),
(471726, '0048339', NULL, NULL, 136, NULL, 'cAMP-binding domain-like', 285484),
(471727, '0044344', NULL, NULL, 128, NULL, 'Domain from hypothetical 2610208m17rik protein', 285485),
(471728, '0054235', NULL, NULL, 184, NULL, 'SopE-like GEF domain', 285486),
(471729, '0043145', NULL, NULL, 168, NULL, 'SopE-like GEF domain', 285486),
(471730, '0038349', NULL, NULL, 165, NULL, 'SopE-like GEF domain', 285486),
(471731, '0054204', NULL, NULL, 47, NULL, 'Ran binding protein zinc finger-like', 285487),
(471732, '0052255', NULL, NULL, 41, NULL, 'Ran binding protein zinc finger-like', 285487),
(471733, '0048377', NULL, NULL, 31, NULL, 'Ran binding protein zinc finger-like', 285487),
(471734, '0052121', NULL, NULL, 46, NULL, 'Ran binding protein zinc finger-like', 285487),
(471735, '0048257', NULL, NULL, 45, NULL, 'Ran binding protein zinc finger-like', 285487),
(471736, '0053966', NULL, NULL, 29, NULL, 'Ran binding protein zinc finger-like', 285487),
(471737, '0051067', NULL, NULL, 378, NULL, 'Serpins', 285488),
(471738, '0034927', NULL, NULL, 378, NULL, 'Serpins', 285488),
(471739, '0042041', NULL, NULL, 385, NULL, 'Serpins', 285488),
(471740, '0035774', NULL, NULL, 381, NULL, 'Serpins', 285488),
(471741, '0038626', NULL, NULL, 376, NULL, 'Serpins', 285488),
(471742, '0037307', NULL, NULL, 342, NULL, 'Serpins', 285488),
(471743, '0039986', NULL, NULL, 376, NULL, 'Serpins', 285488),
(471744, '0036689', NULL, NULL, 429, NULL, 'Serpins', 285488),
(471745, '0035184', NULL, NULL, 370, NULL, 'Serpins', 285488),
(471746, '0039630', NULL, NULL, 420, NULL, 'Serpins', 285488),
(471747, '0039087', NULL, NULL, 383, NULL, 'Serpins', 285488),
(471748, '0041076', NULL, NULL, 356, NULL, 'Serpins', 285488),
(471749, '0035196', NULL, NULL, 421, NULL, 'Serpins', 285488);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(471750, '0043572', NULL, NULL, 376, NULL, 'Serpins', 285488),
(471751, '0039580', NULL, NULL, 336, NULL, 'Serpins', 285488),
(471752, '0040612', NULL, NULL, 359, NULL, 'Serpins', 285488),
(471753, '0042850', NULL, NULL, 372, NULL, 'Serpins', 285488),
(471754, '0042501', NULL, NULL, 447, NULL, 'MFS general substrate transporter', 285489),
(471755, '0042480', NULL, NULL, 417, NULL, 'MFS general substrate transporter', 285489),
(471756, '0043732', NULL, NULL, 336, NULL, 'Rap/Ran-GAP', 285490),
(471757, '0048648', NULL, NULL, 265, NULL, 'HCP-like', 285491),
(471758, '0047832', NULL, NULL, 133, NULL, 'HCP-like', 285491),
(471759, '0043818', NULL, NULL, 81, NULL, 'YggX-like', 285492),
(471760, '0051091', NULL, NULL, 91, NULL, 'YggX-like', 285492),
(471761, '0040532', NULL, NULL, 104, NULL, 'Head-binding domain of phage P22 tailspike protein', 285493),
(471762, '0054195', NULL, NULL, 134, NULL, 'Taf5 N-terminal domain-like', 285494),
(471763, '0054196', NULL, NULL, 131, NULL, 'Taf5 N-terminal domain-like', 285494),
(471764, '0054308', NULL, NULL, 149, NULL, 'Taf5 N-terminal domain-like', 285494),
(471765, '0051255', NULL, NULL, 151, NULL, 'Cu,Zn superoxide dismutase-like', 285495),
(471766, '0049454', NULL, NULL, 154, NULL, 'Cu,Zn superoxide dismutase-like', 285495),
(471767, '0049662', NULL, NULL, 156, NULL, 'Cu,Zn superoxide dismutase-like', 285495),
(471768, '0051813', NULL, NULL, 155, NULL, 'Cu,Zn superoxide dismutase-like', 285495),
(471769, '0046366', NULL, NULL, 154, NULL, 'Cu,Zn superoxide dismutase-like', 285495),
(471770, '0047610', NULL, NULL, 172, NULL, 'Cu,Zn superoxide dismutase-like', 285495),
(471771, '0048149', NULL, NULL, 153, NULL, 'Cu,Zn superoxide dismutase-like', 285495),
(471772, '0048853', NULL, NULL, 171, NULL, 'Cu,Zn superoxide dismutase-like', 285495),
(471773, '0046610', NULL, NULL, 155, NULL, 'Cu,Zn superoxide dismutase-like', 285495),
(471774, '0051094', NULL, NULL, 150, NULL, 'Cu,Zn superoxide dismutase-like', 285495),
(471775, '0046103', NULL, NULL, 151, NULL, 'Cu,Zn superoxide dismutase-like', 285495),
(471776, '0046620', NULL, NULL, 154, NULL, 'Cu,Zn superoxide dismutase-like', 285495),
(471777, '0046679', NULL, NULL, 153, NULL, 'Cu,Zn superoxide dismutase-like', 285495),
(471778, '0050253', NULL, NULL, 136, NULL, 'YjbQ-like', 285496),
(471779, '0050270', NULL, NULL, 138, NULL, 'YjbQ-like', 285496),
(471780, '0050256', NULL, NULL, 139, NULL, 'YjbQ-like', 285496),
(471781, '0045027', NULL, NULL, 131, NULL, 'YjbQ-like', 285496),
(471782, '0043927', NULL, NULL, 67, NULL, 'TAF(II)230 TBP-binding fragment', 285497),
(471783, '0051728', NULL, NULL, 167, NULL, 'CinA-like', 285498),
(471784, '0054153', NULL, NULL, 469, NULL, 'flu NP-like', 285499),
(471785, '0043865', NULL, NULL, 152, NULL, 'PurS-like', 285500),
(471786, '0050284', NULL, NULL, 86, NULL, 'PurS-like', 285500),
(471787, '0038258', NULL, NULL, 82, NULL, 'PurS-like', 285500),
(471788, '0043874', NULL, NULL, 80, NULL, 'PurS-like', 285500),
(471789, '0053994', NULL, NULL, 198, NULL, 'Ribosomal protein L4', 285501),
(471790, '0054774', NULL, NULL, 197, NULL, 'Ribosomal protein L4', 285501),
(471791, '0037531', NULL, NULL, 246, NULL, 'Ribosomal protein L4', 285501),
(471792, '0054178', NULL, NULL, 208, NULL, 'Ribosomal protein L4', 285501),
(471793, '0036499', NULL, NULL, 225, NULL, 'Ribosomal protein L4', 285501),
(471794, '0054231', NULL, NULL, 59, NULL, 'Trm112p-like', 285502),
(471795, '0054030', NULL, NULL, 59, NULL, 'Trm112p-like', 285502),
(471796, '0054515', NULL, NULL, 59, NULL, 'Trm112p-like', 285502),
(471797, '0040400', NULL, NULL, 121, NULL, 'Thiol:disulfide interchange protein DsbD, N-terminal domain (DsbD-alpha)', 285503),
(471798, '0053046', NULL, NULL, 120, NULL, 'YppE-like', 285504),
(471799, '0052518', NULL, NULL, 110, NULL, 'YppE-like', 285504),
(471800, '0053116', NULL, NULL, 123, NULL, 'YppE-like', 285504),
(471801, '0046182', NULL, NULL, 127, NULL, 'p53-like transcription factors', 285505),
(471802, '0048196', NULL, NULL, 303, NULL, 'p53-like transcription factors', 285505),
(471803, '0047380', NULL, NULL, 173, NULL, 'p53-like transcription factors', 285505);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(471804, '0049543', NULL, NULL, 196, NULL, 'p53-like transcription factors', 285505),
(471805, '0048353', NULL, NULL, 212, NULL, 'p53-like transcription factors', 285505),
(471806, '0034796', NULL, NULL, 178, NULL, 'p53-like transcription factors', 285505),
(471807, '0038725', NULL, NULL, 186, NULL, 'p53-like transcription factors', 285505),
(471808, '0034898', NULL, NULL, 178, NULL, 'p53-like transcription factors', 285505),
(471809, '0038434', NULL, NULL, 184, NULL, 'p53-like transcription factors', 285505),
(471810, '0050006', NULL, NULL, 217, NULL, 'p53-like transcription factors', 285505),
(471811, '0045080', NULL, NULL, 191, NULL, 'p53-like transcription factors', 285505),
(471812, '0045705', NULL, NULL, 184, NULL, 'p53-like transcription factors', 285505),
(471813, '0045949', NULL, NULL, 252, NULL, 'p53-like transcription factors', 285505),
(471814, '0044112', NULL, NULL, 185, NULL, 'p53-like transcription factors', 285505),
(471815, '0046018', NULL, NULL, 175, NULL, 'p53-like transcription factors', 285505),
(471816, '0046997', NULL, NULL, 175, NULL, 'p53-like transcription factors', 285505),
(471817, '0045953', NULL, NULL, 254, NULL, 'p53-like transcription factors', 285505),
(471818, '0039080', NULL, NULL, 180, NULL, 'p53-like transcription factors', 285505),
(471819, '0045029', NULL, NULL, 184, NULL, 'p53-like transcription factors', 285505),
(471820, '0053442', NULL, NULL, 53, NULL, 'Inovirus (filamentous phage) major coat protein', 285506),
(471821, '0053443', NULL, NULL, 44, NULL, 'Inovirus (filamentous phage) major coat protein', 285506),
(471822, '0053498', NULL, NULL, 46, NULL, 'Inovirus (filamentous phage) major coat protein', 285506),
(471823, '0053441', NULL, NULL, 51, NULL, 'Inovirus (filamentous phage) major coat protein', 285506),
(471824, '0053573', NULL, NULL, 46, NULL, 'Inovirus (filamentous phage) major coat protein', 285506),
(471825, '0053437', NULL, NULL, 46, NULL, 'Inovirus (filamentous phage) major coat protein', 285506),
(471826, '0053559', NULL, NULL, 50, NULL, 'Inovirus (filamentous phage) major coat protein', 285506),
(471827, '0040144', NULL, NULL, 197, NULL, 'The spindle assembly checkpoint protein mad2', 285507),
(471828, '0044195', NULL, NULL, 143, NULL, 'OmpH-like', 285508),
(471829, '0054284', NULL, NULL, 91, NULL, 'YdgH-like', 285509),
(471830, '0054228', NULL, NULL, 96, NULL, 'YdgH-like', 285509),
(471831, '0052695', NULL, NULL, 83, NULL, 'ImmE5-like', 285510),
(471832, '0040398', NULL, NULL, 159, NULL, 'Retrovirus capsid protein, N-terminal core domain', 285511),
(471833, '0048709', NULL, NULL, 176, NULL, 'Retrovirus capsid protein, N-terminal core domain', 285511),
(471834, '0042959', NULL, NULL, 131, NULL, 'Retrovirus capsid protein, N-terminal core domain', 285511),
(471835, '0049811', NULL, NULL, 131, NULL, 'Retrovirus capsid protein, N-terminal core domain', 285511),
(471836, '0037867', NULL, NULL, 134, NULL, 'Retrovirus capsid protein, N-terminal core domain', 285511),
(471837, '0045256', NULL, NULL, 131, NULL, 'Retrovirus capsid protein, N-terminal core domain', 285511),
(471838, '0051034', NULL, NULL, 131, NULL, 'Hypothetical protein YqbG', 285512),
(471839, '0048588', NULL, NULL, 292, NULL, 'Mitochondrial carrier', 285513),
(471840, '0050032', NULL, NULL, 229, NULL, 'Electron transport accessory proteins', 285514),
(471841, '0047551', NULL, NULL, 69, NULL, 'Electron transport accessory proteins', 285514),
(471842, '0047076', NULL, NULL, 73, NULL, 'Electron transport accessory proteins', 285514),
(471843, '0052937', NULL, NULL, 59, NULL, 'Electron transport accessory proteins', 285514),
(471844, '0047424', NULL, NULL, 228, NULL, 'Electron transport accessory proteins', 285514),
(471845, '0049006', NULL, NULL, 70, NULL, 'Electron transport accessory proteins', 285514),
(471846, '0036454', NULL, NULL, 73, NULL, 'Electron transport accessory proteins', 285514),
(471847, '0048811', NULL, NULL, 69, NULL, 'Electron transport accessory proteins', 285514),
(471848, '0051765', NULL, NULL, 211, NULL, 'Electron transport accessory proteins', 285514);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(471849, '0048731', NULL, NULL, 162, NULL, 'eEF1-gamma domain', 285515),
(471850, '0054094', NULL, NULL, 74, NULL, 'DnaD domain-like', 285516),
(471851, '0044734', NULL, NULL, 215, NULL, 'Poly A polymerase C-terminal region-like', 285517),
(471852, '0042030', NULL, NULL, 204, NULL, 'Poly A polymerase C-terminal region-like', 285517),
(471853, '0040956', NULL, NULL, 265, NULL, 'Poly A polymerase C-terminal region-like', 285517),
(471854, '0039587', NULL, NULL, 79, NULL, 'Quinohemoprotein amine dehydrogenase C chain', 285518),
(471855, '0039649', NULL, NULL, 77, NULL, 'Quinohemoprotein amine dehydrogenase C chain', 285518),
(471856, '0034858', NULL, NULL, 101, NULL, 'PK beta-barrel domain-like', 285519),
(471857, '0042358', NULL, NULL, 102, NULL, 'PK beta-barrel domain-like', 285519),
(471858, '0042000', NULL, NULL, 182, NULL, 'PK beta-barrel domain-like', 285519),
(471859, '0041702', NULL, NULL, 233, NULL, 'PK beta-barrel domain-like', 285519),
(471860, '0034866', NULL, NULL, 102, NULL, 'PK beta-barrel domain-like', 285519),
(471861, '0040512', NULL, NULL, 102, NULL, 'PK beta-barrel domain-like', 285519),
(471862, '0042355', NULL, NULL, 99, NULL, 'PK beta-barrel domain-like', 285519),
(471863, '0036700', NULL, NULL, 98, NULL, 'PK beta-barrel domain-like', 285519),
(471864, '0048273', NULL, NULL, 119, NULL, 'SET domain', 285520),
(471865, '0048183', NULL, NULL, 284, NULL, 'SET domain', 285520),
(471866, '0041233', NULL, NULL, 168, NULL, 'SET domain', 285520),
(471867, '0040998', NULL, NULL, 261, NULL, 'SET domain', 285520),
(471868, '0048228', NULL, NULL, 269, NULL, 'SET domain', 285520),
(471869, '0053861', NULL, NULL, 129, NULL, 'ThrRS/AlaRS common domain', 285521),
(471870, '0042737', NULL, NULL, 179, NULL, 'ThrRS/AlaRS common domain', 285521),
(471871, '0044651', NULL, NULL, 155, NULL, 'ThrRS/AlaRS common domain', 285521),
(471872, '0041633', NULL, NULL, 179, NULL, 'ThrRS/AlaRS common domain', 285521),
(471873, '0037625', NULL, NULL, 83, NULL, 'Ribosomal protein S16', 285522),
(471874, '0053989', NULL, NULL, 78, NULL, 'Ribosomal protein S16', 285522),
(471875, '0054837', NULL, NULL, 101, NULL, 'Ribosomal protein S16', 285522),
(471876, '0051014', NULL, NULL, 116, NULL, 'Voltage-gated potassium channels', 285523),
(471877, '0040580', NULL, NULL, 80, NULL, 'Voltage-gated potassium channels', 285523),
(471878, '0042184', NULL, NULL, 116, NULL, 'Voltage-gated potassium channels', 285523),
(471879, '0053690', NULL, NULL, 97, NULL, 'Voltage-gated potassium channels', 285523),
(471880, '0037417', NULL, NULL, 160, NULL, 'Voltage-gated potassium channels', 285523),
(471881, '0041998', NULL, NULL, 223, NULL, 'Voltage-gated potassium channels', 285523),
(471882, '0048230', NULL, NULL, 549, NULL, 'ssDNA viruses', 285524),
(471883, '0045196', NULL, NULL, 175, NULL, 'ssDNA viruses', 285524),
(471884, '0045195', NULL, NULL, 426, NULL, 'ssDNA viruses', 285524),
(471885, '0040716', NULL, NULL, 187, NULL, 'ssDNA viruses', 285524),
(471886, '0049320', NULL, NULL, 536, NULL, 'ssDNA viruses', 285524),
(471887, '0046092', NULL, NULL, 548, NULL, 'ssDNA viruses', 285524),
(471888, '0036514', NULL, NULL, 415, NULL, 'ssDNA viruses', 285524),
(471889, '0040289', NULL, NULL, 497, NULL, 'ssDNA viruses', 285524),
(471890, '0038077', NULL, NULL, 417, NULL, 'ssDNA viruses', 285524),
(471891, '0048006', NULL, NULL, 519, NULL, 'ssDNA viruses', 285524),
(471892, '0040715', NULL, NULL, 422, NULL, 'ssDNA viruses', 285524),
(471893, '0047743', NULL, NULL, 542, NULL, 'ssDNA viruses', 285524),
(471894, '0046974', NULL, NULL, 177, NULL, 'ssDNA viruses', 285524),
(471895, '0048472', NULL, NULL, 112, NULL, 'Oxygen-evolving enhancer protein 3,', 285525),
(471896, '0050021', NULL, NULL, 74, NULL, 'MoeA C-terminal domain-like', 285526),
(471897, '0043849', NULL, NULL, 83, NULL, 'MoeA C-terminal domain-like', 285526),
(471898, '0050700', NULL, NULL, 72, NULL, 'MoeA C-terminal domain-like', 285526),
(471899, '0050974', NULL, NULL, 72, NULL, 'MoeA C-terminal domain-like', 285526),
(471900, '0046943', NULL, NULL, 83, NULL, 'MoeA C-terminal domain-like', 285526); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(471901, '0036595', NULL, NULL, 202, NULL, 'E2 regulatory, transactivation domain', 285527),
(471902, '0043150', NULL, NULL, 196, NULL, 'E2 regulatory, transactivation domain', 285527),
(471903, '0042936', NULL, NULL, 144, NULL, 'E2 regulatory, transactivation domain', 285527),
(471904, '0044126', NULL, NULL, 194, NULL, 'E2 regulatory, transactivation domain', 285527),
(471905, '0041725', NULL, NULL, 200, NULL, 'Tp47 lipoprotein, N-terminal domain', 285528),
(471906, '0054015', NULL, NULL, 132, NULL, 'TerB-like', 285529),
(471907, '0054415', NULL, NULL, 160, NULL, 'TerB-like', 285529),
(471908, '0054881', NULL, NULL, 224, NULL, '5''-nucleotidase (syn. UDP-sugar hydrolase), C-terminal domain', 285530),
(471909, '0047215', NULL, NULL, 188, NULL, '5''-nucleotidase (syn. UDP-sugar hydrolase), C-terminal domain', 285530),
(471910, '0054757', NULL, NULL, 205, NULL, '5''-nucleotidase (syn. UDP-sugar hydrolase), C-terminal domain', 285530),
(471911, '0053004', NULL, NULL, 326, NULL, 'HD-domain/PDEase-like', 285531),
(471912, '0054512', NULL, NULL, 215, NULL, 'HD-domain/PDEase-like', 285531),
(471913, '0054941', NULL, NULL, 212, NULL, 'HD-domain/PDEase-like', 285531),
(471914, '0050288', NULL, NULL, 286, NULL, 'HD-domain/PDEase-like', 285531),
(471915, '0053047', NULL, NULL, 258, NULL, 'HD-domain/PDEase-like', 285531),
(471916, '0053234', NULL, NULL, 453, NULL, 'HD-domain/PDEase-like', 285531),
(471917, '0051140', NULL, NULL, 172, NULL, 'HD-domain/PDEase-like', 285531),
(471918, '0049586', NULL, NULL, 357, NULL, 'HD-domain/PDEase-like', 285531),
(471919, '0049430', NULL, NULL, 415, NULL, 'HD-domain/PDEase-like', 285531),
(471920, '0053263', NULL, NULL, 186, NULL, 'HD-domain/PDEase-like', 285531),
(471921, '0054608', NULL, NULL, 216, NULL, 'HD-domain/PDEase-like', 285531),
(471922, '0054806', NULL, NULL, 201, NULL, 'HD-domain/PDEase-like', 285531),
(471923, '0051349', NULL, NULL, 167, NULL, 'HD-domain/PDEase-like', 285531),
(471924, '0054937', NULL, NULL, 213, NULL, 'HD-domain/PDEase-like', 285531),
(471925, '0054539', NULL, NULL, 217, NULL, 'HD-domain/PDEase-like', 285531),
(471926, '0049193', NULL, NULL, 326, NULL, 'HD-domain/PDEase-like', 285531),
(471927, '0054007', NULL, NULL, 200, NULL, 'HD-domain/PDEase-like', 285531),
(471928, '0053007', NULL, NULL, 369, NULL, 'HD-domain/PDEase-like', 285531),
(471929, '0049806', NULL, NULL, 197, NULL, 'HD-domain/PDEase-like', 285531),
(471930, '0053085', NULL, NULL, 249, NULL, 'HD-domain/PDEase-like', 285531),
(471931, '0048665', NULL, NULL, 334, NULL, 'HD-domain/PDEase-like', 285531),
(471932, '0049588', NULL, NULL, 326, NULL, 'HD-domain/PDEase-like', 285531),
(471933, '0044798', NULL, NULL, 192, NULL, 'HD-domain/PDEase-like', 285531),
(471934, '0046668', NULL, NULL, 357, NULL, 'HD-domain/PDEase-like', 285531),
(471935, '0053942', NULL, NULL, 468, NULL, 'Poly(A) polymerase catalytic subunit-like', 285532),
(471936, '0036607', NULL, NULL, 69, NULL, 'Signal peptide-binding domain', 285533),
(471937, '0043060', NULL, NULL, 138, NULL, 'Signal peptide-binding domain', 285533),
(471938, '0038671', NULL, NULL, 104, NULL, 'Signal peptide-binding domain', 285533),
(471939, '0042692', NULL, NULL, 107, NULL, 'Signal peptide-binding domain', 285533),
(471940, '0045276', NULL, NULL, 100, NULL, 'Signal peptide-binding domain', 285533),
(471941, '0054574', NULL, NULL, 131, NULL, 'Ava3019-like', 285534),
(471942, '0046989', NULL, NULL, 79, NULL, 'Single hybrid motif', 285535),
(471943, '0038124', NULL, NULL, 81, NULL, 'Single hybrid motif', 285535),
(471944, '0048969', NULL, NULL, 80, NULL, 'Single hybrid motif', 285535),
(471945, '0048508', NULL, NULL, 84, NULL, 'Single hybrid motif', 285535),
(471946, '0051241', NULL, NULL, 102, NULL, 'Single hybrid motif', 285535),
(471947, '0047951', NULL, NULL, 80, NULL, 'Single hybrid motif', 285535),
(471948, '0042385', NULL, NULL, 80, NULL, 'Single hybrid motif', 285535),
(471949, '0038716', NULL, NULL, 131, NULL, 'Single hybrid motif', 285535),
(471950, '0047477', NULL, NULL, 79, NULL, 'Single hybrid motif', 285535),
(471951, '0047763', NULL, NULL, 87, NULL, 'Single hybrid motif', 285535);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(471952, '0048610', NULL, NULL, 127, NULL, 'Single hybrid motif', 285535),
(471953, '0035479', NULL, NULL, 80, NULL, 'Single hybrid motif', 285535),
(471954, '0054499', NULL, NULL, 108, NULL, 'RbcX-like', 285536),
(471955, '0054498', NULL, NULL, 115, NULL, 'RbcX-like', 285536),
(471956, '0054558', NULL, NULL, 120, NULL, 'RbcX-like', 285536),
(471957, '0034839', NULL, NULL, 135, NULL, 'Domain of poly(ADP-ribose) polymerase', 285537),
(471958, '0044402', NULL, NULL, 137, NULL, 'Domain of poly(ADP-ribose) polymerase', 285537),
(471959, '0038239', NULL, NULL, 134, NULL, 'Domain of poly(ADP-ribose) polymerase', 285537),
(471960, '0043736', NULL, NULL, 50, NULL, 'Pollen allergen ole e 6', 285538),
(471961, '0047012', NULL, NULL, 99, NULL, 'RecG, N-terminal domain', 285539),
(471962, '0052175', NULL, NULL, 179, NULL, 'Cloroperoxidase', 285540),
(471963, '0052174', NULL, NULL, 120, NULL, 'Cloroperoxidase', 285540),
(471964, '0054373', NULL, NULL, 128, NULL, 'YueI-like', 285541),
(471965, '0044340', NULL, NULL, 88, NULL, 'Surp module (SWAP domain)', 285542),
(471966, '0053848', NULL, NULL, 84, NULL, 'Surp module (SWAP domain)', 285542),
(471967, '0053637', NULL, NULL, 65, NULL, 'Surp module (SWAP domain)', 285542),
(471968, '0053638', NULL, NULL, 53, NULL, 'Surp module (SWAP domain)', 285542),
(471969, '0053847', NULL, NULL, 63, NULL, 'Surp module (SWAP domain)', 285542),
(471970, '0037881', NULL, NULL, 102, NULL, 'Monooxygenase (hydroxylase) regulatory protein', 285543),
(471971, '0038675', NULL, NULL, 90, NULL, 'Monooxygenase (hydroxylase) regulatory protein', 285543),
(471972, '0036039', NULL, NULL, 141, NULL, 'Monooxygenase (hydroxylase) regulatory protein', 285543),
(471973, '0045369', NULL, NULL, 94, NULL, 'Monooxygenase (hydroxylase) regulatory protein', 285543),
(471974, '0046652', NULL, NULL, 92, NULL, 'Ada DNA repair protein, N-terminal domain (N-Ada 10)', 285544),
(471975, '0051142', NULL, NULL, 138, NULL, 'Ecotin, trypsin inhibitor', 285545),
(471976, '0053579', NULL, NULL, 131, NULL, 'Ecotin, trypsin inhibitor', 285545),
(471977, '0046440', NULL, NULL, 102, NULL, 'Enzyme IIa from lactose specific PTS, IIa-lac', 285546),
(471978, '0038570', NULL, NULL, 99, NULL, 'Cell-division inhibitor MinC, N-terminal domain', 285547),
(471979, '0043231', NULL, NULL, 89, NULL, 'Resistin', 285548),
(471980, '0043237', NULL, NULL, 81, NULL, 'Resistin', 285548),
(471981, '0036361', NULL, NULL, 71, NULL, 'ClpS-like', 285549),
(471982, '0036150', NULL, NULL, 68, NULL, 'ClpS-like', 285549),
(471983, '0040877', NULL, NULL, 87, NULL, 'ClpS-like', 285549),
(471984, '0054767', NULL, NULL, 71, NULL, 'ClpS-like', 285549),
(471985, '0049470', NULL, NULL, 195, NULL, 'Hemopexin-like domain', 285550),
(471986, '0046971', NULL, NULL, 200, NULL, 'Hemopexin-like domain', 285550),
(471987, '0047435', NULL, NULL, 195, NULL, 'Hemopexin-like domain', 285550),
(471988, '0046742', NULL, NULL, 195, NULL, 'Hemopexin-like domain', 285550),
(471989, '0048961', NULL, NULL, 192, NULL, 'Hemopexin-like domain', 285550),
(471990, '0047257', NULL, NULL, 210, NULL, 'Hemopexin-like domain', 285550),
(471991, '0048745', NULL, NULL, 192, NULL, 'Hemopexin-like domain', 285550),
(471992, '0052021', NULL, NULL, 98, NULL, 'Cystatin/monellin', 285551),
(471993, '0052022', NULL, NULL, 119, NULL, 'Cystatin/monellin', 285551),
(471994, '0050887', NULL, NULL, 171, NULL, 'Cystatin/monellin', 285551),
(471995, '0053976', NULL, NULL, 63, NULL, 'Cystatin/monellin', 285551),
(471996, '0037137', NULL, NULL, 102, NULL, 'Cystatin/monellin', 285551),
(471997, '0053977', NULL, NULL, 65, NULL, 'Cystatin/monellin', 285551),
(471998, '0043756', NULL, NULL, 98, NULL, 'Cystatin/monellin', 285551),
(471999, '0043319', NULL, NULL, 111, NULL, 'Cystatin/monellin', 285551),
(472000, '0046949', NULL, NULL, 111, NULL, 'Cystatin/monellin', 285551),
(472001, '0048202', NULL, NULL, 94, NULL, 'Cystatin/monellin', 285551),
(472002, '0046125', NULL, NULL, 108, NULL, 'Cystatin/monellin', 285551),
(472003, '0047900', NULL, NULL, 98, NULL, 'Cystatin/monellin', 285551),
(472004, '0048317', NULL, NULL, 98, NULL, 'Cystatin/monellin', 285551);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(472005, '0052883', NULL, NULL, 59, NULL, 'Tudor/PWWP/MBT', 285552),
(472006, '0053036', NULL, NULL, 90, NULL, 'Tudor/PWWP/MBT', 285552),
(472007, '0048574', NULL, NULL, 104, NULL, 'Tudor/PWWP/MBT', 285552),
(472008, '0052440', NULL, NULL, 97, NULL, 'Tudor/PWWP/MBT', 285552),
(472009, '0054230', NULL, NULL, 76, NULL, 'Tudor/PWWP/MBT', 285552),
(472010, '0048573', NULL, NULL, 103, NULL, 'Tudor/PWWP/MBT', 285552),
(472011, '0050626', NULL, NULL, 127, NULL, 'Tudor/PWWP/MBT', 285552),
(472012, '0052416', NULL, NULL, 97, NULL, 'Tudor/PWWP/MBT', 285552),
(472013, '0052438', NULL, NULL, 55, NULL, 'Tudor/PWWP/MBT', 285552),
(472014, '0050625', NULL, NULL, 107, NULL, 'Tudor/PWWP/MBT', 285552),
(472015, '0052413', NULL, NULL, 60, NULL, 'Tudor/PWWP/MBT', 285552),
(472016, '0054623', NULL, NULL, 56, NULL, 'Tudor/PWWP/MBT', 285552),
(472017, '0050627', NULL, NULL, 127, NULL, 'Tudor/PWWP/MBT', 285552),
(472018, '0051936', NULL, NULL, 110, NULL, 'Tudor/PWWP/MBT', 285552),
(472019, '0043739', NULL, NULL, 54, NULL, 'Tudor/PWWP/MBT', 285552),
(472020, '0048667', NULL, NULL, 110, NULL, 'Tudor/PWWP/MBT', 285552),
(472021, '0040933', NULL, NULL, 59, NULL, 'Tudor/PWWP/MBT', 285552),
(472022, '0048268', NULL, NULL, 96, NULL, 'Tudor/PWWP/MBT', 285552),
(472023, '0047119', NULL, NULL, 108, NULL, 'Tudor/PWWP/MBT', 285552),
(472024, '0043740', NULL, NULL, 69, NULL, 'Tudor/PWWP/MBT', 285552),
(472025, '0047802', NULL, NULL, 137, NULL, 'Tudor/PWWP/MBT', 285552),
(472026, '0048668', NULL, NULL, 108, NULL, 'Tudor/PWWP/MBT', 285552),
(472027, '0048669', NULL, NULL, 106, NULL, 'Tudor/PWWP/MBT', 285552),
(472028, '0048650', NULL, NULL, 161, NULL, 'DHS-like NAD/FAD-binding domain', 285553),
(472029, '0051405', NULL, NULL, 158, NULL, 'DHS-like NAD/FAD-binding domain', 285553),
(472030, '0051605', NULL, NULL, 175, NULL, 'DHS-like NAD/FAD-binding domain', 285553),
(472031, '0051269', NULL, NULL, 179, NULL, 'DHS-like NAD/FAD-binding domain', 285553),
(472032, '0053226', NULL, NULL, 267, NULL, 'DHS-like NAD/FAD-binding domain', 285553),
(472033, '0048859', NULL, NULL, 289, NULL, 'DHS-like NAD/FAD-binding domain', 285553),
(472034, '0048796', NULL, NULL, 183, NULL, 'DHS-like NAD/FAD-binding domain', 285553),
(472035, '0048895', NULL, NULL, 160, NULL, 'DHS-like NAD/FAD-binding domain', 285553),
(472036, '0044477', NULL, NULL, 177, NULL, 'DHS-like NAD/FAD-binding domain', 285553),
(472037, '0046339', NULL, NULL, 361, NULL, 'DHS-like NAD/FAD-binding domain', 285553),
(472038, '0052102', NULL, NULL, 175, NULL, 'DHS-like NAD/FAD-binding domain', 285553),
(472039, '0047672', NULL, NULL, 181, NULL, 'DHS-like NAD/FAD-binding domain', 285553),
(472040, '0051273', NULL, NULL, 245, NULL, 'DHS-like NAD/FAD-binding domain', 285553),
(472041, '0036754', NULL, NULL, 175, NULL, 'DHS-like NAD/FAD-binding domain', 285553),
(472042, '0042917', NULL, NULL, 179, NULL, 'DHS-like NAD/FAD-binding domain', 285553),
(472043, '0052448', NULL, NULL, 177, NULL, 'DHS-like NAD/FAD-binding domain', 285553),
(472044, '0040861', NULL, NULL, 252, NULL, 'DHS-like NAD/FAD-binding domain', 285553),
(472045, '0038971', NULL, NULL, 256, NULL, 'DHS-like NAD/FAD-binding domain', 285553),
(472046, '0036270', NULL, NULL, 177, NULL, 'DHS-like NAD/FAD-binding domain', 285553),
(472047, '0042100', NULL, NULL, 179, NULL, 'DHS-like NAD/FAD-binding domain', 285553),
(472048, '0046541', NULL, NULL, 124, NULL, 'DHS-like NAD/FAD-binding domain', 285553),
(472049, '0048522', NULL, NULL, 123, NULL, 'DHS-like NAD/FAD-binding domain', 285553),
(472050, '0043498', NULL, NULL, 235, NULL, 'DHS-like NAD/FAD-binding domain', 285553),
(472051, '0046545', NULL, NULL, 124, NULL, 'DHS-like NAD/FAD-binding domain', 285553),
(472052, '0047535', NULL, NULL, 323, NULL, 'DHS-like NAD/FAD-binding domain', 285553),
(472053, '0049812', NULL, NULL, 388, NULL, 'Vacuolar ATP synthase subunit C', 285554),
(472054, '0041569', NULL, NULL, 136, NULL, 'Staphylocoagulase', 285555),
(472055, '0041568', NULL, NULL, 145, NULL, 'Staphylocoagulase', 285555),
(472056, '0049653', NULL, NULL, 267, NULL, 'Tsx-like channel', 285556);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(472057, '0053795', NULL, NULL, 218, NULL, 'TBP-interacting protein-like', 285557),
(472058, '0049880', NULL, NULL, 228, NULL, 'Metallo-dependent phosphatases', 285558),
(472059, '0053225', NULL, NULL, 293, NULL, 'Metallo-dependent phosphatases', 285558),
(472060, '0054894', NULL, NULL, 173, NULL, 'Metallo-dependent phosphatases', 285558),
(472061, '0051021', NULL, NULL, 188, NULL, 'Metallo-dependent phosphatases', 285558),
(472062, '0049342', NULL, NULL, 324, NULL, 'Metallo-dependent phosphatases', 285558),
(472063, '0054913', NULL, NULL, 271, NULL, 'Metallo-dependent phosphatases', 285558),
(472064, '0054758', NULL, NULL, 302, NULL, 'Metallo-dependent phosphatases', 285558),
(472065, '0053347', NULL, NULL, 312, NULL, 'Metallo-dependent phosphatases', 285558),
(472066, '0051688', NULL, NULL, 193, NULL, 'Metallo-dependent phosphatases', 285558),
(472067, '0045823', NULL, NULL, 473, NULL, 'Metallo-dependent phosphatases', 285558),
(472068, '0044518', NULL, NULL, 302, NULL, 'Metallo-dependent phosphatases', 285558),
(472069, '0043485', NULL, NULL, 165, NULL, 'Metallo-dependent phosphatases', 285558),
(472070, '0049468', NULL, NULL, 184, NULL, 'Metallo-dependent phosphatases', 285558),
(472071, '0049330', NULL, NULL, 309, NULL, 'Metallo-dependent phosphatases', 285558),
(472072, '0052321', NULL, NULL, 252, NULL, 'Metallo-dependent phosphatases', 285558),
(472073, '0054882', NULL, NULL, 322, NULL, 'Metallo-dependent phosphatases', 285558),
(472074, '0054068', NULL, NULL, 256, NULL, 'Metallo-dependent phosphatases', 285558),
(472075, '0037943', NULL, NULL, 219, NULL, 'Metallo-dependent phosphatases', 285558),
(472076, '0051159', NULL, NULL, 305, NULL, 'Metallo-dependent phosphatases', 285558),
(472077, '0054306', NULL, NULL, 320, NULL, 'Metallo-dependent phosphatases', 285558),
(472078, '0054745', NULL, NULL, 257, NULL, 'Metallo-dependent phosphatases', 285558),
(472079, '0051479', NULL, NULL, 182, NULL, 'Metallo-dependent phosphatases', 285558),
(472080, '0046803', NULL, NULL, 294, NULL, 'Metallo-dependent phosphatases', 285558),
(472081, '0049558', NULL, NULL, 281, NULL, 'Metallo-dependent phosphatases', 285558),
(472082, '0049557', NULL, NULL, 255, NULL, 'Metallo-dependent phosphatases', 285558),
(472083, '0039040', NULL, NULL, 333, NULL, 'Metallo-dependent phosphatases', 285558),
(472084, '0048962', NULL, NULL, 300, NULL, 'Metallo-dependent phosphatases', 285558),
(472085, '0047216', NULL, NULL, 328, NULL, 'Metallo-dependent phosphatases', 285558),
(472086, '0041478', NULL, NULL, 251, NULL, 'Metallo-dependent phosphatases', 285558),
(472087, '0037860', NULL, NULL, 197, NULL, 'Fibrinogen C-terminal domain-like', 285559),
(472088, '0039477', NULL, NULL, 220, NULL, 'Fibrinogen C-terminal domain-like', 285559),
(472089, '0037859', NULL, NULL, 259, NULL, 'Fibrinogen C-terminal domain-like', 285559),
(472090, '0040703', NULL, NULL, 262, NULL, 'Fibrinogen C-terminal domain-like', 285559),
(472091, '0040702', NULL, NULL, 259, NULL, 'Fibrinogen C-terminal domain-like', 285559),
(472092, '0040735', NULL, NULL, 252, NULL, 'Fibrinogen C-terminal domain-like', 285559),
(472093, '0040734', NULL, NULL, 265, NULL, 'Fibrinogen C-terminal domain-like', 285559),
(472094, '0037600', NULL, NULL, 259, NULL, 'Fibrinogen C-terminal domain-like', 285559),
(472095, '0043330', NULL, NULL, 87, NULL, 'Anti-sigma factor FlgM', 285560),
(472096, '0039633', NULL, NULL, 377, NULL, 'V-region of surface antigen I/II (SA I/II, PAC)', 285561),
(472097, '0052034', NULL, NULL, 133, NULL, 'alpha-helical ferredoxin', 285562),
(472098, '0038466', NULL, NULL, 182, NULL, 'alpha-helical ferredoxin', 285562),
(472099, '0047791', NULL, NULL, 138, NULL, 'alpha-helical ferredoxin', 285562),
(472100, '0048346', NULL, NULL, 132, NULL, 'alpha-helical ferredoxin', 285562),
(472101, '0053945', NULL, NULL, 115, NULL, 'SARS Nsp1-like', 285563),
(472102, '0039947', NULL, NULL, 36, NULL, 'Zinc-binding domain of translation initiation factor 2 beta', 285564),
(472103, '0041337', NULL, NULL, 37, NULL, 'Zinc-binding domain of translation initiation factor 2 beta', 285564);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(472104, '0054126', NULL, NULL, 328, NULL, 'AttH-like', 285565),
(472105, '0053704', NULL, NULL, 54, NULL, 'HAMP domain-like', 285566),
(472106, '0039141', NULL, NULL, 201, NULL, 'Ribosomal protein S7', 285567),
(472107, '0054590', NULL, NULL, 150, NULL, 'Ribosomal protein S7', 285567),
(472108, '0038733', NULL, NULL, 139, NULL, 'Ribosomal protein S7', 285567),
(472109, '0043368', NULL, NULL, 145, NULL, 'Ribosomal protein S7', 285567),
(472110, '0052989', NULL, NULL, 108, NULL, 'ICP-like', 285568),
(472111, '0052105', NULL, NULL, 113, NULL, 'ICP-like', 285568),
(472112, '0045856', NULL, NULL, 31, NULL, 'SinR repressor dimerisation domain-like', 285569),
(472113, '0045854', NULL, NULL, 35, NULL, 'SinR repressor dimerisation domain-like', 285569),
(472114, '0035827', NULL, NULL, 152, NULL, 'Mannose 6-phosphate receptor domain', 285570),
(472115, '0036793', NULL, NULL, 134, NULL, 'Mannose 6-phosphate receptor domain', 285570),
(472116, '0042582', NULL, NULL, 123, NULL, 'Mannose 6-phosphate receptor domain', 285570),
(472117, '0042583', NULL, NULL, 151, NULL, 'Mannose 6-phosphate receptor domain', 285570),
(472118, '0042584', NULL, NULL, 152, NULL, 'Mannose 6-phosphate receptor domain', 285570),
(472119, '0040645', NULL, NULL, 174, NULL, 'Lipovitellin-phosvitin complex; beta-sheet shell regions', 285571),
(472120, '0040644', NULL, NULL, 452, NULL, 'Lipovitellin-phosvitin complex; beta-sheet shell regions', 285571),
(472121, '0040643', NULL, NULL, 268, NULL, 'Lipovitellin-phosvitin complex; beta-sheet shell regions', 285571),
(472122, '0052781', NULL, NULL, 130, NULL, 'FlgN-like', 285572),
(472123, '0051124', NULL, NULL, 124, NULL, 'ApaG-like', 285573),
(472124, '0051061', NULL, NULL, 123, NULL, 'ApaG-like', 285573),
(472125, '0049746', NULL, NULL, 132, NULL, 'ApaG-like', 285573),
(472126, '0041378', NULL, NULL, 60, NULL, 'Soluble domain of poliovirus core protein 3a', 285574),
(472127, '0037730', NULL, NULL, 95, NULL, 'HSC20 (HSCB), C-terminal oligomerisation domain', 285575),
(472128, '0051900', NULL, NULL, 81, NULL, 'HIV integrase-binding domain', 285576),
(472129, '0054859', NULL, NULL, 109, NULL, 'EscU C-terminal domain-like', 285577),
(472130, '0054857', NULL, NULL, 109, NULL, 'EscU C-terminal domain-like', 285577),
(472131, '0054734', NULL, NULL, 103, NULL, 'EscU C-terminal domain-like', 285577),
(472132, '0049575', NULL, NULL, 178, NULL, 'MIR domain', 285578),
(472133, '0048281', NULL, NULL, 200, NULL, 'MIR domain', 285578),
(472134, '0053598', NULL, NULL, 283, NULL, 'DNA breaking-rejoining enzymes', 285579),
(472135, '0034815', NULL, NULL, 182, NULL, 'DNA breaking-rejoining enzymes', 285579),
(472136, '0034845', NULL, NULL, 243, NULL, 'DNA breaking-rejoining enzymes', 285579),
(472137, '0034861', NULL, NULL, 230, NULL, 'DNA breaking-rejoining enzymes', 285579),
(472138, '0035058', NULL, NULL, 170, NULL, 'DNA breaking-rejoining enzymes', 285579),
(472139, '0037653', NULL, NULL, 289, NULL, 'DNA breaking-rejoining enzymes', 285579),
(472140, '0043356', NULL, NULL, 237, NULL, 'DNA breaking-rejoining enzymes', 285579),
(472141, '0045588', NULL, NULL, 212, NULL, 'DNA breaking-rejoining enzymes', 285579),
(472142, '0039910', NULL, NULL, 264, NULL, 'DNA breaking-rejoining enzymes', 285579),
(472143, '0049019', NULL, NULL, 138, NULL, 'Staphylokinase/streptokinase', 285580),
(472144, '0045982', NULL, NULL, 137, NULL, 'Staphylokinase/streptokinase', 285580),
(472145, '0047934', NULL, NULL, 136, NULL, 'Staphylokinase/streptokinase', 285580),
(472146, '0035623', NULL, NULL, 88, NULL, 'Staphylokinase/streptokinase', 285580),
(472147, '0043742', NULL, NULL, 136, NULL, 'Staphylokinase/streptokinase', 285580),
(472148, '0040595', NULL, NULL, 55, NULL, 'Bacterial immunoglobulin/albumin-binding domains', 285581),
(472149, '0049607', NULL, NULL, 53, NULL, 'Bacterial immunoglobulin/albumin-binding domains', 285581),
(472150, '0038121', NULL, NULL, 65, NULL, 'Bacterial immunoglobulin/albumin-binding domains', 285581),
(472151, '0051119', NULL, NULL, 56, NULL, 'Bacterial immunoglobulin/albumin-binding domains', 285581);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(472152, '0051118', NULL, NULL, 70, NULL, 'Bacterial immunoglobulin/albumin-binding domains', 285581),
(472153, '0046313', NULL, NULL, 51, NULL, 'Bacterial immunoglobulin/albumin-binding domains', 285581),
(472154, '0049457', NULL, NULL, 62, NULL, 'Bacterial immunoglobulin/albumin-binding domains', 285581),
(472155, '0046525', NULL, NULL, 56, NULL, 'Bacterial immunoglobulin/albumin-binding domains', 285581),
(472156, '0034913', NULL, NULL, 72, NULL, 'Protein serine/threonine phosphatase 2C, C-terminal domain', 285582),
(472157, '0049163', NULL, NULL, 330, NULL, 'Bacterial luciferase-like', 285583),
(472158, '0048354', NULL, NULL, 228, NULL, 'Bacterial luciferase-like', 285583),
(472159, '0048036', NULL, NULL, 355, NULL, 'Bacterial luciferase-like', 285583),
(472160, '0046662', NULL, NULL, 347, NULL, 'Bacterial luciferase-like', 285583),
(472161, '0048037', NULL, NULL, 320, NULL, 'Bacterial luciferase-like', 285583),
(472162, '0046666', NULL, NULL, 321, NULL, 'Bacterial luciferase-like', 285583),
(472163, '0049715', NULL, NULL, 430, NULL, 'Bacterial luciferase-like', 285583),
(472164, '0046866', NULL, NULL, 231, NULL, 'Bacterial luciferase-like', 285583),
(472165, '0048081', NULL, NULL, 361, NULL, 'Bacterial luciferase-like', 285583),
(472166, '0048670', NULL, NULL, 147, NULL, 'SecB-like', 285584),
(472167, '0053595', NULL, NULL, 144, NULL, 'SecB-like', 285584),
(472168, '0054052', NULL, NULL, 124, NULL, 'SecB-like', 285584),
(472169, '0043044', NULL, NULL, 134, NULL, 'SecB-like', 285584),
(472170, '0054319', NULL, NULL, 124, NULL, 'SecB-like', 285584),
(472171, '0045397', NULL, NULL, 79, NULL, 'Cytochrome c oxidase subunit h', 285585),
(472172, '0049681', NULL, NULL, 105, NULL, 'TrpR-like', 285586),
(472173, '0047496', NULL, NULL, 94, NULL, 'TrpR-like', 285586),
(472174, '0054350', NULL, NULL, 93, NULL, 'TrpR-like', 285586),
(472175, '0047944', NULL, NULL, 110, NULL, 'TrpR-like', 285586),
(472176, '0037229', NULL, NULL, 275, NULL, 'DNA repair protein MutS, domain III', 285587),
(472177, '0036747', NULL, NULL, 297, NULL, 'DNA repair protein MutS, domain III', 285587),
(472178, '0051422', NULL, NULL, 359, NULL, 'TROVE domain-like', 285588),
(472179, '0050165', NULL, NULL, 62, NULL, 'Rudiment single hybrid motif', 285589),
(472180, '0053610', NULL, NULL, 66, NULL, 'Rudiment single hybrid motif', 285589),
(472181, '0047171', NULL, NULL, 63, NULL, 'Rudiment single hybrid motif', 285589),
(472182, '0035374', NULL, NULL, 79, NULL, 'Rudiment single hybrid motif', 285589),
(472183, '0037274', NULL, NULL, 74, NULL, 'Rudiment single hybrid motif', 285589),
(472184, '0046145', NULL, NULL, 62, NULL, 'Rudiment single hybrid motif', 285589),
(472185, '0050406', NULL, NULL, 116, NULL, 'Rudiment single hybrid motif', 285589),
(472186, '0046444', NULL, NULL, 64, NULL, 'Rudiment single hybrid motif', 285589),
(472187, '0044432', NULL, NULL, 123, NULL, 'Rudiment single hybrid motif', 285589),
(472188, '0044850', NULL, NULL, 86, NULL, 'Rudiment single hybrid motif', 285589),
(472189, '0046402', NULL, NULL, 116, NULL, 'Rudiment single hybrid motif', 285589),
(472190, '0038249', NULL, NULL, 99, NULL, 'Rudiment single hybrid motif', 285589),
(472191, '0035493', NULL, NULL, 81, NULL, 'Ubiquinone-binding protein QP-C of cytochrome bc1 complex (Ubiquinol-cytochrome c reductase)', 285590),
(472192, '0037296', NULL, NULL, 93, NULL, 'Ubiquinone-binding protein QP-C of cytochrome bc1 complex (Ubiquinol-cytochrome c reductase)', 285590),
(472193, '0035458', NULL, NULL, 78, NULL, 'Ubiquinone-binding protein QP-C of cytochrome bc1 complex (Ubiquinol-cytochrome c reductase)', 285590),
(472194, '0051341', NULL, NULL, 115, NULL, 'PilZ domain-like', 285591),
(472195, '0051340', NULL, NULL, 111, NULL, 'PilZ domain-like', 285591),
(472196, '0051434', NULL, NULL, 125, NULL, 'PilZ domain-like', 285591),
(472197, '0035905', NULL, NULL, 227, NULL, 'CytB endotoxin-like', 285592),
(472198, '0042412', NULL, NULL, 194, NULL, 'CytB endotoxin-like', 285592),
(472199, '0045825', NULL, NULL, 55, NULL, 'SacY-like RNA-binding domain', 285593);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(472200, '0047918', NULL, NULL, 55, NULL, 'SacY-like RNA-binding domain', 285593),
(472201, '0049143', NULL, NULL, 57, NULL, 'Crisp domain-like', 285594),
(472202, '0035825', NULL, NULL, 35, NULL, 'Crisp domain-like', 285594),
(472203, '0035541', NULL, NULL, 37, NULL, 'Crisp domain-like', 285594),
(472204, '0045942', NULL, NULL, 35, NULL, 'Crisp domain-like', 285594),
(472205, '0041906', NULL, NULL, 54, NULL, 'Phosphoprotein XD domain', 285595),
(472206, '0049100', NULL, NULL, 53, NULL, 'Phosphoprotein XD domain', 285595),
(472207, '0049294', NULL, NULL, 94, NULL, 'TM1457-like', 285596),
(472208, '0054131', NULL, NULL, 112, NULL, 'TM1457-like', 285596),
(472209, '0054481', NULL, NULL, 106, NULL, 'TM1457-like', 285596),
(472210, '0053931', NULL, NULL, 111, NULL, 'TM1457-like', 285596),
(472211, '0047916', NULL, NULL, 90, NULL, 'PKD domain', 285597),
(472212, '0050529', NULL, NULL, 123, NULL, 'PKD domain', 285597),
(472213, '0045880', NULL, NULL, 80, NULL, 'PKD domain', 285597),
(472214, '0053412', NULL, NULL, 32, NULL, 'Triple coiled coil domain of C-type lectins', 285598),
(472215, '0053483', NULL, NULL, 40, NULL, 'Triple coiled coil domain of C-type lectins', 285598),
(472216, '0053439', NULL, NULL, 24, NULL, 'Triple coiled coil domain of C-type lectins', 285598),
(472217, '0053505', NULL, NULL, 26, NULL, 'Triple coiled coil domain of C-type lectins', 285598),
(472218, '0053438', NULL, NULL, 28, NULL, 'Triple coiled coil domain of C-type lectins', 285598),
(472219, '0043191', NULL, NULL, 231, NULL, 'Aquaporin-like', 285599),
(472220, '0037740', NULL, NULL, 226, NULL, 'Aquaporin-like', 285599),
(472221, '0039367', NULL, NULL, 249, NULL, 'Aquaporin-like', 285599),
(472222, '0037828', NULL, NULL, 254, NULL, 'Aquaporin-like', 285599),
(472223, '0043681', NULL, NULL, 235, NULL, 'Aquaporin-like', 285599),
(472224, '0053497', NULL, NULL, 31, NULL, 'Tetramerization domain of the Mnt repressor', 285600),
(472225, '0047033', NULL, NULL, 143, NULL, 'Glutamyl tRNA-reductase catalytic, N-terminal domain', 285601),
(472226, '0042046', NULL, NULL, 107, NULL, 'ERP29 C domain-like', 285602),
(472227, '0037969', NULL, NULL, 106, NULL, 'ERP29 C domain-like', 285602),
(472228, '0037657', NULL, NULL, 149, NULL, 'Molybdopterin synthase subunit MoaE', 285603),
(472229, '0050794', NULL, NULL, 57, NULL, 'XPC-binding domain', 285604),
(472230, '0049666', NULL, NULL, 59, NULL, 'XPC-binding domain', 285604),
(472231, '0042489', NULL, NULL, 72, NULL, 'XPC-binding domain', 285604),
(472232, '0041873', NULL, NULL, 223, NULL, 'Eukaryotic DNA topoisomerase I, N-terminal DNA-binding fragment', 285605),
(472233, '0039911', NULL, NULL, 230, NULL, 'Eukaryotic DNA topoisomerase I, N-terminal DNA-binding fragment', 285605),
(472234, '0041025', NULL, NULL, 67, NULL, 'Dodecin-like', 285606),
(472235, '0054684', NULL, NULL, 66, NULL, 'Dodecin-like', 285606),
(472236, '0053621', NULL, NULL, 88, NULL, 'S15/NS1 RNA-binding domain', 285607),
(472237, '0037893', NULL, NULL, 88, NULL, 'S15/NS1 RNA-binding domain', 285607),
(472238, '0034846', NULL, NULL, 85, NULL, 'S15/NS1 RNA-binding domain', 285607),
(472239, '0036463', NULL, NULL, 86, NULL, 'S15/NS1 RNA-binding domain', 285607),
(472240, '0043152', NULL, NULL, 54, NULL, 'S15/NS1 RNA-binding domain', 285607),
(472241, '0035059', NULL, NULL, 70, NULL, 'S15/NS1 RNA-binding domain', 285607),
(472242, '0036236', NULL, NULL, 56, NULL, 'S15/NS1 RNA-binding domain', 285607),
(472243, '0050942', NULL, NULL, 89, NULL, 'S15/NS1 RNA-binding domain', 285607),
(472244, '0037853', NULL, NULL, 57, NULL, 'S15/NS1 RNA-binding domain', 285607),
(472245, '0046292', NULL, NULL, 100, NULL, 'Viral DNA-binding domain', 285608),
(472246, '0049130', NULL, NULL, 87, NULL, 'Viral DNA-binding domain', 285608),
(472247, '0046040', NULL, NULL, 80, NULL, 'Viral DNA-binding domain', 285608),
(472248, '0045729', NULL, NULL, 82, NULL, 'Viral DNA-binding domain', 285608),
(472249, '0035341', NULL, NULL, 147, NULL, 'Viral DNA-binding domain', 285608),
(472250, '0046732', NULL, NULL, 81, NULL, 'Viral DNA-binding domain', 285608); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(472251, '0049000', NULL, NULL, 360, NULL, 'Aldolase', 285609),
(472252, '0052334', NULL, NULL, 319, NULL, 'Aldolase', 285609),
(472253, '0047183', NULL, NULL, 347, NULL, 'Aldolase', 285609),
(472254, '0050239', NULL, NULL, 295, NULL, 'Aldolase', 285609),
(472255, '0050359', NULL, NULL, 293, NULL, 'Aldolase', 285609),
(472256, '0050278', NULL, NULL, 218, NULL, 'Aldolase', 285609),
(472257, '0036525', NULL, NULL, 358, NULL, 'Aldolase', 285609),
(472258, '0035351', NULL, NULL, 326, NULL, 'Aldolase', 285609),
(472259, '0045763', NULL, NULL, 363, NULL, 'Aldolase', 285609),
(472260, '0048312', NULL, NULL, 291, NULL, 'Aldolase', 285609),
(472261, '0049247', NULL, NULL, 305, NULL, 'Aldolase', 285609),
(472262, '0046975', NULL, NULL, 343, NULL, 'Aldolase', 285609),
(472263, '0049848', NULL, NULL, 211, NULL, 'Aldolase', 285609),
(472264, '0043346', NULL, NULL, 303, NULL, 'Aldolase', 285609),
(472265, '0046338', NULL, NULL, 292, NULL, 'Aldolase', 285609),
(472266, '0051011', NULL, NULL, 292, NULL, 'Aldolase', 285609),
(472267, '0046461', NULL, NULL, 328, NULL, 'Aldolase', 285609),
(472268, '0048245', NULL, NULL, 216, NULL, 'Aldolase', 285609),
(472269, '0049453', NULL, NULL, 310, NULL, 'Aldolase', 285609),
(472270, '0051933', NULL, NULL, 462, NULL, 'Aldolase', 285609),
(472271, '0052702', NULL, NULL, 420, NULL, 'Aldolase', 285609),
(472272, '0047070', NULL, NULL, 284, NULL, 'Aldolase', 285609),
(472273, '0050246', NULL, NULL, 205, NULL, 'Aldolase', 285609),
(472274, '0051699', NULL, NULL, 256, NULL, 'Aldolase', 285609),
(472275, '0046628', NULL, NULL, 213, NULL, 'Aldolase', 285609),
(472276, '0041693', NULL, NULL, 295, NULL, 'Aldolase', 285609),
(472277, '0046665', NULL, NULL, 322, NULL, 'Aldolase', 285609),
(472278, '0046741', NULL, NULL, 360, NULL, 'Aldolase', 285609),
(472279, '0041658', NULL, NULL, 251, NULL, 'Aldolase', 285609),
(472280, '0051144', NULL, NULL, 296, NULL, 'Aldolase', 285609),
(472281, '0048294', NULL, NULL, 234, NULL, 'Aldolase', 285609),
(472282, '0049382', NULL, NULL, 236, NULL, 'Aldolase', 285609),
(472283, '0048453', NULL, NULL, 289, NULL, 'Aldolase', 285609),
(472284, '0048496', NULL, NULL, 281, NULL, 'Aldolase', 285609),
(472285, '0049661', NULL, NULL, 291, NULL, 'Aldolase', 285609),
(472286, '0050734', NULL, NULL, 211, NULL, 'Aldolase', 285609),
(472287, '0050339', NULL, NULL, 319, NULL, 'Aldolase', 285609),
(472288, '0051345', NULL, NULL, 341, NULL, 'Aldolase', 285609),
(472289, '0048611', NULL, NULL, 316, NULL, 'Aldolase', 285609),
(472290, '0046878', NULL, NULL, 263, NULL, 'Aldolase', 285609),
(472291, '0050143', NULL, NULL, 226, NULL, 'Aldolase', 285609),
(472292, '0049279', NULL, NULL, 338, NULL, 'Aldolase', 285609),
(472293, '0048586', NULL, NULL, 251, NULL, 'Aldolase', 285609),
(472294, '0050945', NULL, NULL, 342, NULL, 'Aldolase', 285609),
(472295, '0051114', NULL, NULL, 280, NULL, 'Aldolase', 285609),
(472296, '0045714', NULL, NULL, 342, NULL, 'Aldolase', 285609),
(472297, '0046606', NULL, NULL, 357, NULL, 'Aldolase', 285609),
(472298, '0039482', NULL, NULL, 252, NULL, 'Aldolase', 285609),
(472299, '0047939', NULL, NULL, 220, NULL, 'Aldolase', 285609),
(472300, '0041152', NULL, NULL, 225, NULL, 'Aldolase', 285609),
(472301, '0046288', NULL, NULL, 284, NULL, 'Aldolase', 285609),
(472302, '0046720', NULL, NULL, 293, NULL, 'Aldolase', 285609),
(472303, '0050181', NULL, NULL, 212, NULL, 'Aldolase', 285609),
(472304, '0048940', NULL, NULL, 252, NULL, 'Aldolase', 285609),
(472305, '0046689', NULL, NULL, 357, NULL, 'Aldolase', 285609),
(472306, '0045877', NULL, NULL, 323, NULL, 'Aldolase', 285609),
(472307, '0048153', NULL, NULL, 88, NULL, 'Methylated DNA-protein cysteine methyltransferase domain', 285610),
(472308, '0048994', NULL, NULL, 86, NULL, 'Methylated DNA-protein cysteine methyltransferase domain', 285610),
(472309, '0049381', NULL, NULL, 81, NULL, 'Methylated DNA-protein cysteine methyltransferase domain', 285610),
(472310, '0054321', NULL, NULL, 248, NULL, 'ApbE-like', 285611),
(472311, '0050307', NULL, NULL, 309, NULL, 'ApbE-like', 285611),
(472312, '0038109', NULL, NULL, 81, NULL, 'DNA damage-inducible protein DinI', 285612);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(472313, '0046707', NULL, NULL, 100, NULL, 'Glutamine synthetase, N-terminal domain', 285613),
(472314, '0047238', NULL, NULL, 100, NULL, 'Glutamine synthetase, N-terminal domain', 285613),
(472315, '0040894', NULL, NULL, 121, NULL, 'Methylamine dehydrogenase, L chain', 285614),
(472316, '0045182', NULL, NULL, 125, NULL, 'Methylamine dehydrogenase, L chain', 285614),
(472317, '0037634', NULL, NULL, 188, NULL, 'Methuselah ectodomain', 285615),
(472318, '0052058', NULL, NULL, 181, NULL, 'MHC antigen-recognition domain', 285616),
(472319, '0034827', NULL, NULL, 181, NULL, 'MHC antigen-recognition domain', 285616),
(472320, '0040827', NULL, NULL, 181, NULL, 'MHC antigen-recognition domain', 285616),
(472321, '0038944', NULL, NULL, 87, NULL, 'MHC antigen-recognition domain', 285616),
(472322, '0035752', NULL, NULL, 90, NULL, 'MHC antigen-recognition domain', 285616),
(472323, '0039959', NULL, NULL, 82, NULL, 'MHC antigen-recognition domain', 285616),
(472324, '0038700', NULL, NULL, 181, NULL, 'MHC antigen-recognition domain', 285616),
(472325, '0039955', NULL, NULL, 181, NULL, 'MHC antigen-recognition domain', 285616),
(472326, '0035039', NULL, NULL, 181, NULL, 'MHC antigen-recognition domain', 285616),
(472327, '0038943', NULL, NULL, 82, NULL, 'MHC antigen-recognition domain', 285616),
(472328, '0042931', NULL, NULL, 180, NULL, 'MHC antigen-recognition domain', 285616),
(472329, '0038861', NULL, NULL, 120, NULL, 'MHC antigen-recognition domain', 285616),
(472330, '0037256', NULL, NULL, 173, NULL, 'MHC antigen-recognition domain', 285616),
(472331, '0039593', NULL, NULL, 84, NULL, 'MHC antigen-recognition domain', 285616),
(472332, '0039595', NULL, NULL, 92, NULL, 'MHC antigen-recognition domain', 285616),
(472333, '0046058', NULL, NULL, 164, NULL, 'MHC antigen-recognition domain', 285616),
(472334, '0045486', NULL, NULL, 181, NULL, 'MHC antigen-recognition domain', 285616),
(472335, '0036280', NULL, NULL, 91, NULL, 'MHC antigen-recognition domain', 285616),
(472336, '0042893', NULL, NULL, 180, NULL, 'MHC antigen-recognition domain', 285616),
(472337, '0040116', NULL, NULL, 181, NULL, 'MHC antigen-recognition domain', 285616),
(472338, '0046614', NULL, NULL, 87, NULL, 'MHC antigen-recognition domain', 285616),
(472339, '0053675', NULL, NULL, 180, NULL, 'MHC antigen-recognition domain', 285616),
(472340, '0053676', NULL, NULL, 176, NULL, 'MHC antigen-recognition domain', 285616),
(472341, '0036715', NULL, NULL, 181, NULL, 'MHC antigen-recognition domain', 285616),
(472342, '0036913', NULL, NULL, 181, NULL, 'MHC antigen-recognition domain', 285616),
(472343, '0049096', NULL, NULL, 164, NULL, 'MHC antigen-recognition domain', 285616),
(472344, '0050009', NULL, NULL, 92, NULL, 'MHC antigen-recognition domain', 285616),
(472345, '0053319', NULL, NULL, 178, NULL, 'MHC antigen-recognition domain', 285616),
(472346, '0039865', NULL, NULL, 82, NULL, 'MHC antigen-recognition domain', 285616),
(472347, '0034899', NULL, NULL, 88, NULL, 'MHC antigen-recognition domain', 285616),
(472348, '0038699', NULL, NULL, 181, NULL, 'MHC antigen-recognition domain', 285616),
(472349, '0038657', NULL, NULL, 181, NULL, 'MHC antigen-recognition domain', 285616),
(472350, '0039866', NULL, NULL, 87, NULL, 'MHC antigen-recognition domain', 285616),
(472351, '0051534', NULL, NULL, 179, NULL, 'MHC antigen-recognition domain', 285616),
(472352, '0045332', NULL, NULL, 89, NULL, 'MHC antigen-recognition domain', 285616),
(472353, '0048801', NULL, NULL, 139, NULL, 'MHC antigen-recognition domain', 285616),
(472354, '0054532', NULL, NULL, 178, NULL, 'MHC antigen-recognition domain', 285616),
(472355, '0040927', NULL, NULL, 181, NULL, 'MHC antigen-recognition domain', 285616),
(472356, '0053680', NULL, NULL, 181, NULL, 'MHC antigen-recognition domain', 285616),
(472357, '0035334', NULL, NULL, 180, NULL, 'MHC antigen-recognition domain', 285616),
(472358, '0037792', NULL, NULL, 79, NULL, 'MHC antigen-recognition domain', 285616),
(472359, '0040256', NULL, NULL, 120, NULL, 'MHC antigen-recognition domain', 285616),
(472360, '0037794', NULL, NULL, 92, NULL, 'MHC antigen-recognition domain', 285616);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(472361, '0043009', NULL, NULL, 181, NULL, 'MHC antigen-recognition domain', 285616),
(472362, '0044538', NULL, NULL, 83, NULL, 'MHC antigen-recognition domain', 285616),
(472363, '0039499', NULL, NULL, 181, NULL, 'MHC antigen-recognition domain', 285616),
(472364, '0046112', NULL, NULL, 179, NULL, 'MHC antigen-recognition domain', 285616),
(472365, '0041946', NULL, NULL, 177, NULL, 'MHC antigen-recognition domain', 285616),
(472366, '0040019', NULL, NULL, 178, NULL, 'MHC antigen-recognition domain', 285616),
(472367, '0040458', NULL, NULL, 181, NULL, 'MHC antigen-recognition domain', 285616),
(472368, '0040930', NULL, NULL, 180, NULL, 'MHC antigen-recognition domain', 285616),
(472369, '0050385', NULL, NULL, 181, NULL, 'MHC antigen-recognition domain', 285616),
(472370, '0053654', NULL, NULL, 180, NULL, 'MHC antigen-recognition domain', 285616),
(472371, '0053617', NULL, NULL, 181, NULL, 'MHC antigen-recognition domain', 285616),
(472372, '0036973', NULL, NULL, 181, NULL, 'MHC antigen-recognition domain', 285616),
(472373, '0036378', NULL, NULL, 178, NULL, 'MHC antigen-recognition domain', 285616),
(472374, '0036615', NULL, NULL, 181, NULL, 'MHC antigen-recognition domain', 285616),
(472375, '0047092', NULL, NULL, 181, NULL, 'MHC antigen-recognition domain', 285616),
(472376, '0038556', NULL, NULL, 85, NULL, 'MHC antigen-recognition domain', 285616),
(472377, '0037149', NULL, NULL, 84, NULL, 'MHC antigen-recognition domain', 285616),
(472378, '0051953', NULL, NULL, 181, NULL, 'MHC antigen-recognition domain', 285616),
(472379, '0040585', NULL, NULL, 120, NULL, 'MHC antigen-recognition domain', 285616),
(472380, '0040584', NULL, NULL, 83, NULL, 'MHC antigen-recognition domain', 285616),
(472381, '0041354', NULL, NULL, 181, NULL, 'MHC antigen-recognition domain', 285616),
(472382, '0038554', NULL, NULL, 81, NULL, 'MHC antigen-recognition domain', 285616),
(472383, '0039961', NULL, NULL, 94, NULL, 'MHC antigen-recognition domain', 285616),
(472384, '0035166', NULL, NULL, 89, NULL, 'MHC antigen-recognition domain', 285616),
(472385, '0038990', NULL, NULL, 81, NULL, 'MHC antigen-recognition domain', 285616),
(472386, '0047577', NULL, NULL, 174, NULL, 'MHC antigen-recognition domain', 285616),
(472387, '0040621', NULL, NULL, 172, NULL, 'MHC antigen-recognition domain', 285616),
(472388, '0043533', NULL, NULL, 83, NULL, 'MHC antigen-recognition domain', 285616),
(472389, '0043534', NULL, NULL, 92, NULL, 'MHC antigen-recognition domain', 285616),
(472390, '0039390', NULL, NULL, 197, NULL, 'Methionine synthase activation domain-like', 285617),
(472391, '0041070', NULL, NULL, 327, NULL, 'Methionine synthase activation domain-like', 285617),
(472392, '0054018', NULL, NULL, 109, NULL, 'YcgL-like', 285618),
(472393, '0050495', NULL, NULL, 136, NULL, 'C2 domain (Calcium/lipid-binding domain, CaLB)', 285619),
(472394, '0052179', NULL, NULL, 149, NULL, 'C2 domain (Calcium/lipid-binding domain, CaLB)', 285619),
(472395, '0054798', NULL, NULL, 122, NULL, 'C2 domain (Calcium/lipid-binding domain, CaLB)', 285619),
(472396, '0046395', NULL, NULL, 137, NULL, 'C2 domain (Calcium/lipid-binding domain, CaLB)', 285619),
(472397, '0044591', NULL, NULL, 141, NULL, 'C2 domain (Calcium/lipid-binding domain, CaLB)', 285619),
(472398, '0044929', NULL, NULL, 138, NULL, 'C2 domain (Calcium/lipid-binding domain, CaLB)', 285619),
(472399, '0036566', NULL, NULL, 145, NULL, 'C2 domain (Calcium/lipid-binding domain, CaLB)', 285619),
(472400, '0036565', NULL, NULL, 130, NULL, 'C2 domain (Calcium/lipid-binding domain, CaLB)', 285619),
(472401, '0053329', NULL, NULL, 140, NULL, 'C2 domain (Calcium/lipid-binding domain, CaLB)', 285619),
(472402, '0049161', NULL, NULL, 142, NULL, 'C2 domain (Calcium/lipid-binding domain, CaLB)', 285619),
(472403, '0036823', NULL, NULL, 174, NULL, 'C2 domain (Calcium/lipid-binding domain, CaLB)', 285619),
(472404, '0050498', NULL, NULL, 138, NULL, 'C2 domain (Calcium/lipid-binding domain, CaLB)', 285619),
(472405, '0053207', NULL, NULL, 133, NULL, 'C2 domain (Calcium/lipid-binding domain, CaLB)', 285619);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(472406, '0036844', NULL, NULL, 166, NULL, 'C2 domain (Calcium/lipid-binding domain, CaLB)', 285619),
(472407, '0038166', NULL, NULL, 136, NULL, 'C2 domain (Calcium/lipid-binding domain, CaLB)', 285619),
(472408, '0048916', NULL, NULL, 131, NULL, 'C2 domain (Calcium/lipid-binding domain, CaLB)', 285619),
(472409, '0036281', NULL, NULL, 141, NULL, 'C2 domain (Calcium/lipid-binding domain, CaLB)', 285619),
(472410, '0044352', NULL, NULL, 138, NULL, 'C2 domain (Calcium/lipid-binding domain, CaLB)', 285619),
(472411, '0049647', NULL, NULL, 157, NULL, 'C2 domain (Calcium/lipid-binding domain, CaLB)', 285619),
(472412, '0046160', NULL, NULL, 129, NULL, 'C2 domain (Calcium/lipid-binding domain, CaLB)', 285619),
(472413, '0054742', NULL, NULL, 142, NULL, 'C2 domain (Calcium/lipid-binding domain, CaLB)', 285619),
(472414, '0053890', NULL, NULL, 126, NULL, 'C2 domain (Calcium/lipid-binding domain, CaLB)', 285619),
(472415, '0035482', NULL, NULL, 123, NULL, 'C2 domain (Calcium/lipid-binding domain, CaLB)', 285619),
(472416, '0049239', NULL, NULL, 143, NULL, 'C2 domain (Calcium/lipid-binding domain, CaLB)', 285619),
(472417, '0045699', NULL, NULL, 132, NULL, 'C2 domain (Calcium/lipid-binding domain, CaLB)', 285619),
(472418, '0050550', NULL, NULL, 105, NULL, 'PDZ domain-like', 285620),
(472419, '0051242', NULL, NULL, 88, NULL, 'PDZ domain-like', 285620),
(472420, '0052650', NULL, NULL, 96, NULL, 'PDZ domain-like', 285620),
(472421, '0044391', NULL, NULL, 117, NULL, 'PDZ domain-like', 285620),
(472422, '0049521', NULL, NULL, 92, NULL, 'PDZ domain-like', 285620),
(472423, '0038828', NULL, NULL, 130, NULL, 'PDZ domain-like', 285620),
(472424, '0054035', NULL, NULL, 103, NULL, 'PDZ domain-like', 285620),
(472425, '0050833', NULL, NULL, 101, NULL, 'PDZ domain-like', 285620),
(472426, '0051603', NULL, NULL, 93, NULL, 'PDZ domain-like', 285620),
(472427, '0050516', NULL, NULL, 127, NULL, 'PDZ domain-like', 285620),
(472428, '0050835', NULL, NULL, 97, NULL, 'PDZ domain-like', 285620),
(472429, '0050114', NULL, NULL, 100, NULL, 'PDZ domain-like', 285620),
(472430, '0051643', NULL, NULL, 109, NULL, 'PDZ domain-like', 285620),
(472431, '0050553', NULL, NULL, 100, NULL, 'PDZ domain-like', 285620),
(472432, '0050116', NULL, NULL, 111, NULL, 'PDZ domain-like', 285620),
(472433, '0040399', NULL, NULL, 95, NULL, 'PDZ domain-like', 285620),
(472434, '0041246', NULL, NULL, 103, NULL, 'PDZ domain-like', 285620),
(472435, '0041243', NULL, NULL, 95, NULL, 'PDZ domain-like', 285620),
(472436, '0044638', NULL, NULL, 118, NULL, 'PDZ domain-like', 285620),
(472437, '0050507', NULL, NULL, 103, NULL, 'PDZ domain-like', 285620),
(472438, '0040319', NULL, NULL, 88, NULL, 'PDZ domain-like', 285620),
(472439, '0040317', NULL, NULL, 94, NULL, 'PDZ domain-like', 285620),
(472440, '0044310', NULL, NULL, 103, NULL, 'PDZ domain-like', 285620),
(472441, '0044398', NULL, NULL, 111, NULL, 'PDZ domain-like', 285620),
(472442, '0044311', NULL, NULL, 123, NULL, 'PDZ domain-like', 285620),
(472443, '0044399', NULL, NULL, 96, NULL, 'PDZ domain-like', 285620),
(472444, '0044315', NULL, NULL, 128, NULL, 'PDZ domain-like', 285620),
(472445, '0052663', NULL, NULL, 92, NULL, 'PDZ domain-like', 285620),
(472446, '0053596', NULL, NULL, 99, NULL, 'PDZ domain-like', 285620),
(472447, '0050486', NULL, NULL, 103, NULL, 'PDZ domain-like', 285620),
(472448, '0054088', NULL, NULL, 102, NULL, 'PDZ domain-like', 285620),
(472449, '0039028', NULL, NULL, 94, NULL, 'PDZ domain-like', 285620),
(472450, '0050487', NULL, NULL, 94, NULL, 'PDZ domain-like', 285620),
(472451, '0042269', NULL, NULL, 96, NULL, 'PDZ domain-like', 285620),
(472452, '0037485', NULL, NULL, 92, NULL, 'PDZ domain-like', 285620),
(472453, '0038015', NULL, NULL, 91, NULL, 'PDZ domain-like', 285620),
(472454, '0040042', NULL, NULL, 93, NULL, 'PDZ domain-like', 285620),
(472455, '0050836', NULL, NULL, 99, NULL, 'PDZ domain-like', 285620),
(472456, '0044366', NULL, NULL, 107, NULL, 'PDZ domain-like', 285620),
(472457, '0044688', NULL, NULL, 94, NULL, 'PDZ domain-like', 285620),
(472458, '0041775', NULL, NULL, 84, NULL, 'PDZ domain-like', 285620);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(472459, '0049781', NULL, NULL, 94, NULL, 'PDZ domain-like', 285620),
(472460, '0050572', NULL, NULL, 104, NULL, 'PDZ domain-like', 285620),
(472461, '0049780', NULL, NULL, 87, NULL, 'PDZ domain-like', 285620),
(472462, '0050057', NULL, NULL, 122, NULL, 'PDZ domain-like', 285620),
(472463, '0050574', NULL, NULL, 96, NULL, 'PDZ domain-like', 285620),
(472464, '0040806', NULL, NULL, 91, NULL, 'PDZ domain-like', 285620),
(472465, '0052077', NULL, NULL, 94, NULL, 'PDZ domain-like', 285620),
(472466, '0050492', NULL, NULL, 131, NULL, 'PDZ domain-like', 285620),
(472467, '0050857', NULL, NULL, 107, NULL, 'PDZ domain-like', 285620),
(472468, '0049948', NULL, NULL, 113, NULL, 'PDZ domain-like', 285620),
(472469, '0045904', NULL, NULL, 127, NULL, 'PDZ domain-like', 285620),
(472470, '0040294', NULL, NULL, 88, NULL, 'PDZ domain-like', 285620),
(472471, '0048138', NULL, NULL, 95, NULL, 'PDZ domain-like', 285620),
(472472, '0052270', NULL, NULL, 106, NULL, 'PDZ domain-like', 285620),
(472473, '0043682', NULL, NULL, 99, NULL, 'PDZ domain-like', 285620),
(472474, '0045940', NULL, NULL, 115, NULL, 'PDZ domain-like', 285620),
(472475, '0049946', NULL, NULL, 110, NULL, 'PDZ domain-like', 285620),
(472476, '0040455', NULL, NULL, 100, NULL, 'PDZ domain-like', 285620),
(472477, '0042116', NULL, NULL, 99, NULL, 'PDZ domain-like', 285620),
(472478, '0044337', NULL, NULL, 103, NULL, 'PDZ domain-like', 285620),
(472479, '0050541', NULL, NULL, 124, NULL, 'PDZ domain-like', 285620),
(472480, '0050584', NULL, NULL, 126, NULL, 'PDZ domain-like', 285620),
(472481, '0044382', NULL, NULL, 117, NULL, 'PDZ domain-like', 285620),
(472482, '0050063', NULL, NULL, 117, NULL, 'PDZ domain-like', 285620),
(472483, '0052727', NULL, NULL, 88, NULL, 'PDZ domain-like', 285620),
(472484, '0042601', NULL, NULL, 104, NULL, 'PDZ domain-like', 285620),
(472485, '0042844', NULL, NULL, 95, NULL, 'PDZ domain-like', 285620),
(472486, '0050618', NULL, NULL, 90, NULL, 'PDZ domain-like', 285620),
(472487, '0047731', NULL, NULL, 91, NULL, 'PDZ domain-like', 285620),
(472488, '0052281', NULL, NULL, 104, NULL, 'PDZ domain-like', 285620),
(472489, '0049876', NULL, NULL, 114, NULL, 'PDZ domain-like', 285620),
(472490, '0043410', NULL, NULL, 128, NULL, 'PDZ domain-like', 285620),
(472491, '0041357', NULL, NULL, 123, NULL, 'PDZ domain-like', 285620),
(472492, '0041555', NULL, NULL, 82, NULL, 'PDZ domain-like', 285620),
(472493, '0048900', NULL, NULL, 108, NULL, 'PDZ domain-like', 285620),
(472494, '0042687', NULL, NULL, 90, NULL, 'PDZ domain-like', 285620),
(472495, '0049878', NULL, NULL, 101, NULL, 'PDZ domain-like', 285620),
(472496, '0044623', NULL, NULL, 103, NULL, 'PDZ domain-like', 285620),
(472497, '0051639', NULL, NULL, 124, NULL, 'RNase III domain-like', 285621),
(472498, '0044214', NULL, NULL, 127, NULL, 'RNase III domain-like', 285621),
(472499, '0047579', NULL, NULL, 148, NULL, 'RNase III domain-like', 285621),
(472500, '0041655', NULL, NULL, 169, NULL, 'RNase III domain-like', 285621),
(472501, '0053452', NULL, NULL, 59, NULL, 'Eea1 homodimerisation domain', 285622),
(472502, '0050078', NULL, NULL, 202, NULL, 'PHP domain-like', 285623),
(472503, '0048101', NULL, NULL, 244, NULL, 'PHP domain-like', 285623),
(472504, '0051802', NULL, NULL, 229, NULL, 'PHP domain-like', 285623),
(472505, '0038850', NULL, NULL, 61, NULL, 'PABC (PABP) domain', 285624),
(472506, '0041463', NULL, NULL, 85, NULL, 'PABC (PABP) domain', 285624),
(472507, '0038011', NULL, NULL, 144, NULL, 'PABC (PABP) domain', 285624),
(472508, '0038997', NULL, NULL, 92, NULL, 'PABC (PABP) domain', 285624),
(472509, '0039536', NULL, NULL, 98, NULL, 'PABC (PABP) domain', 285624),
(472510, '0054575', NULL, NULL, 155, NULL, 'UraD-Like', 285625),
(472511, '0054343', NULL, NULL, 165, NULL, 'UraD-Like', 285625),
(472512, '0054339', NULL, NULL, 165, NULL, 'UraD-Like', 285625),
(472513, '0054446', NULL, NULL, 148, NULL, 'PSPTO4464-like', 285626),
(472514, '0053782', NULL, NULL, 409, NULL, 'Viral glycoprotein ectodomain-like', 285627),
(472515, '0053980', NULL, NULL, 615, NULL, 'Viral glycoprotein ectodomain-like', 285627);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(472516, '0041552', NULL, NULL, 256, NULL, 'Nop domain', 285628),
(472517, '0054436', NULL, NULL, 249, NULL, 'Nop domain', 285628),
(472518, '0048370', NULL, NULL, 118, NULL, 'PheT/TilS domain', 285629),
(472519, '0042526', NULL, NULL, 209, NULL, 'PheT/TilS domain', 285629),
(472520, '0034925', NULL, NULL, 74, NULL, 'tRNA-intron endonuclease N-terminal domain-like', 285630),
(472521, '0043081', NULL, NULL, 58, NULL, 'tRNA-intron endonuclease N-terminal domain-like', 285630),
(472522, '0043079', NULL, NULL, 75, NULL, 'tRNA-intron endonuclease N-terminal domain-like', 285630),
(472523, '0037976', NULL, NULL, 131, NULL, 'Initiation factor IF2/eIF5b, domain 3', 285631),
(472524, '0049400', NULL, NULL, 181, NULL, 'vWA-like', 285632),
(472525, '0048276', NULL, NULL, 189, NULL, 'vWA-like', 285632),
(472526, '0051423', NULL, NULL, 174, NULL, 'vWA-like', 285632),
(472527, '0053614', NULL, NULL, 196, NULL, 'vWA-like', 285632),
(472528, '0053249', NULL, NULL, 253, NULL, 'vWA-like', 285632),
(472529, '0039774', NULL, NULL, 248, NULL, 'vWA-like', 285632),
(472530, '0035144', NULL, NULL, 201, NULL, 'vWA-like', 285632),
(472531, '0036024', NULL, NULL, 193, NULL, 'vWA-like', 285632),
(472532, '0046828', NULL, NULL, 196, NULL, 'vWA-like', 285632),
(472533, '0045819', NULL, NULL, 184, NULL, 'vWA-like', 285632),
(472534, '0040480', NULL, NULL, 183, NULL, 'vWA-like', 285632),
(472535, '0048147', NULL, NULL, 194, NULL, 'vWA-like', 285632),
(472536, '0040744', NULL, NULL, 271, NULL, 'vWA-like', 285632),
(472537, '0040754', NULL, NULL, 252, NULL, 'vWA-like', 285632),
(472538, '0047568', NULL, NULL, 220, NULL, 'vWA-like', 285632),
(472539, '0047569', NULL, NULL, 236, NULL, 'vWA-like', 285632),
(472540, '0048922', NULL, NULL, 192, NULL, 'vWA-like', 285632),
(472541, '0040011', NULL, NULL, 59, NULL, 'Nuclear receptor coactivator interlocking domain', 285633),
(472542, '0040010', NULL, NULL, 47, NULL, 'Nuclear receptor coactivator interlocking domain', 285633),
(472543, '0053766', NULL, NULL, 51, NULL, 'Nuclear receptor coactivator interlocking domain', 285633),
(472544, '0053346', NULL, NULL, 112, NULL, 'Purple acid phosphatase, N-terminal domain', 285634),
(472545, '0051158', NULL, NULL, 119, NULL, 'Purple acid phosphatase, N-terminal domain', 285634),
(472546, '0052597', NULL, NULL, 161, NULL, 'UBC-like', 285635),
(472547, '0051563', NULL, NULL, 151, NULL, 'UBC-like', 285635),
(472548, '0052596', NULL, NULL, 157, NULL, 'UBC-like', 285635),
(472549, '0046890', NULL, NULL, 149, NULL, 'UBC-like', 285635),
(472550, '0045484', NULL, NULL, 164, NULL, 'UBC-like', 285635),
(472551, '0038907', NULL, NULL, 146, NULL, 'UBC-like', 285635),
(472552, '0042708', NULL, NULL, 148, NULL, 'UBC-like', 285635),
(472553, '0051649', NULL, NULL, 162, NULL, 'UBC-like', 285635),
(472554, '0051720', NULL, NULL, 117, NULL, 'UBC-like', 285635),
(472555, '0051962', NULL, NULL, 154, NULL, 'UBC-like', 285635),
(472556, '0052733', NULL, NULL, 109, NULL, 'UBC-like', 285635),
(472557, '0035854', NULL, NULL, 144, NULL, 'UBC-like', 285635),
(472558, '0051700', NULL, NULL, 139, NULL, 'UBC-like', 285635),
(472559, '0051843', NULL, NULL, 125, NULL, 'UBC-like', 285635),
(472560, '0044417', NULL, NULL, 137, NULL, 'UBC-like', 285635),
(472561, '0045144', NULL, NULL, 150, NULL, 'UBC-like', 285635),
(472562, '0051380', NULL, NULL, 148, NULL, 'UBC-like', 285635),
(472563, '0047526', NULL, NULL, 140, NULL, 'UBC-like', 285635),
(472564, '0048879', NULL, NULL, 149, NULL, 'UBC-like', 285635),
(472565, '0047527', NULL, NULL, 149, NULL, 'UBC-like', 285635),
(472566, '0047549', NULL, NULL, 152, NULL, 'UBC-like', 285635),
(472567, '0045844', NULL, NULL, 153, NULL, 'UBC-like', 285635),
(472568, '0051297', NULL, NULL, 158, NULL, 'UBC-like', 285635),
(472569, '0051310', NULL, NULL, 152, NULL, 'UBC-like', 285635),
(472570, '0054300', NULL, NULL, 176, NULL, 'UBC-like', 285635),
(472571, '0044580', NULL, NULL, 152, NULL, 'UBC-like', 285635),
(472572, '0045252', NULL, NULL, 156, NULL, 'UBC-like', 285635),
(472573, '0051858', NULL, NULL, 146, NULL, 'UBC-like', 285635),
(472574, '0039447', NULL, NULL, 152, NULL, 'UBC-like', 285635);
INSERT INTO "PUBLIC"."MODEL" VALUES
(472575, '0051478', NULL, NULL, 147, NULL, 'UBC-like', 285635),
(472576, '0053811', NULL, NULL, 140, NULL, 'UBC-like', 285635),
(472577, '0053118', NULL, NULL, 162, NULL, 'UBC-like', 285635),
(472578, '0053812', NULL, NULL, 115, NULL, 'UBC-like', 285635),
(472579, '0039449', NULL, NULL, 136, NULL, 'UBC-like', 285635),
(472580, '0050764', NULL, NULL, 150, NULL, 'UBC-like', 285635),
(472581, '0051215', NULL, NULL, 148, NULL, 'UBC-like', 285635),
(472582, '0053810', NULL, NULL, 141, NULL, 'UBC-like', 285635),
(472583, '0040200', NULL, NULL, 144, NULL, 'UBC-like', 285635),
(472584, '0051309', NULL, NULL, 154, NULL, 'UBC-like', 285635),
(472585, '0042542', NULL, NULL, 161, NULL, 'UBC-like', 285635),
(472586, '0049978', NULL, NULL, 147, NULL, 'UBC-like', 285635),
(472587, '0044227', NULL, NULL, 160, NULL, 'UBC-like', 285635),
(472588, '0043048', NULL, NULL, 213, NULL, 'YcfC-like', 285636),
(472589, '0043609', NULL, NULL, 48, NULL, 'Defensin-like', 285637),
(472590, '0035411', NULL, NULL, 42, NULL, 'Defensin-like', 285637),
(472591, '0035631', NULL, NULL, 38, NULL, 'Defensin-like', 285637),
(472592, '0054923', NULL, NULL, 37, NULL, 'Defensin-like', 285637),
(472593, '0036768', NULL, NULL, 37, NULL, 'Defensin-like', 285637),
(472594, '0038424', NULL, NULL, 42, NULL, 'Defensin-like', 285637),
(472595, '0054922', NULL, NULL, 37, NULL, 'Defensin-like', 285637),
(472596, '0036767', NULL, NULL, 36, NULL, 'Defensin-like', 285637),
(472597, '0036766', NULL, NULL, 35, NULL, 'Defensin-like', 285637),
(472598, '0040113', NULL, NULL, 45, NULL, 'Defensin-like', 285637),
(472599, '0045936', NULL, NULL, 43, NULL, 'Defensin-like', 285637),
(472600, '0037233', NULL, NULL, 32, NULL, 'Defensin-like', 285637),
(472601, '0049707', NULL, NULL, 32, NULL, 'Defensin-like', 285637),
(472602, '0035155', NULL, NULL, 49, NULL, 'Defensin-like', 285637),
(472603, '0035197', NULL, NULL, 46, NULL, 'Defensin-like', 285637),
(472604, '0035053', NULL, NULL, 49, NULL, 'Defensin-like', 285637),
(472605, '0036291', NULL, NULL, 42, NULL, 'Defensin-like', 285637),
(472606, '0046326', NULL, NULL, 30, NULL, 'Defensin-like', 285637),
(472607, '0046756', NULL, NULL, 41, NULL, 'Defensin-like', 285637),
(472608, '0044513', NULL, NULL, 38, NULL, 'Defensin-like', 285637),
(472609, '0044663', NULL, NULL, 78, NULL, 'MoaD-related protein, C-terminal domain', 285638),
(472610, '0053643', NULL, NULL, 71, NULL, 'Ribosomal L11/L12e N-terminal domain', 285639),
(472611, '0054893', NULL, NULL, 70, NULL, 'Ribosomal L11/L12e N-terminal domain', 285639),
(472612, '0050580', NULL, NULL, 92, NULL, 'Ribosomal L11/L12e N-terminal domain', 285639),
(472613, '0041008', NULL, NULL, 63, NULL, 'Ribosomal L11/L12e N-terminal domain', 285639),
(472614, '0053999', NULL, NULL, 71, NULL, 'Ribosomal L11/L12e N-terminal domain', 285639),
(472615, '0054092', NULL, NULL, 180, NULL, 'AF1531-like', 285640),
(472616, '0054233', NULL, NULL, 106, NULL, 'Hormone receptor domain', 285641),
(472617, '0044198', NULL, NULL, 119, NULL, 'Hormone receptor domain', 285641),
(472618, '0050783', NULL, NULL, 87, NULL, 'BSD domain-like', 285642),
(472619, '0052439', NULL, NULL, 48, NULL, 'BSD domain-like', 285642),
(472620, '0054952', NULL, NULL, 157, NULL, 'NTF2-like', 285643),
(472621, '0051880', NULL, NULL, 167, NULL, 'NTF2-like', 285643),
(472622, '0053984', NULL, NULL, 128, NULL, 'NTF2-like', 285643),
(472623, '0054951', NULL, NULL, 131, NULL, 'NTF2-like', 285643),
(472624, '0053662', NULL, NULL, 129, NULL, 'NTF2-like', 285643),
(472625, '0054114', NULL, NULL, 113, NULL, 'NTF2-like', 285643),
(472626, '0054673', NULL, NULL, 133, NULL, 'NTF2-like', 285643),
(472627, '0052330', NULL, NULL, 182, NULL, 'NTF2-like', 285643),
(472628, '0054672', NULL, NULL, 153, NULL, 'NTF2-like', 285643),
(472629, '0049321', NULL, NULL, 139, NULL, 'NTF2-like', 285643),
(472630, '0051680', NULL, NULL, 132, NULL, 'NTF2-like', 285643),
(472631, '0042608', NULL, NULL, 174, NULL, 'NTF2-like', 285643),
(472632, '0053947', NULL, NULL, 144, NULL, 'NTF2-like', 285643),
(472633, '0042609', NULL, NULL, 205, NULL, 'NTF2-like', 285643);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(472634, '0053904', NULL, NULL, 129, NULL, 'NTF2-like', 285643),
(472635, '0053747', NULL, NULL, 139, NULL, 'NTF2-like', 285643),
(472636, '0053946', NULL, NULL, 138, NULL, 'NTF2-like', 285643),
(472637, '0054836', NULL, NULL, 124, NULL, 'NTF2-like', 285643),
(472638, '0054957', NULL, NULL, 149, NULL, 'NTF2-like', 285643),
(472639, '0054954', NULL, NULL, 128, NULL, 'NTF2-like', 285643),
(472640, '0054953', NULL, NULL, 130, NULL, 'NTF2-like', 285643),
(472641, '0039599', NULL, NULL, 186, NULL, 'NTF2-like', 285643),
(472642, '0042813', NULL, NULL, 125, NULL, 'NTF2-like', 285643),
(472643, '0054909', NULL, NULL, 162, NULL, 'NTF2-like', 285643),
(472644, '0044078', NULL, NULL, 126, NULL, 'NTF2-like', 285643),
(472645, '0053752', NULL, NULL, 132, NULL, 'NTF2-like', 285643),
(472646, '0047196', NULL, NULL, 141, NULL, 'NTF2-like', 285643),
(472647, '0050285', NULL, NULL, 112, NULL, 'NTF2-like', 285643),
(472648, '0054643', NULL, NULL, 122, NULL, 'NTF2-like', 285643),
(472649, '0054962', NULL, NULL, 159, NULL, 'NTF2-like', 285643),
(472650, '0053673', NULL, NULL, 117, NULL, 'NTF2-like', 285643),
(472651, '0054683', NULL, NULL, 135, NULL, 'NTF2-like', 285643),
(472652, '0054924', NULL, NULL, 132, NULL, 'NTF2-like', 285643),
(472653, '0054966', NULL, NULL, 118, NULL, 'NTF2-like', 285643),
(472654, '0054965', NULL, NULL, 127, NULL, 'NTF2-like', 285643),
(472655, '0050687', NULL, NULL, 182, NULL, 'NTF2-like', 285643),
(472656, '0049938', NULL, NULL, 177, NULL, 'NTF2-like', 285643),
(472657, '0053905', NULL, NULL, 140, NULL, 'NTF2-like', 285643),
(472658, '0048566', NULL, NULL, 125, NULL, 'NTF2-like', 285643),
(472659, '0049417', NULL, NULL, 142, NULL, 'NTF2-like', 285643),
(472660, '0044127', NULL, NULL, 131, NULL, 'NTF2-like', 285643),
(472661, '0054254', NULL, NULL, 123, NULL, 'NTF2-like', 285643),
(472662, '0046550', NULL, NULL, 193, NULL, 'NTF2-like', 285643),
(472663, '0053926', NULL, NULL, 192, NULL, 'NTF2-like', 285643),
(472664, '0054816', NULL, NULL, 144, NULL, 'NTF2-like', 285643),
(472665, '0054815', NULL, NULL, 121, NULL, 'NTF2-like', 285643),
(472666, '0047080', NULL, NULL, 121, NULL, 'NTF2-like', 285643),
(472667, '0054612', NULL, NULL, 139, NULL, 'NTF2-like', 285643),
(472668, '0042033', NULL, NULL, 125, NULL, 'NTF2-like', 285643),
(472669, '0048458', NULL, NULL, 145, NULL, 'NTF2-like', 285643),
(472670, '0041823', NULL, NULL, 165, NULL, 'NTF2-like', 285643),
(472671, '0041822', NULL, NULL, 221, NULL, 'NTF2-like', 285643),
(472672, '0040851', NULL, NULL, 142, NULL, 'NTF2-like', 285643),
(472673, '0053774', NULL, NULL, 167, NULL, 'NTF2-like', 285643),
(472674, '0054666', NULL, NULL, 127, NULL, 'NTF2-like', 285643),
(472675, '0053334', NULL, NULL, 162, NULL, 'NTF2-like', 285643),
(472676, '0054940', NULL, NULL, 133, NULL, 'NTF2-like', 285643),
(472677, '0053770', NULL, NULL, 140, NULL, 'NTF2-like', 285643),
(472678, '0054145', NULL, NULL, 155, NULL, 'NTF2-like', 285643),
(472679, '0054947', NULL, NULL, 163, NULL, 'NTF2-like', 285643),
(472680, '0054901', NULL, NULL, 153, NULL, 'NTF2-like', 285643),
(472681, '0052008', NULL, NULL, 194, NULL, 'NTF2-like', 285643),
(472682, '0054427', NULL, NULL, 128, NULL, 'NTF2-like', 285643),
(472683, '0054943', NULL, NULL, 117, NULL, 'NTF2-like', 285643),
(472684, '0054821', NULL, NULL, 121, NULL, 'NTF2-like', 285643),
(472685, '0054939', NULL, NULL, 135, NULL, 'NTF2-like', 285643),
(472686, '0047611', NULL, NULL, 139, NULL, 'NTF2-like', 285643),
(472687, '0054479', NULL, NULL, 117, NULL, 'GAD domain-like', 285644),
(472688, '0046051', NULL, NULL, 133, NULL, 'GAD domain-like', 285644),
(472689, '0037937', NULL, NULL, 120, NULL, 'GAD domain-like', 285644),
(472690, '0052391', NULL, NULL, 125, NULL, 'GAD domain-like', 285644),
(472691, '0051613', NULL, NULL, 131, NULL, 'GAD domain-like', 285644),
(472692, '0052000', NULL, NULL, 181, NULL, 'Pentapeptide repeat-like', 285645),
(472693, '0052590', NULL, NULL, 132, NULL, 'Pentapeptide repeat-like', 285645),
(472694, '0053162', NULL, NULL, 175, NULL, 'Pentapeptide repeat-like', 285645),
(472695, '0046173', NULL, NULL, 375, NULL, 'Ribonuclease H-like', 285646);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(472696, '0051245', NULL, NULL, 228, NULL, 'Ribonuclease H-like', 285646),
(472697, '0049323', NULL, NULL, 410, NULL, 'Ribonuclease H-like', 285646),
(472698, '0049961', NULL, NULL, 286, NULL, 'Ribonuclease H-like', 285646),
(472699, '0047541', NULL, NULL, 184, NULL, 'Ribonuclease H-like', 285646),
(472700, '0046055', NULL, NULL, 168, NULL, 'Ribonuclease H-like', 285646),
(472701, '0049562', NULL, NULL, 204, NULL, 'Ribonuclease H-like', 285646),
(472702, '0041082', NULL, NULL, 126, NULL, 'Ribonuclease H-like', 285646),
(472703, '0051402', NULL, NULL, 180, NULL, 'Ribonuclease H-like', 285646),
(472704, '0037052', NULL, NULL, 225, NULL, 'Ribonuclease H-like', 285646),
(472705, '0045929', NULL, NULL, 223, NULL, 'Ribonuclease H-like', 285646),
(472706, '0049844', NULL, NULL, 211, NULL, 'Ribonuclease H-like', 285646),
(472707, '0051650', NULL, NULL, 301, NULL, 'Ribonuclease H-like', 285646),
(472708, '0052620', NULL, NULL, 202, NULL, 'Ribonuclease H-like', 285646),
(472709, '0047793', NULL, NULL, 195, NULL, 'Ribonuclease H-like', 285646),
(472710, '0052065', NULL, NULL, 447, NULL, 'Ribonuclease H-like', 285646),
(472711, '0047398', NULL, NULL, 213, NULL, 'Ribonuclease H-like', 285646),
(472712, '0048960', NULL, NULL, 347, NULL, 'Ribonuclease H-like', 285646),
(472713, '0049179', NULL, NULL, 147, NULL, 'Ribonuclease H-like', 285646),
(472714, '0050648', NULL, NULL, 173, NULL, 'Ribonuclease H-like', 285646),
(472715, '0051538', NULL, NULL, 132, NULL, 'Ribonuclease H-like', 285646),
(472716, '0045815', NULL, NULL, 162, NULL, 'Ribonuclease H-like', 285646),
(472717, '0036277', NULL, NULL, 347, NULL, 'Ribonuclease H-like', 285646),
(472718, '0048444', NULL, NULL, 138, NULL, 'Ribonuclease H-like', 285646),
(472719, '0048406', NULL, NULL, 372, NULL, 'Ribonuclease H-like', 285646),
(472720, '0047514', NULL, NULL, 174, NULL, 'Ribonuclease H-like', 285646),
(472721, '0050330', NULL, NULL, 200, NULL, 'Ribonuclease H-like', 285646),
(472722, '0053000', NULL, NULL, 292, NULL, 'Ribonuclease H-like', 285646),
(472723, '0053802', NULL, NULL, 252, NULL, 'Ribonuclease H-like', 285646),
(472724, '0052515', NULL, NULL, 221, NULL, 'Ribonuclease H-like', 285646),
(472725, '0038606', NULL, NULL, 158, NULL, 'Ribonuclease H-like', 285646),
(472726, '0035416', NULL, NULL, 154, NULL, 'Ribonuclease H-like', 285646),
(472727, '0050411', NULL, NULL, 316, NULL, 'Ribonuclease H-like', 285646),
(472728, '0054813', NULL, NULL, 226, NULL, 'Ribonuclease H-like', 285646),
(472729, '0050971', NULL, NULL, 183, NULL, 'Ribonuclease H-like', 285646),
(472730, '0054856', NULL, NULL, 149, NULL, 'Ribonuclease H-like', 285646),
(472731, '0051425', NULL, NULL, 392, NULL, 'Ribonuclease H-like', 285646),
(472732, '0044818', NULL, NULL, 206, NULL, 'Ribonuclease H-like', 285646),
(472733, '0049624', NULL, NULL, 347, NULL, 'Ribonuclease H-like', 285646),
(472734, '0047446', NULL, NULL, 98, NULL, 'Ribonuclease H-like', 285646),
(472735, '0040018', NULL, NULL, 218, NULL, 'Ribonuclease H-like', 285646),
(472736, '0041666', NULL, NULL, 138, NULL, 'Ribonuclease H-like', 285646),
(472737, '0050187', NULL, NULL, 140, NULL, 'Ribonuclease H-like', 285646),
(472738, '0051397', NULL, NULL, 193, NULL, 'Ribonuclease H-like', 285646),
(472739, '0053015', NULL, NULL, 171, NULL, 'Ribonuclease H-like', 285646),
(472740, '0047295', NULL, NULL, 200, NULL, 'Ribonuclease H-like', 285646),
(472741, '0046085', NULL, NULL, 159, NULL, 'Ribonuclease H-like', 285646),
(472742, '0049752', NULL, NULL, 447, NULL, 'Ribonuclease H-like', 285646),
(472743, '0046881', NULL, NULL, 470, NULL, 'Ribonuclease H-like', 285646),
(472744, '0049035', NULL, NULL, 130, NULL, 'Ribonuclease H-like', 285646),
(472745, '0050668', NULL, NULL, 347, NULL, 'Ribonuclease H-like', 285646),
(472746, '0054949', NULL, NULL, 253, NULL, 'Ribonuclease H-like', 285646),
(472747, '0054948', NULL, NULL, 257, NULL, 'Ribonuclease H-like', 285646),
(472748, '0046649', NULL, NULL, 154, NULL, 'Ribonuclease H-like', 285646),
(472749, '0048905', NULL, NULL, 388, NULL, 'Ribonuclease H-like', 285646),
(472750, '0047617', NULL, NULL, 150, NULL, 'Ribonuclease H-like', 285646);
INSERT INTO "PUBLIC"."MODEL" VALUES
(472751, '0046687', NULL, NULL, 152, NULL, 'Ribonuclease H-like', 285646),
(472752, '0048225', NULL, NULL, 474, NULL, 'Ribonuclease H-like', 285646),
(472753, '0047084', NULL, NULL, 106, NULL, 'Multiheme cytochromes', 285647),
(472754, '0052296', NULL, NULL, 107, NULL, 'Multiheme cytochromes', 285647),
(472755, '0049002', NULL, NULL, 101, NULL, 'Multiheme cytochromes', 285647),
(472756, '0046418', NULL, NULL, 332, NULL, 'Multiheme cytochromes', 285647),
(472757, '0037571', NULL, NULL, 499, NULL, 'Multiheme cytochromes', 285647),
(472758, '0046850', NULL, NULL, 471, NULL, 'Multiheme cytochromes', 285647),
(472759, '0048634', NULL, NULL, 71, NULL, 'Multiheme cytochromes', 285647),
(472760, '0048931', NULL, NULL, 473, NULL, 'Multiheme cytochromes', 285647),
(472761, '0047103', NULL, NULL, 506, NULL, 'Multiheme cytochromes', 285647),
(472762, '0049967', NULL, NULL, 107, NULL, 'Multiheme cytochromes', 285647),
(472763, '0046855', NULL, NULL, 211, NULL, 'Multiheme cytochromes', 285647),
(472764, '0048064', NULL, NULL, 90, NULL, 'Multiheme cytochromes', 285647),
(472765, '0047493', NULL, NULL, 108, NULL, 'Multiheme cytochromes', 285647),
(472766, '0048560', NULL, NULL, 293, NULL, 'Multiheme cytochromes', 285647),
(472767, '0049433', NULL, NULL, 442, NULL, 'Multiheme cytochromes', 285647),
(472768, '0049254', NULL, NULL, 81, NULL, 'Multiheme cytochromes', 285647),
(472769, '0036731', NULL, NULL, 102, NULL, 'Multiheme cytochromes', 285647),
(472770, '0035167', NULL, NULL, 110, NULL, 'Multiheme cytochromes', 285647),
(472771, '0037345', NULL, NULL, 68, NULL, 'Multiheme cytochromes', 285647),
(472772, '0052348', NULL, NULL, 118, NULL, 'Multiheme cytochromes', 285647),
(472773, '0037264', NULL, NULL, 310, NULL, 'Multiheme cytochromes', 285647),
(472774, '0038376', NULL, NULL, 240, NULL, 'Multiheme cytochromes', 285647),
(472775, '0047319', NULL, NULL, 107, NULL, 'Multiheme cytochromes', 285647),
(472776, '0044945', NULL, NULL, 111, NULL, 'Multiheme cytochromes', 285647),
(472777, '0039660', NULL, NULL, 68, NULL, 'Multiheme cytochromes', 285647),
(472778, '0045497', NULL, NULL, 102, NULL, 'Multiheme cytochromes', 285647),
(472779, '0046269', NULL, NULL, 102, NULL, 'Multiheme cytochromes', 285647),
(472780, '0046401', NULL, NULL, 289, NULL, 'Multiheme cytochromes', 285647),
(472781, '0047058', NULL, NULL, 441, NULL, 'Multiheme cytochromes', 285647),
(472782, '0048527', NULL, NULL, 482, NULL, 'Multiheme cytochromes', 285647),
(472783, '0045679', NULL, NULL, 292, NULL, 'Multiheme cytochromes', 285647),
(472784, '0041853', NULL, NULL, 127, NULL, 'Multiheme cytochromes', 285647),
(472785, '0049462', NULL, NULL, 119, NULL, 'alpha-catenin/vinculin-like', 285648),
(472786, '0051871', NULL, NULL, 136, NULL, 'alpha-catenin/vinculin-like', 285648),
(472787, '0049466', NULL, NULL, 137, NULL, 'alpha-catenin/vinculin-like', 285648),
(472788, '0046372', NULL, NULL, 205, NULL, 'alpha-catenin/vinculin-like', 285648),
(472789, '0049465', NULL, NULL, 72, NULL, 'alpha-catenin/vinculin-like', 285648),
(472790, '0049464', NULL, NULL, 158, NULL, 'alpha-catenin/vinculin-like', 285648),
(472791, '0049463', NULL, NULL, 117, NULL, 'alpha-catenin/vinculin-like', 285648),
(472792, '0043279', NULL, NULL, 132, NULL, 'alpha-catenin/vinculin-like', 285648),
(472793, '0047128', NULL, NULL, 131, NULL, 'alpha-catenin/vinculin-like', 285648),
(472794, '0038436', NULL, NULL, 124, NULL, 'alpha-catenin/vinculin-like', 285648),
(472795, '0048976', NULL, NULL, 181, NULL, 'alpha-catenin/vinculin-like', 285648),
(472796, '0049191', NULL, NULL, 130, NULL, 'alpha-catenin/vinculin-like', 285648),
(472797, '0053456', NULL, NULL, 69, NULL, 'SNARE fusion complex', 285649),
(472798, '0053511', NULL, NULL, 69, NULL, 'SNARE fusion complex', 285649),
(472799, '0053465', NULL, NULL, 41, NULL, 'SNARE fusion complex', 285649),
(472800, '0053487', NULL, NULL, 54, NULL, 'SNARE fusion complex', 285649),
(472801, '0053430', NULL, NULL, 55, NULL, 'SNARE fusion complex', 285649),
(472802, '0053471', NULL, NULL, 75, NULL, 'SNARE fusion complex', 285649),
(472803, '0053472', NULL, NULL, 28, NULL, 'SNARE fusion complex', 285649);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(472804, '0053529', NULL, NULL, 58, NULL, 'SNARE fusion complex', 285649),
(472805, '0053428', NULL, NULL, 60, NULL, 'SNARE fusion complex', 285649),
(472806, '0053429', NULL, NULL, 60, NULL, 'SNARE fusion complex', 285649),
(472807, '0053514', NULL, NULL, 74, NULL, 'SNARE fusion complex', 285649),
(472808, '0053427', NULL, NULL, 54, NULL, 'SNARE fusion complex', 285649),
(472809, '0053468', NULL, NULL, 66, NULL, 'SNARE fusion complex', 285649),
(472810, '0053512', NULL, NULL, 77, NULL, 'SNARE fusion complex', 285649),
(472811, '0053469', NULL, NULL, 82, NULL, 'SNARE fusion complex', 285649),
(472812, '0053513', NULL, NULL, 72, NULL, 'SNARE fusion complex', 285649),
(472813, '0054810', NULL, NULL, 64, NULL, 'SNARE fusion complex', 285649),
(472814, '0054809', NULL, NULL, 54, NULL, 'SNARE fusion complex', 285649),
(472815, '0054808', NULL, NULL, 59, NULL, 'SNARE fusion complex', 285649),
(472816, '0053470', NULL, NULL, 73, NULL, 'SNARE fusion complex', 285649),
(472817, '0051861', NULL, NULL, 70, NULL, 'FHV B2 protein-like', 285650),
(472818, '0052924', NULL, NULL, 140, NULL, 'Resolvase-like', 285651),
(472819, '0038061', NULL, NULL, 140, NULL, 'Resolvase-like', 285651),
(472820, '0037263', NULL, NULL, 212, NULL, 'Chalcone isomerase', 285652),
(472821, '0054511', NULL, NULL, 123, NULL, 'YheA/YmcA-like', 285653),
(472822, '0054367', NULL, NULL, 113, NULL, 'YheA/YmcA-like', 285653),
(472823, '0054366', NULL, NULL, 110, NULL, 'YheA/YmcA-like', 285653),
(472824, '0054122', NULL, NULL, 111, NULL, 'YheA/YmcA-like', 285653),
(472825, '0038402', NULL, NULL, 192, NULL, 'ValRS/IleRS/LeuRS editing domain', 285654),
(472826, '0049869', NULL, NULL, 179, NULL, 'ValRS/IleRS/LeuRS editing domain', 285654),
(472827, '0037567', NULL, NULL, 194, NULL, 'ValRS/IleRS/LeuRS editing domain', 285654),
(472828, '0046954', NULL, NULL, 153, NULL, 'ValRS/IleRS/LeuRS editing domain', 285654),
(472829, '0049702', NULL, NULL, 102, NULL, 'Tlp20, baculovirus telokin-like protein', 285655),
(472830, '0043103', NULL, NULL, 70, NULL, 'Hydrophobin II, HfbII', 285656),
(472831, '0042040', NULL, NULL, 45, NULL, 'H-NS histone-like proteins', 285657),
(472832, '0047212', NULL, NULL, 47, NULL, 'H-NS histone-like proteins', 285657),
(472833, '0040625', NULL, NULL, 57, NULL, 'H-NS histone-like proteins', 285657),
(472834, '0052550', NULL, NULL, 158, NULL, 'TRCF domain-like', 285658),
(472835, '0043219', NULL, NULL, 344, NULL, 'L-sulfolactate dehydrogenase-like', 285659),
(472836, '0051081', NULL, NULL, 343, NULL, 'L-sulfolactate dehydrogenase-like', 285659),
(472837, '0041611', NULL, NULL, 332, NULL, 'L-sulfolactate dehydrogenase-like', 285659),
(472838, '0041224', NULL, NULL, 82, NULL, 'CO dehydrogenase ISP C-domain like', 285660),
(472839, '0043857', NULL, NULL, 81, NULL, 'CO dehydrogenase ISP C-domain like', 285660),
(472840, '0037560', NULL, NULL, 76, NULL, 'CO dehydrogenase ISP C-domain like', 285660),
(472841, '0037698', NULL, NULL, 73, NULL, 'CO dehydrogenase ISP C-domain like', 285660),
(472842, '0049209', NULL, NULL, 76, NULL, 'CO dehydrogenase ISP C-domain like', 285660),
(472843, '0044863', NULL, NULL, 113, NULL, 'CO dehydrogenase ISP C-domain like', 285660),
(472844, '0039724', NULL, NULL, 82, NULL, 'CO dehydrogenase ISP C-domain like', 285660),
(472845, '0036414', NULL, NULL, 113, NULL, 'CO dehydrogenase ISP C-domain like', 285660),
(472846, '0052715', NULL, NULL, 285, NULL, 'Kelch motif', 285661),
(472847, '0049049', NULL, NULL, 282, NULL, 'F420-dependent methylenetetrahydromethanopterin dehydrogenase (MTD)', 285662),
(472848, '0036393', NULL, NULL, 420, NULL, 'Nitric oxide (NO) synthase oxygenase domain', 285663),
(472849, '0036914', NULL, NULL, 416, NULL, 'Nitric oxide (NO) synthase oxygenase domain', 285663),
(472850, '0040839', NULL, NULL, 363, NULL, 'Nitric oxide (NO) synthase oxygenase domain', 285663),
(472851, '0040969', NULL, NULL, 346, NULL, 'Nitric oxide (NO) synthase oxygenase domain', 285663),
(472852, '0040714', NULL, NULL, 418, NULL, 'Nitric oxide (NO) synthase oxygenase domain', 285663),
(472853, '0045599', NULL, NULL, 421, NULL, 'Nitric oxide (NO) synthase oxygenase domain', 285663);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(472854, '0052037', NULL, NULL, 73, NULL, 'Tim10-like', 285664),
(472855, '0052038', NULL, NULL, 65, NULL, 'Tim10-like', 285664),
(472856, '0047052', NULL, NULL, 80, NULL, 'HMG-box', 285665),
(472857, '0053585', NULL, NULL, 77, NULL, 'HMG-box', 285665),
(472858, '0034978', NULL, NULL, 83, NULL, 'HMG-box', 285665),
(472859, '0053586', NULL, NULL, 79, NULL, 'HMG-box', 285665),
(472860, '0050064', NULL, NULL, 101, NULL, 'HMG-box', 285665),
(472861, '0053174', NULL, NULL, 86, NULL, 'HMG-box', 285665),
(472862, '0035973', NULL, NULL, 93, NULL, 'HMG-box', 285665),
(472863, '0039979', NULL, NULL, 91, NULL, 'HMG-box', 285665),
(472864, '0038826', NULL, NULL, 70, NULL, 'HMG-box', 285665),
(472865, '0050522', NULL, NULL, 90, NULL, 'HMG-box', 285665),
(472866, '0047509', NULL, NULL, 85, NULL, 'HMG-box', 285665),
(472867, '0044636', NULL, NULL, 108, NULL, 'HMG-box', 285665),
(472868, '0039362', NULL, NULL, 77, NULL, 'HMG-box', 285665),
(472869, '0049027', NULL, NULL, 73, NULL, 'HMG-box', 285665),
(472870, '0047504', NULL, NULL, 78, NULL, 'HMG-box', 285665),
(472871, '0040422', NULL, NULL, 84, NULL, 'HMG-box', 285665),
(472872, '0046204', NULL, NULL, 269, NULL, 'TolB, C-terminal domain', 285666),
(472873, '0041883', NULL, NULL, 52, NULL, 'NblA-like', 285667),
(472874, '0049571', NULL, NULL, 75, NULL, 'Hypothetical protein AF0491, middle domain', 285668),
(472875, '0042211', NULL, NULL, 75, NULL, 'Hypothetical protein AF0491, middle domain', 285668),
(472876, '0052362', NULL, NULL, 392, NULL, 'Indolic compounds 2,3-dioxygenase-like', 285669),
(472877, '0053218', NULL, NULL, 262, NULL, 'Indolic compounds 2,3-dioxygenase-like', 285669),
(472878, '0051567', NULL, NULL, 387, NULL, 'Indolic compounds 2,3-dioxygenase-like', 285669),
(472879, '0036760', NULL, NULL, 96, NULL, 'Ribonuclease domain of colicin E3', 285670),
(472880, '0053913', NULL, NULL, 131, NULL, 'Smp-1-like', 285671),
(472881, '0043158', NULL, NULL, 121, NULL, 'Smp-1-like', 285671),
(472882, '0053742', NULL, NULL, 300, NULL, 'Metallo-dependent hydrolases', 285672),
(472883, '0051322', NULL, NULL, 265, NULL, 'Metallo-dependent hydrolases', 285672),
(472884, '0054113', NULL, NULL, 310, NULL, 'Metallo-dependent hydrolases', 285672),
(472885, '0046571', NULL, NULL, 386, NULL, 'Metallo-dependent hydrolases', 285672),
(472886, '0048352', NULL, NULL, 330, NULL, 'Metallo-dependent hydrolases', 285672),
(472887, '0052371', NULL, NULL, 329, NULL, 'Metallo-dependent hydrolases', 285672),
(472888, '0051086', NULL, NULL, 310, NULL, 'Metallo-dependent hydrolases', 285672),
(472889, '0054394', NULL, NULL, 325, NULL, 'Metallo-dependent hydrolases', 285672),
(472890, '0047785', NULL, NULL, 334, NULL, 'Metallo-dependent hydrolases', 285672),
(472891, '0048115', NULL, NULL, 358, NULL, 'Metallo-dependent hydrolases', 285672),
(472892, '0047865', NULL, NULL, 349, NULL, 'Metallo-dependent hydrolases', 285672),
(472893, '0054688', NULL, NULL, 313, NULL, 'Metallo-dependent hydrolases', 285672),
(472894, '0054489', NULL, NULL, 336, NULL, 'Metallo-dependent hydrolases', 285672),
(472895, '0048480', NULL, NULL, 288, NULL, 'Metallo-dependent hydrolases', 285672),
(472896, '0051135', NULL, NULL, 260, NULL, 'Metallo-dependent hydrolases', 285672),
(472897, '0054484', NULL, NULL, 324, NULL, 'Metallo-dependent hydrolases', 285672),
(472898, '0038137', NULL, NULL, 335, NULL, 'Metallo-dependent hydrolases', 285672),
(472899, '0051379', NULL, NULL, 297, NULL, 'Metallo-dependent hydrolases', 285672),
(472900, '0054604', NULL, NULL, 415, NULL, 'Metallo-dependent hydrolases', 285672),
(472901, '0051697', NULL, NULL, 628, NULL, 'Metallo-dependent hydrolases', 285672),
(472902, '0052789', NULL, NULL, 384, NULL, 'Metallo-dependent hydrolases', 285672),
(472903, '0054568', NULL, NULL, 301, NULL, 'Metallo-dependent hydrolases', 285672),
(472904, '0047519', NULL, NULL, 281, NULL, 'Metallo-dependent hydrolases', 285672),
(472905, '0047517', NULL, NULL, 451, NULL, 'Metallo-dependent hydrolases', 285672),
(472906, '0039386', NULL, NULL, 260, NULL, 'Metallo-dependent hydrolases', 285672);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(472907, '0047434', NULL, NULL, 369, NULL, 'Metallo-dependent hydrolases', 285672),
(472908, '0045611', NULL, NULL, 391, NULL, 'Metallo-dependent hydrolases', 285672),
(472909, '0052675', NULL, NULL, 271, NULL, 'Metallo-dependent hydrolases', 285672),
(472910, '0053002', NULL, NULL, 331, NULL, 'Metallo-dependent hydrolases', 285672),
(472911, '0039934', NULL, NULL, 320, NULL, 'Metallo-dependent hydrolases', 285672),
(472912, '0036862', NULL, NULL, 390, NULL, 'Metallo-dependent hydrolases', 285672),
(472913, '0054658', NULL, NULL, 311, NULL, 'Metallo-dependent hydrolases', 285672),
(472914, '0037271', NULL, NULL, 330, NULL, 'Metallo-dependent hydrolases', 285672),
(472915, '0045709', NULL, NULL, 349, NULL, 'Metallo-dependent hydrolases', 285672),
(472916, '0047006', NULL, NULL, 325, NULL, 'Metallo-dependent hydrolases', 285672),
(472917, '0048612', NULL, NULL, 284, NULL, 'Metallo-dependent hydrolases', 285672),
(472918, '0047525', NULL, NULL, 343, NULL, 'Metallo-dependent hydrolases', 285672),
(472919, '0051353', NULL, NULL, 332, NULL, 'Metallo-dependent hydrolases', 285672),
(472920, '0054148', NULL, NULL, 308, NULL, 'Metallo-dependent hydrolases', 285672),
(472921, '0052488', NULL, NULL, 325, NULL, 'Metallo-dependent hydrolases', 285672),
(472922, '0052760', NULL, NULL, 334, NULL, 'Metallo-dependent hydrolases', 285672),
(472923, '0051670', NULL, NULL, 259, NULL, 'Metallo-dependent hydrolases', 285672),
(472924, '0052605', NULL, NULL, 306, NULL, 'Metallo-dependent hydrolases', 285672),
(472925, '0052968', NULL, NULL, 342, NULL, 'Metallo-dependent hydrolases', 285672),
(472926, '0054628', NULL, NULL, 310, NULL, 'Metallo-dependent hydrolases', 285672),
(472927, '0054826', NULL, NULL, 303, NULL, 'Metallo-dependent hydrolases', 285672),
(472928, '0054549', NULL, NULL, 301, NULL, 'Metallo-dependent hydrolases', 285672),
(472929, '0039842', NULL, NULL, 332, NULL, 'Metallo-dependent hydrolases', 285672),
(472930, '0051799', NULL, NULL, 357, NULL, 'Metallo-dependent hydrolases', 285672),
(472931, '0045950', NULL, NULL, 291, NULL, 'Metallo-dependent hydrolases', 285672),
(472932, '0053093', NULL, NULL, 267, NULL, 'Metallo-dependent hydrolases', 285672),
(472933, '0049957', NULL, NULL, 301, NULL, 'Metallo-dependent hydrolases', 285672),
(472934, '0040736', NULL, NULL, 236, NULL, 'Suppressor of Fused, N-terminal domain', 285673),
(472935, '0054466', NULL, NULL, 241, NULL, 'PH0156-like', 285674),
(472936, '0040960', NULL, NULL, 80, NULL, 'Cytochrome b5-like heme/steroid binding domain', 285675),
(472937, '0036519', NULL, NULL, 94, NULL, 'Cytochrome b5-like heme/steroid binding domain', 285675),
(472938, '0040012', NULL, NULL, 97, NULL, 'Cytochrome b5-like heme/steroid binding domain', 285675),
(472939, '0035243', NULL, NULL, 86, NULL, 'Cytochrome b5-like heme/steroid binding domain', 285675),
(472940, '0035258', NULL, NULL, 94, NULL, 'Cytochrome b5-like heme/steroid binding domain', 285675),
(472941, '0038614', NULL, NULL, 104, NULL, 'Cytochrome b5-like heme/steroid binding domain', 285675),
(472942, '0038968', NULL, NULL, 87, NULL, 'Cytochrome b5-like heme/steroid binding domain', 285675),
(472943, '0036191', NULL, NULL, 81, NULL, 'Cytochrome b5-like heme/steroid binding domain', 285675),
(472944, '0043686', NULL, NULL, 91, NULL, 'Cytochrome b5-like heme/steroid binding domain', 285675),
(472945, '0043820', NULL, NULL, 109, NULL, 'Cytochrome b5-like heme/steroid binding domain', 285675),
(472946, '0050589', NULL, NULL, 127, NULL, 'DNA-binding domain of EIN3-like', 285676),
(472947, '0041673', NULL, NULL, 126, NULL, 'Nucleotidyltransferase substrate binding subunit/domain', 285677),
(472948, '0040171', NULL, NULL, 128, NULL, 'Nucleotidyltransferase substrate binding subunit/domain', 285677),
(472949, '0047644', NULL, NULL, 135, NULL, 'Nucleotidyltransferase substrate binding subunit/domain', 285677),
(472950, '0044324', NULL, NULL, 127, NULL, 'Nucleotidyltransferase substrate binding subunit/domain', 285677),
(472951, '0044610', NULL, NULL, 151, NULL, 'Nucleotidyltransferase substrate binding subunit/domain', 285677);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(472952, '0050699', NULL, NULL, 116, NULL, 'Nucleotidyltransferase substrate binding subunit/domain', 285677),
(472953, '0042563', NULL, NULL, 225, NULL, 'Respiratory nitrate reductase 1 gamma chain', 285678),
(472954, '0053531', NULL, NULL, 46, NULL, 'Assembly domain of cartilage oligomeric matrix protein', 285679),
(472955, '0051815', NULL, NULL, 57, NULL, 'Nop10-like SnoRNP', 285680),
(472956, '0051812', NULL, NULL, 55, NULL, 'Nop10-like SnoRNP', 285680),
(472957, '0052544', NULL, NULL, 52, NULL, 'Nop10-like SnoRNP', 285680),
(472958, '0048827', NULL, NULL, 117, NULL, 'Creatinase/prolidase N-terminal domain', 285681),
(472959, '0046142', NULL, NULL, 155, NULL, 'Creatinase/prolidase N-terminal domain', 285681),
(472960, '0040192', NULL, NULL, 156, NULL, 'Creatinase/prolidase N-terminal domain', 285681),
(472961, '0052071', NULL, NULL, 176, NULL, 'Creatinase/prolidase N-terminal domain', 285681),
(472962, '0051000', NULL, NULL, 139, NULL, 'Lipocalins', 285682),
(472963, '0050277', NULL, NULL, 351, NULL, 'Lipocalins', 285682),
(472964, '0051321', NULL, NULL, 131, NULL, 'Lipocalins', 285682),
(472965, '0035357', NULL, NULL, 133, NULL, 'Lipocalins', 285682),
(472966, '0036126', NULL, NULL, 134, NULL, 'Lipocalins', 285682),
(472967, '0036686', NULL, NULL, 148, NULL, 'Lipocalins', 285682),
(472968, '0052611', NULL, NULL, 127, NULL, 'Lipocalins', 285682),
(472969, '0054239', NULL, NULL, 126, NULL, 'Lipocalins', 285682),
(472970, '0046935', NULL, NULL, 131, NULL, 'Lipocalins', 285682),
(472971, '0040311', NULL, NULL, 171, NULL, 'Lipocalins', 285682),
(472972, '0045526', NULL, NULL, 131, NULL, 'Lipocalins', 285682),
(472973, '0037772', NULL, NULL, 133, NULL, 'Lipocalins', 285682),
(472974, '0044914', NULL, NULL, 135, NULL, 'Lipocalins', 285682),
(472975, '0037251', NULL, NULL, 160, NULL, 'Lipocalins', 285682),
(472976, '0042174', NULL, NULL, 125, NULL, 'Lipocalins', 285682),
(472977, '0047302', NULL, NULL, 181, NULL, 'Lipocalins', 285682),
(472978, '0044077', NULL, NULL, 131, NULL, 'Lipocalins', 285682),
(472979, '0046613', NULL, NULL, 184, NULL, 'Lipocalins', 285682),
(472980, '0041962', NULL, NULL, 133, NULL, 'Lipocalins', 285682),
(472981, '0049055', NULL, NULL, 167, NULL, 'Lipocalins', 285682),
(472982, '0035749', NULL, NULL, 132, NULL, 'Lipocalins', 285682),
(472983, '0051695', NULL, NULL, 158, NULL, 'Lipocalins', 285682),
(472984, '0047275', NULL, NULL, 156, NULL, 'Lipocalins', 285682),
(472985, '0052746', NULL, NULL, 161, NULL, 'Lipocalins', 285682),
(472986, '0052867', NULL, NULL, 178, NULL, 'Lipocalins', 285682),
(472987, '0035900', NULL, NULL, 136, NULL, 'Lipocalins', 285682),
(472988, '0051412', NULL, NULL, 162, NULL, 'Lipocalins', 285682),
(472989, '0036878', NULL, NULL, 127, NULL, 'Lipocalins', 285682),
(472990, '0040483', NULL, NULL, 127, NULL, 'Lipocalins', 285682),
(472991, '0042749', NULL, NULL, 175, NULL, 'Lipocalins', 285682),
(472992, '0035581', NULL, NULL, 150, NULL, 'Lipocalins', 285682),
(472993, '0047874', NULL, NULL, 175, NULL, 'Lipocalins', 285682),
(472994, '0040605', NULL, NULL, 133, NULL, 'Lipocalins', 285682),
(472995, '0043076', NULL, NULL, 146, NULL, 'Lipocalins', 285682),
(472996, '0047710', NULL, NULL, 157, NULL, 'Lipocalins', 285682),
(472997, '0041814', NULL, NULL, 187, NULL, 'Lipocalins', 285682),
(472998, '0042384', NULL, NULL, 131, NULL, 'Lipocalins', 285682),
(472999, '0046467', NULL, NULL, 149, NULL, 'Lipocalins', 285682),
(473000, '0048407', NULL, NULL, 184, NULL, 'Lipocalins', 285682),
(473001, '0048251', NULL, NULL, 173, NULL, 'Lipocalins', 285682),
(473002, '0054336', NULL, NULL, 132, NULL, 'Lipocalins', 285682),
(473003, '0054335', NULL, NULL, 137, NULL, 'Lipocalins', 285682),
(473004, '0049020', NULL, NULL, 174, NULL, 'Lipocalins', 285682),
(473005, '0052750', NULL, NULL, 136, NULL, 'Lipocalins', 285682),
(473006, '0052756', NULL, NULL, 125, NULL, 'Lipocalins', 285682),
(473007, '0038129', NULL, NULL, 174, NULL, 'Lipocalins', 285682),
(473008, '0038089', NULL, NULL, 134, NULL, 'Lipocalins', 285682),
(473009, '0038640', NULL, NULL, 131, NULL, 'Lipocalins', 285682);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(473010, '0047968', NULL, NULL, 171, NULL, 'Lipocalins', 285682),
(473011, '0042679', NULL, NULL, 180, NULL, 'Lipocalins', 285682),
(473012, '0049349', NULL, NULL, 106, NULL, 'Lipocalins', 285682),
(473013, '0040216', NULL, NULL, 134, NULL, 'Lipocalins', 285682),
(473014, '0046633', NULL, NULL, 180, NULL, 'Lipocalins', 285682),
(473015, '0040896', NULL, NULL, 131, NULL, 'Lipocalins', 285682),
(473016, '0041743', NULL, NULL, 133, NULL, 'Lipocalins', 285682),
(473017, '0048536', NULL, NULL, 158, NULL, 'Lipocalins', 285682),
(473018, '0041104', NULL, NULL, 125, NULL, 'Lipocalins', 285682),
(473019, '0041665', NULL, NULL, 127, NULL, 'Lipocalins', 285682),
(473020, '0051673', NULL, NULL, 131, NULL, 'Lipocalins', 285682),
(473021, '0051470', NULL, NULL, 189, NULL, 'Lipocalins', 285682),
(473022, '0047376', NULL, NULL, 174, NULL, 'Lipocalins', 285682),
(473023, '0035442', NULL, NULL, 173, NULL, 'Lipocalins', 285682),
(473024, '0051678', NULL, NULL, 153, NULL, 'Lipocalins', 285682),
(473025, '0037502', NULL, NULL, 131, NULL, 'Lipocalins', 285682),
(473026, '0046604', NULL, NULL, 160, NULL, 'Lipocalins', 285682),
(473027, '0038993', NULL, NULL, 131, NULL, 'Lipocalins', 285682),
(473028, '0046640', NULL, NULL, 159, NULL, 'Lipocalins', 285682),
(473029, '0047014', NULL, NULL, 158, NULL, 'Lipocalins', 285682),
(473030, '0045830', NULL, NULL, 142, NULL, 'Lipocalins', 285682),
(473031, '0037815', NULL, NULL, 459, NULL, 'Nitrous oxide reductase, N-terminal domain', 285683),
(473032, '0048991', NULL, NULL, 441, NULL, 'Nitrous oxide reductase, N-terminal domain', 285683),
(473033, '0049460', NULL, NULL, 48, NULL, 'Plexin repeat', 285684),
(473034, '0041917', NULL, NULL, 56, NULL, 'Plexin repeat', 285684),
(473035, '0049403', NULL, NULL, 49, NULL, 'Plexin repeat', 285684),
(473036, '0053613', NULL, NULL, 57, NULL, 'Plexin repeat', 285684),
(473037, '0039423', NULL, NULL, 84, NULL, 'Domain of the SRP/SRP receptor G-proteins', 285685),
(473038, '0048024', NULL, NULL, 88, NULL, 'Domain of the SRP/SRP receptor G-proteins', 285685),
(473039, '0050250', NULL, NULL, 81, NULL, 'Domain of the SRP/SRP receptor G-proteins', 285685),
(473040, '0041903', NULL, NULL, 58, NULL, 'Domain of the SRP/SRP receptor G-proteins', 285685),
(473041, '0050537', NULL, NULL, 99, NULL, 'Domain of the SRP/SRP receptor G-proteins', 285685),
(473042, '0043267', NULL, NULL, 69, NULL, 'Domain of the SRP/SRP receptor G-proteins', 285685),
(473043, '0037775', NULL, NULL, 84, NULL, 'Domain of the SRP/SRP receptor G-proteins', 285685),
(473044, '0043059', NULL, NULL, 87, NULL, 'Domain of the SRP/SRP receptor G-proteins', 285685),
(473045, '0038894', NULL, NULL, 129, NULL, 'Ribosomal protein S8', 285686),
(473046, '0038928', NULL, NULL, 138, NULL, 'Ribosomal protein S8', 285686),
(473047, '0043571', NULL, NULL, 130, NULL, 'Ribosomal protein S8', 285686),
(473048, '0035114', NULL, NULL, 136, NULL, 'Ribosomal protein S8', 285686),
(473049, '0043454', NULL, NULL, 126, NULL, 'Ribosomal protein S8', 285686),
(473050, '0047581', NULL, NULL, 343, NULL, 'PLP-dependent transferases', 285687),
(473051, '0050076', NULL, NULL, 345, NULL, 'PLP-dependent transferases', 285687),
(473052, '0048074', NULL, NULL, 361, NULL, 'PLP-dependent transferases', 285687),
(473053, '0046056', NULL, NULL, 404, NULL, 'PLP-dependent transferases', 285687),
(473054, '0047340', NULL, NULL, 380, NULL, 'PLP-dependent transferases', 285687),
(473055, '0049486', NULL, NULL, 340, NULL, 'PLP-dependent transferases', 285687),
(473056, '0042806', NULL, NULL, 396, NULL, 'PLP-dependent transferases', 285687),
(473057, '0051723', NULL, NULL, 463, NULL, 'PLP-dependent transferases', 285687),
(473058, '0042809', NULL, NULL, 429, NULL, 'PLP-dependent transferases', 285687),
(473059, '0036406', NULL, NULL, 416, NULL, 'PLP-dependent transferases', 285687),
(473060, '0050157', NULL, NULL, 387, NULL, 'PLP-dependent transferases', 285687),
(473061, '0051323', NULL, NULL, 418, NULL, 'PLP-dependent transferases', 285687),
(473062, '0053867', NULL, NULL, 364, NULL, 'PLP-dependent transferases', 285687);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(473063, '0050754', NULL, NULL, 471, NULL, 'PLP-dependent transferases', 285687),
(473064, '0051601', NULL, NULL, 431, NULL, 'PLP-dependent transferases', 285687),
(473065, '0052731', NULL, NULL, 371, NULL, 'PLP-dependent transferases', 285687),
(473066, '0050753', NULL, NULL, 437, NULL, 'PLP-dependent transferases', 285687),
(473067, '0035073', NULL, NULL, 412, NULL, 'PLP-dependent transferases', 285687),
(473068, '0048952', NULL, NULL, 398, NULL, 'PLP-dependent transferases', 285687),
(473069, '0046255', NULL, NULL, 361, NULL, 'PLP-dependent transferases', 285687),
(473070, '0043583', NULL, NULL, 425, NULL, 'PLP-dependent transferases', 285687),
(473071, '0049524', NULL, NULL, 408, NULL, 'PLP-dependent transferases', 285687),
(473072, '0044595', NULL, NULL, 368, NULL, 'PLP-dependent transferases', 285687),
(473073, '0050390', NULL, NULL, 418, NULL, 'PLP-dependent transferases', 285687),
(473074, '0054765', NULL, NULL, 434, NULL, 'PLP-dependent transferases', 285687),
(473075, '0052862', NULL, NULL, 389, NULL, 'PLP-dependent transferases', 285687),
(473076, '0044083', NULL, NULL, 426, NULL, 'PLP-dependent transferases', 285687),
(473077, '0045171', NULL, NULL, 394, NULL, 'PLP-dependent transferases', 285687),
(473078, '0046584', NULL, NULL, 381, NULL, 'PLP-dependent transferases', 285687),
(473079, '0047670', NULL, NULL, 476, NULL, 'PLP-dependent transferases', 285687),
(473080, '0037569', NULL, NULL, 354, NULL, 'PLP-dependent transferases', 285687),
(473081, '0035586', NULL, NULL, 360, NULL, 'PLP-dependent transferases', 285687),
(473082, '0050768', NULL, NULL, 403, NULL, 'PLP-dependent transferases', 285687),
(473083, '0052943', NULL, NULL, 427, NULL, 'PLP-dependent transferases', 285687),
(473084, '0035700', NULL, NULL, 361, NULL, 'PLP-dependent transferases', 285687),
(473085, '0052302', NULL, NULL, 421, NULL, 'PLP-dependent transferases', 285687),
(473086, '0035589', NULL, NULL, 382, NULL, 'PLP-dependent transferases', 285687),
(473087, '0046747', NULL, NULL, 401, NULL, 'PLP-dependent transferases', 285687),
(473088, '0042144', NULL, NULL, 391, NULL, 'PLP-dependent transferases', 285687),
(473089, '0039341', NULL, NULL, 388, NULL, 'PLP-dependent transferases', 285687),
(473090, '0044807', NULL, NULL, 377, NULL, 'PLP-dependent transferases', 285687),
(473091, '0042383', NULL, NULL, 450, NULL, 'PLP-dependent transferases', 285687),
(473092, '0046024', NULL, NULL, 412, NULL, 'PLP-dependent transferases', 285687),
(473093, '0040526', NULL, NULL, 425, NULL, 'PLP-dependent transferases', 285687),
(473094, '0045973', NULL, NULL, 470, NULL, 'PLP-dependent transferases', 285687),
(473095, '0047956', NULL, NULL, 355, NULL, 'PLP-dependent transferases', 285687),
(473096, '0044523', NULL, NULL, 330, NULL, 'PLP-dependent transferases', 285687),
(473097, '0046547', NULL, NULL, 376, NULL, 'PLP-dependent transferases', 285687),
(473098, '0052157', NULL, NULL, 393, NULL, 'PLP-dependent transferases', 285687),
(473099, '0048571', NULL, NULL, 461, NULL, 'PLP-dependent transferases', 285687),
(473100, '0047441', NULL, NULL, 348, NULL, 'PLP-dependent transferases', 285687),
(473101, '0046154', NULL, NULL, 470, NULL, 'PLP-dependent transferases', 285687),
(473102, '0054692', NULL, NULL, 467, NULL, 'PLP-dependent transferases', 285687),
(473103, '0041260', NULL, NULL, 393, NULL, 'PLP-dependent transferases', 285687),
(473104, '0050977', NULL, NULL, 395, NULL, 'PLP-dependent transferases', 285687),
(473105, '0050696', NULL, NULL, 403, NULL, 'PLP-dependent transferases', 285687),
(473106, '0037039', NULL, NULL, 478, NULL, 'PLP-dependent transferases', 285687),
(473107, '0040134', NULL, NULL, 405, NULL, 'PLP-dependent transferases', 285687),
(473108, '0036780', NULL, NULL, 394, NULL, 'PLP-dependent transferases', 285687),
(473109, '0045068', NULL, NULL, 412, NULL, 'PLP-dependent transferases', 285687),
(473110, '0041704', NULL, NULL, 374, NULL, 'PLP-dependent transferases', 285687),
(473111, '0052070', NULL, NULL, 396, NULL, 'PLP-dependent transferases', 285687),
(473112, '0040897', NULL, NULL, 376, NULL, 'PLP-dependent transferases', 285687);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(473113, '0050340', NULL, NULL, 360, NULL, 'PLP-dependent transferases', 285687),
(473114, '0053335', NULL, NULL, 397, NULL, 'PLP-dependent transferases', 285687),
(473115, '0051993', NULL, NULL, 382, NULL, 'PLP-dependent transferases', 285687),
(473116, '0045392', NULL, NULL, 404, NULL, 'PLP-dependent transferases', 285687),
(473117, '0035846', NULL, NULL, 462, NULL, 'PLP-dependent transferases', 285687),
(473118, '0047095', NULL, NULL, 388, NULL, 'PLP-dependent transferases', 285687),
(473119, '0046087', NULL, NULL, 456, NULL, 'PLP-dependent transferases', 285687),
(473120, '0051195', NULL, NULL, 397, NULL, 'PLP-dependent transferases', 285687),
(473121, '0052164', NULL, NULL, 388, NULL, 'PLP-dependent transferases', 285687),
(473122, '0046089', NULL, NULL, 394, NULL, 'PLP-dependent transferases', 285687),
(473123, '0045231', NULL, NULL, 411, NULL, 'PLP-dependent transferases', 285687),
(473124, '0046165', NULL, NULL, 391, NULL, 'PLP-dependent transferases', 285687),
(473125, '0050261', NULL, NULL, 420, NULL, 'PLP-dependent transferases', 285687),
(473126, '0035401', NULL, NULL, 428, NULL, 'PLP-dependent transferases', 285687),
(473127, '0045909', NULL, NULL, 384, NULL, 'PLP-dependent transferases', 285687),
(473128, '0051757', NULL, NULL, 366, NULL, 'PLP-dependent transferases', 285687),
(473129, '0035246', NULL, NULL, 465, NULL, 'PLP-dependent transferases', 285687),
(473130, '0051517', NULL, NULL, 404, NULL, 'PLP-dependent transferases', 285687),
(473131, '0038952', NULL, NULL, 428, NULL, 'PLP-dependent transferases', 285687),
(473132, '0054823', NULL, NULL, 445, NULL, 'PLP-dependent transferases', 285687),
(473133, '0049070', NULL, NULL, 404, NULL, 'PLP-dependent transferases', 285687),
(473134, '0038034', NULL, NULL, 392, NULL, 'PLP-dependent transferases', 285687),
(473135, '0041674', NULL, NULL, 375, NULL, 'PLP-dependent transferases', 285687),
(473136, '0045639', NULL, NULL, 401, NULL, 'PLP-dependent transferases', 285687),
(473137, '0049754', NULL, NULL, 382, NULL, 'PLP-dependent transferases', 285687),
(473138, '0046007', NULL, NULL, 383, NULL, 'PLP-dependent transferases', 285687),
(473139, '0048747', NULL, NULL, 331, NULL, 'PLP-dependent transferases', 285687),
(473140, '0046206', NULL, NULL, 384, NULL, 'PLP-dependent transferases', 285687),
(473141, '0046965', NULL, NULL, 388, NULL, 'PLP-dependent transferases', 285687),
(473142, '0050897', NULL, NULL, 68, NULL, 'Accessory protein X4 (ORF8, ORF7a)', 285688),
(473143, '0054896', NULL, NULL, 317, NULL, 'Periplasmic binding protein-like I', 285689),
(473144, '0053377', NULL, NULL, 305, NULL, 'Periplasmic binding protein-like I', 285689),
(473145, '0052792', NULL, NULL, 305, NULL, 'Periplasmic binding protein-like I', 285689),
(473146, '0045352', NULL, NULL, 344, NULL, 'Periplasmic binding protein-like I', 285689),
(473147, '0044032', NULL, NULL, 316, NULL, 'Periplasmic binding protein-like I', 285689),
(473148, '0049650', NULL, NULL, 296, NULL, 'Periplasmic binding protein-like I', 285689),
(473149, '0039803', NULL, NULL, 338, NULL, 'Periplasmic binding protein-like I', 285689),
(473150, '0036339', NULL, NULL, 282, NULL, 'Periplasmic binding protein-like I', 285689),
(473151, '0036537', NULL, NULL, 425, NULL, 'Periplasmic binding protein-like I', 285689),
(473152, '0053227', NULL, NULL, 275, NULL, 'Periplasmic binding protein-like I', 285689),
(473153, '0046959', NULL, NULL, 309, NULL, 'Periplasmic binding protein-like I', 285689),
(473154, '0039493', NULL, NULL, 401, NULL, 'Periplasmic binding protein-like I', 285689),
(473155, '0035780', NULL, NULL, 255, NULL, 'Periplasmic binding protein-like I', 285689),
(473156, '0046641', NULL, NULL, 477, NULL, 'Periplasmic binding protein-like I', 285689),
(473157, '0048996', NULL, NULL, 373, NULL, 'Periplasmic binding protein-like I', 285689),
(473158, '0045248', NULL, NULL, 271, NULL, 'Periplasmic binding protein-like I', 285689),
(473159, '0043335', NULL, NULL, 288, NULL, 'Periplasmic binding protein-like I', 285689),
(473160, '0049989', NULL, NULL, 346, NULL, 'Periplasmic binding protein-like I', 285689);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(473161, '0053277', NULL, NULL, 122, NULL, 'DNA clamp', 285690),
(473162, '0050271', NULL, NULL, 120, NULL, 'DNA clamp', 285690),
(473163, '0046361', NULL, NULL, 150, NULL, 'DNA clamp', 285690),
(473164, '0044283', NULL, NULL, 119, NULL, 'DNA clamp', 285690),
(473165, '0053276', NULL, NULL, 122, NULL, 'DNA clamp', 285690),
(473166, '0048781', NULL, NULL, 126, NULL, 'DNA clamp', 285690),
(473167, '0044284', NULL, NULL, 119, NULL, 'DNA clamp', 285690),
(473168, '0050273', NULL, NULL, 123, NULL, 'DNA clamp', 285690),
(473169, '0042371', NULL, NULL, 132, NULL, 'DNA clamp', 285690),
(473170, '0050272', NULL, NULL, 123, NULL, 'DNA clamp', 285690),
(473171, '0036501', NULL, NULL, 141, NULL, 'DNA clamp', 285690),
(473172, '0036208', NULL, NULL, 118, NULL, 'DNA clamp', 285690),
(473173, '0036207', NULL, NULL, 110, NULL, 'DNA clamp', 285690),
(473174, '0035249', NULL, NULL, 129, NULL, 'DNA clamp', 285690),
(473175, '0046967', NULL, NULL, 116, NULL, 'DNA clamp', 285690),
(473176, '0043899', NULL, NULL, 126, NULL, 'DNA clamp', 285690),
(473177, '0043900', NULL, NULL, 135, NULL, 'DNA clamp', 285690),
(473178, '0045836', NULL, NULL, 126, NULL, 'DNA clamp', 285690),
(473179, '0045418', NULL, NULL, 122, NULL, 'DNA clamp', 285690),
(473180, '0038064', NULL, NULL, 122, NULL, 'DNA clamp', 285690),
(473181, '0035384', NULL, NULL, 118, NULL, 'DNA clamp', 285690),
(473182, '0035383', NULL, NULL, 110, NULL, 'DNA clamp', 285690),
(473183, '0049258', NULL, NULL, 122, NULL, 'DNA clamp', 285690),
(473184, '0043400', NULL, NULL, 122, NULL, 'DNA clamp', 285690),
(473185, '0035037', NULL, NULL, 493, NULL, 'ALDH-like', 285691),
(473186, '0035565', NULL, NULL, 499, NULL, 'ALDH-like', 285691),
(473187, '0035003', NULL, NULL, 446, NULL, 'ALDH-like', 285691),
(473188, '0034877', NULL, NULL, 503, NULL, 'ALDH-like', 285691),
(473189, '0035766', NULL, NULL, 494, NULL, 'ALDH-like', 285691),
(473190, '0050666', NULL, NULL, 474, NULL, 'ALDH-like', 285691),
(473191, '0036174', NULL, NULL, 494, NULL, 'ALDH-like', 285691),
(473192, '0037277', NULL, NULL, 504, NULL, 'ALDH-like', 285691),
(473193, '0041750', NULL, NULL, 494, NULL, 'ALDH-like', 285691),
(473194, '0041670', NULL, NULL, 414, NULL, 'ALDH-like', 285691),
(473195, '0044574', NULL, NULL, 516, NULL, 'ALDH-like', 285691),
(473196, '0037193', NULL, NULL, 474, NULL, 'ALDH-like', 285691),
(473197, '0040316', NULL, NULL, 499, NULL, 'ALDH-like', 285691),
(473198, '0044883', NULL, NULL, 436, NULL, 'ALDH-like', 285691),
(473199, '0047758', NULL, NULL, 431, NULL, 'ALDH-like', 285691),
(473200, '0040630', NULL, NULL, 118, NULL, 'Replication modulator SeqA, C-terminal DNA-binding domain', 285692),
(473201, '0052271', NULL, NULL, 55, NULL, 'PhtA domain-like', 285693),
(473202, '0054410', NULL, NULL, 152, NULL, 'Ligand-binding domain in the NO signalling and Golgi transport', 285694),
(473203, '0050429', NULL, NULL, 161, NULL, 'Ligand-binding domain in the NO signalling and Golgi transport', 285694),
(473204, '0044205', NULL, NULL, 188, NULL, 'Ligand-binding domain in the NO signalling and Golgi transport', 285694),
(473205, '0054190', NULL, NULL, 168, NULL, 'Ligand-binding domain in the NO signalling and Golgi transport', 285694),
(473206, '0052666', NULL, NULL, 124, NULL, 'PA2201 N-terminal domain-like', 285695),
(473207, '0052902', NULL, NULL, 183, NULL, 'SARS receptor-binding domain-like', 285696),
(473208, '0037266', NULL, NULL, 37, NULL, 'Photosystem II reaction centre subunit H, transmembrane region', 285697),
(473209, '0036659', NULL, NULL, 36, NULL, 'Photosystem II reaction centre subunit H, transmembrane region', 285697),
(473210, '0045434', NULL, NULL, 35, NULL, 'Photosystem II reaction centre subunit H, transmembrane region', 285697),
(473211, '0044674', NULL, NULL, 332, NULL, 'Formin homology 2 domain (FH2 domain)', 285698),
(473212, '0044554', NULL, NULL, 411, NULL, 'Formin homology 2 domain (FH2 domain)', 285698),
(473213, '0037617', NULL, NULL, 81, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473214, '0042490', NULL, NULL, 161, NULL, 'Ribosomal protein S5 domain 2-like', 285699);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(473215, '0052055', NULL, NULL, 121, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473216, '0037619', NULL, NULL, 127, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473217, '0054274', NULL, NULL, 147, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473218, '0050714', NULL, NULL, 215, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473219, '0053987', NULL, NULL, 126, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473220, '0052932', NULL, NULL, 140, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473221, '0051205', NULL, NULL, 168, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473222, '0037810', NULL, NULL, 163, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473223, '0038464', NULL, NULL, 134, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473224, '0037014', NULL, NULL, 172, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473225, '0041085', NULL, NULL, 164, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473226, '0054272', NULL, NULL, 187, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473227, '0040911', NULL, NULL, 174, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473228, '0043463', NULL, NULL, 167, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473229, '0054270', NULL, NULL, 122, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473230, '0043148', NULL, NULL, 151, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473231, '0041171', NULL, NULL, 165, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473232, '0039904', NULL, NULL, 194, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473233, '0054209', NULL, NULL, 191, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473234, '0050966', NULL, NULL, 185, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473235, '0049170', NULL, NULL, 94, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473236, '0042146', NULL, NULL, 120, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473237, '0040285', NULL, NULL, 225, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473238, '0040129', NULL, NULL, 180, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473239, '0043358', NULL, NULL, 182, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473240, '0050450', NULL, NULL, 115, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473241, '0044291', NULL, NULL, 149, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473242, '0054211', NULL, NULL, 148, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473243, '0043249', NULL, NULL, 92, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473244, '0037595', NULL, NULL, 188, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473245, '0044774', NULL, NULL, 135, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473246, '0036739', NULL, NULL, 137, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473247, '0052323', NULL, NULL, 123, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473248, '0036738', NULL, NULL, 149, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473249, '0054587', NULL, NULL, 81, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473250, '0054268', NULL, NULL, 181, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473251, '0043490', NULL, NULL, 176, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473252, '0052560', NULL, NULL, 86, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473253, '0052561', NULL, NULL, 97, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473254, '0054266', NULL, NULL, 145, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473255, '0042360', NULL, NULL, 71, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473256, '0054264', NULL, NULL, 184, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473257, '0053739', NULL, NULL, 176, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473258, '0042083', NULL, NULL, 151, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473259, '0053737', NULL, NULL, 144, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473260, '0051753', NULL, NULL, 95, NULL, 'Ribosomal protein S5 domain 2-like', 285699);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(473261, '0051752', NULL, NULL, 84, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473262, '0036295', NULL, NULL, 117, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473263, '0044305', NULL, NULL, 148, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473264, '0042329', NULL, NULL, 205, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473265, '0035363', NULL, NULL, 115, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473266, '0044509', NULL, NULL, 256, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473267, '0041639', NULL, NULL, 109, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473268, '0034909', NULL, NULL, 113, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473269, '0041876', NULL, NULL, 163, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473270, '0040104', NULL, NULL, 172, NULL, 'Ribosomal protein S5 domain 2-like', 285699),
(473271, '0050384', NULL, NULL, 120, NULL, 'DUSP-like', 285700),
(473272, '0042646', NULL, NULL, 68, NULL, 'Blood coagulation inhibitor (disintegrin)', 285701),
(473273, '0041045', NULL, NULL, 41, NULL, 'Blood coagulation inhibitor (disintegrin)', 285701),
(473274, '0041221', NULL, NULL, 68, NULL, 'Blood coagulation inhibitor (disintegrin)', 285701),
(473275, '0043969', NULL, NULL, 62, NULL, 'Blood coagulation inhibitor (disintegrin)', 285701),
(473276, '0047500', NULL, NULL, 68, NULL, 'Blood coagulation inhibitor (disintegrin)', 285701),
(473277, '0045254', NULL, NULL, 49, NULL, 'Blood coagulation inhibitor (disintegrin)', 285701),
(473278, '0043970', NULL, NULL, 63, NULL, 'Blood coagulation inhibitor (disintegrin)', 285701),
(473279, '0043312', NULL, NULL, 64, NULL, 'Blood coagulation inhibitor (disintegrin)', 285701),
(473280, '0040378', NULL, NULL, 73, NULL, 'Blood coagulation inhibitor (disintegrin)', 285701),
(473281, '0038551', NULL, NULL, 77, NULL, 'Chaperone J-domain', 285702),
(473282, '0039212', NULL, NULL, 88, NULL, 'Chaperone J-domain', 285702),
(473283, '0037729', NULL, NULL, 76, NULL, 'Chaperone J-domain', 285702),
(473284, '0048279', NULL, NULL, 182, NULL, 'Chaperone J-domain', 285702),
(473285, '0046983', NULL, NULL, 114, NULL, 'Chaperone J-domain', 285702),
(473286, '0045028', NULL, NULL, 75, NULL, 'Chaperone J-domain', 285702),
(473287, '0037467', NULL, NULL, 79, NULL, 'Chaperone J-domain', 285702),
(473288, '0050633', NULL, NULL, 94, NULL, 'Chaperone J-domain', 285702),
(473289, '0052575', NULL, NULL, 107, NULL, 'GatB/YqeY motif', 285703),
(473290, '0041377', NULL, NULL, 148, NULL, 'GatB/YqeY motif', 285703),
(473291, '0052390', NULL, NULL, 59, NULL, 'GatB/YqeY motif', 285703),
(473292, '0051612', NULL, NULL, 56, NULL, 'GatB/YqeY motif', 285703),
(473293, '0053144', NULL, NULL, 284, NULL, 'IpaD-like', 285704),
(473294, '0053138', NULL, NULL, 267, NULL, 'IpaD-like', 285704),
(473295, '0035837', NULL, NULL, 372, NULL, 'Arginase/deacetylase', 285705),
(473296, '0044998', NULL, NULL, 303, NULL, 'Arginase/deacetylase', 285705),
(473297, '0054863', NULL, NULL, 386, NULL, 'Arginase/deacetylase', 285705),
(473298, '0038224', NULL, NULL, 301, NULL, 'Arginase/deacetylase', 285705),
(473299, '0050949', NULL, NULL, 324, NULL, 'Arginase/deacetylase', 285705),
(473300, '0036259', NULL, NULL, 308, NULL, 'Arginase/deacetylase', 285705),
(473301, '0043894', NULL, NULL, 364, NULL, 'Arginase/deacetylase', 285705),
(473302, '0045215', NULL, NULL, 298, NULL, 'Arginase/deacetylase', 285705),
(473303, '0051675', NULL, NULL, 298, NULL, 'Arginase/deacetylase', 285705),
(473304, '0042422', NULL, NULL, 306, NULL, 'Arginase/deacetylase', 285705),
(473305, '0051754', NULL, NULL, 309, NULL, 'Arginase/deacetylase', 285705),
(473306, '0051262', NULL, NULL, 166, NULL, 'YktB/PF0168-like', 285706),
(473307, '0051726', NULL, NULL, 210, NULL, 'YktB/PF0168-like', 285706),
(473308, '0053388', NULL, NULL, 49, NULL, 'Oligomerization domain of hepatitis delta antigen', 285707),
(473309, '0047261', NULL, NULL, 41, NULL, 'Satiety factor CART (cocaine and amphetamine regulated transcript)', 285708),
(473310, '0053411', NULL, NULL, 52, NULL, 'Tetrabrachion', 285709);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(473311, '0053433', NULL, NULL, 58, NULL, 'Virus ectodomain', 285710),
(473312, '0053544', NULL, NULL, 53, NULL, 'Virus ectodomain', 285710),
(473313, '0053420', NULL, NULL, 91, NULL, 'Virus ectodomain', 285710),
(473314, '0053453', NULL, NULL, 73, NULL, 'Virus ectodomain', 285710),
(473315, '0053410', NULL, NULL, 76, NULL, 'Virus ectodomain', 285710),
(473316, '0053421', NULL, NULL, 157, NULL, 'Virus ectodomain', 285710),
(473317, '0053454', NULL, NULL, 78, NULL, 'Virus ectodomain', 285710),
(473318, '0053575', NULL, NULL, 71, NULL, 'Virus ectodomain', 285710),
(473319, '0053451', NULL, NULL, 75, NULL, 'Virus ectodomain', 285710),
(473320, '0053484', NULL, NULL, 85, NULL, 'Virus ectodomain', 285710),
(473321, '0053485', NULL, NULL, 53, NULL, 'Virus ectodomain', 285710),
(473322, '0053496', NULL, NULL, 122, NULL, 'Virus ectodomain', 285710),
(473323, '0053406', NULL, NULL, 111, NULL, 'Virus ectodomain', 285710),
(473324, '0053516', NULL, NULL, 38, NULL, 'Virus ectodomain', 285710),
(473325, '0053407', NULL, NULL, 121, NULL, 'Virus ectodomain', 285710),
(473326, '0053515', NULL, NULL, 64, NULL, 'Virus ectodomain', 285710),
(473327, '0053928', NULL, NULL, 90, NULL, 'Virus ectodomain', 285710),
(473328, '0043524', NULL, NULL, 106, NULL, 'B-form DNA mimic Ocr', 285711),
(473329, '0048055', NULL, NULL, 72, NULL, 'D-ribose-5-phosphate isomerase (RpiA), lid domain', 285712),
(473330, '0049920', NULL, NULL, 74, NULL, 'D-ribose-5-phosphate isomerase (RpiA), lid domain', 285712),
(473331, '0047983', NULL, NULL, 80, NULL, 'D-ribose-5-phosphate isomerase (RpiA), lid domain', 285712),
(473332, '0047868', NULL, NULL, 72, NULL, 'D-ribose-5-phosphate isomerase (RpiA), lid domain', 285712),
(473333, '0042508', NULL, NULL, 48, NULL, 'CCHHC domain', 285713),
(473334, '0049149', NULL, NULL, 122, NULL, 'Translational regulator protein regA', 285714),
(473335, '0054413', NULL, NULL, 62, NULL, 'YejL-like', 285715),
(473336, '0054245', NULL, NULL, 72, NULL, 'YejL-like', 285715),
(473337, '0054244', NULL, NULL, 72, NULL, 'YejL-like', 285715),
(473338, '0054242', NULL, NULL, 75, NULL, 'YejL-like', 285715),
(473339, '0054240', NULL, NULL, 75, NULL, 'YejL-like', 285715),
(473340, '0047492', NULL, NULL, 118, NULL, 'Hyaluronate lyase-like, C-terminal domain', 285716),
(473341, '0049252', NULL, NULL, 113, NULL, 'Hyaluronate lyase-like, C-terminal domain', 285716),
(473342, '0046101', NULL, NULL, 101, NULL, 'Hyaluronate lyase-like, C-terminal domain', 285716),
(473343, '0036994', NULL, NULL, 79, NULL, 'Hyaluronate lyase-like, C-terminal domain', 285716),
(473344, '0047207', NULL, NULL, 122, NULL, 'Hyaluronate lyase-like, C-terminal domain', 285716),
(473345, '0037335', NULL, NULL, 65, NULL, 'Hyaluronate lyase-like, C-terminal domain', 285716),
(473346, '0043405', NULL, NULL, 174, NULL, 'DinB/YfiT-like putative metalloenzymes', 285717),
(473347, '0052571', NULL, NULL, 141, NULL, 'DinB/YfiT-like putative metalloenzymes', 285717),
(473348, '0054452', NULL, NULL, 142, NULL, 'DinB/YfiT-like putative metalloenzymes', 285717),
(473349, '0054297', NULL, NULL, 160, NULL, 'DinB/YfiT-like putative metalloenzymes', 285717),
(473350, '0054050', NULL, NULL, 147, NULL, 'DinB/YfiT-like putative metalloenzymes', 285717),
(473351, '0054407', NULL, NULL, 171, NULL, 'DinB/YfiT-like putative metalloenzymes', 285717),
(473352, '0054416', NULL, NULL, 183, NULL, 'DinB/YfiT-like putative metalloenzymes', 285717),
(473353, '0050066', NULL, NULL, 435, NULL, 'Subtilisin-like', 285718),
(473354, '0042193', NULL, NULL, 334, NULL, 'Subtilisin-like', 285718),
(473355, '0035548', NULL, NULL, 274, NULL, 'Subtilisin-like', 285718),
(473356, '0036867', NULL, NULL, 310, NULL, 'Subtilisin-like', 285718),
(473357, '0036139', NULL, NULL, 274, NULL, 'Subtilisin-like', 285718),
(473358, '0036337', NULL, NULL, 280, NULL, 'Subtilisin-like', 285718),
(473359, '0038019', NULL, NULL, 369, NULL, 'Subtilisin-like', 285718),
(473360, '0044008', NULL, NULL, 279, NULL, 'Subtilisin-like', 285718),
(473361, '0042014', NULL, NULL, 338, NULL, 'Subtilisin-like', 285718),
(473362, '0038257', NULL, NULL, 357, NULL, 'Subtilisin-like', 285718);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(473363, '0044989', NULL, NULL, 318, NULL, 'Subtilisin-like', 285718),
(473364, '0038041', NULL, NULL, 269, NULL, 'Subtilisin-like', 285718),
(473365, '0043627', NULL, NULL, 357, NULL, 'Subtilisin-like', 285718),
(473366, '0053283', NULL, NULL, 279, NULL, 'Subtilisin-like', 285718),
(473367, '0040900', NULL, NULL, 275, NULL, 'Subtilisin-like', 285718),
(473368, '0049659', NULL, NULL, 281, NULL, 'Subtilisin-like', 285718),
(473369, '0049119', NULL, NULL, 671, NULL, 'Subtilisin-like', 285718),
(473370, '0036948', NULL, NULL, 137, NULL, 'Diol dehydratase, gamma subunit', 285719),
(473371, '0039254', NULL, NULL, 138, NULL, 'Diol dehydratase, gamma subunit', 285719),
(473372, '0049692', NULL, NULL, 161, NULL, 'DNA-binding protein LAG-1 (CSL)', 285720),
(473373, '0041791', NULL, NULL, 198, NULL, 'Receptor-binding domain of short tail fibre protein gp12', 285721),
(473374, '0038451', NULL, NULL, 80, NULL, 'Receptor-binding domain of short tail fibre protein gp12', 285721),
(473375, '0036407', NULL, NULL, 31, NULL, 'Metallothionein', 285722),
(473376, '0040718', NULL, NULL, 28, NULL, 'Metallothionein', 285722),
(473377, '0045371', NULL, NULL, 31, NULL, 'Metallothionein', 285722),
(473378, '0040717', NULL, NULL, 30, NULL, 'Metallothionein', 285722),
(473379, '0045363', NULL, NULL, 30, NULL, 'Metallothionein', 285722),
(473380, '0036498', NULL, NULL, 28, NULL, 'Metallothionein', 285722),
(473381, '0039564', NULL, NULL, 37, NULL, 'Metallothionein', 285722),
(473382, '0037672', NULL, NULL, 40, NULL, 'Metallothionein', 285722),
(473383, '0039376', NULL, NULL, 28, NULL, 'Metallothionein', 285722),
(473384, '0039576', NULL, NULL, 52, NULL, 'Metallothionein', 285722),
(473385, '0036497', NULL, NULL, 31, NULL, 'Metallothionein', 285722),
(473386, '0042814', NULL, NULL, 36, NULL, 'Metallothionein', 285722),
(473387, '0039375', NULL, NULL, 30, NULL, 'Metallothionein', 285722),
(473388, '0042815', NULL, NULL, 28, NULL, 'Metallothionein', 285722),
(473389, '0040935', NULL, NULL, 31, NULL, 'Metallothionein', 285722),
(473390, '0045598', NULL, NULL, 61, NULL, 'Metallothionein', 285722),
(473391, '0049522', NULL, NULL, 25, NULL, 'Metallothionein', 285722),
(473392, '0046327', NULL, NULL, 30, NULL, 'Metallothionein', 285722),
(473393, '0046095', NULL, NULL, 87, NULL, 'CAD & PB1 domains', 285723),
(473394, '0050144', NULL, NULL, 89, NULL, 'CAD & PB1 domains', 285723),
(473395, '0047342', NULL, NULL, 89, NULL, 'CAD & PB1 domains', 285723),
(473396, '0048552', NULL, NULL, 82, NULL, 'CAD & PB1 domains', 285723),
(473397, '0052120', NULL, NULL, 80, NULL, 'CAD & PB1 domains', 285723),
(473398, '0046691', NULL, NULL, 100, NULL, 'CAD & PB1 domains', 285723),
(473399, '0048553', NULL, NULL, 105, NULL, 'CAD & PB1 domains', 285723),
(473400, '0050570', NULL, NULL, 113, NULL, 'CAD & PB1 domains', 285723),
(473401, '0047341', NULL, NULL, 81, NULL, 'CAD & PB1 domains', 285723),
(473402, '0050657', NULL, NULL, 82, NULL, 'CAD & PB1 domains', 285723),
(473403, '0052303', NULL, NULL, 90, NULL, 'CAD & PB1 domains', 285723),
(473404, '0050609', NULL, NULL, 101, NULL, 'CAD & PB1 domains', 285723),
(473405, '0039115', NULL, NULL, 85, NULL, 'CAD & PB1 domains', 285723),
(473406, '0048864', NULL, NULL, 98, NULL, 'CAD & PB1 domains', 285723),
(473407, '0046268', NULL, NULL, 122, NULL, 'CAD & PB1 domains', 285723),
(473408, '0048461', NULL, NULL, 467, NULL, 'Seven-hairpin glycosidases', 285724),
(473409, '0046353', NULL, NULL, 511, NULL, 'Seven-hairpin glycosidases', 285724),
(473410, '0047864', NULL, NULL, 475, NULL, 'Seven-hairpin glycosidases', 285724),
(473411, '0047169', NULL, NULL, 488, NULL, 'Seven-hairpin glycosidases', 285724),
(473412, '0046831', NULL, NULL, 457, NULL, 'Seven-hairpin glycosidases', 285724),
(473413, '0052372', NULL, NULL, 229, NULL, 'Cullin repeat-like', 285725),
(473414, '0051932', NULL, NULL, 551, NULL, 'Cullin repeat-like', 285725),
(473415, '0047960', NULL, NULL, 394, NULL, 'Cullin repeat-like', 285725),
(473416, '0054070', NULL, NULL, 347, NULL, 'Cullin repeat-like', 285725),
(473417, '0048171', NULL, NULL, 113, NULL, 'Doublecortin (DC)', 285726);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(473418, '0049879', NULL, NULL, 116, NULL, 'Doublecortin (DC)', 285726),
(473419, '0045416', NULL, NULL, 45, NULL, 'Crambin-like', 285727),
(473420, '0041297', NULL, NULL, 46, NULL, 'Crambin-like', 285727),
(473421, '0050716', NULL, NULL, 45, NULL, 'Crambin-like', 285727),
(473422, '0039634', NULL, NULL, 46, NULL, 'Crambin-like', 285727),
(473423, '0037038', NULL, NULL, 46, NULL, 'Crambin-like', 285727),
(473424, '0035557', NULL, NULL, 45, NULL, 'Crambin-like', 285727),
(473425, '0036910', NULL, NULL, 46, NULL, 'Crambin-like', 285727),
(473426, '0039635', NULL, NULL, 46, NULL, 'Crambin-like', 285727),
(473427, '0041995', NULL, NULL, 46, NULL, 'Crambin-like', 285727),
(473428, '0047717', NULL, NULL, 151, NULL, 'CheW-like', 285728),
(473429, '0045872', NULL, NULL, 132, NULL, 'CheW-like', 285728),
(473430, '0051365', NULL, NULL, 131, NULL, 'C-type lectin-like', 285729),
(473431, '0049565', NULL, NULL, 143, NULL, 'C-type lectin-like', 285729),
(473432, '0042096', NULL, NULL, 131, NULL, 'C-type lectin-like', 285729),
(473433, '0050635', NULL, NULL, 150, NULL, 'C-type lectin-like', 285729),
(473434, '0035634', NULL, NULL, 178, NULL, 'C-type lectin-like', 285729),
(473435, '0049081', NULL, NULL, 119, NULL, 'C-type lectin-like', 285729),
(473436, '0037892', NULL, NULL, 118, NULL, 'C-type lectin-like', 285729),
(473437, '0039794', NULL, NULL, 124, NULL, 'C-type lectin-like', 285729),
(473438, '0038340', NULL, NULL, 139, NULL, 'C-type lectin-like', 285729),
(473439, '0042097', NULL, NULL, 123, NULL, 'C-type lectin-like', 285729),
(473440, '0047544', NULL, NULL, 122, NULL, 'C-type lectin-like', 285729),
(473441, '0041727', NULL, NULL, 98, NULL, 'C-type lectin-like', 285729),
(473442, '0044992', NULL, NULL, 140, NULL, 'C-type lectin-like', 285729),
(473443, '0048999', NULL, NULL, 133, NULL, 'C-type lectin-like', 285729),
(473444, '0050046', NULL, NULL, 125, NULL, 'C-type lectin-like', 285729),
(473445, '0051179', NULL, NULL, 129, NULL, 'C-type lectin-like', 285729),
(473446, '0037805', NULL, NULL, 125, NULL, 'C-type lectin-like', 285729),
(473447, '0035828', NULL, NULL, 135, NULL, 'C-type lectin-like', 285729),
(473448, '0039821', NULL, NULL, 135, NULL, 'C-type lectin-like', 285729),
(473449, '0044448', NULL, NULL, 125, NULL, 'C-type lectin-like', 285729),
(473450, '0046868', NULL, NULL, 133, NULL, 'C-type lectin-like', 285729),
(473451, '0039269', NULL, NULL, 123, NULL, 'C-type lectin-like', 285729),
(473452, '0039984', NULL, NULL, 128, NULL, 'C-type lectin-like', 285729),
(473453, '0043955', NULL, NULL, 126, NULL, 'C-type lectin-like', 285729),
(473454, '0044527', NULL, NULL, 150, NULL, 'C-type lectin-like', 285729),
(473455, '0038730', NULL, NULL, 117, NULL, 'C-type lectin-like', 285729),
(473456, '0039268', NULL, NULL, 129, NULL, 'C-type lectin-like', 285729),
(473457, '0051409', NULL, NULL, 210, NULL, 'C-type lectin-like', 285729),
(473458, '0051408', NULL, NULL, 210, NULL, 'C-type lectin-like', 285729),
(473459, '0046069', NULL, NULL, 125, NULL, 'C-type lectin-like', 285729),
(473460, '0047796', NULL, NULL, 136, NULL, 'C-type lectin-like', 285729),
(473461, '0048802', NULL, NULL, 83, NULL, 'C-type lectin-like', 285729),
(473462, '0053191', NULL, NULL, 112, NULL, 'C-type lectin-like', 285729),
(473463, '0046900', NULL, NULL, 118, NULL, 'C-type lectin-like', 285729),
(473464, '0046789', NULL, NULL, 122, NULL, 'C-type lectin-like', 285729),
(473465, '0042149', NULL, NULL, 122, NULL, 'C-type lectin-like', 285729),
(473466, '0044447', NULL, NULL, 135, NULL, 'C-type lectin-like', 285729),
(473467, '0036827', NULL, NULL, 117, NULL, 'C-type lectin-like', 285729),
(473468, '0049147', NULL, NULL, 111, NULL, 'C-type lectin-like', 285729),
(473469, '0049420', NULL, NULL, 179, NULL, 'C-type lectin-like', 285729),
(473470, '0036666', NULL, NULL, 168, NULL, 'C-type lectin-like', 285729),
(473471, '0036620', NULL, NULL, 128, NULL, 'C-type lectin-like', 285729),
(473472, '0035579', NULL, NULL, 129, NULL, 'C-type lectin-like', 285729),
(473473, '0038485', NULL, NULL, 115, NULL, 'C-type lectin-like', 285729),
(473474, '0042435', NULL, NULL, 86, NULL, 'C-type lectin-like', 285729);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(473475, '0044536', NULL, NULL, 140, NULL, 'C-type lectin-like', 285729),
(473476, '0042437', NULL, NULL, 86, NULL, 'C-type lectin-like', 285729),
(473477, '0035372', NULL, NULL, 121, NULL, 'C-type lectin-like', 285729),
(473478, '0047401', NULL, NULL, 123, NULL, 'C-type lectin-like', 285729),
(473479, '0046554', NULL, NULL, 135, NULL, 'C-type lectin-like', 285729),
(473480, '0047400', NULL, NULL, 129, NULL, 'C-type lectin-like', 285729),
(473481, '0044410', NULL, NULL, 131, NULL, 'C-type lectin-like', 285729),
(473482, '0036181', NULL, NULL, 100, NULL, 'C-type lectin-like', 285729),
(473483, '0044411', NULL, NULL, 124, NULL, 'C-type lectin-like', 285729),
(473484, '0049550', NULL, NULL, 109, NULL, 'C-type lectin-like', 285729),
(473485, '0046041', NULL, NULL, 123, NULL, 'C-type lectin-like', 285729),
(473486, '0044061', NULL, NULL, 137, NULL, 'C-type lectin-like', 285729),
(473487, '0049355', NULL, NULL, 127, NULL, 'C-type lectin-like', 285729),
(473488, '0049354', NULL, NULL, 132, NULL, 'C-type lectin-like', 285729),
(473489, '0045154', NULL, NULL, 129, NULL, 'C-type lectin-like', 285729),
(473490, '0051196', NULL, NULL, 267, NULL, 'C-type lectin-like', 285729),
(473491, '0040181', NULL, NULL, 172, NULL, 'C-type lectin-like', 285729),
(473492, '0042719', NULL, NULL, 144, NULL, 'C-type lectin-like', 285729),
(473493, '0035288', NULL, NULL, 121, NULL, 'C-type lectin-like', 285729),
(473494, '0037303', NULL, NULL, 98, NULL, 'C-type lectin-like', 285729),
(473495, '0051512', NULL, NULL, 286, NULL, 'C-type lectin-like', 285729),
(473496, '0038672', NULL, NULL, 123, NULL, 'C-type lectin-like', 285729),
(473497, '0038795', NULL, NULL, 124, NULL, 'C-type lectin-like', 285729),
(473498, '0047699', NULL, NULL, 123, NULL, 'C-type lectin-like', 285729),
(473499, '0040505', NULL, NULL, 116, NULL, 'C-type lectin-like', 285729),
(473500, '0040503', NULL, NULL, 115, NULL, 'C-type lectin-like', 285729),
(473501, '0040502', NULL, NULL, 113, NULL, 'C-type lectin-like', 285729),
(473502, '0044695', NULL, NULL, 77, NULL, 'DNA topoisomerase I domain', 285730),
(473503, '0053718', NULL, NULL, 36, NULL, 'Photosystem II reaction center protein M, PsbM', 285731),
(473504, '0041387', NULL, NULL, 87, NULL, 'AlbA-like', 285732),
(473505, '0044293', NULL, NULL, 88, NULL, 'AlbA-like', 285732),
(473506, '0038363', NULL, NULL, 89, NULL, 'AlbA-like', 285732),
(473507, '0041369', NULL, NULL, 87, NULL, 'AlbA-like', 285732),
(473508, '0044887', NULL, NULL, 99, NULL, 'AlbA-like', 285732),
(473509, '0048794', NULL, NULL, 353, NULL, 'Thermostable phytase (3-phytase)', 285733),
(473510, '0035462', NULL, NULL, 80, NULL, 'mu transposase, C-terminal domain', 285734),
(473511, '0034977', NULL, NULL, 158, NULL, 'Influenza virus matrix protein M1', 285735),
(473512, '0050023', NULL, NULL, 340, NULL, 'Calcium-dependent phosphotriesterase', 285736),
(473513, '0052427', NULL, NULL, 319, NULL, 'Calcium-dependent phosphotriesterase', 285736),
(473514, '0052901', NULL, NULL, 295, NULL, 'Calcium-dependent phosphotriesterase', 285736),
(473515, '0046436', NULL, NULL, 312, NULL, 'Calcium-dependent phosphotriesterase', 285736),
(473516, '0054459', NULL, NULL, 302, NULL, 'Calcium-dependent phosphotriesterase', 285736),
(473517, '0053064', NULL, NULL, 119, NULL, 'DeoB insert domain-like', 285737),
(473518, '0051608', NULL, NULL, 82, NULL, 'TTP0101/SSO1404-like', 285738),
(473519, '0054077', NULL, NULL, 84, NULL, 'TTP0101/SSO1404-like', 285738),
(473520, '0054163', NULL, NULL, 88, NULL, 'TTP0101/SSO1404-like', 285738),
(473521, '0053510', NULL, NULL, 69, NULL, 'G protein-binding domain', 285739),
(473522, '0053522', NULL, NULL, 51, NULL, 'G protein-binding domain', 285739),
(473523, '0053540', NULL, NULL, 90, NULL, 'G protein-binding domain', 285739),
(473524, '0053525', NULL, NULL, 69, NULL, 'G protein-binding domain', 285739),
(473525, '0041176', NULL, NULL, 95, NULL, 'PHL pollen allergen', 285740),
(473526, '0044975', NULL, NULL, 94, NULL, 'PHL pollen allergen', 285740),
(473527, '0043236', NULL, NULL, 32, NULL, 'Sec-beta subunit', 285741),
(473528, '0047915', NULL, NULL, 57, NULL, 'Sigma3 and sigma4 domains of RNA polymerase sigma factors', 285742);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(473529, '0049340', NULL, NULL, 106, NULL, 'Sigma3 and sigma4 domains of RNA polymerase sigma factors', 285742),
(473530, '0049224', NULL, NULL, 71, NULL, 'Sigma3 and sigma4 domains of RNA polymerase sigma factors', 285742),
(473531, '0051096', NULL, NULL, 106, NULL, 'Sigma3 and sigma4 domains of RNA polymerase sigma factors', 285742),
(473532, '0049223', NULL, NULL, 77, NULL, 'Sigma3 and sigma4 domains of RNA polymerase sigma factors', 285742),
(473533, '0049651', NULL, NULL, 68, NULL, 'Sigma3 and sigma4 domains of RNA polymerase sigma factors', 285742),
(473534, '0049695', NULL, NULL, 87, NULL, 'Sigma3 and sigma4 domains of RNA polymerase sigma factors', 285742),
(473535, '0047455', NULL, NULL, 61, NULL, 'Sigma3 and sigma4 domains of RNA polymerase sigma factors', 285742),
(473536, '0041987', NULL, NULL, 68, NULL, 'Sigma3 and sigma4 domains of RNA polymerase sigma factors', 285742),
(473537, '0039239', NULL, NULL, 105, NULL, 'Sigma3 and sigma4 domains of RNA polymerase sigma factors', 285742),
(473538, '0047393', NULL, NULL, 74, NULL, 'YajQ-like', 285743),
(473539, '0047392', NULL, NULL, 88, NULL, 'YajQ-like', 285743),
(473540, '0054215', NULL, NULL, 111, NULL, 'beta-Galactosidase/glucuronidase domain', 285744),
(473541, '0051366', NULL, NULL, 112, NULL, 'beta-Galactosidase/glucuronidase domain', 285744),
(473542, '0046375', NULL, NULL, 105, NULL, 'beta-Galactosidase/glucuronidase domain', 285744),
(473543, '0046374', NULL, NULL, 114, NULL, 'beta-Galactosidase/glucuronidase domain', 285744),
(473544, '0054738', NULL, NULL, 103, NULL, 'beta-Galactosidase/glucuronidase domain', 285744),
(473545, '0054737', NULL, NULL, 122, NULL, 'beta-Galactosidase/glucuronidase domain', 285744),
(473546, '0045963', NULL, NULL, 103, NULL, 'beta-Galactosidase/glucuronidase domain', 285744),
(473547, '0054736', NULL, NULL, 110, NULL, 'beta-Galactosidase/glucuronidase domain', 285744),
(473548, '0051367', NULL, NULL, 93, NULL, 'beta-Galactosidase/glucuronidase domain', 285744),
(473549, '0054216', NULL, NULL, 81, NULL, 'beta-Galactosidase/glucuronidase domain', 285744),
(473550, '0054217', NULL, NULL, 105, NULL, 'beta-Galactosidase/glucuronidase domain', 285744),
(473551, '0044966', NULL, NULL, 87, NULL, 'GroEL-intermediate domain like', 285745),
(473552, '0042604', NULL, NULL, 108, NULL, 'GroEL-intermediate domain like', 285745),
(473553, '0041816', NULL, NULL, 98, NULL, 'GroEL-intermediate domain like', 285745),
(473554, '0049415', NULL, NULL, 90, NULL, 'GroEL-intermediate domain like', 285745),
(473555, '0034908', NULL, NULL, 108, NULL, 'GroEL-intermediate domain like', 285745),
(473556, '0039108', NULL, NULL, 98, NULL, 'GroEL-intermediate domain like', 285745),
(473557, '0045722', NULL, NULL, 106, NULL, 'GroEL-intermediate domain like', 285745),
(473558, '0046000', NULL, NULL, 46, NULL, 'Myosin S1 fragment, N-terminal domain', 285746),
(473559, '0045895', NULL, NULL, 48, NULL, 'Myosin S1 fragment, N-terminal domain', 285746),
(473560, '0046247', NULL, NULL, 46, NULL, 'Myosin S1 fragment, N-terminal domain', 285746),
(473561, '0053192', NULL, NULL, 46, NULL, 'Myosin S1 fragment, N-terminal domain', 285746),
(473562, '0039799', NULL, NULL, 44, NULL, 'Myosin S1 fragment, N-terminal domain', 285746),
(473563, '0048548', NULL, NULL, 58, NULL, 'Myosin S1 fragment, N-terminal domain', 285746),
(473564, '0053761', NULL, NULL, 132, NULL, 'Plus3-like', 285747),
(473565, '0039452', NULL, NULL, 739, NULL, 'Photosystem I subunits PsaA/PsaB', 285748),
(473566, '0039451', NULL, NULL, 743, NULL, 'Photosystem I subunits PsaA/PsaB', 285748),
(473567, '0049827', NULL, NULL, 69, NULL, 'Cysteine alpha-hairpin motif', 285749),
(473568, '0053030', NULL, NULL, 68, NULL, 'Cysteine alpha-hairpin motif', 285749),
(473569, '0035914', NULL, NULL, 56, NULL, 'Serine protease inhibitors', 285750),
(473570, '0045816', NULL, NULL, 62, NULL, 'Serine protease inhibitors', 285750),
(473571, '0038764', NULL, NULL, 60, NULL, 'Serine protease inhibitors', 285750),
(473572, '0046191', NULL, NULL, 85, NULL, 'Serine protease inhibitors', 285750);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(473573, '0036876', NULL, NULL, 61, NULL, 'Serine protease inhibitors', 285750),
(473574, '0052554', NULL, NULL, 71, NULL, 'ACT-like', 285751),
(473575, '0053024', NULL, NULL, 67, NULL, 'ACT-like', 285751),
(473576, '0053025', NULL, NULL, 100, NULL, 'ACT-like', 285751),
(473577, '0054311', NULL, NULL, 80, NULL, 'ACT-like', 285751),
(473578, '0054630', NULL, NULL, 90, NULL, 'ACT-like', 285751),
(473579, '0048893', NULL, NULL, 84, NULL, 'ACT-like', 285751),
(473580, '0052153', NULL, NULL, 75, NULL, 'ACT-like', 285751),
(473581, '0053264', NULL, NULL, 86, NULL, 'ACT-like', 285751),
(473582, '0053265', NULL, NULL, 77, NULL, 'ACT-like', 285751),
(473583, '0052152', NULL, NULL, 91, NULL, 'ACT-like', 285751),
(473584, '0054619', NULL, NULL, 80, NULL, 'ACT-like', 285751),
(473585, '0054936', NULL, NULL, 99, NULL, 'ACT-like', 285751),
(473586, '0051307', NULL, NULL, 78, NULL, 'ACT-like', 285751),
(473587, '0051984', NULL, NULL, 82, NULL, 'ACT-like', 285751),
(473588, '0052555', NULL, NULL, 70, NULL, 'ACT-like', 285751),
(473589, '0053149', NULL, NULL, 91, NULL, 'ACT-like', 285751),
(473590, '0048810', NULL, NULL, 84, NULL, 'ACT-like', 285751),
(473591, '0054885', NULL, NULL, 95, NULL, 'ACT-like', 285751),
(473592, '0052562', NULL, NULL, 76, NULL, 'ACT-like', 285751),
(473593, '0052683', NULL, NULL, 78, NULL, 'ACT-like', 285751),
(473594, '0052563', NULL, NULL, 86, NULL, 'ACT-like', 285751),
(473595, '0049597', NULL, NULL, 88, NULL, 'ACT-like', 285751),
(473596, '0052682', NULL, NULL, 83, NULL, 'ACT-like', 285751),
(473597, '0051230', NULL, NULL, 77, NULL, 'ACT-like', 285751),
(473598, '0051577', NULL, NULL, 60, NULL, 'ACT-like', 285751),
(473599, '0051654', NULL, NULL, 64, NULL, 'ACT-like', 285751),
(473600, '0054626', NULL, NULL, 97, NULL, 'ACT-like', 285751),
(473601, '0051653', NULL, NULL, 66, NULL, 'ACT-like', 285751),
(473602, '0051578', NULL, NULL, 66, NULL, 'ACT-like', 285751),
(473603, '0051607', NULL, NULL, 83, NULL, 'ACT-like', 285751),
(473604, '0053150', NULL, NULL, 64, NULL, 'ACT-like', 285751),
(473605, '0044223', NULL, NULL, 86, NULL, 'ACT-like', 285751),
(473606, '0044224', NULL, NULL, 93, NULL, 'ACT-like', 285751),
(473607, '0043950', NULL, NULL, 91, NULL, 'ACT-like', 285751),
(473608, '0042324', NULL, NULL, 97, NULL, 'ACT-like', 285751),
(473609, '0042375', NULL, NULL, 117, NULL, 'Superantigen (mitogen) Ypm', 285752),
(473610, '0040581', NULL, NULL, 145, NULL, 'X-Prolyl dipeptidyl aminopeptidase PepX, N-terminal domain', 285753),
(473611, '0050345', NULL, NULL, 131, NULL, 'Trigger factor ribosome-binding domain', 285754),
(473612, '0043831', NULL, NULL, 129, NULL, 'Trigger factor ribosome-binding domain', 285754),
(473613, '0053687', NULL, NULL, 509, NULL, 'SNF-like', 285755),
(473614, '0035014', NULL, NULL, 144, NULL, 'Zn-binding domains of ADDBP', 285756),
(473615, '0035013', NULL, NULL, 120, NULL, 'Zn-binding domains of ADDBP', 285756),
(473616, '0048399', NULL, NULL, 106, NULL, 'Hypothetical protein YgiW', 285757),
(473617, '0043196', NULL, NULL, 132, NULL, 'Alanine racemase C-terminal domain-like', 285758),
(473618, '0044144', NULL, NULL, 171, NULL, 'Alanine racemase C-terminal domain-like', 285758),
(473619, '0046698', NULL, NULL, 170, NULL, 'Alanine racemase C-terminal domain-like', 285758),
(473620, '0050170', NULL, NULL, 146, NULL, 'Alanine racemase C-terminal domain-like', 285758),
(473621, '0035464', NULL, NULL, 149, NULL, 'Alanine racemase C-terminal domain-like', 285758),
(473622, '0038617', NULL, NULL, 182, NULL, 'Alanine racemase C-terminal domain-like', 285758),
(473623, '0047840', NULL, NULL, 175, NULL, 'Alanine racemase C-terminal domain-like', 285758),
(473624, '0053369', NULL, NULL, 178, NULL, 'Alanine racemase C-terminal domain-like', 285758),
(473625, '0053126', NULL, NULL, 64, NULL, 'Magnesium transport protein CorA, transmembrane region', 285759),
(473626, '0044800', NULL, NULL, 168, NULL, 'YbaK/ProRS associated domain', 285760),
(473627, '0044834', NULL, NULL, 165, NULL, 'YbaK/ProRS associated domain', 285760),
(473628, '0036342', NULL, NULL, 157, NULL, 'YbaK/ProRS associated domain', 285760);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(473629, '0050454', NULL, NULL, 150, NULL, 'YbaK/ProRS associated domain', 285760),
(473630, '0046738', NULL, NULL, 172, NULL, 'PAP/Archaeal CCA-adding enzyme, C-terminal domain', 285761),
(473631, '0037392', NULL, NULL, 134, NULL, 'PAP/Archaeal CCA-adding enzyme, C-terminal domain', 285761),
(473632, '0049129', NULL, NULL, 180, NULL, 'PAP/Archaeal CCA-adding enzyme, C-terminal domain', 285761),
(473633, '0054388', NULL, NULL, 252, NULL, 'MetI-like', 285762),
(473634, '0054918', NULL, NULL, 248, NULL, 'MetI-like', 285762),
(473635, '0054648', NULL, NULL, 290, NULL, 'MetI-like', 285762),
(473636, '0054934', NULL, NULL, 203, NULL, 'MetI-like', 285762),
(473637, '0054647', NULL, NULL, 244, NULL, 'MetI-like', 285762),
(473638, '0043719', NULL, NULL, 152, NULL, 'CheC-like', 285763),
(473639, '0051007', NULL, NULL, 205, NULL, 'CheC-like', 285763),
(473640, '0039137', NULL, NULL, 200, NULL, 'Ribonuclease Rh-like', 285764),
(473641, '0039273', NULL, NULL, 208, NULL, 'Ribonuclease Rh-like', 285764),
(473642, '0035593', NULL, NULL, 190, NULL, 'Ribonuclease Rh-like', 285764),
(473643, '0039111', NULL, NULL, 196, NULL, 'Ribonuclease Rh-like', 285764),
(473644, '0035643', NULL, NULL, 222, NULL, 'Ribonuclease Rh-like', 285764),
(473645, '0036449', NULL, NULL, 208, NULL, 'Ribonuclease Rh-like', 285764),
(473646, '0039812', NULL, NULL, 207, NULL, 'Ribonuclease Rh-like', 285764),
(473647, '0043599', NULL, NULL, 206, NULL, 'Ribonuclease Rh-like', 285764),
(473648, '0044043', NULL, NULL, 161, NULL, 'YutG-like', 285765),
(473649, '0043223', NULL, NULL, 164, NULL, 'YutG-like', 285765),
(473650, '0051247', NULL, NULL, 159, NULL, 'YutG-like', 285765),
(473651, '0034788', NULL, NULL, 356, NULL, 'Conserved core of transcriptional regulatory protein vp16', 285766),
(473652, '0037312', NULL, NULL, 155, NULL, 'Diphtheria toxin, C-terminal domain', 285767),
(473653, '0042034', NULL, NULL, 210, NULL, 'His-Me finger endonucleases', 285768),
(473654, '0037998', NULL, NULL, 241, NULL, 'His-Me finger endonucleases', 285768),
(473655, '0044583', NULL, NULL, 245, NULL, 'His-Me finger endonucleases', 285768),
(473656, '0037092', NULL, NULL, 131, NULL, 'His-Me finger endonucleases', 285768),
(473657, '0034919', NULL, NULL, 162, NULL, 'His-Me finger endonucleases', 285768),
(473658, '0044201', NULL, NULL, 105, NULL, 'His-Me finger endonucleases', 285768),
(473659, '0045643', NULL, NULL, 127, NULL, 'His-Me finger endonucleases', 285768),
(473660, '0036822', NULL, NULL, 103, NULL, 'His-Me finger endonucleases', 285768),
(473661, '0054326', NULL, NULL, 240, NULL, 'His-Me finger endonucleases', 285768),
(473662, '0046171', NULL, NULL, 166, NULL, 'PurM N-terminal domain-like', 285769),
(473663, '0043867', NULL, NULL, 200, NULL, 'PurM N-terminal domain-like', 285769),
(473664, '0054760', NULL, NULL, 113, NULL, 'PurM N-terminal domain-like', 285769),
(473665, '0050217', NULL, NULL, 162, NULL, 'PurM N-terminal domain-like', 285769),
(473666, '0050216', NULL, NULL, 165, NULL, 'PurM N-terminal domain-like', 285769),
(473667, '0050291', NULL, NULL, 137, NULL, 'PurM N-terminal domain-like', 285769),
(473668, '0049528', NULL, NULL, 209, NULL, 'PurM N-terminal domain-like', 285769),
(473669, '0054801', NULL, NULL, 152, NULL, 'PurM N-terminal domain-like', 285769),
(473670, '0050276', NULL, NULL, 260, NULL, 'TM1631-like', 285770),
(473671, '0050279', NULL, NULL, 269, NULL, 'TM1631-like', 285770),
(473672, '0044655', NULL, NULL, 257, NULL, 'Creatininase', 285771),
(473673, '0054368', NULL, NULL, 245, NULL, 'YacF-like', 285772),
(473674, '0052794', NULL, NULL, 92, NULL, 'Sm-like ribonucleoproteins', 285773),
(473675, '0047980', NULL, NULL, 75, NULL, 'Sm-like ribonucleoproteins', 285773),
(473676, '0053242', NULL, NULL, 67, NULL, 'Sm-like ribonucleoproteins', 285773),
(473677, '0054255', NULL, NULL, 52, NULL, 'Sm-like ribonucleoproteins', 285773),
(473678, '0038922', NULL, NULL, 71, NULL, 'Sm-like ribonucleoproteins', 285773),
(473679, '0052637', NULL, NULL, 80, NULL, 'Sm-like ribonucleoproteins', 285773),
(473680, '0045867', NULL, NULL, 93, NULL, 'Sm-like ribonucleoproteins', 285773);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(473681, '0047126', NULL, NULL, 71, NULL, 'Sm-like ribonucleoproteins', 285773),
(473682, '0040799', NULL, NULL, 127, NULL, 'Sm-like ribonucleoproteins', 285773),
(473683, '0049628', NULL, NULL, 76, NULL, 'Sm-like ribonucleoproteins', 285773),
(473684, '0049770', NULL, NULL, 66, NULL, 'Sm-like ribonucleoproteins', 285773),
(473685, '0047193', NULL, NULL, 65, NULL, 'Sm-like ribonucleoproteins', 285773),
(473686, '0051278', NULL, NULL, 66, NULL, 'Sm-like ribonucleoproteins', 285773),
(473687, '0054664', NULL, NULL, 52, NULL, 'Sm-like ribonucleoproteins', 285773),
(473688, '0054224', NULL, NULL, 50, NULL, 'Sm-like ribonucleoproteins', 285773),
(473689, '0046263', NULL, NULL, 90, NULL, 'Sm-like ribonucleoproteins', 285773),
(473690, '0046262', NULL, NULL, 72, NULL, 'Sm-like ribonucleoproteins', 285773),
(473691, '0047299', NULL, NULL, 72, NULL, 'Sm-like ribonucleoproteins', 285773),
(473692, '0054661', NULL, NULL, 53, NULL, 'Sm-like ribonucleoproteins', 285773),
(473693, '0054824', NULL, NULL, 53, NULL, 'Sm-like ribonucleoproteins', 285773),
(473694, '0054668', NULL, NULL, 52, NULL, 'Sm-like ribonucleoproteins', 285773),
(473695, '0035325', NULL, NULL, 80, NULL, 'Sm-like ribonucleoproteins', 285773),
(473696, '0047853', NULL, NULL, 60, NULL, 'Sm-like ribonucleoproteins', 285773),
(473697, '0048307', NULL, NULL, 74, NULL, 'Sm-like ribonucleoproteins', 285773),
(473698, '0047557', NULL, NULL, 78, NULL, 'Sm-like ribonucleoproteins', 285773),
(473699, '0053445', NULL, NULL, 94, NULL, 'XRCC4, C-terminal oligomerization domain', 285774),
(473700, '0053581', NULL, NULL, 61, NULL, 'XRCC4, C-terminal oligomerization domain', 285774),
(473701, '0039058', NULL, NULL, 122, NULL, 'Frizzled cysteine-rich domain', 285775),
(473702, '0039057', NULL, NULL, 125, NULL, 'Frizzled cysteine-rich domain', 285775),
(473703, '0052847', NULL, NULL, 68, NULL, 'TraM-like', 285776),
(473704, '0039067', NULL, NULL, 143, NULL, 'Exotoxin A, middle domain', 285777),
(473705, '0039973', NULL, NULL, 509, NULL, 'Adenylylcyclase toxin (the edema factor)', 285778),
(473706, '0049075', NULL, NULL, 95, NULL, '1-deoxy-D-xylulose-5-phosphate reductoisomerase, C-terminal domain', 285779),
(473707, '0047751', NULL, NULL, 98, NULL, '1-deoxy-D-xylulose-5-phosphate reductoisomerase, C-terminal domain', 285779),
(473708, '0054681', NULL, NULL, 146, NULL, 'MAPEG domain-like', 285780),
(473709, '0054581', NULL, NULL, 139, NULL, 'MAPEG domain-like', 285780),
(473710, '0054020', NULL, NULL, 139, NULL, 'MAPEG domain-like', 285780),
(473711, '0050497', NULL, NULL, 74, NULL, 'AN1-like Zinc finger', 285781),
(473712, '0050491', NULL, NULL, 85, NULL, 'AN1-like Zinc finger', 285781),
(473713, '0050490', NULL, NULL, 86, NULL, 'AN1-like Zinc finger', 285781),
(473714, '0050493', NULL, NULL, 64, NULL, 'AN1-like Zinc finger', 285781),
(473715, '0050513', NULL, NULL, 64, NULL, 'AN1-like Zinc finger', 285781),
(473716, '0050501', NULL, NULL, 74, NULL, 'AN1-like Zinc finger', 285781),
(473717, '0041705', NULL, NULL, 87, NULL, 'Surface presentation of antigens (SPOA)', 285782),
(473718, '0041753', NULL, NULL, 71, NULL, 'Surface presentation of antigens (SPOA)', 285782),
(473719, '0054236', NULL, NULL, 86, NULL, 'YbeD/HP0495-like', 285783),
(473720, '0049257', NULL, NULL, 87, NULL, 'YbeD/HP0495-like', 285783),
(473721, '0052093', NULL, NULL, 222, NULL, 'Peptidoglycan deacetylase N-terminal noncatalytic region', 285784),
(473722, '0054314', NULL, NULL, 146, NULL, 'Galactose-binding domain-like', 285785),
(473723, '0038309', NULL, NULL, 153, NULL, 'Galactose-binding domain-like', 285785),
(473724, '0051368', NULL, NULL, 216, NULL, 'Galactose-binding domain-like', 285785),
(473725, '0052854', NULL, NULL, 108, NULL, 'Galactose-binding domain-like', 285785),
(473726, '0047060', NULL, NULL, 155, NULL, 'Galactose-binding domain-like', 285785),
(473727, '0039559', NULL, NULL, 150, NULL, 'Galactose-binding domain-like', 285785),
(473728, '0053743', NULL, NULL, 180, NULL, 'Galactose-binding domain-like', 285785),
(473729, '0042013', NULL, NULL, 139, NULL, 'Galactose-binding domain-like', 285785);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(473730, '0036483', NULL, NULL, 145, NULL, 'Galactose-binding domain-like', 285785),
(473731, '0041041', NULL, NULL, 233, NULL, 'Galactose-binding domain-like', 285785),
(473732, '0038180', NULL, NULL, 153, NULL, 'Galactose-binding domain-like', 285785),
(473733, '0048711', NULL, NULL, 136, NULL, 'Galactose-binding domain-like', 285785),
(473734, '0047740', NULL, NULL, 162, NULL, 'Galactose-binding domain-like', 285785),
(473735, '0048554', NULL, NULL, 171, NULL, 'Galactose-binding domain-like', 285785),
(473736, '0041602', NULL, NULL, 232, NULL, 'Galactose-binding domain-like', 285785),
(473737, '0041689', NULL, NULL, 188, NULL, 'Galactose-binding domain-like', 285785),
(473738, '0045964', NULL, NULL, 204, NULL, 'Galactose-binding domain-like', 285785),
(473739, '0047745', NULL, NULL, 168, NULL, 'Galactose-binding domain-like', 285785),
(473740, '0047789', NULL, NULL, 155, NULL, 'Galactose-binding domain-like', 285785),
(473741, '0054721', NULL, NULL, 171, NULL, 'Galactose-binding domain-like', 285785),
(473742, '0054720', NULL, NULL, 145, NULL, 'Galactose-binding domain-like', 285785),
(473743, '0045051', NULL, NULL, 151, NULL, 'Galactose-binding domain-like', 285785),
(473744, '0051052', NULL, NULL, 161, NULL, 'Galactose-binding domain-like', 285785),
(473745, '0053078', NULL, NULL, 180, NULL, 'Galactose-binding domain-like', 285785),
(473746, '0039546', NULL, NULL, 161, NULL, 'Galactose-binding domain-like', 285785),
(473747, '0050642', NULL, NULL, 151, NULL, 'Galactose-binding domain-like', 285785),
(473748, '0050401', NULL, NULL, 142, NULL, 'Galactose-binding domain-like', 285785),
(473749, '0041575', NULL, NULL, 176, NULL, 'Galactose-binding domain-like', 285785),
(473750, '0043558', NULL, NULL, 162, NULL, 'Galactose-binding domain-like', 285785),
(473751, '0043559', NULL, NULL, 158, NULL, 'Galactose-binding domain-like', 285785),
(473752, '0049619', NULL, NULL, 182, NULL, 'Galactose-binding domain-like', 285785),
(473753, '0047719', NULL, NULL, 158, NULL, 'Galactose-binding domain-like', 285785),
(473754, '0041690', NULL, NULL, 150, NULL, 'Galactose-binding domain-like', 285785),
(473755, '0044443', NULL, NULL, 184, NULL, 'Galactose-binding domain-like', 285785),
(473756, '0044564', NULL, NULL, 132, NULL, 'Galactose-binding domain-like', 285785),
(473757, '0046425', NULL, NULL, 156, NULL, 'Galactose-binding domain-like', 285785),
(473758, '0050013', NULL, NULL, 184, NULL, 'Galactose-binding domain-like', 285785),
(473759, '0050331', NULL, NULL, 120, NULL, 'Galactose-binding domain-like', 285785),
(473760, '0046230', NULL, NULL, 153, NULL, 'Galactose-binding domain-like', 285785),
(473761, '0049620', NULL, NULL, 163, NULL, 'Galactose-binding domain-like', 285785),
(473762, '0040408', NULL, NULL, 121, NULL, 'Galactose-binding domain-like', 285785),
(473763, '0050018', NULL, NULL, 131, NULL, 'Galactose-binding domain-like', 285785),
(473764, '0050414', NULL, NULL, 134, NULL, 'Galactose-binding domain-like', 285785),
(473765, '0054739', NULL, NULL, 184, NULL, 'Galactose-binding domain-like', 285785),
(473766, '0054218', NULL, NULL, 192, NULL, 'Galactose-binding domain-like', 285785),
(473767, '0038886', NULL, NULL, 161, NULL, 'Galactose-binding domain-like', 285785),
(473768, '0038168', NULL, NULL, 126, NULL, 'Galactose-binding domain-like', 285785),
(473769, '0038642', NULL, NULL, 210, NULL, 'Galactose-binding domain-like', 285785),
(473770, '0054621', NULL, NULL, 156, NULL, 'Galactose-binding domain-like', 285785),
(473771, '0050662', NULL, NULL, 195, NULL, 'Galactose-binding domain-like', 285785),
(473772, '0047057', NULL, NULL, 142, NULL, 'Galactose-binding domain-like', 285785),
(473773, '0048542', NULL, NULL, 132, NULL, 'Galactose-binding domain-like', 285785),
(473774, '0036533', NULL, NULL, 207, NULL, 'Galactose-binding domain-like', 285785),
(473775, '0036212', NULL, NULL, 160, NULL, 'Galactose-binding domain-like', 285785),
(473776, '0050025', NULL, NULL, 167, NULL, 'Galactose-binding domain-like', 285785),
(473777, '0041433', NULL, NULL, 171, NULL, 'Galactose-binding domain-like', 285785);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(473778, '0044988', NULL, NULL, 116, NULL, 'Galactose-binding domain-like', 285785),
(473779, '0040582', NULL, NULL, 213, NULL, 'Galactose-binding domain-like', 285785),
(473780, '0036298', NULL, NULL, 159, NULL, 'Galactose-binding domain-like', 285785),
(473781, '0039760', NULL, NULL, 223, NULL, 'Galactose-binding domain-like', 285785),
(473782, '0036010', NULL, NULL, 148, NULL, 'Galactose-binding domain-like', 285785),
(473783, '0038231', NULL, NULL, 194, NULL, 'Galactose-binding domain-like', 285785),
(473784, '0047533', NULL, NULL, 180, NULL, 'Galactose-binding domain-like', 285785),
(473785, '0048786', NULL, NULL, 183, NULL, 'Galactose-binding domain-like', 285785),
(473786, '0049713', NULL, NULL, 136, NULL, 'Galactose-binding domain-like', 285785),
(473787, '0048043', NULL, NULL, 106, NULL, 't-snare proteins', 285786),
(473788, '0043526', NULL, NULL, 121, NULL, 't-snare proteins', 285786),
(473789, '0046792', NULL, NULL, 196, NULL, 't-snare proteins', 285786),
(473790, '0050140', NULL, NULL, 89, NULL, 't-snare proteins', 285786),
(473791, '0036510', NULL, NULL, 222, NULL, 't-snare proteins', 285786),
(473792, '0038698', NULL, NULL, 97, NULL, 't-snare proteins', 285786),
(473793, '0053979', NULL, NULL, 111, NULL, 'PG1857-like', 285787),
(473794, '0050110', NULL, NULL, 225, NULL, 'Tetrapyrrole methylase', 285788),
(473795, '0050440', NULL, NULL, 289, NULL, 'Tetrapyrrole methylase', 285788),
(473796, '0050153', NULL, NULL, 235, NULL, 'Tetrapyrrole methylase', 285788),
(473797, '0051949', NULL, NULL, 195, NULL, 'Tetrapyrrole methylase', 285788),
(473798, '0050755', NULL, NULL, 233, NULL, 'Tetrapyrrole methylase', 285788),
(473799, '0049314', NULL, NULL, 265, NULL, 'Tetrapyrrole methylase', 285788),
(473800, '0042343', NULL, NULL, 242, NULL, 'Tetrapyrrole methylase', 285788),
(473801, '0052425', NULL, NULL, 265, NULL, 'Tetrapyrrole methylase', 285788),
(473802, '0035898', NULL, NULL, 239, NULL, 'Tetrapyrrole methylase', 285788),
(473803, '0044765', NULL, NULL, 251, NULL, 'Tetrapyrrole methylase', 285788),
(473804, '0046133', NULL, NULL, 162, NULL, 'HybD-like', 285789),
(473805, '0046091', NULL, NULL, 371, NULL, 'HybD-like', 285789),
(473806, '0048031', NULL, NULL, 108, NULL, 'Bacterial enterotoxins', 285790),
(473807, '0047560', NULL, NULL, 121, NULL, 'Bacterial enterotoxins', 285790),
(473808, '0035115', NULL, NULL, 93, NULL, 'Bacterial enterotoxins', 285790),
(473809, '0054959', NULL, NULL, 102, NULL, 'Bacterial enterotoxins', 285790),
(473810, '0035850', NULL, NULL, 69, NULL, 'Bacterial enterotoxins', 285790),
(473811, '0046618', NULL, NULL, 120, NULL, 'Bacterial enterotoxins', 285790),
(473812, '0042438', NULL, NULL, 110, NULL, 'Bacterial enterotoxins', 285790),
(473813, '0042439', NULL, NULL, 98, NULL, 'Bacterial enterotoxins', 285790),
(473814, '0037096', NULL, NULL, 100, NULL, 'Bacterial enterotoxins', 285790),
(473815, '0053939', NULL, NULL, 83, NULL, 'Bacterial enterotoxins', 285790),
(473816, '0047301', NULL, NULL, 120, NULL, 'Bacterial enterotoxins', 285790),
(473817, '0044158', NULL, NULL, 96, NULL, 'Bacterial enterotoxins', 285790),
(473818, '0042434', NULL, NULL, 110, NULL, 'Bacterial enterotoxins', 285790),
(473819, '0048087', NULL, NULL, 96, NULL, 'Bacterial enterotoxins', 285790),
(473820, '0045194', NULL, NULL, 68, NULL, 'Bacterial enterotoxins', 285790),
(473821, '0053332', NULL, NULL, 121, NULL, 'Bacterial enterotoxins', 285790),
(473822, '0050029', NULL, NULL, 91, NULL, 'Bacterial enterotoxins', 285790),
(473823, '0051814', NULL, NULL, 118, NULL, 'Bacterial enterotoxins', 285790),
(473824, '0035767', NULL, NULL, 119, NULL, 'Bacterial enterotoxins', 285790),
(473825, '0053317', NULL, NULL, 103, NULL, 'Bacterial enterotoxins', 285790),
(473826, '0040146', NULL, NULL, 121, NULL, 'Bacterial enterotoxins', 285790),
(473827, '0046626', NULL, NULL, 97, NULL, 'Bacterial enterotoxins', 285790),
(473828, '0043119', NULL, NULL, 70, NULL, 'Bacterial enterotoxins', 285790),
(473829, '0046829', NULL, NULL, 107, NULL, 'Bacterial enterotoxins', 285790),
(473830, '0044022', NULL, NULL, 98, NULL, 'Bacterial enterotoxins', 285790);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(473831, '0054680', NULL, NULL, 93, NULL, 'Bacterial enterotoxins', 285790),
(473832, '0046623', NULL, NULL, 95, NULL, 'Bacterial enterotoxins', 285790),
(473833, '0048803', NULL, NULL, 110, NULL, 'Bacterial enterotoxins', 285790),
(473834, '0035690', NULL, NULL, 124, NULL, 'Anticodon-binding domain of a subclass of class I aminoacyl-tRNA synthetases', 285791),
(473835, '0039069', NULL, NULL, 180, NULL, 'Anticodon-binding domain of a subclass of class I aminoacyl-tRNA synthetases', 285791),
(473836, '0042946', NULL, NULL, 160, NULL, 'Anticodon-binding domain of a subclass of class I aminoacyl-tRNA synthetases', 285791),
(473837, '0039121', NULL, NULL, 126, NULL, 'Anticodon-binding domain of a subclass of class I aminoacyl-tRNA synthetases', 285791),
(473838, '0052383', NULL, NULL, 152, NULL, 'Anticodon-binding domain of a subclass of class I aminoacyl-tRNA synthetases', 285791),
(473839, '0049755', NULL, NULL, 146, NULL, 'Anticodon-binding domain of a subclass of class I aminoacyl-tRNA synthetases', 285791),
(473840, '0038401', NULL, NULL, 128, NULL, 'Anticodon-binding domain of a subclass of class I aminoacyl-tRNA synthetases', 285791),
(473841, '0039227', NULL, NULL, 218, NULL, 'Anticodon-binding domain of a subclass of class I aminoacyl-tRNA synthetases', 285791),
(473842, '0037566', NULL, NULL, 273, NULL, 'Anticodon-binding domain of a subclass of class I aminoacyl-tRNA synthetases', 285791),
(473843, '0043347', NULL, NULL, 210, NULL, 'Anticodon-binding domain of a subclass of class I aminoacyl-tRNA synthetases', 285791),
(473844, '0053136', NULL, NULL, 297, NULL, 'PTPA-like', 285792),
(473845, '0053137', NULL, NULL, 316, NULL, 'PTPA-like', 285792),
(473846, '0052839', NULL, NULL, 301, NULL, 'PTPA-like', 285792),
(473847, '0041518', NULL, NULL, 115, NULL, 'Collagen-binding domain', 285793),
(473848, '0051174', NULL, NULL, 161, NULL, 'Hcp1-like', 285794),
(473849, '0051210', NULL, NULL, 177, NULL, 'Peptide deformylase', 285795),
(473850, '0040562', NULL, NULL, 154, NULL, 'Peptide deformylase', 285795),
(473851, '0035693', NULL, NULL, 168, NULL, 'Peptide deformylase', 285795),
(473852, '0050041', NULL, NULL, 182, NULL, 'Peptide deformylase', 285795),
(473853, '0039816', NULL, NULL, 179, NULL, 'Peptide deformylase', 285795),
(473854, '0040557', NULL, NULL, 202, NULL, 'Peptide deformylase', 285795),
(473855, '0040623', NULL, NULL, 184, NULL, 'Peptide deformylase', 285795),
(473856, '0040634', NULL, NULL, 165, NULL, 'Peptide deformylase', 285795),
(473857, '0040555', NULL, NULL, 194, NULL, 'Peptide deformylase', 285795),
(473858, '0039684', NULL, NULL, 228, NULL, 'Undecaprenyl diphosphate synthase', 285796),
(473859, '0037424', NULL, NULL, 229, NULL, 'Undecaprenyl diphosphate synthase', 285796),
(473860, '0038860', NULL, NULL, 96, NULL, 'DNA-binding domain of intron-encoded endonucleases', 285797),
(473861, '0044202', NULL, NULL, 69, NULL, 'DNA-binding domain of intron-encoded endonucleases', 285797),
(473862, '0037945', NULL, NULL, 266, NULL, 'Head and neck region of the ectodomain of NDV fusion glycoprotein', 285798),
(473863, '0036619', NULL, NULL, 80, NULL, 'ACP-like', 285799),
(473864, '0037430', NULL, NULL, 74, NULL, 'ACP-like', 285799),
(473865, '0044845', NULL, NULL, 85, NULL, 'ACP-like', 285799),
(473866, '0040143', NULL, NULL, 115, NULL, 'ACP-like', 285799),
(473867, '0054530', NULL, NULL, 76, NULL, 'ACP-like', 285799),
(473868, '0054241', NULL, NULL, 83, NULL, 'ACP-like', 285799),
(473869, '0035027', NULL, NULL, 86, NULL, 'ACP-like', 285799),
(473870, '0041515', NULL, NULL, 95, NULL, 'ACP-like', 285799),
(473871, '0049566', NULL, NULL, 77, NULL, 'ACP-like', 285799),
(473872, '0036515', NULL, NULL, 76, NULL, 'ACP-like', 285799),
(473873, '0041986', NULL, NULL, 82, NULL, 'ACP-like', 285799),
(473874, '0046578', NULL, NULL, 146, NULL, 'Molybdenum cofactor biosynthesis protein C, MoaC', 285800),
(473875, '0051044', NULL, NULL, 151, NULL, 'LEA14-like', 285801),
(473876, '0043216', NULL, NULL, 100, NULL, 'Eukaryotic initiation factor 4f subunit eIF4g, eIF4e-binding domain', 285802),
(473877, '0041186', NULL, NULL, 207, NULL, 'TorD-like', 285803);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(473878, '0054130', NULL, NULL, 160, NULL, 'TorD-like', 285803),
(473879, '0043531', NULL, NULL, 207, NULL, 'TorD-like', 285803),
(473880, '0054349', NULL, NULL, 153, NULL, 'TorD-like', 285803),
(473881, '0036292', NULL, NULL, 47, NULL, 'Cholecystokinin A receptor, N-domain', 285804),
(473882, '0052122', NULL, NULL, 294, NULL, 'Duffy binding domain-like', 285805),
(473883, '0051624', NULL, NULL, 314, NULL, 'Duffy binding domain-like', 285805),
(473884, '0051623', NULL, NULL, 275, NULL, 'Duffy binding domain-like', 285805),
(473885, '0050328', NULL, NULL, 102, NULL, 'Alpha-hemoglobin stabilizing protein AHSP', 285806),
(473886, '0037992', NULL, NULL, 171, NULL, 'MoeA N-terminal region -like', 285807),
(473887, '0044571', NULL, NULL, 176, NULL, 'MoeA N-terminal region -like', 285807),
(473888, '0050701', NULL, NULL, 175, NULL, 'MoeA N-terminal region -like', 285807),
(473889, '0050975', NULL, NULL, 176, NULL, 'MoeA N-terminal region -like', 285807),
(473890, '0043850', NULL, NULL, 181, NULL, 'MoeA N-terminal region -like', 285807),
(473891, '0037420', NULL, NULL, 91, NULL, 'C-terminal domain of B transposition protein', 285808),
(473892, '0038215', NULL, NULL, 127, NULL, 'Inhibitor of vertebrate lysozyme, Ivy', 285809),
(473893, '0044535', NULL, NULL, 130, NULL, 'Inhibitor of vertebrate lysozyme, Ivy', 285809),
(473894, '0038443', NULL, NULL, 168, NULL, 'Mss4-like', 285810),
(473895, '0044153', NULL, NULL, 171, NULL, 'Mss4-like', 285810),
(473896, '0051019', NULL, NULL, 143, NULL, 'Mss4-like', 285810),
(473897, '0037813', NULL, NULL, 115, NULL, 'Mss4-like', 285810),
(473898, '0040349', NULL, NULL, 144, NULL, 'Mss4-like', 285810),
(473899, '0051445', NULL, NULL, 172, NULL, 'Mss4-like', 285810),
(473900, '0038777', NULL, NULL, 115, NULL, 'Mss4-like', 285810),
(473901, '0050863', NULL, NULL, 196, NULL, 'Mss4-like', 285810),
(473902, '0050065', NULL, NULL, 65, NULL, 'SAP domain', 285811),
(473903, '0039508', NULL, NULL, 51, NULL, 'SAP domain', 285811),
(473904, '0051160', NULL, NULL, 44, NULL, 'SAP domain', 285811),
(473905, '0038368', NULL, NULL, 44, NULL, 'SAP domain', 285811),
(473906, '0040017', NULL, NULL, 36, NULL, 'SAP domain', 285811),
(473907, '0052478', NULL, NULL, 42, NULL, 'SAP domain', 285811),
(473908, '0051622', NULL, NULL, 37, NULL, 'SAP domain', 285811),
(473909, '0036360', NULL, NULL, 57, NULL, 'Ribosomal protein L7/12, oligomerisation (N-terminal) domain', 285812),
(473910, '0043353', NULL, NULL, 51, NULL, 'Ribosomal protein L7/12, oligomerisation (N-terminal) domain', 285812),
(473911, '0046986', NULL, NULL, 71, NULL, 'Hypothetical protein MTH1184', 285813),
(473912, '0042540', NULL, NULL, 60, NULL, 'Docking domain B of the erythromycin polyketide synthase (DEBS)', 285814),
(473913, '0043331', NULL, NULL, 374, NULL, 'ERO1-like', 285815),
(473914, '0043895', NULL, NULL, 124, NULL, 'Rbstp2229 protein', 285816),
(473915, '0039433', NULL, NULL, 247, NULL, 'SurE-like', 285817),
(473916, '0040392', NULL, NULL, 276, NULL, 'SurE-like', 285817),
(473917, '0035511', NULL, NULL, 167, NULL, 'STAT', 285818),
(473918, '0045952', NULL, NULL, 186, NULL, 'STAT', 285818),
(473919, '0050005', NULL, NULL, 118, NULL, 'STAT', 285818),
(473920, '0044678', NULL, NULL, 319, NULL, 'V-type ATP synthase subunit C', 285819),
(473921, '0054011', NULL, NULL, 186, NULL, 'PA1994-like', 285820),
(473922, '0054046', NULL, NULL, 54, NULL, 'Rho N-terminal domain-like', 285821),
(473923, '0054417', NULL, NULL, 38, NULL, 'Rho N-terminal domain-like', 285821),
(473924, '0045720', NULL, NULL, 47, NULL, 'Rho N-terminal domain-like', 285821),
(473925, '0054351', NULL, NULL, 96, NULL, 'BLRF2-like', 285822),
(473926, '0047762', NULL, NULL, 143, NULL, 'Arp2/3 complex 16 kDa subunit ARPC5', 285823),
(473927, '0042854', NULL, NULL, 100, NULL, 'S-adenosylmethionine synthetase', 285824),
(473928, '0042855', NULL, NULL, 124, NULL, 'S-adenosylmethionine synthetase', 285824),
(473929, '0041133', NULL, NULL, 152, NULL, 'S-adenosylmethionine synthetase', 285824),
(473930, '0042856', NULL, NULL, 144, NULL, 'S-adenosylmethionine synthetase', 285824);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(473931, '0054443', NULL, NULL, 144, NULL, 'S-adenosylmethionine synthetase', 285824),
(473932, '0041132', NULL, NULL, 124, NULL, 'S-adenosylmethionine synthetase', 285824),
(473933, '0054442', NULL, NULL, 126, NULL, 'S-adenosylmethionine synthetase', 285824),
(473934, '0041131', NULL, NULL, 102, NULL, 'S-adenosylmethionine synthetase', 285824),
(473935, '0054441', NULL, NULL, 110, NULL, 'S-adenosylmethionine synthetase', 285824),
(473936, '0039663', NULL, NULL, 141, NULL, 'Succinate dehydrogenase/fumarate reductase flavoprotein C-terminal domain', 285825),
(473937, '0052031', NULL, NULL, 198, NULL, 'Succinate dehydrogenase/fumarate reductase flavoprotein C-terminal domain', 285825),
(473938, '0048345', NULL, NULL, 138, NULL, 'Succinate dehydrogenase/fumarate reductase flavoprotein C-terminal domain', 285825),
(473939, '0035988', NULL, NULL, 111, NULL, 'Succinate dehydrogenase/fumarate reductase flavoprotein C-terminal domain', 285825),
(473940, '0040048', NULL, NULL, 134, NULL, 'Succinate dehydrogenase/fumarate reductase flavoprotein C-terminal domain', 285825),
(473941, '0052388', NULL, NULL, 72, NULL, 'GatD N-terminal domain-like', 285826),
(473942, '0051610', NULL, NULL, 74, NULL, 'GatD N-terminal domain-like', 285826),
(473943, '0049760', NULL, NULL, 86, NULL, 'CheY-binding domain of CheA', 285827),
(473944, '0046767', NULL, NULL, 68, NULL, 'CheY-binding domain of CheA', 285827),
(473945, '0037431', NULL, NULL, 87, NULL, 'TAZ domain', 285828),
(473946, '0040415', NULL, NULL, 95, NULL, 'TAZ domain', 285828),
(473947, '0040367', NULL, NULL, 101, NULL, 'TAZ domain', 285828),
(473948, '0044519', NULL, NULL, 70, NULL, 'Uteroglobin-like', 285829),
(473949, '0035911', NULL, NULL, 77, NULL, 'Uteroglobin-like', 285829),
(473950, '0048822', NULL, NULL, 72, NULL, 'Uteroglobin-like', 285829),
(473951, '0048823', NULL, NULL, 69, NULL, 'Uteroglobin-like', 285829),
(473952, '0054731', NULL, NULL, 194, NULL, 'FMN-binding split barrel', 285830),
(473953, '0052694', NULL, NULL, 135, NULL, 'FMN-binding split barrel', 285830),
(473954, '0053043', NULL, NULL, 156, NULL, 'FMN-binding split barrel', 285830),
(473955, '0051825', NULL, NULL, 125, NULL, 'FMN-binding split barrel', 285830),
(473956, '0038821', NULL, NULL, 161, NULL, 'FMN-binding split barrel', 285830),
(473957, '0051821', NULL, NULL, 238, NULL, 'FMN-binding split barrel', 285830),
(473958, '0050236', NULL, NULL, 135, NULL, 'FMN-binding split barrel', 285830),
(473959, '0046934', NULL, NULL, 199, NULL, 'FMN-binding split barrel', 285830),
(473960, '0037651', NULL, NULL, 122, NULL, 'FMN-binding split barrel', 285830),
(473961, '0037036', NULL, NULL, 192, NULL, 'FMN-binding split barrel', 285830),
(473962, '0050968', NULL, NULL, 170, NULL, 'FMN-binding split barrel', 285830),
(473963, '0050409', NULL, NULL, 142, NULL, 'FMN-binding split barrel', 285830),
(473964, '0053062', NULL, NULL, 143, NULL, 'FMN-binding split barrel', 285830),
(473965, '0052782', NULL, NULL, 193, NULL, 'FMN-binding split barrel', 285830),
(473966, '0054146', NULL, NULL, 189, NULL, 'FMN-binding split barrel', 285830),
(473967, '0051690', NULL, NULL, 201, NULL, 'FMN-binding split barrel', 285830),
(473968, '0052681', NULL, NULL, 157, NULL, 'FMN-binding split barrel', 285830),
(473969, '0053033', NULL, NULL, 141, NULL, 'FMN-binding split barrel', 285830),
(473970, '0054287', NULL, NULL, 192, NULL, 'FMN-binding split barrel', 285830),
(473971, '0053034', NULL, NULL, 148, NULL, 'FMN-binding split barrel', 285830),
(473972, '0046143', NULL, NULL, 205, NULL, 'FMN-binding split barrel', 285830),
(473973, '0049155', NULL, NULL, 160, NULL, 'FMN-binding split barrel', 285830),
(473974, '0053098', NULL, NULL, 320, NULL, 'FMN-binding split barrel', 285830),
(473975, '0051356', NULL, NULL, 159, NULL, 'FMN-binding split barrel', 285830),
(473976, '0054546', NULL, NULL, 206, NULL, 'FMN-binding split barrel', 285830),
(473977, '0043438', NULL, NULL, 153, NULL, 'FMN-binding split barrel', 285830),
(473978, '0048424', NULL, NULL, 213, NULL, 'FMN-binding split barrel', 285830),
(473979, '0049578', NULL, NULL, 204, NULL, 'FMN-binding split barrel', 285830);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(473980, '0049738', NULL, NULL, 202, NULL, 'FMN-binding split barrel', 285830),
(473981, '0044501', NULL, NULL, 178, NULL, 'FMN-binding split barrel', 285830),
(473982, '0043704', NULL, NULL, 360, NULL, 'Chorismate synthase, AroC', 285831),
(473983, '0043034', NULL, NULL, 388, NULL, 'Chorismate synthase, AroC', 285831),
(473984, '0042573', NULL, NULL, 397, NULL, 'Chorismate synthase, AroC', 285831),
(473985, '0044435', NULL, NULL, 365, NULL, 'Chorismate synthase, AroC', 285831),
(473986, '0043127', NULL, NULL, 371, NULL, 'Chorismate synthase, AroC', 285831),
(473987, '0042548', NULL, NULL, 117, NULL, 'Nickel-containing superoxide dismutase, NiSOD', 285832),
(473988, '0043903', NULL, NULL, 117, NULL, 'Nickel-containing superoxide dismutase, NiSOD', 285832),
(473989, '0053981', NULL, NULL, 168, NULL, 'FwdE-like', 285833),
(473990, '0052922', NULL, NULL, 149, NULL, 'FwdE-like', 285833),
(473991, '0044637', NULL, NULL, 64, NULL, 'KRAB domain (Kruppel-associated box)', 285834),
(473992, '0051098', NULL, NULL, 157, NULL, 'RalF, C-terminal domain', 285835),
(473993, '0053940', NULL, NULL, 130, NULL, 'Superantigen toxins, C-terminal domain', 285836),
(473994, '0046161', NULL, NULL, 118, NULL, 'Superantigen toxins, C-terminal domain', 285836),
(473995, '0035768', NULL, NULL, 115, NULL, 'Superantigen toxins, C-terminal domain', 285836),
(473996, '0037159', NULL, NULL, 113, NULL, 'Superantigen toxins, C-terminal domain', 285836),
(473997, '0035116', NULL, NULL, 113, NULL, 'Superantigen toxins, C-terminal domain', 285836),
(473998, '0053337', NULL, NULL, 101, NULL, 'Superantigen toxins, C-terminal domain', 285836),
(473999, '0037693', NULL, NULL, 114, NULL, 'Superantigen toxins, C-terminal domain', 285836),
(474000, '0040784', NULL, NULL, 104, NULL, 'Superantigen toxins, C-terminal domain', 285836),
(474001, '0037172', NULL, NULL, 109, NULL, 'Superantigen toxins, C-terminal domain', 285836),
(474002, '0037097', NULL, NULL, 112, NULL, 'Superantigen toxins, C-terminal domain', 285836),
(474003, '0037185', NULL, NULL, 113, NULL, 'Superantigen toxins, C-terminal domain', 285836),
(474004, '0049737', NULL, NULL, 108, NULL, 'Superantigen toxins, C-terminal domain', 285836),
(474005, '0044589', NULL, NULL, 105, NULL, 'Superantigen toxins, C-terminal domain', 285836),
(474006, '0045569', NULL, NULL, 117, NULL, 'Superantigen toxins, C-terminal domain', 285836),
(474007, '0047086', NULL, NULL, 128, NULL, 'Clathrin adaptor appendage domain', 285837),
(474008, '0048848', NULL, NULL, 159, NULL, 'Clathrin adaptor appendage domain', 285837),
(474009, '0049103', NULL, NULL, 163, NULL, 'Clathrin adaptor appendage domain', 285837),
(474010, '0048311', NULL, NULL, 151, NULL, 'Clathrin adaptor appendage domain', 285837),
(474011, '0042154', NULL, NULL, 145, NULL, 'Clathrin adaptor appendage domain', 285837),
(474012, '0050393', NULL, NULL, 131, NULL, 'Clathrin adaptor appendage domain', 285837),
(474013, '0046453', NULL, NULL, 120, NULL, 'Clathrin adaptor appendage domain', 285837),
(474014, '0049038', NULL, NULL, 133, NULL, 'Clathrin adaptor appendage domain', 285837),
(474015, '0041628', NULL, NULL, 163, NULL, 'FAS1 domain', 285838),
(474016, '0041721', NULL, NULL, 157, NULL, 'FAS1 domain', 285838),
(474017, '0041720', NULL, NULL, 140, NULL, 'FAS1 domain', 285838),
(474018, '0043391', NULL, NULL, 192, NULL, 'CAPPD, an extracellular domain of amyloid beta A4 protein', 285839),
(474019, '0036453', NULL, NULL, 109, NULL, 'Ferredoxin thioredoxin reductase (FTR), catalytic beta chain', 285840),
(474020, '0054247', NULL, NULL, 70, NULL, 'L28p-like', 285841),
(474021, '0050310', NULL, NULL, 70, NULL, 'L28p-like', 285841),
(474022, '0054792', NULL, NULL, 72, NULL, 'L28p-like', 285841),
(474023, '0054171', NULL, NULL, 50, NULL, 'L28p-like', 285841),
(474024, '0054602', NULL, NULL, 77, NULL, 'L28p-like', 285841),
(474025, '0053139', NULL, NULL, 89, NULL, 'L28p-like', 285841),
(474026, '0048205', NULL, NULL, 111, NULL, 'PWI domain', 285842),
(474027, '0051637', NULL, NULL, 207, NULL, 'PriB N-terminal domain-like', 285843),
(474028, '0040168', NULL, NULL, 247, NULL, 'PLP-binding barrel', 285844);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(474029, '0038618', NULL, NULL, 265, NULL, 'PLP-binding barrel', 285844),
(474030, '0050171', NULL, NULL, 237, NULL, 'PLP-binding barrel', 285844),
(474031, '0049144', NULL, NULL, 226, NULL, 'PLP-binding barrel', 285844),
(474032, '0046278', NULL, NULL, 240, NULL, 'PLP-binding barrel', 285844),
(474033, '0049723', NULL, NULL, 264, NULL, 'PLP-binding barrel', 285844),
(474034, '0053309', NULL, NULL, 240, NULL, 'PLP-binding barrel', 285844),
(474035, '0053370', NULL, NULL, 240, NULL, 'PLP-binding barrel', 285844),
(474036, '0046211', NULL, NULL, 244, NULL, 'PLP-binding barrel', 285844),
(474037, '0045930', NULL, NULL, 233, NULL, 'PLP-binding barrel', 285844),
(474038, '0042645', NULL, NULL, 66, NULL, 'Pre-PUA domain', 285845),
(474039, '0054566', NULL, NULL, 66, NULL, 'Pre-PUA domain', 285845),
(474040, '0043892', NULL, NULL, 94, NULL, 'Pre-PUA domain', 285845),
(474041, '0052339', NULL, NULL, 90, NULL, 'Pre-PUA domain', 285845),
(474042, '0047416', NULL, NULL, 145, NULL, 'Pre-PUA domain', 285845),
(474043, '0041147', NULL, NULL, 231, NULL, 'GFP-like', 285846),
(474044, '0051069', NULL, NULL, 230, NULL, 'GFP-like', 285846),
(474045, '0054675', NULL, NULL, 220, NULL, 'GFP-like', 285846),
(474046, '0044381', NULL, NULL, 225, NULL, 'GFP-like', 285846),
(474047, '0040194', NULL, NULL, 245, NULL, 'GFP-like', 285846),
(474048, '0038418', NULL, NULL, 233, NULL, 'GFP-like', 285846),
(474049, '0038095', NULL, NULL, 219, NULL, 'GFP-like', 285846),
(474050, '0041029', NULL, NULL, 221, NULL, 'GFP-like', 285846),
(474051, '0041101', NULL, NULL, 136, NULL, 'UDP-glucose/GDP-mannose dehydrogenase C-terminal domain', 285847),
(474052, '0046358', NULL, NULL, 108, NULL, 'UDP-glucose/GDP-mannose dehydrogenase C-terminal domain', 285847),
(474053, '0052772', NULL, NULL, 439, NULL, 'Formate dehydrogenase/DMSO reductase, domains 1-3', 285848),
(474054, '0037183', NULL, NULL, 622, NULL, 'Formate dehydrogenase/DMSO reductase, domains 1-3', 285848),
(474055, '0038360', NULL, NULL, 812, NULL, 'Formate dehydrogenase/DMSO reductase, domains 1-3', 285848),
(474056, '0045382', NULL, NULL, 597, NULL, 'Formate dehydrogenase/DMSO reductase, domains 1-3', 285848),
(474057, '0040209', NULL, NULL, 817, NULL, 'Formate dehydrogenase/DMSO reductase, domains 1-3', 285848),
(474058, '0037989', NULL, NULL, 679, NULL, 'Formate dehydrogenase/DMSO reductase, domains 1-3', 285848),
(474059, '0042561', NULL, NULL, 1074, NULL, 'Formate dehydrogenase/DMSO reductase, domains 1-3', 285848),
(474060, '0044013', NULL, NULL, 728, NULL, 'Formate dehydrogenase/DMSO reductase, domains 1-3', 285848),
(474061, '0044058', NULL, NULL, 627, NULL, 'Formate dehydrogenase/DMSO reductase, domains 1-3', 285848),
(474062, '0053129', NULL, NULL, 564, NULL, 'Formate dehydrogenase/DMSO reductase, domains 1-3', 285848),
(474063, '0036504', NULL, NULL, 623, NULL, 'Formate dehydrogenase/DMSO reductase, domains 1-3', 285848),
(474064, '0041852', NULL, NULL, 670, NULL, 'Formate dehydrogenase/DMSO reductase, domains 1-3', 285848),
(474065, '0054039', NULL, NULL, 112, NULL, 'BH3980-like', 285849),
(474066, '0054331', NULL, NULL, 90, NULL, 'BH3980-like', 285849),
(474067, '0054330', NULL, NULL, 82, NULL, 'BH3980-like', 285849),
(474068, '0048980', NULL, NULL, 43, NULL, 'Bacterial aa3 type cytochrome c oxidase subunit IV', 285850),
(474069, '0048090', NULL, NULL, 42, NULL, 'Bacterial aa3 type cytochrome c oxidase subunit IV', 285850),
(474070, '0039456', NULL, NULL, 141, NULL, 'Subunit III of photosystem I reaction centre, PsaF', 285851),
(474071, '0053241', NULL, NULL, 109, NULL, 'Gated mechanosensitive channel', 285852),
(474072, '0053923', NULL, NULL, 65, NULL, 'Phosphoprotein oligomerization domain-like', 285853),
(474073, '0043785', NULL, NULL, 202, NULL, 'Glycolipid transfer protein, GLTP', 285854),
(474074, '0050296', NULL, NULL, 235, NULL, 'ComB-like', 285855),
(474075, '0047508', NULL, NULL, 134, NULL, 'Roadblock/LC7 domain', 285856),
(474076, '0050164', NULL, NULL, 118, NULL, 'Roadblock/LC7 domain', 285856),
(474077, '0050163', NULL, NULL, 122, NULL, 'Roadblock/LC7 domain', 285856);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(474078, '0053647', NULL, NULL, 95, NULL, 'Roadblock/LC7 domain', 285856),
(474079, '0054915', NULL, NULL, 130, NULL, 'Bacillus cereus metalloprotein-like', 285857),
(474080, '0054926', NULL, NULL, 135, NULL, 'Bacillus cereus metalloprotein-like', 285857),
(474081, '0054914', NULL, NULL, 134, NULL, 'Bacillus cereus metalloprotein-like', 285857),
(474082, '0054925', NULL, NULL, 121, NULL, 'Bacillus cereus metalloprotein-like', 285857),
(474083, '0052552', NULL, NULL, 50, NULL, 'Dimerization-anchoring domain of cAMP-dependent PK regulatory subunit', 285858),
(474084, '0043099', NULL, NULL, 46, NULL, 'Dimerization-anchoring domain of cAMP-dependent PK regulatory subunit', 285858),
(474085, '0042477', NULL, NULL, 82, NULL, 'YgfY-like', 285859),
(474086, '0042513', NULL, NULL, 310, NULL, 'Pyruvoyl-dependent histidine and arginine decarboxylases', 285860),
(474087, '0041180', NULL, NULL, 159, NULL, 'Pyruvoyl-dependent histidine and arginine decarboxylases', 285860),
(474088, '0049187', NULL, NULL, 111, NULL, 'Dimeric alpha+beta barrel', 285861),
(474089, '0051166', NULL, NULL, 101, NULL, 'Dimeric alpha+beta barrel', 285861),
(474090, '0052377', NULL, NULL, 439, NULL, 'Dimeric alpha+beta barrel', 285861),
(474091, '0053961', NULL, NULL, 108, NULL, 'Dimeric alpha+beta barrel', 285861),
(474092, '0047284', NULL, NULL, 80, NULL, 'Dimeric alpha+beta barrel', 285861),
(474093, '0052136', NULL, NULL, 307, NULL, 'Dimeric alpha+beta barrel', 285861),
(474094, '0053640', NULL, NULL, 104, NULL, 'Dimeric alpha+beta barrel', 285861),
(474095, '0048013', NULL, NULL, 112, NULL, 'Dimeric alpha+beta barrel', 285861),
(474096, '0050293', NULL, NULL, 104, NULL, 'Dimeric alpha+beta barrel', 285861),
(474097, '0054497', NULL, NULL, 100, NULL, 'Dimeric alpha+beta barrel', 285861),
(474098, '0047442', NULL, NULL, 102, NULL, 'Dimeric alpha+beta barrel', 285861),
(474099, '0054134', NULL, NULL, 108, NULL, 'Dimeric alpha+beta barrel', 285861),
(474100, '0044097', NULL, NULL, 106, NULL, 'Dimeric alpha+beta barrel', 285861),
(474101, '0049441', NULL, NULL, 109, NULL, 'Dimeric alpha+beta barrel', 285861),
(474102, '0052757', NULL, NULL, 103, NULL, 'Dimeric alpha+beta barrel', 285861),
(474103, '0050908', NULL, NULL, 109, NULL, 'Dimeric alpha+beta barrel', 285861),
(474104, '0041120', NULL, NULL, 100, NULL, 'Dimeric alpha+beta barrel', 285861),
(474105, '0042616', NULL, NULL, 103, NULL, 'Dimeric alpha+beta barrel', 285861),
(474106, '0049743', NULL, NULL, 108, NULL, 'Dimeric alpha+beta barrel', 285861),
(474107, '0043520', NULL, NULL, 124, NULL, 'Dimeric alpha+beta barrel', 285861),
(474108, '0049704', NULL, NULL, 106, NULL, 'Dimeric alpha+beta barrel', 285861),
(474109, '0049703', NULL, NULL, 103, NULL, 'Dimeric alpha+beta barrel', 285861),
(474110, '0049174', NULL, NULL, 86, NULL, 'Dimeric alpha+beta barrel', 285861),
(474111, '0053111', NULL, NULL, 306, NULL, 'Dimeric alpha+beta barrel', 285861),
(474112, '0052162', NULL, NULL, 86, NULL, 'Dimeric alpha+beta barrel', 285861),
(474113, '0054363', NULL, NULL, 109, NULL, 'Dimeric alpha+beta barrel', 285861),
(474114, '0054385', NULL, NULL, 98, NULL, 'Dimeric alpha+beta barrel', 285861),
(474115, '0048188', NULL, NULL, 96, NULL, 'Dimeric alpha+beta barrel', 285861),
(474116, '0052703', NULL, NULL, 95, NULL, 'Dimeric alpha+beta barrel', 285861),
(474117, '0052967', NULL, NULL, 309, NULL, 'Dimeric alpha+beta barrel', 285861),
(474118, '0050289', NULL, NULL, 110, NULL, 'Dimeric alpha+beta barrel', 285861),
(474119, '0050149', NULL, NULL, 247, NULL, 'Dimeric alpha+beta barrel', 285861),
(474120, '0054503', NULL, NULL, 206, NULL, 'Dimeric alpha+beta barrel', 285861),
(474121, '0053018', NULL, NULL, 96, NULL, 'Dimeric alpha+beta barrel', 285861),
(474122, '0054403', NULL, NULL, 112, NULL, 'Dimeric alpha+beta barrel', 285861),
(474123, '0048903', NULL, NULL, 93, NULL, 'Dimeric alpha+beta barrel', 285861),
(474124, '0052160', NULL, NULL, 77, NULL, 'Dimeric alpha+beta barrel', 285861),
(474125, '0054361', NULL, NULL, 100, NULL, 'Dimeric alpha+beta barrel', 285861),
(474126, '0049512', NULL, NULL, 243, NULL, 'Dimeric alpha+beta barrel', 285861);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(474127, '0045015', NULL, NULL, 98, NULL, 'Dimeric alpha+beta barrel', 285861),
(474128, '0054381', NULL, NULL, 117, NULL, 'Dimeric alpha+beta barrel', 285861),
(474129, '0037168', NULL, NULL, 266, NULL, 'D-aminoacid aminotransferase-like PLP-dependent enzymes', 285862),
(474130, '0036320', NULL, NULL, 277, NULL, 'D-aminoacid aminotransferase-like PLP-dependent enzymes', 285862),
(474131, '0037053', NULL, NULL, 365, NULL, 'D-aminoacid aminotransferase-like PLP-dependent enzymes', 285862),
(474132, '0034852', NULL, NULL, 305, NULL, 'D-aminoacid aminotransferase-like PLP-dependent enzymes', 285862),
(474133, '0043421', NULL, NULL, 164, NULL, 'Hypothetical protein yfbM', 285863),
(474134, '0047423', NULL, NULL, 385, NULL, 'DHH phosphoesterases', 285864),
(474135, '0038902', NULL, NULL, 309, NULL, 'DHH phosphoesterases', 285864),
(474136, '0039854', NULL, NULL, 307, NULL, 'DHH phosphoesterases', 285864),
(474137, '0039853', NULL, NULL, 310, NULL, 'DHH phosphoesterases', 285864),
(474138, '0039286', NULL, NULL, 83, NULL, 'C-terminal domain of DFF45/ICAD (DFF-C domain)', 285865),
(474139, '0044459', NULL, NULL, 335, NULL, 'DAK1/DegV-like', 285866),
(474140, '0040914', NULL, NULL, 285, NULL, 'DAK1/DegV-like', 285866),
(474141, '0041866', NULL, NULL, 347, NULL, 'DAK1/DegV-like', 285866),
(474142, '0042544', NULL, NULL, 287, NULL, 'DAK1/DegV-like', 285866),
(474143, '0048806', NULL, NULL, 311, NULL, 'Terpenoid synthases', 285867),
(474144, '0048261', NULL, NULL, 328, NULL, 'Terpenoid synthases', 285867),
(474145, '0053355', NULL, NULL, 328, NULL, 'Terpenoid synthases', 285867),
(474146, '0046340', NULL, NULL, 300, NULL, 'Terpenoid synthases', 285867),
(474147, '0047573', NULL, NULL, 354, NULL, 'Terpenoid synthases', 285867),
(474148, '0054583', NULL, NULL, 291, NULL, 'Terpenoid synthases', 285867),
(474149, '0043350', NULL, NULL, 299, NULL, 'Terpenoid synthases', 285867),
(474150, '0043373', NULL, NULL, 290, NULL, 'Terpenoid synthases', 285867),
(474151, '0049855', NULL, NULL, 348, NULL, 'Terpenoid synthases', 285867),
(474152, '0046658', NULL, NULL, 333, NULL, 'Terpenoid synthases', 285867),
(474153, '0044612', NULL, NULL, 280, NULL, 'Terpenoid synthases', 285867),
(474154, '0053783', NULL, NULL, 89, NULL, '"Winged helix" DNA-binding domain', 285868),
(474155, '0043062', NULL, NULL, 92, NULL, '"Winged helix" DNA-binding domain', 285868),
(474156, '0050391', NULL, NULL, 117, NULL, '"Winged helix" DNA-binding domain', 285868),
(474157, '0052579', NULL, NULL, 142, NULL, '"Winged helix" DNA-binding domain', 285868),
(474158, '0053666', NULL, NULL, 82, NULL, '"Winged helix" DNA-binding domain', 285868),
(474159, '0038701', NULL, NULL, 115, NULL, '"Winged helix" DNA-binding domain', 285868),
(474160, '0045802', NULL, NULL, 78, NULL, '"Winged helix" DNA-binding domain', 285868),
(474161, '0045923', NULL, NULL, 69, NULL, '"Winged helix" DNA-binding domain', 285868),
(474162, '0042414', NULL, NULL, 114, NULL, '"Winged helix" DNA-binding domain', 285868),
(474163, '0054074', NULL, NULL, 95, NULL, '"Winged helix" DNA-binding domain', 285868),
(474164, '0042770', NULL, NULL, 76, NULL, '"Winged helix" DNA-binding domain', 285868),
(474165, '0049173', NULL, NULL, 60, NULL, '"Winged helix" DNA-binding domain', 285868),
(474166, '0051371', NULL, NULL, 87, NULL, '"Winged helix" DNA-binding domain', 285868),
(474167, '0050048', NULL, NULL, 100, NULL, '"Winged helix" DNA-binding domain', 285868),
(474168, '0044604', NULL, NULL, 120, NULL, '"Winged helix" DNA-binding domain', 285868),
(474169, '0043758', NULL, NULL, 87, NULL, '"Winged helix" DNA-binding domain', 285868),
(474170, '0049859', NULL, NULL, 74, NULL, '"Winged helix" DNA-binding domain', 285868),
(474171, '0053684', NULL, NULL, 158, NULL, '"Winged helix" DNA-binding domain', 285868),
(474172, '0051024', NULL, NULL, 103, NULL, '"Winged helix" DNA-binding domain', 285868),
(474173, '0051026', NULL, NULL, 73, NULL, '"Winged helix" DNA-binding domain', 285868),
(474174, '0050732', NULL, NULL, 94, NULL, '"Winged helix" DNA-binding domain', 285868),
(474175, '0046914', NULL, NULL, 61, NULL, '"Winged helix" DNA-binding domain', 285868);
INSERT INTO "PUBLIC"."MODEL" VALUES
(474176, '0050608', NULL, NULL, 120, NULL, '"Winged helix" DNA-binding domain', 285868),
(474177, '0047445', NULL, NULL, 92, NULL, '"Winged helix" DNA-binding domain', 285868),
(474178, '0051033', NULL, NULL, 78, NULL, '"Winged helix" DNA-binding domain', 285868),
(474179, '0052246', NULL, NULL, 88, NULL, '"Winged helix" DNA-binding domain', 285868),
(474180, '0052364', NULL, NULL, 109, NULL, '"Winged helix" DNA-binding domain', 285868),
(474181, '0043095', NULL, NULL, 94, NULL, '"Winged helix" DNA-binding domain', 285868),
(474182, '0049993', NULL, NULL, 92, NULL, '"Winged helix" DNA-binding domain', 285868),
(474183, '0045030', NULL, NULL, 74, NULL, '"Winged helix" DNA-binding domain', 285868),
(474184, '0041905', NULL, NULL, 120, NULL, '"Winged helix" DNA-binding domain', 285868),
(474185, '0049992', NULL, NULL, 88, NULL, '"Winged helix" DNA-binding domain', 285868),
(474186, '0045032', NULL, NULL, 127, NULL, '"Winged helix" DNA-binding domain', 285868),
(474187, '0052801', NULL, NULL, 162, NULL, '"Winged helix" DNA-binding domain', 285868),
(474188, '0036614', NULL, NULL, 86, NULL, '"Winged helix" DNA-binding domain', 285868),
(474189, '0040266', NULL, NULL, 151, NULL, '"Winged helix" DNA-binding domain', 285868),
(474190, '0051708', NULL, NULL, 139, NULL, '"Winged helix" DNA-binding domain', 285868),
(474191, '0045833', NULL, NULL, 110, NULL, '"Winged helix" DNA-binding domain', 285868),
(474192, '0046129', NULL, NULL, 67, NULL, '"Winged helix" DNA-binding domain', 285868),
(474193, '0054434', NULL, NULL, 71, NULL, '"Winged helix" DNA-binding domain', 285868),
(474194, '0045284', NULL, NULL, 143, NULL, '"Winged helix" DNA-binding domain', 285868),
(474195, '0047585', NULL, NULL, 138, NULL, '"Winged helix" DNA-binding domain', 285868),
(474196, '0049520', NULL, NULL, 110, NULL, '"Winged helix" DNA-binding domain', 285868),
(474197, '0045283', NULL, NULL, 139, NULL, '"Winged helix" DNA-binding domain', 285868),
(474198, '0047461', NULL, NULL, 89, NULL, '"Winged helix" DNA-binding domain', 285868),
(474199, '0045043', NULL, NULL, 77, NULL, '"Winged helix" DNA-binding domain', 285868),
(474200, '0043669', NULL, NULL, 98, NULL, '"Winged helix" DNA-binding domain', 285868),
(474201, '0045968', NULL, NULL, 63, NULL, '"Winged helix" DNA-binding domain', 285868),
(474202, '0036285', NULL, NULL, 94, NULL, '"Winged helix" DNA-binding domain', 285868),
(474203, '0049886', NULL, NULL, 84, NULL, '"Winged helix" DNA-binding domain', 285868),
(474204, '0047587', NULL, NULL, 71, NULL, '"Winged helix" DNA-binding domain', 285868),
(474205, '0047353', NULL, NULL, 105, NULL, '"Winged helix" DNA-binding domain', 285868),
(474206, '0046825', NULL, NULL, 112, NULL, '"Winged helix" DNA-binding domain', 285868),
(474207, '0051849', NULL, NULL, 144, NULL, '"Winged helix" DNA-binding domain', 285868),
(474208, '0044089', NULL, NULL, 90, NULL, '"Winged helix" DNA-binding domain', 285868),
(474209, '0049777', NULL, NULL, 108, NULL, '"Winged helix" DNA-binding domain', 285868),
(474210, '0047234', NULL, NULL, 74, NULL, '"Winged helix" DNA-binding domain', 285868),
(474211, '0051170', NULL, NULL, 89, NULL, '"Winged helix" DNA-binding domain', 285868),
(474212, '0045974', NULL, NULL, 95, NULL, '"Winged helix" DNA-binding domain', 285868),
(474213, '0047910', NULL, NULL, 107, NULL, '"Winged helix" DNA-binding domain', 285868),
(474214, '0053005', NULL, NULL, 97, NULL, '"Winged helix" DNA-binding domain', 285868),
(474215, '0050651', NULL, NULL, 187, NULL, '"Winged helix" DNA-binding domain', 285868),
(474216, '0048695', NULL, NULL, 125, NULL, '"Winged helix" DNA-binding domain', 285868),
(474217, '0037479', NULL, NULL, 89, NULL, '"Winged helix" DNA-binding domain', 285868),
(474218, '0052159', NULL, NULL, 63, NULL, '"Winged helix" DNA-binding domain', 285868),
(474219, '0046835', NULL, NULL, 100, NULL, '"Winged helix" DNA-binding domain', 285868),
(474220, '0046837', NULL, NULL, 110, NULL, '"Winged helix" DNA-binding domain', 285868),
(474221, '0046839', NULL, NULL, 101, NULL, '"Winged helix" DNA-binding domain', 285868);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(474222, '0045981', NULL, NULL, 120, NULL, '"Winged helix" DNA-binding domain', 285868),
(474223, '0047247', NULL, NULL, 74, NULL, '"Winged helix" DNA-binding domain', 285868),
(474224, '0045862', NULL, NULL, 64, NULL, '"Winged helix" DNA-binding domain', 285868),
(474225, '0049308', NULL, NULL, 143, NULL, '"Winged helix" DNA-binding domain', 285868),
(474226, '0039091', NULL, NULL, 75, NULL, '"Winged helix" DNA-binding domain', 285868),
(474227, '0054468', NULL, NULL, 85, NULL, '"Winged helix" DNA-binding domain', 285868),
(474228, '0046283', NULL, NULL, 81, NULL, '"Winged helix" DNA-binding domain', 285868),
(474229, '0049796', NULL, NULL, 94, NULL, '"Winged helix" DNA-binding domain', 285868),
(474230, '0041150', NULL, NULL, 134, NULL, '"Winged helix" DNA-binding domain', 285868),
(474231, '0054905', NULL, NULL, 85, NULL, '"Winged helix" DNA-binding domain', 285868),
(474232, '0052725', NULL, NULL, 73, NULL, '"Winged helix" DNA-binding domain', 285868),
(474233, '0051874', NULL, NULL, 91, NULL, '"Winged helix" DNA-binding domain', 285868),
(474234, '0038673', NULL, NULL, 76, NULL, '"Winged helix" DNA-binding domain', 285868),
(474235, '0051507', NULL, NULL, 70, NULL, '"Winged helix" DNA-binding domain', 285868),
(474236, '0037340', NULL, NULL, 99, NULL, '"Winged helix" DNA-binding domain', 285868),
(474237, '0052718', NULL, NULL, 64, NULL, '"Winged helix" DNA-binding domain', 285868),
(474238, '0052161', NULL, NULL, 63, NULL, '"Winged helix" DNA-binding domain', 285868),
(474239, '0052282', NULL, NULL, 115, NULL, '"Winged helix" DNA-binding domain', 285868),
(474240, '0049556', NULL, NULL, 77, NULL, '"Winged helix" DNA-binding domain', 285868),
(474241, '0049555', NULL, NULL, 85, NULL, '"Winged helix" DNA-binding domain', 285868),
(474242, '0049797', NULL, NULL, 74, NULL, '"Winged helix" DNA-binding domain', 285868),
(474243, '0035958', NULL, NULL, 82, NULL, '"Winged helix" DNA-binding domain', 285868),
(474244, '0053027', NULL, NULL, 62, NULL, '"Winged helix" DNA-binding domain', 285868),
(474245, '0054478', NULL, NULL, 69, NULL, '"Winged helix" DNA-binding domain', 285868),
(474246, '0054356', NULL, NULL, 81, NULL, '"Winged helix" DNA-binding domain', 285868),
(474247, '0053826', NULL, NULL, 68, NULL, '"Winged helix" DNA-binding domain', 285868),
(474248, '0051528', NULL, NULL, 137, NULL, '"Winged helix" DNA-binding domain', 285868),
(474249, '0053825', NULL, NULL, 78, NULL, '"Winged helix" DNA-binding domain', 285868),
(474250, '0037456', NULL, NULL, 76, NULL, '"Winged helix" DNA-binding domain', 285868),
(474251, '0051521', NULL, NULL, 108, NULL, '"Winged helix" DNA-binding domain', 285868),
(474252, '0052734', NULL, NULL, 100, NULL, '"Winged helix" DNA-binding domain', 285868),
(474253, '0053941', NULL, NULL, 122, NULL, '"Winged helix" DNA-binding domain', 285868),
(474254, '0040517', NULL, NULL, 144, NULL, '"Winged helix" DNA-binding domain', 285868),
(474255, '0053261', NULL, NULL, 194, NULL, '"Winged helix" DNA-binding domain', 285868),
(474256, '0045885', NULL, NULL, 74, NULL, '"Winged helix" DNA-binding domain', 285868),
(474257, '0043589', NULL, NULL, 70, NULL, '"Winged helix" DNA-binding domain', 285868),
(474258, '0053037', NULL, NULL, 145, NULL, '"Winged helix" DNA-binding domain', 285868),
(474259, '0052860', NULL, NULL, 81, NULL, '"Winged helix" DNA-binding domain', 285868),
(474260, '0053154', NULL, NULL, 69, NULL, '"Winged helix" DNA-binding domain', 285868),
(474261, '0049573', NULL, NULL, 111, NULL, '"Winged helix" DNA-binding domain', 285868),
(474262, '0053153', NULL, NULL, 70, NULL, '"Winged helix" DNA-binding domain', 285868),
(474263, '0054362', NULL, NULL, 91, NULL, '"Winged helix" DNA-binding domain', 285868),
(474264, '0052506', NULL, NULL, 114, NULL, '"Winged helix" DNA-binding domain', 285868),
(474265, '0053835', NULL, NULL, 91, NULL, '"Winged helix" DNA-binding domain', 285868),
(474266, '0053953', NULL, NULL, 105, NULL, '"Winged helix" DNA-binding domain', 285868),
(474267, '0047959', NULL, NULL, 90, NULL, '"Winged helix" DNA-binding domain', 285868),
(474268, '0044207', NULL, NULL, 145, NULL, '"Winged helix" DNA-binding domain', 285868);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(474269, '0044208', NULL, NULL, 68, NULL, '"Winged helix" DNA-binding domain', 285868),
(474270, '0047958', NULL, NULL, 74, NULL, '"Winged helix" DNA-binding domain', 285868),
(474271, '0043473', NULL, NULL, 92, NULL, '"Winged helix" DNA-binding domain', 285868),
(474272, '0049335', NULL, NULL, 103, NULL, '"Winged helix" DNA-binding domain', 285868),
(474273, '0041732', NULL, NULL, 142, NULL, '"Winged helix" DNA-binding domain', 285868),
(474274, '0046987', NULL, NULL, 75, NULL, '"Winged helix" DNA-binding domain', 285868),
(474275, '0047283', NULL, NULL, 60, NULL, '"Winged helix" DNA-binding domain', 285868),
(474276, '0054016', NULL, NULL, 79, NULL, '"Winged helix" DNA-binding domain', 285868),
(474277, '0048491', NULL, NULL, 73, NULL, '"Winged helix" DNA-binding domain', 285868),
(474278, '0047161', NULL, NULL, 155, NULL, '"Winged helix" DNA-binding domain', 285868),
(474279, '0052198', NULL, NULL, 82, NULL, '"Winged helix" DNA-binding domain', 285868),
(474280, '0050338', NULL, NULL, 79, NULL, '"Winged helix" DNA-binding domain', 285868),
(474281, '0051302', NULL, NULL, 178, NULL, '"Winged helix" DNA-binding domain', 285868),
(474282, '0051665', NULL, NULL, 73, NULL, '"Winged helix" DNA-binding domain', 285868),
(474283, '0052755', NULL, NULL, 102, NULL, '"Winged helix" DNA-binding domain', 285868),
(474284, '0053603', NULL, NULL, 60, NULL, '"Winged helix" DNA-binding domain', 285868),
(474285, '0052514', NULL, NULL, 140, NULL, '"Winged helix" DNA-binding domain', 285868),
(474286, '0054933', NULL, NULL, 140, NULL, '"Winged helix" DNA-binding domain', 285868),
(474287, '0050578', NULL, NULL, 72, NULL, '"Winged helix" DNA-binding domain', 285868),
(474288, '0052633', NULL, NULL, 76, NULL, '"Winged helix" DNA-binding domain', 285868),
(474289, '0048817', NULL, NULL, 88, NULL, '"Winged helix" DNA-binding domain', 285868),
(474290, '0042156', NULL, NULL, 125, NULL, '"Winged helix" DNA-binding domain', 285868),
(474291, '0052508', NULL, NULL, 89, NULL, '"Winged helix" DNA-binding domain', 285868),
(474292, '0044211', NULL, NULL, 124, NULL, '"Winged helix" DNA-binding domain', 285868),
(474293, '0051672', NULL, NULL, 82, NULL, '"Winged helix" DNA-binding domain', 285868),
(474294, '0052641', NULL, NULL, 136, NULL, '"Winged helix" DNA-binding domain', 285868),
(474295, '0052640', NULL, NULL, 137, NULL, '"Winged helix" DNA-binding domain', 285868),
(474296, '0048143', NULL, NULL, 138, NULL, '"Winged helix" DNA-binding domain', 285868),
(474297, '0038753', NULL, NULL, 71, NULL, '"Winged helix" DNA-binding domain', 285868),
(474298, '0047290', NULL, NULL, 73, NULL, '"Winged helix" DNA-binding domain', 285868),
(474299, '0054945', NULL, NULL, 80, NULL, '"Winged helix" DNA-binding domain', 285868),
(474300, '0054702', NULL, NULL, 149, NULL, '"Winged helix" DNA-binding domain', 285868),
(474301, '0052644', NULL, NULL, 172, NULL, '"Winged helix" DNA-binding domain', 285868),
(474302, '0043935', NULL, NULL, 94, NULL, '"Winged helix" DNA-binding domain', 285868),
(474303, '0048703', NULL, NULL, 82, NULL, '"Winged helix" DNA-binding domain', 285868),
(474304, '0049363', NULL, NULL, 122, NULL, '"Winged helix" DNA-binding domain', 285868),
(474305, '0054036', NULL, NULL, 78, NULL, '"Winged helix" DNA-binding domain', 285868),
(474306, '0051444', NULL, NULL, 114, NULL, '"Winged helix" DNA-binding domain', 285868),
(474307, '0054152', NULL, NULL, 133, NULL, '"Winged helix" DNA-binding domain', 285868),
(474308, '0040679', NULL, NULL, 61, NULL, '"Winged helix" DNA-binding domain', 285868),
(474309, '0047195', NULL, NULL, 125, NULL, '"Winged helix" DNA-binding domain', 285868),
(474310, '0048042', NULL, NULL, 64, NULL, '"Winged helix" DNA-binding domain', 285868),
(474311, '0054842', NULL, NULL, 135, NULL, '"Winged helix" DNA-binding domain', 285868),
(474312, '0048041', NULL, NULL, 73, NULL, '"Winged helix" DNA-binding domain', 285868),
(474313, '0037767', NULL, NULL, 80, NULL, '"Winged helix" DNA-binding domain', 285868),
(474314, '0037648', NULL, NULL, 98, NULL, '"Winged helix" DNA-binding domain', 285868);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(474315, '0038616', NULL, NULL, 106, NULL, '"Winged helix" DNA-binding domain', 285868),
(474316, '0053759', NULL, NULL, 136, NULL, '"Winged helix" DNA-binding domain', 285868),
(474317, '0051455', NULL, NULL, 71, NULL, '"Winged helix" DNA-binding domain', 285868),
(474318, '0054845', NULL, NULL, 78, NULL, '"Winged helix" DNA-binding domain', 285868),
(474319, '0051337', NULL, NULL, 138, NULL, '"Winged helix" DNA-binding domain', 285868),
(474320, '0035347', NULL, NULL, 75, NULL, '"Winged helix" DNA-binding domain', 285868),
(474321, '0045339', NULL, NULL, 109, NULL, '"Winged helix" DNA-binding domain', 285868),
(474322, '0040682', NULL, NULL, 60, NULL, '"Winged helix" DNA-binding domain', 285868),
(474323, '0039384', NULL, NULL, 65, NULL, '"Winged helix" DNA-binding domain', 285868),
(474324, '0048601', NULL, NULL, 100, NULL, '"Winged helix" DNA-binding domain', 285868),
(474325, '0040207', NULL, NULL, 75, NULL, '"Winged helix" DNA-binding domain', 285868),
(474326, '0048605', NULL, NULL, 61, NULL, '"Winged helix" DNA-binding domain', 285868),
(474327, '0054732', NULL, NULL, 70, NULL, '"Winged helix" DNA-binding domain', 285868),
(474328, '0049384', NULL, NULL, 109, NULL, '"Winged helix" DNA-binding domain', 285868),
(474329, '0050373', NULL, NULL, 110, NULL, '"Winged helix" DNA-binding domain', 285868),
(474330, '0054851', NULL, NULL, 84, NULL, '"Winged helix" DNA-binding domain', 285868),
(474331, '0054059', NULL, NULL, 69, NULL, '"Winged helix" DNA-binding domain', 285868),
(474332, '0054850', NULL, NULL, 84, NULL, '"Winged helix" DNA-binding domain', 285868),
(474333, '0048177', NULL, NULL, 75, NULL, '"Winged helix" DNA-binding domain', 285868),
(474334, '0044373', NULL, NULL, 109, NULL, '"Winged helix" DNA-binding domain', 285868),
(474335, '0037759', NULL, NULL, 94, NULL, '"Winged helix" DNA-binding domain', 285868),
(474336, '0036548', NULL, NULL, 69, NULL, '"Winged helix" DNA-binding domain', 285868),
(474337, '0042079', NULL, NULL, 62, NULL, '"Winged helix" DNA-binding domain', 285868),
(474338, '0036540', NULL, NULL, 76, NULL, '"Winged helix" DNA-binding domain', 285868),
(474339, '0043164', NULL, NULL, 90, NULL, '"Winged helix" DNA-binding domain', 285868),
(474340, '0047523', NULL, NULL, 57, NULL, '"Winged helix" DNA-binding domain', 285868),
(474341, '0054295', NULL, NULL, 85, NULL, '"Winged helix" DNA-binding domain', 285868),
(474342, '0054290', NULL, NULL, 143, NULL, '"Winged helix" DNA-binding domain', 285868),
(474343, '0046435', NULL, NULL, 90, NULL, '"Winged helix" DNA-binding domain', 285868),
(474344, '0044258', NULL, NULL, 100, NULL, '"Winged helix" DNA-binding domain', 285868),
(474345, '0054291', NULL, NULL, 117, NULL, '"Winged helix" DNA-binding domain', 285868),
(474346, '0044139', NULL, NULL, 86, NULL, '"Winged helix" DNA-binding domain', 285868),
(474347, '0049944', NULL, NULL, 190, NULL, '"Winged helix" DNA-binding domain', 285868),
(474348, '0049152', NULL, NULL, 103, NULL, '"Winged helix" DNA-binding domain', 285868),
(474349, '0054069', NULL, NULL, 84, NULL, '"Winged helix" DNA-binding domain', 285868),
(474350, '0049151', NULL, NULL, 129, NULL, '"Winged helix" DNA-binding domain', 285868),
(474351, '0051354', NULL, NULL, 88, NULL, '"Winged helix" DNA-binding domain', 285868),
(474352, '0048861', NULL, NULL, 88, NULL, '"Winged helix" DNA-binding domain', 285868),
(474353, '0039808', NULL, NULL, 98, NULL, '"Winged helix" DNA-binding domain', 285868),
(474354, '0047770', NULL, NULL, 100, NULL, '"Winged helix" DNA-binding domain', 285868),
(474355, '0049276', NULL, NULL, 85, NULL, '"Winged helix" DNA-binding domain', 285868),
(474356, '0054502', NULL, NULL, 92, NULL, '"Winged helix" DNA-binding domain', 285868),
(474357, '0040586', NULL, NULL, 141, NULL, '"Winged helix" DNA-binding domain', 285868),
(474358, '0037861', NULL, NULL, 115, NULL, '"Winged helix" DNA-binding domain', 285868),
(474359, '0042087', NULL, NULL, 110, NULL, '"Winged helix" DNA-binding domain', 285868),
(474360, '0054062', NULL, NULL, 73, NULL, '"Winged helix" DNA-binding domain', 285868);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(474361, '0045910', NULL, NULL, 127, NULL, '"Winged helix" DNA-binding domain', 285868),
(474362, '0053754', NULL, NULL, 93, NULL, 'HP0242-like', 285869),
(474363, '0047616', NULL, NULL, 325, NULL, 'S-adenosylmethionine decarboxylase', 285870),
(474364, '0044046', NULL, NULL, 117, NULL, 'S-adenosylmethionine decarboxylase', 285870),
(474365, '0040932', NULL, NULL, 324, NULL, 'S-adenosylmethionine decarboxylase', 285870),
(474366, '0052276', NULL, NULL, 291, NULL, 'Topoisomerase V catalytic domain-like', 285871),
(474367, '0053257', NULL, NULL, 233, NULL, 'PA domain', 285872),
(474368, '0046309', NULL, NULL, 193, NULL, 'PA domain', 285872),
(474369, '0049132', NULL, NULL, 185, NULL, 'STI-like', 285873),
(474370, '0045738', NULL, NULL, 205, NULL, 'STI-like', 285873),
(474371, '0037124', NULL, NULL, 211, NULL, 'STI-like', 285873),
(474372, '0045494', NULL, NULL, 217, NULL, 'STI-like', 285873),
(474373, '0050426', NULL, NULL, 171, NULL, 'STI-like', 285873),
(474374, '0035224', NULL, NULL, 181, NULL, 'STI-like', 285873),
(474375, '0043176', NULL, NULL, 168, NULL, 'STI-like', 285873),
(474376, '0046654', NULL, NULL, 179, NULL, 'STI-like', 285873),
(474377, '0045831', NULL, NULL, 177, NULL, 'STI-like', 285873),
(474378, '0049639', NULL, NULL, 170, NULL, 'STI-like', 285873),
(474379, '0042996', NULL, NULL, 84, NULL, 'Periplasmic chaperone C-domain', 285874),
(474380, '0053785', NULL, NULL, 85, NULL, 'Periplasmic chaperone C-domain', 285874),
(474381, '0042925', NULL, NULL, 91, NULL, 'Periplasmic chaperone C-domain', 285874),
(474382, '0040381', NULL, NULL, 85, NULL, 'Periplasmic chaperone C-domain', 285874),
(474383, '0042170', NULL, NULL, 86, NULL, 'Periplasmic chaperone C-domain', 285874),
(474384, '0053730', NULL, NULL, 121, NULL, 'ParB/Sulfiredoxin', 285875),
(474385, '0054066', NULL, NULL, 201, NULL, 'ParB/Sulfiredoxin', 285875),
(474386, '0044819', NULL, NULL, 232, NULL, 'ParB/Sulfiredoxin', 285875),
(474387, '0044920', NULL, NULL, 93, NULL, 'ParB/Sulfiredoxin', 285875),
(474388, '0044081', NULL, NULL, 50, NULL, 'FnI-like domain', 285876),
(474389, '0037480', NULL, NULL, 46, NULL, 'FnI-like domain', 285876),
(474390, '0037481', NULL, NULL, 47, NULL, 'FnI-like domain', 285876),
(474391, '0042759', NULL, NULL, 44, NULL, 'FnI-like domain', 285876),
(474392, '0046485', NULL, NULL, 41, NULL, 'FnI-like domain', 285876),
(474393, '0049793', NULL, NULL, 73, NULL, 'FnI-like domain', 285876),
(474394, '0052163', NULL, NULL, 43, NULL, 'FnI-like domain', 285876),
(474395, '0042760', NULL, NULL, 49, NULL, 'FnI-like domain', 285876),
(474396, '0048076', NULL, NULL, 145, NULL, '(Phosphotyrosine protein) phosphatases II', 285877),
(474397, '0048179', NULL, NULL, 144, NULL, '(Phosphotyrosine protein) phosphatases II', 285877),
(474398, '0036941', NULL, NULL, 297, NULL, '(Phosphotyrosine protein) phosphatases II', 285877),
(474399, '0037934', NULL, NULL, 243, NULL, '(Phosphotyrosine protein) phosphatases II', 285877),
(474400, '0051429', NULL, NULL, 272, NULL, '(Phosphotyrosine protein) phosphatases II', 285877),
(474401, '0049260', NULL, NULL, 152, NULL, '(Phosphotyrosine protein) phosphatases II', 285877),
(474402, '0050432', NULL, NULL, 308, NULL, '(Phosphotyrosine protein) phosphatases II', 285877),
(474403, '0039614', NULL, NULL, 297, NULL, '(Phosphotyrosine protein) phosphatases II', 285877),
(474404, '0040695', NULL, NULL, 388, NULL, '(Phosphotyrosine protein) phosphatases II', 285877),
(474405, '0036282', NULL, NULL, 174, NULL, '(Phosphotyrosine protein) phosphatases II', 285877),
(474406, '0042113', NULL, NULL, 245, NULL, '(Phosphotyrosine protein) phosphatases II', 285877),
(474407, '0040439', NULL, NULL, 249, NULL, '(Phosphotyrosine protein) phosphatases II', 285877),
(474408, '0040438', NULL, NULL, 317, NULL, '(Phosphotyrosine protein) phosphatases II', 285877),
(474409, '0051082', NULL, NULL, 151, NULL, '(Phosphotyrosine protein) phosphatases II', 285877),
(474410, '0043147', NULL, NULL, 172, NULL, '(Phosphotyrosine protein) phosphatases II', 285877),
(474411, '0047943', NULL, NULL, 273, NULL, '(Phosphotyrosine protein) phosphatases II', 285877);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(474412, '0051299', NULL, NULL, 288, NULL, '(Phosphotyrosine protein) phosphatases II', 285877),
(474413, '0049772', NULL, NULL, 314, NULL, '(Phosphotyrosine protein) phosphatases II', 285877),
(474414, '0045098', NULL, NULL, 278, NULL, '(Phosphotyrosine protein) phosphatases II', 285877),
(474415, '0045450', NULL, NULL, 307, NULL, '(Phosphotyrosine protein) phosphatases II', 285877),
(474416, '0038934', NULL, NULL, 194, NULL, '(Phosphotyrosine protein) phosphatases II', 285877),
(474417, '0046846', NULL, NULL, 176, NULL, '(Phosphotyrosine protein) phosphatases II', 285877),
(474418, '0048567', NULL, NULL, 157, NULL, '(Phosphotyrosine protein) phosphatases II', 285877),
(474419, '0041856', NULL, NULL, 182, NULL, '(Phosphotyrosine protein) phosphatases II', 285877),
(474420, '0044763', NULL, NULL, 178, NULL, '(Phosphotyrosine protein) phosphatases II', 285877),
(474421, '0046845', NULL, NULL, 284, NULL, '(Phosphotyrosine protein) phosphatases II', 285877),
(474422, '0043336', NULL, NULL, 278, NULL, '(Phosphotyrosine protein) phosphatases II', 285877),
(474423, '0045967', NULL, NULL, 30, NULL, 'Bromelain inhibitor VI (cysteine protease inhibitor)', 285878),
(474424, '0053748', NULL, NULL, 30, NULL, 'Bromelain inhibitor VI (cysteine protease inhibitor)', 285878),
(474425, '0051978', NULL, NULL, 24, NULL, 'Bromelain inhibitor VI (cysteine protease inhibitor)', 285878),
(474426, '0053969', NULL, NULL, 98, NULL, 'YNR034W-A-like', 285879),
(474427, '0044490', NULL, NULL, 81, NULL, 'HR1 repeat', 285880),
(474428, '0036192', NULL, NULL, 86, NULL, 'HR1 repeat', 285880),
(474429, '0044071', NULL, NULL, 57, NULL, 'BPTI-like', 285881),
(474430, '0044072', NULL, NULL, 63, NULL, 'BPTI-like', 285881),
(474431, '0035719', NULL, NULL, 61, NULL, 'BPTI-like', 285881),
(474432, '0035577', NULL, NULL, 56, NULL, 'BPTI-like', 285881),
(474433, '0035576', NULL, NULL, 54, NULL, 'BPTI-like', 285881),
(474434, '0034981', NULL, NULL, 56, NULL, 'BPTI-like', 285881),
(474435, '0035678', NULL, NULL, 51, NULL, 'BPTI-like', 285881),
(474436, '0035017', NULL, NULL, 71, NULL, 'BPTI-like', 285881),
(474437, '0039476', NULL, NULL, 65, NULL, 'BPTI-like', 285881),
(474438, '0045626', NULL, NULL, 58, NULL, 'BPTI-like', 285881),
(474439, '0039152', NULL, NULL, 61, NULL, 'BPTI-like', 285881),
(474440, '0040457', NULL, NULL, 58, NULL, 'BPTI-like', 285881),
(474441, '0042851', NULL, NULL, 58, NULL, 'BPTI-like', 285881),
(474442, '0046316', NULL, NULL, 60, NULL, 'BPTI-like', 285881),
(474443, '0035506', NULL, NULL, 60, NULL, 'BPTI-like', 285881),
(474444, '0053674', NULL, NULL, 63, NULL, 'BPTI-like', 285881),
(474445, '0054682', NULL, NULL, 51, NULL, 'BPTI-like', 285881),
(474446, '0036599', NULL, NULL, 59, NULL, 'BPTI-like', 285881),
(474447, '0036218', NULL, NULL, 60, NULL, 'BPTI-like', 285881),
(474448, '0037468', NULL, NULL, 55, NULL, 'BPTI-like', 285881),
(474449, '0053656', NULL, NULL, 56, NULL, 'BPTI-like', 285881),
(474450, '0043615', NULL, NULL, 55, NULL, 'BPTI-like', 285881),
(474451, '0037040', NULL, NULL, 58, NULL, 'BPTI-like', 285881),
(474452, '0036593', NULL, NULL, 57, NULL, 'BPTI-like', 285881),
(474453, '0047876', NULL, NULL, 58, NULL, 'BPTI-like', 285881),
(474454, '0044524', NULL, NULL, 56, NULL, 'BPTI-like', 285881),
(474455, '0050051', NULL, NULL, 386, NULL, 'Six-hairpin glycosidases', 285882),
(474456, '0047123', NULL, NULL, 485, NULL, 'Six-hairpin glycosidases', 285882),
(474457, '0054299', NULL, NULL, 426, NULL, 'Six-hairpin glycosidases', 285882),
(474458, '0052638', NULL, NULL, 492, NULL, 'Six-hairpin glycosidases', 285882),
(474459, '0040233', NULL, NULL, 433, NULL, 'Six-hairpin glycosidases', 285882),
(474460, '0049609', NULL, NULL, 460, NULL, 'Six-hairpin glycosidases', 285882),
(474461, '0038366', NULL, NULL, 404, NULL, 'Six-hairpin glycosidases', 285882),
(474462, '0046939', NULL, NULL, 454, NULL, 'Six-hairpin glycosidases', 285882),
(474463, '0050704', NULL, NULL, 376, NULL, 'Six-hairpin glycosidases', 285882),
(474464, '0046953', NULL, NULL, 472, NULL, 'Six-hairpin glycosidases', 285882),
(474465, '0040358', NULL, NULL, 642, NULL, 'Six-hairpin glycosidases', 285882);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(474466, '0047967', NULL, NULL, 397, NULL, 'Six-hairpin glycosidases', 285882),
(474467, '0054222', NULL, NULL, 511, NULL, 'Six-hairpin glycosidases', 285882),
(474468, '0046166', NULL, NULL, 441, NULL, 'Six-hairpin glycosidases', 285882),
(474469, '0038939', NULL, NULL, 431, NULL, 'Six-hairpin glycosidases', 285882),
(474470, '0050085', NULL, NULL, 531, NULL, 'Six-hairpin glycosidases', 285882),
(474471, '0051759', NULL, NULL, 411, NULL, 'Six-hairpin glycosidases', 285882),
(474472, '0037466', NULL, NULL, 629, NULL, 'Six-hairpin glycosidases', 285882),
(474473, '0050146', NULL, NULL, 377, NULL, 'Six-hairpin glycosidases', 285882),
(474474, '0050765', NULL, NULL, 319, NULL, 'Six-hairpin glycosidases', 285882),
(474475, '0054447', NULL, NULL, 443, NULL, 'Six-hairpin glycosidases', 285882),
(474476, '0047896', NULL, NULL, 363, NULL, 'Six-hairpin glycosidases', 285882),
(474477, '0048326', NULL, NULL, 363, NULL, 'Six-hairpin glycosidases', 285882),
(474478, '0046841', NULL, NULL, 402, NULL, 'Six-hairpin glycosidases', 285882),
(474479, '0049896', NULL, NULL, 413, NULL, 'Six-hairpin glycosidases', 285882),
(474480, '0049995', NULL, NULL, 511, NULL, 'Six-hairpin glycosidases', 285882),
(474481, '0050176', NULL, NULL, 263, NULL, 'Zn-dependent exopeptidases', 285883),
(474482, '0049240', NULL, NULL, 291, NULL, 'Zn-dependent exopeptidases', 285883),
(474483, '0051762', NULL, NULL, 329, NULL, 'Zn-dependent exopeptidases', 285883),
(474484, '0046194', NULL, NULL, 300, NULL, 'Zn-dependent exopeptidases', 285883),
(474485, '0051343', NULL, NULL, 265, NULL, 'Zn-dependent exopeptidases', 285883),
(474486, '0046397', NULL, NULL, 303, NULL, 'Zn-dependent exopeptidases', 285883),
(474487, '0053284', NULL, NULL, 274, NULL, 'Zn-dependent exopeptidases', 285883),
(474488, '0048430', NULL, NULL, 306, NULL, 'Zn-dependent exopeptidases', 285883),
(474489, '0051427', NULL, NULL, 331, NULL, 'Zn-dependent exopeptidases', 285883),
(474490, '0051428', NULL, NULL, 322, NULL, 'Zn-dependent exopeptidases', 285883),
(474491, '0050015', NULL, NULL, 296, NULL, 'Zn-dependent exopeptidases', 285883),
(474492, '0051224', NULL, NULL, 323, NULL, 'Zn-dependent exopeptidases', 285883),
(474493, '0051389', NULL, NULL, 262, NULL, 'Zn-dependent exopeptidases', 285883),
(474494, '0050951', NULL, NULL, 258, NULL, 'Zn-dependent exopeptidases', 285883),
(474495, '0052853', NULL, NULL, 340, NULL, 'Zn-dependent exopeptidases', 285883),
(474496, '0039797', NULL, NULL, 179, NULL, 'Zn-dependent exopeptidases', 285883),
(474497, '0043109', NULL, NULL, 323, NULL, 'Zn-dependent exopeptidases', 285883),
(474498, '0046134', NULL, NULL, 277, NULL, 'Zn-dependent exopeptidases', 285883),
(474499, '0046310', NULL, NULL, 295, NULL, 'Zn-dependent exopeptidases', 285883),
(474500, '0040437', NULL, NULL, 325, NULL, 'Zn-dependent exopeptidases', 285883),
(474501, '0047901', NULL, NULL, 307, NULL, 'Zn-dependent exopeptidases', 285883),
(474502, '0052091', NULL, NULL, 312, NULL, 'Zn-dependent exopeptidases', 285883),
(474503, '0048899', NULL, NULL, 281, NULL, 'Zn-dependent exopeptidases', 285883),
(474504, '0048537', NULL, NULL, 323, NULL, 'Zn-dependent exopeptidases', 285883),
(474505, '0048735', NULL, NULL, 308, NULL, 'Zn-dependent exopeptidases', 285883),
(474506, '0049011', NULL, NULL, 277, NULL, 'Zn-dependent exopeptidases', 285883),
(474507, '0051474', NULL, NULL, 294, NULL, 'Zn-dependent exopeptidases', 285883),
(474508, '0051496', NULL, NULL, 304, NULL, 'Zn-dependent exopeptidases', 285883),
(474509, '0053258', NULL, NULL, 305, NULL, 'Zn-dependent exopeptidases', 285883),
(474510, '0050200', NULL, NULL, 299, NULL, 'Zn-dependent exopeptidases', 285883),
(474511, '0048085', NULL, NULL, 307, NULL, 'Zn-dependent exopeptidases', 285883),
(474512, '0050182', NULL, NULL, 276, NULL, 'Zn-dependent exopeptidases', 285883),
(474513, '0051051', NULL, NULL, 180, NULL, 'Zn-dependent exopeptidases', 285883),
(474514, '0051172', NULL, NULL, 256, NULL, 'Zn-dependent exopeptidases', 285883),
(474515, '0054364', NULL, NULL, 252, NULL, 'Zn-dependent exopeptidases', 285883);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(474516, '0050184', NULL, NULL, 249, NULL, 'Zn-dependent exopeptidases', 285883),
(474517, '0052020', NULL, NULL, 305, NULL, 'Zn-dependent exopeptidases', 285883),
(474518, '0054582', NULL, NULL, 280, NULL, 'Zn-dependent exopeptidases', 285883),
(474519, '0051954', NULL, NULL, 339, NULL, 'Zn-dependent exopeptidases', 285883),
(474520, '0052940', NULL, NULL, 234, NULL, 'Zn-dependent exopeptidases', 285883),
(474521, '0052787', NULL, NULL, 256, NULL, 'Zn-dependent exopeptidases', 285883),
(474522, '0053975', NULL, NULL, 307, NULL, 'Zn-dependent exopeptidases', 285883),
(474523, '0046827', NULL, NULL, 296, NULL, 'Zn-dependent exopeptidases', 285883),
(474524, '0038334', NULL, NULL, 325, NULL, 'Zn-dependent exopeptidases', 285883),
(474525, '0054085', NULL, NULL, 302, NULL, 'Zn-dependent exopeptidases', 285883),
(474526, '0047971', NULL, NULL, 273, NULL, 'Zn-dependent exopeptidases', 285883),
(474527, '0048989', NULL, NULL, 301, NULL, 'Zn-dependent exopeptidases', 285883),
(474528, '0047657', NULL, NULL, 317, NULL, 'Zn-dependent exopeptidases', 285883),
(474529, '0038317', NULL, NULL, 205, NULL, 'Smc hinge domain', 285884),
(474530, '0048826', NULL, NULL, 146, NULL, 'FAT domain of focal adhesion kinase', 285885),
(474531, '0047711', NULL, NULL, 142, NULL, 'FAT domain of focal adhesion kinase', 285885),
(474532, '0052697', NULL, NULL, 79, NULL, 'SP0561-like', 285886),
(474533, '0040366', NULL, NULL, 193, NULL, 'ssDNA-binding transcriptional regulator domain', 285887),
(474534, '0053124', NULL, NULL, 122, NULL, 'ssDNA-binding transcriptional regulator domain', 285887),
(474535, '0042252', NULL, NULL, 66, NULL, 'ssDNA-binding transcriptional regulator domain', 285887),
(474536, '0052904', NULL, NULL, 166, NULL, 'ssDNA-binding transcriptional regulator domain', 285887),
(474537, '0052905', NULL, NULL, 146, NULL, 'ssDNA-binding transcriptional regulator domain', 285887),
(474538, '0053215', NULL, NULL, 121, NULL, 'ssDNA-binding transcriptional regulator domain', 285887),
(474539, '0053929', NULL, NULL, 125, NULL, 'NRDP1 C-terminal domain-like', 285888),
(474540, '0052521', NULL, NULL, 113, NULL, 'YfmB-like', 285889),
(474541, '0037242', NULL, NULL, 99, NULL, 'IHF-like DNA-binding proteins', 285890),
(474542, '0039024', NULL, NULL, 94, NULL, 'IHF-like DNA-binding proteins', 285890),
(474543, '0054346', NULL, NULL, 90, NULL, 'IHF-like DNA-binding proteins', 285890),
(474544, '0042179', NULL, NULL, 94, NULL, 'IHF-like DNA-binding proteins', 285890),
(474545, '0039023', NULL, NULL, 96, NULL, 'IHF-like DNA-binding proteins', 285890),
(474546, '0041092', NULL, NULL, 90, NULL, 'IHF-like DNA-binding proteins', 285890),
(474547, '0036536', NULL, NULL, 55, NULL, 'IHF-like DNA-binding proteins', 285890),
(474548, '0035413', NULL, NULL, 90, NULL, 'IHF-like DNA-binding proteins', 285890),
(474549, '0038734', NULL, NULL, 90, NULL, 'IHF-like DNA-binding proteins', 285890),
(474550, '0043399', NULL, NULL, 218, NULL, 'Chlorophyll a-b binding protein', 285891),
(474551, '0049176', NULL, NULL, 127, NULL, 'ISP domain', 285892),
(474552, '0054248', NULL, NULL, 122, NULL, 'ISP domain', 285892),
(474553, '0054862', NULL, NULL, 108, NULL, 'ISP domain', 285892),
(474554, '0051453', NULL, NULL, 148, NULL, 'ISP domain', 285892),
(474555, '0054232', NULL, NULL, 108, NULL, 'ISP domain', 285892),
(474556, '0051878', NULL, NULL, 162, NULL, 'ISP domain', 285892),
(474557, '0037736', NULL, NULL, 109, NULL, 'ISP domain', 285892),
(474558, '0036982', NULL, NULL, 154, NULL, 'ISP domain', 285892),
(474559, '0039622', NULL, NULL, 202, NULL, 'ISP domain', 285892),
(474560, '0050685', NULL, NULL, 162, NULL, 'ISP domain', 285892),
(474561, '0052423', NULL, NULL, 142, NULL, 'ISP domain', 285892),
(474562, '0052006', NULL, NULL, 150, NULL, 'ISP domain', 285892),
(474563, '0037990', NULL, NULL, 133, NULL, 'ISP domain', 285892),
(474564, '0042667', NULL, NULL, 127, NULL, 'ISP domain', 285892),
(474565, '0044725', NULL, NULL, 134, NULL, 'ISP domain', 285892),
(474566, '0037293', NULL, NULL, 129, NULL, 'ISP domain', 285892),
(474567, '0044891', NULL, NULL, 109, NULL, 'ISP domain', 285892);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(474568, '0041626', NULL, NULL, 156, NULL, 'ISP domain', 285892),
(474569, '0043222', NULL, NULL, 127, NULL, 'ISP domain', 285892),
(474570, '0044425', NULL, NULL, 154, NULL, 'ISP domain', 285892),
(474571, '0037779', NULL, NULL, 117, NULL, 'XRCC4, N-terminal domain', 285893),
(474572, '0053995', NULL, NULL, 177, NULL, 'RL5-like', 285894),
(474573, '0054775', NULL, NULL, 177, NULL, 'RL5-like', 285894),
(474574, '0039125', NULL, NULL, 179, NULL, 'RL5-like', 285894),
(474575, '0054561', NULL, NULL, 133, NULL, 'RL5-like', 285894),
(474576, '0040968', NULL, NULL, 180, NULL, 'RL5-like', 285894),
(474577, '0054294', NULL, NULL, 141, NULL, 'RL5-like', 285894),
(474578, '0054371', NULL, NULL, 141, NULL, 'RL5-like', 285894),
(474579, '0037532', NULL, NULL, 165, NULL, 'RL5-like', 285894),
(474580, '0054304', NULL, NULL, 142, NULL, 'RL5-like', 285894),
(474581, '0054895', NULL, NULL, 510, NULL, 'TPR-like', 285895),
(474582, '0052670', NULL, NULL, 179, NULL, 'TPR-like', 285895),
(474583, '0054057', NULL, NULL, 156, NULL, 'TPR-like', 285895),
(474584, '0046495', NULL, NULL, 185, NULL, 'TPR-like', 285895),
(474585, '0051240', NULL, NULL, 138, NULL, 'TPR-like', 285895),
(474586, '0054395', NULL, NULL, 529, NULL, 'TPR-like', 285895),
(474587, '0051845', NULL, NULL, 231, NULL, 'TPR-like', 285895),
(474588, '0051642', NULL, NULL, 145, NULL, 'TPR-like', 285895),
(474589, '0050358', NULL, NULL, 388, NULL, 'TPR-like', 285895),
(474590, '0042932', NULL, NULL, 290, NULL, 'TPR-like', 285895),
(474591, '0040251', NULL, NULL, 168, NULL, 'TPR-like', 285895),
(474592, '0039276', NULL, NULL, 133, NULL, 'TPR-like', 285895),
(474593, '0048699', NULL, NULL, 170, NULL, 'TPR-like', 285895),
(474594, '0048732', NULL, NULL, 152, NULL, 'TPR-like', 285895),
(474595, '0054096', NULL, NULL, 179, NULL, 'TPR-like', 285895),
(474596, '0046753', NULL, NULL, 323, NULL, 'TPR-like', 285895),
(474597, '0047366', NULL, NULL, 169, NULL, 'TPR-like', 285895),
(474598, '0049644', NULL, NULL, 95, NULL, 'TPR-like', 285895),
(474599, '0047272', NULL, NULL, 366, NULL, 'TPR-like', 285895),
(474600, '0054886', NULL, NULL, 507, NULL, 'TPR-like', 285895),
(474601, '0051253', NULL, NULL, 497, NULL, 'TPR-like', 285895),
(474602, '0052100', NULL, NULL, 201, NULL, 'TPR-like', 285895),
(474603, '0054961', NULL, NULL, 459, NULL, 'TPR-like', 285895),
(474604, '0045692', NULL, NULL, 159, NULL, 'TPR-like', 285895),
(474605, '0046583', NULL, NULL, 128, NULL, 'TPR-like', 285895),
(474606, '0051037', NULL, NULL, 259, NULL, 'TPR-like', 285895),
(474607, '0052646', NULL, NULL, 153, NULL, 'TPR-like', 285895),
(474608, '0046585', NULL, NULL, 117, NULL, 'TPR-like', 285895),
(474609, '0047256', NULL, NULL, 112, NULL, 'TPR-like', 285895),
(474610, '0036938', NULL, NULL, 60, NULL, 'DsbC/DsbG N-terminal domain-like', 285896),
(474611, '0043846', NULL, NULL, 59, NULL, 'DsbC/DsbG N-terminal domain-like', 285896),
(474612, '0044620', NULL, NULL, 60, NULL, 'DsbC/DsbG N-terminal domain-like', 285896),
(474613, '0051265', NULL, NULL, 236, NULL, 'Carbamate kinase-like', 285897),
(474614, '0051682', NULL, NULL, 236, NULL, 'Carbamate kinase-like', 285897),
(474615, '0053148', NULL, NULL, 292, NULL, 'Carbamate kinase-like', 285897),
(474616, '0053112', NULL, NULL, 219, NULL, 'Carbamate kinase-like', 285897),
(474617, '0051530', NULL, NULL, 238, NULL, 'Carbamate kinase-like', 285897),
(474618, '0052013', NULL, NULL, 237, NULL, 'Carbamate kinase-like', 285897),
(474619, '0052046', NULL, NULL, 282, NULL, 'Carbamate kinase-like', 285897),
(474620, '0053023', NULL, NULL, 302, NULL, 'Carbamate kinase-like', 285897),
(474621, '0045891', NULL, NULL, 307, NULL, 'Carbamate kinase-like', 285897),
(474622, '0052030', NULL, NULL, 225, NULL, 'Carbamate kinase-like', 285897),
(474623, '0052151', NULL, NULL, 304, NULL, 'Carbamate kinase-like', 285897),
(474624, '0036708', NULL, NULL, 313, NULL, 'Carbamate kinase-like', 285897),
(474625, '0051788', NULL, NULL, 250, NULL, 'Carbamate kinase-like', 285897),
(474626, '0038241', NULL, NULL, 258, NULL, 'Carbamate kinase-like', 285897),
(474627, '0051807', NULL, NULL, 291, NULL, 'Carbamate kinase-like', 285897);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(474628, '0052050', NULL, NULL, 300, NULL, 'Carbamate kinase-like', 285897),
(474629, '0053474', NULL, NULL, 102, NULL, 'Rad50 coiled-coil Zn hook', 285898),
(474630, '0051362', NULL, NULL, 114, NULL, 'AF0941-like', 285899),
(474631, '0037330', NULL, NULL, 245, NULL, 'Caspase-like', 285900),
(474632, '0036096', NULL, NULL, 243, NULL, 'Caspase-like', 285900),
(474633, '0039807', NULL, NULL, 278, NULL, 'Caspase-like', 285900),
(474634, '0042978', NULL, NULL, 243, NULL, 'Caspase-like', 285900),
(474635, '0042519', NULL, NULL, 258, NULL, 'Caspase-like', 285900),
(474636, '0049359', NULL, NULL, 262, NULL, 'Caspase-like', 285900),
(474637, '0036168', NULL, NULL, 350, NULL, 'Caspase-like', 285900),
(474638, '0040830', NULL, NULL, 256, NULL, 'Caspase-like', 285900),
(474639, '0053532', NULL, NULL, 362, NULL, 'Variant surface glycoprotein (N-terminal domain)', 285901),
(474640, '0053576', NULL, NULL, 358, NULL, 'Variant surface glycoprotein (N-terminal domain)', 285901),
(474641, '0048471', NULL, NULL, 103, NULL, 'GlnB-like', 285902),
(474642, '0049066', NULL, NULL, 112, NULL, 'GlnB-like', 285902),
(474643, '0048360', NULL, NULL, 74, NULL, 'GlnB-like', 285902),
(474644, '0052354', NULL, NULL, 100, NULL, 'GlnB-like', 285902),
(474645, '0054032', NULL, NULL, 75, NULL, 'GlnB-like', 285902),
(474646, '0053273', NULL, NULL, 112, NULL, 'GlnB-like', 285902),
(474647, '0050169', NULL, NULL, 116, NULL, 'GlnB-like', 285902),
(474648, '0038760', NULL, NULL, 112, NULL, 'GlnB-like', 285902),
(474649, '0049929', NULL, NULL, 102, NULL, 'GlnB-like', 285902),
(474650, '0047113', NULL, NULL, 75, NULL, 'GlnB-like', 285902),
(474651, '0047861', NULL, NULL, 110, NULL, 'GlnB-like', 285902),
(474652, '0048313', NULL, NULL, 106, NULL, 'GlnB-like', 285902),
(474653, '0048489', NULL, NULL, 102, NULL, 'GlnB-like', 285902),
(474654, '0049936', NULL, NULL, 112, NULL, 'GlnB-like', 285902),
(474655, '0047018', NULL, NULL, 112, NULL, 'GlnB-like', 285902),
(474656, '0048679', NULL, NULL, 102, NULL, 'GlnB-like', 285902),
(474657, '0048636', NULL, NULL, 108, NULL, 'GlnB-like', 285902),
(474658, '0049253', NULL, NULL, 260, NULL, 'NHL repeat', 285903),
(474659, '0048898', NULL, NULL, 279, NULL, 'NHL repeat', 285903),
(474660, '0042849', NULL, NULL, 316, NULL, 'Methenyltetrahydromethanopterin cyclohydrolase', 285904),
(474661, '0050658', NULL, NULL, 88, NULL, 'RelE-like', 285905),
(474662, '0051527', NULL, NULL, 88, NULL, 'RelE-like', 285905),
(474663, '0051714', NULL, NULL, 83, NULL, 'RelE-like', 285905),
(474664, '0038593', NULL, NULL, 126, NULL, 'Transcription factor NusA, N-terminal domain', 285906),
(474665, '0039834', NULL, NULL, 104, NULL, 'Transcription factor NusA, N-terminal domain', 285906),
(474666, '0039262', NULL, NULL, 179, NULL, 'Sporulation response regulatory protein Spo0B', 285907),
(474667, '0047150', NULL, NULL, 57, NULL, 'LEM domain', 285908),
(474668, '0038494', NULL, NULL, 56, NULL, 'LEM domain', 285908),
(474669, '0047566', NULL, NULL, 53, NULL, 'LEM domain', 285908),
(474670, '0041440', NULL, NULL, 124, NULL, 'Pre-protein crosslinking domain of SecA', 285909),
(474671, '0040823', NULL, NULL, 122, NULL, 'Pre-protein crosslinking domain of SecA', 285909),
(474672, '0050462', NULL, NULL, 64, NULL, 'FYVE/PHD zinc finger', 285910),
(474673, '0050473', NULL, NULL, 91, NULL, 'FYVE/PHD zinc finger', 285910),
(474674, '0050472', NULL, NULL, 71, NULL, 'FYVE/PHD zinc finger', 285910),
(474675, '0050475', NULL, NULL, 78, NULL, 'FYVE/PHD zinc finger', 285910),
(474676, '0050463', NULL, NULL, 72, NULL, 'FYVE/PHD zinc finger', 285910),
(474677, '0050474', NULL, NULL, 88, NULL, 'FYVE/PHD zinc finger', 285910),
(474678, '0050496', NULL, NULL, 88, NULL, 'FYVE/PHD zinc finger', 285910),
(474679, '0048189', NULL, NULL, 61, NULL, 'FYVE/PHD zinc finger', 285910),
(474680, '0050172', NULL, NULL, 67, NULL, 'FYVE/PHD zinc finger', 285910),
(474681, '0037409', NULL, NULL, 51, NULL, 'FYVE/PHD zinc finger', 285910),
(474682, '0037717', NULL, NULL, 70, NULL, 'FYVE/PHD zinc finger', 285910),
(474683, '0051161', NULL, NULL, 51, NULL, 'FYVE/PHD zinc finger', 285910); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(474684, '0050471', NULL, NULL, 85, NULL, 'FYVE/PHD zinc finger', 285910),
(474685, '0050470', NULL, NULL, 79, NULL, 'FYVE/PHD zinc finger', 285910),
(474686, '0050591', NULL, NULL, 89, NULL, 'FYVE/PHD zinc finger', 285910),
(474687, '0036632', NULL, NULL, 72, NULL, 'FYVE/PHD zinc finger', 285910),
(474688, '0054703', NULL, NULL, 74, NULL, 'FYVE/PHD zinc finger', 285910),
(474689, '0038788', NULL, NULL, 65, NULL, 'FYVE/PHD zinc finger', 285910),
(474690, '0048190', NULL, NULL, 61, NULL, 'FYVE/PHD zinc finger', 285910),
(474691, '0050468', NULL, NULL, 71, NULL, 'FYVE/PHD zinc finger', 285910),
(474692, '0050467', NULL, NULL, 76, NULL, 'FYVE/PHD zinc finger', 285910),
(474693, '0045116', NULL, NULL, 124, NULL, 'FYVE/PHD zinc finger', 285910),
(474694, '0054839', NULL, NULL, 196, NULL, 'CdCA1 repeat-like', 285911),
(474695, '0054838', NULL, NULL, 209, NULL, 'CdCA1 repeat-like', 285911),
(474696, '0048263', NULL, NULL, 470, NULL, 'DPP6 N-terminal domain-like', 285912),
(474697, '0050946', NULL, NULL, 465, NULL, 'DPP6 N-terminal domain-like', 285912),
(474698, '0048632', NULL, NULL, 470, NULL, 'DPP6 N-terminal domain-like', 285912),
(474699, '0037397', NULL, NULL, 300, NULL, 'Interferon-induced guanylate-binding protein 1 (GBP1), C-terminal domain', 285913),
(474700, '0049981', NULL, NULL, 1122, NULL, 'Viral ssDNA binding protein', 285914),
(474701, '0052706', NULL, NULL, 74, NULL, 'YozE-like', 285915),
(474702, '0054337', NULL, NULL, 70, NULL, 'YozE-like', 285915),
(474703, '0036366', NULL, NULL, 314, NULL, 'DNA primase core', 285916),
(474704, '0048449', NULL, NULL, 192, NULL, 'DNA primase core', 285916),
(474705, '0051541', NULL, NULL, 264, NULL, 'ImpE-like', 285917),
(474706, '0046065', NULL, NULL, 134, NULL, 'TNF-like', 285918),
(474707, '0044063', NULL, NULL, 144, NULL, 'TNF-like', 285918),
(474708, '0054573', NULL, NULL, 116, NULL, 'TNF-like', 285918),
(474709, '0054584', NULL, NULL, 125, NULL, 'TNF-like', 285918),
(474710, '0045792', NULL, NULL, 146, NULL, 'TNF-like', 285918),
(474711, '0036412', NULL, NULL, 162, NULL, 'TNF-like', 285918),
(474712, '0051107', NULL, NULL, 137, NULL, 'TNF-like', 285918),
(474713, '0053308', NULL, NULL, 148, NULL, 'TNF-like', 285918),
(474714, '0053008', NULL, NULL, 126, NULL, 'TNF-like', 285918),
(474715, '0053009', NULL, NULL, 128, NULL, 'TNF-like', 285918),
(474716, '0039757', NULL, NULL, 155, NULL, 'TNF-like', 285918),
(474717, '0039541', NULL, NULL, 144, NULL, 'TNF-like', 285918),
(474718, '0038234', NULL, NULL, 132, NULL, 'TNF-like', 285918),
(474719, '0048519', NULL, NULL, 131, NULL, 'TNF-like', 285918),
(474720, '0045607', NULL, NULL, 148, NULL, 'TNF-like', 285918),
(474721, '0048776', NULL, NULL, 129, NULL, 'TNF-like', 285918),
(474722, '0042351', NULL, NULL, 133, NULL, 'TNF-like', 285918),
(474723, '0042352', NULL, NULL, 132, NULL, 'TNF-like', 285918),
(474724, '0043266', NULL, NULL, 140, NULL, 'TNF-like', 285918),
(474725, '0043277', NULL, NULL, 33, NULL, 'Pym (Within the bgcn gene intron protein, WIBG), N-terminal domain', 285919),
(474726, '0051386', NULL, NULL, 121, NULL, 'CheY-like', 285920),
(474727, '0046294', NULL, NULL, 123, NULL, 'CheY-like', 285920),
(474728, '0051860', NULL, NULL, 133, NULL, 'CheY-like', 285920),
(474729, '0046075', NULL, NULL, 107, NULL, 'CheY-like', 285920),
(474730, '0045682', NULL, NULL, 138, NULL, 'CheY-like', 285920),
(474731, '0048231', NULL, NULL, 121, NULL, 'CheY-like', 285920),
(474732, '0049761', NULL, NULL, 118, NULL, 'CheY-like', 285920),
(474733, '0051229', NULL, NULL, 139, NULL, 'CheY-like', 285920),
(474734, '0043525', NULL, NULL, 190, NULL, 'CheY-like', 285920),
(474735, '0051859', NULL, NULL, 117, NULL, 'CheY-like', 285920),
(474736, '0046299', NULL, NULL, 134, NULL, 'CheY-like', 285920),
(474737, '0048656', NULL, NULL, 124, NULL, 'CheY-like', 285920),
(474738, '0048975', NULL, NULL, 140, NULL, 'CheY-like', 285920),
(474739, '0048997', NULL, NULL, 189, NULL, 'CheY-like', 285920),
(474740, '0047867', NULL, NULL, 123, NULL, 'CheY-like', 285920),
(474741, '0045700', NULL, NULL, 140, NULL, 'CheY-like', 285920);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(474742, '0050341', NULL, NULL, 139, NULL, 'CheY-like', 285920),
(474743, '0051573', NULL, NULL, 120, NULL, 'CheY-like', 285920),
(474744, '0054521', NULL, NULL, 119, NULL, 'CheY-like', 285920),
(474745, '0050342', NULL, NULL, 153, NULL, 'CheY-like', 285920),
(474746, '0051574', NULL, NULL, 119, NULL, 'CheY-like', 285920),
(474747, '0048465', NULL, NULL, 137, NULL, 'CheY-like', 285920),
(474748, '0048685', NULL, NULL, 120, NULL, 'CheY-like', 285920),
(474749, '0047296', NULL, NULL, 144, NULL, 'CheY-like', 285920),
(474750, '0048066', NULL, NULL, 135, NULL, 'CheY-like', 285920),
(474751, '0048463', NULL, NULL, 119, NULL, 'CheY-like', 285920),
(474752, '0050964', NULL, NULL, 121, NULL, 'CheY-like', 285920),
(474753, '0039925', NULL, NULL, 149, NULL, 'CheY-like', 285920),
(474754, '0051318', NULL, NULL, 128, NULL, 'CheY-like', 285920),
(474755, '0051898', NULL, NULL, 118, NULL, 'CheY-like', 285920),
(474756, '0046428', NULL, NULL, 123, NULL, 'CheY-like', 285920),
(474757, '0048705', NULL, NULL, 129, NULL, 'CheY-like', 285920),
(474758, '0047555', NULL, NULL, 128, NULL, 'CheY-like', 285920),
(474759, '0047753', NULL, NULL, 140, NULL, 'CheY-like', 285920),
(474760, '0049456', NULL, NULL, 119, NULL, 'CheY-like', 285920),
(474761, '0045852', NULL, NULL, 122, NULL, 'CheY-like', 285920),
(474762, '0047799', NULL, NULL, 122, NULL, 'CheY-like', 285920),
(474763, '0048129', NULL, NULL, 123, NULL, 'CheY-like', 285920),
(474764, '0037549', NULL, NULL, 85, NULL, 'Ribosomal protein L31e', 285921),
(474765, '0044900', NULL, NULL, 574, NULL, 'Acid phosphatase/Vanadium-dependent haloperoxidase', 285922),
(474766, '0042804', NULL, NULL, 555, NULL, 'Acid phosphatase/Vanadium-dependent haloperoxidase', 285922),
(474767, '0044476', NULL, NULL, 597, NULL, 'Acid phosphatase/Vanadium-dependent haloperoxidase', 285922),
(474768, '0042785', NULL, NULL, 595, NULL, 'Acid phosphatase/Vanadium-dependent haloperoxidase', 285922),
(474769, '0036249', NULL, NULL, 224, NULL, 'Acid phosphatase/Vanadium-dependent haloperoxidase', 285922),
(474770, '0035025', NULL, NULL, 81, NULL, 'Chemotaxis receptor methyltransferase CheR, N-terminal domain', 285923),
(474771, '0035978', NULL, NULL, 105, NULL, 'Starch-binding domain-like', 285924),
(474772, '0054200', NULL, NULL, 102, NULL, 'Starch-binding domain-like', 285924),
(474773, '0036004', NULL, NULL, 105, NULL, 'Starch-binding domain-like', 285924),
(474774, '0048380', NULL, NULL, 87, NULL, 'Starch-binding domain-like', 285924),
(474775, '0036196', NULL, NULL, 106, NULL, 'Starch-binding domain-like', 285924),
(474776, '0042222', NULL, NULL, 104, NULL, 'Starch-binding domain-like', 285924),
(474777, '0036255', NULL, NULL, 103, NULL, 'Starch-binding domain-like', 285924),
(474778, '0053916', NULL, NULL, 131, NULL, 'Starch-binding domain-like', 285924),
(474779, '0036120', NULL, NULL, 99, NULL, 'Starch-binding domain-like', 285924),
(474780, '0047883', NULL, NULL, 108, NULL, 'Starch-binding domain-like', 285924),
(474781, '0054193', NULL, NULL, 114, NULL, 'Starch-binding domain-like', 285924),
(474782, '0042793', NULL, NULL, 110, NULL, 'Starch-binding domain-like', 285924),
(474783, '0054194', NULL, NULL, 103, NULL, 'Starch-binding domain-like', 285924),
(474784, '0054191', NULL, NULL, 107, NULL, 'Starch-binding domain-like', 285924),
(474785, '0054192', NULL, NULL, 112, NULL, 'Starch-binding domain-like', 285924),
(474786, '0053165', NULL, NULL, 140, NULL, 'Rv1873-like', 285925),
(474787, '0040572', NULL, NULL, 187, NULL, 'DNA-glycosylase', 285926),
(474788, '0048358', NULL, NULL, 144, NULL, 'DNA-glycosylase', 285926),
(474789, '0043362', NULL, NULL, 221, NULL, 'DNA-glycosylase', 285926),
(474790, '0051070', NULL, NULL, 253, NULL, 'DNA-glycosylase', 285926),
(474791, '0045145', NULL, NULL, 211, NULL, 'DNA-glycosylase', 285926),
(474792, '0041094', NULL, NULL, 225, NULL, 'DNA-glycosylase', 285926),
(474793, '0050956', NULL, NULL, 245, NULL, 'DNA-glycosylase', 285926),
(474794, '0036894', NULL, NULL, 190, NULL, 'DNA-glycosylase', 285926),
(474795, '0042464', NULL, NULL, 217, NULL, 'DNA-glycosylase', 285926);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(474796, '0047788', NULL, NULL, 217, NULL, 'DNA-glycosylase', 285926),
(474797, '0041996', NULL, NULL, 214, NULL, 'DNA-glycosylase', 285926),
(474798, '0041038', NULL, NULL, 183, NULL, 'DNA-glycosylase', 285926),
(474799, '0051165', NULL, NULL, 169, NULL, 'YceI-like', 285927),
(474800, '0050707', NULL, NULL, 176, NULL, 'YceI-like', 285927),
(474801, '0051045', NULL, NULL, 150, NULL, 'HSP20-like chaperones', 285928),
(474802, '0050494', NULL, NULL, 131, NULL, 'HSP20-like chaperones', 285928),
(474803, '0043290', NULL, NULL, 92, NULL, 'HSP20-like chaperones', 285928),
(474804, '0050540', NULL, NULL, 134, NULL, 'HSP20-like chaperones', 285928),
(474805, '0043616', NULL, NULL, 115, NULL, 'HSP20-like chaperones', 285928),
(474806, '0050536', NULL, NULL, 124, NULL, 'HSP20-like chaperones', 285928),
(474807, '0047015', NULL, NULL, 150, NULL, 'HSP20-like chaperones', 285928),
(474808, '0037037', NULL, NULL, 110, NULL, 'HSP20-like chaperones', 285928),
(474809, '0042228', NULL, NULL, 35, NULL, 'Notch domain', 285929),
(474810, '0038620', NULL, NULL, 86, NULL, 'Hairpin loop containing domain-like', 285930),
(474811, '0038925', NULL, NULL, 89, NULL, 'Hairpin loop containing domain-like', 285930),
(474812, '0035558', NULL, NULL, 92, NULL, 'Hairpin loop containing domain-like', 285930),
(474813, '0047382', NULL, NULL, 221, NULL, 'Ankyrin repeat', 285931),
(474814, '0051277', NULL, NULL, 130, NULL, 'Ankyrin repeat', 285931),
(474815, '0048640', NULL, NULL, 209, NULL, 'Ankyrin repeat', 285931),
(474816, '0049488', NULL, NULL, 301, NULL, 'Ankyrin repeat', 285931),
(474817, '0047365', NULL, NULL, 156, NULL, 'Ankyrin repeat', 285931),
(474818, '0049331', NULL, NULL, 291, NULL, 'Ankyrin repeat', 285931),
(474819, '0050455', NULL, NULL, 285, NULL, 'Ankyrin repeat', 285931),
(474820, '0053922', NULL, NULL, 277, NULL, 'Ankyrin repeat', 285931),
(474821, '0045933', NULL, NULL, 156, NULL, 'Ankyrin repeat', 285931),
(474822, '0041145', NULL, NULL, 118, NULL, 'Ankyrin repeat', 285931),
(474823, '0045715', NULL, NULL, 156, NULL, 'Ankyrin repeat', 285931),
(474824, '0035240', NULL, NULL, 153, NULL, 'Ankyrin repeat', 285931),
(474825, '0047720', NULL, NULL, 228, NULL, 'Ankyrin repeat', 285931),
(474826, '0048259', NULL, NULL, 408, NULL, 'Ankyrin repeat', 285931),
(474827, '0045980', NULL, NULL, 160, NULL, 'Ankyrin repeat', 285931),
(474828, '0046301', NULL, NULL, 154, NULL, 'Ankyrin repeat', 285931),
(474829, '0049962', NULL, NULL, 223, NULL, 'Ankyrin repeat', 285931),
(474830, '0047469', NULL, NULL, 229, NULL, 'Ankyrin repeat', 285931),
(474831, '0047744', NULL, NULL, 258, NULL, 'Ankyrin repeat', 285931),
(474832, '0044528', NULL, NULL, 76, NULL, 'Lissencephaly-1 protein (Lis-1, PAF-AH alpha) N-terminal domain', 285932),
(474833, '0054079', NULL, NULL, 169, NULL, 'HI0933 insert domain-like', 285933),
(474834, '0053968', NULL, NULL, 148, NULL, 'HI0933 insert domain-like', 285933),
(474835, '0039560', NULL, NULL, 212, NULL, 'delta-Endotoxin (insectocide), middle domain', 285934),
(474836, '0036011', NULL, NULL, 206, NULL, 'delta-Endotoxin (insectocide), middle domain', 285934),
(474837, '0036484', NULL, NULL, 210, NULL, 'delta-Endotoxin (insectocide), middle domain', 285934),
(474838, '0047311', NULL, NULL, 209, NULL, 'delta-Endotoxin (insectocide), middle domain', 285934),
(474839, '0052825', NULL, NULL, 77, NULL, 'PE/PPE dimer-like', 285935),
(474840, '0052826', NULL, NULL, 173, NULL, 'PE/PPE dimer-like', 285935),
(474841, '0050917', NULL, NULL, 228, NULL, 'DBL homology domain (DH-domain)', 285936),
(474842, '0041563', NULL, NULL, 184, NULL, 'DBL homology domain (DH-domain)', 285936),
(474843, '0035771', NULL, NULL, 209, NULL, 'DBL homology domain (DH-domain)', 285936),
(474844, '0044151', NULL, NULL, 234, NULL, 'DBL homology domain (DH-domain)', 285936),
(474845, '0053817', NULL, NULL, 203, NULL, 'DBL homology domain (DH-domain)', 285936),
(474846, '0037708', NULL, NULL, 206, NULL, 'DBL homology domain (DH-domain)', 285936),
(474847, '0036335', NULL, NULL, 207, NULL, 'DBL homology domain (DH-domain)', 285936),
(474848, '0040329', NULL, NULL, 195, NULL, 'DBL homology domain (DH-domain)', 285936);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(474849, '0047812', NULL, NULL, 210, NULL, 'DBL homology domain (DH-domain)', 285936),
(474850, '0037403', NULL, NULL, 208, NULL, 'DBL homology domain (DH-domain)', 285936),
(474851, '0046858', NULL, NULL, 148, NULL, 'Formylmethanofuran:tetrahydromethanopterin formyltransferase', 285937),
(474852, '0046859', NULL, NULL, 148, NULL, 'Formylmethanofuran:tetrahydromethanopterin formyltransferase', 285937),
(474853, '0048093', NULL, NULL, 145, NULL, 'Formylmethanofuran:tetrahydromethanopterin formyltransferase', 285937),
(474854, '0048094', NULL, NULL, 152, NULL, 'Formylmethanofuran:tetrahydromethanopterin formyltransferase', 285937),
(474855, '0048091', NULL, NULL, 145, NULL, 'Formylmethanofuran:tetrahydromethanopterin formyltransferase', 285937),
(474856, '0048092', NULL, NULL, 152, NULL, 'Formylmethanofuran:tetrahydromethanopterin formyltransferase', 285937),
(474857, '0053974', NULL, NULL, 77, NULL, 'HP0062-like', 285938),
(474858, '0048054', NULL, NULL, 111, NULL, 'RNase A-like', 285939),
(474859, '0035307', NULL, NULL, 123, NULL, 'RNase A-like', 285939),
(474860, '0036677', NULL, NULL, 133, NULL, 'RNase A-like', 285939),
(474861, '0035378', NULL, NULL, 124, NULL, 'RNase A-like', 285939),
(474862, '0034782', NULL, NULL, 124, NULL, 'RNase A-like', 285939),
(474863, '0040290', NULL, NULL, 107, NULL, 'RNase A-like', 285939),
(474864, '0036667', NULL, NULL, 124, NULL, 'RNase A-like', 285939),
(474865, '0035041', NULL, NULL, 125, NULL, 'RNase A-like', 285939),
(474866, '0043315', NULL, NULL, 120, NULL, 'RNase A-like', 285939),
(474867, '0038598', NULL, NULL, 135, NULL, 'RNase A-like', 285939),
(474868, '0041881', NULL, NULL, 105, NULL, 'RNase A-like', 285939),
(474869, '0036683', NULL, NULL, 126, NULL, 'RNase A-like', 285939),
(474870, '0038286', NULL, NULL, 123, NULL, 'RNase A-like', 285939),
(474871, '0041936', NULL, NULL, 104, NULL, 'RNase A-like', 285939),
(474872, '0043357', NULL, NULL, 124, NULL, 'RNase A-like', 285939),
(474873, '0040796', NULL, NULL, 106, NULL, 'RNase A-like', 285939),
(474874, '0053404', NULL, NULL, 77, NULL, 'Delta-sleep-inducing peptide immunoreactive peptide', 285940),
(474875, '0054325', NULL, NULL, 167, NULL, 'alpha/beta knot', 285941),
(474876, '0050073', NULL, NULL, 162, NULL, 'alpha/beta knot', 285941),
(474877, '0054693', NULL, NULL, 227, NULL, 'alpha/beta knot', 285941),
(474878, '0044065', NULL, NULL, 157, NULL, 'alpha/beta knot', 285941),
(474879, '0054617', NULL, NULL, 194, NULL, 'alpha/beta knot', 285941),
(474880, '0054635', NULL, NULL, 201, NULL, 'alpha/beta knot', 285941),
(474881, '0054822', NULL, NULL, 204, NULL, 'alpha/beta knot', 285941),
(474882, '0038338', NULL, NULL, 166, NULL, 'alpha/beta knot', 285941),
(474883, '0047409', NULL, NULL, 158, NULL, 'alpha/beta knot', 285941),
(474884, '0039893', NULL, NULL, 192, NULL, 'alpha/beta knot', 285941),
(474885, '0044746', NULL, NULL, 157, NULL, 'alpha/beta knot', 285941),
(474886, '0044758', NULL, NULL, 180, NULL, 'alpha/beta knot', 285941),
(474887, '0042210', NULL, NULL, 246, NULL, 'alpha/beta knot', 285941),
(474888, '0042076', NULL, NULL, 232, NULL, 'alpha/beta knot', 285941),
(474889, '0048501', NULL, NULL, 147, NULL, 'alpha/beta knot', 285941),
(474890, '0044596', NULL, NULL, 191, NULL, 'alpha/beta knot', 285941),
(474891, '0041613', NULL, NULL, 174, NULL, 'alpha/beta knot', 285941),
(474892, '0048429', NULL, NULL, 153, NULL, 'alpha/beta knot', 285941),
(474893, '0044237', NULL, NULL, 252, NULL, 'alpha/beta knot', 285941),
(474894, '0041137', NULL, NULL, 156, NULL, 'alpha/beta knot', 285941),
(474895, '0053392', NULL, NULL, 47, NULL, 'Chicken cartilage matrix protein', 285942),
(474896, '0037009', NULL, NULL, 33, NULL, 'Bacterial ba3 type cytochrome c oxidase subunit IIa', 285943),
(474897, '0046736', NULL, NULL, 158, NULL, '6-hydroxymethyl-7,8-dihydropterin pyrophosphokinase, HPPK', 285944),
(474898, '0046104', NULL, NULL, 160, NULL, '6-hydroxymethyl-7,8-dihydropterin pyrophosphokinase, HPPK', 285944),
(474899, '0037739', NULL, NULL, 76, NULL, 'Skp1 dimerisation domain-like', 285945),
(474900, '0041350', NULL, NULL, 70, NULL, 'Skp1 dimerisation domain-like', 285945);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(474901, '0037754', NULL, NULL, 67, NULL, 'Skp1 dimerisation domain-like', 285945),
(474902, '0054632', NULL, NULL, 312, NULL, 'NAD kinase/diacylglycerol kinase-like', 285946),
(474903, '0054453', NULL, NULL, 299, NULL, 'NAD kinase/diacylglycerol kinase-like', 285946),
(474904, '0044184', NULL, NULL, 302, NULL, 'NAD kinase/diacylglycerol kinase-like', 285946),
(474905, '0043771', NULL, NULL, 249, NULL, 'NAD kinase/diacylglycerol kinase-like', 285946),
(474906, '0053755', NULL, NULL, 295, NULL, 'NAD kinase/diacylglycerol kinase-like', 285946),
(474907, '0037055', NULL, NULL, 210, NULL, 'beta-carbonic anhydrase, cab', 285947),
(474908, '0038893', NULL, NULL, 214, NULL, 'beta-carbonic anhydrase, cab', 285947),
(474909, '0036375', NULL, NULL, 239, NULL, 'beta-carbonic anhydrase, cab', 285947),
(474910, '0036374', NULL, NULL, 242, NULL, 'beta-carbonic anhydrase, cab', 285947),
(474911, '0037944', NULL, NULL, 169, NULL, 'beta-carbonic anhydrase, cab', 285947),
(474912, '0041450', NULL, NULL, 80, NULL, 'HSP40/DnaJ peptide-binding domain', 285948),
(474913, '0041449', NULL, NULL, 75, NULL, 'HSP40/DnaJ peptide-binding domain', 285948),
(474914, '0035834', NULL, NULL, 90, NULL, 'HSP40/DnaJ peptide-binding domain', 285948),
(474915, '0035833', NULL, NULL, 80, NULL, 'HSP40/DnaJ peptide-binding domain', 285948),
(474916, '0053467', NULL, NULL, 55, NULL, 'Tropomyosin', 285949),
(474917, '0053486', NULL, NULL, 37, NULL, 'Tropomyosin', 285949),
(474918, '0053440', NULL, NULL, 79, NULL, 'Tropomyosin', 285949),
(474919, '0053395', NULL, NULL, 284, NULL, 'Tropomyosin', 285949),
(474920, '0053560', NULL, NULL, 122, NULL, 'Tropomyosin', 285949),
(474921, '0051583', NULL, NULL, 413, NULL, 'Thermophilic metalloprotease-like', 285950),
(474922, '0051854', NULL, NULL, 406, NULL, 'Thermophilic metalloprotease-like', 285950),
(474923, '0054776', NULL, NULL, 90, NULL, 'Ribosomal protein L6', 285951),
(474924, '0053786', NULL, NULL, 87, NULL, 'Ribosomal protein L6', 285951),
(474925, '0054599', NULL, NULL, 95, NULL, 'Ribosomal protein L6', 285951),
(474926, '0054179', NULL, NULL, 71, NULL, 'Ribosomal protein L6', 285951),
(474927, '0054598', NULL, NULL, 81, NULL, 'Ribosomal protein L6', 285951),
(474928, '0043293', NULL, NULL, 75, NULL, 'Ribosomal protein L6', 285951),
(474929, '0043294', NULL, NULL, 89, NULL, 'Ribosomal protein L6', 285951),
(474930, '0037526', NULL, NULL, 79, NULL, 'Ribosomal protein L6', 285951),
(474931, '0037527', NULL, NULL, 93, NULL, 'Ribosomal protein L6', 285951),
(474932, '0054180', NULL, NULL, 89, NULL, 'Ribosomal protein L6', 285951),
(474933, '0054777', NULL, NULL, 78, NULL, 'Ribosomal protein L6', 285951),
(474934, '0053973', NULL, NULL, 67, NULL, 'YvfG-like', 285952),
(474935, '0053519', NULL, NULL, 62, NULL, 'Fzo-like conserved region', 285953),
(474936, '0047732', NULL, NULL, 360, NULL, 'Tricorn protease domain 2', 285954),
(474937, '0044729', NULL, NULL, 27, NULL, 'PetN subunit of the cytochrome b6f complex', 285955),
(474938, '0042672', NULL, NULL, 31, NULL, 'PetN subunit of the cytochrome b6f complex', 285955),
(474939, '0051713', NULL, NULL, 83, NULL, 'YefM-like', 285956),
(474940, '0053248', NULL, NULL, 51, NULL, 'YefM-like', 285956),
(474941, '0048071', NULL, NULL, 107, NULL, 'Helical domain of Sec23/24', 285957),
(474942, '0040742', NULL, NULL, 103, NULL, 'Helical domain of Sec23/24', 285957),
(474943, '0039469', NULL, NULL, 100, NULL, 'LCCL domain', 285958),
(474944, '0049819', NULL, NULL, 138, NULL, 'I/LWEQ domain', 285959),
(474945, '0049410', NULL, NULL, 125, NULL, 'I/LWEQ domain', 285959),
(474946, '0043066', NULL, NULL, 194, NULL, 'I/LWEQ domain', 285959),
(474947, '0040453', NULL, NULL, 205, NULL, 'ENV polyprotein, receptor-binding domain', 285960),
(474948, '0035134', NULL, NULL, 228, NULL, 'ENV polyprotein, receptor-binding domain', 285960),
(474949, '0052812', NULL, NULL, 78, NULL, 'TM0693-like', 285961),
(474950, '0039952', NULL, NULL, 175, NULL, 'N-terminal domain of bifunctional PutA protein', 285962),
(474951, '0053965', NULL, NULL, 130, NULL, 'RPA2825-like', 285963);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(474952, '0039280', NULL, NULL, 137, NULL, 'BRCA2 tower domain', 285964),
(474953, '0040952', NULL, NULL, 136, NULL, 'BRCA2 tower domain', 285964),
(474954, '0040963', NULL, NULL, 49, NULL, 'BRCA2 tower domain', 285964),
(474955, '0044733', NULL, NULL, 237, NULL, 'HlyD-like secretion proteins', 285965),
(474956, '0038205', NULL, NULL, 102, NULL, 'Glutamyl tRNA-reductase dimerization domain', 285966),
(474957, '0039457', NULL, NULL, 38, NULL, 'Subunit VIII of photosystem I reaction centre, PsaI', 285967),
(474958, '0044157', NULL, NULL, 254, NULL, 'VPS9 domain', 285968),
(474959, '0051066', NULL, NULL, 231, NULL, 'YaeB-like', 285969),
(474960, '0050186', NULL, NULL, 237, NULL, 'Purine and uridine phosphorylases', 285970),
(474961, '0048112', NULL, NULL, 288, NULL, 'Purine and uridine phosphorylases', 285970),
(474962, '0048860', NULL, NULL, 243, NULL, 'Purine and uridine phosphorylases', 285970),
(474963, '0046099', NULL, NULL, 273, NULL, 'Purine and uridine phosphorylases', 285970),
(474964, '0039819', NULL, NULL, 230, NULL, 'Purine and uridine phosphorylases', 285970),
(474965, '0050257', NULL, NULL, 265, NULL, 'Purine and uridine phosphorylases', 285970),
(474966, '0050047', NULL, NULL, 266, NULL, 'Purine and uridine phosphorylases', 285970),
(474967, '0051268', NULL, NULL, 246, NULL, 'Purine and uridine phosphorylases', 285970),
(474968, '0051743', NULL, NULL, 231, NULL, 'Purine and uridine phosphorylases', 285970),
(474969, '0048936', NULL, NULL, 266, NULL, 'Purine and uridine phosphorylases', 285970),
(474970, '0045902', NULL, NULL, 280, NULL, 'Purine and uridine phosphorylases', 285970),
(474971, '0047738', NULL, NULL, 253, NULL, 'Purine and uridine phosphorylases', 285970),
(474972, '0046908', NULL, NULL, 262, NULL, 'Purine and uridine phosphorylases', 285970),
(474973, '0039496', NULL, NULL, 234, NULL, 'Purine and uridine phosphorylases', 285970),
(474974, '0046520', NULL, NULL, 237, NULL, 'Purine and uridine phosphorylases', 285970),
(474975, '0049568', NULL, NULL, 477, NULL, 'Purine and uridine phosphorylases', 285970),
(474976, '0041801', NULL, NULL, 234, NULL, 'Purine and uridine phosphorylases', 285970),
(474977, '0052258', NULL, NULL, 83, NULL, 'MIT domain-like', 285971),
(474978, '0053475', NULL, NULL, 110, NULL, 'Rotavirus nonstructural proteins', 285972),
(474979, '0053419', NULL, NULL, 43, NULL, 'Rotavirus nonstructural proteins', 285972),
(474980, '0049115', NULL, NULL, 372, NULL, 'tRNA-guanine transglycosylase', 285973),
(474981, '0047415', NULL, NULL, 355, NULL, 'tRNA-guanine transglycosylase', 285973),
(474982, '0052805', NULL, NULL, 123, NULL, 'Coronavirus NSP10-like', 285974),
(474983, '0047262', NULL, NULL, 168, NULL, 'LDH C-terminal domain-like', 285975),
(474984, '0047067', NULL, NULL, 163, NULL, 'LDH C-terminal domain-like', 285975),
(474985, '0053022', NULL, NULL, 161, NULL, 'LDH C-terminal domain-like', 285975),
(474986, '0053364', NULL, NULL, 169, NULL, 'LDH C-terminal domain-like', 285975),
(474987, '0047264', NULL, NULL, 163, NULL, 'LDH C-terminal domain-like', 285975),
(474988, '0053384', NULL, NULL, 172, NULL, 'LDH C-terminal domain-like', 285975),
(474989, '0050213', NULL, NULL, 278, NULL, 'LDH C-terminal domain-like', 285975),
(474990, '0036008', NULL, NULL, 192, NULL, 'LDH C-terminal domain-like', 285975),
(474991, '0045903', NULL, NULL, 171, NULL, 'LDH C-terminal domain-like', 285975),
(474992, '0043508', NULL, NULL, 270, NULL, 'LDH C-terminal domain-like', 285975),
(474993, '0048534', NULL, NULL, 308, NULL, 'LDH C-terminal domain-like', 285975),
(474994, '0044475', NULL, NULL, 253, NULL, 'LDH C-terminal domain-like', 285975),
(474995, '0041889', NULL, NULL, 152, NULL, 'LDH C-terminal domain-like', 285975),
(474996, '0048539', NULL, NULL, 166, NULL, 'LDH C-terminal domain-like', 285975),
(474997, '0047964', NULL, NULL, 168, NULL, 'LDH C-terminal domain-like', 285975),
(474998, '0045646', NULL, NULL, 188, NULL, 'LDH C-terminal domain-like', 285975),
(474999, '0046657', NULL, NULL, 171, NULL, 'LDH C-terminal domain-like', 285975),
(475000, '0053357', NULL, NULL, 179, NULL, 'LDH C-terminal domain-like', 285975);
INSERT INTO "PUBLIC"."MODEL" VALUES
(475001, '0047991', NULL, NULL, 172, NULL, 'LDH C-terminal domain-like', 285975),
(475002, '0047277', NULL, NULL, 172, NULL, 'LDH C-terminal domain-like', 285975),
(475003, '0048187', NULL, NULL, 169, NULL, 'LDH C-terminal domain-like', 285975),
(475004, '0052184', NULL, NULL, 167, NULL, 'LDH C-terminal domain-like', 285975),
(475005, '0051214', NULL, NULL, 169, NULL, 'LDH C-terminal domain-like', 285975),
(475006, '0038277', NULL, NULL, 163, NULL, 'LDH C-terminal domain-like', 285975),
(475007, '0038278', NULL, NULL, 163, NULL, 'LDH C-terminal domain-like', 285975),
(475008, '0045935', NULL, NULL, 172, NULL, 'LDH C-terminal domain-like', 285975),
(475009, '0048849', NULL, NULL, 172, NULL, 'LDH C-terminal domain-like', 285975),
(475010, '0045719', NULL, NULL, 172, NULL, 'LDH C-terminal domain-like', 285975),
(475011, '0046124', NULL, NULL, 166, NULL, 'LDH C-terminal domain-like', 285975),
(475012, '0053173', NULL, NULL, 172, NULL, 'LDH C-terminal domain-like', 285975),
(475013, '0047279', NULL, NULL, 172, NULL, 'LDH C-terminal domain-like', 285975),
(475014, '0044226', NULL, NULL, 276, NULL, 'LDH C-terminal domain-like', 285975),
(475015, '0040543', NULL, NULL, 170, NULL, 'LDH C-terminal domain-like', 285975),
(475016, '0054054', NULL, NULL, 152, NULL, 'PH1570-like', 285976),
(475017, '0036233', NULL, NULL, 83, NULL, 'eIF1-like', 285977),
(475018, '0045333', NULL, NULL, 126, NULL, 'eIF1-like', 285977),
(475019, '0052667', NULL, NULL, 159, NULL, 'PA2201 C-terminal domain-like', 285978),
(475020, '0054013', NULL, NULL, 144, NULL, 'NEAT domain-like', 285979),
(475021, '0054156', NULL, NULL, 121, NULL, 'NEAT domain-like', 285979),
(475022, '0054338', NULL, NULL, 122, NULL, 'NEAT domain-like', 285979),
(475023, '0048587', NULL, NULL, 74, NULL, 'alpha-Amylase inhibitor tendamistat', 285980),
(475024, '0049361', NULL, NULL, 31, NULL, 'Scorpion toxin-like', 285981),
(475025, '0048871', NULL, NULL, 31, NULL, 'Scorpion toxin-like', 285981),
(475026, '0048671', NULL, NULL, 44, NULL, 'Scorpion toxin-like', 285981),
(475027, '0048792', NULL, NULL, 31, NULL, 'Scorpion toxin-like', 285981),
(475028, '0049684', NULL, NULL, 35, NULL, 'Scorpion toxin-like', 285981),
(475029, '0050679', NULL, NULL, 34, NULL, 'Scorpion toxin-like', 285981),
(475030, '0052259', NULL, NULL, 37, NULL, 'Scorpion toxin-like', 285981),
(475031, '0038661', NULL, NULL, 37, NULL, 'Scorpion toxin-like', 285981),
(475032, '0047704', NULL, NULL, 68, NULL, 'Scorpion toxin-like', 285981),
(475033, '0043549', NULL, NULL, 38, NULL, 'Scorpion toxin-like', 285981),
(475034, '0041000', NULL, NULL, 36, NULL, 'Scorpion toxin-like', 285981),
(475035, '0035594', NULL, NULL, 50, NULL, 'Scorpion toxin-like', 285981),
(475036, '0045928', NULL, NULL, 74, NULL, 'Scorpion toxin-like', 285981),
(475037, '0047709', NULL, NULL, 66, NULL, 'Scorpion toxin-like', 285981),
(475038, '0040271', NULL, NULL, 66, NULL, 'Scorpion toxin-like', 285981),
(475039, '0045760', NULL, NULL, 29, NULL, 'Scorpion toxin-like', 285981),
(475040, '0047344', NULL, NULL, 40, NULL, 'Scorpion toxin-like', 285981),
(475041, '0045842', NULL, NULL, 51, NULL, 'Scorpion toxin-like', 285981),
(475042, '0048835', NULL, NULL, 31, NULL, 'Scorpion toxin-like', 285981),
(475043, '0049408', NULL, NULL, 35, NULL, 'Scorpion toxin-like', 285981),
(475044, '0047623', NULL, NULL, 23, NULL, 'Scorpion toxin-like', 285981),
(475045, '0046184', NULL, NULL, 66, NULL, 'Scorpion toxin-like', 285981),
(475046, '0048282', NULL, NULL, 47, NULL, 'Scorpion toxin-like', 285981),
(475047, '0049493', NULL, NULL, 39, NULL, 'Scorpion toxin-like', 285981),
(475048, '0046183', NULL, NULL, 31, NULL, 'Scorpion toxin-like', 285981),
(475049, '0041929', NULL, NULL, 64, NULL, 'Scorpion toxin-like', 285981),
(475050, '0046141', NULL, NULL, 36, NULL, 'Scorpion toxin-like', 285981),
(475051, '0043271', NULL, NULL, 31, NULL, 'Scorpion toxin-like', 285981),
(475052, '0049375', NULL, NULL, 64, NULL, 'Scorpion toxin-like', 285981),
(475053, '0038218', NULL, NULL, 47, NULL, 'Scorpion toxin-like', 285981),
(475054, '0036554', NULL, NULL, 64, NULL, 'Scorpion toxin-like', 285981);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(475055, '0041054', NULL, NULL, 47, NULL, 'Scorpion toxin-like', 285981),
(475056, '0047038', NULL, NULL, 47, NULL, 'Scorpion toxin-like', 285981),
(475057, '0049899', NULL, NULL, 50, NULL, 'Scorpion toxin-like', 285981),
(475058, '0045892', NULL, NULL, 61, NULL, 'Scorpion toxin-like', 285981),
(475059, '0047314', NULL, NULL, 60, NULL, 'Scorpion toxin-like', 285981),
(475060, '0043672', NULL, NULL, 64, NULL, 'Scorpion toxin-like', 285981),
(475061, '0049732', NULL, NULL, 34, NULL, 'Scorpion toxin-like', 285981),
(475062, '0045971', NULL, NULL, 37, NULL, 'Scorpion toxin-like', 285981),
(475063, '0043673', NULL, NULL, 64, NULL, 'Scorpion toxin-like', 285981),
(475064, '0045775', NULL, NULL, 38, NULL, 'Scorpion toxin-like', 285981),
(475065, '0046073', NULL, NULL, 35, NULL, 'Scorpion toxin-like', 285981),
(475066, '0048299', NULL, NULL, 38, NULL, 'Scorpion toxin-like', 285981),
(475067, '0048772', NULL, NULL, 32, NULL, 'Scorpion toxin-like', 285981),
(475068, '0051824', NULL, NULL, 65, NULL, 'Scorpion toxin-like', 285981),
(475069, '0050697', NULL, NULL, 41, NULL, 'Scorpion toxin-like', 285981),
(475070, '0050259', NULL, NULL, 65, NULL, 'Scorpion toxin-like', 285981),
(475071, '0050654', NULL, NULL, 29, NULL, 'Scorpion toxin-like', 285981),
(475072, '0036460', NULL, NULL, 64, NULL, 'Scorpion toxin-like', 285981),
(475073, '0041144', NULL, NULL, 44, NULL, 'Scorpion toxin-like', 285981),
(475074, '0035055', NULL, NULL, 64, NULL, 'Scorpion toxin-like', 285981),
(475075, '0048979', NULL, NULL, 38, NULL, 'Scorpion toxin-like', 285981),
(475076, '0047205', NULL, NULL, 39, NULL, 'Scorpion toxin-like', 285981),
(475077, '0048338', NULL, NULL, 42, NULL, 'Scorpion toxin-like', 285981),
(475078, '0035605', NULL, NULL, 37, NULL, 'Scorpion toxin-like', 285981),
(475079, '0047293', NULL, NULL, 44, NULL, 'Scorpion toxin-like', 285981),
(475080, '0050661', NULL, NULL, 41, NULL, 'Scorpion toxin-like', 285981),
(475081, '0048069', NULL, NULL, 37, NULL, 'Scorpion toxin-like', 285981),
(475082, '0048221', NULL, NULL, 39, NULL, 'Scorpion toxin-like', 285981),
(475083, '0052009', NULL, NULL, 37, NULL, 'Scorpion toxin-like', 285981),
(475084, '0046080', NULL, NULL, 40, NULL, 'Scorpion toxin-like', 285981),
(475085, '0046804', NULL, NULL, 39, NULL, 'Scorpion toxin-like', 285981),
(475086, '0045915', NULL, NULL, 37, NULL, 'Scorpion toxin-like', 285981),
(475087, '0037581', NULL, NULL, 67, NULL, 'Scorpion toxin-like', 285981),
(475088, '0045871', NULL, NULL, 64, NULL, 'Scorpion toxin-like', 285981),
(475089, '0047973', NULL, NULL, 36, NULL, 'Scorpion toxin-like', 285981),
(475090, '0048744', NULL, NULL, 67, NULL, 'Scorpion toxin-like', 285981),
(475091, '0049513', NULL, NULL, 72, NULL, 'Scorpion toxin-like', 285981),
(475092, '0048422', NULL, NULL, 63, NULL, 'Scorpion toxin-like', 285981),
(475093, '0046400', NULL, NULL, 28, NULL, 'Scorpion toxin-like', 285981),
(475094, '0053171', NULL, NULL, 38, NULL, 'Scorpion toxin-like', 285981),
(475095, '0047977', NULL, NULL, 37, NULL, 'Scorpion toxin-like', 285981),
(475096, '0046006', NULL, NULL, 54, NULL, 'Scorpion toxin-like', 285981),
(475097, '0047615', NULL, NULL, 46, NULL, 'Scorpion toxin-like', 285981),
(475098, '0054629', NULL, NULL, 85, NULL, 'Ta0600-like', 285982),
(475099, '0054636', NULL, NULL, 88, NULL, 'Ta0600-like', 285982),
(475100, '0053951', NULL, NULL, 164, NULL, 'NMB0488-like', 285983),
(475101, '0048287', NULL, NULL, 38, NULL, 'Zinc finger domain of DNA polymerase-alpha', 285984),
(475102, '0043134', NULL, NULL, 214, NULL, 'Superantigen MAM', 285985),
(475103, '0052678', NULL, NULL, 83, NULL, 'TSP9-like', 285986),
(475104, '0044856', NULL, NULL, 433, NULL, 'Putative modulator of DNA gyrase, PmbA/TldD', 285987),
(475105, '0050267', NULL, NULL, 439, NULL, 'Putative modulator of DNA gyrase, PmbA/TldD', 285987),
(475106, '0040176', NULL, NULL, 129, NULL, 'HprK N-terminal domain-like', 285988),
(475107, '0054151', NULL, NULL, 120, NULL, 'HprK N-terminal domain-like', 285988),
(475108, '0040169', NULL, NULL, 132, NULL, 'HprK N-terminal domain-like', 285988),
(475109, '0052659', NULL, NULL, 92, NULL, 'AF2331-like', 285989);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(475110, '0048062', NULL, NULL, 110, NULL, 'Cell growth inhibitor/plasmid maintenance toxic component', 285990),
(475111, '0049849', NULL, NULL, 110, NULL, 'Cell growth inhibitor/plasmid maintenance toxic component', 285990),
(475112, '0048342', NULL, NULL, 116, NULL, 'Cell growth inhibitor/plasmid maintenance toxic component', 285990),
(475113, '0051725', NULL, NULL, 80, NULL, 'Cell growth inhibitor/plasmid maintenance toxic component', 285990),
(475114, '0053339', NULL, NULL, 101, NULL, 'Cell growth inhibitor/plasmid maintenance toxic component', 285990),
(475115, '0052331', NULL, NULL, 34, NULL, 'Plant lectins/antimicrobial peptides', 285991),
(475116, '0053387', NULL, NULL, 42, NULL, 'Plant lectins/antimicrobial peptides', 285991),
(475117, '0046560', NULL, NULL, 44, NULL, 'Plant lectins/antimicrobial peptides', 285991),
(475118, '0053385', NULL, NULL, 52, NULL, 'Plant lectins/antimicrobial peptides', 285991),
(475119, '0044360', NULL, NULL, 40, NULL, 'Plant lectins/antimicrobial peptides', 285991),
(475120, '0053386', NULL, NULL, 34, NULL, 'Plant lectins/antimicrobial peptides', 285991),
(475121, '0050534', NULL, NULL, 43, NULL, 'Plant lectins/antimicrobial peptides', 285991),
(475122, '0048191', NULL, NULL, 30, NULL, 'Plant lectins/antimicrobial peptides', 285991),
(475123, '0044428', NULL, NULL, 42, NULL, 'Plant lectins/antimicrobial peptides', 285991),
(475124, '0037003', NULL, NULL, 45, NULL, 'Plant lectins/antimicrobial peptides', 285991),
(475125, '0048717', NULL, NULL, 41, NULL, 'Plant lectins/antimicrobial peptides', 285991),
(475126, '0049904', NULL, NULL, 42, NULL, 'Plant lectins/antimicrobial peptides', 285991),
(475127, '0044429', NULL, NULL, 41, NULL, 'Plant lectins/antimicrobial peptides', 285991),
(475128, '0037095', NULL, NULL, 45, NULL, 'Plant lectins/antimicrobial peptides', 285991),
(475129, '0048909', NULL, NULL, 43, NULL, 'Plant lectins/antimicrobial peptides', 285991),
(475130, '0044430', NULL, NULL, 43, NULL, 'Plant lectins/antimicrobial peptides', 285991),
(475131, '0045674', NULL, NULL, 43, NULL, 'Plant lectins/antimicrobial peptides', 285991),
(475132, '0035838', NULL, NULL, 76, NULL, 'Ubiquitin-like', 285992),
(475133, '0050750', NULL, NULL, 76, NULL, 'Ubiquitin-like', 285992),
(475134, '0052254', NULL, NULL, 96, NULL, 'Ubiquitin-like', 285992),
(475135, '0048151', NULL, NULL, 78, NULL, 'Ubiquitin-like', 285992),
(475136, '0046493', NULL, NULL, 180, NULL, 'Ubiquitin-like', 285992),
(475137, '0050756', NULL, NULL, 93, NULL, 'Ubiquitin-like', 285992),
(475138, '0050757', NULL, NULL, 84, NULL, 'Ubiquitin-like', 285992),
(475139, '0050510', NULL, NULL, 104, NULL, 'Ubiquitin-like', 285992),
(475140, '0043625', NULL, NULL, 71, NULL, 'Ubiquitin-like', 285992),
(475141, '0039275', NULL, NULL, 76, NULL, 'Ubiquitin-like', 285992),
(475142, '0043828', NULL, NULL, 90, NULL, 'Ubiquitin-like', 285992),
(475143, '0050629', NULL, NULL, 100, NULL, 'Ubiquitin-like', 285992),
(475144, '0040559', NULL, NULL, 106, NULL, 'Ubiquitin-like', 285992),
(475145, '0044597', NULL, NULL, 105, NULL, 'Ubiquitin-like', 285992),
(475146, '0046537', NULL, NULL, 88, NULL, 'Ubiquitin-like', 285992),
(475147, '0046977', NULL, NULL, 81, NULL, 'Ubiquitin-like', 285992),
(475148, '0047942', NULL, NULL, 94, NULL, 'Ubiquitin-like', 285992),
(475149, '0046536', NULL, NULL, 84, NULL, 'Ubiquitin-like', 285992),
(475150, '0052069', NULL, NULL, 73, NULL, 'Ubiquitin-like', 285992),
(475151, '0049373', NULL, NULL, 101, NULL, 'Ubiquitin-like', 285992),
(475152, '0046062', NULL, NULL, 77, NULL, 'Ubiquitin-like', 285992),
(475153, '0049690', NULL, NULL, 80, NULL, 'Ubiquitin-like', 285992),
(475154, '0044282', NULL, NULL, 76, NULL, 'Ubiquitin-like', 285992),
(475155, '0050086', NULL, NULL, 95, NULL, 'Ubiquitin-like', 285992),
(475156, '0048122', NULL, NULL, 73, NULL, 'Ubiquitin-like', 285992),
(475157, '0038417', NULL, NULL, 84, NULL, 'Ubiquitin-like', 285992),
(475158, '0050524', NULL, NULL, 116, NULL, 'Ubiquitin-like', 285992),
(475159, '0050923', NULL, NULL, 75, NULL, 'Ubiquitin-like', 285992),
(475160, '0050488', NULL, NULL, 94, NULL, 'Ubiquitin-like', 285992);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(475161, '0050520', NULL, NULL, 93, NULL, 'Ubiquitin-like', 285992),
(475162, '0038854', NULL, NULL, 95, NULL, 'Ubiquitin-like', 285992),
(475163, '0050523', NULL, NULL, 96, NULL, 'Ubiquitin-like', 285992),
(475164, '0052269', NULL, NULL, 84, NULL, 'Ubiquitin-like', 285992),
(475165, '0053634', NULL, NULL, 83, NULL, 'Ubiquitin-like', 285992),
(475166, '0054766', NULL, NULL, 119, NULL, 'Ubiquitin-like', 285992),
(475167, '0037201', NULL, NULL, 79, NULL, 'Ubiquitin-like', 285992),
(475168, '0038176', NULL, NULL, 117, NULL, 'Ubiquitin-like', 285992),
(475169, '0048367', NULL, NULL, 86, NULL, 'Ubiquitin-like', 285992),
(475170, '0050055', NULL, NULL, 102, NULL, 'Ubiquitin-like', 285992),
(475171, '0052076', NULL, NULL, 116, NULL, 'Ubiquitin-like', 285992),
(475172, '0052075', NULL, NULL, 109, NULL, 'Ubiquitin-like', 285992),
(475173, '0050459', NULL, NULL, 111, NULL, 'Ubiquitin-like', 285992),
(475174, '0050579', NULL, NULL, 95, NULL, 'Ubiquitin-like', 285992),
(475175, '0051789', NULL, NULL, 76, NULL, 'Ubiquitin-like', 285992),
(475176, '0050736', NULL, NULL, 83, NULL, 'Ubiquitin-like', 285992),
(475177, '0050735', NULL, NULL, 94, NULL, 'Ubiquitin-like', 285992),
(475178, '0050532', NULL, NULL, 100, NULL, 'Ubiquitin-like', 285992),
(475179, '0050773', NULL, NULL, 94, NULL, 'Ubiquitin-like', 285992),
(475180, '0052632', NULL, NULL, 76, NULL, 'Ubiquitin-like', 285992),
(475181, '0046958', NULL, NULL, 87, NULL, 'Ubiquitin-like', 285992),
(475182, '0047969', NULL, NULL, 87, NULL, 'Ubiquitin-like', 285992),
(475183, '0050607', NULL, NULL, 124, NULL, 'Ubiquitin-like', 285992),
(475184, '0047488', NULL, NULL, 92, NULL, 'Ubiquitin-like', 285992),
(475185, '0048335', NULL, NULL, 74, NULL, 'Ubiquitin-like', 285992),
(475186, '0049903', NULL, NULL, 100, NULL, 'Ubiquitin-like', 285992),
(475187, '0051792', NULL, NULL, 100, NULL, 'Ubiquitin-like', 285992),
(475188, '0051476', NULL, NULL, 76, NULL, 'Ubiquitin-like', 285992),
(475189, '0050067', NULL, NULL, 95, NULL, 'Ubiquitin-like', 285992),
(475190, '0046482', NULL, NULL, 179, NULL, 'Ubiquitin-like', 285992),
(475191, '0049310', NULL, NULL, 118, NULL, 'Ubiquitin-like', 285992),
(475192, '0050460', NULL, NULL, 115, NULL, 'Ubiquitin-like', 285992),
(475193, '0053295', NULL, NULL, 97, NULL, 'Ubiquitin-like', 285992),
(475194, '0043295', NULL, NULL, 90, NULL, 'Ubiquitin-like', 285992),
(475195, '0050543', NULL, NULL, 87, NULL, 'Ubiquitin-like', 285992),
(475196, '0050620', NULL, NULL, 97, NULL, 'Ubiquitin-like', 285992),
(475197, '0050740', NULL, NULL, 73, NULL, 'Ubiquitin-like', 285992),
(475198, '0051477', NULL, NULL, 76, NULL, 'Ubiquitin-like', 285992),
(475199, '0037105', NULL, NULL, 116, NULL, 'Ubiquitin-like', 285992),
(475200, '0050743', NULL, NULL, 81, NULL, 'Ubiquitin-like', 285992),
(475201, '0045716', NULL, NULL, 103, NULL, 'Ubiquitin-like', 285992),
(475202, '0038476', NULL, NULL, 82, NULL, 'Ubiquitin-like', 285992),
(475203, '0044307', NULL, NULL, 95, NULL, 'Ubiquitin-like', 285992),
(475204, '0042200', NULL, NULL, 78, NULL, 'Ubiquitin-like', 285992),
(475205, '0050738', NULL, NULL, 103, NULL, 'Ubiquitin-like', 285992),
(475206, '0044629', NULL, NULL, 90, NULL, 'Ubiquitin-like', 285992),
(475207, '0050539', NULL, NULL, 104, NULL, 'Ubiquitin-like', 285992),
(475208, '0050737', NULL, NULL, 73, NULL, 'Ubiquitin-like', 285992),
(475209, '0047534', NULL, NULL, 103, NULL, 'Ubiquitin-like', 285992),
(475210, '0046009', NULL, NULL, 73, NULL, 'Ubiquitin-like', 285992),
(475211, '0042666', NULL, NULL, 212, NULL, 'Transmembrane di-heme cytochromes', 285993),
(475212, '0035490', NULL, NULL, 260, NULL, 'Transmembrane di-heme cytochromes', 285993),
(475213, '0047858', NULL, NULL, 216, NULL, 'Transmembrane di-heme cytochromes', 285993),
(475214, '0037290', NULL, NULL, 261, NULL, 'Transmembrane di-heme cytochromes', 285993),
(475215, '0035453', NULL, NULL, 260, NULL, 'Transmembrane di-heme cytochromes', 285993),
(475216, '0044720', NULL, NULL, 202, NULL, 'Transmembrane di-heme cytochromes', 285993),
(475217, '0042710', NULL, NULL, 116, NULL, 'Cdc48 domain 2-like', 285994);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(475218, '0036123', NULL, NULL, 103, NULL, 'Cdc48 domain 2-like', 285994),
(475219, '0036202', NULL, NULL, 94, NULL, 'Cdc48 domain 2-like', 285994),
(475220, '0036730', NULL, NULL, 94, NULL, 'Cdc48 domain 2-like', 285994),
(475221, '0044984', NULL, NULL, 80, NULL, 'Cdc48 domain 2-like', 285994),
(475222, '0041462', NULL, NULL, 247, NULL, 'NIF3 (NGG1p interacting factor 3)-like', 285995),
(475223, '0052808', NULL, NULL, 265, NULL, 'NIF3 (NGG1p interacting factor 3)-like', 285995),
(475224, '0052969', NULL, NULL, 370, NULL, 'NIF3 (NGG1p interacting factor 3)-like', 285995),
(475225, '0048284', NULL, NULL, 249, NULL, 'Triosephosphate isomerase (TIM)', 285996),
(475226, '0049592', NULL, NULL, 248, NULL, 'Triosephosphate isomerase (TIM)', 285996),
(475227, '0049680', NULL, NULL, 255, NULL, 'Triosephosphate isomerase (TIM)', 285996),
(475228, '0052045', NULL, NULL, 251, NULL, 'Triosephosphate isomerase (TIM)', 285996),
(475229, '0053375', NULL, NULL, 247, NULL, 'Triosephosphate isomerase (TIM)', 285996),
(475230, '0048198', NULL, NULL, 257, NULL, 'Triosephosphate isomerase (TIM)', 285996),
(475231, '0051284', NULL, NULL, 246, NULL, 'Triosephosphate isomerase (TIM)', 285996),
(475232, '0045908', NULL, NULL, 252, NULL, 'Triosephosphate isomerase (TIM)', 285996),
(475233, '0035234', NULL, NULL, 255, NULL, 'Triosephosphate isomerase (TIM)', 285996),
(475234, '0038583', NULL, NULL, 224, NULL, 'Triosephosphate isomerase (TIM)', 285996),
(475235, '0044928', NULL, NULL, 226, NULL, 'Triosephosphate isomerase (TIM)', 285996),
(475236, '0049668', NULL, NULL, 250, NULL, 'Triosephosphate isomerase (TIM)', 285996),
(475237, '0047237', NULL, NULL, 248, NULL, 'Triosephosphate isomerase (TIM)', 285996),
(475238, '0048109', NULL, NULL, 260, NULL, 'Triosephosphate isomerase (TIM)', 285996),
(475239, '0049669', NULL, NULL, 245, NULL, 'Triosephosphate isomerase (TIM)', 285996),
(475240, '0036908', NULL, NULL, 305, NULL, 'Replication terminator protein (Tus)', 285997),
(475241, '0051988', NULL, NULL, 179, NULL, 'MFPT repeat-like', 285998),
(475242, '0051987', NULL, NULL, 170, NULL, 'MFPT repeat-like', 285998),
(475243, '0051989', NULL, NULL, 184, NULL, 'MFPT repeat-like', 285998),
(475244, '0051986', NULL, NULL, 170, NULL, 'MFPT repeat-like', 285998),
(475245, '0042258', NULL, NULL, 205, NULL, 'Osmotin, thaumatin-like protein', 285999),
(475246, '0035208', NULL, NULL, 208, NULL, 'Osmotin, thaumatin-like protein', 285999),
(475247, '0049235', NULL, NULL, 207, NULL, 'Osmotin, thaumatin-like protein', 285999),
(475248, '0036603', NULL, NULL, 206, NULL, 'Osmotin, thaumatin-like protein', 285999),
(475249, '0044778', NULL, NULL, 55, NULL, 'Neurotoxin B-IV', 286000),
(475250, '0045179', NULL, NULL, 40, NULL, 'Amb V allergen', 286001),
(475251, '0048371', NULL, NULL, 88, NULL, 'MesJ substrate recognition domain-like', 286002),
(475252, '0050747', NULL, NULL, 95, NULL, 'MesJ substrate recognition domain-like', 286002),
(475253, '0051122', NULL, NULL, 246, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475254, '0054633', NULL, NULL, 233, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475255, '0043281', NULL, NULL, 252, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475256, '0048850', NULL, NULL, 233, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475257, '0039913', NULL, NULL, 244, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475258, '0035697', NULL, NULL, 251, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475259, '0050898', NULL, NULL, 235, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475260, '0042270', NULL, NULL, 230, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475261, '0042191', NULL, NULL, 244, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475262, '0034841', NULL, NULL, 251, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475263, '0038502', NULL, NULL, 224, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475264, '0036469', NULL, NULL, 235, NULL, 'Nuclear receptor ligand-binding domain', 286003);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(475265, '0038584', NULL, NULL, 265, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475266, '0042831', NULL, NULL, 241, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475267, '0042832', NULL, NULL, 236, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475268, '0045306', NULL, NULL, 266, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475269, '0037497', NULL, NULL, 236, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475270, '0040276', NULL, NULL, 222, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475271, '0042011', NULL, NULL, 229, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475272, '0045508', NULL, NULL, 246, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475273, '0039072', NULL, NULL, 290, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475274, '0042350', NULL, NULL, 242, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475275, '0045026', NULL, NULL, 235, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475276, '0045423', NULL, NULL, 271, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475277, '0040676', NULL, NULL, 229, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475278, '0043092', NULL, NULL, 243, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475279, '0037904', NULL, NULL, 256, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475280, '0039946', NULL, NULL, 267, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475281, '0038857', NULL, NULL, 246, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475282, '0041290', NULL, NULL, 263, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475283, '0051039', NULL, NULL, 232, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475284, '0037660', NULL, NULL, 232, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475285, '0041397', NULL, NULL, 247, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475286, '0036330', NULL, NULL, 253, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475287, '0041251', NULL, NULL, 251, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475288, '0042042', NULL, NULL, 265, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475289, '0044364', NULL, NULL, 240, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475290, '0042006', NULL, NULL, 231, NULL, 'Nuclear receptor ligand-binding domain', 286003),
(475291, '0041788', NULL, NULL, 43, NULL, 'Mitochondrial cytochrome c oxidase subunit VIIIb (aka IX)', 286004),
(475292, '0040981', NULL, NULL, 59, NULL, 'Midkine', 286005),
(475293, '0040974', NULL, NULL, 43, NULL, 'Midkine', 286005),
(475294, '0041015', NULL, NULL, 85, NULL, 'SRF-like', 286006),
(475295, '0041235', NULL, NULL, 93, NULL, 'SRF-like', 286006),
(475296, '0043734', NULL, NULL, 84, NULL, 'SRF-like', 286006),
(475297, '0036996', NULL, NULL, 71, NULL, 'SRF-like', 286006),
(475298, '0036704', NULL, NULL, 239, NULL, 'Family A G protein-coupled receptor-like', 286007),
(475299, '0037432', NULL, NULL, 348, NULL, 'Family A G protein-coupled receptor-like', 286007),
(475300, '0050980', NULL, NULL, 226, NULL, 'Family A G protein-coupled receptor-like', 286007),
(475301, '0035839', NULL, NULL, 222, NULL, 'Family A G protein-coupled receptor-like', 286007),
(475302, '0035878', NULL, NULL, 196, NULL, 'Family A G protein-coupled receptor-like', 286007),
(475303, '0047106', NULL, NULL, 225, NULL, 'Family A G protein-coupled receptor-like', 286007),
(475304, '0044248', NULL, NULL, 236, NULL, 'Family A G protein-coupled receptor-like', 286007),
(475305, '0053709', NULL, NULL, 447, NULL, 'Photosystem II antenna protein-like', 286008),
(475306, '0053708', NULL, NULL, 488, NULL, 'Photosystem II antenna protein-like', 286008),
(475307, '0034902', NULL, NULL, 172, NULL, 'Positive stranded ssRNA viruses', 286009),
(475308, '0034903', NULL, NULL, 165, NULL, 'Positive stranded ssRNA viruses', 286009),
(475309, '0034901', NULL, NULL, 176, NULL, 'Positive stranded ssRNA viruses', 286009),
(475310, '0049085', NULL, NULL, 238, NULL, 'Positive stranded ssRNA viruses', 286009);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(475311, '0050430', NULL, NULL, 421, NULL, 'Positive stranded ssRNA viruses', 286009),
(475312, '0047145', NULL, NULL, 289, NULL, 'Positive stranded ssRNA viruses', 286009),
(475313, '0048795', NULL, NULL, 340, NULL, 'Positive stranded ssRNA viruses', 286009),
(475314, '0049167', NULL, NULL, 273, NULL, 'Positive stranded ssRNA viruses', 286009),
(475315, '0049166', NULL, NULL, 299, NULL, 'Positive stranded ssRNA viruses', 286009),
(475316, '0050118', NULL, NULL, 196, NULL, 'Positive stranded ssRNA viruses', 286009),
(475317, '0049084', NULL, NULL, 283, NULL, 'Positive stranded ssRNA viruses', 286009),
(475318, '0053349', NULL, NULL, 222, NULL, 'Positive stranded ssRNA viruses', 286009),
(475319, '0035877', NULL, NULL, 219, NULL, 'Positive stranded ssRNA viruses', 286009),
(475320, '0049083', NULL, NULL, 273, NULL, 'Positive stranded ssRNA viruses', 286009),
(475321, '0046813', NULL, NULL, 219, NULL, 'Positive stranded ssRNA viruses', 286009),
(475322, '0045603', NULL, NULL, 236, NULL, 'Positive stranded ssRNA viruses', 286009),
(475323, '0036089', NULL, NULL, 323, NULL, 'Positive stranded ssRNA viruses', 286009),
(475324, '0053183', NULL, NULL, 231, NULL, 'Positive stranded ssRNA viruses', 286009),
(475325, '0039030', NULL, NULL, 492, NULL, 'Positive stranded ssRNA viruses', 286009),
(475326, '0046730', NULL, NULL, 396, NULL, 'Positive stranded ssRNA viruses', 286009),
(475327, '0053182', NULL, NULL, 268, NULL, 'Positive stranded ssRNA viruses', 286009),
(475328, '0041965', NULL, NULL, 267, NULL, 'Positive stranded ssRNA viruses', 286009),
(475329, '0040435', NULL, NULL, 174, NULL, 'Positive stranded ssRNA viruses', 286009),
(475330, '0046812', NULL, NULL, 290, NULL, 'Positive stranded ssRNA viruses', 286009),
(475331, '0045602', NULL, NULL, 273, NULL, 'Positive stranded ssRNA viruses', 286009),
(475332, '0045843', NULL, NULL, 238, NULL, 'Positive stranded ssRNA viruses', 286009),
(475333, '0035628', NULL, NULL, 189, NULL, 'Positive stranded ssRNA viruses', 286009),
(475334, '0035627', NULL, NULL, 182, NULL, 'Positive stranded ssRNA viruses', 286009),
(475335, '0047671', NULL, NULL, 189, NULL, 'Positive stranded ssRNA viruses', 286009),
(475336, '0037206', NULL, NULL, 317, NULL, 'Positive stranded ssRNA viruses', 286009),
(475337, '0041051', NULL, NULL, 271, NULL, 'Positive stranded ssRNA viruses', 286009),
(475338, '0041491', NULL, NULL, 348, NULL, 'Positive stranded ssRNA viruses', 286009),
(475339, '0037207', NULL, NULL, 281, NULL, 'Positive stranded ssRNA viruses', 286009),
(475340, '0035267', NULL, NULL, 285, NULL, 'Positive stranded ssRNA viruses', 286009),
(475341, '0035266', NULL, NULL, 297, NULL, 'Positive stranded ssRNA viruses', 286009),
(475342, '0037726', NULL, NULL, 293, NULL, 'Positive stranded ssRNA viruses', 286009),
(475343, '0035504', NULL, NULL, 268, NULL, 'Positive stranded ssRNA viruses', 286009),
(475344, '0035503', NULL, NULL, 285, NULL, 'Positive stranded ssRNA viruses', 286009),
(475345, '0037325', NULL, NULL, 190, NULL, 'Positive stranded ssRNA viruses', 286009),
(475346, '0038778', NULL, NULL, 297, NULL, 'Positive stranded ssRNA viruses', 286009),
(475347, '0046506', NULL, NULL, 331, NULL, 'Positive stranded ssRNA viruses', 286009),
(475348, '0045812', NULL, NULL, 235, NULL, 'Positive stranded ssRNA viruses', 286009),
(475349, '0046307', NULL, NULL, 188, NULL, 'Positive stranded ssRNA viruses', 286009),
(475350, '0046508', NULL, NULL, 235, NULL, 'Positive stranded ssRNA viruses', 286009),
(475351, '0046507', NULL, NULL, 278, NULL, 'Positive stranded ssRNA viruses', 286009),
(475352, '0041373', NULL, NULL, 218, NULL, 'Positive stranded ssRNA viruses', 286009),
(475353, '0043670', NULL, NULL, 222, NULL, 'Positive stranded ssRNA viruses', 286009),
(475354, '0049018', NULL, NULL, 220, NULL, 'Positive stranded ssRNA viruses', 286009),
(475355, '0049656', NULL, NULL, 232, NULL, 'Positive stranded ssRNA viruses', 286009),
(475356, '0041857', NULL, NULL, 600, NULL, 'Positive stranded ssRNA viruses', 286009),
(475357, '0049017', NULL, NULL, 210, NULL, 'Positive stranded ssRNA viruses', 286009);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(475358, '0049655', NULL, NULL, 256, NULL, 'Positive stranded ssRNA viruses', 286009),
(475359, '0048329', NULL, NULL, 296, NULL, 'Positive stranded ssRNA viruses', 286009),
(475360, '0042940', NULL, NULL, 290, NULL, 'Positive stranded ssRNA viruses', 286009),
(475361, '0046193', NULL, NULL, 238, NULL, 'Positive stranded ssRNA viruses', 286009),
(475362, '0046192', NULL, NULL, 269, NULL, 'Positive stranded ssRNA viruses', 286009),
(475363, '0046272', NULL, NULL, 238, NULL, 'Positive stranded ssRNA viruses', 286009),
(475364, '0045183', NULL, NULL, 344, NULL, 'Positive stranded ssRNA viruses', 286009),
(475365, '0046271', NULL, NULL, 284, NULL, 'Positive stranded ssRNA viruses', 286009),
(475366, '0044050', NULL, NULL, 281, NULL, 'Positive stranded ssRNA viruses', 286009),
(475367, '0041619', NULL, NULL, 182, NULL, 'Positive stranded ssRNA viruses', 286009),
(475368, '0044053', NULL, NULL, 299, NULL, 'Positive stranded ssRNA viruses', 286009),
(475369, '0044054', NULL, NULL, 276, NULL, 'Positive stranded ssRNA viruses', 286009),
(475370, '0036267', NULL, NULL, 322, NULL, 'Positive stranded ssRNA viruses', 286009),
(475371, '0045868', NULL, NULL, 260, NULL, 'Positive stranded ssRNA viruses', 286009),
(475372, '0041620', NULL, NULL, 187, NULL, 'Positive stranded ssRNA viruses', 286009),
(475373, '0045944', NULL, NULL, 242, NULL, 'Positive stranded ssRNA viruses', 286009),
(475374, '0037354', NULL, NULL, 212, NULL, 'Positive stranded ssRNA viruses', 286009),
(475375, '0045869', NULL, NULL, 255, NULL, 'Positive stranded ssRNA viruses', 286009),
(475376, '0045827', NULL, NULL, 189, NULL, 'Positive stranded ssRNA viruses', 286009),
(475377, '0038482', NULL, NULL, 321, NULL, 'Positive stranded ssRNA viruses', 286009),
(475378, '0038484', NULL, NULL, 238, NULL, 'Positive stranded ssRNA viruses', 286009),
(475379, '0045464', NULL, NULL, 321, NULL, 'Positive stranded ssRNA viruses', 286009),
(475380, '0045983', NULL, NULL, 185, NULL, 'Positive stranded ssRNA viruses', 286009),
(475381, '0048972', NULL, NULL, 179, NULL, 'Positive stranded ssRNA viruses', 286009),
(475382, '0048616', NULL, NULL, 238, NULL, 'Positive stranded ssRNA viruses', 286009),
(475383, '0043246', NULL, NULL, 236, NULL, 'Positive stranded ssRNA viruses', 286009),
(475384, '0046636', NULL, NULL, 239, NULL, 'Positive stranded ssRNA viruses', 286009),
(475385, '0037664', NULL, NULL, 207, NULL, 'Positive stranded ssRNA viruses', 286009),
(475386, '0035327', NULL, NULL, 340, NULL, 'Positive stranded ssRNA viruses', 286009),
(475387, '0036176', NULL, NULL, 149, NULL, 'Positive stranded ssRNA viruses', 286009),
(475388, '0048466', NULL, NULL, 189, NULL, 'Positive stranded ssRNA viruses', 286009),
(475389, '0042484', NULL, NULL, 335, NULL, 'Positive stranded ssRNA viruses', 286009),
(475390, '0041955', NULL, NULL, 271, NULL, 'Positive stranded ssRNA viruses', 286009),
(475391, '0042485', NULL, NULL, 279, NULL, 'Positive stranded ssRNA viruses', 286009),
(475392, '0046843', NULL, NULL, 269, NULL, 'Positive stranded ssRNA viruses', 286009),
(475393, '0041954', NULL, NULL, 321, NULL, 'Positive stranded ssRNA viruses', 286009),
(475394, '0042486', NULL, NULL, 235, NULL, 'Positive stranded ssRNA viruses', 286009),
(475395, '0045357', NULL, NULL, 308, NULL, 'Positive stranded ssRNA viruses', 286009),
(475396, '0046844', NULL, NULL, 237, NULL, 'Positive stranded ssRNA viruses', 286009),
(475397, '0046490', NULL, NULL, 268, NULL, 'FAD-binding/transporter-associated domain-like', 286010),
(475398, '0054456', NULL, NULL, 98, NULL, 'FAD-binding/transporter-associated domain-like', 286010),
(475399, '0047282', NULL, NULL, 217, NULL, 'FAD-binding/transporter-associated domain-like', 286010),
(475400, '0054353', NULL, NULL, 87, NULL, 'FAD-binding/transporter-associated domain-like', 286010),
(475401, '0046672', NULL, NULL, 265, NULL, 'FAD-binding/transporter-associated domain-like', 286010),
(475402, '0054450', NULL, NULL, 85, NULL, 'FAD-binding/transporter-associated domain-like', 286010),
(475403, '0054639', NULL, NULL, 84, NULL, 'FAD-binding/transporter-associated domain-like', 286010);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(475404, '0054318', NULL, NULL, 78, NULL, 'FAD-binding/transporter-associated domain-like', 286010),
(475405, '0050017', NULL, NULL, 198, NULL, 'FAD-binding/transporter-associated domain-like', 286010),
(475406, '0054932', NULL, NULL, 87, NULL, 'FAD-binding/transporter-associated domain-like', 286010),
(475407, '0054678', NULL, NULL, 84, NULL, 'FAD-binding/transporter-associated domain-like', 286010),
(475408, '0041229', NULL, NULL, 177, NULL, 'FAD-binding/transporter-associated domain-like', 286010),
(475409, '0043862', NULL, NULL, 176, NULL, 'FAD-binding/transporter-associated domain-like', 286010),
(475410, '0049208', NULL, NULL, 216, NULL, 'FAD-binding/transporter-associated domain-like', 286010),
(475411, '0044931', NULL, NULL, 206, NULL, 'FAD-binding/transporter-associated domain-like', 286010),
(475412, '0046342', NULL, NULL, 236, NULL, 'FAD-binding/transporter-associated domain-like', 286010),
(475413, '0047231', NULL, NULL, 194, NULL, 'FAD-binding/transporter-associated domain-like', 286010),
(475414, '0054286', NULL, NULL, 87, NULL, 'FAD-binding/transporter-associated domain-like', 286010),
(475415, '0037703', NULL, NULL, 223, NULL, 'FAD-binding/transporter-associated domain-like', 286010),
(475416, '0039727', NULL, NULL, 167, NULL, 'FAD-binding/transporter-associated domain-like', 286010),
(475417, '0037565', NULL, NULL, 177, NULL, 'FAD-binding/transporter-associated domain-like', 286010),
(475418, '0054328', NULL, NULL, 76, NULL, 'FAD-binding/transporter-associated domain-like', 286010),
(475419, '0054525', NULL, NULL, 84, NULL, 'FAD-binding/transporter-associated domain-like', 286010),
(475420, '0054524', NULL, NULL, 84, NULL, 'FAD-binding/transporter-associated domain-like', 286010),
(475421, '0054460', NULL, NULL, 82, NULL, 'FAD-binding/transporter-associated domain-like', 286010),
(475422, '0040648', NULL, NULL, 59, NULL, 'TSP-1 type 1 repeat', 286011),
(475423, '0040647', NULL, NULL, 54, NULL, 'TSP-1 type 1 repeat', 286011),
(475424, '0053262', NULL, NULL, 115, NULL, 'DOPA-like', 286012),
(475425, '0052981', NULL, NULL, 187, NULL, 'VC0467-like', 286013),
(475426, '0052480', NULL, NULL, 186, NULL, 'VC0467-like', 286013),
(475427, '0052527', NULL, NULL, 175, NULL, 'VC0467-like', 286013),
(475428, '0052942', NULL, NULL, 193, NULL, 'VC0467-like', 286013),
(475429, '0052995', NULL, NULL, 178, NULL, 'VC0467-like', 286013),
(475430, '0037144', NULL, NULL, 38, NULL, 'Protozoan pheromone proteins', 286014),
(475431, '0038541', NULL, NULL, 37, NULL, 'Protozoan pheromone proteins', 286014),
(475432, '0037141', NULL, NULL, 40, NULL, 'Protozoan pheromone proteins', 286014),
(475433, '0045263', NULL, NULL, 40, NULL, 'Protozoan pheromone proteins', 286014),
(475434, '0037147', NULL, NULL, 39, NULL, 'Protozoan pheromone proteins', 286014),
(475435, '0047850', NULL, NULL, 79, NULL, 'Killer toxin KP6 alpha-subunit', 286015),
(475436, '0053221', NULL, NULL, 405, NULL, 'Proton glutamate symport protein', 286016),
(475437, '0036041', NULL, NULL, 138, NULL, 'Core binding factor beta, CBF', 286017),
(475438, '0037205', NULL, NULL, 58, NULL, 'Cell division protein MinE topological specificity domain', 286018),
(475439, '0052593', NULL, NULL, 176, NULL, 'TM0957-like', 286019),
(475440, '0046280', NULL, NULL, 720, NULL, 'Malate synthase G', 286020),
(475441, '0048297', NULL, NULL, 726, NULL, 'Malate synthase G', 286020),
(475442, '0039967', NULL, NULL, 164, NULL, 'Arp2/3 complex subunits', 286021),
(475443, '0039969', NULL, NULL, 167, NULL, 'Arp2/3 complex subunits', 286021),
(475444, '0039966', NULL, NULL, 120, NULL, 'Arp2/3 complex subunits', 286021),
(475445, '0045384', NULL, NULL, 136, NULL, 'Regulatory factor Nef', 286022),
(475446, '0036963', NULL, NULL, 133, NULL, 'Regulatory factor Nef', 286022),
(475447, '0038025', NULL, NULL, 137, NULL, 'Fertilization protein', 286023),
(475448, '0053178', NULL, NULL, 131, NULL, 'Fertilization protein', 286023),
(475449, '0045536', NULL, NULL, 122, NULL, 'Fertilization protein', 286023),
(475450, '0053482', NULL, NULL, 110, NULL, 'Tumor suppressor gene product Apc', 286024);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(475451, '0052673', NULL, NULL, 309, NULL, 'CofD-like', 286025),
(475452, '0053061', NULL, NULL, 311, NULL, 'CofD-like', 286025),
(475453, '0047961', NULL, NULL, 276, NULL, 'Cullin homology domain', 286026),
(475454, '0054071', NULL, NULL, 273, NULL, 'Cullin homology domain', 286026),
(475455, '0046351', NULL, NULL, 118, NULL, 'Heat shock protein 70kD (HSP70), peptide-binding domain', 286027),
(475456, '0049751', NULL, NULL, 115, NULL, 'Heat shock protein 70kD (HSP70), peptide-binding domain', 286027),
(475457, '0036037', NULL, NULL, 159, NULL, 'Heat shock protein 70kD (HSP70), peptide-binding domain', 286027),
(475458, '0045584', NULL, NULL, 359, NULL, 'Bacteriochlorophyll A protein', 286028),
(475459, '0040236', NULL, NULL, 357, NULL, 'Bacteriochlorophyll A protein', 286028),
(475460, '0041783', NULL, NULL, 84, NULL, 'Mitochondrial cytochrome c oxidase subunit VIa', 286029),
(475461, '0036773', NULL, NULL, 56, NULL, 'C-terminal UvrC-binding domain of UvrB', 286030),
(475462, '0051018', NULL, NULL, 232, NULL, 'RNA-binding protein She2p', 286031),
(475463, '0054010', NULL, NULL, 251, NULL, 'Dhaf3308-like', 286032),
(475464, '0038420', NULL, NULL, 111, NULL, 'SpoIIaa-like', 286033),
(475465, '0054576', NULL, NULL, 125, NULL, 'SpoIIaa-like', 286033),
(475466, '0054398', NULL, NULL, 125, NULL, 'SpoIIaa-like', 286033),
(475467, '0044690', NULL, NULL, 110, NULL, 'SpoIIaa-like', 286033),
(475468, '0035218', NULL, NULL, 116, NULL, 'SpoIIaa-like', 286033),
(475469, '0044005', NULL, NULL, 115, NULL, 'SpoIIaa-like', 286033),
(475470, '0051652', NULL, NULL, 174, NULL, 'Allene oxide cyclase-like', 286034),
(475471, '0051526', NULL, NULL, 174, NULL, 'Allene oxide cyclase-like', 286034),
(475472, '0037314', NULL, NULL, 180, NULL, 'Diphtheria toxin, middle domain', 286035),
(475473, '0054542', NULL, NULL, 296, NULL, 'YerB-like', 286036),
(475474, '0043715', NULL, NULL, 427, NULL, 'Oligoxyloglucan reducing end-specific cellobiohydrolase', 286037),
(475475, '0049445', NULL, NULL, 356, NULL, 'Oligoxyloglucan reducing end-specific cellobiohydrolase', 286037),
(475476, '0049526', NULL, NULL, 68, NULL, 'FGAM synthase PurL, linker domain', 286038),
(475477, '0037026', NULL, NULL, 111, NULL, 'Hypothetical protein MTH538', 286039),
(475478, '0048507', NULL, NULL, 82, NULL, 'Tp47 lipoprotein, middle and C-terminal domains', 286040),
(475479, '0048506', NULL, NULL, 126, NULL, 'Tp47 lipoprotein, middle and C-terminal domains', 286040),
(475480, '0040732', NULL, NULL, 81, NULL, 'N-utilization substance G protein NusG, insert domain', 286041),
(475481, '0048938', NULL, NULL, 61, NULL, 'TGS-like', 286042),
(475482, '0048468', NULL, NULL, 59, NULL, 'TGS-like', 286042),
(475483, '0048368', NULL, NULL, 82, NULL, 'TGS-like', 286042),
(475484, '0047548', NULL, NULL, 85, NULL, 'TGS-like', 286042),
(475485, '0050742', NULL, NULL, 76, NULL, 'TGS-like', 286042),
(475486, '0044748', NULL, NULL, 413, NULL, 'Stabilizer of iron transporter SufD', 286043),
(475487, '0053167', NULL, NULL, 132, NULL, 'Regulator of G-protein signaling, RGS', 286044),
(475488, '0036068', NULL, NULL, 128, NULL, 'Regulator of G-protein signaling, RGS', 286044),
(475489, '0035044', NULL, NULL, 128, NULL, 'Regulator of G-protein signaling, RGS', 286044),
(475490, '0041925', NULL, NULL, 157, NULL, 'Regulator of G-protein signaling, RGS', 286044),
(475491, '0054140', NULL, NULL, 116, NULL, 'Regulator of G-protein signaling, RGS', 286044),
(475492, '0036467', NULL, NULL, 147, NULL, 'Regulator of G-protein signaling, RGS', 286044),
(475493, '0037735', NULL, NULL, 138, NULL, 'Regulator of G-protein signaling, RGS', 286044),
(475494, '0038715', NULL, NULL, 182, NULL, 'Regulator of G-protein signaling, RGS', 286044),
(475495, '0038947', NULL, NULL, 190, NULL, 'Regulator of G-protein signaling, RGS', 286044),
(475496, '0041272', NULL, NULL, 343, NULL, 'P40 nucleoprotein', 286045),
(475497, '0036391', NULL, NULL, 159, NULL, 'Calpain large subunit, middle domain (domain III)', 286046),
(475498, '0040065', NULL, NULL, 159, NULL, 'Calpain large subunit, middle domain (domain III)', 286046);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(475499, '0043036', NULL, NULL, 159, NULL, 'Calpain large subunit, middle domain (domain III)', 286046),
(475500, '0042910', NULL, NULL, 302, NULL, 'Bacterial photosystem II reaction centre, L and M subunits', 286047),
(475501, '0037267', NULL, NULL, 280, NULL, 'Bacterial photosystem II reaction centre, L and M subunits', 286047),
(475502, '0036661', NULL, NULL, 323, NULL, 'Bacterial photosystem II reaction centre, L and M subunits', 286047),
(475503, '0036660', NULL, NULL, 273, NULL, 'Bacterial photosystem II reaction centre, L and M subunits', 286047),
(475504, '0053707', NULL, NULL, 335, NULL, 'Bacterial photosystem II reaction centre, L and M subunits', 286047),
(475505, '0037268', NULL, NULL, 318, NULL, 'Bacterial photosystem II reaction centre, L and M subunits', 286047),
(475506, '0042909', NULL, NULL, 281, NULL, 'Bacterial photosystem II reaction centre, L and M subunits', 286047),
(475507, '0053710', NULL, NULL, 340, NULL, 'Bacterial photosystem II reaction centre, L and M subunits', 286047),
(475508, '0053574', NULL, NULL, 147, NULL, 'Sec2 N-terminal region', 286048),
(475509, '0048831', NULL, NULL, 36, NULL, 'Hypothetical protein Ta0289 C-terminal domain', 286049),
(475510, '0052636', NULL, NULL, 201, NULL, 'YojJ-like', 286050),
(475511, '0040793', NULL, NULL, 100, NULL, 'Cytochrome c oxidase subunit II-like, transmembrane region', 286051),
(475512, '0053245', NULL, NULL, 90, NULL, 'Cytochrome c oxidase subunit II-like, transmembrane region', 286051),
(475513, '0037008', NULL, NULL, 38, NULL, 'Cytochrome c oxidase subunit II-like, transmembrane region', 286051),
(475514, '0037558', NULL, NULL, 91, NULL, 'Cytochrome c oxidase subunit II-like, transmembrane region', 286051),
(475515, '0035180', NULL, NULL, 107, NULL, 'Cytochrome c oxidase subunit II-like, transmembrane region', 286051),
(475516, '0052385', NULL, NULL, 119, NULL, 'PUG domain-like', 286052),
(475517, '0054411', NULL, NULL, 90, NULL, 'HupF/HypC-like', 286053),
(475518, '0054759', NULL, NULL, 71, NULL, 'HupF/HypC-like', 286053),
(475519, '0054921', NULL, NULL, 76, NULL, 'HupF/HypC-like', 286053),
(475520, '0054149', NULL, NULL, 198, NULL, 'YmcC-like', 286054),
(475521, '0054003', NULL, NULL, 115, NULL, 'Ribosomal protein L20', 286055),
(475522, '0054785', NULL, NULL, 117, NULL, 'Ribosomal protein L20', 286055),
(475523, '0054184', NULL, NULL, 117, NULL, 'Ribosomal protein L20', 286055),
(475524, '0038337', NULL, NULL, 60, NULL, 'Ribosomal protein L20', 286055),
(475525, '0051145', NULL, NULL, 135, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475526, '0049444', NULL, NULL, 210, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475527, '0049443', NULL, NULL, 149, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475528, '0051065', NULL, NULL, 113, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475529, '0049683', NULL, NULL, 129, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475530, '0054513', NULL, NULL, 111, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475531, '0046737', NULL, NULL, 135, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475532, '0044219', NULL, NULL, 134, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475533, '0036022', NULL, NULL, 203, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475534, '0047984', NULL, NULL, 131, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475535, '0049800', NULL, NULL, 156, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475536, '0047985', NULL, NULL, 156, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475537, '0052095', NULL, NULL, 139, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(475538, '0046159', NULL, NULL, 150, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475539, '0048015', NULL, NULL, 134, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475540, '0048412', NULL, NULL, 140, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475541, '0049803', NULL, NULL, 137, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475542, '0048855', NULL, NULL, 212, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475543, '0049725', NULL, NULL, 137, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475544, '0039909', NULL, NULL, 190, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475545, '0053079', NULL, NULL, 115, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475546, '0046043', NULL, NULL, 122, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475547, '0047893', NULL, NULL, 132, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475548, '0049036', NULL, NULL, 122, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475549, '0046683', NULL, NULL, 176, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475550, '0046682', NULL, NULL, 146, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475551, '0049133', NULL, NULL, 130, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475552, '0051635', NULL, NULL, 170, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475553, '0051634', NULL, NULL, 144, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475554, '0043737', NULL, NULL, 149, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475555, '0047830', NULL, NULL, 128, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475556, '0046684', NULL, NULL, 144, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475557, '0048964', NULL, NULL, 176, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475558, '0049436', NULL, NULL, 396, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475559, '0049535', NULL, NULL, 199, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475560, '0047894', NULL, NULL, 156, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475561, '0049435', NULL, NULL, 224, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475562, '0049534', NULL, NULL, 163, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475563, '0046521', NULL, NULL, 120, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475564, '0049434', NULL, NULL, 172, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475565, '0048208', NULL, NULL, 145, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475566, '0048209', NULL, NULL, 162, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475567, '0047558', NULL, NULL, 145, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', 286056),
(475568, '0052970', NULL, NULL, 127, NULL, 'Ns1 effector domain-like', 286057),
(475569, '0044442', NULL, NULL, 362, NULL, 'Sulfolobus fructose-1,6-bisphosphatase-like', 286058),
(475570, '0048443', NULL, NULL, 457, NULL, 'Monomethylamine methyltransferase MtmB', 286059),
(475571, '0049459', NULL, NULL, 102, NULL, 'NSFL1 (p97 ATPase) cofactor p47, SEP domain', 286060);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(475572, '0044687', NULL, NULL, 76, NULL, 'NSFL1 (p97 ATPase) cofactor p47, SEP domain', 286060),
(475573, '0051537', NULL, NULL, 122, NULL, 'L,D-transpeptidase pre-catalytic domain-like', 286061),
(475574, '0054229', NULL, NULL, 71, NULL, 'YfgJ-like', 286062),
(475575, '0045511', NULL, NULL, 94, NULL, 'FKBP12-rapamycin-binding domain of FKBP-rapamycin-associated protein (FRAP)', 286063),
(475576, '0044193', NULL, NULL, 125, NULL, 'Dystroglycan, domain 2', 286064),
(475577, '0054640', NULL, NULL, 233, NULL, 'ATP12-like', 286065),
(475578, '0054649', NULL, NULL, 261, NULL, 'ATP12-like', 286065),
(475579, '0052767', NULL, NULL, 105, NULL, 'Nqo1C-terminal domain-like', 286066),
(475580, '0050101', NULL, NULL, 204, NULL, 'Precorrin-8X methylmutase CbiC/CobH', 286067),
(475581, '0037360', NULL, NULL, 209, NULL, 'Precorrin-8X methylmutase CbiC/CobH', 286067),
(475582, '0048647', NULL, NULL, 190, NULL, 'Precorrin-8X methylmutase CbiC/CobH', 286067),
(475583, '0051330', NULL, NULL, 129, NULL, 'Mediator hinge subcomplex-like', 286068),
(475584, '0051329', NULL, NULL, 95, NULL, 'Mediator hinge subcomplex-like', 286068),
(475585, '0043338', NULL, NULL, 145, NULL, 'Tombusvirus P19 core protein, VP19', 286069),
(475586, '0043180', NULL, NULL, 124, NULL, 'Tombusvirus P19 core protein, VP19', 286069),
(475587, '0044107', NULL, NULL, 316, NULL, 'Thymidylate synthase/dCMP hydroxymethylase', 286070),
(475588, '0038750', NULL, NULL, 288, NULL, 'Thymidylate synthase/dCMP hydroxymethylase', 286070),
(475589, '0042943', NULL, NULL, 264, NULL, 'Thymidylate synthase/dCMP hydroxymethylase', 286070),
(475590, '0039350', NULL, NULL, 326, NULL, 'Thymidylate synthase/dCMP hydroxymethylase', 286070),
(475591, '0043052', NULL, NULL, 341, NULL, 'Thymidylate synthase/dCMP hydroxymethylase', 286070),
(475592, '0035603', NULL, NULL, 278, NULL, 'Thymidylate synthase/dCMP hydroxymethylase', 286070),
(475593, '0044026', NULL, NULL, 286, NULL, 'Thymidylate synthase/dCMP hydroxymethylase', 286070),
(475594, '0045478', NULL, NULL, 281, NULL, 'Thymidylate synthase/dCMP hydroxymethylase', 286070),
(475595, '0035358', NULL, NULL, 241, NULL, 'Thymidylate synthase/dCMP hydroxymethylase', 286070),
(475596, '0035996', NULL, NULL, 295, NULL, 'Thymidylate synthase/dCMP hydroxymethylase', 286070),
(475597, '0047374', NULL, NULL, 84, NULL, 'Hypothetical protein MTH865', 286071),
(475598, '0047693', NULL, NULL, 438, NULL, 'Integrin alpha N-terminal domain', 286072),
(475599, '0053611', NULL, NULL, 452, NULL, 'Integrin alpha N-terminal domain', 286072),
(475600, '0053345', NULL, NULL, 65, NULL, 'Leech antihemostatic proteins', 286073),
(475601, '0046570', NULL, NULL, 53, NULL, 'Leech antihemostatic proteins', 286073),
(475602, '0046434', NULL, NULL, 57, NULL, 'Leech antihemostatic proteins', 286073),
(475603, '0046312', NULL, NULL, 39, NULL, 'Leech antihemostatic proteins', 286073),
(475604, '0047229', NULL, NULL, 65, NULL, 'Leech antihemostatic proteins', 286073),
(475605, '0043652', NULL, NULL, 52, NULL, 'Leech antihemostatic proteins', 286073),
(475606, '0049419', NULL, NULL, 52, NULL, 'Leech antihemostatic proteins', 286073),
(475607, '0035754', NULL, NULL, 51, NULL, 'Leech antihemostatic proteins', 286073),
(475608, '0052167', NULL, NULL, 154, NULL, 'Hyaluronidase post-catalytic domain-like', 286074),
(475609, '0052138', NULL, NULL, 129, NULL, 'Hyaluronidase post-catalytic domain-like', 286074),
(475610, '0041421', NULL, NULL, 71, NULL, 'C-terminal domain of ProRS', 286075),
(475611, '0038523', NULL, NULL, 74, NULL, 'C-terminal domain of ProRS', 286075),
(475612, '0041425', NULL, NULL, 62, NULL, 'C-terminal domain of ProRS', 286075),
(475613, '0041466', NULL, NULL, 159, NULL, 'Ribose/Galactose isomerase RpiB/AlsB', 286076),
(475614, '0044504', NULL, NULL, 157, NULL, 'Ribose/Galactose isomerase RpiB/AlsB', 286076),
(475615, '0041667', NULL, NULL, 145, NULL, 'Ribose/Galactose isomerase RpiB/AlsB', 286076),
(475616, '0036915', NULL, NULL, 45, NULL, 'Carbohydrate binding domain', 286077),
(475617, '0036705', NULL, NULL, 52, NULL, 'Carbohydrate binding domain', 286077);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(475618, '0035067', NULL, NULL, 62, NULL, 'Carbohydrate binding domain', 286077),
(475619, '0050646', NULL, NULL, 293, NULL, 'Flagellar hook protein flgE', 286078),
(475620, '0053897', NULL, NULL, 52, NULL, 'E7 C-terminal domain-like', 286079),
(475621, '0053733', NULL, NULL, 52, NULL, 'E7 C-terminal domain-like', 286079),
(475622, '0053781', NULL, NULL, 23, NULL, 'VhTI-like', 286080),
(475623, '0046663', NULL, NULL, 95, NULL, 'Invasin/intimin cell-adhesion fragments', 286081),
(475624, '0046664', NULL, NULL, 89, NULL, 'Invasin/intimin cell-adhesion fragments', 286081),
(475625, '0046227', NULL, NULL, 96, NULL, 'Invasin/intimin cell-adhesion fragments', 286081),
(475626, '0046226', NULL, NULL, 94, NULL, 'Invasin/intimin cell-adhesion fragments', 286081),
(475627, '0036180', NULL, NULL, 91, NULL, 'Invasin/intimin cell-adhesion fragments', 286081),
(475628, '0046228', NULL, NULL, 103, NULL, 'Invasin/intimin cell-adhesion fragments', 286081),
(475629, '0035717', NULL, NULL, 70, NULL, 'Cell cycle regulatory proteins', 286082),
(475630, '0036038', NULL, NULL, 74, NULL, 'Cell cycle regulatory proteins', 286082),
(475631, '0042693', NULL, NULL, 113, NULL, 'Cell cycle regulatory proteins', 286082),
(475632, '0042465', NULL, NULL, 101, NULL, 'Cell cycle regulatory proteins', 286082),
(475633, '0044825', NULL, NULL, 121, NULL, 'Hypothetical protein At3g22680', 286083),
(475634, '0040343', NULL, NULL, 49, NULL, 'Subunit XI (6.4 kDa protein) of cytochrome bc1 complex (Ubiquinol-cytochrome c reductase)', 286084),
(475635, '0040342', NULL, NULL, 53, NULL, 'Subunit XI (6.4 kDa protein) of cytochrome bc1 complex (Ubiquinol-cytochrome c reductase)', 286084),
(475636, '0036590', NULL, NULL, 138, NULL, 'N-terminal domain of eukaryotic peptide chain release factor subunit 1, ERF1', 286085),
(475637, '0054430', NULL, NULL, 85, NULL, 'BH2638-like', 286086),
(475638, '0037135', NULL, NULL, 234, NULL, '2,3-Bisphosphoglycerate-independent phosphoglycerate mutase, substrate-binding domain', 286087),
(475639, '0037918', NULL, NULL, 106, NULL, 'Cyclin-like', 286088),
(475640, '0050198', NULL, NULL, 124, NULL, 'Cyclin-like', 286088),
(475641, '0045780', NULL, NULL, 95, NULL, 'Cyclin-like', 286088),
(475642, '0037917', NULL, NULL, 132, NULL, 'Cyclin-like', 286088),
(475643, '0053624', NULL, NULL, 130, NULL, 'Cyclin-like', 286088),
(475644, '0054835', NULL, NULL, 146, NULL, 'Cyclin-like', 286088),
(475645, '0053625', NULL, NULL, 140, NULL, 'Cyclin-like', 286088),
(475646, '0054834', NULL, NULL, 109, NULL, 'Cyclin-like', 286088),
(475647, '0052578', NULL, NULL, 140, NULL, 'Cyclin-like', 286088),
(475648, '0054090', NULL, NULL, 110, NULL, 'Cyclin-like', 286088),
(475649, '0046712', NULL, NULL, 141, NULL, 'Cyclin-like', 286088),
(475650, '0035706', NULL, NULL, 102, NULL, 'Cyclin-like', 286088),
(475651, '0052145', NULL, NULL, 128, NULL, 'Cyclin-like', 286088),
(475652, '0054089', NULL, NULL, 144, NULL, 'Cyclin-like', 286088),
(475653, '0039605', NULL, NULL, 151, NULL, 'Cyclin-like', 286088),
(475654, '0037400', NULL, NULL, 106, NULL, 'Cyclin-like', 286088),
(475655, '0038414', NULL, NULL, 147, NULL, 'Cyclin-like', 286088),
(475656, '0039746', NULL, NULL, 123, NULL, 'Cyclin-like', 286088),
(475657, '0038276', NULL, NULL, 141, NULL, 'Cyclin-like', 286088),
(475658, '0044901', NULL, NULL, 95, NULL, 'Cyclin-like', 286088),
(475659, '0044902', NULL, NULL, 109, NULL, 'Cyclin-like', 286088),
(475660, '0035065', NULL, NULL, 98, NULL, 'Cyclin-like', 286088),
(475661, '0038275', NULL, NULL, 198, NULL, 'Cyclin-like', 286088),
(475662, '0054162', NULL, NULL, 113, NULL, 'Cyclin-like', 286088),
(475663, '0054161', NULL, NULL, 143, NULL, 'Cyclin-like', 286088),
(475664, '0047613', NULL, NULL, 126, NULL, 'Cyclin-like', 286088),
(475665, '0038294', NULL, NULL, 88, NULL, 'Plasmid maintenance system epsilon/zeta, antidote epsilon subunit', 286089),
(475666, '0048067', NULL, NULL, 139, NULL, 'C-terminal, gelsolin-like domain of Sec23/24', 286090),
(475667, '0040755', NULL, NULL, 173, NULL, 'C-terminal, gelsolin-like domain of Sec23/24', 286090);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(475668, '0039775', NULL, NULL, 85, NULL, 'Integrin beta tail domain', 286091),
(475669, '0039680', NULL, NULL, 100, NULL, 'Ribosome-binding factor A, RbfA', 286092),
(475670, '0053859', NULL, NULL, 91, NULL, 'Ribosome-binding factor A, RbfA', 286092),
(475671, '0048720', NULL, NULL, 96, NULL, 'Ribosome-binding factor A, RbfA', 286092),
(475672, '0047823', NULL, NULL, 108, NULL, 'Ribosome-binding factor A, RbfA', 286092),
(475673, '0053866', NULL, NULL, 116, NULL, 'Ribosome-binding factor A, RbfA', 286092),
(475674, '0047817', NULL, NULL, 74, NULL, 'Anaphylotoxins (complement system)', 286093),
(475675, '0035858', NULL, NULL, 66, NULL, 'Anaphylotoxins (complement system)', 286093),
(475676, '0036409', NULL, NULL, 94, NULL, 'Ribosomal protein L25-like', 286094),
(475677, '0038262', NULL, NULL, 209, NULL, 'Ribosomal protein L25-like', 286094),
(475678, '0054790', NULL, NULL, 175, NULL, 'Ribosomal protein L25-like', 286094),
(475679, '0037515', NULL, NULL, 185, NULL, 'Ribosomal protein L25-like', 286094),
(475680, '0053488', NULL, NULL, 76, NULL, 'Myosin rod fragments', 286095),
(475681, '0053562', NULL, NULL, 126, NULL, 'Myosin rod fragments', 286095),
(475682, '0051894', NULL, NULL, 259, NULL, 'LeuD/IlvD-like', 286096),
(475683, '0045759', NULL, NULL, 226, NULL, 'LeuD/IlvD-like', 286096),
(475684, '0050083', NULL, NULL, 162, NULL, 'LeuD/IlvD-like', 286096),
(475685, '0052934', NULL, NULL, 190, NULL, 'LeuD/IlvD-like', 286096),
(475686, '0053017', NULL, NULL, 132, NULL, 'LeuD/IlvD-like', 286096),
(475687, '0040389', NULL, NULL, 212, NULL, 'LeuD/IlvD-like', 286096),
(475688, '0052212', NULL, NULL, 71, NULL, 'Cap-Gly domain', 286097),
(475689, '0048010', NULL, NULL, 95, NULL, 'Cap-Gly domain', 286097),
(475690, '0052213', NULL, NULL, 128, NULL, 'Cap-Gly domain', 286097),
(475691, '0052210', NULL, NULL, 83, NULL, 'Cap-Gly domain', 286097),
(475692, '0052211', NULL, NULL, 82, NULL, 'Cap-Gly domain', 286097),
(475693, '0047463', NULL, NULL, 104, NULL, 'Cap-Gly domain', 286097),
(475694, '0050558', NULL, NULL, 95, NULL, 'Cap-Gly domain', 286097),
(475695, '0052209', NULL, NULL, 109, NULL, 'Cap-Gly domain', 286097),
(475696, '0050557', NULL, NULL, 91, NULL, 'Cap-Gly domain', 286097),
(475697, '0052207', NULL, NULL, 88, NULL, 'Cap-Gly domain', 286097),
(475698, '0050559', NULL, NULL, 92, NULL, 'Cap-Gly domain', 286097),
(475699, '0052208', NULL, NULL, 99, NULL, 'Cap-Gly domain', 286097),
(475700, '0050554', NULL, NULL, 113, NULL, 'Cap-Gly domain', 286097),
(475701, '0050556', NULL, NULL, 102, NULL, 'Cap-Gly domain', 286097),
(475702, '0052214', NULL, NULL, 160, NULL, 'Cap-Gly domain', 286097),
(475703, '0050555', NULL, NULL, 102, NULL, 'Cap-Gly domain', 286097),
(475704, '0045260', NULL, NULL, 210, NULL, 'Barwin-like endoglucanases', 286098),
(475705, '0054531', NULL, NULL, 365, NULL, 'Barwin-like endoglucanases', 286098),
(475706, '0053694', NULL, NULL, 335, NULL, 'Barwin-like endoglucanases', 286098),
(475707, '0035740', NULL, NULL, 125, NULL, 'Barwin-like endoglucanases', 286098),
(475708, '0040416', NULL, NULL, 207, NULL, 'Barwin-like endoglucanases', 286098),
(475709, '0053626', NULL, NULL, 180, NULL, 'Barwin-like endoglucanases', 286098),
(475710, '0048258', NULL, NULL, 143, NULL, 'Barwin-like endoglucanases', 286098),
(475711, '0053935', NULL, NULL, 402, NULL, 'Barwin-like endoglucanases', 286098),
(475712, '0043826', NULL, NULL, 83, NULL, 'TmoB-like', 286099),
(475713, '0054449', NULL, NULL, 165, NULL, 'FomD-like', 286100),
(475714, '0043535', NULL, NULL, 138, NULL, 'Stathmin', 286101),
(475715, '0047661', NULL, NULL, 118, NULL, 'Dipeptidyl peptidase I (cathepsin C), exclusion domain', 286102),
(475716, '0047736', NULL, NULL, 119, NULL, 'Dipeptidyl peptidase I (cathepsin C), exclusion domain', 286102),
(475717, '0053937', NULL, NULL, 112, NULL, 'YgaC/TfoX-N like', 286103),
(475718, '0054360', NULL, NULL, 103, NULL, 'YgaC/TfoX-N like', 286103),
(475719, '0047605', NULL, NULL, 108, NULL, 'Quinohemoprotein amine dehydrogenase A chain, domain 3', 286104),
(475720, '0047634', NULL, NULL, 119, NULL, 'Quinohemoprotein amine dehydrogenase A chain, domain 3', 286104);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(475721, '0050264', NULL, NULL, 77, NULL, 'XseB-like', 286105),
(475722, '0049889', NULL, NULL, 83, NULL, 'HBS1-like domain', 286106),
(475723, '0035618', NULL, NULL, 192, NULL, 'Serum albumin-like', 286107),
(475724, '0035617', NULL, NULL, 192, NULL, 'Serum albumin-like', 286107),
(475725, '0039401', NULL, NULL, 188, NULL, 'Serum albumin-like', 286107),
(475726, '0035619', NULL, NULL, 194, NULL, 'Serum albumin-like', 286107),
(475727, '0039402', NULL, NULL, 71, NULL, 'Serum albumin-like', 286107),
(475728, '0040312', NULL, NULL, 198, NULL, 'Serum albumin-like', 286107),
(475729, '0036789', NULL, NULL, 70, NULL, 'Bacteriocin AS-48', 286108),
(475730, '0047020', NULL, NULL, 107, NULL, 'HRDC-like', 286109),
(475731, '0050708', NULL, NULL, 77, NULL, 'HRDC-like', 286109),
(475732, '0051176', NULL, NULL, 176, NULL, 'HRDC-like', 286109),
(475733, '0051396', NULL, NULL, 81, NULL, 'HRDC-like', 286109),
(475734, '0051395', NULL, NULL, 101, NULL, 'HRDC-like', 286109),
(475735, '0052492', NULL, NULL, 94, NULL, 'HRDC-like', 286109),
(475736, '0052999', NULL, NULL, 96, NULL, 'HRDC-like', 286109),
(475737, '0046279', NULL, NULL, 81, NULL, 'HRDC-like', 286109),
(475738, '0052106', NULL, NULL, 129, NULL, 'HRDC-like', 286109),
(475739, '0052226', NULL, NULL, 113, NULL, 'HRDC-like', 286109),
(475740, '0054329', NULL, NULL, 389, NULL, 'CV3147-like', 286110),
(475741, '0043945', NULL, NULL, 115, NULL, 'S13-like H2TH domain', 286111),
(475742, '0041471', NULL, NULL, 88, NULL, 'S13-like H2TH domain', 286111),
(475743, '0041084', NULL, NULL, 78, NULL, 'S13-like H2TH domain', 286111),
(475744, '0049091', NULL, NULL, 94, NULL, 'S13-like H2TH domain', 286111),
(475745, '0039948', NULL, NULL, 88, NULL, 'S13-like H2TH domain', 286111),
(475746, '0036934', NULL, NULL, 89, NULL, 'S13-like H2TH domain', 286111),
(475747, '0039898', NULL, NULL, 89, NULL, 'S13-like H2TH domain', 286111),
(475748, '0053988', NULL, NULL, 114, NULL, 'S13-like H2TH domain', 286111),
(475749, '0037623', NULL, NULL, 125, NULL, 'S13-like H2TH domain', 286111),
(475750, '0047621', NULL, NULL, 153, NULL, 'Agglutinin', 286112),
(475751, '0047622', NULL, NULL, 146, NULL, 'Agglutinin', 286112),
(475752, '0053720', NULL, NULL, 30, NULL, 'Photosystem II reaction center protein T, PsbT', 286113),
(475753, '0049635', NULL, NULL, 79, NULL, 'Cna protein B-type domain', 286114),
(475754, '0036246', NULL, NULL, 97, NULL, 'Cna protein B-type domain', 286114),
(475755, '0036245', NULL, NULL, 90, NULL, 'Cna protein B-type domain', 286114),
(475756, '0053840', NULL, NULL, 47, NULL, 'B-box zinc-binding domain', 286115),
(475757, '0053819', NULL, NULL, 40, NULL, 'B-box zinc-binding domain', 286115),
(475758, '0053806', NULL, NULL, 51, NULL, 'B-box zinc-binding domain', 286115),
(475759, '0053807', NULL, NULL, 54, NULL, 'B-box zinc-binding domain', 286115),
(475760, '0037745', NULL, NULL, 39, NULL, 'B-box zinc-binding domain', 286115),
(475761, '0053822', NULL, NULL, 71, NULL, 'B-box zinc-binding domain', 286115),
(475762, '0053788', NULL, NULL, 59, NULL, 'B-box zinc-binding domain', 286115),
(475763, '0035727', NULL, NULL, 216, NULL, 'A virus capsid protein alpha-helical domain', 286116),
(475764, '0044317', NULL, NULL, 269, NULL, 'A virus capsid protein alpha-helical domain', 286116),
(475765, '0042786', NULL, NULL, 214, NULL, 'A virus capsid protein alpha-helical domain', 286116),
(475766, '0045084', NULL, NULL, 108, NULL, 'Cytochrome c', 286117),
(475767, '0047100', NULL, NULL, 90, NULL, 'Cytochrome c', 286117),
(475768, '0036446', NULL, NULL, 74, NULL, 'Cytochrome c', 286117),
(475769, '0036886', NULL, NULL, 159, NULL, 'Cytochrome c', 286117),
(475770, '0037177', NULL, NULL, 92, NULL, 'Cytochrome c', 286117),
(475771, '0037178', NULL, NULL, 98, NULL, 'Cytochrome c', 286117),
(475772, '0038388', NULL, NULL, 150, NULL, 'Cytochrome c', 286117),
(475773, '0038389', NULL, NULL, 111, NULL, 'Cytochrome c', 286117),
(475774, '0039356', NULL, NULL, 104, NULL, 'Cytochrome c', 286117),
(475775, '0037491', NULL, NULL, 80, NULL, 'Cytochrome c', 286117),
(475776, '0038140', NULL, NULL, 78, NULL, 'Cytochrome c', 286117);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(475777, '0037492', NULL, NULL, 94, NULL, 'Cytochrome c', 286117),
(475778, '0036087', NULL, NULL, 121, NULL, 'Cytochrome c', 286117),
(475779, '0037291', NULL, NULL, 199, NULL, 'Cytochrome c', 286117),
(475780, '0035909', NULL, NULL, 83, NULL, 'Cytochrome c', 286117),
(475781, '0038062', NULL, NULL, 85, NULL, 'Cytochrome c', 286117),
(475782, '0035869', NULL, NULL, 71, NULL, 'Cytochrome c', 286117),
(475783, '0035824', NULL, NULL, 116, NULL, 'Cytochrome c', 286117),
(475784, '0045374', NULL, NULL, 147, NULL, 'Cytochrome c', 286117),
(475785, '0047110', NULL, NULL, 138, NULL, 'Cytochrome c', 286117),
(475786, '0040281', NULL, NULL, 104, NULL, 'Cytochrome c', 286117),
(475787, '0037329', NULL, NULL, 88, NULL, 'Cytochrome c', 286117),
(475788, '0045615', NULL, NULL, 103, NULL, 'Cytochrome c', 286117),
(475789, '0046109', NULL, NULL, 111, NULL, 'Cytochrome c', 286117),
(475790, '0036151', NULL, NULL, 89, NULL, 'Cytochrome c', 286117),
(475791, '0040640', NULL, NULL, 91, NULL, 'Cytochrome c', 286117),
(475792, '0044968', NULL, NULL, 104, NULL, 'Cytochrome c', 286117),
(475793, '0039582', NULL, NULL, 80, NULL, 'Cytochrome c', 286117),
(475794, '0036078', NULL, NULL, 107, NULL, 'Cytochrome c', 286117),
(475795, '0038691', NULL, NULL, 105, NULL, 'Cytochrome c', 286117),
(475796, '0045496', NULL, NULL, 112, NULL, 'Cytochrome c', 286117),
(475797, '0048246', NULL, NULL, 131, NULL, 'Cytochrome c', 286117),
(475798, '0038370', NULL, NULL, 82, NULL, 'Cytochrome c', 286117),
(475799, '0036071', NULL, NULL, 86, NULL, 'Cytochrome c', 286117),
(475800, '0046788', NULL, NULL, 82, NULL, 'Cytochrome c', 286117),
(475801, '0040004', NULL, NULL, 97, NULL, 'Cytochrome c', 286117),
(475802, '0045581', NULL, NULL, 82, NULL, 'Cytochrome c', 286117),
(475803, '0048374', NULL, NULL, 112, NULL, 'Cytochrome c', 286117),
(475804, '0035454', NULL, NULL, 195, NULL, 'Cytochrome c', 286117),
(475805, '0035855', NULL, NULL, 131, NULL, 'Cytochrome c', 286117),
(475806, '0046190', NULL, NULL, 82, NULL, 'Cytochrome c', 286117),
(475807, '0046439', NULL, NULL, 135, NULL, 'Cytochrome c', 286117),
(475808, '0039131', NULL, NULL, 158, NULL, 'Cytochrome c', 286117),
(475809, '0041461', NULL, NULL, 160, NULL, 'Cytochrome c', 286117),
(475810, '0042837', NULL, NULL, 99, NULL, 'Cytochrome c', 286117),
(475811, '0046079', NULL, NULL, 79, NULL, 'Cytochrome c', 286117),
(475812, '0046233', NULL, NULL, 124, NULL, 'Cytochrome c', 286117),
(475813, '0046236', NULL, NULL, 90, NULL, 'Cytochrome c', 286117),
(475814, '0039492', NULL, NULL, 118, NULL, 'Cytochrome c', 286117),
(475815, '0045102', NULL, NULL, 112, NULL, 'Cytochrome c', 286117),
(475816, '0046513', NULL, NULL, 164, NULL, 'Cytochrome c', 286117),
(475817, '0046678', NULL, NULL, 129, NULL, 'Cytochrome c', 286117),
(475818, '0047602', NULL, NULL, 85, NULL, 'Cytochrome c', 286117),
(475819, '0048977', NULL, NULL, 127, NULL, 'Cytochrome c', 286117),
(475820, '0042874', NULL, NULL, 99, NULL, 'Cytochrome c', 286117),
(475821, '0046083', NULL, NULL, 88, NULL, 'Cytochrome c', 286117),
(475822, '0046084', NULL, NULL, 87, NULL, 'Cytochrome c', 286117),
(475823, '0045077', NULL, NULL, 108, NULL, 'Cytochrome c', 286117),
(475824, '0051351', NULL, NULL, 80, NULL, 'Cytochrome c', 286117),
(475825, '0039644', NULL, NULL, 77, NULL, 'Cytochrome c', 286117),
(475826, '0052127', NULL, NULL, 149, NULL, 'Cytochrome c', 286117),
(475827, '0046407', NULL, NULL, 82, NULL, 'Cytochrome c', 286117),
(475828, '0045713', NULL, NULL, 81, NULL, 'Cytochrome c', 286117),
(475829, '0047418', NULL, NULL, 150, NULL, 'Cytochrome c', 286117),
(475830, '0039643', NULL, NULL, 84, NULL, 'Cytochrome c', 286117),
(475831, '0046408', NULL, NULL, 112, NULL, 'Cytochrome c', 286117),
(475832, '0038594', NULL, NULL, 114, NULL, 'Cytochrome c', 286117),
(475833, '0048389', NULL, NULL, 166, NULL, 'Cytochrome c', 286117),
(475834, '0046488', NULL, NULL, 124, NULL, 'Cytochrome c', 286117),
(475835, '0040303', NULL, NULL, 81, NULL, 'Cytochrome c', 286117),
(475836, '0046405', NULL, NULL, 79, NULL, 'Cytochrome c', 286117),
(475837, '0045678', NULL, NULL, 134, NULL, 'Cytochrome c', 286117);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(475838, '0048690', NULL, NULL, 35, NULL, 'Microbial and mitochondrial ADK, insert "zinc finger" domain', 286118),
(475839, '0051783', NULL, NULL, 37, NULL, 'Microbial and mitochondrial ADK, insert "zinc finger" domain', 286118),
(475840, '0046460', NULL, NULL, 35, NULL, 'Microbial and mitochondrial ADK, insert "zinc finger" domain', 286118),
(475841, '0045114', NULL, NULL, 31, NULL, 'Microbial and mitochondrial ADK, insert "zinc finger" domain', 286118),
(475842, '0045124', NULL, NULL, 35, NULL, 'Microbial and mitochondrial ADK, insert "zinc finger" domain', 286118),
(475843, '0045786', NULL, NULL, 30, NULL, 'Microbial and mitochondrial ADK, insert "zinc finger" domain', 286118),
(475844, '0045789', NULL, NULL, 38, NULL, 'Microbial and mitochondrial ADK, insert "zinc finger" domain', 286118),
(475845, '0049307', NULL, NULL, 35, NULL, 'Microbial and mitochondrial ADK, insert "zinc finger" domain', 286118),
(475846, '0042699', NULL, NULL, 132, NULL, 'RNA bacteriophage capsid protein', 286119),
(475847, '0052047', NULL, NULL, 129, NULL, 'RNA bacteriophage capsid protein', 286119),
(475848, '0037750', NULL, NULL, 129, NULL, 'RNA bacteriophage capsid protein', 286119),
(475849, '0036638', NULL, NULL, 127, NULL, 'RNA bacteriophage capsid protein', 286119),
(475850, '0044460', NULL, NULL, 129, NULL, 'RNA bacteriophage capsid protein', 286119),
(475851, '0042772', NULL, NULL, 142, NULL, 'Hepatitis B viral capsid (hbcag)', 286120),
(475852, '0037562', NULL, NULL, 140, NULL, 'CO dehydrogenase molybdoprotein N-domain-like', 286121),
(475853, '0043859', NULL, NULL, 165, NULL, 'CO dehydrogenase molybdoprotein N-domain-like', 286121),
(475854, '0049205', NULL, NULL, 125, NULL, 'CO dehydrogenase molybdoprotein N-domain-like', 286121),
(475855, '0039728', NULL, NULL, 122, NULL, 'CO dehydrogenase molybdoprotein N-domain-like', 286121),
(475856, '0046832', NULL, NULL, 158, NULL, 'CO dehydrogenase molybdoprotein N-domain-like', 286121),
(475857, '0036416', NULL, NULL, 117, NULL, 'CO dehydrogenase molybdoprotein N-domain-like', 286121),
(475858, '0041226', NULL, NULL, 141, NULL, 'CO dehydrogenase molybdoprotein N-domain-like', 286121),
(475859, '0044865', NULL, NULL, 117, NULL, 'CO dehydrogenase molybdoprotein N-domain-like', 286121),
(475860, '0044296', NULL, NULL, 76, NULL, 'Obg GTP-binding protein C-terminal domain', 286122),
(475861, '0047265', NULL, NULL, 46, NULL, 'Agouti-related protein', 286123),
(475862, '0052717', NULL, NULL, 240, NULL, 'SipA N-terminal domain-like', 286124),
(475863, '0046050', NULL, NULL, 106, NULL, 'Nucleic acid-binding proteins', 286125),
(475864, '0054754', NULL, NULL, 88, NULL, 'Nucleic acid-binding proteins', 286125),
(475865, '0054597', NULL, NULL, 64, NULL, 'Nucleic acid-binding proteins', 286125),
(475866, '0046451', NULL, NULL, 62, NULL, 'Nucleic acid-binding proteins', 286125),
(475867, '0050030', NULL, NULL, 111, NULL, 'Nucleic acid-binding proteins', 286125),
(475868, '0054593', NULL, NULL, 123, NULL, 'Nucleic acid-binding proteins', 286125),
(475869, '0037576', NULL, NULL, 118, NULL, 'Nucleic acid-binding proteins', 286125),
(475870, '0045922', NULL, NULL, 144, NULL, 'Nucleic acid-binding proteins', 286125),
(475871, '0047828', NULL, NULL, 86, NULL, 'Nucleic acid-binding proteins', 286125),
(475872, '0047028', NULL, NULL, 218, NULL, 'Nucleic acid-binding proteins', 286125),
(475873, '0049722', NULL, NULL, 145, NULL, 'Nucleic acid-binding proteins', 286125),
(475874, '0047147', NULL, NULL, 79, NULL, 'Nucleic acid-binding proteins', 286125),
(475875, '0041327', NULL, NULL, 68, NULL, 'Nucleic acid-binding proteins', 286125),
(475876, '0042019', NULL, NULL, 213, NULL, 'Nucleic acid-binding proteins', 286125),
(475877, '0048514', NULL, NULL, 115, NULL, 'Nucleic acid-binding proteins', 286125),
(475878, '0051771', NULL, NULL, 84, NULL, 'Nucleic acid-binding proteins', 286125),
(475879, '0049455', NULL, NULL, 76, NULL, 'Nucleic acid-binding proteins', 286125),
(475880, '0049576', NULL, NULL, 67, NULL, 'Nucleic acid-binding proteins', 286125),
(475881, '0048641', NULL, NULL, 168, NULL, 'Nucleic acid-binding proteins', 286125);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(475882, '0045011', NULL, NULL, 79, NULL, 'Nucleic acid-binding proteins', 286125),
(475883, '0053958', NULL, NULL, 137, NULL, 'Nucleic acid-binding proteins', 286125),
(475884, '0051418', NULL, NULL, 69, NULL, 'Nucleic acid-binding proteins', 286125),
(475885, '0049051', NULL, NULL, 145, NULL, 'Nucleic acid-binding proteins', 286125),
(475886, '0052107', NULL, NULL, 94, NULL, 'Nucleic acid-binding proteins', 286125),
(475887, '0052503', NULL, NULL, 67, NULL, 'Nucleic acid-binding proteins', 286125),
(475888, '0047715', NULL, NULL, 76, NULL, 'Nucleic acid-binding proteins', 286125),
(475889, '0048887', NULL, NULL, 87, NULL, 'Nucleic acid-binding proteins', 286125),
(475890, '0041615', NULL, NULL, 71, NULL, 'Nucleic acid-binding proteins', 286125),
(475891, '0048642', NULL, NULL, 124, NULL, 'Nucleic acid-binding proteins', 286125),
(475892, '0048643', NULL, NULL, 167, NULL, 'Nucleic acid-binding proteins', 286125),
(475893, '0045777', NULL, NULL, 71, NULL, 'Nucleic acid-binding proteins', 286125),
(475894, '0045898', NULL, NULL, 103, NULL, 'Nucleic acid-binding proteins', 286125),
(475895, '0047679', NULL, NULL, 102, NULL, 'Nucleic acid-binding proteins', 286125),
(475896, '0054651', NULL, NULL, 401, NULL, 'Nucleic acid-binding proteins', 286125),
(475897, '0054772', NULL, NULL, 95, NULL, 'Nucleic acid-binding proteins', 286125),
(475898, '0053683', NULL, NULL, 210, NULL, 'Nucleic acid-binding proteins', 286125),
(475899, '0054650', NULL, NULL, 58, NULL, 'Nucleic acid-binding proteins', 286125),
(475900, '0037797', NULL, NULL, 104, NULL, 'Nucleic acid-binding proteins', 286125),
(475901, '0039578', NULL, NULL, 102, NULL, 'Nucleic acid-binding proteins', 286125),
(475902, '0050575', NULL, NULL, 119, NULL, 'Nucleic acid-binding proteins', 286125),
(475903, '0049181', NULL, NULL, 81, NULL, 'Nucleic acid-binding proteins', 286125),
(475904, '0052237', NULL, NULL, 82, NULL, 'Nucleic acid-binding proteins', 286125),
(475905, '0046596', NULL, NULL, 134, NULL, 'Nucleic acid-binding proteins', 286125),
(475906, '0043000', NULL, NULL, 127, NULL, 'Nucleic acid-binding proteins', 286125),
(475907, '0043001', NULL, NULL, 114, NULL, 'Nucleic acid-binding proteins', 286125),
(475908, '0044179', NULL, NULL, 66, NULL, 'Nucleic acid-binding proteins', 286125),
(475909, '0047328', NULL, NULL, 104, NULL, 'Nucleic acid-binding proteins', 286125),
(475910, '0040655', NULL, NULL, 239, NULL, 'Nucleic acid-binding proteins', 286125),
(475911, '0049870', NULL, NULL, 118, NULL, 'Nucleic acid-binding proteins', 286125),
(475912, '0050502', NULL, NULL, 89, NULL, 'Nucleic acid-binding proteins', 286125),
(475913, '0053734', NULL, NULL, 83, NULL, 'Nucleic acid-binding proteins', 286125),
(475914, '0053338', NULL, NULL, 115, NULL, 'Nucleic acid-binding proteins', 286125),
(475915, '0049071', NULL, NULL, 170, NULL, 'Nucleic acid-binding proteins', 286125),
(475916, '0036299', NULL, NULL, 143, NULL, 'Nucleic acid-binding proteins', 286125),
(475917, '0050616', NULL, NULL, 145, NULL, 'Nucleic acid-binding proteins', 286125),
(475918, '0039281', NULL, NULL, 133, NULL, 'Nucleic acid-binding proteins', 286125),
(475919, '0038590', NULL, NULL, 72, NULL, 'Nucleic acid-binding proteins', 286125),
(475920, '0048308', NULL, NULL, 93, NULL, 'Nucleic acid-binding proteins', 286125),
(475921, '0046800', NULL, NULL, 125, NULL, 'Nucleic acid-binding proteins', 286125),
(475922, '0046921', NULL, NULL, 104, NULL, 'Nucleic acid-binding proteins', 286125),
(475923, '0052498', NULL, NULL, 59, NULL, 'Nucleic acid-binding proteins', 286125),
(475924, '0054279', NULL, NULL, 95, NULL, 'Nucleic acid-binding proteins', 286125),
(475925, '0054276', NULL, NULL, 88, NULL, 'Nucleic acid-binding proteins', 286125),
(475926, '0046097', NULL, NULL, 66, NULL, 'Nucleic acid-binding proteins', 286125),
(475927, '0050994', NULL, NULL, 140, NULL, 'Nucleic acid-binding proteins', 286125),
(475928, '0050995', NULL, NULL, 151, NULL, 'Nucleic acid-binding proteins', 286125),
(475929, '0048839', NULL, NULL, 111, NULL, 'Nucleic acid-binding proteins', 286125),
(475930, '0040310', NULL, NULL, 187, NULL, 'Nucleic acid-binding proteins', 286125);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(475931, '0045686', NULL, NULL, 109, NULL, 'Nucleic acid-binding proteins', 286125),
(475932, '0047223', NULL, NULL, 71, NULL, 'Nucleic acid-binding proteins', 286125),
(475933, '0046777', NULL, NULL, 128, NULL, 'Nucleic acid-binding proteins', 286125),
(475934, '0046930', NULL, NULL, 66, NULL, 'Nucleic acid-binding proteins', 286125),
(475935, '0040675', NULL, NULL, 85, NULL, 'Nucleic acid-binding proteins', 286125),
(475936, '0051177', NULL, NULL, 91, NULL, 'Nucleic acid-binding proteins', 286125),
(475937, '0049372', NULL, NULL, 231, NULL, 'Nucleic acid-binding proteins', 286125),
(475938, '0054168', NULL, NULL, 385, NULL, 'Nucleic acid-binding proteins', 286125),
(475939, '0037529', NULL, NULL, 90, NULL, 'Nucleic acid-binding proteins', 286125),
(475940, '0047474', NULL, NULL, 138, NULL, 'Nucleic acid-binding proteins', 286125),
(475941, '0048167', NULL, NULL, 133, NULL, 'Nucleic acid-binding proteins', 286125),
(475942, '0048442', NULL, NULL, 171, NULL, 'Nucleic acid-binding proteins', 286125),
(475943, '0051294', NULL, NULL, 68, NULL, 'Nucleic acid-binding proteins', 286125),
(475944, '0053990', NULL, NULL, 78, NULL, 'Nucleic acid-binding proteins', 286125),
(475945, '0054166', NULL, NULL, 79, NULL, 'Nucleic acid-binding proteins', 286125),
(475946, '0054167', NULL, NULL, 87, NULL, 'Nucleic acid-binding proteins', 286125),
(475947, '0048165', NULL, NULL, 133, NULL, 'Nucleic acid-binding proteins', 286125),
(475948, '0047473', NULL, NULL, 112, NULL, 'Nucleic acid-binding proteins', 286125),
(475949, '0048166', NULL, NULL, 113, NULL, 'Nucleic acid-binding proteins', 286125),
(475950, '0054165', NULL, NULL, 90, NULL, 'Nucleic acid-binding proteins', 286125),
(475951, '0034894', NULL, NULL, 78, NULL, 'Nucleic acid-binding proteins', 286125),
(475952, '0036158', NULL, NULL, 64, NULL, 'Nucleic acid-binding proteins', 286125),
(475953, '0054725', NULL, NULL, 416, NULL, 'Nucleic acid-binding proteins', 286125),
(475954, '0054724', NULL, NULL, 148, NULL, 'Nucleic acid-binding proteins', 286125),
(475955, '0054205', NULL, NULL, 90, NULL, 'Nucleic acid-binding proteins', 286125),
(475956, '0054723', NULL, NULL, 88, NULL, 'Nucleic acid-binding proteins', 286125),
(475957, '0036711', NULL, NULL, 143, NULL, 'Nucleic acid-binding proteins', 286125),
(475958, '0050885', NULL, NULL, 148, NULL, 'Nucleic acid-binding proteins', 286125),
(475959, '0054722', NULL, NULL, 95, NULL, 'Nucleic acid-binding proteins', 286125),
(475960, '0037641', NULL, NULL, 164, NULL, 'Nucleic acid-binding proteins', 286125),
(475961, '0038054', NULL, NULL, 109, NULL, 'Nucleic acid-binding proteins', 286125),
(475962, '0038296', NULL, NULL, 87, NULL, 'Nucleic acid-binding proteins', 286125),
(475963, '0039264', NULL, NULL, 62, NULL, 'Nucleic acid-binding proteins', 286125),
(475964, '0048841', NULL, NULL, 107, NULL, 'Nucleic acid-binding proteins', 286125),
(475965, '0054282', NULL, NULL, 125, NULL, 'Nucleic acid-binding proteins', 286125),
(475966, '0045976', NULL, NULL, 65, NULL, 'Nucleic acid-binding proteins', 286125),
(475967, '0048844', NULL, NULL, 113, NULL, 'Nucleic acid-binding proteins', 286125),
(475968, '0051100', NULL, NULL, 78, NULL, 'Nucleic acid-binding proteins', 286125),
(475969, '0054212', NULL, NULL, 87, NULL, 'Nucleic acid-binding proteins', 286125),
(475970, '0047483', NULL, NULL, 67, NULL, 'Nucleic acid-binding proteins', 286125),
(475971, '0048176', NULL, NULL, 107, NULL, 'Nucleic acid-binding proteins', 286125),
(475972, '0054176', NULL, NULL, 125, NULL, 'Nucleic acid-binding proteins', 286125),
(475973, '0036423', NULL, NULL, 86, NULL, 'Nucleic acid-binding proteins', 286125),
(475974, '0048170', NULL, NULL, 69, NULL, 'Nucleic acid-binding proteins', 286125),
(475975, '0054855', NULL, NULL, 94, NULL, 'Nucleic acid-binding proteins', 286125),
(475976, '0035732', NULL, NULL, 63, NULL, 'Nucleic acid-binding proteins', 286125),
(475977, '0039498', NULL, NULL, 197, NULL, 'Nucleic acid-binding proteins', 286125),
(475978, '0047805', NULL, NULL, 71, NULL, 'Nucleic acid-binding proteins', 286125),
(475979, '0042114', NULL, NULL, 145, NULL, 'Nucleic acid-binding proteins', 286125); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(475980, '0039892', NULL, NULL, 71, NULL, 'Nucleic acid-binding proteins', 286125),
(475981, '0047920', NULL, NULL, 178, NULL, 'Nucleic acid-binding proteins', 286125),
(475982, '0049427', NULL, NULL, 87, NULL, 'Nucleic acid-binding proteins', 286125),
(475983, '0049790', NULL, NULL, 79, NULL, 'Nucleic acid-binding proteins', 286125),
(475984, '0043292', NULL, NULL, 66, NULL, 'Nucleic acid-binding proteins', 286125),
(475985, '0046163', NULL, NULL, 89, NULL, 'Nucleic acid-binding proteins', 286125),
(475986, '0047013', NULL, NULL, 180, NULL, 'Nucleic acid-binding proteins', 286125),
(475987, '0037626', NULL, NULL, 104, NULL, 'Nucleic acid-binding proteins', 286125),
(475988, '0037226', NULL, NULL, 114, NULL, 'Nucleic acid-binding proteins', 286125),
(475989, '0044549', NULL, NULL, 60, NULL, 'Nucleic acid-binding proteins', 286125),
(475990, '0048748', NULL, NULL, 78, NULL, 'Nucleic acid-binding proteins', 286125),
(475991, '0044302', NULL, NULL, 63, NULL, 'Nucleic acid-binding proteins', 286125),
(475992, '0044303', NULL, NULL, 58, NULL, 'Nucleic acid-binding proteins', 286125),
(475993, '0047019', NULL, NULL, 106, NULL, 'Nucleic acid-binding proteins', 286125),
(475994, '0053814', NULL, NULL, 80, NULL, 'TTHC002-like', 286126),
(475995, '0035063', NULL, NULL, 92, NULL, 'TATA-box binding protein-like', 286127),
(475996, '0041037', NULL, NULL, 101, NULL, 'TATA-box binding protein-like', 286127),
(475997, '0042875', NULL, NULL, 99, NULL, 'TATA-box binding protein-like', 286127),
(475998, '0041036', NULL, NULL, 92, NULL, 'TATA-box binding protein-like', 286127),
(475999, '0042876', NULL, NULL, 83, NULL, 'TATA-box binding protein-like', 286127),
(476000, '0035929', NULL, NULL, 81, NULL, 'TATA-box binding protein-like', 286127),
(476001, '0035928', NULL, NULL, 98, NULL, 'TATA-box binding protein-like', 286127),
(476002, '0035064', NULL, NULL, 89, NULL, 'TATA-box binding protein-like', 286127),
(476003, '0045101', NULL, NULL, 85, NULL, 'TATA-box binding protein-like', 286127),
(476004, '0045100', NULL, NULL, 95, NULL, 'TATA-box binding protein-like', 286127),
(476005, '0036895', NULL, NULL, 127, NULL, 'TATA-box binding protein-like', 286127),
(476006, '0041039', NULL, NULL, 99, NULL, 'TATA-box binding protein-like', 286127),
(476007, '0047140', NULL, NULL, 312, NULL, 'FMN-linked oxidoreductases', 286128),
(476008, '0049587', NULL, NULL, 349, NULL, 'FMN-linked oxidoreductases', 286128),
(476009, '0047242', NULL, NULL, 353, NULL, 'FMN-linked oxidoreductases', 286128),
(476010, '0038308', NULL, NULL, 374, NULL, 'FMN-linked oxidoreductases', 286128),
(476011, '0038429', NULL, NULL, 364, NULL, 'FMN-linked oxidoreductases', 286128),
(476012, '0051489', NULL, NULL, 337, NULL, 'FMN-linked oxidoreductases', 286128),
(476013, '0050135', NULL, NULL, 310, NULL, 'FMN-linked oxidoreductases', 286128),
(476014, '0052610', NULL, NULL, 231, NULL, 'FMN-linked oxidoreductases', 286128),
(476015, '0042611', NULL, NULL, 380, NULL, 'FMN-linked oxidoreductases', 286128),
(476016, '0049708', NULL, NULL, 409, NULL, 'FMN-linked oxidoreductases', 286128),
(476017, '0042110', NULL, NULL, 329, NULL, 'FMN-linked oxidoreductases', 286128),
(476018, '0046599', NULL, NULL, 311, NULL, 'FMN-linked oxidoreductases', 286128),
(476019, '0047026', NULL, NULL, 359, NULL, 'FMN-linked oxidoreductases', 286128),
(476020, '0052481', NULL, NULL, 311, NULL, 'FMN-linked oxidoreductases', 286128),
(476021, '0048661', NULL, NULL, 399, NULL, 'FMN-linked oxidoreductases', 286128),
(476022, '0036457', NULL, NULL, 340, NULL, 'FMN-linked oxidoreductases', 286128),
(476023, '0036258', NULL, NULL, 367, NULL, 'FMN-linked oxidoreductases', 286128),
(476024, '0051899', NULL, NULL, 312, NULL, 'FMN-linked oxidoreductases', 286128),
(476025, '0050003', NULL, NULL, 359, NULL, 'FMN-linked oxidoreductases', 286128),
(476026, '0050201', NULL, NULL, 229, NULL, 'FMN-linked oxidoreductases', 286128),
(476027, '0038972', NULL, NULL, 364, NULL, 'FMN-linked oxidoreductases', 286128),
(476028, '0044803', NULL, NULL, 361, NULL, 'FMN-linked oxidoreductases', 286128),
(476029, '0047996', NULL, NULL, 801, NULL, 'FMN-linked oxidoreductases', 286128);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(476030, '0048029', NULL, NULL, 414, NULL, 'FMN-linked oxidoreductases', 286128),
(476031, '0044760', NULL, NULL, 305, NULL, 'FMN-linked oxidoreductases', 286128),
(476032, '0046501', NULL, NULL, 771, NULL, 'FMN-linked oxidoreductases', 286128),
(476033, '0046721', NULL, NULL, 336, NULL, 'FMN-linked oxidoreductases', 286128),
(476034, '0042445', NULL, NULL, 330, NULL, 'FMN-linked oxidoreductases', 286128),
(476035, '0051372', NULL, NULL, 278, NULL, 'AF0625-like', 286129),
(476036, '0052888', NULL, NULL, 274, NULL, 'AF0625-like', 286129),
(476037, '0054014', NULL, NULL, 62, NULL, 'YonK-like', 286130),
(476038, '0042539', NULL, NULL, 60, NULL, 'Docking domain A of the erythromycin polyketide synthase (DEBS)', 286131),
(476039, '0040928', NULL, NULL, 123, NULL, 'SMAD MH1 domain', 286132),
(476040, '0042248', NULL, NULL, 141, NULL, 'NinB', 286133),
(476041, '0044316', NULL, NULL, 967, NULL, 'Reovirus inner layer core protein p3', 286134),
(476042, '0045200', NULL, NULL, 845, NULL, 'Reovirus inner layer core protein p3', 286134),
(476043, '0052400', NULL, NULL, 85, NULL, 'SAM/Pointed domain', 286135),
(476044, '0053830', NULL, NULL, 78, NULL, 'SAM/Pointed domain', 286135),
(476045, '0049862', NULL, NULL, 81, NULL, 'SAM/Pointed domain', 286135),
(476046, '0046188', NULL, NULL, 68, NULL, 'SAM/Pointed domain', 286135),
(476047, '0049156', NULL, NULL, 67, NULL, 'SAM/Pointed domain', 286135),
(476048, '0052591', NULL, NULL, 64, NULL, 'SAM/Pointed domain', 286135),
(476049, '0050037', NULL, NULL, 78, NULL, 'SAM/Pointed domain', 286135),
(476050, '0049490', NULL, NULL, 91, NULL, 'SAM/Pointed domain', 286135),
(476051, '0050795', NULL, NULL, 78, NULL, 'SAM/Pointed domain', 286135),
(476052, '0049390', NULL, NULL, 67, NULL, 'SAM/Pointed domain', 286135),
(476053, '0050731', NULL, NULL, 78, NULL, 'SAM/Pointed domain', 286135),
(476054, '0054019', NULL, NULL, 71, NULL, 'SAM/Pointed domain', 286135),
(476055, '0043788', NULL, NULL, 97, NULL, 'SAM/Pointed domain', 286135),
(476056, '0045878', NULL, NULL, 74, NULL, 'SAM/Pointed domain', 286135),
(476057, '0039562', NULL, NULL, 77, NULL, 'SAM/Pointed domain', 286135),
(476058, '0042054', NULL, NULL, 60, NULL, 'SAM/Pointed domain', 286135),
(476059, '0049975', NULL, NULL, 85, NULL, 'SAM/Pointed domain', 286135),
(476060, '0049479', NULL, NULL, 82, NULL, 'SAM/Pointed domain', 286135),
(476061, '0045861', NULL, NULL, 72, NULL, 'SAM/Pointed domain', 286135),
(476062, '0047895', NULL, NULL, 70, NULL, 'SAM/Pointed domain', 286135),
(476063, '0048775', NULL, NULL, 63, NULL, 'SAM/Pointed domain', 286135),
(476064, '0049478', NULL, NULL, 77, NULL, 'SAM/Pointed domain', 286135),
(476065, '0045998', NULL, NULL, 110, NULL, 'SAM/Pointed domain', 286135),
(476066, '0048657', NULL, NULL, 62, NULL, 'SAM/Pointed domain', 286135),
(476067, '0050601', NULL, NULL, 164, NULL, 'Hook domain', 286136),
(476068, '0043351', NULL, NULL, 106, NULL, 'Bacterial fluorinating enzyme, C-terminal domain', 286137),
(476069, '0054322', NULL, NULL, 79, NULL, 'SMc04008-like', 286138),
(476070, '0053103', NULL, NULL, 91, NULL, 'Translation initiation factor IF3, C-terminal domain', 286139),
(476071, '0044020', NULL, NULL, 88, NULL, 'Translation initiation factor IF3, C-terminal domain', 286139),
(476072, '0038931', NULL, NULL, 86, NULL, 'Translation initiation factor IF3, C-terminal domain', 286139),
(476073, '0039957', NULL, NULL, 133, NULL, 'Small protein B (SmpB)', 286140),
(476074, '0039317', NULL, NULL, 123, NULL, 'Small protein B (SmpB)', 286140),
(476075, '0038506', NULL, NULL, 51, NULL, 'Pheromone ER-23', 286141),
(476076, '0040743', NULL, NULL, 177, NULL, 'beta-sandwich domain of Sec23/24', 286142),
(476077, '0040753', NULL, NULL, 250, NULL, 'beta-sandwich domain of Sec23/24', 286142),
(476078, '0042137', NULL, NULL, 215, NULL, 'MurD-like peptide ligases, catalytic domain', 286143),
(476079, '0038085', NULL, NULL, 214, NULL, 'MurD-like peptide ligases, catalytic domain', 286143),
(476080, '0045483', NULL, NULL, 204, NULL, 'MurD-like peptide ligases, catalytic domain', 286143),
(476081, '0046487', NULL, NULL, 234, NULL, 'MurD-like peptide ligases, catalytic domain', 286143);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(476082, '0047522', NULL, NULL, 207, NULL, 'MurD-like peptide ligases, catalytic domain', 286143),
(476083, '0052866', NULL, NULL, 296, NULL, 'MurD-like peptide ligases, catalytic domain', 286143),
(476084, '0041699', NULL, NULL, 296, NULL, 'MurD-like peptide ligases, catalytic domain', 286143),
(476085, '0049220', NULL, NULL, 155, NULL, 'ASF1-like', 286144),
(476086, '0053793', NULL, NULL, 161, NULL, 'ASF1-like', 286144),
(476087, '0054083', NULL, NULL, 154, NULL, 'ASF1-like', 286144),
(476088, '0053880', NULL, NULL, 161, NULL, 'WSSV envelope protein-like', 286145),
(476089, '0053879', NULL, NULL, 170, NULL, 'WSSV envelope protein-like', 286145),
(476090, '0047182', NULL, NULL, 107, NULL, 'Cell-division inhibitor MinC, C-terminal domain', 286146),
(476091, '0051893', NULL, NULL, 160, NULL, 'YbiA-like', 286147),
(476092, '0054262', NULL, NULL, 62, NULL, 'YqgQ-like', 286148),
(476093, '0052582', NULL, NULL, 108, NULL, 'Putative glucosidase YicI, C-terminal domain', 286149),
(476094, '0053553', NULL, NULL, 139, NULL, 'Colicin E3 receptor domain', 286150),
(476095, '0042807', NULL, NULL, 77, NULL, 'Fibre shaft of virus attachment proteins', 286151),
(476096, '0040126', NULL, NULL, 63, NULL, 'Fibre shaft of virus attachment proteins', 286151),
(476097, '0047539', NULL, NULL, 343, NULL, 'UROD/MetE-like', 286152),
(476098, '0049982', NULL, NULL, 357, NULL, 'UROD/MetE-like', 286152),
(476099, '0049767', NULL, NULL, 394, NULL, 'UROD/MetE-like', 286152),
(476100, '0049768', NULL, NULL, 365, NULL, 'UROD/MetE-like', 286152),
(476101, '0039840', NULL, NULL, 84, NULL, 'HPr-like', 286153),
(476102, '0042956', NULL, NULL, 88, NULL, 'HPr-like', 286153),
(476103, '0042253', NULL, NULL, 88, NULL, 'HPr-like', 286153),
(476104, '0039990', NULL, NULL, 88, NULL, 'HPr-like', 286153),
(476105, '0042460', NULL, NULL, 87, NULL, 'HPr-like', 286153),
(476106, '0053228', NULL, NULL, 87, NULL, 'HPr-like', 286153),
(476107, '0041964', NULL, NULL, 85, NULL, 'HPr-like', 286153),
(476108, '0043697', NULL, NULL, 87, NULL, 'HPr-like', 286153),
(476109, '0054480', NULL, NULL, 269, NULL, 'Cgl1923-like', 286154),
(476110, '0039844', NULL, NULL, 67, NULL, 'Bcr-Abl oncoprotein oligomerization domain', 286155),
(476111, '0043514', NULL, NULL, 194, NULL, 'Ribosomal proteins S24e, L23 and L15e', 286156),
(476112, '0051035', NULL, NULL, 101, NULL, 'Ribosomal proteins S24e, L23 and L15e', 286156),
(476113, '0041253', NULL, NULL, 96, NULL, 'Ribosomal proteins S24e, L23 and L15e', 286156),
(476114, '0039573', NULL, NULL, 194, NULL, 'Ribosomal proteins S24e, L23 and L15e', 286156),
(476115, '0054708', NULL, NULL, 93, NULL, 'Ribosomal proteins S24e, L23 and L15e', 286156),
(476116, '0037537', NULL, NULL, 194, NULL, 'Ribosomal proteins S24e, L23 and L15e', 286156),
(476117, '0037544', NULL, NULL, 78, NULL, 'Ribosomal proteins S24e, L23 and L15e', 286156),
(476118, '0051435', NULL, NULL, 102, NULL, 'Ribosomal proteins S24e, L23 and L15e', 286156),
(476119, '0052820', NULL, NULL, 98, NULL, 'Ribosomal proteins S24e, L23 and L15e', 286156),
(476120, '0054601', NULL, NULL, 93, NULL, 'Ribosomal proteins S24e, L23 and L15e', 286156),
(476121, '0054788', NULL, NULL, 93, NULL, 'Ribosomal proteins S24e, L23 and L15e', 286156),
(476122, '0048280', NULL, NULL, 167, NULL, 'IP3 receptor type 1 binding core, domain 2', 286157),
(476123, '0051394', NULL, NULL, 83, NULL, 'Coronavirus NSP7-like', 286158),
(476124, '0037630', NULL, NULL, 159, NULL, 'PEBP-like', 286159),
(476125, '0037790', NULL, NULL, 165, NULL, 'PEBP-like', 286159),
(476126, '0053628', NULL, NULL, 219, NULL, 'PEBP-like', 286159),
(476127, '0034862', NULL, NULL, 185, NULL, 'PEBP-like', 286159),
(476128, '0042907', NULL, NULL, 164, NULL, 'PEBP-like', 286159),
(476129, '0035501', NULL, NULL, 184, NULL, 'PEBP-like', 286159),
(476130, '0040158', NULL, NULL, 180, NULL, 'PEBP-like', 286159),
(476131, '0048212', NULL, NULL, 268, NULL, 'Methyl-coenzyme M reductase subunits', 286160),
(476132, '0046474', NULL, NULL, 183, NULL, 'Methyl-coenzyme M reductase subunits', 286160),
(476133, '0046473', NULL, NULL, 265, NULL, 'Methyl-coenzyme M reductase subunits', 286160);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(476134, '0046476', NULL, NULL, 282, NULL, 'Methyl-coenzyme M reductase subunits', 286160),
(476135, '0046475', NULL, NULL, 248, NULL, 'Methyl-coenzyme M reductase subunits', 286160),
(476136, '0048213', NULL, NULL, 187, NULL, 'Methyl-coenzyme M reductase subunits', 286160),
(476137, '0046477', NULL, NULL, 184, NULL, 'Methyl-coenzyme M reductase subunits', 286160),
(476138, '0048214', NULL, NULL, 247, NULL, 'Methyl-coenzyme M reductase subunits', 286160),
(476139, '0036811', NULL, NULL, 247, NULL, 'Methyl-coenzyme M reductase subunits', 286160),
(476140, '0045608', NULL, NULL, 100, NULL, 'Urease, gamma-subunit', 286161),
(476141, '0037041', NULL, NULL, 100, NULL, 'Urease, gamma-subunit', 286161),
(476142, '0036861', NULL, NULL, 105, NULL, 'Urease, gamma-subunit', 286161),
(476143, '0047267', NULL, NULL, 118, NULL, 'Fumarylacetoacetate hydrolase, FAH, N-terminal domain', 286162),
(476144, '0052993', NULL, NULL, 155, NULL, 'EndoU-like', 286163),
(476145, '0052950', NULL, NULL, 153, NULL, 'EndoU-like', 286163),
(476146, '0052094', NULL, NULL, 284, NULL, 'EndoU-like', 286163),
(476147, '0041928', NULL, NULL, 61, NULL, 'Transducin (heterotrimeric G protein), gamma chain', 286164),
(476148, '0043930', NULL, NULL, 68, NULL, 'Transducin (heterotrimeric G protein), gamma chain', 286164),
(476149, '0049093', NULL, NULL, 202, NULL, 'Mob1/phocein', 286165),
(476150, '0054854', NULL, NULL, 324, NULL, 'Tex N-terminal region-like', 286166),
(476151, '0037010', NULL, NULL, 48, NULL, 'Heat-stable enterotoxin B', 286167),
(476152, '0038012', NULL, NULL, 317, NULL, 'gp120 core', 286168),
(476153, '0038014', NULL, NULL, 306, NULL, 'gp120 core', 286168),
(476154, '0053728', NULL, NULL, 339, NULL, 'gp120 core', 286168),
(476155, '0050131', NULL, NULL, 95, NULL, 'YccV-like', 286169),
(476156, '0035109', NULL, NULL, 514, NULL, 'Acetyl-CoA synthetase-like', 286170),
(476157, '0040451', NULL, NULL, 541, NULL, 'Acetyl-CoA synthetase-like', 286170),
(476158, '0042298', NULL, NULL, 643, NULL, 'Acetyl-CoA synthetase-like', 286170),
(476159, '0044590', NULL, NULL, 534, NULL, 'Acetyl-CoA synthetase-like', 286170),
(476160, '0043409', NULL, NULL, 640, NULL, 'Acetyl-CoA synthetase-like', 286170),
(476161, '0040895', NULL, NULL, 536, NULL, 'Acetyl-CoA synthetase-like', 286170),
(476162, '0043886', NULL, NULL, 503, NULL, 'Acetyl-CoA synthetase-like', 286170),
(476163, '0050878', NULL, NULL, 53, NULL, 'Hypothetical membrane protein Ta0354, soluble domain', 286171),
(476164, '0054770', NULL, NULL, 37, NULL, 'Ribosomal protein L36', 286172),
(476165, '0053071', NULL, NULL, 38, NULL, 'Ribosomal protein L36', 286172),
(476166, '0036403', NULL, NULL, 37, NULL, 'Ribosomal protein L36', 286172),
(476167, '0044218', NULL, NULL, 383, NULL, 'Ammonium transporter', 286173),
(476168, '0054118', NULL, NULL, 166, NULL, 'BH3703-like', 286174),
(476169, '0041441', NULL, NULL, 220, NULL, 'Helical scaffold and wing domains of SecA', 286175),
(476170, '0040824', NULL, NULL, 232, NULL, 'Helical scaffold and wing domains of SecA', 286175),
(476171, '0038600', NULL, NULL, 274, NULL, 'Dipeptide transport protein', 286176),
(476172, '0054748', NULL, NULL, 173, NULL, 'MgtE membrane domain-like', 286177),
(476173, '0039077', NULL, NULL, 179, NULL, 'Isochorismatase-like hydrolases', 286178),
(476174, '0041293', NULL, NULL, 253, NULL, 'Isochorismatase-like hydrolases', 286178),
(476175, '0045069', NULL, NULL, 204, NULL, 'Isochorismatase-like hydrolases', 286178),
(476176, '0039336', NULL, NULL, 188, NULL, 'Isochorismatase-like hydrolases', 286178),
(476177, '0041359', NULL, NULL, 207, NULL, 'Isochorismatase-like hydrolases', 286178),
(476178, '0045018', NULL, NULL, 192, NULL, 'Isochorismatase-like hydrolases', 286178),
(476179, '0048691', NULL, NULL, 140, NULL, 'Outer surface protein', 286179),
(476180, '0042010', NULL, NULL, 251, NULL, 'Outer surface protein', 286179),
(476181, '0054586', NULL, NULL, 101, NULL, 'Ribosomal protein S3 C-terminal domain', 286180),
(476182, '0037615', NULL, NULL, 101, NULL, 'Ribosomal protein S3 C-terminal domain', 286180);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(476183, '0047042', NULL, NULL, 141, NULL, 'Type II 3-dehydroquinate dehydratase', 286181),
(476184, '0052430', NULL, NULL, 141, NULL, 'Type II 3-dehydroquinate dehydratase', 286181),
(476185, '0046245', NULL, NULL, 150, NULL, 'Type II 3-dehydroquinate dehydratase', 286181),
(476186, '0047501', NULL, NULL, 158, NULL, 'Type II 3-dehydroquinate dehydratase', 286181),
(476187, '0049974', NULL, NULL, 146, NULL, 'Type II 3-dehydroquinate dehydratase', 286181),
(476188, '0035012', NULL, NULL, 90, NULL, 'Domain of early E2A DNA-binding protein, ADDBP', 286182),
(476189, '0053632', NULL, NULL, 170, NULL, 'Phage tail proteins', 286183),
(476190, '0054884', NULL, NULL, 179, NULL, 'Phage tail proteins', 286183),
(476191, '0054883', NULL, NULL, 168, NULL, 'Phage tail proteins', 286183),
(476192, '0054464', NULL, NULL, 176, NULL, 'Phage tail proteins', 286183),
(476193, '0039828', NULL, NULL, 117, NULL, 'Phage tail proteins', 286183),
(476194, '0054463', NULL, NULL, 187, NULL, 'Phage tail proteins', 286183),
(476195, '0053978', NULL, NULL, 139, NULL, 'Phage tail proteins', 286183),
(476196, '0039864', NULL, NULL, 176, NULL, 'Phage tail proteins', 286183),
(476197, '0053633', NULL, NULL, 174, NULL, 'Phage tail proteins', 286183),
(476198, '0054535', NULL, NULL, 93, NULL, 'Phage tail proteins', 286183),
(476199, '0054920', NULL, NULL, 169, NULL, 'Phage tail proteins', 286183),
(476200, '0039863', NULL, NULL, 197, NULL, 'Phage tail proteins', 286183),
(476201, '0054919', NULL, NULL, 173, NULL, 'Phage tail proteins', 286183),
(476202, '0039968', NULL, NULL, 174, NULL, 'Arp2/3 complex 21 kDa subunit ARPC3', 286184),
(476203, '0046564', NULL, NULL, 103, NULL, 'D-aminopeptidase, middle and C-terminal domains', 286185),
(476204, '0037016', NULL, NULL, 82, NULL, 'D-aminopeptidase, middle and C-terminal domains', 286185),
(476205, '0039462', NULL, NULL, 29, NULL, 'Subunit PsaX of photosystem I reaction centre', 286186),
(476206, '0035324', NULL, NULL, 67, NULL, 'Allophycocyanin linker chain (domain)', 286187),
(476207, '0039531', NULL, NULL, 83, NULL, 'GTP cyclohydrolase I feedback regulatory protein, GFRP', 286188),
(476208, '0039279', NULL, NULL, 196, NULL, 'BRCA2 helical domain', 286189),
(476209, '0040951', NULL, NULL, 191, NULL, 'BRCA2 helical domain', 286189),
(476210, '0049883', NULL, NULL, 151, NULL, 'Lamin A/C globular tail domain', 286190),
(476211, '0047450', NULL, NULL, 122, NULL, 'Lamin A/C globular tail domain', 286190),
(476212, '0051633', NULL, NULL, 156, NULL, 'MAL13P1.257-like', 286191),
(476213, '0044068', NULL, NULL, 371, NULL, 'Glycerate kinase I', 286192),
(476214, '0040771', NULL, NULL, 216, NULL, 'Group II dsDNA viruses VP', 286193),
(476215, '0047254', NULL, NULL, 140, NULL, 'Group II dsDNA viruses VP', 286193),
(476216, '0048079', NULL, NULL, 197, NULL, 'Group II dsDNA viruses VP', 286193),
(476217, '0047253', NULL, NULL, 230, NULL, 'Group II dsDNA viruses VP', 286193),
(476218, '0048686', NULL, NULL, 312, NULL, 'Group II dsDNA viruses VP', 286193),
(476219, '0042129', NULL, NULL, 632, NULL, 'Group II dsDNA viruses VP', 286193),
(476220, '0042127', NULL, NULL, 646, NULL, 'Group II dsDNA viruses VP', 286193),
(476221, '0047378', NULL, NULL, 266, NULL, 'YWTD domain', 286194),
(476222, '0048415', NULL, NULL, 263, NULL, 'YWTD domain', 286194),
(476223, '0039351', NULL, NULL, 164, NULL, 'RraA-like', 286195),
(476224, '0041607', NULL, NULL, 156, NULL, 'RraA-like', 286195),
(476225, '0042629', NULL, NULL, 160, NULL, 'RraA-like', 286195),
(476226, '0044772', NULL, NULL, 162, NULL, 'RraA-like', 286195),
(476227, '0039995', NULL, NULL, 108, NULL, 'DNA-binding C-terminal domain of the transcription factor MotA', 286196),
(476228, '0039641', NULL, NULL, 667, NULL, 'Membrane penetration protein mu1', 286197),
(476229, '0039683', NULL, NULL, 67, NULL, 'Homodimeric domain of signal transducing histidine kinase', 286198),
(476230, '0052096', NULL, NULL, 89, NULL, 'Homodimeric domain of signal transducing histidine kinase', 286198),
(476231, '0035337', NULL, NULL, 62, NULL, 'Homodimeric domain of signal transducing histidine kinase', 286198);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(476232, '0049422', NULL, NULL, 141, NULL, 'Riboflavin synthase domain-like', 286199),
(476233, '0052010', NULL, NULL, 133, NULL, 'Riboflavin synthase domain-like', 286199),
(476234, '0038027', NULL, NULL, 146, NULL, 'Riboflavin synthase domain-like', 286199),
(476235, '0038920', NULL, NULL, 93, NULL, 'Riboflavin synthase domain-like', 286199),
(476236, '0038921', NULL, NULL, 113, NULL, 'Riboflavin synthase domain-like', 286199),
(476237, '0040333', NULL, NULL, 92, NULL, 'Riboflavin synthase domain-like', 286199),
(476238, '0046758', NULL, NULL, 99, NULL, 'Riboflavin synthase domain-like', 286199),
(476239, '0041321', NULL, NULL, 123, NULL, 'Riboflavin synthase domain-like', 286199),
(476240, '0049949', NULL, NULL, 124, NULL, 'Riboflavin synthase domain-like', 286199),
(476241, '0046818', NULL, NULL, 136, NULL, 'Riboflavin synthase domain-like', 286199),
(476242, '0045224', NULL, NULL, 114, NULL, 'Riboflavin synthase domain-like', 286199),
(476243, '0040334', NULL, NULL, 110, NULL, 'Riboflavin synthase domain-like', 286199),
(476244, '0038912', NULL, NULL, 125, NULL, 'Riboflavin synthase domain-like', 286199),
(476245, '0034954', NULL, NULL, 99, NULL, 'Riboflavin synthase domain-like', 286199),
(476246, '0036118', NULL, NULL, 111, NULL, 'Riboflavin synthase domain-like', 286199),
(476247, '0040221', NULL, NULL, 100, NULL, 'Riboflavin synthase domain-like', 286199),
(476248, '0048947', NULL, NULL, 153, NULL, 'Riboflavin synthase domain-like', 286199),
(476249, '0045794', NULL, NULL, 276, NULL, 'Riboflavin synthase domain-like', 286199),
(476250, '0046685', NULL, NULL, 270, NULL, 'Riboflavin synthase domain-like', 286199),
(476251, '0053271', NULL, NULL, 103, NULL, 'Riboflavin synthase domain-like', 286199),
(476252, '0038291', NULL, NULL, 107, NULL, 'Riboflavin synthase domain-like', 286199),
(476253, '0049710', NULL, NULL, 109, NULL, 'Riboflavin synthase domain-like', 286199),
(476254, '0047554', NULL, NULL, 157, NULL, 'Riboflavin synthase domain-like', 286199),
(476255, '0046600', NULL, NULL, 101, NULL, 'Riboflavin synthase domain-like', 286199),
(476256, '0046305', NULL, NULL, 221, NULL, 'Riboflavin synthase domain-like', 286199),
(476257, '0042742', NULL, NULL, 97, NULL, 'Riboflavin synthase domain-like', 286199),
(476258, '0048783', NULL, NULL, 72, NULL, 'Putative DNA-binding domain', 286200),
(476259, '0044064', NULL, NULL, 76, NULL, 'Putative DNA-binding domain', 286200),
(476260, '0039468', NULL, NULL, 106, NULL, 'Putative DNA-binding domain', 286200),
(476261, '0037930', NULL, NULL, 69, NULL, 'Putative DNA-binding domain', 286200),
(476262, '0039432', NULL, NULL, 68, NULL, 'Putative DNA-binding domain', 286200),
(476263, '0036272', NULL, NULL, 75, NULL, 'Putative DNA-binding domain', 286200),
(476264, '0040420', NULL, NULL, 101, NULL, 'Putative DNA-binding domain', 286200),
(476265, '0042546', NULL, NULL, 127, NULL, 'Putative DNA-binding domain', 286200),
(476266, '0037244', NULL, NULL, 118, NULL, 'Putative DNA-binding domain', 286200),
(476267, '0042547', NULL, NULL, 94, NULL, 'Putative DNA-binding domain', 286200),
(476268, '0041317', NULL, NULL, 49, NULL, 'Putative DNA-binding domain', 286200),
(476269, '0042521', NULL, NULL, 78, NULL, 'Putative DNA-binding domain', 286200),
(476270, '0042522', NULL, NULL, 75, NULL, 'Putative DNA-binding domain', 286200),
(476271, '0043545', NULL, NULL, 106, NULL, 'Putative DNA-binding domain', 286200),
(476272, '0037100', NULL, NULL, 114, NULL, 'Elongation factor TFIIS domain 2', 286201),
(476273, '0042733', NULL, NULL, 288, NULL, 'gp9', 286202),
(476274, '0048240', NULL, NULL, 134, NULL, 'Formate/glycerate dehydrogenase catalytic domain-like', 286203),
(476275, '0045380', NULL, NULL, 187, NULL, 'Formate/glycerate dehydrogenase catalytic domain-like', 286203),
(476276, '0034926', NULL, NULL, 269, NULL, 'Formate/glycerate dehydrogenase catalytic domain-like', 286203),
(476277, '0051306', NULL, NULL, 131, NULL, 'Formate/glycerate dehydrogenase catalytic domain-like', 286203),
(476278, '0037438', NULL, NULL, 202, NULL, 'Formate/glycerate dehydrogenase catalytic domain-like', 286203);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(476279, '0052457', NULL, NULL, 141, NULL, 'Formate/glycerate dehydrogenase catalytic domain-like', 286203),
(476280, '0038058', NULL, NULL, 130, NULL, 'Formate/glycerate dehydrogenase catalytic domain-like', 286203),
(476281, '0048809', NULL, NULL, 133, NULL, 'Formate/glycerate dehydrogenase catalytic domain-like', 286203),
(476282, '0042915', NULL, NULL, 122, NULL, 'Formate/glycerate dehydrogenase catalytic domain-like', 286203),
(476283, '0046421', NULL, NULL, 132, NULL, 'Formate/glycerate dehydrogenase catalytic domain-like', 286203),
(476284, '0047511', NULL, NULL, 135, NULL, 'Formate/glycerate dehydrogenase catalytic domain-like', 286203),
(476285, '0050091', NULL, NULL, 314, NULL, 'Formate/glycerate dehydrogenase catalytic domain-like', 286203),
(476286, '0042341', NULL, NULL, 194, NULL, 'Formate/glycerate dehydrogenase catalytic domain-like', 286203),
(476287, '0054045', NULL, NULL, 66, NULL, 'YcfA/nrd intein domain', 286204),
(476288, '0036551', NULL, NULL, 79, NULL, 'YcfA/nrd intein domain', 286204),
(476289, '0050569', NULL, NULL, 70, NULL, 'YcfA/nrd intein domain', 286204),
(476290, '0046174', NULL, NULL, 528, NULL, 'DNA/RNA polymerases', 286205),
(476291, '0047189', NULL, NULL, 664, NULL, 'DNA/RNA polymerases', 286205),
(476292, '0044175', NULL, NULL, 476, NULL, 'DNA/RNA polymerases', 286205),
(476293, '0041083', NULL, NULL, 427, NULL, 'DNA/RNA polymerases', 286205),
(476294, '0044909', NULL, NULL, 426, NULL, 'DNA/RNA polymerases', 286205),
(476295, '0050972', NULL, NULL, 388, NULL, 'DNA/RNA polymerases', 286205),
(476296, '0042798', NULL, NULL, 403, NULL, 'DNA/RNA polymerases', 286205),
(476297, '0042977', NULL, NULL, 409, NULL, 'DNA/RNA polymerases', 286205),
(476298, '0047809', NULL, NULL, 497, NULL, 'DNA/RNA polymerases', 286205),
(476299, '0043905', NULL, NULL, 494, NULL, 'DNA/RNA polymerases', 286205),
(476300, '0049525', NULL, NULL, 273, NULL, 'DNA/RNA polymerases', 286205),
(476301, '0049324', NULL, NULL, 415, NULL, 'DNA/RNA polymerases', 286205),
(476302, '0047702', NULL, NULL, 240, NULL, 'DNA/RNA polymerases', 286205),
(476303, '0047722', NULL, NULL, 239, NULL, 'DNA/RNA polymerases', 286205),
(476304, '0044996', NULL, NULL, 411, NULL, 'DNA/RNA polymerases', 286205),
(476305, '0051078', NULL, NULL, 460, NULL, 'DNA/RNA polymerases', 286205),
(476306, '0049395', NULL, NULL, 502, NULL, 'DNA/RNA polymerases', 286205),
(476307, '0051077', NULL, NULL, 460, NULL, 'DNA/RNA polymerases', 286205),
(476308, '0053016', NULL, NULL, 408, NULL, 'DNA/RNA polymerases', 286205),
(476309, '0049251', NULL, NULL, 451, NULL, 'DNA/RNA polymerases', 286205),
(476310, '0047595', NULL, NULL, 389, NULL, 'DNA/RNA polymerases', 286205),
(476311, '0049312', NULL, NULL, 588, NULL, 'DNA/RNA polymerases', 286205),
(476312, '0051076', NULL, NULL, 460, NULL, 'DNA/RNA polymerases', 286205),
(476313, '0035949', NULL, NULL, 878, NULL, 'DNA/RNA polymerases', 286205),
(476314, '0036278', NULL, NULL, 386, NULL, 'DNA/RNA polymerases', 286205),
(476315, '0038511', NULL, NULL, 216, NULL, 'DNA/RNA polymerases', 286205),
(476316, '0041091', NULL, NULL, 1264, NULL, 'DNA/RNA polymerases', 286205),
(476317, '0054504', NULL, NULL, 774, NULL, 'DNA/RNA polymerases', 286205),
(476318, '0043914', NULL, NULL, 333, NULL, 'DNA/RNA polymerases', 286205),
(476319, '0040062', NULL, NULL, 410, NULL, 'DNA/RNA polymerases', 286205),
(476320, '0046068', NULL, NULL, 563, NULL, 'DNA/RNA polymerases', 286205),
(476321, '0044001', NULL, NULL, 426, NULL, 'DNA/RNA polymerases', 286205),
(476322, '0042660', NULL, NULL, 394, NULL, 'DNA/RNA polymerases', 286205),
(476323, '0049138', NULL, NULL, 461, NULL, 'DNA/RNA polymerases', 286205),
(476324, '0042268', NULL, NULL, 129, NULL, 'PTS system fructose IIA component-like', 286206),
(476325, '0054827', NULL, NULL, 132, NULL, 'PTS system fructose IIA component-like', 286206),
(476326, '0054904', NULL, NULL, 123, NULL, 'PTS system fructose IIA component-like', 286206),
(476327, '0054804', NULL, NULL, 132, NULL, 'PTS system fructose IIA component-like', 286206),
(476328, '0052015', NULL, NULL, 63, NULL, 'Phage replication organizer domain', 286207);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(476329, '0050395', NULL, NULL, 192, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476330, '0052450', NULL, NULL, 229, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476331, '0050394', NULL, NULL, 365, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476332, '0039738', NULL, NULL, 188, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476333, '0051963', NULL, NULL, 203, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476334, '0041167', NULL, NULL, 227, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476335, '0044439', NULL, NULL, 362, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476336, '0039059', NULL, NULL, 191, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476337, '0039197', NULL, NULL, 338, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476338, '0039198', NULL, NULL, 192, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476339, '0048897', NULL, NULL, 183, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476340, '0049028', NULL, NULL, 407, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476341, '0048896', NULL, NULL, 180, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476342, '0040413', NULL, NULL, 230, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476343, '0041403', NULL, NULL, 192, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476344, '0042410', NULL, NULL, 174, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476345, '0044478', NULL, NULL, 186, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476346, '0049968', NULL, NULL, 198, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476347, '0040412', NULL, NULL, 415, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476348, '0041402', NULL, NULL, 362, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476349, '0042411', NULL, NULL, 228, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476350, '0045129', NULL, NULL, 186, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476351, '0052103', NULL, NULL, 188, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476352, '0049136', NULL, NULL, 336, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476353, '0045130', NULL, NULL, 204, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476354, '0049135', NULL, NULL, 190, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476355, '0051271', NULL, NULL, 208, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476356, '0052449', NULL, NULL, 184, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476357, '0052104', NULL, NULL, 183, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476358, '0045857', NULL, NULL, 257, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476359, '0042102', NULL, NULL, 192, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476360, '0042965', NULL, NULL, 204, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476361, '0045858', NULL, NULL, 447, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476362, '0042101', NULL, NULL, 181, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476363, '0036596', NULL, NULL, 394, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476364, '0042045', NULL, NULL, 196, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476365, '0042044', NULL, NULL, 178, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476366, '0044440', NULL, NULL, 186, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476367, '0044101', NULL, NULL, 335, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476368, '0051270', NULL, NULL, 195, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(476369, '0044102', NULL, NULL, 197, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476370, '0042761', NULL, NULL, 195, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476371, '0042487', NULL, NULL, 172, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476372, '0042762', NULL, NULL, 331, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476373, '0042488', NULL, NULL, 196, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', 286208),
(476374, '0052577', NULL, NULL, 92, NULL, 'Glu-tRNAGln amidotransferase C subunit', 286209),
(476375, '0053620', NULL, NULL, 331, NULL, 'Inosine monophosphate dehydrogenase (IMPDH)', 286210),
(476376, '0047561', NULL, NULL, 371, NULL, 'Inosine monophosphate dehydrogenase (IMPDH)', 286210),
(476377, '0046530', NULL, NULL, 388, NULL, 'Inosine monophosphate dehydrogenase (IMPDH)', 286210),
(476378, '0048832', NULL, NULL, 363, NULL, 'Inosine monophosphate dehydrogenase (IMPDH)', 286210),
(476379, '0051569', NULL, NULL, 366, NULL, 'Inosine monophosphate dehydrogenase (IMPDH)', 286210),
(476380, '0047664', NULL, NULL, 379, NULL, 'Inosine monophosphate dehydrogenase (IMPDH)', 286210),
(476381, '0053789', NULL, NULL, 369, NULL, 'Inosine monophosphate dehydrogenase (IMPDH)', 286210),
(476382, '0053824', NULL, NULL, 63, NULL, 'PRP4-like', 286211),
(476383, '0034955', NULL, NULL, 158, NULL, 'Ferredoxin reductase-like, C-terminal NADP-linked domain', 286212),
(476384, '0052188', NULL, NULL, 146, NULL, 'Ferredoxin reductase-like, C-terminal NADP-linked domain', 286212),
(476385, '0049950', NULL, NULL, 147, NULL, 'Ferredoxin reductase-like, C-terminal NADP-linked domain', 286212),
(476386, '0052011', NULL, NULL, 162, NULL, 'Ferredoxin reductase-like, C-terminal NADP-linked domain', 286212),
(476387, '0037504', NULL, NULL, 148, NULL, 'Ferredoxin reductase-like, C-terminal NADP-linked domain', 286212),
(476388, '0035107', NULL, NULL, 160, NULL, 'Ferredoxin reductase-like, C-terminal NADP-linked domain', 286212),
(476389, '0036119', NULL, NULL, 142, NULL, 'Ferredoxin reductase-like, C-terminal NADP-linked domain', 286212),
(476390, '0038028', NULL, NULL, 158, NULL, 'Ferredoxin reductase-like, C-terminal NADP-linked domain', 286212),
(476391, '0037677', NULL, NULL, 160, NULL, 'Ferredoxin reductase-like, C-terminal NADP-linked domain', 286212),
(476392, '0042754', NULL, NULL, 155, NULL, 'Ferredoxin reductase-like, C-terminal NADP-linked domain', 286212),
(476393, '0040222', NULL, NULL, 133, NULL, 'Ferredoxin reductase-like, C-terminal NADP-linked domain', 286212),
(476394, '0041322', NULL, NULL, 147, NULL, 'Ferredoxin reductase-like, C-terminal NADP-linked domain', 286212),
(476395, '0036370', NULL, NULL, 153, NULL, 'Ferredoxin reductase-like, C-terminal NADP-linked domain', 286212),
(476396, '0039466', NULL, NULL, 154, NULL, 'Ferredoxin reductase-like, C-terminal NADP-linked domain', 286212),
(476397, '0043660', NULL, NULL, 155, NULL, 'Ferredoxin reductase-like, C-terminal NADP-linked domain', 286212),
(476398, '0049711', NULL, NULL, 141, NULL, 'Ferredoxin reductase-like, C-terminal NADP-linked domain', 286212),
(476399, '0053272', NULL, NULL, 120, NULL, 'Ferredoxin reductase-like, C-terminal NADP-linked domain', 286212),
(476400, '0038292', NULL, NULL, 143, NULL, 'Ferredoxin reductase-like, C-terminal NADP-linked domain', 286212),
(476401, '0046686', NULL, NULL, 165, NULL, 'Ferredoxin reductase-like, C-terminal NADP-linked domain', 286212),
(476402, '0047323', NULL, NULL, 147, NULL, 'Ferredoxin reductase-like, C-terminal NADP-linked domain', 286212),
(476403, '0046601', NULL, NULL, 160, NULL, 'Ferredoxin reductase-like, C-terminal NADP-linked domain', 286212),
(476404, '0048943', NULL, NULL, 135, NULL, 'Ferredoxin reductase-like, C-terminal NADP-linked domain', 286212),
(476405, '0053796', NULL, NULL, 118, NULL, 'Rnp2-like', 286213),
(476406, '0053705', NULL, NULL, 106, NULL, 'Rnp2-like', 286213),
(476407, '0049339', NULL, NULL, 158, NULL, 'Trimeric adhesin', 286214),
(476408, '0047281', NULL, NULL, 340, NULL, 'FAD-linked oxidases, C-terminal domain', 286215);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(476409, '0046341', NULL, NULL, 279, NULL, 'FAD-linked oxidases, C-terminal domain', 286215),
(476410, '0046671', NULL, NULL, 294, NULL, 'FAD-linked oxidases, C-terminal domain', 286215),
(476411, '0046489', NULL, NULL, 287, NULL, 'FAD-linked oxidases, C-terminal domain', 286215),
(476412, '0050336', NULL, NULL, 289, NULL, 'FAD-linked oxidases, C-terminal domain', 286215),
(476413, '0042700', NULL, NULL, 101, NULL, 'Inhibitor of apoptosis (IAP) repeat', 286216),
(476414, '0036727', NULL, NULL, 136, NULL, 'Inhibitor of apoptosis (IAP) repeat', 286216),
(476415, '0042068', NULL, NULL, 99, NULL, 'Inhibitor of apoptosis (IAP) repeat', 286216),
(476416, '0039490', NULL, NULL, 105, NULL, 'Inhibitor of apoptosis (IAP) repeat', 286216),
(476417, '0053073', NULL, NULL, 90, NULL, 'Inhibitor of apoptosis (IAP) repeat', 286216),
(476418, '0050901', NULL, NULL, 101, NULL, 'Inhibitor of apoptosis (IAP) repeat', 286216),
(476419, '0037913', NULL, NULL, 117, NULL, 'Inhibitor of apoptosis (IAP) repeat', 286216),
(476420, '0040778', NULL, NULL, 112, NULL, 'Inhibitor of apoptosis (IAP) repeat', 286216),
(476421, '0043565', NULL, NULL, 97, NULL, 'Inhibitor of apoptosis (IAP) repeat', 286216),
(476422, '0035887', NULL, NULL, 117, NULL, 'Inhibitor of apoptosis (IAP) repeat', 286216),
(476423, '0035370', NULL, NULL, 296, NULL, 'Creatinase/aminopeptidase', 286217),
(476424, '0035818', NULL, NULL, 262, NULL, 'Creatinase/aminopeptidase', 286217),
(476425, '0045044', NULL, NULL, 219, NULL, 'Creatinase/aminopeptidase', 286217),
(476426, '0040193', NULL, NULL, 246, NULL, 'Creatinase/aminopeptidase', 286217),
(476427, '0042482', NULL, NULL, 221, NULL, 'Creatinase/aminopeptidase', 286217),
(476428, '0052072', NULL, NULL, 264, NULL, 'Creatinase/aminopeptidase', 286217),
(476429, '0041657', NULL, NULL, 249, NULL, 'Creatinase/aminopeptidase', 286217),
(476430, '0035987', NULL, NULL, 246, NULL, 'Creatinase/aminopeptidase', 286217),
(476431, '0043037', NULL, NULL, 249, NULL, 'Creatinase/aminopeptidase', 286217),
(476432, '0039247', NULL, NULL, 88, NULL, 'Multidrug efflux transporter AcrB TolC docking domain; DN and DC subdomains', 286218),
(476433, '0039246', NULL, NULL, 92, NULL, 'Multidrug efflux transporter AcrB TolC docking domain; DN and DC subdomains', 286218),
(476434, '0053751', NULL, NULL, 100, NULL, 'Bacteriocin immunity protein-like', 286219),
(476435, '0049598', NULL, NULL, 111, NULL, 'Bacteriocin immunity protein-like', 286219),
(476436, '0041663', NULL, NULL, 70, NULL, 'Nucleoside phosphorylase/phosphoribosyltransferase N-terminal domain', 286220),
(476437, '0044470', NULL, NULL, 68, NULL, 'Nucleoside phosphorylase/phosphoribosyltransferase N-terminal domain', 286220),
(476438, '0045472', NULL, NULL, 70, NULL, 'Nucleoside phosphorylase/phosphoribosyltransferase N-terminal domain', 286220),
(476439, '0040083', NULL, NULL, 69, NULL, 'Nucleoside phosphorylase/phosphoribosyltransferase N-terminal domain', 286220),
(476440, '0035684', NULL, NULL, 70, NULL, 'Nucleoside phosphorylase/phosphoribosyltransferase N-terminal domain', 286220),
(476441, '0044665', NULL, NULL, 65, NULL, 'Nucleoside phosphorylase/phosphoribosyltransferase N-terminal domain', 286220),
(476442, '0053288', NULL, NULL, 317, NULL, 'Annexin', 286221),
(476443, '0053100', NULL, NULL, 318, NULL, 'Annexin', 286221),
(476444, '0047297', NULL, NULL, 309, NULL, 'Annexin', 286221),
(476445, '0038746', NULL, NULL, 313, NULL, 'Annexin', 286221),
(476446, '0035256', NULL, NULL, 323, NULL, 'Annexin', 286221),
(476447, '0036466', NULL, NULL, 316, NULL, 'Annexin', 286221),
(476448, '0050389', NULL, NULL, 319, NULL, 'Annexin', 286221),
(476449, '0035227', NULL, NULL, 321, NULL, 'Annexin', 286221),
(476450, '0035226', NULL, NULL, 341, NULL, 'Annexin', 286221),
(476451, '0038635', NULL, NULL, 343, NULL, 'Annexin', 286221),
(476452, '0035060', NULL, NULL, 314, NULL, 'Annexin', 286221),
(476453, '0035089', NULL, NULL, 316, NULL, 'Annexin', 286221),
(476454, '0036495', NULL, NULL, 315, NULL, 'Annexin', 286221),
(476455, '0041163', NULL, NULL, 318, NULL, 'Annexin', 286221);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(476456, '0040853', NULL, NULL, 323, NULL, 'Annexin', 286221),
(476457, '0040852', NULL, NULL, 341, NULL, 'Annexin', 286221),
(476458, '0053214', NULL, NULL, 117, NULL, 'XisI-like', 286222),
(476459, '0053220', NULL, NULL, 112, NULL, 'XisI-like', 286222),
(476460, '0053197', NULL, NULL, 111, NULL, 'XisI-like', 286222),
(476461, '0038696', NULL, NULL, 208, NULL, 'Leukotriene A4 hydrolase N-terminal domain', 286223),
(476462, '0054081', NULL, NULL, 185, NULL, 'MM3350-like', 286224),
(476463, '0045317', NULL, NULL, 71, NULL, 'HIPIP (high potential iron protein)', 286225),
(476464, '0038630', NULL, NULL, 75, NULL, 'HIPIP (high potential iron protein)', 286225),
(476465, '0039185', NULL, NULL, 62, NULL, 'HIPIP (high potential iron protein)', 286225),
(476466, '0038665', NULL, NULL, 71, NULL, 'HIPIP (high potential iron protein)', 286225),
(476467, '0037269', NULL, NULL, 83, NULL, 'HIPIP (high potential iron protein)', 286225),
(476468, '0039732', NULL, NULL, 89, NULL, 'HIPIP (high potential iron protein)', 286225),
(476469, '0045525', NULL, NULL, 82, NULL, 'HIPIP (high potential iron protein)', 286225),
(476470, '0050593', NULL, NULL, 143, NULL, 'Band 7/SPFH domain', 286226),
(476471, '0039563', NULL, NULL, 111, NULL, 'DsrC, the gamma subunit of dissimilatory sulfite reductase', 286227),
(476472, '0054701', NULL, NULL, 103, NULL, 'DsrC, the gamma subunit of dissimilatory sulfite reductase', 286227),
(476473, '0042664', NULL, NULL, 118, NULL, 'Holliday junction resolvase RusA', 286228),
(476474, '0046796', NULL, NULL, 237, NULL, 'Ribosomal protein S2', 286229),
(476475, '0050191', NULL, NULL, 193, NULL, 'Ribosomal protein S2', 286229),
(476476, '0053985', NULL, NULL, 218, NULL, 'Ribosomal protein S2', 286229),
(476477, '0040388', NULL, NULL, 160, NULL, 'Aconitase B, N-terminal domain', 286230),
(476478, '0036696', NULL, NULL, 48, NULL, 'LysM domain', 286231),
(476479, '0051227', NULL, NULL, 48, NULL, 'LysM domain', 286231),
(476480, '0047629', NULL, NULL, 95, NULL, 'DNA polymerase beta, N-terminal domain-like', 286232),
(476481, '0048475', NULL, NULL, 86, NULL, 'DNA polymerase beta, N-terminal domain-like', 286232),
(476482, '0045992', NULL, NULL, 82, NULL, 'DNA polymerase beta, N-terminal domain-like', 286232),
(476483, '0046345', NULL, NULL, 87, NULL, 'DNA polymerase beta, N-terminal domain-like', 286232),
(476484, '0051212', NULL, NULL, 151, NULL, 'GUN4-like', 286233),
(476485, '0051488', NULL, NULL, 148, NULL, 'GUN4-like', 286233),
(476486, '0053499', NULL, NULL, 303, NULL, 'Bacterial hemolysins', 286234),
(476487, '0054292', NULL, NULL, 340, NULL, 'Bacterial hemolysins', 286234),
(476488, '0037715', NULL, NULL, 275, NULL, 'Upper collar protein gp10 (connector protein)', 286235),
(476489, '0051838', NULL, NULL, 84, NULL, 'NE0471 N-terminal domain-like', 286236),
(476490, '0051217', NULL, NULL, 124, NULL, 'Kinase-associated protein B-like', 286237),
(476491, '0036509', NULL, NULL, 589, NULL, 'Sec1/munc18-like (SM) proteins', 286238),
(476492, '0037122', NULL, NULL, 590, NULL, 'Sec1/munc18-like (SM) proteins', 286238),
(476493, '0041050', NULL, NULL, 653, NULL, 'Sec1/munc18-like (SM) proteins', 286238),
(476494, '0053101', NULL, NULL, 113, NULL, 'MK0786-like', 286239),
(476495, '0053075', NULL, NULL, 120, NULL, 'MK0786-like', 286239),
(476496, '0050197', NULL, NULL, 192, NULL, 'SIS domain', 286240),
(476497, '0048077', NULL, NULL, 186, NULL, 'SIS domain', 286240),
(476498, '0046385', NULL, NULL, 555, NULL, 'SIS domain', 286240),
(476499, '0039507', NULL, NULL, 177, NULL, 'SIS domain', 286240),
(476500, '0046090', NULL, NULL, 442, NULL, 'SIS domain', 286240),
(476501, '0047090', NULL, NULL, 554, NULL, 'SIS domain', 286240),
(476502, '0050600', NULL, NULL, 284, NULL, 'SIS domain', 286240),
(476503, '0050875', NULL, NULL, 194, NULL, 'SIS domain', 286240),
(476504, '0039383', NULL, NULL, 329, NULL, 'SIS domain', 286240),
(476505, '0049514', NULL, NULL, 556, NULL, 'SIS domain', 286240),
(476506, '0049756', NULL, NULL, 556, NULL, 'SIS domain', 286240),
(476507, '0048425', NULL, NULL, 248, NULL, 'SIS domain', 286240);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(476508, '0044035', NULL, NULL, 188, NULL, 'SIS domain', 286240),
(476509, '0048203', NULL, NULL, 366, NULL, 'SIS domain', 286240),
(476510, '0045017', NULL, NULL, 191, NULL, 'SIS domain', 286240),
(476511, '0049747', NULL, NULL, 301, NULL, 'SIS domain', 286240),
(476512, '0047338', NULL, NULL, 556, NULL, 'SIS domain', 286240),
(476513, '0054730', NULL, NULL, 128, NULL, 'FAD-linked reductases, C-terminal domain', 286241),
(476514, '0038927', NULL, NULL, 69, NULL, 'FAD-linked reductases, C-terminal domain', 286241),
(476515, '0048495', NULL, NULL, 112, NULL, 'FAD-linked reductases, C-terminal domain', 286241),
(476516, '0039759', NULL, NULL, 170, NULL, 'FAD-linked reductases, C-terminal domain', 286241),
(476517, '0035355', NULL, NULL, 132, NULL, 'FAD-linked reductases, C-terminal domain', 286241),
(476518, '0035955', NULL, NULL, 196, NULL, 'FAD-linked reductases, C-terminal domain', 286241),
(476519, '0035118', NULL, NULL, 93, NULL, 'FAD-linked reductases, C-terminal domain', 286241),
(476520, '0037711', NULL, NULL, 101, NULL, 'FAD-linked reductases, C-terminal domain', 286241),
(476521, '0036284', NULL, NULL, 97, NULL, 'FAD-linked reductases, C-terminal domain', 286241),
(476522, '0044415', NULL, NULL, 98, NULL, 'FAD-linked reductases, C-terminal domain', 286241),
(476523, '0042337', NULL, NULL, 119, NULL, 'FAD-linked reductases, C-terminal domain', 286241),
(476524, '0038201', NULL, NULL, 196, NULL, 'FAD-linked reductases, C-terminal domain', 286241),
(476525, '0035331', NULL, NULL, 112, NULL, 'FAD-linked reductases, C-terminal domain', 286241),
(476526, '0052927', NULL, NULL, 99, NULL, 'FAD-linked reductases, C-terminal domain', 286241),
(476527, '0047787', NULL, NULL, 181, NULL, 'FAD-linked reductases, C-terminal domain', 286241),
(476528, '0035805', NULL, NULL, 95, NULL, 'FAD-linked reductases, C-terminal domain', 286241),
(476529, '0053750', NULL, NULL, 69, NULL, 'FAD-linked reductases, C-terminal domain', 286241),
(476530, '0054880', NULL, NULL, 111, NULL, 'FAD-linked reductases, C-terminal domain', 286241),
(476531, '0053858', NULL, NULL, 109, NULL, 'FAD-linked reductases, C-terminal domain', 286241),
(476532, '0052601', NULL, NULL, 198, NULL, 'FAD-linked reductases, C-terminal domain', 286241),
(476533, '0037068', NULL, NULL, 104, NULL, 'FAD-linked reductases, C-terminal domain', 286241),
(476534, '0037442', NULL, NULL, 113, NULL, 'FAD-linked reductases, C-terminal domain', 286241),
(476535, '0040661', NULL, NULL, 113, NULL, 'FAD-linked reductases, C-terminal domain', 286241),
(476536, '0041376', NULL, NULL, 88, NULL, 'FAD-linked reductases, C-terminal domain', 286241),
(476537, '0054160', NULL, NULL, 108, NULL, 'FAD-linked reductases, C-terminal domain', 286241),
(476538, '0036093', NULL, NULL, 132, NULL, 'FAD-linked reductases, C-terminal domain', 286241),
(476539, '0047713', NULL, NULL, 102, NULL, 'FAD-linked reductases, C-terminal domain', 286241),
(476540, '0043212', NULL, NULL, 113, NULL, 'FAD-linked reductases, C-terminal domain', 286241),
(476541, '0038190', NULL, NULL, 112, NULL, 'FAD-linked reductases, C-terminal domain', 286241),
(476542, '0043578', NULL, NULL, 112, NULL, 'FAD-linked reductases, C-terminal domain', 286241),
(476543, '0053960', NULL, NULL, 146, NULL, 'FLJ32549 C-terminal domain-like', 286242),
(476544, '0051668', NULL, NULL, 123, NULL, 'Enzyme I of the PEP:sugar phosphotransferase system HPr-binding (sub)domain', 286243),
(476545, '0039879', NULL, NULL, 281, NULL, 'Tricorn protease N-terminal domain', 286244),
(476546, '0048597', NULL, NULL, 478, NULL, 'Sema domain', 286245),
(476547, '0049402', NULL, NULL, 476, NULL, 'Sema domain', 286245),
(476548, '0048888', NULL, NULL, 495, NULL, 'Sema domain', 286245),
(476549, '0053547', NULL, NULL, 90, NULL, 'Troponin coil-coiled subunits', 286246),
(476550, '0053446', NULL, NULL, 75, NULL, 'Troponin coil-coiled subunits', 286246),
(476551, '0053447', NULL, NULL, 152, NULL, 'Troponin coil-coiled subunits', 286246),
(476552, '0053546', NULL, NULL, 141, NULL, 'Troponin coil-coiled subunits', 286246),
(476553, '0054631', NULL, NULL, 169, NULL, 'BB2672-like', 286247);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(476554, '0054849', NULL, NULL, 191, NULL, 'BB2672-like', 286247),
(476555, '0042205', NULL, NULL, 189, NULL, 'Adhesin YadA, collagen-binding domain', 286248),
(476556, '0044679', NULL, NULL, 317, NULL, 'DNA ligase/mRNA capping enzyme, catalytic domain', 286249),
(476557, '0050929', NULL, NULL, 265, NULL, 'DNA ligase/mRNA capping enzyme, catalytic domain', 286249),
(476558, '0049580', NULL, NULL, 313, NULL, 'DNA ligase/mRNA capping enzyme, catalytic domain', 286249),
(476559, '0046164', NULL, NULL, 228, NULL, 'DNA ligase/mRNA capping enzyme, catalytic domain', 286249),
(476560, '0035285', NULL, NULL, 312, NULL, 'DNA ligase/mRNA capping enzyme, catalytic domain', 286249),
(476561, '0036424', NULL, NULL, 314, NULL, 'DNA ligase/mRNA capping enzyme, catalytic domain', 286249),
(476562, '0048677', NULL, NULL, 245, NULL, 'DNA ligase/mRNA capping enzyme, catalytic domain', 286249),
(476563, '0049326', NULL, NULL, 233, NULL, 'DNA ligase/mRNA capping enzyme, catalytic domain', 286249),
(476564, '0046865', NULL, NULL, 188, NULL, 'DNA ligase/mRNA capping enzyme, catalytic domain', 286249),
(476565, '0045687', NULL, NULL, 239, NULL, 'DNA ligase/mRNA capping enzyme, catalytic domain', 286249),
(476566, '0050886', NULL, NULL, 220, NULL, 'DNA ligase/mRNA capping enzyme, catalytic domain', 286249),
(476567, '0038350', NULL, NULL, 114, NULL, 'Calcium-mediated lectin', 286250),
(476568, '0044487', NULL, NULL, 113, NULL, 'Calcium-mediated lectin', 286250),
(476569, '0049111', NULL, NULL, 105, NULL, 'Avirulence protein AvrPto', 286251),
(476570, '0041427', NULL, NULL, 118, NULL, 'Hypothetical protein YojF', 286252),
(476571, '0049660', NULL, NULL, 64, NULL, 'CI-2 family of serine protease inhibitors', 286253),
(476572, '0036991', NULL, NULL, 70, NULL, 'CI-2 family of serine protease inhibitors', 286253),
(476573, '0047266', NULL, NULL, 69, NULL, 'CI-2 family of serine protease inhibitors', 286253),
(476574, '0045096', NULL, NULL, 64, NULL, 'CI-2 family of serine protease inhibitors', 286253),
(476575, '0036637', NULL, NULL, 69, NULL, 'CI-2 family of serine protease inhibitors', 286253),
(476576, '0045456', NULL, NULL, 64, NULL, 'CI-2 family of serine protease inhibitors', 286253),
(476577, '0041482', NULL, NULL, 562, NULL, 'Major capsid protein VP5', 286254),
(476578, '0044628', NULL, NULL, 126, NULL, 'KA1-like', 286255),
(476579, '0054704', NULL, NULL, 153, NULL, 'KA1-like', 286255),
(476580, '0044422', NULL, NULL, 102, NULL, 'KA1-like', 286255),
(476581, '0054613', NULL, NULL, 171, NULL, 'KA1-like', 286255),
(476582, '0054624', NULL, NULL, 127, NULL, 'KA1-like', 286255),
(476583, '0049574', NULL, NULL, 163, NULL, 'MukF C-terminal domain-like', 286256),
(476584, '0040112', NULL, NULL, 109, NULL, 'alpha-D-mannose-specific plant lectins', 286257),
(476585, '0035319', NULL, NULL, 119, NULL, 'alpha-D-mannose-specific plant lectins', 286257),
(476586, '0036491', NULL, NULL, 120, NULL, 'alpha-D-mannose-specific plant lectins', 286257),
(476587, '0039687', NULL, NULL, 108, NULL, 'alpha-D-mannose-specific plant lectins', 286257),
(476588, '0040111', NULL, NULL, 109, NULL, 'alpha-D-mannose-specific plant lectins', 286257),
(476589, '0036490', NULL, NULL, 115, NULL, 'alpha-D-mannose-specific plant lectins', 286257),
(476590, '0050925', NULL, NULL, 110, NULL, 'alpha-D-mannose-specific plant lectins', 286257),
(476591, '0050924', NULL, NULL, 112, NULL, 'alpha-D-mannose-specific plant lectins', 286257),
(476592, '0041508', NULL, NULL, 109, NULL, 'alpha-D-mannose-specific plant lectins', 286257),
(476593, '0035745', NULL, NULL, 109, NULL, 'alpha-D-mannose-specific plant lectins', 286257),
(476594, '0035744', NULL, NULL, 106, NULL, 'alpha-D-mannose-specific plant lectins', 286257),
(476595, '0042325', NULL, NULL, 312, NULL, 'Aromatic aminoacid monoxygenases, catalytic and oligomerization domains', 286258),
(476596, '0040662', NULL, NULL, 277, NULL, 'Aromatic aminoacid monoxygenases, catalytic and oligomerization domains', 286258),
(476597, '0044074', NULL, NULL, 336, NULL, 'Aromatic aminoacid monoxygenases, catalytic and oligomerization domains', 286258);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(476598, '0040999', NULL, NULL, 290, NULL, 'Aromatic aminoacid monoxygenases, catalytic and oligomerization domains', 286258),
(476599, '0044736', NULL, NULL, 217, NULL, 'FMN-dependent nitroreductase-like', 286259),
(476600, '0051432', NULL, NULL, 199, NULL, 'FMN-dependent nitroreductase-like', 286259),
(476601, '0053102', NULL, NULL, 199, NULL, 'FMN-dependent nitroreductase-like', 286259),
(476602, '0044848', NULL, NULL, 217, NULL, 'FMN-dependent nitroreductase-like', 286259),
(476603, '0041494', NULL, NULL, 200, NULL, 'FMN-dependent nitroreductase-like', 286259),
(476604, '0052748', NULL, NULL, 200, NULL, 'FMN-dependent nitroreductase-like', 286259),
(476605, '0036576', NULL, NULL, 217, NULL, 'FMN-dependent nitroreductase-like', 286259),
(476606, '0051924', NULL, NULL, 201, NULL, 'FMN-dependent nitroreductase-like', 286259),
(476607, '0037401', NULL, NULL, 240, NULL, 'FMN-dependent nitroreductase-like', 286259),
(476608, '0035601', NULL, NULL, 239, NULL, 'FMN-dependent nitroreductase-like', 286259),
(476609, '0041335', NULL, NULL, 216, NULL, 'FMN-dependent nitroreductase-like', 286259),
(476610, '0051556', NULL, NULL, 249, NULL, 'FMN-dependent nitroreductase-like', 286259),
(476611, '0045307', NULL, NULL, 43, NULL, 'Zn2/Cys6 DNA-binding domain', 286260),
(476612, '0042516', NULL, NULL, 42, NULL, 'Zn2/Cys6 DNA-binding domain', 286260),
(476613, '0046168', NULL, NULL, 33, NULL, 'Zn2/Cys6 DNA-binding domain', 286260),
(476614, '0035235', NULL, NULL, 43, NULL, 'Zn2/Cys6 DNA-binding domain', 286260),
(476615, '0045125', NULL, NULL, 36, NULL, 'Zn2/Cys6 DNA-binding domain', 286260),
(476616, '0036289', NULL, NULL, 41, NULL, 'Zn2/Cys6 DNA-binding domain', 286260),
(476617, '0045159', NULL, NULL, 65, NULL, 'Zn2/Cys6 DNA-binding domain', 286260),
(476618, '0034826', NULL, NULL, 28, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476619, '0052895', NULL, NULL, 58, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476620, '0050596', NULL, NULL, 121, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476621, '0050111', NULL, NULL, 29, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476622, '0053340', NULL, NULL, 30, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476623, '0050631', NULL, NULL, 31, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476624, '0050630', NULL, NULL, 35, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476625, '0052459', NULL, NULL, 30, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476626, '0052896', NULL, NULL, 36, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476627, '0045966', NULL, NULL, 38, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476628, '0043305', NULL, NULL, 30, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476629, '0052292', NULL, NULL, 53, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476630, '0052293', NULL, NULL, 30, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476631, '0052290', NULL, NULL, 60, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476632, '0043981', NULL, NULL, 31, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476633, '0043982', NULL, NULL, 31, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476634, '0045127', NULL, NULL, 25, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476635, '0045249', NULL, NULL, 37, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476636, '0052465', NULL, NULL, 30, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476637, '0052466', NULL, NULL, 27, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476638, '0052463', NULL, NULL, 26, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476639, '0052464', NULL, NULL, 28, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476640, '0045295', NULL, NULL, 30, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476641, '0045250', NULL, NULL, 26, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476642, '0045294', NULL, NULL, 33, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476643, '0045693', NULL, NULL, 29, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476644, '0052460', NULL, NULL, 36, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476645, '0045296', NULL, NULL, 31, NULL, 'beta-beta-alpha zinc fingers', 286261);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(476646, '0050840', NULL, NULL, 28, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476647, '0052469', NULL, NULL, 28, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476648, '0053677', NULL, NULL, 72, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476649, '0050841', NULL, NULL, 29, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476650, '0053678', NULL, NULL, 55, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476651, '0049818', NULL, NULL, 33, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476652, '0042220', NULL, NULL, 30, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476653, '0045695', NULL, NULL, 29, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476654, '0045694', NULL, NULL, 29, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476655, '0047831', NULL, NULL, 30, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476656, '0045696', NULL, NULL, 28, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476657, '0049610', NULL, NULL, 29, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476658, '0049852', NULL, NULL, 28, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476659, '0045656', NULL, NULL, 30, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476660, '0052279', NULL, NULL, 53, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476661, '0052470', NULL, NULL, 26, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476662, '0052471', NULL, NULL, 29, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476663, '0051621', NULL, NULL, 67, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476664, '0054735', NULL, NULL, 35, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476665, '0054733', NULL, NULL, 61, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476666, '0043689', NULL, NULL, 31, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476667, '0037795', NULL, NULL, 36, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476668, '0037351', NULL, NULL, 39, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476669, '0041429', NULL, NULL, 37, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476670, '0044259', NULL, NULL, 28, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476671, '0052289', NULL, NULL, 36, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476672, '0054743', NULL, NULL, 48, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476673, '0050860', NULL, NULL, 75, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476674, '0053893', NULL, NULL, 35, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476675, '0052288', NULL, NULL, 28, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476676, '0053894', NULL, NULL, 39, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476677, '0044260', NULL, NULL, 28, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476678, '0045152', NULL, NULL, 31, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476679, '0053891', NULL, NULL, 53, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476680, '0044261', NULL, NULL, 30, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476681, '0053892', NULL, NULL, 32, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476682, '0045110', NULL, NULL, 54, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476683, '0050624', NULL, NULL, 41, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476684, '0050623', NULL, NULL, 24, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476685, '0050944', NULL, NULL, 29, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476686, '0050862', NULL, NULL, 36, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476687, '0052205', NULL, NULL, 27, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476688, '0052920', NULL, NULL, 29, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476689, '0050784', NULL, NULL, 61, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476690, '0050861', NULL, NULL, 37, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476691, '0052206', NULL, NULL, 38, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476692, '0050622', NULL, NULL, 42, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476693, '0048707', NULL, NULL, 37, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476694, '0037782', NULL, NULL, 36, NULL, 'beta-beta-alpha zinc fingers', 286261);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(476695, '0041311', NULL, NULL, 47, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476696, '0043976', NULL, NULL, 31, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476697, '0043977', NULL, NULL, 30, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476698, '0052919', NULL, NULL, 32, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476699, '0043978', NULL, NULL, 31, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476700, '0035441', NULL, NULL, 28, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476701, '0050859', NULL, NULL, 26, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476702, '0050858', NULL, NULL, 33, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476703, '0051749', NULL, NULL, 29, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476704, '0052280', NULL, NULL, 44, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476705, '0040545', NULL, NULL, 28, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476706, '0043730', NULL, NULL, 35, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476707, '0049956', NULL, NULL, 30, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476708, '0045118', NULL, NULL, 32, NULL, 'beta-beta-alpha zinc fingers', 286261),
(476709, '0054135', NULL, NULL, 212, NULL, 'Lysozyme-like', 286262),
(476710, '0045261', NULL, NULL, 129, NULL, 'Lysozyme-like', 286262),
(476711, '0046990', NULL, NULL, 130, NULL, 'Lysozyme-like', 286262),
(476712, '0037418', NULL, NULL, 123, NULL, 'Lysozyme-like', 286262),
(476713, '0034789', NULL, NULL, 164, NULL, 'Lysozyme-like', 286262),
(476714, '0050993', NULL, NULL, 178, NULL, 'Lysozyme-like', 286262),
(476715, '0034786', NULL, NULL, 162, NULL, 'Lysozyme-like', 286262),
(476716, '0039756', NULL, NULL, 178, NULL, 'Lysozyme-like', 286262),
(476717, '0053645', NULL, NULL, 86, NULL, 'Lysozyme-like', 286262),
(476718, '0040570', NULL, NULL, 129, NULL, 'Lysozyme-like', 286262),
(476719, '0038582', NULL, NULL, 123, NULL, 'Lysozyme-like', 286262),
(476720, '0043002', NULL, NULL, 322, NULL, 'Lysozyme-like', 286262),
(476721, '0042970', NULL, NULL, 168, NULL, 'Lysozyme-like', 286262),
(476722, '0035090', NULL, NULL, 122, NULL, 'Lysozyme-like', 286262),
(476723, '0040610', NULL, NULL, 162, NULL, 'Lysozyme-like', 286262),
(476724, '0042950', NULL, NULL, 130, NULL, 'Lysozyme-like', 286262),
(476725, '0047448', NULL, NULL, 130, NULL, 'Lysozyme-like', 286262),
(476726, '0054289', NULL, NULL, 192, NULL, 'Lysozyme-like', 286262),
(476727, '0053597', NULL, NULL, 164, NULL, 'Lysozyme-like', 286262),
(476728, '0047673', NULL, NULL, 129, NULL, 'Lysozyme-like', 286262),
(476729, '0035984', NULL, NULL, 238, NULL, 'Lysozyme-like', 286262),
(476730, '0042085', NULL, NULL, 173, NULL, 'Lysozyme-like', 286262),
(476731, '0034793', NULL, NULL, 162, NULL, 'Lysozyme-like', 286262),
(476732, '0053219', NULL, NULL, 130, NULL, 'Lysozyme-like', 286262),
(476733, '0054408', NULL, NULL, 187, NULL, 'Lysozyme-like', 286262),
(476734, '0035420', NULL, NULL, 123, NULL, 'Lysozyme-like', 286262),
(476735, '0036652', NULL, NULL, 242, NULL, 'Lysozyme-like', 286262),
(476736, '0038595', NULL, NULL, 129, NULL, 'Lysozyme-like', 286262),
(476737, '0040641', NULL, NULL, 144, NULL, 'Lysozyme-like', 286262),
(476738, '0042765', NULL, NULL, 259, NULL, 'Lysozyme-like', 286262),
(476739, '0039764', NULL, NULL, 125, NULL, 'Lysozyme-like', 286262),
(476740, '0036072', NULL, NULL, 243, NULL, 'Lysozyme-like', 286262),
(476741, '0039048', NULL, NULL, 120, NULL, 'Lysozyme-like', 286262),
(476742, '0039862', NULL, NULL, 216, NULL, 'Lysozyme-like', 286262),
(476743, '0035100', NULL, NULL, 154, NULL, 'Lysozyme-like', 286262),
(476744, '0046807', NULL, NULL, 124, NULL, 'Lysozyme-like', 286262),
(476745, '0038053', NULL, NULL, 119, NULL, 'Lysozyme-like', 286262),
(476746, '0034790', NULL, NULL, 164, NULL, 'Lysozyme-like', 286262),
(476747, '0042163', NULL, NULL, 166, NULL, 'Lysozyme-like', 286262),
(476748, '0054383', NULL, NULL, 225, NULL, 'Lysozyme-like', 286262),
(476749, '0054141', NULL, NULL, 163, NULL, 'Lysozyme-like', 286262),
(476750, '0045677', NULL, NULL, 185, NULL, 'Lysozyme-like', 286262),
(476751, '0041358', NULL, NULL, 123, NULL, 'Lysozyme-like', 286262);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(476752, '0044813', NULL, NULL, 302, NULL, 'Coproporphyrinogen III oxidase', 286263),
(476753, '0044037', NULL, NULL, 325, NULL, 'Coproporphyrinogen III oxidase', 286263),
(476754, '0054500', NULL, NULL, 190, NULL, 'AhpD-like', 286264),
(476755, '0053233', NULL, NULL, 144, NULL, 'AhpD-like', 286264),
(476756, '0054431', NULL, NULL, 186, NULL, 'AhpD-like', 286264),
(476757, '0052929', NULL, NULL, 147, NULL, 'AhpD-like', 286264),
(476758, '0054540', NULL, NULL, 190, NULL, 'AhpD-like', 286264),
(476759, '0040162', NULL, NULL, 174, NULL, 'AhpD-like', 286264),
(476760, '0054570', NULL, NULL, 257, NULL, 'AhpD-like', 286264),
(476761, '0054419', NULL, NULL, 134, NULL, 'AhpD-like', 286264),
(476762, '0051758', NULL, NULL, 119, NULL, 'AhpD-like', 286264),
(476763, '0042190', NULL, NULL, 115, NULL, 'AhpD-like', 286264),
(476764, '0052335', NULL, NULL, 117, NULL, 'AhpD-like', 286264),
(476765, '0044522', NULL, NULL, 153, NULL, 'BTV NS2-like ssRNA-binding domain', 286265),
(476766, '0046203', NULL, NULL, 450, NULL, 'Soluble quinoprotein glucose dehydrogenase', 286266),
(476767, '0044728', NULL, NULL, 33, NULL, 'PetM subunit of the cytochrome b6f complex', 286267),
(476768, '0042671', NULL, NULL, 34, NULL, 'PetM subunit of the cytochrome b6f complex', 286267),
(476769, '0046806', NULL, NULL, 194, NULL, 'Ypt/Rab-GAP domain of gyp1p', 286268),
(476770, '0037638', NULL, NULL, 188, NULL, 'Ypt/Rab-GAP domain of gyp1p', 286268),
(476771, '0052531', NULL, NULL, 93, NULL, 'CcmK-like', 286269),
(476772, '0051681', NULL, NULL, 101, NULL, 'CcmK-like', 286269),
(476773, '0051677', NULL, NULL, 104, NULL, 'CcmK-like', 286269),
(476774, '0052842', NULL, NULL, 305, NULL, 'CAC2185-like', 286270),
(476775, '0039234', NULL, NULL, 123, NULL, 'Insert subdomain of RNA polymerase alpha subunit', 286271),
(476776, '0035474', NULL, NULL, 126, NULL, 'Insert subdomain of RNA polymerase alpha subunit', 286271),
(476777, '0038874', NULL, NULL, 131, NULL, 'Insert subdomain of RNA polymerase alpha subunit', 286271),
(476778, '0047315', NULL, NULL, 123, NULL, 'Insert subdomain of RNA polymerase alpha subunit', 286271),
(476779, '0039296', NULL, NULL, 170, NULL, 'YgfB-like', 286272),
(476780, '0036042', NULL, NULL, 32, NULL, 'Retrovirus zinc finger-like domains', 286273),
(476781, '0036581', NULL, NULL, 31, NULL, 'Retrovirus zinc finger-like domains', 286273),
(476782, '0046717', NULL, NULL, 55, NULL, 'Retrovirus zinc finger-like domains', 286273),
(476783, '0049805', NULL, NULL, 56, NULL, 'Retrovirus zinc finger-like domains', 286273),
(476784, '0046619', NULL, NULL, 42, NULL, 'Retrovirus zinc finger-like domains', 286273),
(476785, '0036578', NULL, NULL, 21, NULL, 'Retrovirus zinc finger-like domains', 286273),
(476786, '0045753', NULL, NULL, 55, NULL, 'Retrovirus zinc finger-like domains', 286273),
(476787, '0048327', NULL, NULL, 29, NULL, 'Retrovirus zinc finger-like domains', 286273),
(476788, '0053224', NULL, NULL, 85, NULL, 'CBS-domain pair', 286274),
(476789, '0054677', NULL, NULL, 131, NULL, 'CBS-domain pair', 286274),
(476790, '0054930', NULL, NULL, 135, NULL, 'CBS-domain pair', 286274),
(476791, '0053588', NULL, NULL, 120, NULL, 'CBS-domain pair', 286274),
(476792, '0054752', NULL, NULL, 122, NULL, 'CBS-domain pair', 286274),
(476793, '0053883', NULL, NULL, 127, NULL, 'CBS-domain pair', 286274),
(476794, '0054751', NULL, NULL, 156, NULL, 'CBS-domain pair', 286274),
(476795, '0054750', NULL, NULL, 132, NULL, 'CBS-domain pair', 286274),
(476796, '0053648', NULL, NULL, 123, NULL, 'CBS-domain pair', 286274),
(476797, '0053668', NULL, NULL, 126, NULL, 'CBS-domain pair', 286274),
(476798, '0053801', NULL, NULL, 161, NULL, 'CBS-domain pair', 286274),
(476799, '0053589', NULL, NULL, 120, NULL, 'CBS-domain pair', 286274),
(476800, '0054316', NULL, NULL, 139, NULL, 'CBS-domain pair', 286274),
(476801, '0053601', NULL, NULL, 142, NULL, 'CBS-domain pair', 286274),
(476802, '0053619', NULL, NULL, 121, NULL, 'CBS-domain pair', 286274),
(476803, '0054929', NULL, NULL, 141, NULL, 'CBS-domain pair', 286274),
(476804, '0053653', NULL, NULL, 132, NULL, 'CBS-domain pair', 286274);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(476805, '0054203', NULL, NULL, 169, NULL, 'CBS-domain pair', 286274),
(476806, '0054402', NULL, NULL, 153, NULL, 'CBS-domain pair', 286274),
(476807, '0053599', NULL, NULL, 120, NULL, 'CBS-domain pair', 286274),
(476808, '0054401', NULL, NULL, 179, NULL, 'CBS-domain pair', 286274),
(476809, '0054665', NULL, NULL, 127, NULL, 'CBS-domain pair', 286274),
(476810, '0054421', NULL, NULL, 127, NULL, 'CBS-domain pair', 286274),
(476811, '0053593', NULL, NULL, 145, NULL, 'CBS-domain pair', 286274),
(476812, '0054707', NULL, NULL, 159, NULL, 'CBS-domain pair', 286274),
(476813, '0054706', NULL, NULL, 145, NULL, 'CBS-domain pair', 286274),
(476814, '0054747', NULL, NULL, 144, NULL, 'CBS-domain pair', 286274),
(476815, '0049560', NULL, NULL, 304, NULL, 'BEACH domain', 286275),
(476816, '0040941', NULL, NULL, 305, NULL, 'BEACH domain', 286275),
(476817, '0037674', NULL, NULL, 365, NULL, 'Outer capsid protein sigma 3', 286276),
(476818, '0047159', NULL, NULL, 89, NULL, 'Acyl-CoA binding protein', 286277),
(476819, '0047158', NULL, NULL, 86, NULL, 'Acyl-CoA binding protein', 286277),
(476820, '0053665', NULL, NULL, 177, NULL, 'Ribosomal protein L10-like', 286278),
(476821, '0049997', NULL, NULL, 77, NULL, 'Sporulation related repeat', 286279),
(476822, '0046096', NULL, NULL, 328, NULL, 'Clathrin heavy-chain terminal domain', 286280),
(476823, '0037553', NULL, NULL, 49, NULL, 'Ribosomal protein L39e', 286281),
(476824, '0049088', NULL, NULL, 37, NULL, 'Cyclotides', 286282),
(476825, '0046318', NULL, NULL, 30, NULL, 'Cyclotides', 286282),
(476826, '0047608', NULL, NULL, 29, NULL, 'Cyclotides', 286282),
(476827, '0048815', NULL, NULL, 29, NULL, 'Cyclotides', 286282),
(476828, '0048265', NULL, NULL, 29, NULL, 'Cyclotides', 286282),
(476829, '0048315', NULL, NULL, 29, NULL, 'Cyclotides', 286282),
(476830, '0047773', NULL, NULL, 29, NULL, 'Cyclotides', 286282),
(476831, '0048318', NULL, NULL, 30, NULL, 'Cyclotides', 286282),
(476832, '0035547', NULL, NULL, 30, NULL, 'Cyclotides', 286282),
(476833, '0050124', NULL, NULL, 30, NULL, 'Cyclotides', 286282),
(476834, '0049165', NULL, NULL, 164, NULL, '4-helical cytokines', 286283),
(476835, '0038728', NULL, NULL, 108, NULL, '4-helical cytokines', 286283),
(476836, '0038948', NULL, NULL, 129, NULL, '4-helical cytokines', 286283),
(476837, '0037217', NULL, NULL, 184, NULL, '4-helical cytokines', 286283),
(476838, '0039612', NULL, NULL, 112, NULL, '4-helical cytokines', 286283),
(476839, '0038842', NULL, NULL, 167, NULL, '4-helical cytokines', 286283),
(476840, '0036943', NULL, NULL, 166, NULL, '4-helical cytokines', 286283),
(476841, '0037414', NULL, NULL, 197, NULL, '4-helical cytokines', 286283),
(476842, '0035096', NULL, NULL, 166, NULL, '4-helical cytokines', 286283),
(476843, '0043546', NULL, NULL, 131, NULL, '4-helical cytokines', 286283),
(476844, '0045527', NULL, NULL, 128, NULL, '4-helical cytokines', 286283),
(476845, '0038587', NULL, NULL, 189, NULL, '4-helical cytokines', 286283),
(476846, '0040055', NULL, NULL, 190, NULL, '4-helical cytokines', 286283),
(476847, '0035199', NULL, NULL, 166, NULL, '4-helical cytokines', 286283),
(476848, '0041187', NULL, NULL, 156, NULL, '4-helical cytokines', 286283),
(476849, '0035253', NULL, NULL, 189, NULL, '4-helical cytokines', 286283),
(476850, '0037173', NULL, NULL, 134, NULL, '4-helical cytokines', 286283),
(476851, '0044650', NULL, NULL, 145, NULL, '4-helical cytokines', 286283),
(476852, '0044873', NULL, NULL, 142, NULL, '4-helical cytokines', 286283),
(476853, '0047986', NULL, NULL, 172, NULL, '4-helical cytokines', 286283),
(476854, '0054543', NULL, NULL, 114, NULL, '4-helical cytokines', 286283),
(476855, '0054763', NULL, NULL, 114, NULL, '4-helical cytokines', 286283),
(476856, '0046185', NULL, NULL, 177, NULL, '4-helical cytokines', 286283),
(476857, '0040618', NULL, NULL, 142, NULL, '4-helical cytokines', 286283),
(476858, '0035247', NULL, NULL, 144, NULL, '4-helical cytokines', 286283),
(476859, '0054828', NULL, NULL, 127, NULL, '4-helical cytokines', 286283),
(476860, '0036313', NULL, NULL, 121, NULL, '4-helical cytokines', 286283);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(476861, '0038637', NULL, NULL, 148, NULL, '4-helical cytokines', 286283),
(476862, '0054409', NULL, NULL, 133, NULL, '4-helical cytokines', 286283),
(476863, '0050703', NULL, NULL, 161, NULL, '4-helical cytokines', 286283),
(476864, '0038018', NULL, NULL, 113, NULL, '4-helical cytokines', 286283),
(476865, '0035360', NULL, NULL, 164, NULL, '4-helical cytokines', 286283),
(476866, '0045439', NULL, NULL, 119, NULL, '4-helical cytokines', 286283),
(476867, '0048829', NULL, NULL, 169, NULL, '4-helical cytokines', 286283),
(476868, '0045958', NULL, NULL, 165, NULL, '4-helical cytokines', 286283),
(476869, '0040780', NULL, NULL, 142, NULL, '4-helical cytokines', 286283),
(476870, '0041275', NULL, NULL, 199, NULL, '4-helical cytokines', 286283),
(476871, '0045959', NULL, NULL, 166, NULL, '4-helical cytokines', 286283),
(476872, '0037382', NULL, NULL, 178, NULL, '4-helical cytokines', 286283),
(476873, '0045298', NULL, NULL, 121, NULL, '4-helical cytokines', 286283),
(476874, '0045732', NULL, NULL, 180, NULL, '4-helical cytokines', 286283),
(476875, '0043234', NULL, NULL, 154, NULL, '4-helical cytokines', 286283),
(476876, '0045338', NULL, NULL, 155, NULL, '4-helical cytokines', 286283),
(476877, '0054699', NULL, NULL, 134, NULL, 'Nitrite/Sulfite reductase N-terminal domain-like', 286284),
(476878, '0054875', NULL, NULL, 119, NULL, 'Nitrite/Sulfite reductase N-terminal domain-like', 286284),
(476879, '0045801', NULL, NULL, 80, NULL, 'Nitrite/Sulfite reductase N-terminal domain-like', 286284),
(476880, '0054696', NULL, NULL, 166, NULL, 'Nitrite/Sulfite reductase N-terminal domain-like', 286284),
(476881, '0054872', NULL, NULL, 166, NULL, 'Nitrite/Sulfite reductase N-terminal domain-like', 286284),
(476882, '0053670', NULL, NULL, 152, NULL, 'Nitrite/Sulfite reductase N-terminal domain-like', 286284),
(476883, '0053669', NULL, NULL, 80, NULL, 'Nitrite/Sulfite reductase N-terminal domain-like', 286284),
(476884, '0045800', NULL, NULL, 65, NULL, 'Nitrite/Sulfite reductase N-terminal domain-like', 286284),
(476885, '0053699', NULL, NULL, 85, NULL, 'Nitrite/Sulfite reductase N-terminal domain-like', 286284),
(476886, '0053700', NULL, NULL, 153, NULL, 'Nitrite/Sulfite reductase N-terminal domain-like', 286284),
(476887, '0041247', NULL, NULL, 555, NULL, 'Adsorption protein p2', 286285),
(476888, '0052711', NULL, NULL, 118, NULL, 'YjbR-like', 286286),
(476889, '0051686', NULL, NULL, 131, NULL, 'YjbR-like', 286286),
(476890, '0041477', NULL, NULL, 107, NULL, 'Putative dsDNA mimic', 286287),
(476891, '0053279', NULL, NULL, 174, NULL, 'Inorganic pyrophosphatase', 286288),
(476892, '0053379', NULL, NULL, 282, NULL, 'Inorganic pyrophosphatase', 286288),
(476893, '0048937', NULL, NULL, 170, NULL, 'Inorganic pyrophosphatase', 286288),
(476894, '0049865', NULL, NULL, 168, NULL, 'Inorganic pyrophosphatase', 286288),
(476895, '0048538', NULL, NULL, 175, NULL, 'Inorganic pyrophosphatase', 286288),
(476896, '0049724', NULL, NULL, 173, NULL, 'Inorganic pyrophosphatase', 286288),
(476897, '0037265', NULL, NULL, 201, NULL, 'PRC-barrel domain', 286289),
(476898, '0044351', NULL, NULL, 141, NULL, 'PRC-barrel domain', 286289),
(476899, '0042374', NULL, NULL, 78, NULL, 'PRC-barrel domain', 286289),
(476900, '0042908', NULL, NULL, 215, NULL, 'PRC-barrel domain', 286289),
(476901, '0036658', NULL, NULL, 222, NULL, 'PRC-barrel domain', 286289),
(476902, '0052566', NULL, NULL, 75, NULL, 'PRC-barrel domain', 286289),
(476903, '0052483', NULL, NULL, 133, NULL, 'CalX-like', 286290),
(476904, '0052797', NULL, NULL, 157, NULL, 'CalX-like', 286290),
(476905, '0046046', NULL, NULL, 144, NULL, 'Apolipoprotein', 286291),
(476906, '0047937', NULL, NULL, 129, NULL, 'Retroviral matrix proteins', 286292),
(476907, '0039783', NULL, NULL, 137, NULL, 'Retroviral matrix proteins', 286292),
(476908, '0038565', NULL, NULL, 116, NULL, 'Retroviral matrix proteins', 286292),
(476909, '0041011', NULL, NULL, 95, NULL, 'Retroviral matrix proteins', 286292),
(476910, '0044370', NULL, NULL, 105, NULL, 'Retroviral matrix proteins', 286292),
(476911, '0034915', NULL, NULL, 87, NULL, 'Retroviral matrix proteins', 286292);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(476912, '0049585', NULL, NULL, 120, NULL, 'Retroviral matrix proteins', 286292),
(476913, '0052612', NULL, NULL, 94, NULL, 'Retroviral matrix proteins', 286292),
(476914, '0036911', NULL, NULL, 114, NULL, 'Retroviral matrix proteins', 286292),
(476915, '0051564', NULL, NULL, 115, NULL, 'FimD N-terminal domain-like', 286293),
(476916, '0051566', NULL, NULL, 125, NULL, 'FimD N-terminal domain-like', 286293),
(476917, '0047391', NULL, NULL, 44, NULL, 'Colipase-like', 286294),
(476918, '0048738', NULL, NULL, 44, NULL, 'Colipase-like', 286294),
(476919, '0048007', NULL, NULL, 46, NULL, 'Colipase-like', 286294),
(476920, '0047390', NULL, NULL, 36, NULL, 'Colipase-like', 286294),
(476921, '0049275', NULL, NULL, 120, NULL, 'ARID-like', 286295),
(476922, '0046063', NULL, NULL, 128, NULL, 'ARID-like', 286295),
(476923, '0047826', NULL, NULL, 102, NULL, 'ARID-like', 286295),
(476924, '0047357', NULL, NULL, 107, NULL, 'ARID-like', 286295),
(476925, '0053936', NULL, NULL, 255, NULL, 'EreA/ChaN-like', 286296),
(476926, '0054607', NULL, NULL, 413, NULL, 'EreA/ChaN-like', 286296),
(476927, '0054805', NULL, NULL, 403, NULL, 'EreA/ChaN-like', 286296),
(476928, '0053876', NULL, NULL, 219, NULL, 'EreA/ChaN-like', 286296),
(476929, '0043439', NULL, NULL, 220, NULL, 'Sortase', 286297),
(476930, '0039050', NULL, NULL, 148, NULL, 'Sortase', 286297),
(476931, '0043027', NULL, NULL, 235, NULL, 'Sortase', 286297),
(476932, '0046911', NULL, NULL, 32, NULL, 'Dimerization cofactor of HNF-1 alpha', 286298),
(476933, '0046910', NULL, NULL, 31, NULL, 'Dimerization cofactor of HNF-1 alpha', 286298),
(476934, '0041786', NULL, NULL, 49, NULL, 'Mitochondrial cytochrome c oxidase subunit VIIb', 286299),
(476935, '0048652', NULL, NULL, 156, NULL, 'Spectrin repeat', 286300),
(476936, '0049794', NULL, NULL, 110, NULL, 'Spectrin repeat', 286300),
(476937, '0049304', NULL, NULL, 105, NULL, 'Spectrin repeat', 286300),
(476938, '0047168', NULL, NULL, 125, NULL, 'Spectrin repeat', 286300),
(476939, '0049303', NULL, NULL, 106, NULL, 'Spectrin repeat', 286300),
(476940, '0038529', NULL, NULL, 114, NULL, 'Spectrin repeat', 286300),
(476941, '0043003', NULL, NULL, 124, NULL, 'Spectrin repeat', 286300),
(476942, '0043004', NULL, NULL, 124, NULL, 'Spectrin repeat', 286300),
(476943, '0046218', NULL, NULL, 104, NULL, 'Spectrin repeat', 286300),
(476944, '0046217', NULL, NULL, 109, NULL, 'Spectrin repeat', 286300),
(476945, '0053304', NULL, NULL, 107, NULL, 'Spectrin repeat', 286300),
(476946, '0044877', NULL, NULL, 264, NULL, 'Folate-binding domain', 286301),
(476947, '0042338', NULL, NULL, 315, NULL, 'Folate-binding domain', 286301),
(476948, '0051157', NULL, NULL, 117, NULL, 'Folate-binding domain', 286301),
(476949, '0045002', NULL, NULL, 278, NULL, 'Folate-binding domain', 286301),
(476950, '0050060', NULL, NULL, 310, NULL, 'Folate-binding domain', 286301),
(476951, '0041533', NULL, NULL, 243, NULL, 'Folate-binding domain', 286301),
(476952, '0038726', NULL, NULL, 123, NULL, 'YopH tyrosine phosphatase N-terminal domain', 286302),
(476953, '0054001', NULL, NULL, 121, NULL, 'Ribosomal protein L14', 286303),
(476954, '0053143', NULL, NULL, 122, NULL, 'Ribosomal protein L14', 286303),
(476955, '0037536', NULL, NULL, 132, NULL, 'Ribosomal protein L14', 286303),
(476956, '0054779', NULL, NULL, 134, NULL, 'Ribosomal protein L14', 286303),
(476957, '0044974', NULL, NULL, 122, NULL, 'Ribosomal protein L14', 286303),
(476958, '0043404', NULL, NULL, 123, NULL, 'Avidin/streptavidin', 286304),
(476959, '0041031', NULL, NULL, 127, NULL, 'Avidin/streptavidin', 286304),
(476960, '0043784', NULL, NULL, 126, NULL, 'Avidin/streptavidin', 286304),
(476961, '0045203', NULL, NULL, 124, NULL, 'Avidin/streptavidin', 286304),
(476962, '0049022', NULL, NULL, 230, NULL, 'Flavoproteins', 286305),
(476963, '0048395', NULL, NULL, 171, NULL, 'Flavoproteins', 286305),
(476964, '0049241', NULL, NULL, 174, NULL, 'Flavoproteins', 286305),
(476965, '0049202', NULL, NULL, 135, NULL, 'Flavoproteins', 286305),
(476966, '0049201', NULL, NULL, 179, NULL, 'Flavoproteins', 286305);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(476967, '0049640', NULL, NULL, 203, NULL, 'Flavoproteins', 286305),
(476968, '0051328', NULL, NULL, 146, NULL, 'Flavoproteins', 286305),
(476969, '0052813', NULL, NULL, 233, NULL, 'Flavoproteins', 286305),
(476970, '0035735', NULL, NULL, 152, NULL, 'Flavoproteins', 286305),
(476971, '0052810', NULL, NULL, 137, NULL, 'Flavoproteins', 286305),
(476972, '0051820', NULL, NULL, 184, NULL, 'Flavoproteins', 286305),
(476973, '0046417', NULL, NULL, 273, NULL, 'Flavoproteins', 286305),
(476974, '0042957', NULL, NULL, 273, NULL, 'Flavoproteins', 286305),
(476975, '0048535', NULL, NULL, 169, NULL, 'Flavoproteins', 286305),
(476976, '0051281', NULL, NULL, 201, NULL, 'Flavoproteins', 286305),
(476977, '0047543', NULL, NULL, 177, NULL, 'Flavoproteins', 286305),
(476978, '0049507', NULL, NULL, 185, NULL, 'Flavoproteins', 286305),
(476979, '0044895', NULL, NULL, 148, NULL, 'Flavoproteins', 286305),
(476980, '0049548', NULL, NULL, 201, NULL, 'Flavoproteins', 286305),
(476981, '0049652', NULL, NULL, 202, NULL, 'Flavoproteins', 286305),
(476982, '0051274', NULL, NULL, 149, NULL, 'Flavoproteins', 286305),
(476983, '0045274', NULL, NULL, 173, NULL, 'Flavoproteins', 286305),
(476984, '0051357', NULL, NULL, 179, NULL, 'Flavoproteins', 286305),
(476985, '0036778', NULL, NULL, 152, NULL, 'Flavoproteins', 286305),
(476986, '0053358', NULL, NULL, 138, NULL, 'Flavoproteins', 286305),
(476987, '0046705', NULL, NULL, 147, NULL, 'Flavoproteins', 286305),
(476988, '0036210', NULL, NULL, 169, NULL, 'Flavoproteins', 286305),
(476989, '0051705', NULL, NULL, 196, NULL, 'Flavoproteins', 286305),
(476990, '0043718', NULL, NULL, 232, NULL, 'Flavoproteins', 286305),
(476991, '0046267', NULL, NULL, 273, NULL, 'Flavoproteins', 286305),
(476992, '0045773', NULL, NULL, 175, NULL, 'Flavoproteins', 286305),
(476993, '0046862', NULL, NULL, 163, NULL, 'Flavoproteins', 286305),
(476994, '0044019', NULL, NULL, 76, NULL, 'Translation initiation factor IF3, N-terminal domain', 286306),
(476995, '0039956', NULL, NULL, 157, NULL, 'C-terminal domain of adenylylcyclase associated protein', 286307),
(476996, '0047855', NULL, NULL, 156, NULL, 'C-terminal domain of adenylylcyclase associated protein', 286307),
(476997, '0047036', NULL, NULL, 121, NULL, 'GMP synthetase C-terminal dimerisation domain', 286308),
(476998, '0047273', NULL, NULL, 326, NULL, 'Terpenoid cyclases/Protein prenyltransferases', 286309),
(476999, '0053354', NULL, NULL, 200, NULL, 'Terpenoid cyclases/Protein prenyltransferases', 286309),
(477000, '0046282', NULL, NULL, 407, NULL, 'Terpenoid cyclases/Protein prenyltransferases', 286309),
(477001, '0048283', NULL, NULL, 346, NULL, 'Terpenoid cyclases/Protein prenyltransferases', 286309),
(477002, '0050380', NULL, NULL, 279, NULL, 'Terpenoid cyclases/Protein prenyltransferases', 286309),
(477003, '0046298', NULL, NULL, 329, NULL, 'Terpenoid cyclases/Protein prenyltransferases', 286309),
(477004, '0041184', NULL, NULL, 207, NULL, 'Terpenoid cyclases/Protein prenyltransferases', 286309),
(477005, '0049012', NULL, NULL, 277, NULL, 'Terpenoid cyclases/Protein prenyltransferases', 286309),
(477006, '0053305', NULL, NULL, 353, NULL, 'Terpenoid cyclases/Protein prenyltransferases', 286309),
(477007, '0053306', NULL, NULL, 271, NULL, 'Terpenoid cyclases/Protein prenyltransferases', 286309),
(477008, '0035832', NULL, NULL, 294, NULL, 'Terpenoid cyclases/Protein prenyltransferases', 286309),
(477009, '0050379', NULL, NULL, 449, NULL, 'Terpenoid cyclases/Protein prenyltransferases', 286309),
(477010, '0036636', NULL, NULL, 70, NULL, 'Cyanase C-terminal domain', 286310),
(477011, '0054029', NULL, NULL, 71, NULL, 'YorP-like', 286311),
(477012, '0054514', NULL, NULL, 186, NULL, 'PrpR receptor domain-like', 286312),
(477013, '0054819', NULL, NULL, 239, NULL, 'Bacterial polysaccharide co-polymerase-like', 286313),
(477014, '0054818', NULL, NULL, 265, NULL, 'Bacterial polysaccharide co-polymerase-like', 286313),
(477015, '0054817', NULL, NULL, 267, NULL, 'Bacterial polysaccharide co-polymerase-like', 286313),
(477016, '0036346', NULL, NULL, 110, NULL, 'Rab geranylgeranyltransferase alpha-subunit, insert domain', 286314);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(477017, '0046196', NULL, NULL, 129, NULL, 'Cytochromes', 286315),
(477018, '0049289', NULL, NULL, 129, NULL, 'Cytochromes', 286315),
(477019, '0046484', NULL, NULL, 125, NULL, 'Cytochromes', 286315),
(477020, '0045136', NULL, NULL, 106, NULL, 'Cytochromes', 286315),
(477021, '0038226', NULL, NULL, 130, NULL, 'Cytochromes', 286315),
(477022, '0045734', NULL, NULL, 125, NULL, 'Cytochromes', 286315),
(477023, '0045921', NULL, NULL, 131, NULL, 'Cytochromes', 286315),
(477024, '0047546', NULL, NULL, 128, NULL, 'Cytochromes', 286315),
(477025, '0052148', NULL, NULL, 127, NULL, 'Cytochromes', 286315),
(477026, '0041895', NULL, NULL, 297, NULL, 'Viral glycoprotein, central and dimerisation domains', 286316),
(477027, '0049481', NULL, NULL, 302, NULL, 'Viral glycoprotein, central and dimerisation domains', 286316),
(477028, '0038936', NULL, NULL, 292, NULL, 'Viral glycoprotein, central and dimerisation domains', 286316),
(477029, '0049530', NULL, NULL, 124, NULL, 'Nitrogenase accessory factor-like', 286317),
(477030, '0049148', NULL, NULL, 116, NULL, 'Nitrogenase accessory factor-like', 286317),
(477031, '0037104', NULL, NULL, 124, NULL, 'Nitrogenase accessory factor-like', 286317),
(477032, '0048713', NULL, NULL, 123, NULL, 'Nitrogenase accessory factor-like', 286317),
(477033, '0035647', NULL, NULL, 132, NULL, 'LigA subunit of an aromatic-ring-opening dioxygenase LigAB', 286318),
(477034, '0049649', NULL, NULL, 235, NULL, 'Tachylectin-2', 286319),
(477035, '0053655', NULL, NULL, 65, NULL, 'RILP dimerisation region', 286320),
(477036, '0043014', NULL, NULL, 102, NULL, 'Hypothetical protein Ta1206', 286321),
(477037, '0051023', NULL, NULL, 457, NULL, 'ARM repeat', 286322),
(477038, '0046492', NULL, NULL, 201, NULL, 'ARM repeat', 286322),
(477039, '0051487', NULL, NULL, 87, NULL, 'ARM repeat', 286322),
(477040, '0047241', NULL, NULL, 243, NULL, 'ARM repeat', 286322),
(477041, '0050417', NULL, NULL, 959, NULL, 'ARM repeat', 286322),
(477042, '0050416', NULL, NULL, 503, NULL, 'ARM repeat', 286322),
(477043, '0038302', NULL, NULL, 579, NULL, 'ARM repeat', 286322),
(477044, '0052018', NULL, NULL, 343, NULL, 'ARM repeat', 286322),
(477045, '0053206', NULL, NULL, 388, NULL, 'ARM repeat', 286322),
(477046, '0050410', NULL, NULL, 321, NULL, 'ARM repeat', 286322),
(477047, '0046912', NULL, NULL, 531, NULL, 'ARM repeat', 286322),
(477048, '0038440', NULL, NULL, 296, NULL, 'ARM repeat', 286322),
(477049, '0042771', NULL, NULL, 876, NULL, 'ARM repeat', 286322),
(477050, '0049802', NULL, NULL, 1207, NULL, 'ARM repeat', 286322),
(477051, '0047107', NULL, NULL, 262, NULL, 'ARM repeat', 286322),
(477052, '0047129', NULL, NULL, 264, NULL, 'ARM repeat', 286322),
(477053, '0047075', NULL, NULL, 584, NULL, 'ARM repeat', 286322),
(477054, '0048021', NULL, NULL, 233, NULL, 'ARM repeat', 286322),
(477055, '0051473', NULL, NULL, 361, NULL, 'ARM repeat', 286322),
(477056, '0052026', NULL, NULL, 861, NULL, 'ARM repeat', 286322),
(477057, '0051211', NULL, NULL, 82, NULL, 'ARM repeat', 286322),
(477058, '0053212', NULL, NULL, 129, NULL, 'ARM repeat', 286322),
(477059, '0044481', NULL, NULL, 330, NULL, 'ARM repeat', 286322),
(477060, '0045990', NULL, NULL, 157, NULL, 'ARM repeat', 286322),
(477061, '0047230', NULL, NULL, 150, NULL, 'ARM repeat', 286322),
(477062, '0048121', NULL, NULL, 339, NULL, 'ARM repeat', 286322),
(477063, '0049277', NULL, NULL, 130, NULL, 'ARM repeat', 286322),
(477064, '0049893', NULL, NULL, 127, NULL, 'ARM repeat', 286322),
(477065, '0049892', NULL, NULL, 193, NULL, 'ARM repeat', 286322),
(477066, '0038439', NULL, NULL, 190, NULL, 'ARM repeat', 286322),
(477067, '0054109', NULL, NULL, 121, NULL, 'ARM repeat', 286322),
(477068, '0042225', NULL, NULL, 161, NULL, 'ARM repeat', 286322),
(477069, '0042067', NULL, NULL, 108, NULL, 'ARM repeat', 286322),
(477070, '0051926', NULL, NULL, 213, NULL, 'ARM repeat', 286322),
(477071, '0043958', NULL, NULL, 111, NULL, 'ARM repeat', 286322),
(477072, '0043817', NULL, NULL, 235, NULL, 'ARM repeat', 286322),
(477073, '0047214', NULL, NULL, 477, NULL, 'ARM repeat', 286322);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(477074, '0047335', NULL, NULL, 453, NULL, 'ARM repeat', 286322),
(477075, '0048666', NULL, NULL, 276, NULL, 'ARM repeat', 286322),
(477076, '0051071', NULL, NULL, 264, NULL, 'ARM repeat', 286322),
(477077, '0045897', NULL, NULL, 336, NULL, 'ARM repeat', 286322),
(477078, '0044543', NULL, NULL, 248, NULL, 'ARM repeat', 286322),
(477079, '0045874', NULL, NULL, 588, NULL, 'ARM repeat', 286322),
(477080, '0048921', NULL, NULL, 888, NULL, 'ARM repeat', 286322),
(477081, '0044698', NULL, NULL, 149, NULL, 'Hemolytic lectin CEL-III, C-terminal domain', 286323),
(477082, '0043679', NULL, NULL, 131, NULL, 'Ctag/Cox11', 286324),
(477083, '0036655', NULL, NULL, 123, NULL, 'FAD/NAD-linked reductases, dimerisation (C-terminal) domain', 286325),
(477084, '0036302', NULL, NULL, 97, NULL, 'FAD/NAD-linked reductases, dimerisation (C-terminal) domain', 286325),
(477085, '0037510', NULL, NULL, 128, NULL, 'FAD/NAD-linked reductases, dimerisation (C-terminal) domain', 286325),
(477086, '0039504', NULL, NULL, 123, NULL, 'FAD/NAD-linked reductases, dimerisation (C-terminal) domain', 286325),
(477087, '0050962', NULL, NULL, 62, NULL, 'FAD/NAD-linked reductases, dimerisation (C-terminal) domain', 286325),
(477088, '0042578', NULL, NULL, 103, NULL, 'FAD/NAD-linked reductases, dimerisation (C-terminal) domain', 286325),
(477089, '0050928', NULL, NULL, 118, NULL, 'FAD/NAD-linked reductases, dimerisation (C-terminal) domain', 286325),
(477090, '0041023', NULL, NULL, 140, NULL, 'FAD/NAD-linked reductases, dimerisation (C-terminal) domain', 286325),
(477091, '0038076', NULL, NULL, 115, NULL, 'FAD/NAD-linked reductases, dimerisation (C-terminal) domain', 286325),
(477092, '0038450', NULL, NULL, 133, NULL, 'FAD/NAD-linked reductases, dimerisation (C-terminal) domain', 286325),
(477093, '0040690', NULL, NULL, 123, NULL, 'FAD/NAD-linked reductases, dimerisation (C-terminal) domain', 286325),
(477094, '0041394', NULL, NULL, 126, NULL, 'FAD/NAD-linked reductases, dimerisation (C-terminal) domain', 286325),
(477095, '0035130', NULL, NULL, 130, NULL, 'FAD/NAD-linked reductases, dimerisation (C-terminal) domain', 286325),
(477096, '0036890', NULL, NULL, 115, NULL, 'FAD/NAD-linked reductases, dimerisation (C-terminal) domain', 286325),
(477097, '0040604', NULL, NULL, 124, NULL, 'FAD/NAD-linked reductases, dimerisation (C-terminal) domain', 286325),
(477098, '0037490', NULL, NULL, 74, NULL, 'FAD/NAD-linked reductases, dimerisation (C-terminal) domain', 286325),
(477099, '0045520', NULL, NULL, 115, NULL, 'FAD/NAD-linked reductases, dimerisation (C-terminal) domain', 286325),
(477100, '0040820', NULL, NULL, 131, NULL, 'FAD/NAD-linked reductases, dimerisation (C-terminal) domain', 286325),
(477101, '0041887', NULL, NULL, 128, NULL, 'FAD/NAD-linked reductases, dimerisation (C-terminal) domain', 286325),
(477102, '0045533', NULL, NULL, 124, NULL, 'FAD/NAD-linked reductases, dimerisation (C-terminal) domain', 286325),
(477103, '0041941', NULL, NULL, 119, NULL, 'FAD/NAD-linked reductases, dimerisation (C-terminal) domain', 286325),
(477104, '0048572', NULL, NULL, 121, NULL, 'JAB1/MPN domain', 286326),
(477105, '0037573', NULL, NULL, 70, NULL, 'N-terminal domains of the minor coat protein g3p', 286327),
(477106, '0037919', NULL, NULL, 127, NULL, 'N-terminal domains of the minor coat protein g3p', 286327),
(477107, '0052545', NULL, NULL, 80, NULL, 'CarD-like', 286328),
(477108, '0051980', NULL, NULL, 308, NULL, 'Metallo-hydrolase/oxidoreductase', 286329),
(477109, '0050252', NULL, NULL, 250, NULL, 'Metallo-hydrolase/oxidoreductase', 286329),
(477110, '0051022', NULL, NULL, 254, NULL, 'Metallo-hydrolase/oxidoreductase', 286329),
(477111, '0048073', NULL, NULL, 219, NULL, 'Metallo-hydrolase/oxidoreductase', 286329),
(477112, '0051102', NULL, NULL, 304, NULL, 'Metallo-hydrolase/oxidoreductase', 286329),
(477113, '0050210', NULL, NULL, 209, NULL, 'Metallo-hydrolase/oxidoreductase', 286329),
(477114, '0045185', NULL, NULL, 221, NULL, 'Metallo-hydrolase/oxidoreductase', 286329),
(477115, '0053827', NULL, NULL, 431, NULL, 'Metallo-hydrolase/oxidoreductase', 286329);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(477116, '0050873', NULL, NULL, 228, NULL, 'Metallo-hydrolase/oxidoreductase', 286329),
(477117, '0051863', NULL, NULL, 183, NULL, 'Metallo-hydrolase/oxidoreductase', 286329),
(477118, '0048716', NULL, NULL, 294, NULL, 'Metallo-hydrolase/oxidoreductase', 286329),
(477119, '0050726', NULL, NULL, 280, NULL, 'Metallo-hydrolase/oxidoreductase', 286329),
(477120, '0036363', NULL, NULL, 216, NULL, 'Metallo-hydrolase/oxidoreductase', 286329),
(477121, '0047843', NULL, NULL, 230, NULL, 'Metallo-hydrolase/oxidoreductase', 286329),
(477122, '0043666', NULL, NULL, 266, NULL, 'Metallo-hydrolase/oxidoreductase', 286329),
(477123, '0054104', NULL, NULL, 451, NULL, 'Metallo-hydrolase/oxidoreductase', 286329),
(477124, '0051275', NULL, NULL, 249, NULL, 'Metallo-hydrolase/oxidoreductase', 286329),
(477125, '0054105', NULL, NULL, 515, NULL, 'Metallo-hydrolase/oxidoreductase', 286329),
(477126, '0053773', NULL, NULL, 505, NULL, 'Metallo-hydrolase/oxidoreductase', 286329),
(477127, '0051591', NULL, NULL, 244, NULL, 'Metallo-hydrolase/oxidoreductase', 286329),
(477128, '0051194', NULL, NULL, 307, NULL, 'Metallo-hydrolase/oxidoreductase', 286329),
(477129, '0052141', NULL, NULL, 305, NULL, 'Metallo-hydrolase/oxidoreductase', 286329),
(477130, '0039825', NULL, NULL, 262, NULL, 'Metallo-hydrolase/oxidoreductase', 286329),
(477131, '0051638', NULL, NULL, 207, NULL, 'Metallo-hydrolase/oxidoreductase', 286329),
(477132, '0053954', NULL, NULL, 264, NULL, 'Metallo-hydrolase/oxidoreductase', 286329),
(477133, '0054603', NULL, NULL, 251, NULL, 'Metallo-hydrolase/oxidoreductase', 286329),
(477134, '0054569', NULL, NULL, 298, NULL, 'Metallo-hydrolase/oxidoreductase', 286329),
(477135, '0046465', NULL, NULL, 249, NULL, 'Metallo-hydrolase/oxidoreductase', 286329),
(477136, '0054482', NULL, NULL, 200, NULL, 'Metallo-hydrolase/oxidoreductase', 286329),
(477137, '0042783', NULL, NULL, 260, NULL, 'Metallo-hydrolase/oxidoreductase', 286329),
(477138, '0045733', NULL, NULL, 227, NULL, 'Metallo-hydrolase/oxidoreductase', 286329),
(477139, '0048172', NULL, NULL, 160, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330),
(477140, '0050233', NULL, NULL, 168, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330),
(477141, '0043381', NULL, NULL, 230, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330),
(477142, '0054132', NULL, NULL, 134, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330),
(477143, '0039538', NULL, NULL, 299, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330),
(477144, '0050614', NULL, NULL, 135, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330),
(477145, '0052117', NULL, NULL, 218, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330),
(477146, '0036966', NULL, NULL, 246, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330),
(477147, '0039977', NULL, NULL, 188, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330),
(477148, '0051645', NULL, NULL, 211, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330),
(477149, '0047848', NULL, NULL, 165, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330),
(477150, '0046213', NULL, NULL, 324, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330),
(477151, '0048858', NULL, NULL, 296, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330),
(477152, '0054501', NULL, NULL, 230, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330),
(477153, '0045391', NULL, NULL, 271, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330),
(477154, '0047035', NULL, NULL, 197, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330),
(477155, '0048520', NULL, NULL, 261, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330),
(477156, '0049476', NULL, NULL, 215, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330),
(477157, '0052363', NULL, NULL, 226, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330),
(477158, '0046540', NULL, NULL, 183, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330),
(477159, '0049673', NULL, NULL, 147, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330),
(477160, '0050128', NULL, NULL, 132, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(477161, '0050746', NULL, NULL, 216, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330),
(477162, '0052923', NULL, NULL, 171, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330),
(477163, '0051038', NULL, NULL, 255, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330),
(477164, '0036970', NULL, NULL, 188, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330),
(477165, '0050739', NULL, NULL, 274, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330),
(477166, '0047632', NULL, NULL, 140, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330),
(477167, '0048369', NULL, NULL, 227, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330),
(477168, '0048521', NULL, NULL, 192, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330),
(477169, '0046546', NULL, NULL, 252, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330),
(477170, '0042641', NULL, NULL, 138, NULL, 'Adenine nucleotide alpha hydrolases-like', 286330),
(477171, '0051155', NULL, NULL, 174, NULL, 'TrmE connector domain', 286331),
(477172, '0047141', NULL, NULL, 197, NULL, 'Nucleotide-binding domain', 286332),
(477173, '0048807', NULL, NULL, 180, NULL, 'Nucleotide-binding domain', 286332),
(477174, '0053749', NULL, NULL, 315, NULL, 'Nucleotide-binding domain', 286332),
(477175, '0046057', NULL, NULL, 269, NULL, 'Nucleotide-binding domain', 286332),
(477176, '0046156', NULL, NULL, 231, NULL, 'Nucleotide-binding domain', 286332),
(477177, '0045795', NULL, NULL, 248, NULL, 'Nucleotide-binding domain', 286332),
(477178, '0048016', NULL, NULL, 240, NULL, 'Nucleotide-binding domain', 286332),
(477179, '0036459', NULL, NULL, 234, NULL, 'Nucleotide-binding domain', 286332),
(477180, '0047327', NULL, NULL, 299, NULL, 'Nucleotide-binding domain', 286332),
(477181, '0052594', NULL, NULL, 283, NULL, 'Acetamidase/Formamidase-like', 286333),
(477182, '0047364', NULL, NULL, 416, NULL, 'Phosphoenolpyruvate/pyruvate domain', 286334),
(477183, '0048498', NULL, NULL, 260, NULL, 'Phosphoenolpyruvate/pyruvate domain', 286334),
(477184, '0046386', NULL, NULL, 519, NULL, 'Phosphoenolpyruvate/pyruvate domain', 286334),
(477185, '0047484', NULL, NULL, 299, NULL, 'Phosphoenolpyruvate/pyruvate domain', 286334),
(477186, '0047660', NULL, NULL, 936, NULL, 'Phosphoenolpyruvate/pyruvate domain', 286334),
(477187, '0048078', NULL, NULL, 262, NULL, 'Phosphoenolpyruvate/pyruvate domain', 286334),
(477188, '0042073', NULL, NULL, 262, NULL, 'Phosphoenolpyruvate/pyruvate domain', 286334),
(477189, '0041093', NULL, NULL, 289, NULL, 'Phosphoenolpyruvate/pyruvate domain', 286334),
(477190, '0050125', NULL, NULL, 356, NULL, 'Phosphoenolpyruvate/pyruvate domain', 286334),
(477191, '0049391', NULL, NULL, 231, NULL, 'Phosphoenolpyruvate/pyruvate domain', 286334),
(477192, '0036701', NULL, NULL, 247, NULL, 'Phosphoenolpyruvate/pyruvate domain', 286334),
(477193, '0054448', NULL, NULL, 197, NULL, 'Phosphoenolpyruvate/pyruvate domain', 286334),
(477194, '0037440', NULL, NULL, 427, NULL, 'Phosphoenolpyruvate/pyruvate domain', 286334),
(477195, '0038453', NULL, NULL, 366, NULL, 'Phosphoenolpyruvate/pyruvate domain', 286334),
(477196, '0045706', NULL, NULL, 265, NULL, 'Phosphoenolpyruvate/pyruvate domain', 286334),
(477197, '0045708', NULL, NULL, 283, NULL, 'Phosphoenolpyruvate/pyruvate domain', 286334),
(477198, '0049789', NULL, NULL, 223, NULL, 'Phosphoenolpyruvate/pyruvate domain', 286334),
(477199, '0048777', NULL, NULL, 259, NULL, 'Phosphoenolpyruvate/pyruvate domain', 286334),
(477200, '0048843', NULL, NULL, 291, NULL, 'Phosphoenolpyruvate/pyruvate domain', 286334),
(477201, '0046414', NULL, NULL, 253, NULL, 'Phosphoenolpyruvate/pyruvate domain', 286334),
(477202, '0047659', NULL, NULL, 880, NULL, 'Phosphoenolpyruvate/pyruvate domain', 286334),
(477203, '0047978', NULL, NULL, 282, NULL, 'Phosphoenolpyruvate/pyruvate domain', 286334),
(477204, '0047777', NULL, NULL, 364, NULL, 'Phosphoenolpyruvate/pyruvate domain', 286334),
(477205, '0049923', NULL, NULL, 283, NULL, 'Phosphoenolpyruvate/pyruvate domain', 286334),
(477206, '0052353', NULL, NULL, 118, NULL, 'MTH938-like', 286335);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(477207, '0051739', NULL, NULL, 121, NULL, 'MTH938-like', 286335),
(477208, '0039031', NULL, NULL, 113, NULL, 'MTH938-like', 286335),
(477209, '0052790', NULL, NULL, 127, NULL, 'MTH938-like', 286335),
(477210, '0052700', NULL, NULL, 118, NULL, 'MTH938-like', 286335),
(477211, '0040561', NULL, NULL, 150, NULL, 'VHL', 286336),
(477212, '0040740', NULL, NULL, 490, NULL, 'Amidase signature (AS) enzymes', 286337),
(477213, '0052574', NULL, NULL, 485, NULL, 'Amidase signature (AS) enzymes', 286337),
(477214, '0041075', NULL, NULL, 537, NULL, 'Amidase signature (AS) enzymes', 286337),
(477215, '0052903', NULL, NULL, 475, NULL, 'Amidase signature (AS) enzymes', 286337),
(477216, '0041778', NULL, NULL, 412, NULL, 'Amidase signature (AS) enzymes', 286337),
(477217, '0041989', NULL, NULL, 66, NULL, 'N-terminal, cytoplasmic domain of anti-sigmaE factor RseA', 286338),
(477218, '0050990', NULL, NULL, 320, NULL, 'Protein kinase-like (PK-like)', 286339),
(477219, '0046494', NULL, NULL, 367, NULL, 'Protein kinase-like (PK-like)', 286339),
(477220, '0041719', NULL, NULL, 277, NULL, 'Protein kinase-like (PK-like)', 286339),
(477221, '0046210', NULL, NULL, 293, NULL, 'Protein kinase-like (PK-like)', 286339),
(477222, '0044907', NULL, NULL, 299, NULL, 'Protein kinase-like (PK-like)', 286339),
(477223, '0035157', NULL, NULL, 341, NULL, 'Protein kinase-like (PK-like)', 286339),
(477224, '0038940', NULL, NULL, 275, NULL, 'Protein kinase-like (PK-like)', 286339),
(477225, '0037731', NULL, NULL, 275, NULL, 'Protein kinase-like (PK-like)', 286339),
(477226, '0054833', NULL, NULL, 318, NULL, 'Protein kinase-like (PK-like)', 286339),
(477227, '0037572', NULL, NULL, 299, NULL, 'Protein kinase-like (PK-like)', 286339),
(477228, '0041048', NULL, NULL, 283, NULL, 'Protein kinase-like (PK-like)', 286339),
(477229, '0040670', NULL, NULL, 301, NULL, 'Protein kinase-like (PK-like)', 286339),
(477230, '0039870', NULL, NULL, 258, NULL, 'Protein kinase-like (PK-like)', 286339),
(477231, '0050905', NULL, NULL, 277, NULL, 'Protein kinase-like (PK-like)', 286339),
(477232, '0039792', NULL, NULL, 336, NULL, 'Protein kinase-like (PK-like)', 286339),
(477233, '0044036', NULL, NULL, 321, NULL, 'Protein kinase-like (PK-like)', 286339),
(477234, '0041767', NULL, NULL, 286, NULL, 'Protein kinase-like (PK-like)', 286339),
(477235, '0043269', NULL, NULL, 325, NULL, 'Protein kinase-like (PK-like)', 286339),
(477236, '0051133', NULL, NULL, 273, NULL, 'Protein kinase-like (PK-like)', 286339),
(477237, '0041927', NULL, NULL, 364, NULL, 'Protein kinase-like (PK-like)', 286339),
(477238, '0043074', NULL, NULL, 311, NULL, 'Protein kinase-like (PK-like)', 286339),
(477239, '0041095', NULL, NULL, 261, NULL, 'Protein kinase-like (PK-like)', 286339),
(477240, '0038659', NULL, NULL, 362, NULL, 'Protein kinase-like (PK-like)', 286339),
(477241, '0037803', NULL, NULL, 309, NULL, 'Protein kinase-like (PK-like)', 286339),
(477242, '0038413', NULL, NULL, 286, NULL, 'Protein kinase-like (PK-like)', 286339),
(477243, '0046180', NULL, NULL, 346, NULL, 'Protein kinase-like (PK-like)', 286339),
(477244, '0037369', NULL, NULL, 294, NULL, 'Protein kinase-like (PK-like)', 286339),
(477245, '0036031', NULL, NULL, 299, NULL, 'Protein kinase-like (PK-like)', 286339),
(477246, '0039145', NULL, NULL, 303, NULL, 'Protein kinase-like (PK-like)', 286339),
(477247, '0044407', NULL, NULL, 355, NULL, 'Protein kinase-like (PK-like)', 286339),
(477248, '0044924', NULL, NULL, 322, NULL, 'Protein kinase-like (PK-like)', 286339),
(477249, '0038373', NULL, NULL, 289, NULL, 'Protein kinase-like (PK-like)', 286339),
(477250, '0044203', NULL, NULL, 273, NULL, 'Protein kinase-like (PK-like)', 286339),
(477251, '0048206', NULL, NULL, 273, NULL, 'Protein kinase-like (PK-like)', 286339),
(477252, '0049538', NULL, NULL, 270, NULL, 'Protein kinase-like (PK-like)', 286339),
(477253, '0034801', NULL, NULL, 307, NULL, 'Protein kinase-like (PK-like)', 286339),
(477254, '0035615', NULL, NULL, 305, NULL, 'Protein kinase-like (PK-like)', 286339),
(477255, '0048011', NULL, NULL, 327, NULL, 'Protein kinase-like (PK-like)', 286339);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(477256, '0047088', NULL, NULL, 298, NULL, 'Protein kinase-like (PK-like)', 286339),
(477257, '0040727', NULL, NULL, 325, NULL, 'Protein kinase-like (PK-like)', 286339),
(477258, '0053681', NULL, NULL, 325, NULL, 'Protein kinase-like (PK-like)', 286339),
(477259, '0053164', NULL, NULL, 269, NULL, 'Protein kinase-like (PK-like)', 286339),
(477260, '0042707', NULL, NULL, 282, NULL, 'Protein kinase-like (PK-like)', 286339),
(477261, '0037714', NULL, NULL, 316, NULL, 'Protein kinase-like (PK-like)', 286339),
(477262, '0054536', NULL, NULL, 316, NULL, 'Protein kinase-like (PK-like)', 286339),
(477263, '0044090', NULL, NULL, 192, NULL, 'Protein kinase-like (PK-like)', 286339),
(477264, '0035371', NULL, NULL, 326, NULL, 'Protein kinase-like (PK-like)', 286339),
(477265, '0040179', NULL, NULL, 350, NULL, 'Protein kinase-like (PK-like)', 286339),
(477266, '0042315', NULL, NULL, 277, NULL, 'Protein kinase-like (PK-like)', 286339),
(477267, '0049348', NULL, NULL, 322, NULL, 'Protein kinase-like (PK-like)', 286339),
(477268, '0049347', NULL, NULL, 334, NULL, 'Protein kinase-like (PK-like)', 286339),
(477269, '0049786', NULL, NULL, 285, NULL, 'Protein kinase-like (PK-like)', 286339),
(477270, '0042354', NULL, NULL, 303, NULL, 'Protein kinase-like (PK-like)', 286339),
(477271, '0046998', NULL, NULL, 298, NULL, 'Protein kinase-like (PK-like)', 286339),
(477272, '0054221', NULL, NULL, 288, NULL, 'Protein kinase-like (PK-like)', 286339),
(477273, '0046042', NULL, NULL, 262, NULL, 'Protein kinase-like (PK-like)', 286339),
(477274, '0047332', NULL, NULL, 278, NULL, 'Protein kinase-like (PK-like)', 286339),
(477275, '0049795', NULL, NULL, 309, NULL, 'Protein kinase-like (PK-like)', 286339),
(477276, '0037668', NULL, NULL, 285, NULL, 'Protein kinase-like (PK-like)', 286339),
(477277, '0051877', NULL, NULL, 355, NULL, 'Protein kinase-like (PK-like)', 286339),
(477278, '0040180', NULL, NULL, 353, NULL, 'Protein kinase-like (PK-like)', 286339),
(477279, '0042918', NULL, NULL, 272, NULL, 'Protein kinase-like (PK-like)', 286339),
(477280, '0052889', NULL, NULL, 348, NULL, 'Protein kinase-like (PK-like)', 286339),
(477281, '0036014', NULL, NULL, 342, NULL, 'Protein kinase-like (PK-like)', 286339),
(477282, '0039408', NULL, NULL, 263, NULL, 'Protein kinase-like (PK-like)', 286339),
(477283, '0039603', NULL, NULL, 293, NULL, 'Protein kinase-like (PK-like)', 286339),
(477284, '0054547', NULL, NULL, 392, NULL, 'Protein kinase-like (PK-like)', 286339),
(477285, '0044547', NULL, NULL, 276, NULL, 'Protein kinase-like (PK-like)', 286339),
(477286, '0043658', NULL, NULL, 263, NULL, 'Protein kinase-like (PK-like)', 286339),
(477287, '0038477', NULL, NULL, 352, NULL, 'Protein kinase-like (PK-like)', 286339),
(477288, '0039686', NULL, NULL, 299, NULL, 'Protein kinase-like (PK-like)', 286339),
(477289, '0041592', NULL, NULL, 395, NULL, 'Protein kinase-like (PK-like)', 286339),
(477290, '0048785', NULL, NULL, 345, NULL, 'Protein kinase-like (PK-like)', 286339),
(477291, '0041315', NULL, NULL, 255, NULL, 'Protein kinase-like (PK-like)', 286339),
(477292, '0040302', NULL, NULL, 340, NULL, 'Protein kinase-like (PK-like)', 286339),
(477293, '0041710', NULL, NULL, 337, NULL, 'Protein kinase-like (PK-like)', 286339),
(477294, '0047734', NULL, NULL, 299, NULL, 'Protein kinase-like (PK-like)', 286339),
(477295, '0049834', NULL, NULL, 299, NULL, 'Protein kinase-like (PK-like)', 286339),
(477296, '0036817', NULL, NULL, 45, NULL, 'Epsilon subunit of F1F0-ATP synthase C-terminal domain', 286340),
(477297, '0045808', NULL, NULL, 50, NULL, 'Epsilon subunit of F1F0-ATP synthase C-terminal domain', 286340),
(477298, '0042148', NULL, NULL, 307, NULL, 'Origin of replication-binding domain, RBD-like', 286341),
(477299, '0040363', NULL, NULL, 118, NULL, 'Origin of replication-binding domain, RBD-like', 286341),
(477300, '0040790', NULL, NULL, 193, NULL, 'Origin of replication-binding domain, RBD-like', 286341),
(477301, '0043184', NULL, NULL, 145, NULL, 'Origin of replication-binding domain, RBD-like', 286341),
(477302, '0037306', NULL, NULL, 148, NULL, 'Origin of replication-binding domain, RBD-like', 286341);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(477303, '0041922', NULL, NULL, 293, NULL, 'Origin of replication-binding domain, RBD-like', 286341),
(477304, '0052766', NULL, NULL, 126, NULL, 'Origin of replication-binding domain, RBD-like', 286341),
(477305, '0041782', NULL, NULL, 144, NULL, 'Mitochondrial cytochrome c oxidase subunit IV', 286342),
(477306, '0044030', NULL, NULL, 41, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477307, '0054594', NULL, NULL, 100, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477308, '0036002', NULL, NULL, 89, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477309, '0045122', NULL, NULL, 30, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477310, '0047389', NULL, NULL, 48, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477311, '0043072', NULL, NULL, 86, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477312, '0052461', NULL, NULL, 35, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477313, '0043073', NULL, NULL, 76, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477314, '0052462', NULL, NULL, 33, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477315, '0048881', NULL, NULL, 46, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477316, '0050846', NULL, NULL, 32, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477317, '0050845', NULL, NULL, 27, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477318, '0038533', NULL, NULL, 74, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477319, '0051139', NULL, NULL, 49, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477320, '0040769', NULL, NULL, 39, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477321, '0040768', NULL, NULL, 32, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477322, '0040006', NULL, NULL, 99, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477323, '0036190', NULL, NULL, 31, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477324, '0042543', NULL, NULL, 80, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477325, '0043116', NULL, NULL, 74, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477326, '0050855', NULL, NULL, 34, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477327, '0050854', NULL, NULL, 34, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477328, '0051943', NULL, NULL, 67, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477329, '0050856', NULL, NULL, 34, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477330, '0050851', NULL, NULL, 45, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477331, '0050850', NULL, NULL, 32, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477332, '0050853', NULL, NULL, 29, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477333, '0050852', NULL, NULL, 31, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477334, '0039333', NULL, NULL, 33, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477335, '0039332', NULL, NULL, 30, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477336, '0036189', NULL, NULL, 28, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477337, '0050848', NULL, NULL, 35, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477338, '0050847', NULL, NULL, 31, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477339, '0036583', NULL, NULL, 84, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477340, '0050849', NULL, NULL, 37, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477341, '0045386', NULL, NULL, 103, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477342, '0052191', NULL, NULL, 33, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(477343, '0052192', NULL, NULL, 36, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477344, '0035409', NULL, NULL, 65, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477345, '0035408', NULL, NULL, 35, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477346, '0050585', NULL, NULL, 32, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477347, '0041629', NULL, NULL, 31, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477348, '0052407', NULL, NULL, 25, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477349, '0052408', NULL, NULL, 32, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477350, '0052405', NULL, NULL, 35, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477351, '0052406', NULL, NULL, 42, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477352, '0052403', NULL, NULL, 32, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477353, '0050586', NULL, NULL, 41, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477354, '0052404', NULL, NULL, 25, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477355, '0052126', NULL, NULL, 56, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477356, '0037546', NULL, NULL, 53, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477357, '0042049', NULL, NULL, 38, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477358, '0041630', NULL, NULL, 35, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477359, '0041473', NULL, NULL, 48, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477360, '0053982', NULL, NULL, 33, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477361, '0049246', NULL, NULL, 33, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477362, '0049245', NULL, NULL, 31, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477363, '0052418', NULL, NULL, 45, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477364, '0052417', NULL, NULL, 32, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477365, '0050752', NULL, NULL, 27, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477366, '0050751', NULL, NULL, 32, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477367, '0050907', NULL, NULL, 41, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477368, '0039950', NULL, NULL, 44, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477369, '0043947', NULL, NULL, 44, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477370, '0040677', NULL, NULL, 65, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477371, '0037929', NULL, NULL, 35, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477372, '0045290', NULL, NULL, 66, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477373, '0037928', NULL, NULL, 35, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477374, '0052306', NULL, NULL, 30, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477375, '0052307', NULL, NULL, 33, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477376, '0034932', NULL, NULL, 32, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477377, '0049092', NULL, NULL, 46, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477378, '0036273', NULL, NULL, 36, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477379, '0040440', NULL, NULL, 71, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477380, '0038173', NULL, NULL, 46, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477381, '0045056', NULL, NULL, 36, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477382, '0045730', NULL, NULL, 28, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(477383, '0044640', NULL, NULL, 41, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477384, '0044641', NULL, NULL, 40, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477385, '0050811', NULL, NULL, 27, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477386, '0052319', NULL, NULL, 31, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477387, '0050810', NULL, NULL, 32, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477388, '0053805', NULL, NULL, 86, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477389, '0050813', NULL, NULL, 30, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477390, '0052317', NULL, NULL, 32, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477391, '0050812', NULL, NULL, 29, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477392, '0052318', NULL, NULL, 35, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477393, '0038687', NULL, NULL, 80, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477394, '0052315', NULL, NULL, 31, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477395, '0052316', NULL, NULL, 27, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477396, '0045905', NULL, NULL, 43, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477397, '0045906', NULL, NULL, 49, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477398, '0052202', NULL, NULL, 31, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477399, '0036936', NULL, NULL, 56, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477400, '0052320', NULL, NULL, 25, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477401, '0034917', NULL, NULL, 78, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477402, '0045592', NULL, NULL, 66, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477403, '0037624', NULL, NULL, 60, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477404, '0053658', NULL, NULL, 96, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477405, '0050787', NULL, NULL, 32, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477406, '0052203', NULL, NULL, 35, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477407, '0052445', NULL, NULL, 31, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477408, '0050786', NULL, NULL, 35, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477409, '0052446', NULL, NULL, 36, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477410, '0038158', NULL, NULL, 81, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477411, '0053809', NULL, NULL, 49, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477412, '0039082', NULL, NULL, 28, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477413, '0044540', NULL, NULL, 117, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477414, '0040589', NULL, NULL, 90, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', 286343),
(477415, '0035812', NULL, NULL, 217, NULL, 'gene 59 helicase assembly protein', 286344),
(477416, '0042640', NULL, NULL, 297, NULL, 'LmbE-like', 286345),
(477417, '0044238', NULL, NULL, 227, NULL, 'LmbE-like', 286345),
(477418, '0039566', NULL, NULL, 114, NULL, 'SRP19', 286346),
(477419, '0040287', NULL, NULL, 104, NULL, 'SRP19', 286346),
(477420, '0040576', NULL, NULL, 87, NULL, 'SRP19', 286346),
(477421, '0041530', NULL, NULL, 155, NULL, 'SNARE-like', 286347),
(477422, '0038994', NULL, NULL, 127, NULL, 'SNARE-like', 286347),
(477423, '0052690', NULL, NULL, 129, NULL, 'SNARE-like', 286347),
(477424, '0047143', NULL, NULL, 140, NULL, 'SNARE-like', 286347),
(477425, '0038406', NULL, NULL, 140, NULL, 'SNARE-like', 286347),
(477426, '0038303', NULL, NULL, 141, NULL, 'SNARE-like', 286347);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(477427, '0038304', NULL, NULL, 142, NULL, 'SNARE-like', 286347),
(477428, '0043049', NULL, NULL, 111, NULL, 'Replicase NSP9', 286348),
(477429, '0036839', NULL, NULL, 94, NULL, 'Signal recognition particle alu RNA binding heterodimer, SRP9/14', 286349),
(477430, '0036838', NULL, NULL, 74, NULL, 'Signal recognition particle alu RNA binding heterodimer, SRP9/14', 286349),
(477431, '0034791', NULL, NULL, 78, NULL, 'Signal recognition particle alu RNA binding heterodimer, SRP9/14', 286349),
(477432, '0034792', NULL, NULL, 97, NULL, 'Signal recognition particle alu RNA binding heterodimer, SRP9/14', 286349),
(477433, '0051579', NULL, NULL, 433, NULL, 'Oxysterol-binding protein-like', 286350),
(477434, '0046074', NULL, NULL, 35, NULL, 'Gurmarin-like', 286351),
(477435, '0048883', NULL, NULL, 36, NULL, 'Gurmarin-like', 286351),
(477436, '0046346', NULL, NULL, 38, NULL, 'Gurmarin-like', 286351),
(477437, '0043988', NULL, NULL, 142, NULL, 'Elongation factor Ts (EF-Ts), dimerisation domain', 286352),
(477438, '0050903', NULL, NULL, 111, NULL, 'Elongation factor Ts (EF-Ts), dimerisation domain', 286352),
(477439, '0050904', NULL, NULL, 109, NULL, 'Elongation factor Ts (EF-Ts), dimerisation domain', 286352),
(477440, '0046542', NULL, NULL, 143, NULL, 'Elongation factor Ts (EF-Ts), dimerisation domain', 286352),
(477441, '0046544', NULL, NULL, 85, NULL, 'Elongation factor Ts (EF-Ts), dimerisation domain', 286352),
(477442, '0050280', NULL, NULL, 57, NULL, 'CsrA-like', 286353),
(477443, '0043476', NULL, NULL, 180, NULL, 'Cag-Z', 286354),
(477444, '0040058', NULL, NULL, 118, NULL, 'Phosphoglucomutase, first 3 domains', 286355),
(477445, '0045549', NULL, NULL, 190, NULL, 'Phosphoglucomutase, first 3 domains', 286355),
(477446, '0040057', NULL, NULL, 203, NULL, 'Phosphoglucomutase, first 3 domains', 286355),
(477447, '0039874', NULL, NULL, 104, NULL, 'Phosphoglucomutase, first 3 domains', 286355),
(477448, '0039873', NULL, NULL, 150, NULL, 'Phosphoglucomutase, first 3 domains', 286355),
(477449, '0045550', NULL, NULL, 113, NULL, 'Phosphoglucomutase, first 3 domains', 286355),
(477450, '0045551', NULL, NULL, 117, NULL, 'Phosphoglucomutase, first 3 domains', 286355),
(477451, '0039875', NULL, NULL, 109, NULL, 'Phosphoglucomutase, first 3 domains', 286355),
(477452, '0040059', NULL, NULL, 120, NULL, 'Phosphoglucomutase, first 3 domains', 286355),
(477453, '0045552', NULL, NULL, 141, NULL, 'Phosphoglucomutase, C-terminal domain', 286356),
(477454, '0040060', NULL, NULL, 129, NULL, 'Phosphoglucomutase, C-terminal domain', 286356),
(477455, '0039876', NULL, NULL, 96, NULL, 'Phosphoglucomutase, C-terminal domain', 286356),
(477456, '0050632', NULL, NULL, 112, NULL, 'Phosphoglucomutase, C-terminal domain', 286356),
(477457, '0035936', NULL, NULL, 241, NULL, 'Ribosome inactivating proteins (RIP)', 286357),
(477458, '0054577', NULL, NULL, 247, NULL, 'Ribosome inactivating proteins (RIP)', 286357),
(477459, '0035956', NULL, NULL, 249, NULL, 'Ribosome inactivating proteins (RIP)', 286357),
(477460, '0040749', NULL, NULL, 248, NULL, 'Ribosome inactivating proteins (RIP)', 286357),
(477461, '0049281', NULL, NULL, 259, NULL, 'Ribosome inactivating proteins (RIP)', 286357),
(477462, '0034985', NULL, NULL, 251, NULL, 'Ribosome inactivating proteins (RIP)', 286357),
(477463, '0040597', NULL, NULL, 254, NULL, 'Ribosome inactivating proteins (RIP)', 286357),
(477464, '0035154', NULL, NULL, 261, NULL, 'Ribosome inactivating proteins (RIP)', 286357),
(477465, '0054908', NULL, NULL, 246, NULL, 'Ribosome inactivating proteins (RIP)', 286357),
(477466, '0042475', NULL, NULL, 249, NULL, 'Ribosome inactivating proteins (RIP)', 286357),
(477467, '0035687', NULL, NULL, 247, NULL, 'Ribosome inactivating proteins (RIP)', 286357),
(477468, '0038757', NULL, NULL, 251, NULL, 'Ribosome inactivating proteins (RIP)', 286357),
(477469, '0041058', NULL, NULL, 247, NULL, 'Ribosome inactivating proteins (RIP)', 286357),
(477470, '0043118', NULL, NULL, 297, NULL, 'Ribosome inactivating proteins (RIP)', 286357),
(477471, '0041057', NULL, NULL, 246, NULL, 'Ribosome inactivating proteins (RIP)', 286357);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(477472, '0042803', NULL, NULL, 253, NULL, 'Ribosome inactivating proteins (RIP)', 286357),
(477473, '0039320', NULL, NULL, 261, NULL, 'Ribosome inactivating proteins (RIP)', 286357),
(477474, '0036494', NULL, NULL, 287, NULL, 'Ribosome inactivating proteins (RIP)', 286357),
(477475, '0043991', NULL, NULL, 240, NULL, 'Ribosome inactivating proteins (RIP)', 286357),
(477476, '0049973', NULL, NULL, 263, NULL, 'Ribosome inactivating proteins (RIP)', 286357),
(477477, '0040546', NULL, NULL, 262, NULL, 'Ribosome inactivating proteins (RIP)', 286357),
(477478, '0041415', NULL, NULL, 247, NULL, 'Ribosome inactivating proteins (RIP)', 286357),
(477479, '0036290', NULL, NULL, 262, NULL, 'Ribosome inactivating proteins (RIP)', 286357),
(477480, '0041975', NULL, NULL, 248, NULL, 'Ribosome inactivating proteins (RIP)', 286357),
(477481, '0038090', NULL, NULL, 234, NULL, 'Ribosome inactivating proteins (RIP)', 286357),
(477482, '0039068', NULL, NULL, 115, NULL, 'SCP-like', 286358),
(477483, '0053772', NULL, NULL, 126, NULL, 'SCP-like', 286358),
(477484, '0054298', NULL, NULL, 80, NULL, 'SCP-like', 286358),
(477485, '0050503', NULL, NULL, 143, NULL, 'SCP-like', 286358),
(477486, '0054064', NULL, NULL, 111, NULL, 'SCP-like', 286358),
(477487, '0054075', NULL, NULL, 106, NULL, 'SCP-like', 286358),
(477488, '0042531', NULL, NULL, 113, NULL, 'SCP-like', 286358),
(477489, '0054437', NULL, NULL, 105, NULL, 'SCP-like', 286358),
(477490, '0035842', NULL, NULL, 123, NULL, 'SCP-like', 286358),
(477491, '0054550', NULL, NULL, 144, NULL, 'Sama2622-like', 286359),
(477492, '0037091', NULL, NULL, 83, NULL, 'Colicin E immunity proteins', 286360),
(477493, '0044464', NULL, NULL, 87, NULL, 'Colicin E immunity proteins', 286360),
(477494, '0038315', NULL, NULL, 85, NULL, 'Colicin E immunity proteins', 286360),
(477495, '0050612', NULL, NULL, 124, NULL, 'CRISPR-associated protein', 286361),
(477496, '0050611', NULL, NULL, 87, NULL, 'CRISPR-associated protein', 286361),
(477497, '0040443', NULL, NULL, 146, NULL, 'N-acetylmuramoyl-L-alanine amidase-like', 286362),
(477498, '0051276', NULL, NULL, 167, NULL, 'N-acetylmuramoyl-L-alanine amidase-like', 286362),
(477499, '0052586', NULL, NULL, 166, NULL, 'N-acetylmuramoyl-L-alanine amidase-like', 286362),
(477500, '0049494', NULL, NULL, 173, NULL, 'N-acetylmuramoyl-L-alanine amidase-like', 286362),
(477501, '0052587', NULL, NULL, 165, NULL, 'N-acetylmuramoyl-L-alanine amidase-like', 286362),
(477502, '0051969', NULL, NULL, 173, NULL, 'N-acetylmuramoyl-L-alanine amidase-like', 286362),
(477503, '0039348', NULL, NULL, 187, NULL, 'N-acetylmuramoyl-L-alanine amidase-like', 286362),
(477504, '0043642', NULL, NULL, 163, NULL, 'N-acetylmuramoyl-L-alanine amidase-like', 286362),
(477505, '0048569', NULL, NULL, 174, NULL, 'N-acetylmuramoyl-L-alanine amidase-like', 286362),
(477506, '0052137', NULL, NULL, 171, NULL, 'N-acetylmuramoyl-L-alanine amidase-like', 286362),
(477507, '0051259', NULL, NULL, 157, NULL, 'N-acetylmuramoyl-L-alanine amidase-like', 286362),
(477508, '0039233', NULL, NULL, 107, NULL, 'RBP11-like subunits of RNA polymerase', 286363),
(477509, '0038873', NULL, NULL, 136, NULL, 'RBP11-like subunits of RNA polymerase', 286363),
(477510, '0038895', NULL, NULL, 102, NULL, 'RBP11-like subunits of RNA polymerase', 286363),
(477511, '0035473', NULL, NULL, 106, NULL, 'RBP11-like subunits of RNA polymerase', 286363),
(477512, '0038879', NULL, NULL, 114, NULL, 'RBP11-like subunits of RNA polymerase', 286363),
(477513, '0051060', NULL, NULL, 99, NULL, 'RBP11-like subunits of RNA polymerase', 286363),
(477514, '0051589', NULL, NULL, 79, NULL, 'HP1531-like', 286364),
(477515, '0046889', NULL, NULL, 149, NULL, 'Toll/Interleukin receptor TIR domain', 286365),
(477516, '0046888', NULL, NULL, 161, NULL, 'Toll/Interleukin receptor TIR domain', 286365),
(477517, '0048373', NULL, NULL, 148, NULL, 'Cobalamin adenosyltransferase-like', 286366),
(477518, '0048403', NULL, NULL, 149, NULL, 'Cobalamin adenosyltransferase-like', 286366),
(477519, '0043378', NULL, NULL, 180, NULL, 'Cobalamin adenosyltransferase-like', 286366);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(477520, '0050177', NULL, NULL, 113, NULL, 'Bacterial exopeptidase dimerisation domain', 286367),
(477521, '0051475', NULL, NULL, 117, NULL, 'Bacterial exopeptidase dimerisation domain', 286367),
(477522, '0053285', NULL, NULL, 119, NULL, 'Bacterial exopeptidase dimerisation domain', 286367),
(477523, '0046135', NULL, NULL, 113, NULL, 'Bacterial exopeptidase dimerisation domain', 286367),
(477524, '0043110', NULL, NULL, 116, NULL, 'Bacterial exopeptidase dimerisation domain', 286367),
(477525, '0047972', NULL, NULL, 196, NULL, 'Bacterial exopeptidase dimerisation domain', 286367),
(477526, '0051390', NULL, NULL, 115, NULL, 'Bacterial exopeptidase dimerisation domain', 286367),
(477527, '0037689', NULL, NULL, 113, NULL, 'Bacterial exopeptidase dimerisation domain', 286367),
(477528, '0049594', NULL, NULL, 103, NULL, 'Head decoration protein D (gpD, major capsid protein D)', 286368),
(477529, '0035860', NULL, NULL, 95, NULL, 'Head decoration protein D (gpD, major capsid protein D)', 286368),
(477530, '0039718', NULL, NULL, 90, NULL, 'Fe,Mn superoxide dismutase (SOD), N-terminal domain', 286369),
(477531, '0038819', NULL, NULL, 90, NULL, 'Fe,Mn superoxide dismutase (SOD), N-terminal domain', 286369),
(477532, '0040859', NULL, NULL, 88, NULL, 'Fe,Mn superoxide dismutase (SOD), N-terminal domain', 286369),
(477533, '0051207', NULL, NULL, 88, NULL, 'Fe,Mn superoxide dismutase (SOD), N-terminal domain', 286369),
(477534, '0035695', NULL, NULL, 86, NULL, 'Fe,Mn superoxide dismutase (SOD), N-terminal domain', 286369),
(477535, '0038984', NULL, NULL, 84, NULL, 'Fe,Mn superoxide dismutase (SOD), N-terminal domain', 286369),
(477536, '0050424', NULL, NULL, 89, NULL, 'Fe,Mn superoxide dismutase (SOD), N-terminal domain', 286369),
(477537, '0035151', NULL, NULL, 83, NULL, 'Fe,Mn superoxide dismutase (SOD), N-terminal domain', 286369),
(477538, '0039179', NULL, NULL, 82, NULL, 'Fe,Mn superoxide dismutase (SOD), N-terminal domain', 286369),
(477539, '0040123', NULL, NULL, 84, NULL, 'Fe,Mn superoxide dismutase (SOD), N-terminal domain', 286369),
(477540, '0041013', NULL, NULL, 92, NULL, 'Fe,Mn superoxide dismutase (SOD), N-terminal domain', 286369),
(477541, '0035286', NULL, NULL, 90, NULL, 'Fe,Mn superoxide dismutase (SOD), N-terminal domain', 286369),
(477542, '0036584', NULL, NULL, 83, NULL, 'Fe,Mn superoxide dismutase (SOD), N-terminal domain', 286369),
(477543, '0041142', NULL, NULL, 88, NULL, 'Fe,Mn superoxide dismutase (SOD), N-terminal domain', 286369),
(477544, '0042185', NULL, NULL, 92, NULL, 'Fe,Mn superoxide dismutase (SOD), N-terminal domain', 286369),
(477545, '0038282', NULL, NULL, 102, NULL, 'Fe,Mn superoxide dismutase (SOD), N-terminal domain', 286369),
(477546, '0049958', NULL, NULL, 91, NULL, 'Fe,Mn superoxide dismutase (SOD), N-terminal domain', 286369),
(477547, '0036080', NULL, NULL, 89, NULL, 'Fe,Mn superoxide dismutase (SOD), N-terminal domain', 286369),
(477548, '0042884', NULL, NULL, 84, NULL, 'Fe,Mn superoxide dismutase (SOD), N-terminal domain', 286369),
(477549, '0053873', NULL, NULL, 145, NULL, 'GINS helical bundle-like', 286370),
(477550, '0053871', NULL, NULL, 105, NULL, 'GINS helical bundle-like', 286370),
(477551, '0053868', NULL, NULL, 144, NULL, 'GINS helical bundle-like', 286370),
(477552, '0053869', NULL, NULL, 112, NULL, 'GINS helical bundle-like', 286370),
(477553, '0050011', NULL, NULL, 102, NULL, 'Fe-S cluster assembly (FSCA) domain-like', 286371),
(477554, '0050965', NULL, NULL, 88, NULL, 'Fe-S cluster assembly (FSCA) domain-like', 286371),
(477555, '0052304', NULL, NULL, 91, NULL, 'Fe-S cluster assembly (FSCA) domain-like', 286371),
(477556, '0049627', NULL, NULL, 73, NULL, 'Fe-S cluster assembly (FSCA) domain-like', 286371),
(477557, '0050159', NULL, NULL, 92, NULL, 'Fe-S cluster assembly (FSCA) domain-like', 286371),
(477558, '0042669', NULL, NULL, 30, NULL, 'PetG subunit of the cytochrome b6f complex', 286372),
(477559, '0044730', NULL, NULL, 27, NULL, 'PetG subunit of the cytochrome b6f complex', 286372),
(477560, '0047860', NULL, NULL, 270, NULL, 'Nucleotidylyl transferase', 286373); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(477561, '0048275', NULL, NULL, 339, NULL, 'Nucleotidylyl transferase', 286373),
(477562, '0040507', NULL, NULL, 315, NULL, 'Nucleotidylyl transferase', 286373),
(477563, '0048452', NULL, NULL, 233, NULL, 'Nucleotidylyl transferase', 286373),
(477564, '0048474', NULL, NULL, 286, NULL, 'Nucleotidylyl transferase', 286373),
(477565, '0038847', NULL, NULL, 220, NULL, 'Nucleotidylyl transferase', 286373),
(477566, '0038403', NULL, NULL, 495, NULL, 'Nucleotidylyl transferase', 286373),
(477567, '0043348', NULL, NULL, 362, NULL, 'Nucleotidylyl transferase', 286373),
(477568, '0037452', NULL, NULL, 164, NULL, 'Nucleotidylyl transferase', 286373),
(477569, '0039032', NULL, NULL, 282, NULL, 'Nucleotidylyl transferase', 286373),
(477570, '0039570', NULL, NULL, 323, NULL, 'Nucleotidylyl transferase', 286373),
(477571, '0038263', NULL, NULL, 331, NULL, 'Nucleotidylyl transferase', 286373),
(477572, '0035691', NULL, NULL, 348, NULL, 'Nucleotidylyl transferase', 286373),
(477573, '0039171', NULL, NULL, 317, NULL, 'Nucleotidylyl transferase', 286373),
(477574, '0039071', NULL, NULL, 453, NULL, 'Nucleotidylyl transferase', 286373),
(477575, '0048216', NULL, NULL, 157, NULL, 'Nucleotidylyl transferase', 286373),
(477576, '0047487', NULL, NULL, 305, NULL, 'Nucleotidylyl transferase', 286373),
(477577, '0047586', NULL, NULL, 223, NULL, 'Nucleotidylyl transferase', 286373),
(477578, '0048499', NULL, NULL, 163, NULL, 'Nucleotidylyl transferase', 286373),
(477579, '0046259', NULL, NULL, 326, NULL, 'Nucleotidylyl transferase', 286373),
(477580, '0044335', NULL, NULL, 276, NULL, 'Nucleotidylyl transferase', 286373),
(477581, '0045888', NULL, NULL, 157, NULL, 'Nucleotidylyl transferase', 286373),
(477582, '0053312', NULL, NULL, 319, NULL, 'Nucleotidylyl transferase', 286373),
(477583, '0050045', NULL, NULL, 214, NULL, 'Nucleotidylyl transferase', 286373),
(477584, '0048046', NULL, NULL, 163, NULL, 'Nucleotidylyl transferase', 286373),
(477585, '0052384', NULL, NULL, 348, NULL, 'Nucleotidylyl transferase', 286373),
(477586, '0039908', NULL, NULL, 213, NULL, 'Nucleotidylyl transferase', 286373),
(477587, '0050866', NULL, NULL, 235, NULL, 'Nucleotidylyl transferase', 286373),
(477588, '0037568', NULL, NULL, 451, NULL, 'Nucleotidylyl transferase', 286373),
(477589, '0039322', NULL, NULL, 306, NULL, 'Nucleotidylyl transferase', 286373),
(477590, '0043997', NULL, NULL, 157, NULL, 'Nucleotidylyl transferase', 286373),
(477591, '0036094', NULL, NULL, 126, NULL, 'Nucleotidylyl transferase', 286373),
(477592, '0044869', NULL, NULL, 157, NULL, 'Nucleotidylyl transferase', 286373),
(477593, '0038030', NULL, NULL, 426, NULL, 'Nucleotidylyl transferase', 286373),
(477594, '0042947', NULL, NULL, 352, NULL, 'Nucleotidylyl transferase', 286373),
(477595, '0047412', NULL, NULL, 370, NULL, 'Nucleotidylyl transferase', 286373),
(477596, '0049118', NULL, NULL, 386, NULL, 'Nucleotidylyl transferase', 286373),
(477597, '0046940', NULL, NULL, 221, NULL, 'Nucleotidylyl transferase', 286373),
(477598, '0047114', NULL, NULL, 343, NULL, 'Nucleotidylyl transferase', 286373),
(477599, '0047774', NULL, NULL, 189, NULL, 'Nucleotidylyl transferase', 286373),
(477600, '0048269', NULL, NULL, 288, NULL, 'Nucleotidylyl transferase', 286373),
(477601, '0048544', NULL, NULL, 160, NULL, 'Nucleotidylyl transferase', 286373),
(477602, '0046569', NULL, NULL, 167, NULL, 'Nucleotidylyl transferase', 286373),
(477603, '0041784', NULL, NULL, 73, NULL, 'Mitochondrial cytochrome c oxidase subunit VIc', 286374),
(477604, '0048075', NULL, NULL, 256, NULL, 'alpha/beta-Hydrolases', 286375),
(477605, '0051001', NULL, NULL, 258, NULL, 'alpha/beta-Hydrolases', 286375),
(477606, '0048194', NULL, NULL, 281, NULL, 'alpha/beta-Hydrolases', 286375),
(477607, '0051883', NULL, NULL, 247, NULL, 'alpha/beta-Hydrolases', 286375),
(477608, '0046573', NULL, NULL, 319, NULL, 'alpha/beta-Hydrolases', 286375),
(477609, '0051009', NULL, NULL, 286, NULL, 'alpha/beta-Hydrolases', 286375),
(477610, '0039914', NULL, NULL, 534, NULL, 'alpha/beta-Hydrolases', 286375),
(477611, '0046219', NULL, NULL, 293, NULL, 'alpha/beta-Hydrolases', 286375);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(477612, '0050947', NULL, NULL, 258, NULL, 'alpha/beta-Hydrolases', 286375),
(477613, '0047940', NULL, NULL, 318, NULL, 'alpha/beta-Hydrolases', 286375),
(477614, '0048633', NULL, NULL, 258, NULL, 'alpha/beta-Hydrolases', 286375),
(477615, '0047388', NULL, NULL, 208, NULL, 'alpha/beta-Hydrolases', 286375),
(477616, '0045886', NULL, NULL, 310, NULL, 'alpha/beta-Hydrolases', 286375),
(477617, '0050682', NULL, NULL, 421, NULL, 'alpha/beta-Hydrolases', 286375),
(477618, '0054522', NULL, NULL, 362, NULL, 'alpha/beta-Hydrolases', 286375),
(477619, '0050563', NULL, NULL, 410, NULL, 'alpha/beta-Hydrolases', 286375),
(477620, '0047034', NULL, NULL, 320, NULL, 'alpha/beta-Hydrolases', 286375),
(477621, '0048003', NULL, NULL, 405, NULL, 'alpha/beta-Hydrolases', 286375),
(477622, '0046221', NULL, NULL, 319, NULL, 'alpha/beta-Hydrolases', 286375),
(477623, '0044560', NULL, NULL, 186, NULL, 'alpha/beta-Hydrolases', 286375),
(477624, '0050206', NULL, NULL, 321, NULL, 'alpha/beta-Hydrolases', 286375),
(477625, '0054009', NULL, NULL, 202, NULL, 'alpha/beta-Hydrolases', 286375),
(477626, '0054008', NULL, NULL, 265, NULL, 'alpha/beta-Hydrolases', 286375),
(477627, '0054086', NULL, NULL, 218, NULL, 'alpha/beta-Hydrolases', 286375),
(477628, '0048126', NULL, NULL, 540, NULL, 'alpha/beta-Hydrolases', 286375),
(477629, '0046502', NULL, NULL, 532, NULL, 'alpha/beta-Hydrolases', 286375),
(477630, '0047317', NULL, NULL, 179, NULL, 'alpha/beta-Hydrolases', 286375),
(477631, '0048008', NULL, NULL, 337, NULL, 'alpha/beta-Hydrolases', 286375),
(477632, '0046624', NULL, NULL, 336, NULL, 'alpha/beta-Hydrolases', 286375),
(477633, '0047683', NULL, NULL, 347, NULL, 'alpha/beta-Hydrolases', 286375),
(477634, '0047200', NULL, NULL, 371, NULL, 'alpha/beta-Hydrolases', 286375),
(477635, '0053045', NULL, NULL, 260, NULL, 'alpha/beta-Hydrolases', 286375),
(477636, '0046077', NULL, NULL, 281, NULL, 'alpha/beta-Hydrolases', 286375),
(477637, '0053845', NULL, NULL, 122, NULL, 'alpha/beta-Hydrolases', 286375),
(477638, '0054656', NULL, NULL, 203, NULL, 'alpha/beta-Hydrolases', 286375),
(477639, '0045824', NULL, NULL, 218, NULL, 'alpha/beta-Hydrolases', 286375),
(477640, '0046639', NULL, NULL, 308, NULL, 'alpha/beta-Hydrolases', 286375),
(477641, '0054807', NULL, NULL, 209, NULL, 'alpha/beta-Hydrolases', 286375),
(477642, '0054493', NULL, NULL, 261, NULL, 'alpha/beta-Hydrolases', 286375),
(477643, '0047600', NULL, NULL, 255, NULL, 'alpha/beta-Hydrolases', 286375),
(477644, '0047444', NULL, NULL, 271, NULL, 'alpha/beta-Hydrolases', 286375),
(477645, '0042551', NULL, NULL, 297, NULL, 'alpha/beta-Hydrolases', 286375),
(477646, '0048935', NULL, NULL, 483, NULL, 'alpha/beta-Hydrolases', 286375),
(477647, '0047601', NULL, NULL, 311, NULL, 'alpha/beta-Hydrolases', 286375),
(477648, '0049591', NULL, NULL, 317, NULL, 'alpha/beta-Hydrolases', 286375),
(477649, '0049631', NULL, NULL, 302, NULL, 'alpha/beta-Hydrolases', 286375),
(477650, '0049630', NULL, NULL, 544, NULL, 'alpha/beta-Hydrolases', 286375),
(477651, '0047451', NULL, NULL, 452, NULL, 'alpha/beta-Hydrolases', 286375),
(477652, '0041193', NULL, NULL, 256, NULL, 'alpha/beta-Hydrolases', 286375),
(477653, '0050226', NULL, NULL, 263, NULL, 'alpha/beta-Hydrolases', 286375),
(477654, '0053336', NULL, NULL, 265, NULL, 'alpha/beta-Hydrolases', 286375),
(477655, '0039602', NULL, NULL, 358, NULL, 'alpha/beta-Hydrolases', 286375),
(477656, '0046928', NULL, NULL, 207, NULL, 'alpha/beta-Hydrolases', 286375),
(477657, '0053729', NULL, NULL, 357, NULL, 'alpha/beta-Hydrolases', 286375),
(477658, '0037021', NULL, NULL, 279, NULL, 'alpha/beta-Hydrolases', 286375),
(477659, '0047974', NULL, NULL, 265, NULL, 'alpha/beta-Hydrolases', 286375),
(477660, '0046126', NULL, NULL, 197, NULL, 'alpha/beta-Hydrolases', 286375),
(477661, '0046004', NULL, NULL, 277, NULL, 'alpha/beta-Hydrolases', 286375),
(477662, '0048945', NULL, NULL, 280, NULL, 'alpha/beta-Hydrolases', 286375),
(477663, '0048825', NULL, NULL, 299, NULL, 'alpha/beta-Hydrolases', 286375),
(477664, '0049638', NULL, NULL, 269, NULL, 'alpha/beta-Hydrolases', 286375);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(477665, '0049637', NULL, NULL, 271, NULL, 'alpha/beta-Hydrolases', 286375),
(477666, '0049087', NULL, NULL, 242, NULL, 'alpha/beta-Hydrolases', 286375),
(477667, '0054676', NULL, NULL, 283, NULL, 'alpha/beta-Hydrolases', 286375),
(477668, '0050112', NULL, NULL, 271, NULL, 'alpha/beta-Hydrolases', 286375),
(477669, '0046012', NULL, NULL, 338, NULL, 'alpha/beta-Hydrolases', 286375),
(477670, '0047220', NULL, NULL, 337, NULL, 'alpha/beta-Hydrolases', 286375),
(477671, '0049001', NULL, NULL, 394, NULL, 'alpha/beta-Hydrolases', 286375),
(477672, '0036443', NULL, NULL, 233, NULL, 'alpha/beta-Hydrolases', 286375),
(477673, '0041081', NULL, NULL, 290, NULL, 'alpha/beta-Hydrolases', 286375),
(477674, '0053348', NULL, NULL, 319, NULL, 'alpha/beta-Hydrolases', 286375),
(477675, '0038343', NULL, NULL, 534, NULL, 'alpha/beta-Hydrolases', 286375),
(477676, '0049928', NULL, NULL, 517, NULL, 'alpha/beta-Hydrolases', 286375),
(477677, '0037013', NULL, NULL, 293, NULL, 'alpha/beta-Hydrolases', 286375),
(477678, '0047627', NULL, NULL, 230, NULL, 'alpha/beta-Hydrolases', 286375),
(477679, '0042339', NULL, NULL, 268, NULL, 'alpha/beta-Hydrolases', 286375),
(477680, '0054709', NULL, NULL, 376, NULL, 'alpha/beta-Hydrolases', 286375),
(477681, '0046410', NULL, NULL, 262, NULL, 'alpha/beta-Hydrolases', 286375),
(477682, '0049128', NULL, NULL, 267, NULL, 'alpha/beta-Hydrolases', 286375),
(477683, '0049887', NULL, NULL, 238, NULL, 'alpha/beta-Hydrolases', 286375),
(477684, '0046412', NULL, NULL, 571, NULL, 'alpha/beta-Hydrolases', 286375),
(477685, '0048675', NULL, NULL, 526, NULL, 'alpha/beta-Hydrolases', 286375),
(477686, '0049005', NULL, NULL, 207, NULL, 'alpha/beta-Hydrolases', 286375),
(477687, '0041128', NULL, NULL, 532, NULL, 'alpha/beta-Hydrolases', 286375),
(477688, '0047592', NULL, NULL, 388, NULL, 'alpha/beta-Hydrolases', 286375),
(477689, '0047194', NULL, NULL, 279, NULL, 'alpha/beta-Hydrolases', 286375),
(477690, '0047078', NULL, NULL, 426, NULL, 'alpha/beta-Hydrolases', 286375),
(477691, '0054207', NULL, NULL, 360, NULL, 'alpha/beta-Hydrolases', 286375),
(477692, '0049094', NULL, NULL, 264, NULL, 'alpha/beta-Hydrolases', 286375),
(477693, '0050245', NULL, NULL, 322, NULL, 'alpha/beta-Hydrolases', 286375),
(477694, '0045736', NULL, NULL, 275, NULL, 'alpha/beta-Hydrolases', 286375),
(477695, '0040046', NULL, NULL, 267, NULL, 'alpha/beta-Hydrolases', 286375),
(477696, '0046388', NULL, NULL, 280, NULL, 'alpha/beta-Hydrolases', 286375),
(477697, '0045851', NULL, NULL, 313, NULL, 'alpha/beta-Hydrolases', 286375),
(477698, '0047879', NULL, NULL, 388, NULL, 'alpha/beta-Hydrolases', 286375),
(477699, '0048965', NULL, NULL, 256, NULL, 'alpha/beta-Hydrolases', 286375),
(477700, '0048207', NULL, NULL, 381, NULL, 'alpha/beta-Hydrolases', 286375),
(477701, '0048053', NULL, NULL, 317, NULL, 'alpha/beta-Hydrolases', 286375),
(477702, '0050010', NULL, NULL, 261, NULL, 'alpha/beta-Hydrolases', 286375),
(477703, '0049383', NULL, NULL, 288, NULL, 'alpha/beta-Hydrolases', 286375),
(477704, '0046670', NULL, NULL, 284, NULL, 'alpha/beta-Hydrolases', 286375),
(477705, '0046793', NULL, NULL, 229, NULL, 'alpha/beta-Hydrolases', 286375),
(477706, '0045186', NULL, NULL, 579, NULL, 'alpha/beta-Hydrolases', 286375),
(477707, '0037239', NULL, NULL, 285, NULL, 'alpha/beta-Hydrolases', 286375),
(477708, '0053804', NULL, NULL, 318, NULL, 'alpha/beta-Hydrolases', 286375),
(477709, '0053925', NULL, NULL, 218, NULL, 'alpha/beta-Hydrolases', 286375),
(477710, '0043326', NULL, NULL, 330, NULL, 'alpha/beta-Hydrolases', 286375),
(477711, '0046718', NULL, NULL, 533, NULL, 'alpha/beta-Hydrolases', 286375),
(477712, '0047764', NULL, NULL, 377, NULL, 'alpha/beta-Hydrolases', 286375),
(477713, '0045741', NULL, NULL, 274, NULL, 'alpha/beta-Hydrolases', 286375),
(477714, '0047003', NULL, NULL, 283, NULL, 'alpha/beta-Hydrolases', 286375),
(477715, '0045742', NULL, NULL, 273, NULL, 'alpha/beta-Hydrolases', 286375),
(477716, '0045984', NULL, NULL, 291, NULL, 'alpha/beta-Hydrolases', 286375),
(477717, '0048460', NULL, NULL, 385, NULL, 'alpha/beta-Hydrolases', 286375);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(477718, '0049037', NULL, NULL, 314, NULL, 'alpha/beta-Hydrolases', 286375),
(477719, '0048982', NULL, NULL, 318, NULL, 'alpha/beta-Hydrolases', 286375),
(477720, '0047495', NULL, NULL, 268, NULL, 'alpha/beta-Hydrolases', 286375),
(477721, '0039526', NULL, NULL, 260, NULL, 'alpha/beta-Hydrolases', 286375),
(477722, '0046729', NULL, NULL, 539, NULL, 'alpha/beta-Hydrolases', 286375),
(477723, '0046169', NULL, NULL, 534, NULL, 'alpha/beta-Hydrolases', 286375),
(477724, '0046202', NULL, NULL, 534, NULL, 'alpha/beta-Hydrolases', 286375),
(477725, '0045756', NULL, NULL, 483, NULL, 'alpha/beta-Hydrolases', 286375),
(477726, '0051946', NULL, NULL, 261, NULL, 'EAL domain-like', 286376),
(477727, '0045846', NULL, NULL, 36, NULL, 'Cellulose-binding domain', 286377),
(477728, '0045845', NULL, NULL, 36, NULL, 'Cellulose-binding domain', 286377),
(477729, '0045847', NULL, NULL, 36, NULL, 'Cellulose-binding domain', 286377),
(477730, '0053554', NULL, NULL, 81, NULL, 'MPN010-like', 286378),
(477731, '0035882', NULL, NULL, 79, NULL, 'F1F0 ATP synthase subunit C', 286379),
(477732, '0052915', NULL, NULL, 134, NULL, 'Phage tail protein-like', 286380),
(477733, '0051468', NULL, NULL, 129, NULL, 'Phage tail protein-like', 286380),
(477734, '0050019', NULL, NULL, 299, NULL, 'Autotransporter', 286381),
(477735, '0049184', NULL, NULL, 148, NULL, 'Plant invertase/pectin methylesterase inhibitor', 286382),
(477736, '0050874', NULL, NULL, 149, NULL, 'Plant invertase/pectin methylesterase inhibitor', 286382),
(477737, '0053541', NULL, NULL, 74, NULL, 'Intermediate filament protein, coiled coil region', 286383),
(477738, '0053426', NULL, NULL, 39, NULL, 'Intermediate filament protein, coiled coil region', 286383),
(477739, '0053424', NULL, NULL, 79, NULL, 'Intermediate filament protein, coiled coil region', 286383),
(477740, '0053425', NULL, NULL, 55, NULL, 'Intermediate filament protein, coiled coil region', 286383),
(477741, '0054551', NULL, NULL, 128, NULL, '6-phosphogluconate dehydrogenase C-terminal domain-like', 286384),
(477742, '0054098', NULL, NULL, 103, NULL, '6-phosphogluconate dehydrogenase C-terminal domain-like', 286384),
(477743, '0052836', NULL, NULL, 110, NULL, '6-phosphogluconate dehydrogenase C-terminal domain-like', 286384),
(477744, '0037218', NULL, NULL, 160, NULL, '6-phosphogluconate dehydrogenase C-terminal domain-like', 286384),
(477745, '0037318', NULL, NULL, 99, NULL, '6-phosphogluconate dehydrogenase C-terminal domain-like', 286384),
(477746, '0036487', NULL, NULL, 98, NULL, '6-phosphogluconate dehydrogenase C-terminal domain-like', 286384),
(477747, '0054910', NULL, NULL, 134, NULL, '6-phosphogluconate dehydrogenase C-terminal domain-like', 286384),
(477748, '0035534', NULL, NULL, 172, NULL, '6-phosphogluconate dehydrogenase C-terminal domain-like', 286384),
(477749, '0040234', NULL, NULL, 124, NULL, '6-phosphogluconate dehydrogenase C-terminal domain-like', 286384),
(477750, '0049729', NULL, NULL, 155, NULL, '6-phosphogluconate dehydrogenase C-terminal domain-like', 286384),
(477751, '0044957', NULL, NULL, 125, NULL, '6-phosphogluconate dehydrogenase C-terminal domain-like', 286384),
(477752, '0044958', NULL, NULL, 95, NULL, '6-phosphogluconate dehydrogenase C-terminal domain-like', 286384),
(477753, '0040515', NULL, NULL, 206, NULL, '6-phosphogluconate dehydrogenase C-terminal domain-like', 286384),
(477754, '0048756', NULL, NULL, 297, NULL, '6-phosphogluconate dehydrogenase C-terminal domain-like', 286384),
(477755, '0045524', NULL, NULL, 99, NULL, '6-phosphogluconate dehydrogenase C-terminal domain-like', 286384),
(477756, '0052564', NULL, NULL, 114, NULL, '6-phosphogluconate dehydrogenase C-terminal domain-like', 286384),
(477757, '0051872', NULL, NULL, 102, NULL, '6-phosphogluconate dehydrogenase C-terminal domain-like', 286384),
(477758, '0053659', NULL, NULL, 111, NULL, '6-phosphogluconate dehydrogenase C-terminal domain-like', 286384),
(477759, '0052328', NULL, NULL, 132, NULL, '6-phosphogluconate dehydrogenase C-terminal domain-like', 286384),
(477760, '0050268', NULL, NULL, 133, NULL, '6-phosphogluconate dehydrogenase C-terminal domain-like', 286384); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(477761, '0051796', NULL, NULL, 104, NULL, '6-phosphogluconate dehydrogenase C-terminal domain-like', 286384),
(477762, '0038855', NULL, NULL, 112, NULL, '6-phosphogluconate dehydrogenase C-terminal domain-like', 286384),
(477763, '0042865', NULL, NULL, 288, NULL, '6-phosphogluconate dehydrogenase C-terminal domain-like', 286384),
(477764, '0048408', NULL, NULL, 145, NULL, '6-phosphogluconate dehydrogenase C-terminal domain-like', 286384),
(477765, '0042306', NULL, NULL, 300, NULL, '6-phosphogluconate dehydrogenase C-terminal domain-like', 286384),
(477766, '0041099', NULL, NULL, 98, NULL, '6-phosphogluconate dehydrogenase C-terminal domain-like', 286384),
(477767, '0037222', NULL, NULL, 106, NULL, 'Frataxin/Nqo15-like', 286385),
(477768, '0037054', NULL, NULL, 119, NULL, 'Frataxin/Nqo15-like', 286385),
(477769, '0052857', NULL, NULL, 123, NULL, 'Frataxin/Nqo15-like', 286385),
(477770, '0052778', NULL, NULL, 127, NULL, 'Frataxin/Nqo15-like', 286385),
(477771, '0042492', NULL, NULL, 301, NULL, 'Leukocidin-like', 286386),
(477772, '0043890', NULL, NULL, 282, NULL, 'Leukocidin-like', 286386),
(477773, '0044530', NULL, NULL, 184, NULL, 'Leukocidin-like', 286386),
(477774, '0045641', NULL, NULL, 293, NULL, 'Leukocidin-like', 286386),
(477775, '0045534', NULL, NULL, 299, NULL, 'Leukocidin-like', 286386),
(477776, '0039497', NULL, NULL, 97, NULL, 'SirA-like', 286387),
(477777, '0039494', NULL, NULL, 98, NULL, 'SirA-like', 286387),
(477778, '0036351', NULL, NULL, 81, NULL, 'SirA-like', 286387),
(477779, '0042226', NULL, NULL, 78, NULL, 'SirA-like', 286387),
(477780, '0036840', NULL, NULL, 46, NULL, 'Cellulose docking domain, dockering', 286388),
(477781, '0053695', NULL, NULL, 387, NULL, 'Sialidases', 286389),
(477782, '0046491', NULL, NULL, 446, NULL, 'Sialidases', 286389),
(477783, '0053333', NULL, NULL, 379, NULL, 'Sialidases', 286389),
(477784, '0049431', NULL, NULL, 374, NULL, 'Sialidases', 286389),
(477785, '0050026', NULL, NULL, 516, NULL, 'Sialidases', 286389),
(477786, '0050334', NULL, NULL, 365, NULL, 'Sialidases', 286389),
(477787, '0050039', NULL, NULL, 431, NULL, 'Sialidases', 286389),
(477788, '0050402', NULL, NULL, 356, NULL, 'Sialidases', 286389),
(477789, '0053303', NULL, NULL, 483, NULL, 'Sialidases', 286389),
(477790, '0041541', NULL, NULL, 390, NULL, 'Sialidases', 286389),
(477791, '0051948', NULL, NULL, 388, NULL, 'Sialidases', 286389),
(477792, '0041196', NULL, NULL, 406, NULL, 'Sialidases', 286389),
(477793, '0039096', NULL, NULL, 390, NULL, 'Sialidases', 286389),
(477794, '0048217', NULL, NULL, 398, NULL, 'Sialidases', 286389),
(477795, '0046723', NULL, NULL, 388, NULL, 'Sialidases', 286389),
(477796, '0054028', NULL, NULL, 42, NULL, 'YnzC-like', 286390),
(477797, '0047350', NULL, NULL, 359, NULL, 'Pectin lyase-like', 286391),
(477798, '0047680', NULL, NULL, 361, NULL, 'Pectin lyase-like', 286391),
(477799, '0036209', NULL, NULL, 335, NULL, 'Pectin lyase-like', 286391),
(477800, '0046293', NULL, NULL, 481, NULL, 'Pectin lyase-like', 286391),
(477801, '0047331', NULL, NULL, 339, NULL, 'Pectin lyase-like', 286391),
(477802, '0048563', NULL, NULL, 373, NULL, 'Pectin lyase-like', 286391),
(477803, '0048970', NULL, NULL, 342, NULL, 'Pectin lyase-like', 286391),
(477804, '0047750', NULL, NULL, 333, NULL, 'Pectin lyase-like', 286391),
(477805, '0047142', NULL, NULL, 464, NULL, 'Pectin lyase-like', 286391),
(477806, '0047186', NULL, NULL, 349, NULL, 'Pectin lyase-like', 286391),
(477807, '0049244', NULL, NULL, 400, NULL, 'Pectin lyase-like', 286391),
(477808, '0049255', NULL, NULL, 297, NULL, 'Pectin lyase-like', 286391),
(477809, '0038225', NULL, NULL, 319, NULL, 'Pectin lyase-like', 286391),
(477810, '0036933', NULL, NULL, 197, NULL, 'Pectin lyase-like', 286391),
(477811, '0041388', NULL, NULL, 336, NULL, 'Pectin lyase-like', 286391),
(477812, '0048925', NULL, NULL, 359, NULL, 'Pectin lyase-like', 286391),
(477813, '0036321', NULL, NULL, 539, NULL, 'Pectin lyase-like', 286391),
(477814, '0042926', NULL, NULL, 554, NULL, 'Pectin lyase-like', 286391),
(477815, '0048840', NULL, NULL, 346, NULL, 'Pectin lyase-like', 286391); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(477816, '0049214', NULL, NULL, 422, NULL, 'Pectin lyase-like', 286391),
(477817, '0045985', NULL, NULL, 399, NULL, 'Pectin lyase-like', 286391),
(477818, '0045962', NULL, NULL, 376, NULL, 'Pectin lyase-like', 286391),
(477819, '0048737', NULL, NULL, 355, NULL, 'Pectin lyase-like', 286391),
(477820, '0048515', NULL, NULL, 353, NULL, 'Pectin lyase-like', 286391),
(477821, '0048296', NULL, NULL, 67, NULL, 'Bifunctional inhibitor/lipid-transfer protein/seed storage 2S albumin', 286392),
(477822, '0048161', NULL, NULL, 91, NULL, 'Bifunctional inhibitor/lipid-transfer protein/seed storage 2S albumin', 286392),
(477823, '0038707', NULL, NULL, 120, NULL, 'Bifunctional inhibitor/lipid-transfer protein/seed storage 2S albumin', 286392),
(477824, '0035743', NULL, NULL, 90, NULL, 'Bifunctional inhibitor/lipid-transfer protein/seed storage 2S albumin', 286392),
(477825, '0042457', NULL, NULL, 125, NULL, 'Bifunctional inhibitor/lipid-transfer protein/seed storage 2S albumin', 286392),
(477826, '0046805', NULL, NULL, 93, NULL, 'Bifunctional inhibitor/lipid-transfer protein/seed storage 2S albumin', 286392),
(477827, '0043504', NULL, NULL, 103, NULL, 'Bifunctional inhibitor/lipid-transfer protein/seed storage 2S albumin', 286392),
(477828, '0035496', NULL, NULL, 116, NULL, 'Bifunctional inhibitor/lipid-transfer protein/seed storage 2S albumin', 286392),
(477829, '0040393', NULL, NULL, 69, NULL, 'Bifunctional inhibitor/lipid-transfer protein/seed storage 2S albumin', 286392),
(477830, '0047269', NULL, NULL, 75, NULL, 'Bifunctional inhibitor/lipid-transfer protein/seed storage 2S albumin', 286392),
(477831, '0042396', NULL, NULL, 107, NULL, 'Bifunctional inhibitor/lipid-transfer protein/seed storage 2S albumin', 286392),
(477832, '0044059', NULL, NULL, 117, NULL, 'Bifunctional inhibitor/lipid-transfer protein/seed storage 2S albumin', 286392),
(477833, '0043446', NULL, NULL, 91, NULL, 'Bifunctional inhibitor/lipid-transfer protein/seed storage 2S albumin', 286392),
(477834, '0049572', NULL, NULL, 73, NULL, 'EF-G C-terminal domain-like', 286393),
(477835, '0050451', NULL, NULL, 96, NULL, 'EF-G C-terminal domain-like', 286393),
(477836, '0046824', NULL, NULL, 79, NULL, 'EF-G C-terminal domain-like', 286393),
(477837, '0048719', NULL, NULL, 73, NULL, 'EF-G C-terminal domain-like', 286393),
(477838, '0052056', NULL, NULL, 75, NULL, 'EF-G C-terminal domain-like', 286393),
(477839, '0050452', NULL, NULL, 77, NULL, 'EF-G C-terminal domain-like', 286393),
(477840, '0052057', NULL, NULL, 89, NULL, 'EF-G C-terminal domain-like', 286393),
(477841, '0048253', NULL, NULL, 79, NULL, 'EF-G C-terminal domain-like', 286393),
(477842, '0048254', NULL, NULL, 117, NULL, 'EF-G C-terminal domain-like', 286393),
(477843, '0050192', NULL, NULL, 71, NULL, 'EF-G C-terminal domain-like', 286393),
(477844, '0052324', NULL, NULL, 67, NULL, 'EF-G C-terminal domain-like', 286393),
(477845, '0047827', NULL, NULL, 94, NULL, 'eIF2alpha middle domain-like', 286394),
(477846, '0051770', NULL, NULL, 91, NULL, 'eIF2alpha middle domain-like', 286394),
(477847, '0048886', NULL, NULL, 87, NULL, 'eIF2alpha middle domain-like', 286394),
(477848, '0046447', NULL, NULL, 83, NULL, 'Polynucleotide phosphorylase/guanosine pentaphosphate synthase (PNPase/GPSI), domain 3', 286395),
(477849, '0050564', NULL, NULL, 104, NULL, 'Polynucleotide phosphorylase/guanosine pentaphosphate synthase (PNPase/GPSI), domain 3', 286395),
(477850, '0054234', NULL, NULL, 130, NULL, 'YehR-like', 286396),
(477851, '0052147', NULL, NULL, 99, NULL, 'Agglutinin HPA-like', 286397),
(477852, '0053712', NULL, NULL, 35, NULL, 'Cytochrome b559 subunits', 286398),
(477853, '0053711', NULL, NULL, 82, NULL, 'Cytochrome b559 subunits', 286398),
(477854, '0040578', NULL, NULL, 101, NULL, 'C-terminal domain of mollusc hemocyanin', 286399),
(477855, '0039735', NULL, NULL, 101, NULL, 'C-terminal domain of mollusc hemocyanin', 286399),
(477856, '0047460', NULL, NULL, 555, NULL, 'Cobalamin (vitamin B12)-dependent enzymes', 286400),
(477857, '0046111', NULL, NULL, 483, NULL, 'Cobalamin (vitamin B12)-dependent enzymes', 286400);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(477858, '0053373', NULL, NULL, 460, NULL, 'Cobalamin (vitamin B12)-dependent enzymes', 286400),
(477859, '0045650', NULL, NULL, 557, NULL, 'Cobalamin (vitamin B12)-dependent enzymes', 286400),
(477860, '0046533', NULL, NULL, 551, NULL, 'Cobalamin (vitamin B12)-dependent enzymes', 286400),
(477861, '0051083', NULL, NULL, 516, NULL, 'Cobalamin (vitamin B12)-dependent enzymes', 286400),
(477862, '0041844', NULL, NULL, 199, NULL, 'Dextranase, N-terminal domain', 286401),
(477863, '0052256', NULL, NULL, 126, NULL, 'WGR domain-like', 286402),
(477864, '0039665', NULL, NULL, 145, NULL, 'Succinate dehydrogenase/fumarate reductase flavoprotein, catalytic domain', 286403),
(477865, '0042899', NULL, NULL, 146, NULL, 'Succinate dehydrogenase/fumarate reductase flavoprotein, catalytic domain', 286403),
(477866, '0041342', NULL, NULL, 120, NULL, 'Succinate dehydrogenase/fumarate reductase flavoprotein, catalytic domain', 286403),
(477867, '0035990', NULL, NULL, 116, NULL, 'Succinate dehydrogenase/fumarate reductase flavoprotein, catalytic domain', 286403),
(477868, '0036265', NULL, NULL, 146, NULL, 'Succinate dehydrogenase/fumarate reductase flavoprotein, catalytic domain', 286403),
(477869, '0052033', NULL, NULL, 121, NULL, 'Succinate dehydrogenase/fumarate reductase flavoprotein, catalytic domain', 286403),
(477870, '0040050', NULL, NULL, 132, NULL, 'Succinate dehydrogenase/fumarate reductase flavoprotein, catalytic domain', 286403),
(477871, '0036733', NULL, NULL, 146, NULL, 'Succinate dehydrogenase/fumarate reductase flavoprotein, catalytic domain', 286403),
(477872, '0040071', NULL, NULL, 60, NULL, 'Necrosis inducing protein 1, NIP1', 286404),
(477873, '0052971', NULL, NULL, 52, NULL, 'Zn-binding ribosomal proteins', 286405),
(477874, '0053069', NULL, NULL, 56, NULL, 'Zn-binding ribosomal proteins', 286405),
(477875, '0054795', NULL, NULL, 58, NULL, 'Zn-binding ribosomal proteins', 286405),
(477876, '0049333', NULL, NULL, 73, NULL, 'Zn-binding ribosomal proteins', 286405),
(477877, '0054253', NULL, NULL, 55, NULL, 'Zn-binding ribosomal proteins', 286405),
(477878, '0053725', NULL, NULL, 56, NULL, 'Zn-binding ribosomal proteins', 286405),
(477879, '0037554', NULL, NULL, 92, NULL, 'Zn-binding ribosomal proteins', 286405),
(477880, '0049062', NULL, NULL, 58, NULL, 'Zn-binding ribosomal proteins', 286405),
(477881, '0054768', NULL, NULL, 53, NULL, 'Zn-binding ribosomal proteins', 286405),
(477882, '0046773', NULL, NULL, 73, NULL, 'Zn-binding ribosomal proteins', 286405),
(477883, '0054173', NULL, NULL, 45, NULL, 'Zn-binding ribosomal proteins', 286405),
(477884, '0046774', NULL, NULL, 56, NULL, 'Zn-binding ribosomal proteins', 286405),
(477885, '0047598', NULL, NULL, 73, NULL, 'Zn-binding ribosomal proteins', 286405),
(477886, '0054172', NULL, NULL, 59, NULL, 'Zn-binding ribosomal proteins', 286405),
(477887, '0041713', NULL, NULL, 124, NULL, 'Supernatant protein factor (SPF), C-terminal domain', 286406),
(477888, '0035588', NULL, NULL, 760, NULL, 'Type II DNA topoisomerase', 286407),
(477889, '0034983', NULL, NULL, 477, NULL, 'Type II DNA topoisomerase', 286407),
(477890, '0050817', NULL, NULL, 80, NULL, 'ISY1 domain-like', 286408),
(477891, '0038492', NULL, NULL, 115, NULL, 'PTS-regulatory domain, PRD', 286409),
(477892, '0038493', NULL, NULL, 107, NULL, 'PTS-regulatory domain, PRD', 286409),
(477893, '0054115', NULL, NULL, 39, NULL, 'Sec-C motif', 286410),
(477894, '0054116', NULL, NULL, 25, NULL, 'Sec-C motif', 286410),
(477895, '0042099', NULL, NULL, 24, NULL, 'Sec-C motif', 286410),
(477896, '0049654', NULL, NULL, 22, NULL, 'Sec-C motif', 286410),
(477897, '0043786', NULL, NULL, 22, NULL, 'Sec-C motif', 286410),
(477898, '0053832', NULL, NULL, 70, NULL, 'YopT-like', 286411),
(477899, '0038147', NULL, NULL, 32, NULL, 'PMP inhibitors', 286412),
(477900, '0040110', NULL, NULL, 35, NULL, 'PMP inhibitors', 286412),
(477901, '0040075', NULL, NULL, 35, NULL, 'PMP inhibitors', 286412),
(477902, '0040106', NULL, NULL, 35, NULL, 'PMP inhibitors', 286412),
(477903, '0047007', NULL, NULL, 34, NULL, 'PMP inhibitors', 286412);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(477904, '0044997', NULL, NULL, 35, NULL, 'PMP inhibitors', 286412),
(477905, '0046429', NULL, NULL, 455, NULL, 'Group I dsDNA viruses', 286413),
(477906, '0043624', NULL, NULL, 366, NULL, 'Group I dsDNA viruses', 286413),
(477907, '0043775', NULL, NULL, 348, NULL, 'Group I dsDNA viruses', 286413),
(477908, '0048163', NULL, NULL, 525, NULL, '"Helical backbone" metal receptor', 286414),
(477909, '0036959', NULL, NULL, 262, NULL, '"Helical backbone" metal receptor', 286414),
(477910, '0048164', NULL, NULL, 457, NULL, '"Helical backbone" metal receptor', 286414),
(477911, '0044070', NULL, NULL, 277, NULL, '"Helical backbone" metal receptor', 286414),
(477912, '0051121', NULL, NULL, 279, NULL, '"Helical backbone" metal receptor', 286414),
(477913, '0048271', NULL, NULL, 245, NULL, '"Helical backbone" metal receptor', 286414),
(477914, '0053187', NULL, NULL, 522, NULL, '"Helical backbone" metal receptor', 286414),
(477915, '0053186', NULL, NULL, 476, NULL, '"Helical backbone" metal receptor', 286414),
(477916, '0054509', NULL, NULL, 277, NULL, '"Helical backbone" metal receptor', 286414),
(477917, '0042458', NULL, NULL, 286, NULL, '"Helical backbone" metal receptor', 286414),
(477918, '0052519', NULL, NULL, 334, NULL, '"Helical backbone" metal receptor', 286414),
(477919, '0052172', NULL, NULL, 287, NULL, '"Helical backbone" metal receptor', 286414),
(477920, '0048954', NULL, NULL, 478, NULL, '"Helical backbone" metal receptor', 286414),
(477921, '0042774', NULL, NULL, 519, NULL, '"Helical backbone" metal receptor', 286414),
(477922, '0042423', NULL, NULL, 289, NULL, '"Helical backbone" metal receptor', 286414),
(477923, '0054897', NULL, NULL, 264, NULL, 'Acetoacetate decarboxylase-like', 286415),
(477924, '0054878', NULL, NULL, 250, NULL, 'Acetoacetate decarboxylase-like', 286415),
(477925, '0051940', NULL, NULL, 414, NULL, 'GckA/TtuD-like', 286416),
(477926, '0039249', NULL, NULL, 223, NULL, 'Multidrug efflux transporter AcrB transmembrane domain', 286417),
(477927, '0039248', NULL, NULL, 200, NULL, 'Multidrug efflux transporter AcrB transmembrane domain', 286417),
(477928, '0051465', NULL, NULL, 77, NULL, 'SPy1572-like', 286418),
(477929, '0051057', NULL, NULL, 59, NULL, 'RecA protein, C-terminal domain', 286419),
(477930, '0049854', NULL, NULL, 60, NULL, 'RecA protein, C-terminal domain', 286419),
(477931, '0046896', NULL, NULL, 60, NULL, 'RecA protein, C-terminal domain', 286419),
(477932, '0049826', NULL, NULL, 60, NULL, 'RecA protein, C-terminal domain', 286419),
(477933, '0053841', NULL, NULL, 64, NULL, 'YqaI-like', 286420),
(477934, '0042161', NULL, NULL, 110, NULL, 'SRCR-like', 286421),
(477935, '0035772', NULL, NULL, 116, NULL, 'SRCR-like', 286421),
(477936, '0047184', NULL, NULL, 85, NULL, '4Fe-4S ferredoxins', 286422),
(477937, '0046170', NULL, NULL, 55, NULL, '4Fe-4S ferredoxins', 286422),
(477938, '0052774', NULL, NULL, 151, NULL, '4Fe-4S ferredoxins', 286422),
(477939, '0054698', NULL, NULL, 69, NULL, '4Fe-4S ferredoxins', 286422),
(477940, '0054874', NULL, NULL, 65, NULL, '4Fe-4S ferredoxins', 286422),
(477941, '0053368', NULL, NULL, 106, NULL, '4Fe-4S ferredoxins', 286422),
(477942, '0054695', NULL, NULL, 81, NULL, '4Fe-4S ferredoxins', 286422),
(477943, '0054871', NULL, NULL, 66, NULL, '4Fe-4S ferredoxins', 286422),
(477944, '0036609', NULL, NULL, 55, NULL, '4Fe-4S ferredoxins', 286422),
(477945, '0052658', NULL, NULL, 55, NULL, '4Fe-4S ferredoxins', 286422),
(477946, '0052779', NULL, NULL, 154, NULL, '4Fe-4S ferredoxins', 286422),
(477947, '0035614', NULL, NULL, 80, NULL, '4Fe-4S ferredoxins', 286422),
(477948, '0037513', NULL, NULL, 83, NULL, '4Fe-4S ferredoxins', 286422),
(477949, '0046879', NULL, NULL, 64, NULL, '4Fe-4S ferredoxins', 286422),
(477950, '0039453', NULL, NULL, 80, NULL, '4Fe-4S ferredoxins', 286422),
(477951, '0040210', NULL, NULL, 244, NULL, '4Fe-4S ferredoxins', 286422),
(477952, '0044815', NULL, NULL, 59, NULL, '4Fe-4S ferredoxins', 286422),
(477953, '0052928', NULL, NULL, 102, NULL, '4Fe-4S ferredoxins', 286422),
(477954, '0038361', NULL, NULL, 214, NULL, '4Fe-4S ferredoxins', 286422);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(477955, '0047149', NULL, NULL, 77, NULL, '4Fe-4S ferredoxins', 286422),
(477956, '0046874', NULL, NULL, 58, NULL, '4Fe-4S ferredoxins', 286422),
(477957, '0044015', NULL, NULL, 195, NULL, '4Fe-4S ferredoxins', 286422),
(477958, '0039666', NULL, NULL, 149, NULL, '4Fe-4S ferredoxins', 286422),
(477959, '0035446', NULL, NULL, 77, NULL, '4Fe-4S ferredoxins', 286422),
(477960, '0045859', NULL, NULL, 117, NULL, '4Fe-4S ferredoxins', 286422),
(477961, '0046749', NULL, NULL, 55, NULL, '4Fe-4S ferredoxins', 286422),
(477962, '0038470', NULL, NULL, 173, NULL, '4Fe-4S ferredoxins', 286422),
(477963, '0039142', NULL, NULL, 81, NULL, '4Fe-4S ferredoxins', 286422),
(477964, '0045037', NULL, NULL, 103, NULL, '4Fe-4S ferredoxins', 286422),
(477965, '0042562', NULL, NULL, 509, NULL, '4Fe-4S ferredoxins', 286422),
(477966, '0049159', NULL, NULL, 80, NULL, '4Fe-4S ferredoxins', 286422),
(477967, '0043631', NULL, NULL, 66, NULL, '4Fe-4S ferredoxins', 286422),
(477968, '0051685', NULL, NULL, 270, NULL, 'Bet v1-like', 286423),
(477969, '0054256', NULL, NULL, 183, NULL, 'Bet v1-like', 286423),
(477970, '0054496', NULL, NULL, 147, NULL, 'Bet v1-like', 286423),
(477971, '0046430', NULL, NULL, 159, NULL, 'Bet v1-like', 286423),
(477972, '0054296', NULL, NULL, 147, NULL, 'Bet v1-like', 286423),
(477973, '0053606', NULL, NULL, 269, NULL, 'Bet v1-like', 286423),
(477974, '0050953', NULL, NULL, 165, NULL, 'Bet v1-like', 286423),
(477975, '0052379', NULL, NULL, 146, NULL, 'Bet v1-like', 286423),
(477976, '0052677', NULL, NULL, 151, NULL, 'Bet v1-like', 286423),
(477977, '0049728', NULL, NULL, 147, NULL, 'Bet v1-like', 286423),
(477978, '0050926', NULL, NULL, 157, NULL, 'Bet v1-like', 286423),
(477979, '0047345', NULL, NULL, 155, NULL, 'Bet v1-like', 286423),
(477980, '0046017', NULL, NULL, 159, NULL, 'Bet v1-like', 286423),
(477981, '0046811', NULL, NULL, 159, NULL, 'Bet v1-like', 286423),
(477982, '0054545', NULL, NULL, 197, NULL, 'Bet v1-like', 286423),
(477983, '0053731', NULL, NULL, 137, NULL, 'Bet v1-like', 286423),
(477984, '0051990', NULL, NULL, 153, NULL, 'Bet v1-like', 286423),
(477985, '0051454', NULL, NULL, 279, NULL, 'Bet v1-like', 286423),
(477986, '0054620', NULL, NULL, 133, NULL, 'Bet v1-like', 286423),
(477987, '0047354', NULL, NULL, 155, NULL, 'Bet v1-like', 286423),
(477988, '0051032', NULL, NULL, 143, NULL, 'Bet v1-like', 286423),
(477989, '0054263', NULL, NULL, 160, NULL, 'Bet v1-like', 286423),
(477990, '0048001', NULL, NULL, 203, NULL, 'Bet v1-like', 286423),
(477991, '0051031', NULL, NULL, 138, NULL, 'Bet v1-like', 286423),
(477992, '0054143', NULL, NULL, 164, NULL, 'Bet v1-like', 286423),
(477993, '0050822', NULL, NULL, 132, NULL, 'Bet v1-like', 286423),
(477994, '0050208', NULL, NULL, 120, NULL, 'Bet v1-like', 286423),
(477995, '0051879', NULL, NULL, 279, NULL, 'Bet v1-like', 286423),
(477996, '0050686', NULL, NULL, 279, NULL, 'Bet v1-like', 286423),
(477997, '0051115', NULL, NULL, 163, NULL, 'Bet v1-like', 286423),
(477998, '0052007', NULL, NULL, 287, NULL, 'Bet v1-like', 286423),
(477999, '0054669', NULL, NULL, 155, NULL, 'Bet v1-like', 286423),
(478000, '0054900', NULL, NULL, 138, NULL, 'Bet v1-like', 286423),
(478001, '0052424', NULL, NULL, 242, NULL, 'Bet v1-like', 286423),
(478002, '0054964', NULL, NULL, 143, NULL, 'Bet v1-like', 286423),
(478003, '0046549', NULL, NULL, 293, NULL, 'Bet v1-like', 286423),
(478004, '0049937', NULL, NULL, 281, NULL, 'Bet v1-like', 286423),
(478005, '0051529', NULL, NULL, 143, NULL, 'Bet v1-like', 286423),
(478006, '0052916', NULL, NULL, 155, NULL, 'Bet v1-like', 286423),
(478007, '0046586', NULL, NULL, 214, NULL, 'Bet v1-like', 286423),
(478008, '0047675', NULL, NULL, 199, NULL, 'Bet v1-like', 286423),
(478009, '0049515', NULL, NULL, 148, NULL, 'Bet v1-like', 286423),
(478010, '0054420', NULL, NULL, 130, NULL, 'MgtE N-terminal domain-like', 286424),
(478011, '0054746', NULL, NULL, 125, NULL, 'MgtE N-terminal domain-like', 286424),
(478012, '0038441', NULL, NULL, 204, NULL, 'Telomeric repeat binding factor (TRF) dimerisation domain', 286425),
(478013, '0038442', NULL, NULL, 203, NULL, 'Telomeric repeat binding factor (TRF) dimerisation domain', 286425);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(478014, '0050628', NULL, NULL, 103, NULL, 'Conserved domain common to transcription factors TFIIS, elongin A, CRSP70', 286426),
(478015, '0037103', NULL, NULL, 77, NULL, 'Conserved domain common to transcription factors TFIIS, elongin A, CRSP70', 286426),
(478016, '0042652', NULL, NULL, 192, NULL, '39 kda initiator binding protein, IBP39, C-terminal domains', 286427),
(478017, '0048986', NULL, NULL, 95, NULL, 'RNA 3''-terminal phosphate cyclase, RPTC, insert domain', 286428),
(478018, '0052880', NULL, NULL, 89, NULL, 'Vng1086c-like', 286429),
(478019, '0050659', NULL, NULL, 61, NULL, 'RelB-like', 286430),
(478020, '0042426', NULL, NULL, 91, NULL, 'Hypothetical protein SAV1430', 286431),
(478021, '0053489', NULL, NULL, 77, NULL, 'Head morphogenesis protein gp7', 286432),
(478022, '0047790', NULL, NULL, 218, NULL, 'Translin', 286433),
(478023, '0041756', NULL, NULL, 128, NULL, 'AXH domain', 286434),
(478024, '0040115', NULL, NULL, 152, NULL, 'Hypothetical protein MTH777 (MT0777)', 286435),
(478025, '0054310', NULL, NULL, 117, NULL, 'SspB-like', 286436),
(478026, '0042032', NULL, NULL, 121, NULL, 'SspB-like', 286436),
(478027, '0042064', NULL, NULL, 107, NULL, 'SspB-like', 286436),
(478028, '0052366', NULL, NULL, 119, NULL, 'DsrEFH-like', 286437),
(478029, '0052367', NULL, NULL, 95, NULL, 'DsrEFH-like', 286437),
(478030, '0053057', NULL, NULL, 132, NULL, 'DsrEFH-like', 286437),
(478031, '0052365', NULL, NULL, 128, NULL, 'DsrEFH-like', 286437),
(478032, '0053058', NULL, NULL, 101, NULL, 'DsrEFH-like', 286437),
(478033, '0053056', NULL, NULL, 130, NULL, 'DsrEFH-like', 286437),
(478034, '0050877', NULL, NULL, 87, NULL, 'DsrEFH-like', 286437),
(478035, '0047703', NULL, NULL, 117, NULL, 'DsrEFH-like', 286437),
(478036, '0047921', NULL, NULL, 111, NULL, 'DsrEFH-like', 286437),
(478037, '0052375', NULL, NULL, 87, NULL, 'Glycosyl hydrolase domain', 286438),
(478038, '0051480', NULL, NULL, 93, NULL, 'Glycosyl hydrolase domain', 286438),
(478039, '0038748', NULL, NULL, 90, NULL, 'Glycosyl hydrolase domain', 286438),
(478040, '0038622', NULL, NULL, 92, NULL, 'Glycosyl hydrolase domain', 286438),
(478041, '0041486', NULL, NULL, 107, NULL, 'Glycosyl hydrolase domain', 286438),
(478042, '0039554', NULL, NULL, 83, NULL, 'Glycosyl hydrolase domain', 286438),
(478043, '0046454', NULL, NULL, 90, NULL, 'Glycosyl hydrolase domain', 286438),
(478044, '0046335', NULL, NULL, 93, NULL, 'Glycosyl hydrolase domain', 286438),
(478045, '0046138', NULL, NULL, 88, NULL, 'Glycosyl hydrolase domain', 286438),
(478046, '0044280', NULL, NULL, 90, NULL, 'Glycosyl hydrolase domain', 286438),
(478047, '0052584', NULL, NULL, 80, NULL, 'Glycosyl hydrolase domain', 286438),
(478048, '0046265', NULL, NULL, 90, NULL, 'Glycosyl hydrolase domain', 286438),
(478049, '0046022', NULL, NULL, 83, NULL, 'Glycosyl hydrolase domain', 286438),
(478050, '0041849', NULL, NULL, 144, NULL, 'Glycosyl hydrolase domain', 286438),
(478051, '0050403', NULL, NULL, 153, NULL, 'Glycosyl hydrolase domain', 286438),
(478052, '0035222', NULL, NULL, 57, NULL, 'Glycosyl hydrolase domain', 286438),
(478053, '0051974', NULL, NULL, 72, NULL, 'Glycosyl hydrolase domain', 286438),
(478054, '0037001', NULL, NULL, 67, NULL, 'Glycosyl hydrolase domain', 286438),
(478055, '0041134', NULL, NULL, 74, NULL, 'Glycosyl hydrolase domain', 286438),
(478056, '0046947', NULL, NULL, 94, NULL, 'Glycosyl hydrolase domain', 286438),
(478057, '0050759', NULL, NULL, 79, NULL, 'Glycosyl hydrolase domain', 286438),
(478058, '0044243', NULL, NULL, 89, NULL, 'Glycosyl hydrolase domain', 286438),
(478059, '0043113', NULL, NULL, 98, NULL, 'Glycosyl hydrolase domain', 286438),
(478060, '0040842', NULL, NULL, 106, NULL, 'Glycosyl hydrolase domain', 286438),
(478061, '0046504', NULL, NULL, 80, NULL, 'Glycosyl hydrolase domain', 286438),
(478062, '0048723', NULL, NULL, 90, NULL, 'Glycosyl hydrolase domain', 286438),
(478063, '0046151', NULL, NULL, 89, NULL, 'Glycosyl hydrolase domain', 286438),
(478064, '0043161', NULL, NULL, 70, NULL, 'Glycosyl hydrolase domain', 286438),
(478065, '0044371', NULL, NULL, 155, NULL, 'Glycosyl hydrolase domain', 286438);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(478066, '0045140', NULL, NULL, 95, NULL, 'Glycosyl hydrolase domain', 286438),
(478067, '0052912', NULL, NULL, 87, NULL, 'Glycosyl hydrolase domain', 286438),
(478068, '0039217', NULL, NULL, 67, NULL, 'Glycosyl hydrolase domain', 286438),
(478069, '0038122', NULL, NULL, 64, NULL, 'Glycosyl hydrolase domain', 286438),
(478070, '0038047', NULL, NULL, 61, NULL, 'Glycosyl hydrolase domain', 286438),
(478071, '0040254', NULL, NULL, 95, NULL, 'Glycosyl hydrolase domain', 286438),
(478072, '0045946', NULL, NULL, 113, NULL, 'Glycosyl hydrolase domain', 286438),
(478073, '0040295', NULL, NULL, 54, NULL, 'Glycosyl hydrolase domain', 286438),
(478074, '0053917', NULL, NULL, 118, NULL, 'Glycosyl hydrolase domain', 286438),
(478075, '0045463', NULL, NULL, 97, NULL, 'Glycosyl hydrolase domain', 286438),
(478076, '0049501', NULL, NULL, 103, NULL, 'Glycosyl hydrolase domain', 286438),
(478077, '0046235', NULL, NULL, 89, NULL, 'Glycosyl hydrolase domain', 286438),
(478078, '0049423', NULL, NULL, 83, NULL, 'Glycosyl hydrolase domain', 286438),
(478079, '0049621', NULL, NULL, 175, NULL, 'Glycosyl hydrolase domain', 286438),
(478080, '0042794', NULL, NULL, 88, NULL, 'Glycosyl hydrolase domain', 286438),
(478081, '0040699', NULL, NULL, 50, NULL, 'Glycosyl hydrolase domain', 286438),
(478082, '0052124', NULL, NULL, 132, NULL, 'Glycosyl hydrolase domain', 286438),
(478083, '0047490', NULL, NULL, 83, NULL, 'Glycosyl hydrolase domain', 286438),
(478084, '0037941', NULL, NULL, 74, NULL, 'Glycosyl hydrolase domain', 286438),
(478085, '0038712', NULL, NULL, 57, NULL, 'Glycosyl hydrolase domain', 286438),
(478086, '0038397', NULL, NULL, 83, NULL, 'Glycosyl hydrolase domain', 286438),
(478087, '0039440', NULL, NULL, 93, NULL, 'Glycosyl hydrolase domain', 286438),
(478088, '0040788', NULL, NULL, 78, NULL, 'Glycosyl hydrolase domain', 286438),
(478089, '0043015', NULL, NULL, 131, NULL, 'Glycosyl hydrolase domain', 286438),
(478090, '0049835', NULL, NULL, 78, NULL, 'Glycosyl hydrolase domain', 286438),
(478091, '0044468', NULL, NULL, 79, NULL, 'Glycosyl hydrolase domain', 286438),
(478092, '0049861', NULL, NULL, 494, NULL, 'Phase 1 flagellin', 286439),
(478093, '0044822', NULL, NULL, 179, NULL, 'PurM C-terminal domain-like', 286440),
(478094, '0044823', NULL, NULL, 96, NULL, 'PurM C-terminal domain-like', 286440),
(478095, '0036051', NULL, NULL, 175, NULL, 'PurM C-terminal domain-like', 286440),
(478096, '0043869', NULL, NULL, 217, NULL, 'PurM C-terminal domain-like', 286440),
(478097, '0054761', NULL, NULL, 179, NULL, 'PurM C-terminal domain-like', 286440),
(478098, '0050292', NULL, NULL, 163, NULL, 'PurM C-terminal domain-like', 286440),
(478099, '0049529', NULL, NULL, 187, NULL, 'PurM C-terminal domain-like', 286440),
(478100, '0054802', NULL, NULL, 182, NULL, 'PurM C-terminal domain-like', 286440),
(478101, '0054956', NULL, NULL, 207, NULL, 'CbiG N-terminal domain-like', 286441),
(478102, '0050132', NULL, NULL, 254, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478103, '0052356', NULL, NULL, 206, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478104, '0036628', NULL, NULL, 239, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478105, '0052672', NULL, NULL, 332, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478106, '0051442', NULL, NULL, 230, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478107, '0049004', NULL, NULL, 267, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478108, '0047101', NULL, NULL, 220, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478109, '0048432', NULL, NULL, 205, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478110, '0049146', NULL, NULL, 261, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478111, '0051164', NULL, NULL, 222, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478112, '0052714', NULL, NULL, 217, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478113, '0039992', NULL, NULL, 251, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478114, '0049629', NULL, NULL, 253, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478115, '0036340', NULL, NULL, 237, NULL, 'Ribulose-phoshate binding barrel', 286442);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(478116, '0049228', NULL, NULL, 230, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478117, '0047300', NULL, NULL, 251, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478118, '0047125', NULL, NULL, 252, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478119, '0050290', NULL, NULL, 198, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478120, '0047889', NULL, NULL, 213, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478121, '0048998', NULL, NULL, 241, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478122, '0049922', NULL, NULL, 271, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478123, '0052661', NULL, NULL, 324, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478124, '0049675', NULL, NULL, 221, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478125, '0050062', NULL, NULL, 200, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478126, '0049674', NULL, NULL, 221, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478127, '0037027', NULL, NULL, 231, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478128, '0050322', NULL, NULL, 239, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478129, '0051598', NULL, NULL, 254, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478130, '0050916', NULL, NULL, 267, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478131, '0039781', NULL, NULL, 323, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478132, '0053293', NULL, NULL, 323, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478133, '0046387', NULL, NULL, 267, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478134, '0038072', NULL, NULL, 248, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478135, '0045712', NULL, NULL, 247, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478136, '0048767', NULL, NULL, 198, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478137, '0048768', NULL, NULL, 254, NULL, 'Ribulose-phoshate binding barrel', 286442),
(478138, '0053972', NULL, NULL, 117, NULL, 'IVS-encoded protein-like', 286443),
(478139, '0054679', NULL, NULL, 115, NULL, 'IVS-encoded protein-like', 286443),
(478140, '0050883', NULL, NULL, 149, NULL, 'DR1885-like metal-binding protein', 286444),
(478141, '0051907', NULL, NULL, 96, NULL, 'Carboxypeptidase regulatory domain-like', 286445),
(478142, '0050014', NULL, NULL, 107, NULL, 'Carboxypeptidase regulatory domain-like', 286445),
(478143, '0048988', NULL, NULL, 79, NULL, 'Carboxypeptidase regulatory domain-like', 286445),
(478144, '0042688', NULL, NULL, 110, NULL, 'NAD-binding domain of HMG-CoA reductase', 286446),
(478145, '0046381', NULL, NULL, 117, NULL, 'NAD-binding domain of HMG-CoA reductase', 286446),
(478146, '0050352', NULL, NULL, 276, NULL, 'Restriction endonuclease-like', 286447),
(478147, '0051683', NULL, NULL, 129, NULL, 'Restriction endonuclease-like', 286447),
(478148, '0054379', NULL, NULL, 136, NULL, 'Restriction endonuclease-like', 286447),
(478149, '0054412', NULL, NULL, 179, NULL, 'Restriction endonuclease-like', 286447),
(478150, '0036506', NULL, NULL, 299, NULL, 'Restriction endonuclease-like', 286447),
(478151, '0051167', NULL, NULL, 209, NULL, 'Restriction endonuclease-like', 286447),
(478152, '0045286', NULL, NULL, 193, NULL, 'Restriction endonuclease-like', 286447),
(478153, '0047187', NULL, NULL, 132, NULL, 'Restriction endonuclease-like', 286447),
(478154, '0036344', NULL, NULL, 319, NULL, 'Restriction endonuclease-like', 286447),
(478155, '0051967', NULL, NULL, 133, NULL, 'Restriction endonuclease-like', 286447),
(478156, '0050355', NULL, NULL, 304, NULL, 'Restriction endonuclease-like', 286447),
(478157, '0049280', NULL, NULL, 165, NULL, 'Restriction endonuclease-like', 286447),
(478158, '0050698', NULL, NULL, 272, NULL, 'Restriction endonuclease-like', 286447),
(478159, '0038067', NULL, NULL, 120, NULL, 'Restriction endonuclease-like', 286447),
(478160, '0037212', NULL, NULL, 302, NULL, 'Restriction endonuclease-like', 286447),
(478161, '0035276', NULL, NULL, 226, NULL, 'Restriction endonuclease-like', 286447),
(478162, '0035231', NULL, NULL, 228, NULL, 'Restriction endonuclease-like', 286447);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(478163, '0041285', NULL, NULL, 220, NULL, 'Restriction endonuclease-like', 286447),
(478164, '0048532', NULL, NULL, 124, NULL, 'Restriction endonuclease-like', 286447),
(478165, '0051182', NULL, NULL, 168, NULL, 'Restriction endonuclease-like', 286447),
(478166, '0054150', NULL, NULL, 135, NULL, 'Restriction endonuclease-like', 286447),
(478167, '0040016', NULL, NULL, 257, NULL, 'Restriction endonuclease-like', 286447),
(478168, '0050442', NULL, NULL, 186, NULL, 'Restriction endonuclease-like', 286447),
(478169, '0037606', NULL, NULL, 286, NULL, 'Restriction endonuclease-like', 286447),
(478170, '0051030', NULL, NULL, 385, NULL, 'Restriction endonuclease-like', 286447),
(478171, '0036214', NULL, NULL, 197, NULL, 'Restriction endonuclease-like', 286447),
(478172, '0037109', NULL, NULL, 244, NULL, 'Restriction endonuclease-like', 286447),
(478173, '0036036', NULL, NULL, 261, NULL, 'Restriction endonuclease-like', 286447),
(478174, '0049370', NULL, NULL, 203, NULL, 'Restriction endonuclease-like', 286447),
(478175, '0035965', NULL, NULL, 283, NULL, 'Restriction endonuclease-like', 286447),
(478176, '0037863', NULL, NULL, 129, NULL, 'Restriction endonuclease-like', 286447),
(478177, '0039325', NULL, NULL, 131, NULL, 'Restriction endonuclease-like', 286447),
(478178, '0053933', NULL, NULL, 179, NULL, 'Restriction endonuclease-like', 286447),
(478179, '0051238', NULL, NULL, 125, NULL, 'Restriction endonuclease-like', 286447),
(478180, '0037341', NULL, NULL, 161, NULL, 'Restriction endonuclease-like', 286447),
(478181, '0036173', NULL, NULL, 155, NULL, 'Restriction endonuclease-like', 286447),
(478182, '0043536', NULL, NULL, 262, NULL, 'Restriction endonuclease-like', 286447),
(478183, '0040166', NULL, NULL, 290, NULL, 'Restriction endonuclease-like', 286447),
(478184, '0045917', NULL, NULL, 213, NULL, 'Restriction endonuclease-like', 286447),
(478185, '0046325', NULL, NULL, 223, NULL, 'Restriction endonuclease-like', 286447),
(478186, '0045557', NULL, NULL, 156, NULL, 'Restriction endonuclease-like', 286447),
(478187, '0053244', NULL, NULL, 86, NULL, 'Mechanosensitive channel protein MscS (YggB), transmembrane region', 286448),
(478188, '0047053', NULL, NULL, 94, NULL, 'Porphobilinogen deaminase (hydroxymethylbilane synthase), C-terminal domain', 286449),
(478189, '0054358', NULL, NULL, 123, NULL, 'YdhG-like', 286450),
(478190, '0054106', NULL, NULL, 121, NULL, 'YdhG-like', 286450),
(478191, '0051243', NULL, NULL, 221, NULL, 'Trypsin-like serine proteases', 286451),
(478192, '0050034', NULL, NULL, 223, NULL, 'Trypsin-like serine proteases', 286451),
(478193, '0053300', NULL, NULL, 181, NULL, 'Trypsin-like serine proteases', 286451),
(478194, '0037734', NULL, NULL, 227, NULL, 'Trypsin-like serine proteases', 286451),
(478195, '0035673', NULL, NULL, 234, NULL, 'Trypsin-like serine proteases', 286451),
(478196, '0046290', NULL, NULL, 254, NULL, 'Trypsin-like serine proteases', 286451),
(478197, '0040353', NULL, NULL, 180, NULL, 'Trypsin-like serine proteases', 286451),
(478198, '0042134', NULL, NULL, 215, NULL, 'Trypsin-like serine proteases', 286451),
(478199, '0042416', NULL, NULL, 218, NULL, 'Trypsin-like serine proteases', 286451),
(478200, '0040351', NULL, NULL, 228, NULL, 'Trypsin-like serine proteases', 286451),
(478201, '0040590', NULL, NULL, 221, NULL, 'Trypsin-like serine proteases', 286451),
(478202, '0046575', NULL, NULL, 235, NULL, 'Trypsin-like serine proteases', 286451),
(478203, '0043220', NULL, NULL, 235, NULL, 'Trypsin-like serine proteases', 286451),
(478204, '0048635', NULL, NULL, 223, NULL, 'Trypsin-like serine proteases', 286451),
(478205, '0048877', NULL, NULL, 239, NULL, 'Trypsin-like serine proteases', 286451),
(478206, '0037607', NULL, NULL, 275, NULL, 'Trypsin-like serine proteases', 286451),
(478207, '0037609', NULL, NULL, 277, NULL, 'Trypsin-like serine proteases', 286451),
(478208, '0036116', NULL, NULL, 180, NULL, 'Trypsin-like serine proteases', 286451),
(478209, '0038419', NULL, NULL, 224, NULL, 'Trypsin-like serine proteases', 286451),
(478210, '0037840', NULL, NULL, 228, NULL, 'Trypsin-like serine proteases', 286451);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(478211, '0053039', NULL, NULL, 139, NULL, 'Trypsin-like serine proteases', 286451),
(478212, '0047957', NULL, NULL, 205, NULL, 'Trypsin-like serine proteases', 286451),
(478213, '0052619', NULL, NULL, 237, NULL, 'Trypsin-like serine proteases', 286451),
(478214, '0043596', NULL, NULL, 233, NULL, 'Trypsin-like serine proteases', 286451),
(478215, '0040887', NULL, NULL, 223, NULL, 'Trypsin-like serine proteases', 286451),
(478216, '0045413', NULL, NULL, 233, NULL, 'Trypsin-like serine proteases', 286451),
(478217, '0054138', NULL, NULL, 172, NULL, 'Trypsin-like serine proteases', 286451),
(478218, '0048133', NULL, NULL, 198, NULL, 'Trypsin-like serine proteases', 286451),
(478219, '0051141', NULL, NULL, 237, NULL, 'Trypsin-like serine proteases', 286451),
(478220, '0038086', NULL, NULL, 240, NULL, 'Trypsin-like serine proteases', 286451),
(478221, '0046511', NULL, NULL, 241, NULL, 'Trypsin-like serine proteases', 286451),
(478222, '0046995', NULL, NULL, 257, NULL, 'Trypsin-like serine proteases', 286451),
(478223, '0046356', NULL, NULL, 298, NULL, 'Trypsin-like serine proteases', 286451),
(478224, '0049863', NULL, NULL, 297, NULL, 'Trypsin-like serine proteases', 286451),
(478225, '0048262', NULL, NULL, 202, NULL, 'Trypsin-like serine proteases', 286451),
(478226, '0053299', NULL, NULL, 191, NULL, 'Trypsin-like serine proteases', 286451),
(478227, '0041509', NULL, NULL, 225, NULL, 'Trypsin-like serine proteases', 286451),
(478228, '0043371', NULL, NULL, 261, NULL, 'Trypsin-like serine proteases', 286451),
(478229, '0037786', NULL, NULL, 221, NULL, 'Trypsin-like serine proteases', 286451),
(478230, '0038512', NULL, NULL, 216, NULL, 'Trypsin-like serine proteases', 286451),
(478231, '0045318', NULL, NULL, 230, NULL, 'Trypsin-like serine proteases', 286451),
(478232, '0043779', NULL, NULL, 160, NULL, 'Trypsin-like serine proteases', 286451),
(478233, '0035122', NULL, NULL, 237, NULL, 'Trypsin-like serine proteases', 286451),
(478234, '0042606', NULL, NULL, 242, NULL, 'Trypsin-like serine proteases', 286451),
(478235, '0047218', NULL, NULL, 187, NULL, 'Trypsin-like serine proteases', 286451),
(478236, '0044104', NULL, NULL, 224, NULL, 'Trypsin-like serine proteases', 286451),
(478237, '0048392', NULL, NULL, 224, NULL, 'Trypsin-like serine proteases', 286451),
(478238, '0048030', NULL, NULL, 243, NULL, 'Trypsin-like serine proteases', 286451),
(478239, '0045561', NULL, NULL, 224, NULL, 'Trypsin-like serine proteases', 286451),
(478240, '0044076', NULL, NULL, 235, NULL, 'Trypsin-like serine proteases', 286451),
(478241, '0042293', NULL, NULL, 235, NULL, 'Trypsin-like serine proteases', 286451),
(478242, '0053746', NULL, NULL, 199, NULL, 'Trypsin-like serine proteases', 286451),
(478243, '0037131', NULL, NULL, 222, NULL, 'Trypsin-like serine proteases', 286451),
(478244, '0047907', NULL, NULL, 249, NULL, 'Trypsin-like serine proteases', 286451),
(478245, '0049401', NULL, NULL, 228, NULL, 'Trypsin-like serine proteases', 286451),
(478246, '0045688', NULL, NULL, 244, NULL, 'Trypsin-like serine proteases', 286451),
(478247, '0040038', NULL, NULL, 226, NULL, 'Trypsin-like serine proteases', 286451),
(478248, '0042215', NULL, NULL, 300, NULL, 'Trypsin-like serine proteases', 286451),
(478249, '0034935', NULL, NULL, 221, NULL, 'Trypsin-like serine proteases', 286451),
(478250, '0049010', NULL, NULL, 198, NULL, 'Trypsin-like serine proteases', 286451),
(478251, '0034812', NULL, NULL, 223, NULL, 'Trypsin-like serine proteases', 286451),
(478252, '0035500', NULL, NULL, 177, NULL, 'Trypsin-like serine proteases', 286451),
(478253, '0038219', NULL, NULL, 252, NULL, 'Trypsin-like serine proteases', 286451),
(478254, '0047191', NULL, NULL, 223, NULL, 'Trypsin-like serine proteases', 286451),
(478255, '0035182', NULL, NULL, 263, NULL, 'Trypsin-like serine proteases', 286451),
(478256, '0038059', NULL, NULL, 224, NULL, 'Trypsin-like serine proteases', 286451),
(478257, '0036154', NULL, NULL, 201, NULL, 'Trypsin-like serine proteases', 286451),
(478258, '0038297', NULL, NULL, 237, NULL, 'Trypsin-like serine proteases', 286451);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(478259, '0041537', NULL, NULL, 192, NULL, 'Trypsin-like serine proteases', 286451),
(478260, '0046306', NULL, NULL, 247, NULL, 'Trypsin-like serine proteases', 286451),
(478261, '0042588', NULL, NULL, 299, NULL, 'Trypsin-like serine proteases', 286451),
(478262, '0043039', NULL, NULL, 216, NULL, 'Trypsin-like serine proteases', 286451),
(478263, '0049389', NULL, NULL, 228, NULL, 'Trypsin-like serine proteases', 286451),
(478264, '0045461', NULL, NULL, 222, NULL, 'Trypsin-like serine proteases', 286451),
(478265, '0037635', NULL, NULL, 234, NULL, 'Trypsin-like serine proteases', 286451),
(478266, '0050139', NULL, NULL, 149, NULL, 'Trypsin-like serine proteases', 286451),
(478267, '0037599', NULL, NULL, 227, NULL, 'Trypsin-like serine proteases', 286451),
(478268, '0034885', NULL, NULL, 265, NULL, 'Trypsin-like serine proteases', 286451),
(478269, '0035578', NULL, NULL, 228, NULL, 'Trypsin-like serine proteases', 286451),
(478270, '0035974', NULL, NULL, 224, NULL, 'Trypsin-like serine proteases', 286451),
(478271, '0037077', NULL, NULL, 259, NULL, 'Trypsin-like serine proteases', 286451),
(478272, '0043603', NULL, NULL, 185, NULL, 'Trypsin-like serine proteases', 286451),
(478273, '0035210', NULL, NULL, 240, NULL, 'Trypsin-like serine proteases', 286451),
(478274, '0040692', NULL, NULL, 299, NULL, 'Trypsin-like serine proteases', 286451),
(478275, '0037075', NULL, NULL, 236, NULL, 'Trypsin-like serine proteases', 286451),
(478276, '0040858', NULL, NULL, 241, NULL, 'Trypsin-like serine proteases', 286451),
(478277, '0037192', NULL, NULL, 224, NULL, 'Trypsin-like serine proteases', 286451),
(478278, '0048697', NULL, NULL, 254, NULL, 'Trypsin-like serine proteases', 286451),
(478279, '0043683', NULL, NULL, 213, NULL, 'Trypsin-like serine proteases', 286451),
(478280, '0047648', NULL, NULL, 305, NULL, 'Trypsin-like serine proteases', 286451),
(478281, '0041149', NULL, NULL, 240, NULL, 'Trypsin-like serine proteases', 286451),
(478282, '0049034', NULL, NULL, 246, NULL, 'Trypsin-like serine proteases', 286451),
(478283, '0035283', NULL, NULL, 226, NULL, 'Trypsin-like serine proteases', 286451),
(478284, '0040102', NULL, NULL, 241, NULL, 'Trypsin-like serine proteases', 286451),
(478285, '0048628', NULL, NULL, 232, NULL, 'Trypsin-like serine proteases', 286451),
(478286, '0035683', NULL, NULL, 241, NULL, 'Trypsin-like serine proteases', 286451),
(478287, '0042528', NULL, NULL, 248, NULL, 'Trypsin-like serine proteases', 286451),
(478288, '0042529', NULL, NULL, 251, NULL, 'Trypsin-like serine proteases', 286451),
(478289, '0035042', NULL, NULL, 242, NULL, 'Trypsin-like serine proteases', 286451),
(478290, '0041958', NULL, NULL, 234, NULL, 'Trypsin-like serine proteases', 286451),
(478291, '0046722', NULL, NULL, 223, NULL, 'Trypsin-like serine proteases', 286451),
(478292, '0042882', NULL, NULL, 240, NULL, 'Trypsin-like serine proteases', 286451),
(478293, '0046602', NULL, NULL, 156, NULL, 'Trypsin-like serine proteases', 286451),
(478294, '0045063', NULL, NULL, 71, NULL, 'C-terminal domain of arginine repressor', 286452),
(478295, '0035348', NULL, NULL, 71, NULL, 'C-terminal domain of arginine repressor', 286452),
(478296, '0037457', NULL, NULL, 71, NULL, 'C-terminal domain of arginine repressor', 286452),
(478297, '0036706', NULL, NULL, 88, NULL, 'Chitinase insertion domain', 286453),
(478298, '0036925', NULL, NULL, 73, NULL, 'Chitinase insertion domain', 286453),
(478299, '0038609', NULL, NULL, 68, NULL, 'Chitinase insertion domain', 286453),
(478300, '0051087', NULL, NULL, 68, NULL, 'Chitinase insertion domain', 286453),
(478301, '0036855', NULL, NULL, 70, NULL, 'Chitinase insertion domain', 286453),
(478302, '0050413', NULL, NULL, 62, NULL, 'Chitinase insertion domain', 286453),
(478303, '0040069', NULL, NULL, 61, NULL, 'Chitinase insertion domain', 286453),
(478304, '0043998', NULL, NULL, 68, NULL, 'Chitinase insertion domain', 286453),
(478305, '0047638', NULL, NULL, 92, NULL, 'Chitinase insertion domain', 286453),
(478306, '0042056', NULL, NULL, 68, NULL, 'Chitinase insertion domain', 286453);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(478307, '0039195', NULL, NULL, 72, NULL, 'Chitinase insertion domain', 286453),
(478308, '0046257', NULL, NULL, 62, NULL, 'Chitinase insertion domain', 286453),
(478309, '0040523', NULL, NULL, 68, NULL, 'Chitinase insertion domain', 286453),
(478310, '0040489', NULL, NULL, 68, NULL, 'Chitinase insertion domain', 286453),
(478311, '0041827', NULL, NULL, 102, NULL, 'HAND domain of the nucleosome remodeling ATPase ISWI', 286454),
(478312, '0050260', NULL, NULL, 189, NULL, 'ITPase-like', 286455),
(478313, '0035385', NULL, NULL, 184, NULL, 'ITPase-like', 286455),
(478314, '0052132', NULL, NULL, 194, NULL, 'ITPase-like', 286455),
(478315, '0039945', NULL, NULL, 209, NULL, 'ITPase-like', 286455),
(478316, '0049799', NULL, NULL, 170, NULL, 'ITPase-like', 286455),
(478317, '0049765', NULL, NULL, 169, NULL, 'ITPase-like', 286455),
(478318, '0044652', NULL, NULL, 186, NULL, 'ITPase-like', 286455),
(478319, '0046645', NULL, NULL, 185, NULL, 'ITPase-like', 286455),
(478320, '0051656', NULL, NULL, 173, NULL, 'ITPase-like', 286455),
(478321, '0051798', NULL, NULL, 201, NULL, 'ITPase-like', 286455),
(478322, '0041059', NULL, NULL, 280, NULL, 'Methyl-coenzyme M reductase alpha and beta chain C-terminal domain', 286456),
(478323, '0036803', NULL, NULL, 253, NULL, 'Methyl-coenzyme M reductase alpha and beta chain C-terminal domain', 286456),
(478324, '0036809', NULL, NULL, 248, NULL, 'Methyl-coenzyme M reductase alpha and beta chain C-terminal domain', 286456),
(478325, '0036807', NULL, NULL, 286, NULL, 'Methyl-coenzyme M reductase alpha and beta chain C-terminal domain', 286456),
(478326, '0041061', NULL, NULL, 255, NULL, 'Methyl-coenzyme M reductase alpha and beta chain C-terminal domain', 286456),
(478327, '0036801', NULL, NULL, 280, NULL, 'Methyl-coenzyme M reductase alpha and beta chain C-terminal domain', 286456),
(478328, '0037652', NULL, NULL, 128, NULL, 'lambda integrase-like, N-terminal domain', 286457),
(478329, '0053344', NULL, NULL, 110, NULL, 'lambda integrase-like, N-terminal domain', 286457),
(478330, '0045689', NULL, NULL, 98, NULL, 'lambda integrase-like, N-terminal domain', 286457),
(478331, '0051049', NULL, NULL, 84, NULL, 'EspA/CesA-like', 286458),
(478332, '0051048', NULL, NULL, 160, NULL, 'EspA/CesA-like', 286458),
(478333, '0053466', NULL, NULL, 209, NULL, 'Chemotaxis phosphatase CheZ', 286459),
(478334, '0046714', NULL, NULL, 90, NULL, 'eEF-1beta-like', 286460),
(478335, '0045883', NULL, NULL, 91, NULL, 'eEF-1beta-like', 286460),
(478336, '0046985', NULL, NULL, 89, NULL, 'eEF-1beta-like', 286460),
(478337, '0049158', NULL, NULL, 34, NULL, 'CCCH zinc finger', 286461),
(478338, '0052241', NULL, NULL, 56, NULL, 'CCCH zinc finger', 286461),
(478339, '0049157', NULL, NULL, 36, NULL, 'CCCH zinc finger', 286461),
(478340, '0052242', NULL, NULL, 29, NULL, 'CCCH zinc finger', 286461),
(478341, '0053908', NULL, NULL, 37, NULL, 'CCCH zinc finger', 286461),
(478342, '0040854', NULL, NULL, 40, NULL, 'CCCH zinc finger', 286461),
(478343, '0050605', NULL, NULL, 71, NULL, 'WRKY DNA-binding domain', 286462),
(478344, '0054024', NULL, NULL, 109, NULL, 'FlaG-like', 286463),
(478345, '0053378', NULL, NULL, 186, NULL, 'Dihydrofolate reductase-like', 286464),
(478346, '0053343', NULL, NULL, 202, NULL, 'Dihydrofolate reductase-like', 286464),
(478347, '0043051', NULL, NULL, 178, NULL, 'Dihydrofolate reductase-like', 286464),
(478348, '0053054', NULL, NULL, 198, NULL, 'Dihydrofolate reductase-like', 286464),
(478349, '0051866', NULL, NULL, 219, NULL, 'Dihydrofolate reductase-like', 286464),
(478350, '0053318', NULL, NULL, 162, NULL, 'Dihydrofolate reductase-like', 286464),
(478351, '0051896', NULL, NULL, 214, NULL, 'Dihydrofolate reductase-like', 286464),
(478352, '0036228', NULL, NULL, 164, NULL, 'Dihydrofolate reductase-like', 286464),
(478353, '0035127', NULL, NULL, 192, NULL, 'Dihydrofolate reductase-like', 286464),
(478354, '0039349', NULL, NULL, 231, NULL, 'Dihydrofolate reductase-like', 286464),
(478355, '0046319', NULL, NULL, 159, NULL, 'Dihydrofolate reductase-like', 286464),
(478356, '0047688', NULL, NULL, 193, NULL, 'Dihydrofolate reductase-like', 286464);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(478357, '0049139', NULL, NULL, 159, NULL, 'Dihydrofolate reductase-like', 286464),
(478358, '0047835', NULL, NULL, 186, NULL, 'Dihydrofolate reductase-like', 286464),
(478359, '0044710', NULL, NULL, 157, NULL, 'Dihydrofolate reductase-like', 286464),
(478360, '0045507', NULL, NULL, 84, NULL, 'Colicin E3 immunity protein', 286465),
(478361, '0045703', NULL, NULL, 72, NULL, 'Eukaryotic DNA topoisomerase I, dispensable insert domain', 286466),
(478362, '0038036', NULL, NULL, 111, NULL, 'Second domain of FERM', 286467),
(478363, '0041398', NULL, NULL, 111, NULL, 'Second domain of FERM', 286467),
(478364, '0048168', NULL, NULL, 114, NULL, 'Second domain of FERM', 286467),
(478365, '0051790', NULL, NULL, 123, NULL, 'Second domain of FERM', 286467),
(478366, '0038416', NULL, NULL, 111, NULL, 'Second domain of FERM', 286467),
(478367, '0051180', NULL, NULL, 100, NULL, 'Second domain of FERM', 286467),
(478368, '0046535', NULL, NULL, 111, NULL, 'Second domain of FERM', 286467),
(478369, '0046976', NULL, NULL, 106, NULL, 'Second domain of FERM', 286467),
(478370, '0045040', NULL, NULL, 256, NULL, 'CNF1/YfiH-like putative cysteine hydrolases', 286468),
(478371, '0038670', NULL, NULL, 295, NULL, 'CNF1/YfiH-like putative cysteine hydrolases', 286468),
(478372, '0053906', NULL, NULL, 157, NULL, 'CNF1/YfiH-like putative cysteine hydrolases', 286468),
(478373, '0043384', NULL, NULL, 242, NULL, 'CNF1/YfiH-like putative cysteine hydrolases', 286468),
(478374, '0045023', NULL, NULL, 242, NULL, 'CNF1/YfiH-like putative cysteine hydrolases', 286468),
(478375, '0043908', NULL, NULL, 272, NULL, 'CNF1/YfiH-like putative cysteine hydrolases', 286468),
(478376, '0043389', NULL, NULL, 243, NULL, 'CNF1/YfiH-like putative cysteine hydrolases', 286468),
(478377, '0035983', NULL, NULL, 198, NULL, 'Methylesterase CheB, C-terminal domain', 286469),
(478378, '0049385', NULL, NULL, 24, NULL, 'TNF receptor-like', 286470),
(478379, '0051112', NULL, NULL, 46, NULL, 'TNF receptor-like', 286470),
(478380, '0053011', NULL, NULL, 24, NULL, 'TNF receptor-like', 286470),
(478381, '0046273', NULL, NULL, 46, NULL, 'TNF receptor-like', 286470),
(478382, '0053012', NULL, NULL, 54, NULL, 'TNF receptor-like', 286470),
(478383, '0046650', NULL, NULL, 59, NULL, 'TNF receptor-like', 286470),
(478384, '0043591', NULL, NULL, 55, NULL, 'TNF receptor-like', 286470),
(478385, '0043592', NULL, NULL, 39, NULL, 'TNF receptor-like', 286470),
(478386, '0053010', NULL, NULL, 60, NULL, 'TNF receptor-like', 286470),
(478387, '0039629', NULL, NULL, 46, NULL, 'TNF receptor-like', 286470),
(478388, '0039628', NULL, NULL, 56, NULL, 'TNF receptor-like', 286470),
(478389, '0037253', NULL, NULL, 44, NULL, 'TNF receptor-like', 286470),
(478390, '0041972', NULL, NULL, 31, NULL, 'TNF receptor-like', 286470),
(478391, '0037254', NULL, NULL, 57, NULL, 'TNF receptor-like', 286470),
(478392, '0036276', NULL, NULL, 31, NULL, 'TNF receptor-like', 286470),
(478393, '0036275', NULL, NULL, 40, NULL, 'TNF receptor-like', 286470),
(478394, '0048622', NULL, NULL, 39, NULL, 'TNF receptor-like', 286470),
(478395, '0043593', NULL, NULL, 42, NULL, 'TNF receptor-like', 286470),
(478396, '0048252', NULL, NULL, 138, NULL, 'Translation proteins', 286471),
(478397, '0053860', NULL, NULL, 87, NULL, 'Translation proteins', 286471),
(478398, '0054773', NULL, NULL, 205, NULL, 'Translation proteins', 286471),
(478399, '0054177', NULL, NULL, 205, NULL, 'Translation proteins', 286471),
(478400, '0052053', NULL, NULL, 121, NULL, 'Translation proteins', 286471),
(478401, '0051646', NULL, NULL, 92, NULL, 'Translation proteins', 286471),
(478402, '0051767', NULL, NULL, 114, NULL, 'Translation proteins', 286471),
(478403, '0037974', NULL, NULL, 101, NULL, 'Translation proteins', 286471),
(478404, '0037975', NULL, NULL, 128, NULL, 'Translation proteins', 286471),
(478405, '0046538', NULL, NULL, 92, NULL, 'Translation proteins', 286471),
(478406, '0037530', NULL, NULL, 337, NULL, 'Translation proteins', 286471),
(478407, '0039670', NULL, NULL, 95, NULL, 'Translation proteins', 286471),
(478408, '0040119', NULL, NULL, 121, NULL, 'Translation proteins', 286471);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(478409, '0049446', NULL, NULL, 87, NULL, 'Translation proteins', 286471),
(478410, '0049110', NULL, NULL, 95, NULL, 'Translation proteins', 286471),
(478411, '0052543', NULL, NULL, 73, NULL, 'Translation proteins', 286471),
(478412, '0050420', NULL, NULL, 92, NULL, 'Translation proteins', 286471),
(478413, '0053993', NULL, NULL, 209, NULL, 'Translation proteins', 286471),
(478414, '0036237', NULL, NULL, 98, NULL, 'Translation proteins', 286471),
(478415, '0050448', NULL, NULL, 103, NULL, 'Translation proteins', 286471),
(478416, '0037405', NULL, NULL, 94, NULL, 'Translation proteins', 286471),
(478417, '0037246', NULL, NULL, 100, NULL, 'Translation proteins', 286471),
(478418, '0050421', NULL, NULL, 79, NULL, 'Translation proteins', 286471),
(478419, '0049290', NULL, NULL, 118, NULL, 'Translation proteins', 286471),
(478420, '0052567', NULL, NULL, 89, NULL, 'Translation proteins', 286471),
(478421, '0036231', NULL, NULL, 99, NULL, 'Translation proteins', 286471),
(478422, '0045034', NULL, NULL, 91, NULL, 'Translation proteins', 286471),
(478423, '0047096', NULL, NULL, 165, NULL, 'ADC-like', 286472),
(478424, '0036728', NULL, NULL, 86, NULL, 'ADC-like', 286472),
(478425, '0052771', NULL, NULL, 82, NULL, 'ADC-like', 286472),
(478426, '0045381', NULL, NULL, 123, NULL, 'ADC-like', 286472),
(478427, '0046362', NULL, NULL, 156, NULL, 'ADC-like', 286472),
(478428, '0044362', NULL, NULL, 122, NULL, 'ADC-like', 286472),
(478429, '0042709', NULL, NULL, 86, NULL, 'ADC-like', 286472),
(478430, '0053128', NULL, NULL, 151, NULL, 'ADC-like', 286472),
(478431, '0041851', NULL, NULL, 120, NULL, 'ADC-like', 286472),
(478432, '0036122', NULL, NULL, 82, NULL, 'ADC-like', 286472),
(478433, '0048798', NULL, NULL, 118, NULL, 'ADC-like', 286472),
(478434, '0042560', NULL, NULL, 170, NULL, 'ADC-like', 286472),
(478435, '0049634', NULL, NULL, 147, NULL, 'ADC-like', 286472),
(478436, '0046942', NULL, NULL, 143, NULL, 'ADC-like', 286472),
(478437, '0046237', NULL, NULL, 91, NULL, 'ADC-like', 286472),
(478438, '0047857', NULL, NULL, 165, NULL, 'ADC-like', 286472),
(478439, '0046625', NULL, NULL, 155, NULL, 'ADC-like', 286472),
(478440, '0049658', NULL, NULL, 167, NULL, 'ADC-like', 286472),
(478441, '0044985', NULL, NULL, 87, NULL, 'ADC-like', 286472),
(478442, '0048375', NULL, NULL, 426, NULL, 'C-terminal (heme d1) domain of cytochrome cd1-nitrite reductase', 286473),
(478443, '0048978', NULL, NULL, 432, NULL, 'C-terminal (heme d1) domain of cytochrome cd1-nitrite reductase', 286473),
(478444, '0048456', NULL, NULL, 168, NULL, 'Peptide methionine sulfoxide reductase', 286474),
(478445, '0046766', NULL, NULL, 211, NULL, 'Peptide methionine sulfoxide reductase', 286474),
(478446, '0046864', NULL, NULL, 192, NULL, 'Peptide methionine sulfoxide reductase', 286474),
(478447, '0047728', NULL, NULL, 124, NULL, 'gp5 N-terminal domain-like', 286475),
(478448, '0054462', NULL, NULL, 91, NULL, 'gp5 N-terminal domain-like', 286475),
(478449, '0051781', NULL, NULL, 170, NULL, 'FucI/AraA C-terminal domain-like', 286476),
(478450, '0046863', NULL, NULL, 236, NULL, 'FucI/AraA C-terminal domain-like', 286476),
(478451, '0049286', NULL, NULL, 123, NULL, 'Peptidyl-tRNA hydrolase II', 286477),
(478452, '0042649', NULL, NULL, 117, NULL, 'Peptidyl-tRNA hydrolase II', 286477),
(478453, '0043300', NULL, NULL, 116, NULL, 'Peptidyl-tRNA hydrolase II', 286477),
(478454, '0053943', NULL, NULL, 135, NULL, 'Peptidyl-tRNA hydrolase II', 286477),
(478455, '0051596', NULL, NULL, 282, NULL, 'SGNH hydrolase', 286478),
(478456, '0046880', NULL, NULL, 212, NULL, 'SGNH hydrolase', 286478),
(478457, '0037646', NULL, NULL, 272, NULL, 'SGNH hydrolase', 286478),
(478458, '0054927', NULL, NULL, 207, NULL, 'SGNH hydrolase', 286478),
(478459, '0036388', NULL, NULL, 233, NULL, 'SGNH hydrolase', 286478),
(478460, '0050207', NULL, NULL, 201, NULL, 'SGNH hydrolase', 286478),
(478461, '0054858', NULL, NULL, 248, NULL, 'SGNH hydrolase', 286478),
(478462, '0051447', NULL, NULL, 195, NULL, 'SGNH hydrolase', 286478),
(478463, '0054315', NULL, NULL, 208, NULL, 'SGNH hydrolase', 286478);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(478464, '0046616', NULL, NULL, 212, NULL, 'SGNH hydrolase', 286478),
(478465, '0051808', NULL, NULL, 244, NULL, 'SGNH hydrolase', 286478),
(478466, '0046617', NULL, NULL, 302, NULL, 'SGNH hydrolase', 286478),
(478467, '0054061', NULL, NULL, 211, NULL, 'SGNH hydrolase', 286478),
(478468, '0047668', NULL, NULL, 179, NULL, 'SGNH hydrolase', 286478),
(478469, '0037232', NULL, NULL, 120, NULL, 'DNA repair protein MutS, domain I', 286479),
(478470, '0036750', NULL, NULL, 115, NULL, 'DNA repair protein MutS, domain I', 286479),
(478471, '0042713', NULL, NULL, 163, NULL, 'N5-CAIR mutase (phosphoribosylaminoimidazole carboxylase, PurE)', 286480),
(478472, '0048487', NULL, NULL, 169, NULL, 'N5-CAIR mutase (phosphoribosylaminoimidazole carboxylase, PurE)', 286480),
(478473, '0044185', NULL, NULL, 159, NULL, 'N5-CAIR mutase (phosphoribosylaminoimidazole carboxylase, PurE)', 286480),
(478474, '0051027', NULL, NULL, 155, NULL, 'N5-CAIR mutase (phosphoribosylaminoimidazole carboxylase, PurE)', 286480),
(478475, '0048086', NULL, NULL, 206, NULL, 'Cystine-knot cytokines', 286481),
(478476, '0050684', NULL, NULL, 96, NULL, 'Cystine-knot cytokines', 286481),
(478477, '0050683', NULL, NULL, 100, NULL, 'Cystine-knot cytokines', 286481),
(478478, '0035632', NULL, NULL, 109, NULL, 'Cystine-knot cytokines', 286481),
(478479, '0038527', NULL, NULL, 127, NULL, 'Cystine-knot cytokines', 286481),
(478480, '0037644', NULL, NULL, 107, NULL, 'Cystine-knot cytokines', 286481),
(478481, '0035633', NULL, NULL, 108, NULL, 'Cystine-knot cytokines', 286481),
(478482, '0037865', NULL, NULL, 100, NULL, 'Cystine-knot cytokines', 286481),
(478483, '0037154', NULL, NULL, 104, NULL, 'Cystine-knot cytokines', 286481),
(478484, '0045009', NULL, NULL, 114, NULL, 'Cystine-knot cytokines', 286481),
(478485, '0038531', NULL, NULL, 85, NULL, 'Cystine-knot cytokines', 286481),
(478486, '0040782', NULL, NULL, 112, NULL, 'Cystine-knot cytokines', 286481),
(478487, '0038532', NULL, NULL, 110, NULL, 'Cystine-knot cytokines', 286481),
(478488, '0039692', NULL, NULL, 121, NULL, 'Cystine-knot cytokines', 286481),
(478489, '0042265', NULL, NULL, 96, NULL, 'Cystine-knot cytokines', 286481),
(478490, '0035043', NULL, NULL, 97, NULL, 'Cystine-knot cytokines', 286481),
(478491, '0046809', NULL, NULL, 95, NULL, 'Cystine-knot cytokines', 286481),
(478492, '0047829', NULL, NULL, 112, NULL, 'Cystine-knot cytokines', 286481),
(478493, '0049623', NULL, NULL, 112, NULL, 'Cystine-knot cytokines', 286481),
(478494, '0045796', NULL, NULL, 175, NULL, 'Cystine-knot cytokines', 286481),
(478495, '0041636', NULL, NULL, 115, NULL, 'Cystine-knot cytokines', 286481),
(478496, '0045468', NULL, NULL, 112, NULL, 'Cystine-knot cytokines', 286481),
(478497, '0045943', NULL, NULL, 107, NULL, 'Cystine-knot cytokines', 286481),
(478498, '0054710', NULL, NULL, 131, NULL, 'Riboflavin kinase-like', 286482),
(478499, '0041165', NULL, NULL, 154, NULL, 'Riboflavin kinase-like', 286482),
(478500, '0054906', NULL, NULL, 131, NULL, 'Riboflavin kinase-like', 286482),
(478501, '0048215', NULL, NULL, 130, NULL, 'Riboflavin kinase-like', 286482),
(478502, '0042150', NULL, NULL, 147, NULL, 'Riboflavin kinase-like', 286482),
(478503, '0051320', NULL, NULL, 141, NULL, 'Nicotinate/Quinolinate PRTase N-terminal domain-like', 286483),
(478504, '0042921', NULL, NULL, 115, NULL, 'Nicotinate/Quinolinate PRTase N-terminal domain-like', 286483),
(478505, '0051267', NULL, NULL, 160, NULL, 'Nicotinate/Quinolinate PRTase N-terminal domain-like', 286483),
(478506, '0053068', NULL, NULL, 110, NULL, 'Nicotinate/Quinolinate PRTase N-terminal domain-like', 286483),
(478507, '0050243', NULL, NULL, 149, NULL, 'Nicotinate/Quinolinate PRTase N-terminal domain-like', 286483),
(478508, '0048486', NULL, NULL, 103, NULL, 'Nicotinate/Quinolinate PRTase N-terminal domain-like', 286483),
(478509, '0051404', NULL, NULL, 119, NULL, 'Nicotinate/Quinolinate PRTase N-terminal domain-like', 286483),
(478510, '0052614', NULL, NULL, 137, NULL, 'Nicotinate/Quinolinate PRTase N-terminal domain-like', 286483),
(478511, '0042684', NULL, NULL, 122, NULL, 'Nicotinate/Quinolinate PRTase N-terminal domain-like', 286483); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(478512, '0050396', NULL, NULL, 132, NULL, 'TK C-terminal domain-like', 286484),
(478513, '0042966', NULL, NULL, 134, NULL, 'TK C-terminal domain-like', 286484),
(478514, '0035298', NULL, NULL, 157, NULL, 'TK C-terminal domain-like', 286484),
(478515, '0039199', NULL, NULL, 136, NULL, 'TK C-terminal domain-like', 286484),
(478516, '0039060', NULL, NULL, 135, NULL, 'TK C-terminal domain-like', 286484),
(478517, '0044441', NULL, NULL, 137, NULL, 'TK C-terminal domain-like', 286484),
(478518, '0036598', NULL, NULL, 138, NULL, 'TK C-terminal domain-like', 286484),
(478519, '0049137', NULL, NULL, 143, NULL, 'TK C-terminal domain-like', 286484),
(478520, '0040414', NULL, NULL, 186, NULL, 'TK C-terminal domain-like', 286484),
(478521, '0041404', NULL, NULL, 138, NULL, 'TK C-terminal domain-like', 286484),
(478522, '0044103', NULL, NULL, 146, NULL, 'TK C-terminal domain-like', 286484),
(478523, '0042763', NULL, NULL, 136, NULL, 'TK C-terminal domain-like', 286484),
(478524, '0041591', NULL, NULL, 481, NULL, 'Ras GEF', 286485),
(478525, '0053778', NULL, NULL, 105, NULL, 'ATP synthase B chain-like', 286486),
(478526, '0052333', NULL, NULL, 299, NULL, 'Ferritin-like', 286487),
(478527, '0054357', NULL, NULL, 222, NULL, 'Ferritin-like', 286487),
(478528, '0040908', NULL, NULL, 171, NULL, 'Ferritin-like', 286487),
(478529, '0054155', NULL, NULL, 199, NULL, 'Ferritin-like', 286487),
(478530, '0048157', NULL, NULL, 383, NULL, 'Ferritin-like', 286487),
(478531, '0048355', NULL, NULL, 169, NULL, 'Ferritin-like', 286487),
(478532, '0047582', NULL, NULL, 160, NULL, 'Ferritin-like', 286487),
(478533, '0048397', NULL, NULL, 133, NULL, 'Ferritin-like', 286487),
(478534, '0043064', NULL, NULL, 171, NULL, 'Ferritin-like', 286487),
(478535, '0052977', NULL, NULL, 160, NULL, 'Ferritin-like', 286487),
(478536, '0039557', NULL, NULL, 144, NULL, 'Ferritin-like', 286487),
(478537, '0052811', NULL, NULL, 158, NULL, 'Ferritin-like', 286487),
(478538, '0039558', NULL, NULL, 142, NULL, 'Ferritin-like', 286487),
(478539, '0051644', NULL, NULL, 168, NULL, 'Ferritin-like', 286487),
(478540, '0047148', NULL, NULL, 180, NULL, 'Ferritin-like', 286487),
(478541, '0046379', NULL, NULL, 159, NULL, 'Ferritin-like', 286487),
(478542, '0048950', NULL, NULL, 150, NULL, 'Ferritin-like', 286487),
(478543, '0047502', NULL, NULL, 141, NULL, 'Ferritin-like', 286487),
(478544, '0048201', NULL, NULL, 180, NULL, 'Ferritin-like', 286487),
(478545, '0043194', NULL, NULL, 171, NULL, 'Ferritin-like', 286487),
(478546, '0054123', NULL, NULL, 142, NULL, 'Ferritin-like', 286487),
(478547, '0045770', NULL, NULL, 345, NULL, 'Ferritin-like', 286487),
(478548, '0047593', NULL, NULL, 146, NULL, 'Ferritin-like', 286487),
(478549, '0049497', NULL, NULL, 317, NULL, 'Ferritin-like', 286487),
(478550, '0050162', NULL, NULL, 163, NULL, 'Ferritin-like', 286487),
(478551, '0049090', NULL, NULL, 283, NULL, 'Ferritin-like', 286487),
(478552, '0051415', NULL, NULL, 166, NULL, 'Ferritin-like', 286487),
(478553, '0051533', NULL, NULL, 267, NULL, 'Ferritin-like', 286487),
(478554, '0052941', NULL, NULL, 159, NULL, 'Ferritin-like', 286487),
(478555, '0051609', NULL, NULL, 91, NULL, 'Ferritin-like', 286487),
(478556, '0035460', NULL, NULL, 158, NULL, 'Ferritin-like', 286487),
(478557, '0048645', NULL, NULL, 244, NULL, 'Ferritin-like', 286487),
(478558, '0048525', NULL, NULL, 162, NULL, 'Ferritin-like', 286487),
(478559, '0052156', NULL, NULL, 172, NULL, 'Ferritin-like', 286487),
(478560, '0036622', NULL, NULL, 147, NULL, 'Ferritin-like', 286487),
(478561, '0050978', NULL, NULL, 340, NULL, 'Ferritin-like', 286487),
(478562, '0051506', NULL, NULL, 191, NULL, 'Ferritin-like', 286487),
(478563, '0051505', NULL, NULL, 200, NULL, 'Ferritin-like', 286487),
(478564, '0052712', NULL, NULL, 154, NULL, 'Ferritin-like', 286487),
(478565, '0050214', NULL, NULL, 149, NULL, 'Ferritin-like', 286487),
(478566, '0037194', NULL, NULL, 161, NULL, 'Ferritin-like', 286487),
(478567, '0047609', NULL, NULL, 334, NULL, 'Ferritin-like', 286487),
(478568, '0052707', NULL, NULL, 151, NULL, 'Ferritin-like', 286487);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(478569, '0049426', NULL, NULL, 323, NULL, 'Ferritin-like', 286487),
(478570, '0054372', NULL, NULL, 152, NULL, 'Ferritin-like', 286487),
(478571, '0049309', NULL, NULL, 162, NULL, 'Ferritin-like', 286487),
(478572, '0044579', NULL, NULL, 282, NULL, 'Ferritin-like', 286487),
(478573, '0047097', NULL, NULL, 288, NULL, 'Ferritin-like', 286487),
(478574, '0051154', NULL, NULL, 170, NULL, 'Ferritin-like', 286487),
(478575, '0048222', NULL, NULL, 512, NULL, 'Ferritin-like', 286487),
(478576, '0049510', NULL, NULL, 491, NULL, 'Ferritin-like', 286487),
(478577, '0040938', NULL, NULL, 510, NULL, 'Ferritin-like', 286487),
(478578, '0048264', NULL, NULL, 149, NULL, 'Ferritin-like', 286487),
(478579, '0044868', NULL, NULL, 164, NULL, 'Ferritin-like', 286487),
(478580, '0045957', NULL, NULL, 173, NULL, 'Ferritin-like', 286487),
(478581, '0041078', NULL, NULL, 384, NULL, 'Ferritin-like', 286487),
(478582, '0051629', NULL, NULL, 171, NULL, 'Ferritin-like', 286487),
(478583, '0049511', NULL, NULL, 322, NULL, 'Ferritin-like', 286487),
(478584, '0049951', NULL, NULL, 151, NULL, 'Ferritin-like', 286487),
(478585, '0040226', NULL, NULL, 165, NULL, 'Ferritin-like', 286487),
(478586, '0047612', NULL, NULL, 266, NULL, 'Ferritin-like', 286487),
(478587, '0048625', NULL, NULL, 328, NULL, 'Ferritin-like', 286487),
(478588, '0051059', NULL, NULL, 170, NULL, 'Hypothetical protein PA1324', 286488),
(478589, '0052907', NULL, NULL, 421, NULL, 'Rhabdovirus nucleoprotein-like', 286489),
(478590, '0052957', NULL, NULL, 443, NULL, 'Rhabdovirus nucleoprotein-like', 286489),
(478591, '0041355', NULL, NULL, 324, NULL, 'GTPase activation domain, GAP', 286490),
(478592, '0050892', NULL, NULL, 196, NULL, 'GTPase activation domain, GAP', 286490),
(478593, '0042243', NULL, NULL, 184, NULL, 'GTPase activation domain, GAP', 286490),
(478594, '0037426', NULL, NULL, 191, NULL, 'GTPase activation domain, GAP', 286490),
(478595, '0044971', NULL, NULL, 324, NULL, 'GTPase activation domain, GAP', 286490),
(478596, '0044148', NULL, NULL, 196, NULL, 'GTPase activation domain, GAP', 286490),
(478597, '0053494', NULL, NULL, 75, NULL, 'Dimerization motif of sir4', 286491),
(478598, '0041709', NULL, NULL, 232, NULL, 'Herpes virus serine proteinase, assemblin', 286492),
(478599, '0044926', NULL, NULL, 211, NULL, 'Herpes virus serine proteinase, assemblin', 286492),
(478600, '0037642', NULL, NULL, 229, NULL, 'Herpes virus serine proteinase, assemblin', 286492),
(478601, '0035190', NULL, NULL, 231, NULL, 'Herpes virus serine proteinase, assemblin', 286492),
(478602, '0045005', NULL, NULL, 248, NULL, 'Herpes virus serine proteinase, assemblin', 286492),
(478603, '0048581', NULL, NULL, 136, NULL, 'Sensory domain-like', 286493),
(478604, '0054475', NULL, NULL, 172, NULL, 'Sensory domain-like', 286493),
(478605, '0051947', NULL, NULL, 145, NULL, 'Sensory domain-like', 286493),
(478606, '0054474', NULL, NULL, 93, NULL, 'Sensory domain-like', 286493),
(478607, '0054044', NULL, NULL, 219, NULL, 'Sensory domain-like', 286493),
(478608, '0048676', NULL, NULL, 131, NULL, 'Sensory domain-like', 286493),
(478609, '0046644', NULL, NULL, 214, NULL, 'Beta-D-glucan exohydrolase, C-terminal domain', 286494),
(478610, '0048872', NULL, NULL, 229, NULL, 'LuxS/MPP-like metallohydrolase', 286495),
(478611, '0045925', NULL, NULL, 229, NULL, 'LuxS/MPP-like metallohydrolase', 286495),
(478612, '0038685', NULL, NULL, 222, NULL, 'LuxS/MPP-like metallohydrolase', 286495),
(478613, '0045927', NULL, NULL, 218, NULL, 'LuxS/MPP-like metallohydrolase', 286495),
(478614, '0039395', NULL, NULL, 151, NULL, 'LuxS/MPP-like metallohydrolase', 286495),
(478615, '0045926', NULL, NULL, 213, NULL, 'LuxS/MPP-like metallohydrolase', 286495),
(478616, '0035451', NULL, NULL, 204, NULL, 'LuxS/MPP-like metallohydrolase', 286495),
(478617, '0039394', NULL, NULL, 161, NULL, 'LuxS/MPP-like metallohydrolase', 286495),
(478618, '0047225', NULL, NULL, 237, NULL, 'LuxS/MPP-like metallohydrolase', 286495),
(478619, '0039094', NULL, NULL, 151, NULL, 'LuxS/MPP-like metallohydrolase', 286495),
(478620, '0048875', NULL, NULL, 240, NULL, 'LuxS/MPP-like metallohydrolase', 286495);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(478621, '0047226', NULL, NULL, 217, NULL, 'LuxS/MPP-like metallohydrolase', 286495),
(478622, '0048873', NULL, NULL, 228, NULL, 'LuxS/MPP-like metallohydrolase', 286495),
(478623, '0047224', NULL, NULL, 220, NULL, 'LuxS/MPP-like metallohydrolase', 286495),
(478624, '0048874', NULL, NULL, 240, NULL, 'LuxS/MPP-like metallohydrolase', 286495),
(478625, '0052685', NULL, NULL, 196, NULL, 'LuxS/MPP-like metallohydrolase', 286495),
(478626, '0052686', NULL, NULL, 268, NULL, 'LuxS/MPP-like metallohydrolase', 286495),
(478627, '0052684', NULL, NULL, 258, NULL, 'LuxS/MPP-like metallohydrolase', 286495),
(478628, '0046661', NULL, NULL, 202, NULL, 'LuxS/MPP-like metallohydrolase', 286495),
(478629, '0046660', NULL, NULL, 217, NULL, 'LuxS/MPP-like metallohydrolase', 286495),
(478630, '0039429', NULL, NULL, 154, NULL, 'LuxS/MPP-like metallohydrolase', 286495),
(478631, '0035487', NULL, NULL, 215, NULL, 'LuxS/MPP-like metallohydrolase', 286495),
(478632, '0052687', NULL, NULL, 257, NULL, 'LuxS/MPP-like metallohydrolase', 286495),
(478633, '0037288', NULL, NULL, 150, NULL, 'LuxS/MPP-like metallohydrolase', 286495),
(478634, '0035485', NULL, NULL, 233, NULL, 'LuxS/MPP-like metallohydrolase', 286495),
(478635, '0045938', NULL, NULL, 204, NULL, 'LuxS/MPP-like metallohydrolase', 286495),
(478636, '0045937', NULL, NULL, 213, NULL, 'LuxS/MPP-like metallohydrolase', 286495),
(478637, '0037285', NULL, NULL, 213, NULL, 'LuxS/MPP-like metallohydrolase', 286495),
(478638, '0051641', NULL, NULL, 60, NULL, 'Homeodomain-like', 286496),
(478639, '0052177', NULL, NULL, 63, NULL, 'Homeodomain-like', 286496),
(478640, '0048195', NULL, NULL, 77, NULL, 'Homeodomain-like', 286496),
(478641, '0050954', NULL, NULL, 63, NULL, 'Homeodomain-like', 286496),
(478642, '0051803', NULL, NULL, 120, NULL, 'Homeodomain-like', 286496),
(478643, '0052856', NULL, NULL, 102, NULL, 'Homeodomain-like', 286496),
(478644, '0050796', NULL, NULL, 47, NULL, 'Homeodomain-like', 286496),
(478645, '0037176', NULL, NULL, 98, NULL, 'Homeodomain-like', 286496),
(478646, '0045889', NULL, NULL, 88, NULL, 'Homeodomain-like', 286496),
(478647, '0047429', NULL, NULL, 64, NULL, 'Homeodomain-like', 286496),
(478648, '0039196', NULL, NULL, 67, NULL, 'Homeodomain-like', 286496),
(478649, '0054072', NULL, NULL, 75, NULL, 'Homeodomain-like', 286496),
(478650, '0052741', NULL, NULL, 85, NULL, 'Homeodomain-like', 286496),
(478651, '0036751', NULL, NULL, 57, NULL, 'Homeodomain-like', 286496),
(478652, '0038534', NULL, NULL, 52, NULL, 'Homeodomain-like', 286496),
(478653, '0052742', NULL, NULL, 69, NULL, 'Homeodomain-like', 286496),
(478654, '0046907', NULL, NULL, 61, NULL, 'Homeodomain-like', 286496),
(478655, '0047677', NULL, NULL, 71, NULL, 'Homeodomain-like', 286496),
(478656, '0040923', NULL, NULL, 55, NULL, 'Homeodomain-like', 286496),
(478657, '0049336', NULL, NULL, 50, NULL, 'Homeodomain-like', 286496),
(478658, '0047439', NULL, NULL, 78, NULL, 'Homeodomain-like', 286496),
(478659, '0045778', NULL, NULL, 68, NULL, 'Homeodomain-like', 286496),
(478660, '0053202', NULL, NULL, 65, NULL, 'Homeodomain-like', 286496),
(478661, '0050573', NULL, NULL, 71, NULL, 'Homeodomain-like', 286496),
(478662, '0045264', NULL, NULL, 75, NULL, 'Homeodomain-like', 286496),
(478663, '0054374', NULL, NULL, 79, NULL, 'Homeodomain-like', 286496),
(478664, '0047440', NULL, NULL, 66, NULL, 'Homeodomain-like', 286496),
(478665, '0052877', NULL, NULL, 70, NULL, 'Homeodomain-like', 286496),
(478666, '0053204', NULL, NULL, 69, NULL, 'Homeodomain-like', 286496),
(478667, '0049907', NULL, NULL, 72, NULL, 'Homeodomain-like', 286496),
(478668, '0048818', NULL, NULL, 77, NULL, 'Homeodomain-like', 286496),
(478669, '0047203', NULL, NULL, 65, NULL, 'Homeodomain-like', 286496),
(478670, '0052194', NULL, NULL, 63, NULL, 'Homeodomain-like', 286496),
(478671, '0047202', NULL, NULL, 66, NULL, 'Homeodomain-like', 286496),
(478672, '0048379', NULL, NULL, 77, NULL, 'Homeodomain-like', 286496),
(478673, '0045820', NULL, NULL, 58, NULL, 'Homeodomain-like', 286496),
(478674, '0054027', NULL, NULL, 56, NULL, 'Homeodomain-like', 286496); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(478675, '0053698', NULL, NULL, 97, NULL, 'Homeodomain-like', 286496),
(478676, '0047051', NULL, NULL, 63, NULL, 'Homeodomain-like', 286496),
(478677, '0049195', NULL, NULL, 81, NULL, 'Homeodomain-like', 286496),
(478678, '0050188', NULL, NULL, 72, NULL, 'Homeodomain-like', 286496),
(478679, '0053176', NULL, NULL, 100, NULL, 'Homeodomain-like', 286496),
(478680, '0047970', NULL, NULL, 82, NULL, 'Homeodomain-like', 286496),
(478681, '0048540', NULL, NULL, 67, NULL, 'Homeodomain-like', 286496),
(478682, '0052647', NULL, NULL, 79, NULL, 'Homeodomain-like', 286496),
(478683, '0049590', NULL, NULL, 51, NULL, 'Homeodomain-like', 286496),
(478684, '0052249', NULL, NULL, 59, NULL, 'Homeodomain-like', 286496),
(478685, '0052885', NULL, NULL, 77, NULL, 'Homeodomain-like', 286496),
(478686, '0038474', NULL, NULL, 57, NULL, 'Homeodomain-like', 286496),
(478687, '0046802', NULL, NULL, 65, NULL, 'Homeodomain-like', 286496),
(478688, '0038473', NULL, NULL, 55, NULL, 'Homeodomain-like', 286496),
(478689, '0049910', NULL, NULL, 71, NULL, 'Homeodomain-like', 286496),
(478690, '0047179', NULL, NULL, 63, NULL, 'Homeodomain-like', 286496),
(478691, '0049236', NULL, NULL, 94, NULL, 'Homeodomain-like', 286496),
(478692, '0046765', NULL, NULL, 59, NULL, 'Homeodomain-like', 286496),
(478693, '0047064', NULL, NULL, 50, NULL, 'Homeodomain-like', 286496),
(478694, '0052257', NULL, NULL, 58, NULL, 'Homeodomain-like', 286496),
(478695, '0050079', NULL, NULL, 74, NULL, 'Homeodomain-like', 286496),
(478696, '0052496', NULL, NULL, 76, NULL, 'Homeodomain-like', 286496),
(478697, '0054157', NULL, NULL, 71, NULL, 'Homeodomain-like', 286496),
(478698, '0052252', NULL, NULL, 59, NULL, 'Homeodomain-like', 286496),
(478699, '0052250', NULL, NULL, 60, NULL, 'Homeodomain-like', 286496),
(478700, '0047583', NULL, NULL, 57, NULL, 'Homeodomain-like', 286496),
(478701, '0052493', NULL, NULL, 57, NULL, 'Homeodomain-like', 286496),
(478702, '0053065', NULL, NULL, 69, NULL, 'Homeodomain-like', 286496),
(478703, '0037778', NULL, NULL, 70, NULL, 'Homeodomain-like', 286496),
(478704, '0035079', NULL, NULL, 78, NULL, 'Homeodomain-like', 286496),
(478705, '0038986', NULL, NULL, 54, NULL, 'Homeodomain-like', 286496),
(478706, '0037777', NULL, NULL, 68, NULL, 'Homeodomain-like', 286496),
(478707, '0051446', NULL, NULL, 60, NULL, 'Homeodomain-like', 286496),
(478708, '0052655', NULL, NULL, 76, NULL, 'Homeodomain-like', 286496),
(478709, '0045724', NULL, NULL, 66, NULL, 'Homeodomain-like', 286496),
(478710, '0036286', NULL, NULL, 54, NULL, 'Homeodomain-like', 286496),
(478711, '0049809', NULL, NULL, 50, NULL, 'Homeodomain-like', 286496),
(478712, '0049523', NULL, NULL, 88, NULL, 'Homeodomain-like', 286496),
(478713, '0048555', NULL, NULL, 128, NULL, 'Homeodomain-like', 286496),
(478714, '0049891', NULL, NULL, 95, NULL, 'Homeodomain-like', 286496),
(478715, '0053235', NULL, NULL, 66, NULL, 'Homeodomain-like', 286496),
(478716, '0048162', NULL, NULL, 152, NULL, 'Homeodomain-like', 286496),
(478717, '0054048', NULL, NULL, 70, NULL, 'Homeodomain-like', 286496),
(478718, '0048440', NULL, NULL, 91, NULL, 'Homeodomain-like', 286496),
(478719, '0052261', NULL, NULL, 57, NULL, 'Homeodomain-like', 286496),
(478720, '0052308', NULL, NULL, 68, NULL, 'Homeodomain-like', 286496),
(478721, '0052309', NULL, NULL, 82, NULL, 'Homeodomain-like', 286496),
(478722, '0051615', NULL, NULL, 67, NULL, 'Homeodomain-like', 286496),
(478723, '0052305', NULL, NULL, 65, NULL, 'Homeodomain-like', 286496),
(478724, '0053878', NULL, NULL, 76, NULL, 'Homeodomain-like', 286496),
(478725, '0054327', NULL, NULL, 83, NULL, 'Homeodomain-like', 286496),
(478726, '0045977', NULL, NULL, 62, NULL, 'Homeodomain-like', 286496),
(478727, '0039940', NULL, NULL, 61, NULL, 'Homeodomain-like', 286496),
(478728, '0050913', NULL, NULL, 68, NULL, 'Homeodomain-like', 286496),
(478729, '0046025', NULL, NULL, 66, NULL, 'Homeodomain-like', 286496),
(478730, '0047358', NULL, NULL, 58, NULL, 'Homeodomain-like', 286496),
(478731, '0048725', NULL, NULL, 72, NULL, 'Homeodomain-like', 286496),
(478732, '0046702', NULL, NULL, 61, NULL, 'Homeodomain-like', 286496);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(478733, '0047361', NULL, NULL, 86, NULL, 'Homeodomain-like', 286496),
(478734, '0052312', NULL, NULL, 101, NULL, 'Homeodomain-like', 286496),
(478735, '0052551', NULL, NULL, 99, NULL, 'Homeodomain-like', 286496),
(478736, '0053365', NULL, NULL, 68, NULL, 'Homeodomain-like', 286496),
(478737, '0051585', NULL, NULL, 72, NULL, 'Homeodomain-like', 286496),
(478738, '0053366', NULL, NULL, 65, NULL, 'Homeodomain-like', 286496),
(478739, '0039939', NULL, NULL, 63, NULL, 'Homeodomain-like', 286496),
(478740, '0052393', NULL, NULL, 68, NULL, 'Homeodomain-like', 286496),
(478741, '0046275', NULL, NULL, 65, NULL, 'Homeodomain-like', 286496),
(478742, '0050538', NULL, NULL, 73, NULL, 'Homeodomain-like', 286496),
(478743, '0034887', NULL, NULL, 55, NULL, 'Homeodomain-like', 286496),
(478744, '0051466', NULL, NULL, 68, NULL, 'Homeodomain-like', 286496),
(478745, '0052830', NULL, NULL, 72, NULL, 'Homeodomain-like', 286496),
(478746, '0034886', NULL, NULL, 55, NULL, 'Homeodomain-like', 286496),
(478747, '0052798', NULL, NULL, 73, NULL, 'Homeodomain-like', 286496),
(478748, '0045901', NULL, NULL, 58, NULL, 'Homeodomain-like', 286496),
(478749, '0045900', NULL, NULL, 73, NULL, 'Homeodomain-like', 286496),
(478750, '0039012', NULL, NULL, 149, NULL, 'Homeodomain-like', 286496),
(478751, '0046399', NULL, NULL, 64, NULL, 'Homeodomain-like', 286496),
(478752, '0041825', NULL, NULL, 52, NULL, 'Homeodomain-like', 286496),
(478753, '0049545', NULL, NULL, 73, NULL, 'Homeodomain-like', 286496),
(478754, '0035607', NULL, NULL, 54, NULL, 'Homeodomain-like', 286496),
(478755, '0050781', NULL, NULL, 62, NULL, 'Homeodomain-like', 286496),
(478756, '0050780', NULL, NULL, 52, NULL, 'Homeodomain-like', 286496),
(478757, '0054226', NULL, NULL, 89, NULL, 'Homeodomain-like', 286496),
(478758, '0052200', NULL, NULL, 111, NULL, 'Homeodomain-like', 286496),
(478759, '0053132', NULL, NULL, 65, NULL, 'Homeodomain-like', 286496),
(478760, '0054860', NULL, NULL, 75, NULL, 'Homeodomain-like', 286496),
(478761, '0054341', NULL, NULL, 78, NULL, 'Homeodomain-like', 286496),
(478762, '0050547', NULL, NULL, 80, NULL, 'Homeodomain-like', 286496),
(478763, '0051514', NULL, NULL, 75, NULL, 'Homeodomain-like', 286496),
(478764, '0052848', NULL, NULL, 74, NULL, 'Homeodomain-like', 286496),
(478765, '0050824', NULL, NULL, 49, NULL, 'Homeodomain-like', 286496),
(478766, '0052845', NULL, NULL, 68, NULL, 'Homeodomain-like', 286496),
(478767, '0049392', NULL, NULL, 73, NULL, 'Homeodomain-like', 286496),
(478768, '0052843', NULL, NULL, 65, NULL, 'Homeodomain-like', 286496),
(478769, '0050545', NULL, NULL, 80, NULL, 'Homeodomain-like', 286496),
(478770, '0053777', NULL, NULL, 83, NULL, 'Homeodomain-like', 286496),
(478771, '0053096', NULL, NULL, 68, NULL, 'Homeodomain-like', 286496),
(478772, '0049952', NULL, NULL, 60, NULL, 'Homeodomain-like', 286496),
(478773, '0048742', NULL, NULL, 123, NULL, 'Homeodomain-like', 286496),
(478774, '0046966', NULL, NULL, 43, NULL, 'Homeodomain-like', 286496),
(478775, '0052185', NULL, NULL, 78, NULL, '''SARS ORF9b-like', 286497),
(478776, '0039486', NULL, NULL, 208, NULL, 'YrdC/RibB', 286498),
(478777, '0038693', NULL, NULL, 186, NULL, 'YrdC/RibB', 286498),
(478778, '0039907', NULL, NULL, 216, NULL, 'YrdC/RibB', 286498),
(478779, '0037940', NULL, NULL, 209, NULL, 'YrdC/RibB', 286498),
(478780, '0044038', NULL, NULL, 202, NULL, 'YrdC/RibB', 286498),
(478781, '0039944', NULL, NULL, 206, NULL, 'YrdC/RibB', 286498),
(478782, '0042499', NULL, NULL, 219, NULL, 'YrdC/RibB', 286498),
(478783, '0049618', NULL, NULL, 97, NULL, 'Beta-galactosidase LacA, domain 3', 286499),
(478784, '0054578', NULL, NULL, 127, NULL, 'Ricin B-like lectins', 286500),
(478785, '0049064', NULL, NULL, 138, NULL, 'Ricin B-like lectins', 286500),
(478786, '0049063', NULL, NULL, 145, NULL, 'Ricin B-like lectins', 286500),
(478787, '0049283', NULL, NULL, 127, NULL, 'Ricin B-like lectins', 286500),
(478788, '0054136', NULL, NULL, 154, NULL, 'Ricin B-like lectins', 286500),
(478789, '0049282', NULL, NULL, 135, NULL, 'Ricin B-like lectins', 286500),
(478790, '0034987', NULL, NULL, 127, NULL, 'Ricin B-like lectins', 286500);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(478791, '0048070', NULL, NULL, 136, NULL, 'Ricin B-like lectins', 286500),
(478792, '0050137', NULL, NULL, 133, NULL, 'Ricin B-like lectins', 286500),
(478793, '0054579', NULL, NULL, 134, NULL, 'Ricin B-like lectins', 286500),
(478794, '0046979', NULL, NULL, 126, NULL, 'Ricin B-like lectins', 286500),
(478795, '0040751', NULL, NULL, 126, NULL, 'Ricin B-like lectins', 286500),
(478796, '0050070', NULL, NULL, 133, NULL, 'Ricin B-like lectins', 286500),
(478797, '0044696', NULL, NULL, 150, NULL, 'Ricin B-like lectins', 286500),
(478798, '0046119', NULL, NULL, 122, NULL, 'Ricin B-like lectins', 286500),
(478799, '0049449', NULL, NULL, 167, NULL, 'Ricin B-like lectins', 286500),
(478800, '0047250', NULL, NULL, 133, NULL, 'Ricin B-like lectins', 286500),
(478801, '0049451', NULL, NULL, 154, NULL, 'Ricin B-like lectins', 286500),
(478802, '0049972', NULL, NULL, 131, NULL, 'Ricin B-like lectins', 286500),
(478803, '0046383', NULL, NULL, 134, NULL, 'Ricin B-like lectins', 286500),
(478804, '0046980', NULL, NULL, 128, NULL, 'Ricin B-like lectins', 286500),
(478805, '0052580', NULL, NULL, 154, NULL, 'Ricin B-like lectins', 286500),
(478806, '0051735', NULL, NULL, 127, NULL, 'Ricin B-like lectins', 286500),
(478807, '0051734', NULL, NULL, 135, NULL, 'Ricin B-like lectins', 286500),
(478808, '0038759', NULL, NULL, 131, NULL, 'Ricin B-like lectins', 286500),
(478809, '0054803', NULL, NULL, 130, NULL, 'Ricin B-like lectins', 286500),
(478810, '0047838', NULL, NULL, 129, NULL, 'Ricin B-like lectins', 286500),
(478811, '0048609', NULL, NULL, 126, NULL, 'Ricin B-like lectins', 286500),
(478812, '0050958', NULL, NULL, 131, NULL, 'Ricin B-like lectins', 286500),
(478813, '0048623', NULL, NULL, 137, NULL, 'Ricin B-like lectins', 286500),
(478814, '0048824', NULL, NULL, 125, NULL, 'Ricin B-like lectins', 286500),
(478815, '0048624', NULL, NULL, 126, NULL, 'Ricin B-like lectins', 286500),
(478816, '0045755', NULL, NULL, 140, NULL, 'Ricin B-like lectins', 286500),
(478817, '0049614', NULL, NULL, 122, NULL, 'Ricin B-like lectins', 286500),
(478818, '0053874', NULL, NULL, 58, NULL, 'PriA/YqbF domain', 286501),
(478819, '0054047', NULL, NULL, 49, NULL, 'PriA/YqbF domain', 286501),
(478820, '0053872', NULL, NULL, 87, NULL, 'PriA/YqbF domain', 286501),
(478821, '0053870', NULL, NULL, 61, NULL, 'PriA/YqbF domain', 286501),
(478822, '0054418', NULL, NULL, 67, NULL, 'PriA/YqbF domain', 286501),
(478823, '0054697', NULL, NULL, 190, NULL, 'Nitrite and sulphite reductase 4Fe-4S domain-like', 286502),
(478824, '0054873', NULL, NULL, 186, NULL, 'Nitrite and sulphite reductase 4Fe-4S domain-like', 286502),
(478825, '0053671', NULL, NULL, 149, NULL, 'Nitrite and sulphite reductase 4Fe-4S domain-like', 286502),
(478826, '0053672', NULL, NULL, 165, NULL, 'Nitrite and sulphite reductase 4Fe-4S domain-like', 286502),
(478827, '0053701', NULL, NULL, 126, NULL, 'Nitrite and sulphite reductase 4Fe-4S domain-like', 286502),
(478828, '0053702', NULL, NULL, 171, NULL, 'Nitrite and sulphite reductase 4Fe-4S domain-like', 286502),
(478829, '0035139', NULL, NULL, 145, NULL, 'Nitrite and sulphite reductase 4Fe-4S domain-like', 286502),
(478830, '0035138', NULL, NULL, 197, NULL, 'Nitrite and sulphite reductase 4Fe-4S domain-like', 286502),
(478831, '0054700', NULL, NULL, 178, NULL, 'Nitrite and sulphite reductase 4Fe-4S domain-like', 286502),
(478832, '0054876', NULL, NULL, 180, NULL, 'Nitrite and sulphite reductase 4Fe-4S domain-like', 286502),
(478833, '0051865', NULL, NULL, 101, NULL, 'E2F-DP heterodimerization region', 286503),
(478834, '0051864', NULL, NULL, 148, NULL, 'E2F-DP heterodimerization region', 286503),
(478835, '0054313', NULL, NULL, 247, NULL, 'NagB/RpiA/CoA transferase-like', 286504),
(478836, '0053682', NULL, NULL, 374, NULL, 'NagB/RpiA/CoA transferase-like', 286504),
(478837, '0048793', NULL, NULL, 317, NULL, 'NagB/RpiA/CoA transferase-like', 286504),
(478838, '0043918', NULL, NULL, 340, NULL, 'NagB/RpiA/CoA transferase-like', 286504),
(478839, '0054958', NULL, NULL, 255, NULL, 'NagB/RpiA/CoA transferase-like', 286504);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(478840, '0050636', NULL, NULL, 175, NULL, 'NagB/RpiA/CoA transferase-like', 286504),
(478841, '0052833', NULL, NULL, 175, NULL, 'NagB/RpiA/CoA transferase-like', 286504),
(478842, '0043889', NULL, NULL, 340, NULL, 'NagB/RpiA/CoA transferase-like', 286504),
(478843, '0044937', NULL, NULL, 403, NULL, 'NagB/RpiA/CoA transferase-like', 286504),
(478844, '0052827', NULL, NULL, 221, NULL, 'NagB/RpiA/CoA transferase-like', 286504),
(478845, '0052828', NULL, NULL, 274, NULL, 'NagB/RpiA/CoA transferase-like', 286504),
(478846, '0046311', NULL, NULL, 266, NULL, 'NagB/RpiA/CoA transferase-like', 286504),
(478847, '0048730', NULL, NULL, 220, NULL, 'NagB/RpiA/CoA transferase-like', 286504),
(478848, '0043684', NULL, NULL, 194, NULL, 'NagB/RpiA/CoA transferase-like', 286504),
(478849, '0043544', NULL, NULL, 164, NULL, 'NagB/RpiA/CoA transferase-like', 286504),
(478850, '0050123', NULL, NULL, 274, NULL, 'NagB/RpiA/CoA transferase-like', 286504),
(478851, '0051773', NULL, NULL, 247, NULL, 'NagB/RpiA/CoA transferase-like', 286504),
(478852, '0039928', NULL, NULL, 219, NULL, 'NagB/RpiA/CoA transferase-like', 286504),
(478853, '0040719', NULL, NULL, 148, NULL, 'NagB/RpiA/CoA transferase-like', 286504),
(478854, '0051074', NULL, NULL, 236, NULL, 'NagB/RpiA/CoA transferase-like', 286504),
(478855, '0048341', NULL, NULL, 281, NULL, 'NagB/RpiA/CoA transferase-like', 286504),
(478856, '0051075', NULL, NULL, 269, NULL, 'NagB/RpiA/CoA transferase-like', 286504),
(478857, '0053957', NULL, NULL, 262, NULL, 'NagB/RpiA/CoA transferase-like', 286504),
(478858, '0051774', NULL, NULL, 273, NULL, 'NagB/RpiA/CoA transferase-like', 286504),
(478859, '0054645', NULL, NULL, 258, NULL, 'NagB/RpiA/CoA transferase-like', 286504),
(478860, '0042405', NULL, NULL, 260, NULL, 'NagB/RpiA/CoA transferase-like', 286504),
(478861, '0040229', NULL, NULL, 147, NULL, 'NagB/RpiA/CoA transferase-like', 286504),
(478862, '0054380', NULL, NULL, 250, NULL, 'NagB/RpiA/CoA transferase-like', 286504),
(478863, '0040524', NULL, NULL, 150, NULL, 'NagB/RpiA/CoA transferase-like', 286504),
(478864, '0044389', NULL, NULL, 152, NULL, 'NagB/RpiA/CoA transferase-like', 286504),
(478865, '0040764', NULL, NULL, 222, NULL, 'NagB/RpiA/CoA transferase-like', 286504),
(478866, '0040763', NULL, NULL, 250, NULL, 'NagB/RpiA/CoA transferase-like', 286504),
(478867, '0046875', NULL, NULL, 107, NULL, 'Prefoldin', 286505),
(478868, '0037832', NULL, NULL, 133, NULL, 'Prefoldin', 286505),
(478869, '0047339', NULL, NULL, 74, NULL, 'YhbC-like, C-terminal domain', 286506),
(478870, '0041847', NULL, NULL, 261, NULL, 'Oxidoreductase molybdopterin-binding domain', 286507),
(478871, '0050934', NULL, NULL, 269, NULL, 'Oxidoreductase molybdopterin-binding domain', 286507),
(478872, '0043687', NULL, NULL, 250, NULL, 'Oxidoreductase molybdopterin-binding domain', 286507),
(478873, '0052389', NULL, NULL, 352, NULL, 'Glutaminase/Asparaginase', 286508),
(478874, '0035046', NULL, NULL, 331, NULL, 'Glutaminase/Asparaginase', 286508),
(478875, '0045006', NULL, NULL, 328, NULL, 'Glutaminase/Asparaginase', 286508),
(478876, '0045589', NULL, NULL, 326, NULL, 'Glutaminase/Asparaginase', 286508),
(478877, '0045600', NULL, NULL, 330, NULL, 'Glutaminase/Asparaginase', 286508),
(478878, '0038578', NULL, NULL, 324, NULL, 'Glutaminase/Asparaginase', 286508),
(478879, '0051611', NULL, NULL, 363, NULL, 'Glutaminase/Asparaginase', 286508),
(478880, '0054359', NULL, NULL, 336, NULL, 'Glutaminase/Asparaginase', 286508),
(478881, '0044294', NULL, NULL, 156, NULL, 'Obg GTP-binding protein N-terminal domain', 286509),
(478882, '0040587', NULL, NULL, 157, NULL, 'Obg GTP-binding protein N-terminal domain', 286509),
(478883, '0054334', NULL, NULL, 131, NULL, 'NMB0513-like', 286510),
(478884, '0052535', NULL, NULL, 189, NULL, 'DNA terminal protein', 286511),
(478885, '0053537', NULL, NULL, 78, NULL, 'Geminin coiled-coil domain', 286512),
(478886, '0053524', NULL, NULL, 61, NULL, 'Geminin coiled-coil domain', 286512),
(478887, '0049461', NULL, NULL, 51, NULL, 'Somatomedin B domain', 286513),
(478888, '0048927', NULL, NULL, 179, NULL, 'Formiminotransferase domain of formiminotransferase-cyclodeaminase.', 286514);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(478889, '0048928', NULL, NULL, 146, NULL, 'Formiminotransferase domain of formiminotransferase-cyclodeaminase.', 286514),
(478890, '0040175', NULL, NULL, 159, NULL, 'C-terminal autoproteolytic domain of nucleoporin nup98', 286515),
(478891, '0052955', NULL, NULL, 122, NULL, 'Extracellular hemoglobin linker subunit, receptor domain', 286516),
(478892, '0052953', NULL, NULL, 128, NULL, 'Extracellular hemoglobin linker subunit, receptor domain', 286516),
(478893, '0052951', NULL, NULL, 124, NULL, 'Extracellular hemoglobin linker subunit, receptor domain', 286516),
(478894, '0043352', NULL, NULL, 185, NULL, 'Bacterial fluorinating enzyme, N-terminal domain', 286517),
(478895, '0046380', NULL, NULL, 117, NULL, 'Tautomerase/MIF', 286518),
(478896, '0047185', NULL, NULL, 113, NULL, 'Tautomerase/MIF', 286518),
(478897, '0047087', NULL, NULL, 76, NULL, 'Tautomerase/MIF', 286518),
(478898, '0043460', NULL, NULL, 62, NULL, 'Tautomerase/MIF', 286518),
(478899, '0035587', NULL, NULL, 62, NULL, 'Tautomerase/MIF', 286518),
(478900, '0051736', NULL, NULL, 129, NULL, 'Tautomerase/MIF', 286518),
(478901, '0049293', NULL, NULL, 55, NULL, 'Tautomerase/MIF', 286518),
(478902, '0049829', NULL, NULL, 122, NULL, 'Tautomerase/MIF', 286518),
(478903, '0049917', NULL, NULL, 115, NULL, 'Tautomerase/MIF', 286518),
(478904, '0041123', NULL, NULL, 120, NULL, 'Tautomerase/MIF', 286518),
(478905, '0042022', NULL, NULL, 125, NULL, 'Tautomerase/MIF', 286518),
(478906, '0042021', NULL, NULL, 59, NULL, 'Tautomerase/MIF', 286518),
(478907, '0048148', NULL, NULL, 114, NULL, 'Tautomerase/MIF', 286518),
(478908, '0046964', NULL, NULL, 118, NULL, 'Tautomerase/MIF', 286518),
(478909, '0045192', NULL, NULL, 85, NULL, 'Neurophysin II', 286519),
(478910, '0040387', NULL, NULL, 92, NULL, 'Neurophysin II', 286519),
(478911, '0036957', NULL, NULL, 97, NULL, 'EF-Tu/eEF-1alpha/eIF2-gamma C-terminal domain', 286520),
(478912, '0046254', NULL, NULL, 103, NULL, 'EF-Tu/eEF-1alpha/eIF2-gamma C-terminal domain', 286520),
(478913, '0039671', NULL, NULL, 107, NULL, 'EF-Tu/eEF-1alpha/eIF2-gamma C-terminal domain', 286520),
(478914, '0051647', NULL, NULL, 105, NULL, 'EF-Tu/eEF-1alpha/eIF2-gamma C-terminal domain', 286520),
(478915, '0051768', NULL, NULL, 95, NULL, 'EF-Tu/eEF-1alpha/eIF2-gamma C-terminal domain', 286520),
(478916, '0043132', NULL, NULL, 68, NULL, 'EF-Tu/eEF-1alpha/eIF2-gamma C-terminal domain', 286520),
(478917, '0037406', NULL, NULL, 107, NULL, 'EF-Tu/eEF-1alpha/eIF2-gamma C-terminal domain', 286520),
(478918, '0050422', NULL, NULL, 116, NULL, 'EF-Tu/eEF-1alpha/eIF2-gamma C-terminal domain', 286520),
(478919, '0037247', NULL, NULL, 93, NULL, 'EF-Tu/eEF-1alpha/eIF2-gamma C-terminal domain', 286520),
(478920, '0047821', NULL, NULL, 89, NULL, 'EF-Tu/eEF-1alpha/eIF2-gamma C-terminal domain', 286520),
(478921, '0049291', NULL, NULL, 90, NULL, 'EF-Tu/eEF-1alpha/eIF2-gamma C-terminal domain', 286520),
(478922, '0043568', NULL, NULL, 112, NULL, 'Hypothetical protein YhaI', 286521),
(478923, '0054303', NULL, NULL, 61, NULL, 'AF2212/PG0164-like', 286522),
(478924, '0052412', NULL, NULL, 85, NULL, 'AF2212/PG0164-like', 286522),
(478925, '0037245', NULL, NULL, 79, NULL, 'DnaJ/Hsp40 cysteine-rich domain', 286523),
(478926, '0041451', NULL, NULL, 74, NULL, 'DnaJ/Hsp40 cysteine-rich domain', 286523),
(478927, '0053246', NULL, NULL, 105, NULL, 'Cytochrome c oxidase subunit E', 286524),
(478928, '0039714', NULL, NULL, 90, NULL, 'Anti-sigma factor AsiA', 286525),
(478929, '0051979', NULL, NULL, 233, NULL, 'Cell wall binding repeat', 286526),
(478930, '0047093', NULL, NULL, 149, NULL, 'Cell wall binding repeat', 286526),
(478931, '0038536', NULL, NULL, 127, NULL, 'Cell wall binding repeat', 286526),
(478932, '0035140', NULL, NULL, 395, NULL, 'Aldehyde ferredoxin oxidoreductase, C-terminal domains', 286527),
(478933, '0035314', NULL, NULL, 409, NULL, 'Aldehyde ferredoxin oxidoreductase, C-terminal domains', 286527),
(478934, '0051847', NULL, NULL, 211, NULL, 'YjeF N-terminal domain-like', 286528),
(478935, '0039822', NULL, NULL, 243, NULL, 'YjeF N-terminal domain-like', 286528);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(478936, '0042059', NULL, NULL, 66, NULL, 'Amyloid beta a4 protein copper binding domain (domain 2)', 286529),
(478937, '0038310', NULL, NULL, 175, NULL, 'Cytolysin/lectin', 286530),
(478938, '0050876', NULL, NULL, 145, NULL, 'Cytolysin/lectin', 286530),
(478939, '0051190', NULL, NULL, 142, NULL, 'Cytolysin/lectin', 286530),
(478940, '0038953', NULL, NULL, 175, NULL, 'Cytolysin/lectin', 286530),
(478941, '0050058', NULL, NULL, 85, NULL, 'GAS2 domain-like', 286531),
(478942, '0037760', NULL, NULL, 183, NULL, 'LigT-like', 286532),
(478943, '0053115', NULL, NULL, 219, NULL, 'LigT-like', 286532),
(478944, '0039208', NULL, NULL, 183, NULL, 'LigT-like', 286532),
(478945, '0052753', NULL, NULL, 232, NULL, 'LigT-like', 286532),
(478946, '0044837', NULL, NULL, 292, NULL, 'Indigoidine synthase A-like', 286533),
(478947, '0039331', NULL, NULL, 99, NULL, 'Myosin phosphatase inhibitor 17kDa protein, CPI-17', 286534),
(478948, '0035203', NULL, NULL, 203, NULL, 'CRAL/TRIO domain', 286535),
(478949, '0041714', NULL, NULL, 199, NULL, 'CRAL/TRIO domain', 286535),
(478950, '0043136', NULL, NULL, 185, NULL, 'CRAL/TRIO domain', 286535),
(478951, '0040430', NULL, NULL, 170, NULL, 'Rotavirus NSP2 fragment, C-terminal domain', 286536),
(478952, '0051766', NULL, NULL, 155, NULL, 'Coronavirus NSP8-like', 286537),
(478953, '0036140', NULL, NULL, 435, NULL, 'Citrate synthase', 286538),
(478954, '0039891', NULL, NULL, 426, NULL, 'Citrate synthase', 286538),
(478955, '0036138', NULL, NULL, 433, NULL, 'Citrate synthase', 286538),
(478956, '0039109', NULL, NULL, 374, NULL, 'Citrate synthase', 286538),
(478957, '0034881', NULL, NULL, 377, NULL, 'Citrate synthase', 286538),
(478958, '0035069', NULL, NULL, 371, NULL, 'Citrate synthase', 286538),
(478959, '0041736', NULL, NULL, 367, NULL, 'Citrate synthase', 286538),
(478960, '0045234', NULL, NULL, 437, NULL, 'Citrate synthase', 286538),
(478961, '0039719', NULL, NULL, 111, NULL, 'Fe,Mn superoxide dismutase (SOD), C-terminal domain', 286539),
(478962, '0050425', NULL, NULL, 116, NULL, 'Fe,Mn superoxide dismutase (SOD), C-terminal domain', 286539),
(478963, '0035696', NULL, NULL, 115, NULL, 'Fe,Mn superoxide dismutase (SOD), C-terminal domain', 286539),
(478964, '0051208', NULL, NULL, 116, NULL, 'Fe,Mn superoxide dismutase (SOD), C-terminal domain', 286539),
(478965, '0038820', NULL, NULL, 115, NULL, 'Fe,Mn superoxide dismutase (SOD), C-terminal domain', 286539),
(478966, '0038985', NULL, NULL, 114, NULL, 'Fe,Mn superoxide dismutase (SOD), C-terminal domain', 286539),
(478967, '0040124', NULL, NULL, 116, NULL, 'Fe,Mn superoxide dismutase (SOD), C-terminal domain', 286539),
(478968, '0040860', NULL, NULL, 113, NULL, 'Fe,Mn superoxide dismutase (SOD), C-terminal domain', 286539),
(478969, '0041014', NULL, NULL, 111, NULL, 'Fe,Mn superoxide dismutase (SOD), C-terminal domain', 286539),
(478970, '0049959', NULL, NULL, 134, NULL, 'Fe,Mn superoxide dismutase (SOD), C-terminal domain', 286539),
(478971, '0035287', NULL, NULL, 118, NULL, 'Fe,Mn superoxide dismutase (SOD), C-terminal domain', 286539),
(478972, '0036585', NULL, NULL, 114, NULL, 'Fe,Mn superoxide dismutase (SOD), C-terminal domain', 286539),
(478973, '0038283', NULL, NULL, 111, NULL, 'Fe,Mn superoxide dismutase (SOD), C-terminal domain', 286539),
(478974, '0041143', NULL, NULL, 110, NULL, 'Fe,Mn superoxide dismutase (SOD), C-terminal domain', 286539),
(478975, '0042186', NULL, NULL, 119, NULL, 'Fe,Mn superoxide dismutase (SOD), C-terminal domain', 286539),
(478976, '0035152', NULL, NULL, 115, NULL, 'Fe,Mn superoxide dismutase (SOD), C-terminal domain', 286539),
(478977, '0045567', NULL, NULL, 107, NULL, 'Fe,Mn superoxide dismutase (SOD), C-terminal domain', 286539),
(478978, '0036081', NULL, NULL, 122, NULL, 'Fe,Mn superoxide dismutase (SOD), C-terminal domain', 286539),
(478979, '0039180', NULL, NULL, 110, NULL, 'Fe,Mn superoxide dismutase (SOD), C-terminal domain', 286539),
(478980, '0042885', NULL, NULL, 107, NULL, 'Fe,Mn superoxide dismutase (SOD), C-terminal domain', 286539),
(478981, '0053099', NULL, NULL, 166, NULL, 'UbiD C-terminal domain-like', 286540);
INSERT INTO "PUBLIC"."MODEL" VALUES
(478982, '0036507', NULL, NULL, 237, NULL, 'Carbonic anhydrase', 286541),
(478983, '0040188', NULL, NULL, 252, NULL, 'Carbonic anhydrase', 286541),
(478984, '0039488', NULL, NULL, 260, NULL, 'Carbonic anhydrase', 286541),
(478985, '0045490', NULL, NULL, 258, NULL, 'Carbonic anhydrase', 286541),
(478986, '0043265', NULL, NULL, 259, NULL, 'Carbonic anhydrase', 286541),
(478987, '0037649', NULL, NULL, 259, NULL, 'Carbonic anhydrase', 286541),
(478988, '0048038', NULL, NULL, 259, NULL, 'Carbonic anhydrase', 286541),
(478989, '0044675', NULL, NULL, 259, NULL, 'Carbonic anhydrase', 286541),
(478990, '0045126', NULL, NULL, 262, NULL, 'Carbonic anhydrase', 286541),
(478991, '0038524', NULL, NULL, 258, NULL, 'Carbonic anhydrase', 286541),
(478992, '0044120', NULL, NULL, 245, NULL, 'Tubulin nucleotide-binding domain-like', 286542),
(478993, '0050371', NULL, NULL, 194, NULL, 'Tubulin nucleotide-binding domain-like', 286542),
(478994, '0044122', NULL, NULL, 243, NULL, 'Tubulin nucleotide-binding domain-like', 286542),
(478995, '0043342', NULL, NULL, 198, NULL, 'Tubulin nucleotide-binding domain-like', 286542),
(478996, '0041832', NULL, NULL, 198, NULL, 'Tubulin nucleotide-binding domain-like', 286542),
(478997, '0053757', NULL, NULL, 244, NULL, 'Tubulin nucleotide-binding domain-like', 286542),
(478998, '0050368', NULL, NULL, 209, NULL, 'Tubulin nucleotide-binding domain-like', 286542),
(478999, '0040270', NULL, NULL, 202, NULL, 'Archaeal IMP cyclohydrolase PurO', 286543),
(479000, '0036905', NULL, NULL, 91, NULL, 'Chorismate mutase II', 286544),
(479001, '0052994', NULL, NULL, 94, NULL, 'Chorismate mutase II', 286544),
(479002, '0045614', NULL, NULL, 256, NULL, 'Chorismate mutase II', 286544),
(479003, '0051272', NULL, NULL, 74, NULL, 'Chorismate mutase II', 286544),
(479004, '0052958', NULL, NULL, 93, NULL, 'Chorismate mutase II', 286544),
(479005, '0052736', NULL, NULL, 165, NULL, 'Chorismate mutase II', 286544),
(479006, '0052401', NULL, NULL, 80, NULL, 'Chorismate mutase II', 286544),
(479007, '0035906', NULL, NULL, 487, NULL, 'HydB/Nqo4-like', 286545),
(479008, '0045288', NULL, NULL, 530, NULL, 'HydB/Nqo4-like', 286545),
(479009, '0037746', NULL, NULL, 543, NULL, 'HydB/Nqo4-like', 286545),
(479010, '0038381', NULL, NULL, 534, NULL, 'HydB/Nqo4-like', 286545),
(479011, '0036736', NULL, NULL, 537, NULL, 'HydB/Nqo4-like', 286545),
(479012, '0052775', NULL, NULL, 375, NULL, 'HydB/Nqo4-like', 286545),
(479013, '0042281', NULL, NULL, 311, NULL, 'ABC transporter transmembrane region', 286546),
(479014, '0053060', NULL, NULL, 323, NULL, 'ABC transporter transmembrane region', 286546),
(479015, '0054812', NULL, NULL, 319, NULL, 'ABC transporter transmembrane region', 286546),
(479016, '0053389', NULL, NULL, 32, NULL, 'Leucine zipper domain', 286547),
(479017, '0053422', NULL, NULL, 32, NULL, 'Leucine zipper domain', 286547),
(479018, '0053444', NULL, NULL, 31, NULL, 'Leucine zipper domain', 286547),
(479019, '0053423', NULL, NULL, 64, NULL, 'Leucine zipper domain', 286547),
(479020, '0053564', NULL, NULL, 32, NULL, 'Leucine zipper domain', 286547),
(479021, '0053462', NULL, NULL, 35, NULL, 'Leucine zipper domain', 286547),
(479022, '0053463', NULL, NULL, 35, NULL, 'Leucine zipper domain', 286547),
(479023, '0054870', NULL, NULL, 32, NULL, 'Leucine zipper domain', 286547),
(479024, '0053461', NULL, NULL, 35, NULL, 'Leucine zipper domain', 286547),
(479025, '0053527', NULL, NULL, 33, NULL, 'Leucine zipper domain', 286547),
(479026, '0053528', NULL, NULL, 32, NULL, 'Leucine zipper domain', 286547),
(479027, '0054638', NULL, NULL, 25, NULL, 'Leucine zipper domain', 286547),
(479028, '0053602', NULL, NULL, 33, NULL, 'Leucine zipper domain', 286547),
(479029, '0053526', NULL, NULL, 32, NULL, 'Leucine zipper domain', 286547),
(479030, '0053548', NULL, NULL, 34, NULL, 'Leucine zipper domain', 286547),
(479031, '0053523', NULL, NULL, 32, NULL, 'Leucine zipper domain', 286547),
(479032, '0053545', NULL, NULL, 57, NULL, 'Leucine zipper domain', 286547),
(479033, '0053403', NULL, NULL, 55, NULL, 'Leucine zipper domain', 286547);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(479034, '0053434', NULL, NULL, 71, NULL, 'Leucine zipper domain', 286547),
(479035, '0053533', NULL, NULL, 33, NULL, 'Leucine zipper domain', 286547),
(479036, '0053398', NULL, NULL, 34, NULL, 'Leucine zipper domain', 286547),
(479037, '0053552', NULL, NULL, 29, NULL, 'Leucine zipper domain', 286547),
(479038, '0053399', NULL, NULL, 56, NULL, 'Leucine zipper domain', 286547),
(479039, '0053696', NULL, NULL, 33, NULL, 'Leucine zipper domain', 286547),
(479040, '0053495', NULL, NULL, 46, NULL, 'Leucine zipper domain', 286547),
(479041, '0053572', NULL, NULL, 31, NULL, 'Leucine zipper domain', 286547),
(479042, '0053397', NULL, NULL, 35, NULL, 'Leucine zipper domain', 286547),
(479043, '0053551', NULL, NULL, 31, NULL, 'Leucine zipper domain', 286547),
(479044, '0053570', NULL, NULL, 33, NULL, 'Leucine zipper domain', 286547),
(479045, '0054340', NULL, NULL, 32, NULL, 'Leucine zipper domain', 286547),
(479046, '0053518', NULL, NULL, 61, NULL, 'Leucine zipper domain', 286547),
(479047, '0053517', NULL, NULL, 62, NULL, 'Leucine zipper domain', 286547),
(479048, '0054869', NULL, NULL, 32, NULL, 'Leucine zipper domain', 286547),
(479049, '0053415', NULL, NULL, 60, NULL, 'Leucine zipper domain', 286547),
(479050, '0054868', NULL, NULL, 32, NULL, 'Leucine zipper domain', 286547),
(479051, '0054867', NULL, NULL, 32, NULL, 'Leucine zipper domain', 286547),
(479052, '0053457', NULL, NULL, 43, NULL, 'Leucine zipper domain', 286547),
(479053, '0053534', NULL, NULL, 34, NULL, 'Leucine zipper domain', 286547),
(479054, '0053556', NULL, NULL, 30, NULL, 'Leucine zipper domain', 286547),
(479055, '0053436', NULL, NULL, 57, NULL, 'Leucine zipper domain', 286547),
(479056, '0053557', NULL, NULL, 62, NULL, 'Leucine zipper domain', 286547),
(479057, '0053390', NULL, NULL, 32, NULL, 'Leucine zipper domain', 286547),
(479058, '0053490', NULL, NULL, 60, NULL, 'Leucine zipper domain', 286547),
(479059, '0041164', NULL, NULL, 102, NULL, 'Cyanovirin-N', 286548),
(479060, '0045510', NULL, NULL, 101, NULL, 'Cyanovirin-N', 286548),
(479061, '0045554', NULL, NULL, 80, NULL, 'Alpha-lytic protease prodomain', 286549),
(479062, '0045555', NULL, NULL, 78, NULL, 'Alpha-lytic protease prodomain', 286549),
(479063, '0048890', NULL, NULL, 297, NULL, 'ClpP/crotonase', 286550),
(479064, '0052793', NULL, NULL, 258, NULL, 'ClpP/crotonase', 286550),
(479065, '0038805', NULL, NULL, 266, NULL, 'ClpP/crotonase', 286550),
(479066, '0051041', NULL, NULL, 263, NULL, 'ClpP/crotonase', 286550),
(479067, '0048476', NULL, NULL, 269, NULL, 'ClpP/crotonase', 286550),
(479068, '0051040', NULL, NULL, 258, NULL, 'ClpP/crotonase', 286550),
(479069, '0048770', NULL, NULL, 299, NULL, 'ClpP/crotonase', 286550),
(479070, '0049386', NULL, NULL, 249, NULL, 'ClpP/crotonase', 286550),
(479071, '0051228', NULL, NULL, 192, NULL, 'ClpP/crotonase', 286550),
(479072, '0050758', NULL, NULL, 263, NULL, 'ClpP/crotonase', 286550),
(479073, '0039416', NULL, NULL, 302, NULL, 'ClpP/crotonase', 286550),
(479074, '0051722', NULL, NULL, 271, NULL, 'ClpP/crotonase', 286550),
(479075, '0051721', NULL, NULL, 258, NULL, 'ClpP/crotonase', 286550),
(479076, '0048518', NULL, NULL, 249, NULL, 'ClpP/crotonase', 286550),
(479077, '0051719', NULL, NULL, 230, NULL, 'ClpP/crotonase', 286550),
(479078, '0052629', NULL, NULL, 263, NULL, 'ClpP/crotonase', 286550),
(479079, '0052608', NULL, NULL, 245, NULL, 'ClpP/crotonase', 286550),
(479080, '0052487', NULL, NULL, 259, NULL, 'ClpP/crotonase', 286550),
(479081, '0044160', NULL, NULL, 183, NULL, 'ClpP/crotonase', 286550),
(479082, '0052142', NULL, NULL, 179, NULL, 'ClpP/crotonase', 286550),
(479083, '0044384', NULL, NULL, 253, NULL, 'ClpP/crotonase', 286550),
(479084, '0050305', NULL, NULL, 251, NULL, 'ClpP/crotonase', 286550),
(479085, '0052628', NULL, NULL, 316, NULL, 'ClpP/crotonase', 286550),
(479086, '0050306', NULL, NULL, 264, NULL, 'ClpP/crotonase', 286550),
(479087, '0052604', NULL, NULL, 190, NULL, 'ClpP/crotonase', 286550),
(479088, '0038654', NULL, NULL, 263, NULL, 'ClpP/crotonase', 286550),
(479089, '0050444', NULL, NULL, 310, NULL, 'ClpP/crotonase', 286550);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(479090, '0051137', NULL, NULL, 257, NULL, 'ClpP/crotonase', 286550),
(479091, '0036954', NULL, NULL, 261, NULL, 'ClpP/crotonase', 286550),
(479092, '0046748', NULL, NULL, 295, NULL, 'ClpP/crotonase', 286550),
(479093, '0041794', NULL, NULL, 389, NULL, 'ClpP/crotonase', 286550),
(479094, '0041793', NULL, NULL, 331, NULL, 'ClpP/crotonase', 286550),
(479095, '0039881', NULL, NULL, 292, NULL, 'ClpP/crotonase', 286550),
(479096, '0046300', NULL, NULL, 275, NULL, 'ClpP/crotonase', 286550),
(479097, '0041934', NULL, NULL, 264, NULL, 'ClpP/crotonase', 286550),
(479098, '0041933', NULL, NULL, 253, NULL, 'ClpP/crotonase', 286550),
(479099, '0048769', NULL, NULL, 287, NULL, 'ClpP/crotonase', 286550),
(479100, '0049617', NULL, NULL, 193, NULL, 'ClpP/crotonase', 286550),
(479101, '0039709', NULL, NULL, 260, NULL, 'HemD-like', 286551),
(479102, '0050436', NULL, NULL, 254, NULL, 'HemD-like', 286551),
(479103, '0051111', NULL, NULL, 150, NULL, 'Diaminopimelate epimerase-like', 286552),
(479104, '0051110', NULL, NULL, 128, NULL, 'Diaminopimelate epimerase-like', 286552),
(479105, '0054021', NULL, NULL, 182, NULL, 'Diaminopimelate epimerase-like', 286552),
(479106, '0054022', NULL, NULL, 209, NULL, 'Diaminopimelate epimerase-like', 286552),
(479107, '0043560', NULL, NULL, 140, NULL, 'Diaminopimelate epimerase-like', 286552),
(479108, '0044177', NULL, NULL, 129, NULL, 'Diaminopimelate epimerase-like', 286552),
(479109, '0049368', NULL, NULL, 170, NULL, 'Diaminopimelate epimerase-like', 286552),
(479110, '0046029', NULL, NULL, 144, NULL, 'Diaminopimelate epimerase-like', 286552),
(479111, '0044048', NULL, NULL, 332, NULL, 'Diaminopimelate epimerase-like', 286552),
(479112, '0046028', NULL, NULL, 130, NULL, 'Diaminopimelate epimerase-like', 286552),
(479113, '0043521', NULL, NULL, 260, NULL, 'Diaminopimelate epimerase-like', 286552),
(479114, '0049758', NULL, NULL, 153, NULL, 'Diaminopimelate epimerase-like', 286552),
(479115, '0043647', NULL, NULL, 75, NULL, 'N-terminal domain of alpha and beta subunits of F1 ATP synthase', 286553),
(479116, '0037817', NULL, NULL, 72, NULL, 'N-terminal domain of alpha and beta subunits of F1 ATP synthase', 286553),
(479117, '0048127', NULL, NULL, 81, NULL, 'N-terminal domain of alpha and beta subunits of F1 ATP synthase', 286553),
(479118, '0043650', NULL, NULL, 82, NULL, 'N-terminal domain of alpha and beta subunits of F1 ATP synthase', 286553),
(479119, '0037820', NULL, NULL, 79, NULL, 'N-terminal domain of alpha and beta subunits of F1 ATP synthase', 286553),
(479120, '0040863', NULL, NULL, 86, NULL, 'N-terminal domain of alpha and beta subunits of F1 ATP synthase', 286553),
(479121, '0046094', NULL, NULL, 171, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479122, '0048790', NULL, NULL, 124, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479123, '0050275', NULL, NULL, 155, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479124, '0046093', NULL, NULL, 114, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479125, '0044191', NULL, NULL, 145, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479126, '0049564', NULL, NULL, 143, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479127, '0052099', NULL, NULL, 149, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479128, '0054352', NULL, NULL, 143, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479129, '0053021', NULL, NULL, 156, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479130, '0052337', NULL, NULL, 138, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479131, '0051839', NULL, NULL, 142, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479132, '0049325', NULL, NULL, 129, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479133, '0047466', NULL, NULL, 130, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479134, '0048478', NULL, NULL, 137, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479135, '0046019', NULL, NULL, 139, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554);
INSERT INTO "PUBLIC"."MODEL" VALUES
(479136, '0051892', NULL, NULL, 154, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479137, '0052780', NULL, NULL, 118, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479138, '0051494', NULL, NULL, 132, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479139, '0051977', NULL, NULL, 152, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479140, '0051338', NULL, NULL, 142, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479141, '0051976', NULL, NULL, 178, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479142, '0048889', NULL, NULL, 142, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479143, '0048175', NULL, NULL, 171, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479144, '0054377', NULL, NULL, 131, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479145, '0049345', NULL, NULL, 126, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479146, '0052351', NULL, NULL, 132, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479147, '0053001', NULL, NULL, 142, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479148, '0052350', NULL, NULL, 127, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479149, '0052592', NULL, NULL, 111, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479150, '0052559', NULL, NULL, 136, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479151, '0050179', NULL, NULL, 138, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479152, '0051502', NULL, NULL, 146, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479153, '0052511', NULL, NULL, 149, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479154, '0052512', NULL, NULL, 98, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479155, '0042635', NULL, NULL, 151, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479156, '0041428', NULL, NULL, 133, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479157, '0049589', NULL, NULL, 104, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479158, '0049346', NULL, NULL, 154, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479159, '0048813', NULL, NULL, 131, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479160, '0049396', NULL, NULL, 153, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479161, '0053213', NULL, NULL, 159, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479162, '0052881', NULL, NULL, 134, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479163, '0054422', NULL, NULL, 203, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479164, '0051233', NULL, NULL, 164, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479165, '0051794', NULL, NULL, 130, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479166, '0047497', NULL, NULL, 116, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479167, '0051590', NULL, NULL, 126, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479168, '0052966', NULL, NULL, 116, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479169, '0052965', NULL, NULL, 135, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479170, '0054426', NULL, NULL, 109, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479171, '0051358', NULL, NULL, 145, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479172, '0054425', NULL, NULL, 147, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479173, '0053052', NULL, NULL, 144, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479174, '0054580', NULL, NULL, 130, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479175, '0050180', NULL, NULL, 138, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479176, '0047414', NULL, NULL, 132, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(479177, '0048789', NULL, NULL, 148, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', 286554),
(479178, '0035881', NULL, NULL, 265, NULL, 'Tubby C-terminal domain-like', 286555),
(479179, '0053290', NULL, NULL, 189, NULL, 'Tubby C-terminal domain-like', 286555),
(479180, '0050678', NULL, NULL, 168, NULL, 'YfbU-like', 286556),
(479181, '0046915', NULL, NULL, 76, NULL, 'Iron-dependent repressor protein, dimerization domain', 286557),
(479182, '0037826', NULL, NULL, 80, NULL, 'Iron-dependent repressor protein, dimerization domain', 286557),
(479183, '0041932', NULL, NULL, 74, NULL, 'Iron-dependent repressor protein, dimerization domain', 286557),
(479184, '0036481', NULL, NULL, 104, NULL, 'Protein-L-isoaspartyl O-methyltransferase, C-terminal domain', 286558),
(479185, '0049120', NULL, NULL, 114, NULL, 'KorB DNA-binding domain-like', 286559),
(479186, '0050319', NULL, NULL, 93, NULL, 'KorB DNA-binding domain-like', 286559),
(479187, '0040970', NULL, NULL, 97, NULL, 'GIY-YIG endonuclease', 286560),
(479188, '0047151', NULL, NULL, 30, NULL, 'Plant inhibitors of proteinases and amylases', 286561),
(479189, '0048141', NULL, NULL, 28, NULL, 'Plant inhibitors of proteinases and amylases', 286561),
(479190, '0047152', NULL, NULL, 30, NULL, 'Plant inhibitors of proteinases and amylases', 286561),
(479191, '0048142', NULL, NULL, 28, NULL, 'Plant inhibitors of proteinases and amylases', 286561),
(479192, '0046175', NULL, NULL, 32, NULL, 'Plant inhibitors of proteinases and amylases', 286561),
(479193, '0046692', NULL, NULL, 28, NULL, 'Plant inhibitors of proteinases and amylases', 286561),
(479194, '0052044', NULL, NULL, 29, NULL, 'Plant inhibitors of proteinases and amylases', 286561),
(479195, '0052110', NULL, NULL, 28, NULL, 'Plant inhibitors of proteinases and amylases', 286561),
(479196, '0053175', NULL, NULL, 28, NULL, 'Plant inhibitors of proteinases and amylases', 286561),
(479197, '0047102', NULL, NULL, 39, NULL, 'Plant inhibitors of proteinases and amylases', 286561),
(479198, '0047157', NULL, NULL, 34, NULL, 'Plant inhibitors of proteinases and amylases', 286561),
(479199, '0053307', NULL, NULL, 29, NULL, 'Plant inhibitors of proteinases and amylases', 286561),
(479200, '0044350', NULL, NULL, 83, NULL, 'Uracil-DNA glycosylase inhibitor protein', 286562),
(479201, '0050921', NULL, NULL, 313, NULL, 'AF0104/ALDC/Ptd012-like', 286563),
(479202, '0053051', NULL, NULL, 136, NULL, 'AF0104/ALDC/Ptd012-like', 286563),
(479203, '0052987', NULL, NULL, 138, NULL, 'AF0104/ALDC/Ptd012-like', 286563),
(479204, '0051117', NULL, NULL, 232, NULL, 'AF0104/ALDC/Ptd012-like', 286563),
(479205, '0052696', NULL, NULL, 93, NULL, 'Colicin D/E5 nuclease domain', 286564),
(479206, '0044644', NULL, NULL, 107, NULL, 'Colicin D/E5 nuclease domain', 286564),
(479207, '0053530', NULL, NULL, 42, NULL, 'Vasodilator-stimulated phosphoprotein, VASP, tetramerisation domain', 286565),
(479208, '0044706', NULL, NULL, 199, NULL, 'Recombination protein RecR', 286566),
(479209, '0040325', NULL, NULL, 123, NULL, 'Siroheme synthase middle domains-like', 286567),
(479210, '0042344', NULL, NULL, 102, NULL, 'Siroheme synthase middle domains-like', 286567),
(479211, '0036083', NULL, NULL, 197, NULL, 'Colicin', 286568),
(479212, '0036000', NULL, NULL, 174, NULL, 'Colicin', 286568),
(479213, '0034942', NULL, NULL, 297, NULL, 'Colicin', 286568),
(479214, '0049160', NULL, NULL, 199, NULL, 'Colicin', 286568),
(479215, '0042469', NULL, NULL, 94, NULL, 'YbaB-like', 286569),
(479216, '0039418', NULL, NULL, 92, NULL, 'YbaB-like', 286569),
(479217, '0043365', NULL, NULL, 66, NULL, 'Glycogen synthesis protein GlgS', 286570),
(479218, '0043680', NULL, NULL, 24, NULL, 'Mini-collagen I, C-terminal domain', 286571),
(479219, '0054097', NULL, NULL, 377, NULL, 'SSO1389-like', 286572),
(479220, '0048751', NULL, NULL, 56, NULL, 'Aspartate carbamoyltransferase, Regulatory-chain, C-terminal domain', 286573),
(479221, '0046243', NULL, NULL, 53, NULL, 'Aspartate carbamoyltransferase, Regulatory-chain, C-terminal domain', 286573),
(479222, '0051829', NULL, NULL, 52, NULL, 'Aspartate carbamoyltransferase, Regulatory-chain, C-terminal domain', 286573);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(479223, '0050419', NULL, NULL, 94, NULL, 'EsxAB dimer-like', 286574),
(479224, '0050418', NULL, NULL, 99, NULL, 'EsxAB dimer-like', 286574),
(479225, '0046719', NULL, NULL, 262, NULL, 'Dihydropteroate synthetase-like', 286575),
(479226, '0045781', NULL, NULL, 282, NULL, 'Dihydropteroate synthetase-like', 286575),
(479227, '0046651', NULL, NULL, 270, NULL, 'Dihydropteroate synthetase-like', 286575),
(479228, '0045762', NULL, NULL, 264, NULL, 'Dihydropteroate synthetase-like', 286575),
(479229, '0048901', NULL, NULL, 259, NULL, 'Dihydropteroate synthetase-like', 286575),
(479230, '0049727', NULL, NULL, 273, NULL, 'Dihydropteroate synthetase-like', 286575),
(479231, '0047643', NULL, NULL, 365, NULL, '3-carboxy-cis,cis-mucoante lactonizing enzyme', 286576),
(479232, '0036629', NULL, NULL, 169, NULL, 'Functional domain of the splicing factor Prp18', 286577),
(479233, '0037770', NULL, NULL, 117, NULL, '4''-phosphopantetheinyl transferase', 286578),
(479234, '0042952', NULL, NULL, 127, NULL, '4''-phosphopantetheinyl transferase', 286578),
(479235, '0037427', NULL, NULL, 118, NULL, '4''-phosphopantetheinyl transferase', 286578),
(479236, '0042951', NULL, NULL, 101, NULL, '4''-phosphopantetheinyl transferase', 286578),
(479237, '0054111', NULL, NULL, 221, NULL, 'XCC0632-like', 286579),
(479238, '0054154', NULL, NULL, 178, NULL, 'XCC0632-like', 286579),
(479239, '0047695', NULL, NULL, 226, NULL, 'Hedgehog/intein (Hint) domain', 286580),
(479240, '0035098', NULL, NULL, 199, NULL, 'Hedgehog/intein (Hint) domain', 286580),
(479241, '0036550', NULL, NULL, 169, NULL, 'Hedgehog/intein (Hint) domain', 286580),
(479242, '0035189', NULL, NULL, 145, NULL, 'Hedgehog/intein (Hint) domain', 286580),
(479243, '0038214', NULL, NULL, 229, NULL, 'Hedgehog/intein (Hint) domain', 286580),
(479244, '0048160', NULL, NULL, 158, NULL, 'Hedgehog/intein (Hint) domain', 286580),
(479245, '0054528', NULL, NULL, 122, NULL, 'PspA lactotransferrin-binding region', 286581),
(479246, '0054269', NULL, NULL, 89, NULL, 'Ribonuclease PH domain 2-like', 286582),
(479247, '0054267', NULL, NULL, 90, NULL, 'Ribonuclease PH domain 2-like', 286582),
(479248, '0044292', NULL, NULL, 105, NULL, 'Ribonuclease PH domain 2-like', 286582),
(479249, '0053740', NULL, NULL, 79, NULL, 'Ribonuclease PH domain 2-like', 286582),
(479250, '0054210', NULL, NULL, 84, NULL, 'Ribonuclease PH domain 2-like', 286582),
(479251, '0054265', NULL, NULL, 118, NULL, 'Ribonuclease PH domain 2-like', 286582),
(479252, '0054275', NULL, NULL, 95, NULL, 'Ribonuclease PH domain 2-like', 286582),
(479253, '0053738', NULL, NULL, 99, NULL, 'Ribonuclease PH domain 2-like', 286582),
(479254, '0042084', NULL, NULL, 86, NULL, 'Ribonuclease PH domain 2-like', 286582),
(479255, '0036741', NULL, NULL, 111, NULL, 'Ribonuclease PH domain 2-like', 286582),
(479256, '0053756', NULL, NULL, 93, NULL, 'Ribonuclease PH domain 2-like', 286582),
(479257, '0054273', NULL, NULL, 94, NULL, 'Ribonuclease PH domain 2-like', 286582),
(479258, '0054271', NULL, NULL, 89, NULL, 'Ribonuclease PH domain 2-like', 286582),
(479259, '0046448', NULL, NULL, 96, NULL, 'Ribonuclease PH domain 2-like', 286582),
(479260, '0043149', NULL, NULL, 88, NULL, 'Ribonuclease PH domain 2-like', 286582),
(479261, '0051836', NULL, NULL, 156, NULL, 'LD-carboxypeptidase A C-terminal domain-like', 286583),
(479262, '0041587', NULL, NULL, 51, NULL, 'Transcription factor IIA (TFIIA), alpha-helical domain', 286584),
(479263, '0041585', NULL, NULL, 43, NULL, 'Transcription factor IIA (TFIIA), alpha-helical domain', 286584),
(479264, '0045103', NULL, NULL, 46, NULL, 'Transcription factor IIA (TFIIA), alpha-helical domain', 286584),
(479265, '0045105', NULL, NULL, 50, NULL, 'Transcription factor IIA (TFIIA), alpha-helical domain', 286584),
(479266, '0040939', NULL, NULL, 167, NULL, 'Methane monooxygenase hydrolase, gamma subunit', 286585),
(479267, '0041080', NULL, NULL, 162, NULL, 'Methane monooxygenase hydrolase, gamma subunit', 286585),
(479268, '0053745', NULL, NULL, 68, NULL, 'EspE N-terminal domain-like', 286586),
(479269, '0053798', NULL, NULL, 149, NULL, 'EspE N-terminal domain-like', 286586);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(479270, '0040000', NULL, NULL, 224, NULL, 'beta-Roll', 286587),
(479271, '0043539', NULL, NULL, 225, NULL, 'beta-Roll', 286587),
(479272, '0038009', NULL, NULL, 219, NULL, 'beta-Roll', 286587),
(479273, '0039942', NULL, NULL, 221, NULL, 'beta-Roll', 286587),
(479274, '0041113', NULL, NULL, 162, NULL, 'Hypothetical protein HI1480', 286588),
(479275, '0048088', NULL, NULL, 217, NULL, 'BAH domain', 286589),
(479276, '0046481', NULL, NULL, 54, NULL, 'Recombination endonuclease VII, C-terminal and dimerization domains', 286590),
(479277, '0034988', NULL, NULL, 74, NULL, 'Snake toxin-like', 286591),
(479278, '0052991', NULL, NULL, 77, NULL, 'Snake toxin-like', 286591),
(479279, '0047584', NULL, NULL, 66, NULL, 'Snake toxin-like', 286591),
(479280, '0044150', NULL, NULL, 73, NULL, 'Snake toxin-like', 286591),
(479281, '0037959', NULL, NULL, 62, NULL, 'Snake toxin-like', 286591),
(479282, '0052990', NULL, NULL, 75, NULL, 'Snake toxin-like', 286591),
(479283, '0040309', NULL, NULL, 62, NULL, 'Snake toxin-like', 286591),
(479284, '0048210', NULL, NULL, 68, NULL, 'Snake toxin-like', 286591),
(479285, '0050313', NULL, NULL, 65, NULL, 'Snake toxin-like', 286591),
(479286, '0045505', NULL, NULL, 62, NULL, 'Snake toxin-like', 286591),
(479287, '0037155', NULL, NULL, 86, NULL, 'Snake toxin-like', 286591),
(479288, '0040013', NULL, NULL, 60, NULL, 'Snake toxin-like', 286591),
(479289, '0040232', NULL, NULL, 107, NULL, 'Snake toxin-like', 286591),
(479290, '0041562', NULL, NULL, 60, NULL, 'Snake toxin-like', 286591),
(479291, '0035991', NULL, NULL, 60, NULL, 'Snake toxin-like', 286591),
(479292, '0042858', NULL, NULL, 61, NULL, 'Snake toxin-like', 286591),
(479293, '0037471', NULL, NULL, 61, NULL, 'Snake toxin-like', 286591),
(479294, '0045147', NULL, NULL, 74, NULL, 'Snake toxin-like', 286591),
(479295, '0046116', NULL, NULL, 77, NULL, 'Snake toxin-like', 286591),
(479296, '0050121', NULL, NULL, 61, NULL, 'Snake toxin-like', 286591),
(479297, '0048780', NULL, NULL, 122, NULL, 'Snake toxin-like', 286591),
(479298, '0052301', NULL, NULL, 71, NULL, 'Snake toxin-like', 286591),
(479299, '0050068', NULL, NULL, 62, NULL, 'Snake toxin-like', 286591),
(479300, '0035927', NULL, NULL, 60, NULL, 'Snake toxin-like', 286591),
(479301, '0037525', NULL, NULL, 60, NULL, 'Snake toxin-like', 286591),
(479302, '0038815', NULL, NULL, 60, NULL, 'Snake toxin-like', 286591),
(479303, '0053910', NULL, NULL, 80, NULL, 'Snake toxin-like', 286591),
(479304, '0052986', NULL, NULL, 75, NULL, 'Snake toxin-like', 286591),
(479305, '0054108', NULL, NULL, 101, NULL, 'Snake toxin-like', 286591),
(479306, '0035701', NULL, NULL, 96, NULL, 'Snake toxin-like', 286591),
(479307, '0053911', NULL, NULL, 87, NULL, 'Snake toxin-like', 286591),
(479308, '0037447', NULL, NULL, 63, NULL, 'Snake toxin-like', 286591),
(479309, '0037520', NULL, NULL, 65, NULL, 'Snake toxin-like', 286591),
(479310, '0036572', NULL, NULL, 59, NULL, 'Snake toxin-like', 286591),
(479311, '0040008', NULL, NULL, 66, NULL, 'Snake toxin-like', 286591),
(479312, '0040646', NULL, NULL, 66, NULL, 'Snake toxin-like', 286591),
(479313, '0041559', NULL, NULL, 72, NULL, 'Snake toxin-like', 286591),
(479314, '0044003', NULL, NULL, 60, NULL, 'Snake toxin-like', 286591),
(479315, '0041635', NULL, NULL, 93, NULL, 'Snake toxin-like', 286591),
(479316, '0047417', NULL, NULL, 61, NULL, 'Snake toxin-like', 286591),
(479317, '0045214', NULL, NULL, 60, NULL, 'Snake toxin-like', 286591),
(479318, '0043996', NULL, NULL, 60, NULL, 'Snake toxin-like', 286591),
(479319, '0045481', NULL, NULL, 93, NULL, 'MurCD N-terminal domain', 286592),
(479320, '0047521', NULL, NULL, 89, NULL, 'MurCD N-terminal domain', 286592),
(479321, '0048687', NULL, NULL, 96, NULL, 'MurCD N-terminal domain', 286592),
(479322, '0049250', NULL, NULL, 152, NULL, 'C-terminal domain of Ku80', 286593),
(479323, '0053763', NULL, NULL, 80, NULL, 'RING/U-box', 286594),
(479324, '0050592', NULL, NULL, 94, NULL, 'RING/U-box', 286594),
(479325, '0050318', NULL, NULL, 60, NULL, 'RING/U-box', 286594),
(479326, '0037895', NULL, NULL, 65, NULL, 'RING/U-box', 286594); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(479327, '0050433', NULL, NULL, 60, NULL, 'RING/U-box', 286594),
(479328, '0053820', NULL, NULL, 85, NULL, 'RING/U-box', 286594),
(479329, '0047962', NULL, NULL, 88, NULL, 'RING/U-box', 286594),
(479330, '0052291', NULL, NULL, 73, NULL, 'RING/U-box', 286594),
(479331, '0046458', NULL, NULL, 78, NULL, 'RING/U-box', 286594),
(479332, '0047625', NULL, NULL, 97, NULL, 'RING/U-box', 286594),
(479333, '0047624', NULL, NULL, 103, NULL, 'RING/U-box', 286594),
(479334, '0050087', NULL, NULL, 114, NULL, 'RING/U-box', 286594),
(479335, '0052268', NULL, NULL, 80, NULL, 'RING/U-box', 286594),
(479336, '0046140', NULL, NULL, 68, NULL, 'RING/U-box', 286594),
(479337, '0047475', NULL, NULL, 55, NULL, 'RING/U-box', 286594),
(479338, '0049212', NULL, NULL, 86, NULL, 'RING/U-box', 286594),
(479339, '0050469', NULL, NULL, 93, NULL, 'RING/U-box', 286594),
(479340, '0050527', NULL, NULL, 98, NULL, 'RING/U-box', 286594),
(479341, '0053934', NULL, NULL, 113, NULL, 'RING/U-box', 286594),
(479342, '0035646', NULL, NULL, 56, NULL, 'RING/U-box', 286594),
(479343, '0054129', NULL, NULL, 102, NULL, 'RING/U-box', 286594),
(479344, '0054689', NULL, NULL, 95, NULL, 'RING/U-box', 286594),
(479345, '0053909', NULL, NULL, 69, NULL, 'RING/U-box', 286594),
(479346, '0043836', NULL, NULL, 78, NULL, 'RING/U-box', 286594),
(479347, '0041252', NULL, NULL, 56, NULL, 'RING/U-box', 286594),
(479348, '0053608', NULL, NULL, 52, NULL, 'RING/U-box', 286594),
(479349, '0046745', NULL, NULL, 79, NULL, 'RING/U-box', 286594),
(479350, '0037309', NULL, NULL, 246, NULL, 'Phospholipase D/nuclease', 286595),
(479351, '0042590', NULL, NULL, 215, NULL, 'Phospholipase D/nuclease', 286595),
(479352, '0053240', NULL, NULL, 186, NULL, 'Phospholipase D/nuclease', 286595),
(479353, '0042591', NULL, NULL, 237, NULL, 'Phospholipase D/nuclease', 286595),
(479354, '0050932', NULL, NULL, 187, NULL, 'Phospholipase D/nuclease', 286595),
(479355, '0053903', NULL, NULL, 137, NULL, 'Phospholipase D/nuclease', 286595),
(479356, '0035785', NULL, NULL, 152, NULL, 'Phospholipase D/nuclease', 286595),
(479357, '0050933', NULL, NULL, 187, NULL, 'Phospholipase D/nuclease', 286595),
(479358, '0046667', NULL, NULL, 258, NULL, 'Phospholipase D/nuclease', 286595),
(479359, '0039810', NULL, NULL, 206, NULL, 'Phospholipase D/nuclease', 286595),
(479360, '0053239', NULL, NULL, 188, NULL, 'Phospholipase D/nuclease', 286595),
(479361, '0039811', NULL, NULL, 258, NULL, 'Phospholipase D/nuclease', 286595),
(479362, '0034967', NULL, NULL, 153, NULL, 'Carbamoyl phosphate synthetase, large subunit connection domain', 286596),
(479363, '0054288', NULL, NULL, 64, NULL, 'SO2669-like', 286597),
(479364, '0052598', NULL, NULL, 130, NULL, 'Transposase IS200-like', 286598),
(479365, '0052809', NULL, NULL, 130, NULL, 'Transposase IS200-like', 286598),
(479366, '0051712', NULL, NULL, 130, NULL, 'Transposase IS200-like', 286598),
(479367, '0051691', NULL, NULL, 142, NULL, 'GlcG-like', 286599),
(479368, '0037993', NULL, NULL, 149, NULL, 'Molybdenum cofactor biosynthesis proteins', 286600),
(479369, '0051200', NULL, NULL, 155, NULL, 'Molybdenum cofactor biosynthesis proteins', 286600),
(479370, '0036881', NULL, NULL, 160, NULL, 'Molybdenum cofactor biosynthesis proteins', 286600),
(479371, '0044572', NULL, NULL, 148, NULL, 'Molybdenum cofactor biosynthesis proteins', 286600),
(479372, '0050976', NULL, NULL, 143, NULL, 'Molybdenum cofactor biosynthesis proteins', 286600),
(479373, '0052616', NULL, NULL, 173, NULL, 'Molybdenum cofactor biosynthesis proteins', 286600),
(479374, '0050702', NULL, NULL, 144, NULL, 'Molybdenum cofactor biosynthesis proteins', 286600),
(479375, '0040986', NULL, NULL, 170, NULL, 'Molybdenum cofactor biosynthesis proteins', 286600),
(479376, '0043851', NULL, NULL, 155, NULL, 'Molybdenum cofactor biosynthesis proteins', 286600),
(479377, '0052822', NULL, NULL, 163, NULL, 'Molybdenum cofactor biosynthesis proteins', 286600),
(479378, '0036437', NULL, NULL, 190, NULL, 'Molybdenum cofactor biosynthesis proteins', 286600),
(479379, '0039613', NULL, NULL, 169, NULL, 'Molybdenum cofactor biosynthesis proteins', 286600); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(479380, '0038694', NULL, NULL, 34, NULL, 'p53 tetramerization domain', 286601),
(479381, '0043538', NULL, NULL, 42, NULL, 'p53 tetramerization domain', 286601),
(479382, '0034831', NULL, NULL, 29, NULL, 'p53 tetramerization domain', 286601),
(479383, '0053919', NULL, NULL, 64, NULL, 'E6 C-terminal domain-like', 286602),
(479384, '0043810', NULL, NULL, 226, NULL, 'Mannose-6-phosphate receptor binding protein 1 (Tip47), C-terminal domain', 286603),
(479385, '0037110', NULL, NULL, 77, NULL, 'Retrovirus capsid dimerization domain-like', 286604),
(479386, '0051231', NULL, NULL, 96, NULL, 'Retrovirus capsid dimerization domain-like', 286604),
(479387, '0045255', NULL, NULL, 75, NULL, 'Retrovirus capsid dimerization domain-like', 286604),
(479388, '0034953', NULL, NULL, 70, NULL, 'Retrovirus capsid dimerization domain-like', 286604),
(479389, '0042960', NULL, NULL, 84, NULL, 'Retrovirus capsid dimerization domain-like', 286604),
(479390, '0036227', NULL, NULL, 80, NULL, 'Retrovirus capsid dimerization domain-like', 286604),
(479391, '0052699', NULL, NULL, 92, NULL, 'Retrovirus capsid dimerization domain-like', 286604),
(479392, '0050225', NULL, NULL, 172, NULL, 'GlpP-like', 286605),
(479393, '0053400', NULL, NULL, 428, NULL, 'Colicin Ia, N-terminal domain', 286606),
(479394, '0048051', NULL, NULL, 339, NULL, 'Acid proteases', 286607),
(479395, '0045161', NULL, NULL, 325, NULL, 'Acid proteases', 286607),
(479396, '0037639', NULL, NULL, 391, NULL, 'Acid proteases', 286607),
(479397, '0045262', NULL, NULL, 330, NULL, 'Acid proteases', 286607),
(479398, '0040949', NULL, NULL, 373, NULL, 'Acid proteases', 286607),
(479399, '0045164', NULL, NULL, 356, NULL, 'Acid proteases', 286607),
(479400, '0041040', NULL, NULL, 357, NULL, 'Acid proteases', 286607),
(479401, '0036544', NULL, NULL, 329, NULL, 'Acid proteases', 286607),
(479402, '0036329', NULL, NULL, 99, NULL, 'Acid proteases', 286607),
(479403, '0035359', NULL, NULL, 327, NULL, 'Acid proteases', 286607),
(479404, '0038745', NULL, NULL, 203, NULL, 'Acid proteases', 286607),
(479405, '0039932', NULL, NULL, 99, NULL, 'Acid proteases', 286607),
(479406, '0038981', NULL, NULL, 99, NULL, 'Acid proteases', 286607),
(479407, '0043668', NULL, NULL, 335, NULL, 'Acid proteases', 286607),
(479408, '0038961', NULL, NULL, 325, NULL, 'Acid proteases', 286607),
(479409, '0035430', NULL, NULL, 124, NULL, 'Acid proteases', 286607),
(479410, '0036266', NULL, NULL, 99, NULL, 'Acid proteases', 286607),
(479411, '0035099', NULL, NULL, 324, NULL, 'Acid proteases', 286607),
(479412, '0039295', NULL, NULL, 323, NULL, 'Acid proteases', 286607),
(479413, '0041065', NULL, NULL, 99, NULL, 'Acid proteases', 286607),
(479414, '0042297', NULL, NULL, 375, NULL, 'Acid proteases', 286607),
(479415, '0039397', NULL, NULL, 334, NULL, 'Acid proteases', 286607),
(479416, '0040638', NULL, NULL, 328, NULL, 'Acid proteases', 286607),
(479417, '0049227', NULL, NULL, 99, NULL, 'Acid proteases', 286607),
(479418, '0045441', NULL, NULL, 124, NULL, 'Acid proteases', 286607),
(479419, '0042452', NULL, NULL, 326, NULL, 'Acid proteases', 286607),
(479420, '0045501', NULL, NULL, 323, NULL, 'Acid proteases', 286607),
(479421, '0041545', NULL, NULL, 107, NULL, 'Acid proteases', 286607),
(479422, '0049593', NULL, NULL, 99, NULL, 'Acid proteases', 286607),
(479423, '0049394', NULL, NULL, 99, NULL, 'Acid proteases', 286607),
(479424, '0050640', NULL, NULL, 340, NULL, 'Acid proteases', 286607),
(479425, '0045590', NULL, NULL, 113, NULL, 'Acid proteases', 286607),
(479426, '0035868', NULL, NULL, 99, NULL, 'Acid proteases', 286607),
(479427, '0038719', NULL, NULL, 373, NULL, 'Acid proteases', 286607),
(479428, '0036872', NULL, NULL, 342, NULL, 'Acid proteases', 286607),
(479429, '0054526', NULL, NULL, 141, NULL, 'Acid proteases', 286607),
(479430, '0035765', NULL, NULL, 323, NULL, 'Acid proteases', 286607),
(479431, '0043898', NULL, NULL, 381, NULL, 'Acid proteases', 286607),
(479432, '0035480', NULL, NULL, 99, NULL, 'Acid proteases', 286607),
(479433, '0037661', NULL, NULL, 104, NULL, 'Acid proteases', 286607);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(479434, '0042724', NULL, NULL, 338, NULL, 'Acid proteases', 286607),
(479435, '0038690', NULL, NULL, 337, NULL, 'Acid proteases', 286607),
(479436, '0045556', NULL, NULL, 370, NULL, 'Acid proteases', 286607),
(479437, '0036858', NULL, NULL, 59, NULL, 'Trefoil', 286608),
(479438, '0038599', NULL, NULL, 60, NULL, 'Trefoil', 286608),
(479439, '0045426', NULL, NULL, 53, NULL, 'Trefoil', 286608),
(479440, '0045425', NULL, NULL, 53, NULL, 'Trefoil', 286608),
(479441, '0049988', NULL, NULL, 100, NULL, 'Transcriptional repressor TraM', 286609),
(479442, '0046699', NULL, NULL, 158, NULL, 'TRADD, N-terminal domain', 286610),
(479443, '0054119', NULL, NULL, 111, NULL, 'gpW/gp25-like', 286611),
(479444, '0044727', NULL, NULL, 32, NULL, 'PetL subunit of the cytochrome b6f complex', 286612),
(479445, '0042670', NULL, NULL, 32, NULL, 'PetL subunit of the cytochrome b6f complex', 286612),
(479446, '0046946', NULL, NULL, 176, NULL, 'OMPA-like', 286613),
(479447, '0041003', NULL, NULL, 170, NULL, 'OMPA-like', 286613),
(479448, '0048693', NULL, NULL, 155, NULL, 'OMPA-like', 286613),
(479449, '0051384', NULL, NULL, 155, NULL, 'OMPA-like', 286613),
(479450, '0053719', NULL, NULL, 242, NULL, 'OMPA-like', 286613),
(479451, '0048966', NULL, NULL, 148, NULL, 'OMPA-like', 286613),
(479452, '0038508', NULL, NULL, 63, NULL, 'EGF/Laminin', 286614),
(479453, '0048473', NULL, NULL, 42, NULL, 'EGF/Laminin', 286614),
(479454, '0036644', NULL, NULL, 40, NULL, 'EGF/Laminin', 286614),
(479455, '0042294', NULL, NULL, 40, NULL, 'EGF/Laminin', 286614),
(479456, '0050997', NULL, NULL, 39, NULL, 'EGF/Laminin', 286614),
(479457, '0038148', NULL, NULL, 40, NULL, 'EGF/Laminin', 286614),
(479458, '0048718', NULL, NULL, 54, NULL, 'EGF/Laminin', 286614),
(479459, '0045804', NULL, NULL, 53, NULL, 'EGF/Laminin', 286614),
(479460, '0039114', NULL, NULL, 50, NULL, 'EGF/Laminin', 286614),
(479461, '0042295', NULL, NULL, 60, NULL, 'EGF/Laminin', 286614),
(479462, '0053580', NULL, NULL, 55, NULL, 'EGF/Laminin', 286614),
(479463, '0043221', NULL, NULL, 57, NULL, 'EGF/Laminin', 286614),
(479464, '0045767', NULL, NULL, 40, NULL, 'EGF/Laminin', 286614),
(479465, '0048437', NULL, NULL, 45, NULL, 'EGF/Laminin', 286614),
(479466, '0046899', NULL, NULL, 40, NULL, 'EGF/Laminin', 286614),
(479467, '0044080', NULL, NULL, 41, NULL, 'EGF/Laminin', 286614),
(479468, '0053592', NULL, NULL, 48, NULL, 'EGF/Laminin', 286614),
(479469, '0053152', NULL, NULL, 39, NULL, 'EGF/Laminin', 286614),
(479470, '0035423', NULL, NULL, 44, NULL, 'EGF/Laminin', 286614),
(479471, '0036113', NULL, NULL, 42, NULL, 'EGF/Laminin', 286614),
(479472, '0040564', NULL, NULL, 44, NULL, 'EGF/Laminin', 286614),
(479473, '0046901', NULL, NULL, 39, NULL, 'EGF/Laminin', 286614),
(479474, '0037086', NULL, NULL, 43, NULL, 'EGF/Laminin', 286614),
(479475, '0048204', NULL, NULL, 49, NULL, 'EGF/Laminin', 286614),
(479476, '0048447', NULL, NULL, 25, NULL, 'EGF/Laminin', 286614),
(479477, '0046224', NULL, NULL, 41, NULL, 'EGF/Laminin', 286614),
(479478, '0046589', NULL, NULL, 39, NULL, 'EGF/Laminin', 286614),
(479479, '0046108', NULL, NULL, 42, NULL, 'EGF/Laminin', 286614),
(479480, '0040565', NULL, NULL, 42, NULL, 'EGF/Laminin', 286614),
(479481, '0049664', NULL, NULL, 39, NULL, 'EGF/Laminin', 286614),
(479482, '0048531', NULL, NULL, 51, NULL, 'EGF/Laminin', 286614),
(479483, '0049663', NULL, NULL, 42, NULL, 'EGF/Laminin', 286614),
(479484, '0036621', NULL, NULL, 45, NULL, 'EGF/Laminin', 286614),
(479485, '0035212', NULL, NULL, 50, NULL, 'EGF/Laminin', 286614),
(479486, '0038803', NULL, NULL, 41, NULL, 'EGF/Laminin', 286614),
(479487, '0035211', NULL, NULL, 48, NULL, 'EGF/Laminin', 286614),
(479488, '0038126', NULL, NULL, 49, NULL, 'EGF/Laminin', 286614),
(479489, '0037555', NULL, NULL, 46, NULL, 'EGF/Laminin', 286614),
(479490, '0039776', NULL, NULL, 31, NULL, 'EGF/Laminin', 286614),
(479491, '0048292', NULL, NULL, 44, NULL, 'EGF/Laminin', 286614),
(479492, '0041189', NULL, NULL, 47, NULL, 'EGF/Laminin', 286614),
(479493, '0041188', NULL, NULL, 44, NULL, 'EGF/Laminin', 286614),
(479494, '0039055', NULL, NULL, 50, NULL, 'EGF/Laminin', 286614);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(479495, '0046553', NULL, NULL, 53, NULL, 'EGF/Laminin', 286614),
(479496, '0048017', NULL, NULL, 25, NULL, 'EGF/Laminin', 286614),
(479497, '0049500', NULL, NULL, 45, NULL, 'EGF/Laminin', 286614),
(479498, '0049665', NULL, NULL, 35, NULL, 'EGF/Laminin', 286614),
(479499, '0044576', NULL, NULL, 43, NULL, 'EGF/Laminin', 286614),
(479500, '0053080', NULL, NULL, 40, NULL, 'EGF/Laminin', 286614),
(479501, '0040138', NULL, NULL, 61, NULL, 'EGF/Laminin', 286614),
(479502, '0044577', NULL, NULL, 43, NULL, 'EGF/Laminin', 286614),
(479503, '0046120', NULL, NULL, 45, NULL, 'EGF/Laminin', 286614),
(479504, '0047694', NULL, NULL, 43, NULL, 'EGF/Laminin', 286614),
(479505, '0045033', NULL, NULL, 41, NULL, 'EGF/Laminin', 286614),
(479506, '0046121', NULL, NULL, 51, NULL, 'EGF/Laminin', 286614),
(479507, '0045912', NULL, NULL, 45, NULL, 'EGF/Laminin', 286614),
(479508, '0039882', NULL, NULL, 46, NULL, 'EGF/Laminin', 286614),
(479509, '0047815', NULL, NULL, 51, NULL, 'EGF/Laminin', 286614),
(479510, '0040142', NULL, NULL, 51, NULL, 'EGF/Laminin', 286614),
(479511, '0040141', NULL, NULL, 56, NULL, 'EGF/Laminin', 286614),
(479512, '0040140', NULL, NULL, 55, NULL, 'EGF/Laminin', 286614),
(479513, '0045115', NULL, NULL, 44, NULL, 'EGF/Laminin', 286614),
(479514, '0046526', NULL, NULL, 39, NULL, 'EGF/Laminin', 286614),
(479515, '0047931', NULL, NULL, 41, NULL, 'EGF/Laminin', 286614),
(479516, '0035087', NULL, NULL, 143, NULL, 'Scaffolding protein gpD of bacteriophage procapsid', 286615),
(479517, '0047320', NULL, NULL, 297, NULL, 'OMPT-like', 286616),
(479518, '0047725', NULL, NULL, 249, NULL, 'OMPT-like', 286616),
(479519, '0048639', NULL, NULL, 114, NULL, 'Fungal immunomodulatory protein, FIP', 286617),
(479520, '0052344', NULL, NULL, 180, NULL, 'Class II aaRS ABD-related', 286618),
(479521, '0035004', NULL, NULL, 96, NULL, 'Class II aaRS ABD-related', 286618),
(479522, '0052834', NULL, NULL, 117, NULL, 'Class II aaRS ABD-related', 286618),
(479523, '0037946', NULL, NULL, 127, NULL, 'Class II aaRS ABD-related', 286618),
(479524, '0050405', NULL, NULL, 154, NULL, 'Class II aaRS ABD-related', 286618),
(479525, '0037214', NULL, NULL, 110, NULL, 'Class II aaRS ABD-related', 286618),
(479526, '0041631', NULL, NULL, 113, NULL, 'Class II aaRS ABD-related', 286618),
(479527, '0035193', NULL, NULL, 111, NULL, 'Class II aaRS ABD-related', 286618),
(479528, '0041420', NULL, NULL, 127, NULL, 'Class II aaRS ABD-related', 286618),
(479529, '0038521', NULL, NULL, 127, NULL, 'Class II aaRS ABD-related', 286618),
(479530, '0050705', NULL, NULL, 97, NULL, 'Class II aaRS ABD-related', 286618),
(479531, '0040151', NULL, NULL, 99, NULL, 'Class II aaRS ABD-related', 286618),
(479532, '0042728', NULL, NULL, 95, NULL, 'Class II aaRS ABD-related', 286618),
(479533, '0044672', NULL, NULL, 130, NULL, 'Class II aaRS ABD-related', 286618),
(479534, '0041424', NULL, NULL, 126, NULL, 'Class II aaRS ABD-related', 286618),
(479535, '0043724', NULL, NULL, 282, NULL, 'CbiD-like', 286619),
(479536, '0049059', NULL, NULL, 435, NULL, 'Phosphoglycerate mutase-like', 286620),
(479537, '0049178', NULL, NULL, 243, NULL, 'Phosphoglycerate mutase-like', 286620),
(479538, '0053031', NULL, NULL, 342, NULL, 'Phosphoglycerate mutase-like', 286620),
(479539, '0051064', NULL, NULL, 241, NULL, 'Phosphoglycerate mutase-like', 286620),
(479540, '0053607', NULL, NULL, 191, NULL, 'Phosphoglycerate mutase-like', 286620),
(479541, '0043909', NULL, NULL, 249, NULL, 'Phosphoglycerate mutase-like', 286620),
(479542, '0039931', NULL, NULL, 219, NULL, 'Phosphoglycerate mutase-like', 286620),
(479543, '0050036', NULL, NULL, 171, NULL, 'Phosphoglycerate mutase-like', 286620),
(479544, '0037864', NULL, NULL, 211, NULL, 'Phosphoglycerate mutase-like', 286620),
(479545, '0036777', NULL, NULL, 247, NULL, 'Phosphoglycerate mutase-like', 286620),
(479546, '0036887', NULL, NULL, 202, NULL, 'Phosphoglycerate mutase-like', 286620),
(479547, '0035570', NULL, NULL, 219, NULL, 'Phosphoglycerate mutase-like', 286620),
(479548, '0047369', NULL, NULL, 438, NULL, 'Phosphoglycerate mutase-like', 286620);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(479549, '0049226', NULL, NULL, 342, NULL, 'Phosphoglycerate mutase-like', 286620),
(479550, '0048439', NULL, NULL, 391, NULL, 'Phosphoglycerate mutase-like', 286620),
(479551, '0048946', NULL, NULL, 447, NULL, 'Phosphoglycerate mutase-like', 286620),
(479552, '0046349', NULL, NULL, 409, NULL, 'Phosphoglycerate mutase-like', 286620),
(479553, '0048955', NULL, NULL, 240, NULL, 'Phosphoglycerate mutase-like', 286620),
(479554, '0051188', NULL, NULL, 248, NULL, 'BAR/IMD domain-like', 286621),
(479555, '0053884', NULL, NULL, 279, NULL, 'BAR/IMD domain-like', 286621),
(479556, '0052378', NULL, NULL, 237, NULL, 'BAR/IMD domain-like', 286621),
(479557, '0053885', NULL, NULL, 288, NULL, 'BAR/IMD domain-like', 286621),
(479558, '0047298', NULL, NULL, 200, NULL, 'BAR/IMD domain-like', 286621),
(479559, '0050766', NULL, NULL, 200, NULL, 'BAR/IMD domain-like', 286621),
(479560, '0049984', NULL, NULL, 217, NULL, 'BAR/IMD domain-like', 286621),
(479561, '0053888', NULL, NULL, 268, NULL, 'BAR/IMD domain-like', 286621),
(479562, '0042308', NULL, NULL, 137, NULL, 'PHM/PNGase F', 286622),
(479563, '0048758', NULL, NULL, 174, NULL, 'PHM/PNGase F', 286622),
(479564, '0051313', NULL, NULL, 152, NULL, 'PHM/PNGase F', 286622),
(479565, '0051314', NULL, NULL, 157, NULL, 'PHM/PNGase F', 286622),
(479566, '0040794', NULL, NULL, 265, NULL, 'Cytochrome c oxidase subunit III-like', 286623),
(479567, '0042845', NULL, NULL, 273, NULL, 'Cytochrome c oxidase subunit III-like', 286623),
(479568, '0041781', NULL, NULL, 261, NULL, 'Cytochrome c oxidase subunit III-like', 286623),
(479569, '0037559', NULL, NULL, 185, NULL, 'Cytochrome c oxidase subunit III-like', 286623),
(479570, '0047618', NULL, NULL, 137, NULL, 'Phosphotyrosine protein phosphatases I', 286624),
(479571, '0042188', NULL, NULL, 146, NULL, 'Phosphotyrosine protein phosphatases I', 286624),
(479572, '0046251', NULL, NULL, 159, NULL, 'Phosphotyrosine protein phosphatases I', 286624),
(479573, '0047572', NULL, NULL, 130, NULL, 'Phosphotyrosine protein phosphatases I', 286624),
(479574, '0048765', NULL, NULL, 154, NULL, 'Phosphotyrosine protein phosphatases I', 286624),
(479575, '0053360', NULL, NULL, 157, NULL, 'Phosphotyrosine protein phosphatases I', 286624),
(479576, '0051181', NULL, NULL, 124, NULL, 'Phosphotyrosine protein phosphatases I', 286624),
(479577, '0043165', NULL, NULL, 103, NULL, 'Bacillus phage protein', 286625),
(479578, '0049274', NULL, NULL, 67, NULL, 'RNA polymerase subunits', 286626),
(479579, '0047308', NULL, NULL, 46, NULL, 'RNA polymerase subunits', 286626),
(479580, '0053714', NULL, NULL, 35, NULL, 'Photosystem II reaction center protein I, PsbI', 286627),
(479581, '0048097', NULL, NULL, 108, NULL, 'FKBP-like', 286628),
(479582, '0052573', NULL, NULL, 79, NULL, 'FKBP-like', 286628),
(479583, '0043182', NULL, NULL, 118, NULL, 'FKBP-like', 286628),
(479584, '0040804', NULL, NULL, 107, NULL, 'FKBP-like', 286628),
(479585, '0041183', NULL, NULL, 125, NULL, 'FKBP-like', 286628),
(479586, '0052517', NULL, NULL, 79, NULL, 'FKBP-like', 286628),
(479587, '0040355', NULL, NULL, 106, NULL, 'FKBP-like', 286628),
(479588, '0039255', NULL, NULL, 151, NULL, 'FKBP-like', 286628),
(479589, '0042634', NULL, NULL, 210, NULL, 'FKBP-like', 286628),
(479590, '0044934', NULL, NULL, 116, NULL, 'FKBP-like', 286628),
(479591, '0040253', NULL, NULL, 115, NULL, 'FKBP-like', 286628),
(479592, '0040252', NULL, NULL, 111, NULL, 'FKBP-like', 286628),
(479593, '0040250', NULL, NULL, 115, NULL, 'FKBP-like', 286628),
(479594, '0039396', NULL, NULL, 120, NULL, 'FKBP-like', 286628),
(479595, '0042239', NULL, NULL, 116, NULL, 'FKBP-like', 286628),
(479596, '0042333', NULL, NULL, 119, NULL, 'FKBP-like', 286628),
(479597, '0045075', NULL, NULL, 113, NULL, 'FKBP-like', 286628),
(479598, '0037129', NULL, NULL, 96, NULL, 'FKBP-like', 286628),
(479599, '0038779', NULL, NULL, 85, NULL, 'FKBP-like', 286628),
(479600, '0035884', NULL, NULL, 107, NULL, 'FKBP-like', 286628),
(479601, '0039667', NULL, NULL, 92, NULL, 'FKBP-like', 286628),
(479602, '0037500', NULL, NULL, 204, NULL, 'FKBP-like', 286628);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(479603, '0038237', NULL, NULL, 79, NULL, 'FKBP-like', 286628),
(479604, '0035600', NULL, NULL, 107, NULL, 'FKBP-like', 286628),
(479605, '0039784', NULL, NULL, 160, NULL, 'FKBP-like', 286628),
(479606, '0042567', NULL, NULL, 117, NULL, 'FKBP-like', 286628),
(479607, '0043832', NULL, NULL, 113, NULL, 'FKBP-like', 286628),
(479608, '0049810', NULL, NULL, 125, NULL, 'FKBP-like', 286628),
(479609, '0040249', NULL, NULL, 106, NULL, 'FKBP-like', 286628),
(479610, '0041898', NULL, NULL, 72, NULL, 'FKBP-like', 286628),
(479611, '0053169', NULL, NULL, 105, NULL, 'YeeU-like', 286629),
(479612, '0053119', NULL, NULL, 117, NULL, 'YeeU-like', 286629),
(479613, '0052985', NULL, NULL, 107, NULL, 'YeeU-like', 286629),
(479614, '0048274', NULL, NULL, 130, NULL, 'DEATH domain', 286630),
(479615, '0046261', NULL, NULL, 102, NULL, 'DEATH domain', 286630),
(479616, '0053685', NULL, NULL, 108, NULL, 'DEATH domain', 286630),
(479617, '0045580', NULL, NULL, 97, NULL, 'DEATH domain', 286630),
(479618, '0042393', NULL, NULL, 93, NULL, 'DEATH domain', 286630),
(479619, '0044274', NULL, NULL, 91, NULL, 'DEATH domain', 286630),
(479620, '0041381', NULL, NULL, 85, NULL, 'DEATH domain', 286630),
(479621, '0036368', NULL, NULL, 127, NULL, 'DEATH domain', 286630),
(479622, '0050656', NULL, NULL, 90, NULL, 'DEATH domain', 286630),
(479623, '0036756', NULL, NULL, 104, NULL, 'DEATH domain', 286630),
(479624, '0050544', NULL, NULL, 127, NULL, 'DEATH domain', 286630),
(479625, '0036251', NULL, NULL, 150, NULL, 'DEATH domain', 286630),
(479626, '0038970', NULL, NULL, 87, NULL, 'DEATH domain', 286630),
(479627, '0036193', NULL, NULL, 93, NULL, 'DEATH domain', 286630),
(479628, '0037465', NULL, NULL, 95, NULL, 'DEATH domain', 286630),
(479629, '0036420', NULL, NULL, 89, NULL, 'DEATH domain', 286630),
(479630, '0045697', NULL, NULL, 83, NULL, 'DEATH domain', 286630),
(479631, '0045502', NULL, NULL, 100, NULL, 'DEATH domain', 286630),
(479632, '0046373', NULL, NULL, 309, NULL, 'Chelatase', 286631),
(479633, '0049646', NULL, NULL, 125, NULL, 'Chelatase', 286631),
(479634, '0047952', NULL, NULL, 356, NULL, 'Chelatase', 286631),
(479635, '0048953', NULL, NULL, 257, NULL, 'Chelatase', 286631),
(479636, '0047228', NULL, NULL, 359, NULL, 'Chelatase', 286631),
(479637, '0054465', NULL, NULL, 119, NULL, 'TM1646-like', 286632),
(479638, '0046739', NULL, NULL, 150, NULL, 'PAP/OAS1 substrate-binding domain', 286633),
(479639, '0037393', NULL, NULL, 150, NULL, 'PAP/OAS1 substrate-binding domain', 286633),
(479640, '0042506', NULL, NULL, 146, NULL, 'PAP/OAS1 substrate-binding domain', 286633),
(479641, '0051903', NULL, NULL, 183, NULL, 'PAP/OAS1 substrate-binding domain', 286633),
(479642, '0054491', NULL, NULL, 145, NULL, 'PAP/OAS1 substrate-binding domain', 286633),
(479643, '0043167', NULL, NULL, 115, NULL, 'PAP/OAS1 substrate-binding domain', 286633),
(479644, '0050134', NULL, NULL, 126, NULL, 'Nudix', 286634),
(479645, '0052791', NULL, NULL, 135, NULL, 'Nudix', 286634),
(479646, '0050097', NULL, NULL, 158, NULL, 'Nudix', 286634),
(479647, '0051867', NULL, NULL, 147, NULL, 'Nudix', 286634),
(479648, '0050219', NULL, NULL, 131, NULL, 'Nudix', 286634),
(479649, '0051868', NULL, NULL, 155, NULL, 'Nudix', 286634),
(479650, '0052634', NULL, NULL, 147, NULL, 'Nudix', 286634),
(479651, '0037875', NULL, NULL, 209, NULL, 'Nudix', 286634),
(479652, '0052710', NULL, NULL, 161, NULL, 'Nudix', 286634),
(479653, '0047729', NULL, NULL, 152, NULL, 'Nudix', 286634),
(479654, '0041520', NULL, NULL, 187, NULL, 'Nudix', 286634),
(479655, '0051716', NULL, NULL, 151, NULL, 'Nudix', 286634),
(479656, '0043363', NULL, NULL, 127, NULL, 'Nudix', 286634),
(479657, '0047428', NULL, NULL, 156, NULL, 'Nudix', 286634),
(479658, '0040258', NULL, NULL, 137, NULL, 'Nudix', 286634),
(479659, '0048878', NULL, NULL, 292, NULL, 'Nudix', 286634),
(479660, '0050220', NULL, NULL, 97, NULL, 'Nudix', 286634),
(479661, '0047252', NULL, NULL, 176, NULL, 'Nudix', 286634),
(479662, '0049771', NULL, NULL, 196, NULL, 'Nudix', 286634),
(479663, '0050821', NULL, NULL, 142, NULL, 'Nudix', 286634);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(479664, '0051875', NULL, NULL, 146, NULL, 'Nudix', 286634),
(479665, '0044789', NULL, NULL, 189, NULL, 'Nudix', 286634),
(479666, '0043415', NULL, NULL, 160, NULL, 'Nudix', 286634),
(479667, '0044768', NULL, NULL, 186, NULL, 'Nudix', 286634),
(479668, '0041034', NULL, NULL, 202, NULL, 'Nudix', 286634),
(479669, '0052719', NULL, NULL, 202, NULL, 'Nudix', 286634),
(479670, '0051092', NULL, NULL, 153, NULL, 'Nudix', 286634),
(479671, '0048821', NULL, NULL, 129, NULL, 'Nudix', 286634),
(479672, '0046700', NULL, NULL, 165, NULL, 'Nudix', 286634),
(479673, '0048869', NULL, NULL, 171, NULL, 'Nudix', 286634),
(479674, '0049418', NULL, NULL, 158, NULL, 'Nudix', 286634),
(479675, '0046406', NULL, NULL, 145, NULL, 'ENTH/VHS domain', 286635),
(479676, '0046580', NULL, NULL, 153, NULL, 'ENTH/VHS domain', 286635),
(479677, '0047397', NULL, NULL, 148, NULL, 'ENTH/VHS domain', 286635),
(479678, '0049499', NULL, NULL, 144, NULL, 'ENTH/VHS domain', 286635),
(479679, '0038572', NULL, NULL, 131, NULL, 'ENTH/VHS domain', 286635),
(479680, '0038769', NULL, NULL, 140, NULL, 'ENTH/VHS domain', 286635),
(479681, '0040934', NULL, NULL, 143, NULL, 'ENTH/VHS domain', 286635),
(479682, '0046653', NULL, NULL, 144, NULL, 'ENTH/VHS domain', 286635),
(479683, '0047697', NULL, NULL, 140, NULL, 'ENTH/VHS domain', 286635),
(479684, '0039767', NULL, NULL, 151, NULL, 'ENTH/VHS domain', 286635),
(479685, '0037289', NULL, NULL, 124, NULL, 'a domain/subunit of cytochrome bc1 complex (Ubiquinol-cytochrome c reductase)', 286636),
(479686, '0035452', NULL, NULL, 119, NULL, 'a domain/subunit of cytochrome bc1 complex (Ubiquinol-cytochrome c reductase)', 286636),
(479687, '0048907', NULL, NULL, 156, NULL, 'a domain/subunit of cytochrome bc1 complex (Ubiquinol-cytochrome c reductase)', 286636),
(479688, '0035489', NULL, NULL, 119, NULL, 'a domain/subunit of cytochrome bc1 complex (Ubiquinol-cytochrome c reductase)', 286636),
(479689, '0053865', NULL, NULL, 160, NULL, 'a domain/subunit of cytochrome bc1 complex (Ubiquinol-cytochrome c reductase)', 286636),
(479690, '0050008', NULL, NULL, 80, NULL, 'General secretion pathway protein M, EpsM', 286637),
(479691, '0040990', NULL, NULL, 134, NULL, 'OsmC-like', 286638),
(479692, '0044506', NULL, NULL, 137, NULL, 'OsmC-like', 286638),
(479693, '0044408', NULL, NULL, 141, NULL, 'OsmC-like', 286638),
(479694, '0054386', NULL, NULL, 139, NULL, 'OsmC-like', 286638),
(479695, '0040616', NULL, NULL, 141, NULL, 'OsmC-like', 286638),
(479696, '0054529', NULL, NULL, 132, NULL, 'OsmC-like', 286638),
(479697, '0041625', NULL, NULL, 162, NULL, 'OsmC-like', 286638),
(479698, '0053803', NULL, NULL, 155, NULL, 'OsmC-like', 286638),
(479699, '0044862', NULL, NULL, 144, NULL, 'OsmC-like', 286638),
(479700, '0041204', NULL, NULL, 142, NULL, 'OsmC-like', 286638),
(479701, '0054404', NULL, NULL, 182, NULL, 'OsmC-like', 286638),
(479702, '0049284', NULL, NULL, 61, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479703, '0051388', NULL, NULL, 88, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479704, '0052277', NULL, NULL, 88, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479705, '0038966', NULL, NULL, 94, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479706, '0051844', NULL, NULL, 65, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479707, '0050779', NULL, NULL, 87, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479708, '0054537', NULL, NULL, 62, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479709, '0051249', NULL, NULL, 79, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479710, '0052016', NULL, NULL, 71, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479711, '0053325', NULL, NULL, 65, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479712, '0049180', NULL, NULL, 97, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479713, '0051985', NULL, NULL, 62, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479714, '0044558', NULL, NULL, 59, NULL, 'lambda repressor-like DNA-binding domains', 286639);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(479715, '0036085', NULL, NULL, 66, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479716, '0051837', NULL, NULL, 67, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479717, '0043707', NULL, NULL, 64, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479718, '0053040', NULL, NULL, 57, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479719, '0043143', NULL, NULL, 63, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479720, '0045765', NULL, NULL, 76, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479721, '0041348', NULL, NULL, 74, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479722, '0054369', NULL, NULL, 82, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479723, '0054127', NULL, NULL, 87, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479724, '0051234', NULL, NULL, 69, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479725, '0051630', NULL, NULL, 78, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479726, '0054323', NULL, NULL, 89, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479727, '0052264', NULL, NULL, 65, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479728, '0050602', NULL, NULL, 101, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479729, '0050546', NULL, NULL, 101, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479730, '0035201', NULL, NULL, 72, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479731, '0036752', NULL, NULL, 75, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479732, '0050548', NULL, NULL, 111, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479733, '0050823', NULL, NULL, 78, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479734, '0054428', NULL, NULL, 162, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479735, '0036955', NULL, NULL, 59, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479736, '0051711', NULL, NULL, 69, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479737, '0051908', NULL, NULL, 77, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479738, '0046409', NULL, NULL, 86, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479739, '0044906', NULL, NULL, 56, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479740, '0049316', NULL, NULL, 120, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479741, '0049337', NULL, NULL, 80, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479742, '0042440', NULL, NULL, 56, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479743, '0045855', NULL, NULL, 68, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479744, '0049999', NULL, NULL, 66, NULL, 'lambda repressor-like DNA-binding domains', 286639),
(479745, '0053713', NULL, NULL, 64, NULL, 'Photosystem II 10 kDa phosphoprotein PsbH', 286640),
(479746, '0053455', NULL, NULL, 160, NULL, 'Influenza hemagglutinin (stalk)', 286641),
(479747, '0053521', NULL, NULL, 166, NULL, 'Influenza hemagglutinin (stalk)', 286641),
(479748, '0053500', NULL, NULL, 150, NULL, 'Influenza hemagglutinin (stalk)', 286641),
(479749, '0053561', NULL, NULL, 175, NULL, 'Influenza hemagglutinin (stalk)', 286641),
(479750, '0053507', NULL, NULL, 175, NULL, 'Influenza hemagglutinin (stalk)', 286641),
(479751, '0053508', NULL, NULL, 160, NULL, 'Influenza hemagglutinin (stalk)', 286641),
(479752, '0053413', NULL, NULL, 162, NULL, 'Influenza hemagglutinin (stalk)', 286641),
(479753, '0053435', NULL, NULL, 173, NULL, 'Influenza hemagglutinin (stalk)', 286641),
(479754, '0054208', NULL, NULL, 69, NULL, 'PB2 C-terminal domain-like', 286642),
(479755, '0037024', NULL, NULL, 77, NULL, 'RPB5-like RNA polymerase subunit', 286643),
(479756, '0036685', NULL, NULL, 72, NULL, 'RPB5-like RNA polymerase subunit', 286643),
(479757, '0038639', NULL, NULL, 68, NULL, 'RPB5-like RNA polymerase subunit', 286643),
(479758, '0054902', NULL, NULL, 192, NULL, 'DhaL-like', 286644);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(479759, '0044458', NULL, NULL, 215, NULL, 'DhaL-like', 286644),
(479760, '0051891', NULL, NULL, 151, NULL, 'Cytidine deaminase-like', 286645),
(479761, '0052851', NULL, NULL, 189, NULL, 'Cytidine deaminase-like', 286645),
(479762, '0054555', NULL, NULL, 251, NULL, 'Cytidine deaminase-like', 286645),
(479763, '0052373', NULL, NULL, 124, NULL, 'Cytidine deaminase-like', 286645),
(479764, '0053055', NULL, NULL, 147, NULL, 'Cytidine deaminase-like', 286645),
(479765, '0043140', NULL, NULL, 141, NULL, 'Cytidine deaminase-like', 286645),
(479766, '0044240', NULL, NULL, 151, NULL, 'Cytidine deaminase-like', 286645),
(479767, '0051560', NULL, NULL, 295, NULL, 'Cytidine deaminase-like', 286645),
(479768, '0050283', NULL, NULL, 193, NULL, 'Cytidine deaminase-like', 286645),
(479769, '0051482', NULL, NULL, 156, NULL, 'Cytidine deaminase-like', 286645),
(479770, '0052747', NULL, NULL, 136, NULL, 'Cytidine deaminase-like', 286645),
(479771, '0039755', NULL, NULL, 131, NULL, 'Cytidine deaminase-like', 286645),
(479772, '0050664', NULL, NULL, 125, NULL, 'Cytidine deaminase-like', 286645),
(479773, '0050730', NULL, NULL, 151, NULL, 'Cytidine deaminase-like', 286645),
(479774, '0037995', NULL, NULL, 393, NULL, 'Cytidine deaminase-like', 286645),
(479775, '0051897', NULL, NULL, 145, NULL, 'Cytidine deaminase-like', 286645),
(479776, '0035094', NULL, NULL, 144, NULL, 'Cytidine deaminase-like', 286645),
(479777, '0041046', NULL, NULL, 130, NULL, 'Cytidine deaminase-like', 286645),
(479778, '0035093', NULL, NULL, 150, NULL, 'Cytidine deaminase-like', 286645),
(479779, '0050639', NULL, NULL, 158, NULL, 'Cytidine deaminase-like', 286645),
(479780, '0051727', NULL, NULL, 130, NULL, 'Cytidine deaminase-like', 286645),
(479781, '0044829', NULL, NULL, 147, NULL, 'Cytidine deaminase-like', 286645),
(479782, '0042364', NULL, NULL, 392, NULL, 'Cytidine deaminase-like', 286645),
(479783, '0047726', NULL, NULL, 61, NULL, 'Penicillin-binding protein 2x (pbp-2x), c-terminal domain', 286646),
(479784, '0039857', NULL, NULL, 58, NULL, 'Penicillin-binding protein 2x (pbp-2x), c-terminal domain', 286646),
(479785, '0043332', NULL, NULL, 58, NULL, 'Penicillin-binding protein 2x (pbp-2x), c-terminal domain', 286646),
(479786, '0042861', NULL, NULL, 61, NULL, 'Penicillin-binding protein 2x (pbp-2x), c-terminal domain', 286646),
(479787, '0042862', NULL, NULL, 58, NULL, 'Penicillin-binding protein 2x (pbp-2x), c-terminal domain', 286646),
(479788, '0038256', NULL, NULL, 274, NULL, 'AraD/HMP-PK domain-like', 286647),
(479789, '0036761', NULL, NULL, 206, NULL, 'AraD/HMP-PK domain-like', 286647),
(479790, '0054508', NULL, NULL, 180, NULL, 'AraD/HMP-PK domain-like', 286647),
(479791, '0039491', NULL, NULL, 223, NULL, 'AraD/HMP-PK domain-like', 286647),
(479792, '0054490', NULL, NULL, 184, NULL, 'AraD/HMP-PK domain-like', 286647),
(479793, '0042497', NULL, NULL, 232, NULL, 'AraD/HMP-PK domain-like', 286647),
(479794, '0048152', NULL, NULL, 81, NULL, 'Methylated DNA-protein cysteine methyltransferase, C-terminal domain', 286648),
(479795, '0048993', NULL, NULL, 85, NULL, 'Methylated DNA-protein cysteine methyltransferase, C-terminal domain', 286648),
(479796, '0049380', NULL, NULL, 84, NULL, 'Methylated DNA-protein cysteine methyltransferase, C-terminal domain', 286648),
(479797, '0043747', NULL, NULL, 108, NULL, 'mRNA decapping enzyme DcpS N-terminal domain', 286649),
(479798, '0044882', NULL, NULL, 107, NULL, 'mRNA decapping enzyme DcpS N-terminal domain', 286649),
(479799, '0054225', NULL, NULL, 66, NULL, 'NifT/FixU-like', 286650),
(479800, '0037650', NULL, NULL, 155, NULL, 'TRAF domain-like', 286651),
(479801, '0040442', NULL, NULL, 155, NULL, 'TRAF domain-like', 286651),
(479802, '0052253', NULL, NULL, 146, NULL, 'TRAF domain-like', 286651),
(479803, '0039868', NULL, NULL, 190, NULL, 'TRAF domain-like', 286651),
(479804, '0036213', NULL, NULL, 152, NULL, 'TRAF domain-like', 286651),
(479805, '0043727', NULL, NULL, 152, NULL, '2-isopropylmalate synthase LeuA, allosteric (dimerisation) domain', 286652),
(479806, '0038641', NULL, NULL, 384, NULL, 'Chondroitin AC/alginate lyase', 286653);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(479807, '0037333', NULL, NULL, 371, NULL, 'Chondroitin AC/alginate lyase', 286653),
(479808, '0043392', NULL, NULL, 369, NULL, 'Chondroitin AC/alginate lyase', 286653),
(479809, '0046100', NULL, NULL, 310, NULL, 'Chondroitin AC/alginate lyase', 286653),
(479810, '0048918', NULL, NULL, 351, NULL, 'Chondroitin AC/alginate lyase', 286653),
(479811, '0039308', NULL, NULL, 361, NULL, 'Chondroitin AC/alginate lyase', 286653),
(479812, '0036993', NULL, NULL, 370, NULL, 'Chondroitin AC/alginate lyase', 286653),
(479813, '0053971', NULL, NULL, 157, NULL, 'Ran-GTPase activating protein 1 (RanGAP1), C-terminal domain', 286654),
(479814, '0047852', NULL, NULL, 156, NULL, 'Ran-GTPase activating protein 1 (RanGAP1), C-terminal domain', 286654),
(479815, '0040491', NULL, NULL, 170, NULL, 'VSV matrix protein', 286655),
(479816, '0044866', NULL, NULL, 597, NULL, 'Molybdenum cofactor-binding domain', 286656),
(479817, '0048288', NULL, NULL, 663, NULL, 'Molybdenum cofactor-binding domain', 286656),
(479818, '0039729', NULL, NULL, 654, NULL, 'Molybdenum cofactor-binding domain', 286656),
(479819, '0046330', NULL, NULL, 596, NULL, 'Molybdenum cofactor-binding domain', 286656),
(479820, '0049206', NULL, NULL, 636, NULL, 'Molybdenum cofactor-binding domain', 286656),
(479821, '0037702', NULL, NULL, 638, NULL, 'Molybdenum cofactor-binding domain', 286656),
(479822, '0046775', NULL, NULL, 657, NULL, 'Molybdenum cofactor-binding domain', 286656),
(479823, '0043860', NULL, NULL, 621, NULL, 'Molybdenum cofactor-binding domain', 286656),
(479824, '0040997', NULL, NULL, 176, NULL, 'RuBisCo LSMT C-terminal, substrate-binding domain', 286657),
(479825, '0051729', NULL, NULL, 134, NULL, 'USP8 N-terminal domain-like', 286658),
(479826, '0039123', NULL, NULL, 96, NULL, 'Arginyl-tRNA synthetase (ArgRS), N-terminal ''additional'' domain', 286659),
(479827, '0035692', NULL, NULL, 131, NULL, 'Arginyl-tRNA synthetase (ArgRS), N-terminal ''additional'' domain', 286659),
(479828, '0048063', NULL, NULL, 102, NULL, 'N-utilization substance G protein NusG, N-terminal domain', 286660),
(479829, '0048470', NULL, NULL, 119, NULL, 'N-utilization substance G protein NusG, N-terminal domain', 286660),
(479830, '0045482', NULL, NULL, 140, NULL, 'MurD-like peptide ligases, peptide-binding domain', 286661),
(479831, '0048688', NULL, NULL, 152, NULL, 'MurD-like peptide ligases, peptide-binding domain', 286661),
(479832, '0046486', NULL, NULL, 160, NULL, 'MurD-like peptide ligases, peptide-binding domain', 286661),
(479833, '0038083', NULL, NULL, 135, NULL, 'MurD-like peptide ligases, peptide-binding domain', 286661),
(479834, '0039392', NULL, NULL, 151, NULL, 'MurD-like peptide ligases, peptide-binding domain', 286661),
(479835, '0052865', NULL, NULL, 129, NULL, 'MurD-like peptide ligases, peptide-binding domain', 286661),
(479836, '0041698', NULL, NULL, 137, NULL, 'MurD-like peptide ligases, peptide-binding domain', 286661),
(479837, '0052936', NULL, NULL, 154, NULL, 'Duplicated hybrid motif', 286662),
(479838, '0047037', NULL, NULL, 158, NULL, 'Duplicated hybrid motif', 286662),
(479839, '0047009', NULL, NULL, 168, NULL, 'Duplicated hybrid motif', 286662),
(479840, '0043026', NULL, NULL, 270, NULL, 'Duplicated hybrid motif', 286662),
(479841, '0050936', NULL, NULL, 108, NULL, 'Nucleoplasmin-like core domain', 286663),
(479842, '0048385', NULL, NULL, 105, NULL, 'Nucleoplasmin-like core domain', 286663),
(479843, '0047752', NULL, NULL, 105, NULL, 'Nucleoplasmin-like core domain', 286663),
(479844, '0052087', NULL, NULL, 57, NULL, 'BAS1536-like', 286664),
(479845, '0052083', NULL, NULL, 54, NULL, 'BAS1536-like', 286664),
(479846, '0051540', NULL, NULL, 197, NULL, 'PUA domain-like', 286665),
(479847, '0054831', NULL, NULL, 204, NULL, 'PUA domain-like', 286665),
(479848, '0054796', NULL, NULL, 209, NULL, 'PUA domain-like', 286665),
(479849, '0050072', NULL, NULL, 63, NULL, 'PUA domain-like', 286665),
(479850, '0049288', NULL, NULL, 110, NULL, 'PUA domain-like', 286665),
(479851, '0051801', NULL, NULL, 110, NULL, 'PUA domain-like', 286665),
(479852, '0038846', NULL, NULL, 169, NULL, 'PUA domain-like', 286665);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(479853, '0051822', NULL, NULL, 72, NULL, 'PUA domain-like', 286665),
(479854, '0039975', NULL, NULL, 62, NULL, 'PUA domain-like', 286665),
(479855, '0052338', NULL, NULL, 93, NULL, 'PUA domain-like', 286665),
(479856, '0043106', NULL, NULL, 81, NULL, 'PUA domain-like', 286665),
(479857, '0044757', NULL, NULL, 72, NULL, 'PUA domain-like', 286665),
(479858, '0043605', NULL, NULL, 57, NULL, 'PUA domain-like', 286665),
(479859, '0051817', NULL, NULL, 157, NULL, 'PUA domain-like', 286665),
(479860, '0049549', NULL, NULL, 76, NULL, 'PUA domain-like', 286665),
(479861, '0049603', NULL, NULL, 103, NULL, 'PUA domain-like', 286665),
(479862, '0050660', NULL, NULL, 145, NULL, 'PUA domain-like', 286665),
(479863, '0051036', NULL, NULL, 113, NULL, 'PUA domain-like', 286665),
(479864, '0054301', NULL, NULL, 80, NULL, 'PUA domain-like', 286665),
(479865, '0052541', NULL, NULL, 84, NULL, 'PUA domain-like', 286665),
(479866, '0054564', NULL, NULL, 68, NULL, 'PUA domain-like', 286665),
(479867, '0052482', NULL, NULL, 120, NULL, 'PUA domain-like', 286665),
(479868, '0050744', NULL, NULL, 64, NULL, 'PUA domain-like', 286665),
(479869, '0050865', NULL, NULL, 161, NULL, 'PUA domain-like', 286665),
(479870, '0052824', NULL, NULL, 148, NULL, 'PUA domain-like', 286665),
(479871, '0039128', NULL, NULL, 77, NULL, 'PUA domain-like', 286665),
(479872, '0051555', NULL, NULL, 146, NULL, 'PUA domain-like', 286665),
(479873, '0052524', NULL, NULL, 148, NULL, 'PUA domain-like', 286665),
(479874, '0037984', NULL, NULL, 167, NULL, 'PUA domain-like', 286665),
(479875, '0053955', NULL, NULL, 102, NULL, 'PUA domain-like', 286665),
(479876, '0051810', NULL, NULL, 85, NULL, 'PUA domain-like', 286665),
(479877, '0052864', NULL, NULL, 136, NULL, 'PUA domain-like', 286665),
(479878, '0042644', NULL, NULL, 85, NULL, 'PUA domain-like', 286665),
(479879, '0051929', NULL, NULL, 68, NULL, 'PUA domain-like', 286665),
(479880, '0039543', NULL, NULL, 173, NULL, 'PUA domain-like', 286665),
(479881, '0044608', NULL, NULL, 132, NULL, 'PUA domain-like', 286665),
(479882, '0043893', NULL, NULL, 166, NULL, 'PUA domain-like', 286665),
(479883, '0041612', NULL, NULL, 72, NULL, 'PUA domain-like', 286665),
(479884, '0051220', NULL, NULL, 60, NULL, 'L27 domain', 286666),
(479885, '0051594', NULL, NULL, 54, NULL, 'L27 domain', 286666),
(479886, '0050166', NULL, NULL, 58, NULL, 'L27 domain', 286666),
(479887, '0051593', NULL, NULL, 50, NULL, 'L27 domain', 286666),
(479888, '0051218', NULL, NULL, 57, NULL, 'L27 domain', 286666),
(479889, '0051219', NULL, NULL, 62, NULL, 'L27 domain', 286666),
(479890, '0043366', NULL, NULL, 60, NULL, 'L27 domain', 286666),
(479891, '0043367', NULL, NULL, 56, NULL, 'L27 domain', 286666),
(479892, '0044732', NULL, NULL, 51, NULL, 'L27 domain', 286666),
(479893, '0050763', NULL, NULL, 298, NULL, 'NadA-like', 286667),
(479894, '0053642', NULL, NULL, 72, NULL, 'Ribosomal protein L11, C-terminal domain', 286668),
(479895, '0047166', NULL, NULL, 74, NULL, 'Ribosomal protein L11, C-terminal domain', 286668),
(479896, '0054892', NULL, NULL, 67, NULL, 'Ribosomal protein L11, C-terminal domain', 286668),
(479897, '0049332', NULL, NULL, 70, NULL, 'Ribosomal protein L11, C-terminal domain', 286668),
(479898, '0048192', NULL, NULL, 70, NULL, 'Ribosomal protein L11, C-terminal domain', 286668),
(479899, '0053998', NULL, NULL, 68, NULL, 'Ribosomal protein L11, C-terminal domain', 286668),
(479900, '0047741', NULL, NULL, 387, NULL, 'Galactose oxidase, central domain', 286669),
(479901, '0044290', NULL, NULL, 149, NULL, 'Actin depolymerizing proteins', 286670),
(479902, '0036224', NULL, NULL, 127, NULL, 'Actin depolymerizing proteins', 286670),
(479903, '0036223', NULL, NULL, 96, NULL, 'Actin depolymerizing proteins', 286670),
(479904, '0039398', NULL, NULL, 116, NULL, 'Actin depolymerizing proteins', 286670),
(479905, '0042657', NULL, NULL, 166, NULL, 'Actin depolymerizing proteins', 286670),
(479906, '0035078', NULL, NULL, 174, NULL, 'Actin depolymerizing proteins', 286670),
(479907, '0036222', NULL, NULL, 149, NULL, 'Actin depolymerizing proteins', 286670);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(479908, '0044639', NULL, NULL, 151, NULL, 'Actin depolymerizing proteins', 286670),
(479909, '0036221', NULL, NULL, 121, NULL, 'Actin depolymerizing proteins', 286670),
(479910, '0036220', NULL, NULL, 110, NULL, 'Actin depolymerizing proteins', 286670),
(479911, '0038681', NULL, NULL, 139, NULL, 'Actin depolymerizing proteins', 286670),
(479912, '0039551', NULL, NULL, 102, NULL, 'Actin depolymerizing proteins', 286670),
(479913, '0039550', NULL, NULL, 114, NULL, 'Actin depolymerizing proteins', 286670),
(479914, '0041507', NULL, NULL, 96, NULL, 'Actin depolymerizing proteins', 286670),
(479915, '0043781', NULL, NULL, 102, NULL, 'Actin depolymerizing proteins', 286670),
(479916, '0040776', NULL, NULL, 133, NULL, 'Actin depolymerizing proteins', 286670),
(479917, '0044994', NULL, NULL, 145, NULL, 'Actin depolymerizing proteins', 286670),
(479918, '0035967', NULL, NULL, 133, NULL, 'Actin depolymerizing proteins', 286670),
(479919, '0037429', NULL, NULL, 124, NULL, 'Actin depolymerizing proteins', 286670),
(479920, '0050504', NULL, NULL, 151, NULL, 'Actin depolymerizing proteins', 286670),
(479921, '0053314', NULL, NULL, 126, NULL, 'Actin depolymerizing proteins', 286670),
(479922, '0036074', NULL, NULL, 134, NULL, 'Actin depolymerizing proteins', 286670),
(479923, '0040022', NULL, NULL, 104, NULL, 'Actin depolymerizing proteins', 286670),
(479924, '0038372', NULL, NULL, 96, NULL, 'Actin depolymerizing proteins', 286670),
(479925, '0049533', NULL, NULL, 144, NULL, 'Actin depolymerizing proteins', 286670),
(479926, '0044267', NULL, NULL, 480, NULL, 'Hypothetical protein PH1602', 286671),
(479927, '0049164', NULL, NULL, 91, NULL, 'Immunoglobulin', 286672),
(479928, '0047783', NULL, NULL, 102, NULL, 'Immunoglobulin', 286672),
(479929, '0040903', NULL, NULL, 101, NULL, 'Immunoglobulin', 286672),
(479930, '0038946', NULL, NULL, 82, NULL, 'Immunoglobulin', 286672),
(479931, '0037979', NULL, NULL, 105, NULL, 'Immunoglobulin', 286672),
(479932, '0038149', NULL, NULL, 89, NULL, 'Immunoglobulin', 286672),
(479933, '0038942', NULL, NULL, 108, NULL, 'Immunoglobulin', 286672),
(479934, '0050952', NULL, NULL, 131, NULL, 'Immunoglobulin', 286672),
(479935, '0037854', NULL, NULL, 115, NULL, 'Immunoglobulin', 286672),
(479936, '0037299', NULL, NULL, 127, NULL, 'Immunoglobulin', 286672),
(479937, '0044716', NULL, NULL, 111, NULL, 'Immunoglobulin', 286672),
(479938, '0044717', NULL, NULL, 113, NULL, 'Immunoglobulin', 286672),
(479939, '0039594', NULL, NULL, 98, NULL, 'Immunoglobulin', 286672),
(479940, '0046212', NULL, NULL, 118, NULL, 'Immunoglobulin', 286672),
(479941, '0044276', NULL, NULL, 99, NULL, 'Immunoglobulin', 286672),
(479942, '0039470', NULL, NULL, 86, NULL, 'Immunoglobulin', 286672),
(479943, '0048631', NULL, NULL, 107, NULL, 'Immunoglobulin', 286672),
(479944, '0048753', NULL, NULL, 100, NULL, 'Immunoglobulin', 286672),
(479945, '0048995', NULL, NULL, 119, NULL, 'Immunoglobulin', 286672),
(479946, '0047667', NULL, NULL, 122, NULL, 'Immunoglobulin', 286672),
(479947, '0045008', NULL, NULL, 105, NULL, 'Immunoglobulin', 286672),
(479948, '0040598', NULL, NULL, 115, NULL, 'Immunoglobulin', 286672),
(479949, '0045007', NULL, NULL, 103, NULL, 'Immunoglobulin', 286672),
(479950, '0049851', NULL, NULL, 114, NULL, 'Immunoglobulin', 286672),
(479951, '0045132', NULL, NULL, 106, NULL, 'Immunoglobulin', 286672),
(479952, '0047792', NULL, NULL, 101, NULL, 'Immunoglobulin', 286672),
(479953, '0049177', NULL, NULL, 125, NULL, 'Immunoglobulin', 286672),
(479954, '0037723', NULL, NULL, 103, NULL, 'Immunoglobulin', 286672),
(479955, '0035664', NULL, NULL, 122, NULL, 'Immunoglobulin', 286672),
(479956, '0036511', NULL, NULL, 102, NULL, 'Immunoglobulin', 286672),
(479957, '0037724', NULL, NULL, 105, NULL, 'Immunoglobulin', 286672),
(479958, '0035668', NULL, NULL, 90, NULL, 'Immunoglobulin', 286672),
(479959, '0042304', NULL, NULL, 120, NULL, 'Immunoglobulin', 286672),
(479960, '0044969', NULL, NULL, 111, NULL, 'Immunoglobulin', 286672),
(479961, '0047556', NULL, NULL, 100, NULL, 'Immunoglobulin', 286672),
(479962, '0045133', NULL, NULL, 86, NULL, 'Immunoglobulin', 286672); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(479963, '0040007', NULL, NULL, 117, NULL, 'Immunoglobulin', 286672),
(479964, '0042663', NULL, NULL, 121, NULL, 'Immunoglobulin', 286672),
(479965, '0045932', NULL, NULL, 113, NULL, 'Immunoglobulin', 286672),
(479966, '0045931', NULL, NULL, 111, NULL, 'Immunoglobulin', 286672),
(479967, '0038807', NULL, NULL, 127, NULL, 'Immunoglobulin', 286672),
(479968, '0040926', NULL, NULL, 95, NULL, 'Immunoglobulin', 286672),
(479969, '0049860', NULL, NULL, 96, NULL, 'Immunoglobulin', 286672),
(479970, '0050174', NULL, NULL, 122, NULL, 'Immunoglobulin', 286672),
(479971, '0038808', NULL, NULL, 117, NULL, 'Immunoglobulin', 286672),
(479972, '0049188', NULL, NULL, 107, NULL, 'Immunoglobulin', 286672),
(479973, '0038924', NULL, NULL, 106, NULL, 'Immunoglobulin', 286672),
(479974, '0051029', NULL, NULL, 66, NULL, 'Immunoglobulin', 286672),
(479975, '0052909', NULL, NULL, 177, NULL, 'Immunoglobulin', 286672),
(479976, '0045266', NULL, NULL, 132, NULL, 'Immunoglobulin', 286672),
(479977, '0047325', NULL, NULL, 117, NULL, 'Immunoglobulin', 286672),
(479978, '0045267', NULL, NULL, 107, NULL, 'Immunoglobulin', 286672),
(479979, '0045941', NULL, NULL, 113, NULL, 'Immunoglobulin', 286672),
(479980, '0041349', NULL, NULL, 119, NULL, 'Immunoglobulin', 286672),
(479981, '0047208', NULL, NULL, 101, NULL, 'Immunoglobulin', 286672),
(479982, '0040259', NULL, NULL, 119, NULL, 'Immunoglobulin', 286672),
(479983, '0045269', NULL, NULL, 111, NULL, 'Immunoglobulin', 286672),
(479984, '0042554', NULL, NULL, 102, NULL, 'Immunoglobulin', 286672),
(479985, '0041909', NULL, NULL, 95, NULL, 'Immunoglobulin', 286672),
(479986, '0045270', NULL, NULL, 102, NULL, 'Immunoglobulin', 286672),
(479987, '0045273', NULL, NULL, 88, NULL, 'Immunoglobulin', 286672),
(479988, '0046363', NULL, NULL, 105, NULL, 'Immunoglobulin', 286672),
(479989, '0038918', NULL, NULL, 110, NULL, 'Immunoglobulin', 286672),
(479990, '0036974', NULL, NULL, 100, NULL, 'Immunoglobulin', 286672),
(479991, '0035642', NULL, NULL, 107, NULL, 'Immunoglobulin', 286672),
(479992, '0050983', NULL, NULL, 91, NULL, 'Immunoglobulin', 286672),
(479993, '0052128', NULL, NULL, 96, NULL, 'Immunoglobulin', 286672),
(479994, '0052800', NULL, NULL, 127, NULL, 'Immunoglobulin', 286672),
(479995, '0050984', NULL, NULL, 74, NULL, 'Immunoglobulin', 286672),
(479996, '0040024', NULL, NULL, 107, NULL, 'Immunoglobulin', 286672),
(479997, '0040023', NULL, NULL, 101, NULL, 'Immunoglobulin', 286672),
(479998, '0045839', NULL, NULL, 118, NULL, 'Immunoglobulin', 286672),
(479999, '0047334', NULL, NULL, 121, NULL, 'Immunoglobulin', 286672),
(480000, '0036170', NULL, NULL, 109, NULL, 'Immunoglobulin', 286672),
(480001, '0035080', NULL, NULL, 114, NULL, 'Immunoglobulin', 286672),
(480002, '0045951', NULL, NULL, 95, NULL, 'Immunoglobulin', 286672),
(480003, '0043532', NULL, NULL, 96, NULL, 'Immunoglobulin', 286672),
(480004, '0043412', NULL, NULL, 99, NULL, 'Immunoglobulin', 286672),
(480005, '0035519', NULL, NULL, 107, NULL, 'Immunoglobulin', 286672),
(480006, '0053104', NULL, NULL, 92, NULL, 'Immunoglobulin', 286672),
(480007, '0051168', NULL, NULL, 109, NULL, 'Immunoglobulin', 286672),
(480008, '0053222', NULL, NULL, 97, NULL, 'Immunoglobulin', 286672),
(480009, '0053223', NULL, NULL, 84, NULL, 'Immunoglobulin', 286672),
(480010, '0049642', NULL, NULL, 89, NULL, 'Immunoglobulin', 286672),
(480011, '0041915', NULL, NULL, 92, NULL, 'Immunoglobulin', 286672),
(480012, '0052251', NULL, NULL, 101, NULL, 'Immunoglobulin', 286672),
(480013, '0036169', NULL, NULL, 102, NULL, 'Immunoglobulin', 286672),
(480014, '0037378', NULL, NULL, 87, NULL, 'Immunoglobulin', 286672),
(480015, '0051841', NULL, NULL, 110, NULL, 'Immunoglobulin', 286672),
(480016, '0038347', NULL, NULL, 97, NULL, 'Immunoglobulin', 286672),
(480017, '0053108', NULL, NULL, 112, NULL, 'Immunoglobulin', 286672),
(480018, '0041365', NULL, NULL, 101, NULL, 'Immunoglobulin', 286672),
(480019, '0041364', NULL, NULL, 121, NULL, 'Immunoglobulin', 286672),
(480020, '0041363', NULL, NULL, 104, NULL, 'Immunoglobulin', 286672),
(480021, '0037371', NULL, NULL, 123, NULL, 'Immunoglobulin', 286672);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(480022, '0041362', NULL, NULL, 108, NULL, 'Immunoglobulin', 286672),
(480023, '0037372', NULL, NULL, 119, NULL, 'Immunoglobulin', 286672),
(480024, '0047906', NULL, NULL, 125, NULL, 'Immunoglobulin', 286672),
(480025, '0041361', NULL, NULL, 113, NULL, 'Immunoglobulin', 286672),
(480026, '0041360', NULL, NULL, 113, NULL, 'Immunoglobulin', 286672),
(480027, '0042571', NULL, NULL, 131, NULL, 'Immunoglobulin', 286672),
(480028, '0045840', NULL, NULL, 119, NULL, 'Immunoglobulin', 286672),
(480029, '0042572', NULL, NULL, 113, NULL, 'Immunoglobulin', 286672),
(480030, '0048434', NULL, NULL, 111, NULL, 'Immunoglobulin', 286672),
(480031, '0040832', NULL, NULL, 100, NULL, 'Immunoglobulin', 286672),
(480032, '0048319', NULL, NULL, 105, NULL, 'Immunoglobulin', 286672),
(480033, '0050084', NULL, NULL, 107, NULL, 'Immunoglobulin', 286672),
(480034, '0047352', NULL, NULL, 135, NULL, 'Immunoglobulin', 286672),
(480035, '0048320', NULL, NULL, 122, NULL, 'Immunoglobulin', 286672),
(480036, '0035621', NULL, NULL, 98, NULL, 'Immunoglobulin', 286672),
(480037, '0049095', NULL, NULL, 96, NULL, 'Immunoglobulin', 286672),
(480038, '0052029', NULL, NULL, 108, NULL, 'Immunoglobulin', 286672),
(480039, '0039547', NULL, NULL, 108, NULL, 'Immunoglobulin', 286672),
(480040, '0052149', NULL, NULL, 111, NULL, 'Immunoglobulin', 286672),
(480041, '0037121', NULL, NULL, 92, NULL, 'Immunoglobulin', 286672),
(480042, '0051848', NULL, NULL, 114, NULL, 'Immunoglobulin', 286672),
(480043, '0037120', NULL, NULL, 97, NULL, 'Immunoglobulin', 286672),
(480044, '0046709', NULL, NULL, 126, NULL, 'Immunoglobulin', 286672),
(480045, '0048325', NULL, NULL, 110, NULL, 'Immunoglobulin', 286672),
(480046, '0045972', NULL, NULL, 89, NULL, 'Immunoglobulin', 286672),
(480047, '0046027', NULL, NULL, 109, NULL, 'Immunoglobulin', 286672),
(480048, '0046148', NULL, NULL, 105, NULL, 'Immunoglobulin', 286672),
(480049, '0046389', NULL, NULL, 105, NULL, 'Immunoglobulin', 286672),
(480050, '0046821', NULL, NULL, 96, NULL, 'Immunoglobulin', 286672),
(480051, '0046149', NULL, NULL, 72, NULL, 'Immunoglobulin', 286672),
(480052, '0049539', NULL, NULL, 112, NULL, 'Immunoglobulin', 286672),
(480053, '0046823', NULL, NULL, 89, NULL, 'Immunoglobulin', 286672),
(480054, '0047360', NULL, NULL, 115, NULL, 'Immunoglobulin', 286672),
(480055, '0035859', NULL, NULL, 107, NULL, 'Immunoglobulin', 286672),
(480056, '0048332', NULL, NULL, 112, NULL, 'Immunoglobulin', 286672),
(480057, '0048696', NULL, NULL, 98, NULL, 'Immunoglobulin', 286672),
(480058, '0048330', NULL, NULL, 98, NULL, 'Immunoglobulin', 286672),
(480059, '0048451', NULL, NULL, 109, NULL, 'Immunoglobulin', 286672),
(480060, '0048331', NULL, NULL, 119, NULL, 'Immunoglobulin', 286672),
(480061, '0049540', NULL, NULL, 117, NULL, 'Immunoglobulin', 286672),
(480062, '0035057', NULL, NULL, 120, NULL, 'Immunoglobulin', 286672),
(480063, '0037356', NULL, NULL, 89, NULL, 'Immunoglobulin', 286672),
(480064, '0038563', NULL, NULL, 107, NULL, 'Immunoglobulin', 286672),
(480065, '0040178', NULL, NULL, 97, NULL, 'Immunoglobulin', 286672),
(480066, '0042359', NULL, NULL, 126, NULL, 'Immunoglobulin', 286672),
(480067, '0040056', NULL, NULL, 105, NULL, 'Immunoglobulin', 286672),
(480068, '0041024', NULL, NULL, 119, NULL, 'Immunoglobulin', 286672),
(480069, '0037355', NULL, NULL, 82, NULL, 'Immunoglobulin', 286672),
(480070, '0052150', NULL, NULL, 112, NULL, 'Immunoglobulin', 286672),
(480071, '0041945', NULL, NULL, 97, NULL, 'Immunoglobulin', 286672),
(480072, '0046950', NULL, NULL, 129, NULL, 'Immunoglobulin', 286672),
(480073, '0046952', NULL, NULL, 109, NULL, 'Immunoglobulin', 286672),
(480074, '0043444', NULL, NULL, 133, NULL, 'Immunoglobulin', 286672),
(480075, '0045866', NULL, NULL, 117, NULL, 'Immunoglobulin', 286672),
(480076, '0046713', NULL, NULL, 124, NULL, 'Immunoglobulin', 286672),
(480077, '0043445', NULL, NULL, 111, NULL, 'Immunoglobulin', 286672),
(480078, '0049670', NULL, NULL, 112, NULL, 'Immunoglobulin', 286672),
(480079, '0035725', NULL, NULL, 116, NULL, 'Immunoglobulin', 286672),
(480080, '0035169', NULL, NULL, 105, NULL, 'Immunoglobulin', 286672);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(480081, '0035047', NULL, NULL, 129, NULL, 'Immunoglobulin', 286672),
(480082, '0036136', NULL, NULL, 89, NULL, 'Immunoglobulin', 286672),
(480083, '0036377', NULL, NULL, 94, NULL, 'Immunoglobulin', 286672),
(480084, '0035966', NULL, NULL, 119, NULL, 'Immunoglobulin', 286672),
(480085, '0038555', NULL, NULL, 98, NULL, 'Immunoglobulin', 286672),
(480086, '0038314', NULL, NULL, 130, NULL, 'Immunoglobulin', 286672),
(480087, '0051876', NULL, NULL, 124, NULL, 'Immunoglobulin', 286672),
(480088, '0047816', NULL, NULL, 111, NULL, 'Immunoglobulin', 286672),
(480089, '0045757', NULL, NULL, 110, NULL, 'Immunoglobulin', 286672),
(480090, '0038553', NULL, NULL, 103, NULL, 'Immunoglobulin', 286672),
(480091, '0038796', NULL, NULL, 94, NULL, 'Immunoglobulin', 286672),
(480092, '0036133', NULL, NULL, 97, NULL, 'Immunoglobulin', 286672),
(480093, '0047818', NULL, NULL, 100, NULL, 'Immunoglobulin', 286672),
(480094, '0046047', NULL, NULL, 107, NULL, 'Immunoglobulin', 286672),
(480095, '0046048', NULL, NULL, 122, NULL, 'Immunoglobulin', 286672),
(480096, '0042009', NULL, NULL, 98, NULL, 'Immunoglobulin', 286672),
(480097, '0045512', NULL, NULL, 91, NULL, 'Immunoglobulin', 286672),
(480098, '0045997', NULL, NULL, 119, NULL, 'Immunoglobulin', 286672),
(480099, '0053026', NULL, NULL, 123, NULL, 'Immunoglobulin', 286672),
(480100, '0046172', NULL, NULL, 121, NULL, 'Immunoglobulin', 286672),
(480101, '0045085', NULL, NULL, 123, NULL, 'Immunoglobulin', 286672),
(480102, '0041839', NULL, NULL, 115, NULL, 'Immunoglobulin', 286672),
(480103, '0048595', NULL, NULL, 93, NULL, 'Immunoglobulin', 286672),
(480104, '0041959', NULL, NULL, 125, NULL, 'Immunoglobulin', 286672),
(480105, '0040072', NULL, NULL, 112, NULL, 'Immunoglobulin', 286672),
(480106, '0038423', NULL, NULL, 113, NULL, 'Immunoglobulin', 286672),
(480107, '0050798', NULL, NULL, 90, NULL, 'Immunoglobulin', 286672),
(480108, '0037210', NULL, NULL, 110, NULL, 'Immunoglobulin', 286672),
(480109, '0041960', NULL, NULL, 106, NULL, 'Immunoglobulin', 286672),
(480110, '0037695', NULL, NULL, 115, NULL, 'Immunoglobulin', 286672),
(480111, '0040073', NULL, NULL, 112, NULL, 'Immunoglobulin', 286672),
(480112, '0047941', NULL, NULL, 107, NULL, 'Immunoglobulin', 286672),
(480113, '0045764', NULL, NULL, 104, NULL, 'Immunoglobulin', 286672),
(480114, '0046061', NULL, NULL, 117, NULL, 'Immunoglobulin', 286672),
(480115, '0046060', NULL, NULL, 125, NULL, 'Immunoglobulin', 286672),
(480116, '0053038', NULL, NULL, 111, NULL, 'Immunoglobulin', 286672),
(480117, '0034856', NULL, NULL, 123, NULL, 'Immunoglobulin', 286672),
(480118, '0034857', NULL, NULL, 120, NULL, 'Immunoglobulin', 286672),
(480119, '0049213', NULL, NULL, 119, NULL, 'Immunoglobulin', 286672),
(480120, '0047395', NULL, NULL, 114, NULL, 'Immunoglobulin', 286672),
(480121, '0037448', NULL, NULL, 102, NULL, 'Immunoglobulin', 286672),
(480122, '0052869', NULL, NULL, 110, NULL, 'Immunoglobulin', 286672),
(480123, '0037449', NULL, NULL, 110, NULL, 'Immunoglobulin', 286672),
(480124, '0036114', NULL, NULL, 101, NULL, 'Immunoglobulin', 286672),
(480125, '0037209', NULL, NULL, 101, NULL, 'Immunoglobulin', 286672),
(480126, '0036912', NULL, NULL, 94, NULL, 'Immunoglobulin', 286672),
(480127, '0038775', NULL, NULL, 107, NULL, 'Immunoglobulin', 286672),
(480128, '0051411', NULL, NULL, 118, NULL, 'Immunoglobulin', 286672),
(480129, '0045779', NULL, NULL, 112, NULL, 'Immunoglobulin', 286672),
(480130, '0038772', NULL, NULL, 120, NULL, 'Immunoglobulin', 286672),
(480131, '0037684', NULL, NULL, 84, NULL, 'Immunoglobulin', 286672),
(480132, '0038773', NULL, NULL, 86, NULL, 'Immunoglobulin', 286672),
(480133, '0041299', NULL, NULL, 104, NULL, 'Immunoglobulin', 286672),
(480134, '0038774', NULL, NULL, 123, NULL, 'Immunoglobulin', 286672),
(480135, '0048926', NULL, NULL, 128, NULL, 'Immunoglobulin', 286672),
(480136, '0036352', NULL, NULL, 111, NULL, 'Immunoglobulin', 286672),
(480137, '0042262', NULL, NULL, 94, NULL, 'Immunoglobulin', 286672),
(480138, '0046740', NULL, NULL, 123, NULL, 'Immunoglobulin', 286672),
(480139, '0039061', NULL, NULL, 126, NULL, 'Immunoglobulin', 286672);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(480140, '0048128', NULL, NULL, 108, NULL, 'Immunoglobulin', 286672),
(480141, '0048004', NULL, NULL, 112, NULL, 'Immunoglobulin', 286672),
(480142, '0052180', NULL, NULL, 123, NULL, 'Immunoglobulin', 286672),
(480143, '0040404', NULL, NULL, 96, NULL, 'Immunoglobulin', 286672),
(480144, '0048005', NULL, NULL, 118, NULL, 'Immunoglobulin', 286672),
(480145, '0040403', NULL, NULL, 107, NULL, 'Immunoglobulin', 286672),
(480146, '0048800', NULL, NULL, 99, NULL, 'Immunoglobulin', 286672),
(480147, '0048256', NULL, NULL, 108, NULL, 'Immunoglobulin', 286672),
(480148, '0045660', NULL, NULL, 103, NULL, 'Immunoglobulin', 286672),
(480149, '0035498', NULL, NULL, 125, NULL, 'Immunoglobulin', 286672),
(480150, '0038649', NULL, NULL, 78, NULL, 'Immunoglobulin', 286672),
(480151, '0052635', NULL, NULL, 127, NULL, 'Immunoglobulin', 286672),
(480152, '0042158', NULL, NULL, 84, NULL, 'Immunoglobulin', 286672),
(480153, '0037673', NULL, NULL, 102, NULL, 'Immunoglobulin', 286672),
(480154, '0043802', NULL, NULL, 81, NULL, 'Immunoglobulin', 286672),
(480155, '0040890', NULL, NULL, 111, NULL, 'Immunoglobulin', 286672),
(480156, '0037791', NULL, NULL, 100, NULL, 'Immunoglobulin', 286672),
(480157, '0043241', NULL, NULL, 85, NULL, 'Immunoglobulin', 286672),
(480158, '0043484', NULL, NULL, 112, NULL, 'Immunoglobulin', 286672),
(480159, '0044694', NULL, NULL, 90, NULL, 'Immunoglobulin', 286672),
(480160, '0043243', NULL, NULL, 130, NULL, 'Immunoglobulin', 286672),
(480161, '0046752', NULL, NULL, 85, NULL, 'Immunoglobulin', 286672),
(480162, '0040777', NULL, NULL, 97, NULL, 'Immunoglobulin', 286672),
(480163, '0046082', NULL, NULL, 106, NULL, 'Immunoglobulin', 286672),
(480164, '0048384', NULL, NULL, 112, NULL, 'Immunoglobulin', 286672),
(480165, '0052642', NULL, NULL, 118, NULL, 'Immunoglobulin', 286672),
(480166, '0035923', NULL, NULL, 96, NULL, 'Immunoglobulin', 286672),
(480167, '0048140', NULL, NULL, 117, NULL, 'Immunoglobulin', 286672),
(480168, '0048267', NULL, NULL, 93, NULL, 'Immunoglobulin', 286672),
(480169, '0053296', NULL, NULL, 114, NULL, 'Immunoglobulin', 286672),
(480170, '0042160', NULL, NULL, 84, NULL, 'Immunoglobulin', 286672),
(480171, '0035123', NULL, NULL, 115, NULL, 'Immunoglobulin', 286672),
(480172, '0050900', NULL, NULL, 104, NULL, 'Immunoglobulin', 286672),
(480173, '0035009', NULL, NULL, 108, NULL, 'Immunoglobulin', 286672),
(480174, '0039721', NULL, NULL, 106, NULL, 'Immunoglobulin', 286672),
(480175, '0046081', NULL, NULL, 107, NULL, 'Immunoglobulin', 286672),
(480176, '0052643', NULL, NULL, 109, NULL, 'Immunoglobulin', 286672),
(480177, '0036570', NULL, NULL, 95, NULL, 'Immunoglobulin', 286672),
(480178, '0039960', NULL, NULL, 96, NULL, 'Immunoglobulin', 286672),
(480179, '0042284', NULL, NULL, 111, NULL, 'Immunoglobulin', 286672),
(480180, '0046887', NULL, NULL, 112, NULL, 'Immunoglobulin', 286672),
(480181, '0042961', NULL, NULL, 128, NULL, 'Immunoglobulin', 286672),
(480182, '0047976', NULL, NULL, 107, NULL, 'Immunoglobulin', 286672),
(480183, '0041511', NULL, NULL, 116, NULL, 'Immunoglobulin', 286672),
(480184, '0050594', NULL, NULL, 113, NULL, 'Immunoglobulin', 286672),
(480185, '0050595', NULL, NULL, 72, NULL, 'Immunoglobulin', 286672),
(480186, '0035919', NULL, NULL, 94, NULL, 'Immunoglobulin', 286672),
(480187, '0035918', NULL, NULL, 78, NULL, 'Immunoglobulin', 286672),
(480188, '0035917', NULL, NULL, 93, NULL, 'Immunoglobulin', 286672),
(480189, '0042052', NULL, NULL, 108, NULL, 'Immunoglobulin', 286672),
(480190, '0038989', NULL, NULL, 101, NULL, 'Immunoglobulin', 286672),
(480191, '0042051', NULL, NULL, 101, NULL, 'Immunoglobulin', 286672),
(480192, '0052419', NULL, NULL, 113, NULL, 'Immunoglobulin', 286672),
(480193, '0039958', NULL, NULL, 99, NULL, 'Immunoglobulin', 286672),
(480194, '0050598', NULL, NULL, 93, NULL, 'Immunoglobulin', 286672),
(480195, '0037655', NULL, NULL, 95, NULL, 'Immunoglobulin', 286672),
(480196, '0038987', NULL, NULL, 107, NULL, 'Immunoglobulin', 286672),
(480197, '0043942', NULL, NULL, 112, NULL, 'Immunoglobulin', 286672),
(480198, '0043943', NULL, NULL, 90, NULL, 'Immunoglobulin', 286672);
INSERT INTO "PUBLIC"."MODEL" VALUES
(480199, '0038862', NULL, NULL, 126, NULL, 'Immunoglobulin', 286672),
(480200, '0036563', NULL, NULL, 117, NULL, 'Immunoglobulin', 286672),
(480201, '0043705', NULL, NULL, 112, NULL, 'Immunoglobulin', 286672),
(480202, '0052409', NULL, NULL, 94, NULL, 'Immunoglobulin', 286672),
(480203, '0046531', NULL, NULL, 113, NULL, 'Immunoglobulin', 286672),
(480204, '0045321', NULL, NULL, 107, NULL, 'Immunoglobulin', 286672),
(480205, '0047982', NULL, NULL, 119, NULL, 'Immunoglobulin', 286672),
(480206, '0046776', NULL, NULL, 108, NULL, 'Immunoglobulin', 286672),
(480207, '0047626', NULL, NULL, 259, NULL, 'Immunoglobulin', 286672),
(480208, '0040314', NULL, NULL, 119, NULL, 'Immunoglobulin', 286672),
(480209, '0051572', NULL, NULL, 113, NULL, 'Immunoglobulin', 286672),
(480210, '0046781', NULL, NULL, 107, NULL, 'Immunoglobulin', 286672),
(480211, '0037888', NULL, NULL, 98, NULL, 'Immunoglobulin', 286672),
(480212, '0039149', NULL, NULL, 107, NULL, 'Immunoglobulin', 286672),
(480213, '0041090', NULL, NULL, 99, NULL, 'Immunoglobulin', 286672),
(480214, '0038612', NULL, NULL, 108, NULL, 'Immunoglobulin', 286672),
(480215, '0036315', NULL, NULL, 110, NULL, 'Immunoglobulin', 286672),
(480216, '0045219', NULL, NULL, 109, NULL, 'Immunoglobulin', 286672),
(480217, '0039148', NULL, NULL, 103, NULL, 'Immunoglobulin', 286672),
(480218, '0039147', NULL, NULL, 101, NULL, 'Immunoglobulin', 286672),
(480219, '0039021', NULL, NULL, 116, NULL, 'Immunoglobulin', 286672),
(480220, '0042748', NULL, NULL, 118, NULL, 'Immunoglobulin', 286672),
(480221, '0046784', NULL, NULL, 102, NULL, 'Immunoglobulin', 286672),
(480222, '0045331', NULL, NULL, 108, NULL, 'Immunoglobulin', 286672),
(480223, '0047878', NULL, NULL, 114, NULL, 'Immunoglobulin', 286672),
(480224, '0047998', NULL, NULL, 126, NULL, 'Immunoglobulin', 286672),
(480225, '0050012', NULL, NULL, 108, NULL, 'Immunoglobulin', 286672),
(480226, '0050133', NULL, NULL, 109, NULL, 'Immunoglobulin', 286672),
(480227, '0049268', NULL, NULL, 114, NULL, 'Immunoglobulin', 286672),
(480228, '0046790', NULL, NULL, 119, NULL, 'Immunoglobulin', 286672),
(480229, '0047640', NULL, NULL, 117, NULL, 'Immunoglobulin', 286672),
(480230, '0045220', NULL, NULL, 110, NULL, 'Immunoglobulin', 286672),
(480231, '0037878', NULL, NULL, 96, NULL, 'Immunoglobulin', 286672),
(480232, '0037879', NULL, NULL, 101, NULL, 'Immunoglobulin', 286672),
(480233, '0035574', NULL, NULL, 97, NULL, 'Immunoglobulin', 286672),
(480234, '0039018', NULL, NULL, 102, NULL, 'Immunoglobulin', 286672),
(480235, '0039017', NULL, NULL, 119, NULL, 'Immunoglobulin', 286672),
(480236, '0038965', NULL, NULL, 108, NULL, 'Immunoglobulin', 286672),
(480237, '0051347', NULL, NULL, 119, NULL, 'Immunoglobulin', 286672),
(480238, '0035573', NULL, NULL, 111, NULL, 'Immunoglobulin', 286672),
(480239, '0035572', NULL, NULL, 94, NULL, 'Immunoglobulin', 286672),
(480240, '0042638', NULL, NULL, 102, NULL, 'Immunoglobulin', 286672),
(480241, '0042639', NULL, NULL, 106, NULL, 'Immunoglobulin', 286672),
(480242, '0044132', NULL, NULL, 116, NULL, 'Immunoglobulin', 286672),
(480243, '0044255', NULL, NULL, 113, NULL, 'Immunoglobulin', 286672),
(480244, '0042750', NULL, NULL, 121, NULL, 'Immunoglobulin', 286672),
(480245, '0043047', NULL, NULL, 100, NULL, 'Immunoglobulin', 286672),
(480246, '0049947', NULL, NULL, 117, NULL, 'Immunoglobulin', 286672),
(480247, '0042751', NULL, NULL, 108, NULL, 'Immunoglobulin', 286672),
(480248, '0049278', NULL, NULL, 130, NULL, 'Immunoglobulin', 286672),
(480249, '0038834', NULL, NULL, 102, NULL, 'Immunoglobulin', 286672),
(480250, '0039923', NULL, NULL, 100, NULL, 'Immunoglobulin', 286672),
(480251, '0052689', NULL, NULL, 124, NULL, 'Immunoglobulin', 286672),
(480252, '0050941', NULL, NULL, 116, NULL, 'Immunoglobulin', 286672),
(480253, '0038833', NULL, NULL, 103, NULL, 'Immunoglobulin', 286672),
(480254, '0046208', NULL, NULL, 91, NULL, 'Immunoglobulin', 286672),
(480255, '0045914', NULL, NULL, 115, NULL, 'Immunoglobulin', 286672),
(480256, '0049839', NULL, NULL, 114, NULL, 'Immunoglobulin', 286672),
(480257, '0047419', NULL, NULL, 117, NULL, 'Immunoglobulin', 286672); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(480258, '0035440', NULL, NULL, 109, NULL, 'Immunoglobulin', 286672),
(480259, '0045111', NULL, NULL, 94, NULL, 'Immunoglobulin', 286672),
(480260, '0049830', NULL, NULL, 110, NULL, 'Immunoglobulin', 286672),
(480261, '0041436', NULL, NULL, 127, NULL, 'Immunoglobulin', 286672),
(480262, '0046207', NULL, NULL, 105, NULL, 'Immunoglobulin', 286672),
(480263, '0036927', NULL, NULL, 134, NULL, 'Alpha-macroglobulin receptor domain', 286673),
(480264, '0035269', NULL, NULL, 130, NULL, 'Alpha-macroglobulin receptor domain', 286673),
(480265, '0035724', NULL, NULL, 138, NULL, 'Alpha-macroglobulin receptor domain', 286673),
(480266, '0037935', NULL, NULL, 82, NULL, 'Small-conductance potassium channel', 286674),
(480267, '0040125', NULL, NULL, 92, NULL, 'Small-conductance potassium channel', 286674),
(480268, '0049483', NULL, NULL, 127, NULL, 'RuBisCO, large subunit, small (N-terminal) domain', 286675),
(480269, '0049141', NULL, NULL, 139, NULL, 'RuBisCO, large subunit, small (N-terminal) domain', 286675),
(480270, '0035747', NULL, NULL, 144, NULL, 'RuBisCO, large subunit, small (N-terminal) domain', 286675),
(480271, '0052387', NULL, NULL, 126, NULL, 'RuBisCO, large subunit, small (N-terminal) domain', 286675),
(480272, '0053331', NULL, NULL, 126, NULL, 'RuBisCO, large subunit, small (N-terminal) domain', 286675),
(480273, '0047000', NULL, NULL, 143, NULL, 'RuBisCO, large subunit, small (N-terminal) domain', 286675),
(480274, '0053362', NULL, NULL, 136, NULL, 'RuBisCO, large subunit, small (N-terminal) domain', 286675),
(480275, '0053381', NULL, NULL, 139, NULL, 'RuBisCO, large subunit, small (N-terminal) domain', 286675),
(480276, '0046970', NULL, NULL, 125, NULL, 'RuBisCO, large subunit, small (N-terminal) domain', 286675),
(480277, '0046037', NULL, NULL, 128, NULL, 'RuBisCO, large subunit, small (N-terminal) domain', 286675),
(480278, '0050438', NULL, NULL, 140, NULL, 'RuBisCO, large subunit, small (N-terminal) domain', 286675),
(480279, '0051334', NULL, NULL, 142, NULL, 'RuBisCO, large subunit, small (N-terminal) domain', 286675),
(480280, '0053834', NULL, NULL, 118, NULL, 'V-type ATPase subunit E-like', 286676),
(480281, '0049816', NULL, NULL, 249, NULL, '(2r)-phospho-3-sulfolactate synthase ComA', 286677),
(480282, '0049056', NULL, NULL, 251, NULL, '(2r)-phospho-3-sulfolactate synthase ComA', 286677),
(480283, '0053875', NULL, NULL, 300, NULL, 'PMT central region-like', 286678),
(480284, '0036847', NULL, NULL, 85, NULL, 'PAH2 domain', 286679),
(480285, '0037889', NULL, NULL, 89, NULL, 'PAH2 domain', 286679),
(480286, '0053431', NULL, NULL, 65, NULL, 'F1 ATPase inhibitor, IF1, C-terminal domain', 286680),
(480287, '0053491', NULL, NULL, 37, NULL, 'F1 ATPase inhibitor, IF1, C-terminal domain', 286680),
(480288, '0054841', NULL, NULL, 167, NULL, 'MtlR-like', 286681),
(480289, '0054877', NULL, NULL, 168, NULL, 'MtlR-like', 286681),
(480290, '0042586', NULL, NULL, 63, NULL, 'Phenylalanine zipper', 286682),
(480291, '0042431', NULL, NULL, 386, NULL, 'Aerolisin/ETX pore-forming domain', 286683),
(480292, '0044565', NULL, NULL, 280, NULL, 'Aerolisin/ETX pore-forming domain', 286683),
(480293, '0041238', NULL, NULL, 105, NULL, 'Hypothetical protein Yml108w', 286684),
(480294, '0041919', NULL, NULL, 95, NULL, 'Mitochondrial import receptor subunit Tom20', 286685),
(480295, '0047482', NULL, NULL, 69, NULL, 'Translation proteins SH3-like domain', 286686),
(480296, '0052497', NULL, NULL, 73, NULL, 'Translation proteins SH3-like domain', 286686),
(480297, '0054784', NULL, NULL, 108, NULL, 'Translation proteins SH3-like domain', 286686),
(480298, '0049873', NULL, NULL, 63, NULL, 'Translation proteins SH3-like domain', 286686),
(480299, '0054596', NULL, NULL, 145, NULL, 'Translation proteins SH3-like domain', 286686),
(480300, '0054771', NULL, NULL, 145, NULL, 'Translation proteins SH3-like domain', 286686),
(480301, '0046771', NULL, NULL, 119, NULL, 'Translation proteins SH3-like domain', 286686),
(480302, '0054175', NULL, NULL, 147, NULL, 'Translation proteins SH3-like domain', 286686),
(480303, '0054186', NULL, NULL, 101, NULL, 'Translation proteins SH3-like domain', 286686);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(480304, '0046770', NULL, NULL, 95, NULL, 'Translation proteins SH3-like domain', 286686),
(480305, '0049199', NULL, NULL, 70, NULL, 'Translation proteins SH3-like domain', 286686),
(480306, '0052975', NULL, NULL, 99, NULL, 'Translation proteins SH3-like domain', 286686),
(480307, '0050864', NULL, NULL, 68, NULL, 'Translation proteins SH3-like domain', 286686),
(480308, '0054238', NULL, NULL, 96, NULL, 'Translation proteins SH3-like domain', 286686),
(480309, '0054789', NULL, NULL, 110, NULL, 'Translation proteins SH3-like domain', 286686),
(480310, '0052479', NULL, NULL, 62, NULL, 'Translation proteins SH3-like domain', 286686),
(480311, '0052974', NULL, NULL, 114, NULL, 'Translation proteins SH3-like domain', 286686),
(480312, '0041642', NULL, NULL, 58, NULL, 'Translation proteins SH3-like domain', 286686),
(480313, '0047804', NULL, NULL, 76, NULL, 'Translation proteins SH3-like domain', 286686),
(480314, '0054183', NULL, NULL, 138, NULL, 'Translation proteins SH3-like domain', 286686),
(480315, '0046768', NULL, NULL, 147, NULL, 'Translation proteins SH3-like domain', 286686),
(480316, '0040731', NULL, NULL, 58, NULL, 'Translation proteins SH3-like domain', 286686),
(480317, '0045975', NULL, NULL, 71, NULL, 'Translation proteins SH3-like domain', 286686),
(480318, '0053141', NULL, NULL, 91, NULL, 'Ribosomal protein L9 C-domain', 286687),
(480319, '0053996', NULL, NULL, 91, NULL, 'Ribosomal protein L9 C-domain', 286687),
(480320, '0036447', NULL, NULL, 94, NULL, 'Ribosomal protein L9 C-domain', 286687),
(480321, '0054037', NULL, NULL, 109, NULL, 'YqcC-like', 286688),
(480322, '0051674', NULL, NULL, 118, NULL, 'Histidine-containing phosphotransfer domain, HPT domain', 286689),
(480323, '0051419', NULL, NULL, 142, NULL, 'Histidine-containing phosphotransfer domain, HPT domain', 286689),
(480324, '0044088', NULL, NULL, 105, NULL, 'Histidine-containing phosphotransfer domain, HPT domain', 286689),
(480325, '0049447', NULL, NULL, 116, NULL, 'Histidine-containing phosphotransfer domain, HPT domain', 286689),
(480326, '0046049', NULL, NULL, 166, NULL, 'Histidine-containing phosphotransfer domain, HPT domain', 286689),
(480327, '0051209', NULL, NULL, 114, NULL, 'Histidine-containing phosphotransfer domain, HPT domain', 286689),
(480328, '0054392', NULL, NULL, 104, NULL, 'Histidine-containing phosphotransfer domain, HPT domain', 286689),
(480329, '0038885', NULL, NULL, 128, NULL, 'Histidine-containing phosphotransfer domain, HPT domain', 286689),
(480330, '0050663', NULL, NULL, 131, NULL, 'Histidine-containing phosphotransfer domain, HPT domain', 286689),
(480331, '0050129', NULL, NULL, 175, NULL, 'THUMP domain-like', 286690),
(480332, '0052118', NULL, NULL, 171, NULL, 'THUMP domain-like', 286690),
(480333, '0049192', NULL, NULL, 98, NULL, 'THUMP domain-like', 286690),
(480334, '0053821', NULL, NULL, 85, NULL, 'THUMP domain-like', 286690),
(480335, '0037361', NULL, NULL, 147, NULL, 'Pepsin inhibitor-3', 286691),
(480336, '0044925', NULL, NULL, 76, NULL, 'Mitochondrial ATP synthase coupling factor 6', 286692),
(480337, '0054646', NULL, NULL, 248, NULL, 'MalF N-terminal region-like', 286693),
(480338, '0048462', NULL, NULL, 132, NULL, 'Hypothetical protein VC0424', 286694),
(480339, '0054365', NULL, NULL, 152, NULL, 'AF1862-like', 286695),
(480340, '0051363', NULL, NULL, 135, NULL, 'Trimeric LpxA-like enzymes', 286696),
(480341, '0048541', NULL, NULL, 182, NULL, 'Trimeric LpxA-like enzymes', 286696),
(480342, '0047244', NULL, NULL, 201, NULL, 'Trimeric LpxA-like enzymes', 286696),
(480343, '0049025', NULL, NULL, 210, NULL, 'Trimeric LpxA-like enzymes', 286696),
(480344, '0053166', NULL, NULL, 262, NULL, 'Trimeric LpxA-like enzymes', 286696),
(480345, '0050899', NULL, NULL, 208, NULL, 'Trimeric LpxA-like enzymes', 286696),
(480346, '0050963', NULL, NULL, 172, NULL, 'Trimeric LpxA-like enzymes', 286696),
(480347, '0052621', NULL, NULL, 320, NULL, 'Trimeric LpxA-like enzymes', 286696),
(480348, '0039338', NULL, NULL, 259, NULL, 'Trimeric LpxA-like enzymes', 286696),
(480349, '0054843', NULL, NULL, 193, NULL, 'Trimeric LpxA-like enzymes', 286696);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(480350, '0043848', NULL, NULL, 262, NULL, 'Trimeric LpxA-like enzymes', 286696),
(480351, '0044607', NULL, NULL, 173, NULL, 'Trimeric LpxA-like enzymes', 286696),
(480352, '0049600', NULL, NULL, 256, NULL, 'Trimeric LpxA-like enzymes', 286696),
(480353, '0053094', NULL, NULL, 83, NULL, 'Trimeric LpxA-like enzymes', 286696),
(480354, '0047206', NULL, NULL, 208, NULL, 'Trimeric LpxA-like enzymes', 286696),
(480355, '0047822', NULL, NULL, 207, NULL, 'Trimeric LpxA-like enzymes', 286696),
(480356, '0047866', NULL, NULL, 200, NULL, 'Trimeric LpxA-like enzymes', 286696),
(480357, '0043743', NULL, NULL, 241, NULL, 'Trimeric LpxA-like enzymes', 286696),
(480358, '0044075', NULL, NULL, 92, NULL, 'TolA/TonB C-terminal domain', 286697),
(480359, '0040624', NULL, NULL, 126, NULL, 'TolA/TonB C-terminal domain', 286697),
(480360, '0049753', NULL, NULL, 90, NULL, 'TolA/TonB C-terminal domain', 286697),
(480361, '0041970', NULL, NULL, 112, NULL, 'FAD-dependent thiol oxidase', 286698),
(480362, '0039717', NULL, NULL, 105, NULL, 'FAD-dependent thiol oxidase', 286698),
(480363, '0049039', NULL, NULL, 114, NULL, 'Subdomain of clathrin and coatomer appendage domain', 286699),
(480364, '0043123', NULL, NULL, 111, NULL, 'Subdomain of clathrin and coatomer appendage domain', 286699),
(480365, '0036758', NULL, NULL, 113, NULL, 'Subdomain of clathrin and coatomer appendage domain', 286699),
(480366, '0044855', NULL, NULL, 236, NULL, 'Argininosuccinate synthetase, C-terminal domain', 286700),
(480367, '0039978', NULL, NULL, 256, NULL, 'Argininosuccinate synthetase, C-terminal domain', 286700),
(480368, '0040190', NULL, NULL, 225, NULL, 'Argininosuccinate synthetase, C-terminal domain', 286700),
(480369, '0053323', NULL, NULL, 73, NULL, 'AFP III-like domain', 286701),
(480370, '0038585', NULL, NULL, 66, NULL, 'AFP III-like domain', 286701),
(480371, '0051113', NULL, NULL, 68, NULL, 'AFP III-like domain', 286701),
(480372, '0035874', NULL, NULL, 66, NULL, 'AFP III-like domain', 286701),
(480373, '0044870', NULL, NULL, 72, NULL, 'AFP III-like domain', 286701),
(480374, '0041966', NULL, NULL, 64, NULL, 'AFP III-like domain', 286701),
(480375, '0036608', NULL, NULL, 120, NULL, 'dUTPase-like', 286702),
(480376, '0051089', NULL, NULL, 193, NULL, 'dUTPase-like', 286702),
(480377, '0042623', NULL, NULL, 142, NULL, 'dUTPase-like', 286702),
(480378, '0049409', NULL, NULL, 153, NULL, 'dUTPase-like', 286702),
(480379, '0052041', NULL, NULL, 113, NULL, 'dUTPase-like', 286702),
(480380, '0052042', NULL, NULL, 136, NULL, 'dUTPase-like', 286702),
(480381, '0050315', NULL, NULL, 159, NULL, 'dUTPase-like', 286702),
(480382, '0037428', NULL, NULL, 133, NULL, 'dUTPase-like', 286702),
(480383, '0041842', NULL, NULL, 175, NULL, 'dUTPase-like', 286702),
(480384, '0049218', NULL, NULL, 152, NULL, 'dUTPase-like', 286702),
(480385, '0048130', NULL, NULL, 35, NULL, 'omega toxin-like', 286703),
(480386, '0046591', NULL, NULL, 30, NULL, 'omega toxin-like', 286703),
(480387, '0046153', NULL, NULL, 44, NULL, 'omega toxin-like', 286703),
(480388, '0047782', NULL, NULL, 27, NULL, 'omega toxin-like', 286703),
(480389, '0048376', NULL, NULL, 35, NULL, 'omega toxin-like', 286703),
(480390, '0047288', NULL, NULL, 37, NULL, 'omega toxin-like', 286703),
(480391, '0051186', NULL, NULL, 28, NULL, 'omega toxin-like', 286703),
(480392, '0046352', NULL, NULL, 37, NULL, 'omega toxin-like', 286703),
(480393, '0048034', NULL, NULL, 34, NULL, 'omega toxin-like', 286703),
(480394, '0050311', NULL, NULL, 42, NULL, 'omega toxin-like', 286703),
(480395, '0037891', NULL, NULL, 32, NULL, 'omega toxin-like', 286703),
(480396, '0047849', NULL, NULL, 36, NULL, 'omega toxin-like', 286703),
(480397, '0048039', NULL, NULL, 31, NULL, 'omega toxin-like', 286703),
(480398, '0048710', NULL, NULL, 37, NULL, 'omega toxin-like', 286703),
(480399, '0046695', NULL, NULL, 26, NULL, 'omega toxin-like', 286703),
(480400, '0047468', NULL, NULL, 27, NULL, 'omega toxin-like', 286703),
(480401, '0049689', NULL, NULL, 25, NULL, 'omega toxin-like', 286703),
(480402, '0046951', NULL, NULL, 45, NULL, 'omega toxin-like', 286703);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(480403, '0047245', NULL, NULL, 25, NULL, 'omega toxin-like', 286703),
(480404, '0047289', NULL, NULL, 34, NULL, 'omega toxin-like', 286703),
(480405, '0047685', NULL, NULL, 37, NULL, 'omega toxin-like', 286703),
(480406, '0048599', NULL, NULL, 27, NULL, 'omega toxin-like', 286703),
(480407, '0048973', NULL, NULL, 32, NULL, 'omega toxin-like', 286703),
(480408, '0046655', NULL, NULL, 30, NULL, 'omega toxin-like', 286703),
(480409, '0041106', NULL, NULL, 26, NULL, 'omega toxin-like', 286703),
(480410, '0048932', NULL, NULL, 42, NULL, 'omega toxin-like', 286703),
(480411, '0046086', NULL, NULL, 33, NULL, 'omega toxin-like', 286703),
(480412, '0047351', NULL, NULL, 33, NULL, 'omega toxin-like', 286703),
(480413, '0048000', NULL, NULL, 35, NULL, 'omega toxin-like', 286703),
(480414, '0050987', NULL, NULL, 47, NULL, 'omega toxin-like', 286703),
(480415, '0045837', NULL, NULL, 37, NULL, 'omega toxin-like', 286703),
(480416, '0047859', NULL, NULL, 38, NULL, 'omega toxin-like', 286703),
(480417, '0042823', NULL, NULL, 33, NULL, 'omega toxin-like', 286703),
(480418, '0045772', NULL, NULL, 34, NULL, 'omega toxin-like', 286703),
(480419, '0046861', NULL, NULL, 27, NULL, 'omega toxin-like', 286703),
(480420, '0041418', NULL, NULL, 33, NULL, 'omega toxin-like', 286703),
(480421, '0045774', NULL, NULL, 48, NULL, 'omega toxin-like', 286703),
(480422, '0046885', NULL, NULL, 25, NULL, 'omega toxin-like', 286703),
(480423, '0049215', NULL, NULL, 31, NULL, 'omega toxin-like', 286703),
(480424, '0050082', NULL, NULL, 29, NULL, 'omega toxin-like', 286703),
(480425, '0047950', NULL, NULL, 34, NULL, 'omega toxin-like', 286703),
(480426, '0046249', NULL, NULL, 35, NULL, 'omega toxin-like', 286703),
(480427, '0047999', NULL, NULL, 40, NULL, 'omega toxin-like', 286703),
(480428, '0036070', NULL, NULL, 26, NULL, 'omega toxin-like', 286703),
(480429, '0046567', NULL, NULL, 36, NULL, 'omega toxin-like', 286703),
(480430, '0048528', NULL, NULL, 48, NULL, 'omega toxin-like', 286703),
(480431, '0049721', NULL, NULL, 247, NULL, 'CutC-like', 286704),
(480432, '0047948', NULL, NULL, 99, NULL, 'Transglutaminase, two C-terminal domains', 286705),
(480433, '0047947', NULL, NULL, 114, NULL, 'Transglutaminase, two C-terminal domains', 286705),
(480434, '0046894', NULL, NULL, 101, NULL, 'Transglutaminase, two C-terminal domains', 286705),
(480435, '0047885', NULL, NULL, 117, NULL, 'Transglutaminase, two C-terminal domains', 286705),
(480436, '0046893', NULL, NULL, 112, NULL, 'Transglutaminase, two C-terminal domains', 286705),
(480437, '0047886', NULL, NULL, 102, NULL, 'Transglutaminase, two C-terminal domains', 286705),
(480438, '0046676', NULL, NULL, 112, NULL, 'Transglutaminase, two C-terminal domains', 286705),
(480439, '0046677', NULL, NULL, 101, NULL, 'Transglutaminase, two C-terminal domains', 286705),
(480440, '0043855', NULL, NULL, 115, NULL, 'Lesion bypass DNA polymerase (Y-family), little finger domain', 286706),
(480441, '0049570', NULL, NULL, 105, NULL, 'Lesion bypass DNA polymerase (Y-family), little finger domain', 286706),
(480442, '0049960', NULL, NULL, 111, NULL, 'Lesion bypass DNA polymerase (Y-family), little finger domain', 286706),
(480443, '0047594', NULL, NULL, 120, NULL, 'Lesion bypass DNA polymerase (Y-family), little finger domain', 286706),
(480444, '0039846', NULL, NULL, 105, NULL, 'Lesion bypass DNA polymerase (Y-family), little finger domain', 286706),
(480445, '0039801', NULL, NULL, 101, NULL, 'Lesion bypass DNA polymerase (Y-family), little finger domain', 286706),
(480446, '0054067', NULL, NULL, 116, NULL, 'FinO-like', 286707),
(480447, '0036630', NULL, NULL, 152, NULL, 'FinO-like', 286707),
(480448, '0052064', NULL, NULL, 84, NULL, 'Hermes dimerisation domain', 286708),
(480449, '0050031', NULL, NULL, 203, NULL, 'Nitrile hydratase alpha chain', 286709),
(480450, '0045155', NULL, NULL, 200, NULL, 'Nitrile hydratase alpha chain', 286709),
(480451, '0039150', NULL, NULL, 203, NULL, 'Nitrile hydratase alpha chain', 286709),
(480452, '0037540', NULL, NULL, 115, NULL, 'Ribosomal proteins L15p and L18e', 286710);
INSERT INTO "PUBLIC"."MODEL" VALUES
(480453, '0052972', NULL, NULL, 140, NULL, 'Ribosomal proteins L15p and L18e', 286710),
(480454, '0054780', NULL, NULL, 141, NULL, 'Ribosomal proteins L15p and L18e', 286710),
(480455, '0037538', NULL, NULL, 151, NULL, 'Ribosomal proteins L15p and L18e', 286710),
(480456, '0054182', NULL, NULL, 146, NULL, 'Ribosomal proteins L15p and L18e', 286710),
(480457, '0046902', NULL, NULL, 31, NULL, 'Granulin repeat', 286711),
(480458, '0037812', NULL, NULL, 35, NULL, 'Granulin repeat', 286711),
(480459, '0048951', NULL, NULL, 30, NULL, 'Granulin repeat', 286711),
(480460, '0052341', NULL, NULL, 90, NULL, 'Barstar-related', 286712),
(480461, '0035259', NULL, NULL, 89, NULL, 'Barstar-related', 286712),
(480462, '0052123', NULL, NULL, 204, NULL, 'Glycoside hydrolase/deacetylase', 286713),
(480463, '0048464', NULL, NULL, 235, NULL, 'Glycoside hydrolase/deacetylase', 286713),
(480464, '0053198', NULL, NULL, 224, NULL, 'Glycoside hydrolase/deacetylase', 286713),
(480465, '0052143', NULL, NULL, 192, NULL, 'Glycoside hydrolase/deacetylase', 286713),
(480466, '0053130', NULL, NULL, 220, NULL, 'Glycoside hydrolase/deacetylase', 286713),
(480467, '0051910', NULL, NULL, 404, NULL, 'Glycoside hydrolase/deacetylase', 286713),
(480468, '0051516', NULL, NULL, 301, NULL, 'Glycoside hydrolase/deacetylase', 286713),
(480469, '0050069', NULL, NULL, 254, NULL, 'Glycoside hydrolase/deacetylase', 286713),
(480470, '0052426', NULL, NULL, 250, NULL, 'Glycoside hydrolase/deacetylase', 286713),
(480471, '0051128', NULL, NULL, 247, NULL, 'Glycoside hydrolase/deacetylase', 286713),
(480472, '0038723', NULL, NULL, 381, NULL, 'Glycoside hydrolase/deacetylase', 286713),
(480473, '0041730', NULL, NULL, 331, NULL, 'Glycoside hydrolase/deacetylase', 286713),
(480474, '0053151', NULL, NULL, 235, NULL, 'Glycoside hydrolase/deacetylase', 286713),
(480475, '0052092', NULL, NULL, 196, NULL, 'Glycoside hydrolase/deacetylase', 286713),
(480476, '0044323', NULL, NULL, 412, NULL, 'Glycoside hydrolase/deacetylase', 286713),
(480477, '0054093', NULL, NULL, 261, NULL, 'Glycoside hydrolase/deacetylase', 286713),
(480478, '0047723', NULL, NULL, 310, NULL, 'Glycoside hydrolase/deacetylase', 286713),
(480479, '0038383', NULL, NULL, 60, NULL, 'Htr2 transmembrane domain-like', 286714),
(480480, '0044500', NULL, NULL, 201, NULL, 'Hsp90 co-chaperone CDC37', 286715),
(480481, '0048419', NULL, NULL, 134, NULL, 'Growth factor receptor domain', 286716),
(480482, '0047362', NULL, NULL, 150, NULL, 'Growth factor receptor domain', 286716),
(480483, '0048303', NULL, NULL, 157, NULL, 'Growth factor receptor domain', 286716),
(480484, '0048304', NULL, NULL, 119, NULL, 'Growth factor receptor domain', 286716),
(480485, '0048103', NULL, NULL, 145, NULL, 'Growth factor receptor domain', 286716),
(480486, '0048301', NULL, NULL, 157, NULL, 'Growth factor receptor domain', 286716),
(480487, '0048104', NULL, NULL, 132, NULL, 'Growth factor receptor domain', 286716),
(480488, '0048302', NULL, NULL, 120, NULL, 'Growth factor receptor domain', 286716),
(480489, '0047449', NULL, NULL, 149, NULL, 'Growth factor receptor domain', 286716),
(480490, '0045987', NULL, NULL, 46, NULL, 'Growth factor receptor domain', 286716),
(480491, '0053842', NULL, NULL, 92, NULL, 'Growth factor receptor domain', 286716),
(480492, '0053854', NULL, NULL, 155, NULL, 'Growth factor receptor domain', 286716),
(480493, '0036496', NULL, NULL, 104, NULL, 'Alpha-L RNA-binding motif', 286717),
(480494, '0047871', NULL, NULL, 59, NULL, 'Alpha-L RNA-binding motif', 286717),
(480495, '0039540', NULL, NULL, 99, NULL, 'Alpha-L RNA-binding motif', 286717),
(480496, '0047115', NULL, NULL, 81, NULL, 'Alpha-L RNA-binding motif', 286717),
(480497, '0035794', NULL, NULL, 159, NULL, 'Alpha-L RNA-binding motif', 286717),
(480498, '0037616', NULL, NULL, 208, NULL, 'Alpha-L RNA-binding motif', 286717),
(480499, '0042206', NULL, NULL, 79, NULL, 'Alpha-L RNA-binding motif', 286717),
(480500, '0044787', NULL, NULL, 58, NULL, 'Alpha-L RNA-binding motif', 286717),
(480501, '0053986', NULL, NULL, 204, NULL, 'Alpha-L RNA-binding motif', 286717);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(480502, '0052624', NULL, NULL, 121, NULL, 'PTSIIA/GutA-like', 286718),
(480503, '0047570', NULL, NULL, 319, NULL, 'NAD(P)-linked oxidoreductase', 286719),
(480504, '0051795', NULL, NULL, 324, NULL, 'NAD(P)-linked oxidoreductase', 286719),
(480505, '0046098', NULL, NULL, 315, NULL, 'NAD(P)-linked oxidoreductase', 286719),
(480506, '0048014', NULL, NULL, 346, NULL, 'NAD(P)-linked oxidoreductase', 286719),
(480507, '0049058', NULL, NULL, 312, NULL, 'NAD(P)-linked oxidoreductase', 286719),
(480508, '0049299', NULL, NULL, 315, NULL, 'NAD(P)-linked oxidoreductase', 286719),
(480509, '0050262', NULL, NULL, 284, NULL, 'NAD(P)-linked oxidoreductase', 286719),
(480510, '0048562', NULL, NULL, 298, NULL, 'NAD(P)-linked oxidoreductase', 286719),
(480511, '0048892', NULL, NULL, 322, NULL, 'NAD(P)-linked oxidoreductase', 286719),
(480512, '0046848', NULL, NULL, 315, NULL, 'NAD(P)-linked oxidoreductase', 286719),
(480513, '0048842', NULL, NULL, 311, NULL, 'NAD(P)-linked oxidoreductase', 286719),
(480514, '0045771', NULL, NULL, 319, NULL, 'NAD(P)-linked oxidoreductase', 286719),
(480515, '0046225', NULL, NULL, 324, NULL, 'NAD(P)-linked oxidoreductase', 286719),
(480516, '0047069', NULL, NULL, 324, NULL, 'NAD(P)-linked oxidoreductase', 286719),
(480517, '0049985', NULL, NULL, 314, NULL, 'NAD(P)-linked oxidoreductase', 286719),
(480518, '0047367', NULL, NULL, 320, NULL, 'NAD(P)-linked oxidoreductase', 286719),
(480519, '0048247', NULL, NULL, 274, NULL, 'NAD(P)-linked oxidoreductase', 286719),
(480520, '0045776', NULL, NULL, 315, NULL, 'NAD(P)-linked oxidoreductase', 286719),
(480521, '0048846', NULL, NULL, 333, NULL, 'NAD(P)-linked oxidoreductase', 286719),
(480522, '0046647', NULL, NULL, 326, NULL, 'NAD(P)-linked oxidoreductase', 286719),
(480523, '0047249', NULL, NULL, 262, NULL, 'NAD(P)-linked oxidoreductase', 286719),
(480524, '0049482', NULL, NULL, 318, NULL, 'RuBisCo, C-terminal domain', 286720),
(480525, '0051333', NULL, NULL, 283, NULL, 'RuBisCo, C-terminal domain', 286720),
(480526, '0052386', NULL, NULL, 291, NULL, 'RuBisCo, C-terminal domain', 286720),
(480527, '0046969', NULL, NULL, 307, NULL, 'RuBisCo, C-terminal domain', 286720),
(480528, '0049140', NULL, NULL, 328, NULL, 'RuBisCo, C-terminal domain', 286720),
(480529, '0053330', NULL, NULL, 320, NULL, 'RuBisCo, C-terminal domain', 286720),
(480530, '0053361', NULL, NULL, 320, NULL, 'RuBisCo, C-terminal domain', 286720),
(480531, '0046036', NULL, NULL, 317, NULL, 'RuBisCo, C-terminal domain', 286720),
(480532, '0050437', NULL, NULL, 325, NULL, 'RuBisCo, C-terminal domain', 286720),
(480533, '0046026', NULL, NULL, 328, NULL, 'RuBisCo, C-terminal domain', 286720),
(480534, '0053380', NULL, NULL, 328, NULL, 'RuBisCo, C-terminal domain', 286720),
(480535, '0046999', NULL, NULL, 326, NULL, 'RuBisCo, C-terminal domain', 286720),
(480536, '0034993', NULL, NULL, 722, NULL, 'Anthrax protective antigen', 286721),
(480537, '0044676', NULL, NULL, 113, NULL, 'BolA-like', 286722),
(480538, '0041621', NULL, NULL, 97, NULL, 'BolA-like', 286722),
(480539, '0044935', NULL, NULL, 276, NULL, 'SAICAR synthase-like', 286723),
(480540, '0052189', NULL, NULL, 304, NULL, 'SAICAR synthase-like', 286723),
(480541, '0044167', NULL, NULL, 256, NULL, 'SAICAR synthase-like', 286723),
(480542, '0035636', NULL, NULL, 383, NULL, 'SAICAR synthase-like', 286723),
(480543, '0040269', NULL, NULL, 224, NULL, 'SAICAR synthase-like', 286723),
(480544, '0041741', NULL, NULL, 94, NULL, 'Proguanylin', 286724),
(480545, '0048924', NULL, NULL, 101, NULL, 'FliG', 286725),
(480546, '0047987', NULL, NULL, 213, NULL, 'FliG', 286725),
(480547, '0052081', NULL, NULL, 174, NULL, 'RibA-like', 286726),
(480548, '0041950', NULL, NULL, 144, NULL, 'Mago nashi protein', 286727),
(480549, '0042122', NULL, NULL, 144, NULL, 'Mago nashi protein', 286727),
(480550, '0040409', NULL, NULL, 324, NULL, 'ABC transporter involved in vitamin B12 uptake, BtuC', 286728),
(480551, '0053992', NULL, NULL, 83, NULL, 'Ribosomal protein S20', 286729),
(480552, '0037628', NULL, NULL, 99, NULL, 'Ribosomal protein S20', 286729);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(480553, '0054354', NULL, NULL, 147, NULL, 'RbsD-like', 286730),
(480554, '0041841', NULL, NULL, 131, NULL, 'RbsD-like', 286730),
(480555, '0037808', NULL, NULL, 415, NULL, 'Phosphoglycerate kinase', 286731),
(480556, '0040047', NULL, NULL, 416, NULL, 'Phosphoglycerate kinase', 286731),
(480557, '0044903', NULL, NULL, 398, NULL, 'Phosphoglycerate kinase', 286731),
(480558, '0038550', NULL, NULL, 413, NULL, 'Phosphoglycerate kinase', 286731),
(480559, '0042919', NULL, NULL, 415, NULL, 'Phosphoglycerate kinase', 286731),
(480560, '0042321', NULL, NULL, 394, NULL, 'Phosphoglycerate kinase', 286731),
(480561, '0044642', NULL, NULL, 390, NULL, 'Phosphoglycerate kinase', 286731),
(480562, '0040654', NULL, NULL, 417, NULL, 'Phosphoglycerate kinase', 286731),
(480563, '0034787', NULL, NULL, 415, NULL, 'Phosphoglycerate kinase', 286731),
(480564, '0043456', NULL, NULL, 176, NULL, 'N-terminal domain of adenylylcyclase associated protein, CAP', 286732),
(480565, '0037083', NULL, NULL, 147, NULL, 'DNA polymerase III chi subunit', 286733),
(480566, '0046590', NULL, NULL, 271, NULL, 'Carbon-nitrogen hydrolase', 286734),
(480567, '0039340', NULL, NULL, 262, NULL, 'Carbon-nitrogen hydrolase', 286734),
(480568, '0037433', NULL, NULL, 281, NULL, 'Carbon-nitrogen hydrolase', 286734),
(480569, '0037148', NULL, NULL, 303, NULL, 'Carbon-nitrogen hydrolase', 286734),
(480570, '0043481', NULL, NULL, 104, NULL, 'FMT C-terminal domain-like', 286735),
(480571, '0037670', NULL, NULL, 108, NULL, 'FMT C-terminal domain-like', 286735),
(480572, '0051570', NULL, NULL, 62, NULL, 'FMT C-terminal domain-like', 286735),
(480573, '0037228', NULL, NULL, 214, NULL, 'FMT C-terminal domain-like', 286735),
(480574, '0052062', NULL, NULL, 104, NULL, 'FMT C-terminal domain-like', 286735),
(480575, '0051997', NULL, NULL, 101, NULL, 'FMT C-terminal domain-like', 286735),
(480576, '0053964', NULL, NULL, 90, NULL, 'Shew3726-like', 286736),
(480577, '0045969', NULL, NULL, 47, NULL, 'C-terminal domain of transcriptional repressors', 286737),
(480578, '0054012', NULL, NULL, 75, NULL, 'C-terminal domain of transcriptional repressors', 286737),
(480579, '0046044', NULL, NULL, 97, NULL, 'C-terminal domain of transcriptional repressors', 286737),
(480580, '0047363', NULL, NULL, 60, NULL, 'C-terminal domain of transcriptional repressors', 286737),
(480581, '0046873', NULL, NULL, 86, NULL, 'C-terminal domain of transcriptional repressors', 286737),
(480582, '0053944', NULL, NULL, 75, NULL, 'C-terminal domain of transcriptional repressors', 286737),
(480583, '0050688', NULL, NULL, 47, NULL, 'C-terminal domain of transcriptional repressors', 286737),
(480584, '0037907', NULL, NULL, 94, NULL, 'YlxR-like', 286738),
(480585, '0044328', NULL, NULL, 48, NULL, 'Dimerisation domain of CENP-B', 286739),
(480586, '0051834', NULL, NULL, 132, NULL, 'EF2947-like', 286740),
(480587, '0035624', NULL, NULL, 90, NULL, 'Methionine synthase domain', 286741),
(480588, '0051169', NULL, NULL, 78, NULL, 'YehU-like', 286742),
(480589, '0053667', NULL, NULL, 212, NULL, 'Rv2827c C-terminal domain-like', 286743),
(480590, '0039458', NULL, NULL, 41, NULL, 'Subunit IX of photosystem I reaction centre, PsaJ', 286744),
(480591, '0054025', NULL, NULL, 95, NULL, 'EutN/CcmL-like', 286745),
(480592, '0054634', NULL, NULL, 96, NULL, 'EutN/CcmL-like', 286745),
(480593, '0054667', NULL, NULL, 82, NULL, 'EutN/CcmL-like', 286745),
(480594, '0054705', NULL, NULL, 83, NULL, 'AMPKBI-like', 286746),
(480595, '0054615', NULL, NULL, 107, NULL, 'AMPKBI-like', 286746),
(480596, '0054625', NULL, NULL, 93, NULL, 'AMPKBI-like', 286746),
(480597, '0052688', NULL, NULL, 84, NULL, 'Rv2632c-like', 286747),
(480598, '0041384', NULL, NULL, 290, NULL, 'Antivirulence factor', 286748),
(480599, '0052609', NULL, NULL, 177, NULL, 'Fic-like', 286749),
(480600, '0052814', NULL, NULL, 177, NULL, 'Fic-like', 286749),
(480601, '0045039', NULL, NULL, 360, NULL, 'AF1104-like', 286750),
(480602, '0052676', NULL, NULL, 282, NULL, 'AF1104-like', 286750),
(480603, '0052852', NULL, NULL, 284, NULL, 'AF1104-like', 286750);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(480604, '0038333', NULL, NULL, 178, NULL, 'Macro domain-like', 286751),
(480605, '0043702', NULL, NULL, 172, NULL, 'Macro domain-like', 286751),
(480606, '0051618', NULL, NULL, 186, NULL, 'Macro domain-like', 286751),
(480607, '0051619', NULL, NULL, 189, NULL, 'Macro domain-like', 286751),
(480608, '0051745', NULL, NULL, 168, NULL, 'Macro domain-like', 286751),
(480609, '0048378', NULL, NULL, 264, NULL, 'Macro domain-like', 286751),
(480610, '0038610', NULL, NULL, 192, NULL, 'Macro domain-like', 286751),
(480611, '0040436', NULL, NULL, 159, NULL, 'Macro domain-like', 286751),
(480612, '0052679', NULL, NULL, 154, NULL, 'Macro domain-like', 286751),
(480613, '0041480', NULL, NULL, 67, NULL, 'Replisome organizer (g39p helicase loader/inhibitor protein)', 286752),
(480614, '0047454', NULL, NULL, 95, NULL, 'RPB6/omega subunit-like', 286753),
(480615, '0038875', NULL, NULL, 84, NULL, 'RPB6/omega subunit-like', 286753),
(480616, '0047316', NULL, NULL, 98, NULL, 'RPB6/omega subunit-like', 286753),
(480617, '0042830', NULL, NULL, 127, NULL, 'RPB6/omega subunit-like', 286753),
(480618, '0053558', NULL, NULL, 305, NULL, 'Methyl-accepting chemotaxis protein (MCP) signaling domain', 286754),
(480619, '0053501', NULL, NULL, 227, NULL, 'Methyl-accepting chemotaxis protein (MCP) signaling domain', 286754),
(480620, '0043815', NULL, NULL, 473, NULL, '2-methylcitrate dehydratase PrpD', 286755),
(480621, '0053664', NULL, NULL, 38, NULL, 'UBA-like', 286756),
(480622, '0052455', NULL, NULL, 72, NULL, 'UBA-like', 286756),
(480623, '0050552', NULL, NULL, 64, NULL, 'UBA-like', 286756),
(480624, '0052474', NULL, NULL, 50, NULL, 'UBA-like', 286756),
(480625, '0052431', NULL, NULL, 63, NULL, 'UBA-like', 286756),
(480626, '0050150', NULL, NULL, 80, NULL, 'UBA-like', 286756),
(480627, '0047021', NULL, NULL, 69, NULL, 'UBA-like', 286756),
(480628, '0044670', NULL, NULL, 46, NULL, 'UBA-like', 286756),
(480629, '0050173', NULL, NULL, 73, NULL, 'UBA-like', 286756),
(480630, '0050615', NULL, NULL, 63, NULL, 'UBA-like', 286756),
(480631, '0050158', NULL, NULL, 83, NULL, 'UBA-like', 286756),
(480632, '0052216', NULL, NULL, 51, NULL, 'UBA-like', 286756),
(480633, '0052414', NULL, NULL, 41, NULL, 'UBA-like', 286756),
(480634, '0048193', NULL, NULL, 54, NULL, 'UBA-like', 286756),
(480635, '0050599', NULL, NULL, 73, NULL, 'UBA-like', 286756),
(480636, '0050610', NULL, NULL, 91, NULL, 'UBA-like', 286756),
(480637, '0052215', NULL, NULL, 41, NULL, 'UBA-like', 286756),
(480638, '0050528', NULL, NULL, 63, NULL, 'UBA-like', 286756),
(480639, '0050902', NULL, NULL, 56, NULL, 'UBA-like', 286756),
(480640, '0048854', NULL, NULL, 52, NULL, 'UBA-like', 286756),
(480641, '0049688', NULL, NULL, 55, NULL, 'UBA-like', 286756),
(480642, '0052068', NULL, NULL, 44, NULL, 'UBA-like', 286756),
(480643, '0050161', NULL, NULL, 84, NULL, 'UBA-like', 286756),
(480644, '0052263', NULL, NULL, 51, NULL, 'UBA-like', 286756),
(480645, '0050160', NULL, NULL, 61, NULL, 'UBA-like', 286756),
(480646, '0050526', NULL, NULL, 59, NULL, 'UBA-like', 286756),
(480647, '0051335', NULL, NULL, 42, NULL, 'UBA-like', 286756),
(480648, '0053932', NULL, NULL, 43, NULL, 'UBA-like', 286756),
(480649, '0052228', NULL, NULL, 51, NULL, 'UBA-like', 286756),
(480650, '0052204', NULL, NULL, 41, NULL, 'UBA-like', 286756),
(480651, '0046704', NULL, NULL, 45, NULL, 'UBA-like', 286756),
(480652, '0042026', NULL, NULL, 49, NULL, 'UBA-like', 286756),
(480653, '0035061', NULL, NULL, 52, NULL, 'UBA-like', 286756),
(480654, '0042142', NULL, NULL, 36, NULL, 'UBA-like', 286756),
(480655, '0042141', NULL, NULL, 47, NULL, 'UBA-like', 286756),
(480656, '0047355', NULL, NULL, 49, NULL, 'UBA-like', 286756),
(480657, '0048763', NULL, NULL, 47, NULL, 'UBA-like', 286756),
(480658, '0046543', NULL, NULL, 54, NULL, 'UBA-like', 286756),
(480659, '0048626', NULL, NULL, 44, NULL, 'UBA-like', 286756),
(480660, '0044645', NULL, NULL, 87, NULL, 'Colicin D immunity protein', 286757),
(480661, '0036694', NULL, NULL, 46, NULL, 'N-terminal Zn binding domain of HIV integrase', 286758),
(480662, '0050613', NULL, NULL, 55, NULL, 'N-terminal Zn binding domain of HIV integrase', 286758); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(480663, '0051550', NULL, NULL, 122, NULL, 'Transducin (alpha subunit), insertion domain', 286759),
(480664, '0043922', NULL, NULL, 121, NULL, 'Transducin (alpha subunit), insertion domain', 286759),
(480665, '0035280', NULL, NULL, 116, NULL, 'Transducin (alpha subunit), insertion domain', 286759),
(480666, '0051552', NULL, NULL, 126, NULL, 'Transducin (alpha subunit), insertion domain', 286759),
(480667, '0036001', NULL, NULL, 121, NULL, 'Transducin (alpha subunit), insertion domain', 286759),
(480668, '0051951', NULL, NULL, 117, NULL, 'Transducin (alpha subunit), insertion domain', 286759),
(480669, '0049983', NULL, NULL, 97, NULL, 'Acylphosphatase/BLUF domain-like', 286760),
(480670, '0045805', NULL, NULL, 98, NULL, 'Acylphosphatase/BLUF domain-like', 286760),
(480671, '0047079', NULL, NULL, 88, NULL, 'Acylphosphatase/BLUF domain-like', 286760),
(480672, '0051381', NULL, NULL, 114, NULL, 'Acylphosphatase/BLUF domain-like', 286760),
(480673, '0052052', NULL, NULL, 121, NULL, 'Acylphosphatase/BLUF domain-like', 286760),
(480674, '0052074', NULL, NULL, 136, NULL, 'Acylphosphatase/BLUF domain-like', 286760),
(480675, '0049941', NULL, NULL, 87, NULL, 'Acylphosphatase/BLUF domain-like', 286760),
(480676, '0050769', NULL, NULL, 142, NULL, 'Acylphosphatase/BLUF domain-like', 286760),
(480677, '0051747', NULL, NULL, 98, NULL, 'Acylphosphatase/BLUF domain-like', 286760),
(480678, '0050347', NULL, NULL, 90, NULL, 'Acylphosphatase/BLUF domain-like', 286760),
(480679, '0042479', NULL, NULL, 261, NULL, 'Hypothetical protein YwqG', 286761),
(480680, '0049924', NULL, NULL, 110, NULL, 'WWE domain', 286762),
(480681, '0053688', NULL, NULL, 89, NULL, 'WWE domain', 286762),
(480682, '0053689', NULL, NULL, 80, NULL, 'WWE domain', 286762),
(480683, '0037819', NULL, NULL, 108, NULL, 'C-terminal domain of alpha and beta subunits of F1 ATP synthase', 286763),
(480684, '0043646', NULL, NULL, 131, NULL, 'C-terminal domain of alpha and beta subunits of F1 ATP synthase', 286763),
(480685, '0036814', NULL, NULL, 118, NULL, 'C-terminal domain of alpha and beta subunits of F1 ATP synthase', 286763),
(480686, '0043649', NULL, NULL, 114, NULL, 'C-terminal domain of alpha and beta subunits of F1 ATP synthase', 286763),
(480687, '0037816', NULL, NULL, 129, NULL, 'C-terminal domain of alpha and beta subunits of F1 ATP synthase', 286763),
(480688, '0036812', NULL, NULL, 131, NULL, 'C-terminal domain of alpha and beta subunits of F1 ATP synthase', 286763),
(480689, '0054005', NULL, NULL, 84, NULL, 'Ribosomal L27 protein-like', 286764),
(480690, '0044669', NULL, NULL, 66, NULL, 'Ribosomal L27 protein-like', 286764),
(480691, '0054213', NULL, NULL, 59, NULL, 'Ribosomal L27 protein-like', 286764),
(480692, '0054277', NULL, NULL, 91, NULL, 'Ribosomal L27 protein-like', 286764),
(480693, '0054791', NULL, NULL, 84, NULL, 'Ribosomal L27 protein-like', 286764),
(480694, '0054283', NULL, NULL, 55, NULL, 'Ribosomal L27 protein-like', 286764),
(480695, '0053735', NULL, NULL, 51, NULL, 'Ribosomal L27 protein-like', 286764),
(480696, '0054280', NULL, NULL, 48, NULL, 'Ribosomal L27 protein-like', 286764),
(480697, '0054078', NULL, NULL, 252, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480698, '0047022', NULL, NULL, 386, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480699, '0048199', NULL, NULL, 262, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480700, '0054879', NULL, NULL, 289, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480701, '0036889', NULL, NULL, 117, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480702, '0045881', NULL, NULL, 367, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480703, '0046973', NULL, NULL, 116, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480704, '0048356', NULL, NULL, 277, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480705, '0046972', NULL, NULL, 116, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480706, '0046579', NULL, NULL, 282, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480707, '0047029', NULL, NULL, 392, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480708, '0047270', NULL, NULL, 198, NULL, 'FAD/NAD(P)-binding domain', 286765);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(480709, '0047271', NULL, NULL, 126, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480710, '0048365', NULL, NULL, 123, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480711, '0048364', NULL, NULL, 199, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480712, '0050961', NULL, NULL, 122, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480713, '0050960', NULL, NULL, 168, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480714, '0037441', NULL, NULL, 371, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480715, '0046344', NULL, NULL, 156, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480716, '0047712', NULL, NULL, 293, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480717, '0048009', NULL, NULL, 119, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480718, '0048494', NULL, NULL, 400, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480719, '0053321', NULL, NULL, 230, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480720, '0053322', NULL, NULL, 119, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480721, '0049222', NULL, NULL, 278, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480722, '0047682', NULL, NULL, 352, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480723, '0048771', NULL, NULL, 306, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480724, '0052911', NULL, NULL, 311, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480725, '0053967', NULL, NULL, 254, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480726, '0041341', NULL, NULL, 331, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480727, '0046751', NULL, NULL, 141, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480728, '0046750', NULL, NULL, 187, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480729, '0047564', NULL, NULL, 234, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480730, '0047565', NULL, NULL, 122, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480731, '0046514', NULL, NULL, 224, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480732, '0046760', NULL, NULL, 241, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480733, '0053857', NULL, NULL, 450, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480734, '0042446', NULL, NULL, 162, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480735, '0040660', NULL, NULL, 501, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480736, '0038074', NULL, NULL, 218, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480737, '0046761', NULL, NULL, 117, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480738, '0045798', NULL, NULL, 117, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480739, '0046128', NULL, NULL, 386, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480740, '0045797', NULL, NULL, 239, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480741, '0054159', NULL, NULL, 348, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480742, '0047068', NULL, NULL, 225, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480743, '0049003', NULL, NULL, 318, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480744, '0038468', NULL, NULL, 153, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480745, '0040035', NULL, NULL, 361, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480746, '0052926', NULL, NULL, 381, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480747, '0046416', NULL, NULL, 222, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480748, '0050363', NULL, NULL, 299, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480749, '0035989', NULL, NULL, 306, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480750, '0050364', NULL, NULL, 235, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480751, '0048200', NULL, NULL, 121, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480752, '0048045', NULL, NULL, 115, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480753, '0054729', NULL, NULL, 266, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480754, '0037643', NULL, NULL, 185, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480755, '0039664', NULL, NULL, 357, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480756, '0048607', NULL, NULL, 260, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480757, '0049930', NULL, NULL, 47, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480758, '0040602', NULL, NULL, 230, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480759, '0040688', NULL, NULL, 221, NULL, 'FAD/NAD(P)-binding domain', 286765);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(480760, '0040049', NULL, NULL, 312, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480761, '0046270', NULL, NULL, 323, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480762, '0046274', NULL, NULL, 337, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480763, '0052032', NULL, NULL, 337, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480764, '0044098', NULL, NULL, 191, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480765, '0038449', NULL, NULL, 122, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480766, '0036301', NULL, NULL, 121, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480767, '0036300', NULL, NULL, 184, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480768, '0052313', NULL, NULL, 230, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480769, '0038285', NULL, NULL, 133, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480770, '0050927', NULL, NULL, 234, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480771, '0046834', NULL, NULL, 361, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480772, '0044413', NULL, NULL, 297, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480773, '0041940', NULL, NULL, 117, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480774, '0047133', NULL, NULL, 236, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480775, '0040619', NULL, NULL, 216, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480776, '0048583', NULL, NULL, 230, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480777, '0048584', NULL, NULL, 125, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480778, '0036016', NULL, NULL, 225, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480779, '0036654', NULL, NULL, 123, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480780, '0049150', NULL, NULL, 372, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480781, '0052964', NULL, NULL, 107, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480782, '0050148', NULL, NULL, 193, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480783, '0052600', NULL, NULL, 380, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480784, '0052963', NULL, NULL, 336, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480785, '0045518', NULL, NULL, 222, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480786, '0044705', NULL, NULL, 130, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480787, '0045519', NULL, NULL, 125, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480788, '0049679', NULL, NULL, 126, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480789, '0045870', NULL, NULL, 348, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480790, '0048865', NULL, NULL, 186, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480791, '0036092', NULL, NULL, 372, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480792, '0046446', NULL, NULL, 321, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480793, '0048866', NULL, NULL, 133, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480794, '0043577', NULL, NULL, 374, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480795, '0048108', NULL, NULL, 137, NULL, 'FAD/NAD(P)-binding domain', 286765),
(480796, '0035120', NULL, NULL, 27, NULL, 'Neurotoxin III (ATX III)', 286766),
(480797, '0039786', NULL, NULL, 72, NULL, 'Hemolysin expression modulating protein HHA', 286767),
(480798, '0036260', NULL, NULL, 298, NULL, 'DNA topoisomerase IV, alpha subunit', 286768),
(480799, '0042631', NULL, NULL, 145, NULL, 'Invasion protein A (SipA) , C-terminal actin binding domain', 286769),
(480800, '0039380', NULL, NULL, 127, NULL, 'MTH1598-like', 286770),
(480801, '0039787', NULL, NULL, 140, NULL, 'MTH1598-like', 286770),
(480802, '0039134', NULL, NULL, 88, NULL, 'Hypothetical protein MTH1880', 286771),
(480803, '0051945', NULL, NULL, 32, NULL, 'Viral leader polypeptide zinc finger', 286772),
(480804, '0054006', NULL, NULL, 56, NULL, 'Ribosomal protein L30p/L7e', 286773),
(480805, '0054794', NULL, NULL, 55, NULL, 'Ribosomal protein L30p/L7e', 286773),
(480806, '0035770', NULL, NULL, 60, NULL, 'Ribosomal protein L30p/L7e', 286773),
(480807, '0037548', NULL, NULL, 154, NULL, 'Ribosomal protein L30p/L7e', 286773),
(480808, '0045748', NULL, NULL, 138, NULL, 'Methylglyoxal synthase-like', 286774),
(480809, '0045907', NULL, NULL, 148, NULL, 'Methylglyoxal synthase-like', 286774);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(480810, '0051559', NULL, NULL, 157, NULL, 'Methylglyoxal synthase-like', 286774),
(480811, '0042363', NULL, NULL, 198, NULL, 'Methylglyoxal synthase-like', 286774),
(480812, '0044894', NULL, NULL, 156, NULL, 'Methylglyoxal synthase-like', 286774),
(480813, '0050669', NULL, NULL, 126, NULL, 'Methylglyoxal synthase-like', 286774),
(480814, '0037994', NULL, NULL, 197, NULL, 'Methylglyoxal synthase-like', 286774),
(480815, '0035141', NULL, NULL, 210, NULL, 'Aldehyde ferredoxin oxidoreductase, N-terminal domain', 286775),
(480816, '0035315', NULL, NULL, 210, NULL, 'Aldehyde ferredoxin oxidoreductase, N-terminal domain', 286775),
(480817, '0044505', NULL, NULL, 80, NULL, 'PCD-like', 286776),
(480818, '0036353', NULL, NULL, 99, NULL, 'PCD-like', 286776),
(480819, '0049243', NULL, NULL, 100, NULL, 'PCD-like', 286776),
(480820, '0039848', NULL, NULL, 41, NULL, 'A DNA-binding domain in eukaryotic transcription factors', 286777),
(480821, '0043644', NULL, NULL, 74, NULL, 'A DNA-binding domain in eukaryotic transcription factors', 286777),
(480822, '0053813', NULL, NULL, 55, NULL, 'Orange domain-like', 286778),
(480823, '0035455', NULL, NULL, 46, NULL, 'Cytochrome c1 subunit of cytochrome bc1 complex (Ubiquinol-cytochrome c reductase), transmembrane anchor', 286779),
(480824, '0037292', NULL, NULL, 46, NULL, 'Cytochrome c1 subunit of cytochrome bc1 complex (Ubiquinol-cytochrome c reductase), transmembrane anchor', 286779),
(480825, '0049561', NULL, NULL, 110, NULL, 'PH domain-like', 286780),
(480826, '0051047', NULL, NULL, 114, NULL, 'PH domain-like', 286780),
(480827, '0052133', NULL, NULL, 131, NULL, 'PH domain-like', 286780),
(480828, '0039917', NULL, NULL, 146, NULL, 'PH domain-like', 286780),
(480829, '0038905', NULL, NULL, 109, NULL, 'PH domain-like', 286780),
(480830, '0044152', NULL, NULL, 114, NULL, 'PH domain-like', 286780),
(480831, '0054198', NULL, NULL, 133, NULL, 'PH domain-like', 286780),
(480832, '0050998', NULL, NULL, 118, NULL, 'PH domain-like', 286780),
(480833, '0037213', NULL, NULL, 111, NULL, 'PH domain-like', 286780),
(480834, '0052456', NULL, NULL, 147, NULL, 'PH domain-like', 286780),
(480835, '0039316', NULL, NULL, 119, NULL, 'PH domain-like', 286780),
(480836, '0051204', NULL, NULL, 114, NULL, 'PH domain-like', 286780),
(480837, '0054799', NULL, NULL, 131, NULL, 'PH domain-like', 286780),
(480838, '0041564', NULL, NULL, 121, NULL, 'PH domain-like', 286780),
(480839, '0039313', NULL, NULL, 99, NULL, 'PH domain-like', 286780),
(480840, '0041561', NULL, NULL, 152, NULL, 'PH domain-like', 286780),
(480841, '0042935', NULL, NULL, 104, NULL, 'PH domain-like', 286780),
(480842, '0045807', NULL, NULL, 166, NULL, 'PH domain-like', 286780),
(480843, '0053818', NULL, NULL, 162, NULL, 'PH domain-like', 286780),
(480844, '0048159', NULL, NULL, 109, NULL, 'PH domain-like', 286780),
(480845, '0044630', NULL, NULL, 117, NULL, 'PH domain-like', 286780),
(480846, '0046779', NULL, NULL, 127, NULL, 'PH domain-like', 286780),
(480847, '0044633', NULL, NULL, 132, NULL, 'PH domain-like', 286780),
(480848, '0050088', NULL, NULL, 130, NULL, 'PH domain-like', 286780),
(480849, '0035704', NULL, NULL, 106, NULL, 'PH domain-like', 286780),
(480850, '0050089', NULL, NULL, 118, NULL, 'PH domain-like', 286780),
(480851, '0049773', NULL, NULL, 119, NULL, 'PH domain-like', 286780),
(480852, '0049013', NULL, NULL, 103, NULL, 'PH domain-like', 286780),
(480853, '0049970', NULL, NULL, 107, NULL, 'PH domain-like', 286780),
(480854, '0050722', NULL, NULL, 133, NULL, 'PH domain-like', 286780),
(480855, '0050604', NULL, NULL, 156, NULL, 'PH domain-like', 286780),
(480856, '0052868', NULL, NULL, 238, NULL, 'PH domain-like', 286780),
(480857, '0035702', NULL, NULL, 169, NULL, 'PH domain-like', 286780),
(480858, '0051136', NULL, NULL, 117, NULL, 'PH domain-like', 286780),
(480859, '0052349', NULL, NULL, 129, NULL, 'PH domain-like', 286780),
(480860, '0036997', NULL, NULL, 115, NULL, 'PH domain-like', 286780),
(480861, '0050918', NULL, NULL, 140, NULL, 'PH domain-like', 286780),
(480862, '0036672', NULL, NULL, 113, NULL, 'PH domain-like', 286780);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(480863, '0042143', NULL, NULL, 148, NULL, 'PH domain-like', 286780),
(480864, '0050517', NULL, NULL, 150, NULL, 'PH domain-like', 286780),
(480865, '0039182', NULL, NULL, 126, NULL, 'PH domain-like', 286780),
(480866, '0052260', NULL, NULL, 137, NULL, 'PH domain-like', 286780),
(480867, '0048169', NULL, NULL, 92, NULL, 'PH domain-like', 286780),
(480868, '0048923', NULL, NULL, 113, NULL, 'PH domain-like', 286780),
(480869, '0048603', NULL, NULL, 119, NULL, 'PH domain-like', 286780),
(480870, '0046390', NULL, NULL, 122, NULL, 'PH domain-like', 286780),
(480871, '0050571', NULL, NULL, 126, NULL, 'PH domain-like', 286780),
(480872, '0050772', NULL, NULL, 116, NULL, 'PH domain-like', 286780),
(480873, '0050056', NULL, NULL, 126, NULL, 'PH domain-like', 286780),
(480874, '0050771', NULL, NULL, 136, NULL, 'PH domain-like', 286780),
(480875, '0052197', NULL, NULL, 95, NULL, 'PH domain-like', 286780),
(480876, '0050053', NULL, NULL, 136, NULL, 'PH domain-like', 286780),
(480877, '0052195', NULL, NULL, 99, NULL, 'PH domain-like', 286780),
(480878, '0053042', NULL, NULL, 129, NULL, 'PH domain-like', 286780),
(480879, '0043361', NULL, NULL, 134, NULL, 'PH domain-like', 286780),
(480880, '0052196', NULL, NULL, 102, NULL, 'PH domain-like', 286780),
(480881, '0036787', NULL, NULL, 148, NULL, 'PH domain-like', 286780),
(480882, '0050535', NULL, NULL, 136, NULL, 'PH domain-like', 286780),
(480883, '0051547', NULL, NULL, 109, NULL, 'PH domain-like', 286780),
(480884, '0054814', NULL, NULL, 190, NULL, 'PH domain-like', 286780),
(480885, '0050531', NULL, NULL, 109, NULL, 'PH domain-like', 286780),
(480886, '0053889', NULL, NULL, 101, NULL, 'PH domain-like', 286780),
(480887, '0050335', NULL, NULL, 147, NULL, 'PH domain-like', 286780),
(480888, '0040694', NULL, NULL, 125, NULL, 'PH domain-like', 286780),
(480889, '0040099', NULL, NULL, 142, NULL, 'PH domain-like', 286780),
(480890, '0040330', NULL, NULL, 147, NULL, 'PH domain-like', 286780),
(480891, '0052708', NULL, NULL, 102, NULL, 'PH domain-like', 286780),
(480892, '0054928', NULL, NULL, 116, NULL, 'PH domain-like', 286780),
(480893, '0038081', NULL, NULL, 92, NULL, 'PH domain-like', 286780),
(480894, '0052193', NULL, NULL, 112, NULL, 'PH domain-like', 286780),
(480895, '0049788', NULL, NULL, 209, NULL, 'PH domain-like', 286780),
(480896, '0049787', NULL, NULL, 106, NULL, 'PH domain-like', 286780),
(480897, '0040975', NULL, NULL, 114, NULL, 'PH domain-like', 286780),
(480898, '0046512', NULL, NULL, 103, NULL, 'PH domain-like', 286780),
(480899, '0042632', NULL, NULL, 207, NULL, 'PH domain-like', 286780),
(480900, '0037709', NULL, NULL, 162, NULL, 'PH domain-like', 286780),
(480901, '0047292', NULL, NULL, 145, NULL, 'PH domain-like', 286780),
(480902, '0051750', NULL, NULL, 106, NULL, 'PH domain-like', 286780),
(480903, '0051073', NULL, NULL, 129, NULL, 'PH domain-like', 286780),
(480904, '0047098', NULL, NULL, 117, NULL, 'PH domain-like', 286780),
(480905, '0051791', NULL, NULL, 110, NULL, 'PH domain-like', 286780),
(480906, '0048782', NULL, NULL, 113, NULL, 'PH domain-like', 286780),
(480907, '0049397', NULL, NULL, 195, NULL, 'PH domain-like', 286780),
(480908, '0036336', NULL, NULL, 133, NULL, 'PH domain-like', 286780),
(480909, '0037589', NULL, NULL, 119, NULL, 'PH domain-like', 286780),
(480910, '0037469', NULL, NULL, 100, NULL, 'PH domain-like', 286780),
(480911, '0042168', NULL, NULL, 107, NULL, 'PH domain-like', 286780),
(480912, '0045916', NULL, NULL, 119, NULL, 'PH domain-like', 286780),
(480913, '0042287', NULL, NULL, 108, NULL, 'PH domain-like', 286780),
(480914, '0050619', NULL, NULL, 123, NULL, 'PH domain-like', 286780),
(480915, '0036373', NULL, NULL, 135, NULL, 'PH domain-like', 286780),
(480916, '0049677', NULL, NULL, 133, NULL, 'PH domain-like', 286780),
(480917, '0040866', NULL, NULL, 119, NULL, 'PH domain-like', 286780),
(480918, '0048704', NULL, NULL, 111, NULL, 'PH domain-like', 286780),
(480919, '0047213', NULL, NULL, 242, NULL, 'Pyridoxine 5''-phosphate synthase', 286781),
(480920, '0041249', NULL, NULL, 186, NULL, 'Gametocyte protein Pfg27', 286782);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(480921, '0051715', NULL, NULL, 94, NULL, 'Dcp2 domain-like', 286783),
(480922, '0052872', NULL, NULL, 115, NULL, 'Enolase N-terminal domain-like', 286784),
(480923, '0048551', NULL, NULL, 140, NULL, 'Enolase N-terminal domain-like', 286784),
(480924, '0050712', NULL, NULL, 126, NULL, 'Enolase N-terminal domain-like', 286784),
(480925, '0050710', NULL, NULL, 126, NULL, 'Enolase N-terminal domain-like', 286784),
(480926, '0046517', NULL, NULL, 133, NULL, 'Enolase N-terminal domain-like', 286784),
(480927, '0040034', NULL, NULL, 160, NULL, 'Enolase N-terminal domain-like', 286784),
(480928, '0040132', NULL, NULL, 160, NULL, 'Enolase N-terminal domain-like', 286784),
(480929, '0041088', NULL, NULL, 127, NULL, 'Enolase N-terminal domain-like', 286784),
(480930, '0037593', NULL, NULL, 99, NULL, 'Enolase N-terminal domain-like', 286784),
(480931, '0049602', NULL, NULL, 139, NULL, 'Enolase N-terminal domain-like', 286784),
(480932, '0052171', NULL, NULL, 126, NULL, 'Enolase N-terminal domain-like', 286784),
(480933, '0043386', NULL, NULL, 126, NULL, 'Enolase N-terminal domain-like', 286784),
(480934, '0049749', NULL, NULL, 140, NULL, 'Enolase N-terminal domain-like', 286784),
(480935, '0045368', NULL, NULL, 130, NULL, 'Enolase N-terminal domain-like', 286784),
(480936, '0043071', NULL, NULL, 127, NULL, 'Enolase N-terminal domain-like', 286784),
(480937, '0047650', NULL, NULL, 116, NULL, 'Enolase N-terminal domain-like', 286784),
(480938, '0051293', NULL, NULL, 139, NULL, 'Enolase N-terminal domain-like', 286784),
(480939, '0050382', NULL, NULL, 137, NULL, 'Enolase N-terminal domain-like', 286784),
(480940, '0036853', NULL, NULL, 139, NULL, 'Enolase N-terminal domain-like', 286784),
(480941, '0048606', NULL, NULL, 141, NULL, 'Enolase N-terminal domain-like', 286784),
(480942, '0052918', NULL, NULL, 122, NULL, 'Enolase N-terminal domain-like', 286784),
(480943, '0048446', NULL, NULL, 126, NULL, 'Enolase N-terminal domain-like', 286784),
(480944, '0048743', NULL, NULL, 139, NULL, 'Enolase N-terminal domain-like', 286784),
(480945, '0047479', NULL, NULL, 136, NULL, 'Enolase N-terminal domain-like', 286784),
(480946, '0047652', NULL, NULL, 125, NULL, 'Enolase N-terminal domain-like', 286784),
(480947, '0049412', NULL, NULL, 125, NULL, 'Enolase N-terminal domain-like', 286784),
(480948, '0045995', NULL, NULL, 132, NULL, 'Enolase N-terminal domain-like', 286784),
(480949, '0035492', NULL, NULL, 106, NULL, '14 kDa protein of cytochrome bc1 complex (Ubiquinol-cytochrome c reductase)', 286785),
(480950, '0037295', NULL, NULL, 125, NULL, '14 kDa protein of cytochrome bc1 complex (Ubiquinol-cytochrome c reductase)', 286785),
(480951, '0035457', NULL, NULL, 100, NULL, '14 kDa protein of cytochrome bc1 complex (Ubiquinol-cytochrome c reductase)', 286785),
(480952, '0052705', NULL, NULL, 290, NULL, 'FdhE-like', 286786),
(480953, '0040609', NULL, NULL, 52, NULL, 'Cysteine-rich DNA binding domain, (DM domain)', 286787),
(480954, '0035795', NULL, NULL, 95, NULL, 'EF-hand', 286788),
(480955, '0037732', NULL, NULL, 190, NULL, 'EF-hand', 286788),
(480956, '0044955', NULL, NULL, 142, NULL, 'EF-hand', 286788),
(480957, '0043503', NULL, NULL, 178, NULL, 'EF-hand', 286788),
(480958, '0044956', NULL, NULL, 152, NULL, 'EF-hand', 286788),
(480959, '0049327', NULL, NULL, 182, NULL, 'EF-hand', 286788),
(480960, '0040758', NULL, NULL, 101, NULL, 'EF-hand', 286788),
(480961, '0046215', NULL, NULL, 34, NULL, 'EF-hand', 286788),
(480962, '0047425', NULL, NULL, 85, NULL, 'EF-hand', 286788),
(480963, '0043104', NULL, NULL, 89, NULL, 'EF-hand', 286788),
(480964, '0049328', NULL, NULL, 87, NULL, 'EF-hand', 286788),
(480965, '0046181', NULL, NULL, 73, NULL, 'EF-hand', 286788),
(480966, '0048241', NULL, NULL, 144, NULL, 'EF-hand', 286788),
(480967, '0048244', NULL, NULL, 89, NULL, 'EF-hand', 286788),
(480968, '0042817', NULL, NULL, 99, NULL, 'EF-hand', 286788),
(480969, '0048083', NULL, NULL, 146, NULL, 'EF-hand', 286788),
(480970, '0051413', NULL, NULL, 98, NULL, 'EF-hand', 286788),
(480971, '0038410', NULL, NULL, 84, NULL, 'EF-hand', 286788);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(480972, '0039467', NULL, NULL, 189, NULL, 'EF-hand', 286788),
(480973, '0038096', NULL, NULL, 144, NULL, 'EF-hand', 286788),
(480974, '0036594', NULL, NULL, 156, NULL, 'EF-hand', 286788),
(480975, '0040528', NULL, NULL, 146, NULL, 'EF-hand', 286788),
(480976, '0038094', NULL, NULL, 140, NULL, 'EF-hand', 286788),
(480977, '0041978', NULL, NULL, 77, NULL, 'EF-hand', 286788),
(480978, '0036627', NULL, NULL, 173, NULL, 'EF-hand', 286788),
(480979, '0049189', NULL, NULL, 110, NULL, 'EF-hand', 286788),
(480980, '0035893', NULL, NULL, 78, NULL, 'EF-hand', 286788),
(480981, '0039974', NULL, NULL, 89, NULL, 'EF-hand', 286788),
(480982, '0049061', NULL, NULL, 76, NULL, 'EF-hand', 286788),
(480983, '0049906', NULL, NULL, 189, NULL, 'EF-hand', 286788),
(480984, '0038125', NULL, NULL, 167, NULL, 'EF-hand', 286788),
(480985, '0037031', NULL, NULL, 187, NULL, 'EF-hand', 286788),
(480986, '0036461', NULL, NULL, 141, NULL, 'EF-hand', 286788),
(480987, '0047687', NULL, NULL, 172, NULL, 'EF-hand', 286788),
(480988, '0053282', NULL, NULL, 107, NULL, 'EF-hand', 286788),
(480989, '0046115', NULL, NULL, 108, NULL, 'EF-hand', 286788),
(480990, '0044062', NULL, NULL, 157, NULL, 'EF-hand', 286788),
(480991, '0047571', NULL, NULL, 192, NULL, 'EF-hand', 286788),
(480992, '0043372', NULL, NULL, 109, NULL, 'EF-hand', 286788),
(480993, '0036978', NULL, NULL, 97, NULL, 'EF-hand', 286788),
(480994, '0036977', NULL, NULL, 125, NULL, 'EF-hand', 286788),
(480995, '0048828', NULL, NULL, 109, NULL, 'EF-hand', 286788),
(480996, '0038475', NULL, NULL, 73, NULL, 'EF-hand', 286788),
(480997, '0042847', NULL, NULL, 92, NULL, 'EF-hand', 286788),
(480998, '0048820', NULL, NULL, 103, NULL, 'EF-hand', 286788),
(480999, '0049237', NULL, NULL, 108, NULL, 'EF-hand', 286788),
(481000, '0047730', NULL, NULL, 93, NULL, 'EF-hand', 286788),
(481001, '0045710', NULL, NULL, 92, NULL, 'EF-hand', 286788),
(481002, '0035639', NULL, NULL, 74, NULL, 'EF-hand', 286788),
(481003, '0054797', NULL, NULL, 170, NULL, 'EF-hand', 286788),
(481004, '0052892', NULL, NULL, 143, NULL, 'EF-hand', 286788),
(481005, '0045680', NULL, NULL, 90, NULL, 'EF-hand', 286788),
(481006, '0046010', NULL, NULL, 108, NULL, 'EF-hand', 286788),
(481007, '0035873', NULL, NULL, 68, NULL, 'EF-hand', 286788),
(481008, '0045207', NULL, NULL, 86, NULL, 'EF-hand', 286788),
(481009, '0045726', NULL, NULL, 106, NULL, 'EF-hand', 286788),
(481010, '0037250', NULL, NULL, 146, NULL, 'EF-hand', 286788),
(481011, '0045442', NULL, NULL, 185, NULL, 'EF-hand', 286788),
(481012, '0049489', NULL, NULL, 79, NULL, 'EF-hand', 286788),
(481013, '0045443', NULL, NULL, 174, NULL, 'EF-hand', 286788),
(481014, '0042454', NULL, NULL, 100, NULL, 'EF-hand', 286788),
(481015, '0041808', NULL, NULL, 147, NULL, 'EF-hand', 286788),
(481016, '0036831', NULL, NULL, 87, NULL, 'EF-hand', 286788),
(481017, '0053359', NULL, NULL, 109, NULL, 'EF-hand', 286788),
(481018, '0046706', NULL, NULL, 165, NULL, 'EF-hand', 286788),
(481019, '0035583', NULL, NULL, 181, NULL, 'EF-hand', 286788),
(481020, '0053194', NULL, NULL, 145, NULL, 'EF-hand', 286788),
(481021, '0047873', NULL, NULL, 93, NULL, 'EF-hand', 286788),
(481022, '0043035', NULL, NULL, 188, NULL, 'EF-hand', 286788),
(481023, '0053193', NULL, NULL, 145, NULL, 'EF-hand', 286788),
(481024, '0036390', NULL, NULL, 186, NULL, 'EF-hand', 286788),
(481025, '0043674', NULL, NULL, 99, NULL, 'EF-hand', 286788),
(481026, '0048602', NULL, NULL, 201, NULL, 'EF-hand', 286788),
(481027, '0048211', NULL, NULL, 90, NULL, 'EF-hand', 286788),
(481028, '0051184', NULL, NULL, 182, NULL, 'EF-hand', 286788),
(481029, '0049421', NULL, NULL, 181, NULL, 'EF-hand', 286788),
(481030, '0050653', NULL, NULL, 83, NULL, 'EF-hand', 286788),
(481031, '0039413', NULL, NULL, 86, NULL, 'EF-hand', 286788),
(481032, '0036425', NULL, NULL, 183, NULL, 'EF-hand', 286788),
(481033, '0041542', NULL, NULL, 101, NULL, 'EF-hand', 286788),
(481034, '0037597', NULL, NULL, 92, NULL, 'EF-hand', 286788),
(481035, '0049706', NULL, NULL, 118, NULL, 'EF-hand', 286788),
(481036, '0038680', NULL, NULL, 181, NULL, 'EF-hand', 286788);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(481037, '0039372', NULL, NULL, 94, NULL, 'EF-hand', 286788),
(481038, '0050649', NULL, NULL, 138, NULL, 'EF-hand', 286788),
(481039, '0043728', NULL, NULL, 151, NULL, 'EF-hand', 286788),
(481040, '0047768', NULL, NULL, 76, NULL, 'EF-hand', 286788),
(481041, '0053255', NULL, NULL, 81, NULL, 'EF-hand', 286788),
(481042, '0048981', NULL, NULL, 95, NULL, 'EF-hand', 286788),
(481043, '0037987', NULL, NULL, 187, NULL, 'EF-hand', 286788),
(481044, '0035206', NULL, NULL, 165, NULL, 'EF-hand', 286788),
(481045, '0037066', NULL, NULL, 194, NULL, 'EF-hand', 286788),
(481046, '0046726', NULL, NULL, 95, NULL, 'EF-hand', 286788),
(481047, '0039003', NULL, NULL, 75, NULL, 'EF-hand', 286788),
(481048, '0045999', NULL, NULL, 148, NULL, 'EF-hand', 286788),
(481049, '0043217', NULL, NULL, 148, NULL, 'EF-hand', 286788),
(481050, '0040067', NULL, NULL, 184, NULL, 'EF-hand', 286788),
(481051, '0039521', NULL, NULL, 134, NULL, 'EF-hand', 286788),
(481052, '0040064', NULL, NULL, 186, NULL, 'EF-hand', 286788),
(481053, '0047413', NULL, NULL, 110, NULL, 'EF-hand', 286788),
(481054, '0047377', NULL, NULL, 321, NULL, 'EF-hand', 286788),
(481055, '0048467', NULL, NULL, 176, NULL, 'EF-hand', 286788),
(481056, '0044028', NULL, NULL, 67, NULL, 'EF-hand', 286788),
(481057, '0041313', NULL, NULL, 162, NULL, 'EF-hand', 286788),
(481058, '0054609', NULL, NULL, 126, NULL, 'Dom34/Pelota N-terminal domain-like', 286789),
(481059, '0054715', NULL, NULL, 135, NULL, 'Dom34/Pelota N-terminal domain-like', 286789),
(481060, '0038969', NULL, NULL, 65, NULL, 'Thyroglobulin type-1 domain', 286790),
(481061, '0043310', NULL, NULL, 107, NULL, 'Thyroglobulin type-1 domain', 286790),
(481062, '0053844', NULL, NULL, 79, NULL, 'Thyroglobulin type-1 domain', 286790),
(481063, '0053843', NULL, NULL, 83, NULL, 'Thyroglobulin type-1 domain', 286790),
(481064, '0053631', NULL, NULL, 93, NULL, 'GAT-like domain', 286791),
(481065, '0053630', NULL, NULL, 90, NULL, 'GAT-like domain', 286791),
(481066, '0047255', NULL, NULL, 133, NULL, 'GAT-like domain', 286791),
(481067, '0038571', NULL, NULL, 132, NULL, 'GAT-like domain', 286791),
(481068, '0048660', NULL, NULL, 132, NULL, 'GAT-like domain', 286791),
(481069, '0039330', NULL, NULL, 41, NULL, 'GAT-like domain', 286791),
(481070, '0053301', NULL, NULL, 108, NULL, 'SH2 domain', 286792),
(481071, '0048098', NULL, NULL, 132, NULL, 'SH2 domain', 286792),
(481072, '0049185', NULL, NULL, 100, NULL, 'SH2 domain', 286792),
(481073, '0050893', NULL, NULL, 141, NULL, 'SH2 domain', 286792),
(481074, '0034802', NULL, NULL, 106, NULL, 'SH2 domain', 286792),
(481075, '0047684', NULL, NULL, 109, NULL, 'SH2 domain', 286792),
(481076, '0048234', NULL, NULL, 120, NULL, 'SH2 domain', 286792),
(481077, '0048099', NULL, NULL, 124, NULL, 'SH2 domain', 286792),
(481078, '0040529', NULL, NULL, 105, NULL, 'SH2 domain', 286792),
(481079, '0053769', NULL, NULL, 103, NULL, 'SH2 domain', 286792),
(481080, '0038863', NULL, NULL, 103, NULL, 'SH2 domain', 286792),
(481081, '0034940', NULL, NULL, 129, NULL, 'SH2 domain', 286792),
(481082, '0035513', NULL, NULL, 126, NULL, 'SH2 domain', 286792),
(481083, '0039796', NULL, NULL, 97, NULL, 'SH2 domain', 286792),
(481084, '0040671', NULL, NULL, 108, NULL, 'SH2 domain', 286792),
(481085, '0045209', NULL, NULL, 88, NULL, 'SH2 domain', 286792),
(481086, '0037590', NULL, NULL, 112, NULL, 'SH2 domain', 286792),
(481087, '0036143', NULL, NULL, 112, NULL, 'SH2 domain', 286792),
(481088, '0054170', NULL, NULL, 112, NULL, 'SH2 domain', 286792),
(481089, '0044534', NULL, NULL, 131, NULL, 'SH2 domain', 286792),
(481090, '0049229', NULL, NULL, 86, NULL, 'SH2 domain', 286792),
(481091, '0052267', NULL, NULL, 106, NULL, 'SH2 domain', 286792),
(481092, '0043094', NULL, NULL, 97, NULL, 'SH2 domain', 286792),
(481093, '0045451', NULL, NULL, 109, NULL, 'SH2 domain', 286792),
(481094, '0035526', NULL, NULL, 141, NULL, 'SH2 domain', 286792),
(481095, '0035602', NULL, NULL, 110, NULL, 'SH2 domain', 286792),
(481096, '0037781', NULL, NULL, 111, NULL, 'SH2 domain', 286792),
(481097, '0045735', NULL, NULL, 125, NULL, 'SH2 domain', 286792);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(481098, '0039981', NULL, NULL, 101, NULL, 'SH2 domain', 286792),
(481099, '0036271', NULL, NULL, 104, NULL, 'SH2 domain', 286792),
(481100, '0045979', NULL, NULL, 114, NULL, 'SH2 domain', 286792),
(481101, '0042328', NULL, NULL, 112, NULL, 'SH2 domain', 286792),
(481102, '0035143', NULL, NULL, 106, NULL, 'SH2 domain', 286792),
(481103, '0042706', NULL, NULL, 103, NULL, 'SH2 domain', 286792),
(481104, '0040946', NULL, NULL, 104, NULL, 'SH2 domain', 286792),
(481105, '0048620', NULL, NULL, 101, NULL, 'SH2 domain', 286792),
(481106, '0041534', NULL, NULL, 105, NULL, 'SH2 domain', 286792),
(481107, '0045415', NULL, NULL, 105, NULL, 'SH2 domain', 286792),
(481108, '0044306', NULL, NULL, 120, NULL, 'GHMP Kinase, C-terminal domain', 286793),
(481109, '0037596', NULL, NULL, 203, NULL, 'GHMP Kinase, C-terminal domain', 286793),
(481110, '0048150', NULL, NULL, 193, NULL, 'GHMP Kinase, C-terminal domain', 286793),
(481111, '0047892', NULL, NULL, 169, NULL, 'GHMP Kinase, C-terminal domain', 286793),
(481112, '0050715', NULL, NULL, 176, NULL, 'GHMP Kinase, C-terminal domain', 286793),
(481113, '0037811', NULL, NULL, 133, NULL, 'GHMP Kinase, C-terminal domain', 286793),
(481114, '0049315', NULL, NULL, 171, NULL, 'GHMP Kinase, C-terminal domain', 286793),
(481115, '0042330', NULL, NULL, 183, NULL, 'GHMP Kinase, C-terminal domain', 286793),
(481116, '0041877', NULL, NULL, 120, NULL, 'GHMP Kinase, C-terminal domain', 286793),
(481117, '0047747', NULL, NULL, 135, NULL, 'GHMP Kinase, C-terminal domain', 286793),
(481118, '0047824', NULL, NULL, 137, NULL, 'GHMP Kinase, C-terminal domain', 286793),
(481119, 'TIGR03156', NULL, 'GTP_HflX: GTP-binding protein HflX', 351, NULL, 'TIGR03156', 286794),
(481120, 'TIGR00308', NULL, 'TRM1: N2,N2-dimethylguanosine tRNA methyltransferase', 375, NULL, 'TIGR00308', 286795),
(481121, 'TIGR03396', NULL, 'PC_PLC: phospholipase C, phosphocholine-specific', 688, NULL, 'TIGR03396', 286796),
(481122, 'TIGR02758', NULL, 'TraA_TIGR: type IV conjugative transfer system pilin TraA', 98, NULL, 'TIGR02758', 286797),
(481123, 'TIGR00595', NULL, 'priA: primosomal protein N''', 509, NULL, 'TIGR00595', 286798),
(481124, 'TIGR02621', NULL, 'cas3_GSU0051: CRISPR-associated helicase Cas3, subtype Dpsyc', 864, NULL, 'TIGR02621', 286799),
(481125, 'TIGR02518', NULL, 'EutH_ACDH: acetaldehyde dehydrogenase (acetylating)', 488, NULL, 'TIGR02518', 286800),
(481126, 'TIGR00115', NULL, 'tig: trigger factor', 410, NULL, 'TIGR00115', 286801),
(481127, 'TIGR03109', NULL, 'exosortase_1: exosortase A', 267, NULL, 'TIGR03109', 286802),
(481128, 'TIGR00891', NULL, '2A0112: MFS transporter, sialate:H+ symporter (SHS) family', 405, NULL, 'TIGR00891', 286803),
(481129, 'TIGR01186', NULL, 'proV: glycine betaine/L-proline transport ATP binding subunit', 363, NULL, 'TIGR01186', 286804),
(481130, 'TIGR02861', NULL, 'SASP_H: small acid-soluble spore protein, H-type', 58, NULL, 'TIGR02861', 286805),
(481131, 'TIGR03589', NULL, 'PseB: UDP-N-acetylglucosamine 4,6-dehydratase (inverting)', 324, NULL, 'TIGR03589', 286806),
(481132, 'TIGR00411', NULL, 'redox_disulf_1: redox-active disulfide protein 1', 82, NULL, 'TIGR00411', 286807),
(481133, 'TIGR02565', NULL, 'cas_Csy2: CRISPR type I-F/YPEST-associated protein Csy2', 296, NULL, 'TIGR02565', 286808),
(481134, 'TIGR04090', NULL, 'exp_by_SipW_IV: alternate signal-mediated exported protein, CPF_0494 family', 241, NULL, 'TIGR04090', 286809),
(481135, 'TIGR03212', NULL, 'uraD_N-term-dom: putative urate catabolism protein', 297, NULL, 'TIGR03212', 286810),
(481136, 'TIGR00788', NULL, 'fbt: folate/biopterin transporter', 468, NULL, 'TIGR00788', 286811),
(481137, 'TIGR01242', NULL, '26Sp45: 26S proteasome subunit P45 family', 364, NULL, 'TIGR01242', 286812),
(481138, 'TIGR00059', NULL, 'L17: ribosomal protein bL17', 112, NULL, 'TIGR00059', 286813),
(481139, 'TIGR01734', NULL, 'D-ala-DACP-lig: D-alanine--poly(phosphoribitol) ligase, subunit 1', 504, NULL, 'TIGR01734', 286814),
(481140, 'TIGR03944', NULL, 'dehyd_SbnB_fam: 2,3-diaminopropionate biosynthesis protein SbnB', 327, NULL, 'TIGR03944', 286815);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(481141, 'TIGR00844', NULL, 'c_cpa1: sodium/hydrogen antiporter', 810, NULL, 'TIGR00844', 286816),
(481142, 'TIGR02132', NULL, 'phaR_Bmeg: polyhydroxyalkanoic acid synthase, PhaR subunit', 189, NULL, 'TIGR02132', 286817),
(481143, 'TIGR03692', NULL, 'ATP_dep_HslV: ATP-dependent protease HslVU, peptidase subunit', 171, NULL, 'TIGR03692', 286818),
(481144, 'TIGR01482', NULL, 'SPP-subfamily: sucrose-phosphate phosphatase subfamily', 225, NULL, 'TIGR01482', 286819),
(481145, 'TIGR00651', NULL, 'pta: phosphate acetyltransferase', 304, NULL, 'TIGR00651', 286820),
(481146, 'TIGR02325', NULL, 'C_P_lyase_phnF: phosphonate metabolism transcriptional regulator PhnF', 238, NULL, 'TIGR02325', 286821),
(481147, 'TIGR00903', NULL, '2A0129: major facilitator 4 family protein', 368, NULL, 'TIGR00903', 286822),
(481148, 'TIGR01678', NULL, 'FAD_lactone_ox: sugar 1,4-lactone oxidases', 438, NULL, 'TIGR01678', 286823),
(481149, 'TIGR01675', NULL, 'plant-AP: plant acid phosphatase', 229, NULL, 'TIGR01675', 286824),
(481150, 'TIGR03349', NULL, 'IV_VI_DotU: type IV/VI secretion system protein, DotU family', 211, NULL, 'TIGR03349', 286825),
(481151, 'TIGR02073', NULL, 'PBP_1c: penicillin-binding protein 1C', 728, NULL, 'TIGR02073', 286826),
(481152, 'TIGR01927', NULL, 'menC_gamma/gm+: o-succinylbenzoate synthase', 307, NULL, 'TIGR01927', 286827),
(481153, 'TIGR00950', NULL, '2A78: carboxylate/amino acid/amine transporter', 264, NULL, 'TIGR00950', 286828),
(481154, 'TIGR04286', NULL, 'MSEP-CTERM: MSEP-CTERM protein', 920, NULL, 'TIGR04286', 286829),
(481155, 'TIGR04476', NULL, 'exosort_XrtN: exosortase N', 406, NULL, 'TIGR04476', 286830),
(481156, 'TIGR03648', NULL, 'Na_symport_lg: probable sodium:solute symporter, VC_2705 subfamily', 547, NULL, 'TIGR03648', 286831),
(481157, 'TIGR01438', NULL, 'TGR: thioredoxin and glutathione reductase', 485, NULL, 'TIGR01438', 286832),
(481158, 'TIGR01628', NULL, 'PABP-1234: polyadenylate binding protein, human types 1, 2, 3, 4 family', 595, NULL, 'TIGR01628', 286833),
(481159, 'TIGR02076', NULL, 'pyrH_arch: putative uridylate kinase', 222, NULL, 'TIGR02076', 286834),
(481160, 'TIGR01301', NULL, 'GPH_sucrose: sucrose/H+ symporter', 476, NULL, 'TIGR01301', 286835),
(481161, 'TIGR02266', NULL, 'gmx_TIGR02266: Myxococcus xanthus paralogous domain TIGR02266', 96, NULL, 'TIGR02266', 286836),
(481162, 'TIGR03511', NULL, 'GldH_lipo: gliding motility-associated lipoprotein GldH', 155, NULL, 'TIGR03511', 286837),
(481163, 'TIGR03838', NULL, 'queuosine_YadB: glutamyl-queuosine tRNA(Asp) synthetase', 272, NULL, 'TIGR03838', 286838),
(481164, 'TIGR03701', NULL, 'mena_SCO4490: menaquinone biosynthesis decarboxylase, SCO4490 family', 433, NULL, 'TIGR03701', 286839),
(481165, 'TIGR01731', NULL, 'fil_hemag_20aa: adhesin HecA family 20-residue repeat (two copies)', 40, NULL, 'TIGR01731', 286840),
(481166, 'TIGR03405', NULL, 'Phn_Fe-ADH: phosphonate metabolism-associated iron-containing alcohol dehydrogenase', 355, NULL, 'TIGR03405', 286841),
(481167, 'TIGR04239', NULL, 'rhombo_GlpG: rhomboid family protease GlpG', 271, NULL, 'TIGR04239', 286842),
(481168, 'TIGR04429', NULL, 'Phr_nterm: Phr family secreted Rap phosphatase inhibitor', 28, NULL, 'TIGR04429', 286843),
(481169, 'TIGR01541', NULL, 'tape_meas_lam_C: phage tail tape measure protein, lambda family', 332, NULL, 'TIGR01541', 286844),
(481170, 'TIGR03695', NULL, 'menH_SHCHC: 2-succinyl-6-hydroxy-2,4-cyclohexadiene-1-carboxylate synthase', 252, NULL, 'TIGR03695', 286845),
(481171, 'TIGR02920', NULL, 'acc_sec_Y2: accessory Sec system translocase SecY2', 395, NULL, 'TIGR02920', 286846),
(481172, 'TIGR00847', NULL, 'ccoS: cytochrome oxidase maturation protein, cbb3-type', 51, NULL, 'TIGR00847', 286847),
(481173, 'TIGR03885', NULL, 'flavin_revert: probable non-F420 flavinoid oxidoreductase', 315, NULL, 'TIGR03885', 286848),
(481174, 'TIGR00414', NULL, 'serS: serine--tRNA ligase', 418, NULL, 'TIGR00414', 286849),
(481175, 'TIGR00604', NULL, 'rad3: DNA repair helicase (rad3)', 706, NULL, 'TIGR00604', 286850),
(481176, 'TIGR01379', NULL, 'thiL: thiamine-phosphate kinase', 320, NULL, 'TIGR01379', 286851);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(481177, 'TIGR03452', NULL, 'mycothione_red: mycothione reductase', 452, NULL, 'TIGR03452', 286852),
(481178, 'TIGR00112', NULL, 'proC: pyrroline-5-carboxylate reductase', 263, NULL, 'TIGR00112', 286853),
(481179, 'TIGR02624', NULL, 'rhamnu_1P_ald: rhamnulose-1-phosphate aldolase', 270, NULL, 'TIGR02624', 286854),
(481180, 'TIGR02814', NULL, 'pfaD_fam: PfaD family protein', 444, NULL, 'TIGR02814', 286855),
(481181, 'TIGR01189', NULL, 'ccmA: heme ABC exporter, ATP-binding protein CcmA', 198, NULL, 'TIGR01189', 286856),
(481182, 'TIGR04043', NULL, 'rSAM_MSMEG_0568: radical SAM protein, MSMEG_0568 family', 354, NULL, 'TIGR04043', 286857),
(481183, 'TIGR01974', NULL, 'NDH_I_L: proton-translocating NADH-quinone oxidoreductase, chain L', 630, NULL, 'TIGR01974', 286858),
(481184, 'TIGR04535', NULL, 'ferrit_encaps: ferritin-like protein', 114, NULL, 'TIGR04535', 286859),
(481185, 'TIGR01005', NULL, 'eps_transp_fam: exopolysaccharide transport protein family', 754, NULL, 'TIGR01005', 286860),
(481186, 'TIGR02998', NULL, 'RraA_entero: regulator of ribonuclease activity A', 161, NULL, 'TIGR02998', 286861),
(481187, 'TIGR00355', NULL, 'purH: phosphoribosylaminoimidazolecarboxamide formyltransferase/IMP cyclohydrolase', 511, NULL, 'TIGR00355', 286862),
(481188, 'TIGR04102', NULL, 'SWIM_PBPRA1643: SWIM/SEC-C metal-binding motif protein, PBPRA1643 family', 108, NULL, 'TIGR04102', 286863),
(481189, 'TIGR02219', NULL, 'phage_NlpC_fam: putative phage cell wall peptidase, NlpC/P60 family', 134, NULL, 'TIGR02219', 286864),
(481190, 'TIGR03393', NULL, 'indolpyr_decarb: indolepyruvate decarboxylase', 539, NULL, 'TIGR03393', 286865),
(481191, 'TIGR00296', NULL, 'TIGR00296: uncharacterized protein, PH0010 family', 200, NULL, 'TIGR00296', 286866),
(481192, 'TIGR03262', NULL, 'PhnU2: putative 2-aminoethylphosphonate ABC transporter, permease protein', 546, NULL, 'TIGR03262', 286867),
(481193, 'TIGR02029', NULL, 'AcsF: magnesium-protoporphyrin IX monomethyl ester aerobic oxidative cyclase', 337, NULL, 'TIGR02029', 286868),
(481194, 'TIGR03106', NULL, 'trio_M42_hydro: hydrolase, peptidase M42 family', 343, NULL, 'TIGR03106', 286869),
(481195, 'TIGR02328', NULL, 'TIGR02328: conserved hypothetical protein', 120, NULL, 'TIGR02328', 286870),
(481196, 'TIGR00545', NULL, 'lipoyltrans: lipoyltransferase and lipoate-protein ligase', 326, NULL, 'TIGR00545', 286871),
(481197, 'TIGR03346', NULL, 'chaperone_ClpB: ATP-dependent chaperone protein ClpB', 853, NULL, 'TIGR03346', 286872),
(481198, 'TIGR02708', NULL, 'L_lactate_ox: L-lactate oxidase', 367, NULL, 'TIGR02708', 286873),
(481199, 'TIGR00785', NULL, 'dass: transporter, divalent anion:Na+ symporter (DASS) family', 444, NULL, 'TIGR00785', 286874),
(481200, 'TIGR03153', NULL, 'cytochr_NrfH: cytochrome c nitrite reductase, small subunit', 138, NULL, 'TIGR03153', 286875),
(481201, 'TIGR02671', NULL, 'cas_csx9: CRISPR-associated protein Cas8a2/Csx9, subtype I-A/APERN', 377, NULL, 'TIGR02671', 286876),
(481202, 'TIGR00221', NULL, 'nagA: N-acetylglucosamine-6-phosphate deacetylase', 380, NULL, 'TIGR00221', 286877),
(481203, 'TIGR02375', NULL, 'pseudoazurin: pseudoazurin', 116, NULL, 'TIGR02375', 286878),
(481204, 'TIGR01183', NULL, 'ntrB: nitrate ABC transporter, permease protein', 202, NULL, 'TIGR01183', 286879),
(481205, 'TIGR04105', NULL, 'FeFe_hydrog_B1: [FeFe] hydrogenase, group B1/B3', 462, NULL, 'TIGR04105', 286880),
(481206, 'TIGR01600', NULL, 'phage_tail_L: phage minor tail protein L', 224, NULL, 'TIGR01600', 286881),
(481207, 'TIGR01376', NULL, 'POMP_repeat: chlamydial polymorphic outer membrane protein repeat', 28, NULL, 'TIGR01376', 286882),
(481208, 'TIGR00601', NULL, 'rad23: UV excision repair protein Rad23', 381, NULL, 'TIGR00601', 286883),
(481209, 'TIGR02755', NULL, 'TraX_Ftype: type-F conjugative transfer system pilin acetylase TraX', 224, NULL, 'TIGR02755', 286884),
(481210, 'TIGR00906', NULL, '2A0303: cationic amino acid transport permease', 602, NULL, 'TIGR00906', 286885),
(481211, 'TIGR03882', NULL, 'cyclo_dehyd_2: bacteriocin biosynthesis cyclodehydratase domain', 164, NULL, 'TIGR03882', 286886);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(481212, 'TIGR02699', NULL, 'archaeo_AfpA: archaeoflavoprotein AfpA', 174, NULL, 'TIGR02699', 286887),
(481213, 'TIGR04280', NULL, 'geopep_mat_rSAM: putative geopeptide radical SAM maturase', 428, NULL, 'TIGR04280', 286888),
(481214, 'TIGR01544', NULL, 'HAD-SF-IE: HAD hydrolase, family IE', 283, NULL, 'TIGR01544', 286889),
(481215, 'TIGR00894', NULL, '2A0114euk: Na(+)-dependent inorganic phosphate cotransporter', 465, NULL, 'TIGR00894', 286890),
(481216, 'TIGR00009', NULL, 'L28: ribosomal protein bL28', 58, NULL, 'TIGR00009', 286891),
(481217, 'TIGR00249', NULL, 'sixA: phosphohistidine phosphatase SixA', 154, NULL, 'TIGR00249', 286892),
(481218, 'TIGR01924', NULL, 'rsbW_low_gc: anti-sigma B factor', 159, NULL, 'TIGR01924', 286893),
(481219, 'TIGR02135', NULL, 'phoU_full: phosphate transport system regulatory protein PhoU', 212, NULL, 'TIGR02135', 286894),
(481220, 'TIGR02515', NULL, 'IV_pilus_PilQ: type IV pilus secretin PilQ', 428, NULL, 'TIGR02515', 286895),
(481221, 'TIGR00592', NULL, 'pol2: DNA polymerase (pol2)', 1176, NULL, 'TIGR00592', 286896),
(481222, 'TIGR01485', NULL, 'SPP_plant-cyano: sucrose phosphatase', 249, NULL, 'TIGR01485', 286897),
(481223, 'TIGR01737', NULL, 'FGAM_synth_I: phosphoribosylformylglycinamidine synthase I', 228, NULL, 'TIGR01737', 286898),
(481224, 'TIGR04046', NULL, 'MSMEG_0569_nitr: flavin-dependent oxidoreductase, MSMEG_0569 family', 400, NULL, 'TIGR04046', 286899),
(481225, 'TIGR04426', NULL, 'rSAM_desII: TDP-4-amino-4,6-dideoxy-D-glucose deaminase', 468, NULL, 'TIGR04426', 286900),
(481226, 'TIGR03408', NULL, 'urea_trans_UrtC: urea ABC transporter, permease protein UrtC', 313, NULL, 'TIGR03408', 286901),
(481227, 'TIGR01008', NULL, 'uS3_euk_arch: ribosomal protein uS3', 195, NULL, 'TIGR01008', 286902),
(481228, 'TIGR00710', NULL, 'efflux_Bcr_CflA: drug resistance transporter, Bcr/CflA subfamily', 385, NULL, 'TIGR00710', 286903),
(481229, 'TIGR01865', NULL, 'cas_Csn1: CRISPR subtype II RNA-guided endonuclease Cas9', 830, NULL, 'TIGR01865', 286904),
(481230, 'TIGR03094', NULL, 'sulfo_cyanin: sulfocyanin', 195, NULL, 'TIGR03094', 286905),
(481231, 'TIGR03941', NULL, 'tRNA_deam_assoc: putative tRNA adenosine deaminase-associated protein', 156, NULL, 'TIGR03941', 286906),
(481232, 'TIGR02923', NULL, 'AhaC: ATP synthase A1, C subunit', 348, NULL, 'TIGR02923', 286907),
(481233, 'TIGR02026', NULL, 'BchE: magnesium-protoporphyrin IX monomethyl ester anaerobic oxidative cyclase', 497, NULL, 'TIGR02026', 286908),
(481234, 'TIGR03991', NULL, 'alt_bact_glmU: UDP-N-acetylglucosamine diphosphorylase/glucosamine-1-phosphate N-acetyltransferase', 394, NULL, 'TIGR03991', 286909),
(481235, 'TIGR04093', NULL, 'cas1_CYANO: CRISPR-associated endonuclease Cas1, subtype CYANO', 334, NULL, 'TIGR04093', 286910),
(481236, 'TIGR04473', NULL, 'taxol_Phe_23mut: phenylalanine aminomutase (L-beta-phenylalanine forming)', 687, NULL, 'TIGR04473', 286911),
(481237, 'TIGR01055', NULL, 'parE_Gneg: DNA topoisomerase IV, B subunit', 625, NULL, 'TIGR01055', 286912),
(481238, 'TIGR03561', NULL, 'organ_hyd_perox: peroxiredoxin, Ohr subfamily', 134, NULL, 'TIGR03561', 286913),
(481239, 'TIGR02817', NULL, 'adh_fam_1: zinc-binding alcohol dehydrogenase family protein', 336, NULL, 'TIGR02817', 286914),
(481240, 'TIGR00056', NULL, 'TIGR00056: ABC transport permease subunit', 260, NULL, 'TIGR00056', 286915),
(481241, 'TIGR02269', NULL, 'TIGR02269: Myxococcus xanthus paralogous lipoprotein family TIGR02269', 209, NULL, 'TIGR02269', 286916),
(481242, 'TIGR01435', NULL, 'glu_cys_lig_rel: glutamate--cysteine ligase/glutathione synthase', 719, NULL, 'TIGR01435', 286917),
(481243, 'TIGR04532', NULL, 'PT_fungal_PKS: polyketide product template domain', 329, NULL, 'TIGR04532', 286918),
(481244, 'TIGR00679', NULL, 'hpr-ser: HPr(Ser) kinase/phosphatase', 300, NULL, 'TIGR00679', 286919),
(481245, 'TIGR02182', NULL, 'GRXB: glutaredoxin, GrxB family', 209, NULL, 'TIGR02182', 286920),
(481246, 'TIGR02562', NULL, 'cas3_yersinia: CRISPR-associated helicase Cas3, subtype I-F/YPEST', 1110, NULL, 'TIGR02562', 286921);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(481247, 'TIGR00542', NULL, 'hxl6Piso_put: putative hexulose-6-phosphate isomerase', 279, NULL, 'TIGR00542', 286922),
(481248, 'TIGR02864', NULL, 'spore_sspO: small, acid-soluble spore protein O', 50, NULL, 'TIGR02864', 286923),
(481249, 'TIGR04152', NULL, 'exosort_VPLPA: exosortase D, VPLPA-CTERM-specific', 486, NULL, 'TIGR04152', 286924),
(481250, 'TIGR04289', NULL, 'heavy_Cys: eight-cysteine-cluster domain', 52, NULL, 'TIGR04289', 286925),
(481251, 'TIGR01329', NULL, 'cysta_beta_ly_E: cystathionine beta-lyase', 383, NULL, 'TIGR01329', 286926),
(481252, 'TIGR00162', NULL, 'TIGR00162: TIGR00162 family protein', 260, NULL, 'TIGR00162', 286927),
(481253, 'TIGR00299', NULL, 'TIGR00299: TIGR00299 family protein', 382, NULL, 'TIGR00299', 286928),
(481254, 'TIGR03455', NULL, 'HisG_C-term: ATP phosphoribosyltransferase, C-terminal domain', 100, NULL, 'TIGR03455', 286929),
(481255, 'TIGR03835', NULL, 'termin_org_DnaJ: terminal organelle assembly protein TopJ', 871, NULL, 'TIGR03835', 286930),
(481256, 'TIGR01591', NULL, 'Fdh-alpha: formate dehydrogenase, alpha subunit', 672, NULL, 'TIGR01591', 286931),
(481257, 'TIGR03698', NULL, 'clan_AA_DTGF: clan AA aspartic protease, AF_0612 family', 107, NULL, 'TIGR03698', 286932),
(481258, 'TIGR00358', NULL, '3_prime_RNase: VacB and RNase II family 3''-5'' exoribonucleases', 657, NULL, 'TIGR00358', 286933),
(481259, 'TIGR01133', NULL, 'murG: undecaprenyldiphospho-muramoylpentapeptide beta-N-acetylglucosaminyltransferase', 353, NULL, 'TIGR01133', 286934),
(481260, 'TIGR03514', NULL, 'GldB_lipo: gliding motility-associated lipoprotein GldB', 322, NULL, 'TIGR03514', 286935),
(481261, 'TIGR00417', NULL, 'speE: spermidine synthase', 271, NULL, 'TIGR00417', 286936),
(481262, 'TIGR01971', NULL, 'NuoI: NADH-quinone oxidoreductase, chain I', 121, NULL, 'TIGR01971', 286937),
(481263, 'TIGR00738', NULL, 'rrf2_super: Rrf2 family protein', 132, NULL, 'TIGR00738', 286938),
(481264, 'TIGR01890', NULL, 'N-Ac-Glu-synth: amino-acid N-acetyltransferase', 429, NULL, 'TIGR01890', 286939),
(481265, 'TIGR03776', NULL, 'RPE5: rickettsial palindromic element RPE5 domain', 43, NULL, 'TIGR03776', 286940),
(481266, 'TIGR03860', NULL, 'FMN_nitrolo: FMN-dependent oxidoreductase, nitrilotriacetate monooxygenase family', 422, NULL, 'TIGR03860', 286941),
(481267, 'TIGR00975', NULL, '3a0107s03: phosphate ABC transporter, phosphate-binding protein PstS', 315, NULL, 'TIGR00975', 286942),
(481268, 'TIGR03997', NULL, 'mycofact_OYE_2: mycofactocin system FadH/OYE family oxidoreductase 2', 645, NULL, 'TIGR03997', 286943),
(481269, 'TIGR03536', NULL, 'DapD_gpp: 2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-succinyltransferase', 341, NULL, 'TIGR03536', 286944),
(481270, 'TIGR03620', NULL, 'F420_MSMEG_4141: probable F420-dependent oxidoreductase, MSMEG_4141 family', 280, NULL, 'TIGR03620', 286945),
(481271, 'TIGR00735', NULL, 'hisF: imidazoleglycerol phosphate synthase, cyclase subunit', 254, NULL, 'TIGR00735', 286946),
(481272, 'TIGR01603', NULL, 'maj_tail_phi13: phage major tail protein, phi13 family', 190, NULL, 'TIGR01603', 286947),
(481273, 'TIGR02481', NULL, 'hemeryth_dom: hemerythrin-like metal-binding domain', 126, NULL, 'TIGR02481', 286948),
(481274, 'TIGR03757', NULL, 'conj_TIGR03757: integrating conjugative element protein, PFL_4709 family', 113, NULL, 'TIGR03757', 286949),
(481275, 'TIGR02185', NULL, 'Trep_Strep: putative ECF transporter S component, Trep_Strep family', 188, NULL, 'TIGR02185', 286950),
(481276, 'TIGR02945', NULL, 'SUF_assoc: FeS assembly SUF system protein', 99, NULL, 'TIGR02945', 286951),
(481277, 'TIGR00909', NULL, '2A0306: amino acid transporter', 429, NULL, 'TIGR00909', 286952),
(481278, 'TIGR04367', NULL, 'HpnR_B12_rSAM: hopanoid C-3 methylase HpnR', 490, NULL, 'TIGR04367', 286953),
(481279, 'TIGR04211', NULL, 'SH3_and_anchor: SH3 domain protein', 198, NULL, 'TIGR04211', 286954),
(481280, 'TIGR01566', NULL, 'ZF_HD_prot_N: ZF-HD homeobox protein Cys/His-rich dimerization domain', 53, NULL, 'TIGR01566', 286955),
(481281, 'TIGR00187', NULL, 'ribE: riboflavin synthase, alpha subunit', 207, NULL, 'TIGR00187', 286956);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(481282, 'TIGR02260', NULL, 'benz_CoA_red_B: benzoyl-CoA reductase, subunit B', 413, NULL, 'TIGR02260', 286957),
(481283, 'TIGR01354', NULL, 'cyt_deam_tetra: cytidine deaminase', 126, NULL, 'TIGR01354', 286958),
(481284, 'TIGR01862', NULL, 'N2-ase-Ialpha: nitrogenase component I, alpha chain', 444, NULL, 'TIGR01862', 286959),
(481285, 'TIGR00439', NULL, 'ftsX: putative protein insertion permease FtsX', 310, NULL, 'TIGR00439', 286960),
(481286, 'TIGR01999', NULL, 'iscU: FeS cluster assembly scaffold IscU', 124, NULL, 'TIGR01999', 286961),
(481287, 'TIGR03287', NULL, 'methan_mark_16: putative methanogenesis marker 16 metalloprotein', 391, NULL, 'TIGR03287', 286962),
(481288, 'TIGR01180', NULL, 'aman2_put: putative alpha-1,2-mannosidase', 749, NULL, 'TIGR01180', 286963),
(481289, 'TIGR02020', NULL, 'BchF: 2-vinyl bacteriochlorophyllide hydratase', 145, NULL, 'TIGR02020', 286964),
(481290, 'TIGR02397', NULL, 'dnaX_nterm: DNA polymerase III, subunit gamma and tau', 355, NULL, 'TIGR02397', 286965),
(481291, 'TIGR02705', NULL, 'nudix_YtkD: nucleoside triphosphatase YtkD', 156, NULL, 'TIGR02705', 286966),
(481292, 'TIGR00523', NULL, 'eIF-1A: translation initiation factor eIF-1A', 98, NULL, 'TIGR00523', 286967),
(481293, 'TIGR02453', NULL, 'TIGR02453: TIGR02453 family protein', 218, NULL, 'TIGR02453', 286968),
(481294, 'TIGR04451', NULL, 'lanti_SCO0268: lantipeptide, SCO0268 family', 53, NULL, 'TIGR04451', 286969),
(481295, 'TIGR00520', NULL, 'asnASE_II: L-asparaginase, type II', 352, NULL, 'TIGR00520', 286970),
(481296, 'TIGR04127', NULL, 'flavo_near_exo: exosortase F-associated protein', 136, NULL, 'TIGR04127', 286971),
(481297, 'TIGR03028', NULL, 'EpsE: polysaccharide export protein EpsE', 239, NULL, 'TIGR03028', 286972),
(481298, 'TIGR00897', NULL, '2A0118: polyol permease', 402, NULL, 'TIGR00897', 286973),
(481299, 'TIGR00760', NULL, 'araD: L-ribulose-5-phosphate 4-epimerase', 228, NULL, 'TIGR00760', 286974),
(481300, 'TIGR01058', NULL, 'parE_Gpos: DNA topoisomerase IV, B subunit', 637, NULL, 'TIGR01058', 286975),
(481301, 'TIGR01248', NULL, 'drrC: daunorubicin resistance protein C', 152, NULL, 'TIGR01248', 286976),
(481302, 'TIGR00053', NULL, 'TIGR00053: addiction module toxin component, YafQ family', 92, NULL, 'TIGR00053', 286977),
(481303, 'TIGR01111', NULL, 'mtrA: tetrahydromethanopterin S-methyltransferase, subunit A', 238, NULL, 'TIGR01111', 286978),
(481304, 'TIGR02973', NULL, 'nitrate_rd_NapE: periplasmic nitrate reductase, NapE protein', 42, NULL, 'TIGR02973', 286979),
(481305, 'TIGR01351', NULL, 'adk: adenylate kinase', 212, NULL, 'TIGR01351', 286980),
(481306, 'TIGR01818', NULL, 'ntrC: nitrogen regulation protein NR(I)', 463, NULL, 'TIGR01818', 286981),
(481307, 'TIGR02730', NULL, 'carot_isom: carotene isomerase', 493, NULL, 'TIGR02730', 286982),
(481308, 'TIGR00467', NULL, 'lysS_arch: lysine--tRNA ligase', 515, NULL, 'TIGR00467', 286983),
(481309, 'TIGR00657', NULL, 'asp_kinases: aspartate kinase', 442, NULL, 'TIGR00657', 286984),
(481310, 'TIGR03458', NULL, 'YgfH_subfam: succinate CoA transferase', 489, NULL, 'TIGR03458', 286985),
(481311, 'TIGR02696', NULL, 'pppGpp_PNP: guanosine pentaphosphate synthetase I/polyribonucleotide nucleotidyltransferase', 720, NULL, 'TIGR02696', 286986),
(481312, 'TIGR00290', NULL, 'MJ0570_dom: MJ0570-related uncharacterized domain', 223, NULL, 'TIGR00290', 286987),
(481313, 'TIGR02023', NULL, 'BchP-ChlP: geranylgeranyl reductase', 388, NULL, 'TIGR02023', 286988),
(481314, 'TIGR03754', NULL, 'conj_TOL_TraD: conjugative coupling factor TraD, PFGI-1 class', 643, NULL, 'TIGR03754', 286989),
(481315, 'TIGR03564', NULL, 'F420_MSMEG_4879: F420-dependent oxidoreductase, MSMEG_4879 family', 265, NULL, 'TIGR03564', 286990),
(481316, 'TIGR00224', NULL, 'pckA: phosphoenolpyruvate carboxykinase (ATP)', 532, NULL, 'TIGR00224', 286991),
(481317, 'TIGR03072', NULL, 'release_prfH: putative peptide chain release factor H', 200, NULL, 'TIGR03072', 286992),
(481318, 'TIGR03832', NULL, 'Tyr_2_3_mutase: tyrosine 2,3-aminomutase', 507, NULL, 'TIGR03832', 286993),
(481319, 'TIGR03150', NULL, 'fabF: beta-ketoacyl-acyl-carrier-protein synthase II', 407, NULL, 'TIGR03150', 286994);
INSERT INTO "PUBLIC"."MODEL" VALUES
(481320, 'TIGR03779', NULL, 'Bac_Flav_CT_M: Bacteroides conjugative transposon TraM protein', 410, NULL, 'TIGR03779', 286995),
(481321, 'TIGR03969', NULL, 'mycofactocin: mycofactocin precursor', 23, NULL, 'TIGR03969', 286996),
(481322, 'TIGR01594', NULL, 'holin_lambda: phage holin, lambda family', 107, NULL, 'TIGR01594', 286997),
(481323, 'TIGR03642', NULL, 'cas_csx14: CRISPR-associated protein, Csx14 family', 124, NULL, 'TIGR03642', 286998),
(481324, 'TIGR00302', NULL, 'TIGR00302: phosphoribosylformylglycinamidine synthase, purS protein', 80, NULL, 'TIGR00302', 286999),
(481325, 'TIGR01784', NULL, 'T_den_put_tspse: conserved hypothetical protein', 273, NULL, 'TIGR01784', 287000),
(481326, 'TIGR01569', NULL, 'A_tha_TIGR01569: plant integral membrane protein TIGR01569', 154, NULL, 'TIGR01569', 287001),
(481327, 'TIGR02291', NULL, 'rimK_rel_E_lig: alpha-L-glutamate ligase homolog', 317, NULL, 'TIGR02291', 287002),
(481328, 'TIGR04345', NULL, 'ovoA_Cterm: putative 4-mercaptohistidine N1-methyltranferase', 242, NULL, 'TIGR04345', 287003),
(481329, 'TIGR04233', NULL, 'seadorna_VP8: seadornavirus VP8 protein', 291, NULL, 'TIGR04233', 287004),
(481330, 'TIGR04423', NULL, 'casT3_TIGR04423: CRISPR type III-associated protein, TIGR04423 family', 124, NULL, 'TIGR04423', 287005),
(481331, 'TIGR02867', NULL, 'spore_II_P: stage II sporulation protein P', 196, NULL, 'TIGR02867', 287006),
(481332, 'TIGR02409', NULL, 'carnitine_bodg: gamma-butyrobetaine hydroxylase', 366, NULL, 'TIGR02409', 287007),
(481333, 'TIGR04155', NULL, 'cyano_PEP: PEP-CTERM protein sorting domain, cyanobacterial subclass', 27, NULL, 'TIGR04155', 287008),
(481334, 'TIGR03321', NULL, 'alt_F1F0_F0_B: alternate F1F0 ATPase, F0 subunit B', 246, NULL, 'TIGR03321', 287009),
(481335, 'TIGR01902', NULL, 'dapE-lys-deAc: N-acetyl-ornithine/N-acetyl-lysine deacetylase', 340, NULL, 'TIGR01902', 287010),
(481336, 'TIGR01326', NULL, 'OAH_OAS_sulfhy: O-acetylhomoserine aminocarboxypropyltransferase/cysteine synthase', 418, NULL, 'TIGR01326', 287011),
(481337, 'TIGR01460', NULL, 'HAD-SF-IIA: HAD hydrolase, family IIA', 246, NULL, 'TIGR01460', 287012),
(481338, 'TIGR04021', NULL, 'LLM_DMSO2_sfnG: dimethyl sulfone monooxygenase SfnG', 350, NULL, 'TIGR04021', 287013),
(481339, 'TIGR01136', NULL, 'cysKM: cysteine synthase', 299, NULL, 'TIGR01136', 287014),
(481340, 'TIGR01597', NULL, 'PYST-B: Plasmodium yoelii subtelomeric family PYST-B', 256, NULL, 'TIGR01597', 287015),
(481341, 'TIGR04158', NULL, 'rSAM_MIA_synth: 3-methyl-2-indolic acid synthase', 368, NULL, 'TIGR04158', 287016),
(481342, 'TIGR02948', NULL, 'SigW_bacill: RNA polymerase sigma-W factor', 187, NULL, 'TIGR02948', 287017),
(481343, 'TIGR00118', NULL, 'acolac_lg: acetolactate synthase, large subunit, biosynthetic type', 557, NULL, 'TIGR00118', 287018),
(481344, 'TIGR03430', NULL, 'trp_dimet_allyl: tryptophan dimethylallyltransferase', 419, NULL, 'TIGR03430', 287019),
(481345, 'TIGR00978', NULL, 'asd_EA: aspartate-semialdehyde dehydrogenase', 342, NULL, 'TIGR00978', 287020),
(481346, 'TIGR00184', NULL, 'purA: adenylosuccinate synthase', 425, NULL, 'TIGR00184', 287021),
(481347, 'TIGR00305', NULL, 'TIGR00305: putative toxin-antitoxin system toxin component, PIN family', 115, NULL, 'TIGR00305', 287022),
(481348, 'TIGR02051', NULL, 'MerR: Hg(II)-responsive transcriptional regulator', 124, NULL, 'TIGR02051', 287023),
(481349, 'TIGR04557', NULL, 'fuse_rel_SoxYZ: quinoprotein dehydrogenase-associated SoxYZ-like carrier', 226, NULL, 'TIGR04557', 287024),
(481350, 'TIGR03402', NULL, 'FeS_nifS: cysteine desulfurase NifS', 379, NULL, 'TIGR03402', 287025),
(481351, 'TIGR02976', NULL, 'phageshock_pspB: phage shock protein B', 75, NULL, 'TIGR02976', 287026),
(481352, 'TIGR00732', NULL, 'dprA: DNA protecting protein DprA', 220, NULL, 'TIGR00732', 287027),
(481353, 'TIGR01432', NULL, 'QOXA: cytochrome aa3 quinol oxidase, subunit II', 227, NULL, 'TIGR01432', 287028),
(481354, 'TIGR02587', NULL, 'TIGR02587: putative integral membrane protein TIGR02587', 271, NULL, 'TIGR02587', 287029),
(481355, 'TIGR03994', NULL, 'rSAM_HemZ: coproporphyrinogen dehydrogenase HemZ', 401, NULL, 'TIGR03994', 287030);
INSERT INTO "PUBLIC"."MODEL" VALUES
(481356, 'TIGR01672', NULL, 'AphA: HAD phosphatase, family IIIB', 237, NULL, 'TIGR01672', 287031),
(481357, 'TIGR02450', NULL, 'TIGR02450: tryptophan-rich conserved hypothetical protein', 61, NULL, 'TIGR02450', 287032),
(481358, 'TIGR00654', NULL, 'PhzF_family: phenazine biosynthesis protein, PhzF family', 298, NULL, 'TIGR00654', 287033),
(481359, 'TIGR02702', NULL, 'SufR_cyano: iron-sulfur cluster biosynthesis transcriptional regulator SufR', 208, NULL, 'TIGR02702', 287034),
(481360, 'TIGR04049', NULL, 'AIR_rel_sll0787: AIR synthase-related protein, sll0787 family', 318, NULL, 'TIGR04049', 287035),
(481361, 'TIGR03215', NULL, 'ac_ald_DH_ac: acetaldehyde dehydrogenase (acetylating)', 285, NULL, 'TIGR03215', 287036),
(481362, 'TIGR02839', NULL, 'spore_V_AE: stage V sporulation protein AE', 114, NULL, 'TIGR02839', 287037),
(481363, 'TIGR00841', NULL, 'bass: bile acid transporter', 321, NULL, 'TIGR00841', 287038),
(481364, 'TIGR00081', NULL, 'purC: phosphoribosylaminoimidazolesuccinocarboxamide synthase', 279, NULL, 'TIGR00081', 287039),
(481365, 'TIGR02263', NULL, 'benz_CoA_red_C: benzoyl-CoA reductase, subunit C', 380, NULL, 'TIGR02263', 287040),
(481366, 'TIGR03041', NULL, 'PS_antenn_a_b: chlorophyll a/b binding light-harvesting protein', 321, NULL, 'TIGR03041', 287041),
(481367, 'TIGR01996', NULL, 'PTS-II-BC-sucr: PTS system, sucrose-specific IIBC component', 461, NULL, 'TIGR01996', 287042),
(481368, 'TIGR03539', NULL, 'DapC_actino: succinyldiaminopimelate transaminase', 357, NULL, 'TIGR03539', 287043),
(481369, 'TIGR02188', NULL, 'Ac_CoA_lig_AcsA: acetate--CoA ligase', 629, NULL, 'TIGR02188', 287044),
(481370, 'TIGR03097', NULL, 'PEP_O_lig_1: probable O-glycosylation ligase, exosortase A-associated', 408, NULL, 'TIGR03097', 287045),
(481371, 'TIGR03218', NULL, 'catechol_dmpH: 4-oxalocrotonate decarboxylase', 263, NULL, 'TIGR03218', 287046),
(481372, 'TIGR01606', NULL, 'holin_BlyA: holin, BlyA family', 63, NULL, 'TIGR01606', 287047),
(481373, 'TIGR04236', NULL, 'seadorna_VP2: seadornavirus VP2 protein', 953, NULL, 'TIGR04236', 287048),
(481374, 'TIGR03284', NULL, 'thym_sym: thymidylate synthase', 296, NULL, 'TIGR03284', 287049),
(481375, 'TIGR03888', NULL, 'nitrile_beta: nitrile hydratase, beta subunit', 226, NULL, 'TIGR03888', 287050),
(481376, 'TIGR02693', NULL, 'arsenite_ox_L: arsenite oxidase, large subunit', 806, NULL, 'TIGR02693', 287051),
(481377, 'TIGR01488', NULL, 'HAD-SF-IB: HAD phosphoserine phosphatase-like hydrolase, family IB', 177, NULL, 'TIGR01488', 287052),
(481378, 'TIGR03751', NULL, 'conj_TIGR03751: conjugative transfer region lipoprotein, TIGR03751 family', 124, NULL, 'TIGR03751', 287053),
(481379, 'TIGR00293', NULL, 'TIGR00293: prefoldin, alpha subunit', 129, NULL, 'TIGR00293', 287054),
(481380, 'TIGR00333', NULL, 'nrdI: nrdI protein', 127, NULL, 'TIGR00333', 287055),
(481381, 'TIGR02627', NULL, 'rhamnulo_kin: rhamnulokinase', 454, NULL, 'TIGR02627', 287056),
(481382, 'TIGR00763', NULL, 'lon: endopeptidase La', 795, NULL, 'TIGR00763', 287057),
(481383, 'TIGR04342', NULL, 'EXLDI: EXLDI protein', 124, NULL, 'TIGR04342', 287058),
(481384, 'TIGR01245', NULL, 'trpD: anthranilate phosphoribosyltransferase', 330, NULL, 'TIGR01245', 287059),
(481385, 'TIGR02079', NULL, 'THD1: threonine dehydratase', 410, NULL, 'TIGR02079', 287060),
(481386, 'TIGR03390', NULL, 'ascorbOXfungal: L-ascorbate oxidase', 538, NULL, 'TIGR03390', 287061),
(481387, 'TIGR00869', NULL, 'sec62: protein translocation protein, Sec62 family', 232, NULL, 'TIGR00869', 287062),
(481388, 'TIGR02372', NULL, '4_coum_CoA_lig: 4-coumarate--CoA ligase', 386, NULL, 'TIGR02372', 287063),
(481389, 'TIGR00050', NULL, 'rRNA_methyl_1: RNA methyltransferase, TrmH family, group 1', 233, NULL, 'TIGR00050', 287064),
(481390, 'TIGR02294', NULL, 'nickel_nikA: nickel ABC transporter, nickel/metallophore periplasmic binding protein', 501, NULL, 'TIGR02294', 287065),
(481391, 'TIGR01002', NULL, 'hlyII: beta-channel forming cytolysin', 313, NULL, 'TIGR01002', 287066),
(481392, 'TIGR03324', NULL, 'alt_F1F0_F1_al: alternate F1F0 ATPase, F1 subunit alpha', 497, NULL, 'TIGR03324', 287067);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(481393, 'TIGR01139', NULL, 'cysK: cysteine synthase A', 298, NULL, 'TIGR01139', 287068),
(481394, 'TIGR04420', NULL, 'Sec_Non_Glob: Sec region non-globular protein', 243, NULL, 'TIGR04420', 287069),
(481395, 'TIGR02157', NULL, 'PA_CoA_Oxy2: phenylacetate-CoA oxygenase, PaaH subunit', 90, NULL, 'TIGR02157', 287070),
(481396, 'TIGR01323', NULL, 'nitrile_alph: nitrile hydratase, alpha subunit', 189, NULL, 'TIGR01323', 287071),
(481397, 'TIGR01781', NULL, 'Trep_dent_lipo: Treponema denticola clustered lipoprotein', 412, NULL, 'TIGR01781', 287072),
(481398, 'TIGR03567', NULL, 'FMN_reduc_SsuE: FMN reductase', 171, NULL, 'TIGR03567', 287073),
(481399, 'TIGR02733', NULL, 'desat_CrtD: C-3'',4'' desaturase CrtD', 492, NULL, 'TIGR02733', 287074),
(481400, 'TIGR00227', NULL, 'ribD_Cterm: riboflavin-specific deaminase C-terminal domain', 216, NULL, 'TIGR00227', 287075),
(481401, 'TIGR03645', NULL, 'glyox_marine: lactoylglutathione lyase family protein', 162, NULL, 'TIGR03645', 287076),
(481402, 'TIGR02811', NULL, 'formate_TAT: formate dehydrogenase region TAT target', 66, NULL, 'TIGR02811', 287077),
(481403, 'TIGR03966', NULL, 'actino_HemFlav: heme/flavin dehydrogenase, mycofactocin system', 385, NULL, 'TIGR03966', 287078),
(481404, 'TIGR04479', NULL, 'bcpD_PhpK_rSAM: radical SAM P-methyltransferase, PhpK family', 504, NULL, 'TIGR04479', 287079),
(481405, 'TIGR00548', NULL, 'lolB: outer membrane lipoprotein LolB', 202, NULL, 'TIGR00548', 287080),
(481406, 'TIGR00872', NULL, 'gnd_rel: 6-phosphogluconate dehydrogenase (decarboxylating)', 299, NULL, 'TIGR00872', 287081),
(481407, 'TIGR04314', NULL, 'methano7heme: methanogenesis multiheme c-type cytochrome', 494, NULL, 'TIGR04314', 287082),
(481408, 'TIGR00632', NULL, 'vsr: DNA mismatch endonuclease Vsr', 119, NULL, 'TIGR00632', 287083),
(481409, 'TIGR03916', NULL, 'rSAM_link_UDG: putative DNA modification/repair radical SAM protein', 415, NULL, 'TIGR03916', 287084),
(481410, 'TIGR00769', NULL, 'AAA: ADP/ATP carrier protein family', 472, NULL, 'TIGR00769', 287085),
(481411, 'TIGR00134', NULL, 'gatE_arch: glutamyl-tRNA(Gln) amidotransferase, subunit E', 622, NULL, 'TIGR00134', 287086),
(481412, 'TIGR01753', NULL, 'flav_short: flavodoxin', 140, NULL, 'TIGR01753', 287087),
(481413, 'TIGR03480', NULL, 'HpnN: hopanoid biosynthesis associated RND transporter like protein HpnN', 862, NULL, 'TIGR03480', 287088),
(481414, 'TIGR00529', NULL, 'AF0261: integral membrane protein, TIGR00529 family', 387, NULL, 'TIGR00529', 287089),
(481415, 'TIGR00374', NULL, 'TIGR00374: TIGR00374 family protein', 323, NULL, 'TIGR00374', 287090),
(481416, 'TIGR01513', NULL, 'NAPRTase_put: nicotinate phosphoribosyltransferase', 452, NULL, 'TIGR01513', 287091),
(481417, 'TIGR03137', NULL, 'AhpC: peroxiredoxin', 187, NULL, 'TIGR03137', 287092),
(481418, 'TIGR03240', NULL, 'arg_catab_astD: succinylglutamate-semialdehyde dehydrogenase', 484, NULL, 'TIGR03240', 287093),
(481419, 'TIGR03433', NULL, 'padR_acidobact: transcriptional regulator, Acidobacterial, PadR-family', 101, NULL, 'TIGR03433', 287094),
(481420, 'TIGR04498', NULL, 'AbiV_defense: abortive infection protein, AbiV family', 143, NULL, 'TIGR04498', 287095),
(481421, 'TIGR04121', NULL, 'DEXH_lig_assoc: DEXH box helicase, DNA ligase-associated', 804, NULL, 'TIGR04121', 287096),
(481422, 'TIGR01908', NULL, 'cas_CXXC_CXXC: CRISPR-associated protein Cas8b1/Cst1, subtype I-B/TNEAP', 308, NULL, 'TIGR01908', 287097),
(481423, 'TIGR01416', NULL, 'Rieske_proteo: ubiquinol-cytochrome c reductase, iron-sulfur subunit', 176, NULL, 'TIGR01416', 287098),
(481424, 'TIGR02640', NULL, 'gas_vesic_GvpN: gas vesicle protein GvpN', 262, NULL, 'TIGR02640', 287099),
(481425, 'TIGR02777', NULL, 'LigD_PE_dom: DNA ligase D, 3''-phosphoesterase domain', 156, NULL, 'TIGR02777', 287100),
(481426, 'TIGR04516', NULL, 'glycosyl_450act: glycosyltransferase, activator-dependent family', 418, NULL, 'TIGR04516', 287101),
(481427, 'TIGR02054', NULL, 'MerD: mercuric resistence transcriptional repressor protein MerD', 120, NULL, 'TIGR02054', 287102),
(481428, 'TIGR02400', NULL, 'trehalose_OtsA: alpha,alpha-trehalose-phosphate synthase (UDP-forming)', 456, NULL, 'TIGR02400', 287103);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(481429, 'TIGR02306', NULL, 'RNA_lig_DRB0094: RNA ligase', 341, NULL, 'TIGR02306', 287104),
(481430, 'TIGR04264', NULL, 'hyperosmo_Ebh: hyperosmolarity resistance protein Ebh', 2354, NULL, 'TIGR04264', 287105),
(481431, 'TIGR01158', NULL, 'SUI1_rel: putative translation initiation factor SUI1', 102, NULL, 'TIGR01158', 287106),
(481432, 'TIGR00078', NULL, 'nadC: nicotinate-nucleotide diphosphorylase (carboxylating)', 269, NULL, 'TIGR00078', 287107),
(481433, 'TIGR04320', NULL, 'Surf_Exclu_PgrA: SEC10/PgrA surface exclusion domain', 360, NULL, 'TIGR04320', 287108),
(481434, 'TIGR04258', NULL, '4helix_suffix: four helix bundle suffix domain', 49, NULL, 'TIGR04258', 287109),
(481435, 'TIGR02584', NULL, 'cas_NE0113: CRISPR-associated protein, NE0113 family', 209, NULL, 'TIGR02584', 287110),
(481436, 'TIGR00140', NULL, 'hupD: hydrogenase expression/formation protein', 151, NULL, 'TIGR00140', 287111),
(481437, 'TIGR00576', NULL, 'dut: dUTP diphosphatase', 143, NULL, 'TIGR00576', 287112),
(481438, 'TIGR01560', NULL, 'put_DNA_pack: uncharacterized phage protein (possible DNA packaging)', 91, NULL, 'TIGR01560', 287113),
(481439, 'TIGR02836', NULL, 'spore_IV_A: stage IV sporulation protein A', 492, NULL, 'TIGR02836', 287114),
(481440, 'TIGR00190', NULL, 'thiC: phosphomethylpyrimidine synthase', 423, NULL, 'TIGR00190', 287115),
(481441, 'TIGR04062', NULL, 'dnd_assoc_4: dnd system-associated protein 4', 151, NULL, 'TIGR04062', 287116),
(481442, 'TIGR00087', NULL, 'surE: 5''/3''-nucleotidase SurE', 252, NULL, 'TIGR00087', 287117),
(481443, 'TIGR00433', NULL, 'bioB: biotin synthase', 296, NULL, 'TIGR00433', 287118),
(481444, 'TIGR03922', NULL, 'T7SS_EccA: type VII secretion AAA-ATPase EccA', 557, NULL, 'TIGR03922', 287119),
(481445, 'TIGR01071', NULL, 'rplO_bact: ribosomal protein uL15', 144, NULL, 'TIGR01071', 287120),
(481446, 'TIGR01609', NULL, 'PF_unchar_267: Plasmodium falciparum uncharacterized protein TIGR01609', 146, NULL, 'TIGR01609', 287121),
(481447, 'TIGR02783', NULL, 'TrbL_P: P-type conjugative transfer protein TrbL', 298, NULL, 'TIGR02783', 287122),
(481448, 'TIGR04267', NULL, 'mod_HExxH: HEXXH motif domain', 399, NULL, 'TIGR04267', 287123),
(481449, 'TIGR04457', NULL, 'lipo_LenA_lepto: lipoprotein LenA', 224, NULL, 'TIGR04457', 287124),
(481450, 'TIGR02593', NULL, 'CRISPR_cas5: CRISPR-associated protein Cas5', 43, NULL, 'TIGR02593', 287125),
(481451, 'TIGR01261', NULL, 'hisB_Nterm: histidinol-phosphatase', 161, NULL, 'TIGR01261', 287126),
(481452, 'TIGR04560', NULL, 'ribo_THX: ribosomal small subunit protein bTHX', 26, NULL, 'TIGR04560', 287127),
(481453, 'TIGR03281', NULL, 'methan_mark_12: putative methanogenesis marker protein 12', 326, NULL, 'TIGR03281', 287128),
(481454, 'TIGR02303', NULL, 'HpaG-C-term: 4-hydroxyphenylacetate degradation bifunctional isomerase/decarboxylase, C-terminal subunit', 245, NULL, 'TIGR02303', 287129),
(481455, 'TIGR00277', NULL, 'HDIG: HDIG domain', 84, NULL, 'TIGR00277', 287130),
(481456, 'TIGR02113', NULL, 'coaC_strep: phosphopantothenoylcysteine decarboxylase', 177, NULL, 'TIGR02113', 287131),
(481457, 'TIGR03078', NULL, 'CH4_NH3mon_ox_C: methane monooxygenase/ammonia monooxygenase, subunit C', 231, NULL, 'TIGR03078', 287132),
(481458, 'TIGR00380', NULL, 'cobD: cobalamin biosynthesis protein CobD', 305, NULL, 'TIGR00380', 287133),
(481459, 'TIGR02736', NULL, 'cbb3_Q_epsi: cytochrome c oxidase, cbb3-type, CcoQ subunit', 56, NULL, 'TIGR02736', 287134),
(481460, 'TIGR01320', NULL, 'mal_quin_oxido: malate dehydrogenase (acceptor)', 482, NULL, 'TIGR01320', 287135),
(481461, 'TIGR02095', NULL, 'glgA: glycogen/starch synthase, ADP-glucose type', 477, NULL, 'TIGR02095', 287136),
(481462, 'TIGR02285', NULL, 'TIGR02285: conserved hypothetical protein', 268, NULL, 'TIGR02285', 287137),
(481463, 'TIGR01457', NULL, 'HAD-SF-IIA-hyp2: HAD hydrolase, TIGR01457 family', 249, NULL, 'TIGR01457', 287138),
(481464, 'TIGR04018', NULL, 'Bthiol_YpdA: putative bacillithiol system oxidoreductase, YpdA family', 316, NULL, 'TIGR04018', 287139),
(481465, 'TIGR01949', NULL, 'AroFGH_arch: predicted phospho-2-dehydro-3-deoxyheptonate aldolase', 255, NULL, 'TIGR01949', 287140);
INSERT INTO "PUBLIC"."MODEL" VALUES
(481466, 'TIGR02107', NULL, 'PQQ_syn_pqqA: coenzyme PQQ precursor peptide PqqA', 21, NULL, 'TIGR02107', 287141),
(481467, 'TIGR01955', NULL, 'RfaH: transcription elongation factor/antiterminator RfaH', 159, NULL, 'TIGR01955', 287142),
(481468, 'TIGR03000', NULL, 'plancto_dom_1: Planctomycetes uncharacterized domain TIGR03000', 75, NULL, 'TIGR03000', 287143),
(481469, 'TIGR03629', NULL, 'uS13_arch: ribosomal protein uS13', 144, NULL, 'TIGR03629', 287144),
(481470, 'TIGR03819', NULL, 'heli_sec_ATPase: helicase/secretion neighborhood ATPase', 340, NULL, 'TIGR03819', 287145),
(481471, 'TIGR02101', NULL, 'IpaC_SipC: type III secretion target, IpaC/SipC family', 314, NULL, 'TIGR02101', 287146),
(481472, 'TIGR01398', NULL, 'FlhA: flagellar biosynthesis protein FlhA', 678, NULL, 'TIGR01398', 287147),
(481473, 'TIGR03963', NULL, 'rSAM_QueE_Clost: putative 7-cyano-7-deazaguanosine (preQ0) biosynthesis protein QueE', 219, NULL, 'TIGR03963', 287148),
(481474, 'TIGR00623', NULL, 'sula: cell division inhibitor SulA', 168, NULL, 'TIGR00623', 287149),
(481475, 'TIGR01896', NULL, 'cas_AF1879: CRISPR-associated protein Cas4/Csa1, subtype I-A/APERN', 273, NULL, 'TIGR01896', 287150),
(481476, 'TIGR00931', NULL, 'antiport_nhaC: Na+/H+ antiporter NhaC', 454, NULL, 'TIGR00931', 287151),
(481477, 'TIGR02605', NULL, 'CxxC_CxxC_SSSS: putative regulatory protein, FmdB family', 52, NULL, 'TIGR02605', 287152),
(481478, 'TIGR02880', NULL, 'cbbX_cfxQ: CbbX protein', 284, NULL, 'TIGR02880', 287153),
(481479, 'TIGR03726', NULL, 'strep_RK_lipo: putative cross-wall-targeting lipoprotein signal', 34, NULL, 'TIGR03726', 287154),
(481480, 'TIGR03290', NULL, 'CoB_CoM_SS_C: CoB--CoM heterodisulfide reductase, subunit C', 144, NULL, 'TIGR03290', 287155),
(481481, 'TIGR04504', NULL, 'SDR_subfam_2: SDR family mycofactocin-dependent oxidoreductase', 260, NULL, 'TIGR04504', 287156),
(481482, 'TIGR01220', NULL, 'Pmev_kin_Gr_pos: phosphomevalonate kinase', 358, NULL, 'TIGR01220', 287157),
(481483, 'TIGR02789', NULL, 'nickel_nikB: nickel ABC transporter, permease subunit NikB', 314, NULL, 'TIGR02789', 287158),
(481484, 'TIGR00202', NULL, 'csrA: carbon storage regulator', 69, NULL, 'TIGR00202', 287159),
(481485, 'TIGR03670', NULL, 'rpoB_arch: DNA-directed RNA polymerase subunit B', 599, NULL, 'TIGR03670', 287160),
(481486, 'TIGR01357', NULL, 'aroB: 3-dehydroquinate synthase', 344, NULL, 'TIGR01357', 287161),
(481487, 'TIGR02652', NULL, 'TIGR02652: TIGR02652 family protein', 162, NULL, 'TIGR02652', 287162),
(481488, 'TIGR01117', NULL, 'mmdA: methylmalonyl-CoA decarboxylase alpha subunit', 512, NULL, 'TIGR01117', 287163),
(481489, 'TIGR02892', NULL, 'spore_yabP: sporulation protein YabP', 85, NULL, 'TIGR02892', 287164),
(481490, 'TIGR00339', NULL, 'sopT: sulfate adenylyltransferase', 383, NULL, 'TIGR00339', 287165),
(481491, 'TIGR03533', NULL, 'L3_gln_methyl: protein-(glutamine-N5) methyltransferase, ribosomal protein L3-specific', 284, NULL, 'TIGR03533', 287166),
(481492, 'TIGR02238', NULL, 'recomb_DMC1: meiotic recombinase Dmc1', 314, NULL, 'TIGR02238', 287167),
(481493, 'TIGR00719', NULL, 'sda_beta: L-serine dehydratase, iron-sulfur-dependent, beta subunit', 208, NULL, 'TIGR00719', 287168),
(481494, 'TIGR02727', NULL, 'MTHFS_bact: 5-formyltetrahydrofolate cyclo-ligase', 182, NULL, 'TIGR02727', 287169),
(481495, 'TIGR03623', NULL, 'TIGR03623: probable DNA repair protein', 876, NULL, 'TIGR03623', 287170),
(481496, 'TIGR02154', NULL, 'PhoB: phosphate regulon transcriptional regulatory protein PhoB', 226, NULL, 'TIGR02154', 287171),
(481497, 'TIGR02845', NULL, 'spore_V_AD: stage V sporulation protein AD', 327, NULL, 'TIGR02845', 287172),
(481498, 'TIGR01718', NULL, 'Uridine-psphlse: uridine phosphorylase', 245, NULL, 'TIGR01718', 287173),
(481499, 'TIGR01466', NULL, 'cobJ_cbiH: precorrin-3B C17-methyltransferase', 239, NULL, 'TIGR01466', 287174),
(481500, 'TIGR04074', NULL, 'bacter_Hen1: 3'' terminal RNA ribose 2''-O-methyltransferase Hen1', 462, NULL, 'TIGR04074', 287175),
(481501, 'TIGR01027', NULL, 'proB: glutamate 5-kinase', 363, NULL, 'TIGR01027', 287176);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(481502, 'TIGR03365', NULL, 'Bsubt_queE: 7-cyano-7-deazaguanosine (preQ0) biosynthesis protein QueE', 238, NULL, 'TIGR03365', 287177),
(481503, 'TIGR02210', NULL, 'rodA_shape: rod shape-determining protein RodA', 357, NULL, 'TIGR02210', 287178),
(481504, 'TIGR03863', NULL, 'PQQ_ABC_bind: ABC transporter, substrate binding protein, PQQ-dependent alcohol dehydrogenase system', 347, NULL, 'TIGR03863', 287179),
(481505, 'TIGR01943', NULL, 'rnfA: electron transport complex, RnfABCDGE type, A subunit', 190, NULL, 'TIGR01943', 287180),
(481506, 'TIGR00972', NULL, '3a0107s01c2: phosphate ABC transporter, ATP-binding protein', 248, NULL, 'TIGR00972', 287181),
(481507, 'TIGR00828', NULL, 'EIID-AGA: PTS system, mannose/fructose/sorbose family, IID component', 271, NULL, 'TIGR00828', 287182),
(481508, 'TIGR03172', NULL, 'TIGR03172: putative selenium-dependent hydroxylase accessory protein YqeC', 232, NULL, 'TIGR03172', 287183),
(481509, 'TIGR01164', NULL, 'rplP_bact: ribosomal protein uL16', 126, NULL, 'TIGR01164', 287184),
(481510, 'TIGR02394', NULL, 'rpoS_proteo: RNA polymerase sigma factor RpoS', 285, NULL, 'TIGR02394', 287185),
(481511, 'TIGR00330', NULL, 'glpX: fructose-1,6-bisphosphatase, class II', 334, NULL, 'TIGR00330', 287186),
(481512, 'TIGR04199', NULL, 'exosort_xrtJ: exosortase J', 522, NULL, 'TIGR04199', 287187),
(481513, 'TIGR03424', NULL, 'urea_degr_1: urea carboxylase-associated protein 1', 198, NULL, 'TIGR03424', 287188),
(481514, 'TIGR03044', NULL, 'PS_II_psb27: photosystem II protein Psb27', 135, NULL, 'TIGR03044', 287189),
(481515, 'TIGR02406', NULL, 'ectoine_EctA: diaminobutyrate acetyltransferase', 157, NULL, 'TIGR02406', 287190),
(481516, 'TIGR00816', NULL, 'tdt: C4-dicarboxylate transporter/malic acid transport protein', 320, NULL, 'TIGR00816', 287191),
(481517, 'TIGR00483', NULL, 'EF-1_alpha: translation elongation factor EF-1, subunit alpha', 427, NULL, 'TIGR00483', 287192),
(481518, 'TIGR03972', NULL, 'rSAM_TYW1: wyosine biosynthesis protein TYW1', 297, NULL, 'TIGR03972', 287193),
(481519, 'TIGR00981', NULL, 'rpsL_bact: ribosomal protein uS12', 124, NULL, 'TIGR00981', 287194),
(481520, 'TIGR01348', NULL, 'PDHac_trf_long: dihydrolipoyllysine-residue acetyltransferase', 587, NULL, 'TIGR01348', 287195),
(481521, 'TIGR02904', NULL, 'spore_ysxE: spore coat protein YsxE', 309, NULL, 'TIGR02904', 287196),
(481522, 'TIGR00025', NULL, 'Mtu_efflux: ABC transporter efflux protein, DrrB family', 238, NULL, 'TIGR00025', 287197),
(481523, 'TIGR00863', NULL, 'P2X: cation transporter protein', 372, NULL, 'TIGR00863', 287198),
(481524, 'TIGR03474', NULL, 'incFII_RepA: incFII family plasmid replication initiator RepA', 275, NULL, 'TIGR03474', 287199),
(481525, 'TIGR03854', NULL, 'F420_MSMEG_3544: probable F420-dependent oxidoreductase, MSMEG_3544 family', 290, NULL, 'TIGR03854', 287200),
(481526, 'TIGR03181', NULL, 'PDH_E1_alph_x: pyruvate dehydrogenase (acetyl-transferring) E1 component, alpha subunit', 341, NULL, 'TIGR03181', 287201),
(481527, 'TIGR01525', NULL, 'ATPase-IB_hvy: heavy metal translocating P-type ATPase', 560, NULL, 'TIGR01525', 287202),
(481528, 'TIGR03679', NULL, 'arCOG00187: arCOG00187 universal archaeal metal-binding-domain/4Fe-4S-binding-domain containing ABC transporter, ATP-binding protein', 218, NULL, 'TIGR03679', 287203),
(481529, 'TIGR01697', NULL, 'PNPH-PUNA-XAPA: inosine/guanosine/xanthosine phosphorylase family', 247, NULL, 'TIGR01697', 287204),
(481530, 'TIGR01846', NULL, 'type_I_sec_HlyB: type I secretion system ATPase', 694, NULL, 'TIGR01846', 287205),
(481531, 'TIGR01990', NULL, 'bPGM: beta-phosphoglucomutase', 187, NULL, 'TIGR01990', 287206),
(481532, 'TIGR02045', NULL, 'P_fruct_ADP: ADP-specific phosphofructokinase', 446, NULL, 'TIGR02045', 287207),
(481533, 'TIGR02347', NULL, 'chap_CCT_zeta: T-complex protein 1, zeta subunit', 531, NULL, 'TIGR02347', 287208),
(481534, 'TIGR01709', NULL, 'typeII_sec_gspL: type II secretion system protein L', 389, NULL, 'TIGR01709', 287209),
(481535, 'TIGR04171', NULL, 'RNR_1b_NrdF: ribonucleoside-diphosphate reductase, class 1b, beta subunit', 316, NULL, 'TIGR04171', 287210);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(481536, 'TIGR01211', NULL, 'ELP3: radical SAM enzyme/protein acetyltransferase, ELP3 family', 522, NULL, 'TIGR01211', 287211),
(481537, 'TIGR02543', NULL, 'List_Bact_rpt: repeat, TIGR02543 family', 44, NULL, 'TIGR02543', 287212),
(481538, 'TIGR03377', NULL, 'glycerol3P_GlpA: glycerol-3-phosphate dehydrogenase, anaerobic, A subunit', 530, NULL, 'TIGR03377', 287213),
(481539, 'TIGR04027', NULL, 'LLM_KPN_01858: putative FMN-dependent luciferase-like monooxygenase, KPN_01858 family', 326, NULL, 'TIGR04027', 287214),
(481540, 'TIGR00037', NULL, 'eIF_5A: translation elongation factor IF5A', 130, NULL, 'TIGR00037', 287215),
(481541, 'TIGR04551', NULL, 'TIGR04551: TIGR04551 family protein', 519, NULL, 'TIGR04551', 287216),
(481542, 'TIGR00181', NULL, 'pepF: oligoendopeptidase F', 591, NULL, 'TIGR00181', 287217),
(481543, 'TIGR04230', NULL, 'seadorna_VP11: seadornavirus VP11 protein', 175, NULL, 'TIGR04230', 287218),
(481544, 'TIGR01650', NULL, 'PD_CobS: cobaltochelatase, CobS subunit', 327, NULL, 'TIGR01650', 287219),
(481545, 'TIGR04407', NULL, 'LptF_YjgP: LPS export ABC transporter permease LptF', 347, NULL, 'TIGR04407', 287220),
(481546, 'TIGR02163', NULL, 'napH_: ferredoxin-type protein, NapH/MauN family', 255, NULL, 'TIGR02163', 287221),
(481547, 'TIGR04492', NULL, 'VioB: iminophenyl-pyruvate dimer synthase VioB', 1003, NULL, 'TIGR04492', 287222),
(481548, 'TIGR02484', NULL, 'CitB: CitB domain protein', 372, NULL, 'TIGR02484', 287223),
(481549, 'TIGR01049', NULL, 'rpsJ_bact: ribosomal protein uS10', 99, NULL, 'TIGR01049', 287224),
(481550, 'TIGR04348', NULL, 'TIGR04348: putative glycosyltransferase, TIGR04348 family', 310, NULL, 'TIGR04348', 287225),
(481551, 'TIGR02462', NULL, 'pyranose_ox: pyranose oxidase', 548, NULL, 'TIGR02462', 287226),
(481552, 'TIGR04108', NULL, 'HutX: putative heme utilization carrier protein HutX', 154, NULL, 'TIGR04108', 287227),
(481553, 'TIGR00168', NULL, 'infC: translation initiation factor IF-3', 165, NULL, 'TIGR00168', 287228),
(481554, 'TIGR01289', NULL, 'LPOR: light-dependent protochlorophyllide reductase', 315, NULL, 'TIGR01289', 287229),
(481555, 'TIGR01152', NULL, 'psbD: photosystem II D2 protein (photosystem q(a) protein)', 352, NULL, 'TIGR01152', 287230),
(481556, 'TIGR00994', NULL, '3a0901s05TIC20: chloroplast protein import component, Tic20 family', 267, NULL, 'TIGR00994', 287231),
(481557, 'TIGR01083', NULL, 'nth: endonuclease III', 192, NULL, 'TIGR01083', 287232),
(481558, 'TIGR03343', NULL, 'biphenyl_bphD: 2-hydroxy-6-oxo-6-phenylhexa-2,4-dienoate hydrolase', 282, NULL, 'TIGR03343', 287233),
(481559, 'TIGR01307', NULL, 'pgm_bpd_ind: phosphoglycerate mutase (2,3-diphosphoglycerate-independent)', 504, NULL, 'TIGR01307', 287234),
(481560, 'TIGR04395', NULL, 'cutC_activ_rSAM: choline TMA-lyase-activating enzyme', 309, NULL, 'TIGR04395', 287235),
(481561, 'TIGR00031', NULL, 'UDP-GALP_mutase: UDP-galactopyranose mutase', 378, NULL, 'TIGR00031', 287236),
(481562, 'TIGR03315', NULL, 'Se_ygfK: putative selenate reductase, YgfK subunit', 1012, NULL, 'TIGR03315', 287237),
(481563, 'TIGR01410', NULL, 'tatB: twin arginine-targeting protein translocase TatB', 80, NULL, 'TIGR01410', 287238),
(481564, 'TIGR03813', NULL, 'put_Glu_GABA_T: putative glutamate/gamma-aminobutyrate antiporter', 474, NULL, 'TIGR03813', 287239),
(481565, 'TIGR01787', NULL, 'squalene_cyclas: squalene/oxidosqualene cyclases', 622, NULL, 'TIGR01787', 287240),
(481566, 'TIGR03795', NULL, 'RNP_Burkhold: ribosomal natural product, two-chain TOMM family', 114, NULL, 'TIGR03795', 287241),
(481567, 'TIGR02434', NULL, 'CobF: precorrin-6A synthase (deacetylating)', 250, NULL, 'TIGR02434', 287242),
(481568, 'TIGR01622', NULL, 'SF-CC1: splicing factor, CC1-like family', 500, NULL, 'TIGR01622', 287243),
(481569, 'TIGR03601', NULL, 'B_an_ocin: bacteriocin, heterocycloanthracin/sonorensin family', 88, NULL, 'TIGR03601', 287244),
(481570, 'TIGR03978', NULL, 'rSAM_paired_1: His-Xaa-Ser system radical SAM maturase HxsB', 466, NULL, 'TIGR03978', 287245),
(481571, 'TIGR00638', NULL, 'Mop: molybdenum-pterin binding domain', 70, NULL, 'TIGR00638', 287246);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(481572, 'TIGR04470', NULL, 'rSAM_mob_pairB: radical SAM mobile pair protein B', 285, NULL, 'TIGR04470', 287247),
(481573, 'TIGR03738', NULL, 'PRTRC_C: PRTRC system protein C', 66, NULL, 'TIGR03738', 287248),
(481574, 'TIGR03807', NULL, 'RR_fam_repeat: putative cofactor-binding repeat', 27, NULL, 'TIGR03807', 287249),
(481575, 'TIGR00271', NULL, 'TIGR00271: uncharacterized hydrophobic domain', 175, NULL, 'TIGR00271', 287250),
(481576, 'TIGR00003', NULL, 'TIGR00003: copper ion binding protein', 66, NULL, 'TIGR00003', 287251),
(481577, 'TIGR03103', NULL, 'trio_acet_GNAT: GNAT-family acetyltransferase TIGR03103', 547, NULL, 'TIGR03103', 287252),
(481578, 'TIGR01547', NULL, 'phage_term_2: phage terminase, large subunit, PBSX family', 396, NULL, 'TIGR01547', 287253),
(481579, 'TIGR01295', NULL, 'PedC_BrcD: putative bacteriocin transport accessory protein', 122, NULL, 'TIGR01295', 287254),
(481580, 'TIGR01881', NULL, 'cas_Cmr5: CRISPR type III-B/RAMP module-associated protein Cmr5', 143, NULL, 'TIGR01881', 287255),
(481581, 'TIGR03555', NULL, 'F420_mer: 5,10-methylenetetrahydromethanopterin reductase', 325, NULL, 'TIGR03555', 287256),
(481582, 'TIGR00196', NULL, 'yjeF_cterm: YjeF family C-terminal domain', 277, NULL, 'TIGR00196', 287257),
(481583, 'TIGR00782', NULL, 'ccoP: cytochrome c oxidase, cbb3-type, subunit III', 285, NULL, 'TIGR00782', 287258),
(481584, 'TIGR04442', NULL, 'TIGR04442: TIGR04442 family protein', 608, NULL, 'TIGR04442', 287259),
(481585, 'TIGR04252', NULL, 'SCM_precur_ScmA: SynChlorMet cassette protein ScmA', 49, NULL, 'TIGR04252', 287260),
(481586, 'TIGR00570', NULL, 'cdk7: CDK-activating kinase assembly factor MAT1', 309, NULL, 'TIGR00570', 287261),
(481587, 'TIGR04149', NULL, 'GG_sam_targ_CFB: natural product precursor, GG-Bacteroidales family', 43, NULL, 'TIGR04149', 287262),
(481588, 'TIGR04012', NULL, 'poly_gGlu_PgsB: poly-gamma-glutamate synthase PgsB', 380, NULL, 'TIGR04012', 287263),
(481589, 'TIGR02456', NULL, 'treS_nterm: trehalose synthase', 539, NULL, 'TIGR02456', 287264),
(481590, 'TIGR00072', NULL, 'hydrog_prot: hydrogenase maturation protease', 145, NULL, 'TIGR00072', 287265),
(481591, 'TIGR00243', NULL, 'Dxr: 1-deoxy-D-xylulose 5-phosphate reductoisomerase', 389, NULL, 'TIGR00243', 287266),
(481592, 'TIGR03091', NULL, 'SASP_sspK: small, acid-soluble spore protein K', 32, NULL, 'TIGR03091', 287267),
(481593, 'TIGR01451', NULL, 'B_ant_repeat: conserved repeat domain', 53, NULL, 'TIGR01451', 287268),
(481594, 'TIGR00878', NULL, 'purM: phosphoribosylformylglycinamidine cyclo-ligase', 332, NULL, 'TIGR00878', 287269),
(481595, 'TIGR04326', NULL, 'O_ant_LIC13510: surface carbohydrate biosynthesis protein, LIC13510 family', 602, NULL, 'TIGR04326', 287270),
(481596, 'TIGR01921', NULL, 'DAP-DH: diaminopimelate dehydrogenase', 324, NULL, 'TIGR01921', 287271),
(481597, 'TIGR03268', NULL, 'methan_mark_3: putative methanogenesis marker protein 3', 503, NULL, 'TIGR03268', 287272),
(481598, 'TIGR04136', NULL, 'rSAM_FibroRumin: radical SAM peptide maturase, FibroRumin system', 458, NULL, 'TIGR04136', 287273),
(481599, 'TIGR02886', NULL, 'spore_II_AA: anti-sigma F factor antagonist', 106, NULL, 'TIGR02886', 287274),
(481600, 'TIGR03302', NULL, 'OM_YfiO: outer membrane assembly lipoprotein YfiO', 239, NULL, 'TIGR03302', 287275),
(481601, 'TIGR02926', NULL, 'AhaH: ATP synthase archaeal, H subunit', 85, NULL, 'TIGR02926', 287276),
(481602, 'TIGR01759', NULL, 'MalateDH-SF1: malate dehydrogenase', 327, NULL, 'TIGR01759', 287277),
(481603, 'TIGR01267', NULL, 'Phe4hydrox_mono: phenylalanine-4-hydroxylase', 248, NULL, 'TIGR01267', 287278),
(481604, 'TIGR01130', NULL, 'ER_PDI_fam: protein disulfide isomerase', 476, NULL, 'TIGR01130', 287279),
(481605, 'TIGR02618', NULL, 'tyr_phenol_ly: tyrosine phenol-lyase', 450, NULL, 'TIGR02618', 287280),
(481606, 'TIGR02428', NULL, 'pcaJ_scoB_fam: 3-oxoacid CoA-transferase, B subunit', 207, NULL, 'TIGR02428', 287281),
(481607, 'TIGR01077', NULL, 'L13_A_E: ribosomal protein uL13', 141, NULL, 'TIGR01077', 287282),
(481608, 'TIGR03125', NULL, 'citrate_citG: triphosphoribosyl-dephospho-CoA synthase CitG', 275, NULL, 'TIGR03125', 287283);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(481609, 'TIGR01575', NULL, 'rimI: ribosomal-protein-alanine acetyltransferase', 132, NULL, 'TIGR01575', 287284),
(481610, 'TIGR01765', NULL, 'tspaseT_teng_N: transposase, putative, N-terminal domain', 73, NULL, 'TIGR01765', 287285),
(481611, 'TIGR03439', NULL, 'methyl_EasF: probable methyltransferase domain, EasF family', 321, NULL, 'TIGR03439', 287286),
(481612, 'TIGR00754', NULL, 'bfr: bacterioferritin', 157, NULL, 'TIGR00754', 287287),
(481613, 'TIGR03773', NULL, 'anch_rpt_wall: putative ABC transporter-associated repeat protein', 516, NULL, 'TIGR03773', 287288),
(481614, 'TIGR01588', NULL, 'citE: citrate (pro-3S)-lyase, beta subunit', 288, NULL, 'TIGR01588', 287289),
(481615, 'TIGR02599', NULL, 'TIGR02599: Verru_Chthon cassette protein C', 361, NULL, 'TIGR02599', 287290),
(481616, 'TIGR03131', NULL, 'malonate_mdcH: malonate decarboxylase, epsilon subunit', 297, NULL, 'TIGR03131', 287291),
(481617, 'TIGR03583', NULL, 'EF_0837: putative amidohydrolase, EF_0837/AHA_3915 family', 365, NULL, 'TIGR03583', 287292),
(481618, 'TIGR04096', NULL, 'dnd_rel_methyl: DNA phosphorothioation-associated putative methyltransferase', 478, NULL, 'TIGR04096', 287293),
(481619, 'TIGR00741', NULL, 'yfiA: ribosomal subunit interface protein', 102, NULL, 'TIGR00741', 287294),
(481620, 'TIGR00324', NULL, 'endA: tRNA-intron lyase', 177, NULL, 'TIGR00324', 287295),
(481621, 'TIGR01342', NULL, 'acon_putative: putative aconitate hydratase', 655, NULL, 'TIGR01342', 287296),
(481622, 'TIGR00564', NULL, 'trpE_most: anthranilate synthase component I', 455, NULL, 'TIGR00564', 287297),
(481623, 'TIGR01479', NULL, 'GMP_PMI: mannose-1-phosphate guanylyltransferase/mannose-6-phosphate isomerase', 467, NULL, 'TIGR01479', 287298),
(481624, 'TIGR01703', NULL, 'hybrid_clust: hydroxylamine reductase', 522, NULL, 'TIGR01703', 287299),
(481625, 'TIGR00598', NULL, 'rad14: DNA repair protein', 171, NULL, 'TIGR00598', 287300),
(481626, 'TIGR02858', NULL, 'spore_III_AA: stage III sporulation protein AA', 272, NULL, 'TIGR02858', 287301),
(481627, 'TIGR03022', NULL, 'WbaP_sugtrans: undecaprenyl-phosphate galactose phosphotransferase WbaP', 456, NULL, 'TIGR03022', 287302),
(481628, 'TIGR03050', NULL, 'PS_I_psaK_plant: photosystem I reaction center PsaK', 83, NULL, 'TIGR03050', 287303),
(481629, 'TIGR00822', NULL, 'EII-Sor: PTS system, mannose/fructose/sorbose family, IIC component', 267, NULL, 'TIGR00822', 287304),
(481630, 'TIGR03399', NULL, 'RNA_3prim_cycl: RNA 3''-phosphate cyclase', 326, NULL, 'TIGR03399', 287305),
(481631, 'TIGR03985', NULL, 'TIGR03985: CRISPR-associated protein, TIGR03985 family', 249, NULL, 'TIGR03985', 287306),
(481632, 'TIGR04401', NULL, 'TAT_Cys_rich: twin-arginine translocation signal/Cys-rich four helix bundle protein', 151, NULL, 'TIGR04401', 287307),
(481633, 'TIGR02169', NULL, 'SMC_prok_A: chromosome segregation protein SMC', 1165, NULL, 'TIGR02169', 287308),
(481634, 'TIGR01977', NULL, 'am_tr_V_EF2568: cysteine desulfurase family protein', 376, NULL, 'TIGR01977', 287309),
(481635, 'TIGR02830', NULL, 'spore_III_AG: stage III sporulation protein AG', 186, NULL, 'TIGR02830', 287310),
(481636, 'TIGR04177', NULL, 'exosort_XrtH: exosortase H, IPTLxxWG-CTERM-specific', 158, NULL, 'TIGR04177', 287311),
(481637, 'TIGR01226', NULL, 'phe_am_lyase: phenylalanine ammonia-lyase', 680, NULL, 'TIGR01226', 287312),
(481638, 'TIGR01812', NULL, 'sdhA_frdA_Gneg: succinate dehydrogenase or fumarate reductase, flavoprotein subunit', 568, NULL, 'TIGR01812', 287313),
(481639, 'TIGR03296', NULL, 'M6dom_TIGR03296: M6 family metalloprotease domain', 286, NULL, 'TIGR03296', 287314),
(481640, 'TIGR03411', NULL, 'urea_trans_UrtD: urea ABC transporter, ATP-binding protein UrtD', 242, NULL, 'TIGR03411', 287315),
(481641, 'TIGR01370', NULL, 'TIGR01370: extracellular protein', 315, NULL, 'TIGR01370', 287316),
(481642, 'TIGR02244', NULL, 'HAD-IG-Ncltidse: HAD superfamily (subfamily IG) hydrolase, 5''-nucleotidase', 343, NULL, 'TIGR02244', 287317),
(481643, 'TIGR03548', NULL, 'mutarot_permut: cyclically-permuted mutarotase family protein', 323, NULL, 'TIGR03548', 287318);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(481644, 'TIGR00215', NULL, 'lpxB: lipid-A-disaccharide synthase', 382, NULL, 'TIGR00215', 287319),
(481645, 'TIGR04566', NULL, 'myxo_TraA_Nterm: outer membrane exchange protein TraA, N-terminal region', 240, NULL, 'TIGR04566', 287320),
(481646, 'TIGR02004', NULL, 'PTS-IIBC-malX: PTS system, maltose and glucose-specific IIBC component', 517, NULL, 'TIGR02004', 287321),
(481647, 'TIGR00461', NULL, 'gcvP: glycine dehydrogenase', 939, NULL, 'TIGR00461', 287322),
(481648, 'TIGR02721', NULL, 'ycfN_thiK: thiamine kinase', 256, NULL, 'TIGR02721', 287323),
(481649, 'TIGR01868', NULL, 'casD_Cas5e: CRISPR-associated protein Cas5/CasD, subtype I-E/ECOLI', 230, NULL, 'TIGR01868', 287324),
(481650, 'TIGR04068', NULL, 'rSAM_ocin_clost: Cys-rich peptide radical SAM maturase CcpM', 462, NULL, 'TIGR04068', 287325),
(481651, 'TIGR04510', NULL, 'mod_pep_cyc: putative peptide modification system cyclase', 814, NULL, 'TIGR04510', 287326),
(481652, 'TIGR00713', NULL, 'hemL: glutamate-1-semialdehyde-2,1-aminomutase', 423, NULL, 'TIGR00713', 287327),
(481653, 'TIGR03732', NULL, 'lanti_perm_MutE: lantibiotic protection ABC transporter permease subunit, MutE/EpiE family', 241, NULL, 'TIGR03732', 287328),
(481654, 'TIGR03159', NULL, 'cas_Csc1: CRISPR type I-D/CYANO-associated protein Csc1', 225, NULL, 'TIGR03159', 287329),
(481655, 'TIGR01691', NULL, 'enolase-ppase: 2,3-diketo-5-methylthio-1-phosphopentane phosphatase', 224, NULL, 'TIGR01691', 287330),
(481656, 'TIGR00959', NULL, 'ffh: signal recognition particle protein', 428, NULL, 'TIGR00959', 287331),
(481657, 'TIGR02646', NULL, 'TIGR02646: TIGR02646 family protein', 144, NULL, 'TIGR02646', 287332),
(481658, 'TIGR02967', NULL, 'guan_deamin: guanine deaminase', 401, NULL, 'TIGR02967', 287333),
(481659, 'TIGR04389', NULL, 'Lepto_lipo_1: lipoprotein, tandem type', 201, NULL, 'TIGR04389', 287334),
(481660, 'TIGR02216', NULL, 'phage_TIGR02216: phage conserved hypothetical protein', 58, NULL, 'TIGR02216', 287335),
(481661, 'TIGR00673', NULL, 'cynS: cyanase', 150, NULL, 'TIGR00673', 287336),
(481662, 'TIGR03234', NULL, 'OH-pyruv-isom: hydroxypyruvate isomerase', 254, NULL, 'TIGR03234', 287337),
(481663, 'TIGR03371', NULL, 'cellulose_yhjQ: cellulose synthase operon protein YhjQ', 246, NULL, 'TIGR03371', 287338),
(481664, 'TIGR03869', NULL, 'F420-0_ABCperm: proposed F420-0 ABC transporter, permease protein', 325, NULL, 'TIGR03869', 287339),
(481665, 'TIGR02714', NULL, 'amido_AtzD_TrzD: ring-opening amidohydrolases', 366, NULL, 'TIGR02714', 287340),
(481666, 'TIGR00501', NULL, 'met_pdase_II: methionine aminopeptidase, type II', 295, NULL, 'TIGR00501', 287341),
(481667, 'TIGR01656', NULL, 'Histidinol-ppas: histidinol-phosphate phosphatase domain', 149, NULL, 'TIGR01656', 287342),
(481668, 'TIGR01335', NULL, 'psaA: photosystem I core protein PsaA', 752, NULL, 'TIGR01335', 287343),
(481669, 'TIGR03664', NULL, 'fut_nucase: futalosine hydrolase', 228, NULL, 'TIGR03664', 287344),
(481670, 'TIGR00208', NULL, 'fliS: flagellar protein FliS', 124, NULL, 'TIGR00208', 287345),
(481671, 'TIGR00489', NULL, 'aEF-1_beta: translation elongation factor aEF-1 beta', 88, NULL, 'TIGR00489', 287346),
(481672, 'TIGR02674', NULL, 'cas_cyan_RAMP_2: CRISPR-associated RAMP protein, Csx10 family', 402, NULL, 'TIGR02674', 287347),
(481673, 'TIGR02537', NULL, 'arch_flag_Nterm: archaeal flagellin N-terminal-like domain', 24, NULL, 'TIGR02537', 287348),
(481674, 'TIGR03841', NULL, 'F420_Rv3093c: probable F420-dependent oxidoreductase, Rv3093c family', 298, NULL, 'TIGR03841', 287349),
(481675, 'TIGR01519', NULL, 'plasmod_dom_1: Plasmodium falciparum uncharacterized domain', 70, NULL, 'TIGR01519', 287350),
(481676, 'TIGR03206', NULL, 'benzo_BadH: 2-hydroxycyclohexanecarboxyl-CoA dehydrogenase', 250, NULL, 'TIGR03206', 287351),
(481677, 'TIGR01021', NULL, 'rpsE_bact: ribosomal protein uS5', 156, NULL, 'TIGR01021', 287352),
(481678, 'TIGR02176', NULL, 'pyruv_ox_red: pyruvate:ferredoxin (flavodoxin) oxidoreductase', 1167, NULL, 'TIGR02176', 287353),
(481679, 'TIGR04361', NULL, 'TrbK_Ti: entry exclusion protein TrbK', 64, NULL, 'TIGR04361', 287354);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(481680, 'TIGR02995', NULL, 'ectoine_ehuB: ectoine/hydroxyectoine ABC transporter solute-binding protein EhuB', 275, NULL, 'TIGR02995', 287355),
(481681, 'TIGR04040', NULL, 'glycyl_YjjI: glycine radical enzyme, YjjI family', 497, NULL, 'TIGR04040', 287356),
(481682, 'TIGR00987', NULL, 'himA: integration host factor, alpha subunit', 96, NULL, 'TIGR00987', 287357),
(481683, 'TIGR01840', NULL, 'esterase_phb: esterase, PHB depolymerase family', 213, NULL, 'TIGR01840', 287358),
(481684, 'TIGR03187', NULL, 'DGQHR: DGQHR domain', 276, NULL, 'TIGR03187', 287359),
(481685, 'TIGR04217', NULL, 'archae_ser_T: archaetidylserine synthase', 221, NULL, 'TIGR04217', 287360),
(481686, 'TIGR02353', NULL, 'NRPS_term_dom: non-ribosomal peptide synthetase terminal domain of unknown function', 695, NULL, 'TIGR02353', 287361),
(481687, 'TIGR02032', NULL, 'GG-red-SF: geranylgeranyl reductase family', 297, NULL, 'TIGR02032', 287362),
(481688, 'TIGR04538', NULL, 'P450_cycloAA_1: cytochrome P450, cyclodipeptide synthase-associated', 395, NULL, 'TIGR04538', 287363),
(481689, 'TIGR03704', NULL, 'PrmC_rel_meth: putative protein-(glutamine-N5) methyltransferase, unknown substrate-specific', 251, NULL, 'TIGR03704', 287364),
(481690, 'TIGR01429', NULL, 'AMP_deaminase: AMP deaminase', 611, NULL, 'TIGR01429', 287365),
(481691, 'TIGR03879', NULL, 'near_KaiC_dom: probable regulatory domain', 91, NULL, 'TIGR03879', 287366),
(481692, 'TIGR00806', NULL, 'rfc: reduced folate carrier', 511, NULL, 'TIGR00806', 287367),
(481693, 'TIGR04380', NULL, 'myo_inos_iolG: inositol 2-dehydrogenase', 330, NULL, 'TIGR04380', 287368),
(481694, 'TIGR01684', NULL, 'viral_ppase: viral phosphatase', 301, NULL, 'TIGR01684', 287369),
(481695, 'TIGR02170', NULL, 'thyX: thymidylate synthase, flavin-dependent', 211, NULL, 'TIGR02170', 287370),
(481696, 'TIGR03847', NULL, 'TIGR03847: conserved hypothetical protein', 177, NULL, 'TIGR03847', 287371),
(481697, 'TIGR04052', NULL, 'AZL_007920_fam: AZL_007920/MXAN_0976 family protein', 206, NULL, 'TIGR04052', 287372),
(481698, 'TIGR03742', NULL, 'PRTRC_F: PRTRC system protein F', 343, NULL, 'TIGR03742', 287373),
(481699, 'TIGR03710', NULL, 'OAFO_sf: 2-oxoacid:acceptor oxidoreductase, alpha subunit', 561, NULL, 'TIGR03710', 287374),
(481700, 'TIGR04189', NULL, 'surface_SprA: cell surface protein SprA', 2319, NULL, 'TIGR04189', 287375),
(481701, 'TIGR01476', NULL, 'chlor_syn_BchG: bacteriochlorophyll/chlorophyll synthetase', 283, NULL, 'TIGR01476', 287376),
(481702, 'TIGR01500', NULL, 'sepiapter_red: sepiapterin reductase', 255, NULL, 'TIGR01500', 287377),
(481703, 'TIGR02275', NULL, 'DHB_AMP_lig: (2,3-dihydroxybenzoyl)adenylate synthase', 526, NULL, 'TIGR02275', 287378),
(481704, 'TIGR00701', NULL, 'TIGR00701: TIGR00701 family protein', 142, NULL, 'TIGR00701', 287379),
(481705, 'TIGR00853', NULL, 'pts-lac: PTS system, lactose/cellobiose family IIB component', 140, NULL, 'TIGR00853', 287380),
(481706, 'TIGR01980', NULL, 'sufB: FeS assembly protein SufB', 448, NULL, 'TIGR01980', 287381),
(481707, 'TIGR02123', NULL, 'TRAP_fused: TRAP transporter, 4TM/12TM fusion protein', 615, NULL, 'TIGR02123', 287382),
(481708, 'TIGR01772', NULL, 'MDH_euk_gproteo: malate dehydrogenase, NAD-dependent', 313, NULL, 'TIGR01772', 287383),
(481709, 'TIGR04005', NULL, 'wcaL: colanic acid biosynthesis glycosyltransferase WcaL', 406, NULL, 'TIGR04005', 287384),
(481710, 'TIGR01148', NULL, 'mtrC: tetrahydromethanopterin S-methyltransferase, subunit C', 264, NULL, 'TIGR01148', 287385),
(481711, 'TIGR03598', NULL, 'GTPase_YsxC: ribosome biogenesis GTP-binding protein YsxC', 186, NULL, 'TIGR03598', 287386),
(481712, 'TIGR02571', NULL, 'ComEB: ComE operon protein 2', 151, NULL, 'TIGR02571', 287387),
(481713, 'TIGR00498', NULL, 'lexA: repressor LexA', 203, NULL, 'TIGR00498', 287388),
(481714, 'TIGR01043', NULL, 'ATP_syn_A_arch: ATP synthase archaeal, A subunit', 580, NULL, 'TIGR01043', 287389),
(481715, 'TIGR01933', NULL, 'hflK: HflK protein', 261, NULL, 'TIGR01933', 287390),
(481716, 'TIGR01491', NULL, 'HAD-SF-IB-PSPlk: phosphoserine phosphatase-like hydrolase, archaeal', 201, NULL, 'TIGR01491', 287391);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(481717, 'TIGR00153', NULL, 'TIGR00153: TIGR00153 family protein', 217, NULL, 'TIGR00153', 287392),
(481718, 'TIGR00645', NULL, 'HI0507: TIGR00645 family protein', 167, NULL, 'TIGR00645', 287393),
(481719, 'TIGR04084', NULL, 'rSAM_AF0577: putative peptide-modifying radical SAM enzyme, AF0577 family', 347, NULL, 'TIGR04084', 287394),
(481720, 'TIGR04526', NULL, 'predic_Ig_block: putative immunoglobulin-blocking virulence protein', 693, NULL, 'TIGR04526', 287395),
(481721, 'TIGR02767', NULL, 'TraG-Ti: Ti-type conjugative transfer system protein TraG', 623, NULL, 'TIGR02767', 287396),
(481722, 'TIGR02911', NULL, 'sulfite_red_B: sulfite reductase, subunit B', 261, NULL, 'TIGR02911', 287397),
(481723, 'TIGR00838', NULL, 'argH: argininosuccinate lyase', 455, NULL, 'TIGR00838', 287398),
(481724, 'TIGR04333', NULL, 'Clo7Bot_mod_Cys: Cys-rich peptide, Clo7bot family', 34, NULL, 'TIGR04333', 287399),
(481725, 'TIGR03414', NULL, 'ABC_choline_bnd: choline ABC transporter, periplasmic binding protein', 291, NULL, 'TIGR03414', 287400),
(481726, 'TIGR00317', NULL, 'cobS: cobalamin 5''-phosphate synthase', 241, NULL, 'TIGR00317', 287401),
(481727, 'TIGR01089', NULL, 'fucI: L-fucose isomerase', 587, NULL, 'TIGR01089', 287402),
(481728, 'TIGR04245', NULL, 'nodulat_NodA: N-acyltransferase NodA', 193, NULL, 'TIGR04245', 287403),
(481729, 'TIGR02764', NULL, 'spore_ybaN_pdaB: polysaccharide deacetylase family sporulation protein PdaB', 191, NULL, 'TIGR02764', 287404),
(481730, 'TIGR00212', NULL, 'hemC: hydroxymethylbilane synthase', 293, NULL, 'TIGR00212', 287405),
(481731, 'TIGR00314', NULL, 'cdhA: CO dehydrogenase/acetyl-CoA synthase complex, epsilon subunit', 784, NULL, 'TIGR00314', 287406),
(481732, 'TIGR02612', NULL, 'mob_myst_A: mobile mystery protein A', 150, NULL, 'TIGR02612', 287407),
(481733, 'TIGR02717', NULL, 'AcCoA-syn-alpha: acetyl coenzyme A synthetase (ADP forming), alpha domain', 447, NULL, 'TIGR02717', 287408),
(481734, 'TIGR00794', NULL, 'kup: potassium uptake protein', 688, NULL, 'TIGR00794', 287409),
(481735, 'TIGR02749', NULL, 'prenyl_cyano: solanesyl diphosphate synthase', 322, NULL, 'TIGR02749', 287410),
(481736, 'TIGR03250', NULL, 'PhnAcAld_DH: putative phosphonoacetaldehyde dehydrogenase', 472, NULL, 'TIGR03250', 287411),
(481737, 'TIGR03355', NULL, 'VI_chp_2: type VI secretion protein, EvpB/VC_A0108 family', 473, NULL, 'TIGR03355', 287412),
(481738, 'TIGR00557', NULL, 'pdxA: 4-hydroxythreonine-4-phosphate dehydrogenase PdxA', 320, NULL, 'TIGR00557', 287413),
(481739, 'TIGR02630', NULL, 'xylose_isom_A: xylose isomerase', 435, NULL, 'TIGR02630', 287414),
(481740, 'TIGR01831', NULL, 'fabG_rel: putative 3-oxoacyl-(acyl-carrier-protein) reductase', 239, NULL, 'TIGR01831', 287415),
(481741, 'TIGR00642', NULL, 'mmCoA_mut_beta: methylmalonyl-CoA mutase, small subunit', 620, NULL, 'TIGR00642', 287416),
(481742, 'TIGR00747', NULL, 'fabH: 3-oxoacyl-[acyl-carrier-protein] synthase III', 322, NULL, 'TIGR00747', 287417),
(481743, 'TIGR04529', NULL, 'MTB_hemophore: hemophore-related protein, Rv0203/Rv1174c family', 77, NULL, 'TIGR04529', 287418),
(481744, 'TIGR00885', NULL, 'fucP: L-fucose:H+ symporter permease', 410, NULL, 'TIGR00885', 287419),
(481745, 'TIGR02278', NULL, 'PaaN-DH: phenylacetic acid degradation protein paaN', 664, NULL, 'TIGR02278', 287420),
(481746, 'TIGR03903', NULL, 'TOMM_kin_cyc: TOMM system kinase/cyclase fusion protein', 1267, NULL, 'TIGR03903', 287421),
(481747, 'TIGR01011', NULL, 'rpsB_bact: ribosomal protein uS2', 225, NULL, 'TIGR01011', 287422),
(481748, 'TIGR01503', NULL, 'MthylAspMut_E: methylaspartate mutase, E subunit', 480, NULL, 'TIGR01503', 287423),
(481749, 'TIGR01535', NULL, 'glucan_glucosid: glucan 1,4-alpha-glucosidase', 662, NULL, 'TIGR01535', 287424),
(481750, 'TIGR03891', NULL, 'thiopep_ocin: thiopeptide-type bacteriocin biosynthesis domain', 263, NULL, 'TIGR03891', 287425),
(481751, 'TIGR03446', NULL, 'mycothiol_Mca: mycothiol conjugate amidase Mca', 283, NULL, 'TIGR03446', 287426),
(481752, 'TIGR03059', NULL, 'psaOeuk: photosystem I protein PsaO', 82, NULL, 'TIGR03059', 287427);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(481753, 'TIGR01195', NULL, 'oadG_fam: sodium pump decarboxylases, gamma subunit', 84, NULL, 'TIGR01195', 287428),
(481754, 'TIGR00361', NULL, 'ComEC_Rec2: DNA internalization-related competence protein ComEC/Rec2', 663, NULL, 'TIGR00361', 287429),
(481755, 'TIGR04482', NULL, 'D_pro_red_PrdD: proline reductase cluster protein PrdD', 246, NULL, 'TIGR04482', 287430),
(481756, 'TIGR01280', NULL, 'xseB: exodeoxyribonuclease VII, small subunit', 57, NULL, 'TIGR01280', 287431),
(481757, 'TIGR02173', NULL, 'cyt_kin_arch: putative cytidylate kinase', 169, NULL, 'TIGR02173', 287432),
(481758, 'TIGR01444', NULL, 'fkbM_fam: methyltransferase, FkbM family', 143, NULL, 'TIGR01444', 287433),
(481759, 'TIGR03118', NULL, 'PEPCTERM_chp_1: TIGR03118 family protein', 336, NULL, 'TIGR03118', 287434),
(481760, 'TIGR00420', NULL, 'trmU: tRNA (5-methylaminomethyl-2-thiouridylate)-methyltransferase', 351, NULL, 'TIGR00420', 287435),
(481761, 'TIGR04037', NULL, 'LLM_duo_CE1759: LLM-partnered FMN reductase, CE1759 family', 199, NULL, 'TIGR04037', 287436),
(481762, 'TIGR04541', NULL, 'thiaminase_BcmE: thiamine pyridinylase', 381, NULL, 'TIGR04541', 287437),
(481763, 'TIGR01968', NULL, 'minD_bact: septum site-determining protein MinD', 261, NULL, 'TIGR01968', 287438),
(481764, 'TIGR03203', NULL, 'pimD_small: pimeloyl-CoA dehydrogenase, small subunit', 378, NULL, 'TIGR03203', 287439),
(481765, 'TIGR03308', NULL, 'phn_thr-fam: phosphonate metabolim protein, transferase hexapeptide repeat family', 204, NULL, 'TIGR03308', 287440),
(481766, 'TIGR00856', NULL, 'pyrC_dimer: dihydroorotase, homodimeric type', 341, NULL, 'TIGR00856', 287441),
(481767, 'TIGR01874', NULL, 'cas_cas5a: CRISPR-associated protein Cas5, subtype I-A/APERN', 173, NULL, 'TIGR01874', 287442),
(481768, 'TIGR04435', NULL, 'restrict_AAA_1: restriction system-associated AAA family ATPase', 568, NULL, 'TIGR04435', 287443),
(481769, 'TIGR03464', NULL, 'HpnC: squalene synthase HpnC', 267, NULL, 'TIGR03464', 287444),
(481770, 'TIGR03792', NULL, 'TIGR03792: uncharacterized cyanobacterial protein, TIGR03792 family', 90, NULL, 'TIGR03792', 287445),
(481771, 'TIGR02017', NULL, 'hutG_amidohyd: N-formylglutamate deformylase', 263, NULL, 'TIGR02017', 287446),
(481772, 'TIGR00408', NULL, 'proS_fam_I: proline--tRNA ligase', 475, NULL, 'TIGR00408', 287447),
(481773, 'TIGR02873', NULL, 'spore_ylxY: probable sporulation protein, polysaccharide deacetylase family', 268, NULL, 'TIGR02873', 287448),
(481774, 'TIGR01582', NULL, 'FDH-beta: formate dehydrogenase, beta subunit', 283, NULL, 'TIGR01582', 287449),
(481775, 'TIGR03417', NULL, 'chol_sulfatase: choline-sulfatase', 500, NULL, 'TIGR03417', 287450),
(481776, 'TIGR03844', NULL, 'cysteate_syn: cysteate synthase', 398, NULL, 'TIGR03844', 287451),
(481777, 'TIGR02272', NULL, 'gentisate_1_2: gentisate 1,2-dioxygenase', 336, NULL, 'TIGR02272', 287452),
(481778, 'TIGR02064', NULL, 'dsrA: sulfite reductase, dissimilatory-type alpha subunit', 402, NULL, 'TIGR02064', 287453),
(481779, 'TIGR00287', NULL, 'cas1: CRISPR-associated endonuclease Cas1', 327, NULL, 'TIGR00287', 287454),
(481780, 'TIGR00455', NULL, 'apsK: adenylyl-sulfate kinase', 184, NULL, 'TIGR00455', 287455),
(481781, 'TIGR00448', NULL, 'rpoE: DNA-directed RNA polymerase', 179, NULL, 'TIGR00448', 287456),
(481782, 'TIGR00311', NULL, 'aIF-2beta: putative translation initiation factor aIF-2, beta subunit', 133, NULL, 'TIGR00311', 287457),
(481783, 'TIGR03191', NULL, 'benz_CoA_bzdO: benzoyl-CoA reductase, bzd-type, O subunit', 430, NULL, 'TIGR03191', 287458),
(481784, 'TIGR01086', NULL, 'fucA: L-fuculose phosphate aldolase', 214, NULL, 'TIGR01086', 287459),
(481785, 'TIGR00068', NULL, 'glyox_I: lactoylglutathione lyase', 150, NULL, 'TIGR00068', 287460),
(481786, 'TIGR01983', NULL, 'UbiG: 3-demethylubiquinone-9 3-O-methyltransferase', 228, NULL, 'TIGR01983', 287461),
(481787, 'TIGR00127', NULL, 'nadp_idh_euk: isocitrate dehydrogenase, NADP-dependent', 409, NULL, 'TIGR00127', 287462),
(481788, 'TIGR04143', NULL, 'VPxxxP_CTERM: VPXXXP-CTERM protein sorting domain', 25, NULL, 'TIGR04143', 287463);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(481789, 'TIGR00396', NULL, 'leuS_bact: leucine--tRNA ligase', 843, NULL, 'TIGR00396', 287464),
(481790, 'TIGR01046', NULL, 'uS10_euk_arch: ribosomal protein uS10', 99, NULL, 'TIGR01046', 287465),
(481791, 'TIGR03745', NULL, 'conj_TIGR03745: integrating conjugative element membrane protein, PFL_4702 family', 105, NULL, 'TIGR03745', 287466),
(481792, 'TIGR00150', NULL, 'T6A_YjeE: tRNA threonylcarbamoyl adenosine modification protein YjeE', 135, NULL, 'TIGR00150', 287467),
(481793, 'TIGR02826', NULL, 'RNR_activ_nrdG3: anaerobic ribonucleoside-triphosphate reductase activating protein', 148, NULL, 'TIGR02826', 287468),
(481794, 'TIGR01426', NULL, 'MGT: glycosyltransferase, MGT family', 393, NULL, 'TIGR01426', 287469),
(481795, 'TIGR02319', NULL, 'CPEP_Pphonmut: carboxyvinyl-carboxyphosphonate phosphorylmutase', 294, NULL, 'TIGR02319', 287470),
(481796, 'TIGR03906', NULL, 'quino_hemo_SAM: quinohemoprotein amine dehydrogenase maturation protein', 467, NULL, 'TIGR03906', 287471),
(481797, 'TIGR00776', NULL, 'RhaT: RhaT L-rhamnose-proton symporter family protein', 290, NULL, 'TIGR00776', 287472),
(481798, 'TIGR03337', NULL, 'phnR: phosphonate utilization transcriptional regulator PhnR', 231, NULL, 'TIGR03337', 287473),
(481799, 'TIGR04544', NULL, '3metArgNH2trans: beta-methylarginine biosynthesis bifunctional aminotransferase', 366, NULL, 'TIGR04544', 287474),
(481800, 'TIGR03200', NULL, 'dearomat_oah: 6-oxocyclohex-1-ene-1-carbonyl-CoA hydrolase', 360, NULL, 'TIGR03200', 287475),
(481801, 'TIGR00346', NULL, 'azlC: azaleucine resistance protein AzlC', 221, NULL, 'TIGR00346', 287476),
(481802, 'TIGR01145', NULL, 'ATP_synt_delta: ATP synthase F1, delta subunit', 172, NULL, 'TIGR01145', 287477),
(481803, 'TIGR03009', NULL, 'plancto_dom_2: Planctomycetes uncharacterized domain TIGR03009', 212, NULL, 'TIGR03009', 287478),
(481804, 'TIGR01230', NULL, 'agmatinase: agmatinase', 275, NULL, 'TIGR01230', 287479),
(481805, 'TIGR00018', NULL, 'panC: pantoate--beta-alanine ligase', 283, NULL, 'TIGR00018', 287480),
(481806, 'TIGR01093', NULL, 'aroD: 3-dehydroquinate dehydratase, type I', 229, NULL, 'TIGR01093', 287481),
(481807, 'TIGR00103', NULL, 'DNA_YbaB_EbfC: DNA-binding protein, YbaB/EbfC family', 104, NULL, 'TIGR00103', 287482),
(481808, 'TIGR00915', NULL, '2A0602: RND transporter, hydrophobe/amphiphile efflux-1 (HAE1) family', 1050, NULL, 'TIGR00915', 287483),
(481809, 'TIGR02680', NULL, 'TIGR02680: TIGR02680 family protein', 1356, NULL, 'TIGR02680', 287484),
(481810, 'TIGR03016', NULL, 'pepcterm_hypo_1: uncharacterized protein, PEP-CTERM system associated', 477, NULL, 'TIGR03016', 287485),
(481811, 'TIGR01473', NULL, 'cyoE_ctaB: protoheme IX farnesyltransferase', 281, NULL, 'TIGR01473', 287486),
(481812, 'TIGR04034', NULL, 'export_SdpA: antimicrobial peptide system protein, SdpA family', 157, NULL, 'TIGR04034', 287487),
(481813, 'TIGR00044', NULL, 'TIGR00044: pyridoxal phosphate enzyme, YggS family', 229, NULL, 'TIGR00044', 287488),
(481814, 'TIGR03953', NULL, 'rplD_bact: 50S ribosomal protein uL4', 188, NULL, 'TIGR03953', 287489),
(481815, 'TIGR03894', NULL, 'chp_P_marinus_1: conserved hypothetical protein, TIGR03894 family', 95, NULL, 'TIGR03894', 287490),
(481816, 'TIGR02447', NULL, 'yiiD_Cterm: putative thioesterase domain', 138, NULL, 'TIGR02447', 287491),
(481817, 'TIGR03499', NULL, 'FlhF: flagellar biosynthesis protein FlhF', 286, NULL, 'TIGR03499', 287492),
(481818, 'TIGR03362', NULL, 'VI_chp_7: type VI secretion-associated protein, VC_A0119 family', 476, NULL, 'TIGR03362', 287493),
(481819, 'TIGR02310', NULL, 'HpaB-2: 4-hydroxyphenylacetate 3-monooxygenase, oxygenase component', 519, NULL, 'TIGR02310', 287494),
(481820, 'TIGR04417', NULL, 'PFTS_polysacc: polysaccharide biosynthesis PFTS motif protein', 522, NULL, 'TIGR04417', 287495),
(481821, 'TIGR01824', NULL, 'PabB-clade2: aminodeoxychorismate synthase, component I', 355, NULL, 'TIGR01824', 287496),
(481822, 'TIGR00252', NULL, 'TIGR00252: TIGR00252 family protein', 123, NULL, 'TIGR00252', 287497),
(481823, 'TIGR03034', NULL, 'TIGR03034: conserved hypothetical protein', 274, NULL, 'TIGR03034', 287498);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(481824, 'TIGR00389', NULL, 'glyS_dimeric: glycine--tRNA ligase', 565, NULL, 'TIGR00389', 287499),
(481825, 'TIGR00619', NULL, 'sbcd: exonuclease SbcCD, D subunit', 252, NULL, 'TIGR00619', 287500),
(481826, 'TIGR01856', NULL, 'hisJ_fam: histidinol phosphate phosphatase, HisJ family', 252, NULL, 'TIGR01856', 287501),
(481827, 'TIGR02655', NULL, 'circ_KaiC: circadian clock protein KaiC', 484, NULL, 'TIGR02655', 287502),
(481828, 'TIGR00580', NULL, 'mfd: transcription-repair coupling factor', 923, NULL, 'TIGR00580', 287503),
(481829, 'TIGR00685', NULL, 'T6PP: trehalose-phosphatase', 250, NULL, 'TIGR00685', 287504),
(481830, 'TIGR02829', NULL, 'spore_III_AE: stage III sporulation protein AE', 381, NULL, 'TIGR02829', 287505),
(481831, 'TIGR01096', NULL, '3A0103s03R: lysine-arginine-ornithine-binding periplasmic protein', 250, NULL, 'TIGR01096', 287506),
(481832, 'TIGR02771', NULL, 'TraF_Ti: conjugative transfer signal peptidase TraF', 171, NULL, 'TIGR02771', 287507),
(481833, 'TIGR03278', NULL, 'methan_mark_10: methanogenesis marker radical SAM protein', 404, NULL, 'TIGR03278', 287508),
(481834, 'TIGR04501', NULL, 'microcomp_PduB: microcompartment protein PduB', 225, NULL, 'TIGR04501', 287509),
(481835, 'TIGR00100', NULL, 'hypA: hydrogenase nickel insertion protein HypA', 116, NULL, 'TIGR00100', 287510),
(481836, 'TIGR01036', NULL, 'pyrD_sub2: dihydroorotate dehydrogenase (fumarate)', 356, NULL, 'TIGR01036', 287511),
(481837, 'TIGR04298', NULL, 'his_histam_anti: histidine-histamine antiporter', 429, NULL, 'TIGR04298', 287512),
(481838, 'TIGR01528', NULL, 'NMN_trans_PnuC: nicotinamide mononucleotide transporter PnuC', 187, NULL, 'TIGR01528', 287513),
(481839, 'TIGR02983', NULL, 'SigE-fam_strep: RNA polymerase sigma-70 factor, sigma-E family', 162, NULL, 'TIGR02983', 287514),
(481840, 'TIGR00091', NULL, 'TIGR00091: tRNA (guanine-N(7)-)-methyltransferase', 194, NULL, 'TIGR00091', 287515),
(481841, 'TIGR01171', NULL, 'rplB_bact: ribosomal protein uL2', 275, NULL, 'TIGR01171', 287516),
(481842, 'TIGR01940', NULL, 'nqrE: NADH:ubiquinone oxidoreductase, Na(+)-translocating, E subunit', 200, NULL, 'TIGR01940', 287517),
(481843, 'TIGR02951', NULL, 'DMSO_dmsB: dimethylsulfoxide reductase, chain B', 161, NULL, 'TIGR02951', 287518),
(481844, 'TIGR04193', NULL, 'SPASM_w_grasp: SPASM domain peptide maturase, grasp-with-spasm system', 342, NULL, 'TIGR04193', 287519),
(481845, 'TIGR02198', NULL, 'rfaE_dom_I: bifunctional protein RfaE, domain I', 315, NULL, 'TIGR02198', 287520),
(481846, 'TIGR01612', NULL, '235kDa-fam: rhoptry protein', 2756, NULL, 'TIGR01612', 287521),
(481847, 'TIGR01364', NULL, 'serC_1: phosphoserine transaminase', 358, NULL, 'TIGR01364', 287522),
(481848, 'TIGR02119', NULL, 'panF: sodium/pantothenate symporter', 471, NULL, 'TIGR02119', 287523),
(481849, 'TIGR04271', NULL, 'ThiI_C_thiazole: thiazole biosynthesis domain', 101, NULL, 'TIGR04271', 287524),
(481850, 'TIGR02443', NULL, 'TIGR02443: conserved hypothetical protein', 59, NULL, 'TIGR02443', 287525),
(481851, 'TIGR03719', NULL, 'ABC_ABC_ChvD: ATP-binding cassette protein, ChvD family', 552, NULL, 'TIGR03719', 287526),
(481852, 'TIGR01105', NULL, 'galF: regulatory protein GalF', 297, NULL, 'TIGR01105', 287527),
(481853, 'TIGR03804', NULL, 'para_beta_helix: parallel beta-helix repeat', 44, NULL, 'TIGR03804', 287528),
(481854, 'TIGR02232', NULL, 'myxo_disulf_rpt: Myxococcus cysteine-rich repeat', 38, NULL, 'TIGR02232', 287529),
(481855, 'TIGR02369', NULL, 'trimeth_pyl: trimethylamine:corrinoid methyltransferase', 489, NULL, 'TIGR02369', 287530),
(481856, 'TIGR03680', NULL, 'eif2g_arch: translation initiation factor 2, gamma subunit', 407, NULL, 'TIGR03680', 287531),
(481857, 'TIGR03956', NULL, 'rSAM_HydE: [FeFe] hydrogenase H-cluster radical SAM maturase HydE', 340, NULL, 'TIGR03956', 287532),
(481858, 'TIGR04077', NULL, 'expor_sig_YdyF: exported signaling peptide, YydF/SAG_2028 family', 49, NULL, 'TIGR04077', 287533),
(481859, 'TIGR00177', NULL, 'molyb_syn: molybdenum cofactor synthesis domain', 148, NULL, 'TIGR00177', 287534),
(481860, 'TIGR00965', NULL, 'dapD: 2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-succinyltransferase', 271, NULL, 'TIGR00965', 287535);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(481861, 'TIGR02200', NULL, 'GlrX_actino: glutaredoxin-like protein', 77, NULL, 'TIGR02200', 287536),
(481862, 'TIGR02986', NULL, 'restrict_Alw26I: type II restriction endonuclease, Alw26I/Eco31I/Esp3I family', 425, NULL, 'TIGR02986', 287537),
(481863, 'TIGR00262', NULL, 'trpA: tryptophan synthase, alpha subunit', 256, NULL, 'TIGR00262', 287538),
(481864, 'TIGR03785', NULL, 'marine_sort_HK: proteobacterial dedicated sortase system histidine kinase', 703, NULL, 'TIGR03785', 287539),
(481865, 'TIGR00729', NULL, 'TIGR00729: ribonuclease HII', 207, NULL, 'TIGR00729', 287540),
(481866, 'TIGR02665', NULL, 'molyb_mobA: molybdenum cofactor guanylyltransferase', 186, NULL, 'TIGR02665', 287541),
(481867, 'TIGR01746', NULL, 'Thioester-redct: thioester reductase domain', 371, NULL, 'TIGR01746', 287542),
(481868, 'TIGR02658', NULL, 'TTQ_MADH_Hv: methylamine dehydrogenase (amicyanin) heavy chain', 358, NULL, 'TIGR02658', 287543),
(481869, 'TIGR03910', NULL, 'pyrrolys_PylB: pyrrolysine biosynthesis radical SAM protein', 347, NULL, 'TIGR03910', 287544),
(481870, 'TIGR04161', NULL, 'VPEID-CTERM: VPEID-CTERM protein sorting domain', 31, NULL, 'TIGR04161', 287545),
(481871, 'TIGR02061', NULL, 'aprA: adenylylsulfate reductase, alpha subunit', 616, NULL, 'TIGR02061', 287546),
(481872, 'TIGR02553', NULL, 'SipD_IpaD_SspD: type III effector protein IpaD/SipD/SspD', 317, NULL, 'TIGR02553', 287547),
(481873, 'TIGR03066', NULL, 'Gem_osc_para_1: Gemmata obscuriglobus paralogous family TIGR03066', 121, NULL, 'TIGR03066', 287548),
(481874, 'TIGR00473', NULL, 'pssA: CDP-diacylglycerol-serine O-phosphatidyltransferase', 153, NULL, 'TIGR00473', 287549),
(481875, 'TIGR03570', NULL, 'NeuD_NnaD: sugar O-acyltransferase, sialic acid O-acetyltransferase NeuD family', 202, NULL, 'TIGR03570', 287550),
(481876, 'TIGR00040', NULL, 'yfcE: phosphodiesterase, MJ0936 family', 158, NULL, 'TIGR00040', 287551),
(481877, 'TIGR02337', NULL, 'HpaR: homoprotocatechuate degradation operon regulator, HpaR', 130, NULL, 'TIGR02337', 287552),
(481878, 'TIGR03144', NULL, 'cytochr_II_ccsB: cytochrome c-type biogenesis protein CcsB', 252, NULL, 'TIGR03144', 287553),
(481879, 'TIGR00813', NULL, 'sss: transporter, solute:sodium symporter (SSS) family', 411, NULL, 'TIGR00813', 287554),
(481880, 'TIGR00237', NULL, 'xseA: exodeoxyribonuclease VII, large subunit', 389, NULL, 'TIGR00237', 287555),
(481881, 'TIGR00682', NULL, 'lpxK: tetraacyldisaccharide 4''-kinase', 324, NULL, 'TIGR00682', 287556),
(481882, 'TIGR03829', NULL, 'YokU_near_AblA: uncharacterized protein, YokU family', 89, NULL, 'TIGR03829', 287557),
(481883, 'TIGR03069', NULL, 'PS_II_S4: photosystem II S4 domain protein', 257, NULL, 'TIGR03069', 287558),
(481884, 'TIGR01859', NULL, 'fruc_bis_ald_: fructose-1,6-bisphosphate aldolase, class II', 282, NULL, 'TIGR01859', 287559),
(481885, 'TIGR00704', NULL, 'NaPi_cotrn_rel: Na/Pi-cotransporter II-related protein', 308, NULL, 'TIGR00704', 287560),
(481886, 'TIGR02225', NULL, 'recomb_XerD: tyrosine recombinase XerD', 290, NULL, 'TIGR02225', 287561),
(481887, 'TIGR02341', NULL, 'chap_CCT_beta: T-complex protein 1, beta subunit', 519, NULL, 'TIGR02341', 287562),
(481888, 'TIGR01207', NULL, 'rmlA: glucose-1-phosphate thymidylyltransferase', 286, NULL, 'TIGR01207', 287563),
(481889, 'TIGR01273', NULL, 'speA: arginine decarboxylase', 624, NULL, 'TIGR01273', 287564),
(481890, 'TIGR03140', NULL, 'AhpF: alkyl hydroperoxide reductase subunit F', 515, NULL, 'TIGR03140', 287565),
(481891, 'TIGR02549', NULL, 'CRISPR_DxTHG: CRISPR-associated DxTHG motif protein', 21, NULL, 'TIGR02549', 287566),
(481892, 'TIGR04295', NULL, 'B12_rSAM_oligo: B12-binding domain/radical SAM domain protein, rhizo-twelve system', 422, NULL, 'TIGR04295', 287567),
(481893, 'TIGR04519', NULL, 'MoCo_extend_TAT: MoCo/4Fe-4S cofactor protein extended Tat translocation domain', 45, NULL, 'TIGR04519', 287568),
(481894, 'TIGR00043', NULL, 'TIGR00043: rRNA maturation RNase YbeY', 111, NULL, 'TIGR00043', 287569),
(481895, 'TIGR01821', NULL, '5aminolev_synth: 5-aminolevulinic acid synthase', 402, NULL, 'TIGR01821', 287570);
INSERT INTO "PUBLIC"."MODEL" VALUES
(481896, 'TIGR00912', NULL, '2A0309: spore germination protein (amino acid permease)', 357, NULL, 'TIGR00912', 287571),
(481897, 'TIGR02740', NULL, 'TraF-like: TraF-like protein', 276, NULL, 'TIGR02740', 287572),
(481898, 'TIGR04087', NULL, 'YqxM_for_SipW: YqxM protein', 186, NULL, 'TIGR04087', 287573),
(481899, 'TIGR00583', NULL, 'mre11: DNA repair protein (mre11)', 405, NULL, 'TIGR00583', 287574),
(481900, 'TIGR03031', NULL, 'cas_csx12: CRISPR system subtype II-B RNA-guided endonuclease Cas9/Csx12', 802, NULL, 'TIGR03031', 287575),
(481901, 'TIGR03676', NULL, 'aRF1/eRF1: peptide chain release factor 1, archaeal and eukaryotic forms', 403, NULL, 'TIGR03676', 287576),
(481902, 'TIGR03683', NULL, 'A-tRNA_syn_arch: alanine--tRNA ligase', 902, NULL, 'TIGR03683', 287577),
(481903, 'TIGR01613', NULL, 'primase_Cterm: phage/plasmid primase, P4 family, C-terminal domain', 304, NULL, 'TIGR01613', 287578),
(481904, 'TIGR02126', NULL, 'phgtail_TP901_1: phage major tail protein, TP901-1 family', 135, NULL, 'TIGR02126', 287579),
(481905, 'TIGR02521', NULL, 'type_IV_pilW: type IV pilus biogenesis/stability protein PilW', 234, NULL, 'TIGR02521', 287580),
(481906, 'TIGR03938', NULL, 'deacetyl_PgaB: poly-beta-1,6-N-acetyl-D-glucosamine N-deacetylase PgaB', 618, NULL, 'TIGR03938', 287581),
(481907, 'TIGR01170', NULL, 'rplA_mito: ribosomal protein uL1, mitochondrial', 140, NULL, 'TIGR01170', 287582),
(481908, 'TIGR03617', NULL, 'F420_MSMEG_2256: probable F420-dependent oxidoreductase, MSMEG_2256 family', 318, NULL, 'TIGR03617', 287583),
(481909, 'TIGR01108', NULL, 'oadA: oxaloacetate decarboxylase alpha subunit', 582, NULL, 'TIGR01108', 287584),
(481910, 'TIGR00916', NULL, '2A0604s01: protein-export membrane protein, SecD/SecF family', 231, NULL, 'TIGR00916', 287585),
(481911, 'TIGR00255', NULL, 'TIGR00255: TIGR00255 family protein', 291, NULL, 'TIGR00255', 287586),
(481912, 'TIGR03496', NULL, 'FliI_clade1: flagellar protein export ATPase FliI', 414, NULL, 'TIGR03496', 287587),
(481913, 'TIGR04196', NULL, 'glycopep_SunS: glycopeptide, sublancin family', 80, NULL, 'TIGR04196', 287588),
(481914, 'TIGR00517', NULL, 'acyl_carrier: acyl carrier protein', 77, NULL, 'TIGR00517', 287589),
(481915, 'TIGR01930', NULL, 'AcCoA-C-Actrans: acetyl-CoA C-acyltransferase', 385, NULL, 'TIGR01930', 287590),
(481916, 'TIGR03277', NULL, 'methan_mark_9: putative methanogenesis marker domain 9', 109, NULL, 'TIGR03277', 287591),
(481917, 'TIGR04307', NULL, 'ProTailRpt: proline-rich tail region repeat', 23, NULL, 'TIGR04307', 287592),
(481918, 'TIGR04186', NULL, 'GRASP_targ: putative ATP-grasp target RiPP', 72, NULL, 'TIGR04186', 287593),
(481919, 'TIGR03352', NULL, 'VI_chp_3: type VI secretion lipoprotein, VC_A0113 family', 147, NULL, 'TIGR03352', 287594),
(481920, 'TIGR01382', NULL, 'PfpI: intracellular protease, PfpI family', 169, NULL, 'TIGR01382', 287595),
(481921, 'TIGR00364', NULL, 'TIGR00364: queuosine biosynthesis protein QueC', 201, NULL, 'TIGR00364', 287596),
(481922, 'TIGR03782', NULL, 'Bac_Flav_CT_J: Bacteroides conjugative transposon TraJ protein', 323, NULL, 'TIGR03782', 287597),
(481923, 'TIGR02662', NULL, 'dinitro_DRAG: ADP-ribosyl-[dinitrogen reductase] hydrolase', 287, NULL, 'TIGR02662', 287598),
(481924, 'TIGR00399', NULL, 'metG_C_term: methionine--tRNA ligase, beta subunit', 139, NULL, 'TIGR00399', 287599),
(481925, 'TIGR01316', NULL, 'gltA: glutamate synthase (NADPH), homotetrameric', 449, NULL, 'TIGR01316', 287600),
(481926, 'TIGR01644', NULL, 'phage_P2_V: phage baseplate assembly protein V', 192, NULL, 'TIGR01644', 287601),
(481927, 'TIGR04373', NULL, 'egtB_X_signatur: EgtB-related enzyme signature domain', 50, NULL, 'TIGR04373', 287602),
(481928, 'TIGR02799', NULL, 'thio_ybgC: tol-pal system-associated acyl-CoA thioesterase', 126, NULL, 'TIGR02799', 287603),
(481929, 'TIGR04205', NULL, 'classIII_w_PIP: class III signal peptide protein, archaeosortase D/PIP-CTERM system', 67, NULL, 'TIGR04205', 287604),
(481930, 'TIGR03801', NULL, 'asp_4_decarbox: aspartate 4-decarboxylase', 521, NULL, 'TIGR03801', 287605);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(481931, 'TIGR00128', NULL, 'fabD: malonyl CoA-acyl carrier protein transacylase', 290, NULL, 'TIGR00128', 287606),
(481932, 'TIGR01715', NULL, 'phage_lam_T: phage tail assembly protein T', 111, NULL, 'TIGR01715', 287607),
(481933, 'TIGR01538', NULL, 'portal_SPP1: phage portal protein, SPP1 family', 426, NULL, 'TIGR01538', 287608),
(481934, 'TIGR00470', NULL, 'sepS: O-phosphoserine--tRNA ligase', 533, NULL, 'TIGR00470', 287609),
(481935, 'TIGR02334', NULL, 'prpF: probable AcnD-accessory protein PrpF', 390, NULL, 'TIGR02334', 287610),
(481936, 'TIGR03489', NULL, 'cas_csp1: CRISPR-associated protein Cas7/Csp1, subtype PGING', 292, NULL, 'TIGR03489', 287611),
(481937, 'TIGR03574', NULL, 'selen_PSTK: L-seryl-tRNA(Sec) kinase', 249, NULL, 'TIGR03574', 287612),
(481938, 'TIGR00791', NULL, 'gntP: transporter, gluconate:H+ symporter (GntP) family', 439, NULL, 'TIGR00791', 287613),
(481939, 'TIGR03253', NULL, 'oxalate_frc: formyl-CoA transferase', 416, NULL, 'TIGR03253', 287614),
(481940, 'TIGR00947', NULL, '2A73: putative bicarbonate transporter, IctB family', 425, NULL, 'TIGR00947', 287615),
(481941, 'TIGR00810', NULL, 'secG: preprotein translocase, SecG subunit', 73, NULL, 'TIGR00810', 287616),
(481942, 'TIGR02228', NULL, 'sigpep_I_arch: signal peptidase I', 158, NULL, 'TIGR02228', 287617),
(481943, 'TIGR03168', NULL, '1-PFK: hexose kinase, 1-phosphofructokinase family', 305, NULL, 'TIGR03168', 287618),
(481944, 'TIGR01958', NULL, 'nuoE_fam: NADH-quinone oxidoreductase, E subunit', 148, NULL, 'TIGR01958', 287619),
(481945, 'TIGR03246', NULL, 'arg_catab_astC: succinylornithine transaminase family', 397, NULL, 'TIGR03246', 287620),
(481946, 'TIGR03461', NULL, 'pabC_Proteo: aminodeoxychorismate lyase', 262, NULL, 'TIGR03461', 287621),
(481947, 'TIGR01198', NULL, 'pgl: 6-phosphogluconolactonase', 234, NULL, 'TIGR01198', 287622),
(481948, 'TIGR02013', NULL, 'rpoB: DNA-directed RNA polymerase, beta subunit', 1238, NULL, 'TIGR02013', 287623),
(481949, 'TIGR00803', NULL, 'nst: UDP-galactose transporter', 222, NULL, 'TIGR00803', 287624),
(481950, 'TIGR03508', NULL, 'decahem_SO: decaheme c-type cytochrome, DmsE family', 258, NULL, 'TIGR03508', 287625),
(481951, 'TIGR01061', NULL, 'parC_Gpos: DNA topoisomerase IV, A subunit', 737, NULL, 'TIGR01061', 287626),
(481952, 'TIGR01965', NULL, 'VCBS_repeat: VCBS repeat', 99, NULL, 'TIGR01965', 287627),
(481953, 'TIGR02478', NULL, '6PF1K_euk: 6-phosphofructokinase', 744, NULL, 'TIGR02478', 287628),
(481954, 'TIGR01401', NULL, 'fliR_like_III: type III secretion apparatus protein SpaR/YscT/HrcT', 253, NULL, 'TIGR01401', 287629),
(481955, 'TIGR02556', NULL, 'cas_TM1802: CRISPR-associated protein, TM1802 family', 571, NULL, 'TIGR02556', 287630),
(481956, 'TIGR02412', NULL, 'pepN_strep_liv: aminopeptidase N', 832, NULL, 'TIGR02412', 287631),
(481957, 'TIGR01637', NULL, 'phage_arpU: phage transcriptional regulator, ArpU family', 136, NULL, 'TIGR01637', 287632),
(481958, 'TIGR02235', NULL, 'menA_cyano-plnt: 1,4-dihydroxy-2-naphthoate phytyltransferase', 285, NULL, 'TIGR02235', 287633),
(481959, 'TIGR01722', NULL, 'MMSDH: methylmalonate-semialdehyde dehydrogenase (acylating)', 477, NULL, 'TIGR01722', 287634),
(481960, 'TIGR02877', NULL, 'spore_yhbH: sporulation protein YhbH', 371, NULL, 'TIGR02877', 287635),
(481961, 'TIGR00692', NULL, 'tdh: L-threonine 3-dehydrogenase', 340, NULL, 'TIGR00692', 287636),
(481962, 'TIGR01721', NULL, 'AMN-like: putative AMP nucleosidase', 269, NULL, 'TIGR01721', 287637),
(481963, 'TIGR02827', NULL, 'RNR_anaer_Bdell: anaerobic ribonucleoside-triphosphate reductase', 596, NULL, 'TIGR02827', 287638),
(481964, 'TIGR01858', NULL, 'tag_bisphos_ald: class II aldolase, tagatose bisphosphate family', 282, NULL, 'TIGR01858', 287639),
(481965, 'TIGR01270', NULL, 'Trp_5_monoox: tryptophan 5-monooxygenase', 464, NULL, 'TIGR01270', 287640),
(481966, 'TIGR02979', NULL, 'phageshock_pspD: phage shock protein PspD', 59, NULL, 'TIGR02979', 287641),
(481967, 'TIGR04419', NULL, 'no_iron_rSAM: HemN-related non-iron pseudo-SAM protein PsgB', 378, NULL, 'TIGR04419', 287642);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(481968, 'TIGR02391', NULL, 'hypoth_ymh: TIGR02391 family protein', 125, NULL, 'TIGR02391', 287643),
(481969, 'TIGR02842', NULL, 'CyoC: cytochrome o ubiquinol oxidase, subunit III', 180, NULL, 'TIGR02842', 287644),
(481970, 'TIGR00424', NULL, 'APS_reduc: 5''-adenylylsulfate reductase, thioredoxin-independent', 464, NULL, 'TIGR00424', 287645),
(481971, 'TIGR02048', NULL, 'gshA_cyano: putative glutamate--cysteine ligase', 376, NULL, 'TIGR02048', 287646),
(481972, 'TIGR03032', NULL, 'TIGR03032: TIGR03032 family protein', 335, NULL, 'TIGR03032', 287647),
(481973, 'TIGR01551', NULL, 'major_capsid_P2: phage major capsid protein, P2 family', 326, NULL, 'TIGR01551', 287648),
(481974, 'TIGR02344', NULL, 'chap_CCT_gamma: T-complex protein 1, gamma subunit', 526, NULL, 'TIGR02344', 287649),
(481975, 'TIGR04249', NULL, 'SCM_chp_ScmC: SynChlorMet cassette protein ScmC', 292, NULL, 'TIGR04249', 287650),
(481976, 'TIGR00471', NULL, 'pheT_arch: phenylalanine--tRNA ligase, beta subunit', 551, NULL, 'TIGR00471', 287651),
(481977, 'TIGR00922', NULL, 'nusG: transcription termination/antitermination factor NusG', 172, NULL, 'TIGR00922', 287652),
(481978, 'TIGR03143', NULL, 'AhpF_homolog: putative alkyl hydroperoxide reductase F subunit', 555, NULL, 'TIGR03143', 287653),
(481979, 'TIGR00084', NULL, 'ruvA: Holliday junction DNA helicase RuvA', 192, NULL, 'TIGR00084', 287654),
(481980, 'TIGR02063', NULL, 'RNase_R: ribonuclease R', 711, NULL, 'TIGR02063', 287655),
(481981, 'TIGR02505', NULL, 'RTPR: ribonucleoside-triphosphate reductase, adenosylcobalamin-dependent', 724, NULL, 'TIGR02505', 287656),
(481982, 'TIGR01217', NULL, 'ac_ac_CoA_syn: acetoacetate-CoA ligase', 652, NULL, 'TIGR01217', 287657),
(481983, 'TIGR03175', NULL, 'AllD: ureidoglycolate dehydrogenase', 349, NULL, 'TIGR03175', 287658),
(481984, 'TIGR00069', NULL, 'hisD: histidinol dehydrogenase', 393, NULL, 'TIGR00069', 287659),
(481985, 'TIGR03667', NULL, 'Rv3369: PPOX class probable F420-dependent enzyme, Rv3369 family', 130, NULL, 'TIGR03667', 287660),
(481986, 'TIGR00239', NULL, '2oxo_dh_E1: oxoglutarate dehydrogenase (succinyl-transferring), E1 component', 931, NULL, 'TIGR00239', 287661),
(481987, 'TIGR01223', NULL, 'Pmev_kin_anim: phosphomevalonate kinase', 185, NULL, 'TIGR01223', 287662),
(481988, 'TIGR03339', NULL, 'phn_lysR: aminoethylphosphonate catabolism associated LysR family transcriptional regulator', 279, NULL, 'TIGR03339', 287663),
(481989, 'TIGR01688', NULL, 'dltC: D-alanine--poly(phosphoribitol) ligase, subunit 2', 73, NULL, 'TIGR01688', 287664),
(481990, 'TIGR00913', NULL, '2A0310: amino acid permease (yeast)', 480, NULL, 'TIGR00913', 287665),
(481991, 'TIGR03673', NULL, 'uL14_arch: 50S ribosomal protein uL14', 131, NULL, 'TIGR03673', 287666),
(481992, 'TIGR03169', NULL, 'Nterm_to_SelD: pyridine nucleotide-disulfide oxidoreductase family protein', 365, NULL, 'TIGR03169', 287667),
(481993, 'TIGR02335', NULL, 'hydr_PhnA: phosphonoacetate hydrolase', 408, NULL, 'TIGR02335', 287668),
(481994, 'TIGR01214', NULL, 'rmlD: dTDP-4-dehydrorhamnose reductase', 285, NULL, 'TIGR01214', 287669),
(481995, 'TIGR01366', NULL, 'serC_3: putative phosphoserine aminotransferase', 361, NULL, 'TIGR01366', 287670),
(481996, 'TIGR01712', NULL, 'phage_N6A_met: phage N-6-adenine-methyltransferase', 165, NULL, 'TIGR01712', 287671),
(481997, 'TIGR02350', NULL, 'prok_dnaK: chaperone protein DnaK', 596, NULL, 'TIGR02350', 287672),
(481998, 'TIGR01849', NULL, 'PHB_depoly_PhaZ: polyhydroxyalkanoate depolymerase, intracellular', 406, NULL, 'TIGR01849', 287673),
(481999, 'TIGR01694', NULL, 'MTAP: methylthioadenosine phosphorylase', 240, NULL, 'TIGR01694', 287674),
(482000, 'TIGR02487', NULL, 'NrdD: anaerobic ribonucleoside-triphosphate reductase', 581, NULL, 'TIGR02487', 287675),
(482001, 'TIGR02833', NULL, 'spore_III_AB: stage III sporulation protein AB', 170, NULL, 'TIGR02833', 287676),
(482002, 'TIGR01419', NULL, 'nitro_reg_IIA: PTS IIA-like nitrogen-regulatory protein PtsN', 145, NULL, 'TIGR01419', 287677),
(482003, 'TIGR03471', NULL, 'HpnJ: hopanoid biosynthesis associated radical SAM protein HpnJ', 472, NULL, 'TIGR03471', 287678);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(482004, 'TIGR03202', NULL, 'pucB: xanthine dehydrogenase accessory protein pucB', 192, NULL, 'TIGR03202', 287679),
(482005, 'TIGR01319', NULL, 'glmL_fam: conserved hypothetical protein', 456, NULL, 'TIGR01319', 287680),
(482006, 'TIGR02403', NULL, 'trehalose_treC: alpha,alpha-phosphotrehalase', 544, NULL, 'TIGR02403', 287681),
(482007, 'TIGR01196', NULL, 'edd: phosphogluconate dehydratase', 601, NULL, 'TIGR01196', 287682),
(482008, 'TIGR04370', NULL, 'glyco_rpt_poly: oligosaccharide repeat unit polymerase', 396, NULL, 'TIGR04370', 287683),
(482009, 'TIGR03682', NULL, 'arCOG04112: diphthamide biosynthesis enzyme Dph2', 308, NULL, 'TIGR03682', 287684),
(482010, 'TIGR03178', NULL, 'allantoinase: allantoinase', 441, NULL, 'TIGR03178', 287685),
(482011, 'TIGR01510', NULL, 'coaD_prev_kdtB: pantetheine-phosphate adenylyltransferase', 155, NULL, 'TIGR01510', 287686),
(482012, 'TIGR00963', NULL, 'secA: preprotein translocase, SecA subunit', 787, NULL, 'TIGR00963', 287687),
(482013, 'TIGR02546', NULL, 'III_secr_ATP: type III secretion apparatus H+-transporting two-sector ATPase', 423, NULL, 'TIGR02546', 287688),
(482014, 'TIGR03184', NULL, 'DNA_S_dndE: DNA sulfur modification protein DndE', 104, NULL, 'TIGR03184', 287689),
(482015, 'TIGR01149', NULL, 'mtrG: tetrahydromethanopterin S-methyltransferase, subunit G', 70, NULL, 'TIGR01149', 287690),
(482016, 'TIGR00152', NULL, 'TIGR00152: dephospho-CoA kinase', 188, NULL, 'TIGR00152', 287691),
(482017, 'TIGR03530', NULL, 'GldJ_short: gliding motility-associated lipoprotein GldJ', 396, NULL, 'TIGR03530', 287692),
(482018, 'TIGR01012', NULL, 'uS2_euk_arch: ribosomal protein uS2', 196, NULL, 'TIGR01012', 287693),
(482019, 'TIGR02874', NULL, 'spore_ytfJ: sporulation protein YtfJ', 125, NULL, 'TIGR02874', 287694),
(482020, 'TIGR01208', NULL, 'rmlA_long: glucose-1-phosphate thymidylyltransferase', 353, NULL, 'TIGR01208', 287695),
(482021, 'TIGR03190', NULL, 'benz_CoA_bzdN: benzoyl-CoA reductase, bzd-type, N subunit', 377, NULL, 'TIGR03190', 287696),
(482022, 'TIGR02016', NULL, 'BchX: chlorophyllide reductase iron protein subunit X', 296, NULL, 'TIGR02016', 287697),
(482023, 'TIGR03524', NULL, 'GldJ: gliding motility-associated lipoprotein GldJ', 559, NULL, 'TIGR03524', 287698),
(482024, 'TIGR01706', NULL, 'NAPA: periplasmic nitrate reductase, large subunit', 830, NULL, 'TIGR01706', 287699),
(482025, 'TIGR01647', NULL, 'ATPase-IIIA_H: plasma-membrane proton-efflux P-type ATPase', 755, NULL, 'TIGR01647', 287700),
(482026, 'TIGR02985', NULL, 'Sig70_bacteroi1: RNA polymerase sigma-70 factor, Bacteroides expansion family 1', 162, NULL, 'TIGR02985', 287701),
(482027, 'TIGR04364', NULL, 'methyltran_FxLD: methyltransferase, FxLD system', 394, NULL, 'TIGR04364', 287702),
(482028, 'TIGR03878', NULL, 'thermo_KaiC_2: KaiC domain protein, AF_0795 family', 259, NULL, 'TIGR03878', 287703),
(482029, 'TIGR03741', NULL, 'PRTRC_E: PRTRC system protein E', 106, NULL, 'TIGR03741', 287704),
(482030, 'TIGR02774', NULL, 'rexB_recomb: ATP-dependent nuclease subunit B', 1076, NULL, 'TIGR02774', 287705),
(482031, 'TIGR01428', NULL, 'HAD_type_II: haloacid dehalogenase, type II', 197, NULL, 'TIGR01428', 287706),
(482032, 'TIGR01808', NULL, 'CM_M_hiGC-arch: chorismate mutase', 74, NULL, 'TIGR01808', 287707),
(482033, 'TIGR02446', NULL, 'FadI: acetyl-CoA C-acyltransferase FadI', 430, NULL, 'TIGR02446', 287708),
(482034, 'TIGR03913', NULL, 'rad_SAM_trio: Y_X(10)_GDL-associated radical SAM protein', 477, NULL, 'TIGR03913', 287709),
(482035, 'TIGR00028', NULL, 'Mtu_PIN_fam: toxin-antitoxin system PIN domain toxin', 143, NULL, 'TIGR00028', 287710),
(482036, 'TIGR04036', NULL, 'LLM_CE1758_fam: putative luciferase-like monooxygenase, FMN-dependent, CE1758 family', 355, NULL, 'TIGR04036', 287711),
(482037, 'TIGR00289', NULL, 'TIGR00289: TIGR00289 family protein', 222, NULL, 'TIGR00289', 287712),
(482038, 'TIGR02444', NULL, 'TIGR02444: TIGR02444 family protein', 116, NULL, 'TIGR02444', 287713),
(482039, 'TIGR03599', NULL, 'YloV: DAK2 domain fusion protein YloV', 530, NULL, 'TIGR03599', 287714),
(482040, 'TIGR03243', NULL, 'arg_catab_AOST: arginine and ornithine succinyltransferase subunits', 335, NULL, 'TIGR03243', 287715);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(482041, 'TIGR01638', NULL, 'Atha_cystat_rel: Arabidopsis thaliana cystatin-related protein', 94, NULL, 'TIGR01638', 287716),
(482042, 'TIGR01756', NULL, 'LDH_protist: lactate dehydrogenase', 313, NULL, 'TIGR01756', 287717),
(482043, 'TIGR03415', NULL, 'ABC_choXWV_ATP: choline ABC transporter, ATP-binding protein', 382, NULL, 'TIGR03415', 287718),
(482044, 'TIGR04398', NULL, 'SLAP_DUP: SLAP domain', 125, NULL, 'TIGR04398', 287719),
(482045, 'TIGR02493', NULL, 'PFLA: pyruvate formate-lyase 1-activating enzyme', 235, NULL, 'TIGR02493', 287720),
(482046, 'TIGR00075', NULL, 'hypD: hydrogenase expression/formation protein HypD', 372, NULL, 'TIGR00075', 287721),
(482047, 'TIGR00526', NULL, 'folB_dom: FolB domain', 122, NULL, 'TIGR00526', 287722),
(482048, 'TIGR00629', NULL, 'uvde: UV damage endonuclease UvdE', 312, NULL, 'TIGR00629', 287723),
(482049, 'TIGR02555', NULL, 'OrgA_MxiK: type III secretion apparatus protein OrgA/MxiK', 185, NULL, 'TIGR02555', 287724),
(482050, 'TIGR01121', NULL, 'D_amino_aminoT: D-amino-acid transaminase', 276, NULL, 'TIGR01121', 287725),
(482051, 'TIGR03571', NULL, 'lucif_BA3436: luciferase-type oxidoreductase, BA3436 family', 304, NULL, 'TIGR03571', 287726),
(482052, 'TIGR02116', NULL, 'toxin_Txe_YoeB: addiction module toxin, Txe/YoeB family', 80, NULL, 'TIGR02116', 287727),
(482053, 'TIGR00193', NULL, 'urease_gam: urease, gamma subunit', 102, NULL, 'TIGR00193', 287728),
(482054, 'TIGR00854', NULL, 'pts-sorbose: PTS system, mannose/fructose/sorbose family, IIB component', 150, NULL, 'TIGR00854', 287729),
(482055, 'TIGR04317', NULL, 'W_rSAM_matur: tungsten cofactor oxidoreducase radical SAM maturase', 349, NULL, 'TIGR04317', 287730),
(482056, 'TIGR02276', NULL, 'beta_rpt_yvtn: 40-residue YVTN family beta-propeller repeat', 42, NULL, 'TIGR02276', 287731),
(482057, 'TIGR02057', NULL, 'PAPS_reductase: phosphoadenosine phosphosulfate reductase', 224, NULL, 'TIGR02057', 287732),
(482058, 'TIGR01917', NULL, 'gly_red_sel_B: glycine reductase, selenoprotein B', 431, NULL, 'TIGR01917', 287733),
(482059, 'TIGR04261', NULL, 'rSAM_GlyRichRpt: radical SAM/SPASM domain protein, GRRM system', 363, NULL, 'TIGR04261', 287734),
(482060, 'TIGR01475', NULL, 'ubiA_other: putative 4-hydroxybenzoate polyprenyltransferase', 282, NULL, 'TIGR01475', 287735),
(482061, 'TIGR01501', NULL, 'MthylAspMutase: methylaspartate mutase, S subunit', 134, NULL, 'TIGR01501', 287736),
(482062, 'TIGR01796', NULL, 'CM_mono_aroH: chorismate mutase', 117, NULL, 'TIGR01796', 287737),
(482063, 'TIGR00641', NULL, 'acid_CoA_mut_N: methylmalonyl-CoA mutase N-terminal domain', 528, NULL, 'TIGR00641', 287738),
(482064, 'TIGR01317', NULL, 'GOGAT_sm_gam: glutamate synthase, NADH/NADPH, small subunit', 485, NULL, 'TIGR01317', 287739),
(482065, 'TIGR01747', NULL, 'diampropi_NH3ly: diaminopropionate ammonia-lyase family', 376, NULL, 'TIGR01747', 287740),
(482066, 'TIGR01610', NULL, 'phage_O_Nterm: phage replication protein O, N-terminal domain', 95, NULL, 'TIGR01610', 287741),
(482067, 'TIGR00778', NULL, 'ahpD_dom: alkylhydroperoxidase AhpD family core domain', 51, NULL, 'TIGR00778', 287742),
(482068, 'TIGR02765', NULL, 'crypto_DASH: cryptochrome, DASH family', 431, NULL, 'TIGR02765', 287743),
(482069, 'TIGR01298', NULL, 'RNaseT: ribonuclease T', 200, NULL, 'TIGR01298', 287744),
(482070, 'TIGR02300', NULL, 'FYDLN_acid: TIGR02300 family protein', 129, NULL, 'TIGR02300', 287745),
(482071, 'TIGR02437', NULL, 'FadB: fatty oxidation complex, alpha subunit FadB', 714, NULL, 'TIGR02437', 287746),
(482072, 'TIGR02883', NULL, 'spore_cwlD: N-acetylmuramoyl-L-alanine amidase CwlD', 189, NULL, 'TIGR02883', 287747),
(482073, 'TIGR04270', NULL, 'Rama_corrin_act: methylamine methyltransferase corrinoid protein reductive activase', 534, NULL, 'TIGR04270', 287748),
(482074, 'TIGR02614', NULL, 'ftsW: cell division protein FtsW', 357, NULL, 'TIGR02614', 287749),
(482075, 'TIGR03075', NULL, 'PQQ_enz_alc_DH: PQQ-dependent dehydrogenase, methanol/ethanol family', 530, NULL, 'TIGR03075', 287750),
(482076, 'TIGR00143', NULL, 'hypF: carbamoyltransferase HypF', 741, NULL, 'TIGR00143', 287751);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(482077, 'TIGR00573', NULL, 'dnaq: exonuclease, DNA polymerase III, epsilon subunit family', 217, NULL, 'TIGR00573', 287752),
(482078, 'TIGR01815', NULL, 'TrpE-clade3: anthranilate synthase', 717, NULL, 'TIGR01815', 287753),
(482079, 'TIGR03389', NULL, 'laccase: laccase', 539, NULL, 'TIGR03389', 287754),
(482080, 'TIGR02007', NULL, 'fdx_isc: ferredoxin, 2Fe-2S type, ISC system', 110, NULL, 'TIGR02007', 287755),
(482081, 'TIGR00691', NULL, 'spoT_relA: RelA/SpoT family protein', 687, NULL, 'TIGR00691', 287756),
(482082, 'TIGR04308', NULL, 'repeat_SSSPR51: surface protein repeat SSSPR-51', 49, NULL, 'TIGR04308', 287757),
(482083, 'TIGR01114', NULL, 'mtrH: N5-methyltetrahydromethanopterin:coenzyme M methyltransferase subunit H', 314, NULL, 'TIGR01114', 287758),
(482084, 'TIGR03769', NULL, 'P_ac_wall_RPT: actinobacterial surface-anchored protein domain', 41, NULL, 'TIGR03769', 287759),
(482085, 'TIGR02385', NULL, 'RelE_StbE: addiction module toxin, RelE/StbE family', 88, NULL, 'TIGR02385', 287760),
(482086, 'TIGR02935', NULL, 'TIGR02935: probable nitrogen fixation protein', 140, NULL, 'TIGR02935', 287761),
(482087, 'TIGR03580', NULL, 'EF_0832: conserved hypothetical protein EF_0832/AHA_3913', 257, NULL, 'TIGR03580', 287762),
(482088, 'TIGR03960', NULL, 'rSAM_fuse_unch: radical SAM family uncharacterized protein', 605, NULL, 'TIGR03960', 287763),
(482089, 'TIGR01258', NULL, 'pgm_1: phosphoglycerate mutase 1 family', 245, NULL, 'TIGR01258', 287764),
(482090, 'TIGR03134', NULL, 'malonate_gamma: biotin-independent malonate decarboxylase, gamma subunit', 258, NULL, 'TIGR03134', 287765),
(482091, 'TIGR03252', NULL, 'TIGR03252: uncharacterized HhH-GPD family protein', 189, NULL, 'TIGR03252', 287766),
(482092, 'TIGR03632', NULL, 'uS11_bact: ribosomal protein uS11', 117, NULL, 'TIGR03632', 287767),
(482093, 'TIGR01749', NULL, 'fabA: beta-hydroxyacyl-(acyl-carrier-protein) dehydratase FabA', 169, NULL, 'TIGR01749', 287768),
(482094, 'TIGR04296', NULL, 'PEFG-CTERM: PEFG-CTERM domain', 30, NULL, 'TIGR04296', 287769),
(482095, 'TIGR03462', NULL, 'CarR_dom_SF: lycopene cyclase domain', 89, NULL, 'TIGR03462', 287770),
(482096, 'TIGR03141', NULL, 'cytochro_ccmD: heme exporter protein CcmD', 47, NULL, 'TIGR03141', 287771),
(482097, 'TIGR03573', NULL, 'WbuX: N-acetyl sugar amidotransferase', 344, NULL, 'TIGR03573', 287772),
(482098, 'TIGR04466', NULL, 'rSAM_BlsE: cytosylglucuronate decarboxylase', 327, NULL, 'TIGR04466', 287773),
(482099, 'TIGR03082', NULL, 'Gneg_AbrB_dup: membrane protein AbrB duplication', 157, NULL, 'TIGR03082', 287774),
(482100, 'TIGR04112', NULL, 'seleno_YedE: putative selenium metabolism protein, YedE family', 337, NULL, 'TIGR04112', 287775),
(482101, 'TIGR00703', NULL, 'TIGR00703: TIGR00703 family protein', 223, NULL, 'TIGR00703', 287776),
(482102, 'TIGR01809', NULL, 'Shik-DH-AROM: shikimate-5-dehydrogenase', 282, NULL, 'TIGR01809', 287777),
(482103, 'TIGR03845', NULL, 'sulfopyru_alph: sulfopyruvate decarboxylase, alpha subunit', 160, NULL, 'TIGR03845', 287778),
(482104, 'TIGR02724', NULL, 'phenyl_P_beta: phenylphosphate carboxylase, beta subunit', 472, NULL, 'TIGR02724', 287779),
(482105, 'TIGR02876', NULL, 'spore_yqfD: sporulation protein YqfD', 382, NULL, 'TIGR02876', 287780),
(482106, 'TIGR03791', NULL, 'TTQ_mauG: tryptophan tryptophylquinone biosynthesis enzyme MauG', 291, NULL, 'TIGR03791', 287781),
(482107, 'TIGR02378', NULL, 'nirD_assim_sml: nitrite reductase [NAD(P)H], small subunit', 105, NULL, 'TIGR02378', 287782),
(482108, 'TIGR01373', NULL, 'soxB: sarcosine oxidase, beta subunit family', 407, NULL, 'TIGR01373', 287783),
(482109, 'TIGR02241', NULL, 'TIGR02241: conserved hypothetical phage tail region protein', 141, NULL, 'TIGR02241', 287784),
(482110, 'TIGR01257', NULL, 'rim_protein: rim ABC transporter', 2272, NULL, 'TIGR01257', 287785),
(482111, 'TIGR01120', NULL, 'rpiB: ribose 5-phosphate isomerase B', 143, NULL, 'TIGR01120', 287786),
(482112, 'TIGR02226', NULL, 'two_anch: N-terminal double-transmembrane domain', 82, NULL, 'TIGR02226', 287787),
(482113, 'TIGR00804', NULL, 'nupC: nucleoside transporter, NupC family', 401, NULL, 'TIGR00804', 287788);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(482114, 'TIGR03517', NULL, 'GldM_gliding: gliding motility-associated protein GldM', 524, NULL, 'TIGR03517', 287789),
(482115, 'TIGR04432', NULL, 'rSAM_Cfr: 23S rRNA (adenine(2503)-C(8))-methyltransferase Cfr', 341, NULL, 'TIGR04432', 287790),
(482116, 'TIGR03019', NULL, 'pepcterm_femAB: FemAB-related protein, PEP-CTERM system-associated', 330, NULL, 'TIGR03019', 287791),
(482117, 'TIGR00205', NULL, 'fliE: flagellar hook-basal body complex protein FliE', 109, NULL, 'TIGR00205', 287792),
(482118, 'TIGR00321', NULL, 'dhys: deoxyhypusine synthase', 301, NULL, 'TIGR00321', 287793),
(482119, 'TIGR02172', NULL, 'Fb_sc_TIGR02172: fibrobacter succinogenes paralogous family TIGR02172', 226, NULL, 'TIGR02172', 287794),
(482120, 'TIGR03081', NULL, 'metmalonyl_epim: methylmalonyl-CoA epimerase', 129, NULL, 'TIGR03081', 287795),
(482121, 'TIGR03523', NULL, 'GldN: gliding motility associated protein GldN', 280, NULL, 'TIGR03523', 287796),
(482122, 'TIGR00533', NULL, 'HMG_CoA_R_NADP: hydroxymethylglutaryl-CoA reductase (NADPH)', 402, NULL, 'TIGR00533', 287797),
(482123, 'TIGR00956', NULL, '3a01205: pleiotropic drug resistance family protein', 1394, NULL, 'TIGR00956', 287798),
(482124, 'TIGR02649', NULL, 'true_RNase_BN: ribonuclease BN', 304, NULL, 'TIGR02649', 287799),
(482125, 'TIGR00464', NULL, 'gltX_bact: glutamate--tRNA ligase', 470, NULL, 'TIGR00464', 287800),
(482126, 'TIGR02512', NULL, 'FeFe_hydrog_A: [FeFe] hydrogenase, group A', 375, NULL, 'TIGR02512', 287801),
(482127, 'TIGR00458', NULL, 'aspS_nondisc: aspartate--tRNA(Asn) ligase', 428, NULL, 'TIGR00458', 287802),
(482128, 'TIGR03025', NULL, 'EPS_sugtrans: exopolysaccharide biosynthesis polyprenyl glycosylphosphotransferase', 445, NULL, 'TIGR03025', 287803),
(482129, 'TIGR00792', NULL, 'gph: sugar (Glycoside-Pentoside-Hexuronide) transporter', 437, NULL, 'TIGR00792', 287804),
(482130, 'TIGR02718', NULL, 'sider_RhtX_FptX: siderophore transporter, RhtX/FptX family', 390, NULL, 'TIGR02718', 287805),
(482131, 'TIGR03293', NULL, 'PhnG_redo: phosphonate C-P lyase system protein PhnG', 144, NULL, 'TIGR03293', 287806),
(482132, 'TIGR04569', NULL, 'arch_SelU_Cterm: selenouridine synthase, SelU C-terminal-like subunit', 217, NULL, 'TIGR04569', 287807),
(482133, 'TIGR02014', NULL, 'BchZ: chlorophyllide reductase subunit Z', 468, NULL, 'TIGR02014', 287808),
(482134, 'TIGR03729', NULL, 'acc_ester: putative phosphoesterase', 239, NULL, 'TIGR03729', 287809),
(482135, 'TIGR00962', NULL, 'atpA: ATP synthase F1, alpha subunit', 503, NULL, 'TIGR00962', 287810),
(482136, 'TIGR00211', NULL, 'glyS: glycine--tRNA ligase, beta subunit', 691, NULL, 'TIGR00211', 287811),
(482137, 'TIGR03353', NULL, 'VI_chp_4: type VI secretion protein, VC_A0114 family', 442, NULL, 'TIGR03353', 287812),
(482138, 'TIGR01367', NULL, 'pyrE_Therm: orotate phosphoribosyltransferase', 187, NULL, 'TIGR01367', 287813),
(482139, 'TIGR02384', NULL, 'RelB_DinJ: addiction module antitoxin, RelB/DinJ family', 85, NULL, 'TIGR02384', 287814),
(482140, 'TIGR01469', NULL, 'cobA_cysG_Cterm: uroporphyrinogen-III C-methyltransferase', 238, NULL, 'TIGR01469', 287815),
(482141, 'TIGR01332', NULL, 'cyt_b559_alpha: cytochrome b559, alpha subunit', 80, NULL, 'TIGR01332', 287816),
(482142, 'TIGR00348', NULL, 'hsdR: type I site-specific deoxyribonuclease, HsdR family', 674, NULL, 'TIGR00348', 287817),
(482143, 'TIGR01161', NULL, 'purK: phosphoribosylaminoimidazole carboxylase, ATPase subunit', 362, NULL, 'TIGR01161', 287818),
(482144, 'TIGR03988', NULL, 'antisig_RsrA: mycothiol system anti-sigma-R factor', 77, NULL, 'TIGR03988', 287819),
(482145, 'TIGR00362', NULL, 'DnaA: chromosomal replication initiator protein DnaA', 437, NULL, 'TIGR00362', 287820),
(482146, 'TIGR04221', NULL, 'SecA2_Mycobac: accessory Sec system translocase SecA2', 762, NULL, 'TIGR04221', 287821),
(482147, 'TIGR01967', NULL, 'DEAH_box_HrpA: RNA helicase HrpA', 1284, NULL, 'TIGR01967', 287822),
(482148, 'TIGR03558', NULL, 'oxido_grp_1: luciferase family oxidoreductase, group 1', 325, NULL, 'TIGR03558', 287823),
(482149, 'TIGR03237', NULL, 'dnd_assoc_2: DNA phosphorothioation-dependent restriction protein DptH', 1256, NULL, 'TIGR03237', 287824);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(482150, 'TIGR04542', NULL, 'GMC_mycofac_2: GMC family mycofactocin-associated oxidreductase', 425, NULL, 'TIGR04542', 287825),
(482151, 'TIGR02506', NULL, 'NrdE_NrdA: ribonucleoside-diphosphate reductase, alpha subunit', 616, NULL, 'TIGR02506', 287826),
(482152, 'TIGR04357', NULL, 'CofD_rel_GAK: CofD-related protein, GAK system', 368, NULL, 'TIGR04357', 287827),
(482153, 'TIGR00041', NULL, 'DTMP_kinase: dTMP kinase', 196, NULL, 'TIGR00041', 287828),
(482154, 'TIGR01797', NULL, 'CM_P_1: chorismate mutase', 83, NULL, 'TIGR01797', 287829),
(482155, 'TIGR01039', NULL, 'atpD: ATP synthase F1, beta subunit', 462, NULL, 'TIGR01039', 287830),
(482156, 'TIGR01981', NULL, 'sufD: FeS assembly protein SufD', 275, NULL, 'TIGR01981', 287831),
(482157, 'TIGR00034', NULL, 'aroFGH: 3-deoxy-7-phosphoheptulonate synthase', 342, NULL, 'TIGR00034', 287832),
(482158, 'TIGR02166', NULL, 'dmsA_ynfE: anaerobic dimethyl sulfoxide reductase, A subunit, DmsA/YnfE family', 794, NULL, 'TIGR02166', 287833),
(482159, 'TIGR00997', NULL, 'ispZ: intracellular septation protein A', 178, NULL, 'TIGR00997', 287834),
(482160, 'TIGR02992', NULL, 'ectoine_eutC: ectoine utilization protein EutC', 326, NULL, 'TIGR02992', 287835),
(482161, 'TIGR04187', NULL, 'GRASP_SAV_5884: ATP-grasp ribosomal peptide maturase, SAV_5884 family', 312, NULL, 'TIGR04187', 287836),
(482162, 'TIGR04050', NULL, 'MSMEG_0567_Cter: AIR synthase-related protein, MSMEG_0567 C-terminal family', 296, NULL, 'TIGR04050', 287837),
(482163, 'TIGR01529', NULL, 'argR_whole: arginine repressor', 146, NULL, 'TIGR01529', 287838),
(482164, 'TIGR04214', NULL, 'CSLREA_Nterm: CSLREA domain', 27, NULL, 'TIGR04214', 287839),
(482165, 'TIGR00532', NULL, 'HMG_CoA_R_NAD: hydroxymethylglutaryl-CoA reductase, degradative', 395, NULL, 'TIGR00532', 287840),
(482166, 'TIGR01045', NULL, 'RPE1: rickettsial palindromic element RPE1 domain', 48, NULL, 'TIGR01045', 287841),
(482167, 'TIGR00669', NULL, 'asnA: aspartate--ammonia ligase', 330, NULL, 'TIGR00669', 287842),
(482168, 'TIGR04358', NULL, 'XXXCH_domain: XXXCH domain', 90, NULL, 'TIGR04358', 287843),
(482169, 'TIGR02494', NULL, 'PFLE_PFLC: glycyl-radical enzyme activating protein', 293, NULL, 'TIGR02494', 287844),
(482170, 'TIGR01830', NULL, '3oxo_ACP_reduc: 3-oxoacyl-[acyl-carrier-protein] reductase', 239, NULL, 'TIGR01830', 287845),
(482171, 'TIGR03851', NULL, 'chitin_NgcE: carbohydrate ABC transporter, N-acetylglucosamine/diacetylchitobiose-binding protein', 450, NULL, 'TIGR03851', 287846),
(482172, 'TIGR00499', NULL, 'lysS_bact: lysine--tRNA ligase', 496, NULL, 'TIGR00499', 287847),
(482173, 'TIGR04528', NULL, 'acido_non_PQQ: acido-empty-quinoprotein group A', 493, NULL, 'TIGR04528', 287848),
(482174, 'TIGR00676', NULL, 'fadh2: methylenetetrahydrofolate reductase [NAD(P)H]', 275, NULL, 'TIGR00676', 287849),
(482175, 'TIGR00178', NULL, 'monomer_idh: isocitrate dehydrogenase, NADP-dependent', 744, NULL, 'TIGR00178', 287850),
(482176, 'TIGR01660', NULL, 'narH: nitrate reductase, beta subunit', 492, NULL, 'TIGR01660', 287851),
(482177, 'TIGR02664', NULL, 'nitr_red_assoc: conserved hypothetical protein', 145, NULL, 'TIGR02664', 287852),
(482178, 'TIGR04220', NULL, 'patB_acyB_mcaB: cyanobactin biosynthesis protein, PatB/AcyB/McaB family', 61, NULL, 'TIGR04220', 287853),
(482179, 'TIGR04330', NULL, 'cas_Cpf1: CRISPR-associated protein Cpf1, subtype PREFRAN', 1288, NULL, 'TIGR04330', 287854),
(482180, 'TIGR03312', NULL, 'Se_sel_red_FAD: probable selenate reductase, FAD-binding subunit', 257, NULL, 'TIGR03312', 287855),
(482181, 'TIGR03449', NULL, 'mycothiol_MshA: D-inositol-3-phosphate glycosyltransferase', 406, NULL, 'TIGR03449', 287856),
(482182, 'TIGR04467', NULL, 'CGA_synthase: hydroxymethylcytosylglucuronate/cytosylglucuronate synthase', 382, NULL, 'TIGR04467', 287857),
(482183, 'TIGR00253', NULL, 'RNA_bind_YhbY: putative RNA-binding protein, YhbY family', 96, NULL, 'TIGR00253', 287858),
(482184, 'TIGR02929', NULL, 'anfG_nitrog: Fe-only nitrogenase, delta subunit', 109, NULL, 'TIGR02929', 287859),
(482185, 'TIGR01653', NULL, 'lactococcin_972: bacteriocin, lactococcin 972 family', 97, NULL, 'TIGR01653', 287860);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(482186, 'TIGR03947', NULL, 'viomycin_VioD: capreomycidine synthase', 359, NULL, 'TIGR03947', 287861),
(482187, 'TIGR01687', NULL, 'moaD_arch: MoaD family protein', 88, NULL, 'TIGR01687', 287862),
(482188, 'TIGR00888', NULL, 'guaA_Nterm: GMP synthase (glutamine-hydrolyzing), N-terminal domain', 188, NULL, 'TIGR00888', 287863),
(482189, 'TIGR01052', NULL, 'top6b: DNA topoisomerase VI, B subunit', 488, NULL, 'TIGR01052', 287864),
(482190, 'TIGR02070', NULL, 'mono_pep_trsgly: monofunctional biosynthetic peptidoglycan transglycosylase', 224, NULL, 'TIGR02070', 287865),
(482191, 'TIGR00137', NULL, 'gid_trmFO: tRNA:m(5)U-54 methyltransferase', 433, NULL, 'TIGR00137', 287866),
(482192, 'TIGR02901', NULL, 'QoxD: cytochrome aa3 quinol oxidase, subunit IV', 94, NULL, 'TIGR02901', 287867),
(482193, 'TIGR04248', NULL, 'SCM_PqqD_rel: SynChlorMet cassette protein ScmD', 84, NULL, 'TIGR04248', 287868),
(482194, 'TIGR04111', NULL, 'BcepMu_gp16: phage-associated protein, BcepMu gp16 family', 55, NULL, 'TIGR04111', 287869),
(482195, 'TIGR03100', NULL, 'hydr1_PEP: exosortase A system-associated hydrolase 1', 274, NULL, 'TIGR03100', 287870),
(482196, 'TIGR00860', NULL, 'LIC: cation transporter family protein', 462, NULL, 'TIGR00860', 287871),
(482197, 'TIGR04255', NULL, 'sporadTIGR04255: TIGR04255 family protein', 252, NULL, 'TIGR04255', 287872),
(482198, 'TIGR00635', NULL, 'ruvB: Holliday junction DNA helicase RuvB', 305, NULL, 'TIGR00635', 287873),
(482199, 'TIGR01380', NULL, 'glut_syn: glutathione synthase', 312, NULL, 'TIGR01380', 287874),
(482200, 'TIGR04002', NULL, 'TIGR04002: TIGR04002 family protein', 151, NULL, 'TIGR04002', 287875),
(482201, 'TIGR03421', NULL, 'FeS_CyaY: iron donor protein CyaY', 104, NULL, 'TIGR03421', 287876),
(482202, 'TIGR01550', NULL, 'DOC_P1: death-on-curing family protein', 122, NULL, 'TIGR01550', 287877),
(482203, 'TIGR03810', NULL, 'arg_ornith_anti: arginine-ornithine antiporter', 468, NULL, 'TIGR03810', 287878),
(482204, 'TIGR03735', NULL, 'PRTRC_A: PRTRC system protein A', 192, NULL, 'TIGR03735', 287879),
(482205, 'TIGR00779', NULL, 'cad: cadmium resistance transporter family protein', 193, NULL, 'TIGR00779', 287880),
(482206, 'TIGR04500', NULL, 'PpiC_rel_mature: putative peptide maturation system protein', 340, NULL, 'TIGR04500', 287881),
(482207, 'TIGR04078', NULL, 'rSAM_yydG: peptide modification radical SAM enzyme, YydG family', 309, NULL, 'TIGR04078', 287882),
(482208, 'TIGR01762', NULL, 'chlorin-enz: chlorinating enzyme', 288, NULL, 'TIGR01762', 287883),
(482209, 'TIGR02780', NULL, 'TrbJ_Ti: P-type conjugative transfer protein TrbJ', 253, NULL, 'TIGR02780', 287884),
(482210, 'TIGR02282', NULL, 'MltB: lytic murein transglycosylase B', 290, NULL, 'TIGR02282', 287885),
(482211, 'TIGR04323', NULL, 'SpoChoClust_1: sporadic carbohydrate cluster protein, LIC12192 family', 122, NULL, 'TIGR04323', 287886),
(482212, 'TIGR01899', NULL, 'cas_TM1807_csm5: CRISPR type III-A/MTUBE-associated RAMP protein Csm5', 364, NULL, 'TIGR01899', 287887),
(482213, 'TIGR00744', NULL, 'ROK_glcA_fam: ROK family protein (putative glucokinase)', 318, NULL, 'TIGR00744', 287888),
(482214, 'TIGR03305', NULL, 'alt_F1F0_F1_bet: alternate F1F0 ATPase, F1 subunit beta', 449, NULL, 'TIGR03305', 287889),
(482215, 'TIGR03954', NULL, 'integ_memb_HG: integral membrane protein', 85, NULL, 'TIGR03954', 287890),
(482216, 'TIGR03633', NULL, 'arc_protsome_A: proteasome endopeptidase complex, archaeal, alpha subunit', 230, NULL, 'TIGR03633', 287891),
(482217, 'TIGR04146', NULL, 'GGGPS_Afulg: phosphoglycerol geranylgeranyltransferase', 221, NULL, 'TIGR04146', 287892),
(482218, 'TIGR00246', NULL, 'tRNA_RlmH_YbeA: rRNA large subunit m3Psi methyltransferase RlmH', 155, NULL, 'TIGR00246', 287893),
(482219, 'TIGR01918', NULL, 'various_sel_PB: selenoprotein B, glycine/betaine/sarcosine/D-proline reductase family', 431, NULL, 'TIGR01918', 287894),
(482220, 'TIGR03803', NULL, 'Gloeo_Verruco: gloeo_Verruco repeat', 34, NULL, 'TIGR03803', 287895),
(482221, 'TIGR00567', NULL, '3mg: DNA-3-methyladenine glycosylase', 192, NULL, 'TIGR00567', 287896);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(482222, 'TIGR00430', NULL, 'Q_tRNA_tgt: tRNA-guanine transglycosylase', 368, NULL, 'TIGR00430', 287897),
(482223, 'TIGR02608', NULL, 'delta_60_rpt: delta-60 repeat domain', 55, NULL, 'TIGR02608', 287898),
(482224, 'TIGR02117', NULL, 'chp_urease_rgn: conserved hypothetical protein', 208, NULL, 'TIGR02117', 287899),
(482225, 'TIGR02596', NULL, 'TIGR02596: Verru_Chthon cassette protein D', 196, NULL, 'TIGR02596', 287900),
(482226, 'TIGR00423', NULL, 'TIGR00423: radical SAM domain protein, CofH subfamily', 310, NULL, 'TIGR00423', 287901),
(482227, 'TIGR00090', NULL, 'rsfS_iojap_ybeB: ribosome silencing factor', 99, NULL, 'TIGR00090', 287902),
(482228, 'TIGR01441', NULL, 'GPR: GPR endopeptidase', 358, NULL, 'TIGR01441', 287903),
(482229, 'TIGR01578', NULL, 'MiaB-like-B: MiaB-like tRNA modifying enzyme, archaeal-type', 421, NULL, 'TIGR01578', 287904),
(482230, 'TIGR03626', NULL, 'L3_arch: ribosomal protein uL3', 331, NULL, 'TIGR03626', 287905),
(482231, 'TIGR04139', NULL, 'CxxCx5CxxC_targ: putative peptide modification target, TIGR04139 family', 69, NULL, 'TIGR04139', 287906),
(482232, 'TIGR02098', NULL, 'MJ0042_CXXC: MJ0042 family finger-like domain', 38, NULL, 'TIGR02098', 287907),
(482233, 'TIGR02936', NULL, 'fdxN_nitrog: ferredoxin III, nif-specific', 91, NULL, 'TIGR02936', 287908),
(482234, 'TIGR01087', NULL, 'murD: UDP-N-acetylmuramoylalanine--D-glutamate ligase', 441, NULL, 'TIGR01087', 287909),
(482235, 'TIGR00751', NULL, 'menA: 1,4-dihydroxy-2-naphthoate octaprenyltransferase', 284, NULL, 'TIGR00751', 287910),
(482236, 'TIGR02615', NULL, 'spoVE: stage V sporulation protein E', 354, NULL, 'TIGR02615', 287911),
(482237, 'TIGR01264', NULL, 'tyr_amTase_E: tyrosine aminotransferase', 403, NULL, 'TIGR01264', 287912),
(482238, 'TIGR03128', NULL, 'RuMP_HxlA: 3-hexulose-6-phosphate synthase', 206, NULL, 'TIGR03128', 287913),
(482239, 'TIGR03291', NULL, 'methan_mark_17: putative methanogenesis marker protein 17', 185, NULL, 'TIGR03291', 287914),
(482240, 'TIGR00323', NULL, 'eIF-6: putative translation initiation factor eIF-6', 215, NULL, 'TIGR00323', 287915),
(482241, 'TIGR02653', NULL, 'Lon_rel_chp: conserved hypothetical protein', 675, NULL, 'TIGR02653', 287916),
(482242, 'TIGR03171', NULL, 'soxL2: Rieske iron-sulfur protein SoxL2', 321, NULL, 'TIGR03171', 287917),
(482243, 'TIGR00443', NULL, 'hisZ_biosyn_reg: ATP phosphoribosyltransferase, regulatory subunit', 314, NULL, 'TIGR00443', 287918),
(482244, 'TIGR03051', NULL, 'PS_I_psaG_plant: photosystem I reaction center subunit V', 89, NULL, 'TIGR03051', 287919),
(482245, 'TIGR01081', NULL, 'mpl: UDP-N-acetylmuramate:L-alanyl-gamma-D-glutamyl-meso-diaminopimelate ligase', 448, NULL, 'TIGR01081', 287920),
(482246, 'TIGR04503', NULL, 'mft_etfB: electron transfer flavoprotein, mycofactocin-associated', 290, NULL, 'TIGR04503', 287921),
(482247, 'TIGR00563', NULL, 'rsmB: 16S rRNA (cytosine(967)-C(5))-methyltransferase', 437, NULL, 'TIGR00563', 287922),
(482248, 'TIGR02413', NULL, 'Bac_small_yrzI: Bacillus tandem small hypothetical protein', 46, NULL, 'TIGR02413', 287923),
(482249, 'TIGR02966', NULL, 'phoR_proteo: phosphate regulon sensor kinase PhoR', 333, NULL, 'TIGR02966', 287924),
(482250, 'TIGR01394', NULL, 'TypA_BipA: GTP-binding protein TypA/BipA', 594, NULL, 'TIGR01394', 287925),
(482251, 'TIGR00010', NULL, 'TIGR00010: hydrolase, TatD family', 253, NULL, 'TIGR00010', 287926),
(482252, 'TIGR00683', NULL, 'nanA: N-acetylneuraminate lyase', 293, NULL, 'TIGR00683', 287927),
(482253, 'TIGR01766', NULL, 'tspaseT_teng_C: transposase, IS605 OrfB family', 82, NULL, 'TIGR01766', 287928),
(482254, 'TIGR03677', NULL, 'eL8_ribo: ribosomal protein eL8', 117, NULL, 'TIGR03677', 287929),
(482255, 'TIGR03300', NULL, 'assembly_YfgL: outer membrane assembly lipoprotein YfgL', 377, NULL, 'TIGR03300', 287930),
(482256, 'TIGR01587', NULL, 'cas3_core: CRISPR-associated helicase Cas3', 358, NULL, 'TIGR01587', 287931),
(482257, 'TIGR01210', NULL, 'TIGR01210: radical SAM enzyme, TIGR01210 family', 313, NULL, 'TIGR01210', 287932),
(482258, 'TIGR03856', NULL, 'F420_MSMEG_2906: probable F420-dependent oxidoreductase, MSMEG_2906 family', 249, NULL, 'TIGR03856', 287933);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(482259, 'TIGR04494', NULL, 'c550_PedF: cytochrome c-550 PedF', 133, NULL, 'TIGR04494', 287934),
(482260, 'TIGR00130', NULL, 'frhD: coenzyme F420-reducing hydrogenase, FrhD protein', 153, NULL, 'TIGR00130', 287935),
(482261, 'TIGR00949', NULL, '2A76: homoserine/Threonine efflux protein', 185, NULL, 'TIGR00949', 287936),
(482262, 'TIGR02846', NULL, 'spore_sigmaK: RNA polymerase sigma-K factor', 227, NULL, 'TIGR02846', 287937),
(482263, 'TIGR00756', NULL, 'PPR: pentatricopeptide repeat domain', 35, NULL, 'TIGR00756', 287938),
(482264, 'TIGR02220', NULL, 'phg_TIGR02220: phage conserved hypothetical protein, C-terminal domain', 77, NULL, 'TIGR02220', 287939),
(482265, 'TIGR03912', NULL, 'PylS_Nterm: pyrrolysine--tRNA ligase, N-terminal region', 89, NULL, 'TIGR03912', 287940),
(482266, 'TIGR02597', NULL, 'TIGR02597: TIGR02597 family protein', 363, NULL, 'TIGR02597', 287941),
(482267, 'TIGR04310', NULL, 'pantocin_A_pre: pantocin A family RiPP', 29, NULL, 'TIGR04310', 287942),
(482268, 'TIGR01822', NULL, '2am3keto_CoA: glycine C-acetyltransferase', 393, NULL, 'TIGR01822', 287943),
(482269, 'TIGR01333', NULL, 'cyt_b559_beta: cytochrome b559, beta subunit', 43, NULL, 'TIGR01333', 287944),
(482270, 'TIGR01523', NULL, 'ATPase-IID_K-Na: potassium/sodium efflux P-type ATPase, fungal-type', 997, NULL, 'TIGR01523', 287945),
(482271, 'TIGR03663', NULL, 'TIGR03663: TIGR03663 family protein', 435, NULL, 'TIGR03663', 287946),
(482272, 'TIGR01403', NULL, 'fliQ_rel_III: type III secretion protein, HrpO family', 81, NULL, 'TIGR01403', 287947),
(482273, 'TIGR02905', NULL, 'spore_yutH: spore coat protein YutH', 313, NULL, 'TIGR02905', 287948),
(482274, 'TIGR03733', NULL, 'lanti_perm_MutG: lantibiotic protection ABC transporter permease subunit, MutG family', 248, NULL, 'TIGR03733', 287949),
(482275, 'TIGR02161', NULL, 'napC_nirT: periplasmic nitrate (or nitrite) reductase c-type cytochrome, NapC/NirT family', 185, NULL, 'TIGR02161', 287950),
(482276, 'TIGR04181', NULL, 'NHT_00031: aminotransferase, LLPSF_NHT_00031 family', 359, NULL, 'TIGR04181', 287951),
(482277, 'TIGR04371', NULL, 'methyltran_NanM: putative sugar O-methyltransferase', 273, NULL, 'TIGR04371', 287952),
(482278, 'TIGR01693', NULL, 'UTase_glnD: protein-P-II uridylyltransferase', 850, NULL, 'TIGR01693', 287953),
(482279, 'TIGR03543', NULL, 'divI1A_rptt_fam: DivIVA domain repeat protein', 178, NULL, 'TIGR03543', 287954),
(482280, 'TIGR04011', NULL, 'poly_gGlu_PgsC: poly-gamma-glutamate biosynthesis protein PgsC', 132, NULL, 'TIGR04011', 287955),
(482281, 'TIGR03806', NULL, 'chp_HNE_0200: conserved hypothetical protein, HNE_0200 family', 314, NULL, 'TIGR03806', 287956),
(482282, 'TIGR00742', NULL, 'yjbN: tRNA dihydrouridine synthase A', 318, NULL, 'TIGR00742', 287957),
(482283, 'TIGR00622', NULL, 'ssl1: transcription factor ssl1', 112, NULL, 'TIGR00622', 287958),
(482284, 'TIGR04444', NULL, 'chori_FkbO_Hyg5: chorismatase, FkbO/Hyg5 family', 311, NULL, 'TIGR04444', 287959),
(482285, 'TIGR04324', NULL, 'SpoChoClust_2: sporadic carbohydrate cluster 2OG-Fe(II) oxygenase', 248, NULL, 'TIGR04324', 287960),
(482286, 'TIGR01646', NULL, 'vgr_GE: Rhs element Vgr protein', 480, NULL, 'TIGR01646', 287961),
(482287, 'TIGR00264', NULL, 'TIGR00264: alpha-NAC homolog', 116, NULL, 'TIGR00264', 287962),
(482288, 'TIGR03230', NULL, 'lipo_lipase: lipoprotein lipase', 442, NULL, 'TIGR03230', 287963),
(482289, 'TIGR03420', NULL, 'DnaA_homol_Hda: DnaA regulatory inactivator Hda', 226, NULL, 'TIGR03420', 287964),
(482290, 'TIGR01836', NULL, 'PHA_synth_III_C: poly(R)-hydroxyalkanoic acid synthase, class III, PhaC subunit', 350, NULL, 'TIGR01836', 287965),
(482291, 'TIGR02041', NULL, 'CysI: sulfite reductase (NADPH) hemoprotein, beta-component', 541, NULL, 'TIGR02041', 287966),
(482292, 'TIGR04195', NULL, 'S_glycosyl_SunS: peptide S-glycosyltransferase, SunS family', 421, NULL, 'TIGR04195', 287967),
(482293, 'TIGR03007', NULL, 'pepcterm_ChnLen: polysaccharide chain length determinant protein, PEP-CTERM locus subfamily', 498, NULL, 'TIGR03007', 287968),
(482294, 'TIGR00996', NULL, 'Mtu_fam_mce: virulence factor Mce family protein', 291, NULL, 'TIGR00996', 287969);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(482295, 'TIGR02100', NULL, 'glgX_debranch: glycogen debranching enzyme GlgX', 688, NULL, 'TIGR02100', 287970),
(482296, 'TIGR00027', NULL, 'mthyl_TIGR00027: methyltransferase, TIGR00027 family', 259, NULL, 'TIGR00027', 287971),
(482297, 'TIGR01274', NULL, 'ACC_deam: 1-aminocyclopropane-1-carboxylate deaminase', 337, NULL, 'TIGR01274', 287972),
(482298, 'TIGR02776', NULL, 'NHEJ_ligase_prk: DNA ligase D', 587, NULL, 'TIGR02776', 287973),
(482299, 'TIGR01260', NULL, 'ATP_synt_c: ATP synthase F0, C subunit', 58, NULL, 'TIGR01260', 287974),
(482300, 'TIGR00636', NULL, 'PduO_Nterm: ATP:cob(I)alamin adenosyltransferase', 171, NULL, 'TIGR00636', 287975),
(482301, 'TIGR04430', NULL, 'OM_asym_MlaD: outer membrane lipid asymmetry maintenance protein MlaD', 146, NULL, 'TIGR04430', 287976),
(482302, 'TIGR00250', NULL, 'RNAse_H_YqgF: putative transcription antitermination factor YqgF', 130, NULL, 'TIGR00250', 287977),
(482303, 'TIGR02284', NULL, 'TIGR02284: conserved hypothetical protein', 139, NULL, 'TIGR02284', 287978),
(482304, 'TIGR02474', NULL, 'pec_lyase: pectate lyase', 295, NULL, 'TIGR02474', 287979),
(482305, 'TIGR03498', NULL, 'FliI_clade3: flagellar protein export ATPase FliI', 418, NULL, 'TIGR03498', 287980),
(482306, 'TIGR03976', NULL, 'chp_LLNDYxLRE: His-Xaa-Ser system protein HxsD', 90, NULL, 'TIGR03976', 287981),
(482307, 'TIGR00191', NULL, 'thrB: homoserine kinase', 304, NULL, 'TIGR00191', 287982),
(482308, 'TIGR02533', NULL, 'type_II_gspE: type II secretion system protein E', 486, NULL, 'TIGR02533', 287983),
(482309, 'TIGR01825', NULL, 'gly_Cac_T_rel: putative pyridoxal phosphate-dependent acyltransferase', 385, NULL, 'TIGR01825', 287984),
(482310, 'TIGR02463', NULL, 'MPGP_rel: mannosyl-3-phosphoglycerate phosphatase homolog', 216, NULL, 'TIGR02463', 287985),
(482311, 'TIGR01945', NULL, 'rnfC: electron transport complex, RnfABCDGE type, C subunit', 435, NULL, 'TIGR01945', 287986),
(482312, 'TIGR02723', NULL, 'phenyl_P_alpha: phenylphosphate carboxylase, alpha subunit', 485, NULL, 'TIGR02723', 287987),
(482313, 'TIGR03915', NULL, 'SAM_7_link_chp: probable DNA metabolism protein', 243, NULL, 'TIGR03915', 287988),
(482314, 'TIGR01031', NULL, 'rpmF_bact: ribosomal protein bL32', 56, NULL, 'TIGR01031', 287989),
(482315, 'TIGR04553', NULL, 'ABC_peri_selen: putative selenate ABC transporter periplasmic binding protein', 266, NULL, 'TIGR04553', 287990),
(482316, 'TIGR03554', NULL, 'F420_G6P_DH: glucose-6-phosphate dehydrogenase (coenzyme-F420)', 331, NULL, 'TIGR03554', 287991),
(482317, 'TIGR02390', NULL, 'RNA_pol_rpoA1: DNA-directed RNA polymerase subunit A''', 867, NULL, 'TIGR02390', 287992),
(482318, 'TIGR03674', NULL, 'fen_arch: flap structure-specific endonuclease', 338, NULL, 'TIGR03674', 287993),
(482319, 'TIGR00577', NULL, 'fpg: DNA-formamidopyrimidine glycosylase', 276, NULL, 'TIGR00577', 287994),
(482320, 'TIGR00200', NULL, 'cinA_nterm: competence/damage-inducible protein CinA N-terminal domain', 414, NULL, 'TIGR00200', 287995),
(482321, 'TIGR01584', NULL, 'citF: citrate lyase, alpha subunit', 492, NULL, 'TIGR01584', 287996),
(482322, 'TIGR04360', NULL, 'other_trbK: conjugative transfer region protein TrbK', 73, NULL, 'TIGR04360', 287997),
(482323, 'TIGR01409', NULL, 'TAT_signal_seq: Tat (twin-arginine translocation) pathway signal sequence', 29, NULL, 'TIGR01409', 287998),
(482324, 'TIGR00493', NULL, 'clpP: ATP-dependent Clp endopeptidase, proteolytic subunit ClpP', 192, NULL, 'TIGR00493', 287999),
(482325, 'TIGR03294', NULL, 'FrhG: coenzyme F420 hydrogenase, subunit gamma', 228, NULL, 'TIGR03294', 288000),
(482326, 'TIGR02583', NULL, 'DevR_archaea: CRISPR-associated protein Cas7/Csa2, subtype I-A/APERN', 284, NULL, 'TIGR02583', 288001),
(482327, 'TIGR04072', NULL, 'rSAM_ladder_B12: lipid biosynthesis B12-binding/radical SAM protein', 151, NULL, 'TIGR04072', 288002),
(482328, 'TIGR03127', NULL, 'RuMP_HxlB: 6-phospho 3-hexuloisomerase', 179, NULL, 'TIGR03127', 288003),
(482329, 'TIGR04265', NULL, 'bac_cardiolipin: cardiolipin synthase', 483, NULL, 'TIGR04265', 288004),
(482330, 'TIGR03627', NULL, 'uS9_arch: ribosomal protein uS9', 130, NULL, 'TIGR03627', 288005);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(482331, 'TIGR01537', NULL, 'portal_HK97: phage portal protein, HK97 family', 343, NULL, 'TIGR01537', 288006),
(482332, 'TIGR02175', NULL, 'PorC_KorC: 2-oxoacid:acceptor oxidoreductase, gamma subunit, pyruvate/2-ketoisovalerate family', 177, NULL, 'TIGR02175', 288007),
(482333, 'TIGR01020', NULL, 'uS5_euk_arch: ribosomal protein uS5', 212, NULL, 'TIGR01020', 288008),
(482334, 'TIGR03110', NULL, 'exosort_Gpos: exosortase family protein XrtG', 187, NULL, 'TIGR03110', 288009),
(482335, 'TIGR04480', NULL, 'D_pro_red_PrdA: D-proline reductase (dithiol), PrdA proprotein', 587, NULL, 'TIGR04480', 288010),
(482336, 'TIGR03434', NULL, 'ADOP: acidobacterial duplicated orphan permease', 803, NULL, 'TIGR03434', 288011),
(482337, 'TIGR04192', NULL, 'GRASP_w_spasm: ATP-GRASP peptide maturase, grasp-with-spasm system', 318, NULL, 'TIGR04192', 288012),
(482338, 'TIGR03018', NULL, 'pepcterm_TyrKin: exopolysaccharide/PEP-CTERM locus tyrosine autokinase', 207, NULL, 'TIGR03018', 288013),
(482339, 'TIGR00320', NULL, 'dfx_rbo: desulfoferrodoxin', 125, NULL, 'TIGR00320', 288014),
(482340, 'TIGR00946', NULL, '2a69: auxin efflux carrier', 336, NULL, 'TIGR00946', 288015),
(482341, 'TIGR03722', NULL, 'arch_KAE1: universal archaeal protein Kae1', 323, NULL, 'TIGR03722', 288016),
(482342, 'TIGR02047', NULL, 'CadR-PbrR: Cd(II)/Pb(II)-responsive transcriptional regulator', 127, NULL, 'TIGR02047', 288017),
(482343, 'TIGR02281', NULL, 'clan_AA_DTGA: clan AA aspartic protease, TIGR02281 family', 121, NULL, 'TIGR02281', 288018),
(482344, 'TIGR03783', NULL, 'Bac_Flav_CT_G: Bacteroides conjugation system ATPase, TraG family', 829, NULL, 'TIGR03783', 288019),
(482345, 'TIGR00745', NULL, 'apbA_panE: 2-dehydropantoate 2-reductase', 305, NULL, 'TIGR00745', 288020),
(482346, 'TIGR01643', NULL, 'YD_repeat_2x: YD repeat (two copies)', 42, NULL, 'TIGR01643', 288021),
(482347, 'TIGR04251', NULL, 'SCM_rSAM_ScmF: SynChlorMet cassette radical SAM/SPASM protein ScmF', 353, NULL, 'TIGR04251', 288022),
(482348, 'TIGR02111', NULL, 'PQQ_syn_pqqC: coenzyme PQQ biosynthesis protein C', 239, NULL, 'TIGR02111', 288023),
(482349, 'TIGR01383', NULL, 'not_thiJ: DJ-1 family protein', 180, NULL, 'TIGR01383', 288024),
(482350, 'TIGR00398', NULL, 'metG: methionine--tRNA ligase', 530, NULL, 'TIGR00398', 288025),
(482351, 'TIGR02234', NULL, 'trp_oprn_chp: membrane protein, TIGR02234 family', 202, NULL, 'TIGR02234', 288026),
(482352, 'TIGR03736', NULL, 'PRTRC_ThiF: PRTRC system ThiF family protein', 245, NULL, 'TIGR03736', 288027),
(482353, 'TIGR02642', NULL, 'phage_xxxx: uncharacterized phage protein', 267, NULL, 'TIGR02642', 288028),
(482354, 'TIGR03797', NULL, 'NHLM_micro_ABC2: NHLM bacteriocin system ABC transporter, ATP-binding protein', 686, NULL, 'TIGR03797', 288029),
(482355, 'TIGR02354', NULL, 'thiF_fam2: thiamine biosynthesis protein ThiF', 200, NULL, 'TIGR02354', 288030),
(482356, 'TIGR04131', NULL, 'Bac_Flav_CTERM: gliding motility-associated C-terminal domain', 85, NULL, 'TIGR04131', 288031),
(482357, 'TIGR03613', NULL, 'RutR: pyrimidine utilization regulatory protein R', 202, NULL, 'TIGR03613', 288032),
(482358, 'TIGR01140', NULL, 'L_thr_O3P_dcar: threonine-phosphate decarboxylase', 331, NULL, 'TIGR01140', 288033),
(482359, 'TIGR02295', NULL, 'HpaD: 3,4-dihydroxyphenylacetate 2,3-dioxygenase', 298, NULL, 'TIGR02295', 288034),
(482360, 'TIGR01931', NULL, 'cysJ: sulfite reductase [NADPH] flavoprotein, alpha-component', 597, NULL, 'TIGR01931', 288035),
(482361, 'TIGR03495', NULL, 'phage_LysB: phage lysis regulatory protein, LysB family', 135, NULL, 'TIGR03495', 288036),
(482362, 'TIGR02857', NULL, 'CydD: thiol reductant ABC exporter, CydD subunit', 529, NULL, 'TIGR02857', 288037),
(482363, 'TIGR00384', NULL, 'dhsB: succinate dehydrogenase and fumarate reductase iron-sulfur protein', 222, NULL, 'TIGR00384', 288038),
(482364, 'TIGR02340', NULL, 'chap_CCT_alpha: T-complex protein 1, alpha subunit', 536, NULL, 'TIGR02340', 288039),
(482365, 'TIGR03842', NULL, 'F420_CPS_4043: F420-dependent oxidoreductase, CPS_4043 family', 329, NULL, 'TIGR03842', 288040);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(482366, 'TIGR01702', NULL, 'CO_DH_cata: carbon-monoxide dehydrogenase, catalytic subunit', 621, NULL, 'TIGR01702', 288041),
(482367, 'TIGR03160', NULL, 'cobT_DBIPRT: nicotinate-nucleotide--dimethylbenzimidazole phosphoribosyltransferase', 334, NULL, 'TIGR03160', 288042),
(482368, 'TIGR00686', NULL, 'phnA: putative alkylphosphonate utilization operon protein PhnA', 109, NULL, 'TIGR00686', 288043),
(482369, 'TIGR02890', NULL, 'bacill_yteA: regulatory protein, yteA family', 159, NULL, 'TIGR02890', 288044),
(482370, 'TIGR04374', NULL, 'small_w_EgtBD: hercynine metabolism small protein', 73, NULL, 'TIGR04374', 288045),
(482371, 'TIGR00214', NULL, 'lipB: lipoyl(octanoyl) transferase', 187, NULL, 'TIGR00214', 288046),
(482372, 'TIGR00672', NULL, 'cdh: CDP-diacylglycerol diphosphatase', 250, NULL, 'TIGR00672', 288047),
(482373, 'TIGR01716', NULL, 'RGG_Cterm: transcriptional activator, Rgg/GadR/MutR family, C-terminal domain', 220, NULL, 'TIGR01716', 288048),
(482374, 'TIGR02916', NULL, 'PEP_his_kin: putative PEP-CTERM system histidine kinase', 679, NULL, 'TIGR02916', 288049),
(482375, 'TIGR04086', NULL, 'TIGR04086_membr: putative membrane protein, TIGR04086 family', 115, NULL, 'TIGR04086', 288050),
(482376, 'TIGR01657', NULL, 'P-ATPase-V: P-type ATPase of unknown pump specificity (type V)', 1055, NULL, 'TIGR01657', 288051),
(482377, 'TIGR01886', NULL, 'dipeptidase: dipeptidase PepV', 466, NULL, 'TIGR01886', 288052),
(482378, 'TIGR00502', NULL, 'nagB: glucosamine-6-phosphate deaminase', 259, NULL, 'TIGR00502', 288053),
(482379, 'TIGR03311', NULL, 'Se_dep_XDH: selenium-dependent xanthine dehydrogenase', 848, NULL, 'TIGR03311', 288054),
(482380, 'TIGR04433', NULL, 'UrcA_uranyl: UrcA family protein', 92, NULL, 'TIGR04433', 288055),
(482381, 'TIGR01598', NULL, 'holin_phiLC3: holin, phage phi LC3 family', 79, NULL, 'TIGR01598', 288056),
(482382, 'TIGR01221', NULL, 'rmlC: dTDP-4-dehydrorhamnose 3,5-epimerase', 176, NULL, 'TIGR01221', 288057),
(482383, 'TIGR01478', NULL, 'STEVOR: variant surface antigen, stevor family', 308, NULL, 'TIGR01478', 288058),
(482384, 'TIGR02393', NULL, 'RpoD_Cterm: RNA polymerase sigma factor RpoD', 238, NULL, 'TIGR02393', 288059),
(482385, 'TIGR01101', NULL, 'V_ATP_synt_F: V-type ATPase, F subunit', 121, NULL, 'TIGR01101', 288060),
(482386, 'TIGR01682', NULL, 'moaD: molybdopterin converting factor, subunit 1', 80, NULL, 'TIGR01682', 288061),
(482387, 'TIGR00082', NULL, 'rbfA: ribosome-binding factor A', 115, NULL, 'TIGR00082', 288062),
(482388, 'TIGR02097', NULL, 'yccV: hemimethylated DNA binding domain', 101, NULL, 'TIGR02097', 288063),
(482389, 'TIGR00647', NULL, 'DNA_bind_WhiA: DNA-binding protein WhiA', 304, NULL, 'TIGR00647', 288064),
(482390, 'TIGR03772', NULL, 'anch_rpt_subst: anchored repeat ABC transporter, substrate-binding protein', 486, NULL, 'TIGR03772', 288065),
(482391, 'TIGR02737', NULL, 'caa3_CtaG: cytochrome c oxidase assembly factor CtaG', 281, NULL, 'TIGR02737', 288066),
(482392, 'TIGR04483', NULL, 'D_pro_red_PrdB: D-proline reductase (dithiol), PrdB protein', 238, NULL, 'TIGR04483', 288067),
(482393, 'TIGR00851', NULL, 'mtlA: PTS system, mannitol-specific IIC component', 340, NULL, 'TIGR00851', 288068),
(482394, 'TIGR04215', NULL, 'choice_anch_A: choice-of-anchor A domain', 255, NULL, 'TIGR04215', 288069),
(482395, 'TIGR03549', NULL, 'TIGR03549: YcaO domain protein', 723, NULL, 'TIGR03549', 288070),
(482396, 'TIGR00209', NULL, 'galT_1: galactose-1-phosphate uridylyltransferase', 349, NULL, 'TIGR00209', 288071),
(482397, 'TIGR04455', NULL, 'lipo_MXAN_6521: probable lipoprotein, LA_1396/MXAN_6521 family', 192, NULL, 'TIGR04455', 288072),
(482398, 'TIGR00527', NULL, 'gcvH: glycine cleavage system H protein', 129, NULL, 'TIGR00527', 288073),
(482399, 'TIGR02701', NULL, 'shell_carb_anhy: carboxysome shell carbonic anhydrase', 450, NULL, 'TIGR02701', 288074),
(482400, 'TIGR02365', NULL, 'dha_L_ycgS: dihydroxyacetone kinase, L subunit', 196, NULL, 'TIGR02365', 288075),
(482401, 'TIGR02522', NULL, 'pilus_cpaD: pilus (Caulobacter type) biogenesis lipoprotein CpaD', 198, NULL, 'TIGR02522', 288076);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(482402, 'TIGR00275', NULL, 'TIGR00275: flavoprotein, HI0933 family', 401, NULL, 'TIGR00275', 288077),
(482403, 'TIGR02617', NULL, 'tnaA_trp_ase: tryptophanase', 467, NULL, 'TIGR02617', 288078),
(482404, 'TIGR02941', NULL, 'Sigma_B: RNA polymerase sigma-B factor', 255, NULL, 'TIGR02941', 288079),
(482405, 'TIGR00432', NULL, 'arcsn_tRNA_tgt: tRNA-guanine(15) transglycosylase', 637, NULL, 'TIGR00432', 288080),
(482406, 'TIGR02125', NULL, 'CytB-hydogenase: Ni/Fe-hydrogenase, b-type cytochrome subunit', 212, NULL, 'TIGR02125', 288081),
(482407, 'TIGR03624', NULL, 'TIGR03624: putative hydrolase', 346, NULL, 'TIGR03624', 288082),
(482408, 'TIGR00016', NULL, 'ackA: acetate kinase', 405, NULL, 'TIGR00016', 288083),
(482409, 'TIGR03892', NULL, 'thiopep_precurs: thiazolylpeptide-type bacteriocin precursor', 44, NULL, 'TIGR03892', 288084),
(482410, 'TIGR01442', NULL, 'SASP_gamma: small, acid-soluble spore protein, gamma-type', 86, NULL, 'TIGR01442', 288085),
(482411, 'TIGR03182', NULL, 'PDH_E1_alph_y: pyruvate dehydrogenase (acetyl-transferring) E1 component, alpha subunit', 315, NULL, 'TIGR03182', 288086),
(482412, 'TIGR03532', NULL, 'DapD_Ac: 2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-acetyltransferase', 231, NULL, 'TIGR03532', 288087),
(482413, 'TIGR01092', NULL, 'P5CS: delta l-pyrroline-5-carboxylate synthetase', 715, NULL, 'TIGR01092', 288088),
(482414, 'TIGR01534', NULL, 'GAPDH-I: glyceraldehyde-3-phosphate dehydrogenase, type I', 330, NULL, 'TIGR01534', 288089),
(482415, 'TIGR03280', NULL, 'methan_mark_11: methanogenesis imperfect marker protein 11', 292, NULL, 'TIGR03280', 288090),
(482416, 'TIGR00887', NULL, '2A0109: phosphate:H+ symporter', 502, NULL, 'TIGR00887', 288091),
(482417, 'TIGR02835', NULL, 'spore_sigmaE: RNA polymerase sigma-E factor', 234, NULL, 'TIGR02835', 288092),
(482418, 'TIGR02231', NULL, 'TIGR02231: conserved hypothetical protein', 524, NULL, 'TIGR02231', 288093),
(482419, 'TIGR02488', NULL, 'flgG_G_neg: flagellar basal-body rod protein FlgG', 259, NULL, 'TIGR02488', 288094),
(482420, 'TIGR00865', NULL, 'bcl-2: apoptosis regulator', 213, NULL, 'TIGR00865', 288095),
(482421, 'TIGR00795', NULL, 'lctP: transporter, lactate permease (LctP) family', 530, NULL, 'TIGR00795', 288096),
(482422, 'TIGR00552', NULL, 'nadE: NAD+ synthetase', 251, NULL, 'TIGR00552', 288097),
(482423, 'TIGR01026', NULL, 'fliI_yscN: ATPase, FliI/YscN family', 440, NULL, 'TIGR01026', 288098),
(482424, 'TIGR01777', NULL, 'yfcH: TIGR01777 family protein', 292, NULL, 'TIGR01777', 288099),
(482425, 'TIGR00524', NULL, 'eIF-2B_rel: eIF-2B alpha/beta/delta-related uncharacterized proteins', 303, NULL, 'TIGR00524', 288100),
(482426, 'TIGR01897', NULL, 'cas_MJ1666: CRISPR-associated protein, MJ1666 family', 417, NULL, 'TIGR01897', 288101),
(482427, 'TIGR01934', NULL, 'MenG_MenH_UbiE: ubiquinone/menaquinone biosynthesis methyltransferase', 223, NULL, 'TIGR01934', 288102),
(482428, 'TIGR04201', NULL, 'Myxo_Cys_RPT: Cys-rich repeat, Myxococcales-type', 22, NULL, 'TIGR04201', 288103),
(482429, 'TIGR03196', NULL, 'pucD: xanthine dehydrogenase D subunit', 763, NULL, 'TIGR03196', 288104),
(482430, 'TIGR00395', NULL, 'leuS_arch: leucine--tRNA ligase', 938, NULL, 'TIGR00395', 288105),
(482431, 'TIGR03970', NULL, 'Rv0697: dehydrogenase, Rv0697 family', 487, NULL, 'TIGR03970', 288106),
(482432, 'TIGR02539', NULL, 'SepCysS: O-phospho-L-seryl-tRNA:Cys-tRNA synthase', 370, NULL, 'TIGR02539', 288107),
(482433, 'TIGR02781', NULL, 'VirB9: P-type conjugative transfer protein VirB9', 248, NULL, 'TIGR02781', 288108),
(482434, 'TIGR04509', NULL, 'mod_pep_NH_fam: putative modified peptide', 87, NULL, 'TIGR04509', 288109),
(482435, 'TIGR04017', NULL, 'WcaA: colanic acid biosynthesis glycosyltransferase WcaA', 279, NULL, 'TIGR04017', 288110),
(482436, 'TIGR04083', NULL, 'rSAM_pep_methan: putative peptide-modifying radical SAM enzyme, Mhun_1560 family', 376, NULL, 'TIGR04083', 288111),
(482437, 'TIGR03747', NULL, 'conj_TIGR03747: integrating conjugative element membrane protein, PFL_4697 family', 233, NULL, 'TIGR03747', 288112),
(482438, 'TIGR01235', NULL, 'pyruv_carbox: pyruvate carboxylase', 1143, NULL, 'TIGR01235', 288113);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(482439, 'TIGR00329', NULL, 'gcp_kae1: metallohydrolase, glycoprotease/Kae1 family', 305, NULL, 'TIGR00329', 288114),
(482440, 'TIGR01811', NULL, 'sdhA_Bsu: succinate dehydrogenase or fumarate reductase, flavoprotein subunit', 603, NULL, 'TIGR01811', 288115),
(482441, 'TIGR04240', NULL, 'flavi_E_stem: flavivirus envelope glycoprotein E, stem/anchor domain', 97, NULL, 'TIGR04240', 288116),
(482442, 'TIGR00767', NULL, 'rho: transcription termination factor Rho', 415, NULL, 'TIGR00767', 288117),
(482443, 'TIGR01464', NULL, 'hemE: uroporphyrinogen decarboxylase', 338, NULL, 'TIGR01464', 288118),
(482444, 'TIGR00060', NULL, 'L18_bact: ribosomal protein uL18', 114, NULL, 'TIGR00060', 288119),
(482445, 'TIGR01562', NULL, 'FdhE: formate dehydrogenase accessory protein FdhE', 305, NULL, 'TIGR01562', 288120),
(482446, 'TIGR03236', NULL, 'dnd_assoc_1: DNA phosphorothioation-dependent restriction protein DptG', 363, NULL, 'TIGR03236', 288121),
(482447, 'TIGR03504', NULL, 'FimV_Cterm: FimV C-terminal domain', 44, NULL, 'TIGR03504', 288122),
(482448, 'TIGR02821', NULL, 'fghA_ester_D: S-formylglutathione hydrolase', 275, NULL, 'TIGR02821', 288123),
(482449, 'TIGR00139', NULL, 'h_aconitase: homoaconitase', 709, NULL, 'TIGR00139', 288124),
(482450, 'TIGR03786', NULL, 'strep_pil_rpt: streptococcal pilin isopeptide linkage domain', 70, NULL, 'TIGR03786', 288125),
(482451, 'TIGR02245', NULL, 'HAD_IIID1: HAD hydrolase, family IIID', 195, NULL, 'TIGR02245', 288126),
(482452, 'TIGR01788', NULL, 'Glu-decarb-GAD: glutamate decarboxylase', 431, NULL, 'TIGR01788', 288127),
(482453, 'TIGR00513', NULL, 'accA: acetyl-CoA carboxylase, carboxyl transferase, alpha subunit', 321, NULL, 'TIGR00513', 288128),
(482454, 'TIGR03895', NULL, 'protease_PatA: cyanobactin maturation protease, PatA/PatG family', 606, NULL, 'TIGR03895', 288129),
(482455, 'TIGR01771', NULL, 'L-LDH-NAD: L-lactate dehydrogenase', 299, NULL, 'TIGR01771', 288130),
(482456, 'TIGR03758', NULL, 'conj_TIGR03758: integrating conjugative element protein, PFL_4701 family', 76, NULL, 'TIGR03758', 288131),
(482457, 'TIGR04469', NULL, 'CGA_synth_rel: CGA synthase-related protein', 297, NULL, 'TIGR04469', 288132),
(482458, 'TIGR02603', NULL, 'CxxCH_TIGR02603: putative heme-binding domain', 134, NULL, 'TIGR02603', 288133),
(482459, 'TIGR01668', NULL, 'YqeG_hyp_ppase: HAD phosphatase, family IIIA', 170, NULL, 'TIGR01668', 288134),
(482460, 'TIGR03314', NULL, 'Se_ssnA: putative selenium metabolism protein SsnA', 441, NULL, 'TIGR03314', 288135),
(482461, 'TIGR03518', NULL, 'ABC_perm_GldF: gliding motility-associated ABC transporter permease protein GldF', 240, NULL, 'TIGR03518', 288136),
(482462, 'TIGR02379', NULL, 'ECA_wecE: TDP-4-keto-6-deoxy-D-glucose transaminase', 376, NULL, 'TIGR02379', 288137),
(482463, 'TIGR00940', NULL, '2a6301s01: monovalent cation:proton antiporter', 793, NULL, 'TIGR00940', 288138),
(482464, 'TIGR00180', NULL, 'parB_part: ParB/RepB/Spo0J family partition protein', 186, NULL, 'TIGR00180', 288139),
(482465, 'TIGR01224', NULL, 'hutI: imidazolonepropionase', 377, NULL, 'TIGR01224', 288140),
(482466, 'TIGR00820', NULL, 'zip: ZIP zinc/iron transport family', 324, NULL, 'TIGR00820', 288141),
(482467, 'TIGR02270', NULL, 'TIGR02270: conserved hypothetical protein', 410, NULL, 'TIGR02270', 288142),
(482468, 'TIGR02910', NULL, 'sulfite_red_A: sulfite reductase, subunit A', 334, NULL, 'TIGR02910', 288143),
(482469, 'TIGR03638', NULL, 'cas1_ECOLI: CRISPR-associated endonuclease Cas1, subtype I-E/ECOLI', 269, NULL, 'TIGR03638', 288144),
(482470, 'TIGR02927', NULL, 'SucB_Actino: 2-oxoglutarate dehydrogenase, E2 component, dihydrolipoamide succinyltransferase', 579, NULL, 'TIGR02927', 288145),
(482471, 'TIGR04137', NULL, 'Chlam_Ver_rRNA: Chlam_Verruc_Plancto small basic protein', 50, NULL, 'TIGR04137', 288146),
(482472, 'TIGR01115', NULL, 'pufM: photosynthetic reaction center M subunit', 305, NULL, 'TIGR01115', 288147),
(482473, 'TIGR04120', NULL, 'DNA_lig_bact: DNA ligase, ATP-dependent, PP_1105 family', 526, NULL, 'TIGR04120', 288148),
(482474, 'TIGR01037', NULL, 'pyrD_sub1_fam: dihydroorotate dehydrogenase family protein', 300, NULL, 'TIGR01037', 288149);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(482475, 'TIGR03185', NULL, 'DNA_S_dndD: DNA sulfur modification protein DndD', 650, NULL, 'TIGR03185', 288150),
(482476, 'TIGR00661', NULL, 'MJ1255: conserved hypothetical protein', 321, NULL, 'TIGR00661', 288151),
(482477, 'TIGR02030', NULL, 'BchI-ChlI: magnesium chelatase ATPase subunit I', 337, NULL, 'TIGR02030', 288152),
(482478, 'TIGR03987', NULL, 'TIGR03987: TIGR03987 family protein', 120, NULL, 'TIGR03987', 288153),
(482479, 'TIGR02594', NULL, 'TIGR02594: TIGR02594 family protein', 132, NULL, 'TIGR02594', 288154),
(482480, 'TIGR02122', NULL, 'TRAP_TAXI: TRAP transporter solute receptor, TAXI family', 320, NULL, 'TIGR02122', 288155),
(482481, 'TIGR02528', NULL, 'EutP: ethanolamine utilization protein, EutP', 142, NULL, 'TIGR02528', 288156),
(482482, 'TIGR00985', NULL, '3a0801s04tom: mitochondrial import receptor subunit', 148, NULL, 'TIGR00985', 288157),
(482483, 'TIGR03359', NULL, 'VI_chp_6: type VI secretion protein, TIGR03359 family', 600, NULL, 'TIGR03359', 288158),
(482484, 'TIGR01920', NULL, 'Shik_kin_archae: shikimate kinase', 266, NULL, 'TIGR01920', 288159),
(482485, 'TIGR04212', NULL, 'GlyGly_RbtA: rhombotarget A', 605, NULL, 'TIGR04212', 288160),
(482486, 'TIGR01344', NULL, 'malate_syn_A: malate synthase A', 511, NULL, 'TIGR01344', 288161),
(482487, 'TIGR03090', NULL, 'SASP_tlp: small, acid-soluble spore protein tlp', 70, NULL, 'TIGR03090', 288162),
(482488, 'TIGR01269', NULL, 'Tyr_3_monoox: tyrosine 3-monooxygenase', 457, NULL, 'TIGR01269', 288163),
(482489, 'TIGR02499', NULL, 'HrpE_YscL_not: type III secretion apparatus protein, HrpE/YscL family', 166, NULL, 'TIGR02499', 288164),
(482490, 'TIGR01453', NULL, 'grpIintron_endo: group I intron endonuclease', 215, NULL, 'TIGR01453', 288165),
(482491, 'TIGR02955', NULL, 'TMAO_TorT: TMAO reductase system periplasmic protein TorT', 295, NULL, 'TIGR02955', 288166),
(482492, 'TIGR01573', NULL, 'cas2: CRISPR-associated endonuclease Cas2', 96, NULL, 'TIGR01573', 288167),
(482493, 'TIGR03423', NULL, 'pbp2_mrdA: penicillin-binding protein 2', 593, NULL, 'TIGR03423', 288168),
(482494, 'TIGR01800', NULL, 'cit_synth_II: 2-methylcitrate synthase/citrate synthase II', 368, NULL, 'TIGR01800', 288169),
(482495, 'TIGR00005', NULL, 'rluA_subfam: pseudouridine synthase, RluA family', 298, NULL, 'TIGR00005', 288170),
(482496, 'TIGR03076', NULL, 'near_not_gcvH: chlamydial GcvH-like protein upstream region protein', 686, NULL, 'TIGR03076', 288171),
(482497, 'TIGR04321', NULL, 'spiroSPASM: spiro-SPASM protein', 510, NULL, 'TIGR04321', 288172),
(482498, 'TIGR00071', NULL, 'hisT_truA: tRNA pseudouridine(38-40) synthase', 228, NULL, 'TIGR00071', 288173),
(482499, 'TIGR03116', NULL, 'cas5_csf3: CRISPR type IV/AFERR-associated protein Csf3', 215, NULL, 'TIGR03116', 288174),
(482500, 'TIGR00999', NULL, '8a0102: membrane fusion protein cluster 2 protein', 271, NULL, 'TIGR00999', 288175),
(482501, 'TIGR01880', NULL, 'Ac-peptdase-euk: N-acyl-L-amino-acid amidohydrolase', 401, NULL, 'TIGR01880', 288176),
(482502, 'TIGR02832', NULL, 'spo_yunB: sporulation protein YunB', 204, NULL, 'TIGR02832', 288177),
(482503, 'TIGR02712', NULL, 'urea_carbox: urea carboxylase', 1201, NULL, 'TIGR02712', 288178),
(482504, 'TIGR03867', NULL, 'MprA_tail: MprA protease C-terminal rhombosortase-interaction domain', 27, NULL, 'TIGR03867', 288179),
(482505, 'TIGR02485', NULL, 'CobZ_N-term: precorrin 3B synthase CobZ', 437, NULL, 'TIGR02485', 288180),
(482506, 'TIGR00449', NULL, 'tgt_general: tRNA-guanine family transglycosylase', 367, NULL, 'TIGR00449', 288181),
(482507, 'TIGR00418', NULL, 'thrS: threonine--tRNA ligase', 565, NULL, 'TIGR00418', 288182),
(482508, 'TIGR01330', NULL, 'bisphos_HAL2: 3''(2''),5''-bisphosphate nucleotidase', 359, NULL, 'TIGR01330', 288183),
(482509, 'TIGR04028', NULL, 'SBP_KPN_01854: ABC transporter substrate binding protein, KPN_01854 family', 509, NULL, 'TIGR04028', 288184),
(482510, 'TIGR04335', NULL, 'AmmeMemoSam_A: AmmeMemoRadiSam system protein A', 175, NULL, 'TIGR04335', 288185),
(482511, 'TIGR00541', NULL, 'hisDCase_pyru: histidine decarboxylase, pyruvoyl type', 307, NULL, 'TIGR00541', 288186);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(482512, 'TIGR01696', NULL, 'deoB: phosphopentomutase', 381, NULL, 'TIGR01696', 288187),
(482513, 'TIGR03881', NULL, 'KaiC_arch_4: KaiC domain protein, PAE1156 family', 231, NULL, 'TIGR03881', 288188),
(482514, 'TIGR00876', NULL, 'tal_mycobact: transaldolase', 350, NULL, 'TIGR00876', 288189),
(482515, 'TIGR01389', NULL, 'recQ: ATP-dependent DNA helicase RecQ', 591, NULL, 'TIGR01389', 288190),
(482516, 'TIGR01906', NULL, 'integ_TIGR01906: integral membrane protein TIGR01906', 207, NULL, 'TIGR01906', 288191),
(482517, 'TIGR03239', NULL, 'GarL: 2-dehydro-3-deoxyglucarate aldolase', 249, NULL, 'TIGR03239', 288192),
(482518, 'TIGR02419', NULL, 'C4_traR_proteo: phage/conjugal plasmid C-4 type zinc finger protein, TraR family', 64, NULL, 'TIGR02419', 288193),
(482519, 'TIGR00194', NULL, 'uvrC: excinuclease ABC subunit C', 574, NULL, 'TIGR00194', 288194),
(482520, 'TIGR03652', NULL, 'FeS_repair_RIC: iron-sulfur cluster repair di-iron protein', 216, NULL, 'TIGR03652', 288195),
(482521, 'TIGR03062', NULL, 'pip_yhgE_Cterm: YhgE/Pip C-terminal domain', 208, NULL, 'TIGR03062', 288196),
(482522, 'TIGR04106', NULL, 'cas8c_GSU0052: CRISPR-associated protein GSU0052/csb3, Dpsyc system', 282, NULL, 'TIGR04106', 288197),
(482523, 'TIGR04564', NULL, 'Synergist_CTERM: Synergist-CTERM protein sorting domain', 27, NULL, 'TIGR04564', 288198),
(482524, 'TIGR02726', NULL, 'phenyl_P_delta: phenylphosphate carboxylase, delta subunit', 169, NULL, 'TIGR02726', 288199),
(482525, 'TIGR02648', NULL, 'rep_term_tus: DNA replication terminus site-binding protein', 300, NULL, 'TIGR02648', 288200),
(482526, 'TIGR02150', NULL, 'IPP_isom_1: isopentenyl-diphosphate delta-isomerase', 159, NULL, 'TIGR02150', 288201),
(482527, 'TIGR01146', NULL, 'ATPsyn_F1gamma: ATP synthase F1, gamma subunit', 286, NULL, 'TIGR01146', 288202),
(482528, 'TIGR00633', NULL, 'xth: exodeoxyribonuclease III (xth)', 255, NULL, 'TIGR00633', 288203),
(482529, 'TIGR00286', NULL, 'TIGR00286: arginine decarboxylase, pyruvoyl-dependent', 152, NULL, 'TIGR00286', 288204),
(482530, 'TIGR01255', NULL, 'pyr_form_ly_1: formate acetyltransferase', 744, NULL, 'TIGR01255', 288205),
(482531, 'TIGR02707', NULL, 'butyr_kinase: butyrate kinase', 351, NULL, 'TIGR02707', 288206),
(482532, 'TIGR03931', NULL, 'T7SS_Rv3446c: type VII secretion-associated protein, Rv3446c family', 194, NULL, 'TIGR03931', 288207),
(482533, 'TIGR00046', NULL, 'TIGR00046: RNA methyltransferase, RsmE family', 240, NULL, 'TIGR00046', 288208),
(482534, 'TIGR00617', NULL, 'rpa1: replication factor-a protein 1 (rpa1)', 608, NULL, 'TIGR00617', 288209),
(482535, 'TIGR01841', NULL, 'phasin: phasin family protein', 88, NULL, 'TIGR01841', 288210),
(482536, 'TIGR00720', NULL, 'sda_mono: L-serine ammonia-lyase', 450, NULL, 'TIGR00720', 288211),
(482537, 'TIGR02256', NULL, 'ICE_VC0181: conserved hypothetical protein', 131, NULL, 'TIGR02256', 288212),
(482538, 'TIGR02810', NULL, 'agaZ_gatZ: D-tagatose-bisphosphate aldolase, class II, non-catalytic subunit', 420, NULL, 'TIGR02810', 288213),
(482539, 'TIGR04346', NULL, 'DotA_TraY: conjugal transfer/type IV secretion protein DotA/TraY', 656, NULL, 'TIGR04346', 288214),
(482540, 'TIGR00359', NULL, 'cello_pts_IIC: PTS system, cellobiose-specific IIC component', 424, NULL, 'TIGR00359', 288215),
(482541, 'TIGR02136', NULL, 'ptsS_2: phosphate binding protein', 295, NULL, 'TIGR02136', 288216),
(482542, 'TIGR03828', NULL, 'pfkB: 1-phosphofructokinase', 305, NULL, 'TIGR03828', 288217),
(482543, 'TIGR04539', NULL, 'tRNA_cyclodipep: tRNA-dependent cyclodipeptide synthase', 220, NULL, 'TIGR04539', 288218),
(482544, 'TIGR01425', NULL, 'SRP54_euk: signal recognition particle protein SRP54', 428, NULL, 'TIGR01425', 288219),
(482545, 'TIGR01738', NULL, 'bioH: pimelyl-[acyl-carrier protein] methyl ester esterase', 245, NULL, 'TIGR01738', 288220),
(482546, 'TIGR02449', NULL, 'TIGR02449: TIGR02449 family protein', 65, NULL, 'TIGR02449', 288221),
(482547, 'TIGR02994', NULL, 'ectoine_eutE: ectoine utilization protein EutE', 325, NULL, 'TIGR02994', 288222),
(482548, 'TIGR02279', NULL, 'PaaC-3OHAcCoADH: 3-hydroxyacyl-CoA dehydrogenase PaaC', 503, NULL, 'TIGR02279', 288223);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(482549, 'TIGR03761', NULL, 'ICE_PFL4669: integrating conjugative element protein, PFL_4669 family', 216, NULL, 'TIGR03761', 288224),
(482550, 'TIGR02578', NULL, 'cas_TM1811_Csm1: CRISPR-associated protein Cas10/Csm1, subtype III-A/MTUBE', 650, NULL, 'TIGR02578', 288225),
(482551, 'TIGR04369', NULL, 'fusion_not_SelD: oxidoreductase/SelD-related fusion protein', 701, NULL, 'TIGR04369', 288226),
(482552, 'TIGR01671', NULL, 'phage_TIGR01671: phage conserved hypothetical protein TIGR01671', 151, NULL, 'TIGR01671', 288227),
(482553, 'TIGR02338', NULL, 'gimC_beta: prefoldin, beta subunit', 110, NULL, 'TIGR02338', 288228),
(482554, 'TIGR00488', NULL, 'TIGR00488: putative HD superfamily hydrolase', 173, NULL, 'TIGR00488', 288229),
(482555, 'TIGR04176', NULL, 'MarR_EPS: EPS-associated transcriptional regulator, MarR family', 105, NULL, 'TIGR04176', 288230),
(482556, 'TIGR02689', NULL, 'ars_reduc_gluta: arsenate reductase, glutathione/glutaredoxin type', 126, NULL, 'TIGR02689', 288231),
(482557, 'TIGR04428', NULL, 'B12_rSAM_trp_MT: tryptophan 2-C-methyltransferase', 558, NULL, 'TIGR04428', 288232),
(482558, 'TIGR03418', NULL, 'chol_sulf_TF: putative choline sulfate-utilization transcription factor', 291, NULL, 'TIGR03418', 288233),
(482559, 'TIGR01328', NULL, 'met_gam_lyase: methionine gamma-lyase', 391, NULL, 'TIGR01328', 288234),
(482560, 'TIGR02086', NULL, 'IPMI_arch: 3-isopropylmalate dehydratase, large subunit', 411, NULL, 'TIGR02086', 288235),
(482561, 'TIGR03336', NULL, 'IOR_alpha: indolepyruvate ferredoxin oxidoreductase, alpha subunit', 595, NULL, 'TIGR03336', 288236),
(482562, 'TIGR01246', NULL, 'dapE_proteo: succinyl-diaminopimelate desuccinylase', 370, NULL, 'TIGR01246', 288237),
(482563, 'TIGR00304', NULL, 'TIGR00304: TIGR00304 family protein', 84, NULL, 'TIGR00304', 288238),
(482564, 'TIGR00599', NULL, 'rad18: DNA repair protein rad18', 397, NULL, 'TIGR00599', 288239),
(482565, 'TIGR00125', NULL, 'cyt_tran_rel: cytidyltransferase-like domain', 65, NULL, 'TIGR00125', 288240),
(482566, 'TIGR01627', NULL, 'A_thal_3515: uncharacterized plant-specific domain TIGR01627', 225, NULL, 'TIGR01627', 288241),
(482567, 'TIGR02265', NULL, 'Mxa_TIGR02265: Myxococcales-restricted protein, TIGR02265 family', 184, NULL, 'TIGR02265', 288242),
(482568, 'TIGR03820', NULL, 'lys_2_3_AblA: lysine-2,3-aminomutase', 417, NULL, 'TIGR03820', 288243),
(482569, 'TIGR00728', NULL, 'OPT_sfam: oligopeptide transporter, OPT superfamily', 659, NULL, 'TIGR00728', 288244),
(482570, 'TIGR04115', NULL, 'rSAM_Cxxx_rpt: radical SAM peptide maturase, CXXX-repeat target family', 359, NULL, 'TIGR04115', 288245),
(482571, 'TIGR04305', NULL, 'fol_rel_CADD: putative folate metabolism protein, CADD family', 212, NULL, 'TIGR04305', 288246),
(482572, 'TIGR00761', NULL, 'argB: acetylglutamate kinase', 231, NULL, 'TIGR00761', 288247),
(482573, 'TIGR02748', NULL, 'GerC3_HepT: heptaprenyl diphosphate synthase component II', 319, NULL, 'TIGR02748', 288248),
(482574, 'TIGR03649', NULL, 'ergot_EASG: ergot alkaloid biosynthesis protein, AFUA_2G17970 family', 287, NULL, 'TIGR03649', 288249),
(482575, 'TIGR00951', NULL, '2A43: lysosomal Cystine Transporter', 233, NULL, 'TIGR00951', 288250),
(482576, 'TIGR02801', NULL, 'tolR: protein TolR', 129, NULL, 'TIGR02801', 288251),
(482577, 'TIGR02408', NULL, 'ectoine_ThpD: ectoine hydroxylase', 277, NULL, 'TIGR02408', 288252),
(482578, 'TIGR03752', NULL, 'conj_TIGR03752: integrating conjugative element protein, PFL_4705 family', 471, NULL, 'TIGR03752', 288253),
(482579, 'TIGR04287', NULL, 'exosort_XrtK: exosortase K', 163, NULL, 'TIGR04287', 288254),
(482580, 'TIGR02508', NULL, 'type_III_yscG: type III secretion protein, YscG family', 116, NULL, 'TIGR02508', 288255),
(482581, 'TIGR00105', NULL, 'L31: ribosomal protein bL31', 68, NULL, 'TIGR00105', 288256),
(482582, 'TIGR01006', NULL, 'polys_exp_MPA1: polysaccharide export protein, MPA1 family', 226, NULL, 'TIGR01006', 288257),
(482583, 'TIGR00591', NULL, 'phr2: deoxyribodipyrimidine photolyase', 453, NULL, 'TIGR00591', 288258),
(482584, 'TIGR00781', NULL, 'ccoO: cytochrome c oxidase, cbb3-type, subunit II', 232, NULL, 'TIGR00781', 288259);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(482585, 'TIGR02435', NULL, 'CobG: precorrin-3B synthase', 388, NULL, 'TIGR02435', 288260),
(482586, 'TIGR01568', NULL, 'A_thal_3678: uncharacterized plant-specific domain TIGR01568', 67, NULL, 'TIGR01568', 288261),
(482587, 'TIGR03289', NULL, 'frhB: coenzyme F420 hydrogenase, subunit beta', 275, NULL, 'TIGR03289', 288262),
(482588, 'TIGR03479', NULL, 'DMSO_red_II_alp: DMSO reductase family type II enzyme, molybdopterin subunit', 913, NULL, 'TIGR03479', 288263),
(482589, 'TIGR04390', NULL, 'OMP_YaiO_dom: outer membrane protein, YaiO family', 230, NULL, 'TIGR04390', 288264),
(482590, 'TIGR03459', NULL, 'crt_membr: carotene biosynthesis associated membrane protein', 470, NULL, 'TIGR03459', 288265),
(482591, 'TIGR02631', NULL, 'xylA_Arthro: xylose isomerase', 382, NULL, 'TIGR02631', 288266),
(482592, 'TIGR00558', NULL, 'pdxH: pyridoxamine 5''-phosphate oxidase', 217, NULL, 'TIGR00558', 288267),
(482593, 'TIGR03105', NULL, 'gln_synth_III: glutamine synthetase, type III', 435, NULL, 'TIGR03105', 288268),
(482594, 'TIGR04299', NULL, 'antiport_PotE: putrescine-ornithine antiporter', 430, NULL, 'TIGR04299', 288269),
(482595, 'TIGR03275', NULL, 'methan_mark_8: putative methanogenesis marker protein 8', 259, NULL, 'TIGR03275', 288270),
(482596, 'TIGR03861', NULL, 'phenyl_ABC_PedC: alcohol ABC transporter, permease protein', 253, NULL, 'TIGR03861', 288271),
(482597, 'TIGR00427', NULL, 'TIGR00427: membrane protein, MarC family', 201, NULL, 'TIGR00427', 288272),
(482598, 'TIGR02066', NULL, 'dsrB: sulfite reductase, dissimilatory-type beta subunit', 341, NULL, 'TIGR02066', 288273),
(482599, 'TIGR02517', NULL, 'type_II_gspD: type II secretion system protein D', 600, NULL, 'TIGR02517', 288274),
(482600, 'TIGR00667', NULL, 'aat: leucyl/phenylalanyl-tRNA--protein transferase', 193, NULL, 'TIGR00667', 288275),
(482601, 'TIGR00910', NULL, '2A0307_GadC: glutamate:gamma-aminobutyrate antiporter', 511, NULL, 'TIGR00910', 288276),
(482602, 'TIGR01185', NULL, 'devC: ABC exporter transmembrane subunit, DevC protein', 380, NULL, 'TIGR01185', 288277),
(482603, 'TIGR03035', NULL, 'trp_arylform: arylformamidase', 206, NULL, 'TIGR03035', 288278),
(482604, 'TIGR00974', NULL, '3a0107s02c: phosphate ABC transporter, permease protein PstA', 272, NULL, 'TIGR00974', 288279),
(482605, 'TIGR03608', NULL, 'L_ocin_972_ABC: putative bacteriocin export ABC transporter, lactococcin 972 group', 206, NULL, 'TIGR03608', 288280),
(482606, 'TIGR03582', NULL, 'EF_0829: PRD domain protein, EF_0829/AHA_3910 family', 107, NULL, 'TIGR03582', 288281),
(482607, 'TIGR04246', NULL, 'nitrous_NosZ_Gp: nitrous-oxide reductase, Sec-dependent', 578, NULL, 'TIGR04246', 288282),
(482608, 'TIGR04416', NULL, 'group_II_RT_mat: group II intron reverse transcriptase/maturase', 353, NULL, 'TIGR04416', 288283),
(482609, 'TIGR01492', NULL, 'CPW_WPC: Plasmodium falciparum CPW-WPC domain', 62, NULL, 'TIGR01492', 288284),
(482610, 'TIGR02156', NULL, 'PA_CoA_Oxy1: phenylacetate-CoA oxygenase, PaaG subunit', 289, NULL, 'TIGR02156', 288285),
(482611, 'TIGR01378', NULL, 'thi_PPkinase: thiamine pyrophosphokinase', 206, NULL, 'TIGR01378', 288286),
(482612, 'TIGR02326', NULL, 'transamin_PhnW: 2-aminoethylphosphonate--pyruvate transaminase', 363, NULL, 'TIGR02326', 288287),
(482613, 'TIGR03037', NULL, 'anthran_nbaC: 3-hydroxyanthranilate 3,4-dioxygenase', 159, NULL, 'TIGR03037', 288288),
(482614, 'TIGR01001', NULL, 'metA: homoserine O-succinyltransferase', 301, NULL, 'TIGR01001', 288289),
(482615, 'TIGR01548', NULL, 'HAD-SF-IA-hyp1: HAD hydrolase, TIGR01548 family', 197, NULL, 'TIGR01548', 288290),
(482616, 'TIGR00549', NULL, 'mevalon_kin: mevalonate kinase', 276, NULL, 'TIGR00549', 288291),
(482617, 'TIGR00837', NULL, 'araaP: aromatic amino acid transport protein', 381, NULL, 'TIGR00837', 288292),
(482618, 'TIGR03205', NULL, 'pimA: dicarboxylate--CoA ligase PimA', 541, NULL, 'TIGR03205', 288293),
(482619, 'TIGR03693', NULL, 'ocin_ThiF_like: putative thiazole-containing bacteriocin maturation protein', 637, NULL, 'TIGR03693', 288294),
(482620, 'TIGR01076', NULL, 'sortase_fam: sortase', 136, NULL, 'TIGR01076', 288295);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(482621, 'TIGR01900', NULL, 'dapE-gram_pos: succinyl-diaminopimelate desuccinylase', 351, NULL, 'TIGR01900', 288296),
(482622, 'TIGR01662', NULL, 'HAD-SF-IIIA: HAD hydrolase, family IIIA', 141, NULL, 'TIGR01662', 288297),
(482623, 'TIGR01187', NULL, 'potA: polyamine ABC transporter, ATP-binding protein', 325, NULL, 'TIGR01187', 288298),
(482624, 'TIGR01518', NULL, 'g3p_cytidyltrns: glycerol-3-phosphate cytidylyltransferase', 125, NULL, 'TIGR01518', 288299),
(482625, 'TIGR00032', NULL, 'argG: argininosuccinate synthase', 394, NULL, 'TIGR00032', 288300),
(482626, 'TIGR01806', NULL, 'CM_mono2: putative chorismate mutase', 114, NULL, 'TIGR01806', 288301),
(482627, 'TIGR04006', NULL, 'wcaK: colanic acid biosynthesis pyruvyl transferase WcaK', 426, NULL, 'TIGR04006', 288302),
(482628, 'TIGR03951', NULL, 'Fe_III_red_FhuF: siderophore-iron reductase FhuF', 182, NULL, 'TIGR03951', 288303),
(482629, 'TIGR02980', NULL, 'SigBFG: RNA polymerase sigma-70 factor, sigma-B/F/G subfamily', 227, NULL, 'TIGR02980', 288304),
(482630, 'TIGR03146', NULL, 'cyt_nit_nrfB: cytochrome c nitrite reductase, pentaheme subunit', 145, NULL, 'TIGR03146', 288305),
(482631, 'TIGR00658', NULL, 'orni_carb_tr: ornithine carbamoyltransferase', 304, NULL, 'TIGR00658', 288306),
(482632, 'TIGR01296', NULL, 'asd_B: aspartate-semialdehyde dehydrogenase', 339, NULL, 'TIGR01296', 288307),
(482633, 'TIGR02798', NULL, 'ligK_PcmE: 4-carboxy-4-hydroxy-2-oxoadipate aldolase/oxaloacetate decarboxylase', 222, NULL, 'TIGR02798', 288308),
(482634, 'TIGR02885', NULL, 'spore_sigF: RNA polymerase sigma-F factor', 231, NULL, 'TIGR02885', 288309),
(482635, 'TIGR03717', NULL, 'R_switched_YjbE: integral membrane protein, YjbE family', 176, NULL, 'TIGR03717', 288310),
(482636, 'TIGR01730', NULL, 'RND_mfp: efflux transporter, RND family, MFP subunit', 322, NULL, 'TIGR01730', 288311),
(482637, 'TIGR04237', NULL, 'seadorna_VP9: seadornavirus/coltivirus VP9 protein', 256, NULL, 'TIGR04237', 288312),
(482638, 'TIGR04355', NULL, 'HprK_rel_B: HprK-related kinase B', 351, NULL, 'TIGR04355', 288313),
(482639, 'TIGR02215', NULL, 'phage_chp_gp8: phage conserved hypothetical protein, phiE125 gp8 family', 188, NULL, 'TIGR02215', 288314),
(482640, 'TIGR00726', NULL, 'TIGR00726: YfiH family protein', 223, NULL, 'TIGR00726', 288315),
(482641, 'TIGR04478', NULL, 'rSAM_YfkAB: radical SAM/CxCxxxxC motif protein YfkAB', 363, NULL, 'TIGR04478', 288316),
(482642, 'TIGR00379', NULL, 'cobB: cobyrinic acid a,c-diamide synthase', 449, NULL, 'TIGR00379', 288317),
(482643, 'TIGR01780', NULL, 'SSADH: succinate-semialdehyde dehydrogenase', 448, NULL, 'TIGR01780', 288318),
(482644, 'TIGR02871', NULL, 'spore_ylbJ: sporulation integral membrane protein YlbJ', 363, NULL, 'TIGR02871', 288319),
(482645, 'TIGR00318', NULL, 'cyaB: putative adenylyl cyclase CyaB', 174, NULL, 'TIGR00318', 288320),
(482646, 'TIGR03023', NULL, 'WcaJ_sugtrans: undecaprenyl-phosphate glucose phosphotransferase', 453, NULL, 'TIGR03023', 288321),
(482647, 'TIGR04525', NULL, 'prot_M_MG281: IgG-blocking protein M', 526, NULL, 'TIGR04525', 288322),
(482648, 'TIGR04067', NULL, 'oc_CLOSPO_01332: putative bacteriocin precursor, CLOSPO_01332 family', 59, NULL, 'TIGR04067', 288323),
(482649, 'TIGR02229', NULL, 'caa3_sub_IV: caa(3)-type oxidase, subunit IV', 92, NULL, 'TIGR02229', 288324),
(482650, 'TIGR04414', NULL, 'hepto_Aah_TibC: autotransporter strand-loop-strand O-heptosyltransferase', 374, NULL, 'TIGR04414', 288325),
(482651, 'TIGR01355', NULL, 'cyt_deam_dimer: cytidine deaminase', 283, NULL, 'TIGR01355', 288326),
(482652, 'TIGR02503', NULL, 'type_III_SycN: type III secretion chaperone SycN', 120, NULL, 'TIGR02503', 288327),
(482653, 'TIGR02982', NULL, 'heterocyst_DevA: ABC exporter ATP-binding subunit, DevA family', 220, NULL, 'TIGR02982', 288328),
(482654, 'TIGR03658', NULL, 'IsdH_HarA: haptoglobin-binding heme uptake protein HarA', 895, NULL, 'TIGR03658', 288329),
(482655, 'TIGR01369', NULL, 'CPSaseII_lrg: carbamoyl-phosphate synthase, large subunit', 1052, NULL, 'TIGR01369', 288330),
(482656, 'TIGR02052', NULL, 'MerP: mercuric transport protein periplasmic component', 92, NULL, 'TIGR02052', 288331);  
INSERT INTO "PUBLIC"."MODEL" VALUES
(482657, 'TIGR00155', NULL, 'pqiA_fam: integral membrane protein, PqiA family', 403, NULL, 'TIGR00155', 288332),
(482658, 'TIGR03691', NULL, '20S_bact_alpha: proteasome, alpha subunit', 229, NULL, 'TIGR03691', 288333),
(482659, 'TIGR01015', NULL, 'hmgA: homogentisate 1,2-dioxygenase', 429, NULL, 'TIGR01015', 288334),
(482660, 'TIGR03085', NULL, 'TIGR03085: TIGR03085 family protein', 201, NULL, 'TIGR03085', 288335),
(482661, 'TIGR03965', NULL, 'mycofact_glyco: mycofactocin system glycosyltransferase', 467, NULL, 'TIGR03965', 288336),
(482662, 'TIGR01929', NULL, 'menB: naphthoate synthase', 259, NULL, 'TIGR01929', 288337),
(482663, 'TIGR04142', NULL, 'PCisTranLspir: putative peptidyl-prolyl cis-trans isomerase, LIC12922 family', 316, NULL, 'TIGR04142', 288338),
(482664, 'TIGR01875', NULL, 'cas_MJ0381: CRISPR-associated autoregulator DevR family', 240, NULL, 'TIGR01875', 288339),
(482665, 'TIGR03568', NULL, 'NeuC_NnaA: UDP-N-acetyl-D-glucosamine 2-epimerase, UDP-hydrolysing', 365, NULL, 'TIGR03568', 288340),
(482666, 'TIGR00284', NULL, 'TIGR00284: dihydropteroate synthase-related protein', 497, NULL, 'TIGR00284', 288341),
(482667, 'TIGR00924', NULL, 'yjdL_sub1_fam: amino acid/peptide transporter (Peptide:H+ symporter)', 475, NULL, 'TIGR00924', 288342),
(482668, 'TIGR01240', NULL, 'mevDPdecarb: diphosphomevalonate decarboxylase', 305, NULL, 'TIGR01240', 288343),
(482669, 'TIGR02080', NULL, 'O_succ_thio_ly: O-succinylhomoserine (thiol)-lyase', 382, NULL, 'TIGR02080', 288344),
(482670, 'TIGR03901', NULL, 'MYXO-CTERM: MYXO-CTERM domain', 33, NULL, 'TIGR03901', 288345),
(482671, 'TIGR03330', NULL, 'SAM_DCase_Bsu: S-adenosylmethionine decarboxylase proenzyme', 112, NULL, 'TIGR03330', 288346),
(482672, 'TIGR01165', NULL, 'cbiN: cobalt transport protein', 91, NULL, 'TIGR01165', 288347),
(482673, 'TIGR03227', NULL, 'PhnS: 2-aminoethylphosphonate ABC transporter, 2-aminoethylphosphonate binding protein', 360, NULL, 'TIGR03227', 288348),
(482674, 'TIGR04170', NULL, 'RNR_1b_NrdE: ribonucleoside-diphosphate reductase, class 1b, alpha subunit', 698, NULL, 'TIGR04170', 288349),
(482675, 'TIGR01137', NULL, 'cysta_beta: cystathionine beta-synthase', 457, NULL, 'TIGR01137', 288350),
(482676, 'TIGR01219', NULL, 'Pmev_kin_ERG8: phosphomevalonate kinase', 456, NULL, 'TIGR01219', 288351),
(482677, 'TIGR03309', NULL, 'matur_yqeB: selenium-dependent molybdenum hydroxylase system protein, YqeB family', 256, NULL, 'TIGR03309', 288352),
(482678, 'TIGR03057', NULL, 'xxxLxxG_by_4: X-X-X-Leu-X-X-Gly heptad repeats', 28, NULL, 'TIGR03057', 288353),
(482679, 'TIGR00611', NULL, 'recf: DNA replication and repair protein RecF', 365, NULL, 'TIGR00611', 288354),
(482680, 'TIGR03883', NULL, 'DUF2342_F420: uncharacterized protein, coenzyme F420 biosynthesis associated', 346, NULL, 'TIGR03883', 288355),
(482681, 'TIGR01423', NULL, 'trypano_reduc: trypanothione-disulfide reductase', 486, NULL, 'TIGR01423', 288356),
(482682, 'TIGR01553', NULL, 'formate-DH-alph: formate dehydrogenase-N alpha subunit', 1009, NULL, 'TIGR01553', 288357),
(482683, 'TIGR02816', NULL, 'pfaB_fam: PfaB family protein', 534, NULL, 'TIGR02816', 288358),
(482684, 'TIGR03643', NULL, 'TIGR03643: TIGR03643 family protein', 72, NULL, 'TIGR03643', 288359),
(482685, 'TIGR01793', NULL, 'cit_synth_euk: citrate (Si)-synthase, eukaryotic', 427, NULL, 'TIGR01793', 288360),
(482686, 'TIGR01950', NULL, 'SoxR: redox-sensitive transcriptional activator SoxR', 142, NULL, 'TIGR01950', 288361),
(482687, 'TIGR02250', NULL, 'FCP1_euk: FCP1-like phosphatase, phosphatase domain', 156, NULL, 'TIGR02250', 288362),
(482688, 'TIGR02374', NULL, 'nitri_red_nirB: nitrite reductase [NAD(P)H], large subunit', 794, NULL, 'TIGR02374', 288363),
(482689, 'TIGR00870', NULL, 'trp: transient-receptor-potential calcium channel protein', 747, NULL, 'TIGR00870', 288364),
(482690, 'TIGR01629', NULL, 'rep_II_X: phage/plasmid replication protein, gene II/X family', 407, NULL, 'TIGR01629', 288365),
(482691, 'TIGR03398', NULL, 'plc_access_R: phospholipase C accessory protein PlcR', 141, NULL, 'TIGR03398', 288366);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(482692, 'TIGR04464', NULL, 'chaper_lep: LipL41-expression chaperone Lep', 114, NULL, 'TIGR04464', 288367),
(482693, 'TIGR02106', NULL, 'cyd_oper_ybgT: cyd operon protein YbgT', 30, NULL, 'TIGR02106', 288368),
(482694, 'TIGR02960', NULL, 'SigX5: RNA polymerase sigma-70 factor, TIGR02960 family', 322, NULL, 'TIGR02960', 288369),
(482695, 'TIGR01459', NULL, 'HAD-SF-IIA-hyp4: HAD hydrolase, TIGR01459 family', 242, NULL, 'TIGR01459', 288370),
(482696, 'TIGR02790', NULL, 'nickel_nikC: nickel ABC transporter, permease subunit NikC', 258, NULL, 'TIGR02790', 288371),
(482697, 'TIGR03473', NULL, 'HpnK: hopanoid biosynthesis associated protein HpnK', 283, NULL, 'TIGR03473', 288372),
(482698, 'TIGR01437', NULL, 'selA_rel: uncharacterized pyridoxal phosphate-dependent enzyme', 363, NULL, 'TIGR01437', 288373),
(482699, 'TIGR03767', NULL, 'P_acnes_RR: metallophosphoesterase, PPA1498 family', 496, NULL, 'TIGR03767', 288374),
(482700, 'TIGR02939', NULL, 'RpoE_Sigma70: RNA polymerase sigma factor RpoE', 190, NULL, 'TIGR02939', 288375),
(482701, 'TIGR01110', NULL, 'mdcA: malonate decarboxylase, alpha subunit', 543, NULL, 'TIGR01110', 288376),
(482702, 'TIGR04095', NULL, 'dnd_restrict_1: DNA phosphorothioation system restriction enzyme', 451, NULL, 'TIGR04095', 288377),
(482703, 'TIGR02558', NULL, 'HrpB2: type III secretion protein HrpB2', 124, NULL, 'TIGR02558', 288378),
(482704, 'TIGR04101', NULL, 'CCGSCS: CCGSCS motif protein', 59, NULL, 'TIGR04101', 288379),
(482705, 'TIGR01070', NULL, 'mutS1: DNA mismatch repair protein MutS', 840, NULL, 'TIGR01070', 288380),
(482706, 'TIGR01124', NULL, 'ilvA_2Cterm: threonine ammonia-lyase, biosynthetic', 499, NULL, 'TIGR01124', 288381),
(482707, 'TIGR03132', NULL, 'malonate_mdcB: triphosphoribosyl-dephospho-CoA synthase MdcB', 272, NULL, 'TIGR03132', 288382),
(482708, 'TIGR00454', NULL, 'TIGR00454: TIGR00454 family protein', 183, NULL, 'TIGR00454', 288383),
(482709, 'TIGR01607', NULL, 'PST-A: Plasmodium subtelomeric family', 332, NULL, 'TIGR01607', 288384),
(482710, 'TIGR04319', NULL, 'SerAla_Lrha_rpt: surface protein repeat Ser-Ala-175', 175, NULL, 'TIGR04319', 288385),
(482711, 'TIGR03098', NULL, 'ligase_PEP_1: acyl-CoA ligase (AMP-forming), exosortase A-associated', 517, NULL, 'TIGR03098', 288386),
(482712, 'TIGR00892', NULL, '2A0113: monocarboxylate transporter', 455, NULL, 'TIGR00892', 288387),
(482713, 'TIGR03255', NULL, 'PhnV: 2-aminoethylphosphonate ABC transport system, membrane component PhnV', 270, NULL, 'TIGR03255', 288388),
(482714, 'TIGR00413', NULL, 'rlpA: rare lipoprotein A', 208, NULL, 'TIGR00413', 288389),
(482715, 'TIGR01621', NULL, 'RluA-like: pseudouridine synthase Rlu family protein, TIGR01621', 217, NULL, 'TIGR01621', 288390),
(482716, 'TIGR03937', NULL, 'PgaC_IcaA: poly-beta-1,6 N-acetyl-D-glucosamine synthase', 407, NULL, 'TIGR03937', 288391),
(482717, 'TIGR03445', NULL, 'mycothiol_MshB: N-acetyl-1-D-myo-inositol-2-amino-2-deoxy-alpha-D-glucopyranoside deacetylase', 284, NULL, 'TIGR03445', 288392),
(482718, 'TIGR02134', NULL, 'transald_staph: transaldolase', 236, NULL, 'TIGR02134', 288393),
(482719, 'TIGR01915', NULL, 'npdG: NADPH-dependent F420 reductase', 220, NULL, 'TIGR01915', 288394),
(482720, 'TIGR02932', NULL, 'vnfK_nitrog: V-containing nitrogenase, beta subunit', 457, NULL, 'TIGR02932', 288395),
(482721, 'TIGR03602', NULL, 'streptolysinS: bacteriocin protoxin, streptolysin S family', 56, NULL, 'TIGR03602', 288396),
(482722, 'TIGR01752', NULL, 'flav_long: flavodoxin', 167, NULL, 'TIGR01752', 288397),
(482723, 'TIGR02572', NULL, 'LcrR: type III secretion system regulator LcrR', 139, NULL, 'TIGR02572', 288398),
(482724, 'TIGR01922', NULL, 'purO_arch: IMP cyclohydrolase', 199, NULL, 'TIGR01922', 288399),
(482725, 'TIGR02304', NULL, 'aden_form_hyp: putative adenylate-forming enzyme', 430, NULL, 'TIGR02304', 288400),
(482726, 'TIGR02762', NULL, 'TraL_TIGR: type IV conjugative transfer system protein TraL', 95, NULL, 'TIGR02762', 288401),
(482727, 'TIGR02088', NULL, 'LEU3_arch: isopropylmalate/isohomocitrate dehydrogenases', 324, NULL, 'TIGR02088', 288402);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(482728, 'TIGR01151', NULL, 'psbA: photosystem II q(b) protein', 360, NULL, 'TIGR01151', 288403),
(482729, 'TIGR01205', NULL, 'D_ala_D_alaTIGR: D-alanine--D-alanine ligase', 318, NULL, 'TIGR01205', 288404),
(482730, 'TIGR00236', NULL, 'wecB: UDP-N-acetylglucosamine 2-epimerase', 366, NULL, 'TIGR00236', 288405),
(482731, 'TIGR02497', NULL, 'yscI_hrpB_dom: type III secretion apparatus protein, YscI/HrpB, C-terminal domain', 39, NULL, 'TIGR02497', 288406),
(482732, 'TIGR00373', NULL, 'TIGR00373: transcription factor E', 162, NULL, 'TIGR00373', 288407),
(482733, 'TIGR04210', NULL, 'bunya_NSm: bunyavirus nonstructural protein NSm', 173, NULL, 'TIGR04210', 288408),
(482734, 'TIGR03001', NULL, 'Sig-70_gmx1: RNA polymerase sigma-70 factor, Myxococcales family 1', 244, NULL, 'TIGR03001', 288409),
(482735, 'TIGR04396', NULL, 'surf_polysacc: surface carbohydrate biosynthesis protein', 322, NULL, 'TIGR04396', 288410),
(482736, 'TIGR02946', NULL, 'acyl_WS_DGAT: acyltransferase, WS/DGAT/MGAT', 453, NULL, 'TIGR02946', 288411),
(482737, 'TIGR03241', NULL, 'arg_catab_astB: succinylarginine dihydrolase', 443, NULL, 'TIGR03241', 288412),
(482738, 'TIGR04156', NULL, 'cyanoexo_CrtB: cyanoexosortase B', 280, NULL, 'TIGR04156', 288413),
(482739, 'TIGR03897', NULL, 'lanti_2_LanM: type 2 lantibiotic biosynthesis protein LanM', 932, NULL, 'TIGR03897', 288414),
(482740, 'TIGR03520', NULL, 'GldE: gliding motility-associated protein GldE', 408, NULL, 'TIGR03520', 288415),
(482741, 'TIGR02742', NULL, 'TrbC_Ftype: type-F conjugative transfer system pilin assembly protein TrbC', 130, NULL, 'TIGR02742', 288416),
(482742, 'TIGR01512', NULL, 'ATPase-IB2_Cd: cadmium-translocating P-type ATPase', 494, NULL, 'TIGR01512', 288417),
(482743, 'TIGR02639', NULL, 'ClpA: ATP-dependent Clp protease ATP-binding subunit ClpA', 734, NULL, 'TIGR02639', 288418),
(482744, 'TIGR03711', NULL, 'acc_sec_asp3: accessory Sec system protein Asp3', 135, NULL, 'TIGR03711', 288419),
(482745, 'TIGR03636', NULL, 'uL23_arch: ribosomal protein uL23', 77, NULL, 'TIGR03636', 288420),
(482746, 'TIGR00652', NULL, 'DapF: diaminopimelate epimerase', 270, NULL, 'TIGR00652', 288421),
(482747, 'TIGR00066', NULL, 'g_glut_trans: gamma-glutamyltransferase', 518, NULL, 'TIGR00066', 288422),
(482748, 'TIGR00706', NULL, 'SppA_dom: signal peptide peptidase SppA, 36K type', 208, NULL, 'TIGR00706', 288423),
(482749, 'TIGR04231', NULL, 'seadorna_VP5: seadornavirus VP5 protein', 505, NULL, 'TIGR04231', 288424),
(482750, 'TIGR02141', NULL, 'modB_ABC: molybdate ABC transporter, permease protein', 208, NULL, 'TIGR02141', 288425),
(482751, 'TIGR01861', NULL, 'ANFD: nitrogenase iron-iron protein, alpha chain', 513, NULL, 'TIGR01861', 288426),
(482752, 'TIGR01956', NULL, 'NusG_myco: NusG family protein', 257, NULL, 'TIGR01956', 288427),
(482753, 'TIGR02381', NULL, 'cspD: cold shock domain protein CspD', 68, NULL, 'TIGR02381', 288428),
(482754, 'TIGR03071', NULL, 'couple_hipA: HipA N-terminal domain', 101, NULL, 'TIGR03071', 288429),
(482755, 'TIGR01233', NULL, 'lacG: 6-phospho-beta-galactosidase', 472, NULL, 'TIGR01233', 288430),
(482756, 'TIGR02469', NULL, 'CbiT: precorrin-6Y C5,15-methyltransferase (decarboxylating), CbiT subunit', 124, NULL, 'TIGR02469', 288431),
(482757, 'TIGR00801', NULL, 'ncs2: uracil-xanthine permease', 415, NULL, 'TIGR00801', 288432),
(482758, 'TIGR00298', NULL, 'TIGR00298: 2-phosphosulfolactate phosphatase', 216, NULL, 'TIGR00298', 288433),
(482759, 'TIGR01314', NULL, 'gntK_FGGY: gluconate kinase', 505, NULL, 'TIGR01314', 288434),
(482760, 'TIGR04559', NULL, 'SoxH_rel_PQQ_2: quinoprotein relay system zinc metallohydrolase 2', 283, NULL, 'TIGR04559', 288435),
(482761, 'TIGR02011', NULL, 'IscA: iron-sulfur cluster assembly protein IscA', 105, NULL, 'TIGR02011', 288436),
(482762, 'TIGR03166', NULL, 'alt_F1F0_F1_eps: alternate F1F0 ATPase, F1 subunit epsilon', 122, NULL, 'TIGR03166', 288437),
(482763, 'TIGR02388', NULL, 'rpoC2_cyan: DNA-directed RNA polymerase, beta'''' subunit', 1230, NULL, 'TIGR02388', 288438),
(482764, 'TIGR03404', NULL, 'bicupin_oxalic: bicupin, oxalate decarboxylase family', 367, NULL, 'TIGR03404', 288439);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(482765, 'TIGR03876', NULL, 'cas_csaX: CRISPR type I-A/APERN-associated protein CsaX', 281, NULL, 'TIGR03876', 288440),
(482766, 'TIGR00291', NULL, 'RNA_SBDS: rRNA metabolism protein, SBDS family', 231, NULL, 'TIGR00291', 288441),
(482767, 'TIGR01786', NULL, 'TonB-hemlactrns: TonB-dependent hemoglobin/transferrin/lactoferrin receptor family protein', 719, NULL, 'TIGR01786', 288442),
(482768, 'TIGR00543', NULL, 'isochor_syn: isochorismate synthase', 349, NULL, 'TIGR00543', 288443),
(482769, 'TIGR01056', NULL, 'topB: DNA topoisomerase III', 706, NULL, 'TIGR01056', 288444),
(482770, 'TIGR00468', NULL, 'pheS: phenylalanine--tRNA ligase, alpha subunit', 324, NULL, 'TIGR00468', 288445),
(482771, 'TIGR02851', NULL, 'spore_V_T: stage V sporulation protein T', 180, NULL, 'TIGR02851', 288446),
(482772, 'TIGR00175', NULL, 'mito_nad_idh: isocitrate dehydrogenase, NAD-dependent', 334, NULL, 'TIGR00175', 288447),
(482773, 'TIGR02025', NULL, 'BchH: magnesium chelatase, H subunit', 1271, NULL, 'TIGR02025', 288448),
(482774, 'TIGR00815', NULL, 'sulP: sulfate permease', 565, NULL, 'TIGR00815', 288449),
(482775, 'TIGR00522', NULL, 'dph5: diphthine synthase', 258, NULL, 'TIGR00522', 288450),
(482776, 'TIGR04061', NULL, 'AZL_007950_fam: AZL_007950 family protein', 164, NULL, 'TIGR04061', 288451),
(482777, 'TIGR01677', NULL, 'pln_FAD_oxido: plant-specific FAD-dependent oxidoreductase', 560, NULL, 'TIGR01677', 288452),
(482778, 'TIGR03527', NULL, 'selenium_YedF: selenium metabolism protein YedF', 194, NULL, 'TIGR03527', 288453),
(482779, 'TIGR04340', NULL, 'rSAM_ACGX: radical SAM/SPASM domain protein, ACGX system', 341, NULL, 'TIGR04340', 288454),
(482780, 'TIGR00482', NULL, 'TIGR00482: nicotinate (nicotinamide) nucleotide adenylyltransferase', 194, NULL, 'TIGR00482', 288455),
(482781, 'TIGR00536', NULL, 'hemK_fam: methyltransferase, HemK family', 286, NULL, 'TIGR00536', 288456),
(482782, 'TIGR02197', NULL, 'heptose_epim: ADP-glyceromanno-heptose 6-epimerase', 316, NULL, 'TIGR02197', 288457),
(482783, 'TIGR03699', NULL, 'menaquin_MqnC: dehypoxanthine futalosine cyclase', 342, NULL, 'TIGR03699', 288458),
(482784, 'TIGR01042', NULL, 'V-ATPase_V1_A: V-type ATPase, A subunit', 591, NULL, 'TIGR01042', 288459),
(482785, 'TIGR02544', NULL, 'III_secr_YscJ: type III secretion apparatus lipoprotein, YscJ/HrcJ family', 193, NULL, 'TIGR02544', 288460),
(482786, 'TIGR00189', NULL, 'tesB: acyl-CoA thioesterase II', 282, NULL, 'TIGR00189', 288461),
(482787, 'TIGR03194', NULL, '4hydrxCoA_A: 4-hydroxybenzoyl-CoA reductase, alpha subunit', 746, NULL, 'TIGR03194', 288462),
(482788, 'TIGR03513', NULL, 'GldL_gliding: gliding motility-associated protein GldL', 247, NULL, 'TIGR03513', 288463),
(482789, 'TIGR01970', NULL, 'DEAH_box_HrpB: ATP-dependent helicase HrpB', 825, NULL, 'TIGR01970', 288464),
(482790, 'TIGR00508', NULL, 'bioA: adenosylmethionine-8-amino-7-oxononanoate transaminase', 419, NULL, 'TIGR00508', 288465),
(482791, 'TIGR04033', NULL, 'export_SdpB: antimicrobial peptide system protein, SdpB family', 276, NULL, 'TIGR04033', 288466),
(482792, 'TIGR02681', NULL, 'phage_pRha: phage regulatory protein, Rha family', 108, NULL, 'TIGR02681', 288467),
(482793, 'TIGR01028', NULL, 'uS7_euk_arch: ribosomal protein uS7', 186, NULL, 'TIGR01028', 288468),
(482794, 'TIGR02667', NULL, 'moaB_proteo: molybdenum cofactor biosynthesis protein B', 163, NULL, 'TIGR02667', 288469),
(482795, 'TIGR03350', NULL, 'type_VI_ompA: type VI secretion system peptidoglycan-associated domain', 137, NULL, 'TIGR03350', 288470),
(482796, 'TIGR04224', NULL, 'ser_adhes_Nterm: serine-rich repeat adhesion glycoprotein', 50, NULL, 'TIGR04224', 288471),
(482797, 'TIGR02490', NULL, 'flgF: flagellar basal-body rod protein FlgF', 218, NULL, 'TIGR02490', 288472),
(482798, 'TIGR03364', NULL, 'HpnW_proposed: FAD dependent oxidoreductase TIGR03364', 365, NULL, 'TIGR03364', 288473),
(482799, 'TIGR01847', NULL, 'bacteriocin_sig: bacteriocin-type signal sequence', 15, NULL, 'TIGR01847', 288474),
(482800, 'TIGR03992', NULL, 'Arch_glmU: UDP-N-acetylglucosamine diphosphorylase/glucosamine-1-phosphate N-acetyltransferase', 393, NULL, 'TIGR03992', 288475);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(482801, 'TIGR01984', NULL, 'UbiH: 2-polyprenyl-6-methoxyphenol 4-hydroxylase', 382, NULL, 'TIGR01984', 288476),
(482802, 'TIGR03534', NULL, 'RF_mod_PrmC: protein-(glutamine-N5) methyltransferase, release factor-specific', 253, NULL, 'TIGR03534', 288477),
(482803, 'TIGR04047', NULL, 'MSMEG_0565_glyc: glycosyltransferase, MSMEG_0565 family', 373, NULL, 'TIGR04047', 288478),
(482804, 'TIGR03999', NULL, 'thiol_BshA: N-acetyl-alpha-D-glucosaminyl L-malate synthase BshA', 375, NULL, 'TIGR03999', 288479),
(482805, 'TIGR00345', NULL, 'GET3_arsA_TRC40: transport-energizing ATPase, TRC40/GET3/ArsA family', 299, NULL, 'TIGR00345', 288480),
(482806, 'TIGR03502', NULL, 'lipase_Pla1_cef: extracellular lipase, Pla-1/cef family', 790, NULL, 'TIGR03502', 288481),
(482807, 'TIGR04140', NULL, 'chp_AF_0576: TIGR04140 family protein', 66, NULL, 'TIGR04140', 288482),
(482808, 'TIGR03622', NULL, 'urea_t_UrtB_arc: urea ABC transporter, permease protein UrtB', 284, NULL, 'TIGR03622', 288483),
(482809, 'TIGR04020', NULL, 'seco_metab_LLM: natural product biosynthesis luciferase-like monooxygenase domain', 341, NULL, 'TIGR04020', 288484),
(482810, 'TIGR01412', NULL, 'tat_substr_1: Tat-translocated enzyme', 420, NULL, 'TIGR01412', 288485),
(482811, 'TIGR01564', NULL, 'S_layer_MJ: S-layer protein', 571, NULL, 'TIGR01564', 288486),
(482812, 'TIGR00926', NULL, '2A1704: oligopeptide transporter, peptide:H+ symporter', 671, NULL, 'TIGR00926', 288487),
(482813, 'TIGR01532', NULL, 'E4PD_g-proteo: erythrose-4-phosphate dehydrogenase', 325, NULL, 'TIGR01532', 288488),
(482814, 'TIGR04292', NULL, 'heavy_Cys_CGP: heavy-Cys/CGP-CTERM domain protein', 381, NULL, 'TIGR04292', 288489),
(482815, 'TIGR02395', NULL, 'rpoN_sigma: RNA polymerase sigma-54 factor', 434, NULL, 'TIGR02395', 288490),
(482816, 'TIGR01877', NULL, 'cas_cas6: CRISPR-associated endoribonuclease Cas6', 200, NULL, 'TIGR01877', 288491),
(482817, 'TIGR04485', NULL, 'thiosulf_SoxX: sulfur oxidation c-type cytochrome SoxX', 78, NULL, 'TIGR04485', 288492),
(482818, 'TIGR03654', NULL, 'L6_bact: ribosomal protein uL6', 175, NULL, 'TIGR03654', 288493),
(482819, 'TIGR04172', NULL, 'DGQHR_dnd_1: DNA phosphorothioation-associated DGQHR protein 1', 381, NULL, 'TIGR04172', 288494),
(482820, 'TIGR03967', NULL, 'mycofact_MftB: putative mycofactocin binding protein MftB', 81, NULL, 'TIGR03967', 288495),
(482821, 'TIGR02082', NULL, 'metH: methionine synthase', 1182, NULL, 'TIGR02082', 288496),
(482822, 'TIGR00765', NULL, 'yihY_not_rbn: YihY family inner membrane protein', 259, NULL, 'TIGR00765', 288497),
(482823, 'TIGR04421', NULL, 'FemAB_IMCC1989: FemAB family protein', 345, NULL, 'TIGR04421', 288498),
(482824, 'TIGR00393', NULL, 'kpsF: sugar isomerase, KpsF/GutQ family', 268, NULL, 'TIGR00393', 288499),
(482825, 'TIGR03221', NULL, 'muco_delta: muconolactone delta-isomerase', 90, NULL, 'TIGR03221', 288500),
(482826, 'TIGR04301', NULL, 'ODC_inducible: ornithine decarboxylase SpeF', 719, NULL, 'TIGR04301', 288501),
(482827, 'TIGR02331', NULL, 'rib_alpha: Rib/alpha/Esp surface antigen repeat', 80, NULL, 'TIGR02331', 288502),
(482828, 'TIGR02483', NULL, 'PFK_mixed: phosphofructokinase', 325, NULL, 'TIGR02483', 288503),
(482829, 'TIGR02855', NULL, 'spore_yabG: sporulation peptidase YabG', 283, NULL, 'TIGR02855', 288504),
(482830, 'TIGR02823', NULL, 'oxido_YhdH: putative quinone oxidoreductase, YhdH/YhfP family', 324, NULL, 'TIGR02823', 288505),
(482831, 'TIGR02211', NULL, 'LolD_lipo_ex: lipoprotein releasing system, ATP-binding protein', 221, NULL, 'TIGR02211', 288506),
(482832, 'TIGR00121', NULL, 'birA_ligase: biotin--[acetyl-CoA-carboxylase] ligase', 235, NULL, 'TIGR00121', 288507),
(482833, 'TIGR02735', NULL, 'purC_vibrio: phosphoribosylaminoimidazole-succinocarboxamide synthase', 365, NULL, 'TIGR02735', 288508),
(482834, 'TIGR01596', NULL, 'cas3_HD: CRISPR-associated endonuclease Cas3-HD', 178, NULL, 'TIGR01596', 288509),
(482835, 'TIGR00586', NULL, 'mutt: mutator mutT protein', 129, NULL, 'TIGR00586', 288510),
(482836, 'TIGR03686', NULL, 'pupylate_PafA: Pup--protein ligase', 457, NULL, 'TIGR03686', 288511);
INSERT INTO "PUBLIC"."MODEL" VALUES
(482837, 'TIGR03935', NULL, 'fragilysin: fragilysin', 386, NULL, 'TIGR03935', 288512),
(482838, 'TIGR00733', NULL, 'TIGR00733: oligopeptide transporter, OPT family', 589, NULL, 'TIGR00733', 288513),
(482839, 'TIGR01904', NULL, 'GSu_C4xC__C2xCH: Geobacter sulfurreducens CxxxxCH...CXXCH domain', 42, NULL, 'TIGR01904', 288514),
(482840, 'TIGR03162', NULL, 'ribazole_cobC: alpha-ribazole phosphatase', 176, NULL, 'TIGR03162', 288515),
(482841, 'TIGR03493', NULL, 'cellullose_BcsF: celllulose biosynthesis operon protein BcsF/YhjT', 62, NULL, 'TIGR03493', 288516),
(482842, 'TIGR02050', NULL, 'gshA_cyan_rel: carboxylate-amine ligase, YbdK family', 287, NULL, 'TIGR02050', 288517),
(482843, 'TIGR01131', NULL, 'ATP_synt_6_or_A: ATP synthase F0, A subunit', 227, NULL, 'TIGR01131', 288518),
(482844, 'TIGR01845', NULL, 'outer_NodT: efflux transporter, outer membrane factor (OMF) lipoprotein, NodT family', 460, NULL, 'TIGR01845', 288519),
(482845, 'TIGR03130', NULL, 'malonate_delta: malonate decarboxylase acyl carrier protein', 98, NULL, 'TIGR03130', 288520),
(482846, 'TIGR03060', NULL, 'PS_II_psb29: photosystem II biogenesis protein Psp29', 214, NULL, 'TIGR03060', 288521),
(482847, 'TIGR00434', NULL, 'cysH: phosophoadenylyl-sulfate reductase', 214, NULL, 'TIGR00434', 288522),
(482848, 'TIGR01072', NULL, 'murA: UDP-N-acetylglucosamine 1-carboxyvinyltransferase', 416, NULL, 'TIGR01072', 288523),
(482849, 'TIGR03092', NULL, 'SASP_sspI: small, acid-soluble spore protein I', 65, NULL, 'TIGR03092', 288524),
(482850, 'TIGR03282', NULL, 'methan_mark_13: putative methanogenesis marker 13 metalloprotein', 352, NULL, 'TIGR03282', 288525),
(482851, 'TIGR02422', NULL, 'protocat_beta: protocatechuate 3,4-dioxygenase, beta subunit', 220, NULL, 'TIGR02422', 288526),
(482852, 'TIGR00899', NULL, '2A0120: sugar efflux transporter', 375, NULL, 'TIGR00899', 288527),
(482853, 'TIGR02644', NULL, 'Y_phosphoryl: pyrimidine-nucleoside phosphorylase', 417, NULL, 'TIGR02644', 288528),
(482854, 'TIGR03595', NULL, 'Obg_CgtA_exten: Obg family GTPase CgtA, C-terminal extension', 70, NULL, 'TIGR03595', 288529),
(482855, 'TIGR02925', NULL, 'cis_trans_EpsD: peptidyl-prolyl cis-trans isomerase, EpsD family', 232, NULL, 'TIGR02925', 288530),
(482856, 'TIGR00452', NULL, 'TIGR00452: tRNA (mo5U34)-methyltransferase', 316, NULL, 'TIGR00452', 288531),
(482857, 'TIGR01936', NULL, 'nqrA: NADH:ubiquinone oxidoreductase, Na(+)-translocating, A subunit', 446, NULL, 'TIGR01936', 288532),
(482858, 'TIGR02796', NULL, 'tolQ: protein TolQ', 216, NULL, 'TIGR02796', 288533),
(482859, 'TIGR03713', NULL, 'acc_sec_asp1: accessory Sec system protein Asp1', 519, NULL, 'TIGR03713', 288534),
(482860, 'TIGR01353', NULL, 'dGTP_triPase: putative dGTPase', 389, NULL, 'TIGR01353', 288535),
(482861, 'TIGR04351', NULL, 'TOMM_nitrile_2: putative TOMM peptide', 48, NULL, 'TIGR04351', 288536),
(482862, 'TIGR03341', NULL, 'YhgI_GntY: IscR-regulated protein YhgI', 190, NULL, 'TIGR03341', 288537),
(482863, 'TIGR02363', NULL, 'dhaK1: dihydroxyacetone kinase, DhaK subunit', 329, NULL, 'TIGR02363', 288538),
(482864, 'TIGR02703', NULL, 'carboxysome_A: carboxysome peptide A', 80, NULL, 'TIGR02703', 288539),
(482865, 'TIGR03373', NULL, 'VI_minor_4: type VI secretion-associated protein, BMA_A0400 family', 136, NULL, 'TIGR03373', 288540),
(482866, 'TIGR00171', NULL, 'leuD: 3-isopropylmalate dehydratase, small subunit', 188, NULL, 'TIGR00171', 288541),
(482867, 'TIGR01725', NULL, 'phge_HK97_gp10: phage protein, HK97 gp10 family', 120, NULL, 'TIGR01725', 288542),
(482868, 'TIGR03865', NULL, 'PQQ_CXXCW: PQQ-dependent catabolism-associated CXXCW motif protein', 167, NULL, 'TIGR03865', 288543),
(482869, 'TIGR01201', NULL, 'HU_rel: putative DNA-binding protein', 170, NULL, 'TIGR01201', 288544),
(482870, 'TIGR01385', NULL, 'TFSII: transcription elongation factor S-II', 300, NULL, 'TIGR01385', 288545),
(482871, 'TIGR02887', NULL, 'spore_ger_x_C: germination protein, Ger(x)C family', 371, NULL, 'TIGR02887', 288546),
(482872, 'TIGR04122', NULL, 'Xnuc_lig_assoc: putative exonuclease, DNA ligase-associated', 326, NULL, 'TIGR04122', 288547);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(482873, 'TIGR00944', NULL, '2a6301s04: multicomponent K+:H+antiporter', 463, NULL, 'TIGR00944', 288548),
(482874, 'TIGR01090', NULL, 'apt: adenine phosphoribosyltransferase', 169, NULL, 'TIGR01090', 288549),
(482875, 'TIGR00715', NULL, 'precor6x_red: precorrin-6x reductase', 256, NULL, 'TIGR00715', 288550),
(482876, 'TIGR02000', NULL, 'NifU_proper: Fe-S cluster assembly protein NifU', 290, NULL, 'TIGR02000', 288551),
(482877, 'TIGR01239', NULL, 'galT_2: galactose-1-phosphate uridylyltransferase', 489, NULL, 'TIGR01239', 288552),
(482878, 'TIGR02120', NULL, 'GspF: type II secretion system protein F', 401, NULL, 'TIGR02120', 288553),
(482879, 'TIGR04070', NULL, 'photo_TT_lyase: spore photoproduct lyase', 338, NULL, 'TIGR04070', 288554),
(482880, 'TIGR01119', NULL, 'lacB: galactose-6-phosphate isomerase, LacB subunit', 171, NULL, 'TIGR01119', 288555),
(482881, 'TIGR01494', NULL, 'ATPase_P-type: HAD ATPase, P-type, family IC', 478, NULL, 'TIGR01494', 288556),
(482882, 'TIGR04190', NULL, 'B12_SAM_Ta0216: B12-binding domain/radical SAM domain protein, Ta0216 family', 554, NULL, 'TIGR04190', 288557),
(482883, 'TIGR03552', NULL, 'F420_cofC: 2-phospho-L-lactate guanylyltransferase', 196, NULL, 'TIGR03552', 288558),
(482884, 'TIGR00976', NULL, '/NonD: hydrolase CocE/NonD family protein', 550, NULL, 'TIGR00976', 288559),
(482885, 'TIGR01634', NULL, 'tail_P2_I: phage tail protein I', 139, NULL, 'TIGR01634', 288560),
(482886, 'TIGR03724', NULL, 'arch_bud32: Kae1-associated kinase Bud32', 199, NULL, 'TIGR03724', 288561),
(482887, 'TIGR02914', NULL, 'EpsI_fam: EpsI family protein', 174, NULL, 'TIGR02914', 288562),
(482888, 'TIGR00030', NULL, 'S21p: ribosomal protein bS21', 58, NULL, 'TIGR00030', 288563),
(482889, 'TIGR02585', NULL, 'cas_Cst2_DevR: CRISPR-associated protein Cas7/Cst2/DevR, subtype I-B/TNEAP', 321, NULL, 'TIGR02585', 288564),
(482890, 'TIGR01310', NULL, 'uL30_euk: 60S ribosomal protein uL30', 236, NULL, 'TIGR01310', 288565),
(482891, 'TIGR01666', NULL, 'YCCS: TIGR01666 family membrane protein', 705, NULL, 'TIGR01666', 288566),
(482892, 'TIGR00094', NULL, 'tRNA_TruD_broad: tRNA pseudouridine synthase, TruD family', 413, NULL, 'TIGR00094', 288567),
(482893, 'TIGR00375', NULL, 'TIGR00375: TIGR00375 family protein', 374, NULL, 'TIGR00375', 288568),
(482894, 'TIGR04242', NULL, 'nodulat_NodC: chitooligosaccharide synthase NodC', 395, NULL, 'TIGR04242', 288569),
(482895, 'TIGR00495', NULL, 'crvDNA_42K: DNA-binding protein, 42 kDa', 383, NULL, 'TIGR00495', 288570),
(482896, 'TIGR02465', NULL, 'chlorocat_1_2: chlorocatechol 1,2-dioxygenase', 246, NULL, 'TIGR02465', 288571),
(482897, 'TIGR01430', NULL, 'aden_deam: adenosine deaminase', 323, NULL, 'TIGR01430', 288572),
(482898, 'TIGR04383', NULL, 'acidic_w_LPXTA: processed acidic surface protein', 320, NULL, 'TIGR04383', 288573),
(482899, 'TIGR00223', NULL, 'panD: aspartate 1-decarboxylase', 126, NULL, 'TIGR00223', 288574),
(482900, 'TIGR04128', NULL, 'exoso_Fjoh_1448: exosortase family protein XrtF', 174, NULL, 'TIGR04128', 288575),
(482901, 'TIGR00511', NULL, 'ribulose_e2b2: ribose-1,5-bisphosphate isomerase, e2b2 family', 301, NULL, 'TIGR00511', 288576),
(482902, 'TIGR03271', NULL, 'methan_mark_5: putative methanogenesis marker protein 5', 142, NULL, 'TIGR03271', 288577),
(482903, 'TIGR02038', NULL, 'protease_degS: periplasmic serine peptidase DegS', 351, NULL, 'TIGR02038', 288578),
(482904, 'TIGR03209', NULL, 'P21_Cbot: transcriptional regulator BotR, P-21', 142, NULL, 'TIGR03209', 288579),
(482905, 'TIGR01895', NULL, 'cas_Cas5t: CRISPR-associated protein Cas5, subtype I-B/TNEAP', 217, NULL, 'TIGR01895', 288580),
(482906, 'TIGR00835', NULL, 'agcS: amino acid carrier protein', 424, NULL, 'TIGR00835', 288581),
(482907, 'TIGR02293', NULL, 'TAS_TIGR02293: putative toxin-antitoxin system antitoxin component, TIGR02293 family', 133, NULL, 'TIGR02293', 288582),
(482908, 'TIGR03788', NULL, 'marine_srt_targ: marine proteobacterial sortase target protein', 629, NULL, 'TIGR03788', 288583),
(482909, 'TIGR03264', NULL, 'met_CoM_red_C: methyl-coenzyme M reductase I operon protein C', 194, NULL, 'TIGR03264', 288584); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(482910, 'TIGR03391', NULL, 'FeS_syn_CsdE: cysteine desulfurase, sulfur acceptor subunit CsdE', 139, NULL, 'TIGR03391', 288585),
(482911, 'TIGR03833', NULL, 'TIGR03833: conserved hypothetical protein', 62, NULL, 'TIGR03833', 288586),
(482912, 'TIGR03323', NULL, 'alt_F1F0_F1_gam: alternate F1F0 ATPase, F1 subunit gamma', 285, NULL, 'TIGR03323', 288587),
(482913, 'TIGR02184', NULL, 'Myco_arth_vir_N: Mycoplasma virulence family signal region', 33, NULL, 'TIGR02184', 288588),
(482914, 'TIGR01947', NULL, 'rnfG: electron transport complex, RnfABCDGE type, G subunit', 187, NULL, 'TIGR01947', 288589),
(482915, 'TIGR03604', NULL, 'TOMM_cyclo_SagD: thiazole/oxazole-forming peptide maturase, SagD family component', 377, NULL, 'TIGR03604', 288590),
(482916, 'TIGR02633', NULL, 'xylG: D-xylose ABC transporter, ATP-binding protein', 500, NULL, 'TIGR02633', 288591),
(482917, 'TIGR02574', NULL, 'stabl_TIGR02574: putative addiction module component, TIGR02574 family', 65, NULL, 'TIGR02574', 288592),
(482918, 'TIGR04523', NULL, 'Mplasa_alph_rch: helix-rich protein', 745, NULL, 'TIGR04523', 288593),
(482919, 'TIGR00039', NULL, '6PTHBS: 6-pyruvoyl tetrahydropterin synthase/QueD family protein', 124, NULL, 'TIGR00039', 288594),
(482920, 'TIGR04081', NULL, 'selen_ocin: radical SAM modification target peptide, selenobiotic family', 37, NULL, 'TIGR04081', 288595),
(482921, 'TIGR00554', NULL, 'panK_bact: pantothenate kinase', 307, NULL, 'TIGR00554', 288596),
(482922, 'TIGR01192', NULL, 'chvA: glucan exporter ATP-binding protein', 585, NULL, 'TIGR01192', 288597),
(482923, 'TIGR00332', NULL, 'neela_ferrous: desulfoferrodoxin ferrous iron-binding domain', 107, NULL, 'TIGR00332', 288598),
(482924, 'TIGR01022', NULL, 'rpmJ_bact: ribosomal protein bL36', 37, NULL, 'TIGR01022', 288599),
(482925, 'TIGR01834', NULL, 'PHA_synth_III_E: poly(R)-hydroxyalkanoic acid synthase, class III, PhaE subunit', 324, NULL, 'TIGR01834', 288600),
(482926, 'TIGR02472', NULL, 'sucr_P_syn_N: sucrose-phosphate synthase, putative, glycosyltransferase domain', 439, NULL, 'TIGR02472', 288601),
(482927, 'TIGR01487', NULL, 'Pglycolate_arch: phosphoglycolate phosphatase, TA0175-type', 215, NULL, 'TIGR01487', 288602),
(482928, 'TIGR02989', NULL, 'Sig-70_gvs1: RNA polymerase sigma-70 factor, Rhodopirellula/Verrucomicrobium family', 158, NULL, 'TIGR02989', 288603),
(482929, 'TIGR02694', NULL, 'arsenite_ox_S: arsenite oxidase, small subunit', 129, NULL, 'TIGR02694', 288604),
(482930, 'TIGR04183', NULL, 'Por_Secre_tail: Por secretion system C-terminal sorting domain', 72, NULL, 'TIGR04183', 288605),
(482931, 'TIGR03731', NULL, 'lantibio_gallid: lantibiotic, gallidermin/nisin family', 48, NULL, 'TIGR03731', 288606),
(482932, 'TIGR04530', NULL, 'hemophoreRv0203: hemophore', 118, NULL, 'TIGR04530', 288607),
(482933, 'TIGR02524', NULL, 'dot_icm_DotB: Dot/Icm secretion system ATPase DotB', 358, NULL, 'TIGR02524', 288608),
(482934, 'TIGR03443', NULL, 'alpha_am_amid: L-aminoadipate-semialdehyde dehydrogenase', 1390, NULL, 'TIGR03443', 288609),
(482935, 'TIGR03384', NULL, 'betaine_BetI: transcriptional repressor BetI', 189, NULL, 'TIGR03384', 288610),
(482936, 'TIGR00273', NULL, 'TIGR00273: iron-sulfur cluster-binding protein', 432, NULL, 'TIGR00273', 288611),
(482937, 'TIGR01768', NULL, 'GGGP-family: geranylgeranylglyceryl phosphate synthase family protein', 224, NULL, 'TIGR01768', 288612),
(482938, 'TIGR00613', NULL, 'reco: DNA repair protein RecO', 239, NULL, 'TIGR00613', 288613),
(482939, 'TIGR00842', NULL, 'bcct: transporter, betaine/carnitine/choline transporter (BCCT) family', 452, NULL, 'TIGR00842', 288614),
(482940, 'TIGR02753', NULL, 'sodN: superoxide dismutase, Ni', 145, NULL, 'TIGR02753', 288615),
(482941, 'TIGR04008', NULL, 'WcaF: colanic acid biosynthesis acetyltransferase WcaF', 180, NULL, 'TIGR04008', 288616),
(482942, 'TIGR01997', NULL, 'sufA_proteo: FeS assembly scaffold SufA', 107, NULL, 'TIGR01997', 288617),
(482943, 'TIGR01251', NULL, 'ribP_PPkin: ribose-phosphate diphosphokinase', 309, NULL, 'TIGR01251', 288618),
(482944, 'TIGR01827', NULL, 'gatC_rel: putative Asp-tRNA(Asn)/Glu-tRNA(Gln) amidotransferase, subunit C', 73, NULL, 'TIGR01827', 288619);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(482945, 'TIGR02805', NULL, 'exbB2: tonB-system energizer ExbB', 138, NULL, 'TIGR02805', 288620),
(482946, 'TIGR02222', NULL, 'chap_CsaA: export-related chaperone protein CsaA', 107, NULL, 'TIGR02222', 288621),
(482947, 'TIGR00797', NULL, 'matE: MATE efflux family protein', 396, NULL, 'TIGR00797', 288622),
(482948, 'TIGR02746', NULL, 'TraC-F-type: type-IV secretion system protein TraC', 800, NULL, 'TIGR02746', 288623),
(482949, 'TIGR01303', NULL, 'IMP_DH_rel_1: IMP dehydrogenase family protein', 475, NULL, 'TIGR01303', 288624),
(482950, 'TIGR02996', NULL, 'rpt_mate_G_obs: repeat-companion domain TIGR02996', 45, NULL, 'TIGR02996', 288625),
(482951, 'TIGR02687', NULL, 'TIGR02687: TIGR02687 family protein', 844, NULL, 'TIGR02687', 288626),
(482952, 'TIGR02567', NULL, 'YscW: type III secretion system chaperone YscW', 124, NULL, 'TIGR02567', 288627),
(482953, 'TIGR03482', NULL, 'DMSO_red_II_cha: DMSO reductase family type II enzyme chaperone', 197, NULL, 'TIGR03482', 288628),
(482954, 'TIGR00012', NULL, 'L29: ribosomal protein uL29', 56, NULL, 'TIGR00012', 288629),
(482955, 'TIGR00597', NULL, 'rad10: DNA repair protein rad10', 112, NULL, 'TIGR00597', 288630),
(482956, 'TIGR01392', NULL, 'homoserO_Ac_trn: homoserine O-acetyltransferase', 351, NULL, 'TIGR01392', 288631),
(482957, 'TIGR02102', NULL, 'pullulan_Gpos: pullulanase, extracellular', 1113, NULL, 'TIGR02102', 288632),
(482958, 'TIGR00722', NULL, 'ttdA_fumA_fumB: hydrolyase, tartrate alpha subunit/fumarate domain protein, Fe-S type', 273, NULL, 'TIGR00722', 288633),
(482959, 'TIGR01736', NULL, 'FGAM_synth_II: phosphoribosylformylglycinamidine synthase II', 718, NULL, 'TIGR01736', 288634),
(482960, 'TIGR02683', NULL, 'upstrm_HI1419: putative addiction module killer protein', 95, NULL, 'TIGR02683', 288635),
(482961, 'TIGR00477', NULL, 'tehB: tellurite resistance protein TehB', 238, NULL, 'TIGR00477', 288636),
(482962, 'TIGR03826', NULL, 'YvyF: flagellar operon protein TIGR03826', 137, NULL, 'TIGR03826', 288637),
(482963, 'TIGR00593', NULL, 'pola: DNA polymerase I', 890, NULL, 'TIGR00593', 288638),
(482964, 'TIGR03486', NULL, 'cas_csx13_C: CRISPR-associated protein Cas8a1/Csx13, MYXAN subtype, C-terminal region', 152, NULL, 'TIGR03486', 288639),
(482965, 'TIGR04376', NULL, 'TIGR04376: TIGR04376 family protein', 189, NULL, 'TIGR04376', 288640),
(482966, 'TIGR03366', NULL, 'HpnZ_proposed: putative phosphonate catabolism associated alcohol dehydrogenase', 315, NULL, 'TIGR03366', 288641),
(482967, 'TIGR01276', NULL, 'thiB: thiamin/thiamin pyrophosphate ABC transporter, thiamin/thiamin pyrophospate-binding protein', 324, NULL, 'TIGR01276', 288642),
(482968, 'TIGR04281', NULL, 'peripla_PGF_1: putative ABC transporter PGF-CTERM-modified substrate-binding protein', 330, NULL, 'TIGR04281', 288643),
(482969, 'TIGR01396', NULL, 'FlgB: flagellar basal-body rod protein FlgB', 131, NULL, 'TIGR01396', 288644),
(482970, 'TIGR03706', NULL, 'exo_poly_only: exopolyphosphatase', 300, NULL, 'TIGR03706', 288645),
(482971, 'TIGR01852', NULL, 'lipid_A_lpxA: acyl-[acyl-carrier-protein]-UDP-N-acetylglucosamine O-acyltransferase', 254, NULL, 'TIGR01852', 288646),
(482972, 'TIGR03214', NULL, 'ura-cupin: putative allantoin catabolism protein', 260, NULL, 'TIGR03214', 288647),
(482973, 'TIGR03611', NULL, 'RutD: pyrimidine utilization protein D', 258, NULL, 'TIGR03611', 288648),
(482974, 'TIGR00445', NULL, 'mraY: phospho-N-acetylmuramoyl-pentapeptide-transferase', 321, NULL, 'TIGR00445', 288649),
(482975, 'TIGR03450', NULL, 'mycothiol_INO1: inositol 1-phosphate synthase', 355, NULL, 'TIGR03450', 288650),
(482976, 'TIGR02531', NULL, 'yecD_yerC: TrpR homolog YerC/YecD', 88, NULL, 'TIGR02531', 288651),
(482977, 'TIGR01521', NULL, 'FruBisAldo_II_B: fructose-bisphosphate aldolase, class II, Calvin cycle subtype', 347, NULL, 'TIGR01521', 288652),
(482978, 'TIGR02093', NULL, 'P_ylase: glycogen/starch/alpha-glucan phosphorylases', 804, NULL, 'TIGR02093', 288653),
(482979, 'TIGR02535', NULL, 'hyp_Hser_kinase: proposed homoserine kinase', 397, NULL, 'TIGR02535', 288654),
(482980, 'TIGR01616', NULL, 'nitro_assoc: nitrogenase-associated protein', 126, NULL, 'TIGR01616', 288655);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(482981, 'TIGR03021', NULL, 'pilP_fam: type IV pilus biogenesis protein PilP', 119, NULL, 'TIGR03021', 288656),
(482982, 'TIGR02191', NULL, 'RNaseIII: ribonuclease III', 219, NULL, 'TIGR02191', 288657),
(482983, 'TIGR01986', NULL, 'glut_syn_euk: glutathione synthetase', 473, NULL, 'TIGR01986', 288658),
(482984, 'TIGR02075', NULL, 'pyrH_bact: UMP kinase', 233, NULL, 'TIGR02075', 288659),
(482985, 'TIGR03577', NULL, 'EF_0830: conserved hypothetical protein EF_0830/AHA_3911', 115, NULL, 'TIGR03577', 288660),
(482986, 'TIGR03924', NULL, 'T7SS_EccC_a: type VII secretion protein EccCa', 673, NULL, 'TIGR03924', 288661),
(482987, 'TIGR04339', NULL, 'PQQ_MSMEG_3727: PQQ system protein', 151, NULL, 'TIGR04339', 288662),
(482988, 'TIGR04117', NULL, 'Syntroph_Cxxx: Cys-Xaa-Xaa-Xaa repeat radical SAM target protein', 98, NULL, 'TIGR04117', 288663),
(482989, 'TIGR01142', NULL, 'purT: phosphoribosylglycinamide formyltransferase 2', 380, NULL, 'TIGR01142', 288664),
(482990, 'TIGR03990', NULL, 'Arch_GlmM: phosphoglucosamine mutase', 444, NULL, 'TIGR03990', 288665),
(482991, 'TIGR04219', NULL, 'OMP_w_GlyGly: outer membrane protein', 234, NULL, 'TIGR04219', 288666),
(482992, 'TIGR03799', NULL, 'NOD_PanD_pyr: putative pyridoxal-dependent aspartate 1-decarboxylase', 522, NULL, 'TIGR03799', 288667),
(482993, 'TIGR00159', NULL, 'TIGR00159: TIGR00159 family protein', 254, NULL, 'TIGR00159', 288668),
(482994, 'TIGR01884', NULL, 'cas_HTH: CRISPR locus-related DNA-binding protein', 202, NULL, 'TIGR01884', 288669),
(482995, 'TIGR01405', NULL, 'polC_Gram_pos: DNA polymerase III, alpha subunit, Gram-positive type', 1211, NULL, 'TIGR01405', 288670),
(482996, 'TIGR00937', NULL, '2A51: chromate efflux transporter', 368, NULL, 'TIGR00937', 288671),
(482997, 'TIGR03112', NULL, '6_pyr_pter_rel: 6-pyruvoyl tetrahydropterin synthase-related domain', 113, NULL, 'TIGR03112', 288672),
(482998, 'TIGR00382', NULL, 'clpX: ATP-dependent Clp protease, ATP-binding subunit ClpX', 414, NULL, 'TIGR00382', 288673),
(482999, 'TIGR01294', NULL, 'P_lamban: phospholamban', 52, NULL, 'TIGR01294', 288674),
(483000, 'TIGR03942', NULL, 'sulfatase_rSAM: anaerobic sulfatase maturase', 363, NULL, 'TIGR03942', 288675),
(483001, 'TIGR02907', NULL, 'spore_VI_D: stage VI sporulation protein D', 344, NULL, 'TIGR02907', 288676),
(483002, 'TIGR00688', NULL, 'rarD: protein RarD', 256, NULL, 'TIGR00688', 288677),
(483003, 'TIGR01954', NULL, 'nusA_Cterm_rpt: transcription termination factor NusA, C-terminal duplication', 50, NULL, 'TIGR01954', 288678),
(483004, 'TIGR03870', NULL, 'ABC_MoxJ: methanol oxidation system protein MoxJ', 246, NULL, 'TIGR03870', 288679),
(483005, 'TIGR01641', NULL, 'phageSPP1_gp7: phage head morphogenesis protein, SPP1 gp7 family', 109, NULL, 'TIGR01641', 288680),
(483006, 'TIGR04031', NULL, 'Htur_1727_fam: rSAM-partnered protein, Htur_1727 family', 71, NULL, 'TIGR04031', 288681),
(483007, 'TIGR04285', NULL, 'nucleoid_noc: nucleoid occlusion protein', 255, NULL, 'TIGR04285', 288682),
(483008, 'TIGR04496', NULL, 'rSAM_XyeB: radical SAM/SPASM domain peptide maturase, XyeB family', 385, NULL, 'TIGR04496', 288683),
(483009, 'TIGR02324', NULL, 'CP_lyasePhnL: phosphonate C-P lyase system protein PhnL', 224, NULL, 'TIGR02324', 288684),
(483010, 'TIGR00695', NULL, 'uxuA: mannonate dehydratase', 394, NULL, 'TIGR00695', 288685),
(483011, 'TIGR00230', NULL, 'sfsA: sugar fermentation stimulation protein', 234, NULL, 'TIGR00230', 288686),
(483012, 'TIGR02147', NULL, 'Fsuc_second: TIGR02147 family protein', 272, NULL, 'TIGR02147', 288687),
(483013, 'TIGR02651', NULL, 'RNase_Z: ribonuclease Z', 302, NULL, 'TIGR02651', 288688),
(483014, 'TIGR02415', NULL, '23BDH: acetoin reductases', 254, NULL, 'TIGR02415', 288689),
(483015, 'TIGR03380', NULL, 'agmatine_aguA: agmatine deiminase', 357, NULL, 'TIGR03380', 288690),
(483016, 'TIGR04063', NULL, 'stp3: PEP-CTERM/exosortase A-associated glycosyltransferase, Daro_2409 family', 397, NULL, 'TIGR04063', 288691),
(483017, 'TIGR03334', NULL, 'IOR_beta: indolepyruvate ferredoxin oxidoreductase, beta subunit', 189, NULL, 'TIGR03334', 288692);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(483018, 'TIGR04410', NULL, 'Spiro_T2SS_lipo: type II secretion system-associated lipoprotein', 117, NULL, 'TIGR04410', 288693),
(483019, 'TIGR01732', NULL, 'tiny_TM_bacill: conserved hypothetical protein', 26, NULL, 'TIGR01732', 288694),
(483020, 'TIGR01228', NULL, 'hutU: urocanate hydratase', 545, NULL, 'TIGR01228', 288695),
(483021, 'TIGR03917', NULL, 'Frankia_40_dom: Frankia-40 domain', 40, NULL, 'TIGR03917', 288696),
(483022, 'TIGR00132', NULL, 'gatA: aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase, A subunit', 466, NULL, 'TIGR00132', 288697),
(483023, 'TIGR03189', NULL, 'dienoyl_CoA_hyt: cyclohexa-1,5-dienecarbonyl-CoA hydratase', 251, NULL, 'TIGR03189', 288698),
(483024, 'TIGR00699', NULL, 'GABAtrns_euk: 4-aminobutyrate aminotransferase', 464, NULL, 'TIGR00699', 288699),
(483025, 'TIGR01099', NULL, 'galU: UTP--glucose-1-phosphate uridylyltransferase', 261, NULL, 'TIGR01099', 288700),
(483026, 'TIGR03003', NULL, 'ectoine_ehuD: ectoine/hydroxyectoine ABC transporter, permease protein EhuD', 212, NULL, 'TIGR03003', 288701),
(483027, 'TIGR03123', NULL, 'one_C_unchar_1: probable H4MPT-linked C1 transfer pathway protein', 327, NULL, 'TIGR03123', 288702),
(483028, 'TIGR03584', NULL, 'PseF: pseudaminic acid cytidylyltransferase', 222, NULL, 'TIGR03584', 288703),
(483029, 'TIGR02860', NULL, 'spore_IV_B: stage IV sporulation protein B', 402, NULL, 'TIGR02860', 288704),
(483030, 'TIGR01514', NULL, 'NAPRTase: nicotinate phosphoribosyltransferase', 399, NULL, 'TIGR01514', 288705),
(483031, 'TIGR01979', NULL, 'sufS: cysteine desulfurase, SufS family', 403, NULL, 'TIGR01979', 288706),
(483032, 'TIGR00770', NULL, 'Dcu: transporter, anaerobic C4-dicarboxylate uptake (Dcu) family', 430, NULL, 'TIGR00770', 288707),
(483033, 'TIGR00491', NULL, 'aIF-2: translation initiation factor aIF-2', 594, NULL, 'TIGR00491', 288708),
(483034, 'TIGR04403', NULL, 'rSAM_skfB: sporulation killing factor system radical SAM maturase', 402, NULL, 'TIGR04403', 288709),
(483035, 'TIGR03468', NULL, 'HpnG: hopanoid-associated phosphorylase', 212, NULL, 'TIGR03468', 288710),
(483036, 'TIGR00824', NULL, 'EIIA-man: PTS system, mannose/fructose/sorbose family, IIA component', 116, NULL, 'TIGR00824', 288711),
(483037, 'TIGR02313', NULL, 'HpaI-NOT-DapA: 2,4-dihydroxyhept-2-ene-1,7-dioic acid aldolase', 294, NULL, 'TIGR02313', 288712),
(483038, 'TIGR01181', NULL, 'dTDP_gluc_dehyt: dTDP-glucose 4,6-dehydratase', 321, NULL, 'TIGR01181', 288713),
(483039, 'TIGR02894', NULL, 'DNA_bind_RsfA: transcription factor, RsfA family', 161, NULL, 'TIGR02894', 288714),
(483040, 'TIGR01750', NULL, 'fabZ: beta-hydroxyacyl-(acyl-carrier-protein) dehydratase FabZ', 141, NULL, 'TIGR01750', 288715),
(483041, 'TIGR03928', NULL, 'T7_EssCb_Firm: type VII secretion protein EssC', 1296, NULL, 'TIGR03928', 288716),
(483042, 'TIGR00343', NULL, 'TIGR00343: pyridoxal 5''-phosphate synthase, synthase subunit Pdx1', 287, NULL, 'TIGR00343', 288717),
(483043, 'TIGR03048', NULL, 'PS_I_psaC: photosystem I iron-sulfur protein PsaC', 80, NULL, 'TIGR03048', 288718),
(483044, 'TIGR03808', NULL, 'RR_plus_rpt_1: twin-arg-translocated uncharacterized repeat protein', 455, NULL, 'TIGR03808', 288719),
(483045, 'TIGR01498', NULL, 'folK: 2-amino-4-hydroxy-6-hydroxymethyldihydropteridine diphosphokinase', 128, NULL, 'TIGR01498', 288720),
(483046, 'TIGR01838', NULL, 'PHA_synth_I: poly(R)-hydroxyalkanoic acid synthase, class I', 532, NULL, 'TIGR01838', 288721),
(483047, 'TIGR01743', NULL, 'purR_Bsub: pur operon repressor PurR', 268, NULL, 'TIGR01743', 288722),
(483048, 'TIGR00350', NULL, 'lytR_cpsA_psr: cell envelope-related function transcriptional attenuator common domain', 152, NULL, 'TIGR00350', 288723),
(483049, 'TIGR04274', NULL, 'hypoxanDNAglyco: DNA-deoxyinosine glycosylase', 150, NULL, 'TIGR04274', 288724),
(483050, 'TIGR02440', NULL, 'FadJ: fatty oxidation complex, alpha subunit FadJ', 699, NULL, 'TIGR02440', 288725),
(483051, 'TIGR02898', NULL, 'spore_YhcN_YlaJ: sporulation lipoprotein, YhcN/YlaJ family', 158, NULL, 'TIGR02898', 288726),
(483052, 'TIGR01174', NULL, 'ftsA: cell division protein FtsA', 371, NULL, 'TIGR01174', 288727);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(483053, 'TIGR02358', NULL, 'thia_cytX: putative hydroxymethylpyrimidine transporter CytX', 386, NULL, 'TIGR02358', 288728),
(483054, 'TIGR02669', NULL, 'SpoIID_LytB: SpoIID/LytB domain', 270, NULL, 'TIGR02669', 288729),
(483055, 'TIGR01439', NULL, 'lp_hng_hel_AbrB: transcriptional regulator, AbrB family', 44, NULL, 'TIGR01439', 288730),
(483056, 'TIGR02204', NULL, 'MsbA_rel: ABC transporter, permease/ATP-binding protein', 576, NULL, 'TIGR02204', 288731),
(483057, 'TIGR02433', NULL, 'lysidine_TilS_C: tRNA(Ile)-lysidine synthetase, C-terminal domain', 47, NULL, 'TIGR02433', 288732),
(483058, 'TIGR04448', NULL, 'creatininase: creatininase', 246, NULL, 'TIGR04448', 288733),
(483059, 'TIGR03529', NULL, 'GldK_short: gliding motility-associated lipoprotein GldK', 345, NULL, 'TIGR03529', 288734),
(483060, 'TIGR01033', NULL, 'TIGR01033: DNA-binding regulatory protein, YebC/PmpR family', 238, NULL, 'TIGR01033', 288735),
(483061, 'TIGR00114', NULL, 'lumazine-synth: 6,7-dimethyl-8-ribityllumazine synthase', 138, NULL, 'TIGR00114', 288736),
(483062, 'TIGR03588', NULL, 'PseC: UDP-4-amino-4,6-dideoxy-N-acetyl-beta-L-altrosamine transaminase', 380, NULL, 'TIGR03588', 288737),
(483063, 'TIGR00831', NULL, 'a_cpa1: Na+/H+ antiporter', 525, NULL, 'TIGR00831', 288738),
(483064, 'TIGR00890', NULL, '2A0111: oxalate/formate antiporter family transporter', 377, NULL, 'TIGR00890', 288739),
(483065, 'TIGR00484', NULL, 'EF-G: translation elongation factor G', 691, NULL, 'TIGR00484', 288740),
(483066, 'TIGR02249', NULL, 'integrase_gron: integron integrase', 315, NULL, 'TIGR02249', 288741),
(483067, 'TIGR02129', NULL, 'hisA_euk: phosphoribosylformimino-5-aminoimidazole carboxamide ribotide isomerase', 255, NULL, 'TIGR02129', 288742),
(483068, 'TIGR02195', NULL, 'heptsyl_trn_II: lipopolysaccharide heptosyltransferase II', 339, NULL, 'TIGR02195', 288743),
(483069, 'TIGR03010', NULL, 'sulf_tusC_dsrF: sulfur relay protein TusC/DsrF', 116, NULL, 'TIGR03010', 288744),
(483070, 'TIGR03697', NULL, 'NtcA_cyano: global nitrogen regulator NtcA', 193, NULL, 'TIGR03697', 288745),
(483071, 'TIGR04512', NULL, 'Mycopla_NOT_gsn: STREFT protein', 1045, NULL, 'TIGR04512', 288746),
(483072, 'TIGR01040', NULL, 'V-ATPase_V1_B: V-type ATPase, B subunit', 467, NULL, 'TIGR01040', 288747),
(483073, 'TIGR02027', NULL, 'rpoA: DNA-directed RNA polymerase, alpha subunit', 298, NULL, 'TIGR02027', 288748),
(483074, 'TIGR04165', NULL, 'methano_modCys: Cys-rich peptide, TIGR04165 family', 50, NULL, 'TIGR04165', 288749),
(483075, 'TIGR03232', NULL, 'benzo_1_2_benB: benzoate 1,2-dioxygenase, small subunit', 155, NULL, 'TIGR03232', 288750),
(483076, 'TIGR04387', NULL, 'capsid_maj_N4: major capsid protein, N4-gp56 family', 324, NULL, 'TIGR04387', 288751),
(483077, 'TIGR00933', NULL, '2a38: potassium uptake protein, TrkH family', 391, NULL, 'TIGR00933', 288752),
(483078, 'TIGR00817', NULL, 'tpt: Tpt phosphate/phosphoenolpyruvate translocator', 302, NULL, 'TIGR00817', 288753),
(483079, 'TIGR00241', NULL, 'CoA_E_activ: putative CoA-substrate-specific enzyme activase', 248, NULL, 'TIGR00241', 288754),
(483080, 'TIGR01623', NULL, 'put_zinc_LRP1: putative zinc finger domain, LRP1 type', 43, NULL, 'TIGR01623', 288755),
(483081, 'TIGR02778', NULL, 'ligD_pol: DNA ligase D, polymerase domain', 245, NULL, 'TIGR02778', 288756),
(483082, 'TIGR02542', NULL, 'T_forsyth_147: TANFOR domain', 145, NULL, 'TIGR02542', 288757),
(483083, 'TIGR01507', NULL, 'hopene_cyclase: squalene-hopene cyclase', 640, NULL, 'TIGR01507', 288758),
(483084, 'TIGR01630', NULL, 'psiM2_ORF9: phage uncharacterized protein, C-terminal domain', 142, NULL, 'TIGR01630', 288759),
(483085, 'TIGR01283', NULL, 'nifE: nitrogenase MoFe cofactor biosynthesis protein NifE', 459, NULL, 'TIGR01283', 288760),
(483086, 'TIGR02785', NULL, 'addA_Gpos: helicase-exonuclease AddAB, AddA subunit', 1234, NULL, 'TIGR02785', 288761),
(483087, 'TIGR02792', NULL, 'PCA_ligA: protocatechuate 4,5-dioxygenase, alpha subunit', 117, NULL, 'TIGR02792', 288762),
(483088, 'TIGR03815', NULL, 'CpaE_hom_Actino: helicase/secretion neighborhood CpaE-like protein', 340, NULL, 'TIGR03815', 288763);
INSERT INTO "PUBLIC"."MODEL" VALUES
(483089, 'TIGR00234', NULL, 'tyrS: tyrosine--tRNA ligase', 406, NULL, 'TIGR00234', 288764),
(483090, 'TIGR04328', NULL, 'cas4_PREFRAN: CRISPR-associated protein Cas4, subtype PREFRAN', 178, NULL, 'TIGR04328', 288765),
(483091, 'TIGR00057', NULL, 'TIGR00057: tRNA threonylcarbamoyl adenosine modification protein, Sua5/YciO/YrdC/YwlC family', 202, NULL, 'TIGR00057', 288766),
(483092, 'TIGR02320', NULL, 'PEP_mutase: phosphoenolpyruvate mutase', 284, NULL, 'TIGR02320', 288767),
(483093, 'TIGR03822', NULL, 'AblA_like_2: lysine-2,3-aminomutase-related protein', 321, NULL, 'TIGR03822', 288768),
(483094, 'TIGR01559', NULL, 'squal_synth: farnesyl-diphosphate farnesyltransferase', 337, NULL, 'TIGR01559', 288769),
(483095, 'TIGR04394', NULL, 'choline_CutC: choline trimethylamine-lyase', 789, NULL, 'TIGR04394', 288770),
(483096, 'TIGR04505', NULL, 'PtsS_plasma: phosphate ABC transporter substrate-binding protein', 334, NULL, 'TIGR04505', 288771),
(483097, 'TIGR01290', NULL, 'nifB: nitrogenase cofactor biosynthesis protein NifB', 441, NULL, 'TIGR01290', 288772),
(483098, 'TIGR02962', NULL, 'hdxy_isourate: hydroxyisourate hydrolase', 113, NULL, 'TIGR02962', 288773),
(483099, 'TIGR03475', NULL, 'tap_IncFII_lead: RepA leader peptide Tap', 25, NULL, 'TIGR03475', 288774),
(483100, 'TIGR01135', NULL, 'glmS: glutamine-fructose-6-phosphate transaminase (isomerizing)', 607, NULL, 'TIGR01135', 288775),
(483101, 'TIGR02104', NULL, 'pulA_typeI: pullulanase, type I', 605, NULL, 'TIGR02104', 288776),
(483102, 'TIGR01961', NULL, 'NuoC_fam: NADH (or F420H2) dehydrogenase, subunit C', 122, NULL, 'TIGR01961', 288777),
(483103, 'TIGR00014', NULL, 'arsC: arsenate reductase (glutaredoxin)', 114, NULL, 'TIGR00014', 288778),
(483104, 'TIGR00166', NULL, 'S6: ribosomal protein bS6', 95, NULL, 'TIGR00166', 288779),
(483105, 'TIGR01993', NULL, 'Pyr-5-nucltdase: pyrimidine 5''-nucleotidase', 183, NULL, 'TIGR01993', 288780),
(483106, 'TIGR03225', NULL, 'benzo_boxB: benzoyl-CoA oxygenase, B subunit', 471, NULL, 'TIGR03225', 288781),
(483107, 'TIGR03708', NULL, 'poly_P_AMP_trns: polyphosphate:AMP phosphotransferase', 493, NULL, 'TIGR03708', 288782),
(483108, 'TIGR01167', NULL, 'LPXTG_anchor: LPXTG cell wall anchor domain', 34, NULL, 'TIGR01167', 288783),
(483109, 'TIGR01618', NULL, 'phage_P_loop: phage nucleotide-binding protein', 220, NULL, 'TIGR01618', 288784),
(483110, 'TIGR00992', NULL, '3a0901s03IAP75: chloroplast envelope protein translocase, IAP75 family', 718, NULL, 'TIGR00992', 288785),
(483111, 'TIGR03538', NULL, 'DapC_gpp: succinyldiaminopimelate transaminase', 395, NULL, 'TIGR03538', 288786),
(483112, 'TIGR02739', NULL, 'TraF: type-F conjugative transfer system pilin assembly protein TraF', 256, NULL, 'TIGR02739', 288787),
(483113, 'TIGR01448', NULL, 'recD_rel: helicase, RecD/TraA family', 720, NULL, 'TIGR01448', 288788),
(483114, 'TIGR04056', NULL, 'OMP_RagA_SusC: TonB-linked outer membrane protein, SusC/RagA family', 981, NULL, 'TIGR04056', 288789),
(483115, 'TIGR00649', NULL, 'MG423: beta-CASP ribonuclease, RNase J family', 546, NULL, 'TIGR00649', 288790),
(483116, 'TIGR02930', NULL, 'vnfG_nitrog: V-containing nitrogenase, delta subunit', 109, NULL, 'TIGR02930', 288791),
(483117, 'TIGR00840', NULL, 'b_cpa1: sodium/hydrogen exchanger 3', 559, NULL, 'TIGR00840', 288792),
(483118, 'TIGR00336', NULL, 'pyrE: orotate phosphoribosyltransferase', 173, NULL, 'TIGR00336', 288793),
(483119, 'TIGR03055', NULL, 'photo_alph_chp2: putative photosynthetic complex assembly protein 2', 245, NULL, 'TIGR03055', 288794),
(483120, 'TIGR04226', NULL, 'RrgB_K2N_iso_D2: fimbrial isopeptide formation D2 domain', 123, NULL, 'TIGR04226', 288795),
(483121, 'TIGR02760', NULL, 'TraI_TIGR: conjugative transfer relaxase protein TraI', 1960, NULL, 'TIGR02760', 288796),
(483122, 'TIGR01305', NULL, 'GMP_reduct_1: guanosine monophosphate reductase', 343, NULL, 'TIGR01305', 288797),
(483123, 'TIGR00670', NULL, 'asp_carb_tr: aspartate carbamoyltransferase', 304, NULL, 'TIGR00670', 288798),
(483124, 'TIGR01337', NULL, 'apcB: allophycocyanin, beta subunit', 167, NULL, 'TIGR01337', 288799);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(483125, 'TIGR03427', NULL, 'ABC_peri_uca: ABC transporter periplasmic binding protein, urea carboxylase region', 328, NULL, 'TIGR03427', 288800),
(483126, 'TIGR04337', NULL, 'AmmeMemoSam_rS: AmmeMemoRadiSam system radical SAM enzyme', 349, NULL, 'TIGR04337', 288801),
(483127, 'TIGR03257', NULL, 'met_CoM_red_bet: methyl-coenzyme M reductase, beta subunit', 433, NULL, 'TIGR03257', 288802),
(483128, 'TIGR02247', NULL, 'HAD-1A3-hyp: epoxide hydrolase N-terminal domain-like phosphatase', 211, NULL, 'TIGR02247', 288803),
(483129, 'TIGR04065', NULL, 'ocin_CLI_3235: putative bacteriocin precursor, CLI_3235 family', 34, NULL, 'TIGR04065', 288804),
(483130, 'TIGR00157', NULL, 'TIGR00157: ribosome small subunit-dependent GTPase A', 247, NULL, 'TIGR00157', 288805),
(483131, 'TIGR04507', NULL, 'fluorinase: adenosyl-fluoride synthase', 286, NULL, 'TIGR04507', 288806),
(483132, 'TIGR02417', NULL, 'fruct_sucro_rep: D-fructose-responsive transcription factor', 327, NULL, 'TIGR02417', 288807),
(483133, 'TIGR00327', NULL, 'secE_euk_arch: protein translocase SEC61 complex gamma subunit, archaeal and eukaryotic', 61, NULL, 'TIGR00327', 288808),
(483134, 'TIGR03087', NULL, 'stp1: sugar transferase, PEP-CTERM/EpsH1 system associated', 397, NULL, 'TIGR03087', 288809),
(483135, 'TIGR00538', NULL, 'hemN: oxygen-independent coproporphyrinogen III oxidase', 454, NULL, 'TIGR00538', 288810),
(483136, 'TIGR02971', NULL, 'heterocyst_DevB: ABC exporter membrane fusion protein, DevB family', 327, NULL, 'TIGR02971', 288811),
(483137, 'TIGR00055', NULL, 'uppS: di-trans,poly-cis-decaprenylcistransferase', 228, NULL, 'TIGR00055', 288812),
(483138, 'TIGR00506', NULL, 'ribB: 3,4-dihydroxy-2-butanone-4-phosphate synthase', 204, NULL, 'TIGR00506', 288813),
(483139, 'TIGR03198', NULL, 'pucE: xanthine dehydrogenase E subunit', 151, NULL, 'TIGR03198', 288814),
(483140, 'TIGR01850', NULL, 'argC: N-acetyl-gamma-glutamyl-phosphate reductase', 345, NULL, 'TIGR01850', 288815),
(483141, 'TIGR02297', NULL, 'HpaA: 4-hydroxyphenylacetate catabolism regulatory protein HpaA', 287, NULL, 'TIGR02297', 288816),
(483142, 'TIGR00983', NULL, '3a0801s02tim23: mitochondrial import inner membrane translocase subunit', 149, NULL, 'TIGR00983', 288817),
(483143, 'TIGR01176', NULL, 'fum_red_Fp: fumarate reductase (quinol), flavoprotein subunit', 580, NULL, 'TIGR01176', 288818),
(483144, 'TIGR01659', NULL, 'sex-lethal: sex-lethal family splicing factor', 346, NULL, 'TIGR01659', 288819),
(483145, 'TIGR03872', NULL, 'cytochrome_MoxG: cytochrome c(L), periplasmic', 133, NULL, 'TIGR03872', 288820),
(483146, 'TIGR03368', NULL, 'cellulose_yhjU: cellulose synthase operon protein YhjU', 518, NULL, 'TIGR03368', 288821),
(483147, 'TIGR04167', NULL, 'rSAM_SeCys: radical SAM/Cys-rich domain protein', 303, NULL, 'TIGR04167', 288822),
(483148, 'TIGR01489', NULL, 'DKMTPPase-SF: 2,3-diketo-5-methylthio-1-phosphopentane phosphatase', 188, NULL, 'TIGR01489', 288823),
(483149, 'TIGR00819', NULL, 'ydaH: AbgT transporter family', 521, NULL, 'TIGR00819', 288824),
(483150, 'TIGR01024', NULL, 'rplS_bact: ribosomal protein bL19', 114, NULL, 'TIGR01024', 288825),
(483151, 'TIGR01791', NULL, 'CM_archaeal: chorismate mutase', 83, NULL, 'TIGR01791', 288826),
(483152, 'TIGR00708', NULL, 'cobA: cob(I)yrinic acid a,c-diamide adenosyltransferase', 177, NULL, 'TIGR00708', 288827),
(483153, 'TIGR02690', NULL, 'resist_ArsH: arsenical resistance protein ArsH', 219, NULL, 'TIGR02690', 288828),
(483154, 'TIGR03720', NULL, 'exospor_lead: exosporium leader peptide', 19, NULL, 'TIGR03720', 288829),
(483155, 'TIGR01346', NULL, 'isocit_lyase: isocitrate lyase', 527, NULL, 'TIGR01346', 288830),
(483156, 'TIGR04024', NULL, 'F420_NP1902A: coenzyme F420-dependent oxidoreductase, NP1902A family', 330, NULL, 'TIGR04024', 288831),
(483157, 'TIGR00479', NULL, 'rumA: 23S rRNA (uracil-5-)-methyltransferase RumA', 432, NULL, 'TIGR00479', 288832),
(483158, 'TIGR01680', NULL, 'Veg_Stor_Prot: vegetative storage protein', 270, NULL, 'TIGR01680', 288833),
(483159, 'TIGR04378', NULL, 'myo_inos_iolB: 5-deoxy-glucuronate isomerase', 247, NULL, 'TIGR04378', 288834);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(483160, 'TIGR03046', NULL, 'PS_II_psbV2: photosystem II cytochrome PsbV2', 157, NULL, 'TIGR03046', 288835),
(483161, 'TIGR04548', NULL, 'DnaD_Mollicutes: DnaD family protein', 178, NULL, 'TIGR04548', 288836),
(483162, 'TIGR00198', NULL, 'cat_per_HPI: catalase/peroxidase HPI', 716, NULL, 'TIGR00198', 288837),
(483163, 'TIGR03216', NULL, 'OH_muco_semi_DH: 2-hydroxymuconic semialdehyde dehydrogenase', 481, NULL, 'TIGR03216', 288838),
(483164, 'TIGR00368', NULL, 'TIGR00368: Mg chelatase-like protein', 499, NULL, 'TIGR00368', 288839),
(483165, 'TIGR04489', NULL, 'exosort_XrtO: exosortase O', 451, NULL, 'TIGR04489', 288840),
(483166, 'TIGR03550', NULL, 'F420_cofG: 7,8-didemethyl-8-hydroxy-5-deazariboflavin synthase, CofG subunit', 322, NULL, 'TIGR03550', 288841),
(483167, 'TIGR00096', NULL, 'TIGR00096: 16S rRNA (cytidine(1402)-2''-O)-methyltransferase', 275, NULL, 'TIGR00096', 288842),
(483168, 'TIGR02637', NULL, 'RhaS: rhamnose ABC transporter, rhamnose-binding protein', 302, NULL, 'TIGR02637', 288843),
(483169, 'TIGR03155', NULL, 'sulfolob_CbsB: cytochrome b558/566, subunit B', 302, NULL, 'TIGR03155', 288844),
(483170, 'TIGR03606', NULL, 'non_repeat_PQQ: dehydrogenase, PQQ-dependent, s-GDH family', 454, NULL, 'TIGR03606', 288845),
(483171, 'TIGR03981', NULL, 'SAM_quin_mod: His-Xaa-Ser system putative quinone modification maturase', 411, NULL, 'TIGR03981', 288846),
(483172, 'TIGR02186', NULL, 'alph_Pro_TM: conserved hypothetical protein', 261, NULL, 'TIGR02186', 288847),
(483173, 'TIGR00547', NULL, 'lolA: outer membrane lipoprotein carrier protein LolA', 204, NULL, 'TIGR00547', 288848),
(483174, 'TIGR01891', NULL, 'amidohydrolases: amidohydrolase', 366, NULL, 'TIGR01891', 288849),
(483175, 'TIGR02206', NULL, 'intg_mem_TP0381: conserved hypothetical integral membrane protein TIGR02206', 222, NULL, 'TIGR02206', 288850),
(483176, 'TIGR02581', NULL, 'cas_cyan_RAMP: CRISPR-associated RAMP protein, SSO1426 family', 216, NULL, 'TIGR02581', 288851),
(483177, 'TIGR02519', NULL, 'pilus_MshL: pilus (MSHA type) biogenesis protein MshL', 290, NULL, 'TIGR02519', 288852),
(483178, 'TIGR03157', NULL, 'cas_Csc2: CRISPR type I-D/CYANO-associated protein Csc2', 282, NULL, 'TIGR03157', 288853),
(483179, 'TIGR04124', NULL, 'archaeo_artE: archaeosortase family protein ArtE', 153, NULL, 'TIGR04124', 288854),
(483180, 'TIGR02036', NULL, 'dsdC: D-serine deaminase transcriptional activator', 302, NULL, 'TIGR02036', 288855),
(483181, 'TIGR02002', NULL, 'PTS-II-BC-glcB: PTS system, glucose-specific IIBC component', 502, NULL, 'TIGR02002', 288856),
(483182, 'TIGR01067', NULL, 'rplN_bact: ribosomal protein uL14', 122, NULL, 'TIGR01067', 288857),
(483183, 'TIGR04126', NULL, 'PGF_CTERM: PGF-CTERM archaeal protein-sorting signal', 28, NULL, 'TIGR04126', 288858),
(483184, 'TIGR03327', NULL, 'AMP_phos: AMP phosphorylase', 500, NULL, 'TIGR03327', 288859),
(483185, 'TIGR02467', NULL, 'CbiE: precorrin-6y C5,15-methyltransferase (decarboxylating), CbiE subunit', 204, NULL, 'TIGR02467', 288860),
(483186, 'TIGR01237', NULL, 'D1pyr5carbox2: putative delta-1-pyrroline-5-carboxylate dehydrogenase', 511, NULL, 'TIGR01237', 288861),
(483187, 'TIGR01065', NULL, 'hlyIII: channel protein, hemolysin III family', 204, NULL, 'TIGR01065', 288862),
(483188, 'TIGR00377', NULL, 'ant_ant_sig: anti-anti-sigma factor', 108, NULL, 'TIGR00377', 288863),
(483189, 'TIGR01829', NULL, 'AcAcCoA_reduct: acetoacetyl-CoA reductase', 242, NULL, 'TIGR01829', 288864),
(483190, 'TIGR04405', NULL, 'SkfF: sporulation killing factor system integral membrane protein', 472, NULL, 'TIGR04405', 288865),
(483191, 'TIGR00717', NULL, 'rpsA: ribosomal protein bS1', 516, NULL, 'TIGR00717', 288866),
(483192, 'TIGR02751', NULL, 'PEPCase_arch: phosphoenolpyruvate carboxylase', 506, NULL, 'TIGR02751', 288867),
(483193, 'TIGR02807', NULL, 'cas6_cmx6: CRISPR-associated protein Cas6, subtype MYXAN', 197, NULL, 'TIGR02807', 288868),
(483194, 'TIGR00438', NULL, 'rrmJ: ribosomal RNA large subunit methyltransferase J', 188, NULL, 'TIGR00438', 288869),
(483195, 'TIGR02692', NULL, 'tRNA_CCA_actino: CCA tRNA nucleotidyltransferase', 466, NULL, 'TIGR02692', 288870);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(483196, 'TIGR00268', NULL, 'TIGR00268: TIGR00268 family protein', 253, NULL, 'TIGR00268', 288871),
(483197, 'TIGR02862', NULL, 'spore_BofA: pro-sigmaK processing inhibitor BofA', 83, NULL, 'TIGR02862', 288872),
(483198, 'TIGR04235', NULL, 'seadorna_VP4: seadornavirus VP4 protein', 618, NULL, 'TIGR04235', 288873),
(483199, 'TIGR00901', NULL, '2A0125: AmpG-like permease', 357, NULL, 'TIGR00901', 288874),
(483200, 'TIGR02921', NULL, 'PEP_integral: PEP-CTERM family integral membrane protein', 922, NULL, 'TIGR02921', 288875),
(483201, 'TIGR01952', NULL, 'nusA_arch: NusA family KH domain protein, archaeal', 141, NULL, 'TIGR01952', 288876),
(483202, 'TIGR02590', NULL, 'cas_Csh2: CRISPR-associated protein Cas7/Csh2, subtype I-B/HMARI', 286, NULL, 'TIGR02590', 288877),
(483203, 'TIGR00608', NULL, 'radc: DNA repair protein RadC', 218, NULL, 'TIGR00608', 288878),
(483204, 'TIGR03974', NULL, 'rSAM_six_Cys: SCIFF radical SAM maturase', 451, NULL, 'TIGR03974', 288879),
(483205, 'TIGR01126', NULL, 'pdi_dom: protein disulfide-isomerase domain', 105, NULL, 'TIGR01126', 288880),
(483206, 'TIGR03266', NULL, 'methan_mark_1: putative methanogenesis marker protein 1', 376, NULL, 'TIGR03266', 288881),
(483207, 'TIGR03148', NULL, 'cyt_nit_nrfD: cytochrome c nitrite reductase, NrfD subunit', 316, NULL, 'TIGR03148', 288882),
(483208, 'TIGR00450', NULL, 'mnmE_trmE_thdF: tRNA modification GTPase TrmE', 446, NULL, 'TIGR00450', 288883),
(483209, 'TIGR04133', NULL, 'rSAM_w_lipo: radical SAM enzyme, rSAM/lipoprotein system', 350, NULL, 'TIGR04133', 288884),
(483210, 'TIGR04015', NULL, 'WcaC: colanic acid biosynthesis glycosyltransferase WcaC', 405, NULL, 'TIGR04015', 288885),
(483211, 'TIGR00606', NULL, 'rad50: rad50', 1311, NULL, 'TIGR00606', 288886),
(483212, 'TIGR00259', NULL, 'thylakoid_BtpA: membrane complex biogenesis protein, BtpA family', 257, NULL, 'TIGR00259', 288887),
(483213, 'TIGR04303', NULL, 'GeoRSP_rSAM: GeoRSP system radical SAM/SPASM protein', 325, NULL, 'TIGR04303', 288888),
(483214, 'TIGR00280', NULL, 'eL43_euk_arch: ribosomal protein eL43', 92, NULL, 'TIGR00280', 288889),
(483215, 'TIGR01407', NULL, 'dinG_rel: putative DnaQ family exonuclease/DinG family helicase', 889, NULL, 'TIGR01407', 288890),
(483216, 'TIGR01782', NULL, 'TonB-Xanth-Caul: TonB-dependent receptor', 868, NULL, 'TIGR01782', 288891),
(483217, 'TIGR02909', NULL, 'spore_YkwD: uncharacterized protein, YkwD family', 127, NULL, 'TIGR02909', 288892),
(483218, 'TIGR00436', NULL, 'era: GTP-binding protein Era', 270, NULL, 'TIGR00436', 288893),
(483219, 'TIGR03096', NULL, 'nitroso_cyanin: nitrosocyanin', 135, NULL, 'TIGR03096', 288894),
(483220, 'TIGR00089', NULL, 'TIGR00089: radical SAM methylthiotransferase, MiaB/RimO family', 429, NULL, 'TIGR00089', 288895),
(483221, 'TIGR01879', NULL, 'hydantase: amidase, hydantoinase/carbamoylase family', 401, NULL, 'TIGR01879', 288896),
(483222, 'TIGR03325', NULL, 'BphB_TodD: cis-2,3-dihydrobiphenyl-2,3-diol dehydrogenase', 263, NULL, 'TIGR03325', 288897),
(483223, 'TIGR00731', NULL, 'bL25_bact_ctc: ribosomal protein bL25, Ctc-form', 176, NULL, 'TIGR00731', 288898),
(483224, 'TIGR03429', NULL, 'arom_pren_DMATS: aromatic prenyltransferase, DMATS type', 408, NULL, 'TIGR03429', 288899),
(483225, 'TIGR01893', NULL, 'aa-his-dipept: Xaa-His dipeptidase', 478, NULL, 'TIGR01893', 288900),
(483226, 'TIGR00266', NULL, 'TIGR00266: TIGR00266 family protein', 222, NULL, 'TIGR00266', 288901),
(483227, 'TIGR03436', NULL, 'acidobact_VWFA: VWFA-related Acidobacterial domain', 324, NULL, 'TIGR03436', 288902),
(483228, 'TIGR01414', NULL, 'autotrans_barl: outer membrane autotransporter barrel domain', 432, NULL, 'TIGR01414', 288903),
(483229, 'TIGR02288', NULL, 'PaaN_2: phenylacetic acid degradation protein paaN', 551, NULL, 'TIGR02288', 288904),
(483230, 'TIGR02569', NULL, 'TIGR02569_actnb: TIGR02569 family protein', 272, NULL, 'TIGR02569', 288905),
(483231, 'TIGR01244', NULL, 'TIGR01244: TIGR01244 family protein', 135, NULL, 'TIGR01244', 288906),
(483232, 'TIGR00561', NULL, 'pntA: NAD(P)(+) transhydrogenase (AB-specific), alpha subunit', 511, NULL, 'TIGR00561', 288907);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(483233, 'TIGR03318', NULL, 'YdfZ_fam: putative selenium-binding protein YdfZ', 65, NULL, 'TIGR03318', 288908),
(483234, 'TIGR01074', NULL, 'rep: ATP-dependent DNA helicase Rep', 668, NULL, 'TIGR01074', 288909),
(483235, 'TIGR02628', NULL, 'fuculo_kin_coli: L-fuculokinase', 465, NULL, 'TIGR02628', 288910),
(483236, 'TIGR02399', NULL, 'salt_tol_Pase: glucosylglycerol 3-phosphatase', 389, NULL, 'TIGR02399', 288911),
(483237, 'TIGR02458', NULL, 'CbtA: cobalt transporter subunit CbtA (proposed)', 230, NULL, 'TIGR02458', 288912),
(483238, 'TIGR03259', NULL, 'met_CoM_red_gam: methyl-coenzyme M reductase, gamma subunit', 244, NULL, 'TIGR03259', 288913),
(483239, 'TIGR04228', NULL, 'isopep_sspB_C2: adhesin isopeptide-forming adherence domain', 173, NULL, 'TIGR04228', 288914),
(483240, 'TIGR01169', NULL, 'rplA_bact: ribosomal protein uL1', 227, NULL, 'TIGR01169', 288915),
(483241, 'TIGR02138', NULL, 'phosphate_pstC: phosphate ABC transporter, permease protein PstC', 296, NULL, 'TIGR02138', 288916),
(483242, 'TIGR02084', NULL, 'leud: 3-isopropylmalate dehydratase, small subunit', 156, NULL, 'TIGR02084', 288917),
(483243, 'TIGR02964', NULL, 'xanthine_xdhC: xanthine dehydrogenase accessory protein XdhC', 246, NULL, 'TIGR02964', 288918),
(483244, 'TIGR01530', NULL, 'nadN: NAD nucleotidase', 550, NULL, 'TIGR01530', 288919),
(483245, 'TIGR03053', NULL, 'PS_I_psaM: photosystem I reaction center subunit XII', 29, NULL, 'TIGR03053', 288920),
(483246, 'TIGR01017', NULL, 'rpsD_bact: ribosomal protein uS4', 200, NULL, 'TIGR01017', 288921),
(483247, 'TIGR03107', NULL, 'glu_aminopep: glutamyl aminopeptidase', 350, NULL, 'TIGR03107', 288922),
(483248, 'TIGR04174', NULL, 'IPTL_CTERM: IPTL-CTERM protein sorting domain', 27, NULL, 'TIGR04174', 288923),
(483249, 'TIGR00164', NULL, 'PS_decarb_rel: phosphatidylserine decarboxylase homolog', 215, NULL, 'TIGR00164', 288924),
(483250, 'TIGR02812', NULL, 'fadR_gamma: fatty acid metabolism transcriptional regulator FadR', 235, NULL, 'TIGR02812', 288925),
(483251, 'TIGR00218', NULL, 'manA: mannose-6-phosphate isomerase, class I', 359, NULL, 'TIGR00218', 288926),
(483252, 'TIGR01995', NULL, 'PTS-II-ABC-beta: PTS system, beta-glucoside-specific IIABC component', 618, NULL, 'TIGR01995', 288927),
(483253, 'TIGR04344', NULL, 'ovoA_Nterm: 5-histidylcysteine sulfoxide synthase', 444, NULL, 'TIGR04344', 288928),
(483254, 'TIGR00048', NULL, 'rRNA_mod_RlmN: 23S rRNA (adenine(2503)-C(2))-methyltransferase', 355, NULL, 'TIGR00048', 288929),
(483255, 'TIGR02308', NULL, 'RNA_lig_T4_1: RNA ligase, T4 RnlA family', 373, NULL, 'TIGR02308', 288930),
(483256, 'TIGR02254', NULL, 'YjjG/YfnB: noncanonical pyrimidine nucleotidase, YjjG family', 223, NULL, 'TIGR02254', 288931),
(483257, 'TIGR01700', NULL, 'PNPH: purine nucleoside phosphorylase I, inosine and guanosine-specific', 249, NULL, 'TIGR01700', 288932),
(483258, 'TIGR00799', NULL, 'mtp: Golgi 4-transmembrane spanning transporter', 258, NULL, 'TIGR00799', 288933),
(483259, 'TIGR03817', NULL, 'DECH_helic: helicase/secretion neighborhood putative DEAH-box helicase', 742, NULL, 'TIGR03817', 288934),
(483260, 'TIGR02794', NULL, 'tolA_full: protein TolA', 362, NULL, 'TIGR02794', 288935),
(483261, 'TIGR01727', NULL, 'oligo_HPY: oligopeptide/dipeptide ABC transporter, ATP-binding protein, C-terminal domain', 87, NULL, 'TIGR01727', 288936),
(483262, 'TIGR04487', NULL, 'SoxY_para_1: SoxY-related AACIE arm protein', 146, NULL, 'TIGR04487', 288937),
(483263, 'TIGR00334', NULL, '5S_RNA_mat_M5: ribonuclease M5', 174, NULL, 'TIGR00334', 288938),
(483264, 'TIGR04290', NULL, 'meth_Rta_06860: methyltransferase, Rta_06860 family', 226, NULL, 'TIGR04290', 288939),
(483265, 'TIGR04058', NULL, 'AcACP_reductase: long-chain fatty acyl-ACP reductase (aldehyde-forming)', 339, NULL, 'TIGR04058', 288940),
(483266, 'TIGR02889', NULL, 'spore_YpeB: germination protein YpeB', 435, NULL, 'TIGR02889', 288941),
(483267, 'TIGR01190', NULL, 'ccmB: heme exporter protein CcmB', 211, NULL, 'TIGR01190', 288942),
(483268, 'TIGR01360', NULL, 'aden_kin_iso1: adenylate kinase', 188, NULL, 'TIGR01360', 288943); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(483269, 'TIGR00874', NULL, 'talAB: transaldolase', 317, NULL, 'TIGR00874', 288944),
(483270, 'TIGR01285', NULL, 'nifN: nitrogenase molybdenum-iron cofactor biosynthesis protein NifN', 433, NULL, 'TIGR01285', 288945),
(483271, 'TIGR00969', NULL, '3a0106s02: sulfate ABC transporter, permease protein', 272, NULL, 'TIGR00969', 288946),
(483272, 'TIGR03375', NULL, 'type_I_sec_LssB: type I secretion system ATPase', 696, NULL, 'TIGR03375', 288947),
(483273, 'TIGR04022', NULL, 'sulfur_SfnB: sulfur acquisition oxidoreductase, SfnB family', 391, NULL, 'TIGR04022', 288948),
(483274, 'TIGR00021', NULL, 'rpiA: ribose 5-phosphate isomerase A', 218, NULL, 'TIGR00021', 288949),
(483275, 'TIGR02179', NULL, 'PorD_KorD: 2-oxoacid:acceptor oxidoreductase, delta subunit, pyruvate/2-ketoisovalerate family', 78, NULL, 'TIGR02179', 288950),
(483276, 'TIGR03647', NULL, 'Na_symport_sm: putative solute:sodium symporter small subunit', 77, NULL, 'TIGR03647', 288951),
(483277, 'TIGR04562', NULL, 'TIGR04562: TIGR04562 family protein', 356, NULL, 'TIGR04562', 288952),
(483278, 'TIGR02526', NULL, 'eut_PduT: PduT-like ethanolamine utilization protein', 182, NULL, 'TIGR02526', 288953),
(483279, 'TIGR02678', NULL, 'TIGR02678: TIGR02678 family protein', 376, NULL, 'TIGR02678', 288954),
(483280, 'TIGR02540', NULL, 'gpx7: putative glutathione peroxidase Gpx7', 153, NULL, 'TIGR02540', 288955),
(483281, 'TIGR00504', NULL, 'pyro_pdase: pyroglutamyl-peptidase I', 213, NULL, 'TIGR00504', 288956),
(483282, 'TIGR02043', NULL, 'ZntR: Zn(II)-responsive transcriptional regulator', 131, NULL, 'TIGR02043', 288957),
(483283, 'TIGR03545', NULL, 'TIGR03545: TIGR03545 family protein', 556, NULL, 'TIGR03545', 288958),
(483284, 'TIGR03661', NULL, 'T1SS_VCA0849: type I secretion C-terminal target domain (VC_A0849 subclass)', 91, NULL, 'TIGR03661', 288959),
(483285, 'TIGR02213', NULL, 'lolE_release: lipoprotein releasing system, transmembrane protein LolE', 411, NULL, 'TIGR02213', 288960),
(483286, 'TIGR03715', NULL, 'KxYKxGKxW: KxYKxGKxW signal peptide', 23, NULL, 'TIGR03715', 288961),
(483287, 'TIGR01509', NULL, 'HAD-SF-IA-v3: HAD hydrolase, family IA, variant 3', 154, NULL, 'TIGR01509', 288962),
(483288, 'TIGR03012', NULL, 'sulf_tusD_dsrE: sulfur relay protein TusD/DsrE', 127, NULL, 'TIGR03012', 288963),
(483289, 'TIGR02349', NULL, 'DnaJ_bact: chaperone protein DnaJ', 354, NULL, 'TIGR02349', 288964),
(483290, 'TIGR00007', NULL, 'TIGR00007: 1-(5-phosphoribosyl)-5-[(5-phosphoribosylamino)methylideneamino]imidazole-4-carboxamide isomerase', 231, NULL, 'TIGR00007', 288965),
(483291, 'TIGR02370', NULL, 'pyl_corrinoid: methyltransferase cognate corrinoid proteins, Methanosarcina family', 197, NULL, 'TIGR02370', 288966),
(483292, 'TIGR04514', NULL, 'GWxTD_dom: GWxTD domain', 105, NULL, 'TIGR04514', 288967),
(483293, 'TIGR02356', NULL, 'adenyl_thiF: thiazole biosynthesis adenylyltransferase ThiF', 203, NULL, 'TIGR02356', 288968),
(483294, 'TIGR03858', NULL, 'LLM_2I7G: probable oxidoreductase, LLM family', 337, NULL, 'TIGR03858', 288969),
(483295, 'TIGR01339', NULL, 'phycocy_beta: phycocyanin, beta subunit', 171, NULL, 'TIGR01339', 288970),
(483296, 'TIGR00826', NULL, 'EIIB_glc: PTS system, glucose-like IIB component', 88, NULL, 'TIGR00826', 288971),
(483297, 'TIGR00663', NULL, 'dnan: DNA polymerase III, beta subunit', 367, NULL, 'TIGR00663', 288972),
(483298, 'TIGR02710', NULL, 'TIGR02710: CRISPR-associated protein, TIGR02710 family', 384, NULL, 'TIGR02710', 288973),
(483299, 'TIGR02848', NULL, 'spore_III_AC: stage III sporulation protein AC', 64, NULL, 'TIGR02848', 288974),
(483300, 'TIGR00833', NULL, 'actII: transport protein', 910, NULL, 'TIGR00833', 288975),
(483301, 'TIGR00486', NULL, 'YbgI_SA1388: dinuclear metal center protein, YbgI/SA1388 family', 250, NULL, 'TIGR00486', 288976),
(483302, 'TIGR00656', NULL, 'asp_kin_monofn: aspartate kinase, monofunctional class', 407, NULL, 'TIGR00656', 288977),
(483303, 'TIGR03223', NULL, 'Phn_opern_protn: putative phosphonate metabolism protein', 228, NULL, 'TIGR03223', 288978),
(483304, 'TIGR01843', NULL, 'type_I_hlyD: type I secretion membrane fusion protein, HlyD family', 422, NULL, 'TIGR01843', 288979);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(483305, 'TIGR00990', NULL, '3a0801s09: mitochondrial precursor proteins import receptor', 615, NULL, 'TIGR00990', 288980),
(483306, 'TIGR03491', NULL, 'TIGR03491: putative RecB family nuclease, TM0106 family', 462, NULL, 'TIGR03491', 288981),
(483307, 'TIGR01673', NULL, 'holin_LLH: phage holin, LL-H family', 108, NULL, 'TIGR01673', 288982),
(483308, 'TIGR03688', NULL, 'pupylate_PafA2: proteasome accessory factor PafA2', 485, NULL, 'TIGR03688', 288983),
(483309, 'TIGR01911', NULL, 'HesB_rel_seleno: HesB-like selenoprotein', 92, NULL, 'TIGR01911', 288984),
(483310, 'TIGR00116', NULL, 'tsf: translation elongation factor Ts', 293, NULL, 'TIGR00116', 288985),
(483311, 'TIGR02152', NULL, 'D_ribokin_bact: ribokinase', 298, NULL, 'TIGR02152', 288986),
(483312, 'TIGR03586', NULL, 'PseI: pseudaminic acid synthase', 327, NULL, 'TIGR03586', 288987),
(483313, 'TIGR04521', NULL, 'ECF_ATPase_2: energy-coupling factor transporter ATPase', 279, NULL, 'TIGR04521', 288988),
(483314, 'TIGR00062', NULL, 'L27: ribosomal protein bL27', 83, NULL, 'TIGR00062', 288989),
(483315, 'TIGR00942', NULL, '2a6301s05: multicomponent Na+:H+ antiporter', 144, NULL, 'TIGR00942', 288990),
(483316, 'TIGR02431', NULL, 'pcaR_pcaU: beta-ketoadipate pathway transcriptional regulators, PcaR/PcaU/PobR family', 248, NULL, 'TIGR02431', 288991),
(483317, 'TIGR03400', NULL, '18S_RNA_Rcl1p: 18S rRNA biogenesis protein RCL1', 360, NULL, 'TIGR03400', 288992),
(483318, 'TIGR03756', NULL, 'conj_TIGR03756: integrating conjugative element protein, PFL_4710 family', 298, NULL, 'TIGR03756', 288993),
(483319, 'TIGR02601', NULL, 'autotrns_rpt: autotransporter-associated beta strand repeat', 32, NULL, 'TIGR02601', 288994),
(483320, 'TIGR03831', NULL, 'YgiT_finger: YgiT-type zinc finger domain', 46, NULL, 'TIGR03831', 288995),
(483321, 'TIGR02896', NULL, 'spore_III_AF: stage III sporulation protein AF', 106, NULL, 'TIGR02896', 288996),
(483322, 'TIGR04555', NULL, 'sulfite_DH_soxC: sulfite dehydrogenase', 408, NULL, 'TIGR04555', 288997),
(483323, 'TIGR01741', NULL, 'staph_tand_hypo: conserved hypothetical protein', 157, NULL, 'TIGR01741', 288998),
(483324, 'TIGR00232', NULL, 'tktlase_bact: transketolase', 654, NULL, 'TIGR00232', 288999),
(483325, 'TIGR02315', NULL, 'ABC_phnC: phosphonate ABC transporter, ATP-binding protein', 243, NULL, 'TIGR02315', 289000),
(483326, 'TIGR04392', NULL, 'haoB_nitrify: hydroxylamine oxidation protein HaoB', 320, NULL, 'TIGR04392', 289001),
(483327, 'TIGR02322', NULL, 'phosphon_PhnN: phosphonate metabolism protein/1,5-bisphosphokinase (PRPP-forming) PhnN', 179, NULL, 'TIGR02322', 289002),
(483328, 'TIGR04385', NULL, 'B12_rSAM_cofa1: putative variant cofactor biosynthesis B12-binding domain/radical SAM domain protein 1', 438, NULL, 'TIGR04385', 289003),
(483329, 'TIGR01387', NULL, 'cztR_silR_copR: heavy metal response regulator', 218, NULL, 'TIGR01387', 289004),
(483330, 'TIGR00225', NULL, 'prc: C-terminal processing peptidase', 335, NULL, 'TIGR00225', 289005),
(483331, 'TIGR03919', NULL, 'T7SS_EccB: type VII secretion protein EccB', 457, NULL, 'TIGR03919', 289006),
(483332, 'TIGR03477', NULL, 'DMSO_red_II_gam: DMSO reductase family type II enzyme, heme b subunit', 206, NULL, 'TIGR03477', 289007),
(483333, 'TIGR00867', NULL, 'deg-1: degenerin', 611, NULL, 'TIGR00867', 289008),
(483334, 'TIGR01292', NULL, 'TRX_reduct: thioredoxin-disulfide reductase', 300, NULL, 'TIGR01292', 289009),
(483335, 'TIGR02957', NULL, 'SigX4: RNA polymerase sigma-70 factor, TIGR02957 family', 281, NULL, 'TIGR02957', 289010),
(483336, 'TIGR01632', NULL, 'L11_bact: ribosomal protein uL11', 140, NULL, 'TIGR01632', 289011),
(483337, 'TIGR01802', NULL, 'CM_pl-yst: chorismate mutase', 247, NULL, 'TIGR01802', 289012),
(483338, 'TIGR00697', NULL, 'TIGR00697: conserved hypothetical integral membrane protein', 201, NULL, 'TIGR00697', 289013),
(483339, 'TIGR01462', NULL, 'greA: transcription elongation factor GreA', 151, NULL, 'TIGR01462', 289014),
(483340, 'TIGR00402', NULL, 'napF: ferredoxin-type protein NapF', 149, NULL, 'TIGR00402', 289015),
(483341, 'TIGR01557', NULL, 'myb_SHAQKYF: myb-like DNA-binding domain, SHAQKYF class', 57, NULL, 'TIGR01557', 289016);
INSERT INTO "PUBLIC"."MODEL" VALUES
(483342, 'TIGR02787', NULL, 'codY_Gpos: GTP-sensing transcriptional pleiotropic repressor CodY', 251, NULL, 'TIGR02787', 289017),
(483343, 'TIGR03005', NULL, 'ectoine_ehuA: ectoine/hydroxyectoine ABC transporter, ATP-binding protein EhuA', 252, NULL, 'TIGR03005', 289018),
(483344, 'TIGR00109', NULL, 'hemH: ferrochelatase', 322, NULL, 'TIGR00109', 289019),
(483345, 'TIGR03114', NULL, 'cas8u_csf1: CRISPR type AFERR-associated protein Csf1', 202, NULL, 'TIGR03114', 289020),
(483346, 'TIGR00588', NULL, 'ogg: 8-oxoguanine DNA-glycosylase (ogg)', 310, NULL, 'TIGR00588', 289021),
(483347, 'TIGR02145', NULL, 'Fib_succ_major: fibrobacter succinogenes major paralogous domain', 176, NULL, 'TIGR02145', 289022),
(483348, 'TIGR00935', NULL, '2a45: arsenite/antimonite efflux pump membrane protein', 426, NULL, 'TIGR00935', 289023),
(483349, 'TIGR03593', NULL, 'yidC_nterm: membrane protein insertase, YidC/Oxa1 family, N-terminal domain', 363, NULL, 'TIGR03593', 289024),
(483350, 'TIGR04269', NULL, 'SAM_SPASM_FxsB: radical SAM/SPASM domain protein, FxsB family', 363, NULL, 'TIGR04269', 289025),
(483351, 'TIGR01571', NULL, 'A_thal_Cys_rich: uncharacterized Cys-rich domain', 105, NULL, 'TIGR01571', 289026),
(483352, 'TIGR03940', NULL, 'PGA_PgaD: poly-beta-1,6-N-acetyl-D-glucosamine biosynthesis protein PgaD', 141, NULL, 'TIGR03940', 289027),
(483353, 'TIGR01455', NULL, 'glmM: phosphoglucosamine mutase', 442, NULL, 'TIGR01455', 289028),
(483354, 'TIGR01278', NULL, 'DPOR_BchB: light-independent protochlorophyllide reductase, B subunit', 512, NULL, 'TIGR01278', 289029),
(483355, 'TIGR02424', NULL, 'TF_pcaQ: pca operon transcription factor PcaQ', 300, NULL, 'TIGR02424', 289030),
(483356, 'TIGR03926', NULL, 'T7_EssB: type VII secretion protein EssB', 377, NULL, 'TIGR03926', 289031),
(483357, 'TIGR04283', NULL, 'glyco_like_mftF: transferase 2, rSAM/selenodomain-associated', 221, NULL, 'TIGR04283', 289032),
(483358, 'TIGR00300', NULL, 'TIGR00300: TIGR00300 family protein', 407, NULL, 'TIGR00300', 289033),
(483359, 'TIGR02077', NULL, 'thr_lead_pep: thr operon leader peptide', 23, NULL, 'TIGR02077', 289034),
(483360, 'TIGR03579', NULL, 'EF_0833: conserved hypothetical protein EF_0833/AHA_3914', 209, NULL, 'TIGR03579', 289035),
(483361, 'TIGR03749', NULL, 'conj_TIGR03749: integrating conjugative element protein, PFL_4704 family', 259, NULL, 'TIGR03749', 289036),
(483362, 'TIGR04460', NULL, 'endura_MppR: enduracididine biosynthesis enzyme MppR', 257, NULL, 'TIGR04460', 289037),
(483363, 'TIGR01625', NULL, 'YidE_YbjL_dupl: AspT/YidE/YbjL antiporter duplication domain', 154, NULL, 'TIGR01625', 289038),
(483364, 'TIGR00881', NULL, '2A0104: phosphoglycerate transporter family protein', 379, NULL, 'TIGR00881', 289039),
(483365, 'TIGR00123', NULL, 'cbiM: cobalamin biosynthesis protein CbiM', 214, NULL, 'TIGR00123', 289040),
(483366, 'TIGR04439', NULL, 'histamin_N_OH: putative histamine N-monooxygenase', 431, NULL, 'TIGR04439', 289041),
(483367, 'TIGR03770', NULL, 'anch_rpt_perm: anchored repeat-type ABC transporter, permease subunit', 270, NULL, 'TIGR03770', 289042),
(483368, 'TIGR04446', NULL, 'pren_cyc_PirE: prenylated cyclic peptide, anacyclamide/piricyclamide family', 51, NULL, 'TIGR04446', 289043),
(483369, 'TIGR02261', NULL, 'benz_CoA_red_D: benzoyl-CoA reductase, subunit D', 262, NULL, 'TIGR02261', 289044),
(483370, 'TIGR04099', NULL, 'biosn_Pnap_2097: probable biosynthetic protein, Pnap_2097 family', 259, NULL, 'TIGR04099', 289045),
(483371, 'TIGR00758', NULL, 'UDG_fam4: uracil-DNA glycosylase, family 4', 173, NULL, 'TIGR00758', 289046),
(483372, 'TIGR04453', NULL, 'Lepto_8Cys: Cys-rich protein, LA_1312 family', 85, NULL, 'TIGR04453', 289047),
(483373, 'TIGR03933', NULL, 'PIA_icaB: intercellular adhesin biosynthesis polysaccharide N-deacetylase', 245, NULL, 'TIGR03933', 289048),
(483374, 'TIGR03121', NULL, 'one_C_dehyd_A: formylmethanofuran dehydrogenase subunit A', 556, NULL, 'TIGR03121', 289049),
(483375, 'TIGR00928', NULL, 'purB: adenylosuccinate lyase', 436, NULL, 'TIGR00928', 289050),
(483376, 'TIGR02091', NULL, 'glgC: glucose-1-phosphate adenylyltransferase', 364, NULL, 'TIGR02091', 289051);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(483377, 'TIGR03763', NULL, 'cyanoexo_CrtA: cyanoexosortase A', 260, NULL, 'TIGR03763', 289052),
(483378, 'TIGR04276', NULL, 'FxsC_Cterm: FxsC C-terminal domain', 196, NULL, 'TIGR04276', 289053),
(483379, 'TIGR03036', NULL, 'trp_2_3_diox: tryptophan 2,3-dioxygenase', 264, NULL, 'TIGR03036', 289054),
(483380, 'TIGR01910', NULL, 'DapE-ArgE: peptidase, ArgE/DapE family', 373, NULL, 'TIGR01910', 289055),
(483381, 'TIGR00668', NULL, 'apaH: bis(5''-nucleosyl)-tetraphosphatase (symmetrical)', 279, NULL, 'TIGR00668', 289056),
(483382, 'TIGR00531', NULL, 'BCCP: acetyl-CoA carboxylase, biotin carboxyl carrier protein', 156, NULL, 'TIGR00531', 289057),
(483383, 'TIGR01807', NULL, 'CM_P2: chorismate mutase', 76, NULL, 'TIGR01807', 289058),
(483384, 'TIGR02685', NULL, 'pter_reduc_Leis: pteridine reductase', 267, NULL, 'TIGR02685', 289059),
(483385, 'TIGR02981', NULL, 'phageshock_pspE: phage shock operon rhodanese PspE', 101, NULL, 'TIGR02981', 289060),
(483386, 'TIGR00771', NULL, 'DcuC: transporter, anaerobic C4-dicarboxylate uptake C (DcuC) family', 388, NULL, 'TIGR00771', 289061),
(483387, 'TIGR03083', NULL, 'TIGR03083: uncharacterized Actinobacterial protein TIGR03083', 202, NULL, 'TIGR03083', 289062),
(483388, 'TIGR02205', NULL, 'septum_zipA: cell division protein ZipA', 284, NULL, 'TIGR02205', 289063),
(483389, 'TIGR00475', NULL, 'selB: selenocysteine-specific translation elongation factor', 581, NULL, 'TIGR00475', 289064),
(483390, 'TIGR02501', NULL, 'type_III_yscE: type III secretion system protein, YseE family', 67, NULL, 'TIGR02501', 289065),
(483391, 'TIGR00282', NULL, 'TIGR00282: metallophosphoesterase, MG_246/BB_0505 family', 266, NULL, 'TIGR00282', 289066),
(483392, 'TIGR03276', NULL, 'Phn-HD: phosphonate degradation operons associated HDIG domain protein', 179, NULL, 'TIGR03276', 289067),
(483393, 'TIGR02878', NULL, 'spore_ypjB: sporulation protein YpjB', 233, NULL, 'TIGR02878', 289068),
(483394, 'TIGR01854', NULL, 'lipid_A_lpxH: UDP-2,3-diacylglucosamine diphosphatase', 231, NULL, 'TIGR01854', 289069),
(483395, 'TIGR01499', NULL, 'folC: bifunctional protein FolC', 400, NULL, 'TIGR01499', 289070),
(483396, 'TIGR02934', NULL, 'nifT_nitrog: probable nitrogen fixation protein FixT', 68, NULL, 'TIGR02934', 289071),
(483397, 'TIGR03572', NULL, 'WbuZ: glycosyl amidation-associated protein WbuZ', 232, NULL, 'TIGR03572', 289072),
(483398, 'TIGR01122', NULL, 'ilvE_I: branched-chain amino acid aminotransferase', 298, NULL, 'TIGR01122', 289073),
(483399, 'TIGR02492', NULL, 'flgK_ends: flagellar hook-associated protein FlgK', 437, NULL, 'TIGR02492', 289074),
(483400, 'TIGR01259', NULL, 'comE: comEA protein', 120, NULL, 'TIGR01259', 289075),
(483401, 'TIGR02149', NULL, 'glgA_Coryne: glycogen synthase, Corynebacterium family', 391, NULL, 'TIGR02149', 289076),
(483402, 'TIGR04222', NULL, 'near_uncomplex: TIGR04222 domain', 229, NULL, 'TIGR04222', 289077),
(483403, 'TIGR03332', NULL, 'salvage_mtnW: 2,3-diketo-5-methylthiopentyl-1-phosphate enolase', 407, NULL, 'TIGR03332', 289078),
(483404, 'TIGR03824', NULL, 'FlgM_jcvi: flagellar biosynthesis anti-sigma factor FlgM', 98, NULL, 'TIGR03824', 289079),
(483405, 'TIGR04163', NULL, 'rSAM_cobopep: peptide-modifying radical SAM enzyme CbpB', 428, NULL, 'TIGR04163', 289080),
(483406, 'TIGR03765', NULL, 'ICE_PFL_4695: integrating conjugative element protein, PFL_4695 family', 105, NULL, 'TIGR03765', 289081),
(483407, 'TIGR00235', NULL, 'udk: uridine kinase', 207, NULL, 'TIGR00235', 289082),
(483408, 'TIGR02741', NULL, 'TraQ: type-F conjugative transfer system pilin chaperone TraQ', 93, NULL, 'TIGR02741', 289083),
(483409, 'TIGR03768', NULL, 'RPA4764: metallophosphoesterase, RPA4764 family', 547, NULL, 'TIGR03768', 289084),
(483410, 'TIGR01066', NULL, 'rplM_bact: ribosomal protein uL13', 141, NULL, 'TIGR01066', 289085),
(483411, 'TIGR04415', NULL, 'O_hepto_targRPT: autotransporter passenger strand-loop-strand repeat', 38, NULL, 'TIGR04415', 289086),
(483412, 'TIGR00042', NULL, 'TIGR00042: non-canonical purine NTP pyrophosphatase, RdgB/HAM1 family', 184, NULL, 'TIGR00042', 289087);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(483413, 'TIGR01318', NULL, 'gltD_gamma_fam: glutamate synthase, small subunit', 467, NULL, 'TIGR01318', 289088),
(483414, 'TIGR04116', NULL, 'CXXX_rpt_assoc: CXXX repeat peptide modification system protein', 90, NULL, 'TIGR04116', 289089),
(483415, 'TIGR01555', NULL, 'phge_rel_HI1409: phage-associated protein, HI1409 family', 404, NULL, 'TIGR01555', 289090),
(483416, 'TIGR02800', NULL, 'propeller_TolB: Tol-Pal system beta propeller repeat protein TolB', 418, NULL, 'TIGR02800', 289091),
(483417, 'TIGR00727', NULL, 'ISP4_OPT: small oligopeptide transporter, OPT family', 681, NULL, 'TIGR00727', 289092),
(483418, 'TIGR01365', NULL, 'serC_2: phosphoserine aminotransferase', 374, NULL, 'TIGR01365', 289093),
(483419, 'TIGR02193', NULL, 'heptsyl_trn_I: lipopolysaccharide heptosyltransferase I', 320, NULL, 'TIGR02193', 289094),
(483420, 'TIGR01661', NULL, 'ELAV_HUD_SF: ELAV/HuD family splicing factor', 351, NULL, 'TIGR01661', 289095),
(483421, 'TIGR01851', NULL, 'argC_other: N-acetyl-gamma-glutamyl-phosphate reductase', 310, NULL, 'TIGR01851', 289096),
(483422, 'TIGR03335', NULL, 'F390_ftsA: coenzyme F390 synthetase', 445, NULL, 'TIGR03335', 289097),
(483423, 'TIGR03525', NULL, 'GldK: gliding motility-associated lipoprotein GldK', 449, NULL, 'TIGR03525', 289098),
(483424, 'TIGR00917', NULL, '2A060601: Niemann-Pick C type protein family', 1204, NULL, 'TIGR00917', 289099),
(483425, 'TIGR04359', NULL, 'TrbK_RP4: entry exclusion lipoprotein TrbK', 67, NULL, 'TIGR04359', 289100),
(483426, 'TIGR02146', NULL, 'LysS_fung_arch: homocitrate synthase', 344, NULL, 'TIGR02146', 289101),
(483427, 'TIGR00179', NULL, 'murB: UDP-N-acetylenolpyruvoylglucosamine reductase', 290, NULL, 'TIGR00179', 289102),
(483428, 'TIGR01614', NULL, 'PME_inhib: pectinesterase inhibitor domain', 178, NULL, 'TIGR01614', 289103),
(483429, 'TIGR01804', NULL, 'BADH: betaine-aldehyde dehydrogenase', 467, NULL, 'TIGR01804', 289104),
(483430, 'TIGR02442', NULL, 'Cob-chelat-sub: cobaltochelatase subunit', 641, NULL, 'TIGR02442', 289105),
(483431, 'TIGR02389', NULL, 'RNA_pol_rpoA2: DNA-directed RNA polymerase, subunit A''''', 367, NULL, 'TIGR02389', 289106),
(483432, 'TIGR02579', NULL, 'cas_csx3: CRISPR-associated protein, Csx3 family', 83, NULL, 'TIGR02579', 289107),
(483433, 'TIGR00472', NULL, 'pheT_bact: phenylalanine--tRNA ligase, beta subunit', 798, NULL, 'TIGR00472', 289108),
(483434, 'TIGR00964', NULL, 'secE_bact: preprotein translocase, SecE subunit', 57, NULL, 'TIGR00964', 289109),
(483435, 'TIGR02252', NULL, 'DREG-2: HAD hydrolase, REG-2-like, family IA', 203, NULL, 'TIGR02252', 289110),
(483436, 'TIGR01019', NULL, 'sucCoAalpha: succinate-CoA ligase, alpha subunit', 286, NULL, 'TIGR01019', 289111),
(483437, 'TIGR03229', NULL, 'benzo_1_2_benA: benzoate 1,2-dioxygenase, large subunit', 433, NULL, 'TIGR03229', 289112),
(483438, 'TIGR04462', NULL, 'endura_MppP: enduracididine biosynthesis enzyme MppP', 289, NULL, 'TIGR04462', 289113),
(483439, 'TIGR01988', NULL, 'Ubi-OHases: ubiquinone biosynthesis hydroxylase, UbiH/UbiF/VisC/COQ6 family', 387, NULL, 'TIGR01988', 289114),
(483440, 'TIGR01798', NULL, 'cit_synth_I: citrate (Si)-synthase', 412, NULL, 'TIGR01798', 289115),
(483441, 'TIGR03033', NULL, 'phage_rel_nuc: putative phage-type endonuclease', 153, NULL, 'TIGR03033', 289116),
(483442, 'TIGR00774', NULL, 'NhaB: Na+/H+ antiporter NhaB', 515, NULL, 'TIGR00774', 289117),
(483443, 'TIGR02448', NULL, 'TIGR02448: conserverd hypothetical protein', 101, NULL, 'TIGR02448', 289118),
(483444, 'TIGR03871', NULL, 'ABC_peri_MoxJ_2: quinoprotein dehydrogenase-associated probable ABC transporter substrate-binding protein', 232, NULL, 'TIGR03871', 289119),
(483445, 'TIGR02638', NULL, 'lactal_redase: lactaldehyde reductase', 379, NULL, 'TIGR02638', 289120),
(483446, 'TIGR03226', NULL, 'PhnU: 2-aminoethylphosphonate ABC transporter, permease protein', 311, NULL, 'TIGR03226', 289121),
(483447, 'TIGR02208', NULL, 'lipid_A_msbB: lipid A biosynthesis (KDO)2-(lauroyl)-lipid IVA acyltransferase', 305, NULL, 'TIGR02208', 289122),
(483448, 'TIGR00618', NULL, 'sbcc: exonuclease SbcC', 1043, NULL, 'TIGR00618', 289123); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(483449, 'TIGR01256', NULL, 'modA: molybdate ABC transporter, periplasmic molybdate-binding protein', 217, NULL, 'TIGR01256', 289124),
(483450, 'TIGR00285', NULL, 'TIGR00285: DNA-binding protein Alba', 87, NULL, 'TIGR00285', 289125),
(483451, 'TIGR00858', NULL, 'bioF: 8-amino-7-oxononanoate synthase', 365, NULL, 'TIGR00858', 289126),
(483452, 'TIGR01496', NULL, 'DHPS: dihydropteroate synthase', 258, NULL, 'TIGR01496', 289127),
(483453, 'TIGR02635', NULL, 'RhaI_grampos: L-rhamnose isomerase', 378, NULL, 'TIGR02635', 289128),
(483454, 'TIGR02791', NULL, 'VirB5: P-type DNA transfer protein VirB5', 220, NULL, 'TIGR02791', 289129),
(483455, 'TIGR00341', NULL, 'TIGR00341: TIGR00341 family protein', 325, NULL, 'TIGR00341', 289130),
(483456, 'TIGR01617', NULL, 'arsC_related: transcriptional regulator, Spx/MgsR family', 117, NULL, 'TIGR01617', 289131),
(483457, 'TIGR03039', NULL, 'PS_II_CP47: photosystem II chlorophyll-binding protein CP47', 504, NULL, 'TIGR03039', 289132),
(483458, 'TIGR01209', NULL, 'TIGR01209: RNA ligase, Pab1020 family', 375, NULL, 'TIGR01209', 289133),
(483459, 'TIGR00238', NULL, 'TIGR00238: KamA family protein', 331, NULL, 'TIGR00238', 289134),
(483460, 'TIGR00665', NULL, 'DnaB: replicative DNA helicase', 435, NULL, 'TIGR00665', 289135),
(483461, 'TIGR01312', NULL, 'XylB: xylulokinase', 481, NULL, 'TIGR01312', 289136),
(483462, 'TIGR03382', NULL, 'GC_trans_RRR: Myxococcales GC_trans_RRR domain', 27, NULL, 'TIGR03382', 289137),
(483463, 'TIGR03762', NULL, 'archaeo_artC: archaeosortase C', 274, NULL, 'TIGR03762', 289138),
(483464, 'TIGR02744', NULL, 'TrbI_Ftype: type-F conjugative transfer system protein TrbI', 112, NULL, 'TIGR02744', 289139),
(483465, 'TIGR02087', NULL, 'LEUD_arch: 3-isopropylmalate dehydratase, small subunit', 157, NULL, 'TIGR02087', 289140),
(483466, 'TIGR01069', NULL, 'mutS2: MutS2 family protein', 771, NULL, 'TIGR01069', 289141),
(483467, 'TIGR02984', NULL, 'Sig-70_plancto1: RNA polymerase sigma-70 factor, Planctomycetaceae-specific subfamily 1', 189, NULL, 'TIGR02984', 289142),
(483468, 'TIGR01792', NULL, 'urease_alph: urease, alpha subunit', 568, NULL, 'TIGR01792', 289143),
(483469, 'TIGR03899', NULL, 'TIGR03899: TIGR03899 family protein', 250, NULL, 'TIGR03899', 289144),
(483470, 'TIGR03080', NULL, 'CH4_NH3mon_ox_A: methane monooxygenase/ammonia monooxygenase, subunit A', 243, NULL, 'TIGR03080', 289145),
(483471, 'TIGR04412', NULL, 'T2SS_GspM_XcpZ: type II secretion system protein M', 126, NULL, 'TIGR04412', 289146),
(483472, 'TIGR04549', NULL, 'LP_HExxH_w_tonB: substrate import-associated zinc metallohydrolase lipoprotein', 261, NULL, 'TIGR04549', 289147),
(483473, 'TIGR03634', NULL, 'arc_protsome_B: proteasome endopeptidase complex, archaeal, beta subunit', 185, NULL, 'TIGR03634', 289148),
(483474, 'TIGR03575', NULL, 'selen_PSTK_euk: L-seryl-tRNA(Sec) kinase', 340, NULL, 'TIGR03575', 289149),
(483475, 'TIGR00478', NULL, 'tly: TlyA family rRNA methyltransferase/putative hemolysin', 228, NULL, 'TIGR00478', 289150),
(483476, 'TIGR04225', NULL, 'CshA_fibril_rpt: CshA-type fibril repeat', 104, NULL, 'TIGR04225', 289151),
(483477, 'TIGR00101', NULL, 'ureG: urease accessory protein UreG', 199, NULL, 'TIGR00101', 289152),
(483478, 'TIGR04353', NULL, 'PqqD_rel_X: PqqD family protein, HPr-rel-A system', 74, NULL, 'TIGR04353', 289153),
(483479, 'TIGR04032', NULL, 'toxin_SdpC: antimicrobial peptide, SdpC family', 172, NULL, 'TIGR04032', 289154),
(483480, 'TIGR01128', NULL, 'holA: DNA polymerase III, delta subunit', 314, NULL, 'TIGR01128', 289155),
(483481, 'TIGR01508', NULL, 'rib_reduct_arch: diaminohydroxyphosphoribosylaminopyrimidine reductase', 210, NULL, 'TIGR01508', 289156),
(483482, 'TIGR02803', NULL, 'ExbD_1: TonB system transport protein ExbD', 122, NULL, 'TIGR02803', 289157),
(483483, 'TIGR01449', NULL, 'PGP_bact: phosphoglycolate phosphatase, bacterial', 213, NULL, 'TIGR01449', 289158),
(483484, 'TIGR02682', NULL, 'cas_csx11: CRISPR-associated protein, Csx11 family', 1007, NULL, 'TIGR02682', 289159),
(483485, 'TIGR03958', NULL, 'monoFe_hyd_HmdC: 5,10-methenyltetrahydromethanopterin hydrogenase cofactor biosynthesis protein HmdC', 505, NULL, 'TIGR03958', 289160);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(483486, 'TIGR04166', NULL, 'methano_MtrB: tetrahydromethanopterin S-methyltransferase, subunit B', 95, NULL, 'TIGR04166', 289161),
(483487, 'TIGR04546', NULL, 'rSAM_ahbC_deAc: 12,18-didecarboxysiroheme deacetylase', 390, NULL, 'TIGR04546', 289162),
(483488, 'TIGR03528', NULL, '2_3_DAP_am_ly: diaminopropionate ammonia-lyase', 396, NULL, 'TIGR03528', 289163),
(483489, 'TIGR00830', NULL, 'PTBA: PTS system, glucose subfamily, IIA component', 121, NULL, 'TIGR00830', 289164),
(483490, 'TIGR00967', NULL, '3a0501s007: preprotein translocase, SecY subunit', 414, NULL, 'TIGR00967', 289165),
(483491, 'TIGR02987', NULL, 'met_A_Alw26: type II restriction m6 adenine DNA methyltransferase, Alw26I/Eco31I/Esp3I family', 523, NULL, 'TIGR02987', 289166),
(483492, 'TIGR01938', NULL, 'nqrC: NADH:ubiquinone oxidoreductase, Na(+)-translocating, C subunit', 251, NULL, 'TIGR01938', 289167),
(483493, 'TIGR02850', NULL, 'spore_sigG: RNA polymerase sigma-G factor', 254, NULL, 'TIGR02850', 289168),
(483494, 'TIGR00176', NULL, 'mobB: molybdopterin-guanine dinucleotide biosynthesis protein B', 155, NULL, 'TIGR00176', 289169),
(483495, 'TIGR01801', NULL, 'CM_A: chorismate mutase', 102, NULL, 'TIGR01801', 289170),
(483496, 'TIGR01315', NULL, '5C_CHO_kinase: FGGY-family pentulose kinase', 541, NULL, 'TIGR01315', 289171),
(483497, 'TIGR02937', NULL, 'sigma70-ECF: RNA polymerase sigma factor, sigma-70 family', 165, NULL, 'TIGR02937', 289172),
(483498, 'TIGR03441', NULL, 'urea_trans_yut: urea transporter', 292, NULL, 'TIGR03441', 289173),
(483499, 'TIGR02529', NULL, 'EutJ: ethanolamine utilization protein EutJ family protein', 239, NULL, 'TIGR02529', 289174),
(483500, 'TIGR03821', NULL, 'EFP_modif_epmB: EF-P beta-lysylation protein EpmB', 321, NULL, 'TIGR03821', 289175),
(483501, 'TIGR01558', NULL, 'sm_term_P27: putative phage terminase, small subunit, P27 family', 116, NULL, 'TIGR01558', 289176),
(483502, 'TIGR01985', NULL, 'phasin_2: phasin', 123, NULL, 'TIGR01985', 289177),
(483503, 'TIGR03908', NULL, 'QH_alpha: quinohemoprotein amine dehydrogenase, alpha subunit', 510, NULL, 'TIGR03908', 289178),
(483504, 'TIGR01060', NULL, 'eno: phosphopyruvate hydratase', 425, NULL, 'TIGR01060', 289179),
(483505, 'TIGR00724', NULL, 'urea_amlyse_rel: biotin-dependent carboxylase uncharacterized domain', 315, NULL, 'TIGR00724', 289180),
(483506, 'TIGR01664', NULL, 'DNA-3''-Pase: DNA 3''-phosphatase', 167, NULL, 'TIGR01664', 289181),
(483507, 'TIGR03030', NULL, 'CelA: cellulose synthase catalytic subunit (UDP-forming)', 714, NULL, 'TIGR03030', 289182),
(483508, 'TIGR03089', NULL, 'TIGR03089: TIGR03089 family protein', 227, NULL, 'TIGR03089', 289183),
(483509, 'TIGR03167', NULL, 'tRNA_sel_U_synt: tRNA 2-selenouridine synthase', 311, NULL, 'TIGR03167', 289184),
(483510, 'TIGR02012', NULL, 'tigrfam_recA: protein RecA', 321, NULL, 'TIGR02012', 289185),
(483511, 'TIGR02314', NULL, 'ABC_MetN: D-methionine ABC transporter, ATP-binding protein', 343, NULL, 'TIGR02314', 289186),
(483512, 'TIGR03469', NULL, 'HpnB: hopene-associated glycosyltransferase HpnB', 386, NULL, 'TIGR03469', 289187),
(483513, 'TIGR00391', NULL, 'hydA: hydrogenase (NiFe) small subunit (hydA)', 365, NULL, 'TIGR00391', 289188),
(483514, 'TIGR04119', NULL, 'CXXX_matur: CXXX repeat peptide maturase', 210, NULL, 'TIGR04119', 289189),
(483515, 'TIGR01421', NULL, 'gluta_reduc_1: glutathione-disulfide reductase', 450, NULL, 'TIGR01421', 289190),
(483516, 'TIGR00129', NULL, 'fdhD_narQ: formate dehydrogenase family accessory protein FdhD', 237, NULL, 'TIGR00129', 289191),
(483517, 'TIGR01362', NULL, 'KDO8P_synth: 3-deoxy-8-phosphooctulonate synthase', 258, NULL, 'TIGR01362', 289192),
(483518, 'TIGR02196', NULL, 'GlrX_YruB: glutaredoxin-like protein, YruB-family', 74, NULL, 'TIGR02196', 289193),
(483519, 'TIGR01206', NULL, 'lysW: lysine biosynthesis protein LysW', 54, NULL, 'TIGR01206', 289194),
(483520, 'TIGR03980', NULL, 'prismane_assoc: hybrid cluster protein-associated redox disulfide domain', 58, NULL, 'TIGR03980', 289195),
(483521, 'TIGR01446', NULL, 'DnaD_dom: DnaD domain protein', 73, NULL, 'TIGR01446', 289196);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(483522, 'TIGR04571', NULL, 'LmtA_Leptospira: lipid A Kdo2 1-phosphate O-methyltransferase', 252, NULL, 'TIGR04571', 289197),
(483523, 'TIGR01686', NULL, 'FkbH: FkbH domain', 323, NULL, 'TIGR01686', 289198),
(483524, 'TIGR04468', NULL, 'arg_2_3_am_muta: arginine 2,3-aminomutase', 351, NULL, 'TIGR04468', 289199),
(483525, 'TIGR00095', NULL, 'TIGR00095: 16S rRNA (guanine(966)-N(2))-methyltransferase RsmD', 194, NULL, 'TIGR00095', 289200),
(483526, 'TIGR01770', NULL, 'NDH_I_N: proton-translocating NADH-quinone oxidoreductase, chain N', 472, NULL, 'TIGR01770', 289201),
(483527, 'TIGR04331', NULL, 'o_ant_LIC12162: putative transferase, LIC12162 family', 585, NULL, 'TIGR04331', 289202),
(483528, 'TIGR04007', NULL, 'wcaI: colanic acid biosynthesis glycosyltransferase WcaI', 407, NULL, 'TIGR04007', 289203),
(483529, 'TIGR04275', NULL, 'beta_prop_Msarc: beta propeller repeat', 40, NULL, 'TIGR04275', 289204),
(483530, 'TIGR02825', NULL, 'B4_12hDH: leukotriene B4 12-hydroxydehydrogenase/15-oxo-prostaglandin 13-reductase', 327, NULL, 'TIGR02825', 289205),
(483531, 'TIGR00855', NULL, 'L12: ribosomal protein bL12', 125, NULL, 'TIGR00855', 289206),
(483532, 'TIGR03656', NULL, 'IsdC: heme uptake protein IsdC', 219, NULL, 'TIGR03656', 289207),
(483533, 'TIGR02498', NULL, 'type_III_ssaH: type III secretion system protein, SsaH family', 79, NULL, 'TIGR02498', 289208),
(483534, 'TIGR02277', NULL, 'PaaX_trns_reg: phenylacetic acid degradation operon negative regulatory protein PaaX', 279, NULL, 'TIGR02277', 289209),
(483535, 'TIGR03877', NULL, 'thermo_KaiC_1: KaiC domain protein, Ph0284 family', 238, NULL, 'TIGR03877', 289210),
(483536, 'TIGR03192', NULL, 'benz_CoA_bzdQ: benzoyl-CoA reductase, bzd-type, Q subunit', 293, NULL, 'TIGR03192', 289211),
(483537, 'TIGR03952', NULL, 'metzin_BF0631: zinc-dependent metalloproteinase lipoprotein, BF0631 family', 351, NULL, 'TIGR03952', 289212),
(483538, 'TIGR00422', NULL, 'valS: valine--tRNA ligase', 863, NULL, 'TIGR00422', 289213),
(483539, 'TIGR03270', NULL, 'methan_mark_4: putative methanogen marker protein 4', 204, NULL, 'TIGR03270', 289214),
(483540, 'TIGR00344', NULL, 'alaS: alanine--tRNA ligase', 847, NULL, 'TIGR00344', 289215),
(483541, 'TIGR03712', NULL, 'acc_sec_asp2: accessory Sec system protein Asp2', 511, NULL, 'TIGR03712', 289216),
(483542, 'TIGR03444', NULL, 'EgtA_Cys_ligase: ergothioneine biosynthesis glutamate--cysteine ligase EgtA', 390, NULL, 'TIGR03444', 289217),
(483543, 'TIGR00104', NULL, 'tRNA_TsaA: tRNA-Thr(GGU) m(6)t(6)A37 methyltransferase TsaA', 143, NULL, 'TIGR00104', 289218),
(483544, 'TIGR00559', NULL, 'pdxJ: pyridoxine 5''-phosphate synthase', 239, NULL, 'TIGR00559', 289219),
(483545, 'TIGR01982', NULL, 'UbiB: 2-polyprenylphenol 6-hydroxylase', 436, NULL, 'TIGR01982', 289220),
(483546, 'TIGR04110', NULL, 'heme_HutZ: heme utilization protein HutZ', 168, NULL, 'TIGR04110', 289221),
(483547, 'TIGR00170', NULL, 'leuC: 3-isopropylmalate dehydratase, large subunit', 466, NULL, 'TIGR00170', 289222),
(483548, 'TIGR01013', NULL, '2a58: sodium-dependent inorganic phosphate (Pi) transporter', 456, NULL, 'TIGR01013', 289223),
(483549, 'TIGR04543', NULL, 'ketoArg_3Met: 2-ketoarginine methyltransferase', 336, NULL, 'TIGR04543', 289224),
(483550, 'TIGR04035', NULL, 'glucan_65_rpt: glucan-binding repeat', 64, NULL, 'TIGR04035', 289225),
(483551, 'TIGR02610', NULL, 'PHA_gran_rgn: putative polyhydroxyalkanoic acid system protein', 91, NULL, 'TIGR02610', 289226),
(483552, 'TIGR02613', NULL, 'mob_myst_B: mobile mystery protein B', 186, NULL, 'TIGR02613', 289227),
(483553, 'TIGR02037', NULL, 'degP_htrA_DO: peptidase Do', 434, NULL, 'TIGR02037', 289228),
(483554, 'TIGR00615', NULL, 'recR: recombination protein RecR', 196, NULL, 'TIGR00615', 289229),
(483555, 'TIGR02361', NULL, 'dak_ATP: dihydroxyacetone kinase', 583, NULL, 'TIGR02361', 289230),
(483556, 'TIGR00880', NULL, '2_A_01_02: multidrug resistance protein', 141, NULL, 'TIGR00880', 289231),
(483557, 'TIGR03164', NULL, 'UHCUDC: OHCU decarboxylase', 157, NULL, 'TIGR03164', 289232),
(483558, 'TIGR00316', NULL, 'cdhC: CO dehydrogenase/CO-methylating acetyl-CoA synthase complex, beta subunit', 460, NULL, 'TIGR00316', 289233);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(483559, 'TIGR03578', NULL, 'EF_0831: conserved hypothetical protein EF_0831/AHA_3912', 96, NULL, 'TIGR03578', 289234),
(483560, 'TIGR00210', NULL, 'gltS: sodium/glutamate symporter', 398, NULL, 'TIGR00210', 289235),
(483561, 'TIGR00400', NULL, 'mgtE: magnesium transporter', 450, NULL, 'TIGR00400', 289236),
(483562, 'TIGR00347', NULL, 'bioD: dethiobiotin synthase', 166, NULL, 'TIGR00347', 289237),
(483563, 'TIGR01194', NULL, 'cyc_pep_trnsptr: cyclic peptide transporter', 554, NULL, 'TIGR01194', 289238),
(483564, 'TIGR03955', NULL, 'rSAM_HydG: [FeFe] hydrogenase H-cluster radical SAM maturase HydG', 470, NULL, 'TIGR03955', 289239),
(483565, 'TIGR00537', NULL, 'hemK_rel_arch: putative methylase', 179, NULL, 'TIGR00537', 289240),
(483566, 'TIGR02853', NULL, 'spore_dpaA: dipicolinic acid synthetase, A subunit', 287, NULL, 'TIGR02853', 289241),
(483567, 'TIGR02383', NULL, 'Hfq: RNA chaperone Hfq', 61, NULL, 'TIGR02383', 289242),
(483568, 'TIGR02573', NULL, 'LcrG_PcrG: type III secretion protein LcrG', 90, NULL, 'TIGR02573', 289243),
(483569, 'TIGR00107', NULL, 'deoD: purine nucleoside phosphorylase', 232, NULL, 'TIGR00107', 289244),
(483570, 'TIGR03204', NULL, 'pimC_large: pimeloyl-CoA dehydrogenase, large subunit', 395, NULL, 'TIGR03204', 289245),
(483571, 'TIGR04169', NULL, 'perox_w_seleSAM: alkylhydroperoxidase/carboxymuconolactone decarboxylase family protein', 109, NULL, 'TIGR04169', 289246),
(483572, 'TIGR01234', NULL, 'L-ribulokinase: ribulokinase', 536, NULL, 'TIGR01234', 289247),
(483573, 'TIGR01726', NULL, 'HEQRo_perm_3TM: amino ABC transporter, permease protein, 3-TM region, His/Glu/Gln/Arg/opine family', 99, NULL, 'TIGR01726', 289248),
(483574, 'TIGR01916', NULL, 'F420_cofE: coenzyme F420-0:L-glutamate ligase', 244, NULL, 'TIGR01916', 289249),
(483575, 'TIGR02062', NULL, 'RNase_B: exoribonuclease II', 646, NULL, 'TIGR02062', 289250),
(483576, 'TIGR00067', NULL, 'glut_race: glutamate racemase', 251, NULL, 'TIGR00067', 289251),
(483577, 'TIGR00852', NULL, 'pts-Glc: PTS system, maltose and glucose-specific subfamily, IIC component', 290, NULL, 'TIGR00852', 289252),
(483578, 'TIGR02199', NULL, 'rfaE_dom_II: bifunctional protein RfaE, domain II', 144, NULL, 'TIGR02199', 289253),
(483579, 'TIGR04247', NULL, 'NosD_copper_fam: nitrous oxide reductase family maturation protein NosD', 377, NULL, 'TIGR04247', 289254),
(483580, 'TIGR03413', NULL, 'GSH_gloB: hydroxyacylglutathione hydrolase', 248, NULL, 'TIGR03413', 289255),
(483581, 'TIGR03419', NULL, 'NifU_clost: FeS cluster assembly scaffold protein NifU', 121, NULL, 'TIGR03419', 289256),
(483582, 'TIGR02507', NULL, 'MtrF: tetrahydromethanopterin S-methyltransferase, F subunit', 65, NULL, 'TIGR02507', 289257),
(483583, 'TIGR00643', NULL, 'recG: ATP-dependent DNA helicase RecG', 629, NULL, 'TIGR00643', 289258),
(483584, 'TIGR02317', NULL, 'prpB: methylisocitrate lyase', 285, NULL, 'TIGR02317', 289259),
(483585, 'TIGR00721', NULL, 'tfx: DNA-binding protein, Tfx family', 137, NULL, 'TIGR00721', 289260),
(483586, 'TIGR02828', NULL, 'TIGR02828: putative membrane fusion protein', 188, NULL, 'TIGR02828', 289261),
(483587, 'TIGR03740', NULL, 'galliderm_ABC: lantibiotic protection ABC transporter, ATP-binding subunit', 223, NULL, 'TIGR03740', 289262),
(483588, 'TIGR02959', NULL, 'SigZ: RNA polymerase sigma factor, SigZ family', 170, NULL, 'TIGR02959', 289263),
(483589, 'TIGR04004', NULL, 'WcaM: colanic acid biosynthesis protein WcaM', 464, NULL, 'TIGR04004', 289264),
(483590, 'TIGR02140', NULL, 'permease_CysW: sulfate ABC transporter, permease protein CysW', 261, NULL, 'TIGR02140', 289265),
(483591, 'TIGR04038', NULL, 'tatD_link_rSAM: radical SAM protein, TatD family-associated', 192, NULL, 'TIGR04038', 289266),
(483592, 'TIGR01580', NULL, 'narG: nitrate reductase, alpha subunit', 1235, NULL, 'TIGR01580', 289267),
(483593, 'TIGR01016', NULL, 'sucCoAbeta: succinate-CoA ligase, beta subunit', 386, NULL, 'TIGR01016', 289268),
(483594, 'TIGR02034', NULL, 'CysN: sulfate adenylyltransferase, large subunit', 406, NULL, 'TIGR02034', 289269),
(483595, 'TIGR04278', NULL, 'viperin: antiviral radical SAM protein viperin', 347, NULL, 'TIGR04278', 289270);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(483596, 'TIGR01340', NULL, 'aconitase_mito: aconitate hydratase, mitochondrial', 745, NULL, 'TIGR01340', 289271),
(483597, 'TIGR03086', NULL, 'TIGR03086: TIGR03086 family protein', 180, NULL, 'TIGR03086', 289272),
(483598, 'TIGR03846', NULL, 'sulfopy_beta: sulfopyruvate decarboxylase, beta subunit', 182, NULL, 'TIGR03846', 289273),
(483599, 'TIGR02495', NULL, 'NrdG2: anaerobic ribonucleoside-triphosphate reductase activating protein', 193, NULL, 'TIGR02495', 289274),
(483600, 'TIGR04141', NULL, 'TIGR04141: sporadically distributed protein, TIGR04141 family', 516, NULL, 'TIGR04141', 289275),
(483601, 'TIGR04465', NULL, 'ArgArg_F420: TAT-translocated F420-dependent dehydrogenase, FGD2 family', 364, NULL, 'TIGR04465', 289276),
(483602, 'TIGR03310', NULL, 'matur_MocA_YgfJ: molybdenum cofactor cytidylyltransferase', 188, NULL, 'TIGR03310', 289277),
(483603, 'TIGR01913', NULL, 'bet_lambda: phage recombination protein Bet', 188, NULL, 'TIGR01913', 289278),
(483604, 'TIGR04437', NULL, 'WaaZ_KDO_III: 3-deoxy-D-manno-oct-2-ulosonate III transferase WaaZ', 252, NULL, 'TIGR04437', 289279),
(483605, 'TIGR00064', NULL, 'ftsY: signal recognition particle-docking protein FtsY', 279, NULL, 'TIGR00064', 289280),
(483606, 'TIGR03983', NULL, 'cas1_MYXAN: CRISPR-associated endonuclease Cas1, subtype MYXAN', 347, NULL, 'TIGR03983', 289281),
(483607, 'TIGR00886', NULL, '2A0108: nitrite transporter', 368, NULL, 'TIGR00886', 289282),
(483608, 'TIGR04540', NULL, 'CLB_0814_fam: conserved hypothetical protein', 73, NULL, 'TIGR04540', 289283),
(483609, 'TIGR01443', NULL, 'intein_Cterm: intein C-terminal splicing region', 24, NULL, 'TIGR01443', 289284),
(483610, 'TIGR03687', NULL, 'pupylate_cterm: ubiquitin-like protein Pup', 33, NULL, 'TIGR03687', 289285),
(483611, 'TIGR00092', NULL, 'TIGR00092: GTP-binding protein YchF', 368, NULL, 'TIGR00092', 289286),
(483612, 'TIGR00612', NULL, 'ispG_gcpE: 4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase', 357, NULL, 'TIGR00612', 289287),
(483613, 'TIGR02570', NULL, 'cas7_GSU0053: CRISPR-associated protein GSU0053/csb1, Dpsyc system', 178, NULL, 'TIGR02570', 289288),
(483614, 'TIGR02856', NULL, 'spore_yqfC: sporulation protein YqfC', 85, NULL, 'TIGR02856', 289289),
(483615, 'TIGR00749', NULL, 'glk: glucokinase', 315, NULL, 'TIGR00749', 289290),
(483616, 'TIGR03522', NULL, 'GldA_ABC_ATP: gliding motility-associated ABC transporter ATP-binding subunit GldA', 301, NULL, 'TIGR03522', 289291),
(483617, 'TIGR00989', NULL, '3a0801s07tom40: mitochondrial import receptor subunit', 161, NULL, 'TIGR00989', 289292),
(483618, 'TIGR01203', NULL, 'HGPRTase: hypoxanthine phosphoribosyltransferase', 167, NULL, 'TIGR01203', 289293),
(483619, 'TIGR03447', NULL, 'mycothiol_MshC: cysteine--1-D-myo-inosityl 2-amino-2-deoxy-alpha-D-glucopyranoside ligase', 411, NULL, 'TIGR03447', 289294),
(483620, 'TIGR01125', NULL, 'TIGR01125: ribosomal protein S12 methylthiotransferase RimO', 432, NULL, 'TIGR01125', 289295),
(483621, 'TIGR00425', NULL, 'CBF5: putative rRNA pseudouridine synthase', 322, NULL, 'TIGR00425', 289296),
(483622, 'TIGR02171', NULL, 'Fb_sc_TIGR02171: fibrobacter succinogenes paralogous family TIGR02171', 912, NULL, 'TIGR02171', 289297),
(483623, 'TIGR02931', NULL, 'anfK_nitrog: Fe-only nitrogenase, beta subunit', 461, NULL, 'TIGR02931', 289298),
(483624, 'TIGR04300', NULL, 'exosort_XrtM: exosortase family protein XrtM', 150, NULL, 'TIGR04300', 289299),
(483625, 'TIGR00173', NULL, 'menD: 2-succinyl-5-enolpyruvyl-6-hydroxy-3-cyclohexene-1-carboxylic-acid synthase', 435, NULL, 'TIGR00173', 289300),
(483626, 'TIGR00640', NULL, 'acid_CoA_mut_C: methylmalonyl-CoA mutase C-terminal domain', 132, NULL, 'TIGR00640', 289301),
(483627, 'TIGR01795', NULL, 'CM_mono_cladeE: chorismate mutase', 94, NULL, 'TIGR01795', 289302),
(483628, 'TIGR04356', NULL, 'grasp_GAK: ATP-grasp enzyme, GAK system', 287, NULL, 'TIGR04356', 289303),
(483629, 'TIGR03201', NULL, 'dearomat_had: 6-hydroxycyclohex-1-ene-1-carbonyl-CoA dehydrogenase', 349, NULL, 'TIGR03201', 289304),
(483630, 'TIGR00777', NULL, 'ahpD: alkylhydroperoxidase, AhpD family', 177, NULL, 'TIGR00777', 289305);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(483631, 'TIGR03338', NULL, 'phnR_burk: phosphonate utilization associated transcriptional regulator', 212, NULL, 'TIGR03338', 289306),
(483632, 'TIGR03161', NULL, 'ribazole_CobZ: alpha-ribazole phosphatase CobZ', 140, NULL, 'TIGR03161', 289307),
(483633, 'TIGR02747', NULL, 'TraV: type IV conjugative transfer system protein TraV', 145, NULL, 'TIGR02747', 289308),
(483634, 'TIGR00883', NULL, '2A0106: MFS transporter, metabolite:H+ symporter (MHS) family protein', 400, NULL, 'TIGR00883', 289309),
(483635, 'TIGR02719', NULL, 'repress_PhaQ: poly-beta-hydroxybutyrate-responsive repressor', 138, NULL, 'TIGR02719', 289310),
(483636, 'TIGR03631', NULL, 'uS13_bact: ribosomal protein uS13', 113, NULL, 'TIGR03631', 289311),
(483637, 'TIGR01191', NULL, 'ccmC: heme exporter protein CcmC', 184, NULL, 'TIGR01191', 289312),
(483638, 'TIGR04113', NULL, 'cas_csx17: CRISPR-associated protein Csx17, subtype Dpsyc', 718, NULL, 'TIGR04113', 289313),
(483639, 'TIGR00213', NULL, 'GmhB_yaeD: D,D-heptose 1,7-bisphosphate phosphatase', 176, NULL, 'TIGR00213', 289314),
(483640, 'TIGR01368', NULL, 'CPSaseIIsmall: carbamoyl-phosphate synthase, small subunit', 361, NULL, 'TIGR01368', 289315),
(483641, 'TIGR00534', NULL, 'OpcA: glucose-6-phosphate dehydrogenase assembly protein OpcA', 313, NULL, 'TIGR00534', 289316),
(483642, 'TIGR01689', NULL, 'EcbF-BcbF: capsule biosynthesis phosphatase', 126, NULL, 'TIGR01689', 289317),
(483643, 'TIGR03874', NULL, '4cys_cytochr: c-type cytochrome, methanol metabolism-related', 143, NULL, 'TIGR03874', 289318),
(483644, 'TIGR01552', NULL, 'phd_fam: prevent-host-death family protein', 53, NULL, 'TIGR01552', 289319),
(483645, 'TIGR01474', NULL, 'ubiA_proteo: 4-hydroxybenzoate polyprenyl transferase', 282, NULL, 'TIGR01474', 289320),
(483646, 'TIGR03659', NULL, 'IsdE: heme ABC transporter, heme-binding protein isdE', 292, NULL, 'TIGR03659', 289321),
(483647, 'TIGR02504', NULL, 'NrdJ_Z: ribonucleoside-diphosphate reductase, adenosylcobalamin-dependent', 606, NULL, 'TIGR02504', 289322),
(483648, 'TIGR02143', NULL, 'trmA_only: tRNA (uracil(54)-C(5))-methyltransferase', 352, NULL, 'TIGR02143', 289323),
(483649, 'TIGR02065', NULL, 'ECX1: exosome complex exonuclease 1', 230, NULL, 'TIGR02065', 289324),
(483650, 'TIGR03298', NULL, 'argP: transcriptional regulator, ArgP family', 292, NULL, 'TIGR03298', 289325),
(483651, 'TIGR01873', NULL, 'cas_CT1978: CRISPR-associated endoribonuclease Cas2, subtype I-E/ECOLI', 87, NULL, 'TIGR01873', 289326),
(483652, 'TIGR02386', NULL, 'rpoC_TIGR: DNA-directed RNA polymerase, beta'' subunit', 1147, NULL, 'TIGR02386', 289327),
(483653, 'TIGR00319', NULL, 'desulf_FeS4: desulfoferrodoxin FeS4 iron-binding domain', 34, NULL, 'TIGR00319', 289328),
(483654, 'TIGR01231', NULL, 'lacC: tagatose-6-phosphate kinase', 310, NULL, 'TIGR01231', 289329),
(483655, 'TIGR01729', NULL, 'taurine_ABC_bnd: taurine ABC transporter, periplasmic binding protein', 300, NULL, 'TIGR01729', 289330),
(483656, 'TIGR03416', NULL, 'ABC_choXWV_perm: choline ABC transporter, permease protein', 267, NULL, 'TIGR03416', 289331),
(483657, 'TIGR04434', NULL, 'rSAM_Pput_1520: B12-binding domain/radical SAM domain protein', 515, NULL, 'TIGR04434', 289332),
(483658, 'TIGR04088', NULL, 'cognate_SipW: SipW-cognate class signal peptide', 34, NULL, 'TIGR04088', 289333),
(483659, 'TIGR01390', NULL, 'CycNucDiestase: 2'',3''-cyclic-nucleotide 2''-phosphodiesterase', 626, NULL, 'TIGR01390', 289334),
(483660, 'TIGR01826', NULL, 'CofD_related: conserved hypothetical protein', 310, NULL, 'TIGR01826', 289335),
(483661, 'TIGR02464', NULL, 'ribofla_fusion: conserved hypothetical protein', 153, NULL, 'TIGR02464', 289336),
(483662, 'TIGR01103', NULL, 'fliP: flagellar biosynthetic protein FliP', 197, NULL, 'TIGR01103', 289337),
(483663, 'TIGR04191', NULL, 'YphP_YqiW: putative bacilliredoxin, YphP/YqiW family', 136, NULL, 'TIGR04191', 289338),
(483664, 'TIGR02224', NULL, 'recomb_XerC: tyrosine recombinase XerC', 295, NULL, 'TIGR02224', 289339),
(483665, 'TIGR02031', NULL, 'BchD-ChlD: magnesium chelatase ATPase subunit D', 608, NULL, 'TIGR02031', 289340);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(483666, 'TIGR03603', NULL, 'cyclo_dehy_ocin: thiazole/oxazole-forming peptide maturase, SagC family component', 319, NULL, 'TIGR03603', 289341),
(483667, 'TIGR03793', NULL, 'TOMM_pelo: NHLP leader peptide domain', 77, NULL, 'TIGR03793', 289342),
(483668, 'TIGR01343', NULL, 'hacA_fam: homoaconitate hydratase family protein', 412, NULL, 'TIGR01343', 289343),
(483669, 'TIGR02619', NULL, 'TIGR02619: putative CRISPR-associated protein, APE2256 family', 149, NULL, 'TIGR02619', 289344),
(483670, 'TIGR02722', NULL, 'lp_: uncharacterized lipoprotein', 189, NULL, 'TIGR02722', 289345),
(483671, 'TIGR01150', NULL, 'puhA: photosynthetic reaction center H subunit', 252, NULL, 'TIGR01150', 289346),
(483672, 'TIGR04144', NULL, 'archaeo_VPXXXP: archaeosortase B', 156, NULL, 'TIGR04144', 289347),
(483673, 'TIGR00945', NULL, 'tatC: twin arginine-targeting protein translocase TatC', 215, NULL, 'TIGR00945', 289348),
(483674, 'TIGR00310', NULL, 'ZPR1_znf: ZPR1 zinc finger domain', 192, NULL, 'TIGR00310', 289349),
(483675, 'TIGR00216', NULL, 'ispH_lytB: 4-hydroxy-3-methylbut-2-enyl diphosphate reductase', 282, NULL, 'TIGR00216', 289350),
(483676, 'TIGR00802', NULL, 'nico: transition metal uptake transporter, Ni2+-Co2+ transporter (NiCoT) family', 281, NULL, 'TIGR00802', 289351),
(483677, 'TIGR00687', NULL, 'pyridox_kin: pyridoxal kinase', 288, NULL, 'TIGR00687', 289352),
(483678, 'TIGR02426', NULL, 'protocat_pcaB: 3-carboxy-cis,cis-muconate cycloisomerase', 338, NULL, 'TIGR02426', 289353),
(483679, 'TIGR03650', NULL, 'violacein_E: violacein biosynthesis enzyme VioE', 184, NULL, 'TIGR03650', 289354),
(483680, 'TIGR00550', NULL, 'nadA: quinolinate synthetase complex, A subunit', 309, NULL, 'TIGR00550', 289355),
(483681, 'TIGR02666', NULL, 'moaA: molybdenum cofactor biosynthesis protein A', 336, NULL, 'TIGR02666', 289356),
(483682, 'TIGR03248', NULL, 'galactar-dH20: galactarate dehydratase', 507, NULL, 'TIGR03248', 289357),
(483683, 'TIGR01085', NULL, 'murE: UDP-N-acetylmuramyl-tripeptide synthetase', 472, NULL, 'TIGR01085', 289358),
(483684, 'TIGR00939', NULL, '2a57: nucleoside Transporter', 439, NULL, 'TIGR00939', 289359),
(483685, 'TIGR03008', NULL, 'pepcterm_CAAX: CAAX prenyl protease-related protein', 222, NULL, 'TIGR03008', 289360),
(483686, 'TIGR01583', NULL, 'formate-DH-gamm: formate dehydrogenase, gamma subunit', 204, NULL, 'TIGR01583', 289361),
(483687, 'TIGR02168', NULL, 'SMC_prok_B: chromosome segregation protein SMC', 1181, NULL, 'TIGR02168', 289362),
(483688, 'TIGR02859', NULL, 'spore_sigH: RNA polymerase sigma-H factor', 198, NULL, 'TIGR02859', 289363),
(483689, 'TIGR00746', NULL, 'arcC: carbamate kinase', 309, NULL, 'TIGR00746', 289364),
(483690, 'TIGR03591', NULL, 'polynuc_phos: polyribonucleotide nucleotidyltransferase', 689, NULL, 'TIGR03591', 289365),
(483691, 'TIGR03064', NULL, 'sortase_srtB: sortase, SrtB family', 235, NULL, 'TIGR03064', 289366),
(483692, 'TIGR02230', NULL, 'ATPase_gene1: putative F0F1-ATPase subunit', 100, NULL, 'TIGR02230', 289367),
(483693, 'TIGR03506', NULL, 'FlgEFG_subfam: flagellar hook-basal body protein', 351, NULL, 'TIGR03506', 289368),
(483694, 'TIGR01334', NULL, 'modD: modD protein', 277, NULL, 'TIGR01334', 289369),
(483695, 'TIGR01882', NULL, 'peptidase-T: peptidase T', 410, NULL, 'TIGR01882', 289370),
(483696, 'TIGR04490', NULL, 'SoxZ_true: thiosulfate oxidation carrier complex protein SoxZ', 98, NULL, 'TIGR04490', 289371),
(483697, 'TIGR03805', NULL, 'beta_helix_1: parallel beta-helix repeat-containing protein', 314, NULL, 'TIGR03805', 289372),
(483698, 'TIGR01144', NULL, 'ATP_synt_b: ATP synthase F0, B subunit', 147, NULL, 'TIGR01144', 289373),
(483699, 'TIGR02906', NULL, 'spore_CotS: spore coat protein, CotS family', 314, NULL, 'TIGR02906', 289374),
(483700, 'TIGR01091', NULL, 'upp: uracil phosphoribosyltransferase', 207, NULL, 'TIGR01091', 289375),
(483701, 'TIGR03307', NULL, 'PhnP: phosphonate metabolism protein PhnP', 249, NULL, 'TIGR03307', 289376),
(483702, 'TIGR01384', NULL, 'TFS_arch: transcription factor S', 101, NULL, 'TIGR01384', 289377),
(483703, 'TIGR01779', NULL, 'TonB-B12: TonB-dependent vitamin B12 receptor', 614, NULL, 'TIGR01779', 289378);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(483704, 'TIGR01969', NULL, 'minD_arch: cell division ATPase MinD', 251, NULL, 'TIGR01969', 289379),
(483705, 'TIGR01574', NULL, 'miaB-methiolase: tRNA-i(6)A37 thiotransferase enzyme MiaB', 437, NULL, 'TIGR01574', 289380),
(483706, 'TIGR03787', NULL, 'marine_sort_RR: proteobacterial dedicated sortase system response regulator', 227, NULL, 'TIGR03787', 289381),
(483707, 'TIGR02763', NULL, 'chlamy_scaf: scaffolding protein', 114, NULL, 'TIGR02763', 289382),
(483708, 'TIGR02953', NULL, 'penta_MxKDx: pentapeptide MXKDX repeat protein', 78, NULL, 'TIGR02953', 289383),
(483709, 'TIGR03014', NULL, 'EpsL: exopolysaccharide biosynthesis operon protein EpsL', 380, NULL, 'TIGR03014', 289384),
(483710, 'TIGR00257', NULL, 'IMPACT_YIGZ: uncharacterized protein, YigZ family', 205, NULL, 'TIGR00257', 289385),
(483711, 'TIGR03746', NULL, 'conj_TIGR03746: integrating conjugative element protein, PFL_4703 family', 202, NULL, 'TIGR03746', 289386),
(483712, 'TIGR03890', NULL, 'nif11_cupin: nif11 domain/cupin domain protein', 171, NULL, 'TIGR03890', 289387),
(483713, 'TIGR00447', NULL, 'pth: aminoacyl-tRNA hydrolase', 188, NULL, 'TIGR00447', 289388),
(483714, 'TIGR00263', NULL, 'trpB: tryptophan synthase, beta subunit', 385, NULL, 'TIGR00263', 289389),
(483715, 'TIGR00453', NULL, 'ispD: 2-C-methyl-D-erythritol 4-phosphate cytidylyltransferase', 219, NULL, 'TIGR00453', 289390),
(483716, 'TIGR02127', NULL, 'pyrF_sub2: orotidine 5''-phosphate decarboxylase', 261, NULL, 'TIGR02127', 289391),
(483717, 'TIGR04135', NULL, 'FibroRuminTarg: Cys-rich radical SAM target, FibroRumin family', 52, NULL, 'TIGR04135', 289392),
(483718, 'TIGR00388', NULL, 'glyQ: glycine--tRNA ligase, alpha subunit', 293, NULL, 'TIGR00388', 289393),
(483719, 'TIGR01876', NULL, 'cas_Cas5d: CRISPR-associated protein Cas5, subtype I-C/DVULG', 203, NULL, 'TIGR01876', 289394),
(483720, 'TIGR03111', NULL, 'glyc2_xrt_Gpos1: putative glycosyltransferase, exosortase G-associated', 439, NULL, 'TIGR03111', 289395),
(483721, 'TIGR01287', NULL, 'nifH: nitrogenase iron protein', 275, NULL, 'TIGR01287', 289396),
(483722, 'TIGR04443', NULL, 'F420_CofF: coenzyme gamma-F420-2:alpha-L-glutamate ligase', 283, NULL, 'TIGR04443', 289397),
(483723, 'TIGR03295', NULL, 'frhA: coenzyme F420 hydrogenase, subunit alpha', 412, NULL, 'TIGR03295', 289398),
(483724, 'TIGR02271', NULL, 'TIGR02271: conserved domain', 115, NULL, 'TIGR02271', 289399),
(483725, 'TIGR02461', NULL, 'osmo_MPG_phos: mannosyl-3-phosphoglycerate phosphatase', 227, NULL, 'TIGR02461', 289400),
(483726, 'TIGR04244', NULL, 'nitrous_NosZ_RR: nitrous-oxide reductase, TAT-dependent', 627, NULL, 'TIGR04244', 289401),
(483727, 'TIGR02654', NULL, 'circ_KaiB: circadian clock protein KaiB', 87, NULL, 'TIGR02654', 289402),
(483728, 'TIGR01636', NULL, 'phage_rinA: phage transcriptional regulator, RinA family', 134, NULL, 'TIGR01636', 289403),
(483729, 'TIGR02068', NULL, 'cya_phycin_syn: cyanophycin synthetase', 864, NULL, 'TIGR02068', 289404),
(483730, 'TIGR03363', NULL, 'VI_chp_8: type VI secretion-associated protein, ImpA family', 353, NULL, 'TIGR03363', 289405),
(483731, 'TIGR04381', NULL, 'HTH_TypR: TyrR family helix-turn-helix domain', 49, NULL, 'TIGR04381', 289406),
(483732, 'TIGR00148', NULL, 'TIGR00148: decarboxylase, UbiD family', 438, NULL, 'TIGR00148', 289407),
(483733, 'TIGR00755', NULL, 'ksgA: ribosomal RNA small subunit methyltransferase A', 256, NULL, 'TIGR00755', 289408),
(483734, 'TIGR03207', NULL, 'cyc_hxne_CoA_dh: cyclohexanecarboxyl-CoA dehydrogenase', 372, NULL, 'TIGR03207', 289409),
(483735, 'TIGR04334', NULL, 'rSAM_Clo7bot: radical SAM/SPASM domain Clo7bot peptide maturase', 440, NULL, 'TIGR04334', 289410),
(483736, 'TIGR03556', NULL, 'photolyase_8HDF: deoxyribodipyrimidine photo-lyase, 8-HDF type', 471, NULL, 'TIGR03556', 289411),
(483737, 'TIGR00120', NULL, 'ArgJ: glutamate N-acetyltransferase/amino-acid acetyltransferase', 405, NULL, 'TIGR00120', 289412),
(483738, 'TIGR00500', NULL, 'met_pdase_I: methionine aminopeptidase, type I', 247, NULL, 'TIGR00500', 289413),
(483739, 'TIGR02918', NULL, 'TIGR02918: accessory Sec system glycosylation protein GtfA', 500, NULL, 'TIGR02918', 289414);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(483740, 'TIGR03254', NULL, 'oxalate_oxc: oxalyl-CoA decarboxylase', 554, NULL, 'TIGR03254', 289415),
(483741, 'TIGR02822', NULL, 'adh_fam_2: zinc-binding alcohol dehydrogenase family protein', 329, NULL, 'TIGR02822', 289416),
(483742, 'TIGR00740', NULL, 'TIGR00740: tRNA (cmo5U34)-methyltransferase', 239, NULL, 'TIGR00740', 289417),
(483743, 'TIGR03977', NULL, 'rSAM_pair_HxsC: His-Xaa-Ser system radical SAM maturase HxsC', 292, NULL, 'TIGR03977', 289418),
(483744, 'TIGR00877', NULL, 'purD: phosphoribosylamine--glycine ligase', 425, NULL, 'TIGR00877', 289419),
(483745, 'TIGR03840', NULL, 'TMPT_Se_Te: thiopurine S-methyltransferase, Se/Te detoxification family', 213, NULL, 'TIGR03840', 289420),
(483746, 'TIGR01527', NULL, 'arch_NMN_Atrans: nicotinamide-nucleotide adenylyltransferase', 167, NULL, 'TIGR01527', 289421),
(483747, 'TIGR00360', NULL, 'ComEC_N-term: ComEC/Rec2-related protein', 171, NULL, 'TIGR00360', 289422),
(483748, 'TIGR01275', NULL, 'ACC_deam_rel: pyridoxal phosphate-dependent enzymes, D-cysteine desulfhydrase family', 321, NULL, 'TIGR01275', 289423),
(483749, 'TIGR00497', NULL, 'hsdM: type I restriction-modification system, M subunit', 515, NULL, 'TIGR00497', 289424),
(483750, 'TIGR03058', NULL, 'rpt_csmH: chlorosome envelope protein H', 27, NULL, 'TIGR03058', 289425),
(483751, 'TIGR00556', NULL, 'pantethn_trn: phosphopantetheine--protein transferase domain', 128, NULL, 'TIGR00556', 289426),
(483752, 'TIGR02040', NULL, 'PpsR-CrtJ: transcriptional regulator PpsR', 442, NULL, 'TIGR02040', 289427),
(483753, 'TIGR02420', NULL, 'dksA: RNA polymerase-binding protein DksA', 110, NULL, 'TIGR02420', 289428),
(483754, 'TIGR03316', NULL, 'ygeW: knotted carbamoyltransferase YgeW', 391, NULL, 'TIGR03316', 289429),
(483755, 'TIGR03195', NULL, '4hydrxCoA_B: 4-hydroxybenzoyl-CoA reductase, beta subunit', 321, NULL, 'TIGR03195', 289430),
(483756, 'TIGR03781', NULL, 'Bac_Flav_CT_K: Bacteroides conjugative transposon TraK protein', 202, NULL, 'TIGR03781', 289431),
(483757, 'TIGR00995', NULL, '3a0901s06TIC22: chloroplast protein import component, Tic22 family', 270, NULL, 'TIGR00995', 289432),
(483758, 'TIGR01773', NULL, 'GABAperm: GABA permease', 452, NULL, 'TIGR01773', 289433),
(483759, 'TIGR03460', NULL, 'crt_membr_arch: carotene biosynthesis associated membrane protein', 248, NULL, 'TIGR03460', 289434),
(483760, 'TIGR02059', NULL, 'swm_rep_I: cyanobacterial long protein repeat', 101, NULL, 'TIGR02059', 289435),
(483761, 'TIGR01832', NULL, 'kduD: 2-deoxy-D-gluconate 3-dehydrogenase', 248, NULL, 'TIGR01832', 289436),
(483762, 'TIGR04060', NULL, 'formate_focA: formate transporter FocA', 268, NULL, 'TIGR04060', 289437),
(483763, 'TIGR03351', NULL, 'PhnX-like: phosphonatase-like hydrolase', 220, NULL, 'TIGR03351', 289438),
(483764, 'TIGR04197', NULL, 'T7SS_SACOL2603: type VII secretion effector, TIGR04197 family', 85, NULL, 'TIGR04197', 289439),
(483765, 'TIGR00023', NULL, 'TIGR00023: acyl-phosphate glycerol 3-phosphate acyltransferase', 196, NULL, 'TIGR00023', 289440),
(483766, 'TIGR00693', NULL, 'thiE: thiamine-phosphate diphosphorylase', 197, NULL, 'TIGR00693', 289441),
(483767, 'TIGR02177', NULL, 'PorB_KorB: 2-oxoacid:acceptor oxidoreductase, beta subunit, pyruvate/2-ketoisovalerate family', 286, NULL, 'TIGR02177', 289442),
(483768, 'TIGR04185', NULL, 'ATPgraspMvdC: ATP-grasp ribosomal peptide maturase, MvdC family', 318, NULL, 'TIGR04185', 289443),
(483769, 'TIGR01178', NULL, 'ade: adenine deaminase', 552, NULL, 'TIGR01178', 289444),
(483770, 'TIGR02470', NULL, 'sucr_synth: sucrose synthase', 784, NULL, 'TIGR02470', 289445),
(483771, 'TIGR04565', NULL, 'OMP_myx_plus: outer membrane beta-barrel protein', 161, NULL, 'TIGR04565', 289446),
(483772, 'TIGR02968', NULL, 'succ_dehyd_anc: succinate dehydrogenase, hydrophobic membrane anchor protein', 105, NULL, 'TIGR02968', 289447),
(483773, 'TIGR04013', NULL, 'B12_SAM_MJ_1487: B12-binding domain/radical SAM domain protein, MJ_1487 family', 382, NULL, 'TIGR04013', 289448),
(483774, 'TIGR02557', NULL, 'HpaP: type III secretion protein HpaP', 204, NULL, 'TIGR02557', 289449);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(483775, 'TIGR02236', NULL, 'recomb_radA: DNA repair and recombination protein RadA', 311, NULL, 'TIGR02236', 289450),
(483776, 'TIGR03410', NULL, 'urea_trans_UrtE: urea ABC transporter, ATP-binding protein UrtE', 230, NULL, 'TIGR03410', 289451),
(483777, 'TIGR00986', NULL, '3a0801s05tom22: mitochondrial import receptor subunit', 145, NULL, 'TIGR00986', 289452),
(483778, 'TIGR01402', NULL, 'fliQ: flagellar biosynthetic protein FliQ', 88, NULL, 'TIGR01402', 289453),
(483779, 'TIGR00195', NULL, 'exoDNase_III: exodeoxyribonuclease III', 254, NULL, 'TIGR00195', 289454),
(483780, 'TIGR01820', NULL, 'TrpE-arch: anthranilate synthase component I', 449, NULL, 'TIGR01820', 289455),
(483781, 'TIGR03684', NULL, 'arCOG00985: arCOG04150 universal archaeal PUA-domain protein', 154, NULL, 'TIGR03684', 289456),
(483782, 'TIGR00646', NULL, 'MG010: DNA primase-like protein', 218, NULL, 'TIGR00646', 289457),
(483783, 'TIGR03849', NULL, 'arch_ComA: phosphosulfolactate synthase', 237, NULL, 'TIGR03849', 289458),
(483784, 'TIGR00509', NULL, 'bisC_fam: molybdopterin guanine dinucleotide-containing S/N-oxide reductases', 772, NULL, 'TIGR00509', 289459),
(483785, 'TIGR03986', NULL, 'TIGR03986: CRISPR-associated protein', 568, NULL, 'TIGR03986', 289460),
(483786, 'TIGR00207', NULL, 'fliG: flagellar motor switch protein FliG', 338, NULL, 'TIGR00207', 289461),
(483787, 'TIGR04518', NULL, 'ECF_S_folT_fam: ECF transporter S component, folate family', 163, NULL, 'TIGR04518', 289462),
(483788, 'TIGR02333', NULL, '2met_isocit_dHY: 2-methylisocitrate dehydratase, Fe/S-dependent', 858, NULL, 'TIGR02333', 289463),
(483789, 'TIGR02713', NULL, 'allophanate_hyd: allophanate hydrolase', 563, NULL, 'TIGR02713', 289464),
(483790, 'TIGR00705', NULL, 'SppA_67K: signal peptide peptidase SppA, 67K type', 590, NULL, 'TIGR00705', 289465),
(483791, 'TIGR00325', NULL, 'lpxC: UDP-3-O-[3-hydroxymyristoyl] N-acetylglucosamine deacetylase', 297, NULL, 'TIGR00325', 289466),
(483792, 'TIGR00011', NULL, 'YbaK_EbsC: Cys-tRNA(Pro) deacylase', 152, NULL, 'TIGR00011', 289467),
(483793, 'TIGR03488', NULL, 'cas_Cas5p: CRISPR-associated protein Cas5, subtype PGING', 236, NULL, 'TIGR03488', 289468),
(483794, 'TIGR00790', NULL, 'fnt: formate/nitrite transporter', 239, NULL, 'TIGR00790', 289469),
(483795, 'TIGR03547', NULL, 'muta_rot_YjhT: mutatrotase, YjhT family', 346, NULL, 'TIGR03547', 289470),
(483796, 'TIGR01683', NULL, 'thiS: thiamine biosynthesis protein ThiS', 64, NULL, 'TIGR01683', 289471),
(483797, 'TIGR02831', NULL, 'spo_II_M: stage II sporulation protein M', 200, NULL, 'TIGR02831', 289472),
(483798, 'TIGR01041', NULL, 'ATP_syn_B_arch: ATP synthase archaeal, B subunit', 458, NULL, 'TIGR01041', 289473),
(483799, 'TIGR01539', NULL, 'portal_lambda: phage portal protein, lambda family', 457, NULL, 'TIGR01539', 289474),
(483800, 'TIGR04054', NULL, 'rSAM_NirJ1: putative heme d1 biosynthesis radical SAM protein NirJ1', 387, NULL, 'TIGR04054', 289475),
(483801, 'TIGR00372', NULL, 'cas4: CRISPR-associated protein Cas4', 180, NULL, 'TIGR00372', 289476),
(483802, 'TIGR02018', NULL, 'his_ut_repres: histidine utilization repressor', 230, NULL, 'TIGR02018', 289477),
(483803, 'TIGR02258', NULL, '2_5_ligase: 2''-5'' RNA ligase', 180, NULL, 'TIGR02258', 289478),
(483804, 'TIGR02604', NULL, 'Piru_Ver_Nterm: putative membrane-bound dehydrogenase domain', 367, NULL, 'TIGR02604', 289479),
(483805, 'TIGR00808', NULL, 'malonate_madM: malonate transporter, MadM subunit', 254, NULL, 'TIGR00808', 289480),
(483806, 'TIGR04552', NULL, 'TIGR04552: TIGR04552 family protein', 352, NULL, 'TIGR04552', 289481),
(483807, 'TIGR00578', NULL, 'ku70: ATP-dependent DNA helicase II, 70 kDa subunit (ku70)', 586, NULL, 'TIGR00578', 289482),
(483808, 'TIGR03139', NULL, 'QueF-II: 7-cyano-7-deazaguanine reductase', 115, NULL, 'TIGR03139', 289483),
(483809, 'TIGR00441', NULL, 'gmhA: phosphoheptose isomerase', 154, NULL, 'TIGR00441', 289484),
(483810, 'TIGR03002', NULL, 'outer_YhbN_LptA: lipopolysaccharide transport periplasmic protein LptA', 142, NULL, 'TIGR03002', 289485),
(483811, 'TIGR00338', NULL, 'serB: phosphoserine phosphatase SerB', 219, NULL, 'TIGR00338', 289486);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(483812, 'TIGR04449', NULL, 'halocin_C8_dom: halocin C8-like bacteriocin domain', 69, NULL, 'TIGR04449', 289487),
(483813, 'TIGR03173', NULL, 'pbuX: xanthine permease', 407, NULL, 'TIGR03173', 289488),
(483814, 'TIGR01253', NULL, 'thiP: thiamine/thiamine pyrophosphate ABC transporter, permease protein', 519, NULL, 'TIGR01253', 289489),
(483815, 'TIGR02121', NULL, 'Na_Pro_sym: sodium/proline symporter', 488, NULL, 'TIGR02121', 289490),
(483816, 'TIGR04524', NULL, 'mycoplas_M_dom: IgG-blocking virulence domain', 253, NULL, 'TIGR04524', 289491),
(483817, 'TIGR01723', NULL, 'hmd_TIGR: 5,10-methenyltetrahydromethanopterin hydrogenase', 340, NULL, 'TIGR01723', 289492),
(483818, 'TIGR03500', NULL, 'FliO_TIGR: flagellar biosynthetic protein FliO', 70, NULL, 'TIGR03500', 289493),
(483819, 'TIGR02728', NULL, 'spore_gerQ: spore coat protein GerQ', 82, NULL, 'TIGR02728', 289494),
(483820, 'TIGR01957', NULL, 'nuoB_fam: NADH-quinone oxidoreductase, B subunit', 145, NULL, 'TIGR01957', 289495),
(483821, 'TIGR02380', NULL, 'ECA_wecA: undecaprenyl-phosphate alpha-N-acetylglucosaminyl 1-phosphatetransferase', 346, NULL, 'TIGR02380', 289496),
(483822, 'TIGR02872', NULL, 'spore_ytvI: sporulation integral membrane protein YtvI', 341, NULL, 'TIGR02872', 289497),
(483823, 'TIGR01465', NULL, 'cobM_cbiF: precorrin-4 C11-methyltransferase', 247, NULL, 'TIGR01465', 289498),
(483824, 'TIGR01888', NULL, 'cas_cmr3: CRISPR type III-B/RAMP module-associated protein Cmr3', 346, NULL, 'TIGR01888', 289499),
(483825, 'TIGR04026', NULL, 'PPOX_FMN_cyano: PPOX class probable FMN-dependent enzyme, alr4036 family', 185, NULL, 'TIGR04026', 289500),
(483826, 'TIGR01717', NULL, 'AMP-nucleosdse: AMP nucleosidase', 478, NULL, 'TIGR01717', 289501),
(483827, 'TIGR01963', NULL, 'PHB_DH: 3-hydroxybutyrate dehydrogenase', 255, NULL, 'TIGR01963', 289502),
(483828, 'TIGR03637', NULL, 'cas1_YPEST: CRISPR-associated endonuclease Cas1, subtype I-F/YPEST', 307, NULL, 'TIGR03637', 289503),
(483829, 'TIGR03971', NULL, 'SDR_subfam_1: SDR family mycofactocin-dependent oxidoreductase', 271, NULL, 'TIGR03971', 289504),
(483830, 'TIGR03896', NULL, 'cyc_nuc_ocin: bacteriocin-type transport-associated protein', 317, NULL, 'TIGR03896', 289505),
(483831, 'TIGR03385', NULL, 'CoA_CoA_reduc: CoA-disulfide reductase', 439, NULL, 'TIGR03385', 289506),
(483832, 'TIGR04294', NULL, 'pre_pil_HX9DG: prepilin-type processing-associated H-X9-DG domain', 16, NULL, 'TIGR04294', 289507),
(483833, 'TIGR01452', NULL, 'PGP_euk: phosphoglycolate/pyridoxal phosphate phosphatase family', 279, NULL, 'TIGR01452', 289508),
(483834, 'TIGR02286', NULL, 'PaaD: phenylacetic acid degradation protein PaaD', 114, NULL, 'TIGR02286', 289509),
(483835, 'TIGR00864', NULL, 'PCC: polycystin cation channel protein', 2700, NULL, 'TIGR00864', 289510),
(483836, 'TIGR02299', NULL, 'HpaE: 5-carboxymethyl-2-hydroxymuconate semialdehyde dehydrogenase', 488, NULL, 'TIGR02299', 289511),
(483837, 'TIGR04306', NULL, 'salvage_TenA: thiaminase II', 208, NULL, 'TIGR04306', 289512),
(483838, 'TIGR00126', NULL, 'deoC: deoxyribose-phosphate aldolase', 211, NULL, 'TIGR00126', 289513),
(483839, 'TIGR00086', NULL, 'smpB: SsrA-binding protein', 144, NULL, 'TIGR00086', 289514),
(483840, 'TIGR01281', NULL, 'DPOR_bchL: light-independent protochlorophyllide reductase, iron-sulfur ATP-binding protein', 268, NULL, 'TIGR01281', 289515),
(483841, 'TIGR03145', NULL, 'cyt_nit_nrfE: cytochrome c nitrate reductase biogenesis protein NrfE', 631, NULL, 'TIGR03145', 289516),
(483842, 'TIGR01109', NULL, 'Na_pump_decarbB: sodium ion-translocating decarboxylase, beta subunit', 354, NULL, 'TIGR01109', 289517),
(483843, 'TIGR03117', NULL, 'cas_csf4: CRISPR type AFERR-associated DEAD/DEAH-box helicase Csf4', 676, NULL, 'TIGR03117', 289518),
(483844, 'TIGR03438', NULL, 'egtD_ergothio: dimethylhistidine N-methyltransferase', 301, NULL, 'TIGR03438', 289519),
(483845, 'TIGR03425', NULL, 'urea_degr_2: urea carboxylase-associated protein 2', 233, NULL, 'TIGR03425', 289520),
(483846, 'TIGR03615', NULL, 'RutF: pyrimidine utilization flavin reductase protein F', 156, NULL, 'TIGR03615', 289521);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(483847, 'TIGR01589', NULL, 'A_thal_3526: uncharacterized plant-specific domain TIGR01589', 57, NULL, 'TIGR01589', 289522),
(483848, 'TIGR00624', NULL, 'tag: DNA-3-methyladenine glycosylase I', 179, NULL, 'TIGR00624', 289523),
(483849, 'TIGR03597', NULL, 'GTPase_YqeH: ribosome biogenesis GTPase YqeH', 361, NULL, 'TIGR03597', 289524),
(483850, 'TIGR02632', NULL, 'RhaD_aldol-ADH: rhamnulose-1-phosphate aldolase/alcohol dehydrogenase', 676, NULL, 'TIGR02632', 289525),
(483851, 'TIGR01424', NULL, 'gluta_reduc_2: glutathione-disulfide reductase', 446, NULL, 'TIGR01424', 289526),
(483852, 'TIGR04082', NULL, 'rSAM_for_selen: selenobiotic family peptide radical SAM maturase', 516, NULL, 'TIGR04082', 289527),
(483853, 'TIGR04272', NULL, 'cxxc_cxxc_Mbark: CxxC-x17-CxxC domain', 37, NULL, 'TIGR04272', 289528),
(483854, 'TIGR03936', NULL, 'sam_1_link_chp: radical SAM-linked protein', 209, NULL, 'TIGR03936', 289529),
(483855, 'TIGR01751', NULL, 'crot-CoA-red: crotonyl-CoA carboxylase/reductase', 398, NULL, 'TIGR01751', 289530),
(483856, 'TIGR03609', NULL, 'S_layer_CsaB: polysaccharide pyruvyl transferase CsaB', 301, NULL, 'TIGR03609', 289531),
(483857, 'TIGR00073', NULL, 'hypB: hydrogenase accessory protein HypB', 217, NULL, 'TIGR00073', 289532),
(483858, 'TIGR02081', NULL, 'metW: methionine biosynthesis protein MetW', 194, NULL, 'TIGR02081', 289533),
(483859, 'TIGR03301', NULL, 'PhnW-AepZ: 2-aminoethylphosphonate aminotransferase', 355, NULL, 'TIGR03301', 289534),
(483860, 'TIGR01745', NULL, 'asd_gamma: aspartate-semialdehyde dehydrogenase', 366, NULL, 'TIGR01745', 289535),
(483861, 'TIGR04266', NULL, 'NDMA_methanol: NDMA-dependent methanol dehydrogenase', 420, NULL, 'TIGR04266', 289536),
(483862, 'TIGR04312', NULL, 'choice_anch_B: choice-of-anchor B domain', 364, NULL, 'TIGR04312', 289537),
(483863, 'TIGR00911', NULL, '2A0308: L-type amino acid transporter', 505, NULL, 'TIGR00911', 289538),
(483864, 'TIGR03930', NULL, 'WXG100_ESAT6: WXG100 family type VII secretion target', 90, NULL, 'TIGR03930', 289539),
(483865, 'TIGR01097', NULL, 'PhnE: phosphonate ABC transporter, permease protein PhnE', 252, NULL, 'TIGR01097', 289540),
(483866, 'TIGR01935', NULL, 'NOT-MenG: RraA family', 150, NULL, 'TIGR01935', 289541),
(483867, 'TIGR00394', NULL, 'lac_pts_IIC: PTS system, lactose-specific IIC component', 412, NULL, 'TIGR00394', 289542),
(483868, 'TIGR02769', NULL, 'nickel_nikE: nickel import ATP-binding protein NikE', 265, NULL, 'TIGR02769', 289543),
(483869, 'TIGR02592', NULL, 'cas_Cas5h: CRISPR-associated protein Cas5, subtype I-B/HMARI', 241, NULL, 'TIGR02592', 289544),
(483870, 'TIGR00584', NULL, 'mug: mismatch-specific thymine-DNA glycosylate (mug)', 328, NULL, 'TIGR00584', 289545),
(483871, 'TIGR03569', NULL, 'NeuB_NnaB: N-acetylneuraminate synthase', 329, NULL, 'TIGR03569', 289546),
(483872, 'TIGR02414', NULL, 'pepN_proteo: aminopeptidase N', 868, NULL, 'TIGR02414', 289547),
(483873, 'TIGR04484', NULL, 'thiosulf_SoxA: sulfur oxidation c-type cytochrome SoxA', 212, NULL, 'TIGR04484', 289548),
(483874, 'TIGR00871', NULL, 'zwf: glucose-6-phosphate dehydrogenase', 486, NULL, 'TIGR00871', 289549),
(483875, 'TIGR03432', NULL, 'yjhG_yagF: putative dehydratase, YjhG/YagF family', 640, NULL, 'TIGR03432', 289550),
(483876, 'TIGR00631', NULL, 'uvrb: excinuclease ABC subunit B', 658, NULL, 'TIGR00631', 289551),
(483877, 'TIGR00768', NULL, 'rimK_fam: alpha-L-glutamate ligase, RimK family', 276, NULL, 'TIGR00768', 289552),
(483878, 'TIGR03329', NULL, 'Phn_aa_oxid: putative aminophosphonate oxidoreductase', 460, NULL, 'TIGR03329', 289553),
(483879, 'TIGR00045', NULL, 'TIGR00045: glycerate kinase', 375, NULL, 'TIGR00045', 289554),
(483880, 'TIGR03964', NULL, 'mycofact_creat: mycofactocin system creatininase family protein', 228, NULL, 'TIGR03964', 289555),
(483881, 'TIGR04259', NULL, 'oxa_formateAnti: oxalate/formate antiporter', 405, NULL, 'TIGR04259', 289556),
(483882, 'TIGR01533', NULL, 'lipo_e_P4: 5''-nucleotidase, lipoprotein e(P4) family', 273, NULL, 'TIGR01533', 289557),
(483883, 'TIGR02809', NULL, 'phasin_3: phasin family protein', 110, NULL, 'TIGR02809', 289558);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(483884, 'TIGR01063', NULL, 'gyrA: DNA gyrase, A subunit', 800, NULL, 'TIGR01063', 289559),
(483885, 'TIGR02912', NULL, 'sulfite_red_C: sulfite reductase, subunit C', 314, NULL, 'TIGR02912', 289560),
(483886, 'TIGR01561', NULL, 'gde_arch: putative glycogen debranching enzyme, archaeal type', 569, NULL, 'TIGR01561', 289561),
(483887, 'TIGR02311', NULL, 'HpaI: 2,4-dihydroxyhept-2-ene-1,7-dioic acid aldolase', 249, NULL, 'TIGR02311', 289562),
(483888, 'TIGR03466', NULL, 'HpnA: hopanoid-associated sugar epimerase', 327, NULL, 'TIGR03466', 289563),
(483889, 'TIGR00182', NULL, 'plsX: fatty acid/phospholipid synthesis protein PlsX', 337, NULL, 'TIGR00182', 289564),
(483890, 'TIGR01458', NULL, 'HAD-SF-IIA-hyp3: HAD hydrolase, TIGR01458 family', 257, NULL, 'TIGR01458', 289565),
(483891, 'TIGR02688', NULL, 'TIGR02688: TIGR02688 family protein', 449, NULL, 'TIGR02688', 289566),
(483892, 'TIGR00406', NULL, 'prmA: ribosomal protein L11 methyltransferase', 288, NULL, 'TIGR00406', 289567),
(483893, 'TIGR02476', NULL, 'BluB: 5,6-dimethylbenzimidazole synthase', 205, NULL, 'TIGR02476', 289568),
(483894, 'TIGR00154', NULL, 'ispE: 4-(cytidine 5''-diphospho)-2-C-methyl-D-erythritol kinase', 294, NULL, 'TIGR00154', 289569),
(483895, 'TIGR02053', NULL, 'MerA: mercury(II) reductase', 465, NULL, 'TIGR02053', 289570),
(483896, 'TIGR02339', NULL, 'thermosome_arch: thermosome, various subunits, archaeal', 521, NULL, 'TIGR02339', 289571),
(483897, 'TIGR03827', NULL, 'GNAT_ablB: putative beta-lysine N-acetyltransferase', 266, NULL, 'TIGR03827', 289572),
(483898, 'TIGR02797', NULL, 'exbB: tonB-system energizer ExbB', 211, NULL, 'TIGR02797', 289573),
(483899, 'TIGR01642', NULL, 'U2AF_lg: U2 snRNP auxilliary factor, large subunit, splicing factor', 510, NULL, 'TIGR01642', 289574),
(483900, 'TIGR01698', NULL, 'PUNP: purine nucleotide phosphorylase', 245, NULL, 'TIGR01698', 289575),
(483901, 'TIGR04019', NULL, 'B_thiol_YtxJ: bacillithiol system protein YtxJ', 105, NULL, 'TIGR04019', 289576),
(483902, 'TIGR01321', NULL, 'TrpR: trp operon repressor', 94, NULL, 'TIGR01321', 289577),
(483903, 'TIGR02551', NULL, 'SpaO_YscQ: type III secretion apparatus protein, YscQ/HrcQ family', 300, NULL, 'TIGR02551', 289578),
(483904, 'TIGR03902', NULL, 'rhom_GG_sort: rhombosortase', 154, NULL, 'TIGR03902', 289579),
(483905, 'TIGR03718', NULL, 'R_switched_Alx: integral membrane protein, TerC family', 303, NULL, 'TIGR03718', 289580),
(483906, 'TIGR02162', NULL, 'torC: trimethylamine-N-oxide reductase c-type cytochrome TorC', 387, NULL, 'TIGR02162', 289581),
(483907, 'TIGR02660', NULL, 'nifV_homocitr: homocitrate synthase', 365, NULL, 'TIGR02660', 289582),
(483908, 'TIGR00366', NULL, 'TIGR00366: TIGR00366 family protein', 438, NULL, 'TIGR00366', 289583),
(483909, 'TIGR00796', NULL, 'livcs: branched-chain amino acid transport system II carrier protein', 405, NULL, 'TIGR00796', 289584),
(483910, 'TIGR03541', NULL, 'reg_near_HchA: LuxR family transcriptional regulatory, chaperone HchA-associated', 232, NULL, 'TIGR03541', 289585),
(483911, 'TIGR01505', NULL, 'tartro_sem_red: 2-hydroxy-3-oxopropionate reductase', 291, NULL, 'TIGR01505', 289586),
(483912, 'TIGR02837', NULL, 'spore_II_R: stage II sporulation protein R', 168, NULL, 'TIGR02837', 289587),
(483913, 'TIGR04375', NULL, 'cyano_w_EgtBD: hercynine metabolism protein', 155, NULL, 'TIGR04375', 289588),
(483914, 'TIGR03220', NULL, 'catechol_dmpE: 2-oxopent-4-enoate hydratase', 255, NULL, 'TIGR03220', 289589),
(483915, 'TIGR01212', NULL, 'TIGR01212: radical SAM protein, TIGR01212 family', 302, NULL, 'TIGR01212', 289590),
(483916, 'TIGR04203', NULL, 'RPT_S_cricet: Streptococcal surface-anchored protein repeat, S. criceti family', 38, NULL, 'TIGR04203', 289591),
(483917, 'TIGR02367', NULL, 'PylS_Cterm: pyrrolysine--tRNA ligase, C-terminal region', 242, NULL, 'TIGR02367', 289592),
(483918, 'TIGR02190', NULL, 'GlrX-dom: glutaredoxin-family domain', 79, NULL, 'TIGR02190', 289593),
(483919, 'TIGR01172', NULL, 'cysE: serine O-acetyltransferase', 162, NULL, 'TIGR01172', 289594),
(483920, 'TIGR02046', NULL, 'sdhC_b558_fam: succinate dehydrogenase (or fumarate reductase) cytochrome b subunit, b558 family', 212, NULL, 'TIGR02046', 289595);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(483921, 'TIGR00836', NULL, 'amt: ammonium transporter', 406, NULL, 'TIGR00836', 289596),
(483922, 'TIGR00017', NULL, 'cmk: cytidylate kinase', 217, NULL, 'TIGR00017', 289597),
(483923, 'TIGR03494', NULL, 'salicyl_syn: salicylate synthase', 425, NULL, 'TIGR03494', 289598),
(483924, 'TIGR02202', NULL, 'Ehrlichia_rpt: Ehrlichia chaffeensis immunodominant surface protein repeat', 77, NULL, 'TIGR02202', 289599),
(483925, 'TIGR01035', NULL, 'hemA: glutamyl-tRNA reductase', 416, NULL, 'TIGR01035', 289600),
(483926, 'TIGR01991', NULL, 'HscA: Fe-S protein assembly chaperone HscA', 600, NULL, 'TIGR01991', 289601),
(483927, 'TIGR01356', NULL, 'aroA: 3-phosphoshikimate 1-carboxyvinyltransferase', 415, NULL, 'TIGR01356', 289602),
(483928, 'TIGR02523', NULL, 'type_IV_pilV: type IV pilus modification protein PilV', 139, NULL, 'TIGR02523', 289603),
(483929, 'TIGR00201', NULL, 'comF: comF family protein', 190, NULL, 'TIGR00201', 289604),
(483930, 'TIGR03678', NULL, 'het_cyc_patell: bacteriocin leader peptide, microcyclamide/patellamide family', 34, NULL, 'TIGR03678', 289605),
(483931, 'TIGR03855', NULL, 'NAD_NadX: aspartate dehydrogenase', 229, NULL, 'TIGR03855', 289606),
(483932, 'TIGR00515', NULL, 'accD: acetyl-CoA carboxylase, carboxyl transferase, beta subunit', 285, NULL, 'TIGR00515', 289607),
(483933, 'TIGR01349', NULL, 'PDHac_trf_mito: pyruvate dehydrogenase complex dihydrolipoamide acetyltransferase', 437, NULL, 'TIGR01349', 289608),
(483934, 'TIGR02700', NULL, 'flavo_MJ0208: archaeoflavoprotein, MJ0208 family', 234, NULL, 'TIGR02700', 289609),
(483935, 'TIGR00980', NULL, '3a0801so1tim17: mitochondrial import inner membrane translocase subunit tim17', 170, NULL, 'TIGR00980', 289610),
(483936, 'TIGR03357', NULL, 'VI_zyme: type VI secretion system lysozyme-like protein', 133, NULL, 'TIGR03357', 289611),
(483937, 'TIGR01493', NULL, 'HAD-SF-IA-v2: HAD hydrolase, family IA, variant 2', 161, NULL, 'TIGR01493', 289612),
(483938, 'TIGR02844', NULL, 'spore_III_D: sporulation transcriptional regulator SpoIIID', 80, NULL, 'TIGR02844', 289613),
(483939, 'TIGR03180', NULL, 'UraD_2: OHCU decarboxylase', 158, NULL, 'TIGR03180', 289614),
(483940, 'TIGR04397', NULL, 'SecA2_Bac_anthr: accessory Sec system translocase SecA2', 774, NULL, 'TIGR04397', 289615),
(483941, 'TIGR03519', NULL, 'T9SS_PorP_fam: type IX secretion system membrane protein, PorP/SprF family', 292, NULL, 'TIGR03519', 289616),
(483942, 'TIGR04260', NULL, 'Cyano_gly_rpt: rSAM-associated Gly-rich repeat protein', 118, NULL, 'TIGR04260', 289617),
(483943, 'TIGR01789', NULL, 'lycopene_cycl: lycopene cyclase', 370, NULL, 'TIGR01789', 289618),
(483944, 'TIGR01324', NULL, 'cysta_beta_ly_B: cystathionine beta-lyase', 377, NULL, 'TIGR01324', 289619),
(483945, 'TIGR01652', NULL, 'ATPase-Plipid: phospholipid-translocating P-type ATPase, flippase', 1058, NULL, 'TIGR01652', 289620),
(483946, 'TIGR02099', NULL, 'TIGR02099: TIGR02099 family protein', 1260, NULL, 'TIGR02099', 289621),
(483947, 'TIGR03774', NULL, 'RPE2: rickettsial palindromic element RPE2 domain', 35, NULL, 'TIGR03774', 289622),
(483948, 'TIGR00080', NULL, 'pimt: protein-L-isoaspartate O-methyltransferase', 216, NULL, 'TIGR00080', 289623),
(483949, 'TIGR04069', NULL, 'ocin_ACP_rel: peptide maturation system acyl carrier-related protein', 77, NULL, 'TIGR04069', 289624),
(483950, 'TIGR01620', NULL, 'hyp_HI0043: TIGR01620 family protein', 289, NULL, 'TIGR01620', 289625),
(483951, 'TIGR00958', NULL, '3a01208: antigen peptide transporter 2', 711, NULL, 'TIGR00958', 289626),
(483952, 'TIGR03566', NULL, 'FMN_reduc_MsuE: FMN reductase', 174, NULL, 'TIGR03566', 289627),
(483953, 'TIGR00973', NULL, 'leuA_bact: 2-isopropylmalate synthase', 494, NULL, 'TIGR00973', 289628),
(483954, 'TIGR04213', NULL, 'PGF_pre_PGF: PGF-pre-PGF domain', 153, NULL, 'TIGR04213', 289629),
(483955, 'TIGR04365', NULL, 'spare_glycyl: autonomous glycyl radical cofactor GrcA', 126, NULL, 'TIGR04365', 289630),
(483956, 'TIGR02290', NULL, 'M3_fam_3: oligoendopeptidase, pepF/M3 family', 587, NULL, 'TIGR02290', 289631),
(483957, 'TIGR01371', NULL, 'met_syn_B12ind: 5-methyltetrahydropteroyltriglutamate--homocysteine S-methyltransferase', 754, NULL, 'TIGR01371', 289632);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(483958, 'TIGR01605', NULL, 'PYST-D: Plasmodium yoelii subtelomeric family PYST-D', 55, NULL, 'TIGR01605', 289633),
(483959, 'TIGR02943', NULL, 'Sig70_famx1: RNA polymerase sigma-70 factor, TIGR02943 family', 188, NULL, 'TIGR02943', 289634),
(483960, 'TIGR00033', NULL, 'aroC: chorismate synthase', 351, NULL, 'TIGR00033', 289635),
(483961, 'TIGR01309', NULL, 'uL30_arch: ribosomal protein uL30', 151, NULL, 'TIGR01309', 289636),
(483962, 'TIGR02588', NULL, 'TIGR02588: TIGR02588 family protein', 122, NULL, 'TIGR02588', 289637),
(483963, 'TIGR03581', NULL, 'EF_0839: conserved hypothetical protein EF_0839/AHA_3917', 236, NULL, 'TIGR03581', 289638),
(483964, 'TIGR02243', NULL, 'TIGR02243: putative baseplate assembly protein', 659, NULL, 'TIGR02243', 289639),
(483965, 'TIGR02990', NULL, 'ectoine_eutA: ectoine utilization protein EutA', 239, NULL, 'TIGR02990', 289640),
(483966, 'TIGR00677', NULL, 'fadh2_euk: methylenetetrahydrofolate reductase', 281, NULL, 'TIGR00677', 289641),
(483967, 'TIGR03133', NULL, 'malonate_beta: biotin-independent malonate decarboxylase, beta subunit', 274, NULL, 'TIGR03133', 289642),
(483968, 'TIGR03238', NULL, 'dnd_assoc_3: DNA phosphorothioation-dependent restriction protein DptF', 504, NULL, 'TIGR03238', 289643),
(483969, 'TIGR00540', NULL, 'TPR_hemY_coli: heme biosynthesis-associated TPR protein', 385, NULL, 'TIGR00540', 289644),
(483970, 'TIGR01757', NULL, 'Malate-DH_plant: malate dehydrogenase, NADP-dependent', 387, NULL, 'TIGR01757', 289645),
(483971, 'TIGR00481', NULL, 'TIGR00481: Raf kinase inhibitor-like protein, YbhB/YbcL family', 142, NULL, 'TIGR00481', 289646),
(483972, 'TIGR02928', NULL, 'TIGR02928: orc1/cdc6 family replication initiation protein', 366, NULL, 'TIGR02928', 289647),
(483973, 'TIGR00821', NULL, 'EII-GUT: PTS system, glucitol/sorbitol-specific, IIC component', 181, NULL, 'TIGR00821', 289648),
(483974, 'TIGR03074', NULL, 'PQQ_membr_DH: membrane-bound PQQ-dependent dehydrogenase, glucose/quinate/shikimate family', 783, NULL, 'TIGR03074', 289649),
(483975, 'TIGR00229', NULL, 'sensory_box: PAS domain S-box protein', 126, NULL, 'TIGR00229', 289650),
(483976, 'TIGR00244', NULL, 'TIGR00244: transcriptional regulator NrdR', 147, NULL, 'TIGR00244', 289651),
(483977, 'TIGR00419', NULL, 'tim: triose-phosphate isomerase', 228, NULL, 'TIGR00419', 289652),
(483978, 'TIGR03027', NULL, 'pepcterm_export: putative polysaccharide export protein, PEP-CTERM sytem-associated', 166, NULL, 'TIGR03027', 289653),
(483979, 'TIGR04409', NULL, 'LptC_YrbK: LPS export ABC transporter periplasmic protein LptC', 180, NULL, 'TIGR04409', 289654),
(483980, 'TIGR02454', NULL, 'ECF_T_CbiQ: cobalt ECF transporter T component CbiQ', 200, NULL, 'TIGR02454', 289655),
(483981, 'TIGR01816', NULL, 'sdhA_forward: succinate dehydrogenase, flavoprotein subunit', 584, NULL, 'TIGR01816', 289656),
(483982, 'TIGR01711', NULL, 'gspJ: type II secretion system protein J', 192, NULL, 'TIGR01711', 289657),
(483983, 'TIGR02436', NULL, 'TIGR02436: four helix bundle protein', 109, NULL, 'TIGR02436', 289658),
(483984, 'TIGR02940', NULL, 'anfO_nitrog: Fe-only nitrogenase accessory protein AnfO', 214, NULL, 'TIGR02940', 289659),
(483985, 'TIGR03235', NULL, 'DNA_S_dndA: cysteine desulfurase DndA', 353, NULL, 'TIGR03235', 289660),
(483986, 'TIGR00138', NULL, 'rsmG_gidB: 16S rRNA (guanine(527)-N(7))-methyltransferase RsmG', 183, NULL, 'TIGR00138', 289661),
(483987, 'TIGR04424', NULL, 'metallo_McbB: McbB family protein', 286, NULL, 'TIGR04424', 289662),
(483988, 'TIGR03668', NULL, 'Rv0121_F420: PPOX class probable F420-dependent enzyme, Rv0121 family', 141, NULL, 'TIGR03668', 289663),
(483989, 'TIGR01163', NULL, 'rpe: ribulose-phosphate 3-epimerase', 211, NULL, 'TIGR01163', 289664),
(483990, 'TIGR00970', NULL, 'leuA_yeast: 2-isopropylmalate synthase', 564, NULL, 'TIGR00970', 289665),
(483991, 'TIGR04318', NULL, 'lacto_ODC_hypo: putative ornithine decarboxylase', 695, NULL, 'TIGR04318', 289666),
(483992, 'TIGR03531', NULL, 'selenium_SpcS: O-phosphoseryl-tRNA(Sec) selenium transferase', 444, NULL, 'TIGR03531', 289667);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(483993, 'TIGR03563', NULL, 'perox_SACOL1771: peroxiredoxin, SACOL1771 subfamily', 138, NULL, 'TIGR03563', 289668),
(483994, 'TIGR01116', NULL, 'ATPase-IIA1_Ca: calcium-translocating P-type ATPase, SERCA-type', 799, NULL, 'TIGR01116', 289669),
(483995, 'TIGR02108', NULL, 'PQQ_syn_pqqB: coenzyme PQQ biosynthesis protein B', 302, NULL, 'TIGR02108', 289670),
(483996, 'TIGR00185', NULL, 'tRNA_yibK_trmL: tRNA (cytidine(34)-2''-O)-methyltransferase', 154, NULL, 'TIGR00185', 289671),
(483997, 'TIGR03996', NULL, 'mycofact_OYE_1: mycofactocin system FadH/OYE family oxidoreductase 1', 633, NULL, 'TIGR03996', 289672),
(483998, 'TIGR02049', NULL, 'gshA_ferroox: glutamate--cysteine ligase', 403, NULL, 'TIGR02049', 289673),
(483999, 'TIGR00466', NULL, 'kdsB: 3-deoxy-D-manno-octulosonate cytidylyltransferase', 241, NULL, 'TIGR00466', 289674),
(484000, 'TIGR02782', NULL, 'TrbB_P: P-type conjugative transfer ATPase TrbB', 303, NULL, 'TIGR02782', 289675),
(484001, 'TIGR03727', NULL, 'urea_t_UrtC_arc: urea ABC transporter, permease protein UrtC', 369, NULL, 'TIGR03727', 289676),
(484002, 'TIGR00001', NULL, 'rpmI_bact: ribosomal protein bL35', 63, NULL, 'TIGR00001', 289677),
(484003, 'TIGR00525', NULL, 'folB: dihydroneopterin aldolase', 116, NULL, 'TIGR00525', 289678),
(484004, 'TIGR01359', NULL, 'UMP_CMP_kin_fam: UMP-CMP kinase family', 185, NULL, 'TIGR01359', 289679),
(484005, 'TIGR01863', NULL, 'cas_Csd1: CRISPR-associated protein Cas8c/Csd1, subtype I-C/DVULG', 588, NULL, 'TIGR01863', 289680),
(484006, 'TIGR00736', NULL, 'nifR3_rel_arch: putative TIM-barrel protein', 231, NULL, 'TIGR00736', 289681),
(484007, 'TIGR02392', NULL, 'rpoH_proteo: alternative sigma factor RpoH', 270, NULL, 'TIGR02392', 289682),
(484008, 'TIGR01754', NULL, 'flav_RNR: putative ribonucleotide reductase-associated flavodoxin', 140, NULL, 'TIGR01754', 289683),
(484009, 'TIGR04315', NULL, 'octaheme_Shew: octaheme c-type cytochrome, tetrathionate reductase family', 440, NULL, 'TIGR04315', 289684),
(484010, 'TIGR04107', NULL, 'rSAM_HutW: putative heme utilization radical SAM enzyme HutW', 419, NULL, 'TIGR04107', 289685),
(484011, 'TIGR01374', NULL, 'soxD: sarcosine oxidase, delta subunit family', 83, NULL, 'TIGR01374', 289686),
(484012, 'TIGR00528', NULL, 'gcvT: glycine cleavage system T protein', 362, NULL, 'TIGR00528', 289687),
(484013, 'TIGR00783', NULL, 'ccs: citrate carrier protein, CCS family', 420, NULL, 'TIGR00783', 289688),
(484014, 'TIGR01546', NULL, 'GAPDH-II_archae: glyceraldehyde-3-phosphate dehydrogenase, type II', 333, NULL, 'TIGR01546', 289689),
(484015, 'TIGR01707', NULL, 'gspI: type II secretion system protein I', 101, NULL, 'TIGR01707', 289690),
(484016, 'TIGR04362', NULL, 'choice_anch_C: choice-of-anchor C domain', 157, NULL, 'TIGR04362', 289691),
(484017, 'TIGR04154', NULL, 'archaeo_STT3: oligosaccharyl transferase, archaeosortase A system-associated', 831, NULL, 'TIGR04154', 289692),
(484018, 'TIGR00079', NULL, 'pept_deformyl: peptide deformylase', 161, NULL, 'TIGR00079', 289693),
(484019, 'TIGR03672', NULL, 'rpl4p_arch: 50S ribosomal protein uL4', 251, NULL, 'TIGR03672', 289694),
(484020, 'TIGR02673', NULL, 'FtsE: cell division ATP-binding protein FtsE', 214, NULL, 'TIGR02673', 289695),
(484021, 'TIGR01327', NULL, 'PGDH: phosphoglycerate dehydrogenase', 525, NULL, 'TIGR01327', 289696),
(484022, 'TIGR00955', NULL, '3a01204: pigment precursor permease', 617, NULL, 'TIGR00955', 289697),
(484023, 'TIGR02158', NULL, 'PA_CoA_Oxy3: phenylacetate-CoA oxygenase, PaaI subunit', 237, NULL, 'TIGR02158', 289698),
(484024, 'TIGR02538', NULL, 'type_IV_pilB: type IV-A pilus assembly ATPase PilB', 564, NULL, 'TIGR02538', 289699),
(484025, 'TIGR02021', NULL, 'BchM-ChlM: magnesium protoporphyrin O-methyltransferase', 218, NULL, 'TIGR02021', 289700),
(484026, 'TIGR02401', NULL, 'trehalose_TreY: malto-oligosyltrehalose synthase', 838, NULL, 'TIGR02401', 289701),
(484027, 'TIGR01593', NULL, 'holin_tox_secr: toxin secretion/phage lysis holin', 128, NULL, 'TIGR01593', 289702),
(484028, 'TIGR01655', NULL, 'yxeA_fam: conserved hypothetical protein', 114, NULL, 'TIGR01655', 289703);
INSERT INTO "PUBLIC"."MODEL" VALUES
(484029, 'TIGR04216', NULL, 'halo_surf_glyco: major cell surface glycoprotein', 784, NULL, 'TIGR04216', 289704),
(484030, 'TIGR03176', NULL, 'AllC: allantoate amidohydrolase', 406, NULL, 'TIGR03176', 289705),
(484031, 'TIGR00431', NULL, 'TruB: tRNA pseudouridine(55) synthase', 210, NULL, 'TIGR00431', 289706),
(484032, 'TIGR04471', NULL, 'rSAM_mob_pairA: radical SAM mobile pair protein A', 220, NULL, 'TIGR04471', 289707),
(484033, 'TIGR02486', NULL, 'RDH: reductive dehalogenase', 314, NULL, 'TIGR02486', 289708),
(484034, 'TIGR02345', NULL, 'chap_CCT_eta: T-complex protein 1, eta subunit', 523, NULL, 'TIGR02345', 289709),
(484035, 'TIGR02217', NULL, 'chp_TIGR02217: TIGR02217 family protein', 210, NULL, 'TIGR02217', 289710),
(484036, 'TIGR03136', NULL, 'malonate_biotin: Na+-transporting malonate decarboxylase, carboxybiotin decarboxylase subunit', 399, NULL, 'TIGR03136', 289711),
(484037, 'TIGR03516', NULL, 'ppisom_GldI: peptidyl-prolyl isomerase, gliding motility-associated', 177, NULL, 'TIGR03516', 289712),
(484038, 'TIGR02869', NULL, 'spore_SleB: spore cortex-lytic enzyme', 201, NULL, 'TIGR02869', 289713),
(484039, 'TIGR01714', NULL, 'phage_rep_org_N: phage replisome organizer, putative, N-terminal region', 119, NULL, 'TIGR01714', 289714),
(484040, 'TIGR03457', NULL, 'sulphoacet_xsc: sulfoacetaldehyde acetyltransferase', 579, NULL, 'TIGR03457', 289715),
(484041, 'TIGR00674', NULL, 'dapA: 4-hydroxy-tetrahydrodipicolinate synthase', 286, NULL, 'TIGR00674', 289716),
(484042, 'TIGR02439', NULL, 'catechol_proteo: catechol 1,2-dioxygenase', 285, NULL, 'TIGR02439', 289717),
(484043, 'TIGR02819', NULL, 'fdhA_non_GSH: formaldehyde dehydrogenase, glutathione-independent', 397, NULL, 'TIGR02819', 289718),
(484044, 'TIGR00294', NULL, 'TIGR00294: GTP cyclohydrolase', 308, NULL, 'TIGR00294', 289719),
(484045, 'TIGR02302', NULL, 'aProt_lowcomp: TIGR02302 family protein', 851, NULL, 'TIGR02302', 289720),
(484046, 'TIGR04459', NULL, 'TisB_tox: type I toxin-antitoxin system toxin TisB', 29, NULL, 'TIGR04459', 289721),
(484047, 'TIGR03077', NULL, 'not_gcvH: glycine cleavage protein H-like protein', 110, NULL, 'TIGR03077', 289722),
(484048, 'TIGR00712', NULL, 'glpT: glycerol-3-phosphate transporter', 440, NULL, 'TIGR00712', 289723),
(484049, 'TIGR02404', NULL, 'trehalos_R_Bsub: trehalose operon repressor', 233, NULL, 'TIGR02404', 289724),
(484050, 'TIGR01898', NULL, 'cas_TM1791_cmr6: CRISPR type III-B/RAMP module RAMP protein Cmr6', 195, NULL, 'TIGR01898', 289725),
(484051, 'TIGR00849', NULL, 'gutA: PTS system, glucitol/sorbitol-specific IIA component', 121, NULL, 'TIGR00849', 289726),
(484052, 'TIGR01761', NULL, 'thiaz-red: thiazolinyl imide reductase', 350, NULL, 'TIGR01761', 289727),
(484053, 'TIGR04322', NULL, 'rSAM_QueE_Ecoli: putative 7-cyano-7-deazaguanosine (preQ0) biosynthesis protein QueE', 215, NULL, 'TIGR04322', 289728),
(484054, 'TIGR01265', NULL, 'tyr_nico_aTase: tyrosine/nicotianamine family aminotransferase', 403, NULL, 'TIGR01265', 289729),
(484055, 'TIGR01848', NULL, 'PHA_reg_PhaR: polyhydroxyalkanoate synthesis repressor PhaR', 107, NULL, 'TIGR01848', 289730),
(484056, 'TIGR01695', NULL, 'murJ_mviN: murein biosynthesis integral membrane protein MurJ', 506, NULL, 'TIGR01695', 289731),
(484057, 'TIGR03042', NULL, 'PS_II_psbQ_bact: photosystem II protein PsbQ', 142, NULL, 'TIGR03042', 289732),
(484058, 'TIGR00110', NULL, 'ilvD: dihydroxy-acid dehydratase', 543, NULL, 'TIGR00110', 289733),
(484059, 'TIGR00920', NULL, '2A060605: 3-hydroxy-3-methylglutaryl-coenzyme A reductase', 887, NULL, 'TIGR00920', 289734),
(484060, 'TIGR03129', NULL, 'one_C_dehyd_B: formylmethanofuran dehydrogenase subunit B', 421, NULL, 'TIGR03129', 289735),
(484061, 'TIGR00051', NULL, 'TIGR00051: acyl-CoA thioester hydrolase, YbgC/YbaW family', 117, NULL, 'TIGR00051', 289736),
(484062, 'TIGR02352', NULL, 'thiamin_ThiO: glycine oxidase ThiO', 351, NULL, 'TIGR02352', 289737),
(484063, 'TIGR02732', NULL, 'zeta_caro_desat: 9,9''-di-cis-zeta-carotene desaturase', 474, NULL, 'TIGR02732', 289738),
(484064, 'TIGR03993', NULL, 'hydrog_HybE: [NiFe] hydrogenase assembly chaperone, HybE family', 143, NULL, 'TIGR03993', 289739);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(484065, 'TIGR00896', NULL, 'CynX: cyanate transporter', 355, NULL, 'TIGR00896', 289740),
(484066, 'TIGR02647', NULL, 'DNA: TIGR02647 family protein', 77, NULL, 'TIGR02647', 289741),
(484067, 'TIGR01813', NULL, 'flavo_cyto_c: flavocytochrome c', 444, NULL, 'TIGR01813', 289742),
(484068, 'TIGR00575', NULL, 'dnlj: DNA ligase, NAD-dependent', 652, NULL, 'TIGR00575', 289743),
(484069, 'TIGR04178', NULL, 'exo_archaeo: exosortase/archaeosortase family protein', 97, NULL, 'TIGR04178', 289744),
(484070, 'TIGR01218', NULL, 'Gpos_tandem_5TM: tandem five-TM protein', 208, NULL, 'TIGR01218', 289745),
(484071, 'TIGR00568', NULL, 'alkb: alkylated DNA repair protein AlkB', 173, NULL, 'TIGR00568', 289746),
(484072, 'TIGR02975', NULL, 'phageshock_pspG: phage shock protein G', 64, NULL, 'TIGR02975', 289747),
(484073, 'TIGR01225', NULL, 'hutH: histidine ammonia-lyase', 506, NULL, 'TIGR01225', 289748),
(484074, 'TIGR02071', NULL, 'PBP_1b: penicillin-binding protein 1B', 729, NULL, 'TIGR02071', 289749),
(484075, 'TIGR03625', NULL, 'L3_bact: 50S ribosomal protein uL3', 202, NULL, 'TIGR03625', 289750),
(484076, 'TIGR04256', NULL, 'GxxExxY: GxxExxY protein', 116, NULL, 'TIGR04256', 289751),
(484077, 'TIGR03946', NULL, 'viomycin_VioC: arginine beta-hydroxylase, Fe(II)/alpha-ketoglutarate-dependent', 333, NULL, 'TIGR03946', 289752),
(484078, 'TIGR03101', NULL, 'hydr2_PEP: exosortase A system-associated hydrolase 2', 266, NULL, 'TIGR03101', 289753),
(484079, 'TIGR00247', NULL, 'TIGR00247: conserved hypothetical protein, YceG family', 347, NULL, 'TIGR00247', 289754),
(484080, 'TIGR00627', NULL, 'tfb4: transcription factor tfb4', 284, NULL, 'TIGR00627', 289755),
(484081, 'TIGR00908', NULL, '2A0305: ethanolamine permease', 442, NULL, 'TIGR00908', 289756),
(484082, 'TIGR02510', NULL, 'NrdE-prime: ribonucleoside-diphosphate reductase, alpha chain', 560, NULL, 'TIGR02510', 289757),
(484083, 'TIGR04499', NULL, 'abortive_AbiA: abortive infection protein, AbiA family', 615, NULL, 'TIGR04499', 289758),
(484084, 'TIGR03665', NULL, 'arCOG04150: arCOG04150 universal archaeal KH domain protein', 173, NULL, 'TIGR03665', 289759),
(484085, 'TIGR04263', NULL, 'SasC_Mrp_aggreg: SasC/Mrp/FmtB intercellular aggregation domain', 366, NULL, 'TIGR04263', 289760),
(484086, 'TIGR01480', NULL, 'copper_res_A: copper-resistance protein, CopA family', 593, NULL, 'TIGR01480', 289761),
(484087, 'TIGR02451', NULL, 'anti_sig_ChrR: anti-sigma factor, putative, ChrR family', 216, NULL, 'TIGR02451', 289762),
(484088, 'TIGR03344', NULL, 'VI_effect_Hcp1: type VI secretion system effector, Hcp1 family', 167, NULL, 'TIGR03344', 289763),
(484089, 'TIGR03285', NULL, 'methan_mark_14: putative methanogenesis marker protein 14', 446, NULL, 'TIGR03285', 289764),
(484090, 'TIGR03370', NULL, 'VPLPA-CTERM: VPLPA-CTERM protein sorting domain', 25, NULL, 'TIGR03370', 289765),
(484091, 'TIGR00188', NULL, 'rnpA: ribonuclease P protein component', 111, NULL, 'TIGR00188', 289766),
(484092, 'TIGR03379', NULL, 'glycerol3P_GlpC: glycerol-3-phosphate dehydrogenase, anaerobic, C subunit', 397, NULL, 'TIGR03379', 289767),
(484093, 'TIGR02327', NULL, 'int_mem_ywzB: conserved hypothetical integral membrane protein', 68, NULL, 'TIGR02327', 289768),
(484094, 'TIGR04400', NULL, 'RK_trnsloc_Pase: Arg-Lys translocation region protein phosphatase', 358, NULL, 'TIGR04400', 289769),
(484095, 'TIGR03242', NULL, 'arg_catab_astE: succinylglutamate desuccinylase', 319, NULL, 'TIGR03242', 289770),
(484096, 'TIGR04537', NULL, 'encap_target: encapsulation C-terminal sorting signal', 11, NULL, 'TIGR04537', 289771),
(484097, 'TIGR02891', NULL, 'CtaD_CoxA: cytochrome c oxidase, subunit I', 504, NULL, 'TIGR02891', 289772),
(484098, 'TIGR00681', NULL, 'kdpC: K+-transporting ATPase, C subunit', 187, NULL, 'TIGR00681', 289773),
(484099, 'TIGR00220', NULL, 'mscL: large conductance mechanosensitive channel protein', 127, NULL, 'TIGR00220', 289774),
(484100, 'TIGR00357', NULL, 'TIGR00357: methionine-R-sulfoxide reductase', 134, NULL, 'TIGR00357', 289775),
(484101, 'TIGR03914', NULL, 'UDG_fam_dom: uracil-DNA glycosylase family domain', 231, NULL, 'TIGR03914', 289776);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(484102, 'TIGR02775', NULL, 'TrbG_Ti: P-type conjugative transfer protein TrbG', 206, NULL, 'TIGR02775', 289777),
(484103, 'TIGR00739', NULL, 'yajC: preprotein translocase, YajC subunit', 84, NULL, 'TIGR00739', 289778),
(484104, 'TIGR00565', NULL, 'trpE_proteo: anthranilate synthase component I', 498, NULL, 'TIGR00565', 289779),
(484105, 'TIGR02709', NULL, 'branched_ptb: branched-chain phosphotransacylase', 271, NULL, 'TIGR02709', 289780),
(484106, 'TIGR01188', NULL, 'drrA: daunorubicin resistance ABC transporter, ATP-binding protein', 302, NULL, 'TIGR01188', 289781),
(484107, 'TIGR03394', NULL, 'indol_phenyl_DC: indolepyruvate/phenylpyruvate decarboxylase', 535, NULL, 'TIGR03394', 289782),
(484108, 'TIGR03186', NULL, 'AKGDH_not_PDH: alpha-ketoglutarate dehydrogenase', 889, NULL, 'TIGR03186', 289783),
(484109, 'TIGR03690', NULL, '20S_bact_beta: proteasome, beta subunit', 222, NULL, 'TIGR03690', 289784),
(484110, 'TIGR04041', NULL, 'activase_YjjW: glycine radical enzyme activase, YjjW family', 276, NULL, 'TIGR04041', 289785),
(484111, 'TIGR04533', NULL, 'cyanosortB_assc: cyanoexosortase B-associated protein', 221, NULL, 'TIGR04533', 289786),
(484112, 'TIGR01648', NULL, 'hnRNP-R-Q: hnRNP-R, Q splicing factor family', 577, NULL, 'TIGR01648', 289787),
(484113, 'TIGR01511', NULL, 'ATPase-IB1_Cu: copper-translocating P-type ATPase', 542, NULL, 'TIGR01511', 289788),
(484114, 'TIGR03618', NULL, 'Rv1155_F420: PPOX class probable F420-dependent enzyme', 127, NULL, 'TIGR03618', 289789),
(484115, 'TIGR01433', NULL, 'CyoA: ubiquinol oxidase, subunit II', 226, NULL, 'TIGR01433', 289790),
(484116, 'TIGR03126', NULL, 'one_C_fae: formaldehyde-activating enzyme', 160, NULL, 'TIGR03126', 289791),
(484117, 'TIGR00893', NULL, '2A0114: D-galactonate transporter', 399, NULL, 'TIGR00893', 289792),
(484118, 'TIGR04288', NULL, 'CGP_CTERM: CGP-CTERM domain', 20, NULL, 'TIGR04288', 289793),
(484119, 'TIGR03454', NULL, 'partition_RepB: plasmid partitioning protein RepB', 325, NULL, 'TIGR03454', 289794),
(484120, 'TIGR03702', NULL, 'lip_kinase_YegS: lipid kinase YegS', 295, NULL, 'TIGR03702', 289795),
(484121, 'TIGR01976', NULL, 'am_tr_V_VC1184: cysteine desulfurase family protein', 401, NULL, 'TIGR01976', 289796),
(484122, 'TIGR00602', NULL, 'rad24: checkpoint protein rad24', 640, NULL, 'TIGR00602', 289797),
(484123, 'TIGR00029', NULL, 'S20: ribosomal protein bS20', 87, NULL, 'TIGR00029', 289798),
(484124, 'TIGR00160', NULL, 'MGSA: methylglyoxal synthase', 143, NULL, 'TIGR00160', 289799),
(484125, 'TIGR02623', NULL, 'G1P_cyt_trans: glucose-1-phosphate cytidylyltransferase', 255, NULL, 'TIGR02623', 289800),
(484126, 'TIGR01272', NULL, 'gluP: glucose/galactose transporter WARNING', 310, NULL, 'TIGR01272', 289801),
(484127, 'TIGR01704', NULL, 'MTA/SAH-Nsdase: MTA/SAH nucleosidase', 229, NULL, 'TIGR01704', 289802),
(484128, 'TIGR00353', NULL, 'nrfE: cytochrome c-type biogenesis protein CcmF', 578, NULL, 'TIGR00353', 289803),
(484129, 'TIGR02024', NULL, 'FtcD: glutamate formiminotransferase', 298, NULL, 'TIGR02024', 289804),
(484130, 'TIGR04045', NULL, 'MSMEG_0567_GNAT: putative N-acetyltransferase, MSMEG_0567 N-terminal domain family', 153, NULL, 'TIGR04045', 289805),
(484131, 'TIGR04209', NULL, 'sarcinarray: sarcinarray family protein', 144, NULL, 'TIGR04209', 289806),
(484132, 'TIGR02181', NULL, 'GRX_bact: glutaredoxin 3', 80, NULL, 'TIGR02181', 289807),
(484133, 'TIGR01692', NULL, 'HIBADH: 3-hydroxyisobutyrate dehydrogenase', 288, NULL, 'TIGR01692', 289808),
(484134, 'TIGR01262', NULL, 'maiA: maleylacetoacetate isomerase', 211, NULL, 'TIGR01262', 289809),
(484135, 'TIGR02489', NULL, 'flgE_epsilon: flagellar hook protein FlgE', 719, NULL, 'TIGR02489', 289810),
(484136, 'TIGR01399', NULL, 'hrcV: type III secretion protein, HrcV family', 677, NULL, 'TIGR01399', 289811),
(484137, 'TIGR01436', NULL, 'glu_cys_lig_pln: glutamate--cysteine ligase', 446, NULL, 'TIGR01436', 289812),
(484138, 'TIGR03472', NULL, 'HpnI: hopanoid biosynthesis associated glycosyl transferase protein HpnI', 373, NULL, 'TIGR03472', 289813),
(484139, 'TIGR02009', NULL, 'PGMB-YQAB-SF: beta-phosphoglucomutase family hydrolase', 186, NULL, 'TIGR02009', 289814);
INSERT INTO "PUBLIC"."MODEL" VALUES
(484140, 'TIGR03734', NULL, 'PRTRC_parB: PRTRC system ParB family protein', 555, NULL, 'TIGR03734', 289815),
(484141, 'TIGR03839', NULL, 'termin_org_P1: adhesin P1', 1425, NULL, 'TIGR03839', 289816),
(484142, 'TIGR02283', NULL, 'MltB_2: lytic murein transglycosylase', 300, NULL, 'TIGR02283', 289817),
(484143, 'TIGR02866', NULL, 'CoxB: cytochrome c oxidase, subunit II', 202, NULL, 'TIGR02866', 289818),
(484144, 'TIGR01484', NULL, 'HAD-SF-IIB: HAD hydrolase, family IIB', 221, NULL, 'TIGR01484', 289819),
(484145, 'TIGR00297', NULL, 'TIGR00297: TIGR00297 family protein', 237, NULL, 'TIGR00297', 289820),
(484146, 'TIGR00845', NULL, 'caca: sodium/calcium exchanger 1', 921, NULL, 'TIGR00845', 289821),
(484147, 'TIGR02115', NULL, 'potass_kdpF: K+-transporting ATPase, F subunit', 24, NULL, 'TIGR02115', 289822),
(484148, 'TIGR02881', NULL, 'spore_V_K: stage V sporulation protein K', 261, NULL, 'TIGR02881', 289823),
(484149, 'TIGR03628', NULL, 'arch_S11P: ribosomal protein uS11', 117, NULL, 'TIGR03628', 289824),
(484150, 'TIGR00814', NULL, 'stp: serine transporter', 397, NULL, 'TIGR00814', 289825),
(484151, 'TIGR02560', NULL, 'HrpB4: type III secretion protein HrpB4', 220, NULL, 'TIGR02560', 289826),
(484152, 'TIGR00930', NULL, '2a30: K-Cl cotransporter', 936, NULL, 'TIGR00930', 289827),
(484153, 'TIGR01764', NULL, 'excise: DNA binding domain, excisionase family', 49, NULL, 'TIGR01764', 289828),
(484154, 'TIGR03288', NULL, 'CoB_CoM_SS_B: CoB--CoM heterodisulfide reductase, subunit B', 290, NULL, 'TIGR03288', 289829),
(484155, 'TIGR00637', NULL, 'ModE_repress: ModE molybdate transport repressor domain', 100, NULL, 'TIGR00637', 289830),
(484156, 'TIGR01156', NULL, 'cytb6/f_IV: cytb6/f complex subunit IV', 160, NULL, 'TIGR01156', 289831),
(484157, 'TIGR00145', NULL, 'TIGR00145: FTR1 family protein', 282, NULL, 'TIGR00145', 289832),
(484158, 'TIGR00905', NULL, '2A0302: transporter, basic amino acid/polyamine antiporter (APA) family', 473, NULL, 'TIGR00905', 289833),
(484159, 'TIGR01078', NULL, 'arcA: arginine deiminase', 408, NULL, 'TIGR01078', 289834),
(484160, 'TIGR01941', NULL, 'nqrF: NADH:ubiquinone oxidoreductase, Na(+)-translocating, F subunit', 405, NULL, 'TIGR01941', 289835),
(484161, 'TIGR04076', NULL, 'TIGR04076: TIGR04076 family protein', 91, NULL, 'TIGR04076', 289836),
(484162, 'TIGR02900', NULL, 'spore_V_B: stage V sporulation protein B', 488, NULL, 'TIGR02900', 289837),
(484163, 'TIGR00590', NULL, 'pcna: proliferating cell nuclear antigen (pcna)', 259, NULL, 'TIGR00590', 289838),
(484164, 'TIGR03151', NULL, 'enACPred_II: putative enoyl-[acyl-carrier-protein] reductase II', 307, NULL, 'TIGR03151', 289839),
(484165, 'TIGR00309', NULL, 'V_ATPase_subD: V-type ATPase, D subunit', 209, NULL, 'TIGR00309', 289840),
(484166, 'TIGR04502', NULL, 'microcomp_EutL: microcompartment protein EutL', 214, NULL, 'TIGR04502', 289841),
(484167, 'TIGR03406', NULL, 'FeS_long_SufT: probable FeS assembly SUF system protein SufT', 174, NULL, 'TIGR03406', 289842),
(484168, 'TIGR01418', NULL, 'PEP_synth: phosphoenolpyruvate synthase', 784, NULL, 'TIGR01418', 289843),
(484169, 'TIGR04253', NULL, 'mesacon_CoA_iso: mesaconyl-CoA isomerase', 403, NULL, 'TIGR04253', 289844),
(484170, 'TIGR01051', NULL, 'topA_bact: DNA topoisomerase I', 632, NULL, 'TIGR01051', 289845),
(484171, 'TIGR00322', NULL, 'diphth2_R: diphthamide biosynthesis enzyme Dph1/Dph2 domain', 320, NULL, 'TIGR00322', 289846),
(484172, 'TIGR02697', NULL, 'WPE_wolbac: Wolbachia palindromic element domain', 36, NULL, 'TIGR02697', 289847),
(484173, 'TIGR03812', NULL, 'tyr_de_CO2_Arch: tyrosine decarboxylase MnfA', 375, NULL, 'TIGR03812', 289848),
(484174, 'TIGR04325', NULL, 'MTase_LIC12133: putative methyltransferase, LIC12133 family', 234, NULL, 'TIGR04325', 289849),
(484175, 'TIGR03949', NULL, 'bact_IIb_cerein: class IIb bacteriocin, lactobin A/cerein 7B family', 45, NULL, 'TIGR03949', 289850),
(484176, 'TIGR02757', NULL, 'TIGR02757: TIGR02757 family protein', 229, NULL, 'TIGR02757', 289851),
(484177, 'TIGR01602', NULL, 'PY-rept-46: Plasmodium yoelii repeat of length 46', 46, NULL, 'TIGR01602', 289852);
INSERT INTO "PUBLIC"."MODEL" VALUES
(484178, 'TIGR01739', NULL, 'tegu_FGAM_synt: herpesvirus tegument protein/v-FGAM-synthase', 1206, NULL, 'TIGR01739', 289853),
(484179, 'TIGR00251', NULL, 'TIGR00251: TIGR00251 family protein', 87, NULL, 'TIGR00251', 289854),
(484180, 'TIGR02620', NULL, 'cas_VVA1548: putative CRISPR-associated protein, VVA1548 family', 93, NULL, 'TIGR02620', 289855),
(484181, 'TIGR00135', NULL, 'gatC: aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase, C subunit', 93, NULL, 'TIGR00135', 289856),
(484182, 'TIGR00354', NULL, 'polC: DNA polymerase II, large subunit DP2', 1096, NULL, 'TIGR00354', 289857),
(484183, 'TIGR03348', NULL, 'VI_IcmF: type VI secretion protein IcmF', 1168, NULL, 'TIGR03348', 289858),
(484184, 'TIGR01153', NULL, 'psbC: photosystem II 44 kDa subunit reaction center protein', 432, NULL, 'TIGR01153', 289859),
(484185, 'TIGR02429', NULL, 'pcaI_scoA_fam: 3-oxoacid CoA-transferase, A subunit', 222, NULL, 'TIGR02429', 289860),
(484186, 'TIGR03397', NULL, 'acid_phos_Burk: acid phosphatase, Burkholderia-type', 483, NULL, 'TIGR03397', 289861),
(484187, 'TIGR01975', NULL, 'isoAsp_dipep: beta-aspartyl peptidase', 389, NULL, 'TIGR01975', 289862),
(484188, 'TIGR02598', NULL, 'TIGR02598: Verru_Chthon cassette protein B', 151, NULL, 'TIGR02598', 289863),
(484189, 'TIGR00026', NULL, 'hi_GC_TIGR00026: deazaflavin-dependent oxidoreductase, nitroreductase family', 111, NULL, 'TIGR00026', 289864),
(484190, 'TIGR01481', NULL, 'ccpA: catabolite control protein A', 330, NULL, 'TIGR01481', 289865),
(484191, 'TIGR02096', NULL, 'TIGR02096: conserved hypothetical protein', 129, NULL, 'TIGR02096', 289866),
(484192, 'TIGR04179', NULL, 'rhombo_lipo: rhombotail lipoprotein', 259, NULL, 'TIGR04179', 289867),
(484193, 'TIGR03945', NULL, 'PLP_SbnA_fam: 2,3-diaminopropionate biosynthesis protein SbnA', 304, NULL, 'TIGR03945', 289868),
(484194, 'TIGR03024', NULL, 'arch_PEF_CTERM: PEF-CTERM protein sorting domain', 25, NULL, 'TIGR03024', 289869),
(484195, 'TIGR04042', NULL, 'MSMEG_0570_fam: MSMEG_0570 family protein', 90, NULL, 'TIGR04042', 289870),
(484196, 'TIGR00036', NULL, 'dapB: 4-hydroxy-tetrahydrodipicolinate reductase', 270, NULL, 'TIGR00036', 289871),
(484197, 'TIGR03260', NULL, 'met_CoM_red_D: methyl-coenzyme M reductase operon protein D', 150, NULL, 'TIGR03260', 289872),
(484198, 'TIGR03211', NULL, 'catechol_2_3: catechol 2,3 dioxygenase', 303, NULL, 'TIGR03211', 289873),
(484199, 'TIGR02993', NULL, 'ectoine_eutD: ectoine utilization protein EutD', 391, NULL, 'TIGR02993', 289874),
(484200, 'TIGR04536', NULL, 'geobac_encap: encapsulated protein', 194, NULL, 'TIGR04536', 289875),
(484201, 'TIGR00711', NULL, 'efflux_EmrB: drug resistance MFS transporter, drug:H+ antiporter-2 (14 Spanner) (DHA2) family', 485, NULL, 'TIGR00711', 289876),
(484202, 'TIGR02884', NULL, 'spore_pdaA: delta-lactam-biosynthetic de-N-acetylase', 224, NULL, 'TIGR02884', 289877),
(484203, 'TIGR00848', NULL, 'fruA: PTS system, fructose subfamily, IIA component', 129, NULL, 'TIGR00848', 289878),
(484204, 'TIGR01297', NULL, 'CDF: cation diffusion facilitator family transporter', 285, NULL, 'TIGR01297', 289879),
(484205, 'TIGR01160', NULL, 'SUI1_MOF2: translation initiation factor SUI1', 110, NULL, 'TIGR01160', 289880),
(484206, 'TIGR03409', NULL, 'urea_trans_UrtB: urea ABC transporter, permease protein UrtB', 291, NULL, 'TIGR03409', 289881),
(484207, 'TIGR04094', NULL, 'adjacent_YSIRK: YSIRK-targeted surface antigen transcriptional regulator', 383, NULL, 'TIGR04094', 289882),
(484208, 'TIGR01590', NULL, 'yir-bir-cir_Pla: yir/bir/cir-family of variant antigens', 201, NULL, 'TIGR01590', 289883),
(484209, 'TIGR01866', NULL, 'cas_Csn2: CRISPR type II-A/NMEMI-associated protein Csn2', 222, NULL, 'TIGR01866', 289884),
(484210, 'TIGR04427', NULL, 'PLP_DesI: dTDP-4-dehydro-6-deoxyglucose aminotransferase', 390, NULL, 'TIGR04427', 289885),
(484211, 'TIGR03921', NULL, 'T7SS_mycosin: type VII secretion-associated serine protease mycosin', 353, NULL, 'TIGR03921', 289886),
(484212, 'TIGR02072', NULL, 'BioC: malonyl-acyl carrier protein O-methyltransferase BioC', 244, NULL, 'TIGR02072', 289887);            
INSERT INTO "PUBLIC"."MODEL" VALUES
(484213, 'TIGR01972', NULL, 'NDH_I_M: proton-translocating NADH-quinone oxidoreductase, chain M', 486, NULL, 'TIGR01972', 289888),
(484214, 'TIGR03836', NULL, 'termin_org_HMW1: cytadherence high molecular weight protein 1 N-terminal region', 82, NULL, 'TIGR03836', 289889),
(484215, 'TIGR00279', NULL, 'uL16_euk_arch: ribosomal protein uL16', 172, NULL, 'TIGR00279', 289890),
(484216, 'TIGR03600', NULL, 'phage_DnaB: phage replicative helicase, DnaB family', 421, NULL, 'TIGR03600', 289891),
(484217, 'TIGR02280', NULL, 'PaaB1: phenylacetate degradation probable enoyl-CoA hydratase PaaB', 256, NULL, 'TIGR02280', 289892),
(484218, 'TIGR00463', NULL, 'gltX_arch: glutamate--tRNA ligase', 560, NULL, 'TIGR00463', 289893),
(484219, 'TIGR02563', NULL, 'cas_Csy4: CRISPR-associated endoribonuclease Cas6/Csy4, subtype I-F/YPEST', 184, NULL, 'TIGR02563', 289894),
(484220, 'TIGR04151', NULL, 'exosort_VPDSG: exosortase C, VPDSG-CTERM-specific', 306, NULL, 'TIGR04151', 289895),
(484221, 'TIGR00456', NULL, 'argS: arginine--tRNA ligase', 569, NULL, 'TIGR00456', 289896),
(484222, 'TIGR03017', NULL, 'EpsF: chain length determinant protein EpsF', 444, NULL, 'TIGR03017', 289897),
(484223, 'TIGR02903', NULL, 'spore_lon_C: ATP-dependent protease, Lon family', 615, NULL, 'TIGR02903', 289898),
(484224, 'TIGR01054', NULL, 'rgy: reverse gyrase', 1172, NULL, 'TIGR01054', 289899),
(484225, 'TIGR00784', NULL, 'citMHS: citrate transporter', 431, NULL, 'TIGR00784', 289900),
(484226, 'TIGR00142', NULL, 'hycI: hydrogenase maturation peptidase HycI', 146, NULL, 'TIGR00142', 289901),
(484227, 'TIGR02006', NULL, 'IscS: cysteine desulfurase IscS', 402, NULL, 'TIGR02006', 289902),
(484228, 'TIGR03737', NULL, 'PRTRC_B: PRTRC system protein B', 228, NULL, 'TIGR03737', 289903),
(484229, 'TIGR02818', NULL, 'adh_III_F_hyde: S-(hydroxymethyl)glutathione dehydrogenase/class III alcohol dehydrogenase', 368, NULL, 'TIGR02818', 289904),
(484230, 'TIGR00752', NULL, 'slp: outer membrane lipoprotein, Slp family', 182, NULL, 'TIGR00752', 289905),
(484231, 'TIGR00737', NULL, 'nifR3_yhdG: putative TIM-barrel protein, nifR3 family', 319, NULL, 'TIGR00737', 289906),
(484232, 'TIGR01375', NULL, 'soxG: sarcosine oxidase, gamma subunit family', 152, NULL, 'TIGR01375', 289907),
(484233, 'TIGR03811', NULL, 'tyr_de_CO2_Ent: tyrosine decarboxylase', 608, NULL, 'TIGR03811', 289908),
(484234, 'TIGR00889', NULL, '2A0110: nucleoside transporter', 418, NULL, 'TIGR00889', 289909),
(484235, 'TIGR03345', NULL, 'VI_ClpV1: type VI secretion ATPase, ClpV1 family', 852, NULL, 'TIGR03345', 289910),
(484236, 'TIGR03948', NULL, 'butyr_acet_CoA: butyryl-CoA:acetate CoA-transferase', 445, NULL, 'TIGR03948', 289911),
(484237, 'TIGR03313', NULL, 'Se_sel_red_Mo: probable selenate reductase, molybdenum-binding subunit', 951, NULL, 'TIGR03313', 289912),
(484238, 'TIGR02329', NULL, 'propionate_PrpR: propionate catabolism operon regulatory protein PrpR', 526, NULL, 'TIGR02329', 289913),
(484239, 'TIGR04481', NULL, 'PR_assoc_PrdC: proline reductase-associated electron transfer protein PrdC', 425, NULL, 'TIGR04481', 289914),
(484240, 'TIGR02514', NULL, 'type_III_yscP: type III secretion system needle length determinant', 129, NULL, 'TIGR02514', 289915),
(484241, 'TIGR03497', NULL, 'FliI_clade2: flagellar protein export ATPase FliI', 413, NULL, 'TIGR03497', 289916),
(484242, 'TIGR03995', NULL, 'target_X_rSAM: putative rSAM target protein, CGCGG family', 84, NULL, 'TIGR03995', 289917),
(484243, 'TIGR00254', NULL, 'GGDEF: diguanylate cyclase (GGDEF) domain', 168, NULL, 'TIGR00254', 289918),
(484244, 'TIGR03641', NULL, 'cas1_HMARI: CRISPR-associated endonuclease Cas1, subtype I-B/HMARI/TNEAP', 324, NULL, 'TIGR03641', 289919),
(484245, 'TIGR01047', NULL, 'nspC: carboxynorspermidine decarboxylase', 380, NULL, 'TIGR01047', 289920),
(484246, 'TIGR03515', NULL, 'GldC: gliding motility-associated protein GldC', 108, NULL, 'TIGR03515', 289921),
(484247, 'TIGR02174', NULL, 'CXXU_selWTH: selT/selW/selH selenoprotein domain', 74, NULL, 'TIGR02174', 289922),
(484248, 'TIGR04153', NULL, 'cyanosortA_assc: cyanosortase A-associated protein', 185, NULL, 'TIGR04153', 289923);
INSERT INTO "PUBLIC"."MODEL" VALUES
(484249, 'TIGR01577', NULL, 'oligosac_amyl: oligosaccharide amylase', 616, NULL, 'TIGR01577', 289924),
(484250, 'TIGR02561', NULL, 'HrpB1_HrpK: type III secretion protein HrpB1/HrpK', 183, NULL, 'TIGR02561', 289925),
(484251, 'TIGR02159', NULL, 'PA_CoA_Oxy4: phenylacetate-CoA oxygenase, PaaJ subunit', 146, NULL, 'TIGR02159', 289926),
(484252, 'TIGR00415', NULL, 'serS_MJ: serine--tRNA ligase', 518, NULL, 'TIGR00415', 289927),
(484253, 'TIGR00907', NULL, '2A0304: amino acid permease', 482, NULL, 'TIGR00907', 289928),
(484254, 'TIGR01053', NULL, 'LSD1: zinc finger domain, LSD1 subclass', 31, NULL, 'TIGR01053', 289929),
(484255, 'TIGR01249', NULL, 'pro_imino_pep_1: prolyl aminopeptidase', 307, NULL, 'TIGR01249', 289930),
(484256, 'TIGR02672', NULL, 'cas_csm6: CRISPR type III-A/MTUBE-associated protein Csm6', 362, NULL, 'TIGR02672', 289931),
(484257, 'TIGR03843', NULL, 'TIGR03843: conserved hypothetical protein', 253, NULL, 'TIGR03843', 289932),
(484258, 'TIGR01079', NULL, 'rplX_bact: ribosomal protein uL24', 104, NULL, 'TIGR01079', 289933),
(484259, 'TIGR04425', NULL, 'P_lya_rel_AroB: putative sugar phosphate phospholyase (cyclizing)', 348, NULL, 'TIGR04425', 289934),
(484260, 'TIGR00409', NULL, 'proS_fam_II: proline--tRNA ligase', 568, NULL, 'TIGR00409', 289935),
(484261, 'TIGR03778', NULL, 'VPDSG_CTERM: VPDSG-CTERM protein sorting domain', 24, NULL, 'TIGR03778', 289936),
(484262, 'TIGR01817', NULL, 'nifA: Nif-specific regulatory protein', 534, NULL, 'TIGR01817', 289937),
(484263, 'TIGR03700', NULL, 'mena_SCO4494: putative menaquinone biosynthesis radical SAM enzyme, SCO4494 family', 351, NULL, 'TIGR03700', 289938),
(484264, 'TIGR04475', NULL, 'Phe_D_beta_mut: phenylalanine aminomutase (D-beta-phenylalanine forming)', 510, NULL, 'TIGR04475', 289939),
(484265, 'TIGR00245', NULL, 'TIGR00245: TIGR00245 family protein', 248, NULL, 'TIGR00245', 289940),
(484266, 'TIGR00793', NULL, 'kdgT: 2-keto-3-deoxygluconate transporter', 314, NULL, 'TIGR00793', 289941),
(484267, 'TIGR03354', NULL, 'VI_FHA: type VI secretion system FHA domain protein', 420, NULL, 'TIGR03354', 289942),
(484268, 'TIGR03837', NULL, 'efp_adjacent_2: conserved hypothetical protein, PP_1857 family', 371, NULL, 'TIGR03837', 289943),
(484269, 'TIGR02716', NULL, 'C20_methyl_CrtF: C-20 methyltransferase BchU', 306, NULL, 'TIGR02716', 289944),
(484270, 'TIGR03026', NULL, 'NDP-sugDHase: nucleotide sugar dehydrogenase', 413, NULL, 'TIGR03026', 289945),
(484271, 'TIGR02218', NULL, 'phg_TIGR02218: phage conserved hypothetical protein BR0599', 266, NULL, 'TIGR02218', 289946),
(484272, 'TIGR04010', NULL, 'WcaD: putative colanic acid polymerase WcaD', 404, NULL, 'TIGR04010', 289947),
(484273, 'TIGR01679', NULL, 'bact_FAD_ox: FAD-linked oxidoreductase', 419, NULL, 'TIGR01679', 289948),
(484274, 'TIGR02180', NULL, 'GRX_euk: glutaredoxin', 84, NULL, 'TIGR02180', 289949),
(484275, 'TIGR02663', NULL, 'nifX: nitrogen fixation protein NifX', 119, NULL, 'TIGR02663', 289950),
(484276, 'TIGR02698', NULL, 'CopY_TcrY: copper transport repressor, CopY/TcrY family', 130, NULL, 'TIGR02698', 289951),
(484277, 'TIGR03852', NULL, 'sucrose_gtfA: sucrose phosphorylase', 470, NULL, 'TIGR03852', 289952),
(484278, 'TIGR00295', NULL, 'TIGR00295: TIGR00295 family protein', 164, NULL, 'TIGR00295', 289953),
(484279, 'TIGR02868', NULL, 'CydC: thiol reductant ABC exporter, CydC subunit', 530, NULL, 'TIGR02868', 289954),
(484280, 'TIGR03073', NULL, 'release_rtcB: release factor H-coupled RctB family protein', 356, NULL, 'TIGR03073', 289955),
(484281, 'TIGR04103', NULL, 'rSAM_nif11_3: nif11-class peptide radical SAM maturase 3', 412, NULL, 'TIGR04103', 289956),
(484282, 'TIGR01044', NULL, 'rplV_bact: ribosomal protein uL22', 103, NULL, 'TIGR01044', 289957),
(484283, 'TIGR01536', NULL, 'asn_synth_AEB: asparagine synthase (glutamine-hydrolyzing)', 517, NULL, 'TIGR01536', 289958),
(484284, 'TIGR04194', NULL, 'grasp_w_spasm_A: grasp-with-spasm leader A domain', 28, NULL, 'TIGR04194', 289959),
(484285, 'TIGR01870', NULL, 'cas_TM1810_Csm2: CRISPR type III-A/MTUBE-associated protein Csm2', 96, NULL, 'TIGR01870', 289960);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(484286, 'TIGR02520', NULL, 'pilus_B_mal_scr: type IVB pilus formation outer membrane protein, R64 PilN family', 513, NULL, 'TIGR02520', 289961),
(484287, 'TIGR02657', NULL, 'amicyanin: amicyanin', 83, NULL, 'TIGR02657', 289962),
(484288, 'TIGR04568', NULL, 'arch_SelU_Nterm: selenouridine synthase, SelU N-terminal-like subunit', 215, NULL, 'TIGR04568', 289963),
(484289, 'TIGR02991', NULL, 'ectoine_eutB: ectoine utilization protein EutB', 317, NULL, 'TIGR02991', 289964),
(484290, 'TIGR01372', NULL, 'soxA: sarcosine oxidase, alpha subunit family', 996, NULL, 'TIGR01372', 289965),
(484291, 'TIGR03989', NULL, 'Rxyl_3153: NDMA-dependent alcohol dehydrogenase, Rxyl_3153 family', 370, NULL, 'TIGR03989', 289966),
(484292, 'TIGR01477', NULL, 'RIFIN: variant surface antigen, rifin family', 356, NULL, 'TIGR01477', 289967),
(484293, 'TIGR03360', NULL, 'VI_minor_1: type VI secretion-associated protein, VC_A0118 family', 187, NULL, 'TIGR03360', 289968),
(484294, 'TIGR00787', NULL, 'dctP: TRAP transporter solute receptor, DctP family', 257, NULL, 'TIGR00787', 289969),
(484295, 'TIGR02022', NULL, 'hutF: formiminoglutamate deiminase', 455, NULL, 'TIGR02022', 289970),
(484296, 'TIGR02376', NULL, 'Cu_nitrite_red: nitrite reductase, copper-containing', 326, NULL, 'TIGR02376', 289971),
(484297, 'TIGR01038', NULL, 'uL22_arch_euk: ribosomal protein uL22', 148, NULL, 'TIGR01038', 289972),
(484298, 'TIGR01542', NULL, 'A118_put_portal: phage portal protein, putative, A118 family', 476, NULL, 'TIGR01542', 289973),
(484299, 'TIGR00839', NULL, 'aspA: aspartate ammonia-lyase', 468, NULL, 'TIGR00839', 289974),
(484300, 'TIGR02274', NULL, 'dCTP_deam: deoxycytidine triphosphate deaminase', 180, NULL, 'TIGR02274', 289975),
(484301, 'TIGR03292', NULL, 'PhnH_redo: phosphonate C-P lyase system protein PhnH', 184, NULL, 'TIGR03292', 289976),
(484302, 'TIGR03743', NULL, 'SXT_TraD: conjugative coupling factor TraD, SXT/TOL subfamily', 636, NULL, 'TIGR03743', 289977),
(484303, 'TIGR02725', NULL, 'phenyl_P_gamma: phenylphosphate carboxylase, gamma subunit', 84, NULL, 'TIGR02725', 289978),
(484304, 'TIGR01926', NULL, 'peroxid_rel: uncharacterized peroxidase-related enzyme', 178, NULL, 'TIGR01926', 289979),
(484305, 'TIGR02118', NULL, 'TIGR02118: conserved hypothetical protein', 103, NULL, 'TIGR02118', 289980),
(484306, 'TIGR00459', NULL, 'aspS_bact: aspartate--tRNA ligase', 586, NULL, 'TIGR00459', 289981),
(484307, 'TIGR03245', NULL, 'arg_AOST_alph: arginine/ornithine succinyltransferase, alpha subunit', 336, NULL, 'TIGR03245', 289982),
(484308, 'TIGR03790', NULL, 'TIGR03790: TIGR03790 family protein', 316, NULL, 'TIGR03790', 289983),
(484309, 'TIGR03911', NULL, 'pyrrolys_PylD: pyrrolysine biosynthesis protein PylD', 266, NULL, 'TIGR03911', 289984),
(484310, 'TIGR01973', NULL, 'NuoG: NADH dehydrogenase (quinone), G subunit', 606, NULL, 'TIGR01973', 289985),
(484311, 'TIGR04091', NULL, 'LTA_dltB: D-alanyl-lipoteichoic acid biosynthesis protein DltB', 380, NULL, 'TIGR04091', 289986),
(484312, 'TIGR01010', NULL, 'BexC_CtrB_KpsE: polysaccharide export inner-membrane protein, BexC/CtrB/KpsE family', 362, NULL, 'TIGR01010', 289987),
(484313, 'TIGR01966', NULL, 'RNasePH: ribonuclease PH', 236, NULL, 'TIGR01966', 289988),
(484314, 'TIGR02165', NULL, 'cas5_6_GSU0054: CRISPR-associated protein GSU0054/csb2, Dpsyc system', 492, NULL, 'TIGR02165', 289989),
(484315, 'TIGR02616', NULL, 'tnaC_leader: tryptophanase leader peptide', 22, NULL, 'TIGR02616', 289990),
(484316, 'TIGR02109', NULL, 'PQQ_syn_pqqE: coenzyme PQQ biosynthesis enzyme PqqE', 358, NULL, 'TIGR02109', 289991),
(484317, 'TIGR00811', NULL, 'sit: silicon transporter', 548, NULL, 'TIGR00811', 289992),
(484318, 'TIGR04206', NULL, 'near_ArtA: TIGR04206 family protein', 139, NULL, 'TIGR04206', 289993),
(484319, 'TIGR00186', NULL, 'rRNA_methyl_3: RNA methyltransferase, TrmH family, group 3', 240, NULL, 'TIGR00186', 289994),
(484320, 'TIGR01586', NULL, 'yopT_cys_prot: cysteine protease domain, YopT-type', 199, NULL, 'TIGR01586', 289995),
(484321, 'TIGR04051', NULL, 'rSAM_NirJ: heme d1 biosynthesis radical SAM protein NirJ', 354, NULL, 'TIGR04051', 289996);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(484322, 'TIGR01003', NULL, 'PTS_HPr_family: phosphocarrier, HPr family', 82, NULL, 'TIGR01003', 289997),
(484323, 'TIGR03509', NULL, 'OMP_MtrB_PioB: decaheme-associated outer membrane protein, MtrB/PioB family', 662, NULL, 'TIGR03509', 289998),
(484324, 'TIGR00684', NULL, 'narJ: nitrate reductase molybdenum cofactor assembly chaperone', 152, NULL, 'TIGR00684', 289999),
(484325, 'TIGR04147', NULL, 'GGGPS_Halobact: phosphoglycerol geranylgeranyltransferase, putative', 229, NULL, 'TIGR04147', 290000),
(484326, 'TIGR01645', NULL, 'half-pint: poly-U binding splicing factor, half-pint family', 607, NULL, 'TIGR01645', 290001),
(484327, 'TIGR04431', NULL, 'N6_acetyl_AAC6: aminoglycoside N(6'')-acetyltransferase, AacA4 family', 184, NULL, 'TIGR04431', 290002),
(484328, 'TIGR01331', NULL, 'bisphos_cysQ: 3''(2''),5''-bisphosphate nucleotidase', 250, NULL, 'TIGR01331', 290003),
(484329, 'TIGR02607', NULL, 'antidote_HigA: addiction module antidote protein, HigA family', 81, NULL, 'TIGR02607', 290004),
(484330, 'TIGR04029', NULL, 'CMD_Avi_7170: CMD domain protein, Avi_7170 family', 174, NULL, 'TIGR04029', 290005),
(484331, 'TIGR02944', NULL, 'suf_reg_Xantho: FeS assembly SUF system regulator', 130, NULL, 'TIGR02944', 290006),
(484332, 'TIGR02227', NULL, 'sigpep_I_bact: signal peptidase I', 162, NULL, 'TIGR02227', 290007),
(484333, 'TIGR03304', NULL, 'OMP85_target: outer membrane insertion C-terminal signal', 10, NULL, 'TIGR03304', 290008),
(484334, 'TIGR04079', NULL, 'phero_cyc_pep: KxxxW-cyclized secreted peptide', 23, NULL, 'TIGR04079', 290009),
(484335, 'TIGR03750', NULL, 'conj_TIGR03750: conjugative transfer region protein, TIGR03750 family', 111, NULL, 'TIGR03750', 290010),
(484336, 'TIGR03887', NULL, 'thiocyan_alph: thiocyanate hydrolase, gamma subunit', 200, NULL, 'TIGR03887', 290011),
(484337, 'TIGR00743', NULL, 'TIGR00743: conserved hypothetical protein', 95, NULL, 'TIGR00743', 290012),
(484338, 'TIGR03422', NULL, 'mito_frataxin: frataxin', 100, NULL, 'TIGR03422', 290013),
(484339, 'TIGR03559', NULL, 'F420_Rv3520c: probable F420-dependent oxidoreductase, Rv3520c family', 325, NULL, 'TIGR03559', 290014),
(484340, 'TIGR01088', NULL, 'aroQ: 3-dehydroquinate dehydratase, type II', 141, NULL, 'TIGR01088', 290015),
(484341, 'TIGR01112', NULL, 'mtrD: tetrahydromethanopterin S-methyltransferase, subunit D', 223, NULL, 'TIGR01112', 290016),
(484342, 'TIGR04440', NULL, 'glyco_TIGR04440: glycosyltransferase domain', 215, NULL, 'TIGR04440', 290017),
(484343, 'TIGR02267', NULL, 'TIGR02267: DUSAM domain', 123, NULL, 'TIGR02267', 290018),
(484344, 'TIGR01381', NULL, 'E1_like_apg7: E1-like protein-activating enzyme Gsa7p/Apg7p', 663, NULL, 'TIGR01381', 290019),
(484345, 'TIGR03939', NULL, 'PGA_TPR_OMP: poly-beta-1,6 N-acetyl-D-glucosamine export porin PgaA', 800, NULL, 'TIGR03939', 290020),
(484346, 'TIGR01147', NULL, 'V_ATP_synt_G: V-type ATPase, G subunit', 113, NULL, 'TIGR01147', 290021),
(484347, 'TIGR00313', NULL, 'cobQ: cobyric acid synthase CobQ', 477, NULL, 'TIGR00313', 290022),
(484348, 'TIGR01440', NULL, 'TIGR01440: TIGR01440 family protein', 172, NULL, 'TIGR01440', 290023),
(484349, 'TIGR04001', NULL, 'thiol_BshB1: bacillithiol biosynthesis deacetylase BshB1', 226, NULL, 'TIGR04001', 290024),
(484350, 'TIGR04138', NULL, 'Plancto_Ver_chp: Verruc_Plancto-restricted protein', 123, NULL, 'TIGR04138', 290025),
(484351, 'TIGR00948', NULL, '2a75: L-lysine exporter', 177, NULL, 'TIGR00948', 290026),
(484352, 'TIGR02595', NULL, 'PEP_exosort: PEP-CTERM protein-sorting domain', 24, NULL, 'TIGR02595', 290027),
(484353, 'TIGR02130', NULL, 'dapB_plant: dihydrodipicolinate reductase', 275, NULL, 'TIGR02130', 290028),
(484354, 'TIGR01919', NULL, 'hisA-trpF: bifunctional HisA/TrpF protein', 243, NULL, 'TIGR01919', 290029),
(484355, 'TIGR03802', NULL, 'Asp_Ala_antiprt: aspartate-alanine antiporter', 562, NULL, 'TIGR03802', 290030),
(484356, 'TIGR03920', NULL, 'T7SS_EccD: type VII secretion integral membrane protein EccD', 455, NULL, 'TIGR03920', 290031),
(484357, 'TIGR02772', NULL, 'Ku_bact: Ku protein', 259, NULL, 'TIGR02772', 290032);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(484358, 'TIGR00786', NULL, 'dctM: TRAP transporter, DctM subunit', 405, NULL, 'TIGR00786', 290033),
(484359, 'TIGR02342', NULL, 'chap_CCT_delta: T-complex protein 1, delta subunit', 517, NULL, 'TIGR02342', 290034),
(484360, 'TIGR02670', NULL, 'cas_csx8: CRISPR-associated protein Cas8a1/Csx8, subtype I', 441, NULL, 'TIGR02670', 290035),
(484361, 'TIGR00306', NULL, 'apgM: phosphoglycerate mutase (2,3-diphosphoglycerate-independent), archaeal form', 396, NULL, 'TIGR00306', 290036),
(484362, 'TIGR02479', NULL, 'FliA_WhiG: RNA polymerase sigma factor, FliA/WhiG family', 224, NULL, 'TIGR02479', 290037),
(484363, 'TIGR03347', NULL, 'VI_chp_1: type VI secretion protein, VC_A0111 family', 300, NULL, 'TIGR03347', 290038),
(484364, 'TIGR03463', NULL, 'osq_cycl: 2,3-oxidosqualene cyclase', 634, NULL, 'TIGR03463', 290039),
(484365, 'TIGR02411', NULL, 'leuko_A4_hydro: leukotriene A-4 hydrolase/aminopeptidase', 600, NULL, 'TIGR02411', 290040),
(484366, 'TIGR04262', NULL, 'orph_peri_GRRM: extracellular substrate-binding orphan protein, GRRM family', 257, NULL, 'TIGR04262', 290041),
(484367, 'TIGR01427', NULL, 'PTS_IIC_fructo: PTS system, Fru family, IIC component', 346, NULL, 'TIGR01427', 290042),
(484368, 'TIGR00136', NULL, 'gidA: tRNA uridine 5-carboxymethylaminomethyl modification enzyme GidA', 616, NULL, 'TIGR00136', 290043),
(484369, 'TIGR02840', NULL, 'spore_YtaF: putative sporulation protein YtaF', 206, NULL, 'TIGR02840', 290044),
(484370, 'TIGR03210', NULL, 'badI: 2-ketocyclohexanecarboxyl-CoA hydrolase', 256, NULL, 'TIGR03210', 290045),
(484371, 'TIGR00151', NULL, 'ispF: 2-C-methyl-D-erythritol 2,4-cyclodiphosphate synthase', 155, NULL, 'TIGR00151', 290046),
(484372, 'TIGR00634', NULL, 'recN: DNA repair protein RecN', 563, NULL, 'TIGR00634', 290047),
(484373, 'TIGR04316', NULL, 'dhbA_paeA: 2,3-dihydro-2,3-dihydroxybenzoate dehydrogenase', 250, NULL, 'TIGR04316', 290048),
(484374, 'TIGR02554', NULL, 'PrgH: type III secretion apparatus protein PrgH/EprH', 389, NULL, 'TIGR02554', 290049),
(484375, 'TIGR01197', NULL, 'nramp: metal ion transporter, metal ion (Mn2+/Fe2+) transporter (Nramp) family', 390, NULL, 'TIGR01197', 290050),
(484376, 'TIGR00035', NULL, 'asp_race: aspartate racemase', 236, NULL, 'TIGR00035', 290051),
(484377, 'TIGR01004', NULL, 'PulS_OutS: lipoprotein, PulS/OutS family', 128, NULL, 'TIGR01004', 290052),
(484378, 'TIGR00628', NULL, 'ung: uracil-DNA glycosylase', 210, NULL, 'TIGR00628', 290053),
(484379, 'TIGR00861', NULL, 'MIP: MIP family channel proteins', 224, NULL, 'TIGR00861', 290054),
(484380, 'TIGR00998', NULL, '8a0101: efflux pump membrane protein', 334, NULL, 'TIGR00998', 290055),
(484381, 'TIGR03905', NULL, 'TIGR03905_4_Cys: uncharacterized protein TIGR03905', 78, NULL, 'TIGR03905', 290056),
(484382, 'TIGR02882', NULL, 'QoxB: cytochrome aa3 quinol oxidase, subunit I', 643, NULL, 'TIGR02882', 290057),
(484383, 'TIGR00288', NULL, 'TIGR00288: TIGR00288 family protein', 160, NULL, 'TIGR00288', 290058),
(484384, 'TIGR00363', NULL, 'TIGR00363: lipoprotein, YaeC family', 258, NULL, 'TIGR00363', 290059),
(484385, 'TIGR04474', NULL, 'tcm_partner: three-Cys-motif partner protein', 263, NULL, 'TIGR04474', 290060),
(484386, 'TIGR02977', NULL, 'phageshock_pspA: phage shock protein A', 219, NULL, 'TIGR02977', 290061),
(484387, 'TIGR01639', NULL, 'P_fal_TIGR01639: Plasmodium falciparum uncharacterized domain TIGR01639', 61, NULL, 'TIGR01639', 290062),
(484388, 'TIGR04104', NULL, 'cxxc_20_cxxc: cxxc_20_cxxc protein', 93, NULL, 'TIGR04104', 290063),
(484389, 'TIGR04399', NULL, 'acc_Sec_SLAP: accessory Sec system S-layer assembly protein', 288, NULL, 'TIGR04399', 290064),
(484390, 'TIGR02548', NULL, 'casB_cse2: CRISPR type I-E/ECOLI-associated protein CasB/Cse2', 159, NULL, 'TIGR02548', 290065),
(484391, 'TIGR03961', NULL, 'rSAM_PTO1314: archaeal radical SAM protein, PTO1314 family', 332, NULL, 'TIGR03961', 290066),
(484392, 'TIGR01713', NULL, 'typeII_sec_gspC: type II secretion system protein C', 259, NULL, 'TIGR01713', 290067),
(484393, 'TIGR00690', NULL, 'rpoZ: DNA-directed RNA polymerase, omega subunit', 60, NULL, 'TIGR00690', 290068);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(484394, 'TIGR02336', NULL, 'TIGR02336: 1,3-beta-galactosyl-N-acetylhexosamine phosphorylase', 719, NULL, 'TIGR02336', 290069),
(484395, 'TIGR03388', NULL, 'ascorbase: L-ascorbate oxidase', 542, NULL, 'TIGR03388', 290070),
(484396, 'TIGR02834', NULL, 'spo_ytxC: putative sporulation protein YtxC', 276, NULL, 'TIGR02834', 290071),
(484397, 'TIGR01215', NULL, 'minE: cell division topological specificity factor MinE', 81, NULL, 'TIGR01215', 290072),
(484398, 'TIGR04372', NULL, 'glycosyl_04372: putative glycosyltransferase, TIGR04372 family', 207, NULL, 'TIGR04372', 290073),
(484399, 'TIGR02008', NULL, 'fdx_plant: ferredoxin [2Fe-2S]', 97, NULL, 'TIGR02008', 290074),
(484400, 'TIGR04527', NULL, 'mycoplas_twoTM: two transmembrane protein', 248, NULL, 'TIGR04527', 290075),
(484401, 'TIGR01299', NULL, 'synapt_SV2: synaptic vesicle protein SV2', 742, NULL, 'TIGR01299', 290076),
(484402, 'TIGR04044', NULL, 'MSMEG_0572_fam: MSMEG_0572 family protein', 159, NULL, 'TIGR04044', 290077),
(484403, 'TIGR00192', NULL, 'urease_beta: urease, beta subunit', 103, NULL, 'TIGR00192', 290078),
(484404, 'TIGR01543', NULL, 'proheadase_HK97: phage prohead protease, HK97 family', 142, NULL, 'TIGR01543', 290079),
(484405, 'TIGR02056', NULL, 'ChlG: chlorophyll synthase ChlG', 306, NULL, 'TIGR02056', 290080),
(484406, 'TIGR03407', NULL, 'urea_ABC_UrtA: urea ABC transporter, urea binding protein', 361, NULL, 'TIGR03407', 290081),
(484407, 'TIGR01502', NULL, 'B_methylAsp_ase: methylaspartate ammonia-lyase', 408, NULL, 'TIGR01502', 290082),
(484408, 'TIGR00518', NULL, 'alaDH: alanine dehydrogenase', 370, NULL, 'TIGR00518', 290083),
(484409, 'TIGR04534', NULL, 'ELWxxDGT_rpt: ELWxxDGT repeat', 47, NULL, 'TIGR04534', 290084),
(484410, 'TIGR03183', NULL, 'DNA_S_dndC: putative sulfurtransferase DndC', 447, NULL, 'TIGR03183', 290085),
(484411, 'TIGR03675', NULL, 'arCOG00543: arCOG00543 universal archaeal KH-domain/beta-lactamase-domain protein', 631, NULL, 'TIGR03675', 290086),
(484412, 'TIGR02513', NULL, 'type_III_yscB: type III secretion system chaperone, YscB family', 140, NULL, 'TIGR02513', 290087),
(484413, 'TIGR01490', NULL, 'HAD-SF-IB-hyp1: HAD hydrolase, family IB', 202, NULL, 'TIGR01490', 290088),
(484414, 'TIGR02841', NULL, 'spore_YyaC: putative sporulation protein YyaC', 140, NULL, 'TIGR02841', 290089),
(484415, 'TIGR04188', NULL, 'methyltr_grsp: methyltransferase, ATP-grasp peptide maturase system', 363, NULL, 'TIGR04188', 290090),
(484416, 'TIGR01162', NULL, 'purE: phosphoribosylaminoimidazole carboxylase, catalytic subunit', 156, NULL, 'TIGR01162', 290091),
(484417, 'TIGR00204', NULL, 'dxs: 1-deoxy-D-xylulose-5-phosphate synthase', 616, NULL, 'TIGR00204', 290092),
(484418, 'TIGR03177', NULL, 'pilus_cpaB: Flp pilus assembly protein CpaB', 262, NULL, 'TIGR03177', 290093),
(484419, 'TIGR00846', NULL, 'caca2: calcium/proton exchanger', 372, NULL, 'TIGR00846', 290094),
(484420, 'TIGR01325', NULL, 'O_suc_HS_sulf: O-succinylhomoserine sulfhydrylase', 380, NULL, 'TIGR01325', 290095),
(484421, 'TIGR04418', NULL, 'PriB_gamma: primosomal replication protein PriB', 96, NULL, 'TIGR04418', 290096),
(484422, 'TIGR00307', NULL, 'eS8: ribosomal protein eS8', 127, NULL, 'TIGR00307', 290097),
(484423, 'TIGR02377', NULL, 'MocE_fam_FeS: Rieske [2Fe-2S] domain protein, MocE subfamily', 101, NULL, 'TIGR02377', 290098),
(484424, 'TIGR01271', NULL, 'CFTR_protein: cystic fibrosis transmembrane conductor regulator (CFTR)', 1490, NULL, 'TIGR01271', 290099),
(484425, 'TIGR02343', NULL, 'chap_CCT_epsi: T-complex protein 1, epsilon subunit', 532, NULL, 'TIGR02343', 290100),
(484426, 'TIGR02240', NULL, 'PHA_depoly_arom: poly(3-hydroxyalkanoate) depolymerase', 276, NULL, 'TIGR02240', 290101),
(484427, 'TIGR03395', NULL, 'sphingomy: sphingomyelin phosphodiesterase', 286, NULL, 'TIGR03395', 290102),
(484428, 'TIGR01857', NULL, 'FGAM-synthase: phosphoribosylformylglycinamidine synthase', 1239, NULL, 'TIGR01857', 290103),
(484429, 'TIGR00702', NULL, 'TIGR00702: YcaO-type kinase domain', 377, NULL, 'TIGR00702', 290104),
(484430, 'TIGR02875', NULL, 'spore_0_A: sporulation transcription factor Spo0A', 262, NULL, 'TIGR02875', 290105);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(484431, 'TIGR01720', NULL, 'NRPS-para261: non-ribosomal peptide synthase domain TIGR01720', 155, NULL, 'TIGR01720', 290106),
(484432, 'TIGR03067', NULL, 'Planc_TIGR03067: Planctomycetes uncharacterized domain TIGR03067', 107, NULL, 'TIGR03067', 290107),
(484433, 'TIGR02622', NULL, 'CDP_4_6_dhtase: CDP-glucose 4,6-dehydratase', 352, NULL, 'TIGR02622', 290108),
(484434, 'TIGR03728', NULL, 'glyco_access_1: glycosyltransferase, SP_1767 family', 265, NULL, 'TIGR03728', 290109),
(484435, 'TIGR04085', NULL, 'rSAM_more_4Fe4S: radical SAM additional 4Fe4S-binding SPASM domain', 93, NULL, 'TIGR04085', 290110),
(484436, 'TIGR02015', NULL, 'BchY: chlorophyllide reductase subunit Y', 422, NULL, 'TIGR02015', 290111),
(484437, 'TIGR03777', NULL, 'RPE4: rickettsial palindromic element RPE4 domain', 32, NULL, 'TIGR03777', 290112),
(484438, 'TIGR01823', NULL, 'PabB-fungal: aminodeoxychorismate synthase', 742, NULL, 'TIGR01823', 290113),
(484439, 'TIGR02978', NULL, 'phageshock_pspC: phage shock protein C', 121, NULL, 'TIGR02978', 290114),
(484440, 'TIGR03893', NULL, 'lant_SP_1948: type 2 lantibiotic, SP_1948 family', 61, NULL, 'TIGR03893', 290115),
(484441, 'TIGR02547', NULL, 'casA_cse1: CRISPR type I-E/ECOLI-associated protein CasA/Cse1', 504, NULL, 'TIGR02547', 290116),
(484442, 'TIGR01222', NULL, 'minC: septum site-determining protein MinC', 226, NULL, 'TIGR01222', 290117),
(484443, 'TIGR02950', NULL, 'SigM_subfam: RNA polymerase sigma factor, SigM family', 159, NULL, 'TIGR02950', 290118),
(484444, 'TIGR04297', NULL, 'thauma_sortase: thaumarchaeosortase', 307, NULL, 'TIGR04297', 290119),
(484445, 'TIGR04160', NULL, 'methbact_MbnC: methanobactin biosynthesis cassette protein MbnC', 87, NULL, 'TIGR04160', 290120),
(484446, 'TIGR00465', NULL, 'ilvC: ketol-acid reductoisomerase', 314, NULL, 'TIGR00465', 290121),
(484447, 'TIGR03142', NULL, 'cytochro_ccmI: cytochrome c-type biogenesis protein CcmI', 118, NULL, 'TIGR03142', 290122),
(484448, 'TIGR00144', NULL, 'beta_RFAP_syn: beta-ribofuranosylaminobenzene 5''-phosphate synthase family', 325, NULL, 'TIGR00144', 290123),
(484449, 'TIGR03640', NULL, 'cas1_DVULG: CRISPR-associated endonuclease Cas1, subtype I-C/DVULG', 340, NULL, 'TIGR03640', 290124),
(484450, 'TIGR03470', NULL, 'HpnH: hopanoid biosynthesis associated radical SAM protein HpnH', 318, NULL, 'TIGR03470', 290125),
(484451, 'TIGR02410', NULL, 'carnitine_TMLD: trimethyllysine dioxygenase', 362, NULL, 'TIGR02410', 290126),
(484452, 'TIGR03886', NULL, 'lyase_spl_fam: spore photoproduct lyase family protein', 346, NULL, 'TIGR03886', 290127),
(484453, 'TIGR00805', NULL, 'oat: sodium-independent organic anion transporter', 639, NULL, 'TIGR00805', 290128),
(484454, 'TIGR03565', NULL, 'alk_sulf_monoox: alkanesulfonate monooxygenase, FMNH(2)-dependent', 346, NULL, 'TIGR03565', 290129),
(484455, 'TIGR02731', NULL, 'phytoene_desat: phytoene desaturase', 453, NULL, 'TIGR02731', 290130),
(484456, 'TIGR02301', NULL, 'TIGR02301: TIGR02301 family protein', 121, NULL, 'TIGR02301', 290131),
(484457, 'TIGR03784', NULL, 'marine_sortase: sortase, marine proteobacterial type', 174, NULL, 'TIGR03784', 290132),
(484458, 'TIGR02438', NULL, 'catachol_actin: catechol 1,2-dioxygenase', 281, NULL, 'TIGR02438', 290133),
(484459, 'TIGR02766', NULL, 'crypt_chrom_pln: cryptochrome, plant family', 480, NULL, 'TIGR02766', 290134),
(484460, 'TIGR03251', NULL, 'LAT_fam: L-lysine 6-transaminase', 433, NULL, 'TIGR03251', 290135),
(484461, 'TIGR00397', NULL, 'mauM_napG: MauM/NapG family ferredoxin-type protein', 213, NULL, 'TIGR00397', 290136),
(484462, 'TIGR00260', NULL, 'thrC: threonine synthase', 340, NULL, 'TIGR00260', 290137),
(484463, 'TIGR00416', NULL, 'sms: DNA repair protein RadA', 454, NULL, 'TIGR00416', 290138),
(484464, 'TIGR01748', NULL, 'rhaA: L-rhamnose isomerase', 414, NULL, 'TIGR01748', 290139),
(484465, 'TIGR01592', NULL, 'holin_SPP1: holin, SPP1 family', 78, NULL, 'TIGR01592', 290140),
(484466, 'TIGR03286', NULL, 'methan_mark_15: putative methanogenesis marker protein 15', 404, NULL, 'TIGR03286', 290141),
(484467, 'TIGR02452', NULL, 'TIGR02452: TIGR02452 family protein', 266, NULL, 'TIGR02452', 290142);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(484468, 'TIGR02131', NULL, 'phaP_Bmeg: polyhydroxyalkanoic acid inclusion protein PhaP', 165, NULL, 'TIGR02131', 290143),
(484469, 'TIGR01106', NULL, 'ATPase-IIC_X-K: Na,H/K antiporter P-type ATPase, alpha subunit', 997, NULL, 'TIGR01106', 290144),
(484470, 'TIGR01932', NULL, 'hflC: HflC protein', 318, NULL, 'TIGR01932', 290145),
(484471, 'TIGR03619', NULL, 'F420_Rv2161c: probable F420-dependent oxidoreductase, Rv2161c family', 247, NULL, 'TIGR03619', 290146),
(484472, 'TIGR02124', NULL, 'hypE: hydrogenase expression/formation protein HypE', 332, NULL, 'TIGR02124', 290147),
(484473, 'TIGR00574', NULL, 'dnl1: DNA ligase I, ATP-dependent (dnl1)', 527, NULL, 'TIGR00574', 290148),
(484474, 'TIGR03135', NULL, 'malonate_mdcG: malonate decarboxylase holo-[acyl-carrier-protein] synthase', 205, NULL, 'TIGR03135', 290149),
(484475, 'TIGR00914', NULL, '2A0601: heavy metal efflux pump, CzcA family', 1051, NULL, 'TIGR00914', 290150),
(484476, 'TIGR01925', NULL, 'spIIAB: anti-sigma F factor', 137, NULL, 'TIGR01925', 290151),
(484477, 'TIGR03279', NULL, 'cyano_FeS_chp: putative radical SAM enzyme, TIGR03279 family', 433, NULL, 'TIGR03279', 290152),
(484478, 'TIGR04092', NULL, 'LTA_DltD: D-alanyl-lipoteichoic acid biosynthesis protein DltD', 383, NULL, 'TIGR04092', 290153),
(484479, 'TIGR00581', NULL, 'moaC: molybdenum cofactor biosynthesis protein C', 148, NULL, 'TIGR00581', 290154),
(484480, 'TIGR00895', NULL, '2A0115: MFS transporter, aromatic acid:H+ symporter (AAHS) family', 398, NULL, 'TIGR00895', 290155),
(484481, 'TIGR01604', NULL, 'PYST-C2: Plasmodium yoelii subtelomeric domain PYST-C2', 150, NULL, 'TIGR01604', 290156),
(484482, 'TIGR02445', NULL, 'fadA: acetyl-CoA C-acyltransferase FadA', 385, NULL, 'TIGR02445', 290157),
(484483, 'TIGR01611', NULL, 'tail_tube: phage major tail tube protein', 168, NULL, 'TIGR01611', 290158),
(484484, 'TIGR02759', NULL, 'TraD_Ftype: type IV conjugative transfer system coupling protein TraD', 566, NULL, 'TIGR02759', 290159),
(484485, 'TIGR04309', NULL, 'amanitin: amanitin/phalloidin family toxin', 33, NULL, 'TIGR04309', 290160),
(484486, 'TIGR00600', NULL, 'rad2: DNA excision repair protein (rad2)', 1039, NULL, 'TIGR00600', 290161),
(484487, 'TIGR01113', NULL, 'mtrE: tetrahydromethanopterin S-methyltransferase, subunit E', 283, NULL, 'TIGR01113', 290162),
(484488, 'TIGR00921', NULL, '2A067: efflux transporter, putative, hydrophobe/amphiphile efflux-3 (HAE3) family', 733, NULL, 'TIGR00921', 290163),
(484489, 'TIGR01755', NULL, 'flav_wrbA: NAD(P)H:quinone oxidoreductase, type IV', 197, NULL, 'TIGR01755', 290164),
(484490, 'TIGR01434', NULL, 'glu_cys_ligase: glutamate--cysteine ligase', 512, NULL, 'TIGR01434', 290165),
(484491, 'TIGR02268', NULL, 'TIGR02268: Myxococcus xanthus paralogous family TIGR02268', 295, NULL, 'TIGR02268', 290166),
(484492, 'TIGR00083', NULL, 'ribF: riboflavin biosynthesis protein RibF', 290, NULL, 'TIGR00083', 290167),
(484493, 'TIGR02589', NULL, 'cas_Csd2: CRISPR-associated protein Cas7/Csd2, subtype I-C/DVULG', 284, NULL, 'TIGR02589', 290168),
(484494, 'TIGR01098', NULL, '3A0109s03R: phosphate/phosphite/phosphonate ABC transporter, periplasmic binding protein', 253, NULL, 'TIGR01098', 290169),
(484495, 'TIGR02773', NULL, 'addB_Gpos: helicase-exonuclease AddAB, AddB subunit', 1159, NULL, 'TIGR02773', 290170),
(484496, 'TIGR02893', NULL, 'spore_yabQ: spore cortex biosynthesis protein YabQ', 130, NULL, 'TIGR02893', 290171),
(484497, 'TIGR03188', NULL, 'histidine_hisI: phosphoribosyl-ATP diphosphatase', 84, NULL, 'TIGR03188', 290172),
(484498, 'TIGR00203', NULL, 'cydB: cytochrome d ubiquinol oxidase, subunit II', 378, NULL, 'TIGR00203', 290173),
(484499, 'TIGR03068', NULL, 'srtB_sig_NPQTN: sortase B signal domain, NPQTN class', 33, NULL, 'TIGR03068', 290174),
(484500, 'TIGR01942', NULL, 'pcnB: poly(A) polymerase', 425, NULL, 'TIGR01942', 290175),
(484501, 'TIGR02606', NULL, 'antidote_CC2985: putative addiction module antidote protein, CC2985 family', 70, NULL, 'TIGR02606', 290176),
(484502, 'TIGR00387', NULL, 'glcD: glycolate oxidase, subunit GlcD', 413, NULL, 'TIGR00387', 290177);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(484503, 'TIGR03124', NULL, 'citrate_citX: holo-ACP synthase CitX', 165, NULL, 'TIGR03124', 290178),
(484504, 'TIGR00490', NULL, 'aEF-2: translation elongation factor aEF-2', 720, NULL, 'TIGR00490', 290179),
(484505, 'TIGR03004', NULL, 'ectoine_ehuC: ectoine/hydroxyectoine ABC transporter, permease protein EhuC', 214, NULL, 'TIGR03004', 290180),
(484506, 'TIGR00370', NULL, 'TIGR00370: sensor histidine kinase inhibitor, KipI family', 202, NULL, 'TIGR00370', 290181),
(484507, 'TIGR01034', NULL, 'metK: methionine adenosyltransferase', 377, NULL, 'TIGR01034', 290182),
(484508, 'TIGR04550', NULL, 'sMetMonox_MmoD: soluble methane monooxygenase-binding protein MmoD', 64, NULL, 'TIGR04550', 290183),
(484509, 'TIGR01959', NULL, 'nuoF_fam: NADH oxidoreductase (quinone), F subunit', 410, NULL, 'TIGR01959', 290184),
(484510, 'TIGR00516', NULL, 'acpS: holo-[acyl-carrier-protein] synthase', 125, NULL, 'TIGR00516', 290185),
(484511, 'TIGR02460', NULL, 'osmo_MPGsynth: mannosyl-3-phosphoglycerate synthase', 383, NULL, 'TIGR02460', 290186),
(484512, 'TIGR04327', NULL, 'OMP_LA_2444: outer membrane protein, LA_2444/LA_4059 family', 291, NULL, 'TIGR04327', 290187),
(484513, 'TIGR02237', NULL, 'recomb_radB: DNA repair and recombination protein RadB', 210, NULL, 'TIGR02237', 290188),
(484514, 'TIGR01347', NULL, 'sucB: dihydrolipoyllysine-residue succinyltransferase, E2 component of oxoglutarate dehydrogenase (succinyl-transferring) complex', 404, NULL, 'TIGR01347', 290189),
(484515, 'TIGR01839', NULL, 'PHA_synth_II: poly(R)-hydroxyalkanoic acid synthase, class II', 560, NULL, 'TIGR01839', 290190),
(484516, 'TIGR03437', NULL, 'Soli_cterm: Solibacter uncharacterized C-terminal domain', 225, NULL, 'TIGR03437', 290191),
(484517, 'TIGR03929', NULL, 'T7_esaA_Nterm: type VII secretion protein EsaA', 193, NULL, 'TIGR03929', 290192),
(484518, 'TIGR02580', NULL, 'cas_RAMP_Cmr4: CRISPR type III-B/RAMP module RAMP protein Cmr4', 283, NULL, 'TIGR02580', 290193),
(484519, 'TIGR04075', NULL, 'bacter_Pnkp: polynucleotide kinase-phosphatase', 851, NULL, 'TIGR04075', 290194),
(484520, 'TIGR01570', NULL, 'A_thal_3588: uncharacterized plant-specific domain TIGR01570', 161, NULL, 'TIGR01570', 290195),
(484521, 'TIGR03244', NULL, 'arg_catab_AstA: arginine N-succinyltransferase', 336, NULL, 'TIGR03244', 290196),
(484522, 'TIGR01406', NULL, 'dnaQ_proteo: DNA polymerase III, epsilon subunit', 231, NULL, 'TIGR01406', 290197),
(484523, 'TIGR03660', NULL, 'T1SS_rpt_143: T1SS-143 repeat domain', 143, NULL, 'TIGR03660', 290198),
(484524, 'TIGR04268', NULL, 'FxSxx-COOH: FXSXX-COOH protein', 44, NULL, 'TIGR04268', 290199),
(484525, 'TIGR02178', NULL, 'yeiP: elongation factor P-like protein YeiP', 186, NULL, 'TIGR02178', 290200),
(484526, 'TIGR00147', NULL, 'TIGR00147: lipid kinase, YegS/Rv2252/BmrU family', 296, NULL, 'TIGR00147', 290201),
(484527, 'TIGR00088', NULL, 'trmD: tRNA (guanine(37)-N(1))-methyltransferase', 233, NULL, 'TIGR00088', 290202),
(484528, 'TIGR03853', NULL, 'matur_matur: putative metal-binding protein', 77, NULL, 'TIGR03853', 290203),
(484529, 'TIGR01883', NULL, 'PepT-like: peptidase T-like protein', 361, NULL, 'TIGR01883', 290204),
(484530, 'TIGR04148', NULL, 'GG_samocin_CFB: radical SAM peptide maturase, GG-Bacteroidales family', 411, NULL, 'TIGR04148', 290205),
(484531, 'TIGR02298', NULL, 'HpaD_Fe: 3,4-dihydroxyphenylacetate 2,3-dioxygenase', 284, NULL, 'TIGR02298', 290206),
(484532, 'TIGR00932', NULL, '2a37: transporter, monovalent cation:proton antiporter-2 (CPA2) family', 275, NULL, 'TIGR00932', 290207),
(484533, 'TIGR03780', NULL, 'Bac_Flav_CT_N: Bacteroides conjugative transposon TraN protein', 285, NULL, 'TIGR03780', 290208),
(484534, 'TIGR04134', NULL, 'lipo_with_rSAM: putative lipoprotein, rSAM/lipoprotein system', 150, NULL, 'TIGR04134', 290209),
(484535, 'TIGR03590', NULL, 'PseG: UDP-2,4-diacetamido-2,4,6-trideoxy-beta-L-altropyranose hydrolase', 280, NULL, 'TIGR03590', 290210),
(484536, 'TIGR04254', NULL, 'OpituPEPCTERM_1: putative globular PEP-CTERM protein', 136, NULL, 'TIGR04254', 290211),
(484537, 'TIGR00074', NULL, 'hypC_hupF: hydrogenase assembly chaperone HypC/HupF', 80, NULL, 'TIGR00074', 290212);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(484538, 'TIGR01227', NULL, 'hutG: formimidoylglutamase', 307, NULL, 'TIGR01227', 290213),
(484539, 'TIGR02729', NULL, 'Obg_CgtA: Obg family GTPase CgtA', 329, NULL, 'TIGR02729', 290214),
(484540, 'TIGR03065', NULL, 'srtB_sig_QVPTGV: sortase B signal domain, QVPTGV class', 32, NULL, 'TIGR03065', 290215),
(484541, 'TIGR02919', NULL, 'TIGR02919: accessory Sec system glycosyltransferase GtfB', 438, NULL, 'TIGR02919', 290216),
(484542, 'TIGR02357', NULL, 'ECF_ThiT_YuaJ: energy-coupled thiamine transporter ThiT', 183, NULL, 'TIGR02357', 290217),
(484543, 'TIGR04207', NULL, 'halo_sig_pep: surface glycoprotein signal peptide', 30, NULL, 'TIGR04207', 290218),
(484544, 'TIGR00519', NULL, 'asnASE_I: L-asparaginase, type I', 337, NULL, 'TIGR00519', 290219),
(484545, 'TIGR00709', NULL, 'dat: 2,4-diaminobutyrate 4-transaminase', 442, NULL, 'TIGR00709', 290220),
(484546, 'TIGR00217', NULL, 'malQ: 4-alpha-glucanotransferase', 587, NULL, 'TIGR00217', 290221),
(484547, 'TIGR00446', NULL, 'nop2p: NOL1/NOP2/sun family putative RNA methylase', 264, NULL, 'TIGR00446', 290222),
(484548, 'TIGR04567', NULL, 'RNAP_delt_lowGC: DNA-directed RNA polymerase delta subunit', 83, NULL, 'TIGR04567', 290223),
(484549, 'TIGR01450', NULL, 'recC: exodeoxyribonuclease V, gamma subunit', 1063, NULL, 'TIGR01450', 290224),
(484550, 'TIGR02952', NULL, 'Sig70_famx2: RNA polymerase sigma-70 factor, TIGR02952 family', 170, NULL, 'TIGR02952', 290225),
(484551, 'TIGR00440', NULL, 'glnS: glutamine--tRNA ligase', 524, NULL, 'TIGR00440', 290226),
(484552, 'TIGR00879', NULL, 'SP: MFS transporter, sugar porter (SP) family', 510, NULL, 'TIGR00879', 290227),
(484553, 'TIGR02114', NULL, 'coaB_strep: phosphopantothenate--cysteine ligase', 228, NULL, 'TIGR02114', 290228),
(484554, 'TIGR03616', NULL, 'RutG: pyrimidine utilization transport protein G', 429, NULL, 'TIGR03616', 290229),
(484555, 'TIGR03138', NULL, 'QueF: queuine synthase', 275, NULL, 'TIGR03138', 290230),
(484556, 'TIGR01084', NULL, 'mutY: A/G-specific adenine glycosylase', 277, NULL, 'TIGR01084', 290231),
(484557, 'TIGR01719', NULL, 'euk_UDPppase: uridine phosphorylase', 287, NULL, 'TIGR01719', 290232),
(484558, 'TIGR03557', NULL, 'F420_G6P_family: F420-dependent oxidoreductase, G6PDH family', 316, NULL, 'TIGR03557', 290233),
(484559, 'TIGR03367', NULL, 'queuosine_QueD: queuosine biosynthesis protein QueD', 92, NULL, 'TIGR03367', 290234),
(484560, 'TIGR01909', NULL, 'C_GCAxxG_C_C: C_GCAxxG_C_C family protein', 120, NULL, 'TIGR01909', 290235),
(484561, 'TIGR03481', NULL, 'HpnM: hopanoid biosynthesis associated membrane protein HpnM', 200, NULL, 'TIGR03481', 290236),
(484562, 'TIGR02843', NULL, 'CyoB: cytochrome o ubiquinol oxidase, subunit I', 646, NULL, 'TIGR02843', 290237),
(484563, 'TIGR00013', NULL, 'taut: 4-oxalocrotonate tautomerase family enzyme', 64, NULL, 'TIGR00013', 290238),
(484564, 'TIGR01168', NULL, 'YSIRK_signal: gram-positive signal peptide, YSIRK family', 40, NULL, 'TIGR01168', 290239),
(484565, 'TIGR02963', NULL, 'xanthine_xdhA: xanthine dehydrogenase, small subunit', 468, NULL, 'TIGR02963', 290240),
(484566, 'TIGR04313', NULL, 'aro_clust_Mycop: aromatic cluster surface protein', 296, NULL, 'TIGR04313', 290241),
(484567, 'TIGR00993', NULL, '3a0901s04IAP86: chloroplast protein import component Toc86/159, G and M domains', 763, NULL, 'TIGR00993', 290242),
(484568, 'TIGR01992', NULL, 'PTS-IIBC-Tre: PTS system, trehalose-specific IIBC component', 463, NULL, 'TIGR01992', 290243),
(484569, 'TIGR02416', NULL, 'CO_dehy_Mo_lg: carbon-monoxide dehydrogenase, large subunit', 770, NULL, 'TIGR02416', 290244),
(484570, 'TIGR03962', NULL, 'mycofact_rSAM: mycofactocin radical SAM maturase', 339, NULL, 'TIGR03962', 290245),
(484571, 'TIGR00457', NULL, 'asnS: asparagine--tRNA ligase', 455, NULL, 'TIGR00457', 290246),
(484572, 'TIGR00873', NULL, 'gnd: 6-phosphogluconate dehydrogenase (decarboxylating)', 467, NULL, 'TIGR00873', 290247),
(484573, 'TIGR04506', NULL, 'F_threo_transal: fluorothreonine transaldolase', 609, NULL, 'TIGR04506', 290248),
(484574, 'TIGR00197', NULL, 'yjeF_nterm: YjeF family N-terminal domain', 206, NULL, 'TIGR00197', 290249);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(484575, 'TIGR03361', NULL, 'VI_Rhs_Vgr: type VI secretion system Vgr family protein', 513, NULL, 'TIGR03361', 290250),
(484576, 'TIGR03859', NULL, 'PQQ_PqqD: coenzyme PQQ biosynthesis protein PqqD', 81, NULL, 'TIGR03859', 290251),
(484577, 'TIGR02427', NULL, 'protocat_pcaD: 3-oxoadipate enol-lactonase', 251, NULL, 'TIGR02427', 290252),
(484578, 'TIGR01157', NULL, 'pufL: photosynthetic reaction center L subunit', 239, NULL, 'TIGR01157', 290253),
(484579, 'TIGR01400', NULL, 'fliR: flagellar biosynthetic protein FliR', 245, NULL, 'TIGR01400', 290254),
(484580, 'TIGR01456', NULL, 'CECR5: HAD hydrolase, TIGR01456 family', 321, NULL, 'TIGR01456', 290255),
(484581, 'TIGR01397', NULL, 'fliM_switch: flagellar motor switch protein FliM', 320, NULL, 'TIGR01397', 290256),
(484582, 'TIGR03247', NULL, 'glucar-dehydr: glucarate dehydratase', 441, NULL, 'TIGR03247', 290257),
(484583, 'TIGR00759', NULL, 'aceE: pyruvate dehydrogenase (acetyl-transferring), homodimeric type', 885, NULL, 'TIGR00759', 290258),
(484584, 'TIGR01216', NULL, 'ATP_synt_epsi: ATP synthase F1, epsilon subunit', 130, NULL, 'TIGR01216', 290259),
(484585, 'TIGR04025', NULL, 'PPOX_FMN_DR2398: pyridoxamine 5''-phosphate oxidase, FMN-binding family', 197, NULL, 'TIGR04025', 290260),
(484586, 'TIGR03054', NULL, 'photo_alph_chp1: putative photosynthetic complex assembly protein', 135, NULL, 'TIGR03054', 290261),
(484587, 'TIGR02770', NULL, 'nickel_nikD: nickel import ATP-binding protein NikD', 230, NULL, 'TIGR02770', 290262),
(484588, 'TIGR03306', NULL, 'altF1_A: alternate F1F0 ATPase, F0 subunit A', 217, NULL, 'TIGR03306', 290263),
(484589, 'TIGR00337', NULL, 'PyrG: CTP synthase', 526, NULL, 'TIGR00337', 290264),
(484590, 'TIGR00566', NULL, 'trpG_papA: glutamine amidotransferase of anthranilate synthase or aminodeoxychorismate synthase', 192, NULL, 'TIGR00566', 290265),
(484591, 'TIGR02368', NULL, 'dimeth_PyL: dimethylamine:corrinoid methyltransferase', 466, NULL, 'TIGR02368', 290266),
(484592, 'TIGR04497', NULL, 'GRASP_targ_2: putative ATP-grasp target RiPP', 50, NULL, 'TIGR04497', 290267),
(484593, 'TIGR02656', NULL, 'cyanin_plasto: plastocyanin', 99, NULL, 'TIGR02656', 290268),
(484594, 'TIGR01213', NULL, 'pseudo_Pus10arc: tRNA pseudouridine(54/55) synthase', 387, NULL, 'TIGR01213', 290269),
(484595, 'TIGR00625', NULL, 'tfb2: transcription factor Tfb2', 448, NULL, 'TIGR00625', 290270),
(484596, 'TIGR01763', NULL, 'MalateDH_bact: malate dehydrogenase, NAD-dependent', 305, NULL, 'TIGR01763', 290271),
(484597, 'TIGR02248', NULL, 'mutH_TIGR: DNA mismatch repair endonuclease MutH', 217, NULL, 'TIGR02248', 290272),
(484598, 'TIGR04388', NULL, 'Lepto_longest: putative large structural protein', 1693, NULL, 'TIGR04388', 290273),
(484599, 'TIGR00261', NULL, 'traB: TraB family protein', 380, NULL, 'TIGR00261', 290274),
(484600, 'TIGR03233', NULL, 'DNA_S_dndB: DNA sulfur modification protein DndB', 355, NULL, 'TIGR03233', 290275),
(484601, 'TIGR04218', NULL, 'TOMM_plantaz: ribosomal natural product, plantazolicin-class', 43, NULL, 'TIGR04218', 290276),
(484602, 'TIGR01520', NULL, 'FruBisAldo_II_A: fructose-bisphosphate aldolase, class II', 357, NULL, 'TIGR01520', 290277),
(484603, 'TIGR01690', NULL, 'ICE_RAQPRD: integrative conjugative element protein, RAQPRD family', 96, NULL, 'TIGR01690', 290278),
(484604, 'TIGR02902', NULL, 'spore_lonB: ATP-dependent protease LonB', 531, NULL, 'TIGR02902', 290279),
(484605, 'TIGR01263', NULL, '4HPPD: 4-hydroxyphenylpyruvate dioxygenase', 353, NULL, 'TIGR01263', 290280),
(484606, 'TIGR00639', NULL, 'PurN: phosphoribosylglycinamide formyltransferase', 192, NULL, 'TIGR00639', 290281),
(484607, 'TIGR04145', NULL, 'Firmicu_CTERM: Firmicu-CTERM domain', 45, NULL, 'TIGR04145', 290282),
(484608, 'TIGR03507', NULL, 'decahem_SO1788: decaheme c-type cytochrome, OmcA/MtrC family', 672, NULL, 'TIGR03507', 290283),
(484609, 'TIGR04447', NULL, 'PatC_TenC_TruC: cyanobactin cluster PatC/TenC/TruC protein', 34, NULL, 'TIGR04447', 290284),
(484610, 'TIGR01107', NULL, 'Na_K_ATPase_bet: Na+/K+ ATPase, beta subunit', 290, NULL, 'TIGR01107', 290285);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(484611, 'TIGR02307', NULL, 'RNA_lig_RNL2: RNA ligase, Rnl2 family', 326, NULL, 'TIGR02307', 290286),
(484612, 'TIGR02477', NULL, 'PFKA_PPi: diphosphate--fructose-6-phosphate 1-phosphotransferase', 539, NULL, 'TIGR02477', 290287),
(484613, 'TIGR03979', NULL, 'His_Ser_Rich: His-Xaa-Ser repeat protein HxsA', 190, NULL, 'TIGR03979', 290288),
(484614, 'TIGR02720', NULL, 'pyruv_oxi_spxB: pyruvate oxidase', 575, NULL, 'TIGR02720', 290289),
(484615, 'TIGR00077', NULL, 'lspA: signal peptidase II', 164, NULL, 'TIGR00077', 290290),
(484616, 'TIGR02609', NULL, 'doc_partner: putative addiction module antidote', 74, NULL, 'TIGR02609', 290291),
(484617, 'TIGR02536', NULL, 'eut_hyp: ethanolamine utilization protein', 207, NULL, 'TIGR02536', 290292),
(484618, 'TIGR03174', NULL, 'cas_Csc3: CRISPR type I-D/CYANO-associated protein Csc3/Cas10d', 946, NULL, 'TIGR03174', 290293),
(484619, 'TIGR03540', NULL, 'DapC_direct: LL-diaminopimelate aminotransferase', 383, NULL, 'TIGR03540', 290294),
(484620, 'TIGR04204', NULL, 'MAST_ArtA_sort: MAST domain', 183, NULL, 'TIGR04204', 290295),
(484621, 'TIGR01277', NULL, 'thiQ: thiamine ABC transporter, ATP-binding protein', 213, NULL, 'TIGR01277', 290296),
(484622, 'TIGR01048', NULL, 'lysA: diaminopimelate decarboxylase', 417, NULL, 'TIGR01048', 290297),
(484623, 'TIGR02779', NULL, 'NHEJ_ligase_lig: DNA ligase D, ligase domain', 302, NULL, 'TIGR02779', 290298),
(484624, 'TIGR01336', NULL, 'psaB: photosystem I core protein PsaB', 734, NULL, 'TIGR01336', 290299),
(484625, 'TIGR03809', NULL, 'TIGR03809: TIGR03809 family protein', 172, NULL, 'TIGR03809', 290300),
(484626, 'TIGR01341', NULL, 'aconitase_1: aconitate hydratase 1', 876, NULL, 'TIGR01341', 290301),
(484627, 'TIGR02273', NULL, '16S_RimM: 16S rRNA processing protein RimM', 166, NULL, 'TIGR02273', 290302),
(484628, 'TIGR00823', NULL, 'EIIA-LAC: PTS system, lactose-specific IIa component', 99, NULL, 'TIGR00823', 290303),
(484629, 'TIGR00943', NULL, '2a6301s02: monovalent cation:proton antiporter', 107, NULL, 'TIGR00943', 290304),
(484630, 'TIGR01358', NULL, 'DAHP_synth_II: 3-deoxy-7-phosphoheptulonate synthase', 443, NULL, 'TIGR01358', 290305),
(484631, 'TIGR02033', NULL, 'D-hydantoinase: dihydropyrimidinase', 454, NULL, 'TIGR02033', 290306),
(484632, 'TIGR01238', NULL, 'D1pyr5carbox3: delta-1-pyrroline-5-carboxylate dehydrogenase', 500, NULL, 'TIGR01238', 290307),
(484633, 'TIGR02153', NULL, 'gatD_arch: glutamyl-tRNA(Gln) amidotransferase, subunit D', 405, NULL, 'TIGR02153', 290308),
(484634, 'TIGR02913', NULL, 'HAF_rpt: probable extracellular repeat, HAF family', 39, NULL, 'TIGR02913', 290309),
(484635, 'TIGR01118', NULL, 'lacA: galactose-6-phosphate isomerase, LacA subunit', 141, NULL, 'TIGR01118', 290310),
(484636, 'TIGR04123', NULL, 'P_estr_lig_assc: metallophosphoesterase, DNA ligase-associated', 207, NULL, 'TIGR04123', 290311),
(484637, 'TIGR03328', NULL, 'salvage_mtnB: methylthioribulose-1-phosphate dehydratase', 194, NULL, 'TIGR03328', 290312),
(484638, 'TIGR04039', NULL, 'MXAN_0977_Heme2: di-heme enzyme, MXAN_0977 family', 336, NULL, 'TIGR04039', 290313),
(484639, 'TIGR04363', NULL, 'LD_lanti_pre: FxLD family lantipeptide', 37, NULL, 'TIGR04363', 290314),
(484640, 'TIGR02189', NULL, 'GlrX-like_plant: glutaredoxin-like family', 99, NULL, 'TIGR02189', 290315),
(484641, 'TIGR00750', NULL, 'lao: LAO/AO transport system ATPase', 300, NULL, 'TIGR00750', 290316),
(484642, 'TIGR03918', NULL, 'GTP_HydF: [FeFe] hydrogenase H-cluster maturation GTPase HydF', 392, NULL, 'TIGR03918', 290317),
(484643, 'TIGR00099', NULL, 'Cof-subfamily: Cof-like hydrolase', 256, NULL, 'TIGR00099', 290318),
(484644, 'TIGR01579', NULL, 'MiaB-like-C: MiaB-like tRNA modifying enzyme', 416, NULL, 'TIGR01579', 290319),
(484645, 'TIGR03864', NULL, 'PQQ_ABC_ATP: ABC transporter, ATP-binding subunit, PQQ-dependent alcohol dehydrogenase system', 236, NULL, 'TIGR03864', 290320),
(484646, 'TIGR01699', NULL, 'XAPA: xanthosine phosphorylase', 248, NULL, 'TIGR01699', 290321),
(484647, 'TIGR02069', NULL, 'cyanophycinase: cyanophycinase', 250, NULL, 'TIGR02069', 290322);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(484648, 'TIGR03744', NULL, 'traC_PFL_4706: conjugative transfer ATPase, PFL_4706 family', 892, NULL, 'TIGR03744', 290323),
(484649, 'TIGR04003', NULL, 'rSAM_BssD: [benzylsuccinate synthase]-activating enzyme', 314, NULL, 'TIGR04003', 290324),
(484650, 'TIGR01774', NULL, 'PFL2-3: glycyl radical enzyme, PFL2/glycerol dehydratase family', 786, NULL, 'TIGR01774', 290325),
(484651, 'TIGR03448', NULL, 'mycothiol_MshD: mycothiol synthase', 294, NULL, 'TIGR03448', 290326),
(484652, 'TIGR03669', NULL, 'urea_ABC_arch: urea ABC transporter, substrate-binding protein', 375, NULL, 'TIGR03669', 290327),
(484653, 'TIGR01828', NULL, 'pyru_phos_dikin: pyruvate, phosphate dikinase', 865, NULL, 'TIGR01828', 290328),
(484654, 'TIGR00988', NULL, 'hip: integration host factor, beta subunit', 94, NULL, 'TIGR00988', 290329),
(484655, 'TIGR01894', NULL, 'cas_TM1795_cmr1: CRISPR type III-B/RAMP module RAMP protein Cmr1', 167, NULL, 'TIGR01894', 290330),
(484656, 'TIGR02659', NULL, 'TTQ_MADH_Lt: methylamine dehydrogenase (amicyanin) light chain', 186, NULL, 'TIGR02659', 290331),
(484657, 'TIGR00569', NULL, 'ccl1: cyclin ccl1', 305, NULL, 'TIGR00569', 290332),
(484658, 'TIGR01266', NULL, 'fum_ac_acetase: fumarylacetoacetase', 420, NULL, 'TIGR01266', 290333),
(484659, 'TIGR01708', NULL, 'typeII_sec_gspH: type II secretion system protein H', 149, NULL, 'TIGR01708', 290334),
(484660, 'TIGR03208', NULL, 'cyc_hxne_CoA_lg: cyclohexanecarboxylate-CoA ligase', 538, NULL, 'TIGR03208', 290335),
(484661, 'TIGR02600', NULL, 'Verru_Chthon_A: Verru_Chthon cassette protein A', 1296, NULL, 'TIGR02600', 290336),
(484662, 'TIGR00183', NULL, 'prok_nadp_idh: isocitrate dehydrogenase, NADP-dependent', 417, NULL, 'TIGR00183', 290337),
(484663, 'TIGR03984', NULL, 'TIGR03984: CRISPR-associated protein, TIGR03984 family', 152, NULL, 'TIGR03984', 290338),
(484664, 'TIGR00510', NULL, 'lipA: lipoyl synthase', 302, NULL, 'TIGR00510', 290339),
(484665, 'TIGR03113', NULL, 'exosortase_2: exosortase B', 268, NULL, 'TIGR03113', 290340),
(484666, 'TIGR00435', NULL, 'cysS: cysteine--tRNA ligase', 466, NULL, 'TIGR00435', 290341),
(484667, 'TIGR01143', NULL, 'murF: UDP-N-acetylmuramoyl-tripeptide--D-alanyl-D-alanine ligase', 418, NULL, 'TIGR01143', 290342),
(484668, 'TIGR01903', NULL, 'cas5_csm4: CRISPR type III-A/MTUBE-associated RAMP protein Csm4', 302, NULL, 'TIGR01903', 290343),
(484669, 'TIGR02645', NULL, 'ARCH_P_rylase: putative thymidine phosphorylase', 493, NULL, 'TIGR02645', 290344),
(484670, 'TIGR00315', NULL, 'cdhB: CO dehydrogenase/acetyl-CoA synthase complex, epsilon subunit', 162, NULL, 'TIGR00315', 290345),
(484671, 'TIGR02525', NULL, 'plasmid_TraJ: plasmid transfer ATPase TraJ', 372, NULL, 'TIGR02525', 290346),
(484672, 'TIGR02591', NULL, 'cas_Csh1: CRISPR-associated protein Cas8b/Csh1, subtype I-B/HMARI', 395, NULL, 'TIGR02591', 290347),
(484673, 'TIGR02715', NULL, 'amido_AtzE: amidohydrolase, AtzE family', 452, NULL, 'TIGR02715', 290348),
(484674, 'TIGR02351', NULL, 'thiH: thiazole biosynthesis protein ThiH', 366, NULL, 'TIGR02351', 290349),
(484675, 'TIGR04561', NULL, 'membra_charge: integral membrane protein', 82, NULL, 'TIGR04561', 290350),
(484676, 'TIGR00002', NULL, 'S16: ribosomal protein bS16', 78, NULL, 'TIGR00002', 290351),
(484677, 'TIGR01386', NULL, 'cztS_silS_copS: heavy metal sensor kinase', 457, NULL, 'TIGR01386', 290352),
(484678, 'TIGR00675', NULL, 'dcm: DNA (cytosine-5-)-methyltransferase', 329, NULL, 'TIGR00675', 290353),
(484679, 'TIGR03492', NULL, 'TIGR03492: conserved hypothetical protein', 396, NULL, 'TIGR03492', 290354),
(484680, 'TIGR00971', NULL, '3a0106s03: sulfate ABC transporter, sulfate-binding protein', 315, NULL, 'TIGR00971', 290355),
(484681, 'TIGR04377', NULL, 'myo_inos_iolD: 3,5/4-trihydroxycyclohexa-1,2-dione hydrolase', 616, NULL, 'TIGR04377', 290356),
(484682, 'TIGR00407', NULL, 'proA: glutamate-5-semialdehyde dehydrogenase', 398, NULL, 'TIGR00407', 290357),
(484683, 'TIGR03904', NULL, 'SAM_YgiQ: uncharacterized radical SAM protein YgiQ', 558, NULL, 'TIGR03904', 290358),
(484684, 'TIGR01654', NULL, 'bact_immun_7tm: bacteriocin-associated integral membrane protein', 681, NULL, 'TIGR01654', 290359);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(484685, 'TIGR01948', NULL, 'rnfE: electron transport complex, RnfABCDGE type, E subunit', 196, NULL, 'TIGR01948', 290360),
(484686, 'TIGR02167', NULL, 'Liste_lipo_26: bacterial surface protein 26-residue repeat', 26, NULL, 'TIGR02167', 290361),
(484687, 'TIGR02396', NULL, 'diverge_rpsU: rpsU-divergently transcribed protein', 186, NULL, 'TIGR02396', 290362),
(484688, 'TIGR03412', NULL, 'iscX_yfhJ: FeS assembly protein IscX', 63, NULL, 'TIGR03412', 290363),
(484689, 'TIGR00957', NULL, 'MRP_assoc_pro: multi drug resistance-associated protein (MRP)', 1522, NULL, 'TIGR00957', 290364),
(484690, 'TIGR00630', NULL, 'uvra: excinuclease ABC subunit A', 924, NULL, 'TIGR00630', 290365),
(484691, 'TIGR03426', NULL, 'shape_MreD: rod shape-determining protein MreD', 154, NULL, 'TIGR03426', 290366),
(484692, 'TIGR04338', NULL, 'HEXXH_Rv0185: putative metallohydrolase, TIGR04338 family', 161, NULL, 'TIGR04338', 290367),
(484693, 'TIGR01640', NULL, 'F_box_assoc_1: F-box protein interaction domain', 232, NULL, 'TIGR01640', 290368),
(484694, 'TIGR02402', NULL, 'trehalose_TreZ: malto-oligosyltrehalose trehalohydrolase', 545, NULL, 'TIGR02402', 290369),
(484695, 'TIGR00381', NULL, 'cdhD: CO dehydrogenase/acetyl-CoA synthase, delta subunit', 389, NULL, 'TIGR00381', 290370),
(484696, 'TIGR02055', NULL, 'APS_reductase: adenylylsulfate reductase, thioredoxin dependent', 194, NULL, 'TIGR02055', 290371),
(484697, 'TIGR03079', NULL, 'CH4_NH3mon_ox_B: methane monooxygenase/ammonia monooxygenase, subunit B', 399, NULL, 'TIGR03079', 290372),
(484698, 'TIGR01411', NULL, 'tatAE: twin arginine-targeting protein translocase, TatA/E family', 47, NULL, 'TIGR01411', 290373),
(484699, 'TIGR00689', NULL, 'rpiB_lacA_lacB: sugar-phosphate isomerase, RpiB/LacA/LacB family', 145, NULL, 'TIGR00689', 290374),
(484700, 'TIGR01531', NULL, 'glyc_debranch: glycogen debranching enzyme', 1443, NULL, 'TIGR01531', 290375),
(484701, 'TIGR03775', NULL, 'RPE3: rickettsial palindromic element RPE3 domain', 43, NULL, 'TIGR03775', 290376),
(484702, 'TIGR01651', NULL, 'CobT: cobaltochelatase, CobT subunit', 600, NULL, 'TIGR01651', 290377),
(484703, 'TIGR03621', NULL, 'F420_MSMEG_2516: probable F420-dependent oxidoreductase, MSMEG_2516 family', 295, NULL, 'TIGR03621', 290378),
(484704, 'TIGR00753', NULL, 'undec_PP_bacA: undecaprenyl-diphosphatase UppP', 255, NULL, 'TIGR00753', 290379),
(484705, 'TIGR04229', NULL, 'geopeptide: putative radical SAM-modified peptide', 22, NULL, 'TIGR04229', 290380),
(484706, 'TIGR01104', NULL, 'V_PPase: V-type H(+)-translocating pyrophosphatase', 697, NULL, 'TIGR01104', 290381),
(484707, 'TIGR02259', NULL, 'benz_CoA_red_A: benzoyl-CoA reductase, subunit A', 432, NULL, 'TIGR02259', 290382),
(484708, 'TIGR00326', NULL, 'eubact_ribD: riboflavin biosynthesis protein RibD', 343, NULL, 'TIGR00326', 290383),
(484709, 'TIGR00272', NULL, 'DPH2: diphthamide biosynthesis protein 2', 497, NULL, 'TIGR00272', 290384),
(484710, 'TIGR02287', NULL, 'PaaY: phenylacetic acid degradation protein PaaY', 192, NULL, 'TIGR02287', 290385),
(484711, 'TIGR04349', NULL, 'rSAM_QueE_gams: putative 7-cyano-7-deazaguanosine (preQ0) biosynthesis protein QueE', 210, NULL, 'TIGR04349', 290386),
(484712, 'TIGR01132', NULL, 'pgm: phosphoglucomutase, alpha-D-glucose phosphate-specific', 546, NULL, 'TIGR01132', 290387),
(484713, 'TIGR02362', NULL, 'dhaK1b: probable dihydroxyacetone kinase DhaK1b subunit', 326, NULL, 'TIGR02362', 290388),
(484714, 'TIGR03119', NULL, 'one_C_fhcD: formylmethanofuran--tetrahydromethanopterin N-formyltransferase', 288, NULL, 'TIGR03119', 290389),
(484715, 'TIGR01705', NULL, 'MTA/SAH-nuc-hyp: putative 5''-methylthioadenosine/S-adenosylhomocysteine nucleosidase', 212, NULL, 'TIGR01705', 290390),
(484716, 'TIGR00798', NULL, 'mtc: tricarboxylate carrier', 317, NULL, 'TIGR00798', 290391),
(484717, 'TIGR02849', NULL, 'spore_III_AD: stage III sporulation protein AD', 101, NULL, 'TIGR02849', 290392),
(484718, 'TIGR03610', NULL, 'RutC: pyrimidine utilization protein C', 127, NULL, 'TIGR03610', 290393),
(484719, 'TIGR00019', NULL, 'prfA: peptide chain release factor 1', 361, NULL, 'TIGR00019', 290394);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(484720, 'TIGR00678', NULL, 'holB: DNA polymerase III, delta'' subunit', 188, NULL, 'TIGR00678', 290395),
(484721, 'TIGR03850', NULL, 'bind_CPR_0540: carbohydrate ABC transporter substrate-binding protein, CPR_0540 family', 437, NULL, 'TIGR03850', 290396),
(484722, 'TIGR00392', NULL, 'ileS: isoleucine--tRNA ligase', 861, NULL, 'TIGR00392', 290397),
(484723, 'TIGR01760', NULL, 'tape_meas_TP901: phage tail tape measure protein, TP901 family, core region', 349, NULL, 'TIGR01760', 290398),
(484724, 'TIGR04366', NULL, 'cupin_WbuC: cupin fold metalloprotein, WbuC family', 132, NULL, 'TIGR04366', 290399),
(484725, 'TIGR01252', NULL, 'acetolac_decarb: alpha-acetolactate decarboxylase', 232, NULL, 'TIGR01252', 290400),
(484726, 'TIGR00982', NULL, 'uS12_E_A: ribosomal protein uS12', 139, NULL, 'TIGR00982', 290401),
(484727, 'TIGR00206', NULL, 'fliF: flagellar M-ring protein FliF', 555, NULL, 'TIGR00206', 290402),
(484728, 'TIGR04458', NULL, 'CYP450_TxtE: 4-nitrotryptophan synthase', 403, NULL, 'TIGR04458', 290403),
(484729, 'TIGR03303', NULL, 'OM_YaeT: outer membrane protein assembly complex, YaeT protein', 741, NULL, 'TIGR03303', 290404),
(484730, 'TIGR04441', NULL, 'lept_O_ant_chp1: surface carbohydrate biosynthesis protein', 373, NULL, 'TIGR04441', 290405),
(484731, 'TIGR02471', NULL, 'sucr_syn_bact_C: sucrose-phosphate synthase, sucrose phosphatase-like domain', 236, NULL, 'TIGR02471', 290406),
(484732, 'TIGR01023', NULL, 'rpmG_bact: ribosomal protein bL33', 56, NULL, 'TIGR01023', 290407),
(484733, 'TIGR03907', NULL, 'QH_beta: quinohemoprotein amine dehydrogenase, beta subunit', 338, NULL, 'TIGR03907', 290408),
(484734, 'TIGR01937', NULL, 'nqrB: NADH:ubiquinone oxidoreductase, Na(+)-translocating, B subunit', 413, NULL, 'TIGR01937', 290409),
(484735, 'TIGR02058', NULL, 'lin0512_fam: conserved hypothetical protein', 117, NULL, 'TIGR02058', 290410),
(484736, 'TIGR02405', NULL, 'trehalos_R_Ecol: trehalose operon repressor', 311, NULL, 'TIGR02405', 290411),
(484737, 'TIGR00555', NULL, 'panK_eukar: pantothenate kinase', 304, NULL, 'TIGR00555', 290412),
(484738, 'TIGR03973', NULL, 'six_Cys_in_45: six-cysteine peptide SCIFF', 43, NULL, 'TIGR03973', 290413),
(484739, 'TIGR01009', NULL, 'rpsC_bact: ribosomal protein uS3', 212, NULL, 'TIGR01009', 290414),
(484740, 'TIGR04080', NULL, 'rSAM_pep_cyc: KxxxW cyclic peptide radical SAM maturase', 440, NULL, 'TIGR04080', 290415),
(484741, 'TIGR02044', NULL, 'CueR: Cu(I)-responsive transcriptional regulator', 127, NULL, 'TIGR02044', 290416),
(484742, 'TIGR02804', NULL, 'ExbD_2: TonB system transport protein ExbD', 121, NULL, 'TIGR02804', 290417),
(484743, 'TIGR02164', NULL, 'torA: trimethylamine-N-oxide reductase TorA', 824, NULL, 'TIGR02164', 290418),
(484744, 'TIGR03199', NULL, 'pucC: xanthine dehydrogenase C subunit', 264, NULL, 'TIGR03199', 290419),
(484745, 'TIGR03666', NULL, 'Rv2061_F420: PPOX class probable F420-dependent enzyme, Rv2061 family', 132, NULL, 'TIGR03666', 290420),
(484746, 'TIGR02511', NULL, 'type_III_tyeA: type III secretion effector delivery regulator, TyeA family', 82, NULL, 'TIGR02511', 290421),
(484747, 'TIGR03546', NULL, 'TIGR03546: TIGR03546 family protein', 154, NULL, 'TIGR03546', 290422),
(484748, 'TIGR03317', NULL, 'ygfZ_signature: folate-binding protein YgfZ', 67, NULL, 'TIGR03317', 290423),
(484749, 'TIGR03102', NULL, 'halo_cynanin: halocyanin domain', 115, NULL, 'TIGR03102', 290424),
(484750, 'TIGR04000', NULL, 'thiol_BshB2: bacillithiol biosynthesis deacetylase BshB2', 217, NULL, 'TIGR04000', 290425),
(484751, 'TIGR04257', NULL, 'nanowire_3heme: c(7)-type cytochrome triheme domain', 75, NULL, 'TIGR04257', 290426),
(484752, 'TIGR01545', NULL, 'YfhB_g-proteo: HAD hydrolase, family IF', 210, NULL, 'TIGR01545', 290427),
(484753, 'TIGR03789', NULL, 'pdsO: proteobacterial sortase system peptidoglycan-associated protein', 243, NULL, 'TIGR03789', 290428),
(484754, 'TIGR04472', NULL, 'reg_rSAM_mob: mobile rSAM pair MarR family regulator', 141, NULL, 'TIGR04472', 290429),
(484755, 'TIGR02242', NULL, 'tail_TIGR02242: phage tail protein domain', 131, NULL, 'TIGR02242', 290430);     
INSERT INTO "PUBLIC"."MODEL" VALUES
(484756, 'TIGR04486', NULL, 'thiosulf_SoxB: thiosulfohydrolase SoxB', 556, NULL, 'TIGR04486', 290431),
(484757, 'TIGR01814', NULL, 'kynureninase: kynureninase', 400, NULL, 'TIGR01814', 290432),
(484758, 'TIGR00862', NULL, 'O-ClC: intracellular chloride channel protein', 236, NULL, 'TIGR00862', 290433),
(484759, 'TIGR02969', NULL, 'mam_aldehyde_ox: aldehyde oxidase', 1330, NULL, 'TIGR02969', 290434),
(484760, 'TIGR00954', NULL, '3a01203: peroxysomal long chain fatty acyl transporter', 660, NULL, 'TIGR00954', 290435),
(484761, 'TIGR03501', NULL, 'GlyGly_CTERM: GlyGly-CTERM domain', 22, NULL, 'TIGR03501', 290436),
(484762, 'TIGR03730', NULL, 'tungstate_WtpA: tungstate ABC transporter binding protein WtpA', 275, NULL, 'TIGR03730', 290437),
(484763, 'TIGR04014', NULL, 'B12_SAM_MJ_0865: B12-binding domain/radical SAM domain protein, MJ_0865 family', 434, NULL, 'TIGR04014', 290438),
(484764, 'TIGR04243', NULL, 'nodulat_NodB: chitooligosaccharide deacetylase NodB', 197, NULL, 'TIGR04243', 290439),
(484765, 'TIGR00312', NULL, 'cbiD: cobalamin biosynthesis protein CbiD', 347, NULL, 'TIGR00312', 290440),
(484766, 'TIGR01467', NULL, 'cobI_cbiL: precorrin-2 C(20)-methyltransferase', 230, NULL, 'TIGR01467', 290441),
(484767, 'TIGR01978', NULL, 'sufC: FeS assembly ATPase SufC', 243, NULL, 'TIGR01978', 290442),
(484768, 'TIGR01601', NULL, 'PYST-C1: Plasmodium yoelii subtelomeric domain PYST-C1', 82, NULL, 'TIGR01601', 290443),
(484769, 'TIGR03465', NULL, 'HpnD: squalene synthase HpnD', 267, NULL, 'TIGR03465', 290444),
(484770, 'TIGR00857', NULL, 'pyrC_multi: dihydroorotase, multifunctional complex type', 412, NULL, 'TIGR00857', 290445),
(484771, 'TIGR02947', NULL, 'SigH_actino: RNA polymerase sigma-70 factor, TIGR02947 family', 193, NULL, 'TIGR02947', 290446),
(484772, 'TIGR00544', NULL, 'lgt: prolipoprotein diacylglyceryl transferase', 280, NULL, 'TIGR00544', 290447),
(484773, 'TIGR02634', NULL, 'xylF: D-xylose ABC transporter, D-xylose-binding protein', 302, NULL, 'TIGR02634', 290448),
(484774, 'TIGR03392', NULL, 'FeS_syn_CsdA: cysteine desulfurase, catalytic subunit CsdA', 398, NULL, 'TIGR03392', 290449),
(484775, 'TIGR02552', NULL, 'LcrH_SycD: type III secretion low calcium response chaperone LcrH/SycD', 136, NULL, 'TIGR02552', 290450),
(484776, 'TIGR00462', NULL, 'genX: EF-P lysine aminoacylase GenX', 304, NULL, 'TIGR00462', 290451),
(484777, 'TIGR03263', NULL, 'guanyl_kin: guanylate kinase', 180, NULL, 'TIGR03263', 290452),
(484778, 'TIGR00111', NULL, 'pelota: mRNA surveillance protein pelota', 351, NULL, 'TIGR00111', 290453),
(484779, 'TIGR02865', NULL, 'spore_II_E: stage II sporulation protein E', 764, NULL, 'TIGR02865', 290454),
(484780, 'TIGR03152', NULL, 'cyto_c552_HCOOH: formate-dependent cytochrome c nitrite reductase, c552 subunit', 441, NULL, 'TIGR03152', 290455),
(484781, 'TIGR01472', NULL, 'gmd: GDP-mannose 4,6-dehydratase', 342, NULL, 'TIGR01472', 290456),
(484782, 'TIGR01923', NULL, 'menE: O-succinylbenzoate-CoA ligase', 442, NULL, 'TIGR01923', 290457),
(484783, 'TIGR02142', NULL, 'modC_ABC: molybdate ABC transporter, ATP-binding protein', 353, NULL, 'TIGR02142', 290458),
(484784, 'TIGR02201', NULL, 'heptsyl_trn_III: putative lipopolysaccharide heptosyltransferase III', 344, NULL, 'TIGR02201', 290459),
(484785, 'TIGR01062', NULL, 'parC_Gneg: DNA topoisomerase IV, A subunit', 735, NULL, 'TIGR01062', 290460),
(484786, 'TIGR03562', NULL, 'osmo_induc_OsmC: peroxiredoxin, OsmC subfamily', 137, NULL, 'TIGR03562', 290461),
(484787, 'TIGR04232', NULL, 'seadorna_VP3: seadornavirus VP3 protein', 731, NULL, 'TIGR04232', 290462),
(484788, 'TIGR01504', NULL, 'glyox_carbo_lig: glyoxylate carboligase', 589, NULL, 'TIGR01504', 290463),
(484789, 'TIGR03070', NULL, 'couple_hipB: transcriptional regulator, y4mF family', 58, NULL, 'TIGR03070', 290464),
(484790, 'TIGR02754', NULL, 'sod_Ni_protease: nickel-type superoxide dismutase maturation protease', 90, NULL, 'TIGR02754', 290465),
(484791, 'TIGR02312', NULL, 'HpaH: 2-oxo-hepta-3-ene-1,7-dioic acid hydratase', 267, NULL, 'TIGR02312', 290466),
(484792, 'TIGR02924', NULL, 'ICDH_alpha: isocitrate dehydrogenase', 473, NULL, 'TIGR02924', 290467);   
INSERT INTO "PUBLIC"."MODEL" VALUES
(484793, 'TIGR01914', NULL, 'cas_Csa4: CRISPR-associated protein Cas8a2/Csa4, subtype I-A/APERN', 353, NULL, 'TIGR01914', 290468),
(484794, 'TIGR00052', NULL, 'TIGR00052: nudix-type nucleoside diphosphatase, YffH/AdpP family', 188, NULL, 'TIGR00052', 290469),
(484795, 'TIGR04402', NULL, 'mob_CxxC_CxxC: mobilome CxxCx(11)CxxC protein', 186, NULL, 'TIGR04402', 290470),
(484796, 'TIGR00222', NULL, 'panB: 3-methyl-2-oxobutanoate hydroxymethyltransferase', 264, NULL, 'TIGR00222', 290471),
(484797, 'TIGR03093', NULL, 'SASP_sspL: small, acid-soluble spore protein L', 37, NULL, 'TIGR03093', 290472),
(484798, 'TIGR02455', NULL, 'TreS_stutzeri: trehalose synthase', 689, NULL, 'TIGR02455', 290473),
(484799, 'TIGR03957', NULL, 'rSAM_HmdB: 5,10-methenyltetrahydromethanopterin hydrogenase cofactor biosynthesis protein HmdB', 317, NULL, 'TIGR03957', 290474),
(484800, 'TIGR00898', NULL, '2A0119: cation transport protein', 506, NULL, 'TIGR00898', 290475),
(484801, 'TIGR03576', NULL, 'pyridox_MJ0158: pyridoxal phosphate enzyme, MJ0158 family', 346, NULL, 'TIGR03576', 290476),
(484802, 'TIGR02611', NULL, 'TIGR02611: TIGR02611 family protein', 121, NULL, 'TIGR02611', 290477),
(484803, 'TIGR03512', NULL, 'GldD_lipo: gliding motility-associated lipoprotein GldD', 186, NULL, 'TIGR03512', 290478),
(484804, 'TIGR02938', NULL, 'nifL_nitrog: nitrogen fixation negative regulator NifL', 494, NULL, 'TIGR02938', 290479),
(484805, 'TIGR00585', NULL, 'mutl: DNA mismatch repair protein MutL', 313, NULL, 'TIGR00585', 290480),
(484806, 'TIGR03322', NULL, 'alt_F1F0_F0_C: alternate F1F0 ATPase, F0 subunit C', 86, NULL, 'TIGR03322', 290481),
(484807, 'TIGR01744', NULL, 'XPRTase: xanthine phosphoribosyltransferase', 191, NULL, 'TIGR01744', 290482),
(484808, 'TIGR00775', NULL, 'NhaD: Na+/H+ antiporter, NhaD family', 420, NULL, 'TIGR00775', 290483),
(484809, 'TIGR02768', NULL, 'TraA_Ti: Ti-type conjugative transfer relaxase TraA', 751, NULL, 'TIGR02768', 290484),
(484810, 'TIGR04162', NULL, 'exo_VPEID: exosortase E/protease, VPEID-CTERM system', 516, NULL, 'TIGR04162', 290485),
(484811, 'TIGR02089', NULL, 'TTC: tartrate dehydrogenase', 352, NULL, 'TIGR02089', 290486),
(484812, 'TIGR00421', NULL, 'ubiX_pad: polyprenyl P-hydroxybenzoate and phenylacrylic acid decarboxylases', 181, NULL, 'TIGR00421', 290487),
(484813, 'TIGR00714', NULL, 'hscB: Fe-S protein assembly co-chaperone HscB', 156, NULL, 'TIGR00714', 290488),
(484814, 'TIGR00904', NULL, 'mreB: cell shape determining protein, MreB/Mrl family', 334, NULL, 'TIGR00904', 290489),
(484815, 'TIGR01129', NULL, 'secD: protein-export membrane protein SecD', 397, NULL, 'TIGR01129', 290490),
(484816, 'TIGR04129', NULL, 'CxxH_BA5709: CxxH/CxxC protein, BA_5709 family', 49, NULL, 'TIGR04129', 290491),
(484817, 'TIGR04463', NULL, 'rSAM_vs_C_rich: radical SAM/SPASM domain protein maturase', 438, NULL, 'TIGR04463', 290492),
(484818, 'TIGR02133', NULL, 'RPI_actino: ribose 5-phosphate isomerase', 148, NULL, 'TIGR02133', 290493),
(484819, 'TIGR02625', NULL, 'YiiL_rotase: L-rhamnose mutarotase', 102, NULL, 'TIGR02625', 290494),
(484820, 'TIGR01241', NULL, 'FtsH_fam: ATP-dependent metallopeptidase HflB', 496, NULL, 'TIGR01241', 290495),
(484821, 'TIGR02441', NULL, 'fa_ox_alpha_mit: fatty acid oxidation complex, alpha subunit, mitochondrial', 737, NULL, 'TIGR02441', 290496),
(484822, 'TIGR00603', NULL, 'rad25: DNA repair helicase rad25', 734, NULL, 'TIGR00603', 290497),
(484823, 'TIGR01431', NULL, 'adm_rel: adenosine deaminase-related growth factor', 479, NULL, 'TIGR01431', 290498),
(484824, 'TIGR02933', NULL, 'nifM_nitrog: nitrogen fixation protein NifM', 256, NULL, 'TIGR02933', 290499),
(484825, 'TIGR03898', NULL, 'lanti_MRSA_kill: type 2 lantibiotic, mersacidin/lichenicidin family', 44, NULL, 'TIGR03898', 290500),
(484826, 'TIGR03635', NULL, 'uS17_bact: ribosomal protein uS17', 72, NULL, 'TIGR03635', 290501),
(484827, 'TIGR04273', NULL, 'Y_sulf_Ax21: sulfation-dependent quorum factor, Ax21 family', 186, NULL, 'TIGR04273', 290502),
(484828, 'TIGR01785', NULL, 'TonB-hemin: TonB-dependent heme/hemoglobin receptor family protein', 677, NULL, 'TIGR01785', 290503);          
INSERT INTO "PUBLIC"."MODEL" VALUES
(484829, 'TIGR02382', NULL, 'wecD_rffC: TDP-D-fucosamine acetyltransferase', 191, NULL, 'TIGR02382', 290504),
(484830, 'TIGR00093', NULL, 'TIGR00093: pseudouridine synthase', 161, NULL, 'TIGR00093', 290505),
(484831, 'TIGR00283', NULL, 'arch_pth2: peptidyl-tRNA hydrolase', 115, NULL, 'TIGR00283', 290506),
(484832, 'TIGR00119', NULL, 'acolac_sm: acetolactate synthase, small subunit', 158, NULL, 'TIGR00119', 290507),
(484833, 'TIGR03884', NULL, 'sel_bind_Methan: selenium-binding protein', 74, NULL, 'TIGR03884', 290508),
(484834, 'TIGR02566', NULL, 'cas_Csy3: CRISPR type I-F/YPEST-associated protein Csy3', 341, NULL, 'TIGR02566', 290509),
(484835, 'TIGR04109', NULL, 'heme_ox_HugZ: heme oxygenase, HugZ family', 243, NULL, 'TIGR04109', 290510),
(484836, 'TIGR00476', NULL, 'selD: selenide, water dikinase', 311, NULL, 'TIGR00476', 290511),
(484837, 'TIGR00807', NULL, 'malonate_madL: malonate transporter, MadL subunit', 125, NULL, 'TIGR00807', 290512),
(484838, 'TIGR01928', NULL, 'menC_lowGC/arch: o-succinylbenzoate synthase', 325, NULL, 'TIGR01928', 290513),
(484839, 'TIGR01445', NULL, 'intein_Nterm: intein N-terminal splicing region', 83, NULL, 'TIGR01445', 290514),
(484840, 'TIGR03998', NULL, 'thiol_BshC: bacillithiol biosynthesis cysteine-adding enzyme BshC', 529, NULL, 'TIGR03998', 290515),
(484841, 'TIGR04053', NULL, 'sam_11: radical SAM protein, BA_1875 family', 366, NULL, 'TIGR04053', 290516),
(484842, 'TIGR00530', NULL, 'AGP_acyltrn: 1-acylglycerol-3-phosphate O-acyltransferases', 130, NULL, 'TIGR00530', 290517),
(484843, 'TIGR03084', NULL, 'TIGR03084: TIGR03084 family protein', 253, NULL, 'TIGR03084', 290518),
(484844, 'TIGR01685', NULL, 'MDP-1: magnesium-dependent phosphatase-1', 174, NULL, 'TIGR01685', 290519),
(484845, 'TIGR03535', NULL, 'DapD_actino: 2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-succinyltransferase', 320, NULL, 'TIGR03535', 290520),
(484846, 'TIGR04332', NULL, 'gamma_Glu_sys: poly-gamma-glutamate system protein', 307, NULL, 'TIGR04332', 290521),
(484847, 'TIGR00169', NULL, 'leuB: 3-isopropylmalate dehydrogenase', 349, NULL, 'TIGR00169', 290522),
(484848, 'TIGR01029', NULL, 'rpsG_bact: ribosomal protein uS7', 154, NULL, 'TIGR01029', 290523),
(484849, 'TIGR01615', NULL, 'A_thal_3542: uncharacterized plant-specific domain TIGR01615', 131, NULL, 'TIGR01615', 290524),
(484850, 'TIGR01050', NULL, 'rpsS_bact: ribosomal protein uS19', 92, NULL, 'TIGR01050', 290525),
(484851, 'TIGR03705', NULL, 'poly_P_kin: polyphosphate kinase 1', 673, NULL, 'TIGR03705', 290526),
(484852, 'TIGR03453', NULL, 'partition_RepA: plasmid partitioning protein RepA', 387, NULL, 'TIGR03453', 290527),
(484853, 'TIGR02675', NULL, 'tape_meas_nterm: tape measure domain', 75, NULL, 'TIGR02675', 290528),
(484854, 'TIGR02482', NULL, 'PFKA_ATP: 6-phosphofructokinase', 301, NULL, 'TIGR02482', 290529),
(484855, 'TIGR00644', NULL, 'recJ: single-stranded-DNA-specific exonuclease RecJ', 546, NULL, 'TIGR00644', 290530),
(484856, 'TIGR03644', NULL, 'marine_trans_1: probable ammonium transporter, marine subtype', 404, NULL, 'TIGR03644', 290531),
(484857, 'TIGR01799', NULL, 'CM_T: chorismate mutase', 83, NULL, 'TIGR01799', 290532),
(484858, 'TIGR00884', NULL, 'guaA_Cterm: GMP synthase (glutamine-hydrolyzing), C-terminal domain', 310, NULL, 'TIGR00884', 290533),
(484859, 'TIGR02734', NULL, 'crtI_fam: phytoene desaturase', 504, NULL, 'TIGR02734', 290534),
(484860, 'TIGR03814', NULL, 'Gln_ase: glutaminase A', 300, NULL, 'TIGR03814', 290535),
(484861, 'TIGR03889', NULL, 'nitrile_acc: nitrile hydratase accessory protein', 74, NULL, 'TIGR03889', 290536),
(484862, 'TIGR03372', NULL, 'putres_am_tran: putrescine aminotransferase', 442, NULL, 'TIGR03372', 290537),
(484863, 'TIGR04150', NULL, 'pseudo_rSAM_GG: pseudo-rSAM protein, GG-Bacteroidales system', 407, NULL, 'TIGR04150', 290538),
(484864, 'TIGR00242', NULL, 'TIGR00242: division/cell wall cluster transcriptional repressor MraZ', 144, NULL, 'TIGR00242', 290539),
(484865, 'TIGR00474', NULL, 'selA: L-seryl-tRNA(Sec) selenium transferase', 455, NULL, 'TIGR00474', 290540);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(484866, 'TIGR02564', NULL, 'cas_Csy1: CRISPR type I-F/YPEST-associated protein Csy1', 385, NULL, 'TIGR02564', 290541),
(484867, 'TIGR03342', NULL, 'dsrC_tusE_dsvC: sulfur relay protein, TusE/DsrC/DsvC family', 108, NULL, 'TIGR03342', 290542),
(484868, 'TIGR01282', NULL, 'nifD: nitrogenase molybdenum-iron protein alpha chain', 466, NULL, 'TIGR01282', 290543),
(484869, 'TIGR03228', NULL, 'anthran_1_2_A: anthranilate 1,2-dioxygenase, large subunit', 438, NULL, 'TIGR03228', 290544),
(484870, 'TIGR01308', NULL, 'rpmD_bact: ribosomal protein uL30', 55, NULL, 'TIGR01308', 290545),
(484871, 'TIGR01855', NULL, 'IMP_synth_hisH: imidazole glycerol phosphate synthase, glutamine amidotransferase subunit', 198, NULL, 'TIGR01855', 290546),
(484872, 'TIGR00412', NULL, 'redox_disulf_2: redox-active disulfide protein 2', 78, NULL, 'TIGR00412', 290547),
(484873, 'TIGR01138', NULL, 'cysM: cysteine synthase B', 290, NULL, 'TIGR01138', 290548),
(484874, 'TIGR00700', NULL, 'GABAtrnsam: 4-aminobutyrate transaminase', 420, NULL, 'TIGR00700', 290549),
(484875, 'TIGR00521', NULL, 'coaBC_dfp: phosphopantothenoylcysteine decarboxylase / phosphopantothenate--cysteine ligase', 392, NULL, 'TIGR00521', 290550),
(484876, 'TIGR02661', NULL, 'MauD: methylamine dehydrogenase accessory protein MauD', 189, NULL, 'TIGR02661', 290551),
(484877, 'TIGR01676', NULL, 'GLDHase: galactonolactone dehydrogenase', 541, NULL, 'TIGR01676', 290552),
(484878, 'TIGR04100', NULL, 'rSAM_pair_X: radical SAM enzyme, TIGR04100 family', 197, NULL, 'TIGR04100', 290553),
(484879, 'TIGR04511', NULL, 'SagB_rel_DH_2: putative peptide maturation dehydrogenase', 380, NULL, 'TIGR04511', 290554),
(484880, 'TIGR03526', NULL, 'selenium_YgeY: putative selenium metabolism hydrolase', 395, NULL, 'TIGR03526', 290555),
(484881, 'TIGR00365', NULL, 'TIGR00365: monothiol glutaredoxin, Grx4 family', 99, NULL, 'TIGR00365', 290556),
(484882, 'TIGR02387', NULL, 'rpoC1_cyan: DNA-directed RNA polymerase, gamma subunit', 619, NULL, 'TIGR02387', 290557),
(484883, 'TIGR03356', NULL, 'BGL: beta-galactosidase', 427, NULL, 'TIGR03356', 290558),
(484884, 'TIGR00292', NULL, 'TIGR00292: thiazole biosynthesis enzyme', 254, NULL, 'TIGR00292', 290559),
(484885, 'TIGR03703', NULL, 'plsB: glycerol-3-phosphate O-acyltransferase', 799, NULL, 'TIGR03703', 290560),
(484886, 'TIGR04164', NULL, 'cobo_pep: modified peptide precursor CbpA', 25, NULL, 'TIGR04164', 290561),
(484887, 'TIGR00058', NULL, 'Hemerythrin: hemerythrin family non-heme iron protein', 115, NULL, 'TIGR00058', 290562),
(484888, 'TIGR01232', NULL, 'lacD: tagatose 1,6-diphosphate aldolase', 325, NULL, 'TIGR01232', 290563),
(484889, 'TIGR03219', NULL, 'salicylate_mono: salicylate 1-monooxygenase', 414, NULL, 'TIGR03219', 290564),
(484890, 'TIGR01173', NULL, 'glmU: UDP-N-acetylglucosamine diphosphorylase/glucosamine-1-phosphate N-acetyltransferase', 452, NULL, 'TIGR01173', 290565),
(484891, 'TIGR00228', NULL, 'ruvC: crossover junction endodeoxyribonuclease RuvC', 156, NULL, 'TIGR00228', 290566),
(484892, 'TIGR00653', NULL, 'GlnA: glutamine synthetase, type I', 462, NULL, 'TIGR00653', 290567),
(484893, 'TIGR02203', NULL, 'MsbA_lipidA: lipid A export permease/ATP-binding protein MsbA', 572, NULL, 'TIGR02203', 290568),
(484894, 'TIGR01853', NULL, 'lipid_A_lpxD: UDP-3-O-[3-hydroxymyristoyl] glucosamine N-acyltransferase LpxD', 325, NULL, 'TIGR01853', 290569),
(484895, 'TIGR02491', NULL, 'NrdG: anaerobic ribonucleoside-triphosphate reductase activating protein', 154, NULL, 'TIGR02491', 290570),
(484896, 'TIGR01964', NULL, 'chpXY: CO2 hydration protein', 411, NULL, 'TIGR01964', 290571),
(484897, 'TIGR02373', NULL, 'photo_yellow: photoactive yellow protein', 124, NULL, 'TIGR02373', 290572),
(484898, 'TIGR03875', NULL, 'RNA_lig_partner: RNA ligase partner, MJ_0950 family', 206, NULL, 'TIGR03875', 290573),
(484899, 'TIGR03193', NULL, '4hydroxCoAred: 4-hydroxybenzoyl-CoA reductase, gamma subunit', 148, NULL, 'TIGR03193', 290574),
(484900, 'TIGR02824', NULL, 'quinone_pig3: putative NAD(P)H quinone oxidoreductase, PIG3 family', 325, NULL, 'TIGR02824', 290575);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(484901, 'TIGR03049', NULL, 'PS_I_psaK: photosystem I reaction center subunit PsaK', 81, NULL, 'TIGR03049', 290576),
(484902, 'TIGR00351', NULL, 'narI: respiratory nitrate reductase, gamma subunit', 225, NULL, 'TIGR00351', 290577),
(484903, 'TIGR03521', NULL, 'GldG: gliding-associated putative ABC transporter substrate-binding component GldG', 552, NULL, 'TIGR03521', 290578),
(484904, 'TIGR04223', NULL, 'quorum_AgrD: cyclic lactone autoinducer peptide', 38, NULL, 'TIGR04223', 290579),
(484905, 'TIGR02838', NULL, 'spore_V_AC: stage V sporulation protein AC', 141, NULL, 'TIGR02838', 290580),
(484906, 'TIGR04341', NULL, 'target_ACGX: ACGX-repeat peptide', 65, NULL, 'TIGR04341', 290581),
(484907, 'TIGR02019', NULL, 'BchJ: bacteriochlorophyll 4-vinyl reductase', 188, NULL, 'TIGR02019', 290582),
(484908, 'TIGR00535', NULL, 'SAM_DCase: S-adenosylmethionine decarboxylase proenzyme', 334, NULL, 'TIGR00535', 290583),
(484909, 'TIGR00666', NULL, 'PBP4: D-alanyl-D-alanine carboxypeptidase/D-alanyl-D-alanine-endopeptidase', 397, NULL, 'TIGR00666', 290584),
(484910, 'TIGR03671', NULL, 'cca_archaeal: CCA-adding enzyme', 410, NULL, 'TIGR03671', 290585),
(484911, 'TIGR01635', NULL, 'tail_comp_S: phage virion morphogenesis protein', 144, NULL, 'TIGR01635', 290586),
(484912, 'TIGR02756', NULL, 'TraK_Ftype: type-F conjugative transfer system secretin TraK', 232, NULL, 'TIGR02756', 290587),
(484913, 'TIGR03431', NULL, 'PhnD: phosphonate ABC transporter, periplasmic phosphonate binding protein', 288, NULL, 'TIGR03431', 290588),
(484914, 'TIGR01581', NULL, 'Mo_ABC_porter: NifC-like ABC-type porter', 225, NULL, 'TIGR01581', 290589),
(484915, 'TIGR03725', NULL, 'T6A_YeaZ: tRNA threonylcarbamoyl adenosine modification protein YeaZ', 212, NULL, 'TIGR03725', 290590),
(484916, 'TIGR04436', NULL, 'SpoChoClust_3: putative 2OG-Fe(II) oxygenase', 300, NULL, 'TIGR04436', 290591),
(484917, 'TIGR04279', NULL, 'TIGR04279: TIGR04279 domain', 316, NULL, 'TIGR04279', 290592),
(484918, 'TIGR02346', NULL, 'chap_CCT_theta: T-complex protein 1, theta subunit', 531, NULL, 'TIGR02346', 290593),
(484919, 'TIGR01322', NULL, 'scrB_fam: sucrose-6-phosphate hydrolase', 447, NULL, 'TIGR01322', 290594),
(484920, 'TIGR00256', NULL, 'TIGR00256: D-tyrosyl-tRNA(Tyr) deacylase', 146, NULL, 'TIGR00256', 290595),
(484921, 'TIGR01805', NULL, 'CM_mono_grmpos: chorismate mutase', 81, NULL, 'TIGR01805', 290596),
(484922, 'TIGR02550', NULL, 'flagell_flgL: flagellar hook-associated protein 3', 387, NULL, 'TIGR02550', 290597),
(484923, 'TIGR02516', NULL, 'type_III_yscC: type III secretion outer membrane pore, YscC/HrcC family', 463, NULL, 'TIGR02516', 290598),
(484924, 'TIGR03261', NULL, 'phnS2: putative 2-aminoethylphosphonate ABC transporter, periplasmic 2-aminoethylphosphonate-binding protein', 334, NULL, 'TIGR03261', 290599),
(484925, 'TIGR00426', NULL, 'TIGR00426: competence protein ComEA helix-hairpin-helix repeat region', 69, NULL, 'TIGR00426', 290600),
(484926, 'TIGR03015', NULL, 'pepcterm_ATPase: putative secretion ATPase, PEP-CTERM locus subfamily', 269, NULL, 'TIGR03015', 290601),
(484927, 'TIGR02005', NULL, 'PTS-IIBC-alpha: PTS system, alpha-glucoside-specific IIBC component', 524, NULL, 'TIGR02005', 290602),
(484928, 'TIGR00694', NULL, 'thiM: hydroxyethylthiazole kinase', 249, NULL, 'TIGR00694', 290603),
(484929, 'TIGR03297', NULL, 'Ppyr-DeCO2ase: phosphonopyruvate decarboxylase', 360, NULL, 'TIGR03297', 290604),
(484930, 'TIGR02292', NULL, 'ygfB_yecA: yecA family protein', 179, NULL, 'TIGR02292', 290605),
(484931, 'TIGR02784', NULL, 'addA_alphas: double-strand break repair helicase AddA', 1138, NULL, 'TIGR02784', 290606),
(484932, 'TIGR03800', NULL, 'PLP_synth_Pdx2: pyridoxal 5''-phosphate synthase, glutaminase subunit Pdx2', 184, NULL, 'TIGR03800', 290607),
(484933, 'TIGR01377', NULL, 'soxA_mon: sarcosine oxidase, monomeric form', 381, NULL, 'TIGR01377', 290608),
(484934, 'TIGR04382', NULL, 'myo_inos_iolC_N: 5-dehydro-2-deoxygluconokinase', 309, NULL, 'TIGR04382', 290609),
(484935, 'TIGR00952', NULL, 'S15_bact: ribosomal protein uS15', 86, NULL, 'TIGR00952', 290610);
INSERT INTO "PUBLIC"."MODEL" VALUES
(484936, 'TIGR03467', NULL, 'HpnE: squalene-associated FAD-dependent desaturase', 430, NULL, 'TIGR03467', 290611),
(484937, 'TIGR04114', NULL, 'tSAM_targ_Cxxx: modification target Cys-rich repeat', 18, NULL, 'TIGR04114', 290612),
(484938, 'TIGR01000', NULL, 'bacteriocin_acc: bacteriocin secretion accessory protein', 457, NULL, 'TIGR01000', 290613),
(484939, 'TIGR00278', NULL, 'TIGR00278: putative membrane protein insertion efficiency factor', 75, NULL, 'TIGR00278', 290614),
(484940, 'TIGR03283', NULL, 'thy_syn_methano: thymidylate synthase, methanogen type', 201, NULL, 'TIGR03283', 290615),
(484941, 'TIGR02421', NULL, 'QEGLA: conserved hypothetical protein', 368, NULL, 'TIGR02421', 290616),
(484942, 'TIGR00571', NULL, 'dam: DNA adenine methylase', 267, NULL, 'TIGR00571', 290617),
(484943, 'TIGR01247', NULL, 'drrB: daunorubicin resistance ABC transporter membrane protein', 236, NULL, 'TIGR01247', 290618),
(484944, 'TIGR02264', NULL, 'gmx_para_CXXCG: Myxococcus xanthus double-CXXCG motif paralogous family', 237, NULL, 'TIGR02264', 290619),
(484945, 'TIGR02802', NULL, 'Pal_lipo: peptidoglycan-associated lipoprotein', 104, NULL, 'TIGR02802', 290620),
(484946, 'TIGR03630', NULL, 'uS17_arch: ribosomal protein uS17', 102, NULL, 'TIGR03630', 290621),
(484947, 'TIGR04477', NULL, 'sorted_by_XrtN: XrtN system VIT domain protein', 822, NULL, 'TIGR04477', 290622),
(484948, 'TIGR03923', NULL, 'T7SS_EccE: type VII secretion protein EccE', 344, NULL, 'TIGR03923', 290623),
(484949, 'TIGR03766', NULL, 'TIGR03766: conserved hypothetical integral membrane protein', 483, NULL, 'TIGR03766', 290624),
(484950, 'TIGR01300', NULL, 'CPA3_mnhG_phaG: monovalent cation/proton antiporter, MnhG/PhaG subunit', 97, NULL, 'TIGR01300', 290625),
(484951, 'TIGR02148', NULL, 'Fibro_Slime: fibro-slime domain', 90, NULL, 'TIGR02148', 290626),
(484952, 'TIGR02899', NULL, 'spore_safA: spore coat assembly protein SafA', 44, NULL, 'TIGR02899', 290627),
(484953, 'TIGR02074', NULL, 'PBP_1a_fam: penicillin-binding protein, 1A family', 535, NULL, 'TIGR02074', 290628),
(484954, 'TIGR02318', NULL, 'phosphono_phnM: phosphonate metabolism protein PhnM', 376, NULL, 'TIGR02318', 290629),
(484955, 'TIGR01417', NULL, 'PTS_I_fam: phosphoenolpyruvate-protein phosphotransferase', 565, NULL, 'TIGR01417', 290630),
(484956, 'TIGR02128', NULL, 'G6PI_arch: bifunctional phosphoglucose/phosphomannose isomerase', 308, NULL, 'TIGR02128', 290631),
(484957, 'TIGR00113', NULL, 'queA: S-adenosylmethionine:tRNA ribosyltransferase-isomerase', 345, NULL, 'TIGR00113', 290632),
(484958, 'TIGR01758', NULL, 'MDH_euk_cyt: malate dehydrogenase, NAD-dependent', 324, NULL, 'TIGR01758', 290633),
(484959, 'TIGR03099', NULL, 'dCO2ase_PEP1: pyridoxal-dependent decarboxylase, exosortase A system-associated', 398, NULL, 'TIGR03099', 290634),
(484960, 'TIGR00938', NULL, 'thrB_alt: homoserine kinase', 307, NULL, 'TIGR00938', 290635),
(484961, 'TIGR02251', NULL, 'HIF-SF_euk: dullard-like phosphatase domain', 168, NULL, 'TIGR02251', 290636),
(484962, 'TIGR01595', NULL, 'cas_CT1132: CRISPR-associated protein, CT1132 family', 268, NULL, 'TIGR01595', 290637),
(484963, 'TIGR02094', NULL, 'more_P_ylases: alpha-glucan phosphorylases', 600, NULL, 'TIGR02094', 290638),
(484964, 'TIGR02586', NULL, 'cas5_cmx5_devS: CRISPR-associated protein Cas5/DevS, subtype MYXAN', 183, NULL, 'TIGR02586', 290639),
(484965, 'TIGR03269', NULL, 'met_CoM_red_A2: methyl coenzyme M reductase system, component A2', 530, NULL, 'TIGR03269', 290640),
(484966, 'TIGR03596', NULL, 'GTPase_YlqF: ribosome biogenesis GTP-binding protein YlqF', 276, NULL, 'TIGR03596', 290641),
(484967, 'TIGR00748', NULL, 'HMG_CoA_syn_Arc: putative hydroxymethylglutaryl-CoA synthase', 345, NULL, 'TIGR00748', 290642),
(484968, 'TIGR03753', NULL, 'blh_monoox: beta-carotene 15,15''-monooxygenase, Brp/Blh family', 260, NULL, 'TIGR03753', 290643),
(484969, 'TIGR03943', NULL, 'TIGR03943: TIGR03943 family protein', 221, NULL, 'TIGR03943', 290644),
(484970, 'TIGR00918', NULL, '2A060602: transmembrane receptor Patched', 1145, NULL, 'TIGR00918', 290645);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(484971, 'TIGR01123', NULL, 'ilvE_II: branched-chain amino acid aminotransferase', 313, NULL, 'TIGR01123', 290646),
(484972, 'TIGR01254', NULL, 'sfuA: ABC transporter periplasmic binding protein, thiB subfamily', 306, NULL, 'TIGR01254', 290647),
(484973, 'TIGR00133', NULL, 'gatB: aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase, B subunit', 481, NULL, 'TIGR00133', 290648),
(484974, 'TIGR04293', NULL, 'archaeo_artF: archaeosortase family protein ArtF', 166, NULL, 'TIGR04293', 290649),
(484975, 'TIGR04347', NULL, 'pseudo_SAM_Halo: pseudo-rSAM protein/SPASM domain protein', 390, NULL, 'TIGR04347', 290650),
(484976, 'TIGR02223', NULL, 'ftsN: cell division protein FtsN', 299, NULL, 'TIGR02223', 290651),
(484977, 'TIGR02360', NULL, 'pbenz_hydroxyl: 4-hydroxybenzoate 3-monooxygenase', 390, NULL, 'TIGR02360', 290652),
(484978, 'TIGR01288', NULL, 'nodI: nodulation ABC transporter NodI', 303, NULL, 'TIGR01288', 290653),
(484979, 'TIGR03378', NULL, 'glycerol3P_GlpB: glycerol-3-phosphate dehydrogenase, anaerobic, B subunit', 419, NULL, 'TIGR03378', 290654),
(484980, 'TIGR00270', NULL, 'TIGR00270: TIGR00270 family protein', 154, NULL, 'TIGR00270', 290655),
(484981, 'TIGR04089', NULL, 'exp_by_SipW_III: alternate signal-mediated exported protein, RER_14450 family', 179, NULL, 'TIGR04089', 290656),
(484982, 'TIGR01391', NULL, 'dnaG: DNA primase', 414, NULL, 'TIGR01391', 290657),
(484983, 'TIGR00680', NULL, 'kdpA: K+-transporting ATPase, A subunit', 563, NULL, 'TIGR00680', 290658),
(484984, 'TIGR00734', NULL, 'hisAF_rel: hisA/hisF family protein', 221, NULL, 'TIGR00734', 290659),
(484985, 'TIGR01889', NULL, 'Staph_reg_Sar: staphylococcal accessory regulator family', 109, NULL, 'TIGR01889', 290660),
(484986, 'TIGR00303', NULL, 'TIGR00303: TIGR00303 family protein', 334, NULL, 'TIGR00303', 290661),
(484987, 'TIGR03104', NULL, 'trio_amidotrans: asparagine synthase family amidotransferase', 589, NULL, 'TIGR03104', 290662),
(484988, 'TIGR04517', NULL, 'rSAM_PoyD: radical SAM family RiPP maturation amino acid epimerase', 446, NULL, 'TIGR04517', 290663),
(484989, 'TIGR03487', NULL, 'cas_csp2: CRISPR-associated protein Cas8c/Csp2, subtype PGING', 483, NULL, 'TIGR03487', 290664),
(484990, 'TIGR04422', NULL, 'PLP_IMCC1989: putative PLP-dependent aminotransferase', 315, NULL, 'TIGR04422', 290665),
(484991, 'TIGR02974', NULL, 'phageshock_pspF: psp operon transcriptional activator', 336, NULL, 'TIGR02974', 290666),
(484992, 'TIGR03739', NULL, 'PRTRC_D: PRTRC system protein D', 320, NULL, 'TIGR03739', 290667),
(484993, 'TIGR01554', NULL, 'major_cap_HK97: phage major capsid protein, HK97 family', 385, NULL, 'TIGR01554', 290668),
(484994, 'TIGR02332', NULL, 'HpaX: 4-hydroxyphenylacetate permease', 412, NULL, 'TIGR02332', 290669),
(484995, 'TIGR01724', NULL, 'hmd_rel: H2-forming N(5),N(10)-methenyltetrahydromethanopterin dehydrogenase-related protein', 341, NULL, 'TIGR01724', 290670),
(484996, 'TIGR03657', NULL, 'IsdB: heme uptake protein IsdB', 644, NULL, 'TIGR03657', 290671),
(484997, 'TIGR01649', NULL, 'hnRNP-L_PTB: hnRNP-L/PTB/hephaestus splicing factor family', 493, NULL, 'TIGR01649', 290672),
(484998, 'TIGR02060', NULL, 'aprB: adenylylsulfate reductase, beta subunit', 132, NULL, 'TIGR02060', 290673),
(484999, 'TIGR03794', NULL, 'NHLM_micro_HlyD: NHLM bacteriocin system secretion protein', 421, NULL, 'TIGR03794', 290674),
(485000, 'TIGR02502', NULL, 'type_III_YscX: type III secretion protein, YscX family', 121, NULL, 'TIGR02502', 290675),
(485001, 'TIGR00789', NULL, 'flhB_rel: FlhB domain protein', 84, NULL, 'TIGR00789', 290676),
(485002, 'TIGR03909', NULL, 'pyrrolys_PylC: pyrrolysine biosynthesis protein PylC', 374, NULL, 'TIGR03909', 290677),
(485003, 'TIGR01819', NULL, 'F420_cofD: 2-phospho-L-lactate transferase', 301, NULL, 'TIGR01819', 290678),
(485004, 'TIGR00331', NULL, 'hrcA: heat-inducible transcription repressor HrcA', 338, NULL, 'TIGR00331', 290679),
(485005, 'TIGR01833', NULL, 'HMG-CoA-S_euk: hydroxymethylglutaryl-CoA synthase', 457, NULL, 'TIGR01833', 290680),
(485006, 'TIGR02509', NULL, 'type_III_yopR: type III secretion effector, YopR family', 131, NULL, 'TIGR02509', 290681); 
INSERT INTO "PUBLIC"."MODEL" VALUES
(485007, 'TIGR04491', NULL, 'reactive_PduG: diol dehydratase reactivase alpha subunit', 599, NULL, 'TIGR04491', 290682),
(485008, 'TIGR00038', NULL, 'efp: translation elongation factor P', 184, NULL, 'TIGR00038', 290683),
(485009, 'TIGR04545', NULL, 'rSAM_ahbD_hemeb: heme b synthase', 339, NULL, 'TIGR04545', 290684),
(485010, 'TIGR01007', NULL, 'eps_fam: capsular exopolysaccharide family', 204, NULL, 'TIGR01007', 290685),
(485011, 'TIGR02695', NULL, 'azurin: azurin', 125, NULL, 'TIGR02695', 290686),
(485012, 'TIGR01486', NULL, 'HAD-SF-IIB-MPGP: mannosyl-3-phosphoglycerate phosphatase family', 257, NULL, 'TIGR01486', 290687),
(485013, 'TIGR04198', NULL, 'paramyx_RNAcap: mRNA capping enzyme', 938, NULL, 'TIGR04198', 290688),
(485014, 'TIGR00659', NULL, 'TIGR00659: TIGR00659 family protein', 226, NULL, 'TIGR00659', 290689),
(485015, 'TIGR04354', NULL, 'amphi-Trp: amphi-Trp domain', 67, NULL, 'TIGR04354', 290690),
(485016, 'TIGR01540', NULL, 'portal_PBSX: phage portal protein, PBSX family', 320, NULL, 'TIGR01540', 290691),
(485017, 'TIGR00966', NULL, '3a0501s07: protein-export membrane protein SecF', 246, NULL, 'TIGR00966', 290692),
(485018, 'TIGR01193', NULL, 'bacteriocin_ABC: ABC-type bacteriocin transporter', 708, NULL, 'TIGR01193', 290693),
(485019, 'TIGR03043', NULL, 'PS_II_psbZ: photosystem II core protein PsbZ', 58, NULL, 'TIGR03043', 290694),
(485020, 'TIGR04238', NULL, 'seadorna_dsRNA: seadornavirus double-stranded RNA-binding protein', 201, NULL, 'TIGR04238', 290695),
(485021, 'TIGR02988', NULL, 'YaaA_near_RecF: S4 domain protein YaaA', 60, NULL, 'TIGR02988', 290696),
(485022, 'TIGR01710', NULL, 'typeII_sec_gspG: type II secretion system protein G', 134, NULL, 'TIGR01710', 290697),
(485023, 'TIGR03834', NULL, 'EAGR_box: EAGR box', 28, NULL, 'TIGR03834', 290698),
(485024, 'TIGR04408', NULL, 'LptG_lptG: LPS export ABC transporter permease LptG', 351, NULL, 'TIGR04408', 290699),
(485025, 'TIGR03029', NULL, 'EpsG: chain length determinant protein tyrosine kinase EpsG', 274, NULL, 'TIGR03029', 290700),
(485026, 'TIGR01363', NULL, 'strep_his_triad: streptococcal histidine triad protein', 348, NULL, 'TIGR01363', 290701),
(485027, 'TIGR00829', NULL, 'FRU: PTS system, Fru family, IIB component', 85, NULL, 'TIGR00829', 290702),
(485028, 'TIGR03213', NULL, '23dbph12diox: 2,3-dihydroxybiphenyl 1,2-dioxygenase', 287, NULL, 'TIGR03213', 290703),
(485029, 'TIGR01663', NULL, 'PNK-3''Pase: polynucleotide kinase 3''-phosphatase', 520, NULL, 'TIGR01663', 290704),
(485030, 'TIGR02039', NULL, 'CysD: sulfate adenylyltransferase, small subunit', 294, NULL, 'TIGR02039', 290705),
(485031, 'TIGR04368', NULL, 'Glu_2_3_NH3_mut: glutamate 2,3-aminomutase', 404, NULL, 'TIGR04368', 290706),
(485032, 'TIGR02183', NULL, 'GRXA: glutaredoxin, GrxA family', 86, NULL, 'TIGR02183', 290707),
(485033, 'TIGR03685', NULL, 'ribo_P1_arch: 50S ribosomal protein P1', 105, NULL, 'TIGR03685', 290708),
(485034, 'TIGR00496', NULL, 'frr: ribosome recycling factor', 176, NULL, 'TIGR00496', 290709),
(485035, 'TIGR01670', NULL, 'KdsC-phosphatas: 3-deoxy-D-manno-octulosonate 8-phosphate phosphatase, YrbI family', 154, NULL, 'TIGR01670', 290710),
(485036, 'TIGR01998', NULL, 'PTS-II-BC-nag: PTS system, N-acetylglucosamine-specific IIBC component', 475, NULL, 'TIGR01998', 290711),
(485037, 'TIGR00161', NULL, 'TIGR00161: TIGR00161 family protein', 239, NULL, 'TIGR00161', 290712),
(485038, 'TIGR00843', NULL, 'benE: benzoate transporter', 395, NULL, 'TIGR00843', 290713),
(485039, 'TIGR02530', NULL, 'flg_new: flagellar operon protein', 96, NULL, 'TIGR02530', 290714),
(485040, 'TIGR01179', NULL, 'galE: UDP-glucose 4-epimerase GalE', 332, NULL, 'TIGR01179', 290715),
(485041, 'TIGR04184', NULL, 'ATPgraspMvdD: ATP-grasp ribosomal peptide maturase, MvdD family', 321, NULL, 'TIGR04184', 290716),
(485042, 'TIGR03848', NULL, 'MSMEG_4193: probable phosphomutase, MSMEG_4193 family', 204, NULL, 'TIGR03848', 290717),
(485043, 'TIGR01526', NULL, 'nadR_NMN_Atrans: nicotinamide-nucleotide adenylyltransferase', 325, NULL, 'TIGR01526', 290718),
(485044, 'TIGR04531', NULL, 'nonproteo_OH: putative nonproteinogenic amino acid hydroxylase', 277, NULL, 'TIGR04531', 290719);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(485045, 'TIGR02209', NULL, 'ftsL_broad: cell division protein FtsL', 85, NULL, 'TIGR02209', 290720),
(485046, 'TIGR00024', NULL, 'SbcD_rel_arch: putative phosphoesterase', 224, NULL, 'TIGR00024', 290721),
(485047, 'TIGR02067', NULL, 'his_9_HisN: histidinol-phosphatase', 252, NULL, 'TIGR02067', 290722),
(485048, 'TIGR03759', NULL, 'conj_TIGR03759: integrating conjugative element protein, PFL_4693 family', 200, NULL, 'TIGR03759', 290723),
(485049, 'TIGR04277', NULL, 'squa_tetra_cyc: tetrahymanol synthase', 624, NULL, 'TIGR04277', 290724),
(485050, 'TIGR01549', NULL, 'HAD-SF-IA-v1: HAD hydrolase, family IA, variant 1', 149, NULL, 'TIGR01549', 290725),
(485051, 'TIGR01669', NULL, 'phage_XkdX: phage uncharacterized protein, XkdX family', 45, NULL, 'TIGR01669', 290726),
(485052, 'TIGR03639', NULL, 'cas1_NMENI: CRISPR-associated endonuclease Cas1, subtype II/NMENI', 278, NULL, 'TIGR03639', 290727),
(485053, 'TIGR00941', NULL, '2a6301s03: multicomponent Na+:H+ antiporter, MnhC subunit', 104, NULL, 'TIGR00941', 290728),
(485054, 'TIGR03607', NULL, 'TIGR03607: patatin-related protein', 732, NULL, 'TIGR03607', 290729),
(485055, 'TIGR03982', NULL, 'TIGR03982: His-Xaa-Ser system protein, TIGR03982 family', 117, NULL, 'TIGR03982', 290730),
(485056, 'TIGR04125', NULL, 'exosort_PGF_TRM: archaeosortase A', 271, NULL, 'TIGR04125', 290731),
(485057, 'TIGR04157', NULL, 'glyco_rSAM_CFB: glycosyltransferase, GG-Bacteroidales peptide system', 406, NULL, 'TIGR04157', 290732),
(485058, 'TIGR01892', NULL, 'AcOrn-deacetyl: acetylornithine deacetylase (ArgE)', 365, NULL, 'TIGR01892', 290733),
(485059, 'TIGR02035', NULL, 'D_Ser_am_lyase: D-serine ammonia-lyase', 431, NULL, 'TIGR02035', 290734),
(485060, 'TIGR03950', NULL, 'sidero_Fe_reduc: siderophore ferric iron reductase, AHA_1954 family', 223, NULL, 'TIGR03950', 290735),
(485061, 'TIGR01517', NULL, 'ATPase-IIB_Ca: calcium-translocating P-type ATPase, PMCA-type', 882, NULL, 'TIGR01517', 290736),
(485062, 'TIGR00097', NULL, 'HMP-P_kinase: hydroxymethylpyrimidine kinase/phosphomethylpyrimidine kinase', 254, NULL, 'TIGR00097', 290737),
(485063, 'TIGR01204', NULL, 'bioW: 6-carboxyhexanoate--CoA ligase', 232, NULL, 'TIGR01204', 290738),
(485064, 'TIGR02187', NULL, 'GlrX_arch: glutaredoxin-like domain protein', 216, NULL, 'TIGR02187', 290739),
(485065, 'TIGR03862', NULL, 'flavo_PP4765: flavoprotein, TIGR03862 family', 376, NULL, 'TIGR03862', 290740),
(485066, 'TIGR02348', NULL, 'GroEL: chaperonin GroL', 526, NULL, 'TIGR02348', 290741),
(485067, 'TIGR04438', NULL, 'small_Trp_rich: small Trp-rich protein', 76, NULL, 'TIGR04438', 290742),
(485068, 'TIGR00405', NULL, 'KOW_elon_Spt5: transcription elongation factor Spt5', 145, NULL, 'TIGR00405', 290743),
(485069, 'TIGR00258', NULL, 'TIGR00258: inosine/xanthosine triphosphatase', 168, NULL, 'TIGR00258', 290744),
(485070, 'TIGR03830', NULL, 'CxxCG_CxxCG_HTH: putative zinc finger/helix-turn-helix protein, YgiT family', 127, NULL, 'TIGR03830', 290745),
(485071, 'TIGR00065', NULL, 'ftsZ: cell division protein FtsZ', 353, NULL, 'TIGR00065', 290746),
(485072, 'TIGR00589', NULL, 'ogt: methylated-DNA--[protein]-cysteine S-methyltransferase', 80, NULL, 'TIGR00589', 290747),
(485073, 'TIGR03326', NULL, 'rubisco_III: ribulose bisphosphate carboxylase, type III', 426, NULL, 'TIGR03326', 290748),
(485074, 'TIGR02407', NULL, 'ectoine_ectB: diaminobutyrate--2-oxoglutarate aminotransferase', 412, NULL, 'TIGR02407', 290749),
(485075, 'TIGR02155', NULL, 'PA_CoA_ligase: phenylacetate-CoA ligase', 422, NULL, 'TIGR02155', 290750),
(485076, 'TIGR02679', NULL, 'TIGR02679: TIGR02679 family protein', 382, NULL, 'TIGR02679', 290751),
(485077, 'TIGR01236', NULL, 'D1pyr5carbox1: 1-pyrroline-5-carboxylate dehydrogenase', 533, NULL, 'TIGR01236', 290752),
(485078, 'TIGR01740', NULL, 'pyrF: orotidine 5''-phosphate decarboxylase', 216, NULL, 'TIGR01740', 290753),
(485079, 'TIGR03197', NULL, 'MnmC_Cterm: tRNA U-34 5-methylaminomethyl-2-thiouridine biosynthesis protein MnmC, C-terminal domain', 400, NULL, 'TIGR03197', 290754),
(485080, 'TIGR01057', NULL, 'topA_arch: DNA topoisomerase I', 618, NULL, 'TIGR01057', 290755);               
INSERT INTO "PUBLIC"."MODEL" VALUES
(485081, 'TIGR02559', NULL, 'HrpB7: type III secretion protein HrpB7', 158, NULL, 'TIGR02559', 290756),
(485082, 'TIGR00539', NULL, 'hemN_rel: putative oxygen-independent coproporphyrinogen III oxidase', 361, NULL, 'TIGR00539', 290757),
(485083, 'TIGR01177', NULL, 'TIGR01177: putative methyltransferase, TIGR01177 family', 330, NULL, 'TIGR01177', 290758),
(485084, 'TIGR03165', NULL, 'F1F0_chp_2: F1/F0 ATPase, Methanosarcina type, subunit 2', 83, NULL, 'TIGR03165', 290759),
(485085, 'TIGR03490', NULL, 'Mycoplas_LppA: mycoides cluster lipoprotein, LppA/P72 family', 541, NULL, 'TIGR03490', 290760),
(485086, 'TIGR00762', NULL, 'DegV: EDD domain protein, DegV family', 276, NULL, 'TIGR00762', 290761),
(485087, 'TIGR02527', NULL, 'dot_icm_IcmQ: Dot/Icm secretion system protein IcmQ', 179, NULL, 'TIGR02527', 290762),
(485088, 'TIGR01901', NULL, 'adhes_NPXG: filamentous hemagglutinin family N-terminal domain', 79, NULL, 'TIGR01901', 290763),
(485089, 'TIGR02246', NULL, 'TIGR02246: conserved hypothetical protein', 128, NULL, 'TIGR02246', 290764),
(485090, 'TIGR02750', NULL, 'TraN_Ftype: type-F conjugative transfer system mating-pair stabilization protein TraN', 572, NULL, 'TIGR02750', 290765),
(485091, 'TIGR02316', NULL, 'propion_prpE: propionate--CoA ligase', 628, NULL, 'TIGR02316', 290766),
(485092, 'TIGR02820', NULL, 'formald_GSH: S-(hydroxymethyl)glutathione synthase', 182, NULL, 'TIGR02820', 290767),
(485093, 'TIGR03045', NULL, 'PS_II_C550: cytochrome c-550', 159, NULL, 'TIGR03045', 290768),
(485094, 'TIGR02691', NULL, 'arsC_pI258_fam: arsenate reductase (thioredoxin)', 129, NULL, 'TIGR02691', 290769),
(485095, 'TIGR03818', NULL, 'MotA1: flagellar motor stator protein MotA', 282, NULL, 'TIGR03818', 290770),
(485096, 'TIGR03478', NULL, 'DMSO_red_II_bet: DMSO reductase family type II enzyme, iron-sulfur subunit', 321, NULL, 'TIGR03478', 290771),
(485097, 'TIGR01268', NULL, 'Phe4hydrox_tetr: phenylalanine-4-hydroxylase', 436, NULL, 'TIGR01268', 290772),
(485098, 'TIGR02468', NULL, 'sucrsPsyn_pln: sucrose phosphate synthase', 1051, NULL, 'TIGR02468', 290773),
(485099, 'TIGR00780', NULL, 'ccoN: cytochrome c oxidase, cbb3-type, subunit I', 474, NULL, 'TIGR00780', 290774),
(485100, 'TIGR02003', NULL, 'PTS-II-BC-unk1: PTS system, IIBC component', 547, NULL, 'TIGR02003', 290775),
(485101, 'TIGR01306', NULL, 'GMP_reduct_2: guanosine monophosphate reductase', 321, NULL, 'TIGR01306', 290776),
(485102, 'TIGR03760', NULL, 'ICE_TraI_Pfluor: integrating conjugative element relaxase, PFGI-1 class', 218, NULL, 'TIGR03760', 290777),
(485103, 'TIGR00276', NULL, 'TIGR00276: epoxyqueuosine reductase', 337, NULL, 'TIGR00276', 290778),
(485104, 'TIGR03013', NULL, 'EpsB_2: sugar transferase, PEP-CTERM system associated', 443, NULL, 'TIGR03013', 290779),
(485105, 'TIGR01608', NULL, 'citD: citrate lyase acyl carrier protein', 94, NULL, 'TIGR01608', 290780),
(485106, 'TIGR02972', NULL, 'TMAO_torE: trimethylamine N-oxide reductase system, TorE protein', 49, NULL, 'TIGR02972', 290781),
(485107, 'TIGR01025', NULL, 'uS19_arch: ribosomal protein uS19', 135, NULL, 'TIGR01025', 290782),
(485108, 'TIGR02808', NULL, 'short_TIGR02808: TIGR02808 family protein', 42, NULL, 'TIGR02808', 290783),
(485109, 'TIGR03537', NULL, 'DapC: succinyldiaminopimelate transaminase', 350, NULL, 'TIGR03537', 290784),
(485110, 'TIGR04227', NULL, 'zmp_18_rpt: zinc metalloproteinase 18-residue repeat', 18, NULL, 'TIGR04227', 290785),
(485111, 'TIGR04456', NULL, 'LruC_dom: LruC domain', 243, NULL, 'TIGR04456', 290786),
(485112, 'TIGR00106', NULL, 'TIGR00106: uncharacterized protein, MTH1187 family', 97, NULL, 'TIGR00106', 290787),
(485113, 'TIGR02257', NULL, 'cobalto_cobN: cobaltochelatase, CobN subunit', 1226, NULL, 'TIGR02257', 290788),
(485114, 'TIGR01619', NULL, 'hyp_HI0040: TIGR01619 family protein', 250, NULL, 'TIGR01619', 290789),
(485115, 'TIGR01994', NULL, 'SUF_scaf_2: SUF system FeS assembly protein, NifU family', 137, NULL, 'TIGR01994', 290790),
(485116, 'TIGR04450', NULL, 'Gpos_C8_like: putative immunity protein/bacteriocin', 240, NULL, 'TIGR04450', 290791);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(485117, 'TIGR00991', NULL, '3a0901s02IAP34: GTP-binding protein', 313, NULL, 'TIGR00991', 290792),
(485118, 'TIGR03689', NULL, 'pup_AAA: proteasome ATPase', 512, NULL, 'TIGR03689', 290793),
(485119, 'TIGR03932', NULL, 'PIA_icaD: intracellular adhesion protein D', 88, NULL, 'TIGR03932', 290794),
(485120, 'TIGR04570', NULL, 'mollicut_2TM: small integral membrane protein', 87, NULL, 'TIGR04570', 290795),
(485121, 'TIGR00167', NULL, 'cbbA: ketose-bisphosphate aldolase', 290, NULL, 'TIGR00167', 290796),
(485122, 'TIGR03224', NULL, 'benzo_boxA: benzoyl-CoA oxygenase/reductase, BoxA protein', 411, NULL, 'TIGR03224', 290797),
(485123, 'TIGR01102', NULL, 'yscR: type III secretion apparatus protein, YscR/HrcR family', 202, NULL, 'TIGR01102', 290798),
(485124, 'TIGR02085', NULL, 'meth_trns_rumB: 23S rRNA (uracil-5-)-methyltransferase RumB', 374, NULL, 'TIGR02085', 290799),
(485125, 'TIGR00809', NULL, 'secB: protein-export chaperone SecB', 140, NULL, 'TIGR00809', 290800),
(485126, 'TIGR01286', NULL, 'nifK: nitrogenase molybdenum-iron protein beta chain', 516, NULL, 'TIGR01286', 290801),
(485127, 'TIGR03505', NULL, 'FimV_core: FimV N-terminal domain', 74, NULL, 'TIGR03505', 290802),
(485128, 'TIGR00929', NULL, 'VirB4_CagE: type IV secretion/conjugal transfer ATPase, VirB4 family', 792, NULL, 'TIGR00929', 290803),
(485129, 'TIGR02706', NULL, 'P_butyryltrans: phosphate butyryltransferase', 294, NULL, 'TIGR02706', 290804),
(485130, 'TIGR02961', NULL, 'allantoicase: allantoicase', 324, NULL, 'TIGR02961', 290805),
(485131, 'TIGR03880', NULL, 'KaiC_arch_3: KaiC domain protein, AF_0351 family', 224, NULL, 'TIGR03880', 290806),
(485132, 'TIGR01962', NULL, 'NuoD: NADH dehydrogenase (quinone), D subunit', 386, NULL, 'TIGR01962', 290807),
(485133, 'TIGR01338', NULL, 'phycocy_alpha: phycocyanin, alpha subunit', 161, NULL, 'TIGR01338', 290808),
(485134, 'TIGR04336', NULL, 'AmmeMemoSam_B: AmmeMemoRadiSam system protein B', 270, NULL, 'TIGR04336', 290809),
(485135, 'TIGR01907', NULL, 'casE_Cse3: CRISPR-associated protein Cas6/Cse3/CasE, subtype I-E/ECOLI', 208, NULL, 'TIGR01907', 290810),
(485136, 'TIGR02305', NULL, 'HpaG-N-term: 4-hydroxyphenylacetate degradation bifunctional isomerase/decarboxylase, N-terminal subunit', 205, NULL, 'TIGR02305', 290811),
(485137, 'TIGR02793', NULL, 'nikR: nickel-responsive transcriptional regulator NikR', 129, NULL, 'TIGR02793', 290812),
(485138, 'TIGR01567', NULL, 'S_layer_rel_Mac: S-layer family duplication domain', 259, NULL, 'TIGR01567', 290813),
(485139, 'TIGR00507', NULL, 'aroE: shikimate dehydrogenase', 270, NULL, 'TIGR00507', 290814),
(485140, 'TIGR04098', NULL, 'biosyn_clust_1: biosynthesis cluster domain', 270, NULL, 'TIGR04098', 290815),
(485141, 'TIGR04379', NULL, 'myo_inos_iolE: myo-inosose-2 dehydratase', 290, NULL, 'TIGR04379', 290816),
(485142, 'TIGR01681', NULL, 'HAD-SF-IIIC: HAD phosphatase, family IIIC', 132, NULL, 'TIGR01681', 290817),
(485143, 'TIGR01279', NULL, 'DPOR_bchN: light-independent protochlorophyllide reductase, N subunit', 407, NULL, 'TIGR01279', 290818),
(485144, 'TIGR04055', NULL, 'rSAM_NirJ2: putative heme d1 biosynthesis radical SAM protein NirJ2', 326, NULL, 'TIGR04055', 290819),
(485145, 'TIGR00124', NULL, 'cit_ly_ligase: [citrate (pro-3S)-lyase] ligase', 335, NULL, 'TIGR00124', 290820),
(485146, 'TIGR03771', NULL, 'anch_rpt_ABC: anchored repeat-type ABC transporter, ATP-binding subunit', 223, NULL, 'TIGR03771', 290821),
(485147, 'TIGR00648', NULL, 'recU: recombination protein U', 169, NULL, 'TIGR00648', 290822),
(485148, 'TIGR00174', NULL, 'miaA: tRNA dimethylallyltransferase', 288, NULL, 'TIGR00174', 290823),
(485149, 'TIGR02954', NULL, 'Sig70_famx3: RNA polymerase sigma-70 factor, TIGR02954 family', 170, NULL, 'TIGR02954', 290824),
(485150, 'TIGR00469', NULL, 'pheS_mito: phenylalanine--tRNA ligase', 451, NULL, 'TIGR00469', 290825),
(485151, 'TIGR00004', NULL, 'TIGR00004: reactive intermediate/imine deaminase', 125, NULL, 'TIGR00004', 290826),
(485152, 'TIGR02144', NULL, 'LysX_arch: lysine biosynthesis enzyme LysX', 281, NULL, 'TIGR02144', 290827);      
INSERT INTO "PUBLIC"."MODEL" VALUES
(485153, 'TIGR02852', NULL, 'spore_dpaB: dipicolinic acid synthetase, B subunit', 187, NULL, 'TIGR02852', 290828),
(485154, 'TIGR01159', NULL, 'DRP1: density-regulated protein DRP1', 168, NULL, 'TIGR01159', 290829),
(485155, 'TIGR03115', NULL, 'cas7_csf2: CRISPR type IV/AFERR-associated protein Csf2', 344, NULL, 'TIGR03115', 290830),
(485156, 'TIGR01350', NULL, 'lipoamide_DH: dihydrolipoyl dehydrogenase', 461, NULL, 'TIGR01350', 290831),
(485157, 'TIGR04048', NULL, 'nitrile_sll0784: putative nitrilase, sll0784 family', 301, NULL, 'TIGR04048', 290832),
(485158, 'TIGR01728', NULL, 'SsuA_fam: ABC transporter, substrate-binding protein, aliphatic sulfonates family', 290, NULL, 'TIGR01728', 290833),
(485159, 'TIGR03299', NULL, 'LGT_TIGR03299: phage/plasmid-like protein TIGR03299', 312, NULL, 'TIGR03299', 290834),
(485160, 'TIGR03063', NULL, 'srtB_target: sortase B cell surface sorting signal', 29, NULL, 'TIGR03063', 290835),
(485161, 'TIGR03592', NULL, 'yidC_oxa1_cterm: membrane protein insertase, YidC/Oxa1 family', 191, NULL, 'TIGR03592', 290836),
(485162, 'TIGR03358', NULL, 'VI_chp_5: type VI secretion protein, VC_A0107 family', 160, NULL, 'TIGR03358', 290837),
(485163, 'TIGR03403', NULL, 'nifS_epsilon: cysteine desulfurase, NifS family', 382, NULL, 'TIGR03403', 290838),
(485164, 'TIGR04558', NULL, 'SoxH_rel_PQQ_1: quinoprotein relay system zinc metallohydrolase 1', 285, NULL, 'TIGR04558', 290839),
(485165, 'TIGR03056', NULL, 'bchO_mg_che_rel: putative magnesium chelatase accessory protein', 278, NULL, 'TIGR03056', 290840),
(485166, 'TIGR03651', NULL, 'circ_ocin_uber: circular bacteriocin, circularin A/uberolysin family', 73, NULL, 'TIGR03651', 290841),
(485167, 'TIGR02418', NULL, 'acolac_catab: acetolactate synthase, catabolic', 539, NULL, 'TIGR02418', 290842),
(485168, 'TIGR01631', NULL, 'Trypano_RHS: trypanosome RHS family', 761, NULL, 'TIGR01631', 290843),
(485169, 'TIGR01388', NULL, 'rnd: ribonuclease D', 363, NULL, 'TIGR01388', 290844),
(485170, 'TIGR01860', NULL, 'VNFD: nitrogenase vanadium-iron protein, alpha chain', 461, NULL, 'TIGR01860', 290845),
(485171, 'TIGR00882', NULL, '2A0105: oligosaccharide:H+ symporter', 396, NULL, 'TIGR00882', 290846),
(485172, 'TIGR01166', NULL, 'cbiO: cobalt ABC transporter, ATP-binding protein', 190, NULL, 'TIGR01166', 290847),
(485173, 'TIGR01447', NULL, 'recD: exodeoxyribonuclease V, alpha subunit', 597, NULL, 'TIGR01447', 290848),
(485174, 'TIGR02949', NULL, 'anti_SigH_actin: anti-sigma factor, TIGR02949 family', 84, NULL, 'TIGR02949', 290849),
(485175, 'TIGR02078', NULL, 'AspKin_pair: putative Pyrococcus aspartate kinase subunit', 327, NULL, 'TIGR02078', 290850),
(485176, 'TIGR02366', NULL, 'DHAK_reg: probable dihydroxyacetone kinase regulator', 176, NULL, 'TIGR02366', 290851),
(485177, 'TIGR02425', NULL, 'decarb_PcaC: 4-carboxymuconolactone decarboxylase', 123, NULL, 'TIGR02425', 290852),
(485178, 'TIGR01506', NULL, 'ribC_arch: riboflavin synthase', 151, NULL, 'TIGR01506', 290853),
(485179, 'TIGR02137', NULL, 'HSK-PSP: phosphoserine phosphatase/homoserine phosphotransferase bifunctional protein', 203, NULL, 'TIGR02137', 290854),
(485180, 'TIGR03868', NULL, 'F420-O_ABCperi: proposed F420-0 ABC transporter, periplasmic F420-0 binding protein', 287, NULL, 'TIGR03868', 290855),
(485181, 'TIGR00117', NULL, 'acnB: aconitate hydratase 2', 844, NULL, 'TIGR00117', 290856),
(485182, 'TIGR03122', NULL, 'one_C_dehyd_C: formylmethanofuran dehydrogenase subunit C', 260, NULL, 'TIGR03122', 290857),
(485183, 'TIGR02430', NULL, 'pcaF: 3-oxoadipyl-CoA thiolase', 400, NULL, 'TIGR02430', 290858),
(485184, 'TIGR00514', NULL, 'accC: acetyl-CoA carboxylase, biotin carboxylase subunit', 449, NULL, 'TIGR00514', 290859),
(485185, 'TIGR03274', NULL, 'methan_mark_7: putative methanogenesis marker protein 7', 302, NULL, 'TIGR03274', 290860),
(485186, 'TIGR00149', NULL, 'TIGR00149_YjbQ: secondary thiamine-phosphate synthase enzyme', 132, NULL, 'TIGR00149', 290861),
(485187, 'TIGR02207', NULL, 'lipid_A_htrB: lipid A biosynthesis lauroyl (or palmitoleoyl) acyltransferase', 303, NULL, 'TIGR02207', 290862);
INSERT INTO "PUBLIC"."MODEL" VALUES
(485188, 'TIGR01184', NULL, 'ntrCD: nitrate ABC transporter, ATP-binding proteins C and D', 230, NULL, 'TIGR01184', 290863),
(485189, 'TIGR02239', NULL, 'recomb_RAD51: DNA repair protein RAD51', 316, NULL, 'TIGR02239', 290864),
(485190, 'TIGR02668', NULL, 'moaA_archaeal: probable molybdenum cofactor biosynthesis protein A', 303, NULL, 'TIGR02668', 290865),
(485191, 'TIGR03158', NULL, 'cas3_cyano: CRISPR-associated helicase Cas3, subtype CYANO', 357, NULL, 'TIGR03158', 290866),
(485192, 'TIGR02788', NULL, 'VirB11: P-type DNA transfer ATPase VirB11', 308, NULL, 'TIGR02788', 290867),
(485193, 'TIGR00460', NULL, 'fmt: methionyl-tRNA formyltransferase', 315, NULL, 'TIGR00460', 290868),
(485194, 'TIGR03587', NULL, 'Pse_Me-ase: pseudaminic acid biosynthesis-associated methylase', 204, NULL, 'TIGR03587', 290869),
(485195, 'TIGR00269', NULL, 'TIGR00269: TIGR00269 family protein', 104, NULL, 'TIGR00269', 290870),
(485196, 'TIGR02917', NULL, 'PEP_TPR_lipo: putative PEP-CTERM system TPR-repeat lipoprotein', 899, NULL, 'TIGR02917', 290871),
(485197, 'TIGR03006', NULL, 'pepcterm_polyde: polysaccharide deacetylase family protein, PEP-CTERM locus subfamily', 272, NULL, 'TIGR03006', 290872),
(485198, 'TIGR02359', NULL, 'thiW: energy coupling factor transporter S component ThiW', 160, NULL, 'TIGR02359', 290873),
(485199, 'TIGR02863', NULL, 'spore_sspJ: small, acid-soluble spore protein, SspJ family', 47, NULL, 'TIGR02863', 290874),
(485200, 'TIGR01944', NULL, 'rnfB: electron transport complex, RnfABCDGE type, B subunit', 190, NULL, 'TIGR01944', 290875),
(485201, 'TIGR00773', NULL, 'NhaA: Na+/H+ antiporter NhaA', 374, NULL, 'TIGR00773', 290876),
(485202, 'TIGR00707', NULL, 'argD: transaminase, acetylornithine/succinylornithine family', 381, NULL, 'TIGR00707', 290877),
(485203, 'TIGR02355', NULL, 'moeB: molybdopterin synthase sulfurylase MoeB', 240, NULL, 'TIGR02355', 290878),
(485204, 'TIGR03748', NULL, 'conj_PilL: integrating conjugative element protein PilL, PFGI-1 class', 105, NULL, 'TIGR03748', 290879),
(485205, 'TIGR01989', NULL, 'COQ6: ubiquinone biosynthesis monooxygenase COQ6', 437, NULL, 'TIGR01989', 290880),
(485206, 'TIGR04445', NULL, 'preny_LynF_TruF: peptide O-prenyltransferase, LynF/TruF/PatF family', 282, NULL, 'TIGR04445', 290881),
(485207, 'TIGR03038', NULL, 'PS_II_psbM: photosystem II reaction center protein PsbM', 33, NULL, 'TIGR03038', 290882),
(485208, 'TIGR00979', NULL, 'fumC_II: fumarate hydratase, class II', 458, NULL, 'TIGR00979', 290883),
(485209, 'TIGR00340', NULL, 'zpr1_rel: zinc finger protein ZPR1 homolog', 163, NULL, 'TIGR00340', 290884),
(485210, 'TIGR01524', NULL, 'ATPase-IIIB_Mg: magnesium-translocating P-type ATPase', 867, NULL, 'TIGR01524', 290885),
(485211, 'TIGR03542', NULL, 'DAPAT_plant: LL-diaminopimelate aminotransferase', 402, NULL, 'TIGR03542', 290886),
(485212, 'TIGR04202', NULL, 'capSnatchArena: RNA endonuclease, cap-snatching', 61, NULL, 'TIGR04202', 290887),
(485213, 'TIGR02895', NULL, 'spore_sigI: RNA polymerase sigma-I factor', 219, NULL, 'TIGR02895', 290888),
(485214, 'TIGR03614', NULL, 'RutB: pyrimidine utilization protein B', 226, NULL, 'TIGR03614', 290889),
(485215, 'TIGR00609', NULL, 'recB: exodeoxyribonuclease V, beta subunit', 1175, NULL, 'TIGR00609', 290890),
(485216, 'TIGR03440', NULL, 'egtB_TIGR03440: ergothioneine biosynthesis protein EgtB', 406, NULL, 'TIGR03440', 290891),
(485217, 'TIGR01404', NULL, 'FlhB_rel_III: type III secretion protein, YscU/HrpY family', 342, NULL, 'TIGR01404', 290892),
(485218, 'TIGR01556', NULL, 'rhamnosyltran: rhamnosyltransferase', 281, NULL, 'TIGR01556', 290893),
(485219, 'TIGR03662', NULL, 'Chlor_Arch_YYY: chlor_Arch_YYY domain', 727, NULL, 'TIGR03662', 290894),
(485220, 'TIGR00022', NULL, 'TIGR00022: YhcH/YjgK/YiaL family protein', 155, NULL, 'TIGR00022', 290895),
(485221, 'TIGR01626', NULL, 'ytfJ_HI0045: conserved hypothetical protein YtfJ-family, TIGR01626', 184, NULL, 'TIGR01626', 290896),
(485222, 'TIGR00054', NULL, 'TIGR00054: RIP metalloprotease RseP', 421, NULL, 'TIGR00054', 290897),
(485223, 'TIGR00487', NULL, 'IF-2: translation initiation factor IF-2', 587, NULL, 'TIGR00487', 290898);              
INSERT INTO "PUBLIC"."MODEL" VALUES
(485224, 'TIGR00367', NULL, 'TIGR00367: K+-dependent Na+/Ca+ exchanger homolog', 312, NULL, 'TIGR00367', 290899),
(485225, 'TIGR02010', NULL, 'IscR: iron-sulfur cluster assembly transcription factor IscR', 135, NULL, 'TIGR02010', 290900),
(485226, 'TIGR04547', NULL, 'Mollicu_LP: MOLPALP family lipoprotein', 807, NULL, 'TIGR04547', 290901),
(485227, 'TIGR02475', NULL, 'CobW: cobalamin biosynthesis protein CobW', 342, NULL, 'TIGR02475', 290902),
(485228, 'TIGR01869', NULL, 'casC_Cse4: CRISPR-associated protein Cas7/Cse4/CasC, subtype I-E/ECOLI', 325, NULL, 'TIGR01869', 290903),
(485229, 'TIGR01313', NULL, 'therm_gnt_kin: carbohydrate kinase, thermoresistant glucokinase family', 164, NULL, 'TIGR01313', 290904),
(485230, 'TIGR00827', NULL, 'EIIC-GAT: PTS system, galactitol-specific IIC component', 407, NULL, 'TIGR00827', 290905),
(485231, 'TIGR03485', NULL, 'cas_csx13_N: CRISPR-associated protein Cas8a1/Csx13, MYXAN subtype', 316, NULL, 'TIGR03485', 290906),
(485232, 'TIGR04391', NULL, 'CcmD_alt_fam: CcmD family protein', 36, NULL, 'TIGR04391', 290907),
(485233, 'TIGR04508', NULL, 'queE_Cx14CxxC: 7-carboxy-7-deazaguanine synthase', 208, NULL, 'TIGR04508', 290908),
(485234, 'TIGR02323', NULL, 'CP_lyasePhnK: phosphonate C-P lyase system protein PhnK', 239, NULL, 'TIGR02323', 290909),
(485235, 'TIGR02815', NULL, 'agaS_fam: putative sugar isomerase, AgaS family', 372, NULL, 'TIGR02815', 290910),
(485236, 'TIGR02743', NULL, 'TraW: type-F conjugative transfer system protein TraW', 202, NULL, 'TIGR02743', 290911),
(485237, 'TIGR01810', NULL, 'betA: choline dehydrogenase', 532, NULL, 'TIGR01810', 290912),
(485238, 'TIGR03256', NULL, 'met_CoM_red_alp: methyl-coenzyme M reductase, alpha subunit', 548, NULL, 'TIGR03256', 290913),
(485239, 'TIGR04168', NULL, 'TIGR04168: TIGR04168 family protein', 269, NULL, 'TIGR04168', 290914),
(485240, 'TIGR03249', NULL, 'KdgD: 5-dehydro-4-deoxyglucarate dehydratase', 299, NULL, 'TIGR03249', 290915),
(485241, 'TIGR01778', NULL, 'TonB-copper: TonB-dependent copper receptor', 637, NULL, 'TIGR01778', 290916),
(485242, 'TIGR03694', NULL, 'exosort_acyl: N-acyl amino acid synthase, PEP-CTERM/exosortase system-associated', 241, NULL, 'TIGR03694', 290917),
(485243, 'TIGR04515', NULL, 'P450_rel_GT_act: P450-derived glycosyltranferase activator', 386, NULL, 'TIGR04515', 290918),
(485244, 'TIGR00800', NULL, 'ncs1: NCS1 nucleoside transporter family', 447, NULL, 'TIGR00800', 290919),
(485245, 'TIGR00859', NULL, 'ENaC: sodium channel transporter', 596, NULL, 'TIGR00859', 290920),
(485246, 'TIGR01470', NULL, 'cysG_Nterm: siroheme synthase, N-terminal domain', 205, NULL, 'TIGR01470', 290921),
(485247, 'TIGR00551', NULL, 'nadB: L-aspartate oxidase', 489, NULL, 'TIGR00551', 290922),
(485248, 'TIGR01064', NULL, 'pyruv_kin: pyruvate kinase', 476, NULL, 'TIGR01064', 290923),
(485249, 'TIGR02686', NULL, 'relax_trwC: conjugative relaxase domain', 286, NULL, 'TIGR02686', 290924),
(485250, 'TIGR03709', NULL, 'PPK2_rel_1: polyphosphate:nucleotide phosphotransferase, PPK2 family', 264, NULL, 'TIGR03709', 290925),
(485251, 'TIGR00442', NULL, 'hisS: histidine--tRNA ligase', 406, NULL, 'TIGR00442', 290926),
(485252, 'TIGR00562', NULL, 'proto_IX_ox: protoporphyrinogen oxidase', 470, NULL, 'TIGR00562', 290927),
(485253, 'TIGR01842', NULL, 'type_I_sec_PrtD: type I secretion system ATPase', 544, NULL, 'TIGR01842', 290928),
(485254, 'TIGR04175', NULL, 'archaeo_artD: archaeosortase D', 150, NULL, 'TIGR04175', 290929),
(485255, 'TIGR03020', NULL, 'EpsA: transcriptional regulator EpsA', 247, NULL, 'TIGR03020', 290930),
(485256, 'TIGR02997', NULL, 'Sig70-cyanoRpoD: RNA polymerase sigma factor, cyanobacterial RpoD-like family', 298, NULL, 'TIGR02997', 290931),
(485257, 'TIGR03052', NULL, 'PS_I_psaI: photosystem I reaction center subunit VIII', 31, NULL, 'TIGR03052', 290932),
(485258, 'TIGR02221', NULL, 'cas_TM1812: CRISPR-associated protein, TM1812 family', 218, NULL, 'TIGR02221', 290933),
(485259, 'TIGR02105', NULL, 'III_needle: type III secretion apparatus needle protein', 72, NULL, 'TIGR02105', 290934);             
INSERT INTO "PUBLIC"."MODEL" VALUES
(485260, 'TIGR02532', NULL, 'IV_pilin_GFxxxE: prepilin-type N-terminal cleavage/methylation domain', 24, NULL, 'TIGR02532', 290935),
(485261, 'TIGR04311', NULL, 'rSAM_Geo_metal: putative metalloenzyme radical SAM/SPASM domain maturase', 423, NULL, 'TIGR04311', 290936),
(485262, 'TIGR00616', NULL, 'rect: recombinase, phage RecT family', 242, NULL, 'TIGR00616', 290937),
(485263, 'TIGR03376', NULL, 'glycerol3P_DH: glycerol-3-phosphate dehydrogenase (NAD(+))', 342, NULL, 'TIGR03376', 290938),
(485264, 'TIGR03451', NULL, 'mycoS_dep_FDH: S-(hydroxymethyl)mycothiol dehydrogenase', 358, NULL, 'TIGR03451', 290939),
(485265, 'TIGR01887', NULL, 'dipeptidaselike: putative dipeptidase', 447, NULL, 'TIGR01887', 290940),
(485266, 'TIGR01361', NULL, 'DAHP_synth_Bsub: 3-deoxy-7-phosphoheptulonate synthase', 260, NULL, 'TIGR01361', 290941),
(485267, 'TIGR01701', NULL, 'Fdhalpha-like: oxidoreductase alpha (molybdopterin) subunit', 744, NULL, 'TIGR01701', 290942),
(485268, 'TIGR00605', NULL, 'rad4: DNA repair protein rad4', 1047, NULL, 'TIGR00605', 290943),
(485269, 'TIGR04059', NULL, 'Ald_deCOase: long-chain fatty aldehyde decarbonylase', 220, NULL, 'TIGR04059', 290944),
(485270, 'TIGR02761', NULL, 'TraE_TIGR: type IV conjugative transfer system protein TraE', 181, NULL, 'TIGR02761', 290945),
(485271, 'TIGR03857', NULL, 'F420_MSMEG_2249: probable F420-dependent oxidoreductase, MSMEG_2249 family', 329, NULL, 'TIGR03857', 290946),
(485272, 'TIGR00671', NULL, 'baf: pantothenate kinase, type III', 243, NULL, 'TIGR00671', 290947),
(485273, 'TIGR01767', NULL, 'MTRK: S-methyl-5-thioribose kinase', 369, NULL, 'TIGR01767', 290948),
(485274, 'TIGR04304', NULL, 'GeoRSP_SPASM: GeoRSP system SPASM domain protein', 293, NULL, 'TIGR04304', 290949),
(485275, 'TIGR03369', NULL, 'cellulose_bcsE: cellulose biosynthesis protein BcsE', 322, NULL, 'TIGR03369', 290950),
(485276, 'TIGR00163', NULL, 'PS_decarb: phosphatidylserine decarboxylase', 243, NULL, 'TIGR00163', 290951),
(485277, 'TIGR02214', NULL, 'spoVD_pbp: stage V sporulation protein D', 636, NULL, 'TIGR02214', 290952),
(485278, 'TIGR01082', NULL, 'murC: UDP-N-acetylmuramate--L-alanine ligase', 449, NULL, 'TIGR01082', 290953),
(485279, 'TIGR04130', NULL, 'FnlA: UDP-N-acetylglucosamine 4,6-dehydratase/5-epimerase', 337, NULL, 'TIGR04130', 290954),
(485280, 'TIGR00968', NULL, '3a0106s01: sulfate ABC transporter, ATP-binding protein', 237, NULL, 'TIGR00968', 290955),
(485281, 'TIGR03267', NULL, 'methan_mark_2: putative methanogenesis marker protein 2', 323, NULL, 'TIGR03267', 290956),
(485282, 'TIGR03147', NULL, 'cyt_nit_nrfF: cytochrome c nitrite reductase, accessory protein NrfF', 126, NULL, 'TIGR03147', 290957),
(485283, 'TIGR03560', NULL, 'F420_Rv1855c: probable F420-dependent oxidoreductase, Rv1855c family', 227, NULL, 'TIGR03560', 290958),
(485284, 'TIGR02112', NULL, 'cyd_oper_ybgE: cyd operon protein YbgE', 93, NULL, 'TIGR02112', 290959),
(485285, 'TIGR00902', NULL, '2A0127: MFS transporter, phenyl propionate permease (PPP) family', 388, NULL, 'TIGR00902', 290960),
(485286, 'TIGR01951', NULL, 'nusB: transcription antitermination factor NusB', 131, NULL, 'TIGR01951', 290961),
(485287, 'TIGR04250', NULL, 'SCM_rSAM_ScmE: SynChlorMet cassette radical SAM/SPASM protein ScmE', 358, NULL, 'TIGR04250', 290962),
(485288, 'TIGR03716', NULL, 'R_switched_YkoY: integral membrane protein, YkoY family', 220, NULL, 'TIGR03716', 290963),
(485289, 'TIGR01075', NULL, 'uvrD: DNA helicase II', 715, NULL, 'TIGR01075', 290964),
(485290, 'TIGR02577', NULL, 'cas_TM1794_Cmr2: CRISPR-associated protein Cas10/Cmr2, subtype III-B', 510, NULL, 'TIGR02577', 290965),
(485291, 'TIGR00156', NULL, 'TIGR00156: TIGR00156 family protein', 128, NULL, 'TIGR00156', 290966),
(485292, 'TIGR01302', NULL, 'IMP_dehydrog: inosine-5''-monophosphate dehydrogenase', 450, NULL, 'TIGR01302', 290967),
(485293, 'TIGR01658', NULL, 'EYA-cons_domain: EYA conserved domain', 274, NULL, 'TIGR01658', 290968),
(485294, 'TIGR02457', NULL, 'TreS_Cterm: putative maltokinase', 529, NULL, 'TIGR02457', 290969),
(485295, 'TIGR03959', NULL, 'hyd_TM1266: putative iron-only hydrogenase system regulator', 76, NULL, 'TIGR03959', 290970);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(485296, 'TIGR01422', NULL, 'phosphonatase: phosphonoacetaldehyde hydrolase', 253, NULL, 'TIGR01422', 290971),
(485297, 'TIGR04493', NULL, 'microcomp_PduM: microcompartment protein PduM', 153, NULL, 'TIGR04493', 290972),
(485298, 'TIGR00503', NULL, 'prfC: peptide chain release factor 3', 527, NULL, 'TIGR00503', 290973),
(485299, 'TIGR04406', NULL, 'LPS_export_lptB: LPS export ABC transporter ATP-binding protein', 239, NULL, 'TIGR04406', 290974),
(485300, 'TIGR00385', NULL, 'dsbE: periplasmic protein thiol:disulfide oxidoreductases, DsbE subfamily', 173, NULL, 'TIGR00385', 290975),
(485301, 'TIGR03796', NULL, 'NHLM_micro_ABC1: NHLM bacteriocin system ABC transporter, peptidase/ATP-binding protein', 710, NULL, 'TIGR03796', 290976),
(485302, 'TIGR04413', NULL, 'MYXAN_cmx8: CRISPR type MYXAN-associated protein Cmx8', 537, NULL, 'TIGR04413', 290977),
(485303, 'TIGR03383', NULL, 'urate_oxi: urate oxidase', 283, NULL, 'TIGR03383', 290978),
(485304, 'TIGR01415', NULL, 'trpB_rel: pyridoxal-phosphate dependent TrpB-like enzyme', 419, NULL, 'TIGR01415', 290979),
(485305, 'TIGR04066', NULL, 'nat_prod_clost: peptide maturation system protein, TIGR04066 family', 361, NULL, 'TIGR04066', 290980),
(485306, 'TIGR03331', NULL, 'SAM_DCase_Eco: S-adenosylmethionine decarboxylase proenzyme', 259, NULL, 'TIGR03331', 290981),
(485307, 'TIGR01068', NULL, 'thioredoxin: thioredoxin', 101, NULL, 'TIGR01068', 290982),
(485308, 'TIGR00718', NULL, 'sda_alpha: L-serine dehydratase, iron-sulfur-dependent, alpha subunit', 300, NULL, 'TIGR00718', 290983),
(485309, 'TIGR03900', NULL, 'prc_long_Delta: putative carboxyl-terminal-processing protease, deltaproteobacterial', 973, NULL, 'TIGR03900', 290984),
(485310, 'TIGR00725', NULL, 'TIGR00725: TIGR00725 family protein', 159, NULL, 'TIGR00725', 290985),
(485311, 'TIGR02870', NULL, 'spore_II_D: stage II sporulation protein D', 338, NULL, 'TIGR02870', 290986),
(485312, 'TIGR04073', NULL, 'exo_TIGR04073: putative exosortase-associated protein, TIGR04073 family', 75, NULL, 'TIGR04073', 290987),
(485313, 'TIGR00378', NULL, 'cax: calcium/proton exchanger', 349, NULL, 'TIGR00378', 290988),
(485314, 'TIGR02641', NULL, 'gvpC_cyan_rpt: gas vesicle protein GvpC repeat', 33, NULL, 'TIGR02641', 290989),
(485315, 'TIGR01408', NULL, 'Ube1: ubiquitin-activating enzyme E1', 1008, NULL, 'TIGR01408', 290990),
(485316, 'TIGR03154', NULL, 'sulfolob_CbsA: cytochrome b558/566, subunit A', 465, NULL, 'TIGR03154', 290991),
(485317, 'TIGR03585', NULL, 'PseH: UDP-4-amino-4,6-dideoxy-N-acetyl-beta-L-altrosamine N-acetyltransferase', 156, NULL, 'TIGR03585', 290992),
(485318, 'TIGR00512', NULL, 'salvage_mtnA: S-methyl-5-thioribose-1-phosphate isomerase', 335, NULL, 'TIGR00512', 290993),
(485319, 'TIGR01495', NULL, 'ETRAMP: early transcribed membrane protein (ETRAMP) family', 85, NULL, 'TIGR01495', 290994),
(485320, 'TIGR04554', NULL, '3TM_mycoplas: three transmembrane helix protein', 105, NULL, 'TIGR04554', 290995),
(485321, 'TIGR01030', NULL, 'rpmH_bact: ribosomal protein bL34', 44, NULL, 'TIGR01030', 290996),
(485322, 'TIGR02602', NULL, '8TM_EpsH: exosortase', 241, NULL, 'TIGR02602', 290997),
(485323, 'TIGR02915', NULL, 'PEP_resp_reg: PEP-CTERM-box response regulator transcription factor', 445, NULL, 'TIGR02915', 290998),
(485324, 'TIGR03553', NULL, 'F420_FbiB_CTERM: F420 biosynthesis protein FbiB, C-terminal domain', 194, NULL, 'TIGR03553', 290999),
(485325, 'TIGR01463', NULL, 'mtaA_cmuA: methyltransferase, MtaA/CmuA family', 340, NULL, 'TIGR01463', 291000),
(485326, 'TIGR03723', NULL, 'T6A_TsaD_YgjD: tRNA threonylcarbamoyl adenosine modification protein TsaD', 314, NULL, 'TIGR03723', 291001),
(485327, 'TIGR02432', NULL, 'lysidine_TilS_N: tRNA(Ile)-lysidine synthetase', 189, NULL, 'TIGR02432', 291002),
(485328, 'TIGR02151', NULL, 'IPP_isom_2: isopentenyl-diphosphate delta-isomerase, type 2', 338, NULL, 'TIGR02151', 291003),
(485329, 'TIGR04522', NULL, 'EcfS_MSC_0063: putative energy coupling factor transporter S component', 152, NULL, 'TIGR04522', 291004),
(485330, 'TIGR00061', NULL, 'L21: ribosomal protein bL21', 101, NULL, 'TIGR00061', 291005);
INSERT INTO "PUBLIC"."MODEL" VALUES
(485331, 'TIGR01946', NULL, 'rnfD: electron transport complex, RnfABCDGE type, D subunit', 327, NULL, 'TIGR01946', 291006),
(485332, 'TIGR03120', NULL, 'one_C_mch: methenyltetrahydromethanopterin cyclohydrolase', 313, NULL, 'TIGR03120', 291007),
(485333, 'TIGR01633', NULL, 'phi3626_gp14_N: putative phage tail component, N-terminal domain', 123, NULL, 'TIGR01633', 291008),
(485334, 'TIGR04393', NULL, 'rpt_T5SS_PEPC: T5SS/PEP-CTERM-associated repeat', 49, NULL, 'TIGR04393', 291009),
(485335, 'TIGR03866', NULL, 'PQQ_ABC_repeats: PQQ-dependent catabolism-associated beta-propeller protein', 310, NULL, 'TIGR03866', 291010),
(485336, 'TIGR01200', NULL, 'GLPGLI: GLPGLI family protein', 229, NULL, 'TIGR01200', 291011),
(485337, 'TIGR04009', NULL, 'wcaE: colanic acid biosynthesis glycosyltransferase WcaE', 248, NULL, 'TIGR04009', 291012),
(485338, 'TIGR04241', NULL, 'adenoE3CR1rpt: mastadenovirus E3 CR1-alpha-1', 81, NULL, 'TIGR04241', 291013),
(485339, 'TIGR01776', NULL, 'TonB-tbp-lbp: TonB-dependent lactoferrin and transferrin receptors', 946, NULL, 'TIGR01776', 291014),
(485340, 'TIGR00383', NULL, 'corA: magnesium and cobalt transport protein CorA', 320, NULL, 'TIGR00383', 291015),
(485341, 'TIGR00834', NULL, 'ae: anion exchange protein', 900, NULL, 'TIGR00834', 291016),
(485342, 'TIGR00825', NULL, 'EIIBC-GUT: PTS system, glucitol/sorbitol-specific, IIBC component', 331, NULL, 'TIGR00825', 291017),
(485343, 'TIGR01141', NULL, 'hisC: histidinol-phosphate transaminase', 349, NULL, 'TIGR01141', 291018),
(485344, 'TIGR03231', NULL, 'anthran_1_2_B: anthranilate 1,2-dioxygenase, small subunit', 155, NULL, 'TIGR03231', 291019),
(485345, 'TIGR00664', NULL, 'DNA_III_psi: DNA polymerase III, psi subunit', 131, NULL, 'TIGR00664', 291020),
(485346, 'TIGR01835', NULL, 'HMG-CoA-S_prok: hydroxymethylglutaryl-CoA synthase', 382, NULL, 'TIGR01835', 291021),
(485347, 'TIGR01311', NULL, 'glycerol_kin: glycerol kinase', 496, NULL, 'TIGR01311', 291022),
(485348, 'TIGR04071', NULL, 'methanobac_OB3b: methanobactin precursor, Mb-OB3b family', 30, NULL, 'TIGR04071', 291023),
(485349, 'TIGR03755', NULL, 'conj_TIGR03755: integrating conjugative element protein, PFL_4711 family', 419, NULL, 'TIGR03755', 291024),
(485350, 'TIGR03925', NULL, 'T7SS_EccC_b: type VII secretion protein EccCb', 564, NULL, 'TIGR03925', 291025),
(485351, 'TIGR03696', NULL, 'Rhs_assc_core: RHS repeat-associated core domain', 76, NULL, 'TIGR03696', 291026),
(485352, 'TIGR00494', NULL, 'crcB: protein CrcB', 117, NULL, 'TIGR00494', 291027),
(485353, 'TIGR01665', NULL, 'put_anti_recept: phage minor structural protein, N-terminal region', 316, NULL, 'TIGR01665', 291028),
(485354, 'TIGR03401', NULL, 'cyanamide_fam: HD domain protein, cyanamide hydratase family', 228, NULL, 'TIGR03401', 291029),
(485355, 'TIGR04182', NULL, 'glyco_TIGR04182: glycosyltransferase, TIGR04182 family', 293, NULL, 'TIGR04182', 291030),
(485356, 'TIGR00401', NULL, 'msrA: peptide-methionine (S)-S-oxide reductase', 153, NULL, 'TIGR00401', 291031),
(485357, 'TIGR01987', NULL, 'HI0074: nucleotidyltransferase substrate binding protein, HI0074 family', 123, NULL, 'TIGR01987', 291032),
(485358, 'TIGR00020', NULL, 'prfB: peptide chain release factor 2', 365, NULL, 'TIGR00020', 291033),
(485359, 'TIGR01522', NULL, 'ATPase-IIA2_Ca: calcium-transporting P-type ATPase, PMR1-type', 854, NULL, 'TIGR01522', 291034),
(485360, 'TIGR02160', NULL, 'PA_CoA_Oxy5: phenylacetate-CoA oxygenase/reductase, PaaK subunit', 352, NULL, 'TIGR02160', 291035),
(485361, 'TIGR02423', NULL, 'protocat_alph: protocatechuate 3,4-dioxygenase, alpha subunit', 193, NULL, 'TIGR02423', 291036),
(485362, 'TIGR03544', NULL, 'DivI1A_domain: DivIVA domain', 34, NULL, 'TIGR03544', 291037),
(485363, 'TIGR00172', NULL, 'maf: septum formation protein Maf', 185, NULL, 'TIGR00172', 291038),
(485364, 'TIGR02192', NULL, 'HtrL_YibB: protein YibB', 270, NULL, 'TIGR02192', 291039),
(485365, 'TIGR02473', NULL, 'flagell_FliJ: flagellar export protein FliJ', 141, NULL, 'TIGR02473', 291040),
(485366, 'TIGR00655', NULL, 'PurU: formyltetrahydrofolate deformylase', 280, NULL, 'TIGR00655', 291041);       
INSERT INTO "PUBLIC"."MODEL" VALUES
(485367, 'TIGR04411', NULL, 'T2SS_GspN_Lepto: type II secretion system protein N', 280, NULL, 'TIGR04411', 291042),
(485368, 'TIGR04352', NULL, 'HprK_rel_A: HprK-related kinase A', 280, NULL, 'TIGR04352', 291043),
(485369, 'TIGR01803', NULL, 'CM-like: chorismate mutase related enzymes', 82, NULL, 'TIGR01803', 291044),
(485370, 'TIGR01674', NULL, 'phage_lambda_G: phage minor tail protein G', 138, NULL, 'TIGR01674', 291045),
(485371, 'TIGR00231', NULL, 'small_GTP: small GTP-binding protein domain', 164, NULL, 'TIGR00231', 291046),
(485372, 'TIGR00485', NULL, 'EF-Tu: translation elongation factor Tu', 394, NULL, 'TIGR00485', 291047),
(485373, 'TIGR03374', NULL, 'ABALDH: 1-pyrroline dehydrogenase', 472, NULL, 'TIGR03374', 291048),
(485374, 'TIGR03825', NULL, 'FliH_bacil: flagellar assembly protein FliH', 255, NULL, 'TIGR03825', 291049),
(485375, 'TIGR02330', NULL, 'prpD: 2-methylcitrate dehydratase', 468, NULL, 'TIGR02330', 291050),
(485376, 'TIGR03222', NULL, 'benzo_boxC: benzoyl-CoA-dihydrodiol lyase', 548, NULL, 'TIGR03222', 291051),
(485377, 'TIGR00696', NULL, 'wecG_tagA_cpsF: glycosyltransferase, WecB/TagA/CpsF family', 178, NULL, 'TIGR00696', 291052),
(485378, 'TIGR01293', NULL, 'Kv_beta: voltage-dependent potassium channel beta subunit', 319, NULL, 'TIGR01293', 291053),
(485379, 'TIGR00342', NULL, 'TIGR00342: tRNA sulfurtransferase ThiI', 373, NULL, 'TIGR00342', 291054),
(485380, 'TIGR01018', NULL, 'uS4_arch: ribosomal protein uS4', 162, NULL, 'TIGR01018', 291055),
(485381, 'TIGR04495', NULL, 'RiPP_XyeA: putative rSAM-modified RiPP, XyeA family', 50, NULL, 'TIGR04495', 291056),
(485382, 'TIGR01182', NULL, 'eda: 2-dehydro-3-deoxyphosphogluconate aldolase/4-hydroxy-2-oxoglutarate aldolase', 204, NULL, 'TIGR01182', 291057),
(485383, 'TIGR02965', NULL, 'xanthine_xdhB: xanthine dehydrogenase, molybdopterin binding subunit', 758, NULL, 'TIGR02965', 291058),
(485384, 'TIGR04200', NULL, 'targ_of_XrtJ: XrtJ-associated TM-motif-TM protein', 60, NULL, 'TIGR04200', 291059),
(485385, 'TIGR04030', NULL, 'perox_Avi_7169: alkylhydroperoxidase domain protein, Avi_7169 family', 185, NULL, 'TIGR04030', 291060),
(485386, 'TIGR01352', NULL, 'tonB_Cterm: TonB family C-terminal domain', 76, NULL, 'TIGR01352', 291061),
(485387, 'TIGR00008', NULL, 'infA: translation initiation factor IF-1', 69, NULL, 'TIGR00008', 291062),
(485388, 'TIGR00977', NULL, 'citramal_synth: citramalate synthase', 526, NULL, 'TIGR00977', 291063),
(485389, 'TIGR03714', NULL, 'secA2: accessory Sec system translocase SecA2', 762, NULL, 'TIGR03714', 291064),
(485390, 'TIGR02795', NULL, 'tol_pal_ybgF: tol-pal system protein YbgF', 119, NULL, 'TIGR02795', 291065),
(485391, 'TIGR03655', NULL, 'anti_R_Lar: restriction alleviation protein, Lar family', 55, NULL, 'TIGR03655', 291066),
(485392, 'TIGR04384', NULL, 'putr_carbamoyl: putrescine carbamoyltransferase', 330, NULL, 'TIGR04384', 291067),
(485393, 'TIGR02083', NULL, 'LEU2: 3-isopropylmalate dehydratase, large subunit', 419, NULL, 'TIGR02083', 291068),
(485394, 'TIGR02500', NULL, 'type_III_yscD: type III secretion apparatus protein, YscD/HrpQ family', 413, NULL, 'TIGR02500', 291069),
(485395, 'TIGR01565', NULL, 'homeo_ZF_HD: homeobox domain, ZF-HD class', 58, NULL, 'TIGR01565', 291070),
(485396, 'TIGR02534', NULL, 'mucon_cyclo: muconate and chloromuconate cycloisomerases', 368, NULL, 'TIGR02534', 291071),
(485397, 'TIGR04173', NULL, 'PIP_CTERM: PIP-CTERM protein sorting domain', 27, NULL, 'TIGR04173', 291072),
(485398, 'TIGR00410', NULL, 'lacE: PTS system, lactose/cellobiose family IIC component', 424, NULL, 'TIGR00410', 291073),
(485399, 'TIGR00596', NULL, 'rad1: DNA repair protein (rad1)', 813, NULL, 'TIGR00596', 291074),
(485400, 'TIGR01563', NULL, 'gp16_SPP1: putative phage head-tail adaptor', 101, NULL, 'TIGR01563', 291075),
(485401, 'TIGR04291', NULL, 'arsen_driv_ArsA: arsenical pump-driving ATPase', 565, NULL, 'TIGR04291', 291076),
(485402, 'TIGR03934', NULL, 'TQXA_dom: TQXA domain', 42, NULL, 'TIGR03934', 291077),
(485403, 'TIGR02999', NULL, 'Sig-70_X6: RNA polymerase sigma factor, TIGR02999 family', 183, NULL, 'TIGR02999', 291078);         
INSERT INTO "PUBLIC"."MODEL" VALUES
(485404, 'TIGR00131', NULL, 'gal_kin: galactokinase', 388, NULL, 'TIGR00131', 291079),
(485405, 'TIGR01844', NULL, 'type_I_sec_TolC: type I secretion outer membrane protein, TolC family', 414, NULL, 'TIGR01844', 291080),
(485406, 'TIGR04452', NULL, 'Lepto_Lipo_YY_C: small lipoprotein, LA_3946 family', 116, NULL, 'TIGR04452', 291081),
(485407, 'TIGR02704', NULL, 'carboxysome_B: carboxysome peptide B', 80, NULL, 'TIGR02704', 291082),
(485408, 'TIGR00927', NULL, '2A1904: K+-dependent Na+/Ca+ exchanger', 1209, NULL, 'TIGR00927', 291083),
(485409, 'TIGR02364', NULL, 'dha_pts: dihydroxyacetone kinase, phosphotransfer subunit', 125, NULL, 'TIGR02364', 291084),
(485410, 'TIGR04343', NULL, 'egtE_PLP_lyase: ergothioneine biosynthesis PLP-dependent enzyme EgtE', 370, NULL, 'TIGR04343', 291085),
(485411, 'TIGR00766', NULL, 'TIGR00766: inner membrane protein YhjD', 263, NULL, 'TIGR00766', 291086),
(485412, 'TIGR01733', NULL, 'AA-adenyl-dom: amino acid adenylation domain', 409, NULL, 'TIGR01733', 291087),
(485413, 'TIGR02888', NULL, 'spore_YlmC_YmxH: sporulation protein, YlmC/YmxH family', 76, NULL, 'TIGR02888', 291088),
(485414, 'TIGR03823', NULL, 'FliZ: flagellar regulatory protein FliZ', 168, NULL, 'TIGR03823', 291089),
(485415, 'TIGR04454', NULL, 'Lepto_4Cys: small lipoprotein, LB_250 family', 92, NULL, 'TIGR04454', 291090),
(485416, 'TIGR00049', NULL, 'TIGR00049: iron-sulfur cluster assembly accessory protein', 106, NULL, 'TIGR00049', 291091),
(485417, 'TIGR02309', NULL, 'HpaB-1: 4-hydroxyphenylacetate 3-monooxygenase, oxygenase component', 477, NULL, 'TIGR02309', 291092),
(485418, 'TIGR03653', NULL, 'uL6_arch: ribosomal protein uL6', 170, NULL, 'TIGR03653', 291093),
(485419, 'TIGR02139', NULL, 'permease_CysT: sulfate ABC transporter, permease protein CysT', 265, NULL, 'TIGR02139', 291094),
(485420, 'TIGR01393', NULL, 'lepA: elongation factor 4', 595, NULL, 'TIGR01393', 291095),
(485421, 'TIGR04461', NULL, 'endura_MppQ: enduracididine biosynthesis enzyme MppQ', 392, NULL, 'TIGR04461', 291096),
(485422, 'TIGR04284', NULL, 'aldehy_Rv0768: aldehyde dehydrogenase, Rv0768 family', 480, NULL, 'TIGR04284', 291097),
(485423, 'TIGR02253', NULL, 'CTE7: HAD hydrolase, TIGR02253 family', 221, NULL, 'TIGR02253', 291098),
(485424, 'TIGR02371', NULL, 'ala_DH_arch: alanine dehydrogenase', 325, NULL, 'TIGR02371', 291099),
(485425, 'TIGR00219', NULL, 'mreC: rod shape-determining protein MreC', 283, NULL, 'TIGR00219', 291100),
(485426, 'TIGR03483', NULL, 'FtsZ_alphas_C: cell division protein FtsZ, alphaProteobacterial C-terminal extension', 121, NULL, 'TIGR03483', 291101),
(485427, 'TIGR00936', NULL, 'ahcY: adenosylhomocysteinase', 416, NULL, 'TIGR00936', 291102),
(485428, 'TIGR00934', NULL, '2a38euk: potassium uptake protein, Trk family', 836, NULL, 'TIGR00934', 291103),
(485429, 'TIGR00070', NULL, 'hisG: ATP phosphoribosyltransferase', 183, NULL, 'TIGR00070', 291104),
(485430, 'TIGR04513', NULL, 'VPAMP_CTERM: VPAMP-CTERM protein sorting domain', 28, NULL, 'TIGR04513', 291105),
(485431, 'TIGR03594', NULL, 'GTPase_EngA: ribosome-associated GTPase EngA', 432, NULL, 'TIGR03594', 291106),
(485432, 'TIGR01454', NULL, 'AHBA_synth_RP: AHBA synthesis associated protein', 205, NULL, 'TIGR01454', 291107),
(485433, 'TIGR02956', NULL, 'TMAO_torS: TMAO reductase sytem sensor TorS', 967, NULL, 'TIGR02956', 291108),
(485434, 'TIGR01572', NULL, 'A_thl_para_3677: Arabidopsis paralogous family TIGR01572', 265, NULL, 'TIGR01572', 291109),
(485435, 'TIGR03011', NULL, 'sulf_tusB_dsrH: sulfur relay protein TusB/DsrH', 95, NULL, 'TIGR03011', 291110),
(485436, 'TIGR03061', NULL, 'pip_yhgE_Nterm: YhgE/Pip N-terminal domain', 164, NULL, 'TIGR03061', 291111),
(485437, 'TIGR00587', NULL, 'nfo: apurinic endonuclease (APN1)', 279, NULL, 'TIGR00587', 291112),
(485438, 'TIGR03476', NULL, 'HpnL: putative membrane protein', 318, NULL, 'TIGR03476', 291113),
(485439, 'TIGR01905', NULL, 'paired_CXXCH_1: doubled CXXCH domain', 41, NULL, 'TIGR01905', 291114),
(485440, 'TIGR03764', NULL, 'ICE_PFGI_1_parB: integrating conjugative element, PFGI_1 class, ParB family protein', 260, NULL, 'TIGR03764', 291115);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(485441, 'TIGR04563', NULL, 'TIGR04563: MXAN_4361/MXAN_4362 family small protein', 53, NULL, 'TIGR04563', 291116),
(485442, 'TIGR02092', NULL, 'glgD: glucose-1-phosphate adenylyltransferase, GlgD subunit', 370, NULL, 'TIGR02092', 291117),
(485443, 'TIGR03646', NULL, 'YtoQ_fam: YtoQ family protein', 144, NULL, 'TIGR03646', 291118),
(485444, 'TIGR02321', NULL, 'Pphn_pyruv_hyd: phosphonopyruvate hydrolase', 290, NULL, 'TIGR02321', 291119),
(485445, 'TIGR02090', NULL, 'LEU1_arch: isopropylmalate/citramalate/homocitrate synthases', 363, NULL, 'TIGR02090', 291120),
(485446, 'TIGR00403', NULL, 'ndhI: NADH-plastoquinone oxidoreductase, I subunit', 183, NULL, 'TIGR00403', 291121),
(485447, 'TIGR02262', NULL, 'benz_CoA_lig: benzoate-CoA ligase family', 508, NULL, 'TIGR02262', 291122),
(485448, 'TIGR00757', NULL, 'RNaseEG: ribonuclease, Rne/Rng family', 415, NULL, 'TIGR00757', 291123),
(485449, 'TIGR01395', NULL, 'FlgC: flagellar basal-body rod protein FlgC', 137, NULL, 'TIGR01395', 291124),
(485450, 'TIGR02897', NULL, 'QoxC: cytochrome aa3 quinol oxidase, subunit III', 190, NULL, 'TIGR02897', 291125),
(485451, 'TIGR02786', NULL, 'addB_alphas: double-strand break repair protein AddB', 1024, NULL, 'TIGR02786', 291126),
(485452, 'TIGR03816', NULL, 'tadE_like_DECH: helicase/secretion neighborhood TadE-like protein', 109, NULL, 'TIGR03816', 291127),
(485453, 'TIGR01742', NULL, 'SA_tandem_lipo: Staphylococcus tandem lipoproteins', 255, NULL, 'TIGR01742', 291128),
(485454, 'TIGR00233', NULL, 'trpS: tryptophan--tRNA ligase', 328, NULL, 'TIGR00233', 291129),
(485455, 'TIGR01735', NULL, 'FGAM_synt: phosphoribosylformylglycinamidine synthase', 1307, NULL, 'TIGR01735', 291130),
(485456, 'TIGR00875', NULL, 'fsa_talC_mipB: fructose-6-phosphate aldolase', 213, NULL, 'TIGR00875', 291131),
(485457, 'TIGR01284', NULL, 'alt_nitrog_alph: nitrogenase alpha chain', 457, NULL, 'TIGR01284', 291132),
(485458, 'TIGR04282', NULL, 'glyco_like_cofC: transferase 1, rSAM/selenodomain-associated', 189, NULL, 'TIGR04282', 291133),
(485459, 'TIGR00122', NULL, 'birA_repr_reg: biotin operon repressor', 69, NULL, 'TIGR00122', 291134),
(485460, 'TIGR00594', NULL, 'polc: DNA polymerase III, alpha subunit', 1022, NULL, 'TIGR00594', 291135),
(485461, 'TIGR03108', NULL, 'eps_aminotran_1: exosortase A system-associated amidotransferase 1', 628, NULL, 'TIGR03108', 291136),
(485462, 'TIGR03927', NULL, 'T7SS_EssA_Firm: type VII secretion protein EssA', 151, NULL, 'TIGR03927', 291137),
(485463, 'TIGR00764', NULL, 'lon_rel: putative ATP-dependent protease', 608, NULL, 'TIGR00764', 291138),
(485464, 'TIGR01100', NULL, 'V_ATP_synt_C: V-type ATPase, C subunit', 108, NULL, 'TIGR01100', 291139),
(485465, 'TIGR01624', NULL, 'LRP1_Cterm: LRP1 C-terminal domain', 50, NULL, 'TIGR01624', 291140),
(485466, 'TIGR00240', NULL, 'ATCase_reg: aspartate carbamoyltransferase, regulatory subunit', 150, NULL, 'TIGR00240', 291141),
(485467, 'TIGR01912', NULL, 'TatC-Arch: Sec-independent protein translocase TatC', 234, NULL, 'TIGR01912', 291142),
(485468, 'TIGR01515', NULL, 'branching_enzym: 1,4-alpha-glucan branching enzyme', 607, NULL, 'TIGR01515', 291143),
(485469, 'TIGR04520', NULL, 'ECF_ATPase_1: energy-coupling factor transporter ATPase', 269, NULL, 'TIGR04520', 291144),
(485470, 'TIGR00492', NULL, 'alr: alanine racemase', 369, NULL, 'TIGR00492', 291145),
(485471, 'TIGR03551', NULL, 'F420_cofH: 7,8-didemethyl-8-hydroxy-5-deazariboflavin synthase, CofH subunit', 345, NULL, 'TIGR03551', 291146),
(485472, 'TIGR02582', NULL, 'cas7_TM1809: CRISPR type III-A/MTUBE-associated RAMP protein Csm3', 203, NULL, 'TIGR02582', 291147),
(485473, 'TIGR02001', NULL, 'gcw_chp: conserved hypothetical protein', 244, NULL, 'TIGR02001', 291148),
(485474, 'TIGR01667', NULL, 'YCCS_YHJK: integral membrane protein, YccS/YhfK family', 701, NULL, 'TIGR01667', 291149),
(485475, 'TIGR02636', NULL, 'galM_Leloir: galactose mutarotase', 336, NULL, 'TIGR02636', 291150),
(485476, 'TIGR00063', NULL, 'folE: GTP cyclohydrolase I', 180, NULL, 'TIGR00063', 291151),
(485477, 'TIGR00546', NULL, 'lnt: apolipoprotein N-acyltransferase', 395, NULL, 'TIGR00546', 291152);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(485478, 'TIGR04329', NULL, 'cas1_PREFRAN: CRISPR-associated endonuclease Cas1, subtype PREFRAN', 317, NULL, 'TIGR04329', 291153),
(485479, 'TIGR01497', NULL, 'kdpB: K+-transporting ATPase, B subunit', 675, NULL, 'TIGR01497', 291154),
(485480, 'TIGR03435', NULL, 'Soli_TIGR03435: soil-associated protein, TIGR03435 family', 241, NULL, 'TIGR03435', 291155),
(485481, 'TIGR04159', NULL, 'methbact_MbnB: methanobactin biosynthesis cassette protein MbnB', 91, NULL, 'TIGR04159', 291156),
(485482, 'TIGR01345', NULL, 'malate_syn_G: malate synthase G', 721, NULL, 'TIGR01345', 291157),
(485483, 'TIGR01032', NULL, 'rplT_bact: ribosomal protein bL20', 114, NULL, 'TIGR01032', 291158),
(485484, 'TIGR00698', NULL, 'TIGR00698: conserved hypothetical protein', 335, NULL, 'TIGR00698', 291159),
(485485, 'TIGR01461', NULL, 'greB: transcription elongation factor GreB', 156, NULL, 'TIGR01461', 291160),
(485486, 'TIGR03605', NULL, 'antibiot_sagB: SagB-type dehydrogenase domain', 173, NULL, 'TIGR03605', 291161),
(485487, 'TIGR02806', NULL, 'clostrip: clostripain', 472, NULL, 'TIGR02806', 291162),
(485488, 'TIGR01291', NULL, 'nodJ: ABC-2 type transporter, NodJ family', 253, NULL, 'TIGR01291', 291163),
(485489, 'TIGR00716', NULL, 'rnhC: ribonuclease HIII', 284, NULL, 'TIGR00716', 291164),
(485490, 'TIGR00868', NULL, 'hCaCC: calcium-activated chloride channel protein 1', 863, NULL, 'TIGR00868', 291165),
(485491, 'TIGR01783', NULL, 'TonB-siderophor: TonB-dependent siderophore receptor', 649, NULL, 'TIGR01783', 291166),
(485492, 'TIGR04350', NULL, 'C_S_lyase_PatB: putative C-S lyase', 384, NULL, 'TIGR04350', 291167),
(485493, 'TIGR00621', NULL, 'ssb: single-stranded DNA-binding protein', 166, NULL, 'TIGR00621', 291168),
(485494, 'TIGR04016', NULL, 'WcaB: colanic acid biosynthesis acetyltransferase WcaB', 146, NULL, 'TIGR04016', 291169),
(485495, 'TIGR03381', NULL, 'agmatine_aguB: N-carbamoylputrescine amidase', 279, NULL, 'TIGR03381', 291170),
(485496, 'TIGR03873', NULL, 'F420-0_ABC_ATP: proposed F420-0 ABC transporter, ATP-binding protein', 256, NULL, 'TIGR03873', 291171),
(485497, 'TIGR02711', NULL, 'symport_actP: cation/acetate symporter ActP', 549, NULL, 'TIGR02711', 291172),
(485498, 'TIGR02296', NULL, 'HpaC: 4-hydroxyphenylacetate 3-monooxygenase, reductase component', 154, NULL, 'TIGR02296', 291173),
(485499, 'TIGR04556', NULL, 'PKS_assoc: polyketide synthase-associated domain', 226, NULL, 'TIGR04556', 291174),
(485500, 'TIGR04386', NULL, 'ThiC_like_1: ThiC-like protein 1', 426, NULL, 'TIGR04386', 291175),
(485501, 'TIGR00376', NULL, 'TIGR00376: putative DNA helicase', 639, NULL, 'TIGR00376', 291176),
(485502, 'TIGR00006', NULL, 'TIGR00006: 16S rRNA (cytosine(1402)-N(4))-methyltransferase', 310, NULL, 'TIGR00006', 291177),
(485503, 'TIGR01953', NULL, 'NusA: transcription termination factor NusA', 340, NULL, 'TIGR01953', 291178),
(485504, 'TIGR02970', NULL, 'succ_dehyd_cytB: succinate dehydrogenase, cytochrome b556 subunit', 120, NULL, 'TIGR02970', 291179),
(485505, 'TIGR02466', NULL, 'TIGR02466: conserved hypothetical protein', 201, NULL, 'TIGR02466', 291180),
(485506, 'TIGR00505', NULL, 'ribA: GTP cyclohydrolase II', 191, NULL, 'TIGR00505', 291181),
(485507, 'TIGR03510', NULL, 'XapX: XapX domain', 49, NULL, 'TIGR03510', 291182),
(485508, 'TIGR00158', NULL, 'L9: ribosomal protein bL9', 148, NULL, 'TIGR00158', 291183),
(485509, 'TIGR00984', NULL, '3a0801s03tim44: mitochondrial import inner membrane, translocase subunit', 376, NULL, 'TIGR00984', 291184),
(485510, 'TIGR02541', NULL, 'flagell_FlgJ: flagellar rod assembly protein/muramidase FlgJ', 294, NULL, 'TIGR02541', 291185),
(485511, 'TIGR02042', NULL, 'sir: sulfite reductase, ferredoxin dependent', 581, NULL, 'TIGR02042', 291186),
(485512, 'TIGR02194', NULL, 'GlrX_NrdH: glutaredoxin-like protein NrdH', 72, NULL, 'TIGR02194', 291187),
(485513, 'TIGR01175', NULL, 'pilM: type IV pilus assembly protein PilM', 348, NULL, 'TIGR01175', 291188),
(485514, 'TIGR02677', NULL, 'TIGR02677: TIGR02677 family protein', 494, NULL, 'TIGR02677', 291189),
(485515, 'TIGR01059', NULL, 'gyrB: DNA gyrase, B subunit', 639, NULL, 'TIGR01059', 291190);           
INSERT INTO "PUBLIC"."MODEL" VALUES
(485516, 'TIGR02028', NULL, 'ChlP: geranylgeranyl reductase', 398, NULL, 'TIGR02028', 291191),
(485517, 'TIGR03975', NULL, 'rSAM_ocin_1: ribosomal peptide maturation radical SAM protein 1', 606, NULL, 'TIGR03975', 291192),
(485518, 'TIGR04064', NULL, 'rSAM_nif11: nif11-like peptide radical SAM maturase', 459, NULL, 'TIGR04064', 291193),
(485519, 'TIGR01229', NULL, 'rocF_arginase: arginase', 300, NULL, 'TIGR01229', 291194),
(485520, 'TIGR04234', NULL, 'seadorna_RNAP: RNA-directed RNA polymerase', 1144, NULL, 'TIGR04234', 291195),
(485521, 'TIGR00832', NULL, 'acr3: arsenical-resistance protein', 327, NULL, 'TIGR00832', 291196),
(485522, 'TIGR03047', NULL, 'PS_II_psb28: photosystem II reaction center protein Psb28', 109, NULL, 'TIGR03047', 291197),
(485523, 'TIGR03217', NULL, '4OH_2_O_val_ald: 4-hydroxy-2-oxovalerate aldolase', 334, NULL, 'TIGR03217', 291198),
(485524, 'TIGR04180', NULL, 'EDH_00030: NAD dependent epimerase/dehydratase, LLPSF_EDH_00030 family', 297, NULL, 'TIGR04180', 291199),
(485525, 'TIGR00328', NULL, 'flhB: flagellar biosynthetic protein FlhB', 348, NULL, 'TIGR00328', 291200),
(485526, 'TIGR03721', NULL, 'exospore_TM: BclB C-terminal domain', 169, NULL, 'TIGR03721', 291201),
(485527, 'TIGR00335', NULL, 'primase_sml: putative DNA primase, eukaryotic-type, small subunit', 324, NULL, 'TIGR00335', 291202),
(485528, 'TIGR04404', NULL, 'RiPP_SkfA: sporulation killing factor', 53, NULL, 'TIGR04404', 291203),
(485529, 'TIGR01202', NULL, 'bchC: chlorophyll synthesis pathway protein BchC', 308, NULL, 'TIGR01202', 291204),
(485530, 'TIGR02847', NULL, 'CyoD: cytochrome o ubiquinol oxidase subunit IV', 96, NULL, 'TIGR02847', 291205),
(485531, 'TIGR03340', NULL, 'phn_DUF6: phosphonate utilization associated putative membrane protein', 281, NULL, 'TIGR03340', 291206),
(485532, 'TIGR04057', NULL, 'SusC_RagA_signa: TonB-dependent outer membrane receptor, SusC/RagA subfamily, signature region', 31, NULL, 'TIGR04057', 291207),
(485533, 'TIGR03707', NULL, 'PPK2_P_aer: polyphosphate kinase 2', 230, NULL, 'TIGR03707', 291208),
(485534, 'TIGR02684', NULL, 'dnstrm_HI1420: probable addiction module antidote protein', 89, NULL, 'TIGR02684', 291209),
(485535, 'TIGR00165', NULL, 'S18: ribosomal protein bS18', 70, NULL, 'TIGR00165', 291210),
(485536, 'TIGR02212', NULL, 'lolCE: lipoprotein releasing system, transmembrane protein, LolC/E family', 411, NULL, 'TIGR02212', 291211),
(485537, 'TIGR01837', NULL, 'PHA_granule_1: poly(hydroxyalkanoate) granule-associated protein', 118, NULL, 'TIGR01837', 291212),
(485538, 'TIGR02854', NULL, 'spore_II_GA: sigma-E processing peptidase SpoIIGA', 293, NULL, 'TIGR02854', 291213),
(485539, 'TIGR01960', NULL, 'ndhF3_CO2: NAD(P)H dehydrogenase, subunit NdhF3 family', 606, NULL, 'TIGR01960', 291214),
(485540, 'TIGR02103', NULL, 'pullul_strch: alpha-1,6-glucosidases, pullulanase-type', 900, NULL, 'TIGR02103', 291215),
(485541, 'TIGR02480', NULL, 'fliN: flagellar motor switch protein FliN', 77, NULL, 'TIGR02480', 291216),
(485542, 'TIGR03170', NULL, 'flgA_cterm: flagella basal body P-ring formation protein FlgA', 137, NULL, 'TIGR03170', 291217),
(485543, 'TIGR01134', NULL, 'purF: amidophosphoribosyltransferase', 432, NULL, 'TIGR01134', 291218),
(485544, 'TIGR02568', NULL, 'LcrE: type III secretion regulator YopN/LcrE/InvE/MxiC', 241, NULL, 'TIGR02568', 291219),
(485545, 'TIGR00199', NULL, 'PncC_domain: amidohydrolase, PncC family', 149, NULL, 'TIGR00199', 291220),
(485546, 'TIGR01080', NULL, 'rplX_A_E: ribosomal protein uL24', 116, NULL, 'TIGR01080', 291221),
(485547, 'TIGR02289', NULL, 'M3_not_pepF: oligoendopeptidase, M3 family', 549, NULL, 'TIGR02289', 291222),
(485548, 'TIGR03503', NULL, 'TIGR03503: TIGR03503 family protein', 374, NULL, 'TIGR03503', 291223),
(485549, 'TIGR00560', NULL, 'pgsA: CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', 183, NULL, 'TIGR00560', 291224),
(485550, 'TIGR04023', NULL, 'PPOX_MSMEG_5819: PPOX class F420-dependent enzyme, MSMEG_5819/OxyR family', 115, NULL, 'TIGR04023', 291225),
(485551, 'TIGR01769', NULL, 'GGGP: phosphoglycerol geranylgeranyltransferase', 205, NULL, 'TIGR01769', 291226);    
INSERT INTO "PUBLIC"."MODEL" VALUES
(485552, 'TIGR00390', NULL, 'hslU: ATP-dependent protease HslVU, ATPase subunit', 441, NULL, 'TIGR00390', 291227),
(485553, 'TIGR00614', NULL, 'recQ_fam: ATP-dependent DNA helicase, RecQ family', 470, NULL, 'TIGR00614', 291228),
(485554, 'TIGR03258', NULL, 'PhnT: 2-aminoethylphosphonate ABC transport system, ATP-binding component PhnT', 359, NULL, 'TIGR03258', 291229),
(485555, 'TIGR01790', NULL, 'carotene-cycl: lycopene cyclase family protein', 387, NULL, 'TIGR01790', 291230),
(485556, 'TIGR01599', NULL, 'PYST-A: Plasmodium yoelii subtelomeric family PYST-A', 209, NULL, 'TIGR01599', 291231),
(485557, 'TIGR03088', NULL, 'stp2: sugar transferase, PEP-CTERM/EpsH1 system associated', 374, NULL, 'TIGR03088', 291232),
(485558, 'TIGR02650', NULL, 'RNase_Z_T_toga: ribonuclease Z, Thermotoga type', 277, NULL, 'TIGR02650', 291233),
(485559, 'TIGR00444', NULL, 'mazG: MazG family protein', 248, NULL, 'TIGR00444', 291234),
(485560, 'TIGR00369', NULL, 'unchar_dom_1: uncharacterized domain 1', 117, NULL, 'TIGR00369', 291235),
(485561, 'TIGR04488', NULL, 'SoxY_true_GGCGG: thiosulfate oxidation carrier protein SoxY', 149, NULL, 'TIGR04488', 291236),
(485562, 'TIGR01304', NULL, 'IMP_DH_rel_2: IMP dehydrogenase family protein', 365, NULL, 'TIGR01304', 291237),
(485563, 'TIGR02398', NULL, 'gluc_glyc_Psyn: glucosylglycerol-phosphate synthase', 487, NULL, 'TIGR02398', 291238),
(485564, 'TIGR00274', NULL, 'TIGR00274: N-acetylmuramic acid 6-phosphate etherase', 291, NULL, 'TIGR00274', 291239),
(485565, 'TIGR02459', NULL, 'CbtB: cobalt transporter subunit CbtB (proposed)', 60, NULL, 'TIGR02459', 291240),
(485566, 'TIGR03333', NULL, 'salvage_mtnX: 2-hydroxy-3-keto-5-methylthiopentenyl-1-phosphate phosphatase', 214, NULL, 'TIGR03333', 291241),
(485567, 'TIGR00730', NULL, 'TIGR00730: TIGR00730 family protein', 178, NULL, 'TIGR00730', 291242),
(485568, 'TIGR01243', NULL, 'CDC48: AAA family ATPase, CDC48 subfamily', 733, NULL, 'TIGR01243', 291243),
(485569, 'TIGR03428', NULL, 'ureacarb_perm: permease, urea carboxylase system', 475, NULL, 'TIGR03428', 291244),
(485570, 'TIGR03798', NULL, 'ocin_TIGR03798: nif11-like leader peptide domain', 68, NULL, 'TIGR03798', 291245),
(485571, 'TIGR02908', NULL, 'CoxD_Bacillus: cytochrome c oxidase, subunit IVB', 110, NULL, 'TIGR02908', 291246),
(485572, 'TIGR02643', NULL, 'T_phosphoryl: thymidine phosphorylase', 437, NULL, 'TIGR02643', 291247),
(485573, 'TIGR01413', NULL, 'Dyp_perox_fam: Dyp-type peroxidase family', 323, NULL, 'TIGR01413', 291248),
(485574, 'TIGR02738', NULL, 'TrbB: type-F conjugative transfer system pilin assembly thiol-disulfide isomerase TrbB', 153, NULL, 'TIGR02738', 291249),
(485575, 'TIGR03968', NULL, 'mycofact_TetR: mycofactocin system transcriptional regulator', 190, NULL, 'TIGR03968', 291250),
(485576, 'TIGR00553', NULL, 'pabB: aminodeoxychorismate synthase, component I', 329, NULL, 'TIGR00553', 291251),
(485577, 'TIGR02813', NULL, 'omega_3_PfaA: polyketide-type polyunsaturated fatty acid synthase PfaA', 2582, NULL, 'TIGR02813', 291252),
(485578, 'TIGR00723', NULL, 'ttdB_fumA_fumB: hydrolyase, tartrate beta subunit/fumarate domain protein, Fe-S type', 169, NULL, 'TIGR00723', 291253),
(485579, 'TIGR01878', NULL, 'cas_Csa5: CRISPR type I-A/APERN-associated protein Csa5', 107, NULL, 'TIGR01878', 291254),
(485580, 'TIGR00281', NULL, 'TIGR00281: segregation and condensation protein B', 186, NULL, 'TIGR00281', 291255),
(485581, 'TIGR02629', NULL, 'L_rham_iso_rhiz: L-rhamnose catabolism isomerase', 412, NULL, 'TIGR02629', 291256),
(485582, 'TIGR04132', NULL, 'intra_fol_E_lig: putative folate metabolism gamma-glutamate ligase', 241, NULL, 'TIGR04132', 291257),
(485583, 'TIGR01073', NULL, 'pcrA: ATP-dependent DNA helicase PcrA', 725, NULL, 'TIGR01073', 291258),
(485584, 'TIGR00451', NULL, 'unchar_dom_2: uncharacterized domain 2', 107, NULL, 'TIGR00451', 291259),
(485585, 'TIGR02922', NULL, 'TIGR02922: TIGR02922 family protein', 67, NULL, 'TIGR02922', 291260),
(485586, 'TIGR01127', NULL, 'ilvA_1Cterm: threonine ammonia-lyase', 380, NULL, 'TIGR01127', 291261),
(485587, 'TIGR03149', NULL, 'cyt_nit_nrfC: cytochrome c nitrite reductase, Fe-S protein', 225, NULL, 'TIGR03149', 291262);        
INSERT INTO "PUBLIC"."MODEL" VALUES
(485588, 'TIGR00900', NULL, '2A0121: H+ Antiporter protein', 364, NULL, 'TIGR00900', 291263),
(485589, 'TIGR02110', NULL, 'PQQ_syn_pqqF: coenzyme PQQ biosynthesis protein PqqF', 697, NULL, 'TIGR02110', 291264),
(485590, 'TIGR03265', NULL, 'PhnT2: putative 2-aminoethylphosphonate ABC transporter, ATP-binding protein', 353, NULL, 'TIGR03265', 291265),
(485591, 'TIGR01939', NULL, 'nqrD: NADH:ubiquinone oxidoreductase, Na(+)-translocating, D subunit', 207, NULL, 'TIGR01939', 291266),
(485592, 'TIGR03319', NULL, 'RNase_Y: ribonuclease Y', 514, NULL, 'TIGR03319', 291267),
(485593, 'TIGR01885', NULL, 'Orn_aminotrans: ornithine--oxo-acid transaminase', 402, NULL, 'TIGR01885', 291268),
(485594, 'TIGR02745', NULL, 'ccoG_rdxA_fixG: cytochrome c oxidase accessory protein CcoG', 435, NULL, 'TIGR02745', 291269),
(485595, 'TIGR04118', NULL, 'Cxxx_AC3_0185: modification target Cys-rich peptide, AC3_0185 family', 46, NULL, 'TIGR04118', 291270),
(485596, 'TIGR01420', NULL, 'pilT_fam: twitching motility protein', 343, NULL, 'TIGR01420', 291271),
(485597, 'TIGR01250', NULL, 'pro_imino_pep_2: proline-specific peptidase', 288, NULL, 'TIGR01250', 291272),
(485598, 'TIGR02752', NULL, 'MenG_heptapren: demethylmenaquinone methyltransferase', 231, NULL, 'TIGR02752', 291273),
(485599, 'TIGR00267', NULL, 'TIGR00267: TIGR00267 family protein', 171, NULL, 'TIGR00267', 291274),
(485600, 'TIGR00437', NULL, 'feoB: ferrous iron transport protein B', 594, NULL, 'TIGR00437', 291275),
(485601, 'TIGR03442', NULL, 'TIGR03442: ergothioneine biosynthesis protein EgtC', 251, NULL, 'TIGR03442', 291276),
(485602, 'TIGR03272', NULL, 'methan_mark_6: putative methanogenesis marker protein 6', 132, NULL, 'TIGR03272', 291277),
(485603, 'TIGR03095', NULL, 'rusti_cyanin: rusticyanin', 148, NULL, 'TIGR03095', 291278),
(485604, 'TIGR03612', NULL, 'RutA: pyrimidine utilization protein A', 355, NULL, 'TIGR03612', 291279),
(485605, 'TIGR04302', NULL, 'geo_PqqD_fam: GeoRSP system PqqD family protein', 102, NULL, 'TIGR04302', 291280),
(485606, 'TIGR00607', NULL, 'rad52: recombination protein rad52', 161, NULL, 'TIGR00607', 291281),
(485607, 'inside', NULL, 'inside cell region', NULL, NULL, 'inside cell region', 291282),
(485608, 'outside', NULL, 'outside cell region', NULL, NULL, 'outside cell region', 291283),
(485609, 'TMhelix', NULL, 'Region of a membrane-bound protein predicted to be embedded in the membrane.', NULL, NULL, 'transmembrane helix', 291284),
(485610, 'O', NULL, NULL, NULL, NULL, 'O region', 291285);     
CREATE INDEX "PUBLIC"."MODEL_AC_IDX" ON "PUBLIC"."MODEL"("ACCESSION");         
CREATE INDEX "PUBLIC"."MODEL_NAME_IDX" ON "PUBLIC"."MODEL"("MODEL_NAME");      
CREATE INDEX "PUBLIC"."MODEL_MD5_IDX" ON "PUBLIC"."MODEL"("MD5");              
CREATE CACHED TABLE "PUBLIC"."MODEL_DEFINITION_CHUNK"(
    "MODEL_ID" BIGINT NOT NULL,
    "DEFINITION_CHUNK" VARCHAR(4000),
    "CHUNK_INDEX" INTEGER NOT NULL
);             
ALTER TABLE "PUBLIC"."MODEL_DEFINITION_CHUNK" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_92" PRIMARY KEY("MODEL_ID", "CHUNK_INDEX");  
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.MODEL_DEFINITION_CHUNK;   
CREATE CACHED TABLE "PUBLIC"."MODEL_DESCRIPTION_CHUNK"(
    "MODEL_ID" BIGINT NOT NULL,
    "DESCRIPTION_CHUNK" VARCHAR(4000),
    "CHUNK_INDEX" INTEGER NOT NULL
);           
ALTER TABLE "PUBLIC"."MODEL_DESCRIPTION_CHUNK" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_76" PRIMARY KEY("MODEL_ID", "CHUNK_INDEX"); 
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.MODEL_DESCRIPTION_CHUNK;  
CREATE CACHED TABLE "PUBLIC"."NUCLEOTIDE_SEQUENCE_CHUNK"(
    "NUCLEOTIDE_SEQUENCE_ID" BIGINT NOT NULL,
    "SEQUENCE_CHUNKS" VARCHAR(4000),
    "CHUNK_INDEX" INTEGER NOT NULL
);             
ALTER TABLE "PUBLIC"."NUCLEOTIDE_SEQUENCE_CHUNK" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_C9" PRIMARY KEY("NUCLEOTIDE_SEQUENCE_ID", "CHUNK_INDEX"); 
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.NUCLEOTIDE_SEQUENCE_CHUNK;
CREATE CACHED TABLE "PUBLIC"."NUCLEOTIDE_SEQUENCE"(
    "ID" BIGINT NOT NULL,
    "MD5" VARCHAR(32) NOT NULL,
    "SEQUENCE_FIRST_CHUNK" VARCHAR(4000) NOT NULL
);             
ALTER TABLE "PUBLIC"."NUCLEOTIDE_SEQUENCE" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_4B" PRIMARY KEY("ID");          
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.NUCLEOTIDE_SEQUENCE;      
CREATE CACHED TABLE "PUBLIC"."NUCLEOTIDE_SEQUENCE_XREF"(
    "ID" BIGINT NOT NULL,
    "DATABASE_NAME" VARCHAR(255),
    "IDENTIFIER" VARCHAR(255) NOT NULL,
    "NAME" VARCHAR(255),
    "SEQUENCE_ID" BIGINT NOT NULL
);     
ALTER TABLE "PUBLIC"."NUCLEOTIDE_SEQUENCE_XREF" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_48" PRIMARY KEY("ID");     
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.NUCLEOTIDE_SEQUENCE_XREF; 
CREATE INDEX "PUBLIC"."IDX7LWATP16IYMAUIY0X0U22PJ19" ON "PUBLIC"."NUCLEOTIDE_SEQUENCE_XREF"("IDENTIFIER");     
CREATE CACHED TABLE "PUBLIC"."OPEN_READING_FRAME"(
    "ID" BIGINT NOT NULL,
    "ORF_END" INTEGER NOT NULL,
    "ORF_START" INTEGER NOT NULL,
    "STRAND" VARCHAR(255) NOT NULL,
    "NUCLEOTIDE_SEQUENCE_ID" BIGINT NOT NULL,
    "PROTEIN_ID" BIGINT NOT NULL
);           
ALTER TABLE "PUBLIC"."OPEN_READING_FRAME" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_47" PRIMARY KEY("ID");           
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.OPEN_READING_FRAME;       
CREATE CACHED TABLE "PUBLIC"."PANTHER_LOCATION"(
    "ID" BIGINT NOT NULL,
    "LOC_END" INTEGER NOT NULL,
    "LOC_START" INTEGER NOT NULL,
    "MATCH_ID" BIGINT NOT NULL,
    "ENVELOPE_END" INTEGER NOT NULL,
    "ENVELOPE_START" INTEGER NOT NULL,
    "HMM_BOUNDS" VARCHAR(2) NOT NULL,
    "HMM_END" INTEGER NOT NULL,
    "HMM_LENGTH" INTEGER NOT NULL,
    "HMM_START" INTEGER NOT NULL
);          
ALTER TABLE "PUBLIC"."PANTHER_LOCATION" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_93" PRIMARY KEY("ID");             
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.PANTHER_LOCATION;         
CREATE CACHED TABLE "PUBLIC"."PANTHER_LOCATION_FRAGMENT"(
    "ID" BIGINT NOT NULL,
    "DC_STATUS" VARCHAR(255) NOT NULL,
    "LOC_END" INTEGER NOT NULL,
    "LOC_START" INTEGER NOT NULL,
    "LOCATION_ID" BIGINT NOT NULL
);              
ALTER TABLE "PUBLIC"."PANTHER_LOCATION_FRAGMENT" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_EA" PRIMARY KEY("ID");    
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.PANTHER_LOCATION_FRAGMENT;
CREATE CACHED TABLE "PUBLIC"."PANTHER_RAW_MATCH"(
    "ID" BIGINT NOT NULL,
    "LOC_FRAGMENT_DCS_TATUS" VARCHAR(255),
    "LOCATION_END" INTEGER,
    "LOCATION_START" INTEGER,
    "MODEL_ID" VARCHAR(255),
    "NUMERIC_SEQUENCE_ID" BIGINT,
    "SEQUENCE_ID" VARCHAR(255),
    "SIGNATURE_LIBRARY" VARCHAR(255),
    "SIG_LIB_RELEASE" VARCHAR(255),
    "ANNOTATIONS_NODE_ID" VARCHAR(255),
    "ENVELOPE_END" INTEGER NOT NULL,
    "ENVELOPE_START" INTEGER NOT NULL,
    "EVALUE" DOUBLE,
    "HMM_BOUNDS" VARCHAR(2),
    "HMM_END" INTEGER NOT NULL,
    "HMM_LENGTH" INTEGER NOT NULL,
    "HMM_START" INTEGER NOT NULL,
    "SCORE" DOUBLE
);     
ALTER TABLE "PUBLIC"."PANTHER_RAW_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_F7" PRIMARY KEY("ID");            
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.PANTHER_RAW_MATCH;        
CREATE INDEX "PUBLIC"."PANTHER_RW_SEQ_IDX" ON "PUBLIC"."PANTHER_RAW_MATCH"("SEQUENCE_ID");     
CREATE INDEX "PUBLIC"."PANTHER_RW_NUM_SEQ_IDX" ON "PUBLIC"."PANTHER_RAW_MATCH"("NUMERIC_SEQUENCE_ID");         
CREATE INDEX "PUBLIC"."PANTHER_RW_MODEL_IDX" ON "PUBLIC"."PANTHER_RAW_MATCH"("MODEL_ID");      
CREATE INDEX "PUBLIC"."PANTHER_RW_SIGLIB_IDX" ON "PUBLIC"."PANTHER_RAW_MATCH"("SIGNATURE_LIBRARY");            
CREATE INDEX "PUBLIC"."PANTHER_RW_SIGLIB_REL_IDX" ON "PUBLIC"."PANTHER_RAW_MATCH"("SIG_LIB_RELEASE");          
CREATE CACHED TABLE "PUBLIC"."PANTHER_MATCH"(
    "ID" BIGINT NOT NULL,
    "SIGNATURE_MODELS" VARCHAR(255),
    "PROTEIN_ID" BIGINT NOT NULL,
    "SIGNATURE_ID" BIGINT NOT NULL,
    "ACCESSION" VARCHAR(255),
    "ANNOTATIONS_NODE_ID" VARCHAR(255),
    "EVALUE" DOUBLE NOT NULL,
    "GRAFT_POINT" VARCHAR(255),
    "NAME" VARCHAR(255),
    "PROTEIN_CLASS" VARCHAR(255),
    "SCORE" DOUBLE NOT NULL
);               
ALTER TABLE "PUBLIC"."PANTHER_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_4D" PRIMARY KEY("ID");
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.PANTHER_MATCH;            
CREATE CACHED TABLE "PUBLIC"."PANTHER_MATCH_GO_XREF"(
    "PANTHER_MATCH_ID" BIGINT NOT NULL,
    "GO_XREFS_ID" BIGINT NOT NULL
);             
ALTER TABLE "PUBLIC"."PANTHER_MATCH_GO_XREF" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_F2" PRIMARY KEY("PANTHER_MATCH_ID", "GO_XREFS_ID");           
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.PANTHER_MATCH_GO_XREF;    
CREATE CACHED TABLE "PUBLIC"."PATHWAY_XREF"(
    "ID" BIGINT NOT NULL,
    "DATABASE_NAME" VARCHAR(255),
    "IDENTIFIER" VARCHAR(255) NOT NULL,
    "NAME" VARCHAR(255)
);    
ALTER TABLE "PUBLIC"."PATHWAY_XREF" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_6A" PRIMARY KEY("ID"); 
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.PATHWAY_XREF;             
CREATE INDEX "PUBLIC"."IDXF7EQ58XO5QEGQBYNS44T7TVI1" ON "PUBLIC"."PATHWAY_XREF"("IDENTIFIER"); 
CREATE CACHED TABLE "PUBLIC"."PATTERN_SCAN_LOCATION"(
    "ID" BIGINT NOT NULL,
    "LOC_END" INTEGER NOT NULL,
    "LOC_START" INTEGER NOT NULL,
    "MATCH_ID" BIGINT NOT NULL,
    "CIGAR_ALIGN" VARCHAR(255) NOT NULL,
    "LOCATION_LEVEL" INTEGER NOT NULL
);            
ALTER TABLE "PUBLIC"."PATTERN_SCAN_LOCATION" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_26" PRIMARY KEY("ID");        
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.PATTERN_SCAN_LOCATION;    
CREATE CACHED TABLE "PUBLIC"."PATTERN_SCAN_LOCATION_FRAGMENT"(
    "ID" BIGINT NOT NULL,
    "DC_STATUS" VARCHAR(255) NOT NULL,
    "LOC_END" INTEGER NOT NULL,
    "LOC_START" INTEGER NOT NULL,
    "LOCATION_ID" BIGINT NOT NULL
);         
ALTER TABLE "PUBLIC"."PATTERN_SCAN_LOCATION_FRAGMENT" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_17" PRIMARY KEY("ID");               
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.PATTERN_SCAN_LOCATION_FRAGMENT;           
CREATE CACHED TABLE "PUBLIC"."PATTERN_SCAN_MATCH"(
    "ID" BIGINT NOT NULL,
    "SIGNATURE_MODELS" VARCHAR(255),
    "PROTEIN_ID" BIGINT NOT NULL,
    "SIGNATURE_ID" BIGINT NOT NULL
);      
ALTER TABLE "PUBLIC"."PATTERN_SCAN_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_6E" PRIMARY KEY("ID");           
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.PATTERN_SCAN_MATCH;       
CREATE CACHED TABLE "PUBLIC"."PFAM_HMMER3_RAW_MATCH"(
    "ID" BIGINT NOT NULL,
    "LOC_FRAGMENT_DCS_TATUS" VARCHAR(255),
    "LOCATION_END" INTEGER,
    "LOCATION_START" INTEGER,
    "MODEL_ID" VARCHAR(255),
    "NUMERIC_SEQUENCE_ID" BIGINT,
    "SEQUENCE_ID" VARCHAR(255),
    "SIGNATURE_LIBRARY" VARCHAR(255),
    "SIG_LIB_RELEASE" VARCHAR(255),
    "EVALUE" DOUBLE NOT NULL,
    "HMM_BOUNDS" VARCHAR(2),
    "HMM_END" INTEGER NOT NULL,
    "HMM_START" INTEGER NOT NULL,
    "LOCATION_SCORE" DOUBLE NOT NULL,
    "SCORE" DOUBLE NOT NULL,
    "DOMAIN_BIAS" DOUBLE NOT NULL,
    "DOMAIN_CE_VALUE" DOUBLE NOT NULL,
    "DOMAIN_IE_VALUE" DOUBLE NOT NULL,
    "ENVELOPE_END" INTEGER NOT NULL,
    "ENVELOPE_START" INTEGER NOT NULL,
    "EXPECTED_ACCURACY" DOUBLE NOT NULL,
    "FULL_SEQUENCE_BIAS" DOUBLE NOT NULL,
    "SPLIT_GROUP" BINARY
);      
ALTER TABLE "PUBLIC"."PFAM_HMMER3_RAW_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_84" PRIMARY KEY("ID");        
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.PFAM_HMMER3_RAW_MATCH;    
CREATE INDEX "PUBLIC"."PFAM_RW_SEQ_IDX" ON "PUBLIC"."PFAM_HMMER3_RAW_MATCH"("SEQUENCE_ID");    
CREATE INDEX "PUBLIC"."PFAM_RW_NUM_SEQ_IDX" ON "PUBLIC"."PFAM_HMMER3_RAW_MATCH"("NUMERIC_SEQUENCE_ID");        
CREATE INDEX "PUBLIC"."PFAM_RW_MODEL_IDX" ON "PUBLIC"."PFAM_HMMER3_RAW_MATCH"("MODEL_ID");     
CREATE INDEX "PUBLIC"."PFAM_RW_SIGLIB_IDX" ON "PUBLIC"."PFAM_HMMER3_RAW_MATCH"("SIGNATURE_LIBRARY");           
CREATE INDEX "PUBLIC"."PFAM_RW_SIGLIB_REL_IDX" ON "PUBLIC"."PFAM_HMMER3_RAW_MATCH"("SIG_LIB_RELEASE");         
CREATE CACHED TABLE "PUBLIC"."PHOBIUS_LOCATION"(
    "ID" BIGINT NOT NULL,
    "LOC_END" INTEGER NOT NULL,
    "LOC_START" INTEGER NOT NULL,
    "MATCH_ID" BIGINT NOT NULL
); 
ALTER TABLE "PUBLIC"."PHOBIUS_LOCATION" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_6F4" PRIMARY KEY("ID");            
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.PHOBIUS_LOCATION;         
CREATE CACHED TABLE "PUBLIC"."PHOBIUS_LOCATION_FRAGMENT"(
    "ID" BIGINT NOT NULL,
    "DC_STATUS" VARCHAR(255) NOT NULL,
    "LOC_END" INTEGER NOT NULL,
    "LOC_START" INTEGER NOT NULL,
    "LOCATION_ID" BIGINT NOT NULL
);              
ALTER TABLE "PUBLIC"."PHOBIUS_LOCATION_FRAGMENT" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_F78" PRIMARY KEY("ID");   
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.PHOBIUS_LOCATION_FRAGMENT;
CREATE CACHED TABLE "PUBLIC"."PHOBIUS_MATCH"(
    "ID" BIGINT NOT NULL,
    "SIGNATURE_MODELS" VARCHAR(255),
    "PROTEIN_ID" BIGINT NOT NULL,
    "SIGNATURE_ID" BIGINT NOT NULL
);           
ALTER TABLE "PUBLIC"."PHOBIUS_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_32" PRIMARY KEY("ID");
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.PHOBIUS_MATCH;            
CREATE CACHED TABLE "PUBLIC"."PIRSF_HMMER2_RAW_MATCH"(
    "ID" BIGINT NOT NULL,
    "LOC_FRAGMENT_DCS_TATUS" VARCHAR(255),
    "LOCATION_END" INTEGER,
    "LOCATION_START" INTEGER,
    "MODEL_ID" VARCHAR(255),
    "NUMERIC_SEQUENCE_ID" BIGINT,
    "SEQUENCE_ID" VARCHAR(255),
    "SIGNATURE_LIBRARY" VARCHAR(255),
    "SIG_LIB_RELEASE" VARCHAR(255),
    "EVALUE" DOUBLE NOT NULL,
    "HMM_BOUNDS" VARCHAR(2),
    "HMM_END" INTEGER NOT NULL,
    "HMM_START" INTEGER NOT NULL,
    "LOCATION_SCORE" DOUBLE NOT NULL,
    "SCORE" DOUBLE NOT NULL,
    "LOCATION_EVALUE" DOUBLE
); 
ALTER TABLE "PUBLIC"."PIRSF_HMMER2_RAW_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_931" PRIMARY KEY("ID");      
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.PIRSF_HMMER2_RAW_MATCH;   
CREATE INDEX "PUBLIC"."PIRSF2_RW_SEQ_IDX" ON "PUBLIC"."PIRSF_HMMER2_RAW_MATCH"("SEQUENCE_ID"); 
CREATE INDEX "PUBLIC"."PIRSF2_RW_NUM_SEQ_IDX" ON "PUBLIC"."PIRSF_HMMER2_RAW_MATCH"("NUMERIC_SEQUENCE_ID");     
CREATE INDEX "PUBLIC"."PIRSF2_RW_MODEL_IDX" ON "PUBLIC"."PIRSF_HMMER2_RAW_MATCH"("MODEL_ID");  
CREATE INDEX "PUBLIC"."PIRSF2_RW_SIGLIB_IDX" ON "PUBLIC"."PIRSF_HMMER2_RAW_MATCH"("SIGNATURE_LIBRARY");        
CREATE INDEX "PUBLIC"."PIRSF2_RW_SIGLIB_REL_IDX" ON "PUBLIC"."PIRSF_HMMER2_RAW_MATCH"("SIG_LIB_RELEASE");      
CREATE CACHED TABLE "PUBLIC"."PIRSF_HMMER3_RAW_MATCH"(
    "ID" BIGINT NOT NULL,
    "LOC_FRAGMENT_DCS_TATUS" VARCHAR(255),
    "LOCATION_END" INTEGER,
    "LOCATION_START" INTEGER,
    "MODEL_ID" VARCHAR(255),
    "NUMERIC_SEQUENCE_ID" BIGINT,
    "SEQUENCE_ID" VARCHAR(255),
    "SIGNATURE_LIBRARY" VARCHAR(255),
    "SIG_LIB_RELEASE" VARCHAR(255),
    "EVALUE" DOUBLE NOT NULL,
    "HMM_BOUNDS" VARCHAR(2),
    "HMM_END" INTEGER NOT NULL,
    "HMM_START" INTEGER NOT NULL,
    "LOCATION_SCORE" DOUBLE NOT NULL,
    "SCORE" DOUBLE NOT NULL,
    "DOMAIN_BIAS" DOUBLE NOT NULL,
    "DOMAIN_CE_VALUE" DOUBLE NOT NULL,
    "DOMAIN_IE_VALUE" DOUBLE NOT NULL,
    "ENVELOPE_END" INTEGER NOT NULL,
    "ENVELOPE_START" INTEGER NOT NULL,
    "EXPECTED_ACCURACY" DOUBLE NOT NULL,
    "FULL_SEQUENCE_BIAS" DOUBLE NOT NULL,
    "SPLIT_GROUP" BINARY
);     
ALTER TABLE "PUBLIC"."PIRSF_HMMER3_RAW_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_27" PRIMARY KEY("ID");       
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.PIRSF_HMMER3_RAW_MATCH;   
CREATE INDEX "PUBLIC"."PIRSF3_RW_SEQ_IDX" ON "PUBLIC"."PIRSF_HMMER3_RAW_MATCH"("SEQUENCE_ID"); 
CREATE INDEX "PUBLIC"."PIRSF3_RW_NUM_SEQ_IDX" ON "PUBLIC"."PIRSF_HMMER3_RAW_MATCH"("NUMERIC_SEQUENCE_ID");     
CREATE INDEX "PUBLIC"."PIRSF3_RW_MODEL_IDX" ON "PUBLIC"."PIRSF_HMMER3_RAW_MATCH"("MODEL_ID");  
CREATE INDEX "PUBLIC"."PIRSF3_RW_SIGLIB_IDX" ON "PUBLIC"."PIRSF_HMMER3_RAW_MATCH"("SIGNATURE_LIBRARY");        
CREATE INDEX "PUBLIC"."PIRSF3_RW_SIGLIB_REL_IDX" ON "PUBLIC"."PIRSF_HMMER3_RAW_MATCH"("SIG_LIB_RELEASE");      
CREATE CACHED TABLE "PUBLIC"."PIRSR_HMMER3_RAW_MATCH"(
    "ID" BIGINT NOT NULL,
    "LOC_FRAGMENT_DCS_TATUS" VARCHAR(255),
    "LOCATION_END" INTEGER,
    "LOCATION_START" INTEGER,
    "MODEL_ID" VARCHAR(255),
    "NUMERIC_SEQUENCE_ID" BIGINT,
    "SEQUENCE_ID" VARCHAR(255),
    "SIGNATURE_LIBRARY" VARCHAR(255),
    "SIG_LIB_RELEASE" VARCHAR(255),
    "EVALUE" DOUBLE NOT NULL,
    "HMM_BOUNDS" VARCHAR(2),
    "HMM_END" INTEGER NOT NULL,
    "HMM_START" INTEGER NOT NULL,
    "LOCATION_SCORE" DOUBLE NOT NULL,
    "SCORE" DOUBLE NOT NULL,
    "DOMAIN_BIAS" DOUBLE NOT NULL,
    "DOMAIN_CE_VALUE" DOUBLE NOT NULL,
    "DOMAIN_IE_VALUE" DOUBLE NOT NULL,
    "ENVELOPE_END" INTEGER NOT NULL,
    "ENVELOPE_START" INTEGER NOT NULL,
    "EXPECTED_ACCURACY" DOUBLE NOT NULL,
    "FULL_SEQUENCE_BIAS" DOUBLE NOT NULL,
    "SPLIT_GROUP" BINARY,
    "HMM_ALIGNMENT" VARCHAR(255),
    "SCOPE" VARCHAR(255),
    "SEQ_ALIGNMENT" VARCHAR(255)
);       
ALTER TABLE "PUBLIC"."PIRSR_HMMER3_RAW_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_5E" PRIMARY KEY("ID");       
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.PIRSR_HMMER3_RAW_MATCH;   
CREATE INDEX "PUBLIC"."PIRSR_RW_SEQ_IDX" ON "PUBLIC"."PIRSR_HMMER3_RAW_MATCH"("SEQUENCE_ID");  
CREATE INDEX "PUBLIC"."PIRSR_RW_NUM_SEQ_IDX" ON "PUBLIC"."PIRSR_HMMER3_RAW_MATCH"("NUMERIC_SEQUENCE_ID");      
CREATE INDEX "PUBLIC"."PIRSR_RW_MODEL_IDX" ON "PUBLIC"."PIRSR_HMMER3_RAW_MATCH"("MODEL_ID");   
CREATE INDEX "PUBLIC"."PIRSR_RW_SIGLIB_IDX" ON "PUBLIC"."PIRSR_HMMER3_RAW_MATCH"("SIGNATURE_LIBRARY");         
CREATE INDEX "PUBLIC"."PIRSR_RW_SIGLIB_REL_IDX" ON "PUBLIC"."PIRSR_HMMER3_RAW_MATCH"("SIG_LIB_RELEASE");       
CREATE CACHED TABLE "PUBLIC"."PIRSR_HMMER3_RAW_SITE"(
    "ID" BIGINT NOT NULL,
    "FIRST_START" INTEGER,
    "LAST_END" INTEGER,
    "MODEL_ID" VARCHAR(255),
    "NUMERIC_SEQUENCE_ID" BIGINT,
    "RESIDUES" VARCHAR(6000) NOT NULL,
    "SEQUENCE_ID" VARCHAR(255),
    "SIGNATURE_LIBRARY" VARCHAR(255),
    "SIG_LIB_RELEASE" VARCHAR(255),
    "TITLE" VARCHAR(255),
    "SITE_GROUP" INTEGER,
    "HMM_END" INTEGER,
    "HMM_START" INTEGER,
    "SITE_LABEL" VARCHAR(255),
    "RULE_ALIGN_END" INTEGER NOT NULL,
    "RULE_ALIGN_START" INTEGER NOT NULL,
    "RULE_CONDITION" VARCHAR(255)
);     
ALTER TABLE "PUBLIC"."PIRSR_HMMER3_RAW_SITE" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_D9" PRIMARY KEY("ID");        
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.PIRSR_HMMER3_RAW_SITE;    
CREATE INDEX "PUBLIC"."PIRSR_RW_S_SEQ_IDX" ON "PUBLIC"."PIRSR_HMMER3_RAW_SITE"("SEQUENCE_ID"); 
CREATE INDEX "PUBLIC"."PIRSR_RW_S_NUM_SEQ_IDX" ON "PUBLIC"."PIRSR_HMMER3_RAW_SITE"("NUMERIC_SEQUENCE_ID");     
CREATE INDEX "PUBLIC"."PIRSR_RW_S_MODEL_IDX" ON "PUBLIC"."PIRSR_HMMER3_RAW_SITE"("MODEL_ID");  
CREATE INDEX "PUBLIC"."PIRSR_RW_S_SIGLIB_IDX" ON "PUBLIC"."PIRSR_HMMER3_RAW_SITE"("SIGNATURE_LIBRARY");        
CREATE INDEX "PUBLIC"."PIRSR_RW_S_SIGLIB_REL_IDX" ON "PUBLIC"."PIRSR_HMMER3_RAW_SITE"("SIG_LIB_RELEASE");      
CREATE CACHED TABLE "PUBLIC"."PRINTS_RAW_MATCH"(
    "ID" BIGINT NOT NULL,
    "LOC_FRAGMENT_DCS_TATUS" VARCHAR(255),
    "LOCATION_END" INTEGER,
    "LOCATION_START" INTEGER,
    "MODEL_ID" VARCHAR(255),
    "NUMERIC_SEQUENCE_ID" BIGINT,
    "SEQUENCE_ID" VARCHAR(255),
    "SIGNATURE_LIBRARY" VARCHAR(255),
    "SIG_LIB_RELEASE" VARCHAR(255),
    "EVALUE" DOUBLE,
    "GRAPHSCAN" VARCHAR(25) NOT NULL,
    "MOTIF_COUNT" INTEGER,
    "MOTIF_NUMBER" INTEGER,
    "PVALUE" DOUBLE,
    "SCORE" DOUBLE
);          
ALTER TABLE "PUBLIC"."PRINTS_RAW_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_4C" PRIMARY KEY("ID");             
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.PRINTS_RAW_MATCH;         
CREATE INDEX "PUBLIC"."PRINTS_RW_SEQ_IDX" ON "PUBLIC"."PRINTS_RAW_MATCH"("SEQUENCE_ID");       
CREATE INDEX "PUBLIC"."PRINTS_RW_NUM_SEQ_IDX" ON "PUBLIC"."PRINTS_RAW_MATCH"("NUMERIC_SEQUENCE_ID");           
CREATE INDEX "PUBLIC"."PRINTS_RW_MODEL_IDX" ON "PUBLIC"."PRINTS_RAW_MATCH"("MODEL_ID");        
CREATE INDEX "PUBLIC"."PRINTS_RW_SIGLIB_IDX" ON "PUBLIC"."PRINTS_RAW_MATCH"("SIGNATURE_LIBRARY");              
CREATE INDEX "PUBLIC"."PRINTS_RW_SIGLIB_REL_IDX" ON "PUBLIC"."PRINTS_RAW_MATCH"("SIG_LIB_RELEASE");            
CREATE CACHED TABLE "PUBLIC"."PRODOM_RAW_MATCH"(
    "ID" BIGINT NOT NULL,
    "LOC_FRAGMENT_DCS_TATUS" VARCHAR(255),
    "LOCATION_END" INTEGER,
    "LOCATION_START" INTEGER,
    "MODEL_ID" VARCHAR(255),
    "NUMERIC_SEQUENCE_ID" BIGINT,
    "SEQUENCE_ID" VARCHAR(255),
    "SIGNATURE_LIBRARY" VARCHAR(255),
    "SIG_LIB_RELEASE" VARCHAR(255),
    "EVALUE" DOUBLE,
    "METHOD_NAME" VARCHAR(255),
    "NUM_DOMAINS_IN_FAMILY" INTEGER,
    "SCORE" INTEGER,
    "SIG_MATCH_LOCATION_END" INTEGER,
    "SIG_MATCH_LOCATION_START" INTEGER,
    "SP_ID" VARCHAR(255)
);              
ALTER TABLE "PUBLIC"."PRODOM_RAW_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_A2" PRIMARY KEY("ID");             
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.PRODOM_RAW_MATCH;         
CREATE INDEX "PUBLIC"."PRODOM_RW_SEQ_IDX" ON "PUBLIC"."PRODOM_RAW_MATCH"("SEQUENCE_ID");       
CREATE INDEX "PUBLIC"."PRODOM_RW_NUM_SEQ_IDX" ON "PUBLIC"."PRODOM_RAW_MATCH"("NUMERIC_SEQUENCE_ID");           
CREATE INDEX "PUBLIC"."PRODOM_RW_MODEL_IDX" ON "PUBLIC"."PRODOM_RAW_MATCH"("MODEL_ID");        
CREATE INDEX "PUBLIC"."PRODOM_RW_SIGLIB_IDX" ON "PUBLIC"."PRODOM_RAW_MATCH"("SIGNATURE_LIBRARY");              
CREATE INDEX "PUBLIC"."PRODOM_RW_SIGLIB_REL_IDX" ON "PUBLIC"."PRODOM_RAW_MATCH"("SIG_LIB_RELEASE");            
CREATE CACHED TABLE "PUBLIC"."PROFILE_SCAN_LOCATION"(
    "ID" BIGINT NOT NULL,
    "LOC_END" INTEGER NOT NULL,
    "LOC_START" INTEGER NOT NULL,
    "MATCH_ID" BIGINT NOT NULL,
    "CIGAR_ALIGNMENT" VARCHAR(4000) NOT NULL,
    "SCORE" DOUBLE NOT NULL
); 
ALTER TABLE "PUBLIC"."PROFILE_SCAN_LOCATION" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_94" PRIMARY KEY("ID");        
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.PROFILE_SCAN_LOCATION;    
CREATE CACHED TABLE "PUBLIC"."PROFILE_SCAN_LOCATION_FRAGMENT"(
    "ID" BIGINT NOT NULL,
    "DC_STATUS" VARCHAR(255) NOT NULL,
    "LOC_END" INTEGER NOT NULL,
    "LOC_START" INTEGER NOT NULL,
    "LOCATION_ID" BIGINT NOT NULL
);         
ALTER TABLE "PUBLIC"."PROFILE_SCAN_LOCATION_FRAGMENT" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_11" PRIMARY KEY("ID");               
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.PROFILE_SCAN_LOCATION_FRAGMENT;           
CREATE CACHED TABLE "PUBLIC"."PROFILE_SCAN_MATCH"(
    "ID" BIGINT NOT NULL,
    "SIGNATURE_MODELS" VARCHAR(255),
    "PROTEIN_ID" BIGINT NOT NULL,
    "SIGNATURE_ID" BIGINT NOT NULL
);      
ALTER TABLE "PUBLIC"."PROFILE_SCAN_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_23" PRIMARY KEY("ID");           
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.PROFILE_SCAN_MATCH;       
CREATE CACHED TABLE "PUBLIC"."PROSITE_PAT_RAW_MATCH"(
    "ID" BIGINT NOT NULL,
    "LOC_FRAGMENT_DCS_TATUS" VARCHAR(255),
    "LOCATION_END" INTEGER,
    "LOCATION_START" INTEGER,
    "MODEL_ID" VARCHAR(255),
    "NUMERIC_SEQUENCE_ID" BIGINT,
    "SEQUENCE_ID" VARCHAR(255),
    "SIGNATURE_LIBRARY" VARCHAR(255),
    "SIG_LIB_RELEASE" VARCHAR(255),
    "CIGAR_ALIGNMENT" VARCHAR(4000) NOT NULL,
    "PATTERN_LEVEL" VARCHAR(255) NOT NULL
);       
ALTER TABLE "PUBLIC"."PROSITE_PAT_RAW_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_E0" PRIMARY KEY("ID");        
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.PROSITE_PAT_RAW_MATCH;    
CREATE INDEX "PUBLIC"."PROSITE_PAT_RW_SEQ_IDX" ON "PUBLIC"."PROSITE_PAT_RAW_MATCH"("SEQUENCE_ID");             
CREATE INDEX "PUBLIC"."PROSITE_PAT_RW_NUM_SEQ_IDX" ON "PUBLIC"."PROSITE_PAT_RAW_MATCH"("NUMERIC_SEQUENCE_ID"); 
CREATE INDEX "PUBLIC"."PROSITE_PAT_RW_MODEL_IDX" ON "PUBLIC"."PROSITE_PAT_RAW_MATCH"("MODEL_ID");              
CREATE INDEX "PUBLIC"."PROSITE_PAT_RW_SIGLIB_IDX" ON "PUBLIC"."PROSITE_PAT_RAW_MATCH"("SIGNATURE_LIBRARY");    
CREATE INDEX "PUBLIC"."PROSITE_PAT_RW_SIGLIB_REL_IDX" ON "PUBLIC"."PROSITE_PAT_RAW_MATCH"("SIG_LIB_RELEASE");  
CREATE CACHED TABLE "PUBLIC"."PROSITE_PROF_RAW_MATCH"(
    "ID" BIGINT NOT NULL,
    "LOC_FRAGMENT_DCS_TATUS" VARCHAR(255),
    "LOCATION_END" INTEGER,
    "LOCATION_START" INTEGER,
    "MODEL_ID" VARCHAR(255),
    "NUMERIC_SEQUENCE_ID" BIGINT,
    "SEQUENCE_ID" VARCHAR(255),
    "SIGNATURE_LIBRARY" VARCHAR(255),
    "SIG_LIB_RELEASE" VARCHAR(255),
    "CIGAR_ALIGNMENT" VARCHAR(4000) NOT NULL,
    "PF_SCAN_LEVEL" VARCHAR(255) NOT NULL,
    "SCORE" DOUBLE
);  
ALTER TABLE "PUBLIC"."PROSITE_PROF_RAW_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_1D" PRIMARY KEY("ID");       
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.PROSITE_PROF_RAW_MATCH;   
CREATE INDEX "PUBLIC"."PRSITE_PROF_RW_SEQ_IDX" ON "PUBLIC"."PROSITE_PROF_RAW_MATCH"("SEQUENCE_ID");            
CREATE INDEX "PUBLIC"."PRSITE_PROF_RW_NUM_SEQ_IDX" ON "PUBLIC"."PROSITE_PROF_RAW_MATCH"("NUMERIC_SEQUENCE_ID");
CREATE INDEX "PUBLIC"."PRSITE_PROF_RW_MODEL_IDX" ON "PUBLIC"."PROSITE_PROF_RAW_MATCH"("MODEL_ID");             
CREATE INDEX "PUBLIC"."PRSITE_PROF_RW_SIGLIB_IDX" ON "PUBLIC"."PROSITE_PROF_RAW_MATCH"("SIGNATURE_LIBRARY");   
CREATE INDEX "PUBLIC"."PRSITE_PROF_RW_SIGLIB_REL_IDX" ON "PUBLIC"."PROSITE_PROF_RAW_MATCH"("SIG_LIB_RELEASE"); 
CREATE CACHED TABLE "PUBLIC"."PROTEIN"(
    "ID" BIGINT NOT NULL,
    "MD5" VARCHAR(32) NOT NULL,
    "SEQUENCE_FIRST_CHUNK" VARCHAR(4000) NOT NULL
);         
ALTER TABLE "PUBLIC"."PROTEIN" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_186" PRIMARY KEY("ID");     
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.PROTEIN;  
CREATE CACHED TABLE "PUBLIC"."PROTEIN_SEQUENCE_CHUNK"(
    "PROTEIN_ID" BIGINT NOT NULL,
    "SEQUENCE_CHUNKS" VARCHAR(4000),
    "CHUNK_INDEX" INTEGER NOT NULL
);            
ALTER TABLE "PUBLIC"."PROTEIN_SEQUENCE_CHUNK" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_98" PRIMARY KEY("PROTEIN_ID", "CHUNK_INDEX");
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.PROTEIN_SEQUENCE_CHUNK;   
CREATE CACHED TABLE "PUBLIC"."PROTEIN_XREF"(
    "ID" BIGINT NOT NULL,
    "DATABASE_NAME" VARCHAR(255),
    "IDENTIFIER" VARCHAR(255) NOT NULL,
    "NAME" VARCHAR(255),
    "DESCRIPTION" VARCHAR(255),
    "PROTEIN_ID" BIGINT NOT NULL
);  
ALTER TABLE "PUBLIC"."PROTEIN_XREF" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_C1" PRIMARY KEY("ID"); 
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.PROTEIN_XREF;             
CREATE INDEX "PUBLIC"."IDXMT3YVUCS4VEIFBJRJ7RI3KGDM" ON "PUBLIC"."PROTEIN_XREF"("IDENTIFIER"); 
CREATE CACHED TABLE "PUBLIC"."RELEASE"(
    "ID" BIGINT NOT NULL,
    "VERSION" VARCHAR(255) NOT NULL
);       
ALTER TABLE "PUBLIC"."RELEASE" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_6B" PRIMARY KEY("ID");      
-- 1 +/- SELECT COUNT(*) FROM PUBLIC.RELEASE;  
INSERT INTO "PUBLIC"."RELEASE" VALUES
(1, '90.0');             
CREATE CACHED TABLE "PUBLIC"."RESIDUE_LOCATION"(
    "ID" BIGINT NOT NULL,
    "LOC_END" INTEGER NOT NULL,
    "RESIDUE" VARCHAR(255) NOT NULL,
    "LOC_START" INTEGER NOT NULL,
    "SITE_ID" BIGINT NOT NULL
);             
ALTER TABLE "PUBLIC"."RESIDUE_LOCATION" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_AF" PRIMARY KEY("ID");             
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.RESIDUE_LOCATION;         
CREATE CACHED TABLE "PUBLIC"."RPSBLAST_LOCATION"(
    "ID" BIGINT NOT NULL,
    "LOC_END" INTEGER NOT NULL,
    "LOC_START" INTEGER NOT NULL,
    "MATCH_ID" BIGINT NOT NULL,
    "EVALUE" DOUBLE NOT NULL,
    "SCORE" DOUBLE NOT NULL
);     
ALTER TABLE "PUBLIC"."RPSBLAST_LOCATION" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_87" PRIMARY KEY("ID");            
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.RPSBLAST_LOCATION;        
CREATE CACHED TABLE "PUBLIC"."RPSBLAST_LOCATION_FRAGMENT"(
    "ID" BIGINT NOT NULL,
    "DC_STATUS" VARCHAR(255) NOT NULL,
    "LOC_END" INTEGER NOT NULL,
    "LOC_START" INTEGER NOT NULL,
    "LOCATION_ID" BIGINT NOT NULL
);             
ALTER TABLE "PUBLIC"."RPSBLAST_LOCATION_FRAGMENT" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_79" PRIMARY KEY("ID");   
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.RPSBLAST_LOCATION_FRAGMENT;               
CREATE CACHED TABLE "PUBLIC"."RPSBLAST_MATCH"(
    "ID" BIGINT NOT NULL,
    "SIGNATURE_MODELS" VARCHAR(255),
    "PROTEIN_ID" BIGINT NOT NULL,
    "SIGNATURE_ID" BIGINT NOT NULL
);          
ALTER TABLE "PUBLIC"."RPSBLAST_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_9E" PRIMARY KEY("ID");               
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.RPSBLAST_MATCH;           
CREATE CACHED TABLE "PUBLIC"."RPSBLAST_SITE"(
    "ID" BIGINT NOT NULL,
    "DESCRIPTION" VARCHAR(255),
    "NUM_LOCATIONS" INTEGER NOT NULL,
    "LOCATION_ID" BIGINT NOT NULL
);             
ALTER TABLE "PUBLIC"."RPSBLAST_SITE" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_2E" PRIMARY KEY("ID");
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.RPSBLAST_SITE;            
CREATE CACHED TABLE "PUBLIC"."SFLD_HMMER3_RAW_MATCH"(
    "ID" BIGINT NOT NULL,
    "LOC_FRAGMENT_DCS_TATUS" VARCHAR(255),
    "LOCATION_END" INTEGER,
    "LOCATION_START" INTEGER,
    "MODEL_ID" VARCHAR(255),
    "NUMERIC_SEQUENCE_ID" BIGINT,
    "SEQUENCE_ID" VARCHAR(255),
    "SIGNATURE_LIBRARY" VARCHAR(255),
    "SIG_LIB_RELEASE" VARCHAR(255),
    "EVALUE" DOUBLE NOT NULL,
    "HMM_BOUNDS" VARCHAR(2),
    "HMM_END" INTEGER NOT NULL,
    "HMM_START" INTEGER NOT NULL,
    "LOCATION_SCORE" DOUBLE NOT NULL,
    "SCORE" DOUBLE NOT NULL,
    "DOMAIN_BIAS" DOUBLE NOT NULL,
    "DOMAIN_CE_VALUE" DOUBLE NOT NULL,
    "DOMAIN_IE_VALUE" DOUBLE NOT NULL,
    "ENVELOPE_END" INTEGER NOT NULL,
    "ENVELOPE_START" INTEGER NOT NULL,
    "EXPECTED_ACCURACY" DOUBLE NOT NULL,
    "FULL_SEQUENCE_BIAS" DOUBLE NOT NULL,
    "SPLIT_GROUP" BINARY
);      
ALTER TABLE "PUBLIC"."SFLD_HMMER3_RAW_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_97" PRIMARY KEY("ID");        
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.SFLD_HMMER3_RAW_MATCH;    
CREATE INDEX "PUBLIC"."SFLD_RW_SEQ_IDX" ON "PUBLIC"."SFLD_HMMER3_RAW_MATCH"("SEQUENCE_ID");    
CREATE INDEX "PUBLIC"."SFLD_RW_NUM_SEQ_IDX" ON "PUBLIC"."SFLD_HMMER3_RAW_MATCH"("NUMERIC_SEQUENCE_ID");        
CREATE INDEX "PUBLIC"."SFLD_RW_MODEL_IDX" ON "PUBLIC"."SFLD_HMMER3_RAW_MATCH"("MODEL_ID");     
CREATE INDEX "PUBLIC"."SFLD_RW_SIGLIB_IDX" ON "PUBLIC"."SFLD_HMMER3_RAW_MATCH"("SIGNATURE_LIBRARY");           
CREATE INDEX "PUBLIC"."SFLD_RW_SIGLIB_REL_IDX" ON "PUBLIC"."SFLD_HMMER3_RAW_MATCH"("SIG_LIB_RELEASE");         
CREATE CACHED TABLE "PUBLIC"."SFLD_HMMER3_RAW_SITE"(
    "ID" BIGINT NOT NULL,
    "FIRST_START" INTEGER,
    "LAST_END" INTEGER,
    "MODEL_ID" VARCHAR(255),
    "NUMERIC_SEQUENCE_ID" BIGINT,
    "RESIDUES" VARCHAR(6000) NOT NULL,
    "SEQUENCE_ID" VARCHAR(255),
    "SIGNATURE_LIBRARY" VARCHAR(255),
    "SIG_LIB_RELEASE" VARCHAR(255),
    "TITLE" VARCHAR(255)
);  
ALTER TABLE "PUBLIC"."SFLD_HMMER3_RAW_SITE" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_89" PRIMARY KEY("ID");         
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.SFLD_HMMER3_RAW_SITE;     
CREATE INDEX "PUBLIC"."SFLD_RW_S_SEQ_IDX" ON "PUBLIC"."SFLD_HMMER3_RAW_SITE"("SEQUENCE_ID");   
CREATE INDEX "PUBLIC"."SFLD_RW_S_NUM_SEQ_IDX" ON "PUBLIC"."SFLD_HMMER3_RAW_SITE"("NUMERIC_SEQUENCE_ID");       
CREATE INDEX "PUBLIC"."SFLD_RW_S_MODEL_IDX" ON "PUBLIC"."SFLD_HMMER3_RAW_SITE"("MODEL_ID");    
CREATE INDEX "PUBLIC"."SFLD_RW_S_SIGLIB_IDX" ON "PUBLIC"."SFLD_HMMER3_RAW_SITE"("SIGNATURE_LIBRARY");          
CREATE INDEX "PUBLIC"."SFLD_RW_S_SIGLIB_REL_IDX" ON "PUBLIC"."SFLD_HMMER3_RAW_SITE"("SIG_LIB_RELEASE");        
CREATE CACHED TABLE "PUBLIC"."SIGNALP_LOCATION"(
    "ID" BIGINT NOT NULL,
    "LOC_END" INTEGER NOT NULL,
    "LOC_START" INTEGER NOT NULL,
    "MATCH_ID" BIGINT NOT NULL,
    "SCORE" DOUBLE
);             
ALTER TABLE "PUBLIC"."SIGNALP_LOCATION" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_36" PRIMARY KEY("ID");             
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.SIGNALP_LOCATION;         
CREATE CACHED TABLE "PUBLIC"."SIGNALP_LOCATION_FRAGMENT"(
    "ID" BIGINT NOT NULL,
    "DC_STATUS" VARCHAR(255) NOT NULL,
    "LOC_END" INTEGER NOT NULL,
    "LOC_START" INTEGER NOT NULL,
    "LOCATION_ID" BIGINT NOT NULL
);              
ALTER TABLE "PUBLIC"."SIGNALP_LOCATION_FRAGMENT" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_8A" PRIMARY KEY("ID");    
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.SIGNALP_LOCATION_FRAGMENT;
CREATE CACHED TABLE "PUBLIC"."SIGNALP_MATCH"(
    "ID" BIGINT NOT NULL,
    "SIGNATURE_MODELS" VARCHAR(255),
    "PROTEIN_ID" BIGINT NOT NULL,
    "SIGNATURE_ID" BIGINT NOT NULL,
    "ORG_TYPE" INTEGER
);   
ALTER TABLE "PUBLIC"."SIGNALP_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_EA9" PRIMARY KEY("ID");               
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.SIGNALP_MATCH;            
CREATE CACHED TABLE "PUBLIC"."SIGNATURE"(
    "ID" BIGINT NOT NULL SELECTIVITY 100,
    "ABSTRACT_FIRST_CHUNK" VARCHAR(4000) SELECTIVITY 1,
    "ACCESSION" VARCHAR(255) NOT NULL SELECTIVITY 100,
    "SIGNATURE_COMMENT" VARCHAR(255) SELECTIVITY 1,
    "CREATED" TIMESTAMP SELECTIVITY 1,
    "DESCRIPTION_FIRST_CHUNK" VARCHAR(4000) SELECTIVITY 95,
    "MD5" VARCHAR(255) SELECTIVITY 1,
    "SIG_NAME" VARCHAR(4000) SELECTIVITY 99,
    "TYPE" VARCHAR(255) SELECTIVITY 1,
    "UPDATED" TIMESTAMP SELECTIVITY 1,
    "ENTRY_ID" BIGINT SELECTIVITY 1,
    "SIGNATURE_LIBRARY_RELEASE_ID" BIGINT SELECTIVITY 1
);     
ALTER TABLE "PUBLIC"."SIGNATURE" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_E6" PRIMARY KEY("ID");    
-- 291285 +/- SELECT COUNT(*) FROM PUBLIC.SIGNATURE;           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(1, NULL, 'ANF00102', NULL, NULL, 'Shadow ORF (opposite aat)', NULL, 'Spurious_ORF_102', NULL, NULL, NULL, 1),
(2, NULL, 'ANF00185', NULL, NULL, 'Shadow ORF (opposite ybhD)', NULL, 'Spurious_ORF_185', NULL, NULL, NULL, 1),
(3, NULL, 'ANF00222', NULL, NULL, 'Shadow ORF (opposite groL1)', NULL, 'Spurious_ORF_222', NULL, NULL, NULL, 1),
(4, NULL, 'ANF00047', NULL, NULL, 'Overlaps RNaseP, same strand', NULL, 'Spurious_ORF_47', NULL, NULL, NULL, 1),
(5, NULL, 'ANF00207', NULL, NULL, 'Shadow ORF (opposite glnS)', NULL, 'Spurious_ORF_207', NULL, NULL, NULL, 1),
(6, NULL, 'ANF00119', NULL, NULL, 'Shadow ORF (opposite ftsZ)', NULL, 'Spurious_ORF_119', NULL, NULL, NULL, 1),
(7, NULL, 'ANF00062', NULL, NULL, 'Shadow ORF (opposite ABC transporter protein)', NULL, 'Spurious_ORF_62', NULL, NULL, NULL, 1),
(8, NULL, 'ANF00153', NULL, NULL, 'Shadow ORF (opposite rodA)', NULL, 'Spurious_ORF_153', NULL, NULL, NULL, 1),
(9, NULL, 'ANF00081', NULL, NULL, 'Shadow ORF (opposite lysS)', NULL, 'Spurious_ORF_81', NULL, NULL, NULL, 1),
(10, NULL, 'ANF00121', NULL, NULL, 'Shadow ORF (opposite algI)', NULL, 'Spurious_ORF_121', NULL, NULL, NULL, 1),
(11, NULL, 'ANF00134', NULL, NULL, 'Shadow ORF (opposite odhA)', NULL, 'Spurious_ORF_134', NULL, NULL, NULL, 1),
(12, NULL, 'ANF00079', NULL, NULL, 'Shadow ORF (opposite rarA)', NULL, 'Spurious_ORF_79', NULL, NULL, NULL, 1),
(13, NULL, 'ANF00094', NULL, NULL, 'Shadow ORF (opposite kynA)', NULL, 'Spurious_ORF_94', NULL, NULL, NULL, 1),
(14, NULL, 'ANF00015', NULL, NULL, 'tRNA translation', NULL, 'Spurious_ORF_15', NULL, NULL, NULL, 1),
(15, NULL, 'ANF00106', NULL, NULL, 'Shadow ORF (opposite InsH)', NULL, 'Spurious_ORF_106', NULL, NULL, NULL, 1),
(16, NULL, 'ANF00239', NULL, NULL, 'Shadow ORF (opposite y4bM)', NULL, 'Spurious_ORF_239', NULL, NULL, NULL, 1),
(17, NULL, 'ANF00043', NULL, NULL, 'Antisense to RNaseP', NULL, 'Spurious_ORF_43', NULL, NULL, NULL, 1),
(18, NULL, 'ANF00066', NULL, NULL, 'Translation of palindromic DNA repeat', NULL, 'Spurious_ORF_66', NULL, NULL, NULL, 1),
(19, NULL, 'ANF00140', NULL, NULL, 'Shadow ORF (opposite ResIII Domain)', NULL, 'Spurious_ORF_140', NULL, NULL, NULL, 1),
(20, NULL, 'ANF00260', NULL, NULL, 'Protein of unknown function (DUF2575)', NULL, 'Spurious_ORF_260', NULL, NULL, NULL, 1),
(21, NULL, 'ANF00172', NULL, NULL, 'Shadow ORF (opposite lhr)', NULL, 'Spurious_ORF_172', NULL, NULL, NULL, 1),
(22, NULL, 'ANF00019', NULL, NULL, 'tRNA translation', NULL, 'Spurious_ORF_19', NULL, NULL, NULL, 1),
(23, NULL, 'ANF00130', NULL, NULL, 'Shadow ORF (opposite rnfC)', NULL, 'Spurious_ORF_130', NULL, NULL, NULL, 1),
(24, NULL, 'ANF00235', NULL, NULL, 'Shadow ORF (opposite ycf24)', NULL, 'Spurious_ORF_235', NULL, NULL, NULL, 1),
(25, NULL, 'ANF00258', NULL, NULL, 'Domain of unknown function (DUF1196)', NULL, 'Spurious_ORF_258', NULL, NULL, NULL, 1),
(26, NULL, 'ANF00254', NULL, NULL, 'DNA repeat', NULL, 'Spurious_ORF_254', NULL, NULL, NULL, 1),
(27, NULL, 'ANF00176', NULL, NULL, 'Shadow ORF (opposite nrdR)', NULL, 'Spurious_ORF_176', NULL, NULL, NULL, 1),
(28, NULL, 'ANF00085', NULL, NULL, 'Shadow ORF (opposite pacL)', NULL, 'Spurious_ORF_85', NULL, NULL, NULL, 1),
(29, NULL, 'ANF00166', NULL, NULL, 'Shadow ORF (opposite ndh)', NULL, 'Spurious_ORF_166', NULL, NULL, NULL, 1),
(30, NULL, 'ANF00179', NULL, NULL, 'Shadow ORF (opposite mobL)', NULL, 'Spurious_ORF_179', NULL, NULL, NULL, 1),
(31, NULL, 'ANF00098', NULL, NULL, 'Shadow ORF (opposite leuC)', NULL, 'Spurious_ORF_98', NULL, NULL, NULL, 1),
(32, NULL, 'ANF00075', NULL, NULL, 'Shadow ORF (opposite prpE)', NULL, 'Spurious_ORF_75', NULL, NULL, NULL, 1),
(33, NULL, 'ANF00241', NULL, NULL, 'Shadow ORF (opposite mro)', NULL, 'Spurious_ORF_241', NULL, NULL, NULL, 1),
(34, NULL, 'ANF00189', NULL, NULL, 'Shadow ORF (opposite fumA)', NULL, 'Spurious_ORF_189', NULL, NULL, NULL, 1),
(35, NULL, 'ANF00071', NULL, NULL, 'Translation of intergenic region', NULL, 'Spurious_ORF_71', NULL, NULL, NULL, 1),
(36, NULL, 'ANF00248', NULL, NULL, 'Shadow ORF (opposite ppsD)', NULL, 'Spurious_ORF_248', NULL, NULL, NULL, 1);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(37, NULL, 'ANF00264', NULL, NULL, 'Spurious protein deried frameshifted phage protein', NULL, 'Spurious_ORF_264', NULL, NULL, NULL, 1),
(38, NULL, 'ANF00089', NULL, NULL, 'Shadow ORF (opposite rplC)', NULL, 'Spurious_ORF_89', NULL, NULL, NULL, 1),
(39, NULL, 'ANF00144', NULL, NULL, 'Shadow ORF (opposite pstP)', NULL, 'Spurious_ORF_144', NULL, NULL, NULL, 1),
(40, NULL, 'ANF00231', NULL, NULL, 'Shadow ORF (opposite rplA)', NULL, 'Spurious_ORF_231', NULL, NULL, NULL, 1),
(41, NULL, 'ANF00006', NULL, NULL, 'Translation of CRISPR region', NULL, 'Spurious_ORF_06', NULL, NULL, NULL, 1),
(42, NULL, 'ANF00056', NULL, NULL, 'Translation of DNA repeat', NULL, 'Spurious_ORF_56', NULL, NULL, NULL, 1),
(43, NULL, 'ANF00111', NULL, NULL, 'Shadow ORF (opposite rpfG)', NULL, 'Spurious_ORF_111', NULL, NULL, NULL, 1),
(44, NULL, 'ANF00263', NULL, NULL, 'Spurious protein deried from human HSATII repeats', NULL, 'Spurious_ORF_263', NULL, NULL, NULL, 1),
(45, NULL, 'ANF00038', NULL, NULL, 'Overlaps SRP RNA, same strand', NULL, 'Spurious_ORF_38', NULL, NULL, NULL, 1),
(46, NULL, 'ANF00112', NULL, NULL, 'Shadow ORF (opposite phnC)', NULL, 'Spurious_ORF_112', NULL, NULL, NULL, 1),
(47, NULL, 'ANF00005', NULL, NULL, 'Antisense to 23S rRNA', NULL, 'Spurious_ORF_05', NULL, NULL, NULL, 1),
(48, NULL, 'ANF00249', NULL, NULL, 'Shadow ORF (ywcA)', NULL, 'Spurious_ORF_249', NULL, NULL, NULL, 1),
(49, NULL, 'ANF00191', NULL, NULL, 'Shadow ORF (opposite rplU)', NULL, 'Spurious_ORF_191', NULL, NULL, NULL, 1),
(50, NULL, 'ANF00216', NULL, NULL, 'Shadow ORF (opposite pepPI)', NULL, 'Spurious_ORF_216', NULL, NULL, NULL, 1),
(51, NULL, 'ANF00250', NULL, NULL, 'Shadow ORF (opposite ACADL)', NULL, 'Spurious_ORF_250', NULL, NULL, NULL, 1),
(52, NULL, 'ANF00124', NULL, NULL, 'Shadow ORF (opposite mscK)', NULL, 'Spurious_ORF_124', NULL, NULL, NULL, 1),
(53, NULL, 'ANF00229', NULL, NULL, 'Shadow ORF (opposite tilS)', NULL, 'Spurious_ORF_229', NULL, NULL, NULL, 1),
(54, NULL, 'ANF00025', NULL, NULL, 'Antisense to 23S rRNA', NULL, 'Spurious_ORF_25', NULL, NULL, NULL, 1),
(55, NULL, 'ANF00198', NULL, NULL, 'Shadow ORF (opposite pilG)', NULL, 'Spurious_ORF_198', NULL, NULL, NULL, 1),
(56, NULL, 'ANF00076', NULL, NULL, 'Shadow ORF (opposite copA)', NULL, 'Spurious_ORF_76', NULL, NULL, NULL, 1),
(57, NULL, 'ANF00157', NULL, NULL, 'Shadow ORF (opposite ileS)', NULL, 'Spurious_ORF_157', NULL, NULL, NULL, 1),
(58, NULL, 'ANF00131', NULL, NULL, 'Shadow ORF (opposite qseC)', NULL, 'Spurious_ORF_131', NULL, NULL, NULL, 1),
(59, NULL, 'ANF00018', NULL, NULL, 'tRNA translation', NULL, 'Spurious_ORF_18', NULL, NULL, NULL, 1),
(60, NULL, 'ANF00190', NULL, NULL, 'Shadow ORF (opposite fur)', NULL, 'Spurious_ORF_190', NULL, NULL, NULL, 1),
(61, NULL, 'ANF00203', NULL, NULL, 'Shadow ORF (opposite algB)', NULL, 'Spurious_ORF_203', NULL, NULL, NULL, 1),
(62, NULL, 'ANF00236', NULL, NULL, 'Shadow ORF (opposite sadA)', NULL, 'Spurious_ORF_236', NULL, NULL, NULL, 1),
(63, NULL, 'ANF00171', NULL, NULL, 'Shadow ORF (opposite pikAII)', NULL, 'Spurious_ORF_171', NULL, NULL, NULL, 1),
(64, NULL, 'ANF00090', NULL, NULL, 'Shadow ORF (opposite yegE)', NULL, 'Spurious_ORF_90', NULL, NULL, NULL, 1),
(65, NULL, 'ANF00024', NULL, NULL, 'Antisense to 23S rRNA', NULL, 'Spurious_ORF_24', NULL, NULL, NULL, 1),
(66, NULL, 'ANF00037', NULL, NULL, 'Overlap with RNaseP, same strand', NULL, 'Spurious_ORF_37', NULL, NULL, NULL, 1),
(67, NULL, 'ANF00217', NULL, NULL, 'Shadow ORF (opposite uvrB)', NULL, 'Spurious_ORF_217', NULL, NULL, NULL, 1),
(68, NULL, 'ANF00011', NULL, NULL, 'tRNA translation', NULL, 'Spurious_ORF_11', NULL, NULL, NULL, 1),
(69, NULL, 'ANF00138', NULL, NULL, 'Shadow ORF (opposite ppc)', NULL, 'Spurious_ORF_138', NULL, NULL, NULL, 1),
(70, NULL, 'ANF00044', NULL, NULL, 'Antisense to RNaseP', NULL, 'Spurious_ORF_44', NULL, NULL, NULL, 1),
(71, NULL, 'ANF00105', NULL, NULL, 'Shadow ORF (opposite purF)', NULL, 'Spurious_ORF_105', NULL, NULL, NULL, 1),
(72, NULL, 'ANF00125', NULL, NULL, 'Shadow ORF (opposite lpxD)', NULL, 'Spurious_ORF_125', NULL, NULL, NULL, 1);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(73, NULL, 'ANF00057', NULL, NULL, 'Translation of E. coli type CRISPR repeat', NULL, 'Spurious_ORF_57', NULL, NULL, NULL, 1),
(74, NULL, 'ANF00103', NULL, NULL, 'Shadow ORF (opposite can)', NULL, 'Spurious_ORF_103', NULL, NULL, NULL, 1),
(75, NULL, 'ANF00046', NULL, NULL, 'Overlaps RNaseP, same strand', NULL, 'Spurious_ORF_46', NULL, NULL, NULL, 1),
(76, NULL, 'ANF00095', NULL, NULL, 'Shadow ORF (opposite ABC transporters)', NULL, 'Spurious_ORF_95', NULL, NULL, NULL, 1),
(77, NULL, 'ANF00221', NULL, NULL, 'Shadow ORF (opposite ureE)', NULL, 'Spurious_ORF_221', NULL, NULL, NULL, 1),
(78, NULL, 'ANF00169', NULL, NULL, 'Shadow ORF (opposite dgdR)', NULL, 'Spurious_ORF_169', NULL, NULL, NULL, 1),
(79, NULL, 'ANF00186', NULL, NULL, 'Shadow ORF (opposite rpmB)', NULL, 'Spurious_ORF_186', NULL, NULL, NULL, 1),
(80, NULL, 'ANF00188', NULL, NULL, 'Shadow ORF (opposite dtd)', NULL, 'Spurious_ORF_188', NULL, NULL, NULL, 1),
(81, NULL, 'ANF00150', NULL, NULL, 'Shadow ORF (opposite gltB)', NULL, 'Spurious_ORF_150', NULL, NULL, NULL, 1),
(82, NULL, 'ANF00240', NULL, NULL, 'Shadow ORF (opposite frmR)', NULL, 'Spurious_ORF_240', NULL, NULL, NULL, 1),
(83, NULL, 'ANF00167', NULL, NULL, 'Shadow ORF (opposite uxaA)', NULL, 'Spurious_ORF_167', NULL, NULL, NULL, 1),
(84, NULL, 'ANF00257', NULL, NULL, 'Protein of unknown function (DUF1560)', NULL, 'Spurious_ORF_257', NULL, NULL, NULL, 1),
(85, NULL, 'ANF00242', NULL, NULL, 'Shadow ORF (opposite carB)', NULL, 'Spurious_ORF_242', NULL, NULL, NULL, 1),
(86, NULL, 'ANF00048', NULL, NULL, 'Contained within repeat in Vibrio superintegron', NULL, 'Spurious_ORF_48', NULL, NULL, NULL, 1),
(87, NULL, 'ANF00101', NULL, NULL, 'Shadow ORF (opposite yjhX)', NULL, 'Spurious_ORF_101', NULL, NULL, NULL, 1),
(88, NULL, 'ANF00010', NULL, NULL, 'tRNA translation', NULL, 'Spurious_ORF_10', NULL, NULL, NULL, 1),
(89, NULL, 'ANF00139', NULL, NULL, 'Shadow ORF (opposite cya)', NULL, 'Spurious_ORF_139', NULL, NULL, NULL, 1),
(90, NULL, 'ANF00084', NULL, NULL, 'Shadow ORF (opposite mutS)', NULL, 'Spurious_ORF_84', NULL, NULL, NULL, 1),
(91, NULL, 'ANF00202', NULL, NULL, 'Shadow ORF (opposite gacS)', NULL, 'Spurious_ORF_202', NULL, NULL, NULL, 1),
(92, NULL, 'ANF00219', NULL, NULL, 'Shadow ORF (opposite fpr)', NULL, 'Spurious_ORF_219', NULL, NULL, NULL, 1),
(93, NULL, 'ANF00091', NULL, NULL, 'Shadow ORF (opposite smc)', NULL, 'Spurious_ORF_91', NULL, NULL, NULL, 1),
(94, NULL, 'ANF00069', NULL, NULL, 'Translation of predicted DNA regulatory sequence', NULL, 'Spurious_ORF_69', NULL, NULL, NULL, 1),
(95, NULL, 'ANF00029', NULL, NULL, 'Antisense to 16S rRNA', NULL, 'Spurious_ORF_29', NULL, NULL, NULL, 1),
(96, NULL, 'ANF00261', NULL, NULL, 'Protein of unknown function (DUF1534)', NULL, 'Spurious_ORF_261', NULL, NULL, NULL, 1),
(97, NULL, 'ANF00065', NULL, NULL, 'Translation of REP sequence', NULL, 'Spurious_ORF_65', NULL, NULL, NULL, 1),
(98, NULL, 'ANF00146', NULL, NULL, 'Shadow ORF (opposite fprA)', NULL, 'Spurious_ORF_146', NULL, NULL, NULL, 1),
(99, NULL, 'ANF00003', NULL, NULL, 'Shadow ORF', NULL, 'Spurious_ORF_03', NULL, NULL, NULL, 1),
(100, NULL, 'ANF00120', NULL, NULL, 'Shadow ORF (opposite pinE)', NULL, 'Spurious_ORF_120', NULL, NULL, NULL, 1),
(101, NULL, 'ANF00143', NULL, NULL, 'Shadow ORF (opposite mdtB)', NULL, 'Spurious_ORF_143', NULL, NULL, NULL, 1),
(102, NULL, 'ANF00238', NULL, NULL, 'Shadow ORF (opposite gpx1)', NULL, 'Spurious_ORF_238', NULL, NULL, NULL, 1),
(103, NULL, 'ANF00160', NULL, NULL, 'Shadow ORF (opposite NIK1)', NULL, 'Spurious_ORF_160', NULL, NULL, NULL, 1),
(104, NULL, 'ANF00055', NULL, NULL, 'Translation of DNA repeat', NULL, 'Spurious_ORF_55', NULL, NULL, NULL, 1),
(105, NULL, 'ANF00088', NULL, NULL, 'Shadow ORF (opposite Fdh)', NULL, 'Spurious_ORF_88', NULL, NULL, NULL, 1),
(106, NULL, 'ANF00129', NULL, NULL, 'Shadow ORF (opposite rpoB)', NULL, 'Spurious_ORF_129', NULL, NULL, NULL, 1),
(107, NULL, 'ANF00193', NULL, NULL, 'Shadow ORF (opposite ilvB)', NULL, 'Spurious_ORF_193', NULL, NULL, NULL, 1),
(108, NULL, 'ANF00127', NULL, NULL, 'Shadow ORF (opposite eno)', NULL, 'Spurious_ORF_127', NULL, NULL, NULL, 1);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(109, NULL, 'ANF00162', NULL, NULL, 'Shadow ORF (opposite ppdK)', NULL, 'Spurious_ORF_162', NULL, NULL, NULL, 1),
(110, NULL, 'ANF00022', NULL, NULL, 'Long non-coding RNA', NULL, 'Spurious_ORF_22', NULL, NULL, NULL, 1),
(111, NULL, 'ANF00195', NULL, NULL, 'Shadow ORF (opposite cca)', NULL, 'Spurious_ORF_195', NULL, NULL, NULL, 1),
(112, NULL, 'ANF00072', NULL, NULL, 'Shadow ORF (opposite TypA)', NULL, 'Spurious_ORF_72', NULL, NULL, NULL, 1),
(113, NULL, 'ANF00212', NULL, NULL, 'Shadow ORF (opposite kdsA)', NULL, 'Spurious_ORF_212', NULL, NULL, NULL, 1),
(114, NULL, 'ANF00086', NULL, NULL, 'Shadow ORF (opposite lon)', NULL, 'Spurious_ORF_86', NULL, NULL, NULL, 1),
(115, NULL, 'ANF00074', NULL, NULL, 'Shadow ORF (opposite alaS)', NULL, 'Spurious_ORF_74', NULL, NULL, NULL, 1),
(116, NULL, 'ANF00020', NULL, NULL, 'tRNA translation', NULL, 'Spurious_ORF_20', NULL, NULL, NULL, 1),
(117, NULL, 'ANF00245', NULL, NULL, 'Shadow ORF (opposite aceB)', NULL, 'Spurious_ORF_245', NULL, NULL, NULL, 1),
(118, NULL, 'ANF00053', NULL, NULL, 'Translation of DNA repeat', NULL, 'Spurious_ORF_53', NULL, NULL, NULL, 1),
(119, NULL, 'ANF00041', NULL, NULL, 'Antisense to RNaseP', NULL, 'Spurious_ORF_41', NULL, NULL, NULL, 1),
(120, NULL, 'ANF00214', NULL, NULL, 'Shadow ORF (opposite aco-1)', NULL, 'Spurious_ORF_214', NULL, NULL, NULL, 1),
(121, NULL, 'ANF00247', NULL, NULL, 'Shadow ORF (opposite tnpA)', NULL, 'Spurious_ORF_247', NULL, NULL, NULL, 1),
(122, NULL, 'ANF00001', NULL, NULL, 'Shadow ORF', NULL, 'Spurious_ORF_01', NULL, NULL, NULL, 1),
(123, NULL, 'ANF00181', NULL, NULL, 'Shadow ORF (opposite rpmE)', NULL, 'Spurious_ORF_181', NULL, NULL, NULL, 1),
(124, NULL, 'ANF00027', NULL, NULL, 'Antisense to SAM riboswitch', NULL, 'Spurious_ORF_27', NULL, NULL, NULL, 1),
(125, NULL, 'ANF00108', NULL, NULL, 'Shadow ORF (opposite rnpA)', NULL, 'Spurious_ORF_108', NULL, NULL, NULL, 1),
(126, NULL, 'ANF00226', NULL, NULL, 'Shadow ORF (opposite pknB)', NULL, 'Spurious_ORF_226', NULL, NULL, NULL, 1),
(127, NULL, 'ANF00252', NULL, NULL, 'Shadow ORF (formerly DUF1590)', NULL, 'Spurious_ORF_252', NULL, NULL, NULL, 1),
(128, NULL, 'ANF00122', NULL, NULL, 'Shadow ORF (opposite clpB)', NULL, 'Spurious_ORF_122', NULL, NULL, NULL, 1),
(129, NULL, 'ANF00259', NULL, NULL, 'Protein of unknown function (DUF1472)', NULL, 'Spurious_ORF_259', NULL, NULL, NULL, 1),
(130, NULL, 'ANF00233', NULL, NULL, 'Shadow ORF (opposite trxB)', NULL, 'Spurious_ORF_233', NULL, NULL, NULL, 1),
(131, NULL, 'ANF00008', NULL, NULL, 'Translation of CRISPR region', NULL, 'Spurious_ORF_08', NULL, NULL, NULL, 1),
(132, NULL, 'ANF00093', NULL, NULL, 'Shadow ORF (opposite nagR)', NULL, 'Spurious_ORF_93', NULL, NULL, NULL, 1),
(133, NULL, 'ANF00174', NULL, NULL, 'Shadow ORF (irp2)', NULL, 'Spurious_ORF_174', NULL, NULL, NULL, 1),
(134, NULL, 'ANF00067', NULL, NULL, 'Translation of non-protein-coding upstream region of an enzyme', NULL, 'Spurious_ORF_67', NULL, NULL, NULL, 1),
(135, NULL, 'ANF00141', NULL, NULL, 'Shadow ORF (opposite guaB)', NULL, 'Spurious_ORF_141', NULL, NULL, NULL, 1),
(136, NULL, 'ANF00060', NULL, NULL, 'FAM74 lncRNA', NULL, 'Spurious_ORF_60', NULL, NULL, NULL, 1),
(137, NULL, 'ANF00034', NULL, NULL, 'Antisense to 5.8S rRNA', NULL, 'Spurious_ORF_34', NULL, NULL, NULL, 1),
(138, NULL, 'ANF00115', NULL, NULL, 'Shadow ORF (opposite Oplah)', NULL, 'Spurious_ORF_115', NULL, NULL, NULL, 1),
(139, NULL, 'ANF00200', NULL, NULL, 'Shadow ORF (opposite yrdD)', NULL, 'Spurious_ORF_200', NULL, NULL, NULL, 1),
(140, NULL, 'ANF00148', NULL, NULL, 'Shadow ORF (opposite flhA)', NULL, 'Spurious_ORF_148', NULL, NULL, NULL, 1),
(141, NULL, 'ANF00256', NULL, NULL, 'Protein of unknown function (DUF1586)', NULL, 'Spurious_ORF_256', NULL, NULL, NULL, 1),
(142, NULL, 'ANF00104', NULL, NULL, 'Shadow ORF (opposite FlhA)', NULL, 'Spurious_ORF_104', NULL, NULL, NULL, 1),
(143, NULL, 'ANF00064', NULL, NULL, 'Unclear; Possibly translation of poorly localized IS Element IS621', NULL, 'Spurious_ORF_64', NULL, NULL, NULL, 1),
(144, NULL, 'ANF00187', NULL, NULL, 'Shadow ORF (opposite parA)', NULL, 'Spurious_ORF_187', NULL, NULL, NULL, 1);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(145, NULL, 'ANF00168', NULL, NULL, 'Shadow ORF (opposite smc)', NULL, 'Spurious_ORF_168', NULL, NULL, NULL, 1),
(146, NULL, 'ANF00013', NULL, NULL, 'tRNA translation', NULL, 'Spurious_ORF_13', NULL, NULL, NULL, 1),
(147, NULL, 'ANF00136', NULL, NULL, 'Shadow ORF (opposite garK)', NULL, 'Spurious_ORF_136', NULL, NULL, NULL, 1),
(148, NULL, 'ANF00209', NULL, NULL, 'Shadow ORF (opposite thrS)', NULL, 'Spurious_ORF_209', NULL, NULL, NULL, 1),
(149, NULL, 'ANF00045', NULL, NULL, 'Antisense to RNaseP', NULL, 'Spurious_ORF_45', NULL, NULL, NULL, 1),
(150, NULL, 'ANF00155', NULL, NULL, 'Shadow ORF (opposite secY)', NULL, 'Spurious_ORF_155', NULL, NULL, NULL, 1),
(151, NULL, 'ANF00237', NULL, NULL, 'Shadow ORF (opposite ahcY)', NULL, 'Spurious_ORF_237', NULL, NULL, NULL, 1),
(152, NULL, 'ANF00170', NULL, NULL, 'Shadow ORF (opposite rpoB)', NULL, 'Spurious_ORF_170', NULL, NULL, NULL, 1),
(153, NULL, 'ANF00017', NULL, NULL, 'tRNA translation', NULL, 'Spurious_ORF_17', NULL, NULL, NULL, 1),
(154, NULL, 'ANF00224', NULL, NULL, 'Shadow ORF (opposite pntA)', NULL, 'Spurious_ORF_224', NULL, NULL, NULL, 1),
(155, NULL, 'ANF00183', NULL, NULL, 'Shadow ORF (opposite rarD)', NULL, 'Spurious_ORF_183', NULL, NULL, NULL, 1),
(156, NULL, 'ANF00068', NULL, NULL, 'Translation of DNA repeat', NULL, 'Spurious_ORF_68', NULL, NULL, NULL, 1),
(157, NULL, 'ANF00149', NULL, NULL, 'Shadow ORF (opposite cshA)', NULL, 'Spurious_ORF_149', NULL, NULL, NULL, 1),
(158, NULL, 'ANF00092', NULL, NULL, 'Shadow ORF (opposite soxA)', NULL, 'Spurious_ORF_92', NULL, NULL, NULL, 1),
(159, NULL, 'ANF00201', NULL, NULL, 'Shadow ORF (opposite gacS)', NULL, 'Spurious_ORF_201', NULL, NULL, NULL, 1),
(160, NULL, 'ANF00026', NULL, NULL, 'Overlaps glmS ribozyme', NULL, 'Spurious_ORF_26', NULL, NULL, NULL, 1),
(161, NULL, 'ANF00123', NULL, NULL, 'Shadow ORF (opposite nasD)', NULL, 'Spurious_ORF_123', NULL, NULL, NULL, 1),
(162, NULL, 'ANF00228', NULL, NULL, 'Shadow ORF (opposite rbsA1)', NULL, 'Spurious_ORF_228', NULL, NULL, NULL, 1),
(163, NULL, 'ANF00218', NULL, NULL, 'Shadow ORF (opposite Oca2)', NULL, 'Spurious_ORF_218', NULL, NULL, NULL, 1),
(164, NULL, 'ANF00211', NULL, NULL, 'Shadow ORF (opposite nasD)', NULL, 'Spurious_ORF_211', NULL, NULL, NULL, 1),
(165, NULL, 'ANF00036', NULL, NULL, 'Antisense to RNaseP', NULL, 'Spurious_ORF_36', NULL, NULL, NULL, 1),
(166, NULL, 'ANF00032', NULL, NULL, 'Antisense to tmRNA', NULL, 'Spurious_ORF_32', NULL, NULL, NULL, 1),
(167, NULL, 'ANF00113', NULL, NULL, 'Shadow ORF (opposite OPLAH)', NULL, 'Spurious_ORF_113', NULL, NULL, NULL, 1),
(168, NULL, 'ANF00100', NULL, NULL, 'Shadow ORF (opposite leuC)', NULL, 'Spurious_ORF_100', NULL, NULL, NULL, 1),
(169, NULL, 'ANF00117', NULL, NULL, 'Shadow ORF (opposite PRN2)', NULL, 'Spurious_ORF_117', NULL, NULL, NULL, 1),
(170, NULL, 'ANF00205', NULL, NULL, 'Shadow ORF (opposite nemA)', NULL, 'Spurious_ORF_205', NULL, NULL, NULL, 1),
(171, NULL, 'ANF00049', NULL, NULL, 'Contained within insertion sequence ISlin1', NULL, 'Spurious_ORF_49', NULL, NULL, NULL, 1),
(172, NULL, 'ANF00110', NULL, NULL, 'Shadow ORF (opposite hemE)', NULL, 'Spurious_ORF_110', NULL, NULL, NULL, 1),
(173, NULL, 'ANF00039', NULL, NULL, 'Antisense to SRP RNA', NULL, 'Spurious_ORF_39', NULL, NULL, NULL, 1),
(174, NULL, 'ANF00230', NULL, NULL, 'Shadow ORF (opposite rpoZ)', NULL, 'Spurious_ORF_230', NULL, NULL, NULL, 1),
(175, NULL, 'ANF00178', NULL, NULL, 'Shadow ORF (opposite dhbF)', NULL, 'Spurious_ORF_178', NULL, NULL, NULL, 1),
(176, NULL, 'ANF00023', NULL, NULL, 'Spurious family', NULL, 'Spurious_ORF_23', NULL, NULL, NULL, 1),
(177, NULL, 'ANF00004', NULL, NULL, 'Shadow ORF', NULL, 'Spurious_ORF_04', NULL, NULL, NULL, 1),
(178, NULL, 'ANF00177', NULL, NULL, 'Shadow ORF (opposite rpsU)', NULL, 'Spurious_ORF_177', NULL, NULL, NULL, 1),
(179, NULL, 'ANF00262', NULL, NULL, 'Sheep genome contamination of bacterial genome', NULL, 'Spurious_ORF_262', NULL, NULL, NULL, 1),
(180, NULL, 'ANF00145', NULL, NULL, 'Shadow ORF (opposite macB)', NULL, 'Spurious_ORF_145', NULL, NULL, NULL, 1),
(181, NULL, 'ANF00126', NULL, NULL, 'Shadow ORF (opposite kdpA)', NULL, 'Spurious_ORF_126', NULL, NULL, NULL, 1);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(182, NULL, 'ANF00196', NULL, NULL, 'Shadow ORF (opposite deoA)', NULL, 'Spurious_ORF_196', NULL, NULL, NULL, 1),
(183, NULL, 'ANF00159', NULL, NULL, 'Shadow ORF (opposite uvrA)', NULL, 'Spurious_ORF_159', NULL, NULL, NULL, 1),
(184, NULL, 'ANF00058', NULL, NULL, 'Translation of ribosomal DNA repeat', NULL, 'Spurious_ORF_58', NULL, NULL, NULL, 1),
(185, NULL, 'ANF00051', NULL, NULL, 'Translation of DNA tandem repeat', NULL, 'Spurious_ORF_51', NULL, NULL, NULL, 1),
(186, NULL, 'ANF00165', NULL, NULL, 'Shadow ORF (opposite Transposase_Mut domain)', NULL, 'Spurious_ORF_165', NULL, NULL, NULL, 1),
(187, NULL, 'ANF00243', NULL, NULL, 'Shadow ORF (opposite yfeH)', NULL, 'Spurious_ORF_243', NULL, NULL, NULL, 1),
(188, NULL, 'ANF00132', NULL, NULL, 'Shadow ORF (opposite rne)', NULL, 'Spurious_ORF_132', NULL, NULL, NULL, 1),
(189, NULL, 'ANF00050', NULL, NULL, 'Translation of CRISPR YPEST repeat 1', NULL, 'Spurious_ORF_50', NULL, NULL, NULL, 1),
(190, NULL, 'ANF00164', NULL, NULL, 'Shadow ORF (opposite btuB)', NULL, 'Spurious_ORF_164', NULL, NULL, NULL, 1),
(191, NULL, 'ANF00210', NULL, NULL, 'Shadow ORF (opposite tuaD)', NULL, 'Spurious_ORF_210', NULL, NULL, NULL, 1),
(192, NULL, 'ANF00077', NULL, NULL, 'Shadow ORF (opposite AtoC)', NULL, 'Spurious_ORF_77', NULL, NULL, NULL, 1),
(193, NULL, 'ANF00158', NULL, NULL, 'Shadow ORF (opposite ftsK2)', NULL, 'Spurious_ORF_158', NULL, NULL, NULL, 1),
(194, NULL, 'ANF00070', NULL, NULL, 'Spurious family', NULL, 'Spurious_ORF_70', NULL, NULL, NULL, 1),
(195, NULL, 'ANF00151', NULL, NULL, 'Shadow ORF (opposite dapD)', NULL, 'Spurious_ORF_151', NULL, NULL, NULL, 1),
(196, NULL, 'ANF00184', NULL, NULL, 'Shadow ORF (opposite pur8)', NULL, 'Spurious_ORF_184', NULL, NULL, NULL, 1),
(197, NULL, 'ANF00083', NULL, NULL, 'Shadow ORF (opposite leuS)', NULL, 'Spurious_ORF_83', NULL, NULL, NULL, 1),
(198, NULL, 'ANF00197', NULL, NULL, 'Shadow ORF (opposite mdh)', NULL, 'Spurious_ORF_197', NULL, NULL, NULL, 1),
(199, NULL, 'ANF00223', NULL, NULL, 'Shadow ORF (opposite guaB)', NULL, 'Spurious_ORF_223', NULL, NULL, NULL, 1),
(200, NULL, 'ANF00063', NULL, NULL, 'Antisense to ATP synthase alpha subunit', NULL, 'Spurious_ORF_63', NULL, NULL, NULL, 1),
(201, NULL, 'ANF00152', NULL, NULL, 'Shadow ORF (opposite nadB1)', NULL, 'Spurious_ORF_152', NULL, NULL, NULL, 1),
(202, NULL, 'ANF00014', NULL, NULL, 'tRNA translation', NULL, 'Spurious_ORF_14', NULL, NULL, NULL, 1),
(203, NULL, 'ANF00097', NULL, NULL, 'Shadow ORF (opposite CRYZ)', NULL, 'Spurious_ORF_97', NULL, NULL, NULL, 1),
(204, NULL, 'ANF00135', NULL, NULL, 'Shadow ORF (opposite gmr)', NULL, 'Spurious_ORF_135', NULL, NULL, NULL, 1),
(205, NULL, 'ANF00031', NULL, NULL, 'Antisense to tmRNA', NULL, 'Spurious_ORF_31', NULL, NULL, NULL, 1),
(206, NULL, 'ANF00137', NULL, NULL, 'Shadow ORF (opposite dnaQ)', NULL, 'Spurious_ORF_137', NULL, NULL, NULL, 1),
(207, NULL, 'ANF00208', NULL, NULL, 'Shadow ORF (opposite rpmJ)', NULL, 'Spurious_ORF_208', NULL, NULL, NULL, 1),
(208, NULL, 'ANF00080', NULL, NULL, 'Shadow ORF (opposite dnaE)', NULL, 'Spurious_ORF_80', NULL, NULL, NULL, 1),
(209, NULL, 'ANF00154', NULL, NULL, 'Shadow ORF (opposite mnmG)', NULL, 'Spurious_ORF_154', NULL, NULL, NULL, 1),
(210, NULL, 'ANF00099', NULL, NULL, 'Shadow ORF (opposite glcB)', NULL, 'Spurious_ORF_99', NULL, NULL, NULL, 1),
(211, NULL, 'ANF00204', NULL, NULL, 'Shadow ORF (opposite rpsA)', NULL, 'Spurious_ORF_204', NULL, NULL, NULL, 1),
(212, NULL, 'ANF00118', NULL, NULL, 'Shadow ORF (opposite ucp12)', NULL, 'Spurious_ORF_118', NULL, NULL, NULL, 1),
(213, NULL, 'ANF00061', NULL, NULL, 'FAM182 lncRNA', NULL, 'Spurious_ORF_61', NULL, NULL, NULL, 1),
(214, NULL, 'ANF00082', NULL, NULL, 'Shadow ORF (opposite glgX)', NULL, 'Spurious_ORF_82', NULL, NULL, NULL, 1),
(215, NULL, 'ANF00012', NULL, NULL, 'tRNA translation', NULL, 'Spurious_ORF_12', NULL, NULL, NULL, 1),
(216, NULL, 'ANF00255', NULL, NULL, 'Protein of unknown function (DUF1584)', NULL, 'Spurious_ORF_255', NULL, NULL, NULL, 1),
(217, NULL, 'ANF00033', NULL, NULL, 'Antisense to tmRNA', NULL, 'Spurious_ORF_33', NULL, NULL, NULL, 1);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(218, NULL, 'ANF00116', NULL, NULL, 'Shadow ORF (opposite cobK)', NULL, 'Spurious_ORF_116', NULL, NULL, NULL, 1),
(219, NULL, 'ANF00206', NULL, NULL, 'Shadow ORF (opposite sucB)', NULL, 'Spurious_ORF_206', NULL, NULL, NULL, 1),
(220, NULL, 'ANF00251', NULL, NULL, 'Shadow ORF (opposite moaA)', NULL, 'Spurious_ORF_251', NULL, NULL, NULL, 1),
(221, NULL, 'ANF00042', NULL, NULL, 'Antisense to RNaseP', NULL, 'Spurious_ORF_42', NULL, NULL, NULL, 1),
(222, NULL, 'ANF00035', NULL, NULL, 'Antisense to 23S rRNA', NULL, 'Spurious_ORF_35', NULL, NULL, NULL, 1),
(223, NULL, 'ANF00199', NULL, NULL, 'Shadow ORF (opposite gltB)', NULL, 'Spurious_ORF_199', NULL, NULL, NULL, 1),
(224, NULL, 'ANF00059', NULL, NULL, 'Ret finger protein-like 3 antisense', NULL, 'Spurious_ORF_59', NULL, NULL, NULL, 1),
(225, NULL, 'ANF00173', NULL, NULL, 'Shadow ORF (opposite ppk)', NULL, 'Spurious_ORF_173', NULL, NULL, NULL, 1),
(226, NULL, 'ANF00234', NULL, NULL, 'Shadow ORF (opposite dnaE1)', NULL, 'Spurious_ORF_234', NULL, NULL, NULL, 1),
(227, NULL, 'ANF00163', NULL, NULL, 'Shadow ORF (opposite pspPIM)', NULL, 'Spurious_ORF_163', NULL, NULL, NULL, 1),
(228, NULL, 'ANF00078', NULL, NULL, 'Shadow ORF (opposite pccB)', NULL, 'Spurious_ORF_78', NULL, NULL, NULL, 1),
(229, NULL, 'ANF00244', NULL, NULL, 'Shadow ORF (yokA)', NULL, 'Spurious_ORF_244', NULL, NULL, NULL, 1),
(230, NULL, 'ANF00225', NULL, NULL, 'Shadow ORF (opposite tuf)', NULL, 'Spurious_ORF_225', NULL, NULL, NULL, 1),
(231, NULL, 'ANF00182', NULL, NULL, 'Shadow ORF (opposite rplL)', NULL, 'Spurious_ORF_182', NULL, NULL, NULL, 1),
(232, NULL, 'ANF00156', NULL, NULL, 'Shadow ORF (opposite yahK)', NULL, 'Spurious_ORF_156', NULL, NULL, NULL, 1),
(233, NULL, 'ANF00052', NULL, NULL, 'Translation of DNA tandem repeat', NULL, 'Spurious_ORF_52', NULL, NULL, NULL, 1),
(234, NULL, 'ANF00215', NULL, NULL, 'Shadow ORF (opposite nolG)', NULL, 'Spurious_ORF_215', NULL, NULL, NULL, 1),
(235, NULL, 'ANF00107', NULL, NULL, 'Shadow ORF (opposite qor)', NULL, 'Spurious_ORF_107', NULL, NULL, NULL, 1),
(236, NULL, 'ANF00192', NULL, NULL, 'Shadow ORF (opposite ethA)', NULL, 'Spurious_ORF_192', NULL, NULL, NULL, 1),
(237, NULL, 'ANF00016', NULL, NULL, 'tRNA translation', NULL, 'Spurious_ORF_16', NULL, NULL, NULL, 1),
(238, NULL, 'ANF00133', NULL, NULL, 'Shadow ORF (opposite mccA)', NULL, 'Spurious_ORF_133', NULL, NULL, NULL, 1),
(239, NULL, 'ANF00128', NULL, NULL, 'Shadow ORF (ftsA)', NULL, 'Spurious_ORF_128', NULL, NULL, NULL, 1),
(240, NULL, 'ANF00021', NULL, NULL, 'Incorrect frame translation', NULL, 'Spurious_ORF_21', NULL, NULL, NULL, 1),
(241, NULL, 'ANF00194', NULL, NULL, 'Shadow ORF (opposite ams)', NULL, 'Spurious_ORF_194', NULL, NULL, NULL, 1),
(242, NULL, 'ANF00161', NULL, NULL, 'Shadow ORF (opposite leuA)', NULL, 'Spurious_ORF_161', NULL, NULL, NULL, 1),
(243, NULL, 'ANF00054', NULL, NULL, 'Translation of long non-coding RNA DLEU2', NULL, 'Spurious_ORF_54', NULL, NULL, NULL, 1),
(244, NULL, 'ANF00087', NULL, NULL, 'Shadow ORF (opposite mnmG)', NULL, 'Spurious_ORF_87', NULL, NULL, NULL, 1),
(245, NULL, 'ANF00147', NULL, NULL, 'Shadow ORF (opposite ptlH)', NULL, 'Spurious_ORF_147', NULL, NULL, NULL, 1),
(246, NULL, 'ANF00175', NULL, NULL, 'Shadow ORF (opposite plcN)', NULL, 'Spurious_ORF_175', NULL, NULL, NULL, 1),
(247, NULL, 'ANF00009', NULL, NULL, 'Shadow ORF (opposite transposase protein)', NULL, 'Spurious_ORF_09', NULL, NULL, NULL, 1),
(248, NULL, 'ANF00114', NULL, NULL, 'Shadow ORF (opposite afsK)', NULL, 'Spurious_ORF_114', NULL, NULL, NULL, 1),
(249, NULL, 'ANF00007', NULL, NULL, 'Shadow ORF (opposite clpB)', NULL, 'Spurious_ORF_07', NULL, NULL, NULL, 1),
(250, NULL, 'ANF00265', NULL, NULL, 'Borrelia repeat', NULL, 'Spurious_ORF_265', NULL, NULL, NULL, 1),
(251, NULL, 'ANF00002', NULL, NULL, 'Shadow ORF', NULL, 'Spurious_ORF_02', NULL, NULL, NULL, 1),
(252, NULL, 'ANF00142', NULL, NULL, 'Shadow ORF (opposite yadG)', NULL, 'Spurious_ORF_142', NULL, NULL, NULL, 1),
(253, NULL, 'ANF00232', NULL, NULL, 'Shadow ORF (opposite metK)', NULL, 'Spurious_ORF_232', NULL, NULL, NULL, 1);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(254, NULL, 'ANF00227', NULL, NULL, 'Shadow ORF (opposite hmrR)', NULL, 'Spurious_ORF_227', NULL, NULL, NULL, 1),
(255, NULL, 'ANF00109', NULL, NULL, 'Shadow ORF (opposite afsK)', NULL, 'Spurious_ORF_109', NULL, NULL, NULL, 1),
(256, NULL, 'ANF00253', NULL, NULL, 'DNA repeat (formerly DUF1658)', NULL, 'Spurious_ORF_253', NULL, NULL, NULL, 1),
(257, NULL, 'ANF00028', NULL, NULL, 'Antisense to SRP RNA', NULL, 'Spurious_ORF_28', NULL, NULL, NULL, 1),
(258, NULL, 'ANF00180', NULL, NULL, 'Shadow ORF (opposite PGK1)', NULL, 'Spurious_ORF_180', NULL, NULL, NULL, 1),
(259, NULL, 'ANF00040', NULL, NULL, 'Overlaps SRP RNA, same strand', NULL, 'Spurious_ORF_40', NULL, NULL, NULL, 1),
(260, NULL, 'ANF00220', NULL, NULL, 'Shadow ORF (opposite fdxA)', NULL, 'Spurious_ORF_220', NULL, NULL, NULL, 1),
(261, NULL, 'ANF00246', NULL, NULL, 'Shadow ORF (opposite dctM)', NULL, 'Spurious_ORF_246', NULL, NULL, NULL, 1),
(262, NULL, 'ANF00073', NULL, NULL, 'Shadow ORF', NULL, 'Spurious_ORF_73', NULL, NULL, NULL, 1),
(263, NULL, 'ANF00213', NULL, NULL, 'Shadow ORF (opposite glyS)', NULL, 'Spurious_ORF_213', NULL, NULL, NULL, 1),
(264, NULL, 'cd12843', NULL, NULL, 'Bvu_2165_C_like', NULL, 'Bvu_2165_C_like', NULL, NULL, 21627, 2),
(265, NULL, 'cd10287', NULL, NULL, 'prolactin_2', NULL, 'prolactin_2', NULL, NULL, NULL, 2),
(266, NULL, 'cd03714', NULL, NULL, 'RT_DIRS1', NULL, 'RT_DIRS1', NULL, NULL, NULL, 2),
(267, NULL, 'cd17228', NULL, NULL, 'RA_ARAP3', NULL, 'RA_ARAP3', NULL, NULL, NULL, 2),
(268, NULL, 'cd16001', NULL, NULL, '7tmA_P2Y3-like', NULL, '7tmA_P2Y3-like', NULL, NULL, NULL, 2),
(269, NULL, 'cd18664', NULL, NULL, 'CD2_tandem_ScCHD1_like', NULL, 'CD2_tandem_ScCHD1_like', NULL, NULL, NULL, 2),
(270, NULL, 'cd05487', NULL, NULL, 'renin_like', NULL, 'renin_like', NULL, NULL, 10229, 2),
(271, NULL, 'cd02608', NULL, NULL, 'P-type_ATPase_Na-K_like', NULL, 'P-type_ATPase_Na-K_like', NULL, NULL, 4810, 2),
(272, NULL, 'cd07727', NULL, NULL, 'YmaE-like_MBL-fold', NULL, 'YmaE-like_MBL-fold', NULL, NULL, NULL, 2),
(273, NULL, 'cd09204', NULL, NULL, 'PLDc_N_DEXD_b2', NULL, 'PLDc_N_DEXD_b2', NULL, NULL, NULL, 2),
(274, NULL, 'cd08963', NULL, NULL, 'L-asparaginase_I', NULL, 'L-asparaginase_I', NULL, NULL, 29524, 2),
(275, NULL, 'cd05349', NULL, NULL, 'BKR_2_SDR_c', NULL, 'BKR_2_SDR_c', NULL, NULL, NULL, 2),
(276, NULL, 'cd12708', NULL, NULL, 'RRM_RCAN1', NULL, 'RRM_RCAN1', NULL, NULL, 17119, 2),
(277, NULL, 'cd10376', NULL, NULL, 'SH2_STAT5', NULL, 'SH2_STAT5', NULL, NULL, NULL, 2),
(278, NULL, 'cd16783', NULL, NULL, 'mRING-HC-C2H2C4_MDM2', NULL, 'mRING-HC-C2H2C4_MDM2', NULL, NULL, 34599, 2),
(279, NULL, 'cd11583', NULL, NULL, 'Orc6_mid', NULL, 'Orc6_mid', NULL, NULL, NULL, 2),
(280, NULL, 'cd05704', NULL, NULL, 'S1_Rrp5_repeat_hs13', NULL, 'S1_Rrp5_repeat_hs13', NULL, NULL, NULL, 2),
(281, NULL, 'cd04334', NULL, NULL, 'ProRS-INS', NULL, 'ProRS-INS', NULL, NULL, NULL, 2),
(282, NULL, 'cd03128', NULL, NULL, 'GAT_1', NULL, 'GAT_1', NULL, NULL, NULL, 2),
(283, NULL, 'cd21589', NULL, NULL, 'betaCoV_RdRp', NULL, 'betaCoV_RdRp', NULL, NULL, NULL, 2),
(284, NULL, 'cd11750', NULL, NULL, 'GH94N_like_3', NULL, 'GH94N_like_3', NULL, NULL, NULL, 2),
(285, NULL, 'cd03187', NULL, NULL, 'GST_C_Phi', NULL, 'GST_C_Phi', NULL, NULL, 16204, 2),
(286, NULL, 'cd11402', NULL, NULL, 'bHLHzip_Mnt', NULL, 'bHLHzip_Mnt', NULL, NULL, NULL, 2),
(287, NULL, 'cd07972', NULL, NULL, 'OBF_DNA_ligase_Arch_LigB', NULL, 'OBF_DNA_ligase_Arch_LigB', NULL, NULL, NULL, 2),
(288, NULL, 'cd18087', NULL, NULL, 'TrmY-like', NULL, 'TrmY-like', NULL, NULL, 202, 2),
(289, NULL, 'cd12903', NULL, NULL, 'SPRY_PRY_SPRYD4', NULL, 'SPRY_PRY_SPRYD4', NULL, NULL, NULL, 2),
(290, NULL, 'cd14054', NULL, NULL, 'STKc_BMPR2_AMHR2', NULL, 'STKc_BMPR2_AMHR2', NULL, NULL, NULL, 2),
(291, NULL, 'cd12635', NULL, NULL, 'RRM2_CELF3_4_5_6', NULL, 'RRM2_CELF3_4_5_6', NULL, NULL, NULL, 2),
(292, NULL, 'cd17101', NULL, NULL, 'FERM_F1_PTPN13_like', NULL, 'FERM_F1_PTPN13_like', NULL, NULL, NULL, 2),
(293, NULL, 'cd14080', NULL, NULL, 'STKc_TSSK-like', NULL, 'STKc_TSSK-like', NULL, NULL, NULL, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(294, NULL, 'cd08179', NULL, NULL, 'NADPH_BDH', NULL, 'NADPH_BDH', NULL, NULL, 15983, 2),
(295, NULL, 'cd07052', NULL, NULL, 'BMC_like_1_repeat2', NULL, 'BMC_like_1_repeat2', NULL, NULL, NULL, 2),
(296, NULL, 'cd01995', NULL, NULL, 'ExsB', NULL, 'ExsB', NULL, NULL, 16631, 2),
(297, NULL, 'cd16568', NULL, NULL, 'RING-HC_ScPSH1_like', NULL, 'RING-HC_ScPSH1_like', NULL, NULL, NULL, 2),
(298, NULL, 'cd03045', NULL, NULL, 'GST_N_Delta_Epsilon', NULL, 'GST_N_Delta_Epsilon', NULL, NULL, NULL, 2),
(299, NULL, 'cd11736', NULL, NULL, 'HSPA12B_like_NBD', NULL, 'HSPA12B_like_NBD', NULL, NULL, NULL, 2),
(300, NULL, 'cd15203', NULL, NULL, '7tmA_NPYR-like', NULL, '7tmA_NPYR-like', NULL, NULL, NULL, 2),
(301, NULL, 'cd00950', NULL, NULL, 'DHDPS', NULL, 'DHDPS', NULL, NULL, 4098, 2),
(302, NULL, 'cd12183', NULL, NULL, 'LDH_like_2', NULL, 'LDH_like_2', NULL, NULL, NULL, 2),
(303, NULL, 'cd04501', NULL, NULL, 'SGNH_hydrolase_like_4', NULL, 'SGNH_hydrolase_like_4', NULL, NULL, NULL, 2),
(304, NULL, 'cd18992', NULL, NULL, 'LGIC_ECD_HisCl', NULL, 'LGIC_ECD_HisCl', NULL, NULL, NULL, 2),
(305, NULL, 'cd17436', NULL, NULL, 'MFS_GLUT10_Class3', NULL, 'MFS_GLUT10_Class3', NULL, NULL, NULL, 2),
(306, NULL, 'cd14758', NULL, NULL, 'GS_GGDEF_1', NULL, 'GS_GGDEF_1', NULL, NULL, NULL, 2),
(307, NULL, 'cd06142', NULL, NULL, 'RNaseD_exo', NULL, 'RNaseD_exo', NULL, NULL, NULL, 2),
(308, NULL, 'cd06350', NULL, NULL, 'PBP1_GPCR_family_C-like', NULL, 'PBP1_GPCR_family_C-like', NULL, NULL, NULL, 2),
(309, NULL, 'cd07028', NULL, NULL, 'RNAP_RPB3_like', NULL, 'RNAP_RPB3_like', NULL, NULL, NULL, 2),
(310, NULL, 'cd12271', NULL, NULL, 'RRM1_PHIP1', NULL, 'RRM1_PHIP1', NULL, NULL, 1477, 2),
(311, NULL, 'cd02183', NULL, NULL, 'GH16_fungal_CRH1_transglycosylase', NULL, 'GH16_fungal_CRH1_transglycosylase', NULL, NULL, NULL, 2),
(312, NULL, 'cd00078', NULL, NULL, 'HECTc', NULL, 'HECTc', NULL, NULL, 5907, 2),
(313, NULL, 'cd15470', NULL, NULL, 'Myo5_CBD', NULL, 'Myo5_CBD', NULL, NULL, NULL, 2),
(314, NULL, 'cd09146', NULL, NULL, 'PLDc_vPLD5_1', NULL, 'PLDc_vPLD5_1', NULL, NULL, NULL, 2),
(315, NULL, 'cd09444', NULL, NULL, 'LIM_Mical_like_1', NULL, 'LIM_Mical_like_1', NULL, NULL, NULL, 2),
(316, NULL, 'cd19404', NULL, NULL, 'TGF_beta_INHBA', NULL, 'TGF_beta_INHBA', NULL, NULL, NULL, 2),
(317, NULL, 'cd19114', NULL, NULL, 'AKR_AKR2C1', NULL, 'AKR_AKR2C1', NULL, NULL, NULL, 2),
(318, NULL, 'cd07802', NULL, NULL, 'FGGY_L-XK', NULL, 'FGGY_L-XK', NULL, NULL, NULL, 2),
(319, NULL, 'cd01972', NULL, NULL, 'Nitrogenase_VnfE_like', NULL, 'Nitrogenase_VnfE_like', NULL, NULL, NULL, 2),
(320, NULL, 'cd01944', NULL, NULL, 'YegV_kinase_like', NULL, 'YegV_kinase_like', NULL, NULL, NULL, 2),
(321, NULL, 'cd11653', NULL, NULL, 'rap1_RCT', NULL, 'rap1_RCT', NULL, NULL, NULL, 2),
(322, NULL, 'cd05675', NULL, NULL, 'M20_yscS_like', NULL, 'M20_yscS_like', NULL, NULL, NULL, 2),
(323, NULL, 'cd15441', NULL, NULL, '7tmB2_CELSR_Adhesion_IV', NULL, '7tmB2_CELSR_Adhesion_IV', NULL, NULL, NULL, 2),
(324, NULL, 'cd12069', NULL, NULL, 'SH3_ARHGAP27', NULL, 'SH3_ARHGAP27', NULL, NULL, NULL, 2),
(325, NULL, 'cd06060', NULL, NULL, 'misato', NULL, 'misato', NULL, NULL, NULL, 2),
(326, NULL, 'cd03821', NULL, NULL, 'GT4_Bme6-like', NULL, 'GT4_Bme6-like', NULL, NULL, NULL, 2),
(327, NULL, 'cd04445', NULL, NULL, 'DEP_PLEK1', NULL, 'DEP_PLEK1', NULL, NULL, 27858, 2),
(328, NULL, 'cd16690', NULL, NULL, 'RING-H2_Vps41', NULL, 'RING-H2_Vps41', NULL, NULL, NULL, 2),
(329, NULL, 'cd07039', NULL, NULL, 'TPP_PYR_POX', NULL, 'TPP_PYR_POX', NULL, NULL, NULL, 2),
(330, NULL, 'cd09572', NULL, NULL, 'SAM_tumor-p63', NULL, 'SAM_tumor-p63', NULL, NULL, 30879, 2),
(331, NULL, 'cd12591', NULL, NULL, 'RRM2_p54nrb', NULL, 'RRM2_p54nrb', NULL, NULL, 3578, 2),
(332, NULL, 'cd17215', NULL, NULL, 'RA_Rin1', NULL, 'RA_Rin1', NULL, NULL, NULL, 2),
(333, NULL, 'cd19767', NULL, NULL, 'Bbox2_TRIM13_C-XI', NULL, 'Bbox2_TRIM13_C-XI', NULL, NULL, NULL, 2),
(334, NULL, 'cd18627', NULL, NULL, 'CD_polycomb_like', NULL, 'CD_polycomb_like', NULL, NULL, NULL, 2),
(335, NULL, 'cd08376', NULL, NULL, 'C2B_MCTP_PRT', NULL, 'C2B_MCTP_PRT', NULL, NULL, NULL, 2);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(336, NULL, 'cd06590', NULL, NULL, 'RNase_HII_bacteria_HIII_like', NULL, 'RNase_HII_bacteria_HIII_like', NULL, NULL, NULL, 2),
(337, NULL, 'cd07676', NULL, NULL, 'F-BAR_FBP17', NULL, 'F-BAR_FBP17', NULL, NULL, 32055, 2),
(338, NULL, 'cd07224', NULL, NULL, 'Pat_like', NULL, 'Pat_like', NULL, NULL, NULL, 2),
(339, NULL, 'cd04617', NULL, NULL, 'CBS_pair_CcpN', NULL, 'CBS_pair_CcpN', NULL, NULL, NULL, 2),
(340, NULL, 'cd18986', NULL, NULL, 'CBD_ESA1_like', NULL, 'CBD_ESA1_like', NULL, NULL, NULL, 2),
(341, NULL, 'cd04892', NULL, NULL, 'ACT_AK-like_2', NULL, 'ACT_AK-like_2', NULL, NULL, NULL, 2),
(342, NULL, 'cd10807', NULL, NULL, 'YdjC_like_3', NULL, 'YdjC_like_3', NULL, NULL, NULL, 2),
(343, NULL, 'cd01181', NULL, NULL, 'IPT_plexin_repeat3', NULL, 'IPT_plexin_repeat3', NULL, NULL, NULL, 2),
(344, NULL, 'cd11285', NULL, NULL, 'ADF_Twf-N_like', NULL, 'ADF_Twf-N_like', NULL, NULL, NULL, 2),
(345, NULL, 'cd09141', NULL, NULL, 'PLDc_vPLD1_2_yPLD_like_2', NULL, 'PLDc_vPLD1_2_yPLD_like_2', NULL, NULL, NULL, 2),
(346, NULL, 'cd05102', NULL, NULL, 'PTKc_VEGFR3', NULL, 'PTKc_VEGFR3', NULL, NULL, NULL, 2),
(347, NULL, 'cd12450', NULL, NULL, 'RRM1_NUCLs', NULL, 'RRM1_NUCLs', NULL, NULL, 851, 2),
(348, NULL, 'cd08706', NULL, NULL, 'RGS_R12-like', NULL, 'RGS_R12-like', NULL, NULL, NULL, 2),
(349, NULL, 'cd14760', NULL, NULL, 'GS_PAS-GGDEF-EAL', NULL, 'GS_PAS-GGDEF-EAL', NULL, NULL, NULL, 2),
(350, NULL, 'cd15024', NULL, NULL, '7tm_TAS2R42', NULL, '7tm_TAS2R42', NULL, NULL, NULL, 2),
(351, NULL, 'cd07662', NULL, NULL, 'BAR_SNX6', NULL, 'BAR_SNX6', NULL, NULL, NULL, 2),
(352, NULL, 'cd19079', NULL, NULL, 'AKR_EcYajO-like', NULL, 'AKR_EcYajO-like', NULL, NULL, NULL, 2),
(353, NULL, 'cd15708', NULL, NULL, 'ePHD_AF10', NULL, 'ePHD_AF10', NULL, NULL, NULL, 2),
(354, NULL, 'cd09926', NULL, NULL, 'SH2_CRK_like', NULL, 'SH2_CRK_like', NULL, NULL, NULL, 2),
(355, NULL, 'cd08937', NULL, NULL, 'DHB_DH-like_SDR_c', NULL, 'DHB_DH-like_SDR_c', NULL, NULL, NULL, 2),
(356, NULL, 'cd00160', NULL, NULL, 'RhoGEF', NULL, 'RhoGEF', NULL, NULL, 3790, 2),
(357, NULL, 'cd05701', NULL, NULL, 'S1_Rrp5_repeat_hs10', NULL, 'S1_Rrp5_repeat_hs10', NULL, NULL, NULL, 2),
(358, NULL, 'cd17994', NULL, NULL, 'DEXHc_CHD3_4_5', NULL, 'DEXHc_CHD3_4_5', NULL, NULL, NULL, 2),
(359, NULL, 'cd07080', NULL, NULL, 'ALDH_Acyl-CoA-Red_LuxC', NULL, 'ALDH_Acyl-CoA-Red_LuxC', NULL, NULL, 12737, 2),
(360, NULL, 'cd15697', NULL, NULL, 'ePHD2_KMT2C', NULL, 'ePHD2_KMT2C', NULL, NULL, 30578, 2),
(361, NULL, 'cd14994', NULL, NULL, '7tmA_GPR141', NULL, '7tmA_GPR141', NULL, NULL, NULL, 2),
(362, NULL, 'cd16139', NULL, NULL, 'RA_GRB14', NULL, 'RA_GRB14', NULL, NULL, NULL, 2),
(363, NULL, 'cd19930', NULL, NULL, 'REC_DesR-like', NULL, 'REC_DesR-like', NULL, NULL, NULL, 2),
(364, NULL, 'cd14668', NULL, NULL, 'mlta_B', NULL, 'mlta_B', NULL, NULL, NULL, 2),
(365, NULL, 'cd11755', NULL, NULL, 'GH94N_ChBP_like', NULL, 'GH94N_ChBP_like', NULL, NULL, 31759, 2),
(366, NULL, 'cd19421', NULL, NULL, 'lipocalin_5_8-like', NULL, 'lipocalin_5_8-like', NULL, NULL, NULL, 2),
(367, NULL, 'cd13857', NULL, NULL, 'CuRO_1_Diphenol_Ox', NULL, 'CuRO_1_Diphenol_Ox', NULL, NULL, NULL, 2),
(368, NULL, 'cd19616', NULL, NULL, 'FABP11', NULL, 'FABP11', NULL, NULL, NULL, 2),
(369, NULL, 'cd12341', NULL, NULL, 'RRM_hnRNPC_like', NULL, 'RRM_hnRNPC_like', NULL, NULL, NULL, 2),
(370, NULL, 'cd13529', NULL, NULL, 'PBP2_transferrin', NULL, 'PBP2_transferrin', NULL, NULL, NULL, 2),
(371, NULL, 'cd17919', NULL, NULL, 'DEXHc_Snf', NULL, 'DEXHc_Snf', NULL, NULL, NULL, 2),
(372, NULL, 'cd11570', NULL, NULL, 'FAT-like_NEDD9_C', NULL, 'FAT-like_NEDD9_C', NULL, NULL, NULL, 2),
(373, NULL, 'cd10941', NULL, NULL, 'CE4_PuuE_HpPgdA_like_2', NULL, 'CE4_PuuE_HpPgdA_like_2', NULL, NULL, 36824, 2),
(374, NULL, 'cd12214', NULL, NULL, 'ChiA1_BD', NULL, 'ChiA1_BD', NULL, NULL, NULL, 2),
(375, NULL, 'cd18328', NULL, NULL, 'BTB_POZ_ZBTB7C_ZBTB36', NULL, 'BTB_POZ_ZBTB7C_ZBTB36', NULL, NULL, NULL, 2),
(376, NULL, 'cd10144', NULL, NULL, 'Peptidase_S74_CIMCD', NULL, 'Peptidase_S74_CIMCD', NULL, NULL, NULL, 2),
(377, NULL, 'cd14639', NULL, NULL, 'DSP_DUSP5', NULL, 'DSP_DUSP5', NULL, NULL, NULL, 2);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(378, NULL, 'cd12780', NULL, NULL, 'RRM1_hnRNPL', NULL, 'RRM1_hnRNPL', NULL, NULL, 20953, 2),
(379, NULL, 'cd14953', NULL, NULL, 'NHL_like_1', NULL, 'NHL_like_1', NULL, NULL, NULL, 2),
(380, NULL, 'cd01611', NULL, NULL, 'Ubl_Autophagy_like', NULL, 'Ubl_Autophagy_like', NULL, NULL, NULL, 2),
(381, NULL, 'cd01107', NULL, NULL, 'HTH_BmrR', NULL, 'HTH_BmrR', NULL, NULL, NULL, 2),
(382, NULL, 'cd01338', NULL, NULL, 'MDH_choloroplast_like', NULL, 'MDH_choloroplast_like', NULL, NULL, NULL, 2),
(383, NULL, 'cd07886', NULL, NULL, 'RHD-n_RelB', NULL, 'RHD-n_RelB', NULL, NULL, NULL, 2),
(384, NULL, 'cd01471', NULL, NULL, 'vWA_micronemal_protein', NULL, 'vWA_micronemal_protein', NULL, NULL, NULL, 2),
(385, NULL, 'cd11534', NULL, NULL, 'NTP-PPase_HisIE_like', NULL, 'NTP-PPase_HisIE_like', NULL, NULL, 7130, 2),
(386, NULL, 'cd05476', NULL, NULL, 'pepsin_A_like_plant', NULL, 'pepsin_A_like_plant', NULL, NULL, 23363, 2),
(387, NULL, 'cd13414', NULL, NULL, 'TNFRSF17', NULL, 'TNFRSF17', NULL, NULL, 15869, 2),
(388, NULL, 'cd18176', NULL, NULL, 'ATP-synt_Vo_c_ATP6C_rpt2', NULL, 'ATP-synt_Vo_c_ATP6C_rpt2', NULL, NULL, NULL, 2),
(389, NULL, 'cd13619', NULL, NULL, 'PBP2_GlnP', NULL, 'PBP2_GlnP', NULL, NULL, NULL, 2),
(390, NULL, 'cd04970', NULL, NULL, 'Ig6_Contactin', NULL, 'Ig6_Contactin', NULL, NULL, NULL, 2),
(391, NULL, 'cd19753', NULL, NULL, 'Mb-like_oxidoreductase', NULL, 'Mb-like_oxidoreductase', NULL, NULL, NULL, 2),
(392, NULL, 'cd15275', NULL, NULL, '7tmB1_secretin', NULL, '7tmB1_secretin', NULL, NULL, NULL, 2),
(393, NULL, 'cd09891', NULL, NULL, 'NGN_Bact_1', NULL, 'NGN_Bact_1', NULL, NULL, NULL, 2),
(394, NULL, 'cd15359', NULL, NULL, '7tmA_LHCGR', NULL, '7tmA_LHCGR', NULL, NULL, NULL, 2),
(395, NULL, 'cd06494', NULL, NULL, 'p23_NUDCD2_like', NULL, 'p23_NUDCD2_like', NULL, NULL, 30358, 2),
(396, NULL, 'cd17455', NULL, NULL, 'MFS_FLVCR1', NULL, 'MFS_FLVCR1', NULL, NULL, NULL, 2),
(397, NULL, 'cd01022', NULL, NULL, 'GH57N_like', NULL, 'GH57N_like', NULL, NULL, NULL, 2),
(398, NULL, 'cd15749', NULL, NULL, 'FYVE_ZFY19', NULL, 'FYVE_ZFY19', NULL, NULL, NULL, 2),
(399, NULL, 'cd18529', NULL, NULL, 'BACK_RCBTB2', NULL, 'BACK_RCBTB2', NULL, NULL, NULL, 2),
(400, NULL, 'cd00326', NULL, NULL, 'alpha_CA', NULL, 'alpha_CA', NULL, NULL, NULL, 2),
(401, NULL, 'cd15244', NULL, NULL, '7tm_bacteriorhodopsin', NULL, '7tm_bacteriorhodopsin', NULL, NULL, NULL, 2),
(402, NULL, 'cd08647', NULL, NULL, 'FMT_core_FDH_N', NULL, 'FMT_core_FDH_N', NULL, NULL, NULL, 2),
(403, NULL, 'cd00411', NULL, NULL, 'L-asparaginase_like', NULL, 'L-asparaginase_like', NULL, NULL, NULL, 2),
(404, NULL, 'cd10047', NULL, NULL, 'Reelin_repeat_3_subrepeat_2', NULL, 'Reelin_repeat_3_subrepeat_2', NULL, NULL, NULL, 2),
(405, NULL, 'cd01948', NULL, NULL, 'EAL', NULL, 'EAL', NULL, NULL, 5479, 2),
(406, NULL, 'cd13775', NULL, NULL, 'SPFH_eoslipins_u3', NULL, 'SPFH_eoslipins_u3', NULL, NULL, NULL, 2),
(407, NULL, 'cd09466', NULL, NULL, 'LIM1_Lhx3a', NULL, 'LIM1_Lhx3a', NULL, NULL, NULL, 2),
(408, NULL, 'cd05651', NULL, NULL, 'M20_ArgE_DapE-like', NULL, 'M20_ArgE_DapE-like', NULL, NULL, NULL, 2),
(409, NULL, 'cd14436', NULL, NULL, 'LepB', NULL, 'LepB', NULL, NULL, NULL, 2),
(410, NULL, 'cd18442', NULL, NULL, 'BRCT_polymerase_mu', NULL, 'BRCT_polymerase_mu', NULL, NULL, NULL, 2),
(411, NULL, 'cd01412', NULL, NULL, 'SIRT5_Af1_CobB', NULL, 'SIRT5_Af1_CobB', NULL, NULL, 23616, 2),
(412, NULL, 'cd07211', NULL, NULL, 'Pat_PNPLA8', NULL, 'Pat_PNPLA8', NULL, NULL, 36189, 2),
(413, NULL, 'cd11860', NULL, NULL, 'SH3_DLG5', NULL, 'SH3_DLG5', NULL, NULL, 28158, 2),
(414, NULL, 'cd19129', NULL, NULL, 'AKR_BaDH-like', NULL, 'AKR_BaDH-like', NULL, NULL, 35807, 2),
(415, NULL, 'cd09570', NULL, NULL, 'SAM_kazrin_repeat3', NULL, 'SAM_kazrin_repeat3', NULL, NULL, 30668, 2),
(416, NULL, 'cd00599', NULL, NULL, 'GH25_muramidase', NULL, 'GH25_muramidase', NULL, NULL, NULL, 2),
(417, NULL, 'cd07548', NULL, NULL, 'P-type_ATPase-Cd_Zn_Co_like', NULL, 'P-type_ATPase-Cd_Zn_Co_like', NULL, NULL, NULL, 2),
(418, NULL, 'cd08428', NULL, NULL, 'PBP2_IciA_ArgP', NULL, 'PBP2_IciA_ArgP', NULL, NULL, NULL, 2);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(419, NULL, 'cd14772', NULL, NULL, 'TrHb2_Bs-trHb-like_O', NULL, 'TrHb2_Bs-trHb-like_O', NULL, NULL, NULL, 2),
(420, NULL, 'cd16249', NULL, NULL, 'EFh_DTNA', NULL, 'EFh_DTNA', NULL, NULL, NULL, 2),
(421, NULL, 'cd04872', NULL, NULL, 'ACT_1ZPV', NULL, 'ACT_1ZPV', NULL, NULL, 15463, 2),
(422, NULL, 'cd10933', NULL, NULL, 'CE4_u9', NULL, 'CE4_u9', NULL, NULL, NULL, 2),
(423, NULL, 'cd05887', NULL, NULL, 'Ig1_Nectin-3_like', NULL, 'Ig1_Nectin-3_like', NULL, NULL, NULL, 2),
(424, NULL, 'cd15933', NULL, NULL, '7tmB2_GPR133-like_Adhesion_V', NULL, '7tmB2_GPR133-like_Adhesion_V', NULL, NULL, NULL, 2),
(425, NULL, 'cd17396', NULL, NULL, 'MFS_YdiM_like', NULL, 'MFS_YdiM_like', NULL, NULL, NULL, 2),
(426, NULL, 'cd00197', NULL, NULL, 'VHS_ENTH_ANTH', NULL, 'VHS_ENTH_ANTH', NULL, NULL, NULL, 2),
(427, NULL, 'cd13969', NULL, NULL, 'ADCK1-like', NULL, 'ADCK1-like', NULL, NULL, 34334, 2),
(428, NULL, 'cd00951', NULL, NULL, 'KDGDH', NULL, 'KDGDH', NULL, NULL, 17400, 2),
(429, NULL, 'cd12703', NULL, NULL, 'RRM4_ROD1', NULL, 'RRM4_ROD1', NULL, NULL, 32311, 2),
(430, NULL, 'cd12595', NULL, NULL, 'RRM1_SRSF5', NULL, 'RRM1_SRSF5', NULL, NULL, NULL, 2),
(431, NULL, 'cd16310', NULL, NULL, 'Mbl1b-like_MBL-B3', NULL, 'Mbl1b-like_MBL-B3', NULL, NULL, NULL, 2),
(432, NULL, 'cd05105', NULL, NULL, 'PTKc_PDGFR_alpha', NULL, 'PTKc_PDGFR_alpha', NULL, NULL, NULL, 2),
(433, NULL, 'cd17317', NULL, NULL, 'MFS_SLC22', NULL, 'MFS_SLC22', NULL, NULL, NULL, 2),
(434, NULL, 'cd16023', NULL, NULL, 'GPI_EPT_3', NULL, 'GPI_EPT_3', NULL, NULL, 27780, 2),
(435, NULL, 'cd06175', NULL, NULL, 'MFS_POT', NULL, 'MFS_POT', NULL, NULL, NULL, 2),
(436, NULL, 'cd04259', NULL, NULL, 'AAK_AK-DapDC', NULL, 'AAK_AK-DapDC', NULL, NULL, NULL, 2),
(437, NULL, 'cd19711', NULL, NULL, 'bHLH_TS_MIST1', NULL, 'bHLH_TS_MIST1', NULL, NULL, NULL, 2),
(438, NULL, 'cd04167', NULL, NULL, 'Snu114p', NULL, 'Snu114p', NULL, NULL, 35164, 2),
(439, NULL, 'cd07463', NULL, NULL, 'CRD_FZ9', NULL, 'CRD_FZ9', NULL, NULL, 30967, 2),
(440, NULL, 'cd12368', NULL, NULL, 'RRM3_RBM45', NULL, 'RRM3_RBM45', NULL, NULL, 20772, 2),
(441, NULL, 'cd06240', NULL, NULL, 'M14-like', NULL, 'M14-like', NULL, NULL, NULL, 2),
(442, NULL, 'cd12021', NULL, NULL, 'SH3_p47phox_1', NULL, 'SH3_p47phox_1', NULL, NULL, 30106, 2),
(443, NULL, 'cd16645', NULL, NULL, 'mRING-HC-C3HC3D_TRIM23_C-IX', NULL, 'mRING-HC-C3HC3D_TRIM23_C-IX', NULL, NULL, NULL, 2),
(444, NULL, 'cd11998', NULL, NULL, 'SH3_PACSIN1-2', NULL, 'SH3_PACSIN1-2', NULL, NULL, 28389, 2),
(445, NULL, 'cd07107', NULL, NULL, 'ALDH_PhdK-like', NULL, 'ALDH_PhdK-like', NULL, NULL, NULL, 2),
(446, NULL, 'cd14535', NULL, NULL, 'PTP-MTM1-like', NULL, 'PTP-MTM1-like', NULL, NULL, NULL, 2),
(447, NULL, 'cd19977', NULL, NULL, 'PBP1_EndR-like', NULL, 'PBP1_EndR-like', NULL, NULL, NULL, 2),
(448, NULL, 'cd08169', NULL, NULL, 'DHQ-like', NULL, 'DHQ-like', NULL, NULL, NULL, 2),
(449, NULL, 'cd09881', NULL, NULL, 'PIN_VapC4-5_FitB-like', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, NULL, 2),
(450, NULL, 'cd10373', NULL, NULL, 'SH2_STAT2', NULL, 'SH2_STAT2', NULL, NULL, 28403, 2),
(451, NULL, 'cd13629', NULL, NULL, 'PBP2_Dsm1740', NULL, 'PBP2_Dsm1740', NULL, NULL, NULL, 2),
(452, NULL, 'cd13965', NULL, NULL, 'PT_UbiA_3', NULL, 'PT_UbiA_3', NULL, NULL, NULL, 2),
(453, NULL, 'cd14235', NULL, NULL, 'GAT_GGA_fungi', NULL, 'GAT_GGA_fungi', NULL, NULL, NULL, 2),
(454, NULL, 'cd02253', NULL, NULL, 'DmpA', NULL, 'DmpA', NULL, NULL, NULL, 2),
(455, NULL, 'cd04146', NULL, NULL, 'RERG_RasL11_like', NULL, 'RERG_RasL11_like', NULL, NULL, NULL, 2),
(456, NULL, 'cd17150', NULL, NULL, 'DCX1_DCDC2B', NULL, 'DCX1_DCDC2B', NULL, NULL, NULL, 2),
(457, NULL, 'cd04738', NULL, NULL, 'DHOD_2_like', NULL, 'DHOD_2_like', NULL, NULL, 4859, 2),
(458, NULL, 'cd19599', NULL, NULL, 'serpin18-like_insects', NULL, 'serpin18-like_insects', NULL, NULL, NULL, 2),
(459, NULL, 'cd01235', NULL, NULL, 'PH_Sbf1_hMTMR5', NULL, 'PH_Sbf1_hMTMR5', NULL, NULL, NULL, 2),
(460, NULL, 'cd11827', NULL, NULL, 'SH3_MyoIe_If_like', NULL, 'SH3_MyoIe_If_like', NULL, NULL, 17505, 2),
(461, NULL, 'cd14411', NULL, NULL, 'UBA_DCNL1', NULL, 'UBA_DCNL1', NULL, NULL, NULL, 2);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(462, NULL, 'cd11944', NULL, NULL, 'SH3_Endophilin_B2', NULL, 'SH3_Endophilin_B2', NULL, NULL, 28042, 2),
(463, NULL, 'cd13729', NULL, NULL, 'PBP2_iGluR_AMPA_GluR1', NULL, 'PBP2_iGluR_AMPA_GluR1', NULL, NULL, NULL, 2),
(464, NULL, 'cd01982', NULL, NULL, 'Chlide_reductase_Z', NULL, 'Chlide_reductase_Z', NULL, NULL, NULL, 2),
(465, NULL, 'cd08321', NULL, NULL, 'Pyrin_ASC-like', NULL, 'Pyrin_ASC-like', NULL, NULL, NULL, 2),
(466, NULL, 'cd17340', NULL, NULL, 'MFS_MFSD1', NULL, 'MFS_MFSD1', NULL, NULL, NULL, 2),
(467, NULL, 'cd01284', NULL, NULL, 'Riboflavin_deaminase-reductase', NULL, 'Riboflavin_deaminase-reductase', NULL, NULL, NULL, 2),
(468, NULL, 'cd15637', NULL, NULL, 'PHD_dPYGO', NULL, 'PHD_dPYGO', NULL, NULL, NULL, 2),
(469, NULL, 'cd00274', NULL, NULL, 'Chemokine_CX3C', NULL, 'Chemokine_CX3C', NULL, NULL, 31918, 2),
(470, NULL, 'cd03486', NULL, NULL, 'MutL_Trans_MLH3', NULL, 'MutL_Trans_MLH3', NULL, NULL, NULL, 2),
(471, NULL, 'cd18619', NULL, NULL, 'GH43_CoXyl43_like', NULL, 'GH43_CoXyl43_like', NULL, NULL, NULL, 2),
(472, NULL, 'cd05090', NULL, NULL, 'PTKc_Ror1', NULL, 'PTKc_Ror1', NULL, NULL, NULL, 2),
(473, NULL, 'cd01514', NULL, NULL, 'Elongation_Factor_C', NULL, 'Elongation_Factor_C', NULL, NULL, NULL, 2),
(474, NULL, 'cd02237', NULL, NULL, 'cupin_DAD_ChrR', NULL, 'cupin_DAD_ChrR', NULL, NULL, NULL, 2),
(475, NULL, 'cd11890', NULL, NULL, 'MIA', NULL, 'MIA', NULL, NULL, NULL, 2),
(476, NULL, 'cd11568', NULL, NULL, 'FAT-like_CASS4_C', NULL, 'FAT-like_CASS4_C', NULL, NULL, NULL, 2),
(477, NULL, 'cd17758', NULL, NULL, 'MCM7', NULL, 'MCM7', NULL, NULL, 5283, 2),
(478, NULL, 'cd09396', NULL, NULL, 'LIM_DA1', NULL, 'LIM_DA1', NULL, NULL, NULL, 2),
(479, NULL, 'cd03336', NULL, NULL, 'TCP1_beta', NULL, 'TCP1_beta', NULL, NULL, 11813, 2),
(480, NULL, 'cd19786', NULL, NULL, 'Bbox2_TRIM46_C-I', NULL, 'Bbox2_TRIM46_C-I', NULL, NULL, NULL, 2),
(481, NULL, 'cd15804', NULL, NULL, 'RLR_C', NULL, 'RLR_C', NULL, NULL, NULL, 2),
(482, NULL, 'cd06903', NULL, NULL, 'lectin_EMP46_EMP47', NULL, 'lectin_EMP46_EMP47', NULL, NULL, 31126, 2),
(483, NULL, 'cd17653', NULL, NULL, 'A_NRPS_GliP_like', NULL, 'A_NRPS_GliP_like', NULL, NULL, NULL, 2),
(484, NULL, 'cd15173', NULL, NULL, '7tmA_CXCR6', NULL, '7tmA_CXCR6', NULL, NULL, 144, 2),
(485, NULL, 'cd19870', NULL, NULL, 'DSRM_SON-like', NULL, 'DSRM_SON-like', NULL, NULL, NULL, 2),
(486, NULL, 'cd07090', NULL, NULL, 'ALDH_F9_TMBADH', NULL, 'ALDH_F9_TMBADH', NULL, NULL, NULL, 2),
(487, NULL, 'cd13379', NULL, NULL, 'PH_RhoGap24', NULL, 'PH_RhoGap24', NULL, NULL, NULL, 2),
(488, NULL, 'cd09608', NULL, NULL, 'M3B_PepF', NULL, 'M3B_PepF', NULL, NULL, NULL, 2),
(489, NULL, 'cd06870', NULL, NULL, 'PX_CISK', NULL, 'PX_CISK', NULL, NULL, 28959, 2),
(490, NULL, 'cd13353', NULL, NULL, 'PH-GRAM2_TBC1D8', NULL, 'PH-GRAM2_TBC1D8', NULL, NULL, 28445, 2),
(491, NULL, 'cd12312', NULL, NULL, 'RRM_SRSF10_SRSF12', NULL, 'RRM_SRSF10_SRSF12', NULL, NULL, NULL, 2),
(492, NULL, 'cd13583', NULL, NULL, 'PBP2_AlgQ_like_4', NULL, 'PBP2_AlgQ_like_4', NULL, NULL, NULL, 2),
(493, NULL, 'cd19851', NULL, NULL, 'lipocalin_CHL', NULL, 'lipocalin_CHL', NULL, NULL, NULL, 2),
(494, NULL, 'cd15187', NULL, NULL, '7tmA_CCR8', NULL, '7tmA_CCR8', NULL, NULL, NULL, 2),
(495, NULL, 'cd16504', NULL, NULL, 'RING-HC_COP1', NULL, 'RING-HC_COP1', NULL, NULL, NULL, 2),
(496, NULL, 'cd13580', NULL, NULL, 'PBP2_AlgQ_like_1', NULL, 'PBP2_AlgQ_like_1', NULL, NULL, NULL, 2),
(497, NULL, 'cd15175', NULL, NULL, '7tmA_CCR7', NULL, '7tmA_CCR7', NULL, NULL, NULL, 2),
(498, NULL, 'cd14485', NULL, NULL, 'mltA_like_LT_A', NULL, 'mltA_like_LT_A', NULL, NULL, 6414, 2),
(499, NULL, 'cd16763', NULL, NULL, 'RING-HC_TRIM59_C-V', NULL, 'RING-HC_TRIM59_C-V', NULL, NULL, NULL, 2),
(500, NULL, 'cd00342', NULL, NULL, 'gram_neg_porins', NULL, 'gram_neg_porins', NULL, NULL, 27372, 2),
(501, NULL, 'cd17328', NULL, NULL, 'MFS_spinster_like', NULL, 'MFS_spinster_like', NULL, NULL, 34140, 2),
(502, NULL, 'cd02793', NULL, NULL, 'MopB_CT_DMSOR-BSOR-TMAOR', NULL, 'MopB_CT_DMSOR-BSOR-TMAOR', NULL, NULL, 30701, 2),
(503, NULL, 'cd15157', NULL, NULL, '7tmA_CysLTR2', NULL, '7tmA_CysLTR2', NULL, NULL, NULL, 2);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(504, NULL, 'cd01865', NULL, NULL, 'Rab3', NULL, 'Rab3', NULL, NULL, 27229, 2),
(505, NULL, 'sd00002', NULL, NULL, 'TSP3', NULL, 'TSP3', NULL, NULL, NULL, 2),
(506, NULL, 'cd06124', NULL, NULL, 'cupin_NimR-like_N', NULL, 'cupin_NimR-like_N', NULL, NULL, NULL, 2),
(507, NULL, 'cd18450', NULL, NULL, 'BACK_KLHL10', NULL, 'BACK_KLHL10', NULL, NULL, NULL, 2),
(508, NULL, 'cd02014', NULL, NULL, 'TPP_POX', NULL, 'TPP_POX', NULL, NULL, NULL, 2),
(509, NULL, 'cd02182', NULL, NULL, 'GH16_Strep_laminarinase_like', NULL, 'GH16_Strep_laminarinase_like', NULL, NULL, NULL, 2),
(510, NULL, 'cd06339', NULL, NULL, 'PBP1_YraM_LppC_lipoprotein-like', NULL, 'PBP1_YraM_LppC_lipoprotein-like', NULL, NULL, NULL, 2),
(511, NULL, 'cd17992', NULL, NULL, 'DEXHc_RecG', NULL, 'DEXHc_RecG', NULL, NULL, NULL, 2),
(512, NULL, 'cd01609', NULL, NULL, 'RNAP_beta''_N', NULL, 'RNAP_beta''_N', NULL, NULL, NULL, 2),
(513, NULL, 'cd08443', NULL, NULL, 'PBP2_CysB', NULL, 'PBP2_CysB', NULL, NULL, NULL, 2),
(514, NULL, 'cd16934', NULL, NULL, 'HATPase_RsbT-like', NULL, 'HATPase_RsbT-like', NULL, NULL, NULL, 2),
(515, NULL, 'cd13654', NULL, NULL, 'PBP2_phosphate_like_2', NULL, 'PBP2_phosphate_like_2', NULL, NULL, NULL, 2),
(516, NULL, 'cd14835', NULL, NULL, 'AP1_Mu_N', NULL, 'AP1_Mu_N', NULL, NULL, NULL, 2),
(517, NULL, 'cd17290', NULL, NULL, 'RMtype1_S_AleSS8ORF2795P_TRD1-CR1_like', NULL, 'RMtype1_S_AleSS8ORF2795P_TRD1-CR1_like', NULL, NULL, NULL, 2),
(518, NULL, 'cd00074', NULL, NULL, 'H2A', NULL, 'H2A', NULL, NULL, 1479, 2),
(519, NULL, 'cd08284', NULL, NULL, 'FDH_like_2', NULL, 'FDH_like_2', NULL, NULL, NULL, 2),
(520, NULL, 'cd11424', NULL, NULL, 'bHLH_TS_OUT', NULL, 'bHLH_TS_OUT', NULL, NULL, NULL, 2),
(521, NULL, 'cd19126', NULL, NULL, 'AKR_AKR5A_5G', NULL, 'AKR_AKR5A_5G', NULL, NULL, NULL, 2),
(522, NULL, 'cd03426', NULL, NULL, 'CoAse', NULL, 'CoAse', NULL, NULL, 35759, 2),
(523, NULL, 'cd01274', NULL, NULL, 'PTB_Anks', NULL, 'PTB_Anks', NULL, NULL, NULL, 2),
(524, NULL, 'cd05135', NULL, NULL, 'RasGAP_RASAL', NULL, 'RasGAP_RASAL', NULL, NULL, 32153, 2),
(525, NULL, 'cd07867', NULL, NULL, 'STKc_CDC2L6', NULL, 'STKc_CDC2L6', NULL, NULL, NULL, 2),
(526, NULL, 'cd15497', NULL, NULL, 'PHD1_Snt2p_like', NULL, 'PHD1_Snt2p_like', NULL, NULL, NULL, 2),
(527, NULL, 'cd21565', NULL, NULL, 'betaCoV_M', NULL, 'betaCoV_M', NULL, NULL, NULL, 2),
(528, NULL, 'cd02563', NULL, NULL, 'PseudoU_synth_TruC', NULL, 'PseudoU_synth_TruC', NULL, NULL, NULL, 2),
(529, NULL, 'cd17755', NULL, NULL, 'MCM4', NULL, 'MCM4', NULL, NULL, NULL, 2),
(530, NULL, 'cd19776', NULL, NULL, 'Bbox2_TRIM25_C-IV', NULL, 'Bbox2_TRIM25_C-IV', NULL, NULL, NULL, 2),
(531, NULL, 'cd19730', NULL, NULL, 'bHLH-PAS_spineless_like', NULL, 'bHLH-PAS_spineless_like', NULL, NULL, NULL, 2),
(532, NULL, 'cd03689', NULL, NULL, 'RF3_II', NULL, 'RF3_II', NULL, NULL, NULL, 2),
(533, NULL, 'cd07707', NULL, NULL, 'MBL-B1-B2-like', NULL, 'MBL-B1-B2-like', NULL, NULL, NULL, 2),
(534, NULL, 'cd06310', NULL, NULL, 'PBP1_ABC_sugar_binding-like', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, NULL, 2),
(535, NULL, 'cd02906', NULL, NULL, 'Macro_1', NULL, 'Macro_1', NULL, NULL, 32768, 2),
(536, NULL, 'cd11393', NULL, NULL, 'bHLH_AtbHLH_like', NULL, 'bHLH_AtbHLH_like', NULL, NULL, 36875, 2),
(537, NULL, 'cd18543', NULL, NULL, 'ABC_6TM_Rv0194_D1_like', NULL, 'ABC_6TM_Rv0194_D1_like', NULL, NULL, NULL, 2),
(538, NULL, 'cd06212', NULL, NULL, 'monooxygenase_like', NULL, 'monooxygenase_like', NULL, NULL, NULL, 2),
(539, NULL, 'cd00260', NULL, NULL, 'Sialidase', NULL, 'Sialidase', NULL, NULL, NULL, 2),
(540, NULL, 'cd06326', NULL, NULL, 'PBP1_ABC_ligand_binding-like', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, NULL, 2),
(541, NULL, 'cd02191', NULL, NULL, 'FtsZ_CetZ-like', NULL, 'FtsZ_CetZ-like', NULL, NULL, NULL, 2),
(542, NULL, 'cd12697', NULL, NULL, 'RRM3_ROD1', NULL, 'RRM3_ROD1', NULL, NULL, NULL, 2),
(543, NULL, 'cd05899', NULL, NULL, 'IgV_TCR_beta', NULL, 'IgV_TCR_beta', NULL, NULL, NULL, 2),
(544, NULL, 'cd05167', NULL, NULL, 'PI4Kc_III_alpha', NULL, 'PI4Kc_III_alpha', NULL, NULL, NULL, 2);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(545, NULL, 'cd16545', NULL, NULL, 'RING-HC_RNF141', NULL, 'RING-HC_RNF141', NULL, NULL, 36308, 2),
(546, NULL, 'cd10445', NULL, NULL, 'GIY-YIG_bI1_like', NULL, 'GIY-YIG_bI1_like', NULL, NULL, NULL, 2),
(547, NULL, 'cd07111', NULL, NULL, 'ALDH_F16', NULL, 'ALDH_F16', NULL, NULL, NULL, 2),
(548, NULL, 'cd13733', NULL, NULL, 'SPRY_PRY_C-I_1', NULL, 'SPRY_PRY_C-I_1', NULL, NULL, NULL, 2),
(549, NULL, 'cd01624', NULL, NULL, 'HAD_VSP_like', NULL, 'HAD_VSP_like', NULL, NULL, NULL, 2),
(550, NULL, 'cd08178', NULL, NULL, 'AAD_C', NULL, 'AAD_C', NULL, NULL, 11113, 2),
(551, NULL, 'cd14598', NULL, NULL, 'PTPc-N21', NULL, 'PTPc-N21', NULL, NULL, NULL, 2),
(552, NULL, 'cd16428', NULL, NULL, 'TcpC_C', NULL, 'TcpC_C', NULL, NULL, 28601, 2),
(553, NULL, 'cd15415', NULL, NULL, '7tmA_OR5J-like', NULL, '7tmA_OR5J-like', NULL, NULL, NULL, 2),
(554, NULL, 'cd04269', NULL, NULL, 'ZnMc_adamalysin_II_like', NULL, 'ZnMc_adamalysin_II_like', NULL, NULL, 14620, 2),
(555, NULL, 'cd13576', NULL, NULL, 'PBP2_BugD_Asp', NULL, 'PBP2_BugD_Asp', NULL, NULL, NULL, 2),
(556, NULL, 'cd14310', NULL, NULL, 'UBA_cnDdi1_like', NULL, 'UBA_cnDdi1_like', NULL, NULL, NULL, 2),
(557, NULL, 'cd05303', NULL, NULL, 'PGDH_2', NULL, 'PGDH_2', NULL, NULL, NULL, 2),
(558, NULL, 'cd11637', NULL, NULL, 'HR1_PKN3_3', NULL, 'HR1_PKN3_3', NULL, NULL, NULL, 2),
(559, NULL, 'cd09179', NULL, NULL, 'PLDc_N_DEXD_a', NULL, 'PLDc_N_DEXD_a', NULL, NULL, NULL, 2),
(560, NULL, 'cd17159', NULL, NULL, 'DCX4_DCDC5', NULL, 'DCX4_DCDC5', NULL, NULL, NULL, 2),
(561, NULL, 'cd05910', NULL, NULL, 'FACL_like_1', NULL, 'FACL_like_1', NULL, NULL, NULL, 2),
(562, NULL, 'cd16091', NULL, NULL, 'Ig_HHLA2', NULL, 'Ig_HHLA2', NULL, NULL, NULL, 2),
(563, NULL, 'cd07956', NULL, NULL, 'Anticodon_Ia_Arg', NULL, 'Anticodon_Ia_Arg', NULL, NULL, NULL, 2),
(564, NULL, 'cd18734', NULL, NULL, 'PIN_RfVapC2-like', NULL, 'PIN_RfVapC2-like', NULL, NULL, NULL, 2),
(565, NULL, 'cd03887', NULL, NULL, 'M20_Acy1L2', NULL, 'M20_Acy1L2', NULL, NULL, NULL, 2),
(566, NULL, 'cd07470', NULL, NULL, 'CYTH-like_mRNA_RTPase', NULL, 'CYTH-like_mRNA_RTPase', NULL, NULL, 3532, 2),
(567, NULL, 'cd12774', NULL, NULL, 'RRM2_HuD', NULL, 'RRM2_HuD', NULL, NULL, NULL, 2),
(568, NULL, 'cd10979', NULL, NULL, 'CE4_PuuE_like', NULL, 'CE4_PuuE_like', NULL, NULL, NULL, 2),
(569, NULL, 'cd11258', NULL, NULL, 'Sema_4C', NULL, 'Sema_4C', NULL, NULL, NULL, 2),
(570, NULL, 'cd12190', NULL, NULL, 'Bacova_04320_like', NULL, 'Bacova_04320_like', NULL, NULL, NULL, 2),
(571, NULL, 'cd21642', NULL, NULL, 'ORF8-Ig_Bat_SARS_CoV_Rf1_type-II-like', NULL, 'ORF8-Ig_Bat_SARS_CoV_Rf1_type-II-like', NULL, NULL, 35492, 2),
(572, NULL, 'cd09486', NULL, NULL, 'LIM_Eplin_like_1', NULL, 'LIM_Eplin_like_1', NULL, NULL, 34289, 2),
(573, NULL, 'cd00618', NULL, NULL, 'PLA2_like', NULL, 'PLA2_like', NULL, NULL, NULL, 2),
(574, NULL, 'cd03392', NULL, NULL, 'PAP2_like_2', NULL, 'PAP2_like_2', NULL, NULL, NULL, 2),
(575, NULL, 'cd04480', NULL, NULL, 'RPA1_DBD_A_like', NULL, 'RPA1_DBD_A_like', NULL, NULL, NULL, 2),
(576, NULL, 'cd00779', NULL, NULL, 'ProRS_core_prok', NULL, 'ProRS_core_prok', NULL, NULL, 32647, 2),
(577, NULL, 'cd13867', NULL, NULL, 'CuRO_2_CueO_FtsP', NULL, 'CuRO_2_CueO_FtsP', NULL, NULL, NULL, 2),
(578, NULL, 'cd17183', NULL, NULL, 'FERM_F1_KIND1', NULL, 'FERM_F1_KIND1', NULL, NULL, NULL, 2),
(579, NULL, 'cd08010', NULL, NULL, 'MltG_like', NULL, 'MltG_like', NULL, NULL, 2434, 2),
(580, NULL, 'cd12734', NULL, NULL, 'RRM3_hnRNPH_hnRNPH2_hnRNPF', NULL, 'RRM3_hnRNPH_hnRNPH2_hnRNPF', NULL, NULL, NULL, 2),
(581, NULL, 'cd18610', NULL, NULL, 'GH130_BT3780-like', NULL, 'GH130_BT3780-like', NULL, NULL, NULL, 2),
(582, NULL, 'cd00517', NULL, NULL, 'ATPS', NULL, 'ATPS', NULL, NULL, 2952, 2),
(583, NULL, 'cd16553', NULL, NULL, 'RING-HC_RNF170', NULL, 'RING-HC_RNF170', NULL, NULL, NULL, 2),
(584, NULL, 'cd01307', NULL, NULL, 'Met_dep_hydrolase_B', NULL, 'Met_dep_hydrolase_B', NULL, NULL, NULL, 2),
(585, NULL, 'cd07027', NULL, NULL, 'RNAP_RPB11_like', NULL, 'RNAP_RPB11_like', NULL, NULL, NULL, 2),
(586, NULL, 'cd15537', NULL, NULL, 'PHD_BS69', NULL, 'PHD_BS69', NULL, NULL, NULL, 2);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(587, NULL, 'cd05244', NULL, NULL, 'BVR-B_like_SDR_a', NULL, 'BVR-B_like_SDR_a', NULL, NULL, NULL, 2),
(588, NULL, 'cd05087', NULL, NULL, 'PTKc_Aatyk1', NULL, 'PTKc_Aatyk1', NULL, NULL, 36599, 2),
(589, NULL, 'cd12206', NULL, NULL, 'RasGAP_IQGAP_related', NULL, 'RasGAP_IQGAP_related', NULL, NULL, NULL, 2),
(590, NULL, 'cd13300', NULL, NULL, 'PH1_TECPR1', NULL, 'PH1_TECPR1', NULL, NULL, NULL, 2),
(591, NULL, 'cd09890', NULL, NULL, 'NGN_plant', NULL, 'NGN_plant', NULL, NULL, NULL, 2),
(592, NULL, 'cd01327', NULL, NULL, 'KAZAL_PSTI', NULL, 'KAZAL_PSTI', NULL, NULL, NULL, 2),
(593, NULL, 'cd16623', NULL, NULL, 'RING-HC_RBR_TRIAD1_like', NULL, 'RING-HC_RBR_TRIAD1_like', NULL, NULL, NULL, 2),
(594, NULL, 'cd19373', NULL, NULL, 'UDG-F1_NsUNG-like', NULL, 'UDG-F1_NsUNG-like', NULL, NULL, NULL, 2),
(595, NULL, 'cd12511', NULL, NULL, 'RRM2_RBM12_like', NULL, 'RRM2_RBM12_like', NULL, NULL, NULL, 2),
(596, NULL, 'cd11763', NULL, NULL, 'SH3_SNX9_like', NULL, 'SH3_SNX9_like', NULL, NULL, NULL, 2),
(597, NULL, 'cd12317', NULL, NULL, 'RRM4_RBM19_RRM3_MRD1', NULL, 'RRM4_RBM19_RRM3_MRD1', NULL, NULL, NULL, 2),
(598, NULL, 'cd05367', NULL, NULL, 'SPR-like_SDR_c', NULL, 'SPR-like_SDR_c', NULL, NULL, NULL, 2),
(599, NULL, 'cd18691', NULL, NULL, 'PIN_VapC-like', NULL, 'PIN_VapC-like', NULL, NULL, NULL, 2),
(600, NULL, 'cd08730', NULL, NULL, 'RGS-like_3', NULL, 'RGS-like_3', NULL, NULL, NULL, 2),
(601, NULL, 'cd16192', NULL, NULL, 'EFh_PEF_CAPN9', NULL, 'EFh_PEF_CAPN9', NULL, NULL, NULL, 2),
(602, NULL, 'cd03233', NULL, NULL, 'ABCG_PDR_domain1', NULL, 'ABCG_PDR_domain1', NULL, NULL, 9631, 2),
(603, NULL, 'cd15861', NULL, NULL, 'SNARE_SNAP25N_23N_29N_SEC9N', NULL, 'SNARE_SNAP25N_23N_29N_SEC9N', NULL, NULL, 34461, 2),
(604, NULL, 'cd03011', NULL, NULL, 'TlpA_like_ScsD_MtbDsbE', NULL, 'TlpA_like_ScsD_MtbDsbE', NULL, NULL, NULL, 2),
(605, NULL, 'cd15942', NULL, NULL, '7tmA_OR10G6-like', NULL, '7tmA_OR10G6-like', NULL, NULL, NULL, 2),
(606, NULL, 'cd12528', NULL, NULL, 'RRM2_MEI2_fungi', NULL, 'RRM2_MEI2_fungi', NULL, NULL, 9431, 2),
(607, NULL, 'cd11675', NULL, NULL, 'SCAB1_middle', NULL, 'SCAB1_middle', NULL, NULL, NULL, 2),
(608, NULL, 'cd15268', NULL, NULL, '7tmB1_GLP1R', NULL, '7tmB1_GLP1R', NULL, NULL, NULL, 2),
(609, NULL, 'cd00776', NULL, NULL, 'AsxRS_core', NULL, 'AsxRS_core', NULL, NULL, NULL, 2),
(610, NULL, 'cd02434', NULL, NULL, 'Nodulin-21_like_3', NULL, 'Nodulin-21_like_3', NULL, NULL, NULL, 2),
(611, NULL, 'cd05918', NULL, NULL, 'A_NRPS_SidN3_like', NULL, 'A_NRPS_SidN3_like', NULL, NULL, NULL, 2),
(612, NULL, 'cd07640', NULL, NULL, 'BAR_ASAP3', NULL, 'BAR_ASAP3', NULL, NULL, NULL, 2),
(613, NULL, 'cd19393', NULL, NULL, 'TGF_beta_BMP3', NULL, 'TGF_beta_BMP3', NULL, NULL, NULL, 2),
(614, NULL, 'cd16738', NULL, NULL, 'RING-HC_PCGF6', NULL, 'RING-HC_PCGF6', NULL, NULL, NULL, 2),
(615, NULL, 'cd00542', NULL, NULL, 'Ntn_PVA', NULL, 'Ntn_PVA', NULL, NULL, NULL, 2),
(616, NULL, 'cd10930', NULL, NULL, 'CE4_u6', NULL, 'CE4_u6', NULL, NULL, NULL, 2),
(617, NULL, 'cd07021', NULL, NULL, 'Clp_protease_NfeD_like', NULL, 'Clp_protease_NfeD_like', NULL, NULL, NULL, 2),
(618, NULL, 'cd14278', NULL, NULL, 'UBA_NAC_like', NULL, 'UBA_NAC_like', NULL, NULL, NULL, 2),
(619, NULL, 'cd00730', NULL, NULL, 'rubredoxin', NULL, 'rubredoxin', NULL, NULL, 15274, 2),
(620, NULL, 'cd04210', NULL, NULL, 'Cupredoxin_like_1', NULL, 'Cupredoxin_like_1', NULL, NULL, 30005, 2),
(621, NULL, 'cd08538', NULL, NULL, 'SAM_PNT-ESE-2-like', NULL, 'SAM_PNT-ESE-2-like', NULL, NULL, NULL, 2),
(622, NULL, 'cd01640', NULL, NULL, 'IPPase', NULL, 'IPPase', NULL, NULL, NULL, 2),
(623, NULL, 'cd14695', NULL, NULL, 'bZIP_HLF', NULL, 'bZIP_HLF', NULL, NULL, NULL, 2),
(624, NULL, 'cd18519', NULL, NULL, 'BACK_SPOPL', NULL, 'BACK_SPOPL', NULL, NULL, NULL, 2),
(625, NULL, 'cd16932', NULL, NULL, 'HATPase_Phy-like', NULL, 'HATPase_Phy-like', NULL, NULL, 34087, 2),
(626, NULL, 'cd10322', NULL, NULL, 'SLC5sbd', NULL, 'SLC5sbd', NULL, NULL, NULL, 2),
(627, NULL, 'cd13373', NULL, NULL, 'PH_nGAP', NULL, 'PH_nGAP', NULL, NULL, NULL, 2),
(628, NULL, 'cd08747', NULL, NULL, 'RGS_GRK2_GRK3', NULL, 'RGS_GRK2_GRK3', NULL, NULL, NULL, 2);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(629, NULL, 'cd09600', NULL, NULL, 'M1_APN', NULL, 'M1_APN', NULL, NULL, NULL, 2),
(630, NULL, 'cd11715', NULL, NULL, 'THUMP_AdoMetMT', NULL, 'THUMP_AdoMetMT', NULL, NULL, NULL, 2),
(631, NULL, 'cd08198', NULL, NULL, 'DHQS-like', NULL, 'DHQS-like', NULL, NULL, NULL, 2),
(632, NULL, 'cd06416', NULL, NULL, 'GH25_Lys1-like', NULL, 'GH25_Lys1-like', NULL, NULL, NULL, 2),
(633, NULL, 'cd09627', NULL, NULL, 'DOMON_murB_like', NULL, 'DOMON_murB_like', NULL, NULL, NULL, 2),
(634, NULL, 'cd08908', NULL, NULL, 'START_STARD12-like', NULL, 'START_STARD12-like', NULL, NULL, NULL, 2),
(635, NULL, 'cd02680', NULL, NULL, 'MIT_calpain7_2', NULL, 'MIT_calpain7_2', NULL, NULL, NULL, 2),
(636, NULL, 'cd18048', NULL, NULL, 'DEADc_DDX25', NULL, 'DEADc_DDX25', NULL, NULL, NULL, 2),
(637, NULL, 'cd14120', NULL, NULL, 'STKc_ULK1_2-like', NULL, 'STKc_ULK1_2-like', NULL, NULL, NULL, 2),
(638, NULL, 'cd17202', NULL, NULL, 'FERM_F1_EPB41L2', NULL, 'FERM_F1_EPB41L2', NULL, NULL, NULL, 2),
(639, NULL, 'cd18938', NULL, NULL, 'bHLH_TS_Mesp', NULL, 'bHLH_TS_Mesp', NULL, NULL, NULL, 2),
(640, NULL, 'cd03123', NULL, NULL, 'alpha_CA_VI_IX_XII_XIV', NULL, 'alpha_CA_VI_IX_XII_XIV', NULL, NULL, NULL, 2),
(641, NULL, 'cd07832', NULL, NULL, 'STKc_CCRK', NULL, 'STKc_CCRK', NULL, NULL, NULL, 2),
(642, NULL, 'cd05746', NULL, NULL, 'Ig4_Peroxidasin', NULL, 'Ig4_Peroxidasin', NULL, NULL, NULL, 2),
(643, NULL, 'cd11327', NULL, NULL, 'AmyAc_Glg_debranch_2', NULL, 'AmyAc_Glg_debranch_2', NULL, NULL, 22311, 2),
(644, NULL, 'cd15361', NULL, NULL, '7tmA_LGR4', NULL, '7tmA_LGR4', NULL, NULL, NULL, 2),
(645, NULL, 'cd07838', NULL, NULL, 'STKc_CDK4_6_like', NULL, 'STKc_CDK4_6_like', NULL, NULL, NULL, 2),
(646, NULL, 'cd04451', NULL, NULL, 'S1_IF1', NULL, 'S1_IF1', NULL, NULL, 5451, 2),
(647, NULL, 'cd17555', NULL, NULL, 'REC_RssB-like', NULL, 'REC_RssB-like', NULL, NULL, NULL, 2),
(648, NULL, 'cd12878', NULL, NULL, 'SPRY2_RyR', NULL, 'SPRY2_RyR', NULL, NULL, 31045, 2),
(649, NULL, 'cd14783', NULL, NULL, 'FHb-globin_3', NULL, 'FHb-globin_3', NULL, NULL, NULL, 2),
(650, NULL, 'cd16815', NULL, NULL, 'RING-HC_RNF40', NULL, 'RING-HC_RNF40', NULL, NULL, NULL, 2),
(651, NULL, 'cd14156', NULL, NULL, 'PKc_LIMK_like_unk', NULL, 'PKc_LIMK_like_unk', NULL, NULL, NULL, 2),
(652, NULL, 'cd16405', NULL, NULL, 'RepB_like_N', NULL, 'RepB_like_N', NULL, NULL, 32875, 2),
(653, NULL, 'cd01660', NULL, NULL, 'ba3-like_Oxidase_I', NULL, 'ba3-like_Oxidase_I', NULL, NULL, 29252, 2),
(654, NULL, 'cd15604', NULL, NULL, 'PHD1_KDM5C_5D', NULL, 'PHD1_KDM5C_5D', NULL, NULL, NULL, 2),
(655, NULL, 'cd04254', NULL, NULL, 'AAK_UMPK-PyrH-Ec', NULL, 'AAK_UMPK-PyrH-Ec', NULL, NULL, 8973, 2),
(656, NULL, 'cd16016', NULL, NULL, 'AP-SPAP', NULL, 'AP-SPAP', NULL, NULL, 21898, 2),
(657, NULL, 'cd14766', NULL, NULL, 'CeGLB25-like', NULL, 'CeGLB25-like', NULL, NULL, NULL, 2),
(658, NULL, 'cd05482', NULL, NULL, 'HIV_retropepsin_like', NULL, 'HIV_retropepsin_like', NULL, NULL, 22581, 2),
(659, NULL, 'cd11491', NULL, NULL, 'SLC5sbd_SMIT', NULL, 'SLC5sbd_SMIT', NULL, NULL, 35469, 2),
(660, NULL, 'cd05046', NULL, NULL, 'PTK_CCK4', NULL, 'PTK_CCK4', NULL, NULL, NULL, 2),
(661, NULL, 'cd19973', NULL, NULL, 'PBP1_ABC_sugar_binding-like', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, NULL, 2),
(662, NULL, 'cd04729', NULL, NULL, 'NanE', NULL, 'NanE', NULL, NULL, 6524, 2),
(663, NULL, 'cd14744', NULL, NULL, 'PAAR_CT_2', NULL, 'PAAR_CT_2', NULL, NULL, NULL, 2),
(664, NULL, 'cd16112', NULL, NULL, 'DCX1_DCX', NULL, 'DCX1_DCX', NULL, NULL, NULL, 2),
(665, NULL, 'cd19981', NULL, NULL, 'PBP1_ABC_HAAT-like', NULL, 'PBP1_ABC_HAAT-like', NULL, NULL, NULL, 2),
(666, NULL, 'cd18722', NULL, NULL, 'PIN_NicB-like', NULL, 'PIN_NicB-like', NULL, NULL, NULL, 2),
(667, NULL, 'cd08554', NULL, NULL, 'Cyt_b561', NULL, 'Cyt_b561', NULL, NULL, NULL, 2),
(668, NULL, 'cd15195', NULL, NULL, '7tmA_GnRHR-like', NULL, '7tmA_GnRHR-like', NULL, NULL, NULL, 2),
(669, NULL, 'cd14195', NULL, NULL, 'STKc_DAPK3', NULL, 'STKc_DAPK3', NULL, NULL, NULL, 2),
(670, NULL, 'cd08452', NULL, NULL, 'PBP2_AlsR', NULL, 'PBP2_AlsR', NULL, NULL, 30713, 2);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(671, NULL, 'cd10234', NULL, NULL, 'HSPA9-Ssq1-like_NBD', NULL, 'HSPA9-Ssq1-like_NBD', NULL, NULL, NULL, 2),
(672, NULL, 'cd04394', NULL, NULL, 'RhoGAP-ARHGAP11A', NULL, 'RhoGAP-ARHGAP11A', NULL, NULL, NULL, 2),
(673, NULL, 'cd08472', NULL, NULL, 'PBP2_CrgA_like_3', NULL, 'PBP2_CrgA_like_3', NULL, NULL, NULL, 2),
(674, NULL, 'cd19817', NULL, NULL, 'Bbox1_ANCHR-like', NULL, 'Bbox1_ANCHR-like', NULL, NULL, 36322, 2),
(675, NULL, 'cd08927', NULL, NULL, 'Hb-alpha-like', NULL, 'Hb-alpha-like', NULL, NULL, 6121, 2),
(676, NULL, 'cd10408', NULL, NULL, 'SH2_Nck1', NULL, 'SH2_Nck1', NULL, NULL, 32734, 2),
(677, NULL, 'cd16354', NULL, NULL, 'BAT', NULL, 'BAT', NULL, NULL, NULL, 2),
(678, NULL, 'sd00044', NULL, NULL, 'HEAT', NULL, 'HEAT', NULL, NULL, NULL, 2),
(679, NULL, 'cd04662', NULL, NULL, 'Nudix_Hydrolase_5', NULL, 'Nudix_Hydrolase_5', NULL, NULL, NULL, 2),
(680, NULL, 'cd00354', NULL, NULL, 'FBPase', NULL, 'FBPase', NULL, NULL, 3945, 2),
(681, NULL, 'cd17221', NULL, NULL, 'RA_RASSF2', NULL, 'RA_RASSF2', NULL, NULL, NULL, 2),
(682, NULL, 'cd17365', NULL, NULL, 'MFS_PcaK_like', NULL, 'MFS_PcaK_like', NULL, NULL, NULL, 2),
(683, NULL, 'cd02685', NULL, NULL, 'MIT_C', NULL, 'MIT_C', NULL, NULL, 24097, 2),
(684, NULL, 'cd11269', NULL, NULL, 'Sema_6D', NULL, 'Sema_6D', NULL, NULL, NULL, 2),
(685, NULL, 'cd06631', NULL, NULL, 'STKc_YSK4', NULL, 'STKc_YSK4', NULL, NULL, NULL, 2),
(686, NULL, 'cd03808', NULL, NULL, 'GT4_CapM-like', NULL, 'GT4_CapM-like', NULL, NULL, NULL, 2),
(687, NULL, 'cd07632', NULL, NULL, 'BAR_APPL2', NULL, 'BAR_APPL2', NULL, NULL, NULL, 2),
(688, NULL, 'cd11635', NULL, NULL, 'HR1_PKN2_3', NULL, 'HR1_PKN2_3', NULL, NULL, NULL, 2),
(689, NULL, 'cd05162', NULL, NULL, 'PWWP', NULL, 'PWWP', NULL, NULL, NULL, 2),
(690, NULL, 'cd15572', NULL, NULL, 'PHD_BRPF', NULL, 'PHD_BRPF', NULL, NULL, NULL, 2),
(691, NULL, 'cd17395', NULL, NULL, 'MFS_MFSD4', NULL, 'MFS_MFSD4', NULL, NULL, NULL, 2),
(692, NULL, 'cd11917', NULL, NULL, 'SH3_Sorbs2_3', NULL, 'SH3_Sorbs2_3', NULL, NULL, NULL, 2),
(693, NULL, 'cd11922', NULL, NULL, 'SH3_Sorbs1_2', NULL, 'SH3_Sorbs1_2', NULL, NULL, 28089, 2),
(694, NULL, 'cd13343', NULL, NULL, 'PH-GRAM_MTMR6', NULL, 'PH-GRAM_MTMR6', NULL, NULL, 28287, 2),
(695, NULL, 'cd03028', NULL, NULL, 'GRX_PICOT_like', NULL, 'GRX_PICOT_like', NULL, NULL, 32142, 2),
(696, NULL, 'cd05678', NULL, NULL, 'M20_dipept_like', NULL, 'M20_dipept_like', NULL, NULL, NULL, 2),
(697, NULL, 'cd09934', NULL, NULL, 'SH2_Tec_family', NULL, 'SH2_Tec_family', NULL, NULL, NULL, 2),
(698, NULL, 'cd12445', NULL, NULL, 'RRM2_CPEBs', NULL, 'RRM2_CPEBs', NULL, NULL, NULL, 2),
(699, NULL, 'cd03587', NULL, NULL, 'SOCS', NULL, 'SOCS', NULL, NULL, NULL, 2),
(700, NULL, 'cd11525', NULL, NULL, 'SYLF_SH3YL1_like', NULL, 'SYLF_SH3YL1_like', NULL, NULL, 31784, 2),
(701, NULL, 'cd07198', NULL, NULL, 'Patatin', NULL, 'Patatin', NULL, NULL, NULL, 2),
(702, NULL, 'cd11638', NULL, NULL, 'HR1_ROCK2', NULL, 'HR1_ROCK2', NULL, NULL, 27882, 2),
(703, NULL, 'cd00873', NULL, NULL, 'KU80', NULL, 'KU80', NULL, NULL, 13630, 2),
(704, NULL, 'cd09762', NULL, NULL, 'HSDL2_SDR_c', NULL, 'HSDL2_SDR_c', NULL, NULL, NULL, 2),
(705, NULL, 'cd00419', NULL, NULL, 'Ferrochelatase_C', NULL, 'Ferrochelatase_C', NULL, NULL, 29204, 2),
(706, NULL, 'cd02032', NULL, NULL, 'Bchl-like', NULL, 'Bchl-like', NULL, NULL, NULL, 2),
(707, NULL, 'cd04493', NULL, NULL, 'BRCA2DBD_OB1', NULL, 'BRCA2DBD_OB1', NULL, NULL, 10757, 2),
(708, NULL, 'cd16426', NULL, NULL, 'VirB10_like', NULL, 'VirB10_like', NULL, NULL, NULL, 2),
(709, NULL, 'cd16127', NULL, NULL, 'Ubl_ATG8_GABARAP_like', NULL, 'Ubl_ATG8_GABARAP_like', NULL, NULL, NULL, 2),
(710, NULL, 'cd03819', NULL, NULL, 'GT4_WavL-like', NULL, 'GT4_WavL-like', NULL, NULL, NULL, 2),
(711, NULL, 'cd17662', NULL, NULL, 'PFA-DSP_Oca4', NULL, 'PFA-DSP_Oca4', NULL, NULL, NULL, 2),
(712, NULL, 'cd18478', NULL, NULL, 'BACK_KLHL42_KLHDC5', NULL, 'BACK_KLHL42_KLHDC5', NULL, NULL, 34840, 2),
(713, NULL, 'cd20308', NULL, NULL, 'cupin_YdaE', NULL, 'cupin_YdaE', NULL, NULL, NULL, 2),
(714, NULL, 'cd08619', NULL, NULL, 'PI-PLCXDc_plant', NULL, 'PI-PLCXDc_plant', NULL, NULL, NULL, 2);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(715, NULL, 'cd16632', NULL, NULL, 'mRING-HC-C4C4_RBR_RNF144', NULL, 'mRING-HC-C4C4_RBR_RNF144', NULL, NULL, NULL, 2),
(716, NULL, 'cd14036', NULL, NULL, 'STKc_GAK', NULL, 'STKc_GAK', NULL, NULL, NULL, 2),
(717, NULL, 'cd00034', NULL, NULL, 'CSD', NULL, 'CSD', NULL, NULL, NULL, 2),
(718, NULL, 'cd03762', NULL, NULL, 'proteasome_beta_type_6', NULL, 'proteasome_beta_type_6', NULL, NULL, NULL, 2),
(719, NULL, 'cd18701', NULL, NULL, 'PIN_VapC_like', NULL, 'PIN_VapC_like', NULL, NULL, NULL, 2),
(720, NULL, 'cd17343', NULL, NULL, 'MFS_SLC37A4', NULL, 'MFS_SLC37A4', NULL, NULL, NULL, 2),
(721, NULL, 'cd17498', NULL, NULL, 'RMtype1_S_Aco12261I-TRD1-CR1_like', NULL, 'RMtype1_S_Aco12261I-TRD1-CR1_like', NULL, NULL, NULL, 2),
(722, NULL, 'cd10424', NULL, NULL, 'GST_C_9', NULL, 'GST_C_9', NULL, NULL, NULL, 2),
(723, NULL, 'cd01335', NULL, NULL, 'Radical_SAM', NULL, 'Radical_SAM', NULL, NULL, NULL, 2),
(724, NULL, 'cd01912', NULL, NULL, 'proteasome_beta', NULL, 'proteasome_beta', NULL, NULL, NULL, 2),
(725, NULL, 'cd11887', NULL, NULL, 'SH3_Bbc1', NULL, 'SH3_Bbc1', NULL, NULL, 30117, 2),
(726, NULL, 'cd00213', NULL, NULL, 'S-100', NULL, 'S-100', NULL, NULL, 381, 2),
(727, NULL, 'cd00825', NULL, NULL, 'decarbox_cond_enzymes', NULL, 'decarbox_cond_enzymes', NULL, NULL, NULL, 2),
(728, NULL, 'cd03380', NULL, NULL, 'PAP2_like_1', NULL, 'PAP2_like_1', NULL, NULL, NULL, 2),
(729, NULL, 'cd13416', NULL, NULL, 'TNFRSF16', NULL, 'TNFRSF16', NULL, NULL, 32678, 2),
(730, NULL, 'cd14067', NULL, NULL, 'STKc_LRRK1', NULL, 'STKc_LRRK1', NULL, NULL, NULL, 2),
(731, NULL, 'cd00925', NULL, NULL, 'Cyt_c_Oxidase_VIa', NULL, 'Cyt_c_Oxidase_VIa', NULL, NULL, 2116, 2),
(732, NULL, 'cd01038', NULL, NULL, 'Endonuclease_DUF559', NULL, 'Endonuclease_DUF559', NULL, NULL, NULL, 2),
(733, NULL, 'cd06227', NULL, NULL, 'M14-CPA-like', NULL, 'M14-CPA-like', NULL, NULL, 14020, 2),
(734, NULL, 'cd17279', NULL, NULL, 'RMtype1_S_BmuCF2ORF3362P_TRD1-CR1_like', NULL, 'RMtype1_S_BmuCF2ORF3362P_TRD1-CR1_like', NULL, NULL, NULL, 2),
(735, NULL, 'cd11291', NULL, NULL, 'gelsolin_S6_like', NULL, 'gelsolin_S6_like', NULL, NULL, NULL, 2),
(736, NULL, 'cd00084', NULL, NULL, 'HMG-box', NULL, 'HMG-box', NULL, NULL, NULL, 2),
(737, NULL, 'cd14132', NULL, NULL, 'STKc_CK2_alpha', NULL, 'STKc_CK2_alpha', NULL, NULL, 36206, 2),
(738, NULL, 'cd14198', NULL, NULL, 'STKc_DRAK2', NULL, 'STKc_DRAK2', NULL, NULL, 35280, 2),
(739, NULL, 'cd17988', NULL, NULL, 'DEXHc_TDRD9', NULL, 'DEXHc_TDRD9', NULL, NULL, NULL, 2),
(740, NULL, 'cd08545', NULL, NULL, 'YcnI_like', NULL, 'YcnI_like', NULL, NULL, 12861, 2),
(741, NULL, 'cd07120', NULL, NULL, 'ALDH_PsfA-ACA09737', NULL, 'ALDH_PsfA-ACA09737', NULL, NULL, NULL, 2),
(742, NULL, 'cd05506', NULL, NULL, 'Bromo_plant1', NULL, 'Bromo_plant1', NULL, NULL, 27853, 2),
(743, NULL, 'cd11009', NULL, NULL, 'Zn_dep_PLPC', NULL, 'Zn_dep_PLPC', NULL, NULL, 3136, 2),
(744, NULL, 'cd07168', NULL, NULL, 'NR_DBD_DHR4_like', NULL, 'NR_DBD_DHR4_like', NULL, NULL, NULL, 2),
(745, NULL, 'cd08682', NULL, NULL, 'C2_Rab11-FIP_classI', NULL, 'C2_Rab11-FIP_classI', NULL, NULL, NULL, 2),
(746, NULL, 'cd17259', NULL, NULL, 'RMtype1_S_StySKI-TRD2-CR2_like', NULL, 'RMtype1_S_StySKI-TRD2-CR2_like', NULL, NULL, NULL, 2),
(747, NULL, 'cd07015', NULL, NULL, 'Clp_protease_NfeD', NULL, 'Clp_protease_NfeD', NULL, NULL, 30829, 2),
(748, NULL, 'cd10031', NULL, NULL, 'UDG-F5_TTUDGB_like', NULL, 'UDG-F5_TTUDGB_like', NULL, NULL, 37198, 2),
(749, NULL, 'cd09508', NULL, NULL, 'SAM_HD', NULL, 'SAM_HD', NULL, NULL, NULL, 2),
(750, NULL, 'cd16263', NULL, NULL, 'BipA_III', NULL, 'BipA_III', NULL, NULL, NULL, 2),
(751, NULL, 'cd15117', NULL, NULL, '7tmA_FPR-like', NULL, '7tmA_FPR-like', NULL, NULL, NULL, 2),
(752, NULL, 'cd19002', NULL, NULL, 'LGIC_ECD_GABAAR_E', NULL, 'LGIC_ECD_GABAAR_E', NULL, NULL, NULL, 2),
(753, NULL, 'cd04106', NULL, NULL, 'Rab23_like', NULL, 'Rab23_like', NULL, NULL, 21213, 2),
(754, NULL, 'cd11447', NULL, NULL, 'bHLH-O_HEYL', NULL, 'bHLH-O_HEYL', NULL, NULL, NULL, 2),
(755, NULL, 'cd03300', NULL, NULL, 'ABC_PotA_N', NULL, 'ABC_PotA_N', NULL, NULL, 12875, 2);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(756, NULL, 'cd18294', NULL, NULL, 'BTB_POZ_BTBD19', NULL, 'BTB_POZ_BTBD19', NULL, NULL, NULL, 2),
(757, NULL, 'cd09267', NULL, NULL, 'FCHo2_MHD', NULL, 'FCHo2_MHD', NULL, NULL, NULL, 2),
(758, NULL, 'cd13984', NULL, NULL, 'PK_NRBP1_like', NULL, 'PK_NRBP1_like', NULL, NULL, NULL, 2),
(759, NULL, 'cd19890', NULL, NULL, 'DSRM_TARBP2_rpt1', NULL, 'DSRM_TARBP2_rpt1', NULL, NULL, 34282, 2),
(760, NULL, 'cd01792', NULL, NULL, 'Ubl1_ISG15', NULL, 'Ubl1_ISG15', NULL, NULL, NULL, 2),
(761, NULL, 'cd16218', NULL, NULL, 'EFh_PI-PLCdelta3', NULL, 'EFh_PI-PLCdelta3', NULL, NULL, 31278, 2),
(762, NULL, 'cd12489', NULL, NULL, 'RRM2_hnRNPQ', NULL, 'RRM2_hnRNPQ', NULL, NULL, 3454, 2),
(763, NULL, 'cd12515', NULL, NULL, 'RRM5_RBM12_like', NULL, 'RRM5_RBM12_like', NULL, NULL, NULL, 2),
(764, NULL, 'cd16980', NULL, NULL, 'VHS_Lsb5', NULL, 'VHS_Lsb5', NULL, NULL, NULL, 2),
(765, NULL, 'cd00353', NULL, NULL, 'Ribosomal_S15p_S13e', NULL, 'Ribosomal_S15p_S13e', NULL, NULL, 5694, 2),
(766, NULL, 'cd15793', NULL, NULL, 'PH1_FGD6', NULL, 'PH1_FGD6', NULL, NULL, 28078, 2),
(767, NULL, 'cd11608', NULL, NULL, 'eIF2D_C', NULL, 'eIF2D_C', NULL, NULL, 27224, 2),
(768, NULL, 'cd12742', NULL, NULL, 'RRM3_ESRP1_ESRP2', NULL, 'RRM3_ESRP1_ESRP2', NULL, NULL, NULL, 2),
(769, NULL, 'cd18381', NULL, NULL, 'BTB_POZ_Kv5_KCNF1', NULL, 'BTB_POZ_Kv5_KCNF1', NULL, NULL, NULL, 2),
(770, NULL, 'cd05564', NULL, NULL, 'PTS_IIB_chitobiose_lichenan', NULL, 'PTS_IIB_chitobiose_lichenan', NULL, NULL, NULL, 2),
(771, NULL, 'cd17238', NULL, NULL, 'FERM_F1_Radixin', NULL, 'FERM_F1_Radixin', NULL, NULL, NULL, 2),
(772, NULL, 'cd19138', NULL, NULL, 'AKR_YeaE', NULL, 'AKR_YeaE', NULL, NULL, NULL, 2),
(773, NULL, 'cd18227', NULL, NULL, 'BTB_POZ_ZBTB43', NULL, 'BTB_POZ_ZBTB43', NULL, NULL, NULL, 2),
(774, NULL, 'cd03164', NULL, NULL, 'CD53_like_LEL', NULL, 'CD53_like_LEL', NULL, NULL, NULL, 2),
(775, NULL, 'cd06536', NULL, NULL, 'CIDE_N_ICAD', NULL, 'CIDE_N_ICAD', NULL, NULL, NULL, 2),
(776, NULL, 'cd18831', NULL, NULL, 'GH43_AnAbnA-like', NULL, 'GH43_AnAbnA-like', NULL, NULL, NULL, 2),
(777, NULL, 'cd08716', NULL, NULL, 'RGS_RGS13', NULL, 'RGS_RGS13', NULL, NULL, NULL, 2),
(778, NULL, 'cd03893', NULL, NULL, 'M20_Dipept_like', NULL, 'M20_Dipept_like', NULL, NULL, NULL, 2),
(779, NULL, 'cd19857', NULL, NULL, 'DSRM_STAU_rpt1', NULL, 'DSRM_STAU_rpt1', NULL, NULL, NULL, 2),
(780, NULL, 'cd16156', NULL, NULL, 'sulfatase_like', NULL, 'sulfatase_like', NULL, NULL, NULL, 2),
(781, NULL, 'cd19458', NULL, NULL, 'lipocalin_12', NULL, 'lipocalin_12', NULL, NULL, NULL, 2),
(782, NULL, 'cd12260', NULL, NULL, 'RRM2_SREK1', NULL, 'RRM2_SREK1', NULL, NULL, 6745, 2),
(783, NULL, 'cd17711', NULL, NULL, 'BRCT_PAXIP1_rpt3', NULL, 'BRCT_PAXIP1_rpt3', NULL, NULL, NULL, 2),
(784, NULL, 'cd16103', NULL, NULL, 'Ubl2_OASL', NULL, 'Ubl2_OASL', NULL, NULL, NULL, 2),
(785, NULL, 'cd17251', NULL, NULL, 'RMtype1_S_HinAWORF1578P-TRD2-CR2_like', NULL, 'RMtype1_S_HinAWORF1578P-TRD2-CR2_like', NULL, NULL, NULL, 2),
(786, NULL, 'cd19336', NULL, NULL, 'Wnt_Wnt4', NULL, 'Wnt_Wnt4', NULL, NULL, NULL, 2),
(787, NULL, 'cd14686', NULL, NULL, 'bZIP', NULL, 'bZIP', NULL, NULL, NULL, 2),
(788, NULL, 'cd16212', NULL, NULL, 'EFh_NorpA_like', NULL, 'EFh_NorpA_like', NULL, NULL, NULL, 2),
(789, NULL, 'cd10488', NULL, NULL, 'MH1_R-SMAD', NULL, 'MH1_R-SMAD', NULL, NULL, NULL, 2),
(790, NULL, 'cd04613', NULL, NULL, 'CBS_pair_voltage-gated_CLC_bac', NULL, 'CBS_pair_voltage-gated_CLC_bac', NULL, NULL, NULL, 2),
(791, NULL, 'cd06929', NULL, NULL, 'NR_LBD_F1', NULL, 'NR_LBD_F1', NULL, NULL, NULL, 2),
(792, NULL, 'cd11552', NULL, NULL, 'Serine_rich_BCAR1', NULL, 'Serine_rich_BCAR1', NULL, NULL, NULL, 2),
(793, NULL, 'cd18929', NULL, NULL, 'bHLHzip_Mad4', NULL, 'bHLHzip_Mad4', NULL, NULL, NULL, 2),
(794, NULL, 'cd16286', NULL, NULL, 'SPM-1-like_MBL-B1-B2-like', NULL, 'SPM-1-like_MBL-B1-B2-like', NULL, NULL, NULL, 2),
(795, NULL, 'cd19868', NULL, NULL, 'DSRM_DGCR8_rpt2', NULL, 'DSRM_DGCR8_rpt2', NULL, NULL, NULL, 2),
(796, NULL, 'cd13700', NULL, NULL, 'PBP2_Arg_STM4351', NULL, 'PBP2_Arg_STM4351', NULL, NULL, NULL, 2);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(797, NULL, 'cd04470', NULL, NULL, 'S1_EF-P_repeat_1', NULL, 'S1_EF-P_repeat_1', NULL, NULL, 2162, 2),
(798, NULL, 'cd17779', NULL, NULL, 'CBS_archAMPK_gamma-repeat1', NULL, 'CBS_archAMPK_gamma-repeat1', NULL, NULL, NULL, 2),
(799, NULL, 'cd05351', NULL, NULL, 'XR_like_SDR_c', NULL, 'XR_like_SDR_c', NULL, NULL, NULL, 2),
(800, NULL, 'cd16322', NULL, NULL, 'TTHA1623-like_MBL-fold', NULL, 'TTHA1623-like_MBL-fold', NULL, NULL, NULL, 2),
(801, NULL, 'cd09710', NULL, NULL, 'Cas3_I-D', NULL, 'Cas3_I-D', NULL, NULL, NULL, 2),
(802, NULL, 'cd06596', NULL, NULL, 'GH31_CPE1046', NULL, 'GH31_CPE1046', NULL, NULL, NULL, 2),
(803, NULL, 'cd06148', NULL, NULL, 'Egl_like_exo', NULL, 'Egl_like_exo', NULL, NULL, NULL, 2),
(804, NULL, 'cd11358', NULL, NULL, 'RNase_PH', NULL, 'RNase_PH', NULL, NULL, NULL, 2),
(805, NULL, 'cd19124', NULL, NULL, 'AKR_AKR4A_4B', NULL, 'AKR_AKR4A_4B', NULL, NULL, 34641, 2),
(806, NULL, 'cd14597', NULL, NULL, 'PTPc-N13', NULL, 'PTPc-N13', NULL, NULL, NULL, 2),
(807, NULL, 'cd15446', NULL, NULL, '7tmB1_CRF-R2', NULL, '7tmB1_CRF-R2', NULL, NULL, NULL, 2),
(808, NULL, 'cd01364', NULL, NULL, 'KISc_BimC_Eg5', NULL, 'KISc_BimC_Eg5', NULL, NULL, NULL, 2),
(809, NULL, 'cd04857', NULL, NULL, 'Peptidases_S8_Tripeptidyl_Aminopeptidase_II', NULL, 'Peptidases_S8_Tripeptidyl_Aminopeptidase_II', NULL, NULL, 23477, 2),
(810, NULL, 'cd14062', NULL, NULL, 'STKc_Raf', NULL, 'STKc_Raf', NULL, NULL, NULL, 2),
(811, NULL, 'cd16304', NULL, NULL, 'BcII-like_MBL-B1', NULL, 'BcII-like_MBL-B1', NULL, NULL, NULL, 2),
(812, NULL, 'cd19201', NULL, NULL, 'PR-SET_ZFPM', NULL, 'PR-SET_ZFPM', NULL, NULL, NULL, 2),
(813, NULL, 'cd15039', NULL, NULL, '7tmB3_Methuselah-like', NULL, '7tmB3_Methuselah-like', NULL, NULL, NULL, 2),
(814, NULL, 'cd00806', NULL, NULL, 'TrpRS_core', NULL, 'TrpRS_core', NULL, NULL, 5928, 2),
(815, NULL, 'cd08415', NULL, NULL, 'PBP2_LysR_opines_like', NULL, 'PBP2_LysR_opines_like', NULL, NULL, 29741, 2),
(816, NULL, 'cd11990', NULL, NULL, 'SH3_Intersectin2_2', NULL, 'SH3_Intersectin2_2', NULL, NULL, 28086, 2),
(817, NULL, 'cd15292', NULL, NULL, '7tmC_GPR156', NULL, '7tmC_GPR156', NULL, NULL, 30579, 2),
(818, NULL, 'cd06887', NULL, NULL, 'PX_p47phox', NULL, 'PX_p47phox', NULL, NULL, 19116, 2),
(819, NULL, 'cd15249', NULL, NULL, '7tmF_FZD5', NULL, '7tmF_FZD5', NULL, NULL, NULL, 2),
(820, NULL, 'cd13978', NULL, NULL, 'STKc_RIP', NULL, 'STKc_RIP', NULL, NULL, NULL, 2),
(821, NULL, 'cd19178', NULL, NULL, 'SET_SETD6', NULL, 'SET_SETD6', NULL, NULL, 35349, 2),
(822, NULL, 'cd07356', NULL, NULL, 'HN_L-whirlin_R1_like', NULL, 'HN_L-whirlin_R1_like', NULL, NULL, NULL, 2),
(823, NULL, 'cd06086', NULL, NULL, 'KOW_Spt5_6', NULL, 'KOW_Spt5_6', NULL, NULL, 30038, 2),
(824, NULL, 'cd12548', NULL, NULL, 'RRM_Set1A', NULL, 'RRM_Set1A', NULL, NULL, 11599, 2),
(825, NULL, 'cd02587', NULL, NULL, 'HAD_5-3dNT', NULL, 'HAD_5-3dNT', NULL, NULL, NULL, 2),
(826, NULL, 'cd14700', NULL, NULL, 'bZIP_ATF6', NULL, 'bZIP_ATF6', NULL, NULL, NULL, 2),
(827, NULL, 'cd08709', NULL, NULL, 'RGS_RGS2', NULL, 'RGS_RGS2', NULL, NULL, NULL, 2),
(828, NULL, 'cd13962', NULL, NULL, 'PT_UbiA_UBIAD1', NULL, 'PT_UbiA_UBIAD1', NULL, NULL, 21752, 2),
(829, NULL, 'cd06555', NULL, NULL, 'ASCH_PF0470_like', NULL, 'ASCH_PF0470_like', NULL, NULL, NULL, 2),
(830, NULL, 'cd11906', NULL, NULL, 'SH3_BTK', NULL, 'SH3_BTK', NULL, NULL, 29092, 2),
(831, NULL, 'cd00137', NULL, NULL, 'PI-PLCc', NULL, 'PI-PLCc', NULL, NULL, NULL, 2),
(832, NULL, 'cd05485', NULL, NULL, 'Cathepsin_D_like', NULL, 'Cathepsin_D_like', NULL, NULL, 22843, 2),
(833, NULL, 'cd14655', NULL, NULL, 'ZIP_Hap1', NULL, 'ZIP_Hap1', NULL, NULL, NULL, 2),
(834, NULL, 'cd03691', NULL, NULL, 'BipA_TypA_II', NULL, 'BipA_TypA_II', NULL, NULL, NULL, 2),
(835, NULL, 'cd10426', NULL, NULL, 'Ephrin-B_Ectodomain', NULL, 'Ephrin-B_Ectodomain', NULL, NULL, 31897, 2),
(836, NULL, 'cd14351', NULL, NULL, 'UBA_Ubx1_like', NULL, 'UBA_Ubx1_like', NULL, NULL, NULL, 2),
(837, NULL, 'cd17006', NULL, NULL, 'ANTH_N_HIP1_like', NULL, 'ANTH_N_HIP1_like', NULL, NULL, NULL, 2),
(838, NULL, 'cd18813', NULL, NULL, 'CAP_CRISPLD1', NULL, 'CAP_CRISPLD1', NULL, NULL, NULL, 2);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(839, NULL, 'cd09155', NULL, NULL, 'PLDc_PaCLS_like_1', NULL, 'PLDc_PaCLS_like_1', NULL, NULL, NULL, 2),
(840, NULL, 'cd07673', NULL, NULL, 'F-BAR_FCHO2', NULL, 'F-BAR_FCHO2', NULL, NULL, NULL, 2),
(841, NULL, 'cd18491', NULL, NULL, 'BACK_ABTB2_like', NULL, 'BACK_ABTB2_like', NULL, NULL, NULL, 2),
(842, NULL, 'cd07187', NULL, NULL, 'YvcK_like', NULL, 'YvcK_like', NULL, NULL, NULL, 2),
(843, NULL, 'cd07805', NULL, NULL, 'FGGY_XK_like_2', NULL, 'FGGY_XK_like_2', NULL, NULL, NULL, 2),
(844, NULL, 'cd13854', NULL, NULL, 'CuRO_1_MaLCC_like', NULL, 'CuRO_1_MaLCC_like', NULL, NULL, NULL, 2),
(845, NULL, 'cd07708', NULL, NULL, 'MBL-B3-like', NULL, 'MBL-B3-like', NULL, NULL, NULL, 2),
(846, NULL, 'cd17538', NULL, NULL, 'REC_D1_PleD-like', NULL, 'REC_D1_PleD-like', NULL, NULL, NULL, 2),
(847, NULL, 'cd19047', NULL, NULL, 'LGIC_ECD_GABAAR_rho2', NULL, 'LGIC_ECD_GABAAR_rho2', NULL, NULL, NULL, 2),
(848, NULL, 'cd17460', NULL, NULL, 'MFS_SLCO2B_OATP2B', NULL, 'MFS_SLCO2B_OATP2B', NULL, NULL, NULL, 2),
(849, NULL, 'cd14809', NULL, NULL, 'bZIP_AUREO-like', NULL, 'bZIP_AUREO-like', NULL, NULL, NULL, 2),
(850, NULL, 'cd01016', NULL, NULL, 'TroA', NULL, 'TroA', NULL, NULL, NULL, 2),
(851, NULL, 'cd01092', NULL, NULL, 'APP-like', NULL, 'APP-like', NULL, NULL, NULL, 2),
(852, NULL, 'cd14091', NULL, NULL, 'STKc_RSK_C', NULL, 'STKc_RSK_C', NULL, NULL, NULL, 2),
(853, NULL, 'cd09450', NULL, NULL, 'LIM_ALP', NULL, 'LIM_ALP', NULL, NULL, NULL, 2),
(854, NULL, 'cd17513', NULL, NULL, 'RMtype1_S_AveSPN6ORF1907P_TRD2-CR2_like', NULL, 'RMtype1_S_AveSPN6ORF1907P_TRD2-CR2_like', NULL, NULL, NULL, 2),
(855, NULL, 'cd16424', NULL, NULL, 'VirB8', NULL, 'VirB8', NULL, NULL, NULL, 2),
(856, NULL, 'cd17645', NULL, NULL, 'A_NRPS_LgrA-like', NULL, 'A_NRPS_LgrA-like', NULL, NULL, NULL, 2),
(857, NULL, 'cd11714', NULL, NULL, 'GINS_A_archaea', NULL, 'GINS_A_archaea', NULL, NULL, NULL, 2),
(858, NULL, 'cd16248', NULL, NULL, 'EFh_DRP-2', NULL, 'EFh_DRP-2', NULL, NULL, NULL, 2),
(859, NULL, 'cd04256', NULL, NULL, 'AAK_P5CS_ProBA', NULL, 'AAK_P5CS_ProBA', NULL, NULL, 30010, 2),
(860, NULL, 'cd09104', NULL, NULL, 'PLDc_vPLD1_2_like_1', NULL, 'PLDc_vPLD1_2_like_1', NULL, NULL, NULL, 2),
(861, NULL, 'cd04129', NULL, NULL, 'Rho2', NULL, 'Rho2', NULL, NULL, NULL, 2),
(862, NULL, 'cd09542', NULL, NULL, 'SAM_EPH-A1', NULL, 'SAM_EPH-A1', NULL, NULL, NULL, 2),
(863, NULL, 'cd10963', NULL, NULL, 'CE4_RC0012_like', NULL, 'CE4_RC0012_like', NULL, NULL, NULL, 2),
(864, NULL, 'cd01815', NULL, NULL, 'Ubl_UBL7', NULL, 'Ubl_UBL7', NULL, NULL, NULL, 2),
(865, NULL, 'cd14915', NULL, NULL, 'MYSc_Myh4', NULL, 'MYSc_Myh4', NULL, NULL, NULL, 2),
(866, NULL, 'cd13358', NULL, NULL, 'PH-GRAM_MTMR1', NULL, 'PH-GRAM_MTMR1', NULL, NULL, 28132, 2),
(867, NULL, 'cd16201', NULL, NULL, 'EFh_PI-PLCgamma', NULL, 'EFh_PI-PLCgamma', NULL, NULL, NULL, 2),
(868, NULL, 'cd12661', NULL, NULL, 'RRM3_hnRNPM', NULL, 'RRM3_hnRNPM', NULL, NULL, 18508, 2),
(869, NULL, 'cd00352', NULL, NULL, 'Gn_AT_II', NULL, 'Gn_AT_II', NULL, NULL, NULL, 2),
(870, NULL, 'cd00445', NULL, NULL, 'Uricase', NULL, 'Uricase', NULL, NULL, NULL, 2),
(871, NULL, 'cd13163', NULL, NULL, 'PTB_ICAP1', NULL, 'PTB_ICAP1', NULL, NULL, NULL, 2),
(872, NULL, 'cd08867', NULL, NULL, 'START_STARD4_5_6-like', NULL, 'START_STARD4_5_6-like', NULL, NULL, NULL, 2),
(873, NULL, 'cd16903', NULL, NULL, 'pesticin_lyz-like', NULL, 'pesticin_lyz-like', NULL, NULL, NULL, 2),
(874, NULL, 'cd07465', NULL, NULL, 'CRD_FZ1', NULL, 'CRD_FZ1', NULL, NULL, NULL, 2),
(875, NULL, 'cd16944', NULL, NULL, 'HATPase_NtrY-like', NULL, 'HATPase_NtrY-like', NULL, NULL, NULL, 2),
(876, NULL, 'cd00577', NULL, NULL, 'PCNA', NULL, 'PCNA', NULL, NULL, NULL, 2),
(877, NULL, 'cd07960', NULL, NULL, 'Anticodon_Ia_Ile_BEm', NULL, 'Anticodon_Ia_Ile_BEm', NULL, NULL, 28190, 2),
(878, NULL, 'cd04276', NULL, NULL, 'ZnMc_MMP_like_2', NULL, 'ZnMc_MMP_like_2', NULL, NULL, 13289, 2),
(879, NULL, 'cd05818', NULL, NULL, 'CBM20_water_dikinase', NULL, 'CBM20_water_dikinase', NULL, NULL, 32407, 2),
(880, NULL, 'cd05080', NULL, NULL, 'PTKc_Tyk2_rpt2', NULL, 'PTKc_Tyk2_rpt2', NULL, NULL, NULL, 2);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(881, NULL, 'cd03411', NULL, NULL, 'Ferrochelatase_N', NULL, 'Ferrochelatase_N', NULL, NULL, 31541, 2),
(882, NULL, 'cd09098', NULL, NULL, 'INPP5c_Synj1', NULL, 'INPP5c_Synj1', NULL, NULL, NULL, 2),
(883, NULL, 'cd18720', NULL, NULL, 'PIN_YqxD-like', NULL, 'PIN_YqxD-like', NULL, NULL, NULL, 2),
(884, NULL, 'cd05728', NULL, NULL, 'Ig4_Contactin-2-like', NULL, 'Ig4_Contactin-2-like', NULL, NULL, NULL, 2),
(885, NULL, 'cd18736', NULL, NULL, 'PIN_CcVapC1-like', NULL, 'PIN_CcVapC1-like', NULL, NULL, NULL, 2),
(886, NULL, 'cd07637', NULL, NULL, 'BAR_ACAP3', NULL, 'BAR_ACAP3', NULL, NULL, 36172, 2),
(887, NULL, 'cd01673', NULL, NULL, 'dNK', NULL, 'dNK', NULL, NULL, 24020, 2),
(888, NULL, 'cd03522', NULL, NULL, 'MoeA_like', NULL, 'MoeA_like', NULL, NULL, NULL, 2),
(889, NULL, 'cd13680', NULL, NULL, 'PBP2_TRAP_SBP_like_4', NULL, 'PBP2_TRAP_SBP_like_4', NULL, NULL, NULL, 2),
(890, NULL, 'cd03390', NULL, NULL, 'PAP2_containing_1_like', NULL, 'PAP2_containing_1_like', NULL, NULL, NULL, 2),
(891, NULL, 'cd06638', NULL, NULL, 'STKc_myosinIIIA_N', NULL, 'STKc_myosinIIIA_N', NULL, NULL, NULL, 2),
(892, NULL, 'cd18924', NULL, NULL, 'bHLHzip_USF1', NULL, 'bHLHzip_USF1', NULL, NULL, NULL, 2),
(893, NULL, 'cd12560', NULL, NULL, 'RRM_SRSF12', NULL, 'RRM_SRSF12', NULL, NULL, NULL, 2),
(894, NULL, 'cd09273', NULL, NULL, 'RNase_HI_RT_Bel', NULL, 'RNase_HI_RT_Bel', NULL, NULL, NULL, 2),
(895, NULL, 'cd10556', NULL, NULL, 'SER_beta', NULL, 'SER_beta', NULL, NULL, NULL, 2),
(896, NULL, 'cd01457', NULL, NULL, 'vWA_ORF176_type', NULL, 'vWA_ORF176_type', NULL, NULL, NULL, 2),
(897, NULL, 'cd18343', NULL, NULL, 'BTB_POZ_SPOPL', NULL, 'BTB_POZ_SPOPL', NULL, NULL, NULL, 2),
(898, NULL, 'cd17043', NULL, NULL, 'RA', NULL, 'RA', NULL, NULL, NULL, 2),
(899, NULL, 'cd03178', NULL, NULL, 'GST_C_Ure2p_like', NULL, 'GST_C_Ure2p_like', NULL, NULL, NULL, 2),
(900, NULL, 'cd01079', NULL, NULL, 'NAD_bind_m-THF_DH', NULL, 'NAD_bind_m-THF_DH', NULL, NULL, 29970, 2),
(901, NULL, 'cd04709', NULL, NULL, 'BAH_MTA', NULL, 'BAH_MTA', NULL, NULL, NULL, 2),
(902, NULL, 'cd06324', NULL, NULL, 'PBP1_ABC_sugar_binding-like', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, NULL, 2),
(903, NULL, 'cd01814', NULL, NULL, 'Ubl_MUBs_plant', NULL, 'Ubl_MUBs_plant', NULL, NULL, NULL, 2),
(904, NULL, 'cd09827', NULL, NULL, 'PET_Prickle', NULL, 'PET_Prickle', NULL, NULL, 30434, 2),
(905, NULL, 'cd00713', NULL, NULL, 'GltS', NULL, 'GltS', NULL, NULL, NULL, 2),
(906, NULL, 'cd17937', NULL, NULL, 'DEXXYc_viral_SF1-N', NULL, 'DEXXYc_viral_SF1-N', NULL, NULL, NULL, 2),
(907, NULL, 'cd09431', NULL, NULL, 'LIM3_Fhl2', NULL, 'LIM3_Fhl2', NULL, NULL, NULL, 2),
(908, NULL, 'cd13551', NULL, NULL, 'PBP2_Fbp_like_5', NULL, 'PBP2_Fbp_like_5', NULL, NULL, NULL, 2),
(909, NULL, 'cd04866', NULL, NULL, 'LigD_Pol_like_3', NULL, 'LigD_Pol_like_3', NULL, NULL, 30223, 2),
(910, NULL, 'cd01175', NULL, NULL, 'IPT_COE', NULL, 'IPT_COE', NULL, NULL, 27784, 2),
(911, NULL, 'cd05540', NULL, NULL, 'UreG', NULL, 'UreG', NULL, NULL, NULL, 2),
(912, NULL, 'cd07365', NULL, NULL, 'MhpB_like', NULL, 'MhpB_like', NULL, NULL, 16623, 2),
(913, NULL, 'cd04933', NULL, NULL, 'ACT_AK1-AT_1', NULL, 'ACT_AK1-AT_1', NULL, NULL, NULL, 2),
(914, NULL, 'cd01804', NULL, NULL, 'Ubl_midnolin', NULL, 'Ubl_midnolin', NULL, NULL, NULL, 2),
(915, NULL, 'cd07331', NULL, NULL, 'M48C_Oma1_like', NULL, 'M48C_Oma1_like', NULL, NULL, NULL, 2),
(916, NULL, 'cd06424', NULL, NULL, 'UGGPase', NULL, 'UGGPase', NULL, NULL, NULL, 2),
(917, NULL, 'cd10973', NULL, NULL, 'CE4_DAC_u4_5s', NULL, 'CE4_DAC_u4_5s', NULL, NULL, NULL, 2),
(918, NULL, 'cd15926', NULL, NULL, '7tmA_RNL3R1', NULL, '7tmA_RNL3R1', NULL, NULL, NULL, 2),
(919, NULL, 'cd07812', NULL, NULL, 'SRPBCC', NULL, 'SRPBCC', NULL, NULL, NULL, 2),
(920, NULL, 'cd20334', NULL, NULL, 'Cas13b', NULL, 'Cas13b', NULL, NULL, NULL, 2),
(921, NULL, 'cd16333', NULL, NULL, 'RELM', NULL, 'RELM', NULL, NULL, 12402, 2),
(922, NULL, 'cd14631', NULL, NULL, 'R-PTPc-K-1', NULL, 'R-PTPc-K-1', NULL, NULL, NULL, 2),
(923, NULL, 'cd19376', NULL, NULL, 'TGF_beta_GDF15', NULL, 'TGF_beta_GDF15', NULL, NULL, NULL, 2);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(924, NULL, 'cd04784', NULL, NULL, 'HTH_CadR-PbrR', NULL, 'HTH_CadR-PbrR', NULL, NULL, 13141, 2),
(925, NULL, 'cd10312', NULL, NULL, 'Deadenylase_CCR4b', NULL, 'Deadenylase_CCR4b', NULL, NULL, 31373, 2),
(926, NULL, 'cd19554', NULL, NULL, 'serpinA6_CBG', NULL, 'serpinA6_CBG', NULL, NULL, NULL, 2),
(927, NULL, 'cd12150', NULL, NULL, 'talin-RS', NULL, 'talin-RS', NULL, NULL, 32652, 2),
(928, NULL, 'cd01255', NULL, NULL, 'PH2_Tiam1_2', NULL, 'PH2_Tiam1_2', NULL, NULL, NULL, 2),
(929, NULL, 'cd11648', NULL, NULL, 'RsmI', NULL, 'RsmI', NULL, NULL, 7184, 2),
(930, NULL, 'cd18636', NULL, NULL, 'CD_Chp1_like', NULL, 'CD_Chp1_like', NULL, NULL, NULL, 2),
(931, NULL, 'cd15539', NULL, NULL, 'PHD1_AIRE', NULL, 'PHD1_AIRE', NULL, NULL, NULL, 2),
(932, NULL, 'cd00226', NULL, NULL, 'PRCH', NULL, 'PRCH', NULL, NULL, 2586, 2),
(933, NULL, 'cd06373', NULL, NULL, 'PBP1_NPR-like', NULL, 'PBP1_NPR-like', NULL, NULL, NULL, 2),
(934, NULL, 'cd10231', NULL, NULL, 'YegD_like', NULL, 'YegD_like', NULL, NULL, 30292, 2),
(935, NULL, 'cd13578', NULL, NULL, 'PBP2_Bug27', NULL, 'PBP2_Bug27', NULL, NULL, NULL, 2),
(936, NULL, 'cd18344', NULL, NULL, 'BTB_POZ_TDPOZ', NULL, 'BTB_POZ_TDPOZ', NULL, NULL, NULL, 2),
(937, NULL, 'cd03879', NULL, NULL, 'M28_AAP', NULL, 'M28_AAP', NULL, NULL, NULL, 2),
(938, NULL, 'cd06083', NULL, NULL, 'KOW_Spt5_3', NULL, 'KOW_Spt5_3', NULL, NULL, 30643, 2),
(939, NULL, 'cd05520', NULL, NULL, 'Bromo_polybromo_III', NULL, 'Bromo_polybromo_III', NULL, NULL, NULL, 2),
(940, NULL, 'cd14938', NULL, NULL, 'MYSc_Myo24B', NULL, 'MYSc_Myo24B', NULL, NULL, NULL, 2),
(941, NULL, 'cd16292', NULL, NULL, 'CPSF3-like_MBL-fold', NULL, 'CPSF3-like_MBL-fold', NULL, NULL, NULL, 2),
(942, NULL, 'cd07590', NULL, NULL, 'BAR_Bin3', NULL, 'BAR_Bin3', NULL, NULL, 33064, 2),
(943, NULL, 'cd15510', NULL, NULL, 'PHD2_KMT2C_like', NULL, 'PHD2_KMT2C_like', NULL, NULL, NULL, 2),
(944, NULL, 'cd06957', NULL, NULL, 'NR_DBD_PNR_like_2', NULL, 'NR_DBD_PNR_like_2', NULL, NULL, NULL, 2),
(945, NULL, 'cd11665', NULL, NULL, 'LamB_like', NULL, 'LamB_like', NULL, NULL, NULL, 2),
(946, NULL, 'cd16656', NULL, NULL, 'RING-Ubox_PRP19', NULL, 'RING-Ubox_PRP19', NULL, NULL, NULL, 2),
(947, NULL, 'cd10316', NULL, NULL, 'RGL4_M', NULL, 'RGL4_M', NULL, NULL, 21648, 2),
(948, NULL, 'cd04910', NULL, NULL, 'ACT_AK-Ectoine_1', NULL, 'ACT_AK-Ectoine_1', NULL, NULL, NULL, 2),
(949, NULL, 'cd06897', NULL, NULL, 'PX_SNARE', NULL, 'PX_SNARE', NULL, NULL, NULL, 2),
(950, NULL, 'cd17076', NULL, NULL, 'UBX_UBXN10', NULL, 'UBX_UBXN10', NULL, NULL, NULL, 2),
(951, NULL, 'cd09008', NULL, NULL, 'MTAN', NULL, 'MTAN', NULL, NULL, NULL, 2),
(952, NULL, 'cd18642', NULL, NULL, 'CBD_MOF_like', NULL, 'CBD_MOF_like', NULL, NULL, NULL, 2),
(953, NULL, 'cd08254', NULL, NULL, 'hydroxyacyl_CoA_DH', NULL, 'hydroxyacyl_CoA_DH', NULL, NULL, NULL, 2),
(954, NULL, 'cd18673', NULL, NULL, 'PIN_XRN1-2-like', NULL, 'PIN_XRN1-2-like', NULL, NULL, NULL, 2),
(955, NULL, 'cd11689', NULL, NULL, 'SidM_DrrA_GEF', NULL, 'SidM_DrrA_GEF', NULL, NULL, 31675, 2),
(956, NULL, 'cd05915', NULL, NULL, 'ttLC_FACS_like', NULL, 'ttLC_FACS_like', NULL, NULL, NULL, 2),
(957, NULL, 'cd08465', NULL, NULL, 'PBP2_ToxR', NULL, 'PBP2_ToxR', NULL, NULL, NULL, 2),
(958, NULL, 'cd16797', NULL, NULL, 'RING-H2_RNF167', NULL, 'RING-H2_RNF167', NULL, NULL, NULL, 2),
(959, NULL, 'cd16822', NULL, NULL, 'SP-RING_ZMIZ1', NULL, 'SP-RING_ZMIZ1', NULL, NULL, NULL, 2),
(960, NULL, 'cd01392', NULL, NULL, 'HTH_LacI', NULL, 'HTH_LacI', NULL, NULL, 411, 2),
(961, NULL, 'cd09717', NULL, NULL, 'Cas7_I', NULL, 'Cas7_I', NULL, NULL, 17615, 2),
(962, NULL, 'cd11699', NULL, NULL, 'DHR2_DOCK10', NULL, 'DHR2_DOCK10', NULL, NULL, NULL, 2),
(963, NULL, 'cd12228', NULL, NULL, 'RRM_ENOX', NULL, 'RRM_ENOX', NULL, NULL, 10019, 2),
(964, NULL, 'cd09720', NULL, NULL, 'Cas1_II', NULL, 'Cas1_II', NULL, NULL, NULL, 2),
(965, NULL, 'cd05764', NULL, NULL, 'Ig_2', NULL, 'Ig_2', NULL, NULL, NULL, 2),
(966, NULL, 'cd01279', NULL, NULL, 'HTH_HspR-like', NULL, 'HTH_HspR-like', NULL, NULL, NULL, 2),
(967, NULL, 'cd00583', NULL, NULL, 'MutH_Sau3AI', NULL, 'MutH_Sau3AI', NULL, NULL, 13646, 2);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(968, NULL, 'cd03802', NULL, NULL, 'GT4_AviGT4-like', NULL, 'GT4_AviGT4-like', NULL, NULL, NULL, 2),
(969, NULL, 'cd01373', NULL, NULL, 'KISc_KLP2_like', NULL, 'KISc_KLP2_like', NULL, NULL, NULL, 2),
(970, NULL, 'cd00795', NULL, NULL, 'NOS_oxygenase_euk', NULL, 'NOS_oxygenase_euk', NULL, NULL, NULL, 2),
(971, NULL, 'cd06641', NULL, NULL, 'STKc_MST3', NULL, 'STKc_MST3', NULL, NULL, NULL, 2),
(972, NULL, 'cd11820', NULL, NULL, 'SH3_STAM', NULL, 'SH3_STAM', NULL, NULL, NULL, 2),
(973, NULL, 'cd18698', NULL, NULL, 'PIN_VapC_C-like', NULL, 'PIN_VapC_C-like', NULL, NULL, NULL, 2),
(974, NULL, 'cd17107', NULL, NULL, 'FERM_F1_EPB41L4A', NULL, 'FERM_F1_EPB41L4A', NULL, NULL, NULL, 2),
(975, NULL, 'cd09164', NULL, NULL, 'PLDc_EcPPK1_C1_like', NULL, 'PLDc_EcPPK1_C1_like', NULL, NULL, NULL, 2),
(976, NULL, 'cd13615', NULL, NULL, 'PBP2_ProWY', NULL, 'PBP2_ProWY', NULL, NULL, NULL, 2),
(977, NULL, 'cd09133', NULL, NULL, 'PLDc_unchar5', NULL, 'PLDc_unchar5', NULL, NULL, NULL, 2),
(978, NULL, 'cd15183', NULL, NULL, '7tmA_CCR1', NULL, '7tmA_CCR1', NULL, NULL, NULL, 2),
(979, NULL, 'cd16684', NULL, NULL, 'RING-H2_RNF145', NULL, 'RING-H2_RNF145', NULL, NULL, NULL, 2),
(980, NULL, 'cd19086', NULL, NULL, 'AKR_AKR11C1', NULL, 'AKR_AKR11C1', NULL, NULL, NULL, 2),
(981, NULL, 'cd04113', NULL, NULL, 'Rab4', NULL, 'Rab4', NULL, NULL, 30195, 2),
(982, NULL, 'cd05853', NULL, NULL, 'Ig6_Contactin-4', NULL, 'Ig6_Contactin-4', NULL, NULL, NULL, 2),
(983, NULL, 'cd16209', NULL, NULL, 'EFh_PI-PLCbeta2', NULL, 'EFh_PI-PLCbeta2', NULL, NULL, NULL, 2),
(984, NULL, 'cd17658', NULL, NULL, 'PTPc_plant_PTP1', NULL, 'PTPc_plant_PTP1', NULL, NULL, NULL, 2),
(985, NULL, 'cd01891', NULL, NULL, 'TypA_BipA', NULL, 'TypA_BipA', NULL, NULL, NULL, 2),
(986, NULL, 'cd14954', NULL, NULL, 'NHL_TRIM71_like', NULL, 'NHL_TRIM71_like', NULL, NULL, NULL, 2),
(987, NULL, 'cd02419', NULL, NULL, 'Peptidase_C39C', NULL, 'Peptidase_C39C', NULL, NULL, 32488, 2),
(988, NULL, 'cd12877', NULL, NULL, 'SPRY1_RyR', NULL, 'SPRY1_RyR', NULL, NULL, 30508, 2),
(989, NULL, 'cd09287', NULL, NULL, 'GluRS_non_core', NULL, 'GluRS_non_core', NULL, NULL, NULL, 2),
(990, NULL, 'cd15847', NULL, NULL, 'SNARE_syntaxin7_like', NULL, 'SNARE_syntaxin7_like', NULL, NULL, NULL, 2),
(991, NULL, 'cd10164', NULL, NULL, 'ClassIIa_HDAC5_Gln-rich-N', NULL, 'ClassIIa_HDAC5_Gln-rich-N', NULL, NULL, NULL, 2),
(992, NULL, 'cd02642', NULL, NULL, 'R3H_encore_like', NULL, 'R3H_encore_like', NULL, NULL, NULL, 2),
(993, NULL, 'cd14965', NULL, NULL, '7tm_Opsins_type1', NULL, '7tm_Opsins_type1', NULL, NULL, NULL, 2),
(994, NULL, 'cd04039', NULL, NULL, 'C2_PSD', NULL, 'C2_PSD', NULL, NULL, NULL, 2),
(995, NULL, 'cd14768', NULL, NULL, 'PC_PEC_beta', NULL, 'PC_PEC_beta', NULL, NULL, NULL, 2),
(996, NULL, 'cd09592', NULL, NULL, 'SAM_DLC2', NULL, 'SAM_DLC2', NULL, NULL, NULL, 2),
(997, NULL, 'cd14698', NULL, NULL, 'bZIP_CNC', NULL, 'bZIP_CNC', NULL, NULL, NULL, 2),
(998, NULL, 'cd18758', NULL, NULL, 'PIN_MtVapC3-like', NULL, 'PIN_MtVapC3-like', NULL, NULL, NULL, 2),
(999, NULL, 'cd12075', NULL, NULL, 'SH3_Tks4_1', NULL, 'SH3_Tks4_1', NULL, NULL, 15360, 2),
(1000, NULL, 'cd12705', NULL, NULL, 'RRM4_hnRPLL', NULL, 'RRM4_hnRPLL', NULL, NULL, 18524, 2),
(1001, NULL, 'cd15436', NULL, NULL, '7tmB2_Latrophilin', NULL, '7tmB2_Latrophilin', NULL, NULL, NULL, 2),
(1002, NULL, 'cd10236', NULL, NULL, 'HscA_like_NBD', NULL, 'HscA_like_NBD', NULL, NULL, 30642, 2),
(1003, NULL, 'cd11426', NULL, NULL, 'bHLH_TS_MIST1_like', NULL, 'bHLH_TS_MIST1_like', NULL, NULL, NULL, 2),
(1004, NULL, 'cd10500', NULL, NULL, 'MH2_SMAD_7', NULL, 'MH2_SMAD_7', NULL, NULL, NULL, 2),
(1005, NULL, 'cd10471', NULL, NULL, 'FAM20C_C', NULL, 'FAM20C_C', NULL, NULL, NULL, 2),
(1006, NULL, 'cd13387', NULL, NULL, 'PH1_FGD3', NULL, 'PH1_FGD3', NULL, NULL, NULL, 2),
(1007, NULL, 'cd14209', NULL, NULL, 'STKc_PKA', NULL, 'STKc_PKA', NULL, NULL, 34012, 2),
(1008, NULL, 'cd08215', NULL, NULL, 'STKc_Nek', NULL, 'STKc_Nek', NULL, NULL, NULL, 2),
(1009, NULL, 'cd11851', NULL, NULL, 'SH3_RIM-BP', NULL, 'SH3_RIM-BP', NULL, NULL, NULL, 2),
(1010, NULL, 'cd07633', NULL, NULL, 'BAR_OPHN1', NULL, 'BAR_OPHN1', NULL, NULL, NULL, 2);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(1011, NULL, 'cd14531', NULL, NULL, 'PFA-DSP_Oca1', NULL, 'PFA-DSP_Oca1', NULL, NULL, NULL, 2),
(1012, NULL, 'cd04143', NULL, NULL, 'Rhes_like', NULL, 'Rhes_like', NULL, NULL, NULL, 2),
(1013, NULL, 'cd09330', NULL, NULL, 'LIM4_abLIM', NULL, 'LIM4_abLIM', NULL, NULL, NULL, 2),
(1014, NULL, 'cd19026', NULL, NULL, 'LGIC_ECD_nAChR_B3', NULL, 'LGIC_ECD_nAChR_B3', NULL, NULL, NULL, 2),
(1015, NULL, 'cd19918', NULL, NULL, 'RsmI_like', NULL, 'RsmI_like', NULL, NULL, NULL, 2),
(1016, NULL, 'cd07433', NULL, NULL, 'PHP_PolIIIA_DnaE1', NULL, 'PHP_PolIIIA_DnaE1', NULL, NULL, NULL, 2),
(1017, NULL, 'cd09902', NULL, NULL, 'H3TH_MKT1', NULL, 'H3TH_MKT1', NULL, NULL, 32401, 2),
(1018, NULL, 'cd20761', NULL, NULL, 'capping_2-OMTase_Flaviviridae', NULL, 'capping_2-OMTase_Flaviviridae', NULL, NULL, 25117, 2),
(1019, NULL, 'cd12639', NULL, NULL, 'RRM3_CELF3_4_5_6', NULL, 'RRM3_CELF3_4_5_6', NULL, NULL, NULL, 2),
(1020, NULL, 'cd07078', NULL, NULL, 'ALDH', NULL, 'ALDH', NULL, NULL, NULL, 2),
(1021, NULL, 'cd02847', NULL, NULL, 'E_set_Chitobiase_C', NULL, 'E_set_Chitobiase_C', NULL, NULL, 7093, 2),
(1022, NULL, 'cd04885', NULL, NULL, 'ACT_ThrD-I', NULL, 'ACT_ThrD-I', NULL, NULL, NULL, 2),
(1023, NULL, 'cd17388', NULL, NULL, 'MFS_TetA', NULL, 'MFS_TetA', NULL, NULL, NULL, 2),
(1024, NULL, 'cd12384', NULL, NULL, 'RRM_RBM24_RBM38_like', NULL, 'RRM_RBM24_RBM38_like', NULL, NULL, NULL, 2),
(1025, NULL, 'cd17307', NULL, NULL, 'PIPKc_PIP5K1B', NULL, 'PIPKc_PIP5K1B', NULL, NULL, NULL, 2),
(1026, NULL, 'cd19473', NULL, NULL, 'SET_SUV39H_DIM5-like', NULL, 'SET_SUV39H_DIM5-like', NULL, NULL, NULL, 2),
(1027, NULL, 'cd09501', NULL, NULL, 'SAM_SARM1-like_repeat1', NULL, 'SAM_SARM1-like_repeat1', NULL, NULL, NULL, 2),
(1028, NULL, 'cd09923', NULL, NULL, 'SH2_SOCS_family', NULL, 'SH2_SOCS_family', NULL, NULL, NULL, 2),
(1029, NULL, 'cd15644', NULL, NULL, 'PHD_KDM2B', NULL, 'PHD_KDM2B', NULL, NULL, NULL, 2),
(1030, NULL, 'cd08291', NULL, NULL, 'ETR_like_1', NULL, 'ETR_like_1', NULL, NULL, NULL, 2),
(1031, NULL, 'cd12393', NULL, NULL, 'RRM_ZCRB1', NULL, 'RRM_ZCRB1', NULL, NULL, 21346, 2),
(1032, NULL, 'cd05234', NULL, NULL, 'UDP_G4E_2_SDR_e', NULL, 'UDP_G4E_2_SDR_e', NULL, NULL, NULL, 2),
(1033, NULL, 'cd05497', NULL, NULL, 'Bromo_Brdt_I_like', NULL, 'Bromo_Brdt_I_like', NULL, NULL, 35608, 2),
(1034, NULL, 'cd03718', NULL, NULL, 'SOCS_SSB1_4', NULL, 'SOCS_SSB1_4', NULL, NULL, NULL, 2),
(1035, NULL, 'cd19954', NULL, NULL, 'serpin42Dd-like_insects', NULL, 'serpin42Dd-like_insects', NULL, NULL, NULL, 2),
(1036, NULL, 'cd05619', NULL, NULL, 'STKc_nPKC_theta', NULL, 'STKc_nPKC_theta', NULL, NULL, 30929, 2),
(1037, NULL, 'cd12258', NULL, NULL, 'RRM2_RBM26_like', NULL, 'RRM2_RBM26_like', NULL, NULL, 33703, 2),
(1038, NULL, 'cd12689', NULL, NULL, 'RRM1_hnRNPL_like', NULL, 'RRM1_hnRNPL_like', NULL, NULL, NULL, 2),
(1039, NULL, 'cd15632', NULL, NULL, 'PHD_PHF13', NULL, 'PHD_PHF13', NULL, NULL, 30976, 2),
(1040, NULL, 'cd18990', NULL, NULL, 'LGIC_ECD_GABAAR', NULL, 'LGIC_ECD_GABAAR', NULL, NULL, NULL, 2),
(1041, NULL, 'cd15307', NULL, NULL, '7tmA_5-HT2_insect-like', NULL, '7tmA_5-HT2_insect-like', NULL, NULL, NULL, 2),
(1042, NULL, 'cd09638', NULL, NULL, 'Cas2_I_II_III', NULL, 'Cas2_I_II_III', NULL, NULL, NULL, 2),
(1043, NULL, 'cd21170', NULL, NULL, 'NTD_cv_Nsp15-like', NULL, 'NTD_cv_Nsp15-like', NULL, NULL, 35295, 2),
(1044, NULL, 'cd08175', NULL, NULL, 'G1PDH', NULL, 'G1PDH', NULL, NULL, NULL, 2),
(1045, NULL, 'cd12372', NULL, NULL, 'RRM_CFIm68_CFIm59', NULL, 'RRM_CFIm68_CFIm59', NULL, NULL, NULL, 2),
(1046, NULL, 'cd13272', NULL, NULL, 'PH_INPP4A_INPP4B', NULL, 'PH_INPP4A_INPP4B', NULL, NULL, NULL, 2),
(1047, NULL, 'cd01389', NULL, NULL, 'MATA_HMG-box', NULL, 'MATA_HMG-box', NULL, NULL, NULL, 2),
(1048, NULL, 'cd07866', NULL, NULL, 'STKc_BUR1', NULL, 'STKc_BUR1', NULL, NULL, NULL, 2),
(1049, NULL, 'cd12452', NULL, NULL, 'RRM_ARP_like', NULL, 'RRM_ARP_like', NULL, NULL, 728, 2),
(1050, NULL, 'cd09846', NULL, NULL, 'DUF1312', NULL, 'DUF1312', NULL, NULL, NULL, 2),
(1051, NULL, 'cd17205', NULL, NULL, 'FERM_F1_EPB41L5', NULL, 'FERM_F1_EPB41L5', NULL, NULL, NULL, 2);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(1052, NULL, 'cd14025', NULL, NULL, 'STKc_RIP4_like', NULL, 'STKc_RIP4_like', NULL, NULL, NULL, 2),
(1053, NULL, 'cd18222', NULL, NULL, 'BTB_POZ_ZBTB37', NULL, 'BTB_POZ_ZBTB37', NULL, NULL, NULL, 2),
(1054, NULL, 'cd08205', NULL, NULL, 'RuBisCO_IV_RLP', NULL, 'RuBisCO_IV_RLP', NULL, NULL, NULL, 2),
(1055, NULL, 'cd01314', NULL, NULL, 'D-HYD', NULL, 'D-HYD', NULL, NULL, 13185, 2),
(1056, NULL, 'cd15645', NULL, NULL, 'PHD_FXL19', NULL, 'PHD_FXL19', NULL, NULL, NULL, 2),
(1057, NULL, 'cd14577', NULL, NULL, 'DUSP13B', NULL, 'DUSP13B', NULL, NULL, NULL, 2),
(1058, NULL, 'cd11529', NULL, NULL, 'NTP-PPase_MazG_Cterm', NULL, 'NTP-PPase_MazG_Cterm', NULL, NULL, NULL, 2),
(1059, NULL, 'cd12755', NULL, NULL, 'RRM2_RBM5', NULL, 'RRM2_RBM5', NULL, NULL, 14869, 2),
(1060, NULL, 'cd00559', NULL, NULL, 'Cyanase_C', NULL, 'Cyanase_C', NULL, NULL, 2161, 2),
(1061, NULL, 'cd18423', NULL, NULL, 'BTB_POZ_KCNG4', NULL, 'BTB_POZ_KCNG4', NULL, NULL, NULL, 2),
(1062, NULL, 'cd09159', NULL, NULL, 'PLDc_ybhO_like_2', NULL, 'PLDc_ybhO_like_2', NULL, NULL, NULL, 2),
(1063, NULL, 'cd07048', NULL, NULL, 'BMC_PduB_repeat2', NULL, 'BMC_PduB_repeat2', NULL, NULL, NULL, 2),
(1064, NULL, 'cd07826', NULL, NULL, 'SRPBCC_CalC_Aha1-like_9', NULL, 'SRPBCC_CalC_Aha1-like_9', NULL, NULL, NULL, 2),
(1065, NULL, 'cd00251', NULL, NULL, 'Mth_Ecto', NULL, 'Mth_Ecto', NULL, NULL, 8052, 2),
(1066, NULL, 'cd14827', NULL, NULL, 'AP_sigma', NULL, 'AP_sigma', NULL, NULL, NULL, 2),
(1067, NULL, 'cd08759', NULL, NULL, 'Type_III_cohesin_like', NULL, 'Type_III_cohesin_like', NULL, NULL, NULL, 2),
(1068, NULL, 'cd04031', NULL, NULL, 'C2A_RIM1alpha', NULL, 'C2A_RIM1alpha', NULL, NULL, NULL, 2),
(1069, NULL, 'cd09425', NULL, NULL, 'LIM4_LIMPETin', NULL, 'LIM4_LIMPETin', NULL, NULL, NULL, 2),
(1070, NULL, 'cd08734', NULL, NULL, 'RGS-like_1', NULL, 'RGS-like_1', NULL, NULL, NULL, 2),
(1071, NULL, 'cd13710', NULL, NULL, 'PBP2_TcyK', NULL, 'PBP2_TcyK', NULL, NULL, NULL, 2),
(1072, NULL, 'cd04216', NULL, NULL, 'Phytocyanin', NULL, 'Phytocyanin', NULL, NULL, NULL, 2),
(1073, NULL, 'cd06842', NULL, NULL, 'PLPDE_III_Y4yA_like', NULL, 'PLPDE_III_Y4yA_like', NULL, NULL, 35363, 2),
(1074, NULL, 'cd19710', NULL, NULL, 'bHLH_TS_TCF24', NULL, 'bHLH_TS_TCF24', NULL, NULL, NULL, 2),
(1075, NULL, 'cd01900', NULL, NULL, 'YchF', NULL, 'YchF', NULL, NULL, 30644, 2),
(1076, NULL, 'cd03447', NULL, NULL, 'FAS_MaoC', NULL, 'FAS_MaoC', NULL, NULL, NULL, 2),
(1077, NULL, 'cd03781', NULL, NULL, 'MATH_TRAF4', NULL, 'MATH_TRAF4', NULL, NULL, 27701, 2),
(1078, NULL, 'cd16295', NULL, NULL, 'TTHA0252-CPSF-like_MBL-fold', NULL, 'TTHA0252-CPSF-like_MBL-fold', NULL, NULL, NULL, 2),
(1079, NULL, 'cd03009', NULL, NULL, 'TryX_like_TryX_NRX', NULL, 'TryX_like_TryX_NRX', NULL, NULL, 34021, 2),
(1080, NULL, 'cd16925', NULL, NULL, 'HATPase_TutC-TodS-like', NULL, 'HATPase_TutC-TodS-like', NULL, NULL, NULL, 2),
(1081, NULL, 'cd16449', NULL, NULL, 'RING-HC', NULL, 'RING-HC', NULL, NULL, NULL, 2),
(1082, NULL, 'cd19788', NULL, NULL, 'Bbox2_MuRF', NULL, 'Bbox2_MuRF', NULL, NULL, NULL, 2),
(1083, NULL, 'cd05837', NULL, NULL, 'MSH6_like', NULL, 'MSH6_like', NULL, NULL, NULL, 2),
(1084, NULL, 'cd19531', NULL, NULL, 'LCL_NRPS-like', NULL, 'LCL_NRPS-like', NULL, NULL, NULL, 2),
(1085, NULL, 'cd14819', NULL, NULL, 'Translin', NULL, 'Translin', NULL, NULL, 29767, 2),
(1086, NULL, 'cd18378', NULL, NULL, 'BTB_POZ_Kv2_KCNB', NULL, 'BTB_POZ_Kv2_KCNB', NULL, NULL, NULL, 2),
(1087, NULL, 'cd18612', NULL, NULL, 'GH130_Lin0857-like', NULL, 'GH130_Lin0857-like', NULL, NULL, NULL, 2),
(1088, NULL, 'cd06423', NULL, NULL, 'CESA_like', NULL, 'CESA_like', NULL, NULL, NULL, 2),
(1089, NULL, 'cd18278', NULL, NULL, 'BTB_POZ_BACH2', NULL, 'BTB_POZ_BACH2', NULL, NULL, NULL, 2),
(1090, NULL, 'cd14638', NULL, NULL, 'DSP_DUSP1', NULL, 'DSP_DUSP1', NULL, NULL, NULL, 2),
(1091, NULL, 'cd15684', NULL, NULL, 'PHD_ING4', NULL, 'PHD_ING4', NULL, NULL, NULL, 2),
(1092, NULL, 'cd00402', NULL, NULL, 'Riboflavin_synthase_like', NULL, 'Riboflavin_synthase_like', NULL, NULL, 4430, 2),
(1093, NULL, 'cd17651', NULL, NULL, 'A_NRPS_VisG_like', NULL, 'A_NRPS_VisG_like', NULL, NULL, NULL, 2);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(1094, NULL, 'cd11969', NULL, NULL, 'SH3_PLCgamma2', NULL, 'SH3_PLCgamma2', NULL, NULL, 31261, 2),
(1095, NULL, 'cd02770', NULL, NULL, 'MopB_DmsA-EC', NULL, 'MopB_DmsA-EC', NULL, NULL, NULL, 2),
(1096, NULL, 'cd08435', NULL, NULL, 'PBP2_GbpR', NULL, 'PBP2_GbpR', NULL, NULL, 32044, 2),
(1097, NULL, 'cd14849', NULL, NULL, 'DD-dipeptidase_VanXYc', NULL, 'DD-dipeptidase_VanXYc', NULL, NULL, NULL, 2),
(1098, NULL, 'cd08264', NULL, NULL, 'Zn_ADH_like2', NULL, 'Zn_ADH_like2', NULL, NULL, NULL, 2),
(1099, NULL, 'cd01451', NULL, NULL, 'vWA_Magnesium_chelatase', NULL, 'vWA_Magnesium_chelatase', NULL, NULL, 30671, 2),
(1100, NULL, 'cd15405', NULL, NULL, '7tmA_OR8B-like', NULL, '7tmA_OR8B-like', NULL, NULL, NULL, 2),
(1101, NULL, 'cd03110', NULL, NULL, 'SIMIBI_bact_arch', NULL, 'SIMIBI_bact_arch', NULL, NULL, NULL, 2),
(1102, NULL, 'cd07647', NULL, NULL, 'F-BAR_PSTPIP', NULL, 'F-BAR_PSTPIP', NULL, NULL, NULL, 2),
(1103, NULL, 'cd00044', NULL, NULL, 'CysPc', NULL, 'CysPc', NULL, NULL, 2051, 2),
(1104, NULL, 'cd03569', NULL, NULL, 'VHS_Hrs', NULL, 'VHS_Hrs', NULL, NULL, NULL, 2),
(1105, NULL, 'cd19459', NULL, NULL, 'lipocalin_C1_moubatin-like', NULL, 'lipocalin_C1_moubatin-like', NULL, NULL, NULL, 2),
(1106, NULL, 'cd15123', NULL, NULL, '7tmA_BRS-3', NULL, '7tmA_BRS-3', NULL, NULL, NULL, 2),
(1107, NULL, 'cd00161', NULL, NULL, 'RICIN', NULL, 'RICIN', NULL, NULL, 3959, 2),
(1108, NULL, 'cd01917', NULL, NULL, 'ACS_2', NULL, 'ACS_2', NULL, NULL, NULL, 2),
(1109, NULL, 'cd20609', NULL, NULL, 'nitroreductase', NULL, 'nitroreductase', NULL, NULL, NULL, 2),
(1110, NULL, 'cd16005', NULL, NULL, '7tmB2_Latrophilin-3', NULL, '7tmB2_Latrophilin-3', NULL, NULL, NULL, 2),
(1111, NULL, 'cd09741', NULL, NULL, 'Csx1_III-U', NULL, 'Csx1_III-U', NULL, NULL, NULL, 2),
(1112, NULL, 'cd18324', NULL, NULL, 'BTB_POZ_ZBTB18_RP58', NULL, 'BTB_POZ_ZBTB18_RP58', NULL, NULL, NULL, 2),
(1113, NULL, 'cd05092', NULL, NULL, 'PTKc_TrkA', NULL, 'PTKc_TrkA', NULL, NULL, NULL, 2),
(1114, NULL, 'cd11862', NULL, NULL, 'SH3_MPP', NULL, 'SH3_MPP', NULL, NULL, NULL, 2),
(1115, NULL, 'cd18753', NULL, NULL, 'PIN_VapC4-5_FitB-like', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, NULL, 2),
(1116, NULL, 'cd17218', NULL, NULL, 'RA_RASSF1', NULL, 'RA_RASSF1', NULL, NULL, NULL, 2),
(1117, NULL, 'cd00581', NULL, NULL, 'QFR_TypeB_TM', NULL, 'QFR_TypeB_TM', NULL, NULL, 3824, 2),
(1118, NULL, 'cd19724', NULL, NULL, 'bHLH_TS_ASCL3_like', NULL, 'bHLH_TS_ASCL3_like', NULL, NULL, NULL, 2),
(1119, NULL, 'cd21404', NULL, NULL, 'ZBD_rv_SF1_Hel-like', NULL, 'ZBD_rv_SF1_Hel-like', NULL, NULL, 37651, 2),
(1120, NULL, 'cd15546', NULL, NULL, 'PHD_PHF13_like', NULL, 'PHD_PHF13_like', NULL, NULL, NULL, 2),
(1121, NULL, 'cd03267', NULL, NULL, 'ABC_NatA_like', NULL, 'ABC_NatA_like', NULL, NULL, NULL, 2),
(1122, NULL, 'cd16002', NULL, NULL, '7tmA_NK1R', NULL, '7tmA_NK1R', NULL, NULL, NULL, 2),
(1123, NULL, 'cd15008', NULL, NULL, '7tmA_GPR19', NULL, '7tmA_GPR19', NULL, NULL, NULL, 2),
(1124, NULL, 'cd14828', NULL, NULL, 'AP_Mu_N', NULL, 'AP_Mu_N', NULL, NULL, NULL, 2),
(1125, NULL, 'cd01210', NULL, NULL, 'PTB_EPS8', NULL, 'PTB_EPS8', NULL, NULL, 27679, 2),
(1126, NULL, 'cd08513', NULL, NULL, 'PBP2_thermophilic_Hb8_like', NULL, 'PBP2_thermophilic_Hb8_like', NULL, NULL, NULL, 2),
(1127, NULL, 'cd18464', NULL, NULL, 'BACK_KLHL25_like', NULL, 'BACK_KLHL25_like', NULL, NULL, NULL, 2),
(1128, NULL, 'cd17058', NULL, NULL, 'Ubl_SNRNP25', NULL, 'Ubl_SNRNP25', NULL, NULL, 31548, 2),
(1129, NULL, 'cd18069', NULL, NULL, 'DEXHc_ARIP4', NULL, 'DEXHc_ARIP4', NULL, NULL, 36335, 2),
(1130, NULL, 'cd12006', NULL, NULL, 'SH3_Fyn_Yrk', NULL, 'SH3_Fyn_Yrk', NULL, NULL, 30430, 2),
(1131, NULL, 'cd07588', NULL, NULL, 'BAR_Amphiphysin', NULL, 'BAR_Amphiphysin', NULL, NULL, NULL, 2),
(1132, NULL, 'cd01000', NULL, NULL, 'PBP2_Cys_DEBP_like', NULL, 'PBP2_Cys_DEBP_like', NULL, NULL, NULL, 2),
(1133, NULL, 'cd13440', NULL, NULL, 'CamS_repeat_2', NULL, 'CamS_repeat_2', NULL, NULL, NULL, 2),
(1134, NULL, 'cd14818', NULL, NULL, 'longin-like', NULL, 'longin-like', NULL, NULL, NULL, 2),
(1135, NULL, 'cd15767', NULL, NULL, 'FYVE_SPIR1', NULL, 'FYVE_SPIR1', NULL, NULL, NULL, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(1136, NULL, 'cd12011', NULL, NULL, 'SH3_SLAP2', NULL, 'SH3_SLAP2', NULL, NULL, NULL, 2),
(1137, NULL, 'cd12036', NULL, NULL, 'SH3_MPP5', NULL, 'SH3_MPP5', NULL, NULL, 33833, 2),
(1138, NULL, 'cd00035', NULL, NULL, 'ChtBD1', NULL, 'ChtBD1', NULL, NULL, NULL, 2),
(1139, NULL, 'cd18579', NULL, NULL, 'ABC_6TM_ABCC_D1', NULL, 'ABC_6TM_ABCC_D1', NULL, NULL, 34492, 2),
(1140, NULL, 'cd08520', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_21', NULL, 'PBP2_NikA_DppA_OppA_like_21', NULL, NULL, NULL, 2),
(1141, NULL, 'cd05488', NULL, NULL, 'Proteinase_A_fungi', NULL, 'Proteinase_A_fungi', NULL, NULL, 30421, 2),
(1142, NULL, 'cd01556', NULL, NULL, 'EPSP_synthase', NULL, 'EPSP_synthase', NULL, NULL, 3826, 2),
(1143, NULL, 'cd15641', NULL, NULL, 'PHD_PHF2', NULL, 'PHD_PHF2', NULL, NULL, NULL, 2),
(1144, NULL, 'cd13339', NULL, NULL, 'PH-GRAM_MTMR13', NULL, 'PH-GRAM_MTMR13', NULL, NULL, 31534, 2),
(1145, NULL, 'cd01650', NULL, NULL, 'RT_nLTR_like', NULL, 'RT_nLTR_like', NULL, NULL, NULL, 2),
(1146, NULL, 'cd14018', NULL, NULL, 'STKc_PINK1', NULL, 'STKc_PINK1', NULL, NULL, 27064, 2),
(1147, NULL, 'cd16297', NULL, NULL, 'artemis-SNM1C-like_MBL-fold', NULL, 'artemis-SNM1C-like_MBL-fold', NULL, NULL, NULL, 2),
(1148, NULL, 'cd12162', NULL, NULL, '2-Hacid_dh_4', NULL, '2-Hacid_dh_4', NULL, NULL, NULL, 2),
(1149, NULL, 'cd16152', NULL, NULL, 'sulfatase_like', NULL, 'sulfatase_like', NULL, NULL, NULL, 2),
(1150, NULL, 'cd01759', NULL, NULL, 'PLAT_PL', NULL, 'PLAT_PL', NULL, NULL, NULL, 2),
(1151, NULL, 'cd19548', NULL, NULL, 'serpinA_A1AT-like', NULL, 'serpinA_A1AT-like', NULL, NULL, NULL, 2),
(1152, NULL, 'cd06935', NULL, NULL, 'NR_LBD_TR', NULL, 'NR_LBD_TR', NULL, NULL, NULL, 2),
(1153, NULL, 'cd19351', NULL, NULL, 'Wnt_Wnt8a', NULL, 'Wnt_Wnt8a', NULL, NULL, NULL, 2),
(1154, NULL, 'cd09163', NULL, NULL, 'PLDc_CLS_unchar2_2', NULL, 'PLDc_CLS_unchar2_2', NULL, NULL, NULL, 2),
(1155, NULL, 'cd04367', NULL, NULL, 'IlGF_insulin_like', NULL, 'IlGF_insulin_like', NULL, NULL, 4085, 2),
(1156, NULL, 'cd15225', NULL, NULL, '7tmA_OR10A-like', NULL, '7tmA_OR10A-like', NULL, NULL, NULL, 2),
(1157, NULL, 'cd06382', NULL, NULL, 'PBP1_iGluR_Kainate', NULL, 'PBP1_iGluR_Kainate', NULL, NULL, NULL, 2),
(1158, NULL, 'cd18202', NULL, NULL, 'BTB_POZ_ZBTB11', NULL, 'BTB_POZ_ZBTB11', NULL, NULL, NULL, 2),
(1159, NULL, 'cd06991', NULL, NULL, 'cupin_TcmJ-like', NULL, 'cupin_TcmJ-like', NULL, NULL, NULL, 2),
(1160, NULL, 'cd09134', NULL, NULL, 'PLDc_PSS_G_neg_1', NULL, 'PLDc_PSS_G_neg_1', NULL, NULL, NULL, 2),
(1161, NULL, 'cd07438', NULL, NULL, 'PHP_HisPPase_AMP', NULL, 'PHP_HisPPase_AMP', NULL, NULL, NULL, 2),
(1162, NULL, 'cd18258', NULL, NULL, 'BTB_POZ_KLHL29_KBTBD9', NULL, 'BTB_POZ_KLHL29_KBTBD9', NULL, NULL, NULL, 2),
(1163, NULL, 'cd01426', NULL, NULL, 'ATP-synt_F1_V1_A1_AB_FliI_N', NULL, 'ATP-synt_F1_V1_A1_AB_FliI_N', NULL, NULL, NULL, 2),
(1164, NULL, 'cd15827', NULL, NULL, 'SPRY_PRY_TRIM10', NULL, 'SPRY_PRY_TRIM10', NULL, NULL, NULL, 2),
(1165, NULL, 'cd17983', NULL, NULL, 'DEXHc_DHX38', NULL, 'DEXHc_DHX38', NULL, NULL, NULL, 2),
(1166, NULL, 'cd09348', NULL, NULL, 'LIM4_FHL1', NULL, 'LIM4_FHL1', NULL, NULL, NULL, 2),
(1167, NULL, 'cd19552', NULL, NULL, 'serpinA4_KST', NULL, 'serpinA4_KST', NULL, NULL, NULL, 2),
(1168, NULL, 'cd05040', NULL, NULL, 'PTKc_Ack_like', NULL, 'PTKc_Ack_like', NULL, NULL, NULL, 2),
(1169, NULL, 'cd02933', NULL, NULL, 'OYE_like_FMN', NULL, 'OYE_like_FMN', NULL, NULL, NULL, 2),
(1170, NULL, 'cd17284', NULL, NULL, 'RMtype1_S_Cbo7060ORF11580P_TRD2-CR2_like', NULL, 'RMtype1_S_Cbo7060ORF11580P_TRD2-CR2_like', NULL, NULL, NULL, 2),
(1171, NULL, 'cd00918', NULL, NULL, 'Der-p2_like', NULL, 'Der-p2_like', NULL, NULL, NULL, 2),
(1172, NULL, 'cd19418', NULL, NULL, 'lipocalin_A1M-like', NULL, 'lipocalin_A1M-like', NULL, NULL, NULL, 2),
(1173, NULL, 'cd06007', NULL, NULL, 'R3H_DEXH_helicase', NULL, 'R3H_DEXH_helicase', NULL, NULL, 25082, 2),
(1174, NULL, 'cd01475', NULL, NULL, 'vWA_Matrilin', NULL, 'vWA_Matrilin', NULL, NULL, NULL, 2),
(1175, NULL, 'cd04158', NULL, NULL, 'ARD1', NULL, 'ARD1', NULL, NULL, NULL, 2),
(1176, NULL, 'cd09093', NULL, NULL, 'INPP5c_INPP5B', NULL, 'INPP5c_INPP5B', NULL, NULL, 32475, 2);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(1177, NULL, 'cd15443', NULL, NULL, '7tmB2_GPR114', NULL, '7tmB2_GPR114', NULL, NULL, NULL, 2),
(1178, NULL, 'cd10802', NULL, NULL, 'YdjC_TTHB029_like', NULL, 'YdjC_TTHB029_like', NULL, NULL, NULL, 2),
(1179, NULL, 'cd10033', NULL, NULL, 'UDG_like', NULL, 'UDG_like', NULL, NULL, NULL, 2),
(1180, NULL, 'cd01068', NULL, NULL, 'globin_sensor', NULL, 'globin_sensor', NULL, NULL, 29386, 2),
(1181, NULL, 'cd08449', NULL, NULL, 'PBP2_XapR', NULL, 'PBP2_XapR', NULL, NULL, 28514, 2),
(1182, NULL, 'cd06330', NULL, NULL, 'PBP1_As_SBP-like', NULL, 'PBP1_As_SBP-like', NULL, NULL, NULL, 2),
(1183, NULL, 'cd12324', NULL, NULL, 'RRM_RBM8', NULL, 'RRM_RBM8', NULL, NULL, 27640, 2),
(1184, NULL, 'cd13152', NULL, NULL, 'KOW_GPKOW_A', NULL, 'KOW_GPKOW_A', NULL, NULL, 30313, 2),
(1185, NULL, 'cd10014', NULL, NULL, 'TFIIA_gamma_C', NULL, 'TFIIA_gamma_C', NULL, NULL, 14453, 2),
(1186, NULL, 'cd11420', NULL, NULL, 'bHLH_E-protein', NULL, 'bHLH_E-protein', NULL, NULL, NULL, 2),
(1187, NULL, 'cd19339', NULL, NULL, 'Wnt_Wnt7', NULL, 'Wnt_Wnt7', NULL, NULL, NULL, 2),
(1188, NULL, 'cd00381', NULL, NULL, 'IMPDH', NULL, 'IMPDH', NULL, NULL, 2031, 2),
(1189, NULL, 'cd05719', NULL, NULL, 'Ig2_PVR_like', NULL, 'Ig2_PVR_like', NULL, NULL, NULL, 2),
(1190, NULL, 'cd14637', NULL, NULL, 'R-PTPc-U-2', NULL, 'R-PTPc-U-2', NULL, NULL, NULL, 2),
(1191, NULL, 'cd17176', NULL, NULL, 'FERM_F0_SHANK2', NULL, 'FERM_F0_SHANK2', NULL, NULL, NULL, 2),
(1192, NULL, 'cd03422', NULL, NULL, 'YedF', NULL, 'YedF', NULL, NULL, NULL, 2),
(1193, NULL, 'cd18589', NULL, NULL, 'ABC_6TM_TAP1', NULL, 'ABC_6TM_TAP1', NULL, NULL, NULL, 2),
(1194, NULL, 'cd11838', NULL, NULL, 'SH3_Intersectin_3', NULL, 'SH3_Intersectin_3', NULL, NULL, NULL, 2),
(1195, NULL, 'cd10917', NULL, NULL, 'CE4_NodB_like_6s_7s', NULL, 'CE4_NodB_like_6s_7s', NULL, NULL, NULL, 2),
(1196, NULL, 'cd09901', NULL, NULL, 'H3TH_FEN1-like', NULL, 'H3TH_FEN1-like', NULL, NULL, NULL, 2),
(1197, NULL, 'cd06118', NULL, NULL, 'citrate_synt_like_1', NULL, 'citrate_synt_like_1', NULL, NULL, NULL, 2),
(1198, NULL, 'cd07927', NULL, NULL, 'RHD-n_NFAT_like', NULL, 'RHD-n_NFAT_like', NULL, NULL, NULL, 2),
(1199, NULL, 'cd04392', NULL, NULL, 'RhoGAP_ARHGAP19', NULL, 'RhoGAP_ARHGAP19', NULL, NULL, NULL, 2),
(1200, NULL, 'cd14594', NULL, NULL, 'PTP-MTMR12', NULL, 'PTP-MTMR12', NULL, NULL, NULL, 2),
(1201, NULL, 'cd04320', NULL, NULL, 'AspRS_cyto_N', NULL, 'AspRS_cyto_N', NULL, NULL, NULL, 2),
(1202, NULL, 'cd15975', NULL, NULL, '7tmA_ET-AR', NULL, '7tmA_ET-AR', NULL, NULL, NULL, 2),
(1203, NULL, 'cd12533', NULL, NULL, 'RRM_EWS', NULL, 'RRM_EWS', NULL, NULL, 28512, 2),
(1204, NULL, 'cd14040', NULL, NULL, 'STKc_TLK1', NULL, 'STKc_TLK1', NULL, NULL, NULL, 2),
(1205, NULL, 'cd06281', NULL, NULL, 'PBP1_LacI-like', NULL, 'PBP1_LacI-like', NULL, NULL, NULL, 2),
(1206, NULL, 'cd17939', NULL, NULL, 'DEADc_EIF4A', NULL, 'DEADc_EIF4A', NULL, NULL, NULL, 2),
(1207, NULL, 'cd03536', NULL, NULL, 'Rieske_RO_Alpha_DTDO', NULL, 'Rieske_RO_Alpha_DTDO', NULL, NULL, NULL, 2),
(1208, NULL, 'cd08954', NULL, NULL, 'KR_1_FAS_SDR_x', NULL, 'KR_1_FAS_SDR_x', NULL, NULL, NULL, 2),
(1209, NULL, 'cd11486', NULL, NULL, 'SLC5sbd_SGLT1', NULL, 'SLC5sbd_SGLT1', NULL, NULL, NULL, 2),
(1210, NULL, 'cd15872', NULL, NULL, 'R-SNARE_VAMP5', NULL, 'R-SNARE_VAMP5', NULL, NULL, 35830, 2),
(1211, NULL, 'cd04498', NULL, NULL, 'hPOT1_OB2', NULL, 'hPOT1_OB2', NULL, NULL, NULL, 2),
(1212, NULL, 'cd01005', NULL, NULL, 'PBP2_CysP', NULL, 'PBP2_CysP', NULL, NULL, 3688, 2),
(1213, NULL, 'cd19191', NULL, NULL, 'PR-SET_PRDM6', NULL, 'PR-SET_PRDM6', NULL, NULL, 35132, 2),
(1214, NULL, 'cd06231', NULL, NULL, 'M14_REP34-like', NULL, 'M14_REP34-like', NULL, NULL, NULL, 2),
(1215, NULL, 'cd07642', NULL, NULL, 'BAR_ASAP2', NULL, 'BAR_ASAP2', NULL, NULL, NULL, 2),
(1216, NULL, 'cd16328', NULL, NULL, 'RseA_N', NULL, 'RseA_N', NULL, NULL, 1525, 2),
(1217, NULL, 'cd02244', NULL, NULL, 'cupin_7S_vicilin-like_N', NULL, 'cupin_7S_vicilin-like_N', NULL, NULL, NULL, 2),
(1218, NULL, 'cd03117', NULL, NULL, 'alpha_CA_IV_XV_like', NULL, 'alpha_CA_IV_XV_like', NULL, NULL, 30778, 2); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(1219, NULL, 'cd03236', NULL, NULL, 'ABC_RNaseL_inhibitor_domain1', NULL, 'ABC_RNaseL_inhibitor_domain1', NULL, NULL, 20902, 2),
(1220, NULL, 'cd07981', NULL, NULL, 'TAF12', NULL, 'TAF12', NULL, NULL, 2961, 2),
(1221, NULL, 'cd12043', NULL, NULL, 'SH3_CACNB4', NULL, 'SH3_CACNB4', NULL, NULL, NULL, 2),
(1222, NULL, 'cd07855', NULL, NULL, 'STKc_ERK5', NULL, 'STKc_ERK5', NULL, NULL, NULL, 2),
(1223, NULL, 'cd03147', NULL, NULL, 'GATase1_Ydr533c_like', NULL, 'GATase1_Ydr533c_like', NULL, NULL, NULL, 2),
(1224, NULL, 'cd11296', NULL, NULL, 'O-FucT_like', NULL, 'O-FucT_like', NULL, NULL, NULL, 2),
(1225, NULL, 'cd17404', NULL, NULL, 'MFS_SLCO5_OATP5', NULL, 'MFS_SLCO5_OATP5', NULL, NULL, NULL, 2),
(1226, NULL, 'cd07281', NULL, NULL, 'PX_SNX1', NULL, 'PX_SNX1', NULL, NULL, 31169, 2),
(1227, NULL, 'cd16792', NULL, NULL, 'SP-RING_Siz_plant', NULL, 'SP-RING_Siz_plant', NULL, NULL, NULL, 2),
(1228, NULL, 'cd14226', NULL, NULL, 'PKc_DYRK1', NULL, 'PKc_DYRK1', NULL, NULL, 35062, 2),
(1229, NULL, 'cd15388', NULL, NULL, '7tmA_V2R', NULL, '7tmA_V2R', NULL, NULL, NULL, 2),
(1230, NULL, 'cd07206', NULL, NULL, 'Pat_TGL3-4-5_SDP1', NULL, 'Pat_TGL3-4-5_SDP1', NULL, NULL, NULL, 2),
(1231, NULL, 'cd17742', NULL, NULL, 'BRCT_CHS5_like', NULL, 'BRCT_CHS5_like', NULL, NULL, NULL, 2),
(1232, NULL, 'cd17666', NULL, NULL, 'PTP-MTM-like_fungal', NULL, 'PTP-MTM-like_fungal', NULL, NULL, NULL, 2),
(1233, NULL, 'cd02526', NULL, NULL, 'GT2_RfbF_like', NULL, 'GT2_RfbF_like', NULL, NULL, NULL, 2),
(1234, NULL, 'cd17963', NULL, NULL, 'DEADc_DDX19_DDX25', NULL, 'DEADc_DDX19_DDX25', NULL, NULL, NULL, 2),
(1235, NULL, 'cd19873', NULL, NULL, 'DSRM_MRPL3_like', NULL, 'DSRM_MRPL3_like', NULL, NULL, 34642, 2),
(1236, NULL, 'cd02808', NULL, NULL, 'GltS_FMN', NULL, 'GltS_FMN', NULL, NULL, 6985, 2),
(1237, NULL, 'cd07088', NULL, NULL, 'ALDH_LactADH-AldA', NULL, 'ALDH_LactADH-AldA', NULL, NULL, NULL, 2),
(1238, NULL, 'cd16709', NULL, NULL, 'RING-HC_Cbl-b', NULL, 'RING-HC_Cbl-b', NULL, NULL, 33475, 2),
(1239, NULL, 'cd19389', NULL, NULL, 'TGF_beta_GDF11', NULL, 'TGF_beta_GDF11', NULL, NULL, NULL, 2),
(1240, NULL, 'cd19828', NULL, NULL, 'Bbox2_TIF1a_C-VI', NULL, 'Bbox2_TIF1a_C-VI', NULL, NULL, NULL, 2),
(1241, NULL, 'cd19887', NULL, NULL, 'DSRM_STAU1_rpt5', NULL, 'DSRM_STAU1_rpt5', NULL, NULL, NULL, 2),
(1242, NULL, 'cd13584', NULL, NULL, 'PBP2_AlgQ1_2', NULL, 'PBP2_AlgQ1_2', NULL, NULL, NULL, 2),
(1243, NULL, 'cd11391', NULL, NULL, 'bHLH_PAS', NULL, 'bHLH_PAS', NULL, NULL, NULL, 2),
(1244, NULL, 'cd15724', NULL, NULL, 'FYVE_ZFY26', NULL, 'FYVE_ZFY26', NULL, NULL, NULL, 2),
(1245, NULL, 'cd12309', NULL, NULL, 'RRM2_Spen', NULL, 'RRM2_Spen', NULL, NULL, NULL, 2),
(1246, NULL, 'cd16359', NULL, NULL, 'VOC_BsCatE_like_C', NULL, 'VOC_BsCatE_like_C', NULL, NULL, NULL, 2),
(1247, NULL, 'cd03881', NULL, NULL, 'M28_Nicastrin', NULL, 'M28_Nicastrin', NULL, NULL, NULL, 2),
(1248, NULL, 'cd13540', NULL, NULL, 'PBP2_ModA_WtpA', NULL, 'PBP2_ModA_WtpA', NULL, NULL, NULL, 2),
(1249, NULL, 'cd18700', NULL, NULL, 'PIN_GNAT-like', NULL, 'PIN_GNAT-like', NULL, NULL, NULL, 2),
(1250, NULL, 'cd17458', NULL, NULL, 'MFS_SLCO1A_OATP1A', NULL, 'MFS_SLCO1A_OATP1A', NULL, NULL, NULL, 2),
(1251, NULL, 'cd07456', NULL, NULL, 'CRD_FZ5_like', NULL, 'CRD_FZ5_like', NULL, NULL, NULL, 2),
(1252, NULL, 'cd18064', NULL, NULL, 'DEXHc_SMARCA5', NULL, 'DEXHc_SMARCA5', NULL, NULL, NULL, 2),
(1253, NULL, 'cd00887', NULL, NULL, 'MoeA', NULL, 'MoeA', NULL, NULL, 27850, 2),
(1254, NULL, 'cd08825', NULL, NULL, 'MVP_shoulder', NULL, 'MVP_shoulder', NULL, NULL, 19940, 2),
(1255, NULL, 'cd06913', NULL, NULL, 'beta3GnTL1_like', NULL, 'beta3GnTL1_like', NULL, NULL, NULL, 2),
(1256, NULL, 'cd01387', NULL, NULL, 'MYSc_Myo15', NULL, 'MYSc_Myo15', NULL, NULL, 29274, 2),
(1257, NULL, 'cd08702', NULL, NULL, 'Arna_FMT_C', NULL, 'Arna_FMT_C', NULL, NULL, NULL, 2),
(1258, NULL, 'cd00290', NULL, NULL, 'cytochrome_b_C', NULL, 'cytochrome_b_C', NULL, NULL, 5662, 2),
(1259, NULL, 'cd04925', NULL, NULL, 'ACT_ACR_2', NULL, 'ACT_ACR_2', NULL, NULL, NULL, 2),
(1260, NULL, 'cd03864', NULL, NULL, 'M14_CPN', NULL, 'M14_CPN', NULL, NULL, 29451, 2);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(1261, NULL, 'cd18743', NULL, NULL, 'PIN_VapC4-5_FitB-like', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, NULL, 2),
(1262, NULL, 'cd04377', NULL, NULL, 'RhoGAP_myosin_IX', NULL, 'RhoGAP_myosin_IX', NULL, NULL, NULL, 2),
(1263, NULL, 'cd09116', NULL, NULL, 'PLDc_Nuc_like', NULL, 'PLDc_Nuc_like', NULL, NULL, NULL, 2),
(1264, NULL, 'cd15269', NULL, NULL, '7tmB1_VIP-R1', NULL, '7tmB1_VIP-R1', NULL, NULL, NULL, 2),
(1265, NULL, 'cd10554', NULL, NULL, 'HycB_like', NULL, 'HycB_like', NULL, NULL, NULL, 2),
(1266, NULL, 'cd16828', NULL, NULL, 'HemS-like', NULL, 'HemS-like', NULL, NULL, NULL, 2),
(1267, NULL, 'cd10580', NULL, NULL, 'TNFRSF10', NULL, 'TNFRSF10', NULL, NULL, 26300, 2),
(1268, NULL, 'cd05255', NULL, NULL, 'SQD1_like_SDR_e', NULL, 'SQD1_like_SDR_e', NULL, NULL, NULL, 2),
(1269, NULL, 'cd18975', NULL, NULL, 'CD_MarY1_POL_like', NULL, 'CD_MarY1_POL_like', NULL, NULL, NULL, 2),
(1270, NULL, 'cd10911', NULL, NULL, 'PIN_LabA', NULL, 'PIN_LabA', NULL, NULL, NULL, 2),
(1271, NULL, 'cd06524', NULL, NULL, 'GH25_YegX-like', NULL, 'GH25_YegX-like', NULL, NULL, NULL, 2),
(1272, NULL, 'cd03022', NULL, NULL, 'DsbA_HCCA_Iso', NULL, 'DsbA_HCCA_Iso', NULL, NULL, 34895, 2),
(1273, NULL, 'cd00538', NULL, NULL, 'PA', NULL, 'PA', NULL, NULL, NULL, 2),
(1274, NULL, 'cd12139', NULL, NULL, 'SH3_Bin1', NULL, 'SH3_Bin1', NULL, NULL, 15243, 2),
(1275, NULL, 'cd13178', NULL, NULL, 'RanBD4_RanBP2-like', NULL, 'RanBD4_RanBP2-like', NULL, NULL, NULL, 2),
(1276, NULL, 'cd06006', NULL, NULL, 'R3H_unknown_2', NULL, 'R3H_unknown_2', NULL, NULL, 33307, 2),
(1277, NULL, 'cd12356', NULL, NULL, 'RRM_PPARGC1B', NULL, 'RRM_PPARGC1B', NULL, NULL, 5822, 2),
(1278, NULL, 'cd05326', NULL, NULL, 'secoisolariciresinol-DH_like_SDR_c', NULL, 'secoisolariciresinol-DH_like_SDR_c', NULL, NULL, 37212, 2),
(1279, NULL, 'cd07905', NULL, NULL, 'Adenylation_DNA_ligase_LigC', NULL, 'Adenylation_DNA_ligase_LigC', NULL, NULL, 35408, 2),
(1280, NULL, 'cd02576', NULL, NULL, 'PseudoU_synth_ScPUS7', NULL, 'PseudoU_synth_ScPUS7', NULL, NULL, NULL, 2),
(1281, NULL, 'cd14962', NULL, NULL, 'NHL_like_6', NULL, 'NHL_like_6', NULL, NULL, NULL, 2),
(1282, NULL, 'cd02636', NULL, NULL, 'R3H_sperm-antigen', NULL, 'R3H_sperm-antigen', NULL, NULL, 12579, 2),
(1283, NULL, 'cd09598', NULL, NULL, 'M4_like', NULL, 'M4_like', NULL, NULL, NULL, 2),
(1284, NULL, 'cd17361', NULL, NULL, 'MFS_STP', NULL, 'MFS_STP', NULL, NULL, 34503, 2),
(1285, NULL, 'cd10562', NULL, NULL, 'FDH_b_like', NULL, 'FDH_b_like', NULL, NULL, NULL, 2),
(1286, NULL, 'cd09573', NULL, NULL, 'SAM_STIM1', NULL, 'SAM_STIM1', NULL, NULL, 30611, 2),
(1287, NULL, 'cd15344', NULL, NULL, '7tmA_LPAR1_Edg2', NULL, '7tmA_LPAR1_Edg2', NULL, NULL, 191, 2),
(1288, NULL, 'cd08991', NULL, NULL, 'GH43_HoAraf43-like', NULL, 'GH43_HoAraf43-like', NULL, NULL, NULL, 2),
(1289, NULL, 'cd04400', NULL, NULL, 'RhoGAP_fBEM3', NULL, 'RhoGAP_fBEM3', NULL, NULL, NULL, 2),
(1290, NULL, 'cd18566', NULL, NULL, 'ABC_6TM_PrtD_LapB_HlyB_like', NULL, 'ABC_6TM_PrtD_LapB_HlyB_like', NULL, NULL, NULL, 2),
(1291, NULL, 'cd08681', NULL, NULL, 'C2_fungal_Inn1p-like', NULL, 'C2_fungal_Inn1p-like', NULL, NULL, 32833, 2),
(1292, NULL, 'cd09579', NULL, NULL, 'SAM_Samd7,11', NULL, 'SAM_Samd7,11', NULL, NULL, NULL, 2),
(1293, NULL, 'cd19045', NULL, NULL, 'LGIC_ECD_GABAAR_G3', NULL, 'LGIC_ECD_GABAAR_G3', NULL, NULL, NULL, 2),
(1294, NULL, 'cd12573', NULL, NULL, 'RRM2_MSI2', NULL, 'RRM2_MSI2', NULL, NULL, NULL, 2),
(1295, NULL, 'cd02235', NULL, NULL, 'cupin_BLL4011-like', NULL, 'cupin_BLL4011-like', NULL, NULL, NULL, 2),
(1296, NULL, 'cd04459', NULL, NULL, 'Rho_CSD', NULL, 'Rho_CSD', NULL, NULL, 11297, 2),
(1297, NULL, 'cd07992', NULL, NULL, 'LPLAT_AAK14816-like', NULL, 'LPLAT_AAK14816-like', NULL, NULL, NULL, 2),
(1298, NULL, 'cd01785', NULL, NULL, 'RA_PDZ-GEF1', NULL, 'RA_PDZ-GEF1', NULL, NULL, NULL, 2),
(1299, NULL, 'cd18055', NULL, NULL, 'DEXHc_CHD3', NULL, 'DEXHc_CHD3', NULL, NULL, NULL, 2),
(1300, NULL, 'cd12323', NULL, NULL, 'RRM2_MSI', NULL, 'RRM2_MSI', NULL, NULL, 6484, 2),
(1301, NULL, 'cd19011', NULL, NULL, 'LGIC_ECD_5-HT3A', NULL, 'LGIC_ECD_5-HT3A', NULL, NULL, NULL, 2);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(1302, NULL, 'cd19550', NULL, NULL, 'serpinA2_PIL', NULL, 'serpinA2_PIL', NULL, NULL, NULL, 2),
(1303, NULL, 'cd03268', NULL, NULL, 'ABC_BcrA_bacitracin_resist', NULL, 'ABC_BcrA_bacitracin_resist', NULL, NULL, NULL, 2),
(1304, NULL, 'cd07551', NULL, NULL, 'P-type_ATPase_HM_ZosA_PfeT-like', NULL, 'P-type_ATPase_HM_ZosA_PfeT-like', NULL, NULL, NULL, 2),
(1305, NULL, 'cd07611', NULL, NULL, 'BAR_Amphiphysin_I_II', NULL, 'BAR_Amphiphysin_I_II', NULL, NULL, NULL, 2),
(1306, NULL, 'cd14872', NULL, NULL, 'MYSc_Myo4', NULL, 'MYSc_Myo4', NULL, NULL, NULL, 2),
(1307, NULL, 'cd14523', NULL, NULL, 'DSP_DUSP19', NULL, 'DSP_DUSP19', NULL, NULL, NULL, 2),
(1308, NULL, 'cd11303', NULL, NULL, 'Dystroglycan_repeat', NULL, 'Dystroglycan_repeat', NULL, NULL, NULL, 2),
(1309, NULL, 'cd16236', NULL, NULL, 'EFh_SPARC_SPARCL1', NULL, 'EFh_SPARC_SPARCL1', NULL, NULL, NULL, 2),
(1310, NULL, 'cd16796', NULL, NULL, 'RING-H2_RNF13', NULL, 'RING-H2_RNF13', NULL, NULL, NULL, 2),
(1311, NULL, 'cd17088', NULL, NULL, 'FERM_F1_FRMPD1_like', NULL, 'FERM_F1_FRMPD1_like', NULL, NULL, NULL, 2),
(1312, NULL, 'cd14792', NULL, NULL, 'GH27', NULL, 'GH27', NULL, NULL, 5507, 2),
(1313, NULL, 'cd17706', NULL, NULL, 'MCM', NULL, 'MCM', NULL, NULL, NULL, 2),
(1314, NULL, 'cd06370', NULL, NULL, 'PBP1_SAP_GC-like', NULL, 'PBP1_SAP_GC-like', NULL, NULL, NULL, 2),
(1315, NULL, 'cd04112', NULL, NULL, 'Rab26', NULL, 'Rab26', NULL, NULL, NULL, 2),
(1316, NULL, 'cd06856', NULL, NULL, 'GT_GPT_archaea', NULL, 'GT_GPT_archaea', NULL, NULL, NULL, 2),
(1317, NULL, 'cd10490', NULL, NULL, 'MH1_SMAD_1_5_9', NULL, 'MH1_SMAD_1_5_9', NULL, NULL, NULL, 2),
(1318, NULL, 'cd03194', NULL, NULL, 'GST_C_3', NULL, 'GST_C_3', NULL, NULL, NULL, 2),
(1319, NULL, 'cd12798', NULL, NULL, 'Alt_A1', NULL, 'Alt_A1', NULL, NULL, NULL, 2),
(1320, NULL, 'cd14118', NULL, NULL, 'STKc_CAMKK', NULL, 'STKc_CAMKK', NULL, NULL, NULL, 2),
(1321, NULL, 'cd12650', NULL, NULL, 'RRM1_Hu', NULL, 'RRM1_Hu', NULL, NULL, 21672, 2),
(1322, NULL, 'cd12282', NULL, NULL, 'RRM2_TatSF1_like', NULL, 'RRM2_TatSF1_like', NULL, NULL, NULL, 2),
(1323, NULL, 'cd11806', NULL, NULL, 'SH3_PRMT2', NULL, 'SH3_PRMT2', NULL, NULL, NULL, 2),
(1324, NULL, 'cd07007', NULL, NULL, 'cupin_CapF-like_C', NULL, 'cupin_CapF-like_C', NULL, NULL, NULL, 2),
(1325, NULL, 'cd12145', NULL, NULL, 'Rev1_C', NULL, 'Rev1_C', NULL, NULL, NULL, 2),
(1326, NULL, 'cd21654', NULL, NULL, 'embe-merbe_CoV_ORF8b_protein-I-like', NULL, 'embe-merbe_CoV_ORF8b_protein-I-like', NULL, NULL, NULL, 2),
(1327, NULL, 'cd00015', NULL, NULL, 'ALBUMIN', NULL, 'ALBUMIN', NULL, NULL, 12292, 2),
(1328, NULL, 'cd14731', NULL, NULL, 'LodA_like_1', NULL, 'LodA_like_1', NULL, NULL, 30459, 2),
(1329, NULL, 'cd13553', NULL, NULL, 'PBP2_NrtA_CpmA_like', NULL, 'PBP2_NrtA_CpmA_like', NULL, NULL, 34734, 2),
(1330, NULL, 'cd17193', NULL, NULL, 'FERM_F1_PTPN3', NULL, 'FERM_F1_PTPN3', NULL, NULL, NULL, 2),
(1331, NULL, 'cd00446', NULL, NULL, 'GrpE', NULL, 'GrpE', NULL, NULL, 3633, 2),
(1332, NULL, 'cd15569', NULL, NULL, 'PHD_RAG2', NULL, 'PHD_RAG2', NULL, NULL, 26287, 2),
(1333, NULL, 'cd17156', NULL, NULL, 'DCX1_DCDC5', NULL, 'DCX1_DCDC5', NULL, NULL, NULL, 2),
(1334, NULL, 'cd05762', NULL, NULL, 'Ig8_hMLCK_like', NULL, 'Ig8_hMLCK_like', NULL, NULL, NULL, 2),
(1335, NULL, 'cd07681', NULL, NULL, 'F-BAR_PACSIN3', NULL, 'F-BAR_PACSIN3', NULL, NULL, NULL, 2),
(1336, NULL, 'cd16338', NULL, NULL, 'CpcT', NULL, 'CpcT', NULL, NULL, 9465, 2),
(1337, NULL, 'cd09500', NULL, NULL, 'SAM_AIDA1AB-like_repeat2', NULL, 'SAM_AIDA1AB-like_repeat2', NULL, NULL, 30049, 2),
(1338, NULL, 'cd08541', NULL, NULL, 'SAM_PNT-FLI-1', NULL, 'SAM_PNT-FLI-1', NULL, NULL, 33168, 2),
(1339, NULL, 'cd19388', NULL, NULL, 'TGF_beta_GDF8', NULL, 'TGF_beta_GDF8', NULL, NULL, NULL, 2),
(1340, NULL, 'cd10238', NULL, NULL, 'HSPA14-like_NBD', NULL, 'HSPA14-like_NBD', NULL, NULL, 30229, 2),
(1341, NULL, 'cd16189', NULL, NULL, 'EFh_PEF_CAPN1_like', NULL, 'EFh_PEF_CAPN1_like', NULL, NULL, NULL, 2),
(1342, NULL, 'cd07469', NULL, NULL, 'CRD_TK_ROR_related', NULL, 'CRD_TK_ROR_related', NULL, NULL, NULL, 2),
(1343, NULL, 'cd11318', NULL, NULL, 'AmyAc_bac_fung_AmyA', NULL, 'AmyAc_bac_fung_AmyA', NULL, NULL, NULL, 2);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(1344, NULL, 'cd12424', NULL, NULL, 'RRM3_hnRNPL_like', NULL, 'RRM3_hnRNPL_like', NULL, NULL, NULL, 2),
(1345, NULL, 'cd05827', NULL, NULL, 'Sortase_C', NULL, 'Sortase_C', NULL, NULL, 30944, 2),
(1346, NULL, 'cd06945', NULL, NULL, 'NR_LBD_Nurr1_like', NULL, 'NR_LBD_Nurr1_like', NULL, NULL, NULL, 2),
(1347, NULL, 'cd01260', NULL, NULL, 'PH_CNK_mammalian-like', NULL, 'PH_CNK_mammalian-like', NULL, NULL, NULL, 2),
(1348, NULL, 'cd01675', NULL, NULL, 'RNR_III', NULL, 'RNR_III', NULL, NULL, 12910, 2),
(1349, NULL, 'cd05780', NULL, NULL, 'DNA_polB_Kod1_like_exo', NULL, 'DNA_polB_Kod1_like_exo', NULL, NULL, NULL, 2),
(1350, NULL, 'cd14824', NULL, NULL, 'Longin', NULL, 'Longin', NULL, NULL, 5394, 2),
(1351, NULL, 'cd01423', NULL, NULL, 'MGS_CPS_I_III', NULL, 'MGS_CPS_I_III', NULL, NULL, NULL, 2),
(1352, NULL, 'cd13935', NULL, NULL, 'RNase_H_bacteria_like', NULL, 'RNase_H_bacteria_like', NULL, NULL, NULL, 2),
(1353, NULL, 'cd17790', NULL, NULL, '7tmA_mAChR_M1', NULL, '7tmA_mAChR_M1', NULL, NULL, NULL, 2),
(1354, NULL, 'cd05735', NULL, NULL, 'Ig_DSCAM', NULL, 'Ig_DSCAM', NULL, NULL, NULL, 2),
(1355, NULL, 'cd04226', NULL, NULL, 'CuRO_1_FV_like', NULL, 'CuRO_1_FV_like', NULL, NULL, NULL, 2),
(1356, NULL, 'cd12464', NULL, NULL, 'RRM_G3BP2', NULL, 'RRM_G3BP2', NULL, NULL, 5570, 2),
(1357, NULL, 'cd19738', NULL, NULL, 'bHLH-PAS_SIM1', NULL, 'bHLH-PAS_SIM1', NULL, NULL, NULL, 2),
(1358, NULL, 'cd03586', NULL, NULL, 'PolY_Pol_IV_kappa', NULL, 'PolY_Pol_IV_kappa', NULL, NULL, 17120, 2),
(1359, NULL, 'cd14379', NULL, NULL, 'UBA1_Rad23_plant', NULL, 'UBA1_Rad23_plant', NULL, NULL, NULL, 2),
(1360, NULL, 'cd00659', NULL, NULL, 'Topo_IB_C', NULL, 'Topo_IB_C', NULL, NULL, 11648, 2),
(1361, NULL, 'cd14143', NULL, NULL, 'STKc_TGFbR1_ACVR1b_ACVR1c', NULL, 'STKc_TGFbR1_ACVR1b_ACVR1c', NULL, NULL, NULL, 2),
(1362, NULL, 'cd02644', NULL, NULL, 'R3H_jag', NULL, 'R3H_jag', NULL, NULL, 26656, 2),
(1363, NULL, 'cd09752', NULL, NULL, 'Cas5_I-C', NULL, 'Cas5_I-C', NULL, NULL, NULL, 2),
(1364, NULL, 'cd09991', NULL, NULL, 'HDAC_classI', NULL, 'HDAC_classI', NULL, NULL, NULL, 2),
(1365, NULL, 'cd14683', NULL, NULL, 'PH-EXOC1', NULL, 'PH-EXOC1', NULL, NULL, NULL, 2),
(1366, NULL, 'cd00468', NULL, NULL, 'HIT_like', NULL, 'HIT_like', NULL, NULL, NULL, 2),
(1367, NULL, 'cd18002', NULL, NULL, 'DEXQc_INO80', NULL, 'DEXQc_INO80', NULL, NULL, NULL, 2),
(1368, NULL, 'cd07094', NULL, NULL, 'ALDH_F21_LactADH-like', NULL, 'ALDH_F21_LactADH-like', NULL, NULL, NULL, 2),
(1369, NULL, 'cd07508', NULL, NULL, 'HAD_Pase_UmpH-like', NULL, 'HAD_Pase_UmpH-like', NULL, NULL, NULL, 2),
(1370, NULL, 'cd19743', NULL, NULL, 'bHLH_TS_ASCL2_Mash2', NULL, 'bHLH_TS_ASCL2_Mash2', NULL, NULL, NULL, 2),
(1371, NULL, 'cd05657', NULL, NULL, 'M42_glucanase_like', NULL, 'M42_glucanase_like', NULL, NULL, NULL, 2),
(1372, NULL, 'cd16133', NULL, NULL, 'RA_RASSF9', NULL, 'RA_RASSF9', NULL, NULL, NULL, 2),
(1373, NULL, 'cd15587', NULL, NULL, 'PHD_Yng1p_like', NULL, 'PHD_Yng1p_like', NULL, NULL, NULL, 2),
(1374, NULL, 'cd05992', NULL, NULL, 'PB1', NULL, 'PB1', NULL, NULL, NULL, 2),
(1375, NULL, 'cd10414', NULL, NULL, 'SH2_Grb14', NULL, 'SH2_Grb14', NULL, NULL, 28209, 2),
(1376, NULL, 'cd01371', NULL, NULL, 'KISc_KIF3', NULL, 'KISc_KIF3', NULL, NULL, NULL, 2),
(1377, NULL, 'cd07976', NULL, NULL, 'TFIIA_alpha_beta_like', NULL, 'TFIIA_alpha_beta_like', NULL, NULL, NULL, 2),
(1378, NULL, 'cd13243', NULL, NULL, 'PH_PLEKHG1_G2_G3', NULL, 'PH_PLEKHG1_G2_G3', NULL, NULL, 36627, 2),
(1379, NULL, 'cd04154', NULL, NULL, 'Arl2', NULL, 'Arl2', NULL, NULL, 37252, 2),
(1380, NULL, 'cd17417', NULL, NULL, 'MFS_NPF5', NULL, 'MFS_NPF5', NULL, NULL, 34940, 2),
(1381, NULL, 'cd01374', NULL, NULL, 'KISc_CENP_E', NULL, 'KISc_CENP_E', NULL, NULL, NULL, 2),
(1382, NULL, 'cd04151', NULL, NULL, 'Arl1', NULL, 'Arl1', NULL, NULL, NULL, 2),
(1383, NULL, 'cd14012', NULL, NULL, 'PK_eIF2AK_GCN2_rpt1', NULL, 'PK_eIF2AK_GCN2_rpt1', NULL, NULL, NULL, 2),
(1384, NULL, 'cd11448', NULL, NULL, 'bHLH_AtFAMA_like', NULL, 'bHLH_AtFAMA_like', NULL, NULL, NULL, 2),
(1385, NULL, 'cd08285', NULL, NULL, 'NADP_ADH', NULL, 'NADP_ADH', NULL, NULL, NULL, 2);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(1386, NULL, 'cd03413', NULL, NULL, 'CbiK_C', NULL, 'CbiK_C', NULL, NULL, NULL, 2),
(1387, NULL, 'cd14853', NULL, NULL, 'TRAPPC_longin-like', NULL, 'TRAPPC_longin-like', NULL, NULL, NULL, 2),
(1388, NULL, 'cd15509', NULL, NULL, 'PHD1_KMT2C_like', NULL, 'PHD1_KMT2C_like', NULL, NULL, NULL, 2),
(1389, NULL, 'cd19040', NULL, NULL, 'LGIC_ECD_GABAAR_B1', NULL, 'LGIC_ECD_GABAAR_B1', NULL, NULL, NULL, 2),
(1390, NULL, 'cd21591', NULL, NULL, 'SARS-CoV-like_RdRp', NULL, 'SARS-CoV-like_RdRp', NULL, NULL, 33511, 2),
(1391, NULL, 'cd16278', NULL, NULL, 'metallo-hydrolase-like_MBL-fold', NULL, 'metallo-hydrolase-like_MBL-fold', NULL, NULL, NULL, 2),
(1392, NULL, 'cd06292', NULL, NULL, 'PBP1_AglR_RafR-like', NULL, 'PBP1_AglR_RafR-like', NULL, NULL, NULL, 2),
(1393, NULL, 'cd15624', NULL, NULL, 'PHD_TIF1gamma', NULL, 'PHD_TIF1gamma', NULL, NULL, NULL, 2),
(1394, NULL, 'cd13422', NULL, NULL, 'TNFRSF5_teleost', NULL, 'TNFRSF5_teleost', NULL, NULL, 13770, 2),
(1395, NULL, 'cd01616', NULL, NULL, 'TGS', NULL, 'TGS', NULL, NULL, NULL, 2),
(1396, NULL, 'cd11908', NULL, NULL, 'SH3_ITK', NULL, 'SH3_ITK', NULL, NULL, 33065, 2),
(1397, NULL, 'cd18281', NULL, NULL, 'BTB_POZ_BTBD1_2', NULL, 'BTB_POZ_BTBD1_2', NULL, NULL, NULL, 2),
(1398, NULL, 'cd12642', NULL, NULL, 'RRM_TRA2A', NULL, 'RRM_TRA2A', NULL, NULL, NULL, 2),
(1399, NULL, 'cd17020', NULL, NULL, 'T3SC_IA_ShcM-like', NULL, 'T3SC_IA_ShcM-like', NULL, NULL, NULL, 2),
(1400, NULL, 'cd05759', NULL, NULL, 'Ig2_KIRREL3-like', NULL, 'Ig2_KIRREL3-like', NULL, NULL, NULL, 2),
(1401, NULL, 'cd16864', NULL, NULL, 'ARID_JARID', NULL, 'ARID_JARID', NULL, NULL, NULL, 2),
(1402, NULL, 'cd08793', NULL, NULL, 'Death_IRAK4', NULL, 'Death_IRAK4', NULL, NULL, 27461, 2),
(1403, NULL, 'cd12303', NULL, NULL, 'RRM_spSet1p_like', NULL, 'RRM_spSet1p_like', NULL, NULL, NULL, 2),
(1404, NULL, 'cd05039', NULL, NULL, 'PTKc_Csk_like', NULL, 'PTKc_Csk_like', NULL, NULL, NULL, 2),
(1405, NULL, 'cd15823', NULL, NULL, 'SPRY_PRY_TRIM6', NULL, 'SPRY_PRY_TRIM6', NULL, NULL, 31242, 2),
(1406, NULL, 'cd05856', NULL, NULL, 'Ig2_FGFRL1-like', NULL, 'Ig2_FGFRL1-like', NULL, NULL, NULL, 2),
(1407, NULL, 'cd09360', NULL, NULL, 'LIM_ALP_like', NULL, 'LIM_ALP_like', NULL, NULL, NULL, 2),
(1408, NULL, 'cd07296', NULL, NULL, 'PX_PLD1', NULL, 'PX_PLD1', NULL, NULL, NULL, 2),
(1409, NULL, 'cd14452', NULL, NULL, 'CuRO_1_FVIII_like', NULL, 'CuRO_1_FVIII_like', NULL, NULL, NULL, 2),
(1410, NULL, 'cd09384', NULL, NULL, 'LIM1_LMO2', NULL, 'LIM1_LMO2', NULL, NULL, NULL, 2),
(1411, NULL, 'cd09434', NULL, NULL, 'LIM4_FHL3', NULL, 'LIM4_FHL3', NULL, NULL, NULL, 2),
(1412, NULL, 'cd04337', NULL, NULL, 'Rieske_RO_Alpha_Cao', NULL, 'Rieske_RO_Alpha_Cao', NULL, NULL, NULL, 2),
(1413, NULL, 'cd07846', NULL, NULL, 'STKc_CDKL2_3', NULL, 'STKc_CDKL2_3', NULL, NULL, NULL, 2),
(1414, NULL, 'cd11433', NULL, NULL, 'bHLH-PAS_HIF', NULL, 'bHLH-PAS_HIF', NULL, NULL, NULL, 2),
(1415, NULL, 'cd19399', NULL, NULL, 'TGF_beta_GDF5', NULL, 'TGF_beta_GDF5', NULL, NULL, NULL, 2),
(1416, NULL, 'cd16688', NULL, NULL, 'RING-H2_Vps11', NULL, 'RING-H2_Vps11', NULL, NULL, NULL, 2),
(1417, NULL, 'cd09626', NULL, NULL, 'DOMON_glucodextranase_like', NULL, 'DOMON_glucodextranase_like', NULL, NULL, NULL, 2),
(1418, NULL, 'cd06646', NULL, NULL, 'STKc_MAP4K5', NULL, 'STKc_MAP4K5', NULL, NULL, NULL, 2),
(1419, NULL, 'cd01482', NULL, NULL, 'vWA_collagen_alphaI-XII-like', NULL, 'vWA_collagen_alphaI-XII-like', NULL, NULL, NULL, 2),
(1420, NULL, 'cd11695', NULL, NULL, 'DHR2_DOCK_C', NULL, 'DHR2_DOCK_C', NULL, NULL, NULL, 2),
(1421, NULL, 'cd18419', NULL, NULL, 'BTB_POZ_KCND3', NULL, 'BTB_POZ_KCND3', NULL, NULL, NULL, 2),
(1422, NULL, 'cd13115', NULL, NULL, 'POLO_box_Plk4_2', NULL, 'POLO_box_Plk4_2', NULL, NULL, 28109, 2),
(1423, NULL, 'cd18256', NULL, NULL, 'BTB_POZ_KLHL27_IPP', NULL, 'BTB_POZ_KLHL27_IPP', NULL, NULL, NULL, 2),
(1424, NULL, 'cd00613', NULL, NULL, 'GDC-P', NULL, 'GDC-P', NULL, NULL, 19057, 2),
(1425, NULL, 'cd17967', NULL, NULL, 'DEADc_DDX3_DDX4', NULL, 'DEADc_DDX3_DDX4', NULL, NULL, 34091, 2),
(1426, NULL, 'cd20294', NULL, NULL, 'cupin_KduI_N', NULL, 'cupin_KduI_N', NULL, NULL, NULL, 2);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(1427, NULL, 'cd05840', NULL, NULL, 'SPBC215_ISWI_like', NULL, 'SPBC215_ISWI_like', NULL, NULL, 17764, 2),
(1428, NULL, 'cd12399', NULL, NULL, 'RRM_HP0827_like', NULL, 'RRM_HP0827_like', NULL, NULL, NULL, 2),
(1429, NULL, 'cd07535', NULL, NULL, 'HAD_VSP', NULL, 'HAD_VSP', NULL, NULL, NULL, 2),
(1430, NULL, 'cd19825', NULL, NULL, 'Bbox2_TRIM3_C-VII', NULL, 'Bbox2_TRIM3_C-VII', NULL, NULL, NULL, 2),
(1431, NULL, 'cd15797', NULL, NULL, 'PMEI', NULL, 'PMEI', NULL, NULL, 11331, 2),
(1432, NULL, 'cd11421', NULL, NULL, 'bHLH_TS_ATOH8', NULL, 'bHLH_TS_ATOH8', NULL, NULL, NULL, 2),
(1433, NULL, 'cd14533', NULL, NULL, 'PTP-MTMR3-like', NULL, 'PTP-MTMR3-like', NULL, NULL, NULL, 2),
(1434, NULL, 'cd20249', NULL, NULL, 'Hemotin', NULL, 'Hemotin', NULL, NULL, NULL, 2),
(1435, NULL, 'cd08606', NULL, NULL, 'GDPD_YPL110cp_fungi', NULL, 'GDPD_YPL110cp_fungi', NULL, NULL, NULL, 2),
(1436, NULL, 'cd16642', NULL, NULL, 'mRING-HC-C3HC3D_TRAF5', NULL, 'mRING-HC-C3HC3D_TRAF5', NULL, NULL, NULL, 2),
(1437, NULL, 'cd00060', NULL, NULL, 'FHA', NULL, 'FHA', NULL, NULL, 4899, 2),
(1438, NULL, 'cd12397', NULL, NULL, 'RRM2_Nop13p_fungi', NULL, 'RRM2_Nop13p_fungi', NULL, NULL, 30782, 2),
(1439, NULL, 'cd03575', NULL, NULL, 'NTR_WFIKKN', NULL, 'NTR_WFIKKN', NULL, NULL, NULL, 2),
(1440, NULL, 'cd17220', NULL, NULL, 'RA_RASSF5', NULL, 'RA_RASSF5', NULL, NULL, NULL, 2),
(1441, NULL, 'cd08038', NULL, NULL, 'LARP_2', NULL, 'LARP_2', NULL, NULL, NULL, 2),
(1442, NULL, 'cd04778', NULL, NULL, 'HTH_MerR-like_sg2', NULL, 'HTH_MerR-like_sg2', NULL, NULL, NULL, 2),
(1443, NULL, 'cd05726', NULL, NULL, 'Ig4_Robo', NULL, 'Ig4_Robo', NULL, NULL, NULL, 2),
(1444, NULL, 'cd04458', NULL, NULL, 'CSP_CDS', NULL, 'CSP_CDS', NULL, NULL, 1455, 2),
(1445, NULL, 'cd12015', NULL, NULL, 'SH3_Tks_1', NULL, 'SH3_Tks_1', NULL, NULL, NULL, 2),
(1446, NULL, 'cd16267', NULL, NULL, 'HBS1-like_II', NULL, 'HBS1-like_II', NULL, NULL, NULL, 2),
(1447, NULL, 'cd01892', NULL, NULL, 'Miro2', NULL, 'Miro2', NULL, NULL, NULL, 2),
(1448, NULL, 'cd19837', NULL, NULL, 'Bbox1_MID2_C-I', NULL, 'Bbox1_MID2_C-I', NULL, NULL, NULL, 2),
(1449, NULL, 'cd12428', NULL, NULL, 'RRM_PARN', NULL, 'RRM_PARN', NULL, NULL, NULL, 2),
(1450, NULL, 'cd07749', NULL, NULL, 'NT_Pol-beta-like_1', NULL, 'NT_Pol-beta-like_1', NULL, NULL, NULL, 2),
(1451, NULL, 'cd16589', NULL, NULL, 'RING-HC_TRIM71_C-VII', NULL, 'RING-HC_TRIM71_C-VII', NULL, NULL, NULL, 2),
(1452, NULL, 'cd14401', NULL, NULL, 'UBA_HERC1', NULL, 'UBA_HERC1', NULL, NULL, NULL, 2),
(1453, NULL, 'cd09708', NULL, NULL, 'Csf4_U', NULL, 'Csf4_U', NULL, NULL, NULL, 2),
(1454, NULL, 'cd05958', NULL, NULL, 'ABCL', NULL, 'ABCL', NULL, NULL, NULL, 2),
(1455, NULL, 'cd09978', NULL, NULL, 'LOTUS_2_Limkain_b1', NULL, 'LOTUS_2_Limkain_b1', NULL, NULL, NULL, 2),
(1456, NULL, 'cd02843', NULL, NULL, 'PAZ_dicer_like', NULL, 'PAZ_dicer_like', NULL, NULL, NULL, 2),
(1457, NULL, 'cd00119', NULL, NULL, 'LYZ', NULL, 'LYZ', NULL, NULL, NULL, 2),
(1458, NULL, 'cd14939', NULL, NULL, '7tmD_STE2', NULL, '7tmD_STE2', NULL, NULL, NULL, 2),
(1459, NULL, 'cd08181', NULL, NULL, 'PPD-like', NULL, 'PPD-like', NULL, NULL, NULL, 2),
(1460, NULL, 'cd14335', NULL, NULL, 'UBA_SnRK1_plant', NULL, 'UBA_SnRK1_plant', NULL, NULL, NULL, 2),
(1461, NULL, 'cd14590', NULL, NULL, 'PTP-MTMR2', NULL, 'PTP-MTMR2', NULL, NULL, NULL, 2),
(1462, NULL, 'cd09525', NULL, NULL, 'SAM_GAREM', NULL, 'SAM_GAREM', NULL, NULL, NULL, 2),
(1463, NULL, 'cd01227', NULL, NULL, 'PH_Dbs', NULL, 'PH_Dbs', NULL, NULL, 28245, 2),
(1464, NULL, 'cd02932', NULL, NULL, 'OYE_YqiM_FMN', NULL, 'OYE_YqiM_FMN', NULL, NULL, 33714, 2),
(1465, NULL, 'cd01802', NULL, NULL, 'Ubl_ZFAND4', NULL, 'Ubl_ZFAND4', NULL, NULL, NULL, 2),
(1466, NULL, 'cd09506', NULL, NULL, 'SAM_Shank1,2,3', NULL, 'SAM_Shank1,2,3', NULL, NULL, NULL, 2),
(1467, NULL, 'cd18300', NULL, NULL, 'BTB2_POZ_RhoBTB', NULL, 'BTB2_POZ_RhoBTB', NULL, NULL, NULL, 2),
(1468, NULL, 'cd18107', NULL, NULL, 'SpoU-like_AviRb', NULL, 'SpoU-like_AviRb', NULL, NULL, NULL, 2),
(1469, NULL, 'cd14393', NULL, NULL, 'UBA_c-Cbl', NULL, 'UBA_c-Cbl', NULL, NULL, NULL, 2);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(1470, NULL, 'cd13971', NULL, NULL, 'ADCK2-like', NULL, 'ADCK2-like', NULL, NULL, 35432, 2),
(1471, NULL, 'cd15514', NULL, NULL, 'PHD6_KMT2C_like', NULL, 'PHD6_KMT2C_like', NULL, NULL, NULL, 2),
(1472, NULL, 'cd06562', NULL, NULL, 'GH20_HexA_HexB-like', NULL, 'GH20_HexA_HexB-like', NULL, NULL, NULL, 2),
(1473, NULL, 'cd07532', NULL, NULL, 'HAD_PNPase_UmpH-like', NULL, 'HAD_PNPase_UmpH-like', NULL, NULL, NULL, 2),
(1474, NULL, 'cd04822', NULL, NULL, 'PA_M28_1_3', NULL, 'PA_M28_1_3', NULL, NULL, NULL, 2),
(1475, NULL, 'cd16473', NULL, NULL, 'RING-H2_RNF103', NULL, 'RING-H2_RNF103', NULL, NULL, NULL, 2),
(1476, NULL, 'cd17153', NULL, NULL, 'DCX2_DCDC2B', NULL, 'DCX2_DCDC2B', NULL, NULL, NULL, 2),
(1477, NULL, 'cd17465', NULL, NULL, 'MFS_MCT8', NULL, 'MFS_MCT8', NULL, NULL, NULL, 2),
(1478, NULL, 'cd09537', NULL, NULL, 'SAM_CP2-like', NULL, 'SAM_CP2-like', NULL, NULL, NULL, 2),
(1479, NULL, 'cd06940', NULL, NULL, 'NR_LBD_REV_ERB', NULL, 'NR_LBD_REV_ERB', NULL, NULL, NULL, 2),
(1480, NULL, 'cd03089', NULL, NULL, 'PMM_PGM', NULL, 'PMM_PGM', NULL, NULL, NULL, 2),
(1481, NULL, 'cd07613', NULL, NULL, 'BAR_Endophilin_A1', NULL, 'BAR_Endophilin_A1', NULL, NULL, NULL, 2),
(1482, NULL, 'cd19985', NULL, NULL, 'PBP1_ABC_HAAT-like', NULL, 'PBP1_ABC_HAAT-like', NULL, NULL, NULL, 2),
(1483, NULL, 'cd06820', NULL, NULL, 'PLPDE_III_LS_D-TA_like', NULL, 'PLPDE_III_LS_D-TA_like', NULL, NULL, NULL, 2),
(1484, NULL, 'cd05723', NULL, NULL, 'Ig4_Neogenin', NULL, 'Ig4_Neogenin', NULL, NULL, NULL, 2),
(1485, NULL, 'cd14059', NULL, NULL, 'STKc_MAP3K12_13', NULL, 'STKc_MAP3K12_13', NULL, NULL, NULL, 2),
(1486, NULL, 'cd18516', NULL, NULL, 'BACK_KLHL40_KBTBD5', NULL, 'BACK_KLHL40_KBTBD5', NULL, NULL, NULL, 2),
(1487, NULL, 'cd00826', NULL, NULL, 'nondecarbox_cond_enzymes', NULL, 'nondecarbox_cond_enzymes', NULL, NULL, NULL, 2),
(1488, NULL, 'cd03360', NULL, NULL, 'LbH_AT_putative', NULL, 'LbH_AT_putative', NULL, NULL, 11686, 2),
(1489, NULL, 'cd15135', NULL, NULL, '7tmA_GPR39', NULL, '7tmA_GPR39', NULL, NULL, NULL, 2),
(1490, NULL, 'cd03895', NULL, NULL, 'M20_ArgE_DapE-like', NULL, 'M20_ArgE_DapE-like', NULL, NULL, 32396, 2),
(1491, NULL, 'cd15215', NULL, NULL, '7tmA_GPR101', NULL, '7tmA_GPR101', NULL, NULL, NULL, 2),
(1492, NULL, 'cd06108', NULL, NULL, 'Ec2MCS_like', NULL, 'Ec2MCS_like', NULL, NULL, NULL, 2),
(1493, NULL, 'cd08232', NULL, NULL, 'idonate-5-DH', NULL, 'idonate-5-DH', NULL, NULL, NULL, 2),
(1494, NULL, 'cd10146', NULL, NULL, 'LabA_like_C', NULL, 'LabA_like_C', NULL, NULL, NULL, 2),
(1495, NULL, 'cd18432', NULL, NULL, 'BRCT_PAXIP1_rpt6_like', NULL, 'BRCT_PAXIP1_rpt6_like', NULL, NULL, NULL, 2),
(1496, NULL, 'cd03033', NULL, NULL, 'ArsC_15kD', NULL, 'ArsC_15kD', NULL, NULL, 6741, 2),
(1497, NULL, 'cd17673', NULL, NULL, 'MDM4', NULL, 'MDM4', NULL, NULL, NULL, 2),
(1498, NULL, 'cd13901', NULL, NULL, 'CuRO_3_MaLCC_like', NULL, 'CuRO_3_MaLCC_like', NULL, NULL, NULL, 2),
(1499, NULL, 'cd12416', NULL, NULL, 'RRM4_RBM28_like', NULL, 'RRM4_RBM28_like', NULL, NULL, NULL, 2),
(1500, NULL, 'cd02394', NULL, NULL, 'vigilin_like_KH', NULL, 'vigilin_like_KH', NULL, NULL, NULL, 2),
(1501, NULL, 'cd01351', NULL, NULL, 'Aconitase', NULL, 'Aconitase', NULL, NULL, NULL, 2),
(1502, NULL, 'cd09604', NULL, NULL, 'M1_APN_like', NULL, 'M1_APN_like', NULL, NULL, NULL, 2),
(1503, NULL, 'cd03705', NULL, NULL, 'EF1_alpha_III', NULL, 'EF1_alpha_III', NULL, NULL, NULL, 2),
(1504, NULL, 'cd06622', NULL, NULL, 'PKc_PBS2_like', NULL, 'PKc_PBS2_like', NULL, NULL, NULL, 2),
(1505, NULL, 'cd19353', NULL, NULL, 'Wnt_Wnt9a', NULL, 'Wnt_Wnt9a', NULL, NULL, NULL, 2),
(1506, NULL, 'cd19818', NULL, NULL, 'Bbox1_ZBBX', NULL, 'Bbox1_ZBBX', NULL, NULL, NULL, 2),
(1507, NULL, 'cd08956', NULL, NULL, 'KR_3_FAS_SDR_x', NULL, 'KR_3_FAS_SDR_x', NULL, NULL, NULL, 2),
(1508, NULL, 'cd17507', NULL, NULL, 'GT28_Beta-DGS-like', NULL, 'GT28_Beta-DGS-like', NULL, NULL, NULL, 2),
(1509, NULL, 'cd05562', NULL, NULL, 'Peptidases_S53_like', NULL, 'Peptidases_S53_like', NULL, NULL, 22365, 2),
(1510, NULL, 'cd14755', NULL, NULL, 'GS_BA2291-HK-like', NULL, 'GS_BA2291-HK-like', NULL, NULL, NULL, 2);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(1511, NULL, 'cd07522', NULL, NULL, 'HAD_cN-II', NULL, 'HAD_cN-II', NULL, NULL, NULL, 2),
(1512, NULL, 'cd02130', NULL, NULL, 'PA_ScAPY_like', NULL, 'PA_ScAPY_like', NULL, NULL, NULL, 2),
(1513, NULL, 'cd15680', NULL, NULL, 'PHD_JADE2', NULL, 'PHD_JADE2', NULL, NULL, 31371, 2),
(1514, NULL, 'cd14805', NULL, NULL, 'Translin-like', NULL, 'Translin-like', NULL, NULL, NULL, 2),
(1515, NULL, 'cd17406', NULL, NULL, 'MFS_unc93A_like', NULL, 'MFS_unc93A_like', NULL, NULL, NULL, 2),
(1516, NULL, 'cd05486', NULL, NULL, 'Cathespin_E', NULL, 'Cathespin_E', NULL, NULL, NULL, 2),
(1517, NULL, 'cd13148', NULL, NULL, 'MATE_like_3', NULL, 'MATE_like_3', NULL, NULL, NULL, 2),
(1518, NULL, 'cd05297', NULL, NULL, 'GH4_alpha_glucosidase_galactosidase', NULL, 'GH4_alpha_glucosidase_galactosidase', NULL, NULL, NULL, 2),
(1519, NULL, 'cd14170', NULL, NULL, 'STKc_MAPKAPK2', NULL, 'STKc_MAPKAPK2', NULL, NULL, NULL, 2),
(1520, NULL, 'cd03670', NULL, NULL, 'ADPRase_NUDT9', NULL, 'ADPRase_NUDT9', NULL, NULL, NULL, 2),
(1521, NULL, 'cd14316', NULL, NULL, 'UBA2_UBAP1_like', NULL, 'UBA2_UBAP1_like', NULL, NULL, NULL, 2),
(1522, NULL, 'cd00303', NULL, NULL, 'retropepsin_like', NULL, 'retropepsin_like', NULL, NULL, NULL, 2),
(1523, NULL, 'cd11673', NULL, NULL, 'hemoglobin_linker_C', NULL, 'hemoglobin_linker_C', NULL, NULL, 25212, 2),
(1524, NULL, 'cd15226', NULL, NULL, '7tmA_OR4-like', NULL, '7tmA_OR4-like', NULL, NULL, NULL, 2),
(1525, NULL, 'cd08966', NULL, NULL, 'EcFpg-like_N', NULL, 'EcFpg-like_N', NULL, NULL, NULL, 2),
(1526, NULL, 'cd19834', NULL, NULL, 'Bbox2_BSPRY', NULL, 'Bbox2_BSPRY', NULL, NULL, NULL, 2),
(1527, NULL, 'cd11514', NULL, NULL, 'SLC6sbd_DAT1', NULL, 'SLC6sbd_DAT1', NULL, NULL, NULL, 2),
(1528, NULL, 'cd13975', NULL, NULL, 'PKc_Dusty', NULL, 'PKc_Dusty', NULL, NULL, NULL, 2),
(1529, NULL, 'cd06172', NULL, NULL, 'MFS_LacY', NULL, 'MFS_LacY', NULL, NULL, NULL, 2),
(1530, NULL, 'cd06319', NULL, NULL, 'PBP1_ABC_sugar_binding-like', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, NULL, 2),
(1531, NULL, 'cd08521', NULL, NULL, 'C2A_SLP', NULL, 'C2A_SLP', NULL, NULL, NULL, 2),
(1532, NULL, 'cd08880', NULL, NULL, 'RHO_alpha_C_ahdA1c-like', NULL, 'RHO_alpha_C_ahdA1c-like', NULL, NULL, 34050, 2),
(1533, NULL, 'cd18704', NULL, NULL, 'PIN_VapC-like', NULL, 'PIN_VapC-like', NULL, NULL, NULL, 2),
(1534, NULL, 'cd13338', NULL, NULL, 'FERM-like_C_SNX27', NULL, 'FERM-like_C_SNX27', NULL, NULL, 31946, 2),
(1535, NULL, 'cd00024', NULL, NULL, 'CD_CSD', NULL, 'CD_CSD', NULL, NULL, NULL, 2),
(1536, NULL, 'cd09623', NULL, NULL, 'DOMON_EBDH', NULL, 'DOMON_EBDH', NULL, NULL, 19880, 2),
(1537, NULL, 'cd04450', NULL, NULL, 'DEP_RGS7-like', NULL, 'DEP_RGS7-like', NULL, NULL, NULL, 2),
(1538, NULL, 'cd14314', NULL, NULL, 'UBA_II_E2_pyUCE_like', NULL, 'UBA_II_E2_pyUCE_like', NULL, NULL, NULL, 2),
(1539, NULL, 'cd17171', NULL, NULL, 'FERM_F0_TLN1', NULL, 'FERM_F0_TLN1', NULL, NULL, NULL, 2),
(1540, NULL, 'cd00094', NULL, NULL, 'HX', NULL, 'HX', NULL, NULL, 5678, 2),
(1541, NULL, 'cd17774', NULL, NULL, 'CBS_two-component_sensor_histidine_kinase_repeat2', NULL, 'CBS_two-component_sensor_histidine_kinase_repeat2', NULL, NULL, NULL, 2),
(1542, NULL, 'cd13319', NULL, NULL, 'PH_RARhoGAP', NULL, 'PH_RARhoGAP', NULL, NULL, NULL, 2),
(1543, NULL, 'cd01428', NULL, NULL, 'ADK', NULL, 'ADK', NULL, NULL, 174, 2),
(1544, NULL, 'cd14524', NULL, NULL, 'PTPMT1', NULL, 'PTPMT1', NULL, NULL, 34456, 2),
(1545, NULL, 'cd09107', NULL, NULL, 'PLDc_vPLD3_4_5_like_2', NULL, 'PLDc_vPLD3_4_5_like_2', NULL, NULL, NULL, 2),
(1546, NULL, 'cd09982', NULL, NULL, 'LOTUS_6_Limkain_b1', NULL, 'LOTUS_6_Limkain_b1', NULL, NULL, NULL, 2),
(1547, NULL, 'cd11741', NULL, NULL, 'TIN2_TBM', NULL, 'TIN2_TBM', NULL, NULL, NULL, 2),
(1548, NULL, 'cd15988', NULL, NULL, '7tmB2_BAI2', NULL, '7tmB2_BAI2', NULL, NULL, NULL, 2),
(1549, NULL, 'cd14396', NULL, NULL, 'UBA_XtBIRC7_like', NULL, 'UBA_XtBIRC7_like', NULL, NULL, NULL, 2),
(1550, NULL, 'cd15732', NULL, NULL, 'FYVE_MTMR3', NULL, 'FYVE_MTMR3', NULL, NULL, NULL, 2),
(1551, NULL, 'cd09652', NULL, NULL, 'Cas6-I-III', NULL, 'Cas6-I-III', NULL, NULL, NULL, 2);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(1552, NULL, 'cd02877', NULL, NULL, 'GH18_hevamine_XipI_class_III', NULL, 'GH18_hevamine_XipI_class_III', NULL, NULL, 36371, 2),
(1553, NULL, 'cd17581', NULL, NULL, 'REC_typeA_ARR', NULL, 'REC_typeA_ARR', NULL, NULL, NULL, 2),
(1554, NULL, 'cd01988', NULL, NULL, 'Na_H_Antiporter_C', NULL, 'Na_H_Antiporter_C', NULL, NULL, NULL, 2),
(1555, NULL, 'cd11951', NULL, NULL, 'SH3_GRAP_C', NULL, 'SH3_GRAP_C', NULL, NULL, NULL, 2),
(1556, NULL, 'cd01614', NULL, NULL, 'EutN_CcmL', NULL, 'EutN_CcmL', NULL, NULL, 778, 2),
(1557, NULL, 'cd14029', NULL, NULL, 'STKc_BubR1_vert', NULL, 'STKc_BubR1_vert', NULL, NULL, NULL, 2),
(1558, NULL, 'cd02048', NULL, NULL, 'serpinI1_NSP', NULL, 'serpinI1_NSP', NULL, NULL, NULL, 2),
(1559, NULL, 'cd00340', NULL, NULL, 'GSH_Peroxidase', NULL, 'GSH_Peroxidase', NULL, NULL, 4632, 2),
(1560, NULL, 'cd18362', NULL, NULL, 'BTB_POZ_KCTD2-like', NULL, 'BTB_POZ_KCTD2-like', NULL, NULL, NULL, 2),
(1561, NULL, 'cd02667', NULL, NULL, 'Peptidase_C19K', NULL, 'Peptidase_C19K', NULL, NULL, NULL, 2),
(1562, NULL, 'cd17490', NULL, NULL, 'MFS_YxlH_like', NULL, 'MFS_YxlH_like', NULL, NULL, NULL, 2),
(1563, NULL, 'cd19088', NULL, NULL, 'AKR_AKR13B1', NULL, 'AKR_AKR13B1', NULL, NULL, NULL, 2),
(1564, NULL, 'cd11247', NULL, NULL, 'Sema_plexin_D1', NULL, 'Sema_plexin_D1', NULL, NULL, 35239, 2),
(1565, NULL, 'cd12824', NULL, NULL, 'ZntB-like', NULL, 'ZntB-like', NULL, NULL, NULL, 2),
(1566, NULL, 'cd05755', NULL, NULL, 'Ig2_ICAM-1_like', NULL, 'Ig2_ICAM-1_like', NULL, NULL, NULL, 2),
(1567, NULL, 'cd19064', NULL, NULL, 'LGIC_TM_nAChR', NULL, 'LGIC_TM_nAChR', NULL, NULL, NULL, 2),
(1568, NULL, 'cd11764', NULL, NULL, 'SH3_Eps8', NULL, 'SH3_Eps8', NULL, NULL, 14520, 2),
(1569, NULL, 'cd12812', NULL, NULL, 'BPSL1549', NULL, 'BPSL1549', NULL, NULL, 27754, 2),
(1570, NULL, 'cd06376', NULL, NULL, 'PBP1_mGluR_groupIII', NULL, 'PBP1_mGluR_groupIII', NULL, NULL, NULL, 2),
(1571, NULL, 'cd05758', NULL, NULL, 'Ig5_KIRREL3-like', NULL, 'Ig5_KIRREL3-like', NULL, NULL, NULL, 2),
(1572, NULL, 'cd18250', NULL, NULL, 'BTB_POZ_KLHL21', NULL, 'BTB_POZ_KLHL21', NULL, NULL, NULL, 2),
(1573, NULL, 'cd00602', NULL, NULL, 'IPT_TF', NULL, 'IPT_TF', NULL, NULL, NULL, 2),
(1574, NULL, 'cd03043', NULL, NULL, 'GST_N_1', NULL, 'GST_N_1', NULL, NULL, NULL, 2),
(1575, NULL, 'cd07574', NULL, NULL, 'nitrilase_Rim1_like', NULL, 'nitrilase_Rim1_like', NULL, NULL, NULL, 2),
(1576, NULL, 'cd06341', NULL, NULL, 'PBP1_ABC_ligand_binding-like', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, NULL, 2),
(1577, NULL, 'cd10020', NULL, NULL, '14-3-3_epsilon', NULL, '14-3-3_epsilon', NULL, NULL, NULL, 2),
(1578, NULL, 'cd03743', NULL, NULL, 'SOCS_SSB4', NULL, 'SOCS_SSB4', NULL, NULL, NULL, 2),
(1579, NULL, 'cd05589', NULL, NULL, 'STKc_PKN', NULL, 'STKc_PKN', NULL, NULL, NULL, 2),
(1580, NULL, 'cd11586', NULL, NULL, 'VbhA_like', NULL, 'VbhA_like', NULL, NULL, 31585, 2),
(1581, NULL, 'cd03002', NULL, NULL, 'PDI_a_MPD1_like', NULL, 'PDI_a_MPD1_like', NULL, NULL, NULL, 2),
(1582, NULL, 'cd12148', NULL, NULL, 'fungal_TF_MHR', NULL, 'fungal_TF_MHR', NULL, NULL, NULL, 2),
(1583, NULL, 'cd08354', NULL, NULL, 'VOC_like', NULL, 'VOC_like', NULL, NULL, NULL, 2),
(1584, NULL, 'cd17528', NULL, NULL, 'HAMP_III', NULL, 'HAMP_III', NULL, NULL, NULL, 2),
(1585, NULL, 'cd14704', NULL, NULL, 'bZIP_HY5-like', NULL, 'bZIP_HY5-like', NULL, NULL, NULL, 2),
(1586, NULL, 'cd17971', NULL, NULL, 'DEXHc_DHX8', NULL, 'DEXHc_DHX8', NULL, NULL, 34101, 2),
(1587, NULL, 'cd09663', NULL, NULL, 'Csm4_III-A', NULL, 'Csm4_III-A', NULL, NULL, NULL, 2),
(1588, NULL, 'cd18301', NULL, NULL, 'BTB1_POZ_IBtk', NULL, 'BTB1_POZ_IBtk', NULL, NULL, NULL, 2),
(1589, NULL, 'cd01530', NULL, NULL, 'Cdc25', NULL, 'Cdc25', NULL, NULL, 4040, 2),
(1590, NULL, 'cd02002', NULL, NULL, 'TPP_BFDC', NULL, 'TPP_BFDC', NULL, NULL, NULL, 2),
(1591, NULL, 'cd13588', NULL, NULL, 'PBP2_polyamine_1', NULL, 'PBP2_polyamine_1', NULL, NULL, NULL, 2),
(1592, NULL, 'cd06628', NULL, NULL, 'STKc_Byr2_like', NULL, 'STKc_Byr2_like', NULL, NULL, NULL, 2),
(1593, NULL, 'cd07354', NULL, NULL, 'HN_L-delphilin-R1_like', NULL, 'HN_L-delphilin-R1_like', NULL, NULL, NULL, 2); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(1594, NULL, 'cd19017', NULL, NULL, 'LGIC_ECD_nAChR_A4', NULL, 'LGIC_ECD_nAChR_A4', NULL, NULL, NULL, 2),
(1595, NULL, 'cd19869', NULL, NULL, 'DSRM_DCL_plant', NULL, 'DSRM_DCL_plant', NULL, NULL, NULL, 2),
(1596, NULL, 'cd10572', NULL, NULL, 'PH_RhoGEF3_XPLN', NULL, 'PH_RhoGEF3_XPLN', NULL, NULL, 35342, 2),
(1597, NULL, 'cd02677', NULL, NULL, 'MIT_SNX15', NULL, 'MIT_SNX15', NULL, NULL, NULL, 2),
(1598, NULL, 'cd10302', NULL, NULL, 'GST_C_GDAP1L1', NULL, 'GST_C_GDAP1L1', NULL, NULL, NULL, 2),
(1599, NULL, 'cd18714', NULL, NULL, 'PIN_VapC-like', NULL, 'PIN_VapC-like', NULL, NULL, NULL, 2),
(1600, NULL, 'cd02017', NULL, NULL, 'TPP_E1_EcPDC_like', NULL, 'TPP_E1_EcPDC_like', NULL, NULL, 27947, 2),
(1601, NULL, 'cd07373', NULL, NULL, '2A5CPDO_A', NULL, '2A5CPDO_A', NULL, NULL, NULL, 2),
(1602, NULL, 'cd17030', NULL, NULL, 'T3SC_IA_SycH-like', NULL, 'T3SC_IA_SycH-like', NULL, NULL, NULL, 2),
(1603, NULL, 'cd19402', NULL, NULL, 'TGF_beta_GDF9B', NULL, 'TGF_beta_GDF9B', NULL, NULL, NULL, 2),
(1604, NULL, 'cd00408', NULL, NULL, 'DHDPS-like', NULL, 'DHDPS-like', NULL, NULL, NULL, 2),
(1605, NULL, 'cd00519', NULL, NULL, 'Lipase_3', NULL, 'Lipase_3', NULL, NULL, NULL, 2),
(1606, NULL, 'cd10920', NULL, NULL, 'CE4_WbmS', NULL, 'CE4_WbmS', NULL, NULL, NULL, 2),
(1607, NULL, 'cd16410', NULL, NULL, 'ParB_N_like', NULL, 'ParB_N_like', NULL, NULL, NULL, 2),
(1608, NULL, 'cd09208', NULL, NULL, 'Lumazine_synthase-II', NULL, 'Lumazine_synthase-II', NULL, NULL, NULL, 2),
(1609, NULL, 'cd11737', NULL, NULL, 'HSPA4_NBD', NULL, 'HSPA4_NBD', NULL, NULL, 30187, 2),
(1610, NULL, 'cd13589', NULL, NULL, 'PBP2_polyamine_RpCGA009', NULL, 'PBP2_polyamine_RpCGA009', NULL, NULL, NULL, 2),
(1611, NULL, 'cd14596', NULL, NULL, 'PTPc-N20', NULL, 'PTPc-N20', NULL, NULL, NULL, 2),
(1612, NULL, 'cd11452', NULL, NULL, 'bHLH_AtNAI1_like', NULL, 'bHLH_AtNAI1_like', NULL, NULL, NULL, 2),
(1613, NULL, 'cd12066', NULL, NULL, 'SH3_GRAF3', NULL, 'SH3_GRAF3', NULL, NULL, NULL, 2),
(1614, NULL, 'cd12727', NULL, NULL, 'RRM_like_Smg4_UPF3A', NULL, 'RRM_like_Smg4_UPF3A', NULL, NULL, NULL, 2),
(1615, NULL, 'cd17650', NULL, NULL, 'A_NRPS_PpsD_like', NULL, 'A_NRPS_PpsD_like', NULL, NULL, NULL, 2),
(1616, NULL, 'cd07817', NULL, NULL, 'SRPBCC_8', NULL, 'SRPBCC_8', NULL, NULL, NULL, 2),
(1617, NULL, 'cd21598', NULL, NULL, 'ORF7b_SARS_bat-CoV-like', NULL, 'ORF7b_SARS_bat-CoV-like', NULL, NULL, NULL, 2),
(1618, NULL, 'cd09740', NULL, NULL, 'Csx3_III-U', NULL, 'Csx3_III-U', NULL, NULL, NULL, 2),
(1619, NULL, 'cd03019', NULL, NULL, 'DsbA_DsbA', NULL, 'DsbA_DsbA', NULL, NULL, 15714, 2),
(1620, NULL, 'cd01117', NULL, NULL, 'YbiR_permease', NULL, 'YbiR_permease', NULL, NULL, NULL, 2),
(1621, NULL, 'cd01160', NULL, NULL, 'LCAD', NULL, 'LCAD', NULL, NULL, 20623, 2),
(1622, NULL, 'cd06300', NULL, NULL, 'PBP1_ABC_sugar_binding-like', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, NULL, 2),
(1623, NULL, 'cd16974', NULL, NULL, 'Alpha_kinase_ALPK2', NULL, 'Alpha_kinase_ALPK2', NULL, NULL, NULL, 2),
(1624, NULL, 'cd01898', NULL, NULL, 'Obg', NULL, 'Obg', NULL, NULL, 23589, 2),
(1625, NULL, 'cd09619', NULL, NULL, 'CBM9_like_4', NULL, 'CBM9_like_4', NULL, NULL, NULL, 2),
(1626, NULL, 'cd07509', NULL, NULL, 'HAD_PPase', NULL, 'HAD_PPase', NULL, NULL, 4732, 2),
(1627, NULL, 'cd01081', NULL, NULL, 'Aldose_epim', NULL, 'Aldose_epim', NULL, NULL, NULL, 2),
(1628, NULL, 'cd18825', NULL, NULL, 'GH43_CtGH43-like', NULL, 'GH43_CtGH43-like', NULL, NULL, NULL, 2),
(1629, NULL, 'cd05669', NULL, NULL, 'M20_Acy1_YxeP-like', NULL, 'M20_Acy1_YxeP-like', NULL, NULL, NULL, 2),
(1630, NULL, 'cd18121', NULL, NULL, 'ATP-synt_Fo_c', NULL, 'ATP-synt_Fo_c', NULL, NULL, NULL, 2),
(1631, NULL, 'cd00576', NULL, NULL, 'RNR_PFL', NULL, 'RNR_PFL', NULL, NULL, NULL, 2),
(1632, NULL, 'cd19750', NULL, NULL, 'bHLH-O_DEC2', NULL, 'bHLH-O_DEC2', NULL, NULL, NULL, 2),
(1633, NULL, 'cd03481', NULL, NULL, 'TopoIIA_Trans_ScTopoIIA', NULL, 'TopoIIA_Trans_ScTopoIIA', NULL, NULL, NULL, 2),
(1634, NULL, 'cd15836', NULL, NULL, 'TNFRSF11A_teleost', NULL, 'TNFRSF11A_teleost', NULL, NULL, NULL, 2),
(1635, NULL, 'cd12828', NULL, NULL, 'TmCorA-like_1', NULL, 'TmCorA-like_1', NULL, NULL, NULL, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(1636, NULL, 'cd15086', NULL, NULL, '7tmA_tmt_opsin', NULL, '7tmA_tmt_opsin', NULL, NULL, NULL, 2),
(1637, NULL, 'cd17945', NULL, NULL, 'DEADc_DDX23', NULL, 'DEADc_DDX23', NULL, NULL, NULL, 2),
(1638, NULL, 'cd07238', NULL, NULL, 'VOC_like', NULL, 'VOC_like', NULL, NULL, NULL, 2),
(1639, NULL, 'cd19604', NULL, NULL, 'serpin_protozoa', NULL, 'serpin_protozoa', NULL, NULL, NULL, 2),
(1640, NULL, 'cd00606', NULL, NULL, 'fungal_RNase', NULL, 'fungal_RNase', NULL, NULL, NULL, 2),
(1641, NULL, 'cd20243', NULL, NULL, 'NoBody', NULL, 'NoBody', NULL, NULL, NULL, 2),
(1642, NULL, 'cd15759', NULL, NULL, 'FYVE_RUFY2', NULL, 'FYVE_RUFY2', NULL, NULL, NULL, 2),
(1643, NULL, 'cd16530', NULL, NULL, 'RING-HC_RAG1', NULL, 'RING-HC_RAG1', NULL, NULL, NULL, 2),
(1644, NULL, 'cd12791', NULL, NULL, 'RasGAP_plexin_B3', NULL, 'RasGAP_plexin_B3', NULL, NULL, NULL, 2),
(1645, NULL, 'cd20292', NULL, NULL, 'cupin_QdtA-like', NULL, 'cupin_QdtA-like', NULL, NULL, 7515, 2),
(1646, NULL, 'cd18480', NULL, NULL, 'BACK_KBTBD3', NULL, 'BACK_KBTBD3', NULL, NULL, NULL, 2),
(1647, NULL, 'cd01017', NULL, NULL, 'AdcA', NULL, 'AdcA', NULL, NULL, NULL, 2),
(1648, NULL, 'cd09165', NULL, NULL, 'PLDc_PaPPK1_C1_like', NULL, 'PLDc_PaPPK1_C1_like', NULL, NULL, NULL, 2),
(1649, NULL, 'cd06896', NULL, NULL, 'PX_PI3K_C2_gamma', NULL, 'PX_PI3K_C2_gamma', NULL, NULL, NULL, 2),
(1650, NULL, 'cd16011', NULL, NULL, 'iPGM_like', NULL, 'iPGM_like', NULL, NULL, 7075, 2),
(1651, NULL, 'cd03153', NULL, NULL, 'PHEMX_like_LEL', NULL, 'PHEMX_like_LEL', NULL, NULL, 34999, 2),
(1652, NULL, 'cd10534', NULL, NULL, 'PR-SET_PRDM-like', NULL, 'PR-SET_PRDM-like', NULL, NULL, NULL, 2),
(1653, NULL, 'cd07046', NULL, NULL, 'BMC_PduU-EutS', NULL, 'BMC_PduU-EutS', NULL, NULL, 13878, 2),
(1654, NULL, 'cd17763', NULL, NULL, 'UP_hUPP-like', NULL, 'UP_hUPP-like', NULL, NULL, 6190, 2),
(1655, NULL, 'cd00833', NULL, NULL, 'PKS', NULL, 'PKS', NULL, NULL, NULL, 2),
(1656, NULL, 'cd06645', NULL, NULL, 'STKc_MAP4K3', NULL, 'STKc_MAP4K3', NULL, NULL, NULL, 2),
(1657, NULL, 'cd09804', NULL, NULL, 'Dcp1', NULL, 'Dcp1', NULL, NULL, NULL, 2),
(1658, NULL, 'cd19170', NULL, NULL, 'SET_KMT2A_2B', NULL, 'SET_KMT2A_2B', NULL, NULL, NULL, 2),
(1659, NULL, 'cd07723', NULL, NULL, 'hydroxyacylglutathione_hydrolase_MBL-fold', NULL, 'hydroxyacylglutathione_hydrolase_MBL-fold', NULL, NULL, 29883, 2),
(1660, NULL, 'cd16880', NULL, NULL, 'ARID_ARID3C', NULL, 'ARID_ARID3C', NULL, NULL, NULL, 2),
(1661, NULL, 'cd07667', NULL, NULL, 'BAR_SNX30', NULL, 'BAR_SNX30', NULL, NULL, NULL, 2),
(1662, NULL, 'cd08814', NULL, NULL, 'DED_Caspase_10_r2', NULL, 'DED_Caspase_10_r2', NULL, NULL, NULL, 2),
(1663, NULL, 'cd09080', NULL, NULL, 'TDP2', NULL, 'TDP2', NULL, NULL, NULL, 2),
(1664, NULL, 'cd13879', NULL, NULL, 'CuRO_2_McoP_like', NULL, 'CuRO_2_McoP_like', NULL, NULL, NULL, 2),
(1665, NULL, 'cd09757', NULL, NULL, 'Cas8c_I-C', NULL, 'Cas8c_I-C', NULL, NULL, NULL, 2),
(1666, NULL, 'cd06107', NULL, NULL, 'EcCS_AthCS-per_like', NULL, 'EcCS_AthCS-per_like', NULL, NULL, NULL, 2),
(1667, NULL, 'cd11414', NULL, NULL, 'bHLH_TS_HEN', NULL, 'bHLH_TS_HEN', NULL, NULL, NULL, 2),
(1668, NULL, 'cd19863', NULL, NULL, 'DSRM_PRKRA-like_rpt2', NULL, 'DSRM_PRKRA-like_rpt2', NULL, NULL, NULL, 2),
(1669, NULL, 'cd01662', NULL, NULL, 'Ubiquinol_Oxidase_I', NULL, 'Ubiquinol_Oxidase_I', NULL, NULL, NULL, 2),
(1670, NULL, 'cd05851', NULL, NULL, 'Ig3_Contactin-1', NULL, 'Ig3_Contactin-1', NULL, NULL, NULL, 2),
(1671, NULL, 'cd08061', NULL, NULL, 'MPN_NPL4', NULL, 'MPN_NPL4', NULL, NULL, 1214, 2),
(1672, NULL, 'cd16833', NULL, NULL, 'YfiH', NULL, 'YfiH', NULL, NULL, 2018, 2),
(1673, NULL, 'cd07358', NULL, NULL, 'HN_PDZD7_like', NULL, 'HN_PDZD7_like', NULL, NULL, 33682, 2),
(1674, NULL, 'cd15465', NULL, NULL, 'bS6_mito', NULL, 'bS6_mito', NULL, NULL, NULL, 2),
(1675, NULL, 'cd01357', NULL, NULL, 'Aspartase', NULL, 'Aspartase', NULL, NULL, NULL, 2),
(1676, NULL, 'cd06435', NULL, NULL, 'CESA_NdvC_like', NULL, 'CESA_NdvC_like', NULL, NULL, NULL, 2),
(1677, NULL, 'cd10423', NULL, NULL, 'RNase_RNase-L', NULL, 'RNase_RNase-L', NULL, NULL, 35038, 2);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(1678, NULL, 'cd19826', NULL, NULL, 'Bbox2_TRIM9_C-I', NULL, 'Bbox2_TRIM9_C-I', NULL, NULL, NULL, 2),
(1679, NULL, 'cd09605', NULL, NULL, 'M3A', NULL, 'M3A', NULL, NULL, NULL, 2),
(1680, NULL, 'cd09545', NULL, NULL, 'SAM_EPH-A4', NULL, 'SAM_EPH-A4', NULL, NULL, 26081, 2),
(1681, NULL, 'cd15745', NULL, NULL, 'FYVE_RUFY4', NULL, 'FYVE_RUFY4', NULL, NULL, NULL, 2),
(1682, NULL, 'cd19150', NULL, NULL, 'AKR_AKR14A1', NULL, 'AKR_AKR14A1', NULL, NULL, NULL, 2),
(1683, NULL, 'cd17771', NULL, NULL, 'CBS_pair_CAP-ED_NT_Pol-beta-like_DUF294_assoc', NULL, 'CBS_pair_CAP-ED_NT_Pol-beta-like_DUF294_assoc', NULL, NULL, NULL, 2),
(1684, NULL, 'cd19532', NULL, NULL, 'C_PKS-NRPS', NULL, 'C_PKS-NRPS', NULL, NULL, NULL, 2),
(1685, NULL, 'cd05271', NULL, NULL, 'NDUFA9_like_SDR_a', NULL, 'NDUFA9_like_SDR_a', NULL, NULL, NULL, 2),
(1686, NULL, 'cd17009', NULL, NULL, 'VHS_GGA1', NULL, 'VHS_GGA1', NULL, NULL, NULL, 2),
(1687, NULL, 'cd05305', NULL, NULL, 'L-AlaDH', NULL, 'L-AlaDH', NULL, NULL, 7396, 2),
(1688, NULL, 'cd19135', NULL, NULL, 'AKR_CeZK1290-like', NULL, 'AKR_CeZK1290-like', NULL, NULL, NULL, 2),
(1689, NULL, 'cd15000', NULL, NULL, '7tmA_BNGR-A34-like', NULL, '7tmA_BNGR-A34-like', NULL, NULL, NULL, 2),
(1690, NULL, 'cd10441', NULL, NULL, 'GIY-YIG_COG1833', NULL, 'GIY-YIG_COG1833', NULL, NULL, 5119, 2),
(1691, NULL, 'cd01897', NULL, NULL, 'NOG', NULL, 'NOG', NULL, NULL, NULL, 2),
(1692, NULL, 'cd05616', NULL, NULL, 'STKc_cPKC_beta', NULL, 'STKc_cPKC_beta', NULL, NULL, 18941, 2),
(1693, NULL, 'cd06328', NULL, NULL, 'PBP1_SBP-like', NULL, 'PBP1_SBP-like', NULL, NULL, NULL, 2),
(1694, NULL, 'cd08675', NULL, NULL, 'C2B_RasGAP', NULL, 'C2B_RasGAP', NULL, NULL, NULL, 2),
(1695, NULL, 'cd15016', NULL, NULL, '7tm_TAS2R1', NULL, '7tm_TAS2R1', NULL, NULL, NULL, 2),
(1696, NULL, 'cd07808', NULL, NULL, 'FGGY_D-XK_EcXK-like', NULL, 'FGGY_D-XK_EcXK-like', NULL, NULL, NULL, 2),
(1697, NULL, 'cd08835', NULL, NULL, 'ArfGap_ACAP', NULL, 'ArfGap_ACAP', NULL, NULL, NULL, 2),
(1698, NULL, 'cd03752', NULL, NULL, 'proteasome_alpha_type_4', NULL, 'proteasome_alpha_type_4', NULL, NULL, NULL, 2),
(1699, NULL, 'cd14551', NULL, NULL, 'R-PTPc-A-E-1', NULL, 'R-PTPc-A-E-1', NULL, NULL, NULL, 2),
(1700, NULL, 'cd13294', NULL, NULL, 'PH_ORP_plant', NULL, 'PH_ORP_plant', NULL, NULL, NULL, 2),
(1701, NULL, 'cd13862', NULL, NULL, 'CuRO_1_MCO_like_1', NULL, 'CuRO_1_MCO_like_1', NULL, NULL, NULL, 2),
(1702, NULL, 'cd11434', NULL, NULL, 'bHLH-PAS_SIM', NULL, 'bHLH-PAS_SIM', NULL, NULL, NULL, 2),
(1703, NULL, 'cd15486', NULL, NULL, 'ZIP_Sip4', NULL, 'ZIP_Sip4', NULL, NULL, NULL, 2),
(1704, NULL, 'cd05613', NULL, NULL, 'STKc_MSK1_N', NULL, 'STKc_MSK1_N', NULL, NULL, NULL, 2),
(1705, NULL, 'cd05828', NULL, NULL, 'Sortase_D_1', NULL, 'Sortase_D_1', NULL, NULL, 31464, 2),
(1706, NULL, 'cd08811', NULL, NULL, 'CARD_IPS1', NULL, 'CARD_IPS1', NULL, NULL, 33859, 2),
(1707, NULL, 'cd12326', NULL, NULL, 'RRM1_hnRNPA0', NULL, 'RRM1_hnRNPA0', NULL, NULL, 32370, 2),
(1708, NULL, 'cd08641', NULL, NULL, 'DNA_pol_gammaA', NULL, 'DNA_pol_gammaA', NULL, NULL, NULL, 2),
(1709, NULL, 'cd16862', NULL, NULL, 'ING_ING4', NULL, 'ING_ING4', NULL, NULL, NULL, 2),
(1710, NULL, 'cd18337', NULL, NULL, 'BTB_POZ_KLHL5', NULL, 'BTB_POZ_KLHL5', NULL, NULL, 25364, 2),
(1711, NULL, 'cd09557', NULL, NULL, 'SAM_Smaug', NULL, 'SAM_Smaug', NULL, NULL, 32231, 2),
(1712, NULL, 'cd19198', NULL, NULL, 'PR-SET_PRDM14', NULL, 'PR-SET_PRDM14', NULL, NULL, 34617, 2),
(1713, NULL, 'cd13693', NULL, NULL, 'PBP2_polar_AA', NULL, 'PBP2_polar_AA', NULL, NULL, NULL, 2),
(1714, NULL, 'cd01667', NULL, NULL, 'TGS_ThrRS', NULL, 'TGS_ThrRS', NULL, NULL, NULL, 2),
(1715, NULL, 'cd02994', NULL, NULL, 'PDI_a_TMX', NULL, 'PDI_a_TMX', NULL, NULL, NULL, 2),
(1716, NULL, 'cd18508', NULL, NULL, 'BACK_KEL_like', NULL, 'BACK_KEL_like', NULL, NULL, NULL, 2),
(1717, NULL, 'cd13290', NULL, NULL, 'PH_ORP9', NULL, 'PH_ORP9', NULL, NULL, NULL, 2),
(1718, NULL, 'cd17505', NULL, NULL, 'Ubl_SAMP1_like', NULL, 'Ubl_SAMP1_like', NULL, NULL, NULL, 2),
(1719, NULL, 'cd01979', NULL, NULL, 'Pchlide_reductase_N', NULL, 'Pchlide_reductase_N', NULL, NULL, NULL, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(1720, NULL, 'cd17638', NULL, NULL, 'FadD3', NULL, 'FadD3', NULL, NULL, NULL, 2),
(1721, NULL, 'cd07118', NULL, NULL, 'ALDH_SNDH', NULL, 'ALDH_SNDH', NULL, NULL, NULL, 2),
(1722, NULL, 'cd01779', NULL, NULL, 'RA_Myosin-IX', NULL, 'RA_Myosin-IX', NULL, NULL, NULL, 2),
(1723, NULL, 'cd11237', NULL, NULL, 'Sema_1A', NULL, 'Sema_1A', NULL, NULL, 30168, 2),
(1724, NULL, 'cd12646', NULL, NULL, 'RRM_SRSF7', NULL, 'RRM_SRSF7', NULL, NULL, 30952, 2),
(1725, NULL, 'cd16808', NULL, NULL, 'RING_CH-C4HC3_MARCH2', NULL, 'RING_CH-C4HC3_MARCH2', NULL, NULL, NULL, 2),
(1726, NULL, 'cd16993', NULL, NULL, 'ENTH_Ent5', NULL, 'ENTH_Ent5', NULL, NULL, NULL, 2),
(1727, NULL, 'cd13886', NULL, NULL, 'CuRO_2_MCO_like_1', NULL, 'CuRO_2_MCO_like_1', NULL, NULL, NULL, 2),
(1728, NULL, 'cd12160', NULL, NULL, '2-Hacid_dh_3', NULL, '2-Hacid_dh_3', NULL, NULL, NULL, 2),
(1729, NULL, 'cd17217', NULL, NULL, 'RA_Myosin-IXb', NULL, 'RA_Myosin-IXb', NULL, NULL, NULL, 2),
(1730, NULL, 'cd01169', NULL, NULL, 'HMPP_kinase', NULL, 'HMPP_kinase', NULL, NULL, 5731, 2),
(1731, NULL, 'cd09613', NULL, NULL, 'Jacalin_metallopeptidase_like', NULL, 'Jacalin_metallopeptidase_like', NULL, NULL, 30906, 2),
(1732, NULL, 'cd14006', NULL, NULL, 'STKc_MLCK-like', NULL, 'STKc_MLCK-like', NULL, NULL, NULL, 2),
(1733, NULL, 'cd12105', NULL, NULL, 'HmuY', NULL, 'HmuY', NULL, NULL, 24505, 2),
(1734, NULL, 'cd16605', NULL, NULL, 'RING-HC_TRIM50_like_C-IV', NULL, 'RING-HC_TRIM50_like_C-IV', NULL, NULL, NULL, 2),
(1735, NULL, 'cd04801', NULL, NULL, 'CBS_pair_peptidase_M50', NULL, 'CBS_pair_peptidase_M50', NULL, NULL, NULL, 2),
(1736, NULL, 'cd09411', NULL, NULL, 'LIM4_Paxillin', NULL, 'LIM4_Paxillin', NULL, NULL, NULL, 2),
(1737, NULL, 'cd18608', NULL, NULL, 'GH43_F5-8_typeC-like', NULL, 'GH43_F5-8_typeC-like', NULL, NULL, NULL, 2),
(1738, NULL, 'cd12804', NULL, NULL, 'AKAP10_AKB', NULL, 'AKAP10_AKB', NULL, NULL, 32904, 2),
(1739, NULL, 'cd04116', NULL, NULL, 'Rab9', NULL, 'Rab9', NULL, NULL, 30064, 2),
(1740, NULL, 'cd19334', NULL, NULL, 'Wnt_Wnt2_like', NULL, 'Wnt_Wnt2_like', NULL, NULL, NULL, 2),
(1741, NULL, 'cd18789', NULL, NULL, 'SF2_C_XPB', NULL, 'SF2_C_XPB', NULL, NULL, NULL, 2),
(1742, NULL, 'cd19896', NULL, NULL, 'DSRM_RED2_rpt1', NULL, 'DSRM_RED2_rpt1', NULL, NULL, 35325, 2),
(1743, NULL, 'cd16719', NULL, NULL, 'RING-HC_LNX4', NULL, 'RING-HC_LNX4', NULL, NULL, NULL, 2),
(1744, NULL, 'cd11350', NULL, NULL, 'AmyAc_4', NULL, 'AmyAc_4', NULL, NULL, NULL, 2),
(1745, NULL, 'cd05146', NULL, NULL, 'RIO3_euk', NULL, 'RIO3_euk', NULL, NULL, NULL, 2),
(1746, NULL, 'cd10386', NULL, NULL, 'SH2_SOCS5', NULL, 'SH2_SOCS5', NULL, NULL, NULL, 2),
(1747, NULL, 'cd14512', NULL, NULL, 'DSP_MKP', NULL, 'DSP_MKP', NULL, NULL, NULL, 2),
(1748, NULL, 'cd08386', NULL, NULL, 'C2A_Synaptotagmin-7', NULL, 'C2A_Synaptotagmin-7', NULL, NULL, 32744, 2),
(1749, NULL, 'cd09558', NULL, NULL, 'SAM_ZCCH14', NULL, 'SAM_ZCCH14', NULL, NULL, 32301, 2),
(1750, NULL, 'cd16392', NULL, NULL, 'toxin-ParB', NULL, 'toxin-ParB', NULL, NULL, 33431, 2),
(1751, NULL, 'cd03277', NULL, NULL, 'ABC_SMC5_euk', NULL, 'ABC_SMC5_euk', NULL, NULL, NULL, 2),
(1752, NULL, 'cd06815', NULL, NULL, 'PLPDE_III_AR_like_1', NULL, 'PLPDE_III_AR_like_1', NULL, NULL, NULL, 2),
(1753, NULL, 'cd09112', NULL, NULL, 'PLDc_CLS_2', NULL, 'PLDc_CLS_2', NULL, NULL, NULL, 2),
(1754, NULL, 'cd19815', NULL, NULL, 'Bbox1_HOIP', NULL, 'Bbox1_HOIP', NULL, NULL, NULL, 2),
(1755, NULL, 'cd12879', NULL, NULL, 'SPRY3_RyR', NULL, 'SPRY3_RyR', NULL, NULL, 31375, 2),
(1756, NULL, 'cd12052', NULL, NULL, 'SH3_CIN85_1', NULL, 'SH3_CIN85_1', NULL, NULL, 31773, 2),
(1757, NULL, 'cd06191', NULL, NULL, 'FNR_iron_sulfur_binding', NULL, 'FNR_iron_sulfur_binding', NULL, NULL, NULL, 2),
(1758, NULL, 'cd17332', NULL, NULL, 'MFS_MelB_like', NULL, 'MFS_MelB_like', NULL, NULL, NULL, 2),
(1759, NULL, 'cd03230', NULL, NULL, 'ABC_DR_subfamily_A', NULL, 'ABC_DR_subfamily_A', NULL, NULL, NULL, 2),
(1760, NULL, 'cd09628', NULL, NULL, 'DOMON_SDR_2_like', NULL, 'DOMON_SDR_2_like', NULL, NULL, NULL, 2),
(1761, NULL, 'cd08560', NULL, NULL, 'GDPD_EcGlpQ_like_1', NULL, 'GDPD_EcGlpQ_like_1', NULL, NULL, NULL, 2);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(1762, NULL, 'cd12440', NULL, NULL, 'RRM_SYNJ', NULL, 'RRM_SYNJ', NULL, NULL, NULL, 2),
(1763, NULL, 'cd08743', NULL, NULL, 'RGS_RGS14', NULL, 'RGS_RGS14', NULL, NULL, 31523, 2),
(1764, NULL, 'cd12055', NULL, NULL, 'SH3_CIN85_2', NULL, 'SH3_CIN85_2', NULL, NULL, 31529, 2),
(1765, NULL, 'cd16340', NULL, NULL, 'CpcS_T', NULL, 'CpcS_T', NULL, NULL, NULL, 2),
(1766, NULL, 'cd00687', NULL, NULL, 'Terpene_cyclase_nonplant_C1', NULL, 'Terpene_cyclase_nonplant_C1', NULL, NULL, NULL, 2),
(1767, NULL, 'cd07346', NULL, NULL, 'ABC_6TM_exporters', NULL, 'ABC_6TM_exporters', NULL, NULL, NULL, 2),
(1768, NULL, 'cd17644', NULL, NULL, 'A_NRPS_ApnA-like', NULL, 'A_NRPS_ApnA-like', NULL, NULL, NULL, 2),
(1769, NULL, 'cd16090', NULL, NULL, 'IgV_CD47', NULL, 'IgV_CD47', NULL, NULL, 28628, 2),
(1770, NULL, 'cd03338', NULL, NULL, 'TCP1_delta', NULL, 'TCP1_delta', NULL, NULL, 11554, 2),
(1771, NULL, 'cd00794', NULL, NULL, 'NOS_oxygenase_prok', NULL, 'NOS_oxygenase_prok', NULL, NULL, NULL, 2),
(1772, NULL, 'cd06345', NULL, NULL, 'PBP1_ABC_ligand_binding-like', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, NULL, 2),
(1773, NULL, 'cd01295', NULL, NULL, 'AdeC', NULL, 'AdeC', NULL, NULL, 1736, 2),
(1774, NULL, 'cd02649', NULL, NULL, 'nuc_hydro_CeIAG', NULL, 'nuc_hydro_CeIAG', NULL, NULL, NULL, 2),
(1775, NULL, 'cd05713', NULL, NULL, 'Ig_MOG_like', NULL, 'Ig_MOG_like', NULL, NULL, NULL, 2),
(1776, NULL, 'cd09443', NULL, NULL, 'LIM_Ltd-1', NULL, 'LIM_Ltd-1', NULL, NULL, NULL, 2),
(1777, NULL, 'cd16025', NULL, NULL, 'PAS_like', NULL, 'PAS_like', NULL, NULL, NULL, 2),
(1778, NULL, 'cd08693', NULL, NULL, 'C2_PI3K_class_I_beta_delta', NULL, 'C2_PI3K_class_I_beta_delta', NULL, NULL, NULL, 2),
(1779, NULL, 'cd19173', NULL, NULL, 'SET_NSD', NULL, 'SET_NSD', NULL, NULL, NULL, 2),
(1780, NULL, 'cd07400', NULL, NULL, 'MPP_1', NULL, 'MPP_1', NULL, NULL, NULL, 2),
(1781, NULL, 'cd07435', NULL, NULL, 'PHP_PolIIIA_POLC', NULL, 'PHP_PolIIIA_POLC', NULL, NULL, NULL, 2),
(1782, NULL, 'cd16093', NULL, NULL, 'IgC_CH2_Mu', NULL, 'IgC_CH2_Mu', NULL, NULL, NULL, 2),
(1783, NULL, 'cd08905', NULL, NULL, 'START_STARD1-like', NULL, 'START_STARD1-like', NULL, NULL, 22218, 2),
(1784, NULL, 'cd14072', NULL, NULL, 'STKc_MARK', NULL, 'STKc_MARK', NULL, NULL, NULL, 2),
(1785, NULL, 'cd10043', NULL, NULL, 'Reelin_repeat_7_subrepeat_1', NULL, 'Reelin_repeat_7_subrepeat_1', NULL, NULL, NULL, 2),
(1786, NULL, 'cd00611', NULL, NULL, 'PSAT_like', NULL, 'PSAT_like', NULL, NULL, 15261, 2),
(1787, NULL, 'cd10241', NULL, NULL, 'HSPA5-like_NBD', NULL, 'HSPA5-like_NBD', NULL, NULL, 30489, 2),
(1788, NULL, 'cd06297', NULL, NULL, 'PBP1_CcpA_TTHA0807', NULL, 'PBP1_CcpA_TTHA0807', NULL, NULL, NULL, 2),
(1789, NULL, 'cd05592', NULL, NULL, 'STKc_nPKC_theta_like', NULL, 'STKc_nPKC_theta_like', NULL, NULL, NULL, 2),
(1790, NULL, 'cd12383', NULL, NULL, 'RRM_RBM42', NULL, 'RRM_RBM42', NULL, NULL, 21420, 2),
(1791, NULL, 'cd08718', NULL, NULL, 'RGS_RZ-like', NULL, 'RGS_RZ-like', NULL, NULL, NULL, 2),
(1792, NULL, 'cd07903', NULL, NULL, 'Adenylation_DNA_ligase_IV', NULL, 'Adenylation_DNA_ligase_IV', NULL, NULL, 37297, 2),
(1793, NULL, 'cd14359', NULL, NULL, 'UBA_AeNAC', NULL, 'UBA_AeNAC', NULL, NULL, NULL, 2),
(1794, NULL, 'cd14761', NULL, NULL, 'GS_GsGCS-like', NULL, 'GS_GsGCS-like', NULL, NULL, NULL, 2),
(1795, NULL, 'cd07049', NULL, NULL, 'BMC_EutL_repeat1', NULL, 'BMC_EutL_repeat1', NULL, NULL, NULL, 2),
(1796, NULL, 'cd20253', NULL, NULL, 'Sarcolipin', NULL, 'Sarcolipin', NULL, NULL, NULL, 2),
(1797, NULL, 'cd06985', NULL, NULL, 'cupin_BF4112', NULL, 'cupin_BF4112', NULL, NULL, NULL, 2),
(1798, NULL, 'cd11266', NULL, NULL, 'Sema_6A', NULL, 'Sema_6A', NULL, NULL, NULL, 2),
(1799, NULL, 'cd16469', NULL, NULL, 'RING-H2_RNF24_like', NULL, 'RING-H2_RNF24_like', NULL, NULL, NULL, 2),
(1800, NULL, 'cd14929', NULL, NULL, 'MYSc_Myh15_mammals', NULL, 'MYSc_Myh15_mammals', NULL, NULL, NULL, 2),
(1801, NULL, 'cd04190', NULL, NULL, 'Chitin_synth_C', NULL, 'Chitin_synth_C', NULL, NULL, NULL, 2),
(1802, NULL, 'cd08540', NULL, NULL, 'SAM_PNT-ERG', NULL, 'SAM_PNT-ERG', NULL, NULL, NULL, 2);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(1803, NULL, 'cd18950', NULL, NULL, 'bHLH-PAS_NCoA2_SRC2', NULL, 'bHLH-PAS_NCoA2_SRC2', NULL, NULL, NULL, 2),
(1804, NULL, 'cd05932', NULL, NULL, 'LC_FACS_bac', NULL, 'LC_FACS_bac', NULL, NULL, NULL, 2),
(1805, NULL, 'cd02042', NULL, NULL, 'ParAB_family', NULL, 'ParAB_family', NULL, NULL, NULL, 2),
(1806, NULL, 'cd12205', NULL, NULL, 'RasGAP_plexin', NULL, 'RasGAP_plexin', NULL, NULL, NULL, 2),
(1807, NULL, 'cd15154', NULL, NULL, '7tmA_LPAR5', NULL, '7tmA_LPAR5', NULL, NULL, NULL, 2),
(1808, NULL, 'cd18314', NULL, NULL, 'BTB_POZ_trishanku-like', NULL, 'BTB_POZ_trishanku-like', NULL, NULL, NULL, 2),
(1809, NULL, 'cd12685', NULL, NULL, 'RRM_RBM20', NULL, 'RRM_RBM20', NULL, NULL, 19463, 2),
(1810, NULL, 'cd01585', NULL, NULL, 'AcnA_Bact', NULL, 'AcnA_Bact', NULL, NULL, NULL, 2),
(1811, NULL, 'cd19449', NULL, NULL, 'ReP1-NCXSQ-like', NULL, 'ReP1-NCXSQ-like', NULL, NULL, NULL, 2),
(1812, NULL, 'cd19083', NULL, NULL, 'AKR_AKR11A1_11D1', NULL, 'AKR_AKR11A1_11D1', NULL, NULL, NULL, 2),
(1813, NULL, 'cd20216', NULL, NULL, 'PFM_HFR-2-like', NULL, 'PFM_HFR-2-like', NULL, NULL, NULL, 2),
(1814, NULL, 'cd17912', NULL, NULL, 'DEAD-like_helicase_N', NULL, 'DEAD-like_helicase_N', NULL, NULL, NULL, 2),
(1815, NULL, 'cd20234', NULL, NULL, 'PFM_fascin-like', NULL, 'PFM_fascin-like', NULL, NULL, NULL, 2),
(1816, NULL, 'cd01669', NULL, NULL, 'TGS_MJ1332_like', NULL, 'TGS_MJ1332_like', NULL, NULL, NULL, 2),
(1817, NULL, 'cd02071', NULL, NULL, 'MM_CoA_mut_B12_BD', NULL, 'MM_CoA_mut_B12_BD', NULL, NULL, NULL, 2),
(1818, NULL, 'cd03565', NULL, NULL, 'VHS_Tom1_like', NULL, 'VHS_Tom1_like', NULL, NULL, NULL, 2),
(1819, NULL, 'cd03474', NULL, NULL, 'Rieske_T4moC', NULL, 'Rieske_T4moC', NULL, NULL, NULL, 2),
(1820, NULL, 'cd19181', NULL, NULL, 'SET_SETD5', NULL, 'SET_SETD5', NULL, NULL, 35187, 2),
(1821, NULL, 'cd00974', NULL, NULL, 'DSRD', NULL, 'DSRD', NULL, NULL, 7250, 2),
(1822, NULL, 'cd07888', NULL, NULL, 'CRD_corin_2', NULL, 'CRD_corin_2', NULL, NULL, 30203, 2),
(1823, NULL, 'cd13745', NULL, NULL, 'SPRY_PRY_TRIM39', NULL, 'SPRY_PRY_TRIM39', NULL, NULL, 29238, 2),
(1824, NULL, 'cd15938', NULL, NULL, '7tmA_OR4Q2-like', NULL, '7tmA_OR4Q2-like', NULL, NULL, NULL, 2),
(1825, NULL, 'cd08789', NULL, NULL, 'CARD_IPS-1_RIG-I', NULL, 'CARD_IPS-1_RIG-I', NULL, NULL, NULL, 2),
(1826, NULL, 'cd18792', NULL, NULL, 'SF2_C_RecG_TRCF', NULL, 'SF2_C_RecG_TRCF', NULL, NULL, NULL, 2),
(1827, NULL, 'cd03183', NULL, NULL, 'GST_C_Theta', NULL, 'GST_C_Theta', NULL, NULL, 27370, 2),
(1828, NULL, 'cd00775', NULL, NULL, 'LysRS_core', NULL, 'LysRS_core', NULL, NULL, 19875, 2),
(1829, NULL, 'cd18562', NULL, NULL, 'ABC_6TM_NdvA_beta-glucan_exporter_like', NULL, 'ABC_6TM_NdvA_beta-glucan_exporter_like', NULL, NULL, NULL, 2),
(1830, NULL, 'cd16547', NULL, NULL, 'RING-HC_RNF151', NULL, 'RING-HC_RNF151', NULL, NULL, NULL, 2),
(1831, NULL, 'cd11626', NULL, NULL, 'HR1_ROCK', NULL, 'HR1_ROCK', NULL, NULL, NULL, 2),
(1832, NULL, 'cd00680', NULL, NULL, 'RHO_alpha_C', NULL, 'RHO_alpha_C', NULL, NULL, NULL, 2),
(1833, NULL, 'cd13705', NULL, NULL, 'PBP2_BvgS_D1', NULL, 'PBP2_BvgS_D1', NULL, NULL, NULL, 2),
(1834, NULL, 'cd17360', NULL, NULL, 'MFS_HMIT_like', NULL, 'MFS_HMIT_like', NULL, NULL, NULL, 2),
(1835, NULL, 'cd12340', NULL, NULL, 'RBD_RRM1_NPL3', NULL, 'RBD_RRM1_NPL3', NULL, NULL, 3035, 2),
(1836, NULL, 'cd16498', NULL, NULL, 'RING-HC_BRCA1', NULL, 'RING-HC_BRCA1', NULL, NULL, NULL, 2),
(1837, NULL, 'cd10282', NULL, NULL, 'DNase1', NULL, 'DNase1', NULL, NULL, NULL, 2),
(1838, NULL, 'cd11523', NULL, NULL, 'NTP-PPase', NULL, 'NTP-PPase', NULL, NULL, NULL, 2),
(1839, NULL, 'cd16361', NULL, NULL, 'VOC_ShValD_like', NULL, 'VOC_ShValD_like', NULL, NULL, NULL, 2),
(1840, NULL, 'cd04488', NULL, NULL, 'RecG_wedge_OBF', NULL, 'RecG_wedge_OBF', NULL, NULL, NULL, 2),
(1841, NULL, 'cd14185', NULL, NULL, 'STKc_DCKL3', NULL, 'STKc_DCKL3', NULL, NULL, NULL, 2),
(1842, NULL, 'cd08266', NULL, NULL, 'Zn_ADH_like1', NULL, 'Zn_ADH_like1', NULL, NULL, NULL, 2),
(1843, NULL, 'cd07967', NULL, NULL, 'OBF_DNA_ligase_III', NULL, 'OBF_DNA_ligase_III', NULL, NULL, NULL, 2);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(1844, NULL, 'cd10017', NULL, NULL, 'B3_DNA', NULL, 'B3_DNA', NULL, NULL, 4130, 2),
(1845, NULL, 'cd11657', NULL, NULL, 'TIN2_N', NULL, 'TIN2_N', NULL, NULL, 23323, 2),
(1846, NULL, 'cd17903', NULL, NULL, 'ArfGap_AGFG2', NULL, 'ArfGap_AGFG2', NULL, NULL, NULL, 2),
(1847, NULL, 'cd05165', NULL, NULL, 'PI3Kc_I', NULL, 'PI3Kc_I', NULL, NULL, NULL, 2),
(1848, NULL, 'cd07577', NULL, NULL, 'Ph0642_like', NULL, 'Ph0642_like', NULL, NULL, NULL, 2),
(1849, NULL, 'cd15383', NULL, NULL, '7tmA_GnRHR_vertebrate', NULL, '7tmA_GnRHR_vertebrate', NULL, NULL, NULL, 2),
(1850, NULL, 'cd03535', NULL, NULL, 'Rieske_RO_Alpha_NDO', NULL, 'Rieske_RO_Alpha_NDO', NULL, NULL, 34598, 2),
(1851, NULL, 'cd08430', NULL, NULL, 'PBP2_IlvY', NULL, 'PBP2_IlvY', NULL, NULL, 32352, 2),
(1852, NULL, 'cd07136', NULL, NULL, 'ALDH_YwdH-P39616', NULL, 'ALDH_YwdH-P39616', NULL, NULL, NULL, 2),
(1853, NULL, 'cd14416', NULL, NULL, 'UBA_NACAD', NULL, 'UBA_NACAD', NULL, NULL, 30073, 2),
(1854, NULL, 'cd15035', NULL, NULL, '7tmF_FZD5_FZD8-like', NULL, '7tmF_FZD5_FZD8-like', NULL, NULL, NULL, 2),
(1855, NULL, 'cd00305', NULL, NULL, 'Cu-Zn_Superoxide_Dismutase', NULL, 'Cu-Zn_Superoxide_Dismutase', NULL, NULL, 3239, 2),
(1856, NULL, 'cd06102', NULL, NULL, 'citrate_synt_like_2', NULL, 'citrate_synt_like_2', NULL, NULL, NULL, 2),
(1857, NULL, 'cd07127', NULL, NULL, 'ALDH_PAD-PaaZ', NULL, 'ALDH_PAD-PaaZ', NULL, NULL, NULL, 2),
(1858, NULL, 'cd05068', NULL, NULL, 'PTKc_Frk_like', NULL, 'PTKc_Frk_like', NULL, NULL, NULL, 2),
(1859, NULL, 'cd16573', NULL, NULL, 'RING-HC_TFB3_like', NULL, 'RING-HC_TFB3_like', NULL, NULL, NULL, 2),
(1860, NULL, 'cd01520', NULL, NULL, 'RHOD_YbbB', NULL, 'RHOD_YbbB', NULL, NULL, NULL, 2),
(1861, NULL, 'cd12470', NULL, NULL, 'RRM1_MSSP1', NULL, 'RRM1_MSSP1', NULL, NULL, 15103, 2),
(1862, NULL, 'cd18514', NULL, NULL, 'BACK_KLHL25_ENC2', NULL, 'BACK_KLHL25_ENC2', NULL, NULL, NULL, 2),
(1863, NULL, 'cd15340', NULL, NULL, '7tmA_CB1', NULL, '7tmA_CB1', NULL, NULL, NULL, 2),
(1864, NULL, 'cd07834', NULL, NULL, 'STKc_MAPK', NULL, 'STKc_MAPK', NULL, NULL, NULL, 2),
(1865, NULL, 'cd04877', NULL, NULL, 'ACT_TyrR', NULL, 'ACT_TyrR', NULL, NULL, NULL, 2),
(1866, NULL, 'cd14829', NULL, NULL, 'Zeta-COP', NULL, 'Zeta-COP', NULL, NULL, NULL, 2),
(1867, NULL, 'cd06239', NULL, NULL, 'M14-like', NULL, 'M14-like', NULL, NULL, NULL, 2),
(1868, NULL, 'cd18436', NULL, NULL, 'BRCT_BRC1_like_rpt2', NULL, 'BRCT_BRC1_like_rpt2', NULL, NULL, NULL, 2),
(1869, NULL, 'cd00105', NULL, NULL, 'KH-I', NULL, 'KH-I', NULL, NULL, NULL, 2),
(1870, NULL, 'cd10814', NULL, NULL, 'GH38N_AMII_SpGH38_like', NULL, 'GH38N_AMII_SpGH38_like', NULL, NULL, NULL, 2),
(1871, NULL, 'sd00036', NULL, NULL, 'LRR_3', NULL, 'LRR_3', NULL, NULL, NULL, 2),
(1872, NULL, 'cd09994', NULL, NULL, 'HDAC_AcuC_like', NULL, 'HDAC_AcuC_like', NULL, NULL, 948, 2),
(1873, NULL, 'cd07553', NULL, NULL, 'P-type_ATPase_HM', NULL, 'P-type_ATPase_HM', NULL, NULL, NULL, 2),
(1874, NULL, 'cd09232', NULL, NULL, 'Snurportin-1_C', NULL, 'Snurportin-1_C', NULL, NULL, NULL, 2),
(1875, NULL, 'cd15207', NULL, NULL, '7tmA_NPFFR', NULL, '7tmA_NPFFR', NULL, NULL, NULL, 2),
(1876, NULL, 'cd00821', NULL, NULL, 'PH', NULL, 'PH', NULL, NULL, NULL, 2),
(1877, NULL, 'cd08512', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_7', NULL, 'PBP2_NikA_DppA_OppA_like_7', NULL, NULL, NULL, 2),
(1878, NULL, 'cd07544', NULL, NULL, 'P-type_ATPase_HM', NULL, 'P-type_ATPase_HM', NULL, NULL, NULL, 2),
(1879, NULL, 'cd05296', NULL, NULL, 'GH4_P_beta_glucosidase', NULL, 'GH4_P_beta_glucosidase', NULL, NULL, NULL, 2),
(1880, NULL, 'cd09690', NULL, NULL, 'Cas7_I-B', NULL, 'Cas7_I-B', NULL, NULL, NULL, 2),
(1881, NULL, 'cd04985', NULL, NULL, 'IgC_CH1_IgAEGM', NULL, 'IgC_CH1_IgAEGM', NULL, NULL, NULL, 2),
(1882, NULL, 'cd06136', NULL, NULL, 'TREX1_2', NULL, 'TREX1_2', NULL, NULL, NULL, 2),
(1883, NULL, 'cd06469', NULL, NULL, 'p23_DYX1C1_like', NULL, 'p23_DYX1C1_like', NULL, NULL, 27270, 2),
(1884, NULL, 'cd06990', NULL, NULL, 'cupin_DUF861', NULL, 'cupin_DUF861', NULL, NULL, NULL, 2),
(1885, NULL, 'cd12943', NULL, NULL, 'LEM_ANKL1', NULL, 'LEM_ANKL1', NULL, NULL, NULL, 2);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(1886, NULL, 'cd03067', NULL, NULL, 'PDI_b_PDIR_N', NULL, 'PDI_b_PDIR_N', NULL, NULL, 30194, 2),
(1887, NULL, 'cd17189', NULL, NULL, 'FERM_F1_FARP1', NULL, 'FERM_F1_FARP1', NULL, NULL, NULL, 2),
(1888, NULL, 'cd01813', NULL, NULL, 'Ubl_UBLCP1', NULL, 'Ubl_UBLCP1', NULL, NULL, NULL, 2),
(1889, NULL, 'cd15875', NULL, NULL, 'SNARE_syntaxin7', NULL, 'SNARE_syntaxin7', NULL, NULL, NULL, 2),
(1890, NULL, 'cd01869', NULL, NULL, 'Rab1_Ypt1', NULL, 'Rab1_Ypt1', NULL, NULL, NULL, 2),
(1891, NULL, 'cd03800', NULL, NULL, 'GT4_sucrose_synthase', NULL, 'GT4_sucrose_synthase', NULL, NULL, NULL, 2),
(1892, NULL, 'cd14517', NULL, NULL, 'DSP_STYXL1', NULL, 'DSP_STYXL1', NULL, NULL, NULL, 2),
(1893, NULL, 'cd15150', NULL, NULL, '7tmA_P2Y12', NULL, '7tmA_P2Y12', NULL, NULL, NULL, 2),
(1894, NULL, 'cd07454', NULL, NULL, 'CRD_LIN_17', NULL, 'CRD_LIN_17', NULL, NULL, 30730, 2),
(1895, NULL, 'cd00435', NULL, NULL, 'ACBP', NULL, 'ACBP', NULL, NULL, 5595, 2),
(1896, NULL, 'cd13393', NULL, NULL, 'PH_ARHGEF2', NULL, 'PH_ARHGEF2', NULL, NULL, 31644, 2),
(1897, NULL, 'cd16786', NULL, NULL, 'mRING-HC-C3HC5_NEU1B', NULL, 'mRING-HC-C3HC5_NEU1B', NULL, NULL, NULL, 2),
(1898, NULL, 'cd19804', NULL, NULL, 'Bbox1_TRIM19_C-V', NULL, 'Bbox1_TRIM19_C-V', NULL, NULL, NULL, 2),
(1899, NULL, 'cd05767', NULL, NULL, 'IgC_MHC_II_alpha', NULL, 'IgC_MHC_II_alpha', NULL, NULL, NULL, 2),
(1900, NULL, 'cd01810', NULL, NULL, 'Ubl2_ISG15', NULL, 'Ubl2_ISG15', NULL, NULL, NULL, 2),
(1901, NULL, 'cd08843', NULL, NULL, 'ArfGap_ADAP1', NULL, 'ArfGap_ADAP1', NULL, NULL, NULL, 2),
(1902, NULL, 'cd13659', NULL, NULL, 'PBP2_PotF', NULL, 'PBP2_PotF', NULL, NULL, NULL, 2),
(1903, NULL, 'cd17128', NULL, NULL, 'Ubl_IKKE', NULL, 'Ubl_IKKE', NULL, NULL, NULL, 2),
(1904, NULL, 'cd16497', NULL, NULL, 'RING-HC_BAR', NULL, 'RING-HC_BAR', NULL, NULL, NULL, 2),
(1905, NULL, 'cd03346', NULL, NULL, 'eu_TrpOH', NULL, 'eu_TrpOH', NULL, NULL, 30059, 2),
(1906, NULL, 'cd11633', NULL, NULL, 'HR1_Rhophilin-1', NULL, 'HR1_Rhophilin-1', NULL, NULL, NULL, 2),
(1907, NULL, 'cd10914', NULL, NULL, 'Peptidase_C25_N_1', NULL, 'Peptidase_C25_N_1', NULL, NULL, NULL, 2),
(1908, NULL, 'cd13530', NULL, NULL, 'PBP2_peptides_like', NULL, 'PBP2_peptides_like', NULL, NULL, NULL, 2),
(1909, NULL, 'cd19912', NULL, NULL, 'DSRM_ILF3_rpt2', NULL, 'DSRM_ILF3_rpt2', NULL, NULL, NULL, 2),
(1910, NULL, 'cd00050', NULL, NULL, 'MH2', NULL, 'MH2', NULL, NULL, NULL, 2),
(1911, NULL, 'cd15136', NULL, NULL, '7tmA_Glyco_hormone_R', NULL, '7tmA_Glyco_hormone_R', NULL, NULL, NULL, 2),
(1912, NULL, 'cd01301', NULL, NULL, 'rDP_like', NULL, 'rDP_like', NULL, NULL, 8620, 2),
(1913, NULL, 'cd09667', NULL, NULL, 'Csb2_I-U', NULL, 'Csb2_I-U', NULL, NULL, NULL, 2),
(1914, NULL, 'cd13602', NULL, NULL, 'PBP2_TRAP_BpDctp6_7', NULL, 'PBP2_TRAP_BpDctp6_7', NULL, NULL, NULL, 2),
(1915, NULL, 'cd17052', NULL, NULL, 'Ubl1_FAT10', NULL, 'Ubl1_FAT10', NULL, NULL, NULL, 2),
(1916, NULL, 'cd06956', NULL, NULL, 'NR_DBD_RXR', NULL, 'NR_DBD_RXR', NULL, NULL, NULL, 2),
(1917, NULL, 'cd14624', NULL, NULL, 'R-PTPc-D-1', NULL, 'R-PTPc-D-1', NULL, NULL, 36505, 2),
(1918, NULL, 'cd15067', NULL, NULL, '7tmA_Dop1R2-like', NULL, '7tmA_Dop1R2-like', NULL, NULL, NULL, 2),
(1919, NULL, 'cd05647', NULL, NULL, 'M20_DapE_actinobac', NULL, 'M20_DapE_actinobac', NULL, NULL, NULL, 2),
(1920, NULL, 'cd09192', NULL, NULL, 'PLDc_DNaseII_beta_2', NULL, 'PLDc_DNaseII_beta_2', NULL, NULL, NULL, 2),
(1921, NULL, 'cd16258', NULL, NULL, 'Tet_III', NULL, 'Tet_III', NULL, NULL, NULL, 2),
(1922, NULL, 'cd08990', NULL, NULL, 'GH43_AXH_like', NULL, 'GH43_AXH_like', NULL, NULL, NULL, 2),
(1923, NULL, 'cd12140', NULL, NULL, 'SH3_Amphiphysin_I', NULL, 'SH3_Amphiphysin_I', NULL, NULL, 15026, 2),
(1924, NULL, 'cd11826', NULL, NULL, 'SH3_Abi', NULL, 'SH3_Abi', NULL, NULL, NULL, 2),
(1925, NULL, 'cd20170', NULL, NULL, 'Peptidase_M90-like', NULL, 'Peptidase_M90-like', NULL, NULL, NULL, 2),
(1926, NULL, 'cd12500', NULL, NULL, 'RRM_BsYxiN_like', NULL, 'RRM_BsYxiN_like', NULL, NULL, NULL, 2),
(1927, NULL, 'cd14186', NULL, NULL, 'STKc_PLK4', NULL, 'STKc_PLK4', NULL, NULL, NULL, 2);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(1928, NULL, 'cd03353', NULL, NULL, 'LbH_GlmU_C', NULL, 'LbH_GlmU_C', NULL, NULL, 27563, 2),
(1929, NULL, 'cd19872', NULL, NULL, 'DSRM_A1CF-like', NULL, 'DSRM_A1CF-like', NULL, NULL, NULL, 2),
(1930, NULL, 'cd00739', NULL, NULL, 'DHPS', NULL, 'DHPS', NULL, NULL, 5535, 2),
(1931, NULL, 'cd11774', NULL, NULL, 'SH3_Sla1p_2', NULL, 'SH3_Sla1p_2', NULL, NULL, NULL, 2),
(1932, NULL, 'cd04439', NULL, NULL, 'DEP_1_P-Rex', NULL, 'DEP_1_P-Rex', NULL, NULL, 27645, 2),
(1933, NULL, 'cd07134', NULL, NULL, 'ALDH_AlkH-like', NULL, 'ALDH_AlkH-like', NULL, NULL, NULL, 2),
(1934, NULL, 'cd18932', NULL, NULL, 'bHLHzip_Mad3', NULL, 'bHLHzip_Mad3', NULL, NULL, NULL, 2),
(1935, NULL, 'cd05599', NULL, NULL, 'STKc_NDR_like', NULL, 'STKc_NDR_like', NULL, NULL, NULL, 2),
(1936, NULL, 'cd09242', NULL, NULL, 'BRO1_ScBro1_like', NULL, 'BRO1_ScBro1_like', NULL, NULL, NULL, 2),
(1937, NULL, 'cd05496', NULL, NULL, 'Bromo_WDR9_II', NULL, 'Bromo_WDR9_II', NULL, NULL, NULL, 2),
(1938, NULL, 'cd07233', NULL, NULL, 'GlxI_Zn', NULL, 'GlxI_Zn', NULL, NULL, NULL, 2),
(1939, NULL, 'cd02860', NULL, NULL, 'E_set_Pullulanase', NULL, 'E_set_Pullulanase', NULL, NULL, NULL, 2),
(1940, NULL, 'cd06336', NULL, NULL, 'PBP1_ABC_ligand_binding-like', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, NULL, 2),
(1941, NULL, 'cd14045', NULL, NULL, 'PK_GC_unk', NULL, 'PK_GC_unk', NULL, NULL, NULL, 2),
(1942, NULL, 'cd07151', NULL, NULL, 'ALDH_HBenzADH', NULL, 'ALDH_HBenzADH', NULL, NULL, NULL, 2),
(1943, NULL, 'cd14607', NULL, NULL, 'PTPc-N2', NULL, 'PTPc-N2', NULL, NULL, NULL, 2),
(1944, NULL, 'cd15079', NULL, NULL, '7tmA_photoreceptors_insect', NULL, '7tmA_photoreceptors_insect', NULL, NULL, NULL, 2),
(1945, NULL, 'cd16137', NULL, NULL, 'RA_MRL_RIAM', NULL, 'RA_MRL_RIAM', NULL, NULL, NULL, 2),
(1946, NULL, 'cd03381', NULL, NULL, 'PAP2_glucose_6_phosphatase', NULL, 'PAP2_glucose_6_phosphatase', NULL, NULL, NULL, 2),
(1947, NULL, 'cd11585', NULL, NULL, 'SATB1_N', NULL, 'SATB1_N', NULL, NULL, 24421, 2),
(1948, NULL, 'cd00085', NULL, NULL, 'HNHc', NULL, 'HNHc', NULL, NULL, 848, 2),
(1949, NULL, 'cd01526', NULL, NULL, 'RHOD_ThiF', NULL, 'RHOD_ThiF', NULL, NULL, NULL, 2),
(1950, NULL, 'cd09027', NULL, NULL, 'PET', NULL, 'PET', NULL, NULL, NULL, 2),
(1951, NULL, 'cd15285', NULL, NULL, '7tmC_mGluR_group1', NULL, '7tmC_mGluR_group1', NULL, NULL, NULL, 2),
(1952, NULL, 'cd06466', NULL, NULL, 'p23_CS_SGT1_like', NULL, 'p23_CS_SGT1_like', NULL, NULL, NULL, 2),
(1953, NULL, 'cd05344', NULL, NULL, 'BKR_like_SDR_like', NULL, 'BKR_like_SDR_like', NULL, NULL, NULL, 2),
(1954, NULL, 'cd17323', NULL, NULL, 'MFS_Tpo1_MDR_like', NULL, 'MFS_Tpo1_MDR_like', NULL, NULL, NULL, 2),
(1955, NULL, 'cd00884', NULL, NULL, 'beta_CA_cladeB', NULL, 'beta_CA_cladeB', NULL, NULL, 36046, 2),
(1956, NULL, 'cd15410', NULL, NULL, '7tmA_OR5D-like', NULL, '7tmA_OR5D-like', NULL, NULL, NULL, 2),
(1957, NULL, 'cd15873', NULL, NULL, 'R-SNARE_STXBP5_6', NULL, 'R-SNARE_STXBP5_6', NULL, NULL, NULL, 2),
(1958, NULL, 'cd18082', NULL, NULL, 'SpoU-like_family', NULL, 'SpoU-like_family', NULL, NULL, NULL, 2),
(1959, NULL, 'cd05612', NULL, NULL, 'STKc_PRKX_like', NULL, 'STKc_PRKX_like', NULL, NULL, NULL, 2),
(1960, NULL, 'cd05850', NULL, NULL, 'Ig1_Contactin-2', NULL, 'Ig1_Contactin-2', NULL, NULL, NULL, 2),
(1961, NULL, 'cd06553', NULL, NULL, 'ASCH_Ef3133_like', NULL, 'ASCH_Ef3133_like', NULL, NULL, 14245, 2),
(1962, NULL, 'cd07502', NULL, NULL, 'HAD_PNKP-C', NULL, 'HAD_PNKP-C', NULL, NULL, 34560, 2),
(1963, NULL, 'cd06093', NULL, NULL, 'PX_domain', NULL, 'PX_domain', NULL, NULL, NULL, 2),
(1964, NULL, 'cd19108', NULL, NULL, 'AKR_AKR1C1-35', NULL, 'AKR_AKR1C1-35', NULL, NULL, 34072, 2),
(1965, NULL, 'cd06629', NULL, NULL, 'STKc_Bck1_like', NULL, 'STKc_Bck1_like', NULL, NULL, NULL, 2),
(1966, NULL, 'cd12002', NULL, NULL, 'SH3_NEDD9', NULL, 'SH3_NEDD9', NULL, NULL, 28440, 2),
(1967, NULL, 'cd08515', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_10', NULL, 'PBP2_NikA_DppA_OppA_like_10', NULL, NULL, NULL, 2),
(1968, NULL, 'cd06893', NULL, NULL, 'PX_SNX19', NULL, 'PX_SNX19', NULL, NULL, 27353, 2),
(1969, NULL, 'cd15832', NULL, NULL, 'SNAP', NULL, 'SNAP', NULL, NULL, 6737, 2);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(1970, NULL, 'cd17454', NULL, NULL, 'MFS_NaGLT1_MFSD4B', NULL, 'MFS_NaGLT1_MFSD4B', NULL, NULL, NULL, 2),
(1971, NULL, 'cd17743', NULL, NULL, 'BRCT_BRC1_like_rpt5', NULL, 'BRCT_BRC1_like_rpt5', NULL, NULL, NULL, 2),
(1972, NULL, 'cd03025', NULL, NULL, 'DsbA_FrnE_like', NULL, 'DsbA_FrnE_like', NULL, NULL, NULL, 2),
(1973, NULL, 'cd14716', NULL, NULL, 'bZIP_CEBP-like_1', NULL, 'bZIP_CEBP-like_1', NULL, NULL, NULL, 2),
(1974, NULL, 'cd16493', NULL, NULL, 'RING-CH-C4HC3_NSE1', NULL, 'RING-CH-C4HC3_NSE1', NULL, NULL, 13488, 2),
(1975, NULL, 'cd02584', NULL, NULL, 'RNAP_II_Rpb1_C', NULL, 'RNAP_II_Rpb1_C', NULL, NULL, NULL, 2),
(1976, NULL, 'cd00396', NULL, NULL, 'PurM-like', NULL, 'PurM-like', NULL, NULL, NULL, 2),
(1977, NULL, 'cd16634', NULL, NULL, 'mRING-HC-C3HC3D_Nrdp1', NULL, 'mRING-HC-C3HC3D_Nrdp1', NULL, NULL, NULL, 2),
(1978, NULL, 'cd00740', NULL, NULL, 'MeTr', NULL, 'MeTr', NULL, NULL, NULL, 2),
(1979, NULL, 'cd16165', NULL, NULL, 'OCRE_ZOP1_plant', NULL, 'OCRE_ZOP1_plant', NULL, NULL, 33121, 2),
(1980, NULL, 'cd05483', NULL, NULL, 'retropepsin_like_bacteria', NULL, 'retropepsin_like_bacteria', NULL, NULL, 17626, 2),
(1981, NULL, 'cd06244', NULL, NULL, 'M14-like', NULL, 'M14-like', NULL, NULL, NULL, 2),
(1982, NULL, 'cd07291', NULL, NULL, 'PX_SNX5', NULL, 'PX_SNX5', NULL, NULL, 37199, 2),
(1983, NULL, 'cd04713', NULL, NULL, 'BAH_plant_3', NULL, 'BAH_plant_3', NULL, NULL, NULL, 2),
(1984, NULL, 'cd14097', NULL, NULL, 'STKc_STK33', NULL, 'STKc_STK33', NULL, NULL, NULL, 2),
(1985, NULL, 'cd02429', NULL, NULL, 'PTH2_like', NULL, 'PTH2_like', NULL, NULL, NULL, 2),
(1986, NULL, 'cd16341', NULL, NULL, 'FdhE', NULL, 'FdhE', NULL, NULL, 6997, 2),
(1987, NULL, 'cd16704', NULL, NULL, 'RING-HC_RNF20_like', NULL, 'RING-HC_RNF20_like', NULL, NULL, NULL, 2),
(1988, NULL, 'cd03892', NULL, NULL, 'M20_peptT', NULL, 'M20_peptT', NULL, NULL, NULL, 2),
(1989, NULL, 'cd15607', NULL, NULL, 'PHD2_KDM5B', NULL, 'PHD2_KDM5B', NULL, NULL, NULL, 2),
(1990, NULL, 'cd03738', NULL, NULL, 'SOCS_SOCS4', NULL, 'SOCS_SOCS4', NULL, NULL, 27676, 2),
(1991, NULL, 'cd06989', NULL, NULL, 'cupin_DRT102', NULL, 'cupin_DRT102', NULL, NULL, NULL, 2),
(1992, NULL, 'cd09877', NULL, NULL, 'PIN_YacL-like', NULL, 'PIN_YacL-like', NULL, NULL, NULL, 2),
(1993, NULL, 'cd14878', NULL, NULL, 'MYSc_Myo16', NULL, 'MYSc_Myo16', NULL, NULL, 28048, 2),
(1994, NULL, 'cd02661', NULL, NULL, 'Peptidase_C19E', NULL, 'Peptidase_C19E', NULL, NULL, NULL, 2),
(1995, NULL, 'cd10367', NULL, NULL, 'SH2_Src_Fgr', NULL, 'SH2_Src_Fgr', NULL, NULL, 31070, 2),
(1996, NULL, 'cd15968', NULL, NULL, '7tmA_P2Y6_P2Y3-like', NULL, '7tmA_P2Y6_P2Y3-like', NULL, NULL, NULL, 2),
(1997, NULL, 'cd15826', NULL, NULL, 'SPRY_PRY_TRIM15', NULL, 'SPRY_PRY_TRIM15', NULL, NULL, NULL, 2),
(1998, NULL, 'cd08822', NULL, NULL, 'FMT_core_like_2', NULL, 'FMT_core_like_2', NULL, NULL, NULL, 2),
(1999, NULL, 'cd10452', NULL, NULL, 'GIY-YIG_RE_Eco29kI_NgoMIII', NULL, 'GIY-YIG_RE_Eco29kI_NgoMIII', NULL, NULL, NULL, 2),
(2000, NULL, 'cd19892', NULL, NULL, 'DSRM_PRKRA_rpt3', NULL, 'DSRM_PRKRA_rpt3', NULL, NULL, 34118, 2),
(2001, NULL, 'cd05095', NULL, NULL, 'PTKc_DDR2', NULL, 'PTKc_DDR2', NULL, NULL, NULL, 2),
(2002, NULL, 'cd15666', NULL, NULL, 'ePHD2_KMT2C_like', NULL, 'ePHD2_KMT2C_like', NULL, NULL, NULL, 2),
(2003, NULL, 'cd18247', NULL, NULL, 'BTB_POZ_KLHL18', NULL, 'BTB_POZ_KLHL18', NULL, NULL, 25152, 2),
(2004, NULL, 'cd03867', NULL, NULL, 'M14_CPZ', NULL, 'M14_CPZ', NULL, NULL, 18288, 2),
(2005, NULL, 'cd06165', NULL, NULL, 'Sortase_A', NULL, 'Sortase_A', NULL, NULL, 30986, 2),
(2006, NULL, 'cd00385', NULL, NULL, 'Isoprenoid_Biosyn_C1', NULL, 'Isoprenoid_Biosyn_C1', NULL, NULL, NULL, 2),
(2007, NULL, 'cd05157', NULL, NULL, 'ETNK_euk', NULL, 'ETNK_euk', NULL, NULL, NULL, 2),
(2008, NULL, 'cd08423', NULL, NULL, 'PBP2_LTTR_like_6', NULL, 'PBP2_LTTR_like_6', NULL, NULL, NULL, 2),
(2009, NULL, 'cd04903', NULL, NULL, 'ACT_LSD', NULL, 'ACT_LSD', NULL, NULL, NULL, 2),
(2010, NULL, 'cd10550', NULL, NULL, 'DMSOR_beta_like', NULL, 'DMSOR_beta_like', NULL, NULL, NULL, 2),
(2011, NULL, 'cd16735', NULL, NULL, 'RING-HC_PCGF3', NULL, 'RING-HC_PCGF3', NULL, NULL, NULL, 2);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(2012, NULL, 'cd03415', NULL, NULL, 'CbiX_CbiC', NULL, 'CbiX_CbiC', NULL, NULL, NULL, 2),
(2013, NULL, 'cd04248', NULL, NULL, 'AAK_AK-Ectoine', NULL, 'AAK_AK-Ectoine', NULL, NULL, 30135, 2),
(2014, NULL, 'cd06234', NULL, NULL, 'M14_PaCCP-like', NULL, 'M14_PaCCP-like', NULL, NULL, NULL, 2),
(2015, NULL, 'cd09241', NULL, NULL, 'BRO1_ScRim20-like', NULL, 'BRO1_ScRim20-like', NULL, NULL, NULL, 2),
(2016, NULL, 'cd07418', NULL, NULL, 'MPP_PP7', NULL, 'MPP_PP7', NULL, NULL, 30622, 2),
(2017, NULL, 'cd12373', NULL, NULL, 'RRM_SRSF3_like', NULL, 'RRM_SRSF3_like', NULL, NULL, NULL, 2),
(2018, NULL, 'cd14078', NULL, NULL, 'STKc_MELK', NULL, 'STKc_MELK', NULL, NULL, 15508, 2),
(2019, NULL, 'cd06404', NULL, NULL, 'PB1_aPKC', NULL, 'PB1_aPKC', NULL, NULL, 16858, 2),
(2020, NULL, 'cd09235', NULL, NULL, 'V_Alix', NULL, 'V_Alix', NULL, NULL, NULL, 2),
(2021, NULL, 'cd05156', NULL, NULL, 'ChoK_euk', NULL, 'ChoK_euk', NULL, NULL, NULL, 2),
(2022, NULL, 'cd13944', NULL, NULL, 'lytB_ispH', NULL, 'lytB_ispH', NULL, NULL, 5344, 2),
(2023, NULL, 'cd18365', NULL, NULL, 'BTB_POZ_KCTD6_like', NULL, 'BTB_POZ_KCTD6_like', NULL, NULL, NULL, 2),
(2024, NULL, 'cd03192', NULL, NULL, 'GST_C_Sigma_like', NULL, 'GST_C_Sigma_like', NULL, NULL, NULL, 2),
(2025, NULL, 'cd01453', NULL, NULL, 'vWA_transcription_factor_IIH_type', NULL, 'vWA_transcription_factor_IIH_type', NULL, NULL, 1393, 2),
(2026, NULL, 'cd13998', NULL, NULL, 'STKc_TGFbR-like', NULL, 'STKc_TGFbR-like', NULL, NULL, NULL, 2),
(2027, NULL, 'cd17534', NULL, NULL, 'REC_DC-like', NULL, 'REC_DC-like', NULL, NULL, NULL, 2),
(2028, NULL, 'cd14898', NULL, NULL, 'MYSc_Myo37', NULL, 'MYSc_Myo37', NULL, NULL, NULL, 2),
(2029, NULL, 'cd16032', NULL, NULL, 'choline-sulfatase', NULL, 'choline-sulfatase', NULL, NULL, 19426, 2),
(2030, NULL, 'cd09096', NULL, NULL, 'Deadenylase_nocturnin', NULL, 'Deadenylase_nocturnin', NULL, NULL, 27459, 2),
(2031, NULL, 'cd07320', NULL, NULL, 'Extradiol_Dioxygenase_3B_like', NULL, 'Extradiol_Dioxygenase_3B_like', NULL, NULL, NULL, 2),
(2032, NULL, 'cd09265', NULL, NULL, 'AP_Syp1_like_MHD', NULL, 'AP_Syp1_like_MHD', NULL, NULL, NULL, 2),
(2033, NULL, 'cd10156', NULL, NULL, 'FpFrmR-Cterm-like_DUF156', NULL, 'FpFrmR-Cterm-like_DUF156', NULL, NULL, NULL, 2),
(2034, NULL, 'cd15006', NULL, NULL, '7tmA_GPR176', NULL, '7tmA_GPR176', NULL, NULL, 35150, 2),
(2035, NULL, 'cd08481', NULL, NULL, 'PBP2_GcdR_like', NULL, 'PBP2_GcdR_like', NULL, NULL, NULL, 2),
(2036, NULL, 'cd10353', NULL, NULL, 'SH2_Nterm_RasGAP', NULL, 'SH2_Nterm_RasGAP', NULL, NULL, 29731, 2),
(2037, NULL, 'cd19346', NULL, NULL, 'Wnt_Wnt2b', NULL, 'Wnt_Wnt2b', NULL, NULL, NULL, 2),
(2038, NULL, 'cd12667', NULL, NULL, 'RRM3_RAVER1', NULL, 'RRM3_RAVER1', NULL, NULL, NULL, 2),
(2039, NULL, 'cd16465', NULL, NULL, 'RING-H2_PJA1_2', NULL, 'RING-H2_PJA1_2', NULL, NULL, NULL, 2),
(2040, NULL, 'cd06263', NULL, NULL, 'MAM', NULL, 'MAM', NULL, NULL, 3140, 2),
(2041, NULL, 'cd00365', NULL, NULL, 'HMG-CoA_reductase', NULL, 'HMG-CoA_reductase', NULL, NULL, NULL, 2),
(2042, NULL, 'cd12215', NULL, NULL, 'ChiC_BD', NULL, 'ChiC_BD', NULL, NULL, NULL, 2),
(2043, NULL, 'cd00295', NULL, NULL, 'RNA_Cyclase', NULL, 'RNA_Cyclase', NULL, NULL, NULL, 2),
(2044, NULL, 'cd14406', NULL, NULL, 'UBA_MARK2', NULL, 'UBA_MARK2', NULL, NULL, NULL, 2),
(2045, NULL, 'cd04899', NULL, NULL, 'ACT_ACR-UUR-like_2', NULL, 'ACT_ACR-UUR-like_2', NULL, NULL, NULL, 2),
(2046, NULL, 'cd06203', NULL, NULL, 'methionine_synthase_red', NULL, 'methionine_synthase_red', NULL, NULL, NULL, 2),
(2047, NULL, 'cd10407', NULL, NULL, 'SH2_Vav3', NULL, 'SH2_Vav3', NULL, NULL, 32614, 2),
(2048, NULL, 'cd00115', NULL, NULL, 'LMWP', NULL, 'LMWP', NULL, NULL, NULL, 2),
(2049, NULL, 'cd02216', NULL, NULL, 'cupin_GDO-like_N', NULL, 'cupin_GDO-like_N', NULL, NULL, NULL, 2),
(2050, NULL, 'cd06455', NULL, NULL, 'M3A_TOP', NULL, 'M3A_TOP', NULL, NULL, NULL, 2),
(2051, NULL, 'cd03476', NULL, NULL, 'Rieske_ArOX_small', NULL, 'Rieske_ArOX_small', NULL, NULL, 13132, 2),
(2052, NULL, 'cd19746', NULL, NULL, 'bHLH_TS_ASCL4', NULL, 'bHLH_TS_ASCL4', NULL, NULL, NULL, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(2053, NULL, 'cd15420', NULL, NULL, '7tmA_OR2A-like', NULL, '7tmA_OR2A-like', NULL, NULL, NULL, 2),
(2054, NULL, 'cd07419', NULL, NULL, 'MPP_Bsu1_C', NULL, 'MPP_Bsu1_C', NULL, NULL, 30850, 2),
(2055, NULL, 'cd09850', NULL, NULL, 'Ebola-like_HR1-HR2', NULL, 'Ebola-like_HR1-HR2', NULL, NULL, NULL, 2),
(2056, NULL, 'cd13225', NULL, NULL, 'PH-like_bacteria', NULL, 'PH-like_bacteria', NULL, NULL, NULL, 2),
(2057, NULL, 'cd03003', NULL, NULL, 'PDI_a_ERdj5_N', NULL, 'PDI_a_ERdj5_N', NULL, NULL, 33353, 2),
(2058, NULL, 'cd17031', NULL, NULL, 'T3SC_IA_SycN-like', NULL, 'T3SC_IA_SycN-like', NULL, NULL, NULL, 2),
(2059, NULL, 'cd18733', NULL, NULL, 'PIN_RfVapC1-like', NULL, 'PIN_RfVapC1-like', NULL, NULL, NULL, 2),
(2060, NULL, 'cd06968', NULL, NULL, 'NR_DBD_ROR', NULL, 'NR_DBD_ROR', NULL, NULL, 35490, 2),
(2061, NULL, 'cd06836', NULL, NULL, 'PLPDE_III_ODC_DapDC_like_1', NULL, 'PLPDE_III_ODC_DapDC_like_1', NULL, NULL, NULL, 2),
(2062, NULL, 'cd11690', NULL, NULL, 'Tsi2_like', NULL, 'Tsi2_like', NULL, NULL, 31718, 2),
(2063, NULL, 'cd14948', NULL, NULL, 'BACON', NULL, 'BACON', NULL, NULL, 23915, 2),
(2064, NULL, 'cd17652', NULL, NULL, 'A_NRPS_CmdD_like', NULL, 'A_NRPS_CmdD_like', NULL, NULL, NULL, 2),
(2065, NULL, 'cd02236', NULL, NULL, 'cupin_CV2614-like', NULL, 'cupin_CV2614-like', NULL, NULL, NULL, 2),
(2066, NULL, 'cd05111', NULL, NULL, 'PTK_HER3', NULL, 'PTK_HER3', NULL, NULL, NULL, 2),
(2067, NULL, 'cd09083', NULL, NULL, 'EEP-1', NULL, 'EEP-1', NULL, NULL, NULL, 2),
(2068, NULL, 'cd05610', NULL, NULL, 'STKc_MASTL', NULL, 'STKc_MASTL', NULL, NULL, 32355, 2),
(2069, NULL, 'cd07504', NULL, NULL, 'HAD_5NT', NULL, 'HAD_5NT', NULL, NULL, 6960, 2),
(2070, NULL, 'cd02335', NULL, NULL, 'ZZ_ADA2', NULL, 'ZZ_ADA2', NULL, NULL, 30682, 2),
(2071, NULL, 'cd00673', NULL, NULL, 'AlaRS_core', NULL, 'AlaRS_core', NULL, NULL, NULL, 2),
(2072, NULL, 'cd15148', NULL, NULL, '7tmA_GPR34-like', NULL, '7tmA_GPR34-like', NULL, NULL, NULL, 2),
(2073, NULL, 'cd15757', NULL, NULL, 'FYVE_WDFY2', NULL, 'FYVE_WDFY2', NULL, NULL, NULL, 2),
(2074, NULL, 'cd04745', NULL, NULL, 'LbH_paaY_like', NULL, 'LbH_paaY_like', NULL, NULL, NULL, 2),
(2075, NULL, 'cd13383', NULL, NULL, 'PH_OCRL2', NULL, 'PH_OCRL2', NULL, NULL, 23634, 2),
(2076, NULL, 'cd20219', NULL, NULL, 'PFM_physalysin-1-like', NULL, 'PFM_physalysin-1-like', NULL, NULL, NULL, 2),
(2077, NULL, 'cd15506', NULL, NULL, 'PHD1_KMT2A_like', NULL, 'PHD1_KMT2A_like', NULL, NULL, NULL, 2),
(2078, NULL, 'cd10974', NULL, NULL, 'CE4_CDA_like_1', NULL, 'CE4_CDA_like_1', NULL, NULL, NULL, 2),
(2079, NULL, 'cd17409', NULL, NULL, 'MFS_NIMT_like', NULL, 'MFS_NIMT_like', NULL, NULL, NULL, 2),
(2080, NULL, 'cd18774', NULL, NULL, 'PDC2_HK_sensor', NULL, 'PDC2_HK_sensor', NULL, NULL, NULL, 2),
(2081, NULL, 'cd16143', NULL, NULL, 'ARS_like', NULL, 'ARS_like', NULL, NULL, NULL, 2),
(2082, NULL, 'cd14653', NULL, NULL, 'ZIP_Gal4p-like', NULL, 'ZIP_Gal4p-like', NULL, NULL, NULL, 2),
(2083, NULL, 'cd05059', NULL, NULL, 'PTKc_Tec_like', NULL, 'PTKc_Tec_like', NULL, NULL, NULL, 2),
(2084, NULL, 'cd12127', NULL, NULL, 'PE-PC-PEC_beta', NULL, 'PE-PC-PEC_beta', NULL, NULL, NULL, 2),
(2085, NULL, 'cd02413', NULL, NULL, '40S_S3_KH', NULL, '40S_S3_KH', NULL, NULL, NULL, 2),
(2086, NULL, 'cd08717', NULL, NULL, 'RGS_RGS5', NULL, 'RGS_RGS5', NULL, NULL, 33656, 2),
(2087, NULL, 'cd08445', NULL, NULL, 'PBP2_BenM_CatM_CatR', NULL, 'PBP2_BenM_CatM_CatR', NULL, NULL, NULL, 2),
(2088, NULL, 'cd18548', NULL, NULL, 'ABC_6TM_Tm287_like', NULL, 'ABC_6TM_Tm287_like', NULL, NULL, NULL, 2),
(2089, NULL, 'cd10466', NULL, NULL, 'FimH_man-bind', NULL, 'FimH_man-bind', NULL, NULL, 12279, 2),
(2090, NULL, 'cd07112', NULL, NULL, 'ALDH_GABALDH-PuuC', NULL, 'ALDH_GABALDH-PuuC', NULL, NULL, NULL, 2),
(2091, NULL, 'cd12046', NULL, NULL, 'SH3_p67phox_C', NULL, 'SH3_p67phox_C', NULL, NULL, NULL, 2),
(2092, NULL, 'cd12157', NULL, NULL, 'PTDH', NULL, 'PTDH', NULL, NULL, NULL, 2),
(2093, NULL, 'cd03184', NULL, NULL, 'GST_C_Omega', NULL, 'GST_C_Omega', NULL, NULL, NULL, 2),
(2094, NULL, 'cd15301', NULL, NULL, '7tmA_mAChR_DM1-like', NULL, '7tmA_mAChR_DM1-like', NULL, NULL, NULL, 2);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(2095, NULL, 'cd05115', NULL, NULL, 'PTKc_Zap-70', NULL, 'PTKc_Zap-70', NULL, NULL, NULL, 2),
(2096, NULL, 'cd17902', NULL, NULL, 'ArfGap_ARAP3', NULL, 'ArfGap_ARAP3', NULL, NULL, NULL, 2),
(2097, NULL, 'cd12442', NULL, NULL, 'RRM_RBM48', NULL, 'RRM_RBM48', NULL, NULL, 6336, 2),
(2098, NULL, 'cd19379', NULL, NULL, 'TGF_beta_GSDF', NULL, 'TGF_beta_GSDF', NULL, NULL, NULL, 2),
(2099, NULL, 'cd14194', NULL, NULL, 'STKc_DAPK1', NULL, 'STKc_DAPK1', NULL, NULL, NULL, 2),
(2100, NULL, 'cd08154', NULL, NULL, 'catalase_clade_1', NULL, 'catalase_clade_1', NULL, NULL, NULL, 2),
(2101, NULL, 'cd15368', NULL, NULL, '7tmA_P2Y8', NULL, '7tmA_P2Y8', NULL, NULL, NULL, 2),
(2102, NULL, 'cd08799', NULL, NULL, 'Death_UNC5C', NULL, 'Death_UNC5C', NULL, NULL, 33897, 2),
(2103, NULL, 'cd11023', NULL, NULL, 'CuRO_2_ceruloplasmin_like_2', NULL, 'CuRO_2_ceruloplasmin_like_2', NULL, NULL, NULL, 2),
(2104, NULL, 'cd17374', NULL, NULL, 'MFS_OAT', NULL, 'MFS_OAT', NULL, NULL, NULL, 2),
(2105, NULL, 'cd00384', NULL, NULL, 'ALAD_PBGS', NULL, 'ALAD_PBGS', NULL, NULL, NULL, 2),
(2106, NULL, 'cd06881', NULL, NULL, 'PX_SNX15_like', NULL, 'PX_SNX15_like', NULL, NULL, NULL, 2),
(2107, NULL, 'cd13676', NULL, NULL, 'PBP2_TRAP_DctP2_like', NULL, 'PBP2_TRAP_DctP2_like', NULL, NULL, NULL, 2),
(2108, NULL, 'cd07474', NULL, NULL, 'Peptidases_S8_subtilisin_Vpr-like', NULL, 'Peptidases_S8_subtilisin_Vpr-like', NULL, NULL, 28780, 2),
(2109, NULL, 'cd17248', NULL, NULL, 'RMtype1_S_AmiI-TRD2-CR2_like', NULL, 'RMtype1_S_AmiI-TRD2-CR2_like', NULL, NULL, NULL, 2),
(2110, NULL, 'cd13183', NULL, NULL, 'FERM_C_FRMPD1_FRMPD3_FRMPD4', NULL, 'FERM_C_FRMPD1_FRMPD3_FRMPD4', NULL, NULL, 30522, 2),
(2111, NULL, 'cd15771', NULL, NULL, 'FYVE1_BSN_PCLO', NULL, 'FYVE1_BSN_PCLO', NULL, NULL, NULL, 2),
(2112, NULL, 'cd06243', NULL, NULL, 'M14_CP_Csd4-like', NULL, 'M14_CP_Csd4-like', NULL, NULL, NULL, 2),
(2113, NULL, 'cd10334', NULL, NULL, 'SLC6sbd_u1', NULL, 'SLC6sbd_u1', NULL, NULL, NULL, 2),
(2114, NULL, 'cd08879', NULL, NULL, 'RHO_alpha_C_AntDO-like', NULL, 'RHO_alpha_C_AntDO-like', NULL, NULL, NULL, 2),
(2115, NULL, 'cd19356', NULL, NULL, 'Wnt_Wnt10b', NULL, 'Wnt_Wnt10b', NULL, NULL, NULL, 2),
(2116, NULL, 'cd11522', NULL, NULL, 'SLC6sbd_SBAT1', NULL, 'SLC6sbd_SBAT1', NULL, NULL, 35926, 2),
(2117, NULL, 'cd17809', NULL, NULL, 'HipA_So_like', NULL, 'HipA_So_like', NULL, NULL, NULL, 2),
(2118, NULL, 'cd10051', NULL, NULL, 'Reelin_repeat_7_subrepeat_2', NULL, 'Reelin_repeat_7_subrepeat_2', NULL, NULL, NULL, 2),
(2119, NULL, 'cd03137', NULL, NULL, 'GATase1_AraC_1', NULL, 'GATase1_AraC_1', NULL, NULL, NULL, 2),
(2120, NULL, 'cd02035', NULL, NULL, 'ArsA', NULL, 'ArsA', NULL, NULL, NULL, 2),
(2121, NULL, 'cd04460', NULL, NULL, 'S1_RpoE', NULL, 'S1_RpoE', NULL, NULL, NULL, 2),
(2122, NULL, 'cd16443', NULL, NULL, 'LplA', NULL, 'LplA', NULL, NULL, NULL, 2),
(2123, NULL, 'cd10378', NULL, NULL, 'SH2_Jak1', NULL, 'SH2_Jak1', NULL, NULL, NULL, 2),
(2124, NULL, 'cd03005', NULL, NULL, 'PDI_a_ERp46', NULL, 'PDI_a_ERp46', NULL, NULL, NULL, 2),
(2125, NULL, 'cd08866', NULL, NULL, 'SRPBCC_11', NULL, 'SRPBCC_11', NULL, NULL, NULL, 2),
(2126, NULL, 'cd15282', NULL, NULL, '7tmC_CaSR', NULL, '7tmC_CaSR', NULL, NULL, NULL, 2),
(2127, NULL, 'cd16308', NULL, NULL, 'GOB1-like_MBL-B3', NULL, 'GOB1-like_MBL-B3', NULL, NULL, NULL, 2),
(2128, NULL, 'cd16506', NULL, NULL, 'RING-HC_DTX3_like', NULL, 'RING-HC_DTX3_like', NULL, NULL, NULL, 2),
(2129, NULL, 'cd01894', NULL, NULL, 'EngA1', NULL, 'EngA1', NULL, NULL, NULL, 2),
(2130, NULL, 'cd03682', NULL, NULL, 'ClC_sycA_like', NULL, 'ClC_sycA_like', NULL, NULL, NULL, 2),
(2131, NULL, 'cd05743', NULL, NULL, 'Ig_Perlecan_like', NULL, 'Ig_Perlecan_like', NULL, NULL, NULL, 2),
(2132, NULL, 'cd12605', NULL, NULL, 'RRM_RALYL', NULL, 'RRM_RALYL', NULL, NULL, 20651, 2),
(2133, NULL, 'cd19031', NULL, NULL, 'LGIC_ECD_nAChR_proto_alpha-like', NULL, 'LGIC_ECD_nAChR_proto_alpha-like', NULL, NULL, NULL, 2),
(2134, NULL, 'cd12371', NULL, NULL, 'RRM2_PUF60', NULL, 'RRM2_PUF60', NULL, NULL, 21490, 2),
(2135, NULL, 'cd06907', NULL, NULL, 'M14_AGBL2-3_like', NULL, 'M14_AGBL2-3_like', NULL, NULL, NULL, 2);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(2136, NULL, 'cd08055', NULL, NULL, 'gp15', NULL, 'gp15', NULL, NULL, NULL, 2),
(2137, NULL, 'cd09949', NULL, NULL, 'RSV-like_HR1-HR2', NULL, 'RSV-like_HR1-HR2', NULL, NULL, NULL, 2),
(2138, NULL, 'cd19430', NULL, NULL, 'lipocalin_trichosorin-like', NULL, 'lipocalin_trichosorin-like', NULL, NULL, NULL, 2),
(2139, NULL, 'cd15138', NULL, NULL, '7tmA_LRR_GPR', NULL, '7tmA_LRR_GPR', NULL, NULL, NULL, 2),
(2140, NULL, 'cd05688', NULL, NULL, 'S1_RPS1_repeat_ec3', NULL, 'S1_RPS1_repeat_ec3', NULL, NULL, NULL, 2),
(2141, NULL, 'cd11919', NULL, NULL, 'SH3_Sorbs1_1', NULL, 'SH3_Sorbs1_1', NULL, NULL, 28452, 2),
(2142, NULL, 'cd01730', NULL, NULL, 'LSm3', NULL, 'LSm3', NULL, NULL, 2772, 2),
(2143, NULL, 'cd09494', NULL, NULL, 'SAM_liprin-kazrin_repeat1', NULL, 'SAM_liprin-kazrin_repeat1', NULL, NULL, NULL, 2),
(2144, NULL, 'cd17341', NULL, NULL, 'MFS_NRT2_like', NULL, 'MFS_NRT2_like', NULL, NULL, 34632, 2),
(2145, NULL, 'cd18982', NULL, NULL, 'CSD', NULL, 'CSD', NULL, NULL, NULL, 2),
(2146, NULL, 'cd18738', NULL, NULL, 'PIN_VapC4-5_FitB-like', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, NULL, 2),
(2147, NULL, 'cd09818', NULL, NULL, 'PIOX_like', NULL, 'PIOX_like', NULL, NULL, 29352, 2),
(2148, NULL, 'cd01224', NULL, NULL, 'PH_Collybistin_ASEF', NULL, 'PH_Collybistin_ASEF', NULL, NULL, NULL, 2),
(2149, NULL, 'cd05283', NULL, NULL, 'CAD1', NULL, 'CAD1', NULL, NULL, NULL, 2),
(2150, NULL, 'cd08982', NULL, NULL, 'GH43-like', NULL, 'GH43-like', NULL, NULL, NULL, 2),
(2151, NULL, 'cd17338', NULL, NULL, 'MFS_unc93_like', NULL, 'MFS_unc93_like', NULL, NULL, 34396, 2),
(2152, NULL, 'cd04755', NULL, NULL, 'Commd7', NULL, 'Commd7', NULL, NULL, 29291, 2),
(2153, NULL, 'cd11995', NULL, NULL, 'SH3_Intersectin1_5', NULL, 'SH3_Intersectin1_5', NULL, NULL, NULL, 2),
(2154, NULL, 'cd16183', NULL, NULL, 'EFh_PEF_ALG-2', NULL, 'EFh_PEF_ALG-2', NULL, NULL, NULL, 2),
(2155, NULL, 'cd11550', NULL, NULL, 'Serine_rich_NEDD9', NULL, 'Serine_rich_NEDD9', NULL, NULL, NULL, 2),
(2156, NULL, 'cd03478', NULL, NULL, 'Rieske_AIFL_N', NULL, 'Rieske_AIFL_N', NULL, NULL, NULL, 2),
(2157, NULL, 'cd15638', NULL, NULL, 'PHD_PHF3', NULL, 'PHD_PHF3', NULL, NULL, NULL, 2),
(2158, NULL, 'cd12750', NULL, NULL, 'RRM5_RBM12B', NULL, 'RRM5_RBM12B', NULL, NULL, NULL, 2),
(2159, NULL, 'cd08062', NULL, NULL, 'MPN_RPN7_8', NULL, 'MPN_RPN7_8', NULL, NULL, 28530, 2),
(2160, NULL, 'cd16896', NULL, NULL, 'LT_Slt70-like', NULL, 'LT_Slt70-like', NULL, NULL, NULL, 2),
(2161, NULL, 'cd00957', NULL, NULL, 'Transaldolase_TalAB', NULL, 'Transaldolase_TalAB', NULL, NULL, 3526, 2),
(2162, NULL, 'cd15692', NULL, NULL, 'PHD1_DPF3', NULL, 'PHD1_DPF3', NULL, NULL, NULL, 2),
(2163, NULL, 'cd01143', NULL, NULL, 'YvrC', NULL, 'YvrC', NULL, NULL, NULL, 2),
(2164, NULL, 'cd05753', NULL, NULL, 'Ig2_FcgammaR_like', NULL, 'Ig2_FcgammaR_like', NULL, NULL, NULL, 2),
(2165, NULL, 'cd15143', NULL, NULL, '7tmA_TXA2_R', NULL, '7tmA_TXA2_R', NULL, NULL, NULL, 2),
(2166, NULL, 'cd17294', NULL, NULL, 'RMtype1_S_MmaC7ORF19P_TRD1-CR1_like', NULL, 'RMtype1_S_MmaC7ORF19P_TRD1-CR1_like', NULL, NULL, NULL, 2),
(2167, NULL, 'cd03813', NULL, NULL, 'GT4-like', NULL, 'GT4-like', NULL, NULL, NULL, 2),
(2168, NULL, 'cd11932', NULL, NULL, 'SH3_SH3RF2_2', NULL, 'SH3_SH3RF2_2', NULL, NULL, 32618, 2),
(2169, NULL, 'cd04468', NULL, NULL, 'S1_eIF5A', NULL, 'S1_eIF5A', NULL, NULL, NULL, 2),
(2170, NULL, 'cd19806', NULL, NULL, 'Bbox1_TRIM32_C-VII', NULL, 'Bbox1_TRIM32_C-VII', NULL, NULL, NULL, 2),
(2171, NULL, 'cd00571', NULL, NULL, 'UreE', NULL, 'UreE', NULL, NULL, 13315, 2),
(2172, NULL, 'cd17377', NULL, NULL, 'MFS_SLC22A15', NULL, 'MFS_SLC22A15', NULL, NULL, NULL, 2),
(2173, NULL, 'cd13282', NULL, NULL, 'PH1_PLEKHH1_PLEKHH2', NULL, 'PH1_PLEKHH1_PLEKHH2', NULL, NULL, NULL, 2),
(2174, NULL, 'cd18394', NULL, NULL, 'BTB_POZ_KCTD6', NULL, 'BTB_POZ_KCTD6', NULL, NULL, NULL, 2),
(2175, NULL, 'cd12902', NULL, NULL, 'SPRY_PRY_RNF135', NULL, 'SPRY_PRY_RNF135', NULL, NULL, 36139, 2),
(2176, NULL, 'cd14348', NULL, NULL, 'UBA_p47', NULL, 'UBA_p47', NULL, NULL, NULL, 2),
(2177, NULL, 'cd11724', NULL, NULL, 'TP_methylase', NULL, 'TP_methylase', NULL, NULL, NULL, 2);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(2178, NULL, 'cd14790', NULL, NULL, 'GH_D', NULL, 'GH_D', NULL, NULL, NULL, 2),
(2179, NULL, 'cd10966', NULL, NULL, 'CE4_yadE_5s', NULL, 'CE4_yadE_5s', NULL, NULL, NULL, 2),
(2180, NULL, 'cd12191', NULL, NULL, 'gal11_coact', NULL, 'gal11_coact', NULL, NULL, 31911, 2),
(2181, NULL, 'cd13982', NULL, NULL, 'STKc_IRE1', NULL, 'STKc_IRE1', NULL, NULL, NULL, 2),
(2182, NULL, 'cd17285', NULL, NULL, 'RMtype1_S_Csp16704I_TRD2-CR2_like', NULL, 'RMtype1_S_Csp16704I_TRD2-CR2_like', NULL, NULL, NULL, 2),
(2183, NULL, 'cd11706', NULL, NULL, 'DHR2_DOCK2', NULL, 'DHR2_DOCK2', NULL, NULL, NULL, 2),
(2184, NULL, 'cd15551', NULL, NULL, 'PHD_PYGO', NULL, 'PHD_PYGO', NULL, NULL, NULL, 2),
(2185, NULL, 'cd19154', NULL, NULL, 'AKR_AKR1G1_CeAKR', NULL, 'AKR_AKR1G1_CeAKR', NULL, NULL, NULL, 2),
(2186, NULL, 'cd09414', NULL, NULL, 'LIM1_LIMPETin', NULL, 'LIM1_LIMPETin', NULL, NULL, NULL, 2),
(2187, NULL, 'cd14141', NULL, NULL, 'STKc_ACVR2a', NULL, 'STKc_ACVR2a', NULL, NULL, NULL, 2),
(2188, NULL, 'cd10356', NULL, NULL, 'SH2_ShkA_ShkC', NULL, 'SH2_ShkA_ShkC', NULL, NULL, 32422, 2),
(2189, NULL, 'cd16935', NULL, NULL, 'HATPase_AgrC-ComD-like', NULL, 'HATPase_AgrC-ComD-like', NULL, NULL, NULL, 2),
(2190, NULL, 'cd10007', NULL, NULL, 'HDAC5', NULL, 'HDAC5', NULL, NULL, NULL, 2),
(2191, NULL, 'cd04848', NULL, NULL, 'Peptidases_S8_Autotransporter_serine_protease_like', NULL, 'Peptidases_S8_Autotransporter_serine_protease_like', NULL, NULL, 27968, 2),
(2192, NULL, 'cd13293', NULL, NULL, 'PH_CpORP2-like', NULL, 'PH_CpORP2-like', NULL, NULL, NULL, 2),
(2193, NULL, 'cd05661', NULL, NULL, 'M28_like_PA', NULL, 'M28_like_PA', NULL, NULL, NULL, 2),
(2194, NULL, 'cd06229', NULL, NULL, 'M14_Endopeptidase_I', NULL, 'M14_Endopeptidase_I', NULL, NULL, 14012, 2),
(2195, NULL, 'cd17304', NULL, NULL, 'PIPKc_PIP5KL1', NULL, 'PIPKc_PIP5KL1', NULL, NULL, NULL, 2),
(2196, NULL, 'cd18641', NULL, NULL, 'CBD_RBP1_like', NULL, 'CBD_RBP1_like', NULL, NULL, NULL, 2),
(2197, NULL, 'cd11265', NULL, NULL, 'Sema_5C', NULL, 'Sema_5C', NULL, NULL, NULL, 2),
(2198, NULL, 'cd06605', NULL, NULL, 'PKc_MAPKK', NULL, 'PKc_MAPKK', NULL, NULL, NULL, 2),
(2199, NULL, 'cd00799', NULL, NULL, 'INT_Cre_C', NULL, 'INT_Cre_C', NULL, NULL, NULL, 2),
(2200, NULL, 'cd03727', NULL, NULL, 'SOCS_ASB8', NULL, 'SOCS_ASB8', NULL, NULL, 29829, 2),
(2201, NULL, 'cd00765', NULL, NULL, 'Pyrophosphate_PFK', NULL, 'Pyrophosphate_PFK', NULL, NULL, NULL, 2),
(2202, NULL, 'cd03341', NULL, NULL, 'TCP1_theta', NULL, 'TCP1_theta', NULL, NULL, 11578, 2),
(2203, NULL, 'cd01488', NULL, NULL, 'Uba3_RUB', NULL, 'Uba3_RUB', NULL, NULL, NULL, 2),
(2204, NULL, 'cd10161', NULL, NULL, 'CsoR-like_DUF156_4', NULL, 'CsoR-like_DUF156_4', NULL, NULL, NULL, 2),
(2205, NULL, 'cd04163', NULL, NULL, 'Era', NULL, 'Era', NULL, NULL, 26957, 2),
(2206, NULL, 'cd05392', NULL, NULL, 'RasGAP_Neurofibromin_like', NULL, 'RasGAP_Neurofibromin_like', NULL, NULL, NULL, 2),
(2207, NULL, 'cd14580', NULL, NULL, 'DUSP13A', NULL, 'DUSP13A', NULL, NULL, NULL, 2),
(2208, NULL, 'cd18588', NULL, NULL, 'ABC_6TM_CyaB_HlyB_like', NULL, 'ABC_6TM_CyaB_HlyB_like', NULL, NULL, NULL, 2),
(2209, NULL, 'cd09872', NULL, NULL, 'PIN_Sll0205-like', NULL, 'PIN_Sll0205-like', NULL, NULL, 30746, 2),
(2210, NULL, 'cd11557', NULL, NULL, 'ST7', NULL, 'ST7', NULL, NULL, 4585, 2),
(2211, NULL, 'cd06285', NULL, NULL, 'PBP1_LacI-like', NULL, 'PBP1_LacI-like', NULL, NULL, NULL, 2),
(2212, NULL, 'cd06556', NULL, NULL, 'ICL_KPHMT', NULL, 'ICL_KPHMT', NULL, NULL, NULL, 2),
(2213, NULL, 'cd16939', NULL, NULL, 'HATPase_RstB-like', NULL, 'HATPase_RstB-like', NULL, NULL, NULL, 2),
(2214, NULL, 'cd11704', NULL, NULL, 'DHR2_DOCK3', NULL, 'DHR2_DOCK3', NULL, NULL, NULL, 2),
(2215, NULL, 'cd15417', NULL, NULL, '7tmA_OR5A1-like', NULL, '7tmA_OR5A1-like', NULL, NULL, NULL, 2),
(2216, NULL, 'cd13119', NULL, NULL, 'BF2867_like', NULL, 'BF2867_like', NULL, NULL, NULL, 2),
(2217, NULL, 'cd01857', NULL, NULL, 'HSR1_MMR1', NULL, 'HSR1_MMR1', NULL, NULL, NULL, 2),
(2218, NULL, 'cd02767', NULL, NULL, 'MopB_ydeP', NULL, 'MopB_ydeP', NULL, NULL, 30832, 2),
(2219, NULL, 'cd04374', NULL, NULL, 'RhoGAP_Graf', NULL, 'RhoGAP_Graf', NULL, NULL, NULL, 2);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(2220, NULL, 'cd14863', NULL, NULL, 'Fe-ADH-like', NULL, 'Fe-ADH-like', NULL, NULL, NULL, 2),
(2221, NULL, 'cd01434', NULL, NULL, 'EFG_mtEFG1_IV', NULL, 'EFG_mtEFG1_IV', NULL, NULL, 1765, 2),
(2222, NULL, 'cd07338', NULL, NULL, 'M48B_HtpX_like', NULL, 'M48B_HtpX_like', NULL, NULL, NULL, 2),
(2223, NULL, 'cd17474', NULL, NULL, 'MFS_YfmO_like', NULL, 'MFS_YfmO_like', NULL, NULL, NULL, 2),
(2224, NULL, 'cd10977', NULL, NULL, 'CE4_PuuE_SpCDA1', NULL, 'CE4_PuuE_SpCDA1', NULL, NULL, 16801, 2),
(2225, NULL, 'cd01309', NULL, NULL, 'Met_dep_hydrolase_C', NULL, 'Met_dep_hydrolase_C', NULL, NULL, NULL, 2),
(2226, NULL, 'cd17322', NULL, NULL, 'MFS_ARN_like', NULL, 'MFS_ARN_like', NULL, NULL, NULL, 2),
(2227, NULL, 'cd16551', NULL, NULL, 'RING-HC_RNF169', NULL, 'RING-HC_RNF169', NULL, NULL, NULL, 2),
(2228, NULL, 'cd20250', NULL, NULL, 'Phospholamban', NULL, 'Phospholamban', NULL, NULL, 1257, 2),
(2229, NULL, 'cd08433', NULL, NULL, 'PBP2_Nac', NULL, 'PBP2_Nac', NULL, NULL, NULL, 2),
(2230, NULL, 'cd14611', NULL, NULL, 'R-PTPc-R', NULL, 'R-PTPc-R', NULL, NULL, NULL, 2),
(2231, NULL, 'cd00328', NULL, NULL, 'catalase', NULL, 'catalase', NULL, NULL, NULL, 2),
(2232, NULL, 'cd05480', NULL, NULL, 'NRIP_C', NULL, 'NRIP_C', NULL, NULL, 26872, 2),
(2233, NULL, 'cd04469', NULL, NULL, 'S1_Hex1', NULL, 'S1_Hex1', NULL, NULL, 33154, 2),
(2234, NULL, 'cd03446', NULL, NULL, 'MaoC_like', NULL, 'MaoC_like', NULL, NULL, NULL, 2),
(2235, NULL, 'cd10936', NULL, NULL, 'CE4_DAC2', NULL, 'CE4_DAC2', NULL, NULL, 3953, 2),
(2236, NULL, 'cd10815', NULL, NULL, 'GH38N_AMII_EcMngB_like', NULL, 'GH38N_AMII_EcMngB_like', NULL, NULL, NULL, 2),
(2237, NULL, 'cd19369', NULL, NULL, 'TenA_C-like', NULL, 'TenA_C-like', NULL, NULL, NULL, 2),
(2238, NULL, 'cd01243', NULL, NULL, 'PH_MRCK', NULL, 'PH_MRCK', NULL, NULL, NULL, 2),
(2239, NULL, 'cd14999', NULL, NULL, '7tmA_UII-R', NULL, '7tmA_UII-R', NULL, NULL, NULL, 2),
(2240, NULL, 'cd17663', NULL, NULL, 'PFA-DSP_Oca6', NULL, 'PFA-DSP_Oca6', NULL, NULL, NULL, 2),
(2241, NULL, 'cd05571', NULL, NULL, 'STKc_PKB', NULL, 'STKc_PKB', NULL, NULL, NULL, 2),
(2242, NULL, 'cd02152', NULL, NULL, 'OAT', NULL, 'OAT', NULL, NULL, 4625, 2),
(2243, NULL, 'cd15492', NULL, NULL, 'PHD_BRPF_JADE_like', NULL, 'PHD_BRPF_JADE_like', NULL, NULL, NULL, 2),
(2244, NULL, 'cd17375', NULL, NULL, 'MFS_SLC22A16_CT2', NULL, 'MFS_SLC22A16_CT2', NULL, NULL, NULL, 2),
(2245, NULL, 'cd01202', NULL, NULL, 'PTB_FRS2', NULL, 'PTB_FRS2', NULL, NULL, 31730, 2),
(2246, NULL, 'cd15791', NULL, NULL, 'PH1_FDG4', NULL, 'PH1_FDG4', NULL, NULL, 28054, 2),
(2247, NULL, 'cd17489', NULL, NULL, 'MFS_YfcJ_like', NULL, 'MFS_YfcJ_like', NULL, NULL, NULL, 2),
(2248, NULL, 'cd18061', NULL, NULL, 'DEXHc_CHD9', NULL, 'DEXHc_CHD9', NULL, NULL, NULL, 2),
(2249, NULL, 'cd17045', NULL, NULL, 'Ubl_TBCEL', NULL, 'Ubl_TBCEL', NULL, NULL, NULL, 2),
(2250, NULL, 'cd14263', NULL, NULL, 'DAGK_IM_like', NULL, 'DAGK_IM_like', NULL, NULL, NULL, 2),
(2251, NULL, 'cd07600', NULL, NULL, 'BAR_Gvp36', NULL, 'BAR_Gvp36', NULL, NULL, NULL, 2),
(2252, NULL, 'cd18653', NULL, NULL, 'CD_HP1a_insect', NULL, 'CD_HP1a_insect', NULL, NULL, NULL, 2),
(2253, NULL, 'cd20072', NULL, NULL, 'SET_SET1', NULL, 'SET_SET1', NULL, NULL, NULL, 2),
(2254, NULL, 'cd16144', NULL, NULL, 'ARS_like', NULL, 'ARS_like', NULL, NULL, NULL, 2),
(2255, NULL, 'cd05590', NULL, NULL, 'STKc_nPKC_eta', NULL, 'STKc_nPKC_eta', NULL, NULL, 29602, 2),
(2256, NULL, 'cd13698', NULL, NULL, 'PBP2_HisGluGlnArgOpine', NULL, 'PBP2_HisGluGlnArgOpine', NULL, NULL, NULL, 2),
(2257, NULL, 'cd19021', NULL, NULL, 'LGIC_ECD_nAChR_A7L', NULL, 'LGIC_ECD_nAChR_A7L', NULL, NULL, NULL, 2),
(2258, NULL, 'cd03675', NULL, NULL, 'Nudix_Hydrolase_2', NULL, 'Nudix_Hydrolase_2', NULL, NULL, 30399, 2),
(2259, NULL, 'cd15430', NULL, NULL, '7tmA_OR13-like', NULL, '7tmA_OR13-like', NULL, NULL, NULL, 2),
(2260, NULL, 'cd01784', NULL, NULL, 'RA_RASSF2_like', NULL, 'RA_RASSF2_like', NULL, NULL, NULL, 2),
(2261, NULL, 'cd04928', NULL, NULL, 'ACT_TyrKc', NULL, 'ACT_TyrKc', NULL, NULL, NULL, 2),
(2262, NULL, 'cd17357', NULL, NULL, 'MFS_GLUT_Class1_2_like', NULL, 'MFS_GLUT_Class1_2_like', NULL, NULL, NULL, 2);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(2263, NULL, 'cd18052', NULL, NULL, 'DEADc_DDX4', NULL, 'DEADc_DDX4', NULL, NULL, NULL, 2),
(2264, NULL, 'cd15908', NULL, NULL, '7tm_TAS2R40-like', NULL, '7tm_TAS2R40-like', NULL, NULL, NULL, 2),
(2265, NULL, 'cd01830', NULL, NULL, 'XynE_like', NULL, 'XynE_like', NULL, NULL, NULL, 2),
(2266, NULL, 'cd08349', NULL, NULL, 'BLMA_like', NULL, 'BLMA_like', NULL, NULL, 647, 2),
(2267, NULL, 'cd12213', NULL, NULL, 'ABD', NULL, 'ABD', NULL, NULL, NULL, 2),
(2268, NULL, 'cd04453', NULL, NULL, 'S1_RNase_E', NULL, 'S1_RNase_E', NULL, NULL, NULL, 2),
(2269, NULL, 'cd14808', NULL, NULL, 'RAP_D3', NULL, 'RAP_D3', NULL, NULL, 28646, 2),
(2270, NULL, 'cd18200', NULL, NULL, 'BTB_POZ_ZBTB9', NULL, 'BTB_POZ_ZBTB9', NULL, NULL, NULL, 2),
(2271, NULL, 'cd19704', NULL, NULL, 'bHLH_TS_TCF21_capsulin', NULL, 'bHLH_TS_TCF21_capsulin', NULL, NULL, NULL, 2),
(2272, NULL, 'cd05070', NULL, NULL, 'PTKc_Fyn', NULL, 'PTKc_Fyn', NULL, NULL, NULL, 2),
(2273, NULL, 'cd09479', NULL, NULL, 'LIM1_CRP1', NULL, 'LIM1_CRP1', NULL, NULL, NULL, 2),
(2274, NULL, 'cd10486', NULL, NULL, 'EphR_LBD_A8', NULL, 'EphR_LBD_A8', NULL, NULL, 12544, 2),
(2275, NULL, 'cd15327', NULL, NULL, '7tmA_alpha1D_AR', NULL, '7tmA_alpha1D_AR', NULL, NULL, NULL, 2),
(2276, NULL, 'cd11937', NULL, NULL, 'SH3_UBASH3A', NULL, 'SH3_UBASH3A', NULL, NULL, 33677, 2),
(2277, NULL, 'cd03672', NULL, NULL, 'Dcp2p', NULL, 'Dcp2p', NULL, NULL, 35379, 2),
(2278, NULL, 'cd13357', NULL, NULL, 'PH-GRAM_MTMR2_insect-like', NULL, 'PH-GRAM_MTMR2_insect-like', NULL, NULL, NULL, 2),
(2279, NULL, 'cd06447', NULL, NULL, 'D-Ser-dehyd', NULL, 'D-Ser-dehyd', NULL, NULL, NULL, 2),
(2280, NULL, 'cd10528', NULL, NULL, 'SET_SETD8', NULL, 'SET_SETD8', NULL, NULL, NULL, 2),
(2281, NULL, 'cd08058', NULL, NULL, 'MPN_euk_mb', NULL, 'MPN_euk_mb', NULL, NULL, NULL, 2),
(2282, NULL, 'cd06096', NULL, NULL, 'Plasmepsin_5', NULL, 'Plasmepsin_5', NULL, NULL, 27918, 2),
(2283, NULL, 'cd11796', NULL, NULL, 'SH3_DNMBP_N3', NULL, 'SH3_DNMBP_N3', NULL, NULL, 28973, 2),
(2284, NULL, 'cd03776', NULL, NULL, 'MATH_TRAF6', NULL, 'MATH_TRAF6', NULL, NULL, 27852, 2),
(2285, NULL, 'cd11246', NULL, NULL, 'Sema_plexin_C1', NULL, 'Sema_plexin_C1', NULL, NULL, 30873, 2),
(2286, NULL, 'cd13142', NULL, NULL, 'MATE_like_12', NULL, 'MATE_like_12', NULL, NULL, NULL, 2),
(2287, NULL, 'cd14038', NULL, NULL, 'STKc_IKK_beta', NULL, 'STKc_IKK_beta', NULL, NULL, NULL, 2),
(2288, NULL, 'cd02145', NULL, NULL, 'BluB', NULL, 'BluB', NULL, NULL, 12858, 2),
(2289, NULL, 'cd10357', NULL, NULL, 'SH2_ShkD_ShkE', NULL, 'SH2_ShkD_ShkE', NULL, NULL, 28740, 2),
(2290, NULL, 'cd11510', NULL, NULL, 'SLC6sbd_TauT', NULL, 'SLC6sbd_TauT', NULL, NULL, 6757, 2),
(2291, NULL, 'cd05597', NULL, NULL, 'STKc_DMPK_like', NULL, 'STKc_DMPK_like', NULL, NULL, NULL, 2),
(2292, NULL, 'cd09449', NULL, NULL, 'LIM_Mystique', NULL, 'LIM_Mystique', NULL, NULL, NULL, 2),
(2293, NULL, 'cd11332', NULL, NULL, 'AmyAc_OligoGlu_TS', NULL, 'AmyAc_OligoGlu_TS', NULL, NULL, NULL, 2),
(2294, NULL, 'cd15266', NULL, NULL, '7tmB1_GLP2R', NULL, '7tmB1_GLP2R', NULL, NULL, NULL, 2),
(2295, NULL, 'cd08567', NULL, NULL, 'GDPD_SpGDE_like', NULL, 'GDPD_SpGDE_like', NULL, NULL, NULL, 2),
(2296, NULL, 'cd06456', NULL, NULL, 'M3A_DCP', NULL, 'M3A_DCP', NULL, NULL, 1659, 2),
(2297, NULL, 'cd15358', NULL, NULL, '7tmA_NMU-R1', NULL, '7tmA_NMU-R1', NULL, NULL, NULL, 2),
(2298, NULL, 'cd17947', NULL, NULL, 'DEADc_DDX27', NULL, 'DEADc_DDX27', NULL, NULL, NULL, 2),
(2299, NULL, 'cd12176', NULL, NULL, 'PGDH_3', NULL, 'PGDH_3', NULL, NULL, NULL, 2),
(2300, NULL, 'cd01265', NULL, NULL, 'PH_TBC1D2A', NULL, 'PH_TBC1D2A', NULL, NULL, NULL, 2),
(2301, NULL, 'cd01913', NULL, NULL, 'protease_HslV', NULL, 'protease_HslV', NULL, NULL, 15133, 2),
(2302, NULL, 'cd15895', NULL, NULL, 'SNARE_SNAP23N', NULL, 'SNARE_SNAP23N', NULL, NULL, NULL, 2),
(2303, NULL, 'cd04699', NULL, NULL, 'Nudix_Hydrolase_39', NULL, 'Nudix_Hydrolase_39', NULL, NULL, NULL, 2),
(2304, NULL, 'cd08707', NULL, NULL, 'RGS_Axin', NULL, 'RGS_Axin', NULL, NULL, NULL, 2),
(2305, NULL, 'cd14026', NULL, NULL, 'STKc_RIP2', NULL, 'STKc_RIP2', NULL, NULL, NULL, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(2306, NULL, 'cd00986', NULL, NULL, 'PDZ_LON_protease', NULL, 'PDZ_LON_protease', NULL, NULL, 29241, 2),
(2307, NULL, 'cd00497', NULL, NULL, 'PseudoU_synth_TruA_like', NULL, 'PseudoU_synth_TruA_like', NULL, NULL, NULL, 2),
(2308, NULL, 'cd00738', NULL, NULL, 'HGTP_anticodon', NULL, 'HGTP_anticodon', NULL, NULL, NULL, 2),
(2309, NULL, 'cd18067', NULL, NULL, 'DEXHc_RAD54A', NULL, 'DEXHc_RAD54A', NULL, NULL, NULL, 2),
(2310, NULL, 'cd09422', NULL, NULL, 'LIM1_FHL2', NULL, 'LIM1_FHL2', NULL, NULL, NULL, 2),
(2311, NULL, 'cd20493', NULL, NULL, 'M34_ATLF_C-like', NULL, 'M34_ATLF_C-like', NULL, NULL, NULL, 2),
(2312, NULL, 'cd09640', NULL, NULL, 'Cas7_I-C', NULL, 'Cas7_I-C', NULL, NULL, NULL, 2),
(2313, NULL, 'cd04870', NULL, NULL, 'ACT_PSP_1', NULL, 'ACT_PSP_1', NULL, NULL, NULL, 2),
(2314, NULL, 'cd08887', NULL, NULL, 'RHO_alpha_C_3', NULL, 'RHO_alpha_C_3', NULL, NULL, NULL, 2),
(2315, NULL, 'cd04108', NULL, NULL, 'Rab36_Rab34', NULL, 'Rab36_Rab34', NULL, NULL, NULL, 2),
(2316, NULL, 'cd09215', NULL, NULL, 'Thaumatin-like', NULL, 'Thaumatin-like', NULL, NULL, NULL, 2),
(2317, NULL, 'cd00667', NULL, NULL, 'ring_hydroxylating_dioxygenases_beta', NULL, 'ring_hydroxylating_dioxygenases_beta', NULL, NULL, 6824, 2),
(2318, NULL, 'cd11873', NULL, NULL, 'SH3_CD2AP-like_1', NULL, 'SH3_CD2AP-like_1', NULL, NULL, NULL, 2),
(2319, NULL, 'cd14556', NULL, NULL, 'R-PTPc-typeIIb-2', NULL, 'R-PTPc-typeIIb-2', NULL, NULL, NULL, 2),
(2320, NULL, 'cd08589', NULL, NULL, 'PI-PLCc_SaPLC1_like', NULL, 'PI-PLCc_SaPLC1_like', NULL, NULL, 26342, 2),
(2321, NULL, 'cd04509', NULL, NULL, 'PBP1_ABC_transporter_GPCR_C-like', NULL, 'PBP1_ABC_transporter_GPCR_C-like', NULL, NULL, NULL, 2),
(2322, NULL, 'cd06425', NULL, NULL, 'M1P_guanylylT_B_like_N', NULL, 'M1P_guanylylT_B_like_N', NULL, NULL, 35583, 2),
(2323, NULL, 'cd01170', NULL, NULL, 'THZ_kinase', NULL, 'THZ_kinase', NULL, NULL, 6810, 2),
(2324, NULL, 'cd07487', NULL, NULL, 'Peptidases_S8_1', NULL, 'Peptidases_S8_1', NULL, NULL, NULL, 2),
(2325, NULL, 'cd05900', NULL, NULL, 'Ig_Aggrecan', NULL, 'Ig_Aggrecan', NULL, NULL, NULL, 2),
(2326, NULL, 'cd06176', NULL, NULL, 'MFS_BCD_PucC-like', NULL, 'MFS_BCD_PucC-like', NULL, NULL, 23212, 2),
(2327, NULL, 'cd21661', NULL, NULL, 'merbe_CoV_ORF8b-like', NULL, 'merbe_CoV_ORF8b-like', NULL, NULL, 35448, 2),
(2328, NULL, 'cd02435', NULL, NULL, 'CCC1', NULL, 'CCC1', NULL, NULL, NULL, 2),
(2329, NULL, 'cd08953', NULL, NULL, 'KR_2_SDR_x', NULL, 'KR_2_SDR_x', NULL, NULL, NULL, 2),
(2330, NULL, 'cd14398', NULL, NULL, 'UBA_LATS2', NULL, 'UBA_LATS2', NULL, NULL, NULL, 2),
(2331, NULL, 'cd00907', NULL, NULL, 'Bacterioferritin', NULL, 'Bacterioferritin', NULL, NULL, 2463, 2),
(2332, NULL, 'cd03026', NULL, NULL, 'AhpF_NTD_C', NULL, 'AhpF_NTD_C', NULL, NULL, 35331, 2),
(2333, NULL, 'cd17252', NULL, NULL, 'RMtype1_S_EcoKI-TRD1-CR1_like', NULL, 'RMtype1_S_EcoKI-TRD1-CR1_like', NULL, NULL, NULL, 2),
(2334, NULL, 'cd05026', NULL, NULL, 'S-100Z', NULL, 'S-100Z', NULL, NULL, 26199, 2),
(2335, NULL, 'cd07726', NULL, NULL, 'ST1585-like_MBL-fold', NULL, 'ST1585-like_MBL-fold', NULL, NULL, 27299, 2),
(2336, NULL, 'cd18494', NULL, NULL, 'BACK_BTBD19', NULL, 'BACK_BTBD19', NULL, NULL, NULL, 2),
(2337, NULL, 'cd14217', NULL, NULL, 'STKc_SRPK2', NULL, 'STKc_SRPK2', NULL, NULL, NULL, 2),
(2338, NULL, 'cd00505', NULL, NULL, 'Glyco_transf_8', NULL, 'Glyco_transf_8', NULL, NULL, NULL, 2),
(2339, NULL, 'cd00040', NULL, NULL, 'CSF2', NULL, 'CSF2', NULL, NULL, 6701, 2),
(2340, NULL, 'cd07475', NULL, NULL, 'Peptidases_S8_C5a_Peptidase', NULL, 'Peptidases_S8_C5a_Peptidase', NULL, NULL, 28824, 2),
(2341, NULL, 'cd01798', NULL, NULL, 'Ubl_parkin', NULL, 'Ubl_parkin', NULL, NULL, NULL, 2),
(2342, NULL, 'cd14139', NULL, NULL, 'PTKc_Wee1b', NULL, 'PTKc_Wee1b', NULL, NULL, NULL, 2),
(2343, NULL, 'cd15237', NULL, NULL, '7tmA_OR2-like', NULL, '7tmA_OR2-like', NULL, NULL, NULL, 2),
(2344, NULL, 'cd18022', NULL, NULL, 'DEXHc_ASCC3_2', NULL, 'DEXHc_ASCC3_2', NULL, NULL, NULL, 2),
(2345, NULL, 'cd13302', NULL, NULL, 'PH2_Pleckstrin_2', NULL, 'PH2_Pleckstrin_2', NULL, NULL, NULL, 2);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(2346, NULL, 'cd19574', NULL, NULL, 'serpinE3', NULL, 'serpinE3', NULL, NULL, NULL, 2),
(2347, NULL, 'cd12171', NULL, NULL, '2-Hacid_dh_10', NULL, '2-Hacid_dh_10', NULL, NULL, NULL, 2),
(2348, NULL, 'cd20220', NULL, NULL, 'PFM_natterin-3-like', NULL, 'PFM_natterin-3-like', NULL, NULL, NULL, 2),
(2349, NULL, 'sd00031', NULL, NULL, 'LRR_1', NULL, 'LRR_1', NULL, NULL, NULL, 2),
(2350, NULL, 'cd07597', NULL, NULL, 'BAR_SNX8', NULL, 'BAR_SNX8', NULL, NULL, NULL, 2),
(2351, NULL, 'cd16996', NULL, NULL, 'VHS_Tom1L2', NULL, 'VHS_Tom1L2', NULL, NULL, NULL, 2),
(2352, NULL, 'cd04716', NULL, NULL, 'BAH_plantDCM_I', NULL, 'BAH_plantDCM_I', NULL, NULL, NULL, 2),
(2353, NULL, 'cd11884', NULL, NULL, 'SH3_MYO15', NULL, 'SH3_MYO15', NULL, NULL, NULL, 2),
(2354, NULL, 'cd17243', NULL, NULL, 'RMtype1_S_AchA6I-TRD2-CR2_like', NULL, 'RMtype1_S_AchA6I-TRD2-CR2_like', NULL, NULL, NULL, 2),
(2355, NULL, 'cd18820', NULL, NULL, 'GH43_LbAraf43-like', NULL, 'GH43_LbAraf43-like', NULL, NULL, NULL, 2),
(2356, NULL, 'cd13375', NULL, NULL, 'PH_SynGAP', NULL, 'PH_SynGAP', NULL, NULL, 28059, 2),
(2357, NULL, 'cd18354', NULL, NULL, 'BTB_POZ_RCBTB2_CHC1L', NULL, 'BTB_POZ_RCBTB2_CHC1L', NULL, NULL, NULL, 2),
(2358, NULL, 'cd18949', NULL, NULL, 'bHLH-PAS_NCoA3_SRC3', NULL, 'bHLH-PAS_NCoA3_SRC3', NULL, NULL, NULL, 2),
(2359, NULL, 'cd12422', NULL, NULL, 'RRM2_PTBP1_hnRNPL_like', NULL, 'RRM2_PTBP1_hnRNPL_like', NULL, NULL, NULL, 2),
(2360, NULL, 'cd15342', NULL, NULL, '7tmA_LPAR2_Edg4', NULL, '7tmA_LPAR2_Edg4', NULL, NULL, NULL, 2),
(2361, NULL, 'cd16883', NULL, NULL, 'ARID_ARID4B', NULL, 'ARID_ARID4B', NULL, NULL, NULL, 2),
(2362, NULL, 'cd19964', NULL, NULL, 'PBP1_BMP-like', NULL, 'PBP1_BMP-like', NULL, NULL, NULL, 2),
(2363, NULL, 'cd19217', NULL, NULL, 'SET_EZH1', NULL, 'SET_EZH1', NULL, NULL, 36314, 2),
(2364, NULL, 'cd09910', NULL, NULL, 'NGN-insert_like', NULL, 'NGN-insert_like', NULL, NULL, NULL, 2),
(2365, NULL, 'cd00123', NULL, NULL, 'DmpA_OAT', NULL, 'DmpA_OAT', NULL, NULL, NULL, 2),
(2366, NULL, 'cd18583', NULL, NULL, 'ABC_6TM_HMT1', NULL, 'ABC_6TM_HMT1', NULL, NULL, NULL, 2),
(2367, NULL, 'cd01570', NULL, NULL, 'NAPRTase_A', NULL, 'NAPRTase_A', NULL, NULL, NULL, 2),
(2368, NULL, 'cd16740', NULL, NULL, 'RING-HC_RING2', NULL, 'RING-HC_RING2', NULL, NULL, NULL, 2),
(2369, NULL, 'cd06313', NULL, NULL, 'PBP1_ABC_ThpA_XypA', NULL, 'PBP1_ABC_ThpA_XypA', NULL, NULL, NULL, 2),
(2370, NULL, 'cd21560', NULL, NULL, 'betaCoV-Nsp6', NULL, 'betaCoV-Nsp6', NULL, NULL, 35192, 2),
(2371, NULL, 'cd13417', NULL, NULL, 'TNFRSF18', NULL, 'TNFRSF18', NULL, NULL, 12482, 2),
(2372, NULL, 'cd16106', NULL, NULL, 'Ubl_Dsk2p_like', NULL, 'Ubl_Dsk2p_like', NULL, NULL, NULL, 2),
(2373, NULL, 'cd06495', NULL, NULL, 'p23_NUDCD3_like', NULL, 'p23_NUDCD3_like', NULL, NULL, 30045, 2),
(2374, NULL, 'cd02554', NULL, NULL, 'PseudoU_synth_RluF', NULL, 'PseudoU_synth_RluF', NULL, NULL, NULL, 2),
(2375, NULL, 'cd18449', NULL, NULL, 'BACK_KLHL9_13', NULL, 'BACK_KLHL9_13', NULL, NULL, NULL, 2),
(2376, NULL, 'cd07239', NULL, NULL, 'BphC5-RK37_C_like', NULL, 'BphC5-RK37_C_like', NULL, NULL, NULL, 2),
(2377, NULL, 'cd15321', NULL, NULL, '7tmA_alpha2B_AR', NULL, '7tmA_alpha2B_AR', NULL, NULL, NULL, 2),
(2378, NULL, 'cd05110', NULL, NULL, 'PTKc_HER4', NULL, 'PTKc_HER4', NULL, NULL, NULL, 2),
(2379, NULL, 'cd13255', NULL, NULL, 'PH_TAAP2-like', NULL, 'PH_TAAP2-like', NULL, NULL, NULL, 2),
(2380, NULL, 'cd13765', NULL, NULL, 'TGF_beta_ADMP', NULL, 'TGF_beta_ADMP', NULL, NULL, NULL, 2),
(2381, NULL, 'cd00997', NULL, NULL, 'PBP2_GluR0', NULL, 'PBP2_GluR0', NULL, NULL, NULL, 2),
(2382, NULL, 'cd03264', NULL, NULL, 'ABC_drug_resistance_like', NULL, 'ABC_drug_resistance_like', NULL, NULL, NULL, 2),
(2383, NULL, 'cd16871', NULL, NULL, 'ARID_Swi1p-like', NULL, 'ARID_Swi1p-like', NULL, NULL, NULL, 2),
(2384, NULL, 'cd02953', NULL, NULL, 'DsbDgamma', NULL, 'DsbDgamma', NULL, NULL, 27603, 2),
(2385, NULL, 'cd13691', NULL, NULL, 'PBP2_Peb1a_like', NULL, 'PBP2_Peb1a_like', NULL, NULL, NULL, 2),
(2386, NULL, 'cd11297', NULL, NULL, 'PIN_LabA-like_N_1', NULL, 'PIN_LabA-like_N_1', NULL, NULL, NULL, 2);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(2387, NULL, 'cd12064', NULL, NULL, 'SH3_GRAF', NULL, 'SH3_GRAF', NULL, NULL, 17251, 2),
(2388, NULL, 'cd19808', NULL, NULL, 'Bbox1_TRIM42_C-III', NULL, 'Bbox1_TRIM42_C-III', NULL, NULL, NULL, 2),
(2389, NULL, 'cd01062', NULL, NULL, 'RNase_T2_prok', NULL, 'RNase_T2_prok', NULL, NULL, 27700, 2),
(2390, NULL, 'cd12346', NULL, NULL, 'RRM3_NGR1_NAM8_like', NULL, 'RRM3_NGR1_NAM8_like', NULL, NULL, NULL, 2),
(2391, NULL, 'cd00333', NULL, NULL, 'MIP', NULL, 'MIP', NULL, NULL, 4930, 2),
(2392, NULL, 'cd18980', NULL, NULL, 'CD_NC-like', NULL, 'CD_NC-like', NULL, NULL, NULL, 2),
(2393, NULL, 'cd14886', NULL, NULL, 'MYSc_Myo25', NULL, 'MYSc_Myo25', NULL, NULL, NULL, 2),
(2394, NULL, 'cd14919', NULL, NULL, 'MYSc_Myh9', NULL, 'MYSc_Myh9', NULL, NULL, NULL, 2),
(2395, NULL, 'cd08289', NULL, NULL, 'MDR_yhfp_like', NULL, 'MDR_yhfp_like', NULL, NULL, NULL, 2),
(2396, NULL, 'cd09340', NULL, NULL, 'LIM1_Testin_like', NULL, 'LIM1_Testin_like', NULL, NULL, NULL, 2),
(2397, NULL, 'cd00398', NULL, NULL, 'Aldolase_II', NULL, 'Aldolase_II', NULL, NULL, NULL, 2),
(2398, NULL, 'cd11654', NULL, NULL, 'TRF2_RBM', NULL, 'TRF2_RBM', NULL, NULL, 22217, 2),
(2399, NULL, 'cd18781', NULL, NULL, 'ABC_6TM_AarD_CydDC_like', NULL, 'ABC_6TM_AarD_CydDC_like', NULL, NULL, NULL, 2),
(2400, NULL, 'cd07949', NULL, NULL, 'PCA_45_Doxase_B_like_1', NULL, 'PCA_45_Doxase_B_like_1', NULL, NULL, NULL, 2),
(2401, NULL, 'cd06615', NULL, NULL, 'PKc_MEK', NULL, 'PKc_MEK', NULL, NULL, NULL, 2),
(2402, NULL, 'cd14089', NULL, NULL, 'STKc_MAPKAPK', NULL, 'STKc_MAPKAPK', NULL, NULL, NULL, 2),
(2403, NULL, 'cd09410', NULL, NULL, 'LIM3_Leupaxin', NULL, 'LIM3_Leupaxin', NULL, NULL, NULL, 2),
(2404, NULL, 'cd00829', NULL, NULL, 'SCP-x_thiolase', NULL, 'SCP-x_thiolase', NULL, NULL, NULL, 2),
(2405, NULL, 'cd17976', NULL, NULL, 'DEXHc_DHX30', NULL, 'DEXHc_DHX30', NULL, NULL, NULL, 2),
(2406, NULL, 'cd05888', NULL, NULL, 'Ig1_Nectin-4_like', NULL, 'Ig1_Nectin-4_like', NULL, NULL, NULL, 2),
(2407, NULL, 'cd20184', NULL, NULL, 'M34_peptidase_like', NULL, 'M34_peptidase_like', NULL, NULL, NULL, 2),
(2408, NULL, 'cd18919', NULL, NULL, 'bHLH_AtBPE_like', NULL, 'bHLH_AtBPE_like', NULL, NULL, NULL, 2),
(2409, NULL, 'cd15571', NULL, NULL, 'ePHD', NULL, 'ePHD', NULL, NULL, NULL, 2),
(2410, NULL, 'cd04686', NULL, NULL, 'Nudix_Hydrolase_27', NULL, 'Nudix_Hydrolase_27', NULL, NULL, NULL, 2),
(2411, NULL, 'cd03284', NULL, NULL, 'ABC_MutS1', NULL, 'ABC_MutS1', NULL, NULL, NULL, 2),
(2412, NULL, 'cd19980', NULL, NULL, 'PBP1_ABC_ligand_binding-like', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, NULL, 2),
(2413, NULL, 'cd13670', NULL, NULL, 'PBP2_TRAP_Tp0957_like', NULL, 'PBP2_TRAP_Tp0957_like', NULL, NULL, NULL, 2),
(2414, NULL, 'cd15484', NULL, NULL, 'uS7_plant', NULL, 'uS7_plant', NULL, NULL, 7342, 2),
(2415, NULL, 'cd04463', NULL, NULL, 'S1_EF_like', NULL, 'S1_EF_like', NULL, NULL, NULL, 2),
(2416, NULL, 'cd16285', NULL, NULL, 'MBL-B1', NULL, 'MBL-B1', NULL, NULL, NULL, 2),
(2417, NULL, 'cd05668', NULL, NULL, 'M20_Acy1-like', NULL, 'M20_Acy1-like', NULL, NULL, NULL, 2),
(2418, NULL, 'cd16436', NULL, NULL, 'beta_Kdo_transferase', NULL, 'beta_Kdo_transferase', NULL, NULL, NULL, 2),
(2419, NULL, 'cd07340', NULL, NULL, 'M48B_Htpx_like', NULL, 'M48B_Htpx_like', NULL, NULL, NULL, 2),
(2420, NULL, 'cd00840', NULL, NULL, 'MPP_Mre11_N', NULL, 'MPP_Mre11_N', NULL, NULL, 30119, 2),
(2421, NULL, 'cd07170', NULL, NULL, 'NR_DBD_ERR', NULL, 'NR_DBD_ERR', NULL, NULL, NULL, 2),
(2422, NULL, 'cd06437', NULL, NULL, 'CESA_CaSu_A2', NULL, 'CESA_CaSu_A2', NULL, NULL, NULL, 2),
(2423, NULL, 'cd13876', NULL, NULL, 'CuRO_2_Abr2_like', NULL, 'CuRO_2_Abr2_like', NULL, NULL, NULL, 2),
(2424, NULL, 'cd16256', NULL, NULL, 'LumP', NULL, 'LumP', NULL, NULL, NULL, 2),
(2425, NULL, 'cd10483', NULL, NULL, 'EphR_LBD_A5', NULL, 'EphR_LBD_A5', NULL, NULL, 27559, 2),
(2426, NULL, 'cd15958', NULL, NULL, '7tmA_Beta1_AR', NULL, '7tmA_Beta1_AR', NULL, NULL, NULL, 2),
(2427, NULL, 'cd06094', NULL, NULL, 'RP_Saci_like', NULL, 'RP_Saci_like', NULL, NULL, 22807, 2),
(2428, NULL, 'cd13660', NULL, NULL, 'PBP2_PotD', NULL, 'PBP2_PotD', NULL, NULL, NULL, 2);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(2429, NULL, 'cd01846', NULL, NULL, 'fatty_acyltransferase_like', NULL, 'fatty_acyltransferase_like', NULL, NULL, NULL, 2),
(2430, NULL, 'cd03352', NULL, NULL, 'LbH_LpxD', NULL, 'LbH_LpxD', NULL, NULL, 1402, 2),
(2431, NULL, 'cd12712', NULL, NULL, 'RRM_TNRC6B', NULL, 'RRM_TNRC6B', NULL, NULL, 11375, 2),
(2432, NULL, 'cd03716', NULL, NULL, 'SOCS_ASB_like', NULL, 'SOCS_ASB_like', NULL, NULL, NULL, 2),
(2433, NULL, 'cd09325', NULL, NULL, 'TDT_C4-dicarb_trans', NULL, 'TDT_C4-dicarb_trans', NULL, NULL, NULL, 2),
(2434, NULL, 'cd01939', NULL, NULL, 'Ketohexokinase', NULL, 'Ketohexokinase', NULL, NULL, 22813, 2),
(2435, NULL, 'cd05803', NULL, NULL, 'PGM_like4', NULL, 'PGM_like4', NULL, NULL, NULL, 2),
(2436, NULL, 'cd16799', NULL, NULL, 'RING-H2_ZNRF3', NULL, 'RING-H2_ZNRF3', NULL, NULL, 36935, 2),
(2437, NULL, 'cd00496', NULL, NULL, 'PheRS_alpha_core', NULL, 'PheRS_alpha_core', NULL, NULL, NULL, 2),
(2438, NULL, 'cd01180', NULL, NULL, 'IPT_plexin_repeat1', NULL, 'IPT_plexin_repeat1', NULL, NULL, NULL, 2),
(2439, NULL, 'cd00580', NULL, NULL, 'CHMI', NULL, 'CHMI', NULL, NULL, 3966, 2),
(2440, NULL, 'cd11547', NULL, NULL, 'NTP-PPase_HisE', NULL, 'NTP-PPase_HisE', NULL, NULL, NULL, 2),
(2441, NULL, 'cd19187', NULL, NULL, 'PR-SET_PRDM1', NULL, 'PR-SET_PRDM1', NULL, NULL, 34926, 2),
(2442, NULL, 'cd15992', NULL, NULL, '7tmB2_CELSR2', NULL, '7tmB2_CELSR2', NULL, NULL, NULL, 2),
(2443, NULL, 'cd14295', NULL, NULL, 'UBA1_atUBP14', NULL, 'UBA1_atUBP14', NULL, NULL, NULL, 2),
(2444, NULL, 'cd15390', NULL, NULL, '7tmA_TACR', NULL, '7tmA_TACR', NULL, NULL, NULL, 2),
(2445, NULL, 'cd03376', NULL, NULL, 'TPP_PFOR_porB_like', NULL, 'TPP_PFOR_porB_like', NULL, NULL, NULL, 2),
(2446, NULL, 'cd09966', NULL, NULL, 'UP_III_II', NULL, 'UP_III_II', NULL, NULL, NULL, 2),
(2447, NULL, 'cd16652', NULL, NULL, 'dRing_Rmd5p_like', NULL, 'dRing_Rmd5p_like', NULL, NULL, 27896, 2),
(2448, NULL, 'cd17517', NULL, NULL, 'RMtype1_S_EcoKI_StySPI-TRD2-CR2_like', NULL, 'RMtype1_S_EcoKI_StySPI-TRD2-CR2_like', NULL, NULL, NULL, 2),
(2449, NULL, 'cd02234', NULL, NULL, 'cupin_BLR7677-like', NULL, 'cupin_BLR7677-like', NULL, NULL, NULL, 2),
(2450, NULL, 'cd12118', NULL, NULL, 'ttLC_FACS_AEE21_like', NULL, 'ttLC_FACS_AEE21_like', NULL, NULL, NULL, 2),
(2451, NULL, 'cd09363', NULL, NULL, 'LIM3_Enigma_like', NULL, 'LIM3_Enigma_like', NULL, NULL, NULL, 2),
(2452, NULL, 'cd05843', NULL, NULL, 'Peptidase_M48_M56', NULL, 'Peptidase_M48_M56', NULL, NULL, NULL, 2),
(2453, NULL, 'cd09895', NULL, NULL, 'NGN_SP_UpxY', NULL, 'NGN_SP_UpxY', NULL, NULL, NULL, 2),
(2454, NULL, 'cd14916', NULL, NULL, 'MYSc_Myh6', NULL, 'MYSc_Myh6', NULL, NULL, NULL, 2),
(2455, NULL, 'cd18326', NULL, NULL, 'BTB_POZ_ZBTB7A', NULL, 'BTB_POZ_ZBTB7A', NULL, NULL, NULL, 2),
(2456, NULL, 'cd19717', NULL, NULL, 'bHLH_TS_NGN2_ATOH4', NULL, 'bHLH_TS_NGN2_ATOH4', NULL, NULL, NULL, 2),
(2457, NULL, 'cd12782', NULL, NULL, 'RRM2_PTBP1', NULL, 'RRM2_PTBP1', NULL, NULL, NULL, 2),
(2458, NULL, 'cd06385', NULL, NULL, 'PBP1_NPR_A', NULL, 'PBP1_NPR_A', NULL, NULL, NULL, 2),
(2459, NULL, 'cd12224', NULL, NULL, 'RRM_RBM22', NULL, 'RRM_RBM22', NULL, NULL, NULL, 2),
(2460, NULL, 'cd12192', NULL, NULL, 'GCN4_cent', NULL, 'GCN4_cent', NULL, NULL, NULL, 2),
(2461, NULL, 'cd04150', NULL, NULL, 'Arf1_5_like', NULL, 'Arf1_5_like', NULL, NULL, 33754, 2),
(2462, NULL, 'cd07998', NULL, NULL, 'WGR_DNA_ligase', NULL, 'WGR_DNA_ligase', NULL, NULL, NULL, 2),
(2463, NULL, 'cd07328', NULL, NULL, 'M48_Ste24p_like', NULL, 'M48_Ste24p_like', NULL, NULL, NULL, 2),
(2464, NULL, 'cd17924', NULL, NULL, 'DDXDc_reverse_gyrase', NULL, 'DDXDc_reverse_gyrase', NULL, NULL, NULL, 2),
(2465, NULL, 'cd08023', NULL, NULL, 'GH16_laminarinase_like', NULL, 'GH16_laminarinase_like', NULL, NULL, NULL, 2),
(2466, NULL, 'cd01021', NULL, NULL, 'GEWL', NULL, 'GEWL', NULL, NULL, NULL, 2),
(2467, NULL, 'cd14883', NULL, NULL, 'MYSc_Myo22', NULL, 'MYSc_Myo22', NULL, NULL, NULL, 2),
(2468, NULL, 'cd07636', NULL, NULL, 'BAR_GRAF', NULL, 'BAR_GRAF', NULL, NULL, 17433, 2),
(2469, NULL, 'cd02132', NULL, NULL, 'PA_GO-like', NULL, 'PA_GO-like', NULL, NULL, NULL, 2);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(2470, NULL, 'cd14344', NULL, NULL, 'UBA_TYDP2', NULL, 'UBA_TYDP2', NULL, NULL, NULL, 2),
(2471, NULL, 'cd06926', NULL, NULL, 'RNAP_II_RPB11', NULL, 'RNAP_II_RPB11', NULL, NULL, 27736, 2),
(2472, NULL, 'cd17669', NULL, NULL, 'R-PTP-Z-2', NULL, 'R-PTP-Z-2', NULL, NULL, NULL, 2),
(2473, NULL, 'cd01241', NULL, NULL, 'PH_PKB', NULL, 'PH_PKB', NULL, NULL, 33162, 2),
(2474, NULL, 'cd01399', NULL, NULL, 'GlcN6P_deaminase', NULL, 'GlcN6P_deaminase', NULL, NULL, 660, 2),
(2475, NULL, 'cd02568', NULL, NULL, 'PseudoU_synth_PUS1_PUS2', NULL, 'PseudoU_synth_PUS1_PUS2', NULL, NULL, 30948, 2),
(2476, NULL, 'cd20275', NULL, NULL, 'Sarcolamban_B', NULL, 'Sarcolamban_B', NULL, NULL, NULL, 2),
(2477, NULL, 'cd02015', NULL, NULL, 'TPP_AHAS', NULL, 'TPP_AHAS', NULL, NULL, 30629, 2),
(2478, NULL, 'cd18545', NULL, NULL, 'ABC_6TM_YknV_like', NULL, 'ABC_6TM_YknV_like', NULL, NULL, NULL, 2),
(2479, NULL, 'cd16253', NULL, NULL, 'EFh_parvalbumins', NULL, 'EFh_parvalbumins', NULL, NULL, NULL, 2),
(2480, NULL, 'cd09333', NULL, NULL, 'LIM3_PINCH', NULL, 'LIM3_PINCH', NULL, NULL, NULL, 2),
(2481, NULL, 'cd01390', NULL, NULL, 'HMGB-UBF_HMG-box', NULL, 'HMGB-UBF_HMG-box', NULL, NULL, NULL, 2),
(2482, NULL, 'cd01765', NULL, NULL, 'FERM_F0_F1', NULL, 'FERM_F0_F1', NULL, NULL, NULL, 2),
(2483, NULL, 'cd01072', NULL, NULL, 'PBP2_SMa0082_like', NULL, 'PBP2_SMa0082_like', NULL, NULL, NULL, 2),
(2484, NULL, 'cd04683', NULL, NULL, 'Nudix_Hydrolase_24', NULL, 'Nudix_Hydrolase_24', NULL, NULL, NULL, 2),
(2485, NULL, 'cd08713', NULL, NULL, 'RGS_RGS3', NULL, 'RGS_RGS3', NULL, NULL, 29038, 2),
(2486, NULL, 'cd18095', NULL, NULL, 'SpoU-like_rRNA-MTase', NULL, 'SpoU-like_rRNA-MTase', NULL, NULL, NULL, 2),
(2487, NULL, 'cd14588', NULL, NULL, 'PTP-MTMR5', NULL, 'PTP-MTMR5', NULL, NULL, NULL, 2),
(2488, NULL, 'cd00030', NULL, NULL, 'C2', NULL, 'C2', NULL, NULL, NULL, 2),
(2489, NULL, 'cd09476', NULL, NULL, 'LIM1_TLP', NULL, 'LIM1_TLP', NULL, NULL, NULL, 2),
(2490, NULL, 'cd14608', NULL, NULL, 'PTPc-N1', NULL, 'PTPc-N1', NULL, NULL, NULL, 2),
(2491, NULL, 'cd06499', NULL, NULL, 'GT_MraY-like', NULL, 'GT_MraY-like', NULL, NULL, NULL, 2),
(2492, NULL, 'cd17511', NULL, NULL, 'YbjN_AmyR-like', NULL, 'YbjN_AmyR-like', NULL, NULL, NULL, 2),
(2493, NULL, 'cd01264', NULL, NULL, 'PH_MELT_VEPH1', NULL, 'PH_MELT_VEPH1', NULL, NULL, NULL, 2),
(2494, NULL, 'cd07316', NULL, NULL, 'terB_like_DjlA', NULL, 'terB_like_DjlA', NULL, NULL, NULL, 2),
(2495, NULL, 'cd15318', NULL, NULL, '7tmA_TAAR5', NULL, '7tmA_TAAR5', NULL, NULL, NULL, 2),
(2496, NULL, 'cd18213', NULL, NULL, 'BTB_POZ_ZBTB25_ZNF46_KUP', NULL, 'BTB_POZ_ZBTB25_ZNF46_KUP', NULL, NULL, NULL, 2),
(2497, NULL, 'cd01782', NULL, NULL, 'RA1_Afadin', NULL, 'RA1_Afadin', NULL, NULL, NULL, 2),
(2498, NULL, 'cd14167', NULL, NULL, 'STKc_CaMKI_alpha', NULL, 'STKc_CaMKI_alpha', NULL, NULL, NULL, 2),
(2499, NULL, 'cd00704', NULL, NULL, 'MDH', NULL, 'MDH', NULL, NULL, NULL, 2),
(2500, NULL, 'cd09216', NULL, NULL, 'GH64-LPHase-like', NULL, 'GH64-LPHase-like', NULL, NULL, NULL, 2),
(2501, NULL, 'cd14010', NULL, NULL, 'STKc_ULK4', NULL, 'STKc_ULK4', NULL, NULL, NULL, 2),
(2502, NULL, 'cd05212', NULL, NULL, 'NAD_bind_m-THF_DH_Cyclohyd_like', NULL, 'NAD_bind_m-THF_DH_Cyclohyd_like', NULL, NULL, NULL, 2),
(2503, NULL, 'cd08628', NULL, NULL, 'PI-PLCc_gamma2', NULL, 'PI-PLCc_gamma2', NULL, NULL, NULL, 2),
(2504, NULL, 'cd16665', NULL, NULL, 'RING-H2_RNF13_like', NULL, 'RING-H2_RNF13_like', NULL, NULL, NULL, 2),
(2505, NULL, 'cd08568', NULL, NULL, 'GDPD_TmGDE_like', NULL, 'GDPD_TmGDE_like', NULL, NULL, NULL, 2),
(2506, NULL, 'cd07782', NULL, NULL, 'FGGY_YpCarbK_like', NULL, 'FGGY_YpCarbK_like', NULL, NULL, 1151, 2),
(2507, NULL, 'cd11891', NULL, NULL, 'MIAL', NULL, 'MIAL', NULL, NULL, 33076, 2),
(2508, NULL, 'cd17593', NULL, NULL, 'REC_CheC-like', NULL, 'REC_CheC-like', NULL, NULL, NULL, 2),
(2509, NULL, 'cd17389', NULL, NULL, 'MFS_MFSD10', NULL, 'MFS_MFSD10', NULL, NULL, NULL, 2),
(2510, NULL, 'cd06383', NULL, NULL, 'PBP1_iGluR_AMPA_Like', NULL, 'PBP1_iGluR_AMPA_Like', NULL, NULL, NULL, 2),
(2511, NULL, 'cd14340', NULL, NULL, 'UBA_BRSK', NULL, 'UBA_BRSK', NULL, NULL, NULL, 2);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(2512, NULL, 'cd17253', NULL, NULL, 'RMtype1_S_Eco933I-TRD2-CR2_like', NULL, 'RMtype1_S_Eco933I-TRD2-CR2_like', NULL, NULL, NULL, 2),
(2513, NULL, 'cd15864', NULL, NULL, 'SNARE_GS28', NULL, 'SNARE_GS28', NULL, NULL, NULL, 2),
(2514, NULL, 'cd16789', NULL, NULL, 'mRING-HC-C3HC5_MGRN1_like---blasttree', NULL, 'mRING-HC-C3HC5_MGRN1_like---blasttree', NULL, NULL, 34889, 2),
(2515, NULL, 'cd14148', NULL, NULL, 'STKc_MLK2', NULL, 'STKc_MLK2', NULL, NULL, NULL, 2),
(2516, NULL, 'cd05286', NULL, NULL, 'QOR2', NULL, 'QOR2', NULL, NULL, NULL, 2),
(2517, NULL, 'cd08929', NULL, NULL, 'SDR_c4', NULL, 'SDR_c4', NULL, NULL, NULL, 2),
(2518, NULL, 'cd11493', NULL, NULL, 'SLC5sbd_NIS-like_u1', NULL, 'SLC5sbd_NIS-like_u1', NULL, NULL, NULL, 2),
(2519, NULL, 'cd11475', NULL, NULL, 'SLC5sbd_PutP', NULL, 'SLC5sbd_PutP', NULL, NULL, 13834, 2),
(2520, NULL, 'cd09349', NULL, NULL, 'LIM1_Zyxin', NULL, 'LIM1_Zyxin', NULL, NULL, NULL, 2),
(2521, NULL, 'cd13645', NULL, NULL, 'PBP2_HuPBGD_like', NULL, 'PBP2_HuPBGD_like', NULL, NULL, NULL, 2),
(2522, NULL, 'cd12942', NULL, NULL, 'LEM_Man1', NULL, 'LEM_Man1', NULL, NULL, NULL, 2),
(2523, NULL, 'cd11644', NULL, NULL, 'Precorrin-6Y-MT', NULL, 'Precorrin-6Y-MT', NULL, NULL, 12697, 2),
(2524, NULL, 'cd09271', NULL, NULL, 'RNase_H2-C', NULL, 'RNase_H2-C', NULL, NULL, 14116, 2),
(2525, NULL, 'cd14536', NULL, NULL, 'PTP-MTMR9', NULL, 'PTP-MTMR9', NULL, NULL, NULL, 2),
(2526, NULL, 'cd12656', NULL, NULL, 'RRM3_HuD', NULL, 'RRM3_HuD', NULL, NULL, 11403, 2),
(2527, NULL, 'cd08201', NULL, NULL, 'plant_peroxidase_like_1', NULL, 'plant_peroxidase_like_1', NULL, NULL, NULL, 2),
(2528, NULL, 'cd16030', NULL, NULL, 'iduronate-2-sulfatase', NULL, 'iduronate-2-sulfatase', NULL, NULL, 31272, 2),
(2529, NULL, 'cd08859', NULL, NULL, 'ArfGap_SMAP2', NULL, 'ArfGap_SMAP2', NULL, NULL, NULL, 2),
(2530, NULL, 'cd05574', NULL, NULL, 'STKc_phototropin_like', NULL, 'STKc_phototropin_like', NULL, NULL, NULL, 2),
(2531, NULL, 'cd12117', NULL, NULL, 'A_NRPS_Srf_like', NULL, 'A_NRPS_Srf_like', NULL, NULL, NULL, 2),
(2532, NULL, 'cd10314', NULL, NULL, 'FAM20_C', NULL, 'FAM20_C', NULL, NULL, NULL, 2),
(2533, NULL, 'cd19094', NULL, NULL, 'AKR_Tas-like', NULL, 'AKR_Tas-like', NULL, NULL, NULL, 2),
(2534, NULL, 'cd09912', NULL, NULL, 'DLP_2', NULL, 'DLP_2', NULL, NULL, NULL, 2),
(2535, NULL, 'cd06651', NULL, NULL, 'STKc_MEKK3', NULL, 'STKc_MEKK3', NULL, NULL, NULL, 2),
(2536, NULL, 'cd15209', NULL, NULL, '7tmA_Mel1', NULL, '7tmA_Mel1', NULL, NULL, NULL, 2),
(2537, NULL, 'cd16400', NULL, NULL, 'ParB_Srx_like_nuclease', NULL, 'ParB_Srx_like_nuclease', NULL, NULL, NULL, 2),
(2538, NULL, 'cd07795', NULL, NULL, 'FGGY_ScGut1p_like', NULL, 'FGGY_ScGut1p_like', NULL, NULL, NULL, 2),
(2539, NULL, 'cd04598', NULL, NULL, 'CBS_pair_GGDEF_EAL', NULL, 'CBS_pair_GGDEF_EAL', NULL, NULL, NULL, 2),
(2540, NULL, 'cd18350', NULL, NULL, 'BTB_POZ_ABTB2_BPOZ2', NULL, 'BTB_POZ_ABTB2_BPOZ2', NULL, NULL, NULL, 2),
(2541, NULL, 'cd03463', NULL, NULL, '3,4-PCD_alpha', NULL, '3,4-PCD_alpha', NULL, NULL, 9624, 2),
(2542, NULL, 'cd07951', NULL, NULL, 'ED_3B_N_AMMECR1', NULL, 'ED_3B_N_AMMECR1', NULL, NULL, NULL, 2),
(2543, NULL, 'cd06996', NULL, NULL, 'cupin_Lmo2851-like_N', NULL, 'cupin_Lmo2851-like_N', NULL, NULL, NULL, 2),
(2544, NULL, 'cd08195', NULL, NULL, 'DHQS', NULL, 'DHQS', NULL, NULL, NULL, 2),
(2545, NULL, 'cd03037', NULL, NULL, 'GST_N_GRX2', NULL, 'GST_N_GRX2', NULL, NULL, NULL, 2),
(2546, NULL, 'cd12920', NULL, NULL, 'VKOR_3', NULL, 'VKOR_3', NULL, NULL, NULL, 2),
(2547, NULL, 'cd16529', NULL, NULL, 'RING-HC_RAD18', NULL, 'RING-HC_RAD18', NULL, NULL, NULL, 2),
(2548, NULL, 'cd02573', NULL, NULL, 'PseudoU_synth_EcTruB', NULL, 'PseudoU_synth_EcTruB', NULL, NULL, 8750, 2),
(2549, NULL, 'cd17732', NULL, NULL, 'BRCT_Ect2_rpt2', NULL, 'BRCT_Ect2_rpt2', NULL, NULL, NULL, 2),
(2550, NULL, 'cd05920', NULL, NULL, '23DHB-AMP_lg', NULL, '23DHB-AMP_lg', NULL, NULL, NULL, 2),
(2551, NULL, 'cd08834', NULL, NULL, 'ArfGap_ASAP', NULL, 'ArfGap_ASAP', NULL, NULL, NULL, 2),
(2552, NULL, 'cd19060', NULL, NULL, 'LGIC_TM_GlyR_alpha', NULL, 'LGIC_TM_GlyR_alpha', NULL, NULL, NULL, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(2553, NULL, 'cd18397', NULL, NULL, 'BTB_POZ_KCTD12_Pfetin', NULL, 'BTB_POZ_KCTD12_Pfetin', NULL, NULL, NULL, 2),
(2554, NULL, 'cd16578', NULL, NULL, 'RING-HC_TRIM42_C-III', NULL, 'RING-HC_TRIM42_C-III', NULL, NULL, 36867, 2),
(2555, NULL, 'cd11765', NULL, NULL, 'SH3_Nck_1', NULL, 'SH3_Nck_1', NULL, NULL, NULL, 2),
(2556, NULL, 'cd05176', NULL, NULL, 'PI3Kc_C2_alpha', NULL, 'PI3Kc_C2_alpha', NULL, NULL, 31209, 2),
(2557, NULL, 'cd19768', NULL, NULL, 'Bbox2_TRIM14', NULL, 'Bbox2_TRIM14', NULL, NULL, NULL, 2),
(2558, NULL, 'cd20236', NULL, NULL, 'PFM_SP17-like', NULL, 'PFM_SP17-like', NULL, NULL, NULL, 2),
(2559, NULL, 'cd05892', NULL, NULL, 'Ig_Myotilin_C', NULL, 'Ig_Myotilin_C', NULL, NULL, NULL, 2),
(2560, NULL, 'cd14271', NULL, NULL, 'UBA_YLR419W_like', NULL, 'UBA_YLR419W_like', NULL, NULL, 15361, 2),
(2561, NULL, 'cd17186', NULL, NULL, 'FERM_F1_Merlin', NULL, 'FERM_F1_Merlin', NULL, NULL, NULL, 2),
(2562, NULL, 'cd05769', NULL, NULL, 'IgC_TCR_beta', NULL, 'IgC_TCR_beta', NULL, NULL, NULL, 2),
(2563, NULL, 'cd13881', NULL, NULL, 'CuRO_2_McoC_like', NULL, 'CuRO_2_McoC_like', NULL, NULL, NULL, 2),
(2564, NULL, 'cd03217', NULL, NULL, 'ABC_FeS_Assembly', NULL, 'ABC_FeS_Assembly', NULL, NULL, 4082, 2),
(2565, NULL, 'cd01192', NULL, NULL, 'INT_C_like_3', NULL, 'INT_C_like_3', NULL, NULL, NULL, 2),
(2566, NULL, 'sd00030', NULL, NULL, 'zf-RanBP2', NULL, 'zf-RanBP2', NULL, NULL, NULL, 2),
(2567, NULL, 'cd07140', NULL, NULL, 'ALDH_F1L_FTFDH', NULL, 'ALDH_F1L_FTFDH', NULL, NULL, NULL, 2),
(2568, NULL, 'cd12315', NULL, NULL, 'RRM1_RBM19_MRD1', NULL, 'RRM1_RBM19_MRD1', NULL, NULL, NULL, 2),
(2569, NULL, 'cd13895', NULL, NULL, 'CuRO_3_AAO_like_2', NULL, 'CuRO_3_AAO_like_2', NULL, NULL, 33333, 2),
(2570, NULL, 'cd01693', NULL, NULL, 'mtEFG2_like_IV', NULL, 'mtEFG2_like_IV', NULL, NULL, NULL, 2),
(2571, NULL, 'cd09140', NULL, NULL, 'PLDc_vPLD1_2_like_bac_1', NULL, 'PLDc_vPLD1_2_like_bac_1', NULL, NULL, NULL, 2),
(2572, NULL, 'cd00530', NULL, NULL, 'PTE', NULL, 'PTE', NULL, NULL, 5123, 2),
(2573, NULL, 'cd05833', NULL, NULL, 'Ribosomal_P2', NULL, 'Ribosomal_P2', NULL, NULL, 35221, 2),
(2574, NULL, 'cd04098', NULL, NULL, 'eEF2_C_snRNP', NULL, 'eEF2_C_snRNP', NULL, NULL, 32037, 2),
(2575, NULL, 'cd13905', NULL, NULL, 'CuRO_3_tcLLC2_insect_like', NULL, 'CuRO_3_tcLLC2_insect_like', NULL, NULL, NULL, 2),
(2576, NULL, 'cd15544', NULL, NULL, 'PHD_BAZ1A_like', NULL, 'PHD_BAZ1A_like', NULL, NULL, NULL, 2),
(2577, NULL, 'cd01980', NULL, NULL, 'Chlide_reductase_Y', NULL, 'Chlide_reductase_Y', NULL, NULL, NULL, 2),
(2578, NULL, 'cd05354', NULL, NULL, 'SDR_c7', NULL, 'SDR_c7', NULL, NULL, NULL, 2),
(2579, NULL, 'cd08356', NULL, NULL, 'VOC_CChe_VCA0619_like', NULL, 'VOC_CChe_VCA0619_like', NULL, NULL, NULL, 2),
(2580, NULL, 'cd07879', NULL, NULL, 'STKc_p38delta', NULL, 'STKc_p38delta', NULL, NULL, 31128, 2),
(2581, NULL, 'cd03076', NULL, NULL, 'GST_N_Pi', NULL, 'GST_N_Pi', NULL, NULL, NULL, 2),
(2582, NULL, 'cd04852', NULL, NULL, 'Peptidases_S8_3', NULL, 'Peptidases_S8_3', NULL, NULL, 17185, 2),
(2583, NULL, 'cd16482', NULL, NULL, 'RING-H2_UBR1_like', NULL, 'RING-H2_UBR1_like', NULL, NULL, NULL, 2),
(2584, NULL, 'cd17219', NULL, NULL, 'RA_RASSF3', NULL, 'RA_RASSF3', NULL, NULL, NULL, 2),
(2585, NULL, 'cd08832', NULL, NULL, 'ArfGap_ADAP', NULL, 'ArfGap_ADAP', NULL, NULL, NULL, 2),
(2586, NULL, 'cd00433', NULL, NULL, 'Peptidase_M17', NULL, 'Peptidase_M17', NULL, NULL, 14647, 2),
(2587, NULL, 'cd01838', NULL, NULL, 'Isoamyl_acetate_hydrolase_like', NULL, 'Isoamyl_acetate_hydrolase_like', NULL, NULL, NULL, 2),
(2588, NULL, 'cd09408', NULL, NULL, 'LIM2_Leupaxin', NULL, 'LIM2_Leupaxin', NULL, NULL, NULL, 2),
(2589, NULL, 'cd05145', NULL, NULL, 'RIO1_like', NULL, 'RIO1_like', NULL, NULL, NULL, 2),
(2590, NULL, 'cd13964', NULL, NULL, 'PT_UbiA_1', NULL, 'PT_UbiA_1', NULL, NULL, NULL, 2),
(2591, NULL, 'cd15814', NULL, NULL, 'SPRY_PRY_TRIM27', NULL, 'SPRY_PRY_TRIM27', NULL, NULL, 32707, 2),
(2592, NULL, 'cd09687', NULL, NULL, 'Cas7_I-C', NULL, 'Cas7_I-C', NULL, NULL, NULL, 2),
(2593, NULL, 'cd07481', NULL, NULL, 'Peptidases_S8_BacillopeptidaseF-like', NULL, 'Peptidases_S8_BacillopeptidaseF-like', NULL, NULL, 30054, 2);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(2594, NULL, 'cd14404', NULL, NULL, 'UBA_AID_AAPK2', NULL, 'UBA_AID_AAPK2', NULL, NULL, 26906, 2),
(2595, NULL, 'cd08764', NULL, NULL, 'Cyt_b561_CG1275_like', NULL, 'Cyt_b561_CG1275_like', NULL, NULL, NULL, 2),
(2596, NULL, 'cd01474', NULL, NULL, 'vWA_ATR', NULL, 'vWA_ATR', NULL, NULL, NULL, 2),
(2597, NULL, 'cd06878', NULL, NULL, 'PX_SNX25', NULL, 'PX_SNX25', NULL, NULL, 28847, 2),
(2598, NULL, 'cd10152', NULL, NULL, 'SaCsoR-like_DUF156', NULL, 'SaCsoR-like_DUF156', NULL, NULL, NULL, 2),
(2599, NULL, 'cd10541', NULL, NULL, 'SET_SETDB', NULL, 'SET_SETDB', NULL, NULL, NULL, 2),
(2600, NULL, 'cd09321', NULL, NULL, 'TDT_like_3', NULL, 'TDT_like_3', NULL, NULL, NULL, 2),
(2601, NULL, 'cd00604', NULL, NULL, 'IPT_CGTD', NULL, 'IPT_CGTD', NULL, NULL, NULL, 2),
(2602, NULL, 'cd01989', NULL, NULL, 'STK_N', NULL, 'STK_N', NULL, NULL, NULL, 2),
(2603, NULL, 'cd06059', NULL, NULL, 'Tubulin', NULL, 'Tubulin', NULL, NULL, NULL, 2),
(2604, NULL, 'cd04050', NULL, NULL, 'C2B_Synaptotagmin-like', NULL, 'C2B_Synaptotagmin-like', NULL, NULL, 31501, 2),
(2605, NULL, 'cd11579', NULL, NULL, 'Glyco_tran_WbsX', NULL, 'Glyco_tran_WbsX', NULL, NULL, 26934, 2),
(2606, NULL, 'cd15930', NULL, NULL, '7tmB1_Secretin_R-like', NULL, '7tmB1_Secretin_R-like', NULL, NULL, NULL, 2),
(2607, NULL, 'cd11835', NULL, NULL, 'SH3_ARHGAP32_33', NULL, 'SH3_ARHGAP32_33', NULL, NULL, NULL, 2),
(2608, NULL, 'cd07060', NULL, NULL, 'SPOUT_MTase', NULL, 'SPOUT_MTase', NULL, NULL, NULL, 2),
(2609, NULL, 'cd18531', NULL, NULL, 'BACK_RHOBTB2', NULL, 'BACK_RHOBTB2', NULL, NULL, NULL, 2),
(2610, NULL, 'cd09675', NULL, NULL, 'Csy1_I-F', NULL, 'Csy1_I-F', NULL, NULL, NULL, 2),
(2611, NULL, 'cd06392', NULL, NULL, 'PBP1_iGluR_delta_1', NULL, 'PBP1_iGluR_delta_1', NULL, NULL, NULL, 2),
(2612, NULL, 'cd00568', NULL, NULL, 'TPP_enzymes', NULL, 'TPP_enzymes', NULL, NULL, NULL, 2),
(2613, NULL, 'cd15305', NULL, NULL, '7tmA_5-HT2C', NULL, '7tmA_5-HT2C', NULL, NULL, NULL, 2),
(2614, NULL, 'cd14701', NULL, NULL, 'bZIP_BATF', NULL, 'bZIP_BATF', NULL, NULL, NULL, 2),
(2615, NULL, 'cd07690', NULL, NULL, 'Ig1_CD4', NULL, 'Ig1_CD4', NULL, NULL, NULL, 2),
(2616, NULL, 'cd15367', NULL, NULL, '7tmA_GPR68_OGR1', NULL, '7tmA_GPR68_OGR1', NULL, NULL, NULL, 2),
(2617, NULL, 'cd08852', NULL, NULL, 'ArfGap_ACAP1', NULL, 'ArfGap_ACAP1', NULL, NULL, NULL, 2),
(2618, NULL, 'cd16215', NULL, NULL, 'EFh_PI-PLCgamma2', NULL, 'EFh_PI-PLCgamma2', NULL, NULL, NULL, 2),
(2619, NULL, 'cd07995', NULL, NULL, 'TPK', NULL, 'TPK', NULL, NULL, 5938, 2),
(2620, NULL, 'cd05005', NULL, NULL, 'SIS_PHI', NULL, 'SIS_PHI', NULL, NULL, 14897, 2),
(2621, NULL, 'cd04264', NULL, NULL, 'DUF619-NAGS', NULL, 'DUF619-NAGS', NULL, NULL, NULL, 2),
(2622, NULL, 'cd02430', NULL, NULL, 'PTH2', NULL, 'PTH2', NULL, NULL, 5407, 2),
(2623, NULL, 'cd12507', NULL, NULL, 'RRM1_ESRPs_Fusilli', NULL, 'RRM1_ESRPs_Fusilli', NULL, NULL, NULL, 2),
(2624, NULL, 'cd17102', NULL, NULL, 'FERM_F1_FRMD3', NULL, 'FERM_F1_FRMD3', NULL, NULL, NULL, 2),
(2625, NULL, 'cd11885', NULL, NULL, 'SH3_SH3TC', NULL, 'SH3_SH3TC', NULL, NULL, NULL, 2),
(2626, NULL, 'cd04695', NULL, NULL, 'Nudix_Hydrolase_36', NULL, 'Nudix_Hydrolase_36', NULL, NULL, NULL, 2),
(2627, NULL, 'cd16723', NULL, NULL, 'RING-HC_MEX3D', NULL, 'RING-HC_MEX3D', NULL, NULL, NULL, 2),
(2628, NULL, 'cd17370', NULL, NULL, 'MFS_MJ1317_like', NULL, 'MFS_MJ1317_like', NULL, NULL, NULL, 2),
(2629, NULL, 'cd19415', NULL, NULL, 'lipocalin_ApoM_AGP', NULL, 'lipocalin_ApoM_AGP', NULL, NULL, NULL, 2),
(2630, NULL, 'cd16188', NULL, NULL, 'EFh_PEF_CPNS1_2', NULL, 'EFh_PEF_CPNS1_2', NULL, NULL, NULL, 2),
(2631, NULL, 'cd11628', NULL, NULL, 'HR1_CIP4_FNBP1L', NULL, 'HR1_CIP4_FNBP1L', NULL, NULL, NULL, 2),
(2632, NULL, 'cd19141', NULL, NULL, 'Aldo_ket_red_shaker', NULL, 'Aldo_ket_red_shaker', NULL, NULL, NULL, 2),
(2633, NULL, 'cd13400', NULL, NULL, 'LT_IagB-like', NULL, 'LT_IagB-like', NULL, NULL, NULL, 2),
(2634, NULL, 'cd09114', NULL, NULL, 'PLDc_PPK1_C1', NULL, 'PLDc_PPK1_C1', NULL, NULL, NULL, 2),
(2635, NULL, 'cd06179', NULL, NULL, 'MFS_TRI12_like', NULL, 'MFS_TRI12_like', NULL, NULL, NULL, 2);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(2636, NULL, 'cd01237', NULL, NULL, 'PH_fermitin', NULL, 'PH_fermitin', NULL, NULL, 32559, 2),
(2637, NULL, 'cd01774', NULL, NULL, 'UBX_UBXN8', NULL, 'UBX_UBXN8', NULL, NULL, NULL, 2),
(2638, NULL, 'cd17523', NULL, NULL, 'RMtype1_S_StySPI-TRD2-CR2_like', NULL, 'RMtype1_S_StySPI-TRD2-CR2_like', NULL, NULL, NULL, 2),
(2639, NULL, 'cd18539', NULL, NULL, 'SRP_G', NULL, 'SRP_G', NULL, NULL, NULL, 2),
(2640, NULL, 'cd09724', NULL, NULL, 'CsaX_III-U', NULL, 'CsaX_III-U', NULL, NULL, NULL, 2),
(2641, NULL, 'cd12128', NULL, NULL, 'PBP_PBS-LCM', NULL, 'PBP_PBS-LCM', NULL, NULL, NULL, 2),
(2642, NULL, 'cd03205', NULL, NULL, 'GST_C_6', NULL, 'GST_C_6', NULL, NULL, NULL, 2),
(2643, NULL, 'cd19558', NULL, NULL, 'serpinA12_vaspin', NULL, 'serpinA12_vaspin', NULL, NULL, NULL, 2),
(2644, NULL, 'cd10317', NULL, NULL, 'RGL4_C', NULL, 'RGL4_C', NULL, NULL, NULL, 2),
(2645, NULL, 'cd08694', NULL, NULL, 'C2_Dock-A', NULL, 'C2_Dock-A', NULL, NULL, NULL, 2),
(2646, NULL, 'cd09081', NULL, NULL, 'CdtB', NULL, 'CdtB', NULL, NULL, 7395, 2),
(2647, NULL, 'cd18979', NULL, NULL, 'CD_POL_like', NULL, 'CD_POL_like', NULL, NULL, NULL, 2),
(2648, NULL, 'cd07534', NULL, NULL, 'HAD_CAP', NULL, 'HAD_CAP', NULL, NULL, 6504, 2),
(2649, NULL, 'cd08241', NULL, NULL, 'QOR1', NULL, 'QOR1', NULL, NULL, NULL, 2),
(2650, NULL, 'cd16442', NULL, NULL, 'BPL', NULL, 'BPL', NULL, NULL, 5951, 2),
(2651, NULL, 'cd04764', NULL, NULL, 'HTH_MlrA-like_sg1', NULL, 'HTH_MlrA-like_sg1', NULL, NULL, NULL, 2),
(2652, NULL, 'cd14579', NULL, NULL, 'DUSP3', NULL, 'DUSP3', NULL, NULL, NULL, 2),
(2653, NULL, 'cd15280', NULL, NULL, '7tmC_V2R-like', NULL, '7tmC_V2R-like', NULL, NULL, NULL, 2),
(2654, NULL, 'cd18669', NULL, NULL, 'M20_18_42', NULL, 'M20_18_42', NULL, NULL, NULL, 2),
(2655, NULL, 'cd15325', NULL, NULL, '7tmA_alpha1A_AR', NULL, '7tmA_alpha1A_AR', NULL, NULL, NULL, 2),
(2656, NULL, 'cd04669', NULL, NULL, 'Nudix_Hydrolase_11', NULL, 'Nudix_Hydrolase_11', NULL, NULL, NULL, 2),
(2657, NULL, 'cd00187', NULL, NULL, 'TOP4c', NULL, 'TOP4c', NULL, NULL, 5957, 2),
(2658, NULL, 'cd04255', NULL, NULL, 'AAK_UMPK-MosAB', NULL, 'AAK_UMPK-MosAB', NULL, NULL, 25080, 2),
(2659, NULL, 'cd13727', NULL, NULL, 'PBP2_iGluR_AMPA_GluR4', NULL, 'PBP2_iGluR_AMPA_GluR4', NULL, NULL, NULL, 2),
(2660, NULL, 'cd05241', NULL, NULL, '3b-HSD-like_SDR_e', NULL, '3b-HSD-like_SDR_e', NULL, NULL, NULL, 2),
(2661, NULL, 'cd18912', NULL, NULL, 'bHLH_TS_bHLHa9', NULL, 'bHLH_TS_bHLHa9', NULL, NULL, NULL, 2),
(2662, NULL, 'cd10796', NULL, NULL, 'GH57N_APU', NULL, 'GH57N_APU', NULL, NULL, NULL, 2),
(2663, NULL, 'cd15735', NULL, NULL, 'FYVE_spVPS27p_like', NULL, 'FYVE_spVPS27p_like', NULL, NULL, NULL, 2),
(2664, NULL, 'cd07408', NULL, NULL, 'MPP_SA0022_N', NULL, 'MPP_SA0022_N', NULL, NULL, 30819, 2),
(2665, NULL, 'cd14930', NULL, NULL, 'MYSc_Myh14_mammals', NULL, 'MYSc_Myh14_mammals', NULL, NULL, NULL, 2),
(2666, NULL, 'cd16157', NULL, NULL, 'GALNS', NULL, 'GALNS', NULL, NULL, 33496, 2),
(2667, NULL, 'cd09718', NULL, NULL, 'Cas1_I-F', NULL, 'Cas1_I-F', NULL, NULL, 14847, 2),
(2668, NULL, 'cd16242', NULL, NULL, 'EFh_DMD_like', NULL, 'EFh_DMD_like', NULL, NULL, NULL, 2),
(2669, NULL, 'cd05559', NULL, NULL, 'CAP_PI16_HrTT-1', NULL, 'CAP_PI16_HrTT-1', NULL, NULL, NULL, 2),
(2670, NULL, 'cd12295', NULL, NULL, 'RRM_YRA2', NULL, 'RRM_YRA2', NULL, NULL, 1271, 2),
(2671, NULL, 'cd15869', NULL, NULL, 'R-SNARE_VAMP4', NULL, 'R-SNARE_VAMP4', NULL, NULL, NULL, 2),
(2672, NULL, 'cd02876', NULL, NULL, 'GH18_SI-CLP', NULL, 'GH18_SI-CLP', NULL, NULL, NULL, 2),
(2673, NULL, 'cd09575', NULL, NULL, 'SAM_DGK-delta', NULL, 'SAM_DGK-delta', NULL, NULL, 30793, 2),
(2674, NULL, 'cd00086', NULL, NULL, 'homeodomain', NULL, 'homeodomain', NULL, NULL, 7496, 2),
(2675, NULL, 'cd16585', NULL, NULL, 'RING-HC_TIF1_C-VI', NULL, 'RING-HC_TIF1_C-VI', NULL, NULL, NULL, 2),
(2676, NULL, 'cd04025', NULL, NULL, 'C2B_RasA1_RasA4', NULL, 'C2B_RasA1_RasA4', NULL, NULL, NULL, 2),
(2677, NULL, 'cd08273', NULL, NULL, 'MDR8', NULL, 'MDR8', NULL, NULL, NULL, 2),
(2678, NULL, 'cd09028', NULL, NULL, 'ArfGap_ArfGap3', NULL, 'ArfGap_ArfGap3', NULL, NULL, NULL, 2);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(2679, NULL, 'cd09460', NULL, NULL, 'LIM3_ZASP_Cypher', NULL, 'LIM3_ZASP_Cypher', NULL, NULL, NULL, 2),
(2680, NULL, 'cd01637', NULL, NULL, 'IMPase_like', NULL, 'IMPase_like', NULL, NULL, NULL, 2),
(2681, NULL, 'cd05386', NULL, NULL, 'TraL', NULL, 'TraL', NULL, NULL, NULL, 2),
(2682, NULL, 'cd18367', NULL, NULL, 'BTB_POZ_KCTD8-like', NULL, 'BTB_POZ_KCTD8-like', NULL, NULL, NULL, 2),
(2683, NULL, 'cd09633', NULL, NULL, 'Deltex_C', NULL, 'Deltex_C', NULL, NULL, 33483, 2),
(2684, NULL, 'cd14267', NULL, NULL, 'Rif1_CTD_C-II_like', NULL, 'Rif1_CTD_C-II_like', NULL, NULL, NULL, 2),
(2685, NULL, 'cd04814', NULL, NULL, 'PA_M28_1', NULL, 'PA_M28_1', NULL, NULL, NULL, 2),
(2686, NULL, 'cd06252', NULL, NULL, 'M14_ASTE_ASPA-like', NULL, 'M14_ASTE_ASPA-like', NULL, NULL, NULL, 2),
(2687, NULL, 'cd11253', NULL, NULL, 'Sema_3E', NULL, 'Sema_3E', NULL, NULL, NULL, 2),
(2688, NULL, 'cd13168', NULL, NULL, 'PTB_LOC417372', NULL, 'PTB_LOC417372', NULL, NULL, NULL, 2),
(2689, NULL, 'cd08894', NULL, NULL, 'SRPBCC_CalC_Aha1-like_1', NULL, 'SRPBCC_CalC_Aha1-like_1', NULL, NULL, NULL, 2),
(2690, NULL, 'cd11846', NULL, NULL, 'SH3_Srms', NULL, 'SH3_Srms', NULL, NULL, NULL, 2),
(2691, NULL, 'cd18086', NULL, NULL, 'HsC9orf114-like', NULL, 'HsC9orf114-like', NULL, NULL, 2209, 2),
(2692, NULL, 'cd12637', NULL, NULL, 'RRM2_FCA', NULL, 'RRM2_FCA', NULL, NULL, 7047, 2),
(2693, NULL, 'cd15363', NULL, NULL, '7tmA_LGR5', NULL, '7tmA_LGR5', NULL, NULL, NULL, 2),
(2694, NULL, 'cd03589', NULL, NULL, 'CLECT_CEL-1_like', NULL, 'CLECT_CEL-1_like', NULL, NULL, 8915, 2),
(2695, NULL, 'cd08500', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_4', NULL, 'PBP2_NikA_DppA_OppA_like_4', NULL, NULL, NULL, 2),
(2696, NULL, 'cd11979', NULL, NULL, 'SH3_VAV1_1', NULL, 'SH3_VAV1_1', NULL, NULL, 27525, 2),
(2697, NULL, 'cd06187', NULL, NULL, 'O2ase_reductase_like', NULL, 'O2ase_reductase_like', NULL, NULL, NULL, 2),
(2698, NULL, 'cd02140', NULL, NULL, 'Frm2-like', NULL, 'Frm2-like', NULL, NULL, 30881, 2),
(2699, NULL, 'cd19755', NULL, NULL, 'TrHb2_AtGlb3-like_O', NULL, 'TrHb2_AtGlb3-like_O', NULL, NULL, NULL, 2),
(2700, NULL, 'cd00156', NULL, NULL, 'REC', NULL, 'REC', NULL, NULL, NULL, 2),
(2701, NULL, 'cd07125', NULL, NULL, 'ALDH_PutA-P5CDH', NULL, 'ALDH_PutA-P5CDH', NULL, NULL, NULL, 2),
(2702, NULL, 'cd02616', NULL, NULL, 'HAD_PPase', NULL, 'HAD_PPase', NULL, NULL, NULL, 2),
(2703, NULL, 'cd00632', NULL, NULL, 'Prefoldin_beta', NULL, 'Prefoldin_beta', NULL, NULL, NULL, 2),
(2704, NULL, 'cd15045', NULL, NULL, '7tmC_mGluRs', NULL, '7tmC_mGluRs', NULL, NULL, NULL, 2),
(2705, NULL, 'cd18682', NULL, NULL, 'PIN_VapC-like', NULL, 'PIN_VapC-like', NULL, NULL, NULL, 2),
(2706, NULL, 'cd08723', NULL, NULL, 'RGS_RGS21', NULL, 'RGS_RGS21', NULL, NULL, NULL, 2),
(2707, NULL, 'cd19205', NULL, NULL, 'SET_SETD1B', NULL, 'SET_SETD1B', NULL, NULL, NULL, 2),
(2708, NULL, 'cd21628', NULL, NULL, 'deltaCoV_NS7_NS7a', NULL, 'deltaCoV_NS7_NS7a', NULL, NULL, 36200, 2),
(2709, NULL, 'cd14387', NULL, NULL, 'UBA2_UBP13', NULL, 'UBA2_UBP13', NULL, NULL, NULL, 2),
(2710, NULL, 'cd17283', NULL, NULL, 'RMtype1_S_Hpy180ORF7835P_TRD2-CR2_like', NULL, 'RMtype1_S_Hpy180ORF7835P_TRD2-CR2_like', NULL, NULL, NULL, 2),
(2711, NULL, 'cd04009', NULL, NULL, 'C2B_Munc13-like', NULL, 'C2B_Munc13-like', NULL, NULL, NULL, 2),
(2712, NULL, 'cd14968', NULL, NULL, '7tmA_Adenosine_R', NULL, '7tmA_Adenosine_R', NULL, NULL, NULL, 2),
(2713, NULL, 'cd14725', NULL, NULL, 'ZIP_Gal4-like_2', NULL, 'ZIP_Gal4-like_2', NULL, NULL, NULL, 2),
(2714, NULL, 'cd16919', NULL, NULL, 'HATPase_CckA-like', NULL, 'HATPase_CckA-like', NULL, NULL, NULL, 2),
(2715, NULL, 'cd14996', NULL, NULL, '7tmA_GPR82', NULL, '7tmA_GPR82', NULL, NULL, NULL, 2),
(2716, NULL, 'cd11929', NULL, NULL, 'SH3_SH3RF2_1', NULL, 'SH3_SH3RF2_1', NULL, NULL, 32686, 2),
(2717, NULL, 'cd16129', NULL, NULL, 'Ubl_ATG8_MAP1LC3', NULL, 'Ubl_ATG8_MAP1LC3', NULL, NULL, NULL, 2),
(2718, NULL, 'cd17327', NULL, NULL, 'MFS_FEN2_like', NULL, 'MFS_FEN2_like', NULL, NULL, NULL, 2),
(2719, NULL, 'cd18028', NULL, NULL, 'DEXHc_archSki2', NULL, 'DEXHc_archSki2', NULL, NULL, NULL, 2);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(2720, NULL, 'cd09616', NULL, NULL, 'Peptidase_C12_UCH_L1_L3', NULL, 'Peptidase_C12_UCH_L1_L3', NULL, NULL, NULL, 2),
(2721, NULL, 'cd17019', NULL, NULL, 'T3SC_IA_ShcA-like', NULL, 'T3SC_IA_ShcA-like', NULL, NULL, NULL, 2),
(2722, NULL, 'cd19370', NULL, NULL, 'TenA_PqqC', NULL, 'TenA_PqqC', NULL, NULL, NULL, 2),
(2723, NULL, 'cd04049', NULL, NULL, 'C2_putative_Elicitor-responsive_gene', NULL, 'C2_putative_Elicitor-responsive_gene', NULL, NULL, NULL, 2),
(2724, NULL, 'cd12694', NULL, NULL, 'RRM2_hnRNPL_like', NULL, 'RRM2_hnRNPL_like', NULL, NULL, NULL, 2),
(2725, NULL, 'cd19166', NULL, NULL, 'HemeO-bac', NULL, 'HemeO-bac', NULL, NULL, NULL, 2),
(2726, NULL, 'cd14341', NULL, NULL, 'UBA_MELK', NULL, 'UBA_MELK', NULL, NULL, NULL, 2),
(2727, NULL, 'cd13980', NULL, NULL, 'STKc_Vps15', NULL, 'STKc_Vps15', NULL, NULL, NULL, 2),
(2728, NULL, 'cd11324', NULL, NULL, 'AmyAc_Amylosucrase', NULL, 'AmyAc_Amylosucrase', NULL, NULL, 35529, 2),
(2729, NULL, 'cd11598', NULL, NULL, 'HDAC_Hos2', NULL, 'HDAC_Hos2', NULL, NULL, NULL, 2),
(2730, NULL, 'cd03459', NULL, NULL, '3,4-PCD', NULL, '3,4-PCD', NULL, NULL, 27187, 2),
(2731, NULL, 'cd14368', NULL, NULL, 'CUE_DEF1_like', NULL, 'CUE_DEF1_like', NULL, NULL, 30696, 2),
(2732, NULL, 'cd14211', NULL, NULL, 'STKc_HIPK', NULL, 'STKc_HIPK', NULL, NULL, NULL, 2),
(2733, NULL, 'cd05640', NULL, NULL, 'M28_like', NULL, 'M28_like', NULL, NULL, NULL, 2),
(2734, NULL, 'cd17125', NULL, NULL, 'Ubl_TECRL', NULL, 'Ubl_TECRL', NULL, NULL, NULL, 2),
(2735, NULL, 'cd00591', NULL, NULL, 'HU_IHF', NULL, 'HU_IHF', NULL, NULL, NULL, 2),
(2736, NULL, 'cd05819', NULL, NULL, 'NHL', NULL, 'NHL', NULL, NULL, NULL, 2),
(2737, NULL, 'cd11295', NULL, NULL, 'Mago_nashi', NULL, 'Mago_nashi', NULL, NULL, 804, 2),
(2738, NULL, 'cd15414', NULL, NULL, '7tmA_OR5G-like', NULL, '7tmA_OR5G-like', NULL, NULL, NULL, 2),
(2739, NULL, 'cd07942', NULL, NULL, 'DRE_TIM_LeuA', NULL, 'DRE_TIM_LeuA', NULL, NULL, 30716, 2),
(2740, NULL, 'cd00138', NULL, NULL, 'PLDc_SF', NULL, 'PLDc_SF', NULL, NULL, NULL, 2),
(2741, NULL, 'cd03471', NULL, NULL, 'Rieske_cytochrome_b6f', NULL, 'Rieske_cytochrome_b6f', NULL, NULL, NULL, 2),
(2742, NULL, 'cd00551', NULL, NULL, 'AmyAc_family', NULL, 'AmyAc_family', NULL, NULL, NULL, 2),
(2743, NULL, 'cd11909', NULL, NULL, 'SH3_PI3K_p85beta', NULL, 'SH3_PI3K_p85beta', NULL, NULL, 33469, 2),
(2744, NULL, 'cd08192', NULL, NULL, 'MAR-like', NULL, 'MAR-like', NULL, NULL, NULL, 2),
(2745, NULL, 'cd10347', NULL, NULL, 'SH2_Nterm_shark_like', NULL, 'SH2_Nterm_shark_like', NULL, NULL, 17245, 2),
(2746, NULL, 'cd18916', NULL, NULL, 'bHLH-O_ESM5_like', NULL, 'bHLH-O_ESM5_like', NULL, NULL, NULL, 2),
(2747, NULL, 'cd13836', NULL, NULL, 'IHF_B', NULL, 'IHF_B', NULL, NULL, NULL, 2),
(2748, NULL, 'cd07217', NULL, NULL, 'Pat17_PNPLA8_PNPLA9_like4', NULL, 'Pat17_PNPLA8_PNPLA9_like4', NULL, NULL, NULL, 2),
(2749, NULL, 'cd13936', NULL, NULL, 'PANDER_like', NULL, 'PANDER_like', NULL, NULL, NULL, 2),
(2750, NULL, 'cd19442', NULL, NULL, 'CRBP', NULL, 'CRBP', NULL, NULL, NULL, 2),
(2751, NULL, 'cd05782', NULL, NULL, 'DNA_polB_like1_exo', NULL, 'DNA_polB_like1_exo', NULL, NULL, NULL, 2),
(2752, NULL, 'cd02845', NULL, NULL, 'PAZ_piwi_like', NULL, 'PAZ_piwi_like', NULL, NULL, NULL, 2),
(2753, NULL, 'cd02893', NULL, NULL, 'FTase', NULL, 'FTase', NULL, NULL, 26879, 2),
(2754, NULL, 'cd15505', NULL, NULL, 'PHD_ING', NULL, 'PHD_ING', NULL, NULL, NULL, 2),
(2755, NULL, 'cd19059', NULL, NULL, 'LGIC_TM_GABAAR_rho', NULL, 'LGIC_TM_GABAAR_rho', NULL, NULL, NULL, 2),
(2756, NULL, 'cd08341', NULL, NULL, 'DED_Caspase_10_r1', NULL, 'DED_Caspase_10_r1', NULL, NULL, NULL, 2),
(2757, NULL, 'cd04238', NULL, NULL, 'AAK_NAGK-like', NULL, 'AAK_NAGK-like', NULL, NULL, NULL, 2),
(2758, NULL, 'cd14369', NULL, NULL, 'CUE_VPS9_like', NULL, 'CUE_VPS9_like', NULL, NULL, 30714, 2),
(2759, NULL, 'cd14706', NULL, NULL, 'bZIP_CREBZF', NULL, 'bZIP_CREBZF', NULL, NULL, NULL, 2),
(2760, NULL, 'cd14669', NULL, NULL, 'mlta_related_B', NULL, 'mlta_related_B', NULL, NULL, NULL, 2),
(2761, NULL, 'cd13672', NULL, NULL, 'PBP2_TRAP_Siap', NULL, 'PBP2_TRAP_Siap', NULL, NULL, NULL, 2);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(2762, NULL, 'cd13630', NULL, NULL, 'PBP2_PDT_1', NULL, 'PBP2_PDT_1', NULL, NULL, NULL, 2),
(2763, NULL, 'cd14721', NULL, NULL, 'bZIP_Fos', NULL, 'bZIP_Fos', NULL, NULL, NULL, 2),
(2764, NULL, 'cd00607', NULL, NULL, 'RNase_Sa', NULL, 'RNase_Sa', NULL, NULL, NULL, 2),
(2765, NULL, 'cd16166', NULL, NULL, 'OCRE_SUA_like', NULL, 'OCRE_SUA_like', NULL, NULL, 33018, 2),
(2766, NULL, 'cd21638', NULL, NULL, 'NS7a_deltaCoV_HKU16-like', NULL, 'NS7a_deltaCoV_HKU16-like', NULL, NULL, 36442, 2),
(2767, NULL, 'cd14445', NULL, NULL, 'RILP-like', NULL, 'RILP-like', NULL, NULL, NULL, 2),
(2768, NULL, 'cd18818', NULL, NULL, 'GH43_GbtXyl43B-like', NULL, 'GH43_GbtXyl43B-like', NULL, NULL, NULL, 2),
(2769, NULL, 'cd02123', NULL, NULL, 'PA_C_RZF_like', NULL, 'PA_C_RZF_like', NULL, NULL, 35113, 2),
(2770, NULL, 'cd17619', NULL, NULL, 'REC_OmpR_ArcA_TorR-like', NULL, 'REC_OmpR_ArcA_TorR-like', NULL, NULL, NULL, 2),
(2771, NULL, 'cd18411', NULL, NULL, 'BTB_POZ_KCNB1', NULL, 'BTB_POZ_KCNB1', NULL, NULL, NULL, 2),
(2772, NULL, 'cd18460', NULL, NULL, 'BACK_KLHL21', NULL, 'BACK_KLHL21', NULL, NULL, NULL, 2),
(2773, NULL, 'cd12567', NULL, NULL, 'RRM3_RBM19', NULL, 'RRM3_RBM19', NULL, NULL, 13403, 2),
(2774, NULL, 'cd04024', NULL, NULL, 'C2A_Synaptotagmin-like', NULL, 'C2A_Synaptotagmin-like', NULL, NULL, NULL, 2),
(2775, NULL, 'cd16085', NULL, NULL, 'IgC_SIRP_domain_3', NULL, 'IgC_SIRP_domain_3', NULL, NULL, NULL, 2),
(2776, NULL, 'cd08768', NULL, NULL, 'Cdc6_C', NULL, 'Cdc6_C', NULL, NULL, 9714, 2),
(2777, NULL, 'cd13322', NULL, NULL, 'PH_PHLPP-like', NULL, 'PH_PHLPP-like', NULL, NULL, NULL, 2),
(2778, NULL, 'cd04097', NULL, NULL, 'mtEFG1_C', NULL, 'mtEFG1_C', NULL, NULL, 31733, 2),
(2779, NULL, 'cd11559', NULL, NULL, 'W2_eIF4G1_like', NULL, 'W2_eIF4G1_like', NULL, NULL, NULL, 2),
(2780, NULL, 'cd15762', NULL, NULL, 'FYVE_RP3A', NULL, 'FYVE_RP3A', NULL, NULL, NULL, 2),
(2781, NULL, 'cd00022', NULL, NULL, 'BIR', NULL, 'BIR', NULL, NULL, 2021, 2),
(2782, NULL, 'cd20483', NULL, NULL, 'C_PKS-NRPS', NULL, 'C_PKS-NRPS', NULL, NULL, NULL, 2),
(2783, NULL, 'cd06598', NULL, NULL, 'GH31_transferase_CtsZ', NULL, 'GH31_transferase_CtsZ', NULL, NULL, NULL, 2),
(2784, NULL, 'cd12300', NULL, NULL, 'RRM1_PAR14', NULL, 'RRM1_PAR14', NULL, NULL, NULL, 2),
(2785, NULL, 'cd14583', NULL, NULL, 'PTP-MTMR7', NULL, 'PTP-MTMR7', NULL, NULL, NULL, 2),
(2786, NULL, 'cd12325', NULL, NULL, 'RRM1_hnRNPA_hnRNPD_like', NULL, 'RRM1_hnRNPA_hnRNPD_like', NULL, NULL, NULL, 2),
(2787, NULL, 'cd01557', NULL, NULL, 'BCAT_beta_family', NULL, 'BCAT_beta_family', NULL, NULL, 32267, 2),
(2788, NULL, 'cd11406', NULL, NULL, 'bHLHzip_Max', NULL, 'bHLHzip_Max', NULL, NULL, NULL, 2),
(2789, NULL, 'cd19692', NULL, NULL, 'bHLH_dnHLH_ID2', NULL, 'bHLH_dnHLH_ID2', NULL, NULL, NULL, 2),
(2790, NULL, 'sd00004', NULL, NULL, 'PPR', NULL, 'PPR', NULL, NULL, NULL, 2),
(2791, NULL, 'cd14079', NULL, NULL, 'STKc_AMPK_alpha', NULL, 'STKc_AMPK_alpha', NULL, NULL, NULL, 2),
(2792, NULL, 'cd11620', NULL, NULL, 'HR1_PKC-like_2_fungi', NULL, 'HR1_PKC-like_2_fungi', NULL, NULL, 27937, 2),
(2793, NULL, 'cd08969', NULL, NULL, 'MeNeil3_N', NULL, 'MeNeil3_N', NULL, NULL, NULL, 2),
(2794, NULL, 'cd16991', NULL, NULL, 'ENTH_Ent1_Ent2', NULL, 'ENTH_Ent1_Ent2', NULL, NULL, NULL, 2),
(2795, NULL, 'cd13950', NULL, NULL, '7tm_TAS2R', NULL, '7tm_TAS2R', NULL, NULL, NULL, 2),
(2796, NULL, 'cd14388', NULL, NULL, 'UBA2_atUBP14', NULL, 'UBA2_atUBP14', NULL, NULL, NULL, 2),
(2797, NULL, 'cd01579', NULL, NULL, 'AcnA_Bact_Swivel', NULL, 'AcnA_Bact_Swivel', NULL, NULL, NULL, 2),
(2798, NULL, 'cd21593', NULL, NULL, 'HCoV_HKU1-like_RdRp', NULL, 'HCoV_HKU1-like_RdRp', NULL, NULL, 33613, 2),
(2799, NULL, 'cd10039', NULL, NULL, 'Reelin_repeat_3_subrepeat_1', NULL, 'Reelin_repeat_3_subrepeat_1', NULL, NULL, NULL, 2),
(2800, NULL, 'cd12790', NULL, NULL, 'RasGAP_plexin_A', NULL, 'RasGAP_plexin_A', NULL, NULL, NULL, 2),
(2801, NULL, 'cd01700', NULL, NULL, 'PolY_Pol_V_umuC', NULL, 'PolY_Pol_V_umuC', NULL, NULL, NULL, 2),
(2802, NULL, 'cd16217', NULL, NULL, 'EFh_PI-PLCdelta1', NULL, 'EFh_PI-PLCdelta1', NULL, NULL, NULL, 2);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(2803, NULL, 'cd08239', NULL, NULL, 'THR_DH_like', NULL, 'THR_DH_like', NULL, NULL, NULL, 2),
(2804, NULL, 'cd12777', NULL, NULL, 'RRM1_PTBP1', NULL, 'RRM1_PTBP1', NULL, NULL, 20829, 2),
(2805, NULL, 'cd15854', NULL, NULL, 'SNARE_SNAP47C', NULL, 'SNARE_SNAP47C', NULL, NULL, NULL, 2),
(2806, NULL, 'cd12723', NULL, NULL, 'RRM1_CPEB1', NULL, 'RRM1_CPEB1', NULL, NULL, 27304, 2),
(2807, NULL, 'cd19130', NULL, NULL, 'AKR_AKR5C1', NULL, 'AKR_AKR5C1', NULL, NULL, 35638, 2),
(2808, NULL, 'cd06871', NULL, NULL, 'PX_MONaKA', NULL, 'PX_MONaKA', NULL, NULL, 28930, 2),
(2809, NULL, 'cd08853', NULL, NULL, 'ArfGap_AGAP2', NULL, 'ArfGap_AGAP2', NULL, NULL, NULL, 2),
(2810, NULL, 'cd18667', NULL, NULL, 'CD1_tandem_CHD3-4_like', NULL, 'CD1_tandem_CHD3-4_like', NULL, NULL, NULL, 2),
(2811, NULL, 'cd08710', NULL, NULL, 'RGS_RGS16', NULL, 'RGS_RGS16', NULL, NULL, NULL, 2),
(2812, NULL, 'cd14222', NULL, NULL, 'STKc_LIMK2', NULL, 'STKc_LIMK2', NULL, NULL, NULL, 2),
(2813, NULL, 'cd18816', NULL, NULL, 'CAP_CRISPLD2', NULL, 'CAP_CRISPLD2', NULL, NULL, NULL, 2),
(2814, NULL, 'cd13346', NULL, NULL, 'PH-GRAM_MTMR10', NULL, 'PH-GRAM_MTMR10', NULL, NULL, 28321, 2),
(2815, NULL, 'cd15089', NULL, NULL, '7tmA_Delta_opioid_R', NULL, '7tmA_Delta_opioid_R', NULL, NULL, NULL, 2),
(2816, NULL, 'cd15815', NULL, NULL, 'SPRY_PRY_TRIM38', NULL, 'SPRY_PRY_TRIM38', NULL, NULL, 32586, 2),
(2817, NULL, 'cd16664', NULL, NULL, 'RING-Ubox_PUB', NULL, 'RING-Ubox_PUB', NULL, NULL, 36401, 2),
(2818, NULL, 'cd16034', NULL, NULL, 'sulfatase_like', NULL, 'sulfatase_like', NULL, NULL, NULL, 2),
(2819, NULL, 'cd17098', NULL, NULL, 'FERM_F1_FARP1_like', NULL, 'FERM_F1_FARP1_like', NULL, NULL, NULL, 2),
(2820, NULL, 'cd03174', NULL, NULL, 'DRE_TIM_metallolyase', NULL, 'DRE_TIM_metallolyase', NULL, NULL, NULL, 2),
(2821, NULL, 'cd01867', NULL, NULL, 'Rab8_Rab10_Rab13_like', NULL, 'Rab8_Rab10_Rab13_like', NULL, NULL, NULL, 2),
(2822, NULL, 'cd07473', NULL, NULL, 'Peptidases_S8_Subtilisin_like', NULL, 'Peptidases_S8_Subtilisin_like', NULL, NULL, 5707, 2),
(2823, NULL, 'cd08767', NULL, NULL, 'Cdt1_c', NULL, 'Cdt1_c', NULL, NULL, 25019, 2),
(2824, NULL, 'cd16121', NULL, NULL, 'FERM_F1_SNX17', NULL, 'FERM_F1_SNX17', NULL, NULL, NULL, 2),
(2825, NULL, 'cd20492', NULL, NULL, 'cupin_HQDO_large_C', NULL, 'cupin_HQDO_large_C', NULL, NULL, NULL, 2),
(2826, NULL, 'cd07813', NULL, NULL, 'COQ10p_like', NULL, 'COQ10p_like', NULL, NULL, 36949, 2),
(2827, NULL, 'cd10928', NULL, NULL, 'CE4_u4', NULL, 'CE4_u4', NULL, NULL, NULL, 2),
(2828, NULL, 'cd01375', NULL, NULL, 'KISc_KIF9_like', NULL, 'KISc_KIF9_like', NULL, NULL, NULL, 2),
(2829, NULL, 'cd13539', NULL, NULL, 'PBP2_AvModA', NULL, 'PBP2_AvModA', NULL, NULL, 35857, 2),
(2830, NULL, 'cd05340', NULL, NULL, 'Ycik_SDR_c', NULL, 'Ycik_SDR_c', NULL, NULL, NULL, 2),
(2831, NULL, 'cd00387', NULL, NULL, 'Ribosomal_L7_L12', NULL, 'Ribosomal_L7_L12', NULL, NULL, 3982, 2),
(2832, NULL, 'cd01981', NULL, NULL, 'Pchlide_reductase_B', NULL, 'Pchlide_reductase_B', NULL, NULL, NULL, 2),
(2833, NULL, 'cd10276', NULL, NULL, 'BamB_YfgL', NULL, 'BamB_YfgL', NULL, NULL, NULL, 2),
(2834, NULL, 'cd16877', NULL, NULL, 'ARID_ARID1B', NULL, 'ARID_ARID1B', NULL, NULL, NULL, 2),
(2835, NULL, 'cd10306', NULL, NULL, 'GST_C_GluRS_N', NULL, 'GST_C_GluRS_N', NULL, NULL, NULL, 2),
(2836, NULL, 'cd18616', NULL, NULL, 'GH43_ABN-like', NULL, 'GH43_ABN-like', NULL, NULL, NULL, 2),
(2837, NULL, 'cd18730', NULL, NULL, 'PIN_PH0500-like', NULL, 'PIN_PH0500-like', NULL, NULL, NULL, 2),
(2838, NULL, 'cd14804', NULL, NULL, 'Tra_M', NULL, 'Tra_M', NULL, NULL, 3488, 2),
(2839, NULL, 'cd11955', NULL, NULL, 'SH3_srGAP1-3', NULL, 'SH3_srGAP1-3', NULL, NULL, 28318, 2),
(2840, NULL, 'cd01998', NULL, NULL, 'tRNA_Me_trans', NULL, 'tRNA_Me_trans', NULL, NULL, 1671, 2),
(2841, NULL, 'cd13174', NULL, NULL, 'RanBD4_RanBP2_insect-like', NULL, 'RanBD4_RanBP2_insect-like', NULL, NULL, NULL, 2),
(2842, NULL, 'cd05901', NULL, NULL, 'Ig_Versican', NULL, 'Ig_Versican', NULL, NULL, NULL, 2),
(2843, NULL, 'cd15333', NULL, NULL, '7tmA_5-HT1B_1D', NULL, '7tmA_5-HT1B_1D', NULL, NULL, NULL, 2);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(2844, NULL, 'cd06100', NULL, NULL, 'CCL_ACL-C', NULL, 'CCL_ACL-C', NULL, NULL, NULL, 2),
(2845, NULL, 'cd08013', NULL, NULL, 'M20_ArgE_DapE-like', NULL, 'M20_ArgE_DapE-like', NULL, NULL, NULL, 2),
(2846, NULL, 'cd19207', NULL, NULL, 'SET_KMT2B', NULL, 'SET_KMT2B', NULL, NULL, NULL, 2),
(2847, NULL, 'cd01030', NULL, NULL, 'TOPRIM_TopoIIA_like', NULL, 'TOPRIM_TopoIIA_like', NULL, NULL, NULL, 2),
(2848, NULL, 'cd01596', NULL, NULL, 'Aspartase_like', NULL, 'Aspartase_like', NULL, NULL, NULL, 2),
(2849, NULL, 'cd15255', NULL, NULL, '7tmB2_GPR144', NULL, '7tmB2_GPR144', NULL, NULL, NULL, 2),
(2850, NULL, 'cd16202', NULL, NULL, 'EFh_PI-PLCdelta', NULL, 'EFh_PI-PLCdelta', NULL, NULL, NULL, 2),
(2851, NULL, 'cd18215', NULL, NULL, 'BTB_POZ_ZBTB27-like', NULL, 'BTB_POZ_ZBTB27-like', NULL, NULL, NULL, 2),
(2852, NULL, 'cd17729', NULL, NULL, 'BRCT_CTDP1', NULL, 'BRCT_CTDP1', NULL, NULL, NULL, 2),
(2853, NULL, 'cd00645', NULL, NULL, 'AsnA', NULL, 'AsnA', NULL, NULL, 2212, 2),
(2854, NULL, 'cd06550', NULL, NULL, 'TM_ABC_iron-siderophores_like', NULL, 'TM_ABC_iron-siderophores_like', NULL, NULL, NULL, 2),
(2855, NULL, 'cd12153', NULL, NULL, 'F1-ATPase_epsilon', NULL, 'F1-ATPase_epsilon', NULL, NULL, 2449, 2),
(2856, NULL, 'cd15651', NULL, NULL, 'PHD2_NSD2', NULL, 'PHD2_NSD2', NULL, NULL, NULL, 2),
(2857, NULL, 'cd00421', NULL, NULL, 'intradiol_dioxygenase', NULL, 'intradiol_dioxygenase', NULL, NULL, NULL, 2),
(2858, NULL, 'cd19172', NULL, NULL, 'SET_SETD2', NULL, 'SET_SETD2', NULL, NULL, 35479, 2),
(2859, NULL, 'cd20263', NULL, NULL, 'Complex1_LYR_NDUFB9_LYRM3', NULL, 'Complex1_LYR_NDUFB9_LYRM3', NULL, NULL, 34123, 2),
(2860, NULL, 'cd17721', NULL, NULL, 'BRCT_BRCA1_rpt2', NULL, 'BRCT_BRCA1_rpt2', NULL, NULL, NULL, 2),
(2861, NULL, 'cd07370', NULL, NULL, 'HPCD', NULL, 'HPCD', NULL, NULL, 13327, 2),
(2862, NULL, 'cd13420', NULL, NULL, 'TNFRSF25', NULL, 'TNFRSF25', NULL, NULL, 4133, 2),
(2863, NULL, 'cd15171', NULL, NULL, '7tmA_CCRL2', NULL, '7tmA_CCRL2', NULL, NULL, NULL, 2),
(2864, NULL, 'cd15241', NULL, NULL, '7tm_ChRs', NULL, '7tm_ChRs', NULL, NULL, NULL, 2),
(2865, NULL, 'cd19997', NULL, NULL, 'PBP1_ABC_sugar_binding-like', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, NULL, 2),
(2866, NULL, 'cd19885', NULL, NULL, 'DSRM_STAU1_rpt4', NULL, 'DSRM_STAU1_rpt4', NULL, NULL, NULL, 2),
(2867, NULL, 'cd14172', NULL, NULL, 'STKc_MAPKAPK3', NULL, 'STKc_MAPKAPK3', NULL, NULL, NULL, 2),
(2868, NULL, 'cd06967', NULL, NULL, 'NR_DBD_TR2_like', NULL, 'NR_DBD_TR2_like', NULL, NULL, NULL, 2),
(2869, NULL, 'cd18744', NULL, NULL, 'PIN_VapC4-5_FitB-like', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, NULL, 2),
(2870, NULL, 'cd01244', NULL, NULL, 'PH_GAP1-like', NULL, 'PH_GAP1-like', NULL, NULL, NULL, 2),
(2871, NULL, 'cd16120', NULL, NULL, 'UBX_UBXN3B', NULL, 'UBX_UBXN3B', NULL, NULL, NULL, 2),
(2872, NULL, 'cd17315', NULL, NULL, 'MFS_GLUT_like', NULL, 'MFS_GLUT_like', NULL, NULL, NULL, 2),
(2873, NULL, 'cd06206', NULL, NULL, 'bifunctional_CYPOR', NULL, 'bifunctional_CYPOR', NULL, NULL, NULL, 2),
(2874, NULL, 'cd11698', NULL, NULL, 'DHR2_DOCK9', NULL, 'DHR2_DOCK9', NULL, NULL, NULL, 2),
(2875, NULL, 'cd00394', NULL, NULL, 'Clp_protease_like', NULL, 'Clp_protease_like', NULL, NULL, NULL, 2),
(2876, NULL, 'cd12019', NULL, NULL, 'SH3_Tks5_4', NULL, 'SH3_Tks5_4', NULL, NULL, 20072, 2),
(2877, NULL, 'cd16555', NULL, NULL, 'RING-HC_RNF182', NULL, 'RING-HC_RNF182', NULL, NULL, NULL, 2),
(2878, NULL, 'cd19791', NULL, NULL, 'Bbox2_TRIM60-like', NULL, 'Bbox2_TRIM60-like', NULL, NULL, NULL, 2),
(2879, NULL, 'cd00174', NULL, NULL, 'SH3', NULL, 'SH3', NULL, NULL, NULL, 2),
(2880, NULL, 'cd04658', NULL, NULL, 'Piwi_piwi-like_Euk', NULL, 'Piwi_piwi-like_Euk', NULL, NULL, NULL, 2),
(2881, NULL, 'cd09913', NULL, NULL, 'EHD', NULL, 'EHD', NULL, NULL, NULL, 2),
(2882, NULL, 'cd13434', NULL, NULL, 'SPFH_SLPs', NULL, 'SPFH_SLPs', NULL, NULL, NULL, 2),
(2883, NULL, 'cd02763', NULL, NULL, 'MopB_2', NULL, 'MopB_2', NULL, NULL, NULL, 2),
(2884, NULL, 'cd08775', NULL, NULL, 'DED_Caspase-like_r2', NULL, 'DED_Caspase-like_r2', NULL, NULL, NULL, 2);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(2885, NULL, 'cd12459', NULL, NULL, 'RRM1_CID8_like', NULL, 'RRM1_CID8_like', NULL, NULL, 33338, 2),
(2886, NULL, 'cd20272', NULL, NULL, 'Complex1_LYR_MIEF1-MP', NULL, 'Complex1_LYR_MIEF1-MP', NULL, NULL, 37352, 2),
(2887, NULL, 'cd07570', NULL, NULL, 'GAT_Gln-NAD-synth', NULL, 'GAT_Gln-NAD-synth', NULL, NULL, NULL, 2),
(2888, NULL, 'cd16981', NULL, NULL, 'CID_RPRD_like', NULL, 'CID_RPRD_like', NULL, NULL, NULL, 2),
(2889, NULL, 'cd07736', NULL, NULL, 'PhnP-like_MBL-fold', NULL, 'PhnP-like_MBL-fold', NULL, NULL, 31403, 2),
(2890, NULL, 'cd10509', NULL, NULL, 'Zn-ribbon_RPC11', NULL, 'Zn-ribbon_RPC11', NULL, NULL, 13076, 2),
(2891, NULL, 'cd09453', NULL, NULL, 'LIM1_ENH', NULL, 'LIM1_ENH', NULL, NULL, NULL, 2),
(2892, NULL, 'cd08365', NULL, NULL, 'APC10-like1', NULL, 'APC10-like1', NULL, NULL, NULL, 2),
(2893, NULL, 'cd07569', NULL, NULL, 'DCase', NULL, 'DCase', NULL, NULL, NULL, 2),
(2894, NULL, 'cd02507', NULL, NULL, 'eIF-2B_gamma_N_like', NULL, 'eIF-2B_gamma_N_like', NULL, NULL, NULL, 2),
(2895, NULL, 'cd05846', NULL, NULL, 'Ig1_MRC-OX-2_like', NULL, 'Ig1_MRC-OX-2_like', NULL, NULL, NULL, 2),
(2896, NULL, 'cd13241', NULL, NULL, 'PH2_Kalirin_Trio_p63RhoGEF', NULL, 'PH2_Kalirin_Trio_p63RhoGEF', NULL, NULL, NULL, 2),
(2897, NULL, 'cd06362', NULL, NULL, 'PBP1_mGluR', NULL, 'PBP1_mGluR', NULL, NULL, NULL, 2),
(2898, NULL, 'cd06171', NULL, NULL, 'Sigma70_r4', NULL, 'Sigma70_r4', NULL, NULL, NULL, 2),
(2899, NULL, 'cd10507', NULL, NULL, 'Zn-ribbon_RPA12', NULL, 'Zn-ribbon_RPA12', NULL, NULL, 28818, 2),
(2900, NULL, 'cd19946', NULL, NULL, 'GlpA-like_Fer2_BFD-like', NULL, 'GlpA-like_Fer2_BFD-like', NULL, NULL, NULL, 2),
(2901, NULL, 'cd18303', NULL, NULL, 'BTB_POZ_Rank-5', NULL, 'BTB_POZ_Rank-5', NULL, NULL, NULL, 2),
(2902, NULL, 'cd12380', NULL, NULL, 'RRM3_I_PABPs', NULL, 'RRM3_I_PABPs', NULL, NULL, NULL, 2),
(2903, NULL, 'cd13432', NULL, NULL, 'LDT_IgD_like_2', NULL, 'LDT_IgD_like_2', NULL, NULL, NULL, 2),
(2904, NULL, 'cd02961', NULL, NULL, 'PDI_a_family', NULL, 'PDI_a_family', NULL, NULL, NULL, 2),
(2905, NULL, 'cd01046', NULL, NULL, 'Rubrerythrin_like', NULL, 'Rubrerythrin_like', NULL, NULL, 36830, 2),
(2906, NULL, 'cd02541', NULL, NULL, 'UGPase_prokaryotic', NULL, 'UGPase_prokaryotic', NULL, NULL, 4867, 2),
(2907, NULL, 'cd09150', NULL, NULL, 'PLDc_Ymt_1', NULL, 'PLDc_Ymt_1', NULL, NULL, NULL, 2),
(2908, NULL, 'cd08838', NULL, NULL, 'ArfGap_AGFG', NULL, 'ArfGap_AGFG', NULL, NULL, NULL, 2),
(2909, NULL, 'cd03506', NULL, NULL, 'Delta6-FADS-like', NULL, 'Delta6-FADS-like', NULL, NULL, NULL, 2),
(2910, NULL, 'cd02058', NULL, NULL, 'serpinB_MENT-like', NULL, 'serpinB_MENT-like', NULL, NULL, NULL, 2),
(2911, NULL, 'cd19335', NULL, NULL, 'Wnt_Wnt3_Wnt3a', NULL, 'Wnt_Wnt3_Wnt3a', NULL, NULL, NULL, 2),
(2912, NULL, 'cd06266', NULL, NULL, 'RNase_HII', NULL, 'RNase_HII', NULL, NULL, NULL, 2),
(2913, NULL, 'cd08948', NULL, NULL, '5beta-POR_like_SDR_a', NULL, '5beta-POR_like_SDR_a', NULL, NULL, NULL, 2),
(2914, NULL, 'cd00284', NULL, NULL, 'Cytochrome_b_N', NULL, 'Cytochrome_b_N', NULL, NULL, 5653, 2),
(2915, NULL, 'cd12447', NULL, NULL, 'RRM1_gar2', NULL, 'RRM1_gar2', NULL, NULL, 6852, 2),
(2916, NULL, 'cd19367', NULL, NULL, 'TenA_C_ScTHI20-like', NULL, 'TenA_C_ScTHI20-like', NULL, NULL, NULL, 2),
(2917, NULL, 'cd08275', NULL, NULL, 'MDR3', NULL, 'MDR3', NULL, NULL, NULL, 2),
(2918, NULL, 'cd19603', NULL, NULL, 'serpin_platyhelminthes', NULL, 'serpin_platyhelminthes', NULL, NULL, NULL, 2),
(2919, NULL, 'cd20310', NULL, NULL, 'cupin_L-RbI', NULL, 'cupin_L-RbI', NULL, NULL, NULL, 2),
(2920, NULL, 'cd15115', NULL, NULL, '7tmA_C3aR', NULL, '7tmA_C3aR', NULL, NULL, NULL, 2),
(2921, NULL, 'cd01977', NULL, NULL, 'Nitrogenase_VFe_alpha', NULL, 'Nitrogenase_VFe_alpha', NULL, NULL, NULL, 2),
(2922, NULL, 'cd12892', NULL, NULL, 'SPRY_PRY_TRIM18', NULL, 'SPRY_PRY_TRIM18', NULL, NULL, NULL, 2),
(2923, NULL, 'cd18811', NULL, NULL, 'SF2_C_RecG', NULL, 'SF2_C_RecG', NULL, NULL, NULL, 2),
(2924, NULL, 'cd06299', NULL, NULL, 'PBP1_LacI-like', NULL, 'PBP1_LacI-like', NULL, NULL, NULL, 2),
(2925, NULL, 'cd07751', NULL, NULL, 'PolyPPase_VTC4_like', NULL, 'PolyPPase_VTC4_like', NULL, NULL, NULL, 2);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(2926, NULL, 'cd11914', NULL, NULL, 'SH3_BAIAP2L2', NULL, 'SH3_BAIAP2L2', NULL, NULL, 33060, 2),
(2927, NULL, 'cd16782', NULL, NULL, 'mRING-HC-C3HC3D_Roquin2', NULL, 'mRING-HC-C3HC3D_Roquin2', NULL, NULL, NULL, 2),
(2928, NULL, 'cd18657', NULL, NULL, 'CSD_Swi6', NULL, 'CSD_Swi6', NULL, NULL, NULL, 2),
(2929, NULL, 'cd17640', NULL, NULL, 'LC_FACS_like', NULL, 'LC_FACS_like', NULL, NULL, NULL, 2),
(2930, NULL, 'cd11805', NULL, NULL, 'SH3_GRB2_like_C', NULL, 'SH3_GRB2_like_C', NULL, NULL, NULL, 2),
(2931, NULL, 'cd09653', NULL, NULL, 'Csa5_I-A', NULL, 'Csa5_I-A', NULL, NULL, NULL, 2),
(2932, NULL, 'cd12391', NULL, NULL, 'RRM1_SART3', NULL, 'RRM1_SART3', NULL, NULL, 21312, 2),
(2933, NULL, 'cd08788', NULL, NULL, 'CARD_NOD2_2_CARD15', NULL, 'CARD_NOD2_2_CARD15', NULL, NULL, NULL, 2),
(2934, NULL, 'cd18639', NULL, NULL, 'CD_SUV39H1_like', NULL, 'CD_SUV39H1_like', NULL, NULL, NULL, 2),
(2935, NULL, 'cd13568', NULL, NULL, 'PBP2_TAXI_TRAP_like_3', NULL, 'PBP2_TAXI_TRAP_like_3', NULL, NULL, NULL, 2),
(2936, NULL, 'cd07416', NULL, NULL, 'MPP_PP2B', NULL, 'MPP_PP2B', NULL, NULL, 30183, 2),
(2937, NULL, 'cd11271', NULL, NULL, 'Sema_plexin_A1', NULL, 'Sema_plexin_A1', NULL, NULL, 35327, 2),
(2938, NULL, 'cd15676', NULL, NULL, 'PHD_BRPF1', NULL, 'PHD_BRPF1', NULL, NULL, 30068, 2),
(2939, NULL, 'cd03160', NULL, NULL, 'CD37_CD82_like_LEL', NULL, 'CD37_CD82_like_LEL', NULL, NULL, NULL, 2),
(2940, NULL, 'cd07429', NULL, NULL, 'Cby_like', NULL, 'Cby_like', NULL, NULL, 21978, 2),
(2941, NULL, 'cd19733', NULL, NULL, 'bHLH-PAS_trachealess_like', NULL, 'bHLH-PAS_trachealess_like', NULL, NULL, NULL, 2),
(2942, NULL, 'cd02653', NULL, NULL, 'nuc_hydro_3', NULL, 'nuc_hydro_3', NULL, NULL, NULL, 2),
(2943, NULL, 'cd11840', NULL, NULL, 'SH3_Intersectin_5', NULL, 'SH3_Intersectin_5', NULL, NULL, NULL, 2),
(2944, NULL, 'cd11619', NULL, NULL, 'HR1_CIP4-like', NULL, 'HR1_CIP4-like', NULL, NULL, NULL, 2),
(2945, NULL, 'cd17383', NULL, NULL, 'MFS_SLC18A3_VAChT', NULL, 'MFS_SLC18A3_VAChT', NULL, NULL, NULL, 2),
(2946, NULL, 'cd04487', NULL, NULL, 'RecJ_OBF2_like', NULL, 'RecJ_OBF2_like', NULL, NULL, NULL, 2),
(2947, NULL, 'cd02226', NULL, NULL, 'cupin_YdbB-like', NULL, 'cupin_YdbB-like', NULL, NULL, NULL, 2),
(2948, NULL, 'cd17722', NULL, NULL, 'BRCT_DNA_ligase_IV_rpt1', NULL, 'BRCT_DNA_ligase_IV_rpt1', NULL, NULL, NULL, 2),
(2949, NULL, 'cd19440', NULL, NULL, 'lipocalin_Bla_g_4_Per_a_4', NULL, 'lipocalin_Bla_g_4_Per_a_4', NULL, NULL, NULL, 2),
(2950, NULL, 'cd14238', NULL, NULL, 'GAT_TM1L2', NULL, 'GAT_TM1L2', NULL, NULL, NULL, 2),
(2951, NULL, 'cd17908', NULL, NULL, 'FliM', NULL, 'FliM', NULL, NULL, 3202, 2),
(2952, NULL, 'cd04770', NULL, NULL, 'HTH_HMRTR', NULL, 'HTH_HMRTR', NULL, NULL, NULL, 2),
(2953, NULL, 'cd06323', NULL, NULL, 'PBP1_ribose_binding', NULL, 'PBP1_ribose_binding', NULL, NULL, NULL, 2),
(2954, NULL, 'cd01836', NULL, NULL, 'FeeA_FeeB_like', NULL, 'FeeA_FeeB_like', NULL, NULL, NULL, 2),
(2955, NULL, 'cd08416', NULL, NULL, 'PBP2_MdcR', NULL, 'PBP2_MdcR', NULL, NULL, 32225, 2),
(2956, NULL, 'cd07688', NULL, NULL, 'IgC_TCR_alpha', NULL, 'IgC_TCR_alpha', NULL, NULL, 14269, 2),
(2957, NULL, 'cd16531', NULL, NULL, 'RING-HC_RING1_like', NULL, 'RING-HC_RING1_like', NULL, NULL, NULL, 2),
(2958, NULL, 'cd02869', NULL, NULL, 'PseudoU_synth_RluA_like', NULL, 'PseudoU_synth_RluA_like', NULL, NULL, 11240, 2),
(2959, NULL, 'cd01454', NULL, NULL, 'vWA_norD_type', NULL, 'vWA_norD_type', NULL, NULL, NULL, 2),
(2960, NULL, 'cd10327', NULL, NULL, 'SLC5sbd_PanF', NULL, 'SLC5sbd_PanF', NULL, NULL, 13896, 2),
(2961, NULL, 'cd12413', NULL, NULL, 'RRM1_RBM28_like', NULL, 'RRM1_RBM28_like', NULL, NULL, NULL, 2),
(2962, NULL, 'cd08869', NULL, NULL, 'START_RhoGAP', NULL, 'START_RhoGAP', NULL, NULL, NULL, 2),
(2963, NULL, 'cd18017', NULL, NULL, 'DEXHc_RecQ3', NULL, 'DEXHc_RecQ3', NULL, NULL, NULL, 2),
(2964, NULL, 'cd14003', NULL, NULL, 'STKc_AMPK-like', NULL, 'STKc_AMPK-like', NULL, NULL, NULL, 2),
(2965, NULL, 'cd07715', NULL, NULL, 'TaR3-like_MBL-fold', NULL, 'TaR3-like_MBL-fold', NULL, NULL, NULL, 2),
(2966, NULL, 'cd12622', NULL, NULL, 'RRM3_PUB1', NULL, 'RRM3_PUB1', NULL, NULL, 12534, 2);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(2967, NULL, 'cd06157', NULL, NULL, 'NR_LBD', NULL, 'NR_LBD', NULL, NULL, NULL, 2),
(2968, NULL, 'cd09199', NULL, NULL, 'PLDc_pPLDalpha_2', NULL, 'PLDc_pPLDalpha_2', NULL, NULL, NULL, 2),
(2969, NULL, 'cd18778', NULL, NULL, 'ABC_6TM_exporter_like', NULL, 'ABC_6TM_exporter_like', NULL, NULL, NULL, 2),
(2970, NULL, 'cd12660', NULL, NULL, 'RRM2_MYEF2', NULL, 'RRM2_MYEF2', NULL, NULL, NULL, 2),
(2971, NULL, 'cd18576', NULL, NULL, 'ABC_6TM_bac_exporter_ABCB8_10_like', NULL, 'ABC_6TM_bac_exporter_ABCB8_10_like', NULL, NULL, NULL, 2),
(2972, NULL, 'cd07412', NULL, NULL, 'MPP_YhcR_N', NULL, 'MPP_YhcR_N', NULL, NULL, 30811, 2),
(2973, NULL, 'cd18219', NULL, NULL, 'BTB_POZ_ZBTB33_KAISO', NULL, 'BTB_POZ_ZBTB33_KAISO', NULL, NULL, NULL, 2),
(2974, NULL, 'cd19152', NULL, NULL, 'AKR_AKR15A', NULL, 'AKR_AKR15A', NULL, NULL, NULL, 2),
(2975, NULL, 'cd15336', NULL, NULL, '7tmA_Melanopsin', NULL, '7tmA_Melanopsin', NULL, NULL, NULL, 2),
(2976, NULL, 'cd16970', NULL, NULL, 'Alpha_kinase_VwkA_like', NULL, 'Alpha_kinase_VwkA_like', NULL, NULL, NULL, 2),
(2977, NULL, 'cd10462', NULL, NULL, 'PUB_UBA', NULL, 'PUB_UBA', NULL, NULL, NULL, 2),
(2978, NULL, 'cd15973', NULL, NULL, '7tmA_SSTR4', NULL, '7tmA_SSTR4', NULL, NULL, NULL, 2),
(2979, NULL, 'cd04183', NULL, NULL, 'GT2_BcE_like', NULL, 'GT2_BcE_like', NULL, NULL, NULL, 2),
(2980, NULL, 'cd10434', NULL, NULL, 'GIY-YIG_UvrC_Cho', NULL, 'GIY-YIG_UvrC_Cho', NULL, NULL, NULL, 2),
(2981, NULL, 'cd06911', NULL, NULL, 'VirB9_CagX_TrbG', NULL, 'VirB9_CagX_TrbG', NULL, NULL, 31358, 2),
(2982, NULL, 'cd10803', NULL, NULL, 'YdjC_EF3048_like', NULL, 'YdjC_EF3048_like', NULL, NULL, 14893, 2),
(2983, NULL, 'cd11431', NULL, NULL, 'bHLH_TS_taxi_Dei', NULL, 'bHLH_TS_taxi_Dei', NULL, NULL, NULL, 2),
(2984, NULL, 'cd00470', NULL, NULL, 'PTPS', NULL, 'PTPS', NULL, NULL, NULL, 2),
(2985, NULL, 'cd15355', NULL, NULL, '7tmA_NTSR1', NULL, '7tmA_NTSR1', NULL, NULL, NULL, 2),
(2986, NULL, 'cd19216', NULL, NULL, 'PR-SET_ZFPM2', NULL, 'PR-SET_ZFPM2', NULL, NULL, NULL, 2),
(2987, NULL, 'cd17174', NULL, NULL, 'FERM_F1_TLN2', NULL, 'FERM_F1_TLN2', NULL, NULL, NULL, 2),
(2988, NULL, 'cd19884', NULL, NULL, 'DSRM_STAU2_rpt3', NULL, 'DSRM_STAU2_rpt3', NULL, NULL, 34007, 2),
(2989, NULL, 'cd11471', NULL, NULL, 'bHLH_TS_HAND2', NULL, 'bHLH_TS_HAND2', NULL, NULL, NULL, 2),
(2990, NULL, 'cd07792', NULL, NULL, 'FGGY_GK1-3_metazoa', NULL, 'FGGY_GK1-3_metazoa', NULL, NULL, 30247, 2),
(2991, NULL, 'cd09077', NULL, NULL, 'R1-I-EN', NULL, 'R1-I-EN', NULL, NULL, NULL, 2),
(2992, NULL, 'cd10450', NULL, NULL, 'GIY-YIG_AtGrxS16_like', NULL, 'GIY-YIG_AtGrxS16_like', NULL, NULL, NULL, 2),
(2993, NULL, 'cd00844', NULL, NULL, 'MPP_Dbr1_N', NULL, 'MPP_Dbr1_N', NULL, NULL, 31096, 2),
(2994, NULL, 'cd04979', NULL, NULL, 'Ig_Semaphorin_C', NULL, 'Ig_Semaphorin_C', NULL, NULL, NULL, 2),
(2995, NULL, 'cd14028', NULL, NULL, 'STKc_Bub1_vert', NULL, 'STKc_Bub1_vert', NULL, NULL, NULL, 2),
(2996, NULL, 'cd20238', NULL, NULL, 'PFM_ABFB-like', NULL, 'PFM_ABFB-like', NULL, NULL, NULL, 2),
(2997, NULL, 'cd03162', NULL, NULL, 'peripherin_like_LEL', NULL, 'peripherin_like_LEL', NULL, NULL, 30878, 2),
(2998, NULL, 'cd07093', NULL, NULL, 'ALDH_F8_HMSADH', NULL, 'ALDH_F8_HMSADH', NULL, NULL, NULL, 2),
(2999, NULL, 'cd11381', NULL, NULL, 'NSA2', NULL, 'NSA2', NULL, NULL, 27526, 2),
(3000, NULL, 'cd17647', NULL, NULL, 'A_NRPS_alphaAR', NULL, 'A_NRPS_alphaAR', NULL, NULL, NULL, 2),
(3001, NULL, 'cd18282', NULL, NULL, 'BTB_POZ_BTBD3_6', NULL, 'BTB_POZ_BTBD3_6', NULL, NULL, NULL, 2),
(3002, NULL, 'cd19085', NULL, NULL, 'AKR_AKR11B3', NULL, 'AKR_AKR11B3', NULL, NULL, NULL, 2),
(3003, NULL, 'cd01367', NULL, NULL, 'KISc_KIF2_like', NULL, 'KISc_KIF2_like', NULL, NULL, NULL, 2),
(3004, NULL, 'cd04189', NULL, NULL, 'G1P_TT_long', NULL, 'G1P_TT_long', NULL, NULL, 121, 2),
(3005, NULL, 'cd05148', NULL, NULL, 'PTKc_Srm_Brk', NULL, 'PTKc_Srm_Brk', NULL, NULL, NULL, 2),
(3006, NULL, 'cd12950', NULL, NULL, 'RRP7_Rrp7p', NULL, 'RRP7_Rrp7p', NULL, NULL, NULL, 2),
(3007, NULL, 'cd18183', NULL, NULL, 'ATP-synt_Fo_c_ATPH', NULL, 'ATP-synt_Fo_c_ATPH', NULL, NULL, NULL, 2);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(3008, NULL, 'cd01167', NULL, NULL, 'bac_FRK', NULL, 'bac_FRK', NULL, NULL, NULL, 2),
(3009, NULL, 'cd18071', NULL, NULL, 'DEXHc_HLTF1_SMARC3', NULL, 'DEXHc_HLTF1_SMARC3', NULL, NULL, NULL, 2),
(3010, NULL, 'cd09552', NULL, NULL, 'SAM_EPH-B2', NULL, 'SAM_EPH-B2', NULL, NULL, NULL, 2),
(3011, NULL, 'cd04229', NULL, NULL, 'CuRO_1_Ceruloplasmin_like_1', NULL, 'CuRO_1_Ceruloplasmin_like_1', NULL, NULL, NULL, 2),
(3012, NULL, 'cd13604', NULL, NULL, 'PBP2_TRAP_ketoacid_lactate_like', NULL, 'PBP2_TRAP_ketoacid_lactate_like', NULL, NULL, NULL, 2),
(3013, NULL, 'cd15296', NULL, NULL, '7tmA_Histamine_H3R', NULL, '7tmA_Histamine_H3R', NULL, NULL, 30792, 2),
(3014, NULL, 'cd18321', NULL, NULL, 'BTB_POZ_EloC', NULL, 'BTB_POZ_EloC', NULL, NULL, NULL, 2),
(3015, NULL, 'cd07618', NULL, NULL, 'BAR_Rich1', NULL, 'BAR_Rich1', NULL, NULL, NULL, 2),
(3016, NULL, 'cd10553', NULL, NULL, 'PhsB_like', NULL, 'PhsB_like', NULL, NULL, NULL, 2),
(3017, NULL, 'cd07126', NULL, NULL, 'ALDH_F12_P5CDH', NULL, 'ALDH_F12_P5CDH', NULL, NULL, NULL, 2),
(3018, NULL, 'cd17050', NULL, NULL, 'Ubl1_ANKUB1', NULL, 'Ubl1_ANKUB1', NULL, NULL, NULL, 2),
(3019, NULL, 'cd19446', NULL, NULL, 'FABP6', NULL, 'FABP6', NULL, NULL, NULL, 2),
(3020, NULL, 'cd03254', NULL, NULL, 'ABCC_Glucan_exporter_like', NULL, 'ABCC_Glucan_exporter_like', NULL, NULL, NULL, 2),
(3021, NULL, 'cd16683', NULL, NULL, 'RING-H2_RNF139', NULL, 'RING-H2_RNF139', NULL, NULL, NULL, 2),
(3022, NULL, 'cd09190', NULL, NULL, 'PLDc_DNaseII_beta_1', NULL, 'PLDc_DNaseII_beta_1', NULL, NULL, NULL, 2),
(3023, NULL, 'cd10389', NULL, NULL, 'SH2_SHB', NULL, 'SH2_SHB', NULL, NULL, 9035, 2),
(3024, NULL, 'cd15618', NULL, NULL, 'PHD1_MOZ_MORF', NULL, 'PHD1_MOZ_MORF', NULL, NULL, NULL, 2),
(3025, NULL, 'cd14581', NULL, NULL, 'DUSP22', NULL, 'DUSP22', NULL, NULL, NULL, 2),
(3026, NULL, 'cd01044', NULL, NULL, 'Ferritin_CCC1_N', NULL, 'Ferritin_CCC1_N', NULL, NULL, 27653, 2),
(3027, NULL, 'cd06462', NULL, NULL, 'Peptidase_S24_S26', NULL, 'Peptidase_S24_S26', NULL, NULL, NULL, 2),
(3028, NULL, 'cd00899', NULL, NULL, 'b4GalT', NULL, 'b4GalT', NULL, NULL, NULL, 2),
(3029, NULL, 'cd03220', NULL, NULL, 'ABC_KpsT_Wzt', NULL, 'ABC_KpsT_Wzt', NULL, NULL, 13390, 2),
(3030, NULL, 'cd06380', NULL, NULL, 'PBP1_iGluR_AMPA', NULL, 'PBP1_iGluR_AMPA', NULL, NULL, NULL, 2),
(3031, NULL, 'cd08911', NULL, NULL, 'START_STARD7-like', NULL, 'START_STARD7-like', NULL, NULL, 30601, 2),
(3032, NULL, 'cd17966', NULL, NULL, 'DEADc_DDX5_DDX17', NULL, 'DEADc_DDX5_DDX17', NULL, NULL, NULL, 2),
(3033, NULL, 'cd06481', NULL, NULL, 'ACD_HspB9_like', NULL, 'ACD_HspB9_like', NULL, NULL, NULL, 2),
(3034, NULL, 'cd04133', NULL, NULL, 'Rop_like', NULL, 'Rop_like', NULL, NULL, NULL, 2),
(3035, NULL, 'cd11791', NULL, NULL, 'SH3_UBASH3', NULL, 'SH3_UBASH3', NULL, NULL, NULL, 2),
(3036, NULL, 'cd09845', NULL, NULL, 'PLDc_vPLD2_2', NULL, 'PLDc_vPLD2_2', NULL, NULL, NULL, 2),
(3037, NULL, 'cd15378', NULL, NULL, '7tmA_SUCNR1_GPR91', NULL, '7tmA_SUCNR1_GPR91', NULL, NULL, NULL, 2),
(3038, NULL, 'cd03289', NULL, NULL, 'ABCC_CFTR2', NULL, 'ABCC_CFTR2', NULL, NULL, NULL, 2),
(3039, NULL, 'cd18896', NULL, NULL, 'TET2', NULL, 'TET2', NULL, NULL, NULL, 2),
(3040, NULL, 'cd08403', NULL, NULL, 'C2B_Synaptotagmin-3-5-6-9-10', NULL, 'C2B_Synaptotagmin-3-5-6-9-10', NULL, NULL, NULL, 2),
(3041, NULL, 'cd13566', NULL, NULL, 'PBP2_phosphate', NULL, 'PBP2_phosphate', NULL, NULL, NULL, 2),
(3042, NULL, 'cd04200', NULL, NULL, 'CuRO_2_ceruloplasmin_like', NULL, 'CuRO_2_ceruloplasmin_like', NULL, NULL, NULL, 2),
(3043, NULL, 'cd05567', NULL, NULL, 'PTS_IIB_mannitol', NULL, 'PTS_IIB_mannitol', NULL, NULL, 23830, 2),
(3044, NULL, 'cd13591', NULL, NULL, 'PBP2_HisGL1', NULL, 'PBP2_HisGL1', NULL, NULL, NULL, 2),
(3045, NULL, 'cd12275', NULL, NULL, 'RRM1_MEI2_EAR1_like', NULL, 'RRM1_MEI2_EAR1_like', NULL, NULL, NULL, 2),
(3046, NULL, 'cd05301', NULL, NULL, 'GDH', NULL, 'GDH', NULL, NULL, NULL, 2),
(3047, NULL, 'cd17627', NULL, NULL, 'REC_OmpR_PrrA-like', NULL, 'REC_OmpR_PrrA-like', NULL, NULL, NULL, 2),
(3048, NULL, 'cd19790', NULL, NULL, 'Bbox2_TRIM59_C-XI', NULL, 'Bbox2_TRIM59_C-XI', NULL, NULL, NULL, 2);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(3049, NULL, 'cd16401', NULL, NULL, 'ParB_N_like_MT', NULL, 'ParB_N_like_MT', NULL, NULL, NULL, 2),
(3050, NULL, 'cd15193', NULL, NULL, '7tmA_GPR25', NULL, '7tmA_GPR25', NULL, NULL, NULL, 2),
(3051, NULL, 'cd06218', NULL, NULL, 'DHOD_e_trans', NULL, 'DHOD_e_trans', NULL, NULL, NULL, 2),
(3052, NULL, 'cd13145', NULL, NULL, 'MATE_like_5', NULL, 'MATE_like_5', NULL, NULL, NULL, 2),
(3053, NULL, 'cd16193', NULL, NULL, 'EFh_PEF_CAPN11', NULL, 'EFh_PEF_CAPN11', NULL, NULL, NULL, 2),
(3054, NULL, 'cd09672', NULL, NULL, 'Cas8a1_I-A', NULL, 'Cas8a1_I-A', NULL, NULL, NULL, 2),
(3055, NULL, 'cd04081', NULL, NULL, 'CBM35_galactosidase-like', NULL, 'CBM35_galactosidase-like', NULL, NULL, NULL, 2),
(3056, NULL, 'cd10467', NULL, NULL, 'FAM20_C_like', NULL, 'FAM20_C_like', NULL, NULL, NULL, 2),
(3057, NULL, 'cd10339', NULL, NULL, 'SH2_RIN_family', NULL, 'SH2_RIN_family', NULL, NULL, NULL, 2),
(3058, NULL, 'cd15494', NULL, NULL, 'PHD_ATX1_2_like', NULL, 'PHD_ATX1_2_like', NULL, NULL, 30475, 2),
(3059, NULL, 'cd12602', NULL, NULL, 'RRM2_SF2_plant_like', NULL, 'RRM2_SF2_plant_like', NULL, NULL, NULL, 2),
(3060, NULL, 'cd11776', NULL, NULL, 'SH3_PI3K_p85', NULL, 'SH3_PI3K_p85', NULL, NULL, NULL, 2),
(3061, NULL, 'cd03530', NULL, NULL, 'Rieske_NirD_small_Bacillus', NULL, 'Rieske_NirD_small_Bacillus', NULL, NULL, NULL, 2),
(3062, NULL, 'cd11994', NULL, NULL, 'SH3_Intersectin2_4', NULL, 'SH3_Intersectin2_4', NULL, NULL, 28166, 2),
(3063, NULL, 'cd17942', NULL, NULL, 'DEADc_DDX18', NULL, 'DEADc_DDX18', NULL, NULL, 34789, 2),
(3064, NULL, 'cd08492', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_15', NULL, 'PBP2_NikA_DppA_OppA_like_15', NULL, NULL, NULL, 2),
(3065, NULL, 'cd03687', NULL, NULL, 'Dehydratase_LU', NULL, 'Dehydratase_LU', NULL, NULL, 2370, 2),
(3066, NULL, 'cd18046', NULL, NULL, 'DEADc_EIF4AII_EIF4AI_DDX2', NULL, 'DEADc_EIF4AII_EIF4AI_DDX2', NULL, NULL, 36866, 2),
(3067, NULL, 'cd01049', NULL, NULL, 'RNRR2', NULL, 'RNRR2', NULL, NULL, 27798, 2),
(3068, NULL, 'cd09618', NULL, NULL, 'CBM9_like_2', NULL, 'CBM9_like_2', NULL, NULL, NULL, 2),
(3069, NULL, 'cd01305', NULL, NULL, 'archeal_chlorohydrolases', NULL, 'archeal_chlorohydrolases', NULL, NULL, NULL, 2),
(3070, NULL, 'cd04794', NULL, NULL, 'euk_LANCL', NULL, 'euk_LANCL', NULL, NULL, NULL, 2),
(3071, NULL, 'cd07823', NULL, NULL, 'SRPBCC_5', NULL, 'SRPBCC_5', NULL, NULL, NULL, 2),
(3072, NULL, 'cd08915', NULL, NULL, 'V_Alix_like', NULL, 'V_Alix_like', NULL, NULL, NULL, 2),
(3073, NULL, 'cd01254', NULL, NULL, 'PH_PLD', NULL, 'PH_PLD', NULL, NULL, NULL, 2),
(3074, NULL, 'cd12188', NULL, NULL, 'SDH', NULL, 'SDH', NULL, NULL, 26321, 2),
(3075, NULL, 'cd05107', NULL, NULL, 'PTKc_PDGFR_beta', NULL, 'PTKc_PDGFR_beta', NULL, NULL, NULL, 2),
(3076, NULL, 'cd16752', NULL, NULL, 'RING-HC_SIAH2', NULL, 'RING-HC_SIAH2', NULL, NULL, NULL, 2),
(3077, NULL, 'cd19797', NULL, NULL, 'Bbox2_TRIM72_C-IV', NULL, 'Bbox2_TRIM72_C-IV', NULL, NULL, NULL, 2),
(3078, NULL, 'cd02737', NULL, NULL, 'RNAP_IV_NRPD1_C', NULL, 'RNAP_IV_NRPD1_C', NULL, NULL, 27664, 2),
(3079, NULL, 'cd17572', NULL, NULL, 'REC_NtrC1-like', NULL, 'REC_NtrC1-like', NULL, NULL, NULL, 2),
(3080, NULL, 'cd18962', NULL, NULL, 'CD_MT_like', NULL, 'CD_MT_like', NULL, NULL, NULL, 2),
(3081, NULL, 'cd19022', NULL, NULL, 'LGIC_ECD_nAChR_A9', NULL, 'LGIC_ECD_nAChR_A9', NULL, NULL, NULL, 2),
(3082, NULL, 'cd09940', NULL, NULL, 'SH2_Vav_family', NULL, 'SH2_Vav_family', NULL, NULL, 28211, 2),
(3083, NULL, 'cd12107', NULL, NULL, 'Hemerythrin', NULL, 'Hemerythrin', NULL, NULL, 12714, 2),
(3084, NULL, 'cd09020', NULL, NULL, 'D-hex-6-P-epi_like', NULL, 'D-hex-6-P-epi_like', NULL, NULL, 23537, 2),
(3085, NULL, 'cd11432', NULL, NULL, 'bHLH-PAS_NPAS1_3_like', NULL, 'bHLH-PAS_NPAS1_3_like', NULL, NULL, NULL, 2),
(3086, NULL, 'cd12238', NULL, NULL, 'RRM1_RBM40_like', NULL, 'RRM1_RBM40_like', NULL, NULL, 21370, 2),
(3087, NULL, 'cd05939', NULL, NULL, 'hsFATP4_like', NULL, 'hsFATP4_like', NULL, NULL, NULL, 2),
(3088, NULL, 'cd14846', NULL, NULL, 'Peptidase_M15_like', NULL, 'Peptidase_M15_like', NULL, NULL, NULL, 2),
(3089, NULL, 'cd01721', NULL, NULL, 'Sm_D3', NULL, 'Sm_D3', NULL, NULL, 11260, 2);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(3090, NULL, 'cd14553', NULL, NULL, 'R-PTPc-LAR-1', NULL, 'R-PTPc-LAR-1', NULL, NULL, NULL, 2),
(3091, NULL, 'cd20233', NULL, NULL, 'PFM_unzipped-like', NULL, 'PFM_unzipped-like', NULL, NULL, NULL, 2),
(3092, NULL, 'cd21410', NULL, NULL, '1B_av_Nsp10-like', NULL, '1B_av_Nsp10-like', NULL, NULL, 33708, 2),
(3093, NULL, 'cd11010', NULL, NULL, 'S1-P1_nuclease', NULL, 'S1-P1_nuclease', NULL, NULL, 1670, 2),
(3094, NULL, 'cd18024', NULL, NULL, 'DEXHc_Mtr4-like', NULL, 'DEXHc_Mtr4-like', NULL, NULL, NULL, 2),
(3095, NULL, 'cd17736', NULL, NULL, 'BRCT_microcephalin_rpt2', NULL, 'BRCT_microcephalin_rpt2', NULL, NULL, NULL, 2),
(3096, NULL, 'cd15912', NULL, NULL, '7tmA_OR6C-like', NULL, '7tmA_OR6C-like', NULL, NULL, NULL, 2),
(3097, NULL, 'cd07355', NULL, NULL, 'HN_L-delphilin-R2_like', NULL, 'HN_L-delphilin-R2_like', NULL, NULL, NULL, 2),
(3098, NULL, 'cd04234', NULL, NULL, 'AAK_AK', NULL, 'AAK_AK', NULL, NULL, NULL, 2),
(3099, NULL, 'cd16028', NULL, NULL, 'PMH', NULL, 'PMH', NULL, NULL, NULL, 2),
(3100, NULL, 'cd02672', NULL, NULL, 'Peptidase_C19P', NULL, 'Peptidase_C19P', NULL, NULL, NULL, 2),
(3101, NULL, 'cd06286', NULL, NULL, 'PBP1_CcpB-like', NULL, 'PBP1_CcpB-like', NULL, NULL, NULL, 2),
(3102, NULL, 'cd07740', NULL, NULL, 'metallo-hydrolase-like_MBL-fold', NULL, 'metallo-hydrolase-like_MBL-fold', NULL, NULL, NULL, 2),
(3103, NULL, 'cd14425', NULL, NULL, 'UBA1_HR23A', NULL, 'UBA1_HR23A', NULL, NULL, NULL, 2),
(3104, NULL, 'cd02947', NULL, NULL, 'TRX_family', NULL, 'TRX_family', NULL, NULL, NULL, 2),
(3105, NULL, 'cd00055', NULL, NULL, 'EGF_Lam', NULL, 'EGF_Lam', NULL, NULL, 1303, 2),
(3106, NULL, 'cd03419', NULL, NULL, 'GRX_GRXh_1_2_like', NULL, 'GRX_GRXh_1_2_like', NULL, NULL, NULL, 2),
(3107, NULL, 'cd18935', NULL, NULL, 'bHLH_TS_MYOG_Myf4', NULL, 'bHLH_TS_MYOG_Myf4', NULL, NULL, NULL, 2),
(3108, NULL, 'cd02696', NULL, NULL, 'MurNAc-LAA', NULL, 'MurNAc-LAA', NULL, NULL, 604, 2),
(3109, NULL, 'cd14675', NULL, NULL, 'PH-SEC3_like', NULL, 'PH-SEC3_like', NULL, NULL, NULL, 2),
(3110, NULL, 'cd04776', NULL, NULL, 'HTH_GnyR', NULL, 'HTH_GnyR', NULL, NULL, NULL, 2),
(3111, NULL, 'cd12836', NULL, NULL, 'HpCorA-like', NULL, 'HpCorA-like', NULL, NULL, NULL, 2),
(3112, NULL, 'cd00865', NULL, NULL, 'PEBP_bact_arch', NULL, 'PEBP_bact_arch', NULL, NULL, 11363, 2),
(3113, NULL, 'cd08366', NULL, NULL, 'APC10', NULL, 'APC10', NULL, NULL, 17362, 2),
(3114, NULL, 'cd18827', NULL, NULL, 'GH43_XlnD-like', NULL, 'GH43_XlnD-like', NULL, NULL, NULL, 2),
(3115, NULL, 'cd13518', NULL, NULL, 'PBP2_Fe3_thiamine_like', NULL, 'PBP2_Fe3_thiamine_like', NULL, NULL, NULL, 2),
(3116, NULL, 'cd08184', NULL, NULL, 'Fe-ADH_KdnB-like', NULL, 'Fe-ADH_KdnB-like', NULL, NULL, NULL, 2),
(3117, NULL, 'cd18520', NULL, NULL, 'BACK_roadkill_like', NULL, 'BACK_roadkill_like', NULL, NULL, NULL, 2),
(3118, NULL, 'cd18615', NULL, NULL, 'GH130', NULL, 'GH130', NULL, NULL, NULL, 2),
(3119, NULL, 'cd08459', NULL, NULL, 'PBP2_DntR_NahR_LinR_like', NULL, 'PBP2_DntR_NahR_LinR_like', NULL, NULL, NULL, 2),
(3120, NULL, 'cd15972', NULL, NULL, '7tmA_SSTR3', NULL, '7tmA_SSTR3', NULL, NULL, NULL, 2),
(3121, NULL, 'cd18676', NULL, NULL, 'PIN_asteroid-like', NULL, 'PIN_asteroid-like', NULL, NULL, NULL, 2),
(3122, NULL, 'cd04677', NULL, NULL, 'Nudix_Hydrolase_18', NULL, 'Nudix_Hydrolase_18', NULL, NULL, NULL, 2),
(3123, NULL, 'cd01733', NULL, NULL, 'LSm10', NULL, 'LSm10', NULL, NULL, NULL, 2),
(3124, NULL, 'cd03461', NULL, NULL, '1,2-HQD', NULL, '1,2-HQD', NULL, NULL, 27121, 2),
(3125, NULL, 'cd07148', NULL, NULL, 'ALDH_RL0313', NULL, 'ALDH_RL0313', NULL, NULL, NULL, 2),
(3126, NULL, 'cd15655', NULL, NULL, 'PHD3_NSD3', NULL, 'PHD3_NSD3', NULL, NULL, NULL, 2),
(3127, NULL, 'cd05083', NULL, NULL, 'PTKc_Chk', NULL, 'PTKc_Chk', NULL, NULL, NULL, 2),
(3128, NULL, 'cd14830', NULL, NULL, 'Delta_COP_N', NULL, 'Delta_COP_N', NULL, NULL, NULL, 2),
(3129, NULL, 'cd05681', NULL, NULL, 'M20_dipept_Sso-CP2', NULL, 'M20_dipept_Sso-CP2', NULL, NULL, NULL, 2),
(3130, NULL, 'cd19093', NULL, NULL, 'AKR_AtPLR-like', NULL, 'AKR_AtPLR-like', NULL, NULL, NULL, 2),
(3131, NULL, 'cd19732', NULL, NULL, 'bHLH-PAS_NPAS3_PASD6', NULL, 'bHLH-PAS_NPAS3_PASD6', NULL, NULL, NULL, 2);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(3132, NULL, 'cd14066', NULL, NULL, 'STKc_IRAK', NULL, 'STKc_IRAK', NULL, NULL, NULL, 2),
(3133, NULL, 'cd02690', NULL, NULL, 'M28', NULL, 'M28', NULL, NULL, NULL, 2),
(3134, NULL, 'cd06315', NULL, NULL, 'PBP1_ABC_sugar_binding-like', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, NULL, 2),
(3135, NULL, 'cd12749', NULL, NULL, 'RRM4_RBM12', NULL, 'RRM4_RBM12', NULL, NULL, 8713, 2),
(3136, NULL, 'cd15999', NULL, NULL, '7tmB2_GPR125', NULL, '7tmB2_GPR125', NULL, NULL, NULL, 2),
(3137, NULL, 'cd11526', NULL, NULL, 'SYLF_FYVE', NULL, 'SYLF_FYVE', NULL, NULL, NULL, 2),
(3138, NULL, 'cd16725', NULL, NULL, 'RING2-HC_MIB1', NULL, 'RING2-HC_MIB1', NULL, NULL, NULL, 2),
(3139, NULL, 'cd17134', NULL, NULL, 'RBD_BRAF', NULL, 'RBD_BRAF', NULL, NULL, NULL, 2),
(3140, NULL, 'cd02067', NULL, NULL, 'B12-binding', NULL, 'B12-binding', NULL, NULL, NULL, 2),
(3141, NULL, 'cd09879', NULL, NULL, 'PIN_VapC_AF0591-like', NULL, 'PIN_VapC_AF0591-like', NULL, NULL, NULL, 2),
(3142, NULL, 'cd17400', NULL, NULL, 'MFS_SLCO1_OATP1', NULL, 'MFS_SLCO1_OATP1', NULL, NULL, NULL, 2),
(3143, NULL, 'cd10438', NULL, NULL, 'GIY-YIG_MSH', NULL, 'GIY-YIG_MSH', NULL, NULL, NULL, 2),
(3144, NULL, 'cd16239', NULL, NULL, 'EFh_SPARC_TICN3', NULL, 'EFh_SPARC_TICN3', NULL, NULL, NULL, 2),
(3145, NULL, 'cd19906', NULL, NULL, 'DSRM_ADAD2', NULL, 'DSRM_ADAD2', NULL, NULL, 35188, 2),
(3146, NULL, 'cd16906', NULL, NULL, 'YEATS_AF-9_like', NULL, 'YEATS_AF-9_like', NULL, NULL, NULL, 2),
(3147, NULL, 'cd12698', NULL, NULL, 'RRM3_PTBPH3', NULL, 'RRM3_PTBPH3', NULL, NULL, 32373, 2),
(3148, NULL, 'cd03773', NULL, NULL, 'MATH_TRIM37', NULL, 'MATH_TRIM37', NULL, NULL, 32273, 2),
(3149, NULL, 'cd19034', NULL, NULL, 'LGIC_ECD_GABAAR_A1', NULL, 'LGIC_ECD_GABAAR_A1', NULL, NULL, NULL, 2),
(3150, NULL, 'cd10410', NULL, NULL, 'SH2_SH2B1', NULL, 'SH2_SH2B1', NULL, NULL, NULL, 2),
(3151, NULL, 'cd14243', NULL, NULL, 'PT-AcyF_like', NULL, 'PT-AcyF_like', NULL, NULL, NULL, 2),
(3152, NULL, 'cd09646', NULL, NULL, 'Cas7_I-E', NULL, 'Cas7_I-E', NULL, NULL, 10592, 2),
(3153, NULL, 'cd18587', NULL, NULL, 'ABC_6TM_LapB_like', NULL, 'ABC_6TM_LapB_like', NULL, NULL, NULL, 2),
(3154, NULL, 'cd09707', NULL, NULL, 'Csf3_U', NULL, 'Csf3_U', NULL, NULL, 14906, 2),
(3155, NULL, 'cd15231', NULL, NULL, '7tmA_OR5V1-like', NULL, '7tmA_OR5V1-like', NULL, NULL, NULL, 2),
(3156, NULL, 'cd16222', NULL, NULL, 'EFh_PRIP1', NULL, 'EFh_PRIP1', NULL, NULL, NULL, 2),
(3157, NULL, 'cd13220', NULL, NULL, 'PH-GRAM_GRAMDC', NULL, 'PH-GRAM_GRAMDC', NULL, NULL, NULL, 2),
(3158, NULL, 'cd16299', NULL, NULL, 'IND_BlaB-like_MBL-B1', NULL, 'IND_BlaB-like_MBL-B1', NULL, NULL, NULL, 2),
(3159, NULL, 'cd07608', NULL, NULL, 'BAR_ArfGAP_fungi', NULL, 'BAR_ArfGAP_fungi', NULL, NULL, NULL, 2),
(3160, NULL, 'cd18487', NULL, NULL, 'BACK_BTBD1_like', NULL, 'BACK_BTBD1_like', NULL, NULL, NULL, 2),
(3161, NULL, 'cd01152', NULL, NULL, 'ACAD_fadE6_17_26', NULL, 'ACAD_fadE6_17_26', NULL, NULL, NULL, 2),
(3162, NULL, 'cd12311', NULL, NULL, 'RRM_SRSF2_SRSF8', NULL, 'RRM_SRSF2_SRSF8', NULL, NULL, NULL, 2),
(3163, NULL, 'cd03008', NULL, NULL, 'TryX_like_RdCVF', NULL, 'TryX_like_RdCVF', NULL, NULL, NULL, 2),
(3164, NULL, 'cd13918', NULL, NULL, 'CuRO_HCO_II_like_6', NULL, 'CuRO_HCO_II_like_6', NULL, NULL, NULL, 2),
(3165, NULL, 'cd13668', NULL, NULL, 'PBP2_TRAP_UehA_TeaA', NULL, 'PBP2_TRAP_UehA_TeaA', NULL, NULL, NULL, 2),
(3166, NULL, 'cd02873', NULL, NULL, 'GH18_IDGF', NULL, 'GH18_IDGF', NULL, NULL, 8003, 2),
(3167, NULL, 'cd07089', NULL, NULL, 'ALDH_CddD-AldA-like', NULL, 'ALDH_CddD-AldA-like', NULL, NULL, NULL, 2),
(3168, NULL, 'cd07247', NULL, NULL, 'SgaA_N_like', NULL, 'SgaA_N_like', NULL, NULL, NULL, 2),
(3169, NULL, 'cd09588', NULL, NULL, 'SAM_LBP1', NULL, 'SAM_LBP1', NULL, NULL, 33778, 2),
(3170, NULL, 'cd19374', NULL, NULL, 'UDG-F3_SMUG1-like', NULL, 'UDG-F3_SMUG1-like', NULL, NULL, 27654, 2),
(3171, NULL, 'cd05022', NULL, NULL, 'S-100A13', NULL, 'S-100A13', NULL, NULL, NULL, 2),
(3172, NULL, 'cd00494', NULL, NULL, 'PBP2_HMBS', NULL, 'PBP2_HMBS', NULL, NULL, NULL, 2),
(3173, NULL, 'cd00229', NULL, NULL, 'SGNH_hydrolase', NULL, 'SGNH_hydrolase', NULL, NULL, NULL, 2);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(3174, NULL, 'cd07005', NULL, NULL, 'cupin_WbuC-like', NULL, 'cupin_WbuC-like', NULL, NULL, NULL, 2),
(3175, NULL, 'cd13639', NULL, NULL, 'PBP2_OpuAC_like', NULL, 'PBP2_OpuAC_like', NULL, NULL, NULL, 2),
(3176, NULL, 'cd05598', NULL, NULL, 'STKc_LATS', NULL, 'STKc_LATS', NULL, NULL, NULL, 2),
(3177, NULL, 'cd10361', NULL, NULL, 'SH2_Fps_family', NULL, 'SH2_Fps_family', NULL, NULL, 32096, 2),
(3178, NULL, 'cd09299', NULL, NULL, 'TDT', NULL, 'TDT', NULL, NULL, NULL, 2),
(3179, NULL, 'cd17872', NULL, NULL, 'GPN3', NULL, 'GPN3', NULL, NULL, NULL, 2),
(3180, NULL, 'cd11709', NULL, NULL, 'SPRY', NULL, 'SPRY', NULL, NULL, NULL, 2),
(3181, NULL, 'cd14982', NULL, NULL, '7tmA_purinoceptor-like', NULL, '7tmA_purinoceptor-like', NULL, NULL, NULL, 2),
(3182, NULL, 'cd02036', NULL, NULL, 'MinD', NULL, 'MinD', NULL, NULL, NULL, 2),
(3183, NULL, 'cd03214', NULL, NULL, 'ABC_Iron-Siderophores_B12_Hemin', NULL, 'ABC_Iron-Siderophores_B12_Hemin', NULL, NULL, NULL, 2),
(3184, NULL, 'cd05334', NULL, NULL, 'DHPR_SDR_c_like', NULL, 'DHPR_SDR_c_like', NULL, NULL, NULL, 2),
(3185, NULL, 'cd15264', NULL, NULL, '7tmB1_CRF-R', NULL, '7tmB1_CRF-R', NULL, NULL, NULL, 2),
(3186, NULL, 'cd01197', NULL, NULL, 'INT_FimBE_like', NULL, 'INT_FimBE_like', NULL, NULL, NULL, 2),
(3187, NULL, 'cd08276', NULL, NULL, 'MDR7', NULL, 'MDR7', NULL, NULL, NULL, 2),
(3188, NULL, 'cd10958', NULL, NULL, 'CE4_NodB_like_2', NULL, 'CE4_NodB_like_2', NULL, NULL, NULL, 2),
(3189, NULL, 'cd11459', NULL, NULL, 'bHLH-O_HES1_4', NULL, 'bHLH-O_HES1_4', NULL, NULL, NULL, 2),
(3190, NULL, 'cd03713', NULL, NULL, 'EFG_mtEFG_C', NULL, 'EFG_mtEFG_C', NULL, NULL, 31733, 2),
(3191, NULL, 'cd14892', NULL, NULL, 'MYSc_Myo31', NULL, 'MYSc_Myo31', NULL, NULL, NULL, 2),
(3192, NULL, 'cd06949', NULL, NULL, 'NR_LBD_ER', NULL, 'NR_LBD_ER', NULL, NULL, NULL, 2),
(3193, NULL, 'cd14246', NULL, NULL, 'ADAM17_MPD', NULL, 'ADAM17_MPD', NULL, NULL, 23106, 2),
(3194, NULL, 'cd10401', NULL, NULL, 'SH2_C-SH2_Syk_like', NULL, 'SH2_C-SH2_Syk_like', NULL, NULL, NULL, 2),
(3195, NULL, 'cd15700', NULL, NULL, 'ePHD_RAI1', NULL, 'ePHD_RAI1', NULL, NULL, NULL, 2),
(3196, NULL, 'cd05617', NULL, NULL, 'STKc_aPKC_zeta', NULL, 'STKc_aPKC_zeta', NULL, NULL, 7112, 2),
(3197, NULL, 'cd14907', NULL, NULL, 'MYSc_Myo46', NULL, 'MYSc_Myo46', NULL, NULL, NULL, 2),
(3198, NULL, 'cd01253', NULL, NULL, 'PH_ARHGAP21-like', NULL, 'PH_ARHGAP21-like', NULL, NULL, NULL, 2),
(3199, NULL, 'cd03868', NULL, NULL, 'M14_CPD_I', NULL, 'M14_CPD_I', NULL, NULL, NULL, 2),
(3200, NULL, 'cd16928', NULL, NULL, 'HATPase_GyrB-like', NULL, 'HATPase_GyrB-like', NULL, NULL, NULL, 2),
(3201, NULL, 'cd12966', NULL, NULL, 'CBM-Ec_CBM-Fc', NULL, 'CBM-Ec_CBM-Fc', NULL, NULL, NULL, 2),
(3202, NULL, 'cd00570', NULL, NULL, 'GST_N_family', NULL, 'GST_N_family', NULL, NULL, NULL, 2),
(3203, NULL, 'cd15714', NULL, NULL, 'ePHD_JMJD2B', NULL, 'ePHD_JMJD2B', NULL, NULL, NULL, 2),
(3204, NULL, 'cd02064', NULL, NULL, 'FAD_synthetase_N', NULL, 'FAD_synthetase_N', NULL, NULL, 13358, 2),
(3205, NULL, 'cd07447', NULL, NULL, 'CRD_Carboxypeptidase_Z', NULL, 'CRD_Carboxypeptidase_Z', NULL, NULL, NULL, 2),
(3206, NULL, 'cd06160', NULL, NULL, 'S2P-M50_like_2', NULL, 'S2P-M50_like_2', NULL, NULL, NULL, 2),
(3207, NULL, 'cd04692', NULL, NULL, 'Nudix_Hydrolase_33', NULL, 'Nudix_Hydrolase_33', NULL, NULL, NULL, 2),
(3208, NULL, 'cd07492', NULL, NULL, 'Peptidases_S8_8', NULL, 'Peptidases_S8_8', NULL, NULL, 21557, 2),
(3209, NULL, 'cd13563', NULL, NULL, 'PBP2_SsuA_like_6', NULL, 'PBP2_SsuA_like_6', NULL, NULL, NULL, 2),
(3210, NULL, 'cd02209', NULL, NULL, 'cupin_XRE_C', NULL, 'cupin_XRE_C', NULL, NULL, NULL, 2),
(3211, NULL, 'cd08382', NULL, NULL, 'C2_Smurf-like', NULL, 'C2_Smurf-like', NULL, NULL, NULL, 2),
(3212, NULL, 'cd13939', NULL, NULL, 'PANDER_FAM3B', NULL, 'PANDER_FAM3B', NULL, NULL, NULL, 2),
(3213, NULL, 'cd19606', NULL, NULL, 'GH113-like', NULL, 'GH113-like', NULL, NULL, NULL, 2),
(3214, NULL, 'cd18806', NULL, NULL, 'SF2_C_viral', NULL, 'SF2_C_viral', NULL, NULL, NULL, 2),
(3215, NULL, 'cd18635', NULL, NULL, 'CD_CMT3_like', NULL, 'CD_CMT3_like', NULL, NULL, NULL, 2);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(3216, NULL, 'cd12880', NULL, NULL, 'SPRYD7', NULL, 'SPRYD7', NULL, NULL, 31431, 2),
(3217, NULL, 'cd13134', NULL, NULL, 'MATE_like_8', NULL, 'MATE_like_8', NULL, NULL, NULL, 2),
(3218, NULL, 'cd09742', NULL, NULL, 'Csm6_III-A', NULL, 'Csm6_III-A', NULL, NULL, NULL, 2),
(3219, NULL, 'cd06406', NULL, NULL, 'PB1_P67', NULL, 'PB1_P67', NULL, NULL, 19407, 2),
(3220, NULL, 'cd16910', NULL, NULL, 'YEATS_TFIID14_like', NULL, 'YEATS_TFIID14_like', NULL, NULL, NULL, 2),
(3221, NULL, 'cd16720', NULL, NULL, 'RING-HC_MEX3A', NULL, 'RING-HC_MEX3A', NULL, NULL, NULL, 2),
(3222, NULL, 'cd11519', NULL, NULL, 'SLC5sbd_SMCT1', NULL, 'SLC5sbd_SMCT1', NULL, NULL, 30191, 2),
(3223, NULL, 'cd11993', NULL, NULL, 'SH3_Intersectin1_4', NULL, 'SH3_Intersectin1_4', NULL, NULL, NULL, 2),
(3224, NULL, 'cd01699', NULL, NULL, 'RNA_dep_RNAP', NULL, 'RNA_dep_RNAP', NULL, NULL, NULL, 2),
(3225, NULL, 'cd05611', NULL, NULL, 'STKc_Rim15_like', NULL, 'STKc_Rim15_like', NULL, NULL, NULL, 2),
(3226, NULL, 'cd03120', NULL, NULL, 'alpha_CARP_VIII', NULL, 'alpha_CARP_VIII', NULL, NULL, 30551, 2),
(3227, NULL, 'cd04981', NULL, NULL, 'IgV_H', NULL, 'IgV_H', NULL, NULL, NULL, 2),
(3228, NULL, 'cd13126', NULL, NULL, 'MATE_like_11', NULL, 'MATE_like_11', NULL, NULL, NULL, 2),
(3229, NULL, 'cd14297', NULL, NULL, 'UBA2_spUBP14_like', NULL, 'UBA2_spUBP14_like', NULL, NULL, NULL, 2),
(3230, NULL, 'cd07221', NULL, NULL, 'Pat_PNPLA3', NULL, 'Pat_PNPLA3', NULL, NULL, 32839, 2),
(3231, NULL, 'cd12026', NULL, NULL, 'SH3_ZO-1', NULL, 'SH3_ZO-1', NULL, NULL, 33705, 2),
(3232, NULL, 'cd16409', NULL, NULL, 'ParB_N_like', NULL, 'ParB_N_like', NULL, NULL, NULL, 2),
(3233, NULL, 'cd12633', NULL, NULL, 'RRM1_FCA', NULL, 'RRM1_FCA', NULL, NULL, NULL, 2),
(3234, NULL, 'cd18772', NULL, NULL, 'PIN_Mut7-C-like', NULL, 'PIN_Mut7-C-like', NULL, NULL, NULL, 2),
(3235, NULL, 'cd04078', NULL, NULL, 'CBM36_xylanase-like', NULL, 'CBM36_xylanase-like', NULL, NULL, NULL, 2),
(3236, NULL, 'cd08208', NULL, NULL, 'RLP_Photo', NULL, 'RLP_Photo', NULL, NULL, NULL, 2),
(3237, NULL, 'cd16230', NULL, NULL, 'EFh_CREC_RCN3', NULL, 'EFh_CREC_RCN3', NULL, NULL, NULL, 2),
(3238, NULL, 'cd19987', NULL, NULL, 'PBP1_SBP-like', NULL, 'PBP1_SBP-like', NULL, NULL, NULL, 2),
(3239, NULL, 'cd08571', NULL, NULL, 'GDPD_SHV3_plant', NULL, 'GDPD_SHV3_plant', NULL, NULL, NULL, 2),
(3240, NULL, 'cd06413', NULL, NULL, 'GH25_muramidase_1', NULL, 'GH25_muramidase_1', NULL, NULL, NULL, 2),
(3241, NULL, 'cd01480', NULL, NULL, 'vWA_collagen_alpha_1-VI-type', NULL, 'vWA_collagen_alpha_1-VI-type', NULL, NULL, NULL, 2),
(3242, NULL, 'cd16476', NULL, NULL, 'RING-H2_RNF139_like', NULL, 'RING-H2_RNF139_like', NULL, NULL, NULL, 2),
(3243, NULL, 'cd16812', NULL, NULL, 'RING_CH-C4HC3_MARCH7', NULL, 'RING_CH-C4HC3_MARCH7', NULL, NULL, NULL, 2),
(3244, NULL, 'cd14566', NULL, NULL, 'DSP_MKP_classII', NULL, 'DSP_MKP_classII', NULL, NULL, NULL, 2),
(3245, NULL, 'cd16561', NULL, NULL, 'RING-HC_RNF213', NULL, 'RING-HC_RNF213', NULL, NULL, NULL, 2),
(3246, NULL, 'cd19836', NULL, NULL, 'Bbox1_MID1_C-I', NULL, 'Bbox1_MID1_C-I', NULL, NULL, NULL, 2),
(3247, NULL, 'cd08262', NULL, NULL, 'Zn_ADH8', NULL, 'Zn_ADH8', NULL, NULL, NULL, 2),
(3248, NULL, 'cd19445', NULL, NULL, 'FABP2', NULL, 'FABP2', NULL, NULL, NULL, 2),
(3249, NULL, 'cd05173', NULL, NULL, 'PI3Kc_IA_beta', NULL, 'PI3Kc_IA_beta', NULL, NULL, 31078, 2),
(3250, NULL, 'cd17120', NULL, NULL, 'Ubl_UBTD1', NULL, 'Ubl_UBTD1', NULL, NULL, NULL, 2),
(3251, NULL, 'cd02121', NULL, NULL, 'PA_GCPII_like', NULL, 'PA_GCPII_like', NULL, NULL, NULL, 2),
(3252, NULL, 'cd18072', NULL, NULL, 'DEXHc_TTF2', NULL, 'DEXHc_TTF2', NULL, NULL, NULL, 2),
(3253, NULL, 'cd15467', NULL, NULL, 'MV-h', NULL, 'MV-h', NULL, NULL, NULL, 2),
(3254, NULL, 'cd06282', NULL, NULL, 'PBP1_LacI-like', NULL, 'PBP1_LacI-like', NULL, NULL, NULL, 2),
(3255, NULL, 'cd01519', NULL, NULL, 'RHOD_HSP67B2', NULL, 'RHOD_HSP67B2', NULL, NULL, NULL, 2),
(3256, NULL, 'cd14745', NULL, NULL, 'GH66', NULL, 'GH66', NULL, NULL, 22246, 2),
(3257, NULL, 'cd14866', NULL, NULL, 'Fe-ADH-like', NULL, 'Fe-ADH-like', NULL, NULL, NULL, 2);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(3258, NULL, 'cd16379', NULL, NULL, 'YitT_C_like', NULL, 'YitT_C_like', NULL, NULL, NULL, 2),
(3259, NULL, 'cd17444', NULL, NULL, 'MFS_SLC22A23', NULL, 'MFS_SLC22A23', NULL, NULL, NULL, 2),
(3260, NULL, 'cd09594', NULL, NULL, 'GluZincin', NULL, 'GluZincin', NULL, NULL, NULL, 2),
(3261, NULL, 'cd19888', NULL, NULL, 'DSRM_STAU2_rpt5', NULL, 'DSRM_STAU2_rpt5', NULL, NULL, NULL, 2),
(3262, NULL, 'cd09151', NULL, NULL, 'PLDc_Ymt_2', NULL, 'PLDc_Ymt_2', NULL, NULL, NULL, 2),
(3263, NULL, 'cd09474', NULL, NULL, 'LIM2_Lhx2', NULL, 'LIM2_Lhx2', NULL, NULL, NULL, 2),
(3264, NULL, 'cd18971', NULL, NULL, 'CD_POL_like', NULL, 'CD_POL_like', NULL, NULL, NULL, 2),
(3265, NULL, 'cd12318', NULL, NULL, 'RRM5_RBM19_like', NULL, 'RRM5_RBM19_like', NULL, NULL, 13157, 2),
(3266, NULL, 'cd14196', NULL, NULL, 'STKc_DAPK2', NULL, 'STKc_DAPK2', NULL, NULL, NULL, 2),
(3267, NULL, 'cd15527', NULL, NULL, 'PHD2_KAT6A_6B', NULL, 'PHD2_KAT6A_6B', NULL, NULL, NULL, 2),
(3268, NULL, 'cd19102', NULL, NULL, 'AKR_unchar', NULL, 'AKR_unchar', NULL, NULL, NULL, 2),
(3269, NULL, 'cd02605', NULL, NULL, 'HAD_SPP', NULL, 'HAD_SPP', NULL, NULL, NULL, 2),
(3270, NULL, 'cd18618', NULL, NULL, 'GH43_Xsa43E-like', NULL, 'GH43_Xsa43E-like', NULL, NULL, NULL, 2),
(3271, NULL, 'cd10381', NULL, NULL, 'SH2_Jak_Tyk2', NULL, 'SH2_Jak_Tyk2', NULL, NULL, NULL, 2),
(3272, NULL, 'cd17173', NULL, NULL, 'FERM_F1_TLN1', NULL, 'FERM_F1_TLN1', NULL, NULL, NULL, 2),
(3273, NULL, 'cd11649', NULL, NULL, 'RsmI_like', NULL, 'RsmI_like', NULL, NULL, NULL, 2),
(3274, NULL, 'cd16211', NULL, NULL, 'EFh_PI-PLCbeta4', NULL, 'EFh_PI-PLCbeta4', NULL, NULL, NULL, 2),
(3275, NULL, 'cd03296', NULL, NULL, 'ABC_CysA_sulfate_importer', NULL, 'ABC_CysA_sulfate_importer', NULL, NULL, 3740, 2),
(3276, NULL, 'cd11589', NULL, NULL, 'Agmatinase_like_1', NULL, 'Agmatinase_like_1', NULL, NULL, NULL, 2),
(3277, NULL, 'cd16125', NULL, NULL, 'RA_ASPP1_2', NULL, 'RA_ASPP1_2', NULL, NULL, NULL, 2),
(3278, NULL, 'cd12255', NULL, NULL, 'RRM1_LKAP', NULL, 'RRM1_LKAP', NULL, NULL, 5930, 2),
(3279, NULL, 'cd16136', NULL, NULL, 'RA_MRL_Lpd', NULL, 'RA_MRL_Lpd', NULL, NULL, NULL, 2),
(3280, NULL, 'cd17195', NULL, NULL, 'FERM_F1_PTPN13', NULL, 'FERM_F1_PTPN13', NULL, NULL, NULL, 2),
(3281, NULL, 'cd04393', NULL, NULL, 'RhoGAP_FAM13A1a', NULL, 'RhoGAP_FAM13A1a', NULL, NULL, NULL, 2),
(3282, NULL, 'cd09138', NULL, NULL, 'PLDc_vPLD1_2_yPLD_like_1', NULL, 'PLDc_vPLD1_2_yPLD_like_1', NULL, NULL, NULL, 2),
(3283, NULL, 'cd00276', NULL, NULL, 'C2B_Synaptotagmin', NULL, 'C2B_Synaptotagmin', NULL, NULL, NULL, 2),
(3284, NULL, 'cd18515', NULL, NULL, 'BACK_KLHL37_ENC1', NULL, 'BACK_KLHL37_ENC1', NULL, NULL, NULL, 2),
(3285, NULL, 'cd03884', NULL, NULL, 'M20_bAS', NULL, 'M20_bAS', NULL, NULL, NULL, 2),
(3286, NULL, 'cd17672', NULL, NULL, 'MDM2', NULL, 'MDM2', NULL, NULL, NULL, 2),
(3287, NULL, 'cd16220', NULL, NULL, 'EFh_PI-PLCeta1', NULL, 'EFh_PI-PLCeta1', NULL, NULL, NULL, 2),
(3288, NULL, 'cd06880', NULL, NULL, 'PX_SNX22', NULL, 'PX_SNX22', NULL, NULL, NULL, 2),
(3289, NULL, 'cd14337', NULL, NULL, 'UBA_MARK_Par1', NULL, 'UBA_MARK_Par1', NULL, NULL, NULL, 2),
(3290, NULL, 'cd18185', NULL, NULL, 'ATP-synt_Fo_c_ATPE', NULL, 'ATP-synt_Fo_c_ATPE', NULL, NULL, NULL, 2),
(3291, NULL, 'cd15324', NULL, NULL, '7tmA_alpha-2D_AR', NULL, '7tmA_alpha-2D_AR', NULL, NULL, NULL, 2),
(3292, NULL, 'cd15418', NULL, NULL, '7tmA_OR9G-like', NULL, '7tmA_OR9G-like', NULL, NULL, NULL, 2),
(3293, NULL, 'cd04100', NULL, NULL, 'Asp_Lys_Asn_RS_N', NULL, 'Asp_Lys_Asn_RS_N', NULL, NULL, NULL, 2),
(3294, NULL, 'cd05630', NULL, NULL, 'STKc_GRK6', NULL, 'STKc_GRK6', NULL, NULL, NULL, 2),
(3295, NULL, 'cd15407', NULL, NULL, '7tmA_OR5B-like', NULL, '7tmA_OR5B-like', NULL, NULL, NULL, 2),
(3296, NULL, 'cd16425', NULL, NULL, 'TrbF', NULL, 'TrbF', NULL, NULL, 27995, 2),
(3297, NULL, 'cd01013', NULL, NULL, 'isochorismatase', NULL, 'isochorismatase', NULL, NULL, NULL, 2),
(3298, NULL, 'cd14600', NULL, NULL, 'PTPc-N3', NULL, 'PTPc-N3', NULL, NULL, NULL, 2),
(3299, NULL, 'cd16404', NULL, NULL, 'pNOB8_ParB_N_like', NULL, 'pNOB8_ParB_N_like', NULL, NULL, NULL, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(3300, NULL, 'cd02129', NULL, NULL, 'PA_hSPPL_like', NULL, 'PA_hSPPL_like', NULL, NULL, NULL, 2),
(3301, NULL, 'cd09888', NULL, NULL, 'NGN_Euk', NULL, 'NGN_Euk', NULL, NULL, 27350, 2),
(3302, NULL, 'cd00984', NULL, NULL, 'DnaB_C', NULL, 'DnaB_C', NULL, NULL, 1492, 2),
(3303, NULL, 'cd17632', NULL, NULL, 'AFD_CAR-like', NULL, 'AFD_CAR-like', NULL, NULL, NULL, 2),
(3304, NULL, 'cd09677', NULL, NULL, 'Csy3_I-F', NULL, 'Csy3_I-F', NULL, NULL, NULL, 2),
(3305, NULL, 'cd12965', NULL, NULL, 'CBM-Eb_CBM-Fb', NULL, 'CBM-Eb_CBM-Fb', NULL, NULL, NULL, 2),
(3306, NULL, 'cd02257', NULL, NULL, 'Peptidase_C19', NULL, 'Peptidase_C19', NULL, NULL, NULL, 2),
(3307, NULL, 'cd09989', NULL, NULL, 'Arginase', NULL, 'Arginase', NULL, NULL, 9390, 2),
(3308, NULL, 'cd05766', NULL, NULL, 'IgC_MHC_II_beta', NULL, 'IgC_MHC_II_beta', NULL, NULL, NULL, 2),
(3309, NULL, 'cd16534', NULL, NULL, 'RING-HC_RNF5_like', NULL, 'RING-HC_RNF5_like', NULL, NULL, NULL, 2),
(3310, NULL, 'cd11277', NULL, NULL, 'Sema_plexin_B3', NULL, 'Sema_plexin_B3', NULL, NULL, NULL, 2),
(3311, NULL, 'cd15625', NULL, NULL, 'PHD_TIF1delta', NULL, 'PHD_TIF1delta', NULL, NULL, NULL, 2),
(3312, NULL, 'cd11900', NULL, NULL, 'SH3_Nck1_1', NULL, 'SH3_Nck1_1', NULL, NULL, 28474, 2),
(3313, NULL, 'cd10532', NULL, NULL, 'SET_SUV39H2', NULL, 'SET_SUV39H2', NULL, NULL, NULL, 2),
(3314, NULL, 'cd17122', NULL, NULL, 'Ubl_UHRF1', NULL, 'Ubl_UHRF1', NULL, NULL, NULL, 2),
(3315, NULL, 'cd09385', NULL, NULL, 'LIM2_LMO2', NULL, 'LIM2_LMO2', NULL, NULL, NULL, 2),
(3316, NULL, 'cd15293', NULL, NULL, '7tmC_GPR158-like', NULL, '7tmC_GPR158-like', NULL, NULL, NULL, 2),
(3317, NULL, 'cd17018', NULL, NULL, 'T3SC_IA_ExsC-like', NULL, 'T3SC_IA_ExsC-like', NULL, NULL, NULL, 2),
(3318, NULL, 'cd17876', NULL, NULL, 'SRalpha_C', NULL, 'SRalpha_C', NULL, NULL, NULL, 2),
(3319, NULL, 'cd11417', NULL, NULL, 'bHLH_TS_PTF1A', NULL, 'bHLH_TS_PTF1A', NULL, NULL, NULL, 2),
(3320, NULL, 'cd16554', NULL, NULL, 'RING-HC_RNF180', NULL, 'RING-HC_RNF180', NULL, NULL, NULL, 2),
(3321, NULL, 'cd17237', NULL, NULL, 'FERM_F1_Moesin', NULL, 'FERM_F1_Moesin', NULL, NULL, NULL, 2),
(3322, NULL, 'cd03532', NULL, NULL, 'Rieske_RO_Alpha_VanA_DdmC', NULL, 'Rieske_RO_Alpha_VanA_DdmC', NULL, NULL, NULL, 2),
(3323, NULL, 'cd11606', NULL, NULL, 'COE_DBD', NULL, 'COE_DBD', NULL, NULL, 24019, 2),
(3324, NULL, 'cd08332', NULL, NULL, 'CARD_CASP2', NULL, 'CARD_CASP2', NULL, NULL, NULL, 2),
(3325, NULL, 'cd15913', NULL, NULL, '7tmA_OR11G-like', NULL, '7tmA_OR11G-like', NULL, NULL, NULL, 2),
(3326, NULL, 'cd08741', NULL, NULL, 'RGS_RGS10', NULL, 'RGS_RGS10', NULL, NULL, 31633, 2),
(3327, NULL, 'cd00216', NULL, NULL, 'PQQ_DH_like', NULL, 'PQQ_DH_like', NULL, NULL, NULL, 2),
(3328, NULL, 'cd03731', NULL, NULL, 'SOCS_ASB15', NULL, 'SOCS_ASB15', NULL, NULL, NULL, 2),
(3329, NULL, 'cd01921', NULL, NULL, 'cyclophilin_RRM', NULL, 'cyclophilin_RRM', NULL, NULL, 32573, 2),
(3330, NULL, 'cd01409', NULL, NULL, 'SIRT4', NULL, 'SIRT4', NULL, NULL, NULL, 2),
(3331, NULL, 'cd08965', NULL, NULL, 'EcNei-like_N', NULL, 'EcNei-like_N', NULL, NULL, 34510, 2),
(3332, NULL, 'cd16376', NULL, NULL, 'Avd_like', NULL, 'Avd_like', NULL, NULL, NULL, 2),
(3333, NULL, 'cd15356', NULL, NULL, '7tmA_NTSR2', NULL, '7tmA_NTSR2', NULL, NULL, NULL, 2),
(3334, NULL, 'cd13904', NULL, NULL, 'CuRO_3_Diphenol_Ox', NULL, 'CuRO_3_Diphenol_Ox', NULL, NULL, NULL, 2),
(3335, NULL, 'cd15728', NULL, NULL, 'FYVE_ANFY1', NULL, 'FYVE_ANFY1', NULL, NULL, NULL, 2),
(3336, NULL, 'cd18524', NULL, NULL, 'BACK_BTBD3', NULL, 'BACK_BTBD3', NULL, NULL, NULL, 2),
(3337, NULL, 'cd01646', NULL, NULL, 'RT_Bac_retron_I', NULL, 'RT_Bac_retron_I', NULL, NULL, NULL, 2),
(3338, NULL, 'cd09527', NULL, NULL, 'SAM_Samd5', NULL, 'SAM_Samd5', NULL, NULL, NULL, 2),
(3339, NULL, 'cd18763', NULL, NULL, 'PIN_MtVapC3-like', NULL, 'PIN_MtVapC3-like', NULL, NULL, NULL, 2),
(3340, NULL, 'cd08591', NULL, NULL, 'PI-PLCc_beta', NULL, 'PI-PLCc_beta', NULL, NULL, NULL, 2),
(3341, NULL, 'cd12425', NULL, NULL, 'RRM4_PTBP1_like', NULL, 'RRM4_PTBP1_like', NULL, NULL, NULL, 2),
(3342, NULL, 'cd16182', NULL, NULL, 'EFh_PEF_Group_II_CAPN_like', NULL, 'EFh_PEF_Group_II_CAPN_like', NULL, NULL, NULL, 2);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(3343, NULL, 'cd08438', NULL, NULL, 'PBP2_CidR', NULL, 'PBP2_CidR', NULL, NULL, NULL, 2),
(3344, NULL, 'cd20290', NULL, NULL, 'cupin_Mj0764-like', NULL, 'cupin_Mj0764-like', NULL, NULL, NULL, 2),
(3345, NULL, 'cd07458', NULL, NULL, 'CRD_FZ1_like', NULL, 'CRD_FZ1_like', NULL, NULL, NULL, 2),
(3346, NULL, 'cd14728', NULL, NULL, 'Ere-like', NULL, 'Ere-like', NULL, NULL, 2450, 2),
(3347, NULL, 'cd19424', NULL, NULL, 'lipocalin_NPs-like', NULL, 'lipocalin_NPs-like', NULL, NULL, NULL, 2),
(3348, NULL, 'cd18234', NULL, NULL, 'BTB_POZ_KLHL1-like', NULL, 'BTB_POZ_KLHL1-like', NULL, NULL, NULL, 2),
(3349, NULL, 'cd04862', NULL, NULL, 'PaeLigD_Pol_like', NULL, 'PaeLigD_Pol_like', NULL, NULL, 30227, 2),
(3350, NULL, 'cd00124', NULL, NULL, 'MYSc', NULL, 'MYSc', NULL, NULL, NULL, 2),
(3351, NULL, 'cd05312', NULL, NULL, 'NAD_bind_1_malic_enz', NULL, 'NAD_bind_1_malic_enz', NULL, NULL, NULL, 2),
(3352, NULL, 'cd14986', NULL, NULL, '7tmA_Vasopressin-like', NULL, '7tmA_Vasopressin-like', NULL, NULL, NULL, 2),
(3353, NULL, 'cd00347', NULL, NULL, 'Flavin_utilizing_monoxygenases', NULL, 'Flavin_utilizing_monoxygenases', NULL, NULL, NULL, 2),
(3354, NULL, 'cd00423', NULL, NULL, 'Pterin_binding', NULL, 'Pterin_binding', NULL, NULL, NULL, 2),
(3355, NULL, 'cd18112', NULL, NULL, 'ATP-synt_V_A-type_beta_C', NULL, 'ATP-synt_V_A-type_beta_C', NULL, NULL, NULL, 2),
(3356, NULL, 'cd18573', NULL, NULL, 'ABC_6TM_ABCB10_like', NULL, 'ABC_6TM_ABCB10_like', NULL, NULL, NULL, 2),
(3357, NULL, 'cd01625', NULL, NULL, 'HAD_PNP', NULL, 'HAD_PNP', NULL, NULL, NULL, 2),
(3358, NULL, 'cd08172', NULL, NULL, 'GlyDH-like', NULL, 'GlyDH-like', NULL, NULL, NULL, 2),
(3359, NULL, 'cd06368', NULL, NULL, 'PBP1_iGluR_non_NMDA-like', NULL, 'PBP1_iGluR_non_NMDA-like', NULL, NULL, NULL, 2),
(3360, NULL, 'cd06398', NULL, NULL, 'PB1_Joka2', NULL, 'PB1_Joka2', NULL, NULL, NULL, 2),
(3361, NULL, 'cd00710', NULL, NULL, 'LbH_gamma_CA', NULL, 'LbH_gamma_CA', NULL, NULL, NULL, 2),
(3362, NULL, 'cd14129', NULL, NULL, 'STKc_TTBK2', NULL, 'STKc_TTBK2', NULL, NULL, NULL, 2),
(3363, NULL, 'cd00117', NULL, NULL, 'LU', NULL, 'LU', NULL, NULL, 9146, 2),
(3364, NULL, 'cd08988', NULL, NULL, 'GH43_ABN', NULL, 'GH43_ABN', NULL, NULL, NULL, 2),
(3365, NULL, 'cd03027', NULL, NULL, 'GRX_DEP', NULL, 'GRX_DEP', NULL, NULL, NULL, 2),
(3366, NULL, 'cd15513', NULL, NULL, 'PHD5_KMT2C_like', NULL, 'PHD5_KMT2C_like', NULL, NULL, NULL, 2),
(3367, NULL, 'cd11539', NULL, NULL, 'NTP-PPase_u2', NULL, 'NTP-PPase_u2', NULL, NULL, NULL, 2),
(3368, NULL, 'cd18909', NULL, NULL, 'bHLH_TCFL5', NULL, 'bHLH_TCFL5', NULL, NULL, NULL, 2),
(3369, NULL, 'cd17920', NULL, NULL, 'DEXHc_RecQ', NULL, 'DEXHc_RecQ', NULL, NULL, NULL, 2),
(3370, NULL, 'cd00306', NULL, NULL, 'Peptidases_S8_S53', NULL, 'Peptidases_S8_S53', NULL, NULL, NULL, 2),
(3371, NULL, 'cd13707', NULL, NULL, 'PBP2_BvgS_D2', NULL, 'PBP2_BvgS_D2', NULL, NULL, NULL, 2),
(3372, NULL, 'cd16287', NULL, NULL, 'CphS_ImiS-like_MBL-B2', NULL, 'CphS_ImiS-like_MBL-B2', NULL, NULL, NULL, 2),
(3373, NULL, 'cd19841', NULL, NULL, 'Bbox1_TRIM44', NULL, 'Bbox1_TRIM44', NULL, NULL, NULL, 2),
(3374, NULL, 'cd02125', NULL, NULL, 'PA_VSR', NULL, 'PA_VSR', NULL, NULL, NULL, 2),
(3375, NULL, 'cd05085', NULL, NULL, 'PTKc_Fer', NULL, 'PTKc_Fer', NULL, NULL, NULL, 2),
(3376, NULL, 'cd13279', NULL, NULL, 'PH_Cla4_Ste20', NULL, 'PH_Cla4_Ste20', NULL, NULL, NULL, 2),
(3377, NULL, 'cd20227', NULL, NULL, 'PFM_CPE-like', NULL, 'PFM_CPE-like', NULL, NULL, NULL, 2),
(3378, NULL, 'cd12344', NULL, NULL, 'RRM1_SECp43_like', NULL, 'RRM1_SECp43_like', NULL, NULL, NULL, 2),
(3379, NULL, 'cd14413', NULL, NULL, 'UBA_FAF1', NULL, 'UBA_FAF1', NULL, NULL, 35476, 2),
(3380, NULL, 'cd21524', NULL, NULL, 'DPUP_MHV_Nsp3', NULL, 'DPUP_MHV_Nsp3', NULL, NULL, 34494, 2),
(3381, NULL, 'cd16933', NULL, NULL, 'HATPase_TopVIB-like', NULL, 'HATPase_TopVIB-like', NULL, NULL, NULL, 2),
(3382, NULL, 'cd19942', NULL, NULL, 'Fer2_BFD-like', NULL, 'Fer2_BFD-like', NULL, NULL, NULL, 2),
(3383, NULL, 'cd12199', NULL, NULL, 'AMPKA1_C', NULL, 'AMPKA1_C', NULL, NULL, 28750, 2),
(3384, NULL, 'cd13410', NULL, NULL, 'TNFRSF9', NULL, 'TNFRSF9', NULL, NULL, 1956, 2);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(3385, NULL, 'cd04646', NULL, NULL, 'LbH_Dynactin_6', NULL, 'LbH_Dynactin_6', NULL, NULL, NULL, 2),
(3386, NULL, 'cd12898', NULL, NULL, 'SPRY_PRY_TRIM76', NULL, 'SPRY_PRY_TRIM76', NULL, NULL, NULL, 2),
(3387, NULL, 'cd02855', NULL, NULL, 'E_set_GBE_prok_N', NULL, 'E_set_GBE_prok_N', NULL, NULL, 35285, 2),
(3388, NULL, 'cd04037', NULL, NULL, 'C2E_Ferlin', NULL, 'C2E_Ferlin', NULL, NULL, 32505, 2),
(3389, NULL, 'cd00555', NULL, NULL, 'Maf', NULL, 'Maf', NULL, NULL, 2141, 2),
(3390, NULL, 'cd03708', NULL, NULL, 'GTPBP_III', NULL, 'GTPBP_III', NULL, NULL, NULL, 2),
(3391, NULL, 'cd05917', NULL, NULL, 'FACL_like_2', NULL, 'FACL_like_2', NULL, NULL, NULL, 2),
(3392, NULL, 'cd17793', NULL, NULL, 'HipA', NULL, 'HipA', NULL, NULL, NULL, 2),
(3393, NULL, 'cd03857', NULL, NULL, 'M14-like', NULL, 'M14-like', NULL, NULL, NULL, 2),
(3394, NULL, 'cd14642', NULL, NULL, 'DSP_DUSP6', NULL, 'DSP_DUSP6', NULL, NULL, NULL, 2),
(3395, NULL, 'cd04512', NULL, NULL, 'Ntn_Asparaginase_2_like', NULL, 'Ntn_Asparaginase_2_like', NULL, NULL, NULL, 2),
(3396, NULL, 'cd04898', NULL, NULL, 'ACT_ACR-like_4', NULL, 'ACT_ACR-like_4', NULL, NULL, NULL, 2),
(3397, NULL, 'cd18581', NULL, NULL, 'ABC_6TM_ABCB6', NULL, 'ABC_6TM_ABCB6', NULL, NULL, NULL, 2),
(3398, NULL, 'cd09734', NULL, NULL, 'Csb2_I-U', NULL, 'Csb2_I-U', NULL, NULL, NULL, 2),
(3399, NULL, 'cd16160', NULL, NULL, 'spARS_like', NULL, 'spARS_like', NULL, NULL, NULL, 2),
(3400, NULL, 'cd09103', NULL, NULL, 'PLDc_CDP-OH_P_transf_II_2', NULL, 'PLDc_CDP-OH_P_transf_II_2', NULL, NULL, NULL, 2),
(3401, NULL, 'cd01058', NULL, NULL, 'AAMH_B', NULL, 'AAMH_B', NULL, NULL, 12014, 2),
(3402, NULL, 'cd12726', NULL, NULL, 'RRM2_CPEB2_like', NULL, 'RRM2_CPEB2_like', NULL, NULL, NULL, 2),
(3403, NULL, 'cd07566', NULL, NULL, 'ScNTA1_like', NULL, 'ScNTA1_like', NULL, NULL, NULL, 2),
(3404, NULL, 'cd05054', NULL, NULL, 'PTKc_VEGFR', NULL, 'PTKc_VEGFR', NULL, NULL, NULL, 2),
(3405, NULL, 'cd14274', NULL, NULL, 'UBA_ACK1', NULL, 'UBA_ACK1', NULL, NULL, NULL, 2),
(3406, NULL, 'cd08368', NULL, NULL, 'LIM', NULL, 'LIM', NULL, NULL, NULL, 2),
(3407, NULL, 'cd13909', NULL, NULL, 'CuRO_3_MCO_like_3', NULL, 'CuRO_3_MCO_like_3', NULL, NULL, NULL, 2),
(3408, NULL, 'cd20246', NULL, NULL, 'CASIMO1', NULL, 'CASIMO1', NULL, NULL, NULL, 2),
(3409, NULL, 'cd04894', NULL, NULL, 'ACT_ACR-like_1', NULL, 'ACT_ACR-like_1', NULL, NULL, NULL, 2),
(3410, NULL, 'cd15887', NULL, NULL, 'SNARE_SNAP29N', NULL, 'SNARE_SNAP29N', NULL, NULL, NULL, 2),
(3411, NULL, 'cd02194', NULL, NULL, 'ThiL', NULL, 'ThiL', NULL, NULL, 3742, 2),
(3412, NULL, 'cd16369', NULL, NULL, 'DMSOR_beta_like', NULL, 'DMSOR_beta_like', NULL, NULL, NULL, 2),
(3413, NULL, 'cd01424', NULL, NULL, 'MGS_CPS_II', NULL, 'MGS_CPS_II', NULL, NULL, 28757, 2),
(3414, NULL, 'cd13708', NULL, NULL, 'PBP2_BvgS_like_1', NULL, 'PBP2_BvgS_like_1', NULL, NULL, NULL, 2),
(3415, NULL, 'cd11407', NULL, NULL, 'bHLH-O_HERP', NULL, 'bHLH-O_HERP', NULL, NULL, NULL, 2),
(3416, NULL, 'cd17475', NULL, NULL, 'MFS_MT3072_like', NULL, 'MFS_MT3072_like', NULL, NULL, NULL, 2),
(3417, NULL, 'cd18643', NULL, NULL, 'CBD', NULL, 'CBD', NULL, NULL, NULL, 2),
(3418, NULL, 'cd06101', NULL, NULL, 'citrate_synt', NULL, 'citrate_synt', NULL, NULL, NULL, 2),
(3419, NULL, 'cd19038', NULL, NULL, 'LGIC_ECD_GABAAR_A5', NULL, 'LGIC_ECD_GABAAR_A5', NULL, NULL, NULL, 2),
(3420, NULL, 'cd20297', NULL, NULL, 'cupin_HQDO_small', NULL, 'cupin_HQDO_small', NULL, NULL, NULL, 2),
(3421, NULL, 'cd04747', NULL, NULL, 'OYE_like_5_FMN', NULL, 'OYE_like_5_FMN', NULL, NULL, NULL, 2),
(3422, NULL, 'cd21169', NULL, NULL, 'M_dcv_Nsp15-like', NULL, 'M_dcv_Nsp15-like', NULL, NULL, 36184, 2),
(3423, NULL, 'cd12929', NULL, NULL, 'GUCT', NULL, 'GUCT', NULL, NULL, NULL, 2),
(3424, NULL, 'cd19049', NULL, NULL, 'LGIC_TM_anion', NULL, 'LGIC_TM_anion', NULL, NULL, NULL, 2),
(3425, NULL, 'cd05387', NULL, NULL, 'BY-kinase', NULL, 'BY-kinase', NULL, NULL, NULL, 2),
(3426, NULL, 'cd17953', NULL, NULL, 'DEADc_DDX46', NULL, 'DEADc_DDX46', NULL, NULL, NULL, 2),
(3427, NULL, 'cd04022', NULL, NULL, 'C2A_MCTP_PRT_plant', NULL, 'C2A_MCTP_PRT_plant', NULL, NULL, NULL, 2); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(3428, NULL, 'cd13848', NULL, NULL, 'CuRO_1_CopA', NULL, 'CuRO_1_CopA', NULL, NULL, 21040, 2),
(3429, NULL, 'cd21470', NULL, NULL, 'CoV_Spike_S1_RBD', NULL, 'CoV_Spike_S1_RBD', NULL, NULL, NULL, 2),
(3430, NULL, 'cd03001', NULL, NULL, 'PDI_a_P5', NULL, 'PDI_a_P5', NULL, NULL, NULL, 2),
(3431, NULL, 'cd13239', NULL, NULL, 'PH_Obscurin', NULL, 'PH_Obscurin', NULL, NULL, NULL, 2),
(3432, NULL, 'cd08683', NULL, NULL, 'C2_C2cd3', NULL, 'C2_C2cd3', NULL, NULL, 31539, 2),
(3433, NULL, 'cd14383', NULL, NULL, 'UBA1_UBP5', NULL, 'UBA1_UBP5', NULL, NULL, 30775, 2),
(3434, NULL, 'cd06593', NULL, NULL, 'GH31_xylosidase_YicI', NULL, 'GH31_xylosidase_YicI', NULL, NULL, NULL, 2),
(3435, NULL, 'cd12390', NULL, NULL, 'RRM3_RAVER', NULL, 'RRM3_RAVER', NULL, NULL, NULL, 2),
(3436, NULL, 'cd14214', NULL, NULL, 'PKc_CLK3', NULL, 'PKc_CLK3', NULL, NULL, NULL, 2),
(3437, NULL, 'cd07173', NULL, NULL, 'NR_DBD_AR', NULL, 'NR_DBD_AR', NULL, NULL, NULL, 2),
(3438, NULL, 'cd18933', NULL, NULL, 'bHLH-O_HES3', NULL, 'bHLH-O_HES3', NULL, NULL, NULL, 2),
(3439, NULL, 'cd18569', NULL, NULL, 'ABC_6TM_NHLM_bacteriocin', NULL, 'ABC_6TM_NHLM_bacteriocin', NULL, NULL, NULL, 2),
(3440, NULL, 'cd05749', NULL, NULL, 'Ig2_Axl_Tyro3_like', NULL, 'Ig2_Axl_Tyro3_like', NULL, NULL, NULL, 2),
(3441, NULL, 'cd15687', NULL, NULL, 'PHD3_KDM5B', NULL, 'PHD3_KDM5B', NULL, NULL, NULL, 2),
(3442, NULL, 'cd05124', NULL, NULL, 'AFK', NULL, 'AFK', NULL, NULL, 12358, 2),
(3443, NULL, 'cd14495', NULL, NULL, 'PTPLP-like', NULL, 'PTPLP-like', NULL, NULL, NULL, 2),
(3444, NULL, 'cd01204', NULL, NULL, 'PTB_IRS', NULL, 'PTB_IRS', NULL, NULL, 6975, 2),
(3445, NULL, 'cd12088', NULL, NULL, 'helicase_insert_domain', NULL, 'helicase_insert_domain', NULL, NULL, NULL, 2),
(3446, NULL, 'cd10495', NULL, NULL, 'MH2_R-SMAD', NULL, 'MH2_R-SMAD', NULL, NULL, NULL, 2),
(3447, NULL, 'cd07514', NULL, NULL, 'HAD_Pase', NULL, 'HAD_Pase', NULL, NULL, NULL, 2),
(3448, NULL, 'cd15434', NULL, NULL, '7tmA_OR2W-like', NULL, '7tmA_OR2W-like', NULL, NULL, NULL, 2),
(3449, NULL, 'cd18240', NULL, NULL, 'BTB_POZ_KLHL10', NULL, 'BTB_POZ_KLHL10', NULL, NULL, 25459, 2),
(3450, NULL, 'cd08323', NULL, NULL, 'CARD_APAF1', NULL, 'CARD_APAF1', NULL, NULL, 32268, 2),
(3451, NULL, 'cd19097', NULL, NULL, 'AKR_unchar', NULL, 'AKR_unchar', NULL, NULL, NULL, 2),
(3452, NULL, 'cd13297', NULL, NULL, 'PH3_MyoX-like', NULL, 'PH3_MyoX-like', NULL, NULL, NULL, 2),
(3453, NULL, 'cd09564', NULL, NULL, 'SAM_kazrin_repeat1', NULL, 'SAM_kazrin_repeat1', NULL, NULL, 30821, 2),
(3454, NULL, 'cd17376', NULL, NULL, 'MFS_SLC22A4_5_OCTN1_2', NULL, 'MFS_SLC22A4_5_OCTN1_2', NULL, NULL, 37600, 2),
(3455, NULL, 'cd06438', NULL, NULL, 'EpsO_like', NULL, 'EpsO_like', NULL, NULL, NULL, 2),
(3456, NULL, 'cd09567', NULL, NULL, 'SAM_kazrin_repeat2', NULL, 'SAM_kazrin_repeat2', NULL, NULL, 30786, 2),
(3457, NULL, 'cd09907', NULL, NULL, 'H3TH_FEN1-Euk', NULL, 'H3TH_FEN1-Euk', NULL, NULL, NULL, 2),
(3458, NULL, 'cd10943', NULL, NULL, 'CE4_NodB', NULL, 'CE4_NodB', NULL, NULL, NULL, 2),
(3459, NULL, 'cd04370', NULL, NULL, 'BAH', NULL, 'BAH', NULL, NULL, NULL, 2),
(3460, NULL, 'cd18807', NULL, NULL, 'SF1_C_UvrD', NULL, 'SF1_C_UvrD', NULL, NULL, NULL, 2),
(3461, NULL, 'cd12037', NULL, NULL, 'SH3_MPP2', NULL, 'SH3_MPP2', NULL, NULL, 28455, 2),
(3462, NULL, 'cd11907', NULL, NULL, 'SH3_TXK', NULL, 'SH3_TXK', NULL, NULL, 29385, 2),
(3463, NULL, 'cd13620', NULL, NULL, 'PBP2_GltS', NULL, 'PBP2_GltS', NULL, NULL, NULL, 2),
(3464, NULL, 'cd15994', NULL, NULL, '7tmB2_GPR111_115', NULL, '7tmB2_GPR111_115', NULL, NULL, NULL, 2),
(3465, NULL, 'cd04518', NULL, NULL, 'TBP_archaea', NULL, 'TBP_archaea', NULL, NULL, 32463, 2),
(3466, NULL, 'cd04088', NULL, NULL, 'EFG_mtEFG_II', NULL, 'EFG_mtEFG_II', NULL, NULL, NULL, 2),
(3467, NULL, 'cd16905', NULL, NULL, 'YEATS_Taf14_like', NULL, 'YEATS_Taf14_like', NULL, NULL, NULL, 2),
(3468, NULL, 'cd10159', NULL, NULL, 'CsoR-like_DUF156_2', NULL, 'CsoR-like_DUF156_2', NULL, NULL, NULL, 2),
(3469, NULL, 'cd02115', NULL, NULL, 'AAK', NULL, 'AAK', NULL, NULL, NULL, 2),
(3470, NULL, 'cd01037', NULL, NULL, 'Restriction_endonuclease_like', NULL, 'Restriction_endonuclease_like', NULL, NULL, NULL, 2);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(3471, NULL, 'cd20756', NULL, NULL, 'capping_2-OMTase_Poxviridae', NULL, 'capping_2-OMTase_Poxviridae', NULL, NULL, 23819, 2),
(3472, NULL, 'cd11610', NULL, NULL, 'eIF2D_N', NULL, 'eIF2D_N', NULL, NULL, NULL, 2),
(3473, NULL, 'cd07712', NULL, NULL, 'MBLAC2-like_MBL-fold', NULL, 'MBLAC2-like_MBL-fold', NULL, NULL, NULL, 2),
(3474, NULL, 'cd14257', NULL, NULL, 'CttA_X', NULL, 'CttA_X', NULL, NULL, 29489, 2),
(3475, NULL, 'cd04186', NULL, NULL, 'GT_2_like_c', NULL, 'GT_2_like_c', NULL, NULL, NULL, 2),
(3476, NULL, 'cd12670', NULL, NULL, 'RRM2_Nop12p_like', NULL, 'RRM2_Nop12p_like', NULL, NULL, NULL, 2),
(3477, NULL, 'cd12535', NULL, NULL, 'RRM_FUS_TAF15', NULL, 'RRM_FUS_TAF15', NULL, NULL, NULL, 2),
(3478, NULL, 'cd03707', NULL, NULL, 'EFTU_III', NULL, 'EFTU_III', NULL, NULL, NULL, 2),
(3479, NULL, 'cd07113', NULL, NULL, 'ALDH_PADH_NahF', NULL, 'ALDH_PADH_NahF', NULL, NULL, NULL, 2),
(3480, NULL, 'cd12924', NULL, NULL, 'iSH2_PIK3R1', NULL, 'iSH2_PIK3R1', NULL, NULL, 33566, 2),
(3481, NULL, 'cd06636', NULL, NULL, 'STKc_MAP4K4_6_N', NULL, 'STKc_MAP4K4_6_N', NULL, NULL, NULL, 2),
(3482, NULL, 'cd04931', NULL, NULL, 'ACT_PAH', NULL, 'ACT_PAH', NULL, NULL, NULL, 2),
(3483, NULL, 'cd12030', NULL, NULL, 'SH3_DLG4', NULL, 'SH3_DLG4', NULL, NULL, NULL, 2),
(3484, NULL, 'cd13154', NULL, NULL, 'KOW_Mtr4', NULL, 'KOW_Mtr4', NULL, NULL, NULL, 2),
(3485, NULL, 'cd15603', NULL, NULL, 'PHD1_KDM5B', NULL, 'PHD1_KDM5B', NULL, NULL, NULL, 2),
(3486, NULL, 'cd10951', NULL, NULL, 'CE4_ClCDA_like', NULL, 'CE4_ClCDA_like', NULL, NULL, NULL, 2),
(3487, NULL, 'cd15083', NULL, NULL, '7tmA_Melanopsin-like', NULL, '7tmA_Melanopsin-like', NULL, NULL, NULL, 2),
(3488, NULL, 'cd18049', NULL, NULL, 'DEADc_DDX5', NULL, 'DEADc_DDX5', NULL, NULL, NULL, 2),
(3489, NULL, 'cd02609', NULL, NULL, 'P-type_ATPase', NULL, 'P-type_ATPase', NULL, NULL, NULL, 2),
(3490, NULL, 'cd07552', NULL, NULL, 'P-type_ATPase_Cu-like', NULL, 'P-type_ATPase_Cu-like', NULL, NULL, NULL, 2),
(3491, NULL, 'cd10163', NULL, NULL, 'ClassIIa_HDAC9_Gln-rich-N', NULL, 'ClassIIa_HDAC9_Gln-rich-N', NULL, NULL, NULL, 2),
(3492, NULL, 'cd19994', NULL, NULL, 'PBP1_ChvE', NULL, 'PBP1_ChvE', NULL, NULL, NULL, 2),
(3493, NULL, 'cd08464', NULL, NULL, 'PBP2_DntR_like_2', NULL, 'PBP2_DntR_like_2', NULL, NULL, NULL, 2),
(3494, NULL, 'cd16791', NULL, NULL, 'SP-RING_ZMIZ', NULL, 'SP-RING_ZMIZ', NULL, NULL, NULL, 2),
(3495, NULL, 'cd02128', NULL, NULL, 'PA_TfR', NULL, 'PA_TfR', NULL, NULL, 33479, 2),
(3496, NULL, 'cd06977', NULL, NULL, 'cupin_RhaR_RhaS-like_N', NULL, 'cupin_RhaR_RhaS-like_N', NULL, NULL, NULL, 2),
(3497, NULL, 'cd03308', NULL, NULL, 'CmuA_CmuC_like', NULL, 'CmuA_CmuC_like', NULL, NULL, NULL, 2),
(3498, NULL, 'cd16759', NULL, NULL, 'RING-HC_MuRF1', NULL, 'RING-HC_MuRF1', NULL, NULL, 35437, 2),
(3499, NULL, 'cd16891', NULL, NULL, 'CwlT-like', NULL, 'CwlT-like', NULL, NULL, NULL, 2),
(3500, NULL, 'cd18565', NULL, NULL, 'ABC_6TM_exporter_like', NULL, 'ABC_6TM_exporter_like', NULL, NULL, NULL, 2),
(3501, NULL, 'cd17033', NULL, NULL, 'DR1245-like', NULL, 'DR1245-like', NULL, NULL, NULL, 2),
(3502, NULL, 'cd17940', NULL, NULL, 'DEADc_DDX6', NULL, 'DEADc_DDX6', NULL, NULL, NULL, 2),
(3503, NULL, 'cd00307', NULL, NULL, 'RuBisCO_small_like', NULL, 'RuBisCO_small_like', NULL, NULL, NULL, 2),
(3504, NULL, 'cd14435', NULL, NULL, 'SPO1_TF1_like', NULL, 'SPO1_TF1_like', NULL, NULL, NULL, 2),
(3505, NULL, 'cd12490', NULL, NULL, 'RRM2_ACF', NULL, 'RRM2_ACF', NULL, NULL, NULL, 2),
(3506, NULL, 'cd05909', NULL, NULL, 'AAS_C', NULL, 'AAS_C', NULL, NULL, NULL, 2),
(3507, NULL, 'cd02011', NULL, NULL, 'TPP_PK', NULL, 'TPP_PK', NULL, NULL, NULL, 2),
(3508, NULL, 'cd03757', NULL, NULL, 'proteasome_beta_type_1', NULL, 'proteasome_beta_type_1', NULL, NULL, NULL, 2),
(3509, NULL, 'cd05834', NULL, NULL, 'HDGF_related', NULL, 'HDGF_related', NULL, NULL, 28645, 2),
(3510, NULL, 'cd13224', NULL, NULL, 'PH_Net1', NULL, 'PH_Net1', NULL, NULL, 32498, 2),
(3511, NULL, 'cd15831', NULL, NULL, 'BTAD', NULL, 'BTAD', NULL, NULL, 4334, 2),
(3512, NULL, 'cd11484', NULL, NULL, 'SLC-NCS1sbd_CobB-like', NULL, 'SLC-NCS1sbd_CobB-like', NULL, NULL, NULL, 2);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(3513, NULL, 'cd18931', NULL, NULL, 'bHLHzip_Mad1', NULL, 'bHLHzip_Mad1', NULL, NULL, NULL, 2),
(3514, NULL, 'cd00685', NULL, NULL, 'Trans_IPPS_HT', NULL, 'Trans_IPPS_HT', NULL, NULL, 2916, 2),
(3515, NULL, 'cd09894', NULL, NULL, 'NGN_SP_AnfA1', NULL, 'NGN_SP_AnfA1', NULL, NULL, NULL, 2),
(3516, NULL, 'cd07401', NULL, NULL, 'MPP_TMEM62_N', NULL, 'MPP_TMEM62_N', NULL, NULL, 30872, 2),
(3517, NULL, 'cd03199', NULL, NULL, 'GST_C_GRX2', NULL, 'GST_C_GRX2', NULL, NULL, 10332, 2),
(3518, NULL, 'cd12109', NULL, NULL, 'Hr_FBXL5', NULL, 'Hr_FBXL5', NULL, NULL, 34384, 2),
(3519, NULL, 'cd04740', NULL, NULL, 'DHOD_1B_like', NULL, 'DHOD_1B_like', NULL, NULL, 27836, 2),
(3520, NULL, 'cd05033', NULL, NULL, 'PTKc_EphR', NULL, 'PTKc_EphR', NULL, NULL, NULL, 2),
(3521, NULL, 'cd09866', NULL, NULL, 'PIN_Fcf1-Utp23-H', NULL, 'PIN_Fcf1-Utp23-H', NULL, NULL, NULL, 2),
(3522, NULL, 'cd19359', NULL, NULL, 'TenA_C_Bt3146-like', NULL, 'TenA_C_Bt3146-like', NULL, NULL, NULL, 2),
(3523, NULL, 'cd02621', NULL, NULL, 'Peptidase_C1A_CathepsinC', NULL, 'Peptidase_C1A_CathepsinC', NULL, NULL, 33473, 2),
(3524, NULL, 'cd15935', NULL, NULL, '7tmA_OR4Q3-like', NULL, '7tmA_OR4Q3-like', NULL, NULL, NULL, 2),
(3525, NULL, 'cd12579', NULL, NULL, 'RRM2_hnRNPA0', NULL, 'RRM2_hnRNPA0', NULL, NULL, NULL, 2),
(3526, NULL, 'cd08784', NULL, NULL, 'Death_DRs', NULL, 'Death_DRs', NULL, NULL, NULL, 2),
(3527, NULL, 'cd10473', NULL, NULL, 'EphR_LBD_A', NULL, 'EphR_LBD_A', NULL, NULL, NULL, 2),
(3528, NULL, 'cd04792', NULL, NULL, 'LanM-like', NULL, 'LanM-like', NULL, NULL, 20589, 2),
(3529, NULL, 'cd19391', NULL, NULL, 'TGF_beta_BMP4_BMP2B', NULL, 'TGF_beta_BMP4_BMP2B', NULL, NULL, NULL, 2),
(3530, NULL, 'cd17775', NULL, NULL, 'CBS_pair_bact_arch', NULL, 'CBS_pair_bact_arch', NULL, NULL, NULL, 2),
(3531, NULL, 'cd13368', NULL, NULL, 'PH_BCR_arthropod', NULL, 'PH_BCR_arthropod', NULL, NULL, NULL, 2),
(3532, NULL, 'cd08742', NULL, NULL, 'RGS_RGS12', NULL, 'RGS_RGS12', NULL, NULL, 31588, 2),
(3533, NULL, 'cd10366', NULL, NULL, 'SH2_Src_Yes', NULL, 'SH2_Src_Yes', NULL, NULL, NULL, 2),
(3534, NULL, 'cd18386', NULL, NULL, 'BTB_POZ_KCTD20', NULL, 'BTB_POZ_KCTD20', NULL, NULL, NULL, 2),
(3535, NULL, 'cd12456', NULL, NULL, 'RRM_p65', NULL, 'RRM_p65', NULL, NULL, NULL, 2),
(3536, NULL, 'cd00855', NULL, NULL, 'SWIB-MDM2', NULL, 'SWIB-MDM2', NULL, NULL, NULL, 2),
(3537, NULL, 'cd01263', NULL, NULL, 'PH_anillin', NULL, 'PH_anillin', NULL, NULL, 33381, 2),
(3538, NULL, 'cd07213', NULL, NULL, 'Pat17_PNPLA8_PNPLA9_like1', NULL, 'Pat17_PNPLA8_PNPLA9_like1', NULL, NULL, NULL, 2),
(3539, NULL, 'cd09248', NULL, NULL, 'BRO1_Rhophilin_1', NULL, 'BRO1_Rhophilin_1', NULL, NULL, 36178, 2),
(3540, NULL, 'cd02019', NULL, NULL, 'NK', NULL, 'NK', NULL, NULL, NULL, 2),
(3541, NULL, 'cd01370', NULL, NULL, 'KISc_KIP3_like', NULL, 'KISc_KIP3_like', NULL, NULL, NULL, 2),
(3542, NULL, 'cd10028', NULL, NULL, 'UDG-F2_TDG_MUG', NULL, 'UDG-F2_TDG_MUG', NULL, NULL, 17999, 2),
(3543, NULL, 'cd15818', NULL, NULL, 'SPRY_PRY_TRIM69', NULL, 'SPRY_PRY_TRIM69', NULL, NULL, NULL, 2),
(3544, NULL, 'cd15748', NULL, NULL, 'FYVE_SPIR', NULL, 'FYVE_SPIR', NULL, NULL, NULL, 2),
(3545, NULL, 'cd08761', NULL, NULL, 'Cyt_b561_CYB561D2_like', NULL, 'Cyt_b561_CYB561D2_like', NULL, NULL, NULL, 2),
(3546, NULL, 'cd13611', NULL, NULL, 'PBP2_YehZ', NULL, 'PBP2_YehZ', NULL, NULL, NULL, 2),
(3547, NULL, 'cd02338', NULL, NULL, 'ZZ_PCMF_like', NULL, 'ZZ_PCMF_like', NULL, NULL, NULL, 2),
(3548, NULL, 'cd00179', NULL, NULL, 'SynN', NULL, 'SynN', NULL, NULL, 1071, 2),
(3549, NULL, 'cd10792', NULL, NULL, 'GH57N_AmyC_like', NULL, 'GH57N_AmyC_like', NULL, NULL, NULL, 2),
(3550, NULL, 'cd17391', NULL, NULL, 'MFS_MdtG_MDR_like', NULL, 'MFS_MdtG_MDR_like', NULL, NULL, NULL, 2),
(3551, NULL, 'cd14810', NULL, NULL, 'bZIP_u1', NULL, 'bZIP_u1', NULL, NULL, NULL, 2),
(3552, NULL, 'cd03680', NULL, NULL, 'MM_CoA_mutase_ICM_like', NULL, 'MM_CoA_mutase_ICM_like', NULL, NULL, NULL, 2),
(3553, NULL, 'cd07696', NULL, NULL, 'IgC_CH3_IgAEM_CH2_IgG', NULL, 'IgC_CH3_IgAEM_CH2_IgG', NULL, NULL, NULL, 2),
(3554, NULL, 'cd02081', NULL, NULL, 'P-type_ATPase_Ca_PMCA-like', NULL, 'P-type_ATPase_Ca_PMCA-like', NULL, NULL, NULL, 2);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(3555, NULL, 'cd20207', NULL, NULL, 'Bbox2_GefO-like', NULL, 'Bbox2_GefO-like', NULL, NULL, NULL, 2),
(3556, NULL, 'cd16612', NULL, NULL, 'RING-HC_TRIM72_C-IV', NULL, 'RING-HC_TRIM72_C-IV', NULL, NULL, NULL, 2),
(3557, NULL, 'cd02164', NULL, NULL, 'PPAT_CoAS', NULL, 'PPAT_CoAS', NULL, NULL, NULL, 2),
(3558, NULL, 'cd00191', NULL, NULL, 'TY', NULL, 'TY', NULL, NULL, 6911, 2),
(3559, NULL, 'cd00643', NULL, NULL, 'HMG-CoA_reductase_classI', NULL, 'HMG-CoA_reductase_classI', NULL, NULL, 699, 2),
(3560, NULL, 'cd05748', NULL, NULL, 'Ig_Titin_like', NULL, 'Ig_Titin_like', NULL, NULL, NULL, 2),
(3561, NULL, 'cd01282', NULL, NULL, 'HTH_MerR-like_sg3', NULL, 'HTH_MerR-like_sg3', NULL, NULL, NULL, 2),
(3562, NULL, 'cd09135', NULL, NULL, 'PLDc_PGS1_euk_1', NULL, 'PLDc_PGS1_euk_1', NULL, NULL, NULL, 2),
(3563, NULL, 'cd16985', NULL, NULL, 'ANTH_N_AP180', NULL, 'ANTH_N_AP180', NULL, NULL, NULL, 2),
(3564, NULL, 'cd18116', NULL, NULL, 'ATP-synt_F1_alpha_N', NULL, 'ATP-synt_F1_alpha_N', NULL, NULL, NULL, 2),
(3565, NULL, 'cd15646', NULL, NULL, 'PHD_p300', NULL, 'PHD_p300', NULL, NULL, NULL, 2),
(3566, NULL, 'cd14694', NULL, NULL, 'bZIP_NFIL3', NULL, 'bZIP_NFIL3', NULL, NULL, NULL, 2),
(3567, NULL, 'cd16082', NULL, NULL, 'IgC_CRIg', NULL, 'IgC_CRIg', NULL, NULL, NULL, 2),
(3568, NULL, 'cd04123', NULL, NULL, 'Rab21', NULL, 'Rab21', NULL, NULL, 30557, 2),
(3569, NULL, 'cd15232', NULL, NULL, '7tmA_OR13-like', NULL, '7tmA_OR13-like', NULL, NULL, NULL, 2),
(3570, NULL, 'cd21532', NULL, NULL, 'HKU1-CoV-like_E', NULL, 'HKU1-CoV-like_E', NULL, NULL, 34187, 2),
(3571, NULL, 'cd01141', NULL, NULL, 'TroA_d', NULL, 'TroA_d', NULL, NULL, NULL, 2),
(3572, NULL, 'cd07739', NULL, NULL, 'metallo-hydrolase-like_MBL-fold', NULL, 'metallo-hydrolase-like_MBL-fold', NULL, NULL, NULL, 2),
(3573, NULL, 'cd03440', NULL, NULL, 'hot_dog', NULL, 'hot_dog', NULL, NULL, NULL, 2),
(3574, NULL, 'cd14100', NULL, NULL, 'STKc_PIM1', NULL, 'STKc_PIM1', NULL, NULL, NULL, 2),
(3575, NULL, 'cd13240', NULL, NULL, 'PH1_Kalirin_Trio_like', NULL, 'PH1_Kalirin_Trio_like', NULL, NULL, NULL, 2),
(3576, NULL, 'cd02825', NULL, NULL, 'PAZ', NULL, 'PAZ', NULL, NULL, NULL, 2),
(3577, NULL, 'cd16931', NULL, NULL, 'HATPase_MORC-like', NULL, 'HATPase_MORC-like', NULL, NULL, NULL, 2),
(3578, NULL, 'cd07629', NULL, NULL, 'BAR_Atg20p', NULL, 'BAR_Atg20p', NULL, NULL, NULL, 2),
(3579, NULL, 'cd00350', NULL, NULL, 'rubredoxin_like', NULL, 'rubredoxin_like', NULL, NULL, NULL, 2),
(3580, NULL, 'cd14971', NULL, NULL, '7tmA_Galanin_R-like', NULL, '7tmA_Galanin_R-like', NULL, NULL, NULL, 2),
(3581, NULL, 'cd19587', NULL, NULL, 'serpinA16_HongrES1-like', NULL, 'serpinA16_HongrES1-like', NULL, NULL, NULL, 2),
(3582, NULL, 'cd07521', NULL, NULL, 'HAD_FCP1-like', NULL, 'HAD_FCP1-like', NULL, NULL, NULL, 2),
(3583, NULL, 'cd14984', NULL, NULL, '7tmA_Chemokine_R', NULL, '7tmA_Chemokine_R', NULL, NULL, NULL, 2),
(3584, NULL, 'cd00106', NULL, NULL, 'KISc', NULL, 'KISc', NULL, NULL, NULL, 2),
(3585, NULL, 'cd19447', NULL, NULL, 'L-BABP-like', NULL, 'L-BABP-like', NULL, NULL, NULL, 2),
(3586, NULL, 'cd03883', NULL, NULL, 'M28_Pgcp_like', NULL, 'M28_Pgcp_like', NULL, NULL, NULL, 2),
(3587, NULL, 'cd07686', NULL, NULL, 'F-BAR_Fer', NULL, 'F-BAR_Fer', NULL, NULL, 28701, 2),
(3588, NULL, 'cd16517', NULL, NULL, 'RING-HC_MAT1', NULL, 'RING-HC_MAT1', NULL, NULL, NULL, 2),
(3589, NULL, 'cd00004', NULL, NULL, 'Sortase', NULL, 'Sortase', NULL, NULL, NULL, 2),
(3590, NULL, 'cd05484', NULL, NULL, 'retropepsin_like_LTR_2', NULL, 'retropepsin_like_LTR_2', NULL, NULL, 26930, 2),
(3591, NULL, 'cd13547', NULL, NULL, 'PBP2_Fbp_like_2', NULL, 'PBP2_Fbp_like_2', NULL, NULL, NULL, 2),
(3592, NULL, 'cd16489', NULL, NULL, 'mRING-CH-C4HC2H_ZNRF', NULL, 'mRING-CH-C4HC2H_ZNRF', NULL, NULL, NULL, 2),
(3593, NULL, 'cd07526', NULL, NULL, 'HAD_BPGM_like', NULL, 'HAD_BPGM_like', NULL, NULL, NULL, 2),
(3594, NULL, 'cd13577', NULL, NULL, 'PBP2_BugE_Glu', NULL, 'PBP2_BugE_Glu', NULL, NULL, NULL, 2),
(3595, NULL, 'cd18117', NULL, NULL, 'ATP-synt_flagellum-secretory_path_III_N', NULL, 'ATP-synt_flagellum-secretory_path_III_N', NULL, NULL, NULL, 2);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(3596, NULL, 'cd14150', NULL, NULL, 'STKc_A-Raf', NULL, 'STKc_A-Raf', NULL, NULL, NULL, 2),
(3597, NULL, 'cd15070', NULL, NULL, '7tmA_Adenosine_R_A3', NULL, '7tmA_Adenosine_R_A3', NULL, NULL, NULL, 2),
(3598, NULL, 'cd02171', NULL, NULL, 'G3P_Cytidylyltransferase', NULL, 'G3P_Cytidylyltransferase', NULL, NULL, NULL, 2),
(3599, NULL, 'cd08935', NULL, NULL, 'mannonate_red_SDR_c', NULL, 'mannonate_red_SDR_c', NULL, NULL, NULL, 2),
(3600, NULL, 'cd05721', NULL, NULL, 'IgV_CTLA-4', NULL, 'IgV_CTLA-4', NULL, NULL, NULL, 2),
(3601, NULL, 'cd06810', NULL, NULL, 'PLPDE_III_ODC_DapDC_like', NULL, 'PLPDE_III_ODC_DapDC_like', NULL, NULL, NULL, 2),
(3602, NULL, 'cd01760', NULL, NULL, 'RBD', NULL, 'RBD', NULL, NULL, NULL, 2),
(3603, NULL, 'cd00205', NULL, NULL, 'rhv_like', NULL, 'rhv_like', NULL, NULL, 30937, 2),
(3604, NULL, 'cd09599', NULL, NULL, 'M1_LTA4H', NULL, 'M1_LTA4H', NULL, NULL, 23808, 2),
(3605, NULL, 'cd13544', NULL, NULL, 'PBP2_Fbp_like_1', NULL, 'PBP2_Fbp_like_1', NULL, NULL, NULL, 2),
(3606, NULL, 'cd05481', NULL, NULL, 'retropepsin_like_LTR_1', NULL, 'retropepsin_like_LTR_1', NULL, NULL, NULL, 2),
(3607, NULL, 'cd11787', NULL, NULL, 'SH3_SH3RF_2', NULL, 'SH3_SH3RF_2', NULL, NULL, NULL, 2),
(3608, NULL, 'cd01847', NULL, NULL, 'Triacylglycerol_lipase_like', NULL, 'Triacylglycerol_lipase_like', NULL, NULL, NULL, 2),
(3609, NULL, 'cd11593', NULL, NULL, 'Agmatinase-like_2', NULL, 'Agmatinase-like_2', NULL, NULL, NULL, 2),
(3610, NULL, 'cd02111', NULL, NULL, 'eukary_SO_Moco', NULL, 'eukary_SO_Moco', NULL, NULL, NULL, 2),
(3611, NULL, 'cd14641', NULL, NULL, 'DSP_DUSP2', NULL, 'DSP_DUSP2', NULL, NULL, NULL, 2),
(3612, NULL, 'cd19789', NULL, NULL, 'Bbox2_TRIM56_C-V', NULL, 'Bbox2_TRIM56_C-V', NULL, NULL, NULL, 2),
(3613, NULL, 'cd08334', NULL, NULL, 'DED_Caspase_8_10_r2', NULL, 'DED_Caspase_8_10_r2', NULL, NULL, NULL, 2),
(3614, NULL, 'cd00516', NULL, NULL, 'PRTase_typeII', NULL, 'PRTase_typeII', NULL, NULL, NULL, 2),
(3615, NULL, 'cd01270', NULL, NULL, 'PTB_CAPON-like', NULL, 'PTB_CAPON-like', NULL, NULL, NULL, 2),
(3616, NULL, 'cd01871', NULL, NULL, 'Rac1_like', NULL, 'Rac1_like', NULL, NULL, NULL, 2),
(3617, NULL, 'cd17923', NULL, NULL, 'DEXHc_Hrq1-like', NULL, 'DEXHc_Hrq1-like', NULL, NULL, NULL, 2),
(3618, NULL, 'cd06954', NULL, NULL, 'NR_LBD_LXR', NULL, 'NR_LBD_LXR', NULL, NULL, NULL, 2),
(3619, NULL, 'cd08216', NULL, NULL, 'PK_STRAD', NULL, 'PK_STRAD', NULL, NULL, NULL, 2),
(3620, NULL, 'cd02846', NULL, NULL, 'PAZ_argonaute_like', NULL, 'PAZ_argonaute_like', NULL, NULL, NULL, 2),
(3621, NULL, 'cd16811', NULL, NULL, 'RING_CH-C4HC3_MARCH4_9', NULL, 'RING_CH-C4HC3_MARCH4_9', NULL, NULL, NULL, 2),
(3622, NULL, 'cd07582', NULL, NULL, 'nitrilase_4', NULL, 'nitrilase_4', NULL, NULL, NULL, 2),
(3623, NULL, 'cd11782', NULL, NULL, 'SH3_Sorbs_2', NULL, 'SH3_Sorbs_2', NULL, NULL, NULL, 2),
(3624, NULL, 'cd01164', NULL, NULL, 'FruK_PfkB_like', NULL, 'FruK_PfkB_like', NULL, NULL, 15890, 2),
(3625, NULL, 'cd12809', NULL, NULL, 'Esterase_713_like-2', NULL, 'Esterase_713_like-2', NULL, NULL, NULL, 2),
(3626, NULL, 'cd06405', NULL, NULL, 'PB1_Mekk2_3', NULL, 'PB1_Mekk2_3', NULL, NULL, 16877, 2),
(3627, NULL, 'cd09736', NULL, NULL, 'Csy2_I-F', NULL, 'Csy2_I-F', NULL, NULL, NULL, 2),
(3628, NULL, 'cd09021', NULL, NULL, 'Aldose_epim_Ec_YphB', NULL, 'Aldose_epim_Ec_YphB', NULL, NULL, NULL, 2),
(3629, NULL, 'cd14895', NULL, NULL, 'MYSc_Myo34', NULL, 'MYSc_Myo34', NULL, NULL, NULL, 2),
(3630, NULL, 'cd12033', NULL, NULL, 'SH3_MPP7', NULL, 'SH3_MPP7', NULL, NULL, 33534, 2),
(3631, NULL, 'cd01130', NULL, NULL, 'VirB11-like_ATPase', NULL, 'VirB11-like_ATPase', NULL, NULL, NULL, 2),
(3632, NULL, 'cd10230', NULL, NULL, 'HYOU1-like_NBD', NULL, 'HYOU1-like_NBD', NULL, NULL, NULL, 2),
(3633, NULL, 'cd01581', NULL, NULL, 'AcnB', NULL, 'AcnB', NULL, NULL, NULL, 2),
(3634, NULL, 'cd09562', NULL, NULL, 'SAM_liprin-alpha1,2,3,4_repeat1', NULL, 'SAM_liprin-alpha1,2,3,4_repeat1', NULL, NULL, 32250, 2),
(3635, NULL, 'cd15924', NULL, NULL, '7tmA_P2Y12-like', NULL, '7tmA_P2Y12-like', NULL, NULL, NULL, 2),
(3636, NULL, 'cd13419', NULL, NULL, 'TNFRSF19L', NULL, 'TNFRSF19L', NULL, NULL, 9351, 2);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(3637, NULL, 'cd01743', NULL, NULL, 'GATase1_Anthranilate_Synthase', NULL, 'GATase1_Anthranilate_Synthase', NULL, NULL, 11310, 2),
(3638, NULL, 'cd01873', NULL, NULL, 'RhoBTB', NULL, 'RhoBTB', NULL, NULL, NULL, 2),
(3639, NULL, 'cd11240', NULL, NULL, 'Sema_4', NULL, 'Sema_4', NULL, NULL, NULL, 2),
(3640, NULL, 'cd12438', NULL, NULL, 'RRM_CNOT4', NULL, 'RRM_CNOT4', NULL, NULL, 6222, 2),
(3641, NULL, 'cd15532', NULL, NULL, 'PHD2_CHD_II', NULL, 'PHD2_CHD_II', NULL, NULL, NULL, 2),
(3642, NULL, 'cd17915', NULL, NULL, 'DEAHc_XPD-like', NULL, 'DEAHc_XPD-like', NULL, NULL, NULL, 2),
(3643, NULL, 'cd18274', NULL, NULL, 'BTB_POZ_KBTBD8', NULL, 'BTB_POZ_KBTBD8', NULL, NULL, NULL, 2),
(3644, NULL, 'cd12773', NULL, NULL, 'RRM2_HuR', NULL, 'RRM2_HuR', NULL, NULL, 14973, 2),
(3645, NULL, 'cd18458', NULL, NULL, 'BACK_KLHL19_KEAP1', NULL, 'BACK_KLHL19_KEAP1', NULL, NULL, NULL, 2),
(3646, NULL, 'cd05325', NULL, NULL, 'carb_red_sniffer_like_SDR_c', NULL, 'carb_red_sniffer_like_SDR_c', NULL, NULL, NULL, 2),
(3647, NULL, 'cd16911', NULL, NULL, 'AfaD_SafA-like', NULL, 'AfaD_SafA-like', NULL, NULL, NULL, 2),
(3648, NULL, 'cd17990', NULL, NULL, 'DEXHc_HrpB', NULL, 'DEXHc_HrpB', NULL, NULL, NULL, 2),
(3649, NULL, 'cd01033', NULL, NULL, 'ClC_like', NULL, 'ClC_like', NULL, NULL, NULL, 2),
(3650, NULL, 'cd11466', NULL, NULL, 'bHLH_TS_HAND', NULL, 'bHLH_TS_HAND', NULL, NULL, NULL, 2),
(3651, NULL, 'cd09946', NULL, NULL, 'SH2_HSH2_like', NULL, 'SH2_HSH2_like', NULL, NULL, NULL, 2),
(3652, NULL, 'cd05495', NULL, NULL, 'Bromo_cbp_like', NULL, 'Bromo_cbp_like', NULL, NULL, NULL, 2),
(3653, NULL, 'cd11306', NULL, NULL, 'M35_peptidyl-Lys', NULL, 'M35_peptidyl-Lys', NULL, NULL, 19517, 2),
(3654, NULL, 'cd12669', NULL, NULL, 'RRM1_Nop12p_like', NULL, 'RRM1_Nop12p_like', NULL, NULL, 24499, 2),
(3655, NULL, 'cd13199', NULL, NULL, 'FERM_C2_MyoVII', NULL, 'FERM_C2_MyoVII', NULL, NULL, 30798, 2),
(3656, NULL, 'cd17649', NULL, NULL, 'A_NRPS_PvdJ-like', NULL, 'A_NRPS_PvdJ-like', NULL, NULL, NULL, 2),
(3657, NULL, 'cd06340', NULL, NULL, 'PBP1_ABC_ligand_binding-like', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, NULL, 2),
(3658, NULL, 'cd00520', NULL, NULL, 'RRF', NULL, 'RRF', NULL, NULL, 2767, 2),
(3659, NULL, 'cd03292', NULL, NULL, 'ABC_FtsE_transporter', NULL, 'ABC_FtsE_transporter', NULL, NULL, NULL, 2),
(3660, NULL, 'cd00518', NULL, NULL, 'H2MP', NULL, 'H2MP', NULL, NULL, NULL, 2),
(3661, NULL, 'cd05824', NULL, NULL, 'LbH_M1P_guanylylT_C', NULL, 'LbH_M1P_guanylylT_C', NULL, NULL, NULL, 2),
(3662, NULL, 'cd05582', NULL, NULL, 'STKc_RSK_N', NULL, 'STKc_RSK_N', NULL, NULL, 30484, 2),
(3663, NULL, 'cd15966', NULL, NULL, '7tmA_RXFP2_LGR8', NULL, '7tmA_RXFP2_LGR8', NULL, NULL, NULL, 2),
(3664, NULL, 'cd01854', NULL, NULL, 'YjeQ_EngC', NULL, 'YjeQ_EngC', NULL, NULL, 7245, 2),
(3665, NULL, 'cd09878', NULL, NULL, 'PIN_VapC_VirB11L-ATPase-like', NULL, 'PIN_VapC_VirB11L-ATPase-like', NULL, NULL, NULL, 2),
(3666, NULL, 'cd15723', NULL, NULL, 'FYVE_protrudin', NULL, 'FYVE_protrudin', NULL, NULL, NULL, 2),
(3667, NULL, 'cd17004', NULL, NULL, 'CID_SCAF8', NULL, 'CID_SCAF8', NULL, NULL, NULL, 2),
(3668, NULL, 'cd12763', NULL, NULL, 'RRM1_hnRNPA3', NULL, 'RRM1_hnRNPA3', NULL, NULL, 12019, 2),
(3669, NULL, 'cd11317', NULL, NULL, 'AmyAc_bac_euk_AmyA', NULL, 'AmyAc_bac_euk_AmyA', NULL, NULL, NULL, 2),
(3670, NULL, 'cd15164', NULL, NULL, '7tmA_GPR35-like', NULL, '7tmA_GPR35-like', NULL, NULL, 34474, 2),
(3671, NULL, 'cd00144', NULL, NULL, 'MPP_PPP_family', NULL, 'MPP_PPP_family', NULL, NULL, NULL, 2),
(3672, NULL, 'cd03564', NULL, NULL, 'ANTH_N', NULL, 'ANTH_N', NULL, NULL, NULL, 2),
(3673, NULL, 'cd04883', NULL, NULL, 'ACT_AcuB', NULL, 'ACT_AcuB', NULL, NULL, NULL, 2),
(3674, NULL, 'cd19377', NULL, NULL, 'TGF_beta_INHA_B_like', NULL, 'TGF_beta_INHA_B_like', NULL, NULL, NULL, 2),
(3675, NULL, 'cd17405', NULL, NULL, 'MFS_SLCO6_OATP6', NULL, 'MFS_SLCO6_OATP6', NULL, NULL, NULL, 2),
(3676, NULL, 'cd18819', NULL, NULL, 'GH43_LbAraf43-like', NULL, 'GH43_LbAraf43-like', NULL, NULL, NULL, 2),
(3677, NULL, 'cd02975', NULL, NULL, 'PfPDO_like_N', NULL, 'PfPDO_like_N', NULL, NULL, NULL, 2);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(3678, NULL, 'cd05035', NULL, NULL, 'PTKc_TAM', NULL, 'PTKc_TAM', NULL, NULL, NULL, 2),
(3679, NULL, 'cd13846', NULL, NULL, 'CuRO_1_AAO_like_1', NULL, 'CuRO_1_AAO_like_1', NULL, NULL, 32822, 2),
(3680, NULL, 'cd18244', NULL, NULL, 'BTB_POZ_KLHL15', NULL, 'BTB_POZ_KLHL15', NULL, NULL, NULL, 2),
(3681, NULL, 'cd17546', NULL, NULL, 'REC_hyHK_CKI1_RcsC-like', NULL, 'REC_hyHK_CKI1_RcsC-like', NULL, NULL, NULL, 2),
(3682, NULL, 'cd12559', NULL, NULL, 'RRM_SRSF10', NULL, 'RRM_SRSF10', NULL, NULL, NULL, 2),
(3683, NULL, 'cd07652', NULL, NULL, 'F-BAR_Rgd1', NULL, 'F-BAR_Rgd1', NULL, NULL, NULL, 2),
(3684, NULL, 'cd13864', NULL, NULL, 'CuRO_1_MCO_like_2', NULL, 'CuRO_1_MCO_like_2', NULL, NULL, NULL, 2),
(3685, NULL, 'cd04791', NULL, NULL, 'LanC_SerThrkinase', NULL, 'LanC_SerThrkinase', NULL, NULL, NULL, 2),
(3686, NULL, 'cd04969', NULL, NULL, 'Ig5_Contactin', NULL, 'Ig5_Contactin', NULL, NULL, NULL, 2),
(3687, NULL, 'cd00922', NULL, NULL, 'Cyt_c_Oxidase_IV', NULL, 'Cyt_c_Oxidase_IV', NULL, NULL, 3000, 2),
(3688, NULL, 'cd11337', NULL, NULL, 'AmyAc_CMD_like', NULL, 'AmyAc_CMD_like', NULL, NULL, NULL, 2),
(3689, NULL, 'cd06959', NULL, NULL, 'NR_DBD_EcR_like', NULL, 'NR_DBD_EcR_like', NULL, NULL, NULL, 2),
(3690, NULL, 'cd01862', NULL, NULL, 'Rab7', NULL, 'Rab7', NULL, NULL, NULL, 2),
(3691, NULL, 'cd06067', NULL, NULL, 'H2MP_MemB-H2evol', NULL, 'H2MP_MemB-H2evol', NULL, NULL, 7306, 2),
(3692, NULL, 'cd00990', NULL, NULL, 'PDZ_glycyl_aminopeptidase', NULL, 'PDZ_glycyl_aminopeptidase', NULL, NULL, 29279, 2),
(3693, NULL, 'cd18009', NULL, NULL, 'DEXHc_HELLS_SMARCA6', NULL, 'DEXHc_HELLS_SMARCA6', NULL, NULL, 34099, 2),
(3694, NULL, 'cd05875', NULL, NULL, 'Ig_hNeurofascin_like', NULL, 'Ig_hNeurofascin_like', NULL, NULL, NULL, 2),
(3695, NULL, 'cd11423', NULL, NULL, 'bHLH_TS_musculin_like', NULL, 'bHLH_TS_musculin_like', NULL, NULL, NULL, 2),
(3696, NULL, 'cd08190', NULL, NULL, 'HOT', NULL, 'HOT', NULL, NULL, 35272, 2),
(3697, NULL, 'cd00255', NULL, NULL, 'nidG2', NULL, 'nidG2', NULL, NULL, 1394, 2),
(3698, NULL, 'cd14616', NULL, NULL, 'R-PTPc-Q', NULL, 'R-PTPc-Q', NULL, NULL, NULL, 2),
(3699, NULL, 'cd01535', NULL, NULL, '4RHOD_Repeat_4', NULL, '4RHOD_Repeat_4', NULL, NULL, NULL, 2),
(3700, NULL, 'cd14421', NULL, NULL, 'CUE_AMFR', NULL, 'CUE_AMFR', NULL, NULL, NULL, 2),
(3701, NULL, 'cd01437', NULL, NULL, 'parp_like', NULL, 'parp_like', NULL, NULL, NULL, 2),
(3702, NULL, 'cd13940', NULL, NULL, 'ILEI_FAM3C', NULL, 'ILEI_FAM3C', NULL, NULL, 33068, 2),
(3703, NULL, 'cd03078', NULL, NULL, 'GST_N_Metaxin1_like', NULL, 'GST_N_Metaxin1_like', NULL, NULL, NULL, 2),
(3704, NULL, 'cd03404', NULL, NULL, 'SPFH_HflK', NULL, 'SPFH_HflK', NULL, NULL, 4500, 2),
(3705, NULL, 'cd05938', NULL, NULL, 'hsFATP2a_ACSVL_like', NULL, 'hsFATP2a_ACSVL_like', NULL, NULL, NULL, 2),
(3706, NULL, 'cd17952', NULL, NULL, 'DEADc_DDX42', NULL, 'DEADc_DDX42', NULL, NULL, NULL, 2),
(3707, NULL, 'cd13391', NULL, NULL, 'PH_PRG', NULL, 'PH_PRG', NULL, NULL, 28879, 2),
(3708, NULL, 'cd12531', NULL, NULL, 'RRM3_MEI2_like', NULL, 'RRM3_MEI2_like', NULL, NULL, 28316, 2),
(3709, NULL, 'cd02242', NULL, NULL, 'cupin_11S_legumin_N', NULL, 'cupin_11S_legumin_N', NULL, NULL, NULL, 2),
(3710, NULL, 'cd12349', NULL, NULL, 'RRM2_SHARP', NULL, 'RRM2_SHARP', NULL, NULL, 3619, 2),
(3711, NULL, 'cd01832', NULL, NULL, 'SGNH_hydrolase_like_1', NULL, 'SGNH_hydrolase_like_1', NULL, NULL, NULL, 2),
(3712, NULL, 'cd05109', NULL, NULL, 'PTKc_HER2', NULL, 'PTKc_HER2', NULL, NULL, NULL, 2),
(3713, NULL, 'cd20291', NULL, NULL, 'cupin_CucA-like', NULL, 'cupin_CucA-like', NULL, NULL, NULL, 2),
(3714, NULL, 'cd12041', NULL, NULL, 'SH3_CACNB1', NULL, 'SH3_CACNB1', NULL, NULL, NULL, 2),
(3715, NULL, 'cd00159', NULL, NULL, 'RhoGAP', NULL, 'RhoGAP', NULL, NULL, NULL, 2),
(3716, NULL, 'cd03084', NULL, NULL, 'phosphohexomutase', NULL, 'phosphohexomutase', NULL, NULL, NULL, 2),
(3717, NULL, 'cd17709', NULL, NULL, 'BRCT_pescadillo_like', NULL, 'BRCT_pescadillo_like', NULL, NULL, NULL, 2),
(3718, NULL, 'cd02883', NULL, NULL, 'Nudix_Hydrolase', NULL, 'Nudix_Hydrolase', NULL, NULL, NULL, 2); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(3719, NULL, 'cd01277', NULL, NULL, 'HINT_subgroup', NULL, 'HINT_subgroup', NULL, NULL, 29299, 2),
(3720, NULL, 'cd16024', NULL, NULL, 'GPI_EPT_2', NULL, 'GPI_EPT_2', NULL, NULL, 27877, 2),
(3721, NULL, 'cd16845', NULL, NULL, 'STAT1_DBD', NULL, 'STAT1_DBD', NULL, NULL, NULL, 2),
(3722, NULL, 'cd02538', NULL, NULL, 'G1P_TT_short', NULL, 'G1P_TT_short', NULL, NULL, 232, 2),
(3723, NULL, 'cd02520', NULL, NULL, 'Glucosylceramide_synthase', NULL, 'Glucosylceramide_synthase', NULL, NULL, NULL, 2),
(3724, NULL, 'cd09596', NULL, NULL, 'M36', NULL, 'M36', NULL, NULL, NULL, 2),
(3725, NULL, 'cd06427', NULL, NULL, 'CESA_like_2', NULL, 'CESA_like_2', NULL, NULL, NULL, 2),
(3726, NULL, 'cd05862', NULL, NULL, 'Ig_VEGFR', NULL, 'Ig_VEGFR', NULL, NULL, NULL, 2),
(3727, NULL, 'cd15575', NULL, NULL, 'PHD_JMJD2A', NULL, 'PHD_JMJD2A', NULL, NULL, NULL, 2),
(3728, NULL, 'cd03571', NULL, NULL, 'ENTH', NULL, 'ENTH', NULL, NULL, NULL, 2),
(3729, NULL, 'cd08639', NULL, NULL, 'DNA_pol_A_Aquificae_like', NULL, 'DNA_pol_A_Aquificae_like', NULL, NULL, NULL, 2),
(3730, NULL, 'cd16992', NULL, NULL, 'ENTH_Ent3', NULL, 'ENTH_Ent3', NULL, NULL, NULL, 2),
(3731, NULL, 'cd19938', NULL, NULL, 'REC_OmpR_BaeR-like', NULL, 'REC_OmpR_BaeR-like', NULL, NULL, NULL, 2),
(3732, NULL, 'cd05390', NULL, NULL, 'HypB', NULL, 'HypB', NULL, NULL, 5621, 2),
(3733, NULL, 'cd11274', NULL, NULL, 'Sema_plexin_A4', NULL, 'Sema_plexin_A4', NULL, NULL, NULL, 2),
(3734, NULL, 'cd16830', NULL, NULL, 'HemS-like_N', NULL, 'HemS-like_N', NULL, NULL, NULL, 2),
(3735, NULL, 'cd19425', NULL, NULL, 'lipocalin_10-like', NULL, 'lipocalin_10-like', NULL, NULL, NULL, 2),
(3736, NULL, 'cd04715', NULL, NULL, 'BAH_Orc1p_like', NULL, 'BAH_Orc1p_like', NULL, NULL, NULL, 2),
(3737, NULL, 'cd00763', NULL, NULL, 'Bacterial_PFK', NULL, 'Bacterial_PFK', NULL, NULL, 12744, 2),
(3738, NULL, 'cd07450', NULL, NULL, 'CRD_FZ6', NULL, 'CRD_FZ6', NULL, NULL, 30411, 2),
(3739, NULL, 'cd16705', NULL, NULL, 'RING-HC_dBre1_like', NULL, 'RING-HC_dBre1_like', NULL, NULL, NULL, 2),
(3740, NULL, 'cd16955', NULL, NULL, 'HATPase_YpdA-like', NULL, 'HATPase_YpdA-like', NULL, NULL, NULL, 2),
(3741, NULL, 'cd02202', NULL, NULL, 'CetZ_tubulin-like', NULL, 'CetZ_tubulin-like', NULL, NULL, NULL, 2),
(3742, NULL, 'cd17522', NULL, NULL, 'RMtype1_S_MjaORF1531P-TRD1-CR1_like', NULL, 'RMtype1_S_MjaORF1531P-TRD1-CR1_like', NULL, NULL, NULL, 2),
(3743, NULL, 'cd07003', NULL, NULL, 'cupin_YobQ-like_N', NULL, 'cupin_YobQ-like_N', NULL, NULL, NULL, 2),
(3744, NULL, 'cd15980', NULL, NULL, '7tmA_NPFFR2', NULL, '7tmA_NPFFR2', NULL, NULL, NULL, 2),
(3745, NULL, 'cd05715', NULL, NULL, 'Ig_P0-like', NULL, 'Ig_P0-like', NULL, NULL, NULL, 2),
(3746, NULL, 'cd06331', NULL, NULL, 'PBP1_AmiC-like', NULL, 'PBP1_AmiC-like', NULL, NULL, NULL, 2),
(3747, NULL, 'cd16227', NULL, NULL, 'EFh_CREC_RCN2_like', NULL, 'EFh_CREC_RCN2_like', NULL, NULL, NULL, 2),
(3748, NULL, 'cd08819', NULL, NULL, 'CARD_MDA5_r2', NULL, 'CARD_MDA5_r2', NULL, NULL, NULL, 2),
(3749, NULL, 'cd09887', NULL, NULL, 'NGN_Arch', NULL, 'NGN_Arch', NULL, NULL, NULL, 2),
(3750, NULL, 'cd17451', NULL, NULL, 'MFS_NLS1_MFSD2A', NULL, 'MFS_NLS1_MFSD2A', NULL, NULL, NULL, 2),
(3751, NULL, 'cd17192', NULL, NULL, 'FERM_F1_PTPN21', NULL, 'FERM_F1_PTPN21', NULL, NULL, NULL, 2),
(3752, NULL, 'cd09319', NULL, NULL, 'TDT_like_1', NULL, 'TDT_like_1', NULL, NULL, NULL, 2),
(3753, NULL, 'cd01968', NULL, NULL, 'Nitrogenase_NifE_I', NULL, 'Nitrogenase_NifE_I', NULL, NULL, NULL, 2),
(3754, NULL, 'cd01003', NULL, NULL, 'PBP2_YckB', NULL, 'PBP2_YckB', NULL, NULL, NULL, 2),
(3755, NULL, 'cd03423', NULL, NULL, 'SirA', NULL, 'SirA', NULL, NULL, 14771, 2),
(3756, NULL, 'cd01393', NULL, NULL, 'recA_like', NULL, 'recA_like', NULL, NULL, NULL, 2),
(3757, NULL, 'cd14559', NULL, NULL, 'PTP_YopH-like', NULL, 'PTP_YopH-like', NULL, NULL, NULL, 2),
(3758, NULL, 'cd15808', NULL, NULL, 'SPRY_PRY_TRIM47', NULL, 'SPRY_PRY_TRIM47', NULL, NULL, 37002, 2),
(3759, NULL, 'cd10456', NULL, NULL, 'GIY-YIG_UPF0213', NULL, 'GIY-YIG_UPF0213', NULL, NULL, NULL, 2),
(3760, NULL, 'cd15261', NULL, NULL, '7tmB1_PDFR', NULL, '7tmB1_PDFR', NULL, NULL, NULL, 2);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(3761, NULL, 'cd05043', NULL, NULL, 'PTK_Ryk', NULL, 'PTK_Ryk', NULL, NULL, NULL, 2),
(3762, NULL, 'cd07586', NULL, NULL, 'nitrilase_8', NULL, 'nitrilase_8', NULL, NULL, NULL, 2),
(3763, NULL, 'cd17785', NULL, NULL, 'CBS_pair_bac_arch', NULL, 'CBS_pair_bac_arch', NULL, NULL, NULL, 2),
(3764, NULL, 'cd04516', NULL, NULL, 'TBP_eukaryotes', NULL, 'TBP_eukaryotes', NULL, NULL, 32241, 2),
(3765, NULL, 'cd06647', NULL, NULL, 'STKc_PAK_I', NULL, 'STKc_PAK_I', NULL, NULL, NULL, 2),
(3766, NULL, 'cd08753', NULL, NULL, 'RGS_PDZRhoGEF', NULL, 'RGS_PDZRhoGEF', NULL, NULL, 31895, 2),
(3767, NULL, 'cd12343', NULL, NULL, 'RRM1_2_CoAA_like', NULL, 'RRM1_2_CoAA_like', NULL, NULL, NULL, 2),
(3768, NULL, 'cd14605', NULL, NULL, 'PTPc-N11', NULL, 'PTPc-N11', NULL, NULL, NULL, 2),
(3769, NULL, 'cd00214', NULL, NULL, 'Calpain_III', NULL, 'Calpain_III', NULL, NULL, 31133, 2),
(3770, NULL, 'cd08583', NULL, NULL, 'PI-PLCc_GDPD_SF_unchar1', NULL, 'PI-PLCc_GDPD_SF_unchar1', NULL, NULL, NULL, 2),
(3771, NULL, 'cd15034', NULL, NULL, '7tmF_FZD1_2_7-like', NULL, '7tmF_FZD1_2_7-like', NULL, NULL, NULL, 2),
(3772, NULL, 'cd15473', NULL, NULL, 'Myo5p-like_CBD_DIL_ANK', NULL, 'Myo5p-like_CBD_DIL_ANK', NULL, NULL, 33355, 2),
(3773, NULL, 'cd10526', NULL, NULL, 'SET_SMYD1', NULL, 'SET_SMYD1', NULL, NULL, 35466, 2),
(3774, NULL, 'cd13832', NULL, NULL, 'IHF', NULL, 'IHF', NULL, NULL, NULL, 2),
(3775, NULL, 'cd09803', NULL, NULL, 'UBAN', NULL, 'UBAN', NULL, NULL, NULL, 2),
(3776, NULL, 'cd14236', NULL, NULL, 'GAT_TOM1', NULL, 'GAT_TOM1', NULL, NULL, NULL, 2),
(3777, NULL, 'cd05078', NULL, NULL, 'PTK_Jak2_rpt1', NULL, 'PTK_Jak2_rpt1', NULL, NULL, 26759, 2),
(3778, NULL, 'cd13351', NULL, NULL, 'PH-GRAM1_TCB1D9_TCB1D9B', NULL, 'PH-GRAM1_TCB1D9_TCB1D9B', NULL, NULL, 28218, 2),
(3779, NULL, 'cd04144', NULL, NULL, 'Ras2', NULL, 'Ras2', NULL, NULL, NULL, 2),
(3780, NULL, 'cd09238', NULL, NULL, 'V_Alix_like_1', NULL, 'V_Alix_like_1', NULL, NULL, NULL, 2),
(3781, NULL, 'cd15478', NULL, NULL, 'Myo5a_CBD', NULL, 'Myo5a_CBD', NULL, NULL, 33346, 2),
(3782, NULL, 'cd16406', NULL, NULL, 'ParB_N_like', NULL, 'ParB_N_like', NULL, NULL, NULL, 2),
(3783, NULL, 'cd14423', NULL, NULL, 'CUE_UBR5', NULL, 'CUE_UBR5', NULL, NULL, 1307, 2),
(3784, NULL, 'cd03737', NULL, NULL, 'SOCS_SOCS3', NULL, 'SOCS_SOCS3', NULL, NULL, NULL, 2),
(3785, NULL, 'cd15931', NULL, NULL, '7tmB2_EMR_Adhesion_II', NULL, '7tmB2_EMR_Adhesion_II', NULL, NULL, NULL, 2),
(3786, NULL, 'cd13223', NULL, NULL, 'PH-GRAM_MTM-like', NULL, 'PH-GRAM_MTM-like', NULL, NULL, NULL, 2),
(3787, NULL, 'cd08287', NULL, NULL, 'FDH_like_ADH3', NULL, 'FDH_like_ADH3', NULL, NULL, NULL, 2),
(3788, NULL, 'cd09194', NULL, NULL, 'PLDc_yTdp1_1', NULL, 'PLDc_yTdp1_1', NULL, NULL, NULL, 2),
(3789, NULL, 'cd03679', NULL, NULL, 'MM_CoA_mutase_alpha_like', NULL, 'MM_CoA_mutase_alpha_like', NULL, NULL, NULL, 2),
(3790, NULL, 'cd17078', NULL, NULL, 'Ubl_SLD1_NFATC2ip', NULL, 'Ubl_SLD1_NFATC2ip', NULL, NULL, NULL, 2),
(3791, NULL, 'cd05941', NULL, NULL, 'MCS', NULL, 'MCS', NULL, NULL, NULL, 2),
(3792, NULL, 'cd14408', NULL, NULL, 'UBA_SIK1', NULL, 'UBA_SIK1', NULL, NULL, NULL, 2),
(3793, NULL, 'cd15976', NULL, NULL, '7tmA_ET-BR', NULL, '7tmA_ET-BR', NULL, NULL, NULL, 2),
(3794, NULL, 'cd08301', NULL, NULL, 'alcohol_DH_plants', NULL, 'alcohol_DH_plants', NULL, NULL, NULL, 2),
(3795, NULL, 'cd05857', NULL, NULL, 'Ig2_FGFR', NULL, 'Ig2_FGFR', NULL, NULL, NULL, 2),
(3796, NULL, 'cd18591', NULL, NULL, 'ABC_6TM_SUR1_D1_like', NULL, 'ABC_6TM_SUR1_D1_like', NULL, NULL, NULL, 2),
(3797, NULL, 'cd14504', NULL, NULL, 'DUSP23', NULL, 'DUSP23', NULL, NULL, NULL, 2),
(3798, NULL, 'cd19773', NULL, NULL, 'Bbox2_TRIM23_C-IX_rpt1', NULL, 'Bbox2_TRIM23_C-IX_rpt1', NULL, NULL, NULL, 2),
(3799, NULL, 'cd16100', NULL, NULL, 'ARID', NULL, 'ARID', NULL, NULL, NULL, 2),
(3800, NULL, 'cd18965', NULL, NULL, 'chromodomain', NULL, 'chromodomain', NULL, NULL, NULL, 2),
(3801, NULL, 'cd14002', NULL, NULL, 'STKc_STK36', NULL, 'STKc_STK36', NULL, NULL, NULL, 2),
(3802, NULL, 'cd13585', NULL, NULL, 'PBP2_TMBP_like', NULL, 'PBP2_TMBP_like', NULL, NULL, NULL, 2);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(3803, NULL, 'cd07381', NULL, NULL, 'MPP_CapA', NULL, 'MPP_CapA', NULL, NULL, 16886, 2),
(3804, NULL, 'cd11478', NULL, NULL, 'SLC5sbd_u2', NULL, 'SLC5sbd_u2', NULL, NULL, NULL, 2),
(3805, NULL, 'cd11320', NULL, NULL, 'AmyAc_AmyMalt_CGTase_like', NULL, 'AmyAc_AmyMalt_CGTase_like', NULL, NULL, NULL, 2),
(3806, NULL, 'cd07978', NULL, NULL, 'TAF13', NULL, 'TAF13', NULL, NULL, 4025, 2),
(3807, NULL, 'cd20298', NULL, NULL, 'cupin_UAH', NULL, 'cupin_UAH', NULL, NULL, NULL, 2),
(3808, NULL, 'cd07249', NULL, NULL, 'MMCE', NULL, 'MMCE', NULL, NULL, 21120, 2),
(3809, NULL, 'cd10925', NULL, NULL, 'CE4_u1', NULL, 'CE4_u1', NULL, NULL, NULL, 2),
(3810, NULL, 'cd04020', NULL, NULL, 'C2B_SLP_1-2-3-4', NULL, 'C2B_SLP_1-2-3-4', NULL, NULL, 35026, 2),
(3811, NULL, 'cd13859', NULL, NULL, 'CuRO_D1_2dMcoN_like', NULL, 'CuRO_D1_2dMcoN_like', NULL, NULL, NULL, 2),
(3812, NULL, 'cd14927', NULL, NULL, 'MYSc_Myh7b', NULL, 'MYSc_Myh7b', NULL, NULL, NULL, 2),
(3813, NULL, 'cd17298', NULL, NULL, 'DUF1907', NULL, 'DUF1907', NULL, NULL, NULL, 2),
(3814, NULL, 'cd19756', NULL, NULL, 'Bbox2', NULL, 'Bbox2', NULL, NULL, NULL, 2),
(3815, NULL, 'cd12914', NULL, NULL, 'PDC1_DGC_like', NULL, 'PDC1_DGC_like', NULL, NULL, NULL, 2),
(3816, NULL, 'cd08891', NULL, NULL, 'SRPBCC_CalC', NULL, 'SRPBCC_CalC', NULL, NULL, NULL, 2),
(3817, NULL, 'cd13689', NULL, NULL, 'PBP2_BsGlnH', NULL, 'PBP2_BsGlnH', NULL, NULL, NULL, 2),
(3818, NULL, 'cd13769', NULL, NULL, 'ApoLp-III_like', NULL, 'ApoLp-III_like', NULL, NULL, NULL, 2),
(3819, NULL, 'cd10787', NULL, NULL, 'LamB_YcsF_like', NULL, 'LamB_YcsF_like', NULL, NULL, NULL, 2),
(3820, NULL, 'cd16229', NULL, NULL, 'EFh_CREC_RCN1', NULL, 'EFh_CREC_RCN1', NULL, NULL, NULL, 2),
(3821, NULL, 'cd16913', NULL, NULL, 'YkuD_like', NULL, 'YkuD_like', NULL, NULL, 670, 2),
(3822, NULL, 'cd05937', NULL, NULL, 'FATP_chFAT1_like', NULL, 'FATP_chFAT1_like', NULL, NULL, NULL, 2),
(3823, NULL, 'cd04433', NULL, NULL, 'AFD_class_I', NULL, 'AFD_class_I', NULL, NULL, NULL, 2),
(3824, NULL, 'cd10301', NULL, NULL, 'GST_C_CLIC6', NULL, 'GST_C_CLIC6', NULL, NULL, NULL, 2),
(3825, NULL, 'cd09999', NULL, NULL, 'Arginase-like_1', NULL, 'Arginase-like_1', NULL, NULL, NULL, 2),
(3826, NULL, 'cd19192', NULL, NULL, 'PR-SET_PRDM8', NULL, 'PR-SET_PRDM8', NULL, NULL, 34746, 2),
(3827, NULL, 'cd03517', NULL, NULL, 'Link_domain_CSPGs_modules_1_3', NULL, 'Link_domain_CSPGs_modules_1_3', NULL, NULL, NULL, 2),
(3828, NULL, 'cd19856', NULL, NULL, 'DSRM_Kanadaptin', NULL, 'DSRM_Kanadaptin', NULL, NULL, NULL, 2),
(3829, NULL, 'cd16599', NULL, NULL, 'RING-HC_TRIM35_C-IV', NULL, 'RING-HC_TRIM35_C-IV', NULL, NULL, NULL, 2),
(3830, NULL, 'cd05687', NULL, NULL, 'S1_RPS1_repeat_ec1_hs1', NULL, 'S1_RPS1_repeat_ec1_hs1', NULL, NULL, NULL, 2),
(3831, NULL, 'cd07378', NULL, NULL, 'MPP_ACP5', NULL, 'MPP_ACP5', NULL, NULL, 16440, 2),
(3832, NULL, 'cd16360', NULL, NULL, 'ED_TypeI_classII_N', NULL, 'ED_TypeI_classII_N', NULL, NULL, NULL, 2),
(3833, NULL, 'cd16617', NULL, NULL, 'mRING-HC-C4C4_CesA_plant', NULL, 'mRING-HC-C4C4_CesA_plant', NULL, NULL, NULL, 2),
(3834, NULL, 'cd18793', NULL, NULL, 'SF2_C_SNF', NULL, 'SF2_C_SNF', NULL, NULL, NULL, 2),
(3835, NULL, 'cd14511', NULL, NULL, 'PTP_auxilin-like', NULL, 'PTP_auxilin-like', NULL, NULL, NULL, 2),
(3836, NULL, 'cd07969', NULL, NULL, 'OBF_DNA_ligase_I', NULL, 'OBF_DNA_ligase_I', NULL, NULL, NULL, 2),
(3837, NULL, 'cd15411', NULL, NULL, '7tmA_OR8H-like', NULL, '7tmA_OR8H-like', NULL, NULL, NULL, 2),
(3838, NULL, 'cd01885', NULL, NULL, 'EF2', NULL, 'EF2', NULL, NULL, NULL, 2),
(3839, NULL, 'cd18601', NULL, NULL, 'ABC_6TM_MRP4_D2_like', NULL, 'ABC_6TM_MRP4_D2_like', NULL, NULL, NULL, 2),
(3840, NULL, 'cd06879', NULL, NULL, 'PX_UP1_plant', NULL, 'PX_UP1_plant', NULL, NULL, NULL, 2),
(3841, NULL, 'cd14360', NULL, NULL, 'UBA_NAC_like_bac', NULL, 'UBA_NAC_like_bac', NULL, NULL, NULL, 2),
(3842, NULL, 'cd03113', NULL, NULL, 'CTPS_N', NULL, 'CTPS_N', NULL, NULL, 18517, 2),
(3843, NULL, 'cd06222', NULL, NULL, 'RNase_H_like', NULL, 'RNase_H_like', NULL, NULL, 34720, 2),
(3844, NULL, 'cd08350', NULL, NULL, 'BLMT_like', NULL, 'BLMT_like', NULL, NULL, NULL, 2);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(3845, NULL, 'cd12839', NULL, NULL, 'Killer_toxin_beta', NULL, 'Killer_toxin_beta', NULL, NULL, 13879, 2),
(3846, NULL, 'cd01768', NULL, NULL, 'RA_FERM_F0_F1_like', NULL, 'RA_FERM_F0_F1_like', NULL, NULL, NULL, 2),
(3847, NULL, 'cd00043', NULL, NULL, 'CYCLIN', NULL, 'CYCLIN', NULL, NULL, 7606, 2),
(3848, NULL, 'sd00005', NULL, NULL, 'TPR', NULL, 'TPR', NULL, NULL, NULL, 2),
(3849, NULL, 'cd00371', NULL, NULL, 'HMA', NULL, 'HMA', NULL, NULL, 10473, 2),
(3850, NULL, 'cd09531', NULL, NULL, 'SAM_CS047', NULL, 'SAM_CS047', NULL, NULL, 28680, 2),
(3851, NULL, 'cd18327', NULL, NULL, 'BTB_POZ_ZBTB7B_ZBTB15', NULL, 'BTB_POZ_ZBTB7B_ZBTB15', NULL, NULL, NULL, 2),
(3852, NULL, 'cd16840', NULL, NULL, 'toxin_MLD', NULL, 'toxin_MLD', NULL, NULL, NULL, 2),
(3853, NULL, 'cd14225', NULL, NULL, 'PKc_DYRK4', NULL, 'PKc_DYRK4', NULL, NULL, NULL, 2),
(3854, NULL, 'cd15468', NULL, NULL, 'HeV-G', NULL, 'HeV-G', NULL, NULL, NULL, 2),
(3855, NULL, 'cd11387', NULL, NULL, 'bHLHzip_USF_MITF', NULL, 'bHLHzip_USF_MITF', NULL, NULL, NULL, 2),
(3856, NULL, 'cd08922', NULL, NULL, 'FHb-globin', NULL, 'FHb-globin', NULL, NULL, NULL, 2),
(3857, NULL, 'cd20221', NULL, NULL, 'PFM_Dln1-like', NULL, 'PFM_Dln1-like', NULL, NULL, NULL, 2),
(3858, NULL, 'cd12430', NULL, NULL, 'RRM_LARP4_5_like', NULL, 'RRM_LARP4_5_like', NULL, NULL, NULL, 2),
(3859, NULL, 'cd05847', NULL, NULL, 'IgC_CH2_IgE', NULL, 'IgC_CH2_IgE', NULL, NULL, NULL, 2),
(3860, NULL, 'cd16949', NULL, NULL, 'HATPase_CpxA-like', NULL, 'HATPase_CpxA-like', NULL, NULL, NULL, 2),
(3861, NULL, 'cd19891', NULL, NULL, 'DSRM_PRKRA_rpt2', NULL, 'DSRM_PRKRA_rpt2', NULL, NULL, 34358, 2),
(3862, NULL, 'cd16869', NULL, NULL, 'ARID_ARID5', NULL, 'ARID_ARID5', NULL, NULL, NULL, 2),
(3863, NULL, 'cd02144', NULL, NULL, 'iodotyrosine_dehalogenase', NULL, 'iodotyrosine_dehalogenase', NULL, NULL, NULL, 2),
(3864, NULL, 'cd04056', NULL, NULL, 'Peptidases_S53', NULL, 'Peptidases_S53', NULL, NULL, 25139, 2),
(3865, NULL, 'cd14086', NULL, NULL, 'STKc_CaMKII', NULL, 'STKc_CaMKII', NULL, NULL, NULL, 2),
(3866, NULL, 'cd16418', NULL, NULL, 'HAD_Pase', NULL, 'HAD_Pase', NULL, NULL, NULL, 2),
(3867, NULL, 'cd16716', NULL, NULL, 'vRING-HC_IRF2BP2', NULL, 'vRING-HC_IRF2BP2', NULL, NULL, NULL, 2),
(3868, NULL, 'cd04300', NULL, NULL, 'GT35_Glycogen_Phosphorylase', NULL, 'GT35_Glycogen_Phosphorylase', NULL, NULL, NULL, 2),
(3869, NULL, 'cd12056', NULL, NULL, 'SH3_CD2AP_3', NULL, 'SH3_CD2AP_3', NULL, NULL, 31564, 2),
(3870, NULL, 'cd03580', NULL, NULL, 'NTR_Sfrp1_like', NULL, 'NTR_Sfrp1_like', NULL, NULL, NULL, 2),
(3871, NULL, 'cd02550', NULL, NULL, 'PseudoU_synth_Rsu_Rlu_like', NULL, 'PseudoU_synth_Rsu_Rlu_like', NULL, NULL, NULL, 2),
(3872, NULL, 'cd08497', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_14', NULL, 'PBP2_NikA_DppA_OppA_like_14', NULL, NULL, NULL, 2),
(3873, NULL, 'cd12553', NULL, NULL, 'RRM1_RBM15', NULL, 'RRM1_RBM15', NULL, NULL, 11805, 2),
(3874, NULL, 'cd11752', NULL, NULL, 'GH94N_CDP_like', NULL, 'GH94N_CDP_like', NULL, NULL, NULL, 2),
(3875, NULL, 'cd03431', NULL, NULL, 'DNA_Glycosylase_C', NULL, 'DNA_Glycosylase_C', NULL, NULL, 25685, 2),
(3876, NULL, 'cd07330', NULL, NULL, 'M48A_Ste24p', NULL, 'M48A_Ste24p', NULL, NULL, NULL, 2),
(3877, NULL, 'cd01524', NULL, NULL, 'RHOD_Pyr_redox', NULL, 'RHOD_Pyr_redox', NULL, NULL, NULL, 2),
(3878, NULL, 'cd18833', NULL, NULL, 'GH43_PcXyl-like', NULL, 'GH43_PcXyl-like', NULL, NULL, NULL, 2),
(3879, NULL, 'cd09329', NULL, NULL, 'LIM3_abLIM', NULL, 'LIM3_abLIM', NULL, NULL, NULL, 2),
(3880, NULL, 'cd02760', NULL, NULL, 'MopB_Phenylacetyl-CoA-OR', NULL, 'MopB_Phenylacetyl-CoA-OR', NULL, NULL, 30677, 2),
(3881, NULL, 'cd17146', NULL, NULL, 'DCX1_RP1L1', NULL, 'DCX1_RP1L1', NULL, NULL, NULL, 2),
(3882, NULL, 'cd06245', NULL, NULL, 'M14_CPD_III', NULL, 'M14_CPD_III', NULL, NULL, 32239, 2),
(3883, NULL, 'cd15763', NULL, NULL, 'FYVE_RPH3L', NULL, 'FYVE_RPH3L', NULL, NULL, 30752, 2),
(3884, NULL, 'cd21662', NULL, NULL, 'embe-CoV_Protein-I_like', NULL, 'embe-CoV_Protein-I_like', NULL, NULL, 36152, 2),
(3885, NULL, 'cd08003', NULL, NULL, 'WGR_PARP2_like', NULL, 'WGR_PARP2_like', NULL, NULL, NULL, 2);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(3886, NULL, 'cd17540', NULL, NULL, 'REC_PhyR', NULL, 'REC_PhyR', NULL, NULL, NULL, 2),
(3887, NULL, 'cd13157', NULL, NULL, 'PTB_tensin-related', NULL, 'PTB_tensin-related', NULL, NULL, NULL, 2),
(3888, NULL, 'cd04010', NULL, NULL, 'C2B_RasA3', NULL, 'C2B_RasA3', NULL, NULL, NULL, 2),
(3889, NULL, 'cd14777', NULL, NULL, 'Yhb1-globin-like', NULL, 'Yhb1-globin-like', NULL, NULL, NULL, 2),
(3890, NULL, 'cd15119', NULL, NULL, '7tmA_GPR1', NULL, '7tmA_GPR1', NULL, NULL, NULL, 2),
(3891, NULL, 'cd18759', NULL, NULL, 'PIN_MtVapC3-like', NULL, 'PIN_MtVapC3-like', NULL, NULL, NULL, 2),
(3892, NULL, 'cd11962', NULL, NULL, 'SH3_Abp1_fungi_C1', NULL, 'SH3_Abp1_fungi_C1', NULL, NULL, 31254, 2),
(3893, NULL, 'cd08550', NULL, NULL, 'GlyDH-like', NULL, 'GlyDH-like', NULL, NULL, NULL, 2),
(3894, NULL, 'cd11490', NULL, NULL, 'SLC5sbd_SGLT6', NULL, 'SLC5sbd_SGLT6', NULL, NULL, NULL, 2),
(3895, NULL, 'cd05860', NULL, NULL, 'Ig4_SCFR', NULL, 'Ig4_SCFR', NULL, NULL, NULL, 2),
(3896, NULL, 'cd14328', NULL, NULL, 'UBA_TNK1', NULL, 'UBA_TNK1', NULL, NULL, NULL, 2),
(3897, NULL, 'cd17095', NULL, NULL, 'FERM_F0_kindlins', NULL, 'FERM_F0_kindlins', NULL, NULL, NULL, 2),
(3898, NULL, 'cd05716', NULL, NULL, 'Ig_pIgR_like', NULL, 'Ig_pIgR_like', NULL, NULL, NULL, 2),
(3899, NULL, 'cd15047', NULL, NULL, '7tmC_GABA-B-like', NULL, '7tmC_GABA-B-like', NULL, NULL, NULL, 2),
(3900, NULL, 'cd03221', NULL, NULL, 'ABCF_EF-3', NULL, 'ABCF_EF-3', NULL, NULL, NULL, 2),
(3901, NULL, 'cd12092', NULL, NULL, 'TM_ErbB4', NULL, 'TM_ErbB4', NULL, NULL, NULL, 2),
(3902, NULL, 'cd14418', NULL, NULL, 'CUE_DMA_DMRTA2', NULL, 'CUE_DMA_DMRTA2', NULL, NULL, NULL, 2),
(3903, NULL, 'cd08558', NULL, NULL, 'PI-PLCc_eukaryota', NULL, 'PI-PLCc_eukaryota', NULL, NULL, NULL, 2),
(3904, NULL, 'cd11458', NULL, NULL, 'bHLHzip_c-Myc', NULL, 'bHLHzip_c-Myc', NULL, NULL, NULL, 2),
(3905, NULL, 'cd01448', NULL, NULL, 'TST_Repeat_1', NULL, 'TST_Repeat_1', NULL, NULL, NULL, 2),
(3906, NULL, 'cd06255', NULL, NULL, 'M14_ASTE_ASPA-like', NULL, 'M14_ASTE_ASPA-like', NULL, NULL, NULL, 2),
(3907, NULL, 'cd08307', NULL, NULL, 'Death_Pelle', NULL, 'Death_Pelle', NULL, NULL, 31597, 2),
(3908, NULL, 'cd12121', NULL, NULL, 'MARK_C_like', NULL, 'MARK_C_like', NULL, NULL, NULL, 2),
(3909, NULL, 'cd05645', NULL, NULL, 'M20_peptidase_T', NULL, 'M20_peptidase_T', NULL, NULL, NULL, 2),
(3910, NULL, 'cd08802', NULL, NULL, 'Death_UNC5B', NULL, 'Death_UNC5B', NULL, NULL, 33985, 2),
(3911, NULL, 'cd15304', NULL, NULL, '7tmA_5-HT2A', NULL, '7tmA_5-HT2A', NULL, NULL, NULL, 2),
(3912, NULL, 'cd05071', NULL, NULL, 'PTKc_Src', NULL, 'PTKc_Src', NULL, NULL, NULL, 2),
(3913, NULL, 'cd06467', NULL, NULL, 'p23_NUDC_like', NULL, 'p23_NUDC_like', NULL, NULL, NULL, 2),
(3914, NULL, 'cd09407', NULL, NULL, 'LIM2_Paxillin', NULL, 'LIM2_Paxillin', NULL, NULL, NULL, 2),
(3915, NULL, 'cd14486', NULL, NULL, '3D_domain', NULL, '3D_domain', NULL, NULL, NULL, 2),
(3916, NULL, 'cd15149', NULL, NULL, '7tmA_P2Y14', NULL, '7tmA_P2Y14', NULL, NULL, NULL, 2),
(3917, NULL, 'cd19986', NULL, NULL, 'PBP1_ABC_HAAT-like', NULL, 'PBP1_ABC_HAAT-like', NULL, NULL, NULL, 2),
(3918, NULL, 'cd12166', NULL, NULL, '2-Hacid_dh_7', NULL, '2-Hacid_dh_7', NULL, NULL, NULL, 2),
(3919, NULL, 'sd00017', NULL, NULL, 'ZF_C2H2', NULL, 'ZF_C2H2', NULL, NULL, NULL, 2),
(3920, NULL, 'cd11622', NULL, NULL, 'HR1_PKN_1', NULL, 'HR1_PKN_1', NULL, NULL, 27586, 2),
(3921, NULL, 'cd16567', NULL, NULL, 'RING-HC_RAD16_like', NULL, 'RING-HC_RAD16_like', NULL, NULL, NULL, 2),
(3922, NULL, 'cd00259', NULL, NULL, 'STNV', NULL, 'STNV', NULL, NULL, 2984, 2),
(3923, NULL, 'cd08914', NULL, NULL, 'START_STARD15-like', NULL, 'START_STARD15-like', NULL, NULL, NULL, 2),
(3924, NULL, 'cd09625', NULL, NULL, 'DOMON_like_cytochrome', NULL, 'DOMON_like_cytochrome', NULL, NULL, NULL, 2),
(3925, NULL, 'cd05082', NULL, NULL, 'PTKc_Csk', NULL, 'PTKc_Csk', NULL, NULL, NULL, 2),
(3926, NULL, 'cd05924', NULL, NULL, 'FACL_like_5', NULL, 'FACL_like_5', NULL, NULL, NULL, 2),
(3927, NULL, 'cd10345', NULL, NULL, 'SH2_C-SH2_Zap70_Syk_like', NULL, 'SH2_C-SH2_Zap70_Syk_like', NULL, NULL, NULL, 2);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(3928, NULL, 'cd09559', NULL, NULL, 'SAM_SASH1_repeat1', NULL, 'SAM_SASH1_repeat1', NULL, NULL, 32307, 2),
(3929, NULL, 'cd07599', NULL, NULL, 'BAR_Rvs167p', NULL, 'BAR_Rvs167p', NULL, NULL, NULL, 2),
(3930, NULL, 'cd10942', NULL, NULL, 'CE4_u11', NULL, 'CE4_u11', NULL, NULL, NULL, 2),
(3931, NULL, 'cd06974', NULL, NULL, 'TerD_like', NULL, 'TerD_like', NULL, NULL, 4284, 2),
(3932, NULL, 'cd21517', NULL, NULL, 'cv_beta_Nsp2_MERS-like', NULL, 'cv_beta_Nsp2_MERS-like', NULL, NULL, 35568, 2),
(3933, NULL, 'cd13325', NULL, NULL, 'PH_unc89', NULL, 'PH_unc89', NULL, NULL, NULL, 2),
(3934, NULL, 'cd01168', NULL, NULL, 'adenosine_kinase', NULL, 'adenosine_kinase', NULL, NULL, NULL, 2),
(3935, NULL, 'cd10394', NULL, NULL, 'SH2_RIN2', NULL, 'SH2_RIN2', NULL, NULL, 31518, 2),
(3936, NULL, 'cd17162', NULL, NULL, 'UBX_UBXN2C', NULL, 'UBX_UBXN2C', NULL, NULL, NULL, 2),
(3937, NULL, 'cd19139', NULL, NULL, 'AKR_AKR3F2', NULL, 'AKR_AKR3F2', NULL, NULL, NULL, 2),
(3938, NULL, 'cd12222', NULL, NULL, 'Caa3-IV', NULL, 'Caa3-IV', NULL, NULL, 31298, 2),
(3939, NULL, 'cd10406', NULL, NULL, 'SH2_Vav2', NULL, 'SH2_Vav2', NULL, NULL, 32530, 2),
(3940, NULL, 'cd00067', NULL, NULL, 'GAL4', NULL, 'GAL4', NULL, NULL, 2419, 2),
(3941, NULL, 'cd01794', NULL, NULL, 'Ubl_UBTD', NULL, 'Ubl_UBTD', NULL, NULL, NULL, 2),
(3942, NULL, 'cd04110', NULL, NULL, 'Rab35', NULL, 'Rab35', NULL, NULL, 30914, 2),
(3943, NULL, 'cd20374', NULL, NULL, 'Pot1C', NULL, 'Pot1C', NULL, NULL, NULL, 2),
(3944, NULL, 'cd06188', NULL, NULL, 'NADH_quinone_reductase', NULL, 'NADH_quinone_reductase', NULL, NULL, NULL, 2),
(3945, NULL, 'cd00769', NULL, NULL, 'PheRS_beta_core', NULL, 'PheRS_beta_core', NULL, NULL, 30822, 2),
(3946, NULL, 'cd09659', NULL, NULL, 'Cas4_I-A', NULL, 'Cas4_I-A', NULL, NULL, NULL, 2),
(3947, NULL, 'cd07144', NULL, NULL, 'ALDH_ALD2-YMR170C', NULL, 'ALDH_ALD2-YMR170C', NULL, NULL, NULL, 2),
(3948, NULL, 'cd11630', NULL, NULL, 'HR1_PKN1_2', NULL, 'HR1_PKN1_2', NULL, NULL, 31814, 2),
(3949, NULL, 'cd11639', NULL, NULL, 'HR1_ROCK1', NULL, 'HR1_ROCK1', NULL, NULL, 27693, 2),
(3950, NULL, 'cd00636', NULL, NULL, 'TroA-like', NULL, 'TroA-like', NULL, NULL, NULL, 2),
(3951, NULL, 'cd01386', NULL, NULL, 'MYSc_Myo18', NULL, 'MYSc_Myo18', NULL, NULL, 27908, 2),
(3952, NULL, 'cd05778', NULL, NULL, 'DNA_polB_zeta_exo', NULL, 'DNA_polB_zeta_exo', NULL, NULL, NULL, 2),
(3953, NULL, 'cd06656', NULL, NULL, 'STKc_PAK3', NULL, 'STKc_PAK3', NULL, NULL, 27969, 2),
(3954, NULL, 'cd06194', NULL, NULL, 'FNR_N-term_Iron_sulfur_binding', NULL, 'FNR_N-term_Iron_sulfur_binding', NULL, NULL, NULL, 2),
(3955, NULL, 'cd09683', NULL, NULL, 'Csm3_III-A', NULL, 'Csm3_III-A', NULL, NULL, NULL, 2),
(3956, NULL, 'cd18008', NULL, NULL, 'DEXDc_SHPRH-like', NULL, 'DEXDc_SHPRH-like', NULL, NULL, NULL, 2),
(3957, NULL, 'cd00098', NULL, NULL, 'IgC', NULL, 'IgC', NULL, NULL, NULL, 2),
(3958, NULL, 'cd13657', NULL, NULL, 'PBP2_Maltodextrin', NULL, 'PBP2_Maltodextrin', NULL, NULL, NULL, 2),
(3959, NULL, 'cd03710', NULL, NULL, 'BipA_TypA_C', NULL, 'BipA_TypA_C', NULL, NULL, 28848, 2),
(3960, NULL, 'cd20004', NULL, NULL, 'PBP1_ABC_sugar_binding-like', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, NULL, 2),
(3961, NULL, 'cd01031', NULL, NULL, 'EriC', NULL, 'EriC', NULL, NULL, NULL, 2),
(3962, NULL, 'cd07680', NULL, NULL, 'F-BAR_PACSIN1', NULL, 'F-BAR_PACSIN1', NULL, NULL, 28947, 2),
(3963, NULL, 'cd07816', NULL, NULL, 'Bet_v1-like', NULL, 'Bet_v1-like', NULL, NULL, NULL, 2),
(3964, NULL, 'cd13681', NULL, NULL, 'PBP2_TRAP_lactate', NULL, 'PBP2_TRAP_lactate', NULL, NULL, 29744, 2),
(3965, NULL, 'cd09084', NULL, NULL, 'EEP-2', NULL, 'EEP-2', NULL, NULL, NULL, 2),
(3966, NULL, 'cd18428', NULL, NULL, 'BTB_POZ_KCNS3', NULL, 'BTB_POZ_KCNS3', NULL, NULL, NULL, 2),
(3967, NULL, 'cd08925', NULL, NULL, 'Hb-beta-like', NULL, 'Hb-beta-like', NULL, NULL, 6461, 2),
(3968, NULL, 'cd01368', NULL, NULL, 'KISc_KIF23_like', NULL, 'KISc_KIF23_like', NULL, NULL, NULL, 2),
(3969, NULL, 'cd03699', NULL, NULL, 'EF4_II', NULL, 'EF4_II', NULL, NULL, NULL, 2),
(3970, NULL, 'cd03112', NULL, NULL, 'CobW-like', NULL, 'CobW-like', NULL, NULL, NULL, 2);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(3971, NULL, 'cd15695', NULL, NULL, 'ePHD1_KMT2D', NULL, 'ePHD1_KMT2D', NULL, NULL, 30402, 2),
(3972, NULL, 'cd08045', NULL, NULL, 'TAF4', NULL, 'TAF4', NULL, NULL, 3023, 2),
(3973, NULL, 'cd16559', NULL, NULL, 'RING-HC_RNF208', NULL, 'RING-HC_RNF208', NULL, NULL, 31763, 2),
(3974, NULL, 'cd16441', NULL, NULL, 'beta_Kdo_transferase_KpsS', NULL, 'beta_Kdo_transferase_KpsS', NULL, NULL, NULL, 2),
(3975, NULL, 'cd17239', NULL, NULL, 'FERM_F1_Ezrin', NULL, 'FERM_F1_Ezrin', NULL, NULL, NULL, 2),
(3976, NULL, 'cd05037', NULL, NULL, 'PTK_Jak_rpt1', NULL, 'PTK_Jak_rpt1', NULL, NULL, NULL, 2),
(3977, NULL, 'cd21528', NULL, NULL, 'CoV_Nsp14', NULL, 'CoV_Nsp14', NULL, NULL, NULL, 2),
(3978, NULL, 'cd15967', NULL, NULL, '7tmA_P2Y1-like', NULL, '7tmA_P2Y1-like', NULL, NULL, NULL, 2),
(3979, NULL, 'cd01026', NULL, NULL, 'TOPRIM_OLD', NULL, 'TOPRIM_OLD', NULL, NULL, 27320, 2),
(3980, NULL, 'cd12627', NULL, NULL, 'RRM1_IGF2BP3', NULL, 'RRM1_IGF2BP3', NULL, NULL, NULL, 2),
(3981, NULL, 'cd02664', NULL, NULL, 'Peptidase_C19H', NULL, 'Peptidase_C19H', NULL, NULL, 27792, 2),
(3982, NULL, 'cd05228', NULL, NULL, 'AR_FR_like_1_SDR_e', NULL, 'AR_FR_like_1_SDR_e', NULL, NULL, NULL, 2),
(3983, NULL, 'cd12306', NULL, NULL, 'RRM_II_PABPs', NULL, 'RRM_II_PABPs', NULL, NULL, NULL, 2),
(3984, NULL, 'cd15092', NULL, NULL, '7tmA_NOFQ_opioid_R', NULL, '7tmA_NOFQ_opioid_R', NULL, NULL, NULL, 2),
(3985, NULL, 'cd18473', NULL, NULL, 'BACK_KLHL34', NULL, 'BACK_KLHL34', NULL, NULL, NULL, 2),
(3986, NULL, 'cd06660', NULL, NULL, 'AKR_SF', NULL, 'AKR_SF', NULL, NULL, NULL, 2),
(3987, NULL, 'cd08688', NULL, NULL, 'C2_KIAA0528-like', NULL, 'C2_KIAA0528-like', NULL, NULL, 28338, 2),
(3988, NULL, 'cd15667', NULL, NULL, 'ePHD_Snt2p_like', NULL, 'ePHD_Snt2p_like', NULL, NULL, NULL, 2),
(3989, NULL, 'cd16653', NULL, NULL, 'RING-like_Rtf2', NULL, 'RING-like_Rtf2', NULL, NULL, 22752, 2),
(3990, NULL, 'cd13136', NULL, NULL, 'MATE_DinF_like', NULL, 'MATE_DinF_like', NULL, NULL, 35247, 2),
(3991, NULL, 'cd05820', NULL, NULL, 'CBM20_novamyl', NULL, 'CBM20_novamyl', NULL, NULL, 32364, 2),
(3992, NULL, 'cd00113', NULL, NULL, 'PLAT', NULL, 'PLAT', NULL, NULL, NULL, 2),
(3993, NULL, 'cd07933', NULL, NULL, 'RHD-n_c-Rel', NULL, 'RHD-n_c-Rel', NULL, NULL, 35067, 2),
(3994, NULL, 'cd01418', NULL, NULL, 'Ribosomal_L19e_A', NULL, 'Ribosomal_L19e_A', NULL, NULL, 30864, 2),
(3995, NULL, 'cd08778', NULL, NULL, 'Death_TNFRSF21', NULL, 'Death_TNFRSF21', NULL, NULL, 275, 2),
(3996, NULL, 'cd11848', NULL, NULL, 'SH3_SLAP-like', NULL, 'SH3_SLAP-like', NULL, NULL, NULL, 2),
(3997, NULL, 'cd21485', NULL, NULL, 'HCoV-OC43-like_Spike_S1_RBD', NULL, 'HCoV-OC43-like_Spike_S1_RBD', NULL, NULL, 36057, 2),
(3998, NULL, 'cd13176', NULL, NULL, 'RanBD_RanBP2-like', NULL, 'RanBD_RanBP2-like', NULL, NULL, NULL, 2),
(3999, NULL, 'cd15337', NULL, NULL, '7tmA_Opsin_Gq_invertebrates', NULL, '7tmA_Opsin_Gq_invertebrates', NULL, NULL, NULL, 2),
(4000, NULL, 'cd16691', NULL, NULL, 'mRING-H2-C3H3C2_Mio', NULL, 'mRING-H2-C3H3C2_Mio', NULL, NULL, 22575, 2),
(4001, NULL, 'cd06997', NULL, NULL, 'cupin_MelR-like_N', NULL, 'cupin_MelR-like_N', NULL, NULL, NULL, 2),
(4002, NULL, 'cd16370', NULL, NULL, 'DMSOR_beta_like', NULL, 'DMSOR_beta_like', NULL, NULL, NULL, 2),
(4003, NULL, 'cd19725', NULL, NULL, 'bHLH_TS_OLIG2_like', NULL, 'bHLH_TS_OLIG2_like', NULL, NULL, NULL, 2),
(4004, NULL, 'cd14122', NULL, NULL, 'STKc_VRK1', NULL, 'STKc_VRK1', NULL, NULL, NULL, 2),
(4005, NULL, 'cd19162', NULL, NULL, 'AKR_FDH', NULL, 'AKR_FDH', NULL, NULL, 34291, 2),
(4006, NULL, 'cd12588', NULL, NULL, 'RRM1_p54nrb', NULL, 'RRM1_p54nrb', NULL, NULL, 3830, 2),
(4007, NULL, 'cd13332', NULL, NULL, 'FERM_C_JAK1', NULL, 'FERM_C_JAK1', NULL, NULL, NULL, 2),
(4008, NULL, 'cd15204', NULL, NULL, '7tmA_prokineticin-R', NULL, '7tmA_prokineticin-R', NULL, NULL, NULL, 2),
(4009, NULL, 'cd00165', NULL, NULL, 'S4', NULL, 'S4', NULL, NULL, NULL, 2),
(4010, NULL, 'cd06419', NULL, NULL, 'GH25_muramidase_2', NULL, 'GH25_muramidase_2', NULL, NULL, NULL, 2),
(4011, NULL, 'cd10543', NULL, NULL, 'SET_EHMT', NULL, 'SET_EHMT', NULL, NULL, NULL, 2);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(4012, NULL, 'cd14046', NULL, NULL, 'STKc_EIF2AK4_GCN2_rpt2', NULL, 'STKc_EIF2AK4_GCN2_rpt2', NULL, NULL, NULL, 2),
(4013, NULL, 'cd17213', NULL, NULL, 'RA_PHLPP', NULL, 'RA_PHLPP', NULL, NULL, NULL, 2),
(4014, NULL, 'cd12045', NULL, NULL, 'SH3_SKAP2', NULL, 'SH3_SKAP2', NULL, NULL, NULL, 2),
(4015, NULL, 'cd16430', NULL, NULL, 'TraB', NULL, 'TraB', NULL, NULL, NULL, 2),
(4016, NULL, 'cd10468', NULL, NULL, 'Four-jointed-like_C', NULL, 'Four-jointed-like_C', NULL, NULL, NULL, 2),
(4017, NULL, 'cd13995', NULL, NULL, 'STKc_MAP3K8', NULL, 'STKc_MAP3K8', NULL, NULL, NULL, 2),
(4018, NULL, 'cd09692', NULL, NULL, 'Cas5_I-B', NULL, 'Cas5_I-B', NULL, NULL, NULL, 2),
(4019, NULL, 'cd14574', NULL, NULL, 'DUSP28', NULL, 'DUSP28', NULL, NULL, NULL, 2),
(4020, NULL, 'cd08155', NULL, NULL, 'catalase_clade_2', NULL, 'catalase_clade_2', NULL, NULL, NULL, 2),
(4021, NULL, 'cd00677', NULL, NULL, 'S15_NS1_EPRS_RNA-bind', NULL, 'S15_NS1_EPRS_RNA-bind', NULL, NULL, NULL, 2),
(4022, NULL, 'cd17234', NULL, NULL, 'Ubl_ATG8_MAP1LC3A', NULL, 'Ubl_ATG8_MAP1LC3A', NULL, NULL, NULL, 2),
(4023, NULL, 'cd19386', NULL, NULL, 'TGF_beta_TGFB3', NULL, 'TGF_beta_TGFB3', NULL, NULL, NULL, 2),
(4024, NULL, 'cd09636', NULL, NULL, 'Cas1_I-II-III', NULL, 'Cas1_I-II-III', NULL, NULL, NULL, 2),
(4025, NULL, 'cd02789', NULL, NULL, 'MopB_CT_FmdC-FwdD', NULL, 'MopB_CT_FmdC-FwdD', NULL, NULL, 30172, 2),
(4026, NULL, 'cd11313', NULL, NULL, 'AmyAc_arch_bac_AmyA', NULL, 'AmyAc_arch_bac_AmyA', NULL, NULL, NULL, 2),
(4027, NULL, 'cd19014', NULL, NULL, 'LGIC_ECD_nAChR_A1', NULL, 'LGIC_ECD_nAChR_A1', NULL, NULL, NULL, 2),
(4028, NULL, 'cd21409', NULL, NULL, '1B_cv_Nsp13-like', NULL, '1B_cv_Nsp13-like', NULL, NULL, 34868, 2),
(4029, NULL, 'cd08881', NULL, NULL, 'RHO_alpha_C_NDO-like', NULL, 'RHO_alpha_C_NDO-like', NULL, NULL, 34968, 2),
(4030, NULL, 'cd12170', NULL, NULL, '2-Hacid_dh_9', NULL, '2-Hacid_dh_9', NULL, NULL, NULL, 2),
(4031, NULL, 'cd00772', NULL, NULL, 'ProRS_core', NULL, 'ProRS_core', NULL, NULL, NULL, 2),
(4032, NULL, 'cd08073', NULL, NULL, 'MPN_NLPC_P60', NULL, 'MPN_NLPC_P60', NULL, NULL, NULL, 2),
(4033, NULL, 'cd07165', NULL, NULL, 'NR_DBD_DmE78_like', NULL, 'NR_DBD_DmE78_like', NULL, NULL, NULL, 2),
(4034, NULL, 'cd17529', NULL, NULL, 'HAMP_I', NULL, 'HAMP_I', NULL, NULL, NULL, 2),
(4035, NULL, 'cd00637', NULL, NULL, '7tm_classA_rhodopsin-like', NULL, '7tm_classA_rhodopsin-like', NULL, NULL, NULL, 2),
(4036, NULL, 'cd16929', NULL, NULL, 'HATPase_PDK-like', NULL, 'HATPase_PDK-like', NULL, NULL, NULL, 2),
(4037, NULL, 'cd03688', NULL, NULL, 'eIF2_gamma_II', NULL, 'eIF2_gamma_II', NULL, NULL, 35427, 2),
(4038, NULL, 'cd17913', NULL, NULL, 'DEXQc_Suv3', NULL, 'DEXQc_Suv3', NULL, NULL, 34591, 2),
(4039, NULL, 'cd00163', NULL, NULL, 'RNase_A', NULL, 'RNase_A', NULL, NULL, NULL, 2),
(4040, NULL, 'cd17466', NULL, NULL, 'T3SS_Flik_C_like', NULL, 'T3SS_Flik_C_like', NULL, NULL, NULL, 2),
(4041, NULL, 'cd00063', NULL, NULL, 'FN3', NULL, 'FN3', NULL, NULL, 7389, 2),
(4042, NULL, 'cd15097', NULL, NULL, '7tmA_Gal2_Gal3_R', NULL, '7tmA_Gal2_Gal3_R', NULL, NULL, NULL, 2),
(4043, NULL, 'cd17470', NULL, NULL, 'T3SS_Flik_C', NULL, 'T3SS_Flik_C', NULL, NULL, NULL, 2),
(4044, NULL, 'cd07218', NULL, NULL, 'Pat_iPLA2', NULL, 'Pat_iPLA2', NULL, NULL, NULL, 2),
(4045, NULL, 'cd08224', NULL, NULL, 'STKc_Nek6_7', NULL, 'STKc_Nek6_7', NULL, NULL, NULL, 2),
(4046, NULL, 'cd11515', NULL, NULL, 'SLC6sbd_NTT4-like', NULL, 'SLC6sbd_NTT4-like', NULL, NULL, NULL, 2),
(4047, NULL, 'cd17792', NULL, NULL, 'CtkA', NULL, 'CtkA', NULL, NULL, NULL, 2),
(4048, NULL, 'cd12618', NULL, NULL, 'RRM2_TIA1', NULL, 'RRM2_TIA1', NULL, NULL, 33247, 2),
(4049, NULL, 'cd04950', NULL, NULL, 'GT4_TuaH-like', NULL, 'GT4_TuaH-like', NULL, NULL, NULL, 2),
(4050, NULL, 'cd07146', NULL, NULL, 'ALDH_PhpJ', NULL, 'ALDH_PhpJ', NULL, NULL, 17124, 2),
(4051, NULL, 'cd03744', NULL, NULL, 'SOCS_SSB1', NULL, 'SOCS_SSB1', NULL, NULL, NULL, 2),
(4052, NULL, 'cd10315', NULL, NULL, 'CBM41_pullulanase', NULL, 'CBM41_pullulanase', NULL, NULL, 5524, 2),
(4053, NULL, 'cd12427', NULL, NULL, 'RRM4_hnRNPL_like', NULL, 'RRM4_hnRNPL_like', NULL, NULL, NULL, 2);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(4054, NULL, 'cd05368', NULL, NULL, 'DHRS6_like_SDR_c', NULL, 'DHRS6_like_SDR_c', NULL, NULL, NULL, 2),
(4055, NULL, 'cd12301', NULL, NULL, 'RRM1_2_PAR10_like', NULL, 'RRM1_2_PAR10_like', NULL, NULL, NULL, 2),
(4056, NULL, 'cd12200', NULL, NULL, 'AMPKA2_C', NULL, 'AMPKA2_C', NULL, NULL, 32852, 2),
(4057, NULL, 'cd04301', NULL, NULL, 'NAT_SF', NULL, 'NAT_SF', NULL, NULL, NULL, 2),
(4058, NULL, 'cd03334', NULL, NULL, 'Fab1_TCP', NULL, 'Fab1_TCP', NULL, NULL, NULL, 2),
(4059, NULL, 'cd06497', NULL, NULL, 'ACD_alphaA-crystallin_HspB4', NULL, 'ACD_alphaA-crystallin_HspB4', NULL, NULL, NULL, 2),
(4060, NULL, 'cd08697', NULL, NULL, 'C2_Dock-D', NULL, 'C2_Dock-D', NULL, NULL, 29708, 2),
(4061, NULL, 'cd11511', NULL, NULL, 'SLC6sbd_BGT1', NULL, 'SLC6sbd_BGT1', NULL, NULL, NULL, 2),
(4062, NULL, 'cd17335', NULL, NULL, 'MFS_MFSD6', NULL, 'MFS_MFSD6', NULL, NULL, NULL, 2),
(4063, NULL, 'cd06844', NULL, NULL, 'STAS', NULL, 'STAS', NULL, NULL, NULL, 2),
(4064, NULL, 'cd02957', NULL, NULL, 'Phd_like', NULL, 'Phd_like', NULL, NULL, NULL, 2),
(4065, NULL, 'cd00018', NULL, NULL, 'AP2', NULL, 'AP2', NULL, NULL, 3180, 2),
(4066, NULL, 'cd09097', NULL, NULL, 'Deadenylase_CCR4', NULL, 'Deadenylase_CCR4', NULL, NULL, NULL, 2),
(4067, NULL, 'cd19819', NULL, NULL, 'Bbox1_ZFYVE1_rpt1', NULL, 'Bbox1_ZFYVE1_rpt1', NULL, NULL, NULL, 2),
(4068, NULL, 'cd15716', NULL, NULL, 'FYVE_RBNS5', NULL, 'FYVE_RBNS5', NULL, NULL, NULL, 2),
(4069, NULL, 'cd08035', NULL, NULL, 'LARP_4', NULL, 'LARP_4', NULL, NULL, NULL, 2),
(4070, NULL, 'cd02992', NULL, NULL, 'PDI_a_QSOX', NULL, 'PDI_a_QSOX', NULL, NULL, NULL, 2),
(4071, NULL, 'cd10040', NULL, NULL, 'Reelin_repeat_4_subrepeat_1', NULL, 'Reelin_repeat_4_subrepeat_1', NULL, NULL, NULL, 2),
(4072, NULL, 'cd16843', NULL, NULL, 'Ig_LILR_KIR_like', NULL, 'Ig_LILR_KIR_like', NULL, NULL, NULL, 2),
(4073, NULL, 'cd05254', NULL, NULL, 'dTDP_HR_like_SDR_e', NULL, 'dTDP_HR_like_SDR_e', NULL, NULL, NULL, 2),
(4074, NULL, 'cd13292', NULL, NULL, 'PH_Osh1p_Osh2p_yeast', NULL, 'PH_Osh1p_Osh2p_yeast', NULL, NULL, NULL, 2),
(4075, NULL, 'cd13296', NULL, NULL, 'PH2_MyoX', NULL, 'PH2_MyoX', NULL, NULL, NULL, 2),
(4076, NULL, 'cd18363', NULL, NULL, 'BTB_POZ_KCTD3-like', NULL, 'BTB_POZ_KCTD3-like', NULL, NULL, NULL, 2),
(4077, NULL, 'cd01149', NULL, NULL, 'HutB', NULL, 'HutB', NULL, NULL, NULL, 2),
(4078, NULL, 'cd13634', NULL, NULL, 'PBP2_Sco4506', NULL, 'PBP2_Sco4506', NULL, NULL, NULL, 2),
(4079, NULL, 'cd17003', NULL, NULL, 'CID_Rtt103', NULL, 'CID_Rtt103', NULL, NULL, NULL, 2),
(4080, NULL, 'cd03138', NULL, NULL, 'GATase1_AraC_2', NULL, 'GATase1_AraC_2', NULL, NULL, NULL, 2),
(4081, NULL, 'cd07678', NULL, NULL, 'F-BAR_FCHSD1', NULL, 'F-BAR_FCHSD1', NULL, NULL, NULL, 2),
(4082, NULL, 'cd07994', NULL, NULL, 'WGR', NULL, 'WGR', NULL, NULL, NULL, 2),
(4083, NULL, 'cd19821', NULL, NULL, 'Bbox1_BBX-like', NULL, 'Bbox1_BBX-like', NULL, NULL, NULL, 2),
(4084, NULL, 'cd09490', NULL, NULL, 'SAM_Arap1,2,3', NULL, 'SAM_Arap1,2,3', NULL, NULL, NULL, 2),
(4085, NULL, 'cd07171', NULL, NULL, 'NR_DBD_ER', NULL, 'NR_DBD_ER', NULL, NULL, NULL, 2),
(4086, NULL, 'cd18003', NULL, NULL, 'DEXQc_SRCAP', NULL, 'DEXQc_SRCAP', NULL, NULL, NULL, 2),
(4087, NULL, 'cd18602', NULL, NULL, 'ABC_6TM_SUR1_D2_like', NULL, 'ABC_6TM_SUR1_D2_like', NULL, NULL, NULL, 2),
(4088, NULL, 'cd00412', NULL, NULL, 'pyrophosphatase', NULL, 'pyrophosphatase', NULL, NULL, 7463, 2),
(4089, NULL, 'cd17270', NULL, NULL, 'RMtype1_S_Sba223ORF3470P-TRD1-CR1_like', NULL, 'RMtype1_S_Sba223ORF3470P-TRD1-CR1_like', NULL, NULL, NULL, 2),
(4090, NULL, 'cd05580', NULL, NULL, 'STKc_PKA_like', NULL, 'STKc_PKA_like', NULL, NULL, NULL, 2),
(4091, NULL, 'cd19363', NULL, NULL, 'TenA_C_PH1161-like', NULL, 'TenA_C_PH1161-like', NULL, NULL, NULL, 2),
(4092, NULL, 'cd09262', NULL, NULL, 'AP_stonin-1_MHD', NULL, 'AP_stonin-1_MHD', NULL, NULL, NULL, 2),
(4093, NULL, 'cd03783', NULL, NULL, 'MATH_Meprin_Alpha', NULL, 'MATH_Meprin_Alpha', NULL, NULL, NULL, 2),
(4094, NULL, 'cd12740', NULL, NULL, 'RRM2_ESRP2', NULL, 'RRM2_ESRP2', NULL, NULL, NULL, 2),
(4095, NULL, 'cd11825', NULL, NULL, 'SH3_PLCgamma', NULL, 'SH3_PLCgamma', NULL, NULL, NULL, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(4096, NULL, 'cd09585', NULL, NULL, 'SAM_DDHD2', NULL, 'SAM_DDHD2', NULL, NULL, NULL, 2),
(4097, NULL, 'cd18197', NULL, NULL, 'BTB_POZ_ZBTB6', NULL, 'BTB_POZ_ZBTB6', NULL, NULL, NULL, 2),
(4098, NULL, 'cd15042', NULL, NULL, '7tmC_Boss', NULL, '7tmC_Boss', NULL, NULL, NULL, 2),
(4099, NULL, 'cd01920', NULL, NULL, 'cyclophilin_EcCYP_like', NULL, 'cyclophilin_EcCYP_like', NULL, NULL, NULL, 2),
(4100, NULL, 'cd06386', NULL, NULL, 'PBP1_NPR_C', NULL, 'PBP1_NPR_C', NULL, NULL, NULL, 2),
(4101, NULL, 'cd14947', NULL, NULL, 'NBR1_like', NULL, 'NBR1_like', NULL, NULL, 24171, 2),
(4102, NULL, 'cd19056', NULL, NULL, 'LGIC_TM_GABAAR_theta', NULL, 'LGIC_TM_GABAAR_theta', NULL, NULL, NULL, 2),
(4103, NULL, 'cd04170', NULL, NULL, 'EF-G_bact', NULL, 'EF-G_bact', NULL, NULL, NULL, 2),
(4104, NULL, 'cd04447', NULL, NULL, 'DEP_BRCC3', NULL, 'DEP_BRCC3', NULL, NULL, NULL, 2),
(4105, NULL, 'cd12177', NULL, NULL, '2-Hacid_dh_12', NULL, '2-Hacid_dh_12', NULL, NULL, NULL, 2),
(4106, NULL, 'cd07997', NULL, NULL, 'WGR_PARP', NULL, 'WGR_PARP', NULL, NULL, NULL, 2),
(4107, NULL, 'cd01883', NULL, NULL, 'EF1_alpha', NULL, 'EF1_alpha', NULL, NULL, NULL, 2),
(4108, NULL, 'cd10277', NULL, NULL, 'PQQ_ADH_I', NULL, 'PQQ_ADH_I', NULL, NULL, 28850, 2),
(4109, NULL, 'cd04935', NULL, NULL, 'ACT_AKiii-DAPDC_1', NULL, 'ACT_AKiii-DAPDC_1', NULL, NULL, NULL, 2),
(4110, NULL, 'cd03331', NULL, NULL, 'Macro_Poa1p-like_SNF2', NULL, 'Macro_Poa1p-like_SNF2', NULL, NULL, NULL, 2),
(4111, NULL, 'cd07361', NULL, NULL, 'MEMO_like', NULL, 'MEMO_like', NULL, NULL, 3653, 2),
(4112, NULL, 'cd08643', NULL, NULL, 'DNA_pol_A_pol_I_B', NULL, 'DNA_pol_A_pol_I_B', NULL, NULL, NULL, 2),
(4113, NULL, 'cd01781', NULL, NULL, 'RA2_Afadin', NULL, 'RA2_Afadin', NULL, NULL, NULL, 2),
(4114, NULL, 'cd15464', NULL, NULL, 'HN_like', NULL, 'HN_like', NULL, NULL, NULL, 2),
(4115, NULL, 'cd03167', NULL, NULL, 'oculospanin_like_LEL', NULL, 'oculospanin_like_LEL', NULL, NULL, NULL, 2),
(4116, NULL, 'cd17789', NULL, NULL, 'CBS_pair_plant_CBSX', NULL, 'CBS_pair_plant_CBSX', NULL, NULL, NULL, 2),
(4117, NULL, 'cd17491', NULL, NULL, 'MFS_MFSD12', NULL, 'MFS_MFSD12', NULL, NULL, NULL, 2),
(4118, NULL, 'cd03356', NULL, NULL, 'LbH_G1P_AT_C_like', NULL, 'LbH_G1P_AT_C_like', NULL, NULL, NULL, 2),
(4119, NULL, 'cd04762', NULL, NULL, 'HTH_MerR-trunc', NULL, 'HTH_MerR-trunc', NULL, NULL, NULL, 2),
(4120, NULL, 'cd13946', NULL, NULL, 'LysW', NULL, 'LysW', NULL, NULL, 436, 2),
(4121, NULL, 'cd14545', NULL, NULL, 'PTPc-N1_2', NULL, 'PTPc-N1_2', NULL, NULL, NULL, 2),
(4122, NULL, 'cd14061', NULL, NULL, 'STKc_MLK', NULL, 'STKc_MLK', NULL, NULL, NULL, 2),
(4123, NULL, 'cd07722', NULL, NULL, 'LACTB2-like_MBL-fold', NULL, 'LACTB2-like_MBL-fold', NULL, NULL, NULL, 2),
(4124, NULL, 'cd16536', NULL, NULL, 'RING-HC_RNF10', NULL, 'RING-HC_RNF10', NULL, NULL, NULL, 2),
(4125, NULL, 'cd18921', NULL, NULL, 'bHLHzip_SREBP1', NULL, 'bHLHzip_SREBP1', NULL, NULL, NULL, 2),
(4126, NULL, 'cd04597', NULL, NULL, 'CBS_pair_inorgPPase', NULL, 'CBS_pair_inorgPPase', NULL, NULL, NULL, 2),
(4127, NULL, 'cd14200', NULL, NULL, 'STKc_CaMKK1', NULL, 'STKc_CaMKK1', NULL, NULL, NULL, 2),
(4128, NULL, 'cd14232', NULL, NULL, 'GAT_LSB5', NULL, 'GAT_LSB5', NULL, NULL, 35014, 2),
(4129, NULL, 'cd08475', NULL, NULL, 'PBP2_CrgA_like_6', NULL, 'PBP2_CrgA_like_6', NULL, NULL, NULL, 2),
(4130, NULL, 'cd08817', NULL, NULL, 'CARD_RIG-I_r2', NULL, 'CARD_RIG-I_r2', NULL, NULL, 33558, 2),
(4131, NULL, 'cd09883', NULL, NULL, 'PIN_VapC_PhoHL-ATPase', NULL, 'PIN_VapC_PhoHL-ATPase', NULL, NULL, NULL, 2),
(4132, NULL, 'cd03312', NULL, NULL, 'CIMS_N_terminal_like', NULL, 'CIMS_N_terminal_like', NULL, NULL, NULL, 2),
(4133, NULL, 'cd19614', NULL, NULL, 'FABP_Der_p_13-like', NULL, 'FABP_Der_p_13-like', NULL, NULL, NULL, 2),
(4134, NULL, 'cd14747', NULL, NULL, 'PBP2_MalE', NULL, 'PBP2_MalE', NULL, NULL, NULL, 2),
(4135, NULL, 'cd01858', NULL, NULL, 'NGP_1', NULL, 'NGP_1', NULL, NULL, NULL, 2),
(4136, NULL, 'cd05047', NULL, NULL, 'PTKc_Tie', NULL, 'PTKc_Tie', NULL, NULL, NULL, 2),
(4137, NULL, 'cd07988', NULL, NULL, 'LPLAT_ABO13168-like', NULL, 'LPLAT_ABO13168-like', NULL, NULL, NULL, 2);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(4138, NULL, 'cd10148', NULL, NULL, 'CsoR-like_DUF156', NULL, 'CsoR-like_DUF156', NULL, NULL, NULL, 2),
(4139, NULL, 'cd16844', NULL, NULL, 'ParB_N_like_MT', NULL, 'ParB_N_like_MT', NULL, NULL, NULL, 2),
(4140, NULL, 'cd04589', NULL, NULL, 'CBS_pair_CAP-ED_NT_Pol-beta-like_DUF294_assoc', NULL, 'CBS_pair_CAP-ED_NT_Pol-beta-like_DUF294_assoc', NULL, NULL, NULL, 2),
(4141, NULL, 'cd03130', NULL, NULL, 'GATase1_CobB', NULL, 'GATase1_CobB', NULL, NULL, NULL, 2),
(4142, NULL, 'cd04142', NULL, NULL, 'RRP22', NULL, 'RRP22', NULL, NULL, NULL, 2),
(4143, NULL, 'cd12252', NULL, NULL, 'RRM_DbpA', NULL, 'RRM_DbpA', NULL, NULL, NULL, 2),
(4144, NULL, 'cd14832', NULL, NULL, 'AP4_sigma', NULL, 'AP4_sigma', NULL, NULL, NULL, 2),
(4145, NULL, 'cd18173', NULL, NULL, 'M14_CP_bacteria', NULL, 'M14_CP_bacteria', NULL, NULL, NULL, 2),
(4146, NULL, 'cd15178', NULL, NULL, '7tmA_CXCR1_2', NULL, '7tmA_CXCR1_2', NULL, NULL, NULL, 2),
(4147, NULL, 'cd08431', NULL, NULL, 'PBP2_HupR', NULL, 'PBP2_HupR', NULL, NULL, NULL, 2),
(4148, NULL, 'cd08700', NULL, NULL, 'FMT_C_OzmH_like', NULL, 'FMT_C_OzmH_like', NULL, NULL, NULL, 2),
(4149, NULL, 'cd12691', NULL, NULL, 'RRM2_PTBPH1_PTBPH2', NULL, 'RRM2_PTBPH1_PTBPH2', NULL, NULL, 32230, 2),
(4150, NULL, 'cd07955', NULL, NULL, 'Anticodon_Ia_Cys_like', NULL, 'Anticodon_Ia_Cys_like', NULL, NULL, NULL, 2),
(4151, NULL, 'cd03795', NULL, NULL, 'GT4_WfcD-like', NULL, 'GT4_WfcD-like', NULL, NULL, NULL, 2),
(4152, NULL, 'cd02794', NULL, NULL, 'MopB_CT_DmsA-EC', NULL, 'MopB_CT_DmsA-EC', NULL, NULL, NULL, 2),
(4153, NULL, 'cd13869', NULL, NULL, 'CuRO_2_PHS', NULL, 'CuRO_2_PHS', NULL, NULL, NULL, 2),
(4154, NULL, 'cd14355', NULL, NULL, 'UBA_UBP28', NULL, 'UBA_UBP28', NULL, NULL, NULL, 2),
(4155, NULL, 'cd06177', NULL, NULL, 'MFS_NHS', NULL, 'MFS_NHS', NULL, NULL, NULL, 2),
(4156, NULL, 'cd04456', NULL, NULL, 'S1_IF1A_like', NULL, 'S1_IF1A_like', NULL, NULL, NULL, 2),
(4157, NULL, 'cd11008', NULL, NULL, 'M35_deuterolysin_like', NULL, 'M35_deuterolysin_like', NULL, NULL, NULL, 2),
(4158, NULL, 'cd09239', NULL, NULL, 'BRO1_HD-PTP_like', NULL, 'BRO1_HD-PTP_like', NULL, NULL, NULL, 2),
(4159, NULL, 'cd08898', NULL, NULL, 'SRPBCC_CalC_Aha1-like_5', NULL, 'SRPBCC_CalC_Aha1-like_5', NULL, NULL, NULL, 2),
(4160, NULL, 'cd18291', NULL, NULL, 'BTB_POZ_BTBD16', NULL, 'BTB_POZ_BTBD16', NULL, NULL, NULL, 2),
(4161, NULL, 'cd00413', NULL, NULL, 'Glyco_hydrolase_16', NULL, 'Glyco_hydrolase_16', NULL, NULL, NULL, 2),
(4162, NULL, 'cd04198', NULL, NULL, 'eIF-2B_gamma_N', NULL, 'eIF-2B_gamma_N', NULL, NULL, NULL, 2),
(4163, NULL, 'cd03755', NULL, NULL, 'proteasome_alpha_type_7', NULL, 'proteasome_alpha_type_7', NULL, NULL, NULL, 2),
(4164, NULL, 'cd11443', NULL, NULL, 'bHLH_AtAMS_like', NULL, 'bHLH_AtAMS_like', NULL, NULL, NULL, 2),
(4165, NULL, 'cd19759', NULL, NULL, 'Bbox2_TRIM2-like', NULL, 'Bbox2_TRIM2-like', NULL, NULL, NULL, 2),
(4166, NULL, 'cd04217', NULL, NULL, 'Cupredoxin_Fibrocystin-L_like', NULL, 'Cupredoxin_Fibrocystin-L_like', NULL, NULL, NULL, 2),
(4167, NULL, 'cd10506', NULL, NULL, 'RNAP_IV_RPD1_N', NULL, 'RNAP_IV_RPD1_N', NULL, NULL, 27758, 2),
(4168, NULL, 'cd14032', NULL, NULL, 'STKc_WNK2_like', NULL, 'STKc_WNK2_like', NULL, NULL, NULL, 2),
(4169, NULL, 'cd01936', NULL, NULL, 'Ntn_CA', NULL, 'Ntn_CA', NULL, NULL, NULL, 2),
(4170, NULL, 'cd02199', NULL, NULL, 'YjgF_YER057c_UK114_like_1', NULL, 'YjgF_YER057c_UK114_like_1', NULL, NULL, 7917, 2),
(4171, NULL, 'cd11508', NULL, NULL, 'SLC6sbd_GAT3', NULL, 'SLC6sbd_GAT3', NULL, NULL, 7035, 2),
(4172, NULL, 'cd06618', NULL, NULL, 'PKc_MKK7', NULL, 'PKc_MKK7', NULL, NULL, NULL, 2),
(4173, NULL, 'cd16615', NULL, NULL, 'RING-HC_ZNF598', NULL, 'RING-HC_ZNF598', NULL, NULL, 30346, 2),
(4174, NULL, 'cd04365', NULL, NULL, 'IlGF_relaxin_like', NULL, 'IlGF_relaxin_like', NULL, NULL, NULL, 2),
(4175, NULL, 'cd12038', NULL, NULL, 'SH3_MPP6', NULL, 'SH3_MPP6', NULL, NULL, 28481, 2),
(4176, NULL, 'cd00379', NULL, NULL, 'Ribosomal_L10_P0', NULL, 'Ribosomal_L10_P0', NULL, NULL, NULL, 2),
(4177, NULL, 'cd07593', NULL, NULL, 'BAR_MUG137_fungi', NULL, 'BAR_MUG137_fungi', NULL, NULL, NULL, 2);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(4178, NULL, 'cd07368', NULL, NULL, 'PhnC_Bs_like', NULL, 'PhnC_Bs_like', NULL, NULL, 30232, 2),
(4179, NULL, 'cd04714', NULL, NULL, 'BAH_BAHCC1', NULL, 'BAH_BAHCC1', NULL, NULL, NULL, 2),
(4180, NULL, 'cd05756', NULL, NULL, 'Ig1_IL1R_like', NULL, 'Ig1_IL1R_like', NULL, NULL, NULL, 2),
(4181, NULL, 'cd16661', NULL, NULL, 'RING-Ubox1_NOSIP', NULL, 'RING-Ubox1_NOSIP', NULL, NULL, NULL, 2),
(4182, NULL, 'cd07371', NULL, NULL, '2A5CPDO_AB', NULL, '2A5CPDO_AB', NULL, NULL, NULL, 2),
(4183, NULL, 'cd07009', NULL, NULL, 'cupin_BLL0285-like', NULL, 'cupin_BLL0285-like', NULL, NULL, NULL, 2),
(4184, NULL, 'cd17777', NULL, NULL, 'CBS_arch_repeat1', NULL, 'CBS_arch_repeat1', NULL, NULL, NULL, 2),
(4185, NULL, 'cd19769', NULL, NULL, 'Bbox2_TRIM16-like', NULL, 'Bbox2_TRIM16-like', NULL, NULL, NULL, 2),
(4186, NULL, 'cd21685', NULL, NULL, 'ORF7a_SARS-CoV-like', NULL, 'ORF7a_SARS-CoV-like', NULL, NULL, NULL, 2),
(4187, NULL, 'cd03083', NULL, NULL, 'TRX_Fd_NuoE_hoxF', NULL, 'TRX_Fd_NuoE_hoxF', NULL, NULL, NULL, 2),
(4188, NULL, 'cd13341', NULL, NULL, 'PH-GRAM_MTMR3', NULL, 'PH-GRAM_MTMR3', NULL, NULL, 31868, 2),
(4189, NULL, 'cd12687', NULL, NULL, 'RRM1_PTBPH3', NULL, 'RRM1_PTBPH3', NULL, NULL, 32187, 2),
(4190, NULL, 'cd17390', NULL, NULL, 'MFS_MFSD9', NULL, 'MFS_MFSD9', NULL, NULL, NULL, 2),
(4191, NULL, 'cd11674', NULL, NULL, 'lambda-1', NULL, 'lambda-1', NULL, NULL, NULL, 2),
(4192, NULL, 'cd00860', NULL, NULL, 'ThrRS_anticodon', NULL, 'ThrRS_anticodon', NULL, NULL, NULL, 2),
(4193, NULL, 'cd16677', NULL, NULL, 'RING1-H2_RNF32', NULL, 'RING1-H2_RNF32', NULL, NULL, NULL, 2),
(4194, NULL, 'cd16335', NULL, NULL, 'MukF_N', NULL, 'MukF_N', NULL, NULL, NULL, 2),
(4195, NULL, 'cd08434', NULL, NULL, 'PBP2_GltC_like', NULL, 'PBP2_GltC_like', NULL, NULL, NULL, 2),
(4196, NULL, 'cd17563', NULL, NULL, 'REC_RegA-like', NULL, 'REC_RegA-like', NULL, NULL, NULL, 2),
(4197, NULL, 'cd10365', NULL, NULL, 'SH2_Src_Src', NULL, 'SH2_Src_Src', NULL, NULL, NULL, 2),
(4198, NULL, 'cd16293', NULL, NULL, 'CPSF2-like_MBL-fold', NULL, 'CPSF2-like_MBL-fold', NULL, NULL, 32020, 2),
(4199, NULL, 'cd15165', NULL, NULL, '7tmA_GPR55-like', NULL, '7tmA_GPR55-like', NULL, NULL, NULL, 2),
(4200, NULL, 'cd13692', NULL, NULL, 'PBP2_BztA', NULL, 'PBP2_BztA', NULL, NULL, NULL, 2),
(4201, NULL, 'cd02954', NULL, NULL, 'DIM1', NULL, 'DIM1', NULL, NULL, 1589, 2),
(4202, NULL, 'cd05967', NULL, NULL, 'PrpE', NULL, 'PrpE', NULL, NULL, NULL, 2),
(4203, NULL, 'cd17072', NULL, NULL, 'DCX_DCDC5_like', NULL, 'DCX_DCDC5_like', NULL, NULL, NULL, 2),
(4204, NULL, 'cd14160', NULL, NULL, 'PK_IRAK3', NULL, 'PK_IRAK3', NULL, NULL, 35900, 2),
(4205, NULL, 'cd16495', NULL, NULL, 'RING_CH-C4HC3_MARCH', NULL, 'RING_CH-C4HC3_MARCH', NULL, NULL, NULL, 2),
(4206, NULL, 'cd04236', NULL, NULL, 'AAK_NAGS-Urea', NULL, 'AAK_NAGS-Urea', NULL, NULL, NULL, 2),
(4207, NULL, 'cd11802', NULL, NULL, 'SH3_Endophilin_B', NULL, 'SH3_Endophilin_B', NULL, NULL, NULL, 2),
(4208, NULL, 'cd00158', NULL, NULL, 'RHOD', NULL, 'RHOD', NULL, NULL, NULL, 2),
(4209, NULL, 'cd18493', NULL, NULL, 'BACK_BTBD17', NULL, 'BACK_BTBD17', NULL, NULL, NULL, 2),
(4210, NULL, 'cd14168', NULL, NULL, 'STKc_CaMKI_delta', NULL, 'STKc_CaMKI_delta', NULL, NULL, NULL, 2),
(4211, NULL, 'cd07819', NULL, NULL, 'SRPBCC_2', NULL, 'SRPBCC_2', NULL, NULL, NULL, 2),
(4212, NULL, 'cd17447', NULL, NULL, 'MFS_SLC22A7_OAT2', NULL, 'MFS_SLC22A7_OAT2', NULL, NULL, NULL, 2),
(4213, NULL, 'cd21508', NULL, NULL, 'HEV_Spike_S1_RBD', NULL, 'HEV_Spike_S1_RBD', NULL, NULL, 33848, 2),
(4214, NULL, 'cd06379', NULL, NULL, 'PBP1_iGluR_NMDA_NR1', NULL, 'PBP1_iGluR_NMDA_NR1', NULL, NULL, NULL, 2),
(4215, NULL, 'cd12738', NULL, NULL, 'RRM1_Fusilli', NULL, 'RRM1_Fusilli', NULL, NULL, NULL, 2),
(4216, NULL, 'cd05776', NULL, NULL, 'DNA_polB_alpha_exo', NULL, 'DNA_polB_alpha_exo', NULL, NULL, NULL, 2),
(4217, NULL, 'cd19549', NULL, NULL, 'serpinA_A1AT-like', NULL, 'serpinA_A1AT-like', NULL, NULL, NULL, 2),
(4218, NULL, 'cd00731', NULL, NULL, 'CheA_reg', NULL, 'CheA_reg', NULL, NULL, NULL, 2),
(4219, NULL, 'cd11304', NULL, NULL, 'Cadherin_repeat', NULL, 'Cadherin_repeat', NULL, NULL, NULL, 2);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(4220, NULL, 'cd11401', NULL, NULL, 'bHLHzip_Mad', NULL, 'bHLHzip_Mad', NULL, NULL, NULL, 2),
(4221, NULL, 'cd20608', NULL, NULL, 'nitroreductase', NULL, 'nitroreductase', NULL, NULL, NULL, 2),
(4222, NULL, 'cd07303', NULL, NULL, 'Porin3', NULL, 'Porin3', NULL, NULL, NULL, 2),
(4223, NULL, 'sd00029', NULL, NULL, 'zf-RanBP2', NULL, 'zf-RanBP2', NULL, NULL, NULL, 2),
(4224, NULL, 'cd00635', NULL, NULL, 'PLPDE_III_YBL036c_like', NULL, 'PLPDE_III_YBL036c_like', NULL, NULL, NULL, 2),
(4225, NULL, 'cd04111', NULL, NULL, 'Rab39', NULL, 'Rab39', NULL, NULL, 30110, 2),
(4226, NULL, 'cd07770', NULL, NULL, 'FGGY_GntK', NULL, 'FGGY_GntK', NULL, NULL, NULL, 2),
(4227, NULL, 'cd08297', NULL, NULL, 'CAD3', NULL, 'CAD3', NULL, NULL, NULL, 2),
(4228, NULL, 'cd13750', NULL, NULL, 'TGF_beta_GDNF_like', NULL, 'TGF_beta_GDNF_like', NULL, NULL, NULL, 2),
(4229, NULL, 'cd03339', NULL, NULL, 'TCP1_epsilon', NULL, 'TCP1_epsilon', NULL, NULL, 11564, 2),
(4230, NULL, 'cd07132', NULL, NULL, 'ALDH_F3AB', NULL, 'ALDH_F3AB', NULL, NULL, NULL, 2),
(4231, NULL, 'cd04665', NULL, NULL, 'Nudix_Hydrolase_8', NULL, 'Nudix_Hydrolase_8', NULL, NULL, 13097, 2),
(4232, NULL, 'cd08543', NULL, NULL, 'SAM_PNT-ETS-2', NULL, 'SAM_PNT-ETS-2', NULL, NULL, NULL, 2),
(4233, NULL, 'cd16770', NULL, NULL, 'RING-HC_UHRF2', NULL, 'RING-HC_UHRF2', NULL, NULL, NULL, 2),
(4234, NULL, 'cd11287', NULL, NULL, 'Sec23_C', NULL, 'Sec23_C', NULL, NULL, 32995, 2),
(4235, NULL, 'cd00513', NULL, NULL, 'Ribosomal_L32_L32e', NULL, 'Ribosomal_L32_L32e', NULL, NULL, 6254, 2),
(4236, NULL, 'cd05600', NULL, NULL, 'STKc_Sid2p_like', NULL, 'STKc_Sid2p_like', NULL, NULL, NULL, 2),
(4237, NULL, 'cd03087', NULL, NULL, 'PGM_like1', NULL, 'PGM_like1', NULL, NULL, 12002, 2),
(4238, NULL, 'cd08388', NULL, NULL, 'C2A_Synaptotagmin-4-11', NULL, 'C2A_Synaptotagmin-4-11', NULL, NULL, NULL, 2),
(4239, NULL, 'cd17172', NULL, NULL, 'FERM_F0_TLN2', NULL, 'FERM_F0_TLN2', NULL, NULL, NULL, 2),
(4240, NULL, 'cd13893', NULL, NULL, 'CuRO_3_AAO', NULL, 'CuRO_3_AAO', NULL, NULL, 23529, 2),
(4241, NULL, 'cd14101', NULL, NULL, 'STKc_PIM2', NULL, 'STKc_PIM2', NULL, NULL, NULL, 2),
(4242, NULL, 'cd18974', NULL, NULL, 'CD_POL_like', NULL, 'CD_POL_like', NULL, NULL, NULL, 2),
(4243, NULL, 'cd19010', NULL, NULL, 'LGIC_ECD_GlyR_beta', NULL, 'LGIC_ECD_GlyR_beta', NULL, NULL, NULL, 2),
(4244, NULL, 'cd10303', NULL, NULL, 'GST_C_GDAP1', NULL, 'GST_C_GDAP1', NULL, NULL, NULL, 2),
(4245, NULL, 'cd00317', NULL, NULL, 'cyclophilin', NULL, 'cyclophilin', NULL, NULL, NULL, 2),
(4246, NULL, 'cd19215', NULL, NULL, 'PR-SET_ZFPM1', NULL, 'PR-SET_ZFPM1', NULL, NULL, NULL, 2),
(4247, NULL, 'cd12649', NULL, NULL, 'RRM1_SXL', NULL, 'RRM1_SXL', NULL, NULL, NULL, 2),
(4248, NULL, 'cd13855', NULL, NULL, 'CuRO_1_McoC_like', NULL, 'CuRO_1_McoC_like', NULL, NULL, NULL, 2),
(4249, NULL, 'cd18777', NULL, NULL, 'PsaA_MyfA', NULL, 'PsaA_MyfA', NULL, NULL, NULL, 2),
(4250, NULL, 'cd11871', NULL, NULL, 'SH3_p67phox_N', NULL, 'SH3_p67phox_N', NULL, NULL, 29363, 2),
(4251, NULL, 'cd15658', NULL, NULL, 'PHD4_NSD3', NULL, 'PHD4_NSD3', NULL, NULL, NULL, 2),
(4252, NULL, 'cd11621', NULL, NULL, 'HR1_PKC-like_1_fungi', NULL, 'HR1_PKC-like_1_fungi', NULL, NULL, NULL, 2),
(4253, NULL, 'cd08071', NULL, NULL, 'MPN_DUF2466', NULL, 'MPN_DUF2466', NULL, NULL, 23757, 2),
(4254, NULL, 'cd12432', NULL, NULL, 'RRM_ACINU', NULL, 'RRM_ACINU', NULL, NULL, 31851, 2),
(4255, NULL, 'cd06864', NULL, NULL, 'PX_SNX4', NULL, 'PX_SNX4', NULL, NULL, 31008, 2),
(4256, NULL, 'cd07923', NULL, NULL, 'Gallate_dioxygenase_C', NULL, 'Gallate_dioxygenase_C', NULL, NULL, 11904, 2),
(4257, NULL, 'cd17972', NULL, NULL, 'DEXHc_DHX9', NULL, 'DEXHc_DHX9', NULL, NULL, 37771, 2),
(4258, NULL, 'cd03704', NULL, NULL, 'eRF3_C_III', NULL, 'eRF3_C_III', NULL, NULL, NULL, 2),
(4259, NULL, 'cd19839', NULL, NULL, 'Bbox1_TRIM16', NULL, 'Bbox1_TRIM16', NULL, NULL, NULL, 2),
(4260, NULL, 'cd03467', NULL, NULL, 'Rieske', NULL, 'Rieske', NULL, NULL, NULL, 2),
(4261, NULL, 'cd04921', NULL, NULL, 'ACT_AKi-HSDH-ThrA-like_1', NULL, 'ACT_AKi-HSDH-ThrA-like_1', NULL, NULL, NULL, 2);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(4262, NULL, 'cd05388', NULL, NULL, 'CobB_N', NULL, 'CobB_N', NULL, NULL, NULL, 2),
(4263, NULL, 'cd17225', NULL, NULL, 'RA_ASPP2', NULL, 'RA_ASPP2', NULL, NULL, NULL, 2),
(4264, NULL, 'cd09376', NULL, NULL, 'LIM2_Lhx3_Lhx4', NULL, 'LIM2_Lhx3_Lhx4', NULL, NULL, NULL, 2),
(4265, NULL, 'cd14176', NULL, NULL, 'STKc_RSK2_C', NULL, 'STKc_RSK2_C', NULL, NULL, 30067, 2),
(4266, NULL, 'cd15990', NULL, NULL, '7tmB2_BAI1', NULL, '7tmB2_BAI1', NULL, NULL, NULL, 2),
(4267, NULL, 'cd07332', NULL, NULL, 'M48C_Oma1_like', NULL, 'M48C_Oma1_like', NULL, NULL, NULL, 2),
(4268, NULL, 'cd15852', NULL, NULL, 'SNARE_Syntaxin8', NULL, 'SNARE_Syntaxin8', NULL, NULL, 30842, 2),
(4269, NULL, 'cd03228', NULL, NULL, 'ABCC_MRP_Like', NULL, 'ABCC_MRP_Like', NULL, NULL, NULL, 2),
(4270, NULL, 'cd18927', NULL, NULL, 'bHLHzip_TFEB', NULL, 'bHLHzip_TFEB', NULL, NULL, NULL, 2),
(4271, NULL, 'cd14502', NULL, NULL, 'RNA_5''-triphosphatase', NULL, 'RNA_5''-triphosphatase', NULL, NULL, NULL, 2),
(4272, NULL, 'cd01751', NULL, NULL, 'PLAT_LH2', NULL, 'PLAT_LH2', NULL, NULL, 30312, 2),
(4273, NULL, 'cd00991', NULL, NULL, 'PDZ_archaeal_metalloprotease', NULL, 'PDZ_archaeal_metalloprotease', NULL, NULL, NULL, 2),
(4274, NULL, 'cd16077', NULL, NULL, 'TSP-5cc', NULL, 'TSP-5cc', NULL, NULL, 32986, 2),
(4275, NULL, 'cd12070', NULL, NULL, 'SH3_ARHGAP12', NULL, 'SH3_ARHGAP12', NULL, NULL, 16627, 2),
(4276, NULL, 'cd03244', NULL, NULL, 'ABCC_MRP_domain2', NULL, 'ABCC_MRP_domain2', NULL, NULL, NULL, 2),
(4277, NULL, 'cd06361', NULL, NULL, 'PBP1_GPC6A-like', NULL, 'PBP1_GPC6A-like', NULL, NULL, NULL, 2),
(4278, NULL, 'cd00939', NULL, NULL, 'MetRS_RNA', NULL, 'MetRS_RNA', NULL, NULL, NULL, 2),
(4279, NULL, 'cd13519', NULL, NULL, 'PBP2_PEB3_AcfC', NULL, 'PBP2_PEB3_AcfC', NULL, NULL, NULL, 2),
(4280, NULL, 'cd06166', NULL, NULL, 'Sortase_D_2', NULL, 'Sortase_D_2', NULL, NULL, 31180, 2),
(4281, NULL, 'cd18702', NULL, NULL, 'PIN_VapC_like', NULL, 'PIN_VapC_like', NULL, NULL, NULL, 2),
(4282, NULL, 'cd07263', NULL, NULL, 'VOC_like', NULL, 'VOC_like', NULL, NULL, NULL, 2),
(4283, NULL, 'cd18346', NULL, NULL, 'BTB_POZ_BTBD1', NULL, 'BTB_POZ_BTBD1', NULL, NULL, NULL, 2),
(4284, NULL, 'cd07921', NULL, NULL, 'PCA_45_Doxase_A_like', NULL, 'PCA_45_Doxase_A_like', NULL, NULL, NULL, 2),
(4285, NULL, 'cd16461', NULL, NULL, 'RING-H2_EL5_like', NULL, 'RING-H2_EL5_like', NULL, NULL, NULL, 2),
(4286, NULL, 'cd12658', NULL, NULL, 'RRM1_MYEF2', NULL, 'RRM1_MYEF2', NULL, NULL, 11750, 2),
(4287, NULL, 'cd04888', NULL, NULL, 'ACT_PheB-BS', NULL, 'ACT_PheB-BS', NULL, NULL, NULL, 2),
(4288, NULL, 'cd15606', NULL, NULL, 'PHD2_KDM5A', NULL, 'PHD2_KDM5A', NULL, NULL, NULL, 2),
(4289, NULL, 'cd10748', NULL, NULL, 'anti-TRAP', NULL, 'anti-TRAP', NULL, NULL, NULL, 2),
(4290, NULL, 'cd16870', NULL, NULL, 'ARID_JARD2', NULL, 'ARID_JARD2', NULL, NULL, NULL, 2),
(4291, NULL, 'cd03209', NULL, NULL, 'GST_C_Mu', NULL, 'GST_C_Mu', NULL, NULL, NULL, 2),
(4292, NULL, 'cd03291', NULL, NULL, 'ABCC_CFTR1', NULL, 'ABCC_CFTR1', NULL, NULL, NULL, 2),
(4293, NULL, 'cd18078', NULL, NULL, 'DEXXQc_Mov10L1', NULL, 'DEXXQc_Mov10L1', NULL, NULL, NULL, 2),
(4294, NULL, 'cd19882', NULL, NULL, 'DSRM_STAU2_rpt2', NULL, 'DSRM_STAU2_rpt2', NULL, NULL, 36413, 2),
(4295, NULL, 'cd13214', NULL, NULL, 'PH-GRAM_WBP2', NULL, 'PH-GRAM_WBP2', NULL, NULL, NULL, 2),
(4296, NULL, 'cd13891', NULL, NULL, 'CuRO_3_CotA_like', NULL, 'CuRO_3_CotA_like', NULL, NULL, NULL, 2),
(4297, NULL, 'cd14204', NULL, NULL, 'PTKc_Mer', NULL, 'PTKc_Mer', NULL, NULL, NULL, 2),
(4298, NULL, 'cd01559', NULL, NULL, 'ADCL_like', NULL, 'ADCL_like', NULL, NULL, 19439, 2),
(4299, NULL, 'cd09145', NULL, NULL, 'PLDc_vPLD4_1', NULL, 'PLDc_vPLD4_1', NULL, NULL, NULL, 2),
(4300, NULL, 'cd05329', NULL, NULL, 'TR_SDR_c', NULL, 'TR_SDR_c', NULL, NULL, NULL, 2),
(4301, NULL, 'cd14039', NULL, NULL, 'STKc_IKK_alpha', NULL, 'STKc_IKK_alpha', NULL, NULL, NULL, 2),
(4302, NULL, 'cd12094', NULL, NULL, 'TM_ErbB2', NULL, 'TM_ErbB2', NULL, NULL, NULL, 2),
(4303, NULL, 'cd07656', NULL, NULL, 'F-BAR_srGAP', NULL, 'F-BAR_srGAP', NULL, NULL, NULL, 2),
(4304, NULL, 'cd02409', NULL, NULL, 'KH-II', NULL, 'KH-II', NULL, NULL, NULL, 2); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(4305, NULL, 'cd04606', NULL, NULL, 'CBS_pair_Mg_transporter', NULL, 'CBS_pair_Mg_transporter', NULL, NULL, NULL, 2),
(4306, NULL, 'cd09882', NULL, NULL, 'PIN_MtVapC3-like_start', NULL, 'PIN_MtVapC3-like_start', NULL, NULL, NULL, 2),
(4307, NULL, 'cd07309', NULL, NULL, 'PHP', NULL, 'PHP', NULL, NULL, NULL, 2),
(4308, NULL, 'cd08820', NULL, NULL, 'FMT_core_like_6', NULL, 'FMT_core_like_6', NULL, NULL, NULL, 2),
(4309, NULL, 'cd03860', NULL, NULL, 'M14_CP_A-B_like', NULL, 'M14_CP_A-B_like', NULL, NULL, NULL, 2),
(4310, NULL, 'cd15998', NULL, NULL, '7tmB2_GPR124', NULL, '7tmB2_GPR124', NULL, NULL, NULL, 2),
(4311, NULL, 'cd14894', NULL, NULL, 'MYSc_Myo33', NULL, 'MYSc_Myo33', NULL, NULL, NULL, 2),
(4312, NULL, 'cd08555', NULL, NULL, 'PI-PLCc_GDPD_SF', NULL, 'PI-PLCc_GDPD_SF', NULL, NULL, NULL, 2),
(4313, NULL, 'cd15082', NULL, NULL, '7tmA_VA_opsin', NULL, '7tmA_VA_opsin', NULL, NULL, NULL, 2),
(4314, NULL, 'cd02192', NULL, NULL, 'PurM-like3', NULL, 'PurM-like3', NULL, NULL, 8451, 2),
(4315, NULL, 'cd07844', NULL, NULL, 'STKc_PCTAIRE_like', NULL, 'STKc_PCTAIRE_like', NULL, NULL, NULL, 2),
(4316, NULL, 'cd13987', NULL, NULL, 'STKc_SBK1', NULL, 'STKc_SBK1', NULL, NULL, NULL, 2),
(4317, NULL, 'cd16950', NULL, NULL, 'HATPase_EnvZ-like', NULL, 'HATPase_EnvZ-like', NULL, NULL, NULL, 2),
(4318, NULL, 'cd10037', NULL, NULL, 'Reelin_repeat_1_subrepeat_1', NULL, 'Reelin_repeat_1_subrepeat_1', NULL, NULL, NULL, 2),
(4319, NULL, 'cd21486', NULL, NULL, 'human_MERS-CoV_Spike_S1_RBD', NULL, 'human_MERS-CoV_Spike_S1_RBD', NULL, NULL, 34844, 2),
(4320, NULL, 'cd00812', NULL, NULL, 'LeuRS_core', NULL, 'LeuRS_core', NULL, NULL, NULL, 2),
(4321, NULL, 'cd02949', NULL, NULL, 'TRX_NTR', NULL, 'TRX_NTR', NULL, NULL, NULL, 2),
(4322, NULL, 'cd07954', NULL, NULL, 'AP_MHD_Cterm', NULL, 'AP_MHD_Cterm', NULL, NULL, NULL, 2),
(4323, NULL, 'cd14071', NULL, NULL, 'STKc_SIK', NULL, 'STKc_SIK', NULL, NULL, 18991, 2),
(4324, NULL, 'cd15041', NULL, NULL, '7tmB1_hormone_R', NULL, '7tmB1_hormone_R', NULL, NULL, NULL, 2),
(4325, NULL, 'cd06333', NULL, NULL, 'PBP1_ABC_RPA1789-like', NULL, 'PBP1_ABC_RPA1789-like', NULL, NULL, NULL, 2),
(4326, NULL, 'cd03383', NULL, NULL, 'PAP2_diacylglycerolkinase', NULL, 'PAP2_diacylglycerolkinase', NULL, NULL, NULL, 2),
(4327, NULL, 'cd15727', NULL, NULL, 'FYVE_ZF21', NULL, 'FYVE_ZF21', NULL, NULL, NULL, 2),
(4328, NULL, 'cd18393', NULL, NULL, 'BTB_POZ_SHKBP1', NULL, 'BTB_POZ_SHKBP1', NULL, NULL, NULL, 2),
(4329, NULL, 'cd17311', NULL, NULL, 'PIPKc_PIP5K2C', NULL, 'PIPKc_PIP5K2C', NULL, NULL, NULL, 2),
(4330, NULL, 'cd15829', NULL, NULL, 'SPRY_PRY_TRIM75', NULL, 'SPRY_PRY_TRIM75', NULL, NULL, 32471, 2),
(4331, NULL, 'cd18435', NULL, NULL, 'BRCT_BRC1_like_rpt1', NULL, 'BRCT_BRC1_like_rpt1', NULL, NULL, NULL, 2),
(4332, NULL, 'cd01965', NULL, NULL, 'Nitrogenase_MoFe_beta_like', NULL, 'Nitrogenase_MoFe_beta_like', NULL, NULL, NULL, 2),
(4333, NULL, 'cd03425', NULL, NULL, 'MutT_pyrophosphohydrolase', NULL, 'MutT_pyrophosphohydrolase', NULL, NULL, NULL, 2),
(4334, NULL, 'cd01259', NULL, NULL, 'PH_APBB1IP', NULL, 'PH_APBB1IP', NULL, NULL, 27312, 2),
(4335, NULL, 'cd04641', NULL, NULL, 'CBS_euAMPK_gamma-like_repeat2', NULL, 'CBS_euAMPK_gamma-like_repeat2', NULL, NULL, NULL, 2),
(4336, NULL, 'cd15073', NULL, NULL, '7tmA_Peropsin', NULL, '7tmA_Peropsin', NULL, NULL, NULL, 2),
(4337, NULL, 'cd00210', NULL, NULL, 'PTS_IIA_glc', NULL, 'PTS_IIA_glc', NULL, NULL, NULL, 2),
(4338, NULL, 'cd12754', NULL, NULL, 'RRM2_RBM10', NULL, 'RRM2_RBM10', NULL, NULL, 14768, 2),
(4339, NULL, 'cd18737', NULL, NULL, 'PIN_VapC4-5_FitB-like', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, NULL, 2),
(4340, NULL, 'cd15939', NULL, NULL, '7tmA_OR4A-like', NULL, '7tmA_OR4A-like', NULL, NULL, NULL, 2),
(4341, NULL, 'cd09906', NULL, NULL, 'H3TH_YEN1', NULL, 'H3TH_YEN1', NULL, NULL, 32184, 2),
(4342, NULL, 'cd16626', NULL, NULL, 'RING-HC_RBR_HHARI', NULL, 'RING-HC_RBR_HHARI', NULL, NULL, NULL, 2),
(4343, NULL, 'cd00484', NULL, NULL, 'PEPCK_ATP', NULL, 'PEPCK_ATP', NULL, NULL, 5279, 2),
(4344, NULL, 'cd07624', NULL, NULL, 'BAR_SNX7_30', NULL, 'BAR_SNX7_30', NULL, NULL, NULL, 2);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(4345, NULL, 'cd18289', NULL, NULL, 'BTB_POZ_BTBD14A_NAC2', NULL, 'BTB_POZ_BTBD14A_NAC2', NULL, NULL, NULL, 2),
(4346, NULL, 'cd01066', NULL, NULL, 'APP_MetAP', NULL, 'APP_MetAP', NULL, NULL, NULL, 2),
(4347, NULL, 'cd06603', NULL, NULL, 'GH31_GANC_GANAB_alpha', NULL, 'GH31_GANC_GANAB_alpha', NULL, NULL, NULL, 2),
(4348, NULL, 'cd08703', NULL, NULL, 'FDH_Hydrolase_C', NULL, 'FDH_Hydrolase_C', NULL, NULL, NULL, 2),
(4349, NULL, 'cd15590', NULL, NULL, 'PHD2_KMT2A', NULL, 'PHD2_KMT2A', NULL, NULL, 30962, 2),
(4350, NULL, 'cd13709', NULL, NULL, 'PBP2_YxeM', NULL, 'PBP2_YxeM', NULL, NULL, NULL, 2),
(4351, NULL, 'cd14043', NULL, NULL, 'PK_GC-2D', NULL, 'PK_GC-2D', NULL, NULL, NULL, 2),
(4352, NULL, 'cd18727', NULL, NULL, 'PIN_Swt1-like', NULL, 'PIN_Swt1-like', NULL, NULL, NULL, 2),
(4353, NULL, 'cd18561', NULL, NULL, 'ABC_6TM_AarD_CydDC_like', NULL, 'ABC_6TM_AarD_CydDC_like', NULL, NULL, NULL, 2),
(4354, NULL, 'cd18760', NULL, NULL, 'PIN_MtVapC3-like', NULL, 'PIN_MtVapC3-like', NULL, NULL, NULL, 2),
(4355, NULL, 'cd07932', NULL, NULL, 'arginine_kinase_like', NULL, 'arginine_kinase_like', NULL, NULL, NULL, 2),
(4356, NULL, 'cd11544', NULL, NULL, 'NTP-PPase_DR2231', NULL, 'NTP-PPase_DR2231', NULL, NULL, NULL, 2),
(4357, NULL, 'cd07702', NULL, NULL, 'Ig_VEGFR-1', NULL, 'Ig_VEGFR-1', NULL, NULL, NULL, 2),
(4358, NULL, 'cd14422', NULL, NULL, 'CUE_RIN3_plant', NULL, 'CUE_RIN3_plant', NULL, NULL, 32328, 2),
(4359, NULL, 'cd16541', NULL, NULL, 'RING-HC_RNF123', NULL, 'RING-HC_RNF123', NULL, NULL, NULL, 2),
(4360, NULL, 'cd05943', NULL, NULL, 'AACS', NULL, 'AACS', NULL, NULL, NULL, 2),
(4361, NULL, 'cd18681', NULL, NULL, 'PIN_MtVapC27-VapC40_like', NULL, 'PIN_MtVapC27-VapC40_like', NULL, NULL, NULL, 2),
(4362, NULL, 'cd08037', NULL, NULL, 'LARP_1', NULL, 'LARP_1', NULL, NULL, NULL, 2),
(4363, NULL, 'cd08565', NULL, NULL, 'GDPD_pAtGDE_like', NULL, 'GDPD_pAtGDE_like', NULL, NULL, NULL, 2),
(4364, NULL, 'cd19972', NULL, NULL, 'PBP1_ABC_sugar_binding-like', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, NULL, 2),
(4365, NULL, 'cd01839', NULL, NULL, 'SGNH_arylesterase_like', NULL, 'SGNH_arylesterase_like', NULL, NULL, NULL, 2),
(4366, NULL, 'cd00923', NULL, NULL, 'Cyt_c_Oxidase_Va', NULL, 'Cyt_c_Oxidase_Va', NULL, NULL, 1933, 2),
(4367, NULL, 'cd06906', NULL, NULL, 'M14_Nna1', NULL, 'M14_Nna1', NULL, NULL, 32688, 2),
(4368, NULL, 'cd08557', NULL, NULL, 'PI-PLCc_bacteria_like', NULL, 'PI-PLCc_bacteria_like', NULL, NULL, NULL, 2),
(4369, NULL, 'cd03702', NULL, NULL, 'IF2_mtIF2_II', NULL, 'IF2_mtIF2_II', NULL, NULL, 35314, 2),
(4370, NULL, 'cd06168', NULL, NULL, 'LSMD1', NULL, 'LSMD1', NULL, NULL, 21033, 2),
(4371, NULL, 'cd08738', NULL, NULL, 'RGS_RGS7', NULL, 'RGS_RGS7', NULL, NULL, NULL, 2),
(4372, NULL, 'cd02826', NULL, NULL, 'Piwi-like', NULL, 'Piwi-like', NULL, NULL, NULL, 2),
(4373, NULL, 'cd12473', NULL, NULL, 'RRM2_MSSP1', NULL, 'RRM2_MSSP1', NULL, NULL, NULL, 2),
(4374, NULL, 'cd00013', NULL, NULL, 'ADF_gelsolin', NULL, 'ADF_gelsolin', NULL, NULL, NULL, 2),
(4375, NULL, 'cd18325', NULL, NULL, 'BTB_POZ_ZBTB18_2-like', NULL, 'BTB_POZ_ZBTB18_2-like', NULL, NULL, NULL, 2),
(4376, NULL, 'cd05279', NULL, NULL, 'Zn_ADH1', NULL, 'Zn_ADH1', NULL, NULL, NULL, 2),
(4377, NULL, 'cd06288', NULL, NULL, 'PBP1_sucrose_transcription_regulator', NULL, 'PBP1_sucrose_transcription_regulator', NULL, NULL, NULL, 2),
(4378, NULL, 'cd08374', NULL, NULL, 'C2F_Ferlin', NULL, 'C2F_Ferlin', NULL, NULL, 32957, 2),
(4379, NULL, 'cd19754', NULL, NULL, 'FHb_fungal-globin', NULL, 'FHb_fungal-globin', NULL, NULL, NULL, 2),
(4380, NULL, 'cd07543', NULL, NULL, 'P-type_ATPase_cation', NULL, 'P-type_ATPase_cation', NULL, NULL, NULL, 2),
(4381, NULL, 'cd13892', NULL, NULL, 'CuRO_3_PHS', NULL, 'CuRO_3_PHS', NULL, NULL, NULL, 2),
(4382, NULL, 'cd15081', NULL, NULL, '7tmA_LWS_opsin', NULL, '7tmA_LWS_opsin', NULL, NULL, NULL, 2),
(4383, NULL, 'cd00200', NULL, NULL, 'WD40', NULL, 'WD40', NULL, NULL, NULL, 2),
(4384, NULL, 'cd03882', NULL, NULL, 'M28_nicalin_like', NULL, 'M28_nicalin_like', NULL, NULL, NULL, 2),
(4385, NULL, 'cd12028', NULL, NULL, 'SH3_ZO-3', NULL, 'SH3_ZO-3', NULL, NULL, NULL, 2);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(4386, NULL, 'cd06825', NULL, NULL, 'PLPDE_III_VanT', NULL, 'PLPDE_III_VanT', NULL, NULL, NULL, 2),
(4387, NULL, 'cd16898', NULL, NULL, 'LYZ_LA', NULL, 'LYZ_LA', NULL, NULL, NULL, 2),
(4388, NULL, 'cd08579', NULL, NULL, 'GDPD_memb_like', NULL, 'GDPD_memb_like', NULL, NULL, NULL, 2),
(4389, NULL, 'cd18788', NULL, NULL, 'SF2_C_XPD', NULL, 'SF2_C_XPD', NULL, NULL, NULL, 2),
(4390, NULL, 'cd00798', NULL, NULL, 'INT_XerDC_C', NULL, 'INT_XerDC_C', NULL, NULL, NULL, 2),
(4391, NULL, 'cd08293', NULL, NULL, 'PTGR2', NULL, 'PTGR2', NULL, NULL, 32465, 2),
(4392, NULL, 'cd14426', NULL, NULL, 'UBA1_HR23B', NULL, 'UBA1_HR23B', NULL, NULL, NULL, 2),
(4393, NULL, 'cd03823', NULL, NULL, 'GT4_ExpE7-like', NULL, 'GT4_ExpE7-like', NULL, NULL, NULL, 2),
(4394, NULL, 'cd06133', NULL, NULL, 'ERI-1_3''hExo_like', NULL, 'ERI-1_3''hExo_like', NULL, NULL, NULL, 2),
(4395, NULL, 'cd07448', NULL, NULL, 'CRD_FZ4', NULL, 'CRD_FZ4', NULL, NULL, 30166, 2),
(4396, NULL, 'cd18357', NULL, NULL, 'BTB1_POZ_RHOBTB3', NULL, 'BTB1_POZ_RHOBTB3', NULL, NULL, NULL, 2),
(4397, NULL, 'cd09586', NULL, NULL, 'SAM_USH1G', NULL, 'SAM_USH1G', NULL, NULL, 33583, 2),
(4398, NULL, 'cd10435', NULL, NULL, 'GIY-YIG_RE_Eco29kI_like', NULL, 'GIY-YIG_RE_Eco29kI_like', NULL, NULL, NULL, 2),
(4399, NULL, 'cd03681', NULL, NULL, 'MM_CoA_mutase_MeaA', NULL, 'MM_CoA_mutase_MeaA', NULL, NULL, NULL, 2),
(4400, NULL, 'cd13404', NULL, NULL, 'UreI_AmiS_like', NULL, 'UreI_AmiS_like', NULL, NULL, NULL, 2),
(4401, NULL, 'cd11302', NULL, NULL, 'O-FucT-1', NULL, 'O-FucT-1', NULL, NULL, 30186, 2),
(4402, NULL, 'cd19208', NULL, NULL, 'SET_KMT2C', NULL, 'SET_KMT2C', NULL, NULL, NULL, 2),
(4403, NULL, 'cd07541', NULL, NULL, 'P-type_ATPase_APLT_Neo1-like', NULL, 'P-type_ATPase_APLT_Neo1-like', NULL, NULL, NULL, 2),
(4404, NULL, 'cd02648', NULL, NULL, 'nuc_hydro_1', NULL, 'nuc_hydro_1', NULL, NULL, NULL, 2),
(4405, NULL, 'cd18212', NULL, NULL, 'BTB_POZ_ZBTB24_ZNF450', NULL, 'BTB_POZ_ZBTB24_ZNF450', NULL, NULL, NULL, 2),
(4406, NULL, 'cd08316', NULL, NULL, 'Death_FAS_TNFRSF6', NULL, 'Death_FAS_TNFRSF6', NULL, NULL, 31573, 2),
(4407, NULL, 'cd08981', NULL, NULL, 'GH43_Bt1873-like', NULL, 'GH43_Bt1873-like', NULL, NULL, NULL, 2),
(4408, NULL, 'cd15583', NULL, NULL, 'PHD_ash2p_like', NULL, 'PHD_ash2p_like', NULL, NULL, NULL, 2),
(4409, NULL, 'cd07561', NULL, NULL, 'Peptidase_S41_CPP_like', NULL, 'Peptidase_S41_CPP_like', NULL, NULL, NULL, 2),
(4410, NULL, 'cd08510', NULL, NULL, 'PBP2_Lactococcal_OppA_like', NULL, 'PBP2_Lactococcal_OppA_like', NULL, NULL, NULL, 2),
(4411, NULL, 'cd12916', NULL, NULL, 'VKOR_1', NULL, 'VKOR_1', NULL, NULL, 34546, 2),
(4412, NULL, 'cd17532', NULL, NULL, 'REC_LytTR_AlgR-like', NULL, 'REC_LytTR_AlgR-like', NULL, NULL, NULL, 2),
(4413, NULL, 'cd13171', NULL, NULL, 'RanBD1_RanBP2_insect-like', NULL, 'RanBD1_RanBP2_insect-like', NULL, NULL, NULL, 2),
(4414, NULL, 'cd12074', NULL, NULL, 'SH3_Tks5_1', NULL, 'SH3_Tks5_1', NULL, NULL, 20403, 2),
(4415, NULL, 'cd01927', NULL, NULL, 'cyclophilin_WD40', NULL, 'cyclophilin_WD40', NULL, NULL, NULL, 2),
(4416, NULL, 'cd04368', NULL, NULL, 'IlGF', NULL, 'IlGF', NULL, NULL, NULL, 2),
(4417, NULL, 'cd12682', NULL, NULL, 'RRM_RBPMS', NULL, 'RRM_RBPMS', NULL, NULL, NULL, 2),
(4418, NULL, 'cd16312', NULL, NULL, 'THIN-B-like_MBL-B3', NULL, 'THIN-B-like_MBL-B3', NULL, NULL, NULL, 2),
(4419, NULL, 'cd18489', NULL, NULL, 'BACK_BTBD7', NULL, 'BACK_BTBD7', NULL, NULL, NULL, 2),
(4420, NULL, 'cd12690', NULL, NULL, 'RRM3_PTBPH1_PTBPH2', NULL, 'RRM3_PTBPH1_PTBPH2', NULL, NULL, 32426, 2),
(4421, NULL, 'cd09018', NULL, NULL, 'DEDDy_polA_RNaseD_like_exo', NULL, 'DEDDy_polA_RNaseD_like_exo', NULL, NULL, NULL, 2),
(4422, NULL, 'cd17347', NULL, NULL, 'MFS_SLC15A1_2_like', NULL, 'MFS_SLC15A1_2_like', NULL, NULL, NULL, 2),
(4423, NULL, 'cd06577', NULL, NULL, 'PASTA_pknB', NULL, 'PASTA_pknB', NULL, NULL, NULL, 2),
(4424, NULL, 'cd08479', NULL, NULL, 'PBP2_CrgA_like_9', NULL, 'PBP2_CrgA_like_9', NULL, NULL, NULL, 2),
(4425, NULL, 'cd12186', NULL, NULL, 'LDH', NULL, 'LDH', NULL, NULL, NULL, 2),
(4426, NULL, 'cd19112', NULL, NULL, 'AKR_AKR2A1-2', NULL, 'AKR_AKR2A1-2', NULL, NULL, 35243, 2);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(4427, NULL, 'cd00985', NULL, NULL, 'Maf_Ham1', NULL, 'Maf_Ham1', NULL, NULL, NULL, 2),
(4428, NULL, 'cd08972', NULL, NULL, 'PF_Nei_N', NULL, 'PF_Nei_N', NULL, NULL, NULL, 2),
(4429, NULL, 'cd09656', NULL, NULL, 'Cmr3_III-B', NULL, 'Cmr3_III-B', NULL, NULL, NULL, 2),
(4430, NULL, 'cd17198', NULL, NULL, 'FERM_F1_FRMD6', NULL, 'FERM_F1_FRMD6', NULL, NULL, NULL, 2),
(4431, NULL, 'cd09091', NULL, NULL, 'INPP5c_SHIP', NULL, 'INPP5c_SHIP', NULL, NULL, NULL, 2),
(4432, NULL, 'cd19560', NULL, NULL, 'serpinB1_LEI', NULL, 'serpinB1_LEI', NULL, NULL, NULL, 2),
(4433, NULL, 'cd00069', NULL, NULL, 'GHB_like', NULL, 'GHB_like', NULL, NULL, 3145, 2),
(4434, NULL, 'cd06902', NULL, NULL, 'lectin_ERGIC-53_ERGL', NULL, 'lectin_ERGIC-53_ERGL', NULL, NULL, NULL, 2),
(4435, NULL, 'cd12216', NULL, NULL, 'Csn2_like', NULL, 'Csn2_like', NULL, NULL, NULL, 2),
(4436, NULL, 'cd08028', NULL, NULL, 'LARP_3', NULL, 'LARP_3', NULL, NULL, NULL, 2),
(4437, NULL, 'cd06936', NULL, NULL, 'NR_LBD_Fxr', NULL, 'NR_LBD_Fxr', NULL, NULL, 35393, 2),
(4438, NULL, 'cd13250', NULL, NULL, 'PH_ACAP', NULL, 'PH_ACAP', NULL, NULL, NULL, 2),
(4439, NULL, 'cd01575', NULL, NULL, 'PBP1_GntR', NULL, 'PBP1_GntR', NULL, NULL, NULL, 2),
(4440, NULL, 'cd02056', NULL, NULL, 'serpinA1_A1AT', NULL, 'serpinA1_A1AT', NULL, NULL, NULL, 2),
(4441, NULL, 'cd17145', NULL, NULL, 'DCX1_RP1', NULL, 'DCX1_RP1', NULL, NULL, NULL, 2),
(4442, NULL, 'cd07329', NULL, NULL, 'M56_like', NULL, 'M56_like', NULL, NULL, NULL, 2),
(4443, NULL, 'cd07730', NULL, NULL, 'metallo-hydrolase-like_MBL-fold', NULL, 'metallo-hydrolase-like_MBL-fold', NULL, NULL, NULL, 2),
(4444, NULL, 'cd18917', NULL, NULL, 'bHLH_AtSAC51_like', NULL, 'bHLH_AtSAC51_like', NULL, NULL, NULL, 2),
(4445, NULL, 'cd19161', NULL, NULL, 'AKR_AKR15A1', NULL, 'AKR_AKR15A1', NULL, NULL, 34495, 2),
(4446, NULL, 'cd16846', NULL, NULL, 'STAT2_DBD', NULL, 'STAT2_DBD', NULL, NULL, NULL, 2),
(4447, NULL, 'cd18552', NULL, NULL, 'ABC_6TM_MsbA_like', NULL, 'ABC_6TM_MsbA_like', NULL, NULL, NULL, 2),
(4448, NULL, 'cd09402', NULL, NULL, 'LIM1_CRP', NULL, 'LIM1_CRP', NULL, NULL, NULL, 2),
(4449, NULL, 'cd02138', NULL, NULL, 'TdsD-like', NULL, 'TdsD-like', NULL, NULL, NULL, 2),
(4450, NULL, 'cd07943', NULL, NULL, 'DRE_TIM_HOA', NULL, 'DRE_TIM_HOA', NULL, NULL, 31714, 2),
(4451, NULL, 'cd12521', NULL, NULL, 'RRM3_MRN1', NULL, 'RRM3_MRN1', NULL, NULL, NULL, 2),
(4452, NULL, 'cd16039', NULL, NULL, 'PHD_SPP1', NULL, 'PHD_SPP1', NULL, NULL, NULL, 2),
(4453, NULL, 'cd03829', NULL, NULL, 'Sina', NULL, 'Sina', NULL, NULL, NULL, 2),
(4454, NULL, 'cd01856', NULL, NULL, 'YlqF', NULL, 'YlqF', NULL, NULL, NULL, 2),
(4455, NULL, 'cd07670', NULL, NULL, 'BAR_SNX18', NULL, 'BAR_SNX18', NULL, NULL, NULL, 2),
(4456, NULL, 'cd14771', NULL, NULL, 'TrHb2_Mt-trHbO-like_O', NULL, 'TrHb2_Mt-trHbO-like_O', NULL, NULL, NULL, 2),
(4457, NULL, 'cd20758', NULL, NULL, 'capping_2-OMTase_Orbivirus', NULL, 'capping_2-OMTase_Orbivirus', NULL, NULL, 1328, 2),
(4458, NULL, 'cd06602', NULL, NULL, 'GH31_MGAM_SI_GAA', NULL, 'GH31_MGAM_SI_GAA', NULL, NULL, NULL, 2),
(4459, NULL, 'cd07201', NULL, NULL, 'cPLA2_Grp-IVB-IVD-IVE-IVF', NULL, 'cPLA2_Grp-IVB-IVD-IVE-IVF', NULL, NULL, NULL, 2),
(4460, NULL, 'cd09448', NULL, NULL, 'LIM_CLP36', NULL, 'LIM_CLP36', NULL, NULL, NULL, 2),
(4461, NULL, 'cd03171', NULL, NULL, 'SORL_Dfx_classI', NULL, 'SORL_Dfx_classI', NULL, NULL, NULL, 2),
(4462, NULL, 'cd10508', NULL, NULL, 'Zn-ribbon_RPB9', NULL, 'Zn-ribbon_RPB9', NULL, NULL, 13755, 2),
(4463, NULL, 'cd05076', NULL, NULL, 'PTK_Tyk2_rpt1', NULL, 'PTK_Tyk2_rpt1', NULL, NULL, NULL, 2),
(4464, NULL, 'cd17433', NULL, NULL, 'MFS_GLUT8_Class3', NULL, 'MFS_GLUT8_Class3', NULL, NULL, NULL, 2),
(4465, NULL, 'cd05332', NULL, NULL, '11beta-HSD1_like_SDR_c', NULL, '11beta-HSD1_like_SDR_c', NULL, NULL, NULL, 2),
(4466, NULL, 'cd14563', NULL, NULL, 'PTP_auxilin_N', NULL, 'PTP_auxilin_N', NULL, NULL, NULL, 2),
(4467, NULL, 'cd05806', NULL, NULL, 'CBM20_laforin', NULL, 'CBM20_laforin', NULL, NULL, 10448, 2),
(4468, NULL, 'cd15121', NULL, NULL, '7tmA_LTB4R1', NULL, '7tmA_LTB4R1', NULL, NULL, NULL, 2); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(4469, NULL, 'cd15802', NULL, NULL, 'RING_CBP-p300', NULL, 'RING_CBP-p300', NULL, NULL, 7892, 2),
(4470, NULL, 'cd15681', NULL, NULL, 'PHD_JADE3', NULL, 'PHD_JADE3', NULL, NULL, 31461, 2),
(4471, NULL, 'cd03086', NULL, NULL, 'PGM3', NULL, 'PGM3', NULL, NULL, 19559, 2),
(4472, NULL, 'cd07390', NULL, NULL, 'MPP_AQ1575', NULL, 'MPP_AQ1575', NULL, NULL, NULL, 2),
(4473, NULL, 'cd17265', NULL, NULL, 'RMtype1_S_Eco4255III-TRD2-CR2_like', NULL, 'RMtype1_S_Eco4255III-TRD2-CR2_like', NULL, NULL, NULL, 2),
(4474, NULL, 'cd11353', NULL, NULL, 'AmyAc_euk_bac_CMD_like', NULL, 'AmyAc_euk_bac_CMD_like', NULL, NULL, NULL, 2),
(4475, NULL, 'cd19360', NULL, NULL, 'TenA_C_SaTenA-like', NULL, 'TenA_C_SaTenA-like', NULL, NULL, NULL, 2),
(4476, NULL, 'cd13746', NULL, NULL, 'Sir4p-SID_like', NULL, 'Sir4p-SID_like', NULL, NULL, 24092, 2),
(4477, NULL, 'cd19937', NULL, NULL, 'REC_OmpR_BsPhoP-like', NULL, 'REC_OmpR_BsPhoP-like', NULL, NULL, NULL, 2),
(4478, NULL, 'cd14180', NULL, NULL, 'STKc_MSK2_C', NULL, 'STKc_MSK2_C', NULL, NULL, NULL, 2),
(4479, NULL, 'cd07219', NULL, NULL, 'Pat_PNPLA1', NULL, 'Pat_PNPLA1', NULL, NULL, 28376, 2),
(4480, NULL, 'sd00010', NULL, NULL, 'SLR', NULL, 'SLR', NULL, NULL, NULL, 2),
(4481, NULL, 'cd11735', NULL, NULL, 'HSPA12A_like_NBD', NULL, 'HSPA12A_like_NBD', NULL, NULL, NULL, 2),
(4482, NULL, 'cd04671', NULL, NULL, 'Nudix_Hydrolase_13', NULL, 'Nudix_Hydrolase_13', NULL, NULL, 35080, 2),
(4483, NULL, 'cd02783', NULL, NULL, 'MopB_CT_2', NULL, 'MopB_CT_2', NULL, NULL, NULL, 2),
(4484, NULL, 'cd09086', NULL, NULL, 'ExoIII-like_AP-endo', NULL, 'ExoIII-like_AP-endo', NULL, NULL, 32948, 2),
(4485, NULL, 'cd00894', NULL, NULL, 'PI3Kc_IB_gamma', NULL, 'PI3Kc_IB_gamma', NULL, NULL, NULL, 2),
(4486, NULL, 'cd13606', NULL, NULL, 'PBP2_ProX_like', NULL, 'PBP2_ProX_like', NULL, NULL, NULL, 2),
(4487, NULL, 'cd01491', NULL, NULL, 'Ube1_repeat1', NULL, 'Ube1_repeat1', NULL, NULL, NULL, 2),
(4488, NULL, 'cd19559', NULL, NULL, 'serpinA14_UTMP_UABP-2', NULL, 'serpinA14_UTMP_UABP-2', NULL, NULL, NULL, 2),
(4489, NULL, 'cd17233', NULL, NULL, 'Ubl_ATG8_GABARAPL1_like', NULL, 'Ubl_ATG8_GABARAPL1_like', NULL, NULL, NULL, 2),
(4490, NULL, 'cd16581', NULL, NULL, 'RING-HC_TRIM13_like_C-V', NULL, 'RING-HC_TRIM13_like_C-V', NULL, NULL, NULL, 2),
(4491, NULL, 'cd19553', NULL, NULL, 'serpinA5_PCI', NULL, 'serpinA5_PCI', NULL, NULL, NULL, 2),
(4492, NULL, 'cd02113', NULL, NULL, 'bact_SoxC_Moco', NULL, 'bact_SoxC_Moco', NULL, NULL, NULL, 2),
(4493, NULL, 'cd17424', NULL, NULL, 'MFS_MCT12', NULL, 'MFS_MCT12', NULL, NULL, NULL, 2),
(4494, NULL, 'cd04083', NULL, NULL, 'CBM35_Lmo2446-like', NULL, 'CBM35_Lmo2446-like', NULL, NULL, NULL, 2),
(4495, NULL, 'cd14131', NULL, NULL, 'PKc_Mps1', NULL, 'PKc_Mps1', NULL, NULL, NULL, 2),
(4496, NULL, 'cd12889', NULL, NULL, 'SPRY_PRY_TRIM67_9', NULL, 'SPRY_PRY_TRIM67_9', NULL, NULL, NULL, 2),
(4497, NULL, 'cd06230', NULL, NULL, 'M14_ASTE_ASPA_like', NULL, 'M14_ASTE_ASPA_like', NULL, NULL, NULL, 2),
(4498, NULL, 'cd05500', NULL, NULL, 'Bromo_BDF1_2_I', NULL, 'Bromo_BDF1_2_I', NULL, NULL, NULL, 2),
(4499, NULL, 'cd00271', NULL, NULL, 'Chemokine_C', NULL, 'Chemokine_C', NULL, NULL, 6243, 2),
(4500, NULL, 'cd05797', NULL, NULL, 'Ribosomal_L10', NULL, 'Ribosomal_L10', NULL, NULL, 4424, 2),
(4501, NULL, 'cd02201', NULL, NULL, 'FtsZ_type1', NULL, 'FtsZ_type1', NULL, NULL, 1534, 2),
(4502, NULL, 'cd10015', NULL, NULL, 'BfiI_C_EcoRII_N_B3', NULL, 'BfiI_C_EcoRII_N_B3', NULL, NULL, NULL, 2),
(4503, NULL, 'cd17643', NULL, NULL, 'A_NRPS_Cytc1-like', NULL, 'A_NRPS_Cytc1-like', NULL, NULL, NULL, 2),
(4504, NULL, 'cd01642', NULL, NULL, 'Arch_FBPase_2', NULL, 'Arch_FBPase_2', NULL, NULL, NULL, 2),
(4505, NULL, 'cd13618', NULL, NULL, 'PBP2_transferrin_N', NULL, 'PBP2_transferrin_N', NULL, NULL, NULL, 2),
(4506, NULL, 'cd03195', NULL, NULL, 'GST_C_4', NULL, 'GST_C_4', NULL, NULL, 367, 2),
(4507, NULL, 'cd06845', NULL, NULL, 'Bcl-2_like', NULL, 'Bcl-2_like', NULL, NULL, 21508, 2),
(4508, NULL, 'cd03749', NULL, NULL, 'proteasome_alpha_type_1', NULL, 'proteasome_alpha_type_1', NULL, NULL, 8353, 2);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(4509, NULL, 'cd03766', NULL, NULL, 'Gn_AT_II_novel', NULL, 'Gn_AT_II_novel', NULL, NULL, NULL, 2),
(4510, NULL, 'cd06318', NULL, NULL, 'PBP1_ABC_D-talitol-like', NULL, 'PBP1_ABC_D-talitol-like', NULL, NULL, NULL, 2),
(4511, NULL, 'cd15267', NULL, NULL, '7tmB1_GCGR', NULL, '7tmB1_GCGR', NULL, NULL, NULL, 2),
(4512, NULL, 'cd16339', NULL, NULL, 'CpcS', NULL, 'CpcS', NULL, NULL, NULL, 2),
(4513, NULL, 'cd18801', NULL, NULL, 'SF2_C_FANCM_Hef', NULL, 'SF2_C_FANCM_Hef', NULL, NULL, NULL, 2),
(4514, NULL, 'cd07253', NULL, NULL, 'GLOD5', NULL, 'GLOD5', NULL, NULL, NULL, 2),
(4515, NULL, 'cd02043', NULL, NULL, 'serpinP_plants', NULL, 'serpinP_plants', NULL, NULL, NULL, 2),
(4516, NULL, 'cd19099', NULL, NULL, 'AKR_unchar', NULL, 'AKR_unchar', NULL, NULL, NULL, 2),
(4517, NULL, 'cd19803', NULL, NULL, 'Bbox1_TRIM9-like_C-I', NULL, 'Bbox1_TRIM9-like_C-I', NULL, NULL, NULL, 2),
(4518, NULL, 'cd04759', NULL, NULL, 'Rib_hydrolase', NULL, 'Rib_hydrolase', NULL, NULL, 1761, 2),
(4519, NULL, 'cd14900', NULL, NULL, 'MYSc_Myo39', NULL, 'MYSc_Myo39', NULL, NULL, NULL, 2),
(4520, NULL, 'cd18712', NULL, NULL, 'PIN_VapC-like_DUF411', NULL, 'PIN_VapC-like_DUF411', NULL, NULL, NULL, 2),
(4521, NULL, 'cd16006', NULL, NULL, '7tmB2_Latrophilin-2', NULL, '7tmB2_Latrophilin-2', NULL, NULL, NULL, 2),
(4522, NULL, 'cd11800', NULL, NULL, 'SH3_DNMBP_C2_like', NULL, 'SH3_DNMBP_C2_like', NULL, NULL, NULL, 2),
(4523, NULL, 'cd04674', NULL, NULL, 'Nudix_Hydrolase_16', NULL, 'Nudix_Hydrolase_16', NULL, NULL, NULL, 2),
(4524, NULL, 'cd17870', NULL, NULL, 'GPN1', NULL, 'GPN1', NULL, NULL, NULL, 2),
(4525, NULL, 'cd01947', NULL, NULL, 'Guanosine_kinase_like', NULL, 'Guanosine_kinase_like', NULL, NULL, NULL, 2),
(4526, NULL, 'cd07863', NULL, NULL, 'STKc_CDK4', NULL, 'STKc_CDK4', NULL, NULL, NULL, 2),
(4527, NULL, 'cd00757', NULL, NULL, 'ThiF_MoeB_HesA_family', NULL, 'ThiF_MoeB_HesA_family', NULL, NULL, NULL, 2),
(4528, NULL, 'cd05042', NULL, NULL, 'PTKc_Aatyk', NULL, 'PTKc_Aatyk', NULL, NULL, NULL, 2),
(4529, NULL, 'cd16147', NULL, NULL, 'G6S', NULL, 'G6S', NULL, NULL, NULL, 2),
(4530, NULL, 'cd12079', NULL, NULL, 'SH3_Tks5_3', NULL, 'SH3_Tks5_3', NULL, NULL, 20345, 2),
(4531, NULL, 'cd14552', NULL, NULL, 'R-PTPc-A-E-2', NULL, 'R-PTPc-A-E-2', NULL, NULL, NULL, 2),
(4532, NULL, 'cd13757', NULL, NULL, 'TGF_beta_AMH', NULL, 'TGF_beta_AMH', NULL, NULL, NULL, 2),
(4533, NULL, 'cd11865', NULL, NULL, 'SH3_Nbp2-like', NULL, 'SH3_Nbp2-like', NULL, NULL, NULL, 2),
(4534, NULL, 'cd13951', NULL, NULL, '7tmF_Frizzled_SMO', NULL, '7tmF_Frizzled_SMO', NULL, NULL, NULL, 2),
(4535, NULL, 'cd19758', NULL, NULL, 'Bbox2_MID', NULL, 'Bbox2_MID', NULL, NULL, NULL, 2),
(4536, NULL, 'cd16560', NULL, NULL, 'RING-HC_RNF212_like', NULL, 'RING-HC_RNF212_like', NULL, NULL, NULL, 2),
(4537, NULL, 'cd02122', NULL, NULL, 'PA_GRAIL_like', NULL, 'PA_GRAIL_like', NULL, NULL, NULL, 2),
(4538, NULL, 'cd04765', NULL, NULL, 'HTH_MlrA-like_sg2', NULL, 'HTH_MlrA-like_sg2', NULL, NULL, NULL, 2),
(4539, NULL, 'cd13307', NULL, NULL, 'PH2_AFAP', NULL, 'PH2_AFAP', NULL, NULL, NULL, 2),
(4540, NULL, 'cd19050', NULL, NULL, 'LGIC_TM_bact', NULL, 'LGIC_TM_bact', NULL, NULL, NULL, 2),
(4541, NULL, 'cd01540', NULL, NULL, 'PBP1_arabinose_binding', NULL, 'PBP1_arabinose_binding', NULL, NULL, 22639, 2),
(4542, NULL, 'cd15240', NULL, NULL, '7tm_ASR-like', NULL, '7tm_ASR-like', NULL, NULL, NULL, 2),
(4543, NULL, 'cd07507', NULL, NULL, 'HAD_Pase', NULL, 'HAD_Pase', NULL, NULL, 5994, 2),
(4544, NULL, 'cd00081', NULL, NULL, 'Hint', NULL, 'Hint', NULL, NULL, NULL, 2),
(4545, NULL, 'cd14475', NULL, NULL, 'SPX_SYG1_like', NULL, 'SPX_SYG1_like', NULL, NULL, NULL, 2),
(4546, NULL, 'cd20005', NULL, NULL, 'PBP1_ABC_sugar_binding-like', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, NULL, 2),
(4547, NULL, 'cd09574', NULL, NULL, 'SAM_STIM2', NULL, 'SAM_STIM2', NULL, NULL, 30875, 2),
(4548, NULL, 'cd18649', NULL, NULL, 'CD_Cbx8', NULL, 'CD_Cbx8', NULL, NULL, NULL, 2),
(4549, NULL, 'cd16362', NULL, NULL, 'TflA', NULL, 'TflA', NULL, NULL, NULL, 2),
(4550, NULL, 'cd05777', NULL, NULL, 'DNA_polB_delta_exo', NULL, 'DNA_polB_delta_exo', NULL, NULL, NULL, 2); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(4551, NULL, 'cd19691', NULL, NULL, 'bHLH_dnHLH_ID1', NULL, 'bHLH_dnHLH_ID1', NULL, NULL, NULL, 2),
(4552, NULL, 'cd13231', NULL, NULL, 'PH2_SSRP1-like', NULL, 'PH2_SSRP1-like', NULL, NULL, NULL, 2),
(4553, NULL, 'cd18401', NULL, NULL, 'BTB_POZ_TNFAIP1_BACURD2', NULL, 'BTB_POZ_TNFAIP1_BACURD2', NULL, NULL, NULL, 2),
(4554, NULL, 'cd19020', NULL, NULL, 'LGIC_ECD_nAChR_A7', NULL, 'LGIC_ECD_nAChR_A7', NULL, NULL, NULL, 2),
(4555, NULL, 'cd15090', NULL, NULL, '7tmA_Mu_opioid_R', NULL, '7tmA_Mu_opioid_R', NULL, NULL, NULL, 2),
(4556, NULL, 'cd03273', NULL, NULL, 'ABC_SMC2_euk', NULL, 'ABC_SMC2_euk', NULL, NULL, 25450, 2),
(4557, NULL, 'cd04660', NULL, NULL, 'nsLTP_like', NULL, 'nsLTP_like', NULL, NULL, 34556, 2),
(4558, NULL, 'cd07674', NULL, NULL, 'F-BAR_FCHO1', NULL, 'F-BAR_FCHO1', NULL, NULL, 33636, 2),
(4559, NULL, 'cd03542', NULL, NULL, 'Rieske_RO_Alpha_HBDO', NULL, 'Rieske_RO_Alpha_HBDO', NULL, NULL, NULL, 2),
(4560, NULL, 'cd07160', NULL, NULL, 'NR_DBD_LXR', NULL, 'NR_DBD_LXR', NULL, NULL, NULL, 2),
(4561, NULL, 'cd07393', NULL, NULL, 'MPP_DR1119', NULL, 'MPP_DR1119', NULL, NULL, NULL, 2),
(4562, NULL, 'cd08610', NULL, NULL, 'GDPD_GDE6', NULL, 'GDPD_GDE6', NULL, NULL, NULL, 2),
(4563, NULL, 'cd19058', NULL, NULL, 'LGIC_TM_GABAAR_pi', NULL, 'LGIC_TM_GABAAR_pi', NULL, NULL, NULL, 2),
(4564, NULL, 'cd05601', NULL, NULL, 'STKc_CRIK', NULL, 'STKc_CRIK', NULL, NULL, 31122, 2),
(4565, NULL, 'cd08244', NULL, NULL, 'MDR_enoyl_red', NULL, 'MDR_enoyl_red', NULL, NULL, NULL, 2),
(4566, NULL, 'cd03375', NULL, NULL, 'TPP_OGFOR', NULL, 'TPP_OGFOR', NULL, NULL, NULL, 2),
(4567, NULL, 'cd02570', NULL, NULL, 'PseudoU_synth_EcTruA', NULL, 'PseudoU_synth_EcTruA', NULL, NULL, 7190, 2),
(4568, NULL, 'cd07520', NULL, NULL, 'HAD_like', NULL, 'HAD_like', NULL, NULL, NULL, 2),
(4569, NULL, 'cd07432', NULL, NULL, 'PHP_HisPPase', NULL, 'PHP_HisPPase', NULL, NULL, NULL, 2),
(4570, NULL, 'cd13362', NULL, NULL, 'PH_PLC_gamma', NULL, 'PH_PLC_gamma', NULL, NULL, NULL, 2),
(4571, NULL, 'cd19566', NULL, NULL, 'serpinB7_megsin', NULL, 'serpinB7_megsin', NULL, NULL, NULL, 2),
(4572, NULL, 'cd12060', NULL, NULL, 'SH3_alphaPIX', NULL, 'SH3_alphaPIX', NULL, NULL, 32931, 2),
(4573, NULL, 'cd14251', NULL, NULL, 'PL-6', NULL, 'PL-6', NULL, NULL, 33851, 2),
(4574, NULL, 'cd14565', NULL, NULL, 'DSP_MKP_classI', NULL, 'DSP_MKP_classI', NULL, NULL, NULL, 2),
(4575, NULL, 'cd16620', NULL, NULL, 'vRING-HC-C4C4_RBBP6', NULL, 'vRING-HC-C4C4_RBBP6', NULL, NULL, NULL, 2),
(4576, NULL, 'cd00041', NULL, NULL, 'CUB', NULL, 'CUB', NULL, NULL, 3339, 2),
(4577, NULL, 'cd00540', NULL, NULL, 'AAG', NULL, 'AAG', NULL, NULL, 2693, 2),
(4578, NULL, 'cd15044', NULL, NULL, '7tmC_V2R_AA_sensing_receptor-like', NULL, '7tmC_V2R_AA_sensing_receptor-like', NULL, NULL, NULL, 2),
(4579, NULL, 'cd14787', NULL, NULL, 'Tiki_TraB-like', NULL, 'Tiki_TraB-like', NULL, NULL, NULL, 2),
(4580, NULL, 'cd08576', NULL, NULL, 'GDPD_like_SMaseD_PLD', NULL, 'GDPD_like_SMaseD_PLD', NULL, NULL, NULL, 2),
(4581, NULL, 'cd01555', NULL, NULL, 'UdpNAET', NULL, 'UdpNAET', NULL, NULL, 4695, 2),
(4582, NULL, 'cd14265', NULL, NULL, 'UDPK_IM_like', NULL, 'UDPK_IM_like', NULL, NULL, 32548, 2),
(4583, NULL, 'cd07137', NULL, NULL, 'ALDH_F3FHI', NULL, 'ALDH_F3FHI', NULL, NULL, NULL, 2),
(4584, NULL, 'cd21641', NULL, NULL, 'ORF8-Ig_SARS-CoV-2-like', NULL, 'ORF8-Ig_SARS-CoV-2-like', NULL, NULL, 37638, 2),
(4585, NULL, 'cd19547', NULL, NULL, 'beta-lac_NRPS', NULL, 'beta-lac_NRPS', NULL, NULL, NULL, 2),
(4586, NULL, 'cd03193', NULL, NULL, 'GST_C_Metaxin', NULL, 'GST_C_Metaxin', NULL, NULL, NULL, 2),
(4587, NULL, 'cd03145', NULL, NULL, 'GAT1_cyanophycinase', NULL, 'GAT1_cyanophycinase', NULL, NULL, NULL, 2),
(4588, NULL, 'cd18690', NULL, NULL, 'PIN_VapC-like', NULL, 'PIN_VapC-like', NULL, NULL, NULL, 2),
(4589, NULL, 'cd20235', NULL, NULL, 'PFM_spherulin-2a-like', NULL, 'PFM_spherulin-2a-like', NULL, NULL, NULL, 2),
(4590, NULL, 'cd02612', NULL, NULL, 'HAD_PGPPase', NULL, 'HAD_PGPPase', NULL, NULL, NULL, 2),
(4591, NULL, 'cd13287', NULL, NULL, 'PH_ORP3_ORP6_ORP7', NULL, 'PH_ORP3_ORP6_ORP7', NULL, NULL, NULL, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(4592, NULL, 'cd17975', NULL, NULL, 'DEXHc_DHX29', NULL, 'DEXHc_DHX29', NULL, NULL, NULL, 2),
(4593, NULL, 'cd04783', NULL, NULL, 'HTH_MerR1', NULL, 'HTH_MerR1', NULL, NULL, 13361, 2),
(4594, NULL, 'cd07589', NULL, NULL, 'BAR_DNMBP', NULL, 'BAR_DNMBP', NULL, NULL, NULL, 2),
(4595, NULL, 'cd03421', NULL, NULL, 'SirA_like_N', NULL, 'SirA_like_N', NULL, NULL, NULL, 2),
(4596, NULL, 'cd07043', NULL, NULL, 'STAS_anti-anti-sigma_factors', NULL, 'STAS_anti-anti-sigma_factors', NULL, NULL, NULL, 2),
(4597, NULL, 'cd16491', NULL, NULL, 'RING-CH-C4HC3_LTN1', NULL, 'RING-CH-C4HC3_LTN1', NULL, NULL, 27315, 2),
(4598, NULL, 'cd11454', NULL, NULL, 'bHLH_AtIND_like', NULL, 'bHLH_AtIND_like', NULL, NULL, NULL, 2),
(4599, NULL, 'cd17275', NULL, NULL, 'RMtype1_S_MjaORF132P-TRD1-CR1_like', NULL, 'RMtype1_S_MjaORF132P-TRD1-CR1_like', NULL, NULL, NULL, 2),
(4600, NULL, 'cd03031', NULL, NULL, 'GRX_GRX_like', NULL, 'GRX_GRX_like', NULL, NULL, NULL, 2),
(4601, NULL, 'cd07900', NULL, NULL, 'Adenylation_DNA_ligase_I_Euk', NULL, 'Adenylation_DNA_ligase_I_Euk', NULL, NULL, NULL, 2),
(4602, NULL, 'cd11532', NULL, NULL, 'NTP-PPase_COG4997', NULL, 'NTP-PPase_COG4997', NULL, NULL, 32679, 2),
(4603, NULL, 'cd13887', NULL, NULL, 'CuRO_2_MCO_like_2', NULL, 'CuRO_2_MCO_like_2', NULL, NULL, NULL, 2),
(4604, NULL, 'cd07980', NULL, NULL, 'TFIIF_beta', NULL, 'TFIIF_beta', NULL, NULL, NULL, 2),
(4605, NULL, 'cd13587', NULL, NULL, 'PBP2_polyamine_2', NULL, 'PBP2_polyamine_2', NULL, NULL, NULL, 2),
(4606, NULL, 'cd08665', NULL, NULL, 'APC10-CUL7', NULL, 'APC10-CUL7', NULL, NULL, NULL, 2),
(4607, NULL, 'cd15957', NULL, NULL, '7tmA_Beta2_AR', NULL, '7tmA_Beta2_AR', NULL, NULL, NULL, 2),
(4608, NULL, 'cd12357', NULL, NULL, 'RRM_PPARGC1A_like', NULL, 'RRM_PPARGC1A_like', NULL, NULL, NULL, 2),
(4609, NULL, 'cd12104', NULL, NULL, 'DD_RIIbeta_PKA', NULL, 'DD_RIIbeta_PKA', NULL, NULL, NULL, 2),
(4610, NULL, 'cd09143', NULL, NULL, 'PLDc_vPLD1_2_like_bac_2', NULL, 'PLDc_vPLD1_2_like_bac_2', NULL, NULL, NULL, 2),
(4611, NULL, 'cd21644', NULL, NULL, 'batCoV-HKU9_NS7b', NULL, 'batCoV-HKU9_NS7b', NULL, NULL, 36072, 2),
(4612, NULL, 'cd13113', NULL, NULL, 'Wnt', NULL, 'Wnt', NULL, NULL, NULL, 2),
(4613, NULL, 'cd16492', NULL, NULL, 'RING-CH-C4HC3_NFX1_like', NULL, 'RING-CH-C4HC3_NFX1_like', NULL, NULL, NULL, 2),
(4614, NULL, 'cd00088', NULL, NULL, 'HPT', NULL, 'HPT', NULL, NULL, 7469, 2),
(4615, NULL, 'cd15058', NULL, NULL, '7tmA_Beta_AR', NULL, '7tmA_Beta_AR', NULL, NULL, NULL, 2),
(4616, NULL, 'cd19701', NULL, NULL, 'bHLH_TS_HEN1', NULL, 'bHLH_TS_HEN1', NULL, NULL, NULL, 2),
(4617, NULL, 'cd18490', NULL, NULL, 'BACK_BTBD8', NULL, 'BACK_BTBD8', NULL, NULL, 33823, 2),
(4618, NULL, 'cd09252', NULL, NULL, 'AP-3_Mu3_Cterm', NULL, 'AP-3_Mu3_Cterm', NULL, NULL, NULL, 2),
(4619, NULL, 'cd02008', NULL, NULL, 'TPP_IOR_alpha', NULL, 'TPP_IOR_alpha', NULL, NULL, NULL, 2),
(4620, NULL, 'cd05298', NULL, NULL, 'GH4_GlvA_pagL_like', NULL, 'GH4_GlvA_pagL_like', NULL, NULL, NULL, 2),
(4621, NULL, 'cd16750', NULL, NULL, 'RING-HC_SH3RF3', NULL, 'RING-HC_SH3RF3', NULL, NULL, NULL, 2),
(4622, NULL, 'cd03719', NULL, NULL, 'SOCS_SSB2', NULL, 'SOCS_SSB2', NULL, NULL, 27827, 2),
(4623, NULL, 'cd16595', NULL, NULL, 'RING-HC_TRIM17_C-IV', NULL, 'RING-HC_TRIM17_C-IV', NULL, NULL, NULL, 2),
(4624, NULL, 'cd04816', NULL, NULL, 'PA_SaNapH_like', NULL, 'PA_SaNapH_like', NULL, NULL, NULL, 2),
(4625, NULL, 'cd12483', NULL, NULL, 'RRM1_hnRNPQ', NULL, 'RRM1_hnRNPQ', NULL, NULL, 3120, 2),
(4626, NULL, 'cd06872', NULL, NULL, 'PX_SNX19_like_plant', NULL, 'PX_SNX19_like_plant', NULL, NULL, NULL, 2),
(4627, NULL, 'cd15925', NULL, NULL, '7tmA_RNL3R2', NULL, '7tmA_RNL3R2', NULL, NULL, NULL, 2),
(4628, NULL, 'cd06942', NULL, NULL, 'NR_LBD_Sex_1_like', NULL, 'NR_LBD_Sex_1_like', NULL, NULL, NULL, 2),
(4629, NULL, 'cd01918', NULL, NULL, 'HprK_C', NULL, 'HprK_C', NULL, NULL, 11475, 2),
(4630, NULL, 'cd00009', NULL, NULL, 'AAA', NULL, 'AAA', NULL, NULL, NULL, 2),
(4631, NULL, 'cd07884', NULL, NULL, 'RHD-n_Relish', NULL, 'RHD-n_Relish', NULL, NULL, NULL, 2),
(4632, NULL, 'cd16544', NULL, NULL, 'RING-HC_RNF138', NULL, 'RING-HC_RNF138', NULL, NULL, NULL, 2);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(4633, NULL, 'cd16342', NULL, NULL, 'FusC_FusB', NULL, 'FusC_FusB', NULL, NULL, NULL, 2),
(4634, NULL, 'cd02879', NULL, NULL, 'GH18_plant_chitinase_class_V', NULL, 'GH18_plant_chitinase_class_V', NULL, NULL, NULL, 2),
(4635, NULL, 'cd08242', NULL, NULL, 'MDR_like', NULL, 'MDR_like', NULL, NULL, NULL, 2),
(4636, NULL, 'cd15776', NULL, NULL, 'FYVE2_PCLO', NULL, 'FYVE2_PCLO', NULL, NULL, NULL, 2),
(4637, NULL, 'cd20174', NULL, NULL, 'GH18_LinChi78-like_UFR', NULL, 'GH18_LinChi78-like_UFR', NULL, NULL, NULL, 2),
(4638, NULL, 'cd01801', NULL, NULL, 'Ubl_TECR_like', NULL, 'Ubl_TECR_like', NULL, NULL, NULL, 2),
(4639, NULL, 'cd15934', NULL, NULL, '7tmC_mGluRs_group2_3', NULL, '7tmC_mGluRs_group2_3', NULL, NULL, NULL, 2),
(4640, NULL, 'cd00462', NULL, NULL, 'PTH', NULL, 'PTH', NULL, NULL, 2443, 2),
(4641, NULL, 'cd11663', NULL, NULL, 'GH119_BcIgtZ-like', NULL, 'GH119_BcIgtZ-like', NULL, NULL, NULL, 2),
(4642, NULL, 'cd05016', NULL, NULL, 'SIS_PGI_2', NULL, 'SIS_PGI_2', NULL, NULL, 28827, 2),
(4643, NULL, 'cd05299', NULL, NULL, 'CtBP_dh', NULL, 'CtBP_dh', NULL, NULL, 34262, 2),
(4644, NULL, 'cd01657', NULL, NULL, 'Ribosomal_L7_archeal_euk', NULL, 'Ribosomal_L7_archeal_euk', NULL, NULL, 27984, 2),
(4645, NULL, 'cd18832', NULL, NULL, 'GH43_GsAbnA-like', NULL, 'GH43_GsAbnA-like', NULL, NULL, NULL, 2),
(4646, NULL, 'cd01788', NULL, NULL, 'Ubl_ElonginB', NULL, 'Ubl_ElonginB', NULL, NULL, NULL, 2),
(4647, NULL, 'cd03407', NULL, NULL, 'SPFH_like_u4', NULL, 'SPFH_like_u4', NULL, NULL, NULL, 2),
(4648, NULL, 'cd00327', NULL, NULL, 'cond_enzymes', NULL, 'cond_enzymes', NULL, NULL, NULL, 2),
(4649, NULL, 'cd14876', NULL, NULL, 'MYSc_Myo14', NULL, 'MYSc_Myo14', NULL, NULL, 28282, 2),
(4650, NULL, 'cd09695', NULL, NULL, 'Csx16_III-U', NULL, 'Csx16_III-U', NULL, NULL, NULL, 2),
(4651, NULL, 'cd05628', NULL, NULL, 'STKc_NDR1', NULL, 'STKc_NDR1', NULL, NULL, NULL, 2),
(4652, NULL, 'cd07494', NULL, NULL, 'Peptidases_S8_10', NULL, 'Peptidases_S8_10', NULL, NULL, NULL, 2),
(4653, NULL, 'cd21399', NULL, NULL, 'ZBD_nv_SF1_Hel-like', NULL, 'ZBD_nv_SF1_Hel-like', NULL, NULL, NULL, 2),
(4654, NULL, 'cd13112', NULL, NULL, 'POLO_box', NULL, 'POLO_box', NULL, NULL, NULL, 2),
(4655, NULL, 'cd17015', NULL, NULL, 'ING_plant', NULL, 'ING_plant', NULL, NULL, NULL, 2),
(4656, NULL, 'cd12577', NULL, NULL, 'RRM1_Hrp1p', NULL, 'RRM1_Hrp1p', NULL, NULL, 13876, 2),
(4657, NULL, 'cd13137', NULL, NULL, 'MATE_NorM_like', NULL, 'MATE_NorM_like', NULL, NULL, NULL, 2),
(4658, NULL, 'cd02670', NULL, NULL, 'Peptidase_C19N', NULL, 'Peptidase_C19N', NULL, NULL, NULL, 2),
(4659, NULL, 'cd07037', NULL, NULL, 'TPP_PYR_MenD', NULL, 'TPP_PYR_MenD', NULL, NULL, NULL, 2),
(4660, NULL, 'cd14503', NULL, NULL, 'PTP-bact', NULL, 'PTP-bact', NULL, NULL, NULL, 2),
(4661, NULL, 'cd08517', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_13', NULL, 'PBP2_NikA_DppA_OppA_like_13', NULL, NULL, NULL, 2),
(4662, NULL, 'cd21406', NULL, NULL, '1B_nv_SF1_Hel-like', NULL, '1B_nv_SF1_Hel-like', NULL, NULL, NULL, 2),
(4663, NULL, 'cd01413', NULL, NULL, 'SIR2_Af2', NULL, 'SIR2_Af2', NULL, NULL, NULL, 2),
(4664, NULL, 'cd01465', NULL, NULL, 'vWA_subgroup', NULL, 'vWA_subgroup', NULL, NULL, NULL, 2),
(4665, NULL, 'cd13253', NULL, NULL, 'PH1_ARAP', NULL, 'PH1_ARAP', NULL, NULL, NULL, 2),
(4666, NULL, 'cd19354', NULL, NULL, 'Wnt_Wnt9b', NULL, 'Wnt_Wnt9b', NULL, NULL, NULL, 2),
(4667, NULL, 'cd08765', NULL, NULL, 'Cyt_b561_CYBRD1', NULL, 'Cyt_b561_CYBRD1', NULL, NULL, NULL, 2),
(4668, NULL, 'cd12494', NULL, NULL, 'RRM3_hnRNPR', NULL, 'RRM3_hnRNPR', NULL, NULL, NULL, 2),
(4669, NULL, 'cd03044', NULL, NULL, 'GST_N_EF1Bgamma', NULL, 'GST_N_EF1Bgamma', NULL, NULL, NULL, 2),
(4670, NULL, 'cd05649', NULL, NULL, 'M20_ArgE_DapE-like', NULL, 'M20_ArgE_DapE-like', NULL, NULL, NULL, 2),
(4671, NULL, 'cd11696', NULL, NULL, 'DHR2_DOCK_B', NULL, 'DHR2_DOCK_B', NULL, NULL, NULL, 2),
(4672, NULL, 'cd17065', NULL, NULL, 'Ubl_UBP24', NULL, 'Ubl_UBP24', NULL, NULL, NULL, 2),
(4673, NULL, 'cd03568', NULL, NULL, 'VHS_STAM', NULL, 'VHS_STAM', NULL, NULL, NULL, 2),
(4674, NULL, 'cd07121', NULL, NULL, 'ALDH_EutE', NULL, 'ALDH_EutE', NULL, NULL, 13217, 2);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(4675, NULL, 'cd17071', NULL, NULL, 'DCX1_DCDC2_like', NULL, 'DCX1_DCDC2_like', NULL, NULL, NULL, 2),
(4676, NULL, 'cd02962', NULL, NULL, 'TMX2', NULL, 'TMX2', NULL, NULL, 32809, 2),
(4677, NULL, 'cd01703', NULL, NULL, 'PolY_Pol_iota', NULL, 'PolY_Pol_iota', NULL, NULL, NULL, 2),
(4678, NULL, 'cd07883', NULL, NULL, 'RHD-n_NFkB', NULL, 'RHD-n_NFkB', NULL, NULL, NULL, 2),
(4679, NULL, 'cd14840', NULL, NULL, 'D-Ala-D-Ala_dipeptidase_Aad', NULL, 'D-Ala-D-Ala_dipeptidase_Aad', NULL, NULL, NULL, 2),
(4680, NULL, 'cd15214', NULL, NULL, '7tmA_GPR161', NULL, '7tmA_GPR161', NULL, NULL, NULL, 2),
(4681, NULL, 'cd00876', NULL, NULL, 'Ras', NULL, 'Ras', NULL, NULL, NULL, 2),
(4682, NULL, 'cd08231', NULL, NULL, 'MDR_TM0436_like', NULL, 'MDR_TM0436_like', NULL, NULL, NULL, 2),
(4683, NULL, 'cd14868', NULL, NULL, 'uS7_Mitochondria_Fungi', NULL, 'uS7_Mitochondria_Fungi', NULL, NULL, NULL, 2),
(4684, NULL, 'cd03574', NULL, NULL, 'NTR_complement_C345C', NULL, 'NTR_complement_C345C', NULL, NULL, NULL, 2),
(4685, NULL, 'cd21537', NULL, NULL, 'SUD_C_HKU9_CoV_Nsp3', NULL, 'SUD_C_HKU9_CoV_Nsp3', NULL, NULL, 33696, 2),
(4686, NULL, 'cd13310', NULL, NULL, 'PH_RalGPS1_2', NULL, 'PH_RalGPS1_2', NULL, NULL, NULL, 2),
(4687, NULL, 'cd18027', NULL, NULL, 'DEXHc_SKIV2L', NULL, 'DEXHc_SKIV2L', NULL, NULL, NULL, 2),
(4688, NULL, 'cd01750', NULL, NULL, 'GATase1_CobQ', NULL, 'GATase1_CobQ', NULL, NULL, 32302, 2),
(4689, NULL, 'cd15030', NULL, NULL, '7tmF_SMO_homolog', NULL, '7tmF_SMO_homolog', NULL, NULL, 27390, 2),
(4690, NULL, 'cd15322', NULL, NULL, '7tmA_alpha2A_AR', NULL, '7tmA_alpha2A_AR', NULL, NULL, NULL, 2),
(4691, NULL, 'cd17954', NULL, NULL, 'DEADc_DDX47', NULL, 'DEADc_DDX47', NULL, NULL, 34136, 2),
(4692, NULL, 'cd12129', NULL, NULL, 'PE-PC-PEC_alpha', NULL, 'PE-PC-PEC_alpha', NULL, NULL, NULL, 2),
(4693, NULL, 'cd18662', NULL, NULL, 'CD2_tandem_CHD3-4_like', NULL, 'CD2_tandem_CHD3-4_like', NULL, NULL, NULL, 2),
(4694, NULL, 'cd18417', NULL, NULL, 'BTB_POZ_KCND1', NULL, 'BTB_POZ_KCND1', NULL, NULL, NULL, 2),
(4695, NULL, 'cd12319', NULL, NULL, 'RRM4_MRD1', NULL, 'RRM4_MRD1', NULL, NULL, NULL, 2),
(4696, NULL, 'cd11272', NULL, NULL, 'Sema_plexin_A2', NULL, 'Sema_plexin_A2', NULL, NULL, 35423, 2),
(4697, NULL, 'cd08695', NULL, NULL, 'C2_Dock-B', NULL, 'C2_Dock-B', NULL, NULL, 29623, 2),
(4698, NULL, 'cd12457', NULL, NULL, 'RRM_XMAS2', NULL, 'RRM_XMAS2', NULL, NULL, 4166, 2),
(4699, NULL, 'cd18388', NULL, NULL, 'BTB_POZ_KCTD15', NULL, 'BTB_POZ_KCTD15', NULL, NULL, 37363, 2),
(4700, NULL, 'cd18040', NULL, NULL, 'DEXXc_HELZ2-C', NULL, 'DEXXc_HELZ2-C', NULL, NULL, NULL, 2),
(4701, NULL, 'cd09395', NULL, NULL, 'LIM2_Rga', NULL, 'LIM2_Rga', NULL, NULL, NULL, 2),
(4702, NULL, 'cd15339', NULL, NULL, '7tmA_MCHR2', NULL, '7tmA_MCHR2', NULL, NULL, NULL, 2),
(4703, NULL, 'cd05508', NULL, NULL, 'Bromo_RACK7', NULL, 'Bromo_RACK7', NULL, NULL, 31191, 2),
(4704, NULL, 'cd07362', NULL, NULL, 'HPCD_like', NULL, 'HPCD_like', NULL, NULL, NULL, 2),
(4705, NULL, 'cd17423', NULL, NULL, 'MFS_MCT11_13', NULL, 'MFS_MCT11_13', NULL, NULL, NULL, 2),
(4706, NULL, 'cd00822', NULL, NULL, 'TopoII_Trans_DNA_gyrase', NULL, 'TopoII_Trans_DNA_gyrase', NULL, NULL, NULL, 2),
(4707, NULL, 'cd01250', NULL, NULL, 'PH_AGAP', NULL, 'PH_AGAP', NULL, NULL, NULL, 2),
(4708, NULL, 'cd15678', NULL, NULL, 'PHD_BRPF3', NULL, 'PHD_BRPF3', NULL, NULL, NULL, 2),
(4709, NULL, 'cd15870', NULL, NULL, 'R-SNARE_VAMP2', NULL, 'R-SNARE_VAMP2', NULL, NULL, NULL, 2),
(4710, NULL, 'cd08750', NULL, NULL, 'RGS_GRK4', NULL, 'RGS_GRK4', NULL, NULL, NULL, 2),
(4711, NULL, 'cd01576', NULL, NULL, 'AcnB_Swivel', NULL, 'AcnB_Swivel', NULL, NULL, 9978, 2),
(4712, NULL, 'cd00817', NULL, NULL, 'ValRS_core', NULL, 'ValRS_core', NULL, NULL, NULL, 2),
(4713, NULL, 'cd09012', NULL, NULL, 'VOC_like', NULL, 'VOC_like', NULL, NULL, NULL, 2),
(4714, NULL, 'cd17280', NULL, NULL, 'RMtype1_S_MspEN3ORF6650P_TRD2-CR2_like', NULL, 'RMtype1_S_MspEN3ORF6650P_TRD2-CR2_like', NULL, NULL, NULL, 2),
(4715, NULL, 'cd12948', NULL, NULL, 'NOPS_PSF', NULL, 'NOPS_PSF', NULL, NULL, 32170, 2),
(4716, NULL, 'cd03378', NULL, NULL, 'beta_CA_cladeC', NULL, 'beta_CA_cladeC', NULL, NULL, NULL, 2);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(4717, NULL, 'cd19783', NULL, NULL, 'Bbox2_TRIM43-like', NULL, 'Bbox2_TRIM43-like', NULL, NULL, NULL, 2),
(4718, NULL, 'cd16205', NULL, NULL, 'EFh_PI-PLCeta', NULL, 'EFh_PI-PLCeta', NULL, NULL, NULL, 2),
(4719, NULL, 'cd04213', NULL, NULL, 'CuRO_CcO_Caa3_II', NULL, 'CuRO_CcO_Caa3_II', NULL, NULL, 7293, 2),
(4720, NULL, 'cd04751', NULL, NULL, 'Commd3', NULL, 'Commd3', NULL, NULL, NULL, 2),
(4721, NULL, 'cd03745', NULL, NULL, 'SOCS_WSB2_SWIP2', NULL, 'SOCS_WSB2_SWIP2', NULL, NULL, NULL, 2),
(4722, NULL, 'cd15262', NULL, NULL, '7tmB1_NPR_B3_insect-like', NULL, '7tmB1_NPR_B3_insect-like', NULL, NULL, NULL, 2),
(4723, NULL, 'cd18533', NULL, NULL, 'PTP_fungal', NULL, 'PTP_fungal', NULL, NULL, NULL, 2),
(4724, NULL, 'cd00173', NULL, NULL, 'SH2', NULL, 'SH2', NULL, NULL, NULL, 2),
(4725, NULL, 'cd11436', NULL, NULL, 'bHLH-PAS_AhR', NULL, 'bHLH-PAS_AhR', NULL, NULL, NULL, 2),
(4726, NULL, 'cd11450', NULL, NULL, 'bHLH_AtFIT_like', NULL, 'bHLH_AtFIT_like', NULL, NULL, NULL, 2),
(4727, NULL, 'cd13431', NULL, NULL, 'LDT_IgD_like_1', NULL, 'LDT_IgD_like_1', NULL, NULL, NULL, 2),
(4728, NULL, 'cd17595', NULL, NULL, 'REC_TrxB', NULL, 'REC_TrxB', NULL, NULL, NULL, 2),
(4729, NULL, 'cd00780', NULL, NULL, 'NTF2', NULL, 'NTF2', NULL, NULL, 7597, 2),
(4730, NULL, 'cd17127', NULL, NULL, 'Ubl_TBK1', NULL, 'Ubl_TBK1', NULL, NULL, NULL, 2),
(4731, NULL, 'cd15555', NULL, NULL, 'PHD_KDM2A_2B', NULL, 'PHD_KDM2A_2B', NULL, NULL, NULL, 2),
(4732, NULL, 'cd16522', NULL, NULL, 'RING-HC_MSL2', NULL, 'RING-HC_MSL2', NULL, NULL, NULL, 2),
(4733, NULL, 'cd05536', NULL, NULL, 'POLBc_B3', NULL, 'POLBc_B3', NULL, NULL, NULL, 2),
(4734, NULL, 'cd18925', NULL, NULL, 'bHLHzip_TFEC', NULL, 'bHLHzip_TFEC', NULL, NULL, NULL, 2),
(4735, NULL, 'cd09386', NULL, NULL, 'LIM1_LMO4', NULL, 'LIM1_LMO4', NULL, NULL, NULL, 2),
(4736, NULL, 'cd09401', NULL, NULL, 'LIM_TLP_like', NULL, 'LIM_TLP_like', NULL, NULL, NULL, 2),
(4737, NULL, 'cd11335', NULL, NULL, 'AmyAc_MTase_N', NULL, 'AmyAc_MTase_N', NULL, NULL, NULL, 2),
(4738, NULL, 'cd01056', NULL, NULL, 'Euk_Ferritin', NULL, 'Euk_Ferritin', NULL, NULL, NULL, 2),
(4739, NULL, 'cd11494', NULL, NULL, 'SLC5sbd_NIS-like_u2', NULL, 'SLC5sbd_NIS-like_u2', NULL, NULL, NULL, 2),
(4740, NULL, 'cd19573', NULL, NULL, 'serpinE2_GDN', NULL, 'serpinE2_GDN', NULL, NULL, NULL, 2),
(4741, NULL, 'cd12068', NULL, NULL, 'SH3_MYO15B', NULL, 'SH3_MYO15B', NULL, NULL, 16528, 2),
(4742, NULL, 'cd02170', NULL, NULL, 'cytidylyltransferase', NULL, 'cytidylyltransferase', NULL, NULL, NULL, 2),
(4743, NULL, 'cd17277', NULL, NULL, 'RMtype1_M_Cni19672ORF1405P_RMtype11G_Hci611ORF...', NULL, 'RMtype1_M_Cni19672ORF1405P_RMtype11G_Hci611ORFHP_TRD1-CR1_like', NULL, NULL, NULL, 2),
(4744, NULL, 'cd18631', NULL, NULL, 'CD_HP1_like', NULL, 'CD_HP1_like', NULL, NULL, NULL, 2),
(4745, NULL, 'cd04446', NULL, NULL, 'DEP_DEPDC4', NULL, 'DEP_DEPDC4', NULL, NULL, NULL, 2),
(4746, NULL, 'cd11492', NULL, NULL, 'SLC5sbd_NIS-SMVT', NULL, 'SLC5sbd_NIS-SMVT', NULL, NULL, NULL, 2),
(4747, NULL, 'cd13165', NULL, NULL, 'PTB_DOK7', NULL, 'PTB_DOK7', NULL, NULL, 32332, 2),
(4748, NULL, 'cd09224', NULL, NULL, 'CytoC_RC', NULL, 'CytoC_RC', NULL, NULL, 3356, 2),
(4749, NULL, 'cd20223', NULL, NULL, 'PFM_epsilon-toxin-like', NULL, 'PFM_epsilon-toxin-like', NULL, NULL, NULL, 2),
(4750, NULL, 'cd04717', NULL, NULL, 'BAH_polybromo', NULL, 'BAH_polybromo', NULL, NULL, NULL, 2),
(4751, NULL, 'cd10384', NULL, NULL, 'SH2_SOCS3', NULL, 'SH2_SOCS3', NULL, NULL, 31845, 2),
(4752, NULL, 'cd13222', NULL, NULL, 'PH-GRAM_GEM', NULL, 'PH-GRAM_GEM', NULL, NULL, NULL, 2),
(4753, NULL, 'cd11020', NULL, NULL, 'CuRO_1_CuNIR', NULL, 'CuRO_1_CuNIR', NULL, NULL, NULL, 2),
(4754, NULL, 'cd05213', NULL, NULL, 'NAD_bind_Glutamyl_tRNA_reduct', NULL, 'NAD_bind_Glutamyl_tRNA_reduct', NULL, NULL, NULL, 2),
(4755, NULL, 'cd02645', NULL, NULL, 'R3H_AAA', NULL, 'R3H_AAA', NULL, NULL, 26812, 2),
(4756, NULL, 'cd05790', NULL, NULL, 'S1_Rrp40', NULL, 'S1_Rrp40', NULL, NULL, 33137, 2),
(4757, NULL, 'cd00083', NULL, NULL, 'bHLH_SF', NULL, 'bHLH_SF', NULL, NULL, NULL, 2),
(4758, NULL, 'cd01086', NULL, NULL, 'MetAP1', NULL, 'MetAP1', NULL, NULL, 6896, 2);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(4759, NULL, 'cd05650', NULL, NULL, 'M20_ArgE_DapE-like', NULL, 'M20_ArgE_DapE-like', NULL, NULL, NULL, 2),
(4760, NULL, 'cd10294', NULL, NULL, 'GST_C_ValRS_N', NULL, 'GST_C_ValRS_N', NULL, NULL, NULL, 2),
(4761, NULL, 'cd16513', NULL, NULL, 'RING1-HC_LONFs', NULL, 'RING1-HC_LONFs', NULL, NULL, NULL, 2),
(4762, NULL, 'cd04652', NULL, NULL, 'LbH_eIF2B_gamma_C', NULL, 'LbH_eIF2B_gamma_C', NULL, NULL, NULL, 2),
(4763, NULL, 'cd07536', NULL, NULL, 'P-type_ATPase_APLT', NULL, 'P-type_ATPase_APLT', NULL, NULL, NULL, 2),
(4764, NULL, 'cd03034', NULL, NULL, 'ArsC_ArsC', NULL, 'ArsC_ArsC', NULL, NULL, 1779, 2),
(4765, NULL, 'cd12334', NULL, NULL, 'RRM1_SF3B4', NULL, 'RRM1_SF3B4', NULL, NULL, 14276, 2),
(4766, NULL, 'cd15377', NULL, NULL, '7tmA_P2Y1', NULL, '7tmA_P2Y1', NULL, NULL, NULL, 2),
(4767, NULL, 'cd11281', NULL, NULL, 'ADF_drebrin_like', NULL, 'ADF_drebrin_like', NULL, NULL, NULL, 2),
(4768, NULL, 'cd12462', NULL, NULL, 'RRM_SCAF8', NULL, 'RRM_SCAF8', NULL, NULL, 30770, 2),
(4769, NULL, 'cd14309', NULL, NULL, 'UBA_scDdi1_like', NULL, 'UBA_scDdi1_like', NULL, NULL, NULL, 2),
(4770, NULL, 'cd07122', NULL, NULL, 'ALDH_F20_ACDH', NULL, 'ALDH_F20_ACDH', NULL, NULL, NULL, 2),
(4771, NULL, 'cd20300', NULL, NULL, 'cupin_npun_f5605-like_N', NULL, 'cupin_npun_f5605-like_N', NULL, NULL, NULL, 2),
(4772, NULL, 'cd18329', NULL, NULL, 'BTB_POZ_ZBTB8A_BOZF1', NULL, 'BTB_POZ_ZBTB8A_BOZF1', NULL, NULL, NULL, 2),
(4773, NULL, 'cd07791', NULL, NULL, 'FGGY_GK2_bacteria', NULL, 'FGGY_GK2_bacteria', NULL, NULL, 30403, 2),
(4774, NULL, 'cd06146', NULL, NULL, 'mut-7_like_exo', NULL, 'mut-7_like_exo', NULL, NULL, 30785, 2),
(4775, NULL, 'cd17178', NULL, NULL, 'FERM_F1_PLEKHH1', NULL, 'FERM_F1_PLEKHH1', NULL, NULL, NULL, 2),
(4776, NULL, 'cd13146', NULL, NULL, 'MATE_like_6', NULL, 'MATE_like_6', NULL, NULL, NULL, 2),
(4777, NULL, 'cd04398', NULL, NULL, 'RhoGAP_fRGD1', NULL, 'RhoGAP_fRGD1', NULL, NULL, NULL, 2),
(4778, NULL, 'cd09809', NULL, NULL, 'human_WWOX_like_SDR_c-like', NULL, 'human_WWOX_like_SDR_c-like', NULL, NULL, 34512, 2),
(4779, NULL, 'cd08228', NULL, NULL, 'STKc_Nek6', NULL, 'STKc_Nek6', NULL, NULL, NULL, 2),
(4780, NULL, 'cd06498', NULL, NULL, 'ACD_alphaB-crystallin_HspB5', NULL, 'ACD_alphaB-crystallin_HspB5', NULL, NULL, 33476, 2),
(4781, NULL, 'cd14710', NULL, NULL, 'bZIP_HAC1-like', NULL, 'bZIP_HAC1-like', NULL, NULL, NULL, 2),
(4782, NULL, 'cd15212', NULL, NULL, '7tmA_GPR135', NULL, '7tmA_GPR135', NULL, NULL, NULL, 2),
(4783, NULL, 'cd11935', NULL, NULL, 'SH3_Nebulette_C', NULL, 'SH3_Nebulette_C', NULL, NULL, 33845, 2),
(4784, NULL, 'cd06289', NULL, NULL, 'PBP1_MalI-like', NULL, 'PBP1_MalI-like', NULL, NULL, NULL, 2),
(4785, NULL, 'cd15274', NULL, NULL, '7tmB1_calcitonin_R', NULL, '7tmB1_calcitonin_R', NULL, NULL, NULL, 2),
(4786, NULL, 'cd19796', NULL, NULL, 'Bbox2_TRIM71_C-VII', NULL, 'Bbox2_TRIM71_C-VII', NULL, NULL, NULL, 2),
(4787, NULL, 'cd02080', NULL, NULL, 'P-type_ATPase_cation', NULL, 'P-type_ATPase_cation', NULL, NULL, NULL, 2),
(4788, NULL, 'cd16858', NULL, NULL, 'ING_ING3_Yng2p', NULL, 'ING_ING3_Yng2p', NULL, NULL, NULL, 2),
(4789, NULL, 'cd19787', NULL, NULL, 'Bbox2_TRIM50-like', NULL, 'Bbox2_TRIM50-like', NULL, NULL, NULL, 2),
(4790, NULL, 'cd04490', NULL, NULL, 'PolII_SU_OBF', NULL, 'PolII_SU_OBF', NULL, NULL, NULL, 2),
(4791, NULL, 'cd15258', NULL, NULL, '7tmB2_GPR126-like_Adhesion_VIII', NULL, '7tmB2_GPR126-like_Adhesion_VIII', NULL, NULL, NULL, 2),
(4792, NULL, 'cd14801', NULL, NULL, 'STAT_DBD', NULL, 'STAT_DBD', NULL, NULL, NULL, 2),
(4793, NULL, 'cd01336', NULL, NULL, 'MDH_cytoplasmic_cytosolic', NULL, 'MDH_cytoplasmic_cytosolic', NULL, NULL, 9648, 2),
(4794, NULL, 'cd06988', NULL, NULL, 'cupin_DddK', NULL, 'cupin_DddK', NULL, NULL, NULL, 2),
(4795, NULL, 'cd08439', NULL, NULL, 'PBP2_LrhA_like', NULL, 'PBP2_LrhA_like', NULL, NULL, NULL, 2),
(4796, NULL, 'cd01446', NULL, NULL, 'DSP_MapKP', NULL, 'DSP_MapKP', NULL, NULL, NULL, 2),
(4797, NULL, 'cd06650', NULL, NULL, 'PKc_MEK1', NULL, 'PKc_MEK1', NULL, NULL, NULL, 2),
(4798, NULL, 'cd14108', NULL, NULL, 'STKc_SPEG_rpt1', NULL, 'STKc_SPEG_rpt1', NULL, NULL, NULL, 2);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(4799, NULL, 'cd12220', NULL, NULL, 'Pesticin_RB', NULL, 'Pesticin_RB', NULL, NULL, 31459, 2),
(4800, NULL, 'cd19929', NULL, NULL, 'psREC_Atg32', NULL, 'psREC_Atg32', NULL, NULL, NULL, 2),
(4801, NULL, 'cd02555', NULL, NULL, 'PSSA_1', NULL, 'PSSA_1', NULL, NULL, NULL, 2),
(4802, NULL, 'cd12508', NULL, NULL, 'RRM2_ESRPs_Fusilli', NULL, 'RRM2_ESRPs_Fusilli', NULL, NULL, NULL, 2),
(4803, NULL, 'cd15937', NULL, NULL, '7tmA_OR4N-like', NULL, '7tmA_OR4N-like', NULL, NULL, NULL, 2),
(4804, NULL, 'cd19456', NULL, NULL, 'lipocalin_NP4', NULL, 'lipocalin_NP4', NULL, NULL, NULL, 2),
(4805, NULL, 'cd02024', NULL, NULL, 'NRK1', NULL, 'NRK1', NULL, NULL, NULL, 2),
(4806, NULL, 'cd07417', NULL, NULL, 'MPP_PP5_C', NULL, 'MPP_PP5_C', NULL, NULL, 30506, 2),
(4807, NULL, 'cd13608', NULL, NULL, 'PBP2_OpuCC_like', NULL, 'PBP2_OpuCC_like', NULL, NULL, NULL, 2),
(4808, NULL, 'cd19860', NULL, NULL, 'DSRM_STAU_rpt4', NULL, 'DSRM_STAU_rpt4', NULL, NULL, NULL, 2),
(4809, NULL, 'cd08715', NULL, NULL, 'RGS_RGS1', NULL, 'RGS_RGS1', NULL, NULL, NULL, 2),
(4810, NULL, 'cd04279', NULL, NULL, 'ZnMc_MMP_like_1', NULL, 'ZnMc_MMP_like_1', NULL, NULL, NULL, 2),
(4811, NULL, 'cd03265', NULL, NULL, 'ABC_DrrA', NULL, 'ABC_DrrA', NULL, NULL, NULL, 2),
(4812, NULL, 'cd18288', NULL, NULL, 'BTB_POZ_BTBD12_SLX4', NULL, 'BTB_POZ_BTBD12_SLX4', NULL, NULL, NULL, 2),
(4813, NULL, 'cd18201', NULL, NULL, 'BTB_POZ_ZBTB10', NULL, 'BTB_POZ_ZBTB10', NULL, NULL, NULL, 2),
(4814, NULL, 'cd00104', NULL, NULL, 'KAZAL_FS', NULL, 'KAZAL_FS', NULL, NULL, NULL, 2),
(4815, NULL, 'cd21595', NULL, NULL, 'CoV_N-CTD', NULL, 'CoV_N-CTD', NULL, NULL, 33741, 2),
(4816, NULL, 'cd11850', NULL, NULL, 'SH3_Abl', NULL, 'SH3_Abl', NULL, NULL, NULL, 2),
(4817, NULL, 'cd16893', NULL, NULL, 'LT_MltC_MltE', NULL, 'LT_MltC_MltE', NULL, NULL, NULL, 2),
(4818, NULL, 'cd17325', NULL, NULL, 'MFS_MdtG_SLC18_like', NULL, 'MFS_MdtG_SLC18_like', NULL, NULL, NULL, 2),
(4819, NULL, 'cd08974', NULL, NULL, 'BaFpgNei_N_2', NULL, 'BaFpgNei_N_2', NULL, NULL, NULL, 2),
(4820, NULL, 'cd12604', NULL, NULL, 'RRM_RALY', NULL, 'RRM_RALY', NULL, NULL, 29928, 2),
(4821, NULL, 'cd06236', NULL, NULL, 'M14_AGBL5_like', NULL, 'M14_AGBL5_like', NULL, NULL, 24955, 2),
(4822, NULL, 'cd13545', NULL, NULL, 'PBP2_TbpA', NULL, 'PBP2_TbpA', NULL, NULL, 207, 2),
(4823, NULL, 'cd18266', NULL, NULL, 'BTB_POZ_KLHL36', NULL, 'BTB_POZ_KLHL36', NULL, NULL, NULL, 2),
(4824, NULL, 'cd15794', NULL, NULL, 'PH_ARHGEF18', NULL, 'PH_ARHGEF18', NULL, NULL, 28271, 2),
(4825, NULL, 'cd08249', NULL, NULL, 'enoyl_reductase_like', NULL, 'enoyl_reductase_like', NULL, NULL, NULL, 2),
(4826, NULL, 'cd09004', NULL, NULL, 'GH43_bXyl-like', NULL, 'GH43_bXyl-like', NULL, NULL, NULL, 2),
(4827, NULL, 'cd14521', NULL, NULL, 'DSP_fungal_SDP1-like', NULL, 'DSP_fungal_SDP1-like', NULL, NULL, NULL, 2),
(4828, NULL, 'cd09607', NULL, NULL, 'M3B_PepF', NULL, 'M3B_PepF', NULL, NULL, 1954, 2),
(4829, NULL, 'cd02220', NULL, NULL, 'cupin_ABP1', NULL, 'cupin_ABP1', NULL, NULL, NULL, 2),
(4830, NULL, 'cd04333', NULL, NULL, 'ProX_deacylase', NULL, 'ProX_deacylase', NULL, NULL, NULL, 2),
(4831, NULL, 'cd13999', NULL, NULL, 'STKc_MAP3K-like', NULL, 'STKc_MAP3K-like', NULL, NULL, NULL, 2),
(4832, NULL, 'cd01139', NULL, NULL, 'TroA_f', NULL, 'TroA_f', NULL, NULL, NULL, 2),
(4833, NULL, 'cd00102', NULL, NULL, 'IPT', NULL, 'IPT', NULL, NULL, NULL, 2),
(4834, NULL, 'cd05522', NULL, NULL, 'Bromo_Rsc1_2_II', NULL, 'Bromo_Rsc1_2_II', NULL, NULL, NULL, 2),
(4835, NULL, 'cd08621', NULL, NULL, 'PI-PLCXDc_like_2', NULL, 'PI-PLCXDc_like_2', NULL, NULL, NULL, 2),
(4836, NULL, 'cd08942', NULL, NULL, 'RhlG_SDR_c', NULL, 'RhlG_SDR_c', NULL, NULL, NULL, 2),
(4837, NULL, 'cd17415', NULL, NULL, 'MFS_NPF3', NULL, 'MFS_NPF3', NULL, NULL, NULL, 2),
(4838, NULL, 'cd09504', NULL, NULL, 'SAM_STIM-1,2-like', NULL, 'SAM_STIM-1,2-like', NULL, NULL, NULL, 2),
(4839, NULL, 'cd13376', NULL, NULL, 'PH_DAB2IP', NULL, 'PH_DAB2IP', NULL, NULL, NULL, 2),
(4840, NULL, 'cd18572', NULL, NULL, 'ABC_6TM_TAP', NULL, 'ABC_6TM_TAP', NULL, NULL, NULL, 2),
(4841, NULL, 'cd04821', NULL, NULL, 'PA_M28_1_2', NULL, 'PA_M28_1_2', NULL, NULL, NULL, 2);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(4842, NULL, 'cd04793', NULL, NULL, 'LanC', NULL, 'LanC', NULL, NULL, 29981, 2),
(4843, NULL, 'cd05798', NULL, NULL, 'SIS_TAL_PGI', NULL, 'SIS_TAL_PGI', NULL, NULL, NULL, 2),
(4844, NULL, 'cd00221', NULL, NULL, 'Vsr', NULL, 'Vsr', NULL, NULL, 971, 2),
(4845, NULL, 'cd03282', NULL, NULL, 'ABC_MSH4_euk', NULL, 'ABC_MSH4_euk', NULL, NULL, NULL, 2),
(4846, NULL, 'cd21556', NULL, NULL, 'Macro_cv_SUD-N-M_Nsp3-like', NULL, 'Macro_cv_SUD-N-M_Nsp3-like', NULL, NULL, NULL, 2),
(4847, NULL, 'cd18535', NULL, NULL, 'PTP-IVa3', NULL, 'PTP-IVa3', NULL, NULL, NULL, 2),
(4848, NULL, 'cd00148', NULL, NULL, 'PROF', NULL, 'PROF', NULL, NULL, 952, 2),
(4849, NULL, 'cd11954', NULL, NULL, 'SH3_ASPP1', NULL, 'SH3_ASPP1', NULL, NULL, NULL, 2),
(4850, NULL, 'cd01347', NULL, NULL, 'ligand_gated_channel', NULL, 'ligand_gated_channel', NULL, NULL, NULL, 2),
(4851, NULL, 'cd07961', NULL, NULL, 'Anticodon_Ia_Ile_ABEc', NULL, 'Anticodon_Ia_Ile_ABEc', NULL, NULL, 32985, 2),
(4852, NULL, 'cd01834', NULL, NULL, 'SGNH_hydrolase_like_2', NULL, 'SGNH_hydrolase_like_2', NULL, NULL, NULL, 2),
(4853, NULL, 'cd07619', NULL, NULL, 'BAR_Rich2', NULL, 'BAR_Rich2', NULL, NULL, NULL, 2),
(4854, NULL, 'cd16580', NULL, NULL, 'RING-HC_TRIM8_C-V', NULL, 'RING-HC_TRIM8_C-V', NULL, NULL, NULL, 2),
(4855, NULL, 'cd04742', NULL, NULL, 'NPD_FabD', NULL, 'NPD_FabD', NULL, NULL, 8576, 2),
(4856, NULL, 'cd18968', NULL, NULL, 'chromodomain', NULL, 'chromodomain', NULL, NULL, NULL, 2),
(4857, NULL, 'cd06839', NULL, NULL, 'PLPDE_III_Btrk_like', NULL, 'PLPDE_III_Btrk_like', NULL, NULL, NULL, 2),
(4858, NULL, 'cd14228', NULL, NULL, 'STKc_HIPK1', NULL, 'STKc_HIPK1', NULL, NULL, NULL, 2),
(4859, NULL, 'cd08805', NULL, NULL, 'Death_ank1', NULL, 'Death_ank1', NULL, NULL, NULL, 2),
(4860, NULL, 'cd14275', NULL, NULL, 'UBA_EF-Ts', NULL, 'UBA_EF-Ts', NULL, NULL, NULL, 2),
(4861, NULL, 'cd06983', NULL, NULL, 'cupin_dsy2733', NULL, 'cupin_dsy2733', NULL, NULL, NULL, 2),
(4862, NULL, 'cd15904', NULL, NULL, 'TSPO_MBR', NULL, 'TSPO_MBR', NULL, NULL, 4649, 2),
(4863, NULL, 'cd05499', NULL, NULL, 'Bromo_BDF1_2_II', NULL, 'Bromo_BDF1_2_II', NULL, NULL, NULL, 2),
(4864, NULL, 'cd00235', NULL, NULL, 'TLP-20', NULL, 'TLP-20', NULL, NULL, 6345, 2),
(4865, NULL, 'cd15790', NULL, NULL, 'PH-GRAM_MTMR11', NULL, 'PH-GRAM_MTMR11', NULL, NULL, NULL, 2),
(4866, NULL, 'cd04407', NULL, NULL, 'RhoGAP_myosin_IXB', NULL, 'RhoGAP_myosin_IXB', NULL, NULL, NULL, 2),
(4867, NULL, 'cd05006', NULL, NULL, 'SIS_GmhA', NULL, 'SIS_GmhA', NULL, NULL, 28828, 2),
(4868, NULL, 'cd03023', NULL, NULL, 'DsbA_Com1_like', NULL, 'DsbA_Com1_like', NULL, NULL, NULL, 2),
(4869, NULL, 'cd15198', NULL, NULL, '7tmA_GPR150', NULL, '7tmA_GPR150', NULL, NULL, NULL, 2),
(4870, NULL, 'cd00956', NULL, NULL, 'Transaldolase_FSA', NULL, 'Transaldolase_FSA', NULL, NULL, 29434, 2),
(4871, NULL, 'cd07075', NULL, NULL, 'NR_LBD_MR', NULL, 'NR_LBD_MR', NULL, NULL, NULL, 2),
(4872, NULL, 'cd14789', NULL, NULL, 'Tiki', NULL, 'Tiki', NULL, NULL, NULL, 2),
(4873, NULL, 'cd13961', NULL, NULL, 'PT_UbiA_DGGGPS', NULL, 'PT_UbiA_DGGGPS', NULL, NULL, NULL, 2),
(4874, NULL, 'cd15991', NULL, NULL, '7tmB2_CELSR1', NULL, '7tmB2_CELSR1', NULL, NULL, NULL, 2),
(4875, NULL, 'cd01712', NULL, NULL, 'ThiI', NULL, 'ThiI', NULL, NULL, 18719, 2),
(4876, NULL, 'cd05369', NULL, NULL, 'TER_DECR_SDR_a', NULL, 'TER_DECR_SDR_a', NULL, NULL, NULL, 2),
(4877, NULL, 'cd07713', NULL, NULL, 'DHPS-like_MBL-fold', NULL, 'DHPS-like_MBL-fold', NULL, NULL, 29650, 2),
(4878, NULL, 'cd01645', NULL, NULL, 'RT_Rtv', NULL, 'RT_Rtv', NULL, NULL, NULL, 2),
(4879, NULL, 'cd00622', NULL, NULL, 'PLPDE_III_ODC', NULL, 'PLPDE_III_ODC', NULL, NULL, NULL, 2),
(4880, NULL, 'cd11468', NULL, NULL, 'bHLH_TS_bHLHe22_like', NULL, 'bHLH_TS_bHLHe22_like', NULL, NULL, NULL, 2),
(4881, NULL, 'cd08337', NULL, NULL, 'DED_c-FLIP_r1', NULL, 'DED_c-FLIP_r1', NULL, NULL, NULL, 2),
(4882, NULL, 'cd07991', NULL, NULL, 'LPLAT_LPCAT1-like', NULL, 'LPLAT_LPCAT1-like', NULL, NULL, 36708, 2),
(4883, NULL, 'cd16037', NULL, NULL, 'sulfatase_like', NULL, 'sulfatase_like', NULL, NULL, NULL, 2),
(4884, NULL, 'cd07031', NULL, NULL, 'RNAP_II_RPB3', NULL, 'RNAP_II_RPB3', NULL, NULL, NULL, 2);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(4885, NULL, 'cd01866', NULL, NULL, 'Rab2', NULL, 'Rab2', NULL, NULL, NULL, 2),
(4886, NULL, 'cd14342', NULL, NULL, 'UBA_TAP-C', NULL, 'UBA_TAP-C', NULL, NULL, 2768, 2),
(4887, NULL, 'cd00691', NULL, NULL, 'ascorbate_peroxidase', NULL, 'ascorbate_peroxidase', NULL, NULL, NULL, 2),
(4888, NULL, 'cd05829', NULL, NULL, 'Sortase_F', NULL, 'Sortase_F', NULL, NULL, 30727, 2),
(4889, NULL, 'cd21144', NULL, NULL, 'NendoU_XendoU-like', NULL, 'NendoU_XendoU-like', NULL, NULL, NULL, 2),
(4890, NULL, 'cd19145', NULL, NULL, 'AKR_AKR13D1', NULL, 'AKR_AKR13D1', NULL, NULL, NULL, 2),
(4891, NULL, 'cd19793', NULL, NULL, 'Bbox2_TRIM65-like', NULL, 'Bbox2_TRIM65-like', NULL, NULL, NULL, 2),
(4892, NULL, 'cd18340', NULL, NULL, 'BTB_POZ_KLHL40_KBTBD5', NULL, 'BTB_POZ_KLHL40_KBTBD5', NULL, NULL, NULL, 2),
(4893, NULL, 'cd19777', NULL, NULL, 'Bbox2_TRIM35_C-IV', NULL, 'Bbox2_TRIM35_C-IV', NULL, NULL, NULL, 2),
(4894, NULL, 'cd05741', NULL, NULL, 'Ig_CEACAM_like', NULL, 'Ig_CEACAM_like', NULL, NULL, NULL, 2),
(4895, NULL, 'cd15454', NULL, NULL, '7tmC_mGluR8', NULL, '7tmC_mGluR8', NULL, NULL, NULL, 2),
(4896, NULL, 'cd19383', NULL, NULL, 'TGF_beta_Neurturin', NULL, 'TGF_beta_Neurturin', NULL, NULL, NULL, 2),
(4897, NULL, 'cd20481', NULL, NULL, 'phage_tailspike_middle', NULL, 'phage_tailspike_middle', NULL, NULL, NULL, 2),
(4898, NULL, 'cd11815', NULL, NULL, 'SH3_Eve1_2', NULL, 'SH3_Eve1_2', NULL, NULL, NULL, 2),
(4899, NULL, 'cd06587', NULL, NULL, 'VOC', NULL, 'VOC', NULL, NULL, NULL, 2),
(4900, NULL, 'cd06063', NULL, NULL, 'H2MP_Cyano-H2up', NULL, 'H2MP_Cyano-H2up', NULL, NULL, NULL, 2),
(4901, NULL, 'cd09884', NULL, NULL, 'PIN_Smg5-like', NULL, 'PIN_Smg5-like', NULL, NULL, NULL, 2),
(4902, NULL, 'cd02638', NULL, NULL, 'R3H_unknown_1', NULL, 'R3H_unknown_1', NULL, NULL, NULL, 2),
(4903, NULL, 'cd04753', NULL, NULL, 'Commd5_HCaRG', NULL, 'Commd5_HCaRG', NULL, NULL, NULL, 2),
(4904, NULL, 'cd19686', NULL, NULL, 'bHLH_TS_FERD3L_like', NULL, 'bHLH_TS_FERD3L_like', NULL, NULL, NULL, 2),
(4905, NULL, 'cd12613', NULL, NULL, 'RRM2_NGR1_NAM8_like', NULL, 'RRM2_NGR1_NAM8_like', NULL, NULL, NULL, 2),
(4906, NULL, 'cd08442', NULL, NULL, 'PBP2_YofA_SoxR_like', NULL, 'PBP2_YofA_SoxR_like', NULL, NULL, NULL, 2),
(4907, NULL, 'cd20239', NULL, NULL, 'PFM_aerolysin-like', NULL, 'PFM_aerolysin-like', NULL, NULL, NULL, 2),
(4908, NULL, 'cd09682', NULL, NULL, 'Cmr4_III-B', NULL, 'Cmr4_III-B', NULL, NULL, NULL, 2),
(4909, NULL, 'cd06209', NULL, NULL, 'BenDO_FAD_NAD', NULL, 'BenDO_FAD_NAD', NULL, NULL, NULL, 2),
(4910, NULL, 'cd09294', NULL, NULL, 'SmpB', NULL, 'SmpB', NULL, NULL, 2703, 2),
(4911, NULL, 'cd13158', NULL, NULL, 'PTB_APPL', NULL, 'PTB_APPL', NULL, NULL, NULL, 2),
(4912, NULL, 'cd05974', NULL, NULL, 'MACS_like_1', NULL, 'MACS_like_1', NULL, NULL, NULL, 2),
(4913, NULL, 'cd01234', NULL, NULL, 'PH_CADPS', NULL, 'PH_CADPS', NULL, NULL, NULL, 2),
(4914, NULL, 'cd14595', NULL, NULL, 'PTP-MTMR11', NULL, 'PTP-MTMR11', NULL, NULL, NULL, 2),
(4915, NULL, 'cd03363', NULL, NULL, 'TOPRIM_TopoIA_TopoI', NULL, 'TOPRIM_TopoIA_TopoI', NULL, NULL, 25480, 2),
(4916, NULL, 'cd14189', NULL, NULL, 'STKc_PLK3', NULL, 'STKc_PLK3', NULL, NULL, 35798, 2),
(4917, NULL, 'cd14950', NULL, NULL, 'Asparaginase_2_like_2', NULL, 'Asparaginase_2_like_2', NULL, NULL, NULL, 2),
(4918, NULL, 'cd07734', NULL, NULL, 'Int9-11_CPSF2-3-like_MBL-fold', NULL, 'Int9-11_CPSF2-3-like_MBL-fold', NULL, NULL, NULL, 2),
(4919, NULL, 'cd12042', NULL, NULL, 'SH3_CACNB3', NULL, 'SH3_CACNB3', NULL, NULL, 30448, 2),
(4920, NULL, 'cd03769', NULL, NULL, 'SR_IS607_transposase_like', NULL, 'SR_IS607_transposase_like', NULL, NULL, 30193, 2),
(4921, NULL, 'cd12111', NULL, NULL, 'PHP_HisPPase_Thermotoga_like', NULL, 'PHP_HisPPase_Thermotoga_like', NULL, NULL, NULL, 2),
(4922, NULL, 'cd12221', NULL, NULL, 'Cin1', NULL, 'Cin1', NULL, NULL, 31382, 2),
(4923, NULL, 'cd08393', NULL, NULL, 'C2A_SLP-1_2', NULL, 'C2A_SLP-1_2', NULL, NULL, NULL, 2),
(4924, NULL, 'cd14178', NULL, NULL, 'STKc_RSK3_C', NULL, 'STKc_RSK3_C', NULL, NULL, 35425, 2),
(4925, NULL, 'cd08358', NULL, NULL, 'GLOD4_N', NULL, 'GLOD4_N', NULL, NULL, NULL, 2);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(4926, NULL, 'cd15389', NULL, NULL, '7tmA_GPR83', NULL, '7tmA_GPR83', NULL, NULL, NULL, 2),
(4927, NULL, 'cd09723', NULL, NULL, 'Csx1_III-U', NULL, 'Csx1_III-U', NULL, NULL, NULL, 2),
(4928, NULL, 'cd05905', NULL, NULL, 'Dip2', NULL, 'Dip2', NULL, NULL, 27991, 2),
(4929, NULL, 'cd19731', NULL, NULL, 'bHLH-PAS_NPAS1_PASD5', NULL, 'bHLH-PAS_NPAS1_PASD5', NULL, NULL, NULL, 2),
(4930, NULL, 'cd07128', NULL, NULL, 'ALDH_MaoC-N', NULL, 'ALDH_MaoC-N', NULL, NULL, NULL, 2),
(4931, NULL, 'cd14035', NULL, NULL, 'PK_MADML', NULL, 'PK_MADML', NULL, NULL, 35783, 2),
(4932, NULL, 'cd14909', NULL, NULL, 'MYSc_Myh1_insects_crustaceans', NULL, 'MYSc_Myh1_insects_crustaceans', NULL, NULL, NULL, 2),
(4933, NULL, 'cd02766', NULL, NULL, 'MopB_3', NULL, 'MopB_3', NULL, NULL, NULL, 2),
(4934, NULL, 'cd08360', NULL, NULL, 'MhqB_like_C', NULL, 'MhqB_like_C', NULL, NULL, NULL, 2),
(4935, NULL, 'cd09071', NULL, NULL, 'FAR_C', NULL, 'FAR_C', NULL, NULL, 30240, 2),
(4936, NULL, 'cd17557', NULL, NULL, 'REC_Rcp-like', NULL, 'REC_Rcp-like', NULL, NULL, NULL, 2),
(4937, NULL, 'cd06586', NULL, NULL, 'TPP_enzyme_PYR', NULL, 'TPP_enzyme_PYR', NULL, NULL, NULL, 2),
(4938, NULL, 'cd09024', NULL, NULL, 'Aldose_epim_lacX', NULL, 'Aldose_epim_lacX', NULL, NULL, 27075, 2),
(4939, NULL, 'cd11767', NULL, NULL, 'SH3_Nck_3', NULL, 'SH3_Nck_3', NULL, NULL, NULL, 2),
(4940, NULL, 'cd02995', NULL, NULL, 'PDI_a_PDI_a''_C', NULL, 'PDI_a_PDI_a''_C', NULL, NULL, NULL, 2),
(4941, NULL, 'cd00864', NULL, NULL, 'PI3Ka', NULL, 'PI3Ka', NULL, NULL, NULL, 2),
(4942, NULL, 'cd08319', NULL, NULL, 'Death_RAIDD', NULL, 'Death_RAIDD', NULL, NULL, 31811, 2),
(4943, NULL, 'cd07672', NULL, NULL, 'F-BAR_PSTPIP2', NULL, 'F-BAR_PSTPIP2', NULL, NULL, 36309, 2),
(4944, NULL, 'cd04871', NULL, NULL, 'ACT_PSP_2', NULL, 'ACT_PSP_2', NULL, NULL, NULL, 2),
(4945, NULL, 'cd07410', NULL, NULL, 'MPP_CpdB_N', NULL, 'MPP_CpdB_N', NULL, NULL, 30760, 2),
(4946, NULL, 'cd17093', NULL, NULL, 'FERM2_F1_Myosin-VII', NULL, 'FERM2_F1_Myosin-VII', NULL, NULL, NULL, 2),
(4947, NULL, 'cd01647', NULL, NULL, 'RT_LTR', NULL, 'RT_LTR', NULL, NULL, NULL, 2),
(4948, NULL, 'cd04772', NULL, NULL, 'HTH_TioE_rpt1', NULL, 'HTH_TioE_rpt1', NULL, NULL, NULL, 2),
(4949, NULL, 'cd00436', NULL, NULL, 'UP_TbUP-like', NULL, 'UP_TbUP-like', NULL, NULL, NULL, 2),
(4950, NULL, 'cd11722', NULL, NULL, 'SOAR', NULL, 'SOAR', NULL, NULL, 24084, 2),
(4951, NULL, 'cd14424', NULL, NULL, 'CUE_Cue1p_like', NULL, 'CUE_Cue1p_like', NULL, NULL, NULL, 2),
(4952, NULL, 'cd17111', NULL, NULL, 'RA1_DAGK-theta', NULL, 'RA1_DAGK-theta', NULL, NULL, NULL, 2),
(4953, NULL, 'cd15615', NULL, NULL, 'PHD_ARID4_like', NULL, 'PHD_ARID4_like', NULL, NULL, NULL, 2),
(4954, NULL, 'cd05817', NULL, NULL, 'CBM20_DSP', NULL, 'CBM20_DSP', NULL, NULL, NULL, 2),
(4955, NULL, 'cd17137', NULL, NULL, 'RBD1_RGS14', NULL, 'RBD1_RGS14', NULL, NULL, NULL, 2),
(4956, NULL, 'cd16787', NULL, NULL, 'mRING-HC-C3HC5_CGRF1', NULL, 'mRING-HC-C3HC5_CGRF1', NULL, NULL, NULL, 2),
(4957, NULL, 'cd11276', NULL, NULL, 'Sema_plexin_B2', NULL, 'Sema_plexin_B2', NULL, NULL, NULL, 2),
(4958, NULL, 'cd12010', NULL, NULL, 'SH3_SLAP', NULL, 'SH3_SLAP', NULL, NULL, 33661, 2),
(4959, NULL, 'cd08450', NULL, NULL, 'PBP2_HcaR', NULL, 'PBP2_HcaR', NULL, NULL, NULL, 2),
(4960, NULL, 'cd20607', NULL, NULL, 'FbiB_C-like', NULL, 'FbiB_C-like', NULL, NULL, NULL, 2),
(4961, NULL, 'cd02859', NULL, NULL, 'E_set_AMPKbeta_like_N', NULL, 'E_set_AMPKbeta_like_N', NULL, NULL, NULL, 2),
(4962, NULL, 'cd13696', NULL, NULL, 'PBP2_Atu4678_like', NULL, 'PBP2_Atu4678_like', NULL, NULL, NULL, 2),
(4963, NULL, 'cd21512', NULL, NULL, 'cv_gamma-delta_Nsp2_IBV-like', NULL, 'cv_gamma-delta_Nsp2_IBV-like', NULL, NULL, 35938, 2),
(4964, NULL, 'cd02537', NULL, NULL, 'GT8_Glycogenin', NULL, 'GT8_Glycogenin', NULL, NULL, NULL, 2),
(4965, NULL, 'cd00842', NULL, NULL, 'MPP_ASMase', NULL, 'MPP_ASMase', NULL, NULL, 30991, 2),
(4966, NULL, 'cd12108', NULL, NULL, 'Hr-like', NULL, 'Hr-like', NULL, NULL, NULL, 2),
(4967, NULL, 'cd03088', NULL, NULL, 'ManB', NULL, 'ManB', NULL, NULL, NULL, 2),
(4968, NULL, 'cd15065', NULL, NULL, '7tmA_Ap5-HTB1-like', NULL, '7tmA_Ap5-HTB1-like', NULL, NULL, NULL, 2);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(4969, NULL, 'cd20183', NULL, NULL, 'M34_PPEP', NULL, 'M34_PPEP', NULL, NULL, NULL, 2),
(4970, NULL, 'cd06403', NULL, NULL, 'PB1_Par6', NULL, 'PB1_Par6', NULL, NULL, 33213, 2),
(4971, NULL, 'cd13527', NULL, NULL, 'PBP2_TRAP', NULL, 'PBP2_TRAP', NULL, NULL, NULL, 2),
(4972, NULL, 'cd01231', NULL, NULL, 'PH_SH2B_family', NULL, 'PH_SH2B_family', NULL, NULL, NULL, 2),
(4973, NULL, 'cd14537', NULL, NULL, 'PTP-MTMR10-like', NULL, 'PTP-MTMR10-like', NULL, NULL, NULL, 2),
(4974, NULL, 'cd13226', NULL, NULL, 'PH-GRAM-like_Eap45', NULL, 'PH-GRAM-like_Eap45', NULL, NULL, NULL, 2),
(4975, NULL, 'cd16673', NULL, NULL, 'RING-H2_RNF6', NULL, 'RING-H2_RNF6', NULL, NULL, NULL, 2),
(4976, NULL, 'cd09233', NULL, NULL, 'ACE1-Sec16-like', NULL, 'ACE1-Sec16-like', NULL, NULL, NULL, 2),
(4977, NULL, 'cd16174', NULL, NULL, 'EFh_MICU2', NULL, 'EFh_MICU2', NULL, NULL, NULL, 2),
(4978, NULL, 'cd09852', NULL, NULL, 'PIN_SF', NULL, 'PIN_SF', NULL, NULL, NULL, 2),
(4979, NULL, 'cd10009', NULL, NULL, 'HDAC9', NULL, 'HDAC9', NULL, NULL, NULL, 2),
(4980, NULL, 'cd18193', NULL, NULL, 'BTB_POZ_ZBTB2', NULL, 'BTB_POZ_ZBTB2', NULL, NULL, NULL, 2),
(4981, NULL, 'cd07327', NULL, NULL, 'M48B_HtpX_like', NULL, 'M48B_HtpX_like', NULL, NULL, NULL, 2),
(4982, NULL, 'cd00064', NULL, NULL, 'FU', NULL, 'FU', NULL, NULL, 11201, 2),
(4983, NULL, 'cd10816', NULL, NULL, 'GH57N_BE_TK1436_like', NULL, 'GH57N_BE_TK1436_like', NULL, NULL, NULL, 2),
(4984, NULL, 'cd08772', NULL, NULL, 'GH43_62_32_68_117_130', NULL, 'GH43_62_32_68_117_130', NULL, NULL, NULL, 2),
(4985, NULL, 'cd07394', NULL, NULL, 'MPP_Vps29', NULL, 'MPP_Vps29', NULL, NULL, 22627, 2),
(4986, NULL, 'cd17154', NULL, NULL, 'DCX2_DCDC2C', NULL, 'DCX2_DCDC2C', NULL, NULL, NULL, 2),
(4987, NULL, 'cd16679', NULL, NULL, 'RING-H2_RNF38', NULL, 'RING-H2_RNF38', NULL, NULL, NULL, 2),
(4988, NULL, 'cd10798', NULL, NULL, 'GH57N_like_1', NULL, 'GH57N_like_1', NULL, NULL, NULL, 2),
(4989, NULL, 'cd15498', NULL, NULL, 'PHD2_Snt2p_like', NULL, 'PHD2_Snt2p_like', NULL, NULL, NULL, 2),
(4990, NULL, 'cd08260', NULL, NULL, 'Zn_ADH6', NULL, 'Zn_ADH6', NULL, NULL, NULL, 2),
(4991, NULL, 'cd02911', NULL, NULL, 'arch_FMN', NULL, 'arch_FMN', NULL, NULL, 29188, 2),
(4992, NULL, 'cd08595', NULL, NULL, 'PI-PLCc_zeta', NULL, 'PI-PLCc_zeta', NULL, NULL, NULL, 2),
(4993, NULL, 'cd18742', NULL, NULL, 'PIN_VapC4-5_FitB-like', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, NULL, 2),
(4994, NULL, 'cd09082', NULL, NULL, 'Deadenylase', NULL, 'Deadenylase', NULL, NULL, NULL, 2),
(4995, NULL, 'cd15884', NULL, NULL, 'SNARE_SNAP23C', NULL, 'SNARE_SNAP23C', NULL, NULL, NULL, 2),
(4996, NULL, 'cd04929', NULL, NULL, 'ACT_TPH', NULL, 'ACT_TPH', NULL, NULL, NULL, 2),
(4997, NULL, 'cd18946', NULL, NULL, 'bHLH_E-protein_TCF12_HEB', NULL, 'bHLH_E-protein_TCF12_HEB', NULL, NULL, NULL, 2),
(4998, NULL, 'cd19778', NULL, NULL, 'Bbox2_TRIM36_C-I', NULL, 'Bbox2_TRIM36_C-I', NULL, NULL, NULL, 2),
(4999, NULL, 'cd01778', NULL, NULL, 'RA_RASSF1_like', NULL, 'RA_RASSF1_like', NULL, NULL, NULL, 2),
(5000, NULL, 'cd03750', NULL, NULL, 'proteasome_alpha_type_2', NULL, 'proteasome_alpha_type_2', NULL, NULL, NULL, 2),
(5001, NULL, 'cd14870', NULL, NULL, 'uS7_Mitochondria_Mammalian', NULL, 'uS7_Mitochondria_Mammalian', NULL, NULL, NULL, 2),
(5002, NULL, 'cd15688', NULL, NULL, 'PHD1_MOZ', NULL, 'PHD1_MOZ', NULL, NULL, NULL, 2),
(5003, NULL, 'cd17731', NULL, NULL, 'BRCT_TopBP1_rpt2_like', NULL, 'BRCT_TopBP1_rpt2_like', NULL, NULL, NULL, 2),
(5004, NULL, 'cd06969', NULL, NULL, 'NR_DBD_NGFI-B', NULL, 'NR_DBD_NGFI-B', NULL, NULL, NULL, 2),
(5005, NULL, 'cd12277', NULL, NULL, 'RRM3_MEI2_EAR1_like', NULL, 'RRM3_MEI2_EAR1_like', NULL, NULL, NULL, 2),
(5006, NULL, 'cd01397', NULL, NULL, 'HAT_MBD', NULL, 'HAT_MBD', NULL, NULL, NULL, 2),
(5007, NULL, 'cd18277', NULL, NULL, 'BTB_POZ_BACH1', NULL, 'BTB_POZ_BACH1', NULL, NULL, NULL, 2),
(5008, NULL, 'cd15729', NULL, NULL, 'FYVE_endofin', NULL, 'FYVE_endofin', NULL, NULL, NULL, 2),
(5009, NULL, 'cd06538', NULL, NULL, 'CIDE_N_FSP27', NULL, 'CIDE_N_FSP27', NULL, NULL, NULL, 2),
(5010, NULL, 'cd12316', NULL, NULL, 'RRM3_RBM19_RRM2_MRD1', NULL, 'RRM3_RBM19_RRM2_MRD1', NULL, NULL, NULL, 2);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(5011, NULL, 'cd08483', NULL, NULL, 'PBP2_HvrB', NULL, 'PBP2_HvrB', NULL, NULL, NULL, 2),
(5012, NULL, 'cd09483', NULL, NULL, 'LIM1_Prickle_1', NULL, 'LIM1_Prickle_1', NULL, NULL, NULL, 2),
(5013, NULL, 'cd13374', NULL, NULL, 'PH_RASAL3', NULL, 'PH_RASAL3', NULL, NULL, NULL, 2),
(5014, NULL, 'cd21568', NULL, NULL, 'HCoV-like_M', NULL, 'HCoV-like_M', NULL, NULL, 36403, 2),
(5015, NULL, 'cd07878', NULL, NULL, 'STKc_p38beta', NULL, 'STKc_p38beta', NULL, NULL, NULL, 2),
(5016, NULL, 'cd09524', NULL, NULL, 'SAM_tankyrase1,2', NULL, 'SAM_tankyrase1,2', NULL, NULL, NULL, 2),
(5017, NULL, 'cd10972', NULL, NULL, 'CE4_DAC_u3_5s', NULL, 'CE4_DAC_u3_5s', NULL, NULL, NULL, 2),
(5018, NULL, 'cd12893', NULL, NULL, 'SPRY_PRY_TRIM35', NULL, 'SPRY_PRY_TRIM35', NULL, NULL, NULL, 2),
(5019, NULL, 'cd03207', NULL, NULL, 'GST_C_8', NULL, 'GST_C_8', NULL, NULL, NULL, 2),
(5020, NULL, 'cd17901', NULL, NULL, 'ArfGap_ARAP1', NULL, 'ArfGap_ARAP1', NULL, NULL, NULL, 2),
(5021, NULL, 'cd05257', NULL, NULL, 'Arna_like_SDR_e', NULL, 'Arna_like_SDR_e', NULL, NULL, 36616, 2),
(5022, NULL, 'cd10050', NULL, NULL, 'Reelin_repeat_6_subrepeat_2', NULL, 'Reelin_repeat_6_subrepeat_2', NULL, NULL, NULL, 2),
(5023, NULL, 'cd08240', NULL, NULL, '6_hydroxyhexanoate_dh_like', NULL, '6_hydroxyhexanoate_dh_like', NULL, NULL, NULL, 2),
(5024, NULL, 'cd14555', NULL, NULL, 'R-PTPc-typeIIb-1', NULL, 'R-PTPc-typeIIb-1', NULL, NULL, NULL, 2),
(5025, NULL, 'cd15507', NULL, NULL, 'PHD2_KMT2A_like', NULL, 'PHD2_KMT2A_like', NULL, NULL, NULL, 2),
(5026, NULL, 'cd14081', NULL, NULL, 'STKc_BRSK1_2', NULL, 'STKc_BRSK1_2', NULL, NULL, NULL, 2),
(5027, NULL, 'cd00947', NULL, NULL, 'TBP_aldolase_IIB', NULL, 'TBP_aldolase_IIB', NULL, NULL, 6927, 2),
(5028, NULL, 'cd19466', NULL, NULL, 'FABP3', NULL, 'FABP3', NULL, NULL, NULL, 2),
(5029, NULL, 'cd05127', NULL, NULL, 'RasGAP_IQGAP_like', NULL, 'RasGAP_IQGAP_like', NULL, NULL, NULL, 2),
(5030, NULL, 'cd00501', NULL, NULL, 'Peptidase_C15', NULL, 'Peptidase_C15', NULL, NULL, 6564, 2),
(5031, NULL, 'cd13172', NULL, NULL, 'RanBD2_RanBP2_insect-like', NULL, 'RanBD2_RanBP2_insect-like', NULL, NULL, NULL, 2),
(5032, NULL, 'cd06356', NULL, NULL, 'PBP1_amide_urea_BP-like', NULL, 'PBP1_amide_urea_BP-like', NULL, NULL, NULL, 2),
(5033, NULL, 'cd04893', NULL, NULL, 'ACT_GcvR_1', NULL, 'ACT_GcvR_1', NULL, NULL, NULL, 2),
(5034, NULL, 'cd13849', NULL, NULL, 'CuRO_1_LCC_plant', NULL, 'CuRO_1_LCC_plant', NULL, NULL, 24636, 2),
(5035, NULL, 'cd08901', NULL, NULL, 'SRPBCC_CalC_Aha1-like_8', NULL, 'SRPBCC_CalC_Aha1-like_8', NULL, NULL, NULL, 2),
(5036, NULL, 'cd13217', NULL, NULL, 'PH-GRAM1_TCB1D8_TCB1D9_family', NULL, 'PH-GRAM1_TCB1D8_TCB1D9_family', NULL, NULL, NULL, 2),
(5037, NULL, 'cd01586', NULL, NULL, 'AcnA_IRP', NULL, 'AcnA_IRP', NULL, NULL, NULL, 2),
(5038, NULL, 'cd11687', NULL, NULL, 'PpPFK_gamma', NULL, 'PpPFK_gamma', NULL, NULL, 31512, 2),
(5039, NULL, 'cd17484', NULL, NULL, 'MFS_FBT', NULL, 'MFS_FBT', NULL, NULL, NULL, 2),
(5040, NULL, 'cd02085', NULL, NULL, 'P-type_ATPase_SPCA', NULL, 'P-type_ATPase_SPCA', NULL, NULL, NULL, 2),
(5041, NULL, 'cd08692', NULL, NULL, 'C2B_Tac2-N', NULL, 'C2B_Tac2-N', NULL, NULL, 30019, 2),
(5042, NULL, 'cd10482', NULL, NULL, 'EphR_LBD_A4', NULL, 'EphR_LBD_A4', NULL, NULL, 24208, 2),
(5043, NULL, 'cd17384', NULL, NULL, 'MFS_SLC18A1_2_VAT1_2', NULL, 'MFS_SLC18A1_2_VAT1_2', NULL, NULL, NULL, 2),
(5044, NULL, 'cd05660', NULL, NULL, 'M28_like_PA', NULL, 'M28_like_PA', NULL, NULL, NULL, 2),
(5045, NULL, 'cd05895', NULL, NULL, 'Ig_Pro_neuregulin-1', NULL, 'Ig_Pro_neuregulin-1', NULL, NULL, NULL, 2),
(5046, NULL, 'cd13189', NULL, NULL, 'FERM_C_PTPN4_PTPN3_like', NULL, 'FERM_C_PTPN4_PTPN3_like', NULL, NULL, 30589, 2),
(5047, NULL, 'cd15538', NULL, NULL, 'PHD_PRKCBP1', NULL, 'PHD_PRKCBP1', NULL, NULL, 34618, 2),
(5048, NULL, 'cd16241', NULL, NULL, 'EFh_SPARC_SMOC2', NULL, 'EFh_SPARC_SMOC2', NULL, NULL, 31201, 2),
(5049, NULL, 'cd16479', NULL, NULL, 'RING-H2_synoviolin', NULL, 'RING-H2_synoviolin', NULL, NULL, NULL, 2),
(5050, NULL, 'cd07796', NULL, NULL, 'FGGY_NHO1_plant', NULL, 'FGGY_NHO1_plant', NULL, NULL, NULL, 2);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(5051, NULL, 'cd15903', NULL, NULL, 'Dicer_PBD', NULL, 'Dicer_PBD', NULL, NULL, NULL, 2),
(5052, NULL, 'cd11913', NULL, NULL, 'SH3_BAIAP2L1', NULL, 'SH3_BAIAP2L1', NULL, NULL, 33437, 2),
(5053, NULL, 'cd21344', NULL, NULL, '1B_UPF1_nv_SF1_Hel-like', NULL, '1B_UPF1_nv_SF1_Hel-like', NULL, NULL, NULL, 2),
(5054, NULL, 'cd19602', NULL, NULL, 'serpin_mollusks', NULL, 'serpin_mollusks', NULL, NULL, NULL, 2),
(5055, NULL, 'cd19470', NULL, NULL, 'FABP7', NULL, 'FABP7', NULL, NULL, NULL, 2),
(5056, NULL, 'cd12936', NULL, NULL, 'GUCT_RHII_Gualpha_beta', NULL, 'GUCT_RHII_Gualpha_beta', NULL, NULL, NULL, 2),
(5057, NULL, 'cd02046', NULL, NULL, 'serpinH1_CBP1', NULL, 'serpinH1_CBP1', NULL, NULL, 33256, 2),
(5058, NULL, 'cd05089', NULL, NULL, 'PTKc_Tie1', NULL, 'PTKc_Tie1', NULL, NULL, NULL, 2),
(5059, NULL, 'cd19455', NULL, NULL, 'lipocalin_NP1', NULL, 'lipocalin_NP1', NULL, NULL, NULL, 2),
(5060, NULL, 'cd00838', NULL, NULL, 'MPP_superfamily', NULL, 'MPP_superfamily', NULL, NULL, NULL, 2),
(5061, NULL, 'cd07491', NULL, NULL, 'Peptidases_S8_7', NULL, 'Peptidases_S8_7', NULL, NULL, NULL, 2),
(5062, NULL, 'cd08957', NULL, NULL, 'WbmH_like_SDR_e', NULL, 'WbmH_like_SDR_e', NULL, NULL, NULL, 2),
(5063, NULL, 'cd09660', NULL, NULL, 'Csx1_III-U', NULL, 'Csx1_III-U', NULL, NULL, NULL, 2),
(5064, NULL, 'cd05922', NULL, NULL, 'FACL_like_6', NULL, 'FACL_like_6', NULL, NULL, NULL, 2),
(5065, NULL, 'cd09177', NULL, NULL, 'PLDc_RE_NgoFVII', NULL, 'PLDc_RE_NgoFVII', NULL, NULL, NULL, 2),
(5066, NULL, 'cd03597', NULL, NULL, 'CLECT_attractin_like', NULL, 'CLECT_attractin_like', NULL, NULL, 5849, 2),
(5067, NULL, 'cd05246', NULL, NULL, 'dTDP_GD_SDR_e', NULL, 'dTDP_GD_SDR_e', NULL, NULL, 6694, 2),
(5068, NULL, 'cd14288', NULL, NULL, 'UBA_HUWE1', NULL, 'UBA_HUWE1', NULL, NULL, 30163, 2),
(5069, NULL, 'cd15385', NULL, NULL, '7tmA_V1aR', NULL, '7tmA_V1aR', NULL, NULL, NULL, 2),
(5070, NULL, 'cd06241', NULL, NULL, 'M14-like', NULL, 'M14-like', NULL, NULL, NULL, 2),
(5071, NULL, 'cd13902', NULL, NULL, 'CuRO_3_McoC_like', NULL, 'CuRO_3_McoC_like', NULL, NULL, NULL, 2),
(5072, NULL, 'cd19726', NULL, NULL, 'bHLH-PAS_cycle_like', NULL, 'bHLH-PAS_cycle_like', NULL, NULL, NULL, 2),
(5073, NULL, 'cd08604', NULL, NULL, 'GDPD_SHV3_repeat_2', NULL, 'GDPD_SHV3_repeat_2', NULL, NULL, NULL, 2),
(5074, NULL, 'cd00304', NULL, NULL, 'RT_like', NULL, 'RT_like', NULL, NULL, NULL, 2),
(5075, NULL, 'cd16988', NULL, NULL, 'ANTH_N_YAP180', NULL, 'ANTH_N_YAP180', NULL, NULL, NULL, 2),
(5076, NULL, 'cd17350', NULL, NULL, 'MFS_PTR2', NULL, 'MFS_PTR2', NULL, NULL, NULL, 2),
(5077, NULL, 'cd05801', NULL, NULL, 'PGM_like3', NULL, 'PGM_like3', NULL, NULL, 6594, 2),
(5078, NULL, 'cd06995', NULL, NULL, 'cupin_YkgD-like_N', NULL, 'cupin_YkgD-like_N', NULL, NULL, NULL, 2),
(5079, NULL, 'cd16330', NULL, NULL, 'LolA_VioE', NULL, 'LolA_VioE', NULL, NULL, 11609, 2),
(5080, NULL, 'cd09919', NULL, NULL, 'SH2_STAT_family', NULL, 'SH2_STAT_family', NULL, NULL, NULL, 2),
(5081, NULL, 'cd16689', NULL, NULL, 'RING-H2_Vps18', NULL, 'RING-H2_Vps18', NULL, NULL, NULL, 2),
(5082, NULL, 'cd05389', NULL, NULL, 'CobQ_N', NULL, 'CobQ_N', NULL, NULL, NULL, 2),
(5083, NULL, 'cd06961', NULL, NULL, 'NR_DBD_TR', NULL, 'NR_DBD_TR', NULL, NULL, NULL, 2),
(5084, NULL, 'cd07384', NULL, NULL, 'MPP_Cdc1_like', NULL, 'MPP_Cdc1_like', NULL, NULL, NULL, 2),
(5085, NULL, 'cd12827', NULL, NULL, 'EcCorA_ZntB-like_u2', NULL, 'EcCorA_ZntB-like_u2', NULL, NULL, NULL, 2),
(5086, NULL, 'cd18379', NULL, NULL, 'BTB_POZ_Kv3_KCNC', NULL, 'BTB_POZ_Kv3_KCNC', NULL, NULL, NULL, 2),
(5087, NULL, 'cd18604', NULL, NULL, 'ABC_6TM_VMR1_D2_like', NULL, 'ABC_6TM_VMR1_D2_like', NULL, NULL, NULL, 2),
(5088, NULL, 'cd19740', NULL, NULL, 'bHLH-PAS_dSIM_like', NULL, 'bHLH-PAS_dSIM_like', NULL, NULL, NULL, 2),
(5089, NULL, 'cd01853', NULL, NULL, 'Toc34_like', NULL, 'Toc34_like', NULL, NULL, NULL, 2),
(5090, NULL, 'cd18550', NULL, NULL, 'ABC_6TM_exporter_like', NULL, 'ABC_6TM_exporter_like', NULL, NULL, NULL, 2),
(5091, NULL, 'cd07387', NULL, NULL, 'MPP_PolD2_C', NULL, 'MPP_PolD2_C', NULL, NULL, 30109, 2),
(5092, NULL, 'cd07199', NULL, NULL, 'Pat17_PNPLA8_PNPLA9_like', NULL, 'Pat17_PNPLA8_PNPLA9_like', NULL, NULL, NULL, 2);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(5093, NULL, 'cd16412', NULL, NULL, 'dndB', NULL, 'dndB', NULL, NULL, 16577, 2),
(5094, NULL, 'cd00615', NULL, NULL, 'Orn_deC_like', NULL, 'Orn_deC_like', NULL, NULL, 817, 2),
(5095, NULL, 'cd03596', NULL, NULL, 'CLECT_tetranectin_like', NULL, 'CLECT_tetranectin_like', NULL, NULL, NULL, 2),
(5096, NULL, 'cd18964', NULL, NULL, 'chromodomain', NULL, 'chromodomain', NULL, NULL, NULL, 2),
(5097, NULL, 'cd13550', NULL, NULL, 'PBP2_Fbp_like_4', NULL, 'PBP2_Fbp_like_4', NULL, NULL, NULL, 2),
(5098, NULL, 'cd15320', NULL, NULL, '7tmA_D1A_dopamine_R', NULL, '7tmA_D1A_dopamine_R', NULL, NULL, NULL, 2),
(5099, NULL, 'cd03299', NULL, NULL, 'ABC_ModC_like', NULL, 'ABC_ModC_like', NULL, NULL, NULL, 2),
(5100, NULL, 'cd06381', NULL, NULL, 'PBP1_iGluR_delta-like', NULL, 'PBP1_iGluR_delta-like', NULL, NULL, NULL, 2),
(5101, NULL, 'cd00823', NULL, NULL, 'TopoIIB_Trans', NULL, 'TopoIIB_Trans', NULL, NULL, 13079, 2),
(5102, NULL, 'cd19180', NULL, NULL, 'SET_SpSET10-like', NULL, 'SET_SpSET10-like', NULL, NULL, 35458, 2),
(5103, NULL, 'cd01176', NULL, NULL, 'IPT_RBP-Jkappa', NULL, 'IPT_RBP-Jkappa', NULL, NULL, 27760, 2),
(5104, NULL, 'cd17494', NULL, NULL, 'RMtype1_S_Sma198ORF994P-TRD2-CR2_like', NULL, 'RMtype1_S_Sma198ORF994P-TRD2-CR2_like', NULL, NULL, NULL, 2),
(5105, NULL, 'cd16126', NULL, NULL, 'Ubl_HR23B', NULL, 'Ubl_HR23B', NULL, NULL, NULL, 2),
(5106, NULL, 'cd19052', NULL, NULL, 'LGIC_TM_GABAAR_alpha', NULL, 'LGIC_TM_GABAAR_alpha', NULL, NULL, NULL, 2),
(5107, NULL, 'cd19431', NULL, NULL, 'lipocalin_Can_f_2', NULL, 'lipocalin_Can_f_2', NULL, NULL, NULL, 2),
(5108, NULL, 'cd13673', NULL, NULL, 'PBP2_TRAP_SBP_like_2', NULL, 'PBP2_TRAP_SBP_like_2', NULL, NULL, NULL, 2),
(5109, NULL, 'cd09468', NULL, NULL, 'LIM1_Lhx4', NULL, 'LIM1_Lhx4', NULL, NULL, NULL, 2),
(5110, NULL, 'cd10962', NULL, NULL, 'CE4_GT2-like', NULL, 'CE4_GT2-like', NULL, NULL, NULL, 2),
(5111, NULL, 'cd12367', NULL, NULL, 'RRM2_RBM45', NULL, 'RRM2_RBM45', NULL, NULL, 20877, 2),
(5112, NULL, 'cd13579', NULL, NULL, 'PBP2_Bug_NagM', NULL, 'PBP2_Bug_NagM', NULL, NULL, NULL, 2),
(5113, NULL, 'cd04028', NULL, NULL, 'C2B_RIM1alpha', NULL, 'C2B_RIM1alpha', NULL, NULL, NULL, 2),
(5114, NULL, 'cd12484', NULL, NULL, 'RRM1_RBM46', NULL, 'RRM1_RBM46', NULL, NULL, 13561, 2),
(5115, NULL, 'cd05230', NULL, NULL, 'UGD_SDR_e', NULL, 'UGD_SDR_e', NULL, NULL, NULL, 2),
(5116, NULL, 'cd07066', NULL, NULL, 'CRD_FZ', NULL, 'CRD_FZ', NULL, NULL, NULL, 2),
(5117, NULL, 'cd11857', NULL, NULL, 'SH3_DBS', NULL, 'SH3_DBS', NULL, NULL, 28422, 2),
(5118, NULL, 'cd18037', NULL, NULL, 'DEXSc_Pif1_like', NULL, 'DEXSc_Pif1_like', NULL, NULL, NULL, 2),
(5119, NULL, 'cd05968', NULL, NULL, 'AACS_like', NULL, 'AACS_like', NULL, NULL, NULL, 2),
(5120, NULL, 'cd09481', NULL, NULL, 'LIM1_CRP3', NULL, 'LIM1_CRP3', NULL, NULL, NULL, 2),
(5121, NULL, 'cd08903', NULL, NULL, 'START_STARD5-like', NULL, 'START_STARD5-like', NULL, NULL, NULL, 2),
(5122, NULL, 'cd15821', NULL, NULL, 'SPRY_PRY_RFPL', NULL, 'SPRY_PRY_RFPL', NULL, NULL, 31208, 2),
(5123, NULL, 'cd00648', NULL, NULL, 'Periplasmic_Binding_Protein_Type_2', NULL, 'Periplasmic_Binding_Protein_Type_2', NULL, NULL, NULL, 2),
(5124, NULL, 'cd03409', NULL, NULL, 'Chelatase_Class_II', NULL, 'Chelatase_Class_II', NULL, NULL, NULL, 2),
(5125, NULL, 'cd07825', NULL, NULL, 'SRPBCC_7', NULL, 'SRPBCC_7', NULL, NULL, NULL, 2),
(5126, NULL, 'cd01422', NULL, NULL, 'MGS', NULL, 'MGS', NULL, NULL, 5073, 2),
(5127, NULL, 'cd09976', NULL, NULL, 'LOTUS_3_TDRD5', NULL, 'LOTUS_3_TDRD5', NULL, NULL, NULL, 2),
(5128, NULL, 'cd13560', NULL, NULL, 'PBP2_taurine', NULL, 'PBP2_taurine', NULL, NULL, 6364, 2),
(5129, NULL, 'cd05605', NULL, NULL, 'STKc_GRK4_like', NULL, 'STKc_GRK4_like', NULL, NULL, NULL, 2),
(5130, NULL, 'cd08051', NULL, NULL, 'gp6_gp15_like', NULL, 'gp6_gp15_like', NULL, NULL, NULL, 2),
(5131, NULL, 'cd08054', NULL, NULL, 'gp6', NULL, 'gp6', NULL, NULL, 15145, 2),
(5132, NULL, 'cd07057', NULL, NULL, 'BMC_CcmK', NULL, 'BMC_CcmK', NULL, NULL, NULL, 2),
(5133, NULL, 'cd07256', NULL, NULL, 'HPCD_C_class_II', NULL, 'HPCD_C_class_II', NULL, NULL, NULL, 2);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(5134, NULL, 'cd08679', NULL, NULL, 'C2_DOCK180_related', NULL, 'C2_DOCK180_related', NULL, NULL, NULL, 2),
(5135, NULL, 'cd13913', NULL, NULL, 'ba3_CcO_II_C', NULL, 'ba3_CcO_II_C', NULL, NULL, 29809, 2),
(5136, NULL, 'cd00935', NULL, NULL, 'GlyRS_RNA', NULL, 'GlyRS_RNA', NULL, NULL, NULL, 2),
(5137, NULL, 'cd10286', NULL, NULL, 'somatolactin', NULL, 'somatolactin', NULL, NULL, NULL, 2),
(5138, NULL, 'cd04309', NULL, NULL, 'HAD_PSP_eu', NULL, 'HAD_PSP_eu', NULL, NULL, NULL, 2),
(5139, NULL, 'cd09977', NULL, NULL, 'LOTUS_1_Limkain_b1', NULL, 'LOTUS_1_Limkain_b1', NULL, NULL, NULL, 2),
(5140, NULL, 'cd06873', NULL, NULL, 'PX_SNX13', NULL, 'PX_SNX13', NULL, NULL, 27421, 2),
(5141, NULL, 'cd19444', NULL, NULL, 'FABP1', NULL, 'FABP1', NULL, NULL, NULL, 2),
(5142, NULL, 'cd07664', NULL, NULL, 'BAR_SNX2', NULL, 'BAR_SNX2', NULL, NULL, NULL, 2),
(5143, NULL, 'cd12520', NULL, NULL, 'RRM1_MRN1', NULL, 'RRM1_MRN1', NULL, NULL, 19762, 2),
(5144, NULL, 'cd04149', NULL, NULL, 'Arf6', NULL, 'Arf6', NULL, NULL, 30758, 2),
(5145, NULL, 'sd00034', NULL, NULL, 'LRR_AMN1', NULL, 'LRR_AMN1', NULL, NULL, NULL, 2),
(5146, NULL, 'cd04115', NULL, NULL, 'Rab33B_Rab33A', NULL, 'Rab33B_Rab33A', NULL, NULL, 30340, 2),
(5147, NULL, 'cd00114', NULL, NULL, 'LIGANc', NULL, 'LIGANc', NULL, NULL, 12700, 2),
(5148, NULL, 'cd19439', NULL, NULL, 'lipocalin_Ex-FABP-like', NULL, 'lipocalin_Ex-FABP-like', NULL, NULL, NULL, 2),
(5149, NULL, 'cd07011', NULL, NULL, 'cupin_PMI_type_I_N', NULL, 'cupin_PMI_type_I_N', NULL, NULL, NULL, 2),
(5150, NULL, 'cd13370', NULL, NULL, 'PH_GAP1m_mammal-like', NULL, 'PH_GAP1m_mammal-like', NULL, NULL, 32277, 2),
(5151, NULL, 'cd07035', NULL, NULL, 'TPP_PYR_POX_like', NULL, 'TPP_PYR_POX_like', NULL, NULL, NULL, 2),
(5152, NULL, 'cd11509', NULL, NULL, 'SLC6sbd_CT1', NULL, 'SLC6sbd_CT1', NULL, NULL, NULL, 2),
(5153, NULL, 'cd12792', NULL, NULL, 'RasGAP_plexin_B2', NULL, 'RasGAP_plexin_B2', NULL, NULL, NULL, 2),
(5154, NULL, 'cd01171', NULL, NULL, 'YXKO-related', NULL, 'YXKO-related', NULL, NULL, 5788, 2),
(5155, NULL, 'cd06446', NULL, NULL, 'Trp-synth_B', NULL, 'Trp-synth_B', NULL, NULL, 1206, 2),
(5156, NULL, 'cd19807', NULL, NULL, 'Bbox1_TRIM36-like', NULL, 'Bbox1_TRIM36-like', NULL, NULL, NULL, 2),
(5157, NULL, 'cd13258', NULL, NULL, 'PH_PLEKHJ1', NULL, 'PH_PLEKHJ1', NULL, NULL, NULL, 2),
(5158, NULL, 'cd13135', NULL, NULL, 'MATE_like_9', NULL, 'MATE_like_9', NULL, NULL, NULL, 2),
(5159, NULL, 'cd07220', NULL, NULL, 'Pat_PNPLA2', NULL, 'Pat_PNPLA2', NULL, NULL, 32317, 2),
(5160, NULL, 'cd01172', NULL, NULL, 'RfaE_like', NULL, 'RfaE_like', NULL, NULL, 12209, 2),
(5161, NULL, 'cd03588', NULL, NULL, 'CLECT_CSPGs', NULL, 'CLECT_CSPGs', NULL, NULL, 31658, 2),
(5162, NULL, 'cd07172', NULL, NULL, 'NR_DBD_GR_PR', NULL, 'NR_DBD_GR_PR', NULL, NULL, NULL, 2),
(5163, NULL, 'cd10845', NULL, NULL, 'DSRM_RNAse_III_family', NULL, 'DSRM_RNAse_III_family', NULL, NULL, NULL, 2),
(5164, NULL, 'cd04373', NULL, NULL, 'RhoGAP_p190', NULL, 'RhoGAP_p190', NULL, NULL, NULL, 2),
(5165, NULL, 'cd12600', NULL, NULL, 'RRM2_SRSF4_like', NULL, 'RRM2_SRSF4_like', NULL, NULL, NULL, 2),
(5166, NULL, 'cd17676', NULL, NULL, 'SWIB_BAF60C', NULL, 'SWIB_BAF60C', NULL, NULL, NULL, 2),
(5167, NULL, 'cd01359', NULL, NULL, 'Argininosuccinate_lyase', NULL, 'Argininosuccinate_lyase', NULL, NULL, 6393, 2),
(5168, NULL, 'cd16081', NULL, NULL, 'TSPcc_insect', NULL, 'TSPcc_insect', NULL, NULL, NULL, 2),
(5169, NULL, 'cd02342', NULL, NULL, 'ZZ_UBA_plant', NULL, 'ZZ_UBA_plant', NULL, NULL, NULL, 2),
(5170, NULL, 'cd03720', NULL, NULL, 'SOCS_ASB1', NULL, 'SOCS_ASB1', NULL, NULL, 29943, 2),
(5171, NULL, 'cd19019', NULL, NULL, 'LGIC_ECD_nAChR_A6', NULL, 'LGIC_ECD_nAChR_A6', NULL, NULL, NULL, 2),
(5172, NULL, 'cd06084', NULL, NULL, 'KOW_Spt5_4', NULL, 'KOW_Spt5_4', NULL, NULL, 30988, 2),
(5173, NULL, 'cd08159', NULL, NULL, 'APC10-like', NULL, 'APC10-like', NULL, NULL, NULL, 2),
(5174, NULL, 'cd00344', NULL, NULL, 'FBP_aldolase_I', NULL, 'FBP_aldolase_I', NULL, NULL, NULL, 2),
(5175, NULL, 'cd09665', NULL, NULL, 'Cas8a1_I-A', NULL, 'Cas8a1_I-A', NULL, NULL, NULL, 2);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(5176, NULL, 'cd13871', NULL, NULL, 'CuRO_2_AAO', NULL, 'CuRO_2_AAO', NULL, NULL, 29112, 2),
(5177, NULL, 'cd06389', NULL, NULL, 'PBP1_iGluR_AMPA_GluR2', NULL, 'PBP1_iGluR_AMPA_GluR2', NULL, NULL, NULL, 2),
(5178, NULL, 'cd03115', NULL, NULL, 'SRP_G_like', NULL, 'SRP_G_like', NULL, NULL, NULL, 2),
(5179, NULL, 'cd09462', NULL, NULL, 'LIM1_LIMK1', NULL, 'LIM1_LIMK1', NULL, NULL, NULL, 2),
(5180, NULL, 'cd19859', NULL, NULL, 'DSRM_STAU_rpt3', NULL, 'DSRM_STAU_rpt3', NULL, NULL, NULL, 2),
(5181, NULL, 'cd00657', NULL, NULL, 'Ferritin_like', NULL, 'Ferritin_like', NULL, NULL, NULL, 2),
(5182, NULL, 'cd08846', NULL, NULL, 'ArfGap_GIT1', NULL, 'ArfGap_GIT1', NULL, NULL, NULL, 2),
(5183, NULL, 'cd14908', NULL, NULL, 'MYSc_Myo47', NULL, 'MYSc_Myo47', NULL, NULL, NULL, 2),
(5184, NULL, 'cd11691', NULL, NULL, 'HRI1_like', NULL, 'HRI1_like', NULL, NULL, NULL, 2),
(5185, NULL, 'cd13227', NULL, NULL, 'PH-GRAM-like_Vps36', NULL, 'PH-GRAM-like_Vps36', NULL, NULL, NULL, 2),
(5186, NULL, 'cd09927', NULL, NULL, 'SH2_Tensin_like', NULL, 'SH2_Tensin_like', NULL, NULL, 12832, 2),
(5187, NULL, 'cd11845', NULL, NULL, 'SH3_Src_like', NULL, 'SH3_Src_like', NULL, NULL, NULL, 2),
(5188, NULL, 'cd18361', NULL, NULL, 'BTB_POZ_KCTD1-like', NULL, 'BTB_POZ_KCTD1-like', NULL, NULL, NULL, 2),
(5189, NULL, 'cd08308', NULL, NULL, 'Death_Tube', NULL, 'Death_Tube', NULL, NULL, 24946, 2),
(5190, NULL, 'cd04691', NULL, NULL, 'Nudix_Hydrolase_32', NULL, 'Nudix_Hydrolase_32', NULL, NULL, NULL, 2),
(5191, NULL, 'cd13632', NULL, NULL, 'PBP2_Aa-PDT_like', NULL, 'PBP2_Aa-PDT_like', NULL, NULL, NULL, 2),
(5192, NULL, 'cd02040', NULL, NULL, 'NifH', NULL, 'NifH', NULL, NULL, NULL, 2),
(5193, NULL, 'cd15442', NULL, NULL, '7tmB2_GPR97', NULL, '7tmB2_GPR97', NULL, NULL, NULL, 2),
(5194, NULL, 'cd16773', NULL, NULL, 'RING-HC_RBR_TRIAD1', NULL, 'RING-HC_RBR_TRIAD1', NULL, NULL, NULL, 2),
(5195, NULL, 'cd14173', NULL, NULL, 'STKc_Mnk2', NULL, 'STKc_Mnk2', NULL, NULL, NULL, 2),
(5196, NULL, 'cd03416', NULL, NULL, 'CbiX_SirB_N', NULL, 'CbiX_SirB_N', NULL, NULL, NULL, 2),
(5197, NULL, 'cd04922', NULL, NULL, 'ACT_AKi-HSDH-ThrA_2', NULL, 'ACT_AKi-HSDH-ThrA_2', NULL, NULL, NULL, 2),
(5198, NULL, 'cd12673', NULL, NULL, 'RRM_BOULE', NULL, 'RRM_BOULE', NULL, NULL, NULL, 2),
(5199, NULL, 'cd03427', NULL, NULL, 'MTH1', NULL, 'MTH1', NULL, NULL, NULL, 2),
(5200, NULL, 'cd05615', NULL, NULL, 'STKc_cPKC_alpha', NULL, 'STKc_cPKC_alpha', NULL, NULL, 5060, 2),
(5201, NULL, 'cd03062', NULL, NULL, 'TRX_Fd_Sucrase', NULL, 'TRX_Fd_Sucrase', NULL, NULL, 12051, 2),
(5202, NULL, 'cd11731', NULL, NULL, 'Lin1944_like_SDR_c', NULL, 'Lin1944_like_SDR_c', NULL, NULL, NULL, 2),
(5203, NULL, 'cd14164', NULL, NULL, 'STKc_TSSK6-like', NULL, 'STKc_TSSK6-like', NULL, NULL, 35711, 2),
(5204, NULL, 'cd16283', NULL, NULL, 'RomA-like_MBL-fold', NULL, 'RomA-like_MBL-fold', NULL, NULL, NULL, 2),
(5205, NULL, 'cd09281', NULL, NULL, 'UPF0066', NULL, 'UPF0066', NULL, NULL, 15800, 2),
(5206, NULL, 'cd18995', NULL, NULL, 'LGIC_AChBP', NULL, 'LGIC_AChBP', NULL, NULL, NULL, 2),
(5207, NULL, 'cd15566', NULL, NULL, 'PHD3_NSD', NULL, 'PHD3_NSD', NULL, NULL, NULL, 2),
(5208, NULL, 'cd15899', NULL, NULL, 'EFh_CREC', NULL, 'EFh_CREC', NULL, NULL, NULL, 2),
(5209, NULL, 'cd03154', NULL, NULL, 'TM4SF3_like_LEL', NULL, 'TM4SF3_like_LEL', NULL, NULL, NULL, 2),
(5210, NULL, 'cd08762', NULL, NULL, 'Cyt_b561_CYBASC3', NULL, 'Cyt_b561_CYBASC3', NULL, NULL, NULL, 2),
(5211, NULL, 'cd11362', NULL, NULL, 'RNase_PH_bact', NULL, 'RNase_PH_bact', NULL, NULL, 6590, 2),
(5212, NULL, 'cd18786', NULL, NULL, 'SF1_C', NULL, 'SF1_C', NULL, NULL, NULL, 2),
(5213, NULL, 'cd05537', NULL, NULL, 'POLBc_Pol_II', NULL, 'POLBc_Pol_II', NULL, NULL, NULL, 2),
(5214, NULL, 'cd13191', NULL, NULL, 'FERM_C_FRMD4A_FRMD4B', NULL, 'FERM_C_FRMD4A_FRMD4B', NULL, NULL, 30221, 2),
(5215, NULL, 'cd02669', NULL, NULL, 'Peptidase_C19M', NULL, 'Peptidase_C19M', NULL, NULL, 29199, 2),
(5216, NULL, 'cd05579', NULL, NULL, 'STKc_MAST_like', NULL, 'STKc_MAST_like', NULL, NULL, NULL, 2),
(5217, NULL, 'cd06581', NULL, NULL, 'TM_PBP1_LivM_like', NULL, 'TM_PBP1_LivM_like', NULL, NULL, 34864, 2);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(5218, NULL, 'cd11965', NULL, NULL, 'SH3_ASAP1', NULL, 'SH3_ASAP1', NULL, NULL, 29840, 2),
(5219, NULL, 'cd13972', NULL, NULL, 'UbiB', NULL, 'UbiB', NULL, NULL, 34822, 2),
(5220, NULL, 'cd02243', NULL, NULL, 'cupin_11S_legumin_C', NULL, 'cupin_11S_legumin_C', NULL, NULL, NULL, 2),
(5221, NULL, 'cd06150', NULL, NULL, 'YjgF_YER057c_UK114_like_2', NULL, 'YjgF_YER057c_UK114_like_2', NULL, NULL, 32794, 2),
(5222, NULL, 'cd05478', NULL, NULL, 'pepsin_A', NULL, 'pepsin_A', NULL, NULL, 26898, 2),
(5223, NULL, 'cd15053', NULL, NULL, '7tmA_D2-like_dopamine_R', NULL, '7tmA_D2-like_dopamine_R', NULL, NULL, NULL, 2),
(5224, NULL, 'cd17091', NULL, NULL, 'FERM_F0_SHANK', NULL, 'FERM_F0_SHANK', NULL, NULL, NULL, 2),
(5225, NULL, 'cd20169', NULL, NULL, 'Peptidase_M90_mtfA', NULL, 'Peptidase_M90_mtfA', NULL, NULL, 9412, 2),
(5226, NULL, 'cd13720', NULL, NULL, 'PBP2_iGluR_NMDA_Nr3', NULL, 'PBP2_iGluR_NMDA_Nr3', NULL, NULL, NULL, 2),
(5227, NULL, 'cd17100', NULL, NULL, 'FERM_F1_PTPN3_like', NULL, 'FERM_F1_PTPN3_like', NULL, NULL, NULL, 2),
(5228, NULL, 'cd08373', NULL, NULL, 'C2A_Ferlin', NULL, 'C2A_Ferlin', NULL, NULL, 32547, 2),
(5229, NULL, 'cd01355', NULL, NULL, 'AcnX', NULL, 'AcnX', NULL, NULL, 10135, 2),
(5230, NULL, 'cd16743', NULL, NULL, 'RING-HC_RNF5', NULL, 'RING-HC_RNF5', NULL, NULL, NULL, 2),
(5231, NULL, 'cd18389', NULL, NULL, 'BTB_POZ_KCTD2', NULL, 'BTB_POZ_KCTD2', NULL, NULL, NULL, 2),
(5232, NULL, 'cd01466', NULL, NULL, 'vWA_C3HC4_type', NULL, 'vWA_C3HC4_type', NULL, NULL, NULL, 2),
(5233, NULL, 'cd07679', NULL, NULL, 'F-BAR_PACSIN2', NULL, 'F-BAR_PACSIN2', NULL, NULL, 28777, 2),
(5234, NULL, 'cd13418', NULL, NULL, 'TNFRSF19', NULL, 'TNFRSF19', NULL, NULL, 13859, 2),
(5235, NULL, 'cd00316', NULL, NULL, 'Oxidoreductase_nitrogenase', NULL, 'Oxidoreductase_nitrogenase', NULL, NULL, NULL, 2),
(5236, NULL, 'cd13756', NULL, NULL, 'TGF_beta_BMPs_GDFs', NULL, 'TGF_beta_BMPs_GDFs', NULL, NULL, NULL, 2),
(5237, NULL, 'cd14134', NULL, NULL, 'PKc_CLK', NULL, 'PKc_CLK', NULL, NULL, NULL, 2),
(5238, NULL, 'cd12513', NULL, NULL, 'RRM3_RBM12B', NULL, 'RRM3_RBM12B', NULL, NULL, 8998, 2),
(5239, NULL, 'cd14709', NULL, NULL, 'bZIP_CREBL2', NULL, 'bZIP_CREBL2', NULL, NULL, NULL, 2),
(5240, NULL, 'cd14560', NULL, NULL, 'PTP_tensin-1', NULL, 'PTP_tensin-1', NULL, NULL, NULL, 2),
(5241, NULL, 'cd07546', NULL, NULL, 'P-type_ATPase_Pb_Zn_Cd2-like', NULL, 'P-type_ATPase_Pb_Zn_Cd2-like', NULL, NULL, NULL, 2),
(5242, NULL, 'cd02150', NULL, NULL, 'nitroreductase', NULL, 'nitroreductase', NULL, NULL, NULL, 2),
(5243, NULL, 'cd12549', NULL, NULL, 'RRM_Set1B', NULL, 'RRM_Set1B', NULL, NULL, 11714, 2),
(5244, NULL, 'cd16538', NULL, NULL, 'RING-HC_RNF112', NULL, 'RING-HC_RNF112', NULL, NULL, NULL, 2),
(5245, NULL, 'cd15751', NULL, NULL, 'FYVE_BSN_PCLO', NULL, 'FYVE_BSN_PCLO', NULL, NULL, NULL, 2),
(5246, NULL, 'cd15834', NULL, NULL, 'TNFRSF1A_teleost', NULL, 'TNFRSF1A_teleost', NULL, NULL, 8467, 2),
(5247, NULL, 'cd01025', NULL, NULL, 'TOPRIM_recR', NULL, 'TOPRIM_recR', NULL, NULL, 26100, 2),
(5248, NULL, 'cd12008', NULL, NULL, 'SH3_Src', NULL, 'SH3_Src', NULL, NULL, NULL, 2),
(5249, NULL, 'cd15892', NULL, NULL, 'R-SNARE_STXBP6', NULL, 'R-SNARE_STXBP6', NULL, NULL, 31507, 2),
(5250, NULL, 'cd09380', NULL, NULL, 'LIM1_Lhx6', NULL, 'LIM1_Lhx6', NULL, NULL, NULL, 2),
(5251, NULL, 'cd08728', NULL, NULL, 'RGS-like_2', NULL, 'RGS-like_2', NULL, NULL, NULL, 2),
(5252, NULL, 'cd04271', NULL, NULL, 'ZnMc_ADAM_fungal', NULL, 'ZnMc_ADAM_fungal', NULL, NULL, 14873, 2),
(5253, NULL, 'cd13218', NULL, NULL, 'PH-GRAM2_TCB1D8_TCB1D9_family', NULL, 'PH-GRAM2_TCB1D8_TCB1D9_family', NULL, NULL, NULL, 2),
(5254, NULL, 'cd01841', NULL, NULL, 'NnaC_like', NULL, 'NnaC_like', NULL, NULL, NULL, 2),
(5255, NULL, 'cd15525', NULL, NULL, 'PHD_UHRF1_2', NULL, 'PHD_UHRF1_2', NULL, NULL, NULL, 2),
(5256, NULL, 'cd08704', NULL, NULL, 'Met_tRNA_FMT_C', NULL, 'Met_tRNA_FMT_C', NULL, NULL, 36176, 2),
(5257, NULL, 'cd02238', NULL, NULL, 'cupin_KdgF', NULL, 'cupin_KdgF', NULL, NULL, NULL, 2),
(5258, NULL, 'cd16109', NULL, NULL, 'DCX1', NULL, 'DCX1', NULL, NULL, NULL, 2); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(5259, NULL, 'cd16860', NULL, NULL, 'ING_ING1', NULL, 'ING_ING1', NULL, NULL, NULL, 2),
(5260, NULL, 'cd06534', NULL, NULL, 'ALDH-SF', NULL, 'ALDH-SF', NULL, NULL, NULL, 2),
(5261, NULL, 'cd07204', NULL, NULL, 'Pat_PNPLA_like', NULL, 'Pat_PNPLA_like', NULL, NULL, NULL, 2),
(5262, NULL, 'cd11397', NULL, NULL, 'bHLHzip_MITF_like', NULL, 'bHLHzip_MITF_like', NULL, NULL, NULL, 2),
(5263, NULL, 'cd13264', NULL, NULL, 'PH_ITSN', NULL, 'PH_ITSN', NULL, NULL, NULL, 2),
(5264, NULL, 'cd15592', NULL, NULL, 'PHD3_KMT2A', NULL, 'PHD3_KMT2A', NULL, NULL, 36094, 2),
(5265, NULL, 'cd03030', NULL, NULL, 'GRX_SH3BGR', NULL, 'GRX_SH3BGR', NULL, NULL, 5868, 2),
(5266, NULL, 'cd21652', NULL, NULL, 'ORF4b_HKU4-CoV', NULL, 'ORF4b_HKU4-CoV', NULL, NULL, 36476, 2),
(5267, NULL, 'cd12721', NULL, NULL, 'RRM_Nup53p_fungi', NULL, 'RRM_Nup53p_fungi', NULL, NULL, NULL, 2),
(5268, NULL, 'cd16728', NULL, NULL, 'RING2-HC_MIB2', NULL, 'RING2-HC_MIB2', NULL, NULL, NULL, 2),
(5269, NULL, 'cd14334', NULL, NULL, 'UBA_SNF1_fungi', NULL, 'UBA_SNF1_fungi', NULL, NULL, 17562, 2),
(5270, NULL, 'cd06640', NULL, NULL, 'STKc_MST4', NULL, 'STKc_MST4', NULL, NULL, 18821, 2),
(5271, NULL, 'cd12461', NULL, NULL, 'RRM_SCAF4', NULL, 'RRM_SCAF4', NULL, NULL, 27702, 2),
(5272, NULL, 'cd08444', NULL, NULL, 'PBP2_Cbl', NULL, 'PBP2_Cbl', NULL, NULL, 28708, 2),
(5273, NULL, 'cd09837', NULL, NULL, 'CBS_pair_chlorobiales', NULL, 'CBS_pair_chlorobiales', NULL, NULL, NULL, 2),
(5274, NULL, 'cd18689', NULL, NULL, 'PIN_VapC-like', NULL, 'PIN_VapC-like', NULL, NULL, NULL, 2),
(5275, NULL, 'cd18242', NULL, NULL, 'BTB_POZ_KLHL12_C3IP1_DKIR', NULL, 'BTB_POZ_KLHL12_C3IP1_DKIR', NULL, NULL, NULL, 2),
(5276, NULL, 'cd01715', NULL, NULL, 'ETF_alpha', NULL, 'ETF_alpha', NULL, NULL, 32288, 2),
(5277, NULL, 'cd12510', NULL, NULL, 'RRM1_RBM12_like', NULL, 'RRM1_RBM12_like', NULL, NULL, NULL, 2),
(5278, NULL, 'cd00719', NULL, NULL, 'GIY-YIG_SF', NULL, 'GIY-YIG_SF', NULL, NULL, NULL, 2),
(5279, NULL, 'cd11945', NULL, NULL, 'SH3_Endophilin_B1', NULL, 'SH3_Endophilin_B1', NULL, NULL, NULL, 2),
(5280, NULL, 'cd05240', NULL, NULL, 'UDP_G4E_3_SDR_e', NULL, 'UDP_G4E_3_SDR_e', NULL, NULL, NULL, 2),
(5281, NULL, 'cd02803', NULL, NULL, 'OYE_like_FMN_family', NULL, 'OYE_like_FMN_family', NULL, NULL, NULL, 2),
(5282, NULL, 'cd16505', NULL, NULL, 'RING-HC_CYHR1', NULL, 'RING-HC_CYHR1', NULL, NULL, NULL, 2),
(5283, NULL, 'cd15558', NULL, NULL, 'PHD_Hop1p_like', NULL, 'PHD_Hop1p_like', NULL, NULL, NULL, 2),
(5284, NULL, 'cd14113', NULL, NULL, 'STKc_Trio_C', NULL, 'STKc_Trio_C', NULL, NULL, NULL, 2),
(5285, NULL, 'cd12189', NULL, NULL, 'LKR_SDH_like', NULL, 'LKR_SDH_like', NULL, NULL, NULL, 2),
(5286, NULL, 'cd17063', NULL, NULL, 'Ubl_ANKRD60', NULL, 'Ubl_ANKRD60', NULL, NULL, NULL, 2),
(5287, NULL, 'cd04789', NULL, NULL, 'HTH_Cfa', NULL, 'HTH_Cfa', NULL, NULL, NULL, 2),
(5288, NULL, 'cd12586', NULL, NULL, 'RRM1_PSP1', NULL, 'RRM1_PSP1', NULL, NULL, 32086, 2),
(5289, NULL, 'cd15721', NULL, NULL, 'FYVE_RUFY1_like', NULL, 'FYVE_RUFY1_like', NULL, NULL, NULL, 2),
(5290, NULL, 'cd18523', NULL, NULL, 'BACK_BTBD2', NULL, 'BACK_BTBD2', NULL, NULL, NULL, 2),
(5291, NULL, 'cd08467', NULL, NULL, 'PBP2_SyrM', NULL, 'PBP2_SyrM', NULL, NULL, 30689, 2),
(5292, NULL, 'cd11359', NULL, NULL, 'AmyAc_SLC3A1', NULL, 'AmyAc_SLC3A1', NULL, NULL, NULL, 2),
(5293, NULL, 'cd11783', NULL, NULL, 'SH3_SH3RF_3', NULL, 'SH3_SH3RF_3', NULL, NULL, NULL, 2),
(5294, NULL, 'cd14798', NULL, NULL, 'RX-CC_like', NULL, 'RX-CC_like', NULL, NULL, 33321, 2),
(5295, NULL, 'cd19423', NULL, NULL, 'lipocalin_LTBP1-like', NULL, 'lipocalin_LTBP1-like', NULL, NULL, NULL, 2),
(5296, NULL, 'cd01890', NULL, NULL, 'LepA', NULL, 'LepA', NULL, NULL, NULL, 2),
(5297, NULL, 'cd19397', NULL, NULL, 'TGF_beta_BMP7', NULL, 'TGF_beta_BMP7', NULL, NULL, NULL, 2),
(5298, NULL, 'cd16018', NULL, NULL, 'Enpp', NULL, 'Enpp', NULL, NULL, NULL, 2),
(5299, NULL, 'cd03581', NULL, NULL, 'NTR_Sfrp3_like', NULL, 'NTR_Sfrp3_like', NULL, NULL, 31424, 2),
(5300, NULL, 'cd09935', NULL, NULL, 'SH2_ABL', NULL, 'SH2_ABL', NULL, NULL, 31620, 2),
(5301, NULL, 'cd04879', NULL, NULL, 'ACT_3PGDH-like', NULL, 'ACT_3PGDH-like', NULL, NULL, NULL, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(5302, NULL, 'cd01291', NULL, NULL, 'PseudoU_synth', NULL, 'PseudoU_synth', NULL, NULL, NULL, 2),
(5303, NULL, 'cd07155', NULL, NULL, 'NR_DBD_ER_like', NULL, 'NR_DBD_ER_like', NULL, NULL, NULL, 2),
(5304, NULL, 'cd06608', NULL, NULL, 'STKc_myosinIII_N_like', NULL, 'STKc_myosinIII_N_like', NULL, NULL, NULL, 2),
(5305, NULL, 'cd19944', NULL, NULL, 'NirB_Fer2_BFD-like_2', NULL, 'NirB_Fer2_BFD-like_2', NULL, NULL, NULL, 2),
(5306, NULL, 'cd09485', NULL, NULL, 'LIM_Eplin_alpha_beta', NULL, 'LIM_Eplin_alpha_beta', NULL, NULL, NULL, 2),
(5307, NULL, 'cd09332', NULL, NULL, 'LIM2_PINCH', NULL, 'LIM2_PINCH', NULL, NULL, NULL, 2),
(5308, NULL, 'cd17635', NULL, NULL, 'FADD10', NULL, 'FADD10', NULL, NULL, NULL, 2),
(5309, NULL, 'cd13703', NULL, NULL, 'PBP2_HisJ_LAO', NULL, 'PBP2_HisJ_LAO', NULL, NULL, NULL, 2),
(5310, NULL, 'cd06342', NULL, NULL, 'PBP1_ABC_LIVBP-like', NULL, 'PBP1_ABC_LIVBP-like', NULL, NULL, NULL, 2),
(5311, NULL, 'cd15401', NULL, NULL, '7tmA_Mel1C', NULL, '7tmA_Mel1C', NULL, NULL, NULL, 2),
(5312, NULL, 'cd18510', NULL, NULL, 'BACK_KLHL4', NULL, 'BACK_KLHL4', NULL, NULL, NULL, 2),
(5313, NULL, 'cd02970', NULL, NULL, 'PRX_like2', NULL, 'PRX_like2', NULL, NULL, NULL, 2),
(5314, NULL, 'cd08339', NULL, NULL, 'DED_DEDD-like', NULL, 'DED_DEDD-like', NULL, NULL, NULL, 2),
(5315, NULL, 'cd13981', NULL, NULL, 'STKc_Bub1_BubR1', NULL, 'STKc_Bub1_BubR1', NULL, NULL, NULL, 2),
(5316, NULL, 'cd16872', NULL, NULL, 'ARID_HMGB9-like', NULL, 'ARID_HMGB9-like', NULL, NULL, 35572, 2),
(5317, NULL, 'cd04442', NULL, NULL, 'DEP_1_DEP6', NULL, 'DEP_1_DEP6', NULL, NULL, 27550, 2),
(5318, NULL, 'cd13922', NULL, NULL, 'Azurin', NULL, 'Azurin', NULL, NULL, 13155, 2),
(5319, NULL, 'cd05099', NULL, NULL, 'PTKc_FGFR4', NULL, 'PTKc_FGFR4', NULL, NULL, NULL, 2),
(5320, NULL, 'cd08766', NULL, NULL, 'Cyt_b561_ACYB-1_like', NULL, 'Cyt_b561_ACYB-1_like', NULL, NULL, NULL, 2),
(5321, NULL, 'cd11707', NULL, NULL, 'DHR2_DOCK1', NULL, 'DHR2_DOCK1', NULL, NULL, NULL, 2),
(5322, NULL, 'cd17754', NULL, NULL, 'MCM3', NULL, 'MCM3', NULL, NULL, NULL, 2),
(5323, NULL, 'cd14169', NULL, NULL, 'STKc_CaMKI_beta', NULL, 'STKc_CaMKI_beta', NULL, NULL, 36085, 2),
(5324, NULL, 'cd02018', NULL, NULL, 'TPP_PFOR', NULL, 'TPP_PFOR', NULL, NULL, NULL, 2),
(5325, NULL, 'cd09893', NULL, NULL, 'NGN_SP_TaA', NULL, 'NGN_SP_TaA', NULL, NULL, NULL, 2),
(5326, NULL, 'cd02769', NULL, NULL, 'MopB_DMSOR-BSOR-TMAOR', NULL, 'MopB_DMSOR-BSOR-TMAOR', NULL, NULL, NULL, 2),
(5327, NULL, 'cd08259', NULL, NULL, 'Zn_ADH5', NULL, 'Zn_ADH5', NULL, NULL, NULL, 2),
(5328, NULL, 'cd14482', NULL, NULL, 'SPX_BAH1-like', NULL, 'SPX_BAH1-like', NULL, NULL, NULL, 2),
(5329, NULL, 'cd16131', NULL, NULL, 'RA_Rin2', NULL, 'RA_Rin2', NULL, NULL, NULL, 2),
(5330, NULL, 'sd00018', NULL, NULL, 'ZF_C2H2', NULL, 'ZF_C2H2', NULL, NULL, NULL, 2),
(5331, NULL, 'cd05251', NULL, NULL, 'NmrA_like_SDR_a', NULL, 'NmrA_like_SDR_a', NULL, NULL, NULL, 2),
(5332, NULL, 'cd11263', NULL, NULL, 'Sema_5A', NULL, 'Sema_5A', NULL, NULL, 35296, 2),
(5333, NULL, 'cd12347', NULL, NULL, 'RRM_PPIE', NULL, 'RRM_PPIE', NULL, NULL, 3467, 2),
(5334, NULL, 'cd09503', NULL, NULL, 'SAM_tumor-p63,p73', NULL, 'SAM_tumor-p63,p73', NULL, NULL, NULL, 2),
(5335, NULL, 'cd12564', NULL, NULL, 'RRM1_RBM19', NULL, 'RRM1_RBM19', NULL, NULL, 12710, 2),
(5336, NULL, 'cd01809', NULL, NULL, 'Ubl_BAG6', NULL, 'Ubl_BAG6', NULL, NULL, NULL, 2),
(5337, NULL, 'cd13549', NULL, NULL, 'PBP2_Fbp_like_3', NULL, 'PBP2_Fbp_like_3', NULL, NULL, NULL, 2),
(5338, NULL, 'cd17380', NULL, NULL, 'MFS_SLC17A9_like', NULL, 'MFS_SLC17A9_like', NULL, NULL, 34711, 2),
(5339, NULL, 'cd08283', NULL, NULL, 'FDH_like_1', NULL, 'FDH_like_1', NULL, NULL, NULL, 2),
(5340, NULL, 'cd12063', NULL, NULL, 'SH3_Caskin2', NULL, 'SH3_Caskin2', NULL, NULL, 16876, 2),
(5341, NULL, 'cd02968', NULL, NULL, 'SCO', NULL, 'SCO', NULL, NULL, 3197, 2),
(5342, NULL, 'cd00688', NULL, NULL, 'ISOPREN_C2_like', NULL, 'ISOPREN_C2_like', NULL, NULL, NULL, 2),
(5343, NULL, 'cd12058', NULL, NULL, 'SH3_MLK4', NULL, 'SH3_MLK4', NULL, NULL, NULL, 2),
(5344, NULL, 'cd09381', NULL, NULL, 'LIM1_Lhx7_Lhx8', NULL, 'LIM1_Lhx7_Lhx8', NULL, NULL, NULL, 2);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(5345, NULL, 'cd00128', NULL, NULL, 'PIN_FEN1_EXO1-like', NULL, 'PIN_FEN1_EXO1-like', NULL, NULL, NULL, 2),
(5346, NULL, 'cd17393', NULL, NULL, 'MFS_MosC_like', NULL, 'MFS_MosC_like', NULL, NULL, NULL, 2),
(5347, NULL, 'cd17105', NULL, NULL, 'FERM_F1_EPB41', NULL, 'FERM_F1_EPB41', NULL, NULL, NULL, 2),
(5348, NULL, 'cd17185', NULL, NULL, 'FERM_F1_KIND3', NULL, 'FERM_F1_KIND3', NULL, NULL, NULL, 2),
(5349, NULL, 'cd16874', NULL, NULL, 'ARID_KDM5B', NULL, 'ARID_KDM5B', NULL, NULL, NULL, 2),
(5350, NULL, 'cd18578', NULL, NULL, 'ABC_6TM_Pgp_ABCB1_D2_like', NULL, 'ABC_6TM_Pgp_ABCB1_D2_like', NULL, NULL, NULL, 2),
(5351, NULL, 'cd18541', NULL, NULL, 'ABC_6TM_TmrB_like', NULL, 'ABC_6TM_TmrB_like', NULL, NULL, NULL, 2),
(5352, NULL, 'cd08977', NULL, NULL, 'SusD', NULL, 'SusD', NULL, NULL, NULL, 2),
(5353, NULL, 'cd17206', NULL, NULL, 'FERM_F1_Myosin-X', NULL, 'FERM_F1_Myosin-X', NULL, NULL, NULL, 2),
(5354, NULL, 'cd09472', NULL, NULL, 'LIM2_Lhx3b', NULL, 'LIM2_Lhx3b', NULL, NULL, NULL, 2),
(5355, NULL, 'cd07117', NULL, NULL, 'ALDH_StaphAldA1', NULL, 'ALDH_StaphAldA1', NULL, NULL, NULL, 2),
(5356, NULL, 'cd13666', NULL, NULL, 'PBP2_TRAP_DctP_like_1', NULL, 'PBP2_TRAP_DctP_like_1', NULL, NULL, NULL, 2),
(5357, NULL, 'cd13730', NULL, NULL, 'PBP2_iGluR_delta_1', NULL, 'PBP2_iGluR_delta_1', NULL, NULL, NULL, 2),
(5358, NULL, 'cd16317', NULL, NULL, 'IND_MBL-B1', NULL, 'IND_MBL-B1', NULL, NULL, NULL, 2),
(5359, NULL, 'cd02051', NULL, NULL, 'serpinE1_PAI-1', NULL, 'serpinE1_PAI-1', NULL, NULL, NULL, 2),
(5360, NULL, 'cd13415', NULL, NULL, 'TNFRSF13B', NULL, 'TNFRSF13B', NULL, NULL, 15896, 2),
(5361, NULL, 'cd10968', NULL, NULL, 'CE4_Mlr8448_like_5s', NULL, 'CE4_Mlr8448_like_5s', NULL, NULL, NULL, 2),
(5362, NULL, 'cd16895', NULL, NULL, 'TraH-like', NULL, 'TraH-like', NULL, NULL, NULL, 2),
(5363, NULL, 'cd16596', NULL, NULL, 'RING-HC_TRIM21_C-IV', NULL, 'RING-HC_TRIM21_C-IV', NULL, NULL, NULL, 2),
(5364, NULL, 'cd17337', NULL, NULL, 'MFS_CsbX', NULL, 'MFS_CsbX', NULL, NULL, NULL, 2),
(5365, NULL, 'cd19928', NULL, NULL, 'REC_RcNtrC-like', NULL, 'REC_RcNtrC-like', NULL, NULL, NULL, 2),
(5366, NULL, 'cd05327', NULL, NULL, 'retinol-DH_like_SDR_c_like', NULL, 'retinol-DH_like_SDR_c_like', NULL, NULL, NULL, 2),
(5367, NULL, 'cd03424', NULL, NULL, 'ADPRase_NUDT5', NULL, 'ADPRase_NUDT5', NULL, NULL, NULL, 2),
(5368, NULL, 'cd17373', NULL, NULL, 'MFS_SLC22A17_like', NULL, 'MFS_SLC22A17_like', NULL, NULL, NULL, 2),
(5369, NULL, 'cd00198', NULL, NULL, 'vWFA', NULL, 'vWFA', NULL, NULL, NULL, 2),
(5370, NULL, 'cd14739', NULL, NULL, 'PAAR_3', NULL, 'PAAR_3', NULL, NULL, NULL, 2),
(5371, NULL, 'cd19117', NULL, NULL, 'AKR_AKR3A1-2', NULL, 'AKR_AKR3A1-2', NULL, NULL, 34701, 2),
(5372, NULL, 'cd10981', NULL, NULL, 'ZnPC_S1P1', NULL, 'ZnPC_S1P1', NULL, NULL, NULL, 2),
(5373, NULL, 'cd05096', NULL, NULL, 'PTKc_DDR1', NULL, 'PTKc_DDR1', NULL, NULL, NULL, 2),
(5374, NULL, 'cd04375', NULL, NULL, 'RhoGAP_DLC1', NULL, 'RhoGAP_DLC1', NULL, NULL, NULL, 2),
(5375, NULL, 'cd00733', NULL, NULL, 'GlyRS_alpha_core', NULL, 'GlyRS_alpha_core', NULL, NULL, 6021, 2),
(5376, NULL, 'cd04454', NULL, NULL, 'S1_Rrp4_like', NULL, 'S1_Rrp4_like', NULL, NULL, NULL, 2),
(5377, NULL, 'cd17371', NULL, NULL, 'MFS_MucK', NULL, 'MFS_MucK', NULL, NULL, NULL, 2),
(5378, NULL, 'cd16074', NULL, NULL, 'OCRE', NULL, 'OCRE', NULL, NULL, NULL, 2),
(5379, NULL, 'cd16594', NULL, NULL, 'RING-HC_TRIM11_like_C-IV', NULL, 'RING-HC_TRIM11_like_C-IV', NULL, NULL, NULL, 2),
(5380, NULL, 'cd15668', NULL, NULL, 'ePHD_RAI1_like', NULL, 'ePHD_RAI1_like', NULL, NULL, NULL, 2),
(5381, NULL, 'cd19894', NULL, NULL, 'DSRM_STRBP-like_rpt1', NULL, 'DSRM_STRBP-like_rpt1', NULL, NULL, NULL, 2),
(5382, NULL, 'cd04093', NULL, NULL, 'HBS1_C_III', NULL, 'HBS1_C_III', NULL, NULL, NULL, 2),
(5383, NULL, 'cd02646', NULL, NULL, 'R3H_G-patch', NULL, 'R3H_G-patch', NULL, NULL, 26643, 2),
(5384, NULL, 'cd09836', NULL, NULL, 'CBS_pair_arch', NULL, 'CBS_pair_arch', NULL, NULL, NULL, 2),
(5385, NULL, 'cd00741', NULL, NULL, 'Lipase', NULL, 'Lipase', NULL, NULL, NULL, 2),
(5386, NULL, 'cd15334', NULL, NULL, '7tmA_5-HT1F', NULL, '7tmA_5-HT1F', NULL, NULL, NULL, 2);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(5387, NULL, 'cd15348', NULL, NULL, '7tmA_S1PR5_Edg8', NULL, '7tmA_S1PR5_Edg8', NULL, NULL, NULL, 2),
(5388, NULL, 'cd19204', NULL, NULL, 'SET_SETD1A', NULL, 'SET_SETD1A', NULL, NULL, NULL, 2),
(5389, NULL, 'cd14410', NULL, NULL, 'UBA_SIK3', NULL, 'UBA_SIK3', NULL, NULL, NULL, 2),
(5390, NULL, 'sd00043', NULL, NULL, 'ARM', NULL, 'ARM', NULL, NULL, NULL, 2),
(5391, NULL, 'cd05603', NULL, NULL, 'STKc_SGK2', NULL, 'STKc_SGK2', NULL, NULL, NULL, 2),
(5392, NULL, 'cd06523', NULL, NULL, 'GH25_PlyB-like', NULL, 'GH25_PlyB-like', NULL, NULL, NULL, 2),
(5393, NULL, 'cd06095', NULL, NULL, 'RP_RTVL_H_like', NULL, 'RP_RTVL_H_like', NULL, NULL, NULL, 2),
(5394, NULL, 'cd04682', NULL, NULL, 'Nudix_Hydrolase_23', NULL, 'Nudix_Hydrolase_23', NULL, NULL, NULL, 2),
(5395, NULL, 'cd16849', NULL, NULL, 'STAT5_DBD', NULL, 'STAT5_DBD', NULL, NULL, NULL, 2),
(5396, NULL, 'cd11286', NULL, NULL, 'ADF_cofilin_like', NULL, 'ADF_cofilin_like', NULL, NULL, 8375, 2),
(5397, NULL, 'cd16744', NULL, NULL, 'RING-HC_RNF185', NULL, 'RING-HC_RNF185', NULL, NULL, NULL, 2),
(5398, NULL, 'cd13355', NULL, NULL, 'PH-GRAM_MTM1', NULL, 'PH-GRAM_MTM1', NULL, NULL, NULL, 2),
(5399, NULL, 'cd06390', NULL, NULL, 'PBP1_iGluR_AMPA_GluR1', NULL, 'PBP1_iGluR_AMPA_GluR1', NULL, NULL, NULL, 2),
(5400, NULL, 'cd07571', NULL, NULL, 'ALP_N-acyl_transferase', NULL, 'ALP_N-acyl_transferase', NULL, NULL, 768, 2),
(5401, NULL, 'cd19910', NULL, NULL, 'DSRM_ILF3_rpt1', NULL, 'DSRM_ILF3_rpt1', NULL, NULL, NULL, 2),
(5402, NULL, 'cd14021', NULL, NULL, 'ChoK-like_euk', NULL, 'ChoK-like_euk', NULL, NULL, NULL, 2),
(5403, NULL, 'cd02810', NULL, NULL, 'DHOD_DHPD_FMN', NULL, 'DHOD_DHPD_FMN', NULL, NULL, NULL, 2),
(5404, NULL, 'cd00569', NULL, NULL, 'HTH_Hin_like', NULL, 'HTH_Hin_like', NULL, NULL, NULL, 2),
(5405, NULL, 'cd18705', NULL, NULL, 'PIN_VapC-like', NULL, 'PIN_VapC-like', NULL, NULL, NULL, 2),
(5406, NULL, 'cd15489', NULL, NULL, 'PHD_SF', NULL, 'PHD_SF', NULL, NULL, NULL, 2),
(5407, NULL, 'cd09237', NULL, NULL, 'V_ScBro1_like', NULL, 'V_ScBro1_like', NULL, NULL, NULL, 2),
(5408, NULL, 'cd10280', NULL, NULL, 'PQQ_mGDH', NULL, 'PQQ_mGDH', NULL, NULL, 21227, 2),
(5409, NULL, 'cd06279', NULL, NULL, 'PBP1_LacI-like', NULL, 'PBP1_LacI-like', NULL, NULL, NULL, 2),
(5410, NULL, 'cd18823', NULL, NULL, 'GH43_RcAra43A-like', NULL, 'GH43_RcAra43A-like', NULL, NULL, NULL, 2),
(5411, NULL, 'cd00026', NULL, NULL, 'BPI2', NULL, 'BPI2', NULL, NULL, NULL, 2),
(5412, NULL, 'cd04978', NULL, NULL, 'Ig4_L1-NrCAM_like', NULL, 'Ig4_L1-NrCAM_like', NULL, NULL, NULL, 2),
(5413, NULL, 'cd13121', NULL, NULL, 'BF2867_like_C', NULL, 'BF2867_like_C', NULL, NULL, NULL, 2),
(5414, NULL, 'cd12025', NULL, NULL, 'SH3_Obscurin_like', NULL, 'SH3_Obscurin_like', NULL, NULL, 27803, 2),
(5415, NULL, 'cd18039', NULL, NULL, 'DEXXQc_UPF1', NULL, 'DEXXQc_UPF1', NULL, NULL, NULL, 2),
(5416, NULL, 'cd03018', NULL, NULL, 'PRX_AhpE_like', NULL, 'PRX_AhpE_like', NULL, NULL, NULL, 2),
(5417, NULL, 'cd19683', NULL, NULL, 'bHLH_SOHLH_like', NULL, 'bHLH_SOHLH_like', NULL, NULL, NULL, 2),
(5418, NULL, 'cd19809', NULL, NULL, 'Bbox1_TRIM45_C-X', NULL, 'Bbox1_TRIM45_C-X', NULL, NULL, NULL, 2),
(5419, NULL, 'cd15670', NULL, NULL, 'ePHD_BRPF', NULL, 'ePHD_BRPF', NULL, NULL, NULL, 2),
(5420, NULL, 'cd15795', NULL, NULL, 'PMEI-Pla_a_1_like', NULL, 'PMEI-Pla_a_1_like', NULL, NULL, 29694, 2),
(5421, NULL, 'cd07095', NULL, NULL, 'ALDH_SGSD_AstD', NULL, 'ALDH_SGSD_AstD', NULL, NULL, 17368, 2),
(5422, NULL, 'cd16274', NULL, NULL, 'PQQB-like_MBL-fold', NULL, 'PQQB-like_MBL-fold', NULL, NULL, 13737, 2),
(5423, NULL, 'cd03537', NULL, NULL, 'Rieske_RO_Alpha_PrnD', NULL, 'Rieske_RO_Alpha_PrnD', NULL, NULL, 31732, 2),
(5424, NULL, 'cd06367', NULL, NULL, 'PBP1_iGluR_NMDA', NULL, 'PBP1_iGluR_NMDA', NULL, NULL, NULL, 2),
(5425, NULL, 'cd16396', NULL, NULL, 'Noc_N', NULL, 'Noc_N', NULL, NULL, NULL, 2),
(5426, NULL, 'cd06337', NULL, NULL, 'PBP1_ABC_ligand_binding-like', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, NULL, 2),
(5427, NULL, 'cd12805', NULL, NULL, 'Allergen_V_VI', NULL, 'Allergen_V_VI', NULL, NULL, NULL, 2);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(5428, NULL, 'cd14229', NULL, NULL, 'STKc_HIPK3', NULL, 'STKc_HIPK3', NULL, NULL, NULL, 2),
(5429, NULL, 'cd04372', NULL, NULL, 'RhoGAP_chimaerin', NULL, 'RhoGAP_chimaerin', NULL, NULL, 32473, 2),
(5430, NULL, 'cd02684', NULL, NULL, 'MIT_2', NULL, 'MIT_2', NULL, NULL, NULL, 2),
(5431, NULL, 'cd15754', NULL, NULL, 'FYVE_PKHF1', NULL, 'FYVE_PKHF1', NULL, NULL, 34276, 2),
(5432, NULL, 'cd19338', NULL, NULL, 'Wnt_Wnt6', NULL, 'Wnt_Wnt6', NULL, NULL, NULL, 2),
(5433, NULL, 'cd05757', NULL, NULL, 'Ig2_IL1R_like', NULL, 'Ig2_IL1R_like', NULL, NULL, NULL, 2),
(5434, NULL, 'cd06592', NULL, NULL, 'GH31_NET37', NULL, 'GH31_NET37', NULL, NULL, NULL, 2),
(5435, NULL, 'cd15663', NULL, NULL, 'ePHD_ATX3_4_5_like', NULL, 'ePHD_ATX3_4_5_like', NULL, NULL, 30333, 2),
(5436, NULL, 'cd04089', NULL, NULL, 'eRF3_II', NULL, 'eRF3_II', NULL, NULL, NULL, 2),
(5437, NULL, 'cd18229', NULL, NULL, 'BTB_POZ_ZBTB45', NULL, 'BTB_POZ_ZBTB45', NULL, NULL, NULL, 2),
(5438, NULL, 'cd18412', NULL, NULL, 'BTB_POZ_KCNB2', NULL, 'BTB_POZ_KCNB2', NULL, NULL, NULL, 2),
(5439, NULL, 'cd02575', NULL, NULL, 'PseudoU_synth_EcTruD', NULL, 'PseudoU_synth_EcTruD', NULL, NULL, NULL, 2),
(5440, NULL, 'cd13160', NULL, NULL, 'PTB_LDLRAP_insect-like', NULL, 'PTB_LDLRAP_insect-like', NULL, NULL, NULL, 2),
(5441, NULL, 'cd17670', NULL, NULL, 'R-PTP-G-2', NULL, 'R-PTP-G-2', NULL, NULL, NULL, 2),
(5442, NULL, 'cd00196', NULL, NULL, 'Ubiquitin_like_fold', NULL, 'Ubiquitin_like_fold', NULL, NULL, NULL, 2),
(5443, NULL, 'cd02656', NULL, NULL, 'MIT', NULL, 'MIT', NULL, NULL, NULL, 2),
(5444, NULL, 'cd02735', NULL, NULL, 'RNAP_I_Rpa1_C', NULL, 'RNAP_I_Rpa1_C', NULL, NULL, NULL, 2),
(5445, NULL, 'cd17368', NULL, NULL, 'MFS_CitA', NULL, 'MFS_CitA', NULL, NULL, NULL, 2),
(5446, NULL, 'cd00527', NULL, NULL, 'IF6', NULL, 'IF6', NULL, NULL, 4654, 2),
(5447, NULL, 'cd05188', NULL, NULL, 'MDR', NULL, 'MDR', NULL, NULL, NULL, 2),
(5448, NULL, 'cd14037', NULL, NULL, 'STKc_NAK_like', NULL, 'STKc_NAK_like', NULL, NULL, NULL, 2),
(5449, NULL, 'cd09478', NULL, NULL, 'LIM_CRIP', NULL, 'LIM_CRIP', NULL, NULL, NULL, 2),
(5450, NULL, 'cd15306', NULL, NULL, '7tmA_5-HT2B', NULL, '7tmA_5-HT2B', NULL, NULL, NULL, 2),
(5451, NULL, 'cd15373', NULL, NULL, '7tmA_P2Y2', NULL, '7tmA_P2Y2', NULL, NULL, NULL, 2),
(5452, NULL, 'cd06332', NULL, NULL, 'PBP1_aromatic_compounds-like', NULL, 'PBP1_aromatic_compounds-like', NULL, NULL, NULL, 2),
(5453, NULL, 'cd12431', NULL, NULL, 'RRM_ALKBH8', NULL, 'RRM_ALKBH8', NULL, NULL, 31754, 2),
(5454, NULL, 'cd03081', NULL, NULL, 'TRX_Fd_NuoE_FDH_gamma', NULL, 'TRX_Fd_NuoE_FDH_gamma', NULL, NULL, NULL, 2),
(5455, NULL, 'cd07022', NULL, NULL, 'S49_Sppa_36K_type', NULL, 'S49_Sppa_36K_type', NULL, NULL, 30781, 2),
(5456, NULL, 'cd18403', NULL, NULL, 'BTB_POZ_KCNA2_KCNA3', NULL, 'BTB_POZ_KCNA2_KCNA3', NULL, NULL, NULL, 2),
(5457, NULL, 'cd16356', NULL, NULL, 'PsjN_like', NULL, 'PsjN_like', NULL, NULL, NULL, 2),
(5458, NULL, 'cd19401', NULL, NULL, 'TGF_beta_BMP10', NULL, 'TGF_beta_BMP10', NULL, NULL, NULL, 2),
(5459, NULL, 'cd18292', NULL, NULL, 'BTB_POZ_BTBD17', NULL, 'BTB_POZ_BTBD17', NULL, NULL, NULL, 2),
(5460, NULL, 'cd12676', NULL, NULL, 'RRM3_Nop4p', NULL, 'RRM3_Nop4p', NULL, NULL, 32155, 2),
(5461, NULL, 'cd16904', NULL, NULL, 'pesticin_lyz-like', NULL, 'pesticin_lyz-like', NULL, NULL, NULL, 2),
(5462, NULL, 'cd15709', NULL, NULL, 'ePHD_AF17', NULL, 'ePHD_AF17', NULL, NULL, NULL, 2),
(5463, NULL, 'cd03319', NULL, NULL, 'L-Ala-DL-Glu_epimerase', NULL, 'L-Ala-DL-Glu_epimerase', NULL, NULL, 10541, 2),
(5464, NULL, 'cd10344', NULL, NULL, 'SH2_SLAP', NULL, 'SH2_SLAP', NULL, NULL, 9037, 2),
(5465, NULL, 'cd04494', NULL, NULL, 'BRCA2DBD_OB2', NULL, 'BRCA2DBD_OB2', NULL, NULL, NULL, 2),
(5466, NULL, 'cd09234', NULL, NULL, 'V_HD-PTP_like', NULL, 'V_HD-PTP_like', NULL, NULL, NULL, 2),
(5467, NULL, 'cd01855', NULL, NULL, 'YqeH', NULL, 'YqeH', NULL, NULL, NULL, 2),
(5468, NULL, 'cd17144', NULL, NULL, 'DCX2_DCLK2', NULL, 'DCX2_DCLK2', NULL, NULL, NULL, 2),
(5469, NULL, 'cd03822', NULL, NULL, 'GT4_mannosyltransferase-like', NULL, 'GT4_mannosyltransferase-like', NULL, NULL, NULL, 2);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(5470, NULL, 'cd11496', NULL, NULL, 'SLC6sbd-TauT-like', NULL, 'SLC6sbd-TauT-like', NULL, NULL, NULL, 2),
(5471, NULL, 'cd00203', NULL, NULL, 'ZnMc', NULL, 'ZnMc', NULL, NULL, NULL, 2),
(5472, NULL, 'cd17372', NULL, NULL, 'MFS_SVOP_like', NULL, 'MFS_SVOP_like', NULL, NULL, NULL, 2),
(5473, NULL, 'sd00035', NULL, NULL, 'LRR_NTF', NULL, 'LRR_NTF', NULL, NULL, NULL, 2),
(5474, NULL, 'cd00065', NULL, NULL, 'FYVE_like_SF', NULL, 'FYVE_like_SF', NULL, NULL, NULL, 2),
(5475, NULL, 'cd16269', NULL, NULL, 'GBP_C', NULL, 'GBP_C', NULL, NULL, 27917, 2),
(5476, NULL, 'cd11480', NULL, NULL, 'SLC5sbd_u4', NULL, 'SLC5sbd_u4', NULL, NULL, NULL, 2),
(5477, NULL, 'cd16798', NULL, NULL, 'RING-H2_RNF43', NULL, 'RING-H2_RNF43', NULL, NULL, 34811, 2),
(5478, NULL, 'cd19158', NULL, NULL, 'AKR_KCAB2B_AKR6A1-like', NULL, 'AKR_KCAB2B_AKR6A1-like', NULL, NULL, NULL, 2),
(5479, NULL, 'cd05391', NULL, NULL, 'RasGAP_p120GAP', NULL, 'RasGAP_p120GAP', NULL, NULL, NULL, 2),
(5480, NULL, 'cd01104', NULL, NULL, 'HTH_MlrA-CarA', NULL, 'HTH_MlrA-CarA', NULL, NULL, NULL, 2),
(5481, NULL, 'cd09589', NULL, NULL, 'SAM_TFCP2', NULL, 'SAM_TFCP2', NULL, NULL, 33909, 2),
(5482, NULL, 'cd12284', NULL, NULL, 'RRM2_RBM23_RBM39', NULL, 'RRM2_RBM23_RBM39', NULL, NULL, NULL, 2),
(5483, NULL, 'cd16132', NULL, NULL, 'RA_RASSF10', NULL, 'RA_RASSF10', NULL, NULL, NULL, 2),
(5484, NULL, 'cd17655', NULL, NULL, 'A_NRPS_Bac', NULL, 'A_NRPS_Bac', NULL, NULL, NULL, 2),
(5485, NULL, 'cd01725', NULL, NULL, 'LSm2', NULL, 'LSm2', NULL, NULL, 19567, 2),
(5486, NULL, 'cd03709', NULL, NULL, 'lepA_C', NULL, 'lepA_C', NULL, NULL, 32316, 2),
(5487, NULL, 'cd13441', NULL, NULL, 'CamS_repeat_1', NULL, 'CamS_repeat_1', NULL, NULL, NULL, 2),
(5488, NULL, 'cd17032', NULL, NULL, 'T3SC_IA_SycT-like', NULL, 'T3SC_IA_SycT-like', NULL, NULL, NULL, 2),
(5489, NULL, 'cd18341', NULL, NULL, 'BTB_POZ_KLHL41_KBTBD10', NULL, 'BTB_POZ_KLHL41_KBTBD10', NULL, NULL, NULL, 2),
(5490, NULL, 'cd02198', NULL, NULL, 'YjgH_like', NULL, 'YjgH_like', NULL, NULL, 31837, 2),
(5491, NULL, 'cd14544', NULL, NULL, 'PTPc-N11_6', NULL, 'PTPc-N11_6', NULL, NULL, NULL, 2),
(5492, NULL, 'cd04436', NULL, NULL, 'DEP_fRgd2', NULL, 'DEP_fRgd2', NULL, NULL, NULL, 2),
(5493, NULL, 'cd12147', NULL, NULL, 'Cep3_C', NULL, 'Cep3_C', NULL, NULL, NULL, 2),
(5494, NULL, 'cd04731', NULL, NULL, 'HisF', NULL, 'HisF', NULL, NULL, 2673, 2),
(5495, NULL, 'cd09173', NULL, NULL, 'PLDc_Nuc_like_unchar1_2', NULL, 'PLDc_Nuc_like_unchar1_2', NULL, NULL, NULL, 2),
(5496, NULL, 'cd03599', NULL, NULL, 'CLECT_DGCR2_like', NULL, 'CLECT_DGCR2_like', NULL, NULL, 5539, 2),
(5497, NULL, 'cd07443', NULL, NULL, 'CRD_SFRP1', NULL, 'CRD_SFRP1', NULL, NULL, 30486, 2),
(5498, NULL, 'cd18961', NULL, NULL, 'CD_CEC-4_like', NULL, 'CD_CEC-4_like', NULL, NULL, NULL, 2),
(5499, NULL, 'cd06454', NULL, NULL, 'KBL_like', NULL, 'KBL_like', NULL, NULL, NULL, 2),
(5500, NULL, 'cd11280', NULL, NULL, 'gelsolin_like', NULL, 'gelsolin_like', NULL, NULL, NULL, 2),
(5501, NULL, 'cd16463', NULL, NULL, 'RING-H2_PHR', NULL, 'RING-H2_PHR', NULL, NULL, NULL, 2),
(5502, NULL, 'cd15184', NULL, NULL, '7tmA_CCR5_CCR2', NULL, '7tmA_CCR5_CCR2', NULL, NULL, NULL, 2),
(5503, NULL, 'cd09983', NULL, NULL, 'LOTUS_7_Limkain_b1', NULL, 'LOTUS_7_Limkain_b1', NULL, NULL, NULL, 2),
(5504, NULL, 'cd19540', NULL, NULL, 'LCL_NRPS-like', NULL, 'LCL_NRPS-like', NULL, NULL, NULL, 2),
(5505, NULL, 'cd17421', NULL, NULL, 'MFS_MCT5', NULL, 'MFS_MCT5', NULL, NULL, NULL, 2),
(5506, NULL, 'cd04159', NULL, NULL, 'Arl10_like', NULL, 'Arl10_like', NULL, NULL, 33706, 2),
(5507, NULL, 'cd11984', NULL, NULL, 'SH3_Shank3', NULL, 'SH3_Shank3', NULL, NULL, NULL, 2),
(5508, NULL, 'cd07971', NULL, NULL, 'OBF_DNA_ligase_LigD', NULL, 'OBF_DNA_ligase_LigD', NULL, NULL, NULL, 2),
(5509, NULL, 'cd18006', NULL, NULL, 'DEXHc_CHD1L', NULL, 'DEXHc_CHD1L', NULL, NULL, NULL, 2),
(5510, NULL, 'cd06369', NULL, NULL, 'PBP1_GC_C_enterotoxin_receptor', NULL, 'PBP1_GC_C_enterotoxin_receptor', NULL, NULL, NULL, 2),
(5511, NULL, 'cd15182', NULL, NULL, '7tmA_XCR1', NULL, '7tmA_XCR1', NULL, NULL, NULL, 2),
(5512, NULL, 'cd00652', NULL, NULL, 'TBP_TLF', NULL, 'TBP_TLF', NULL, NULL, NULL, 2);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(5513, NULL, 'cd09250', NULL, NULL, 'AP-1_Mu1_Cterm', NULL, 'AP-1_Mu1_Cterm', NULL, NULL, NULL, 2),
(5514, NULL, 'cd10288', NULL, NULL, 'prolactin_like', NULL, 'prolactin_like', NULL, NULL, NULL, 2),
(5515, NULL, 'cd19700', NULL, NULL, 'bHLH_TS_TWIST2', NULL, 'bHLH_TS_TWIST2', NULL, NULL, NULL, 2),
(5516, NULL, 'cd07258', NULL, NULL, 'PpCmtC_C', NULL, 'PpCmtC_C', NULL, NULL, NULL, 2),
(5517, NULL, 'cd19536', NULL, NULL, 'DCL_NRPS-like', NULL, 'DCL_NRPS-like', NULL, NULL, NULL, 2),
(5518, NULL, 'cd15529', NULL, NULL, 'PHD2_PHF10', NULL, 'PHD2_PHF10', NULL, NULL, NULL, 2),
(5519, NULL, 'cd01702', NULL, NULL, 'PolY_Pol_eta', NULL, 'PolY_Pol_eta', NULL, NULL, NULL, 2),
(5520, NULL, 'cd15382', NULL, NULL, '7tmA_AKHR', NULL, '7tmA_AKHR', NULL, NULL, NULL, 2),
(5521, NULL, 'cd00257', NULL, NULL, 'Fascin', NULL, 'Fascin', NULL, NULL, 20465, 2),
(5522, NULL, 'cd04448', NULL, NULL, 'DEP_PIKfyve', NULL, 'DEP_PIKfyve', NULL, NULL, 27990, 2),
(5523, NULL, 'cd16009', NULL, NULL, 'PPM', NULL, 'PPM', NULL, NULL, 5455, 2),
(5524, NULL, 'cd12569', NULL, NULL, 'RRM4_RBM19', NULL, 'RRM4_RBM19', NULL, NULL, 13068, 2),
(5525, NULL, 'cd19120', NULL, NULL, 'AKR_AKR3C2-3', NULL, 'AKR_AKR3C2-3', NULL, NULL, 34558, 2),
(5526, NULL, 'cd07313', NULL, NULL, 'terB_like_2', NULL, 'terB_like_2', NULL, NULL, NULL, 2),
(5527, NULL, 'cd01901', NULL, NULL, 'Ntn_hydrolase', NULL, 'Ntn_hydrolase', NULL, NULL, NULL, 2),
(5528, NULL, 'cd11567', NULL, NULL, 'YciH_like', NULL, 'YciH_like', NULL, NULL, 6941, 2),
(5529, NULL, 'cd12475', NULL, NULL, 'RRM2_RBMS3', NULL, 'RRM2_RBMS3', NULL, NULL, 15150, 2),
(5530, NULL, 'cd14492', NULL, NULL, 'lipocalin_MxiM-like', NULL, 'lipocalin_MxiM-like', NULL, NULL, 26318, 2),
(5531, NULL, 'cd18920', NULL, NULL, 'bHLH-O_HEY2', NULL, 'bHLH-O_HEY2', NULL, NULL, NULL, 2),
(5532, NULL, 'cd11293', NULL, NULL, 'gelsolin_S4_like', NULL, 'gelsolin_S4_like', NULL, NULL, NULL, 2),
(5533, NULL, 'cd12248', NULL, NULL, 'RRM_RBM44', NULL, 'RRM_RBM44', NULL, NULL, 14582, 2),
(5534, NULL, 'cd00596', NULL, NULL, 'Peptidase_M14_like', NULL, 'Peptidase_M14_like', NULL, NULL, NULL, 2),
(5535, NULL, 'cd01381', NULL, NULL, 'MYSc_Myo7', NULL, 'MYSc_Myo7', NULL, NULL, 28073, 2),
(5536, NULL, 'cd09543', NULL, NULL, 'SAM_EPH-A2', NULL, 'SAM_EPH-A2', NULL, NULL, NULL, 2),
(5537, NULL, 'cd09738', NULL, NULL, 'Csb1_I-U', NULL, 'Csb1_I-U', NULL, NULL, NULL, 2),
(5538, NULL, 'cd14670', NULL, NULL, 'BslA_like', NULL, 'BslA_like', NULL, NULL, 5669, 2),
(5539, NULL, 'cd18031', NULL, NULL, 'DEXHc_UvsW', NULL, 'DEXHc_UvsW', NULL, NULL, NULL, 2),
(5540, NULL, 'cd07828', NULL, NULL, 'lipocalin_heme-bd-THAP4-like', NULL, 'lipocalin_heme-bd-THAP4-like', NULL, NULL, 13451, 2),
(5541, NULL, 'cd16213', NULL, NULL, 'EFh_PI-PLC21', NULL, 'EFh_PI-PLC21', NULL, NULL, NULL, 2),
(5542, NULL, 'cd16035', NULL, NULL, 'sulfatase_like', NULL, 'sulfatase_like', NULL, NULL, NULL, 2),
(5543, NULL, 'cd17077', NULL, NULL, 'UBX_UBXN11', NULL, 'UBX_UBXN11', NULL, NULL, NULL, 2),
(5544, NULL, 'cd15168', NULL, NULL, '7tmA_P2Y1-like', NULL, '7tmA_P2Y1-like', NULL, NULL, NULL, 2),
(5545, NULL, 'cd09424', NULL, NULL, 'LIM2_FHL1', NULL, 'LIM2_FHL1', NULL, NULL, NULL, 2),
(5546, NULL, 'cd01055', NULL, NULL, 'Nonheme_Ferritin', NULL, 'Nonheme_Ferritin', NULL, NULL, 29734, 2),
(5547, NULL, 'cd02010', NULL, NULL, 'TPP_ALS', NULL, 'TPP_ALS', NULL, NULL, NULL, 2),
(5548, NULL, 'cd12137', NULL, NULL, 'GbX', NULL, 'GbX', NULL, NULL, NULL, 2),
(5549, NULL, 'cd16823', NULL, NULL, 'SP-RING_ZMIZ2', NULL, 'SP-RING_ZMIZ2', NULL, NULL, NULL, 2),
(5550, NULL, 'cd11824', NULL, NULL, 'SH3_PSTPIP1', NULL, 'SH3_PSTPIP1', NULL, NULL, 24268, 2),
(5551, NULL, 'cd21511', NULL, NULL, 'cv-alpha_beta_Nsp2-like', NULL, 'cv-alpha_beta_Nsp2-like', NULL, NULL, NULL, 2),
(5552, NULL, 'cd03029', NULL, NULL, 'GRX_hybridPRX5', NULL, 'GRX_hybridPRX5', NULL, NULL, NULL, 2),
(5553, NULL, 'cd04281', NULL, NULL, 'ZnMc_BMP1_TLD', NULL, 'ZnMc_BMP1_TLD', NULL, NULL, 19084, 2),
(5554, NULL, 'cd16282', NULL, NULL, 'metallo-hydrolase-like_MBL-fold', NULL, 'metallo-hydrolase-like_MBL-fold', NULL, NULL, NULL, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(5555, NULL, 'cd10370', NULL, NULL, 'SH2_Src_Src42', NULL, 'SH2_Src_Src42', NULL, NULL, NULL, 2),
(5556, NULL, 'cd14813', NULL, NULL, 'bZIP_BmCbz-like', NULL, 'bZIP_BmCbz-like', NULL, NULL, NULL, 2),
(5557, NULL, 'cd14740', NULL, NULL, 'PAAR_4', NULL, 'PAAR_4', NULL, NULL, NULL, 2),
(5558, NULL, 'cd16454', NULL, NULL, 'RING-H2_PA-TM-RING', NULL, 'RING-H2_PA-TM-RING', NULL, NULL, NULL, 2),
(5559, NULL, 'cd12765', NULL, NULL, 'RRM2_SRSF5', NULL, 'RRM2_SRSF5', NULL, NULL, NULL, 2),
(5560, NULL, 'cd08754', NULL, NULL, 'RGS_LARG', NULL, 'RGS_LARG', NULL, NULL, 31537, 2),
(5561, NULL, 'cd12772', NULL, NULL, 'RRM1_HuC', NULL, 'RRM1_HuC', NULL, NULL, NULL, 2),
(5562, NULL, 'cd02426', NULL, NULL, 'Pol_gamma_b_Cterm', NULL, 'Pol_gamma_b_Cterm', NULL, NULL, 31533, 2),
(5563, NULL, 'cd01429', NULL, NULL, 'ATP-synt_F1_V1_A1_AB_FliI_C', NULL, 'ATP-synt_F1_V1_A1_AB_FliI_C', NULL, NULL, NULL, 2),
(5564, NULL, 'cd01120', NULL, NULL, 'RecA-like_NTPases', NULL, 'RecA-like_NTPases', NULL, NULL, NULL, 2),
(5565, NULL, 'cd07464', NULL, NULL, 'CRD_FZ2', NULL, 'CRD_FZ2', NULL, NULL, 30924, 2),
(5566, NULL, 'cd00133', NULL, NULL, 'PTS_IIB', NULL, 'PTS_IIB', NULL, NULL, NULL, 2),
(5567, NULL, 'cd03678', NULL, NULL, 'MM_CoA_mutase_1', NULL, 'MM_CoA_mutase_1', NULL, NULL, NULL, 2),
(5568, NULL, 'cd03340', NULL, NULL, 'TCP1_eta', NULL, 'TCP1_eta', NULL, NULL, 11551, 2),
(5569, NULL, 'cd07061', NULL, NULL, 'HP_HAP_like', NULL, 'HP_HAP_like', NULL, NULL, 4229, 2),
(5570, NULL, 'cd16270', NULL, NULL, 'Apc5_N', NULL, 'Apc5_N', NULL, NULL, NULL, 2),
(5571, NULL, 'cd14825', NULL, NULL, 'TRAPPC2_sedlin', NULL, 'TRAPPC2_sedlin', NULL, NULL, NULL, 2),
(5572, NULL, 'cd17948', NULL, NULL, 'DEADc_DDX28', NULL, 'DEADc_DDX28', NULL, NULL, NULL, 2),
(5573, NULL, 'cd00912', NULL, NULL, 'ML', NULL, 'ML', NULL, NULL, NULL, 2),
(5574, NULL, 'cd11479', NULL, NULL, 'SLC5sbd_u3', NULL, 'SLC5sbd_u3', NULL, NULL, NULL, 2),
(5575, NULL, 'cd01421', NULL, NULL, 'IMPCH', NULL, 'IMPCH', NULL, NULL, NULL, 2),
(5576, NULL, 'cd02758', NULL, NULL, 'MopB_Tetrathionate-Ra', NULL, 'MopB_Tetrathionate-Ra', NULL, NULL, 30555, 2),
(5577, NULL, 'cd13690', NULL, NULL, 'PBP2_GluB', NULL, 'PBP2_GluB', NULL, NULL, NULL, 2),
(5578, NULL, 'cd17539', NULL, NULL, 'psREC-like_D2_PleD', NULL, 'psREC-like_D2_PleD', NULL, NULL, NULL, 2),
(5579, NULL, 'cd03238', NULL, NULL, 'ABC_UvrA', NULL, 'ABC_UvrA', NULL, NULL, NULL, 2),
(5580, NULL, 'cd09347', NULL, NULL, 'LIM4_FHL', NULL, 'LIM4_FHL', NULL, NULL, NULL, 2),
(5581, NULL, 'cd14785', NULL, NULL, 'V-ATPase_C', NULL, 'V-ATPase_C', NULL, NULL, 1904, 2),
(5582, NULL, 'cd12837', NULL, NULL, 'EcCorA-like_u1', NULL, 'EcCorA-like_u1', NULL, NULL, NULL, 2),
(5583, NULL, 'cd11934', NULL, NULL, 'SH3_Lasp1_C', NULL, 'SH3_Lasp1_C', NULL, NULL, 33988, 2),
(5584, NULL, 'cd15128', NULL, NULL, '7tmA_ET_R', NULL, '7tmA_ET_R', NULL, NULL, NULL, 2),
(5585, NULL, 'cd13259', NULL, NULL, 'PH5_ARAP', NULL, 'PH5_ARAP', NULL, NULL, NULL, 2),
(5586, NULL, 'cd00869', NULL, NULL, 'PI3Ka_II', NULL, 'PI3Ka_II', NULL, NULL, NULL, 2),
(5587, NULL, 'cd18713', NULL, NULL, 'PIN_VapC-like', NULL, 'PIN_VapC-like', NULL, NULL, NULL, 2),
(5588, NULL, 'cd15944', NULL, NULL, '7tmA_OR5AR1-like', NULL, '7tmA_OR5AR1-like', NULL, NULL, NULL, 2),
(5589, NULL, 'cd12024', NULL, NULL, 'SH3_NoxO1_2', NULL, 'SH3_NoxO1_2', NULL, NULL, 30417, 2),
(5590, NULL, 'cd04444', NULL, NULL, 'DEP_PLEK2', NULL, 'DEP_PLEK2', NULL, NULL, 27561, 2),
(5591, NULL, 'cd16804', NULL, NULL, 'RING-H2_RNF149', NULL, 'RING-H2_RNF149', NULL, NULL, 34369, 2),
(5592, NULL, 'cd09122', NULL, NULL, 'PLDc_Tdp1_1', NULL, 'PLDc_Tdp1_1', NULL, NULL, NULL, 2),
(5593, NULL, 'cd08952', NULL, NULL, 'KR_1_SDR_x', NULL, 'KR_1_SDR_x', NULL, NULL, NULL, 2),
(5594, NULL, 'cd07179', NULL, NULL, '2DBD_NR_DBD2', NULL, '2DBD_NR_DBD2', NULL, NULL, NULL, 2),
(5595, NULL, 'cd17537', NULL, NULL, 'REC_FixJ', NULL, 'REC_FixJ', NULL, NULL, NULL, 2),
(5596, NULL, 'cd11245', NULL, NULL, 'Sema_plexin_B', NULL, 'Sema_plexin_B', NULL, NULL, NULL, 2),
(5597, NULL, 'cd01994', NULL, NULL, 'Alpha_ANH_like_IV', NULL, 'Alpha_ANH_like_IV', NULL, NULL, 4123, 2);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(5598, NULL, 'cd01416', NULL, NULL, 'SAICAR_synt_Ade5', NULL, 'SAICAR_synt_Ade5', NULL, NULL, NULL, 2),
(5599, NULL, 'cd11582', NULL, NULL, 'Axin_TNKS_binding', NULL, 'Axin_TNKS_binding', NULL, NULL, 22787, 2),
(5600, NULL, 'cd18605', NULL, NULL, 'ABC_6TM_MRP7_D2_like', NULL, 'ABC_6TM_MRP7_D2_like', NULL, NULL, NULL, 2),
(5601, NULL, 'cd04443', NULL, NULL, 'DEP_GPR155', NULL, 'DEP_GPR155', NULL, NULL, 27668, 2),
(5602, NULL, 'cd10447', NULL, NULL, 'GIY-YIG_unchar_2', NULL, 'GIY-YIG_unchar_2', NULL, NULL, NULL, 2),
(5603, NULL, 'cd09874', NULL, NULL, 'PIN_MT3492-like', NULL, 'PIN_MT3492-like', NULL, NULL, NULL, 2),
(5604, NULL, 'cd08864', NULL, NULL, 'SRPBCC_DUF3074', NULL, 'SRPBCC_DUF3074', NULL, NULL, NULL, 2),
(5605, NULL, 'cd05525', NULL, NULL, 'Bromo_ASH1', NULL, 'Bromo_ASH1', NULL, NULL, 34833, 2),
(5606, NULL, 'cd18671', NULL, NULL, 'PIN_PRORP-Zc3h12a-like', NULL, 'PIN_PRORP-Zc3h12a-like', NULL, NULL, NULL, 2),
(5607, NULL, 'cd18074', NULL, NULL, 'DEXHc_RLR-2', NULL, 'DEXHc_RLR-2', NULL, NULL, NULL, 2),
(5608, NULL, 'cd18476', NULL, NULL, 'BACK_KLHL38', NULL, 'BACK_KLHL38', NULL, NULL, NULL, 2),
(5609, NULL, 'cd01716', NULL, NULL, 'Hfq', NULL, 'Hfq', NULL, NULL, 831, 2),
(5610, NULL, 'cd04221', NULL, NULL, 'MauL', NULL, 'MauL', NULL, NULL, 19633, 2),
(5611, NULL, 'cd14441', NULL, NULL, 'AlgX_N', NULL, 'AlgX_N', NULL, NULL, 15070, 2),
(5612, NULL, 'cd09203', NULL, NULL, 'PLDc_N_DEXD_b1', NULL, 'PLDc_N_DEXD_b1', NULL, NULL, NULL, 2),
(5613, NULL, 'cd04508', NULL, NULL, 'TUDOR', NULL, 'TUDOR', NULL, NULL, 7274, 2),
(5614, NULL, 'cd15222', NULL, NULL, '7tmA_OR51-like', NULL, '7tmA_OR51-like', NULL, NULL, NULL, 2),
(5615, NULL, 'cd16698', NULL, NULL, 'RING_CH-C4HC3_MARCH1_like', NULL, 'RING_CH-C4HC3_MARCH1_like', NULL, NULL, NULL, 2),
(5616, NULL, 'cd15169', NULL, NULL, '7tmA_FFAR1', NULL, '7tmA_FFAR1', NULL, NULL, NULL, 2),
(5617, NULL, 'cd01789', NULL, NULL, 'Ubl_TBCB', NULL, 'Ubl_TBCB', NULL, NULL, 36934, 2),
(5618, NULL, 'cd19082', NULL, NULL, 'AKR_AKR10A1_2', NULL, 'AKR_AKR10A1_2', NULL, NULL, NULL, 2),
(5619, NULL, 'cd16207', NULL, NULL, 'EFh_ScPlc1p_like', NULL, 'EFh_ScPlc1p_like', NULL, NULL, NULL, 2),
(5620, NULL, 'cd06140', NULL, NULL, 'DNA_polA_I_Bacillus_like_exo', NULL, 'DNA_polA_I_Bacillus_like_exo', NULL, NULL, NULL, 2),
(5621, NULL, 'cd04251', NULL, NULL, 'AAK_NAGK-UC', NULL, 'AAK_NAGK-UC', NULL, NULL, NULL, 2),
(5622, NULL, 'cd11681', NULL, NULL, 'HDAC_classIIa', NULL, 'HDAC_classIIa', NULL, NULL, NULL, 2),
(5623, NULL, 'cd10804', NULL, NULL, 'YdjC_HpnK_like', NULL, 'YdjC_HpnK_like', NULL, NULL, NULL, 2),
(5624, NULL, 'cd16930', NULL, NULL, 'HATPase_TopII-like', NULL, 'HATPase_TopII-like', NULL, NULL, NULL, 2),
(5625, NULL, 'cd15576', NULL, NULL, 'PHD_JMJD2B', NULL, 'PHD_JMJD2B', NULL, NULL, NULL, 2),
(5626, NULL, 'cd04926', NULL, NULL, 'ACT_ACR_4', NULL, 'ACT_ACR_4', NULL, NULL, NULL, 2),
(5627, NULL, 'cd03388', NULL, NULL, 'PAP2_SPPase1', NULL, 'PAP2_SPPase1', NULL, NULL, NULL, 2),
(5628, NULL, 'cd12961', NULL, NULL, 'CBM58_SusG', NULL, 'CBM58_SusG', NULL, NULL, NULL, 2),
(5629, NULL, 'cd19157', NULL, NULL, 'AKR_AKR5G1-3', NULL, 'AKR_AKR5G1-3', NULL, NULL, 34768, 2),
(5630, NULL, 'cd11762', NULL, NULL, 'SH3_FCHSD_2', NULL, 'SH3_FCHSD_2', NULL, NULL, NULL, 2),
(5631, NULL, 'cd06268', NULL, NULL, 'PBP1_ABC_transporter_LIVBP-like', NULL, 'PBP1_ABC_transporter_LIVBP-like', NULL, NULL, NULL, 2),
(5632, NULL, 'cd08310', NULL, NULL, 'Death_NFkB-like', NULL, 'Death_NFkB-like', NULL, NULL, NULL, 2),
(5633, NULL, 'cd02796', NULL, NULL, 'tRNA_bind_bactPheRS', NULL, 'tRNA_bind_bactPheRS', NULL, NULL, 32682, 2),
(5634, NULL, 'cd04282', NULL, NULL, 'ZnMc_meprin', NULL, 'ZnMc_meprin', NULL, NULL, 26190, 2),
(5635, NULL, 'cd06354', NULL, NULL, 'PBP1_PrnA-like', NULL, 'PBP1_PrnA-like', NULL, NULL, NULL, 2),
(5636, NULL, 'cd09256', NULL, NULL, 'AP_MuD_MHD', NULL, 'AP_MuD_MHD', NULL, NULL, NULL, 2),
(5637, NULL, 'cd00142', NULL, NULL, 'PI3Kc_like', NULL, 'PI3Kc_like', NULL, NULL, NULL, 2),
(5638, NULL, 'cd07283', NULL, NULL, 'PX_SNX30', NULL, 'PX_SNX30', NULL, NULL, NULL, 2),
(5639, NULL, 'cd17382', NULL, NULL, 'MFS_SLC17A6_7_8_VGluT', NULL, 'MFS_SLC17A6_7_8_VGluT', NULL, NULL, NULL, 2);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(5640, NULL, 'cd01456', NULL, NULL, 'vWA_ywmD_type', NULL, 'vWA_ywmD_type', NULL, NULL, NULL, 2),
(5641, NULL, 'cd05091', NULL, NULL, 'PTKc_Ror2', NULL, 'PTKc_Ror2', NULL, NULL, NULL, 2),
(5642, NULL, 'cd08735', NULL, NULL, 'RGS_AKAP2_1', NULL, 'RGS_AKAP2_1', NULL, NULL, NULL, 2),
(5643, NULL, 'cd05513', NULL, NULL, 'Bromo_brd7_like', NULL, 'Bromo_brd7_like', NULL, NULL, NULL, 2),
(5644, NULL, 'cd00157', NULL, NULL, 'Rho', NULL, 'Rho', NULL, NULL, NULL, 2),
(5645, NULL, 'cd05343', NULL, NULL, 'Mgc4172-like_SDR_c', NULL, 'Mgc4172-like_SDR_c', NULL, NULL, NULL, 2),
(5646, NULL, 'cd13597', NULL, NULL, 'PBP2_lipoprotein_Tp32', NULL, 'PBP2_lipoprotein_Tp32', NULL, NULL, NULL, 2),
(5647, NULL, 'cd19103', NULL, NULL, 'AKR_unchar', NULL, 'AKR_unchar', NULL, NULL, NULL, 2),
(5648, NULL, 'cd21596', NULL, NULL, 'batCoV-HKU9-like_RdRp', NULL, 'batCoV-HKU9-like_RdRp', NULL, NULL, 33663, 2),
(5649, NULL, 'cd14621', NULL, NULL, 'R-PTPc-A-1', NULL, 'R-PTPc-A-1', NULL, NULL, NULL, 2),
(5650, NULL, 'cd10801', NULL, NULL, 'LamB_YcsF_like_1', NULL, 'LamB_YcsF_like_1', NULL, NULL, NULL, 2),
(5651, NULL, 'cd07081', NULL, NULL, 'ALDH_F20_ACDH_EutE-like', NULL, 'ALDH_F20_ACDH_EutE-like', NULL, NULL, NULL, 2),
(5652, NULL, 'cd19585', NULL, NULL, 'serpin_poxvirus', NULL, 'serpin_poxvirus', NULL, NULL, NULL, 2),
(5653, NULL, 'cd05870', NULL, NULL, 'Ig_NCAM-2', NULL, 'Ig_NCAM-2', NULL, NULL, NULL, 2),
(5654, NULL, 'cd07836', NULL, NULL, 'STKc_Pho85', NULL, 'STKc_Pho85', NULL, NULL, NULL, 2),
(5655, NULL, 'cd08502', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_16', NULL, 'PBP2_NikA_DppA_OppA_like_16', NULL, NULL, NULL, 2),
(5656, NULL, 'cd15146', NULL, NULL, '7tmA_PGE2_EP3', NULL, '7tmA_PGE2_EP3', NULL, NULL, NULL, 2),
(5657, NULL, 'cd06639', NULL, NULL, 'STKc_myosinIIIB_N', NULL, 'STKc_myosinIIIB_N', NULL, NULL, NULL, 2),
(5658, NULL, 'cd07322', NULL, NULL, 'PriL_PriS_Eukaryotic', NULL, 'PriL_PriS_Eukaryotic', NULL, NULL, 17802, 2),
(5659, NULL, 'cd18220', NULL, NULL, 'BTB_POZ_ZBTB34', NULL, 'BTB_POZ_ZBTB34', NULL, NULL, NULL, 2),
(5660, NULL, 'cd00141', NULL, NULL, 'NT_POLXc', NULL, 'NT_POLXc', NULL, NULL, 1066, 2),
(5661, NULL, 'cd01713', NULL, NULL, 'PAPS_reductase', NULL, 'PAPS_reductase', NULL, NULL, 600, 2),
(5662, NULL, 'cd12550', NULL, NULL, 'RRM_II_PABPN1', NULL, 'RRM_II_PABPN1', NULL, NULL, NULL, 2),
(5663, NULL, 'cd14688', NULL, NULL, 'bZIP_YAP', NULL, 'bZIP_YAP', NULL, NULL, NULL, 2),
(5664, NULL, 'cd17342', NULL, NULL, 'MFS_SLC37A3', NULL, 'MFS_SLC37A3', NULL, NULL, NULL, 2),
(5665, NULL, 'cd04760', NULL, NULL, 'BAH_Dnmt1_I', NULL, 'BAH_Dnmt1_I', NULL, NULL, NULL, 2),
(5666, NULL, 'cd07243', NULL, NULL, '2_3_CTD_C', NULL, '2_3_CTD_C', NULL, NULL, NULL, 2),
(5667, NULL, 'cd16550', NULL, NULL, 'RING-HC_RNF168', NULL, 'RING-HC_RNF168', NULL, NULL, NULL, 2),
(5668, NULL, 'cd10024', NULL, NULL, '14-3-3_gamma', NULL, '14-3-3_gamma', NULL, NULL, NULL, 2),
(5669, NULL, 'cd11603', NULL, NULL, 'ThermoDBP', NULL, 'ThermoDBP', NULL, NULL, 31606, 2),
(5670, NULL, 'cd13251', NULL, NULL, 'PH_ASAP', NULL, 'PH_ASAP', NULL, NULL, 30513, 2),
(5671, NULL, 'cd04882', NULL, NULL, 'ACT_Bt0572_2', NULL, 'ACT_Bt0572_2', NULL, NULL, NULL, 2),
(5672, NULL, 'cd01088', NULL, NULL, 'MetAP2', NULL, 'MetAP2', NULL, NULL, 6844, 2),
(5673, NULL, 'cd07053', NULL, NULL, 'BMC_PduT_repeat1', NULL, 'BMC_PduT_repeat1', NULL, NULL, NULL, 2),
(5674, NULL, 'cd06161', NULL, NULL, 'S2P-M50_SpoIVFB', NULL, 'S2P-M50_SpoIVFB', NULL, NULL, NULL, 2),
(5675, NULL, 'cd13213', NULL, NULL, 'PH-GRAM_MTMR14', NULL, 'PH-GRAM_MTMR14', NULL, NULL, 28904, 2),
(5676, NULL, 'cd15076', NULL, NULL, '7tmA_SWS1_opsin', NULL, '7tmA_SWS1_opsin', NULL, NULL, NULL, 2),
(5677, NULL, 'cd04874', NULL, NULL, 'ACT_Af1403', NULL, 'ACT_Af1403', NULL, NULL, NULL, 2),
(5678, NULL, 'cd07503', NULL, NULL, 'HAD_HisB-N', NULL, 'HAD_HisB-N', NULL, NULL, NULL, 2),
(5679, NULL, 'cd11823', NULL, NULL, 'SH3_Nostrin', NULL, 'SH3_Nostrin', NULL, NULL, 27297, 2),
(5680, NULL, 'cd14076', NULL, NULL, 'STKc_Kin4', NULL, 'STKc_Kin4', NULL, NULL, 7041, 2),
(5681, NULL, 'cd08391', NULL, NULL, 'C2A_C2C_Synaptotagmin_like', NULL, 'C2A_C2C_Synaptotagmin_like', NULL, NULL, 32774, 2);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(5682, NULL, 'cd11259', NULL, NULL, 'Sema_4D', NULL, 'Sema_4D', NULL, NULL, NULL, 2),
(5683, NULL, 'cd08774', NULL, NULL, '14-3-3', NULL, '14-3-3', NULL, NULL, NULL, 2),
(5684, NULL, 'cd06894', NULL, NULL, 'PX_SNX3_like', NULL, 'PX_SNX3_like', NULL, NULL, NULL, 2),
(5685, NULL, 'cd16111', NULL, NULL, 'DCX_DCLK3', NULL, 'DCX_DCLK3', NULL, NULL, NULL, 2),
(5686, NULL, 'cd12544', NULL, NULL, 'RRM_NMI', NULL, 'RRM_NMI', NULL, NULL, NULL, 2),
(5687, NULL, 'cd12930', NULL, NULL, 'GAT_SF', NULL, 'GAT_SF', NULL, NULL, NULL, 2),
(5688, NULL, 'cd17410', NULL, NULL, 'MFS_CynX_like', NULL, 'MFS_CynX_like', NULL, NULL, NULL, 2),
(5689, NULL, 'cd15799', NULL, NULL, 'PMEI-like_4', NULL, 'PMEI-like_4', NULL, NULL, NULL, 2),
(5690, NULL, 'cd00735', NULL, NULL, 'T4-like_lys', NULL, 'T4-like_lys', NULL, NULL, NULL, 2),
(5691, NULL, 'cd15741', NULL, NULL, 'FYVE_FGD1_2_4', NULL, 'FYVE_FGD1_2_4', NULL, NULL, NULL, 2),
(5692, NULL, 'cd17464', NULL, NULL, 'MFS_MCT10', NULL, 'MFS_MCT10', NULL, NULL, NULL, 2),
(5693, NULL, 'cd08685', NULL, NULL, 'C2_RGS-like', NULL, 'C2_RGS-like', NULL, NULL, NULL, 2),
(5694, NULL, 'cd17226', NULL, NULL, 'RA_ARAP1', NULL, 'RA_ARAP1', NULL, NULL, NULL, 2),
(5695, NULL, 'cd16622', NULL, NULL, 'vRING-HC-C4C4_RBR_RNF217', NULL, 'vRING-HC-C4C4_RBR_RNF217', NULL, NULL, NULL, 2),
(5696, NULL, 'cd11249', NULL, NULL, 'Sema_3A', NULL, 'Sema_3A', NULL, NULL, 35480, 2),
(5697, NULL, 'cd09326', NULL, NULL, 'LIM_CRP_like', NULL, 'LIM_CRP_like', NULL, NULL, NULL, 2),
(5698, NULL, 'cd18041', NULL, NULL, 'DEXXQc_DNA2', NULL, 'DEXXQc_DNA2', NULL, NULL, NULL, 2),
(5699, NULL, 'cd17726', NULL, NULL, 'BRCT_PARP4_like', NULL, 'BRCT_PARP4_like', NULL, NULL, NULL, 2),
(5700, NULL, 'cd00871', NULL, NULL, 'PI4Ka', NULL, 'PI4Ka', NULL, NULL, NULL, 2),
(5701, NULL, 'cd03173', NULL, NULL, 'DUF619-like', NULL, 'DUF619-like', NULL, NULL, NULL, 2),
(5702, NULL, 'cd09470', NULL, NULL, 'LIM1_Lhx9', NULL, 'LIM1_Lhx9', NULL, NULL, NULL, 2),
(5703, NULL, 'cd15139', NULL, NULL, '7tmA_PGE2_EP2', NULL, '7tmA_PGE2_EP2', NULL, NULL, NULL, 2),
(5704, NULL, 'cd19469', NULL, NULL, 'FABP8', NULL, 'FABP8', NULL, NULL, NULL, 2),
(5705, NULL, 'cd15289', NULL, NULL, '7tmC_TAS1R1', NULL, '7tmC_TAS1R1', NULL, NULL, NULL, 2),
(5706, NULL, 'cd05708', NULL, NULL, 'S1_Rrp5_repeat_sc12', NULL, 'S1_Rrp5_repeat_sc12', NULL, NULL, NULL, 2),
(5707, NULL, 'cd17061', NULL, NULL, 'Ubl_IQUB', NULL, 'Ubl_IQUB', NULL, NULL, NULL, 2),
(5708, NULL, 'cd08944', NULL, NULL, 'SDR_c12', NULL, 'SDR_c12', NULL, NULL, NULL, 2),
(5709, NULL, 'cd14400', NULL, NULL, 'UBA_Gts1p_like', NULL, 'UBA_Gts1p_like', NULL, NULL, NULL, 2),
(5710, NULL, 'cd07559', NULL, NULL, 'ALDH_ACDHII_AcoD-like', NULL, 'ALDH_ACDHII_AcoD-like', NULL, NULL, NULL, 2),
(5711, NULL, 'cd18194', NULL, NULL, 'BTB_POZ_ZBTB3-like', NULL, 'BTB_POZ_ZBTB3-like', NULL, NULL, NULL, 2),
(5712, NULL, 'cd05830', NULL, NULL, 'Sortase_E', NULL, 'Sortase_E', NULL, NULL, 30617, 2),
(5713, NULL, 'cd16650', NULL, NULL, 'SP-RING_PIAS_like', NULL, 'SP-RING_PIAS_like', NULL, NULL, NULL, 2),
(5714, NULL, 'cd19784', NULL, NULL, 'Bbox2_TRIM44', NULL, 'Bbox2_TRIM44', NULL, NULL, NULL, 2),
(5715, NULL, 'cd03047', NULL, NULL, 'GST_N_2', NULL, 'GST_N_2', NULL, NULL, NULL, 2),
(5716, NULL, 'cd16629', NULL, NULL, 'RING-HC_RBR_RNF19', NULL, 'RING-HC_RBR_RNF19', NULL, NULL, NULL, 2),
(5717, NULL, 'cd01541', NULL, NULL, 'PBP1_AraR', NULL, 'PBP1_AraR', NULL, NULL, 31419, 2),
(5718, NULL, 'cd17503', NULL, NULL, 'MFS_LmrB_MDR_like', NULL, 'MFS_LmrB_MDR_like', NULL, NULL, NULL, 2),
(5719, NULL, 'cd05239', NULL, NULL, 'GDP_FS_SDR_e', NULL, 'GDP_FS_SDR_e', NULL, NULL, 25024, 2),
(5720, NULL, 'cd14795', NULL, NULL, 'RNLA_N_2', NULL, 'RNLA_N_2', NULL, NULL, NULL, 2),
(5721, NULL, 'cd17118', NULL, NULL, 'Ubl_HERP1', NULL, 'Ubl_HERP1', NULL, NULL, NULL, 2),
(5722, NULL, 'cd05534', NULL, NULL, 'POLBc_zeta', NULL, 'POLBc_zeta', NULL, NULL, NULL, 2),
(5723, NULL, 'cd09713', NULL, NULL, 'Cas8c_I-C', NULL, 'Cas8c_I-C', NULL, NULL, 15164, 2),
(5724, NULL, 'cd11629', NULL, NULL, 'HR1_FBP17', NULL, 'HR1_FBP17', NULL, NULL, NULL, 2),
(5725, NULL, 'cd14472', NULL, NULL, 'mltA_B_like', NULL, 'mltA_B_like', NULL, NULL, NULL, 2); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(5726, NULL, 'cd16994', NULL, NULL, 'ENTH_Ent4', NULL, 'ENTH_Ent4', NULL, NULL, NULL, 2),
(5727, NULL, 'cd00243', NULL, NULL, 'Lysin-Sp18', NULL, 'Lysin-Sp18', NULL, NULL, 6543, 2),
(5728, NULL, 'cd03583', NULL, NULL, 'NTR_complement_C3', NULL, 'NTR_complement_C3', NULL, NULL, 33047, 2),
(5729, NULL, 'cd07030', NULL, NULL, 'RNAP_D', NULL, 'RNAP_D', NULL, NULL, NULL, 2),
(5730, NULL, 'cd13617', NULL, NULL, 'PBP2_transferrin_C', NULL, 'PBP2_transferrin_C', NULL, NULL, NULL, 2),
(5731, NULL, 'cd01377', NULL, NULL, 'MYSc_class_II', NULL, 'MYSc_class_II', NULL, NULL, NULL, 2),
(5732, NULL, 'cd06287', NULL, NULL, 'PBP1_LacI-like', NULL, 'PBP1_LacI-like', NULL, NULL, NULL, 2),
(5733, NULL, 'cd04474', NULL, NULL, 'RPA1_DBD_A', NULL, 'RPA1_DBD_A', NULL, NULL, NULL, 2),
(5734, NULL, 'cd19163', NULL, NULL, 'AKR_galDH', NULL, 'AKR_galDH', NULL, NULL, 34486, 2),
(5735, NULL, 'cd12565', NULL, NULL, 'RRM1_MRD1', NULL, 'RRM1_MRD1', NULL, NULL, NULL, 2),
(5736, NULL, 'cd06649', NULL, NULL, 'PKc_MEK2', NULL, 'PKc_MEK2', NULL, NULL, NULL, 2),
(5737, NULL, 'cd01419', NULL, NULL, 'MoaC_A', NULL, 'MoaC_A', NULL, NULL, 15477, 2),
(5738, NULL, 'cd19387', NULL, NULL, 'TGF_beta_univin', NULL, 'TGF_beta_univin', NULL, NULL, NULL, 2),
(5739, NULL, 'cd04223', NULL, NULL, 'N2OR_C', NULL, 'N2OR_C', NULL, NULL, 7465, 2),
(5740, NULL, 'cd07016', NULL, NULL, 'S14_ClpP_1', NULL, 'S14_ClpP_1', NULL, NULL, NULL, 2),
(5741, NULL, 'cd11710', NULL, NULL, 'GINS_A_psf1', NULL, 'GINS_A_psf1', NULL, NULL, 6456, 2),
(5742, NULL, 'cd07403', NULL, NULL, 'MPP_TTHA0053', NULL, 'MPP_TTHA0053', NULL, NULL, NULL, 2),
(5743, NULL, 'cd17136', NULL, NULL, 'RBD1_RGS12', NULL, 'RBD1_RGS12', NULL, NULL, NULL, 2),
(5744, NULL, 'cd10583', NULL, NULL, 'TNFRSF21', NULL, 'TNFRSF21', NULL, NULL, 12013, 2),
(5745, NULL, 'cd10967', NULL, NULL, 'CE4_GLA_like_6s', NULL, 'CE4_GLA_like_6s', NULL, NULL, NULL, 2),
(5746, NULL, 'cd00054', NULL, NULL, 'EGF_CA', NULL, 'EGF_CA', NULL, NULL, NULL, 2),
(5747, NULL, 'cd00789', NULL, NULL, 'KU_like', NULL, 'KU_like', NULL, NULL, 9701, 2),
(5748, NULL, 'cd14815', NULL, NULL, 'BA_2398_like', NULL, 'BA_2398_like', NULL, NULL, 30167, 2),
(5749, NULL, 'cd14305', NULL, NULL, 'UBA_UBAC2', NULL, 'UBA_UBAC2', NULL, NULL, 30237, 2),
(5750, NULL, 'cd03210', NULL, NULL, 'GST_C_Pi', NULL, 'GST_C_Pi', NULL, NULL, NULL, 2),
(5751, NULL, 'cd19214', NULL, NULL, 'PR-SET_PRDM3', NULL, 'PR-SET_PRDM3', NULL, NULL, 34790, 2),
(5752, NULL, 'cd13929', NULL, NULL, 'PT-DMATS_CymD', NULL, 'PT-DMATS_CymD', NULL, NULL, 19153, 2),
(5753, NULL, 'cd09127', NULL, NULL, 'PLDc_unchar1_1', NULL, 'PLDc_unchar1_1', NULL, NULL, NULL, 2),
(5754, NULL, 'cd11974', NULL, NULL, 'SH3_ASEF2', NULL, 'SH3_ASEF2', NULL, NULL, NULL, 2),
(5755, NULL, 'cd15106', NULL, NULL, '7tmA_MrgprX-like', NULL, '7tmA_MrgprX-like', NULL, NULL, NULL, 2),
(5756, NULL, 'cd07251', NULL, NULL, 'VOC_like', NULL, 'VOC_like', NULL, NULL, NULL, 2),
(5757, NULL, 'cd17910', NULL, NULL, 'CheC_ClassII', NULL, 'CheC_ClassII', NULL, NULL, NULL, 2),
(5758, NULL, 'cd19605', NULL, NULL, 'serpin_protozoa', NULL, 'serpin_protozoa', NULL, NULL, NULL, 2),
(5759, NULL, 'cd16647', NULL, NULL, 'mRING-HC-C3HC5_NEU1', NULL, 'mRING-HC-C3HC5_NEU1', NULL, NULL, NULL, 2),
(5760, NULL, 'cd18392', NULL, NULL, 'BTB_POZ_KCTD3', NULL, 'BTB_POZ_KCTD3', NULL, NULL, NULL, 2),
(5761, NULL, 'cd01179', NULL, NULL, 'IPT_plexin_repeat2', NULL, 'IPT_plexin_repeat2', NULL, NULL, NULL, 2),
(5762, NULL, 'cd04247', NULL, NULL, 'AAK_AK-Hom3', NULL, 'AAK_AK-Hom3', NULL, NULL, 30271, 2),
(5763, NULL, 'cd01864', NULL, NULL, 'Rab19', NULL, 'Rab19', NULL, NULL, NULL, 2),
(5764, NULL, 'cd03240', NULL, NULL, 'ABC_Rad50', NULL, 'ABC_Rad50', NULL, NULL, 36893, 2),
(5765, NULL, 'cd00617', NULL, NULL, 'Tnase_like', NULL, 'Tnase_like', NULL, NULL, NULL, 2),
(5766, NULL, 'cd15883', NULL, NULL, 'SNARE_syntaxin4', NULL, 'SNARE_syntaxin4', NULL, NULL, NULL, 2),
(5767, NULL, 'cd11708', NULL, NULL, 'DHR2_DOCK5', NULL, 'DHR2_DOCK5', NULL, NULL, NULL, 2),
(5768, NULL, 'cd15563', NULL, NULL, 'PHD3_PHF14', NULL, 'PHD3_PHF14', NULL, NULL, NULL, 2);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(5769, NULL, 'cd19829', NULL, NULL, 'Bbox2_TIF1b_C-VI', NULL, 'Bbox2_TIF1b_C-VI', NULL, NULL, NULL, 2),
(5770, NULL, 'cd16600', NULL, NULL, 'RING-HC_TRIM38_C-IV', NULL, 'RING-HC_TRIM38_C-IV', NULL, NULL, NULL, 2),
(5771, NULL, 'cd18230', NULL, NULL, 'BTB_POZ_ZBTB46', NULL, 'BTB_POZ_ZBTB46', NULL, NULL, NULL, 2),
(5772, NULL, 'cd01726', NULL, NULL, 'LSm6', NULL, 'LSm6', NULL, NULL, NULL, 2),
(5773, NULL, 'cd04980', NULL, NULL, 'IgV_L_kappa', NULL, 'IgV_L_kappa', NULL, NULL, NULL, 2),
(5774, NULL, 'cd12479', NULL, NULL, 'RRM2_SNF', NULL, 'RRM2_SNF', NULL, NULL, NULL, 2),
(5775, NULL, 'cd10313', NULL, NULL, 'Deadenylase_CCR4a', NULL, 'Deadenylase_CCR4a', NULL, NULL, 27094, 2),
(5776, NULL, 'cd00374', NULL, NULL, 'RNase_T2', NULL, 'RNase_T2', NULL, NULL, NULL, 2),
(5777, NULL, 'cd05069', NULL, NULL, 'PTKc_Yes', NULL, 'PTKc_Yes', NULL, NULL, NULL, 2),
(5778, NULL, 'cd02777', NULL, NULL, 'MopB_CT_DMSOR-like', NULL, 'MopB_CT_DMSOR-like', NULL, NULL, NULL, 2),
(5779, NULL, 'cd07008', NULL, NULL, 'cupin_yp_001338853-like', NULL, 'cupin_yp_001338853-like', NULL, NULL, NULL, 2),
(5780, NULL, 'cd09357', NULL, NULL, 'LIM3_Zyxin_like', NULL, 'LIM3_Zyxin_like', NULL, NULL, NULL, 2),
(5781, NULL, 'cd21467', NULL, NULL, 'Ubl1_cv_Nsp3_N-like', NULL, 'Ubl1_cv_Nsp3_N-like', NULL, NULL, 35025, 2),
(5782, NULL, 'cd00090', NULL, NULL, 'HTH_ARSR', NULL, 'HTH_ARSR', NULL, NULL, 12693, 2),
(5783, NULL, 'cd02025', NULL, NULL, 'PanK', NULL, 'PanK', NULL, NULL, 736, 2),
(5784, NULL, 'cd07444', NULL, NULL, 'CRD_SFRP5', NULL, 'CRD_SFRP5', NULL, NULL, 30243, 2),
(5785, NULL, 'cd02755', NULL, NULL, 'MopB_Thiosulfate-R-like', NULL, 'MopB_Thiosulfate-R-like', NULL, NULL, NULL, 2),
(5786, NULL, 'cd08199', NULL, NULL, 'EEVS', NULL, 'EEVS', NULL, NULL, 31468, 2),
(5787, NULL, 'cd00523', NULL, NULL, 'archeal_HJR', NULL, 'archeal_HJR', NULL, NULL, 7574, 2),
(5788, NULL, 'cd02437', NULL, NULL, 'CCC1_like_1', NULL, 'CCC1_like_1', NULL, NULL, NULL, 2),
(5789, NULL, 'cd14806', NULL, NULL, 'RAP_D1', NULL, 'RAP_D1', NULL, NULL, 6488, 2),
(5790, NULL, 'cd03444', NULL, NULL, 'Thioesterase_II_repeat1', NULL, 'Thioesterase_II_repeat1', NULL, NULL, NULL, 2),
(5791, NULL, 'cd01083', NULL, NULL, 'GAG_Lyase', NULL, 'GAG_Lyase', NULL, NULL, NULL, 2),
(5792, NULL, 'cd02641', NULL, NULL, 'R3H_Smubp-2_like', NULL, 'R3H_Smubp-2_like', NULL, NULL, 8548, 2),
(5793, NULL, 'cd05273', NULL, NULL, 'GME-like_SDR_e', NULL, 'GME-like_SDR_e', NULL, NULL, 30231, 2),
(5794, NULL, 'cd08796', NULL, NULL, 'Death_IRAK-M', NULL, 'Death_IRAK-M', NULL, NULL, 34712, 2),
(5795, NULL, 'cd10806', NULL, NULL, 'YdjC_like_2', NULL, 'YdjC_like_2', NULL, NULL, NULL, 2),
(5796, NULL, 'cd02109', NULL, NULL, 'arch_bact_SO_family_Moco', NULL, 'arch_bact_SO_family_Moco', NULL, NULL, NULL, 2),
(5797, NULL, 'cd13868', NULL, NULL, 'CuRO_2_CotA_like', NULL, 'CuRO_2_CotA_like', NULL, NULL, NULL, 2),
(5798, NULL, 'cd07710', NULL, NULL, 'arylsulfatase_Sdsa1-like_MBL-fold', NULL, 'arylsulfatase_Sdsa1-like_MBL-fold', NULL, NULL, 35993, 2),
(5799, NULL, 'cd10940', NULL, NULL, 'CE4_PuuE_HpPgdA_like_1', NULL, 'CE4_PuuE_HpPgdA_like_1', NULL, NULL, NULL, 2),
(5800, NULL, 'cd17319', NULL, NULL, 'MFS_ExuT_GudP_like', NULL, 'MFS_ExuT_GudP_like', NULL, NULL, NULL, 2),
(5801, NULL, 'cd09341', NULL, NULL, 'LIM2_Testin_like', NULL, 'LIM2_Testin_like', NULL, NULL, NULL, 2),
(5802, NULL, 'cd07562', NULL, NULL, 'Peptidase_S41_TRI', NULL, 'Peptidase_S41_TRI', NULL, NULL, NULL, 2),
(5803, NULL, 'cd01578', NULL, NULL, 'AcnA_Mitochon_Swivel', NULL, 'AcnA_Mitochon_Swivel', NULL, NULL, NULL, 2),
(5804, NULL, 'cd11315', NULL, NULL, 'AmyAc_bac1_AmyA', NULL, 'AmyAc_bac1_AmyA', NULL, NULL, NULL, 2),
(5805, NULL, 'cd17292', NULL, NULL, 'RMtype1_S_LlaA17I_TRD2-CR2_like', NULL, 'RMtype1_S_LlaA17I_TRD2-CR2_like', NULL, NULL, NULL, 2),
(5806, NULL, 'cd17411', NULL, NULL, 'MFS_SLC15A2', NULL, 'MFS_SLC15A2', NULL, NULL, 35491, 2),
(5807, NULL, 'cd16191', NULL, NULL, 'EFh_PEF_CAPN8', NULL, 'EFh_PEF_CAPN8', NULL, NULL, NULL, 2),
(5808, NULL, 'cd13408', NULL, NULL, 'TNFRSF7', NULL, 'TNFRSF7', NULL, NULL, 29312, 2),
(5809, NULL, 'cd18376', NULL, NULL, 'BTB_POZ_FIP2-like', NULL, 'BTB_POZ_FIP2-like', NULL, NULL, NULL, 2);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(5810, NULL, 'cd01118', NULL, NULL, 'ArsB_permease', NULL, 'ArsB_permease', NULL, NULL, 4458, 2),
(5811, NULL, 'cd12696', NULL, NULL, 'RRM3_PTBP2', NULL, 'RRM3_PTBP2', NULL, NULL, 32295, 2),
(5812, NULL, 'cd16700', NULL, NULL, 'RING_CH-C4HC3_MARCH4_like', NULL, 'RING_CH-C4HC3_MARCH4_like', NULL, NULL, NULL, 2),
(5813, NULL, 'cd09603', NULL, NULL, 'M1_APN_like', NULL, 'M1_APN_like', NULL, NULL, NULL, 2),
(5814, NULL, 'cd02077', NULL, NULL, 'P-type_ATPase_Mg', NULL, 'P-type_ATPase_Mg', NULL, NULL, 6676, 2),
(5815, NULL, 'cd14276', NULL, NULL, 'UBA_UBP25_like', NULL, 'UBA_UBP25_like', NULL, NULL, NULL, 2),
(5816, NULL, 'cd21536', NULL, NULL, 'SARS-CoV-2_E', NULL, 'SARS-CoV-2_E', NULL, NULL, 33612, 2),
(5817, NULL, 'cd15543', NULL, NULL, 'PHD_RSF1', NULL, 'PHD_RSF1', NULL, NULL, NULL, 2),
(5818, NULL, 'cd03452', NULL, NULL, 'MaoC_C', NULL, 'MaoC_C', NULL, NULL, NULL, 2),
(5819, NULL, 'cd01532', NULL, NULL, '4RHOD_Repeat_1', NULL, '4RHOD_Repeat_1', NULL, NULL, NULL, 2),
(5820, NULL, 'cd09566', NULL, NULL, 'SAM_liprin-beta1,2_repeat2', NULL, 'SAM_liprin-beta1,2_repeat2', NULL, NULL, 32265, 2),
(5821, NULL, 'cd19935', NULL, NULL, 'REC_OmpR_CusR-like', NULL, 'REC_OmpR_CusR-like', NULL, NULL, NULL, 2),
(5822, NULL, 'cd01893', NULL, NULL, 'Miro1', NULL, 'Miro1', NULL, NULL, NULL, 2),
(5823, NULL, 'cd05512', NULL, NULL, 'Bromo_brd1_like', NULL, 'Bromo_brd1_like', NULL, NULL, NULL, 2),
(5824, NULL, 'cd03281', NULL, NULL, 'ABC_MSH5_euk', NULL, 'ABC_MSH5_euk', NULL, NULL, NULL, 2),
(5825, NULL, 'cd05077', NULL, NULL, 'PTK_Jak1_rpt1', NULL, 'PTK_Jak1_rpt1', NULL, NULL, NULL, 2),
(5826, NULL, 'cd13911', NULL, NULL, 'CuRO_3_MCO_like_5', NULL, 'CuRO_3_MCO_like_5', NULL, NULL, NULL, 2),
(5827, NULL, 'cd08930', NULL, NULL, 'SDR_c8', NULL, 'SDR_c8', NULL, NULL, NULL, 2),
(5828, NULL, 'cd16300', NULL, NULL, 'NDM_FIM-like_MBL-B1', NULL, 'NDM_FIM-like_MBL-B1', NULL, NULL, NULL, 2),
(5829, NULL, 'cd17769', NULL, NULL, 'NP_TgUP-like', NULL, 'NP_TgUP-like', NULL, NULL, NULL, 2),
(5830, NULL, 'cd02203', NULL, NULL, 'PurL_repeat1', NULL, 'PurL_repeat1', NULL, NULL, NULL, 2),
(5831, NULL, 'cd02659', NULL, NULL, 'peptidase_C19C', NULL, 'peptidase_C19C', NULL, NULL, NULL, 2),
(5832, NULL, 'cd20270', NULL, NULL, 'Complex1_LYR_SDHAF3_LYRM10', NULL, 'Complex1_LYR_SDHAF3_LYRM10', NULL, NULL, NULL, 2),
(5833, NULL, 'cd02675', NULL, NULL, 'Ephrin_ectodomain', NULL, 'Ephrin_ectodomain', NULL, NULL, NULL, 2),
(5834, NULL, 'cd09630', NULL, NULL, 'CDH_like_cytochrome', NULL, 'CDH_like_cytochrome', NULL, NULL, 8454, 2),
(5835, NULL, 'cd17654', NULL, NULL, 'A_NRPS_acs4', NULL, 'A_NRPS_acs4', NULL, NULL, NULL, 2),
(5836, NULL, 'cd06941', NULL, NULL, 'NR_LBD_DmE78_like', NULL, 'NR_LBD_DmE78_like', NULL, NULL, NULL, 2),
(5837, NULL, 'cd12963', NULL, NULL, 'X45_BaPul_like', NULL, 'X45_BaPul_like', NULL, NULL, NULL, 2),
(5838, NULL, 'cd12730', NULL, NULL, 'RRM1_GRSF1', NULL, 'RRM1_GRSF1', NULL, NULL, 13035, 2),
(5839, NULL, 'cd04267', NULL, NULL, 'ZnMc_ADAM_like', NULL, 'ZnMc_ADAM_like', NULL, NULL, 32362, 2),
(5840, NULL, 'cd20313', NULL, NULL, 'DSRM_DND1', NULL, 'DSRM_DND1', NULL, NULL, 35365, 2),
(5841, NULL, 'cd08961', NULL, NULL, 'GH64-TLP-SF', NULL, 'GH64-TLP-SF', NULL, NULL, NULL, 2),
(5842, NULL, 'cd19160', NULL, NULL, 'AKR_KCAB3B_AKR6A9-like', NULL, 'AKR_KCAB3B_AKR6A9-like', NULL, NULL, NULL, 2),
(5843, NULL, 'cd10810', NULL, NULL, 'GH38N_AMII_LAM_like', NULL, 'GH38N_AMII_LAM_like', NULL, NULL, NULL, 2),
(5844, NULL, 'cd11344', NULL, NULL, 'AmyAc_GlgE_like', NULL, 'AmyAc_GlgE_like', NULL, NULL, NULL, 2),
(5845, NULL, 'cd09714', NULL, NULL, 'Cas8c''_I-D', NULL, 'Cas8c''_I-D', NULL, NULL, NULL, 2),
(5846, NULL, 'cd01020', NULL, NULL, 'TroA_b', NULL, 'TroA_b', NULL, NULL, NULL, 2),
(5847, NULL, 'cd13204', NULL, NULL, 'FERM_C2_myosin_like', NULL, 'FERM_C2_myosin_like', NULL, NULL, NULL, 2),
(5848, NULL, 'cd17772', NULL, NULL, 'CBS_pair_DHH_polyA_Pol_assoc', NULL, 'CBS_pair_DHH_polyA_Pol_assoc', NULL, NULL, NULL, 2),
(5849, NULL, 'cd06248', NULL, NULL, 'M14_CP_insect', NULL, 'M14_CP_insect', NULL, NULL, NULL, 2),
(5850, NULL, 'cd10158', NULL, NULL, 'CsoR-like_DUF156_1', NULL, 'CsoR-like_DUF156_1', NULL, NULL, NULL, 2);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(5851, NULL, 'cd14821', NULL, NULL, 'BACK_SPOP_like', NULL, 'BACK_SPOP_like', NULL, NULL, NULL, 2),
(5852, NULL, 'cd13269', NULL, NULL, 'PH_alsin', NULL, 'PH_alsin', NULL, NULL, NULL, 2),
(5853, NULL, 'cd11314', NULL, NULL, 'AmyAc_arch_bac_plant_AmyA', NULL, 'AmyAc_arch_bac_plant_AmyA', NULL, NULL, NULL, 2),
(5854, NULL, 'cd04867', NULL, NULL, 'TGS_YchF_OLA1', NULL, 'TGS_YchF_OLA1', NULL, NULL, 11410, 2),
(5855, NULL, 'cd05533', NULL, NULL, 'POLBc_delta', NULL, 'POLBc_delta', NULL, NULL, NULL, 2),
(5856, NULL, 'cd07778', NULL, NULL, 'FGGY_L-RBK_like', NULL, 'FGGY_L-RBK_like', NULL, NULL, 30691, 2),
(5857, NULL, 'cd13276', NULL, NULL, 'PH_AtPH1', NULL, 'PH_AtPH1', NULL, NULL, NULL, 2),
(5858, NULL, 'cd07307', NULL, NULL, 'BAR', NULL, 'BAR', NULL, NULL, NULL, 2),
(5859, NULL, 'cd15787', NULL, NULL, 'YycH_N', NULL, 'YycH_N', NULL, NULL, NULL, 2),
(5860, NULL, 'cd09929', NULL, NULL, 'SH2_BLNK_SLP-76', NULL, 'SH2_BLNK_SLP-76', NULL, NULL, NULL, 2),
(5861, NULL, 'cd12505', NULL, NULL, 'RRM2_GRSF1', NULL, 'RRM2_GRSF1', NULL, NULL, 13147, 2),
(5862, NULL, 'cd02549', NULL, NULL, 'Peptidase_C39A', NULL, 'Peptidase_C39A', NULL, NULL, 33981, 2),
(5863, NULL, 'cd16714', NULL, NULL, 'RING-HC_BIRC4_8', NULL, 'RING-HC_BIRC4_8', NULL, NULL, NULL, 2),
(5864, NULL, 'cd06134', NULL, NULL, 'RNaseT', NULL, 'RNaseT', NULL, NULL, 1039, 2),
(5865, NULL, 'cd19875', NULL, NULL, 'DSRM_EIF2AK2-like', NULL, 'DSRM_EIF2AK2-like', NULL, NULL, NULL, 2),
(5866, NULL, 'cd19179', NULL, NULL, 'SET_RBCMT', NULL, 'SET_RBCMT', NULL, NULL, 35397, 2),
(5867, NULL, 'cd14646', NULL, NULL, 'DSP_DUSP16', NULL, 'DSP_DUSP16', NULL, NULL, NULL, 2),
(5868, NULL, 'cd19349', NULL, NULL, 'Wnt_Wnt7a', NULL, 'Wnt_Wnt7a', NULL, NULL, NULL, 2),
(5869, NULL, 'cd15126', NULL, NULL, '7tmA_ETBR-LP2', NULL, '7tmA_ETBR-LP2', NULL, NULL, NULL, 2),
(5870, NULL, 'cd09464', NULL, NULL, 'LIM2_LIMK1', NULL, 'LIM2_LIMK1', NULL, NULL, NULL, 2),
(5871, NULL, 'cd18987', NULL, NULL, 'LGIC_ECD_anion', NULL, 'LGIC_ECD_anion', NULL, NULL, NULL, 2),
(5872, NULL, 'cd03189', NULL, NULL, 'GST_C_GTT1_like', NULL, 'GST_C_GTT1_like', NULL, NULL, NULL, 2),
(5873, NULL, 'cd06568', NULL, NULL, 'GH20_SpHex_like', NULL, 'GH20_SpHex_like', NULL, NULL, NULL, 2),
(5874, NULL, 'cd07777', NULL, NULL, 'FGGY_SHK_like', NULL, 'FGGY_SHK_like', NULL, NULL, 30196, 2),
(5875, NULL, 'cd00027', NULL, NULL, 'BRCT', NULL, 'BRCT', NULL, NULL, NULL, 2),
(5876, NULL, 'cd13655', NULL, NULL, 'PBP2_oligosaccharide_1', NULL, 'PBP2_oligosaccharide_1', NULL, NULL, NULL, 2),
(5877, NULL, 'cd12956', NULL, NULL, 'CBM_SusE-F_like', NULL, 'CBM_SusE-F_like', NULL, NULL, NULL, 2),
(5878, NULL, 'cd07531', NULL, NULL, 'HAD_Pase_UmpH-like', NULL, 'HAD_Pase_UmpH-like', NULL, NULL, NULL, 2),
(5879, NULL, 'cd02663', NULL, NULL, 'Peptidase_C19G', NULL, 'Peptidase_C19G', NULL, NULL, NULL, 2),
(5880, NULL, 'cd04967', NULL, NULL, 'Ig1_Contactin', NULL, 'Ig1_Contactin', NULL, NULL, NULL, 2),
(5881, NULL, 'cd08180', NULL, NULL, 'PDD', NULL, 'PDD', NULL, NULL, NULL, 2),
(5882, NULL, 'cd18260', NULL, NULL, 'BTB_POZ_KLHL31_KBTBD1', NULL, 'BTB_POZ_KLHL31_KBTBD1', NULL, NULL, NULL, 2),
(5883, NULL, 'cd06196', NULL, NULL, 'FNR_like_1', NULL, 'FNR_like_1', NULL, NULL, NULL, 2),
(5884, NULL, 'cd01119', NULL, NULL, 'Chemokine_CC_DCCL', NULL, 'Chemokine_CC_DCCL', NULL, NULL, 22860, 2),
(5885, NULL, 'cd16277', NULL, NULL, 'metallo-hydrolase-like_MBL-fold', NULL, 'metallo-hydrolase-like_MBL-fold', NULL, NULL, NULL, 2),
(5886, NULL, 'cd04666', NULL, NULL, 'Nudix_Hydrolase_9', NULL, 'Nudix_Hydrolase_9', NULL, NULL, NULL, 2),
(5887, NULL, 'cd08474', NULL, NULL, 'PBP2_CrgA_like_5', NULL, 'PBP2_CrgA_like_5', NULL, NULL, NULL, 2),
(5888, NULL, 'cd08542', NULL, NULL, 'SAM_PNT-ETS-1', NULL, 'SAM_PNT-ETS-1', NULL, NULL, 30436, 2),
(5889, NULL, 'cd09025', NULL, NULL, 'Aldose_epim_Slr1438', NULL, 'Aldose_epim_Slr1438', NULL, NULL, NULL, 2),
(5890, NULL, 'cd12436', NULL, NULL, 'RRM1_2_MATR3_like', NULL, 'RRM1_2_MATR3_like', NULL, NULL, NULL, 2),
(5891, NULL, 'cd17245', NULL, NULL, 'RMtype1_S_TteMORF1547P-TRD2-CR2_Aco12261I-TRD1...', NULL, 'RMtype1_S_TteMORF1547P-TRD2-CR2_Aco12261I-TRD1-CR1_like', NULL, NULL, NULL, 2);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(5892, NULL, 'cd18477', NULL, NULL, 'BACK_KLHL40_like', NULL, 'BACK_KLHL40_like', NULL, NULL, NULL, 2),
(5893, NULL, 'cd14476', NULL, NULL, 'SPX_PHO1_like', NULL, 'SPX_PHO1_like', NULL, NULL, 22597, 2),
(5894, NULL, 'cd10409', NULL, NULL, 'SH2_Nck2', NULL, 'SH2_Nck2', NULL, NULL, 32611, 2),
(5895, NULL, 'cd06563', NULL, NULL, 'GH20_chitobiase-like', NULL, 'GH20_chitobiase-like', NULL, NULL, NULL, 2),
(5896, NULL, 'cd04939', NULL, NULL, 'PA2301', NULL, 'PA2301', NULL, NULL, NULL, 2),
(5897, NULL, 'cd01166', NULL, NULL, 'KdgK', NULL, 'KdgK', NULL, NULL, NULL, 2),
(5898, NULL, 'cd11996', NULL, NULL, 'SH3_Intersectin2_5', NULL, 'SH3_Intersectin2_5', NULL, NULL, 28055, 2),
(5899, NULL, 'cd18518', NULL, NULL, 'BACK_SPOP', NULL, 'BACK_SPOP', NULL, NULL, 29945, 2),
(5900, NULL, 'cd07885', NULL, NULL, 'RHD-n_RelA', NULL, 'RHD-n_RelA', NULL, NULL, NULL, 2),
(5901, NULL, 'cd08057', NULL, NULL, 'MPN_euk_non_mb', NULL, 'MPN_euk_non_mb', NULL, NULL, NULL, 2),
(5902, NULL, 'cd18252', NULL, NULL, 'BTB_POZ_KLHL23', NULL, 'BTB_POZ_KLHL23', NULL, NULL, NULL, 2),
(5903, NULL, 'cd07818', NULL, NULL, 'SRPBCC_1', NULL, 'SRPBCC_1', NULL, NULL, NULL, 2),
(5904, NULL, 'cd05503', NULL, NULL, 'Bromo_BAZ2A_B_like', NULL, 'Bromo_BAZ2A_B_like', NULL, NULL, 27728, 2),
(5905, NULL, 'cd03871', NULL, NULL, 'M14_CPB', NULL, 'M14_CPB', NULL, NULL, 13971, 2),
(5906, NULL, 'cd07873', NULL, NULL, 'STKc_PCTAIRE1', NULL, 'STKc_PCTAIRE1', NULL, NULL, NULL, 2),
(5907, NULL, 'cd00288', NULL, NULL, 'Pyruvate_Kinase', NULL, 'Pyruvate_Kinase', NULL, NULL, 3451, 2),
(5908, NULL, 'cd10049', NULL, NULL, 'Reelin_repeat_5_subrepeat_2', NULL, 'Reelin_repeat_5_subrepeat_2', NULL, NULL, NULL, 2),
(5909, NULL, 'cd15158', NULL, NULL, '7tmA_CysLTR1', NULL, '7tmA_CysLTR1', NULL, NULL, NULL, 2),
(5910, NULL, 'cd08625', NULL, NULL, 'PI-PLCc_beta3', NULL, 'PI-PLCc_beta3', NULL, NULL, NULL, 2),
(5911, NULL, 'cd14661', NULL, NULL, 'Imelysin_like_PIBO', NULL, 'Imelysin_like_PIBO', NULL, NULL, NULL, 2),
(5912, NULL, 'cd16733', NULL, NULL, 'RING-HC_PCGF1', NULL, 'RING-HC_PCGF1', NULL, NULL, NULL, 2),
(5913, NULL, 'cd16228', NULL, NULL, 'EFh_CREC_Calumenin', NULL, 'EFh_CREC_Calumenin', NULL, NULL, NULL, 2),
(5914, NULL, 'cd15429', NULL, NULL, '7tmA_OR2F-like', NULL, '7tmA_OR2F-like', NULL, NULL, NULL, 2),
(5915, NULL, 'cd04718', NULL, NULL, 'BAH_plant_2', NULL, 'BAH_plant_2', NULL, NULL, NULL, 2),
(5916, NULL, 'cd16027', NULL, NULL, 'SGSH', NULL, 'SGSH', NULL, NULL, NULL, 2),
(5917, NULL, 'cd19947', NULL, NULL, 'NifU_Fer2_BFD-like', NULL, 'NifU_Fer2_BFD-like', NULL, NULL, NULL, 2),
(5918, NULL, 'cd01462', NULL, NULL, 'VWA_YIEM_type', NULL, 'VWA_YIEM_type', NULL, NULL, NULL, 2),
(5919, NULL, 'cd11368', NULL, NULL, 'RNase_PH_RRP45', NULL, 'RNase_PH_RRP45', NULL, NULL, 32825, 2),
(5920, NULL, 'cd10542', NULL, NULL, 'SET_SUV39H', NULL, 'SET_SUV39H', NULL, NULL, NULL, 2),
(5921, NULL, 'cd11943', NULL, NULL, 'SH3_JIP1', NULL, 'SH3_JIP1', NULL, NULL, 28401, 2),
(5922, NULL, 'cd03219', NULL, NULL, 'ABC_Mj1267_LivG_branched', NULL, 'ABC_Mj1267_LivG_branched', NULL, NULL, NULL, 2),
(5923, NULL, 'cd12090', NULL, NULL, 'MDA5_ID', NULL, 'MDA5_ID', NULL, NULL, NULL, 2),
(5924, NULL, 'cd15812', NULL, NULL, 'SPRY_PRY_TRIM17', NULL, 'SPRY_PRY_TRIM17', NULL, NULL, 28529, 2),
(5925, NULL, 'cd17996', NULL, NULL, 'DEXHc_SMARCA2_SMARCA4', NULL, 'DEXHc_SMARCA2_SMARCA4', NULL, NULL, NULL, 2),
(5926, NULL, 'cd19979', NULL, NULL, 'PBP1_ABC_ligand_binding-like', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, NULL, 2),
(5927, NULL, 'cd03420', NULL, NULL, 'SirA_RHOD_Pry_redox', NULL, 'SirA_RHOD_Pry_redox', NULL, NULL, NULL, 2),
(5928, NULL, 'cd04902', NULL, NULL, 'ACT_3PGDH-xct', NULL, 'ACT_3PGDH-xct', NULL, NULL, NULL, 2),
(5929, NULL, 'cd15524', NULL, NULL, 'PHD_PHF21B', NULL, 'PHD_PHF21B', NULL, NULL, NULL, 2),
(5930, NULL, 'cd02967', NULL, NULL, 'mauD', NULL, 'mauD', NULL, NULL, NULL, 2),
(5931, NULL, 'cd11260', NULL, NULL, 'Sema_4E', NULL, 'Sema_4E', NULL, NULL, NULL, 2),
(5932, NULL, 'cd21648', NULL, NULL, 'SARS-CoV-like_ORF3a', NULL, 'SARS-CoV-like_ORF3a', NULL, NULL, 22407, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(5933, NULL, 'cd11564', NULL, NULL, 'FAT-like_CAS_C', NULL, 'FAT-like_CAS_C', NULL, NULL, NULL, 2),
(5934, NULL, 'cd08659', NULL, NULL, 'M20_ArgE_DapE-like', NULL, 'M20_ArgE_DapE-like', NULL, NULL, NULL, 2),
(5935, NULL, 'cd15789', NULL, NULL, 'PH_ARHGEF2_18_like', NULL, 'PH_ARHGEF2_18_like', NULL, NULL, NULL, 2),
(5936, NULL, 'cd16646', NULL, NULL, 'mRING-HC-C2H2C4_MDM2_like', NULL, 'mRING-HC-C2H2C4_MDM2_like', NULL, NULL, NULL, 2),
(5937, NULL, 'cd00028', NULL, NULL, 'B_lectin', NULL, 'B_lectin', NULL, NULL, 3016, 2),
(5938, NULL, 'cd13344', NULL, NULL, 'PH-GRAM_MTMR7', NULL, 'PH-GRAM_MTMR7', NULL, NULL, 28258, 2),
(5939, NULL, 'cd02874', NULL, NULL, 'GH18_CFLE_spore_hydrolase', NULL, 'GH18_CFLE_spore_hydrolase', NULL, NULL, 30983, 2),
(5940, NULL, 'cd18297', NULL, NULL, 'BTB_POZ_ABTB2-like', NULL, 'BTB_POZ_ABTB2-like', NULL, NULL, NULL, 2),
(5941, NULL, 'cd14748', NULL, NULL, 'PBP2_UgpB', NULL, 'PBP2_UgpB', NULL, NULL, NULL, 2),
(5942, NULL, 'cd03412', NULL, NULL, 'CbiK_N', NULL, 'CbiK_N', NULL, NULL, NULL, 2),
(5943, NULL, 'cd06927', NULL, NULL, 'RNAP_L', NULL, 'RNAP_L', NULL, NULL, NULL, 2),
(5944, NULL, 'cd12050', NULL, NULL, 'SH3_DOCK2_A', NULL, 'SH3_DOCK2_A', NULL, NULL, NULL, 2),
(5945, NULL, 'cd15323', NULL, NULL, '7tmA_alpha2C_AR', NULL, '7tmA_alpha2C_AR', NULL, NULL, NULL, 2),
(5946, NULL, 'cd10319', NULL, NULL, 'EphR_LBD', NULL, 'EphR_LBD', NULL, NULL, NULL, 2),
(5947, NULL, 'cd05869', NULL, NULL, 'Ig_NCAM-1', NULL, 'Ig_NCAM-1', NULL, NULL, NULL, 2),
(5948, NULL, 'cd06349', NULL, NULL, 'PBP1_ABC_HAAT-like', NULL, 'PBP1_ABC_HAAT-like', NULL, NULL, NULL, 2),
(5949, NULL, 'cd06265', NULL, NULL, 'RNase_A_canonical', NULL, 'RNase_A_canonical', NULL, NULL, NULL, 2),
(5950, NULL, 'cd07230', NULL, NULL, 'Pat_TGL4-5_like', NULL, 'Pat_TGL4-5_like', NULL, NULL, NULL, 2),
(5951, NULL, 'cd09812', NULL, NULL, '3b-HSD_like_1_SDR_e', NULL, '3b-HSD_like_1_SDR_e', NULL, NULL, NULL, 2),
(5952, NULL, 'cd18447', NULL, NULL, 'BACK_KLHL7', NULL, 'BACK_KLHL7', NULL, NULL, NULL, 2),
(5953, NULL, 'cd12962', NULL, NULL, 'X25_BaPul_like', NULL, 'X25_BaPul_like', NULL, NULL, NULL, 2),
(5954, NULL, 'cd05358', NULL, NULL, 'GlcDH_SDR_c', NULL, 'GlcDH_SDR_c', NULL, NULL, NULL, 2),
(5955, NULL, 'cd20013', NULL, NULL, 'PBP1_RPA0985_benzoate-like', NULL, 'PBP1_RPA0985_benzoate-like', NULL, NULL, NULL, 2),
(5956, NULL, 'cd03477', NULL, NULL, 'Rieske_YhfW_C', NULL, 'Rieske_YhfW_C', NULL, NULL, 27537, 2),
(5957, NULL, 'cd04869', NULL, NULL, 'ACT_GcvR_2', NULL, 'ACT_GcvR_2', NULL, NULL, NULL, 2),
(5958, NULL, 'cd11918', NULL, NULL, 'SH3_Vinexin_3', NULL, 'SH3_Vinexin_3', NULL, NULL, 28219, 2),
(5959, NULL, 'cd17313', NULL, NULL, 'MFS_SLC45_SUC', NULL, 'MFS_SLC45_SUC', NULL, NULL, NULL, 2),
(5960, NULL, 'cd05969', NULL, NULL, 'MACS_like_4', NULL, 'MACS_like_4', NULL, NULL, NULL, 2),
(5961, NULL, 'cd16161', NULL, NULL, 'ARSG', NULL, 'ARSG', NULL, NULL, NULL, 2),
(5962, NULL, 'cd12801', NULL, NULL, 'HopAB_KID', NULL, 'HopAB_KID', NULL, NULL, NULL, 2),
(5963, NULL, 'cd19053', NULL, NULL, 'LGIC_TM_GABAAR_beta', NULL, 'LGIC_TM_GABAAR_beta', NULL, NULL, NULL, 2),
(5964, NULL, 'cd14047', NULL, NULL, 'STKc_EIF2AK2_PKR', NULL, 'STKc_EIF2AK2_PKR', NULL, NULL, NULL, 2),
(5965, NULL, 'cd07936', NULL, NULL, 'SCAN', NULL, 'SCAN', NULL, NULL, 1239, 2),
(5966, NULL, 'cd13858', NULL, NULL, 'CuRO_1_tcLCC2_insect_like', NULL, 'CuRO_1_tcLCC2_insect_like', NULL, NULL, NULL, 2),
(5967, NULL, 'cd16494', NULL, NULL, 'RING-CH-C4HC3_ZSWM2', NULL, 'RING-CH-C4HC3_ZSWM2', NULL, NULL, NULL, 2),
(5968, NULL, 'cd11768', NULL, NULL, 'SH3_Tec_like', NULL, 'SH3_Tec_like', NULL, NULL, NULL, 2),
(5969, NULL, 'cd17429', NULL, NULL, 'MFS_MCT14', NULL, 'MFS_MCT14', NULL, NULL, NULL, 2),
(5970, NULL, 'cd21413', NULL, NULL, 'unc_tv_SF1_Hel-like', NULL, 'unc_tv_SF1_Hel-like', NULL, NULL, 36351, 2),
(5971, NULL, 'cd12114', NULL, NULL, 'A_NRPS_TlmIV_like', NULL, 'A_NRPS_TlmIV_like', NULL, NULL, NULL, 2),
(5972, NULL, 'cd06476', NULL, NULL, 'ACD_HspB2_like', NULL, 'ACD_HspB2_like', NULL, NULL, NULL, 2),
(5973, NULL, 'cd01741', NULL, NULL, 'GATase1_1', NULL, 'GATase1_1', NULL, NULL, 34625, 2);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(5974, NULL, 'cd16681', NULL, NULL, 'RING-H2_RNF111', NULL, 'RING-H2_RNF111', NULL, NULL, NULL, 2),
(5975, NULL, 'cd15396', NULL, NULL, '7tmA_NPY6R', NULL, '7tmA_NPY6R', NULL, NULL, NULL, 2),
(5976, NULL, 'cd10555', NULL, NULL, 'EBDH_beta', NULL, 'EBDH_beta', NULL, NULL, 19950, 2),
(5977, NULL, 'cd09236', NULL, NULL, 'V_AnPalA_UmRIM20_like', NULL, 'V_AnPalA_UmRIM20_like', NULL, NULL, NULL, 2),
(5978, NULL, 'cd06068', NULL, NULL, 'H2MP_like-1', NULL, 'H2MP_like-1', NULL, NULL, NULL, 2),
(5979, NULL, 'cd08306', NULL, NULL, 'Death_FADD', NULL, 'Death_FADD', NULL, NULL, NULL, 2),
(5980, NULL, 'cd00068', NULL, NULL, 'GGL', NULL, 'GGL', NULL, NULL, 7554, 2),
(5981, NULL, 'cd02679', NULL, NULL, 'MIT_spastin', NULL, 'MIT_spastin', NULL, NULL, NULL, 2),
(5982, NULL, 'cd07564', NULL, NULL, 'nitrilases_CHs', NULL, 'nitrilases_CHs', NULL, NULL, 33890, 2),
(5983, NULL, 'cd07625', NULL, NULL, 'BAR_Vps17p', NULL, 'BAR_Vps17p', NULL, NULL, NULL, 2),
(5984, NULL, 'cd13941', NULL, NULL, 'PANDER_like_KIAA1199', NULL, 'PANDER_like_KIAA1199', NULL, NULL, NULL, 2),
(5985, NULL, 'cd09277', NULL, NULL, 'RNase_HI_bacteria_like', NULL, 'RNase_HI_bacteria_like', NULL, NULL, NULL, 2),
(5986, NULL, 'cd15220', NULL, NULL, '7tmA_GPR61_GPR62-like', NULL, '7tmA_GPR61_GPR62-like', NULL, NULL, NULL, 2),
(5987, NULL, 'cd16909', NULL, NULL, 'YEATS_GAS41_like', NULL, 'YEATS_GAS41_like', NULL, NULL, NULL, 2),
(5988, NULL, 'cd03572', NULL, NULL, 'ENTH_like_Tepsin', NULL, 'ENTH_like_Tepsin', NULL, NULL, 32677, 2),
(5989, NULL, 'cd04485', NULL, NULL, 'DnaE_OBF', NULL, 'DnaE_OBF', NULL, NULL, NULL, 2),
(5990, NULL, 'cd04395', NULL, NULL, 'RhoGAP_ARHGAP21', NULL, 'RhoGAP_ARHGAP21', NULL, NULL, NULL, 2),
(5991, NULL, 'cd19956', NULL, NULL, 'serpinB', NULL, 'serpinB', NULL, NULL, NULL, 2),
(5992, NULL, 'cd03519', NULL, NULL, 'Link_domain_HAPLN_module_2', NULL, 'Link_domain_HAPLN_module_2', NULL, NULL, NULL, 2),
(5993, NULL, 'cd17092', NULL, NULL, 'FERM1_F1_Myosin-VII', NULL, 'FERM1_F1_Myosin-VII', NULL, NULL, NULL, 2),
(5994, NULL, 'cd10141', NULL, NULL, 'CopZ-like_Fer2_BFD-like', NULL, 'CopZ-like_Fer2_BFD-like', NULL, NULL, NULL, 2),
(5995, NULL, 'cd01162', NULL, NULL, 'IBD', NULL, 'IBD', NULL, NULL, 11784, 2),
(5996, NULL, 'cd07716', NULL, NULL, 'RNaseZ_short-form-like_MBL-fold', NULL, 'RNaseZ_short-form-like_MBL-fold', NULL, NULL, NULL, 2),
(5997, NULL, 'cd18723', NULL, NULL, 'PIN_LabA-like', NULL, 'PIN_LabA-like', NULL, NULL, NULL, 2),
(5998, NULL, 'cd16749', NULL, NULL, 'RING-HC_SH3RF2', NULL, 'RING-HC_SH3RF2', NULL, NULL, NULL, 2),
(5999, NULL, 'cd12378', NULL, NULL, 'RRM1_I_PABPs', NULL, 'RRM1_I_PABPs', NULL, NULL, NULL, 2),
(6000, NULL, 'cd03558', NULL, NULL, 'LGIC_ECD', NULL, 'LGIC_ECD', NULL, NULL, NULL, 2),
(6001, NULL, 'cd14033', NULL, NULL, 'STKc_WNK4', NULL, 'STKc_WNK4', NULL, NULL, NULL, 2),
(6002, NULL, 'cd06164', NULL, NULL, 'S2P-M50_SpoIVFB_CBS', NULL, 'S2P-M50_SpoIVFB_CBS', NULL, NULL, NULL, 2),
(6003, NULL, 'cd08739', NULL, NULL, 'RGS_RGS9', NULL, 'RGS_RGS9', NULL, NULL, NULL, 2),
(6004, NULL, 'cd13860', NULL, NULL, 'CuRO_1_2dMco_1', NULL, 'CuRO_1_2dMco_1', NULL, NULL, NULL, 2),
(6005, NULL, 'cd15747', NULL, NULL, 'FYVE_Slp3_4_5', NULL, 'FYVE_Slp3_4_5', NULL, NULL, NULL, 2),
(6006, NULL, 'cd13402', NULL, NULL, 'LT_TF-like', NULL, 'LT_TF-like', NULL, NULL, NULL, 2),
(6007, NULL, 'cd13626', NULL, NULL, 'PBP2_Cystine_like', NULL, 'PBP2_Cystine_like', NULL, NULL, NULL, 2),
(6008, NULL, 'cd09205', NULL, NULL, 'PLDc_N_DEXD_b3', NULL, 'PLDc_N_DEXD_b3', NULL, NULL, NULL, 2),
(6009, NULL, 'cd03286', NULL, NULL, 'ABC_MSH6_euk', NULL, 'ABC_MSH6_euk', NULL, NULL, NULL, 2),
(6010, NULL, 'cd15550', NULL, NULL, 'PHD_MLL5', NULL, 'PHD_MLL5', NULL, NULL, NULL, 2),
(6011, NULL, 'cd00512', NULL, NULL, 'MM_CoA_mutase', NULL, 'MM_CoA_mutase', NULL, NULL, NULL, 2),
(6012, NULL, 'cd07902', NULL, NULL, 'Adenylation_DNA_ligase_III', NULL, 'Adenylation_DNA_ligase_III', NULL, NULL, NULL, 2),
(6013, NULL, 'cd08913', NULL, NULL, 'START_STARD14-like', NULL, 'START_STARD14-like', NULL, NULL, NULL, 2),
(6014, NULL, 'cd03315', NULL, NULL, 'MLE_like', NULL, 'MLE_like', NULL, NULL, 11981, 2);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(6015, NULL, 'cd08572', NULL, NULL, 'GDPD_GDE5_like', NULL, 'GDPD_GDE5_like', NULL, NULL, NULL, 2),
(6016, NULL, 'cd03729', NULL, NULL, 'SOCS_ASB13', NULL, 'SOCS_ASB13', NULL, NULL, 29754, 2),
(6017, NULL, 'cd18544', NULL, NULL, 'ABC_6TM_TmrA_like', NULL, 'ABC_6TM_TmrA_like', NULL, NULL, NULL, 2),
(6018, NULL, 'cd19899', NULL, NULL, 'DSRM_RED2_rpt2', NULL, 'DSRM_RED2_rpt2', NULL, NULL, NULL, 2),
(6019, NULL, 'cd14050', NULL, NULL, 'PKc_Myt1', NULL, 'PKc_Myt1', NULL, NULL, NULL, 2),
(6020, NULL, 'cd16746', NULL, NULL, 'RING-HC_RNF212', NULL, 'RING-HC_RNF212', NULL, NULL, NULL, 2),
(6021, NULL, 'cd10985', NULL, NULL, 'MH2_SMAD_2_3', NULL, 'MH2_SMAD_2_3', NULL, NULL, NULL, 2),
(6022, NULL, 'cd18333', NULL, NULL, 'BTB_POZ_ZBTB29_HIC1', NULL, 'BTB_POZ_ZBTB29_HIC1', NULL, NULL, NULL, 2),
(6023, NULL, 'cd16502', NULL, NULL, 'RING-HC_Cbl_like', NULL, 'RING-HC_Cbl_like', NULL, NULL, NULL, 2),
(6024, NULL, 'cd05505', NULL, NULL, 'Bromo_WSTF_like', NULL, 'Bromo_WSTF_like', NULL, NULL, 27612, 2),
(6025, NULL, 'cd04317', NULL, NULL, 'EcAspRS_like_N', NULL, 'EcAspRS_like_N', NULL, NULL, NULL, 2),
(6026, NULL, 'cd05889', NULL, NULL, 'Ig1_DNAM-1_like', NULL, 'Ig1_DNAM-1_like', NULL, NULL, NULL, 2),
(6027, NULL, 'cd15019', NULL, NULL, '7tm_TAS2R14-like', NULL, '7tm_TAS2R14-like', NULL, NULL, NULL, 2),
(6028, NULL, 'cd00771', NULL, NULL, 'ThrRS_core', NULL, 'ThrRS_core', NULL, NULL, 32846, 2),
(6029, NULL, 'cd12941', NULL, NULL, 'LEM_LEMD2', NULL, 'LEM_LEMD2', NULL, NULL, NULL, 2),
(6030, NULL, 'cd03246', NULL, NULL, 'ABCC_Protease_Secretion', NULL, 'ABCC_Protease_Secretion', NULL, NULL, NULL, 2),
(6031, NULL, 'cd18253', NULL, NULL, 'BTB_POZ_KLHL24_KRIP6', NULL, 'BTB_POZ_KLHL24_KRIP6', NULL, NULL, NULL, 2),
(6032, NULL, 'cd01876', NULL, NULL, 'YihA_EngB', NULL, 'YihA_EngB', NULL, NULL, 26176, 2),
(6033, NULL, 'cd05852', NULL, NULL, 'Ig5_Contactin-1', NULL, 'Ig5_Contactin-1', NULL, NULL, NULL, 2),
(6034, NULL, 'cd09639', NULL, NULL, 'Cas3_I', NULL, 'Cas3_I', NULL, NULL, NULL, 2),
(6035, NULL, 'cd07237', NULL, NULL, 'BphC1-RGP6_C_like', NULL, 'BphC1-RGP6_C_like', NULL, NULL, NULL, 2),
(6036, NULL, 'cd17486', NULL, NULL, 'MFS_AmpG_like', NULL, 'MFS_AmpG_like', NULL, NULL, NULL, 2),
(6037, NULL, 'cd00175', NULL, NULL, 'SNc', NULL, 'SNc', NULL, NULL, NULL, 2),
(6038, NULL, 'cd18035', NULL, NULL, 'DEXHc_Hef', NULL, 'DEXHc_Hef', NULL, NULL, NULL, 2),
(6039, NULL, 'cd12061', NULL, NULL, 'SH3_betaPIX', NULL, 'SH3_betaPIX', NULL, NULL, 32731, 2),
(6040, NULL, 'cd04387', NULL, NULL, 'RhoGAP_Bcr', NULL, 'RhoGAP_Bcr', NULL, NULL, NULL, 2),
(6041, NULL, 'cd02556', NULL, NULL, 'PseudoU_synth_RluB', NULL, 'PseudoU_synth_RluB', NULL, NULL, NULL, 2),
(6042, NULL, 'cd16003', NULL, NULL, '7tmA_NKR_NK3R', NULL, '7tmA_NKR_NK3R', NULL, NULL, NULL, 2),
(6043, NULL, 'cd12621', NULL, NULL, 'RRM3_TIA1', NULL, 'RRM3_TIA1', NULL, NULL, 33433, 2),
(6044, NULL, 'cd16702', NULL, NULL, 'RING_CH-C4HC3_MARCH6', NULL, 'RING_CH-C4HC3_MARCH6', NULL, NULL, NULL, 2),
(6045, NULL, 'cd06626', NULL, NULL, 'STKc_MEKK4', NULL, 'STKc_MEKK4', NULL, NULL, NULL, 2),
(6046, NULL, 'cd16972', NULL, NULL, 'Alpha_kinase_ChaK2_TRPM6', NULL, 'Alpha_kinase_ChaK2_TRPM6', NULL, NULL, NULL, 2),
(6047, NULL, 'cd07756', NULL, NULL, 'CYTH-like_Pase_CHAD', NULL, 'CYTH-like_Pase_CHAD', NULL, NULL, NULL, 2),
(6048, NULL, 'cd16978', NULL, NULL, 'VHS_HSE1', NULL, 'VHS_HSE1', NULL, NULL, NULL, 2),
(6049, NULL, 'cd07880', NULL, NULL, 'STKc_p38gamma', NULL, 'STKc_p38gamma', NULL, NULL, 31032, 2),
(6050, NULL, 'cd13717', NULL, NULL, 'PBP2_iGluR_putative', NULL, 'PBP2_iGluR_putative', NULL, NULL, NULL, 2),
(6051, NULL, 'cd07851', NULL, NULL, 'STKc_p38', NULL, 'STKc_p38', NULL, NULL, NULL, 2),
(6052, NULL, 'cd17364', NULL, NULL, 'MFS_PhT', NULL, 'MFS_PhT', NULL, NULL, NULL, 2),
(6053, NULL, 'cd08992', NULL, NULL, 'GH117', NULL, 'GH117', NULL, NULL, NULL, 2),
(6054, NULL, 'cd11879', NULL, NULL, 'SH3_Bem1p_2', NULL, 'SH3_Bem1p_2', NULL, NULL, 30169, 2),
(6055, NULL, 'cd02750', NULL, NULL, 'MopB_Nitrate-R-NarG-like', NULL, 'MopB_Nitrate-R-NarG-like', NULL, NULL, NULL, 2),
(6056, NULL, 'cd05871', NULL, NULL, 'Ig_Semaphorin_classIII', NULL, 'Ig_Semaphorin_classIII', NULL, NULL, NULL, 2);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(6057, NULL, 'cd02524', NULL, NULL, 'G1P_cytidylyltransferase', NULL, 'G1P_cytidylyltransferase', NULL, NULL, 9248, 2),
(6058, NULL, 'cd06953', NULL, NULL, 'NR_LBD_DHR4_like', NULL, 'NR_LBD_DHR4_like', NULL, NULL, NULL, 2),
(6059, NULL, 'cd08253', NULL, NULL, 'zeta_crystallin', NULL, 'zeta_crystallin', NULL, NULL, NULL, 2),
(6060, NULL, 'cd16621', NULL, NULL, 'vRING-HC-C4C4_RFPL1_like', NULL, 'vRING-HC-C4C4_RFPL1_like', NULL, NULL, NULL, 2),
(6061, NULL, 'cd01194', NULL, NULL, 'INT_C_like_4', NULL, 'INT_C_like_4', NULL, NULL, NULL, 2),
(6062, NULL, 'cd05930', NULL, NULL, 'A_NRPS', NULL, 'A_NRPS', NULL, NULL, NULL, 2),
(6063, NULL, 'cd09769', NULL, NULL, 'Luminal_IRE1', NULL, 'Luminal_IRE1', NULL, NULL, NULL, 2),
(6064, NULL, 'cd12281', NULL, NULL, 'RRM1_TatSF1_like', NULL, 'RRM1_TatSF1_like', NULL, NULL, 507, 2),
(6065, NULL, 'cd06975', NULL, NULL, 'cupin_BacB', NULL, 'cupin_BacB', NULL, NULL, NULL, 2),
(6066, NULL, 'cd11549', NULL, NULL, 'Serine_rich_CAS', NULL, 'Serine_rich_CAS', NULL, NULL, NULL, 2),
(6067, NULL, 'cd14902', NULL, NULL, 'MYSc_Myo41', NULL, 'MYSc_Myo41', NULL, NULL, NULL, 2),
(6068, NULL, 'cd13701', NULL, NULL, 'PBP2_ml15202_like', NULL, 'PBP2_ml15202_like', NULL, NULL, NULL, 2),
(6069, NULL, 'cd06979', NULL, NULL, 'cupin_RemF-like', NULL, 'cupin_RemF-like', NULL, NULL, NULL, 2),
(6070, NULL, 'cd20264', NULL, NULL, 'Complex1_LYR_LYRM4', NULL, 'Complex1_LYR_LYRM4', NULL, NULL, 37107, 2),
(6071, NULL, 'cd02572', NULL, NULL, 'PseudoU_synth_hDyskerin', NULL, 'PseudoU_synth_hDyskerin', NULL, NULL, NULL, 2),
(6072, NULL, 'cd09366', NULL, NULL, 'LIM1_Isl', NULL, 'LIM1_Isl', NULL, NULL, NULL, 2),
(6073, NULL, 'cd14409', NULL, NULL, 'UBA_SIK2', NULL, 'UBA_SIK2', NULL, NULL, NULL, 2),
(6074, NULL, 'cd12529', NULL, NULL, 'RRM2_MEI2_like', NULL, 'RRM2_MEI2_like', NULL, NULL, NULL, 2),
(6075, NULL, 'cd18755', NULL, NULL, 'PIN_MtVapC3_VapC21-like', NULL, 'PIN_MtVapC3_VapC21-like', NULL, NULL, NULL, 2),
(6076, NULL, 'cd11889', NULL, NULL, 'SH3_Cyk3p-like', NULL, 'SH3_Cyk3p-like', NULL, NULL, 30050, 2),
(6077, NULL, 'cd18276', NULL, NULL, 'BTB_POZ_KBTBD12', NULL, 'BTB_POZ_KBTBD12', NULL, NULL, NULL, 2),
(6078, NULL, 'cd03885', NULL, NULL, 'M20_CPDG2', NULL, 'M20_CPDG2', NULL, NULL, NULL, 2),
(6079, NULL, 'cd08574', NULL, NULL, 'GDPD_GDE_2_3_6', NULL, 'GDPD_GDE_2_3_6', NULL, NULL, NULL, 2),
(6080, NULL, 'cd15800', NULL, NULL, 'PMEI-like_2', NULL, 'PMEI-like_2', NULL, NULL, NULL, 2),
(6081, NULL, 'cd06824', NULL, NULL, 'PLPDE_III_Yggs_like', NULL, 'PLPDE_III_Yggs_like', NULL, NULL, NULL, 2),
(6082, NULL, 'cd16663', NULL, NULL, 'RING-Ubox_PPIL2', NULL, 'RING-Ubox_PPIL2', NULL, NULL, 22671, 2),
(6083, NULL, 'cd19705', NULL, NULL, 'bHLH_TS_LYL1', NULL, 'bHLH_TS_LYL1', NULL, NULL, NULL, 2),
(6084, NULL, 'cd06307', NULL, NULL, 'PBP1_sugar_binding', NULL, 'PBP1_sugar_binding', NULL, NULL, NULL, 2),
(6085, NULL, 'cd16776', NULL, NULL, 'RING-HC_RBR_RNF19B', NULL, 'RING-HC_RBR_RNF19B', NULL, NULL, NULL, 2),
(6086, NULL, 'cd15956', NULL, NULL, '7tmA_OR52W-like', NULL, '7tmA_OR52W-like', NULL, NULL, NULL, 2),
(6087, NULL, 'cd02867', NULL, NULL, 'PseudoU_synth_TruB_4', NULL, 'PseudoU_synth_TruB_4', NULL, NULL, NULL, 2),
(6088, NULL, 'cd08523', NULL, NULL, 'Reeler_cohesin_like', NULL, 'Reeler_cohesin_like', NULL, NULL, NULL, 2),
(6089, NULL, 'cd05569', NULL, NULL, 'PTS_IIB_fructose', NULL, 'PTS_IIB_fructose', NULL, NULL, 4429, 2),
(6090, NULL, 'cd08524', NULL, NULL, 'Reelin_subrepeat_like', NULL, 'Reelin_subrepeat_like', NULL, NULL, NULL, 2),
(6091, NULL, 'cd12124', NULL, NULL, 'Pgbs', NULL, 'Pgbs', NULL, NULL, 12941, 2),
(6092, NULL, 'cd14585', NULL, NULL, 'PTP-MTMR6', NULL, 'PTP-MTMR6', NULL, NULL, NULL, 2),
(6093, NULL, 'cd18430', NULL, NULL, 'M14_ASTE_ASPA_like', NULL, 'M14_ASTE_ASPA_like', NULL, NULL, NULL, 2),
(6094, NULL, 'cd01987', NULL, NULL, 'USP_OKCHK', NULL, 'USP_OKCHK', NULL, NULL, NULL, 2),
(6095, NULL, 'cd05591', NULL, NULL, 'STKc_nPKC_epsilon', NULL, 'STKc_nPKC_epsilon', NULL, NULL, 33472, 2),
(6096, NULL, 'cd09394', NULL, NULL, 'LIM1_Rga', NULL, 'LIM1_Rga', NULL, NULL, NULL, 2),
(6097, NULL, 'cd13925', NULL, NULL, 'RPF', NULL, 'RPF', NULL, NULL, 8490, 2);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(6098, NULL, 'cd03040', NULL, NULL, 'GST_N_mPGES2', NULL, 'GST_N_mPGES2', NULL, NULL, NULL, 2),
(6099, NULL, 'cd04302', NULL, NULL, 'HAD_5NT', NULL, 'HAD_5NT', NULL, NULL, NULL, 2),
(6100, NULL, 'cd12534', NULL, NULL, 'RRM_SARFH', NULL, 'RRM_SARFH', NULL, NULL, NULL, 2),
(6101, NULL, 'cd04120', NULL, NULL, 'Rab12', NULL, 'Rab12', NULL, NULL, 30472, 2),
(6102, NULL, 'cd02971', NULL, NULL, 'PRX_family', NULL, 'PRX_family', NULL, NULL, NULL, 2),
(6103, NULL, 'cd10476', NULL, NULL, 'EphR_LBD_B1', NULL, 'EphR_LBD_B1', NULL, NULL, 27029, 2),
(6104, NULL, 'cd17463', NULL, NULL, 'MFS_SLCO4C_OATP4C', NULL, 'MFS_SLCO4C_OATP4C', NULL, NULL, NULL, 2),
(6105, NULL, 'cd07389', NULL, NULL, 'MPP_PhoD', NULL, 'MPP_PhoD', NULL, NULL, 9430, 2),
(6106, NULL, 'cd17302', NULL, NULL, 'PIPKc_AtPIP5K_like', NULL, 'PIPKc_AtPIP5K_like', NULL, NULL, NULL, 2),
(6107, NULL, 'cd15331', NULL, NULL, '7tmA_5-HT1A_invertebrates', NULL, '7tmA_5-HT1A_invertebrates', NULL, NULL, NULL, 2),
(6108, NULL, 'cd14303', NULL, NULL, 'UBA1_KPC2', NULL, 'UBA1_KPC2', NULL, NULL, 30154, 2),
(6109, NULL, 'cd01539', NULL, NULL, 'PBP1_GGBP', NULL, 'PBP1_GGBP', NULL, NULL, 35998, 2),
(6110, NULL, 'cd11250', NULL, NULL, 'Sema_3B', NULL, 'Sema_3B', NULL, NULL, NULL, 2),
(6111, NULL, 'cd16591', NULL, NULL, 'RING-HC_TRIM5_like-C-IV', NULL, 'RING-HC_TRIM5_like-C-IV', NULL, NULL, NULL, 2),
(6112, NULL, 'cd04492', NULL, NULL, 'YhaM_OBF_like', NULL, 'YhaM_OBF_like', NULL, NULL, NULL, 2),
(6113, NULL, 'cd17300', NULL, NULL, 'PIPKc_PIKfyve', NULL, 'PIPKc_PIKfyve', NULL, NULL, 34374, 2),
(6114, NULL, 'cd02951', NULL, NULL, 'SoxW', NULL, 'SoxW', NULL, NULL, 30048, 2),
(6115, NULL, 'cd02439', NULL, NULL, 'DMB-PRT_CobT', NULL, 'DMB-PRT_CobT', NULL, NULL, 1646, 2),
(6116, NULL, 'cd21657', NULL, NULL, 'deltaCoV_Nsp14', NULL, 'deltaCoV_Nsp14', NULL, NULL, 34629, 2),
(6117, NULL, 'cd08839', NULL, NULL, 'ArfGap_SMAP', NULL, 'ArfGap_SMAP', NULL, NULL, 34330, 2),
(6118, NULL, 'cd16367', NULL, NULL, 'DMSOR_beta_like', NULL, 'DMSOR_beta_like', NULL, NULL, NULL, 2),
(6119, NULL, 'cd11336', NULL, NULL, 'AmyAc_MTSase', NULL, 'AmyAc_MTSase', NULL, NULL, 9910, 2),
(6120, NULL, 'cd07305', NULL, NULL, 'Porin3_Tom40', NULL, 'Porin3_Tom40', NULL, NULL, 32727, 2),
(6121, NULL, 'cd17957', NULL, NULL, 'DEADc_DDX52', NULL, 'DEADc_DDX52', NULL, NULL, 34234, 2),
(6122, NULL, 'cd06112', NULL, NULL, 'citrate_synt_like_1_1', NULL, 'citrate_synt_like_1_1', NULL, NULL, NULL, 2),
(6123, NULL, 'cd15565', NULL, NULL, 'PHD2_NSD', NULL, 'PHD2_NSD', NULL, NULL, NULL, 2),
(6124, NULL, 'cd09529', NULL, NULL, 'SAM_MLTK', NULL, 'SAM_MLTK', NULL, NULL, NULL, 2),
(6125, NULL, 'cd11680', NULL, NULL, 'HDAC_Hos1', NULL, 'HDAC_Hos1', NULL, NULL, NULL, 2),
(6126, NULL, 'cd15950', NULL, NULL, '7tmA_OR52I-like', NULL, '7tmA_OR52I-like', NULL, NULL, NULL, 2),
(6127, NULL, 'cd15533', NULL, NULL, 'PHD1_PHF12', NULL, 'PHD1_PHF12', NULL, NULL, NULL, 2),
(6128, NULL, 'cd00980', NULL, NULL, 'FwdC/FmdC', NULL, 'FwdC/FmdC', NULL, NULL, 14800, 2),
(6129, NULL, 'cd12819', NULL, NULL, 'LbR_vir_like', NULL, 'LbR_vir_like', NULL, NULL, NULL, 2),
(6130, NULL, 'cd00548', NULL, NULL, 'NrfA-like', NULL, 'NrfA-like', NULL, NULL, 4438, 2),
(6131, NULL, 'cd16313', NULL, NULL, 'SMB-1-like_MBL-B3', NULL, 'SMB-1-like_MBL-B3', NULL, NULL, NULL, 2),
(6132, NULL, 'cd14240', NULL, NULL, 'GAT_GGA3', NULL, 'GAT_GGA3', NULL, NULL, 35482, 2),
(6133, NULL, 'cd07646', NULL, NULL, 'I-BAR_IMD_IRSp53', NULL, 'I-BAR_IMD_IRSp53', NULL, NULL, NULL, 2),
(6134, NULL, 'cd09034', NULL, NULL, 'BRO1_Alix_like', NULL, 'BRO1_Alix_like', NULL, NULL, NULL, 2),
(6135, NULL, 'cd05075', NULL, NULL, 'PTKc_Axl', NULL, 'PTKc_Axl', NULL, NULL, NULL, 2),
(6136, NULL, 'cd13647', NULL, NULL, 'PBP2_PBGD_2', NULL, 'PBP2_PBGD_2', NULL, NULL, NULL, 2),
(6137, NULL, 'cd10454', NULL, NULL, 'GIY-YIG_COG3680_Meta', NULL, 'GIY-YIG_COG3680_Meta', NULL, NULL, NULL, 2),
(6138, NULL, 'cd18159', NULL, NULL, 'REC_OmpR_NsrR-like', NULL, 'REC_OmpR_NsrR-like', NULL, NULL, NULL, 2),
(6139, NULL, 'cd03859', NULL, NULL, 'M14_CPT', NULL, 'M14_CPT', NULL, NULL, 29395, 2),
(6140, NULL, 'cd15909', NULL, NULL, '7tmF_FZD4_9_10-like', NULL, '7tmF_FZD4_9_10-like', NULL, NULL, NULL, 2);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(6141, NULL, 'cd04661', NULL, NULL, 'MRP_L46', NULL, 'MRP_L46', NULL, NULL, 28693, 2),
(6142, NULL, 'cd11465', NULL, NULL, 'bHLH_TS_scleraxis_like', NULL, 'bHLH_TS_scleraxis_like', NULL, NULL, NULL, 2),
(6143, NULL, 'cd12872', NULL, NULL, 'SPRY_Ash2', NULL, 'SPRY_Ash2', NULL, NULL, NULL, 2),
(6144, NULL, 'cd17432', NULL, NULL, 'MFS_GLUT_Class2', NULL, 'MFS_GLUT_Class2', NULL, NULL, NULL, 2),
(6145, NULL, 'cd14007', NULL, NULL, 'STKc_Aurora', NULL, 'STKc_Aurora', NULL, NULL, NULL, 2),
(6146, NULL, 'cd15475', NULL, NULL, 'MyosinXI_CBD', NULL, 'MyosinXI_CBD', NULL, NULL, 27303, 2),
(6147, NULL, 'cd02107', NULL, NULL, 'YedY_like_Moco', NULL, 'YedY_like_Moco', NULL, NULL, NULL, 2),
(6148, NULL, 'cd11572', NULL, NULL, 'RlmI_M_like', NULL, 'RlmI_M_like', NULL, NULL, NULL, 2),
(6149, NULL, 'cd15806', NULL, NULL, 'LGP2_C', NULL, 'LGP2_C', NULL, NULL, NULL, 2),
(6150, NULL, 'cd20477', NULL, NULL, 'Cas13b_Pb-like', NULL, 'Cas13b_Pb-like', NULL, NULL, NULL, 2),
(6151, NULL, 'cd06422', NULL, NULL, 'NTP_transferase_like_1', NULL, 'NTP_transferase_like_1', NULL, NULL, NULL, 2),
(6152, NULL, 'cd07908', NULL, NULL, 'Mn_catalase_like', NULL, 'Mn_catalase_like', NULL, NULL, NULL, 2),
(6153, NULL, 'cd07527', NULL, NULL, 'HAD_ScGPP-like', NULL, 'HAD_ScGPP-like', NULL, NULL, NULL, 2),
(6154, NULL, 'cd02809', NULL, NULL, 'alpha_hydroxyacid_oxid_FMN', NULL, 'alpha_hydroxyacid_oxid_FMN', NULL, NULL, 13758, 2),
(6155, NULL, 'cd11378', NULL, NULL, 'DUF296', NULL, 'DUF296', NULL, NULL, 5145, 2),
(6156, NULL, 'cd17481', NULL, NULL, 'MFS_MFSD13A', NULL, 'MFS_MFSD13A', NULL, NULL, NULL, 2),
(6157, NULL, 'cd18985', NULL, NULL, 'CBD_TIP60_like', NULL, 'CBD_TIP60_like', NULL, NULL, NULL, 2),
(6158, NULL, 'cd19075', NULL, NULL, 'AKR_AKR7A1-5', NULL, 'AKR_AKR7A1-5', NULL, NULL, NULL, 2),
(6159, NULL, 'cd18106', NULL, NULL, 'SpoU-like_RNMTL1', NULL, 'SpoU-like_RNMTL1', NULL, NULL, NULL, 2),
(6160, NULL, 'cd15080', NULL, NULL, '7tmA_MWS_opsin', NULL, '7tmA_MWS_opsin', NULL, NULL, NULL, 2),
(6161, NULL, 'cd03042', NULL, NULL, 'GST_N_Zeta', NULL, 'GST_N_Zeta', NULL, NULL, 19843, 2),
(6162, NULL, 'cd18794', NULL, NULL, 'SF2_C_RecQ', NULL, 'SF2_C_RecQ', NULL, NULL, NULL, 2),
(6163, NULL, 'cd11905', NULL, NULL, 'SH3_Tec', NULL, 'SH3_Tec', NULL, NULL, 29227, 2),
(6164, NULL, 'cd16637', NULL, NULL, 'mRING-HC-C3HC3D_LNX1_like', NULL, 'mRING-HC-C3HC3D_LNX1_like', NULL, NULL, NULL, 2),
(6165, NULL, 'cd11016', NULL, NULL, 'CuRO_4_FVIII_like', NULL, 'CuRO_4_FVIII_like', NULL, NULL, NULL, 2),
(6166, NULL, 'cd02861', NULL, NULL, 'E_set_pullulanase_like', NULL, 'E_set_pullulanase_like', NULL, NULL, NULL, 2),
(6167, NULL, 'cd04486', NULL, NULL, 'YhcR_OBF_like', NULL, 'YhcR_OBF_like', NULL, NULL, NULL, 2),
(6168, NULL, 'cd10469', NULL, NULL, 'FAM20A_C', NULL, 'FAM20A_C', NULL, NULL, NULL, 2),
(6169, NULL, 'cd05231', NULL, NULL, 'NmrA_TMR_like_1_SDR_a', NULL, 'NmrA_TMR_like_1_SDR_a', NULL, NULL, NULL, 2),
(6170, NULL, 'cd18245', NULL, NULL, 'BTB_POZ_KLHL16_gigaxonin', NULL, 'BTB_POZ_KLHL16_gigaxonin', NULL, NULL, NULL, 2),
(6171, NULL, 'cd08188', NULL, NULL, 'PDDH', NULL, 'PDDH', NULL, NULL, NULL, 2),
(6172, NULL, 'cd03122', NULL, NULL, 'alpha_CARP_receptor_like', NULL, 'alpha_CARP_receptor_like', NULL, NULL, 30546, 2),
(6173, NULL, 'cd08586', NULL, NULL, 'PI-PLCc_BcPLC_like', NULL, 'PI-PLCc_BcPLC_like', NULL, NULL, NULL, 2),
(6174, NULL, 'cd08148', NULL, NULL, 'RuBisCO_large', NULL, 'RuBisCO_large', NULL, NULL, NULL, 2),
(6175, NULL, 'cd03394', NULL, NULL, 'PAP2_like_5', NULL, 'PAP2_like_5', NULL, NULL, NULL, 2),
(6176, NULL, 'cd16155', NULL, NULL, 'sulfatase_like', NULL, 'sulfatase_like', NULL, NULL, NULL, 2),
(6177, NULL, 'cd13261', NULL, NULL, 'PH_RasGRF1_2', NULL, 'PH_RasGRF1_2', NULL, NULL, NULL, 2),
(6178, NULL, 'cd19761', NULL, NULL, 'Bbox2_TRIM5-like', NULL, 'Bbox2_TRIM5-like', NULL, NULL, NULL, 2),
(6179, NULL, 'cd03779', NULL, NULL, 'MATH_TRAF1', NULL, 'MATH_TRAF1', NULL, NULL, 27890, 2),
(6180, NULL, 'cd05365', NULL, NULL, '7_alpha_HSDH_SDR_c', NULL, '7_alpha_HSDH_SDR_c', NULL, NULL, NULL, 2),
(6181, NULL, 'cd13933', NULL, NULL, 'harmonin_N_like_u1', NULL, 'harmonin_N_like_u1', NULL, NULL, NULL, 2);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(6182, NULL, 'cd19042', NULL, NULL, 'LGIC_ECD_GABAAR_B3', NULL, 'LGIC_ECD_GABAAR_B3', NULL, NULL, NULL, 2),
(6183, NULL, 'cd00367', NULL, NULL, 'PTS-HPr_like', NULL, 'PTS-HPr_like', NULL, NULL, 3439, 2),
(6184, NULL, 'cd15272', NULL, NULL, '7tmB1_PTH-R_related', NULL, '7tmB1_PTH-R_related', NULL, NULL, NULL, 2),
(6185, NULL, 'cd08714', NULL, NULL, 'RGS_RGS4', NULL, 'RGS_RGS4', NULL, NULL, 15950, 2),
(6186, NULL, 'cd03538', NULL, NULL, 'Rieske_RO_Alpha_AntDO', NULL, 'Rieske_RO_Alpha_AntDO', NULL, NULL, NULL, 2),
(6187, NULL, 'cd02407', NULL, NULL, 'PTH2_family', NULL, 'PTH2_family', NULL, NULL, NULL, 2),
(6188, NULL, 'cd08826', NULL, NULL, 'SPFH_eoslipins_u1', NULL, 'SPFH_eoslipins_u1', NULL, NULL, NULL, 2),
(6189, NULL, 'cd03293', NULL, NULL, 'ABC_NrtD_SsuB_transporters', NULL, 'ABC_NrtD_SsuB_transporters', NULL, NULL, NULL, 2),
(6190, NULL, 'cd18528', NULL, NULL, 'BACK_RCBTB1', NULL, 'BACK_RCBTB1', NULL, NULL, NULL, 2),
(6191, NULL, 'cd08384', NULL, NULL, 'C2B_Rabphilin_Doc2', NULL, 'C2B_Rabphilin_Doc2', NULL, NULL, NULL, 2),
(6192, NULL, 'cd01487', NULL, NULL, 'E1_ThiF_like', NULL, 'E1_ThiF_like', NULL, NULL, 11830, 2),
(6193, NULL, 'cd16576', NULL, NULL, 'RING-HC_TRIM9_like_C-I', NULL, 'RING-HC_TRIM9_like_C-I', NULL, NULL, NULL, 2),
(6194, NULL, 'cd15142', NULL, NULL, '7tmA_PGE2_EP4', NULL, '7tmA_PGE2_EP4', NULL, NULL, NULL, 2),
(6195, NULL, 'cd03453', NULL, NULL, 'SAV4209_like', NULL, 'SAV4209_like', NULL, NULL, NULL, 2),
(6196, NULL, 'cd04095', NULL, NULL, 'CysN_NoDQ_III', NULL, 'CysN_NoDQ_III', NULL, NULL, 36115, 2),
(6197, NULL, 'cd01791', NULL, NULL, 'Ubl_UBL5', NULL, 'Ubl_UBL5', NULL, NULL, NULL, 2),
(6198, NULL, 'cd05885', NULL, NULL, 'Ig2_Necl-4', NULL, 'Ig2_Necl-4', NULL, NULL, NULL, 2),
(6199, NULL, 'cd05710', NULL, NULL, 'SIS_1', NULL, 'SIS_1', NULL, NULL, 33894, 2),
(6200, NULL, 'cd18385', NULL, NULL, 'BTB_POZ_BTBD10_GMRP1', NULL, 'BTB_POZ_BTBD10_GMRP1', NULL, NULL, NULL, 2),
(6201, NULL, 'cd07706', NULL, NULL, 'IgV_TCR_delta', NULL, 'IgV_TCR_delta', NULL, NULL, NULL, 2),
(6202, NULL, 'cd00862', NULL, NULL, 'ProRS_anticodon_zinc', NULL, 'ProRS_anticodon_zinc', NULL, NULL, NULL, 2),
(6203, NULL, 'cd08390', NULL, NULL, 'C2A_Synaptotagmin-15-17', NULL, 'C2A_Synaptotagmin-15-17', NULL, NULL, NULL, 2),
(6204, NULL, 'cd10443', NULL, NULL, 'GIY-YIG_HE_Tlr8p_PBC-V_like', NULL, 'GIY-YIG_HE_Tlr8p_PBC-V_like', NULL, NULL, NULL, 2),
(6205, NULL, 'cd12278', NULL, NULL, 'RRM_eIF3B', NULL, 'RRM_eIF3B', NULL, NULL, 3813, 2),
(6206, NULL, 'cd05841', NULL, NULL, 'BS69_related', NULL, 'BS69_related', NULL, NULL, 32764, 2),
(6207, NULL, 'cd19061', NULL, NULL, 'LGIC_TM_GlyR_beta', NULL, 'LGIC_TM_GlyR_beta', NULL, NULL, NULL, 2),
(6208, NULL, 'cd16816', NULL, NULL, 'mRING-HC-C3HC5_MGRN1', NULL, 'mRING-HC-C3HC5_MGRN1', NULL, NULL, NULL, 2),
(6209, NULL, 'cd05366', NULL, NULL, 'meso-BDH-like_SDR_c', NULL, 'meso-BDH-like_SDR_c', NULL, NULL, NULL, 2),
(6210, NULL, 'cd10795', NULL, NULL, 'GH57N_MJA1_like', NULL, 'GH57N_MJA1_like', NULL, NULL, NULL, 2),
(6211, NULL, 'cd18747', NULL, NULL, 'PIN_VapC4-5_FitB-like', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, NULL, 2),
(6212, NULL, 'cd05751', NULL, NULL, 'Ig1_LILR_KIR_like', NULL, 'Ig1_LILR_KIR_like', NULL, NULL, NULL, 2),
(6213, NULL, 'cd10461', NULL, NULL, 'PUB_UBA_plant', NULL, 'PUB_UBA_plant', NULL, NULL, NULL, 2),
(6214, NULL, 'cd08593', NULL, NULL, 'PI-PLCc_delta', NULL, 'PI-PLCc_delta', NULL, NULL, NULL, 2),
(6215, NULL, 'cd05049', NULL, NULL, 'PTKc_Trk', NULL, 'PTKc_Trk', NULL, NULL, NULL, 2),
(6216, NULL, 'cd06533', NULL, NULL, 'Glyco_transf_WecG_TagA', NULL, 'Glyco_transf_WecG_TagA', NULL, NULL, 2136, 2),
(6217, NULL, 'cd15064', NULL, NULL, '7tmA_5-HT1_5_7', NULL, '7tmA_5-HT1_5_7', NULL, NULL, NULL, 2),
(6218, NULL, 'cd17381', NULL, NULL, 'MFS_SLC17A5', NULL, 'MFS_SLC17A5', NULL, NULL, NULL, 2),
(6219, NULL, 'cd08582', NULL, NULL, 'GDPD_like_2', NULL, 'GDPD_like_2', NULL, NULL, NULL, 2),
(6220, NULL, 'cd10027', NULL, NULL, 'UDG-F1-like', NULL, 'UDG-F1-like', NULL, NULL, 1399, 2),
(6221, NULL, 'cd15120', NULL, NULL, '7tmA_GPR33', NULL, '7tmA_GPR33', NULL, NULL, NULL, 2);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(6222, NULL, 'cd19463', NULL, NULL, 'CRBP2', NULL, 'CRBP2', NULL, NULL, NULL, 2),
(6223, NULL, 'cd17345', NULL, NULL, 'MFS_GlpT', NULL, 'MFS_GlpT', NULL, NULL, NULL, 2),
(6224, NULL, 'cd07725', NULL, NULL, 'TTHA1429-like_MBL-fold', NULL, 'TTHA1429-like_MBL-fold', NULL, NULL, NULL, 2),
(6225, NULL, 'cd11624', NULL, NULL, 'HR1_Rhophilin', NULL, 'HR1_Rhophilin', NULL, NULL, NULL, 2),
(6226, NULL, 'cd03131', NULL, NULL, 'GATase1_HTS', NULL, 'GATase1_HTS', NULL, NULL, 30160, 2),
(6227, NULL, 'cd12047', NULL, NULL, 'SH3_Noxa1_C', NULL, 'SH3_Noxa1_C', NULL, NULL, NULL, 2),
(6228, NULL, 'cd01417', NULL, NULL, 'Ribosomal_L19e_E', NULL, 'Ribosomal_L19e_E', NULL, NULL, 30762, 2),
(6229, NULL, 'cd10149', NULL, NULL, 'ClassIIa_HDAC_Gln-rich-N', NULL, 'ClassIIa_HDAC_Gln-rich-N', NULL, NULL, NULL, 2),
(6230, NULL, 'cd19766', NULL, NULL, 'Bbox2_TRIM11_C-IV', NULL, 'Bbox2_TRIM11_C-IV', NULL, NULL, NULL, 2),
(6231, NULL, 'cd05247', NULL, NULL, 'UDP_G4E_1_SDR_e', NULL, 'UDP_G4E_1_SDR_e', NULL, NULL, 6595, 2),
(6232, NULL, 'cd13702', NULL, NULL, 'PBP2_mlr5654_like', NULL, 'PBP2_mlr5654_like', NULL, NULL, NULL, 2),
(6233, NULL, 'cd05835', NULL, NULL, 'Dnmt3b_related', NULL, 'Dnmt3b_related', NULL, NULL, NULL, 2),
(6234, NULL, 'cd16108', NULL, NULL, 'Ubl_ATG8_like', NULL, 'Ubl_ATG8_like', NULL, NULL, NULL, 2),
(6235, NULL, 'cd16901', NULL, NULL, 'lyz_P1', NULL, 'lyz_P1', NULL, NULL, NULL, 2),
(6236, NULL, 'cd08041', NULL, NULL, 'OBF_kDNA_ligase_like', NULL, 'OBF_kDNA_ligase_like', NULL, NULL, NULL, 2),
(6237, NULL, 'cd19395', NULL, NULL, 'TGF_beta_BMP5', NULL, 'TGF_beta_BMP5', NULL, NULL, NULL, 2),
(6238, NULL, 'cd05737', NULL, NULL, 'Ig_Myomesin_like_C', NULL, 'Ig_Myomesin_like_C', NULL, NULL, NULL, 2),
(6239, NULL, 'cd15788', NULL, NULL, 'Clospo_01618_like', NULL, 'Clospo_01618_like', NULL, NULL, 30374, 2),
(6240, NULL, 'cd09634', NULL, NULL, 'Cas1_I-II-III', NULL, 'Cas1_I-II-III', NULL, NULL, NULL, 2),
(6241, NULL, 'cd12631', NULL, NULL, 'RRM1_CELF1_2_Bruno', NULL, 'RRM1_CELF1_2_Bruno', NULL, NULL, 19679, 2),
(6242, NULL, 'cd16135', NULL, NULL, 'RA_RASSF7', NULL, 'RA_RASSF7', NULL, NULL, NULL, 2),
(6243, NULL, 'cd09703', NULL, NULL, 'Cas6-I-III', NULL, 'Cas6-I-III', NULL, NULL, 8772, 2),
(6244, NULL, 'cd00252', NULL, NULL, 'EFh_SPARC_EC', NULL, 'EFh_SPARC_EC', NULL, NULL, NULL, 2),
(6245, NULL, 'cd04912', NULL, NULL, 'ACT_AKiii-LysC-EC-like_1', NULL, 'ACT_AKiii-LysC-EC-like_1', NULL, NULL, NULL, 2),
(6246, NULL, 'cd14327', NULL, NULL, 'UBA_atUPL1_2_like', NULL, 'UBA_atUPL1_2_like', NULL, NULL, NULL, 2),
(6247, NULL, 'cd09419', NULL, NULL, 'LIM3_Testin', NULL, 'LIM3_Testin', NULL, NULL, 10823, 2),
(6248, NULL, 'cd15062', NULL, NULL, '7tmA_alpha1_AR', NULL, '7tmA_alpha1_AR', NULL, NULL, NULL, 2),
(6249, NULL, 'cd00237', NULL, NULL, 'p23', NULL, 'p23', NULL, NULL, NULL, 2),
(6250, NULL, 'cd16252', NULL, NULL, 'EFh_calglandulin_like', NULL, 'EFh_calglandulin_like', NULL, NULL, NULL, 2),
(6251, NULL, 'cd00578', NULL, NULL, 'L-fuc_L-ara-isomerases', NULL, 'L-fuc_L-ara-isomerases', NULL, NULL, NULL, 2),
(6252, NULL, 'cd10026', NULL, NULL, '14-3-3_plant', NULL, '14-3-3_plant', NULL, NULL, NULL, 2),
(6253, NULL, 'cd18972', NULL, NULL, 'CD_POL_like', NULL, 'CD_POL_like', NULL, NULL, NULL, 2),
(6254, NULL, 'cd06321', NULL, NULL, 'PBP1_ABC_sugar_binding-like', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, NULL, 2),
(6255, NULL, 'cd17149', NULL, NULL, 'DCX1_DCDC2', NULL, 'DCX1_DCDC2', NULL, NULL, NULL, 2),
(6256, NULL, 'cd06366', NULL, NULL, 'PBP1_GABAb_receptor', NULL, 'PBP1_GABAb_receptor', NULL, NULL, NULL, 2),
(6257, NULL, 'cd12279', NULL, NULL, 'RRM_TUT1', NULL, 'RRM_TUT1', NULL, NULL, 554, 2),
(6258, NULL, 'cd04054', NULL, NULL, 'C2A_Rasal1_RasA4', NULL, 'C2A_Rasal1_RasA4', NULL, NULL, NULL, 2),
(6259, NULL, 'cd06280', NULL, NULL, 'PBP1_LacI-like', NULL, 'PBP1_LacI-like', NULL, NULL, NULL, 2),
(6260, NULL, 'cd04084', NULL, NULL, 'CBM6_xylanase-like', NULL, 'CBM6_xylanase-like', NULL, NULL, NULL, 2),
(6261, NULL, 'cd19936', NULL, NULL, 'REC_OmpR_ChvI-like', NULL, 'REC_OmpR_ChvI-like', NULL, NULL, NULL, 2),
(6262, NULL, 'cd03730', NULL, NULL, 'SOCS_ASB14', NULL, 'SOCS_ASB14', NULL, NULL, NULL, 2);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(6263, NULL, 'cd00777', NULL, NULL, 'AspRS_core', NULL, 'AspRS_core', NULL, NULL, NULL, 2),
(6264, NULL, 'cd08587', NULL, NULL, 'PI-PLCXDc_like', NULL, 'PI-PLCXDc_like', NULL, NULL, NULL, 2),
(6265, NULL, 'cd09471', NULL, NULL, 'LIM2_Isl2', NULL, 'LIM2_Isl2', NULL, NULL, NULL, 2),
(6266, NULL, 'cd05760', NULL, NULL, 'Ig2_PTK7', NULL, 'Ig2_PTK7', NULL, NULL, NULL, 2),
(6267, NULL, 'cd04245', NULL, NULL, 'AAK_AKiii-YclM-BS', NULL, 'AAK_AKiii-YclM-BS', NULL, NULL, 33448, 2),
(6268, NULL, 'cd16244', NULL, NULL, 'EFh_DTN', NULL, 'EFh_DTN', NULL, NULL, NULL, 2),
(6269, NULL, 'cd19934', NULL, NULL, 'REC_OmpR_EcPhoP-like', NULL, 'REC_OmpR_EcPhoP-like', NULL, NULL, NULL, 2),
(6270, NULL, 'cd00508', NULL, NULL, 'MopB_CT_Fdh-Nap-like', NULL, 'MopB_CT_Fdh-Nap-like', NULL, NULL, NULL, 2),
(6271, NULL, 'cd05098', NULL, NULL, 'PTKc_FGFR1', NULL, 'PTKc_FGFR1', NULL, NULL, 21909, 2),
(6272, NULL, 'cd14361', NULL, NULL, 'UBA_HYPK', NULL, 'UBA_HYPK', NULL, NULL, 27286, 2),
(6273, NULL, 'cd14339', NULL, NULL, 'UBA_SNRK', NULL, 'UBA_SNRK', NULL, NULL, NULL, 2),
(6274, NULL, 'cd05324', NULL, NULL, 'carb_red_PTCR-like_SDR_c', NULL, 'carb_red_PTCR-like_SDR_c', NULL, NULL, 36231, 2),
(6275, NULL, 'cd16807', NULL, NULL, 'RING_CH-C4HC3_MARCH8', NULL, 'RING_CH-C4HC3_MARCH8', NULL, NULL, NULL, 2),
(6276, NULL, 'cd18053', NULL, NULL, 'DEXHc_CHD1', NULL, 'DEXHc_CHD1', NULL, NULL, NULL, 2),
(6277, NULL, 'cd17530', NULL, NULL, 'REC_RocR', NULL, 'REC_RocR', NULL, NULL, NULL, 2),
(6278, NULL, 'cd08185', NULL, NULL, 'Fe-ADH-like', NULL, 'Fe-ADH-like', NULL, NULL, NULL, 2),
(6279, NULL, 'cd13600', NULL, NULL, 'PBP2_lipoprotein_like_1', NULL, 'PBP2_lipoprotein_like_1', NULL, NULL, NULL, 2),
(6280, NULL, 'cd20003', NULL, NULL, 'PBP1_LsrB_Quorum_Sensing', NULL, 'PBP1_LsrB_Quorum_Sensing', NULL, NULL, 22618, 2),
(6281, NULL, 'cd14562', NULL, NULL, 'PTP_tensin-2', NULL, 'PTP_tensin-2', NULL, NULL, NULL, 2),
(6282, NULL, 'cd09840', NULL, NULL, 'LIM2_CRP2', NULL, 'LIM2_CRP2', NULL, NULL, NULL, 2),
(6283, NULL, 'cd17087', NULL, NULL, 'RAWUL_DRIP_like', NULL, 'RAWUL_DRIP_like', NULL, NULL, 34318, 2),
(6284, NULL, 'cd11901', NULL, NULL, 'SH3_Nck1_2', NULL, 'SH3_Nck1_2', NULL, NULL, 28373, 2),
(6285, NULL, 'cd18440', NULL, NULL, 'BRCT_PAXIP1_rpt6', NULL, 'BRCT_PAXIP1_rpt6', NULL, NULL, NULL, 2),
(6286, NULL, 'cd08594', NULL, NULL, 'PI-PLCc_eta', NULL, 'PI-PLCc_eta', NULL, NULL, NULL, 2),
(6287, NULL, 'cd01849', NULL, NULL, 'YlqF_related_GTPase', NULL, 'YlqF_related_GTPase', NULL, NULL, NULL, 2),
(6288, NULL, 'cd18261', NULL, NULL, 'BTB_POZ_KLHL32', NULL, 'BTB_POZ_KLHL32', NULL, NULL, NULL, 2),
(6289, NULL, 'cd05768', NULL, NULL, 'IgC_CH3_IgAGD_CH4_IgAEM', NULL, 'IgC_CH3_IgAGD_CH4_IgAEM', NULL, NULL, NULL, 2),
(6290, NULL, 'cd08711', NULL, NULL, 'RGS_RGS8', NULL, 'RGS_RGS8', NULL, NULL, 30861, 2),
(6291, NULL, 'cd09174', NULL, NULL, 'PLDc_Nuc_like_unchar2', NULL, 'PLDc_Nuc_like_unchar2', NULL, NULL, NULL, 2),
(6292, NULL, 'cd10036', NULL, NULL, 'Reelin_subrepeat_Nt', NULL, 'Reelin_subrepeat_Nt', NULL, NULL, NULL, 2),
(6293, NULL, 'cd14817', NULL, NULL, 'D-Ala-D-Ala_dipeptidase_VanX', NULL, 'D-Ala-D-Ala_dipeptidase_VanX', NULL, NULL, NULL, 2),
(6294, NULL, 'cd08064', NULL, NULL, 'MPN_eIF3f', NULL, 'MPN_eIF3f', NULL, NULL, 25172, 2),
(6295, NULL, 'cd19984', NULL, NULL, 'PBP1_ABC_ligand_binding-like', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, NULL, 2),
(6296, NULL, 'cd09993', NULL, NULL, 'HDAC_classIV', NULL, 'HDAC_classIV', NULL, NULL, 36333, 2),
(6297, NULL, 'cd00122', NULL, NULL, 'MBD', NULL, 'MBD', NULL, NULL, NULL, 2),
(6298, NULL, 'cd17138', NULL, NULL, 'RBD2_RGS12', NULL, 'RBD2_RGS12', NULL, NULL, NULL, 2),
(6299, NULL, 'cd09749', NULL, NULL, 'Cmr5_III-B', NULL, 'Cmr5_III-B', NULL, NULL, NULL, 2),
(6300, NULL, 'cd13898', NULL, NULL, 'CuRO_3_Abr2_like', NULL, 'CuRO_3_Abr2_like', NULL, NULL, NULL, 2),
(6301, NULL, 'cd08453', NULL, NULL, 'PBP2_IlvR', NULL, 'PBP2_IlvR', NULL, NULL, 30765, 2),
(6302, NULL, 'cd17235', NULL, NULL, 'Ubl_ATG8_MAP1LC3B', NULL, 'Ubl_ATG8_MAP1LC3B', NULL, NULL, NULL, 2),
(6303, NULL, 'cd02812', NULL, NULL, 'PcrB_like', NULL, 'PcrB_like', NULL, NULL, 7128, 2);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(6304, NULL, 'cd05877', NULL, NULL, 'Ig_LP_like', NULL, 'Ig_LP_like', NULL, NULL, NULL, 2),
(6305, NULL, 'cd06374', NULL, NULL, 'PBP1_mGluR_groupI', NULL, 'PBP1_mGluR_groupI', NULL, NULL, NULL, 2),
(6306, NULL, 'cd14963', NULL, NULL, 'NHL_like_5', NULL, 'NHL_like_5', NULL, NULL, NULL, 2),
(6307, NULL, 'cd16703', NULL, NULL, 'RING_CH-C4HC3_MARCH7_like', NULL, 'RING_CH-C4HC3_MARCH7_like', NULL, NULL, NULL, 2),
(6308, NULL, 'cd18762', NULL, NULL, 'PIN_MtVapC3-like', NULL, 'PIN_MtVapC3-like', NULL, NULL, NULL, 2),
(6309, NULL, 'cd00959', NULL, NULL, 'DeoC', NULL, 'DeoC', NULL, NULL, 8631, 2),
(6310, NULL, 'cd18630', NULL, NULL, 'CD_Rhino', NULL, 'CD_Rhino', NULL, NULL, NULL, 2),
(6311, NULL, 'cd04051', NULL, NULL, 'C2_SRC2_like', NULL, 'C2_SRC2_like', NULL, NULL, 34124, 2),
(6312, NULL, 'cd09409', NULL, NULL, 'LIM3_Paxillin', NULL, 'LIM3_Paxillin', NULL, NULL, NULL, 2),
(6313, NULL, 'cd16636', NULL, NULL, 'mRING-HC-C3HC3D_SCAF11', NULL, 'mRING-HC-C3HC3D_SCAF11', NULL, NULL, NULL, 2),
(6314, NULL, 'cd18526', NULL, NULL, 'BACK_ABTB2', NULL, 'BACK_ABTB2', NULL, NULL, NULL, 2),
(6315, NULL, 'cd11607', NULL, NULL, 'DENR_C', NULL, 'DENR_C', NULL, NULL, 33618, 2),
(6316, NULL, 'cd12178', NULL, NULL, '2-Hacid_dh_13', NULL, '2-Hacid_dh_13', NULL, NULL, NULL, 2),
(6317, NULL, 'cd04331', NULL, NULL, 'RNAP_E_N', NULL, 'RNAP_E_N', NULL, NULL, NULL, 2),
(6318, NULL, 'cd16768', NULL, NULL, 'RING-HC_TRIM3', NULL, 'RING-HC_TRIM3', NULL, NULL, NULL, 2),
(6319, NULL, 'cd19957', NULL, NULL, 'serpinA', NULL, 'serpinA', NULL, NULL, NULL, 2),
(6320, NULL, 'cd21516', NULL, NULL, 'cv_beta_Nsp2_SARS-like', NULL, 'cv_beta_Nsp2_SARS-like', NULL, NULL, 35560, 2),
(6321, NULL, 'cd12082', NULL, NULL, 'MATE_like', NULL, 'MATE_like', NULL, NULL, NULL, 2),
(6322, NULL, 'cd16352', NULL, NULL, 'CheD', NULL, 'CheD', NULL, NULL, 3505, 2),
(6323, NULL, 'cd03039', NULL, NULL, 'GST_N_Sigma_like', NULL, 'GST_N_Sigma_like', NULL, NULL, NULL, 2),
(6324, NULL, 'cd16824', NULL, NULL, 'RING_CH-C4HC3_MARCH4', NULL, 'RING_CH-C4HC3_MARCH4', NULL, NULL, NULL, 2),
(6325, NULL, 'cd15853', NULL, NULL, 'SNARE_Bet1', NULL, 'SNARE_Bet1', NULL, NULL, 33336, 2),
(6326, NULL, 'cd15057', NULL, NULL, '7tmA_D1-like_dopamine_R', NULL, '7tmA_D1-like_dopamine_R', NULL, NULL, NULL, 2),
(6327, NULL, 'cd16347', NULL, NULL, 'VOC_like', NULL, 'VOC_like', NULL, NULL, NULL, 2),
(6328, NULL, 'cd16884', NULL, NULL, 'ARID_ARID5A', NULL, 'ARID_ARID5A', NULL, NULL, NULL, 2),
(6329, NULL, 'cd18023', NULL, NULL, 'DEXHc_HFM1', NULL, 'DEXHc_HFM1', NULL, NULL, NULL, 2),
(6330, NULL, 'cd14684', NULL, NULL, 'RanBD1_RanBP2-like', NULL, 'RanBD1_RanBP2-like', NULL, NULL, NULL, 2),
(6331, NULL, 'cd08551', NULL, NULL, 'Fe-ADH', NULL, 'Fe-ADH', NULL, NULL, NULL, 2),
(6332, NULL, 'cd13151', NULL, NULL, 'DAXX_helical_bundle', NULL, 'DAXX_helical_bundle', NULL, NULL, 21695, 2),
(6333, NULL, 'cd21627', NULL, NULL, 'batCoV-HKU9-like_Spike_S1_NTD', NULL, 'batCoV-HKU9-like_Spike_S1_NTD', NULL, NULL, 33592, 2),
(6334, NULL, 'cd15316', NULL, NULL, '7tmA_TAAR6_8_9', NULL, '7tmA_TAAR6_8_9', NULL, NULL, NULL, 2),
(6335, NULL, 'cd04012', NULL, NULL, 'C2A_PI3K_class_II', NULL, 'C2A_PI3K_class_II', NULL, NULL, NULL, 2),
(6336, NULL, 'cd14658', NULL, NULL, 'Imelysin-like_IrpA', NULL, 'Imelysin-like_IrpA', NULL, NULL, 18980, 2),
(6337, NULL, 'cd05691', NULL, NULL, 'S1_RPS1_repeat_ec6', NULL, 'S1_RPS1_repeat_ec6', NULL, NULL, NULL, 2),
(6338, NULL, 'cd00256', NULL, NULL, 'VATPase_H', NULL, 'VATPase_H', NULL, NULL, NULL, 2),
(6339, NULL, 'cd03429', NULL, NULL, 'NADH_pyrophosphatase', NULL, 'NADH_pyrophosphatase', NULL, NULL, NULL, 2),
(6340, NULL, 'cd05972', NULL, NULL, 'MACS_like', NULL, 'MACS_like', NULL, NULL, NULL, 2),
(6341, NULL, 'cd16900', NULL, NULL, 'endolysin_R21-like', NULL, 'endolysin_R21-like', NULL, NULL, NULL, 2),
(6342, NULL, 'cd12396', NULL, NULL, 'RRM1_Nop13p_fungi', NULL, 'RRM1_Nop13p_fungi', NULL, NULL, 30741, 2),
(6343, NULL, 'cd20311', NULL, NULL, 'cupin_Yhhw_C', NULL, 'cupin_Yhhw_C', NULL, NULL, NULL, 2),
(6344, NULL, 'cd01300', NULL, NULL, 'YtcJ_like', NULL, 'YtcJ_like', NULL, NULL, 27846, 2);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(6345, NULL, 'cd15151', NULL, NULL, '7tmA_P2Y13', NULL, '7tmA_P2Y13', NULL, NULL, NULL, 2),
(6346, NULL, 'cd19864', NULL, NULL, 'DSRM_PRKRA-like_rpt3', NULL, 'DSRM_PRKRA-like_rpt3', NULL, NULL, NULL, 2),
(6347, NULL, 'cd16748', NULL, NULL, 'RING-HC_SH3RF1', NULL, 'RING-HC_SH3RF1', NULL, NULL, NULL, 2),
(6348, NULL, 'cd01793', NULL, NULL, 'Ubl_FUBI', NULL, 'Ubl_FUBI', NULL, NULL, 27176, 2),
(6349, NULL, 'cd00169', NULL, NULL, 'Chemokine', NULL, 'Chemokine', NULL, NULL, NULL, 2),
(6350, NULL, 'cd03215', NULL, NULL, 'ABC_Carb_Monos_II', NULL, 'ABC_Carb_Monos_II', NULL, NULL, NULL, 2),
(6351, NULL, 'cd04219', NULL, NULL, 'Plastocyanin', NULL, 'Plastocyanin', NULL, NULL, 6187, 2),
(6352, NULL, 'cd07077', NULL, NULL, 'ALDH-like', NULL, 'ALDH-like', NULL, NULL, NULL, 2),
(6353, NULL, 'cd13318', NULL, NULL, 'PH_IQSEC', NULL, 'PH_IQSEC', NULL, NULL, 31697, 2),
(6354, NULL, 'cd14187', NULL, NULL, 'STKc_PLK1', NULL, 'STKc_PLK1', NULL, NULL, 28246, 2),
(6355, NULL, 'cd16509', NULL, NULL, 'RING-HC_HLTF', NULL, 'RING-HC_HLTF', NULL, NULL, NULL, 2),
(6356, NULL, 'cd07363', NULL, NULL, '45_DOPA_Dioxygenase', NULL, '45_DOPA_Dioxygenase', NULL, NULL, 7842, 2),
(6357, NULL, 'cd07411', NULL, NULL, 'MPP_SoxB_N', NULL, 'MPP_SoxB_N', NULL, NULL, 30900, 2),
(6358, NULL, 'cd03484', NULL, NULL, 'MutL_Trans_hPMS_2_like', NULL, 'MutL_Trans_hPMS_2_like', NULL, NULL, NULL, 2),
(6359, NULL, 'cd18208', NULL, NULL, 'BTB_POZ_ZBTB20_DPZF', NULL, 'BTB_POZ_ZBTB20_DPZF', NULL, NULL, NULL, 2),
(6360, NULL, 'cd00453', NULL, NULL, 'FTBP_aldolase_II', NULL, 'FTBP_aldolase_II', NULL, NULL, NULL, 2),
(6361, NULL, 'cd14959', NULL, NULL, 'NHL_brat_like', NULL, 'NHL_brat_like', NULL, NULL, NULL, 2),
(6362, NULL, 'cd05690', NULL, NULL, 'S1_RPS1_repeat_ec5', NULL, 'S1_RPS1_repeat_ec5', NULL, NULL, NULL, 2),
(6363, NULL, 'cd07957', NULL, NULL, 'Anticodon_Ia_Met', NULL, 'Anticodon_Ia_Met', NULL, NULL, 30693, 2),
(6364, NULL, 'cd11308', NULL, NULL, 'Peptidase_M14NE-CP-C_like', NULL, 'Peptidase_M14NE-CP-C_like', NULL, NULL, NULL, 2),
(6365, NULL, 'cd15310', NULL, NULL, '7tmA_D3_dopamine_R', NULL, '7tmA_D3_dopamine_R', NULL, NULL, NULL, 2),
(6366, NULL, 'cd14767', NULL, NULL, 'PE_beta-like', NULL, 'PE_beta-like', NULL, NULL, NULL, 2),
(6367, NULL, 'cd15224', NULL, NULL, '7tmA_OR6B-like', NULL, '7tmA_OR6B-like', NULL, NULL, NULL, 2),
(6368, NULL, 'cd08265', NULL, NULL, 'Zn_ADH3', NULL, 'Zn_ADH3', NULL, NULL, NULL, 2),
(6369, NULL, 'cd08919', NULL, NULL, 'PBP-like', NULL, 'PBP-like', NULL, NULL, NULL, 2),
(6370, NULL, 'cd18724', NULL, NULL, 'PIN_LabA-like', NULL, 'PIN_LabA-like', NULL, NULL, NULL, 2),
(6371, NULL, 'cd19054', NULL, NULL, 'LGIC_TM_GABAAR_gamma', NULL, 'LGIC_TM_GABAAR_gamma', NULL, NULL, NULL, 2),
(6372, NULL, 'cd08616', NULL, NULL, 'PI-PLCXD1c', NULL, 'PI-PLCXD1c', NULL, NULL, 35457, 2),
(6373, NULL, 'cd15577', NULL, NULL, 'PHD_JMJD2C', NULL, 'PHD_JMJD2C', NULL, NULL, NULL, 2),
(6374, NULL, 'cd06661', NULL, NULL, 'GGCT_like', NULL, 'GGCT_like', NULL, NULL, 13973, 2),
(6375, NULL, 'cd00562', NULL, NULL, 'NifX_NifB', NULL, 'NifX_NifB', NULL, NULL, NULL, 2),
(6376, NULL, 'cd04199', NULL, NULL, 'CuRO_1_ceruloplasmin_like', NULL, 'CuRO_1_ceruloplasmin_like', NULL, NULL, NULL, 2),
(6377, NULL, 'cd13752', NULL, NULL, 'TGF_beta_INHB', NULL, 'TGF_beta_INHB', NULL, NULL, NULL, 2),
(6378, NULL, 'cd09502', NULL, NULL, 'SAM_SARM1-like_repeat2', NULL, 'SAM_SARM1-like_repeat2', NULL, NULL, NULL, 2),
(6379, NULL, 'cd07829', NULL, NULL, 'STKc_CDK_like', NULL, 'STKc_CDK_like', NULL, NULL, NULL, 2),
(6380, NULL, 'cd10451', NULL, NULL, 'GIY-YIG_LuxR_like', NULL, 'GIY-YIG_LuxR_like', NULL, NULL, NULL, 2),
(6381, NULL, 'cd03212', NULL, NULL, 'GST_C_Metaxin1_3', NULL, 'GST_C_Metaxin1_3', NULL, NULL, NULL, 2),
(6382, NULL, 'cd00933', NULL, NULL, 'barnase', NULL, 'barnase', NULL, NULL, 4247, 2),
(6383, NULL, 'cd10449', NULL, NULL, 'GIY-YIG_SLX1_like', NULL, 'GIY-YIG_SLX1_like', NULL, NULL, NULL, 2),
(6384, NULL, 'cd08649', NULL, NULL, 'FMT_core_NRPS_like', NULL, 'FMT_core_NRPS_like', NULL, NULL, NULL, 2),
(6385, NULL, 'cd16584', NULL, NULL, 'RING-HC_TRIM56_C-V', NULL, 'RING-HC_TRIM56_C-V', NULL, NULL, NULL, 2);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(6386, NULL, 'cd08345', NULL, NULL, 'Fosfomycin_RP', NULL, 'Fosfomycin_RP', NULL, NULL, NULL, 2),
(6387, NULL, 'cd14949', NULL, NULL, 'Asparaginase_2_like_3', NULL, 'Asparaginase_2_like_3', NULL, NULL, NULL, 2),
(6388, NULL, 'cd18105', NULL, NULL, 'SpoU-like_MRM1', NULL, 'SpoU-like_MRM1', NULL, NULL, NULL, 2),
(6389, NULL, 'cd09722', NULL, NULL, 'Cas1_I-B', NULL, 'Cas1_I-B', NULL, NULL, 14711, 2),
(6390, NULL, 'cd12894', NULL, NULL, 'SPRY_PRY_TRIM36', NULL, 'SPRY_PRY_TRIM36', NULL, NULL, 27819, 2),
(6391, NULL, 'cd02153', NULL, NULL, 'tRNA_bindingDomain', NULL, 'tRNA_bindingDomain', NULL, NULL, NULL, 2),
(6392, NULL, 'cd05787', NULL, NULL, 'LbH_eIF2B_epsilon', NULL, 'LbH_eIF2B_epsilon', NULL, NULL, NULL, 2),
(6393, NULL, 'cd09169', NULL, NULL, 'PLDc_PPK1_C2_unchar', NULL, 'PLDc_PPK1_C2_unchar', NULL, NULL, NULL, 2),
(6394, NULL, 'cd05114', NULL, NULL, 'PTKc_Tec_Rlk', NULL, 'PTKc_Tec_Rlk', NULL, NULL, NULL, 2),
(6395, NULL, 'cd01048', NULL, NULL, 'Ferritin_like_AB2', NULL, 'Ferritin_like_AB2', NULL, NULL, 19575, 2),
(6396, NULL, 'cd08406', NULL, NULL, 'C2B_Synaptotagmin-12', NULL, 'C2B_Synaptotagmin-12', NULL, NULL, NULL, 2),
(6397, NULL, 'cd12342', NULL, NULL, 'RRM_Nab3p', NULL, 'RRM_Nab3p', NULL, NULL, 3172, 2),
(6398, NULL, 'cd19996', NULL, NULL, 'PBP1_ABC_sugar_binding-like', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, NULL, 2),
(6399, NULL, 'cd09615', NULL, NULL, 'Jacalin_EEP', NULL, 'Jacalin_EEP', NULL, NULL, NULL, 2),
(6400, NULL, 'cd11747', NULL, NULL, 'GH94N_like_1', NULL, 'GH94N_like_1', NULL, NULL, NULL, 2),
(6401, NULL, 'cd14913', NULL, NULL, 'MYSc_Myh3', NULL, 'MYSc_Myh3', NULL, NULL, 30224, 2),
(6402, NULL, 'cd02172', NULL, NULL, 'RfaE_N', NULL, 'RfaE_N', NULL, NULL, NULL, 2),
(6403, NULL, 'cd15312', NULL, NULL, '7tmA_TAAR2_3_4', NULL, '7tmA_TAAR2_3_4', NULL, NULL, NULL, 2),
(6404, NULL, 'cd05141', NULL, NULL, 'Barstar_evA4336-like', NULL, 'Barstar_evA4336-like', NULL, NULL, NULL, 2),
(6405, NULL, 'cd09432', NULL, NULL, 'LIM6_LIMPETin', NULL, 'LIM6_LIMPETin', NULL, NULL, NULL, 2),
(6406, NULL, 'cd09970', NULL, NULL, 'UP_IIIa', NULL, 'UP_IIIa', NULL, NULL, NULL, 2),
(6407, NULL, 'cd13311', NULL, NULL, 'PH_Slm1', NULL, 'PH_Slm1', NULL, NULL, 35464, 2),
(6408, NULL, 'cd13428', NULL, NULL, 'UreI_AmiS', NULL, 'UreI_AmiS', NULL, NULL, NULL, 2),
(6409, NULL, 'cd12923', NULL, NULL, 'iSH2_PI3K_IA_R', NULL, 'iSH2_PI3K_IA_R', NULL, NULL, NULL, 2),
(6410, NULL, 'cd00181', NULL, NULL, 'Tar_Tsr_LBD', NULL, 'Tar_Tsr_LBD', NULL, NULL, 2649, 2),
(6411, NULL, 'cd12243', NULL, NULL, 'RRM1_MSSP', NULL, 'RRM1_MSSP', NULL, NULL, NULL, 2),
(6412, NULL, 'cd10544', NULL, NULL, 'SET_SETMAR', NULL, 'SET_SETMAR', NULL, NULL, NULL, 2),
(6413, NULL, 'cd15774', NULL, NULL, 'FYVE1_PCLO', NULL, 'FYVE1_PCLO', NULL, NULL, 36964, 2),
(6414, NULL, 'cd18457', NULL, NULL, 'BACK_KLHL18', NULL, 'BACK_KLHL18', NULL, NULL, NULL, 2),
(6415, NULL, 'cd12270', NULL, NULL, 'RRM_MTHFSD', NULL, 'RRM_MTHFSD', NULL, NULL, 1072, 2),
(6416, NULL, 'cd04679', NULL, NULL, 'Nudix_Hydrolase_20', NULL, 'Nudix_Hydrolase_20', NULL, NULL, NULL, 2),
(6417, NULL, 'cd09986', NULL, NULL, 'LOTUS_1_TDRD7', NULL, 'LOTUS_1_TDRD7', NULL, NULL, NULL, 2),
(6418, NULL, 'cd09998', NULL, NULL, 'HDAC_Hos3', NULL, 'HDAC_Hos3', NULL, NULL, NULL, 2),
(6419, NULL, 'cd15689', NULL, NULL, 'PHD1_MORF', NULL, 'PHD1_MORF', NULL, NULL, NULL, 2),
(6420, NULL, 'cd01134', NULL, NULL, 'V_A-ATPase_A', NULL, 'V_A-ATPase_A', NULL, NULL, NULL, 2),
(6421, NULL, 'cd13651', NULL, NULL, 'PBP2_ThiY', NULL, 'PBP2_ThiY', NULL, NULL, NULL, 2),
(6422, NULL, 'cd14255', NULL, NULL, 'Dockerin_III', NULL, 'Dockerin_III', NULL, NULL, NULL, 2),
(6423, NULL, 'cd10559', NULL, NULL, 'W-FDH', NULL, 'W-FDH', NULL, NULL, NULL, 2),
(6424, NULL, 'cd16775', NULL, NULL, 'RING-HC_RBR_RNF19A', NULL, 'RING-HC_RBR_RNF19A', NULL, NULL, NULL, 2),
(6425, NULL, 'cd03085', NULL, NULL, 'PGM1', NULL, 'PGM1', NULL, NULL, NULL, 2),
(6426, NULL, 'cd08267', NULL, NULL, 'MDR1', NULL, 'MDR1', NULL, NULL, NULL, 2),
(6427, NULL, 'cd00245', NULL, NULL, 'Glm_e', NULL, 'Glm_e', NULL, NULL, 5556, 2),
(6428, NULL, 'cd12826', NULL, NULL, 'EcCorA_ZntB-like_u1', NULL, 'EcCorA_ZntB-like_u1', NULL, NULL, NULL, 2);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(6429, NULL, 'cd15052', NULL, NULL, '7tmA_5-HT2', NULL, '7tmA_5-HT2', NULL, NULL, NULL, 2),
(6430, NULL, 'cd16518', NULL, NULL, 'RING-HC_MEX3', NULL, 'RING-HC_MEX3', NULL, NULL, NULL, 2),
(6431, NULL, 'cd21646', NULL, NULL, 'CoV_Nsp5_Mpro', NULL, 'CoV_Nsp5_Mpro', NULL, NULL, NULL, 2),
(6432, NULL, 'cd01047', NULL, NULL, 'ACSF', NULL, 'ACSF', NULL, NULL, 8937, 2),
(6433, NULL, 'cd16660', NULL, NULL, 'RING-Ubox_RNF37', NULL, 'RING-Ubox_RNF37', NULL, NULL, 33294, 2),
(6434, NULL, 'cd18732', NULL, NULL, 'PIN_MtVapC4-C5_like', NULL, 'PIN_MtVapC4-C5_like', NULL, NULL, NULL, 2),
(6435, NULL, 'cd02889', NULL, NULL, 'SQCY', NULL, 'SQCY', NULL, NULL, NULL, 2),
(6436, NULL, 'cd02991', NULL, NULL, 'UAS_ETEA', NULL, 'UAS_ETEA', NULL, NULL, NULL, 2),
(6437, NULL, 'cd19451', NULL, NULL, 'lipocalin_AGP-like', NULL, 'lipocalin_AGP-like', NULL, NULL, NULL, 2),
(6438, NULL, 'cd01874', NULL, NULL, 'Cdc42', NULL, 'Cdc42', NULL, NULL, 27193, 2),
(6439, NULL, 'cd13175', NULL, NULL, 'RanBD5_RanBP2_insect-like', NULL, 'RanBD5_RanBP2_insect-like', NULL, NULL, NULL, 2),
(6440, NULL, 'cd05199', NULL, NULL, 'SDH_like', NULL, 'SDH_like', NULL, NULL, NULL, 2),
(6441, NULL, 'cd13380', NULL, NULL, 'PH_Skap1', NULL, 'PH_Skap1', NULL, NULL, NULL, 2),
(6442, NULL, 'cd14285', NULL, NULL, 'UBA_scEDE1_like', NULL, 'UBA_scEDE1_like', NULL, NULL, NULL, 2),
(6443, NULL, 'cd11788', NULL, NULL, 'SH3_RasGAP', NULL, 'SH3_RasGAP', NULL, NULL, 27172, 2),
(6444, NULL, 'cd12400', NULL, NULL, 'RRM_Nop6', NULL, 'RRM_Nop6', NULL, NULL, 30706, 2),
(6445, NULL, 'cd10355', NULL, NULL, 'SH2_DAPP1_BAM32_like', NULL, 'SH2_DAPP1_BAM32_like', NULL, NULL, 32026, 2),
(6446, NULL, 'cd12781', NULL, NULL, 'RRM1_hnRPLL', NULL, 'RRM1_hnRPLL', NULL, NULL, 18527, 2),
(6447, NULL, 'cd17437', NULL, NULL, 'MFS_PLT', NULL, 'MFS_PLT', NULL, NULL, 34540, 2),
(6448, NULL, 'cd17430', NULL, NULL, 'MFS_MCT3_4', NULL, 'MFS_MCT3_4', NULL, NULL, NULL, 2),
(6449, NULL, 'cd03557', NULL, NULL, 'L-arabinose_isomerase', NULL, 'L-arabinose_isomerase', NULL, NULL, NULL, 2),
(6450, NULL, 'cd08900', NULL, NULL, 'SRPBCC_CalC_Aha1-like_7', NULL, 'SRPBCC_CalC_Aha1-like_7', NULL, NULL, NULL, 2),
(6451, NULL, 'cd09637', NULL, NULL, 'Cas4_I-A_I-B_I-C_I-D_II-B', NULL, 'Cas4_I-A_I-B_I-C_I-D_II-B', NULL, NULL, NULL, 2),
(6452, NULL, 'cd07609', NULL, NULL, 'BAR_SIP3_fungi', NULL, 'BAR_SIP3_fungi', NULL, NULL, 31020, 2),
(6453, NULL, 'cd03578', NULL, NULL, 'NTR_netrin-4_like', NULL, 'NTR_netrin-4_like', NULL, NULL, 28901, 2),
(6454, NULL, 'cd11599', NULL, NULL, 'HDAC_classII_2', NULL, 'HDAC_classII_2', NULL, NULL, NULL, 2),
(6455, NULL, 'cd16713', NULL, NULL, 'RING-HC_BIRC2_3_7', NULL, 'RING-HC_BIRC2_3_7', NULL, NULL, NULL, 2),
(6456, NULL, 'cd12583', NULL, NULL, 'RRM2_hnRNPD', NULL, 'RRM2_hnRNPD', NULL, NULL, NULL, 2),
(6457, NULL, 'cd01786', NULL, NULL, 'RA_STE50', NULL, 'RA_STE50', NULL, NULL, NULL, 2),
(6458, NULL, 'cd13342', NULL, NULL, 'PH-GRAM_MTMR4', NULL, 'PH-GRAM_MTMR4', NULL, NULL, 28439, 2),
(6459, NULL, 'cd05838', NULL, NULL, 'WHSC1_related', NULL, 'WHSC1_related', NULL, NULL, NULL, 2),
(6460, NULL, 'cd06549', NULL, NULL, 'GH18_trifunctional', NULL, 'GH18_trifunctional', NULL, NULL, NULL, 2),
(6461, NULL, 'cd07241', NULL, NULL, 'VOC_BsYyaH', NULL, 'VOC_BsYyaH', NULL, NULL, NULL, 2),
(6462, NULL, 'cd15858', NULL, NULL, 'SNARE_VAM7', NULL, 'SNARE_VAM7', NULL, NULL, NULL, 2),
(6463, NULL, 'cd21518', NULL, NULL, 'cv_beta_Nsp2_HKU9-like', NULL, 'cv_beta_Nsp2_HKU9-like', NULL, NULL, 36356, 2),
(6464, NULL, 'cd16503', NULL, NULL, 'RING-HC_CHFR', NULL, 'RING-HC_CHFR', NULL, NULL, NULL, 2),
(6465, NULL, 'cd14627', NULL, NULL, 'R-PTP-S-2', NULL, 'R-PTP-S-2', NULL, NULL, NULL, 2),
(6466, NULL, 'cd12623', NULL, NULL, 'RRM_PPARGC1A', NULL, 'RRM_PPARGC1A', NULL, NULL, 33111, 2),
(6467, NULL, 'cd00291', NULL, NULL, 'SirA_YedF_YeeD', NULL, 'SirA_YedF_YeeD', NULL, NULL, NULL, 2),
(6468, NULL, 'cd00958', NULL, NULL, 'DhnA', NULL, 'DhnA', NULL, NULL, 29842, 2),
(6469, NULL, 'cd01734', NULL, NULL, 'YlxS_C', NULL, 'YlxS_C', NULL, NULL, 23500, 2),
(6470, NULL, 'cd10788', NULL, NULL, 'YdjC_like', NULL, 'YdjC_like', NULL, NULL, NULL, 2);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(6471, NULL, 'cd09400', NULL, NULL, 'LIM_like_1', NULL, 'LIM_like_1', NULL, NULL, NULL, 2),
(6472, NULL, 'cd04380', NULL, NULL, 'RhoGAP_OCRL1', NULL, 'RhoGAP_OCRL1', NULL, NULL, NULL, 2),
(6473, NULL, 'cd19182', NULL, NULL, 'SET_KMT2E', NULL, 'SET_KMT2E', NULL, NULL, 35340, 2),
(6474, NULL, 'cd19454', NULL, NULL, 'lipocalin_NP3', NULL, 'lipocalin_NP3', NULL, NULL, NULL, 2),
(6475, NULL, 'cd05339', NULL, NULL, '17beta-HSDXI-like_SDR_c', NULL, '17beta-HSDXI-like_SDR_c', NULL, NULL, NULL, 2),
(6476, NULL, 'cd12603', NULL, NULL, 'RRM_hnRNPC', NULL, 'RRM_hnRNPC', NULL, NULL, NULL, 2),
(6477, NULL, 'cd10480', NULL, NULL, 'EphR_LBD_A2', NULL, 'EphR_LBD_A2', NULL, NULL, 20643, 2),
(6478, NULL, 'cd11018', NULL, NULL, 'CuRO_6_FVIII_like', NULL, 'CuRO_6_FVIII_like', NULL, NULL, NULL, 2),
(6479, NULL, 'cd05066', NULL, NULL, 'PTKc_EphR_A', NULL, 'PTKc_EphR_A', NULL, NULL, NULL, 2),
(6480, NULL, 'cd19167', NULL, NULL, 'SET_SMYD1_2_3-like', NULL, 'SET_SMYD1_2_3-like', NULL, NULL, NULL, 2),
(6481, NULL, 'cd14578', NULL, NULL, 'DUSP26', NULL, 'DUSP26', NULL, NULL, NULL, 2),
(6482, NULL, 'cd10155', NULL, NULL, 'BsYrkD-like_DUF156', NULL, 'BsYrkD-like_DUF156', NULL, NULL, NULL, 2),
(6483, NULL, 'cd16415', NULL, NULL, 'HAD_dREG-2_like', NULL, 'HAD_dREG-2_like', NULL, NULL, NULL, 2),
(6484, NULL, 'cd17746', NULL, NULL, 'BRCT_Rad4_rpt2', NULL, 'BRCT_Rad4_rpt2', NULL, NULL, NULL, 2),
(6485, NULL, 'cd09440', NULL, NULL, 'LIM1_SF3', NULL, 'LIM1_SF3', NULL, NULL, NULL, 2),
(6486, NULL, 'cd07110', NULL, NULL, 'ALDH_F10_BADH', NULL, 'ALDH_F10_BADH', NULL, NULL, NULL, 2),
(6487, NULL, 'cd06934', NULL, NULL, 'NR_LBD_PXR_like', NULL, 'NR_LBD_PXR_like', NULL, NULL, NULL, 2),
(6488, NULL, 'cd01861', NULL, NULL, 'Rab6', NULL, 'Rab6', NULL, NULL, NULL, 2),
(6489, NULL, 'cd14856', NULL, NULL, 'TRAPPC4_synbindin', NULL, 'TRAPPC4_synbindin', NULL, NULL, NULL, 2),
(6490, NULL, 'cd09217', NULL, NULL, 'TLP-P', NULL, 'TLP-P', NULL, NULL, NULL, 2),
(6491, NULL, 'cd13559', NULL, NULL, 'PBP2_SsuA_like_3', NULL, 'PBP2_SsuA_like_3', NULL, NULL, NULL, 2),
(6492, NULL, 'cd00001', NULL, NULL, 'PTS_IIB_man', NULL, 'PTS_IIB_man', NULL, NULL, 3329, 2),
(6493, NULL, 'cd08236', NULL, NULL, 'sugar_DH', NULL, 'sugar_DH', NULL, NULL, NULL, 2),
(6494, NULL, 'cd11485', NULL, NULL, 'SLC-NCS1sbd_YbbW-like', NULL, 'SLC-NCS1sbd_YbbW-like', NULL, NULL, NULL, 2),
(6495, NULL, 'cd12193', NULL, NULL, 'bZIP_GCN4', NULL, 'bZIP_GCN4', NULL, NULL, NULL, 2),
(6496, NULL, 'cd06984', NULL, NULL, 'cupin_Moth_1897', NULL, 'cupin_Moth_1897', NULL, NULL, NULL, 2),
(6497, NULL, 'cd08722', NULL, NULL, 'RGS_SNX14', NULL, 'RGS_SNX14', NULL, NULL, 27204, 2),
(6498, NULL, 'cd14561', NULL, NULL, 'PTP_tensin-3', NULL, 'PTP_tensin-3', NULL, NULL, NULL, 2),
(6499, NULL, 'cd14098', NULL, NULL, 'STKc_Rad53_Cds1', NULL, 'STKc_Rad53_Cds1', NULL, NULL, NULL, 2),
(6500, NULL, 'cd11592', NULL, NULL, 'Agmatinase_PAH', NULL, 'Agmatinase_PAH', NULL, NULL, NULL, 2),
(6501, NULL, 'cd07461', NULL, NULL, 'CRD_FZ8', NULL, 'CRD_FZ8', NULL, NULL, 30561, 2),
(6502, NULL, 'cd12578', NULL, NULL, 'RRM1_hnRNPA_like', NULL, 'RRM1_hnRNPA_like', NULL, NULL, NULL, 2),
(6503, NULL, 'cd05373', NULL, NULL, 'SDR_c10', NULL, 'SDR_c10', NULL, NULL, NULL, 2),
(6504, NULL, 'cd13389', NULL, NULL, 'PH1_FGD5_FGD6', NULL, 'PH1_FGD5_FGD6', NULL, NULL, NULL, 2),
(6505, NULL, 'cd00820', NULL, NULL, 'PEPCK_HprK', NULL, 'PEPCK_HprK', NULL, NULL, NULL, 2),
(6506, NULL, 'cd11613', NULL, NULL, 'SAF_AH_GD', NULL, 'SAF_AH_GD', NULL, NULL, 35438, 2),
(6507, NULL, 'cd14233', NULL, NULL, 'GAT_TOM1_like', NULL, 'GAT_TOM1_like', NULL, NULL, NULL, 2),
(6508, NULL, 'cd00686', NULL, NULL, 'Terpene_cyclase_cis_trans_C1', NULL, 'Terpene_cyclase_cis_trans_C1', NULL, NULL, NULL, 2),
(6509, NULL, 'cd10560', NULL, NULL, 'FDH-O_like', NULL, 'FDH-O_like', NULL, NULL, NULL, 2),
(6510, NULL, 'cd08381', NULL, NULL, 'C2B_PI3K_class_II', NULL, 'C2B_PI3K_class_II', NULL, NULL, NULL, 2),
(6511, NULL, 'cd14109', NULL, NULL, 'PK_Unc-89_rpt1', NULL, 'PK_Unc-89_rpt1', NULL, NULL, NULL, 2),
(6512, NULL, 'cd00052', NULL, NULL, 'EH', NULL, 'EH', NULL, NULL, 1264, 2);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(6513, NULL, 'cd06493', NULL, NULL, 'p23_NUDCD1_like', NULL, 'p23_NUDCD1_like', NULL, NULL, NULL, 2),
(6514, NULL, 'cd11656', NULL, NULL, 'FBX4_GTPase_like', NULL, 'FBX4_GTPase_like', NULL, NULL, NULL, 2),
(6515, NULL, 'cd10341', NULL, NULL, 'SH2_N-SH2_PLC_gamma_like', NULL, 'SH2_N-SH2_PLC_gamma_like', NULL, NULL, 20960, 2),
(6516, NULL, 'cd11920', NULL, NULL, 'SH3_Sorbs2_1', NULL, 'SH3_Sorbs2_1', NULL, NULL, NULL, 2),
(6517, NULL, 'cd19202', NULL, NULL, 'SET_SMYD2', NULL, 'SET_SMYD2', NULL, NULL, 35443, 2),
(6518, NULL, 'cd03872', NULL, NULL, 'M14_CPA6', NULL, 'M14_CPA6', NULL, NULL, 29347, 2),
(6519, NULL, 'cd14526', NULL, NULL, 'DSP_laforin-like', NULL, 'DSP_laforin-like', NULL, NULL, 36372, 2),
(6520, NULL, 'cd08019', NULL, NULL, 'M20_Acy1-like', NULL, 'M20_Acy1-like', NULL, NULL, NULL, 2),
(6521, NULL, 'cd10349', NULL, NULL, 'SH2_SH2D2A_SH2D7', NULL, 'SH2_SH2D2A_SH2D7', NULL, NULL, NULL, 2),
(6522, NULL, 'cd07380', NULL, NULL, 'MPP_CWF19_N', NULL, 'MPP_CWF19_N', NULL, NULL, NULL, 2),
(6523, NULL, 'cd04763', NULL, NULL, 'HTH_MlrA-like', NULL, 'HTH_MlrA-like', NULL, NULL, NULL, 2),
(6524, NULL, 'cd03065', NULL, NULL, 'PDI_b_Calsequestrin_N', NULL, 'PDI_b_Calsequestrin_N', NULL, NULL, 30745, 2),
(6525, NULL, 'cd10922', NULL, NULL, 'CE4_PelA_like_C', NULL, 'CE4_PelA_like_C', NULL, NULL, NULL, 2),
(6526, NULL, 'cd05740', NULL, NULL, 'Ig_CEACAM', NULL, 'Ig_CEACAM', NULL, NULL, NULL, 2),
(6527, NULL, 'cd16457', NULL, NULL, 'RING-H2_BRAP2', NULL, 'RING-H2_BRAP2', NULL, NULL, NULL, 2),
(6528, NULL, 'cd18648', NULL, NULL, 'CD_Cbx6', NULL, 'CD_Cbx6', NULL, NULL, NULL, 2),
(6529, NULL, 'cd19337', NULL, NULL, 'Wnt_Wnt5', NULL, 'Wnt_Wnt5', NULL, NULL, NULL, 2),
(6530, NULL, 'cd06089', NULL, NULL, 'KOW_RPL26', NULL, 'KOW_RPL26', NULL, NULL, 30238, 2),
(6531, NULL, 'cd16480', NULL, NULL, 'RING-H2_TRAIP', NULL, 'RING-H2_TRAIP', NULL, NULL, NULL, 2),
(6532, NULL, 'cd16437', NULL, NULL, 'beta_Kdo_transferase_KpsC', NULL, 'beta_Kdo_transferase_KpsC', NULL, NULL, NULL, 2),
(6533, NULL, 'cd04192', NULL, NULL, 'GT_2_like_e', NULL, 'GT_2_like_e', NULL, NULL, NULL, 2),
(6534, NULL, 'cd18915', NULL, NULL, 'bHLH_AtLHW_like', NULL, 'bHLH_AtLHW_like', NULL, NULL, NULL, 2),
(6535, NULL, 'cd07937', NULL, NULL, 'DRE_TIM_PC_TC_5S', NULL, 'DRE_TIM_PC_TC_5S', NULL, NULL, NULL, 2),
(6536, NULL, 'cd03495', NULL, NULL, 'SQR_TypeC_SdhD_like', NULL, 'SQR_TypeC_SdhD_like', NULL, NULL, NULL, 2),
(6537, NULL, 'cd03398', NULL, NULL, 'PAP2_haloperoxidase', NULL, 'PAP2_haloperoxidase', NULL, NULL, NULL, 2),
(6538, NULL, 'cd03874', NULL, NULL, 'M28_PMSA_TfR_like', NULL, 'M28_PMSA_TfR_like', NULL, NULL, NULL, 2),
(6539, NULL, 'cd10044', NULL, NULL, 'Reelin_repeat_8_subrepeat_1', NULL, 'Reelin_repeat_8_subrepeat_1', NULL, NULL, NULL, 2),
(6540, NULL, 'cd10030', NULL, NULL, 'UDG-F4_TTUDGA_SPO1dp_like', NULL, 'UDG-F4_TTUDGA_SPO1dp_like', NULL, NULL, NULL, 2),
(6541, NULL, 'cd16332', NULL, NULL, 'Prp-like', NULL, 'Prp-like', NULL, NULL, 3544, 2),
(6542, NULL, 'cd03140', NULL, NULL, 'GATase1_PfpI_3', NULL, 'GATase1_PfpI_3', NULL, NULL, NULL, 2),
(6543, NULL, 'cd17412', NULL, NULL, 'MFS_SLC15A1', NULL, 'MFS_SLC15A1', NULL, NULL, NULL, 2),
(6544, NULL, 'cd01661', NULL, NULL, 'cbb3_Oxidase_I', NULL, 'cbb3_Oxidase_I', NULL, NULL, 3261, 2),
(6545, NULL, 'cd10547', NULL, NULL, 'cupin_BacB_C', NULL, 'cupin_BacB_C', NULL, NULL, NULL, 2),
(6546, NULL, 'cd12530', NULL, NULL, 'RRM3_EAR1_like', NULL, 'RRM3_EAR1_like', NULL, NULL, 28490, 2),
(6547, NULL, 'cd19461', NULL, NULL, 'CRABP2', NULL, 'CRABP2', NULL, NULL, NULL, 2),
(6548, NULL, 'cd08371', NULL, NULL, 'Lumazine_synthase-like', NULL, 'Lumazine_synthase-like', NULL, NULL, NULL, 2),
(6549, NULL, 'cd19762', NULL, NULL, 'Bbox2_TRIM7-like', NULL, 'Bbox2_TRIM7-like', NULL, NULL, NULL, 2),
(6550, NULL, 'cd08973', NULL, NULL, 'BaFpgNei_N_1', NULL, 'BaFpgNei_N_1', NULL, NULL, NULL, 2),
(6551, NULL, 'cd04194', NULL, NULL, 'GT8_A4GalT_like', NULL, 'GT8_A4GalT_like', NULL, NULL, NULL, 2),
(6552, NULL, 'cd04332', NULL, NULL, 'YbaK_like', NULL, 'YbaK_like', NULL, NULL, NULL, 2),
(6553, NULL, 'cd02089', NULL, NULL, 'P-type_ATPase_Ca_prok', NULL, 'P-type_ATPase_Ca_prok', NULL, NULL, NULL, 2); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(6554, NULL, 'cd02208', NULL, NULL, 'cupin_RmlC-like', NULL, 'cupin_RmlC-like', NULL, NULL, NULL, 2),
(6555, NULL, 'cd11798', NULL, NULL, 'SH3_DNMBP_C1', NULL, 'SH3_DNMBP_C1', NULL, NULL, 28562, 2),
(6556, NULL, 'cd17725', NULL, NULL, 'BRCT_XRCC1_rpt1', NULL, 'BRCT_XRCC1_rpt1', NULL, NULL, 34417, 2),
(6557, NULL, 'cd06866', NULL, NULL, 'PX_SNX8_Mvp1p_like', NULL, 'PX_SNX8_Mvp1p_like', NULL, NULL, 27865, 2),
(6558, NULL, 'cd10491', NULL, NULL, 'MH1_SMAD_2_3', NULL, 'MH1_SMAD_2_3', NULL, NULL, NULL, 2),
(6559, NULL, 'cd17723', NULL, NULL, 'BRCT_Rad4_rpt4', NULL, 'BRCT_Rad4_rpt4', NULL, NULL, NULL, 2),
(6560, NULL, 'cd08624', NULL, NULL, 'PI-PLCc_beta2', NULL, 'PI-PLCc_beta2', NULL, NULL, NULL, 2),
(6561, NULL, 'cd08983', NULL, NULL, 'GH43_Bt3655-like', NULL, 'GH43_Bt3655-like', NULL, NULL, NULL, 2),
(6562, NULL, 'cd12789', NULL, NULL, 'RasGAP_plexin_C1', NULL, 'RasGAP_plexin_C1', NULL, NULL, NULL, 2),
(6563, NULL, 'cd13324', NULL, NULL, 'PH_Gab-like', NULL, 'PH_Gab-like', NULL, NULL, NULL, 2),
(6564, NULL, 'cd14762', NULL, NULL, 'GS_STAS', NULL, 'GS_STAS', NULL, NULL, NULL, 2),
(6565, NULL, 'cd01302', NULL, NULL, 'Cyclic_amidohydrolases', NULL, 'Cyclic_amidohydrolases', NULL, NULL, NULL, 2),
(6566, NULL, 'cd12478', NULL, NULL, 'RRM1_U2B', NULL, 'RRM1_U2B', NULL, NULL, 3763, 2),
(6567, NULL, 'cd08311', NULL, NULL, 'Death_p75NR', NULL, 'Death_p75NR', NULL, NULL, NULL, 2),
(6568, NULL, 'cd02603', NULL, NULL, 'HAD_sEH-N_like', NULL, 'HAD_sEH-N_like', NULL, NULL, NULL, 2),
(6569, NULL, 'cd02225', NULL, NULL, 'cupin_PA3510-like', NULL, 'cupin_PA3510-like', NULL, NULL, NULL, 2),
(6570, NULL, 'cd02139', NULL, NULL, 'nitroreductase', NULL, 'nitroreductase', NULL, NULL, NULL, 2),
(6571, NULL, 'cd15074', NULL, NULL, '7tmA_Opsin5_neuropsin', NULL, '7tmA_Opsin5_neuropsin', NULL, NULL, NULL, 2),
(6572, NULL, 'cd15549', NULL, NULL, 'PHD_PHF20_like', NULL, 'PHD_PHF20_like', NULL, NULL, NULL, 2),
(6573, NULL, 'cd15712', NULL, NULL, 'ePHD_PHF11', NULL, 'ePHD_PHF11', NULL, NULL, NULL, 2),
(6574, NULL, 'cd19462', NULL, NULL, 'CRBP1', NULL, 'CRBP1', NULL, NULL, NULL, 2),
(6575, NULL, 'cd18497', NULL, NULL, 'BACK_ABTB1_BPOZ', NULL, 'BACK_ABTB1_BPOZ', NULL, NULL, NULL, 2),
(6576, NULL, 'cd14070', NULL, NULL, 'STKc_HUNK', NULL, 'STKc_HUNK', NULL, NULL, 17148, 2),
(6577, NULL, 'cd09671', NULL, NULL, 'Csx1_III-U', NULL, 'Csx1_III-U', NULL, NULL, NULL, 2),
(6578, NULL, 'cd01157', NULL, NULL, 'MCAD', NULL, 'MCAD', NULL, NULL, 20938, 2),
(6579, NULL, 'cd15672', NULL, NULL, 'ePHD_AF10_like', NULL, 'ePHD_AF10_like', NULL, NULL, NULL, 2),
(6580, NULL, 'cd15291', NULL, NULL, '7tmC_GABA-B-R1', NULL, '7tmC_GABA-B-R1', NULL, NULL, 6791, 2),
(6581, NULL, 'cd04048', NULL, NULL, 'C2A_Copine', NULL, 'C2A_Copine', NULL, NULL, NULL, 2),
(6582, NULL, 'cd16118', NULL, NULL, 'UBX2_UBXN9', NULL, 'UBX2_UBXN9', NULL, NULL, NULL, 2),
(6583, NULL, 'cd19390', NULL, NULL, 'TGF_beta_BMP2', NULL, 'TGF_beta_BMP2', NULL, NULL, NULL, 2),
(6584, NULL, 'cd19417', NULL, NULL, 'lipocalin_C8gamma', NULL, 'lipocalin_C8gamma', NULL, NULL, NULL, 2),
(6585, NULL, 'cd03379', NULL, NULL, 'beta_CA_cladeD', NULL, 'beta_CA_cladeD', NULL, NULL, NULL, 2),
(6586, NULL, 'cd16122', NULL, NULL, 'FERM_F1_SNX31', NULL, 'FERM_F1_SNX31', NULL, NULL, NULL, 2),
(6587, NULL, 'cd11642', NULL, NULL, 'SUMT', NULL, 'SUMT', NULL, NULL, 5506, 2),
(6588, NULL, 'cd05667', NULL, NULL, 'M20_Acy1-like', NULL, 'M20_Acy1-like', NULL, NULL, NULL, 2),
(6589, NULL, 'cd06888', NULL, NULL, 'PX_FISH', NULL, 'PX_FISH', NULL, NULL, 28429, 2),
(6590, NULL, 'cd00139', NULL, NULL, 'PIPKc', NULL, 'PIPKc', NULL, NULL, NULL, 2),
(6591, NULL, 'cd17674', NULL, NULL, 'SWIB_BAF60A', NULL, 'SWIB_BAF60A', NULL, NULL, NULL, 2),
(6592, NULL, 'cd07891', NULL, NULL, 'CYTH-like_CthTTM-like_1', NULL, 'CYTH-like_CthTTM-like_1', NULL, NULL, NULL, 2),
(6593, NULL, 'cd01051', NULL, NULL, 'Mn_catalase', NULL, 'Mn_catalase', NULL, NULL, 27785, 2),
(6594, NULL, 'cd00561', NULL, NULL, 'CobA_CobO_BtuR', NULL, 'CobA_CobO_BtuR', NULL, NULL, 6293, 2),
(6595, NULL, 'cd15197', NULL, NULL, '7tmA_NPSR', NULL, '7tmA_NPSR', NULL, NULL, NULL, 2);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(6596, NULL, 'cd09200', NULL, NULL, 'PLDc_pPLDbeta_2', NULL, 'PLDc_pPLDbeta_2', NULL, NULL, NULL, 2),
(6597, NULL, 'cd11777', NULL, NULL, 'SH3_CIP4_Bzz1_like', NULL, 'SH3_CIP4_Bzz1_like', NULL, NULL, NULL, 2),
(6598, NULL, 'cd06082', NULL, NULL, 'KOW_Spt5_2', NULL, 'KOW_Spt5_2', NULL, NULL, 30776, 2),
(6599, NULL, 'cd15202', NULL, NULL, '7tmA_TACR-like', NULL, '7tmA_TACR-like', NULL, NULL, NULL, 2),
(6600, NULL, 'cd13571', NULL, NULL, 'PBP2_PnhD_1', NULL, 'PBP2_PnhD_1', NULL, NULL, NULL, 2),
(6601, NULL, 'cd06434', NULL, NULL, 'GT2_HAS', NULL, 'GT2_HAS', NULL, NULL, NULL, 2),
(6602, NULL, 'cd18293', NULL, NULL, 'BTB_POZ_BTBD18', NULL, 'BTB_POZ_BTBD18', NULL, NULL, NULL, 2),
(6603, NULL, 'cd11869', NULL, NULL, 'SH3_p40phox', NULL, 'SH3_p40phox', NULL, NULL, 30779, 2),
(6604, NULL, 'cd13275', NULL, NULL, 'PH_M-RIP', NULL, 'PH_M-RIP', NULL, NULL, 33800, 2),
(6605, NULL, 'cd10008', NULL, NULL, 'HDAC7', NULL, 'HDAC7', NULL, NULL, NULL, 2),
(6606, NULL, 'cd16276', NULL, NULL, 'metallo-hydrolase-like_MBL-fold', NULL, 'metallo-hydrolase-like_MBL-fold', NULL, NULL, NULL, 2),
(6607, NULL, 'cd18418', NULL, NULL, 'BTB_POZ_KCND2', NULL, 'BTB_POZ_KCND2', NULL, NULL, NULL, 2),
(6608, NULL, 'cd05245', NULL, NULL, 'SDR_a2', NULL, 'SDR_a2', NULL, NULL, NULL, 2),
(6609, NULL, 'cd11618', NULL, NULL, 'ChtBD1_1', NULL, 'ChtBD1_1', NULL, NULL, NULL, 2),
(6610, NULL, 'cd07482', NULL, NULL, 'Peptidases_S8_Lantibiotic_specific_protease', NULL, 'Peptidases_S8_Lantibiotic_specific_protease', NULL, NULL, 7968, 2),
(6611, NULL, 'cd08794', NULL, NULL, 'Death_IRAK1', NULL, 'Death_IRAK1', NULL, NULL, 32025, 2),
(6612, NULL, 'cd00222', NULL, NULL, 'CollagenBindB', NULL, 'CollagenBindB', NULL, NULL, 12010, 2),
(6613, NULL, 'cd05084', NULL, NULL, 'PTKc_Fes', NULL, 'PTKc_Fes', NULL, NULL, NULL, 2),
(6614, NULL, 'cd21484', NULL, NULL, 'MHV-like_Spike_S1_RBD', NULL, 'MHV-like_Spike_S1_RBD', NULL, NULL, NULL, 2),
(6615, NULL, 'cd05121', NULL, NULL, 'ABC1_ADCK3-like', NULL, 'ABC1_ADCK3-like', NULL, NULL, NULL, 2),
(6616, NULL, 'cd04704', NULL, NULL, 'PLA2_bee_venom_like', NULL, 'PLA2_bee_venom_like', NULL, NULL, NULL, 2),
(6617, NULL, 'cd19615', NULL, NULL, 'lipocalin_NP7', NULL, 'lipocalin_NP7', NULL, NULL, NULL, 2),
(6618, NULL, 'cd14094', NULL, NULL, 'STKc_CASK', NULL, 'STKc_CASK', NULL, NULL, NULL, 2),
(6619, NULL, 'cd19177', NULL, NULL, 'SET_SETD4', NULL, 'SET_SETD4', NULL, NULL, 36435, 2),
(6620, NULL, 'cd04680', NULL, NULL, 'Nudix_Hydrolase_21', NULL, 'Nudix_Hydrolase_21', NULL, NULL, NULL, 2),
(6621, NULL, 'cd03520', NULL, NULL, 'Link_domain_CSPGs_modules_2_4', NULL, 'Link_domain_CSPGs_modules_2_4', NULL, NULL, NULL, 2),
(6622, NULL, 'cd07023', NULL, NULL, 'S49_Sppa_N_C', NULL, 'S49_Sppa_N_C', NULL, NULL, 1030, 2),
(6623, NULL, 'cd09811', NULL, NULL, '3b-HSD_HSDB1_like_SDR_e', NULL, '3b-HSD_HSDB1_like_SDR_e', NULL, NULL, NULL, 2),
(6624, NULL, 'cd12645', NULL, NULL, 'RRM_SRSF3', NULL, 'RRM_SRSF3', NULL, NULL, NULL, 2),
(6625, NULL, 'cd05252', NULL, NULL, 'CDP_GD_SDR_e', NULL, 'CDP_GD_SDR_e', NULL, NULL, 9182, 2),
(6626, NULL, 'cd11999', NULL, NULL, 'SH3_PACSIN_like', NULL, 'SH3_PACSIN_like', NULL, NULL, NULL, 2),
(6627, NULL, 'cd14294', NULL, NULL, 'UBA1_UBP5_like', NULL, 'UBA1_UBP5_like', NULL, NULL, NULL, 2),
(6628, NULL, 'cd13919', NULL, NULL, 'CuRO_HCO_II_like_5', NULL, 'CuRO_HCO_II_like_5', NULL, NULL, NULL, 2),
(6629, NULL, 'cd19739', NULL, NULL, 'bHLH-PAS_SIM2', NULL, 'bHLH-PAS_SIM2', NULL, NULL, NULL, 2),
(6630, NULL, 'cd00475', NULL, NULL, 'Cis_IPPS', NULL, 'Cis_IPPS', NULL, NULL, 3313, 2),
(6631, NULL, 'cd03690', NULL, NULL, 'Tet_II', NULL, 'Tet_II', NULL, NULL, NULL, 2),
(6632, NULL, 'cd00280', NULL, NULL, 'TRFH', NULL, 'TRFH', NULL, NULL, NULL, 2),
(6633, NULL, 'cd11007', NULL, NULL, 'M35_like_1', NULL, 'M35_like_1', NULL, NULL, 9734, 2),
(6634, NULL, 'cd09733', NULL, NULL, 'Cas6-I-III', NULL, 'Cas6-I-III', NULL, NULL, NULL, 2),
(6635, NULL, 'cd18269', NULL, NULL, 'BTB_POZ_KLHL40-like', NULL, 'BTB_POZ_KLHL40-like', NULL, NULL, NULL, 2),
(6636, NULL, 'cd03406', NULL, NULL, 'SPFH_like_u3', NULL, 'SPFH_like_u3', NULL, NULL, 28135, 2); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(6637, NULL, 'cd05288', NULL, NULL, 'PGDH', NULL, 'PGDH', NULL, NULL, NULL, 2),
(6638, NULL, 'cd14391', NULL, NULL, 'UBA_II_E2_UBCD4', NULL, 'UBA_II_E2_UBCD4', NULL, NULL, 35049, 2),
(6639, NULL, 'cd06457', NULL, NULL, 'M3A_MIP', NULL, 'M3A_MIP', NULL, NULL, NULL, 2),
(6640, NULL, 'cd17933', NULL, NULL, 'DEXSc_RecD-like', NULL, 'DEXSc_RecD-like', NULL, NULL, NULL, 2),
(6641, NULL, 'cd17109', NULL, NULL, 'FERM_F1_SNX17_like', NULL, 'FERM_F1_SNX17_like', NULL, NULL, NULL, 2),
(6642, NULL, 'cd14420', NULL, NULL, 'CUE_AUP1', NULL, 'CUE_AUP1', NULL, NULL, NULL, 2),
(6643, NULL, 'cd07793', NULL, NULL, 'FGGY_GK5_metazoa', NULL, 'FGGY_GK5_metazoa', NULL, NULL, 32329, 2),
(6644, NULL, 'cd17416', NULL, NULL, 'MFS_NPF1_2', NULL, 'MFS_NPF1_2', NULL, NULL, NULL, 2),
(6645, NULL, 'cd08970', NULL, NULL, 'AcNei1_N', NULL, 'AcNei1_N', NULL, NULL, NULL, 2),
(6646, NULL, 'cd17271', NULL, NULL, 'RMtype1_S_NmaSCMORF606P_TRD2-CR2_like', NULL, 'RMtype1_S_NmaSCMORF606P_TRD2-CR2_like', NULL, NULL, NULL, 2),
(6647, NULL, 'cd15072', NULL, NULL, '7tmA_Retinal_GPR', NULL, '7tmA_Retinal_GPR', NULL, NULL, NULL, 2),
(6648, NULL, 'cd19867', NULL, NULL, 'DSRM_DGCR8_rpt1', NULL, 'DSRM_DGCR8_rpt1', NULL, NULL, NULL, 2),
(6649, NULL, 'cd07794', NULL, NULL, 'FGGY_GK_like_proteobact', NULL, 'FGGY_GK_like_proteobact', NULL, NULL, 30002, 2),
(6650, NULL, 'cd15851', NULL, NULL, 'SNARE_Syntaxin6', NULL, 'SNARE_Syntaxin6', NULL, NULL, NULL, 2),
(6651, NULL, 'cd18633', NULL, NULL, 'CD_MMP8', NULL, 'CD_MMP8', NULL, NULL, NULL, 2),
(6652, NULL, 'cd00118', NULL, NULL, 'LysM', NULL, 'LysM', NULL, NULL, 8452, 2),
(6653, NULL, 'cd00073', NULL, NULL, 'H15', NULL, 'H15', NULL, NULL, 5977, 2),
(6654, NULL, 'cd16922', NULL, NULL, 'HATPase_EvgS-ArcB-TorS-like', NULL, 'HATPase_EvgS-ArcB-TorS-like', NULL, NULL, NULL, 2),
(6655, NULL, 'cd15242', NULL, NULL, '7tm_Proteorhodopsin', NULL, '7tm_Proteorhodopsin', NULL, NULL, NULL, 2),
(6656, NULL, 'cd06952', NULL, NULL, 'NR_LBD_TR2_like', NULL, 'NR_LBD_TR2_like', NULL, NULL, NULL, 2),
(6657, NULL, 'cd11275', NULL, NULL, 'Sema_plexin_B1', NULL, 'Sema_plexin_B1', NULL, NULL, NULL, 2),
(6658, NULL, 'cd18100', NULL, NULL, 'Trm10euk_B', NULL, 'Trm10euk_B', NULL, NULL, NULL, 2),
(6659, NULL, 'cd11812', NULL, NULL, 'SH3_AHI-1', NULL, 'SH3_AHI-1', NULL, NULL, 28624, 2),
(6660, NULL, 'cd18647', NULL, NULL, 'CD_Cbx2', NULL, 'CD_Cbx2', NULL, NULL, NULL, 2),
(6661, NULL, 'cd02045', NULL, NULL, 'serpinC1_AT3', NULL, 'serpinC1_AT3', NULL, NULL, 33037, 2),
(6662, NULL, 'cd17291', NULL, NULL, 'RMtype1_S_MgeORF438P-TRD-CR_like', NULL, 'RMtype1_S_MgeORF438P-TRD-CR_like', NULL, NULL, NULL, 2),
(6663, NULL, 'cd13364', NULL, NULL, 'PH_PLC_eta', NULL, 'PH_PLC_eta', NULL, NULL, NULL, 2),
(6664, NULL, 'cd11530', NULL, NULL, 'NTP-PPase_DR2231_like', NULL, 'NTP-PPase_DR2231_like', NULL, NULL, 30204, 2),
(6665, NULL, 'cd05866', NULL, NULL, 'Ig1_NCAM-2', NULL, 'Ig1_NCAM-2', NULL, NULL, NULL, 2),
(6666, NULL, 'cd05398', NULL, NULL, 'NT_ClassII-CCAase', NULL, 'NT_ClassII-CCAase', NULL, NULL, 2749, 2),
(6667, NULL, 'cd18783', NULL, NULL, 'ABC_6TM_PrtD_LapB_HlyB_like', NULL, 'ABC_6TM_PrtD_LapB_HlyB_like', NULL, NULL, NULL, 2),
(6668, NULL, 'cd00502', NULL, NULL, 'DHQase_I', NULL, 'DHQase_I', NULL, NULL, 6658, 2),
(6669, NULL, 'cd06269', NULL, NULL, 'PBP1_glutamate_receptors-like', NULL, 'PBP1_glutamate_receptors-like', NULL, NULL, NULL, 2),
(6670, NULL, 'cd12084', NULL, NULL, 'DD_R_PKA', NULL, 'DD_R_PKA', NULL, NULL, NULL, 2),
(6671, NULL, 'cd08456', NULL, NULL, 'PBP2_LysR', NULL, 'PBP2_LysR', NULL, NULL, 30886, 2),
(6672, NULL, 'cd16850', NULL, NULL, 'STAT6_DBD', NULL, 'STAT6_DBD', NULL, NULL, NULL, 2),
(6673, NULL, 'cd17155', NULL, NULL, 'DCX_DCDC1', NULL, 'DCX_DCDC1', NULL, NULL, NULL, 2),
(6674, NULL, 'cd19874', NULL, NULL, 'DSRM_MRPL44', NULL, 'DSRM_MRPL44', NULL, NULL, 35047, 2),
(6675, NULL, 'cd08613', NULL, NULL, 'GDPD_GDE4_like_1', NULL, 'GDPD_GDE4_like_1', NULL, NULL, NULL, 2),
(6676, NULL, 'cd06174', NULL, NULL, 'MFS', NULL, 'MFS', NULL, NULL, NULL, 2),
(6677, NULL, 'cd03735', NULL, NULL, 'SOCS_SOCS1', NULL, 'SOCS_SOCS1', NULL, NULL, NULL, 2);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(6678, NULL, 'cd00162', NULL, NULL, 'RING_Ubox', NULL, 'RING_Ubox', NULL, NULL, NULL, 2),
(6679, NULL, 'cd04452', NULL, NULL, 'S1_IF2_alpha', NULL, 'S1_IF2_alpha', NULL, NULL, 34848, 2),
(6680, NULL, 'cd02432', NULL, NULL, 'Nodulin-21_like_1', NULL, 'Nodulin-21_like_1', NULL, NULL, NULL, 2),
(6681, NULL, 'cd16878', NULL, NULL, 'ARID_ARID3A', NULL, 'ARID_ARID3A', NULL, NULL, NULL, 2),
(6682, NULL, 'cd06848', NULL, NULL, 'GCS_H', NULL, 'GCS_H', NULL, NULL, 31378, 2),
(6683, NULL, 'cd08640', NULL, NULL, 'DNA_pol_A_plastid_like', NULL, 'DNA_pol_A_plastid_like', NULL, NULL, NULL, 2),
(6684, NULL, 'cd07860', NULL, NULL, 'STKc_CDK2_3', NULL, 'STKc_CDK2_3', NULL, NULL, NULL, 2),
(6685, NULL, 'cd19812', NULL, NULL, 'Bbox1_TRIM71_C-VII', NULL, 'Bbox1_TRIM71_C-VII', NULL, NULL, NULL, 2),
(6686, NULL, 'cd08281', NULL, NULL, 'liver_ADH_like1', NULL, 'liver_ADH_like1', NULL, NULL, NULL, 2),
(6687, NULL, 'cd00993', NULL, NULL, 'PBP2_ModA_like', NULL, 'PBP2_ModA_like', NULL, NULL, NULL, 2),
(6688, NULL, 'cd07413', NULL, NULL, 'MPP_PA3087', NULL, 'MPP_PA3087', NULL, NULL, 30379, 2),
(6689, NULL, 'cd01109', NULL, NULL, 'HTH_YyaN', NULL, 'HTH_YyaN', NULL, NULL, NULL, 2),
(6690, NULL, 'cd10351', NULL, NULL, 'SH2_SH2D4B', NULL, 'SH2_SH2D4B', NULL, NULL, 31602, 2),
(6691, NULL, 'cd13265', NULL, NULL, 'PH_evt', NULL, 'PH_evt', NULL, NULL, NULL, 2),
(6692, NULL, 'cd18716', NULL, NULL, 'PIN_SSO1118-like', NULL, 'PIN_SSO1118-like', NULL, NULL, NULL, 2),
(6693, NULL, 'cd21527', NULL, NULL, 'CoV_Spike_S1_NTD', NULL, 'CoV_Spike_S1_NTD', NULL, NULL, NULL, 2),
(6694, NULL, 'cd00199', NULL, NULL, 'WAP', NULL, 'WAP', NULL, NULL, NULL, 2),
(6695, NULL, 'cd06859', NULL, NULL, 'PX_SNX1_2_like', NULL, 'PX_SNX1_2_like', NULL, NULL, NULL, 2),
(6696, NULL, 'cd19968', NULL, NULL, 'PBP1_ABC_IbpA-like', NULL, 'PBP1_ABC_IbpA-like', NULL, NULL, NULL, 2),
(6697, NULL, 'cd02678', NULL, NULL, 'MIT_VPS4', NULL, 'MIT_VPS4', NULL, NULL, 36768, 2),
(6698, NULL, 'cd20271', NULL, NULL, 'Complex1_LYR_FMC1', NULL, 'Complex1_LYR_FMC1', NULL, NULL, NULL, 2),
(6699, NULL, 'cd18767', NULL, NULL, 'PIN_MtVapC3-like', NULL, 'PIN_MtVapC3-like', NULL, NULL, NULL, 2),
(6700, NULL, 'cd16134', NULL, NULL, 'RA_RASSF8', NULL, 'RA_RASSF8', NULL, NULL, NULL, 2),
(6701, NULL, 'cd12410', NULL, NULL, 'RRM2_RRT5', NULL, 'RRM2_RRT5', NULL, NULL, 7272, 2),
(6702, NULL, 'cd12710', NULL, NULL, 'RRM_RCAN3', NULL, 'RRM_RCAN3', NULL, NULL, NULL, 2),
(6703, NULL, 'cd06655', NULL, NULL, 'STKc_PAK2', NULL, 'STKc_PAK2', NULL, NULL, 27889, 2),
(6704, NULL, 'cd00336', NULL, NULL, 'Ribosomal_L22', NULL, 'Ribosomal_L22', NULL, NULL, 2301, 2),
(6705, NULL, 'cd14402', NULL, NULL, 'UBA_HERC2', NULL, 'UBA_HERC2', NULL, NULL, NULL, 2),
(6706, NULL, 'cd18629', NULL, NULL, 'CD2_cpSRP43_like', NULL, 'CD2_cpSRP43_like', NULL, NULL, NULL, 2),
(6707, NULL, 'cd21407', NULL, NULL, '1B_UPF1-like', NULL, '1B_UPF1-like', NULL, NULL, 29283, 2),
(6708, NULL, 'cd15133', NULL, NULL, '7tmA_NMU-R', NULL, '7tmA_NMU-R', NULL, NULL, NULL, 2),
(6709, NULL, 'cd13686', NULL, NULL, 'GluR_Plant', NULL, 'GluR_Plant', NULL, NULL, NULL, 2),
(6710, NULL, 'cd07156', NULL, NULL, 'NR_DBD_VDR_like', NULL, 'NR_DBD_VDR_like', NULL, NULL, NULL, 2),
(6711, NULL, 'cd01644', NULL, NULL, 'RT_pepA17', NULL, 'RT_pepA17', NULL, NULL, NULL, 2),
(6712, NULL, 'cd12542', NULL, NULL, 'RRM2_LARP7', NULL, 'RRM2_LARP7', NULL, NULL, 19075, 2),
(6713, NULL, 'cd01311', NULL, NULL, 'PDC_hydrolase', NULL, 'PDC_hydrolase', NULL, NULL, NULL, 2),
(6714, NULL, 'cd11855', NULL, NULL, 'SH3_Sho1p', NULL, 'SH3_Sho1p', NULL, NULL, 27724, 2),
(6715, NULL, 'cd09382', NULL, NULL, 'LIM2_Lhx6', NULL, 'LIM2_Lhx6', NULL, NULL, NULL, 2),
(6716, NULL, 'cd10976', NULL, NULL, 'CE4_CDA_like_3', NULL, 'CE4_CDA_like_3', NULL, NULL, NULL, 2),
(6717, NULL, 'cd12314', NULL, NULL, 'RRM1_RBM6', NULL, 'RRM1_RBM6', NULL, NULL, 30481, 2),
(6718, NULL, 'cd20071', NULL, NULL, 'SET_SMYD', NULL, 'SET_SMYD', NULL, NULL, NULL, 2),
(6719, NULL, 'cd00994', NULL, NULL, 'PBP2_GlnH', NULL, 'PBP2_GlnH', NULL, NULL, 36721, 2),
(6720, NULL, 'cd07505', NULL, NULL, 'HAD_BPGM-like', NULL, 'HAD_BPGM-like', NULL, NULL, NULL, 2);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(6721, NULL, 'cd16172', NULL, NULL, 'TorS_sensor_domain', NULL, 'TorS_sensor_domain', NULL, NULL, 30904, 2),
(6722, NULL, 'cd02552', NULL, NULL, 'PseudoU_synth_TruD_like', NULL, 'PseudoU_synth_TruD_like', NULL, NULL, NULL, 2),
(6723, NULL, 'cd00567', NULL, NULL, 'ACAD', NULL, 'ACAD', NULL, NULL, NULL, 2),
(6724, NULL, 'cd11733', NULL, NULL, 'HSPA9-like_NBD', NULL, 'HSPA9-like_NBD', NULL, NULL, NULL, 2),
(6725, NULL, 'cd09544', NULL, NULL, 'SAM_EPH-A3', NULL, 'SAM_EPH-A3', NULL, NULL, NULL, 2),
(6726, NULL, 'cd12364', NULL, NULL, 'RRM_RDM1', NULL, 'RRM_RDM1', NULL, NULL, 18226, 2),
(6727, NULL, 'cd14601', NULL, NULL, 'PTPc-N4', NULL, 'PTPc-N4', NULL, NULL, NULL, 2),
(6728, NULL, 'cd12407', NULL, NULL, 'RRM_FOX1_like', NULL, 'RRM_FOX1_like', NULL, NULL, 30672, 2),
(6729, NULL, 'cd08068', NULL, NULL, 'MPN_BRCC36', NULL, 'MPN_BRCC36', NULL, NULL, 32366, 2),
(6730, NULL, 'cd15163', NULL, NULL, '7tmA_GPR20', NULL, '7tmA_GPR20', NULL, NULL, NULL, 2),
(6731, NULL, 'cd13596', NULL, NULL, 'PBP2_lipoprotein_GmpC', NULL, 'PBP2_lipoprotein_GmpC', NULL, NULL, NULL, 2),
(6732, NULL, 'cd09245', NULL, NULL, 'BRO1_UmRIM23-like', NULL, 'BRO1_UmRIM23-like', NULL, NULL, NULL, 2),
(6733, NULL, 'cd09172', NULL, NULL, 'PLDc_Nuc_like_unchar1_1', NULL, 'PLDc_Nuc_like_unchar1_1', NULL, NULL, NULL, 2),
(6734, NULL, 'cd00032', NULL, NULL, 'CASc', NULL, 'CASc', NULL, NULL, 7166, 2),
(6735, NULL, 'cd13784', NULL, NULL, 'SP_1775_like', NULL, 'SP_1775_like', NULL, NULL, NULL, 2),
(6736, NULL, 'cd19933', NULL, NULL, 'REC_ETR-like', NULL, 'REC_ETR-like', NULL, NULL, NULL, 2),
(6737, NULL, 'cd02979', NULL, NULL, 'PHOX_C', NULL, 'PHOX_C', NULL, NULL, NULL, 2),
(6738, NULL, 'cd14417', NULL, NULL, 'CUE_DMA_DMRTA1', NULL, 'CUE_DMA_DMRTA1', NULL, NULL, NULL, 2),
(6739, NULL, 'cd14613', NULL, NULL, 'PTPc-N5', NULL, 'PTPc-N5', NULL, NULL, NULL, 2),
(6740, NULL, 'cd15095', NULL, NULL, '7tmA_KiSS1R', NULL, '7tmA_KiSS1R', NULL, NULL, NULL, 2),
(6741, NULL, 'cd00982', NULL, NULL, 'gltB_C', NULL, 'gltB_C', NULL, NULL, 774, 2),
(6742, NULL, 'cd17119', NULL, NULL, 'Ubl_HERP2', NULL, 'Ubl_HERP2', NULL, NULL, NULL, 2),
(6743, NULL, 'cd11817', NULL, NULL, 'SH3_Eve1_4', NULL, 'SH3_Eve1_4', NULL, NULL, NULL, 2),
(6744, NULL, 'cd08580', NULL, NULL, 'GDPD_Rv2277c_like', NULL, 'GDPD_Rv2277c_like', NULL, NULL, NULL, 2),
(6745, NULL, 'cd05902', NULL, NULL, 'Ig_Neurocan', NULL, 'Ig_Neurocan', NULL, NULL, NULL, 2),
(6746, NULL, 'cd16983', NULL, NULL, 'CID_SCAF8_like', NULL, 'CID_SCAF8_like', NULL, NULL, NULL, 2),
(6747, NULL, 'cd09489', NULL, NULL, 'SAM_Smaug-like', NULL, 'SAM_Smaug-like', NULL, NULL, NULL, 2),
(6748, NULL, 'cd14478', NULL, NULL, 'SPX_PHO87_PHO90_like', NULL, 'SPX_PHO87_PHO90_like', NULL, NULL, NULL, 2),
(6749, NULL, 'cd11435', NULL, NULL, 'bHLH-PAS_AhRR', NULL, 'bHLH-PAS_AhRR', NULL, NULL, NULL, 2),
(6750, NULL, 'cd16221', NULL, NULL, 'EFh_PI-PLCeta2', NULL, 'EFh_PI-PLCeta2', NULL, NULL, NULL, 2),
(6751, NULL, 'cd03191', NULL, NULL, 'GST_C_Zeta', NULL, 'GST_C_Zeta', NULL, NULL, 30761, 2),
(6752, NULL, 'cd12501', NULL, NULL, 'RRM_EcDbpA_like', NULL, 'RRM_EcDbpA_like', NULL, NULL, NULL, 2),
(6753, NULL, 'cd07376', NULL, NULL, 'PLPDE_III_DSD_D-TA_like', NULL, 'PLPDE_III_DSD_D-TA_like', NULL, NULL, NULL, 2),
(6754, NULL, 'cd01098', NULL, NULL, 'PAN_AP_plant', NULL, 'PAN_AP_plant', NULL, NULL, NULL, 2),
(6755, NULL, 'cd03314', NULL, NULL, 'MAL', NULL, 'MAL', NULL, NULL, 5706, 2),
(6756, NULL, 'cd18910', NULL, NULL, 'bHLHzip_USF3', NULL, 'bHLHzip_USF3', NULL, NULL, NULL, 2),
(6757, NULL, 'cd09980', NULL, NULL, 'LOTUS_4_Limkain_b1', NULL, 'LOTUS_4_Limkain_b1', NULL, NULL, NULL, 2),
(6758, NULL, 'cd15400', NULL, NULL, '7tmA_Mel1B', NULL, '7tmA_Mel1B', NULL, NULL, NULL, 2),
(6759, NULL, 'cd05118', NULL, NULL, 'STKc_CMGC', NULL, 'STKc_CMGC', NULL, NULL, NULL, 2),
(6760, NULL, 'cd07186', NULL, NULL, 'CofD_like', NULL, 'CofD_like', NULL, NULL, 10733, 2),
(6761, NULL, 'cd13194', NULL, NULL, 'FERM_C_ERM', NULL, 'FERM_C_ERM', NULL, NULL, 30184, 2),
(6762, NULL, 'cd07279', NULL, NULL, 'PX_SNX20_21_like', NULL, 'PX_SNX20_21_like', NULL, NULL, NULL, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(6763, NULL, 'cd14975', NULL, NULL, '7tmA_LTB4R', NULL, '7tmA_LTB4R', NULL, NULL, NULL, 2),
(6764, NULL, 'cd06296', NULL, NULL, 'PBP1_CatR-like', NULL, 'PBP1_CatR-like', NULL, NULL, NULL, 2),
(6765, NULL, 'cd10808', NULL, NULL, 'YdjC', NULL, 'YdjC', NULL, NULL, NULL, 2),
(6766, NULL, 'cd00254', NULL, NULL, 'LT-like', NULL, 'LT-like', NULL, NULL, NULL, 2),
(6767, NULL, 'cd10785', NULL, NULL, 'GH38-57_N_LamB_YdjC_SF', NULL, 'GH38-57_N_LamB_YdjC_SF', NULL, NULL, NULL, 2),
(6768, NULL, 'cd19104', NULL, NULL, 'AKR_unchar', NULL, 'AKR_unchar', NULL, NULL, NULL, 2),
(6769, NULL, 'cd18180', NULL, NULL, 'ATP-synt_Vo_Ao_c_NTPK_rpt2', NULL, 'ATP-synt_Vo_Ao_c_NTPK_rpt2', NULL, NULL, NULL, 2),
(6770, NULL, 'cd08748', NULL, NULL, 'RGS_GRK1', NULL, 'RGS_GRK1', NULL, NULL, NULL, 2),
(6771, NULL, 'cd05711', NULL, NULL, 'Ig2_LILR_KIR_like', NULL, 'Ig2_LILR_KIR_like', NULL, NULL, NULL, 2),
(6772, NULL, 'cd17998', NULL, NULL, 'DEXHc_SMARCAD1', NULL, 'DEXHc_SMARCAD1', NULL, NULL, NULL, 2),
(6773, NULL, 'cd17207', NULL, NULL, 'FERM_F1_PLEKHH3', NULL, 'FERM_F1_PLEKHH3', NULL, NULL, NULL, 2),
(6774, NULL, 'cd21513', NULL, NULL, 'SUD_C_DPUP_CoV_Nsp3', NULL, 'SUD_C_DPUP_CoV_Nsp3', NULL, NULL, NULL, 2),
(6775, NULL, 'cd16247', NULL, NULL, 'EFh_UTRO', NULL, 'EFh_UTRO', NULL, NULL, NULL, 2),
(6776, NULL, 'cd16542', NULL, NULL, 'RING-HC_RNF125', NULL, 'RING-HC_RNF125', NULL, NULL, NULL, 2),
(6777, NULL, 'cd06909', NULL, NULL, 'M14_ASPA', NULL, 'M14_ASPA', NULL, NULL, NULL, 2),
(6778, NULL, 'cd09689', NULL, NULL, 'Cas7_I-C', NULL, 'Cas7_I-C', NULL, NULL, NULL, 2),
(6779, NULL, 'cd06163', NULL, NULL, 'S2P-M50_PDZ_RseP-like', NULL, 'S2P-M50_PDZ_RseP-like', NULL, NULL, NULL, 2),
(6780, NULL, 'cd12675', NULL, NULL, 'RRM2_Nop4p', NULL, 'RRM2_Nop4p', NULL, NULL, 32088, 2),
(6781, NULL, 'cd20232', NULL, NULL, 'PFM_crystallin-like', NULL, 'PFM_crystallin-like', NULL, NULL, NULL, 2),
(6782, NULL, 'cd06875', NULL, NULL, 'PX_IRAS', NULL, 'PX_IRAS', NULL, NULL, 28560, 2),
(6783, NULL, 'cd14974', NULL, NULL, '7tmA_Anaphylatoxin_R-like', NULL, '7tmA_Anaphylatoxin_R-like', NULL, NULL, NULL, 2),
(6784, NULL, 'cd07339', NULL, NULL, 'M48B_HtpX_like', NULL, 'M48B_HtpX_like', NULL, NULL, NULL, 2),
(6785, NULL, 'cd12072', NULL, NULL, 'SH3_FNBP1L', NULL, 'SH3_FNBP1L', NULL, NULL, 16611, 2),
(6786, NULL, 'cd08031', NULL, NULL, 'LARP_4_5_like', NULL, 'LARP_4_5_like', NULL, NULL, NULL, 2),
(6787, NULL, 'cd18826', NULL, NULL, 'GH43_CtGH43-like', NULL, 'GH43_CtGH43-like', NULL, NULL, NULL, 2),
(6788, NULL, 'cd08602', NULL, NULL, 'GDPD_ScGlpQ1_like', NULL, 'GDPD_ScGlpQ1_like', NULL, NULL, NULL, 2),
(6789, NULL, 'cd14727', NULL, NULL, 'ChanN-like', NULL, 'ChanN-like', NULL, NULL, 4984, 2),
(6790, NULL, 'cd00108', NULL, NULL, 'KR', NULL, 'KR', NULL, NULL, 1643, 2),
(6791, NULL, 'cd08485', NULL, NULL, 'PBP2_ClcR', NULL, 'PBP2_ClcR', NULL, NULL, 29597, 2),
(6792, NULL, 'cd17459', NULL, NULL, 'MFS_SLCO1C_OATP1C', NULL, 'MFS_SLCO1C_OATP1C', NULL, NULL, NULL, 2),
(6793, NULL, 'cd15290', NULL, NULL, '7tmC_TAS1R3', NULL, '7tmC_TAS1R3', NULL, NULL, NULL, 2),
(6794, NULL, 'cd03855', NULL, NULL, 'M14_ASTE', NULL, 'M14_ASTE', NULL, NULL, 20010, 2),
(6795, NULL, 'cd02181', NULL, NULL, 'GH16_fungal_Lam16A_glucanase', NULL, 'GH16_fungal_Lam16A_glucanase', NULL, NULL, NULL, 2),
(6796, NULL, 'cd13244', NULL, NULL, 'PH_PLEKHG5_G6', NULL, 'PH_PLEKHG5_G6', NULL, NULL, NULL, 2),
(6797, NULL, 'cd16552', NULL, NULL, 'RING-HC_NEURL3', NULL, 'RING-HC_NEURL3', NULL, NULL, NULL, 2),
(6798, NULL, 'cd10429', NULL, NULL, 'GAAP_like', NULL, 'GAAP_like', NULL, NULL, NULL, 2),
(6799, NULL, 'cd04673', NULL, NULL, 'Nudix_Hydrolase_15', NULL, 'Nudix_Hydrolase_15', NULL, NULL, NULL, 2),
(6800, NULL, 'cd01678', NULL, NULL, 'PFL1', NULL, 'PFL1', NULL, NULL, 386, 2),
(6801, NULL, 'cd10336', NULL, NULL, 'SLC6sbd_Tyt1-Like', NULL, 'SLC6sbd_Tyt1-Like', NULL, NULL, NULL, 2),
(6802, NULL, 'cd13991', NULL, NULL, 'STKc_NIK', NULL, 'STKc_NIK', NULL, NULL, 33606, 2),
(6803, NULL, 'cd12582', NULL, NULL, 'RRM2_hnRNPA3', NULL, 'RRM2_hnRNPA3', NULL, NULL, 12020, 2),
(6804, NULL, 'cd01427', NULL, NULL, 'HAD_like', NULL, 'HAD_like', NULL, NULL, NULL, 2);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(6805, NULL, 'cd17527', NULL, NULL, 'HAMP_II', NULL, 'HAMP_II', NULL, NULL, NULL, 2),
(6806, NULL, 'cd06843', NULL, NULL, 'PLPDE_III_PvsE_like', NULL, 'PLPDE_III_PvsE_like', NULL, NULL, NULL, 2),
(6807, NULL, 'cd06344', NULL, NULL, 'PBP1_ABC_HAAT-like', NULL, 'PBP1_ABC_HAAT-like', NULL, NULL, NULL, 2),
(6808, NULL, 'cd19382', NULL, NULL, 'TGF_beta_Persephin', NULL, 'TGF_beta_Persephin', NULL, NULL, NULL, 2),
(6809, NULL, 'cd06099', NULL, NULL, 'CS_ACL-C_CCL', NULL, 'CS_ACL-C_CCL', NULL, NULL, NULL, 2),
(6810, NULL, 'cd13394', NULL, NULL, 'Syo1_like', NULL, 'Syo1_like', NULL, NULL, NULL, 2),
(6811, NULL, 'cd18978', NULL, NULL, 'CD_DDE_transposase_like', NULL, 'CD_DDE_transposase_like', NULL, NULL, NULL, 2),
(6812, NULL, 'cd09576', NULL, NULL, 'SAM_DGK-eta', NULL, 'SAM_DGK-eta', NULL, NULL, NULL, 2),
(6813, NULL, 'cd18251', NULL, NULL, 'BTB_POZ_KLHL22', NULL, 'BTB_POZ_KLHL22', NULL, NULL, NULL, 2),
(6814, NULL, 'cd06261', NULL, NULL, 'TM_PBP2', NULL, 'TM_PBP2', NULL, NULL, 5588, 2),
(6815, NULL, 'cd16190', NULL, NULL, 'EFh_PEF_CAPN3', NULL, 'EFh_PEF_CAPN3', NULL, NULL, NULL, 2),
(6816, NULL, 'cd17756', NULL, NULL, 'MCM5', NULL, 'MCM5', NULL, NULL, NULL, 2),
(6817, NULL, 'cd02210', NULL, NULL, 'cupin_BLR2406-like', NULL, 'cupin_BLR2406-like', NULL, NULL, NULL, 2),
(6818, NULL, 'cd15066', NULL, NULL, '7tmA_DmOct-betaAR-like', NULL, '7tmA_DmOct-betaAR-like', NULL, NULL, NULL, 2),
(6819, NULL, 'cd00447', NULL, NULL, 'NusB_Sun', NULL, 'NusB_Sun', NULL, NULL, NULL, 2),
(6820, NULL, 'cd02940', NULL, NULL, 'DHPD_FMN', NULL, 'DHPD_FMN', NULL, NULL, NULL, 2),
(6821, NULL, 'cd17814', NULL, NULL, 'Fe-ADH-like', NULL, 'Fe-ADH-like', NULL, NULL, NULL, 2),
(6822, NULL, 'cd05604', NULL, NULL, 'STKc_SGK3', NULL, 'STKc_SGK3', NULL, NULL, 31176, 2),
(6823, NULL, 'cd03393', NULL, NULL, 'PAP2_like_3', NULL, 'PAP2_like_3', NULL, NULL, NULL, 2),
(6824, NULL, 'cd05836', NULL, NULL, 'N_Pac_NP60', NULL, 'N_Pac_NP60', NULL, NULL, 17721, 2),
(6825, NULL, 'cd03166', NULL, NULL, 'CD63_LEL', NULL, 'CD63_LEL', NULL, NULL, 30867, 2),
(6826, NULL, 'cd01554', NULL, NULL, 'EPT-like', NULL, 'EPT-like', NULL, NULL, NULL, 2),
(6827, NULL, 'cd01186', NULL, NULL, 'INT_tnpA_C_Tn554', NULL, 'INT_tnpA_C_Tn554', NULL, NULL, 36994, 2),
(6828, NULL, 'cd19877', NULL, NULL, 'DSRM_RNAse_III_meta_like', NULL, 'DSRM_RNAse_III_meta_like', NULL, NULL, 37677, 2),
(6829, NULL, 'cd11877', NULL, NULL, 'SH3_PIX', NULL, 'SH3_PIX', NULL, NULL, NULL, 2),
(6830, NULL, 'cd16176', NULL, NULL, 'EFh_HEF_CB', NULL, 'EFh_HEF_CB', NULL, NULL, NULL, 2),
(6831, NULL, 'cd19429', NULL, NULL, 'lipocalin_9', NULL, 'lipocalin_9', NULL, NULL, NULL, 2),
(6832, NULL, 'cd07457', NULL, NULL, 'CRD_FZ9_like', NULL, 'CRD_FZ9_like', NULL, NULL, NULL, 2),
(6833, NULL, 'cd20009', NULL, NULL, 'PBP1_RafR-like', NULL, 'PBP1_RafR-like', NULL, NULL, NULL, 2),
(6834, NULL, 'cd00201', NULL, NULL, 'WW', NULL, 'WW', NULL, NULL, 1285, 2),
(6835, NULL, 'cd01458', NULL, NULL, 'vWA_ku', NULL, 'vWA_ku', NULL, NULL, NULL, 2),
(6836, NULL, 'cd01208', NULL, NULL, 'PTB_X11', NULL, 'PTB_X11', NULL, NULL, NULL, 2),
(6837, NULL, 'cd03386', NULL, NULL, 'PAP2_Aur1_like', NULL, 'PAP2_Aur1_like', NULL, NULL, NULL, 2),
(6838, NULL, 'cd15885', NULL, NULL, 'SNARE_SNAP25C', NULL, 'SNARE_SNAP25C', NULL, NULL, NULL, 2),
(6839, NULL, 'cd00313', NULL, NULL, 'ATP-synt_Fo_Vo_Ao_c', NULL, 'ATP-synt_Fo_Vo_Ao_c', NULL, NULL, NULL, 2),
(6840, NULL, 'cd07982', NULL, NULL, 'TAF10', NULL, 'TAF10', NULL, NULL, 6013, 2),
(6841, NULL, 'cd14307', NULL, NULL, 'UBA_RUP1p', NULL, 'UBA_RUP1p', NULL, NULL, 30055, 2),
(6842, NULL, 'cd18719', NULL, NULL, 'PIN_Zc3h12a-N4BP1-like', NULL, 'PIN_Zc3h12a-N4BP1-like', NULL, NULL, NULL, 2),
(6843, NULL, 'cd08971', NULL, NULL, 'AcNei2_N', NULL, 'AcNei2_N', NULL, NULL, 34807, 2),
(6844, NULL, 'cd14065', NULL, NULL, 'PKc_LIMK_like', NULL, 'PKc_LIMK_like', NULL, NULL, NULL, 2),
(6845, NULL, 'cd02135', NULL, NULL, 'YdjA-like', NULL, 'YdjA-like', NULL, NULL, 24580, 2),
(6846, NULL, 'cd13164', NULL, NULL, 'PTB_DOK4_DOK5_DOK6', NULL, 'PTB_DOK4_DOK5_DOK6', NULL, NULL, NULL, 2),
(6847, NULL, 'cd15007', NULL, NULL, '7tmA_GPR75', NULL, '7tmA_GPR75', NULL, NULL, NULL, 2);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(6848, NULL, 'cd18632', NULL, NULL, 'CD_Clr4_like', NULL, 'CD_Clr4_like', NULL, NULL, NULL, 2),
(6849, NULL, 'cd15686', NULL, NULL, 'PHD3_KDM5A', NULL, 'PHD3_KDM5A', NULL, NULL, NULL, 2),
(6850, NULL, 'cd02334', NULL, NULL, 'ZZ_dystrophin', NULL, 'ZZ_dystrophin', NULL, NULL, NULL, 2),
(6851, NULL, 'cd12212', NULL, NULL, 'Fis1', NULL, 'Fis1', NULL, NULL, 28733, 2),
(6852, NULL, 'cd19895', NULL, NULL, 'DSRM_RED1_rpt1', NULL, 'DSRM_RED1_rpt1', NULL, NULL, 35160, 2),
(6853, NULL, 'cd04188', NULL, NULL, 'DPG_synthase', NULL, 'DPG_synthase', NULL, NULL, 33175, 2),
(6854, NULL, 'cd17177', NULL, NULL, 'FERM_F0_SHANK3', NULL, 'FERM_F0_SHANK3', NULL, NULL, NULL, 2),
(6855, NULL, 'cd14277', NULL, NULL, 'UBA_UBP2_like', NULL, 'UBA_UBP2_like', NULL, NULL, NULL, 2),
(6856, NULL, 'cd05531', NULL, NULL, 'POLBc_B2', NULL, 'POLBc_B2', NULL, NULL, NULL, 2),
(6857, NULL, 'cd18804', NULL, NULL, 'SF2_C_priA', NULL, 'SF2_C_priA', NULL, NULL, NULL, 2),
(6858, NULL, 'cd19063', NULL, NULL, 'LGIC_TM_5-HT3', NULL, 'LGIC_TM_5-HT3', NULL, NULL, NULL, 2),
(6859, NULL, 'cd14095', NULL, NULL, 'STKc_DCKL', NULL, 'STKc_DCKL', NULL, NULL, NULL, 2),
(6860, NULL, 'cd03066', NULL, NULL, 'PDI_b_Calsequestrin_middle', NULL, 'PDI_b_Calsequestrin_middle', NULL, NULL, 30787, 2),
(6861, NULL, 'cd11799', NULL, NULL, 'SH3_ARHGEF37_C1', NULL, 'SH3_ARHGEF37_C1', NULL, NULL, 32308, 2),
(6862, NULL, 'cd08463', NULL, NULL, 'PBP2_DntR_like_4', NULL, 'PBP2_DntR_like_4', NULL, NULL, NULL, 2),
(6863, NULL, 'cd10431', NULL, NULL, 'GHITM', NULL, 'GHITM', NULL, NULL, 29060, 2),
(6864, NULL, 'cd06808', NULL, NULL, 'PLPDE_III', NULL, 'PLPDE_III', NULL, NULL, NULL, 2),
(6865, NULL, 'cd02553', NULL, NULL, 'PseudoU_synth_RsuA', NULL, 'PseudoU_synth_RsuA', NULL, NULL, NULL, 2),
(6866, NULL, 'cd18683', NULL, NULL, 'PIN_VapC-like', NULL, 'PIN_VapC-like', NULL, NULL, NULL, 2),
(6867, NULL, 'cd02986', NULL, NULL, 'DLP', NULL, 'DLP', NULL, NULL, NULL, 2),
(6868, NULL, 'cd08044', NULL, NULL, 'TAF5_NTD2', NULL, 'TAF5_NTD2', NULL, NULL, 1676, 2),
(6869, NULL, 'cd07073', NULL, NULL, 'NR_LBD_AR', NULL, 'NR_LBD_AR', NULL, NULL, NULL, 2),
(6870, NULL, 'cd01034', NULL, NULL, 'EriC_like', NULL, 'EriC_like', NULL, NULL, NULL, 2),
(6871, NULL, 'cd12116', NULL, NULL, 'A_NRPS_Ta1_like', NULL, 'A_NRPS_Ta1_like', NULL, NULL, NULL, 2),
(6872, NULL, 'cd15896', NULL, NULL, 'MYSc_Myh19', NULL, 'MYSc_Myh19', NULL, NULL, NULL, 2),
(6873, NULL, 'cd03348', NULL, NULL, 'pro_PheOH', NULL, 'pro_PheOH', NULL, NULL, 214, 2),
(6874, NULL, 'cd03697', NULL, NULL, 'EFTU_II', NULL, 'EFTU_II', NULL, NULL, 31159, 2),
(6875, NULL, 'cd04390', NULL, NULL, 'RhoGAP_ARHGAP22_24_25', NULL, 'RhoGAP_ARHGAP22_24_25', NULL, NULL, NULL, 2),
(6876, NULL, 'cd20276', NULL, NULL, 'Sarcolamban_A', NULL, 'Sarcolamban_A', NULL, NULL, NULL, 2),
(6877, NULL, 'cd15894', NULL, NULL, 'SNARE_SNAP25N', NULL, 'SNARE_SNAP25N', NULL, NULL, NULL, 2),
(6878, NULL, 'cd01303', NULL, NULL, 'GDEase', NULL, 'GDEase', NULL, NULL, 9754, 2),
(6879, NULL, 'cd13861', NULL, NULL, 'CuRO_1_CumA_like', NULL, 'CuRO_1_CumA_like', NULL, NULL, NULL, 2),
(6880, NULL, 'cd17955', NULL, NULL, 'DEADc_DDX49', NULL, 'DEADc_DDX49', NULL, NULL, NULL, 2),
(6881, NULL, 'cd04712', NULL, NULL, 'BAH_DCM_I', NULL, 'BAH_DCM_I', NULL, NULL, NULL, 2),
(6882, NULL, 'cd14259', NULL, NULL, 'PUFD_like', NULL, 'PUFD_like', NULL, NULL, NULL, 2),
(6883, NULL, 'cd17152', NULL, NULL, 'DCX2_DCDC2', NULL, 'DCX2_DCDC2', NULL, NULL, NULL, 2),
(6884, NULL, 'cd01236', NULL, NULL, 'PH_RIP', NULL, 'PH_RIP', NULL, NULL, NULL, 2),
(6885, NULL, 'cd14165', NULL, NULL, 'STKc_TSSK1_2-like', NULL, 'STKc_TSSK1_2-like', NULL, NULL, NULL, 2),
(6886, NULL, 'cd03074', NULL, NULL, 'PDI_b''_Calsequestrin_C', NULL, 'PDI_b''_Calsequestrin_C', NULL, NULL, 30838, 2),
(6887, NULL, 'cd04214', NULL, NULL, 'PAD_N', NULL, 'PAD_N', NULL, NULL, NULL, 2),
(6888, NULL, 'cd03576', NULL, NULL, 'NTR_PCOLCE', NULL, 'NTR_PCOLCE', NULL, NULL, 33326, 2),
(6889, NULL, 'cd07343', NULL, NULL, 'M48A_Zmpste24p_like', NULL, 'M48A_Zmpste24p_like', NULL, NULL, 24898, 2),
(6890, NULL, 'cd05694', NULL, NULL, 'S1_Rrp5_repeat_hs2_sc2', NULL, 'S1_Rrp5_repeat_hs2_sc2', NULL, NULL, NULL, 2); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(6891, NULL, 'cd02619', NULL, NULL, 'Peptidase_C1', NULL, 'Peptidase_C1', NULL, NULL, NULL, 2),
(6892, NULL, 'cd07000', NULL, NULL, 'cupin_HGO_N', NULL, 'cupin_HGO_N', NULL, NULL, NULL, 2),
(6893, NULL, 'cd11983', NULL, NULL, 'SH3_Shank2', NULL, 'SH3_Shank2', NULL, NULL, NULL, 2),
(6894, NULL, 'cd05256', NULL, NULL, 'UDP_AE_SDR_e', NULL, 'UDP_AE_SDR_e', NULL, NULL, NULL, 2),
(6895, NULL, 'cd15286', NULL, NULL, '7tmC_mGluR_group3', NULL, '7tmC_mGluR_group3', NULL, NULL, NULL, 2),
(6896, NULL, 'cd15499', NULL, NULL, 'PHD1_MTF2_PHF19_like', NULL, 'PHD1_MTF2_PHF19_like', NULL, NULL, NULL, 2),
(6897, NULL, 'cd16364', NULL, NULL, 'T3SC_I_like', NULL, 'T3SC_I_like', NULL, NULL, NULL, 2),
(6898, NULL, 'cd12362', NULL, NULL, 'RRM3_CELF1-6', NULL, 'RRM3_CELF1-6', NULL, NULL, NULL, 2),
(6899, NULL, 'cd12502', NULL, NULL, 'RRM2_RMB19', NULL, 'RRM2_RMB19', NULL, NULL, 12980, 2),
(6900, NULL, 'cd11400', NULL, NULL, 'bHLHzip_Myc', NULL, 'bHLHzip_Myc', NULL, NULL, NULL, 2),
(6901, NULL, 'cd14306', NULL, NULL, 'UBA_VP13D', NULL, 'UBA_VP13D', NULL, NULL, 30274, 2),
(6902, NULL, 'cd10296', NULL, NULL, 'GST_C_CLIC4', NULL, 'GST_C_CLIC4', NULL, NULL, NULL, 2),
(6903, NULL, 'cd11946', NULL, NULL, 'SH3_GRB2_N', NULL, 'SH3_GRB2_N', NULL, NULL, 28001, 2),
(6904, NULL, 'cd00253', NULL, NULL, 'PL_Passenger_AT', NULL, 'PL_Passenger_AT', NULL, NULL, NULL, 2),
(6905, NULL, 'cd10358', NULL, NULL, 'SH2_PTK6_Brk', NULL, 'SH2_PTK6_Brk', NULL, NULL, 28817, 2),
(6906, NULL, 'cd18926', NULL, NULL, 'bHLHzip_MITF', NULL, 'bHLHzip_MITF', NULL, NULL, NULL, 2),
(6907, NULL, 'cd18658', NULL, NULL, 'CSD_HP1a_insect', NULL, 'CSD_HP1a_insect', NULL, NULL, NULL, 2),
(6908, NULL, 'cd08493', NULL, NULL, 'PBP2_DppA_like', NULL, 'PBP2_DppA_like', NULL, NULL, NULL, 2),
(6909, NULL, 'cd03721', NULL, NULL, 'SOCS_ASB2', NULL, 'SOCS_ASB2', NULL, NULL, 30939, 2),
(6910, NULL, 'cd15970', NULL, NULL, '7tmA_SSTR1', NULL, '7tmA_SSTR1', NULL, NULL, NULL, 2),
(6911, NULL, 'cd18257', NULL, NULL, 'BTB_POZ_KLHL28_BTBD5', NULL, 'BTB_POZ_KLHL28_BTBD5', NULL, NULL, NULL, 2),
(6912, NULL, 'cd00584', NULL, NULL, 'Prefoldin_alpha', NULL, 'Prefoldin_alpha', NULL, NULL, NULL, 2),
(6913, NULL, 'cd16471', NULL, NULL, 'RING-H2_RNF32', NULL, 'RING-H2_RNF32', NULL, NULL, NULL, 2),
(6914, NULL, 'cd10582', NULL, NULL, 'TNFRSF14', NULL, 'TNFRSF14', NULL, NULL, 31428, 2),
(6915, NULL, 'cd16101', NULL, NULL, 'ING', NULL, 'ING', NULL, NULL, NULL, 2),
(6916, NULL, 'cd12000', NULL, NULL, 'SH3_CASS4', NULL, 'SH3_CASS4', NULL, NULL, 28285, 2),
(6917, NULL, 'cd03057', NULL, NULL, 'GST_N_Beta', NULL, 'GST_N_Beta', NULL, NULL, NULL, 2),
(6918, NULL, 'cd14027', NULL, NULL, 'STKc_RIP1', NULL, 'STKc_RIP1', NULL, NULL, NULL, 2),
(6919, NULL, 'cd17260', NULL, NULL, 'RMtype1_S_EcoEI-TRD1-CR1_like', NULL, 'RMtype1_S_EcoEI-TRD1-CR1_like', NULL, NULL, NULL, 2),
(6920, NULL, 'cd03505', NULL, NULL, 'Delta9-FADS-like', NULL, 'Delta9-FADS-like', NULL, NULL, 7445, 2),
(6921, NULL, 'cd15037', NULL, NULL, '7tmF_FZD10', NULL, '7tmF_FZD10', NULL, NULL, NULL, 2),
(6922, NULL, 'cd15252', NULL, NULL, '7tmB2_Latrophilin_Adhesion_I', NULL, '7tmB2_Latrophilin_Adhesion_I', NULL, NULL, NULL, 2),
(6923, NULL, 'cd16194', NULL, NULL, 'EFh_PEF_CAPN12', NULL, 'EFh_PEF_CAPN12', NULL, NULL, NULL, 2),
(6924, NULL, 'cd10446', NULL, NULL, 'GIY-YIG_unchar_1', NULL, 'GIY-YIG_unchar_1', NULL, NULL, NULL, 2),
(6925, NULL, 'cd13963', NULL, NULL, 'PT_UbiA_2', NULL, 'PT_UbiA_2', NULL, NULL, NULL, 2),
(6926, NULL, 'cd16302', NULL, NULL, 'CcrA-like_MBL-B1', NULL, 'CcrA-like_MBL-B1', NULL, NULL, NULL, 2),
(6927, NULL, 'cd04440', NULL, NULL, 'DEP_2_P-Rex', NULL, 'DEP_2_P-Rex', NULL, NULL, NULL, 2),
(6928, NULL, 'cd16368', NULL, NULL, 'DMSOR_beta_like', NULL, 'DMSOR_beta_like', NULL, NULL, NULL, 2),
(6929, NULL, 'cd12366', NULL, NULL, 'RRM1_RBM45', NULL, 'RRM1_RBM45', NULL, NULL, 18474, 2),
(6930, NULL, 'cd08022', NULL, NULL, 'M28_PSMA_like', NULL, 'M28_PSMA_like', NULL, NULL, NULL, 2),
(6931, NULL, 'cd04782', NULL, NULL, 'HTH_BltR', NULL, 'HTH_BltR', NULL, NULL, NULL, 2),
(6932, NULL, 'cd09591', NULL, NULL, 'SAM_DLC1', NULL, 'SAM_DLC1', NULL, NULL, NULL, 2);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(6933, NULL, 'cd10383', NULL, NULL, 'SH2_SOCS2', NULL, 'SH2_SOCS2', NULL, NULL, 31992, 2),
(6934, NULL, 'cd15210', NULL, NULL, '7tmA_GPR84-like', NULL, '7tmA_GPR84-like', NULL, NULL, NULL, 2),
(6935, NULL, 'cd12294', NULL, NULL, 'RRM_Rrp7A', NULL, 'RRM_Rrp7A', NULL, NULL, 11084, 2),
(6936, NULL, 'cd19727', NULL, NULL, 'bHLH-PAS_HIF1a_PASD8', NULL, 'bHLH-PAS_HIF1a_PASD8', NULL, NULL, NULL, 2),
(6937, NULL, 'cd19879', NULL, NULL, 'DSRM_STAU1_rpt1', NULL, 'DSRM_STAU1_rpt1', NULL, NULL, NULL, 2),
(6938, NULL, 'cd18773', NULL, NULL, 'PDC1_HK_sensor', NULL, 'PDC1_HK_sensor', NULL, NULL, NULL, 2),
(6939, NULL, 'cd04868', NULL, NULL, 'ACT_AK-like', NULL, 'ACT_AK-like', NULL, NULL, NULL, 2),
(6940, NULL, 'cd18175', NULL, NULL, 'ATP-synt_Vo_c_ATP6C_rpt1', NULL, 'ATP-synt_Vo_c_ATP6C_rpt1', NULL, NULL, NULL, 2),
(6941, NULL, 'cd12067', NULL, NULL, 'SH3_MYO15A', NULL, 'SH3_MYO15A', NULL, NULL, NULL, 2),
(6942, NULL, 'cd12601', NULL, NULL, 'RRM2_SRSF1_like', NULL, 'RRM2_SRSF1_like', NULL, NULL, NULL, 2),
(6943, NULL, 'cd09756', NULL, NULL, 'Cas5_I-E', NULL, 'Cas5_I-E', NULL, NULL, NULL, 2),
(6944, NULL, 'cd10229', NULL, NULL, 'HSPA12_like_NBD', NULL, 'HSPA12_like_NBD', NULL, NULL, NULL, 2),
(6945, NULL, 'cd09553', NULL, NULL, 'SAM_EPH-B3', NULL, 'SAM_EPH-B3', NULL, NULL, NULL, 2),
(6946, NULL, 'cd07719', NULL, NULL, 'arylsulfatase_AtsA-like_MBL-fold', NULL, 'arylsulfatase_AtsA-like_MBL-fold', NULL, NULL, 35051, 2),
(6947, NULL, 'cd19169', NULL, NULL, 'SET_SETD1', NULL, 'SET_SETD1', NULL, NULL, NULL, 2),
(6948, NULL, 'cd01268', NULL, NULL, 'PTB_Numb', NULL, 'PTB_Numb', NULL, NULL, NULL, 2),
(6949, NULL, 'cd11677', NULL, NULL, 'Gemin7', NULL, 'Gemin7', NULL, NULL, 19995, 2),
(6950, NULL, 'cd06827', NULL, NULL, 'PLPDE_III_AR_proteobact', NULL, 'PLPDE_III_AR_proteobact', NULL, NULL, NULL, 2),
(6951, NULL, 'cd13266', NULL, NULL, 'PH_Skap_family', NULL, 'PH_Skap_family', NULL, NULL, NULL, 2),
(6952, NULL, 'cd09160', NULL, NULL, 'PLDc_SMU_988_like_2', NULL, 'PLDc_SMU_988_like_2', NULL, NULL, NULL, 2),
(6953, NULL, 'cd13205', NULL, NULL, 'FERM_C_fermitin', NULL, 'FERM_C_fermitin', NULL, NULL, NULL, 2),
(6954, NULL, 'cd10805', NULL, NULL, 'YdjC_like_1', NULL, 'YdjC_like_1', NULL, NULL, NULL, 2),
(6955, NULL, 'cd17309', NULL, NULL, 'PIPKc_PIP5K2A', NULL, 'PIPKc_PIP5K2A', NULL, NULL, NULL, 2),
(6956, NULL, 'cd19814', NULL, NULL, 'Bbox1_RNF207-like', NULL, 'Bbox1_RNF207-like', NULL, NULL, NULL, 2),
(6957, NULL, 'cd07970', NULL, NULL, 'OBF_DNA_ligase_LigC', NULL, 'OBF_DNA_ligase_LigC', NULL, NULL, 36183, 2),
(6958, NULL, 'cd18611', NULL, NULL, 'GH130', NULL, 'GH130', NULL, NULL, NULL, 2),
(6959, NULL, 'cd20255', NULL, NULL, 'CASIMO1_SMIM22', NULL, 'CASIMO1_SMIM22', NULL, NULL, NULL, 2),
(6960, NULL, 'cd07164', NULL, NULL, 'NR_DBD_PNR_like_1', NULL, 'NR_DBD_PNR_like_1', NULL, NULL, NULL, 2),
(6961, NULL, 'cd13778', NULL, NULL, 'Aar2_C', NULL, 'Aar2_C', NULL, NULL, 30301, 2),
(6962, NULL, 'cd09561', NULL, NULL, 'SAM_SAMSN1', NULL, 'SAM_SAMSN1', NULL, NULL, 32216, 2),
(6963, NULL, 'cd15180', NULL, NULL, '7tmA_CXCR3', NULL, '7tmA_CXCR3', NULL, NULL, NULL, 2),
(6964, NULL, 'cd00987', NULL, NULL, 'PDZ_serine_protease', NULL, 'PDZ_serine_protease', NULL, NULL, NULL, 2),
(6965, NULL, 'cd12385', NULL, NULL, 'RRM1_hnRNPM_like', NULL, 'RRM1_hnRNPM_like', NULL, NULL, NULL, 2),
(6966, NULL, 'cd15054', NULL, NULL, '7tmA_5-HT6', NULL, '7tmA_5-HT6', NULL, NULL, 167, 2),
(6967, NULL, 'cd12112', NULL, NULL, 'PHP_HisPPase_Chlorobi_like', NULL, 'PHP_HisPPase_Chlorobi_like', NULL, NULL, NULL, 2),
(6968, NULL, 'cd16110', NULL, NULL, 'DCX1_RP_like', NULL, 'DCX1_RP_like', NULL, NULL, NULL, 2),
(6969, NULL, 'cd07414', NULL, NULL, 'MPP_PP1_PPKL', NULL, 'MPP_PP1_PPKL', NULL, NULL, NULL, 2),
(6970, NULL, 'cd11843', NULL, NULL, 'SH3_PACSIN', NULL, 'SH3_PACSIN', NULL, NULL, NULL, 2),
(6971, NULL, 'cd12474', NULL, NULL, 'RRM2_MSSP2', NULL, 'RRM2_MSSP2', NULL, NULL, NULL, 2),
(6972, NULL, 'cd09344', NULL, NULL, 'LIM1_FHL1', NULL, 'LIM1_FHL1', NULL, NULL, NULL, 2),
(6973, NULL, 'cd12065', NULL, NULL, 'SH3_GRAF2', NULL, 'SH3_GRAF2', NULL, NULL, 17488, 2); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(6974, NULL, 'cd01292', NULL, NULL, 'metallo-dependent_hydrolases', NULL, 'metallo-dependent_hydrolases', NULL, NULL, NULL, 2),
(6975, NULL, 'cd09806', NULL, NULL, 'type1_17beta-HSD-like_SDR_c', NULL, 'type1_17beta-HSD-like_SDR_c', NULL, NULL, NULL, 2),
(6976, NULL, 'cd07098', NULL, NULL, 'ALDH_F15-22', NULL, 'ALDH_F15-22', NULL, NULL, NULL, 2),
(6977, NULL, 'cd08457', NULL, NULL, 'PBP2_OccR', NULL, 'PBP2_OccR', NULL, NULL, 30790, 2),
(6978, NULL, 'cd18317', NULL, NULL, 'BTB_POZ_Kv', NULL, 'BTB_POZ_Kv', NULL, NULL, NULL, 2),
(6979, NULL, 'cd04860', NULL, NULL, 'AE_Prim_S', NULL, 'AE_Prim_S', NULL, NULL, 9089, 2),
(6980, NULL, 'cd03222', NULL, NULL, 'ABC_RNaseL_inhibitor', NULL, 'ABC_RNaseL_inhibitor', NULL, NULL, NULL, 2),
(6981, NULL, 'cd17714', NULL, NULL, 'BRCT_PAXIP1_rpt1', NULL, 'BRCT_PAXIP1_rpt1', NULL, NULL, NULL, 2),
(6982, NULL, 'cd14051', NULL, NULL, 'PTKc_Wee1', NULL, 'PTKc_Wee1', NULL, NULL, NULL, 2),
(6983, NULL, 'cd15989', NULL, NULL, '7tmB2_BAI3', NULL, '7tmB2_BAI3', NULL, NULL, NULL, 2),
(6984, NULL, 'cd02854', NULL, NULL, 'E_set_GBE_euk_N', NULL, 'E_set_GBE_euk_N', NULL, NULL, NULL, 2),
(6985, NULL, 'cd20315', NULL, NULL, 'DSRM_mL44_subfamily', NULL, 'DSRM_mL44_subfamily', NULL, NULL, NULL, 2),
(6986, NULL, 'cd07143', NULL, NULL, 'ALDH_AldA_AN0554', NULL, 'ALDH_AldA_AN0554', NULL, NULL, NULL, 2),
(6987, NULL, 'cd07324', NULL, NULL, 'M48C_Oma1-like', NULL, 'M48C_Oma1-like', NULL, NULL, NULL, 2),
(6988, NULL, 'cd15393', NULL, NULL, '7tmA_leucokinin-like', NULL, '7tmA_leucokinin-like', NULL, NULL, NULL, 2),
(6989, NULL, 'cd06103', NULL, NULL, 'ScCS-like', NULL, 'ScCS-like', NULL, NULL, NULL, 2),
(6990, NULL, 'cd15619', NULL, NULL, 'PHD1_d4', NULL, 'PHD1_d4', NULL, NULL, NULL, 2),
(6991, NULL, 'cd19729', NULL, NULL, 'bHLH-PAS_HIF3a_PASD7', NULL, 'bHLH-PAS_HIF3a_PASD7', NULL, NULL, NULL, 2),
(6992, NULL, 'cd10954', NULL, NULL, 'CE4_CtAXE_like', NULL, 'CE4_CtAXE_like', NULL, NULL, NULL, 2),
(6993, NULL, 'cd21562', NULL, NULL, 'Macro_cv_SUD-N_Nsp3-like', NULL, 'Macro_cv_SUD-N_Nsp3-like', NULL, NULL, 36150, 2),
(6994, NULL, 'cd16582', NULL, NULL, 'RING-HC_TRIM31_C-V', NULL, 'RING-HC_TRIM31_C-V', NULL, NULL, NULL, 2),
(6995, NULL, 'cd10003', NULL, NULL, 'HDAC6-dom2', NULL, 'HDAC6-dom2', NULL, NULL, NULL, 2),
(6996, NULL, 'cd09822', NULL, NULL, 'peroxinectin_like_bacterial', NULL, 'peroxinectin_like_bacterial', NULL, NULL, NULL, 2),
(6997, NULL, 'cd15102', NULL, NULL, '7tmA_S1PR', NULL, '7tmA_S1PR', NULL, NULL, NULL, 2),
(6998, NULL, 'cd18179', NULL, NULL, 'ATP-synt_Vo_Ao_c_NTPK_rpt1', NULL, 'ATP-synt_Vo_Ao_c_NTPK_rpt1', NULL, NULL, NULL, 2),
(6999, NULL, 'cd15026', NULL, NULL, '7tm_TAS2R13', NULL, '7tm_TAS2R13', NULL, NULL, NULL, 2),
(7000, NULL, 'cd03562', NULL, NULL, 'CID', NULL, 'CID', NULL, NULL, NULL, 2),
(7001, NULL, 'cd04924', NULL, NULL, 'ACT_AK-Arch_2', NULL, 'ACT_AK-Arch_2', NULL, NULL, NULL, 2),
(7002, NULL, 'cd09747', NULL, NULL, 'Csx1_III-U', NULL, 'Csx1_III-U', NULL, NULL, NULL, 2),
(7003, NULL, 'cd15900', NULL, NULL, 'EFh_MICU', NULL, 'EFh_MICU', NULL, NULL, NULL, 2),
(7004, NULL, 'cd17070', NULL, NULL, 'DCX2_RP_like', NULL, 'DCX2_RP_like', NULL, NULL, NULL, 2),
(7005, NULL, 'cd18016', NULL, NULL, 'DEXHc_RecQ2_BLM', NULL, 'DEXHc_RecQ2_BLM', NULL, NULL, NULL, 2),
(7006, NULL, 'cd00586', NULL, NULL, '4HBT', NULL, '4HBT', NULL, NULL, NULL, 2),
(7007, NULL, 'cd04305', NULL, NULL, 'HAD_Neu5Ac-Pase_like', NULL, 'HAD_Neu5Ac-Pase_like', NULL, NULL, NULL, 2),
(7008, NULL, 'cd11977', NULL, NULL, 'SH3_VAV2_2', NULL, 'SH3_VAV2_2', NULL, NULL, 27621, 2),
(7009, NULL, 'cd14693', NULL, NULL, 'bZIP_CEBP', NULL, 'bZIP_CEBP', NULL, NULL, NULL, 2),
(7010, NULL, 'cd03295', NULL, NULL, 'ABC_OpuCA_Osmoprotection', NULL, 'ABC_OpuCA_Osmoprotection', NULL, NULL, NULL, 2),
(7011, NULL, 'cd11978', NULL, NULL, 'SH3_VAV3_2', NULL, 'SH3_VAV3_2', NULL, NULL, 27609, 2),
(7012, NULL, 'cd12614', NULL, NULL, 'RRM1_PUB1', NULL, 'RRM1_PUB1', NULL, NULL, 17153, 2),
(7013, NULL, 'cd16997', NULL, NULL, 'VHS_Tom1L1', NULL, 'VHS_Tom1L1', NULL, NULL, NULL, 2),
(7014, NULL, 'cd04511', NULL, NULL, 'Nudix_Hydrolase_4', NULL, 'Nudix_Hydrolase_4', NULL, NULL, NULL, 2);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(7015, NULL, 'cd12802', NULL, NULL, 'HopAB_PID', NULL, 'HopAB_PID', NULL, NULL, 32733, 2),
(7016, NULL, 'cd15424', NULL, NULL, '7tmA_OR2_unk', NULL, '7tmA_OR2_unk', NULL, NULL, NULL, 2),
(7017, NULL, 'cd11248', NULL, NULL, 'Sema_MET_like', NULL, 'Sema_MET_like', NULL, NULL, NULL, 2),
(7018, NULL, 'cd19974', NULL, NULL, 'PBP1_LacI-like', NULL, 'PBP1_LacI-like', NULL, NULL, NULL, 2),
(7019, NULL, 'cd21588', NULL, NULL, 'alphaCoV_RdRp', NULL, 'alphaCoV_RdRp', NULL, NULL, 36299, 2),
(7020, NULL, 'cd15711', NULL, NULL, 'ePHD2_PHF6', NULL, 'ePHD2_PHF6', NULL, NULL, NULL, 2),
(7021, NULL, 'cd16727', NULL, NULL, 'RING3-HC_MIB1', NULL, 'RING3-HC_MIB1', NULL, NULL, NULL, 2),
(7022, NULL, 'cd17392', NULL, NULL, 'MFS_MFSD2', NULL, 'MFS_MFSD2', NULL, NULL, NULL, 2),
(7023, NULL, 'cd12800', NULL, NULL, 'Sol_i_2', NULL, 'Sol_i_2', NULL, NULL, 13746, 2),
(7024, NULL, 'cd17776', NULL, NULL, 'CBS_pair_arch', NULL, 'CBS_pair_arch', NULL, NULL, NULL, 2),
(7025, NULL, 'cd05130', NULL, NULL, 'RasGAP_Neurofibromin', NULL, 'RasGAP_Neurofibromin', NULL, NULL, NULL, 2),
(7026, NULL, 'cd15170', NULL, NULL, '7tmA_FFAR2_FFAR3', NULL, '7tmA_FFAR2_FFAR3', NULL, NULL, NULL, 2),
(7027, NULL, 'cd15447', NULL, NULL, '7tmC_mGluR2', NULL, '7tmC_mGluR2', NULL, NULL, NULL, 2),
(7028, NULL, 'cd04224', NULL, NULL, 'CuRO_3_ceruloplasmin', NULL, 'CuRO_3_ceruloplasmin', NULL, NULL, NULL, 2),
(7029, NULL, 'cd13899', NULL, NULL, 'CuRO_3_Fet3p', NULL, 'CuRO_3_Fet3p', NULL, NULL, NULL, 2),
(7030, NULL, 'cd16800', NULL, NULL, 'RING-H2_RNF115', NULL, 'RING-H2_RNF115', NULL, NULL, NULL, 2),
(7031, NULL, 'cd07695', NULL, NULL, 'Ig3_CD4', NULL, 'Ig3_CD4', NULL, NULL, NULL, 2),
(7032, NULL, 'cd03288', NULL, NULL, 'ABCC_SUR2', NULL, 'ABCC_SUR2', NULL, NULL, NULL, 2),
(7033, NULL, 'cd05744', NULL, NULL, 'Ig_Myotilin_C_like', NULL, 'Ig_Myotilin_C_like', NULL, NULL, NULL, 2),
(7034, NULL, 'cd13219', NULL, NULL, 'PH-GRAM_C2-GRAM', NULL, 'PH-GRAM_C2-GRAM', NULL, NULL, NULL, 2),
(7035, NULL, 'cd03780', NULL, NULL, 'MATH_TRAF5', NULL, 'MATH_TRAF5', NULL, NULL, 27510, 2),
(7036, NULL, 'cd14692', NULL, NULL, 'bZIP_ATF4', NULL, 'bZIP_ATF4', NULL, NULL, NULL, 2),
(7037, NULL, 'cd19071', NULL, NULL, 'AKR_AKR1-5-like', NULL, 'AKR_AKR1-5-like', NULL, NULL, NULL, 2),
(7038, NULL, 'cd12766', NULL, NULL, 'RRM2_SRSF6', NULL, 'RRM2_SRSF6', NULL, NULL, NULL, 2),
(7039, NULL, 'cd01584', NULL, NULL, 'AcnA_Mitochondrial', NULL, 'AcnA_Mitochondrial', NULL, NULL, NULL, 2),
(7040, NULL, 'cd06567', NULL, NULL, 'Peptidase_S41', NULL, 'Peptidase_S41', NULL, NULL, NULL, 2),
(7041, NULL, 'cd15201', NULL, NULL, '7tmA_HCAR1-3', NULL, '7tmA_HCAR1-3', NULL, NULL, NULL, 2),
(7042, NULL, 'cd19913', NULL, NULL, 'DSRM_DRADA_rpt1', NULL, 'DSRM_DRADA_rpt1', NULL, NULL, 35332, 2),
(7043, NULL, 'cd09090', NULL, NULL, 'INPP5c_ScInp51p-like', NULL, 'INPP5c_ScInp51p-like', NULL, NULL, NULL, 2),
(7044, NULL, 'cd07184', NULL, NULL, 'E_set_Isoamylase_like_N', NULL, 'E_set_Isoamylase_like_N', NULL, NULL, NULL, 2),
(7045, NULL, 'cd02414', NULL, NULL, 'jag_KH', NULL, 'jag_KH', NULL, NULL, 27514, 2),
(7046, NULL, 'cd04413', NULL, NULL, 'NDPk_I', NULL, 'NDPk_I', NULL, NULL, NULL, 2),
(7047, NULL, 'cd00093', NULL, NULL, 'HTH_XRE', NULL, 'HTH_XRE', NULL, NULL, 2217, 2),
(7048, NULL, 'cd15256', NULL, NULL, '7tmB2_GPR133', NULL, '7tmB2_GPR133', NULL, NULL, NULL, 2),
(7049, NULL, 'cd01319', NULL, NULL, 'AMPD', NULL, 'AMPD', NULL, NULL, 4562, 2),
(7050, NULL, 'cd09642', NULL, NULL, 'Cas8c_I-C', NULL, 'Cas8c_I-C', NULL, NULL, NULL, 2),
(7051, NULL, 'cd03275', NULL, NULL, 'ABC_SMC1_euk', NULL, 'ABC_SMC1_euk', NULL, NULL, 25360, 2),
(7052, NULL, 'cd16975', NULL, NULL, 'HATPase_SpaK_NisK-like', NULL, 'HATPase_SpaK_NisK-like', NULL, NULL, 35066, 2),
(7053, NULL, 'cd09178', NULL, NULL, 'PLDc_N_Snf2_like', NULL, 'PLDc_N_Snf2_like', NULL, NULL, NULL, 2),
(7054, NULL, 'cd12835', NULL, NULL, 'EcCorA-like_1', NULL, 'EcCorA-like_1', NULL, NULL, NULL, 2),
(7055, NULL, 'cd01272', NULL, NULL, 'PTB1_Fe65', NULL, 'PTB1_Fe65', NULL, NULL, NULL, 2),
(7056, NULL, 'cd16130', NULL, NULL, 'RA_Rin3', NULL, 'RA_Rin3', NULL, NULL, NULL, 2);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(7057, NULL, 'cd06149', NULL, NULL, 'ISG20', NULL, 'ISG20', NULL, NULL, 30883, 2),
(7058, NULL, 'cd06353', NULL, NULL, 'PBP1_Med-like', NULL, 'PBP1_Med-like', NULL, NULL, NULL, 2),
(7059, NULL, 'cd08622', NULL, NULL, 'PI-PLCXDc_CG14945_like', NULL, 'PI-PLCXDc_CG14945_like', NULL, NULL, NULL, 2),
(7060, NULL, 'cd10952', NULL, NULL, 'CE4_MrCDA_like', NULL, 'CE4_MrCDA_like', NULL, NULL, NULL, 2),
(7061, NULL, 'cd15208', NULL, NULL, '7tmA_OXR', NULL, '7tmA_OXR', NULL, NULL, NULL, 2),
(7062, NULL, 'cd17224', NULL, NULL, 'RA_ASPP1', NULL, 'RA_ASPP1', NULL, NULL, NULL, 2),
(7063, NULL, 'cd17668', NULL, NULL, 'R-PTPc-Z-1', NULL, 'R-PTPc-Z-1', NULL, NULL, NULL, 2),
(7064, NULL, 'cd17367', NULL, NULL, 'MFS_KgtP', NULL, 'MFS_KgtP', NULL, NULL, NULL, 2),
(7065, NULL, 'cd09001', NULL, NULL, 'GH43_FsAxh1-like', NULL, 'GH43_FsAxh1-like', NULL, NULL, NULL, 2),
(7066, NULL, 'cd17554', NULL, NULL, 'REC_TrrA-like', NULL, 'REC_TrrA-like', NULL, NULL, NULL, 2),
(7067, NULL, 'cd14957', NULL, NULL, 'NHL_like_2', NULL, 'NHL_like_2', NULL, NULL, NULL, 2),
(7068, NULL, 'cd13661', NULL, NULL, 'PBP2_PotD_PotF_like_1', NULL, 'PBP2_PotD_PotF_like_1', NULL, NULL, NULL, 2),
(7069, NULL, 'cd16818', NULL, NULL, 'SP-RING_PIAS1', NULL, 'SP-RING_PIAS1', NULL, NULL, NULL, 2),
(7070, NULL, 'cd04774', NULL, NULL, 'HTH_YfmP', NULL, 'HTH_YfmP', NULL, NULL, 27913, 2),
(7071, NULL, 'cd06869', NULL, NULL, 'PX_UP2_fungi', NULL, 'PX_UP2_fungi', NULL, NULL, NULL, 2),
(7072, NULL, 'cd01945', NULL, NULL, 'ribokinase_group_B', NULL, 'ribokinase_group_B', NULL, NULL, NULL, 2),
(7073, NULL, 'cd07993', NULL, NULL, 'LPLAT_DHAPAT-like', NULL, 'LPLAT_DHAPAT-like', NULL, NULL, 29681, 2),
(7074, NULL, 'cd16829', NULL, NULL, 'ChuX_HutX-like', NULL, 'ChuX_HutX-like', NULL, NULL, 9497, 2),
(7075, NULL, 'cd09760', NULL, NULL, 'Cas6_III', NULL, 'Cas6_III', NULL, NULL, NULL, 2),
(7076, NULL, 'cd19835', NULL, NULL, 'Bbox2_TRIM65_C-IV', NULL, 'Bbox2_TRIM65_C-IV', NULL, NULL, NULL, 2),
(7077, NULL, 'cd05150', NULL, NULL, 'APH', NULL, 'APH', NULL, NULL, 12787, 2),
(7078, NULL, 'cd12704', NULL, NULL, 'RRM4_hnRNPL', NULL, 'RRM4_hnRNPL', NULL, NULL, 33035, 2),
(7079, NULL, 'cd09463', NULL, NULL, 'LIM1_LIMK2', NULL, 'LIM1_LIMK2', NULL, NULL, NULL, 2),
(7080, NULL, 'cd17589', NULL, NULL, 'REC_TPR', NULL, 'REC_TPR', NULL, NULL, NULL, 2),
(7081, NULL, 'cd14920', NULL, NULL, 'MYSc_Myh10', NULL, 'MYSc_Myh10', NULL, NULL, NULL, 2),
(7082, NULL, 'cd16625', NULL, NULL, 'RING-HC_RBR_HEL2_like', NULL, 'RING-HC_RBR_HEL2_like', NULL, NULL, NULL, 2),
(7083, NULL, 'cd13127', NULL, NULL, 'MATE_tuaB_like', NULL, 'MATE_tuaB_like', NULL, NULL, NULL, 2),
(7084, NULL, 'cd07563', NULL, NULL, 'Peptidase_S41_IRBP', NULL, 'Peptidase_S41_IRBP', NULL, NULL, NULL, 2),
(7085, NULL, 'cd05596', NULL, NULL, 'STKc_ROCK', NULL, 'STKc_ROCK', NULL, NULL, NULL, 2),
(7086, NULL, 'cd07421', NULL, NULL, 'MPP_Rhilphs', NULL, 'MPP_Rhilphs', NULL, NULL, 30942, 2),
(7087, NULL, 'cd11930', NULL, NULL, 'SH3_SH3RF1_2', NULL, 'SH3_SH3RF1_2', NULL, NULL, 32681, 2),
(7088, NULL, 'cd12709', NULL, NULL, 'RRM_RCAN2', NULL, 'RRM_RCAN2', NULL, NULL, 11009, 2),
(7089, NULL, 'cd04227', NULL, NULL, 'CuRO_3_FVIII_like', NULL, 'CuRO_3_FVIII_like', NULL, NULL, NULL, 2),
(7090, NULL, 'cd05699', NULL, NULL, 'S1_Rrp5_repeat_hs7', NULL, 'S1_Rrp5_repeat_hs7', NULL, NULL, NULL, 2),
(7091, NULL, 'cd11669', NULL, NULL, 'TTHB210-like', NULL, 'TTHB210-like', NULL, NULL, 31781, 2),
(7092, NULL, 'cd13561', NULL, NULL, 'PBP2_SsuA_like_4', NULL, 'PBP2_SsuA_like_4', NULL, NULL, NULL, 2),
(7093, NULL, 'cd08827', NULL, NULL, 'SPFH_podocin', NULL, 'SPFH_podocin', NULL, NULL, NULL, 2),
(7094, NULL, 'cd13185', NULL, NULL, 'FERM_C_FRMD1_FRMD6', NULL, 'FERM_C_FRMD1_FRMD6', NULL, NULL, 30729, 2),
(7095, NULL, 'cd19719', NULL, NULL, 'bHLH_TS_NeuroD1', NULL, 'bHLH_TS_NeuroD1', NULL, NULL, NULL, 2),
(7096, NULL, 'cd02811', NULL, NULL, 'IDI-2_FMN', NULL, 'IDI-2_FMN', NULL, NULL, 10669, 2),
(7097, NULL, 'cd14069', NULL, NULL, 'STKc_Chk1', NULL, 'STKc_Chk1', NULL, NULL, 8573, 2),
(7098, NULL, 'cd15036', NULL, NULL, '7tmF_FZD9', NULL, '7tmF_FZD9', NULL, NULL, NULL, 2);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(7099, NULL, 'cd07459', NULL, NULL, 'CRD_TK_ROR_like', NULL, 'CRD_TK_ROR_like', NULL, NULL, 30966, 2),
(7100, NULL, 'cd07939', NULL, NULL, 'DRE_TIM_NifV', NULL, 'DRE_TIM_NifV', NULL, NULL, 10411, 2),
(7101, NULL, 'cd08907', NULL, NULL, 'START_STARD8-like', NULL, 'START_STARD8-like', NULL, NULL, NULL, 2),
(7102, NULL, 'cd16571', NULL, NULL, 'RING-HC_SIAHs', NULL, 'RING-HC_SIAHs', NULL, NULL, NULL, 2),
(7103, NULL, 'cd19702', NULL, NULL, 'bHLH_TS_HEN2', NULL, 'bHLH_TS_HEN2', NULL, NULL, NULL, 2),
(7104, NULL, 'cd15457', NULL, NULL, 'NADAR', NULL, 'NADAR', NULL, NULL, 12703, 2),
(7105, NULL, 'cd02052', NULL, NULL, 'serpinF1_PEDF', NULL, 'serpinF1_PEDF', NULL, NULL, 31640, 2),
(7106, NULL, 'cd08432', NULL, NULL, 'PBP2_GcdR_TrpI_HvrB_AmpR_like', NULL, 'PBP2_GcdR_TrpI_HvrB_AmpR_like', NULL, NULL, NULL, 2),
(7107, NULL, 'cd06828', NULL, NULL, 'PLPDE_III_DapDC', NULL, 'PLPDE_III_DapDC', NULL, NULL, 7012, 2),
(7108, NULL, 'cd05638', NULL, NULL, 'M42', NULL, 'M42', NULL, NULL, NULL, 2),
(7109, NULL, 'cd01820', NULL, NULL, 'PAF_acetylesterase_like', NULL, 'PAF_acetylesterase_like', NULL, NULL, NULL, 2),
(7110, NULL, 'cd03139', NULL, NULL, 'GATase1_PfpI_2', NULL, 'GATase1_PfpI_2', NULL, NULL, NULL, 2),
(7111, NULL, 'cd19000', NULL, NULL, 'LGIC_ECD_GABAAR_G', NULL, 'LGIC_ECD_GABAAR_G', NULL, NULL, NULL, 2),
(7112, NULL, 'cd12841', NULL, NULL, 'TM_EphA1', NULL, 'TM_EphA1', NULL, NULL, NULL, 2),
(7113, NULL, 'cd00315', NULL, NULL, 'Cyt_C5_DNA_methylase', NULL, 'Cyt_C5_DNA_methylase', NULL, NULL, NULL, 2),
(7114, NULL, 'cd00650', NULL, NULL, 'LDH_MDH_like', NULL, 'LDH_MDH_like', NULL, NULL, NULL, 2),
(7115, NULL, 'cd03149', NULL, NULL, 'alpha_CA_VII', NULL, 'alpha_CA_VII', NULL, NULL, 30354, 2),
(7116, NULL, 'cd16466', NULL, NULL, 'RING-H2_RBX2', NULL, 'RING-H2_RBX2', NULL, NULL, NULL, 2),
(7117, NULL, 'cd12959', NULL, NULL, 'MMACHC-like', NULL, 'MMACHC-like', NULL, NULL, 23342, 2),
(7118, NULL, 'cd11940', NULL, NULL, 'SH3_ARHGEF5_19', NULL, 'SH3_ARHGEF5_19', NULL, NULL, NULL, 2),
(7119, NULL, 'cd04895', NULL, NULL, 'ACT_ACR_1', NULL, 'ACT_ACR_1', NULL, NULL, NULL, 2),
(7120, NULL, 'cd17133', NULL, NULL, 'RBD_ARAF', NULL, 'RBD_ARAF', NULL, NULL, NULL, 2),
(7121, NULL, 'cd18012', NULL, NULL, 'DEXQc_arch_SWI2_SNF2', NULL, 'DEXQc_arch_SWI2_SNF2', NULL, NULL, NULL, 2),
(7122, NULL, 'cd04090', NULL, NULL, 'EF2_II_snRNP', NULL, 'EF2_II_snRNP', NULL, NULL, NULL, 2),
(7123, NULL, 'cd19115', NULL, NULL, 'AKR_AKR2D1', NULL, 'AKR_AKR2D1', NULL, NULL, 33598, 2),
(7124, NULL, 'cd21597', NULL, NULL, 'SARS-CoV-2_Orf10', NULL, 'SARS-CoV-2_Orf10', NULL, NULL, 33920, 2),
(7125, NULL, 'cd14893', NULL, NULL, 'MYSc_Myo32', NULL, 'MYSc_Myo32', NULL, NULL, NULL, 2),
(7126, NULL, 'cd17310', NULL, NULL, 'PIPKc_PIP5K2B', NULL, 'PIPKc_PIP5K2B', NULL, NULL, NULL, 2),
(7127, NULL, 'cd08330', NULL, NULL, 'CARD_ASC_NALP1', NULL, 'CARD_ASC_NALP1', NULL, NULL, 32070, 2),
(7128, NULL, 'cd04689', NULL, NULL, 'Nudix_Hydrolase_30', NULL, 'Nudix_Hydrolase_30', NULL, NULL, NULL, 2),
(7129, NULL, 'cd06572', NULL, NULL, 'Histidinol_dh', NULL, 'Histidinol_dh', NULL, NULL, 13893, 2),
(7130, NULL, 'cd08174', NULL, NULL, 'G1PDH-like', NULL, 'G1PDH-like', NULL, NULL, NULL, 2),
(7131, NULL, 'cd10154', NULL, NULL, 'NreA-like_DUF156', NULL, 'NreA-like_DUF156', NULL, NULL, NULL, 2),
(7132, NULL, 'cd09621', NULL, NULL, 'CBM9_like_5', NULL, 'CBM9_like_5', NULL, NULL, NULL, 2),
(7133, NULL, 'cd05561', NULL, NULL, 'Peptidases_S8_4', NULL, 'Peptidases_S8_4', NULL, NULL, NULL, 2),
(7134, NULL, 'cd06190', NULL, NULL, 'T4MO_e_transfer_like', NULL, 'T4MO_e_transfer_like', NULL, NULL, NULL, 2),
(7135, NULL, 'cd03121', NULL, NULL, 'alpha_CARP_X_XI_like', NULL, 'alpha_CARP_X_XI_like', NULL, NULL, 30947, 2),
(7136, NULL, 'cd12736', NULL, NULL, 'RRM1_ESRP1', NULL, 'RRM1_ESRP1', NULL, NULL, 13040, 2),
(7137, NULL, 'cd16260', NULL, NULL, 'EF4_III', NULL, 'EF4_III', NULL, NULL, NULL, 2),
(7138, NULL, 'cd13751', NULL, NULL, 'TGF_beta_GDF8_like', NULL, 'TGF_beta_GDF8_like', NULL, NULL, NULL, 2),
(7139, NULL, 'cd16819', NULL, NULL, 'SP-RING_PIAS2', NULL, 'SP-RING_PIAS2', NULL, NULL, NULL, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(7140, NULL, 'cd17751', NULL, NULL, 'BRCT_microcephalin_rpt3', NULL, 'BRCT_microcephalin_rpt3', NULL, NULL, NULL, 2),
(7141, NULL, 'cd00232', NULL, NULL, 'HemeO-like', NULL, 'HemeO-like', NULL, NULL, NULL, 2),
(7142, NULL, 'cd17269', NULL, NULL, 'RMtype1_S_PluTORF4319P-TRD2-CR2_like', NULL, 'RMtype1_S_PluTORF4319P-TRD2-CR2_like', NULL, NULL, NULL, 2),
(7143, NULL, 'cd15516', NULL, NULL, 'PHD2_KDM5A_like', NULL, 'PHD2_KDM5A_like', NULL, NULL, NULL, 2),
(7144, NULL, 'cd05010', NULL, NULL, 'SIS_AgaS_like', NULL, 'SIS_AgaS_like', NULL, NULL, 28711, 2),
(7145, NULL, 'cd14234', NULL, NULL, 'GAT_GGA_meta', NULL, 'GAT_GGA_meta', NULL, NULL, NULL, 2),
(7146, NULL, 'cd06111', NULL, NULL, 'DsCS_like', NULL, 'DsCS_like', NULL, NULL, NULL, 2),
(7147, NULL, 'cd17344', NULL, NULL, 'MFS_SLC37A1_2', NULL, 'MFS_SLC37A1_2', NULL, NULL, 34731, 2),
(7148, NULL, 'cd02871', NULL, NULL, 'GH18_chitinase_D-like', NULL, 'GH18_chitinase_D-like', NULL, NULL, NULL, 2),
(7149, NULL, 'cd01396', NULL, NULL, 'MeCP2_MBD', NULL, 'MeCP2_MBD', NULL, NULL, NULL, 2),
(7150, NULL, 'cd17306', NULL, NULL, 'PIPKc_PIP5K1A_like', NULL, 'PIPKc_PIP5K1A_like', NULL, NULL, NULL, 2),
(7151, NULL, 'cd06151', NULL, NULL, 'YjgF_YER057c_UK114_like_3', NULL, 'YjgF_YER057c_UK114_like_3', NULL, NULL, NULL, 2),
(7152, NULL, 'cd19799', NULL, NULL, 'Bbox2_MYCBP2', NULL, 'Bbox2_MYCBP2', NULL, NULL, NULL, 2),
(7153, NULL, 'cd07266', NULL, NULL, 'HPCD_N_class_II', NULL, 'HPCD_N_class_II', NULL, NULL, NULL, 2),
(7154, NULL, 'cd19437', NULL, NULL, 'lipocalin_apoD-like', NULL, 'lipocalin_apoD-like', NULL, NULL, NULL, 2),
(7155, NULL, 'cd00557', NULL, NULL, 'Translocase_SecB', NULL, 'Translocase_SecB', NULL, NULL, NULL, 2),
(7156, NULL, 'cd04788', NULL, NULL, 'HTH_NolA-AlbR', NULL, 'HTH_NolA-AlbR', NULL, NULL, NULL, 2),
(7157, NULL, 'cd18033', NULL, NULL, 'DEXDc_FANCM', NULL, 'DEXDc_FANCM', NULL, NULL, 34203, 2),
(7158, NULL, 'cd02577', NULL, NULL, 'PSTD1', NULL, 'PSTD1', NULL, NULL, NULL, 2),
(7159, NULL, 'cd10479', NULL, NULL, 'EphR_LBD_A1', NULL, 'EphR_LBD_A1', NULL, NULL, 23274, 2),
(7160, NULL, 'cd09295', NULL, NULL, 'Sema', NULL, 'Sema', NULL, NULL, NULL, 2),
(7161, NULL, 'cd05131', NULL, NULL, 'RasGAP_IQGAP2', NULL, 'RasGAP_IQGAP2', NULL, NULL, NULL, 2),
(7162, NULL, 'cd16363', NULL, NULL, 'Col_Im_like', NULL, 'Col_Im_like', NULL, NULL, 4245, 2),
(7163, NULL, 'cd14711', NULL, NULL, 'bZIP_CEBPA', NULL, 'bZIP_CEBPA', NULL, NULL, NULL, 2),
(7164, NULL, 'cd07666', NULL, NULL, 'BAR_SNX7', NULL, 'BAR_SNX7', NULL, NULL, 37487, 2),
(7165, NULL, 'cd12031', NULL, NULL, 'SH3_DLG1', NULL, 'SH3_DLG1', NULL, NULL, NULL, 2),
(7166, NULL, 'cd00186', NULL, NULL, 'TOP1Ac', NULL, 'TOP1Ac', NULL, NULL, 10698, 2),
(7167, NULL, 'cd15087', NULL, NULL, '7tmA_NPBWR', NULL, '7tmA_NPBWR', NULL, NULL, NULL, 2),
(7168, NULL, 'cd09857', NULL, NULL, 'PIN_EXO1', NULL, 'PIN_EXO1', NULL, NULL, 34941, 2),
(7169, NULL, 'cd01766', NULL, NULL, 'Ubl_UFM1', NULL, 'Ubl_UFM1', NULL, NULL, NULL, 2),
(7170, NULL, 'cd19348', NULL, NULL, 'Wnt_Wnt5b', NULL, 'Wnt_Wnt5b', NULL, NULL, NULL, 2),
(7171, NULL, 'cd13535', NULL, NULL, 'PBP2_Osm_BCP_like', NULL, 'PBP2_Osm_BCP_like', NULL, NULL, NULL, 2),
(7172, NULL, 'cd01974', NULL, NULL, 'Nitrogenase_MoFe_beta', NULL, 'Nitrogenase_MoFe_beta', NULL, NULL, NULL, 2),
(7173, NULL, 'cd15162', NULL, NULL, '7tmA_PAR', NULL, '7tmA_PAR', NULL, NULL, NULL, 2),
(7174, NULL, 'cd18315', NULL, NULL, 'BTB_POZ_BAB-like', NULL, 'BTB_POZ_BAB-like', NULL, NULL, NULL, 2),
(7175, NULL, 'cd12543', NULL, NULL, 'RRM2_PAR14', NULL, 'RRM2_PAR14', NULL, NULL, 12497, 2),
(7176, NULL, 'cd14102', NULL, NULL, 'STKc_PIM3', NULL, 'STKc_PIM3', NULL, NULL, NULL, 2),
(7177, NULL, 'cd19209', NULL, NULL, 'SET_KMT2D', NULL, 'SET_KMT2D', NULL, NULL, NULL, 2),
(7178, NULL, 'cd15940', NULL, NULL, '7tmA_OR4E-like', NULL, '7tmA_OR4E-like', NULL, NULL, NULL, 2),
(7179, NULL, 'cd11976', NULL, NULL, 'SH3_VAV1_2', NULL, 'SH3_VAV1_2', NULL, NULL, 27557, 2),
(7180, NULL, 'cd18522', NULL, NULL, 'BACK_BTBD1', NULL, 'BACK_BTBD1', NULL, NULL, NULL, 2),
(7181, NULL, 'cd09493', NULL, NULL, 'SAM_SASH-like', NULL, 'SAM_SASH-like', NULL, NULL, NULL, 2);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(7182, NULL, 'cd01610', NULL, NULL, 'PAP2_like', NULL, 'PAP2_like', NULL, NULL, NULL, 2),
(7183, NULL, 'cd12779', NULL, NULL, 'RRM1_ROD1', NULL, 'RRM1_ROD1', NULL, NULL, 20021, 2),
(7184, NULL, 'cd18697', NULL, NULL, 'PIN_VapC_N-like', NULL, 'PIN_VapC_N-like', NULL, NULL, NULL, 2),
(7185, NULL, 'cd10292', NULL, NULL, 'GST_C_YghU_like', NULL, 'GST_C_YghU_like', NULL, NULL, NULL, 2),
(7186, NULL, 'cd15764', NULL, NULL, 'FYVE_Slp4', NULL, 'FYVE_Slp4', NULL, NULL, 36319, 2),
(7187, NULL, 'cd15071', NULL, NULL, '7tmA_Adenosine_R_A1', NULL, '7tmA_Adenosine_R_A1', NULL, NULL, NULL, 2),
(7188, NULL, 'cd15496', NULL, NULL, 'PHD_PHF7_G2E3_like', NULL, 'PHD_PHF7_G2E3_like', NULL, NULL, 30177, 2),
(7189, NULL, 'cd15108', NULL, NULL, '7tmA_MrgprD', NULL, '7tmA_MrgprD', NULL, NULL, NULL, 2),
(7190, NULL, 'cd02977', NULL, NULL, 'ArsC_family', NULL, 'ArsC_family', NULL, NULL, NULL, 2),
(7191, NULL, 'cd03329', NULL, NULL, 'MR_like_4', NULL, 'MR_like_4', NULL, NULL, NULL, 2),
(7192, NULL, 'cd14024', NULL, NULL, 'PK_TRB3', NULL, 'PK_TRB3', NULL, NULL, NULL, 2),
(7193, NULL, 'cd19422', NULL, NULL, 'lipocalin_15-like', NULL, 'lipocalin_15-like', NULL, NULL, NULL, 2),
(7194, NULL, 'cd04725', NULL, NULL, 'OMP_decarboxylase_like', NULL, 'OMP_decarboxylase_like', NULL, NULL, NULL, 2),
(7195, NULL, 'cd17414', NULL, NULL, 'MFS_NPF4', NULL, 'MFS_NPF4', NULL, NULL, NULL, 2),
(7196, NULL, 'cd17926', NULL, NULL, 'DEXHc_RE', NULL, 'DEXHc_RE', NULL, NULL, NULL, 2),
(7197, NULL, 'cd07762', NULL, NULL, 'CYTH-like_Pase_1', NULL, 'CYTH-like_Pase_1', NULL, NULL, 9835, 2),
(7198, NULL, 'cd02006', NULL, NULL, 'TPP_Gcl', NULL, 'TPP_Gcl', NULL, NULL, NULL, 2),
(7199, NULL, 'cd01737', NULL, NULL, 'LSm16_N', NULL, 'LSm16_N', NULL, NULL, 21179, 2),
(7200, NULL, 'cd15859', NULL, NULL, 'SNARE_SYN8', NULL, 'SNARE_SYN8', NULL, NULL, NULL, 2),
(7201, NULL, 'cd04185', NULL, NULL, 'GT_2_like_b', NULL, 'GT_2_like_b', NULL, NULL, NULL, 2),
(7202, NULL, 'cd02137', NULL, NULL, 'MhqN-like', NULL, 'MhqN-like', NULL, NULL, NULL, 2),
(7203, NULL, 'cd17762', NULL, NULL, 'AMN', NULL, 'AMN', NULL, NULL, NULL, 2),
(7204, NULL, 'cd14252', NULL, NULL, 'Dockerin_like', NULL, 'Dockerin_like', NULL, NULL, NULL, 2),
(7205, NULL, 'cd05882', NULL, NULL, 'Ig1_Necl-1', NULL, 'Ig1_Necl-1', NULL, NULL, NULL, 2),
(7206, NULL, 'cd16861', NULL, NULL, 'ING_ING2', NULL, 'ING_ING2', NULL, NULL, NULL, 2),
(7207, NULL, 'cd12172', NULL, NULL, 'PGDH_like_2', NULL, 'PGDH_like_2', NULL, NULL, NULL, 2),
(7208, NULL, 'cd09915', NULL, NULL, 'Rag', NULL, 'Rag', NULL, NULL, NULL, 2),
(7209, NULL, 'cd08164', NULL, NULL, 'MPP_Ted1', NULL, 'MPP_Ted1', NULL, NULL, NULL, 2),
(7210, NULL, 'cd17631', NULL, NULL, 'FACL_FadD13-like', NULL, 'FACL_FadD13-like', NULL, NULL, NULL, 2),
(7211, NULL, 'cd17457', NULL, NULL, 'MFS_SLCO1B_OATP1B', NULL, 'MFS_SLCO1B_OATP1B', NULL, NULL, NULL, 2),
(7212, NULL, 'cd19720', NULL, NULL, 'bHLH_TS_NeuroD2', NULL, 'bHLH_TS_NeuroD2', NULL, NULL, NULL, 2),
(7213, NULL, 'cd05644', NULL, NULL, 'M28_like', NULL, 'M28_like', NULL, NULL, NULL, 2),
(7214, NULL, 'cd18748', NULL, NULL, 'PIN_VapC4-5_FitB-like', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, NULL, 2),
(7215, NULL, 'cd09868', NULL, NULL, 'PIN_XPG_RAD2', NULL, 'PIN_XPG_RAD2', NULL, NULL, NULL, 2),
(7216, NULL, 'cd06090', NULL, NULL, 'KOW_RPL27', NULL, 'KOW_RPL27', NULL, NULL, 30279, 2),
(7217, NULL, 'cd13633', NULL, NULL, 'PBP2_Sa-PDT_like', NULL, 'PBP2_Sa-PDT_like', NULL, NULL, NULL, 2),
(7218, NULL, 'cd08539', NULL, NULL, 'SAM_PNT-ESE-3-like', NULL, 'SAM_PNT-ESE-3-like', NULL, NULL, NULL, 2),
(7219, NULL, 'cd05700', NULL, NULL, 'S1_Rrp5_repeat_hs9', NULL, 'S1_Rrp5_repeat_hs9', NULL, NULL, NULL, 2),
(7220, NULL, 'cd00892', NULL, NULL, 'PIKKc_ATR', NULL, 'PIKKc_ATR', NULL, NULL, NULL, 2),
(7221, NULL, 'cd15288', NULL, NULL, '7tmC_TAS1R2', NULL, '7tmC_TAS1R2', NULL, NULL, NULL, 2),
(7222, NULL, 'cd05662', NULL, NULL, 'M28_like', NULL, 'M28_like', NULL, NULL, NULL, 2),
(7223, NULL, 'cd08053', NULL, NULL, 'Yqbg', NULL, 'Yqbg', NULL, NULL, 7388, 2),
(7224, NULL, 'cd01467', NULL, NULL, 'vWA_BatA_type', NULL, 'vWA_BatA_type', NULL, NULL, 31460, 2);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(7225, NULL, 'cd14057', NULL, NULL, 'PK_ILK', NULL, 'PK_ILK', NULL, NULL, 29580, 2),
(7226, NULL, 'cd14087', NULL, NULL, 'STKc_PSKH1', NULL, 'STKc_PSKH1', NULL, NULL, NULL, 2),
(7227, NULL, 'cd12443', NULL, NULL, 'RRM_MCM3A_like', NULL, 'RRM_MCM3A_like', NULL, NULL, 6727, 2),
(7228, NULL, 'cd16487', NULL, NULL, 'mRING-H2-C3DHC3_ZFPL1', NULL, 'mRING-H2-C3DHC3_ZFPL1', NULL, NULL, NULL, 2),
(7229, NULL, 'cd19858', NULL, NULL, 'DSRM_STAU_rpt2', NULL, 'DSRM_STAU_rpt2', NULL, NULL, NULL, 2),
(7230, NULL, 'cd15713', NULL, NULL, 'ePHD_JMJD2A', NULL, 'ePHD_JMJD2A', NULL, NULL, NULL, 2),
(7231, NULL, 'cd20283', NULL, NULL, 'cupin_DddY', NULL, 'cupin_DddY', NULL, NULL, NULL, 2),
(7232, NULL, 'cd13203', NULL, NULL, 'FERM_C1_myosin_like', NULL, 'FERM_C1_myosin_like', NULL, NULL, NULL, 2),
(7233, NULL, 'cd11739', NULL, NULL, 'HSPH1_NBD', NULL, 'HSPH1_NBD', NULL, NULL, 30258, 2),
(7234, NULL, 'cd12027', NULL, NULL, 'SH3_ZO-2', NULL, 'SH3_ZO-2', NULL, NULL, 33642, 2),
(7235, NULL, 'cd04235', NULL, NULL, 'AAK_CK', NULL, 'AAK_CK', NULL, NULL, 7437, 2),
(7236, NULL, 'cd09375', NULL, NULL, 'LIM2_Lhx1_Lhx5', NULL, 'LIM2_Lhx1_Lhx5', NULL, NULL, NULL, 2),
(7237, NULL, 'cd11463', NULL, NULL, 'bHLH-O_HES2', NULL, 'bHLH-O_HES2', NULL, NULL, NULL, 2),
(7238, NULL, 'cd06965', NULL, NULL, 'NR_DBD_Ppar', NULL, 'NR_DBD_Ppar', NULL, NULL, NULL, 2),
(7239, NULL, 'cd11679', NULL, NULL, 'archaeal_Sm_like', NULL, 'archaeal_Sm_like', NULL, NULL, NULL, 2),
(7240, NULL, 'cd07489', NULL, NULL, 'Peptidases_S8_5', NULL, 'Peptidases_S8_5', NULL, NULL, 22979, 2),
(7241, NULL, 'cd07580', NULL, NULL, 'nitrilase_2', NULL, 'nitrilase_2', NULL, NULL, NULL, 2),
(7242, NULL, 'cd20759', NULL, NULL, 'capping_2-OMTase_Phytoreovirus', NULL, 'capping_2-OMTase_Phytoreovirus', NULL, NULL, 34896, 2),
(7243, NULL, 'cd04918', NULL, NULL, 'ACT_AK1-AT_2', NULL, 'ACT_AK1-AT_2', NULL, NULL, NULL, 2),
(7244, NULL, 'cd08320', NULL, NULL, 'Pyrin_NALPs', NULL, 'Pyrin_NALPs', NULL, NULL, NULL, 2),
(7245, NULL, 'cd19907', NULL, NULL, 'DSRM_AtDRB-like_rpt1', NULL, 'DSRM_AtDRB-like_rpt1', NULL, NULL, 35063, 2),
(7246, NULL, 'cd08875', NULL, NULL, 'START_ArGLABRA2_like', NULL, 'START_ArGLABRA2_like', NULL, NULL, NULL, 2),
(7247, NULL, 'cd09279', NULL, NULL, 'RNase_HI_like', NULL, 'RNase_HI_like', NULL, NULL, NULL, 2),
(7248, NULL, 'cd10400', NULL, NULL, 'SH2_SAP1a', NULL, 'SH2_SAP1a', NULL, NULL, 32584, 2),
(7249, NULL, 'cd15530', NULL, NULL, 'PHD2_d4', NULL, 'PHD2_d4', NULL, NULL, NULL, 2),
(7250, NULL, 'cd11352', NULL, NULL, 'AmyAc_5', NULL, 'AmyAc_5', NULL, NULL, NULL, 2),
(7251, NULL, 'cd01363', NULL, NULL, 'Motor_domain', NULL, 'Motor_domain', NULL, NULL, NULL, 2),
(7252, NULL, 'cd19048', NULL, NULL, 'LGIC_ECD_GABAAR_rho3', NULL, 'LGIC_ECD_GABAAR_rho3', NULL, NULL, NULL, 2),
(7253, NULL, 'cd14757', NULL, NULL, 'GS_EcDosC-like_GGDEF', NULL, 'GS_EcDosC-like_GGDEF', NULL, NULL, 33057, 2),
(7254, NULL, 'cd03242', NULL, NULL, 'ABC_RecF', NULL, 'ABC_RecF', NULL, NULL, NULL, 2),
(7255, NULL, 'cd08152', NULL, NULL, 'y4iL_like', NULL, 'y4iL_like', NULL, NULL, NULL, 2),
(7256, NULL, 'cd00839', NULL, NULL, 'MPP_PAPs', NULL, 'MPP_PAPs', NULL, NULL, 30908, 2),
(7257, NULL, 'cd18659', NULL, NULL, 'CD2_tandem', NULL, 'CD2_tandem', NULL, NULL, NULL, 2),
(7258, NULL, 'cd08573', NULL, NULL, 'GDPD_GDE1', NULL, 'GDPD_GDE1', NULL, NULL, NULL, 2),
(7259, NULL, 'cd02784', NULL, NULL, 'MopB_CT_PHLH', NULL, 'MopB_CT_PHLH', NULL, NULL, NULL, 2),
(7260, NULL, 'cd09735', NULL, NULL, 'Csy1_I-F', NULL, 'Csy1_I-F', NULL, NULL, NULL, 2),
(7261, NULL, 'cd06865', NULL, NULL, 'PX_SNX_like', NULL, 'PX_SNX_like', NULL, NULL, NULL, 2),
(7262, NULL, 'cd11936', NULL, NULL, 'SH3_UBASH3B', NULL, 'SH3_UBASH3B', NULL, NULL, 33782, 2),
(7263, NULL, 'cd07868', NULL, NULL, 'STKc_CDK8', NULL, 'STKc_CDK8', NULL, NULL, NULL, 2),
(7264, NULL, 'cd18286', NULL, NULL, 'BTB2_POZ_BTBD8', NULL, 'BTB2_POZ_BTBD8', NULL, NULL, NULL, 2),
(7265, NULL, 'cd07862', NULL, NULL, 'STKc_CDK6', NULL, 'STKc_CDK6', NULL, NULL, 26515, 2),
(7266, NULL, 'cd19468', NULL, NULL, 'FABP5', NULL, 'FABP5', NULL, NULL, NULL, 2),
(7267, NULL, 'cd19920', NULL, NULL, 'REC_PA4781-like', NULL, 'REC_PA4781-like', NULL, NULL, NULL, 2);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(7268, NULL, 'cd13742', NULL, NULL, 'SPRY_PRY_TRIM72', NULL, 'SPRY_PRY_TRIM72', NULL, NULL, NULL, 2),
(7269, NULL, 'cd08258', NULL, NULL, 'Zn_ADH4', NULL, 'Zn_ADH4', NULL, NULL, NULL, 2),
(7270, NULL, 'cd05302', NULL, NULL, 'FDH', NULL, 'FDH', NULL, NULL, 28359, 2),
(7271, NULL, 'cd06850', NULL, NULL, 'biotinyl_domain', NULL, 'biotinyl_domain', NULL, NULL, NULL, 2),
(7272, NULL, 'cd01080', NULL, NULL, 'NAD_bind_m-THF_DH_Cyclohyd', NULL, 'NAD_bind_m-THF_DH_Cyclohyd', NULL, NULL, 20202, 2),
(7273, NULL, 'cd05125', NULL, NULL, 'Mth938_2P1-like', NULL, 'Mth938_2P1-like', NULL, NULL, 11390, 2),
(7274, NULL, 'cd19978', NULL, NULL, 'PBP1_ABC_ligand_binding-like', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, NULL, 2),
(7275, NULL, 'cd14347', NULL, NULL, 'UBA_Cezanne_like', NULL, 'UBA_Cezanne_like', NULL, NULL, NULL, 2),
(7276, NULL, 'cd03203', NULL, NULL, 'GST_C_Lambda', NULL, 'GST_C_Lambda', NULL, NULL, NULL, 2),
(7277, NULL, 'cd05346', NULL, NULL, 'SDR_c5', NULL, 'SDR_c5', NULL, NULL, NULL, 2),
(7278, NULL, 'cd12081', NULL, NULL, 'SH3_CASK', NULL, 'SH3_CASK', NULL, NULL, 15063, 2),
(7279, NULL, 'cd11566', NULL, NULL, 'eIF1_SUI1', NULL, 'eIF1_SUI1', NULL, NULL, 6610, 2),
(7280, NULL, 'cd05765', NULL, NULL, 'Ig_3', NULL, 'Ig_3', NULL, NULL, NULL, 2),
(7281, NULL, 'cd15679', NULL, NULL, 'PHD_JADE1', NULL, 'PHD_JADE1', NULL, NULL, 31167, 2),
(7282, NULL, 'cd18422', NULL, NULL, 'BTB_POZ_KCNG3', NULL, 'BTB_POZ_KCNG3', NULL, NULL, NULL, 2),
(7283, NULL, 'cd01805', NULL, NULL, 'Ubl_Rad23', NULL, 'Ubl_Rad23', NULL, NULL, NULL, 2),
(7284, NULL, 'cd14843', NULL, NULL, 'D-Ala-D-Ala_dipeptidase_like', NULL, 'D-Ala-D-Ala_dipeptidase_like', NULL, NULL, NULL, 2),
(7285, NULL, 'cd06663', NULL, NULL, 'Biotinyl_lipoyl_domains', NULL, 'Biotinyl_lipoyl_domains', NULL, NULL, NULL, 2),
(7286, NULL, 'cd12887', NULL, NULL, 'SPRY_NHR_like', NULL, 'SPRY_NHR_like', NULL, NULL, NULL, 2),
(7287, NULL, 'cd15110', NULL, NULL, '7tmA_MrgprH', NULL, '7tmA_MrgprH', NULL, NULL, NULL, 2),
(7288, NULL, 'cd14680', NULL, NULL, 'PH_p190RhoGEF', NULL, 'PH_p190RhoGEF', NULL, NULL, 31966, 2),
(7289, NULL, 'cd18045', NULL, NULL, 'DEADc_EIF4AIII_DDX48', NULL, 'DEADc_EIF4AIII_DDX48', NULL, NULL, NULL, 2),
(7290, NULL, 'cd16602', NULL, NULL, 'RING-HC_TRIM41_like_C-IV', NULL, 'RING-HC_TRIM41_like_C-IV', NULL, NULL, NULL, 2),
(7291, NULL, 'cd03064', NULL, NULL, 'TRX_Fd_NuoE', NULL, 'TRX_Fd_NuoE', NULL, NULL, 35177, 2),
(7292, NULL, 'cd00143', NULL, NULL, 'PP2Cc', NULL, 'PP2Cc', NULL, NULL, 2124, 2),
(7293, NULL, 'cd08868', NULL, NULL, 'START_STARD1_3_like', NULL, 'START_STARD1_3_like', NULL, NULL, NULL, 2),
(7294, NULL, 'cd12480', NULL, NULL, 'RRM2_U1A', NULL, 'RRM2_U1A', NULL, NULL, 15379, 2),
(7295, NULL, 'cd07700', NULL, NULL, 'IgV_CD8_beta', NULL, 'IgV_CD8_beta', NULL, NULL, NULL, 2),
(7296, NULL, 'cd00249', NULL, NULL, 'AGE', NULL, 'AGE', NULL, NULL, 21031, 2),
(7297, NULL, 'cd15796', NULL, NULL, 'CIF_like', NULL, 'CIF_like', NULL, NULL, 24263, 2),
(7298, NULL, 'cd14382', NULL, NULL, 'UBA2_RAD23_plant', NULL, 'UBA2_RAD23_plant', NULL, NULL, NULL, 2),
(7299, NULL, 'cd09765', NULL, NULL, 'Csx14_I-U', NULL, 'Csx14_I-U', NULL, NULL, NULL, 2),
(7300, NULL, 'cd17472', NULL, NULL, 'MFS_YajR_like', NULL, 'MFS_YajR_like', NULL, NULL, NULL, 2),
(7301, NULL, 'cd19827', NULL, NULL, 'Bbox2_TRIM67_C-I', NULL, 'Bbox2_TRIM67_C-I', NULL, NULL, NULL, 2),
(7302, NULL, 'cd12093', NULL, NULL, 'TM_ErbB1', NULL, 'TM_ErbB1', NULL, NULL, NULL, 2),
(7303, NULL, 'cd18267', NULL, NULL, 'BTB_POZ_KLHL37_ENC1', NULL, 'BTB_POZ_KLHL37_ENC1', NULL, NULL, NULL, 2),
(7304, NULL, 'sd00042', NULL, NULL, 'LVIVD', NULL, 'LVIVD', NULL, NULL, NULL, 2),
(7305, NULL, 'cd03693', NULL, NULL, 'EF1_alpha_II', NULL, 'EF1_alpha_II', NULL, NULL, NULL, 2),
(7306, NULL, 'cd08829', NULL, NULL, 'SPFH_paraslipin', NULL, 'SPFH_paraslipin', NULL, NULL, NULL, 2),
(7307, NULL, 'cd04027', NULL, NULL, 'C2B_Munc13', NULL, 'C2B_Munc13', NULL, NULL, 31670, 2),
(7308, NULL, 'cd14836', NULL, NULL, 'AP2_Mu_N', NULL, 'AP2_Mu_N', NULL, NULL, 35100, 2),
(7309, NULL, 'cd00152', NULL, NULL, 'PTX', NULL, 'PTX', NULL, NULL, 3338, 2);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(7310, NULL, 'cd11616', NULL, NULL, 'SAF_DH_OX_like', NULL, 'SAF_DH_OX_like', NULL, NULL, NULL, 2),
(7311, NULL, 'cd15879', NULL, NULL, 'SNARE_syntaxin19', NULL, 'SNARE_syntaxin19', NULL, NULL, NULL, 2),
(7312, NULL, 'cd15734', NULL, NULL, 'FYVE_ZFYV1', NULL, 'FYVE_ZFYV1', NULL, NULL, NULL, 2),
(7313, NULL, 'cd18001', NULL, NULL, 'DEXHc_ERCC6L', NULL, 'DEXHc_ERCC6L', NULL, NULL, NULL, 2),
(7314, NULL, 'cd04131', NULL, NULL, 'Rnd', NULL, 'Rnd', NULL, NULL, NULL, 2),
(7315, NULL, 'cd05873', NULL, NULL, 'Ig_Sema4D_like', NULL, 'Ig_Sema4D_like', NULL, NULL, NULL, 2),
(7316, NULL, 'cd19908', NULL, NULL, 'DSRM_AtDRB-like_rpt2', NULL, 'DSRM_AtDRB-like_rpt2', NULL, NULL, 35499, 2),
(7317, NULL, 'cd16329', NULL, NULL, 'LolA_like', NULL, 'LolA_like', NULL, NULL, NULL, 2),
(7318, NULL, 'cd18015', NULL, NULL, 'DEXHc_RecQ1', NULL, 'DEXHc_RecQ1', NULL, NULL, NULL, 2),
(7319, NULL, 'cd13649', NULL, NULL, 'PBP2_Cae31940', NULL, 'PBP2_Cae31940', NULL, NULL, NULL, 2),
(7320, NULL, 'cd06463', NULL, NULL, 'p23_like', NULL, 'p23_like', NULL, NULL, NULL, 2),
(7321, NULL, 'cd07605', NULL, NULL, 'I-BAR_IMD', NULL, 'I-BAR_IMD', NULL, NULL, NULL, 2),
(7322, NULL, 'cd17094', NULL, NULL, 'FERM_F1_Max1_like', NULL, 'FERM_F1_Max1_like', NULL, NULL, NULL, 2),
(7323, NULL, 'cd17515', NULL, NULL, 'RMtype1_S_MjaORF132P_Sau1132ORF3780P-TRD1-CR1_like', NULL, 'RMtype1_S_MjaORF132P_Sau1132ORF3780P-TRD1-CR1_like', NULL, NULL, NULL, 2),
(7324, NULL, 'cd01296', NULL, NULL, 'Imidazolone-5PH', NULL, 'Imidazolone-5PH', NULL, NULL, 9, 2),
(7325, NULL, 'cd07973', NULL, NULL, 'Spt4', NULL, 'Spt4', NULL, NULL, 17345, 2),
(7326, NULL, 'cd00318', NULL, NULL, 'Phosphoglycerate_kinase', NULL, 'Phosphoglycerate_kinase', NULL, NULL, 5397, 2),
(7327, NULL, 'cd08292', NULL, NULL, 'ETR_like_2', NULL, 'ETR_like_2', NULL, NULL, NULL, 2),
(7328, NULL, 'cd17773', NULL, NULL, 'CBS_pair_NeuB', NULL, 'CBS_pair_NeuB', NULL, NULL, NULL, 2),
(7329, NULL, 'cd13900', NULL, NULL, 'CuRO_3_Tth-MCO_like', NULL, 'CuRO_3_Tth-MCO_like', NULL, NULL, NULL, 2),
(7330, NULL, 'cd11910', NULL, NULL, 'SH3_PI3K_p85alpha', NULL, 'SH3_PI3K_p85alpha', NULL, NULL, 27638, 2),
(7331, NULL, 'cd14009', NULL, NULL, 'STKc_ATG1_ULK_like', NULL, 'STKc_ATG1_ULK_like', NULL, NULL, NULL, 2),
(7332, NULL, 'cd12896', NULL, NULL, 'SPRY_PRY_TRIM65', NULL, 'SPRY_PRY_TRIM65', NULL, NULL, NULL, 2),
(7333, NULL, 'cd20265', NULL, NULL, 'Complex1_LYR_ETFRF1_LYRM5', NULL, 'Complex1_LYR_ETFRF1_LYRM5', NULL, NULL, 34092, 2),
(7334, NULL, 'cd07064', NULL, NULL, 'AlkD_like_1', NULL, 'AlkD_like_1', NULL, NULL, NULL, 2),
(7335, NULL, 'cd17194', NULL, NULL, 'FERM_F1_PTPN4', NULL, 'FERM_F1_PTPN4', NULL, NULL, NULL, 2),
(7336, NULL, 'cd09275', NULL, NULL, 'RNase_HI_RT_DIRS1', NULL, 'RNase_HI_RT_DIRS1', NULL, NULL, NULL, 2),
(7337, NULL, 'cd12875', NULL, NULL, 'SPRY_SOCS_Fbox', NULL, 'SPRY_SOCS_Fbox', NULL, NULL, NULL, 2),
(7338, NULL, 'cd14498', NULL, NULL, 'DSP', NULL, 'DSP', NULL, NULL, NULL, 2),
(7339, NULL, 'cd08359', NULL, NULL, 'VOC_like', NULL, 'VOC_like', NULL, NULL, NULL, 2),
(7340, NULL, 'cd08909', NULL, NULL, 'START_STARD13-like', NULL, 'START_STARD13-like', NULL, NULL, NULL, 2),
(7341, NULL, 'cd14147', NULL, NULL, 'STKc_MLK3', NULL, 'STKc_MLK3', NULL, NULL, NULL, 2),
(7342, NULL, 'cd11676', NULL, NULL, 'Gemin6', NULL, 'Gemin6', NULL, NULL, NULL, 2),
(7343, NULL, 'cd15250', NULL, NULL, '7tmF_FZD8', NULL, '7tmF_FZD8', NULL, NULL, NULL, 2),
(7344, NULL, 'cd01837', NULL, NULL, 'SGNH_plant_lipase_like', NULL, 'SGNH_plant_lipase_like', NULL, NULL, 32447, 2),
(7345, NULL, 'cd18368', NULL, NULL, 'BTB_POZ_KCTD9', NULL, 'BTB_POZ_KCTD9', NULL, NULL, NULL, 2),
(7346, NULL, 'cd13352', NULL, NULL, 'PH-GRAM2_TBC1D8B', NULL, 'PH-GRAM2_TBC1D8B', NULL, NULL, 28472, 2),
(7347, NULL, 'cd02984', NULL, NULL, 'TRX_PICOT', NULL, 'TRX_PICOT', NULL, NULL, NULL, 2),
(7348, NULL, 'cd09643', NULL, NULL, 'Csn1', NULL, 'Csn1', NULL, NULL, NULL, 2),
(7349, NULL, 'cd09085', NULL, NULL, 'Mth212-like_AP-endo', NULL, 'Mth212-like_AP-endo', NULL, NULL, NULL, 2),
(7350, NULL, 'cd09816', NULL, NULL, 'prostaglandin_endoperoxide_synthase', NULL, 'prostaglandin_endoperoxide_synthase', NULL, NULL, NULL, 2);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(7351, NULL, 'cd16624', NULL, NULL, 'RING-HC_RBR_CUL9', NULL, 'RING-HC_RBR_CUL9', NULL, NULL, NULL, 2),
(7352, NULL, 'cd15233', NULL, NULL, '7tmA_OR3A-like', NULL, '7tmA_OR3A-like', NULL, NULL, NULL, 2),
(7353, NULL, 'cd09404', NULL, NULL, 'LIM1_MLP84B_like', NULL, 'LIM1_MLP84B_like', NULL, NULL, NULL, 2),
(7354, NULL, 'cd13614', NULL, NULL, 'PBP2_QAT_like', NULL, 'PBP2_QAT_like', NULL, NULL, NULL, 2),
(7355, NULL, 'cd10800', NULL, NULL, 'LamB_YcsF_YbgL_like', NULL, 'LamB_YcsF_YbgL_like', NULL, NULL, NULL, 2),
(7356, NULL, 'cd06468', NULL, NULL, 'p23_CacyBP', NULL, 'p23_CacyBP', NULL, NULL, 27102, 2),
(7357, NULL, 'cd02969', NULL, NULL, 'PRX_like1', NULL, 'PRX_like1', NULL, NULL, NULL, 2),
(7358, NULL, 'cd06395', NULL, NULL, 'PB1_Map2k5', NULL, 'PB1_Map2k5', NULL, NULL, 10268, 2),
(7359, NULL, 'cd13406', NULL, NULL, 'TNFRSF4', NULL, 'TNFRSF4', NULL, NULL, 1505, 2),
(7360, NULL, 'cd01923', NULL, NULL, 'cyclophilin_RING', NULL, 'cyclophilin_RING', NULL, NULL, NULL, 2),
(7361, NULL, 'cd07602', NULL, NULL, 'BAR_RhoGAP_OPHN1-like', NULL, 'BAR_RhoGAP_OPHN1-like', NULL, NULL, NULL, 2),
(7362, NULL, 'cd01636', NULL, NULL, 'FIG', NULL, 'FIG', NULL, NULL, NULL, 2),
(7363, NULL, 'cd09681', NULL, NULL, 'Csx3_III-U', NULL, 'Csx3_III-U', NULL, NULL, NULL, 2),
(7364, NULL, 'cd02989', NULL, NULL, 'Phd_like_TxnDC9', NULL, 'Phd_like_TxnDC9', NULL, NULL, NULL, 2),
(7365, NULL, 'cd11659', NULL, NULL, 'SANT_CDC5_II', NULL, 'SANT_CDC5_II', NULL, NULL, NULL, 2),
(7366, NULL, 'cd18575', NULL, NULL, 'ABC_6TM_bac_exporter_ABCB8_10_like', NULL, 'ABC_6TM_bac_exporter_ABCB8_10_like', NULL, NULL, NULL, 2),
(7367, NULL, 'cd12803', NULL, NULL, 'HopAB_BID', NULL, 'HopAB_BID', NULL, NULL, 22806, 2),
(7368, NULL, 'cd19966', NULL, NULL, 'PBP1_ABC_sugar_binding-like', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, NULL, 2),
(7369, NULL, 'cd12308', NULL, NULL, 'RRM1_Spen', NULL, 'RRM1_Spen', NULL, NULL, NULL, 2),
(7370, NULL, 'cd13436', NULL, NULL, 'SPFH_SLP-1', NULL, 'SPFH_SLP-1', NULL, NULL, NULL, 2),
(7371, NULL, 'cd04752', NULL, NULL, 'Commd4', NULL, 'Commd4', NULL, NULL, 29474, 2),
(7372, NULL, 'cd08030', NULL, NULL, 'LA_like_plant', NULL, 'LA_like_plant', NULL, NULL, NULL, 2),
(7373, NULL, 'cd19742', NULL, NULL, 'bHLH_TS_ASCL1_Mash1', NULL, 'bHLH_TS_ASCL1_Mash1', NULL, NULL, NULL, 2),
(7374, NULL, 'cd19352', NULL, NULL, 'Wnt_Wnt8b', NULL, 'Wnt_Wnt8b', NULL, NULL, NULL, 2),
(7375, NULL, 'cd04316', NULL, NULL, 'ND_PkAspRS_like_N', NULL, 'ND_PkAspRS_like_N', NULL, NULL, NULL, 2),
(7376, NULL, 'cd09925', NULL, NULL, 'SH2_SHC', NULL, 'SH2_SHC', NULL, NULL, 30600, 2),
(7377, NULL, 'cd16810', NULL, NULL, 'RING_CH-C4HC3_MARCH11', NULL, 'RING_CH-C4HC3_MARCH11', NULL, NULL, NULL, 2),
(7378, NULL, 'cd14213', NULL, NULL, 'PKc_CLK1_4', NULL, 'PKc_CLK1_4', NULL, NULL, NULL, 2),
(7379, NULL, 'cd18352', NULL, NULL, 'BTB_POZ_ARIA_plant', NULL, 'BTB_POZ_ARIA_plant', NULL, NULL, NULL, 2),
(7380, NULL, 'cd15069', NULL, NULL, '7tmA_Adenosine_R_A2B', NULL, '7tmA_Adenosine_R_A2B', NULL, NULL, NULL, 2),
(7381, NULL, 'cd18372', NULL, NULL, 'BTB_POZ_KCTD18', NULL, 'BTB_POZ_KCTD18', NULL, NULL, NULL, 2),
(7382, NULL, 'cd18483', NULL, NULL, 'BACK_KBTBD8', NULL, 'BACK_KBTBD8', NULL, NULL, NULL, 2),
(7383, NULL, 'cd15696', NULL, NULL, 'ePHD1_KMT2C', NULL, 'ePHD1_KMT2C', NULL, NULL, 30870, 2),
(7384, NULL, 'cd16831', NULL, NULL, 'HemS-like_C', NULL, 'HemS-like_C', NULL, NULL, NULL, 2),
(7385, NULL, 'cd16885', NULL, NULL, 'ARID_ARID5B', NULL, 'ARID_ARID5B', NULL, NULL, NULL, 2),
(7386, NULL, 'cd19924', NULL, NULL, 'REC_CheV-like', NULL, 'REC_CheV-like', NULL, NULL, NULL, 2),
(7387, NULL, 'cd11894', NULL, NULL, 'SH3_FCHSD2_2', NULL, 'SH3_FCHSD2_2', NULL, NULL, 33369, 2),
(7388, NULL, 'cd17916', NULL, NULL, 'DEXHc_UvrB', NULL, 'DEXHc_UvrB', NULL, NULL, NULL, 2),
(7389, NULL, 'cd15043', NULL, NULL, '7tmC_RAIG_GPRC5', NULL, '7tmC_RAIG_GPRC5', NULL, NULL, NULL, 2),
(7390, NULL, 'cd15384', NULL, NULL, '7tmA_GnRHR_invertebrate', NULL, '7tmA_GnRHR_invertebrate', NULL, NULL, NULL, 2),
(7391, NULL, 'cd11251', NULL, NULL, 'Sema_3C', NULL, 'Sema_3C', NULL, NULL, NULL, 2);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(7392, NULL, 'cd03816', NULL, NULL, 'GT33_ALG1-like', NULL, 'GT33_ALG1-like', NULL, NULL, NULL, 2),
(7393, NULL, 'cd08353', NULL, NULL, 'VOC_like', NULL, 'VOC_like', NULL, NULL, NULL, 2),
(7394, NULL, 'cd18181', NULL, NULL, 'ATP-synt_Vo_Ao_c_TtATPase_like', NULL, 'ATP-synt_Vo_Ao_c_TtATPase_like', NULL, NULL, NULL, 2),
(7395, NULL, 'cd01415', NULL, NULL, 'SAICAR_synt_PurC', NULL, 'SAICAR_synt_PurC', NULL, NULL, 30796, 2),
(7396, NULL, 'cd07032', NULL, NULL, 'RNAP_I_II_AC40', NULL, 'RNAP_I_II_AC40', NULL, NULL, 30149, 2),
(7397, NULL, 'cd09684', NULL, NULL, 'Csm3_III-A', NULL, 'Csm3_III-A', NULL, NULL, 9279, 2),
(7398, NULL, 'cd04208', NULL, NULL, 'CuRO_2_CuNIR', NULL, 'CuRO_2_CuNIR', NULL, NULL, NULL, 2),
(7399, NULL, 'cd19372', NULL, NULL, 'UDG_F1_VAVC_D4-like', NULL, 'UDG_F1_VAVC_D4-like', NULL, NULL, NULL, 2),
(7400, NULL, 'cd10291', NULL, NULL, 'GST_C_YfcG_like', NULL, 'GST_C_YfcG_like', NULL, NULL, NULL, 2),
(7401, NULL, 'cd16237', NULL, NULL, 'EFh_SPARC_TICN1', NULL, 'EFh_SPARC_TICN1', NULL, NULL, NULL, 2),
(7402, NULL, 'cd05489', NULL, NULL, 'xylanase_inhibitor_I_like', NULL, 'xylanase_inhibitor_I_like', NULL, NULL, 27805, 2),
(7403, NULL, 'cd05865', NULL, NULL, 'Ig1_NCAM-1', NULL, 'Ig1_NCAM-1', NULL, NULL, NULL, 2),
(7404, NULL, 'cd06625', NULL, NULL, 'STKc_MEKK3_like', NULL, 'STKc_MEKK3_like', NULL, NULL, NULL, 2),
(7405, NULL, 'cd12593', NULL, NULL, 'RRM_RBM11', NULL, 'RRM_RBM11', NULL, NULL, 29973, 2),
(7406, NULL, 'cd16296', NULL, NULL, 'RNaseZ_ELAC2-N-term-like_MBL-fold', NULL, 'RNaseZ_ELAC2-N-term-like_MBL-fold', NULL, NULL, NULL, 2),
(7407, NULL, 'cd02126', NULL, NULL, 'PA_EDEM3_like', NULL, 'PA_EDEM3_like', NULL, NULL, 33088, 2),
(7408, NULL, 'cd06256', NULL, NULL, 'M14_ASTE_ASPA-like', NULL, 'M14_ASTE_ASPA-like', NULL, NULL, NULL, 2),
(7409, NULL, 'cd05633', NULL, NULL, 'STKc_GRK3', NULL, 'STKc_GRK3', NULL, NULL, NULL, 2),
(7410, NULL, 'cd16288', NULL, NULL, 'BJP-1_FEZ-1-like_MBL-B3', NULL, 'BJP-1_FEZ-1-like_MBL-B3', NULL, NULL, NULL, 2),
(7411, NULL, 'cd04700', NULL, NULL, 'DR1025_like', NULL, 'DR1025_like', NULL, NULL, NULL, 2),
(7412, NULL, 'cd09886', NULL, NULL, 'NGN_SP', NULL, 'NGN_SP', NULL, NULL, NULL, 2),
(7413, NULL, 'cd00023', NULL, NULL, 'BBI', NULL, 'BBI', NULL, NULL, 59, 2),
(7414, NULL, 'cd06121', NULL, NULL, 'cupin_YML079wp', NULL, 'cupin_YML079wp', NULL, NULL, 14377, 2),
(7415, NULL, 'cd15088', NULL, NULL, '7tmA_MCHR-like', NULL, '7tmA_MCHR-like', NULL, NULL, NULL, 2),
(7416, NULL, 'cd01567', NULL, NULL, 'NAPRTase_PncB', NULL, 'NAPRTase_PncB', NULL, NULL, NULL, 2),
(7417, NULL, 'cd14199', NULL, NULL, 'STKc_CaMKK2', NULL, 'STKc_CaMKK2', NULL, NULL, NULL, 2),
(7418, NULL, 'cd09899', NULL, NULL, 'H3TH_T4-like', NULL, 'H3TH_T4-like', NULL, NULL, NULL, 2),
(7419, NULL, 'cd09219', NULL, NULL, 'TLP-F', NULL, 'TLP-F', NULL, NULL, NULL, 2),
(7420, NULL, 'cd13557', NULL, NULL, 'PBP2_SsuA', NULL, 'PBP2_SsuA', NULL, NULL, NULL, 2),
(7421, NULL, 'cd13601', NULL, NULL, 'PBP2_TRAP_DctP1_3_4_like', NULL, 'PBP2_TRAP_DctP1_3_4_like', NULL, NULL, NULL, 2),
(7422, NULL, 'cd15634', NULL, NULL, 'PHD_PHF20', NULL, 'PHD_PHF20', NULL, NULL, NULL, 2),
(7423, NULL, 'cd19583', NULL, NULL, 'serpinN_SPI-1_SPI-2', NULL, 'serpinN_SPI-1_SPI-2', NULL, NULL, NULL, 2),
(7424, NULL, 'cd05168', NULL, NULL, 'PI4Kc_III_beta', NULL, 'PI4Kc_III_beta', NULL, NULL, NULL, 2),
(7425, NULL, 'cd04299', NULL, NULL, 'GT35_Glycogen_Phosphorylase-like', NULL, 'GT35_Glycogen_Phosphorylase-like', NULL, NULL, NULL, 2),
(7426, NULL, 'cd03232', NULL, NULL, 'ABCG_PDR_domain2', NULL, 'ABCG_PDR_domain2', NULL, NULL, 22250, 2),
(7427, NULL, 'cd07761', NULL, NULL, 'CYTH-like_CthTTM-like', NULL, 'CYTH-like_CthTTM-like', NULL, NULL, NULL, 2),
(7428, NULL, 'cd03053', NULL, NULL, 'GST_N_Phi', NULL, 'GST_N_Phi', NULL, NULL, NULL, 2),
(7429, NULL, 'cd12733', NULL, NULL, 'RRM3_GRSF1', NULL, 'RRM3_GRSF1', NULL, NULL, 13244, 2),
(7430, NULL, 'cd07440', NULL, NULL, 'RGS', NULL, 'RGS', NULL, NULL, NULL, 2),
(7431, NULL, 'cd12439', NULL, NULL, 'RRM_TRMT2A', NULL, 'RRM_TRMT2A', NULL, NULL, 6234, 2),
(7432, NULL, 'cd10935', NULL, NULL, 'CE4_WalW', NULL, 'CE4_WalW', NULL, NULL, NULL, 2);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(7433, NULL, 'cd00668', NULL, NULL, 'Ile_Leu_Val_MetRS_core', NULL, 'Ile_Leu_Val_MetRS_core', NULL, NULL, NULL, 2),
(7434, NULL, 'cd01469', NULL, NULL, 'vWA_integrins_alpha_subunit', NULL, 'vWA_integrins_alpha_subunit', NULL, NULL, NULL, 2),
(7435, NULL, 'cd12423', NULL, NULL, 'RRM3_PTBP1_like', NULL, 'RRM3_PTBP1_like', NULL, NULL, NULL, 2),
(7436, NULL, 'cd03114', NULL, NULL, 'MMAA-like', NULL, 'MMAA-like', NULL, NULL, NULL, 2),
(7437, NULL, 'cd14055', NULL, NULL, 'STKc_TGFbR2_like', NULL, 'STKc_TGFbR2_like', NULL, NULL, NULL, 2),
(7438, NULL, 'cd03213', NULL, NULL, 'ABCG_EPDR', NULL, 'ABCG_EPDR', NULL, NULL, NULL, 2),
(7439, NULL, 'cd20171', NULL, NULL, 'M34_peptidase', NULL, 'M34_peptidase', NULL, NULL, NULL, 2),
(7440, NULL, 'cd02393', NULL, NULL, 'PNPase_KH', NULL, 'PNPase_KH', NULL, NULL, NULL, 2),
(7441, NULL, 'cd14786', NULL, NULL, 'STAT_CCD', NULL, 'STAT_CCD', NULL, NULL, NULL, 2),
(7442, NULL, 'cd13386', NULL, NULL, 'PH1_FGD2', NULL, 'PH1_FGD2', NULL, NULL, 32456, 2),
(7443, NULL, 'cd04283', NULL, NULL, 'ZnMc_hatching_enzyme', NULL, 'ZnMc_hatching_enzyme', NULL, NULL, 26777, 2),
(7444, NULL, 'cd17518', NULL, NULL, 'RMtype1_S_Asp27244ORF1181P-TRD1-CR1_like', NULL, 'RMtype1_S_Asp27244ORF1181P-TRD1-CR1_like', NULL, NULL, NULL, 2),
(7445, NULL, 'cd01297', NULL, NULL, 'D-aminoacylase', NULL, 'D-aminoacylase', NULL, NULL, NULL, 2),
(7446, NULL, 'cd08847', NULL, NULL, 'ArfGap_GIT2', NULL, 'ArfGap_GIT2', NULL, NULL, NULL, 2),
(7447, NULL, 'cd05292', NULL, NULL, 'LDH_2', NULL, 'LDH_2', NULL, NULL, NULL, 2),
(7448, NULL, 'cd14245', NULL, NULL, 'DMP12', NULL, 'DMP12', NULL, NULL, 23802, 2),
(7449, NULL, 'cd13360', NULL, NULL, 'PH_PLC_fungal', NULL, 'PH_PLC_fungal', NULL, NULL, 32730, 2),
(7450, NULL, 'cd01356', NULL, NULL, 'AcnX_swivel', NULL, 'AcnX_swivel', NULL, NULL, 5461, 2),
(7451, NULL, 'cd16767', NULL, NULL, 'RING-HC_TRIM2', NULL, 'RING-HC_TRIM2', NULL, NULL, NULL, 2),
(7452, NULL, 'cd18299', NULL, NULL, 'BTB1_POZ_RhoBTB', NULL, 'BTB1_POZ_RhoBTB', NULL, NULL, NULL, 2),
(7453, NULL, 'cd18821', NULL, NULL, 'GH43_Pc3Gal43A-like', NULL, 'GH43_Pc3Gal43A-like', NULL, NULL, NULL, 2),
(7454, NULL, 'cd16377', NULL, NULL, '23S_rRNA_IVP_like', NULL, '23S_rRNA_IVP_like', NULL, NULL, 10099, 2),
(7455, NULL, 'cd04181', NULL, NULL, 'NTP_transferase', NULL, 'NTP_transferase', NULL, NULL, NULL, 2),
(7456, NULL, 'cd04329', NULL, NULL, 'RNAP_II_Rpb7_N', NULL, 'RNAP_II_Rpb7_N', NULL, NULL, NULL, 2),
(7457, NULL, 'cd19838', NULL, NULL, 'Bbox1_TRIM8_C-V', NULL, 'Bbox1_TRIM8_C-V', NULL, NULL, NULL, 2),
(7458, NULL, 'cd06819', NULL, NULL, 'PLPDE_III_LS_D-TA', NULL, 'PLPDE_III_LS_D-TA', NULL, NULL, NULL, 2),
(7459, NULL, 'cd01294', NULL, NULL, 'DHOase', NULL, 'DHOase', NULL, NULL, 3154, 2),
(7460, NULL, 'cd14126', NULL, NULL, 'STKc_CK1_gamma', NULL, 'STKc_CK1_gamma', NULL, NULL, NULL, 2),
(7461, NULL, 'cd00382', NULL, NULL, 'beta_CA', NULL, 'beta_CA', NULL, NULL, NULL, 2),
(7462, NULL, 'cd09867', NULL, NULL, 'PIN_FEN1', NULL, 'PIN_FEN1', NULL, NULL, NULL, 2),
(7463, NULL, 'cd16633', NULL, NULL, 'mRING-HC-C3HC3D_RBR_HOIL1', NULL, 'mRING-HC-C3HC3D_RBR_HOIL1', NULL, NULL, NULL, 2),
(7464, NULL, 'cd00380', NULL, NULL, 'KOW', NULL, 'KOW', NULL, NULL, NULL, 2),
(7465, NULL, 'cd10970', NULL, NULL, 'CE4_DAC_u1_6s', NULL, 'CE4_DAC_u1_6s', NULL, NULL, NULL, 2),
(7466, NULL, 'cd21158', NULL, NULL, 'NendoU_nv', NULL, 'NendoU_nv', NULL, NULL, NULL, 2),
(7467, NULL, 'cd14770', NULL, NULL, 'PC-PEC_alpha', NULL, 'PC-PEC_alpha', NULL, NULL, NULL, 2),
(7468, NULL, 'cd04152', NULL, NULL, 'Arl4_Arl7', NULL, 'Arl4_Arl7', NULL, NULL, NULL, 2),
(7469, NULL, 'cd05623', NULL, NULL, 'STKc_MRCK_alpha', NULL, 'STKc_MRCK_alpha', NULL, NULL, NULL, 2),
(7470, NULL, 'cd13959', NULL, NULL, 'PT_UbiA_COQ2', NULL, 'PT_UbiA_COQ2', NULL, NULL, 27273, 2),
(7471, NULL, 'cd07200', NULL, NULL, 'cPLA2_Grp-IVA', NULL, 'cPLA2_Grp-IVA', NULL, NULL, NULL, 2),
(7472, NULL, 'cd16453', NULL, NULL, 'RING-Ubox', NULL, 'RING-Ubox', NULL, NULL, NULL, 2),
(7473, NULL, 'cd11758', NULL, NULL, 'SH3_CRK_N', NULL, 'SH3_CRK_N', NULL, NULL, 20424, 2),
(7474, NULL, 'cd14085', NULL, NULL, 'STKc_CaMKIV', NULL, 'STKc_CaMKIV', NULL, NULL, NULL, 2);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(7475, NULL, 'cd06139', NULL, NULL, 'DNA_polA_I_Ecoli_like_exo', NULL, 'DNA_polA_I_Ecoli_like_exo', NULL, NULL, NULL, 2),
(7476, NULL, 'cd09362', NULL, NULL, 'LIM2_Enigma_like', NULL, 'LIM2_Enigma_like', NULL, NULL, NULL, 2),
(7477, NULL, 'cd11300', NULL, NULL, 'Fut8_like', NULL, 'Fut8_like', NULL, NULL, NULL, 2),
(7478, NULL, 'cd09268', NULL, NULL, 'FCHo1_MHD', NULL, 'FCHo1_MHD', NULL, NULL, NULL, 2),
(7479, NULL, 'cd13912', NULL, NULL, 'CcO_II_C', NULL, 'CcO_II_C', NULL, NULL, 7135, 2),
(7480, NULL, 'cd01563', NULL, NULL, 'Thr-synth_1', NULL, 'Thr-synth_1', NULL, NULL, NULL, 2),
(7481, NULL, 'cd19118', NULL, NULL, 'AKR_AKR3B1-3', NULL, 'AKR_AKR3B1-3', NULL, NULL, 34794, 2),
(7482, NULL, 'cd19989', NULL, NULL, 'PBP1_SBP-like', NULL, 'PBP1_SBP-like', NULL, NULL, NULL, 2),
(7483, NULL, 'cd04672', NULL, NULL, 'Nudix_Hydrolase_14', NULL, 'Nudix_Hydrolase_14', NULL, NULL, NULL, 2),
(7484, NULL, 'cd16483', NULL, NULL, 'RING-H2_UBR3', NULL, 'RING-H2_UBR3', NULL, NULL, NULL, 2),
(7485, NULL, 'cd04388', NULL, NULL, 'RhoGAP_p85', NULL, 'RhoGAP_p85', NULL, NULL, NULL, 2),
(7486, NULL, 'cd17438', NULL, NULL, 'MFS_SV2B', NULL, 'MFS_SV2B', NULL, NULL, NULL, 2),
(7487, NULL, 'cd18728', NULL, NULL, 'PIN_N4BP1-like', NULL, 'PIN_N4BP1-like', NULL, NULL, NULL, 2),
(7488, NULL, 'cd15109', NULL, NULL, '7tmA_MrgprF', NULL, '7tmA_MrgprF', NULL, NULL, NULL, 2),
(7489, NULL, 'cd17431', NULL, NULL, 'MFS_GLUT_Class1', NULL, 'MFS_GLUT_Class1', NULL, NULL, NULL, 2),
(7490, NULL, 'cd02116', NULL, NULL, 'ACT', NULL, 'ACT', NULL, NULL, NULL, 2),
(7491, NULL, 'cd15882', NULL, NULL, 'SNARE_syntaxin2', NULL, 'SNARE_syntaxin2', NULL, NULL, NULL, 2),
(7492, NULL, 'cd05725', NULL, NULL, 'Ig3_Robo', NULL, 'Ig3_Robo', NULL, NULL, NULL, 2),
(7493, NULL, 'cd13977', NULL, NULL, 'STKc_PDIK1L', NULL, 'STKc_PDIK1L', NULL, NULL, NULL, 2),
(7494, NULL, 'cd09979', NULL, NULL, 'LOTUS_3_Limkain_b1', NULL, 'LOTUS_3_Limkain_b1', NULL, NULL, NULL, 2),
(7495, NULL, 'cd19923', NULL, NULL, 'REC_CheY_CheY3', NULL, 'REC_CheY_CheY3', NULL, NULL, NULL, 2),
(7496, NULL, 'cd00080', NULL, NULL, 'H3TH_StructSpec-5''-nucleases', NULL, 'H3TH_StructSpec-5''-nucleases', NULL, NULL, NULL, 2),
(7497, NULL, 'cd05898', NULL, NULL, 'Ig5_KIRREL3', NULL, 'Ig5_KIRREL3', NULL, NULL, NULL, 2),
(7498, NULL, 'cd06197', NULL, NULL, 'FNR_like_2', NULL, 'FNR_like_2', NULL, NULL, NULL, 2),
(7499, NULL, 'cd13719', NULL, NULL, 'PBP2_iGluR_NMDA_Nr1', NULL, 'PBP2_iGluR_NMDA_Nr1', NULL, NULL, NULL, 2),
(7500, NULL, 'cd00955', NULL, NULL, 'Transaldolase_like', NULL, 'Transaldolase_like', NULL, NULL, 3698, 2),
(7501, NULL, 'cd14582', NULL, NULL, 'DSP_DUSP15', NULL, 'DSP_DUSP15', NULL, NULL, NULL, 2),
(7502, NULL, 'sd00039', NULL, NULL, '7WD40', NULL, '7WD40', NULL, NULL, NULL, 2),
(7503, NULL, 'cd10498', NULL, NULL, 'MH2_SMAD_4', NULL, 'MH2_SMAD_4', NULL, NULL, NULL, 2),
(7504, NULL, 'cd07983', NULL, NULL, 'LPLAT_DUF374-like', NULL, 'LPLAT_DUF374-like', NULL, NULL, 415, 2),
(7505, NULL, 'cd09353', NULL, NULL, 'LIM2_Zyxin', NULL, 'LIM2_Zyxin', NULL, NULL, NULL, 2),
(7506, NULL, 'cd07265', NULL, NULL, '2_3_CTD_N', NULL, '2_3_CTD_N', NULL, NULL, NULL, 2),
(7507, NULL, 'cd18475', NULL, NULL, 'BACK_KLHL36', NULL, 'BACK_KLHL36', NULL, NULL, NULL, 2),
(7508, NULL, 'cd04273', NULL, NULL, 'ZnMc_ADAMTS_like', NULL, 'ZnMc_ADAMTS_like', NULL, NULL, NULL, 2),
(7509, NULL, 'cd08893', NULL, NULL, 'SRPBCC_CalC_Aha1-like_GntR-HTH', NULL, 'SRPBCC_CalC_Aha1-like_GntR-HTH', NULL, NULL, NULL, 2),
(7510, NULL, 'cd08662', NULL, NULL, 'M13', NULL, 'M13', NULL, NULL, 3756, 2),
(7511, NULL, 'cd09338', NULL, NULL, 'LIM3_Paxillin_like', NULL, 'LIM3_Paxillin_like', NULL, NULL, NULL, 2),
(7512, NULL, 'cd19721', NULL, NULL, 'bHLH_TS_NeuroD4_ATOH3', NULL, 'bHLH_TS_NeuroD4_ATOH3', NULL, NULL, NULL, 2),
(7513, NULL, 'cd15247', NULL, NULL, '7tmF_FZD1', NULL, '7tmF_FZD1', NULL, NULL, NULL, 2),
(7514, NULL, 'cd07717', NULL, NULL, 'RNaseZ_ZiPD-like_MBL-fold', NULL, 'RNaseZ_ZiPD-like_MBL-fold', NULL, NULL, 10166, 2),
(7515, NULL, 'cd05709', NULL, NULL, 'S2P-M50', NULL, 'S2P-M50', NULL, NULL, NULL, 2),
(7516, NULL, 'cd16095', NULL, NULL, 'IgV_H_TCR_mu', NULL, 'IgV_H_TCR_mu', NULL, NULL, NULL, 2);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(7517, NULL, 'cd17305', NULL, NULL, 'PIPKc_PIP5KII', NULL, 'PIPKc_PIP5KII', NULL, NULL, NULL, 2),
(7518, NULL, 'cd06470', NULL, NULL, 'ACD_IbpA-B_like', NULL, 'ACD_IbpA-B_like', NULL, NULL, 31438, 2),
(7519, NULL, 'cd01990', NULL, NULL, 'Alpha_ANH_like_I', NULL, 'Alpha_ANH_like_I', NULL, NULL, 11267, 2),
(7520, NULL, 'cd14989', NULL, NULL, '7tmA_GPER1', NULL, '7tmA_GPER1', NULL, NULL, NULL, 2),
(7521, NULL, 'cd15219', NULL, NULL, '7tmA_GPR26_GPR78-like', NULL, '7tmA_GPR26_GPR78-like', NULL, NULL, NULL, 2),
(7522, NULL, 'cd16734', NULL, NULL, 'RING-HC_PCGF2', NULL, 'RING-HC_PCGF2', NULL, NULL, NULL, 2),
(7523, NULL, 'cd07671', NULL, NULL, 'F-BAR_PSTPIP1', NULL, 'F-BAR_PSTPIP1', NULL, NULL, NULL, 2),
(7524, NULL, 'cd15522', NULL, NULL, 'PHD_TAF3', NULL, 'PHD_TAF3', NULL, NULL, NULL, 2),
(7525, NULL, 'cd11577', NULL, NULL, 'GH71', NULL, 'GH71', NULL, NULL, 6811, 2),
(7526, NULL, 'cd08720', NULL, NULL, 'RGS_SNX25', NULL, 'RGS_SNX25', NULL, NULL, NULL, 2),
(7527, NULL, 'cd05097', NULL, NULL, 'PTKc_DDR_like', NULL, 'PTKc_DDR_like', NULL, NULL, NULL, 2),
(7528, NULL, 'cd09089', NULL, NULL, 'INPP5c_Synj', NULL, 'INPP5c_Synj', NULL, NULL, NULL, 2),
(7529, NULL, 'cd04719', NULL, NULL, 'BAH_Orc1p_animal', NULL, 'BAH_Orc1p_animal', NULL, NULL, NULL, 2),
(7530, NULL, 'cd05665', NULL, NULL, 'M20_Acy1_IAAspH', NULL, 'M20_Acy1_IAAspH', NULL, NULL, 30248, 2),
(7531, NULL, 'cd05698', NULL, NULL, 'S1_Rrp5_repeat_hs6_sc5', NULL, 'S1_Rrp5_repeat_hs6_sc5', NULL, NULL, NULL, 2),
(7532, NULL, 'cd02514', NULL, NULL, 'GT13_GLCNAC-TI', NULL, 'GT13_GLCNAC-TI', NULL, NULL, NULL, 2),
(7533, NULL, 'cd18969', NULL, NULL, 'chromodomain', NULL, 'chromodomain', NULL, NULL, NULL, 2),
(7534, NULL, 'cd05170', NULL, NULL, 'PIKKc_SMG1', NULL, 'PIKKc_SMG1', NULL, NULL, 27632, 2),
(7535, NULL, 'cd14769', NULL, NULL, 'PE_alpha', NULL, 'PE_alpha', NULL, NULL, NULL, 2),
(7536, NULL, 'cd16638', NULL, NULL, 'mRING-HC-C3HC3D_Roquin', NULL, 'mRING-HC-C3HC3D_Roquin', NULL, NULL, NULL, 2),
(7537, NULL, 'cd01924', NULL, NULL, 'cyclophilin_TLP40_like', NULL, 'cyclophilin_TLP40_like', NULL, NULL, NULL, 2),
(7538, NULL, 'cd14350', NULL, NULL, 'UBA_DCNL', NULL, 'UBA_DCNL', NULL, NULL, NULL, 2),
(7539, NULL, 'cd15078', NULL, NULL, '7tmA_Encephalopsin', NULL, '7tmA_Encephalopsin', NULL, NULL, NULL, 2),
(7540, NULL, 'cd17456', NULL, NULL, 'MFS_FLVCR2', NULL, 'MFS_FLVCR2', NULL, NULL, NULL, 2),
(7541, NULL, 'cd16805', NULL, NULL, 'RING-H2_RNF150', NULL, 'RING-H2_RNF150', NULL, NULL, NULL, 2),
(7542, NULL, 'cd09420', NULL, NULL, 'LIM3_Prickle', NULL, 'LIM3_Prickle', NULL, NULL, 32511, 2),
(7543, NULL, 'cd01753', NULL, NULL, 'PLAT_LOX', NULL, 'PLAT_LOX', NULL, NULL, 30206, 2),
(7544, NULL, 'cd17129', NULL, NULL, 'Ubl1_FAF1', NULL, 'Ubl1_FAF1', NULL, NULL, NULL, 2),
(7545, NULL, 'cd12519', NULL, NULL, 'RRM1_SREK1', NULL, 'RRM1_SREK1', NULL, NULL, NULL, 2),
(7546, NULL, 'cd15346', NULL, NULL, '7tmA_S1PR1_Edg1', NULL, '7tmA_S1PR1_Edg1', NULL, NULL, NULL, 2),
(7547, NULL, 'cd01209', NULL, NULL, 'PTB_Shc', NULL, 'PTB_Shc', NULL, NULL, 1122, 2),
(7548, NULL, 'cd17508', NULL, NULL, 'Alpha_kinase', NULL, 'Alpha_kinase', NULL, NULL, NULL, 2),
(7549, NULL, 'cd00556', NULL, NULL, 'Thioesterase_II', NULL, 'Thioesterase_II', NULL, NULL, NULL, 2),
(7550, NULL, 'cd14323', NULL, NULL, 'UBA_PLCs_like', NULL, 'UBA_PLCs_like', NULL, NULL, NULL, 2),
(7551, NULL, 'cd09465', NULL, NULL, 'LIM2_LIMK2', NULL, 'LIM2_LIMK2', NULL, NULL, NULL, 2),
(7552, NULL, 'cd01677', NULL, NULL, 'PFL2_DhaB_BssA', NULL, 'PFL2_DhaB_BssA', NULL, NULL, NULL, 2),
(7553, NULL, 'cd04690', NULL, NULL, 'Nudix_Hydrolase_31', NULL, 'Nudix_Hydrolase_31', NULL, NULL, NULL, 2),
(7554, NULL, 'cd09582', NULL, NULL, 'SAM_Scm-like-3MBT3,4', NULL, 'SAM_Scm-like-3MBT3,4', NULL, NULL, NULL, 2),
(7555, NULL, 'cd17675', NULL, NULL, 'SWIB_BAF60B', NULL, 'SWIB_BAF60B', NULL, NULL, NULL, 2),
(7556, NULL, 'cd13694', NULL, NULL, 'PBP2_Cysteine', NULL, 'PBP2_Cysteine', NULL, NULL, NULL, 2),
(7557, NULL, 'cd03126', NULL, NULL, 'alpha_CA_XII_XIV', NULL, 'alpha_CA_XII_XIV', NULL, NULL, NULL, 2),
(7558, NULL, 'cd12587', NULL, NULL, 'RRM1_PSF', NULL, 'RRM1_PSF', NULL, NULL, 32103, 2);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(7559, NULL, 'cd12597', NULL, NULL, 'RRM1_SRSF1', NULL, 'RRM1_SRSF1', NULL, NULL, 32405, 2),
(7560, NULL, 'cd18025', NULL, NULL, 'DEXHc_DDX60', NULL, 'DEXHc_DDX60', NULL, NULL, NULL, 2),
(7561, NULL, 'cd12302', NULL, NULL, 'RRM_scSet1p_like', NULL, 'RRM_scSet1p_like', NULL, NULL, NULL, 2),
(7562, NULL, 'cd05491', NULL, NULL, 'Bromo_TBP7_like', NULL, 'Bromo_TBP7_like', NULL, NULL, NULL, 2),
(7563, NULL, 'cd11236', NULL, NULL, 'Sema_plexin_like', NULL, 'Sema_plexin_like', NULL, NULL, NULL, 2),
(7564, NULL, 'cd12745', NULL, NULL, 'RRM1_RBM12', NULL, 'RRM1_RBM12', NULL, NULL, 27743, 2),
(7565, NULL, 'cd17297', NULL, NULL, 'AldB-like', NULL, 'AldB-like', NULL, NULL, NULL, 2),
(7566, NULL, 'cd00153', NULL, NULL, 'RA_RalGDS_like', NULL, 'RA_RalGDS_like', NULL, NULL, NULL, 2),
(7567, NULL, 'cd00683', NULL, NULL, 'Trans_IPPS_HH', NULL, 'Trans_IPPS_HH', NULL, NULL, 29498, 2),
(7568, NULL, 'cd15523', NULL, NULL, 'PHD_PHF21A', NULL, 'PHD_PHF21A', NULL, NULL, NULL, 2),
(7569, NULL, 'cd09257', NULL, NULL, 'AP_muniscins_like_MHD', NULL, 'AP_muniscins_like_MHD', NULL, NULL, NULL, 2),
(7570, NULL, 'cd06537', NULL, NULL, 'CIDE_N_B', NULL, 'CIDE_N_B', NULL, NULL, NULL, 2),
(7571, NULL, 'cd08996', NULL, NULL, 'GH32_FFase', NULL, 'GH32_FFase', NULL, NULL, NULL, 2),
(7572, NULL, 'cd07533', NULL, NULL, 'HAD_like', NULL, 'HAD_like', NULL, NULL, NULL, 2),
(7573, NULL, 'cd11997', NULL, NULL, 'SH3_PACSIN3', NULL, 'SH3_PACSIN3', NULL, NULL, NULL, 2),
(7574, NULL, 'cd06325', NULL, NULL, 'PBP1_ABC_unchar_transporter', NULL, 'PBP1_ABC_unchar_transporter', NULL, NULL, 10094, 2),
(7575, NULL, 'cd03287', NULL, NULL, 'ABC_MSH3_euk', NULL, 'ABC_MSH3_euk', NULL, NULL, NULL, 2),
(7576, NULL, 'cd02759', NULL, NULL, 'MopB_Acetylene-hydratase', NULL, 'MopB_Acetylene-hydratase', NULL, NULL, 30630, 2),
(7577, NULL, 'cd12195', NULL, NULL, 'CIPK_C', NULL, 'CIPK_C', NULL, NULL, NULL, 2),
(7578, NULL, 'cd12234', NULL, NULL, 'RRM1_AtRSp31_like', NULL, 'RRM1_AtRSp31_like', NULL, NULL, NULL, 2),
(7579, NULL, 'cd12246', NULL, NULL, 'RRM1_U1A_like', NULL, 'RRM1_U1A_like', NULL, NULL, NULL, 2),
(7580, NULL, 'cd14362', NULL, NULL, 'CUE_TAB2_TAB3', NULL, 'CUE_TAB2_TAB3', NULL, NULL, 30102, 2),
(7581, NULL, 'cd17249', NULL, NULL, 'RMtype1_S_EcoR124I-TRD2-CR2_like', NULL, 'RMtype1_S_EcoR124I-TRD2-CR2_like', NULL, NULL, NULL, 2),
(7582, NULL, 'cd05038', NULL, NULL, 'PTKc_Jak_rpt2', NULL, 'PTKc_Jak_rpt2', NULL, NULL, NULL, 2),
(7583, NULL, 'cd13906', NULL, NULL, 'CuRO_3_CumA_like', NULL, 'CuRO_3_CumA_like', NULL, NULL, NULL, 2),
(7584, NULL, 'cd12012', NULL, NULL, 'SH3_RIM-BP_2', NULL, 'SH3_RIM-BP_2', NULL, NULL, 30123, 2),
(7585, NULL, 'cd01230', NULL, NULL, 'PH1_Tiam1_2', NULL, 'PH1_Tiam1_2', NULL, NULL, NULL, 2),
(7586, NULL, 'cd02779', NULL, NULL, 'MopB_CT_Arsenite-Ox', NULL, 'MopB_CT_Arsenite-Ox', NULL, NULL, NULL, 2),
(7587, NULL, 'cd05779', NULL, NULL, 'DNA_polB_epsilon_exo', NULL, 'DNA_polB_epsilon_exo', NULL, NULL, NULL, 2),
(7588, NULL, 'cd05635', NULL, NULL, 'LbH_unknown', NULL, 'LbH_unknown', NULL, NULL, NULL, 2),
(7589, NULL, 'cd18897', NULL, NULL, 'TET3', NULL, 'TET3', NULL, NULL, NULL, 2),
(7590, NULL, 'cd00103', NULL, NULL, 'IRF', NULL, 'IRF', NULL, NULL, 2349, 2),
(7591, NULL, 'cd15552', NULL, NULL, 'PHD_PHF3_like', NULL, 'PHD_PHF3_like', NULL, NULL, NULL, 2),
(7592, NULL, 'cd09726', NULL, NULL, 'RAMP_I_III', NULL, 'RAMP_I_III', NULL, NULL, NULL, 2),
(7593, NULL, 'cd10326', NULL, NULL, 'SLC5sbd_NIS-like', NULL, 'SLC5sbd_NIS-like', NULL, NULL, NULL, 2),
(7594, NULL, 'cd10404', NULL, NULL, 'SH2_STAP2', NULL, 'SH2_STAP2', NULL, NULL, 32604, 2),
(7595, NULL, 'cd06184', NULL, NULL, 'flavohem_like_fad_nad_binding', NULL, 'flavohem_like_fad_nad_binding', NULL, NULL, NULL, 2),
(7596, NULL, 'cd09210', NULL, NULL, 'Riboflavin_synthase_archaeal', NULL, 'Riboflavin_synthase_archaeal', NULL, NULL, 5748, 2),
(7597, NULL, 'cd00928', NULL, NULL, 'Cyt_c_Oxidase_VIIa', NULL, 'Cyt_c_Oxidase_VIIa', NULL, NULL, 1568, 2),
(7598, NULL, 'cd02671', NULL, NULL, 'Peptidase_C19O', NULL, 'Peptidase_C19O', NULL, NULL, 29639, 2),
(7599, NULL, 'cd11816', NULL, NULL, 'SH3_Eve1_3', NULL, 'SH3_Eve1_3', NULL, NULL, 27103, 2);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(7600, NULL, 'cd00228', NULL, NULL, 'eu-GS', NULL, 'eu-GS', NULL, NULL, 2539, 2),
(7601, NULL, 'cd13669', NULL, NULL, 'PBP2_TRAP_TM0322_like', NULL, 'PBP2_TRAP_TM0322_like', NULL, NULL, NULL, 2),
(7602, NULL, 'cd14557', NULL, NULL, 'R-PTPc-C-1', NULL, 'R-PTPc-C-1', NULL, NULL, NULL, 2),
(7603, NULL, 'cd11987', NULL, NULL, 'SH3_Intersectin1_1', NULL, 'SH3_Intersectin1_1', NULL, NULL, NULL, 2),
(7604, NULL, 'cd01123', NULL, NULL, 'Rad51_DMC1_radA', NULL, 'Rad51_DMC1_radA', NULL, NULL, 26846, 2),
(7605, NULL, 'cd07108', NULL, NULL, 'ALDH_MGR_2402', NULL, 'ALDH_MGR_2402', NULL, NULL, NULL, 2),
(7606, NULL, 'cd00309', NULL, NULL, 'chaperonin_type_I_II', NULL, 'chaperonin_type_I_II', NULL, NULL, NULL, 2),
(7607, NULL, 'cd01859', NULL, NULL, 'MJ1464', NULL, 'MJ1464', NULL, NULL, NULL, 2),
(7608, NULL, 'cd08326', NULL, NULL, 'CARD_CASP9', NULL, 'CARD_CASP9', NULL, NULL, 36034, 2),
(7609, NULL, 'cd04946', NULL, NULL, 'GT4_AmsK-like', NULL, 'GT4_AmsK-like', NULL, NULL, NULL, 2),
(7610, NULL, 'cd07530', NULL, NULL, 'HAD_Pase_UmpH-like', NULL, 'HAD_Pase_UmpH-like', NULL, NULL, NULL, 2),
(7611, NULL, 'cd10396', NULL, NULL, 'SH2_Tec_Itk', NULL, 'SH2_Tec_Itk', NULL, NULL, NULL, 2),
(7612, NULL, 'cd12265', NULL, NULL, 'RRM_SLT11', NULL, 'RRM_SLT11', NULL, NULL, 916, 2),
(7613, NULL, 'cd00642', NULL, NULL, 'GTP_cyclohydro1', NULL, 'GTP_cyclohydro1', NULL, NULL, NULL, 2),
(7614, NULL, 'cd09650', NULL, NULL, 'Cas7_I', NULL, 'Cas7_I', NULL, NULL, NULL, 2),
(7615, NULL, 'cd12181', NULL, NULL, 'ceo_syn', NULL, 'ceo_syn', NULL, NULL, NULL, 2),
(7616, NULL, 'cd08047', NULL, NULL, 'TAF7', NULL, 'TAF7', NULL, NULL, 2926, 2),
(7617, NULL, 'cd01258', NULL, NULL, 'PHsplit_syntrophin', NULL, 'PHsplit_syntrophin', NULL, NULL, 30664, 2),
(7618, NULL, 'cd01940', NULL, NULL, 'Fructoselysine_kinase_like', NULL, 'Fructoselysine_kinase_like', NULL, NULL, NULL, 2),
(7619, NULL, 'cd14449', NULL, NULL, 'CuRO_1_2DMCO_NIR_like_2', NULL, 'CuRO_1_2DMCO_NIR_like_2', NULL, NULL, NULL, 2),
(7620, NULL, 'cd01536', NULL, NULL, 'PBP1_ABC_sugar_binding-like', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, NULL, 2),
(7621, NULL, 'cd06502', NULL, NULL, 'TA_like', NULL, 'TA_like', NULL, NULL, NULL, 2),
(7622, NULL, 'cd21668', NULL, NULL, 'deltaCoV_Nsp5_Mpro', NULL, 'deltaCoV_Nsp5_Mpro', NULL, NULL, 36916, 2),
(7623, NULL, 'cd10548', NULL, NULL, 'cupin_CDO', NULL, 'cupin_CDO', NULL, NULL, NULL, 2),
(7624, NULL, 'cd11536', NULL, NULL, 'NTP-PPase_iMazG', NULL, 'NTP-PPase_iMazG', NULL, NULL, NULL, 2),
(7625, NULL, 'cd02799', NULL, NULL, 'tRNA_bind_EMAP-II_like', NULL, 'tRNA_bind_EMAP-II_like', NULL, NULL, NULL, 2),
(7626, NULL, 'cd05845', NULL, NULL, 'Ig2_L1-CAM_like', NULL, 'Ig2_L1-CAM_like', NULL, NULL, NULL, 2),
(7627, NULL, 'cd08598', NULL, NULL, 'PI-PLC1c_yeast', NULL, 'PI-PLC1c_yeast', NULL, NULL, NULL, 2),
(7628, NULL, 'cd14717', NULL, NULL, 'bZIP_Maf_small', NULL, 'bZIP_Maf_small', NULL, NULL, NULL, 2),
(7629, NULL, 'cd06479', NULL, NULL, 'ACD_HspB7_like', NULL, 'ACD_HspB7_like', NULL, NULL, 33146, 2),
(7630, NULL, 'cd11261', NULL, NULL, 'Sema_4F', NULL, 'Sema_4F', NULL, NULL, NULL, 2),
(7631, NULL, 'cd16954', NULL, NULL, 'HATPase_PhoQ-like', NULL, 'HATPase_PhoQ-like', NULL, NULL, NULL, 2),
(7632, NULL, 'cd17707', NULL, NULL, 'BRCT_XRCC1_rpt2', NULL, 'BRCT_XRCC1_rpt2', NULL, NULL, NULL, 2),
(7633, NULL, 'cd11298', NULL, NULL, 'O-FucT-2', NULL, 'O-FucT-2', NULL, NULL, NULL, 2),
(7634, NULL, 'cd03270', NULL, NULL, 'ABC_UvrA_I', NULL, 'ABC_UvrA_I', NULL, NULL, NULL, 2),
(7635, NULL, 'cd09193', NULL, NULL, 'PLDc_mTdp1_1', NULL, 'PLDc_mTdp1_1', NULL, NULL, NULL, 2),
(7636, NULL, 'cd08920', NULL, NULL, 'Ngb', NULL, 'Ngb', NULL, NULL, NULL, 2),
(7637, NULL, 'cd15186', NULL, NULL, '7tmA_CX3CR1', NULL, '7tmA_CX3CR1', NULL, NULL, NULL, 2),
(7638, NULL, 'cd11822', NULL, NULL, 'SH3_SASH_like', NULL, 'SH3_SASH_like', NULL, NULL, NULL, 2),
(7639, NULL, 'cd15856', NULL, NULL, 'SNARE_SNAP29C', NULL, 'SNARE_SNAP29C', NULL, NULL, NULL, 2),
(7640, NULL, 'cd16857', NULL, NULL, 'ING_ING1_2', NULL, 'ING_ING1_2', NULL, NULL, NULL, 2),
(7641, NULL, 'cd19165', NULL, NULL, 'HemeO', NULL, 'HemeO', NULL, NULL, 1294, 2);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(7642, NULL, 'cd14231', NULL, NULL, 'GAT_GGA_like_plant', NULL, 'GAT_GGA_like_plant', NULL, NULL, NULL, 2),
(7643, NULL, 'cd19366', NULL, NULL, 'TenA_C_BhTenA-like', NULL, 'TenA_C_BhTenA-like', NULL, NULL, NULL, 2),
(7644, NULL, 'cd10530', NULL, NULL, 'SET_SETD7', NULL, 'SET_SETD7', NULL, NULL, 35184, 2),
(7645, NULL, 'cd07853', NULL, NULL, 'STKc_NLK', NULL, 'STKc_NLK', NULL, NULL, NULL, 2),
(7646, NULL, 'cd13856', NULL, NULL, 'CuRO_1_Tv-LCC_like', NULL, 'CuRO_1_Tv-LCC_like', NULL, NULL, NULL, 2),
(7647, NULL, 'cd08347', NULL, NULL, 'PcpA_C_like', NULL, 'PcpA_C_like', NULL, NULL, NULL, 2),
(7648, NULL, 'cd03794', NULL, NULL, 'GT4_WbuB-like', NULL, 'GT4_WbuB-like', NULL, NULL, NULL, 2),
(7649, NULL, 'cd09654', NULL, NULL, 'Cmr5_III-B', NULL, 'Cmr5_III-B', NULL, NULL, NULL, 2),
(7650, NULL, 'cd07084', NULL, NULL, 'ALDH_KGSADH-like', NULL, 'ALDH_KGSADH-like', NULL, NULL, NULL, 2),
(7651, NULL, 'cd07837', NULL, NULL, 'STKc_CdkB_plant', NULL, 'STKc_CdkB_plant', NULL, NULL, NULL, 2),
(7652, NULL, 'cd11957', NULL, NULL, 'SH3_RUSC2', NULL, 'SH3_RUSC2', NULL, NULL, NULL, 2),
(7653, NULL, 'cd14807', NULL, NULL, 'RAP_D2', NULL, 'RAP_D2', NULL, NULL, 33042, 2),
(7654, NULL, 'cd06200', NULL, NULL, 'SiR_like1', NULL, 'SiR_like1', NULL, NULL, NULL, 2),
(7655, NULL, 'cd21487', NULL, NULL, 'bat_HKU4-like_Spike_S1_RBD', NULL, 'bat_HKU4-like_Spike_S1_RBD', NULL, NULL, 36569, 2),
(7656, NULL, 'cd09109', NULL, NULL, 'PLDc_PMFPLD_like_2', NULL, 'PLDc_PMFPLD_like_2', NULL, NULL, NULL, 2),
(7657, NULL, 'cd01742', NULL, NULL, 'GATase1_GMP_Synthase', NULL, 'GATase1_GMP_Synthase', NULL, NULL, 5271, 2),
(7658, NULL, 'cd11953', NULL, NULL, 'SH3_ASPP2', NULL, 'SH3_ASPP2', NULL, NULL, NULL, 2),
(7659, NULL, 'cd12261', NULL, NULL, 'RRM1_3_MRN1', NULL, 'RRM1_3_MRN1', NULL, NULL, NULL, 2),
(7660, NULL, 'cd05034', NULL, NULL, 'PTKc_Src_like', NULL, 'PTKc_Src_like', NULL, NULL, NULL, 2),
(7661, NULL, 'cd08166', NULL, NULL, 'MPP_Cdc1_like_1', NULL, 'MPP_Cdc1_like_1', NULL, NULL, NULL, 2),
(7662, NULL, 'cd08401', NULL, NULL, 'C2A_RasA2_RasA3', NULL, 'C2A_RasA2_RasA3', NULL, NULL, NULL, 2),
(7663, NULL, 'cd16938', NULL, NULL, 'HATPase_ETR2_ERS2-EIN4-like', NULL, 'HATPase_ETR2_ERS2-EIN4-like', NULL, NULL, NULL, 2),
(7664, NULL, 'cd12217', NULL, NULL, 'Stu0660_Csn2', NULL, 'Stu0660_Csn2', NULL, NULL, NULL, 2),
(7665, NULL, 'cd01659', NULL, NULL, 'TRX_superfamily', NULL, 'TRX_superfamily', NULL, NULL, NULL, 2),
(7666, NULL, 'cd18446', NULL, NULL, 'BACK_KLHL6', NULL, 'BACK_KLHL6', NULL, NULL, NULL, 2),
(7667, NULL, 'cd15969', NULL, NULL, '7tmA_GPR87', NULL, '7tmA_GPR87', NULL, NULL, NULL, 2),
(7668, NULL, 'cd10927', NULL, NULL, 'CE4_u3', NULL, 'CE4_u3', NULL, NULL, NULL, 2),
(7669, NULL, 'cd03358', NULL, NULL, 'LbH_WxcM_N_like', NULL, 'LbH_WxcM_N_like', NULL, NULL, NULL, 2),
(7670, NULL, 'cd00473', NULL, NULL, 'bS6', NULL, 'bS6', NULL, NULL, 21155, 2),
(7671, NULL, 'cd08473', NULL, NULL, 'PBP2_CrgA_like_4', NULL, 'PBP2_CrgA_like_4', NULL, NULL, NULL, 2),
(7672, NULL, 'cd09356', NULL, NULL, 'LIM2_TRIP6', NULL, 'LIM2_TRIP6', NULL, NULL, NULL, 2),
(7673, NULL, 'cd20218', NULL, NULL, 'PFM_aerolysin', NULL, 'PFM_aerolysin', NULL, NULL, NULL, 2),
(7674, NULL, 'cd13725', NULL, NULL, 'PBP2_iGluR_kainate_KA2', NULL, 'PBP2_iGluR_kainate_KA2', NULL, NULL, NULL, 2),
(7675, NULL, 'cd20296', NULL, NULL, 'cupin_PpnP-like', NULL, 'cupin_PpnP-like', NULL, NULL, NULL, 2),
(7676, NULL, 'cd00457', NULL, NULL, 'PEBP', NULL, 'PEBP', NULL, NULL, NULL, 2),
(7677, NULL, 'cd04408', NULL, NULL, 'RhoGAP_GMIP', NULL, 'RhoGAP_GMIP', NULL, NULL, NULL, 2),
(7678, NULL, 'cd00188', NULL, NULL, 'TOPRIM', NULL, 'TOPRIM', NULL, NULL, NULL, 2),
(7679, NULL, 'cd07875', NULL, NULL, 'STKc_JNK1', NULL, 'STKc_JNK1', NULL, NULL, NULL, 2),
(7680, NULL, 'cd10145', NULL, NULL, 'TFIIA_gamma_N', NULL, 'TFIIA_gamma_N', NULL, NULL, 14072, 2),
(7681, NULL, 'cd12339', NULL, NULL, 'RRM2_SRSF1_4_like', NULL, 'RRM2_SRSF1_4_like', NULL, NULL, NULL, 2),
(7682, NULL, 'cd18590', NULL, NULL, 'ABC_6TM_TAP2', NULL, 'ABC_6TM_TAP2', NULL, NULL, NULL, 2),
(7683, NULL, 'cd04384', NULL, NULL, 'RhoGAP_CdGAP', NULL, 'RhoGAP_CdGAP', NULL, NULL, NULL, 2); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(7684, NULL, 'cd06616', NULL, NULL, 'PKc_MKK4', NULL, 'PKc_MKK4', NULL, NULL, NULL, 2),
(7685, NULL, 'cd09859', NULL, NULL, 'PIN_53EXO', NULL, 'PIN_53EXO', NULL, NULL, NULL, 2),
(7686, NULL, 'cd17025', NULL, NULL, 'T3SC_IA_ShcF-like', NULL, 'T3SC_IA_ShcF-like', NULL, NULL, NULL, 2),
(7687, NULL, 'cd15230', NULL, NULL, '7tmA_OR5-like', NULL, '7tmA_OR5-like', NULL, NULL, NULL, 2),
(7688, NULL, 'cd01783', NULL, NULL, 'RA2_DAGK-theta', NULL, 'RA2_DAGK-theta', NULL, NULL, NULL, 2),
(7689, NULL, 'cd18945', NULL, NULL, 'bHLH_E-protein_TCF4_E2-2', NULL, 'bHLH_E-protein_TCF4_E2-2', NULL, NULL, NULL, 2),
(7690, NULL, 'cd16832', NULL, NULL, 'CNF1_CheD_YfiH-like', NULL, 'CNF1_CheD_YfiH-like', NULL, NULL, NULL, 2),
(7691, NULL, 'cd08451', NULL, NULL, 'PBP2_BudR', NULL, 'PBP2_BudR', NULL, NULL, 28784, 2),
(7692, NULL, 'cd17082', NULL, NULL, 'RAWUL_PCGF2_like', NULL, 'RAWUL_PCGF2_like', NULL, NULL, NULL, 2),
(7693, NULL, 'cd20304', NULL, NULL, 'cupin_OxDC_N', NULL, 'cupin_OxDC_N', NULL, NULL, NULL, 2),
(7694, NULL, 'cd12720', NULL, NULL, 'RRM_SYNJ2', NULL, 'RRM_SYNJ2', NULL, NULL, 27407, 2),
(7695, NULL, 'cd14875', NULL, NULL, 'MYSc_Myo13', NULL, 'MYSc_Myo13', NULL, NULL, 31872, 2),
(7696, NULL, 'cd06841', NULL, NULL, 'PLPDE_III_MccE_like', NULL, 'PLPDE_III_MccE_like', NULL, NULL, NULL, 2),
(7697, NULL, 'cd16219', NULL, NULL, 'EFh_PI-PLCdelta4', NULL, 'EFh_PI-PLCdelta4', NULL, NULL, NULL, 2),
(7698, NULL, 'cd06193', NULL, NULL, 'siderophore_interacting', NULL, 'siderophore_interacting', NULL, NULL, NULL, 2),
(7699, NULL, 'cd14713', NULL, NULL, 'bZIP_CEBPG', NULL, 'bZIP_CEBPG', NULL, NULL, NULL, 2),
(7700, NULL, 'cd07630', NULL, NULL, 'BAR_SNX_like', NULL, 'BAR_SNX_like', NULL, NULL, NULL, 2),
(7701, NULL, 'cd05379', NULL, NULL, 'CAP_bacterial', NULL, 'CAP_bacterial', NULL, NULL, NULL, 2),
(7702, NULL, 'cd13567', NULL, NULL, 'PBP2_TtGluBP', NULL, 'PBP2_TtGluBP', NULL, NULL, NULL, 2),
(7703, NULL, 'cd15857', NULL, NULL, 'SNARE_SEC9C', NULL, 'SNARE_SEC9C', NULL, NULL, NULL, 2),
(7704, NULL, 'cd14865', NULL, NULL, 'Fe-ADH-like', NULL, 'Fe-ADH-like', NULL, NULL, NULL, 2),
(7705, NULL, 'cd15500', NULL, NULL, 'PHD1_PHF1', NULL, 'PHD1_PHF1', NULL, NULL, NULL, 2),
(7706, NULL, 'cd10333', NULL, NULL, 'LeuT-like_sbd', NULL, 'LeuT-like_sbd', NULL, NULL, NULL, 2),
(7707, NULL, 'cd07017', NULL, NULL, 'S14_ClpP_2', NULL, 'S14_ClpP_2', NULL, NULL, 2293, 2),
(7708, NULL, 'cd06947', NULL, NULL, 'NR_LBD_GR_Like', NULL, 'NR_LBD_GR_Like', NULL, NULL, NULL, 2),
(7709, NULL, 'cd09921', NULL, NULL, 'SH2_Jak_family', NULL, 'SH2_Jak_family', NULL, NULL, NULL, 2),
(7710, NULL, 'cd10377', NULL, NULL, 'SH2_STAT6', NULL, 'SH2_STAT6', NULL, NULL, 32360, 2),
(7711, NULL, 'cd19848', NULL, NULL, 'Bbox1_TRIM36_C-I', NULL, 'Bbox1_TRIM36_C-I', NULL, NULL, NULL, 2),
(7712, NULL, 'cd06428', NULL, NULL, 'M1P_guanylylT_A_like_N', NULL, 'M1P_guanylylT_A_like_N', NULL, NULL, NULL, 2),
(7713, NULL, 'cd09920', NULL, NULL, 'SH2_Cbl-b_TKB', NULL, 'SH2_Cbl-b_TKB', NULL, NULL, 14105, 2),
(7714, NULL, 'cd01973', NULL, NULL, 'Nitrogenase_VFe_beta_like', NULL, 'Nitrogenase_VFe_beta_like', NULL, NULL, NULL, 2),
(7715, NULL, 'cd11022', NULL, NULL, 'CuRO_4_ceruloplasmin', NULL, 'CuRO_4_ceruloplasmin', NULL, NULL, NULL, 2),
(7716, NULL, 'cd12506', NULL, NULL, 'RRM3_hnRNPH_CRSF1_like', NULL, 'RRM3_hnRNPH_CRSF1_like', NULL, NULL, NULL, 2),
(7717, NULL, 'cd16411', NULL, NULL, 'ParB_N_like', NULL, 'ParB_N_like', NULL, NULL, NULL, 2),
(7718, NULL, 'cd18409', NULL, NULL, 'BTB_POZ_KCNA10', NULL, 'BTB_POZ_KCNA10', NULL, NULL, NULL, 2),
(7719, NULL, 'cd07466', NULL, NULL, 'CRD_FZ7', NULL, 'CRD_FZ7', NULL, NULL, 35152, 2),
(7720, NULL, 'cd15432', NULL, NULL, '7tmA_OR2B2-like', NULL, '7tmA_OR2B2-like', NULL, NULL, NULL, 2),
(7721, NULL, 'cd02899', NULL, NULL, 'PLAT_SR', NULL, 'PLAT_SR', NULL, NULL, NULL, 2),
(7722, NULL, 'cd21168', NULL, NULL, 'M_gcv_Nsp15-like', NULL, 'M_gcv_Nsp15-like', NULL, NULL, 35679, 2),
(7723, NULL, 'cd17000', NULL, NULL, 'VHS_STAM1', NULL, 'VHS_STAM1', NULL, NULL, NULL, 2),
(7724, NULL, 'cd19703', NULL, NULL, 'bHLH_TS_musculin', NULL, 'bHLH_TS_musculin', NULL, NULL, NULL, 2);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(7725, NULL, 'cd00424', NULL, NULL, 'PolY', NULL, 'PolY', NULL, NULL, NULL, 2),
(7726, NULL, 'cd00182', NULL, NULL, 'TBOX', NULL, 'TBOX', NULL, NULL, 36881, 2),
(7727, NULL, 'cd11784', NULL, NULL, 'SH3_SH3RF2_3', NULL, 'SH3_SH3RF2_3', NULL, NULL, 28609, 2),
(7728, NULL, 'cd19737', NULL, NULL, 'bHLH-PAS_NPAS2_PASD4', NULL, 'bHLH-PAS_NPAS2_PASD4', NULL, NULL, NULL, 2),
(7729, NULL, 'cd07685', NULL, NULL, 'F-BAR_Fes', NULL, 'F-BAR_Fes', NULL, NULL, NULL, 2),
(7730, NULL, 'cd08263', NULL, NULL, 'Zn_ADH10', NULL, 'Zn_ADH10', NULL, NULL, NULL, 2),
(7731, NULL, 'cd10013', NULL, NULL, 'Cas3''''_I', NULL, 'Cas3''''_I', NULL, NULL, NULL, 2),
(7732, NULL, 'cd16383', NULL, NULL, 'GUN4', NULL, 'GUN4', NULL, NULL, 14074, 2),
(7733, NULL, 'cd17139', NULL, NULL, 'RBD2_RGS14', NULL, 'RBD2_RGS14', NULL, NULL, NULL, 2),
(7734, NULL, 'cd06982', NULL, NULL, 'cupin_BauB-like', NULL, 'cupin_BauB-like', NULL, NULL, NULL, 2),
(7735, NULL, 'cd18030', NULL, NULL, 'DEXHc_RE_I_HsdR', NULL, 'DEXHc_RE_I_HsdR', NULL, NULL, NULL, 2),
(7736, NULL, 'cd20222', NULL, NULL, 'PFM_parasporin-2-like', NULL, 'PFM_parasporin-2-like', NULL, NULL, NULL, 2),
(7737, NULL, 'cd07958', NULL, NULL, 'Anticodon_Ia_Leu_BEm', NULL, 'Anticodon_Ia_Leu_BEm', NULL, NULL, NULL, 2),
(7738, NULL, 'cd12144', NULL, NULL, 'SDH_N_domain', NULL, 'SDH_N_domain', NULL, NULL, 3663, 2),
(7739, NULL, 'cd10455', NULL, NULL, 'GIY-YIG_SLX1', NULL, 'GIY-YIG_SLX1', NULL, NULL, NULL, 2),
(7740, NULL, 'cd19199', NULL, NULL, 'PR-SET_PRDM15', NULL, 'PR-SET_PRDM15', NULL, NULL, 34597, 2),
(7741, NULL, 'cd16806', NULL, NULL, 'RING_CH-C4HC3_MARCH1', NULL, 'RING_CH-C4HC3_MARCH1', NULL, NULL, NULL, 2),
(7742, NULL, 'cd14823', NULL, NULL, 'AP_longin-like', NULL, 'AP_longin-like', NULL, NULL, NULL, 2),
(7743, NULL, 'cd06882', NULL, NULL, 'PX_p40phox', NULL, 'PX_p40phox', NULL, NULL, 11012, 2),
(7744, NULL, 'cd19428', NULL, NULL, 'lipocalin_MUP-like', NULL, 'lipocalin_MUP-like', NULL, NULL, NULL, 2),
(7745, NULL, 'cd17232', NULL, NULL, 'Ubl_ATG8_GABARAP', NULL, 'Ubl_ATG8_GABARAP', NULL, NULL, NULL, 2),
(7746, NULL, 'cd05656', NULL, NULL, 'M42_Frv', NULL, 'M42_Frv', NULL, NULL, NULL, 2),
(7747, NULL, 'cd07105', NULL, NULL, 'ALDH_SaliADH', NULL, 'ALDH_SaliADH', NULL, NULL, NULL, 2),
(7748, NULL, 'cd10499', NULL, NULL, 'MH2_SMAD_6', NULL, 'MH2_SMAD_6', NULL, NULL, NULL, 2),
(7749, NULL, 'cd17449', NULL, NULL, 'MFS_SLC46A1_PCFT', NULL, 'MFS_SLC46A1_PCFT', NULL, NULL, NULL, 2),
(7750, NULL, 'cd05492', NULL, NULL, 'Bromo_ZMYND11', NULL, 'Bromo_ZMYND11', NULL, NULL, NULL, 2),
(7751, NULL, 'cd15617', NULL, NULL, 'PHD_UHRF2', NULL, 'PHD_UHRF2', NULL, NULL, NULL, 2),
(7752, NULL, 'cd15673', NULL, NULL, 'ePHD_PHF6_like', NULL, 'ePHD_PHF6_like', NULL, NULL, NULL, 2),
(7753, NULL, 'cd15677', NULL, NULL, 'PHD_BRPF2', NULL, 'PHD_BRPF2', NULL, NULL, 30132, 2),
(7754, NULL, 'cd06125', NULL, NULL, 'DnaQ_like_exo', NULL, 'DnaQ_like_exo', NULL, NULL, NULL, 2),
(7755, NULL, 'cd02112', NULL, NULL, 'eukary_NR_Moco', NULL, 'eukary_NR_Moco', NULL, NULL, NULL, 2),
(7756, NULL, 'cd14912', NULL, NULL, 'MYSc_Myh2_mammals', NULL, 'MYSc_Myh2_mammals', NULL, NULL, NULL, 2),
(7757, NULL, 'cd00312', NULL, NULL, 'Esterase_lipase', NULL, 'Esterase_lipase', NULL, NULL, NULL, 2),
(7758, NULL, 'cd12585', NULL, NULL, 'RRM2_hnRPDL', NULL, 'RRM2_hnRPDL', NULL, NULL, NULL, 2),
(7759, NULL, 'cd09327', NULL, NULL, 'LIM1_abLIM', NULL, 'LIM1_abLIM', NULL, NULL, NULL, 2),
(7760, NULL, 'cd11738', NULL, NULL, 'HSPA4L_NBD', NULL, 'HSPA4L_NBD', NULL, NULL, 35751, 2),
(7761, NULL, 'cd00978', NULL, NULL, 'chitosanase_GH46', NULL, 'chitosanase_GH46', NULL, NULL, 6621, 2),
(7762, NULL, 'cd10440', NULL, NULL, 'GIY-YIG_COG3680', NULL, 'GIY-YIG_COG3680', NULL, NULL, NULL, 2),
(7763, NULL, 'cd06375', NULL, NULL, 'PBP1_mGluR_groupII', NULL, 'PBP1_mGluR_groupII', NULL, NULL, NULL, 2),
(7764, NULL, 'cd12405', NULL, NULL, 'RRM3_NCL', NULL, 'RRM3_NCL', NULL, NULL, 30700, 2),
(7765, NULL, 'cd14844', NULL, NULL, 'Zn-DD-carboxypeptidase_like', NULL, 'Zn-DD-carboxypeptidase_like', NULL, NULL, NULL, 2),
(7766, NULL, 'cd18502', NULL, NULL, 'BACK_NS1BP_IVNS1ABP', NULL, 'BACK_NS1BP_IVNS1ABP', NULL, NULL, NULL, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(7767, NULL, 'cd12624', NULL, NULL, 'RRM_PRC', NULL, 'RRM_PRC', NULL, NULL, 33149, 2),
(7768, NULL, 'cd13270', NULL, NULL, 'PH1_TAPP1_2', NULL, 'PH1_TAPP1_2', NULL, NULL, NULL, 2),
(7769, NULL, 'cd16327', NULL, NULL, 'RseB', NULL, 'RseB', NULL, NULL, 31999, 2),
(7770, NULL, 'cd07789', NULL, NULL, 'FGGY_CsGK_like', NULL, 'FGGY_CsGK_like', NULL, NULL, NULL, 2),
(7771, NULL, 'cd12466', NULL, NULL, 'RRM2_AtRSp31_like', NULL, 'RRM2_AtRSp31_like', NULL, NULL, NULL, 2),
(7772, NULL, 'cd14488', NULL, NULL, 'CBM6-CBM35-CBM36_like_2', NULL, 'CBM6-CBM35-CBM36_like_2', NULL, NULL, 29021, 2),
(7773, NULL, 'cd00946', NULL, NULL, 'FBP_aldolase_IIA', NULL, 'FBP_aldolase_IIA', NULL, NULL, 5608, 2),
(7774, NULL, 'cd10045', NULL, NULL, 'Reelin_repeat_1_subrepeat_2', NULL, 'Reelin_repeat_1_subrepeat_2', NULL, NULL, NULL, 2),
(7775, NULL, 'cd06853', NULL, NULL, 'GT_WecA_like', NULL, 'GT_WecA_like', NULL, NULL, NULL, 2),
(7776, NULL, 'cd06654', NULL, NULL, 'STKc_PAK1', NULL, 'STKc_PAK1', NULL, NULL, NULL, 2),
(7777, NULL, 'cd16140', NULL, NULL, 'RA_GRB7', NULL, 'RA_GRB7', NULL, NULL, NULL, 2),
(7778, NULL, 'cd04938', NULL, NULL, 'TGS_Obg', NULL, 'TGS_Obg', NULL, NULL, NULL, 2),
(7779, NULL, 'cd10487', NULL, NULL, 'EphR_LBD_A10', NULL, 'EphR_LBD_A10', NULL, NULL, NULL, 2),
(7780, NULL, 'cd02016', NULL, NULL, 'TPP_E1_OGDC_like', NULL, 'TPP_E1_OGDC_like', NULL, NULL, NULL, 2),
(7781, NULL, 'cd07453', NULL, NULL, 'CRD_crescent', NULL, 'CRD_crescent', NULL, NULL, 30530, 2),
(7782, NULL, 'cd03465', NULL, NULL, 'URO-D_like', NULL, 'URO-D_like', NULL, NULL, NULL, 2),
(7783, NULL, 'cd06097', NULL, NULL, 'Aspergillopepsin_like', NULL, 'Aspergillopepsin_like', NULL, NULL, 22899, 2),
(7784, NULL, 'cd06891', NULL, NULL, 'PX_Vps17p', NULL, 'PX_Vps17p', NULL, NULL, 27109, 2),
(7785, NULL, 'cd19578', NULL, NULL, 'serpinK_insect_SRPN2-like', NULL, 'serpinK_insect_SRPN2-like', NULL, NULL, NULL, 2),
(7786, NULL, 'cd17784', NULL, NULL, 'CBS_pair_Euryarchaeota', NULL, 'CBS_pair_Euryarchaeota', NULL, NULL, NULL, 2),
(7787, NULL, 'cd12937', NULL, NULL, 'GUCT_RH7_like', NULL, 'GUCT_RH7_like', NULL, NULL, NULL, 2),
(7788, NULL, 'cd21466', NULL, NULL, 'Ubl2_cv_PLpro_N_Nsp3-like', NULL, 'Ubl2_cv_PLpro_N_Nsp3-like', NULL, NULL, 34481, 2),
(7789, NULL, 'cd15235', NULL, NULL, '7tmA_OR1A-like', NULL, '7tmA_OR1A-like', NULL, NULL, NULL, 2),
(7790, NULL, 'cd07460', NULL, NULL, 'CRD_FZ5', NULL, 'CRD_FZ5', NULL, NULL, 33443, 2),
(7791, NULL, 'cd16962', NULL, NULL, 'RuvC', NULL, 'RuvC', NULL, NULL, 5021, 2),
(7792, NULL, 'cd14508', NULL, NULL, 'PTP_tensin', NULL, 'PTP_tensin', NULL, NULL, NULL, 2),
(7793, NULL, 'cd07286', NULL, NULL, 'PX_SNX18', NULL, 'PX_SNX18', NULL, NULL, 27949, 2),
(7794, NULL, 'cd13140', NULL, NULL, 'MATE_like_1', NULL, 'MATE_like_1', NULL, NULL, NULL, 2),
(7795, NULL, 'cd09154', NULL, NULL, 'PLDc_SMU_988_like_1', NULL, 'PLDc_SMU_988_like_1', NULL, NULL, NULL, 2),
(7796, NULL, 'cd08727', NULL, NULL, 'RGS_RGS22_2', NULL, 'RGS_RGS22_2', NULL, NULL, NULL, 2),
(7797, NULL, 'cd19176', NULL, NULL, 'SET_SETD3', NULL, 'SET_SETD3', NULL, NULL, 35381, 2),
(7798, NULL, 'cd18527', NULL, NULL, 'BACK_BTBD11', NULL, 'BACK_BTBD11', NULL, NULL, NULL, 2),
(7799, NULL, 'cd08251', NULL, NULL, 'polyketide_synthase', NULL, 'polyketide_synthase', NULL, NULL, NULL, 2),
(7800, NULL, 'cd15189', NULL, NULL, '7tmA_Bradykinin_R', NULL, '7tmA_Bradykinin_R', NULL, NULL, NULL, 2),
(7801, NULL, 'cd13201', NULL, NULL, 'FERM_C_MyoXV', NULL, 'FERM_C_MyoXV', NULL, NULL, 30590, 2),
(7802, NULL, 'cd16321', NULL, NULL, 'MraZ_C', NULL, 'MraZ_C', NULL, NULL, 32031, 2),
(7803, NULL, 'cd07587', NULL, NULL, 'ML_beta-AS', NULL, 'ML_beta-AS', NULL, NULL, NULL, 2),
(7804, NULL, 'cd17715', NULL, NULL, 'BRCT_polymerase_lambda', NULL, 'BRCT_polymerase_lambda', NULL, NULL, NULL, 2),
(7805, NULL, 'cd07176', NULL, NULL, 'terB', NULL, 'terB', NULL, NULL, NULL, 2),
(7806, NULL, 'cd06251', NULL, NULL, 'M14_ASTE_ASPA-like', NULL, 'M14_ASTE_ASPA-like', NULL, NULL, NULL, 2),
(7807, NULL, 'cd13247', NULL, NULL, 'BAR-PH_APPL', NULL, 'BAR-PH_APPL', NULL, NULL, NULL, 2),
(7808, NULL, 'cd01748', NULL, NULL, 'GATase1_IGP_Synthase', NULL, 'GATase1_IGP_Synthase', NULL, NULL, 10763, 2);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(7809, NULL, 'cd05814', NULL, NULL, 'CBM20_Prei4', NULL, 'CBM20_Prei4', NULL, NULL, 13869, 2),
(7810, NULL, 'cd00351', NULL, NULL, 'TS_Pyrimidine_HMase', NULL, 'TS_Pyrimidine_HMase', NULL, NULL, 16438, 2),
(7811, NULL, 'cd08878', NULL, NULL, 'RHO_alpha_C_DMO-like', NULL, 'RHO_alpha_C_DMO-like', NULL, NULL, NULL, 2),
(7812, NULL, 'cd02233', NULL, NULL, 'cupin_HNL-like', NULL, 'cupin_HNL-like', NULL, NULL, NULL, 2),
(7813, NULL, 'cd07912', NULL, NULL, 'Tweety_N', NULL, 'Tweety_N', NULL, NULL, 5875, 2),
(7814, NULL, 'cd14603', NULL, NULL, 'PTPc-N18', NULL, 'PTPc-N18', NULL, NULL, NULL, 2),
(7815, NULL, 'cd06158', NULL, NULL, 'S2P-M50_like_1', NULL, 'S2P-M50_like_1', NULL, NULL, 34541, 2),
(7816, NULL, 'cd09914', NULL, NULL, 'RocCOR', NULL, 'RocCOR', NULL, NULL, NULL, 2),
(7817, NULL, 'cd01360', NULL, NULL, 'Adenylsuccinate_lyase_1', NULL, 'Adenylsuccinate_lyase_1', NULL, NULL, NULL, 2),
(7818, NULL, 'cd09438', NULL, NULL, 'LIM3_Ajuba_like', NULL, 'LIM3_Ajuba_like', NULL, NULL, NULL, 2),
(7819, NULL, 'cd08575', NULL, NULL, 'GDPD_GDE4_like', NULL, 'GDPD_GDE4_like', NULL, NULL, NULL, 2),
(7820, NULL, 'cd05717', NULL, NULL, 'Ig1_Necl_like', NULL, 'Ig1_Necl_like', NULL, NULL, NULL, 2),
(7821, NULL, 'cd14121', NULL, NULL, 'STKc_ULK3', NULL, 'STKc_ULK3', NULL, NULL, NULL, 2),
(7822, NULL, 'cd16173', NULL, NULL, 'EFh_MICU1', NULL, 'EFh_MICU1', NULL, NULL, NULL, 2),
(7823, NULL, 'cd16820', NULL, NULL, 'SP-RING_PIAS3', NULL, 'SP-RING_PIAS3', NULL, NULL, NULL, 2),
(7824, NULL, 'cd19184', NULL, NULL, 'SET_KMT5B', NULL, 'SET_KMT5B', NULL, NULL, 35174, 2),
(7825, NULL, 'cd11662', NULL, NULL, 'apollo_TRF2_binding', NULL, 'apollo_TRF2_binding', NULL, NULL, NULL, 2),
(7826, NULL, 'cd07244', NULL, NULL, 'FosA', NULL, 'FosA', NULL, NULL, NULL, 2),
(7827, NULL, 'cd01775', NULL, NULL, 'RA_PHLPP_like', NULL, 'RA_PHLPP_like', NULL, NULL, NULL, 2),
(7828, NULL, 'cd04119', NULL, NULL, 'RJL', NULL, 'RJL', NULL, NULL, NULL, 2),
(7829, NULL, 'cd07704', NULL, NULL, 'Ig2_Nectin-3-4_like', NULL, 'Ig2_Nectin-3-4_like', NULL, NULL, NULL, 2),
(7830, NULL, 'cd05015', NULL, NULL, 'SIS_PGI_1', NULL, 'SIS_PGI_1', NULL, NULL, 28616, 2),
(7831, NULL, 'cd00904', NULL, NULL, 'Ferritin', NULL, 'Ferritin', NULL, NULL, NULL, 2),
(7832, NULL, 'cd16882', NULL, NULL, 'ARID_ARID4A', NULL, 'ARID_ARID4A', NULL, NULL, NULL, 2),
(7833, NULL, 'cd18370', NULL, NULL, 'BTB_POZ_KCTD11', NULL, 'BTB_POZ_KCTD11', NULL, NULL, NULL, 2),
(7834, NULL, 'cd01790', NULL, NULL, 'Ubl_HERP', NULL, 'Ubl_HERP', NULL, NULL, NULL, 2),
(7835, NULL, 'cd01967', NULL, NULL, 'Nitrogenase_MoFe_alpha_like', NULL, 'Nitrogenase_MoFe_alpha_like', NULL, NULL, NULL, 2),
(7836, NULL, 'cd09889', NULL, NULL, 'NGN_Bact_2', NULL, 'NGN_Bact_2', NULL, NULL, NULL, 2),
(7837, NULL, 'cd14751', NULL, NULL, 'PBP2_GacH', NULL, 'PBP2_GacH', NULL, NULL, NULL, 2),
(7838, NULL, 'cd14702', NULL, NULL, 'bZIP_plant_GBF1', NULL, 'bZIP_plant_GBF1', NULL, NULL, 36894, 2),
(7839, NULL, 'cd04984', NULL, NULL, 'IgV_L_lambda', NULL, 'IgV_L_lambda', NULL, NULL, NULL, 2),
(7840, NULL, 'cd18098', NULL, NULL, 'SpoU-like', NULL, 'SpoU-like', NULL, NULL, NULL, 2),
(7841, NULL, 'cd00466', NULL, NULL, 'DHQase_II', NULL, 'DHQase_II', NULL, NULL, 4460, 2),
(7842, NULL, 'cd18663', NULL, NULL, 'CD2_tandem_CHD5-9_like', NULL, 'CD2_tandem_CHD5-9_like', NULL, NULL, NULL, 2),
(7843, NULL, 'cd12257', NULL, NULL, 'RRM1_RBM26_like', NULL, 'RRM1_RBM26_like', NULL, NULL, NULL, 2),
(7844, NULL, 'cd16462', NULL, NULL, 'RING-H2_Pep3p_like', NULL, 'RING-H2_Pep3p_like', NULL, NULL, NULL, 2),
(7845, NULL, 'cd03496', NULL, NULL, 'SQR_TypeC_CybS', NULL, 'SQR_TypeC_CybS', NULL, NULL, 4380, 2),
(7846, NULL, 'cd16888', NULL, NULL, 'lyz_G-like_1', NULL, 'lyz_G-like_1', NULL, NULL, NULL, 2),
(7847, NULL, 'cd01220', NULL, NULL, 'PH1_FARP1-like', NULL, 'PH1_FARP1-like', NULL, NULL, NULL, 2),
(7848, NULL, 'cd13997', NULL, NULL, 'PKc_Wee1_like', NULL, 'PKc_Wee1_like', NULL, NULL, 35728, 2),
(7849, NULL, 'cd19534', NULL, NULL, 'E_NRPS', NULL, 'E_NRPS', NULL, NULL, NULL, 2),
(7850, NULL, 'cd11915', NULL, NULL, 'SH3_Irsp53', NULL, 'SH3_Irsp53', NULL, NULL, 31916, 2);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(7851, NULL, 'cd08544', NULL, NULL, 'Reeler', NULL, 'Reeler', NULL, NULL, 5561, 2),
(7852, NULL, 'cd07308', NULL, NULL, 'lectin_leg-like', NULL, 'lectin_leg-like', NULL, NULL, NULL, 2),
(7853, NULL, 'cd12900', NULL, NULL, 'SPRY_PRY_TRIM21', NULL, 'SPRY_PRY_TRIM21', NULL, NULL, 32394, 2),
(7854, NULL, 'cd00057', NULL, NULL, 'FA58C', NULL, 'FA58C', NULL, NULL, 4934, 2),
(7855, NULL, 'cd08397', NULL, NULL, 'C2_PI3K_class_III', NULL, 'C2_PI3K_class_III', NULL, NULL, NULL, 2),
(7856, NULL, 'cd16527', NULL, NULL, 'RING-HC_PEX10', NULL, 'RING-HC_PEX10', NULL, NULL, NULL, 2),
(7857, NULL, 'cd16839', NULL, NULL, 'PCSK9_C-CRD', NULL, 'PCSK9_C-CRD', NULL, NULL, NULL, 2),
(7858, NULL, 'cd01653', NULL, NULL, 'GATase1', NULL, 'GATase1', NULL, NULL, NULL, 2),
(7859, NULL, 'cd15591', NULL, NULL, 'PHD2_KMT2B', NULL, 'PHD2_KMT2B', NULL, NULL, NULL, 2),
(7860, NULL, 'cd06643', NULL, NULL, 'STKc_SLK', NULL, 'STKc_SLK', NULL, NULL, NULL, 2),
(7861, NULL, 'cd08779', NULL, NULL, 'Death_PIDD', NULL, 'Death_PIDD', NULL, NULL, NULL, 2),
(7862, NULL, 'cd04338', NULL, NULL, 'Rieske_RO_Alpha_Tic55', NULL, 'Rieske_RO_Alpha_Tic55', NULL, NULL, NULL, 2),
(7863, NULL, 'cd04645', NULL, NULL, 'LbH_gamma_CA_like', NULL, 'LbH_gamma_CA_like', NULL, NULL, NULL, 2),
(7864, NULL, 'cd00858', NULL, NULL, 'GlyRS_anticodon', NULL, 'GlyRS_anticodon', NULL, NULL, NULL, 2),
(7865, NULL, 'cd04688', NULL, NULL, 'Nudix_Hydrolase_29', NULL, 'Nudix_Hydrolase_29', NULL, NULL, NULL, 2),
(7866, NULL, 'cd13182', NULL, NULL, 'EVH1-like_Dcp1', NULL, 'EVH1-like_Dcp1', NULL, NULL, NULL, 2),
(7867, NULL, 'cd15181', NULL, NULL, '7tmA_CXCR5', NULL, '7tmA_CXCR5', NULL, NULL, NULL, 2),
(7868, NULL, 'cd17048', NULL, NULL, 'Ubl_UBL3', NULL, 'Ubl_UBL3', NULL, NULL, NULL, 2),
(7869, NULL, 'cd06857', NULL, NULL, 'SLC5-6-like_sbd', NULL, 'SLC5-6-like_sbd', NULL, NULL, NULL, 2),
(7870, NULL, 'cd12752', NULL, NULL, 'RRM1_RBM5', NULL, 'RRM1_RBM5', NULL, NULL, 14939, 2),
(7871, NULL, 'cd07119', NULL, NULL, 'ALDH_BADH-GbsA', NULL, 'ALDH_BADH-GbsA', NULL, NULL, NULL, 2),
(7872, NULL, 'cd07524', NULL, NULL, 'HAD_Pase', NULL, 'HAD_Pase', NULL, NULL, NULL, 2),
(7873, NULL, 'cd02433', NULL, NULL, 'Nodulin-21_like_2', NULL, 'Nodulin-21_like_2', NULL, NULL, NULL, 2),
(7874, NULL, 'cd09003', NULL, NULL, 'GH43_XynD-like', NULL, 'GH43_XynD-like', NULL, NULL, NULL, 2),
(7875, NULL, 'cd14779', NULL, NULL, 'FHP_Ae-globin-like', NULL, 'FHP_Ae-globin-like', NULL, NULL, NULL, 2),
(7876, NULL, 'cd19084', NULL, NULL, 'AKR_AKR11B1-like', NULL, 'AKR_AKR11B1-like', NULL, NULL, NULL, 2),
(7877, NULL, 'cd11672', NULL, NULL, 'ADDz', NULL, 'ADDz', NULL, NULL, NULL, 2),
(7878, NULL, 'cd07425', NULL, NULL, 'MPP_Shelphs', NULL, 'MPP_Shelphs', NULL, NULL, 30998, 2),
(7879, NULL, 'cd11356', NULL, NULL, 'AmyAc_Sucrose_phosphorylase-like_1', NULL, 'AmyAc_Sucrose_phosphorylase-like_1', NULL, NULL, 28687, 2),
(7880, NULL, 'cd16012', NULL, NULL, 'ALP', NULL, 'ALP', NULL, NULL, 2005, 2),
(7881, NULL, 'cd18911', NULL, NULL, 'bHLHzip_MGA', NULL, 'bHLHzip_MGA', NULL, NULL, NULL, 2),
(7882, NULL, 'cd01517', NULL, NULL, 'PAP_phosphatase', NULL, 'PAP_phosphatase', NULL, NULL, NULL, 2),
(7883, NULL, 'cd16365', NULL, NULL, 'NarH_like', NULL, 'NarH_like', NULL, NULL, NULL, 2),
(7884, NULL, 'cd08426', NULL, NULL, 'PBP2_LTTR_like_5', NULL, 'PBP2_LTTR_like_5', NULL, NULL, NULL, 2),
(7885, NULL, 'cd14220', NULL, NULL, 'STKc_BMPR1a', NULL, 'STKc_BMPR1a', NULL, NULL, NULL, 2),
(7886, NULL, 'cd06554', NULL, NULL, 'ASCH_ASC-1_like', NULL, 'ASCH_ASC-1_like', NULL, NULL, NULL, 2),
(7887, NULL, 'cd13237', NULL, NULL, 'PH2_FGD5_FGD6', NULL, 'PH2_FGD5_FGD6', NULL, NULL, NULL, 2),
(7888, NULL, 'cd13894', NULL, NULL, 'CuRO_3_AAO_like_1', NULL, 'CuRO_3_AAO_like_1', NULL, NULL, 32594, 2),
(7889, NULL, 'cd14363', NULL, NULL, 'CUE_TOLIP', NULL, 'CUE_TOLIP', NULL, NULL, 30918, 2),
(7890, NULL, 'cd12057', NULL, NULL, 'SH3_CIN85_3', NULL, 'SH3_CIN85_3', NULL, NULL, 31676, 2),
(7891, NULL, 'cd11761', NULL, NULL, 'SH3_FCHSD_1', NULL, 'SH3_FCHSD_1', NULL, NULL, 14627, 2),
(7892, NULL, 'cd12960', NULL, NULL, 'Spider_toxin', NULL, 'Spider_toxin', NULL, NULL, 2750, 2);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(7893, NULL, 'cd06917', NULL, NULL, 'STKc_NAK1_like', NULL, 'STKc_NAK1_like', NULL, NULL, 16325, 2),
(7894, NULL, 'cd00684', NULL, NULL, 'Terpene_cyclase_plant_C1', NULL, 'Terpene_cyclase_plant_C1', NULL, NULL, 34572, 2),
(7895, NULL, 'cd04601', NULL, NULL, 'CBS_pair_IMPDH', NULL, 'CBS_pair_IMPDH', NULL, NULL, NULL, 2),
(7896, NULL, 'cd05784', NULL, NULL, 'DNA_polB_II_exo', NULL, 'DNA_polB_II_exo', NULL, NULL, NULL, 2),
(7897, NULL, 'cd16394', NULL, NULL, 'sopB_N', NULL, 'sopB_N', NULL, NULL, NULL, 2),
(7898, NULL, 'cd16614', NULL, NULL, 'RING-HC_UNK_like', NULL, 'RING-HC_UNK_like', NULL, NULL, NULL, 2),
(7899, NULL, 'cd11581', NULL, NULL, 'GINS_A', NULL, 'GINS_A', NULL, NULL, NULL, 2),
(7900, NULL, 'cd13354', NULL, NULL, 'PH-GRAM2_TCB1D9_TCB1D9B', NULL, 'PH-GRAM2_TCB1D9_TCB1D9B', NULL, NULL, 28069, 2),
(7901, NULL, 'cd15098', NULL, NULL, '7tmA_Gal1_R', NULL, '7tmA_Gal1_R', NULL, NULL, NULL, 2),
(7902, NULL, 'cd12938', NULL, NULL, 'GUCT_Hera', NULL, 'GUCT_Hera', NULL, NULL, NULL, 2),
(7903, NULL, 'cd17296', NULL, NULL, 'RMtype1_S_MmaC5ORF1169P_TRD1-CR1_like', NULL, 'RMtype1_S_MmaC5ORF1169P_TRD1-CR1_like', NULL, NULL, NULL, 2),
(7904, NULL, 'cd03497', NULL, NULL, 'SQR_TypeB_1_TM', NULL, 'SQR_TypeB_1_TM', NULL, NULL, 9096, 2),
(7905, NULL, 'cd14707', NULL, NULL, 'bZIP_plant_BZIP46', NULL, 'bZIP_plant_BZIP46', NULL, NULL, NULL, 2),
(7906, NULL, 'cd09860', NULL, NULL, 'PIN_T4-like', NULL, 'PIN_T4-like', NULL, NULL, NULL, 2),
(7907, NULL, 'cd17495', NULL, NULL, 'RMtype1_S_Cep9333ORF4827P-TRD2-CR2_like', NULL, 'RMtype1_S_Cep9333ORF4827P-TRD2-CR2_like', NULL, NULL, NULL, 2),
(7908, NULL, 'cd16630', NULL, NULL, 'RING-HC_RBR_RNF216', NULL, 'RING-HC_RBR_RNF216', NULL, NULL, NULL, 2),
(7909, NULL, 'sd00025', NULL, NULL, 'zf-RanBP2', NULL, 'zf-RanBP2', NULL, NULL, NULL, 2),
(7910, NULL, 'cd01342', NULL, NULL, 'Translation_Factor_II_like', NULL, 'Translation_Factor_II_like', NULL, NULL, NULL, 2),
(7911, NULL, 'cd07228', NULL, NULL, 'Pat_NTE_like_bacteria', NULL, 'Pat_NTE_like_bacteria', NULL, NULL, NULL, 2),
(7912, NULL, 'cd07010', NULL, NULL, 'cupin_PMI_type_I_N_bac', NULL, 'cupin_PMI_type_I_N_bac', NULL, NULL, NULL, 2),
(7913, NULL, 'cd11456', NULL, NULL, 'bHLHzip_N-Myc_like', NULL, 'bHLHzip_N-Myc_like', NULL, NULL, NULL, 2),
(7914, NULL, 'cd01727', NULL, NULL, 'LSm8', NULL, 'LSm8', NULL, NULL, 2695, 2),
(7915, NULL, 'cd18791', NULL, NULL, 'SF2_C_RHA', NULL, 'SF2_C_RHA', NULL, NULL, NULL, 2),
(7916, NULL, 'cd14854', NULL, NULL, 'TRAPPC2L', NULL, 'TRAPPC2L', NULL, NULL, 34185, 2),
(7917, NULL, 'cd15949', NULL, NULL, '7tmA_OR52M-like', NULL, '7tmA_OR52M-like', NULL, NULL, NULL, 2),
(7918, NULL, 'cd06482', NULL, NULL, 'ACD_HspB10', NULL, 'ACD_HspB10', NULL, NULL, 32483, 2),
(7919, NULL, 'cd16648', NULL, NULL, 'mRING-HC-C3HC5_MAPL', NULL, 'mRING-HC-C3HC5_MAPL', NULL, NULL, NULL, 2),
(7920, NULL, 'cd01324', NULL, NULL, 'cbb3_Oxidase_CcoQ', NULL, 'cbb3_Oxidase_CcoQ', NULL, NULL, 14030, 2),
(7921, NULL, 'cd01808', NULL, NULL, 'Ubl_PLICs', NULL, 'Ubl_PLICs', NULL, NULL, NULL, 2),
(7922, NULL, 'cd04881', NULL, NULL, 'ACT_HSDH-Hom', NULL, 'ACT_HSDH-Hom', NULL, NULL, NULL, 2),
(7923, NULL, 'cd09000', NULL, NULL, 'GH43_SXA-like', NULL, 'GH43_SXA-like', NULL, NULL, NULL, 2),
(7924, NULL, 'cd21623', NULL, NULL, 'ORF7b_SARS-CoV-2', NULL, 'ORF7b_SARS-CoV-2', NULL, NULL, NULL, 2),
(7925, NULL, 'cd14942', NULL, NULL, 'TRAPPC3_bet3', NULL, 'TRAPPC3_bet3', NULL, NULL, 21463, 2),
(7926, NULL, 'cd21514', NULL, NULL, 'cv_alpha_Nsp2_HCoV-229E-like', NULL, 'cv_alpha_Nsp2_HCoV-229E-like', NULL, NULL, 36976, 2),
(7927, NULL, 'cd07501', NULL, NULL, 'HAD_MDP-1_like', NULL, 'HAD_MDP-1_like', NULL, NULL, 32979, 2),
(7928, NULL, 'cd18894', NULL, NULL, 'JBP-like', NULL, 'JBP-like', NULL, NULL, NULL, 2),
(7929, NULL, 'cd19993', NULL, NULL, 'PBP1_ABC_xylose_binding-like', NULL, 'PBP1_ABC_xylose_binding-like', NULL, NULL, NULL, 2),
(7930, NULL, 'cd05884', NULL, NULL, 'Ig2_Necl-3', NULL, 'Ig2_Necl-3', NULL, NULL, NULL, 2),
(7931, NULL, 'cd09128', NULL, NULL, 'PLDc_unchar1_2', NULL, 'PLDc_unchar1_2', NULL, NULL, NULL, 2),
(7932, NULL, 'cd11720', NULL, NULL, 'FANCI', NULL, 'FANCI', NULL, NULL, 25287, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(7933, NULL, 'cd15277', NULL, NULL, '7tmC_RAIG3_GPRC5C', NULL, '7tmC_RAIG3_GPRC5C', NULL, NULL, NULL, 2),
(7934, NULL, 'cd17551', NULL, NULL, 'REC_RpfG-like', NULL, 'REC_RpfG-like', NULL, NULL, NULL, 2),
(7935, NULL, 'cd01795', NULL, NULL, 'Ubl_USP48', NULL, 'Ubl_USP48', NULL, NULL, 36136, 2),
(7936, NULL, 'cd12179', NULL, NULL, '2-Hacid_dh_14', NULL, '2-Hacid_dh_14', NULL, NULL, NULL, 2),
(7937, NULL, 'cd15648', NULL, NULL, 'PHD1_NSD1_2', NULL, 'PHD1_NSD1_2', NULL, NULL, NULL, 2),
(7938, NULL, 'cd17064', NULL, NULL, 'Ubl_TAFs_like', NULL, 'Ubl_TAFs_like', NULL, NULL, NULL, 2),
(7939, NULL, 'cd01747', NULL, NULL, 'GATase1_Glutamyl_Hydrolase', NULL, 'GATase1_Glutamyl_Hydrolase', NULL, NULL, NULL, 2),
(7940, NULL, 'cd02517', NULL, NULL, 'CMP-KDO-Synthetase', NULL, 'CMP-KDO-Synthetase', NULL, NULL, 1570, 2),
(7941, NULL, 'cd19147', NULL, NULL, 'AKR_AKR9A3_9B1-4', NULL, 'AKR_AKR9A3_9B1-4', NULL, NULL, NULL, 2),
(7942, NULL, 'cd10379', NULL, NULL, 'SH2_Jak2', NULL, 'SH2_Jak2', NULL, NULL, 29657, 2),
(7943, NULL, 'cd07741', NULL, NULL, 'metallo-hydrolase-like_MBL-fold', NULL, 'metallo-hydrolase-like_MBL-fold', NULL, NULL, NULL, 2),
(7944, NULL, 'cd19922', NULL, NULL, 'REC_RitR-like', NULL, 'REC_RitR-like', NULL, NULL, NULL, 2),
(7945, NULL, 'cd12760', NULL, NULL, 'RRM1_MSI2', NULL, 'RRM1_MSI2', NULL, NULL, NULL, 2),
(7946, NULL, 'cd04411', NULL, NULL, 'Ribosomal_P1_P2_L12p', NULL, 'Ribosomal_P1_P2_L12p', NULL, NULL, NULL, 2),
(7947, NULL, 'cd14774', NULL, NULL, 'TrHb2_HGbIV-like_O', NULL, 'TrHb2_HGbIV-like_O', NULL, NULL, NULL, 2),
(7948, NULL, 'cd15897', NULL, NULL, 'EFh_PEF', NULL, 'EFh_PEF', NULL, NULL, NULL, 2),
(7949, NULL, 'cd02114', NULL, NULL, 'bact_SorA_Moco', NULL, 'bact_SorA_Moco', NULL, NULL, NULL, 2),
(7950, NULL, 'cd00575', NULL, NULL, 'NOS_oxygenase', NULL, 'NOS_oxygenase', NULL, NULL, NULL, 2),
(7951, NULL, 'cd18020', NULL, NULL, 'DEXHc_ASCC3_1', NULL, 'DEXHc_ASCC3_1', NULL, NULL, NULL, 2),
(7952, NULL, 'cd19582', NULL, NULL, 'serpinM_ShSPI', NULL, 'serpinM_ShSPI', NULL, NULL, NULL, 2),
(7953, NULL, 'cd09704', NULL, NULL, 'Csx12', NULL, 'Csx12', NULL, NULL, NULL, 2),
(7954, NULL, 'cd12540', NULL, NULL, 'RRM_U2AFBPL', NULL, 'RRM_U2AFBPL', NULL, NULL, NULL, 2),
(7955, NULL, 'cd13438', NULL, NULL, 'SPFH_eoslipins_u2', NULL, 'SPFH_eoslipins_u2', NULL, NULL, NULL, 2),
(7956, NULL, 'cd00805', NULL, NULL, 'TyrRS_core', NULL, 'TyrRS_core', NULL, NULL, 6265, 2),
(7957, NULL, 'cd12719', NULL, NULL, 'RRM_SYNJ1', NULL, 'RRM_SYNJ1', NULL, NULL, 27463, 2),
(7958, NULL, 'cd14448', NULL, NULL, 'CuRO_2_BOD_CotA_like', NULL, 'CuRO_2_BOD_CotA_like', NULL, NULL, NULL, 2),
(7959, NULL, 'cd01486', NULL, NULL, 'Apg7', NULL, 'Apg7', NULL, NULL, NULL, 2),
(7960, NULL, 'cd09073', NULL, NULL, 'ExoIII_AP-endo', NULL, 'ExoIII_AP-endo', NULL, NULL, NULL, 2),
(7961, NULL, 'cd05103', NULL, NULL, 'PTKc_VEGFR2', NULL, 'PTKc_VEGFR2', NULL, NULL, NULL, 2),
(7962, NULL, 'cd18356', NULL, NULL, 'BTB1_POZ_RHOBTB2', NULL, 'BTB1_POZ_RHOBTB2', NULL, NULL, NULL, 2),
(7963, NULL, 'cd10332', NULL, NULL, 'SLC6sbd-B0AT-like', NULL, 'SLC6sbd-B0AT-like', NULL, NULL, NULL, 2),
(7964, NULL, 'cd18207', NULL, NULL, 'BTB_POZ_ZBTB19_PATZ1', NULL, 'BTB_POZ_ZBTB19_PATZ1', NULL, NULL, NULL, 2),
(7965, NULL, 'sd00038', NULL, NULL, 'Kelch', NULL, 'Kelch', NULL, NULL, NULL, 2),
(7966, NULL, 'cd18695', NULL, NULL, 'PIN_VapC-like', NULL, 'PIN_VapC-like', NULL, NULL, NULL, 2),
(7967, NULL, 'cd17626', NULL, NULL, 'REC_OmpR_MtrA-like', NULL, 'REC_OmpR_MtrA-like', NULL, NULL, NULL, 2),
(7968, NULL, 'cd16092', NULL, NULL, 'IgC_CH1_IgD', NULL, 'IgC_CH1_IgD', NULL, NULL, NULL, 2),
(7969, NULL, 'cd16374', NULL, NULL, 'DMSOR_beta_like', NULL, 'DMSOR_beta_like', NULL, NULL, NULL, 2),
(7970, NULL, 'cd13758', NULL, NULL, 'TGF_beta_LEFTY1_2', NULL, 'TGF_beta_LEFTY1_2', NULL, NULL, NULL, 2),
(7971, NULL, 'cd12771', NULL, NULL, 'RRM1_HuB', NULL, 'RRM1_HuB', NULL, NULL, NULL, 2),
(7972, NULL, 'cd04401', NULL, NULL, 'RhoGAP_fMSB1', NULL, 'RhoGAP_fMSB1', NULL, NULL, NULL, 2),
(7973, NULL, 'cd06600', NULL, NULL, 'GH31_MGAM-like', NULL, 'GH31_MGAM-like', NULL, NULL, NULL, 2);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(7974, NULL, 'cd00010', NULL, NULL, 'AAI_LTSS', NULL, 'AAI_LTSS', NULL, NULL, NULL, 2),
(7975, NULL, 'cd16158', NULL, NULL, 'ARSA', NULL, 'ARSA', NULL, NULL, NULL, 2),
(7976, NULL, 'cd11513', NULL, NULL, 'SLC6sbd_SERT', NULL, 'SLC6sbd_SERT', NULL, NULL, NULL, 2),
(7977, NULL, 'cd14053', NULL, NULL, 'STKc_ACVR2', NULL, 'STKc_ACVR2', NULL, NULL, NULL, 2),
(7978, NULL, 'cd01763', NULL, NULL, 'Ubl_SUMO_like', NULL, 'Ubl_SUMO_like', NULL, NULL, NULL, 2),
(7979, NULL, 'cd16017', NULL, NULL, 'LptA', NULL, 'LptA', NULL, NULL, NULL, 2),
(7980, NULL, 'cd15398', NULL, NULL, '7tmA_NPY5R', NULL, '7tmA_NPY5R', NULL, NULL, 6722, 2),
(7981, NULL, 'cd10477', NULL, NULL, 'EphR_LBD_B2', NULL, 'EphR_LBD_B2', NULL, NULL, 27134, 2),
(7982, NULL, 'cd00669', NULL, NULL, 'Asp_Lys_Asn_RS_core', NULL, 'Asp_Lys_Asn_RS_core', NULL, NULL, NULL, 2),
(7983, NULL, 'cd04932', NULL, NULL, 'ACT_AKiii-LysC-EC_1', NULL, 'ACT_AKiii-LysC-EC_1', NULL, NULL, NULL, 2),
(7984, NULL, 'cd14428', NULL, NULL, 'UBA2_HR23B', NULL, 'UBA2_HR23B', NULL, NULL, NULL, 2),
(7985, NULL, 'cd00563', NULL, NULL, 'Dtyr_deacylase', NULL, 'Dtyr_deacylase', NULL, NULL, 2046, 2),
(7986, NULL, 'cd13945', NULL, NULL, 'Chs5_N', NULL, 'Chs5_N', NULL, NULL, 22699, 2),
(7987, NULL, 'cd15911', NULL, NULL, '7tmA_OR11A-like', NULL, '7tmA_OR11A-like', NULL, NULL, NULL, 2),
(7988, NULL, 'cd11952', NULL, NULL, 'SH3_iASPP', NULL, 'SH3_iASPP', NULL, NULL, 36458, 2),
(7989, NULL, 'cd02034', NULL, NULL, 'CooC1', NULL, 'CooC1', NULL, NULL, NULL, 2),
(7990, NULL, 'cd17196', NULL, NULL, 'FERM_F1_FRMPD2', NULL, 'FERM_F1_FRMPD2', NULL, NULL, NULL, 2),
(7991, NULL, 'cd09514', NULL, NULL, 'SAM_SGMS1', NULL, 'SAM_SGMS1', NULL, NULL, NULL, 2),
(7992, NULL, 'cd18199', NULL, NULL, 'BTB_POZ_ZBTB8', NULL, 'BTB_POZ_ZBTB8', NULL, NULL, NULL, 2),
(7993, NULL, 'cd17201', NULL, NULL, 'FERM_F1_EPB41L1', NULL, 'FERM_F1_EPB41L1', NULL, NULL, NULL, 2),
(7994, NULL, 'cd00786', NULL, NULL, 'cytidine_deaminase-like', NULL, 'cytidine_deaminase-like', NULL, NULL, NULL, 2),
(7995, NULL, 'cd21480', NULL, NULL, 'SARS-CoV-2_Spike_S1_RBD', NULL, 'SARS-CoV-2_Spike_S1_RBD', NULL, NULL, 36065, 2),
(7996, NULL, 'cd04726', NULL, NULL, 'KGPDC_HPS', NULL, 'KGPDC_HPS', NULL, NULL, 30512, 2),
(7997, NULL, 'cd10018', NULL, NULL, 'BfiI_C', NULL, 'BfiI_C', NULL, NULL, 31859, 2),
(7998, NULL, 'cd12632', NULL, NULL, 'RRM1_CELF3_4_5_6', NULL, 'RRM1_CELF3_4_5_6', NULL, NULL, 7185, 2),
(7999, NULL, 'cd18521', NULL, NULL, 'BACK_Tdpoz', NULL, 'BACK_Tdpoz', NULL, NULL, NULL, 2),
(8000, NULL, 'cd19368', NULL, NULL, 'TenA_C_AtTH2-like', NULL, 'TenA_C_AtTH2-like', NULL, NULL, NULL, 2),
(8001, NULL, 'cd11501', NULL, NULL, 'SLC6sbd_ATB0', NULL, 'SLC6sbd_ATB0', NULL, NULL, NULL, 2),
(8002, NULL, 'cd11602', NULL, NULL, 'Ndc10', NULL, 'Ndc10', NULL, NULL, NULL, 2),
(8003, NULL, 'cd17399', NULL, NULL, 'MFS_MFSD7', NULL, 'MFS_MFSD7', NULL, NULL, NULL, 2),
(8004, NULL, 'cd00404', NULL, NULL, 'Aconitase_swivel', NULL, 'Aconitase_swivel', NULL, NULL, NULL, 2),
(8005, NULL, 'cd08234', NULL, NULL, 'threonine_DH_like', NULL, 'threonine_DH_like', NULL, NULL, NULL, 2),
(8006, NULL, 'cd16756', NULL, NULL, 'RING-HC_TRIM36', NULL, 'RING-HC_TRIM36', NULL, NULL, NULL, 2),
(8007, NULL, 'cd00953', NULL, NULL, 'KDG_aldolase', NULL, 'KDG_aldolase', NULL, NULL, NULL, 2),
(8008, NULL, 'cd05382', NULL, NULL, 'CAP_GAPR1-like', NULL, 'CAP_GAPR1-like', NULL, NULL, 4657, 2),
(8009, NULL, 'cd17346', NULL, NULL, 'MFS_DtpA_like', NULL, 'MFS_DtpA_like', NULL, NULL, 4327, 2),
(8010, NULL, 'cd12761', NULL, NULL, 'RRM1_hnRNPA1', NULL, 'RRM1_hnRNPA1', NULL, NULL, 33681, 2),
(8011, NULL, 'cd10527', NULL, NULL, 'SET_LSMT', NULL, 'SET_LSMT', NULL, NULL, NULL, 2),
(8012, NULL, 'cd12561', NULL, NULL, 'RRM1_RBM5_like', NULL, 'RRM1_RBM5_like', NULL, NULL, NULL, 2),
(8013, NULL, 'cd10439', NULL, NULL, 'GIY-YIG_COG3410', NULL, 'GIY-YIG_COG3410', NULL, NULL, NULL, 2),
(8014, NULL, 'cd06295', NULL, NULL, 'PBP1_CelR', NULL, 'PBP1_CelR', NULL, NULL, NULL, 2),
(8015, NULL, 'cd11941', NULL, NULL, 'SH3_ARHGEF37_C2', NULL, 'SH3_ARHGEF37_C2', NULL, NULL, 28415, 2),
(8016, NULL, 'cd17250', NULL, NULL, 'RMtype1_S_Eco4255II_TRD2-CR2_like', NULL, 'RMtype1_S_Eco4255II_TRD2-CR2_like', NULL, NULL, NULL, 2);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(8017, NULL, 'cd12769', NULL, NULL, 'RRM1_HuR', NULL, 'RRM1_HuR', NULL, NULL, NULL, 2),
(8018, NULL, 'cd05940', NULL, NULL, 'FATP_FACS', NULL, 'FATP_FACS', NULL, NULL, NULL, 2),
(8019, NULL, 'cd04775', NULL, NULL, 'HTH_Cfa-like', NULL, 'HTH_Cfa-like', NULL, NULL, NULL, 2),
(8020, NULL, 'cd09272', NULL, NULL, 'RNase_HI_RT_Ty1', NULL, 'RNase_HI_RT_Ty1', NULL, NULL, NULL, 2),
(8021, NULL, 'cd15211', NULL, NULL, '7tmA_GPR88-like', NULL, '7tmA_GPR88-like', NULL, NULL, NULL, 2),
(8022, NULL, 'cd16701', NULL, NULL, 'RING_CH-C4HC3_MARCH5', NULL, 'RING_CH-C4HC3_MARCH5', NULL, NULL, NULL, 2),
(8023, NULL, 'cd09969', NULL, NULL, 'UP_IIIb', NULL, 'UP_IIIb', NULL, NULL, NULL, 2),
(8024, NULL, 'cd14640', NULL, NULL, 'DSP_DUSP4', NULL, 'DSP_DUSP4', NULL, NULL, NULL, 2),
(8025, NULL, 'cd03188', NULL, NULL, 'GST_C_Beta', NULL, 'GST_C_Beta', NULL, NULL, NULL, 2),
(8026, NULL, 'cd17519', NULL, NULL, 'RMtype1_S_HpyCR35ORFAP-TRD1-CR1_like', NULL, 'RMtype1_S_HpyCR35ORFAP-TRD1-CR1_like', NULL, NULL, NULL, 2),
(8027, NULL, 'cd20303', NULL, NULL, 'cupin_ChrR_1', NULL, 'cupin_ChrR_1', NULL, NULL, NULL, 2),
(8028, NULL, 'cd07071', NULL, NULL, 'NR_LBD_Nurr1', NULL, 'NR_LBD_Nurr1', NULL, NULL, NULL, 2),
(8029, NULL, 'cd05380', NULL, NULL, 'CAP_euk', NULL, 'CAP_euk', NULL, NULL, NULL, 2),
(8030, NULL, 'cd01145', NULL, NULL, 'TroA_c', NULL, 'TroA_c', NULL, NULL, NULL, 2),
(8031, NULL, 'cd14741', NULL, NULL, 'PAAR_5', NULL, 'PAAR_5', NULL, NULL, NULL, 2),
(8032, NULL, 'cd07437', NULL, NULL, 'PHP_HisPPase_Ycdx_like', NULL, 'PHP_HisPPase_Ycdx_like', NULL, NULL, NULL, 2),
(8033, NULL, 'cd01075', NULL, NULL, 'NAD_bind_Leu_Phe_Val_DH', NULL, 'NAD_bind_Leu_Phe_Val_DH', NULL, NULL, NULL, 2),
(8034, NULL, 'cd02136', NULL, NULL, 'PnbA_NfnB-like', NULL, 'PnbA_NfnB-like', NULL, NULL, NULL, 2),
(8035, NULL, 'cd18275', NULL, NULL, 'BTB_POZ_KBTBD11', NULL, 'BTB_POZ_KBTBD11', NULL, NULL, NULL, 2),
(8036, NULL, 'cd07058', NULL, NULL, 'BMC_CsoS1', NULL, 'BMC_CsoS1', NULL, NULL, NULL, 2),
(8037, NULL, 'cd02904', NULL, NULL, 'Macro_H2A-like', NULL, 'Macro_H2A-like', NULL, NULL, 29367, 2),
(8038, NULL, 'cd07262', NULL, NULL, 'VOC_like', NULL, 'VOC_like', NULL, NULL, NULL, 2),
(8039, NULL, 'cd18214', NULL, NULL, 'BTB_POZ_ZBTB26_Bioref', NULL, 'BTB_POZ_ZBTB26_Bioref', NULL, NULL, NULL, 2),
(8040, NULL, 'cd08698', NULL, NULL, 'TGF_beta_SF', NULL, 'TGF_beta_SF', NULL, NULL, NULL, 2),
(8041, NULL, 'cd09987', NULL, NULL, 'Arginase_HDAC', NULL, 'Arginase_HDAC', NULL, NULL, NULL, 2),
(8042, NULL, 'cd04592', NULL, NULL, 'CBS_pair_voltage-gated_CLC_euk_bac', NULL, 'CBS_pair_voltage-gated_CLC_euk_bac', NULL, NULL, NULL, 2),
(8043, NULL, 'cd12644', NULL, NULL, 'RRM_CFIm59', NULL, 'RRM_CFIm59', NULL, NULL, 30805, 2),
(8044, NULL, 'cd09761', NULL, NULL, 'A3DFK9-like_SDR_c', NULL, 'A3DFK9-like_SDR_c', NULL, NULL, NULL, 2),
(8045, NULL, 'cd14742', NULL, NULL, 'PAAR_RHS', NULL, 'PAAR_RHS', NULL, NULL, NULL, 2),
(8046, NULL, 'cd08941', NULL, NULL, '3KS_SDR_c', NULL, '3KS_SDR_c', NULL, NULL, 35387, 2),
(8047, NULL, 'cd08295', NULL, NULL, 'double_bond_reductase_like', NULL, 'double_bond_reductase_like', NULL, NULL, NULL, 2),
(8048, NULL, 'cd16433', NULL, NULL, 'CheB', NULL, 'CheB', NULL, NULL, NULL, 2),
(8049, NULL, 'cd15116', NULL, NULL, '7tmA_CMKLR1', NULL, '7tmA_CMKLR1', NULL, NULL, NULL, 2),
(8050, NULL, 'cd13229', NULL, NULL, 'PH_TFIIH', NULL, 'PH_TFIIH', NULL, NULL, NULL, 2),
(8051, NULL, 'cd14001', NULL, NULL, 'PKc_TOPK', NULL, 'PKc_TOPK', NULL, NULL, 30453, 2),
(8052, NULL, 'cd09452', NULL, NULL, 'LIM1_Enigma', NULL, 'LIM1_Enigma', NULL, NULL, NULL, 2),
(8053, NULL, 'cd15130', NULL, NULL, '7tmA_NTSR', NULL, '7tmA_NTSR', NULL, NULL, NULL, 2),
(8054, NULL, 'cd15118', NULL, NULL, '7tmA_PD2R2_CRTH2', NULL, '7tmA_PD2R2_CRTH2', NULL, NULL, NULL, 2),
(8055, NULL, 'cd11730', NULL, NULL, 'Tthb094_like_SDR_c', NULL, 'Tthb094_like_SDR_c', NULL, NULL, NULL, 2),
(8056, NULL, 'cd15218', NULL, NULL, '7tmA_SREB2_GPR85', NULL, '7tmA_SREB2_GPR85', NULL, NULL, NULL, 2),
(8057, NULL, 'cd16977', NULL, NULL, 'VHS_GGA', NULL, 'VHS_GGA', NULL, NULL, NULL, 2),
(8058, NULL, 'cd07635', NULL, NULL, 'BAR_GRAF2', NULL, 'BAR_GRAF2', NULL, NULL, NULL, 2);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(8059, NULL, 'cd12747', NULL, NULL, 'RRM2_RBM12', NULL, 'RRM2_RBM12', NULL, NULL, 27873, 2),
(8060, NULL, 'cd13734', NULL, NULL, 'SPRY_PRY_C-II', NULL, 'SPRY_PRY_C-II', NULL, NULL, NULL, 2),
(8061, NULL, 'cd13193', NULL, NULL, 'FERM_C_FARP1-like', NULL, 'FERM_C_FARP1-like', NULL, NULL, 30199, 2),
(8062, NULL, 'cd01971', NULL, NULL, 'Nitrogenase_VnfN_like', NULL, 'Nitrogenase_VnfN_like', NULL, NULL, NULL, 2),
(8063, NULL, 'cd09139', NULL, NULL, 'PLDc_pPLD_like_1', NULL, 'PLDc_pPLD_like_1', NULL, NULL, NULL, 2),
(8064, NULL, 'cd11425', NULL, NULL, 'bHLH_TS_Mesp_like', NULL, 'bHLH_TS_Mesp_like', NULL, NULL, NULL, 2),
(8065, NULL, 'cd18546', NULL, NULL, 'ABC_6TM_Rv0194_D2_like', NULL, 'ABC_6TM_Rv0194_D2_like', NULL, NULL, NULL, 2),
(8066, NULL, 'cd05126', NULL, NULL, 'Mth938', NULL, 'Mth938', NULL, NULL, 11480, 2),
(8067, NULL, 'cd06612', NULL, NULL, 'STKc_MST1_2', NULL, 'STKc_MST1_2', NULL, NULL, NULL, 2),
(8068, NULL, 'cd17956', NULL, NULL, 'DEADc_DDX51', NULL, 'DEADc_DDX51', NULL, NULL, NULL, 2),
(8069, NULL, 'cd01754', NULL, NULL, 'PLAT_plant_stress', NULL, 'PLAT_plant_stress', NULL, NULL, NULL, 2),
(8070, NULL, 'cd12352', NULL, NULL, 'RRM1_TIA1_like', NULL, 'RRM1_TIA1_like', NULL, NULL, NULL, 2),
(8071, NULL, 'cd07163', NULL, NULL, 'NR_DBD_TLX', NULL, 'NR_DBD_TLX', NULL, NULL, NULL, 2),
(8072, NULL, 'cd20754', NULL, NULL, 'capping_2-OMTase_viral', NULL, 'capping_2-OMTase_viral', NULL, NULL, NULL, 2),
(8073, NULL, 'cd15075', NULL, NULL, '7tmA_Parapinopsin', NULL, '7tmA_Parapinopsin', NULL, NULL, NULL, 2),
(8074, NULL, 'cd09367', NULL, NULL, 'LIM1_Lhx1_Lhx5', NULL, 'LIM1_Lhx1_Lhx5', NULL, NULL, NULL, 2),
(8075, NULL, 'cd08346', NULL, NULL, 'PcpA_N_like', NULL, 'PcpA_N_like', NULL, NULL, NULL, 2),
(8076, NULL, 'cd15297', NULL, NULL, '7tmA_mAChR_M2', NULL, '7tmA_mAChR_M2', NULL, NULL, NULL, 2),
(8077, NULL, 'cd16711', NULL, NULL, 'RING-HC_DTX3', NULL, 'RING-HC_DTX3', NULL, NULL, NULL, 2),
(8078, NULL, 'cd03046', NULL, NULL, 'GST_N_GTT1_like', NULL, 'GST_N_GTT1_like', NULL, NULL, NULL, 2),
(8079, NULL, 'cd05572', NULL, NULL, 'STKc_cGK', NULL, 'STKc_cGK', NULL, NULL, 12988, 2),
(8080, NULL, 'cd09111', NULL, NULL, 'PLDc_ymdC_like_1', NULL, 'PLDc_ymdC_like_1', NULL, NULL, NULL, 2),
(8081, NULL, 'cd06543', NULL, NULL, 'GH18_PF-ChiA-like', NULL, 'GH18_PF-ChiA-like', NULL, NULL, NULL, 2),
(8082, NULL, 'cd04204', NULL, NULL, 'Pseudoazurin_like', NULL, 'Pseudoazurin_like', NULL, NULL, NULL, 2),
(8083, NULL, 'cd02106', NULL, NULL, 'SPFH_like', NULL, 'SPFH_like', NULL, NULL, NULL, 2),
(8084, NULL, 'cd07783', NULL, NULL, 'FGGY_CarbK-RPE_like', NULL, 'FGGY_CarbK-RPE_like', NULL, NULL, NULL, 2),
(8085, NULL, 'cd18511', NULL, NULL, 'BACK_KLHL5', NULL, 'BACK_KLHL5', NULL, NULL, NULL, 2),
(8086, NULL, 'cd00190', NULL, NULL, 'Tryp_SPc', NULL, 'Tryp_SPc', NULL, NULL, 2102, 2),
(8087, NULL, 'cd14630', NULL, NULL, 'R-PTPc-T-1', NULL, 'R-PTPc-T-1', NULL, NULL, NULL, 2),
(8088, NULL, 'cd04491', NULL, NULL, 'SoSSB_OBF', NULL, 'SoSSB_OBF', NULL, NULL, NULL, 2),
(8089, NULL, 'cd00655', NULL, NULL, 'RNAP_Rpb7_N_like', NULL, 'RNAP_Rpb7_N_like', NULL, NULL, NULL, 2),
(8090, NULL, 'cd13313', NULL, NULL, 'PH_NF1', NULL, 'PH_NF1', NULL, NULL, NULL, 2),
(8091, NULL, 'cd18574', NULL, NULL, 'ABC_6TM_ABCB8_like', NULL, 'ABC_6TM_ABCB8_like', NULL, NULL, NULL, 2),
(8092, NULL, 'cd17781', NULL, NULL, 'CBS_pair_MUG70_1', NULL, 'CBS_pair_MUG70_1', NULL, NULL, NULL, 2),
(8093, NULL, 'cd20478', NULL, NULL, 'Cas13b_Bz-like', NULL, 'Cas13b_Bz-like', NULL, NULL, NULL, 2),
(8094, NULL, 'cd05689', NULL, NULL, 'S1_RPS1_repeat_ec4', NULL, 'S1_RPS1_repeat_ec4', NULL, NULL, NULL, 2),
(8095, NULL, 'cd03545', NULL, NULL, 'Rieske_RO_Alpha_OHBDO_like', NULL, 'Rieske_RO_Alpha_OHBDO_like', NULL, NULL, NULL, 2),
(8096, NULL, 'cd19420', NULL, NULL, 'lipocalin_VDE', NULL, 'lipocalin_VDE', NULL, NULL, NULL, 2),
(8097, NULL, 'cd10916', NULL, NULL, 'CE4_PuuE_HpPgdA_like', NULL, 'CE4_PuuE_HpPgdA_like', NULL, NULL, NULL, 2),
(8098, NULL, 'cd09129', NULL, NULL, 'PLDc_unchar2_1', NULL, 'PLDc_unchar2_1', NULL, NULL, NULL, 2),
(8099, NULL, 'cd10038', NULL, NULL, 'Reelin_repeat_2_subrepeat_1', NULL, 'Reelin_repeat_2_subrepeat_1', NULL, NULL, NULL, 2);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(8100, NULL, 'cd01478', NULL, NULL, 'Sec23-like', NULL, 'Sec23-like', NULL, NULL, NULL, 2),
(8101, NULL, 'cd08017', NULL, NULL, 'M20_IAA_Hyd', NULL, 'M20_IAA_Hyd', NULL, NULL, 34370, 2),
(8102, NULL, 'cd06826', NULL, NULL, 'PLPDE_III_AR2', NULL, 'PLPDE_III_AR2', NULL, NULL, 35018, 2),
(8103, NULL, 'cd00845', NULL, NULL, 'MPP_UshA_N_like', NULL, 'MPP_UshA_N_like', NULL, NULL, NULL, 2),
(8104, NULL, 'cd05526', NULL, NULL, 'Bromo_polybromo_VI', NULL, 'Bromo_polybromo_VI', NULL, NULL, NULL, 2),
(8105, NULL, 'cd10980', NULL, NULL, 'CE4_SpCDA1', NULL, 'CE4_SpCDA1', NULL, NULL, NULL, 2),
(8106, NULL, 'cd02325', NULL, NULL, 'R3H', NULL, 'R3H', NULL, NULL, NULL, 2),
(8107, NULL, 'cd15698', NULL, NULL, 'ePHD2_KMT2D', NULL, 'ePHD2_KMT2D', NULL, NULL, 30165, 2),
(8108, NULL, 'cd15588', NULL, NULL, 'PHD1_KMT2A', NULL, 'PHD1_KMT2A', NULL, NULL, 30502, 2),
(8109, NULL, 'cd00801', NULL, NULL, 'INT_P4_C', NULL, 'INT_P4_C', NULL, NULL, NULL, 2),
(8110, NULL, 'cd00399', NULL, NULL, 'RNAP_largest_subunit_N', NULL, 'RNAP_largest_subunit_N', NULL, NULL, NULL, 2),
(8111, NULL, 'cd08871', NULL, NULL, 'START_STARD10-like', NULL, 'START_STARD10-like', NULL, NULL, 30528, 2),
(8112, NULL, 'cd04330', NULL, NULL, 'RNAP_III_Rpc25_N', NULL, 'RNAP_III_Rpc25_N', NULL, NULL, NULL, 2),
(8113, NULL, 'cd16741', NULL, NULL, 'RING-HC_RNFT1', NULL, 'RING-HC_RNFT1', NULL, NULL, NULL, 2),
(8114, NULL, 'cd03309', NULL, NULL, 'CmuC_like', NULL, 'CmuC_like', NULL, NULL, NULL, 2),
(8115, NULL, 'cd16459', NULL, NULL, 'RING-H2_DTX1_like', NULL, 'RING-H2_DTX1_like', NULL, NULL, NULL, 2),
(8116, NULL, 'cd17565', NULL, NULL, 'REC_GlnL-like', NULL, 'REC_GlnL-like', NULL, NULL, NULL, 2),
(8117, NULL, 'cd00053', NULL, NULL, 'EGF', NULL, 'EGF', NULL, NULL, NULL, 2),
(8118, NULL, 'cd05473', NULL, NULL, 'beta_secretase_like', NULL, 'beta_secretase_like', NULL, NULL, 27284, 2),
(8119, NULL, 'cd16275', NULL, NULL, 'BaeB-like_MBL-fold', NULL, 'BaeB-like_MBL-fold', NULL, NULL, NULL, 2),
(8120, NULL, 'cd00854', NULL, NULL, 'NagA', NULL, 'NagA', NULL, NULL, 2360, 2),
(8121, NULL, 'cd15188', NULL, NULL, '7tmA_ACKR2_D6', NULL, '7tmA_ACKR2_D6', NULL, NULL, NULL, 2),
(8122, NULL, 'cd06635', NULL, NULL, 'STKc_TAO1', NULL, 'STKc_TAO1', NULL, NULL, NULL, 2),
(8123, NULL, 'cd15190', NULL, NULL, '7tmA_Apelin_R', NULL, '7tmA_Apelin_R', NULL, NULL, NULL, 2),
(8124, NULL, 'cd01767', NULL, NULL, 'UBX', NULL, 'UBX', NULL, NULL, NULL, 2),
(8125, NULL, 'cd18937', NULL, NULL, 'bHLH_TS_Myf5', NULL, 'bHLH_TS_Myf5', NULL, NULL, NULL, 2),
(8126, NULL, 'cd19098', NULL, NULL, 'AKR_unchar', NULL, 'AKR_unchar', NULL, NULL, NULL, 2),
(8127, NULL, 'cd04697', NULL, NULL, 'Nudix_Hydrolase_38', NULL, 'Nudix_Hydrolase_38', NULL, NULL, NULL, 2),
(8128, NULL, 'cd13442', NULL, NULL, 'CDI_toxin_Bp1026b_like', NULL, 'CDI_toxin_Bp1026b_like', NULL, NULL, 29153, 2),
(8129, NULL, 'cd12823', NULL, NULL, 'Mrs2_Mfm1p-like', NULL, 'Mrs2_Mfm1p-like', NULL, NULL, 32588, 2),
(8130, NULL, 'cd05712', NULL, NULL, 'Ig_Siglec_N', NULL, 'Ig_Siglec_N', NULL, NULL, NULL, 2),
(8131, NULL, 'cd08760', NULL, NULL, 'Cyt_b561_FRRS1_like', NULL, 'Cyt_b561_FRRS1_like', NULL, NULL, NULL, 2),
(8132, NULL, 'cd11881', NULL, NULL, 'SH3_MYO7A', NULL, 'SH3_MYO7A', NULL, NULL, NULL, 2),
(8133, NULL, 'cd17044', NULL, NULL, 'Ubl_TBCE', NULL, 'Ubl_TBCE', NULL, NULL, 35043, 2),
(8134, NULL, 'cd03010', NULL, NULL, 'TlpA_like_DsbE', NULL, 'TlpA_like_DsbE', NULL, NULL, 5600, 2),
(8135, NULL, 'cd05848', NULL, NULL, 'Ig1_Contactin-5', NULL, 'Ig1_Contactin-5', NULL, NULL, NULL, 2),
(8136, NULL, 'cd10362', NULL, NULL, 'SH2_Src_Lck', NULL, 'SH2_Src_Lck', NULL, NULL, 32087, 2),
(8137, NULL, 'cd01094', NULL, NULL, 'Alkanesulfonate_monoxygenase', NULL, 'Alkanesulfonate_monoxygenase', NULL, NULL, NULL, 2),
(8138, NULL, 'cd06122', NULL, NULL, 'cupin_TTHA0104', NULL, 'cupin_TTHA0104', NULL, NULL, NULL, 2),
(8139, NULL, 'cd14407', NULL, NULL, 'UBA_MARK3_4', NULL, 'UBA_MARK3_4', NULL, NULL, NULL, 2),
(8140, NULL, 'cd17264', NULL, NULL, 'RMtype1_S_Eco3763I-TRD2-CR2_like', NULL, 'RMtype1_S_Eco3763I-TRD2-CR2_like', NULL, NULL, NULL, 2),
(8141, NULL, 'cd16380', NULL, NULL, 'YitT_C', NULL, 'YitT_C', NULL, NULL, NULL, 2);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(8142, NULL, 'cd11803', NULL, NULL, 'SH3_Endophilin_A', NULL, 'SH3_Endophilin_A', NULL, NULL, 32313, 2),
(8143, NULL, 'cd13957', NULL, NULL, 'PT_UbiA_Cox10', NULL, 'PT_UbiA_Cox10', NULL, NULL, 5512, 2),
(8144, NULL, 'cd09620', NULL, NULL, 'CBM9_like_3', NULL, 'CBM9_like_3', NULL, NULL, NULL, 2),
(8145, NULL, 'cd11880', NULL, NULL, 'SH3_Caskin', NULL, 'SH3_Caskin', NULL, NULL, NULL, 2),
(8146, NULL, 'cd16196', NULL, NULL, 'EFh_PEF_CalpA_B', NULL, 'EFh_PEF_CalpA_B', NULL, NULL, NULL, 2),
(8147, NULL, 'cd18054', NULL, NULL, 'DEXHc_CHD2', NULL, 'DEXHc_CHD2', NULL, NULL, NULL, 2),
(8148, NULL, 'cd02212', NULL, NULL, 'cupin_UGlyAH_C', NULL, 'cupin_UGlyAH_C', NULL, NULL, 34757, 2),
(8149, NULL, 'cd00712', NULL, NULL, 'AsnB', NULL, 'AsnB', NULL, NULL, 29053, 2),
(8150, NULL, 'cd12910', NULL, NULL, 'SPRY_SSH4_like', NULL, 'SPRY_SSH4_like', NULL, NULL, 32150, 2),
(8151, NULL, 'cd03789', NULL, NULL, 'GT9_LPS_heptosyltransferase', NULL, 'GT9_LPS_heptosyltransferase', NULL, NULL, 336, 2),
(8152, NULL, 'cd04622', NULL, NULL, 'CBS_pair_HRP1_like', NULL, 'CBS_pair_HRP1_like', NULL, NULL, NULL, 2),
(8153, NULL, 'cd02742', NULL, NULL, 'GH20_hexosaminidase', NULL, 'GH20_hexosaminidase', NULL, NULL, NULL, 2),
(8154, NULL, 'cd05501', NULL, NULL, 'Bromo_SP100C_like', NULL, 'Bromo_SP100C_like', NULL, NULL, NULL, 2),
(8155, NULL, 'cd15953', NULL, NULL, '7tmA_OR52P-like', NULL, '7tmA_OR52P-like', NULL, NULL, NULL, 2),
(8156, NULL, 'cd14952', NULL, NULL, 'NHL_PKND_like', NULL, 'NHL_PKND_like', NULL, NULL, 19967, 2),
(8157, NULL, 'cd05383', NULL, NULL, 'CAP_CRISP', NULL, 'CAP_CRISP', NULL, NULL, 22561, 2),
(8158, NULL, 'cd14797', NULL, NULL, 'DUF302', NULL, 'DUF302', NULL, NULL, NULL, 2),
(8159, NULL, 'cd18231', NULL, NULL, 'BTB_POZ_ZBTB47_ZNF651', NULL, 'BTB_POZ_ZBTB47_ZNF651', NULL, NULL, NULL, 2),
(8160, NULL, 'cd18790', NULL, NULL, 'SF2_C_UvrB', NULL, 'SF2_C_UvrB', NULL, NULL, NULL, 2),
(8161, NULL, 'cd05370', NULL, NULL, 'SDR_c2', NULL, 'SDR_c2', NULL, NULL, NULL, 2),
(8162, NULL, 'cd14000', NULL, NULL, 'STKc_LRRK', NULL, 'STKc_LRRK', NULL, NULL, NULL, 2),
(8163, NULL, 'cd00714', NULL, NULL, 'GFAT', NULL, 'GFAT', NULL, NULL, NULL, 2),
(8164, NULL, 'cd13184', NULL, NULL, 'FERM_C_4_1_family', NULL, 'FERM_C_4_1_family', NULL, NULL, NULL, 2),
(8165, NULL, 'cd06365', NULL, NULL, 'PBP1_pheromone_receptor', NULL, 'PBP1_pheromone_receptor', NULL, NULL, NULL, 2),
(8166, NULL, 'cd07102', NULL, NULL, 'ALDH_EDX86601', NULL, 'ALDH_EDX86601', NULL, NULL, NULL, 2),
(8167, NULL, 'cd19355', NULL, NULL, 'Wnt_Wnt10a', NULL, 'Wnt_Wnt10a', NULL, NULL, NULL, 2),
(8168, NULL, 'cd18371', NULL, NULL, 'BTB_POZ_KCTD14', NULL, 'BTB_POZ_KCTD14', NULL, NULL, NULL, 2),
(8169, NULL, 'cd19846', NULL, NULL, 'Bbox1_TIF1b_C-VI', NULL, 'Bbox1_TIF1b_C-VI', NULL, NULL, NULL, 2),
(8170, NULL, 'cd16788', NULL, NULL, 'mRING-HC-C3HC5_RNF26', NULL, 'mRING-HC-C3HC5_RNF26', NULL, NULL, 31652, 2),
(8171, NULL, 'cd19581', NULL, NULL, 'serpinL_nematode', NULL, 'serpinL_nematode', NULL, NULL, NULL, 2),
(8172, NULL, 'cd01009', NULL, NULL, 'PBP2_YfhD_N', NULL, 'PBP2_YfhD_N', NULL, NULL, NULL, 2),
(8173, NULL, 'cd07979', NULL, NULL, 'TAF9', NULL, 'TAF9', NULL, NULL, 1930, 2),
(8174, NULL, 'cd18081', NULL, NULL, 'RlmH-like', NULL, 'RlmH-like', NULL, NULL, 4425, 2),
(8175, NULL, 'cd19576', NULL, NULL, 'serpinI2_pancpin', NULL, 'serpinI2_pancpin', NULL, NULL, NULL, 2),
(8176, NULL, 'cd15027', NULL, NULL, '7tm_TAS2R43-like', NULL, '7tm_TAS2R43-like', NULL, NULL, NULL, 2),
(8177, NULL, 'cd18509', NULL, NULL, 'BACK_KLHL1', NULL, 'BACK_KLHL1', NULL, NULL, NULL, 2),
(8178, NULL, 'cd17401', NULL, NULL, 'MFS_SLCO2_OATP2', NULL, 'MFS_SLCO2_OATP2', NULL, NULL, NULL, 2),
(8179, NULL, 'cd06574', NULL, NULL, 'TM_PBP1_branched-chain-AA_like', NULL, 'TM_PBP1_branched-chain-AA_like', NULL, NULL, NULL, 2),
(8180, NULL, 'cd06578', NULL, NULL, 'HemD', NULL, 'HemD', NULL, NULL, 2003, 2),
(8181, NULL, 'cd15635', NULL, NULL, 'PHD_PYGO1', NULL, 'PHD_PYGO1', NULL, NULL, NULL, 2),
(8182, NULL, 'cd02851', NULL, NULL, 'E_set_GO_C', NULL, 'E_set_GO_C', NULL, NULL, 10871, 2),
(8183, NULL, 'cd12229', NULL, NULL, 'RRM_G3BP', NULL, 'RRM_G3BP', NULL, NULL, NULL, 2); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(8184, NULL, 'cd15216', NULL, NULL, '7tmA_SREB1_GPR27', NULL, '7tmA_SREB1_GPR27', NULL, NULL, NULL, 2),
(8185, NULL, 'cd01372', NULL, NULL, 'KISc_KIF4', NULL, 'KISc_KIF4', NULL, NULL, NULL, 2),
(8186, NULL, 'cd15131', NULL, NULL, '7tmA_GHSR', NULL, '7tmA_GHSR', NULL, NULL, NULL, 2),
(8187, NULL, 'cd15309', NULL, NULL, '7tmA_D2_dopamine_R', NULL, '7tmA_D2_dopamine_R', NULL, NULL, NULL, 2),
(8188, NULL, 'cd15560', NULL, NULL, 'PHD2_3_BPTF', NULL, 'PHD2_3_BPTF', NULL, NULL, NULL, 2),
(8189, NULL, 'cd15166', NULL, NULL, '7tmA_NAGly_R_GPR18', NULL, '7tmA_NAGly_R_GPR18', NULL, NULL, NULL, 2),
(8190, NULL, 'cd06363', NULL, NULL, 'PBP1_taste_receptor', NULL, 'PBP1_taste_receptor', NULL, NULL, NULL, 2),
(8191, NULL, 'cd18754', NULL, NULL, 'PIN_VapC4-5_FitB-like', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, NULL, 2),
(8192, NULL, 'cd12759', NULL, NULL, 'RRM1_MSI1', NULL, 'RRM1_MSI1', NULL, NULL, NULL, 2),
(8193, NULL, 'cd16331', NULL, NULL, 'YjgA-like', NULL, 'YjgA-like', NULL, NULL, 3689, 2),
(8194, NULL, 'cd12180', NULL, NULL, '2-Hacid_dh_15', NULL, '2-Hacid_dh_15', NULL, NULL, NULL, 2),
(8195, NULL, 'cd13321', NULL, NULL, 'PH_PLEKHM1', NULL, 'PH_PLEKHM1', NULL, NULL, 35145, 2),
(8196, NULL, 'cd17936', NULL, NULL, 'EEXXEc_NFX1', NULL, 'EEXXEc_NFX1', NULL, NULL, NULL, 2),
(8197, NULL, 'cd01521', NULL, NULL, 'RHOD_PspE2', NULL, 'RHOD_PspE2', NULL, NULL, NULL, 2),
(8198, NULL, 'cd01533', NULL, NULL, '4RHOD_Repeat_2', NULL, '4RHOD_Repeat_2', NULL, NULL, NULL, 2),
(8199, NULL, 'cd10380', NULL, NULL, 'SH2_Jak3', NULL, 'SH2_Jak3', NULL, NULL, NULL, 2),
(8200, NULL, 'cd16512', NULL, NULL, 'RING-HC_LNX3_like', NULL, 'RING-HC_LNX3_like', NULL, NULL, NULL, 2),
(8201, NULL, 'cd03075', NULL, NULL, 'GST_N_Mu', NULL, 'GST_N_Mu', NULL, NULL, NULL, 2),
(8202, NULL, 'cd17316', NULL, NULL, 'MFS_SV2_like', NULL, 'MFS_SV2_like', NULL, NULL, NULL, 2),
(8203, NULL, 'cd16510', NULL, NULL, 'RING-HC_IAPs', NULL, 'RING-HC_IAPs', NULL, NULL, NULL, 2),
(8204, NULL, 'cd16627', NULL, NULL, 'RING-HC_RBR_parkin', NULL, 'RING-HC_RBR_parkin', NULL, NULL, NULL, 2),
(8205, NULL, 'cd07677', NULL, NULL, 'F-BAR_FCHSD2', NULL, 'F-BAR_FCHSD2', NULL, NULL, NULL, 2),
(8206, NULL, 'cd01543', NULL, NULL, 'PBP1_XylR', NULL, 'PBP1_XylR', NULL, NULL, NULL, 2),
(8207, NULL, 'cd11457', NULL, NULL, 'bHLHzip_L-Myc', NULL, 'bHLHzip_L-Myc', NULL, NULL, NULL, 2),
(8208, NULL, 'cd12891', NULL, NULL, 'SPRY_PRY_C-I_2', NULL, 'SPRY_PRY_C-I_2', NULL, NULL, NULL, 2),
(8209, NULL, 'cd04643', NULL, NULL, 'CBS_pair_bac', NULL, 'CBS_pair_bac', NULL, NULL, NULL, 2),
(8210, NULL, 'cd05879', NULL, NULL, 'Ig_P0', NULL, 'Ig_P0', NULL, NULL, NULL, 2),
(8211, NULL, 'cd17299', NULL, NULL, 'acetolactate_decarboxylase', NULL, 'acetolactate_decarboxylase', NULL, NULL, 7486, 2),
(8212, NULL, 'cd12527', NULL, NULL, 'RRM2_EAR1_like', NULL, 'RRM2_EAR1_like', NULL, NULL, NULL, 2),
(8213, NULL, 'cd14319', NULL, NULL, 'UBA_NBR1', NULL, 'UBA_NBR1', NULL, NULL, NULL, 2),
(8214, NULL, 'cd16148', NULL, NULL, 'sulfatase_like', NULL, 'sulfatase_like', NULL, NULL, NULL, 2),
(8215, NULL, 'cd04237', NULL, NULL, 'AAK_NAGS-ABP', NULL, 'AAK_NAGS-ABP', NULL, NULL, 31233, 2),
(8216, NULL, 'cd15811', NULL, NULL, 'SPRY_PRY_TRIM11', NULL, 'SPRY_PRY_TRIM11', NULL, NULL, NULL, 2),
(8217, NULL, 'cd18956', NULL, NULL, 'BTB_POZ_ZBTB42', NULL, 'BTB_POZ_ZBTB42', NULL, NULL, NULL, 2),
(8218, NULL, 'cd15439', NULL, NULL, '7tmB2_EMR', NULL, '7tmB2_EMR', NULL, NULL, NULL, 2),
(8219, NULL, 'cd11430', NULL, NULL, 'bHLH_TS_ATOH1_like', NULL, 'bHLH_TS_ATOH1_like', NULL, NULL, NULL, 2),
(8220, NULL, 'cd04455', NULL, NULL, 'S1_NusA', NULL, 'S1_NusA', NULL, NULL, NULL, 2),
(8221, NULL, 'cd13327', NULL, NULL, 'PH_PLEKHM3_2', NULL, 'PH_PLEKHM3_2', NULL, NULL, NULL, 2),
(8222, NULL, 'cd07833', NULL, NULL, 'STKc_CDKL', NULL, 'STKc_CDKL', NULL, NULL, NULL, 2),
(8223, NULL, 'cd18273', NULL, NULL, 'BTB_POZ_KBTBD6_7', NULL, 'BTB_POZ_KBTBD6_7', NULL, NULL, NULL, 2),
(8224, NULL, 'cd18259', NULL, NULL, 'BTB_POZ_KLHL30', NULL, 'BTB_POZ_KLHL30', NULL, NULL, NULL, 2),
(8225, NULL, 'cd05374', NULL, NULL, '17beta-HSD-like_SDR_c', NULL, '17beta-HSD-like_SDR_c', NULL, NULL, NULL, 2);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(8226, NULL, 'cd15028', NULL, NULL, '7tm_Opsin-1_euk', NULL, '7tm_Opsin-1_euk', NULL, NULL, NULL, 2),
(8227, NULL, 'cd02885', NULL, NULL, 'IPP_Isomerase', NULL, 'IPP_Isomerase', NULL, NULL, 14121, 2),
(8228, NULL, 'cd13401', NULL, NULL, 'Slt70-like', NULL, 'Slt70-like', NULL, NULL, NULL, 2),
(8229, NULL, 'cd11938', NULL, NULL, 'SH3_ARHGEF16_26', NULL, 'SH3_ARHGEF16_26', NULL, NULL, 32607, 2),
(8230, NULL, 'cd10359', NULL, NULL, 'SH2_SH3BP2', NULL, 'SH2_SH3BP2', NULL, NULL, 28597, 2),
(8231, NULL, 'cd13627', NULL, NULL, 'PBP2_AA_binding_like_2', NULL, 'PBP2_AA_binding_like_2', NULL, NULL, NULL, 2),
(8232, NULL, 'cd05155', NULL, NULL, 'APH_ChoK_like_1', NULL, 'APH_ChoK_like_1', NULL, NULL, NULL, 2),
(8233, NULL, 'cd07728', NULL, NULL, 'YtnP-like_MBL-fold', NULL, 'YtnP-like_MBL-fold', NULL, NULL, NULL, 2),
(8234, NULL, 'cd21531', NULL, NULL, 'CoV_E', NULL, 'CoV_E', NULL, NULL, NULL, 2),
(8235, NULL, 'cd06338', NULL, NULL, 'PBP1_ABC_ligand_binding-like', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, NULL, 2),
(8236, NULL, 'cd04919', NULL, NULL, 'ACT_AK-Hom3_2', NULL, 'ACT_AK-Hom3_2', NULL, NULL, NULL, 2),
(8237, NULL, 'cd05563', NULL, NULL, 'PTS_IIB_ascorbate', NULL, 'PTS_IIB_ascorbate', NULL, NULL, NULL, 2),
(8238, NULL, 'cd13548', NULL, NULL, 'PBP2_AEPn_like', NULL, 'PBP2_AEPn_like', NULL, NULL, NULL, 2),
(8239, NULL, 'cd05123', NULL, NULL, 'STKc_AGC', NULL, 'STKc_AGC', NULL, NULL, 37122, 2),
(8240, NULL, 'cd05565', NULL, NULL, 'PTS_IIB_lactose', NULL, 'PTS_IIB_lactose', NULL, NULL, 30482, 2),
(8241, NULL, 'cd18944', NULL, NULL, 'bHLH_E-protein_E2A_TCF3', NULL, 'bHLH_E-protein_E2A_TCF3', NULL, NULL, NULL, 2),
(8242, NULL, 'cd14901', NULL, NULL, 'MYSc_Myo40', NULL, 'MYSc_Myo40', NULL, NULL, NULL, 2),
(8243, NULL, 'cd18298', NULL, NULL, 'BTB_POZ_RCBTB1_2', NULL, 'BTB_POZ_RCBTB1_2', NULL, NULL, NULL, 2),
(8244, NULL, 'cd03442', NULL, NULL, 'BFIT_BACH', NULL, 'BFIT_BACH', NULL, NULL, NULL, 2),
(8245, NULL, 'cd13245', NULL, NULL, 'PH_PLEKHG7', NULL, 'PH_PLEKHG7', NULL, NULL, NULL, 2),
(8246, NULL, 'cd21658', NULL, NULL, 'gammaCoV_Nsp14', NULL, 'gammaCoV_Nsp14', NULL, NULL, 36262, 2),
(8247, NULL, 'cd12460', NULL, NULL, 'RRM2_CID8_like', NULL, 'RRM2_CID8_like', NULL, NULL, 33234, 2),
(8248, NULL, 'cd03775', NULL, NULL, 'MATH_Ubp21p', NULL, 'MATH_Ubp21p', NULL, NULL, NULL, 2),
(8249, NULL, 'cd02232', NULL, NULL, 'cupin_ARD', NULL, 'cupin_ARD', NULL, NULL, 4735, 2),
(8250, NULL, 'cd12143', NULL, NULL, 'SH3_ARHGAP9', NULL, 'SH3_ARHGAP9', NULL, NULL, 14638, 2),
(8251, NULL, 'cd18089', NULL, NULL, 'SPOUT_Trm10-like', NULL, 'SPOUT_Trm10-like', NULL, NULL, NULL, 2),
(8252, NULL, 'cd11988', NULL, NULL, 'SH3_Intersectin2_1', NULL, 'SH3_Intersectin2_1', NULL, NULL, 28170, 2),
(8253, NULL, 'cd17984', NULL, NULL, 'DEXHc_DHX40', NULL, 'DEXHc_DHX40', NULL, NULL, NULL, 2),
(8254, NULL, 'cd01824', NULL, NULL, 'Phospholipase_B_like', NULL, 'Phospholipase_B_like', NULL, NULL, 28121, 2),
(8255, NULL, 'cd09590', NULL, NULL, 'SAM_LBP9', NULL, 'SAM_LBP9', NULL, NULL, 33692, 2),
(8256, NULL, 'cd16718', NULL, NULL, 'RING-HC_LNX3', NULL, 'RING-HC_LNX3', NULL, NULL, NULL, 2),
(8257, NULL, 'cd15850', NULL, NULL, 'SNARE_syntaxin18', NULL, 'SNARE_syntaxin18', NULL, NULL, NULL, 2),
(8258, NULL, 'cd02996', NULL, NULL, 'PDI_a_ERp44', NULL, 'PDI_a_ERp44', NULL, NULL, NULL, 2),
(8259, NULL, 'cd12097', NULL, NULL, 'DD_RI_PKA', NULL, 'DD_RI_PKA', NULL, NULL, NULL, 2),
(8260, NULL, 'cd00239', NULL, NULL, 'PapG_CBD', NULL, 'PapG_CBD', NULL, NULL, 5309, 2),
(8261, NULL, 'cd16927', NULL, NULL, 'HATPase_Hsp90-like', NULL, 'HATPase_Hsp90-like', NULL, NULL, NULL, 2),
(8262, NULL, 'cd06846', NULL, NULL, 'Adenylation_DNA_ligase_like', NULL, 'Adenylation_DNA_ligase_like', NULL, NULL, NULL, 2),
(8263, NULL, 'cd17661', NULL, NULL, 'PFA-DSP_Oca2', NULL, 'PFA-DSP_Oca2', NULL, NULL, NULL, 2),
(8264, NULL, 'cd01958', NULL, NULL, 'HPS_like', NULL, 'HPS_like', NULL, NULL, 24147, 2),
(8265, NULL, 'cd09331', NULL, NULL, 'LIM1_PINCH', NULL, 'LIM1_PINCH', NULL, NULL, NULL, 2),
(8266, NULL, 'cd03807', NULL, NULL, 'GT4_WbnK-like', NULL, 'GT4_WbnK-like', NULL, NULL, NULL, 2);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(8267, NULL, 'cd17104', NULL, NULL, 'FERM_F1_MYLIP', NULL, 'FERM_F1_MYLIP', NULL, NULL, NULL, 2),
(8268, NULL, 'cd16873', NULL, NULL, 'ARID_KDM5A', NULL, 'ARID_KDM5A', NULL, NULL, NULL, 2),
(8269, NULL, 'cd04102', NULL, NULL, 'RabL3', NULL, 'RabL3', NULL, NULL, NULL, 2),
(8270, NULL, 'cd04818', NULL, NULL, 'PA_subtilisin_1', NULL, 'PA_subtilisin_1', NULL, NULL, NULL, 2),
(8271, NULL, 'cd04403', NULL, NULL, 'RhoGAP_ARHGAP27_15_12_9', NULL, 'RhoGAP_ARHGAP27_15_12_9', NULL, NULL, NULL, 2),
(8272, NULL, 'cd08509', NULL, NULL, 'PBP2_TmCBP_oligosaccharides_like', NULL, 'PBP2_TmCBP_oligosaccharides_like', NULL, NULL, NULL, 2),
(8273, NULL, 'cd14628', NULL, NULL, 'R-PTP-D-2', NULL, 'R-PTP-D-2', NULL, NULL, NULL, 2),
(8274, NULL, 'cd08313', NULL, NULL, 'Death_TNFR1', NULL, 'Death_TNFR1', NULL, NULL, 33226, 2),
(8275, NULL, 'cd13870', NULL, NULL, 'CuRO_2_CopA_like_1', NULL, 'CuRO_2_CopA_like_1', NULL, NULL, NULL, 2),
(8276, NULL, 'cd17236', NULL, NULL, 'Ubl_ATG8_MAP1LC3C', NULL, 'Ubl_ATG8_MAP1LC3C', NULL, NULL, NULL, 2),
(8277, NULL, 'cd09130', NULL, NULL, 'PLDc_unchar2_2', NULL, 'PLDc_unchar2_2', NULL, NULL, NULL, 2),
(8278, NULL, 'cd16481', NULL, NULL, 'RING-H2_TTC3', NULL, 'RING-H2_TTC3', NULL, NULL, NULL, 2),
(8279, NULL, 'cd12259', NULL, NULL, 'RRM_SRSF11_SREK1', NULL, 'RRM_SRSF11_SREK1', NULL, NULL, NULL, 2),
(8280, NULL, 'cd08962', NULL, NULL, 'GatD', NULL, 'GatD', NULL, NULL, 8511, 2),
(8281, NULL, 'cd06451', NULL, NULL, 'AGAT_like', NULL, 'AGAT_like', NULL, NULL, NULL, 2),
(8282, NULL, 'cd06606', NULL, NULL, 'STKc_MAPKKK', NULL, 'STKc_MAPKKK', NULL, NULL, NULL, 2),
(8283, NULL, 'cd08377', NULL, NULL, 'C2C_MCTP_PRT', NULL, 'C2C_MCTP_PRT', NULL, NULL, NULL, 2),
(8284, NULL, 'cd14016', NULL, NULL, 'STKc_CK1', NULL, 'STKc_CK1', NULL, NULL, NULL, 2),
(8285, NULL, 'cd11535', NULL, NULL, 'NTP-PPase_SsMazG', NULL, 'NTP-PPase_SsMazG', NULL, NULL, NULL, 2),
(8286, NULL, 'cd11903', NULL, NULL, 'SH3_Nck2_3', NULL, 'SH3_Nck2_3', NULL, NULL, 33424, 2),
(8287, NULL, 'cd13330', NULL, NULL, 'PH_CARM1', NULL, 'PH_CARM1', NULL, NULL, NULL, 2),
(8288, NULL, 'cd00195', NULL, NULL, 'UBCc', NULL, 'UBCc', NULL, NULL, 5931, 2),
(8289, NULL, 'cd03473', NULL, NULL, 'Rieske_CMP_Neu5Ac_hydrolase_N', NULL, 'Rieske_CMP_Neu5Ac_hydrolase_N', NULL, NULL, 31871, 2),
(8290, NULL, 'cd12185', NULL, NULL, 'HGDH_LDH_like', NULL, 'HGDH_LDH_like', NULL, NULL, NULL, 2),
(8291, NULL, 'cd17348', NULL, NULL, 'MFS_SLC15A3_4', NULL, 'MFS_SLC15A3_4', NULL, NULL, NULL, 2),
(8292, NULL, 'cd08608', NULL, NULL, 'GDPD_GDE2', NULL, 'GDPD_GDE2', NULL, NULL, NULL, 2),
(8293, NULL, 'cd09676', NULL, NULL, 'Csy2_I-F', NULL, 'Csy2_I-F', NULL, NULL, NULL, 2),
(8294, NULL, 'cd01206', NULL, NULL, 'EVH1_Homer_Vesl', NULL, 'EVH1_Homer_Vesl', NULL, NULL, 35380, 2),
(8295, NULL, 'cd12776', NULL, NULL, 'RRM2_HuC', NULL, 'RRM2_HuC', NULL, NULL, NULL, 2),
(8296, NULL, 'cd05535', NULL, NULL, 'POLBc_epsilon', NULL, 'POLBc_epsilon', NULL, NULL, NULL, 2),
(8297, NULL, 'cd00300', NULL, NULL, 'LDH_like', NULL, 'LDH_like', NULL, NULL, NULL, 2),
(8298, NULL, 'cd13555', NULL, NULL, 'PBP2_sulfate_ester_like', NULL, 'PBP2_sulfate_ester_like', NULL, NULL, NULL, 2),
(8299, NULL, 'cd13990', NULL, NULL, 'STKc_TLK', NULL, 'STKc_TLK', NULL, NULL, NULL, 2),
(8300, NULL, 'cd19095', NULL, NULL, 'AKR_PA4992-like', NULL, 'AKR_PA4992-like', NULL, NULL, NULL, 2),
(8301, NULL, 'cd19119', NULL, NULL, 'AKR_AKR3C1', NULL, 'AKR_AKR3C1', NULL, NULL, 34888, 2),
(8302, NULL, 'cd16521', NULL, NULL, 'RING-HC_MKRN', NULL, 'RING-HC_MKRN', NULL, NULL, NULL, 2),
(8303, NULL, 'cd07705', NULL, NULL, 'Ig2_Necl-1', NULL, 'Ig2_Necl-1', NULL, NULL, NULL, 2),
(8304, NULL, 'cd20610', NULL, NULL, 'Nitro_FMN_reductase_child_20', NULL, 'Nitro_FMN_reductase_child_20', NULL, NULL, NULL, 2),
(8305, NULL, 'cd08885', NULL, NULL, 'RHO_alpha_C_1', NULL, 'RHO_alpha_C_1', NULL, NULL, NULL, 2),
(8306, NULL, 'cd01553', NULL, NULL, 'EPT_RTPC-like', NULL, 'EPT_RTPC-like', NULL, NULL, NULL, 2),
(8307, NULL, 'cd14564', NULL, NULL, 'PTP_GAK', NULL, 'PTP_GAK', NULL, NULL, NULL, 2),
(8308, NULL, 'cd11666', NULL, NULL, 'GH38N_Man2A1', NULL, 'GH38N_Man2A1', NULL, NULL, NULL, 2);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(8309, NULL, 'cd16467', NULL, NULL, 'RING-H2_RNF6_like', NULL, 'RING-H2_RNF6_like', NULL, NULL, NULL, 2),
(8310, NULL, 'cd11574', NULL, NULL, 'GH99', NULL, 'GH99', NULL, NULL, 21625, 2),
(8311, NULL, 'cd16643', NULL, NULL, 'mRING-HC-C3HC3D_TRAF6', NULL, 'mRING-HC-C3HC3D_TRAF6', NULL, NULL, NULL, 2),
(8312, NULL, 'cd05791', NULL, NULL, 'S1_CSL4', NULL, 'S1_CSL4', NULL, NULL, NULL, 2),
(8313, NULL, 'cd15048', NULL, NULL, '7tmA_Histamine_H3R_H4R', NULL, '7tmA_Histamine_H3R_H4R', NULL, NULL, NULL, 2),
(8314, NULL, 'cd06228', NULL, NULL, 'M14-like', NULL, 'M14-like', NULL, NULL, NULL, 2),
(8315, NULL, 'cd07653', NULL, NULL, 'F-BAR_CIP4-like', NULL, 'F-BAR_CIP4-like', NULL, NULL, NULL, 2),
(8316, NULL, 'cd10392', NULL, NULL, 'SH2_SHF', NULL, 'SH2_SHF', NULL, NULL, 9495, 2),
(8317, NULL, 'cd02662', NULL, NULL, 'Peptidase_C19F', NULL, 'Peptidase_C19F', NULL, NULL, NULL, 2),
(8318, NULL, 'cd00109', NULL, NULL, 'KU', NULL, 'KU', NULL, NULL, 481, 2),
(8319, NULL, 'cd15783', NULL, NULL, 'SA1633_like', NULL, 'SA1633_like', NULL, NULL, 26017, 2),
(8320, NULL, 'cd09981', NULL, NULL, 'LOTUS_5_Limkain_b1', NULL, 'LOTUS_5_Limkain_b1', NULL, NULL, NULL, 2),
(8321, NULL, 'cd12832', NULL, NULL, 'TmCorA-like_u3', NULL, 'TmCorA-like_u3', NULL, NULL, NULL, 2),
(8322, NULL, 'cd08883', NULL, NULL, 'RHO_alpha_C_CMO-like', NULL, 'RHO_alpha_C_CMO-like', NULL, NULL, NULL, 2),
(8323, NULL, 'cd11578', NULL, NULL, 'GH99_GH71_like_1', NULL, 'GH99_GH71_like_1', NULL, NULL, NULL, 2),
(8324, NULL, 'cd00323', NULL, NULL, 'uS7', NULL, 'uS7', NULL, NULL, NULL, 2),
(8325, NULL, 'cd14542', NULL, NULL, 'PTPc-N22_18_12', NULL, 'PTPc-N22_18_12', NULL, NULL, NULL, 2),
(8326, NULL, 'cd07821', NULL, NULL, 'PYR_PYL_RCAR_like', NULL, 'PYR_PYL_RCAR_like', NULL, NULL, NULL, 2),
(8327, NULL, 'cd10310', NULL, NULL, 'GST_C_CysRS_N', NULL, 'GST_C_CysRS_N', NULL, NULL, NULL, 2),
(8328, NULL, 'cd01758', NULL, NULL, 'PLAT_LPL', NULL, 'PLAT_LPL', NULL, NULL, NULL, 2),
(8329, NULL, 'cd11949', NULL, NULL, 'SH3_GRB2_C', NULL, 'SH3_GRB2_C', NULL, NULL, 28464, 2),
(8330, NULL, 'cd08252', NULL, NULL, 'AL_MDR', NULL, 'AL_MDR', NULL, NULL, 8861, 2),
(8331, NULL, 'cd19396', NULL, NULL, 'TGF_beta_BMP6', NULL, 'TGF_beta_BMP6', NULL, NULL, NULL, 2),
(8332, NULL, 'cd06970', NULL, NULL, 'NR_DBD_PNR', NULL, 'NR_DBD_PNR', NULL, NULL, NULL, 2),
(8333, NULL, 'cd13640', NULL, NULL, 'PBP2_ChoX', NULL, 'PBP2_ChoX', NULL, NULL, 19243, 2),
(8334, NULL, 'cd19976', NULL, NULL, 'PBP1_DegA_Like', NULL, 'PBP1_DegA_Like', NULL, NULL, NULL, 2),
(8335, NULL, 'cd16378', NULL, NULL, 'CcmH_N', NULL, 'CcmH_N', NULL, NULL, NULL, 2),
(8336, NULL, 'cd18934', NULL, NULL, 'bHLH_TS_MRF4_Myf6', NULL, 'bHLH_TS_MRF4_Myf6', NULL, NULL, NULL, 2),
(8337, NULL, 'cd19800', NULL, NULL, 'Bbox2_xNF7-like', NULL, 'Bbox2_xNF7-like', NULL, NULL, NULL, 2),
(8338, NULL, 'cd08561', NULL, NULL, 'GDPD_cytoplasmic_ScUgpQ2_like', NULL, 'GDPD_cytoplasmic_ScUgpQ2_like', NULL, NULL, NULL, 2),
(8339, NULL, 'cd15983', NULL, NULL, '7tmB1_PTH3R', NULL, '7tmB1_PTH3R', NULL, NULL, NULL, 2),
(8340, NULL, 'cd18496', NULL, NULL, 'BACK_LGALS3BP', NULL, 'BACK_LGALS3BP', NULL, NULL, NULL, 2),
(8341, NULL, 'cd16889', NULL, NULL, 'chitinase-like', NULL, 'chitinase-like', NULL, NULL, NULL, 2),
(8342, NULL, 'cd04202', NULL, NULL, 'CuRO_D2_2dMcoN_like', NULL, 'CuRO_D2_2dMcoN_like', NULL, NULL, NULL, 2),
(8343, NULL, 'cd14788', NULL, NULL, 'GumN', NULL, 'GumN', NULL, NULL, NULL, 2),
(8344, NULL, 'cd12365', NULL, NULL, 'RRM_RNPS1', NULL, 'RRM_RNPS1', NULL, NULL, 18128, 2),
(8345, NULL, 'cd16145', NULL, NULL, 'ARS_like', NULL, 'ARS_like', NULL, NULL, NULL, 2),
(8346, NULL, 'cd19078', NULL, NULL, 'AKR_AKR13C1_2', NULL, 'AKR_AKR13C1_2', NULL, NULL, NULL, 2),
(8347, NULL, 'cd09459', NULL, NULL, 'LIM3_ENH', NULL, 'LIM3_ENH', NULL, NULL, NULL, 2),
(8348, NULL, 'cd00314', NULL, NULL, 'plant_peroxidase_like', NULL, 'plant_peroxidase_like', NULL, NULL, NULL, 2),
(8349, NULL, 'cd05515', NULL, NULL, 'Bromo_polybromo_V', NULL, 'Bromo_polybromo_V', NULL, NULL, 31322, 2),
(8350, NULL, 'cd11728', NULL, NULL, 'ADDz_Dnmt3b', NULL, 'ADDz_Dnmt3b', NULL, NULL, 26316, 2);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(8351, NULL, 'cd14765', NULL, NULL, 'Hb', NULL, 'Hb', NULL, NULL, NULL, 2),
(8352, NULL, 'cd15810', NULL, NULL, 'SPRY_PRY_TRIM5_6_22_34', NULL, 'SPRY_PRY_TRIM5_6_22_34', NULL, NULL, NULL, 2),
(8353, NULL, 'cd18609', NULL, NULL, 'GH32-like', NULL, 'GH32-like', NULL, NULL, NULL, 2),
(8354, NULL, 'cd10151', NULL, NULL, 'TthCsoR-like_DUF156', NULL, 'TthCsoR-like_DUF156', NULL, NULL, NULL, 2),
(8355, NULL, 'cd05811', NULL, NULL, 'CBM20_glucoamylase', NULL, 'CBM20_glucoamylase', NULL, NULL, 10398, 2),
(8356, NULL, 'cd11961', NULL, NULL, 'SH3_Abp1_fungi_C2', NULL, 'SH3_Abp1_fungi_C2', NULL, NULL, 31263, 2),
(8357, NULL, 'cd07650', NULL, NULL, 'F-BAR_Syp1p_like', NULL, 'F-BAR_Syp1p_like', NULL, NULL, NULL, 2),
(8358, NULL, 'cd06144', NULL, NULL, 'REX4_like', NULL, 'REX4_like', NULL, NULL, 30780, 2),
(8359, NULL, 'cd05007', NULL, NULL, 'SIS_Etherase', NULL, 'SIS_Etherase', NULL, NULL, 602, 2),
(8360, NULL, 'cd06283', NULL, NULL, 'PBP1_RegR_EndR_KdgR-like', NULL, 'PBP1_RegR_EndR_KdgR-like', NULL, NULL, NULL, 2),
(8361, NULL, 'cd19375', NULL, NULL, 'UDG-F3-like_SMUG2', NULL, 'UDG-F3-like_SMUG2', NULL, NULL, 21536, 2),
(8362, NULL, 'cd03513', NULL, NULL, 'CrtW_beta-carotene-ketolase', NULL, 'CrtW_beta-carotene-ketolase', NULL, NULL, NULL, 2),
(8363, NULL, 'cd11334', NULL, NULL, 'AmyAc_TreS', NULL, 'AmyAc_TreS', NULL, NULL, NULL, 2),
(8364, NULL, 'cd09136', NULL, NULL, 'PLDc_PSS_G_neg_2', NULL, 'PLDc_PSS_G_neg_2', NULL, NULL, NULL, 2),
(8365, NULL, 'cd14115', NULL, NULL, 'STKc_Kalirin_C', NULL, 'STKc_Kalirin_C', NULL, NULL, NULL, 2),
(8366, NULL, 'cd10228', NULL, NULL, 'HSPA4_like_NDB', NULL, 'HSPA4_like_NDB', NULL, NULL, NULL, 2),
(8367, NULL, 'cd20491', NULL, NULL, 'cupin_KduI_C', NULL, 'cupin_KduI_C', NULL, NULL, NULL, 2),
(8368, NULL, 'cd20274', NULL, NULL, 'Sarcolamban', NULL, 'Sarcolamban', NULL, NULL, NULL, 2),
(8369, NULL, 'cd08745', NULL, NULL, 'RGS_RGS19', NULL, 'RGS_RGS19', NULL, NULL, NULL, 2),
(8370, NULL, 'cd05013', NULL, NULL, 'SIS_RpiR', NULL, 'SIS_RpiR', NULL, NULL, 28883, 2),
(8371, NULL, 'cd02204', NULL, NULL, 'PurL_repeat2', NULL, 'PurL_repeat2', NULL, NULL, NULL, 2),
(8372, NULL, 'cd15719', NULL, NULL, 'FYVE_WDFY3', NULL, 'FYVE_WDFY3', NULL, NULL, NULL, 2),
(8373, NULL, 'cd03255', NULL, NULL, 'ABC_MJ0796_LolCDE_FtsE', NULL, 'ABC_MJ0796_LolCDE_FtsE', NULL, NULL, 12768, 2),
(8374, NULL, 'cd08248', NULL, NULL, 'RTN4I1', NULL, 'RTN4I1', NULL, NULL, 32099, 2),
(8375, NULL, 'cd05116', NULL, NULL, 'PTKc_Syk', NULL, 'PTKc_Syk', NULL, NULL, NULL, 2),
(8376, NULL, 'cd04741', NULL, NULL, 'DHOD_1A_like', NULL, 'DHOD_1A_like', NULL, NULL, 27897, 2),
(8377, NULL, 'cd18784', NULL, NULL, 'ABC_6TM_ABCB9_like', NULL, 'ABC_6TM_ABCB9_like', NULL, NULL, NULL, 2),
(8378, NULL, 'cd19347', NULL, NULL, 'Wnt_Wnt5a', NULL, 'Wnt_Wnt5a', NULL, NULL, NULL, 2),
(8379, NULL, 'cd06588', NULL, NULL, 'PhnB_like', NULL, 'PhnB_like', NULL, NULL, 26569, 2),
(8380, NULL, 'cd14715', NULL, NULL, 'bZIP_CEBPE', NULL, 'bZIP_CEBPE', NULL, NULL, NULL, 2),
(8381, NULL, 'cd12785', NULL, NULL, 'RRM2_hnRNPL', NULL, 'RRM2_hnRNPL', NULL, NULL, 19927, 2),
(8382, NULL, 'cd15906', NULL, NULL, '7tmA_GPR162', NULL, '7tmA_GPR162', NULL, NULL, NULL, 2),
(8383, NULL, 'cd01091', NULL, NULL, 'CDC68-like', NULL, 'CDC68-like', NULL, NULL, 30588, 2),
(8384, NULL, 'cd15387', NULL, NULL, '7tmA_OT_R', NULL, '7tmA_OT_R', NULL, NULL, NULL, 2),
(8385, NULL, 'cd14171', NULL, NULL, 'STKc_MAPKAPK5', NULL, 'STKc_MAPKAPK5', NULL, NULL, NULL, 2),
(8386, NULL, 'cd14687', NULL, NULL, 'bZIP_ATF2', NULL, 'bZIP_ATF2', NULL, NULL, NULL, 2),
(8387, NULL, 'cd03250', NULL, NULL, 'ABCC_MRP_domain1', NULL, 'ABCC_MRP_domain1', NULL, NULL, NULL, 2),
(8388, NULL, 'cd14672', NULL, NULL, 'UBA_ceTYDP2_like', NULL, 'UBA_ceTYDP2_like', NULL, NULL, NULL, 2),
(8389, NULL, 'cd09144', NULL, NULL, 'PLDc_vPLD3_1', NULL, 'PLDc_vPLD3_1', NULL, NULL, NULL, 2),
(8390, NULL, 'cd20230', NULL, NULL, 'PFM_EP37-like', NULL, 'PFM_EP37-like', NULL, NULL, NULL, 2),
(8391, NULL, 'cd03470', NULL, NULL, 'Rieske_cytochrome_bc1', NULL, 'Rieske_cytochrome_bc1', NULL, NULL, NULL, 2),
(8392, NULL, 'cd14290', NULL, NULL, 'UBA_PUB_plant', NULL, 'UBA_PUB_plant', NULL, NULL, NULL, 2);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(8393, NULL, 'cd03328', NULL, NULL, 'MR_like_3', NULL, 'MR_like_3', NULL, NULL, NULL, 2),
(8394, NULL, 'cd07496', NULL, NULL, 'Peptidases_S8_13', NULL, 'Peptidases_S8_13', NULL, NULL, 22778, 2),
(8395, NULL, 'cd07876', NULL, NULL, 'STKc_JNK2', NULL, 'STKc_JNK2', NULL, NULL, NULL, 2),
(8396, NULL, 'cd11412', NULL, NULL, 'bHLH_TS_TWIST1', NULL, 'bHLH_TS_TWIST1', NULL, NULL, NULL, 2),
(8397, NULL, 'cd00818', NULL, NULL, 'IleRS_core', NULL, 'IleRS_core', NULL, NULL, NULL, 2),
(8398, NULL, 'cd08674', NULL, NULL, 'Cdt1_m', NULL, 'Cdt1_m', NULL, NULL, 14175, 2),
(8399, NULL, 'cd16897', NULL, NULL, 'LYZ_C', NULL, 'LYZ_C', NULL, NULL, NULL, 2),
(8400, NULL, 'cd03479', NULL, NULL, 'Rieske_RO_Alpha_PhDO_like', NULL, 'Rieske_RO_Alpha_PhDO_like', NULL, NULL, NULL, 2),
(8401, NULL, 'cd04678', NULL, NULL, 'Nudix_Hydrolase_19', NULL, 'Nudix_Hydrolase_19', NULL, NULL, NULL, 2),
(8402, NULL, 'cd13421', NULL, NULL, 'TNFRSF_EDAR', NULL, 'TNFRSF_EDAR', NULL, NULL, 26749, 2),
(8403, NULL, 'cd11781', NULL, NULL, 'SH3_Sorbs_1', NULL, 'SH3_Sorbs_1', NULL, NULL, NULL, 2),
(8404, NULL, 'cd08828', NULL, NULL, 'SPFH_SLP-3', NULL, 'SPFH_SLP-3', NULL, NULL, NULL, 2),
(8405, NULL, 'cd17584', NULL, NULL, 'REC_typeB_ARR-like', NULL, 'REC_typeB_ARR-like', NULL, NULL, NULL, 2),
(8406, NULL, 'cd08651', NULL, NULL, 'FMT_core_like_4', NULL, 'FMT_core_like_4', NULL, NULL, NULL, 2),
(8407, NULL, 'cd12374', NULL, NULL, 'RRM_UHM_SPF45_PUF60', NULL, 'RRM_UHM_SPF45_PUF60', NULL, NULL, NULL, 2),
(8408, NULL, 'cd16435', NULL, NULL, 'BPL_LplA_LipB', NULL, 'BPL_LplA_LipB', NULL, NULL, NULL, 2),
(8409, NULL, 'cd00859', NULL, NULL, 'HisRS_anticodon', NULL, 'HisRS_anticodon', NULL, NULL, 29130, 2),
(8410, NULL, 'cd08069', NULL, NULL, 'MPN_RPN11_CSN5', NULL, 'MPN_RPN11_CSN5', NULL, NULL, NULL, 2),
(8411, NULL, 'cd00625', NULL, NULL, 'ArsB_NhaD_permease', NULL, 'ArsB_NhaD_permease', NULL, NULL, NULL, 2),
(8412, NULL, 'cd07293', NULL, NULL, 'PX_SNX3', NULL, 'PX_SNX3', NULL, NULL, 33743, 2),
(8413, NULL, 'cd14443', NULL, NULL, 'AlgX_N_like_2', NULL, 'AlgX_N_like_2', NULL, NULL, NULL, 2),
(8414, NULL, 'cd15452', NULL, NULL, '7tmC_mGluR4', NULL, '7tmC_mGluR4', NULL, NULL, NULL, 2),
(8415, NULL, 'cd02765', NULL, NULL, 'MopB_4', NULL, 'MopB_4', NULL, NULL, NULL, 2),
(8416, NULL, 'cd18785', NULL, NULL, 'SF2_C', NULL, 'SF2_C', NULL, NULL, NULL, 2),
(8417, NULL, 'cd09108', NULL, NULL, 'PLDc_PMFPLD_like_1', NULL, 'PLDc_PMFPLD_like_1', NULL, NULL, NULL, 2),
(8418, NULL, 'cd14175', NULL, NULL, 'STKc_RSK1_C', NULL, 'STKc_RSK1_C', NULL, NULL, NULL, 2),
(8419, NULL, 'cd05863', NULL, NULL, 'Ig_VEGFR-3', NULL, 'Ig_VEGFR-3', NULL, NULL, NULL, 2),
(8420, NULL, 'cd07811', NULL, NULL, 'FGGY_D-XK_3', NULL, 'FGGY_D-XK_3', NULL, NULL, NULL, 2),
(8421, NULL, 'cd12291', NULL, NULL, 'RRM1_La', NULL, 'RRM1_La', NULL, NULL, NULL, 2),
(8422, NULL, 'sd00045', NULL, NULL, 'ANK', NULL, 'ANK', NULL, NULL, NULL, 2),
(8423, NULL, 'cd02423', NULL, NULL, 'Peptidase_C39G', NULL, 'Peptidase_C39G', NULL, NULL, NULL, 2),
(8424, NULL, 'cd13609', NULL, NULL, 'PBP2_Opu_like_1', NULL, 'PBP2_Opu_like_1', NULL, NULL, NULL, 2),
(8425, NULL, 'cd12244', NULL, NULL, 'RRM2_MSSP', NULL, 'RRM2_MSSP', NULL, NULL, NULL, 2),
(8426, NULL, 'cd18004', NULL, NULL, 'DEXHc_RAD54', NULL, 'DEXHc_RAD54', NULL, NULL, NULL, 2),
(8427, NULL, 'cd00072', NULL, NULL, 'GYF', NULL, 'GYF', NULL, NULL, 1962, 2),
(8428, NULL, 'cd01247', NULL, NULL, 'PH_FAPP1_FAPP2', NULL, 'PH_FAPP1_FAPP2', NULL, NULL, NULL, 2),
(8429, NULL, 'cd09581', NULL, NULL, 'SAM_Scm-like-4MBT1,2', NULL, 'SAM_Scm-like-4MBT1,2', NULL, NULL, 33528, 2),
(8430, NULL, 'cd16419', NULL, NULL, 'HAD_SPS', NULL, 'HAD_SPS', NULL, NULL, 28706, 2),
(8431, NULL, 'cd13976', NULL, NULL, 'PK_TRB', NULL, 'PK_TRB', NULL, NULL, NULL, 2),
(8432, NULL, 'cd13286', NULL, NULL, 'PH_OPR5_ORP8', NULL, 'PH_OPR5_ORP8', NULL, NULL, NULL, 2),
(8433, NULL, 'cd20489', NULL, NULL, 'cupin_HppE-like_C', NULL, 'cupin_HppE-like_C', NULL, NULL, NULL, 2),
(8434, NULL, 'cd04157', NULL, NULL, 'Arl6', NULL, 'Arl6', NULL, NULL, 30912, 2),
(8435, NULL, 'cd16597', NULL, NULL, 'RING-HC_TRIM25_C-IV', NULL, 'RING-HC_TRIM25_C-IV', NULL, NULL, NULL, 2);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(8436, NULL, 'cd04383', NULL, NULL, 'RhoGAP_srGAP', NULL, 'RhoGAP_srGAP', NULL, NULL, NULL, 2),
(8437, NULL, 'cd19914', NULL, NULL, 'DSRM_DRADA_rpt2', NULL, 'DSRM_DRADA_rpt2', NULL, NULL, NULL, 2),
(8438, NULL, 'cd14112', NULL, NULL, 'STKc_Unc-89_rpt2', NULL, 'STKc_Unc-89_rpt2', NULL, NULL, NULL, 2),
(8439, NULL, 'cd17533', NULL, NULL, 'REC_LytTR_AgrA-like', NULL, 'REC_LytTR_AgrA-like', NULL, NULL, NULL, 2),
(8440, NULL, 'cd18000', NULL, NULL, 'DEXHc_ERCC6', NULL, 'DEXHc_ERCC6', NULL, NULL, NULL, 2),
(8441, NULL, 'cd21640', NULL, NULL, 'ORF8-Ig_SARS-CoV-2-like', NULL, 'ORF8-Ig_SARS-CoV-2-like', NULL, NULL, NULL, 2),
(8442, NULL, 'cd03584', NULL, NULL, 'NTR_complement_C4', NULL, 'NTR_complement_C4', NULL, NULL, NULL, 2),
(8443, NULL, 'cd01545', NULL, NULL, 'PBP1_SalR', NULL, 'PBP1_SalR', NULL, NULL, NULL, 2),
(8444, NULL, 'cd11444', NULL, NULL, 'bHLH_AtIBH1_like', NULL, 'bHLH_AtIBH1_like', NULL, NULL, 35065, 2),
(8445, NULL, 'cd01680', NULL, NULL, 'EFG_like_IV', NULL, 'EFG_like_IV', NULL, NULL, NULL, 2),
(8446, NULL, 'cd13392', NULL, NULL, 'PH_AKAP13', NULL, 'PH_AKAP13', NULL, NULL, NULL, 2),
(8447, NULL, 'cd16243', NULL, NULL, 'EFh_DYTN', NULL, 'EFh_DYTN', NULL, NULL, NULL, 2),
(8448, NULL, 'cd17657', NULL, NULL, 'CDC14_N', NULL, 'CDC14_N', NULL, NULL, 21762, 2),
(8449, NULL, 'cd19991', NULL, NULL, 'PBP1_ABC_xylose_binding', NULL, 'PBP1_ABC_xylose_binding', NULL, NULL, NULL, 2),
(8450, NULL, 'cd00403', NULL, NULL, 'Ribosomal_L1', NULL, 'Ribosomal_L1', NULL, NULL, 22316, 2),
(8451, NULL, 'cd02127', NULL, NULL, 'PA_hPAP21_like', NULL, 'PA_hPAP21_like', NULL, NULL, 33285, 2),
(8452, NULL, 'cd08917', NULL, NULL, 'TrHb2_O', NULL, 'TrHb2_O', NULL, NULL, NULL, 2),
(8453, NULL, 'cd12897', NULL, NULL, 'SPRY_PRY_TRIM50_72', NULL, 'SPRY_PRY_TRIM50_72', NULL, NULL, NULL, 2),
(8454, NULL, 'cd13427', NULL, NULL, 'YncM_like', NULL, 'YncM_like', NULL, NULL, 23691, 2),
(8455, NULL, 'cd01388', NULL, NULL, 'SOX-TCF_HMG-box', NULL, 'SOX-TCF_HMG-box', NULL, NULL, NULL, 2),
(8456, NULL, 'cd16539', NULL, NULL, 'RING-HC_RNF113A_B', NULL, 'RING-HC_RNF113A_B', NULL, NULL, NULL, 2),
(8457, NULL, 'cd21483', NULL, NULL, 'HKU1_N1_CoV_Spike_S1_RBD', NULL, 'HKU1_N1_CoV_Spike_S1_RBD', NULL, NULL, NULL, 2),
(8458, NULL, 'cd21659', NULL, NULL, 'betaCoV_Nsp14', NULL, 'betaCoV_Nsp14', NULL, NULL, 36288, 2),
(8459, NULL, 'cd14474', NULL, NULL, 'SPX_YDR089W', NULL, 'SPX_YDR089W', NULL, NULL, NULL, 2),
(8460, NULL, 'cd08861', NULL, NULL, 'OtcD1_ARO-CYC_like', NULL, 'OtcD1_ARO-CYC_like', NULL, NULL, NULL, 2),
(8461, NULL, 'cd14320', NULL, NULL, 'UBA_SQSTM', NULL, 'UBA_SQSTM', NULL, NULL, 30887, 2),
(8462, NULL, 'cd20006', NULL, NULL, 'PBP1_ABC_sugar_binding-like', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, NULL, 2),
(8463, NULL, 'cd01679', NULL, NULL, 'RNR_I', NULL, 'RNR_I', NULL, NULL, NULL, 2),
(8464, NULL, 'cd05259', NULL, NULL, 'PCBER_SDR_a', NULL, 'PCBER_SDR_a', NULL, NULL, 36860, 2),
(8465, NULL, 'cd05637', NULL, NULL, 'SIS_PGI_PMI_2', NULL, 'SIS_PGI_PMI_2', NULL, NULL, 18379, 2),
(8466, NULL, 'cd13675', NULL, NULL, 'PBP2_TRAP_SBP_like_5', NULL, 'PBP2_TRAP_SBP_like_5', NULL, NULL, NULL, 2),
(8467, NULL, 'cd13637', NULL, NULL, 'PBP2_Ca3427_like', NULL, 'PBP2_Ca3427_like', NULL, NULL, NULL, 2),
(8468, NULL, 'cd14712', NULL, NULL, 'bZIP_CEBPB', NULL, 'bZIP_CEBPB', NULL, NULL, NULL, 2),
(8469, NULL, 'cd09697', NULL, NULL, 'Cas8a1_I-A', NULL, 'Cas8a1_I-A', NULL, NULL, NULL, 2),
(8470, NULL, 'cd13190', NULL, NULL, 'FERM_C_FAK1', NULL, 'FERM_C_FAK1', NULL, NULL, 30326, 2),
(8471, NULL, 'cd13872', NULL, NULL, 'CuRO_2_AAO_like_1', NULL, 'CuRO_2_AAO_like_1', NULL, NULL, 24953, 2),
(8472, NULL, 'cd04321', NULL, NULL, 'ScAspRS_mt_like_N', NULL, 'ScAspRS_mt_like_N', NULL, NULL, NULL, 2),
(8473, NULL, 'cd00853', NULL, NULL, 'NifX', NULL, 'NifX', NULL, NULL, 13473, 2),
(8474, NULL, 'cd06235', NULL, NULL, 'M14_AGTPBP-like', NULL, 'M14_AGTPBP-like', NULL, NULL, NULL, 2),
(8475, NULL, 'cd07621', NULL, NULL, 'BAR_SNX5_6', NULL, 'BAR_SNX5_6', NULL, NULL, NULL, 2),
(8476, NULL, 'cd08823', NULL, NULL, 'FMT_core_like_5', NULL, 'FMT_core_like_5', NULL, NULL, NULL, 2);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(8477, NULL, 'cd04955', NULL, NULL, 'GT4-like', NULL, 'GT4-like', NULL, NULL, NULL, 2),
(8478, NULL, 'cd11262', NULL, NULL, 'Sema_4G', NULL, 'Sema_4G', NULL, NULL, NULL, 2),
(8479, NULL, 'cd11369', NULL, NULL, 'RNase_PH_RRP43', NULL, 'RNase_PH_RRP43', NULL, NULL, NULL, 2),
(8480, NULL, 'cd10427', NULL, NULL, 'FGGY_GK_1', NULL, 'FGGY_GK_1', NULL, NULL, NULL, 2),
(8481, NULL, 'cd12764', NULL, NULL, 'RRM2_SRSF4', NULL, 'RRM2_SRSF4', NULL, NULL, NULL, 2),
(8482, NULL, 'cd02151', NULL, NULL, 'nitroreductase', NULL, 'nitroreductase', NULL, NULL, NULL, 2),
(8483, NULL, 'cd00525', NULL, NULL, 'AE_Prim_S_like', NULL, 'AE_Prim_S_like', NULL, NULL, NULL, 2),
(8484, NULL, 'cd03567', NULL, NULL, 'VHS_GGA_metazoan', NULL, 'VHS_GGA_metazoan', NULL, NULL, NULL, 2),
(8485, NULL, 'cd01173', NULL, NULL, 'pyridoxal_pyridoxamine_kinase', NULL, 'pyridoxal_pyridoxamine_kinase', NULL, NULL, 2078, 2),
(8486, NULL, 'cd04506', NULL, NULL, 'SGNH_hydrolase_YpmR_like', NULL, 'SGNH_hydrolase_YpmR_like', NULL, NULL, NULL, 2),
(8487, NULL, 'cd07665', NULL, NULL, 'BAR_SNX1', NULL, 'BAR_SNX1', NULL, NULL, NULL, 2),
(8488, NULL, 'cd00455', NULL, NULL, 'nuc_hydro', NULL, 'nuc_hydro', NULL, NULL, NULL, 2),
(8489, NULL, 'cd10969', NULL, NULL, 'CE4_Ecf1_like_5s', NULL, 'CE4_Ecf1_like_5s', NULL, NULL, NULL, 2),
(8490, NULL, 'cd02411', NULL, NULL, 'archeal_30S_S3_KH', NULL, 'archeal_30S_S3_KH', NULL, NULL, NULL, 2),
(8491, NULL, 'cd07086', NULL, NULL, 'ALDH_F7_AASADH-like', NULL, 'ALDH_F7_AASADH-like', NULL, NULL, NULL, 2),
(8492, NULL, 'cd15501', NULL, NULL, 'PHD_Int12', NULL, 'PHD_Int12', NULL, NULL, 33461, 2),
(8493, NULL, 'cd11489', NULL, NULL, 'SLC5sbd_SGLT5', NULL, 'SLC5sbd_SGLT5', NULL, NULL, NULL, 2),
(8494, NULL, 'cd20331', NULL, NULL, 'JBP-like', NULL, 'JBP-like', NULL, NULL, NULL, 2),
(8495, NULL, 'cd16890', NULL, NULL, 'lyz_i', NULL, 'lyz_i', NULL, NULL, 14087, 2),
(8496, NULL, 'cd03202', NULL, NULL, 'GST_C_etherase_LigE', NULL, 'GST_C_etherase_LigE', NULL, NULL, NULL, 2),
(8497, NULL, 'cd05560', NULL, NULL, 'Xcc1710_like', NULL, 'Xcc1710_like', NULL, NULL, NULL, 2),
(8498, NULL, 'cd02420', NULL, NULL, 'Peptidase_C39D', NULL, 'Peptidase_C39D', NULL, NULL, NULL, 2),
(8499, NULL, 'cd13575', NULL, NULL, 'PBP2_PnhD', NULL, 'PBP2_PnhD', NULL, NULL, NULL, 2),
(8500, NULL, 'cd06355', NULL, NULL, 'PBP1_FmdD-like', NULL, 'PBP1_FmdD-like', NULL, NULL, 19281, 2),
(8501, NULL, 'cd05707', NULL, NULL, 'S1_Rrp5_repeat_sc11', NULL, 'S1_Rrp5_repeat_sc11', NULL, NULL, NULL, 2),
(8502, NULL, 'cd12722', NULL, NULL, 'RRM_Nup53', NULL, 'RRM_Nup53', NULL, NULL, NULL, 2),
(8503, NULL, 'cd15528', NULL, NULL, 'PHD1_PHF10', NULL, 'PHD1_PHF10', NULL, NULL, NULL, 2),
(8504, NULL, 'cd18205', NULL, NULL, 'BTB_POZ_ZBTB16_PLZF', NULL, 'BTB_POZ_ZBTB16_PLZF', NULL, NULL, NULL, 2),
(8505, NULL, 'cd07350', NULL, NULL, 'NR_LBD_Dax1', NULL, 'NR_LBD_Dax1', NULL, NULL, NULL, 2),
(8506, NULL, 'cd02757', NULL, NULL, 'MopB_Arsenate-R', NULL, 'MopB_Arsenate-R', NULL, NULL, NULL, 2),
(8507, NULL, 'cd10564', NULL, NULL, 'NapF_like', NULL, 'NapF_like', NULL, NULL, 1870, 2),
(8508, NULL, 'cd03401', NULL, NULL, 'SPFH_prohibitin', NULL, 'SPFH_prohibitin', NULL, NULL, 1539, 2),
(8509, NULL, 'cd14645', NULL, NULL, 'DSP_DUSP8', NULL, 'DSP_DUSP8', NULL, NULL, NULL, 2),
(8510, NULL, 'cd11617', NULL, NULL, 'Antifreeze_III', NULL, 'Antifreeze_III', NULL, NULL, NULL, 2),
(8511, NULL, 'cd03539', NULL, NULL, 'Rieske_RO_Alpha_S5H', NULL, 'Rieske_RO_Alpha_S5H', NULL, NULL, NULL, 2),
(8512, NULL, 'cd05524', NULL, NULL, 'Bromo_polybromo_I', NULL, 'Bromo_polybromo_I', NULL, NULL, NULL, 2),
(8513, NULL, 'cd07803', NULL, NULL, 'FGGY_D-XK', NULL, 'FGGY_D-XK', NULL, NULL, NULL, 2),
(8514, NULL, 'cd12677', NULL, NULL, 'RRM4_Nop4p', NULL, 'RRM4_Nop4p', NULL, NULL, 32446, 2),
(8515, NULL, 'cd05973', NULL, NULL, 'MACS_like_2', NULL, 'MACS_like_2', NULL, NULL, NULL, 2),
(8516, NULL, 'cd07689', NULL, NULL, 'Ig_VCAM-1', NULL, 'Ig_VCAM-1', NULL, NULL, NULL, 2),
(8517, NULL, 'cd11405', NULL, NULL, 'bHLHzip_MLXIP_like', NULL, 'bHLHzip_MLXIP_like', NULL, NULL, NULL, 2),
(8518, NULL, 'cd14691', NULL, NULL, 'bZIP_XBP1', NULL, 'bZIP_XBP1', NULL, NULL, NULL, 2);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(8519, NULL, 'cd09523', NULL, NULL, 'SAM_TAL', NULL, 'SAM_TAL', NULL, NULL, NULL, 2),
(8520, NULL, 'cd18940', NULL, NULL, 'bHLH_TS_OLIG2', NULL, 'bHLH_TS_OLIG2', NULL, NULL, NULL, 2),
(8521, NULL, 'cd00045', NULL, NULL, 'DED', NULL, 'DED', NULL, NULL, NULL, 2),
(8522, NULL, 'cd19432', NULL, NULL, 'lipocalin_2_12-like', NULL, 'lipocalin_2_12-like', NULL, NULL, NULL, 2),
(8523, NULL, 'cd10411', NULL, NULL, 'SH2_SH2B2', NULL, 'SH2_SH2B2', NULL, NULL, 17122, 2),
(8524, NULL, 'cd11858', NULL, NULL, 'SH3_Myosin-I_fungi', NULL, 'SH3_Myosin-I_fungi', NULL, NULL, 28273, 2),
(8525, NULL, 'cd18104', NULL, NULL, 'SpoU-like_RNA-MTase', NULL, 'SpoU-like_RNA-MTase', NULL, NULL, NULL, 2),
(8526, NULL, 'cd11389', NULL, NULL, 'bHLH-O_HERP_like', NULL, 'bHLH-O_HERP_like', NULL, NULL, NULL, 2),
(8527, NULL, 'cd06080', NULL, NULL, 'MUM1_like', NULL, 'MUM1_like', NULL, NULL, 17881, 2),
(8528, NULL, 'cd17135', NULL, NULL, 'RBD_CRAF', NULL, 'RBD_CRAF', NULL, NULL, NULL, 2),
(8529, NULL, 'cd09551', NULL, NULL, 'SAM_EPH-B1', NULL, 'SAM_EPH-B1', NULL, NULL, 36673, 2),
(8530, NULL, 'cd09744', NULL, NULL, 'Cas8a1_I-A', NULL, 'Cas8a1_I-A', NULL, NULL, NULL, 2),
(8531, NULL, 'cd13372', NULL, NULL, 'PH_CAPRI', NULL, 'PH_CAPRI', NULL, NULL, 32189, 2),
(8532, NULL, 'cd03445', NULL, NULL, 'Thioesterase_II_repeat2', NULL, 'Thioesterase_II_repeat2', NULL, NULL, NULL, 2),
(8533, NULL, 'cd05646', NULL, NULL, 'M20_AcylaseI_like', NULL, 'M20_AcylaseI_like', NULL, NULL, NULL, 2),
(8534, NULL, 'cd16537', NULL, NULL, 'RING-HC_RNF37', NULL, 'RING-HC_RNF37', NULL, NULL, NULL, 2),
(8535, NULL, 'cd08162', NULL, NULL, 'MPP_PhoA_N', NULL, 'MPP_PhoA_N', NULL, NULL, 30667, 2),
(8536, NULL, 'cd15236', NULL, NULL, '7tmA_OR1E-like', NULL, '7tmA_OR1E-like', NULL, NULL, NULL, 2),
(8537, NULL, 'cd17130', NULL, NULL, 'Ubl2_FAF1', NULL, 'Ubl2_FAF1', NULL, NULL, NULL, 2),
(8538, NULL, 'cd15920', NULL, NULL, '7tmA_GPR34-like', NULL, '7tmA_GPR34-like', NULL, NULL, NULL, 2),
(8539, NULL, 'cd02240', NULL, NULL, 'cupin_OxDC', NULL, 'cupin_OxDC', NULL, NULL, NULL, 2),
(8540, NULL, 'cd11771', NULL, NULL, 'SH3_Pex13p_fungal', NULL, 'SH3_Pex13p_fungal', NULL, NULL, NULL, 2),
(8541, NULL, 'cd01534', NULL, NULL, '4RHOD_Repeat_3', NULL, '4RHOD_Repeat_3', NULL, NULL, NULL, 2),
(8542, NULL, 'cd13124', NULL, NULL, 'MATE_SpoVB_like', NULL, 'MATE_SpoVB_like', NULL, NULL, 24943, 2),
(8543, NULL, 'cd21530', NULL, NULL, 'CoV_RdRp', NULL, 'CoV_RdRp', NULL, NULL, NULL, 2),
(8544, NULL, 'cd04404', NULL, NULL, 'RhoGAP-p50rhoGAP', NULL, 'RhoGAP-p50rhoGAP', NULL, NULL, NULL, 2),
(8545, NULL, 'cd10307', NULL, NULL, 'GST_C_MetRS_N', NULL, 'GST_C_MetRS_N', NULL, NULL, NULL, 2),
(8546, NULL, 'cd11942', NULL, NULL, 'SH3_JIP2', NULL, 'SH3_JIP2', NULL, NULL, 28450, 2),
(8547, NULL, 'cd12412', NULL, NULL, 'RRM_DAZL_BOULE', NULL, 'RRM_DAZL_BOULE', NULL, NULL, 18913, 2),
(8548, NULL, 'cd01812', NULL, NULL, 'Ubl_BAG1', NULL, 'Ubl_BAG1', NULL, NULL, NULL, 2),
(8549, NULL, 'cd04096', NULL, NULL, 'eEF2_snRNP_like_C', NULL, 'eEF2_snRNP_like_C', NULL, NULL, NULL, 2),
(8550, NULL, 'cd12446', NULL, NULL, 'RRM_RBM25', NULL, 'RRM_RBM25', NULL, NULL, 6829, 2),
(8551, NULL, 'cd20237', NULL, NULL, 'PFM_LIN24-like', NULL, 'PFM_LIN24-like', NULL, NULL, NULL, 2),
(8552, NULL, 'cd18661', NULL, NULL, 'CD2_tandem_CHD1-2_like', NULL, 'CD2_tandem_CHD1-2_like', NULL, NULL, NULL, 2),
(8553, NULL, 'cd14353', NULL, NULL, 'UBA_FAF', NULL, 'UBA_FAF', NULL, NULL, NULL, 2),
(8554, NULL, 'cd12793', NULL, NULL, 'RasGAP_plexin_B1', NULL, 'RasGAP_plexin_B1', NULL, NULL, NULL, 2),
(8555, NULL, 'cd07584', NULL, NULL, 'nitrilase_6', NULL, 'nitrilase_6', NULL, NULL, NULL, 2),
(8556, NULL, 'cd09180', NULL, NULL, 'PLDc_N_DEXD_b', NULL, 'PLDc_N_DEXD_b', NULL, NULL, NULL, 2),
(8557, NULL, 'cd09834', NULL, NULL, 'CBS_pair_bac', NULL, 'CBS_pair_bac', NULL, NULL, NULL, 2),
(8558, NULL, 'cd06971', NULL, NULL, 'PgpA', NULL, 'PgpA', NULL, NULL, 1129, 2),
(8559, NULL, 'cd02950', NULL, NULL, 'TxlA', NULL, 'TxlA', NULL, NULL, NULL, 2),
(8560, NULL, 'cd15251', NULL, NULL, '7tmB2_BAI_Adhesion_VII', NULL, '7tmB2_BAI_Adhesion_VII', NULL, NULL, NULL, 2);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(8561, NULL, 'cd03733', NULL, NULL, 'SOCS_WSB_SWIP', NULL, 'SOCS_WSB_SWIP', NULL, NULL, NULL, 2),
(8562, NULL, 'cd00247', NULL, NULL, 'Endostatin-like', NULL, 'Endostatin-like', NULL, NULL, 12441, 2),
(8563, NULL, 'cd07890', NULL, NULL, 'CYTH-like_AC_IV-like', NULL, 'CYTH-like_AC_IV-like', NULL, NULL, 7134, 2),
(8564, NULL, 'cd17231', NULL, NULL, 'TGS_DRG2', NULL, 'TGS_DRG2', NULL, NULL, NULL, 2),
(8565, NULL, 'cd15011', NULL, NULL, '7tmA_GPR149', NULL, '7tmA_GPR149', NULL, NULL, NULL, 2),
(8566, NULL, 'cd16511', NULL, NULL, 'vRING-HC_IRF2BP1_like', NULL, 'vRING-HC_IRF2BP1_like', NULL, NULL, NULL, 2),
(8567, NULL, 'cd15573', NULL, NULL, 'PHD_JADE', NULL, 'PHD_JADE', NULL, NULL, NULL, 2),
(8568, NULL, 'cd03825', NULL, NULL, 'GT4_WcaC-like', NULL, 'GT4_WcaC-like', NULL, NULL, NULL, 2),
(8569, NULL, 'cd11744', NULL, NULL, 'MIT_CorA-like', NULL, 'MIT_CorA-like', NULL, NULL, NULL, 2),
(8570, NULL, 'cd03335', NULL, NULL, 'TCP1_alpha', NULL, 'TCP1_alpha', NULL, NULL, 11604, 2),
(8571, NULL, 'cd06461', NULL, NULL, 'M2_ACE', NULL, 'M2_ACE', NULL, NULL, 3355, 2),
(8572, NULL, 'cd11652', NULL, NULL, 'SSH-N', NULL, 'SSH-N', NULL, NULL, 35139, 2),
(8573, NULL, 'cd00176', NULL, NULL, 'SPEC', NULL, 'SPEC', NULL, NULL, 13944, 2),
(8574, NULL, 'cd03136', NULL, NULL, 'GATase1_AraC_ArgR_like', NULL, 'GATase1_AraC_ArgR_like', NULL, NULL, NULL, 2),
(8575, NULL, 'cd06811', NULL, NULL, 'PLPDE_III_yhfX_like', NULL, 'PLPDE_III_yhfX_like', NULL, NULL, NULL, 2),
(8576, NULL, 'cd15508', NULL, NULL, 'PHD3_KMT2A_like', NULL, 'PHD3_KMT2A_like', NULL, NULL, NULL, 2),
(8577, NULL, 'cd17054', NULL, NULL, 'Ubl_AtBAG1_like', NULL, 'Ubl_AtBAG1_like', NULL, NULL, NULL, 2),
(8578, NULL, 'cd18462', NULL, NULL, 'BACK_KLHL23', NULL, 'BACK_KLHL23', NULL, NULL, NULL, 2),
(8579, NULL, 'cd09274', NULL, NULL, 'RNase_HI_RT_Ty3', NULL, 'RNase_HI_RT_Ty3', NULL, NULL, NULL, 2),
(8580, NULL, 'cd04519', NULL, NULL, 'RasGAP', NULL, 'RasGAP', NULL, NULL, NULL, 2),
(8581, NULL, 'cd18075', NULL, NULL, 'DEXHc_RLR-3', NULL, 'DEXHc_RLR-3', NULL, NULL, NULL, 2),
(8582, NULL, 'cd11575', NULL, NULL, 'GH99_GH71_like_3', NULL, 'GH99_GH71_like_3', NULL, NULL, NULL, 2),
(8583, NULL, 'cd08705', NULL, NULL, 'RGS_R7-like', NULL, 'RGS_R7-like', NULL, NULL, NULL, 2),
(8584, NULL, 'cd13249', NULL, NULL, 'PH_rhotekin2', NULL, 'PH_rhotekin2', NULL, NULL, NULL, 2),
(8585, NULL, 'cd00920', NULL, NULL, 'Cupredoxin', NULL, 'Cupredoxin', NULL, NULL, NULL, 2),
(8586, NULL, 'cd16730', NULL, NULL, 'RING-HC_MKRN1_3', NULL, 'RING-HC_MKRN1_3', NULL, NULL, NULL, 2),
(8587, NULL, 'cd14528', NULL, NULL, 'PFA-DSP_Siw14', NULL, 'PFA-DSP_Siw14', NULL, NULL, NULL, 2),
(8588, NULL, 'cd15376', NULL, NULL, '7tmA_P2Y11', NULL, '7tmA_P2Y11', NULL, NULL, NULL, 2),
(8589, NULL, 'cd18382', NULL, NULL, 'BTB_POZ_Kv6_KCNG', NULL, 'BTB_POZ_Kv6_KCNG', NULL, NULL, NULL, 2),
(8590, NULL, 'cd12496', NULL, NULL, 'RRM3_RBM46', NULL, 'RRM3_RBM46', NULL, NULL, NULL, 2),
(8591, NULL, 'cd01273', NULL, NULL, 'PTB_CED-6', NULL, 'PTB_CED-6', NULL, NULL, NULL, 2),
(8592, NULL, 'cd07644', NULL, NULL, 'I-BAR_IMD_BAIAP2L2', NULL, 'I-BAR_IMD_BAIAP2L2', NULL, NULL, NULL, 2),
(8593, NULL, 'cd17085', NULL, NULL, 'RAWUL_PCGF6', NULL, 'RAWUL_PCGF6', NULL, NULL, NULL, 2),
(8594, NULL, 'cd18665', NULL, NULL, 'CD1_tandem_CHD1_yeast_like', NULL, 'CD1_tandem_CHD1_yeast_like', NULL, NULL, NULL, 2),
(8595, NULL, 'cd10926', NULL, NULL, 'CE4_u2', NULL, 'CE4_u2', NULL, NULL, NULL, 2),
(8596, NULL, 'cd11912', NULL, NULL, 'SH3_Bzz1_1', NULL, 'SH3_Bzz1_1', NULL, NULL, 14641, 2),
(8597, NULL, 'cd18290', NULL, NULL, 'BTB_POZ_BTBD14B_NAC1', NULL, 'BTB_POZ_BTBD14B_NAC1', NULL, NULL, NULL, 2),
(8598, NULL, 'cd17580', NULL, NULL, 'REC_2_DhkD-like', NULL, 'REC_2_DhkD-like', NULL, NULL, NULL, 2),
(8599, NULL, 'cd17115', NULL, NULL, 'RA_RHG20', NULL, 'RA_RHG20', NULL, NULL, NULL, 2),
(8600, NULL, 'cd03414', NULL, NULL, 'CbiX_SirB_C', NULL, 'CbiX_SirB_C', NULL, NULL, NULL, 2),
(8601, NULL, 'cd06966', NULL, NULL, 'NR_DBD_CAR', NULL, 'NR_DBD_CAR', NULL, NULL, NULL, 2),
(8602, NULL, 'cd07054', NULL, NULL, 'BMC_PduT_repeat2', NULL, 'BMC_PduT_repeat2', NULL, NULL, NULL, 2);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(8603, NULL, 'cd09743', NULL, NULL, 'Csx16_III-U', NULL, 'Csx16_III-U', NULL, NULL, NULL, 2),
(8604, NULL, 'cd06271', NULL, NULL, 'PBP1_AglR_RafR-like', NULL, 'PBP1_AglR_RafR-like', NULL, NULL, NULL, 2),
(8605, NULL, 'cd07581', NULL, NULL, 'nitrilase_3', NULL, 'nitrilase_3', NULL, NULL, NULL, 2),
(8606, NULL, 'cd15954', NULL, NULL, '7tmA_OR52N-like', NULL, '7tmA_OR52N-like', NULL, NULL, NULL, 2),
(8607, NULL, 'cd16793', NULL, NULL, 'SP-RING_ScSiz_like', NULL, 'SP-RING_ScSiz_like', NULL, NULL, NULL, 2),
(8608, NULL, 'cd13348', NULL, NULL, 'PH-GRAM_MTMR12', NULL, 'PH-GRAM_MTMR12', NULL, NULL, NULL, 2),
(8609, NULL, 'cd15547', NULL, NULL, 'PHD_SHPRH', NULL, 'PHD_SHPRH', NULL, NULL, NULL, 2),
(8610, NULL, 'cd10448', NULL, NULL, 'GIY-YIG_unchar_3', NULL, 'GIY-YIG_unchar_3', NULL, NULL, NULL, 2),
(8611, NULL, 'cd12152', NULL, NULL, 'F1-ATPase_delta', NULL, 'F1-ATPase_delta', NULL, NULL, 6132, 2),
(8612, NULL, 'cd08646', NULL, NULL, 'FMT_core_Met-tRNA-FMT_N', NULL, 'FMT_core_Met-tRNA-FMT_N', NULL, NULL, 29507, 2),
(8613, NULL, 'cd14910', NULL, NULL, 'MYSc_Myh1_mammals', NULL, 'MYSc_Myh1_mammals', NULL, NULL, NULL, 2),
(8614, NULL, 'cd07959', NULL, NULL, 'Anticodon_Ia_Leu_AEc', NULL, 'Anticodon_Ia_Leu_AEc', NULL, NULL, NULL, 2),
(8615, NULL, 'cd10305', NULL, NULL, 'GST_C_AIMP3', NULL, 'GST_C_AIMP3', NULL, NULL, NULL, 2),
(8616, NULL, 'cd11786', NULL, NULL, 'SH3_SH3RF_1', NULL, 'SH3_SH3RF_1', NULL, NULL, NULL, 2),
(8617, NULL, 'cd15936', NULL, NULL, '7tmA_OR4D-like', NULL, '7tmA_OR4D-like', NULL, NULL, NULL, 2),
(8618, NULL, 'cd13883', NULL, NULL, 'CuRO_2_Diphenol_Ox', NULL, 'CuRO_2_Diphenol_Ox', NULL, NULL, NULL, 2),
(8619, NULL, 'cd17514', NULL, NULL, 'RMtype1_S_Eco2747I_MmaC7ORF19P-TRD-CR_like', NULL, 'RMtype1_S_Eco2747I_MmaC7ORF19P-TRD-CR_like', NULL, NULL, NULL, 2),
(8620, NULL, 'cd18374', NULL, NULL, 'BTB2_POZ_KCTD19', NULL, 'BTB2_POZ_KCTD19', NULL, NULL, NULL, 2),
(8621, NULL, 'cd18942', NULL, NULL, 'bHLH_TS_OLIG1', NULL, 'bHLH_TS_OLIG1', NULL, NULL, NULL, 2),
(8622, NULL, 'cd09678', NULL, NULL, 'Csb1_I-U', NULL, 'Csb1_I-U', NULL, NULL, NULL, 2),
(8623, NULL, 'cd08933', NULL, NULL, 'RDH_SDR_c', NULL, 'RDH_SDR_c', NULL, NULL, NULL, 2),
(8624, NULL, 'cd11842', NULL, NULL, 'SH3_Ysc84p_like', NULL, 'SH3_Ysc84p_like', NULL, NULL, NULL, 2),
(8625, NULL, 'cd01829', NULL, NULL, 'SGNH_hydrolase_peri2', NULL, 'SGNH_hydrolase_peri2', NULL, NULL, 3647, 2),
(8626, NULL, 'cd06436', NULL, NULL, 'GlcNAc-1-P_transferase', NULL, 'GlcNAc-1-P_transferase', NULL, NULL, NULL, 2),
(8627, NULL, 'cd05781', NULL, NULL, 'DNA_polB_B3_exo', NULL, 'DNA_polB_B3_exo', NULL, NULL, NULL, 2),
(8628, NULL, 'cd15541', NULL, NULL, 'PHD_TIF1_like', NULL, 'PHD_TIF1_like', NULL, NULL, NULL, 2),
(8629, NULL, 'cd08749', NULL, NULL, 'RGS_GRK7', NULL, 'RGS_GRK7', NULL, NULL, NULL, 2),
(8630, NULL, 'cd00261', NULL, NULL, 'AAI_SS', NULL, 'AAI_SS', NULL, NULL, 35185, 2),
(8631, NULL, 'cd10929', NULL, NULL, 'CE4_u5', NULL, 'CE4_u5', NULL, NULL, NULL, 2),
(8632, NULL, 'cd06272', NULL, NULL, 'PBP1_hexuronate_repressor-like', NULL, 'PBP1_hexuronate_repressor-like', NULL, NULL, NULL, 2),
(8633, NULL, 'cd18465', NULL, NULL, 'BACK_KLHL26', NULL, 'BACK_KLHL26', NULL, NULL, NULL, 2),
(8634, NULL, 'cd14614', NULL, NULL, 'R-PTPc-O', NULL, 'R-PTPc-O', NULL, NULL, NULL, 2),
(8635, NULL, 'cd06343', NULL, NULL, 'PBP1_ABC_ligand_binding-like', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, NULL, 2),
(8636, NULL, 'cd09617', NULL, NULL, 'Peptidase_C12_UCH37_BAP1', NULL, 'Peptidase_C12_UCH37_BAP1', NULL, NULL, NULL, 2),
(8637, NULL, 'cd09939', NULL, NULL, 'SH2_STAP_family', NULL, 'SH2_STAP_family', NULL, NULL, NULL, 2),
(8638, NULL, 'cd00890', NULL, NULL, 'Prefoldin', NULL, 'Prefoldin', NULL, NULL, NULL, 2),
(8639, NULL, 'cd13242', NULL, NULL, 'PH_puratrophin-1', NULL, 'PH_puratrophin-1', NULL, NULL, NULL, 2),
(8640, NULL, 'cd12492', NULL, NULL, 'RRM2_RBM46', NULL, 'RRM2_RBM46', NULL, NULL, 13854, 2),
(8641, NULL, 'cd19805', NULL, NULL, 'Bbox1_TIF1', NULL, 'Bbox1_TIF1', NULL, NULL, NULL, 2),
(8642, NULL, 'cd00728', NULL, NULL, 'malate_synt_G', NULL, 'malate_synt_G', NULL, NULL, 3775, 2);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(8643, NULL, 'cd07861', NULL, NULL, 'STKc_CDK1_euk', NULL, 'STKc_CDK1_euk', NULL, NULL, NULL, 2),
(8644, NULL, 'cd17478', NULL, NULL, 'MFS_FsR', NULL, 'MFS_FsR', NULL, NULL, NULL, 2),
(8645, NULL, 'cd11477', NULL, NULL, 'SLC5sbd_u1', NULL, 'SLC5sbd_u1', NULL, NULL, NULL, 2),
(8646, NULL, 'cd03169', NULL, NULL, 'GATase1_PfpI_1', NULL, 'GATase1_PfpI_1', NULL, NULL, NULL, 2),
(8647, NULL, 'cd03249', NULL, NULL, 'ABC_MTABC3_MDL1_MDL2', NULL, 'ABC_MTABC3_MDL1_MDL2', NULL, NULL, NULL, 2),
(8648, NULL, 'cd05243', NULL, NULL, 'SDR_a5', NULL, 'SDR_a5', NULL, NULL, NULL, 2),
(8649, NULL, 'cd14304', NULL, NULL, 'UBA2_KPC2', NULL, 'UBA2_KPC2', NULL, NULL, 30334, 2),
(8650, NULL, 'cd01102', NULL, NULL, 'Link_Domain', NULL, 'Link_Domain', NULL, NULL, NULL, 2),
(8651, NULL, 'cd05395', NULL, NULL, 'RasGAP_RASA4', NULL, 'RasGAP_RASA4', NULL, NULL, NULL, 2),
(8652, NULL, 'cd19760', NULL, NULL, 'Bbox2_TRIM4-like', NULL, 'Bbox2_TRIM4-like', NULL, NULL, NULL, 2),
(8653, NULL, 'cd14264', NULL, NULL, 'DAGK_IM', NULL, 'DAGK_IM', NULL, NULL, 32777, 2),
(8654, NULL, 'cd06214', NULL, NULL, 'PA_degradation_oxidoreductase_like', NULL, 'PA_degradation_oxidoreductase_like', NULL, NULL, NULL, 2),
(8655, NULL, 'cd07223', NULL, NULL, 'Pat_PNPLA5-mammals', NULL, 'Pat_PNPLA5-mammals', NULL, NULL, NULL, 2),
(8656, NULL, 'cd14618', NULL, NULL, 'R-PTPc-V', NULL, 'R-PTPc-V', NULL, NULL, NULL, 2),
(8657, NULL, 'cd04623', NULL, NULL, 'CBS_pair_bac_euk', NULL, 'CBS_pair_bac_euk', NULL, NULL, 34767, 2),
(8658, NULL, 'cd03159', NULL, NULL, 'TM4SF9_like_LEL', NULL, 'TM4SF9_like_LEL', NULL, NULL, NULL, 2),
(8659, NULL, 'cd18395', NULL, NULL, 'BTB_POZ_KCTD21', NULL, 'BTB_POZ_KCTD21', NULL, NULL, NULL, 2),
(8660, NULL, 'cd19556', NULL, NULL, 'serpinA9_centerin', NULL, 'serpinA9_centerin', NULL, NULL, NULL, 2),
(8661, NULL, 'cd04475', NULL, NULL, 'RPA1_DBD_B', NULL, 'RPA1_DBD_B', NULL, NULL, NULL, 2),
(8662, NULL, 'cd06892', NULL, NULL, 'PX_SNX5_like', NULL, 'PX_SNX5_like', NULL, NULL, NULL, 2),
(8663, NULL, 'cd09517', NULL, NULL, 'SAM_USH1G_HARP', NULL, 'SAM_USH1G_HARP', NULL, NULL, NULL, 2),
(8664, NULL, 'cd18525', NULL, NULL, 'BACK_BTBD6', NULL, 'BACK_BTBD6', NULL, NULL, NULL, 2),
(8665, NULL, 'cd09593', NULL, NULL, 'UDG-like', NULL, 'UDG-like', NULL, NULL, NULL, 2),
(8666, NULL, 'cd07703', NULL, NULL, 'Ig2_Nectin-2_like', NULL, 'Ig2_Nectin-2_like', NULL, NULL, NULL, 2),
(8667, NULL, 'cd15860', NULL, NULL, 'SNARE_USE1', NULL, 'SNARE_USE1', NULL, NULL, NULL, 2),
(8668, NULL, 'cd15921', NULL, NULL, '7tmA_CysLTR', NULL, '7tmA_CysLTR', NULL, NULL, NULL, 2),
(8669, NULL, 'cd05064', NULL, NULL, 'PTKc_EphR_A10', NULL, 'PTKc_EphR_A10', NULL, NULL, NULL, 2),
(8670, NULL, 'cd15518', NULL, NULL, 'PHD_Ecm5p_Lid2p_like', NULL, 'PHD_Ecm5p_Lid2p_like', NULL, NULL, NULL, 2),
(8671, NULL, 'cd10538', NULL, NULL, 'SET_SETDB-like', NULL, 'SET_SETDB-like', NULL, NULL, NULL, 2),
(8672, NULL, 'cd01863', NULL, NULL, 'Rab18', NULL, 'Rab18', NULL, NULL, NULL, 2),
(8673, NULL, 'cd03770', NULL, NULL, 'SR_TndX_transposase', NULL, 'SR_TndX_transposase', NULL, NULL, NULL, 2),
(8674, NULL, 'cd19131', NULL, NULL, 'AKR_AKR5C2', NULL, 'AKR_AKR5C2', NULL, NULL, 35737, 2),
(8675, NULL, 'cd12904', NULL, NULL, 'SPRY_BSPRY', NULL, 'SPRY_BSPRY', NULL, NULL, NULL, 2),
(8676, NULL, 'cd12799', NULL, NULL, 'pesticin_lyz-like', NULL, 'pesticin_lyz-like', NULL, NULL, NULL, 2),
(8677, NULL, 'cd06503', NULL, NULL, 'ATP-synt_Fo_b', NULL, 'ATP-synt_Fo_b', NULL, NULL, NULL, 2),
(8678, NULL, 'cd11671', NULL, NULL, 'TAZ1_RBM', NULL, 'TAZ1_RBM', NULL, NULL, NULL, 2),
(8679, NULL, 'cd05858', NULL, NULL, 'Ig3_FGFR-2', NULL, 'Ig3_FGFR-2', NULL, NULL, NULL, 2),
(8680, NULL, 'cd02909', NULL, NULL, 'cupin_pirin_N', NULL, 'cupin_pirin_N', NULL, NULL, NULL, 2),
(8681, NULL, 'cd08797', NULL, NULL, 'Death_NFkB1_p105', NULL, 'Death_NFkB1_p105', NULL, NULL, NULL, 2),
(8682, NULL, 'cd13718', NULL, NULL, 'PBP2_iGluR_NMDA_Nr2', NULL, 'PBP2_iGluR_NMDA_Nr2', NULL, NULL, NULL, 2),
(8683, NULL, 'cd00250', NULL, NULL, 'CAS_like', NULL, 'CAS_like', NULL, NULL, NULL, 2),
(8684, NULL, 'cd14177', NULL, NULL, 'STKc_RSK4_C', NULL, 'STKc_RSK4_C', NULL, NULL, NULL, 2);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(8685, NULL, 'cd11778', NULL, NULL, 'SH3_Bzz1_2', NULL, 'SH3_Bzz1_2', NULL, NULL, NULL, 2),
(8686, NULL, 'cd14386', NULL, NULL, 'UBA2_UBP5', NULL, 'UBA2_UBP5', NULL, NULL, NULL, 2),
(8687, NULL, 'cd05585', NULL, NULL, 'STKc_YPK1_like', NULL, 'STKc_YPK1_like', NULL, NULL, NULL, 2),
(8688, NULL, 'cd16687', NULL, NULL, 'RING-H2_Vps8', NULL, 'RING-H2_Vps8', NULL, NULL, NULL, 2),
(8689, NULL, 'cd09763', NULL, NULL, 'DHRS1-like_SDR_c', NULL, 'DHRS1-like_SDR_c', NULL, NULL, NULL, 2),
(8690, NULL, 'cd13695', NULL, NULL, 'PBP2_Mlr3796_like', NULL, 'PBP2_Mlr3796_like', NULL, NULL, NULL, 2),
(8691, NULL, 'cd15068', NULL, NULL, '7tmA_Adenosine_R_A2A', NULL, '7tmA_Adenosine_R_A2A', NULL, NULL, NULL, 2),
(8692, NULL, 'cd16514', NULL, NULL, 'RING2-HC_LONFs', NULL, 'RING2-HC_LONFs', NULL, NULL, NULL, 2),
(8693, NULL, 'cd19185', NULL, NULL, 'SET_KMT5C', NULL, 'SET_KMT5C', NULL, NULL, 35111, 2),
(8694, NULL, 'cd09454', NULL, NULL, 'LIM1_ZASP_Cypher', NULL, 'LIM1_ZASP_Cypher', NULL, NULL, NULL, 2),
(8695, NULL, 'cd19533', NULL, NULL, 'starter-C_NRPS', NULL, 'starter-C_NRPS', NULL, NULL, NULL, 2),
(8696, NULL, 'cd11399', NULL, NULL, 'bHLHzip_scHMS1_like', NULL, 'bHLHzip_scHMS1_like', NULL, NULL, NULL, 2),
(8697, NULL, 'cd01666', NULL, NULL, 'TGS_DRG', NULL, 'TGS_DRG', NULL, NULL, NULL, 2),
(8698, NULL, 'cd03399', NULL, NULL, 'SPFH_flotillin', NULL, 'SPFH_flotillin', NULL, NULL, NULL, 2),
(8699, NULL, 'cd17040', NULL, NULL, 'Ubl_MoaD_like', NULL, 'Ubl_MoaD_like', NULL, NULL, NULL, 2),
(8700, NULL, 'cd17991', NULL, NULL, 'DEXHc_TRCF', NULL, 'DEXHc_TRCF', NULL, NULL, NULL, 2),
(8701, NULL, 'cd01158', NULL, NULL, 'SCAD_SBCAD', NULL, 'SCAD_SBCAD', NULL, NULL, NULL, 2),
(8702, NULL, 'cd18984', NULL, NULL, 'CBD_MOF_like', NULL, 'CBD_MOF_like', NULL, NULL, NULL, 2),
(8703, NULL, 'cd12332', NULL, NULL, 'RRM1_p54nrb_like', NULL, 'RRM1_p54nrb_like', NULL, NULL, NULL, 2),
(8704, NULL, 'cd17938', NULL, NULL, 'DEADc_DDX1', NULL, 'DEADc_DDX1', NULL, NULL, NULL, 2),
(8705, NULL, 'cd03405', NULL, NULL, 'SPFH_HflC', NULL, 'SPFH_HflC', NULL, NULL, 4374, 2),
(8706, NULL, 'cd04162', NULL, NULL, 'Arl9_Arfrp2_like', NULL, 'Arl9_Arfrp2_like', NULL, NULL, NULL, 2),
(8707, NULL, 'cd15094', NULL, NULL, '7tmA_AstC_insect', NULL, '7tmA_AstC_insect', NULL, NULL, NULL, 2),
(8708, NULL, 'cd11333', NULL, NULL, 'AmyAc_SI_OligoGlu_DGase', NULL, 'AmyAc_SI_OligoGlu_DGase', NULL, NULL, NULL, 2),
(8709, NULL, 'cd02688', NULL, NULL, 'E_set', NULL, 'E_set', NULL, NULL, NULL, 2),
(8710, NULL, 'cd05295', NULL, NULL, 'MDH_like', NULL, 'MDH_like', NULL, NULL, NULL, 2),
(8711, NULL, 'cd16162', NULL, NULL, 'OCRE_RBM5_like', NULL, 'OCRE_RBM5_like', NULL, NULL, NULL, 2),
(8712, NULL, 'cd07216', NULL, NULL, 'Pat17_PNPLA8_PNPLA9_like3', NULL, 'Pat17_PNPLA8_PNPLA9_like3', NULL, NULL, NULL, 2),
(8713, NULL, 'cd06478', NULL, NULL, 'ACD_HspB4-5-6', NULL, 'ACD_HspB4-5-6', NULL, NULL, NULL, 2),
(8714, NULL, 'cd14620', NULL, NULL, 'R-PTPc-E-1', NULL, 'R-PTPc-E-1', NULL, NULL, NULL, 2),
(8715, NULL, 'cd01239', NULL, NULL, 'PH_PKD', NULL, 'PH_PKD', NULL, NULL, NULL, 2),
(8716, NULL, 'cd15922', NULL, NULL, '7tmA_P2Y-like', NULL, '7tmA_P2Y-like', NULL, NULL, NULL, 2),
(8717, NULL, 'cd12062', NULL, NULL, 'SH3_Caskin1', NULL, 'SH3_Caskin1', NULL, NULL, 16613, 2),
(8718, NULL, 'cd21660', NULL, NULL, 'alphaCoV_Nsp14', NULL, 'alphaCoV_Nsp14', NULL, NULL, 36304, 2),
(8719, NULL, 'cd16722', NULL, NULL, 'RING-HC_MEX3C', NULL, 'RING-HC_MEX3C', NULL, NULL, NULL, 2),
(8720, NULL, 'cd07285', NULL, NULL, 'PX_SNX9', NULL, 'PX_SNX9', NULL, NULL, 33367, 2),
(8721, NULL, 'cd17900', NULL, NULL, 'ArfGap_ASAP3', NULL, 'ArfGap_ASAP3', NULL, NULL, NULL, 2),
(8722, NULL, 'cd18262', NULL, NULL, 'BTB1_POZ_KLHL33', NULL, 'BTB1_POZ_KLHL33', NULL, NULL, NULL, 2),
(8723, NULL, 'cd05282', NULL, NULL, 'ETR_like', NULL, 'ETR_like', NULL, NULL, NULL, 2),
(8724, NULL, 'cd15113', NULL, NULL, '7tmA_MAS1L', NULL, '7tmA_MAS1L', NULL, NULL, NULL, 2),
(8725, NULL, 'cd18796', NULL, NULL, 'SF2_C_LHR', NULL, 'SF2_C_LHR', NULL, NULL, NULL, 2),
(8726, NULL, 'cd04272', NULL, NULL, 'ZnMc_salivary_gland_MPs', NULL, 'ZnMc_salivary_gland_MPs', NULL, NULL, 13261, 2);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(8727, NULL, 'cd06293', NULL, NULL, 'PBP1_LacI-like', NULL, 'PBP1_LacI-like', NULL, NULL, NULL, 2),
(8728, NULL, 'cd08400', NULL, NULL, 'C2_Ras_p21A1', NULL, 'C2_Ras_p21A1', NULL, NULL, NULL, 2),
(8729, NULL, 'cd15194', NULL, NULL, '7tmA_GPR15', NULL, '7tmA_GPR15', NULL, NULL, NULL, 2),
(8730, NULL, 'cd17385', NULL, NULL, 'MFS_SLC18B1', NULL, 'MFS_SLC18B1', NULL, NULL, NULL, 2),
(8731, NULL, 'cd13263', NULL, NULL, 'PH_RhoGap25-like', NULL, 'PH_RhoGap25-like', NULL, NULL, NULL, 2),
(8732, NULL, 'cd14017', NULL, NULL, 'STKc_TTBK', NULL, 'STKc_TTBK', NULL, NULL, NULL, 2),
(8733, NULL, 'cd13767', NULL, NULL, 'TGF_beta_BMP9_like', NULL, 'TGF_beta_BMP9_like', NULL, NULL, NULL, 2),
(8734, NULL, 'cd08413', NULL, NULL, 'PBP2_CysB_like', NULL, 'PBP2_CysB_like', NULL, NULL, 29780, 2),
(8735, NULL, 'cd11878', NULL, NULL, 'SH3_Bem1p_1', NULL, 'SH3_Bem1p_1', NULL, NULL, 30089, 2),
(8736, NULL, 'cd16199', NULL, NULL, 'EFh_PEF_CAPN2', NULL, 'EFh_PEF_CAPN2', NULL, NULL, 35269, 2),
(8737, NULL, 'cd05056', NULL, NULL, 'PTKc_FAK', NULL, 'PTKc_FAK', NULL, NULL, NULL, 2),
(8738, NULL, 'cd12078', NULL, NULL, 'SH3_Tks4_3', NULL, 'SH3_Tks4_3', NULL, NULL, 16143, 2),
(8739, NULL, 'cd15974', NULL, NULL, '7tmA_SSTR5', NULL, '7tmA_SSTR5', NULL, NULL, NULL, 2),
(8740, NULL, 'cd16325', NULL, NULL, 'LolA', NULL, 'LolA', NULL, NULL, 617, 2),
(8741, NULL, 'cd04136', NULL, NULL, 'Rap_like', NULL, 'Rap_like', NULL, NULL, NULL, 2),
(8742, NULL, 'cd19357', NULL, NULL, 'TenA_E_At3g16990-like', NULL, 'TenA_E_At3g16990-like', NULL, NULL, NULL, 2),
(8743, NULL, 'cd06552', NULL, NULL, 'ASCH_yqfb_like', NULL, 'ASCH_yqfb_like', NULL, NULL, NULL, 2),
(8744, NULL, 'cd04013', NULL, NULL, 'C2_SynGAP_like', NULL, 'C2_SynGAP_like', NULL, NULL, NULL, 2),
(8745, NULL, 'cd04077', NULL, NULL, 'Peptidases_S8_PCSK9_ProteinaseK_like', NULL, 'Peptidases_S8_PCSK9_ProteinaseK_like', NULL, NULL, 10742, 2),
(8746, NULL, 'cd15825', NULL, NULL, 'SPRY_PRY_TRIM34', NULL, 'SPRY_PRY_TRIM34', NULL, NULL, 31286, 2),
(8747, NULL, 'cd03499', NULL, NULL, 'SQR_TypeC_SdhC', NULL, 'SQR_TypeC_SdhC', NULL, NULL, NULL, 2),
(8748, NULL, 'cd13425', NULL, NULL, 'Peptidase_G1_like', NULL, 'Peptidase_G1_like', NULL, NULL, 30596, 2),
(8749, NULL, 'cd16305', NULL, NULL, 'Sfh-1-like_MBL-B2', NULL, 'Sfh-1-like_MBL-B2', NULL, NULL, NULL, 2),
(8750, NULL, 'cd17553', NULL, NULL, 'REC_Spo0F-like', NULL, 'REC_Spo0F-like', NULL, NULL, NULL, 2),
(8751, NULL, 'cd14282', NULL, NULL, 'UBA_TDRD3', NULL, 'UBA_TDRD3', NULL, NULL, 30383, 2),
(8752, NULL, 'cd19009', NULL, NULL, 'LGIC_ECD_GlyR_alpha', NULL, 'LGIC_ECD_GlyR_alpha', NULL, NULL, NULL, 2),
(8753, NULL, 'cd11437', NULL, NULL, 'bHLH-PAS_ARNT_like', NULL, 'bHLH-PAS_ARNT_like', NULL, NULL, NULL, 2),
(8754, NULL, 'cd00491', NULL, NULL, '4Oxalocrotonate_Tautomerase', NULL, '4Oxalocrotonate_Tautomerase', NULL, NULL, 19253, 2),
(8755, NULL, 'cd07014', NULL, NULL, 'S49_SppA', NULL, 'S49_SppA', NULL, NULL, NULL, 2),
(8756, NULL, 'cd10300', NULL, NULL, 'GST_C_CLIC1', NULL, 'GST_C_CLIC1', NULL, NULL, NULL, 2),
(8757, NULL, 'cd05294', NULL, NULL, 'LDH-like_MDH_nadp', NULL, 'LDH-like_MDH_nadp', NULL, NULL, NULL, 2),
(8758, NULL, 'cd03384', NULL, NULL, 'PAP2_wunen', NULL, 'PAP2_wunen', NULL, NULL, NULL, 2),
(8759, NULL, 'cd08065', NULL, NULL, 'MPN_eIF3h', NULL, 'MPN_eIF3h', NULL, NULL, 25491, 2),
(8760, NULL, 'cd10956', NULL, NULL, 'CE4_BH1302_like', NULL, 'CE4_BH1302_like', NULL, NULL, NULL, 2),
(8761, NULL, 'cd10521', NULL, NULL, 'SET_SMYD5', NULL, 'SET_SMYD5', NULL, NULL, 35268, 2),
(8762, NULL, 'cd02054', NULL, NULL, 'serpinA8_AGT', NULL, 'serpinA8_AGT', NULL, NULL, 31954, 2),
(8763, NULL, 'cd03758', NULL, NULL, 'proteasome_beta_type_2', NULL, 'proteasome_beta_type_2', NULL, NULL, 8549, 2),
(8764, NULL, 'cd05886', NULL, NULL, 'Ig1_Nectin-1_like', NULL, 'Ig1_Nectin-1_like', NULL, NULL, 30979, 2),
(8765, NULL, 'cd14794', NULL, NULL, 'RNLA_N_1', NULL, 'RNLA_N_1', NULL, NULL, NULL, 2),
(8766, NULL, 'cd17330', NULL, NULL, 'MFS_SLC46_TetA_like', NULL, 'MFS_SLC46_TetA_like', NULL, NULL, NULL, 2),
(8767, NULL, 'cd12881', NULL, NULL, 'SPRY_HERC1', NULL, 'SPRY_HERC1', NULL, NULL, 31728, 2);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(8768, NULL, 'cd10934', NULL, NULL, 'CE4_cadherin_MopE_like_N', NULL, 'CE4_cadherin_MopE_like_N', NULL, NULL, NULL, 2),
(8769, NULL, 'cd07999', NULL, NULL, 'GH7_CBH_EG', NULL, 'GH7_CBH_EG', NULL, NULL, 3402, 2),
(8770, NULL, 'cd19036', NULL, NULL, 'LGIC_ECD_GABAAR_A3', NULL, 'LGIC_ECD_GABAAR_A3', NULL, NULL, NULL, 2),
(8771, NULL, 'cd02228', NULL, NULL, 'cupin_EutQ', NULL, 'cupin_EutQ', NULL, NULL, NULL, 2),
(8772, NULL, 'cd16087', NULL, NULL, 'IgV_CD86', NULL, 'IgV_CD86', NULL, NULL, 27863, 2),
(8773, NULL, 'cd07169', NULL, NULL, 'NR_DBD_GCNF_like', NULL, 'NR_DBD_GCNF_like', NULL, NULL, NULL, 2),
(8774, NULL, 'cd03891', NULL, NULL, 'M20_DapE_proteobac', NULL, 'M20_DapE_proteobac', NULL, NULL, NULL, 2),
(8775, NULL, 'cd18600', NULL, NULL, 'ABC_6TM_CFTR_D2', NULL, 'ABC_6TM_CFTR_D2', NULL, NULL, NULL, 2),
(8776, NULL, 'cd00006', NULL, NULL, 'PTS_IIA_man', NULL, 'PTS_IIA_man', NULL, NULL, 30514, 2),
(8777, NULL, 'cd04905', NULL, NULL, 'ACT_CM-PDT', NULL, 'ACT_CM-PDT', NULL, NULL, NULL, 2),
(8778, NULL, 'cd12952', NULL, NULL, 'MMP_ACEL2062', NULL, 'MMP_ACEL2062', NULL, NULL, NULL, 2),
(8779, NULL, 'cd17634', NULL, NULL, 'ACS-like', NULL, 'ACS-like', NULL, NULL, NULL, 2),
(8780, NULL, 'cd06105', NULL, NULL, 'ScCit1-2_like', NULL, 'ScCit1-2_like', NULL, NULL, NULL, 2),
(8781, NULL, 'cd13674', NULL, NULL, 'PBP2_TRAP_SBP_like_1', NULL, 'PBP2_TRAP_SBP_like_1', NULL, NULL, NULL, 2),
(8782, NULL, 'cd14973', NULL, NULL, '7tmA_Mrgpr', NULL, '7tmA_Mrgpr', NULL, NULL, NULL, 2),
(8783, NULL, 'cd16387', NULL, NULL, 'ParB_N_Srx', NULL, 'ParB_N_Srx', NULL, NULL, NULL, 2),
(8784, NULL, 'cd03156', NULL, NULL, 'uroplakin_I_like_LEL', NULL, 'uroplakin_I_like_LEL', NULL, NULL, NULL, 2),
(8785, NULL, 'cd07698', NULL, NULL, 'IgC_MHC_I_alpha3', NULL, 'IgC_MHC_I_alpha3', NULL, NULL, NULL, 2),
(8786, NULL, 'cd01629', NULL, NULL, 'HAD_EP', NULL, 'HAD_EP', NULL, NULL, 10362, 2),
(8787, NULL, 'cd12834', NULL, NULL, 'ZntB_u1', NULL, 'ZntB_u1', NULL, NULL, NULL, 2),
(8788, NULL, 'cd18675', NULL, NULL, 'PIN_SpAst1-like', NULL, 'PIN_SpAst1-like', NULL, NULL, NULL, 2),
(8789, NULL, 'cd06397', NULL, NULL, 'PB1_UP1', NULL, 'PB1_UP1', NULL, NULL, NULL, 2),
(8790, NULL, 'cd18620', NULL, NULL, 'GH43_XylA-like', NULL, 'GH43_XylA-like', NULL, NULL, NULL, 2),
(8791, NULL, 'cd02436', NULL, NULL, 'Nodulin-21', NULL, 'Nodulin-21', NULL, NULL, NULL, 2),
(8792, NULL, 'cd13177', NULL, NULL, 'RanBD2_RanBP2-like', NULL, 'RanBD2_RanBP2-like', NULL, NULL, NULL, 2),
(8793, NULL, 'cd01976', NULL, NULL, 'Nitrogenase_MoFe_alpha', NULL, 'Nitrogenase_MoFe_alpha', NULL, NULL, 1389, 2),
(8794, NULL, 'cd14291', NULL, NULL, 'UBA1_NUB1_like', NULL, 'UBA1_NUB1_like', NULL, NULL, NULL, 2),
(8795, NULL, 'cd00633', NULL, NULL, 'Secretoglobin', NULL, 'Secretoglobin', NULL, NULL, 11477, 2),
(8796, NULL, 'cd18563', NULL, NULL, 'ABC_6TM_exporter_like', NULL, 'ABC_6TM_exporter_like', NULL, NULL, NULL, 2),
(8797, NULL, 'cd12187', NULL, NULL, 'LDH_like_1', NULL, 'LDH_like_1', NULL, NULL, NULL, 2),
(8798, NULL, 'cd12003', NULL, NULL, 'SH3_EFS', NULL, 'SH3_EFS', NULL, NULL, 28175, 2),
(8799, NULL, 'cd14674', NULL, NULL, 'PH_PLEKHM3_1', NULL, 'PH_PLEKHM3_1', NULL, NULL, 31769, 2),
(8800, NULL, 'cd09730', NULL, NULL, 'Cas8a1_I-A', NULL, 'Cas8a1_I-A', NULL, NULL, NULL, 2),
(8801, NULL, 'cd08809', NULL, NULL, 'CARD_CARD9', NULL, 'CARD_CARD9', NULL, NULL, 33999, 2),
(8802, NULL, 'cd13996', NULL, NULL, 'STKc_EIF2AK', NULL, 'STKc_EIF2AK', NULL, NULL, NULL, 2),
(8803, NULL, 'cd08556', NULL, NULL, 'GDPD', NULL, 'GDPD', NULL, NULL, NULL, 2),
(8804, NULL, 'cd16423', NULL, NULL, 'HAD_BPGM-like', NULL, 'HAD_BPGM-like', NULL, NULL, NULL, 2),
(8805, NULL, 'cd01464', NULL, NULL, 'vWA_subfamily', NULL, 'vWA_subfamily', NULL, NULL, NULL, 2),
(8806, NULL, 'cd16610', NULL, NULL, 'RING-HC_TRIM68_C-IV', NULL, 'RING-HC_TRIM68_C-IV', NULL, NULL, 35992, 2),
(8807, NULL, 'cd00299', NULL, NULL, 'GST_C_family', NULL, 'GST_C_family', NULL, NULL, NULL, 2),
(8808, NULL, 'cd02647', NULL, NULL, 'nuc_hydro_TvIAG', NULL, 'nuc_hydro_TvIAG', NULL, NULL, NULL, 2),
(8809, NULL, 'cd10422', NULL, NULL, 'RNase_Ire1', NULL, 'RNase_Ire1', NULL, NULL, NULL, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(8810, NULL, 'cd14584', NULL, NULL, 'PTP-MTMR8', NULL, 'PTP-MTMR8', NULL, NULL, NULL, 2),
(8811, NULL, 'cd17164', NULL, NULL, 'RAWUL_PCGF2', NULL, 'RAWUL_PCGF2', NULL, NULL, NULL, 2),
(8812, NULL, 'cd13593', NULL, NULL, 'PBP2_HisGL3', NULL, 'PBP2_HisGL3', NULL, NULL, NULL, 2),
(8813, NULL, 'cd17199', NULL, NULL, 'FERM_F1_FRMD4A', NULL, 'FERM_F1_FRMD4A', NULL, NULL, NULL, 2),
(8814, NULL, 'cd02028', NULL, NULL, 'UMPK_like', NULL, 'UMPK_like', NULL, NULL, NULL, 2),
(8815, NULL, 'cd18161', NULL, NULL, 'REC_hyHK_blue-like', NULL, 'REC_hyHK_blue-like', NULL, NULL, NULL, 2),
(8816, NULL, 'cd00554', NULL, NULL, 'MECDP_synthase', NULL, 'MECDP_synthase', NULL, NULL, 6440, 2),
(8817, NULL, 'cd15932', NULL, NULL, '7tmB2_GPR116-like_Adhesion_VI', NULL, '7tmB2_GPR116-like_Adhesion_VI', NULL, NULL, NULL, 2),
(8818, NULL, 'cd09123', NULL, NULL, 'PLDc_Tdp1_2', NULL, 'PLDc_Tdp1_2', NULL, NULL, NULL, 2),
(8819, NULL, 'cd00048', NULL, NULL, 'DSRM_SF', NULL, 'DSRM_SF', NULL, NULL, NULL, 2),
(8820, NULL, 'cd01401', NULL, NULL, 'PncB_like', NULL, 'PncB_like', NULL, NULL, 5827, 2),
(8821, NULL, 'cd00788', NULL, NULL, 'KU70', NULL, 'KU70', NULL, NULL, NULL, 2),
(8822, NULL, 'cd15855', NULL, NULL, 'SNARE_SNAP25C_23C', NULL, 'SNARE_SNAP25C_23C', NULL, NULL, NULL, 2),
(8823, NULL, 'cd18029', NULL, NULL, 'DEXHc_XPB', NULL, 'DEXHc_XPB', NULL, NULL, NULL, 2),
(8824, NULL, 'cd14960', NULL, NULL, 'NHL_TRIM2_like', NULL, 'NHL_TRIM2_like', NULL, NULL, NULL, 2),
(8825, NULL, 'cd04681', NULL, NULL, 'Nudix_Hydrolase_22', NULL, 'Nudix_Hydrolase_22', NULL, NULL, NULL, 2),
(8826, NULL, 'cd10794', NULL, NULL, 'GH57N_PfGalA_like', NULL, 'GH57N_PfGalA_like', NULL, NULL, NULL, 2),
(8827, NULL, 'cd14941', NULL, NULL, 'TRAPPC_bet3-like', NULL, 'TRAPPC_bet3-like', NULL, NULL, NULL, 2),
(8828, NULL, 'cd15132', NULL, NULL, '7tmA_motilin_R', NULL, '7tmA_motilin_R', NULL, NULL, NULL, 2),
(8829, NULL, 'cd15699', NULL, NULL, 'ePHD_TCF20', NULL, 'ePHD_TCF20', NULL, NULL, 30226, 2),
(8830, NULL, 'cd04319', NULL, NULL, 'PhAsnRS_like_N', NULL, 'PhAsnRS_like_N', NULL, NULL, NULL, 2),
(8831, NULL, 'cd09975', NULL, NULL, 'LOTUS_2_TDRD5', NULL, 'LOTUS_2_TDRD5', NULL, NULL, 32318, 2),
(8832, NULL, 'cd17615', NULL, NULL, 'REC_OmpR_MtPhoP-like', NULL, 'REC_OmpR_MtPhoP-like', NULL, NULL, NULL, 2),
(8833, NULL, 'cd02086', NULL, NULL, 'P-type_ATPase_Na_ENA', NULL, 'P-type_ATPase_Na_ENA', NULL, NULL, 6838, 2),
(8834, NULL, 'cd12517', NULL, NULL, 'RRM_RBM27', NULL, 'RRM_RBM27', NULL, NULL, 28080, 2),
(8835, NULL, 'cd14099', NULL, NULL, 'STKc_PLK', NULL, 'STKc_PLK', NULL, NULL, NULL, 2),
(8836, NULL, 'cd02001', NULL, NULL, 'TPP_ComE_PpyrDC', NULL, 'TPP_ComE_PpyrDC', NULL, NULL, NULL, 2),
(8837, NULL, 'cd17719', NULL, NULL, 'BRCT_Rev1', NULL, 'BRCT_Rev1', NULL, NULL, NULL, 2),
(8838, NULL, 'cd01014', NULL, NULL, 'nicotinamidase_related', NULL, 'nicotinamidase_related', NULL, NULL, NULL, 2),
(8839, NULL, 'cd01494', NULL, NULL, 'AAT_I', NULL, 'AAT_I', NULL, NULL, NULL, 2),
(8840, NULL, 'cd02955', NULL, NULL, 'SSP411', NULL, 'SSP411', NULL, NULL, 7076, 2),
(8841, NULL, 'cd16007', NULL, NULL, '7tmB2_Latrophilin-1', NULL, '7tmB2_Latrophilin-1', NULL, NULL, NULL, 2),
(8842, NULL, 'cd01262', NULL, NULL, 'PH_PDK1', NULL, 'PH_PDK1', NULL, NULL, 27769, 2),
(8843, NULL, 'cd14114', NULL, NULL, 'STKc_Twitchin_like', NULL, 'STKc_Twitchin_like', NULL, NULL, NULL, 2),
(8844, NULL, 'cd05584', NULL, NULL, 'STKc_p70S6K', NULL, 'STKc_p70S6K', NULL, NULL, NULL, 2),
(8845, NULL, 'cd06207', NULL, NULL, 'CyPoR_like', NULL, 'CyPoR_like', NULL, NULL, NULL, 2),
(8846, NULL, 'cd08153', NULL, NULL, 'srpA_like', NULL, 'srpA_like', NULL, NULL, 12926, 2),
(8847, NULL, 'cd15578', NULL, NULL, 'PHD1_MTF2', NULL, 'PHD1_MTF2', NULL, NULL, 30890, 2),
(8848, NULL, 'cd13735', NULL, NULL, 'SPRY_HECT_like', NULL, 'SPRY_HECT_like', NULL, NULL, 32331, 2),
(8849, NULL, 'cd01124', NULL, NULL, 'KaiC', NULL, 'KaiC', NULL, NULL, NULL, 2),
(8850, NULL, 'cd04011', NULL, NULL, 'C2B_Ferlin', NULL, 'C2B_Ferlin', NULL, NULL, 30083, 2),
(8851, NULL, 'cd17001', NULL, NULL, 'CID_RPRD2', NULL, 'CID_RPRD2', NULL, NULL, NULL, 2);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(8852, NULL, 'cd02800', NULL, NULL, 'tRNA_bind_EcMetRS_like', NULL, 'tRNA_bind_EcMetRS_like', NULL, NULL, 1185, 2),
(8853, NULL, 'cd06930', NULL, NULL, 'NR_LBD_F2', NULL, 'NR_LBD_F2', NULL, NULL, NULL, 2),
(8854, NULL, 'cd08777', NULL, NULL, 'Death_RIP1', NULL, 'Death_RIP1', NULL, NULL, 32943, 2),
(8855, NULL, 'cd14871', NULL, NULL, 'uS7_Chloroplast', NULL, 'uS7_Chloroplast', NULL, NULL, NULL, 2),
(8856, NULL, 'cd01052', NULL, NULL, 'DPSL', NULL, 'DPSL', NULL, NULL, 31225, 2),
(8857, NULL, 'cd11569', NULL, NULL, 'FAT-like_BCAR1_C', NULL, 'FAT-like_BCAR1_C', NULL, NULL, NULL, 2),
(8858, NULL, 'cd07245', NULL, NULL, 'VOC_like', NULL, 'VOC_like', NULL, NULL, NULL, 2),
(8859, NULL, 'cd00244', NULL, NULL, 'AlgLyase', NULL, 'AlgLyase', NULL, NULL, 16636, 2),
(8860, NULL, 'cd08810', NULL, NULL, 'CARD_BCL10', NULL, 'CARD_BCL10', NULL, NULL, 33771, 2),
(8861, NULL, 'cd06061', NULL, NULL, 'PurM-like1', NULL, 'PurM-like1', NULL, NULL, NULL, 2),
(8862, NULL, 'cd01343', NULL, NULL, 'PL1_Passenger_AT', NULL, 'PL1_Passenger_AT', NULL, NULL, NULL, 2),
(8863, NULL, 'cd02339', NULL, NULL, 'ZZ_Mind_bomb', NULL, 'ZZ_Mind_bomb', NULL, NULL, 31495, 2),
(8864, NULL, 'cd06291', NULL, NULL, 'PBP1_Qymf-like', NULL, 'PBP1_Qymf-like', NULL, NULL, NULL, 2),
(8865, NULL, 'cd00481', NULL, NULL, 'Ribosomal_L19e', NULL, 'Ribosomal_L19e', NULL, NULL, NULL, 2),
(8866, NULL, 'cd04121', NULL, NULL, 'Rab40', NULL, 'Rab40', NULL, NULL, NULL, 2),
(8867, NULL, 'cd01569', NULL, NULL, 'PBEF_like', NULL, 'PBEF_like', NULL, NULL, 15118, 2),
(8868, NULL, 'cd05530', NULL, NULL, 'POLBc_B1', NULL, 'POLBc_B1', NULL, NULL, NULL, 2),
(8869, NULL, 'cd05494', NULL, NULL, 'Bromodomain_1', NULL, 'Bromodomain_1', NULL, NULL, NULL, 2),
(8870, NULL, 'cd05732', NULL, NULL, 'Ig_NCAM-1_like', NULL, 'Ig_NCAM-1_like', NULL, NULL, NULL, 2),
(8871, NULL, 'cd03367', NULL, NULL, 'Ribosomal_S23', NULL, 'Ribosomal_S23', NULL, NULL, 3722, 2),
(8872, NULL, 'cd10298', NULL, NULL, 'GST_C_CLIC2', NULL, 'GST_C_CLIC2', NULL, NULL, NULL, 2),
(8873, NULL, 'cd15278', NULL, NULL, '7tmC_RAIG2_GPRC5B', NULL, '7tmC_RAIG2_GPRC5B', NULL, NULL, NULL, 2),
(8874, NULL, 'cd13831', NULL, NULL, 'HU', NULL, 'HU', NULL, NULL, NULL, 2),
(8875, NULL, 'cd15350', NULL, NULL, '7tmA_MC2R_ACTH_R', NULL, '7tmA_MC2R_ACTH_R', NULL, NULL, NULL, 2),
(8876, NULL, 'cd13423', NULL, NULL, 'TNFRSF6_teleost', NULL, 'TNFRSF6_teleost', NULL, NULL, 14305, 2),
(8877, NULL, 'cd00504', NULL, NULL, 'GXGXG', NULL, 'GXGXG', NULL, NULL, NULL, 2),
(8878, NULL, 'cd13903', NULL, NULL, 'CuRO_3_Tv-LCC_like', NULL, 'CuRO_3_Tv-LCC_like', NULL, NULL, NULL, 2),
(8879, NULL, 'cd15437', NULL, NULL, '7tmB2_ETL', NULL, '7tmB2_ETL', NULL, NULL, NULL, 2),
(8880, NULL, 'cd09361', NULL, NULL, 'LIM1_Enigma_like', NULL, 'LIM1_Enigma_like', NULL, NULL, NULL, 2),
(8881, NULL, 'cd15263', NULL, NULL, '7tmB1_DH_R', NULL, '7tmB1_DH_R', NULL, NULL, NULL, 2),
(8882, NULL, 'cd21401', NULL, NULL, 'ZBD_cv_Nsp13-like', NULL, 'ZBD_cv_Nsp13-like', NULL, NULL, 24222, 2),
(8883, NULL, 'cd17051', NULL, NULL, 'Ubl2_ANKUB1', NULL, 'Ubl2_ANKUB1', NULL, NULL, NULL, 2),
(8884, NULL, 'cd18138', NULL, NULL, 'HLD_clamp_pol_III_delta', NULL, 'HLD_clamp_pol_III_delta', NULL, NULL, NULL, 2),
(8885, NULL, 'cd03598', NULL, NULL, 'CLECT_EMBP_like', NULL, 'CLECT_EMBP_like', NULL, NULL, 29733, 2),
(8886, NULL, 'cd01085', NULL, NULL, 'APP', NULL, 'APP', NULL, NULL, 30548, 2),
(8887, NULL, 'cd10342', NULL, NULL, 'SH2_SAP1', NULL, 'SH2_SAP1', NULL, NULL, 9158, 2),
(8888, NULL, 'cd17143', NULL, NULL, 'DCX2_DCLK1', NULL, 'DCX2_DCLK1', NULL, NULL, NULL, 2),
(8889, NULL, 'cd16206', NULL, NULL, 'EFh_PRIP', NULL, 'EFh_PRIP', NULL, NULL, NULL, 2),
(8890, NULL, 'cd20259', NULL, NULL, 'pgc', NULL, 'pgc', NULL, NULL, NULL, 2),
(8891, NULL, 'cd19143', NULL, NULL, 'AKR_AKR6C1_2', NULL, 'AKR_AKR6C1_2', NULL, NULL, NULL, 2),
(8892, NULL, 'cd04630', NULL, NULL, 'CBS_pair_bac', NULL, 'CBS_pair_bac', NULL, NULL, NULL, 2),
(8893, NULL, 'cd13958', NULL, NULL, 'PT_UbiA_chlorophyll', NULL, 'PT_UbiA_chlorophyll', NULL, NULL, 5538, 2),
(8894, NULL, 'cd01287', NULL, NULL, 'FabA', NULL, 'FabA', NULL, NULL, 2099, 2);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(8895, NULL, 'cd10350', NULL, NULL, 'SH2_SH2D4A', NULL, 'SH2_SH2D4A', NULL, NULL, NULL, 2),
(8896, NULL, 'cd14064', NULL, NULL, 'PKc_TNNI3K', NULL, 'PKc_TNNI3K', NULL, NULL, NULL, 2),
(8897, NULL, 'cd02764', NULL, NULL, 'MopB_PHLH', NULL, 'MopB_PHLH', NULL, NULL, NULL, 2),
(8898, NULL, 'cd06490', NULL, NULL, 'p23_NCB5OR', NULL, 'p23_NCB5OR', NULL, NULL, 28679, 2),
(8899, NULL, 'cd14208', NULL, NULL, 'PTK_Jak3_rpt1', NULL, 'PTK_Jak3_rpt1', NULL, NULL, NULL, 2),
(8900, NULL, 'cd20485', NULL, NULL, 'USP25_USP28_C-like', NULL, 'USP25_USP28_C-like', NULL, NULL, NULL, 2),
(8901, NULL, 'cd11717', NULL, NULL, 'THUMP_THUMPD1_like', NULL, 'THUMP_THUMPD1_like', NULL, NULL, 33466, 2),
(8902, NULL, 'cd05401', NULL, NULL, 'NT_GlnE_GlnD_like', NULL, 'NT_GlnE_GlnD_like', NULL, NULL, NULL, 2),
(8903, NULL, 'cd21529', NULL, NULL, 'CoV_M', NULL, 'CoV_M', NULL, NULL, NULL, 2),
(8904, NULL, 'cd07092', NULL, NULL, 'ALDH_ABALDH-YdcW', NULL, 'ALDH_ABALDH-YdcW', NULL, NULL, 17990, 2),
(8905, NULL, 'cd07827', NULL, NULL, 'RHD-n', NULL, 'RHD-n', NULL, NULL, NULL, 2),
(8906, NULL, 'cd16113', NULL, NULL, 'DCX2_DCDC2_like', NULL, 'DCX2_DCDC2_like', NULL, NULL, NULL, 2),
(8907, NULL, 'cd14248', NULL, NULL, 'ESP', NULL, 'ESP', NULL, NULL, NULL, 2),
(8908, NULL, 'cd10162', NULL, NULL, 'ClassIIa_HDAC4_Gln-rich-N', NULL, 'ClassIIa_HDAC4_Gln-rich-N', NULL, NULL, NULL, 2),
(8909, NULL, 'cd14023', NULL, NULL, 'PK_TRB1', NULL, 'PK_TRB1', NULL, NULL, NULL, 2),
(8910, NULL, 'cd03498', NULL, NULL, 'SQR_TypeB_2_TM', NULL, 'SQR_TypeB_2_TM', NULL, NULL, NULL, 2),
(8911, NULL, 'cd15610', NULL, NULL, 'PHD3_KDM5A_like', NULL, 'PHD3_KDM5A_like', NULL, NULL, NULL, 2),
(8912, NULL, 'cd13212', NULL, NULL, 'PH-GRAM_MTMR10-like', NULL, 'PH-GRAM_MTMR10-like', NULL, NULL, NULL, 2),
(8913, NULL, 'cd21166', NULL, NULL, 'NTD_av_Nsp11-like', NULL, 'NTD_av_Nsp11-like', NULL, NULL, 35334, 2),
(8914, NULL, 'cd02762', NULL, NULL, 'MopB_1', NULL, 'MopB_1', NULL, NULL, NULL, 2),
(8915, NULL, 'cd06986', NULL, NULL, 'cupin_MmsR-like_N', NULL, 'cupin_MmsR-like_N', NULL, NULL, NULL, 2),
(8916, NULL, 'cd17321', NULL, NULL, 'MFS_MMR_MDR_like', NULL, 'MFS_MMR_MDR_like', NULL, NULL, NULL, 2),
(8917, NULL, 'cd02773', NULL, NULL, 'MopB_Res-Cmplx1_Nad11', NULL, 'MopB_Res-Cmplx1_Nad11', NULL, NULL, NULL, 2),
(8918, NULL, 'cd02523', NULL, NULL, 'PC_cytidylyltransferase', NULL, 'PC_cytidylyltransferase', NULL, NULL, NULL, 2),
(8919, NULL, 'cd03818', NULL, NULL, 'GT4_ExpC-like', NULL, 'GT4_ExpC-like', NULL, NULL, NULL, 2),
(8920, NULL, 'cd19362', NULL, NULL, 'TenA_C_SsTenA-1-like', NULL, 'TenA_C_SsTenA-1-like', NULL, NULL, NULL, 2),
(8921, NULL, 'cd08548', NULL, NULL, 'Type_I_cohesin_like', NULL, 'Type_I_cohesin_like', NULL, NULL, NULL, 2),
(8922, NULL, 'cd12954', NULL, NULL, 'MMP_TTHA0227_like_1', NULL, 'MMP_TTHA0227_like_1', NULL, NULL, NULL, 2),
(8923, NULL, 'cd04018', NULL, NULL, 'C2C_Ferlin', NULL, 'C2C_Ferlin', NULL, NULL, 31557, 2),
(8924, NULL, 'cd03036', NULL, NULL, 'ArsC_like', NULL, 'ArsC_like', NULL, NULL, NULL, 2),
(8925, NULL, 'cd04104', NULL, NULL, 'p47_IIGP_like', NULL, 'p47_IIGP_like', NULL, NULL, NULL, 2),
(8926, NULL, 'cd05971', NULL, NULL, 'MACS_like_3', NULL, 'MACS_like_3', NULL, NULL, NULL, 2),
(8927, NULL, 'cd15750', NULL, NULL, 'FYVE_CARP', NULL, 'FYVE_CARP', NULL, NULL, NULL, 2),
(8928, NULL, 'cd09985', NULL, NULL, 'LOTUS_1_TDRD5', NULL, 'LOTUS_1_TDRD5', NULL, NULL, NULL, 2),
(8929, NULL, 'cd03082', NULL, NULL, 'TRX_Fd_NuoE_W_FDH_beta', NULL, 'TRX_Fd_NuoE_W_FDH_beta', NULL, NULL, NULL, 2),
(8930, NULL, 'cd17324', NULL, NULL, 'MFS_NepI_like', NULL, 'MFS_NepI_like', NULL, NULL, NULL, 2),
(8931, NULL, 'cd16717', NULL, NULL, 'vRING-HC_IRF2BPL', NULL, 'vRING-HC_IRF2BPL', NULL, NULL, NULL, 2),
(8932, NULL, 'cd12482', NULL, NULL, 'RRM1_hnRNPR', NULL, 'RRM1_hnRNPR', NULL, NULL, NULL, 2),
(8933, NULL, 'cd18283', NULL, NULL, 'BTB1_POZ_BTBD7', NULL, 'BTB1_POZ_BTBD7', NULL, NULL, NULL, 2),
(8934, NULL, 'cd18332', NULL, NULL, 'BTB_POZ_ZBTB28_BCL6B', NULL, 'BTB_POZ_ZBTB28_BCL6B', NULL, NULL, NULL, 2),
(8935, NULL, 'cd16075', NULL, NULL, 'ORC6_CTD', NULL, 'ORC6_CTD', NULL, NULL, NULL, 2);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(8936, NULL, 'cd12711', NULL, NULL, 'RRM_TNRC6A', NULL, 'RRM_TNRC6A', NULL, NULL, 11321, 2),
(8937, NULL, 'cd19816', NULL, NULL, 'Bbox1_CYLD', NULL, 'Bbox1_CYLD', NULL, NULL, NULL, 2),
(8938, NULL, 'cd01163', NULL, NULL, 'DszC', NULL, 'DszC', NULL, NULL, NULL, 2),
(8939, NULL, 'cd01515', NULL, NULL, 'Arch_FBPase_1', NULL, 'Arch_FBPase_1', NULL, NULL, NULL, 2),
(8940, NULL, 'cd07649', NULL, NULL, 'F-BAR_GAS7', NULL, 'F-BAR_GAS7', NULL, NULL, 28168, 2),
(8941, NULL, 'cd09211', NULL, NULL, 'Lumazine_synthase_archaeal', NULL, 'Lumazine_synthase_archaeal', NULL, NULL, NULL, 2),
(8942, NULL, 'cd08070', NULL, NULL, 'MPN_like', NULL, 'MPN_like', NULL, NULL, NULL, 2),
(8943, NULL, 'cd08519', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_20', NULL, 'PBP2_NikA_DppA_OppA_like_20', NULL, NULL, NULL, 2),
(8944, NULL, 'cd13278', NULL, NULL, 'PH_Bud4', NULL, 'PH_Bud4', NULL, NULL, NULL, 2),
(8945, NULL, 'cd14493', NULL, NULL, 'lipocalin_MxiM', NULL, 'lipocalin_MxiM', NULL, NULL, NULL, 2),
(8946, NULL, 'cd11321', NULL, NULL, 'AmyAc_bac_euk_BE', NULL, 'AmyAc_bac_euk_BE', NULL, NULL, NULL, 2),
(8947, NULL, 'cd02540', NULL, NULL, 'GT2_GlmU_N_bac', NULL, 'GT2_GlmU_N_bac', NULL, NULL, NULL, 2),
(8948, NULL, 'cd09892', NULL, NULL, 'NGN_SP_RfaH', NULL, 'NGN_SP_RfaH', NULL, NULL, NULL, 2),
(8949, NULL, 'cd00092', NULL, NULL, 'HTH_CRP', NULL, 'HTH_CRP', NULL, NULL, NULL, 2),
(8950, NULL, 'cd07911', NULL, NULL, 'RNRR2_Rv0233_like', NULL, 'RNRR2_Rv0233_like', NULL, NULL, 27651, 2),
(8951, NULL, 'cd03311', NULL, NULL, 'CIMS_C_terminal_like', NULL, 'CIMS_C_terminal_like', NULL, NULL, 2818, 2),
(8952, NULL, 'cd19543', NULL, NULL, 'DCL_NRPS', NULL, 'DCL_NRPS', NULL, NULL, NULL, 2),
(8953, NULL, 'cd18310', NULL, NULL, 'BTB_POZ_NPR_plant', NULL, 'BTB_POZ_NPR_plant', NULL, NULL, NULL, 2),
(8954, NULL, 'cd18542', NULL, NULL, 'ABC_6TM_YknU_like', NULL, 'ABC_6TM_YknU_like', NULL, NULL, NULL, 2),
(8955, NULL, 'cd08014', NULL, NULL, 'M20_Acy1-like', NULL, 'M20_Acy1-like', NULL, NULL, NULL, 2),
(8956, NULL, 'cd14671', NULL, NULL, 'PAAR_like', NULL, 'PAAR_like', NULL, NULL, NULL, 2),
(8957, NULL, 'cd07123', NULL, NULL, 'ALDH_F4-17_P5CDH', NULL, 'ALDH_F4-17_P5CDH', NULL, NULL, 368, 2),
(8958, NULL, 'cd07579', NULL, NULL, 'nitrilase_1_R2', NULL, 'nitrilase_1_R2', NULL, NULL, NULL, 2),
(8959, NULL, 'cd10535', NULL, NULL, 'SET_EHMT1', NULL, 'SET_EHMT1', NULL, NULL, NULL, 2),
(8960, NULL, 'cd18770', NULL, NULL, 'PIN_Mut7-C-like', NULL, 'PIN_Mut7-C-like', NULL, NULL, NULL, 2),
(8961, NULL, 'cd03801', NULL, NULL, 'GT4_PimA-like', NULL, 'GT4_PimA-like', NULL, NULL, NULL, 2),
(8962, NULL, 'cd13230', NULL, NULL, 'PH1_SSRP1-like', NULL, 'PH1_SSRP1-like', NULL, NULL, NULL, 2),
(8963, NULL, 'cd00439', NULL, NULL, 'Transaldolase', NULL, 'Transaldolase', NULL, NULL, NULL, 2),
(8964, NULL, 'cd16583', NULL, NULL, 'RING-HC_TRIM40-C-V', NULL, 'RING-HC_TRIM40-C-V', NULL, NULL, NULL, 2),
(8965, NULL, 'cd06259', NULL, NULL, 'YdcF-like', NULL, 'YdcF-like', NULL, NULL, 3294, 2),
(8966, NULL, 'cd08534', NULL, NULL, 'SAM_PNT-GABP-alpha', NULL, 'SAM_PNT-GABP-alpha', NULL, NULL, NULL, 2),
(8967, NULL, 'cd19121', NULL, NULL, 'AKR_AKR3D1', NULL, 'AKR_AKR3D1', NULL, NULL, 34671, 2),
(8968, NULL, 'cd08219', NULL, NULL, 'STKc_Nek3', NULL, 'STKc_Nek3', NULL, NULL, NULL, 2),
(8969, NULL, 'cd18580', NULL, NULL, 'ABC_6TM_ABCC_D2', NULL, 'ABC_6TM_ABCC_D2', NULL, NULL, 34664, 2),
(8970, NULL, 'cd07542', NULL, NULL, 'P-type_ATPase_cation', NULL, 'P-type_ATPase_cation', NULL, NULL, NULL, 2),
(8971, NULL, 'cd01028', NULL, NULL, 'TOPRIM_TopoIA', NULL, 'TOPRIM_TopoIA', NULL, NULL, NULL, 2),
(8972, NULL, 'cd04638', NULL, NULL, 'CBS_pair_arch2_repeat1', NULL, 'CBS_pair_arch2_repeat1', NULL, NULL, NULL, 2),
(8973, NULL, 'cd06943', NULL, NULL, 'NR_LBD_RXR_like', NULL, 'NR_LBD_RXR_like', NULL, NULL, NULL, 2),
(8974, NULL, 'cd07769', NULL, NULL, 'FGGY_GK', NULL, 'FGGY_GK', NULL, NULL, NULL, 2),
(8975, NULL, 'cd12146', NULL, NULL, 'STING_C', NULL, 'STING_C', NULL, NULL, 32587, 2),
(8976, NULL, 'cd13291', NULL, NULL, 'PH_ORP10_ORP11', NULL, 'PH_ORP10_ORP11', NULL, NULL, NULL, 2),
(8977, NULL, 'cd12290', NULL, NULL, 'RRM1_LARP7', NULL, 'RRM1_LARP7', NULL, NULL, 10701, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(8978, NULL, 'cd04687', NULL, NULL, 'Nudix_Hydrolase_28', NULL, 'Nudix_Hydrolase_28', NULL, NULL, NULL, 2),
(8979, NULL, 'cd05919', NULL, NULL, 'BCL_like', NULL, 'BCL_like', NULL, NULL, NULL, 2),
(8980, NULL, 'cd14253', NULL, NULL, 'Dockerin', NULL, 'Dockerin', NULL, NULL, NULL, 2),
(8981, NULL, 'cd02197', NULL, NULL, 'HypE', NULL, 'HypE', NULL, NULL, 13712, 2),
(8982, NULL, 'cd17278', NULL, NULL, 'RMtype1_S_LdeBORF1052P-TRD2-CR2', NULL, 'RMtype1_S_LdeBORF1052P-TRD2-CR2', NULL, NULL, NULL, 2),
(8983, NULL, 'cd02068', NULL, NULL, 'radical_SAM_B12_BD', NULL, 'radical_SAM_B12_BD', NULL, NULL, NULL, 2),
(8984, NULL, 'cd11967', NULL, NULL, 'SH3_SASH1', NULL, 'SH3_SASH1', NULL, NULL, 31330, 2),
(8985, NULL, 'cd14811', NULL, NULL, 'bZIP_u2', NULL, 'bZIP_u2', NULL, NULL, NULL, 2),
(8986, NULL, 'cd15141', NULL, NULL, '7tmA_PGI2', NULL, '7tmA_PGI2', NULL, NULL, NULL, 2),
(8987, NULL, 'cd08863', NULL, NULL, 'SRPBCC_DUF1857', NULL, 'SRPBCC_DUF1857', NULL, NULL, NULL, 2),
(8988, NULL, 'cd11989', NULL, NULL, 'SH3_Intersectin1_2', NULL, 'SH3_Intersectin1_2', NULL, NULL, NULL, 2),
(8989, NULL, 'cd18895', NULL, NULL, 'TET1', NULL, 'TET1', NULL, NULL, NULL, 2),
(8990, NULL, 'cd12806', NULL, NULL, 'Esterase_713_like', NULL, 'Esterase_713_like', NULL, NULL, NULL, 2),
(8991, NULL, 'cd16967', NULL, NULL, 'Alpha_kinase_eEF2K', NULL, 'Alpha_kinase_eEF2K', NULL, NULL, NULL, 2),
(8992, NULL, 'cd14484', NULL, NULL, 'SPX_GDE1_like', NULL, 'SPX_GDE1_like', NULL, NULL, NULL, 2),
(8993, NULL, 'cd11647', NULL, NULL, 'DHP5_DphB', NULL, 'DHP5_DphB', NULL, NULL, 977, 2),
(8994, NULL, 'cd17906', NULL, NULL, 'CheX', NULL, 'CheX', NULL, NULL, NULL, 2),
(8995, NULL, 'cd18506', NULL, NULL, 'BACK2_LZTR1', NULL, 'BACK2_LZTR1', NULL, NULL, NULL, 2),
(8996, NULL, 'cd11794', NULL, NULL, 'SH3_DNMBP_N1', NULL, 'SH3_DNMBP_N1', NULL, NULL, 28642, 2),
(8997, NULL, 'cd05119', NULL, NULL, 'RIO', NULL, 'RIO', NULL, NULL, NULL, 2),
(8998, NULL, 'cd11330', NULL, NULL, 'AmyAc_OligoGlu', NULL, 'AmyAc_OligoGlu', NULL, NULL, NULL, 2),
(8999, NULL, 'cd16015', NULL, NULL, 'LTA_synthase', NULL, 'LTA_synthase', NULL, NULL, NULL, 2),
(9000, NULL, 'cd03561', NULL, NULL, 'VHS', NULL, 'VHS', NULL, NULL, NULL, 2),
(9001, NULL, 'cd02509', NULL, NULL, 'GDP-M1P_Guanylyltransferase', NULL, 'GDP-M1P_Guanylyltransferase', NULL, NULL, NULL, 2),
(9002, NULL, 'cd09301', NULL, NULL, 'HDAC', NULL, 'HDAC', NULL, NULL, NULL, 2),
(9003, NULL, 'sd00046', NULL, NULL, 'FHA_bHelix', NULL, 'FHA_bHelix', NULL, NULL, NULL, 2),
(9004, NULL, 'cd16357', NULL, NULL, 'GLOD4_C', NULL, 'GLOD4_C', NULL, NULL, 34715, 2),
(9005, NULL, 'cd19967', NULL, NULL, 'PBP1_TmRBP-like', NULL, 'PBP1_TmRBP-like', NULL, NULL, NULL, 2),
(9006, NULL, 'cd20760', NULL, NULL, 'capping_2-OMTase_Mimiviridae', NULL, 'capping_2-OMTase_Mimiviridae', NULL, NULL, NULL, 2),
(9007, NULL, 'cd10460', NULL, NULL, 'PUB_UBXD1', NULL, 'PUB_UBXD1', NULL, NULL, 35668, 2),
(9008, NULL, 'cd18050', NULL, NULL, 'DEADc_DDX17', NULL, 'DEADc_DDX17', NULL, NULL, 37726, 2),
(9009, NULL, 'cd19146', NULL, NULL, 'AKR_AKR9A1-2', NULL, 'AKR_AKR9A1-2', NULL, NULL, NULL, 2),
(9010, NULL, 'cd14860', NULL, NULL, '4HBD_NAD', NULL, '4HBD_NAD', NULL, NULL, NULL, 2),
(9011, NULL, 'cd10912', NULL, NULL, 'PIN_YacP-like', NULL, 'PIN_YacP-like', NULL, NULL, NULL, 2),
(9012, NULL, 'cd13712', NULL, NULL, 'PBP2_FliY', NULL, 'PBP2_FliY', NULL, NULL, NULL, 2),
(9013, NULL, 'cd06948', NULL, NULL, 'NR_LBD_COUP-TF', NULL, 'NR_LBD_COUP-TF', NULL, NULL, NULL, 2),
(9014, NULL, 'cd15720', NULL, NULL, 'FYVE_Hrs', NULL, 'FYVE_Hrs', NULL, NULL, NULL, 2),
(9015, NULL, 'cd17013', NULL, NULL, 'ANTH_N_HIP1', NULL, 'ANTH_N_HIP1', NULL, NULL, NULL, 2),
(9016, NULL, 'cd18718', NULL, NULL, 'PIN_PRORP', NULL, 'PIN_PRORP', NULL, NULL, NULL, 2),
(9017, NULL, 'cd15206', NULL, NULL, '7tmA_CCK_R', NULL, '7tmA_CCK_R', NULL, NULL, NULL, 2),
(9018, NULL, 'cd00242', NULL, NULL, 'Ecotin', NULL, 'Ecotin', NULL, NULL, 15797, 2),
(9019, NULL, 'cd06123', NULL, NULL, 'cupin_HAO', NULL, 'cupin_HAO', NULL, NULL, 8899, 2),
(9020, NULL, 'cd19983', NULL, NULL, 'PBP1_ABC_HAAT-like', NULL, 'PBP1_ABC_HAAT-like', NULL, NULL, NULL, 2);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(9021, NULL, 'cd21343', NULL, NULL, 'ZBD_UPF1_nv_SF1_Hel-like', NULL, 'ZBD_UPF1_nv_SF1_Hel-like', NULL, NULL, NULL, 2),
(9022, NULL, 'cd07598', NULL, NULL, 'BAR_FAM92', NULL, 'BAR_FAM92', NULL, NULL, 32807, 2),
(9023, NULL, 'cd16566', NULL, NULL, 'RING-HC_RSPRY1', NULL, 'RING-HC_RSPRY1', NULL, NULL, NULL, 2),
(9024, NULL, 'cd19081', NULL, NULL, 'AKR_AKR9C1', NULL, 'AKR_AKR9C1', NULL, NULL, NULL, 2),
(9025, NULL, 'cd05510', NULL, NULL, 'Bromo_SPT7_like', NULL, 'Bromo_SPT7_like', NULL, NULL, NULL, 2),
(9026, NULL, 'cd06544', NULL, NULL, 'GH18_narbonin', NULL, 'GH18_narbonin', NULL, NULL, NULL, 2),
(9027, NULL, 'cd02956', NULL, NULL, 'ybbN', NULL, 'ybbN', NULL, NULL, NULL, 2),
(9028, NULL, 'cd17958', NULL, NULL, 'DEADc_DDX43_DDX53', NULL, 'DEADc_DDX43_DDX53', NULL, NULL, NULL, 2),
(9029, NULL, 'cd11830', NULL, NULL, 'SH3_VAV_2', NULL, 'SH3_VAV_2', NULL, NULL, NULL, 2),
(9030, NULL, 'cd07567', NULL, NULL, 'biotinidase_like', NULL, 'biotinidase_like', NULL, NULL, 12960, 2),
(9031, NULL, 'cd10321', NULL, NULL, 'RNase_Ire1_like', NULL, 'RNase_Ire1_like', NULL, NULL, NULL, 2),
(9032, NULL, 'cd13125', NULL, NULL, 'MATE_like_10', NULL, 'MATE_like_10', NULL, NULL, 35723, 2),
(9033, NULL, 'cd15962', NULL, NULL, '7tmA_GPR6', NULL, '7tmA_GPR6', NULL, NULL, NULL, 2),
(9034, NULL, 'cd17734', NULL, NULL, 'BRCT_Bard1_rpt1', NULL, 'BRCT_Bard1_rpt1', NULL, NULL, NULL, 2),
(9035, NULL, 'cd19414', NULL, NULL, 'lipocalin_1_3_4_13-like', NULL, 'lipocalin_1_3_4_13-like', NULL, NULL, NULL, 2),
(9036, NULL, 'cd13531', NULL, NULL, 'PBP2_MxaJ', NULL, 'PBP2_MxaJ', NULL, NULL, NULL, 2),
(9037, NULL, 'cd05923', NULL, NULL, 'CBAL', NULL, 'CBAL', NULL, NULL, NULL, 2),
(9038, NULL, 'cd04684', NULL, NULL, 'Nudix_Hydrolase_25', NULL, 'Nudix_Hydrolase_25', NULL, NULL, NULL, 2),
(9039, NULL, 'cd01385', NULL, NULL, 'MYSc_Myo9', NULL, 'MYSc_Myo9', NULL, NULL, 29921, 2),
(9040, NULL, 'cd03450', NULL, NULL, 'NodN', NULL, 'NodN', NULL, NULL, 33181, 2),
(9041, NULL, 'cd00870', NULL, NULL, 'PI3Ka_III', NULL, 'PI3Ka_III', NULL, NULL, NULL, 2),
(9042, NULL, 'cd16348', NULL, NULL, 'VOC_YdcJ_like', NULL, 'VOC_YdcJ_like', NULL, NULL, 12816, 2),
(9043, NULL, 'cd08379', NULL, NULL, 'C2D_MCTP_PRT_plant', NULL, 'C2D_MCTP_PRT_plant', NULL, NULL, NULL, 2),
(9044, NULL, 'cd02221', NULL, NULL, 'cupin_TM1287-like', NULL, 'cupin_TM1287-like', NULL, NULL, NULL, 2),
(9045, NULL, 'cd17575', NULL, NULL, 'REC_WspR-like', NULL, 'REC_WspR-like', NULL, NULL, NULL, 2),
(9046, NULL, 'cd06830', NULL, NULL, 'PLPDE_III_ADC', NULL, 'PLPDE_III_ADC', NULL, NULL, 7168, 2),
(9047, NULL, 'cd07483', NULL, NULL, 'Peptidases_S8_Subtilisin_Novo-like', NULL, 'Peptidases_S8_Subtilisin_Novo-like', NULL, NULL, 9602, 2),
(9048, NULL, 'cd13744', NULL, NULL, 'SPRY_PRY_TRIM62', NULL, 'SPRY_PRY_TRIM62', NULL, NULL, 32062, 2),
(9049, NULL, 'cd05360', NULL, NULL, 'SDR_c3', NULL, 'SDR_c3', NULL, NULL, NULL, 2),
(9050, NULL, 'cd05730', NULL, NULL, 'Ig3_NCAM-1_like', NULL, 'Ig3_NCAM-1_like', NULL, NULL, NULL, 2),
(9051, NULL, 'cd17918', NULL, NULL, 'DEXHc_RecG', NULL, 'DEXHc_RecG', NULL, NULL, NULL, 2),
(9052, NULL, 'cd21163', NULL, NULL, 'M_cv_Nsp15-NTD_av_Nsp11-like', NULL, 'M_cv_Nsp15-NTD_av_Nsp11-like', NULL, NULL, NULL, 2),
(9053, NULL, 'cd07831', NULL, NULL, 'STKc_MOK', NULL, 'STKc_MOK', NULL, NULL, NULL, 2),
(9054, NULL, 'cd08790', NULL, NULL, 'DED_DEDD', NULL, 'DED_DEDD', NULL, NULL, NULL, 2),
(9055, NULL, 'cd09259', NULL, NULL, 'AP-1_Mu1B_Cterm', NULL, 'AP-1_Mu1B_Cterm', NULL, NULL, NULL, 2),
(9056, NULL, 'cd09439', NULL, NULL, 'LIM_Mical', NULL, 'LIM_Mical', NULL, NULL, NULL, 2),
(9057, NULL, 'cd00194', NULL, NULL, 'UBA_like_SF', NULL, 'UBA_like_SF', NULL, NULL, NULL, 2),
(9058, NULL, 'cd10545', NULL, NULL, 'SET_AtSUVH-like', NULL, 'SET_AtSUVH-like', NULL, NULL, NULL, 2),
(9059, NULL, 'cd09911', NULL, NULL, 'Lin0431_like', NULL, 'Lin0431_like', NULL, NULL, NULL, 2),
(9060, NULL, 'cd16240', NULL, NULL, 'EFh_SPARC_SMOC1', NULL, 'EFh_SPARC_SMOC1', NULL, NULL, 32399, 2),
(9061, NULL, 'cd20228', NULL, NULL, 'PFM_TDP-like', NULL, 'PFM_TDP-like', NULL, NULL, NULL, 2),
(9062, NULL, 'cd05293', NULL, NULL, 'LDH_1', NULL, 'LDH_1', NULL, NULL, NULL, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(9063, NULL, 'cd11474', NULL, NULL, 'SLC5sbd_CHT', NULL, 'SLC5sbd_CHT', NULL, NULL, NULL, 2),
(9064, NULL, 'cd13885', NULL, NULL, 'CuRO_2_CumA_like', NULL, 'CuRO_2_CumA_like', NULL, NULL, NULL, 2),
(9065, NULL, 'cd19073', NULL, NULL, 'AKR_AKR3F2_3', NULL, 'AKR_AKR3F2_3', NULL, NULL, NULL, 2),
(9066, NULL, 'cd12388', NULL, NULL, 'RRM1_RAVER', NULL, 'RRM1_RAVER', NULL, NULL, NULL, 2),
(9067, NULL, 'cd01722', NULL, NULL, 'Sm_F', NULL, 'Sm_F', NULL, NULL, 11161, 2),
(9068, NULL, 'cd02007', NULL, NULL, 'TPP_DXS', NULL, 'TPP_DXS', NULL, NULL, 786, 2),
(9069, NULL, 'cd05067', NULL, NULL, 'PTKc_Lck_Blk', NULL, 'PTKc_Lck_Blk', NULL, NULL, NULL, 2),
(9070, NULL, 'cd07288', NULL, NULL, 'PX_SNX15', NULL, 'PX_SNX15', NULL, NULL, NULL, 2),
(9071, NULL, 'cd13625', NULL, NULL, 'PBP2_AA_binding_like_1', NULL, 'PBP2_AA_binding_like_1', NULL, NULL, NULL, 2),
(9072, NULL, 'cd12264', NULL, NULL, 'RRM_AKAP17A', NULL, 'RRM_AKAP17A', NULL, NULL, NULL, 2),
(9073, NULL, 'cd16821', NULL, NULL, 'SP-RING_PIAS4', NULL, 'SP-RING_PIAS4', NULL, NULL, NULL, 2),
(9074, NULL, 'cd05490', NULL, NULL, 'Cathepsin_D2', NULL, 'Cathepsin_D2', NULL, NULL, 8120, 2),
(9075, NULL, 'cd16543', NULL, NULL, 'RING-HC_RNF135_like', NULL, 'RING-HC_RNF135_like', NULL, NULL, NULL, 2),
(9076, NULL, 'cd12485', NULL, NULL, 'RRM1_RBM47', NULL, 'RRM1_RBM47', NULL, NULL, NULL, 2),
(9077, NULL, 'cd17331', NULL, NULL, 'MFS_SLC22A18', NULL, 'MFS_SLC22A18', NULL, NULL, NULL, 2),
(9078, NULL, 'cd04647', NULL, NULL, 'LbH_MAT_like', NULL, 'LbH_MAT_like', NULL, NULL, NULL, 2),
(9079, NULL, 'cd08501', NULL, NULL, 'PBP2_Lpqw', NULL, 'PBP2_Lpqw', NULL, NULL, NULL, 2),
(9080, NULL, 'cd04908', NULL, NULL, 'ACT_Bt0572_1', NULL, 'ACT_Bt0572_1', NULL, NULL, NULL, 2),
(9081, NULL, 'cd16803', NULL, NULL, 'RING-H2_RNF130', NULL, 'RING-H2_RNF130', NULL, NULL, NULL, 2),
(9082, NULL, 'cd04897', NULL, NULL, 'ACT_ACR_3', NULL, 'ACT_ACR_3', NULL, NULL, NULL, 2),
(9083, NULL, 'cd08317', NULL, NULL, 'Death_ank', NULL, 'Death_ank', NULL, NULL, NULL, 2),
(9084, NULL, 'cd09377', NULL, NULL, 'LIM2_Lhx2_Lhx9', NULL, 'LIM2_Lhx2_Lhx9', NULL, NULL, NULL, 2),
(9085, NULL, 'cd13439', NULL, NULL, 'CamS_repeat', NULL, 'CamS_repeat', NULL, NULL, NULL, 2),
(9086, NULL, 'cd16943', NULL, NULL, 'HATPase_AtoS-like', NULL, 'HATPase_AtoS-like', NULL, NULL, NULL, 2),
(9087, NULL, 'cd09372', NULL, NULL, 'LIM2_FBLP-1', NULL, 'LIM2_FBLP-1', NULL, NULL, NULL, 2),
(9088, NULL, 'cd14313', NULL, NULL, 'UBA_II_E2_UBE2K_like', NULL, 'UBA_II_E2_UBE2K_like', NULL, NULL, NULL, 2),
(9089, NULL, 'cd08261', NULL, NULL, 'Zn_ADH7', NULL, 'Zn_ADH7', NULL, NULL, NULL, 2),
(9090, NULL, 'cd00797', NULL, NULL, 'INT_RitB_C_like', NULL, 'INT_RitB_C_like', NULL, NULL, NULL, 2),
(9091, NULL, 'cd05171', NULL, NULL, 'PIKKc_ATM', NULL, 'PIKKc_ATM', NULL, NULL, 34401, 2),
(9092, NULL, 'cd11864', NULL, NULL, 'SH3_PEX13_eumet', NULL, 'SH3_PEX13_eumet', NULL, NULL, NULL, 2),
(9093, NULL, 'cd19801', NULL, NULL, 'Bbox1_MID', NULL, 'Bbox1_MID', NULL, NULL, NULL, 2),
(9094, NULL, 'cd15582', NULL, NULL, 'PHD2_PHF1', NULL, 'PHD2_PHF1', NULL, NULL, NULL, 2),
(9095, NULL, 'cd04795', NULL, NULL, 'SIS', NULL, 'SIS', NULL, NULL, NULL, 2),
(9096, NULL, 'cd01771', NULL, NULL, 'UBX_UBXN3A', NULL, 'UBX_UBXN3A', NULL, NULL, 31056, 2),
(9097, NULL, 'cd08577', NULL, NULL, 'PI-PLCc_GDPD_SF_unchar3', NULL, 'PI-PLCc_GDPD_SF_unchar3', NULL, NULL, 33193, 2),
(9098, NULL, 'cd21402', NULL, NULL, 'ZBD_mv_SF1_Hel-like', NULL, 'ZBD_mv_SF1_Hel-like', NULL, NULL, NULL, 2),
(9099, NULL, 'cd06278', NULL, NULL, 'PBP1_LacI-like', NULL, 'PBP1_LacI-like', NULL, NULL, NULL, 2),
(9100, NULL, 'cd12197', NULL, NULL, 'MARK4_C', NULL, 'MARK4_C', NULL, NULL, NULL, 2),
(9101, NULL, 'cd14483', NULL, NULL, 'SPX_PHO81_NUC-2_like', NULL, 'SPX_PHO81_NUC-2_like', NULL, NULL, NULL, 2),
(9102, NULL, 'cd18312', NULL, NULL, 'BTB_POZ_NPY3-like', NULL, 'BTB_POZ_NPY3-like', NULL, NULL, NULL, 2),
(9103, NULL, 'cd07326', NULL, NULL, 'M56_BlaR1_MecR1_like', NULL, 'M56_BlaR1_MecR1_like', NULL, NULL, NULL, 2),
(9104, NULL, 'cd05088', NULL, NULL, 'PTKc_Tie2', NULL, 'PTKc_Tie2', NULL, NULL, NULL, 2);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(9105, NULL, 'cd16851', NULL, NULL, 'STAT1_CCD', NULL, 'STAT1_CCD', NULL, NULL, NULL, 2),
(9106, NULL, 'cd19714', NULL, NULL, 'bHLH_TS_ATOH7', NULL, 'bHLH_TS_ATOH7', NULL, NULL, NULL, 2),
(9107, NULL, 'cd00183', NULL, NULL, 'TFIIS_I', NULL, 'TFIIS_I', NULL, NULL, NULL, 2),
(9108, NULL, 'cd08168', NULL, NULL, 'Cytochrom_C3', NULL, 'Cytochrom_C3', NULL, NULL, NULL, 2),
(9109, NULL, 'cd16413', NULL, NULL, 'DGQHR_domain', NULL, 'DGQHR_domain', NULL, NULL, NULL, 2),
(9110, NULL, 'cd12348', NULL, NULL, 'RRM1_SHARP', NULL, 'RRM1_SHARP', NULL, NULL, 3780, 2),
(9111, NULL, 'cd12796', NULL, NULL, 'LbR_Ice_bind', NULL, 'LbR_Ice_bind', NULL, NULL, NULL, 2),
(9112, NULL, 'cd02412', NULL, NULL, '30S_S3_KH', NULL, '30S_S3_KH', NULL, NULL, NULL, 2),
(9113, NULL, 'cd08677', NULL, NULL, 'C2A_Synaptotagmin-13', NULL, 'C2A_Synaptotagmin-13', NULL, NULL, NULL, 2),
(9114, NULL, 'cd12032', NULL, NULL, 'SH3_DLG2', NULL, 'SH3_DLG2', NULL, NULL, 30112, 2),
(9115, NULL, 'cd16225', NULL, NULL, 'EFh_CREC_cab45', NULL, 'EFh_CREC_cab45', NULL, NULL, NULL, 2),
(9116, NULL, 'cd12516', NULL, NULL, 'RRM1_RBM26', NULL, 'RRM1_RBM26', NULL, NULL, 9365, 2),
(9117, NULL, 'cd01537', NULL, NULL, 'PBP1_repressor_sugar_binding-like', NULL, 'PBP1_repressor_sugar_binding-like', NULL, NULL, NULL, 2),
(9118, NULL, 'cd18026', NULL, NULL, 'DEXHc_POLQ-like', NULL, 'DEXHc_POLQ-like', NULL, NULL, NULL, 2),
(9119, NULL, 'cd18051', NULL, NULL, 'DEADc_DDX3', NULL, 'DEADc_DDX3', NULL, NULL, NULL, 2),
(9120, NULL, 'cd07130', NULL, NULL, 'ALDH_F7_AASADH', NULL, 'ALDH_F7_AASADH', NULL, NULL, NULL, 2),
(9121, NULL, 'cd10786', NULL, NULL, 'GH38N_AMII_like', NULL, 'GH38N_AMII_like', NULL, NULL, NULL, 2),
(9122, NULL, 'cd11543', NULL, NULL, 'NTP-PPase_u6', NULL, 'NTP-PPase_u6', NULL, NULL, NULL, 2),
(9123, NULL, 'cd19089', NULL, NULL, 'AKR_AKR14A1_2', NULL, 'AKR_AKR14A1_2', NULL, NULL, NULL, 2),
(9124, NULL, 'cd00311', NULL, NULL, 'TIM', NULL, 'TIM', NULL, NULL, 4335, 2),
(9125, NULL, 'cd15662', NULL, NULL, 'ePHD_ATX1_2_like', NULL, 'ePHD_ATX1_2_like', NULL, NULL, 30322, 2),
(9126, NULL, 'cd08395', NULL, NULL, 'C2C_Munc13', NULL, 'C2C_Munc13', NULL, NULL, NULL, 2),
(9127, NULL, 'cd01571', NULL, NULL, 'NAPRTase_B', NULL, 'NAPRTase_B', NULL, NULL, 28874, 2),
(9128, NULL, 'cd01635', NULL, NULL, 'Glycosyltransferase_GTB-type', NULL, 'Glycosyltransferase_GTB-type', NULL, NULL, NULL, 2),
(9129, NULL, 'cd13132', NULL, NULL, 'MATE_eukaryotic', NULL, 'MATE_eukaryotic', NULL, NULL, 36910, 2),
(9130, NULL, 'cd08025', NULL, NULL, 'RNR_PFL_like_DUF711', NULL, 'RNR_PFL_like_DUF711', NULL, NULL, 2365, 2),
(9131, NULL, 'cd16655', NULL, NULL, 'RING-Ubox_WDSUB1_like', NULL, 'RING-Ubox_WDSUB1_like', NULL, NULL, NULL, 2),
(9132, NULL, 'cd11239', NULL, NULL, 'Sema_3', NULL, 'Sema_3', NULL, NULL, NULL, 2),
(9133, NULL, 'cd15450', NULL, NULL, '7tmC_mGluR5', NULL, '7tmC_mGluR5', NULL, NULL, NULL, 2),
(9134, NULL, 'cd12648', NULL, NULL, 'RRM3_UHM_PUF60', NULL, 'RRM3_UHM_PUF60', NULL, NULL, 21158, 2),
(9135, NULL, 'cd02983', NULL, NULL, 'P5_C', NULL, 'P5_C', NULL, NULL, NULL, 2),
(9136, NULL, 'cd20241', NULL, NULL, 'PFM_aerolysin-like', NULL, 'PFM_aerolysin-like', NULL, NULL, NULL, 2),
(9137, NULL, 'cd18599', NULL, NULL, 'ABC_6TM_MRP5_8_9_D2', NULL, 'ABC_6TM_MRP5_8_9_D2', NULL, NULL, NULL, 2),
(9138, NULL, 'cd16853', NULL, NULL, 'STAT3_CCD', NULL, 'STAT3_CCD', NULL, NULL, NULL, 2),
(9139, NULL, 'cd02000', NULL, NULL, 'TPP_E1_PDC_ADC_BCADC', NULL, 'TPP_E1_PDC_ADC_BCADC', NULL, NULL, NULL, 2),
(9140, NULL, 'cd08795', NULL, NULL, 'Death_IRAK2', NULL, 'Death_IRAK2', NULL, NULL, 33777, 2),
(9141, NULL, 'cd09343', NULL, NULL, 'LIM1_FHL', NULL, 'LIM1_FHL', NULL, NULL, NULL, 2),
(9142, NULL, 'cd18530', NULL, NULL, 'BACK_RHOBTB1', NULL, 'BACK_RHOBTB1', NULL, NULL, NULL, 2),
(9143, NULL, 'cd04046', NULL, NULL, 'C2_Calpain', NULL, 'C2_Calpain', NULL, NULL, 31156, 2),
(9144, NULL, 'cd00537', NULL, NULL, 'MTHFR', NULL, 'MTHFR', NULL, NULL, 1784, 2),
(9145, NULL, 'cd07964', NULL, NULL, 'RBP-H', NULL, 'RBP-H', NULL, NULL, NULL, 2),
(9146, NULL, 'cd06302', NULL, NULL, 'PBP1_LsrB_Quorum_Sensing-like', NULL, 'PBP1_LsrB_Quorum_Sensing-like', NULL, NULL, NULL, 2);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(9147, NULL, 'cd08209', NULL, NULL, 'RLP_DK-MTP-1-P-enolase', NULL, 'RLP_DK-MTP-1-P-enolase', NULL, NULL, 17555, 2),
(9148, NULL, 'cd12688', NULL, NULL, 'RRM1_PTBP1_like', NULL, 'RRM1_PTBP1_like', NULL, NULL, NULL, 2),
(9149, NULL, 'cd04733', NULL, NULL, 'OYE_like_2_FMN', NULL, 'OYE_like_2_FMN', NULL, NULL, NULL, 2),
(9150, NULL, 'cd06348', NULL, NULL, 'PBP1_ABC_HAAT-like', NULL, 'PBP1_ABC_HAAT-like', NULL, NULL, NULL, 2),
(9151, NULL, 'cd13841', NULL, NULL, 'ABBA-PTs', NULL, 'ABBA-PTs', NULL, NULL, NULL, 2),
(9152, NULL, 'cd05621', NULL, NULL, 'STKc_ROCK2', NULL, 'STKc_ROCK2', NULL, NULL, NULL, 2),
(9153, NULL, 'cd16841', NULL, NULL, 'RraA_family', NULL, 'RraA_family', NULL, NULL, 951, 2),
(9154, NULL, 'cd05789', NULL, NULL, 'S1_Rrp4', NULL, 'S1_Rrp4', NULL, NULL, NULL, 2),
(9155, NULL, 'cd18554', NULL, NULL, 'ABC_6TM_Sav1866_like', NULL, 'ABC_6TM_Sav1866_like', NULL, NULL, NULL, 2),
(9156, NULL, 'cd08806', NULL, NULL, 'CARD_CARD14_CARMA2', NULL, 'CARD_CARD14_CARMA2', NULL, NULL, NULL, 2),
(9157, NULL, 'cd16616', NULL, NULL, 'mRING-HC-C4C4_Asi1p_like', NULL, 'mRING-HC-C4C4_Asi1p_like', NULL, NULL, NULL, 2),
(9158, NULL, 'cd06189', NULL, NULL, 'flavin_oxioreductase', NULL, 'flavin_oxioreductase', NULL, NULL, NULL, 2),
(9159, NULL, 'cd06152', NULL, NULL, 'YjgF_YER057c_UK114_like_4', NULL, 'YjgF_YER057c_UK114_like_4', NULL, NULL, NULL, 2),
(9160, NULL, 'cd06472', NULL, NULL, 'ACD_ScHsp26_like', NULL, 'ACD_ScHsp26_like', NULL, NULL, NULL, 2),
(9161, NULL, 'cd08394', NULL, NULL, 'C2A_Munc13', NULL, 'C2A_Munc13', NULL, NULL, NULL, 2),
(9162, NULL, 'cd18005', NULL, NULL, 'DEXHc_ERCC6L2', NULL, 'DEXHc_ERCC6L2', NULL, NULL, NULL, 2),
(9163, NULL, 'cd05291', NULL, NULL, 'HicDH_like', NULL, 'HicDH_like', NULL, NULL, NULL, 2),
(9164, NULL, 'cd10955', NULL, NULL, 'CE4_BH0857_like', NULL, 'CE4_BH0857_like', NULL, NULL, NULL, 2),
(9165, NULL, 'cd03321', NULL, NULL, 'mandelate_racemase', NULL, 'mandelate_racemase', NULL, NULL, NULL, 2),
(9166, NULL, 'cd03701', NULL, NULL, 'IF2_IF5B_II', NULL, 'IF2_IF5B_II', NULL, NULL, NULL, 2),
(9167, NULL, 'cd14403', NULL, NULL, 'UBA_AID_AAPK1', NULL, 'UBA_AID_AAPK1', NULL, NULL, 24290, 2),
(9168, NULL, 'cd09649', NULL, NULL, 'Cas5_I-A', NULL, 'Cas5_I-A', NULL, NULL, NULL, 2),
(9169, NULL, 'cd12085', NULL, NULL, 'DD_cGKI-alpha', NULL, 'DD_cGKI-alpha', NULL, NULL, NULL, 2),
(9170, NULL, 'cd15753', NULL, NULL, 'FYVE_SlaC2-c', NULL, 'FYVE_SlaC2-c', NULL, NULL, NULL, 2),
(9171, NULL, 'cd09170', NULL, NULL, 'PLDc_Nuc', NULL, 'PLDc_Nuc', NULL, NULL, NULL, 2),
(9172, NULL, 'cd17521', NULL, NULL, 'RMtype1_S_Sau13435ORF2165P_TRD2-CR2_like', NULL, 'RMtype1_S_Sau13435ORF2165P_TRD2-CR2_like', NULL, NULL, NULL, 2),
(9173, NULL, 'sd00032', NULL, NULL, 'LRR_2', NULL, 'LRR_2', NULL, NULL, NULL, 2),
(9174, NULL, 'cd16164', NULL, NULL, 'OCRE_VG5Q', NULL, 'OCRE_VG5Q', NULL, NULL, 33318, 2),
(9175, NULL, 'cd00025', NULL, NULL, 'BPI1', NULL, 'BPI1', NULL, NULL, NULL, 2),
(9176, NULL, 'cd05261', NULL, NULL, 'CAPF_like_SDR_e', NULL, 'CAPF_like_SDR_e', NULL, NULL, NULL, 2),
(9177, NULL, 'cd20258', NULL, NULL, 'Tal_Pri', NULL, 'Tal_Pri', NULL, NULL, NULL, 2),
(9178, NULL, 'cd03347', NULL, NULL, 'eu_PheOH', NULL, 'eu_PheOH', NULL, NULL, 30134, 2),
(9179, NULL, 'cd12395', NULL, NULL, 'RRM2_RBM34', NULL, 'RRM2_RBM34', NULL, NULL, 21177, 2),
(9180, NULL, 'cd16128', NULL, NULL, 'Ubl_ATG8', NULL, 'Ubl_ATG8', NULL, NULL, NULL, 2),
(9181, NULL, 'cd12899', NULL, NULL, 'SPRY_PRY_TRIM76_like', NULL, 'SPRY_PRY_TRIM76_like', NULL, NULL, NULL, 2),
(9182, NULL, 'cd14397', NULL, NULL, 'UBA_LATS1', NULL, 'UBA_LATS1', NULL, NULL, NULL, 2),
(9183, NULL, 'cd07344', NULL, NULL, 'M48_yhfN_like', NULL, 'M48_yhfN_like', NULL, NULL, NULL, 2),
(9184, NULL, 'cd11255', NULL, NULL, 'Sema_3G', NULL, 'Sema_3G', NULL, NULL, NULL, 2),
(9185, NULL, 'cd19943', NULL, NULL, 'NirB_Fer2_BFD-like_1', NULL, 'NirB_Fer2_BFD-like_1', NULL, NULL, NULL, 2),
(9186, NULL, 'cd19535', NULL, NULL, 'Cyc_NRPS', NULL, 'Cyc_NRPS', NULL, NULL, NULL, 2),
(9187, NULL, 'cd03485', NULL, NULL, 'MutL_Trans_hPMS_1_like', NULL, 'MutL_Trans_hPMS_1_like', NULL, NULL, NULL, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(9188, NULL, 'cd04502', NULL, NULL, 'SGNH_hydrolase_like_7', NULL, 'SGNH_hydrolase_like_7', NULL, NULL, NULL, 2),
(9189, NULL, 'cd15294', NULL, NULL, '7tmC_GABA-B-R2', NULL, '7tmC_GABA-B-R2', NULL, NULL, NULL, 2),
(9190, NULL, 'cd01925', NULL, NULL, 'cyclophilin_CeCYP16-like', NULL, 'cyclophilin_CeCYP16-like', NULL, NULL, NULL, 2),
(9191, NULL, 'cd08294', NULL, NULL, 'leukotriene_B4_DH_like', NULL, 'leukotriene_B4_DH_like', NULL, NULL, 8771, 2),
(9192, NULL, 'cd17989', NULL, NULL, 'DEXHc_HrpA', NULL, 'DEXHc_HrpA', NULL, NULL, NULL, 2),
(9193, NULL, 'cd04873', NULL, NULL, 'ACT_UUR-ACR-like', NULL, 'ACT_UUR-ACR-like', NULL, NULL, NULL, 2),
(9194, NULL, 'cd16675', NULL, NULL, 'RING-H2_RNF24', NULL, 'RING-H2_RNF24', NULL, NULL, NULL, 2),
(9195, NULL, 'cd18192', NULL, NULL, 'BTB_POZ_ZBTB1', NULL, 'BTB_POZ_ZBTB1', NULL, NULL, NULL, 2),
(9196, NULL, 'cd01256', NULL, NULL, 'PH_dynamin', NULL, 'PH_dynamin', NULL, NULL, NULL, 2),
(9197, NULL, 'cd12453', NULL, NULL, 'RRM1_RIM4_like', NULL, 'RRM1_RIM4_like', NULL, NULL, 715, 2),
(9198, NULL, 'cd14906', NULL, NULL, 'MYSc_Myo45', NULL, 'MYSc_Myo45', NULL, NULL, NULL, 2),
(9199, NULL, 'cd00524', NULL, NULL, 'SORL', NULL, 'SORL', NULL, NULL, NULL, 2),
(9200, NULL, 'cd07835', NULL, NULL, 'STKc_CDK1_CdkB_like', NULL, 'STKc_CDK1_CdkB_like', NULL, NULL, NULL, 2),
(9201, NULL, 'cd15986', NULL, NULL, '7tmB1_VIP-R2', NULL, '7tmB1_VIP-R2', NULL, NULL, NULL, 2),
(9202, NULL, 'cd14676', NULL, NULL, 'PH_DOK1,2,3', NULL, 'PH_DOK1,2,3', NULL, NULL, NULL, 2),
(9203, NULL, 'cd13328', NULL, NULL, 'PH1_FDG_family', NULL, 'PH1_FDG_family', NULL, NULL, NULL, 2),
(9204, NULL, 'cd15406', NULL, NULL, '7tmA_OR8D-like', NULL, '7tmA_OR8D-like', NULL, NULL, NULL, 2),
(9205, NULL, 'cd16290', NULL, NULL, 'AIM-1_SMB-1-like_MBL-B3', NULL, 'AIM-1_SMB-1-like_MBL-B3', NULL, NULL, NULL, 2),
(9206, NULL, 'cd18479', NULL, NULL, 'BACK_KBTBD2', NULL, 'BACK_KBTBD2', NULL, NULL, NULL, 2),
(9207, NULL, 'cd05727', NULL, NULL, 'Ig2_Contactin-2-like', NULL, 'Ig2_Contactin-2-like', NULL, NULL, NULL, 2),
(9208, NULL, 'cd10959', NULL, NULL, 'CE4_NodB_like_3', NULL, 'CE4_NodB_like_3', NULL, NULL, NULL, 2),
(9209, NULL, 'cd00112', NULL, NULL, 'LDLa', NULL, 'LDLa', NULL, NULL, 5466, 2),
(9210, NULL, 'cd08987', NULL, NULL, 'GH62', NULL, 'GH62', NULL, NULL, 6321, 2),
(9211, NULL, 'cd05140', NULL, NULL, 'Barstar_AU1054-like', NULL, 'Barstar_AU1054-like', NULL, NULL, NULL, 2),
(9212, NULL, 'cd09644', NULL, NULL, 'Csn2', NULL, 'Csn2', NULL, NULL, NULL, 2),
(9213, NULL, 'cd19889', NULL, NULL, 'DSRM_PRKRA_rpt1', NULL, 'DSRM_PRKRA_rpt1', NULL, NULL, 34086, 2),
(9214, NULL, 'cd16076', NULL, NULL, 'TSPcc', NULL, 'TSPcc', NULL, NULL, NULL, 2),
(9215, NULL, 'cd18470', NULL, NULL, 'BACK_KLHL31_KBTBD1', NULL, 'BACK_KLHL31_KBTBD1', NULL, NULL, NULL, 2),
(9216, NULL, 'cd16307', NULL, NULL, 'FEZ-1-like_MBL-B3', NULL, 'FEZ-1-like_MBL-B3', NULL, NULL, NULL, 2),
(9217, NULL, 'cd13896', NULL, NULL, 'CuRO_3_CopA', NULL, 'CuRO_3_CopA', NULL, NULL, 2390, 2),
(9218, NULL, 'cd15345', NULL, NULL, '7tmA_S1PR3_Edg3', NULL, '7tmA_S1PR3_Edg3', NULL, NULL, NULL, 2),
(9219, NULL, 'cd10964', NULL, NULL, 'CE4_PgaB_5s', NULL, 'CE4_PgaB_5s', NULL, NULL, NULL, 2),
(9220, NULL, 'cd14884', NULL, NULL, 'MYSc_Myo23', NULL, 'MYSc_Myo23', NULL, NULL, NULL, 2),
(9221, NULL, 'cd12778', NULL, NULL, 'RRM1_PTBP2', NULL, 'RRM1_PTBP2', NULL, NULL, 20865, 2),
(9222, NULL, 'cd01889', NULL, NULL, 'SelB_euk', NULL, 'SelB_euk', NULL, NULL, NULL, 2),
(9223, NULL, 'cd19723', NULL, NULL, 'bHLH_TS_ASCL1_like', NULL, 'bHLH_TS_ASCL1_like', NULL, NULL, NULL, 2),
(9224, NULL, 'cd12884', NULL, NULL, 'SPRY_hnRNP', NULL, 'SPRY_hnRNP', NULL, NULL, 32092, 2),
(9225, NULL, 'cd12931', NULL, NULL, 'eNOPS_SF', NULL, 'eNOPS_SF', NULL, NULL, NULL, 2),
(9226, NULL, 'cd07658', NULL, NULL, 'F-BAR_NOSTRIN', NULL, 'F-BAR_NOSTRIN', NULL, NULL, NULL, 2),
(9227, NULL, 'cd19580', NULL, NULL, 'serpin_silkworm16_18_22', NULL, 'serpin_silkworm16_18_22', NULL, NULL, NULL, 2),
(9228, NULL, 'cd00529', NULL, NULL, 'RuvC_like', NULL, 'RuvC_like', NULL, NULL, NULL, 2),
(9229, NULL, 'cd08535', NULL, NULL, 'SAM_PNT-Tel_Yan', NULL, 'SAM_PNT-Tel_Yan', NULL, NULL, NULL, 2);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(9230, NULL, 'cd12912', NULL, NULL, 'PDC2_MCP_like', NULL, 'PDC2_MCP_like', NULL, NULL, NULL, 2),
(9231, NULL, 'cd09484', NULL, NULL, 'LIM1_Prickle_2', NULL, 'LIM1_Prickle_2', NULL, NULL, NULL, 2),
(9232, NULL, 'cd19861', NULL, NULL, 'DSRM_STAU_rpt5', NULL, 'DSRM_STAU_rpt5', NULL, NULL, NULL, 2),
(9233, NULL, 'cd10019', NULL, NULL, '14-3-3_sigma', NULL, '14-3-3_sigma', NULL, NULL, 27071, 2),
(9234, NULL, 'cd01378', NULL, NULL, 'MYSc_Myo1', NULL, 'MYSc_Myo1', NULL, NULL, 26885, 2),
(9235, NULL, 'cd11804', NULL, NULL, 'SH3_GRB2_like_N', NULL, 'SH3_GRB2_like_N', NULL, NULL, NULL, 2),
(9236, NULL, 'cd15017', NULL, NULL, '7tm_TAS2R16', NULL, '7tm_TAS2R16', NULL, NULL, NULL, 2),
(9237, NULL, 'cd13118', NULL, NULL, 'POLO_box_1', NULL, 'POLO_box_1', NULL, NULL, 28388, 2),
(9238, NULL, 'cd13202', NULL, NULL, 'FERM_C_MyoX', NULL, 'FERM_C_MyoX', NULL, NULL, 30565, 2),
(9239, NULL, 'cd03784', NULL, NULL, 'GT1_Gtf-like', NULL, 'GT1_Gtf-like', NULL, NULL, 5549, 2),
(9240, NULL, 'cd15993', NULL, NULL, '7tmB2_CELSR3', NULL, '7tmB2_CELSR3', NULL, NULL, NULL, 2),
(9241, NULL, 'cd13424', NULL, NULL, 'TNFRSF9_teleost', NULL, 'TNFRSF9_teleost', NULL, NULL, 300, 2),
(9242, NULL, 'cd15335', NULL, NULL, '7tmA_5-HT1E', NULL, '7tmA_5-HT1E', NULL, NULL, NULL, 2),
(9243, NULL, 'cd12927', NULL, NULL, 'MMP_TTHA0227_like', NULL, 'MMP_TTHA0227_like', NULL, NULL, NULL, 2),
(9244, NULL, 'cd09475', NULL, NULL, 'LIM2_Lhx9', NULL, 'LIM2_Lhx9', NULL, NULL, NULL, 2),
(9245, NULL, 'cd11808', NULL, NULL, 'SH3_Alpha_Spectrin', NULL, 'SH3_Alpha_Spectrin', NULL, NULL, 27955, 2),
(9246, NULL, 'cd12905', NULL, NULL, 'SPRY_PRY_A33L', NULL, 'SPRY_PRY_A33L', NULL, NULL, NULL, 2),
(9247, NULL, 'cd07374', NULL, NULL, 'CYTH-like_Pase', NULL, 'CYTH-like_Pase', NULL, NULL, NULL, 2),
(9248, NULL, 'cd16496', NULL, NULL, 'RING-HC_BARD1', NULL, 'RING-HC_BARD1', NULL, NULL, 28584, 2),
(9249, NULL, 'cd12269', NULL, NULL, 'RRM_Vip1_like', NULL, 'RRM_Vip1_like', NULL, NULL, 1025, 2),
(9250, NULL, 'cd03245', NULL, NULL, 'ABCC_bacteriocin_exporters', NULL, 'ABCC_bacteriocin_exporters', NULL, NULL, NULL, 2),
(9251, NULL, 'cd13200', NULL, NULL, 'FERM_C_KCBP', NULL, 'FERM_C_KCBP', NULL, NULL, NULL, 2),
(9252, NULL, 'cd01455', NULL, NULL, 'vWA_F11C1-5a_type', NULL, 'vWA_F11C1-5a_type', NULL, NULL, NULL, 2),
(9253, NULL, 'cd09536', NULL, NULL, 'SAM_Ste50_fungal', NULL, 'SAM_Ste50_fungal', NULL, NULL, 13070, 2),
(9254, NULL, 'cd18761', NULL, NULL, 'PIN_MtVapC3-like', NULL, 'PIN_MtVapC3-like', NULL, NULL, NULL, 2),
(9255, NULL, 'cd03345', NULL, NULL, 'eu_TyrOH', NULL, 'eu_TyrOH', NULL, NULL, 30057, 2),
(9256, NULL, 'cd11740', NULL, NULL, 'YajQ_like', NULL, 'YajQ_like', NULL, NULL, 3556, 2),
(9257, NULL, 'cd11396', NULL, NULL, 'bHLHzip_USF', NULL, 'bHLHzip_USF', NULL, NULL, NULL, 2),
(9258, NULL, 'cd15837', NULL, NULL, 'TNFRSF26', NULL, 'TNFRSF26', NULL, NULL, 8017, 2),
(9259, NULL, 'cd16986', NULL, NULL, 'ANTH_N_Sla2p_HIP1_like', NULL, 'ANTH_N_Sla2p_HIP1_like', NULL, NULL, NULL, 2),
(9260, NULL, 'cd14188', NULL, NULL, 'STKc_PLK2', NULL, 'STKc_PLK2', NULL, NULL, 35369, 2),
(9261, NULL, 'cd18313', NULL, NULL, 'BTB_POZ_BT', NULL, 'BTB_POZ_BT', NULL, NULL, NULL, 2),
(9262, NULL, 'cd21519', NULL, NULL, 'cv_beta_Nsp2_MHV-like', NULL, 'cv_beta_Nsp2_MHV-like', NULL, NULL, 35609, 2),
(9263, NULL, 'cd00076', NULL, NULL, 'H4', NULL, 'H4', NULL, NULL, 2275, 2),
(9264, NULL, 'cd06143', NULL, NULL, 'PAN2_exo', NULL, 'PAN2_exo', NULL, NULL, NULL, 2),
(9265, NULL, 'cd13407', NULL, NULL, 'TNFRSF5', NULL, 'TNFRSF5', NULL, NULL, 15621, 2),
(9266, NULL, 'cd15421', NULL, NULL, '7tmA_OR2T-like', NULL, '7tmA_OR2T-like', NULL, NULL, NULL, 2),
(9267, NULL, 'cd15785', NULL, NULL, 'YycH_N_like', NULL, 'YycH_N_like', NULL, NULL, NULL, 2),
(9268, NULL, 'cd20001', NULL, NULL, 'PBP1_LsrB_Quorum_Sensing-like', NULL, 'PBP1_LsrB_Quorum_Sensing-like', NULL, NULL, NULL, 2),
(9269, NULL, 'cd08653', NULL, NULL, 'FMT_core_like_3', NULL, 'FMT_core_like_3', NULL, NULL, NULL, 2),
(9270, NULL, 'cd11611', NULL, NULL, 'SAF', NULL, 'SAF', NULL, NULL, NULL, 2),
(9271, NULL, 'cd16168', NULL, NULL, 'OCRE_RBM5', NULL, 'OCRE_RBM5', NULL, NULL, NULL, 2);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(9272, NULL, 'cd13517', NULL, NULL, 'PBP2_ModA3_like', NULL, 'PBP2_ModA3_like', NULL, NULL, NULL, 2),
(9273, NULL, 'cd15502', NULL, NULL, 'PHD_Phf1p_Phf2p_like', NULL, 'PHD_Phf1p_Phf2p_like', NULL, NULL, NULL, 2),
(9274, NULL, 'cd18991', NULL, NULL, 'LGIC_ECD_GlyR', NULL, 'LGIC_ECD_GlyR', NULL, NULL, NULL, 2),
(9275, NULL, 'cd14326', NULL, NULL, 'UBA_UBL7', NULL, 'UBA_UBL7', NULL, NULL, NULL, 2),
(9276, NULL, 'cd19467', NULL, NULL, 'FABP4', NULL, 'FABP4', NULL, NULL, NULL, 2),
(9277, NULL, 'cd19607', NULL, NULL, 'GTA_TIM-barrel-like', NULL, 'GTA_TIM-barrel-like', NULL, NULL, NULL, 2),
(9278, NULL, 'cd19443', NULL, NULL, 'FABP3-like', NULL, 'FABP3-like', NULL, NULL, NULL, 2),
(9279, NULL, 'cd07472', NULL, NULL, 'HmuY_like', NULL, 'HmuY_like', NULL, NULL, NULL, 2),
(9280, NULL, 'cd18174', NULL, NULL, 'M14_ASTE_ASPA_like', NULL, 'M14_ASTE_ASPA_like', NULL, NULL, NULL, 2),
(9281, NULL, 'cd15664', NULL, NULL, 'ePHD_KMT2A_like', NULL, 'ePHD_KMT2A_like', NULL, NULL, NULL, 2),
(9282, NULL, 'cd16210', NULL, NULL, 'EFh_PI-PLCbeta3', NULL, 'EFh_PI-PLCbeta3', NULL, NULL, NULL, 2),
(9283, NULL, 'cd07141', NULL, NULL, 'ALDH_F1AB_F2_RALDH1', NULL, 'ALDH_F1AB_F2_RALDH1', NULL, NULL, NULL, 2),
(9284, NULL, 'cd15848', NULL, NULL, 'SNARE_syntaxin1-like', NULL, 'SNARE_syntaxin1-like', NULL, NULL, NULL, 2),
(9285, NULL, 'cd02586', NULL, NULL, 'HAD_PHN', NULL, 'HAD_PHN', NULL, NULL, 4746, 2),
(9286, NULL, 'cd03361', NULL, NULL, 'TOPRIM_TopoIA_RevGyr', NULL, 'TOPRIM_TopoIA_RevGyr', NULL, NULL, 5897, 2),
(9287, NULL, 'cd17648', NULL, NULL, 'A_NRPS_ACVS-like', NULL, 'A_NRPS_ACVS-like', NULL, NULL, NULL, 2),
(9288, NULL, 'cd20306', NULL, NULL, 'cupin_OxDC-like', NULL, 'cupin_OxDC-like', NULL, NULL, NULL, 2),
(9289, NULL, 'cd04228', NULL, NULL, 'CuRO_5_FVIII_like', NULL, 'CuRO_5_FVIII_like', NULL, NULL, NULL, 2),
(9290, NULL, 'cd17182', NULL, NULL, 'FERM_F0_KIND3', NULL, 'FERM_F0_KIND3', NULL, NULL, NULL, 2),
(9291, NULL, 'cd21624', NULL, NULL, 'SARS-CoV-like_Spike_S1_NTD', NULL, 'SARS-CoV-like_Spike_S1_NTD', NULL, NULL, 33522, 2),
(9292, NULL, 'cd04087', NULL, NULL, 'PTPA', NULL, 'PTPA', NULL, NULL, 4863, 2),
(9293, NULL, 'cd16013', NULL, NULL, 'AcpA', NULL, 'AcpA', NULL, NULL, NULL, 2),
(9294, NULL, 'cd19849', NULL, NULL, 'Bbox1_TRIM46_C-I', NULL, 'Bbox1_TRIM46_C-I', NULL, NULL, NULL, 2),
(9295, NULL, 'cd17574', NULL, NULL, 'REC_OmpR', NULL, 'REC_OmpR', NULL, NULL, NULL, 2),
(9296, NULL, 'cd04035', NULL, NULL, 'C2A_Rabphilin_Doc2', NULL, 'C2A_Rabphilin_Doc2', NULL, NULL, NULL, 2),
(9297, NULL, 'cd04126', NULL, NULL, 'Rab20', NULL, 'Rab20', NULL, NULL, 31430, 2),
(9298, NULL, 'cd02981', NULL, NULL, 'PDI_b_family', NULL, 'PDI_b_family', NULL, NULL, NULL, 2),
(9299, NULL, 'cd04085', NULL, NULL, 'delta_endotoxin_C', NULL, 'delta_endotoxin_C', NULL, NULL, NULL, 2),
(9300, NULL, 'cd01140', NULL, NULL, 'FatB', NULL, 'FatB', NULL, NULL, 32024, 2),
(9301, NULL, 'cd15593', NULL, NULL, 'PHD3_KMT2B', NULL, 'PHD3_KMT2B', NULL, NULL, NULL, 2),
(9302, NULL, 'cd10329', NULL, NULL, 'SLC5sbd_SGLT1-like', NULL, 'SLC5sbd_SGLT1-like', NULL, NULL, NULL, 2),
(9303, NULL, 'cd11896', NULL, NULL, 'SH3_SNX33', NULL, 'SH3_SNX33', NULL, NULL, NULL, 2),
(9304, NULL, 'cd06137', NULL, NULL, 'DEDDh_RNase', NULL, 'DEDDh_RNase', NULL, NULL, NULL, 2),
(9305, NULL, 'cd01043', NULL, NULL, 'DPS', NULL, 'DPS', NULL, NULL, 488, 2),
(9306, NULL, 'cd10035', NULL, NULL, 'UDG_like', NULL, 'UDG_like', NULL, NULL, NULL, 2),
(9307, NULL, 'cd05237', NULL, NULL, 'UDP_invert_4-6DH_SDR_e', NULL, 'UDP_invert_4-6DH_SDR_e', NULL, NULL, 4257, 2),
(9308, NULL, 'cd08235', NULL, NULL, 'iditol_2_DH_like', NULL, 'iditol_2_DH_like', NULL, NULL, NULL, 2),
(9309, NULL, 'cd14415', NULL, NULL, 'UBA_NACA_NACP1', NULL, 'UBA_NACA_NACP1', NULL, NULL, NULL, 2),
(9310, NULL, 'cd04047', NULL, NULL, 'C2B_Copine', NULL, 'C2B_Copine', NULL, NULL, 27556, 2),
(9311, NULL, 'cd10492', NULL, NULL, 'MH1_SMAD_4', NULL, 'MH1_SMAD_4', NULL, NULL, NULL, 2),
(9312, NULL, 'cd01369', NULL, NULL, 'KISc_KHC_KIF5', NULL, 'KISc_KHC_KIF5', NULL, NULL, NULL, 2),
(9313, NULL, 'cd16708', NULL, NULL, 'RING-HC_Cbl', NULL, 'RING-HC_Cbl', NULL, NULL, NULL, 2);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(9314, NULL, 'cd18239', NULL, NULL, 'BTB_POZ_KLHL9_13', NULL, 'BTB_POZ_KLHL9_13', NULL, NULL, NULL, 2),
(9315, NULL, 'cd05627', NULL, NULL, 'STKc_NDR2', NULL, 'STKc_NDR2', NULL, NULL, NULL, 2),
(9316, NULL, 'cd08203', NULL, NULL, 'SAM_PNT', NULL, 'SAM_PNT', NULL, NULL, NULL, 2),
(9317, NULL, 'cd08186', NULL, NULL, 'Fe-ADH-like', NULL, 'Fe-ADH-like', NULL, NULL, 37599, 2),
(9318, NULL, 'cd16141', NULL, NULL, 'RA_GRB10', NULL, 'RA_GRB10', NULL, NULL, NULL, 2),
(9319, NULL, 'cd03767', NULL, NULL, 'SR_Res_par', NULL, 'SR_Res_par', NULL, NULL, NULL, 2),
(9320, NULL, 'cd08161', NULL, NULL, 'SET', NULL, 'SET', NULL, NULL, NULL, 2),
(9321, NULL, 'cd09359', NULL, NULL, 'LIM_LASP_like', NULL, 'LIM_LASP_like', NULL, NULL, NULL, 2),
(9322, NULL, 'cd07391', NULL, NULL, 'MPP_PF1019', NULL, 'MPP_PF1019', NULL, NULL, NULL, 2),
(9323, NULL, 'cd16223', NULL, NULL, 'EFh_PRIP2', NULL, 'EFh_PRIP2', NULL, NULL, NULL, 2),
(9324, NULL, 'cd13850', NULL, NULL, 'CuRO_1_Abr2_like', NULL, 'CuRO_1_Abr2_like', NULL, NULL, NULL, 2),
(9325, NULL, 'cd14308', NULL, NULL, 'UBA_Mud1_like', NULL, 'UBA_Mud1_like', NULL, NULL, NULL, 2),
(9326, NULL, 'cd13562', NULL, NULL, 'PBP2_SsuA_like_5', NULL, 'PBP2_SsuA_like_5', NULL, NULL, NULL, 2),
(9327, NULL, 'cd14293', NULL, NULL, 'UBA3_NUB1', NULL, 'UBA3_NUB1', NULL, NULL, NULL, 2),
(9328, NULL, 'cd11697', NULL, NULL, 'DHR2_DOCK_A', NULL, 'DHR2_DOCK_A', NULL, NULL, NULL, 2),
(9329, NULL, 'cd17187', NULL, NULL, 'FERM_F1_ERM', NULL, 'FERM_F1_ERM', NULL, NULL, NULL, 2),
(9330, NULL, 'cd10809', NULL, NULL, 'GH38N_AMII_GMII_SfManIII_like', NULL, 'GH38N_AMII_GMII_SfManIII_like', NULL, NULL, NULL, 2),
(9331, NULL, 'cd12756', NULL, NULL, 'RRM1_hnRNPD', NULL, 'RRM1_hnRNPD', NULL, NULL, NULL, 2),
(9332, NULL, 'cd01261', NULL, NULL, 'PH_SOS', NULL, 'PH_SOS', NULL, NULL, NULL, 2),
(9333, NULL, 'cd16407', NULL, NULL, 'ParB_N_like', NULL, 'ParB_N_like', NULL, NULL, NULL, 2),
(9334, NULL, 'cd16000', NULL, NULL, '7tmB2_GPR123', NULL, '7tmB2_GPR123', NULL, NULL, NULL, 2),
(9335, NULL, 'cd19905', NULL, NULL, 'DSRM_ADAD1', NULL, 'DSRM_ADAD1', NULL, NULL, 35034, 2),
(9336, NULL, 'cd16588', NULL, NULL, 'RING-HC_TRIM45-C-VII', NULL, 'RING-HC_TRIM45-C-VII', NULL, NULL, NULL, 2),
(9337, NULL, 'cd04033', NULL, NULL, 'C2_NEDD4_NEDD4L', NULL, 'C2_NEDD4_NEDD4L', NULL, NULL, NULL, 2),
(9338, NULL, 'cd05761', NULL, NULL, 'Ig2_Necl-1-4_like', NULL, 'Ig2_Necl-1-4_like', NULL, NULL, NULL, 2),
(9339, NULL, 'cd09355', NULL, NULL, 'LIM2_Ajuba_like', NULL, 'LIM2_Ajuba_like', NULL, NULL, NULL, 2),
(9340, NULL, 'cd13144', NULL, NULL, 'MATE_like_4', NULL, 'MATE_like_4', NULL, NULL, NULL, 2),
(9341, NULL, 'cd02993', NULL, NULL, 'PDI_a_APS_reductase', NULL, 'PDI_a_APS_reductase', NULL, NULL, NULL, 2),
(9342, NULL, 'cd11325', NULL, NULL, 'AmyAc_GTHase', NULL, 'AmyAc_GTHase', NULL, NULL, NULL, 2),
(9343, NULL, 'cd15971', NULL, NULL, '7tmA_SSTR2', NULL, '7tmA_SSTR2', NULL, NULL, NULL, 2),
(9344, NULL, 'cd18498', NULL, NULL, 'BACK_RCBTB1_2', NULL, 'BACK_RCBTB1_2', NULL, NULL, NULL, 2),
(9345, NULL, 'cd05233', NULL, NULL, 'SDR_c', NULL, 'SDR_c', NULL, NULL, NULL, 2),
(9346, NULL, 'cd02023', NULL, NULL, 'UMPK', NULL, 'UMPK', NULL, NULL, 3563, 2),
(9347, NULL, 'cd02931', NULL, NULL, 'ER_like_FMN', NULL, 'ER_like_FMN', NULL, NULL, NULL, 2),
(9348, NULL, 'cd12048', NULL, NULL, 'SH3_DOCK3_B', NULL, 'SH3_DOCK3_B', NULL, NULL, 31896, 2),
(9349, NULL, 'cd17147', NULL, NULL, 'DCX2_RP1', NULL, 'DCX2_RP1', NULL, NULL, NULL, 2),
(9350, NULL, 'cd09554', NULL, NULL, 'SAM_EPH-B4', NULL, 'SAM_EPH-B4', NULL, NULL, 32017, 2),
(9351, NULL, 'cd04968', NULL, NULL, 'Ig3_Contactin', NULL, 'Ig3_Contactin', NULL, NULL, NULL, 2),
(9352, NULL, 'cd09075', NULL, NULL, 'DNase1-like', NULL, 'DNase1-like', NULL, NULL, NULL, 2),
(9353, NULL, 'cd02120', NULL, NULL, 'PA_subtilisin_like', NULL, 'PA_subtilisin_like', NULL, NULL, NULL, 2),
(9354, NULL, 'cd01523', NULL, NULL, 'RHOD_Lact_B', NULL, 'RHOD_Lact_B', NULL, NULL, NULL, 2),
(9355, NULL, 'cd06087', NULL, NULL, 'KOW_RPS4', NULL, 'KOW_RPS4', NULL, NULL, 30151, 2),
(9356, NULL, 'cd05129', NULL, NULL, 'RasGAP_RAP6', NULL, 'RasGAP_RAP6', NULL, NULL, NULL, 2);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(9357, NULL, 'cd06156', NULL, NULL, 'eu_AANH_C_2', NULL, 'eu_AANH_C_2', NULL, NULL, NULL, 2),
(9358, NULL, 'cd07894', NULL, NULL, 'Adenylation_RNA_ligase', NULL, 'Adenylation_RNA_ligase', NULL, NULL, 1154, 2),
(9359, NULL, 'cd17917', NULL, NULL, 'DEXHc_RHA-like', NULL, 'DEXHc_RHA-like', NULL, NULL, NULL, 2),
(9360, NULL, 'cd03674', NULL, NULL, 'Nudix_Hydrolase_1', NULL, 'Nudix_Hydrolase_1', NULL, NULL, NULL, 2),
(9361, NULL, 'cd09421', NULL, NULL, 'LIM3_LIMPETin', NULL, 'LIM3_LIMPETin', NULL, NULL, NULL, 2),
(9362, NULL, 'cd01135', NULL, NULL, 'V_A-ATPase_B', NULL, 'V_A-ATPase_B', NULL, NULL, NULL, 2),
(9363, NULL, 'cd04103', NULL, NULL, 'Centaurin_gamma', NULL, 'Centaurin_gamma', NULL, NULL, NULL, 2),
(9364, NULL, 'cd04594', NULL, NULL, 'CBS_pair_voltage-gated_CLC_archaea', NULL, 'CBS_pair_voltage-gated_CLC_archaea', NULL, NULL, NULL, 2),
(9365, NULL, 'cd17786', NULL, NULL, 'CBS_pair_Thermoplasmatales', NULL, 'CBS_pair_Thermoplasmatales', NULL, NULL, NULL, 2),
(9366, NULL, 'cd05258', NULL, NULL, 'CDP_TE_SDR_e', NULL, 'CDP_TE_SDR_e', NULL, NULL, NULL, 2),
(9367, NULL, 'cd15372', NULL, NULL, '7tmA_PAR4', NULL, '7tmA_PAR4', NULL, NULL, NULL, 2),
(9368, NULL, 'cd03585', NULL, NULL, 'NTR_TIMP', NULL, 'NTR_TIMP', NULL, NULL, NULL, 2),
(9369, NULL, 'cd04435', NULL, NULL, 'DEP_fRom2', NULL, 'DEP_fRom2', NULL, NULL, NULL, 2),
(9370, NULL, 'cd19590', NULL, NULL, 'serpin_thermopin-like', NULL, 'serpin_thermopin-like', NULL, NULL, NULL, 2),
(9371, NULL, 'cd20247', NULL, NULL, 'DWORF', NULL, 'DWORF', NULL, NULL, 34939, 2),
(9372, NULL, 'cd11982', NULL, NULL, 'SH3_Shank1', NULL, 'SH3_Shank1', NULL, NULL, 28317, 2),
(9373, NULL, 'cd04043', NULL, NULL, 'C2_Munc13_fungal', NULL, 'C2_Munc13_fungal', NULL, NULL, NULL, 2),
(9374, NULL, 'cd06294', NULL, NULL, 'PBP1_MalR-like', NULL, 'PBP1_MalR-like', NULL, NULL, NULL, 2),
(9375, NULL, 'cd01006', NULL, NULL, 'PBP2_phosphate_binding', NULL, 'PBP2_phosphate_binding', NULL, NULL, NULL, 2),
(9376, NULL, 'cd14983', NULL, NULL, '7tmA_FFAR', NULL, '7tmA_FFAR', NULL, NULL, NULL, 2),
(9377, NULL, 'cd16154', NULL, NULL, 'sulfatase_like', NULL, 'sulfatase_like', NULL, NULL, NULL, 2),
(9378, NULL, 'cd18068', NULL, NULL, 'DEXHc_ATRX', NULL, 'DEXHc_ATRX', NULL, NULL, NULL, 2),
(9379, NULL, 'cd13159', NULL, NULL, 'PTB_LDLRAP-mammal-like', NULL, 'PTB_LDLRAP-mammal-like', NULL, NULL, NULL, 2),
(9380, NULL, 'cd05281', NULL, NULL, 'TDH', NULL, 'TDH', NULL, NULL, NULL, 2),
(9381, NULL, 'cd02337', NULL, NULL, 'ZZ_CBP', NULL, 'ZZ_CBP', NULL, NULL, NULL, 2),
(9382, NULL, 'cd18120', NULL, NULL, 'ATP-synt_Vo_Ao_c', NULL, 'ATP-synt_Vo_Ao_c', NULL, NULL, NULL, 2),
(9383, NULL, 'cd18536', NULL, NULL, 'PTP-IVa2', NULL, 'PTP-IVa2', NULL, NULL, NULL, 2),
(9384, NULL, 'cd07874', NULL, NULL, 'STKc_JNK3', NULL, 'STKc_JNK3', NULL, NULL, NULL, 2),
(9385, NULL, 'cd04203', NULL, NULL, 'Cupredoxin_like_3', NULL, 'Cupredoxin_like_3', NULL, NULL, NULL, 2),
(9386, NULL, 'cd12951', NULL, NULL, 'RRP7_Rrp7A', NULL, 'RRP7_Rrp7A', NULL, NULL, NULL, 2),
(9387, NULL, 'cd14967', NULL, NULL, '7tmA_amine_R-like', NULL, '7tmA_amine_R-like', NULL, NULL, NULL, 2),
(9388, NULL, 'cd09829', NULL, NULL, 'PET_testin', NULL, 'PET_testin', NULL, NULL, 30362, 2),
(9389, NULL, 'cd06932', NULL, NULL, 'NR_LBD_PPAR', NULL, 'NR_LBD_PPAR', NULL, NULL, NULL, 2),
(9390, NULL, 'cd17552', NULL, NULL, 'REC_RR468-like', NULL, 'REC_RR468-like', NULL, NULL, NULL, 2),
(9391, NULL, 'sd00006', NULL, NULL, 'TPR', NULL, 'TPR', NULL, NULL, NULL, 2),
(9392, NULL, 'cd15196', NULL, NULL, '7tmA_Vasopressin_Oxytocin', NULL, '7tmA_Vasopressin_Oxytocin', NULL, NULL, NULL, 2),
(9393, NULL, 'cd01116', NULL, NULL, 'P_permease', NULL, 'P_permease', NULL, NULL, NULL, 2),
(9394, NULL, 'cd04484', NULL, NULL, 'polC_OBF', NULL, 'polC_OBF', NULL, NULL, NULL, 2),
(9395, NULL, 'cd03177', NULL, NULL, 'GST_C_Delta_Epsilon', NULL, 'GST_C_Delta_Epsilon', NULL, NULL, NULL, 2),
(9396, NULL, 'cd08975', NULL, NULL, 'BaFpgNei_N_3', NULL, 'BaFpgNei_N_3', NULL, NULL, NULL, 2),
(9397, NULL, 'cd09383', NULL, NULL, 'LIM2_Lhx7_Lhx8', NULL, 'LIM2_Lhx7_Lhx8', NULL, NULL, NULL, 2);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(9398, NULL, 'cd09833', NULL, NULL, 'CBS_pair_GGDEF_PAS_repeat1', NULL, 'CBS_pair_GGDEF_PAS_repeat1', NULL, NULL, NULL, 2),
(9399, NULL, 'cd07323', NULL, NULL, 'LAM', NULL, 'LAM', NULL, NULL, NULL, 2),
(9400, NULL, 'cd18453', NULL, NULL, 'BACK_KLHL14', NULL, 'BACK_KLHL14', NULL, NULL, NULL, 2),
(9401, NULL, 'cd05044', NULL, NULL, 'PTKc_c-ros', NULL, 'PTKc_c-ros', NULL, NULL, NULL, 2),
(9402, NULL, 'cd07856', NULL, NULL, 'STKc_Sty1_Hog1', NULL, 'STKc_Sty1_Hog1', NULL, NULL, 28769, 2),
(9403, NULL, 'cd14256', NULL, NULL, 'Dockerin_I', NULL, 'Dockerin_I', NULL, NULL, NULL, 2),
(9404, NULL, 'cd11453', NULL, NULL, 'bHLH_AtBIM_like', NULL, 'bHLH_AtBIM_like', NULL, NULL, NULL, 2),
(9405, NULL, 'cd10371', NULL, NULL, 'SH2_Src_Blk', NULL, 'SH2_Src_Blk', NULL, NULL, 28446, 2),
(9406, NULL, 'cd05608', NULL, NULL, 'STKc_GRK1', NULL, 'STKc_GRK1', NULL, NULL, 32556, 2),
(9407, NULL, 'cd01298', NULL, NULL, 'ATZ_TRZ_like', NULL, 'ATZ_TRZ_like', NULL, NULL, NULL, 2),
(9408, NULL, 'cd04710', NULL, NULL, 'BAH_fungalPHD', NULL, 'BAH_fungalPHD', NULL, NULL, NULL, 2),
(9409, NULL, 'cd13315', NULL, NULL, 'PH_Sec3', NULL, 'PH_Sec3', NULL, NULL, NULL, 2),
(9410, NULL, 'cd14458', NULL, NULL, 'DP_DD', NULL, 'DP_DD', NULL, NULL, 13311, 2),
(9411, NULL, 'cd08191', NULL, NULL, 'Fe-ADH-like', NULL, 'Fe-ADH-like', NULL, NULL, NULL, 2),
(9412, NULL, 'cd15156', NULL, NULL, '7tmA_LPAR6_P2Y5', NULL, '7tmA_LPAR6_P2Y5', NULL, NULL, NULL, 2),
(9413, NULL, 'cd17021', NULL, NULL, 'T3SC_IA_SicP-like', NULL, 'T3SC_IA_SicP-like', NULL, NULL, 34580, 2),
(9414, NULL, 'cd07996', NULL, NULL, 'WGR_MMR_like', NULL, 'WGR_MMR_like', NULL, NULL, NULL, 2),
(9415, NULL, 'cd12731', NULL, NULL, 'RRM2_hnRNPH_hnRNPH2_hnRNPF', NULL, 'RRM2_hnRNPH_hnRNPH2_hnRNPF', NULL, NULL, NULL, 2),
(9416, NULL, 'cd16238', NULL, NULL, 'EFh_SPARC_TICN2', NULL, 'EFh_SPARC_TICN2', NULL, NULL, NULL, 2),
(9417, NULL, 'cd07180', NULL, NULL, 'RNase_HII_archaea_like', NULL, 'RNase_HII_archaea_like', NULL, NULL, NULL, 2),
(9418, NULL, 'cd12795', NULL, NULL, 'FILIA_N_like', NULL, 'FILIA_N_like', NULL, NULL, 26705, 2),
(9419, NULL, 'cd12235', NULL, NULL, 'RRM_PPIL4', NULL, 'RRM_PPIL4', NULL, NULL, NULL, 2),
(9420, NULL, 'cd04366', NULL, NULL, 'IlGF_insulin_bombyxin_like', NULL, 'IlGF_insulin_bombyxin_like', NULL, NULL, NULL, 2),
(9421, NULL, 'cd05235', NULL, NULL, 'SDR_e1', NULL, 'SDR_e1', NULL, NULL, 2457, 2),
(9422, NULL, 'cd15145', NULL, NULL, '7tmA_FP', NULL, '7tmA_FP', NULL, NULL, NULL, 2),
(9423, NULL, 'cd12886', NULL, NULL, 'SPRY_like', NULL, 'SPRY_like', NULL, NULL, NULL, 2),
(9424, NULL, 'cd14918', NULL, NULL, 'MYSc_Myh8', NULL, 'MYSc_Myh8', NULL, NULL, NULL, 2),
(9425, NULL, 'cd00212', NULL, NULL, 'PTS_IIB_glc', NULL, 'PTS_IIB_glc', NULL, NULL, 944, 2),
(9426, NULL, 'cd02775', NULL, NULL, 'MopB_CT', NULL, 'MopB_CT', NULL, NULL, NULL, 2),
(9427, NULL, 'cd07738', NULL, NULL, 'DdPDE5-like_MBL-fold', NULL, 'DdPDE5-like_MBL-fold', NULL, NULL, NULL, 2),
(9428, NULL, 'cd10481', NULL, NULL, 'EphR_LBD_A3', NULL, 'EphR_LBD_A3', NULL, NULL, 21500, 2),
(9429, NULL, 'cd14543', NULL, NULL, 'PTPc-N9', NULL, 'PTPc-N9', NULL, NULL, NULL, 2),
(9430, NULL, 'cd00472', NULL, NULL, 'Ribosomal_L24e_L24', NULL, 'Ribosomal_L24e_L24', NULL, NULL, 42, 2),
(9431, NULL, 'cd06420', NULL, NULL, 'GT2_Chondriotin_Pol_N', NULL, 'GT2_Chondriotin_Pol_N', NULL, NULL, NULL, 2),
(9432, NULL, 'cd05238', NULL, NULL, 'Gne_like_SDR_e', NULL, 'Gne_like_SDR_e', NULL, NULL, NULL, 2),
(9433, NULL, 'cd13399', NULL, NULL, 'Slt35-like', NULL, 'Slt35-like', NULL, NULL, NULL, 2),
(9434, NULL, 'cd19696', NULL, NULL, 'bHLH-PAS_AhR_like', NULL, 'bHLH-PAS_AhR_like', NULL, NULL, NULL, 2),
(9435, NULL, 'cd15329', NULL, NULL, '7tmA_5-HT7', NULL, '7tmA_5-HT7', NULL, NULL, NULL, 2),
(9436, NULL, 'cd08686', NULL, NULL, 'C2_ABR', NULL, 'C2_ABR', NULL, NULL, NULL, 2),
(9437, NULL, 'cd10978', NULL, NULL, 'CE4_Sll1306_like', NULL, 'CE4_Sll1306_like', NULL, NULL, NULL, 2),
(9438, NULL, 'cd21564', NULL, NULL, 'alphaCoV_M', NULL, 'alphaCoV_M', NULL, NULL, 35253, 2),
(9439, NULL, 'cd08352', NULL, NULL, 'VOC_Bs_YwkD_like', NULL, 'VOC_Bs_YwkD_like', NULL, NULL, 32795, 2);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(9440, NULL, 'cd00279', NULL, NULL, 'YlxR', NULL, 'YlxR', NULL, NULL, 27005, 2),
(9441, NULL, 'cd03041', NULL, NULL, 'GST_N_2GST_N', NULL, 'GST_N_2GST_N', NULL, NULL, NULL, 2),
(9442, NULL, 'cd05697', NULL, NULL, 'S1_Rrp5_repeat_hs5', NULL, 'S1_Rrp5_repeat_hs5', NULL, NULL, NULL, 2),
(9443, NULL, 'cd08536', NULL, NULL, 'SAM_PNT-Mae', NULL, 'SAM_PNT-Mae', NULL, NULL, NULL, 2),
(9444, NULL, 'cd01050', NULL, NULL, 'Acyl_ACP_Desat', NULL, 'Acyl_ACP_Desat', NULL, NULL, 2203, 2),
(9445, NULL, 'cd07395', NULL, NULL, 'MPP_CSTP1', NULL, 'MPP_CSTP1', NULL, NULL, 30669, 2),
(9446, NULL, 'cd14345', NULL, NULL, 'UBA_UBXD7', NULL, 'UBA_UBXD7', NULL, NULL, NULL, 2),
(9447, NULL, 'cd10232', NULL, NULL, 'ScSsz1p_like_NBD', NULL, 'ScSsz1p_like_NBD', NULL, NULL, NULL, 2),
(9448, NULL, 'cd00835', NULL, NULL, 'RanBD_family', NULL, 'RanBD_family', NULL, NULL, NULL, 2),
(9449, NULL, 'cd20257', NULL, NULL, 'Stannin', NULL, 'Stannin', NULL, NULL, 32479, 2),
(9450, NULL, 'cd00954', NULL, NULL, 'NAL', NULL, 'NAL', NULL, NULL, 4396, 2),
(9451, NULL, 'cd15040', NULL, NULL, '7tmB2_Adhesion', NULL, '7tmB2_Adhesion', NULL, NULL, NULL, 2),
(9452, NULL, 'cd16825', NULL, NULL, 'RING_CH-C4HC3_MARCH9', NULL, 'RING_CH-C4HC3_MARCH9', NULL, NULL, NULL, 2),
(9453, NULL, 'cd05397', NULL, NULL, 'NT_Pol-beta-like', NULL, 'NT_Pol-beta-like', NULL, NULL, NULL, 2),
(9454, NULL, 'cd04813', NULL, NULL, 'PA_1', NULL, 'PA_1', NULL, NULL, NULL, 2),
(9455, NULL, 'cd16373', NULL, NULL, 'DMSOR_beta_like', NULL, 'DMSOR_beta_like', NULL, NULL, NULL, 2),
(9456, NULL, 'cd09971', NULL, NULL, 'SdiA-regulated', NULL, 'SdiA-regulated', NULL, NULL, 12392, 2),
(9457, NULL, 'cd19782', NULL, NULL, 'Bbox2_TRIM42_C-III', NULL, 'Bbox2_TRIM42_C-III', NULL, NULL, NULL, 2),
(9458, NULL, 'cd02022', NULL, NULL, 'DPCK', NULL, 'DPCK', NULL, NULL, NULL, 2),
(9459, NULL, 'cd04951', NULL, NULL, 'GT4_WbdM_like', NULL, 'GT4_WbdM_like', NULL, NULL, NULL, 2),
(9460, NULL, 'cd12240', NULL, NULL, 'RRM_NCBP2', NULL, 'RRM_NCBP2', NULL, NULL, 21339, 2),
(9461, NULL, 'cd03728', NULL, NULL, 'SOCS_ASB_9_11', NULL, 'SOCS_ASB_9_11', NULL, NULL, 29726, 2),
(9462, NULL, 'cd15706', NULL, NULL, 'ePHD_JADE3', NULL, 'ePHD_JADE3', NULL, NULL, NULL, 2),
(9463, NULL, 'cd07321', NULL, NULL, 'Extradiol_Dioxygenase_3A_like', NULL, 'Extradiol_Dioxygenase_3A_like', NULL, NULL, NULL, 2),
(9464, NULL, 'cd07347', NULL, NULL, 'harmonin_N_like', NULL, 'harmonin_N_like', NULL, NULL, NULL, 2),
(9465, NULL, 'cd15050', NULL, NULL, '7tmA_Histamine_H1R', NULL, '7tmA_Histamine_H1R', NULL, NULL, NULL, 2),
(9466, NULL, 'cd04587', NULL, NULL, 'CBS_pair_CAP-ED_NT_Pol-beta-like_DUF294_assoc', NULL, 'CBS_pair_CAP-ED_NT_Pol-beta-like_DUF294_assoc', NULL, NULL, NULL, 2),
(9467, NULL, 'cd10444', NULL, NULL, 'GIY-YIG_SegABCDEFG', NULL, 'GIY-YIG_SegABCDEFG', NULL, NULL, NULL, 2),
(9468, NULL, 'cd02110', NULL, NULL, 'SO_family_Moco_dimer', NULL, 'SO_family_Moco_dimer', NULL, NULL, NULL, 2),
(9469, NULL, 'cd04275', NULL, NULL, 'ZnMc_pappalysin_like', NULL, 'ZnMc_pappalysin_like', NULL, NULL, 12111, 2),
(9470, NULL, 'cd09727', NULL, NULL, 'Cas6_I-E', NULL, 'Cas6_I-E', NULL, NULL, NULL, 2),
(9471, NULL, 'cd10032', NULL, NULL, 'UDG-F6_HDG', NULL, 'UDG-F6_HDG', NULL, NULL, NULL, 2),
(9472, NULL, 'cd09739', NULL, NULL, 'Cas6_I-F', NULL, 'Cas6_I-F', NULL, NULL, 11056, 2),
(9473, NULL, 'cd00477', NULL, NULL, 'FTHFS', NULL, 'FTHFS', NULL, NULL, 5667, 2),
(9474, NULL, 'cd10568', NULL, NULL, 'SWIB_like', NULL, 'SWIB_like', NULL, NULL, NULL, 2),
(9475, NULL, 'cd16159', NULL, NULL, 'ES', NULL, 'ES', NULL, NULL, NULL, 2),
(9476, NULL, 'cd01218', NULL, NULL, 'PH_Phafin2-like', NULL, 'PH_Phafin2-like', NULL, NULL, 32256, 2),
(9477, NULL, 'cd01165', NULL, NULL, 'BTB_POZ', NULL, 'BTB_POZ', NULL, NULL, NULL, 2),
(9478, NULL, 'cd11623', NULL, NULL, 'HR1_PKN_2', NULL, 'HR1_PKN_2', NULL, NULL, NULL, 2),
(9479, NULL, 'cd16781', NULL, NULL, 'mRING-HC-C3HC3D_Roquin1', NULL, 'mRING-HC-C3HC3D_Roquin1', NULL, NULL, NULL, 2),
(9480, NULL, 'cd08696', NULL, NULL, 'C2_Dock-C', NULL, 'C2_Dock-C', NULL, NULL, 29553, 2),
(9481, NULL, 'cd12377', NULL, NULL, 'RRM3_Hu', NULL, 'RRM3_Hu', NULL, NULL, NULL, 2);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(9482, NULL, 'cd16097', NULL, NULL, 'IgV_SIRP', NULL, 'IgV_SIRP', NULL, NULL, NULL, 2),
(9483, NULL, 'cd15842', NULL, NULL, 'SNARE_Qb', NULL, 'SNARE_Qb', NULL, NULL, NULL, 2),
(9484, NULL, 'cd17420', NULL, NULL, 'MFS_MCT8_10', NULL, 'MFS_MCT8_10', NULL, NULL, NULL, 2),
(9485, NULL, 'cd07596', NULL, NULL, 'BAR_SNX', NULL, 'BAR_SNX', NULL, NULL, NULL, 2),
(9486, NULL, 'cd16813', NULL, NULL, 'RING_CH-C4HC3_MARCH10', NULL, 'RING_CH-C4HC3_MARCH10', NULL, NULL, 35793, 2),
(9487, NULL, 'cd05518', NULL, NULL, 'Bromo_polybromo_IV', NULL, 'Bromo_polybromo_IV', NULL, NULL, NULL, 2),
(9488, NULL, 'cd15020', NULL, NULL, '7tm_TAS2R3', NULL, '7tm_TAS2R3', NULL, NULL, NULL, 2),
(9489, NULL, 'cd09115', NULL, NULL, 'PLDc_PPK1_C2', NULL, 'PLDc_PPK1_C2', NULL, NULL, NULL, 2),
(9490, NULL, 'cd13663', NULL, NULL, 'PBP2_PotD_PotF_like_2', NULL, 'PBP2_PotD_PotF_like_2', NULL, NULL, NULL, 2),
(9491, NULL, 'cd11655', NULL, NULL, 'rap1_myb-like', NULL, 'rap1_myb-like', NULL, NULL, NULL, 2),
(9492, NULL, 'cd13150', NULL, NULL, 'DAXX_histone_binding', NULL, 'DAXX_histone_binding', NULL, NULL, 37586, 2),
(9493, NULL, 'cd19155', NULL, NULL, 'AKR_AKR1I_CgAKR1', NULL, 'AKR_AKR1I_CgAKR1', NULL, NULL, NULL, 2),
(9494, NULL, 'cd00184', NULL, NULL, 'TNF', NULL, 'TNF', NULL, NULL, 2809, 2),
(9495, NULL, 'cd10405', NULL, NULL, 'SH2_Vav1', NULL, 'SH2_Vav1', NULL, NULL, 32956, 2),
(9496, NULL, 'cd00879', NULL, NULL, 'Sar1', NULL, 'Sar1', NULL, NULL, NULL, 2),
(9497, NULL, 'cd14976', NULL, NULL, '7tmA_RNL3R', NULL, '7tmA_RNL3R', NULL, NULL, NULL, 2),
(9498, NULL, 'cd16528', NULL, NULL, 'RING-HC_prokRING', NULL, 'RING-HC_prokRING', NULL, NULL, NULL, 2),
(9499, NULL, 'cd07925', NULL, NULL, 'LigA_like_1', NULL, 'LigA_like_1', NULL, NULL, NULL, 2),
(9500, NULL, 'cd00989', NULL, NULL, 'PDZ_metalloprotease', NULL, 'PDZ_metalloprotease', NULL, NULL, NULL, 2),
(9501, NULL, 'cd07591', NULL, NULL, 'BAR_Rvs161p', NULL, 'BAR_Rvs161p', NULL, NULL, 33316, 2),
(9502, NULL, 'cd11627', NULL, NULL, 'HR1_Ste20-like', NULL, 'HR1_Ste20-like', NULL, NULL, NULL, 2),
(9503, NULL, 'cd06260', NULL, NULL, 'DUF820', NULL, 'DUF820', NULL, NULL, 13394, 2),
(9504, NULL, 'cd06421', NULL, NULL, 'CESA_CelA_like', NULL, 'CESA_CelA_like', NULL, NULL, NULL, 2),
(9505, NULL, 'cd14083', NULL, NULL, 'STKc_CaMKI', NULL, 'STKc_CaMKI', NULL, NULL, NULL, 2),
(9506, NULL, 'cd12681', NULL, NULL, 'RRM_SKAR', NULL, 'RRM_SKAR', NULL, NULL, 18868, 2),
(9507, NULL, 'cd00992', NULL, NULL, 'PDZ_signaling', NULL, 'PDZ_signaling', NULL, NULL, NULL, 2),
(9508, NULL, 'cd08156', NULL, NULL, 'catalase_clade_3', NULL, 'catalase_clade_3', NULL, NULL, 27722, 2),
(9509, NULL, 'cd09685', NULL, NULL, 'Cas7_I-A', NULL, 'Cas7_I-A', NULL, NULL, NULL, 2),
(9510, NULL, 'cd14321', NULL, NULL, 'UBA_IAPs', NULL, 'UBA_IAPs', NULL, NULL, NULL, 2),
(9511, NULL, 'cd15649', NULL, NULL, 'PHD1_NSD3', NULL, 'PHD1_NSD3', NULL, NULL, NULL, 2),
(9512, NULL, 'cd00552', NULL, NULL, 'RaiA', NULL, 'RaiA', NULL, NULL, 6480, 2),
(9513, NULL, 'cd14587', NULL, NULL, 'PTP-MTMR4', NULL, 'PTP-MTMR4', NULL, NULL, NULL, 2),
(9514, NULL, 'cd08213', NULL, NULL, 'RuBisCO_large_III', NULL, 'RuBisCO_large_III', NULL, NULL, 17920, 2),
(9515, NULL, 'cd09302', NULL, NULL, 'Jacalin_like', NULL, 'Jacalin_like', NULL, NULL, NULL, 2),
(9516, NULL, 'cd13644', NULL, NULL, 'PBP2_HemC_archaea', NULL, 'PBP2_HemC_archaea', NULL, NULL, NULL, 2),
(9517, NULL, 'cd01308', NULL, NULL, 'Isoaspartyl-dipeptidase', NULL, 'Isoaspartyl-dipeptidase', NULL, NULL, 31203, 2),
(9518, NULL, 'cd00948', NULL, NULL, 'FBP_aldolase_I_a', NULL, 'FBP_aldolase_I_a', NULL, NULL, NULL, 2),
(9519, NULL, 'cd00743', NULL, NULL, 'lipocalin_RBP_like', NULL, 'lipocalin_RBP_like', NULL, NULL, NULL, 2),
(9520, NULL, 'cd17620', NULL, NULL, 'REC_OmpR_KdpE-like', NULL, 'REC_OmpR_KdpE-like', NULL, NULL, NULL, 2),
(9521, NULL, 'cd12626', NULL, NULL, 'RRM1_IGF2BP2', NULL, 'RRM1_IGF2BP2', NULL, NULL, 33409, 2),
(9522, NULL, 'cd10421', NULL, NULL, 'SH2_STAT5a', NULL, 'SH2_STAT5a', NULL, NULL, NULL, 2),
(9523, NULL, 'cd16214', NULL, NULL, 'EFh_PI-PLCgamma1', NULL, 'EFh_PI-PLCgamma1', NULL, NULL, NULL, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(9524, NULL, 'cd12581', NULL, NULL, 'RRM2_hnRNPA2B1', NULL, 'RRM2_hnRNPA2B1', NULL, NULL, NULL, 2),
(9525, NULL, 'cd11766', NULL, NULL, 'SH3_Nck_2', NULL, 'SH3_Nck_2', NULL, NULL, NULL, 2),
(9526, NULL, 'cd08701', NULL, NULL, 'FMT_C_HypX', NULL, 'FMT_C_HypX', NULL, NULL, NULL, 2),
(9527, NULL, 'cd14385', NULL, NULL, 'UBA1_spUBP14_like', NULL, 'UBA1_spUBP14_like', NULL, NULL, NULL, 2),
(9528, NULL, 'cd05891', NULL, NULL, 'Ig_M-protein_C', NULL, 'Ig_M-protein_C', NULL, NULL, NULL, 2),
(9529, NULL, 'cd17262', NULL, NULL, 'RMtype1_S_Aco12261I-TRD2-CR2', NULL, 'RMtype1_S_Aco12261I-TRD2-CR2', NULL, NULL, NULL, 2),
(9530, NULL, 'cd16662', NULL, NULL, 'RING-Ubox2_NOSIP', NULL, 'RING-Ubox2_NOSIP', NULL, NULL, NULL, 2),
(9531, NULL, 'cd04014', NULL, NULL, 'C2_PKC_epsilon', NULL, 'C2_PKC_epsilon', NULL, NULL, NULL, 2),
(9532, NULL, 'cd17010', NULL, NULL, 'VHS_GGA2', NULL, 'VHS_GGA2', NULL, NULL, NULL, 2),
(9533, NULL, 'cd16107', NULL, NULL, 'Ubl_AtUPL5_like', NULL, 'Ubl_AtUPL5_like', NULL, NULL, NULL, 2),
(9534, NULL, 'cd19153', NULL, NULL, 'AKR_galDH-like', NULL, 'AKR_galDH-like', NULL, NULL, NULL, 2),
(9535, NULL, 'cd18140', NULL, NULL, 'HLD_clamp_RFC', NULL, 'HLD_clamp_RFC', NULL, NULL, NULL, 2),
(9536, NULL, 'cd05849', NULL, NULL, 'Ig1_Contactin-1', NULL, 'Ig1_Contactin-1', NULL, NULL, NULL, 2),
(9537, NULL, 'cd00211', NULL, NULL, 'PTS_IIA_fru', NULL, 'PTS_IIA_fru', NULL, NULL, 5869, 2),
(9538, NULL, 'cd11898', NULL, NULL, 'SH3_SNX9', NULL, 'SH3_SNX9', NULL, NULL, 33052, 2),
(9539, NULL, 'cd15526', NULL, NULL, 'PHD1_MOZ_d4', NULL, 'PHD1_MOZ_d4', NULL, NULL, NULL, 2),
(9540, NULL, 'cd08746', NULL, NULL, 'RGS_RGS20', NULL, 'RGS_RGS20', NULL, NULL, NULL, 2),
(9541, NULL, 'cd05897', NULL, NULL, 'Ig2_IL1R2_like', NULL, 'Ig2_IL1R2_like', NULL, NULL, NULL, 2),
(9542, NULL, 'cd17904', NULL, NULL, 'PFM_monalysin-like', NULL, 'PFM_monalysin-like', NULL, NULL, NULL, 2),
(9543, NULL, 'cd00929', NULL, NULL, 'Cyt_c_Oxidase_VIIc', NULL, 'Cyt_c_Oxidase_VIIc', NULL, NULL, 2700, 2),
(9544, NULL, 'cd07830', NULL, NULL, 'STKc_MAK_like', NULL, 'STKc_MAK_like', NULL, NULL, NULL, 2),
(9545, NULL, 'cd00616', NULL, NULL, 'AHBA_syn', NULL, 'AHBA_syn', NULL, NULL, 4124, 2),
(9546, NULL, 'cd07515', NULL, NULL, 'HAD-like', NULL, 'HAD-like', NULL, NULL, NULL, 2),
(9547, NULL, 'cd03877', NULL, NULL, 'M28_like', NULL, 'M28_like', NULL, NULL, NULL, 2),
(9548, NULL, 'cd16771', NULL, NULL, 'RING-HC_UNK', NULL, 'RING-HC_UNK', NULL, NULL, NULL, 2),
(9549, NULL, 'cd18650', NULL, NULL, 'CD_HP1beta_Cbx1', NULL, 'CD_HP1beta_Cbx1', NULL, NULL, NULL, 2),
(9550, NULL, 'cd00754', NULL, NULL, 'Ubl_MoaD', NULL, 'Ubl_MoaD', NULL, NULL, NULL, 2),
(9551, NULL, 'cd11495', NULL, NULL, 'SLC5sbd_NIS-like_u3', NULL, 'SLC5sbd_NIS-like_u3', NULL, NULL, NULL, 2),
(9552, NULL, 'cd01316', NULL, NULL, 'CAD_DHOase', NULL, 'CAD_DHOase', NULL, NULL, NULL, 2),
(9553, NULL, 'cd16865', NULL, NULL, 'ARID_ARID1A-like', NULL, 'ARID_ARID1A-like', NULL, NULL, NULL, 2),
(9554, NULL, 'cd01745', NULL, NULL, 'GATase1_2', NULL, 'GATase1_2', NULL, NULL, NULL, 2),
(9555, NULL, 'cd01881', NULL, NULL, 'Obg_like', NULL, 'Obg_like', NULL, NULL, NULL, 2),
(9556, NULL, 'cd12020', NULL, NULL, 'SH3_Tks5_5', NULL, 'SH3_Tks5_5', NULL, NULL, 20199, 2),
(9557, NULL, 'cd18678', NULL, NULL, 'PIN_MtVapC25_VapC33-like', NULL, 'PIN_MtVapC25_VapC33-like', NULL, NULL, NULL, 2),
(9558, NULL, 'cd09669', NULL, NULL, 'Cse1_I-E', NULL, 'Cse1_I-E', NULL, NULL, 11060, 2),
(9559, NULL, 'cd01985', NULL, NULL, 'ETF', NULL, 'ETF', NULL, NULL, NULL, 2),
(9560, NULL, 'cd09280', NULL, NULL, 'RNase_HI_eukaryote_like', NULL, 'RNase_HI_eukaryote_like', NULL, NULL, NULL, 2),
(9561, NULL, 'cd02055', NULL, NULL, 'serpinA10_PZI', NULL, 'serpinA10_PZI', NULL, NULL, 31927, 2),
(9562, NULL, 'cd07145', NULL, NULL, 'ALDH_LactADH_F420-Bios', NULL, 'ALDH_LactADH_F420-Bios', NULL, NULL, NULL, 2),
(9563, NULL, 'cd17142', NULL, NULL, 'DCX2_DCX', NULL, 'DCX2_DCX', NULL, NULL, NULL, 2),
(9564, NULL, 'cd11975', NULL, NULL, 'SH3_ARHGEF9', NULL, 'SH3_ARHGEF9', NULL, NULL, 27787, 2),
(9565, NULL, 'cd19749', NULL, NULL, 'bHLH-O_DEC1', NULL, 'bHLH-O_DEC1', NULL, NULL, NULL, 2);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(9566, NULL, 'cd09842', NULL, NULL, 'PLDc_vPLD1_1', NULL, 'PLDc_vPLD1_1', NULL, NULL, NULL, 2),
(9567, NULL, 'cd16314', NULL, NULL, 'AIM-1-like_MBL-B3', NULL, 'AIM-1-like_MBL-B3', NULL, NULL, NULL, 2),
(9568, NULL, 'cd04696', NULL, NULL, 'Nudix_Hydrolase_37', NULL, 'Nudix_Hydrolase_37', NULL, NULL, NULL, 2),
(9569, NULL, 'cd10948', NULL, NULL, 'CE4_BsPdaA_like', NULL, 'CE4_BsPdaA_like', NULL, NULL, 10830, 2),
(9570, NULL, 'cd00220', NULL, NULL, 'VMO-I', NULL, 'VMO-I', NULL, NULL, 1610, 2),
(9571, NULL, 'cd15985', NULL, NULL, '7tmB1_GlucagonR-like_1', NULL, '7tmB1_GlucagonR-like_1', NULL, NULL, NULL, 2),
(9572, NULL, 'cd17074', NULL, NULL, 'Ubl_CysO_like', NULL, 'Ubl_CysO_like', NULL, NULL, NULL, 2),
(9573, NULL, 'cd17569', NULL, NULL, 'REC_HupR-like', NULL, 'REC_HupR-like', NULL, NULL, NULL, 2),
(9574, NULL, 'cd08274', NULL, NULL, 'MDR9', NULL, 'MDR9', NULL, NULL, NULL, 2),
(9575, NULL, 'cd04416', NULL, NULL, 'NDPk_TX', NULL, 'NDPk_TX', NULL, NULL, NULL, 2),
(9576, NULL, 'cd02214', NULL, NULL, 'cupin_MJ1618', NULL, 'cupin_MJ1618', NULL, NULL, NULL, 2),
(9577, NULL, 'cd12911', NULL, NULL, 'HK_sensor', NULL, 'HK_sensor', NULL, NULL, NULL, 2),
(9578, NULL, 'cd13323', NULL, NULL, 'PH_PLEKHN1', NULL, 'PH_PLEKHN1', NULL, NULL, 29977, 2),
(9579, NULL, 'cd08270', NULL, NULL, 'MDR4', NULL, 'MDR4', NULL, NULL, NULL, 2),
(9580, NULL, 'cd05906', NULL, NULL, 'A_NRPS_TubE_like', NULL, 'A_NRPS_TubE_like', NULL, NULL, NULL, 2),
(9581, NULL, 'cd13179', NULL, NULL, 'RanBD_RanBP1', NULL, 'RanBD_RanBP1', NULL, NULL, 37324, 2),
(9582, NULL, 'cd00564', NULL, NULL, 'TMP_TenI', NULL, 'TMP_TenI', NULL, NULL, 15149, 2),
(9583, NULL, 'cd06127', NULL, NULL, 'DEDDh', NULL, 'DEDDh', NULL, NULL, NULL, 2),
(9584, NULL, 'cd17121', NULL, NULL, 'Ubl_UBTD2', NULL, 'Ubl_UBTD2', NULL, NULL, NULL, 2),
(9585, NULL, 'cd12337', NULL, NULL, 'RRM1_SRSF4_like', NULL, 'RRM1_SRSF4_like', NULL, NULL, 29117, 2),
(9586, NULL, 'cd15865', NULL, NULL, 'SNARE_SEC20', NULL, 'SNARE_SEC20', NULL, NULL, NULL, 2),
(9587, NULL, 'cd04109', NULL, NULL, 'Rab28', NULL, 'Rab28', NULL, NULL, NULL, 2),
(9588, NULL, 'cd05944', NULL, NULL, 'FACL_like_4', NULL, 'FACL_like_4', NULL, NULL, NULL, 2),
(9589, NULL, 'cd06141', NULL, NULL, 'WRN_exo', NULL, 'WRN_exo', NULL, NULL, NULL, 2),
(9590, NULL, 'cd19457', NULL, NULL, 'lipocalin_2-like', NULL, 'lipocalin_2-like', NULL, NULL, NULL, 2),
(9591, NULL, 'cd05807', NULL, NULL, 'CBM20_CGTase', NULL, 'CBM20_CGTase', NULL, NULL, NULL, 2),
(9592, NULL, 'cd10340', NULL, NULL, 'SH2_N-SH2_SHP_like', NULL, 'SH2_N-SH2_SHP_like', NULL, NULL, NULL, 2),
(9593, NULL, 'cd12638', NULL, NULL, 'RRM3_CELF1_2', NULL, 'RRM3_CELF1_2', NULL, NULL, 7152, 2),
(9594, NULL, 'cd02241', NULL, NULL, 'cupin_OxOx', NULL, 'cupin_OxOx', NULL, NULL, NULL, 2),
(9595, NULL, 'cd02083', NULL, NULL, 'P-type_ATPase_SERCA', NULL, 'P-type_ATPase_SERCA', NULL, NULL, NULL, 2),
(9596, NULL, 'cd11966', NULL, NULL, 'SH3_ASAP2', NULL, 'SH3_ASAP2', NULL, NULL, 30704, 2),
(9597, NULL, 'cd05031', NULL, NULL, 'S-100A10_like', NULL, 'S-100A10_like', NULL, NULL, NULL, 2),
(9598, NULL, 'cd12165', NULL, NULL, '2-Hacid_dh_6', NULL, '2-Hacid_dh_6', NULL, NULL, NULL, 2),
(9599, NULL, 'cd17167', NULL, NULL, 'RAWUL_RING2', NULL, 'RAWUL_RING2', NULL, NULL, NULL, 2),
(9600, NULL, 'cd07934', NULL, NULL, 'RHD-n_NFkB2', NULL, 'RHD-n_NFkB2', NULL, NULL, NULL, 2),
(9601, NULL, 'cd18814', NULL, NULL, 'CAP_PI15', NULL, 'CAP_PI15', NULL, NULL, NULL, 2),
(9602, NULL, 'cd14312', NULL, NULL, 'UBA_II_E2_UBC27_like', NULL, 'UBA_II_E2_UBC27_like', NULL, NULL, 30316, 2),
(9603, NULL, 'cd17036', NULL, NULL, 'T3SC_YbjN-like_1', NULL, 'T3SC_YbjN-like_1', NULL, NULL, NULL, 2),
(9604, NULL, 'cd18988', NULL, NULL, 'LGIC_ECD_bact', NULL, 'LGIC_ECD_bact', NULL, NULL, NULL, 2),
(9605, NULL, 'cd10328', NULL, NULL, 'SLC5sbd_YidK', NULL, 'SLC5sbd_YidK', NULL, NULL, NULL, 2),
(9606, NULL, 'cd11667', NULL, NULL, 'GH38N_Man2A2', NULL, 'GH38N_Man2A2', NULL, NULL, NULL, 2),
(9607, NULL, 'cd04241', NULL, NULL, 'AAK_FomA-like', NULL, 'AAK_FomA-like', NULL, NULL, 13724, 2),
(9608, NULL, 'cd08578', NULL, NULL, 'GDPD_NUC-2_fungi', NULL, 'GDPD_NUC-2_fungi', NULL, NULL, NULL, 2);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(9609, NULL, 'cd18366', NULL, NULL, 'BTB_POZ_KCTD7', NULL, 'BTB_POZ_KCTD7', NULL, NULL, NULL, 2),
(9610, NULL, 'cd03736', NULL, NULL, 'SOCS_SOCS2', NULL, 'SOCS_SOCS2', NULL, NULL, NULL, 2),
(9611, NULL, 'cd05166', NULL, NULL, 'PI3Kc_II', NULL, 'PI3Kc_II', NULL, NULL, NULL, 2),
(9612, NULL, 'cd11294', NULL, NULL, 'E_set_Esterase_like_N', NULL, 'E_set_Esterase_like_N', NULL, NULL, NULL, 2),
(9613, NULL, 'cd16879', NULL, NULL, 'ARID_ARID3B', NULL, 'ARID_ARID3B', NULL, NULL, NULL, 2),
(9614, NULL, 'cd00541', NULL, NULL, 'OMPLA', NULL, 'OMPLA', NULL, NULL, 3435, 2),
(9615, NULL, 'cd03109', NULL, NULL, 'DTBS', NULL, 'DTBS', NULL, NULL, NULL, 2),
(9616, NULL, 'cd04019', NULL, NULL, 'C2C_MCTP_PRT_plant', NULL, 'C2C_MCTP_PRT_plant', NULL, NULL, NULL, 2),
(9617, NULL, 'cd03161', NULL, NULL, 'TM4SF2_6_like_LEL', NULL, 'TM4SF2_6_like_LEL', NULL, NULL, NULL, 2),
(9618, NULL, 'cd07848', NULL, NULL, 'STKc_CDKL5', NULL, 'STKc_CDKL5', NULL, NULL, NULL, 2),
(9619, NULL, 'cd05883', NULL, NULL, 'Ig2_Necl-2', NULL, 'Ig2_Necl-2', NULL, NULL, NULL, 2),
(9620, NULL, 'cd19948', NULL, NULL, 'NasA-like_Fer2_BFD-like', NULL, 'NasA-like_Fer2_BFD-like', NULL, NULL, NULL, 2),
(9621, NULL, 'cd15534', NULL, NULL, 'PHD2_PHF12_Rco1', NULL, 'PHD2_PHF12_Rco1', NULL, NULL, NULL, 2),
(9622, NULL, 'cd03493', NULL, NULL, 'SQR_QFR_TM', NULL, 'SQR_QFR_TM', NULL, NULL, NULL, 2),
(9623, NULL, 'cd09518', NULL, NULL, 'SAM_ANKS6', NULL, 'SAM_ANKS6', NULL, NULL, NULL, 2),
(9624, NULL, 'cd11392', NULL, NULL, 'bHLH_ScPHO4_like', NULL, 'bHLH_ScPHO4_like', NULL, NULL, NULL, 2),
(9625, NULL, 'cd01817', NULL, NULL, 'RBD1_RGS12_like', NULL, 'RBD1_RGS12_like', NULL, NULL, NULL, 2),
(9626, NULL, 'cd02066', NULL, NULL, 'GRX_family', NULL, 'GRX_family', NULL, NULL, NULL, 2),
(9627, NULL, 'cd18556', NULL, NULL, 'ABC_6TM_McjD_like', NULL, 'ABC_6TM_McjD_like', NULL, NULL, NULL, 2),
(9628, NULL, 'cd14491', NULL, NULL, 'lipocalin_MxiM-like', NULL, 'lipocalin_MxiM-like', NULL, NULL, NULL, 2),
(9629, NULL, 'cd01528', NULL, NULL, 'RHOD_2', NULL, 'RHOD_2', NULL, NULL, NULL, 2),
(9630, NULL, 'cd06275', NULL, NULL, 'PBP1_PurR', NULL, 'PBP1_PurR', NULL, NULL, NULL, 2),
(9631, NULL, 'cd07493', NULL, NULL, 'Peptidases_S8_9', NULL, 'Peptidases_S8_9', NULL, NULL, NULL, 2),
(9632, NULL, 'cd19810', NULL, NULL, 'Bbox1_TRIM56_C-V', NULL, 'Bbox1_TRIM56_C-V', NULL, NULL, NULL, 2),
(9633, NULL, 'cd07775', NULL, NULL, 'FGGY_AI-2K', NULL, 'FGGY_AI-2K', NULL, NULL, 29466, 2),
(9634, NULL, 'cd13188', NULL, NULL, 'FERM_C_PTPN14_PTPN21', NULL, 'FERM_C_PTPN14_PTPN21', NULL, NULL, 30891, 2),
(9635, NULL, 'cd10290', NULL, NULL, 'GST_C_MetRS_N_fungi', NULL, 'GST_C_MetRS_N_fungi', NULL, NULL, NULL, 2),
(9636, NULL, 'cd07135', NULL, NULL, 'ALDH_F14-YMR110C', NULL, 'ALDH_F14-YMR110C', NULL, NULL, NULL, 2),
(9637, NULL, 'cd16318', NULL, NULL, 'MUS_TUS_MBL-B1', NULL, 'MUS_TUS_MBL-B1', NULL, NULL, NULL, 2),
(9638, NULL, 'cd19392', NULL, NULL, 'TGF_beta_DPP', NULL, 'TGF_beta_DPP', NULL, NULL, NULL, 2),
(9639, NULL, 'cd14991', NULL, NULL, '7tmA_HCAR-like', NULL, '7tmA_HCAR-like', NULL, NULL, NULL, 2),
(9640, NULL, 'cd00755', NULL, NULL, 'YgdL_like', NULL, 'YgdL_like', NULL, NULL, NULL, 2),
(9641, NULL, 'cd17358', NULL, NULL, 'MFS_GLUT6_8_Class3_like', NULL, 'MFS_GLUT6_8_Class3_like', NULL, NULL, 36241, 2),
(9642, NULL, 'cd14202', NULL, NULL, 'STKc_ULK1', NULL, 'STKc_ULK1', NULL, NULL, NULL, 2),
(9643, NULL, 'cd12155', NULL, NULL, 'PGDH_1', NULL, 'PGDH_1', NULL, NULL, NULL, 2),
(9644, NULL, 'cd16940', NULL, NULL, 'HATPase_BasS-like', NULL, 'HATPase_BasS-like', NULL, NULL, NULL, 2),
(9645, NULL, 'cd18517', NULL, NULL, 'BACK_KLHL41_KBTBD10', NULL, 'BACK_KLHL41_KBTBD10', NULL, NULL, NULL, 2),
(9646, NULL, 'cd16104', NULL, NULL, 'Ubl_USP14_like', NULL, 'Ubl_USP14_like', NULL, NULL, NULL, 2),
(9647, NULL, 'cd09113', NULL, NULL, 'PLDc_ymdC_like_2', NULL, 'PLDc_ymdC_like_2', NULL, NULL, NULL, 2),
(9648, NULL, 'cd03333', NULL, NULL, 'chaperonin_like', NULL, 'chaperonin_like', NULL, NULL, NULL, 2),
(9649, NULL, 'cd04233', NULL, NULL, 'Auracyanin', NULL, 'Auracyanin', NULL, NULL, NULL, 2),
(9650, NULL, 'cd07082', NULL, NULL, 'ALDH_F11_NP-GAPDH', NULL, 'ALDH_F11_NP-GAPDH', NULL, NULL, NULL, 2);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(9651, NULL, 'cd02406', NULL, NULL, 'CRS2', NULL, 'CRS2', NULL, NULL, NULL, 2),
(9652, NULL, 'cd07776', NULL, NULL, 'FGGY_D-XK_euk', NULL, 'FGGY_D-XK_euk', NULL, NULL, 30597, 2),
(9653, NULL, 'cd09767', NULL, NULL, 'Csx17_I-U', NULL, 'Csx17_I-U', NULL, NULL, NULL, 2),
(9654, NULL, 'cd05933', NULL, NULL, 'ACSBG_like', NULL, 'ACSBG_like', NULL, NULL, NULL, 2),
(9655, NULL, 'cd11682', NULL, NULL, 'HDAC6-dom1', NULL, 'HDAC6-dom1', NULL, NULL, NULL, 2),
(9656, NULL, 'cd14219', NULL, NULL, 'STKc_BMPR1b', NULL, 'STKc_BMPR1b', NULL, NULL, NULL, 2),
(9657, NULL, 'cd06129', NULL, NULL, 'RNaseD_like', NULL, 'RNaseD_like', NULL, NULL, NULL, 2),
(9658, NULL, 'cd10325', NULL, NULL, 'SLC5sbd_vSGLT', NULL, 'SLC5sbd_vSGLT', NULL, NULL, NULL, 2),
(9659, NULL, 'cd14182', NULL, NULL, 'STKc_PhKG1', NULL, 'STKc_PhKG1', NULL, NULL, NULL, 2),
(9660, NULL, 'cd17727', NULL, NULL, 'BRCT_TopBP1_rpt6', NULL, 'BRCT_TopBP1_rpt6', NULL, NULL, NULL, 2),
(9661, NULL, 'cd14273', NULL, NULL, 'UBA_TAP-C_like', NULL, 'UBA_TAP-C_like', NULL, NULL, NULL, 2),
(9662, NULL, 'cd07606', NULL, NULL, 'BAR_SFC_plant', NULL, 'BAR_SFC_plant', NULL, NULL, 32382, 2),
(9663, NULL, 'cd08737', NULL, NULL, 'RGS_RGS6', NULL, 'RGS_RGS6', NULL, NULL, 28336, 2),
(9664, NULL, 'cd11947', NULL, NULL, 'SH3_GRAP2_N', NULL, 'SH3_GRAP2_N', NULL, NULL, NULL, 2),
(9665, NULL, 'cd10297', NULL, NULL, 'GST_C_CLIC5', NULL, 'GST_C_CLIC5', NULL, NULL, 31993, 2),
(9666, NULL, 'cd07512', NULL, NULL, 'HAD_PGPase', NULL, 'HAD_PGPase', NULL, NULL, NULL, 2),
(9667, NULL, 'cd18693', NULL, NULL, 'PIN_VapC-like', NULL, 'PIN_VapC-like', NULL, NULL, NULL, 2),
(9668, NULL, 'cd03032', NULL, NULL, 'ArsC_Spx', NULL, 'ArsC_Spx', NULL, NULL, NULL, 2),
(9669, NULL, 'cd18500', NULL, NULL, 'BACK_IBtk', NULL, 'BACK_IBtk', NULL, NULL, NULL, 2),
(9670, NULL, 'cd16868', NULL, NULL, 'ARID_ARID4', NULL, 'ARID_ARID4', NULL, NULL, NULL, 2),
(9671, NULL, 'cd09152', NULL, NULL, 'PLDc_EcCLS_like_1', NULL, 'PLDc_EcCLS_like_1', NULL, NULL, NULL, 2),
(9672, NULL, 'cd12472', NULL, NULL, 'RRM1_RBMS3', NULL, 'RRM1_RBMS3', NULL, NULL, NULL, 2),
(9673, NULL, 'cd01376', NULL, NULL, 'KISc_KID_like', NULL, 'KISc_KID_like', NULL, NULL, NULL, 2),
(9674, NULL, 'cd12753', NULL, NULL, 'RRM1_RBM10', NULL, 'RRM1_RBM10', NULL, NULL, NULL, 2),
(9675, NULL, 'cd16114', NULL, NULL, 'Ubl_SUMO1', NULL, 'Ubl_SUMO1', NULL, NULL, 37701, 2),
(9676, NULL, 'cd09373', NULL, NULL, 'LIM1_AWH', NULL, 'LIM1_AWH', NULL, NULL, NULL, 2),
(9677, NULL, 'cd19926', NULL, NULL, 'REC_PilR', NULL, 'REC_PilR', NULL, NULL, NULL, 2),
(9678, NULL, 'cd16757', NULL, NULL, 'RING-HC_TRIM46', NULL, 'RING-HC_TRIM46', NULL, NULL, NULL, 2),
(9679, NULL, 'cd05624', NULL, NULL, 'STKc_MRCK_beta', NULL, 'STKc_MRCK_beta', NULL, NULL, 36674, 2),
(9680, NULL, 'cd04406', NULL, NULL, 'RhoGAP_myosin_IXA', NULL, 'RhoGAP_myosin_IXA', NULL, NULL, NULL, 2),
(9681, NULL, 'cd15239', NULL, NULL, '7tm_YRO2_fungal-like', NULL, '7tm_YRO2_fungal-like', NULL, NULL, 33735, 2),
(9682, NULL, 'cd15893', NULL, NULL, 'R-SNARE_STXBP5', NULL, 'R-SNARE_STXBP5', NULL, NULL, NULL, 2),
(9683, NULL, 'cd09701', NULL, NULL, 'Cas10_III', NULL, 'Cas10_III', NULL, NULL, NULL, 2),
(9684, NULL, 'cd17132', NULL, NULL, 'Ubl_TMUB2', NULL, 'Ubl_TMUB2', NULL, NULL, NULL, 2),
(9685, NULL, 'cd10025', NULL, NULL, '14-3-3_eta', NULL, '14-3-3_eta', NULL, NULL, NULL, 2),
(9686, NULL, 'cd16916', NULL, NULL, 'HATPase_CheA-like', NULL, 'HATPase_CheA-like', NULL, NULL, NULL, 2),
(9687, NULL, 'cd11349', NULL, NULL, 'AmyAc_3', NULL, 'AmyAc_3', NULL, NULL, NULL, 2),
(9688, NULL, 'cd01214', NULL, NULL, 'PTB_FAM43A', NULL, 'PTB_FAM43A', NULL, NULL, 27978, 2),
(9689, NULL, 'cd09578', NULL, NULL, 'SAM_Scm', NULL, 'SAM_Scm', NULL, NULL, NULL, 2),
(9690, NULL, 'cd08755', NULL, NULL, 'RGS_p115RhoGEF', NULL, 'RGS_p115RhoGEF', NULL, NULL, 31982, 2),
(9691, NULL, 'cd13301', NULL, NULL, 'PH1_Pleckstrin_2', NULL, 'PH1_Pleckstrin_2', NULL, NULL, NULL, 2),
(9692, NULL, 'cd08787', NULL, NULL, 'CARD_NOD2_1_CARD15', NULL, 'CARD_NOD2_1_CARD15', NULL, NULL, NULL, 2),
(9693, NULL, 'cd21414', NULL, NULL, 'unc_rv_SF1_Hel-like', NULL, 'unc_rv_SF1_Hel-like', NULL, NULL, 36388, 2);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(9694, NULL, 'cd16149', NULL, NULL, 'sulfatase_like', NULL, 'sulfatase_like', NULL, NULL, NULL, 2),
(9695, NULL, 'cd05805', NULL, NULL, 'MPG1_transferase', NULL, 'MPG1_transferase', NULL, NULL, NULL, 2),
(9696, NULL, 'cd12404', NULL, NULL, 'RRM2_NCL', NULL, 'RRM2_NCL', NULL, NULL, 30848, 2),
(9697, NULL, 'cd15379', NULL, NULL, '7tmA_P2Y6', NULL, '7tmA_P2Y6', NULL, NULL, NULL, 2),
(9698, NULL, 'cd02231', NULL, NULL, 'cupin_BLL6423-like', NULL, 'cupin_BLL6423-like', NULL, NULL, NULL, 2),
(9699, NULL, 'cd05264', NULL, NULL, 'UDP_G4E_5_SDR_e', NULL, 'UDP_G4E_5_SDR_e', NULL, NULL, NULL, 2),
(9700, NULL, 'cd12794', NULL, NULL, 'Hsm3_like', NULL, 'Hsm3_like', NULL, NULL, NULL, 2),
(9701, NULL, 'cd05151', NULL, NULL, 'ChoK-like', NULL, 'ChoK-like', NULL, NULL, NULL, 2),
(9702, NULL, 'cd14352', NULL, NULL, 'UBA_DCN1', NULL, 'UBA_DCN1', NULL, NULL, NULL, 2),
(9703, NULL, 'cd12552', NULL, NULL, 'RRM_Nop15p', NULL, 'RRM_Nop15p', NULL, NULL, 11948, 2),
(9704, NULL, 'cd18268', NULL, NULL, 'BTB_POZ_KLHL38', NULL, 'BTB_POZ_KLHL38', NULL, NULL, NULL, 2),
(9705, NULL, 'cd18319', NULL, NULL, 'BTB_POZ_KLHL42', NULL, 'BTB_POZ_KLHL42', NULL, NULL, NULL, 2),
(9706, NULL, 'cd07300', NULL, NULL, 'PX_SNX20', NULL, 'PX_SNX20', NULL, NULL, NULL, 2),
(9707, NULL, 'cd11290', NULL, NULL, 'gelsolin_S1_like', NULL, 'gelsolin_S1_like', NULL, NULL, NULL, 2),
(9708, NULL, 'cd07601', NULL, NULL, 'BAR_APPL', NULL, 'BAR_APPL', NULL, NULL, NULL, 2),
(9709, NULL, 'cd07490', NULL, NULL, 'Peptidases_S8_6', NULL, 'Peptidases_S8_6', NULL, NULL, 10340, 2),
(9710, NULL, 'cd18963', NULL, NULL, 'chromodomain', NULL, 'chromodomain', NULL, NULL, NULL, 2),
(9711, NULL, 'cd01221', NULL, NULL, 'PH_ephexin', NULL, 'PH_ephexin', NULL, NULL, NULL, 2),
(9712, NULL, 'cd08490', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_3', NULL, 'PBP2_NikA_DppA_OppA_like_3', NULL, NULL, NULL, 2),
(9713, NULL, 'cd06919', NULL, NULL, 'Asp_decarbox', NULL, 'Asp_decarbox', NULL, NULL, 1642, 2),
(9714, NULL, 'cd00215', NULL, NULL, 'PTS_IIA_lac', NULL, 'PTS_IIA_lac', NULL, NULL, 3212, 2),
(9715, NULL, 'cd16291', NULL, NULL, 'INTS11-like_MBL-fold', NULL, 'INTS11-like_MBL-fold', NULL, NULL, 30006, 2),
(9716, NULL, 'cd11968', NULL, NULL, 'SH3_SASH3', NULL, 'SH3_SASH3', NULL, NULL, 31496, 2),
(9717, NULL, 'cd00361', NULL, NULL, 'arom_aa_hydroxylase', NULL, 'arom_aa_hydroxylase', NULL, NULL, NULL, 2),
(9718, NULL, 'cd19845', NULL, NULL, 'Bbox1_TIF1a_C-VI', NULL, 'Bbox1_TIF1a_C-VI', NULL, NULL, NULL, 2),
(9719, NULL, 'cd12486', NULL, NULL, 'RRM1_ACF', NULL, 'RRM1_ACF', NULL, NULL, 1443, 2),
(9720, NULL, 'cd18316', NULL, NULL, 'BTB_POZ_KCTD-like', NULL, 'BTB_POZ_KCTD-like', NULL, NULL, NULL, 2),
(9721, NULL, 'cd03278', NULL, NULL, 'ABC_SMC_barmotin', NULL, 'ABC_SMC_barmotin', NULL, NULL, NULL, 2),
(9722, NULL, 'cd11828', NULL, NULL, 'SH3_ARHGEF9_like', NULL, 'SH3_ARHGEF9_like', NULL, NULL, NULL, 2),
(9723, NULL, 'cd09624', NULL, NULL, 'DOMON_b558_566', NULL, 'DOMON_b558_566', NULL, NULL, NULL, 2),
(9724, NULL, 'cd13768', NULL, NULL, 'DSS1_Sem1', NULL, 'DSS1_Sem1', NULL, NULL, NULL, 2),
(9725, NULL, 'cd16755', NULL, NULL, 'RING-HC_TRIM9', NULL, 'RING-HC_TRIM9', NULL, NULL, NULL, 2),
(9726, NULL, 'cd18699', NULL, NULL, 'PIN_VapC_like', NULL, 'PIN_VapC_like', NULL, NULL, NULL, 2),
(9727, NULL, 'cd11408', NULL, NULL, 'bHLH-O_HELT', NULL, 'bHLH-O_HELT', NULL, NULL, NULL, 2),
(9728, NULL, 'cd13679', NULL, NULL, 'PBP2_TRAP_YiaO_like', NULL, 'PBP2_TRAP_YiaO_like', NULL, NULL, NULL, 2),
(9729, NULL, 'cd06999', NULL, NULL, 'cupin_HpaA-like_N', NULL, 'cupin_HpaA-like_N', NULL, NULL, NULL, 2),
(9730, NULL, 'cd14793', NULL, NULL, 'DUF302_like', NULL, 'DUF302_like', NULL, NULL, NULL, 2),
(9731, NULL, 'cd01732', NULL, NULL, 'LSm5', NULL, 'LSm5', NULL, NULL, 29133, 2),
(9732, NULL, 'cd09318', NULL, NULL, 'TDT_SSU1', NULL, 'TDT_SSU1', NULL, NULL, NULL, 2),
(9733, NULL, 'cd18571', NULL, NULL, 'ABC_6TM_peptidase_like', NULL, 'ABC_6TM_peptidase_like', NULL, NULL, NULL, 2),
(9734, NULL, 'cd00882', NULL, NULL, 'Ras_like_GTPase', NULL, 'Ras_like_GTPase', NULL, NULL, NULL, 2),
(9735, NULL, 'cd13187', NULL, NULL, 'FERM_C_PTPH13', NULL, 'FERM_C_PTPH13', NULL, NULL, NULL, 2);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(9736, NULL, 'cd06542', NULL, NULL, 'GH18_EndoS-like', NULL, 'GH18_EndoS-like', NULL, NULL, NULL, 2),
(9737, NULL, 'cd14207', NULL, NULL, 'PTKc_VEGFR1', NULL, 'PTKc_VEGFR1', NULL, NULL, NULL, 2),
(9738, NULL, 'cd14887', NULL, NULL, 'MYSc_Myo26', NULL, 'MYSc_Myo26', NULL, NULL, NULL, 2),
(9739, NULL, 'cd17117', NULL, NULL, 'RA_ANKFN1_like', NULL, 'RA_ANKFN1_like', NULL, NULL, NULL, 2),
(9740, NULL, 'cd07038', NULL, NULL, 'TPP_PYR_PDC_IPDC_like', NULL, 'TPP_PYR_PDC_IPDC_like', NULL, NULL, NULL, 2),
(9741, NULL, 'cd15633', NULL, NULL, 'PHD_PHF20L1', NULL, 'PHD_PHF20L1', NULL, NULL, NULL, 2),
(9742, NULL, 'cd11282', NULL, NULL, 'ADF_coactosin_like', NULL, 'ADF_coactosin_like', NULL, NULL, NULL, 2),
(9743, NULL, 'cd15392', NULL, NULL, '7tmA_PR4-like', NULL, '7tmA_PR4-like', NULL, NULL, NULL, 2),
(9744, NULL, 'cd13378', NULL, NULL, 'PH_RhoGAP2', NULL, 'PH_RhoGAP2', NULL, NULL, NULL, 2),
(9745, NULL, 'cd15845', NULL, NULL, 'SNARE_syntaxin16', NULL, 'SNARE_syntaxin16', NULL, NULL, NULL, 2),
(9746, NULL, 'cd04983', NULL, NULL, 'IgV_TCR_alpha', NULL, 'IgV_TCR_alpha', NULL, NULL, NULL, 2),
(9747, NULL, 'cd09458', NULL, NULL, 'LIM3_Enigma', NULL, 'LIM3_Enigma', NULL, NULL, NULL, 2),
(9748, NULL, 'cd11874', NULL, NULL, 'SH3_CD2AP-like_2', NULL, 'SH3_CD2AP-like_2', NULL, NULL, NULL, 2),
(9749, NULL, 'cd15916', NULL, NULL, '7tmA_OR10G-like', NULL, '7tmA_OR10G-like', NULL, NULL, NULL, 2),
(9750, NULL, 'cd09007', NULL, NULL, 'NP-I_spr0068', NULL, 'NP-I_spr0068', NULL, NULL, NULL, 2),
(9751, NULL, 'cd08171', NULL, NULL, 'GlyDH-like', NULL, 'GlyDH-like', NULL, NULL, NULL, 2),
(9752, NULL, 'cd06270', NULL, NULL, 'PBP1_GalS-like', NULL, 'PBP1_GalS-like', NULL, NULL, NULL, 2),
(9753, NULL, 'cd02522', NULL, NULL, 'GT_2_like_a', NULL, 'GT_2_like_a', NULL, NULL, 25198, 2),
(9754, NULL, 'cd03151', NULL, NULL, 'CD81_like_LEL', NULL, 'CD81_like_LEL', NULL, NULL, NULL, 2),
(9755, NULL, 'cd08804', NULL, NULL, 'Death_ank2', NULL, 'Death_ank2', NULL, NULL, NULL, 2),
(9756, NULL, 'cd09759', NULL, NULL, 'Cas6_I-A', NULL, 'Cas6_I-A', NULL, NULL, NULL, 2),
(9757, NULL, 'cd21171', NULL, NULL, 'NTD_alpha_beta_cv_Nsp15-like', NULL, 'NTD_alpha_beta_cv_Nsp15-like', NULL, NULL, 35323, 2),
(9758, NULL, 'cd16195', NULL, NULL, 'EFh_PEF_CAPN13_14', NULL, 'EFh_PEF_CAPN13_14', NULL, NULL, NULL, 2),
(9759, NULL, 'cd00553', NULL, NULL, 'NAD_synthase', NULL, 'NAD_synthase', NULL, NULL, 1517, 2),
(9760, NULL, 'cd20208', NULL, NULL, 'Bbox1_DUF2009', NULL, 'Bbox1_DUF2009', NULL, NULL, NULL, 2),
(9761, NULL, 'cd01850', NULL, NULL, 'CDC_Septin', NULL, 'CDC_Septin', NULL, NULL, 16218, 2),
(9762, NULL, 'cd04094', NULL, NULL, 'eSelB_III', NULL, 'eSelB_III', NULL, NULL, NULL, 2),
(9763, NULL, 'cd00460', NULL, NULL, 'RNAP_RPB11_RPB3', NULL, 'RNAP_RPB11_RPB3', NULL, NULL, NULL, 2),
(9764, NULL, 'cd16184', NULL, NULL, 'EFh_PEF_peflin', NULL, 'EFh_PEF_peflin', NULL, NULL, NULL, 2),
(9765, NULL, 'cd05573', NULL, NULL, 'STKc_ROCK_NDR_like', NULL, 'STKc_ROCK_NDR_like', NULL, NULL, NULL, 2),
(9766, NULL, 'cd03223', NULL, NULL, 'ABCD_peroxisomal_ALDP', NULL, 'ABCD_peroxisomal_ALDP', NULL, NULL, NULL, 2),
(9767, NULL, 'cd05160', NULL, NULL, 'DEDDy_DNA_polB_exo', NULL, 'DEDDy_DNA_polB_exo', NULL, NULL, NULL, 2),
(9768, NULL, 'cd16226', NULL, NULL, 'EFh_CREC_Calumenin_like', NULL, 'EFh_CREC_Calumenin_like', NULL, NULL, NULL, 2),
(9769, NULL, 'cd15589', NULL, NULL, 'PHD1_KMT2B', NULL, 'PHD1_KMT2B', NULL, NULL, NULL, 2),
(9770, NULL, 'cd10416', NULL, NULL, 'SH2_SH2D2A', NULL, 'SH2_SH2D2A', NULL, NULL, 32516, 2),
(9771, NULL, 'cd12821', NULL, NULL, 'EcCorA_ZntB-like', NULL, 'EcCorA_ZntB-like', NULL, NULL, NULL, 2),
(9772, NULL, 'cd18036', NULL, NULL, 'DEXHc_RLR', NULL, 'DEXHc_RLR', NULL, NULL, NULL, 2),
(9773, NULL, 'cd18415', NULL, NULL, 'BTB_KCNC2_4', NULL, 'BTB_KCNC2_4', NULL, NULL, NULL, 2),
(9774, NULL, 'cd03791', NULL, NULL, 'GT5_Glycogen_synthase_DULL1-like', NULL, 'GT5_Glycogen_synthase_DULL1-like', NULL, NULL, NULL, 2),
(9775, NULL, 'cd07859', NULL, NULL, 'STKc_TDY_MAPK', NULL, 'STKc_TDY_MAPK', NULL, NULL, NULL, 2),
(9776, NULL, 'cd18684', NULL, NULL, 'PIN_VapC-like', NULL, 'PIN_VapC-like', NULL, NULL, NULL, 2);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(9777, NULL, 'cd16726', NULL, NULL, 'RING1-HC_MIB2', NULL, 'RING1-HC_MIB2', NULL, NULL, NULL, 2),
(9778, NULL, 'cd19107', NULL, NULL, 'AKR_AKR1B1-19', NULL, 'AKR_AKR1B1-19', NULL, NULL, NULL, 2),
(9779, NULL, 'cd08066', NULL, NULL, 'MPN_AMSH_like', NULL, 'MPN_AMSH_like', NULL, NULL, 35640, 2),
(9780, NULL, 'cd06950', NULL, NULL, 'NR_LBD_Tlx_PNR_like', NULL, 'NR_LBD_Tlx_PNR_like', NULL, NULL, NULL, 2),
(9781, NULL, 'cd11273', NULL, NULL, 'Sema_plexin_A3', NULL, 'Sema_plexin_A3', NULL, NULL, NULL, 2),
(9782, NULL, 'cd14896', NULL, NULL, 'MYSc_Myo35', NULL, 'MYSc_Myo35', NULL, NULL, NULL, 2),
(9783, NULL, 'cd19689', NULL, NULL, 'bHLHzip_MLXIPL', NULL, 'bHLHzip_MLXIPL', NULL, NULL, NULL, 2),
(9784, NULL, 'cd20307', NULL, NULL, 'cupin_BacB_N', NULL, 'cupin_BacB_N', NULL, NULL, NULL, 2),
(9785, NULL, 'cd19584', NULL, NULL, 'serpinO_SPI-3_virus', NULL, 'serpinO_SPI-3_virus', NULL, NULL, NULL, 2),
(9786, NULL, 'cd14270', NULL, NULL, 'UBA', NULL, 'UBA', NULL, NULL, NULL, 2),
(9787, NULL, 'cd12095', NULL, NULL, 'TM_ErbB3', NULL, 'TM_ErbB3', NULL, NULL, NULL, 2),
(9788, NULL, 'cd17413', NULL, NULL, 'MFS_NPF6', NULL, 'MFS_NPF6', NULL, NULL, NULL, 2),
(9789, NULL, 'cd07041', NULL, NULL, 'STAS_RsbR_RsbS_like', NULL, 'STAS_RsbR_RsbS_like', NULL, NULL, NULL, 2),
(9790, NULL, 'cd15982', NULL, NULL, '7tmB1_PTH2R', NULL, '7tmB1_PTH2R', NULL, NULL, NULL, 2),
(9791, NULL, 'cd05278', NULL, NULL, 'FDH_like', NULL, 'FDH_like', NULL, NULL, NULL, 2),
(9792, NULL, 'cd08744', NULL, NULL, 'RGS_RGS17', NULL, 'RGS_RGS17', NULL, NULL, NULL, 2),
(9793, NULL, 'cd17240', NULL, NULL, 'RA_PHLPP1', NULL, 'RA_PHLPP1', NULL, NULL, NULL, 2),
(9794, NULL, 'cd20273', NULL, NULL, 'Complex1_LYR_unchar', NULL, 'Complex1_LYR_unchar', NULL, NULL, 34377, 2),
(9795, NULL, 'cd02866', NULL, NULL, 'PseudoU_synth_TruA_Archea', NULL, 'PseudoU_synth_TruA_Archea', NULL, NULL, NULL, 2),
(9796, NULL, 'cd06630', NULL, NULL, 'STKc_MEKK1', NULL, 'STKc_MEKK1', NULL, NULL, NULL, 2),
(9797, NULL, 'cd12640', NULL, NULL, 'RRM3_Bruno_like', NULL, 'RRM3_Bruno_like', NULL, NULL, NULL, 2),
(9798, NULL, 'cd12401', NULL, NULL, 'RRM_eIF4H', NULL, 'RRM_eIF4H', NULL, NULL, 30866, 2),
(9799, NULL, 'cd03206', NULL, NULL, 'GST_C_7', NULL, 'GST_C_7', NULL, NULL, NULL, 2),
(9800, NULL, 'cd09534', NULL, NULL, 'SAM_Ste11_fungal', NULL, 'SAM_Ste11_fungal', NULL, NULL, NULL, 2),
(9801, NULL, 'cd12156', NULL, NULL, 'HPPR', NULL, 'HPPR', NULL, NULL, NULL, 2),
(9802, NULL, 'cd10016', NULL, NULL, 'EcoRII_N', NULL, 'EcoRII_N', NULL, NULL, NULL, 2),
(9803, NULL, 'cd12273', NULL, NULL, 'RRM1_NEFsp', NULL, 'RRM1_NEFsp', NULL, NULL, NULL, 2),
(9804, NULL, 'cd17951', NULL, NULL, 'DEADc_DDX41', NULL, 'DEADc_DDX41', NULL, NULL, 35527, 2),
(9805, NULL, 'cd19855', NULL, NULL, 'DSRM_DHX9_rpt2', NULL, 'DSRM_DHX9_rpt2', NULL, NULL, 35598, 2),
(9806, NULL, 'cd17949', NULL, NULL, 'DEADc_DDX31', NULL, 'DEADc_DDX31', NULL, NULL, NULL, 2),
(9807, NULL, 'cd02990', NULL, NULL, 'UAS_FAF1', NULL, 'UAS_FAF1', NULL, NULL, NULL, 2),
(9808, NULL, 'cd09291', NULL, NULL, 'Photo-RC_M', NULL, 'Photo-RC_M', NULL, NULL, 5726, 2),
(9809, NULL, 'cd12441', NULL, NULL, 'RRM_Nup53_like', NULL, 'RRM_Nup53_like', NULL, NULL, NULL, 2),
(9810, NULL, 'cd02503', NULL, NULL, 'MobA', NULL, 'MobA', NULL, NULL, 10190, 2),
(9811, NULL, 'cd14756', NULL, NULL, 'TrHb', NULL, 'TrHb', NULL, NULL, NULL, 2),
(9812, NULL, 'cd14373', NULL, NULL, 'CUE_Cue3p_like', NULL, 'CUE_Cue3p_like', NULL, NULL, 30621, 2),
(9813, NULL, 'cd17069', NULL, NULL, 'DCX2', NULL, 'DCX2', NULL, NULL, NULL, 2),
(9814, NULL, 'cd07858', NULL, NULL, 'STKc_TEY_MAPK', NULL, 'STKc_TEY_MAPK', NULL, NULL, NULL, 2),
(9815, NULL, 'cd02652', NULL, NULL, 'nuc_hydro_2', NULL, 'nuc_hydro_2', NULL, NULL, NULL, 2),
(9816, NULL, 'cd01946', NULL, NULL, 'ribokinase_group_C', NULL, 'ribokinase_group_C', NULL, NULL, NULL, 2),
(9817, NULL, 'cd02774', NULL, NULL, 'MopB_Res-Cmplx1_Nad11-M', NULL, 'MopB_Res-Cmplx1_Nad11-M', NULL, NULL, NULL, 2),
(9818, NULL, 'cd13238', NULL, NULL, 'PH2_FGD4_insect-like', NULL, 'PH2_FGD4_insect-like', NULL, NULL, NULL, 2),
(9819, NULL, 'cd16609', NULL, NULL, 'RING-HC_TRIM65_C-IV', NULL, 'RING-HC_TRIM65_C-IV', NULL, NULL, NULL, 2);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(9820, NULL, 'cd10153', NULL, NULL, 'RcnR-FrmR-like_DUF156', NULL, 'RcnR-FrmR-like_DUF156', NULL, NULL, NULL, 2),
(9821, NULL, 'cd12414', NULL, NULL, 'RRM2_RBM28_like', NULL, 'RRM2_RBM28_like', NULL, NULL, NULL, 2),
(9822, NULL, 'cd00768', NULL, NULL, 'class_II_aaRS-like_core', NULL, 'class_II_aaRS-like_core', NULL, NULL, NULL, 2),
(9823, NULL, 'cd05752', NULL, NULL, 'Ig1_FcgammaR_like', NULL, 'Ig1_FcgammaR_like', NULL, NULL, NULL, 2),
(9824, NULL, 'cd14298', NULL, NULL, 'UBA2_scUBP14_like', NULL, 'UBA2_scUBP14_like', NULL, NULL, 33423, 2),
(9825, NULL, 'cd02230', NULL, NULL, 'cupin_HP0902-like', NULL, 'cupin_HP0902-like', NULL, NULL, NULL, 2),
(9826, NULL, 'cd12454', NULL, NULL, 'RRM2_RIM4_like', NULL, 'RRM2_RIM4_like', NULL, NULL, NULL, 2),
(9827, NULL, 'cd08177', NULL, NULL, 'MAR', NULL, 'MAR', NULL, NULL, 11143, 2),
(9828, NULL, 'cd01337', NULL, NULL, 'MDH_glyoxysomal_mitochondrial', NULL, 'MDH_glyoxysomal_mitochondrial', NULL, NULL, 2499, 2),
(9829, NULL, 'cd19544', NULL, NULL, 'E-C_NRPS', NULL, 'E-C_NRPS', NULL, NULL, NULL, 2),
(9830, NULL, 'cd13988', NULL, NULL, 'STKc_TBK1', NULL, 'STKc_TBK1', NULL, NULL, NULL, 2),
(9831, NULL, 'cd03786', NULL, NULL, 'GTB_UDP-GlcNAc_2-Epimerase', NULL, 'GTB_UDP-GlcNAc_2-Epimerase', NULL, NULL, NULL, 2),
(9832, NULL, 'cd09967', NULL, NULL, 'UP_II', NULL, 'UP_II', NULL, NULL, 8384, 2),
(9833, NULL, 'cd19774', NULL, NULL, 'Bbox2_TRIM23_C-IX_rpt2', NULL, 'Bbox2_TRIM23_C-IX_rpt2', NULL, NULL, NULL, 2),
(9834, NULL, 'cd07040', NULL, NULL, 'HP', NULL, 'HP', NULL, NULL, NULL, 2),
(9835, NULL, 'cd13623', NULL, NULL, 'PBP2_AA_hypothetical', NULL, 'PBP2_AA_hypothetical', NULL, NULL, NULL, 2),
(9836, NULL, 'cd11614', NULL, NULL, 'SAF_CpaB_FlgA_like', NULL, 'SAF_CpaB_FlgA_like', NULL, NULL, NULL, 2),
(9837, NULL, 'cd15559', NULL, NULL, 'PHD1_BPTF', NULL, 'PHD1_BPTF', NULL, NULL, NULL, 2),
(9838, NULL, 'cd16908', NULL, NULL, 'YEATS_Yaf9_like', NULL, 'YEATS_Yaf9_like', NULL, NULL, NULL, 2),
(9839, NULL, 'cd16485', NULL, NULL, 'mRING-H2-C3H2C2D_RBX1', NULL, 'mRING-H2-C3H2C2D_RBX1', NULL, NULL, NULL, 2),
(9840, NULL, 'cd19878', NULL, NULL, 'DSRM_AtDRB-like', NULL, 'DSRM_AtDRB-like', NULL, NULL, NULL, 2),
(9841, NULL, 'cd10011', NULL, NULL, 'HDAC2', NULL, 'HDAC2', NULL, NULL, NULL, 2),
(9842, NULL, 'cd01483', NULL, NULL, 'E1_enzyme_family', NULL, 'E1_enzyme_family', NULL, NULL, NULL, 2),
(9843, NULL, 'cd18592', NULL, NULL, 'ABC_6TM_MRP5_8_9_D1', NULL, 'ABC_6TM_MRP5_8_9_D1', NULL, NULL, NULL, 2),
(9844, NULL, 'cd04927', NULL, NULL, 'ACT_ACR-like_2', NULL, 'ACT_ACR-like_2', NULL, NULL, NULL, 2),
(9845, NULL, 'cd09821', NULL, NULL, 'An_peroxidase_bacterial_2', NULL, 'An_peroxidase_bacterial_2', NULL, NULL, NULL, 2),
(9846, NULL, 'cd01380', NULL, NULL, 'MYSc_Myo5', NULL, 'MYSc_Myo5', NULL, NULL, 28183, 2),
(9847, NULL, 'cd20251', NULL, NULL, 'Complex1_LYR_SF', NULL, 'Complex1_LYR_SF', NULL, NULL, NULL, 2),
(9848, NULL, 'cd07767', NULL, NULL, 'MPN', NULL, 'MPN', NULL, NULL, NULL, 2),
(9849, NULL, 'cd08348', NULL, NULL, 'BphC2-C3-RGP6_C_like', NULL, 'BphC2-C3-RGP6_C_like', NULL, NULL, NULL, 2),
(9850, NULL, 'cd07841', NULL, NULL, 'STKc_CDK7', NULL, 'STKc_CDK7', NULL, NULL, 31291, 2),
(9851, NULL, 'cd09853', NULL, NULL, 'PIN_FEN-like', NULL, 'PIN_FEN-like', NULL, NULL, NULL, 2),
(9852, NULL, 'cd15941', NULL, NULL, '7tmA_OR10S1-like', NULL, '7tmA_OR10S1-like', NULL, NULL, NULL, 2),
(9853, NULL, 'cd04887', NULL, NULL, 'ACT_MalLac-Enz', NULL, 'ACT_MalLac-Enz', NULL, NULL, NULL, 2),
(9854, NULL, 'cd14679', NULL, NULL, 'PH_p115RhoGEF', NULL, 'PH_p115RhoGEF', NULL, NULL, NULL, 2),
(9855, NULL, 'cd08623', NULL, NULL, 'PI-PLCc_beta1', NULL, 'PI-PLCc_beta1', NULL, NULL, NULL, 2),
(9856, NULL, 'cd18711', NULL, NULL, 'PIN_VapC-like_DUF411', NULL, 'PIN_VapC-like_DUF411', NULL, NULL, NULL, 2),
(9857, NULL, 'cd14690', NULL, NULL, 'bZIP_CREB1', NULL, 'bZIP_CREB1', NULL, NULL, NULL, 2),
(9858, NULL, 'cd00418', NULL, NULL, 'GlxRS_core', NULL, 'GlxRS_core', NULL, NULL, NULL, 2),
(9859, NULL, 'cd00219', NULL, NULL, 'ToxGAP', NULL, 'ToxGAP', NULL, NULL, 12236, 2),
(9860, NULL, 'cd13648', NULL, NULL, 'PBP2_PBGD_1', NULL, 'PBP2_PBGD_1', NULL, NULL, NULL, 2);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(9861, NULL, 'cd13761', NULL, NULL, 'TGF_beta_BMP5_like', NULL, 'TGF_beta_BMP5_like', NULL, NULL, NULL, 2),
(9862, NULL, 'cd18456', NULL, NULL, 'BACK_KLHL17', NULL, 'BACK_KLHL17', NULL, NULL, NULL, 2),
(9863, NULL, 'cd08282', NULL, NULL, 'PFDH_like', NULL, 'PFDH_like', NULL, NULL, NULL, 2),
(9864, NULL, 'cd07067', NULL, NULL, 'HP_PGM_like', NULL, 'HP_PGM_like', NULL, NULL, 7475, 2),
(9865, NULL, 'cd02259', NULL, NULL, 'Peptidase_C39_like', NULL, 'Peptidase_C39_like', NULL, NULL, NULL, 2),
(9866, NULL, 'cd11305', NULL, NULL, 'alpha_DG_C', NULL, 'alpha_DG_C', NULL, NULL, NULL, 2),
(9867, NULL, 'cd14956', NULL, NULL, 'NHL_like_3', NULL, 'NHL_like_3', NULL, NULL, NULL, 2),
(9868, NULL, 'cd14110', NULL, NULL, 'STKc_obscurin_rpt2', NULL, 'STKc_obscurin_rpt2', NULL, NULL, NULL, 2),
(9869, NULL, 'cd04758', NULL, NULL, 'Commd10', NULL, 'Commd10', NULL, NULL, 32920, 2),
(9870, NULL, 'cd09011', NULL, NULL, 'VOC_like', NULL, 'VOC_like', NULL, NULL, NULL, 2),
(9871, NULL, 'cd14978', NULL, NULL, '7tmA_FMRFamide_R-like', NULL, '7tmA_FMRFamide_R-like', NULL, NULL, NULL, 2),
(9872, NULL, 'cd08151', NULL, NULL, 'AOS', NULL, 'AOS', NULL, NULL, NULL, 2),
(9873, NULL, 'cd05136', NULL, NULL, 'RasGAP_DAB2IP', NULL, 'RasGAP_DAB2IP', NULL, NULL, NULL, 2),
(9874, NULL, 'cd10052', NULL, NULL, 'Reelin_repeat_8_subrepeat_2', NULL, 'Reelin_repeat_8_subrepeat_2', NULL, NULL, NULL, 2),
(9875, NULL, 'cd03856', NULL, NULL, 'M14_Nna1-like', NULL, 'M14_Nna1-like', NULL, NULL, NULL, 2),
(9876, NULL, 'cd08336', NULL, NULL, 'DED_FADD', NULL, 'DED_FADD', NULL, NULL, NULL, 2),
(9877, NULL, 'cd15693', NULL, NULL, 'ePHD_KMT2A', NULL, 'ePHD_KMT2A', NULL, NULL, 30085, 2),
(9878, NULL, 'cd12266', NULL, NULL, 'RRM_like_XS', NULL, 'RRM_like_XS', NULL, NULL, 6435, 2),
(9879, NULL, 'cd09270', NULL, NULL, 'RNase_H2-B', NULL, 'RNase_H2-B', NULL, NULL, 32933, 2),
(9880, NULL, 'cd20288', NULL, NULL, 'cupin_pirin-like_C', NULL, 'cupin_pirin-like_C', NULL, NULL, NULL, 2),
(9881, NULL, 'cd15122', NULL, NULL, '7tmA_LTB4R2', NULL, '7tmA_LTB4R2', NULL, NULL, NULL, 2),
(9882, NULL, 'cd03395', NULL, NULL, 'PAP2_like_4', NULL, 'PAP2_like_4', NULL, NULL, NULL, 2),
(9883, NULL, 'cd17027', NULL, NULL, 'T3SC_IA_YscB_AscB-like', NULL, 'T3SC_IA_YscB_AscB-like', NULL, NULL, NULL, 2),
(9884, NULL, 'cd03263', NULL, NULL, 'ABC_subfamily_A', NULL, 'ABC_subfamily_A', NULL, NULL, NULL, 2),
(9885, NULL, 'cd05058', NULL, NULL, 'PTKc_Met_Ron', NULL, 'PTKc_Met_Ron', NULL, NULL, NULL, 2),
(9886, NULL, 'cd09176', NULL, NULL, 'PLDc_unchar6', NULL, 'PLDc_unchar6', NULL, NULL, NULL, 2),
(9887, NULL, 'cd01560', NULL, NULL, 'Thr-synth_2', NULL, 'Thr-synth_2', NULL, NULL, NULL, 2),
(9888, NULL, 'cd19594', NULL, NULL, 'serpin_crustaceans_chelicerates_insects', NULL, 'serpin_crustaceans_chelicerates_insects', NULL, NULL, NULL, 2),
(9889, NULL, 'cd04748', NULL, NULL, 'Commd', NULL, 'Commd', NULL, NULL, NULL, 2),
(9890, NULL, 'cd19460', NULL, NULL, 'CRABP1', NULL, 'CRABP1', NULL, NULL, NULL, 2),
(9891, NULL, 'cd16020', NULL, NULL, 'GPI_EPT_1', NULL, 'GPI_EPT_1', NULL, NULL, 32831, 2),
(9892, NULL, 'cd19080', NULL, NULL, 'AKR_AKR9A_9B', NULL, 'AKR_AKR9A_9B', NULL, NULL, NULL, 2),
(9893, NULL, 'cd11797', NULL, NULL, 'SH3_DNMBP_N4', NULL, 'SH3_DNMBP_N4', NULL, NULL, NULL, 2),
(9894, NULL, 'cd06192', NULL, NULL, 'DHOD_e_trans_like', NULL, 'DHOD_e_trans_like', NULL, NULL, NULL, 2),
(9895, NULL, 'cd11470', NULL, NULL, 'bHLH_TS_TCF15_paraxis', NULL, 'bHLH_TS_TCF15_paraxis', NULL, NULL, NULL, 2),
(9896, NULL, 'cd16574', NULL, NULL, 'RING-HC_Topors', NULL, 'RING-HC_Topors', NULL, NULL, NULL, 2),
(9897, NULL, 'cd17740', NULL, NULL, 'BRCT_Rad4_rpt1', NULL, 'BRCT_Rad4_rpt1', NULL, NULL, NULL, 2),
(9898, NULL, 'cd20245', NULL, NULL, 'humanin', NULL, 'humanin', NULL, NULL, 23441, 2),
(9899, NULL, 'cd05177', NULL, NULL, 'PI3Kc_C2_gamma', NULL, 'PI3Kc_C2_gamma', NULL, NULL, 31270, 2),
(9900, NULL, 'cd15640', NULL, NULL, 'PHD_KDM7', NULL, 'PHD_KDM7', NULL, NULL, NULL, 2),
(9901, NULL, 'cd19218', NULL, NULL, 'SET_EZH2', NULL, 'SET_EZH2', NULL, NULL, 34745, 2),
(9902, NULL, 'cd16572', NULL, NULL, 'RING-HC_SpRad8_like', NULL, 'RING-HC_SpRad8_like', NULL, NULL, NULL, 2);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(9903, NULL, 'cd02510', NULL, NULL, 'pp-GalNAc-T', NULL, 'pp-GalNAc-T', NULL, NULL, 33997, 2),
(9904, NULL, 'cd12327', NULL, NULL, 'RRM2_DAZAP1', NULL, 'RRM2_DAZAP1', NULL, NULL, 20933, 2),
(9905, NULL, 'cd07129', NULL, NULL, 'ALDH_KGSADH', NULL, 'ALDH_KGSADH', NULL, NULL, 36696, 2),
(9906, NULL, 'cd16337', NULL, NULL, 'MukF_C', NULL, 'MukF_C', NULL, NULL, 31702, 2),
(9907, NULL, 'cd11705', NULL, NULL, 'DHR2_DOCK4', NULL, 'DHR2_DOCK4', NULL, NULL, NULL, 2),
(9908, NULL, 'cd16669', NULL, NULL, 'RING-H2_RNF181', NULL, 'RING-H2_RNF181', NULL, NULL, NULL, 2),
(9909, NULL, 'cd09875', NULL, NULL, 'PIN_VapC-FitB-like', NULL, 'PIN_VapC-FitB-like', NULL, NULL, NULL, 2),
(9910, NULL, 'cd19008', NULL, NULL, 'LGIC_ECD_GABAR_RDL-like', NULL, 'LGIC_ECD_GABAR_RDL-like', NULL, NULL, NULL, 2),
(9911, NULL, 'cd07842', NULL, NULL, 'STKc_CDK8_like', NULL, 'STKc_CDK8_like', NULL, NULL, NULL, 2),
(9912, NULL, 'cd02193', NULL, NULL, 'PurL', NULL, 'PurL', NULL, NULL, NULL, 2),
(9913, NULL, 'cd14154', NULL, NULL, 'STKc_LIMK', NULL, 'STKc_LIMK', NULL, NULL, NULL, 2),
(9914, NULL, 'cd17997', NULL, NULL, 'DEXHc_SMARCA1_SMARCA5', NULL, 'DEXHc_SMARCA1_SMARCA5', NULL, NULL, 34280, 2),
(9915, NULL, 'cd03320', NULL, NULL, 'OSBS', NULL, 'OSBS', NULL, NULL, NULL, 2),
(9916, NULL, 'cd12808', NULL, NULL, 'Esterase_713_like-1', NULL, 'Esterase_713_like-1', NULL, NULL, NULL, 2),
(9917, NULL, 'cd01148', NULL, NULL, 'TroA_a', NULL, 'TroA_a', NULL, NULL, NULL, 2),
(9918, NULL, 'cd14633', NULL, NULL, 'R-PTPc-M-1', NULL, 'R-PTPc-M-1', NULL, NULL, 37632, 2),
(9919, NULL, 'cd09519', NULL, NULL, 'SAM_ANKS3', NULL, 'SAM_ANKS3', NULL, NULL, NULL, 2),
(9920, NULL, 'cd05023', NULL, NULL, 'S-100A11', NULL, 'S-100A11', NULL, NULL, NULL, 2),
(9921, NULL, 'cd07557', NULL, NULL, 'trimeric_dUTPase', NULL, 'trimeric_dUTPase', NULL, NULL, 30440, 2),
(9922, NULL, 'cd19413', NULL, NULL, 'RsbR_N-like', NULL, 'RsbR_N-like', NULL, NULL, NULL, 2),
(9923, NULL, 'cd08605', NULL, NULL, 'GDPD_GDE5_like_1_plant', NULL, 'GDPD_GDE5_like_1_plant', NULL, NULL, NULL, 2),
(9924, NULL, 'cd10537', NULL, NULL, 'SET_SETD9', NULL, 'SET_SETD9', NULL, NULL, NULL, 2),
(9925, NULL, 'cd12080', NULL, NULL, 'SH3_MPP1', NULL, 'SH3_MPP1', NULL, NULL, 15085, 2),
(9926, NULL, 'cd07556', NULL, NULL, 'Nucleotidyl_cyc_III', NULL, 'Nucleotidyl_cyc_III', NULL, NULL, NULL, 2),
(9927, NULL, 'cd18347', NULL, NULL, 'BTB_POZ_BTBD2', NULL, 'BTB_POZ_BTBD2', NULL, NULL, NULL, 2),
(9928, NULL, 'cd10493', NULL, NULL, 'MH1_SMAD_6', NULL, 'MH1_SMAD_6', NULL, NULL, NULL, 2),
(9929, NULL, 'cd00594', NULL, NULL, 'KU', NULL, 'KU', NULL, NULL, NULL, 2),
(9930, NULL, 'cd06623', NULL, NULL, 'PKc_MAPKK_plant_like', NULL, 'PKc_MAPKK_plant_like', NULL, NULL, NULL, 2),
(9931, NULL, 'cd07488', NULL, NULL, 'Peptidases_S8_2', NULL, 'Peptidases_S8_2', NULL, NULL, 27642, 2),
(9932, NULL, 'cd15616', NULL, NULL, 'PHD_UHRF1', NULL, 'PHD_UHRF1', NULL, NULL, NULL, 2),
(9933, NULL, 'cd07687', NULL, NULL, 'IgC_TCR_delta', NULL, 'IgC_TCR_delta', NULL, NULL, NULL, 2),
(9934, NULL, 'cd03054', NULL, NULL, 'GST_N_Metaxin', NULL, 'GST_N_Metaxin', NULL, NULL, NULL, 2),
(9935, NULL, 'cd05100', NULL, NULL, 'PTKc_FGFR3', NULL, 'PTKc_FGFR3', NULL, NULL, NULL, 2),
(9936, NULL, 'cd06180', NULL, NULL, 'MFS_YjiJ', NULL, 'MFS_YjiJ', NULL, NULL, NULL, 2),
(9937, NULL, 'cd09930', NULL, NULL, 'SH2_cSH2_p85_like', NULL, 'SH2_cSH2_p85_like', NULL, NULL, 20956, 2),
(9938, NULL, 'cd15107', NULL, NULL, '7tmA_MrgprB', NULL, '7tmA_MrgprB', NULL, NULL, NULL, 2),
(9939, NULL, 'cd20486', NULL, NULL, 'USP25_C', NULL, 'USP25_C', NULL, NULL, NULL, 2),
(9940, NULL, 'cd00140', NULL, NULL, 'beta_clamp', NULL, 'beta_clamp', NULL, NULL, 4499, 2),
(9941, NULL, 'cd02196', NULL, NULL, 'PurM', NULL, 'PurM', NULL, NULL, 3937, 2),
(9942, NULL, 'cd11928', NULL, NULL, 'SH3_SH3RF3_1', NULL, 'SH3_SH3RF3_1', NULL, NULL, NULL, 2),
(9943, NULL, 'cd05323', NULL, NULL, 'ADH_SDR_c_like', NULL, 'ADH_SDR_c_like', NULL, NULL, NULL, 2),
(9944, NULL, 'cd12523', NULL, NULL, 'RRM2_MRN1', NULL, 'RRM2_MRN1', NULL, NULL, NULL, 2),
(9945, NULL, 'cd12262', NULL, NULL, 'RRM2_4_MRN1', NULL, 'RRM2_4_MRN1', NULL, NULL, 19509, 2);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(9946, NULL, 'cd03464', NULL, NULL, '3,4-PCD_beta', NULL, '3,4-PCD_beta', NULL, NULL, 9955, 2),
(9947, NULL, 'cd05197', NULL, NULL, 'GH4_glycoside_hydrolases', NULL, 'GH4_glycoside_hydrolases', NULL, NULL, NULL, 2),
(9948, NULL, 'cd06621', NULL, NULL, 'PKc_Pek1_like', NULL, 'PKc_Pek1_like', NULL, NULL, NULL, 2),
(9949, NULL, 'cd07480', NULL, NULL, 'Peptidases_S8_12', NULL, 'Peptidases_S8_12', NULL, NULL, NULL, 2),
(9950, NULL, 'cd17542', NULL, NULL, 'REC_CheY', NULL, 'REC_CheY', NULL, NULL, NULL, 2),
(9951, NULL, 'cd03556', NULL, NULL, 'L-fucose_isomerase', NULL, 'L-fucose_isomerase', NULL, NULL, NULL, 2),
(9952, NULL, 'cd07735', NULL, NULL, 'class_II_PDE_MBL-fold', NULL, 'class_II_PDE_MBL-fold', NULL, NULL, 6535, 2),
(9953, NULL, 'cd03480', NULL, NULL, 'Rieske_RO_Alpha_PaO', NULL, 'Rieske_RO_Alpha_PaO', NULL, NULL, NULL, 2),
(9954, NULL, 'cd13621', NULL, NULL, 'PBP2_AA_binding_like_3', NULL, 'PBP2_AA_binding_like_3', NULL, NULL, NULL, 2),
(9955, NULL, 'cd06303', NULL, NULL, 'PBP1_LuxPQ_Quorum_Sensing', NULL, 'PBP1_LuxPQ_Quorum_Sensing', NULL, NULL, NULL, 2),
(9956, NULL, 'cd13412', NULL, NULL, 'TNFRSF11B_teleost', NULL, 'TNFRSF11B_teleost', NULL, NULL, 26775, 2),
(9957, NULL, 'cd01903', NULL, NULL, 'Ntn_AC_NAAA', NULL, 'Ntn_AC_NAAA', NULL, NULL, NULL, 2),
(9958, NULL, 'cd04449', NULL, NULL, 'DEP_DEPDC5-like', NULL, 'DEP_DEPDC5-like', NULL, NULL, NULL, 2),
(9959, NULL, 'cd11338', NULL, NULL, 'AmyAc_CMD', NULL, 'AmyAc_CMD', NULL, NULL, NULL, 2),
(9960, NULL, 'cd18221', NULL, NULL, 'BTB_POZ_ZBTB35_ZNF131', NULL, 'BTB_POZ_ZBTB35_ZNF131', NULL, NULL, NULL, 2),
(9961, NULL, 'cd16500', NULL, NULL, 'RING-HC_CARP', NULL, 'RING-HC_CARP', NULL, NULL, NULL, 2),
(9962, NULL, 'cd01663', NULL, NULL, 'Cyt_c_Oxidase_I', NULL, 'Cyt_c_Oxidase_I', NULL, NULL, 29442, 2),
(9963, NULL, 'cd11726', NULL, NULL, 'ADDz_ATRX', NULL, 'ADDz_ATRX', NULL, NULL, NULL, 2),
(9964, NULL, 'cd00392', NULL, NULL, 'Ribosomal_L13', NULL, 'Ribosomal_L13', NULL, NULL, 5885, 2),
(9965, NULL, 'cd14626', NULL, NULL, 'R-PTPc-F-1', NULL, 'R-PTPc-F-1', NULL, NULL, NULL, 2),
(9966, NULL, 'cd00062', NULL, NULL, 'FN2', NULL, 'FN2', NULL, NULL, 5841, 2),
(9967, NULL, 'cd06213', NULL, NULL, 'oxygenase_e_transfer_subunit', NULL, 'oxygenase_e_transfer_subunit', NULL, NULL, NULL, 2),
(9968, NULL, 'cd09428', NULL, NULL, 'LIM2_FHL5', NULL, 'LIM2_FHL5', NULL, NULL, 35725, 2),
(9969, NULL, 'cd14958', NULL, NULL, 'NHL_PAL_like', NULL, 'NHL_PAL_like', NULL, NULL, NULL, 2),
(9970, NULL, 'cd01137', NULL, NULL, 'PsaA', NULL, 'PsaA', NULL, NULL, NULL, 2),
(9971, NULL, 'cd01310', NULL, NULL, 'TatD_DNAse', NULL, 'TatD_DNAse', NULL, NULL, 1636, 2),
(9972, NULL, 'cd09569', NULL, NULL, 'SAM_liprin-beta1,2_repeat3', NULL, 'SAM_liprin-beta1,2_repeat3', NULL, NULL, 32397, 2),
(9973, NULL, 'cd09328', NULL, NULL, 'LIM2_abLIM', NULL, 'LIM2_abLIM', NULL, NULL, NULL, 2),
(9974, NULL, 'cd14260', NULL, NULL, 'PUFD_like_1', NULL, 'PUFD_like_1', NULL, NULL, NULL, 2),
(9975, NULL, 'cd18444', NULL, NULL, 'BACK_KLHL1_like', NULL, 'BACK_KLHL1_like', NULL, NULL, NULL, 2),
(9976, NULL, 'cd21523', NULL, NULL, 'SUD_C_MERS-CoV_Nsp3', NULL, 'SUD_C_MERS-CoV_Nsp3', NULL, NULL, 36897, 2),
(9977, NULL, 'cd07895', NULL, NULL, 'Adenylation_mRNA_capping', NULL, 'Adenylation_mRNA_capping', NULL, NULL, 7077, 2),
(9978, NULL, 'cd18309', NULL, NULL, 'BTB2_POZ_LZTR1', NULL, 'BTB2_POZ_LZTR1', NULL, NULL, NULL, 2),
(9979, NULL, 'cd13724', NULL, NULL, 'PBP2_iGluR_kainate_KA1', NULL, 'PBP2_iGluR_kainate_KA1', NULL, NULL, NULL, 2),
(9980, NULL, 'cd16019', NULL, NULL, 'GPI_EPT', NULL, 'GPI_EPT', NULL, NULL, NULL, 2),
(9981, NULL, 'cd12610', NULL, NULL, 'RRM1_SECp43', NULL, 'RRM1_SECp43', NULL, NULL, NULL, 2),
(9982, NULL, 'cd17273', NULL, NULL, 'RMtype1_S_EcoJA69PI-TRD1-CR1_like', NULL, 'RMtype1_S_EcoJA69PI-TRD1-CR1_like', NULL, NULL, NULL, 2),
(9983, NULL, 'cd12608', NULL, NULL, 'RRM1_CoAA', NULL, 'RRM1_CoAA', NULL, NULL, 20954, 2),
(9984, NULL, 'cd03014', NULL, NULL, 'PRX_Atyp2cys', NULL, 'PRX_Atyp2cys', NULL, NULL, 5071, 2),
(9985, NULL, 'cd02910', NULL, NULL, 'cupin_Yhhw_N', NULL, 'cupin_Yhhw_N', NULL, NULL, NULL, 2);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(9986, NULL, 'cd08724', NULL, NULL, 'RGS_GRK-like', NULL, 'RGS_GRK-like', NULL, NULL, NULL, 2),
(9987, NULL, 'cd18096', NULL, NULL, 'SpoU-like', NULL, 'SpoU-like', NULL, NULL, NULL, 2),
(9988, NULL, 'cd06862', NULL, NULL, 'PX_SNX9_18_like', NULL, 'PX_SNX9_18_like', NULL, NULL, NULL, 2),
(9989, NULL, 'cd01093', NULL, NULL, 'CRIB_PAK_like', NULL, 'CRIB_PAK_like', NULL, NULL, 26760, 2),
(9990, NULL, 'cd21639', NULL, NULL, 'NS7a_deltaCoV_HKU30-like', NULL, 'NS7a_deltaCoV_HKU30-like', NULL, NULL, 36117, 2),
(9991, NULL, 'cd01382', NULL, NULL, 'MYSc_Myo6', NULL, 'MYSc_Myo6', NULL, NULL, 32708, 2),
(9992, NULL, 'cd06624', NULL, NULL, 'STKc_ASK', NULL, 'STKc_ASK', NULL, NULL, NULL, 2),
(9993, NULL, 'cd12921', NULL, NULL, 'VKOR_4', NULL, 'VKOR_4', NULL, NULL, NULL, 2),
(9994, NULL, 'cd03301', NULL, NULL, 'ABC_MalK_N', NULL, 'ABC_MalK_N', NULL, NULL, 13007, 2),
(9995, NULL, 'cd13371', NULL, NULL, 'PH_GAP1_mammal-like', NULL, 'PH_GAP1_mammal-like', NULL, NULL, 32211, 2),
(9996, NULL, 'cd14013', NULL, NULL, 'STKc_SNT7_plant', NULL, 'STKc_SNT7_plant', NULL, NULL, NULL, 2),
(9997, NULL, 'cd04207', NULL, NULL, 'CuRO_3_LCC_like', NULL, 'CuRO_3_LCC_like', NULL, NULL, NULL, 2),
(9998, NULL, 'cd03469', NULL, NULL, 'Rieske_RO_Alpha_N', NULL, 'Rieske_RO_Alpha_N', NULL, NULL, NULL, 2),
(9999, NULL, 'cd06159', NULL, NULL, 'S2P-M50_PDZ_Arch', NULL, 'S2P-M50_PDZ_Arch', NULL, NULL, NULL, 2),
(10000, NULL, 'cd17625', NULL, NULL, 'REC_OmpR_DrrD-like', NULL, 'REC_OmpR_DrrD-like', NULL, NULL, NULL, 2),
(10001, NULL, 'cd15049', NULL, NULL, '7tmA_mAChR', NULL, '7tmA_mAChR', NULL, NULL, NULL, 2),
(10002, NULL, 'cd19452', NULL, NULL, 'lipocalin_ABP', NULL, 'lipocalin_ABP', NULL, NULL, NULL, 2),
(10003, NULL, 'cd08967', NULL, NULL, 'MeNeil1_N', NULL, 'MeNeil1_N', NULL, NULL, NULL, 2),
(10004, NULL, 'cd02340', NULL, NULL, 'ZZ_NBR1_like', NULL, 'ZZ_NBR1_like', NULL, NULL, NULL, 2),
(10005, NULL, 'cd14529', NULL, NULL, 'TpbA-like', NULL, 'TpbA-like', NULL, NULL, NULL, 2),
(10006, NULL, 'cd09918', NULL, NULL, 'SH2_Nterm_SPT6_like', NULL, 'SH2_Nterm_SPT6_like', NULL, NULL, 20786, 2),
(10007, NULL, 'cd15813', NULL, NULL, 'SPRY_PRY_TRIM20', NULL, 'SPRY_PRY_TRIM20', NULL, NULL, NULL, 2),
(10008, NULL, 'cd15964', NULL, NULL, '7tmA_TSH-R', NULL, '7tmA_TSH-R', NULL, NULL, NULL, 2),
(10009, NULL, 'cd17716', NULL, NULL, 'BRCT_microcephalin_rpt1', NULL, 'BRCT_microcephalin_rpt1', NULL, NULL, NULL, 2),
(10010, NULL, 'cd06901', NULL, NULL, 'lectin_VIP36_VIPL', NULL, 'lectin_VIP36_VIPL', NULL, NULL, 33159, 2),
(10011, NULL, 'cd02888', NULL, NULL, 'RNR_II_dimer', NULL, 'RNR_II_dimer', NULL, NULL, 18995, 2),
(10012, NULL, 'cd12465', NULL, NULL, 'RRM_UHMK1', NULL, 'RRM_UHMK1', NULL, NULL, 30653, 2),
(10013, NULL, 'cd01772', NULL, NULL, 'UBX_UBXN1', NULL, 'UBX_UBXN1', NULL, NULL, NULL, 2),
(10014, NULL, 'cd04171', NULL, NULL, 'SelB', NULL, 'SelB', NULL, NULL, NULL, 2),
(10015, NULL, 'cd16644', NULL, NULL, 'mRING-HC-C3HC3D_TRAF7', NULL, 'mRING-HC-C3HC3D_TRAF7', NULL, NULL, NULL, 2),
(10016, NULL, 'cd21482', NULL, NULL, 'HKU1_N5-like_CoV_Spike_S1_RBD', NULL, 'HKU1_N5-like_CoV_Spike_S1_RBD', NULL, NULL, 36316, 2),
(10017, NULL, 'cd01777', NULL, NULL, 'FERM_F1_SNX27', NULL, 'FERM_F1_SNX27', NULL, NULL, 29538, 2),
(10018, NULL, 'cd01822', NULL, NULL, 'Lysophospholipase_L1_like', NULL, 'Lysophospholipase_L1_like', NULL, NULL, NULL, 2),
(10019, NULL, 'cd04982', NULL, NULL, 'IgV_TCR_gamma', NULL, 'IgV_TCR_gamma', NULL, NULL, NULL, 2),
(10020, NULL, 'cd19032', NULL, NULL, 'LGIC_ECD_nAChR_proto_beta-like', NULL, 'LGIC_ECD_nAChR_proto_beta-like', NULL, NULL, NULL, 2),
(10021, NULL, 'cd14643', NULL, NULL, 'DSP_DUSP7', NULL, 'DSP_DUSP7', NULL, NULL, NULL, 2),
(10022, NULL, 'cd16558', NULL, NULL, 'RING-HC_RNF207', NULL, 'RING-HC_RNF207', NULL, NULL, NULL, 2),
(10023, NULL, 'cd02218', NULL, NULL, 'cupin_PGI', NULL, 'cupin_PGI', NULL, NULL, NULL, 2),
(10024, NULL, 'cd04438', NULL, NULL, 'DEP_dishevelled', NULL, 'DEP_dishevelled', NULL, NULL, NULL, 2),
(10025, NULL, 'cd13914', NULL, NULL, 'CuRO_HCO_II_like_3', NULL, 'CuRO_HCO_II_like_3', NULL, NULL, NULL, 2);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(10026, NULL, 'cd12940', NULL, NULL, 'LEM_LAP2_LEMD1', NULL, 'LEM_LAP2_LEMD1', NULL, NULL, NULL, 2),
(10027, NULL, 'cd08642', NULL, NULL, 'DNA_pol_A_pol_I_A', NULL, 'DNA_pol_A_pol_I_A', NULL, NULL, NULL, 2),
(10028, NULL, 'cd12218', NULL, NULL, 'Csn2', NULL, 'Csn2', NULL, NULL, NULL, 2),
(10029, NULL, 'cd05609', NULL, NULL, 'STKc_MAST', NULL, 'STKc_MAST', NULL, NULL, 31283, 2),
(10030, NULL, 'cd11921', NULL, NULL, 'SH3_Vinexin_1', NULL, 'SH3_Vinexin_1', NULL, NULL, 28312, 2),
(10031, NULL, 'cd19342', NULL, NULL, 'Wnt_Wnt10', NULL, 'Wnt_Wnt10', NULL, NULL, NULL, 2),
(10032, NULL, 'cd11422', NULL, NULL, 'bHLH_TS_FIGLA', NULL, 'bHLH_TS_FIGLA', NULL, NULL, NULL, 2),
(10033, NULL, 'cd14155', NULL, NULL, 'PKc_TESK', NULL, 'PKc_TESK', NULL, NULL, NULL, 2),
(10034, NULL, 'cd07020', NULL, NULL, 'Clp_protease_NfeD_1', NULL, 'Clp_protease_NfeD_1', NULL, NULL, NULL, 2),
(10035, NULL, 'cd15636', NULL, NULL, 'PHD_PYGO2', NULL, 'PHD_PYGO2', NULL, NULL, NULL, 2),
(10036, NULL, 'cd02190', NULL, NULL, 'epsilon_tubulin', NULL, 'epsilon_tubulin', NULL, NULL, NULL, 2),
(10037, NULL, 'cd09261', NULL, NULL, 'AP-3_Mu3B_Cterm', NULL, 'AP-3_Mu3B_Cterm', NULL, NULL, NULL, 2),
(10038, NULL, 'cd01285', NULL, NULL, 'nucleoside_deaminase', NULL, 'nucleoside_deaminase', NULL, NULL, NULL, 2),
(10039, NULL, 'cd09870', NULL, NULL, 'PIN_YEN1', NULL, 'PIN_YEN1', NULL, NULL, NULL, 2),
(10040, NULL, 'cd06840', NULL, NULL, 'PLPDE_III_Bif_AspK_DapDC', NULL, 'PLPDE_III_Bif_AspK_DapDC', NULL, NULL, NULL, 2),
(10041, NULL, 'cd17765', NULL, NULL, 'PNP_ThPNP_like', NULL, 'PNP_ThPNP_like', NULL, NULL, NULL, 2),
(10042, NULL, 'cd09342', NULL, NULL, 'LIM3_Testin_like', NULL, 'LIM3_Testin_like', NULL, NULL, NULL, 2),
(10043, NULL, 'cd09754', NULL, NULL, 'Cas8a1_I-A', NULL, 'Cas8a1_I-A', NULL, NULL, NULL, 2),
(10044, NULL, 'cd11924', NULL, NULL, 'SH3_Vinexin_2', NULL, 'SH3_Vinexin_2', NULL, NULL, 28432, 2),
(10045, NULL, 'cd14261', NULL, NULL, 'PUFD', NULL, 'PUFD', NULL, NULL, NULL, 2),
(10046, NULL, 'cd03354', NULL, NULL, 'LbH_SAT', NULL, 'LbH_SAT', NULL, NULL, 37187, 2),
(10047, NULL, 'cd11721', NULL, NULL, 'FANCD2', NULL, 'FANCD2', NULL, NULL, 25524, 2),
(10048, NULL, 'cd11328', NULL, NULL, 'AmyAc_maltase', NULL, 'AmyAc_maltase', NULL, NULL, NULL, 2),
(10049, NULL, 'cd01907', NULL, NULL, 'GlxB', NULL, 'GlxB', NULL, NULL, NULL, 2),
(10050, NULL, 'cd09249', NULL, NULL, 'BRO1_Rhophilin_2', NULL, 'BRO1_Rhophilin_2', NULL, NULL, NULL, 2),
(10051, NULL, 'cd07786', NULL, NULL, 'FGGY_EcGK_like', NULL, 'FGGY_EcGK_like', NULL, NULL, NULL, 2),
(10052, NULL, 'cd03579', NULL, NULL, 'NTR_netrin-1_like', NULL, 'NTR_netrin-1_like', NULL, NULL, NULL, 2),
(10053, NULL, 'cd18178', NULL, NULL, 'ATP-synt_Vo_c_ATP6F_rpt2', NULL, 'ATP-synt_Vo_c_ATP6F_rpt2', NULL, NULL, NULL, 2),
(10054, NULL, 'cd05361', NULL, NULL, 'haloalcohol_DH_SDR_c-like', NULL, 'haloalcohol_DH_SDR_c-like', NULL, NULL, NULL, 2),
(10055, NULL, 'cd15608', NULL, NULL, 'PHD2_KDM5C_5D', NULL, 'PHD2_KDM5C_5D', NULL, NULL, NULL, 2),
(10056, NULL, 'cd00082', NULL, NULL, 'HisKA', NULL, 'HisKA', NULL, NULL, 1082, 2),
(10057, NULL, 'cd14615', NULL, NULL, 'R-PTPc-J', NULL, 'R-PTPc-J', NULL, NULL, NULL, 2),
(10058, NULL, 'cd14133', NULL, NULL, 'PKc_DYRK_like', NULL, 'PKc_DYRK_like', NULL, NULL, NULL, 2),
(10059, NULL, 'cd12693', NULL, NULL, 'RRM2_PTBP1_like', NULL, 'RRM2_PTBP1_like', NULL, NULL, 32314, 2),
(10060, NULL, 'cd14011', NULL, NULL, 'PK_SCY1_like', NULL, 'PK_SCY1_like', NULL, NULL, NULL, 2),
(10061, NULL, 'cd19610', NULL, NULL, 'mannanase_GH134', NULL, 'mannanase_GH134', NULL, NULL, NULL, 2),
(10062, NULL, 'cd00474', NULL, NULL, 'eIF1_SUI1_like', NULL, 'eIF1_SUI1_like', NULL, NULL, NULL, 2),
(10063, NULL, 'cd00999', NULL, NULL, 'PBP2_ArtJ', NULL, 'PBP2_ArtJ', NULL, NULL, 33440, 2),
(10064, NULL, 'cd12276', NULL, NULL, 'RRM2_MEI2_EAR1_like', NULL, 'RRM2_MEI2_EAR1_like', NULL, NULL, NULL, 2),
(10065, NULL, 'cd13908', NULL, NULL, 'CuRO_3_MCO_like_2', NULL, 'CuRO_3_MCO_like_2', NULL, NULL, NULL, 2),
(10066, NULL, 'cd19932', NULL, NULL, 'REC_PdtaR-like', NULL, 'REC_PdtaR-like', NULL, NULL, NULL, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(10067, NULL, 'cd04631', NULL, NULL, 'CBS_archAMPK_gamma-repeat2', NULL, 'CBS_archAMPK_gamma-repeat2', NULL, NULL, NULL, 2),
(10068, NULL, 'cd13739', NULL, NULL, 'SPRY_PRY_TRIM1', NULL, 'SPRY_PRY_TRIM1', NULL, NULL, 30726, 2),
(10069, NULL, 'cd13260', NULL, NULL, 'PH_RASA1', NULL, 'PH_RASA1', NULL, NULL, NULL, 2),
(10070, NULL, 'cd17112', NULL, NULL, 'RA_MRL_like', NULL, 'RA_MRL_like', NULL, NULL, NULL, 2),
(10071, NULL, 'cd05825', NULL, NULL, 'LbH_wcaF_like', NULL, 'LbH_wcaF_like', NULL, NULL, NULL, 2),
(10072, NULL, 'cd12354', NULL, NULL, 'RRM3_TIA1_like', NULL, 'RRM3_TIA1_like', NULL, NULL, NULL, 2),
(10073, NULL, 'cd13532', NULL, NULL, 'PBP2_PDT_like', NULL, 'PBP2_PDT_like', NULL, NULL, NULL, 2),
(10074, NULL, 'cd13622', NULL, NULL, 'PBP2_Arg_3', NULL, 'PBP2_Arg_3', NULL, NULL, NULL, 2),
(10075, NULL, 'cd06627', NULL, NULL, 'STKc_Cdc7_like', NULL, 'STKc_Cdc7_like', NULL, NULL, NULL, 2),
(10076, NULL, 'cd08947', NULL, NULL, 'NmrA_TMR_like_SDR_a', NULL, 'NmrA_TMR_like_SDR_a', NULL, NULL, NULL, 2),
(10077, NULL, 'cd13759', NULL, NULL, 'TGF_beta_NODAL', NULL, 'TGF_beta_NODAL', NULL, NULL, NULL, 2),
(10078, NULL, 'cd15013', NULL, NULL, '7tm_TAS2R4', NULL, '7tm_TAS2R4', NULL, NULL, NULL, 2),
(10079, NULL, 'cd03247', NULL, NULL, 'ABCC_cytochrome_bd', NULL, 'ABCC_cytochrome_bd', NULL, NULL, NULL, 2),
(10080, NULL, 'cd06312', NULL, NULL, 'PBP1_ABC_sugar_binding-like', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, NULL, 2),
(10081, NULL, 'cd07012', NULL, NULL, 'PBP2_Bug_TTT', NULL, 'PBP2_Bug_TTT', NULL, NULL, NULL, 2),
(10082, NULL, 'cd18249', NULL, NULL, 'BTB_POZ_KLHL20_KLEIP', NULL, 'BTB_POZ_KLHL20_KLEIP', NULL, NULL, NULL, 2),
(10083, NULL, 'cd07225', NULL, NULL, 'Pat_PNPLA6_PNPLA7', NULL, 'Pat_PNPLA6_PNPLA7', NULL, NULL, NULL, 2),
(10084, NULL, 'cd15710', NULL, NULL, 'ePHD1_PHF6', NULL, 'ePHD1_PHF6', NULL, NULL, NULL, 2),
(10085, NULL, 'cd00049', NULL, NULL, 'MH1', NULL, 'MH1', NULL, NULL, NULL, 2),
(10086, NULL, 'cd08015', NULL, NULL, 'M28_like', NULL, 'M28_like', NULL, NULL, NULL, 2),
(10087, NULL, 'cd06895', NULL, NULL, 'PX_PLD', NULL, 'PX_PLD', NULL, NULL, NULL, 2),
(10088, NULL, 'cd02791', NULL, NULL, 'MopB_CT_Nitrate-R-NapA-like', NULL, 'MopB_CT_Nitrate-R-NapA-like', NULL, NULL, 30820, 2),
(10089, NULL, 'cd12110', NULL, NULL, 'PHP_HisPPase_Hisj_like', NULL, 'PHP_HisPPase_Hisj_like', NULL, NULL, NULL, 2),
(10090, NULL, 'cd12335', NULL, NULL, 'RRM2_SF3B4', NULL, 'RRM2_SF3B4', NULL, NULL, 14102, 2),
(10091, NULL, 'cd15890', NULL, NULL, 'SNARE_Vti1b', NULL, 'SNARE_Vti1b', NULL, NULL, NULL, 2),
(10092, NULL, 'cd07025', NULL, NULL, 'Peptidase_S66', NULL, 'Peptidase_S66', NULL, NULL, NULL, 2),
(10093, NULL, 'cd17780', NULL, NULL, 'CBS_pair_arch1_repeat1', NULL, 'CBS_pair_arch1_repeat1', NULL, NULL, NULL, 2),
(10094, NULL, 'cd18241', NULL, NULL, 'BTB_POZ_KLHL11', NULL, 'BTB_POZ_KLHL11', NULL, NULL, NULL, 2),
(10095, NULL, 'cd07385', NULL, NULL, 'MPP_YkuE_C', NULL, 'MPP_YkuE_C', NULL, NULL, NULL, 2),
(10096, NULL, 'cd10295', NULL, NULL, 'GST_C_Sigma', NULL, 'GST_C_Sigma', NULL, NULL, NULL, 2),
(10097, NULL, 'sd00019', NULL, NULL, 'ZF_C2H2', NULL, 'ZF_C2H2', NULL, NULL, NULL, 2),
(10098, NULL, 'cd12700', NULL, NULL, 'RRM3_hnRPLL', NULL, 'RRM3_hnRPLL', NULL, NULL, 18522, 2),
(10099, NULL, 'cd05747', NULL, NULL, 'Ig_Titin_like', NULL, 'Ig_Titin_like', NULL, NULL, NULL, 2),
(10100, NULL, 'cd08407', NULL, NULL, 'C2B_Synaptotagmin-13', NULL, 'C2B_Synaptotagmin-13', NULL, NULL, NULL, 2),
(10101, NULL, 'cd09195', NULL, NULL, 'PLDc_mTdp1_2', NULL, 'PLDc_mTdp1_2', NULL, NULL, NULL, 2),
(10102, NULL, 'cd11482', NULL, NULL, 'SLC-NCS1sbd_NRT1-like', NULL, 'SLC-NCS1sbd_NRT1-like', NULL, NULL, NULL, 2),
(10103, NULL, 'cd14729', NULL, NULL, 'RtxA-like', NULL, 'RtxA-like', NULL, NULL, NULL, 2),
(10104, NULL, 'cd21625', NULL, NULL, 'MHV-like_Spike_S1_NTD', NULL, 'MHV-like_Spike_S1_NTD', NULL, NULL, 33751, 2),
(10105, NULL, 'cd02948', NULL, NULL, 'TRX_NDPK', NULL, 'TRX_NDPK', NULL, NULL, NULL, 2),
(10106, NULL, 'cd04590', NULL, NULL, 'CBS_pair_CorC_HlyC_assoc', NULL, 'CBS_pair_CorC_HlyC_assoc', NULL, NULL, 34206, 2);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(10107, NULL, 'cd06488', NULL, NULL, 'p23_melusin_like', NULL, 'p23_melusin_like', NULL, NULL, NULL, 2),
(10108, NULL, 'cd20378', NULL, NULL, 'PBP1_SBP-like', NULL, 'PBP1_SBP-like', NULL, NULL, NULL, 2),
(10109, NULL, 'cd17394', NULL, NULL, 'MFS_FucP_like', NULL, 'MFS_FucP_like', NULL, NULL, NULL, 2),
(10110, NULL, 'cd13390', NULL, NULL, 'PH_LARG', NULL, 'PH_LARG', NULL, NULL, 28794, 2),
(10111, NULL, 'cd00827', NULL, NULL, 'init_cond_enzymes', NULL, 'init_cond_enzymes', NULL, NULL, NULL, 2),
(10112, NULL, 'cd10585', NULL, NULL, 'CE4_SF', NULL, 'CE4_SF', NULL, NULL, NULL, 2),
(10113, NULL, 'cd14719', NULL, NULL, 'bZIP_BACH', NULL, 'bZIP_BACH', NULL, NULL, 37171, 2),
(10114, NULL, 'cd16778', NULL, NULL, 'mRING-HC-C4C4_RBR_RNF144B', NULL, 'mRING-HC-C4C4_RBR_RNF144B', NULL, NULL, NULL, 2),
(10115, NULL, 'cd08029', NULL, NULL, 'LA_like_fungal', NULL, 'LA_like_fungal', NULL, NULL, NULL, 2),
(10116, NULL, 'cd01138', NULL, NULL, 'FeuA', NULL, 'FeuA', NULL, NULL, NULL, 2),
(10117, NULL, 'cd15298', NULL, NULL, '7tmA_mAChR_M4', NULL, '7tmA_mAChR_M4', NULL, NULL, NULL, 2),
(10118, NULL, 'cd17210', NULL, NULL, 'RA_RGL', NULL, 'RA_RGL', NULL, NULL, NULL, 2),
(10119, NULL, 'cd17461', NULL, NULL, 'MFS_SLCO2A_OATP2A', NULL, 'MFS_SLCO2A_OATP2A', NULL, NULL, NULL, 2),
(10120, NULL, 'cd04191', NULL, NULL, 'Glucan_BSP_MdoH', NULL, 'Glucan_BSP_MdoH', NULL, NULL, NULL, 2),
(10121, NULL, 'cd11902', NULL, NULL, 'SH3_Nck2_2', NULL, 'SH3_Nck2_2', NULL, NULL, 33011, 2),
(10122, NULL, 'cd09731', NULL, NULL, 'Cse2_I-E', NULL, 'Cse2_I-E', NULL, NULL, NULL, 2),
(10123, NULL, 'cd11521', NULL, NULL, 'SLC6sbd_NTT4', NULL, 'SLC6sbd_NTT4', NULL, NULL, NULL, 2),
(10124, NULL, 'cd11252', NULL, NULL, 'Sema_3D', NULL, 'Sema_3D', NULL, NULL, 35718, 2),
(10125, NULL, 'cd00017', NULL, NULL, 'ANATO', NULL, 'ANATO', NULL, NULL, 2547, 2),
(10126, NULL, 'cd00819', NULL, NULL, 'PEPCK_GTP', NULL, 'PEPCK_GTP', NULL, NULL, 7480, 2),
(10127, NULL, 'cd17448', NULL, NULL, 'MFS_SLC46A3', NULL, 'MFS_SLC46A3', NULL, NULL, NULL, 2),
(10128, NULL, 'cd10453', NULL, NULL, 'GIY-YIG_RE_Cfr42I', NULL, 'GIY-YIG_RE_Cfr42I', NULL, NULL, NULL, 2),
(10129, NULL, 'cd13186', NULL, NULL, 'FERM_C_NBL4_NBL5', NULL, 'FERM_C_NBL4_NBL5', NULL, NULL, NULL, 2),
(10130, NULL, 'cd00761', NULL, NULL, 'Glyco_tranf_GTA_type', NULL, 'Glyco_tranf_GTA_type', NULL, NULL, NULL, 2),
(10131, NULL, 'cd13652', NULL, NULL, 'PBP2_ThiY_THI5_like_1', NULL, 'PBP2_ThiY_THI5_like_1', NULL, NULL, NULL, 2),
(10132, NULL, 'cd06591', NULL, NULL, 'GH31_xylosidase_XylS', NULL, 'GH31_xylosidase_XylS', NULL, NULL, NULL, 2),
(10133, NULL, 'cd12208', NULL, NULL, 'septicolysin_like', NULL, 'septicolysin_like', NULL, NULL, NULL, 2),
(10134, NULL, 'cd08924', NULL, NULL, 'Cygb', NULL, 'Cygb', NULL, NULL, NULL, 2),
(10135, NULL, 'cd17493', NULL, NULL, 'toxin_TenpN', NULL, 'toxin_TenpN', NULL, NULL, NULL, 2),
(10136, NULL, 'cd03072', NULL, NULL, 'PDI_b''_ERp44', NULL, 'PDI_b''_ERp44', NULL, NULL, 30767, 2),
(10137, NULL, 'cd01803', NULL, NULL, 'Ubl_ubiquitin', NULL, 'Ubl_ubiquitin', NULL, NULL, NULL, 2),
(10138, NULL, 'cd08173', NULL, NULL, 'Gro1PDH', NULL, 'Gro1PDH', NULL, NULL, NULL, 2),
(10139, NULL, 'cd14241', NULL, NULL, 'PAD', NULL, 'PAD', NULL, NULL, 12207, 2),
(10140, NULL, 'cd16979', NULL, NULL, 'VHS_Vps27', NULL, 'VHS_Vps27', NULL, NULL, NULL, 2),
(10141, NULL, 'cd16306', NULL, NULL, 'CphA_ImiS-like_MBL-B2', NULL, 'CphA_ImiS-like_MBL-B2', NULL, NULL, NULL, 2),
(10142, NULL, 'cd04266', NULL, NULL, 'DUF619-NAGS-FABP', NULL, 'DUF619-NAGS-FABP', NULL, NULL, NULL, 2),
(10143, NULL, 'cd12487', NULL, NULL, 'RRM1_DND1', NULL, 'RRM1_DND1', NULL, NULL, 13749, 2),
(10144, NULL, 'cd14158', NULL, NULL, 'STKc_IRAK4', NULL, 'STKc_IRAK4', NULL, NULL, NULL, 2),
(10145, NULL, 'cd06818', NULL, NULL, 'PLPDE_III_cryptic_DSD', NULL, 'PLPDE_III_cryptic_DSD', NULL, NULL, NULL, 2),
(10146, NULL, 'cd03371', NULL, NULL, 'TPP_PpyrDC', NULL, 'TPP_PpyrDC', NULL, NULL, NULL, 2),
(10147, NULL, 'cd04702', NULL, NULL, 'ASRGL1_like', NULL, 'ASRGL1_like', NULL, NULL, 31829, 2),
(10148, NULL, 'cd19893', NULL, NULL, 'DSRM_TARBP2_rpt3', NULL, 'DSRM_TARBP2_rpt3', NULL, NULL, 34477, 2); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(10149, NULL, 'cd09188', NULL, NULL, 'PLDc_FAM83H_N', NULL, 'PLDc_FAM83H_N', NULL, NULL, 30608, 2),
(10150, NULL, 'cd17398', NULL, NULL, 'MFS_FLVCR_like', NULL, 'MFS_FLVCR_like', NULL, NULL, NULL, 2),
(10151, NULL, 'cd00377', NULL, NULL, 'ICL_PEPM', NULL, 'ICL_PEPM', NULL, NULL, 33485, 2),
(10152, NULL, 'cd08597', NULL, NULL, 'PI-PLCc_PRIP_metazoa', NULL, 'PI-PLCc_PRIP_metazoa', NULL, NULL, NULL, 2),
(10153, NULL, 'cd02177', NULL, NULL, 'GH16_kappa_carrageenase', NULL, 'GH16_kappa_carrageenase', NULL, NULL, NULL, 2),
(10154, NULL, 'cd03225', NULL, NULL, 'ABC_cobalt_CbiO_domain1', NULL, 'ABC_cobalt_CbiO_domain1', NULL, NULL, 13341, 2),
(10155, NULL, 'cd08899', NULL, NULL, 'SRPBCC_CalC_Aha1-like_6', NULL, 'SRPBCC_CalC_Aha1-like_6', NULL, NULL, NULL, 2),
(10156, NULL, 'cd19876', NULL, NULL, 'DSRM_RNT1p-like', NULL, 'DSRM_RNT1p-like', NULL, NULL, 36407, 2),
(10157, NULL, 'cd02131', NULL, NULL, 'PA_hNAALADL2_like', NULL, 'PA_hNAALADL2_like', NULL, NULL, NULL, 2),
(10158, NULL, 'cd03725', NULL, NULL, 'SOCS_ASB6', NULL, 'SOCS_ASB6', NULL, NULL, 30769, 2),
(10159, NULL, 'cd08872', NULL, NULL, 'START_STARD11-like', NULL, 'START_STARD11-like', NULL, NULL, 30637, 2),
(10160, NULL, 'cd01151', NULL, NULL, 'GCD', NULL, 'GCD', NULL, NULL, NULL, 2),
(10161, NULL, 'cd08250', NULL, NULL, 'Mgc45594_like', NULL, 'Mgc45594_like', NULL, NULL, NULL, 2),
(10162, NULL, 'cd14993', NULL, NULL, '7tmA_CCKR-like', NULL, '7tmA_CCKR-like', NULL, NULL, NULL, 2),
(10163, NULL, 'cd01188', NULL, NULL, 'INT_RitA_C_like', NULL, 'INT_RitA_C_like', NULL, NULL, NULL, 2),
(10164, NULL, 'cd08411', NULL, NULL, 'PBP2_OxyR', NULL, 'PBP2_OxyR', NULL, NULL, NULL, 2),
(10165, NULL, 'cd09533', NULL, NULL, 'SAM_Ste50-like_fungal', NULL, 'SAM_Ste50-like_fungal', NULL, NULL, NULL, 2),
(10166, NULL, 'cd08630', NULL, NULL, 'PI-PLCc_delta3', NULL, 'PI-PLCc_delta3', NULL, NULL, NULL, 2),
(10167, NULL, 'cd12558', NULL, NULL, 'RRM3_RBM15B', NULL, 'RRM3_RBM15B', NULL, NULL, 326, 2),
(10168, NULL, 'cd14859', NULL, NULL, 'PMEI_like', NULL, 'PMEI_like', NULL, NULL, NULL, 2),
(10169, NULL, 'cd13938', NULL, NULL, 'PANDER_like_TMEM2', NULL, 'PANDER_like_TMEM2', NULL, NULL, 33032, 2),
(10170, NULL, 'cd01395', NULL, NULL, 'HMT_MBD', NULL, 'HMT_MBD', NULL, NULL, NULL, 2),
(10171, NULL, 'cd02868', NULL, NULL, 'PseudoU_synth_hTruB2_like', NULL, 'PseudoU_synth_hTruB2_like', NULL, NULL, NULL, 2),
(10172, NULL, 'cd07877', NULL, NULL, 'STKc_p38alpha', NULL, 'STKc_p38alpha', NULL, NULL, 30946, 2),
(10173, NULL, 'cd11555', NULL, NULL, 'SLC-NCS1sbd_u1', NULL, 'SLC-NCS1sbd_u1', NULL, NULL, NULL, 2),
(10174, NULL, 'cd12807', NULL, NULL, 'Esterase_713', NULL, 'Esterase_713', NULL, NULL, NULL, 2),
(10175, NULL, 'cd16651', NULL, NULL, 'SPL-RING_NSE2', NULL, 'SPL-RING_NSE2', NULL, NULL, 2874, 2),
(10176, NULL, 'cd14617', NULL, NULL, 'R-PTPc-B', NULL, 'R-PTPc-B', NULL, NULL, NULL, 2),
(10177, NULL, 'cd17037', NULL, NULL, 'T3SC_IA_ShcV-like', NULL, 'T3SC_IA_ShcV-like', NULL, NULL, NULL, 2),
(10178, NULL, 'cd06900', NULL, NULL, 'lectin_VcfQ', NULL, 'lectin_VcfQ', NULL, NULL, 33023, 2),
(10179, NULL, 'cd00268', NULL, NULL, 'DEADc', NULL, 'DEADc', NULL, NULL, NULL, 2),
(10180, NULL, 'cd19771', NULL, NULL, 'Bbox2_TRIM20', NULL, 'Bbox2_TRIM20', NULL, NULL, NULL, 2),
(10181, NULL, 'cd07006', NULL, NULL, 'cupin_XcTcmJ-like', NULL, 'cupin_XcTcmJ-like', NULL, NULL, NULL, 2),
(10182, NULL, 'cd09824', NULL, NULL, 'myeloperoxidase_like', NULL, 'myeloperoxidase_like', NULL, NULL, NULL, 2),
(10183, NULL, 'cd06564', NULL, NULL, 'GH20_DspB_LnbB-like', NULL, 'GH20_DspB_LnbB-like', NULL, NULL, NULL, 2),
(10184, NULL, 'cd18922', NULL, NULL, 'bHLHzip_SREBP2', NULL, 'bHLHzip_SREBP2', NULL, NULL, NULL, 2),
(10185, NULL, 'cd11503', NULL, NULL, 'SLC5sbd_NIS', NULL, 'SLC5sbd_NIS', NULL, NULL, 27820, 2),
(10186, NULL, 'cd16607', NULL, NULL, 'RING-HC_TRIM60_like_C-IV', NULL, 'RING-HC_TRIM60_like_C-IV', NULL, NULL, NULL, 2),
(10187, NULL, 'cd05128', NULL, NULL, 'RasGAP_GAP1_like', NULL, 'RasGAP_GAP1_like', NULL, NULL, NULL, 2),
(10188, NULL, 'cd04336', NULL, NULL, 'YeaK', NULL, 'YeaK', NULL, NULL, 34850, 2);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(10189, NULL, 'cd05936', NULL, NULL, 'FC-FACS_FadD_like', NULL, 'FC-FACS_FadD_like', NULL, NULL, NULL, 2),
(10190, NULL, 'cd12154', NULL, NULL, 'FDH_GDH_like', NULL, 'FDH_GDH_like', NULL, NULL, NULL, 2),
(10191, NULL, 'cd08000', NULL, NULL, 'NGN', NULL, 'NGN', NULL, NULL, NULL, 2),
(10192, NULL, 'cd10913', NULL, NULL, 'Peptidase_C25_N_gingipain', NULL, 'Peptidase_C25_N_gingipain', NULL, NULL, 33259, 2),
(10193, NULL, 'cd09430', NULL, NULL, 'LIM5_LIMPETin', NULL, 'LIM5_LIMPETin', NULL, NULL, NULL, 2),
(10194, NULL, 'cd14576', NULL, NULL, 'DSP_iDUSP27', NULL, 'DSP_iDUSP27', NULL, NULL, NULL, 2),
(10195, NULL, 'cd07341', NULL, NULL, 'M56_BlaR1_MecR1_like', NULL, 'M56_BlaR1_MecR1_like', NULL, NULL, NULL, 2),
(10196, NULL, 'cd01185', NULL, NULL, 'INTN1_C_like', NULL, 'INTN1_C_like', NULL, NULL, NULL, 2),
(10197, NULL, 'cd10938', NULL, NULL, 'CE4_HpPgdA_like', NULL, 'CE4_HpPgdA_like', NULL, NULL, 28765, 2),
(10198, NULL, 'cd15965', NULL, NULL, '7tmA_RXFP1_LGR7', NULL, '7tmA_RXFP1_LGR7', NULL, NULL, NULL, 2),
(10199, NULL, 'cd03208', NULL, NULL, 'GST_C_Alpha', NULL, 'GST_C_Alpha', NULL, NULL, NULL, 2),
(10200, NULL, 'cd19572', NULL, NULL, 'serpinB13_headpin', NULL, 'serpinB13_headpin', NULL, NULL, NULL, 2),
(10201, NULL, 'cd10563', NULL, NULL, 'CooF_like', NULL, 'CooF_like', NULL, NULL, NULL, 2),
(10202, NULL, 'cd05356', NULL, NULL, '17beta-HSD1_like_SDR_c', NULL, '17beta-HSD1_like_SDR_c', NULL, NULL, NULL, 2),
(10203, NULL, 'cd02021', NULL, NULL, 'GntK', NULL, 'GntK', NULL, NULL, 1419, 2),
(10204, NULL, 'cd10399', NULL, NULL, 'SH2_Tec_Bmx', NULL, 'SH2_Tec_Bmx', NULL, NULL, 32538, 2),
(10205, NULL, 'cd14419', NULL, NULL, 'CUE_DMA_DMRTA3', NULL, 'CUE_DMA_DMRTA3', NULL, NULL, NULL, 2),
(10206, NULL, 'cd07499', NULL, NULL, 'HAD_CBAP', NULL, 'HAD_CBAP', NULL, NULL, 5238, 2),
(10207, NULL, 'cd00095', NULL, NULL, 'IFab', NULL, 'IFab', NULL, NULL, 5598, 2),
(10208, NULL, 'cd07231', NULL, NULL, 'Pat_SDP1-like', NULL, 'Pat_SDP1-like', NULL, NULL, NULL, 2),
(10209, NULL, 'cd15554', NULL, NULL, 'PHD_PHF2_like', NULL, 'PHD_PHF2_like', NULL, NULL, NULL, 2),
(10210, NULL, 'cd16432', NULL, NULL, 'CheB_Rec', NULL, 'CheB_Rec', NULL, NULL, 3971, 2),
(10211, NULL, 'cd02776', NULL, NULL, 'MopB_CT_Nitrate-R-NarG-like', NULL, 'MopB_CT_Nitrate-R-NarG-like', NULL, NULL, 31988, 2),
(10212, NULL, 'cd17778', NULL, NULL, 'CBS_arch_repeat2', NULL, 'CBS_arch_repeat2', NULL, NULL, NULL, 2),
(10213, NULL, 'cd11853', NULL, NULL, 'SH3_Kalirin_2', NULL, 'SH3_Kalirin_2', NULL, NULL, NULL, 2),
(10214, NULL, 'cd17011', NULL, NULL, 'CID_RPRD1A', NULL, 'CID_RPRD1A', NULL, NULL, NULL, 2),
(10215, NULL, 'cd18908', NULL, NULL, 'bHLH_SOHLH1_2', NULL, 'bHLH_SOHLH1_2', NULL, NULL, NULL, 2),
(10216, NULL, 'cd18989', NULL, NULL, 'LGIC_ECD_cation', NULL, 'LGIC_ECD_cation', NULL, NULL, NULL, 2),
(10217, NULL, 'cd03812', NULL, NULL, 'GT4_CapH-like', NULL, 'GT4_CapH-like', NULL, NULL, NULL, 2),
(10218, NULL, 'cd17970', NULL, NULL, 'DEAHc_FancJ', NULL, 'DEAHc_FancJ', NULL, NULL, NULL, 2),
(10219, NULL, 'cd02985', NULL, NULL, 'TRX_CDSP32', NULL, 'TRX_CDSP32', NULL, NULL, NULL, 2),
(10220, NULL, 'cd14130', NULL, NULL, 'STKc_TTBK1', NULL, 'STKc_TTBK1', NULL, NULL, 36062, 2),
(10221, NULL, 'cd11427', NULL, NULL, 'bHLH_TS_NeuroD', NULL, 'bHLH_TS_NeuroD', NULL, NULL, NULL, 2),
(10222, NULL, 'cd15803', NULL, NULL, 'RLR_C_like', NULL, 'RLR_C_like', NULL, NULL, NULL, 2),
(10223, NULL, 'cd02039', NULL, NULL, 'cytidylyltransferase_like', NULL, 'cytidylyltransferase_like', NULL, NULL, NULL, 2),
(10224, NULL, 'cd09496', NULL, NULL, 'SAM_liprin-kazrin_repeat3', NULL, 'SAM_liprin-kazrin_repeat3', NULL, NULL, NULL, 2),
(10225, NULL, 'cd15628', NULL, NULL, 'PHD_BAZ1B', NULL, 'PHD_BAZ1B', NULL, NULL, NULL, 2),
(10226, NULL, 'cd00101', NULL, NULL, 'IlGF_like', NULL, 'IlGF_like', NULL, NULL, NULL, 2),
(10227, NULL, 'cd08584', NULL, NULL, 'PI-PLCc_GDPD_SF_unchar2', NULL, 'PI-PLCc_GDPD_SF_unchar2', NULL, NULL, NULL, 2),
(10228, NULL, 'cd12512', NULL, NULL, 'RRM3_RBM12', NULL, 'RRM3_RBM12', NULL, NULL, 8913, 2),
(10229, NULL, 'cd12495', NULL, NULL, 'RRM3_hnRNPQ', NULL, 'RRM3_hnRNPQ', NULL, NULL, NULL, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(10230, NULL, 'cd14946', NULL, NULL, 'Tet_JBP', NULL, 'Tet_JBP', NULL, NULL, NULL, 2),
(10231, NULL, 'cd03888', NULL, NULL, 'M20_PepV', NULL, 'M20_PepV', NULL, NULL, NULL, 2),
(10232, NULL, 'cd15773', NULL, NULL, 'FYVE1_BSN', NULL, 'FYVE1_BSN', NULL, NULL, NULL, 2),
(10233, NULL, 'cd01449', NULL, NULL, 'TST_Repeat_2', NULL, 'TST_Repeat_2', NULL, NULL, NULL, 2),
(10234, NULL, 'cd08218', NULL, NULL, 'STKc_Nek1', NULL, 'STKc_Nek1', NULL, NULL, NULL, 2),
(10235, NULL, 'cd11366', NULL, NULL, 'RNase_PH_archRRP41', NULL, 'RNase_PH_archRRP41', NULL, NULL, 13078, 2),
(10236, NULL, 'cd00298', NULL, NULL, 'ACD_sHsps_p23-like', NULL, 'ACD_sHsps_p23-like', NULL, NULL, NULL, 2),
(10237, NULL, 'cd04412', NULL, NULL, 'NDPk7B', NULL, 'NDPk7B', NULL, NULL, 27578, 2),
(10238, NULL, 'cd12421', NULL, NULL, 'RRM1_PTBP1_hnRNPL_like', NULL, 'RRM1_PTBP1_hnRNPL_like', NULL, NULL, NULL, 2),
(10239, NULL, 'cd18967', NULL, NULL, 'chromodomain', NULL, 'chromodomain', NULL, NULL, NULL, 2),
(10240, NULL, 'cd12783', NULL, NULL, 'RRM2_PTBP2', NULL, 'RRM2_PTBP2', NULL, NULL, NULL, 2),
(10241, NULL, 'cd01797', NULL, NULL, 'Ubl_UHRF', NULL, 'Ubl_UHRF', NULL, NULL, NULL, 2),
(10242, NULL, 'cd19698', NULL, NULL, 'bHLH_AtMEE8_like', NULL, 'bHLH_AtMEE8_like', NULL, NULL, NULL, 2),
(10243, NULL, 'cd19039', NULL, NULL, 'LGIC_ECD_GABAAR_A6', NULL, 'LGIC_ECD_GABAAR_A6', NULL, NULL, NULL, 2),
(10244, NULL, 'cd16216', NULL, NULL, 'EFh_PI-PLCgamma1_like', NULL, 'EFh_PI-PLCgamma1_like', NULL, NULL, NULL, 2),
(10245, NULL, 'cd17303', NULL, NULL, 'PIPKc_PIP5K_yeast_like', NULL, 'PIPKc_PIP5K_yeast_like', NULL, NULL, NULL, 2),
(10246, NULL, 'cd07449', NULL, NULL, 'CRD_FZ3', NULL, 'CRD_FZ3', NULL, NULL, 30011, 2),
(10247, NULL, 'cd04232', NULL, NULL, 'CuRO_1_CueO_FtsP', NULL, 'CuRO_1_CueO_FtsP', NULL, NULL, NULL, 2),
(10248, NULL, 'cd19763', NULL, NULL, 'Bbox2_TRIM8_C-V', NULL, 'Bbox2_TRIM8_C-V', NULL, NULL, NULL, 2),
(10249, NULL, 'cd08886', NULL, NULL, 'RHO_alpha_C_2', NULL, 'RHO_alpha_C_2', NULL, NULL, NULL, 2),
(10250, NULL, 'cd15609', NULL, NULL, 'PHD_TCF19', NULL, 'PHD_TCF19', NULL, NULL, 27088, 2),
(10251, NULL, 'sd00020', NULL, NULL, 'ZF_C2H2', NULL, 'ZF_C2H2', NULL, NULL, NULL, 2),
(10252, NULL, 'cd17440', NULL, NULL, 'MFS_SV2C', NULL, 'MFS_SV2C', NULL, NULL, NULL, 2),
(10253, NULL, 'cd12831', NULL, NULL, 'TmCorA-like_u2', NULL, 'TmCorA-like_u2', NULL, NULL, NULL, 2),
(10254, NULL, 'cd17161', NULL, NULL, 'UBX_UBXN2B', NULL, 'UBX_UBXN2B', NULL, NULL, NULL, 2),
(10255, NULL, 'cd00841', NULL, NULL, 'MPP_YfcE', NULL, 'MPP_YfcE', NULL, NULL, 30650, 2),
(10256, NULL, 'cd14333', NULL, NULL, 'UBA_unchar_Eumetazoa', NULL, 'UBA_unchar_Eumetazoa', NULL, NULL, NULL, 2),
(10257, NULL, 'cd03582', NULL, NULL, 'NTR_complement_C5', NULL, 'NTR_complement_C5', NULL, NULL, NULL, 2),
(10258, NULL, 'cd11505', NULL, NULL, 'SLC5sbd_SMCT', NULL, 'SLC5sbd_SMCT', NULL, NULL, NULL, 2),
(10259, NULL, 'cd18355', NULL, NULL, 'BTB1_POZ_RHOBTB1', NULL, 'BTB1_POZ_RHOBTB1', NULL, NULL, NULL, 2),
(10260, NULL, 'cd19832', NULL, NULL, 'Bbox2_MuRF2_C-II', NULL, 'Bbox2_MuRF2_C-II', NULL, NULL, NULL, 2),
(10261, NULL, 'cd03211', NULL, NULL, 'GST_C_Metaxin2', NULL, 'GST_C_Metaxin2', NULL, NULL, NULL, 2),
(10262, NULL, 'cd17512', NULL, NULL, 'RMtype1_S_BceB55ORF5615P-TRD2-CR2_like', NULL, 'RMtype1_S_BceB55ORF5615P-TRD2-CR2_like', NULL, NULL, NULL, 2),
(10263, NULL, 'cd17745', NULL, NULL, 'BRCT_p53bp1_rpt1', NULL, 'BRCT_p53bp1_rpt1', NULL, NULL, NULL, 2),
(10264, NULL, 'cd00033', NULL, NULL, 'CCP', NULL, 'CCP', NULL, NULL, 6503, 2),
(10265, NULL, 'cd03695', NULL, NULL, 'CysN_NodQ_II', NULL, 'CysN_NodQ_II', NULL, NULL, 34674, 2),
(10266, NULL, 'cd15308', NULL, NULL, '7tmA_D4_dopamine_R', NULL, '7tmA_D4_dopamine_R', NULL, NULL, NULL, 2),
(10267, NULL, 'cd16731', NULL, NULL, 'RING-HC_MKRN2', NULL, 'RING-HC_MKRN2', NULL, NULL, NULL, 2),
(10268, NULL, 'cd04242', NULL, NULL, 'AAK_G5K_ProB', NULL, 'AAK_G5K_ProB', NULL, NULL, 30645, 2),
(10269, NULL, 'cd12073', NULL, NULL, 'SH3_HS1', NULL, 'SH3_HS1', NULL, NULL, NULL, 2),
(10270, NULL, 'cd17017', NULL, NULL, 'ING_Yng1p', NULL, 'ING_Yng1p', NULL, NULL, NULL, 2);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(10271, NULL, 'cd19988', NULL, NULL, 'PBP1_ABC_HAAT-like', NULL, 'PBP1_ABC_HAAT-like', NULL, NULL, NULL, 2),
(10272, NULL, 'cd01984', NULL, NULL, 'AANH_like', NULL, 'AANH_like', NULL, NULL, NULL, 2),
(10273, NULL, 'cd03764', NULL, NULL, 'proteasome_beta_archeal', NULL, 'proteasome_beta_archeal', NULL, NULL, 11582, 2),
(10274, NULL, 'cd20215', NULL, NULL, 'PFM_LSL-like', NULL, 'PFM_LSL-like', NULL, NULL, NULL, 2),
(10275, NULL, 'cd04261', NULL, NULL, 'AAK_AKii-LysC-BS', NULL, 'AAK_AKii-LysC-BS', NULL, NULL, 30678, 2),
(10276, NULL, 'cd12748', NULL, NULL, 'RRM4_RBM12B', NULL, 'RRM4_RBM12B', NULL, NULL, NULL, 2),
(10277, NULL, 'cd13755', NULL, NULL, 'TGF_beta_maverick', NULL, 'TGF_beta_maverick', NULL, NULL, NULL, 2),
(10278, NULL, 'cd06198', NULL, NULL, 'FNR_like_3', NULL, 'FNR_like_3', NULL, NULL, NULL, 2),
(10279, NULL, 'cd15491', NULL, NULL, 'selB_III', NULL, 'selB_III', NULL, NULL, NULL, 2),
(10280, NULL, 'cd07924', NULL, NULL, 'PCA_45_Doxase_A', NULL, 'PCA_45_Doxase_A', NULL, NULL, 14068, 2),
(10281, NULL, 'cd15179', NULL, NULL, '7tmA_CXCR4', NULL, '7tmA_CXCR4', NULL, NULL, NULL, 2),
(10282, NULL, 'cd03524', NULL, NULL, 'RPA2_OBF_family', NULL, 'RPA2_OBF_family', NULL, NULL, NULL, 2),
(10283, NULL, 'cd18607', NULL, NULL, 'GH130', NULL, 'GH130', NULL, NULL, NULL, 2),
(10284, NULL, 'cd08222', NULL, NULL, 'STKc_Nek11', NULL, 'STKc_Nek11', NULL, NULL, NULL, 2),
(10285, NULL, 'cd10533', NULL, NULL, 'SET_EHMT2', NULL, 'SET_EHMT2', NULL, NULL, NULL, 2),
(10286, NULL, 'cd18182', NULL, NULL, 'ATP-synt_Fo_c_ATP5G3', NULL, 'ATP-synt_Fo_c_ATP5G3', NULL, NULL, NULL, 2),
(10287, NULL, 'cd03756', NULL, NULL, 'proteasome_alpha_archeal', NULL, 'proteasome_alpha_archeal', NULL, NULL, 11592, 2),
(10288, NULL, 'cd03778', NULL, NULL, 'MATH_TRAF2', NULL, 'MATH_TRAF2', NULL, NULL, 27558, 2),
(10289, NULL, 'cd16477', NULL, NULL, 'RING-H2_RNF214', NULL, 'RING-H2_RNF214', NULL, NULL, NULL, 2),
(10290, NULL, 'cd14969', NULL, NULL, '7tmA_Opsins_type2_animals', NULL, '7tmA_Opsins_type2_animals', NULL, NULL, NULL, 2),
(10291, NULL, 'cd07872', NULL, NULL, 'STKc_PCTAIRE2', NULL, 'STKc_PCTAIRE2', NULL, NULL, NULL, 2),
(10292, NULL, 'cd18094', NULL, NULL, 'SpoU-like_TrmL', NULL, 'SpoU-like_TrmL', NULL, NULL, 17296, 2),
(10293, NULL, 'cd06569', NULL, NULL, 'GH20_Sm-chitobiase-like', NULL, 'GH20_Sm-chitobiase-like', NULL, NULL, NULL, 2),
(10294, NULL, 'cd16613', NULL, NULL, 'RING-HC_UHRF', NULL, 'RING-HC_UHRF', NULL, NULL, NULL, 2),
(10295, NULL, 'cd09278', NULL, NULL, 'RNase_HI_prokaryote_like', NULL, 'RNase_HI_prokaryote_like', NULL, NULL, 17478, 2),
(10296, NULL, 'cd06657', NULL, NULL, 'STKc_PAK4', NULL, 'STKc_PAK4', NULL, NULL, NULL, 2),
(10297, NULL, 'cd01365', NULL, NULL, 'KISc_KIF1A_KIF1B', NULL, 'KISc_KIF1A_KIF1B', NULL, NULL, NULL, 2),
(10298, NULL, 'cd06316', NULL, NULL, 'PBP1_ABC_sugar_binding-like', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, NULL, 2),
(10299, NULL, 'cd19100', NULL, NULL, 'AKR_unchar', NULL, 'AKR_unchar', NULL, NULL, NULL, 2),
(10300, NULL, 'cd09632', NULL, NULL, 'PliI_like', NULL, 'PliI_like', NULL, NULL, 22856, 2),
(10301, NULL, 'cd08418', NULL, NULL, 'PBP2_TdcA', NULL, 'PBP2_TdcA', NULL, NULL, NULL, 2),
(10302, NULL, 'cd00238', NULL, NULL, 'ERp29c', NULL, 'ERp29c', NULL, NULL, 10931, 2),
(10303, NULL, 'cd09606', NULL, NULL, 'M3B_PepF', NULL, 'M3B_PepF', NULL, NULL, NULL, 2),
(10304, NULL, 'cd14378', NULL, NULL, 'UBA1_Rhp23p_like', NULL, 'UBA1_Rhp23p_like', NULL, NULL, NULL, 2),
(10305, NULL, 'cd13960', NULL, NULL, 'PT_UbiA_HPT1', NULL, 'PT_UbiA_HPT1', NULL, NULL, 35582, 2),
(10306, NULL, 'cd16185', NULL, NULL, 'EFh_PEF_ALG-2_like', NULL, 'EFh_PEF_ALG-2_like', NULL, NULL, NULL, 2),
(10307, NULL, 'cd00672', NULL, NULL, 'CysRS_core', NULL, 'CysRS_core', NULL, NULL, 18055, 2),
(10308, NULL, 'cd11379', NULL, NULL, 'DUF4425', NULL, 'DUF4425', NULL, NULL, 25605, 2),
(10309, NULL, 'cd07264', NULL, NULL, 'VOC_like', NULL, 'VOC_like', NULL, NULL, NULL, 2),
(10310, NULL, 'cd16710', NULL, NULL, 'RING-HC_Cbl-c', NULL, 'RING-HC_Cbl-c', NULL, NULL, NULL, 2),
(10311, NULL, 'cd18285', NULL, NULL, 'BTB1_POZ_BTBD8', NULL, 'BTB1_POZ_BTBD8', NULL, NULL, NULL, 2);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(10312, NULL, 'cd07743', NULL, NULL, 'metallo-hydrolase-like_MBL-fold', NULL, 'metallo-hydrolase-like_MBL-fold', NULL, NULL, NULL, 2),
(10313, NULL, 'cd10395', NULL, NULL, 'SH2_RIN3', NULL, 'SH2_RIN3', NULL, NULL, 29446, 2),
(10314, NULL, 'cd11933', NULL, NULL, 'SH3_Nebulin_C', NULL, 'SH3_Nebulin_C', NULL, NULL, 33879, 2),
(10315, NULL, 'cd03448', NULL, NULL, 'HDE_HSD', NULL, 'HDE_HSD', NULL, NULL, NULL, 2),
(10316, NULL, 'cd15585', NULL, NULL, 'PHD_ING3', NULL, 'PHD_ING3', NULL, NULL, 30574, 2),
(10317, NULL, 'cd17312', NULL, NULL, 'MFS_OPA_SLC37', NULL, 'MFS_OPA_SLC37', NULL, NULL, NULL, 2),
(10318, NULL, 'cd03258', NULL, NULL, 'ABC_MetN_methionine_transporter', NULL, 'ABC_MetN_methionine_transporter', NULL, NULL, 29979, 2),
(10319, NULL, 'cd11021', NULL, NULL, 'CuRO_2_ceruloplasmin', NULL, 'CuRO_2_ceruloplasmin', NULL, NULL, NULL, 2),
(10320, NULL, 'cd11307', NULL, NULL, 'M35_Asp_f2_like', NULL, 'M35_Asp_f2_like', NULL, NULL, 26823, 2),
(10321, NULL, 'cd15177', NULL, NULL, '7tmA_CCR10', NULL, '7tmA_CCR10', NULL, NULL, NULL, 2),
(10322, NULL, 'cd05347', NULL, NULL, 'Ga5DH-like_SDR_c', NULL, 'Ga5DH-like_SDR_c', NULL, NULL, NULL, 2),
(10323, NULL, 'cd13852', NULL, NULL, 'CuRO_1_McoP_like', NULL, 'CuRO_1_McoP_like', NULL, NULL, NULL, 2),
(10324, NULL, 'cd18928', NULL, NULL, 'bHLHzip_TFE3', NULL, 'bHLHzip_TFE3', NULL, NULL, NULL, 2),
(10325, NULL, 'cd00100', NULL, NULL, 'IL1', NULL, 'IL1', NULL, NULL, NULL, 2),
(10326, NULL, 'cd07987', NULL, NULL, 'LPLAT_MGAT-like', NULL, 'LPLAT_MGAT-like', NULL, NULL, NULL, 2),
(10327, NULL, 'cd00407', NULL, NULL, 'Urease_beta', NULL, 'Urease_beta', NULL, NULL, 2157, 2),
(10328, NULL, 'cd07257', NULL, NULL, 'THT_oxygenase_C', NULL, 'THT_oxygenase_C', NULL, NULL, NULL, 2),
(10329, NULL, 'cd07133', NULL, NULL, 'ALDH_CALDH_CalB', NULL, 'ALDH_CALDH_CalB', NULL, NULL, NULL, 2),
(10330, NULL, 'cd04608', NULL, NULL, 'CBS_pair_CBS', NULL, 'CBS_pair_CBS', NULL, NULL, 36899, 2),
(10331, NULL, 'cd07639', NULL, NULL, 'BAR_ACAP1', NULL, 'BAR_ACAP1', NULL, NULL, NULL, 2),
(10332, NULL, 'cd10388', NULL, NULL, 'SH2_SOCS7', NULL, 'SH2_SOCS7', NULL, NULL, 31627, 2),
(10333, NULL, 'cd18468', NULL, NULL, 'BACK_KLHL29_KBTBD9', NULL, 'BACK_KLHL29_KBTBD9', NULL, NULL, NULL, 2),
(10334, NULL, 'cd19690', NULL, NULL, 'bHLHzip_spESC1_like', NULL, 'bHLHzip_spESC1_like', NULL, NULL, NULL, 2),
(10335, NULL, 'cd14456', NULL, NULL, 'Menin', NULL, 'Menin', NULL, NULL, 1459, 2),
(10336, NULL, 'cd15647', NULL, NULL, 'PHD_CBP', NULL, 'PHD_CBP', NULL, NULL, NULL, 2),
(10337, NULL, 'cd17090', NULL, NULL, 'FERM_F1_TLN', NULL, 'FERM_F1_TLN', NULL, NULL, NULL, 2),
(10338, NULL, 'cd15801', NULL, NULL, 'PMEI-like_1', NULL, 'PMEI-like_1', NULL, NULL, NULL, 2),
(10339, NULL, 'cd09647', NULL, NULL, 'Csm2_III-A', NULL, 'Csm2_III-A', NULL, NULL, 10957, 2),
(10340, NULL, 'cd18331', NULL, NULL, 'BTB_POZ_ZBTB27_BCL6', NULL, 'BTB_POZ_ZBTB27_BCL6', NULL, NULL, NULL, 2),
(10341, NULL, 'cd06008', NULL, NULL, 'NF-X1-zinc-finger', NULL, 'NF-X1-zinc-finger', NULL, NULL, NULL, 2),
(10342, NULL, 'cd05684', NULL, NULL, 'S1_DHX8_helicase', NULL, 'S1_DHX8_helicase', NULL, NULL, NULL, 2),
(10343, NULL, 'cd18198', NULL, NULL, 'BTB_POZ_ZBTB7', NULL, 'BTB_POZ_ZBTB7', NULL, NULL, NULL, 2),
(10344, NULL, 'cd19708', NULL, NULL, 'bHLH_TS_dHLH3B_like', NULL, 'bHLH_TS_dHLH3B_like', NULL, NULL, NULL, 2),
(10345, NULL, 'cd00349', NULL, NULL, 'Ribosomal_L11', NULL, 'Ribosomal_L11', NULL, NULL, 337, 2),
(10346, NULL, 'cd05816', NULL, NULL, 'CBM20_DPE2_repeat2', NULL, 'CBM20_DPE2_repeat2', NULL, NULL, 8148, 2),
(10347, NULL, 'cd16772', NULL, NULL, 'RING-HC_UNKL', NULL, 'RING-HC_UNKL', NULL, NULL, NULL, 2),
(10348, NULL, 'cd02248', NULL, NULL, 'Peptidase_C1A', NULL, 'Peptidase_C1A', NULL, NULL, 27426, 2),
(10349, NULL, 'cd18735', NULL, NULL, 'PIN_HiVapC1-like', NULL, 'PIN_HiVapC1-like', NULL, NULL, NULL, 2),
(10350, NULL, 'cd19435', NULL, NULL, 'lipocalin_Bacteroides', NULL, 'lipocalin_Bacteroides', NULL, NULL, NULL, 2),
(10351, NULL, 'cd01538', NULL, NULL, 'PBP1_ABC_xylose_binding-like', NULL, 'PBP1_ABC_xylose_binding-like', NULL, NULL, NULL, 2);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(10352, NULL, 'cd15948', NULL, NULL, '7tmA_OR52K-like', NULL, '7tmA_OR52K-like', NULL, NULL, NULL, 2),
(10353, NULL, 'cd07386', NULL, NULL, 'MPP_DNA_pol_II_small_archeal_C', NULL, 'MPP_DNA_pol_II_small_archeal_C', NULL, NULL, NULL, 2),
(10354, NULL, 'cd15273', NULL, NULL, '7tmB1_NPR_B7_insect-like', NULL, '7tmB1_NPR_B7_insect-like', NULL, NULL, NULL, 2),
(10355, NULL, 'cd10391', NULL, NULL, 'SH2_SHE', NULL, 'SH2_SHE', NULL, NULL, 9084, 2),
(10356, NULL, 'cd12386', NULL, NULL, 'RRM2_hnRNPM_like', NULL, 'RRM2_hnRNPM_like', NULL, NULL, NULL, 2),
(10357, NULL, 'cd19709', NULL, NULL, 'bHLH_TS_TCF23_OUT', NULL, 'bHLH_TS_TCF23_OUT', NULL, NULL, NULL, 2),
(10358, NULL, 'cd12403', NULL, NULL, 'RRM1_NCL', NULL, 'RRM1_NCL', NULL, NULL, 30981, 2),
(10359, NULL, 'cd15503', NULL, NULL, 'PHD2_MTF2_PHF19_like', NULL, 'PHD2_MTF2_PHF19_like', NULL, NULL, NULL, 2),
(10360, NULL, 'cd06445', NULL, NULL, 'ATase', NULL, 'ATase', NULL, NULL, 9653, 2),
(10361, NULL, 'cd08980', NULL, NULL, 'GH43_LbAraf43-like', NULL, 'GH43_LbAraf43-like', NULL, NULL, NULL, 2),
(10362, NULL, 'cd14589', NULL, NULL, 'PTP-MTMR13', NULL, 'PTP-MTMR13', NULL, NULL, NULL, 2),
(10363, NULL, 'cd08888', NULL, NULL, 'SRPBCC_PITPNA-B_like', NULL, 'SRPBCC_PITPNA-B_like', NULL, NULL, NULL, 2),
(10364, NULL, 'cd03007', NULL, NULL, 'PDI_a_ERp29_N', NULL, 'PDI_a_ERp29_N', NULL, NULL, 13336, 2),
(10365, NULL, 'cd12044', NULL, NULL, 'SH3_SKAP1', NULL, 'SH3_SKAP1', NULL, NULL, 31705, 2),
(10366, NULL, 'cd16022', NULL, NULL, 'sulfatase_like', NULL, 'sulfatase_like', NULL, NULL, NULL, 2),
(10367, NULL, 'cd14162', NULL, NULL, 'STKc_TSSK4-like', NULL, 'STKc_TSSK4-like', NULL, NULL, NULL, 2),
(10368, NULL, 'cd18585', NULL, NULL, 'ABC_6TM_CydC', NULL, 'ABC_6TM_CydC', NULL, NULL, NULL, 2),
(10369, NULL, 'cd14123', NULL, NULL, 'STKc_VRK2', NULL, 'STKc_VRK2', NULL, NULL, NULL, 2),
(10370, NULL, 'cd09379', NULL, NULL, 'LIM2_AWH', NULL, 'LIM2_AWH', NULL, NULL, NULL, 2),
(10371, NULL, 'cd11793', NULL, NULL, 'SH3_ephexin1_like', NULL, 'SH3_ephexin1_like', NULL, NULL, NULL, 2),
(10372, NULL, 'cd08531', NULL, NULL, 'SAM_PNT-ERG_FLI-1', NULL, 'SAM_PNT-ERG_FLI-1', NULL, NULL, NULL, 2),
(10373, NULL, 'cd00729', NULL, NULL, 'rubredoxin_SM', NULL, 'rubredoxin_SM', NULL, NULL, NULL, 2),
(10374, NULL, 'cd08585', NULL, NULL, 'GDPD_like_3', NULL, 'GDPD_like_3', NULL, NULL, NULL, 2),
(10375, NULL, 'cd17060', NULL, NULL, 'Ubl_RB1CC1', NULL, 'Ubl_RB1CC1', NULL, NULL, NULL, 2),
(10376, NULL, 'cd12142', NULL, NULL, 'SH3_D21-like', NULL, 'SH3_D21-like', NULL, NULL, 15277, 2),
(10377, NULL, 'cd14981', NULL, NULL, '7tmA_Prostanoid_R', NULL, '7tmA_Prostanoid_R', NULL, NULL, NULL, 2),
(10378, NULL, 'cd19004', NULL, NULL, 'LGIC_ECD_GABAAR_pi', NULL, 'LGIC_ECD_GABAAR_pi', NULL, NULL, NULL, 2),
(10379, NULL, 'cd09688', NULL, NULL, 'Cas5_I-C', NULL, 'Cas5_I-C', NULL, NULL, NULL, 2),
(10380, NULL, 'cd00029', NULL, NULL, 'C1', NULL, 'C1', NULL, NULL, 5392, 2),
(10381, NULL, 'cd18339', NULL, NULL, 'BTB_POZ_KLHL3', NULL, 'BTB_POZ_KLHL3', NULL, NULL, NULL, 2),
(10382, NULL, 'cd15265', NULL, NULL, '7tmB1_PTHR', NULL, '7tmB1_PTHR', NULL, NULL, NULL, 2),
(10383, NULL, 'cd18688', NULL, NULL, 'PIN_VapC-like', NULL, 'PIN_VapC-like', NULL, NULL, NULL, 2),
(10384, NULL, 'cd08468', NULL, NULL, 'PBP2_Pa0477', NULL, 'PBP2_Pa0477', NULL, NULL, NULL, 2),
(10385, NULL, 'cd13994', NULL, NULL, 'STKc_HAL4_like', NULL, 'STKc_HAL4_like', NULL, NULL, NULL, 2),
(10386, NULL, 'cd18254', NULL, NULL, 'BTB_POZ_KLHL25', NULL, 'BTB_POZ_KLHL25', NULL, NULL, NULL, 2),
(10387, NULL, 'cd00807', NULL, NULL, 'GlnRS_core', NULL, 'GlnRS_core', NULL, NULL, NULL, 2),
(10388, NULL, 'cd15707', NULL, NULL, 'ePHD_RNO', NULL, 'ePHD_RNO', NULL, NULL, NULL, 2),
(10389, NULL, 'cd01755', NULL, NULL, 'PLAT_lipase', NULL, 'PLAT_lipase', NULL, NULL, NULL, 2),
(10390, NULL, 'cd19685', NULL, NULL, 'bHLH-O_HERP_HES', NULL, 'bHLH-O_HERP_HES', NULL, NULL, NULL, 2),
(10391, NULL, 'cd16887', NULL, NULL, 'YEATS', NULL, 'YEATS', NULL, NULL, NULL, 2),
(10392, NULL, 'cd18474', NULL, NULL, 'BACK_KLHL35', NULL, 'BACK_KLHL35', NULL, NULL, NULL, 2),
(10393, NULL, 'cd06371', NULL, NULL, 'PBP1_sensory_GC_DEF-like', NULL, 'PBP1_sensory_GC_DEF-like', NULL, NULL, NULL, 2);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(10394, NULL, 'cd15353', NULL, NULL, '7tmA_MC4R', NULL, '7tmA_MC4R', NULL, NULL, NULL, 2),
(10395, NULL, 'cd14075', NULL, NULL, 'STKc_NIM1', NULL, 'STKc_NIM1', NULL, NULL, NULL, 2),
(10396, NULL, 'cd10939', NULL, NULL, 'CE4_ArnD', NULL, 'CE4_ArnD', NULL, NULL, NULL, 2),
(10397, NULL, 'cd03676', NULL, NULL, 'Nudix_hydrolase_3', NULL, 'Nudix_hydrolase_3', NULL, NULL, NULL, 2),
(10398, NULL, 'cd12381', NULL, NULL, 'RRM4_I_PABPs', NULL, 'RRM4_I_PABPs', NULL, NULL, NULL, 2),
(10399, NULL, 'cd11645', NULL, NULL, 'Precorrin_2_C20_MT', NULL, 'Precorrin_2_C20_MT', NULL, NULL, 13310, 2),
(10400, NULL, 'cd03449', NULL, NULL, 'R_hydratase', NULL, 'R_hydratase', NULL, NULL, NULL, 2),
(10401, NULL, 'cd02982', NULL, NULL, 'PDI_b''_family', NULL, 'PDI_b''_family', NULL, NULL, NULL, 2),
(10402, NULL, 'cd15488', NULL, NULL, 'Tm-1-like', NULL, 'Tm-1-like', NULL, NULL, 35105, 2),
(10403, NULL, 'cd16250', NULL, NULL, 'EFh_DTNB', NULL, 'EFh_DTNB', NULL, NULL, NULL, 2),
(10404, NULL, 'cd15927', NULL, NULL, '7tmA_Bombesin_R-like', NULL, '7tmA_Bombesin_R-like', NULL, NULL, NULL, 2),
(10405, NULL, 'cd00800', NULL, NULL, 'INT_Lambda_C', NULL, 'INT_Lambda_C', NULL, NULL, NULL, 2),
(10406, NULL, 'cd04165', NULL, NULL, 'GTPBP1_like', NULL, 'GTPBP1_like', NULL, NULL, 32981, 2),
(10407, NULL, 'cd17550', NULL, NULL, 'REC_NtrX-like', NULL, 'REC_NtrX-like', NULL, NULL, NULL, 2),
(10408, NULL, 'cd09512', NULL, NULL, 'SAM_Neurabin-like', NULL, 'SAM_Neurabin-like', NULL, NULL, NULL, 2),
(10409, NULL, 'cd02862', NULL, NULL, 'NorE_like', NULL, 'NorE_like', NULL, NULL, NULL, 2),
(10410, NULL, 'cd08526', NULL, NULL, 'Reelin_subrepeat_2', NULL, 'Reelin_subrepeat_2', NULL, NULL, NULL, 2),
(10411, NULL, 'cd09851', NULL, NULL, 'HTLV-1-like_HR1-HR2', NULL, 'HTLV-1-like_HR1-HR2', NULL, NULL, NULL, 2),
(10412, NULL, 'cd18284', NULL, NULL, 'BTB2_POZ_BTBD7', NULL, 'BTB2_POZ_BTBD7', NULL, NULL, NULL, 2),
(10413, NULL, 'cd15746', NULL, NULL, 'FYVE_RP3A_like', NULL, 'FYVE_RP3A_like', NULL, NULL, NULL, 2),
(10414, NULL, 'cd04706', NULL, NULL, 'PLA2_plant', NULL, 'PLA2_plant', NULL, NULL, NULL, 2),
(10415, NULL, 'cd05934', NULL, NULL, 'FACL_DitJ_like', NULL, 'FACL_DitJ_like', NULL, NULL, NULL, 2),
(10416, NULL, 'cd18471', NULL, NULL, 'BACK_KLHL32_BKLHD5', NULL, 'BACK_KLHL32_BKLHD5', NULL, NULL, NULL, 2),
(10417, NULL, 'cd13516', NULL, NULL, 'HHD_CCM2', NULL, 'HHD_CCM2', NULL, NULL, 21739, 2),
(10418, NULL, 'cd08221', NULL, NULL, 'STKc_Nek9', NULL, 'STKc_Nek9', NULL, NULL, 35197, 2),
(10419, NULL, 'cd01159', NULL, NULL, 'NcnH', NULL, 'NcnH', NULL, NULL, NULL, 2),
(10420, NULL, 'cd07079', NULL, NULL, 'ALDH_F18-19_ProA-GPR', NULL, 'ALDH_F18-19_ProA-GPR', NULL, NULL, 241, 2),
(10421, NULL, 'cd02425', NULL, NULL, 'Peptidase_C39F', NULL, 'Peptidase_C39F', NULL, NULL, 30507, 2),
(10422, NULL, 'cd03685', NULL, NULL, 'ClC_6_like', NULL, 'ClC_6_like', NULL, NULL, NULL, 2),
(10423, NULL, 'cd07097', NULL, NULL, 'ALDH_KGSADH-YcbD', NULL, 'ALDH_KGSADH-YcbD', NULL, NULL, NULL, 2),
(10424, NULL, 'cd17008', NULL, NULL, 'VHS_GGA3', NULL, 'VHS_GGA3', NULL, NULL, NULL, 2),
(10425, NULL, 'cd00430', NULL, NULL, 'PLPDE_III_AR', NULL, 'PLPDE_III_AR', NULL, NULL, NULL, 2),
(10426, NULL, 'cd10398', NULL, NULL, 'SH2_Tec_Txk', NULL, 'SH2_Tec_Txk', NULL, NULL, 29764, 2),
(10427, NULL, 'cd17667', NULL, NULL, 'R-PTPc-G-1', NULL, 'R-PTPc-G-1', NULL, NULL, NULL, 2),
(10428, NULL, 'cd13646', NULL, NULL, 'PBP2_EcHMBS_like', NULL, 'PBP2_EcHMBS_like', NULL, NULL, NULL, 2),
(10429, NULL, 'cd02785', NULL, NULL, 'MopB_CT_4', NULL, 'MopB_CT_4', NULL, NULL, 30840, 2),
(10430, NULL, 'cd14414', NULL, NULL, 'UBA_FAF2', NULL, 'UBA_FAF2', NULL, NULL, NULL, 2),
(10431, NULL, 'cd17435', NULL, NULL, 'MFS_GLUT12_Class3', NULL, 'MFS_GLUT12_Class3', NULL, NULL, NULL, 2),
(10432, NULL, 'cd09728', NULL, NULL, 'Csx1_III-U', NULL, 'Csx1_III-U', NULL, NULL, NULL, 2),
(10433, NULL, 'cd14384', NULL, NULL, 'UBA1_UBP13', NULL, 'UBA1_UBP13', NULL, NULL, NULL, 2),
(10434, NULL, 'cd16852', NULL, NULL, 'STAT2_CCD', NULL, 'STAT2_CCD', NULL, NULL, NULL, 2),
(10435, NULL, 'cd12958', NULL, NULL, 'SKA1_N', NULL, 'SKA1_N', NULL, NULL, NULL, 2);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(10436, NULL, 'cd01099', NULL, NULL, 'PAN_AP_HGF', NULL, 'PAN_AP_HGF', NULL, NULL, NULL, 2),
(10437, NULL, 'cd19183', NULL, NULL, 'SET_SpSET3-like', NULL, 'SET_SpSET3-like', NULL, NULL, 36273, 2),
(10438, NULL, 'cd10457', NULL, NULL, 'GIY-YIG_AtGrxS16', NULL, 'GIY-YIG_AtGrxS16', NULL, NULL, NULL, 2),
(10439, NULL, 'cd14218', NULL, NULL, 'STKc_SRPK3', NULL, 'STKc_SRPK3', NULL, NULL, NULL, 2),
(10440, NULL, 'cd00116', NULL, NULL, 'LRR_RI', NULL, 'LRR_RI', NULL, NULL, NULL, 2),
(10441, NULL, 'cd11015', NULL, NULL, 'CuRO_2_FVIII_like', NULL, 'CuRO_2_FVIII_like', NULL, NULL, NULL, 2),
(10442, NULL, 'cd17934', NULL, NULL, 'DEXXQc_Upf1-like', NULL, 'DEXXQc_Upf1-like', NULL, NULL, NULL, 2),
(10443, NULL, 'cd15914', NULL, NULL, '7tmA_OR6N-like', NULL, '7tmA_OR6N-like', NULL, NULL, NULL, 2),
(10444, NULL, 'cd06210', NULL, NULL, 'MMO_FAD_NAD_binding', NULL, 'MMO_FAD_NAD_binding', NULL, NULL, NULL, 2),
(10445, NULL, 'cd08286', NULL, NULL, 'FDH_like_ADH2', NULL, 'FDH_like_ADH2', NULL, NULL, NULL, 2),
(10446, NULL, 'cd17787', NULL, NULL, 'CBS_pair_ACT', NULL, 'CBS_pair_ACT', NULL, NULL, NULL, 2),
(10447, NULL, 'cd02772', NULL, NULL, 'MopB_NDH-1_NuoG2', NULL, 'MopB_NDH-1_NuoG2', NULL, NULL, NULL, 2),
(10448, NULL, 'cd13983', NULL, NULL, 'STKc_WNK', NULL, 'STKc_WNK', NULL, NULL, NULL, 2),
(10449, NULL, 'cd00038', NULL, NULL, 'CAP_ED', NULL, 'CAP_ED', NULL, NULL, 5904, 2),
(10450, NULL, 'cd06098', NULL, NULL, 'phytepsin', NULL, 'phytepsin', NULL, NULL, 27764, 2),
(10451, NULL, 'cd01513', NULL, NULL, 'Translation_factor_III', NULL, 'Translation_factor_III', NULL, NULL, NULL, 2),
(10452, NULL, 'cd00180', NULL, NULL, 'PKc', NULL, 'PKc', NULL, NULL, NULL, 2),
(10453, NULL, 'cd17982', NULL, NULL, 'DEXHc_DHX37', NULL, 'DEXHc_DHX37', NULL, NULL, NULL, 2),
(10454, NULL, 'cd16175', NULL, NULL, 'EFh_MICU3', NULL, 'EFh_MICU3', NULL, NULL, NULL, 2),
(10455, NULL, 'cd00248', NULL, NULL, 'Mth938-like', NULL, 'Mth938-like', NULL, NULL, NULL, 2),
(10456, NULL, 'cd06460', NULL, NULL, 'M32_Taq', NULL, 'M32_Taq', NULL, NULL, NULL, 2),
(10457, NULL, 'cd14606', NULL, NULL, 'PTPc-N6', NULL, 'PTPc-N6', NULL, NULL, NULL, 2),
(10458, NULL, 'cd07484', NULL, NULL, 'Peptidases_S8_Thermitase_like', NULL, 'Peptidases_S8_Thermitase_like', NULL, NULL, 9745, 2),
(10459, NULL, 'cd10364', NULL, NULL, 'SH2_Src_Lyn', NULL, 'SH2_Src_Lyn', NULL, NULL, 33382, 2),
(10460, NULL, 'cd02668', NULL, NULL, 'Peptidase_C19L', NULL, 'Peptidase_C19L', NULL, NULL, 27796, 2),
(10461, NULL, 'cd02786', NULL, NULL, 'MopB_CT_3', NULL, 'MopB_CT_3', NULL, NULL, 32609, 2),
(10462, NULL, 'cd05036', NULL, NULL, 'PTKc_ALK_LTK', NULL, 'PTKc_ALK_LTK', NULL, NULL, NULL, 2),
(10463, NULL, 'cd20229', NULL, NULL, 'PFM_tachylectin-like', NULL, 'PFM_tachylectin-like', NULL, NULL, NULL, 2),
(10464, NULL, 'cd01574', NULL, NULL, 'PBP1_LacI', NULL, 'PBP1_LacI', NULL, NULL, NULL, 2),
(10465, NULL, 'cd15987', NULL, NULL, '7tmB1_PACAP-R1', NULL, '7tmB1_PACAP-R1', NULL, NULL, NULL, 2),
(10466, NULL, 'cd04017', NULL, NULL, 'C2D_Ferlin', NULL, 'C2D_Ferlin', NULL, NULL, 32576, 2),
(10467, NULL, 'cd18469', NULL, NULL, 'BACK_KLHL30', NULL, 'BACK_KLHL30', NULL, NULL, NULL, 2),
(10468, NULL, 'cd01736', NULL, NULL, 'LSm14_N', NULL, 'LSm14_N', NULL, NULL, 23373, 2),
(10469, NULL, 'cd14124', NULL, NULL, 'PK_VRK3', NULL, 'PK_VRK3', NULL, NULL, NULL, 2),
(10470, NULL, 'cd05017', NULL, NULL, 'SIS_PGI_PMI_1', NULL, 'SIS_PGI_PMI_1', NULL, NULL, 28863, 2),
(10471, NULL, 'cd13524', NULL, NULL, 'PBP2_Thiaminase_I', NULL, 'PBP2_Thiaminase_I', NULL, NULL, NULL, 2),
(10472, NULL, 'cd16086', NULL, NULL, 'IgV_CD80', NULL, 'IgV_CD80', NULL, NULL, 35670, 2),
(10473, NULL, 'cd05783', NULL, NULL, 'DNA_polB_B1_exo', NULL, 'DNA_polB_B1_exo', NULL, NULL, NULL, 2),
(10474, NULL, 'cd09693', NULL, NULL, 'Cas5_I', NULL, 'Cas5_I', NULL, NULL, NULL, 2),
(10475, NULL, 'cd03696', NULL, NULL, 'SelB_II', NULL, 'SelB_II', NULL, NULL, NULL, 2),
(10476, NULL, 'cd05876', NULL, NULL, 'Ig3_L1-CAM', NULL, 'Ig3_L1-CAM', NULL, NULL, NULL, 2),
(10477, NULL, 'cd00480', NULL, NULL, 'malate_synt', NULL, 'malate_synt', NULL, NULL, NULL, 2);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(10478, NULL, 'cd12647', NULL, NULL, 'RRM_UHM_SPF45', NULL, 'RRM_UHM_SPF45', NULL, NULL, 30569, 2),
(10479, NULL, 'cd18706', NULL, NULL, 'PIN_STKc_like', NULL, 'PIN_STKc_like', NULL, NULL, NULL, 2),
(10480, NULL, 'cd08420', NULL, NULL, 'PBP2_CysL_like', NULL, 'PBP2_CysL_like', NULL, NULL, NULL, 2),
(10481, NULL, 'cd15868', NULL, NULL, 'R-SNARE_VAMP8', NULL, 'R-SNARE_VAMP8', NULL, NULL, NULL, 2),
(10482, NULL, 'cd01226', NULL, NULL, 'PH_RalBD_exo84', NULL, 'PH_RalBD_exo84', NULL, NULL, NULL, 2),
(10483, NULL, 'cd04769', NULL, NULL, 'HTH_MerR2', NULL, 'HTH_MerR2', NULL, NULL, NULL, 2),
(10484, NULL, 'cd15995', NULL, NULL, '7tmB2_GPR56', NULL, '7tmB2_GPR56', NULL, NULL, NULL, 2),
(10485, NULL, 'cd07519', NULL, NULL, 'HAD_PTase', NULL, 'HAD_PTase', NULL, NULL, NULL, 2),
(10486, NULL, 'cd15381', NULL, NULL, '7tmA_BK-2', NULL, '7tmA_BK-2', NULL, NULL, NULL, 2),
(10487, NULL, 'cd05094', NULL, NULL, 'PTKc_TrkC', NULL, 'PTKc_TrkC', NULL, NULL, NULL, 2),
(10488, NULL, 'cd07594', NULL, NULL, 'BAR_Endophilin_B', NULL, 'BAR_Endophilin_B', NULL, NULL, NULL, 2),
(10489, NULL, 'cd09015', NULL, NULL, 'Ureohydrolase', NULL, 'Ureohydrolase', NULL, NULL, NULL, 2),
(10490, NULL, 'cd08482', NULL, NULL, 'PBP2_TrpI', NULL, 'PBP2_TrpI', NULL, NULL, 29946, 2),
(10491, NULL, 'cd03603', NULL, NULL, 'CLECT_VCBS', NULL, 'CLECT_VCBS', NULL, NULL, 29004, 2),
(10492, NULL, 'cd13138', NULL, NULL, 'MATE_yoeA_like', NULL, 'MATE_yoeA_like', NULL, NULL, NULL, 2),
(10493, NULL, 'cd00331', NULL, NULL, 'IGPS', NULL, 'IGPS', NULL, NULL, 9165, 2),
(10494, NULL, 'cd01128', NULL, NULL, 'rho_factor', NULL, 'rho_factor', NULL, NULL, 30844, 2),
(10495, NULL, 'cd04457', NULL, NULL, 'S1_S28E', NULL, 'S1_S28E', NULL, NULL, 4886, 2),
(10496, NULL, 'cd20244', NULL, NULL, 'Toddler', NULL, 'Toddler', NULL, NULL, NULL, 2),
(10497, NULL, 'cd08516', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_11', NULL, 'PBP2_NikA_DppA_OppA_like_11', NULL, NULL, NULL, 2),
(10498, NULL, 'cd02965', NULL, NULL, 'HyaE', NULL, 'HyaE', NULL, NULL, 11986, 2),
(10499, NULL, 'cd17355', NULL, NULL, 'MFS_YcxA_like', NULL, 'MFS_YcxA_like', NULL, NULL, NULL, 2),
(10500, NULL, 'cd16692', NULL, NULL, 'mRING-H2-C3H3C2_WDR59', NULL, 'mRING-H2-C3H3C2_WDR59', NULL, NULL, 31232, 2),
(10501, NULL, 'cd06135', NULL, NULL, 'Orn', NULL, 'Orn', NULL, NULL, 17386, 2),
(10502, NULL, 'cd07254', NULL, NULL, 'VOC_like', NULL, 'VOC_like', NULL, NULL, NULL, 2),
(10503, NULL, 'cd03051', NULL, NULL, 'GST_N_GTT2_like', NULL, 'GST_N_GTT2_like', NULL, NULL, 16453, 2),
(10504, NULL, 'cd06904', NULL, NULL, 'M14_MpaA-like', NULL, 'M14_MpaA-like', NULL, NULL, NULL, 2),
(10505, NULL, 'cd19471', NULL, NULL, 'FABP9', NULL, 'FABP9', NULL, NULL, NULL, 2),
(10506, NULL, 'cd14937', NULL, NULL, 'MYSc_Myo24A', NULL, 'MYSc_Myo24A', NULL, NULL, NULL, 2),
(10507, NULL, 'cd04584', NULL, NULL, 'CBS_pair_AcuB_like', NULL, 'CBS_pair_AcuB_like', NULL, NULL, NULL, 2),
(10508, NULL, 'cd09686', NULL, NULL, 'Csx1_III-U', NULL, 'Csx1_III-U', NULL, NULL, NULL, 2),
(10509, NULL, 'cd12504', NULL, NULL, 'RRM2_hnRNPH_like', NULL, 'RRM2_hnRNPH_like', NULL, NULL, NULL, 2),
(10510, NULL, 'cd01676', NULL, NULL, 'RNR_II_monomer', NULL, 'RNR_II_monomer', NULL, NULL, NULL, 2),
(10511, NULL, 'cd12775', NULL, NULL, 'RRM2_HuB', NULL, 'RRM2_HuB', NULL, NULL, 14600, 2),
(10512, NULL, 'cd13388', NULL, NULL, 'PH1_FGD1-4_like', NULL, 'PH1_FGD1-4_like', NULL, NULL, NULL, 2),
(10513, NULL, 'cd01522', NULL, NULL, 'RHOD_1', NULL, 'RHOD_1', NULL, NULL, NULL, 2),
(10514, NULL, 'cd10797', NULL, NULL, 'GH57N_APU_like_1', NULL, 'GH57N_APU_like_1', NULL, NULL, NULL, 2),
(10515, NULL, 'cd12370', NULL, NULL, 'RRM1_PUF60', NULL, 'RRM1_PUF60', NULL, NULL, 21193, 2),
(10516, NULL, 'cd00895', NULL, NULL, 'PI3Kc_C2_beta', NULL, 'PI3Kc_C2_beta', NULL, NULL, NULL, 2),
(10517, NULL, 'cd13844', NULL, NULL, 'CuRO_1_BOD_CotA_like', NULL, 'CuRO_1_BOD_CotA_like', NULL, NULL, NULL, 2),
(10518, NULL, 'cd14453', NULL, NULL, 'CuRO_2_FV_like', NULL, 'CuRO_2_FV_like', NULL, NULL, NULL, 2),
(10519, NULL, 'cd12173', NULL, NULL, 'PGDH_4', NULL, 'PGDH_4', NULL, NULL, NULL, 2),
(10520, NULL, 'cd19436', NULL, NULL, 'lipocalin_crustacyanin', NULL, 'lipocalin_crustacyanin', NULL, NULL, NULL, 2);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(10521, NULL, 'cd09571', NULL, NULL, 'SAM_tumor-p73', NULL, 'SAM_tumor-p73', NULL, NULL, 30501, 2),
(10522, NULL, 'cd19881', NULL, NULL, 'DSRM_STAU1_rpt2', NULL, 'DSRM_STAU1_rpt2', NULL, NULL, NULL, 2),
(10523, NULL, 'cd13552', NULL, NULL, 'PBP2_Fbp_like_6', NULL, 'PBP2_Fbp_like_6', NULL, NULL, NULL, 2),
(10524, NULL, 'cd08278', NULL, NULL, 'benzyl_alcohol_DH', NULL, 'benzyl_alcohol_DH', NULL, NULL, NULL, 2),
(10525, NULL, 'cd07407', NULL, NULL, 'MPP_YHR202W_N', NULL, 'MPP_YHR202W_N', NULL, NULL, 30783, 2),
(10526, NULL, 'cd06915', NULL, NULL, 'NTP_transferase_WcbM_like', NULL, 'NTP_transferase_WcbM_like', NULL, NULL, NULL, 2),
(10527, NULL, 'cd09547', NULL, NULL, 'SAM_EPH-A6', NULL, 'SAM_EPH-A6', NULL, NULL, 34604, 2),
(10528, NULL, 'cd15101', NULL, NULL, '7tmA_LPAR', NULL, '7tmA_LPAR', NULL, NULL, NULL, 2),
(10529, NULL, 'cd02050', NULL, NULL, 'serpinG1_C1-INH', NULL, 'serpinG1_C1-INH', NULL, NULL, NULL, 2),
(10530, NULL, 'cd05894', NULL, NULL, 'Ig_C5_MyBP-C', NULL, 'Ig_C5_MyBP-C', NULL, NULL, NULL, 2),
(10531, NULL, 'cd14632', NULL, NULL, 'R-PTPc-U-1', NULL, 'R-PTPc-U-1', NULL, NULL, NULL, 2),
(10532, NULL, 'cd06889', NULL, NULL, 'PX_NoxO1', NULL, 'PX_NoxO1', NULL, NULL, NULL, 2),
(10533, NULL, 'cd09002', NULL, NULL, 'GH43_XYL-like', NULL, 'GH43_XYL-like', NULL, NULL, NULL, 2),
(10534, NULL, 'cd14048', NULL, NULL, 'STKc_EIF2AK3_PERK', NULL, 'STKc_EIF2AK3_PERK', NULL, NULL, NULL, 2),
(10535, NULL, 'cd16345', NULL, NULL, 'LMWP_ArsC', NULL, 'LMWP_ArsC', NULL, NULL, NULL, 2),
(10536, NULL, 'cd08824', NULL, NULL, 'LOTUS', NULL, 'LOTUS', NULL, NULL, NULL, 2),
(10537, NULL, 'cd11883', NULL, NULL, 'SH3_Sdc25', NULL, 'SH3_Sdc25', NULL, NULL, NULL, 2),
(10538, NULL, 'cd01384', NULL, NULL, 'MYSc_Myo11', NULL, 'MYSc_Myo11', NULL, NULL, 30020, 2),
(10539, NULL, 'cd04880', NULL, NULL, 'ACT_AAAH-PDT-like', NULL, 'ACT_AAAH-PDT-like', NULL, NULL, NULL, 2),
(10540, NULL, 'cd02756', NULL, NULL, 'MopB_Arsenite-Ox', NULL, 'MopB_Arsenite-Ox', NULL, NULL, NULL, 2),
(10541, NULL, 'cd09826', NULL, NULL, 'peroxidasin_like', NULL, 'peroxidasin_like', NULL, NULL, 33700, 2),
(10542, NULL, 'cd14372', NULL, NULL, 'CUE_Cue5p_like', NULL, 'CUE_Cue5p_like', NULL, NULL, 30836, 2),
(10543, NULL, 'cd14117', NULL, NULL, 'STKc_Aurora-B_like', NULL, 'STKc_Aurora-B_like', NULL, NULL, NULL, 2),
(10544, NULL, 'cd18776', NULL, NULL, 'AfaD-like', NULL, 'AfaD-like', NULL, NULL, NULL, 2),
(10545, NULL, 'cd00246', NULL, NULL, 'RabGEF', NULL, 'RabGEF', NULL, NULL, 10774, 2),
(10546, NULL, 'cd03322', NULL, NULL, 'RspA', NULL, 'RspA', NULL, NULL, NULL, 2),
(10547, NULL, 'cd18983', NULL, NULL, 'CBD_MSL3_like', NULL, 'CBD_MSL3_like', NULL, NULL, NULL, 2),
(10548, NULL, 'cd01203', NULL, NULL, 'PTB_DOK1_DOK2_DOK3', NULL, 'PTB_DOK1_DOK2_DOK3', NULL, NULL, 32172, 2),
(10549, NULL, 'cd00400', NULL, NULL, 'Voltage_gated_ClC', NULL, 'Voltage_gated_ClC', NULL, NULL, NULL, 2),
(10550, NULL, 'cd01638', NULL, NULL, 'CysQ', NULL, 'CysQ', NULL, NULL, NULL, 2),
(10551, NULL, 'cd06442', NULL, NULL, 'DPM1_like', NULL, 'DPM1_like', NULL, NULL, 31112, 2),
(10552, NULL, 'cd05471', NULL, NULL, 'pepsin_like', NULL, 'pepsin_like', NULL, NULL, 22518, 2),
(10553, NULL, 'cd19939', NULL, NULL, 'REC_OmpR_BfmR-like', NULL, 'REC_OmpR_BfmR-like', NULL, NULL, NULL, 2),
(10554, NULL, 'cd03256', NULL, NULL, 'ABC_PhnC_transporter', NULL, 'ABC_PhnC_transporter', NULL, NULL, 11803, 2),
(10555, NULL, 'cd07302', NULL, NULL, 'CHD', NULL, 'CHD', NULL, NULL, 1287, 2),
(10556, NULL, 'cd07208', NULL, NULL, 'Pat_hypo_Ecoli_yjju_like', NULL, 'Pat_hypo_Ecoli_yjju_like', NULL, NULL, 27068, 2),
(10557, NULL, 'cd00913', NULL, NULL, 'PCD_DCoH_subfamily_a', NULL, 'PCD_DCoH_subfamily_a', NULL, NULL, NULL, 2),
(10558, NULL, 'cd05832', NULL, NULL, 'Ribosomal_L12p', NULL, 'Ribosomal_L12p', NULL, NULL, 15073, 2),
(10559, NULL, 'cd12013', NULL, NULL, 'SH3_RIM-BP_3', NULL, 'SH3_RIM-BP_3', NULL, NULL, 30212, 2),
(10560, NULL, 'cd16863', NULL, NULL, 'ING_ING5', NULL, 'ING_ING5', NULL, NULL, NULL, 2),
(10561, NULL, 'cd06066', NULL, NULL, 'H2MP_NAD-link-bidir', NULL, 'H2MP_NAD-link-bidir', NULL, NULL, NULL, 2);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(10562, NULL, 'cd11371', NULL, NULL, 'RNase_PH_MTR3', NULL, 'RNase_PH_MTR3', NULL, NULL, NULL, 2),
(10563, NULL, 'cd19197', NULL, NULL, 'PR-SET_PRDM13', NULL, 'PR-SET_PRDM13', NULL, NULL, 34865, 2),
(10564, NULL, 'cd09674', NULL, NULL, 'Cas6_I-F', NULL, 'Cas6_I-F', NULL, NULL, NULL, 2),
(10565, NULL, 'cd19434', NULL, NULL, 'lipocalin_YxeF', NULL, 'lipocalin_YxeF', NULL, NULL, 18679, 2),
(10566, NULL, 'cd07729', NULL, NULL, 'AHL_lactonase_MBL-fold', NULL, 'AHL_lactonase_MBL-fold', NULL, NULL, NULL, 2),
(10567, NULL, 'cd12310', NULL, NULL, 'RRM3_Spen', NULL, 'RRM3_Spen', NULL, NULL, NULL, 2),
(10568, NULL, 'cd03058', NULL, NULL, 'GST_N_Tau', NULL, 'GST_N_Tau', NULL, NULL, NULL, 2),
(10569, NULL, 'cd06217', NULL, NULL, 'FNR_iron_sulfur_binding_3', NULL, 'FNR_iron_sulfur_binding_3', NULL, NULL, NULL, 2),
(10570, NULL, 'cd08187', NULL, NULL, 'BDH', NULL, 'BDH', NULL, NULL, 36888, 2),
(10571, NULL, 'cd20256', NULL, NULL, 'Stannin_family', NULL, 'Stannin_family', NULL, NULL, NULL, 2),
(10572, NULL, 'cd05586', NULL, NULL, 'STKc_Sck1_like', NULL, 'STKc_Sck1_like', NULL, NULL, NULL, 2),
(10573, NULL, 'cd09908', NULL, NULL, 'H3TH_EXO1', NULL, 'H3TH_EXO1', NULL, NULL, 32193, 2),
(10574, NULL, 'cd04884', NULL, NULL, 'ACT_CBS', NULL, 'ACT_CBS', NULL, NULL, NULL, 2),
(10575, NULL, 'cd12786', NULL, NULL, 'RRM2_hnRPLL', NULL, 'RRM2_hnRPLL', NULL, NULL, 18909, 2),
(10576, NULL, 'cd18308', NULL, NULL, 'BTB1_POZ_LZTR1', NULL, 'BTB1_POZ_LZTR1', NULL, NULL, NULL, 2),
(10577, NULL, 'cd00778', NULL, NULL, 'ProRS_core_arch_euk', NULL, 'ProRS_core_arch_euk', NULL, NULL, 31162, 2),
(10578, NULL, 'cd07896', NULL, NULL, 'Adenylation_kDNA_ligase_like', NULL, 'Adenylation_kDNA_ligase_like', NULL, NULL, NULL, 2),
(10579, NULL, 'cd05025', NULL, NULL, 'S-100A1', NULL, 'S-100A1', NULL, NULL, 26408, 2),
(10580, NULL, 'cd01315', NULL, NULL, 'L-HYD_ALN', NULL, 'L-HYD_ALN', NULL, NULL, NULL, 2),
(10581, NULL, 'cd03751', NULL, NULL, 'proteasome_alpha_type_3', NULL, 'proteasome_alpha_type_3', NULL, NULL, NULL, 2),
(10582, NULL, 'cd11235', NULL, NULL, 'Sema_semaphorin', NULL, 'Sema_semaphorin', NULL, NULL, NULL, 2),
(10583, NULL, 'cd18954', NULL, NULL, 'bHLH_TS_bHLHe22_bHLHb5', NULL, 'bHLH_TS_bHLHe22_bHLHb5', NULL, NULL, NULL, 2),
(10584, NULL, 'cd11867', NULL, NULL, 'hSH3_ADAP', NULL, 'hSH3_ADAP', NULL, NULL, 30953, 2),
(10585, NULL, 'cd00325', NULL, NULL, 'chitinase_GH19', NULL, 'chitinase_GH19', NULL, NULL, NULL, 2),
(10586, NULL, 'cd19350', NULL, NULL, 'wnt_Wnt7b', NULL, 'wnt_Wnt7b', NULL, NULL, NULL, 2),
(10587, NULL, 'cd09900', NULL, NULL, 'H3TH_XPG-like', NULL, 'H3TH_XPG-like', NULL, NULL, NULL, 2),
(10588, NULL, 'cd16563', NULL, NULL, 'RING-HC_RNF220', NULL, 'RING-HC_RNF220', NULL, NULL, 27435, 2),
(10589, NULL, 'cd04820', NULL, NULL, 'PA_M28_1_1', NULL, 'PA_M28_1_1', NULL, NULL, NULL, 2),
(10590, NULL, 'cd12919', NULL, NULL, 'VKOR_2', NULL, 'VKOR_2', NULL, NULL, NULL, 2),
(10591, NULL, 'cd07683', NULL, NULL, 'F-BAR_srGAP1', NULL, 'F-BAR_srGAP1', NULL, NULL, 28588, 2),
(10592, NULL, 'cd21592', NULL, NULL, 'MERS-CoV-like_RdRp', NULL, 'MERS-CoV-like_RdRp', NULL, NULL, 33926, 2),
(10593, NULL, 'cd01674', NULL, NULL, 'Homoaconitase_Swivel', NULL, 'Homoaconitase_Swivel', NULL, NULL, 27379, 2),
(10594, NULL, 'cd17113', NULL, NULL, 'RA_ARAPs', NULL, 'RA_ARAPs', NULL, NULL, NULL, 2),
(10595, NULL, 'cd12662', NULL, NULL, 'RRM3_MYEF2', NULL, 'RRM3_MYEF2', NULL, NULL, 11822, 2),
(10596, NULL, 'cd12204', NULL, NULL, 'CBD_like', NULL, 'CBD_like', NULL, NULL, NULL, 2),
(10597, NULL, 'cd13875', NULL, NULL, 'CuRO_2_LCC_plant', NULL, 'CuRO_2_LCC_plant', NULL, NULL, 21377, 2),
(10598, NULL, 'cd12331', NULL, NULL, 'RRM_NRD1_SEB1_like', NULL, 'RRM_NRD1_SEB1_like', NULL, NULL, 11300, 2),
(10599, NULL, 'cd16989', NULL, NULL, 'ENTH_EpsinR', NULL, 'ENTH_EpsinR', NULL, NULL, NULL, 2),
(10600, NULL, 'cd18232', NULL, NULL, 'BTB_POZ_ZBTB48_TZAP_KR3', NULL, 'BTB_POZ_ZBTB48_TZAP_KR3', NULL, NULL, NULL, 2),
(10601, NULL, 'cd17427', NULL, NULL, 'MFS_MCT2', NULL, 'MFS_MCT2', NULL, NULL, NULL, 2),
(10602, NULL, 'cd16303', NULL, NULL, 'VIM_type_MBL-B1', NULL, 'VIM_type_MBL-B1', NULL, NULL, NULL, 2);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(10603, NULL, 'cd03004', NULL, NULL, 'PDI_a_ERdj5_C', NULL, 'PDI_a_ERdj5_C', NULL, NULL, 33071, 2),
(10604, NULL, 'cd14697', NULL, NULL, 'bZIP_Maf', NULL, 'bZIP_Maf', NULL, NULL, NULL, 2),
(10605, NULL, 'cd02569', NULL, NULL, 'PseudoU_synth_ScPus3', NULL, 'PseudoU_synth_ScPus3', NULL, NULL, 30826, 2),
(10606, NULL, 'cd14654', NULL, NULL, 'ZIP_Gal4', NULL, 'ZIP_Gal4', NULL, NULL, 2616, 2),
(10607, NULL, 'cd13785', NULL, NULL, 'CARD_BinCARD_like', NULL, 'CARD_BinCARD_like', NULL, NULL, 33641, 2),
(10608, NULL, 'cd17986', NULL, NULL, 'DEXQc_DQX1', NULL, 'DEXQc_DQX1', NULL, NULL, NULL, 2),
(10609, NULL, 'cd05108', NULL, NULL, 'PTKc_EGFR', NULL, 'PTKc_EGFR', NULL, NULL, NULL, 2),
(10610, NULL, 'cd12122', NULL, NULL, 'AMPKA_C', NULL, 'AMPKA_C', NULL, NULL, NULL, 2),
(10611, NULL, 'cd15490', NULL, NULL, 'eIF2_gamma_III', NULL, 'eIF2_gamma_III', NULL, NULL, 12005, 2),
(10612, NULL, 'cd19792', NULL, NULL, 'Bbox2_TRIM62_C-IV', NULL, 'Bbox2_TRIM62_C-IV', NULL, NULL, NULL, 2),
(10613, NULL, 'cd08637', NULL, NULL, 'DNA_pol_A_pol_I_C', NULL, 'DNA_pol_A_pol_I_C', NULL, NULL, NULL, 2),
(10614, NULL, 'cd08620', NULL, NULL, 'PI-PLCXDc_like_1', NULL, 'PI-PLCXDc_like_1', NULL, NULL, NULL, 2),
(10615, NULL, 'cd07018', NULL, NULL, 'S49_SppA_67K_type', NULL, 'S49_SppA_67K_type', NULL, NULL, NULL, 2),
(10616, NULL, 'cd19992', NULL, NULL, 'PBP1_ABC_xylose_binding-like', NULL, 'PBP1_ABC_xylose_binding-like', NULL, NULL, NULL, 2),
(10617, NULL, 'cd09766', NULL, NULL, 'Csx15_I-U', NULL, 'Csx15_I-U', NULL, NULL, NULL, 2),
(10618, NULL, 'cd10285', NULL, NULL, 'somatotropin_like', NULL, 'somatotropin_like', NULL, NULL, NULL, 2),
(10619, NULL, 'cd13915', NULL, NULL, 'CuRO_HCO_II_like_2', NULL, 'CuRO_HCO_II_like_2', NULL, NULL, NULL, 2),
(10620, NULL, 'cd10478', NULL, NULL, 'EphR_LBD_B3', NULL, 'EphR_LBD_B3', NULL, NULL, 32723, 2),
(10621, NULL, 'cd02698', NULL, NULL, 'Peptidase_C1A_CathepsinX', NULL, 'Peptidase_C1A_CathepsinX', NULL, NULL, 32663, 2),
(10622, NULL, 'cd18228', NULL, NULL, 'BTB_POZ_ZBTB44', NULL, 'BTB_POZ_ZBTB44', NULL, NULL, NULL, 2),
(10623, NULL, 'cd03260', NULL, NULL, 'ABC_PstB_phosphate_transporter', NULL, 'ABC_PstB_phosphate_transporter', NULL, NULL, 3728, 2),
(10624, NULL, 'cd14060', NULL, NULL, 'STKc_MLTK', NULL, 'STKc_MLTK', NULL, NULL, NULL, 2),
(10625, NULL, 'cd21172', NULL, NULL, 'NTD_dcv_Nsp15-like', NULL, 'NTD_dcv_Nsp15-like', NULL, NULL, 35483, 2),
(10626, NULL, 'cd06444', NULL, NULL, 'DNA_pol_A', NULL, 'DNA_pol_A', NULL, NULL, NULL, 2),
(10627, NULL, 'cd08196', NULL, NULL, 'Fe-ADH-like', NULL, 'Fe-ADH-like', NULL, NULL, NULL, 2),
(10628, NULL, 'cd15562', NULL, NULL, 'PHD2_PHF14', NULL, 'PHD2_PHF14', NULL, NULL, NULL, 2),
(10629, NULL, 'cd18613', NULL, NULL, 'GH130', NULL, 'GH130', NULL, NULL, NULL, 2),
(10630, NULL, 'cd19018', NULL, NULL, 'LGIC_ECD_nAChR_A5', NULL, 'LGIC_ECD_nAChR_A5', NULL, NULL, NULL, 2),
(10631, NULL, 'cd15553', NULL, NULL, 'PHD_Cfp1', NULL, 'PHD_Cfp1', NULL, NULL, NULL, 2),
(10632, NULL, 'cd19608', NULL, NULL, 'GH113_mannanase-like', NULL, 'GH113_mannanase-like', NULL, NULL, NULL, 2),
(10633, NULL, 'cd16508', NULL, NULL, 'RING-HC_HAKAI_like', NULL, 'RING-HC_HAKAI_like', NULL, NULL, 28674, 2),
(10634, NULL, 'cd18237', NULL, NULL, 'BTB_POZ_KLHL7', NULL, 'BTB_POZ_KLHL7', NULL, NULL, NULL, 2),
(10635, NULL, 'cd16515', NULL, NULL, 'RING-HC_LRSAM1', NULL, 'RING-HC_LRSAM1', NULL, NULL, NULL, 2),
(10636, NULL, 'cd18766', NULL, NULL, 'PIN_MtVapC3-like', NULL, 'PIN_MtVapC3-like', NULL, NULL, NULL, 2),
(10637, NULL, 'cd04040', NULL, NULL, 'C2D_Tricalbin-like', NULL, 'C2D_Tricalbin-like', NULL, NULL, 32196, 2),
(10638, NULL, 'cd10558', NULL, NULL, 'FDH-N', NULL, 'FDH-N', NULL, NULL, 6196, 2),
(10639, NULL, 'cd15471', NULL, NULL, 'Myo5p-like_CBD_afadin', NULL, 'Myo5p-like_CBD_afadin', NULL, NULL, 27078, 2),
(10640, NULL, 'cd08056', NULL, NULL, 'MPN_PRP8', NULL, 'MPN_PRP8', NULL, NULL, NULL, 2),
(10641, NULL, 'cd01718', NULL, NULL, 'Sm_E', NULL, 'Sm_E', NULL, NULL, 25667, 2),
(10642, NULL, 'cd08210', NULL, NULL, 'RLP_RrRLP', NULL, 'RLP_RrRLP', NULL, NULL, NULL, 2),
(10643, NULL, 'cd01908', NULL, NULL, 'YafJ', NULL, 'YafJ', NULL, NULL, NULL, 2);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(10644, NULL, 'cd13169', NULL, NULL, 'RanBD_NUP50_plant', NULL, 'RanBD_NUP50_plant', NULL, NULL, 36769, 2),
(10645, NULL, 'cd04258', NULL, NULL, 'AAK_AKiii-LysC-EC', NULL, 'AAK_AKiii-LysC-EC', NULL, NULL, 30476, 2),
(10646, NULL, 'cd03257', NULL, NULL, 'ABC_NikE_OppD_transporters', NULL, 'ABC_NikE_OppD_transporters', NULL, NULL, NULL, 2),
(10647, NULL, 'cd12522', NULL, NULL, 'RRM4_MRN1', NULL, 'RRM4_MRN1', NULL, NULL, NULL, 2),
(10648, NULL, 'cd14569', NULL, NULL, 'DSP_slingshot_2', NULL, 'DSP_slingshot_2', NULL, NULL, NULL, 2),
(10649, NULL, 'cd07177', NULL, NULL, 'terB_like', NULL, 'terB_like', NULL, NULL, NULL, 2),
(10650, NULL, 'cd11019', NULL, NULL, 'OsENODL1_like', NULL, 'OsENODL1_like', NULL, NULL, 30540, 2),
(10651, NULL, 'cd19565', NULL, NULL, 'serpinB6_CAP', NULL, 'serpinB6_CAP', NULL, NULL, NULL, 2),
(10652, NULL, 'cd16540', NULL, NULL, 'RING-HC_RNF114', NULL, 'RING-HC_RNF114', NULL, NULL, 36522, 2),
(10653, NULL, 'cd15111', NULL, NULL, '7tmA_MrgprG', NULL, '7tmA_MrgprG', NULL, NULL, 22512, 2),
(10654, NULL, 'cd15626', NULL, NULL, 'PHD_SP110_140', NULL, 'PHD_SP110_140', NULL, NULL, NULL, 2),
(10655, NULL, 'cd19106', NULL, NULL, 'AKR_AKR1A1-4', NULL, 'AKR_AKR1A1-4', NULL, NULL, 34317, 2),
(10656, NULL, 'cd11973', NULL, NULL, 'SH3_ASEF', NULL, 'SH3_ASEF', NULL, NULL, NULL, 2),
(10657, NULL, 'cd16802', NULL, NULL, 'RING-H2_RNF128_like', NULL, 'RING-H2_RNF128_like', NULL, NULL, NULL, 2),
(10658, NULL, 'cd01320', NULL, NULL, 'ADA', NULL, 'ADA', NULL, NULL, 4550, 2),
(10659, NULL, 'cd08638', NULL, NULL, 'DNA_pol_A_theta', NULL, 'DNA_pol_A_theta', NULL, NULL, NULL, 2),
(10660, NULL, 'cd17637', NULL, NULL, 'ACLS-CaiC', NULL, 'ACLS-CaiC', NULL, NULL, NULL, 2),
(10661, NULL, 'cd18568', NULL, NULL, 'ABC_6TM_HetC_like', NULL, 'ABC_6TM_HetC_like', NULL, NULL, NULL, 2),
(10662, NULL, 'cd13366', NULL, NULL, 'PH_ABR', NULL, 'PH_ABR', NULL, NULL, 27139, 2),
(10663, NULL, 'cd03805', NULL, NULL, 'GT4_ALG2-like', NULL, 'GT4_ALG2-like', NULL, NULL, NULL, 2),
(10664, NULL, 'cd11441', NULL, NULL, 'bHLH-PAS_CLOCK_like', NULL, 'bHLH-PAS_CLOCK_like', NULL, NULL, NULL, 2),
(10665, NULL, 'cd08609', NULL, NULL, 'GDPD_GDE3', NULL, 'GDPD_GDE3', NULL, NULL, NULL, 2),
(10666, NULL, 'cd15876', NULL, NULL, 'SNARE_syntaxin12', NULL, 'SNARE_syntaxin12', NULL, NULL, NULL, 2),
(10667, NULL, 'cd07898', NULL, NULL, 'Adenylation_DNA_ligase', NULL, 'Adenylation_DNA_ligase', NULL, NULL, NULL, 2),
(10668, NULL, 'cd04327', NULL, NULL, 'ZnMc_MMP_like_3', NULL, 'ZnMc_MMP_like_3', NULL, NULL, NULL, 2),
(10669, NULL, 'cd11729', NULL, NULL, 'ADDz_Dnmt3a', NULL, 'ADDz_Dnmt3a', NULL, NULL, 34447, 2),
(10670, NULL, 'cd14685', NULL, NULL, 'RanBD3_RanBP2-like', NULL, 'RanBD3_RanBP2-like', NULL, NULL, NULL, 2),
(10671, NULL, 'cd05720', NULL, NULL, 'Ig_CD8_alpha', NULL, 'Ig_CD8_alpha', NULL, NULL, NULL, 2),
(10672, NULL, 'cd16083', NULL, NULL, 'IgC_CD80', NULL, 'IgC_CD80', NULL, NULL, 27935, 2),
(10673, NULL, 'cd16123', NULL, NULL, 'RA_RASSF7_like', NULL, 'RA_RASSF7_like', NULL, NULL, NULL, 2),
(10674, NULL, 'cd11958', NULL, NULL, 'SH3_RUSC1', NULL, 'SH3_RUSC1', NULL, NULL, NULL, 2),
(10675, NULL, 'cd04399', NULL, NULL, 'RhoGAP_fRGD2', NULL, 'RhoGAP_fRGD2', NULL, NULL, NULL, 2),
(10676, NULL, 'cd17157', NULL, NULL, 'DCX2_DCDC5', NULL, 'DCX2_DCDC5', NULL, NULL, NULL, 2),
(10677, NULL, 'cd08211', NULL, NULL, 'RuBisCO_large_II', NULL, 'RuBisCO_large_II', NULL, NULL, 21170, 2),
(10678, NULL, 'cd16693', NULL, NULL, 'mRING-H2-C3H3C2_WDR24', NULL, 'mRING-H2-C3H3C2_WDR24', NULL, NULL, NULL, 2),
(10679, NULL, 'cd01060', NULL, NULL, 'Membrane-FADS-like', NULL, 'Membrane-FADS-like', NULL, NULL, NULL, 2),
(10680, NULL, 'cd14722', NULL, NULL, 'bZIP_ATF3', NULL, 'bZIP_ATF3', NULL, NULL, NULL, 2),
(10681, NULL, 'cd02187', NULL, NULL, 'beta_tubulin', NULL, 'beta_tubulin', NULL, NULL, NULL, 2),
(10682, NULL, 'cd01334', NULL, NULL, 'Lyase_I', NULL, 'Lyase_I', NULL, NULL, NULL, 2),
(10683, NULL, 'cd09171', NULL, NULL, 'PLDc_vPLD6_like', NULL, 'PLDc_vPLD6_like', NULL, NULL, NULL, 2),
(10684, NULL, 'cd09560', NULL, NULL, 'SAM_SASH3', NULL, 'SAM_SASH3', NULL, NULL, NULL, 2);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(10685, NULL, 'cd19697', NULL, NULL, 'bHLH-PAS_NPAS4_PASD10', NULL, 'bHLH-PAS_NPAS4_PASD10', NULL, NULL, NULL, 2),
(10686, NULL, 'cd00919', NULL, NULL, 'Heme_Cu_Oxidase_I', NULL, 'Heme_Cu_Oxidase_I', NULL, NULL, NULL, 2),
(10687, NULL, 'cd13430', NULL, NULL, 'LDT_IgD_like', NULL, 'LDT_IgD_like', NULL, NULL, NULL, 2),
(10688, NULL, 'cd16923', NULL, NULL, 'HATPase_VanS-like', NULL, 'HATPase_VanS-like', NULL, NULL, NULL, 2),
(10689, NULL, 'cd00836', NULL, NULL, 'FERM_C-lobe', NULL, 'FERM_C-lobe', NULL, NULL, NULL, 2),
(10690, NULL, 'cd07036', NULL, NULL, 'TPP_PYR_E1-PDHc-beta_like', NULL, 'TPP_PYR_E1-PDHc-beta_like', NULL, NULL, NULL, 2),
(10691, NULL, 'cd11284', NULL, NULL, 'ADF_Twf-C_like', NULL, 'ADF_Twf-C_like', NULL, NULL, NULL, 2),
(10692, NULL, 'cd05674', NULL, NULL, 'M20_yscS', NULL, 'M20_yscS', NULL, NULL, NULL, 2),
(10693, NULL, 'cd19122', NULL, NULL, 'AKR_AKR3E1', NULL, 'AKR_AKR3E1', NULL, NULL, NULL, 2),
(10694, NULL, 'cd07377', NULL, NULL, 'WHTH_GntR', NULL, 'WHTH_GntR', NULL, NULL, 5800, 2),
(10695, NULL, 'cd16014', NULL, NULL, 'PLC', NULL, 'PLC', NULL, NULL, NULL, 2),
(10696, NULL, 'cd14427', NULL, NULL, 'UBA2_HR23A', NULL, 'UBA2_HR23A', NULL, NULL, NULL, 2),
(10697, NULL, 'cd01835', NULL, NULL, 'SGNH_hydrolase_like_3', NULL, 'SGNH_hydrolase_like_3', NULL, NULL, NULL, 2),
(10698, NULL, 'cd16119', NULL, NULL, 'UBX_UBXN6', NULL, 'UBX_UBXN6', NULL, NULL, NULL, 2),
(10699, NULL, 'cd07820', NULL, NULL, 'SRPBCC_3', NULL, 'SRPBCC_3', NULL, NULL, NULL, 2),
(10700, NULL, 'cd00814', NULL, NULL, 'MetRS_core', NULL, 'MetRS_core', NULL, NULL, 33402, 2),
(10701, NULL, 'cd03124', NULL, NULL, 'alpha_CA_prokaryotic_like', NULL, 'alpha_CA_prokaryotic_like', NULL, NULL, 30116, 2),
(10702, NULL, 'cd13764', NULL, NULL, 'TGF_beta_GDF1_3_like', NULL, 'TGF_beta_GDF1_3_like', NULL, NULL, NULL, 2),
(10703, NULL, 'cd09417', NULL, NULL, 'LIM2_LIMPETin_like', NULL, 'LIM2_LIMPETin_like', NULL, NULL, NULL, 2),
(10704, NULL, 'cd12572', NULL, NULL, 'RRM2_MSI1', NULL, 'RRM2_MSI1', NULL, NULL, NULL, 2),
(10705, NULL, 'cd07852', NULL, NULL, 'STKc_MAPK15-like', NULL, 'STKc_MAPK15-like', NULL, NULL, NULL, 2),
(10706, NULL, 'cd03350', NULL, NULL, 'LbH_THP_succinylT', NULL, 'LbH_THP_succinylT', NULL, NULL, NULL, 2),
(10707, NULL, 'cd06449', NULL, NULL, 'ACCD', NULL, 'ACCD', NULL, NULL, NULL, 2),
(10708, NULL, 'cd13865', NULL, NULL, 'CuRO_1_LCC_like_3', NULL, 'CuRO_1_LCC_like_3', NULL, NULL, NULL, 2),
(10709, NULL, 'cd18567', NULL, NULL, 'ABC_6TM_CvaB_RaxB_like', NULL, 'ABC_6TM_CvaB_RaxB_like', NULL, NULL, NULL, 2),
(10710, NULL, 'cd08417', NULL, NULL, 'PBP2_Nitroaromatics_like', NULL, 'PBP2_Nitroaromatics_like', NULL, NULL, 32147, 2),
(10711, NULL, 'cd04036', NULL, NULL, 'C2_cPLA2', NULL, 'C2_cPLA2', NULL, NULL, 30978, 2),
(10712, NULL, 'cd18707', NULL, NULL, 'PIN_VapC-like', NULL, 'PIN_VapC-like', NULL, NULL, NULL, 2),
(10713, NULL, 'cd14446', NULL, NULL, 'bt3222_like', NULL, 'bt3222_like', NULL, NULL, 26386, 2),
(10714, NULL, 'cd17089', NULL, NULL, 'FERM_F0_TLN', NULL, 'FERM_F0_TLN', NULL, NULL, NULL, 2),
(10715, NULL, 'cd18330', NULL, NULL, 'BTB_POZ_ZBTB8B', NULL, 'BTB_POZ_ZBTB8B', NULL, NULL, NULL, 2),
(10716, NULL, 'cd15228', NULL, NULL, '7tmA_OR10D-like', NULL, '7tmA_OR10D-like', NULL, NULL, NULL, 2),
(10717, NULL, 'cd18342', NULL, NULL, 'BTB_POZ_SPOP', NULL, 'BTB_POZ_SPOP', NULL, NULL, NULL, 2),
(10718, NULL, 'cd05793', NULL, NULL, 'S1_IF1A', NULL, 'S1_IF1A', NULL, NULL, 624, 2),
(10719, NULL, 'cd09368', NULL, NULL, 'LIM1_Lhx3_Lhx4', NULL, 'LIM1_Lhx3_Lhx4', NULL, NULL, NULL, 2),
(10720, NULL, 'cd07516', NULL, NULL, 'HAD_Pase', NULL, 'HAD_Pase', NULL, NULL, NULL, 2),
(10721, NULL, 'cd10284', NULL, NULL, 'growth_hormone_like', NULL, 'growth_hormone_like', NULL, NULL, NULL, 2),
(10722, NULL, 'cd15881', NULL, NULL, 'SNARE_syntaxin3', NULL, 'SNARE_syntaxin3', NULL, NULL, NULL, 2),
(10723, NULL, 'cd00881', NULL, NULL, 'GTP_translation_factor', NULL, 'GTP_translation_factor', NULL, NULL, NULL, 2),
(10724, NULL, 'cd05926', NULL, NULL, 'FACL_fum10p_like', NULL, 'FACL_fum10p_like', NULL, NULL, 34948, 2),
(10725, NULL, 'cd10420', NULL, NULL, 'SH2_STAT5b', NULL, 'SH2_STAT5b', NULL, NULL, 32922, 2);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(10726, NULL, 'cd11847', NULL, NULL, 'SH3_Brk', NULL, 'SH3_Brk', NULL, NULL, NULL, 2),
(10727, NULL, 'cd05785', NULL, NULL, 'DNA_polB_like2_exo', NULL, 'DNA_polB_like2_exo', NULL, NULL, NULL, 2),
(10728, NULL, 'cd10413', NULL, NULL, 'SH2_Grb7', NULL, 'SH2_Grb7', NULL, NULL, NULL, 2),
(10729, NULL, 'cd17256', NULL, NULL, 'RMtype1_S_EcoJA65PI-TRD1-CR1_like', NULL, 'RMtype1_S_EcoJA65PI-TRD1-CR1_like', NULL, NULL, NULL, 2),
(10730, NULL, 'cd19567', NULL, NULL, 'serpinB8_CAP-2', NULL, 'serpinB8_CAP-2', NULL, NULL, NULL, 2),
(10731, NULL, 'cd13350', NULL, NULL, 'PH-GRAM1_TBC1D8B', NULL, 'PH-GRAM1_TBC1D8B', NULL, NULL, 28005, 2),
(10732, NULL, 'cd12098', NULL, NULL, 'DD_R_PKA_fungi', NULL, 'DD_R_PKA_fungi', NULL, NULL, NULL, 2),
(10733, NULL, 'cd11743', NULL, NULL, 'Cthe_2751_like', NULL, 'Cthe_2751_like', NULL, NULL, NULL, 2),
(10734, NULL, 'cd19833', NULL, NULL, 'Bbox2_MuRF3_C-II', NULL, 'Bbox2_MuRF3_C-II', NULL, NULL, NULL, 2),
(10735, NULL, 'cd04132', NULL, NULL, 'Rho4_like', NULL, 'Rho4_like', NULL, NULL, NULL, 2),
(10736, NULL, 'cd11367', NULL, NULL, 'RNase_PH_RRP42', NULL, 'RNase_PH_RRP42', NULL, NULL, NULL, 2),
(10737, NULL, 'cd13114', NULL, NULL, 'POLO_box_Plk4_1', NULL, 'POLO_box_Plk4_1', NULL, NULL, 29785, 2),
(10738, NULL, 'cd17602', NULL, NULL, 'REC_PatA-like', NULL, 'REC_PatA-like', NULL, NULL, NULL, 2),
(10739, NULL, 'cd16739', NULL, NULL, 'RING-HC_RING1', NULL, 'RING-HC_RING1', NULL, NULL, 35462, 2),
(10740, NULL, 'cd19728', NULL, NULL, 'bHLH-PAS_HIF2a_PASD2', NULL, 'bHLH-PAS_HIF2a_PASD2', NULL, NULL, NULL, 2),
(10741, NULL, 'cd12219', NULL, NULL, 'Ubl_TBK1_like', NULL, 'Ubl_TBK1_like', NULL, NULL, NULL, 2),
(10742, NULL, 'cd01935', NULL, NULL, 'Ntn_CGH_like', NULL, 'Ntn_CGH_like', NULL, NULL, NULL, 2),
(10743, NULL, 'cd19398', NULL, NULL, 'TGF_beta_BMP8', NULL, 'TGF_beta_BMP8', NULL, NULL, NULL, 2),
(10744, NULL, 'cd07402', NULL, NULL, 'MPP_GpdQ', NULL, 'MPP_GpdQ', NULL, NULL, 25432, 2),
(10745, NULL, 'cd19844', NULL, NULL, 'Bbox1_TRIM67_C-I', NULL, 'Bbox1_TRIM67_C-I', NULL, NULL, NULL, 2),
(10746, NULL, 'cd03377', NULL, NULL, 'TPP_PFOR_PNO', NULL, 'TPP_PFOR_PNO', NULL, NULL, NULL, 2),
(10747, NULL, 'cd12463', NULL, NULL, 'RRM_G3BP1', NULL, 'RRM_G3BP1', NULL, NULL, 1546, 2),
(10748, NULL, 'cd13715', NULL, NULL, 'PBP2_iGluR_AMPA', NULL, 'PBP2_iGluR_AMPA', NULL, NULL, NULL, 2),
(10749, NULL, 'cd16254', NULL, NULL, 'EFh_parvalbumin_alpha', NULL, 'EFh_parvalbumin_alpha', NULL, NULL, NULL, 2),
(10750, NULL, 'cd01089', NULL, NULL, 'PA2G4-like', NULL, 'PA2G4-like', NULL, NULL, NULL, 2),
(10751, NULL, 'cd08437', NULL, NULL, 'PBP2_MleR', NULL, 'PBP2_MleR', NULL, NULL, NULL, 2),
(10752, NULL, 'cd01485', NULL, NULL, 'E1-1_like', NULL, 'E1-1_like', NULL, NULL, NULL, 2),
(10753, NULL, 'cd15032', NULL, NULL, '7tmF_FZD6', NULL, '7tmF_FZD6', NULL, NULL, NULL, 2),
(10754, NULL, 'cd05881', NULL, NULL, 'Ig1_Necl-2', NULL, 'Ig1_Necl-2', NULL, NULL, NULL, 2),
(10755, NULL, 'cd17369', NULL, NULL, 'MFS_ShiA_like', NULL, 'MFS_ShiA_like', NULL, NULL, NULL, 2),
(10756, NULL, 'cd08870', NULL, NULL, 'START_STARD2_7-like', NULL, 'START_STARD2_7-like', NULL, NULL, NULL, 2),
(10757, NULL, 'cd08687', NULL, NULL, 'C2_PKN-like', NULL, 'C2_PKN-like', NULL, NULL, 28349, 2),
(10758, NULL, 'cd16519', NULL, NULL, 'RING-HC_MIBs', NULL, 'RING-HC_MIBs', NULL, NULL, NULL, 2),
(10759, NULL, 'cd02185', NULL, NULL, 'AroH', NULL, 'AroH', NULL, NULL, 900, 2),
(10760, NULL, 'cd13316', NULL, NULL, 'PH_Boi', NULL, 'PH_Boi', NULL, NULL, NULL, 2),
(10761, NULL, 'cd09691', NULL, NULL, 'Cas8b_I-B', NULL, 'Cas8b_I-B', NULL, NULL, NULL, 2),
(10762, NULL, 'cd04386', NULL, NULL, 'RhoGAP_nadrin', NULL, 'RhoGAP_nadrin', NULL, NULL, NULL, 2),
(10763, NULL, 'cd17526', NULL, NULL, 'RMtype1_S_Cje2232P-TRD2-CR2_like', NULL, 'RMtype1_S_Cje2232P-TRD2-CR2_like', NULL, NULL, NULL, 2),
(10764, NULL, 'cd18399', NULL, NULL, 'BTB_POZ_KCTD10_BACURD3', NULL, 'BTB_POZ_KCTD10_BACURD3', NULL, NULL, NULL, 2),
(10765, NULL, 'cd00590', NULL, NULL, 'RRM_SF', NULL, 'RRM_SF', NULL, NULL, NULL, 2),
(10766, NULL, 'cd05493', NULL, NULL, 'Bromo_ALL-1', NULL, 'Bromo_ALL-1', NULL, NULL, NULL, 2);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(10767, NULL, 'cd06849', NULL, NULL, 'lipoyl_domain', NULL, 'lipoyl_domain', NULL, NULL, NULL, 2),
(10768, NULL, 'cd18696', NULL, NULL, 'PIN_MtVapC26-like', NULL, 'PIN_MtVapC26-like', NULL, NULL, NULL, 2),
(10769, NULL, 'cd06532', NULL, NULL, 'Glyco_transf_25', NULL, 'Glyco_transf_25', NULL, NULL, 2867, 2),
(10770, NULL, 'cd09555', NULL, NULL, 'SAM_EPH-B6', NULL, 'SAM_EPH-B6', NULL, NULL, NULL, 2),
(10771, NULL, 'cd07950', NULL, NULL, 'Gallate_Doxase_N', NULL, 'Gallate_Doxase_N', NULL, NULL, 11689, 2),
(10772, NULL, 'cd18021', NULL, NULL, 'DEXHc_Brr2_2', NULL, 'DEXHc_Brr2_2', NULL, NULL, NULL, 2),
(10773, NULL, 'cd00107', NULL, NULL, 'Knot1', NULL, 'Knot1', NULL, NULL, 678, 2),
(10774, NULL, 'cd16273', NULL, NULL, 'SNM1A-1C-like_MBL-fold', NULL, 'SNM1A-1C-like_MBL-fold', NULL, NULL, NULL, 2),
(10775, NULL, 'cd00534', NULL, NULL, 'DHNA_DHNTPE', NULL, 'DHNA_DHNTPE', NULL, NULL, 10460, 2),
(10776, NULL, 'cd15910', NULL, NULL, '7tmF_FZD3_FZD6-like', NULL, '7tmF_FZD3_FZD6-like', NULL, NULL, NULL, 2),
(10777, NULL, 'cd07289', NULL, NULL, 'PX_PI3K_C2_alpha', NULL, 'PX_PI3K_C2_alpha', NULL, NULL, 37455, 2),
(10778, NULL, 'cd08599', NULL, NULL, 'PI-PLCc_plant', NULL, 'PI-PLCc_plant', NULL, NULL, NULL, 2),
(10779, NULL, 'cd00936', NULL, NULL, 'WEPRS_RNA', NULL, 'WEPRS_RNA', NULL, NULL, NULL, 2),
(10780, NULL, 'cd18406', NULL, NULL, 'BTB_POZ_KCNA5', NULL, 'BTB_POZ_KCNA5', NULL, NULL, NULL, 2),
(10781, NULL, 'cd14635', NULL, NULL, 'R-PTPc-M-2', NULL, 'R-PTPc-M-2', NULL, NULL, NULL, 2),
(10782, NULL, 'cd16516', NULL, NULL, 'RING-HC_malin', NULL, 'RING-HC_malin', NULL, NULL, NULL, 2),
(10783, NULL, 'cd16742', NULL, NULL, 'RING-HC_RNFT2', NULL, 'RING-HC_RNFT2', NULL, NULL, NULL, 2),
(10784, NULL, 'cd17710', NULL, NULL, 'BRCT_PAXIP1_rpt2', NULL, 'BRCT_PAXIP1_rpt2', NULL, NULL, NULL, 2),
(10785, NULL, 'cd21167', NULL, NULL, 'M_alpha_beta_cv_Nsp15-like', NULL, 'M_alpha_beta_cv_Nsp15-like', NULL, NULL, 36267, 2),
(10786, NULL, 'cd17905', NULL, NULL, 'CheC-like', NULL, 'CheC-like', NULL, NULL, NULL, 2),
(10787, NULL, 'cd01799', NULL, NULL, 'Ubl_HOIL1', NULL, 'Ubl_HOIL1', NULL, NULL, NULL, 2),
(10788, NULL, 'cd16532', NULL, NULL, 'RING-HC_RNFT1_like', NULL, 'RING-HC_RNFT1_like', NULL, NULL, NULL, 2),
(10789, NULL, 'cd01983', NULL, NULL, 'SIMIBI', NULL, 'SIMIBI', NULL, NULL, NULL, 2),
(10790, NULL, 'cd18013', NULL, NULL, 'DEXQc_bact_SNF2', NULL, 'DEXQc_bact_SNF2', NULL, NULL, NULL, 2),
(10791, NULL, 'cd14292', NULL, NULL, 'UBA2_NUB1', NULL, 'UBA2_NUB1', NULL, NULL, NULL, 2),
(10792, NULL, 'cd02781', NULL, NULL, 'MopB_CT_Acetylene-hydratase', NULL, 'MopB_CT_Acetylene-hydratase', NULL, NULL, 32577, 2),
(10793, NULL, 'cd17480', NULL, NULL, 'MFS_SLC40A1_like', NULL, 'MFS_SLC40A1_like', NULL, NULL, 12349, 2),
(10794, NULL, 'cd03763', NULL, NULL, 'proteasome_beta_type_7', NULL, 'proteasome_beta_type_7', NULL, NULL, NULL, 2),
(10795, NULL, 'cd09487', NULL, NULL, 'SAM_superfamily', NULL, 'SAM_superfamily', NULL, NULL, NULL, 2),
(10796, NULL, 'cd12611', NULL, NULL, 'RRM1_NGR1_NAM8_like', NULL, 'RRM1_NGR1_NAM8_like', NULL, NULL, NULL, 2),
(10797, NULL, 'cd13232', NULL, NULL, 'Ig-PH_SCAB1', NULL, 'Ig-PH_SCAB1', NULL, NULL, NULL, 2),
(10798, NULL, 'cd21479', NULL, NULL, 'MERS-like_CoV_Spike_S1_RBD', NULL, 'MERS-like_CoV_Spike_S1_RBD', NULL, NULL, 36105, 2),
(10799, NULL, 'cd17081', NULL, NULL, 'RAWUL_PCGF1', NULL, 'RAWUL_PCGF1', NULL, NULL, NULL, 2),
(10800, NULL, 'cd18782', NULL, NULL, 'ABC_6TM_PrtD_LapB_HlyB_like', NULL, 'ABC_6TM_PrtD_LapB_HlyB_like', NULL, NULL, NULL, 2),
(10801, NULL, 'cd04650', NULL, NULL, 'LbH_FBP', NULL, 'LbH_FBP', NULL, NULL, NULL, 2),
(10802, NULL, 'cd15161', NULL, NULL, '7tmA_GPR17', NULL, '7tmA_GPR17', NULL, NULL, NULL, 2),
(10803, NULL, 'cd07101', NULL, NULL, 'ALDH_SSADH2_GabD2', NULL, 'ALDH_SSADH2_GabD2', NULL, NULL, NULL, 2),
(10804, NULL, 'cd07773', NULL, NULL, 'FGGY_FK', NULL, 'FGGY_FK', NULL, NULL, NULL, 2),
(10805, NULL, 'cd12168', NULL, NULL, 'Mand_dh_like', NULL, 'Mand_dh_like', NULL, NULL, NULL, 2),
(10806, NULL, 'cd14822', NULL, NULL, 'BACK_BTBD9', NULL, 'BACK_BTBD9', NULL, NULL, 22558, 2); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(10807, NULL, 'cd00218', NULL, NULL, 'GlcAT-I', NULL, 'GlcAT-I', NULL, NULL, 1093, 2),
(10808, NULL, 'cd05272', NULL, NULL, 'TDH_SDR_e', NULL, 'TDH_SDR_e', NULL, NULL, NULL, 2),
(10809, NULL, 'cd06334', NULL, NULL, 'PBP1_ABC_ligand_binding-like', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, NULL, 2),
(10810, NULL, 'cd04139', NULL, NULL, 'RalA_RalB', NULL, 'RalA_RalB', NULL, NULL, NULL, 2),
(10811, NULL, 'cd00495', NULL, NULL, 'Ribosomal_L25_TL5_CTC', NULL, 'Ribosomal_L25_TL5_CTC', NULL, NULL, 24747, 2),
(10812, NULL, 'cd13845', NULL, NULL, 'CuRO_1_AAO', NULL, 'CuRO_1_AAO', NULL, NULL, 29172, 2),
(10813, NULL, 'cd08785', NULL, NULL, 'CARD_CARD9-like', NULL, 'CARD_CARD9-like', NULL, NULL, NULL, 2),
(10814, NULL, 'cd12562', NULL, NULL, 'RRM2_RBM5_like', NULL, 'RRM2_RBM5_like', NULL, NULL, NULL, 2),
(10815, NULL, 'cd07948', NULL, NULL, 'DRE_TIM_HCS', NULL, 'DRE_TIM_HCS', NULL, NULL, NULL, 2),
(10816, NULL, 'cd12829', NULL, NULL, 'Alr1p-like', NULL, 'Alr1p-like', NULL, NULL, 35776, 2),
(10817, NULL, 'cd17184', NULL, NULL, 'FERM_F1_KIND2', NULL, 'FERM_F1_KIND2', NULL, NULL, NULL, 2),
(10818, NULL, 'cd04410', NULL, NULL, 'DMSOR_beta-like', NULL, 'DMSOR_beta-like', NULL, NULL, NULL, 2),
(10819, NULL, 'cd08378', NULL, NULL, 'C2B_MCTP_PRT_plant', NULL, 'C2B_MCTP_PRT_plant', NULL, NULL, NULL, 2),
(10820, NULL, 'cd15878', NULL, NULL, 'SNARE_syntaxin11', NULL, 'SNARE_syntaxin11', NULL, NULL, 34705, 2),
(10821, NULL, 'cd12718', NULL, NULL, 'RRM_BRAP2', NULL, 'RRM_BRAP2', NULL, NULL, 29007, 2),
(10822, NULL, 'cd02223', NULL, NULL, 'cupin_Bh2720-like', NULL, 'cupin_Bh2720-like', NULL, NULL, NULL, 2),
(10823, NULL, 'cd19780', NULL, NULL, 'Bbox2_TRIM39-like', NULL, 'Bbox2_TRIM39-like', NULL, NULL, NULL, 2),
(10824, NULL, 'cd04173', NULL, NULL, 'Rnd2_Rho7', NULL, 'Rnd2_Rho7', NULL, NULL, 30858, 2),
(10825, NULL, 'cd03119', NULL, NULL, 'alpha_CA_I_II_III_XIII', NULL, 'alpha_CA_I_II_III_XIII', NULL, NULL, NULL, 2),
(10826, NULL, 'cd18243', NULL, NULL, 'BTB_POZ_KLHL14_printor', NULL, 'BTB_POZ_KLHL14_printor', NULL, NULL, NULL, 2),
(10827, NULL, 'cd08429', NULL, NULL, 'PBP2_NhaR', NULL, 'PBP2_NhaR', NULL, NULL, NULL, 2),
(10828, NULL, 'cd18955', NULL, NULL, 'BTB_POZ_BACH', NULL, 'BTB_POZ_BACH', NULL, NULL, NULL, 2),
(10829, NULL, 'cd15758', NULL, NULL, 'FYVE_RUFY1', NULL, 'FYVE_RUFY1', NULL, NULL, NULL, 2),
(10830, NULL, 'cd12225', NULL, NULL, 'RRM1_2_CID8_like', NULL, 'RRM1_2_CID8_like', NULL, NULL, NULL, 2),
(10831, NULL, 'cd16628', NULL, NULL, 'RING-HC_RBR_RNF14', NULL, 'RING-HC_RBR_RNF14', NULL, NULL, NULL, 2),
(10832, NULL, 'cd06576', NULL, NULL, 'PASTA_Pbp2x-like_1', NULL, 'PASTA_Pbp2x-like_1', NULL, NULL, NULL, 2),
(10833, NULL, 'cd13274', NULL, NULL, 'PH_DGK_type2', NULL, 'PH_DGK_type2', NULL, NULL, NULL, 2),
(10834, NULL, 'cd11005', NULL, NULL, 'M35_like', NULL, 'M35_like', NULL, NULL, NULL, 2),
(10835, NULL, 'cd18775', NULL, NULL, 'SafA-like', NULL, 'SafA-like', NULL, NULL, 15214, 2),
(10836, NULL, 'cd17665', NULL, NULL, 'DSP_DUSP11', NULL, 'DSP_DUSP11', NULL, NULL, NULL, 2),
(10837, NULL, 'cd14682', NULL, NULL, 'PH-EXOC1_like', NULL, 'PH-EXOC1_like', NULL, NULL, NULL, 2),
(10838, NULL, 'cd10571', NULL, NULL, 'PH_beta_spectrin', NULL, 'PH_beta_spectrin', NULL, NULL, NULL, 2),
(10839, NULL, 'cd16678', NULL, NULL, 'RING2-H2_RNF32', NULL, 'RING2-H2_RNF32', NULL, NULL, NULL, 2),
(10840, NULL, 'cd01278', NULL, NULL, 'aprataxin_related', NULL, 'aprataxin_related', NULL, NULL, NULL, 2),
(10841, NULL, 'cd17267', NULL, NULL, 'RMtype1_S_EcoAO83I-TRD1-CR1_like', NULL, 'RMtype1_S_EcoAO83I-TRD1-CR1_like', NULL, NULL, NULL, 2),
(10842, NULL, 'cd00145', NULL, NULL, 'POLBc', NULL, 'POLBc', NULL, NULL, NULL, 2),
(10843, NULL, 'cd12616', NULL, NULL, 'RRM1_TIAR', NULL, 'RRM1_TIAR', NULL, NULL, 32490, 2),
(10844, NULL, 'cd02245', NULL, NULL, 'cupin_7S_vicilin-like_C', NULL, 'cupin_7S_vicilin-like_C', NULL, NULL, NULL, 2),
(10845, NULL, 'cd14004', NULL, NULL, 'STKc_PASK', NULL, 'STKc_PASK', NULL, NULL, NULL, 2),
(10846, NULL, 'cd11476', NULL, NULL, 'SLC5sbd_DUR3', NULL, 'SLC5sbd_DUR3', NULL, NULL, NULL, 2),
(10847, NULL, 'cd14539', NULL, NULL, 'PTP-N23', NULL, 'PTP-N23', NULL, NULL, NULL, 2);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(10848, NULL, 'cd04703', NULL, NULL, 'Asparaginase_2_like_1', NULL, 'Asparaginase_2_like_1', NULL, NULL, NULL, 2),
(10849, NULL, 'cd18595', NULL, NULL, 'ABC_6TM_MRP1_2_3_6_D1_like', NULL, 'ABC_6TM_MRP1_2_3_6_D1_like', NULL, NULL, NULL, 2),
(10850, NULL, 'cd15866', NULL, NULL, 'R-SNARE_SEC22', NULL, 'R-SNARE_SEC22', NULL, NULL, NULL, 2),
(10851, NULL, 'cd06110', NULL, NULL, 'BSuCS-II_like', NULL, 'BSuCS-II_like', NULL, NULL, NULL, 2),
(10852, NULL, 'cd07050', NULL, NULL, 'BMC_EutL_repeat2', NULL, 'BMC_EutL_repeat2', NULL, NULL, NULL, 2),
(10853, NULL, 'cd16186', NULL, NULL, 'EFh_PEF_grancalcin', NULL, 'EFh_PEF_grancalcin', NULL, NULL, NULL, 2),
(10854, NULL, 'cd15238', NULL, NULL, '7tm_ARII-like', NULL, '7tm_ARII-like', NULL, NULL, NULL, 2),
(10855, NULL, 'cd09391', NULL, NULL, 'LIM1_Lrg1p_like', NULL, 'LIM1_Lrg1p_like', NULL, NULL, NULL, 2),
(10856, NULL, 'cd11899', NULL, NULL, 'SH3_Nck2_1', NULL, 'SH3_Nck2_1', NULL, NULL, 33186, 2),
(10857, NULL, 'cd16598', NULL, NULL, 'RING-HC_TRIM26_C-IV', NULL, 'RING-HC_TRIM26_C-IV', NULL, NULL, NULL, 2),
(10858, NULL, 'cd01057', NULL, NULL, 'AAMH_A', NULL, 'AAMH_A', NULL, NULL, NULL, 2),
(10859, NULL, 'cd05502', NULL, NULL, 'Bromo_tif1_like', NULL, 'Bromo_tif1_like', NULL, NULL, NULL, 2),
(10860, NULL, 'cd00233', NULL, NULL, 'VIP2', NULL, 'VIP2', NULL, NULL, NULL, 2),
(10861, NULL, 'cd06944', NULL, NULL, 'NR_LBD_Ftz-F1_like', NULL, 'NR_LBD_Ftz-F1_like', NULL, NULL, NULL, 2),
(10862, NULL, 'cd05260', NULL, NULL, 'GDP_MD_SDR_e', NULL, 'GDP_MD_SDR_e', NULL, NULL, NULL, 2),
(10863, NULL, 'cd18481', NULL, NULL, 'BACK_KBTBD4', NULL, 'BACK_KBTBD4', NULL, NULL, 35658, 2),
(10864, NULL, 'cd13753', NULL, NULL, 'TGF_beta_TGFbeta1_2_3', NULL, 'TGF_beta_TGFbeta1_2_3', NULL, NULL, NULL, 2),
(10865, NULL, 'cd05904', NULL, NULL, '4CL', NULL, '4CL', NULL, NULL, NULL, 2),
(10866, NULL, 'cd09079', NULL, NULL, 'RgfB-like', NULL, 'RgfB-like', NULL, NULL, NULL, 2),
(10867, NULL, 'cd18892', NULL, NULL, 'TET', NULL, 'TET', NULL, NULL, NULL, 2),
(10868, NULL, 'cd05774', NULL, NULL, 'Ig_CEACAM_D1', NULL, 'Ig_CEACAM_D1', NULL, NULL, NULL, 2),
(10869, NULL, 'cd08230', NULL, NULL, 'glucose_DH', NULL, 'glucose_DH', NULL, NULL, NULL, 2),
(10870, NULL, 'cd02699', NULL, NULL, 'M4_M36', NULL, 'M4_M36', NULL, NULL, NULL, 2),
(10871, NULL, 'cd01161', NULL, NULL, 'VLCAD', NULL, 'VLCAD', NULL, NULL, NULL, 2),
(10872, NULL, 'cd04517', NULL, NULL, 'TLF', NULL, 'TLF', NULL, NULL, 8800, 2),
(10873, NULL, 'cd12288', NULL, NULL, 'RRM_La_like_plant', NULL, 'RRM_La_like_plant', NULL, NULL, 12676, 2),
(10874, NULL, 'cd01071', NULL, NULL, 'PBP2_PhnD_like', NULL, 'PBP2_PhnD_like', NULL, NULL, NULL, 2),
(10875, NULL, 'cd17782', NULL, NULL, 'CBS_pair_MUG70_2', NULL, 'CBS_pair_MUG70_2', NULL, NULL, NULL, 2),
(10876, NULL, 'cd10459', NULL, NULL, 'PUB_PNGase', NULL, 'PUB_PNGase', NULL, NULL, NULL, 2),
(10877, NULL, 'cd16680', NULL, NULL, 'RING-H2_RNF44', NULL, 'RING-H2_RNF44', NULL, NULL, NULL, 2),
(10878, NULL, 'cd09668', NULL, NULL, 'Csx1_III-U', NULL, 'Csx1_III-U', NULL, NULL, NULL, 2),
(10879, NULL, 'cd14972', NULL, NULL, '7tmA_EDG-like', NULL, '7tmA_EDG-like', NULL, NULL, NULL, 2),
(10880, NULL, 'cd17624', NULL, NULL, 'REC_OmpR_PmrA-like', NULL, 'REC_OmpR_PmrA-like', NULL, NULL, NULL, 2),
(10881, NULL, 'cd08964', NULL, NULL, 'L-asparaginase_II', NULL, 'L-asparaginase_II', NULL, NULL, 737, 2),
(10882, NULL, 'cd15185', NULL, NULL, '7tmA_CCR3', NULL, '7tmA_CCR3', NULL, NULL, NULL, 2),
(10883, NULL, 'cd01061', NULL, NULL, 'RNase_T2_euk', NULL, 'RNase_T2_euk', NULL, NULL, 32539, 2),
(10884, NULL, 'cd09612', NULL, NULL, 'Jacalin', NULL, 'Jacalin', NULL, NULL, 27208, 2),
(10885, NULL, 'cd14490', NULL, NULL, 'CBM6-CBM35-CBM36_like_1', NULL, 'CBM6-CBM35-CBM36_like_1', NULL, NULL, 29209, 2),
(10886, NULL, 'cd00641', NULL, NULL, 'GTP_cyclohydro2', NULL, 'GTP_cyclohydro2', NULL, NULL, 3494, 2),
(10887, NULL, 'cd06407', NULL, NULL, 'PB1_NLP', NULL, 'PB1_NLP', NULL, NULL, 29769, 2),
(10888, NULL, 'cd01379', NULL, NULL, 'MYSc_Myo3', NULL, 'MYSc_Myo3', NULL, NULL, 31085, 2),
(10889, NULL, 'cd09897', NULL, NULL, 'H3TH_FEN1-XPG-like', NULL, 'H3TH_FEN1-XPG-like', NULL, NULL, NULL, 2);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(10890, NULL, 'cd19433', NULL, NULL, 'lipocalin_CpcS-CpeS', NULL, 'lipocalin_CpcS-CpeS', NULL, NULL, NULL, 2),
(10891, NULL, 'cd14329', NULL, NULL, 'UBA_SWA2p_like', NULL, 'UBA_SWA2p_like', NULL, NULL, 10896, 2),
(10892, NULL, 'cd17561', NULL, NULL, 'REC_Spo0A', NULL, 'REC_Spo0A', NULL, NULL, NULL, 2),
(10893, NULL, 'cd09948', NULL, NULL, 'Ebola_RSV-like_HR1-HR2', NULL, 'Ebola_RSV-like_HR1-HR2', NULL, NULL, NULL, 2),
(10894, NULL, 'cd11345', NULL, NULL, 'AmyAc_SLC3A2', NULL, 'AmyAc_SLC3A2', NULL, NULL, NULL, 2),
(10895, NULL, 'cd11538', NULL, NULL, 'NTP-PPase_u1', NULL, 'NTP-PPase_u1', NULL, NULL, NULL, 2),
(10896, NULL, 'cd05673', NULL, NULL, 'M20_Acy1L2_AbgB', NULL, 'M20_Acy1L2_AbgB', NULL, NULL, NULL, 2),
(10897, NULL, 'cd17066', NULL, NULL, 'Ubl_KPC2', NULL, 'Ubl_KPC2', NULL, NULL, NULL, 2),
(10898, NULL, 'cd03266', NULL, NULL, 'ABC_NatA_sodium_exporter', NULL, 'ABC_NatA_sodium_exporter', NULL, NULL, NULL, 2),
(10899, NULL, 'cd08993', NULL, NULL, 'GH130', NULL, 'GH130', NULL, NULL, NULL, 2),
(10900, NULL, 'cd02980', NULL, NULL, 'TRX_Fd_family', NULL, 'TRX_Fd_family', NULL, NULL, NULL, 2),
(10901, NULL, 'cd17548', NULL, NULL, 'REC_DivK-like', NULL, 'REC_DivK-like', NULL, NULL, NULL, 2),
(10902, NULL, 'cd07178', NULL, NULL, 'terB_like_YebE', NULL, 'terB_like_YebE', NULL, NULL, 10137, 2),
(10903, NULL, 'cd12091', NULL, NULL, 'FANCM_ID', NULL, 'FANCM_ID', NULL, NULL, NULL, 2),
(10904, NULL, 'cd12932', NULL, NULL, 'RRP7_like', NULL, 'RRP7_like', NULL, NULL, NULL, 2),
(10905, NULL, 'cd05331', NULL, NULL, 'DH-DHB-DH_SDR_c', NULL, 'DH-DHB-DH_SDR_c', NULL, NULL, 117, 2),
(10906, NULL, 'cd01240', NULL, NULL, 'PH_GRK2_subgroup', NULL, 'PH_GRK2_subgroup', NULL, NULL, NULL, 2),
(10907, NULL, 'cd14864', NULL, NULL, 'Fe-ADH-like', NULL, 'Fe-ADH-like', NULL, NULL, NULL, 2),
(10908, NULL, 'cd15515', NULL, NULL, 'PHD1_KDM5A_like', NULL, 'PHD1_KDM5A_like', NULL, NULL, NULL, 2),
(10909, NULL, 'cd01015', NULL, NULL, 'CSHase', NULL, 'CSHase', NULL, NULL, NULL, 2),
(10910, NULL, 'cd06147', NULL, NULL, 'Rrp6p_like_exo', NULL, 'Rrp6p_like_exo', NULL, NULL, NULL, 2),
(10911, NULL, 'cd14052', NULL, NULL, 'PTKc_Wee1_fungi', NULL, 'PTKc_Wee1_fungi', NULL, NULL, NULL, 2),
(10912, NULL, 'cd18351', NULL, NULL, 'BTB_POZ_BTBD11', NULL, 'BTB_POZ_BTBD11', NULL, NULL, NULL, 2),
(10913, NULL, 'cd15915', NULL, NULL, '7tmA_OR12D-like', NULL, '7tmA_OR12D-like', NULL, NULL, NULL, 2),
(10914, NULL, 'cd10157', NULL, NULL, 'BsCsoR-like_DUF156', NULL, 'BsCsoR-like_DUF156', NULL, NULL, NULL, 2),
(10915, NULL, 'cd07906', NULL, NULL, 'Adenylation_DNA_ligase_LigD_LigC', NULL, 'Adenylation_DNA_ligase_LigD_LigC', NULL, NULL, NULL, 2),
(10916, NULL, 'cd08857', NULL, NULL, 'ArfGap_AGFG1', NULL, 'ArfGap_AGFG1', NULL, NULL, NULL, 2),
(10917, NULL, 'cd12298', NULL, NULL, 'RRM3_Prp24', NULL, 'RRM3_Prp24', NULL, NULL, NULL, 2),
(10918, NULL, 'cd03134', NULL, NULL, 'GATase1_PfpI_like', NULL, 'GATase1_PfpI_like', NULL, NULL, NULL, 2),
(10919, NULL, 'cd16105', NULL, NULL, 'Ubl_ASPSCR1_like', NULL, 'Ubl_ASPSCR1_like', NULL, NULL, NULL, 2),
(10920, NULL, 'cd13677', NULL, NULL, 'PBP2_TRAP_SBP_like_6', NULL, 'PBP2_TRAP_SBP_like_6', NULL, NULL, NULL, 2),
(10921, NULL, 'cd19105', NULL, NULL, 'AKR_unchar', NULL, 'AKR_unchar', NULL, NULL, NULL, 2),
(10922, NULL, 'cd03297', NULL, NULL, 'ABC_ModC_molybdenum_transporter', NULL, 'ABC_ModC_molybdenum_transporter', NULL, NULL, NULL, 2),
(10923, NULL, 'cd19450', NULL, NULL, 'lipocalin_ApoM', NULL, 'lipocalin_ApoM', NULL, NULL, NULL, 2),
(10924, NULL, 'cd14181', NULL, NULL, 'STKc_PhKG2', NULL, 'STKc_PhKG2', NULL, NULL, NULL, 2),
(10925, NULL, 'cd02511', NULL, NULL, 'Beta4Glucosyltransferase', NULL, 'Beta4Glucosyltransferase', NULL, NULL, NULL, 2),
(10926, NULL, 'cd19688', NULL, NULL, 'bHLHzip_MLXIP', NULL, 'bHLHzip_MLXIP', NULL, NULL, NULL, 2),
(10927, NULL, 'cd03186', NULL, NULL, 'GST_C_SspA', NULL, 'GST_C_SspA', NULL, NULL, 20515, 2),
(10928, NULL, 'cd11632', NULL, NULL, 'HR1_PKN3_2', NULL, 'HR1_PKN3_2', NULL, NULL, NULL, 2),
(10929, NULL, 'cd16657', NULL, NULL, 'RING-Ubox_UBE4A', NULL, 'RING-Ubox_UBE4A', NULL, NULL, NULL, 2);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(10930, NULL, 'cd02598', NULL, NULL, 'HAD_BPGM', NULL, 'HAD_BPGM', NULL, NULL, 2305, 2),
(10931, NULL, 'cd06178', NULL, NULL, 'MFS_unc93-like', NULL, 'MFS_unc93-like', NULL, NULL, NULL, 2),
(10932, NULL, 'cd12254', NULL, NULL, 'RRM_hnRNPH_ESRPs_RBM12_like', NULL, 'RRM_hnRNPH_ESRPs_RBM12_like', NULL, NULL, NULL, 2),
(10933, NULL, 'cd16762', NULL, NULL, 'RING-HC_TRIM13_C-V', NULL, 'RING-HC_TRIM13_C-V', NULL, NULL, NULL, 2),
(10934, NULL, 'cd09950', NULL, NULL, 'ENVV1-like_HR1-HR2', NULL, 'ENVV1-like_HR1-HR2', NULL, NULL, NULL, 2),
(10935, NULL, 'cd14874', NULL, NULL, 'MYSc_Myo12', NULL, 'MYSc_Myo12', NULL, NULL, NULL, 2),
(10936, NULL, 'cd03723', NULL, NULL, 'SOCS_ASB4_ASB18', NULL, 'SOCS_ASB4_ASB18', NULL, NULL, NULL, 2),
(10937, NULL, 'cd11641', NULL, NULL, 'Precorrin-4_C11-MT', NULL, 'Precorrin-4_C11-MT', NULL, NULL, 5602, 2),
(10938, NULL, 'cd11664', NULL, NULL, 'LamB_YcsF_like_2', NULL, 'LamB_YcsF_like_2', NULL, NULL, NULL, 2),
(10939, NULL, 'cd14558', NULL, NULL, 'R-PTP-C-2', NULL, 'R-PTP-C-2', NULL, NULL, NULL, 2),
(10940, NULL, 'cd10279', NULL, NULL, 'PQQ_ADH_II', NULL, 'PQQ_ADH_II', NULL, NULL, NULL, 2),
(10941, NULL, 'cd16751', NULL, NULL, 'RING-HC_SIAH1', NULL, 'RING-HC_SIAH1', NULL, NULL, NULL, 2),
(10942, NULL, 'cd04263', NULL, NULL, 'DUF619-NAGK-FABP', NULL, 'DUF619-NAGK-FABP', NULL, NULL, NULL, 2),
(10943, NULL, 'cd16170', NULL, NULL, 'MvaT_DBD', NULL, 'MvaT_DBD', NULL, NULL, 29232, 2),
(10944, NULL, 'cd16150', NULL, NULL, 'sulfatase_like', NULL, 'sulfatase_like', NULL, NULL, NULL, 2),
(10945, NULL, 'cd14826', NULL, NULL, 'SR_alpha_SRX', NULL, 'SR_alpha_SRX', NULL, NULL, NULL, 2),
(10946, NULL, 'cd15978', NULL, NULL, '7tmA_CCK-AR', NULL, '7tmA_CCK-AR', NULL, NULL, NULL, 2),
(10947, NULL, 'cd04817', NULL, NULL, 'PA_VapT_like', NULL, 'PA_VapT_like', NULL, NULL, NULL, 2),
(10948, NULL, 'cd00981', NULL, NULL, 'arch_gltB', NULL, 'arch_gltB', NULL, NULL, 33428, 2),
(10949, NULL, 'cd13161', NULL, NULL, 'PTB_TK_HMTK', NULL, 'PTB_TK_HMTK', NULL, NULL, NULL, 2),
(10950, NULL, 'cd11301', NULL, NULL, 'Fut1_Fut2_like', NULL, 'Fut1_Fut2_like', NULL, NULL, NULL, 2),
(10951, NULL, 'cd18114', NULL, NULL, 'ATP-synt_flagellum-secretory_path_III_C', NULL, 'ATP-synt_flagellum-secretory_path_III_C', NULL, NULL, NULL, 2),
(10952, NULL, 'cd01776', NULL, NULL, 'RA_Rin', NULL, 'RA_Rin', NULL, NULL, NULL, 2),
(10953, NULL, 'cd08170', NULL, NULL, 'GlyDH', NULL, 'GlyDH', NULL, NULL, NULL, 2),
(10954, NULL, 'cd07528', NULL, NULL, 'HAD_CbbY-like', NULL, 'HAD_CbbY-like', NULL, NULL, NULL, 2),
(10955, NULL, 'cd13834', NULL, NULL, 'HU_like', NULL, 'HU_like', NULL, NULL, NULL, 2),
(10956, NULL, 'cd10569', NULL, NULL, 'FERM_C_Talin', NULL, 'FERM_C_Talin', NULL, NULL, NULL, 2),
(10957, NULL, 'cd14518', NULL, NULL, 'DSP_fungal_YVH1', NULL, 'DSP_fungal_YVH1', NULL, NULL, NULL, 2),
(10958, NULL, 'cd15093', NULL, NULL, '7tmA_SSTR', NULL, '7tmA_SSTR', NULL, NULL, NULL, 2),
(10959, NULL, 'cd11640', NULL, NULL, 'HutP', NULL, 'HutP', NULL, NULL, NULL, 2),
(10960, NULL, 'cd12935', NULL, NULL, 'LEM_like', NULL, 'LEM_like', NULL, NULL, NULL, 2),
(10961, NULL, 'cd16969', NULL, NULL, 'Alpha_kinase_ALPK1', NULL, 'Alpha_kinase_ALPK1', NULL, NULL, NULL, 2),
(10962, NULL, 'cd07984', NULL, NULL, 'LPLAT_LABLAT-like', NULL, 'LPLAT_LABLAT-like', NULL, NULL, 2780, 2),
(10963, NULL, 'cd08333', NULL, NULL, 'DED_Caspase_8_r1', NULL, 'DED_Caspase_8_r1', NULL, NULL, NULL, 2),
(10964, NULL, 'cd06237', NULL, NULL, 'M14_Nna1-like', NULL, 'M14_Nna1-like', NULL, NULL, NULL, 2),
(10965, NULL, 'cd13166', NULL, NULL, 'PTB_CCM2', NULL, 'PTB_CCM2', NULL, NULL, NULL, 2),
(10966, NULL, 'cd07250', NULL, NULL, 'HPPD_C_like', NULL, 'HPPD_C_like', NULL, NULL, 29738, 2),
(10967, NULL, 'cd12620', NULL, NULL, 'RRM3_TIAR', NULL, 'RRM3_TIAR', NULL, NULL, 32035, 2),
(10968, NULL, 'cd03865', NULL, NULL, 'M14_CPE', NULL, 'M14_CPE', NULL, NULL, 22704, 2),
(10969, NULL, 'cd18223', NULL, NULL, 'BTB_POZ_ZBTB38_CIBZ', NULL, 'BTB_POZ_ZBTB38_CIBZ', NULL, NULL, NULL, 2),
(10970, NULL, 'cd16026', NULL, NULL, 'GALNS_like', NULL, 'GALNS_like', NULL, NULL, NULL, 2),
(10971, NULL, 'cd19027', NULL, NULL, 'LGIC_ECD_nAChR_B4', NULL, 'LGIC_ECD_nAChR_B4', NULL, NULL, NULL, 2);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(10972, NULL, 'cd15354', NULL, NULL, '7tmA_MC5R', NULL, '7tmA_MC5R', NULL, NULL, NULL, 2),
(10973, NULL, 'cd15338', NULL, NULL, '7tmA_MCHR1', NULL, '7tmA_MCHR1', NULL, NULL, NULL, 2),
(10974, NULL, 'cd12163', NULL, NULL, '2-Hacid_dh_5', NULL, '2-Hacid_dh_5', NULL, NULL, NULL, 2),
(10975, NULL, 'cd01007', NULL, NULL, 'PBP2_BvgS_HisK_like', NULL, 'PBP2_BvgS_HisK_like', NULL, NULL, NULL, 2),
(10976, NULL, 'cd08876', NULL, NULL, 'START_1', NULL, 'START_1', NULL, NULL, 26985, 2),
(10977, NULL, 'cd17055', NULL, NULL, 'Ubl_AtNPL4_like', NULL, 'Ubl_AtNPL4_like', NULL, NULL, NULL, 2),
(10978, NULL, 'cd09124', NULL, NULL, 'PLDc_like_TrmB_middle', NULL, 'PLDc_like_TrmB_middle', NULL, NULL, NULL, 2),
(10979, NULL, 'cd01217', NULL, NULL, 'PTB_CG12581', NULL, 'PTB_CG12581', NULL, NULL, NULL, 2),
(10980, NULL, 'cd09753', NULL, NULL, 'Cas5_I-A', NULL, 'Cas5_I-A', NULL, NULL, NULL, 2),
(10981, NULL, 'cd19212', NULL, NULL, 'SET_NSD3', NULL, 'SET_NSD3', NULL, NULL, NULL, 2),
(10982, NULL, 'cd12659', NULL, NULL, 'RRM2_hnRNPM', NULL, 'RRM2_hnRNPM', NULL, NULL, NULL, 2),
(10983, NULL, 'cd08968', NULL, NULL, 'MeNeil2_N', NULL, 'MeNeil2_N', NULL, NULL, NULL, 2),
(10984, NULL, 'cd17086', NULL, NULL, 'RAWUL_RING1_like', NULL, 'RAWUL_RING1_like', NULL, NULL, NULL, 2),
(10985, NULL, 'cd17871', NULL, NULL, 'GPN2', NULL, 'GPN2', NULL, NULL, NULL, 2),
(10986, NULL, 'cd07944', NULL, NULL, 'DRE_TIM_HOA_like', NULL, 'DRE_TIM_HOA_like', NULL, NULL, NULL, 2),
(10987, NULL, 'cd02736', NULL, NULL, 'RNAP_III_Rpc1_C', NULL, 'RNAP_III_Rpc1_C', NULL, NULL, 31314, 2),
(10988, NULL, 'cd19852', NULL, NULL, 'FABP_pancrustacea', NULL, 'FABP_pancrustacea', NULL, NULL, NULL, 2),
(10989, NULL, 'cd12022', NULL, NULL, 'SH3_p47phox_2', NULL, 'SH3_p47phox_2', NULL, NULL, 30445, 2),
(10990, NULL, 'cd04437', NULL, NULL, 'DEP_Epac', NULL, 'DEP_Epac', NULL, NULL, NULL, 2),
(10991, NULL, 'cd01906', NULL, NULL, 'proteasome_protease_HslV', NULL, 'proteasome_protease_HslV', NULL, NULL, NULL, 2),
(10992, NULL, 'cd11440', NULL, NULL, 'bHLH-O_Cwo_like', NULL, 'bHLH-O_Cwo_like', NULL, NULL, NULL, 2),
(10993, NULL, 'cd15622', NULL, NULL, 'PHD_TIF1alpha', NULL, 'PHD_TIF1alpha', NULL, NULL, NULL, 2),
(10994, NULL, 'cd10463', NULL, NULL, 'PUB_WLM', NULL, 'PUB_WLM', NULL, NULL, NULL, 2),
(10995, NULL, 'cd08932', NULL, NULL, 'HetN_like_SDR_c', NULL, 'HetN_like_SDR_c', NULL, NULL, NULL, 2),
(10996, NULL, 'cd04891', NULL, NULL, 'ACT_AK-LysC-DapG-like_1', NULL, 'ACT_AK-LysC-DapG-like_1', NULL, NULL, NULL, 2),
(10997, NULL, 'cd16672', NULL, NULL, 'RING-H2_DTX2', NULL, 'RING-H2_DTX2', NULL, NULL, NULL, 2),
(10998, NULL, 'cd13888', NULL, NULL, 'CuRO_3_McoP_like', NULL, 'CuRO_3_McoP_like', NULL, NULL, NULL, 2),
(10999, NULL, 'cd09996', NULL, NULL, 'HDAC_classII_1', NULL, 'HDAC_classII_1', NULL, NULL, NULL, 2),
(11000, NULL, 'cd00296', NULL, NULL, 'SIR2', NULL, 'SIR2', NULL, NULL, NULL, 2),
(11001, NULL, 'cd01096', NULL, NULL, 'Alkanal_monooxygenase', NULL, 'Alkanal_monooxygenase', NULL, NULL, 26650, 2),
(11002, NULL, 'cd07854', NULL, NULL, 'STKc_MAPK4_6', NULL, 'STKc_MAPK4_6', NULL, NULL, NULL, 2),
(11003, NULL, 'cd14534', NULL, NULL, 'PTP-MTMR5-like', NULL, 'PTP-MTMR5-like', NULL, NULL, NULL, 2),
(11004, NULL, 'cd12322', NULL, NULL, 'RRM2_TDP43', NULL, 'RRM2_TDP43', NULL, NULL, NULL, 2),
(11005, NULL, 'cd14289', NULL, NULL, 'UBA_RHBD3', NULL, 'UBA_RHBD3', NULL, NULL, NULL, 2),
(11006, NULL, 'cd19713', NULL, NULL, 'bHLH_TS_ATOH1', NULL, 'bHLH_TS_ATOH1', NULL, NULL, NULL, 2),
(11007, NULL, 'cd11841', NULL, NULL, 'SH3_SH3YL1_like', NULL, 'SH3_SH3YL1_like', NULL, NULL, 17901, 2),
(11008, NULL, 'cd19149', NULL, NULL, 'AKR_AKR11B2', NULL, 'AKR_AKR11B2', NULL, NULL, NULL, 2),
(11009, NULL, 'cd21477', NULL, NULL, 'SARS-CoV-like_Spike_S1_RBD', NULL, 'SARS-CoV-like_Spike_S1_RBD', NULL, NULL, NULL, 2),
(11010, NULL, 'cd09854', NULL, NULL, 'PIN_VapC-like', NULL, 'PIN_VapC-like', NULL, NULL, NULL, 2),
(11011, NULL, 'cd11660', NULL, NULL, 'SANT_TRF', NULL, 'SANT_TRF', NULL, NULL, NULL, 2),
(11012, NULL, 'cd18271', NULL, NULL, 'BTB_POZ_KBTBD3_BKLHD3', NULL, 'BTB_POZ_KBTBD3_BKLHD3', NULL, NULL, NULL, 2);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(11013, NULL, 'cd06814', NULL, NULL, 'PLPDE_III_DSD_D-TA_like_3', NULL, 'PLPDE_III_DSD_D-TA_like_3', NULL, NULL, NULL, 2),
(11014, NULL, 'cd03150', NULL, NULL, 'alpha_CA_IX', NULL, 'alpha_CA_IX', NULL, NULL, NULL, 2),
(11015, NULL, 'cd16403', NULL, NULL, 'ParB_N_like_MT', NULL, 'ParB_N_like_MT', NULL, NULL, NULL, 2),
(11016, NULL, 'cd18560', NULL, NULL, 'ABC_6TM_ATM1_ABCB7_HMT1_ABCB6', NULL, 'ABC_6TM_ATM1_ABCB7_HMT1_ABCB6', NULL, NULL, NULL, 2),
(11017, NULL, 'cd03276', NULL, NULL, 'ABC_SMC6_euk', NULL, 'ABC_SMC6_euk', NULL, NULL, NULL, 2),
(11018, NULL, 'cd11415', NULL, NULL, 'bHLH_TS_FERD3L_NATO3', NULL, 'bHLH_TS_FERD3L_NATO3', NULL, NULL, NULL, 2),
(11019, NULL, 'cd17439', NULL, NULL, 'MFS_SV2A', NULL, 'MFS_SV2A', NULL, NULL, NULL, 2),
(11020, NULL, 'cd15738', NULL, NULL, 'FYVE_MTMR_unchar', NULL, 'FYVE_MTMR_unchar', NULL, NULL, NULL, 2),
(11021, NULL, 'cd02421', NULL, NULL, 'Peptidase_C39_likeD', NULL, 'Peptidase_C39_likeD', NULL, NULL, NULL, 2),
(11022, NULL, 'cd01594', NULL, NULL, 'Lyase_I_like', NULL, 'Lyase_I_like', NULL, NULL, NULL, 2),
(11023, NULL, 'cd13537', NULL, NULL, 'PBP2_YvgL_like', NULL, 'PBP2_YvgL_like', NULL, NULL, 30001, 2),
(11024, NULL, 'cd04670', NULL, NULL, 'Nudix_Hydrolase_12', NULL, 'Nudix_Hydrolase_12', NULL, NULL, NULL, 2),
(11025, NULL, 'cd04378', NULL, NULL, 'RhoGAP_GMIP_PARG1', NULL, 'RhoGAP_GMIP_PARG1', NULL, NULL, NULL, 2),
(11026, NULL, 'cd17023', NULL, NULL, 'T3SC_IA_CesT-like', NULL, 'T3SC_IA_CesT-like', NULL, NULL, NULL, 2),
(11027, NULL, 'cd13706', NULL, NULL, 'PBP2_HisK_like_1', NULL, 'PBP2_HisK_like_1', NULL, NULL, NULL, 2),
(11028, NULL, 'cd13335', NULL, NULL, 'FERM_C_TYK2', NULL, 'FERM_C_TYK2', NULL, NULL, NULL, 2),
(11029, NULL, 'cd09076', NULL, NULL, 'L1-EN', NULL, 'L1-EN', NULL, NULL, NULL, 2),
(11030, NULL, 'cd16856', NULL, NULL, 'STAT6_CCD', NULL, 'STAT6_CCD', NULL, NULL, NULL, 2),
(11031, NULL, 'cd07235', NULL, NULL, 'MRD', NULL, 'MRD', NULL, NULL, NULL, 2),
(11032, NULL, 'cd19794', NULL, NULL, 'Bbox2_TRIM66-like', NULL, 'Bbox2_TRIM66-like', NULL, NULL, NULL, 2),
(11033, NULL, 'cd12016', NULL, NULL, 'SH3_Tks_2', NULL, 'SH3_Tks_2', NULL, NULL, NULL, 2),
(11034, NULL, 'cd17783', NULL, NULL, 'CBS_pair_bac', NULL, 'CBS_pair_bac', NULL, NULL, NULL, 2),
(11035, NULL, 'cd08471', NULL, NULL, 'PBP2_CrgA_like_2', NULL, 'PBP2_CrgA_like_2', NULL, NULL, NULL, 2),
(11036, NULL, 'cd00329', NULL, NULL, 'TopoII_MutL_Trans', NULL, 'TopoII_MutL_Trans', NULL, NULL, NULL, 2),
(11037, NULL, 'cd04971', NULL, NULL, 'Ig_TrKABC_d5', NULL, 'Ig_TrKABC_d5', NULL, NULL, NULL, 2),
(11038, NULL, 'cd03237', NULL, NULL, 'ABC_RNaseL_inhibitor_domain2', NULL, 'ABC_RNaseL_inhibitor_domain2', NULL, NULL, NULL, 2),
(11039, NULL, 'cd04705', NULL, NULL, 'PLA2_group_III_like', NULL, 'PLA2_group_III_like', NULL, NULL, NULL, 2),
(11040, NULL, 'cd06664', NULL, NULL, 'IscU_like', NULL, 'IscU_like', NULL, NULL, 5732, 2),
(11041, NULL, 'cd14412', NULL, NULL, 'UBA_DCNL2', NULL, 'UBA_DCNL2', NULL, NULL, NULL, 2),
(11042, NULL, 'cd08923', NULL, NULL, 'class1-2_nsHbs_Lbs', NULL, 'class1-2_nsHbs_Lbs', NULL, NULL, NULL, 2),
(11043, NULL, 'cd06109', NULL, NULL, 'BsCS-I_like', NULL, 'BsCS-I_like', NULL, NULL, NULL, 2),
(11044, NULL, 'cd06201', NULL, NULL, 'SiR_like2', NULL, 'SiR_like2', NULL, NULL, NULL, 2),
(11045, NULL, 'cd12737', NULL, NULL, 'RRM1_ESRP2', NULL, 'RRM1_ESRP2', NULL, NULL, NULL, 2),
(11046, NULL, 'cd03804', NULL, NULL, 'GT4_WbaZ-like', NULL, 'GT4_WbaZ-like', NULL, NULL, NULL, 2),
(11047, NULL, 'cd16204', NULL, NULL, 'EFh_PI-PLCzeta', NULL, 'EFh_PI-PLCzeta', NULL, NULL, NULL, 2),
(11048, NULL, 'cd01870', NULL, NULL, 'RhoA_like', NULL, 'RhoA_like', NULL, NULL, NULL, 2),
(11049, NULL, 'cd12358', NULL, NULL, 'RRM1_VICKZ', NULL, 'RRM1_VICKZ', NULL, NULL, NULL, 2),
(11050, NULL, 'cd07106', NULL, NULL, 'ALDH_AldA-AAD23400', NULL, 'ALDH_AldA-AAD23400', NULL, NULL, 34972, 2),
(11051, NULL, 'cd08603', NULL, NULL, 'GDPD_SHV3_repeat_1', NULL, 'GDPD_SHV3_repeat_1', NULL, NULL, NULL, 2),
(11052, NULL, 'cd10965', NULL, NULL, 'CE4_IcaB_5s', NULL, 'CE4_IcaB_5s', NULL, NULL, NULL, 2),
(11053, NULL, 'cd01922', NULL, NULL, 'cyclophilin_SpCYP2_like', NULL, 'cyclophilin_SpCYP2_like', NULL, NULL, NULL, 2);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(11054, NULL, 'cd03196', NULL, NULL, 'GST_C_5', NULL, 'GST_C_5', NULL, NULL, NULL, 2),
(11055, NULL, 'cd14077', NULL, NULL, 'STKc_Kin1_2', NULL, 'STKc_Kin1_2', NULL, NULL, NULL, 2),
(11056, NULL, 'cd07161', NULL, NULL, 'NR_DBD_EcR', NULL, 'NR_DBD_EcR', NULL, NULL, NULL, 2),
(11057, NULL, 'cd10403', NULL, NULL, 'SH2_STAP1', NULL, 'SH2_STAP1', NULL, NULL, 32662, 2),
(11058, NULL, 'cd04632', NULL, NULL, 'CBS_pair_arch1_repeat2', NULL, 'CBS_pair_arch1_repeat2', NULL, NULL, NULL, 2),
(11059, NULL, 'cd07525', NULL, NULL, 'HAD_like', NULL, 'HAD_like', NULL, NULL, NULL, 2),
(11060, NULL, 'cd15504', NULL, NULL, 'PHD_PRHA_like', NULL, 'PHD_PRHA_like', NULL, NULL, 34765, 2),
(11061, NULL, 'cd12201', NULL, NULL, 'MARK2_C', NULL, 'MARK2_C', NULL, NULL, NULL, 2),
(11062, NULL, 'cd17151', NULL, NULL, 'DCX1_DCDC2C', NULL, 'DCX1_DCDC2C', NULL, NULL, NULL, 2),
(11063, NULL, 'cd17422', NULL, NULL, 'MFS_MCT7', NULL, 'MFS_MCT7', NULL, NULL, NULL, 2),
(11064, NULL, 'cd18191', NULL, NULL, 'BTB_POZ_ARMC5', NULL, 'BTB_POZ_ARMC5', NULL, NULL, NULL, 2),
(11065, NULL, 'cd00071', NULL, NULL, 'GMPK', NULL, 'GMPK', NULL, NULL, NULL, 2),
(11066, NULL, 'cd05792', NULL, NULL, 'S1_eIF1AD_like', NULL, 'S1_eIF1AD_like', NULL, NULL, NULL, 2),
(11067, NULL, 'cd00773', NULL, NULL, 'HisRS-like_core', NULL, 'HisRS-like_core', NULL, NULL, 30065, 2),
(11068, NULL, 'cd11963', NULL, NULL, 'SH3_STAM2', NULL, 'SH3_STAM2', NULL, NULL, 30856, 2),
(11069, NULL, 'cd01053', NULL, NULL, 'AOX', NULL, 'AOX', NULL, NULL, 2676, 2),
(11070, NULL, 'cd08508', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_1', NULL, 'PBP2_NikA_DppA_OppA_like_1', NULL, NULL, NULL, 2),
(11071, NULL, 'cd18311', NULL, NULL, 'BTB_POZ_CP190-like', NULL, 'BTB_POZ_CP190-like', NULL, NULL, NULL, 2),
(11072, NULL, 'cd05253', NULL, NULL, 'UDP_GE_SDE_e', NULL, 'UDP_GE_SDE_e', NULL, NULL, NULL, 2),
(11073, NULL, 'cd12018', NULL, NULL, 'SH3_Tks4_4', NULL, 'SH3_Tks4_4', NULL, NULL, 16583, 2),
(11074, NULL, 'cd12313', NULL, NULL, 'RRM1_RRM2_RBM5_like', NULL, 'RRM1_RRM2_RBM5_like', NULL, NULL, NULL, 2),
(11075, NULL, 'cd15661', NULL, NULL, 'PHD5_NSD3', NULL, 'PHD5_NSD3', NULL, NULL, NULL, 2),
(11076, NULL, 'cd13954', NULL, NULL, '7tmA_OR', NULL, '7tmA_OR', NULL, NULL, NULL, 2),
(11077, NULL, 'cd18318', NULL, NULL, 'BTB_POZ_KCTD20-like', NULL, 'BTB_POZ_KCTD20-like', NULL, NULL, NULL, 2),
(11078, NULL, 'cd21649', NULL, NULL, 'SARS-CoV_ORF3b', NULL, 'SARS-CoV_ORF3b', NULL, NULL, 20950, 2),
(11079, NULL, 'cd05576', NULL, NULL, 'STKc_RPK118_like', NULL, 'STKc_RPK118_like', NULL, NULL, 10622, 2),
(11080, NULL, 'cd18391', NULL, NULL, 'BTB_POZ_KCTD17', NULL, 'BTB_POZ_KCTD17', NULL, NULL, NULL, 2),
(11081, NULL, 'cd07865', NULL, NULL, 'STKc_CDK9', NULL, 'STKc_CDK9', NULL, NULL, NULL, 2),
(11082, NULL, 'cd11836', NULL, NULL, 'SH3_Intersectin_1', NULL, 'SH3_Intersectin_1', NULL, NULL, NULL, 2),
(11083, NULL, 'cd12320', NULL, NULL, 'RRM6_RBM19_RRM5_MRD1', NULL, 'RRM6_RBM19_RRM5_MRD1', NULL, NULL, NULL, 2),
(11084, NULL, 'cd09480', NULL, NULL, 'LIM1_CRP2', NULL, 'LIM1_CRP2', NULL, NULL, NULL, 2),
(11085, NULL, 'cd12607', NULL, NULL, 'RRM2_RBM4', NULL, 'RRM2_RBM4', NULL, NULL, 29472, 2),
(11086, NULL, 'cd16448', NULL, NULL, 'RING-H2', NULL, 'RING-H2', NULL, NULL, NULL, 2),
(11087, NULL, 'cd17308', NULL, NULL, 'PIPKc_PIP5K1C', NULL, 'PIPKc_PIP5K1C', NULL, NULL, NULL, 2),
(11088, NULL, 'cd14629', NULL, NULL, 'R-PTP-F-2', NULL, 'R-PTP-F-2', NULL, NULL, NULL, 2),
(11089, NULL, 'cd17425', NULL, NULL, 'MFS_MCT6', NULL, 'MFS_MCT6', NULL, NULL, NULL, 2),
(11090, NULL, 'cd14287', NULL, NULL, 'UBA_At3g58460_like', NULL, 'UBA_At3g58460_like', NULL, NULL, NULL, 2),
(11091, NULL, 'cd09010', NULL, NULL, 'MTAP_SsMTAPII_like_MTIP', NULL, 'MTAP_SsMTAPII_like_MTIP', NULL, NULL, 5106, 2),
(11092, NULL, 'cd12023', NULL, NULL, 'SH3_NoxO1_1', NULL, 'SH3_NoxO1_1', NULL, NULL, NULL, 2),
(11093, NULL, 'cd16907', NULL, NULL, 'YEATS_YEATS2_like', NULL, 'YEATS_YEATS2_like', NULL, NULL, NULL, 2),
(11094, NULL, 'cd04707', NULL, NULL, 'otoconin_90', NULL, 'otoconin_90', NULL, NULL, 30897, 2),
(11095, NULL, 'cd09885', NULL, NULL, 'PIN_Smg6-like', NULL, 'PIN_Smg6-like', NULL, NULL, NULL, 2); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(11096, NULL, 'cd16556', NULL, NULL, 'RING-HC_RNF183_like', NULL, 'RING-HC_RNF183_like', NULL, NULL, NULL, 2),
(11097, NULL, 'cd19736', NULL, NULL, 'bHLH-PAS_PASD1', NULL, 'bHLH-PAS_PASD1', NULL, NULL, NULL, 2),
(11098, NULL, 'cd09497', NULL, NULL, 'SAM_caskin1,2_repeat1', NULL, 'SAM_caskin1,2_repeat1', NULL, NULL, 16851, 2),
(11099, NULL, 'cd07864', NULL, NULL, 'STKc_CDK12', NULL, 'STKc_CDK12', NULL, NULL, NULL, 2),
(11100, NULL, 'cd12151', NULL, NULL, 'F1-ATPase_gamma', NULL, 'F1-ATPase_gamma', NULL, NULL, 1624, 2),
(11101, NULL, 'cd12268', NULL, NULL, 'RRM_Vip1', NULL, 'RRM_Vip1', NULL, NULL, 1434, 2),
(11102, NULL, 'cd04750', NULL, NULL, 'Commd2', NULL, 'Commd2', NULL, NULL, 29023, 2),
(11103, NULL, 'cd11331', NULL, NULL, 'AmyAc_OligoGlu_like', NULL, 'AmyAc_OligoGlu_like', NULL, NULL, NULL, 2),
(11104, NULL, 'cd13180', NULL, NULL, 'RanBD_RanBP3', NULL, 'RanBD_RanBP3', NULL, NULL, NULL, 2),
(11105, NULL, 'cd14861', NULL, NULL, 'Fe-ADH-like', NULL, 'Fe-ADH-like', NULL, NULL, NULL, 2),
(11106, NULL, 'cd04886', NULL, NULL, 'ACT_ThrD-II-like', NULL, 'ACT_ThrD-II-like', NULL, NULL, 36420, 2),
(11107, NULL, 'cd15736', NULL, NULL, 'FYVE_scVPS27p_Vac1p_like', NULL, 'FYVE_scVPS27p_Vac1p_like', NULL, NULL, NULL, 2),
(11108, NULL, 'cd01899', NULL, NULL, 'Ygr210', NULL, 'Ygr210', NULL, NULL, NULL, 2),
(11109, NULL, 'cd07019', NULL, NULL, 'S49_SppA_1', NULL, 'S49_SppA_1', NULL, NULL, 30754, 2),
(11110, NULL, 'cd05041', NULL, NULL, 'PTKc_Fes_like', NULL, 'PTKc_Fes_like', NULL, NULL, NULL, 2),
(11111, NULL, 'cd01460', NULL, NULL, 'vWA_midasin', NULL, 'vWA_midasin', NULL, NULL, NULL, 2),
(11112, NULL, 'cd12692', NULL, NULL, 'RRM2_PTBPH3', NULL, 'RRM2_PTBPH3', NULL, NULL, 32322, 2),
(11113, NULL, 'cd01627', NULL, NULL, 'HAD_TPP', NULL, 'HAD_TPP', NULL, NULL, NULL, 2),
(11114, NULL, 'cd18538', NULL, NULL, 'PFA-DSP_unk', NULL, 'PFA-DSP_unk', NULL, NULL, NULL, 2),
(11115, NULL, 'cd14193', NULL, NULL, 'STKc_MLCK4', NULL, 'STKc_MLCK4', NULL, NULL, NULL, 2),
(11116, NULL, 'cd11374', NULL, NULL, 'CE4_u10', NULL, 'CE4_u10', NULL, NULL, NULL, 2),
(11117, NULL, 'cd15351', NULL, NULL, '7tmA_MC1R', NULL, '7tmA_MC1R', NULL, NULL, NULL, 2),
(11118, NULL, 'cd18101', NULL, NULL, 'Trm10euk_A', NULL, 'Trm10euk_A', NULL, NULL, NULL, 2),
(11119, NULL, 'cd21645', NULL, NULL, 'MERS-CoV-like_ORF5', NULL, 'MERS-CoV-like_ORF5', NULL, NULL, 36151, 2),
(11120, NULL, 'cd11354', NULL, NULL, 'AmyAc_bac_CMD_like', NULL, 'AmyAc_bac_CMD_like', NULL, NULL, NULL, 2),
(11121, NULL, 'cd10971', NULL, NULL, 'CE4_DAC_u2_5s', NULL, 'CE4_DAC_u2_5s', NULL, NULL, NULL, 2),
(11122, NULL, 'cd00058', NULL, NULL, 'FGF', NULL, 'FGF', NULL, NULL, 5967, 2),
(11123, NULL, 'cd17029', NULL, NULL, 'T3SC_IA_SycE_SpcS-like', NULL, 'T3SC_IA_SycE_SpcS-like', NULL, NULL, NULL, 2),
(11124, NULL, 'cd18206', NULL, NULL, 'BTB_POZ_ZBTB17_MIZ1', NULL, 'BTB_POZ_ZBTB17_MIZ1', NULL, NULL, NULL, 2),
(11125, NULL, 'cd03817', NULL, NULL, 'GT4_UGDG-like', NULL, 'GT4_UGDG-like', NULL, NULL, NULL, 2),
(11126, NULL, 'cd16414', NULL, NULL, 'dndB_like', NULL, 'dndB_like', NULL, NULL, NULL, 2),
(11127, NULL, 'cd10338', NULL, NULL, 'SH2_SHA', NULL, 'SH2_SHA', NULL, NULL, NULL, 2),
(11128, NULL, 'cd09844', NULL, NULL, 'PLDc_vPLD1_2', NULL, 'PLDc_vPLD1_2', NULL, NULL, NULL, 2),
(11129, NULL, 'cd04196', NULL, NULL, 'GT_2_like_d', NULL, 'GT_2_like_d', NULL, NULL, NULL, 2),
(11130, NULL, 'cd09532', NULL, NULL, 'SAM_SLA1_fungal', NULL, 'SAM_SLA1_fungal', NULL, NULL, NULL, 2),
(11131, NULL, 'cd09839', NULL, NULL, 'M1_like_TAF2', NULL, 'M1_like_TAF2', NULL, NULL, NULL, 2),
(11132, NULL, 'cd08848', NULL, NULL, 'ArfGap_ASAP1', NULL, 'ArfGap_ASAP1', NULL, NULL, NULL, 2),
(11133, NULL, 'cd15317', NULL, NULL, '7tmA_TAAR5-like', NULL, '7tmA_TAAR5-like', NULL, NULL, NULL, 2),
(11134, NULL, 'cd01744', NULL, NULL, 'GATase1_CPSase', NULL, 'GATase1_CPSase', NULL, NULL, 31345, 2),
(11135, NULL, 'cd02683', NULL, NULL, 'MIT_1', NULL, 'MIT_1', NULL, NULL, 36060, 2),
(11136, NULL, 'cd13363', NULL, NULL, 'PH_PLC_delta', NULL, 'PH_PLC_delta', NULL, NULL, NULL, 2),
(11137, NULL, 'cd04211', NULL, NULL, 'Cupredoxin_like_2', NULL, 'Cupredoxin_like_2', NULL, NULL, NULL, 2);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(11138, NULL, 'cd12101', NULL, NULL, 'DD_RIalpha_PKA', NULL, 'DD_RIalpha_PKA', NULL, NULL, NULL, 2),
(11139, NULL, 'cd03711', NULL, NULL, 'Tet_C', NULL, 'Tet_C', NULL, NULL, 28853, 2),
(11140, NULL, 'cd21554', NULL, NULL, 'CoV_N-NTD', NULL, 'CoV_N-NTD', NULL, NULL, 33609, 2),
(11141, NULL, 'cd05300', NULL, NULL, '2-Hacid_dh_1', NULL, '2-Hacid_dh_1', NULL, NULL, NULL, 2),
(11142, NULL, 'cd12202', NULL, NULL, 'CASP8AP2', NULL, 'CASP8AP2', NULL, NULL, NULL, 2),
(11143, NULL, 'cd14775', NULL, NULL, 'TrHb2_O-like', NULL, 'TrHb2_O-like', NULL, NULL, NULL, 2),
(11144, NULL, 'cd09657', NULL, NULL, 'Cmr1_III-B', NULL, 'Cmr1_III-B', NULL, NULL, NULL, 2),
(11145, NULL, 'cd09243', NULL, NULL, 'BRO1_Brox_like', NULL, 'BRO1_Brox_like', NULL, NULL, NULL, 2),
(11146, NULL, 'cd14119', NULL, NULL, 'STKc_LKB1', NULL, 'STKc_LKB1', NULL, NULL, 32836, 2),
(11147, NULL, 'cd18765', NULL, NULL, 'PIN_MtVapC3-like', NULL, 'PIN_MtVapC3-like', NULL, NULL, NULL, 2),
(11148, NULL, 'cd00717', NULL, NULL, 'URO-D', NULL, 'URO-D', NULL, NULL, 5844, 2),
(11149, NULL, 'cd16764', NULL, NULL, 'RING-HC_TIF1alpha', NULL, 'RING-HC_TIF1alpha', NULL, NULL, NULL, 2),
(11150, NULL, 'cd00185', NULL, NULL, 'TNFRSF', NULL, 'TNFRSF', NULL, NULL, NULL, 2),
(11151, NULL, 'cd15652', NULL, NULL, 'PHD2_NSD3', NULL, 'PHD2_NSD3', NULL, NULL, NULL, 2),
(11152, NULL, 'cd05353', NULL, NULL, 'hydroxyacyl-CoA-like_DH_SDR_c-like', NULL, 'hydroxyacyl-CoA-like_DH_SDR_c-like', NULL, NULL, NULL, 2),
(11153, NULL, 'cd15453', NULL, NULL, '7tmC_mGluR6', NULL, '7tmC_mGluR6', NULL, NULL, NULL, 2),
(11154, NULL, 'cd06199', NULL, NULL, 'SiR', NULL, 'SiR', NULL, NULL, NULL, 2),
(11155, NULL, 'cd17485', NULL, NULL, 'MFS_MFSD3', NULL, 'MFS_MFSD3', NULL, NULL, NULL, 2),
(11156, NULL, 'cd16458', NULL, NULL, 'RING-H2_Dmap_like', NULL, 'RING-H2_Dmap_like', NULL, NULL, 35455, 2),
(11157, NULL, 'cd15248', NULL, NULL, '7tmF_FZD1_insect', NULL, '7tmF_FZD1_insect', NULL, NULL, NULL, 2),
(11158, NULL, 'cd17877', NULL, NULL, 'NP_MTAN-like', NULL, 'NP_MTAN-like', NULL, NULL, NULL, 2),
(11159, NULL, 'cd00927', NULL, NULL, 'Cyt_c_Oxidase_VIc', NULL, 'Cyt_c_Oxidase_VIc', NULL, NULL, 3897, 2),
(11160, NULL, 'cd18553', NULL, NULL, 'ABC_6TM_PglK_like', NULL, 'ABC_6TM_PglK_like', NULL, NULL, NULL, 2),
(11161, NULL, 'cd15809', NULL, NULL, 'SPRY_PRY_TRIM4', NULL, 'SPRY_PRY_TRIM4', NULL, NULL, 32200, 2),
(11162, NULL, 'cd04253', NULL, NULL, 'AAK_UMPK-PyrH-Pf', NULL, 'AAK_UMPK-PyrH-Pf', NULL, NULL, 13252, 2),
(11163, NULL, 'cd09030', NULL, NULL, 'DUF1425', NULL, 'DUF1425', NULL, NULL, 10555, 2),
(11164, NULL, 'cd14782', NULL, NULL, 'FHb-globin_2', NULL, 'FHb-globin_2', NULL, NULL, NULL, 2),
(11165, NULL, 'cd11703', NULL, NULL, 'DHR2_DOCK7', NULL, 'DHR2_DOCK7', NULL, NULL, NULL, 2),
(11166, NULL, 'cd03747', NULL, NULL, 'Ntn_PGA_like', NULL, 'Ntn_PGA_like', NULL, NULL, NULL, 2),
(11167, NULL, 'cd07182', NULL, NULL, 'RNase_HII_bacteria_HII_like', NULL, 'RNase_HII_bacteria_HII_like', NULL, NULL, 17359, 2),
(11168, NULL, 'cd01701', NULL, NULL, 'PolY_Rev1', NULL, 'PolY_Rev1', NULL, NULL, NULL, 2),
(11169, NULL, 'cd17927', NULL, NULL, 'DEXHc_RIG-I', NULL, 'DEXHc_RIG-I', NULL, NULL, NULL, 2),
(11170, NULL, 'cd04605', NULL, NULL, 'CBS_pair_arch_MET2_assoc', NULL, 'CBS_pair_arch_MET2_assoc', NULL, NULL, NULL, 2),
(11171, NULL, 'cd01150', NULL, NULL, 'AXO', NULL, 'AXO', NULL, NULL, 13988, 2),
(11172, NULL, 'cd07774', NULL, NULL, 'FGGY_1', NULL, 'FGGY_1', NULL, NULL, NULL, 2),
(11173, NULL, 'cd15021', NULL, NULL, '7tm_TAS2R10', NULL, '7tm_TAS2R10', NULL, NULL, NULL, 2),
(11174, NULL, 'cd18186', NULL, NULL, 'BTB_POZ_ZBTB_KLHL-like', NULL, 'BTB_POZ_ZBTB_KLHL-like', NULL, NULL, NULL, 2),
(11175, NULL, 'cd19133', NULL, NULL, 'AKR_AKR5F1', NULL, 'AKR_AKR5F1', NULL, NULL, NULL, 2),
(11176, NULL, 'cd00125', NULL, NULL, 'PLA2c', NULL, 'PLA2c', NULL, NULL, 10230, 2),
(11177, NULL, 'cd12119', NULL, NULL, 'ttLC_FACS_AlkK_like', NULL, 'ttLC_FACS_AlkK_like', NULL, NULL, NULL, 2),
(11178, NULL, 'cd18797', NULL, NULL, 'SF2_C_Hrq', NULL, 'SF2_C_Hrq', NULL, NULL, NULL, 2),
(11179, NULL, 'cd00270', NULL, NULL, 'MATH_TRAF_C', NULL, 'MATH_TRAF_C', NULL, NULL, NULL, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(11180, NULL, 'cd07857', NULL, NULL, 'STKc_MPK1', NULL, 'STKc_MPK1', NULL, NULL, NULL, 2),
(11181, NULL, 'cd10382', NULL, NULL, 'SH2_SOCS1', NULL, 'SH2_SOCS1', NULL, NULL, 28095, 2),
(11182, NULL, 'cd09951', NULL, NULL, 'HERV-Rb-like_HR1-HR2', NULL, 'HERV-Rb-like_HR1-HR2', NULL, NULL, NULL, 2),
(11183, NULL, 'cd18390', NULL, NULL, 'BTB_POZ_KCTD5', NULL, 'BTB_POZ_KCTD5', NULL, NULL, NULL, 2),
(11184, NULL, 'cd05861', NULL, NULL, 'Ig_PDGFR-alphabeta', NULL, 'Ig_PDGFR-alphabeta', NULL, NULL, NULL, 2),
(11185, NULL, 'cd16654', NULL, NULL, 'RING-Ubox_CHIP', NULL, 'RING-Ubox_CHIP', NULL, NULL, 34483, 2),
(11186, NULL, 'cd19764', NULL, NULL, 'Bbox2_TRIM9-like', NULL, 'Bbox2_TRIM9-like', NULL, NULL, NULL, 2),
(11187, NULL, 'cd14759', NULL, NULL, 'GS_GGDEF_2', NULL, 'GS_GGDEF_2', NULL, NULL, NULL, 2),
(11188, NULL, 'cd02053', NULL, NULL, 'serpinF2_A2AP', NULL, 'serpinF2_A2AP', NULL, NULL, 31876, 2),
(11189, NULL, 'cd19577', NULL, NULL, 'serpinJ_IRS-2-like', NULL, 'serpinJ_IRS-2-like', NULL, NULL, NULL, 2),
(11190, NULL, 'cd03077', NULL, NULL, 'GST_N_Alpha', NULL, 'GST_N_Alpha', NULL, NULL, NULL, 2),
(11191, NULL, 'cd01193', NULL, NULL, 'INT_IntI_C', NULL, 'INT_IntI_C', NULL, NULL, NULL, 2),
(11192, NULL, 'cd04773', NULL, NULL, 'HTH_TioE_rpt2', NULL, 'HTH_TioE_rpt2', NULL, NULL, NULL, 2),
(11193, NULL, 'cd09364', NULL, NULL, 'LIM1_LIMK', NULL, 'LIM1_LIMK', NULL, NULL, NULL, 2),
(11194, NULL, 'cd00880', NULL, NULL, 'Era_like', NULL, 'Era_like', NULL, NULL, NULL, 2),
(11195, NULL, 'cd05371', NULL, NULL, 'HSD10-like_SDR_c', NULL, 'HSD10-like_SDR_c', NULL, NULL, NULL, 2),
(11196, NULL, 'cd07268', NULL, NULL, 'VOC_EcYecM_like', NULL, 'VOC_EcYecM_like', NULL, NULL, 9065, 2),
(11197, NULL, 'cd03858', NULL, NULL, 'M14_CP_N-E_like', NULL, 'M14_CP_N-E_like', NULL, NULL, NULL, 2),
(11198, NULL, 'cd05269', NULL, NULL, 'TMR_SDR_a', NULL, 'TMR_SDR_a', NULL, NULL, NULL, 2),
(11199, NULL, 'cd01257', NULL, NULL, 'PH_IRS', NULL, 'PH_IRS', NULL, NULL, NULL, 2),
(11200, NULL, 'cd04651', NULL, NULL, 'LbH_G1P_AT_C', NULL, 'LbH_G1P_AT_C', NULL, NULL, NULL, 2),
(11201, NULL, 'cd09825', NULL, NULL, 'thyroid_peroxidase', NULL, 'thyroid_peroxidase', NULL, NULL, NULL, 2),
(11202, NULL, 'cd11844', NULL, NULL, 'SH3_CAS', NULL, 'SH3_CAS', NULL, NULL, NULL, 2),
(11203, NULL, 'cd17468', NULL, NULL, 'T3SS_HrpP_C', NULL, 'T3SS_HrpP_C', NULL, NULL, NULL, 2),
(11204, NULL, 'cd05337', NULL, NULL, 'BKR_1_SDR_c', NULL, 'BKR_1_SDR_c', NULL, NULL, NULL, 2),
(11205, NULL, 'cd04591', NULL, NULL, 'CBS_pair_voltage-gated_CLC_euk_bac', NULL, 'CBS_pair_voltage-gated_CLC_euk_bac', NULL, NULL, NULL, 2),
(11206, NULL, 'cd09540', NULL, NULL, 'SAM_EPS8-like', NULL, 'SAM_EPS8-like', NULL, NULL, NULL, 2),
(11207, NULL, 'cd14550', NULL, NULL, 'R5-PTP-2', NULL, 'R5-PTP-2', NULL, NULL, NULL, 2),
(11208, NULL, 'cd00089', NULL, NULL, 'HR1', NULL, 'HR1', NULL, NULL, NULL, 2),
(11209, NULL, 'cd10227', NULL, NULL, 'ParM_like', NULL, 'ParM_like', NULL, NULL, 30158, 2),
(11210, NULL, 'cd05073', NULL, NULL, 'PTKc_Hck', NULL, 'PTKc_Hck', NULL, NULL, NULL, 2),
(11211, NULL, 'cd11380', NULL, NULL, 'Ribosomal_S8e_like', NULL, 'Ribosomal_S8e_like', NULL, NULL, NULL, 2),
(11212, NULL, 'cd09941', NULL, NULL, 'SH2_Grb2_like', NULL, 'SH2_Grb2_like', NULL, NULL, NULL, 2),
(11213, NULL, 'cd12526', NULL, NULL, 'RRM1_EAR1_like', NULL, 'RRM1_EAR1_like', NULL, NULL, NULL, 2),
(11214, NULL, 'cd05467', NULL, NULL, 'CBM20', NULL, 'CBM20', NULL, NULL, NULL, 2),
(11215, NULL, 'cd00830', NULL, NULL, 'KAS_III', NULL, 'KAS_III', NULL, NULL, NULL, 2),
(11216, NULL, 'cd17402', NULL, NULL, 'MFS_SLCO3_OATP3', NULL, 'MFS_SLCO3_OATP3', NULL, NULL, NULL, 2),
(11217, NULL, 'cd12674', NULL, NULL, 'RRM1_Nop4p', NULL, 'RRM1_Nop4p', NULL, NULL, 32166, 2),
(11218, NULL, 'cd07699', NULL, NULL, 'IgC_L', NULL, 'IgC_L', NULL, NULL, NULL, 2),
(11219, NULL, 'cd07511', NULL, NULL, 'HAD_like', NULL, 'HAD_like', NULL, NULL, NULL, 2),
(11220, NULL, 'cd13281', NULL, NULL, 'PH_PLEKHD1', NULL, 'PH_PLEKHD1', NULL, NULL, NULL, 2),
(11221, NULL, 'cd17445', NULL, NULL, 'MFS_SLC22A17', NULL, 'MFS_SLC22A17', NULL, NULL, NULL, 2);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(11222, NULL, 'cd10523', NULL, NULL, 'SET_SETDB2', NULL, 'SET_SETDB2', NULL, NULL, NULL, 2),
(11223, NULL, 'cd00585', NULL, NULL, 'Peptidase_C1B', NULL, 'Peptidase_C1B', NULL, NULL, 2919, 2),
(11224, NULL, 'cd02651', NULL, NULL, 'nuc_hydro_IU_UC_XIUA', NULL, 'nuc_hydro_IU_UC_XIUA', NULL, NULL, NULL, 2),
(11225, NULL, 'cd06545', NULL, NULL, 'GH18_3CO4_chitinase', NULL, 'GH18_3CO4_chitinase', NULL, NULL, NULL, 2),
(11226, NULL, 'cd02165', NULL, NULL, 'NMNAT', NULL, 'NMNAT', NULL, NULL, 11102, 2),
(11227, NULL, 'cd18203', NULL, NULL, 'BTB_POZ_ZBTB12', NULL, 'BTB_POZ_ZBTB12', NULL, NULL, NULL, 2),
(11228, NULL, 'cd00952', NULL, NULL, 'CHBPH_aldolase', NULL, 'CHBPH_aldolase', NULL, NULL, NULL, 2),
(11229, NULL, 'cd08357', NULL, NULL, 'VOC_like', NULL, 'VOC_like', NULL, NULL, NULL, 2),
(11230, NULL, 'cd04495', NULL, NULL, 'BRCA2DBD_OB3', NULL, 'BRCA2DBD_OB3', NULL, NULL, 10970, 2),
(11231, NULL, 'cd15886', NULL, NULL, 'SNARE_SEC9N', NULL, 'SNARE_SEC9N', NULL, NULL, NULL, 2),
(11232, NULL, 'cd07404', NULL, NULL, 'MPP_MS158', NULL, 'MPP_MS158', NULL, NULL, NULL, 2),
(11233, NULL, 'cd01620', NULL, NULL, 'Ala_dh_like', NULL, 'Ala_dh_like', NULL, NULL, NULL, 2),
(11234, NULL, 'cd18638', NULL, NULL, 'CD_EhHp1_like', NULL, 'CD_EhHp1_like', NULL, NULL, NULL, 2),
(11235, NULL, 'cd14988', NULL, NULL, '7tmA_GPR182', NULL, '7tmA_GPR182', NULL, NULL, NULL, 2),
(11236, NULL, 'cd19142', NULL, NULL, 'AKR_AKR6B1', NULL, 'AKR_AKR6B1', NULL, NULL, NULL, 2),
(11237, NULL, 'cd03201', NULL, NULL, 'GST_C_DHAR', NULL, 'GST_C_DHAR', NULL, NULL, NULL, 2),
(11238, NULL, 'cd17419', NULL, NULL, 'MFS_NPF7', NULL, 'MFS_NPF7', NULL, NULL, NULL, 2),
(11239, NULL, 'cd04105', NULL, NULL, 'SR_beta', NULL, 'SR_beta', NULL, NULL, 15698, 2),
(11240, NULL, 'cd09167', NULL, NULL, 'PLDc_EcPPK1_C2_like', NULL, 'PLDc_EcPPK1_C2_like', NULL, NULL, NULL, 2),
(11241, NULL, 'cd05142', NULL, NULL, 'Barstar', NULL, 'Barstar', NULL, NULL, NULL, 2),
(11242, NULL, 'cd04462', NULL, NULL, 'S1_RNAPII_Rpb7', NULL, 'S1_RNAPII_Rpb7', NULL, NULL, NULL, 2),
(11243, NULL, 'cd12729', NULL, NULL, 'RRM1_hnRNPH_hnRNPH2_hnRNPF', NULL, 'RRM1_hnRNPH_hnRNPH2_hnRNPF', NULL, NULL, NULL, 2),
(11244, NULL, 'cd02431', NULL, NULL, 'Ferritin_CCC1_C', NULL, 'Ferritin_CCC1_C', NULL, NULL, NULL, 2),
(11245, NULL, 'cd17428', NULL, NULL, 'MFS_MCT9', NULL, 'MFS_MCT9', NULL, NULL, NULL, 2),
(11246, NULL, 'cd00231', NULL, NULL, 'ZipA', NULL, 'ZipA', NULL, NULL, 4718, 2),
(11247, NULL, 'cd17056', NULL, NULL, 'Ubl_FAF1', NULL, 'Ubl_FAF1', NULL, NULL, NULL, 2),
(11248, NULL, 'cd01251', NULL, NULL, 'PH2_ADAP', NULL, 'PH2_ADAP', NULL, NULL, 31165, 2),
(11249, NULL, 'cd18063', NULL, NULL, 'DEXHc_SMARCA2', NULL, 'DEXHc_SMARCA2', NULL, NULL, NULL, 2),
(11250, NULL, 'cd01580', NULL, NULL, 'AcnA_IRP_Swivel', NULL, 'AcnA_IRP_Swivel', NULL, NULL, 35347, 2),
(11251, NULL, 'cd07641', NULL, NULL, 'BAR_ASAP1', NULL, 'BAR_ASAP1', NULL, NULL, 32856, 2),
(11252, NULL, 'cd03602', NULL, NULL, 'CLECT_1', NULL, 'CLECT_1', NULL, NULL, NULL, 2),
(11253, NULL, 'cd08736', NULL, NULL, 'RGS_RhoGEF-like', NULL, 'RGS_RhoGEF-like', NULL, NULL, NULL, 2),
(11254, NULL, 'cd21559', NULL, NULL, 'gammaCoV-Nsp6', NULL, 'gammaCoV-Nsp6', NULL, NULL, 36400, 2),
(11255, NULL, 'cd18694', NULL, NULL, 'PIN_VapC-like', NULL, 'PIN_VapC-like', NULL, NULL, NULL, 2),
(11256, NULL, 'cd11839', NULL, NULL, 'SH3_Intersectin_4', NULL, 'SH3_Intersectin_4', NULL, NULL, NULL, 2),
(11257, NULL, 'cd06360', NULL, NULL, 'PBP1_alkylbenzenes-like', NULL, 'PBP1_alkylbenzenes-like', NULL, NULL, NULL, 2),
(11258, NULL, 'cd05872', NULL, NULL, 'Ig_Sema4B_like', NULL, 'Ig_Sema4B_like', NULL, NULL, NULL, 2),
(11259, NULL, 'cd08998', NULL, NULL, 'GH43_Arb43a-like', NULL, 'GH43_Arb43a-like', NULL, NULL, NULL, 2),
(11260, NULL, 'cd12871', NULL, NULL, 'Bacuni_01323_like', NULL, 'Bacuni_01323_like', NULL, NULL, NULL, 2),
(11261, NULL, 'cd18092', NULL, NULL, 'SpoU-like_TrmH', NULL, 'SpoU-like_TrmH', NULL, NULL, 29863, 2),
(11262, NULL, 'cd05402', NULL, NULL, 'NT_PAP_TUTase', NULL, 'NT_PAP_TUTase', NULL, NULL, NULL, 2),
(11263, NULL, 'cd05809', NULL, NULL, 'CBM20_beta_amylase', NULL, 'CBM20_beta_amylase', NULL, NULL, 10057, 2);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(11264, NULL, 'cd10567', NULL, NULL, 'SWIB-MDM2_like', NULL, 'SWIB-MDM2_like', NULL, NULL, NULL, 2),
(11265, NULL, 'cd01154', NULL, NULL, 'AidB', NULL, 'AidB', NULL, NULL, 1726, 2),
(11266, NULL, 'cd06958', NULL, NULL, 'NR_DBD_COUP_TF', NULL, 'NR_DBD_COUP_TF', NULL, NULL, NULL, 2),
(11267, NULL, 'cd10536', NULL, NULL, 'SET_SMYD4', NULL, 'SET_SMYD4', NULL, NULL, 36324, 2),
(11268, NULL, 'cd12575', NULL, NULL, 'RRM1_hnRNPD_like', NULL, 'RRM1_hnRNPD_like', NULL, NULL, NULL, 2),
(11269, NULL, 'cd01433', NULL, NULL, 'Ribosomal_L16_L10e', NULL, 'Ribosomal_L16_L10e', NULL, NULL, 11696, 2),
(11270, NULL, 'cd09528', NULL, NULL, 'SAM_Samd9_Samd9L', NULL, 'SAM_Samd9_Samd9L', NULL, NULL, NULL, 2),
(11271, NULL, 'cd10790', NULL, NULL, 'GH38N_AMII_1', NULL, 'GH38N_AMII_1', NULL, NULL, NULL, 2),
(11272, NULL, 'cd08958', NULL, NULL, 'FR_SDR_e', NULL, 'FR_SDR_e', NULL, NULL, NULL, 2),
(11273, NULL, 'cd16146', NULL, NULL, 'ARS_like', NULL, 'ARS_like', NULL, NULL, NULL, 2),
(11274, NULL, 'cd19148', NULL, NULL, 'AKR_AKR11B1', NULL, 'AKR_AKR11B1', NULL, NULL, NULL, 2),
(11275, NULL, 'cd08629', NULL, NULL, 'PI-PLCc_delta1', NULL, 'PI-PLCc_delta1', NULL, NULL, NULL, 2),
(11276, NULL, 'cd14489', NULL, NULL, 'CBM_SBP_bac_1_like', NULL, 'CBM_SBP_bac_1_like', NULL, NULL, NULL, 2),
(11277, NULL, 'cd03814', NULL, NULL, 'GT4-like', NULL, 'GT4-like', NULL, NULL, NULL, 2),
(11278, NULL, 'cd15174', NULL, NULL, '7tmA_CCR9', NULL, '7tmA_CCR9', NULL, NULL, NULL, 2),
(11279, NULL, 'cd05027', NULL, NULL, 'S-100B', NULL, 'S-100B', NULL, NULL, 26182, 2),
(11280, NULL, 'cd13605', NULL, NULL, 'PBP2_TRAP_DctP_like_2', NULL, 'PBP2_TRAP_DctP_like_2', NULL, NULL, NULL, 2),
(11281, NULL, 'cd19842', NULL, NULL, 'Bbox1_TRIM25-like_C-IV', NULL, 'Bbox1_TRIM25-like_C-IV', NULL, NULL, NULL, 2),
(11282, NULL, 'cd09389', NULL, NULL, 'LIM2_LMO1_LMO3', NULL, 'LIM2_LMO1_LMO3', NULL, NULL, NULL, 2),
(11283, NULL, 'cd01787', NULL, NULL, 'RA_MRL', NULL, 'RA_MRL', NULL, NULL, NULL, 2),
(11284, NULL, 'cd11299', NULL, NULL, 'O-FucT_plant', NULL, 'O-FucT_plant', NULL, NULL, 12955, 2),
(11285, NULL, 'cd12735', NULL, NULL, 'RRM3_hnRNPH3', NULL, 'RRM3_hnRNPH3', NULL, NULL, 27010, 2),
(11286, NULL, 'cd02418', NULL, NULL, 'Peptidase_C39B', NULL, 'Peptidase_C39B', NULL, NULL, NULL, 2),
(11287, NULL, 'cd17621', NULL, NULL, 'REC_OmpR_RegX3-like', NULL, 'REC_OmpR_RegX3-like', NULL, NULL, NULL, 2),
(11288, NULL, 'cd03197', NULL, NULL, 'GST_C_mPGES2', NULL, 'GST_C_mPGES2', NULL, NULL, 20356, 2),
(11289, NULL, 'cd18302', NULL, NULL, 'BTB2_POZ_IBtk', NULL, 'BTB2_POZ_IBtk', NULL, NULL, NULL, 2),
(11290, NULL, 'cd12375', NULL, NULL, 'RRM1_Hu_like', NULL, 'RRM1_Hu_like', NULL, NULL, NULL, 2),
(11291, NULL, 'cd00503', NULL, NULL, 'Frataxin', NULL, 'Frataxin', NULL, NULL, NULL, 2),
(11292, NULL, 'cd14944', NULL, NULL, 'TRAPPC6A_Trs33', NULL, 'TRAPPC6A_Trs33', NULL, NULL, 28944, 2),
(11293, NULL, 'cd16474', NULL, NULL, 'RING-H2_RNF111_like', NULL, 'RING-H2_RNF111_like', NULL, NULL, NULL, 2),
(11294, NULL, 'cd03290', NULL, NULL, 'ABCC_SUR1_N', NULL, 'ABCC_SUR1_N', NULL, NULL, NULL, 2),
(11295, NULL, 'cd07850', NULL, NULL, 'STKc_JNK', NULL, 'STKc_JNK', NULL, NULL, NULL, 2),
(11296, NULL, 'cd20254', NULL, NULL, 'CASIMO1_SMIM5', NULL, 'CASIMO1_SMIM5', NULL, NULL, NULL, 2),
(11297, NULL, 'cd08874', NULL, NULL, 'START_STARD9-like', NULL, 'START_STARD9-like', NULL, NULL, NULL, 2),
(11298, NULL, 'cd01807', NULL, NULL, 'Ubl_UBL4A_like', NULL, 'Ubl_UBL4A_like', NULL, NULL, 37717, 2),
(11299, NULL, 'cd14934', NULL, NULL, 'MYSc_Myh16', NULL, 'MYSc_Myh16', NULL, NULL, NULL, 2),
(11300, NULL, 'cd08946', NULL, NULL, 'SDR_e', NULL, 'SDR_e', NULL, NULL, NULL, 2),
(11301, NULL, 'cd13688', NULL, NULL, 'PBP2_GltI_DEBP', NULL, 'PBP2_GltI_DEBP', NULL, NULL, NULL, 2),
(11302, NULL, 'cd05511', NULL, NULL, 'Bromo_TFIID', NULL, 'Bromo_TFIID', NULL, NULL, NULL, 2),
(11303, NULL, 'cd09254', NULL, NULL, 'AP_delta-COPI_MHD', NULL, 'AP_delta-COPI_MHD', NULL, NULL, NULL, 2),
(11304, NULL, 'cd03317', NULL, NULL, 'NAAAR', NULL, 'NAAAR', NULL, NULL, 4278, 2),
(11305, NULL, 'cd15768', NULL, NULL, 'FYVE_SPIR2', NULL, 'FYVE_SPIR2', NULL, NULL, NULL, 2);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(11306, NULL, 'cd18402', NULL, NULL, 'BTB_POZ_KCNA1', NULL, 'BTB_POZ_KCNA1', NULL, NULL, NULL, 2),
(11307, NULL, 'cd01445', NULL, NULL, 'TST_Repeats', NULL, 'TST_Repeats', NULL, NULL, NULL, 2),
(11308, NULL, 'cd08559', NULL, NULL, 'GDPD_periplasmic_GlpQ_like', NULL, 'GDPD_periplasmic_GlpQ_like', NULL, NULL, NULL, 2),
(11309, NULL, 'cd07158', NULL, NULL, 'NR_DBD_Ppar_like', NULL, 'NR_DBD_Ppar_like', NULL, NULL, NULL, 2),
(11310, NULL, 'cd11416', NULL, NULL, 'bHLH_TS_ceHLH13_like', NULL, 'bHLH_TS_ceHLH13_like', NULL, NULL, NULL, 2),
(11311, NULL, 'cd17386', NULL, NULL, 'MFS_SLC46', NULL, 'MFS_SLC46', NULL, NULL, NULL, 2),
(11312, NULL, 'cd12353', NULL, NULL, 'RRM2_TIA1_like', NULL, 'RRM2_TIA1_like', NULL, NULL, NULL, 2),
(11313, NULL, 'cd08072', NULL, NULL, 'MPN_archaeal', NULL, 'MPN_archaeal', NULL, NULL, NULL, 2),
(11314, NULL, 'cd17791', NULL, NULL, 'HipA-like', NULL, 'HipA-like', NULL, NULL, NULL, 2),
(11315, NULL, 'cd09541', NULL, NULL, 'SAM_KIF24-like', NULL, 'SAM_KIF24-like', NULL, NULL, NULL, 2),
(11316, NULL, 'cd17753', NULL, NULL, 'MCM2', NULL, 'MCM2', NULL, NULL, NULL, 2),
(11317, NULL, 'cd18482', NULL, NULL, 'BACK_KBTBD6_7', NULL, 'BACK_KBTBD6_7', NULL, NULL, NULL, 2),
(11318, NULL, 'cd08412', NULL, NULL, 'PBP2_PAO1_like', NULL, 'PBP2_PAO1_like', NULL, NULL, NULL, 2),
(11319, NULL, 'cd09539', NULL, NULL, 'SAM_TNK-like', NULL, 'SAM_TNK-like', NULL, NULL, NULL, 2),
(11320, NULL, 'cd13131', NULL, NULL, 'MATE_NorM_like', NULL, 'MATE_NorM_like', NULL, NULL, NULL, 2),
(11321, NULL, 'cd19822', NULL, NULL, 'Bbox2_MID1_C-I', NULL, 'Bbox2_MID1_C-I', NULL, NULL, NULL, 2),
(11322, NULL, 'cd06884', NULL, NULL, 'PX_PI3K_C2_68D', NULL, 'PX_PI3K_C2_68D', NULL, NULL, NULL, 2),
(11323, NULL, 'cd18953', NULL, NULL, 'bHLH_TS_bHLHe23_bHLHb4', NULL, 'bHLH_TS_bHLHe23_bHLHb4', NULL, NULL, NULL, 2),
(11324, NULL, 'cd00515', NULL, NULL, 'HAM1', NULL, 'HAM1', NULL, NULL, 2878, 2),
(11325, NULL, 'cd15822', NULL, NULL, 'SPRY_PRY_TRIM5', NULL, 'SPRY_PRY_TRIM5', NULL, NULL, NULL, 2),
(11326, NULL, 'cd13926', NULL, NULL, 'N-acetylmuramidase_GH108', NULL, 'N-acetylmuramidase_GH108', NULL, NULL, NULL, 2),
(11327, NULL, 'cd15545', NULL, NULL, 'PHD_BAZ2A_like', NULL, 'PHD_BAZ2A_like', NULL, NULL, NULL, 2),
(11328, NULL, 'cd17586', NULL, NULL, 'REC_PFxFATGY', NULL, 'REC_PFxFATGY', NULL, NULL, NULL, 2),
(11329, NULL, 'cd04649', NULL, NULL, 'LbH_THP_succinylT_putative', NULL, 'LbH_THP_succinylT_putative', NULL, NULL, NULL, 2),
(11330, NULL, 'cd10278', NULL, NULL, 'PQQ_MDH', NULL, 'PQQ_MDH', NULL, NULL, NULL, 2),
(11331, NULL, 'cd20490', NULL, NULL, 'cupin_HutD_C', NULL, 'cupin_HutD_C', NULL, NULL, NULL, 2),
(11332, NULL, 'cd05517', NULL, NULL, 'Bromo_polybromo_II', NULL, 'Bromo_polybromo_II', NULL, NULL, NULL, 2),
(11333, NULL, 'cd12957', NULL, NULL, 'SKA3_N', NULL, 'SKA3_N', NULL, NULL, NULL, 2),
(11334, NULL, 'cd21533', NULL, NULL, 'MERS-CoV-like_E', NULL, 'MERS-CoV-like_E', NULL, NULL, 34078, 2),
(11335, NULL, 'cd03362', NULL, NULL, 'TOPRIM_TopoIA_TopoIII', NULL, 'TOPRIM_TopoIA_TopoIII', NULL, NULL, 5939, 2),
(11336, NULL, 'cd07070', NULL, NULL, 'NR_LBD_SF-1', NULL, 'NR_LBD_SF-1', NULL, NULL, NULL, 2),
(11337, NULL, 'cd09392', NULL, NULL, 'LIM2_Lrg1p_like', NULL, 'LIM2_Lrg1p_like', NULL, NULL, NULL, 2),
(11338, NULL, 'cd19911', NULL, NULL, 'DSRM_STRBP_rpt2', NULL, 'DSRM_STRBP_rpt2', NULL, NULL, NULL, 2),
(11339, NULL, 'cd01345', NULL, NULL, 'OM_channels', NULL, 'OM_channels', NULL, NULL, NULL, 2),
(11340, NULL, 'cd02856', NULL, NULL, 'E_set_GDE_Isoamylase_N', NULL, 'E_set_GDE_Isoamylase_N', NULL, NULL, 35073, 2),
(11341, NULL, 'cd11718', NULL, NULL, 'THUMP_SPOUT', NULL, 'THUMP_SPOUT', NULL, NULL, 29671, 2),
(11342, NULL, 'cd06085', NULL, NULL, 'KOW_Spt5_5', NULL, 'KOW_Spt5_5', NULL, NULL, 30666, 2),
(11343, NULL, 'cd07455', NULL, NULL, 'CRD_Collagen_XVIII', NULL, 'CRD_Collagen_XVIII', NULL, NULL, 33455, 2),
(11344, NULL, 'cd16966', NULL, NULL, 'Alpha_kinase_ALPK2_3', NULL, 'Alpha_kinase_ALPK2_3', NULL, NULL, NULL, 2),
(11345, NULL, 'cd09651', NULL, NULL, 'Cas5_I-C', NULL, 'Cas5_I-C', NULL, NULL, NULL, 2),
(11346, NULL, 'cd16124', NULL, NULL, 'RA_GRB7_10_14', NULL, 'RA_GRB7_10_14', NULL, NULL, NULL, 2);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(11347, NULL, 'cd08229', NULL, NULL, 'STKc_Nek7', NULL, 'STKc_Nek7', NULL, NULL, NULL, 2),
(11348, NULL, 'cd14447', NULL, NULL, 'SPX', NULL, 'SPX', NULL, NULL, NULL, 2),
(11349, NULL, 'cd09841', NULL, NULL, 'LIM1_Prickle_3', NULL, 'LIM1_Prickle_3', NULL, NULL, NULL, 2),
(11350, NULL, 'cd04911', NULL, NULL, 'ACT_AKiii-YclM-BS_1', NULL, 'ACT_AKiii-YclM-BS_1', NULL, NULL, NULL, 2),
(11351, NULL, 'cd08889', NULL, NULL, 'SRPBCC_PITPNM1-2_like', NULL, 'SRPBCC_PITPNM1-2_like', NULL, NULL, NULL, 2),
(11352, NULL, 'cd09074', NULL, NULL, 'INPP5c', NULL, 'INPP5c', NULL, NULL, NULL, 2),
(11353, NULL, 'cd00451', NULL, NULL, 'GH38N_AMII_euk', NULL, 'GH38N_AMII_euk', NULL, NULL, NULL, 2),
(11354, NULL, 'cd00762', NULL, NULL, 'NAD_bind_malic_enz', NULL, 'NAD_bind_malic_enz', NULL, NULL, NULL, 2),
(11355, NULL, 'cd14159', NULL, NULL, 'STKc_IRAK1', NULL, 'STKc_IRAK1', NULL, NULL, NULL, 2),
(11356, NULL, 'cd02033', NULL, NULL, 'BchX', NULL, 'BchX', NULL, NULL, NULL, 2),
(11357, NULL, 'cd07742', NULL, NULL, 'metallo-hydrolase-like_MBL-fold', NULL, 'metallo-hydrolase-like_MBL-fold', NULL, NULL, NULL, 2),
(11358, NULL, 'cd16116', NULL, NULL, 'Ubl_Smt3_like', NULL, 'Ubl_Smt3_like', NULL, NULL, NULL, 2),
(11359, NULL, 'cd01966', NULL, NULL, 'Nitrogenase_NifN_1', NULL, 'Nitrogenase_NifN_1', NULL, NULL, 1085, 2),
(11360, NULL, 'cd03307', NULL, NULL, 'Mta_CmuA_like', NULL, 'Mta_CmuA_like', NULL, NULL, 5559, 2),
(11361, NULL, 'cd12524', NULL, NULL, 'RRM1_MEI2_like', NULL, 'RRM1_MEI2_like', NULL, NULL, 28030, 2),
(11362, NULL, 'cd05242', NULL, NULL, 'SDR_a8', NULL, 'SDR_a8', NULL, NULL, NULL, 2),
(11363, NULL, 'cd14346', NULL, NULL, 'UBA_Ubx5_like', NULL, 'UBA_Ubx5_like', NULL, NULL, NULL, 2),
(11364, NULL, 'cd08060', NULL, NULL, 'MPN_UPF0172', NULL, 'MPN_UPF0172', NULL, NULL, 6245, 2),
(11365, NULL, 'cd10318', NULL, NULL, 'RGL11', NULL, 'RGL11', NULL, NULL, 6218, 2),
(11366, NULL, 'cd17179', NULL, NULL, 'FERM_F1_PLEKHH2', NULL, 'FERM_F1_PLEKHH2', NULL, NULL, NULL, 2),
(11367, NULL, 'cd13288', NULL, NULL, 'PH_Ses', NULL, 'PH_Ses', NULL, NULL, NULL, 2),
(11368, NULL, 'cd06653', NULL, NULL, 'STKc_MEKK3_like_u1', NULL, 'STKc_MEKK3_like_u1', NULL, NULL, NULL, 2),
(11369, NULL, 'cd09706', NULL, NULL, 'Csf2_U', NULL, 'Csf2_U', NULL, NULL, NULL, 2),
(11370, NULL, 'cd11386', NULL, NULL, 'MCP_signal', NULL, 'MCP_signal', NULL, NULL, NULL, 2),
(11371, NULL, 'cd11518', NULL, NULL, 'SLC6sbd_SIT1', NULL, 'SLC6sbd_SIT1', NULL, NULL, NULL, 2),
(11372, NULL, 'cd11986', NULL, NULL, 'SH3_Stac3_1', NULL, 'SH3_Stac3_1', NULL, NULL, 28467, 2),
(11373, NULL, 'cd06322', NULL, NULL, 'PBP1_ABC_sugar_binding-like', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, NULL, 2),
(11374, NULL, 'cd04138', NULL, NULL, 'H_N_K_Ras_like', NULL, 'H_N_K_Ras_like', NULL, NULL, NULL, 2),
(11375, NULL, 'cd01941', NULL, NULL, 'YeiC_kinase_like', NULL, 'YeiC_kinase_like', NULL, NULL, NULL, 2),
(11376, NULL, 'cd02798', NULL, NULL, 'tRNA_bind_CsaA', NULL, 'tRNA_bind_CsaA', NULL, NULL, NULL, 2),
(11377, NULL, 'cd01996', NULL, NULL, 'Alpha_ANH_like_III', NULL, 'Alpha_ANH_like_III', NULL, NULL, NULL, 2),
(11378, NULL, 'cd05800', NULL, NULL, 'PGM_like2', NULL, 'PGM_like2', NULL, NULL, NULL, 2),
(11379, NULL, 'cd11814', NULL, NULL, 'SH3_Eve1_1', NULL, 'SH3_Eve1_1', NULL, NULL, 27194, 2),
(11380, NULL, 'cd16611', NULL, NULL, 'RING-HC_TRIM69_C-IV', NULL, 'RING-HC_TRIM69_C-IV', NULL, NULL, NULL, 2),
(11381, NULL, 'cd18488', NULL, NULL, 'BACK_BTBD3_like', NULL, 'BACK_BTBD3_like', NULL, NULL, NULL, 2),
(11382, NULL, 'sd00016', NULL, NULL, 'Apc5', NULL, 'Apc5', NULL, NULL, NULL, 2),
(11383, NULL, 'cd11790', NULL, NULL, 'SH3_Amphiphysin', NULL, 'SH3_Amphiphysin', NULL, NULL, NULL, 2),
(11384, NULL, 'cd18598', NULL, NULL, 'ABC_6TM_MRP7_D1_like', NULL, 'ABC_6TM_MRP7_D1_like', NULL, NULL, NULL, 2),
(11385, NULL, 'cd08034', NULL, NULL, 'LARP_1_2', NULL, 'LARP_1_2', NULL, NULL, NULL, 2),
(11386, NULL, 'cd09516', NULL, NULL, 'SAM_sec23ip-like', NULL, 'SAM_sec23ip-like', NULL, NULL, NULL, 2),
(11387, NULL, 'cd12131', NULL, NULL, 'HGbI-like', NULL, 'HGbI-like', NULL, NULL, NULL, 2);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(11388, NULL, 'cd05053', NULL, NULL, 'PTKc_FGFR', NULL, 'PTKc_FGFR', NULL, NULL, NULL, 2),
(11389, NULL, 'cd07150', NULL, NULL, 'ALDH_VaniDH_like', NULL, 'ALDH_VaniDH_like', NULL, NULL, NULL, 2),
(11390, NULL, 'cd07824', NULL, NULL, 'SRPBCC_6', NULL, 'SRPBCC_6', NULL, NULL, NULL, 2),
(11391, NULL, 'cd16745', NULL, NULL, 'RING-HC_AtRMA_like', NULL, 'RING-HC_AtRMA_like', NULL, NULL, NULL, 2),
(11392, NULL, 'cd07804', NULL, NULL, 'FGGY_XK_like_1', NULL, 'FGGY_XK_like_1', NULL, NULL, NULL, 2),
(11393, NULL, 'cd16942', NULL, NULL, 'HATPase_SpoIIAB-like', NULL, 'HATPase_SpoIIAB-like', NULL, NULL, NULL, 2),
(11394, NULL, 'cd11460', NULL, NULL, 'bHLH-O_HES6', NULL, 'bHLH-O_HES6', NULL, NULL, NULL, 2),
(11395, NULL, 'cd03016', NULL, NULL, 'PRX_1cys', NULL, 'PRX_1cys', NULL, NULL, 35925, 2),
(11396, NULL, 'cd17443', NULL, NULL, 'MFS_SLC22A31', NULL, 'MFS_SLC22A31', NULL, NULL, NULL, 2),
(11397, NULL, 'cd05659', NULL, NULL, 'M18_API', NULL, 'M18_API', NULL, NULL, NULL, 2),
(11398, NULL, 'cd11670', NULL, NULL, 'Sp_RAP1_RCT', NULL, 'Sp_RAP1_RCT', NULL, NULL, NULL, 2),
(11399, NULL, 'cd16965', NULL, NULL, 'Alpha_kinase_ChaK', NULL, 'Alpha_kinase_ChaK', NULL, NULL, NULL, 2),
(11400, NULL, 'cd07398', NULL, NULL, 'MPP_YbbF-LpxH', NULL, 'MPP_YbbF-LpxH', NULL, NULL, NULL, 2),
(11401, NULL, 'cd16200', NULL, NULL, 'EFh_PI-PLCbeta', NULL, 'EFh_PI-PLCbeta', NULL, NULL, NULL, 2),
(11402, NULL, 'cd05588', NULL, NULL, 'STKc_aPKC', NULL, 'STKc_aPKC', NULL, NULL, 28250, 2),
(11403, NULL, 'cd02059', NULL, NULL, 'serpinB14_OVA', NULL, 'serpinB14_OVA', NULL, NULL, NULL, 2),
(11404, NULL, 'cd07675', NULL, NULL, 'F-BAR_FNBP1L', NULL, 'F-BAR_FNBP1L', NULL, NULL, 16557, 2),
(11405, NULL, 'cd18746', NULL, NULL, 'PIN_VapC4-5_FitB-like', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, NULL, 2),
(11406, NULL, 'cd14699', NULL, NULL, 'bZIP_Fos_like', NULL, 'bZIP_Fos_like', NULL, NULL, NULL, 2),
(11407, NULL, 'cd11700', NULL, NULL, 'DHR2_DOCK11', NULL, 'DHR2_DOCK11', NULL, NULL, NULL, 2),
(11408, NULL, 'cd14068', NULL, NULL, 'STKc_LRRK2', NULL, 'STKc_LRRK2', NULL, NULL, NULL, 2),
(11409, NULL, 'cd07422', NULL, NULL, 'MPP_ApaH', NULL, 'MPP_ApaH', NULL, NULL, 2296, 2),
(11410, NULL, 'cd03231', NULL, NULL, 'ABC_CcmA_heme_exporter', NULL, 'ABC_CcmA_heme_exporter', NULL, NULL, NULL, 2),
(11411, NULL, 'cd09371', NULL, NULL, 'LIM1_Lmx1b', NULL, 'LIM1_Lmx1b', NULL, NULL, NULL, 2),
(11412, NULL, 'cd11537', NULL, NULL, 'NTP-PPase_RS21-C6_like', NULL, 'NTP-PPase_RS21-C6_like', NULL, NULL, 25950, 2),
(11413, NULL, 'cd09255', NULL, NULL, 'AP-like_stonins_MHD', NULL, 'AP-like_stonins_MHD', NULL, NULL, NULL, 2),
(11414, NULL, 'cd01444', NULL, NULL, 'GlpE_ST', NULL, 'GlpE_ST', NULL, NULL, 11863, 2),
(11415, NULL, 'cd09645', NULL, NULL, 'Cas5_I-E', NULL, 'Cas5_I-E', NULL, NULL, NULL, 2),
(11416, NULL, 'cd06829', NULL, NULL, 'PLPDE_III_CANSDC', NULL, 'PLPDE_III_CANSDC', NULL, NULL, 4650, 2),
(11417, NULL, 'cd18812', NULL, NULL, 'CAP_PI15-like', NULL, 'CAP_PI15-like', NULL, NULL, NULL, 2),
(11418, NULL, 'cd13590', NULL, NULL, 'PBP2_PotD_PotF_like', NULL, 'PBP2_PotD_PotF_like', NULL, NULL, NULL, 2),
(11419, NULL, 'cd01670', NULL, NULL, 'Death', NULL, 'Death', NULL, NULL, NULL, 2),
(11420, NULL, 'cd14781', NULL, NULL, 'FHb-globin_1', NULL, 'FHb-globin_1', NULL, NULL, NULL, 2),
(11421, NULL, 'cd05921', NULL, NULL, 'FCS', NULL, 'FCS', NULL, NULL, NULL, 2),
(11422, NULL, 'cd16659', NULL, NULL, 'RING-Ubox_Emp', NULL, 'RING-Ubox_Emp', NULL, NULL, NULL, 2),
(11423, NULL, 'cd06273', NULL, NULL, 'PBP1_LacI-like', NULL, 'PBP1_LacI-like', NULL, NULL, NULL, 2),
(11424, NULL, 'cd20248', NULL, NULL, 'phospholamban_like', NULL, 'phospholamban_like', NULL, NULL, NULL, 2),
(11425, NULL, 'cd20266', NULL, NULL, 'Complex1_LYR_NDUFA6_LYRM6', NULL, 'Complex1_LYR_NDUFA6_LYRM6', NULL, NULL, 37341, 2),
(11426, NULL, 'cd19785', NULL, NULL, 'Bbox2_TRIM45_C-X', NULL, 'Bbox2_TRIM45_C-X', NULL, NULL, NULL, 2),
(11427, NULL, 'cd02516', NULL, NULL, 'CDP-ME_synthetase', NULL, 'CDP-ME_synthetase', NULL, NULL, 18793, 2),
(11428, NULL, 'cd05060', NULL, NULL, 'PTKc_Syk_like', NULL, 'PTKc_Syk_like', NULL, NULL, NULL, 2);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(11429, NULL, 'cd12732', NULL, NULL, 'RRM2_hnRNPH3', NULL, 'RRM2_hnRNPH3', NULL, NULL, 27099, 2),
(11430, NULL, 'cd07335', NULL, NULL, 'M48B_HtpX_like', NULL, 'M48B_HtpX_like', NULL, NULL, NULL, 2),
(11431, NULL, 'cd09413', NULL, NULL, 'LIM1_Testin', NULL, 'LIM1_Testin', NULL, NULL, 11742, 2),
(11432, NULL, 'cd15542', NULL, NULL, 'PHD_UBR7', NULL, 'PHD_UBR7', NULL, NULL, NULL, 2),
(11433, NULL, 'cd10574', NULL, NULL, 'EVH1_SPRED-like', NULL, 'EVH1_SPRED-like', NULL, NULL, 30389, 2),
(11434, NULL, 'cd17255', NULL, NULL, 'RMtype1_S_Fco49512ORF2615P-TRD2-CR2_like', NULL, 'RMtype1_S_Fco49512ORF2615P-TRD2-CR2_like', NULL, NULL, NULL, 2),
(11435, NULL, 'cd03332', NULL, NULL, 'LMO_FMN', NULL, 'LMO_FMN', NULL, NULL, 29471, 2),
(11436, NULL, 'cd06113', NULL, NULL, 'citrate_synt_like_1_2', NULL, 'citrate_synt_like_1_2', NULL, NULL, NULL, 2),
(11437, NULL, 'cd09337', NULL, NULL, 'LIM2_Paxillin_like', NULL, 'LIM2_Paxillin_like', NULL, NULL, NULL, 2),
(11438, NULL, 'cd12598', NULL, NULL, 'RRM1_SRSF9', NULL, 'RRM1_SRSF9', NULL, NULL, 20948, 2),
(11439, NULL, 'cd07909', NULL, NULL, 'YciF', NULL, 'YciF', NULL, NULL, NULL, 2),
(11440, NULL, 'cd15586', NULL, NULL, 'PHD_ING4_5', NULL, 'PHD_ING4_5', NULL, NULL, NULL, 2),
(11441, NULL, 'cd00448', NULL, NULL, 'YjgF_YER057c_UK114_family', NULL, 'YjgF_YER057c_UK114_family', NULL, NULL, NULL, 2),
(11442, NULL, 'cd18977', NULL, NULL, 'CD_POL_like', NULL, 'CD_POL_like', NULL, NULL, NULL, 2),
(11443, NULL, 'cd06145', NULL, NULL, 'REX1_like', NULL, 'REX1_like', NULL, NULL, 28893, 2),
(11444, NULL, 'cd18824', NULL, NULL, 'GH43_CtGH43-like', NULL, 'GH43_CtGH43-like', NULL, NULL, NULL, 2),
(11445, NULL, 'cd04118', NULL, NULL, 'Rab24', NULL, 'Rab24', NULL, NULL, 30378, 2),
(11446, NULL, 'cd05653', NULL, NULL, 'M20_ArgE_LysK', NULL, 'M20_ArgE_LysK', NULL, NULL, NULL, 2),
(11447, NULL, 'cd16265', NULL, NULL, 'Translation_Factor_II', NULL, 'Translation_Factor_II', NULL, NULL, NULL, 2),
(11448, NULL, 'cd02557', NULL, NULL, 'PseudoU_synth_ScRIB2', NULL, 'PseudoU_synth_ScRIB2', NULL, NULL, NULL, 2),
(11449, NULL, 'cd16827', NULL, NULL, 'ChuX-like', NULL, 'ChuX-like', NULL, NULL, NULL, 2),
(11450, NULL, 'cd18749', NULL, NULL, 'PIN_VapC4-5_FitB-like', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, NULL, 2),
(11451, NULL, 'cd18425', NULL, NULL, 'BTB_POZ_KCNV2', NULL, 'BTB_POZ_KCNV2', NULL, NULL, NULL, 2),
(11452, NULL, 'cd04218', NULL, NULL, 'Pseudoazurin', NULL, 'Pseudoazurin', NULL, NULL, 9338, 2),
(11453, NULL, 'cd04513', NULL, NULL, 'Glycosylasparaginase', NULL, 'Glycosylasparaginase', NULL, NULL, NULL, 2),
(11454, NULL, 'cd09602', NULL, NULL, 'M1_APN', NULL, 'M1_APN', NULL, NULL, NULL, 2),
(11455, NULL, 'cd00096', NULL, NULL, 'Ig', NULL, 'Ig', NULL, NULL, NULL, 2),
(11456, NULL, 'cd01842', NULL, NULL, 'SGNH_hydrolase_like_5', NULL, 'SGNH_hydrolase_like_5', NULL, NULL, NULL, 2),
(11457, NULL, 'cd00732', NULL, NULL, 'CheW', NULL, 'CheW', NULL, NULL, NULL, 2),
(11458, NULL, 'cd01111', NULL, NULL, 'HTH_MerD', NULL, 'HTH_MerD', NULL, NULL, NULL, 2),
(11459, NULL, 'cd18787', NULL, NULL, 'SF2_C_DEAD', NULL, 'SF2_C_DEAD', NULL, NULL, NULL, 2),
(11460, NULL, 'cd01189', NULL, NULL, 'INT_ICEBs1_C_like', NULL, 'INT_ICEBs1_C_like', NULL, NULL, NULL, 2),
(11461, NULL, 'cd16421', NULL, NULL, 'HAD_PGPase', NULL, 'HAD_PGPase', NULL, NULL, NULL, 2),
(11462, NULL, 'cd16388', NULL, NULL, 'SbnI_like_N', NULL, 'SbnI_like_N', NULL, NULL, 30854, 2),
(11463, NULL, 'cd17477', NULL, NULL, 'MFS_YcaD_like', NULL, 'MFS_YcaD_like', NULL, NULL, NULL, 2),
(11464, NULL, 'cd19593', NULL, NULL, 'serpin_bacteria_crustaceans', NULL, 'serpin_bacteria_crustaceans', NULL, NULL, NULL, 2),
(11465, NULL, 'cd02894', NULL, NULL, 'GGTase-II', NULL, 'GGTase-II', NULL, NULL, 26668, 2),
(11466, NULL, 'cd18034', NULL, NULL, 'DEXHc_dicer', NULL, 'DEXHc_dicer', NULL, NULL, NULL, 2),
(11467, NULL, 'cd08414', NULL, NULL, 'PBP2_LTTR_aromatics_like', NULL, 'PBP2_LTTR_aromatics_like', NULL, NULL, NULL, 2),
(11468, NULL, 'cd08440', NULL, NULL, 'PBP2_LTTR_like_4', NULL, 'PBP2_LTTR_like_4', NULL, NULL, NULL, 2),
(11469, NULL, 'cd04936', NULL, NULL, 'ACT_AKii-LysC-BS-like_2', NULL, 'ACT_AKii-LysC-BS-like_2', NULL, NULL, NULL, 2);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(11470, NULL, 'cd17197', NULL, NULL, 'FERM_F1_FRMD1', NULL, 'FERM_F1_FRMD1', NULL, NULL, NULL, 2),
(11471, NULL, 'cd19945', NULL, NULL, 'Fer2_BFD', NULL, 'Fer2_BFD', NULL, NULL, NULL, 2),
(11472, NULL, 'cd05799', NULL, NULL, 'PGM2', NULL, 'PGM2', NULL, NULL, NULL, 2),
(11473, NULL, 'cd11970', NULL, NULL, 'SH3_PLCgamma1', NULL, 'SH3_PLCgamma1', NULL, NULL, 31346, 2),
(11474, NULL, 'cd06357', NULL, NULL, 'PBP1_AmiC', NULL, 'PBP1_AmiC', NULL, NULL, 27133, 2),
(11475, NULL, 'cd09705', NULL, NULL, 'Csf1_U', NULL, 'Csf1_U', NULL, NULL, NULL, 2),
(11476, NULL, 'cd11571', NULL, NULL, 'FAT-like_EFS_C', NULL, 'FAT-like_EFS_C', NULL, NULL, NULL, 2),
(11477, NULL, 'cd12328', NULL, NULL, 'RRM2_hnRNPA_like', NULL, 'RRM2_hnRNPA_like', NULL, NULL, NULL, 2),
(11478, NULL, 'cd14567', NULL, NULL, 'DSP_DUSP10', NULL, 'DSP_DUSP10', NULL, NULL, NULL, 2),
(11479, NULL, 'cd07278', NULL, NULL, 'PX_RICS_like', NULL, 'PX_RICS_like', NULL, NULL, NULL, 2),
(11480, NULL, 'cd07845', NULL, NULL, 'STKc_CDK10', NULL, 'STKc_CDK10', NULL, NULL, 35074, 2),
(11481, NULL, 'cd15360', NULL, NULL, '7tmA_FSH-R', NULL, '7tmA_FSH-R', NULL, NULL, NULL, 2),
(11482, NULL, 'cd12444', NULL, NULL, 'RRM1_CPEBs', NULL, 'RRM1_CPEBs', NULL, NULL, NULL, 2),
(11483, NULL, 'cd20214', NULL, NULL, 'PFM_CEL-III-like', NULL, 'PFM_CEL-III-like', NULL, NULL, NULL, 2),
(11484, NULL, 'cd15963', NULL, NULL, '7tmA_GPR3', NULL, '7tmA_GPR3', NULL, NULL, NULL, 2),
(11485, NULL, 'cd06860', NULL, NULL, 'PX_SNX7_30_like', NULL, 'PX_SNX7_30_like', NULL, NULL, NULL, 2),
(11486, NULL, 'cd11756', NULL, NULL, 'GH94N_ChvB_NdvB_1_like', NULL, 'GH94N_ChvB_NdvB_1_like', NULL, NULL, 29295, 2),
(11487, NULL, 'cd10233', NULL, NULL, 'HSPA1-2_6-8-like_NBD', NULL, 'HSPA1-2_6-8-like_NBD', NULL, NULL, NULL, 2),
(11488, NULL, 'cd14184', NULL, NULL, 'STKc_DCKL2', NULL, 'STKc_DCKL2', NULL, NULL, NULL, 2),
(11489, NULL, 'cd09944', NULL, NULL, 'SH2_Grb7_family', NULL, 'SH2_Grb7_family', NULL, NULL, NULL, 2),
(11490, NULL, 'cd04052', NULL, NULL, 'C2B_Tricalbin-like', NULL, 'C2B_Tricalbin-like', NULL, NULL, 33286, 2),
(11491, NULL, 'cd06662', NULL, NULL, 'SURF1', NULL, 'SURF1', NULL, NULL, 7455, 2),
(11492, NULL, 'cd08243', NULL, NULL, 'quinone_oxidoreductase_like_1', NULL, 'quinone_oxidoreductase_like_1', NULL, NULL, NULL, 2),
(11493, NULL, 'cd11807', NULL, NULL, 'SH3_ASPP', NULL, 'SH3_ASPP', NULL, NULL, NULL, 2),
(11494, NULL, 'cd16010', NULL, NULL, 'iPGM', NULL, 'iPGM', NULL, NULL, 1480, 2),
(11495, NULL, 'cd06394', NULL, NULL, 'PBP1_iGluR_Kainate_KA1_2', NULL, 'PBP1_iGluR_Kainate_KA1_2', NULL, NULL, NULL, 2),
(11496, NULL, 'cd05403', NULL, NULL, 'NT_KNTase_like', NULL, 'NT_KNTase_like', NULL, NULL, NULL, 2),
(11497, NULL, 'cd16569', NULL, NULL, 'RING-HC_SHPRH', NULL, 'RING-HC_SHPRH', NULL, NULL, NULL, 2),
(11498, NULL, 'cd15740', NULL, NULL, 'FYVE_FGD3', NULL, 'FYVE_FGD3', NULL, NULL, NULL, 2),
(11499, NULL, 'cd04180', NULL, NULL, 'UGPase_euk_like', NULL, 'UGPase_euk_like', NULL, NULL, NULL, 2),
(11500, NULL, 'cd01406', NULL, NULL, 'SIR2-like', NULL, 'SIR2-like', NULL, NULL, NULL, 2),
(11501, NULL, 'cd09661', NULL, NULL, 'Cmr6_III-B', NULL, 'Cmr6_III-B', NULL, NULL, NULL, 2),
(11502, NULL, 'cd17630', NULL, NULL, 'OSB_MenE-like', NULL, 'OSB_MenE-like', NULL, NULL, NULL, 2),
(11503, NULL, 'cd04904', NULL, NULL, 'ACT_AAAH', NULL, 'ACT_AAAH', NULL, NULL, NULL, 2),
(11504, NULL, 'cd20762', NULL, NULL, 'capping_2-OMTase_Nidovirales', NULL, 'capping_2-OMTase_Nidovirales', NULL, NULL, 9021, 2),
(11505, NULL, 'cd16281', NULL, NULL, 'metallo-hydrolase-like_MBL-fold', NULL, 'metallo-hydrolase-like_MBL-fold', NULL, NULL, NULL, 2),
(11506, NULL, 'cd06609', NULL, NULL, 'STKc_MST3_like', NULL, 'STKc_MST3_like', NULL, NULL, NULL, 2),
(11507, NULL, 'cd06601', NULL, NULL, 'GH31_lyase_GLase', NULL, 'GH31_lyase_GLase', NULL, NULL, NULL, 2),
(11508, NULL, 'cd13206', NULL, NULL, 'FERM_C-lobe_PLEKHH1_PLEKHH2', NULL, 'FERM_C-lobe_PLEKHH1_PLEKHH2', NULL, NULL, NULL, 2),
(11509, NULL, 'cd05663', NULL, NULL, 'M28_like_PA_PDZ_associated', NULL, 'M28_like_PA_PDZ_associated', NULL, NULL, NULL, 2),
(11510, NULL, 'cd00395', NULL, NULL, 'Tyr_Trp_RS_core', NULL, 'Tyr_Trp_RS_core', NULL, NULL, NULL, 2);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(11511, NULL, 'cd15536', NULL, NULL, 'PHD_PHRF1', NULL, 'PHD_PHRF1', NULL, NULL, NULL, 2),
(11512, NULL, 'cd06106', NULL, NULL, 'ScCit3_like', NULL, 'ScCit3_like', NULL, NULL, NULL, 2),
(11513, NULL, 'cd03069', NULL, NULL, 'PDI_b_ERp57', NULL, 'PDI_b_ERp57', NULL, NULL, 30806, 2),
(11514, NULL, 'cd03772', NULL, NULL, 'MATH_HAUSP', NULL, 'MATH_HAUSP', NULL, NULL, NULL, 2),
(11515, NULL, 'cd04032', NULL, NULL, 'C2_Perforin', NULL, 'C2_Perforin', NULL, NULL, 31608, 2),
(11516, NULL, 'cd12272', NULL, NULL, 'RRM2_PHIP1', NULL, 'RRM2_PHIP1', NULL, NULL, 1230, 2),
(11517, NULL, 'cd12299', NULL, NULL, 'RRM4_Prp24', NULL, 'RRM4_Prp24', NULL, NULL, 24074, 2),
(11518, NULL, 'cd08487', NULL, NULL, 'PBP2_BlaA', NULL, 'PBP2_BlaA', NULL, NULL, 29835, 2),
(11519, NULL, 'cd15943', NULL, NULL, '7tmA_OR5AP2-like', NULL, '7tmA_OR5AP2-like', NULL, NULL, NULL, 2),
(11520, NULL, 'cd08496', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_9', NULL, 'PBP2_NikA_DppA_OppA_like_9', NULL, NULL, NULL, 2),
(11521, NULL, 'cd02173', NULL, NULL, 'ECT', NULL, 'ECT', NULL, NULL, NULL, 2),
(11522, NULL, 'cd18375', NULL, NULL, 'BTB_POZ_KCNRG', NULL, 'BTB_POZ_KCNRG', NULL, NULL, NULL, 2),
(11523, NULL, 'cd00736', NULL, NULL, 'lambda_lys-like', NULL, 'lambda_lys-like', NULL, NULL, NULL, 2),
(11524, NULL, 'cd13235', NULL, NULL, 'PH2_FARP1-like', NULL, 'PH2_FARP1-like', NULL, NULL, NULL, 2),
(11525, NULL, 'cd08441', NULL, NULL, 'PBP2_MetR', NULL, 'PBP2_MetR', NULL, NULL, 32321, 2),
(11526, NULL, 'cd19744', NULL, NULL, 'bHLH_TS_dAS-C_like', NULL, 'bHLH_TS_dAS-C_like', NULL, NULL, NULL, 2),
(11527, NULL, 'cd15001', NULL, NULL, '7tmA_GPRnna14-like', NULL, '7tmA_GPRnna14-like', NULL, NULL, NULL, 2),
(11528, NULL, 'cd12574', NULL, NULL, 'RRM1_DAZAP1', NULL, 'RRM1_DAZAP1', NULL, NULL, 20573, 2),
(11529, NULL, 'cd17757', NULL, NULL, 'MCM6', NULL, 'MCM6', NULL, NULL, NULL, 2),
(11530, NULL, 'cd18593', NULL, NULL, 'ABC_6TM_MRP4_D1_like', NULL, 'ABC_6TM_MRP4_D1_like', NULL, NULL, NULL, 2),
(11531, NULL, 'cd03325', NULL, NULL, 'D-galactonate_dehydratase', NULL, 'D-galactonate_dehydratase', NULL, NULL, 16422, 2),
(11532, NULL, 'cd08300', NULL, NULL, 'alcohol_DH_class_III', NULL, 'alcohol_DH_class_III', NULL, NULL, 8972, 2),
(11533, NULL, 'cd11376', NULL, NULL, 'Imelysin-like', NULL, 'Imelysin-like', NULL, NULL, NULL, 2),
(11534, NULL, 'cd12102', NULL, NULL, 'DD_RIbeta_PKA', NULL, 'DD_RIbeta_PKA', NULL, NULL, 36836, 2),
(11535, NULL, 'cd00266', NULL, NULL, 'MADS_SRF_like', NULL, 'MADS_SRF_like', NULL, NULL, 27345, 2),
(11536, NULL, 'cd17108', NULL, NULL, 'FERM_F1_EPB41L5_like', NULL, 'FERM_F1_EPB41L5_like', NULL, NULL, NULL, 2),
(11537, NULL, 'cd08860', NULL, NULL, 'TcmN_ARO-CYC_like', NULL, 'TcmN_ARO-CYC_like', NULL, NULL, NULL, 2),
(11538, NULL, 'cd04915', NULL, NULL, 'ACT_AK-Ectoine_2', NULL, 'ACT_AK-Ectoine_2', NULL, NULL, NULL, 2),
(11539, NULL, 'cd15984', NULL, NULL, '7tmB1_PTH1R', NULL, '7tmB1_PTH1R', NULL, NULL, NULL, 2),
(11540, NULL, 'cd08627', NULL, NULL, 'PI-PLCc_gamma1', NULL, 'PI-PLCc_gamma1', NULL, NULL, NULL, 2),
(11541, NULL, 'cd14394', NULL, NULL, 'UBA_BIRC2_3', NULL, 'UBA_BIRC2_3', NULL, NULL, 30497, 2),
(11542, NULL, 'cd15404', NULL, NULL, '7tmA_GPR63', NULL, '7tmA_GPR63', NULL, NULL, NULL, 2),
(11543, NULL, 'cd16961', NULL, NULL, 'RMtype1_S_TRD-CR_like', NULL, 'RMtype1_S_TRD-CR_like', NULL, NULL, NULL, 2),
(11544, NULL, 'cd13426', NULL, NULL, 'Peptidase_G1', NULL, 'Peptidase_G1', NULL, NULL, NULL, 2),
(11545, NULL, 'cd15127', NULL, NULL, '7tmA_GPR37', NULL, '7tmA_GPR37', NULL, NULL, NULL, 2),
(11546, NULL, 'cd00059', NULL, NULL, 'FH', NULL, 'FH', NULL, NULL, 3039, 2),
(11547, NULL, 'cd00454', NULL, NULL, 'TrHb1_N', NULL, 'TrHb1_N', NULL, NULL, NULL, 2),
(11548, NULL, 'cd06450', NULL, NULL, 'DOPA_deC_like', NULL, 'DOPA_deC_like', NULL, NULL, NULL, 2),
(11549, NULL, 'cd05693', NULL, NULL, 'S1_Rrp5_repeat_hs1_sc1', NULL, 'S1_Rrp5_repeat_hs1_sc1', NULL, NULL, NULL, 2),
(11550, NULL, 'cd15568', NULL, NULL, 'PHD5_NSD', NULL, 'PHD5_NSD', NULL, NULL, NULL, 2),
(11551, NULL, 'cd07931', NULL, NULL, 'eukaryotic_phosphagen_kinases', NULL, 'eukaryotic_phosphagen_kinases', NULL, NULL, NULL, 2);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(11552, NULL, 'cd08690', NULL, NULL, 'C2_Freud-1', NULL, 'C2_Freud-1', NULL, NULL, 28052, 2),
(11553, NULL, 'cd10160', NULL, NULL, 'CsoR-like_DUF156_3', NULL, 'CsoR-like_DUF156_3', NULL, NULL, NULL, 2),
(11554, NULL, 'cd15674', NULL, NULL, 'ePHD_PHF14', NULL, 'ePHD_PHF14', NULL, NULL, NULL, 2),
(11555, NULL, 'cd21481', NULL, NULL, 'SARS-CoV_Spike_S1_RBD', NULL, 'SARS-CoV_Spike_S1_RBD', NULL, NULL, 36275, 2),
(11556, NULL, 'cd03227', NULL, NULL, 'ABC_Class2', NULL, 'ABC_Class2', NULL, NULL, NULL, 2),
(11557, NULL, 'cd14540', NULL, NULL, 'PTPc-N21_14', NULL, 'PTPc-N21_14', NULL, NULL, NULL, 2),
(11558, NULL, 'cd17141', NULL, NULL, 'DCX1_DCLK2', NULL, 'DCX1_DCLK2', NULL, NULL, NULL, 2),
(11559, NULL, 'cd20282', NULL, NULL, 'cupin_DddQ', NULL, 'cupin_DddQ', NULL, NULL, NULL, 2),
(11560, NULL, 'cd11821', NULL, NULL, 'SH3_ASAP', NULL, 'SH3_ASAP', NULL, NULL, 27032, 2),
(11561, NULL, 'cd12089', NULL, NULL, 'Hef_ID', NULL, 'Hef_ID', NULL, NULL, 31066, 2),
(11562, NULL, 'cd17764', NULL, NULL, 'MTAP_SsMTAPI_like', NULL, 'MTAP_SsMTAPI_like', NULL, NULL, NULL, 2),
(11563, NULL, 'cd08200', NULL, NULL, 'catalase_peroxidase_2', NULL, 'catalase_peroxidase_2', NULL, NULL, NULL, 2),
(11564, NULL, 'cd09286', NULL, NULL, 'NMNAT_Eukarya', NULL, 'NMNAT_Eukarya', NULL, NULL, 36869, 2),
(11565, NULL, 'cd17363', NULL, NULL, 'MFS_SV2', NULL, 'MFS_SV2', NULL, NULL, NULL, 2),
(11566, NULL, 'cd18507', NULL, NULL, 'BACK_GPRS_like', NULL, 'BACK_GPRS_like', NULL, NULL, NULL, 2),
(11567, NULL, 'cd18769', NULL, NULL, 'PIN_Mut7-C-like', NULL, 'PIN_Mut7-C-like', NULL, NULL, NULL, 2),
(11568, NULL, 'cd08245', NULL, NULL, 'CAD', NULL, 'CAD', NULL, NULL, NULL, 2),
(11569, NULL, 'cd06402', NULL, NULL, 'PB1_p62', NULL, 'PB1_p62', NULL, NULL, 33932, 2),
(11570, NULL, 'cd18756', NULL, NULL, 'PIN_MtVapC15-VapC11-like', NULL, 'PIN_MtVapC15-VapC11-like', NULL, NULL, NULL, 2),
(11571, NULL, 'cd08375', NULL, NULL, 'C2_Intersectin', NULL, 'C2_Intersectin', NULL, NULL, NULL, 2),
(11572, NULL, 'cd09324', NULL, NULL, 'TDT_TehA', NULL, 'TDT_TehA', NULL, NULL, 31934, 2),
(11573, NULL, 'cd14073', NULL, NULL, 'STKc_NUAK', NULL, 'STKc_NUAK', NULL, NULL, NULL, 2),
(11574, NULL, 'cd05362', NULL, NULL, 'THN_reductase-like_SDR_c', NULL, 'THN_reductase-like_SDR_c', NULL, NULL, NULL, 2),
(11575, NULL, 'cd15951', NULL, NULL, '7tmA_OR52R_52L-like', NULL, '7tmA_OR52R_52L-like', NULL, NULL, NULL, 2),
(11576, NULL, 'cd04396', NULL, NULL, 'RhoGAP_fSAC7_BAG7', NULL, 'RhoGAP_fSAC7_BAG7', NULL, NULL, NULL, 2),
(11577, NULL, 'cd08532', NULL, NULL, 'SAM_PNT-PDEF-like', NULL, 'SAM_PNT-PDEF-like', NULL, NULL, NULL, 2),
(11578, NULL, 'cd06267', NULL, NULL, 'PBP1_LacI_sugar_binding-like', NULL, 'PBP1_LacI_sugar_binding-like', NULL, NULL, NULL, 2),
(11579, NULL, 'cd10923', NULL, NULL, 'CE4_COG5298', NULL, 'CE4_COG5298', NULL, NULL, NULL, 2),
(11580, NULL, 'cd12770', NULL, NULL, 'RRM1_HuD', NULL, 'RRM1_HuD', NULL, NULL, NULL, 2),
(11581, NULL, 'cd19203', NULL, NULL, 'SET_SMYD3', NULL, 'SET_SMYD3', NULL, NULL, 35180, 2),
(11582, NULL, 'cd00449', NULL, NULL, 'PLPDE_IV', NULL, 'PLPDE_IV', NULL, NULL, NULL, 2),
(11583, NULL, 'cd11520', NULL, NULL, 'SLC5sbd_SMCT2', NULL, 'SLC5sbd_SMCT2', NULL, NULL, 35631, 2),
(11584, NULL, 'cd12451', NULL, NULL, 'RRM2_NUCLs', NULL, 'RRM2_NUCLs', NULL, NULL, 662, 2),
(11585, NULL, 'cd19072', NULL, NULL, 'AKR_AKR3F1-like', NULL, 'AKR_AKR3F1-like', NULL, NULL, NULL, 2),
(11586, NULL, 'cd07423', NULL, NULL, 'MPP_Prp_like', NULL, 'MPP_Prp_like', NULL, NULL, 30659, 2),
(11587, NULL, 'cd11418', NULL, NULL, 'bHLH_TS_ASCL', NULL, 'bHLH_TS_ASCL', NULL, NULL, NULL, 2),
(11588, NULL, 'cd13359', NULL, NULL, 'PH_ELMO1_CED-12', NULL, 'PH_ELMO1_CED-12', NULL, NULL, NULL, 2),
(11589, NULL, 'cd14286', NULL, NULL, 'UBA_UBP24', NULL, 'UBA_UBP24', NULL, NULL, NULL, 2),
(11590, NULL, 'cd15601', NULL, NULL, 'PHD5_KMT2D', NULL, 'PHD5_KMT2D', NULL, NULL, NULL, 2),
(11591, NULL, 'cd02604', NULL, NULL, 'HAD_5NT', NULL, 'HAD_5NT', NULL, NULL, 4003, 2),
(11592, NULL, 'cd14135', NULL, NULL, 'STKc_PRP4', NULL, 'STKc_PRP4', NULL, NULL, 35129, 2),
(11593, NULL, 'cd12083', NULL, NULL, 'DD_cGKI', NULL, 'DD_cGKI', NULL, NULL, NULL, 2);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(11594, NULL, 'cd16682', NULL, NULL, 'RING-H2_RNF165', NULL, 'RING-H2_RNF165', NULL, NULL, NULL, 2),
(11595, NULL, 'cd02410', NULL, NULL, 'archeal_CPSF_KH', NULL, 'archeal_CPSF_KH', NULL, NULL, NULL, 2),
(11596, NULL, 'cd09498', NULL, NULL, 'SAM_caskin1,2_repeat2', NULL, 'SAM_caskin1,2_repeat2', NULL, NULL, 16562, 2),
(11597, NULL, 'cd10975', NULL, NULL, 'CE4_CDA_like_2', NULL, 'CE4_CDA_like_2', NULL, NULL, NULL, 2),
(11598, NULL, 'cd13381', NULL, NULL, 'PH_Skap-hom_Skap2', NULL, 'PH_Skap-hom_Skap2', NULL, NULL, NULL, 2),
(11599, NULL, 'cd05311', NULL, NULL, 'NAD_bind_2_malic_enz', NULL, 'NAD_bind_2_malic_enz', NULL, NULL, 36408, 2),
(11600, NULL, 'cd05683', NULL, NULL, 'M20_peptT_like', NULL, 'M20_peptT_like', NULL, NULL, NULL, 2),
(11601, NULL, 'cd13572', NULL, NULL, 'PBP2_PnhD_2', NULL, 'PBP2_PnhD_2', NULL, NULL, NULL, 2),
(11602, NULL, 'cd03274', NULL, NULL, 'ABC_SMC4_euk', NULL, 'ABC_SMC4_euk', NULL, NULL, 30685, 2),
(11603, NULL, 'cd16390', NULL, NULL, 'ParB_N_Srx_like', NULL, 'ParB_N_Srx_like', NULL, NULL, 14170, 2),
(11604, NULL, 'cd05867', NULL, NULL, 'Ig4_L1-CAM_like', NULL, 'Ig4_L1-CAM_like', NULL, NULL, NULL, 2),
(11605, NULL, 'cd05211', NULL, NULL, 'NAD_bind_Glu_Leu_Phe_Val', NULL, 'NAD_bind_Glu_Leu_Phe_Val', NULL, NULL, NULL, 2),
(11606, NULL, 'cd13345', NULL, NULL, 'PH-GRAM_MTMR8', NULL, 'PH-GRAM_MTMR8', NULL, NULL, NULL, 2),
(11607, NULL, 'cd13658', NULL, NULL, 'PBP2_CMBP', NULL, 'PBP2_CMBP', NULL, NULL, NULL, 2),
(11608, NULL, 'cd11363', NULL, NULL, 'RNase_PH_PNPase_1', NULL, 'RNase_PH_PNPase_1', NULL, NULL, NULL, 2),
(11609, NULL, 'cd11395', NULL, NULL, 'bHLHzip_SREBP_like', NULL, 'bHLHzip_SREBP_like', NULL, NULL, NULL, 2),
(11610, NULL, 'cd12939', NULL, NULL, 'LEM_emerin', NULL, 'LEM_emerin', NULL, NULL, 33460, 2),
(11611, NULL, 'cd03172', NULL, NULL, 'SORL_classII', NULL, 'SORL_classII', NULL, NULL, NULL, 2),
(11612, NULL, 'cd09446', NULL, NULL, 'LIM_N_RAP', NULL, 'LIM_N_RAP', NULL, NULL, NULL, 2),
(11613, NULL, 'cd09513', NULL, NULL, 'SAM_BAR', NULL, 'SAM_BAR', NULL, NULL, NULL, 2),
(11614, NULL, 'cd03595', NULL, NULL, 'CLECT_chondrolectin_like', NULL, 'CLECT_chondrolectin_like', NULL, NULL, NULL, 2),
(11615, NULL, 'cd16169', NULL, NULL, 'Tau138_eWH', NULL, 'Tau138_eWH', NULL, NULL, 33169, 2),
(11616, NULL, 'cd09750', NULL, NULL, 'Csa5_I-A', NULL, 'Csa5_I-A', NULL, NULL, NULL, 2),
(11617, NULL, 'cd18070', NULL, NULL, 'DEXQc_SHPRH', NULL, 'DEXQc_SHPRH', NULL, NULL, NULL, 2),
(11618, NULL, 'cd06464', NULL, NULL, 'ACD_sHsps-like', NULL, 'ACD_sHsps-like', NULL, NULL, NULL, 2),
(11619, NULL, 'cd11604', NULL, NULL, 'RTT106_N', NULL, 'RTT106_N', NULL, NULL, 28221, 2),
(11620, NULL, 'cd12885', NULL, NULL, 'SPRY_RanBP_like', NULL, 'SPRY_RanBP_like', NULL, NULL, 34216, 2),
(11621, NULL, 'cd08931', NULL, NULL, 'SDR_c9', NULL, 'SDR_c9', NULL, NULL, NULL, 2),
(11622, NULL, 'cd00390', NULL, NULL, 'Urease_gamma', NULL, 'Urease_gamma', NULL, NULL, 5051, 2),
(11623, NULL, 'cd11329', NULL, NULL, 'AmyAc_maltase-like', NULL, 'AmyAc_maltase-like', NULL, NULL, NULL, 2),
(11624, NULL, 'cd12810', NULL, NULL, 'Esterase_713_like-3', NULL, 'Esterase_713_like-3', NULL, NULL, NULL, 2),
(11625, NULL, 'cd01577', NULL, NULL, 'IPMI_Swivel', NULL, 'IPMI_Swivel', NULL, NULL, 29311, 2),
(11626, NULL, 'cd15428', NULL, NULL, '7tmA_OR2D-like', NULL, '7tmA_OR2D-like', NULL, NULL, NULL, 2),
(11627, NULL, 'cd00883', NULL, NULL, 'beta_CA_cladeA', NULL, 'beta_CA_cladeA', NULL, NULL, NULL, 2),
(11628, NULL, 'cd08865', NULL, NULL, 'SRPBCC_10', NULL, 'SRPBCC_10', NULL, NULL, NULL, 2),
(11629, NULL, 'cd15129', NULL, NULL, '7tmA_GPR142', NULL, '7tmA_GPR142', NULL, NULL, NULL, 2),
(11630, NULL, 'cd20240', NULL, NULL, 'PFM_aerolysin-like', NULL, 'PFM_aerolysin-like', NULL, NULL, NULL, 2),
(11631, NULL, 'cd17002', NULL, NULL, 'CID_RPRD1', NULL, 'CID_RPRD1', NULL, NULL, NULL, 2),
(11632, NULL, 'cd07042', NULL, NULL, 'STAS_SulP_like_sulfate_transporter', NULL, 'STAS_SulP_like_sulfate_transporter', NULL, NULL, NULL, 2),
(11633, NULL, 'cd18780', NULL, NULL, 'ABC_6TM_AtABCB27_like', NULL, 'ABC_6TM_AtABCB27_like', NULL, NULL, NULL, 2);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(11634, NULL, 'cd18808', NULL, NULL, 'SF1_C_Upf1', NULL, 'SF1_C_Upf1', NULL, NULL, 30150, 2),
(11635, NULL, 'cd07333', NULL, NULL, 'M48C_bepA_like', NULL, 'M48C_bepA_like', NULL, NULL, NULL, 2),
(11636, NULL, 'cd16579', NULL, NULL, 'RING-HC_PML_C-V', NULL, 'RING-HC_PML_C-V', NULL, NULL, NULL, 2),
(11637, NULL, 'cd10531', NULL, NULL, 'SET_SETD2-like', NULL, 'SET_SETD2-like', NULL, NULL, NULL, 2),
(11638, NULL, 'cd08223', NULL, NULL, 'STKc_Nek4', NULL, 'STKc_Nek4', NULL, NULL, NULL, 2),
(11639, NULL, 'cd15685', NULL, NULL, 'PHD_ING5', NULL, 'PHD_ING5', NULL, NULL, NULL, 2),
(11640, NULL, 'cd08890', NULL, NULL, 'SRPBCC_PITPNC1_like', NULL, 'SRPBCC_PITPNC1_like', NULL, NULL, NULL, 2),
(11641, NULL, 'cd16724', NULL, NULL, 'RING1-HC_MIB1', NULL, 'RING1-HC_MIB1', NULL, NULL, NULL, 2),
(11642, NULL, 'cd17266', NULL, NULL, 'RMtype1_S_Sau1132ORF3780P-TRD2-CR2_like', NULL, 'RMtype1_S_Sau1132ORF3780P-TRD2-CR2_like', NULL, NULL, NULL, 2),
(11643, NULL, 'cd06070', NULL, NULL, 'H2MP_like-2', NULL, 'H2MP_like-2', NULL, NULL, NULL, 2),
(11644, NULL, 'cd08985', NULL, NULL, 'GH43_CtGH43-like', NULL, 'GH43_CtGH43-like', NULL, NULL, NULL, 2),
(11645, NULL, 'cd00330', NULL, NULL, 'phosphagen_kinases', NULL, 'phosphagen_kinases', NULL, NULL, NULL, 2),
(11646, NULL, 'cd16814', NULL, NULL, 'RING-HC_RNF20', NULL, 'RING-HC_RNF20', NULL, NULL, NULL, 2),
(11647, NULL, 'cd02012', NULL, NULL, 'TPP_TK', NULL, 'TPP_TK', NULL, NULL, 902, 2),
(11648, NULL, 'cd12194', NULL, NULL, 'Kcc4p_like_C', NULL, 'Kcc4p_like_C', NULL, NULL, NULL, 2),
(11649, NULL, 'cd13367', NULL, NULL, 'PH_BCR_vertebrate', NULL, 'PH_BCR_vertebrate', NULL, NULL, NULL, 2),
(11650, NULL, 'cd15955', NULL, NULL, '7tmA_OR52A-like', NULL, '7tmA_OR52A-like', NULL, NULL, NULL, 2),
(11651, NULL, 'cd17148', NULL, NULL, 'DCX2_RP1L1', NULL, 'DCX2_RP1L1', NULL, NULL, NULL, 2),
(11652, NULL, 'cd01949', NULL, NULL, 'GGDEF', NULL, 'GGDEF', NULL, NULL, 1794, 2),
(11653, NULL, 'cd03466', NULL, NULL, 'Nitrogenase_NifN_2', NULL, 'Nitrogenase_NifN_2', NULL, NULL, NULL, 2),
(11654, NULL, 'cd07692', NULL, NULL, 'Ig_CD3_epsilon', NULL, 'Ig_CD3_epsilon', NULL, NULL, NULL, 2),
(11655, NULL, 'cd11292', NULL, NULL, 'gelsolin_S3_like', NULL, 'gelsolin_S3_like', NULL, NULL, NULL, 2),
(11656, NULL, 'cd01851', NULL, NULL, 'GBP', NULL, 'GBP', NULL, NULL, NULL, 2),
(11657, NULL, 'cd09873', NULL, NULL, 'PIN_Pae0151-like', NULL, 'PIN_Pae0151-like', NULL, NULL, 36514, 2),
(11658, NULL, 'cd11384', NULL, NULL, 'RagA_like', NULL, 'RagA_like', NULL, NULL, 33029, 2),
(11659, NULL, 'cd15192', NULL, NULL, '7tmA_AT1R', NULL, '7tmA_AT1R', NULL, NULL, NULL, 2),
(11660, NULL, 'cd12699', NULL, NULL, 'RRM3_hnRNPL', NULL, 'RRM3_hnRNPL', NULL, NULL, 33096, 2),
(11661, NULL, 'cd04603', NULL, NULL, 'CBS_pair_KefB_assoc', NULL, 'CBS_pair_KefB_assoc', NULL, NULL, NULL, 2),
(11662, NULL, 'cd03722', NULL, NULL, 'SOCS_ASB3', NULL, 'SOCS_ASB3', NULL, NULL, 30791, 2),
(11663, NULL, 'cd07709', NULL, NULL, 'flavodiiron_proteins_MBL-fold', NULL, 'flavodiiron_proteins_MBL-fold', NULL, NULL, NULL, 2),
(11664, NULL, 'cd18416', NULL, NULL, 'BTB_Shaw-like', NULL, 'BTB_Shaw-like', NULL, NULL, NULL, 2),
(11665, NULL, 'cd10944', NULL, NULL, 'CE4_SmPgdA_like', NULL, 'CE4_SmPgdA_like', NULL, NULL, NULL, 2),
(11666, NULL, 'cd18238', NULL, NULL, 'BTB_POZ_KLHL8', NULL, 'BTB_POZ_KLHL8', NULL, NULL, NULL, 2),
(11667, NULL, 'cd13956', NULL, NULL, 'PT_UbiA', NULL, 'PT_UbiA', NULL, NULL, NULL, 2),
(11668, NULL, 'cd12594', NULL, NULL, 'RRM1_SRSF4', NULL, 'RRM1_SRSF4', NULL, NULL, NULL, 2),
(11669, NULL, 'cd03272', NULL, NULL, 'ABC_SMC3_euk', NULL, 'ABC_SMC3_euk', NULL, NULL, 30698, 2),
(11670, NULL, 'cd05516', NULL, NULL, 'Bromo_SNF2L2', NULL, 'Bromo_SNF2L2', NULL, NULL, NULL, 2),
(11671, NULL, 'cd09009', NULL, NULL, 'PNP-EcPNPII_like', NULL, 'PNP-EcPNPII_like', NULL, NULL, 9806, 2),
(11672, NULL, 'cd03294', NULL, NULL, 'ABC_Pro_Gly_Betaine', NULL, 'ABC_Pro_Gly_Betaine', NULL, NULL, NULL, 2),
(11673, NULL, 'cd00401', NULL, NULL, 'SAHH', NULL, 'SAHH', NULL, NULL, 3741, 2),
(11674, NULL, 'cd03055', NULL, NULL, 'GST_N_Omega', NULL, 'GST_N_Omega', NULL, NULL, NULL, 2);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(11675, NULL, 'cd08355', NULL, NULL, 'TioX_like', NULL, 'TioX_like', NULL, NULL, NULL, 2),
(11676, NULL, 'cd13437', NULL, NULL, 'SPFH_alloslipin', NULL, 'SPFH_alloslipin', NULL, NULL, NULL, 2),
(11677, NULL, 'cd14995', NULL, NULL, '7tmA_TRH-R', NULL, '7tmA_TRH-R', NULL, NULL, NULL, 2),
(11678, NULL, 'cd16233', NULL, NULL, 'EFh_SPARC_FSTL1', NULL, 'EFh_SPARC_FSTL1', NULL, NULL, NULL, 2),
(11679, NULL, 'cd14174', NULL, NULL, 'STKc_Mnk1', NULL, 'STKc_Mnk1', NULL, NULL, NULL, 2),
(11680, NULL, 'cd01212', NULL, NULL, 'PTB_JIP', NULL, 'PTB_JIP', NULL, NULL, NULL, 2),
(11681, NULL, 'cd14224', NULL, NULL, 'PKc_DYRK2_3', NULL, 'PKc_DYRK2_3', NULL, NULL, NULL, 2),
(11682, NULL, 'cd16358', NULL, NULL, 'GlxI_Ni', NULL, 'GlxI_Ni', NULL, NULL, NULL, 2),
(11683, NULL, 'cd11234', NULL, NULL, 'E_set_GDE_N', NULL, 'E_set_GDE_N', NULL, NULL, NULL, 2),
(11684, NULL, 'cd18467', NULL, NULL, 'BACK_KLHL28_BTBD5', NULL, 'BACK_KLHL28_BTBD5', NULL, NULL, NULL, 2),
(11685, NULL, 'cd11410', NULL, NULL, 'bHLH_O_HES', NULL, 'bHLH_O_HES', NULL, NULL, NULL, 2),
(11686, NULL, 'cd15905', NULL, NULL, '7tmA_GPBAR1', NULL, '7tmA_GPBAR1', NULL, NULL, NULL, 2),
(11687, NULL, 'cd05813', NULL, NULL, 'CBM20_genethonin_1', NULL, 'CBM20_genethonin_1', NULL, NULL, 13679, 2),
(11688, NULL, 'cd12059', NULL, NULL, 'SH3_MLK1-3', NULL, 'SH3_MLK1-3', NULL, NULL, 31766, 2),
(11689, NULL, 'cd13528', NULL, NULL, 'PBP2_osmoprotectants', NULL, 'PBP2_osmoprotectants', NULL, NULL, NULL, 2),
(11690, NULL, 'cd09614', NULL, NULL, 'griffithsin_like', NULL, 'griffithsin_like', NULL, NULL, NULL, 2),
(11691, NULL, 'cd03024', NULL, NULL, 'DsbA_FrnE', NULL, 'DsbA_FrnE', NULL, NULL, NULL, 2),
(11692, NULL, 'cd17473', NULL, NULL, 'MFS_arabinose_efflux_permease_like', NULL, 'MFS_arabinose_efflux_permease_like', NULL, NULL, NULL, 2),
(11693, NULL, 'cd21526', NULL, NULL, 'CoV_Nsp6', NULL, 'CoV_Nsp6', NULL, NULL, NULL, 2),
(11694, NULL, 'cd05914', NULL, NULL, 'LC_FACL_like', NULL, 'LC_FACL_like', NULL, NULL, NULL, 2),
(11695, NULL, 'cd03366', NULL, NULL, 'TOPRIM_TopoIIA_GyrB', NULL, 'TOPRIM_TopoIIA_GyrB', NULL, NULL, 26933, 2),
(11696, NULL, 'cd19579', NULL, NULL, 'serpin1K-like', NULL, 'serpin1K-like', NULL, NULL, NULL, 2),
(11697, NULL, 'cd15341', NULL, NULL, '7tmA_CB2', NULL, '7tmA_CB2', NULL, NULL, NULL, 2),
(11698, NULL, 'cd18437', NULL, NULL, 'BRCT_BRC1_like_rpt3', NULL, 'BRCT_BRC1_like_rpt3', NULL, NULL, NULL, 2),
(11699, NULL, 'cd03368', NULL, NULL, 'Ribosomal_S12', NULL, 'Ribosomal_S12', NULL, NULL, 3549, 2),
(11700, NULL, 'cd12086', NULL, NULL, 'DD_cGKI-beta', NULL, 'DD_cGKI-beta', NULL, NULL, NULL, 2),
(11701, NULL, 'cd07445', NULL, NULL, 'CRD_corin_1', NULL, 'CRD_corin_1', NULL, NULL, 30438, 2),
(11702, NULL, 'cd05625', NULL, NULL, 'STKc_LATS1', NULL, 'STKc_LATS1', NULL, NULL, 36080, 2),
(11703, NULL, 'cd07781', NULL, NULL, 'FGGY_RBK', NULL, 'FGGY_RBK', NULL, NULL, 140, 2),
(11704, NULL, 'cd05050', NULL, NULL, 'PTKc_Musk', NULL, 'PTKc_Musk', NULL, NULL, NULL, 2),
(11705, NULL, 'cd18400', NULL, NULL, 'BTB_POZ_KCTD13_BACURD1', NULL, 'BTB_POZ_KCTD13_BACURD1', NULL, NULL, NULL, 2),
(11706, NULL, 'cd09339', NULL, NULL, 'LIM4_Paxillin_like', NULL, 'LIM4_Paxillin_like', NULL, NULL, NULL, 2),
(11707, NULL, 'cd15798', NULL, NULL, 'PMEI-like_3', NULL, 'PMEI-like_3', NULL, NULL, NULL, 2),
(11708, NULL, 'cd12051', NULL, NULL, 'SH3_DOCK1_5_A', NULL, 'SH3_DOCK1_5_A', NULL, NULL, NULL, 2),
(11709, NULL, 'cd18798', NULL, NULL, 'SF2_C_reverse_gyrase', NULL, 'SF2_C_reverse_gyrase', NULL, NULL, NULL, 2),
(11710, NULL, 'cd07298', NULL, NULL, 'PX_RICS', NULL, 'PX_RICS', NULL, NULL, 35733, 2),
(11711, NULL, 'cd09546', NULL, NULL, 'SAM_EPH-A5', NULL, 'SAM_EPH-A5', NULL, NULL, NULL, 2),
(11712, NULL, 'cd12005', NULL, NULL, 'SH3_Lck', NULL, 'SH3_Lck', NULL, NULL, 30115, 2),
(11713, NULL, 'cd01087', NULL, NULL, 'Prolidase', NULL, 'Prolidase', NULL, NULL, NULL, 2),
(11714, NULL, 'cd16963', NULL, NULL, 'CCE1', NULL, 'CCE1', NULL, NULL, NULL, 2),
(11715, NULL, 'cd05112', NULL, NULL, 'PTKc_Itk', NULL, 'PTKc_Itk', NULL, NULL, 35033, 2),
(11716, NULL, 'cd06565', NULL, NULL, 'GH20_GcnA-like', NULL, 'GH20_GcnA-like', NULL, NULL, NULL, 2);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(11717, NULL, 'cd18265', NULL, NULL, 'BTB_POZ_KLHL35', NULL, 'BTB_POZ_KLHL35', NULL, NULL, NULL, 2),
(11718, NULL, 'cd09213', NULL, NULL, 'Luminal_IRE1_like', NULL, 'Luminal_IRE1_like', NULL, NULL, NULL, 2),
(11719, NULL, 'cd21651', NULL, NULL, 'ORF4b_MERS-CoV-like', NULL, 'ORF4b_MERS-CoV-like', NULL, NULL, 35261, 2),
(11720, NULL, 'cd06831', NULL, NULL, 'PLPDE_III_ODC_like_AZI', NULL, 'PLPDE_III_ODC_like_AZI', NULL, NULL, NULL, 2),
(11721, NULL, 'cd17203', NULL, NULL, 'FERM_F1_EPB41L3', NULL, 'FERM_F1_EPB41L3', NULL, NULL, NULL, 2),
(11722, NULL, 'cd21515', NULL, NULL, 'cv_beta_Nsp2_SARS_MHV-like', NULL, 'cv_beta_Nsp2_SARS_MHV-like', NULL, NULL, NULL, 2),
(11723, NULL, 'cd17227', NULL, NULL, 'RA_ARAP2', NULL, 'RA_ARAP2', NULL, NULL, NULL, 2),
(11724, NULL, 'cd15819', NULL, NULL, 'SPRY_PRY_BTN1_2', NULL, 'SPRY_PRY_BTN1_2', NULL, NULL, 32741, 2),
(11725, NULL, 'cd16548', NULL, NULL, 'RING-HC_RNF152', NULL, 'RING-HC_RNF152', NULL, NULL, NULL, 2),
(11726, NULL, 'cd03509', NULL, NULL, 'DesA_FADS-like', NULL, 'DesA_FADS-like', NULL, NULL, NULL, 2),
(11727, NULL, 'cd17339', NULL, NULL, 'MFS_NIMT_CynX_like', NULL, 'MFS_NIMT_CynX_like', NULL, NULL, NULL, 2),
(11728, NULL, 'cd10385', NULL, NULL, 'SH2_SOCS4', NULL, 'SH2_SOCS4', NULL, NULL, 31797, 2),
(11729, NULL, 'cd17426', NULL, NULL, 'MFS_MCT1', NULL, 'MFS_MCT1', NULL, NULL, NULL, 2),
(11730, NULL, 'cd08049', NULL, NULL, 'TAF8', NULL, 'TAF8', NULL, NULL, 17312, 2),
(11731, NULL, 'cd04409', NULL, NULL, 'RhoGAP_PARG1', NULL, 'RhoGAP_PARG1', NULL, NULL, NULL, 2),
(11732, NULL, 'cd08050', NULL, NULL, 'TAF6C', NULL, 'TAF6C', NULL, NULL, 13902, 2),
(11733, NULL, 'cd01229', NULL, NULL, 'PH_Ect2', NULL, 'PH_Ect2', NULL, NULL, NULL, 2),
(11734, NULL, 'cd02258', NULL, NULL, 'Peptidase_C25_N', NULL, 'Peptidase_C25_N', NULL, NULL, NULL, 2),
(11735, NULL, 'cd12125', NULL, NULL, 'APC_alpha', NULL, 'APC_alpha', NULL, NULL, NULL, 2),
(11736, NULL, 'cd14903', NULL, NULL, 'MYSc_Myo42', NULL, 'MYSc_Myo42', NULL, NULL, NULL, 2),
(11737, NULL, 'cd12695', NULL, NULL, 'RRM3_PTBP1', NULL, 'RRM3_PTBP1', NULL, NULL, 20766, 2),
(11738, NULL, 'cd14104', NULL, NULL, 'STKc_Titin', NULL, 'STKc_Titin', NULL, NULL, NULL, 2),
(11739, NULL, 'cd03068', NULL, NULL, 'PDI_b_ERp72', NULL, 'PDI_b_ERp72', NULL, NULL, 30283, 2),
(11740, NULL, 'cd12589', NULL, NULL, 'RRM2_PSP1', NULL, 'RRM2_PSP1', NULL, NULL, 32069, 2),
(11741, NULL, 'cd16079', NULL, NULL, 'TSP-3cc', NULL, 'TSP-3cc', NULL, NULL, NULL, 2),
(11742, NULL, 'cd16948', NULL, NULL, 'HATPase_BceS-YxdK-YvcQ-like', NULL, 'HATPase_BceS-YxdK-YvcQ-like', NULL, NULL, NULL, 2),
(11743, NULL, 'cd13534', NULL, NULL, 'PBP2_MqnD_like', NULL, 'PBP2_MqnD_like', NULL, NULL, NULL, 2),
(11744, NULL, 'cd11370', NULL, NULL, 'RNase_PH_RRP41', NULL, 'RNase_PH_RRP41', NULL, NULL, NULL, 2),
(11745, NULL, 'cd04471', NULL, NULL, 'S1_RNase_R', NULL, 'S1_RNase_R', NULL, NULL, NULL, 2),
(11746, NULL, 'cd13409', NULL, NULL, 'TNFRSF8', NULL, 'TNFRSF8', NULL, NULL, 15088, 2),
(11747, NULL, 'cd08207', NULL, NULL, 'RLP_NonPhot', NULL, 'RLP_NonPhot', NULL, NULL, NULL, 2),
(11748, NULL, 'cd14505', NULL, NULL, 'CDKN3-like', NULL, 'CDKN3-like', NULL, NULL, NULL, 2),
(11749, NULL, 'cd18459', NULL, NULL, 'BACK_KLHL20', NULL, 'BACK_KLHL20', NULL, NULL, NULL, 2),
(11750, NULL, 'cd02782', NULL, NULL, 'MopB_CT_1', NULL, 'MopB_CT_1', NULL, NULL, NULL, 2),
(11751, NULL, 'cd05304', NULL, NULL, 'Rubrum_tdh', NULL, 'Rubrum_tdh', NULL, NULL, NULL, 2),
(11752, NULL, 'cd01951', NULL, NULL, 'lectin_L-type', NULL, 'lectin_L-type', NULL, NULL, NULL, 2),
(11753, NULL, 'cd03489', NULL, NULL, 'Topoisomer_IB_N_LdtopoI_like', NULL, 'Topoisomer_IB_N_LdtopoI_like', NULL, NULL, NULL, 2),
(11754, NULL, 'cd14636', NULL, NULL, 'R-PTPc-K-2', NULL, 'R-PTPc-K-2', NULL, NULL, NULL, 2),
(11755, NULL, 'cd15657', NULL, NULL, 'PHD4_NSD2', NULL, 'PHD4_NSD2', NULL, NULL, NULL, 2),
(11756, NULL, 'cd10517', NULL, NULL, 'SET_SETDB1', NULL, 'SET_SETDB1', NULL, NULL, NULL, 2),
(11757, NULL, 'cd06409', NULL, NULL, 'PB1_MUG70', NULL, 'PB1_MUG70', NULL, NULL, NULL, 2),
(11758, NULL, 'cd04397', NULL, NULL, 'RhoGAP_fLRG1', NULL, 'RhoGAP_fLRG1', NULL, NULL, NULL, 2); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(11759, NULL, 'cd04169', NULL, NULL, 'RF3', NULL, 'RF3', NULL, NULL, 29906, 2),
(11760, NULL, 'cd14619', NULL, NULL, 'R-PTPc-H', NULL, 'R-PTPc-H', NULL, NULL, NULL, 2),
(11761, NULL, 'cd07295', NULL, NULL, 'PX_Grd19', NULL, 'PX_Grd19', NULL, NULL, 33809, 2),
(11762, NULL, 'cd09817', NULL, NULL, 'linoleate_diol_synthase_like', NULL, 'linoleate_diol_synthase_like', NULL, NULL, 15884, 2),
(11763, NULL, 'cd07604', NULL, NULL, 'BAR_ASAPs', NULL, 'BAR_ASAPs', NULL, NULL, NULL, 2),
(11764, NULL, 'cd04415', NULL, NULL, 'NDPk7A', NULL, 'NDPk7A', NULL, NULL, 33350, 2),
(11765, NULL, 'cd14210', NULL, NULL, 'PKc_DYRK', NULL, 'PKc_DYRK', NULL, NULL, NULL, 2),
(11766, NULL, 'cd11872', NULL, NULL, 'SH3_DOCK_AB', NULL, 'SH3_DOCK_AB', NULL, NULL, NULL, 2),
(11767, NULL, 'cd18951', NULL, NULL, 'bHLH_TS_scleraxis', NULL, 'bHLH_TS_scleraxis', NULL, NULL, NULL, 2),
(11768, NULL, 'cd08305', NULL, NULL, 'Pyrin', NULL, 'Pyrin', NULL, NULL, NULL, 2),
(11769, NULL, 'cd13554', NULL, NULL, 'PBP2_DszB', NULL, 'PBP2_DszB', NULL, NULL, NULL, 2),
(11770, NULL, 'cd09175', NULL, NULL, 'PLDc_Bfil', NULL, 'PLDc_Bfil', NULL, NULL, NULL, 2),
(11771, NULL, 'cd19965', NULL, NULL, 'PBP1_ABC_sugar_binding-like', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, NULL, 2),
(11772, NULL, 'cd09300', NULL, NULL, 'DEAD-like_helicase_C', NULL, 'DEAD-like_helicase_C', NULL, NULL, NULL, 2),
(11773, NULL, 'cd01481', NULL, NULL, 'vWA_collagen_alpha3-VI-like', NULL, 'vWA_collagen_alpha3-VI-like', NULL, NULL, 30920, 2),
(11774, NULL, 'cd04620', NULL, NULL, 'CBS_two-component_sensor_histidine_kinase_repeat1', NULL, 'CBS_two-component_sensor_histidine_kinase_repeat1', NULL, NULL, NULL, 2),
(11775, NULL, 'cd00464', NULL, NULL, 'SK', NULL, 'SK', NULL, NULL, 5997, 2),
(11776, NULL, 'cd11243', NULL, NULL, 'Sema_7A', NULL, 'Sema_7A', NULL, NULL, 35478, 2),
(11777, NULL, 'cd04659', NULL, NULL, 'Piwi_piwi-like_ProArk', NULL, 'Piwi_piwi-like_ProArk', NULL, NULL, NULL, 2),
(11778, NULL, 'cd09354', NULL, NULL, 'LIM2_LPP', NULL, 'LIM2_LPP', NULL, NULL, NULL, 2),
(11779, NULL, 'cd08247', NULL, NULL, 'AST1_like', NULL, 'AST1_like', NULL, NULL, NULL, 2),
(11780, NULL, 'cd14354', NULL, NULL, 'UBA_UBP25', NULL, 'UBA_UBP25', NULL, NULL, NULL, 2),
(11781, NULL, 'cd05718', NULL, NULL, 'Ig1_PVR_like', NULL, 'Ig1_PVR_like', NULL, NULL, NULL, 2),
(11782, NULL, 'cd11760', NULL, NULL, 'SH3_MIA_like', NULL, 'SH3_MIA_like', NULL, NULL, NULL, 2),
(11783, NULL, 'cd01219', NULL, NULL, 'PH1_FGD1', NULL, 'PH1_FGD1', NULL, NULL, 22763, 2),
(11784, NULL, 'cd05731', NULL, NULL, 'Ig3_L1-CAM_like', NULL, 'Ig3_L1-CAM_like', NULL, NULL, NULL, 2),
(11785, NULL, 'cd01414', NULL, NULL, 'SAICAR_synt_Sc', NULL, 'SAICAR_synt_Sc', NULL, NULL, NULL, 2),
(11786, NULL, 'cd13521', NULL, NULL, 'PBP2_AlgQ_like', NULL, 'PBP2_AlgQ_like', NULL, NULL, NULL, 2),
(11787, NULL, 'cd12744', NULL, NULL, 'RRM1_RBM12B', NULL, 'RRM1_RBM12B', NULL, NULL, NULL, 2),
(11788, NULL, 'cd19340', NULL, NULL, 'Wnt_Wnt8', NULL, 'Wnt_Wnt8', NULL, NULL, NULL, 2),
(11789, NULL, 'cd02643', NULL, NULL, 'R3H_NF-X1', NULL, 'R3H_NF-X1', NULL, NULL, 26112, 2),
(11790, NULL, 'cd08684', NULL, NULL, 'C2A_Tac2-N', NULL, 'C2A_Tac2-N', NULL, NULL, 28240, 2),
(11791, NULL, 'cd16187', NULL, NULL, 'EFh_PEF_sorcin', NULL, 'EFh_PEF_sorcin', NULL, NULL, NULL, 2),
(11792, NULL, 'cd21566', NULL, NULL, 'gammaCoV_M', NULL, 'gammaCoV_M', NULL, NULL, 35442, 2),
(11793, NULL, 'cd16179', NULL, NULL, 'EFh_HEF_CBN', NULL, 'EFh_HEF_CBN', NULL, NULL, 31320, 2),
(11794, NULL, 'cd15907', NULL, NULL, '7tmA_GPR153', NULL, '7tmA_GPR153', NULL, NULL, NULL, 2),
(11795, NULL, 'cd01476', NULL, NULL, 'VWA_integrin_invertebrates', NULL, 'VWA_integrin_invertebrates', NULL, NULL, NULL, 2),
(11796, NULL, 'cd01362', NULL, NULL, 'Fumarase_classII', NULL, 'Fumarase_classII', NULL, NULL, 3732, 2),
(11797, NULL, 'cd13268', NULL, NULL, 'PH_Brdg1', NULL, 'PH_Brdg1', NULL, NULL, NULL, 2),
(11798, NULL, 'cd16945', NULL, NULL, 'HATPase_CreC-like', NULL, 'HATPase_CreC-like', NULL, NULL, NULL, 2),
(11799, NULL, 'cd09106', NULL, NULL, 'PLDc_vPLD3_4_5_like_1', NULL, 'PLDc_vPLD3_4_5_like_1', NULL, NULL, NULL, 2);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(11800, NULL, 'cd15012', NULL, NULL, '7tmA_Trissin_R', NULL, '7tmA_Trissin_R', NULL, NULL, NULL, 2),
(11801, NULL, 'cd12417', NULL, NULL, 'RRM_SAFB_like', NULL, 'RRM_SAFB_like', NULL, NULL, NULL, 2),
(11802, NULL, 'cd01770', NULL, NULL, 'UBX_UBXN2', NULL, 'UBX_UBXN2', NULL, NULL, NULL, 2),
(11803, NULL, 'cd04724', NULL, NULL, 'Tryptophan_synthase_alpha', NULL, 'Tryptophan_synthase_alpha', NULL, NULL, 5400, 2),
(11804, NULL, 'cd05907', NULL, NULL, 'VL_LC_FACS_like', NULL, 'VL_LC_FACS_like', NULL, NULL, NULL, 2),
(11805, NULL, 'cd16084', NULL, NULL, 'IgC_CH2_IgD', NULL, 'IgC_CH2_IgD', NULL, NULL, NULL, 2),
(11806, NULL, 'cd17007', NULL, NULL, 'ANTH_N_Sla2p', NULL, 'ANTH_N_Sla2p', NULL, NULL, NULL, 2),
(11807, NULL, 'cd07622', NULL, NULL, 'BAR_SNX4', NULL, 'BAR_SNX4', NULL, NULL, 33224, 2),
(11808, NULL, 'cd03673', NULL, NULL, 'Ap6A_hydrolase', NULL, 'Ap6A_hydrolase', NULL, NULL, NULL, 2),
(11809, NULL, 'cd00111', NULL, NULL, 'Trefoil', NULL, 'Trefoil', NULL, NULL, 5964, 2),
(11810, NULL, 'cd02062', NULL, NULL, 'Nitro_FMN_reductase', NULL, 'Nitro_FMN_reductase', NULL, NULL, NULL, 2),
(11811, NULL, 'cd19405', NULL, NULL, 'TGF_beta_INHBB', NULL, 'TGF_beta_INHBB', NULL, NULL, NULL, 2),
(11812, NULL, 'cd06301', NULL, NULL, 'PBP1_rhizopine_binding-like', NULL, 'PBP1_rhizopine_binding-like', NULL, NULL, NULL, 2),
(11813, NULL, 'cd08549', NULL, NULL, 'G1PDH_related', NULL, 'G1PDH_related', NULL, NULL, NULL, 2),
(11814, NULL, 'cd16604', NULL, NULL, 'RING-HC_TRIM47_C-IV', NULL, 'RING-HC_TRIM47_C-IV', NULL, NULL, NULL, 2),
(11815, NULL, 'cd18184', NULL, NULL, 'ATP-synt_Fo_c_NaATPase', NULL, 'ATP-synt_Fo_c_NaATPase', NULL, NULL, NULL, 2),
(11816, NULL, 'cd10363', NULL, NULL, 'SH2_Src_HCK', NULL, 'SH2_Src_HCK', NULL, NULL, 33260, 2),
(11817, NULL, 'cd06377', NULL, NULL, 'PBP1_iGluR_NMDA_NR3', NULL, 'PBP1_iGluR_NMDA_NR3', NULL, NULL, NULL, 2),
(11818, NULL, 'cd07227', NULL, NULL, 'Pat_Fungal_NTE1', NULL, 'Pat_Fungal_NTE1', NULL, NULL, NULL, 2),
(11819, NULL, 'cd07610', NULL, NULL, 'FCH_F-BAR', NULL, 'FCH_F-BAR', NULL, NULL, NULL, 2),
(11820, NULL, 'cd08182', NULL, NULL, 'HEPD', NULL, 'HEPD', NULL, NULL, 31062, 2),
(11821, NULL, 'cd06599', NULL, NULL, 'GH31_glycosidase_Aec37', NULL, 'GH31_glycosidase_Aec37', NULL, NULL, NULL, 2),
(11822, NULL, 'cd02525', NULL, NULL, 'Succinoglycan_BP_ExoA', NULL, 'Succinoglycan_BP_ExoA', NULL, NULL, NULL, 2),
(11823, NULL, 'cd11818', NULL, NULL, 'SH3_Eve1_5', NULL, 'SH3_Eve1_5', NULL, NULL, NULL, 2),
(11824, NULL, 'cd09568', NULL, NULL, 'SAM_liprin-alpha1,2,3,4_repeat3', NULL, 'SAM_liprin-alpha1,2,3,4_repeat3', NULL, NULL, 32369, 2),
(11825, NULL, 'cd18065', NULL, NULL, 'DEXHc_SMARCA1', NULL, 'DEXHc_SMARCA1', NULL, NULL, 34141, 2),
(11826, NULL, 'cd18097', NULL, NULL, 'SpoU-like', NULL, 'SpoU-like', NULL, NULL, NULL, 2),
(11827, NULL, 'cd02518', NULL, NULL, 'GT2_SpsF', NULL, 'GT2_SpsF', NULL, NULL, NULL, 2),
(11828, NULL, 'cd10718', NULL, NULL, 'SH2_CIS', NULL, 'SH2_CIS', NULL, NULL, 32791, 2),
(11829, NULL, 'cd18113', NULL, NULL, 'ATP-synt_F1_alpha_C', NULL, 'ATP-synt_F1_alpha_C', NULL, NULL, 4623, 2),
(11830, NULL, 'cd17946', NULL, NULL, 'DEADc_DDX24', NULL, 'DEADc_DDX24', NULL, NULL, NULL, 2),
(11831, NULL, 'cd00193', NULL, NULL, 'SNARE', NULL, 'SNARE', NULL, NULL, NULL, 2),
(11832, NULL, 'cd01597', NULL, NULL, 'pCLME', NULL, 'pCLME', NULL, NULL, NULL, 2),
(11833, NULL, 'cd00438', NULL, NULL, 'cupin_RmlC', NULL, 'cupin_RmlC', NULL, NULL, NULL, 2),
(11834, NULL, 'cd10418', NULL, NULL, 'SH2_Src_Fyn_isoform_a_like', NULL, 'SH2_Src_Fyn_isoform_a_like', NULL, NULL, NULL, 2),
(11835, NULL, 'cd14921', NULL, NULL, 'MYSc_Myh11', NULL, 'MYSc_Myh11', NULL, NULL, NULL, 2),
(11836, NULL, 'cd00693', NULL, NULL, 'secretory_peroxidase', NULL, 'secretory_peroxidase', NULL, NULL, 31222, 2),
(11837, NULL, 'cd15960', NULL, NULL, '7tmA_GPR185-like', NULL, '7tmA_GPR185-like', NULL, NULL, NULL, 2),
(11838, NULL, 'cd01318', NULL, NULL, 'DHOase_IIb', NULL, 'DHOase_IIb', NULL, NULL, NULL, 2),
(11839, NULL, 'cd19140', NULL, NULL, 'AKR_AKR3F3', NULL, 'AKR_AKR3F3', NULL, NULL, NULL, 2),
(11840, NULL, 'cd12053', NULL, NULL, 'SH3_CD2AP_1', NULL, 'SH3_CD2AP_1', NULL, NULL, 31516, 2);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(11841, NULL, 'cd11625', NULL, NULL, 'HR1_PKN_3', NULL, 'HR1_PKN_3', NULL, NULL, NULL, 2),
(11842, NULL, 'cd16098', NULL, NULL, 'FliS', NULL, 'FliS', NULL, NULL, 2413, 2),
(11843, NULL, 'cd01583', NULL, NULL, 'IPMI', NULL, 'IPMI', NULL, NULL, 29470, 2),
(11844, NULL, 'cd16577', NULL, NULL, 'RING-HC_MuRF_C-II', NULL, 'RING-HC_MuRF_C-II', NULL, NULL, NULL, 2),
(11845, NULL, 'cd20268', NULL, NULL, 'Complex1_LYR_SDHAF1_LYRM8', NULL, 'Complex1_LYR_SDHAF1_LYRM8', NULL, NULL, 34349, 2),
(11846, NULL, 'cd01992', NULL, NULL, 'PP-ATPase', NULL, 'PP-ATPase', NULL, NULL, 9892, 2),
(11847, NULL, 'cd11244', NULL, NULL, 'Sema_plexin_A', NULL, 'Sema_plexin_A', NULL, NULL, NULL, 2),
(11848, NULL, 'cd17320', NULL, NULL, 'MFS_MdfA_MDR_like', NULL, 'MFS_MdfA_MDR_like', NULL, NULL, NULL, 2),
(11849, NULL, 'cd05348', NULL, NULL, 'BphB-like_SDR_c', NULL, 'BphB-like_SDR_c', NULL, NULL, NULL, 2),
(11850, NULL, 'cd09565', NULL, NULL, 'SAM_liprin-alpha1,2,3,4_repeat2', NULL, 'SAM_liprin-alpha1,2,3,4_repeat2', NULL, NULL, 32432, 2),
(11851, NULL, 'cd00287', NULL, NULL, 'ribokinase_pfkB_like', NULL, 'ribokinase_pfkB_like', NULL, NULL, NULL, 2),
(11852, NULL, 'cd04244', NULL, NULL, 'AAK_AK-LysC-like', NULL, 'AAK_AK-LysC-like', NULL, NULL, 30293, 2),
(11853, NULL, 'cd05622', NULL, NULL, 'STKc_ROCK1', NULL, 'STKc_ROCK1', NULL, NULL, NULL, 2),
(11854, NULL, 'cd21400', NULL, NULL, 'ZBD_UPF1-like', NULL, 'ZBD_UPF1-like', NULL, NULL, 15695, 2),
(11855, NULL, 'cd07044', NULL, NULL, 'CofD_YvcK', NULL, 'CofD_YvcK', NULL, NULL, NULL, 2),
(11856, NULL, 'cd10921', NULL, NULL, 'CE4_MJ0505_like', NULL, 'CE4_MJ0505_like', NULL, NULL, NULL, 2),
(11857, NULL, 'cd04385', NULL, NULL, 'RhoGAP_ARAP', NULL, 'RhoGAP_ARAP', NULL, NULL, 32226, 2),
(11858, NULL, 'cd13384', NULL, NULL, 'PH_Gab2_2', NULL, 'PH_Gab2_2', NULL, NULL, NULL, 2),
(11859, NULL, 'cd06329', NULL, NULL, 'PBP1_SBP-like', NULL, 'PBP1_SBP-like', NULL, NULL, NULL, 2),
(11860, NULL, 'cd18287', NULL, NULL, 'BTB_POZ_BTBD9', NULL, 'BTB_POZ_BTBD9', NULL, NULL, NULL, 2),
(11861, NULL, 'cd03428', NULL, NULL, 'Ap4A_hydrolase_human_like', NULL, 'Ap4A_hydrolase_human_like', NULL, NULL, 6038, 2),
(11862, NULL, 'cd04137', NULL, NULL, 'RheB', NULL, 'RheB', NULL, NULL, NULL, 2),
(11863, NULL, 'cd17229', NULL, NULL, 'RA1_PLC-epsilon', NULL, 'RA1_PLC-epsilon', NULL, NULL, NULL, 2),
(11864, NULL, 'cd13331', NULL, NULL, 'PH_Avo1', NULL, 'PH_Avo1', NULL, NULL, NULL, 2),
(11865, NULL, 'cd13653', NULL, NULL, 'PBP2_phosphate_like_1', NULL, 'PBP2_phosphate_like_1', NULL, NULL, NULL, 2),
(11866, NULL, 'cd15365', NULL, NULL, '7tmA_GPR65_TDAG8', NULL, '7tmA_GPR65_TDAG8', NULL, NULL, NULL, 2),
(11867, NULL, 'cd13616', NULL, NULL, 'PBP2_OsmF', NULL, 'PBP2_OsmF', NULL, NULL, NULL, 2),
(11868, NULL, 'cd16854', NULL, NULL, 'STAT4_CCD', NULL, 'STAT4_CCD', NULL, NULL, NULL, 2),
(11869, NULL, 'cd07087', NULL, NULL, 'ALDH_F3-13-14_CALDH-like', NULL, 'ALDH_F3-13-14_CALDH-like', NULL, NULL, NULL, 2),
(11870, NULL, 'cd08782', NULL, NULL, 'Death_DAPK1', NULL, 'Death_DAPK1', NULL, NULL, NULL, 2),
(11871, NULL, 'cd10489', NULL, NULL, 'MH1_SMAD_6_7', NULL, 'MH1_SMAD_6_7', NULL, NULL, NULL, 2),
(11872, NULL, 'cd08288', NULL, NULL, 'MDR_yhdh', NULL, 'MDR_yhdh', NULL, NULL, NULL, 2),
(11873, NULL, 'cd12615', NULL, NULL, 'RRM1_TIA1', NULL, 'RRM1_TIA1', NULL, NULL, 33288, 2),
(11874, NULL, 'cd21557', NULL, NULL, 'Macro_X_Nsp3-like', NULL, 'Macro_X_Nsp3-like', NULL, NULL, 36235, 2),
(11875, NULL, 'cd09006', NULL, NULL, 'PNP_EcPNPI-like', NULL, 'PNP_EcPNPI-like', NULL, NULL, 5573, 2),
(11876, NULL, 'cd18090', NULL, NULL, 'Arginine_MT_Sfm1', NULL, 'Arginine_MT_Sfm1', NULL, NULL, NULL, 2),
(11877, NULL, 'cd13721', NULL, NULL, 'PBP2_iGluR_Kainate_GluR6', NULL, 'PBP2_iGluR_Kainate_GluR6', NULL, NULL, NULL, 2),
(11878, NULL, 'cd00715', NULL, NULL, 'GPATase_N', NULL, 'GPATase_N', NULL, NULL, 29483, 2),
(11879, NULL, 'cd15581', NULL, NULL, 'PHD2_PHF19', NULL, 'PHD2_PHF19', NULL, NULL, 30577, 2),
(11880, NULL, 'cd05475', NULL, NULL, 'nucellin_like', NULL, 'nucellin_like', NULL, NULL, 30124, 2),
(11881, NULL, 'cd06526', NULL, NULL, 'metazoan_ACD', NULL, 'metazoan_ACD', NULL, NULL, NULL, 2);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(11882, NULL, 'cd06081', NULL, NULL, 'KOW_Spt5_1', NULL, 'KOW_Spt5_1', NULL, NULL, 30662, 2),
(11883, NULL, 'cd18451', NULL, NULL, 'BACK_KLHL11', NULL, 'BACK_KLHL11', NULL, NULL, NULL, 2),
(11884, NULL, 'cd07645', NULL, NULL, 'I-BAR_IMD_BAIAP2L1', NULL, 'I-BAR_IMD_BAIAP2L1', NULL, NULL, NULL, 2),
(11885, NULL, 'cd10170', NULL, NULL, 'HSP70_NBD', NULL, 'HSP70_NBD', NULL, NULL, NULL, 2),
(11886, NULL, 'cd04434', NULL, NULL, 'LanC_like', NULL, 'LanC_like', NULL, NULL, NULL, 2),
(11887, NULL, 'cd00544', NULL, NULL, 'CobU', NULL, 'CobU', NULL, NULL, 3291, 2),
(11888, NULL, 'cd17735', NULL, NULL, 'BRCT_BRCA1_rpt1', NULL, 'BRCT_BRCA1_rpt1', NULL, NULL, NULL, 2),
(11889, NULL, 'cd01190', NULL, NULL, 'INT_StrepXerD_C_like', NULL, 'INT_StrepXerD_C_like', NULL, NULL, NULL, 2),
(11890, NULL, 'cd12292', NULL, NULL, 'RRM2_La_like', NULL, 'RRM2_La_like', NULL, NULL, NULL, 2),
(11891, NULL, 'cd01598', NULL, NULL, 'PurB', NULL, 'PurB', NULL, NULL, NULL, 2),
(11892, NULL, 'cd11554', NULL, NULL, 'SLC6sbd_u2', NULL, 'SLC6sbd_u2', NULL, NULL, NULL, 2),
(11893, NULL, 'cd15271', NULL, NULL, '7tmB1_GHRHR2', NULL, '7tmB1_GHRHR2', NULL, NULL, NULL, 2),
(11894, NULL, 'cd15448', NULL, NULL, '7tmC_mGluR3', NULL, '7tmC_mGluR3', NULL, NULL, NULL, 2),
(11895, NULL, 'cd19820', NULL, NULL, 'Bbox1_ZFYVE1_rpt2', NULL, 'Bbox1_ZFYVE1_rpt2', NULL, NULL, NULL, 2),
(11896, NULL, 'cd16881', NULL, NULL, 'ARID_Dri-like', NULL, 'ARID_Dri-like', NULL, NULL, NULL, 2),
(11897, NULL, 'cd18405', NULL, NULL, 'BTB_POZ_KCNA4', NULL, 'BTB_POZ_KCNA4', NULL, NULL, NULL, 2),
(11898, NULL, 'cd17487', NULL, NULL, 'MFS_MFSD5_like', NULL, 'MFS_MFSD5_like', NULL, NULL, NULL, 2),
(11899, NULL, 'cd15512', NULL, NULL, 'PHD4_KMT2C_like', NULL, 'PHD4_KMT2C_like', NULL, NULL, NULL, 2),
(11900, NULL, 'cd05672', NULL, NULL, 'M20_ACY1L2-like', NULL, 'M20_ACY1L2-like', NULL, NULL, NULL, 2),
(11901, NULL, 'cd00851', NULL, NULL, 'MTH1175', NULL, 'MTH1175', NULL, NULL, 33262, 2),
(11902, NULL, 'cd16294', NULL, NULL, 'Int9-like_MBL-fold', NULL, 'Int9-like_MBL-fold', NULL, NULL, NULL, 2),
(11903, NULL, 'cd14568', NULL, NULL, 'DSP_MKP_classIII', NULL, 'DSP_MKP_classIII', NULL, NULL, NULL, 2),
(11904, NULL, 'cd15557', NULL, NULL, 'PHD_CBP_p300', NULL, 'PHD_CBP_p300', NULL, NULL, NULL, 2),
(11905, NULL, 'cd18093', NULL, NULL, 'SpoU-like_TrmJ', NULL, 'SpoU-like_TrmJ', NULL, NULL, NULL, 2),
(11906, NULL, 'cd08033', NULL, NULL, 'LARP_6', NULL, 'LARP_6', NULL, NULL, NULL, 2),
(11907, NULL, 'cd00742', NULL, NULL, 'FABP', NULL, 'FABP', NULL, NULL, NULL, 2),
(11908, NULL, 'cd15580', NULL, NULL, 'PHD2_MTF2', NULL, 'PHD2_MTF2', NULL, NULL, 30518, 2),
(11909, NULL, 'cd09320', NULL, NULL, 'TDT_like_2', NULL, 'TDT_like_2', NULL, NULL, NULL, 2),
(11910, NULL, 'cd04405', NULL, NULL, 'RhoGAP_BRCC3-like', NULL, 'RhoGAP_BRCC3-like', NULL, NULL, NULL, 2),
(11911, NULL, 'cd04823', NULL, NULL, 'ALAD_PBGS_aspartate_rich', NULL, 'ALAD_PBGS_aspartate_rich', NULL, NULL, NULL, 2),
(11912, NULL, 'cd17397', NULL, NULL, 'MFS_DIRC2', NULL, 'MFS_DIRC2', NULL, NULL, NULL, 2),
(11913, NULL, 'cd01477', NULL, NULL, 'vWA_F09G8-8_type', NULL, 'vWA_F09G8-8_type', NULL, NULL, NULL, 2),
(11914, NULL, 'cd12739', NULL, NULL, 'RRM2_ESRP1', NULL, 'RRM2_ESRP1', NULL, NULL, NULL, 2),
(11915, NULL, 'cd07149', NULL, NULL, 'ALDH_y4uC', NULL, 'ALDH_y4uC', NULL, NULL, NULL, 2),
(11916, NULL, 'cd12141', NULL, NULL, 'SH3_DNMBP_C2', NULL, 'SH3_DNMBP_C2', NULL, NULL, NULL, 2),
(11917, NULL, 'cd04127', NULL, NULL, 'Rab27A', NULL, 'Rab27A', NULL, NULL, 31484, 2),
(11918, NULL, 'cd15871', NULL, NULL, 'R-SNARE_VAMP7', NULL, 'R-SNARE_VAMP7', NULL, NULL, NULL, 2),
(11919, NULL, 'cd06921', NULL, NULL, 'ChtBD1_GH19_hevein', NULL, 'ChtBD1_GH19_hevein', NULL, NULL, NULL, 2),
(11920, NULL, 'cd19113', NULL, NULL, 'AKR_AKR2B1-10', NULL, 'AKR_AKR2B1-10', NULL, NULL, 35083, 2),
(11921, NULL, 'cd05643', NULL, NULL, 'M28_like', NULL, 'M28_like', NULL, NULL, NULL, 2),
(11922, NULL, 'cd02255', NULL, NULL, 'Peptidase_C12', NULL, 'Peptidase_C12', NULL, NULL, 32451, 2),
(11923, NULL, 'cd04124', NULL, NULL, 'RabL2', NULL, 'RabL2', NULL, NULL, 31392, 2);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(11924, NULL, 'cd18032', NULL, NULL, 'DEXHc_RE_I_III_res', NULL, 'DEXHc_RE_I_III_res', NULL, NULL, NULL, 2),
(11925, NULL, 'cd01879', NULL, NULL, 'FeoB', NULL, 'FeoB', NULL, NULL, 24738, 2),
(11926, NULL, 'cd06573', NULL, NULL, 'PASTA', NULL, 'PASTA', NULL, NULL, NULL, 2),
(11927, NULL, 'cd16153', NULL, NULL, 'sulfatase_like', NULL, 'sulfatase_like', NULL, NULL, NULL, 2),
(11928, NULL, 'cd11631', NULL, NULL, 'HR1_PKN2_2', NULL, 'HR1_PKN2_2', NULL, NULL, NULL, 2),
(11929, NULL, 'cd18558', NULL, NULL, 'ABC_6TM_Pgp_ABCB1', NULL, 'ABC_6TM_Pgp_ABCB1', NULL, NULL, NULL, 2),
(11930, NULL, 'cd02844', NULL, NULL, 'PAZ_CAF_like', NULL, 'PAZ_CAF_like', NULL, NULL, NULL, 2),
(11931, NULL, 'cd08751', NULL, NULL, 'RGS_GRK6', NULL, 'RGS_GRK6', NULL, NULL, NULL, 2),
(11932, NULL, 'cd07409', NULL, NULL, 'MPP_CD73_N', NULL, 'MPP_CD73_N', NULL, NULL, NULL, 2),
(11933, NULL, 'cd16382', NULL, NULL, 'XisI-like', NULL, 'XisI-like', NULL, NULL, 14294, 2),
(11934, NULL, 'cd05195', NULL, NULL, 'enoyl_red', NULL, 'enoyl_red', NULL, NULL, NULL, 2),
(11935, NULL, 'cd04246', NULL, NULL, 'AAK_AK-DapG-like', NULL, 'AAK_AK-DapG-like', NULL, NULL, NULL, 2),
(11936, NULL, 'cd04923', NULL, NULL, 'ACT_AK-LysC-DapG-like_2', NULL, 'ACT_AK-LysC-DapG-like_2', NULL, NULL, NULL, 2),
(11937, NULL, 'cd14527', NULL, NULL, 'DSP_bac', NULL, 'DSP_bac', NULL, NULL, NULL, 2),
(11938, NULL, 'cd11394', NULL, NULL, 'bHLHzip_SREBP', NULL, 'bHLHzip_SREBP', NULL, NULL, NULL, 2),
(11939, NULL, 'cd03487', NULL, NULL, 'RT_Bac_retron_II', NULL, 'RT_Bac_retron_II', NULL, NULL, 1585, 2),
(11940, NULL, 'cd02660', NULL, NULL, 'Peptidase_C19D', NULL, 'Peptidase_C19D', NULL, NULL, NULL, 2),
(11941, NULL, 'cd18445', NULL, NULL, 'BACK_KLHL2_like', NULL, 'BACK_KLHL2_like', NULL, NULL, NULL, 2),
(11942, NULL, 'cd01425', NULL, NULL, 'RPS2', NULL, 'RPS2', NULL, NULL, 4059, 2),
(11943, NULL, 'cd02142', NULL, NULL, 'McbC_SagB-like_oxidoreductase', NULL, 'McbC_SagB-like_oxidoreductase', NULL, NULL, NULL, 2),
(11944, NULL, 'cd11693', NULL, NULL, 'HRI1_C_like', NULL, 'HRI1_C_like', NULL, NULL, NULL, 2),
(11945, NULL, 'cd15366', NULL, NULL, '7tmA_GPR4', NULL, '7tmA_GPR4', NULL, NULL, NULL, 2),
(11946, NULL, 'cd17969', NULL, NULL, 'DEAHc_XPD', NULL, 'DEAHc_XPD', NULL, NULL, NULL, 2),
(11947, NULL, 'cd12820', NULL, NULL, 'LbR_YadA-like', NULL, 'LbR_YadA-like', NULL, NULL, NULL, 2),
(11948, NULL, 'cd06091', NULL, NULL, 'KOW_NusG', NULL, 'KOW_NusG', NULL, NULL, NULL, 2),
(11949, NULL, 'cd06877', NULL, NULL, 'PX_SNX14', NULL, 'PX_SNX14', NULL, NULL, 27300, 2),
(11950, NULL, 'cd18204', NULL, NULL, 'BTB_POZ_ZBTB14', NULL, 'BTB_POZ_ZBTB14', NULL, NULL, NULL, 2),
(11951, NULL, 'cd11528', NULL, NULL, 'NTP-PPase_MazG_Nterm', NULL, 'NTP-PPase_MazG_Nterm', NULL, NULL, NULL, 2),
(11952, NULL, 'cd04418', NULL, NULL, 'NDPk5', NULL, 'NDPk5', NULL, NULL, NULL, 2),
(11953, NULL, 'cd03594', NULL, NULL, 'CLECT_REG-1_like', NULL, 'CLECT_REG-1_like', NULL, NULL, NULL, 2),
(11954, NULL, 'cd00867', NULL, NULL, 'Trans_IPPS', NULL, 'Trans_IPPS', NULL, NULL, NULL, 2),
(11955, NULL, 'cd04949', NULL, NULL, 'GT4_GtfA-like', NULL, 'GT4_GtfA-like', NULL, NULL, NULL, 2),
(11956, NULL, 'cd16231', NULL, NULL, 'EFh_SPARC_like', NULL, 'EFh_SPARC_like', NULL, NULL, NULL, 2),
(11957, NULL, 'cd18295', NULL, NULL, 'BTB1_POZ_ABTB1_BPOZ1', NULL, 'BTB1_POZ_ABTB1_BPOZ1', NULL, NULL, NULL, 2),
(11958, NULL, 'cd16736', NULL, NULL, 'RING-HC_PCGF4', NULL, 'RING-HC_PCGF4', NULL, NULL, NULL, 2),
(11959, NULL, 'cd21561', NULL, NULL, 'deltaCoV-Nsp6', NULL, 'deltaCoV-Nsp6', NULL, NULL, 35028, 2),
(11960, NULL, 'cd07147', NULL, NULL, 'ALDH_F21_RNP123', NULL, 'ALDH_F21_RNP123', NULL, NULL, NULL, 2),
(11961, NULL, 'cd19537', NULL, NULL, 'C_NRPS-like', NULL, 'C_NRPS-like', NULL, NULL, NULL, 2),
(11962, NULL, 'cd12174', NULL, NULL, 'PGDH_like_3', NULL, 'PGDH_like_3', NULL, NULL, NULL, 2),
(11963, NULL, 'cd12536', NULL, NULL, 'RRM1_RBM39', NULL, 'RRM1_RBM39', NULL, NULL, NULL, 2),
(11964, NULL, 'cd12537', NULL, NULL, 'RRM1_RBM23', NULL, 'RRM1_RBM23', NULL, NULL, NULL, 2),
(11965, NULL, 'cd13610', NULL, NULL, 'PBP2_ChoS', NULL, 'PBP2_ChoS', NULL, NULL, NULL, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(11966, NULL, 'cd12668', NULL, NULL, 'RRM3_RAVER2', NULL, 'RRM3_RAVER2', NULL, NULL, NULL, 2),
(11967, NULL, 'cd15374', NULL, NULL, '7tmA_P2Y4', NULL, '7tmA_P2Y4', NULL, NULL, NULL, 2),
(11968, NULL, 'cd17214', NULL, NULL, 'RA_CYR1_like', NULL, 'RA_CYR1_like', NULL, NULL, NULL, 2),
(11969, NULL, 'cd19416', NULL, NULL, 'lipocalin_beta-LG-like', NULL, 'lipocalin_beta-LG-like', NULL, NULL, NULL, 2),
(11970, NULL, 'cd05394', NULL, NULL, 'RasGAP_RASA2', NULL, 'RasGAP_RASA2', NULL, NULL, NULL, 2),
(11971, NULL, 'cd08821', NULL, NULL, 'FMT_core_like_1', NULL, 'FMT_core_like_1', NULL, NULL, NULL, 2),
(11972, NULL, 'cd19381', NULL, NULL, 'TGF_beta_Artemin', NULL, 'TGF_beta_Artemin', NULL, NULL, NULL, 2),
(11973, NULL, 'cd09467', NULL, NULL, 'LIM1_Lhx3b', NULL, 'LIM1_Lhx3b', NULL, NULL, NULL, 2),
(11974, NULL, 'cd09441', NULL, NULL, 'LIM2_SF3', NULL, 'LIM2_SF3', NULL, NULL, NULL, 2),
(11975, NULL, 'cd16546', NULL, NULL, 'RING-HC_RNF146', NULL, 'RING-HC_RNF146', NULL, NULL, 34111, 2),
(11976, NULL, 'cd07568', NULL, NULL, 'ML_beta-AS_like', NULL, 'ML_beta-AS_like', NULL, NULL, NULL, 2),
(11977, NULL, 'cd01391', NULL, NULL, 'Periplasmic_Binding_Protein_type1', NULL, 'Periplasmic_Binding_Protein_type1', NULL, NULL, NULL, 2),
(11978, NULL, 'cd11688', NULL, NULL, 'THUMP', NULL, 'THUMP', NULL, NULL, NULL, 2),
(11979, NULL, 'cd14659', NULL, NULL, 'Imelysin-like_IPPA', NULL, 'Imelysin-like_IPPA', NULL, NULL, 19600, 2),
(11980, NULL, 'cd06211', NULL, NULL, 'phenol_2-monooxygenase_like', NULL, 'phenol_2-monooxygenase_like', NULL, NULL, NULL, 2),
(11981, NULL, 'cd14205', NULL, NULL, 'PTKc_Jak2_rpt2', NULL, 'PTKc_Jak2_rpt2', NULL, NULL, 26575, 2),
(11982, NULL, 'cd19453', NULL, NULL, 'lipocalin_NP2', NULL, 'lipocalin_NP2', NULL, NULL, NULL, 2),
(11983, NULL, 'cd18918', NULL, NULL, 'bHLH_AtMYC1_like', NULL, 'bHLH_AtMYC1_like', NULL, NULL, 37267, 2),
(11984, NULL, 'cd04155', NULL, NULL, 'Arl3', NULL, 'Arl3', NULL, NULL, NULL, 2),
(11985, NULL, 'cd13236', NULL, NULL, 'PH2_FGD1-4', NULL, 'PH2_FGD1-4', NULL, NULL, 23225, 2),
(11986, NULL, 'cd07056', NULL, NULL, 'BMC_PduK', NULL, 'BMC_PduK', NULL, NULL, NULL, 2),
(11987, NULL, 'cd12509', NULL, NULL, 'RRM3_ESRPs_Fusilli', NULL, 'RRM3_ESRPs_Fusilli', NULL, NULL, NULL, 2),
(11988, NULL, 'cd14977', NULL, NULL, '7tmA_ET_R-like', NULL, '7tmA_ET_R-like', NULL, NULL, NULL, 2),
(11989, NULL, 'cd21473', NULL, NULL, 'cv_Nsp4_TM', NULL, 'cv_Nsp4_TM', NULL, NULL, 35416, 2),
(11990, NULL, 'cd07721', NULL, NULL, 'yflN-like_MBL-fold', NULL, 'yflN-like_MBL-fold', NULL, NULL, NULL, 2),
(11991, NULL, 'cd14730', NULL, NULL, 'LodA_like', NULL, 'LodA_like', NULL, NULL, 30459, 2),
(11992, NULL, 'cd15399', NULL, NULL, '7tmA_NPY2R', NULL, '7tmA_NPY2R', NULL, NULL, NULL, 2),
(11993, NULL, 'cd08884', NULL, NULL, 'RHO_alpha_C_GbcA-like', NULL, 'RHO_alpha_C_GbcA-like', NULL, NULL, NULL, 2),
(11994, NULL, 'cd04257', NULL, NULL, 'AAK_AK-HSDH', NULL, 'AAK_AK-HSDH', NULL, NULL, 30465, 2),
(11995, NULL, 'cd09990', NULL, NULL, 'Agmatinase-like', NULL, 'Agmatinase-like', NULL, NULL, NULL, 2),
(11996, NULL, 'cd11886', NULL, NULL, 'SH3_BOI', NULL, 'SH3_BOI', NULL, NULL, 30391, 2),
(11997, NULL, 'cd01205', NULL, NULL, 'EVH1_WASP-like', NULL, 'EVH1_WASP-like', NULL, NULL, 28370, 2),
(11998, NULL, 'cd20757', NULL, NULL, 'capping_2-OMTase_Rotavirus', NULL, 'capping_2-OMTase_Rotavirus', NULL, NULL, 10967, 2),
(11999, NULL, 'cd12411', NULL, NULL, 'RRM_ist3_like', NULL, 'RRM_ist3_like', NULL, NULL, 36369, 2),
(12000, NULL, 'cd04178', NULL, NULL, 'Nucleostemin_like', NULL, 'Nucleostemin_like', NULL, NULL, NULL, 2),
(12001, NULL, 'cd04465', NULL, NULL, 'S1_RPS1_repeat_ec2_hs2', NULL, 'S1_RPS1_repeat_ec2_hs2', NULL, NULL, NULL, 2),
(12002, NULL, 'cd09931', NULL, NULL, 'SH2_C-SH2_SHP_like', NULL, 'SH2_C-SH2_SHP_like', NULL, NULL, NULL, 2),
(12003, NULL, 'cd15596', NULL, NULL, 'PHD4_KMT2C', NULL, 'PHD4_KMT2C', NULL, NULL, NULL, 2),
(12004, NULL, 'cd15386', NULL, NULL, '7tmA_V1bR', NULL, '7tmA_V1bR', NULL, NULL, NULL, 2),
(12005, NULL, 'cd05855', NULL, NULL, 'Ig_TrkB_d5', NULL, 'Ig_TrkB_d5', NULL, NULL, NULL, 2);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(12006, NULL, 'cd05796', NULL, NULL, 'Ribosomal_P0_like', NULL, 'Ribosomal_P0_like', NULL, NULL, 29040, 2),
(12007, NULL, 'cd09495', NULL, NULL, 'SAM_liprin-kazrin_repeat2', NULL, 'SAM_liprin-kazrin_repeat2', NULL, NULL, NULL, 2),
(12008, NULL, 'cd01213', NULL, NULL, 'PTB_tensin', NULL, 'PTB_tensin', NULL, NULL, 27835, 2),
(12009, NULL, 'cd07348', NULL, NULL, 'NR_LBD_NGFI-B', NULL, 'NR_LBD_NGFI-B', NULL, NULL, NULL, 2),
(12010, NULL, 'cd19006', NULL, NULL, 'LGIC_ECD_GABAAR_LCCH3-like', NULL, 'LGIC_ECD_GABAAR_LCCH3-like', NULL, NULL, NULL, 2),
(12011, NULL, 'cd04876', NULL, NULL, 'ACT_RelA-SpoT', NULL, 'ACT_RelA-SpoT', NULL, NULL, NULL, 2),
(12012, NULL, 'cd07034', NULL, NULL, 'TPP_PYR_PFOR_IOR-alpha_like', NULL, 'TPP_PYR_PFOR_IOR-alpha_like', NULL, NULL, 5721, 2),
(12013, NULL, 'cd01463', NULL, NULL, 'vWA_VGCC_like', NULL, 'vWA_VGCC_like', NULL, NULL, NULL, 2),
(12014, NULL, 'cd10140', NULL, NULL, 'PFM_aerolysin_family', NULL, 'PFM_aerolysin_family', NULL, NULL, NULL, 2),
(12015, NULL, 'cd17925', NULL, NULL, 'DEXDc_ComFA', NULL, 'DEXDc_ComFA', NULL, NULL, NULL, 2),
(12016, NULL, 'cd07115', NULL, NULL, 'ALDH_HMSADH_HapE', NULL, 'ALDH_HMSADH_HapE', NULL, NULL, NULL, 2),
(12017, NULL, 'cd09629', NULL, NULL, 'DOMON_CIL1_like', NULL, 'DOMON_CIL1_like', NULL, NULL, 37132, 2),
(12018, NULL, 'cd13839', NULL, NULL, 'MEF2_binding', NULL, 'MEF2_binding', NULL, NULL, 9922, 2),
(12019, NULL, 'cd16769', NULL, NULL, 'RING-HC_UHRF1', NULL, 'RING-HC_UHRF1', NULL, NULL, NULL, 2),
(12020, NULL, 'cd19051', NULL, NULL, 'LGIC_TM_cation', NULL, 'LGIC_TM_cation', NULL, NULL, NULL, 2),
(12021, NULL, 'cd16470', NULL, NULL, 'RING-H2_RNF25', NULL, 'RING-H2_RNF25', NULL, NULL, NULL, 2),
(12022, NULL, 'cd15160', NULL, NULL, '7tmA_Proton-sensing_R', NULL, '7tmA_Proton-sensing_R', NULL, NULL, NULL, 2),
(12023, NULL, 'cd12825', NULL, NULL, 'EcCorA-like', NULL, 'EcCorA-like', NULL, NULL, NULL, 2),
(12024, NULL, 'cd16311', NULL, NULL, 'THIN-B2-like_MBL-B3', NULL, 'THIN-B2-like_MBL-B3', NULL, NULL, NULL, 2),
(12025, NULL, 'cd17351', NULL, NULL, 'MFS_NPF', NULL, 'MFS_NPF', NULL, NULL, NULL, 2),
(12026, NULL, 'cd04091', NULL, NULL, 'mtEFG1_II_like', NULL, 'mtEFG1_II_like', NULL, NULL, NULL, 2),
(12027, NULL, 'cd04479', NULL, NULL, 'RPA3', NULL, 'RPA3', NULL, NULL, NULL, 2),
(12028, NULL, 'cd12029', NULL, NULL, 'SH3_DLG3', NULL, 'SH3_DLG3', NULL, NULL, 31724, 2),
(12029, NULL, 'cd16641', NULL, NULL, 'mRING-HC-C3HC3D_TRAF4', NULL, 'mRING-HC-C3HC3D_TRAF4', NULL, NULL, NULL, 2),
(12030, NULL, 'cd19962', NULL, NULL, 'PBP1_ABC_RfuA-like', NULL, 'PBP1_ABC_RfuA-like', NULL, NULL, NULL, 2),
(12031, NULL, 'cd15015', NULL, NULL, '7tm_TAS2R39', NULL, '7tm_TAS2R39', NULL, NULL, NULL, 2),
(12032, NULL, 'cd08436', NULL, NULL, 'PBP2_LTTR_like_3', NULL, 'PBP2_LTTR_like_3', NULL, NULL, NULL, 2),
(12033, NULL, 'cd03013', NULL, NULL, 'PRX5_like', NULL, 'PRX5_like', NULL, NULL, 29516, 2),
(12034, NULL, 'cd08518', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_19', NULL, 'PBP2_NikA_DppA_OppA_like_19', NULL, NULL, NULL, 2),
(12035, NULL, 'cd11753', NULL, NULL, 'GH94N_ChvB_NdvB_2_like', NULL, 'GH94N_ChvB_NdvB_2_like', NULL, NULL, 29956, 2),
(12036, NULL, 'cd18323', NULL, NULL, 'BTB_POZ_ZBTB3', NULL, 'BTB_POZ_ZBTB3', NULL, NULL, NULL, 2),
(12037, NULL, 'cd06173', NULL, NULL, 'MFS_MefA_like', NULL, 'MFS_MefA_like', NULL, NULL, NULL, 2),
(12038, NULL, 'cd09903', NULL, NULL, 'H3TH_FEN1-Arc', NULL, 'H3TH_FEN1-Arc', NULL, NULL, NULL, 2),
(12039, NULL, 'cd15077', NULL, NULL, '7tmA_SWS2_opsin', NULL, '7tmA_SWS2_opsin', NULL, NULL, NULL, 2),
(12040, NULL, 'cd05772', NULL, NULL, 'IgC_SIRP_domain_2', NULL, 'IgC_SIRP_domain_2', NULL, NULL, NULL, 2),
(12041, NULL, 'cd08678', NULL, NULL, 'C2_C21orf25-like', NULL, 'C2_C21orf25-like', NULL, NULL, NULL, 2),
(12042, NULL, 'cd00924', NULL, NULL, 'Cyt_c_Oxidase_Vb', NULL, 'Cyt_c_Oxidase_Vb', NULL, NULL, 5450, 2),
(12043, NULL, 'cd14554', NULL, NULL, 'R-PTP-LAR-2', NULL, 'R-PTP-LAR-2', NULL, NULL, NULL, 2),
(12044, NULL, 'cd05474', NULL, NULL, 'SAP_like', NULL, 'SAP_like', NULL, NULL, 27283, 2),
(12045, NULL, 'cd04909', NULL, NULL, 'ACT_PDH-BS', NULL, 'ACT_PDH-BS', NULL, NULL, NULL, 2);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(12046, NULL, 'cd19862', NULL, NULL, 'DSRM_PRKRA-like_rpt1', NULL, 'DSRM_PRKRA-like_rpt1', NULL, NULL, NULL, 2),
(12047, NULL, 'cd09721', NULL, NULL, 'Cas1_I-C', NULL, 'Cas1_I-C', NULL, NULL, 14986, 2),
(12048, NULL, 'cd11322', NULL, NULL, 'AmyAc_Glg_BE', NULL, 'AmyAc_Glg_BE', NULL, NULL, NULL, 2),
(12049, NULL, 'cd18750', NULL, NULL, 'PIN_VapC4-5_FitB-like', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, NULL, 2),
(12050, NULL, 'cd16381', NULL, NULL, 'YitT_C_like_1', NULL, 'YitT_C_like_1', NULL, NULL, NULL, 2),
(12051, NULL, 'cd01411', NULL, NULL, 'SIR2H', NULL, 'SIR2H', NULL, NULL, NULL, 2),
(12052, NULL, 'cd16758', NULL, NULL, 'RING-HC_TRIM67', NULL, 'RING-HC_TRIM67', NULL, NULL, NULL, 2),
(12053, NULL, 'cd18741', NULL, NULL, 'PIN_VapC4-5_FitB-like', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, NULL, 2),
(12054, NULL, 'cd00378', NULL, NULL, 'SHMT', NULL, 'SHMT', NULL, NULL, 2430, 2),
(12055, NULL, 'cd05521', NULL, NULL, 'Bromo_Rsc1_2_I', NULL, 'Bromo_Rsc1_2_I', NULL, NULL, 32561, 2),
(12056, NULL, 'cd01800', NULL, NULL, 'Ubl_SF3a120', NULL, 'Ubl_SF3a120', NULL, NULL, 28269, 2),
(12057, NULL, 'cd14157', NULL, NULL, 'STKc_IRAK2', NULL, 'STKc_IRAK2', NULL, NULL, NULL, 2),
(12058, NULL, 'cd03671', NULL, NULL, 'Ap4A_hydrolase_plant_like', NULL, 'Ap4A_hydrolase_plant_like', NULL, NULL, 14615, 2),
(12059, NULL, 'cd13992', NULL, NULL, 'PK_GC', NULL, 'PK_GC', NULL, NULL, NULL, 2),
(12060, NULL, 'cd16251', NULL, NULL, 'EFh_parvalbumin_like', NULL, 'EFh_parvalbumin_like', NULL, NULL, NULL, 2),
(12061, NULL, 'cd08771', NULL, NULL, 'DLP_1', NULL, 'DLP_1', NULL, NULL, 3135, 2),
(12062, NULL, 'cd12245', NULL, NULL, 'RRM_scw1_like', NULL, 'RRM_scw1_like', NULL, NULL, NULL, 2),
(12063, NULL, 'cd08458', NULL, NULL, 'PBP2_NocR', NULL, 'PBP2_NocR', NULL, NULL, NULL, 2),
(12064, NULL, 'cd17079', NULL, NULL, 'Ubl_SLD2_NFATC2ip', NULL, 'Ubl_SLD2_NFATC2ip', NULL, NULL, NULL, 2),
(12065, NULL, 'cd12361', NULL, NULL, 'RRM1_2_CELF1-6_like', NULL, 'RRM1_2_CELF1-6_like', NULL, NULL, NULL, 2),
(12066, NULL, 'cd06233', NULL, NULL, 'M14-like', NULL, 'M14-like', NULL, NULL, NULL, 2),
(12067, NULL, 'cd08491', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_12', NULL, 'PBP2_NikA_DppA_OppA_like_12', NULL, NULL, NULL, 2),
(12068, NULL, 'cd18725', NULL, NULL, 'PIN_LabA-like', NULL, 'PIN_LabA-like', NULL, NULL, NULL, 2),
(12069, NULL, 'cd07202', NULL, NULL, 'cPLA2_Grp-IVC', NULL, 'cPLA2_Grp-IVC', NULL, NULL, NULL, 2),
(12070, NULL, 'cd13444', NULL, NULL, 'CDI_toxin_EC869_like', NULL, 'CDI_toxin_EC869_like', NULL, NULL, 30080, 2),
(12071, NULL, 'cd01126', NULL, NULL, 'TraG_VirD4', NULL, 'TraG_VirD4', NULL, NULL, NULL, 2),
(12072, NULL, 'cd19092', NULL, NULL, 'AKR_BsYcsN_EcYdhF-like', NULL, 'AKR_BsYcsN_EcYdhF-like', NULL, NULL, NULL, 2),
(12073, NULL, 'cd07843', NULL, NULL, 'STKc_CDC2L1', NULL, 'STKc_CDC2L1', NULL, NULL, 35813, 2),
(12074, NULL, 'cd08600', NULL, NULL, 'GDPD_EcGlpQ_like', NULL, 'GDPD_EcGlpQ_like', NULL, NULL, NULL, 2),
(12075, NULL, 'cd01110', NULL, NULL, 'HTH_SoxR', NULL, 'HTH_SoxR', NULL, NULL, 4175, 2),
(12076, NULL, 'cd12634', NULL, NULL, 'RRM2_CELF1_2', NULL, 'RRM2_CELF1_2', NULL, NULL, 7102, 2),
(12077, NULL, 'cd16953', NULL, NULL, 'HATPase_BvrS-ChvG-like', NULL, 'HATPase_BvrS-ChvG-like', NULL, NULL, NULL, 2),
(12078, NULL, 'cd00120', NULL, NULL, 'MADS', NULL, 'MADS', NULL, NULL, NULL, 2),
(12079, NULL, 'cd05666', NULL, NULL, 'M20_Acy1-like', NULL, 'M20_Acy1-like', NULL, NULL, NULL, 2),
(12080, NULL, 'cd19772', NULL, NULL, 'Bbox2_TRIM21_C-IV', NULL, 'Bbox2_TRIM21_C-IV', NULL, NULL, NULL, 2),
(12081, NULL, 'cd07306', NULL, NULL, 'Porin3_VDAC', NULL, 'Porin3_VDAC', NULL, NULL, 4260, 2),
(12082, NULL, 'cd16699', NULL, NULL, 'RING_CH-C4HC3_MARCH2_like', NULL, 'RING_CH-C4HC3_MARCH2_like', NULL, NULL, NULL, 2),
(12083, NULL, 'cd13595', NULL, NULL, 'PBP2_HisGs', NULL, 'PBP2_HisGs', NULL, NULL, 17609, 2),
(12084, NULL, 'cd08934', NULL, NULL, 'CAD_SDR_c', NULL, 'CAD_SDR_c', NULL, NULL, NULL, 2),
(12085, NULL, 'cd15556', NULL, NULL, 'PHD_MMD1_like', NULL, 'PHD_MMD1_like', NULL, NULL, NULL, 2),
(12086, NULL, 'cd08902', NULL, NULL, 'START_STARD4-like', NULL, 'START_STARD4-like', NULL, NULL, NULL, 2);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(12087, NULL, 'cd08525', NULL, NULL, 'Reelin_subrepeat_1', NULL, 'Reelin_subrepeat_1', NULL, NULL, NULL, 2),
(12088, NULL, 'cd19012', NULL, NULL, 'LGIC_ECD_5-HT3B', NULL, 'LGIC_ECD_5-HT3B', NULL, NULL, NULL, 2),
(12089, NULL, 'cd19971', NULL, NULL, 'PBP1_ABC_sugar_binding-like', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, NULL, 2),
(12090, NULL, 'cd12743', NULL, NULL, 'RRM3_Fusilli', NULL, 'RRM3_Fusilli', NULL, NULL, NULL, 2),
(12091, NULL, 'cd12009', NULL, NULL, 'SH3_Blk', NULL, 'SH3_Blk', NULL, NULL, NULL, 2),
(12092, NULL, 'cd06874', NULL, NULL, 'PX_KIF16B_SNX23', NULL, 'PX_KIF16B_SNX23', NULL, NULL, NULL, 2),
(12093, NULL, 'cd09451', NULL, NULL, 'LIM_RIL', NULL, 'LIM_RIL', NULL, NULL, NULL, 2),
(12094, NULL, 'cd14945', NULL, NULL, 'Myo5-like_CBD', NULL, 'Myo5-like_CBD', NULL, NULL, NULL, 2),
(12095, NULL, 'cd14718', NULL, NULL, 'bZIP_Maf_large', NULL, 'bZIP_Maf_large', NULL, NULL, NULL, 2),
(12096, NULL, 'cd18501', NULL, NULL, 'BACK_ANKFY1_Rank5', NULL, 'BACK_ANKFY1_Rank5', NULL, NULL, NULL, 2),
(12097, NULL, 'cd05466', NULL, NULL, 'PBP2_LTTR_substrate', NULL, 'PBP2_LTTR_substrate', NULL, NULL, NULL, 2),
(12098, NULL, 'cd11540', NULL, NULL, 'NTP-PPase_u3', NULL, 'NTP-PPase_u3', NULL, NULL, NULL, 2),
(12099, NULL, 'cd03144', NULL, NULL, 'GATase1_ScBLP_like', NULL, 'GATase1_ScBLP_like', NULL, NULL, NULL, 2),
(12100, NULL, 'cd18997', NULL, NULL, 'LGIC_ECD_nAChR', NULL, 'LGIC_ECD_nAChR', NULL, NULL, NULL, 2),
(12101, NULL, 'cd02988', NULL, NULL, 'Phd_like_VIAF', NULL, 'Phd_like_VIAF', NULL, NULL, NULL, 2),
(12102, NULL, 'cd16957', NULL, NULL, 'HATPase_LytS-like', NULL, 'HATPase_LytS-like', NULL, NULL, NULL, 2),
(12103, NULL, 'cd03181', NULL, NULL, 'GST_C_EF1Bgamma_like', NULL, 'GST_C_EF1Bgamma_like', NULL, NULL, NULL, 2),
(12104, NULL, 'cd04607', NULL, NULL, 'CBS_pair_NTP_transferase_assoc', NULL, 'CBS_pair_NTP_transferase_assoc', NULL, NULL, NULL, 2),
(12105, NULL, 'cd07691', NULL, NULL, 'Ig_CD3_gamma_delta', NULL, 'Ig_CD3_gamma_delta', NULL, NULL, NULL, 2),
(12106, NULL, 'cd13920', NULL, NULL, 'Stellacyanin', NULL, 'Stellacyanin', NULL, NULL, NULL, 2),
(12107, NULL, 'cd14332', NULL, NULL, 'UBA_RuvA_C', NULL, 'UBA_RuvA_C', NULL, NULL, 11453, 2),
(12108, NULL, 'cd05032', NULL, NULL, 'PTKc_InsR_like', NULL, 'PTKc_InsR_like', NULL, NULL, NULL, 2),
(12109, NULL, 'cd14223', NULL, NULL, 'STKc_GRK2', NULL, 'STKc_GRK2', NULL, NULL, NULL, 2),
(12110, NULL, 'cd16417', NULL, NULL, 'HAD_PGPase', NULL, 'HAD_PGPase', NULL, NULL, NULL, 2),
(12111, NULL, 'cd13122', NULL, NULL, 'MSL2_CXC', NULL, 'MSL2_CXC', NULL, NULL, 25426, 2),
(12112, NULL, 'cd16564', NULL, NULL, 'RING-HC_RNF222', NULL, 'RING-HC_RNF222', NULL, NULL, NULL, 2),
(12113, NULL, 'cd12813', NULL, NULL, 'LbR-like', NULL, 'LbR-like', NULL, NULL, NULL, 2),
(12114, NULL, 'cd04600', NULL, NULL, 'CBS_pair_HPP_assoc', NULL, 'CBS_pair_HPP_assoc', NULL, NULL, NULL, 2),
(12115, NULL, 'cd18948', NULL, NULL, 'bHLH-PAS_NCoA1_SRC1', NULL, 'bHLH-PAS_NCoA1_SRC1', NULL, NULL, NULL, 2),
(12116, NULL, 'cd06411', NULL, NULL, 'PB1_p51', NULL, 'PB1_p51', NULL, NULL, NULL, 2),
(12117, NULL, 'cd16468', NULL, NULL, 'RING-H2_RNF11', NULL, 'RING-H2_RNF11', NULL, NULL, 34737, 2),
(12118, NULL, 'cd16484', NULL, NULL, 'RING-H2_Vps', NULL, 'RING-H2_Vps', NULL, NULL, NULL, 2),
(12119, NULL, 'cd07634', NULL, NULL, 'BAR_GAP10-like', NULL, 'BAR_GAP10-like', NULL, NULL, NULL, 2),
(12120, NULL, 'cd06885', NULL, NULL, 'PX_SNX17_31', NULL, 'PX_SNX17_31', NULL, NULL, NULL, 2),
(12121, NULL, 'cd08581', NULL, NULL, 'GDPD_like_1', NULL, 'GDPD_like_1', NULL, NULL, NULL, 2),
(12122, NULL, 'cd11888', NULL, NULL, 'SH3_ARHGAP9_like', NULL, 'SH3_ARHGAP9_like', NULL, NULL, NULL, 2),
(12123, NULL, 'cd03798', NULL, NULL, 'GT4_WlbH-like', NULL, 'GT4_WlbH-like', NULL, NULL, NULL, 2),
(12124, NULL, 'cd00075', NULL, NULL, 'HATPase', NULL, 'HATPase', NULL, NULL, NULL, 2),
(12125, NULL, 'cd17509', NULL, NULL, 'Alpha_kinase', NULL, 'Alpha_kinase', NULL, NULL, NULL, 2),
(12126, NULL, 'cd17349', NULL, NULL, 'MFS_SLC15A5', NULL, 'MFS_SLC15A5', NULL, NULL, NULL, 2),
(12127, NULL, 'cd08503', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_17', NULL, 'PBP2_NikA_DppA_OppA_like_17', NULL, NULL, NULL, 2);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(12128, NULL, 'cd08660', NULL, NULL, 'M20_Acy1-like', NULL, 'M20_Acy1-like', NULL, NULL, NULL, 2),
(12129, NULL, 'cd15084', NULL, NULL, '7tmA_Pinopsin', NULL, '7tmA_Pinopsin', NULL, NULL, NULL, 2),
(12130, NULL, 'cd02073', NULL, NULL, 'P-type_ATPase_APLT_Dnf-like', NULL, 'P-type_ATPase_APLT_Dnf-like', NULL, NULL, NULL, 2),
(12131, NULL, 'cd08770', NULL, NULL, 'DAP_dppA_3', NULL, 'DAP_dppA_3', NULL, NULL, NULL, 2),
(12132, NULL, 'cd11267', NULL, NULL, 'Sema_6B', NULL, 'Sema_6B', NULL, NULL, NULL, 2),
(12133, NULL, 'cd06938', NULL, NULL, 'NR_LBD_EcR', NULL, 'NR_LBD_EcR', NULL, NULL, 30093, 2),
(12134, NULL, 'cd13931', NULL, NULL, 'PT-CloQ_NphB', NULL, 'PT-CloQ_NphB', NULL, NULL, 15779, 2),
(12135, NULL, 'cd15701', NULL, NULL, 'ePHD_BRPF1', NULL, 'ePHD_BRPF1', NULL, NULL, 31937, 2),
(12136, NULL, 'cd11870', NULL, NULL, 'SH3_p67phox-like_C', NULL, 'SH3_p67phox-like_C', NULL, NULL, NULL, 2),
(12137, NULL, 'cd15349', NULL, NULL, '7tmA_S1PR4_Edg6', NULL, '7tmA_S1PR4_Edg6', NULL, NULL, NULL, 2),
(12138, NULL, 'cd16549', NULL, NULL, 'RING-HC_RNF166', NULL, 'RING-HC_RNF166', NULL, NULL, NULL, 2),
(12139, NULL, 'cd00539', NULL, NULL, 'MCR_gamma', NULL, 'MCR_gamma', NULL, NULL, 2912, 2),
(12140, NULL, 'cd19538', NULL, NULL, 'LCL_NRPS', NULL, 'LCL_NRPS', NULL, NULL, NULL, 2),
(12141, NULL, 'cd06922', NULL, NULL, 'ChtBD1_GH18_1', NULL, 'ChtBD1_GH18_1', NULL, NULL, NULL, 2),
(12142, NULL, 'cd19917', NULL, NULL, 'RsmI_like', NULL, 'RsmI_like', NULL, NULL, NULL, 2),
(12143, NULL, 'cd06855', NULL, NULL, 'GT_GPT_euk', NULL, 'GT_GPT_euk', NULL, NULL, 32459, 2),
(12144, NULL, 'cd15412', NULL, NULL, '7tmA_OR5M-like', NULL, '7tmA_OR5M-like', NULL, NULL, NULL, 2),
(12145, NULL, 'cd12007', NULL, NULL, 'SH3_Yes', NULL, 'SH3_Yes', NULL, NULL, 30474, 2),
(12146, NULL, 'cd15444', NULL, NULL, '7tmB2_GPR64', NULL, '7tmB2_GPR64', NULL, NULL, NULL, 2),
(12147, NULL, 'cd05854', NULL, NULL, 'Ig6_Contactin-2', NULL, 'Ig6_Contactin-2', NULL, NULL, NULL, 2),
(12148, NULL, 'cd20226', NULL, NULL, 'PFM_Cry51Aa-like', NULL, 'PFM_Cry51Aa-like', NULL, NULL, NULL, 2),
(12149, NULL, 'cd08318', NULL, NULL, 'Death_NMPP84', NULL, 'Death_NMPP84', NULL, NULL, NULL, 2),
(12150, NULL, 'cd20295', NULL, NULL, 'cupin_Pac13-like', NULL, 'cupin_Pac13-like', NULL, NULL, NULL, 2),
(12151, NULL, 'cd14230', NULL, NULL, 'GAT_GGA', NULL, 'GAT_GGA', NULL, NULL, NULL, 2),
(12152, NULL, 'cd00619', NULL, NULL, 'Terminator_NusB', NULL, 'Terminator_NusB', NULL, NULL, NULL, 2),
(12153, NULL, 'cd13283', NULL, NULL, 'PH_GPBP', NULL, 'PH_GPBP', NULL, NULL, NULL, 2),
(12154, NULL, 'cd08631', NULL, NULL, 'PI-PLCc_delta4', NULL, 'PI-PLCc_delta4', NULL, NULL, NULL, 2),
(12155, NULL, 'cd00660', NULL, NULL, 'Topoisomer_IB_N', NULL, 'Topoisomer_IB_N', NULL, NULL, NULL, 2),
(12156, NULL, 'cd08425', NULL, NULL, 'PBP2_CynR', NULL, 'PBP2_CynR', NULL, NULL, 32063, 2),
(12157, NULL, 'cd08726', NULL, NULL, 'RGS_RGS22_3', NULL, 'RGS_RGS22_3', NULL, NULL, NULL, 2),
(12158, NULL, 'cd12406', NULL, NULL, 'RRM4_NCL', NULL, 'RRM4_NCL', NULL, NULL, 30950, 2),
(12159, NULL, 'cd07181', NULL, NULL, 'RNase_HII_eukaryota_like', NULL, 'RNase_HII_eukaryota_like', NULL, NULL, NULL, 2),
(12160, NULL, 'cd17921', NULL, NULL, 'DEXHc_Ski2', NULL, 'DEXHc_Ski2', NULL, NULL, NULL, 2),
(12161, NULL, 'cd13921', NULL, NULL, 'Amicyanin', NULL, 'Amicyanin', NULL, NULL, 27534, 2),
(12162, NULL, 'cd02029', NULL, NULL, 'PRK_like', NULL, 'PRK_like', NULL, NULL, NULL, 2),
(12163, NULL, 'cd04177', NULL, NULL, 'RSR1', NULL, 'RSR1', NULL, NULL, 30951, 2),
(12164, NULL, 'cd14610', NULL, NULL, 'R-PTP-N2', NULL, 'R-PTP-N2', NULL, NULL, NULL, 2),
(12165, NULL, 'cd04134', NULL, NULL, 'Rho3', NULL, 'Rho3', NULL, NULL, NULL, 2),
(12166, NULL, 'cd10417', NULL, NULL, 'SH2_SH2D7', NULL, 'SH2_SH2D7', NULL, NULL, 32894, 2),
(12167, NULL, 'cd08268', NULL, NULL, 'MDR2', NULL, 'MDR2', NULL, NULL, NULL, 2),
(12168, NULL, 'cd11832', NULL, NULL, 'SH3_Shank', NULL, 'SH3_Shank', NULL, NULL, NULL, 2),
(12169, NULL, 'cd09876', NULL, NULL, 'PIN_Nob1-like', NULL, 'PIN_Nob1-like', NULL, NULL, 32970, 2),
(12170, NULL, 'cd04101', NULL, NULL, 'RabL4', NULL, 'RabL4', NULL, NULL, 21106, 2);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(12171, NULL, 'cd03279', NULL, NULL, 'ABC_sbcCD', NULL, 'ABC_sbcCD', NULL, NULL, NULL, 2),
(12172, NULL, 'cd14943', NULL, NULL, 'TRAPPC5_Trs31', NULL, 'TRAPPC5_Trs31', NULL, NULL, 20363, 2),
(12173, NULL, 'cd03793', NULL, NULL, 'GT3_GSY2-like', NULL, 'GT3_GSY2-like', NULL, NULL, NULL, 2),
(12174, NULL, 'cd16921', NULL, NULL, 'HATPase_FilI-like', NULL, 'HATPase_FilI-like', NULL, NULL, NULL, 2),
(12175, NULL, 'cd08546', NULL, NULL, 'cohesin_like', NULL, 'cohesin_like', NULL, NULL, NULL, 2),
(12176, NULL, 'cd11264', NULL, NULL, 'Sema_5B', NULL, 'Sema_5B', NULL, NULL, NULL, 2),
(12177, NULL, 'cd01895', NULL, NULL, 'EngA2', NULL, 'EngA2', NULL, NULL, NULL, 2),
(12178, NULL, 'cd10518', NULL, NULL, 'SET_SETD1-like', NULL, 'SET_SETD1-like', NULL, NULL, NULL, 2),
(12179, NULL, 'cd11925', NULL, NULL, 'SH3_SH3RF3_3', NULL, 'SH3_SH3RF3_3', NULL, NULL, 28074, 2),
(12180, NULL, 'cd03369', NULL, NULL, 'ABCC_NFT1', NULL, 'ABCC_NFT1', NULL, NULL, NULL, 2),
(12181, NULL, 'cd16486', NULL, NULL, 'mRING-H2-C3H2C2D_ZSWM2', NULL, 'mRING-H2-C3H2C2D_ZSWM2', NULL, NULL, NULL, 2),
(12182, NULL, 'cd02417', NULL, NULL, 'Peptidase_C39_likeA', NULL, 'Peptidase_C39_likeA', NULL, NULL, 33398, 2),
(12183, NULL, 'cd07839', NULL, NULL, 'STKc_CDK5', NULL, 'STKc_CDK5', NULL, NULL, NULL, 2),
(12184, NULL, 'cd03204', NULL, NULL, 'GST_C_GDAP1_like', NULL, 'GST_C_GDAP1_like', NULL, NULL, NULL, 2),
(12185, NULL, 'cd10551', NULL, NULL, 'PsrB', NULL, 'PsrB', NULL, NULL, NULL, 2),
(12186, NULL, 'cd10437', NULL, NULL, 'GIY-YIG_HE_I-TevI_like', NULL, 'GIY-YIG_HE_I-TevI_like', NULL, NULL, NULL, 2),
(12187, NULL, 'cd00046', NULL, NULL, 'SF2-N', NULL, 'SF2-N', NULL, NULL, NULL, 2),
(12188, NULL, 'cd02222', NULL, NULL, 'cupin_TM1459-like', NULL, 'cupin_TM1459-like', NULL, NULL, NULL, 2),
(12189, NULL, 'cd05804', NULL, NULL, 'StaR_like', NULL, 'StaR_like', NULL, NULL, 31647, 2),
(12190, NULL, 'cd05602', NULL, NULL, 'STKc_SGK1', NULL, 'STKc_SGK1', NULL, NULL, NULL, 2),
(12191, NULL, 'cd09828', NULL, NULL, 'PET_OEBT', NULL, 'PET_OEBT', NULL, NULL, NULL, 2),
(12192, NULL, 'cd08402', NULL, NULL, 'C2B_Synaptotagmin-1', NULL, 'C2B_Synaptotagmin-1', NULL, NULL, NULL, 2),
(12193, NULL, 'cd12164', NULL, NULL, 'GDH_like_2', NULL, 'GDH_like_2', NULL, NULL, NULL, 2),
(12194, NULL, 'cd17110', NULL, NULL, 'FERM_F1_Myo10_like', NULL, 'FERM_F1_Myo10_like', NULL, NULL, NULL, 2),
(12195, NULL, 'cd06412', NULL, NULL, 'GH25_CH-type', NULL, 'GH25_CH-type', NULL, NULL, NULL, 2),
(12196, NULL, 'cd17931', NULL, NULL, 'DEXHc_viral_Ns3', NULL, 'DEXHc_viral_Ns3', NULL, NULL, NULL, 2),
(12197, NULL, 'cd19611', NULL, NULL, 'Ctf13_LRR_LRR-insertion', NULL, 'Ctf13_LRR_LRR-insertion', NULL, NULL, NULL, 2),
(12198, NULL, 'cd10428', NULL, NULL, 'LFG_like', NULL, 'LFG_like', NULL, NULL, NULL, 2),
(12199, NULL, 'cd06987', NULL, NULL, 'cupin_MAE_RS03005', NULL, 'cupin_MAE_RS03005', NULL, NULL, NULL, 2),
(12200, NULL, 'cd18102', NULL, NULL, 'Trm10_MRRP1', NULL, 'Trm10_MRRP1', NULL, NULL, NULL, 2),
(12201, NULL, 'cd11024', NULL, NULL, 'CuRO_1_2DMCO_NIR_like', NULL, 'CuRO_1_2DMCO_NIR_like', NULL, NULL, NULL, 2),
(12202, NULL, 'cd09712', NULL, NULL, 'Cas10d_I-D', NULL, 'Cas10d_I-D', NULL, NULL, NULL, 2),
(12203, NULL, 'cd04195', NULL, NULL, 'GT2_AmsE_like', NULL, 'GT2_AmsE_like', NULL, NULL, NULL, 2),
(12204, NULL, 'cd11754', NULL, NULL, 'GH94N_CBP_like', NULL, 'GH94N_CBP_like', NULL, NULL, 31963, 2),
(12205, NULL, 'cd05738', NULL, NULL, 'Ig2_RPTP_IIa_LAR_like', NULL, 'Ig2_RPTP_IIa_LAR_like', NULL, NULL, NULL, 2),
(12206, NULL, 'cd13565', NULL, NULL, 'PBP2_PstS', NULL, 'PBP2_PstS', NULL, NULL, NULL, 2),
(12207, NULL, 'cd12768', NULL, NULL, 'RRM2_SRSF9', NULL, 'RRM2_SRSF9', NULL, NULL, 14528, 2),
(12208, NULL, 'cd18731', NULL, NULL, 'PIN_NgFitB-like', NULL, 'PIN_NgFitB-like', NULL, NULL, NULL, 2),
(12209, NULL, 'cd13638', NULL, NULL, 'PBP2_EcProx_like', NULL, 'PBP2_EcProx_like', NULL, NULL, NULL, 2),
(12210, NULL, 'cd05055', NULL, NULL, 'PTKc_PDGFR', NULL, 'PTKc_PDGFR', NULL, NULL, NULL, 2),
(12211, NULL, 'cd15114', NULL, NULL, '7tmA_C5aR', NULL, '7tmA_C5aR', NULL, NULL, NULL, 2);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(12212, NULL, 'cd08290', NULL, NULL, 'ETR', NULL, 'ETR', NULL, NULL, NULL, 2),
(12213, NULL, 'cd01125', NULL, NULL, 'repA', NULL, 'repA', NULL, NULL, 31885, 2),
(12214, NULL, 'cd13762', NULL, NULL, 'TGF_beta_GDP9_9B_like', NULL, 'TGF_beta_GDP9_9B_like', NULL, NULL, NULL, 2),
(12215, NULL, 'cd14845', NULL, NULL, 'L-Ala-D-Glu_peptidase_like', NULL, 'L-Ala-D-Glu_peptidase_like', NULL, NULL, NULL, 2),
(12216, NULL, 'cd09698', NULL, NULL, 'Cas8a2_I-A', NULL, 'Cas8a2_I-A', NULL, NULL, NULL, 2),
(12217, NULL, 'cd14477', NULL, NULL, 'SPX_XPR1_like', NULL, 'SPX_XPR1_like', NULL, NULL, NULL, 2),
(12218, NULL, 'cd03224', NULL, NULL, 'ABC_TM1139_LivF_branched', NULL, 'ABC_TM1139_LivF_branched', NULL, NULL, NULL, 2),
(12219, NULL, 'cd12161', NULL, NULL, 'GDH_like_1', NULL, 'GDH_like_1', NULL, NULL, NULL, 2),
(12220, NULL, 'cd16668', NULL, NULL, 'RING-H2_GRAIL', NULL, 'RING-H2_GRAIL', NULL, NULL, NULL, 2),
(12221, NULL, 'cd10360', NULL, NULL, 'SH2_Srm', NULL, 'SH2_Srm', NULL, NULL, NULL, 2),
(12222, NULL, 'cd04596', NULL, NULL, 'CBS_pair_DRTGG_assoc', NULL, 'CBS_pair_DRTGG_assoc', NULL, NULL, NULL, 2),
(12223, NULL, 'cd06561', NULL, NULL, 'AlkD_like', NULL, 'AlkD_like', NULL, NULL, NULL, 2),
(12224, NULL, 'cd00031', NULL, NULL, 'CA_like', NULL, 'CA_like', NULL, NULL, NULL, 2),
(12225, NULL, 'cd00900', NULL, NULL, 'PH-like', NULL, 'PH-like', NULL, NULL, NULL, 2),
(12226, NULL, 'cd15511', NULL, NULL, 'PHD3_KMT2C', NULL, 'PHD3_KMT2C', NULL, NULL, NULL, 2),
(12227, NULL, 'cd17035', NULL, NULL, 'T3SC_IB_Spa15-like', NULL, 'T3SC_IB_Spa15-like', NULL, NULL, NULL, 2),
(12228, NULL, 'cd16760', NULL, NULL, 'RING-HC_MuRF2', NULL, 'RING-HC_MuRF2', NULL, NULL, NULL, 2),
(12229, NULL, 'cd14873', NULL, NULL, 'MYSc_Myo10', NULL, 'MYSc_Myo10', NULL, NULL, 31683, 2),
(12230, NULL, 'cd01452', NULL, NULL, 'VWA_26S_proteasome_subunit', NULL, 'VWA_26S_proteasome_subunit', NULL, NULL, NULL, 2),
(12231, NULL, 'cd02179', NULL, NULL, 'GH16_beta_GRP', NULL, 'GH16_beta_GRP', NULL, NULL, 27691, 2),
(12232, NULL, 'cd14322', NULL, NULL, 'UBA_LATS', NULL, 'UBA_LATS', NULL, NULL, NULL, 2),
(12233, NULL, 'cd14651', NULL, NULL, 'ZIP_Put3', NULL, 'ZIP_Put3', NULL, NULL, NULL, 2),
(12234, NULL, 'cd15752', NULL, NULL, 'FYVE_SlaC2-a', NULL, 'FYVE_SlaC2-a', NULL, NULL, 33212, 2),
(12235, NULL, 'cd16138', NULL, NULL, 'RA_MRL_MIG10', NULL, 'RA_MRL_MIG10', NULL, NULL, NULL, 2),
(12236, NULL, 'cd14107', NULL, NULL, 'STKc_obscurin_rpt1', NULL, 'STKc_obscurin_rpt1', NULL, NULL, NULL, 2),
(12237, NULL, 'cd07684', NULL, NULL, 'F-BAR_srGAP3', NULL, 'F-BAR_srGAP3', NULL, NULL, NULL, 2),
(12238, NULL, 'cd09745', NULL, NULL, 'Cas8a2_I-A', NULL, 'Cas8a2_I-A', NULL, NULL, NULL, 2),
(12239, NULL, 'cd01195', NULL, NULL, 'INT_C_like_5', NULL, 'INT_C_like_5', NULL, NULL, NULL, 2),
(12240, NULL, 'cd10924', NULL, NULL, 'CE4_COG4878', NULL, 'CE4_COG4878', NULL, NULL, NULL, 2),
(12241, NULL, 'cd15051', NULL, NULL, '7tmA_Histamine_H2R', NULL, '7tmA_Histamine_H2R', NULL, NULL, NULL, 2),
(12242, NULL, 'cd09984', NULL, NULL, 'LOTUS_8_Limkain_b1', NULL, 'LOTUS_8_Limkain_b1', NULL, NULL, NULL, 2),
(12243, NULL, 'cd01719', NULL, NULL, 'Sm_G', NULL, 'Sm_G', NULL, NULL, 11246, 2),
(12244, NULL, 'cd02076', NULL, NULL, 'P-type_ATPase_H', NULL, 'P-type_ATPase_H', NULL, NULL, 269, 2),
(12245, NULL, 'cd03500', NULL, NULL, 'SQR_TypeA_SdhD_like', NULL, 'SQR_TypeA_SdhD_like', NULL, NULL, NULL, 2),
(12246, NULL, 'cd10006', NULL, NULL, 'HDAC4', NULL, 'HDAC4', NULL, NULL, NULL, 2),
(12247, NULL, 'cd12471', NULL, NULL, 'RRM1_MSSP2', NULL, 'RRM1_MSSP2', NULL, NULL, NULL, 2),
(12248, NULL, 'cd05911', NULL, NULL, 'Firefly_Luc_like', NULL, 'Firefly_Luc_like', NULL, NULL, NULL, 2),
(12249, NULL, 'cd02864', NULL, NULL, 'Heme_Cu_Oxidase_III_1', NULL, 'Heme_Cu_Oxidase_III_1', NULL, NULL, NULL, 2),
(12250, NULL, 'cd08994', NULL, NULL, 'GH43_62_32_68_117_130-like', NULL, 'GH43_62_32_68_117_130-like', NULL, NULL, NULL, 2),
(12251, NULL, 'cd06117', NULL, NULL, 'Ec2MCS_like_1', NULL, 'Ec2MCS_like_1', NULL, NULL, NULL, 2),
(12252, NULL, 'cd12476', NULL, NULL, 'RRM1_SNF', NULL, 'RRM1_SNF', NULL, NULL, NULL, 2);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(12253, NULL, 'cd15531', NULL, NULL, 'PHD1_CHD_II', NULL, 'PHD1_CHD_II', NULL, NULL, NULL, 2),
(12254, NULL, 'cd13162', NULL, NULL, 'PTB_RGS12', NULL, 'PTB_RGS12', NULL, NULL, NULL, 2),
(12255, NULL, 'cd11692', NULL, NULL, 'HRI1_N_like', NULL, 'HRI1_N_like', NULL, NULL, 31880, 2),
(12256, NULL, 'cd05620', NULL, NULL, 'STKc_nPKC_delta', NULL, 'STKc_nPKC_delta', NULL, NULL, 12670, 2),
(12257, NULL, 'cd19175', NULL, NULL, 'SET_ASHR3-like', NULL, 'SET_ASHR3-like', NULL, NULL, NULL, 2),
(12258, NULL, 'cd12706', NULL, NULL, 'RRM_LARP5', NULL, 'RRM_LARP5', NULL, NULL, 17108, 2),
(12259, NULL, 'cd19927', NULL, NULL, 'REC_Ycf29', NULL, 'REC_Ycf29', NULL, NULL, NULL, 2),
(12260, NULL, 'cd09488', NULL, NULL, 'SAM_EPH-R', NULL, 'SAM_EPH-R', NULL, NULL, NULL, 2),
(12261, NULL, 'cd17314', NULL, NULL, 'MFS_MCT_like', NULL, 'MFS_MCT_like', NULL, NULL, NULL, 2),
(12262, NULL, 'cd16234', NULL, NULL, 'EFh_SPARC_SMOC', NULL, 'EFh_SPARC_SMOC', NULL, NULL, NULL, 2),
(12263, NULL, 'cd00321', NULL, NULL, 'SO_family_Moco', NULL, 'SO_family_Moco', NULL, NULL, NULL, 2),
(12264, NULL, 'cd11773', NULL, NULL, 'SH3_Sla1p_1', NULL, 'SH3_Sla1p_1', NULL, NULL, 32955, 2),
(12265, NULL, 'cd10046', NULL, NULL, 'Reelin_repeat_2_subrepeat_2', NULL, 'Reelin_repeat_2_subrepeat_2', NULL, NULL, NULL, 2),
(12266, NULL, 'cd01313', NULL, NULL, 'Met_dep_hydrolase_E', NULL, 'Met_dep_hydrolase_E', NULL, NULL, NULL, 2),
(12267, NULL, 'cd06558', NULL, NULL, 'crotonase-like', NULL, 'crotonase-like', NULL, NULL, NULL, 2),
(12268, NULL, 'cd12158', NULL, NULL, 'ErythrP_dh', NULL, 'ErythrP_dh', NULL, NULL, 14682, 2),
(12269, NULL, 'cd12330', NULL, NULL, 'RRM2_Hrp1p', NULL, 'RRM2_Hrp1p', NULL, NULL, 13881, 2),
(12270, NULL, 'cd06530', NULL, NULL, 'S26_SPase_I', NULL, 'S26_SPase_I', NULL, NULL, 19307, 2),
(12271, NULL, 'cd16995', NULL, NULL, 'VHS_Tom1', NULL, 'VHS_Tom1', NULL, NULL, NULL, 2),
(12272, NULL, 'cd01106', NULL, NULL, 'HTH_TipAL-Mta', NULL, 'HTH_TipAL-Mta', NULL, NULL, NULL, 2),
(12273, NULL, 'cd01752', NULL, NULL, 'PLAT_polycystin', NULL, 'PLAT_polycystin', NULL, NULL, 30404, 2),
(12274, NULL, 'cd05030', NULL, NULL, 'calgranulins', NULL, 'calgranulins', NULL, NULL, NULL, 2),
(12275, NULL, 'cd04114', NULL, NULL, 'Rab30', NULL, 'Rab30', NULL, NULL, 30407, 2),
(12276, NULL, 'cd05063', NULL, NULL, 'PTKc_EphR_A2', NULL, 'PTKc_EphR_A2', NULL, NULL, NULL, 2),
(12277, NULL, 'cd11634', NULL, NULL, 'HR1_Rhophilin-2', NULL, 'HR1_Rhophilin-2', NULL, NULL, NULL, 2),
(12278, NULL, 'cd06492', NULL, NULL, 'p23_mNUDC_like', NULL, 'p23_mNUDC_like', NULL, NULL, NULL, 2),
(12279, NULL, 'cd03483', NULL, NULL, 'MutL_Trans_MLH1', NULL, 'MutL_Trans_MLH1', NULL, NULL, NULL, 2),
(12280, NULL, 'cd03518', NULL, NULL, 'Link_domain_HAPLN_module_1', NULL, 'Link_domain_HAPLN_module_1', NULL, NULL, NULL, 2),
(12281, NULL, 'cd13731', NULL, NULL, 'PBP2_iGluR_delta_2', NULL, 'PBP2_iGluR_delta_2', NULL, NULL, NULL, 2),
(12282, NULL, 'cd08999', NULL, NULL, 'GH43_ABN-like', NULL, 'GH43_ABN-like', NULL, NULL, NULL, 2),
(12283, NULL, 'cd07055', NULL, NULL, 'BMC_like_2', NULL, 'BMC_like_2', NULL, NULL, NULL, 2),
(12284, NULL, 'cd12725', NULL, NULL, 'RRM2_CPEB1', NULL, 'RRM2_CPEB1', NULL, NULL, NULL, 2),
(12285, NULL, 'cd07153', NULL, NULL, 'Fur_like', NULL, 'Fur_like', NULL, NULL, 550, 2),
(12286, NULL, 'cd12944', NULL, NULL, 'LEM_ANKL2', NULL, 'LEM_ANKL2', NULL, NULL, 12183, 2),
(12287, NULL, 'cd01709', NULL, NULL, 'RT_like_1', NULL, 'RT_like_1', NULL, NULL, NULL, 2),
(12288, NULL, 'cd11279', NULL, NULL, 'Sema_RON', NULL, 'Sema_RON', NULL, NULL, 27954, 2),
(12289, NULL, 'cd14015', NULL, NULL, 'STKc_VRK', NULL, 'STKc_VRK', NULL, NULL, NULL, 2),
(12290, NULL, 'cd08421', NULL, NULL, 'PBP2_LTTR_like_1', NULL, 'PBP2_LTTR_like_1', NULL, NULL, NULL, 2),
(12291, NULL, 'cd00319', NULL, NULL, 'Ribosomal_S12_like', NULL, 'Ribosomal_S12_like', NULL, NULL, NULL, 2),
(12292, NULL, 'cd04754', NULL, NULL, 'Commd6', NULL, 'Commd6', NULL, NULL, NULL, 2),
(12293, NULL, 'sd00003', NULL, NULL, 'TSP3_1C', NULL, 'TSP3_1C', NULL, NULL, NULL, 2),
(12294, NULL, 'cd06242', NULL, NULL, 'M14-like', NULL, 'M14-like', NULL, NULL, NULL, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(12295, NULL, 'cd06250', NULL, NULL, 'M14_PaAOTO_like', NULL, 'M14_PaAOTO_like', NULL, NULL, NULL, 2),
(12296, NULL, 'cd01207', NULL, NULL, 'EVH1_Ena_VASP-like', NULL, 'EVH1_Ena_VASP-like', NULL, NULL, NULL, 2),
(12297, NULL, 'cd08984', NULL, NULL, 'GH43-like', NULL, 'GH43-like', NULL, NULL, NULL, 2),
(12298, NULL, 'cd09968', NULL, NULL, 'UP_III', NULL, 'UP_III', NULL, NULL, NULL, 2),
(12299, NULL, 'cd14496', NULL, NULL, 'PTP_paladin', NULL, 'PTP_paladin', NULL, NULL, NULL, 2),
(12300, NULL, 'cd07772', NULL, NULL, 'FGGY_NaCK_like', NULL, 'FGGY_NaCK_like', NULL, NULL, NULL, 2),
(12301, NULL, 'cd03133', NULL, NULL, 'GATase1_ES1', NULL, 'GATase1_ES1', NULL, NULL, NULL, 2),
(12302, NULL, 'cd14838', NULL, NULL, 'AP4_Mu_N', NULL, 'AP4_Mu_N', NULL, NULL, NULL, 2),
(12303, NULL, 'cd05685', NULL, NULL, 'S1_Tex', NULL, 'S1_Tex', NULL, NULL, 35205, 2),
(12304, NULL, 'cd08489', NULL, NULL, 'PBP2_NikA', NULL, 'PBP2_NikA', NULL, NULL, 13376, 2),
(12305, NULL, 'cd14127', NULL, NULL, 'STKc_CK1_fungal', NULL, 'STKc_CK1_fungal', NULL, NULL, NULL, 2),
(12306, NULL, 'cd17728', NULL, NULL, 'BRCT_TopBP1_rpt8', NULL, 'BRCT_TopBP1_rpt8', NULL, NULL, NULL, 2),
(12307, NULL, 'cd04629', NULL, NULL, 'CBS_pair_bac', NULL, 'CBS_pair_bac', NULL, NULL, 34816, 2),
(12308, NULL, 'cd02582', NULL, NULL, 'RNAP_archeal_A''', NULL, 'RNAP_archeal_A''', NULL, NULL, 9691, 2),
(12309, NULL, 'cd07325', NULL, NULL, 'M48_Ste24p_like', NULL, 'M48_Ste24p_like', NULL, NULL, NULL, 2),
(12310, NULL, 'cd01806', NULL, NULL, 'Ubl_NEDD8', NULL, 'Ubl_NEDD8', NULL, NULL, 28579, 2),
(12311, NULL, 'cd20167', NULL, NULL, 'Peptidase_M90-like', NULL, 'Peptidase_M90-like', NULL, NULL, NULL, 2),
(12312, NULL, 'cd08338', NULL, NULL, 'DED_PEA15', NULL, 'DED_PEA15', NULL, NULL, 25346, 2),
(12313, NULL, 'cd08939', NULL, NULL, 'KDSR-like_SDR_c', NULL, 'KDSR-like_SDR_c', NULL, NULL, 35686, 2),
(12314, NULL, 'cd07292', NULL, NULL, 'PX_SNX6', NULL, 'PX_SNX6', NULL, NULL, 37231, 2),
(12315, NULL, 'cd08204', NULL, NULL, 'ArfGap', NULL, 'ArfGap', NULL, NULL, NULL, 2),
(12316, NULL, 'cd09166', NULL, NULL, 'PLDc_PPK1_C1_unchar', NULL, 'PLDc_PPK1_C1_unchar', NULL, NULL, NULL, 2),
(12317, NULL, 'cd16971', NULL, NULL, 'Alpha_kinase_ChaK1_TRMP7', NULL, 'Alpha_kinase_ChaK1_TRMP7', NULL, NULL, NULL, 2),
(12318, NULL, 'cd19001', NULL, NULL, 'LGIC_ECD_GABAAR_delta', NULL, 'LGIC_ECD_GABAAR_delta', NULL, NULL, NULL, 2),
(12319, NULL, 'cd14358', NULL, NULL, 'UBA_NAC_euk', NULL, 'UBA_NAC_euk', NULL, NULL, NULL, 2),
(12320, NULL, 'cd08387', NULL, NULL, 'C2A_Synaptotagmin-8', NULL, 'C2A_Synaptotagmin-8', NULL, NULL, NULL, 2),
(12321, NULL, 'cd10022', NULL, NULL, '14-3-3_beta_zeta', NULL, '14-3-3_beta_zeta', NULL, NULL, NULL, 2),
(12322, NULL, 'cd14324', NULL, NULL, 'UBA_Dsk2p_like', NULL, 'UBA_Dsk2p_like', NULL, NULL, NULL, 2),
(12323, NULL, 'cd01828', NULL, NULL, 'sialate_O-acetylesterase_like2', NULL, 'sialate_O-acetylesterase_like2', NULL, NULL, NULL, 2),
(12324, NULL, 'cd03052', NULL, NULL, 'GST_N_GDAP1', NULL, 'GST_N_GDAP1', NULL, NULL, NULL, 2),
(12325, NULL, 'cd07375', NULL, NULL, 'Anticodon_Ia_like', NULL, 'Anticodon_Ia_like', NULL, NULL, NULL, 2),
(12326, NULL, 'cd01200', NULL, NULL, 'WHEPGMRS_RNA', NULL, 'WHEPGMRS_RNA', NULL, NULL, NULL, 2),
(12327, NULL, 'cd02857', NULL, NULL, 'E_set_CDase_PDE_N', NULL, 'E_set_CDase_PDE_N', NULL, NULL, 2608, 2),
(12328, NULL, 'cd03809', NULL, NULL, 'GT4_MtfB-like', NULL, 'GT4_MtfB-like', NULL, NULL, NULL, 2),
(12329, NULL, 'cd14738', NULL, NULL, 'PAAR_2', NULL, 'PAAR_2', NULL, NULL, NULL, 2),
(12330, NULL, 'cd05057', NULL, NULL, 'PTKc_EGFR_like', NULL, 'PTKc_EGFR_like', NULL, NULL, NULL, 2),
(12331, NULL, 'cd10375', NULL, NULL, 'SH2_STAT4', NULL, 'SH2_STAT4', NULL, NULL, 32281, 2),
(12332, NULL, 'cd14899', NULL, NULL, 'MYSc_Myo38', NULL, 'MYSc_Myo38', NULL, NULL, NULL, 2),
(12333, NULL, 'cd04038', NULL, NULL, 'C2_ArfGAP', NULL, 'C2_ArfGAP', NULL, NULL, NULL, 2),
(12334, NULL, 'cd18596', NULL, NULL, 'ABC_6TM_VMR1_D1_like', NULL, 'ABC_6TM_VMR1_D1_like', NULL, NULL, NULL, 2),
(12335, NULL, 'cd13833', NULL, NULL, 'HU_IHF_like', NULL, 'HU_IHF_like', NULL, NULL, NULL, 2);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(12336, NULL, 'cd06128', NULL, NULL, 'DNA_polA_exo', NULL, 'DNA_polA_exo', NULL, NULL, NULL, 2),
(12337, NULL, 'cd07287', NULL, NULL, 'PX_RPK118_like', NULL, 'PX_RPK118_like', NULL, NULL, 37001, 2),
(12338, NULL, 'cd18091', NULL, NULL, 'SpoU-like_TRM3-like', NULL, 'SpoU-like_TRM3-like', NULL, NULL, 34684, 2),
(12339, NULL, 'cd15046', NULL, NULL, '7tmC_TAS1R', NULL, '7tmC_TAS1R', NULL, NULL, NULL, 2),
(12340, NULL, 'cd01330', NULL, NULL, 'KAZAL_SLC21', NULL, 'KAZAL_SLC21', NULL, NULL, NULL, 2),
(12341, NULL, 'cd04732', NULL, NULL, 'HisA', NULL, 'HisA', NULL, NULL, 15173, 2),
(12342, NULL, 'cd13910', NULL, NULL, 'CuRO_3_MCO_like_4', NULL, 'CuRO_3_MCO_like_4', NULL, NULL, NULL, 2),
(12343, NULL, 'cd13254', NULL, NULL, 'PH2_ARAP', NULL, 'PH2_ARAP', NULL, NULL, NULL, 2),
(12344, NULL, 'cd09288', NULL, NULL, 'Photosystem-II_D2', NULL, 'Photosystem-II_D2', NULL, NULL, 6665, 2),
(12345, NULL, 'cd16301', NULL, NULL, 'IMP_DIM-like_MBL-B1', NULL, 'IMP_DIM-like_MBL-B1', NULL, NULL, NULL, 2),
(12346, NULL, 'cd19600', NULL, NULL, 'serpin11-like_insects', NULL, 'serpin11-like_insects', NULL, NULL, NULL, 2),
(12347, NULL, 'cd07940', NULL, NULL, 'DRE_TIM_IPMS', NULL, 'DRE_TIM_IPMS', NULL, NULL, NULL, 2),
(12348, NULL, 'cd00837', NULL, NULL, 'EVH1_family', NULL, 'EVH1_family', NULL, NULL, NULL, 2),
(12349, NULL, 'cd03359', NULL, NULL, 'LbH_Dynactin_5', NULL, 'LbH_Dynactin_5', NULL, NULL, NULL, 2),
(12350, NULL, 'cd18380', NULL, NULL, 'BTB_POZ_Kv4_KCND', NULL, 'BTB_POZ_Kv4_KCND', NULL, NULL, NULL, 2),
(12351, NULL, 'cd06320', NULL, NULL, 'PBP1_allose_binding', NULL, 'PBP1_allose_binding', NULL, NULL, NULL, 2),
(12352, NULL, 'cd14392', NULL, NULL, 'UBA_Cbl-b', NULL, 'UBA_Cbl-b', NULL, NULL, NULL, 2),
(12353, NULL, 'cd13558', NULL, NULL, 'PBP2_SsuA_like_2', NULL, 'PBP2_SsuA_like_2', NULL, NULL, NULL, 2),
(12354, NULL, 'cd03190', NULL, NULL, 'GST_C_Omega_like', NULL, 'GST_C_Omega_like', NULL, NULL, NULL, 2),
(12355, NULL, 'cd12788', NULL, NULL, 'RasGAP_plexin_D1', NULL, 'RasGAP_plexin_D1', NULL, NULL, NULL, 2),
(12356, NULL, 'cd03060', NULL, NULL, 'GST_N_Omega_like', NULL, 'GST_N_Omega_like', NULL, NULL, NULL, 2),
(12357, NULL, 'cd07345', NULL, NULL, 'M48A_Ste24p-like', NULL, 'M48A_Ste24p-like', NULL, NULL, NULL, 2),
(12358, NULL, 'cd08667', NULL, NULL, 'APC10-ZZEF1', NULL, 'APC10-ZZEF1', NULL, NULL, NULL, 2),
(12359, NULL, 'cd20014', NULL, NULL, 'PBP1_RPA0668_benzoate-like', NULL, 'PBP1_RPA0668_benzoate-like', NULL, NULL, NULL, 2),
(12360, NULL, 'cd00802', NULL, NULL, 'class_I_aaRS_core', NULL, 'class_I_aaRS_core', NULL, NULL, NULL, 2),
(12361, NULL, 'cd17024', NULL, NULL, 'T3SC_IA_DspF-like', NULL, 'T3SC_IA_DspF-like', NULL, NULL, NULL, 2),
(12362, NULL, 'cd17868', NULL, NULL, 'GPN', NULL, 'GPN', NULL, NULL, NULL, 2),
(12363, NULL, 'cd04723', NULL, NULL, 'HisA_HisF', NULL, 'HisA_HisF', NULL, NULL, NULL, 2),
(12364, NULL, 'cd13317', NULL, NULL, 'PH_PLEKHO1_PLEKHO2', NULL, 'PH_PLEKHO1_PLEKHO2', NULL, NULL, NULL, 2),
(12365, NULL, 'cd19464', NULL, NULL, 'CRBP3', NULL, 'CRBP3', NULL, NULL, NULL, 2),
(12366, NULL, 'cd02607', NULL, NULL, 'HAD_ThrH_like', NULL, 'HAD_ThrH_like', NULL, NULL, NULL, 2),
(12367, NULL, 'cd03344', NULL, NULL, 'GroEL', NULL, 'GroEL', NULL, NULL, 4116, 2),
(12368, NULL, 'cd00917', NULL, NULL, 'PG-PI_TP', NULL, 'PG-PI_TP', NULL, NULL, 33231, 2),
(12369, NULL, 'cd09509', NULL, NULL, 'SAM_Polycomb', NULL, 'SAM_Polycomb', NULL, NULL, NULL, 2),
(12370, NULL, 'cd05775', NULL, NULL, 'Ig_CD2_like_N', NULL, 'Ig_CD2_like_N', NULL, NULL, NULL, 2),
(12371, NULL, 'cd19871', NULL, NULL, 'DSRM_DUS2L', NULL, 'DSRM_DUS2L', NULL, NULL, 34856, 2),
(12372, NULL, 'cd15874', NULL, NULL, 'R-SNARE_Snc1', NULL, 'R-SNARE_Snc1', NULL, NULL, NULL, 2),
(12373, NULL, 'cd09499', NULL, NULL, 'SAM_AIDA1AB-like_repeat1', NULL, 'SAM_AIDA1AB-like_repeat1', NULL, NULL, 30153, 2),
(12374, NULL, 'cd14519', NULL, NULL, 'DSP_DUSP22_15', NULL, 'DSP_DUSP22_15', NULL, NULL, NULL, 2),
(12375, NULL, 'cd21684', NULL, NULL, 'ORF7a_SARS-CoV-2-like', NULL, 'ORF7a_SARS-CoV-2-like', NULL, NULL, 36289, 2),
(12376, NULL, 'cd03050', NULL, NULL, 'GST_N_Theta', NULL, 'GST_N_Theta', NULL, NULL, 27497, 2);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(12377, NULL, 'cd06634', NULL, NULL, 'STKc_TAO2', NULL, 'STKc_TAO2', NULL, NULL, NULL, 2),
(12378, NULL, 'cd08626', NULL, NULL, 'PI-PLCc_beta4', NULL, 'PI-PLCc_beta4', NULL, NULL, NULL, 2),
(12379, NULL, 'cd12233', NULL, NULL, 'RRM_Srp1p_AtRSp31_like', NULL, 'RRM_Srp1p_AtRSp31_like', NULL, NULL, NULL, 2),
(12380, NULL, 'cd13257', NULL, NULL, 'PH4_ARAP', NULL, 'PH4_ARAP', NULL, NULL, NULL, 2),
(12381, NULL, 'cd19041', NULL, NULL, 'LGIC_ECD_GABAAR_B2', NULL, 'LGIC_ECD_GABAAR_B2', NULL, NULL, NULL, 2),
(12382, NULL, 'cd11931', NULL, NULL, 'SH3_SH3RF3_2', NULL, 'SH3_SH3RF3_2', NULL, NULL, NULL, 2),
(12383, NULL, 'cd03820', NULL, NULL, 'GT4_AmsD-like', NULL, 'GT4_AmsD-like', NULL, NULL, NULL, 2),
(12384, NULL, 'cd00528', NULL, NULL, 'MoaC', NULL, 'MoaC', NULL, NULL, NULL, 2),
(12385, NULL, 'cd09716', NULL, NULL, 'Cas5_I', NULL, 'Cas5_I', NULL, NULL, 17922, 2),
(12386, NULL, 'cd14546', NULL, NULL, 'R-PTP-N-N2', NULL, 'R-PTP-N-N2', NULL, NULL, NULL, 2),
(12387, NULL, 'cd03870', NULL, NULL, 'M14_CPA', NULL, 'M14_CPA', NULL, NULL, 18974, 2),
(12388, NULL, 'cd15756', NULL, NULL, 'FYVE_WDFY1', NULL, 'FYVE_WDFY1', NULL, NULL, 35986, 2),
(12389, NULL, 'cd19745', NULL, NULL, 'bHLH_TS_ASCL3', NULL, 'bHLH_TS_ASCL3', NULL, NULL, NULL, 2),
(12390, NULL, 'cd02336', NULL, NULL, 'ZZ_RSC8', NULL, 'ZZ_RSC8', NULL, NULL, 30933, 2),
(12391, NULL, 'cd14869', NULL, NULL, 'uS7_Bacteria', NULL, 'uS7_Bacteria', NULL, NULL, NULL, 2),
(12392, NULL, 'cd04743', NULL, NULL, 'NPD_PKS', NULL, 'NPD_PKS', NULL, NULL, NULL, 2),
(12393, NULL, 'cd06396', NULL, NULL, 'PB1_NBR1', NULL, 'PB1_NBR1', NULL, NULL, 10147, 2),
(12394, NULL, 'cd04230', NULL, NULL, 'Sulfocyanin', NULL, 'Sulfocyanin', NULL, NULL, 19708, 2),
(12395, NULL, 'cd10430', NULL, NULL, 'BI-1', NULL, 'BI-1', NULL, NULL, NULL, 2),
(12396, NULL, 'cd04184', NULL, NULL, 'GT2_RfbC_Mx_like', NULL, 'GT2_RfbC_Mx_like', NULL, NULL, NULL, 2),
(12397, NULL, 'cd09831', NULL, NULL, 'CBS_pair_ABC_Gly_Pro_assoc', NULL, 'CBS_pair_ABC_Gly_Pro_assoc', NULL, NULL, NULL, 2),
(12398, NULL, 'cd05528', NULL, NULL, 'Bromo_AAA', NULL, 'Bromo_AAA', NULL, NULL, NULL, 2),
(12399, NULL, 'cd19741', NULL, NULL, 'bHLH-O_ESMB_like', NULL, 'bHLH-O_ESMB_like', NULL, NULL, NULL, 2),
(12400, NULL, 'cd12895', NULL, NULL, 'SPRY_PRY_TRIM46', NULL, 'SPRY_PRY_TRIM46', NULL, NULL, 27686, 2),
(12401, NULL, 'cd17788', NULL, NULL, 'CBS_pair_bac', NULL, 'CBS_pair_bac', NULL, NULL, NULL, 2),
(12402, NULL, 'cd01408', NULL, NULL, 'SIRT1', NULL, 'SIRT1', NULL, NULL, NULL, 2),
(12403, NULL, 'cd18448', NULL, NULL, 'BACK_KLHL8', NULL, 'BACK_KLHL8', NULL, NULL, NULL, 2),
(12404, NULL, 'cd10002', NULL, NULL, 'HDAC10_HDAC6-dom1', NULL, 'HDAC10_HDAC6-dom1', NULL, NULL, NULL, 2),
(12405, NULL, 'cd17761', NULL, NULL, 'MCM_arch', NULL, 'MCM_arch', NULL, NULL, NULL, 2),
(12406, NULL, 'cd17642', NULL, NULL, 'Firefly_Luc', NULL, 'Firefly_Luc', NULL, NULL, NULL, 2),
(12407, NULL, 'cd17510', NULL, NULL, 'T3SC_YbjN-like_2', NULL, 'T3SC_YbjN-like_2', NULL, NULL, NULL, 2),
(12408, NULL, 'cd01036', NULL, NULL, 'ClC_euk', NULL, 'ClC_euk', NULL, NULL, NULL, 2),
(12409, NULL, 'cd00488', NULL, NULL, 'PCD_DCoH', NULL, 'PCD_DCoH', NULL, NULL, NULL, 2),
(12410, NULL, 'cd04734', NULL, NULL, 'OYE_like_3_FMN', NULL, 'OYE_like_3_FMN', NULL, NULL, NULL, 2),
(12411, NULL, 'cd02848', NULL, NULL, 'E_set_Chitinase_N', NULL, 'E_set_Chitinase_N', NULL, NULL, NULL, 2),
(12412, NULL, 'cd12184', NULL, NULL, 'HGDH_like', NULL, 'HGDH_like', NULL, NULL, NULL, 2),
(12413, NULL, 'cd06308', NULL, NULL, 'PBP1_sensor_kinase-like', NULL, 'PBP1_sensor_kinase-like', NULL, NULL, NULL, 2),
(12414, NULL, 'cd15755', NULL, NULL, 'FYVE_PKHF2', NULL, 'FYVE_PKHF2', NULL, NULL, NULL, 2),
(12415, NULL, 'cd19969', NULL, NULL, 'PBP1_ABC_sugar_binding-like', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, NULL, 2),
(12416, NULL, 'cd14440', NULL, NULL, 'AlgX_N_like_3', NULL, 'AlgX_N_like_3', NULL, NULL, NULL, 2),
(12417, NULL, 'cd18263', NULL, NULL, 'BTB2_POZ_KLHL33', NULL, 'BTB2_POZ_KLHL33', NULL, NULL, NULL, 2),
(12418, NULL, 'cd14090', NULL, NULL, 'STKc_Mnk', NULL, 'STKc_Mnk', NULL, NULL, NULL, 2);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(12419, NULL, 'cd04974', NULL, NULL, 'Ig3_FGFR', NULL, 'Ig3_FGFR', NULL, NULL, NULL, 2),
(12420, NULL, 'cd07477', NULL, NULL, 'Peptidases_S8_Subtilisin_subset', NULL, 'Peptidases_S8_Subtilisin_subset', NULL, NULL, 5925, 2),
(12421, NULL, 'cd08997', NULL, NULL, 'GH68', NULL, 'GH68', NULL, NULL, 6448, 2),
(12422, NULL, 'cd16674', NULL, NULL, 'RING-H2_RNF12', NULL, 'RING-H2_RNF12', NULL, NULL, NULL, 2),
(12423, NULL, 'cd00588', NULL, NULL, 'CheW_like', NULL, 'CheW_like', NULL, NULL, NULL, 2),
(12424, NULL, 'cd00363', NULL, NULL, 'PFK', NULL, 'PFK', NULL, NULL, NULL, 2),
(12425, NULL, 'cd05350', NULL, NULL, 'SDR_c6', NULL, 'SDR_c6', NULL, NULL, NULL, 2),
(12426, NULL, 'cd08408', NULL, NULL, 'C2B_Synaptotagmin-14_16', NULL, 'C2B_Synaptotagmin-14_16', NULL, NULL, NULL, 2),
(12427, NULL, 'cd03451', NULL, NULL, 'FkbR2', NULL, 'FkbR2', NULL, NULL, NULL, 2),
(12428, NULL, 'cd06535', NULL, NULL, 'CIDE_N_CAD', NULL, 'CIDE_N_CAD', NULL, NULL, NULL, 2),
(12429, NULL, 'cd13139', NULL, NULL, 'MATE_like_14', NULL, 'MATE_like_14', NULL, NULL, NULL, 2),
(12430, NULL, 'cd12671', NULL, NULL, 'RRM_CSTF2_CSTF2T', NULL, 'RRM_CSTF2_CSTF2T', NULL, NULL, NULL, 2),
(12431, NULL, 'cd13382', NULL, NULL, 'PH_OCRL1', NULL, 'PH_OCRL1', NULL, NULL, 32215, 2),
(12432, NULL, 'cd14612', NULL, NULL, 'PTPc-N7', NULL, 'PTPc-N7', NULL, NULL, NULL, 2),
(12433, NULL, 'cd18503', NULL, NULL, 'BACK_calicin', NULL, 'BACK_calicin', NULL, NULL, NULL, 2),
(12434, NULL, 'cd15140', NULL, NULL, '7tmA_PGD2', NULL, '7tmA_PGD2', NULL, NULL, NULL, 2),
(12435, NULL, 'cd03726', NULL, NULL, 'SOCS_ASB7', NULL, 'SOCS_ASB7', NULL, NULL, 30853, 2),
(12436, NULL, 'cd14897', NULL, NULL, 'MYSc_Myo36', NULL, 'MYSc_Myo36', NULL, NULL, NULL, 2),
(12437, NULL, 'cd09655', NULL, NULL, 'CasRa_I-A', NULL, 'CasRa_I-A', NULL, NULL, NULL, 2),
(12438, NULL, 'cd17582', NULL, NULL, 'psREC_PRR', NULL, 'psREC_PRR', NULL, NULL, NULL, 2),
(12439, NULL, 'cd12576', NULL, NULL, 'RRM1_MSI', NULL, 'RRM1_MSI', NULL, NULL, 20559, 2),
(12440, NULL, 'cd06992', NULL, NULL, 'cupin_GDO-like_C', NULL, 'cupin_GDO-like_C', NULL, NULL, NULL, 2),
(12441, NULL, 'cd09168', NULL, NULL, 'PLDc_PaPPK1_C2_like', NULL, 'PLDc_PaPPK1_C2_like', NULL, NULL, NULL, 2),
(12442, NULL, 'cd19134', NULL, NULL, 'AKR_AKR5H1', NULL, 'AKR_AKR5H1', NULL, NULL, NULL, 2),
(12443, NULL, 'cd15487', NULL, NULL, 'bS6_chloro_cyano', NULL, 'bS6_chloro_cyano', NULL, NULL, NULL, 2),
(12444, NULL, 'cd18438', NULL, NULL, 'BRCT_BRC1_like_rpt4', NULL, 'BRCT_BRC1_like_rpt4', NULL, NULL, NULL, 2),
(12445, NULL, 'cd11643', NULL, NULL, 'Precorrin-6A-synthase', NULL, 'Precorrin-6A-synthase', NULL, NULL, 11586, 2),
(12446, NULL, 'cd18740', NULL, NULL, 'PIN_VapC4-5_FitB-like', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, NULL, 2),
(12447, NULL, 'cd16350', NULL, NULL, 'VOC_like', NULL, 'VOC_like', NULL, NULL, NULL, 2),
(12448, NULL, 'cd01447', NULL, NULL, 'Polysulfide_ST', NULL, 'Polysulfide_ST', NULL, NULL, NULL, 2),
(12449, NULL, 'cd18923', NULL, NULL, 'bHLHzip_USF2', NULL, 'bHLHzip_USF2', NULL, NULL, NULL, 2),
(12450, NULL, 'cd01720', NULL, NULL, 'Sm_D2', NULL, 'Sm_D2', NULL, NULL, 26855, 2),
(12451, NULL, 'cd06304', NULL, NULL, 'PBP1_BmpA_Med_PnrA-like', NULL, 'PBP1_BmpA_Med_PnrA-like', NULL, NULL, NULL, 2),
(12452, NULL, 'cd16197', NULL, NULL, 'EFh_PEF_CalpC', NULL, 'EFh_PEF_CalpC', NULL, NULL, NULL, 2),
(12453, NULL, 'cd01266', NULL, NULL, 'PH_Gab1_Gab2', NULL, 'PH_Gab1_Gab2', NULL, NULL, NULL, 2),
(12454, NULL, 'cd19127', NULL, NULL, 'AKR_AKR5B1', NULL, 'AKR_AKR5B1', NULL, NULL, NULL, 2),
(12455, NULL, 'cd11916', NULL, NULL, 'SH3_Sorbs1_3', NULL, 'SH3_Sorbs1_3', NULL, NULL, 28252, 2),
(12456, NULL, 'cd11451', NULL, NULL, 'bHLH_AtTT8_like', NULL, 'bHLH_AtTT8_like', NULL, NULL, NULL, 2),
(12457, NULL, 'cd11950', NULL, NULL, 'SH3_GRAP2_C', NULL, 'SH3_GRAP2_C', NULL, NULL, 28494, 2),
(12458, NULL, 'cd09550', NULL, NULL, 'SAM_EPH-A8', NULL, 'SAM_EPH-A8', NULL, NULL, NULL, 2),
(12459, NULL, 'cd00019', NULL, NULL, 'AP2Ec', NULL, 'AP2Ec', NULL, NULL, 3499, 2),
(12460, NULL, 'cd11829', NULL, NULL, 'SH3_GAS7', NULL, 'SH3_GAS7', NULL, NULL, NULL, 2);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(12461, NULL, 'cd10747', NULL, NULL, 'DnaJ_C', NULL, 'DnaJ_C', NULL, NULL, NULL, 2),
(12462, NULL, 'cd15627', NULL, NULL, 'PHD_BAZ1A', NULL, 'PHD_BAZ1A', NULL, NULL, NULL, 2),
(12463, NULL, 'cd20073', NULL, NULL, 'SET_SUV39H_Clr4-like', NULL, 'SET_SUV39H_Clr4-like', NULL, NULL, NULL, 2),
(12464, NULL, 'cd06812', NULL, NULL, 'PLPDE_III_DSD_D-TA_like_1', NULL, 'PLPDE_III_DSD_D-TA_like_1', NULL, NULL, NULL, 2),
(12465, NULL, 'cd10010', NULL, NULL, 'HDAC1', NULL, 'HDAC1', NULL, NULL, NULL, 2),
(12466, NULL, 'cd15433', NULL, NULL, '7tmA_OR2Y-like', NULL, '7tmA_OR2Y-like', NULL, NULL, NULL, 2),
(12467, NULL, 'cd19563', NULL, NULL, 'serpinB3_B4_SCCA1_2', NULL, 'serpinB3_B4_SCCA1_2', NULL, NULL, NULL, 2),
(12468, NULL, 'cd06071', NULL, NULL, 'Beach', NULL, 'Beach', NULL, NULL, 299, 2),
(12469, NULL, 'cd06414', NULL, NULL, 'GH25_LytC-like', NULL, 'GH25_LytC-like', NULL, NULL, NULL, 2),
(12470, NULL, 'cd15733', NULL, NULL, 'FYVE_MTMR4', NULL, 'FYVE_MTMR4', NULL, NULL, NULL, 2),
(12471, NULL, 'cd08212', NULL, NULL, 'RuBisCO_large_I', NULL, 'RuBisCO_large_I', NULL, NULL, 20958, 2),
(12472, NULL, 'cd15099', NULL, NULL, '7tmA_Cannabinoid_R', NULL, '7tmA_Cannabinoid_R', NULL, NULL, NULL, 2),
(12473, NULL, 'cd02896', NULL, NULL, 'complement_C3_C4_C5', NULL, 'complement_C3_C4_C5', NULL, NULL, NULL, 2),
(12474, NULL, 'cd15846', NULL, NULL, 'SNARE_syntaxin17', NULL, 'SNARE_syntaxin17', NULL, NULL, NULL, 2),
(12475, NULL, 'cd20224', NULL, NULL, 'PFM_alpha-toxin-like', NULL, 'PFM_alpha-toxin-like', NULL, NULL, NULL, 2),
(12476, NULL, 'cd08447', NULL, NULL, 'PBP2_LTTR_aromatics_like_1', NULL, 'PBP2_LTTR_aromatics_like_1', NULL, NULL, NULL, 2),
(12477, NULL, 'cd15659', NULL, NULL, 'PHD5_NSD1', NULL, 'PHD5_NSD1', NULL, NULL, NULL, 2),
(12478, NULL, 'cd12351', NULL, NULL, 'RRM4_SHARP', NULL, 'RRM4_SHARP', NULL, NULL, 4218, 2),
(12479, NULL, 'cd05008', NULL, NULL, 'SIS_GlmS_GlmD_1', NULL, 'SIS_GlmS_GlmD_1', NULL, NULL, 32579, 2),
(12480, NULL, 'cd12762', NULL, NULL, 'RRM1_hnRNPA2B1', NULL, 'RRM1_hnRNPA2B1', NULL, NULL, 4405, 2),
(12481, NULL, 'cd02215', NULL, NULL, 'cupin_QDO_N_C', NULL, 'cupin_QDO_N_C', NULL, NULL, NULL, 2),
(12482, NULL, 'cd18654', NULL, NULL, 'CSD_HP1beta_Cbx1', NULL, 'CSD_HP1beta_Cbx1', NULL, NULL, NULL, 2),
(12483, NULL, 'cd07185', NULL, NULL, 'OmpA_C-like', NULL, 'OmpA_C-like', NULL, NULL, 1786, 2),
(12484, NULL, 'cd15096', NULL, NULL, '7tmA_AstA_R_insect', NULL, '7tmA_AstA_R_insect', NULL, NULL, NULL, 2),
(12485, NULL, 'cd11411', NULL, NULL, 'bHLH_TS_MRF', NULL, 'bHLH_TS_MRF', NULL, NULL, NULL, 2),
(12486, NULL, 'cd19925', NULL, NULL, 'REC_citrate_TCS', NULL, 'REC_citrate_TCS', NULL, NULL, NULL, 2),
(12487, NULL, 'cd02174', NULL, NULL, 'CCT', NULL, 'CCT', NULL, NULL, 29781, 2),
(12488, NULL, 'cd08422', NULL, NULL, 'PBP2_CrgA_like', NULL, 'PBP2_CrgA_like', NULL, NULL, NULL, 2),
(12489, NULL, 'cd15690', NULL, NULL, 'PHD1_DPF1', NULL, 'PHD1_DPF1', NULL, NULL, NULL, 2),
(12490, NULL, 'cd04767', NULL, NULL, 'HTH_HspR-like_MBC', NULL, 'HTH_HspR-like_MBC', NULL, NULL, NULL, 2),
(12491, NULL, 'cd14365', NULL, NULL, 'CUE_N4BP2', NULL, 'CUE_N4BP2', NULL, NULL, 30772, 2),
(12492, NULL, 'cd01131', NULL, NULL, 'PilT', NULL, 'PilT', NULL, NULL, 4985, 2),
(12493, NULL, 'cd08769', NULL, NULL, 'DAP_dppA_2', NULL, 'DAP_dppA_2', NULL, NULL, NULL, 2),
(12494, NULL, 'cd11775', NULL, NULL, 'SH3_Sla1p_3', NULL, 'SH3_Sla1p_3', NULL, NULL, 28622, 2),
(12495, NULL, 'cd08757', NULL, NULL, 'SAM_PNT_ESE', NULL, 'SAM_PNT_ESE', NULL, NULL, NULL, 2),
(12496, NULL, 'cd07415', NULL, NULL, 'MPP_PP2A_PP4_PP6', NULL, 'MPP_PP2A_PP4_PP6', NULL, NULL, NULL, 2),
(12497, NULL, 'cd15352', NULL, NULL, '7tmA_MC3R', NULL, '7tmA_MC3R', NULL, NULL, NULL, 2),
(12498, NULL, 'cd18674', NULL, NULL, 'PIN_Pox_G5', NULL, 'PIN_Pox_G5', NULL, NULL, NULL, 2),
(12499, NULL, 'cd00522', NULL, NULL, 'Hemerythrin-like', NULL, 'Hemerythrin-like', NULL, NULL, NULL, 2),
(12500, NULL, 'cd08002', NULL, NULL, 'WGR_PARP3_like', NULL, 'WGR_PARP3_like', NULL, NULL, NULL, 2),
(12501, NULL, 'cd12525', NULL, NULL, 'RRM1_MEI2_fungi', NULL, 'RRM1_MEI2_fungi', NULL, NULL, NULL, 2);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(12502, NULL, 'cd07737', NULL, NULL, 'YcbL-like_MBL-fold', NULL, 'YcbL-like_MBL-fold', NULL, NULL, NULL, 2),
(12503, NULL, 'cd06489', NULL, NULL, 'p23_CS_hSgt1_like', NULL, 'p23_CS_hSgt1_like', NULL, NULL, NULL, 2),
(12504, NULL, 'sd00001', NULL, NULL, 'TSP3', NULL, 'TSP3', NULL, NULL, NULL, 2),
(12505, NULL, 'cd19824', NULL, NULL, 'Bbox2_TRIM2_C-VII', NULL, 'Bbox2_TRIM2_C-VII', NULL, NULL, NULL, 2),
(12506, NULL, 'cd16915', NULL, NULL, 'HATPase_DpiB-CitA-like', NULL, 'HATPase_DpiB-CitA-like', NULL, NULL, NULL, 2),
(12507, NULL, 'cd19111', NULL, NULL, 'AKR_AKR1G1_1I', NULL, 'AKR_AKR1G1_1I', NULL, NULL, NULL, 2),
(12508, NULL, 'cd09823', NULL, NULL, 'peroxinectin_like', NULL, 'peroxinectin_like', NULL, NULL, NULL, 2),
(12509, NULL, 'cd09666', NULL, NULL, 'Cas8a2_I-A', NULL, 'Cas8a2_I-A', NULL, NULL, 4011, 2),
(12510, NULL, 'cd13949', NULL, NULL, '7tm_V1R_pheromone', NULL, '7tm_V1R_pheromone', NULL, NULL, NULL, 2),
(12511, NULL, 'cd06258', NULL, NULL, 'M3_like', NULL, 'M3_like', NULL, NULL, NULL, 2),
(12512, NULL, 'cd14513', NULL, NULL, 'DSP_slingshot', NULL, 'DSP_slingshot', NULL, NULL, NULL, 2),
(12513, NULL, 'cd13877', NULL, NULL, 'CuRO_2_Fet3p_like', NULL, 'CuRO_2_Fet3p_like', NULL, NULL, 35125, 2),
(12514, NULL, 'cd09023', NULL, NULL, 'Aldose_epim_Ec_c4013', NULL, 'Aldose_epim_Ec_c4013', NULL, NULL, NULL, 2),
(12515, NULL, 'cd09350', NULL, NULL, 'LIM1_TRIP6', NULL, 'LIM1_TRIP6', NULL, NULL, NULL, 2),
(12516, NULL, 'cd09095', NULL, NULL, 'INPP5c_INPP5E-like', NULL, 'INPP5c_INPP5E-like', NULL, NULL, NULL, 2),
(12517, NULL, 'cd08712', NULL, NULL, 'RGS_RGS18', NULL, 'RGS_RGS18', NULL, NULL, NULL, 2),
(12518, NULL, 'cd03774', NULL, NULL, 'MATH_SPOP', NULL, 'MATH_SPOP', NULL, NULL, NULL, 2),
(12519, NULL, 'cd12784', NULL, NULL, 'RRM2_ROD1', NULL, 'RRM2_ROD1', NULL, NULL, NULL, 2),
(12520, NULL, 'cd07620', NULL, NULL, 'BAR_SH3BP1', NULL, 'BAR_SH3BP1', NULL, NULL, NULL, 2),
(12521, NULL, 'cd03402', NULL, NULL, 'SPFH_like_u2', NULL, 'SPFH_like_u2', NULL, NULL, NULL, 2),
(12522, NULL, 'cd05341', NULL, NULL, '3beta-17beta-HSD_like_SDR_c', NULL, '3beta-17beta-HSD_like_SDR_c', NULL, NULL, NULL, 2),
(12523, NULL, 'cd01321', NULL, NULL, 'ADGF', NULL, 'ADGF', NULL, NULL, NULL, 2),
(12524, NULL, 'cd11609', NULL, NULL, 'MCT1_N', NULL, 'MCT1_N', NULL, NULL, NULL, 2),
(12525, NULL, 'cd00670', NULL, NULL, 'Gly_His_Pro_Ser_Thr_tRS_core', NULL, 'Gly_His_Pro_Ser_Thr_tRS_core', NULL, NULL, NULL, 2),
(12526, NULL, 'cd00674', NULL, NULL, 'LysRS_core_class_I', NULL, 'LysRS_core_class_I', NULL, NULL, NULL, 2),
(12527, NULL, 'cd08807', NULL, NULL, 'CARD_CARD10_CARMA3', NULL, 'CARD_CARD10_CARMA3', NULL, NULL, 33526, 2),
(12528, NULL, 'cd15682', NULL, NULL, 'PHD_ING1', NULL, 'PHD_ING1', NULL, NULL, NULL, 2),
(12529, NULL, 'cd03788', NULL, NULL, 'GT20_TPS', NULL, 'GT20_TPS', NULL, NULL, 4078, 2),
(12530, NULL, 'cd06589', NULL, NULL, 'GH31', NULL, 'GH31', NULL, NULL, NULL, 2),
(12531, NULL, 'cd11365', NULL, NULL, 'RNase_PH_archRRP42', NULL, 'RNase_PH_archRRP42', NULL, NULL, 20672, 2),
(12532, NULL, 'cd00595', NULL, NULL, 'NDPk', NULL, 'NDPk', NULL, NULL, NULL, 2),
(12533, NULL, 'cd05618', NULL, NULL, 'STKc_aPKC_iota', NULL, 'STKc_aPKC_iota', NULL, NULL, 6166, 2),
(12534, NULL, 'cd03283', NULL, NULL, 'ABC_MutS-like', NULL, 'ABC_MutS-like', NULL, NULL, NULL, 2),
(12535, NULL, 'cd09094', NULL, NULL, 'INPP5c_INPP5J-like', NULL, 'INPP5c_INPP5J-like', NULL, NULL, NULL, 2),
(12536, NULL, 'cd08032', NULL, NULL, 'LARP_7', NULL, 'LARP_7', NULL, NULL, 11723, 2),
(12537, NULL, 'cd03880', NULL, NULL, 'M28_QC_like', NULL, 'M28_QC_like', NULL, NULL, 27488, 2),
(12538, NULL, 'cd18099', NULL, NULL, 'Trm10arch', NULL, 'Trm10arch', NULL, NULL, NULL, 2),
(12539, NULL, 'cd21159', NULL, NULL, 'XendoU', NULL, 'XendoU', NULL, NULL, 15843, 2),
(12540, NULL, 'cd17047', NULL, NULL, 'Ubl_UBFD1', NULL, 'Ubl_UBFD1', NULL, NULL, NULL, 2),
(12541, NULL, 'cd00498', NULL, NULL, 'Hsp33', NULL, 'Hsp33', NULL, NULL, 4769, 2),
(12542, NULL, 'cd11516', NULL, NULL, 'SLC6sbd_B0AT1', NULL, 'SLC6sbd_B0AT1', NULL, NULL, NULL, 2),
(12543, NULL, 'cd07893', NULL, NULL, 'OBF_DNA_ligase', NULL, 'OBF_DNA_ligase', NULL, NULL, NULL, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(12544, NULL, 'cd14405', NULL, NULL, 'UBA_MARK1', NULL, 'UBA_MARK1', NULL, NULL, NULL, 2),
(12545, NULL, 'cd12953', NULL, NULL, 'MMP_TTHA0227', NULL, 'MMP_TTHA0227', NULL, NULL, NULL, 2),
(12546, NULL, 'cd16472', NULL, NULL, 'RING-H2_RNF38_like', NULL, 'RING-H2_RNF38_like', NULL, NULL, NULL, 2),
(12547, NULL, 'cd03155', NULL, NULL, 'CD151_like_LEL', NULL, 'CD151_like_LEL', NULL, NULL, NULL, 2),
(12548, NULL, 'cd19562', NULL, NULL, 'serpinB2_PAI-2', NULL, 'serpinB2_PAI-2', NULL, NULL, NULL, 2),
(12549, NULL, 'cd02396', NULL, NULL, 'PCBP_like_KH', NULL, 'PCBP_like_KH', NULL, NULL, NULL, 2),
(12550, NULL, 'cd17718', NULL, NULL, 'BRCT_TopBP1_rpt3', NULL, 'BRCT_TopBP1_rpt3', NULL, NULL, NULL, 2),
(12551, NULL, 'cd12822', NULL, NULL, 'TmCorA-like', NULL, 'TmCorA-like', NULL, NULL, NULL, 2),
(12552, NULL, 'cd19358', NULL, NULL, 'TenA_E_Spr0628-like', NULL, 'TenA_E_Spr0628-like', NULL, NULL, NULL, 2),
(12553, NULL, 'cd15715', NULL, NULL, 'ePHD_JMJD2C', NULL, 'ePHD_JMJD2C', NULL, NULL, NULL, 2),
(12554, NULL, 'cd05469', NULL, NULL, 'Transthyretin_like', NULL, 'Transthyretin_like', NULL, NULL, NULL, 2),
(12555, NULL, 'cd07366', NULL, NULL, '3MGA_Dioxygenase', NULL, '3MGA_Dioxygenase', NULL, NULL, 29327, 2),
(12556, NULL, 'cd07822', NULL, NULL, 'SRPBCC_4', NULL, 'SRPBCC_4', NULL, NULL, NULL, 2),
(12557, NULL, 'cd15059', NULL, NULL, '7tmA_alpha2_AR', NULL, '7tmA_alpha2_AR', NULL, NULL, NULL, 2),
(12558, NULL, 'cd18335', NULL, NULL, 'BTB_POZ_KLHL1', NULL, 'BTB_POZ_KLHL1', NULL, NULL, NULL, 2),
(12559, NULL, 'cd17656', NULL, NULL, 'A_NRPS_ProA', NULL, 'A_NRPS_ProA', NULL, NULL, NULL, 2),
(12560, NULL, 'cd20002', NULL, NULL, 'PBP1_LsrB_Quorum_Sensing-like', NULL, 'PBP1_LsrB_Quorum_Sensing-like', NULL, NULL, NULL, 2),
(12561, NULL, 'cd06131', NULL, NULL, 'DNA_pol_III_epsilon_Ecoli_like', NULL, 'DNA_pol_III_epsilon_Ecoli_like', NULL, NULL, 4675, 2),
(12562, NULL, 'cd06202', NULL, NULL, 'Nitric_oxide_synthase', NULL, 'Nitric_oxide_synthase', NULL, NULL, NULL, 2),
(12563, NULL, 'cd01911', NULL, NULL, 'proteasome_alpha', NULL, 'proteasome_alpha', NULL, NULL, NULL, 2),
(12564, NULL, 'cd11923', NULL, NULL, 'SH3_Sorbs2_2', NULL, 'SH3_Sorbs2_2', NULL, NULL, NULL, 2),
(12565, NULL, 'cd19949', NULL, NULL, 'PDH1_Fer2_BFD-like', NULL, 'PDH1_Fer2_BFD-like', NULL, NULL, NULL, 2),
(12566, NULL, 'cd01643', NULL, NULL, 'Bacterial_IMPase_like_2', NULL, 'Bacterial_IMPase_like_2', NULL, NULL, NULL, 2),
(12567, NULL, 'cd09609', NULL, NULL, 'M3B_PepF', NULL, 'M3B_PepF', NULL, NULL, 31855, 2),
(12568, NULL, 'cd16224', NULL, NULL, 'EFh_CREC_RCN2', NULL, 'EFh_CREC_RCN2', NULL, NULL, NULL, 2),
(12569, NULL, 'cd03806', NULL, NULL, 'GT4_ALG11-like', NULL, 'GT4_ALG11-like', NULL, NULL, 27513, 2),
(12570, NULL, 'cd18652', NULL, NULL, 'CD_HP1gamma_Cbx3', NULL, 'CD_HP1gamma_Cbx3', NULL, NULL, NULL, 2),
(12571, NULL, 'cd21667', NULL, NULL, 'gammaCoV_Nsp5_Mpro', NULL, 'gammaCoV_Nsp5_Mpro', NULL, NULL, 34395, 2),
(12572, NULL, 'cd17741', NULL, NULL, 'BRCT_nibrin', NULL, 'BRCT_nibrin', NULL, NULL, NULL, 2),
(12573, NULL, 'cd18757', NULL, NULL, 'PIN_MtVapC3-like', NULL, 'PIN_MtVapC3-like', NULL, NULL, NULL, 2),
(12574, NULL, 'cd08892', NULL, NULL, 'SRPBCC_Aha1', NULL, 'SRPBCC_Aha1', NULL, NULL, NULL, 2),
(12575, NULL, 'cd00275', NULL, NULL, 'C2_PLC_like', NULL, 'C2_PLC_like', NULL, NULL, NULL, 2),
(12576, NULL, 'cd02566', NULL, NULL, 'PseudoU_synth_RluE', NULL, 'PseudoU_synth_RluE', NULL, NULL, NULL, 2),
(12577, NULL, 'cd09871', NULL, NULL, 'PIN_MtVapC28-VapC30-like', NULL, 'PIN_MtVapC28-VapC30-like', NULL, NULL, NULL, 2),
(12578, NULL, 'cd03441', NULL, NULL, 'R_hydratase_like', NULL, 'R_hydratase_like', NULL, NULL, NULL, 2),
(12579, NULL, 'cd17987', NULL, NULL, 'DEXHc_YTHDC2', NULL, 'DEXHc_YTHDC2', NULL, NULL, NULL, 2),
(12580, NULL, 'cd18296', NULL, NULL, 'BTB2_POZ_ABTB1_BPOZ1', NULL, 'BTB2_POZ_ABTB1_BPOZ1', NULL, NULL, NULL, 2),
(12581, NULL, 'cd19438', NULL, NULL, 'lipocalin_Blc-like', NULL, 'lipocalin_Blc-like', NULL, NULL, NULL, 2),
(12582, NULL, 'cd17479', NULL, NULL, 'MFS_MFSD6L', NULL, 'MFS_MFSD6L', NULL, NULL, NULL, 2),
(12583, NULL, 'cd12833', NULL, NULL, 'ZntB-like_1', NULL, 'ZntB-like_1', NULL, NULL, NULL, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(12584, NULL, 'cd11956', NULL, NULL, 'SH3_srGAP4', NULL, 'SH3_srGAP4', NULL, NULL, 30527, 2),
(12585, NULL, 'cd13411', NULL, NULL, 'TNFRSF11A', NULL, 'TNFRSF11A', NULL, NULL, 17064, 2),
(12586, NULL, 'cd17216', NULL, NULL, 'RA_Myosin-IXa', NULL, 'RA_Myosin-IXa', NULL, NULL, NULL, 2),
(12587, NULL, 'cd09197', NULL, NULL, 'PLDc_pPLDalpha_1', NULL, 'PLDc_pPLDalpha_1', NULL, NULL, NULL, 2),
(12588, NULL, 'cd08721', NULL, NULL, 'RGS_AKAP2_2', NULL, 'RGS_AKAP2_2', NULL, NULL, NULL, 2),
(12589, NULL, 'cd11734', NULL, NULL, 'Ssq1_like_NBD', NULL, 'Ssq1_like_NBD', NULL, NULL, NULL, 2),
(12590, NULL, 'cd18640', NULL, NULL, 'CD_Chro-like', NULL, 'CD_Chro-like', NULL, NULL, NULL, 2),
(12591, NULL, 'cd08645', NULL, NULL, 'FMT_core_GART', NULL, 'FMT_core_GART', NULL, NULL, 957, 2),
(12592, NULL, 'cd05770', NULL, NULL, 'IgC_beta2m', NULL, 'IgC_beta2m', NULL, NULL, 11230, 2),
(12593, NULL, 'cd15744', NULL, NULL, 'FYVE_RUFY3', NULL, 'FYVE_RUFY3', NULL, NULL, NULL, 2),
(12594, NULL, 'cd18118', NULL, NULL, 'ATP-synt_V_A-type_beta_N', NULL, 'ATP-synt_V_A-type_beta_N', NULL, NULL, NULL, 2),
(12595, NULL, 'cd02768', NULL, NULL, 'MopB_NADH-Q-OR-NuoG2', NULL, 'MopB_NADH-Q-OR-NuoG2', NULL, NULL, NULL, 2),
(12596, NULL, 'cd15694', NULL, NULL, 'ePHD_KMT2B', NULL, 'ePHD_KMT2B', NULL, NULL, 30348, 2),
(12597, NULL, 'cd13835', NULL, NULL, 'IHF_A', NULL, 'IHF_A', NULL, NULL, 3834, 2),
(12598, NULL, 'cd19076', NULL, NULL, 'AKR_AKR13A_13D', NULL, 'AKR_AKR13A_13D', NULL, NULL, NULL, 2),
(12599, NULL, 'cd15091', NULL, NULL, '7tmA_Kappa_opioid_R', NULL, '7tmA_Kappa_opioid_R', NULL, NULL, NULL, 2),
(12600, NULL, 'cd04768', NULL, NULL, 'HTH_BmrR-like', NULL, 'HTH_BmrR-like', NULL, NULL, NULL, 2),
(12601, NULL, 'cd00241', NULL, NULL, 'DOMON_like', NULL, 'DOMON_like', NULL, NULL, NULL, 2),
(12602, NULL, 'cd14390', NULL, NULL, 'UBA_II_E2_UBE2K', NULL, 'UBA_II_E2_UBE2K', NULL, NULL, 35676, 2),
(12603, NULL, 'cd03127', NULL, NULL, 'tetraspanin_LEL', NULL, 'tetraspanin_LEL', NULL, NULL, NULL, 2),
(12604, NULL, 'cd20267', NULL, NULL, 'Complex1_LYR_LYRM7', NULL, 'Complex1_LYR_LYRM7', NULL, NULL, 37083, 2),
(12605, NULL, 'cd14336', NULL, NULL, 'UBA_AID_AMPKalpha', NULL, 'UBA_AID_AMPKalpha', NULL, NULL, NULL, 2),
(12606, NULL, 'cd00545', NULL, NULL, 'MCH', NULL, 'MCH', NULL, NULL, 2202, 2),
(12607, NULL, 'cd15025', NULL, NULL, '7tm_TAS2R38', NULL, '7tm_TAS2R38', NULL, NULL, NULL, 2),
(12608, NULL, 'cd15302', NULL, NULL, '7tmA_mAChR_GAR-2-like', NULL, '7tmA_mAChR_GAR-2-like', NULL, NULL, NULL, 2),
(12609, NULL, 'cd18084', NULL, NULL, 'RsmE-like', NULL, 'RsmE-like', NULL, NULL, 37768, 2),
(12610, NULL, 'cd07616', NULL, NULL, 'BAR_Endophilin_B1', NULL, 'BAR_Endophilin_B1', NULL, NULL, 31874, 2),
(12611, NULL, 'cd11467', NULL, NULL, 'bHLH_E-protein_Da_like', NULL, 'bHLH_E-protein_Da_like', NULL, NULL, NULL, 2),
(12612, NULL, 'cd02978', NULL, NULL, 'KaiB_like', NULL, 'KaiB_like', NULL, NULL, 10807, 2),
(12613, NULL, 'cd00915', NULL, NULL, 'MD-1_MD-2', NULL, 'MD-1_MD-2', NULL, NULL, NULL, 2),
(12614, NULL, 'cd00427', NULL, NULL, 'Ribosomal_L29_HIP', NULL, 'Ribosomal_L29_HIP', NULL, NULL, NULL, 2),
(12615, NULL, 'cd00489', NULL, NULL, 'Barstar_like', NULL, 'Barstar_like', NULL, NULL, NULL, 2),
(12616, NULL, 'cd07651', NULL, NULL, 'F-BAR_PombeCdc15_like', NULL, 'F-BAR_PombeCdc15_like', NULL, NULL, NULL, 2),
(12617, NULL, 'cd13726', NULL, NULL, 'PBP2_iGluR_AMPA_GluR2', NULL, 'PBP2_iGluR_AMPA_GluR2', NULL, NULL, NULL, 2),
(12618, NULL, 'cd01182', NULL, NULL, 'INT_RitC_C_like', NULL, 'INT_RitC_C_like', NULL, NULL, NULL, 2),
(12619, NULL, 'cd07406', NULL, NULL, 'MPP_CG11883_N', NULL, 'MPP_CG11883_N', NULL, NULL, 30583, 2),
(12620, NULL, 'cd14315', NULL, NULL, 'UBA1_UBAP1', NULL, 'UBA1_UBAP1', NULL, NULL, NULL, 2),
(12621, NULL, 'cd14820', NULL, NULL, 'TRAX', NULL, 'TRAX', NULL, NULL, NULL, 2),
(12622, NULL, 'cd02801', NULL, NULL, 'DUS_like_FMN', NULL, 'DUS_like_FMN', NULL, NULL, 29349, 2),
(12623, NULL, 'cd05101', NULL, NULL, 'PTKc_FGFR2', NULL, 'PTKc_FGFR2', NULL, NULL, NULL, 2),
(12624, NULL, 'cd09416', NULL, NULL, 'LIM2_Testin', NULL, 'LIM2_Testin', NULL, NULL, 12472, 2);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(12625, NULL, 'cd16562', NULL, NULL, 'RING-HC_RNF219', NULL, 'RING-HC_RNF219', NULL, NULL, 29698, 2),
(12626, NULL, 'cd18721', NULL, NULL, 'PIN_ZNF451-like', NULL, 'PIN_ZNF451-like', NULL, NULL, NULL, 2),
(12627, NULL, 'cd00223', NULL, NULL, 'TOPRIM_TopoIIB_SPO', NULL, 'TOPRIM_TopoIIB_SPO', NULL, NULL, 29160, 2),
(12628, NULL, 'cd16899', NULL, NULL, 'LYZ_C_invert', NULL, 'LYZ_C_invert', NULL, NULL, NULL, 2),
(12629, NULL, 'cd02082', NULL, NULL, 'P-type_ATPase_cation', NULL, 'P-type_ATPase_cation', NULL, NULL, NULL, 2),
(12630, NULL, 'cd17407', NULL, NULL, 'MFS_MFSD11', NULL, 'MFS_MFSD11', NULL, NULL, NULL, 2),
(12631, NULL, 'cd16232', NULL, NULL, 'EFh_SPARC_TICN', NULL, 'EFh_SPARC_TICN', NULL, NULL, NULL, 2),
(12632, NULL, 'cd11683', NULL, NULL, 'HDAC10', NULL, 'HDAC10', NULL, NULL, NULL, 2),
(12633, NULL, 'cd15112', NULL, NULL, '7tmA_MrgprE', NULL, '7tmA_MrgprE', NULL, NULL, NULL, 2),
(12634, NULL, 'cd18177', NULL, NULL, 'ATP-synt_Vo_c_ATP6F_rpt1', NULL, 'ATP-synt_Vo_c_ATP6F_rpt1', NULL, NULL, NULL, 2),
(12635, NULL, 'cd07142', NULL, NULL, 'ALDH_F2BC', NULL, 'ALDH_F2BC', NULL, NULL, NULL, 2),
(12636, NULL, 'cd18993', NULL, NULL, 'LGIC_ECD_GluCl', NULL, 'LGIC_ECD_GluCl', NULL, NULL, NULL, 2),
(12637, NULL, 'cd01472', NULL, NULL, 'vWA_collagen', NULL, 'vWA_collagen', NULL, NULL, NULL, 2),
(12638, NULL, 'cd10470', NULL, NULL, 'FAM20B_C', NULL, 'FAM20B_C', NULL, NULL, NULL, 2),
(12639, NULL, 'cd17326', NULL, NULL, 'MFS_MFSD8', NULL, 'MFS_MFSD8', NULL, NULL, NULL, 2),
(12640, NULL, 'cd13304', NULL, NULL, 'PH2-like_Rtt106', NULL, 'PH2-like_Rtt106', NULL, NULL, NULL, 2),
(12641, NULL, 'cd02026', NULL, NULL, 'PRK', NULL, 'PRK', NULL, NULL, NULL, 2),
(12642, NULL, 'cd07840', NULL, NULL, 'STKc_CDK9_like', NULL, 'STKc_CDK9_like', NULL, NULL, NULL, 2),
(12643, NULL, 'cd03694', NULL, NULL, 'GTPBP_II', NULL, 'GTPBP_II', NULL, NULL, NULL, 2),
(12644, NULL, 'cd06311', NULL, NULL, 'PBP1_ABC_sugar_binding-like', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, NULL, 2),
(12645, NULL, 'cd05658', NULL, NULL, 'M18_DAP', NULL, 'M18_DAP', NULL, NULL, NULL, 2),
(12646, NULL, 'cd10390', NULL, NULL, 'SH2_SHD', NULL, 'SH2_SHD', NULL, NULL, 9381, 2),
(12647, NULL, 'cd15597', NULL, NULL, 'PHD3_KMT2D', NULL, 'PHD3_KMT2D', NULL, NULL, NULL, 2),
(12648, NULL, 'cd13228', NULL, NULL, 'PHear_NECAP', NULL, 'PHear_NECAP', NULL, NULL, 14482, 2),
(12649, NULL, 'cd12241', NULL, NULL, 'RRM_SF3B14', NULL, 'RRM_SF3B14', NULL, NULL, 21275, 2),
(12650, NULL, 'cd14634', NULL, NULL, 'R-PTPc-T-2', NULL, 'R-PTPc-T-2', NULL, NULL, NULL, 2),
(12651, NULL, 'cd03457', NULL, NULL, 'intradiol_dioxygenase_like', NULL, 'intradiol_dioxygenase_like', NULL, NULL, NULL, 2),
(12652, NULL, 'cd11727', NULL, NULL, 'ADDz_Dnmt3l', NULL, 'ADDz_Dnmt3l', NULL, NULL, NULL, 2),
(12653, NULL, 'cd12873', NULL, NULL, 'SPRY_DDX1', NULL, 'SPRY_DDX1', NULL, NULL, NULL, 2),
(12654, NULL, 'cd00653', NULL, NULL, 'RNA_pol_B_RPB2', NULL, 'RNA_pol_B_RPB2', NULL, NULL, 11074, 2),
(12655, NULL, 'cd04322', NULL, NULL, 'LysRS_N', NULL, 'LysRS_N', NULL, NULL, 36091, 2),
(12656, NULL, 'cd09100', NULL, NULL, 'INPP5c_SHIP1-INPP5D', NULL, 'INPP5c_SHIP1-INPP5D', NULL, NULL, NULL, 2),
(12657, NULL, 'cd10552', NULL, NULL, 'TH_beta_N', NULL, 'TH_beta_N', NULL, NULL, NULL, 2),
(12658, NULL, 'cd18670', NULL, NULL, 'PIN_Mut7-C-like', NULL, 'PIN_Mut7-C-like', NULL, NULL, NULL, 2),
(12659, NULL, 'cd14192', NULL, NULL, 'STKc_MLCK3', NULL, 'STKc_MLCK3', NULL, NULL, NULL, 2),
(12660, NULL, 'cd02189', NULL, NULL, 'delta_zeta_tubulin-like', NULL, 'delta_zeta_tubulin-like', NULL, NULL, NULL, 2),
(12661, NULL, 'cd06480', NULL, NULL, 'ACD_HspB8_like', NULL, 'ACD_HspB8_like', NULL, NULL, 35343, 2),
(12662, NULL, 'cd13847', NULL, NULL, 'CuRO_1_AAO_like_2', NULL, 'CuRO_1_AAO_like_2', NULL, NULL, NULL, 2),
(12663, NULL, 'cd14183', NULL, NULL, 'STKc_DCKL1', NULL, 'STKc_DCKL1', NULL, NULL, NULL, 2),
(12664, NULL, 'cd09755', NULL, NULL, 'Cas2_I-E', NULL, 'Cas2_I-E', NULL, NULL, NULL, 2),
(12665, NULL, 'cd19903', NULL, NULL, 'DSRM_EIF2AK2_rpt1', NULL, 'DSRM_EIF2AK2_rpt1', NULL, NULL, 35453, 2),
(12666, NULL, 'cd10442', NULL, NULL, 'GIY-YIG_PLEs', NULL, 'GIY-YIG_PLEs', NULL, NULL, NULL, 2);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(12667, NULL, 'cd13526', NULL, NULL, 'PBP2_lipoprotein_MetQ_like', NULL, 'PBP2_lipoprotein_MetQ_like', NULL, NULL, NULL, 2),
(12668, NULL, 'cd07529', NULL, NULL, 'HAD_AtGPP-like', NULL, 'HAD_AtGPP-like', NULL, NULL, 34243, 2),
(12669, NULL, 'cd10793', NULL, NULL, 'GH57N_TLGT_like', NULL, 'GH57N_TLGT_like', NULL, NULL, NULL, 2),
(12670, NULL, 'cd06854', NULL, NULL, 'GT_WbpL_WbcO_like', NULL, 'GT_WbpL_WbcO_like', NULL, NULL, NULL, 2),
(12671, NULL, 'cd14221', NULL, NULL, 'STKc_LIMK1', NULL, 'STKc_LIMK1', NULL, NULL, NULL, 2),
(12672, NULL, 'cd01178', NULL, NULL, 'IPT_NFAT', NULL, 'IPT_NFAT', NULL, NULL, NULL, 2),
(12673, NULL, 'cd05263', NULL, NULL, 'MupV_like_SDR_e', NULL, 'MupV_like_SDR_e', NULL, NULL, NULL, 2),
(12674, NULL, 'cd07765', NULL, NULL, 'KRAB_A-box', NULL, 'KRAB_A-box', NULL, NULL, 4346, 2),
(12675, NULL, 'cd06305', NULL, NULL, 'PBP1_methylthioribose_binding-like', NULL, 'PBP1_methylthioribose_binding-like', NULL, NULL, NULL, 2),
(12676, NULL, 'cd15085', NULL, NULL, '7tmA_Parietopsin', NULL, '7tmA_Parietopsin', NULL, NULL, NULL, 2),
(12677, NULL, 'cd02964', NULL, NULL, 'TryX_like_family', NULL, 'TryX_like_family', NULL, NULL, NULL, 2),
(12678, NULL, 'cd04303', NULL, NULL, 'HAD_PGPase', NULL, 'HAD_PGPase', NULL, NULL, NULL, 2),
(12679, NULL, 'cd15403', NULL, NULL, '7tmA_GPR45', NULL, '7tmA_GPR45', NULL, NULL, NULL, 2),
(12680, NULL, 'cd19400', NULL, NULL, 'TGF_beta_BMP9', NULL, 'TGF_beta_BMP9', NULL, NULL, NULL, 2),
(12681, NULL, 'cd09577', NULL, NULL, 'SAM_Ph1,2,3', NULL, 'SAM_Ph1,2,3', NULL, NULL, NULL, 2),
(12682, NULL, 'cd21653', NULL, NULL, 'ORF4b_HKU5-CoV', NULL, 'ORF4b_HKU5-CoV', NULL, NULL, 34961, 2),
(12683, NULL, 'cd14145', NULL, NULL, 'STKc_MLK1', NULL, 'STKc_MLK1', NULL, NULL, NULL, 2),
(12684, NULL, 'cd18115', NULL, NULL, 'ATP-synt_F1_beta_N', NULL, 'ATP-synt_F1_beta_N', NULL, NULL, NULL, 2),
(12685, NULL, 'cd15614', NULL, NULL, 'PHD_HAC_like', NULL, 'PHD_HAC_like', NULL, NULL, NULL, 2),
(12686, NULL, 'cd14201', NULL, NULL, 'STKc_ULK2', NULL, 'STKc_ULK2', NULL, NULL, NULL, 2),
(12687, NULL, 'cd12949', NULL, NULL, 'NOPS_PSPC1', NULL, 'NOPS_PSPC1', NULL, NULL, NULL, 2),
(12688, NULL, 'cd08663', NULL, NULL, 'DAP_dppA_1', NULL, 'DAP_dppA_1', NULL, NULL, NULL, 2),
(12689, NULL, 'cd13128', NULL, NULL, 'MATE_Wzx_like', NULL, 'MATE_Wzx_like', NULL, NULL, NULL, 2),
(12690, NULL, 'cd03894', NULL, NULL, 'M20_ArgE', NULL, 'M20_ArgE', NULL, NULL, NULL, 2),
(12691, NULL, 'cd19847', NULL, NULL, 'Bbox1_TIF1g_C-VI', NULL, 'Bbox1_TIF1g_C-VI', NULL, NULL, NULL, 2),
(12692, NULL, 'cd04160', NULL, NULL, 'Arfrp1', NULL, 'Arfrp1', NULL, NULL, NULL, 2),
(12693, NULL, 'cd06410', NULL, NULL, 'PB1_UP2', NULL, 'PB1_UP2', NULL, NULL, NULL, 2),
(12694, NULL, 'cd06183', NULL, NULL, 'cyt_b5_reduct_like', NULL, 'cyt_b5_reduct_like', NULL, NULL, NULL, 2),
(12695, NULL, 'cd01155', NULL, NULL, 'ACAD_FadE2', NULL, 'ACAD_FadE2', NULL, NULL, NULL, 2),
(12696, NULL, 'cd08529', NULL, NULL, 'STKc_FA2-like', NULL, 'STKc_FA2-like', NULL, NULL, NULL, 2),
(12697, NULL, 'cd17501', NULL, NULL, 'RMtype1_S_Vch69ORF1407P_TRD2-CR2_like', NULL, 'RMtype1_S_Vch69ORF1407P_TRD2-CR2_like', NULL, NULL, NULL, 2),
(12698, NULL, 'cd02146', NULL, NULL, 'NfsA-like', NULL, 'NfsA-like', NULL, NULL, 15397, 2),
(12699, NULL, 'cd09943', NULL, NULL, 'SH2_Nck_family', NULL, 'SH2_Nck_family', NULL, NULL, NULL, 2),
(12700, NULL, 'cd00217', NULL, NULL, 'INT_Flp_C', NULL, 'INT_Flp_C', NULL, NULL, NULL, 2),
(12701, NULL, 'cd20217', NULL, NULL, 'PFM_agglutinin-like', NULL, 'PFM_agglutinin-like', NULL, NULL, NULL, 2),
(12702, NULL, 'cd06620', NULL, NULL, 'PKc_Byr1_like', NULL, 'PKc_Byr1_like', NULL, NULL, NULL, 2),
(12703, NULL, 'cd15104', NULL, NULL, '7tmA_GPR119_R_insulinotropic_receptor', NULL, '7tmA_GPR119_R_insulinotropic_receptor', NULL, NULL, NULL, 2),
(12704, NULL, 'cd18398', NULL, NULL, 'BTB_POZ_KCTD16', NULL, 'BTB_POZ_KCTD16', NULL, NULL, NULL, 2),
(12705, NULL, 'cd18996', NULL, NULL, 'LGIC_ECD_5-HT3', NULL, 'LGIC_ECD_5-HT3', NULL, NULL, NULL, 2),
(12706, NULL, 'cd11732', NULL, NULL, 'HSP105-110_like_NBD', NULL, 'HSP105-110_like_NBD', NULL, NULL, NULL, 2);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(12707, NULL, 'cd10432', NULL, NULL, 'BI-1-like_bacterial', NULL, 'BI-1-like_bacterial', NULL, NULL, NULL, 2),
(12708, NULL, 'cd16324', NULL, NULL, 'LolA_fold-like', NULL, 'LolA_fold-like', NULL, NULL, NULL, 2),
(12709, NULL, 'cd14572', NULL, NULL, 'DUSP14', NULL, 'DUSP14', NULL, NULL, NULL, 2),
(12710, NULL, 'cd12915', NULL, NULL, 'PDC2_DGC_like', NULL, 'PDC2_DGC_like', NULL, NULL, NULL, 2),
(12711, NULL, 'cd18373', NULL, NULL, 'BTB1_POZ_KCTD19', NULL, 'BTB1_POZ_KCTD19', NULL, NULL, NULL, 2),
(12712, NULL, 'cd18420', NULL, NULL, 'BTB_POZ_Shal-like', NULL, 'BTB_POZ_Shal-like', NULL, NULL, NULL, 2),
(12713, NULL, 'cd19211', NULL, NULL, 'SET_NSD2', NULL, 'SET_NSD2', NULL, NULL, NULL, 2),
(12714, NULL, 'cd17257', NULL, NULL, 'RMtype1_S_EcoBI-TRD1-CR1_like', NULL, 'RMtype1_S_EcoBI-TRD1-CR1_like', NULL, NULL, NULL, 2),
(12715, NULL, 'cd07099', NULL, NULL, 'ALDH_DDALDH', NULL, 'ALDH_DDALDH', NULL, NULL, NULL, 2),
(12716, NULL, 'cd05147', NULL, NULL, 'RIO1_euk', NULL, 'RIO1_euk', NULL, NULL, NULL, 2),
(12717, NULL, 'cd01749', NULL, NULL, 'GATase1_PB', NULL, 'GATase1_PB', NULL, NULL, 5189, 2),
(12718, NULL, 'cd14247', NULL, NULL, 'Lmo2686_like', NULL, 'Lmo2686_like', NULL, NULL, 29152, 2),
(12719, NULL, 'cd16794', NULL, NULL, 'dRING_RMD5A', NULL, 'dRING_RMD5A', NULL, NULL, 27717, 2),
(12720, NULL, 'cd12253', NULL, NULL, 'RRM_PIN4_like', NULL, 'RRM_PIN4_like', NULL, NULL, 16187, 2),
(12721, NULL, 'cd07442', NULL, NULL, 'CRD_SFRP4', NULL, 'CRD_SFRP4', NULL, NULL, NULL, 2),
(12722, NULL, 'cd09276', NULL, NULL, 'Rnase_HI_RT_non_LTR', NULL, 'Rnase_HI_RT_non_LTR', NULL, NULL, NULL, 2),
(12723, NULL, 'cd15033', NULL, NULL, '7tmF_FZD3', NULL, '7tmF_FZD3', NULL, NULL, NULL, 2),
(12724, NULL, 'cd08344', NULL, NULL, 'MhqB_like_N', NULL, 'MhqB_like_N', NULL, NULL, NULL, 2),
(12725, NULL, 'cd09858', NULL, NULL, 'PIN_MKT1', NULL, 'PIN_MKT1', NULL, NULL, NULL, 2),
(12726, NULL, 'cd12678', NULL, NULL, 'RRM_SLTM', NULL, 'RRM_SLTM', NULL, NULL, NULL, 2),
(12727, NULL, 'cd10311', NULL, NULL, 'PLDc_N_DEXD_c', NULL, 'PLDc_N_DEXD_c', NULL, NULL, NULL, 2),
(12728, NULL, 'cd19722', NULL, NULL, 'bHLH_TS_NeuroD6_ATOH2', NULL, 'bHLH_TS_NeuroD6_ATOH2', NULL, NULL, NULL, 2),
(12729, NULL, 'cd05677', NULL, NULL, 'M20_dipept_like_DUG2_type', NULL, 'M20_dipept_like_DUG2_type', NULL, NULL, NULL, 2),
(12730, NULL, 'cd17288', NULL, NULL, 'RMtype1_S_LlaAI06ORF1089P_TRD1-CR1_like', NULL, 'RMtype1_S_LlaAI06ORF1089P_TRD1-CR1_like', NULL, NULL, NULL, 2),
(12731, NULL, 'cd02733', NULL, NULL, 'RNAP_II_RPB1_N', NULL, 'RNAP_II_RPB1_N', NULL, NULL, NULL, 2),
(12732, NULL, 'cd03742', NULL, NULL, 'SOCS_Rab40', NULL, 'SOCS_Rab40', NULL, NULL, NULL, 2),
(12733, NULL, 'cd11326', NULL, NULL, 'AmyAc_Glg_debranch', NULL, 'AmyAc_Glg_debranch', NULL, NULL, NULL, 2),
(12734, NULL, 'cd21665', NULL, NULL, 'alphaCoV_Nsp5_Mpro', NULL, 'alphaCoV_Nsp5_Mpro', NULL, NULL, 34647, 2),
(12735, NULL, 'cd12890', NULL, NULL, 'SPRY_PRY_TRIM16', NULL, 'SPRY_PRY_TRIM16', NULL, NULL, NULL, 2),
(12736, NULL, 'cd16478', NULL, NULL, 'RING-H2_Rapsyn', NULL, 'RING-H2_Rapsyn', NULL, NULL, NULL, 2),
(12737, NULL, 'cd15928', NULL, NULL, '7tmA_GHSR-like', NULL, '7tmA_GHSR-like', NULL, NULL, NULL, 2),
(12738, NULL, 'cd16431', NULL, NULL, 'IcmE', NULL, 'IcmE', NULL, NULL, NULL, 2),
(12739, NULL, 'cd00886', NULL, NULL, 'MogA_MoaB', NULL, 'MogA_MoaB', NULL, NULL, 6278, 2),
(12740, NULL, 'cd06528', NULL, NULL, 'RNAP_A''''', NULL, 'RNAP_A''''', NULL, NULL, 9663, 2),
(12741, NULL, 'cd01531', NULL, NULL, 'Acr2p', NULL, 'Acr2p', NULL, NULL, NULL, 2),
(12742, NULL, 'cd08756', NULL, NULL, 'RGS_GEF_like', NULL, 'RGS_GEF_like', NULL, NULL, NULL, 2),
(12743, NULL, 'cd14932', NULL, NULL, 'MYSc_Myh18', NULL, 'MYSc_Myh18', NULL, NULL, NULL, 2),
(12744, NULL, 'cd01011', NULL, NULL, 'nicotinamidase', NULL, 'nicotinamidase', NULL, NULL, NULL, 2),
(12745, NULL, 'cd04694', NULL, NULL, 'Nudix_Hydrolase_35', NULL, 'Nudix_Hydrolase_35', NULL, NULL, 30290, 2),
(12746, NULL, 'cd19551', NULL, NULL, 'serpinA3_A1AC', NULL, 'serpinA3_A1AC', NULL, NULL, NULL, 2),
(12747, NULL, 'cd01816', NULL, NULL, 'RBD_RAF', NULL, 'RBD_RAF', NULL, NULL, NULL, 2);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(12748, NULL, 'cd01819', NULL, NULL, 'Patatin_and_cPLA2', NULL, 'Patatin_and_cPLA2', NULL, NULL, NULL, 2),
(12749, NULL, 'cd07282', NULL, NULL, 'PX_SNX2', NULL, 'PX_SNX2', NULL, NULL, 31404, 2),
(12750, NULL, 'cd20261', NULL, NULL, 'Complex1_LYR_LYRM1', NULL, 'Complex1_LYR_LYRM1', NULL, NULL, 34448, 2),
(12751, NULL, 'cd12556', NULL, NULL, 'RRM2_RBM15B', NULL, 'RRM2_RBM15B', NULL, NULL, 314, 2),
(12752, NULL, 'cd17168', NULL, NULL, 'FERM_F1_FRMPD1', NULL, 'FERM_F1_FRMPD1', NULL, NULL, NULL, 2),
(12753, NULL, 'cd05831', NULL, NULL, 'Ribosomal_P1', NULL, 'Ribosomal_P1', NULL, NULL, NULL, 2),
(12754, NULL, 'cd02211', NULL, NULL, 'cupin_UGlyAH_N', NULL, 'cupin_UGlyAH_N', NULL, NULL, 34571, 2),
(12755, NULL, 'cd18110', NULL, NULL, 'ATP-synt_F1_beta_C', NULL, 'ATP-synt_F1_beta_C', NULL, NULL, NULL, 2),
(12756, NULL, 'cd03302', NULL, NULL, 'Adenylsuccinate_lyase_2', NULL, 'Adenylsuccinate_lyase_2', NULL, NULL, NULL, 2),
(12757, NULL, 'cd20480', NULL, NULL, 'ArgR-Cyc_NRPS-like', NULL, 'ArgR-Cyc_NRPS-like', NULL, NULL, NULL, 2),
(12758, NULL, 'cd10494', NULL, NULL, 'MH1_SMAD_7', NULL, 'MH1_SMAD_7', NULL, NULL, NULL, 2),
(12759, NULL, 'cd08815', NULL, NULL, 'Death_TNFRSF25_DR3', NULL, 'Death_TNFRSF25_DR3', NULL, NULL, NULL, 2),
(12760, NULL, 'cd15570', NULL, NULL, 'PHD_Bye1p_SIZ1_like', NULL, 'PHD_Bye1p_SIZ1_like', NULL, NULL, NULL, 2),
(12761, NULL, 'cd00988', NULL, NULL, 'PDZ_CTP_protease', NULL, 'PDZ_CTP_protease', NULL, NULL, NULL, 2),
(12762, NULL, 'cd08392', NULL, NULL, 'C2A_SLP-3', NULL, 'C2A_SLP-3', NULL, NULL, NULL, 2),
(12763, NULL, 'cd09447', NULL, NULL, 'LIM_LASP', NULL, 'LIM_LASP', NULL, NULL, NULL, 2),
(12764, NULL, 'cd08783', NULL, NULL, 'Death_MALT1', NULL, 'Death_MALT1', NULL, NULL, 29832, 2),
(12765, NULL, 'cd15602', NULL, NULL, 'PHD1_KDM5A', NULL, 'PHD1_KDM5A', NULL, NULL, NULL, 2),
(12766, NULL, 'cd19159', NULL, NULL, 'AKR_KCAB1B_AKR6A3-like', NULL, 'AKR_KCAB1B_AKR6A3-like', NULL, NULL, NULL, 2),
(12767, NULL, 'cd13716', NULL, NULL, 'PBP2_iGluR_delta_like', NULL, 'PBP2_iGluR_delta_like', NULL, NULL, NULL, 2),
(12768, NULL, 'cd14677', NULL, NULL, 'PH_DOK7', NULL, 'PH_DOK7', NULL, NULL, 28164, 2),
(12769, NULL, 'cd16520', NULL, NULL, 'RING-HC_MIBs_like', NULL, 'RING-HC_MIBs_like', NULL, NULL, NULL, 2),
(12770, NULL, 'cd11971', NULL, NULL, 'SH3_Abi1', NULL, 'SH3_Abi1', NULL, NULL, 27608, 2),
(12771, NULL, 'cd05692', NULL, NULL, 'S1_RPS1_repeat_hs4', NULL, 'S1_RPS1_repeat_hs4', NULL, NULL, NULL, 2),
(12772, NULL, 'cd06186', NULL, NULL, 'NOX_Duox_like_FAD_NADP', NULL, 'NOX_Duox_like_FAD_NADP', NULL, NULL, NULL, 2),
(12773, NULL, 'cd07246', NULL, NULL, 'VOC_like', NULL, 'VOC_like', NULL, NULL, NULL, 2),
(12774, NULL, 'cd20231', NULL, NULL, 'PFM_jacalin-like', NULL, 'PFM_jacalin-like', NULL, NULL, NULL, 2),
(12775, NULL, 'cd16924', NULL, NULL, 'HATPase_YpdA-YehU-LytS-like', NULL, 'HATPase_YpdA-YehU-LytS-like', NULL, NULL, NULL, 2),
(12776, NULL, 'cd14681', NULL, NULL, 'PH-STXBP6', NULL, 'PH-STXBP6', NULL, NULL, 31853, 2),
(12777, NULL, 'cd06933', NULL, NULL, 'NR_LBD_VDR', NULL, 'NR_LBD_VDR', NULL, NULL, NULL, 2),
(12778, NULL, 'cd11831', NULL, NULL, 'SH3_VAV_1', NULL, 'SH3_VAV_1', NULL, NULL, NULL, 2),
(12779, NULL, 'cd20242', NULL, NULL, 'PFM_aerolysin-like', NULL, 'PFM_aerolysin-like', NULL, NULL, NULL, 2),
(12780, NULL, 'cd14300', NULL, NULL, 'UBA_UBS3A_like', NULL, 'UBA_UBS3A_like', NULL, NULL, NULL, 2),
(12781, NULL, 'cd08780', NULL, NULL, 'Death_TRADD', NULL, 'Death_TRADD', NULL, NULL, NULL, 2),
(12782, NULL, 'cd03063', NULL, NULL, 'TRX_Fd_FDH_beta', NULL, 'TRX_Fd_FDH_beta', NULL, NULL, NULL, 2),
(12783, NULL, 'cd10346', NULL, NULL, 'SH2_SH2B_family', NULL, 'SH2_SH2B_family', NULL, NULL, 17194, 2),
(12784, NULL, 'cd01018', NULL, NULL, 'ZntC', NULL, 'ZntC', NULL, NULL, NULL, 2),
(12785, NULL, 'cd12493', NULL, NULL, 'RRM2_DND1', NULL, 'RRM2_DND1', NULL, NULL, NULL, 2),
(12786, NULL, 'cd00016', NULL, NULL, 'ALP_like', NULL, 'ALP_like', NULL, NULL, NULL, 2),
(12787, NULL, 'cd08304', NULL, NULL, 'DD', NULL, 'DD', NULL, NULL, NULL, 2),
(12788, NULL, 'cd08936', NULL, NULL, 'CR_SDR_c', NULL, 'CR_SDR_c', NULL, NULL, NULL, 2);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(12789, NULL, 'cd20332', NULL, NULL, 'JBP', NULL, 'JBP', NULL, NULL, NULL, 2),
(12790, NULL, 'cd04168', NULL, NULL, 'TetM_like', NULL, 'TetM_like', NULL, NULL, NULL, 2),
(12791, NULL, 'cd01191', NULL, NULL, 'INT_C_like_2', NULL, 'INT_C_like_2', NULL, NULL, NULL, 2),
(12792, NULL, 'cd11545', NULL, NULL, 'NTP-PPase_YP_001813558', NULL, 'NTP-PPase_YP_001813558', NULL, NULL, NULL, 2),
(12793, NULL, 'cd12285', NULL, NULL, 'RRM3_RBM39_like', NULL, 'RRM3_RBM39_like', NULL, NULL, NULL, 2),
(12794, NULL, 'cd15639', NULL, NULL, 'PHD_DIDO1_like', NULL, 'PHD_DIDO1_like', NULL, NULL, NULL, 2),
(12795, NULL, 'cd01714', NULL, NULL, 'ETF_beta', NULL, 'ETF_beta', NULL, NULL, 32372, 2),
(12796, NULL, 'cd00132', NULL, NULL, 'CRIB', NULL, 'CRIB', NULL, NULL, NULL, 2),
(12797, NULL, 'cd13435', NULL, NULL, 'SPFH_SLP-4', NULL, 'SPFH_SLP-4', NULL, NULL, NULL, 2),
(12798, NULL, 'cd09492', NULL, NULL, 'SAM_SASH1_repeat2', NULL, 'SAM_SASH1_repeat2', NULL, NULL, 32112, 2),
(12799, NULL, 'cd18594', NULL, NULL, 'ABC_6TM_CFTR_D1', NULL, 'ABC_6TM_CFTR_D1', NULL, NULL, NULL, 2),
(12800, NULL, 'cd06916', NULL, NULL, 'NR_DBD_like', NULL, 'NR_DBD_like', NULL, NULL, NULL, 2),
(12801, NULL, 'cd07388', NULL, NULL, 'MPP_Tt1561', NULL, 'MPP_Tt1561', NULL, NULL, 30965, 2),
(12802, NULL, 'cd05372', NULL, NULL, 'ENR_SDR', NULL, 'ENR_SDR', NULL, NULL, 11154, 2),
(12803, NULL, 'cd00177', NULL, NULL, 'START', NULL, 'START', NULL, NULL, NULL, 2),
(12804, NULL, 'cd06471', NULL, NULL, 'ACD_LpsHSP_like', NULL, 'ACD_LpsHSP_like', NULL, NULL, NULL, 2),
(12805, NULL, 'cd02976', NULL, NULL, 'NrdH', NULL, 'NrdH', NULL, NULL, NULL, 2),
(12806, NULL, 'cd06637', NULL, NULL, 'STKc_TNIK', NULL, 'STKc_TNIK', NULL, NULL, NULL, 2),
(12807, NULL, 'cd01041', NULL, NULL, 'Rubrerythrin', NULL, 'Rubrerythrin', NULL, NULL, 2686, 2),
(12808, NULL, 'cd20007', NULL, NULL, 'PBP1_ABC_sugar_binding-like', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, NULL, 2),
(12809, NULL, 'cd05679', NULL, NULL, 'M20_dipept_like', NULL, 'M20_dipept_like', NULL, NULL, NULL, 2),
(12810, NULL, 'cd09758', NULL, NULL, 'Csn2', NULL, 'Csn2', NULL, NULL, NULL, 2),
(12811, NULL, 'cd08951', NULL, NULL, 'DR_C-13_KR_SDR_c_like', NULL, 'DR_C-13_KR_SDR_c_like', NULL, NULL, NULL, 2),
(12812, NULL, 'cd12830', NULL, NULL, 'MtCorA-like', NULL, 'MtCorA-like', NULL, NULL, NULL, 2),
(12813, NULL, 'cd02186', NULL, NULL, 'alpha_tubulin', NULL, 'alpha_tubulin', NULL, NULL, NULL, 2),
(12814, NULL, 'cd03000', NULL, NULL, 'PDI_a_TMX3', NULL, 'PDI_a_TMX3', NULL, NULL, NULL, 2),
(12815, NULL, 'cd07870', NULL, NULL, 'STKc_PFTAIRE2', NULL, 'STKc_PFTAIRE2', NULL, NULL, 34055, 2),
(12816, NULL, 'cd07882', NULL, NULL, 'RHD-n_TonEBP', NULL, 'RHD-n_TonEBP', NULL, NULL, NULL, 2),
(12817, NULL, 'cd12625', NULL, NULL, 'RRM1_IGF2BP1', NULL, 'RRM1_IGF2BP1', NULL, NULL, 33436, 2),
(12818, NULL, 'cd17482', NULL, NULL, 'MFS_YxiO_like', NULL, 'MFS_YxiO_like', NULL, NULL, NULL, 2),
(12819, NULL, 'cd18056', NULL, NULL, 'DEXHc_CHD4', NULL, 'DEXHc_CHD4', NULL, NULL, NULL, 2),
(12820, NULL, 'cd18651', NULL, NULL, 'CD_HP1alpha_Cbx5', NULL, 'CD_HP1alpha_Cbx5', NULL, NULL, NULL, 2),
(12821, NULL, 'cd17276', NULL, NULL, 'RMtype1_S_Sau1132ORF3780P-TRD1-CR1_like', NULL, 'RMtype1_S_Sau1132ORF3780P-TRD1-CR1_like', NULL, NULL, NULL, 2),
(12822, NULL, 'cd08495', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_8', NULL, 'PBP2_NikA_DppA_OppA_like_8', NULL, NULL, NULL, 2),
(12823, NULL, 'cd04973', NULL, NULL, 'Ig1_FGFR', NULL, 'Ig1_FGFR', NULL, NULL, NULL, 2),
(12824, NULL, 'cd08916', NULL, NULL, 'TrHb3_P', NULL, 'TrHb3_P', NULL, NULL, NULL, 2),
(12825, NULL, 'cd00207', NULL, NULL, 'fer2', NULL, 'fer2', NULL, NULL, 2014, 2),
(12826, NULL, 'cd17046', NULL, NULL, 'Ubl_IKKA_like', NULL, 'Ubl_IKKA_like', NULL, NULL, NULL, 2),
(12827, NULL, 'cd12538', NULL, NULL, 'RRM_U2AF35', NULL, 'RRM_U2AF35', NULL, NULL, NULL, 2),
(12828, NULL, 'cd01065', NULL, NULL, 'NAD_bind_Shikimate_DH', NULL, 'NAD_bind_Shikimate_DH', NULL, NULL, NULL, 2),
(12829, NULL, 'cd21590', NULL, NULL, 'deltaCoV_RdRp', NULL, 'deltaCoV_RdRp', NULL, NULL, 33775, 2),
(12830, NULL, 'cd14212', NULL, NULL, 'PKc_YAK1', NULL, 'PKc_YAK1', NULL, NULL, NULL, 2);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(12831, NULL, 'cd13704', NULL, NULL, 'PBP2_HisK', NULL, 'PBP2_HisK', NULL, NULL, NULL, 2),
(12832, NULL, 'cd16926', NULL, NULL, 'HATPase_MutL-MLH-PMS-like', NULL, 'HATPase_MutL-MLH-PMS-like', NULL, NULL, NULL, 2),
(12833, NULL, 'cd04777', NULL, NULL, 'HTH_MerR-like_sg1', NULL, 'HTH_MerR-like_sg1', NULL, NULL, NULL, 2),
(12834, NULL, 'cd15476', NULL, NULL, 'Myo5c_CBD', NULL, 'Myo5c_CBD', NULL, NULL, 32570, 2),
(12835, NULL, 'cd19013', NULL, NULL, 'LGIC_ECD_5-HT3C_E', NULL, 'LGIC_ECD_5-HT3C_E', NULL, NULL, NULL, 2),
(12836, NULL, 'cd17131', NULL, NULL, 'Ubl_TMUB1', NULL, 'Ubl_TMUB1', NULL, NULL, NULL, 2),
(12837, NULL, 'cd17241', NULL, NULL, 'RA_PHLPP2', NULL, 'RA_PHLPP2', NULL, NULL, NULL, 2),
(12838, NULL, 'cd16366', NULL, NULL, 'FDH_beta_like', NULL, 'FDH_beta_like', NULL, NULL, NULL, 2),
(12839, NULL, 'cd01012', NULL, NULL, 'YcaC_related', NULL, 'YcaC_related', NULL, NULL, NULL, 2),
(12840, NULL, 'cd04086', NULL, NULL, 'CBM35_mannanase-like', NULL, 'CBM35_mannanase-like', NULL, NULL, NULL, 2),
(12841, NULL, 'cd05839', NULL, NULL, 'BR140_related', NULL, 'BR140_related', NULL, NULL, 17578, 2),
(12842, NULL, 'cd10561', NULL, NULL, 'HybA_like', NULL, 'HybA_like', NULL, NULL, NULL, 2),
(12843, NULL, 'cd10811', NULL, NULL, 'GH38N_AMII_Epman_like', NULL, 'GH38N_AMII_Epman_like', NULL, NULL, NULL, 2),
(12844, NULL, 'cd14254', NULL, NULL, 'Dockerin_II', NULL, 'Dockerin_II', NULL, NULL, NULL, 2),
(12845, NULL, 'cd05959', NULL, NULL, 'BCL_4HBCL', NULL, 'BCL_4HBCL', NULL, NULL, NULL, 2),
(12846, NULL, 'cd16533', NULL, NULL, 'RING-HC_RNF4', NULL, 'RING-HC_RNF4', NULL, NULL, 34534, 2),
(12847, NULL, 'cd01122', NULL, NULL, 'GP4d_helicase', NULL, 'GP4d_helicase', NULL, NULL, NULL, 2),
(12848, NULL, 'cd16163', NULL, NULL, 'OCRE_RBM6', NULL, 'OCRE_RBM6', NULL, NULL, 29247, 2),
(12849, NULL, 'cd19066', NULL, NULL, 'C_NRPS-like', NULL, 'C_NRPS-like', NULL, NULL, NULL, 2),
(12850, NULL, 'cd01875', NULL, NULL, 'RhoG', NULL, 'RhoG', NULL, NULL, 33588, 2),
(12851, NULL, 'cd05626', NULL, NULL, 'STKc_LATS2', NULL, 'STKc_LATS2', NULL, NULL, NULL, 2),
(12852, NULL, 'cd09335', NULL, NULL, 'LIM5_PINCH', NULL, 'LIM5_PINCH', NULL, NULL, NULL, 2),
(12853, NULL, 'cd11895', NULL, NULL, 'SH3_FCHSD1_2', NULL, 'SH3_FCHSD1_2', NULL, NULL, NULL, 2),
(12854, NULL, 'cd17014', NULL, NULL, 'ANTH_N_HIP1R', NULL, 'ANTH_N_HIP1R', NULL, NULL, NULL, 2),
(12855, NULL, 'cd19055', NULL, NULL, 'LGIC_TM_GABAAR_delta', NULL, 'LGIC_TM_GABAAR_delta', NULL, NULL, NULL, 2),
(12856, NULL, 'cd07154', NULL, NULL, 'NR_DBD_PNR_like', NULL, 'NR_DBD_PNR_like', NULL, NULL, NULL, 2),
(12857, NULL, 'cd12563', NULL, NULL, 'RRM2_RBM6', NULL, 'RRM2_RBM6', NULL, NULL, 5922, 2),
(12858, NULL, 'cd13628', NULL, NULL, 'PBP2_Ala', NULL, 'PBP2_Ala', NULL, NULL, NULL, 2),
(12859, NULL, 'cd09538', NULL, NULL, 'SAM_DLC1,2-like', NULL, 'SAM_DLC1,2-like', NULL, NULL, NULL, 2),
(12860, NULL, 'cd02148', NULL, NULL, 'RutE-like', NULL, 'RutE-like', NULL, NULL, 17056, 2),
(12861, NULL, 'cd16790', NULL, NULL, 'SP-RING_PIAS', NULL, 'SP-RING_PIAS', NULL, NULL, NULL, 2),
(12862, NULL, 'cd16817', NULL, NULL, 'mRING-HC-C3HC5_RNF157', NULL, 'mRING-HC-C3HC5_RNF157', NULL, NULL, NULL, 2),
(12863, NULL, 'cd16440', NULL, NULL, 'beta_Kdo_transferase_KpsC_1', NULL, 'beta_Kdo_transferase_KpsC_1', NULL, NULL, NULL, 2),
(12864, NULL, 'cd13256', NULL, NULL, 'PH3_ARAP', NULL, 'PH3_ARAP', NULL, NULL, NULL, 2),
(12865, NULL, 'cd19057', NULL, NULL, 'LGIC_TM_GABAAR_epsilon', NULL, 'LGIC_TM_GABAAR_epsilon', NULL, NULL, NULL, 2),
(12866, NULL, 'cd06898', NULL, NULL, 'PX_SNX10', NULL, 'PX_SNX10', NULL, NULL, NULL, 2),
(12867, NULL, 'cd09436', NULL, NULL, 'LIM3_TRIP6', NULL, 'LIM3_TRIP6', NULL, NULL, NULL, 2),
(12868, NULL, 'cd01615', NULL, NULL, 'CIDE_N', NULL, 'CIDE_N', NULL, NULL, NULL, 2),
(12869, NULL, 'cd08664', NULL, NULL, 'APC10-HERC2', NULL, 'APC10-HERC2', NULL, NULL, 32071, 2),
(12870, NULL, 'cd09370', NULL, NULL, 'LIM1_Lmx1a', NULL, 'LIM1_Lmx1a', NULL, NULL, 36145, 2),
(12871, NULL, 'cd01304', NULL, NULL, 'FMDH_A', NULL, 'FMDH_A', NULL, NULL, 10873, 2),
(12872, NULL, 'cd12231', NULL, NULL, 'RRM2_U2AF65', NULL, 'RRM2_U2AF65', NULL, NULL, NULL, 2);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(12873, NULL, 'cd18139', NULL, NULL, 'HLD_clamp_RarA', NULL, 'HLD_clamp_RarA', NULL, NULL, NULL, 2),
(12874, NULL, 'cd08325', NULL, NULL, 'CARD_CASP1-like', NULL, 'CARD_CASP1-like', NULL, NULL, NULL, 2),
(12875, NULL, 'cd02795', NULL, NULL, 'CBM6-CBM35-CBM36_like', NULL, 'CBM6-CBM35-CBM36_like', NULL, NULL, NULL, 2),
(12876, NULL, 'cd14837', NULL, NULL, 'AP3_Mu_N', NULL, 'AP3_Mu_N', NULL, NULL, NULL, 2),
(12877, NULL, 'cd16259', NULL, NULL, 'RF3_III', NULL, 'RF3_III', NULL, NULL, NULL, 2),
(12878, NULL, 'cd19090', NULL, NULL, 'AKR_AKR15A-like', NULL, 'AKR_AKR15A-like', NULL, NULL, NULL, 2),
(12879, NULL, 'cd09196', NULL, NULL, 'PLDc_yTdp1_2', NULL, 'PLDc_yTdp1_2', NULL, NULL, NULL, 2),
(12880, NULL, 'cd09415', NULL, NULL, 'LIM1_Prickle', NULL, 'LIM1_Prickle', NULL, NULL, 30197, 2),
(12881, NULL, 'cd18076', NULL, NULL, 'DEXXQc_HELZ2-N', NULL, 'DEXXQc_HELZ2-N', NULL, NULL, NULL, 2),
(12882, NULL, 'cd01144', NULL, NULL, 'BtuF', NULL, 'BtuF', NULL, NULL, NULL, 2),
(12883, NULL, 'cd02963', NULL, NULL, 'TRX_DnaJ', NULL, 'TRX_DnaJ', NULL, NULL, 34515, 2),
(12884, NULL, 'cd16323', NULL, NULL, 'Syd', NULL, 'Syd', NULL, NULL, 8418, 2),
(12885, NULL, 'cd19136', NULL, NULL, 'AKR_DrGR-like', NULL, 'AKR_DrGR-like', NULL, NULL, NULL, 2),
(12886, NULL, 'cd12207', NULL, NULL, 'RasGAP_IQGAP3', NULL, 'RasGAP_IQGAP3', NULL, NULL, NULL, 2),
(12887, NULL, 'cd08480', NULL, NULL, 'PBP2_CrgA_like_10', NULL, 'PBP2_CrgA_like_10', NULL, NULL, NULL, 2),
(12888, NULL, 'cd19901', NULL, NULL, 'DSRM_RBM46', NULL, 'DSRM_RBM46', NULL, NULL, 35072, 2),
(12889, NULL, 'cd13607', NULL, NULL, 'PBP2_AfProX_like', NULL, 'PBP2_AfProX_like', NULL, NULL, 30461, 2),
(12890, NULL, 'cd01299', NULL, NULL, 'Met_dep_hydrolase_A', NULL, 'Met_dep_hydrolase_A', NULL, NULL, NULL, 2),
(12891, NULL, 'cd05929', NULL, NULL, 'BACL_like', NULL, 'BACL_like', NULL, NULL, NULL, 2),
(12892, NULL, 'cd16456', NULL, NULL, 'RING-H2_APC11', NULL, 'RING-H2_APC11', NULL, NULL, 22992, 2),
(12893, NULL, 'cd09158', NULL, NULL, 'PLDc_EcCLS_like_2', NULL, 'PLDc_EcCLS_like_2', NULL, NULL, NULL, 2),
(12894, NULL, 'cd16353', NULL, NULL, 'CheC_CheX_FliY', NULL, 'CheC_CheX_FliY', NULL, NULL, NULL, 2),
(12895, NULL, 'cd14705', NULL, NULL, 'bZIP_Zip1', NULL, 'bZIP_Zip1', NULL, NULL, NULL, 2),
(12896, NULL, 'cd04737', NULL, NULL, 'LOX_like_FMN', NULL, 'LOX_like_FMN', NULL, NULL, NULL, 2),
(12897, NULL, 'cd15650', NULL, NULL, 'PHD2_NSD1', NULL, 'PHD2_NSD1', NULL, NULL, NULL, 2),
(12898, NULL, 'cd18010', NULL, NULL, 'DEXHc_HARP_SMARCAL1', NULL, 'DEXHc_HARP_SMARCAL1', NULL, NULL, NULL, 2),
(12899, NULL, 'cd08566', NULL, NULL, 'GDPD_AtGDE_like', NULL, 'GDPD_AtGDE_like', NULL, NULL, NULL, 2),
(12900, NULL, 'cd04145', NULL, NULL, 'M_R_Ras_like', NULL, 'M_R_Ras_like', NULL, NULL, NULL, 2),
(12901, NULL, 'cd08351', NULL, NULL, 'ChaP_like', NULL, 'ChaP_like', NULL, NULL, NULL, 2),
(12902, NULL, 'cd14867', NULL, NULL, 'uS7_Eukaryote', NULL, 'uS7_Eukaryote', NULL, NULL, 3566, 2),
(12903, NULL, 'cd06347', NULL, NULL, 'PBP1_ABC_LivK_ligand_binding-like', NULL, 'PBP1_ABC_LivK_ligand_binding-like', NULL, NULL, NULL, 2),
(12904, NULL, 'cd14395', NULL, NULL, 'UBA_BIRC4_8', NULL, 'UBA_BIRC4_8', NULL, NULL, 35761, 2),
(12905, NULL, 'cd08533', NULL, NULL, 'SAM_PNT-ETS-1,2', NULL, 'SAM_PNT-ETS-1,2', NULL, NULL, NULL, 2),
(12906, NULL, 'cd08363', NULL, NULL, 'FosB', NULL, 'FosB', NULL, NULL, NULL, 2),
(12907, NULL, 'cd13252', NULL, NULL, 'PH1_ADAP', NULL, 'PH1_ADAP', NULL, NULL, 31148, 2),
(12908, NULL, 'cd10719', NULL, NULL, 'DnaJ_zf', NULL, 'DnaJ_zf', NULL, NULL, 188, 2),
(12909, NULL, 'cd16876', NULL, NULL, 'ARID_ARID1A', NULL, 'ARID_ARID1A', NULL, NULL, NULL, 2),
(12910, NULL, 'cd01617', NULL, NULL, 'DCX', NULL, 'DCX', NULL, NULL, NULL, 2),
(12911, NULL, 'cd11413', NULL, NULL, 'bHLH_TS_TAL_LYL', NULL, 'bHLH_TS_TAL_LYL', NULL, NULL, NULL, 2),
(12912, NULL, 'cd00014', NULL, NULL, 'CH', NULL, 'CH', NULL, NULL, 3399, 2),
(12913, NULL, 'cd07114', NULL, NULL, 'ALDH_DhaS', NULL, 'ALDH_DhaS', NULL, NULL, NULL, 2),
(12914, NULL, 'cd14442', NULL, NULL, 'AlgJ_like', NULL, 'AlgJ_like', NULL, NULL, 15424, 2); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(12915, NULL, 'cd05280', NULL, NULL, 'MDR_yhdh_yhfp', NULL, 'MDR_yhdh_yhfp', NULL, NULL, NULL, 2),
(12916, NULL, 'cd01076', NULL, NULL, 'NAD_bind_1_Glu_DH', NULL, 'NAD_bind_1_Glu_DH', NULL, NULL, 31282, 2),
(12917, NULL, 'cd17083', NULL, NULL, 'RAWUL_PCGF3', NULL, 'RAWUL_PCGF3', NULL, NULL, NULL, 2),
(12918, NULL, 'cd09258', NULL, NULL, 'AP-1_Mu1A_Cterm', NULL, 'AP-1_Mu1A_Cterm', NULL, NULL, NULL, 2),
(12919, NULL, 'cd11576', NULL, NULL, 'GH99_GH71_like_2', NULL, 'GH99_GH71_like_2', NULL, NULL, NULL, 2),
(12920, NULL, 'cd14030', NULL, NULL, 'STKc_WNK1', NULL, 'STKc_WNK1', NULL, NULL, NULL, 2),
(12921, NULL, 'cd01276', NULL, NULL, 'PKCI_related', NULL, 'PKCI_related', NULL, NULL, NULL, 2),
(12922, NULL, 'cd14106', NULL, NULL, 'STKc_DRAK', NULL, 'STKc_DRAK', NULL, NULL, NULL, 2),
(12923, NULL, 'cd11893', NULL, NULL, 'SH3_MIA3', NULL, 'SH3_MIA3', NULL, NULL, NULL, 2),
(12924, NULL, 'cd03216', NULL, NULL, 'ABC_Carb_Monos_I', NULL, 'ABC_Carb_Monos_I', NULL, NULL, NULL, 2),
(12925, NULL, 'cd15375', NULL, NULL, '7tmA_OXGR1', NULL, '7tmA_OXGR1', NULL, NULL, NULL, 2),
(12926, NULL, 'cd09610', NULL, NULL, 'M3B_PepF', NULL, 'M3B_PepF', NULL, NULL, NULL, 2),
(12927, NULL, 'cd16697', NULL, NULL, 'RING-CH-C4HC3_NFXL1', NULL, 'RING-CH-C4HC3_NFXL1', NULL, NULL, NULL, 2),
(12928, NULL, 'cd10343', NULL, NULL, 'SH2_SHIP', NULL, 'SH2_SHIP', NULL, NULL, NULL, 2),
(12929, NULL, 'cd19546', NULL, NULL, 'X-Domain_NRPS', NULL, 'X-Domain_NRPS', NULL, NULL, NULL, 2),
(12930, NULL, 'cd19898', NULL, NULL, 'DSRM_RED1_rpt2', NULL, 'DSRM_RED1_rpt2', NULL, NULL, 35353, 2),
(12931, NULL, 'cd09522', NULL, NULL, 'SAM_SLP76', NULL, 'SAM_SLP76', NULL, NULL, NULL, 2),
(12932, NULL, 'cd19545', NULL, NULL, 'FUM14_C_NRPS-like', NULL, 'FUM14_C_NRPS-like', NULL, NULL, NULL, 2),
(12933, NULL, 'cd15880', NULL, NULL, 'SNARE_syntaxin1', NULL, 'SNARE_syntaxin1', NULL, NULL, NULL, 2),
(12934, NULL, 'cd00996', NULL, NULL, 'PBP2_AatB_like', NULL, 'PBP2_AatB_like', NULL, NULL, NULL, 2),
(12935, NULL, 'cd11323', NULL, NULL, 'AmyAc_AGS', NULL, 'AmyAc_AGS', NULL, NULL, NULL, 2),
(12936, NULL, 'cd15959', NULL, NULL, '7tmA_Beta3_AR', NULL, '7tmA_Beta3_AR', NULL, NULL, NULL, 2),
(12937, NULL, 'cd17506', NULL, NULL, 'Ubl_SAMP2_like', NULL, 'Ubl_SAMP2_like', NULL, NULL, NULL, 2),
(12938, NULL, 'cd03494', NULL, NULL, 'SQR_TypeC_SdhD', NULL, 'SQR_TypeC_SdhD', NULL, NULL, NULL, 2),
(12939, NULL, 'cd07467', NULL, NULL, 'CRD_TK_ROR1', NULL, 'CRD_TK_ROR1', NULL, NULL, NULL, 2),
(12940, NULL, 'cd12394', NULL, NULL, 'RRM1_RBM34', NULL, 'RRM1_RBM34', NULL, NULL, 21360, 2),
(12941, NULL, 'cd04466', NULL, NULL, 'S1_YloQ_GTPase', NULL, 'S1_YloQ_GTPase', NULL, NULL, 22902, 2),
(12942, NULL, 'cd06522', NULL, NULL, 'GH25_AtlA-like', NULL, 'GH25_AtlA-like', NULL, NULL, NULL, 2),
(12943, NULL, 'cd18692', NULL, NULL, 'PIN_VapC-like', NULL, 'PIN_VapC-like', NULL, NULL, NULL, 2),
(12944, NULL, 'cd14092', NULL, NULL, 'STKc_MSK_C', NULL, 'STKc_MSK_C', NULL, NULL, NULL, 2),
(12945, NULL, 'cd03318', NULL, NULL, 'MLE', NULL, 'MLE', NULL, NULL, 18631, 2),
(12946, NULL, 'cd09583', NULL, NULL, 'SAM_Atherin-like', NULL, 'SAM_Atherin-like', NULL, NULL, NULL, 2),
(12947, NULL, 'cd11636', NULL, NULL, 'HR1_PKN1_3', NULL, 'HR1_PKN1_3', NULL, NULL, NULL, 2),
(12948, NULL, 'cd13520', NULL, NULL, 'PBP2_TAXI_TRAP', NULL, 'PBP2_TAXI_TRAP', NULL, NULL, NULL, 2),
(12949, NULL, 'cd20278', NULL, NULL, 'Minion', NULL, 'Minion', NULL, NULL, NULL, 2),
(12950, NULL, 'cd17995', NULL, NULL, 'DEXHc_CHD6_7_8_9', NULL, 'DEXHc_CHD6_7_8_9', NULL, NULL, NULL, 2),
(12951, NULL, 'cd07869', NULL, NULL, 'STKc_PFTAIRE1', NULL, 'STKc_PFTAIRE1', NULL, NULL, NULL, 2),
(12952, NULL, 'cd15838', NULL, NULL, 'TNFRSF27', NULL, 'TNFRSF27', NULL, NULL, 8581, 2),
(12953, NULL, 'cd02440', NULL, NULL, 'AdoMet_MTases', NULL, 'AdoMet_MTases', NULL, NULL, NULL, 2),
(12954, NULL, 'cd13120', NULL, NULL, 'BF2867_like_N', NULL, 'BF2867_like_N', NULL, NULL, NULL, 2),
(12955, NULL, 'cd12663', NULL, NULL, 'RRM1_RAVER1', NULL, 'RRM1_RAVER1', NULL, NULL, 12466, 2),
(12956, NULL, 'cd09679', NULL, NULL, 'Cas10_III', NULL, 'Cas10_III', NULL, NULL, NULL, 2);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(12957, NULL, 'cd14763', NULL, NULL, 'SSDgbs_1', NULL, 'SSDgbs_1', NULL, NULL, NULL, 2),
(12958, NULL, 'cd15923', NULL, NULL, '7tmA_GPR35_55-like', NULL, '7tmA_GPR35_55-like', NULL, NULL, NULL, 2),
(12959, NULL, 'cd16606', NULL, NULL, 'RING-HC_TRIM58_C-IV', NULL, 'RING-HC_TRIM58_C-IV', NULL, NULL, 35687, 2),
(12960, NULL, 'cd03313', NULL, NULL, 'enolase', NULL, 'enolase', NULL, NULL, 3263, 2),
(12961, NULL, 'cd18364', NULL, NULL, 'BTB_POZ_KCTD4', NULL, 'BTB_POZ_KCTD4', NULL, NULL, NULL, 2),
(12962, NULL, 'cd15595', NULL, NULL, 'PHD2_KMT2D', NULL, 'PHD2_KMT2D', NULL, NULL, NULL, 2),
(12963, NULL, 'cd15246', NULL, NULL, '7tmF_FZD7', NULL, '7tmF_FZD7', NULL, NULL, NULL, 2),
(12964, NULL, 'cd04172', NULL, NULL, 'Rnd3_RhoE_Rho8', NULL, 'Rnd3_RhoE_Rho8', NULL, NULL, 30846, 2),
(12965, NULL, 'cd05606', NULL, NULL, 'STKc_beta_ARK', NULL, 'STKc_beta_ARK', NULL, NULL, NULL, 2),
(12966, NULL, 'cd06439', NULL, NULL, 'CESA_like_1', NULL, 'CESA_like_1', NULL, NULL, NULL, 2),
(12967, NULL, 'cd11875', NULL, NULL, 'SH3_CD2AP-like_3', NULL, 'SH3_CD2AP-like_3', NULL, NULL, NULL, 2),
(12968, NULL, 'cd04721', NULL, NULL, 'BAH_plant_1', NULL, 'BAH_plant_1', NULL, NULL, NULL, 2),
(12969, NULL, 'cd03706', NULL, NULL, 'mtEFTU_III', NULL, 'mtEFTU_III', NULL, NULL, NULL, 2),
(12970, NULL, 'cd18564', NULL, NULL, 'ABC_6TM_exporter_like', NULL, 'ABC_6TM_exporter_like', NULL, NULL, NULL, 2),
(12971, NULL, 'cd16565', NULL, NULL, 'RING-HC_RNF224_like', NULL, 'RING-HC_RNF224_like', NULL, NULL, NULL, 2),
(12972, NULL, 'cd07669', NULL, NULL, 'BAR_SNX33', NULL, 'BAR_SNX33', NULL, NULL, 33456, 2),
(12973, NULL, 'cd00598', NULL, NULL, 'GH18_chitinase-like', NULL, 'GH18_chitinase-like', NULL, NULL, NULL, 2),
(12974, NULL, 'cd07771', NULL, NULL, 'FGGY_RhuK', NULL, 'FGGY_RhuK', NULL, NULL, 9368, 2),
(12975, NULL, 'cd01943', NULL, NULL, 'MAK32', NULL, 'MAK32', NULL, NULL, 11372, 2),
(12976, NULL, 'cd02344', NULL, NULL, 'ZZ_HERC2', NULL, 'ZZ_HERC2', NULL, NULL, 30159, 2),
(12977, NULL, 'cd04376', NULL, NULL, 'RhoGAP_ARHGAP6', NULL, 'RhoGAP_ARHGAP6', NULL, NULL, 30823, 2),
(12978, NULL, 'cd03035', NULL, NULL, 'ArsC_Yffb', NULL, 'ArsC_Yffb', NULL, NULL, NULL, 2),
(12979, NULL, 'cd09251', NULL, NULL, 'AP-2_Mu2_Cterm', NULL, 'AP-2_Mu2_Cterm', NULL, NULL, 34613, 2),
(12980, NULL, 'cd12580', NULL, NULL, 'RRM2_hnRNPA1', NULL, 'RRM2_hnRNPA1', NULL, NULL, 32271, 2),
(12981, NULL, 'cd09209', NULL, NULL, 'Lumazine_synthase-I', NULL, 'Lumazine_synthase-I', NULL, NULL, 14502, 2),
(12982, NULL, 'cd14905', NULL, NULL, 'MYSc_Myo44', NULL, 'MYSc_Myo44', NULL, NULL, NULL, 2),
(12983, NULL, 'cd08837', NULL, NULL, 'ArfGap_ARAP', NULL, 'ArfGap_ARAP', NULL, NULL, NULL, 2),
(12984, NULL, 'cd13973', NULL, NULL, 'PK_MviN-like', NULL, 'PK_MviN-like', NULL, NULL, NULL, 2),
(12985, NULL, 'cd15521', NULL, NULL, 'PHD_VIN3_plant', NULL, 'PHD_VIN3_plant', NULL, NULL, NULL, 2),
(12986, NULL, 'cd11013', NULL, NULL, 'Plantacyanin', NULL, 'Plantacyanin', NULL, NULL, 30670, 2),
(12987, NULL, 'cd19539', NULL, NULL, 'SgcC5_NRPS-like', NULL, 'SgcC5_NRPS-like', NULL, NULL, NULL, 2),
(12988, NULL, 'cd11792', NULL, NULL, 'SH3_Fut8', NULL, 'SH3_Fut8', NULL, NULL, 27498, 2),
(12989, NULL, 'cd04962', NULL, NULL, 'GT4_BshA-like', NULL, 'GT4_BshA-like', NULL, NULL, NULL, 2),
(12990, NULL, 'cd17964', NULL, NULL, 'DEADc_MSS116', NULL, 'DEADc_MSS116', NULL, NULL, NULL, 2),
(12991, NULL, 'cd04761', NULL, NULL, 'HTH_MerR-SF', NULL, 'HTH_MerR-SF', NULL, NULL, NULL, 2),
(12992, NULL, 'cd12071', NULL, NULL, 'SH3_FBP17', NULL, 'SH3_FBP17', NULL, NULL, 16547, 2),
(12993, NULL, 'cd12641', NULL, NULL, 'RRM_TRA2B', NULL, 'RRM_TRA2B', NULL, NULL, NULL, 2),
(12994, NULL, 'cd05024', NULL, NULL, 'S-100A10', NULL, 'S-100A10', NULL, NULL, 26452, 2),
(12995, NULL, 'cd09260', NULL, NULL, 'AP-3_Mu3A_Cterm', NULL, 'AP-3_Mu3A_Cterm', NULL, NULL, NULL, 2),
(12996, NULL, 'cd08296', NULL, NULL, 'CAD_like', NULL, 'CAD_like', NULL, NULL, NULL, 2),
(12997, NULL, 'cd11404', NULL, NULL, 'bHLHzip_Mlx_like', NULL, 'bHLHzip_Mlx_like', NULL, NULL, NULL, 2),
(12998, NULL, 'cd15022', NULL, NULL, '7tm_TAS2R8', NULL, '7tm_TAS2R8', NULL, NULL, NULL, 2);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(12999, NULL, 'cd05802', NULL, NULL, 'GlmM', NULL, 'GlmM', NULL, NULL, 4722, 2),
(13000, NULL, 'cd00546', NULL, NULL, 'QFR_TypeD_subunitC', NULL, 'QFR_TypeD_subunitC', NULL, NULL, 6231, 2),
(13001, NULL, 'cd09535', NULL, NULL, 'SAM_BOI-like_fungal', NULL, 'SAM_BOI-like_fungal', NULL, NULL, NULL, 2),
(13002, NULL, 'cd14203', NULL, NULL, 'PTKc_Src_Fyn_like', NULL, 'PTKc_Src_Fyn_like', NULL, NULL, NULL, 2),
(13003, NULL, 'cd05236', NULL, NULL, 'FAR-N_SDR_e', NULL, 'FAR-N_SDR_e', NULL, NULL, NULL, 2),
(13004, NULL, 'cd09005', NULL, NULL, 'NP-I', NULL, 'NP-I', NULL, NULL, NULL, 2),
(13005, NULL, 'cd00671', NULL, NULL, 'ArgRS_core', NULL, 'ArgRS_core', NULL, NULL, 28799, 2),
(13006, NULL, 'cd17446', NULL, NULL, 'MFS_SLC22A6_OAT1_like', NULL, 'MFS_SLC22A6_OAT1_like', NULL, NULL, NULL, 2),
(13007, NULL, 'cd18943', NULL, NULL, 'bHLH_E-protein_E47-like', NULL, 'bHLH_E-protein_E47-like', NULL, NULL, NULL, 2),
(13008, NULL, 'cd05966', NULL, NULL, 'ACS', NULL, 'ACS', NULL, NULL, NULL, 2),
(13009, NULL, 'cd01997', NULL, NULL, 'GMP_synthase_C', NULL, 'GMP_synthase_C', NULL, NULL, 3100, 2),
(13010, NULL, 'cd11487', NULL, NULL, 'SLC5sbd_SGLT2', NULL, 'SLC5sbd_SGLT2', NULL, NULL, NULL, 2),
(13011, NULL, 'cd17977', NULL, NULL, 'DEXHc_DHX32', NULL, 'DEXHc_DHX32', NULL, NULL, NULL, 2),
(13012, NULL, 'cd01108', NULL, NULL, 'HTH_CueR', NULL, 'HTH_CueR', NULL, NULL, 13137, 2),
(13013, NULL, 'cd04166', NULL, NULL, 'CysN_ATPS', NULL, 'CysN_ATPS', NULL, NULL, 31182, 2),
(13014, NULL, 'cd01344', NULL, NULL, 'PL2_Passenger_AT', NULL, 'PL2_Passenger_AT', NULL, NULL, 37183, 2),
(13015, NULL, 'cd00056', NULL, NULL, 'ENDO3c', NULL, 'ENDO3c', NULL, NULL, 3330, 2),
(13016, NULL, 'cd09126', NULL, NULL, 'PLDc_C_DEXD_like', NULL, 'PLDc_C_DEXD_like', NULL, NULL, NULL, 2),
(13017, NULL, 'cd09819', NULL, NULL, 'An_peroxidase_bacterial_1', NULL, 'An_peroxidase_bacterial_1', NULL, NULL, NULL, 2),
(13018, NULL, 'cd08309', NULL, NULL, 'Death_IRAK', NULL, 'Death_IRAK', NULL, NULL, NULL, 2),
(13019, NULL, 'cd02252', NULL, NULL, 'nylC_like', NULL, 'nylC_like', NULL, NULL, NULL, 2),
(13020, NULL, 'cd06062', NULL, NULL, 'H2MP_MemB-H2up', NULL, 'H2MP_MemB-H2up', NULL, NULL, NULL, 2),
(13021, NULL, 'cd04391', NULL, NULL, 'RhoGAP_ARHGAP18', NULL, 'RhoGAP_ARHGAP18', NULL, NULL, NULL, 2),
(13022, NULL, 'cd12014', NULL, NULL, 'SH3_RIM-BP_1', NULL, 'SH3_RIM-BP_1', NULL, NULL, NULL, 2),
(13023, NULL, 'cd10789', NULL, NULL, 'GH38N_AMII_ER_cytosolic', NULL, 'GH38N_AMII_ER_cytosolic', NULL, NULL, NULL, 2),
(13024, NULL, 'cd07068', NULL, NULL, 'NR_LBD_ER_like', NULL, 'NR_LBD_ER_like', NULL, NULL, NULL, 2),
(13025, NULL, 'cd05079', NULL, NULL, 'PTKc_Jak1_rpt2', NULL, 'PTKc_Jak1_rpt2', NULL, NULL, NULL, 2),
(13026, NULL, 'cd17062', NULL, NULL, 'Ubl_NUB1', NULL, 'Ubl_NUB1', NULL, NULL, NULL, 2),
(13027, NULL, 'cd13662', NULL, NULL, 'PBP2_TpPotD_like', NULL, 'PBP2_TpPotD_like', NULL, NULL, NULL, 2),
(13028, NULL, 'cd16507', NULL, NULL, 'RING-HC_GEFO_like', NULL, 'RING-HC_GEFO_like', NULL, NULL, NULL, 2),
(13029, NULL, 'cd17180', NULL, NULL, 'FERM_F0_KIND1', NULL, 'FERM_F0_KIND1', NULL, NULL, NULL, 2),
(13030, NULL, 'cd05132', NULL, NULL, 'RasGAP_GAPA', NULL, 'RasGAP_GAPA', NULL, NULL, NULL, 2),
(13031, NULL, 'cd07887', NULL, NULL, 'RHD-n_Dorsal_Dif', NULL, 'RHD-n_Dorsal_Dif', NULL, NULL, NULL, 2),
(13032, NULL, 'cd13766', NULL, NULL, 'TGF_beta_GDF5_6_7', NULL, 'TGF_beta_GDF5_6_7', NULL, NULL, NULL, 2),
(13033, NULL, 'cd13149', NULL, NULL, 'MATE_like_2', NULL, 'MATE_like_2', NULL, NULL, NULL, 2),
(13034, NULL, 'cd07550', NULL, NULL, 'P-type_ATPase_HM', NULL, 'P-type_ATPase_HM', NULL, NULL, NULL, 2),
(13035, NULL, 'cd15253', NULL, NULL, '7tmB2_GPR113', NULL, '7tmB2_GPR113', NULL, NULL, NULL, 2),
(13036, NULL, 'cd10000', NULL, NULL, 'HDAC8', NULL, 'HDAC8', NULL, NULL, NULL, 2),
(13037, NULL, 'cd02853', NULL, NULL, 'E_set_MTHase_like_N', NULL, 'E_set_MTHase_like_N', NULL, NULL, NULL, 2),
(13038, NULL, 'cd14152', NULL, NULL, 'STKc_KSR1', NULL, 'STKc_KSR1', NULL, NULL, NULL, 2),
(13039, NULL, 'cd15370', NULL, NULL, '7tmA_PAR2', NULL, '7tmA_PAR2', NULL, NULL, NULL, 2);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(13040, NULL, 'cd09345', NULL, NULL, 'LIM2_FHL', NULL, 'LIM2_FHL', NULL, NULL, NULL, 2),
(13041, NULL, 'cd08039', NULL, NULL, 'Adenylation_DNA_ligase_Fungal', NULL, 'Adenylation_DNA_ligase_Fungal', NULL, NULL, NULL, 2),
(13042, NULL, 'cd18936', NULL, NULL, 'bHLH_TS_MYOD1_Myf3', NULL, 'bHLH_TS_MYOD1_Myf3', NULL, NULL, NULL, 2),
(13043, NULL, 'cd01724', NULL, NULL, 'Sm_D1', NULL, 'Sm_D1', NULL, NULL, 11276, 2),
(13044, NULL, 'cd14042', NULL, NULL, 'PK_GC-A_B', NULL, 'PK_GC-A_B', NULL, NULL, NULL, 2),
(13045, NULL, 'cd04889', NULL, NULL, 'ACT_PDH-BS-like', NULL, 'ACT_PDH-BS-like', NULL, NULL, NULL, 2),
(13046, NULL, 'cd15394', NULL, NULL, '7tmA_PrRP_R', NULL, '7tmA_PrRP_R', NULL, NULL, NULL, 2),
(13047, NULL, 'cd06861', NULL, NULL, 'PX_Vps5p', NULL, 'PX_Vps5p', NULL, NULL, 32068, 2),
(13048, NULL, 'cd09240', NULL, NULL, 'BRO1_Alix', NULL, 'BRO1_Alix', NULL, NULL, NULL, 2),
(13049, NULL, 'cd00272', NULL, NULL, 'Chemokine_CC', NULL, 'Chemokine_CC', NULL, NULL, NULL, 2),
(13050, NULL, 'cd07592', NULL, NULL, 'BAR_Endophilin_A', NULL, 'BAR_Endophilin_A', NULL, NULL, NULL, 2),
(13051, NULL, 'cd08340', NULL, NULL, 'DED_c-FLIP_r2', NULL, 'DED_c-FLIP_r2', NULL, NULL, NULL, 2),
(13052, NULL, 'cd08427', NULL, NULL, 'PBP2_LTTR_like_2', NULL, 'PBP2_LTTR_like_2', NULL, NULL, NULL, 2),
(13053, NULL, 'cd03142', NULL, NULL, 'GATase1_ThuA', NULL, 'GATase1_ThuA', NULL, NULL, NULL, 2),
(13054, NULL, 'cd05250', NULL, NULL, 'CC3_like_SDR_a', NULL, 'CC3_like_SDR_a', NULL, NULL, NULL, 2),
(13055, NULL, 'cd07047', NULL, NULL, 'BMC_PduB_repeat1', NULL, 'BMC_PduB_repeat1', NULL, NULL, NULL, 2),
(13056, NULL, 'cd00131', NULL, NULL, 'PAX', NULL, 'PAX', NULL, NULL, 5743, 2),
(13057, NULL, 'cd15540', NULL, NULL, 'PHD2_AIRE', NULL, 'PHD2_AIRE', NULL, NULL, 35506, 2),
(13058, NULL, 'cd14660', NULL, NULL, 'E2F_DD', NULL, 'E2F_DD', NULL, NULL, 24165, 2),
(13059, NULL, 'cd07941', NULL, NULL, 'DRE_TIM_LeuA3', NULL, 'DRE_TIM_LeuA3', NULL, NULL, NULL, 2),
(13060, NULL, 'cd17752', NULL, NULL, 'BRCT_RFC1', NULL, 'BRCT_RFC1', NULL, NULL, NULL, 2),
(13061, NULL, 'cd13116', NULL, NULL, 'POLO_box_Plk4_3', NULL, 'POLO_box_Plk4_3', NULL, NULL, 28140, 2),
(13062, NULL, 'cd01410', NULL, NULL, 'SIRT7', NULL, 'SIRT7', NULL, NULL, NULL, 2),
(13063, NULL, 'cd05670', NULL, NULL, 'M20_Acy1_YkuR-like', NULL, 'M20_Acy1_YkuR-like', NULL, NULL, NULL, 2),
(13064, NULL, 'cd14301', NULL, NULL, 'UBA_UBS3B', NULL, 'UBA_UBS3B', NULL, NULL, NULL, 2),
(13065, NULL, 'cd02897', NULL, NULL, 'A2M_2', NULL, 'A2M_2', NULL, NULL, 30541, 2),
(13066, NULL, 'cd01668', NULL, NULL, 'TGS_RSH', NULL, 'TGS_RSH', NULL, NULL, 30921, 2),
(13067, NULL, 'cd08001', NULL, NULL, 'WGR_PARP1_like', NULL, 'WGR_PARP1_like', NULL, NULL, NULL, 2),
(13068, NULL, 'cd01542', NULL, NULL, 'PBP1_TreR-like', NULL, 'PBP1_TreR-like', NULL, NULL, NULL, 2),
(13069, NULL, 'cd01435', NULL, NULL, 'RNAP_I_RPA1_N', NULL, 'RNAP_I_RPA1_N', NULL, NULL, NULL, 2),
(13070, NULL, 'cd19699', NULL, NULL, 'bHLH_TS_dMYOD_like', NULL, 'bHLH_TS_dMYOD_like', NULL, NULL, NULL, 2),
(13071, NULL, 'cd07615', NULL, NULL, 'BAR_Endophilin_A3', NULL, 'BAR_Endophilin_A3', NULL, NULL, 7614, 2),
(13072, NULL, 'cd14153', NULL, NULL, 'PK_KSR2', NULL, 'PK_KSR2', NULL, NULL, NULL, 2),
(13073, NULL, 'cd01914', NULL, NULL, 'HCP', NULL, 'HCP', NULL, NULL, 5305, 2),
(13074, NULL, 'cd10960', NULL, NULL, 'CE4_NodB_like_1', NULL, 'CE4_NodB_like_1', NULL, NULL, NULL, 2),
(13075, NULL, 'cd09505', NULL, NULL, 'SAM_WDSUB1', NULL, 'SAM_WDSUB1', NULL, NULL, NULL, 2),
(13076, NULL, 'cd16464', NULL, NULL, 'RING-H2_Pirh2', NULL, 'RING-H2_Pirh2', NULL, NULL, NULL, 2),
(13077, NULL, 'cd17747', NULL, NULL, 'BRCT_PARP1', NULL, 'BRCT_PARP1', NULL, NULL, NULL, 2),
(13078, NULL, 'cd07518', NULL, NULL, 'HAD_YbiV-Like', NULL, 'HAD_YbiV-Like', NULL, NULL, NULL, 2),
(13079, NULL, 'cd09526', NULL, NULL, 'SAM_Samd3', NULL, 'SAM_Samd3', NULL, NULL, 34169, 2),
(13080, NULL, 'cd03601', NULL, NULL, 'CLECT_TC14_like', NULL, 'CLECT_TC14_like', NULL, NULL, 29484, 2),
(13081, NULL, 'cd15061', NULL, NULL, '7tmA_tyramine_R-like', NULL, '7tmA_tyramine_R-like', NULL, NULL, NULL, 2);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(13082, NULL, 'cd08995', NULL, NULL, 'GH32_EcAec43-like', NULL, 'GH32_EcAec43-like', NULL, NULL, NULL, 2),
(13083, NULL, 'cd11498', NULL, NULL, 'SLC6sbd_GlyT1', NULL, 'SLC6sbd_GlyT1', NULL, NULL, NULL, 2),
(13084, NULL, 'cd17073', NULL, NULL, 'KHA', NULL, 'KHA', NULL, NULL, NULL, 2),
(13085, NULL, 'cd07203', NULL, NULL, 'cPLA2_Fungal_PLB', NULL, 'cPLA2_Fungal_PLB', NULL, NULL, NULL, 2),
(13086, NULL, 'cd11419', NULL, NULL, 'bHLHzip_TFAP4', NULL, 'bHLHzip_TFAP4', NULL, NULL, NULL, 2),
(13087, NULL, 'cd18999', NULL, NULL, 'LGIC_ECD_GABAAR_B', NULL, 'LGIC_ECD_GABAAR_B', NULL, NULL, NULL, 2),
(13088, NULL, 'cd04182', NULL, NULL, 'GT_2_like_f', NULL, 'GT_2_like_f', NULL, NULL, NULL, 2),
(13089, NULL, 'cd05632', NULL, NULL, 'STKc_GRK5', NULL, 'STKc_GRK5', NULL, NULL, NULL, 2),
(13090, NULL, 'cd07849', NULL, NULL, 'STKc_ERK1_2_like', NULL, 'STKc_ERK1_2_like', NULL, NULL, NULL, 2),
(13091, NULL, 'cd12130', NULL, NULL, 'Apl', NULL, 'Apl', NULL, NULL, NULL, 2),
(13092, NULL, 'cd09699', NULL, NULL, 'Csm6_III-A', NULL, 'Csm6_III-A', NULL, NULL, 10146, 2),
(13093, NULL, 'cd15018', NULL, NULL, '7tm_TAS2R41-like', NULL, '7tm_TAS2R41-like', NULL, NULL, NULL, 2),
(13094, NULL, 'cd18817', NULL, NULL, 'GH43f_LbAraf43-like', NULL, 'GH43f_LbAraf43-like', NULL, NULL, NULL, 2),
(13095, NULL, 'cd18279', NULL, NULL, 'BTB_POZ_SPOP-like', NULL, 'BTB_POZ_SPOP-like', NULL, NULL, NULL, 2),
(13096, NULL, 'cd15765', NULL, NULL, 'FYVE_Slp3', NULL, 'FYVE_Slp3', NULL, NULL, NULL, 2),
(13097, NULL, 'cd06475', NULL, NULL, 'ACD_HspB1_like', NULL, 'ACD_HspB1_like', NULL, NULL, 31560, 2),
(13098, NULL, 'cd00737', NULL, NULL, 'lyz_endolysin_autolysin', NULL, 'lyz_endolysin_autolysin', NULL, NULL, 31107, 2),
(13099, NULL, 'cd00891', NULL, NULL, 'PI3Kc', NULL, 'PI3Kc', NULL, NULL, 20455, 2),
(13100, NULL, 'cd04514', NULL, NULL, 'Taspase1_like', NULL, 'Taspase1_like', NULL, NULL, 32930, 2),
(13101, NULL, 'cd07166', NULL, NULL, 'NR_DBD_REV_ERB', NULL, 'NR_DBD_REV_ERB', NULL, NULL, NULL, 2),
(13102, NULL, 'cd13974', NULL, NULL, 'STKc_SHIK', NULL, 'STKc_SHIK', NULL, NULL, 20038, 2),
(13103, NULL, 'cd18799', NULL, NULL, 'SF2_C_EcoAI-like', NULL, 'SF2_C_EcoAI-like', NULL, NULL, NULL, 2),
(13104, NULL, 'cd16261', NULL, NULL, 'EF2_snRNP_III', NULL, 'EF2_snRNP_III', NULL, NULL, NULL, 2),
(13105, NULL, 'cd07109', NULL, NULL, 'ALDH_AAS00426', NULL, 'ALDH_AAS00426', NULL, NULL, NULL, 2),
(13106, NULL, 'cd08312', NULL, NULL, 'Death_MyD88', NULL, 'Death_MyD88', NULL, NULL, 16351, 2),
(13107, NULL, 'cd08369', NULL, NULL, 'FMT_core', NULL, 'FMT_core', NULL, NULL, NULL, 2),
(13108, NULL, 'cd17483', NULL, NULL, 'MFS_Atg22_like', NULL, 'MFS_Atg22_like', NULL, NULL, 34702, 2),
(13109, NULL, 'cd01916', NULL, NULL, 'ACS_1', NULL, 'ACS_1', NULL, NULL, 7265, 2),
(13110, NULL, 'cd05734', NULL, NULL, 'Ig_DSCAM', NULL, 'Ig_DSCAM', NULL, NULL, NULL, 2),
(13111, NULL, 'cd13156', NULL, NULL, 'KOW_RPL6', NULL, 'KOW_RPL6', NULL, NULL, 30373, 2),
(13112, NULL, 'cd05352', NULL, NULL, 'MDH-like_SDR_c', NULL, 'MDH-like_SDR_c', NULL, NULL, NULL, 2),
(13113, NULL, 'cd19137', NULL, NULL, 'AKR_AKR3F1', NULL, 'AKR_AKR3F1', NULL, NULL, NULL, 2),
(13114, NULL, 'cd17981', NULL, NULL, 'DEXHc_DHX36', NULL, 'DEXHc_DHX36', NULL, NULL, NULL, 2),
(13115, NULL, 'cd01121', NULL, NULL, 'Sms', NULL, 'Sms', NULL, NULL, 1831, 2),
(13116, NULL, 'cd14146', NULL, NULL, 'STKc_MLK4', NULL, 'STKc_MLK4', NULL, NULL, NULL, 2),
(13117, NULL, 'cd16917', NULL, NULL, 'HATPase_UhpB-NarQ-NarX-like', NULL, 'HATPase_UhpB-NarQ-NarX-like', NULL, NULL, NULL, 2),
(13118, NULL, 'cd11531', NULL, NULL, 'NTP-PPase_BsYpjD', NULL, 'NTP-PPase_BsYpjD', NULL, NULL, 12599, 2),
(13119, NULL, 'cd16180', NULL, NULL, 'EFh_PEF_Group_I', NULL, 'EFh_PEF_Group_I', NULL, NULL, NULL, 2),
(13120, NULL, 'cd09162', NULL, NULL, 'PLDc_CLS_unchar1_2', NULL, 'PLDc_CLS_unchar1_2', NULL, NULL, NULL, 2),
(13121, NULL, 'cd09909', NULL, NULL, 'HIV-1-like_HR1-HR2', NULL, 'HIV-1-like_HR1-HR2', NULL, NULL, 559, 2),
(13122, NULL, 'cd12488', NULL, NULL, 'RRM2_hnRNPR', NULL, 'RRM2_hnRNPR', NULL, NULL, 16388, 2),
(13123, NULL, 'cd18555', NULL, NULL, 'ABC_6TM_T1SS_like', NULL, 'ABC_6TM_T1SS_like', NULL, NULL, NULL, 2);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(13124, NULL, 'cd15660', NULL, NULL, 'PHD5_NSD2', NULL, 'PHD5_NSD2', NULL, NULL, NULL, 2),
(13125, NULL, 'cd19101', NULL, NULL, 'AKR_unchar', NULL, 'AKR_unchar', NULL, NULL, NULL, 2),
(13126, NULL, 'cd16416', NULL, NULL, 'HAD_BsYqeG-like', NULL, 'HAD_BsYqeG-like', NULL, NULL, NULL, 2),
(13127, NULL, 'cd16523', NULL, NULL, 'RING-HC_MYLIP', NULL, 'RING-HC_MYLIP', NULL, NULL, NULL, 2),
(13128, NULL, 'cd10519', NULL, NULL, 'SET_EZH', NULL, 'SET_EZH', NULL, NULL, NULL, 2),
(13129, NULL, 'cd18626', NULL, NULL, 'CD_eEF3', NULL, 'CD_eEF3', NULL, NULL, NULL, 2),
(13130, NULL, 'cd18505', NULL, NULL, 'BACK1_LZTR1', NULL, 'BACK1_LZTR1', NULL, NULL, NULL, 2),
(13131, NULL, 'cd05232', NULL, NULL, 'UDP_G4E_4_SDR_e', NULL, 'UDP_G4E_4_SDR_e', NULL, NULL, NULL, 2),
(13132, NULL, 'cd01942', NULL, NULL, 'ribokinase_group_A', NULL, 'ribokinase_group_A', NULL, NULL, NULL, 2),
(13133, NULL, 'cd14990', NULL, NULL, '7tmA_GPR146', NULL, '7tmA_GPR146', NULL, NULL, NULL, 2),
(13134, NULL, 'cd15600', NULL, NULL, 'PHD6_KMT2C', NULL, 'PHD6_KMT2C', NULL, NULL, NULL, 2),
(13135, NULL, 'cd15137', NULL, NULL, '7tmA_Relaxin_R', NULL, '7tmA_Relaxin_R', NULL, NULL, NULL, 2),
(13136, NULL, 'cd10235', NULL, NULL, 'HscC_like_NBD', NULL, 'HscC_like_NBD', NULL, NULL, 30972, 2),
(13137, NULL, 'cd03475', NULL, NULL, 'Rieske_SoxF_SoxL', NULL, 'Rieske_SoxF_SoxL', NULL, NULL, NULL, 2),
(13138, NULL, 'cd02901', NULL, NULL, 'Macro_Poa1p-like', NULL, 'Macro_Poa1p-like', NULL, NULL, NULL, 2),
(13139, NULL, 'cd14522', NULL, NULL, 'DSP_STYX', NULL, 'DSP_STYX', NULL, NULL, NULL, 2),
(13140, NULL, 'cd03418', NULL, NULL, 'GRX_GRXb_1_3_like', NULL, 'GRX_GRXb_1_3_like', NULL, NULL, 12228, 2),
(13141, NULL, 'cd20487', NULL, NULL, 'USP28_C', NULL, 'USP28_C', NULL, NULL, NULL, 2),
(13142, NULL, 'cd08238', NULL, NULL, 'sorbose_phosphate_red', NULL, 'sorbose_phosphate_red', NULL, NULL, NULL, 2),
(13143, NULL, 'cd19970', NULL, NULL, 'PBP1_ABC_sugar_binding-like', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, NULL, 2),
(13144, NULL, 'cd13538', NULL, NULL, 'PBP2_ModA_like_1', NULL, 'PBP2_ModA_like_1', NULL, NULL, NULL, 2),
(13145, NULL, 'cd00640', NULL, NULL, 'Trp-synth-beta_II', NULL, 'Trp-synth-beta_II', NULL, NULL, NULL, 2),
(13146, NULL, 'cd09746', NULL, NULL, 'Csm6_III-A', NULL, 'Csm6_III-A', NULL, NULL, NULL, 2),
(13147, NULL, 'cd13763', NULL, NULL, 'TGF_beta_BMP3_like', NULL, 'TGF_beta_BMP3_like', NULL, NULL, NULL, 2),
(13148, NULL, 'cd06351', NULL, NULL, 'PBP1_iGluR_N_LIVBP-like', NULL, 'PBP1_iGluR_N_LIVBP-like', NULL, NULL, NULL, 2),
(13149, NULL, 'cd09972', NULL, NULL, 'LOTUS_TDRD_OSKAR', NULL, 'LOTUS_TDRD_OSKAR', NULL, NULL, NULL, 2),
(13150, NULL, 'cd13337', NULL, NULL, 'FERM-like_C_SNX17', NULL, 'FERM-like_C_SNX17', NULL, NULL, 29891, 2),
(13151, NULL, 'cd11678', NULL, NULL, 'archaeal_LSm', NULL, 'archaeal_LSm', NULL, NULL, NULL, 2),
(13152, NULL, 'cd07439', NULL, NULL, 'FANCE_c-term', NULL, 'FANCE_c-term', NULL, NULL, 15607, 2),
(13153, NULL, 'cd19813', NULL, NULL, 'Bbox1_BRAT-like', NULL, 'Bbox1_BRAT-like', NULL, NULL, NULL, 2),
(13154, NULL, 'cd02908', NULL, NULL, 'Macro_OAADPr_deacetylase', NULL, 'Macro_OAADPr_deacetylase', NULL, NULL, NULL, 2),
(13155, NULL, 'cd14330', NULL, NULL, 'UBA_atDRM2_like', NULL, 'UBA_atDRM2_like', NULL, NULL, NULL, 2),
(13156, NULL, 'cd17499', NULL, NULL, 'RMtype1_S_CloLW9ORF3270P-TRD1-CR1_like', NULL, 'RMtype1_S_CloLW9ORF3270P-TRD1-CR1_like', NULL, NULL, NULL, 2),
(13157, NULL, 'cd04477', NULL, NULL, 'RPA1N', NULL, 'RPA1N', NULL, NULL, 1384, 2),
(13158, NULL, 'cd13953', NULL, NULL, '7tm_classC_mGluR-like', NULL, '7tm_classC_mGluR-like', NULL, NULL, NULL, 2),
(13159, NULL, 'cd16593', NULL, NULL, 'RING-HC_TRIM10_C-IV', NULL, 'RING-HC_TRIM10_C-IV', NULL, NULL, 34869, 2),
(13160, NULL, 'cd14586', NULL, NULL, 'PTP-MTMR3', NULL, 'PTP-MTMR3', NULL, NULL, 36641, 2),
(13161, NULL, 'cd01004', NULL, NULL, 'PBP2_MidA_like', NULL, 'PBP2_MidA_like', NULL, NULL, NULL, 2),
(13162, NULL, 'cd02175', NULL, NULL, 'GH16_lichenase', NULL, 'GH16_lichenase', NULL, NULL, NULL, 2),
(13163, NULL, 'cd17005', NULL, NULL, 'CID_SFRS15_SCAF4', NULL, 'CID_SFRS15_SCAF4', NULL, NULL, NULL, 2);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(13164, NULL, 'cd18537', NULL, NULL, 'PTP-IVa1', NULL, 'PTP-IVa1', NULL, NULL, NULL, 2),
(13165, NULL, 'cd18660', NULL, NULL, 'CD1_tandem', NULL, 'CD1_tandem', NULL, NULL, NULL, 2),
(13166, NULL, 'cd01915', NULL, NULL, 'CODH', NULL, 'CODH', NULL, NULL, 5487, 2),
(13167, NULL, 'cd13667', NULL, NULL, 'PBP2_TRAP_DctP1', NULL, 'PBP2_TRAP_DctP1', NULL, NULL, NULL, 2),
(13168, NULL, 'cd05152', NULL, NULL, 'MPH2''', NULL, 'MPH2''', NULL, NULL, NULL, 2),
(13169, NULL, 'cd17016', NULL, NULL, 'ING_Pho23p_like', NULL, 'ING_Pho23p_like', NULL, NULL, NULL, 2),
(13170, NULL, 'cd02195', NULL, NULL, 'SelD', NULL, 'SelD', NULL, NULL, 1501, 2),
(13171, NULL, 'cd12336', NULL, NULL, 'RRM_RBM7_like', NULL, 'RRM_RBM7_like', NULL, NULL, NULL, 2),
(13172, NULL, 'cd19007', NULL, NULL, 'LGIC_ECD_GABAR_GRD-like', NULL, 'LGIC_ECD_GABAR_GRD-like', NULL, NULL, NULL, 2),
(13173, NULL, 'cd07304', NULL, NULL, 'Chorismate_synthase', NULL, 'Chorismate_synthase', NULL, NULL, 6508, 2),
(13174, NULL, 'cd17541', NULL, NULL, 'REC_CheB-like', NULL, 'REC_CheB-like', NULL, NULL, NULL, 2),
(13175, NULL, 'cd11238', NULL, NULL, 'Sema_2A', NULL, 'Sema_2A', NULL, NULL, NULL, 2),
(13176, NULL, 'cd00322', NULL, NULL, 'FNR_like', NULL, 'FNR_like', NULL, NULL, NULL, 2),
(13177, NULL, 'cd15867', NULL, NULL, 'R-SNARE_YKT6', NULL, 'R-SNARE_YKT6', NULL, NULL, 36425, 2),
(13178, NULL, 'cd03397', NULL, NULL, 'PAP2_acid_phosphatase', NULL, 'PAP2_acid_phosphatase', NULL, NULL, 2024, 2),
(13179, NULL, 'cd09641', NULL, NULL, 'Cas3''''_I', NULL, 'Cas3''''_I', NULL, NULL, NULL, 2),
(13180, NULL, 'cd07627', NULL, NULL, 'BAR_Vps5p', NULL, 'BAR_Vps5p', NULL, NULL, 33470, 2),
(13181, NULL, 'cd15613', NULL, NULL, 'PHD_AL_plant', NULL, 'PHD_AL_plant', NULL, NULL, 35305, 2),
(13182, NULL, 'cd06208', NULL, NULL, 'CYPOR_like_FNR', NULL, 'CYPOR_like_FNR', NULL, NULL, NULL, 2),
(13183, NULL, 'cd18042', NULL, NULL, 'DEXXQc_SETX', NULL, 'DEXXQc_SETX', NULL, NULL, NULL, 2),
(13184, NULL, 'cd08399', NULL, NULL, 'C2_PI3K_class_I_gamma', NULL, 'C2_PI3K_class_I_gamma', NULL, NULL, NULL, 2),
(13185, NULL, 'cd15584', NULL, NULL, 'PHD_ING1_2', NULL, 'PHD_ING1_2', NULL, NULL, NULL, 2),
(13186, NULL, 'cd10953', NULL, NULL, 'CE4_SlAXE_like', NULL, 'CE4_SlAXE_like', NULL, NULL, NULL, 2),
(13187, NULL, 'cd08607', NULL, NULL, 'GDPD_GDE5', NULL, 'GDPD_GDE5', NULL, NULL, NULL, 2),
(13188, NULL, 'cd01420', NULL, NULL, 'MoaC_PE', NULL, 'MoaC_PE', NULL, NULL, 15016, 2),
(13189, NULL, 'cd04610', NULL, NULL, 'CBS_pair_ParBc_assoc', NULL, 'CBS_pair_ParBc_assoc', NULL, NULL, NULL, 2),
(13190, NULL, 'cd14796', NULL, NULL, 'RNAse_HIII_N', NULL, 'RNAse_HIII_N', NULL, NULL, 21535, 2),
(13191, NULL, 'cd18334', NULL, NULL, 'BTB_POZ_ZBTB30_HIC2', NULL, 'BTB_POZ_ZBTB30_HIC2', NULL, NULL, NULL, 2),
(13192, NULL, 'cd06306', NULL, NULL, 'PBP1_TorT-like', NULL, 'PBP1_TorT-like', NULL, NULL, NULL, 2),
(13193, NULL, 'cd11385', NULL, NULL, 'RagC_like', NULL, 'RagC_like', NULL, NULL, 33399, 2),
(13194, NULL, 'cd08854', NULL, NULL, 'ArfGap_AGAP1', NULL, 'ArfGap_AGAP1', NULL, NULL, NULL, 2),
(13195, NULL, 'cd09715', NULL, NULL, 'Csp2_I-U', NULL, 'Csp2_I-U', NULL, NULL, NULL, 2),
(13196, NULL, 'cd12925', NULL, NULL, 'iSH2_PIK3R3', NULL, 'iSH2_PIK3R3', NULL, NULL, NULL, 2),
(13197, NULL, 'cd03403', NULL, NULL, 'SPFH_stomatin', NULL, 'SPFH_stomatin', NULL, NULL, NULL, 2),
(13198, NULL, 'cd06978', NULL, NULL, 'cupin_EctC', NULL, 'cupin_EctC', NULL, NULL, 10136, 2),
(13199, NULL, 'cd19448', NULL, NULL, 'FABP_pancrustacea', NULL, 'FABP_pancrustacea', NULL, NULL, NULL, 2),
(13200, NULL, 'cd11746', NULL, NULL, 'GH94N_like', NULL, 'GH94N_like', NULL, NULL, NULL, 2),
(13201, NULL, 'cd01529', NULL, NULL, '4RHOD_Repeats', NULL, '4RHOD_Repeats', NULL, NULL, NULL, 2),
(13202, NULL, 'cd01518', NULL, NULL, 'RHOD_YceA', NULL, 'RHOD_YceA', NULL, NULL, NULL, 2),
(13203, NULL, 'cd05093', NULL, NULL, 'PTKc_TrkB', NULL, 'PTKc_TrkB', NULL, NULL, NULL, 2),
(13204, NULL, 'cd18810', NULL, NULL, 'SF2_C_TRCF', NULL, 'SF2_C_TRCF', NULL, NULL, NULL, 2),
(13205, NULL, 'cd03200', NULL, NULL, 'GST_C_AIMP2', NULL, 'GST_C_AIMP2', NULL, NULL, NULL, 2);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(13206, NULL, 'cd06525', NULL, NULL, 'GH25_Lyc-like', NULL, 'GH25_Lyc-like', NULL, NULL, NULL, 2),
(13207, NULL, 'cd09662', NULL, NULL, 'Csm5_III-A', NULL, 'Csm5_III-A', NULL, NULL, NULL, 2),
(13208, NULL, 'cd06465', NULL, NULL, 'p23_hB-ind1_like', NULL, 'p23_hB-ind1_like', NULL, NULL, NULL, 2),
(13209, NULL, 'cd12175', NULL, NULL, '2-Hacid_dh_11', NULL, '2-Hacid_dh_11', NULL, NULL, NULL, 2),
(13210, NULL, 'cd16115', NULL, NULL, 'Ubl_SUMO2_3_4', NULL, 'Ubl_SUMO2_3_4', NULL, NULL, NULL, 2),
(13211, NULL, 'cd16951', NULL, NULL, 'HATPase_EL346-LOV-HK-like', NULL, 'HATPase_EL346-LOV-HK-like', NULL, NULL, NULL, 2),
(13212, NULL, 'cd12304', NULL, NULL, 'RRM_Set1', NULL, 'RRM_Set1', NULL, NULL, NULL, 2),
(13213, NULL, 'cd20289', NULL, NULL, 'cupin_ADO', NULL, 'cupin_ADO', NULL, NULL, NULL, 2),
(13214, NULL, 'cd02227', NULL, NULL, 'cupin_TM1112-like', NULL, 'cupin_TM1112-like', NULL, NULL, NULL, 2),
(13215, NULL, 'cd04161', NULL, NULL, 'Arl2l1_Arl13_like', NULL, 'Arl2l1_Arl13_like', NULL, NULL, NULL, 2),
(13216, NULL, 'cd07261', NULL, NULL, 'EhpR_like', NULL, 'EhpR_like', NULL, NULL, NULL, 2),
(13217, NULL, 'cd01045', NULL, NULL, 'Ferritin_like_AB', NULL, 'Ferritin_like_AB', NULL, NULL, NULL, 2),
(13218, NULL, 'cd08849', NULL, NULL, 'ArfGap_ASAP2', NULL, 'ArfGap_ASAP2', NULL, NULL, NULL, 2),
(13219, NULL, 'cd11789', NULL, NULL, 'SH3_Nebulin_family_C', NULL, 'SH3_Nebulin_family_C', NULL, NULL, NULL, 2),
(13220, NULL, 'cd10497', NULL, NULL, 'MH2_SMAD_1_5_9', NULL, 'MH2_SMAD_1_5_9', NULL, NULL, NULL, 2),
(13221, NULL, 'cd16973', NULL, NULL, 'Alpha_kinase_ALPK3', NULL, 'Alpha_kinase_ALPK3', NULL, NULL, NULL, 2),
(13222, NULL, 'cd07947', NULL, NULL, 'DRE_TIM_Re_CS', NULL, 'DRE_TIM_Re_CS', NULL, NULL, NULL, 2),
(13223, NULL, 'cd02891', NULL, NULL, 'A2M_like', NULL, 'A2M_like', NULL, NULL, NULL, 2),
(13224, NULL, 'cd11310', NULL, NULL, '14-3-3_1', NULL, '14-3-3_1', NULL, NULL, NULL, 2),
(13225, NULL, 'cd15391', NULL, NULL, '7tmA_NPR-like_invertebrate', NULL, '7tmA_NPR-like_invertebrate', NULL, NULL, NULL, 2),
(13226, NULL, 'cd10475', NULL, NULL, 'EphR_LBD_B6', NULL, 'EphR_LBD_B6', NULL, NULL, NULL, 2),
(13227, NULL, 'cd12555', NULL, NULL, 'RRM2_RBM15', NULL, 'RRM2_RBM15', NULL, NULL, 12313, 2),
(13228, NULL, 'cd14773', NULL, NULL, 'TrHb2_PhHbO-like_O', NULL, 'TrHb2_PhHbO-like_O', NULL, NULL, NULL, 2),
(13229, NULL, 'cd02792', NULL, NULL, 'MopB_CT_Formate-Dh-Na-like', NULL, 'MopB_CT_Formate-Dh-Na-like', NULL, NULL, NULL, 2),
(13230, NULL, 'cd07538', NULL, NULL, 'P-type_ATPase', NULL, 'P-type_ATPase', NULL, NULL, NULL, 2),
(13231, NULL, 'cd15229', NULL, NULL, '7tmA_OR8S1-like', NULL, '7tmA_OR8S1-like', NULL, NULL, NULL, 2),
(13232, NULL, 'cd07724', NULL, NULL, 'POD-like_MBL-fold', NULL, 'POD-like_MBL-fold', NULL, NULL, 34863, 2),
(13233, NULL, 'cd09751', NULL, NULL, 'Cas8a2_I-A', NULL, 'Cas8a2_I-A', NULL, NULL, NULL, 2),
(13234, NULL, 'cd00983', NULL, NULL, 'recA', NULL, 'recA', NULL, NULL, 7303, 2),
(13235, NULL, 'cd08850', NULL, NULL, 'ArfGap_ACAP3', NULL, 'ArfGap_ACAP3', NULL, NULL, NULL, 2),
(13236, NULL, 'cd13737', NULL, NULL, 'SPRY_PRY_TRIM25-like', NULL, 'SPRY_PRY_TRIM25-like', NULL, NULL, NULL, 2),
(13237, NULL, 'cd09358', NULL, NULL, 'LIM_Mical_like', NULL, 'LIM_Mical_like', NULL, NULL, NULL, 2),
(13238, NULL, 'cd18059', NULL, NULL, 'DEXHc_CHD7', NULL, 'DEXHc_CHD7', NULL, NULL, NULL, 2),
(13239, NULL, 'cd08588', NULL, NULL, 'PI-PLCc_At5g67130_like', NULL, 'PI-PLCc_At5g67130_like', NULL, NULL, NULL, 2),
(13240, NULL, 'cd21626', NULL, NULL, 'MERS-CoV-like_Spike_S1_NTD', NULL, 'MERS-CoV-like_Spike_S1_NTD', NULL, NULL, 33874, 2),
(13241, NULL, 'cd18628', NULL, NULL, 'CD3_cpSRP43_like', NULL, 'CD3_cpSRP43_like', NULL, NULL, NULL, 2),
(13242, NULL, 'cd17525', NULL, NULL, 'RMtype1_S_Eco15ORF14057P-TRD1-CR1_like', NULL, 'RMtype1_S_Eco15ORF14057P-TRD1-CR1_like', NULL, NULL, NULL, 2),
(13243, NULL, 'cd19694', NULL, NULL, 'bHLH_dnHLH_ID4', NULL, 'bHLH_dnHLH_ID4', NULL, NULL, NULL, 2),
(13244, NULL, 'sd00041', NULL, NULL, 'GyrA-ParC_C', NULL, 'GyrA-ParC_C', NULL, NULL, NULL, 2),
(13245, NULL, 'cd05396', NULL, NULL, 'An_peroxidase_like', NULL, 'An_peroxidase_like', NULL, NULL, NULL, 2);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(13246, NULL, 'cd04916', NULL, NULL, 'ACT_AKiii-YclM-BS_2', NULL, 'ACT_AKiii-YclM-BS_2', NULL, NULL, NULL, 2),
(13247, NULL, 'cd14005', NULL, NULL, 'STKc_PIM', NULL, 'STKc_PIM', NULL, NULL, NULL, 2),
(13248, NULL, 'cd04824', NULL, NULL, 'eu_ALAD_PBGS_cysteine_rich', NULL, 'eu_ALAD_PBGS_cysteine_rich', NULL, NULL, NULL, 2),
(13249, NULL, 'cd15002', NULL, NULL, '7tmA_GPR151', NULL, '7tmA_GPR151', NULL, NULL, NULL, 2),
(13250, NULL, 'cd03472', NULL, NULL, 'Rieske_RO_Alpha_BPDO_like', NULL, 'Rieske_RO_Alpha_BPDO_like', NULL, NULL, NULL, 2),
(13251, NULL, 'cd14917', NULL, NULL, 'MYSc_Myh7', NULL, 'MYSc_Myh7', NULL, NULL, NULL, 2),
(13252, NULL, 'cd04382', NULL, NULL, 'RhoGAP_MgcRacGAP', NULL, 'RhoGAP_MgcRacGAP', NULL, NULL, NULL, 2),
(13253, NULL, 'cd04092', NULL, NULL, 'mtEFG2_II_like', NULL, 'mtEFG2_II_like', NULL, NULL, NULL, 2),
(13254, NULL, 'cd12382', NULL, NULL, 'RRM_RBMX_like', NULL, 'RRM_RBMX_like', NULL, NULL, NULL, 2),
(13255, NULL, 'cd08163', NULL, NULL, 'MPP_Cdc1', NULL, 'MPP_Cdc1', NULL, NULL, 30694, 2),
(13256, NULL, 'cd12716', NULL, NULL, 'RRM1_2_NP220', NULL, 'RRM1_2_NP220', NULL, NULL, NULL, 2),
(13257, NULL, 'cd04240', NULL, NULL, 'AAK_UC', NULL, 'AAK_UC', NULL, NULL, 14963, 2),
(13258, NULL, 'cd15031', NULL, NULL, '7tmF_FZD3_insect', NULL, '7tmF_FZD3_insect', NULL, NULL, NULL, 2),
(13259, NULL, 'cd18668', NULL, NULL, 'CD1_tandem_CHD5-9_like', NULL, 'CD1_tandem_CHD5-9_like', NULL, NULL, NULL, 2),
(13260, NULL, 'cd17329', NULL, NULL, 'MFS_MdtH_MDR_like', NULL, 'MFS_MdtH_MDR_like', NULL, NULL, NULL, 2),
(13261, NULL, 'cd05686', NULL, NULL, 'S1_pNO40', NULL, 'S1_pNO40', NULL, NULL, NULL, 2),
(13262, NULL, 'cd11702', NULL, NULL, 'DHR2_DOCK6', NULL, 'DHR2_DOCK6', NULL, NULL, NULL, 2),
(13263, NULL, 'cd05507', NULL, NULL, 'Bromo_brd8_like', NULL, 'Bromo_brd8_like', NULL, NULL, 31206, 2),
(13264, NULL, 'cd04878', NULL, NULL, 'ACT_AHAS', NULL, 'ACT_AHAS', NULL, NULL, 33191, 2),
(13265, NULL, 'cd00146', NULL, NULL, 'PKD', NULL, 'PKD', NULL, NULL, NULL, 2),
(13266, NULL, 'cd06238', NULL, NULL, 'M14-like', NULL, 'M14-like', NULL, NULL, NULL, 2),
(13267, NULL, 'cd11651', NULL, NULL, 'YPK1_N_like', NULL, 'YPK1_N_like', NULL, NULL, NULL, 2),
(13268, NULL, 'cd05081', NULL, NULL, 'PTKc_Jak3_rpt2', NULL, 'PTKc_Jak3_rpt2', NULL, NULL, NULL, 2),
(13269, NULL, 'cd04975', NULL, NULL, 'Ig4_SCFR_like', NULL, 'Ig4_SCFR_like', NULL, NULL, NULL, 2),
(13270, NULL, 'cd17334', NULL, NULL, 'MFS_SLC49', NULL, 'MFS_SLC49', NULL, NULL, NULL, 2),
(13271, NULL, 'cd00764', NULL, NULL, 'Eukaryotic_PFK', NULL, 'Eukaryotic_PFK', NULL, NULL, 30740, 2),
(13272, NULL, 'cd14515', NULL, NULL, 'DUSP3-like', NULL, 'DUSP3-like', NULL, NULL, NULL, 2),
(13273, NULL, 'cd03528', NULL, NULL, 'Rieske_RO_ferredoxin', NULL, 'Rieske_RO_ferredoxin', NULL, NULL, NULL, 2),
(13274, NULL, 'cd13851', NULL, NULL, 'CuRO_1_Fet3p', NULL, 'CuRO_1_Fet3p', NULL, NULL, NULL, 2),
(13275, NULL, 'cd03111', NULL, NULL, 'CpaE-like', NULL, 'CpaE-like', NULL, NULL, NULL, 2),
(13276, NULL, 'cd03163', NULL, NULL, 'TM4SF8_like_LEL', NULL, 'TM4SF8_like_LEL', NULL, NULL, NULL, 2),
(13277, NULL, 'cd13308', NULL, NULL, 'PH_3BP2', NULL, 'PH_3BP2', NULL, NULL, NULL, 2),
(13278, NULL, 'cd09247', NULL, NULL, 'BRO1_Alix_like_2', NULL, 'BRO1_Alix_like_2', NULL, NULL, NULL, 2),
(13279, NULL, 'cd18687', NULL, NULL, 'PIN_VapC-like', NULL, 'PIN_VapC-like', NULL, NULL, NULL, 2),
(13280, NULL, 'cd18358', NULL, NULL, 'BTB2_POZ_RHOBTB1', NULL, 'BTB2_POZ_RHOBTB1', NULL, NULL, NULL, 2),
(13281, NULL, 'cd20484', NULL, NULL, 'C_PKS-NRPS_PksJ-like', NULL, 'C_PKS-NRPS_PksJ-like', NULL, NULL, NULL, 2),
(13282, NULL, 'cd06580', NULL, NULL, 'TM_PBP1_transp_TpRbsC_like', NULL, 'TM_PBP1_transp_TpRbsC_like', NULL, NULL, NULL, 2),
(13283, NULL, 'cd01826', NULL, NULL, 'acyloxyacyl_hydrolase_like', NULL, 'acyloxyacyl_hydrolase_like', NULL, NULL, NULL, 2),
(13284, NULL, 'cd00774', NULL, NULL, 'GlyRS-like_core', NULL, 'GlyRS-like_core', NULL, NULL, 32849, 2),
(13285, NULL, 'cd07059', NULL, NULL, 'BMC_PduA', NULL, 'BMC_PduA', NULL, NULL, NULL, 2),
(13286, NULL, 'cd08484', NULL, NULL, 'PBP2_LTTR_beta_lactamase', NULL, 'PBP2_LTTR_beta_lactamase', NULL, NULL, 29648, 2);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(13287, NULL, 'cd17123', NULL, NULL, 'Ubl_UHRF2', NULL, 'Ubl_UHRF2', NULL, NULL, NULL, 2),
(13288, NULL, 'cd15010', NULL, NULL, '7tmA_ACKR1_DARC', NULL, '7tmA_ACKR1_DARC', NULL, NULL, NULL, 2),
(13289, NULL, 'cd04901', NULL, NULL, 'ACT_3PGDH', NULL, 'ACT_3PGDH', NULL, NULL, NULL, 2),
(13290, NULL, 'cd10419', NULL, NULL, 'SH2_Src_Fyn_isoform_b_like', NULL, 'SH2_Src_Fyn_isoform_b_like', NULL, NULL, NULL, 2),
(13291, NULL, 'cd08959', NULL, NULL, 'ArfGap_ArfGap1_like', NULL, 'ArfGap_ArfGap1_like', NULL, NULL, NULL, 2),
(13292, NULL, 'cd19044', NULL, NULL, 'LGIC_ECD_GABAAR_G2', NULL, 'LGIC_ECD_GABAAR_G2', NULL, NULL, NULL, 2),
(13293, NULL, 'cd18172', NULL, NULL, 'M14_CP_plant', NULL, 'M14_CP_plant', NULL, NULL, NULL, 2),
(13294, NULL, 'cd12617', NULL, NULL, 'RRM2_TIAR', NULL, 'RRM2_TIAR', NULL, NULL, 32389, 2),
(13295, NULL, 'cd11959', NULL, NULL, 'SH3_Cortactin', NULL, 'SH3_Cortactin', NULL, NULL, 31121, 2),
(13296, NULL, 'cd08048', NULL, NULL, 'TAF11', NULL, 'TAF11', NULL, NULL, 3810, 2),
(13297, NULL, 'cd14891', NULL, NULL, 'MYSc_Myo30', NULL, 'MYSc_Myo30', NULL, NULL, NULL, 2),
(13298, NULL, 'cd17985', NULL, NULL, 'DEXHc_DHX57', NULL, 'DEXHc_DHX57', NULL, NULL, NULL, 2),
(13299, NULL, 'cd07033', NULL, NULL, 'TPP_PYR_DXS_TK_like', NULL, 'TPP_PYR_DXS_TK_like', NULL, NULL, NULL, 2),
(13300, NULL, 'cd08499', NULL, NULL, 'PBP2_Ylib_like', NULL, 'PBP2_Ylib_like', NULL, NULL, NULL, 2),
(13301, NULL, 'cd04727', NULL, NULL, 'pdxS', NULL, 'pdxS', NULL, NULL, 4143, 2),
(13302, NULL, 'cd12532', NULL, NULL, 'RRM3_MEI2_fungi', NULL, 'RRM3_MEI2_fungi', NULL, NULL, 9135, 2),
(13303, NULL, 'cd02094', NULL, NULL, 'P-type_ATPase_Cu-like', NULL, 'P-type_ATPase_Cu-like', NULL, NULL, NULL, 2),
(13304, NULL, 'cd14074', NULL, NULL, 'STKc_SNRK', NULL, 'STKc_SNRK', NULL, NULL, NULL, 2),
(13305, NULL, 'cd11573', NULL, NULL, 'GH99_GH71_like', NULL, 'GH99_GH71_like', NULL, NULL, NULL, 2),
(13306, NULL, 'cd14058', NULL, NULL, 'STKc_TAK1', NULL, 'STKc_TAK1', NULL, NULL, NULL, 2),
(13307, NULL, 'cd13167', NULL, NULL, 'PTB_P-CLI1', NULL, 'PTB_P-CLI1', NULL, NULL, 28169, 2),
(13308, NULL, 'cd06346', NULL, NULL, 'PBP1_ABC_ligand_binding-like', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, NULL, 2),
(13309, NULL, 'cd12115', NULL, NULL, 'A_NRPS_Sfm_like', NULL, 'A_NRPS_Sfm_like', NULL, NULL, NULL, 2),
(13310, NULL, 'cd06224', NULL, NULL, 'REM', NULL, 'REM', NULL, NULL, 6675, 2),
(13311, NULL, 'cd18225', NULL, NULL, 'BTB_POZ_ZBTB40', NULL, 'BTB_POZ_ZBTB40', NULL, NULL, NULL, 2),
(13312, NULL, 'cd17096', NULL, NULL, 'FERM_F1_kindlins', NULL, 'FERM_F1_kindlins', NULL, NULL, NULL, 2),
(13313, NULL, 'cd04900', NULL, NULL, 'ACT_UUR-like_1', NULL, 'ACT_UUR-like_1', NULL, NULL, NULL, 2),
(13314, NULL, 'cd19403', NULL, NULL, 'TGF_beta_GDF9', NULL, 'TGF_beta_GDF9', NULL, NULL, NULL, 2),
(13315, NULL, 'cd15630', NULL, NULL, 'PHD_BAZ2B', NULL, 'PHD_BAZ2B', NULL, NULL, NULL, 2),
(13316, NULL, 'cd12713', NULL, NULL, 'RRM_TNRC6C', NULL, 'RRM_TNRC6C', NULL, NULL, 11971, 2),
(13317, NULL, 'cd04685', NULL, NULL, 'Nudix_Hydrolase_26', NULL, 'Nudix_Hydrolase_26', NULL, NULL, NULL, 2),
(13318, NULL, 'cd17039', NULL, NULL, 'Ubl_ubiquitin_like', NULL, 'Ubl_ubiquitin_like', NULL, NULL, NULL, 2),
(13319, NULL, 'cd05029', NULL, NULL, 'S-100A6', NULL, 'S-100A6', NULL, NULL, 28606, 2),
(13320, NULL, 'cd13198', NULL, NULL, 'FERM_C1_MyoVII', NULL, 'FERM_C1_MyoVII', NULL, NULL, 30202, 2),
(13321, NULL, 'cd03182', NULL, NULL, 'GST_C_GTT2_like', NULL, 'GST_C_GTT2_like', NULL, NULL, 16407, 2),
(13322, NULL, 'cd08246', NULL, NULL, 'crotonyl_coA_red', NULL, 'crotonyl_coA_red', NULL, NULL, 2090, 2),
(13323, NULL, 'cd07396', NULL, NULL, 'MPP_Nbla03831', NULL, 'MPP_Nbla03831', NULL, NULL, 30736, 2),
(13324, NULL, 'cd15319', NULL, NULL, '7tmA_D1B_dopamine_R', NULL, '7tmA_D1B_dopamine_R', NULL, NULL, NULL, 2),
(13325, NULL, 'cd17544', NULL, NULL, 'REC_2_GGDEF', NULL, 'REC_2_GGDEF', NULL, NULL, NULL, 2),
(13326, NULL, 'cd01821', NULL, NULL, 'Rhamnogalacturan_acetylesterase_like', NULL, 'Rhamnogalacturan_acetylesterase_like', NULL, NULL, 30336, 2),
(13327, NULL, 'cd04231', NULL, NULL, 'Rusticyanin', NULL, 'Rusticyanin', NULL, NULL, 563, 2);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(13328, NULL, 'cd18233', NULL, NULL, 'BTB_POZ_ZBTB49', NULL, 'BTB_POZ_ZBTB49', NULL, NULL, NULL, 2),
(13329, NULL, 'cd05913', NULL, NULL, 'PaaK', NULL, 'PaaK', NULL, NULL, 8911, 2),
(13330, NULL, 'cd09856', NULL, NULL, 'PIN_FEN1-like', NULL, 'PIN_FEN1-like', NULL, NULL, NULL, 2),
(13331, NULL, 'cd18966', NULL, NULL, 'chromodomain', NULL, 'chromodomain', NULL, NULL, NULL, 2),
(13332, NULL, 'cd13747', NULL, NULL, 'UreI_AmiS_like_1', NULL, 'UreI_AmiS_like_1', NULL, NULL, NULL, 2),
(13333, NULL, 'cd11939', NULL, NULL, 'SH3_ephexin1', NULL, 'SH3_ephexin1', NULL, NULL, 33984, 2),
(13334, NULL, 'cd00070', NULL, NULL, 'GLECT', NULL, 'GLECT', NULL, NULL, 2387, 2),
(13335, NULL, 'cd16968', NULL, NULL, 'Alpha_kinase_MHCK_like', NULL, 'Alpha_kinase_MHCK_like', NULL, NULL, NULL, 2),
(13336, NULL, 'cd16695', NULL, NULL, 'mRING-CH-C4HC2H_ZNRF2', NULL, 'mRING-CH-C4HC2H_ZNRF2', NULL, NULL, NULL, 2),
(13337, NULL, 'cd05285', NULL, NULL, 'sorbitol_DH', NULL, 'sorbitol_DH', NULL, NULL, 37084, 2),
(13338, NULL, 'cd20305', NULL, NULL, 'cupin_OxDC_C', NULL, 'cupin_OxDC_C', NULL, NULL, NULL, 2),
(13339, NULL, 'cd08237', NULL, NULL, 'ribitol-5-phosphate_DH', NULL, 'ribitol-5-phosphate_DH', NULL, NULL, NULL, 2),
(13340, NULL, 'cd11819', NULL, NULL, 'SH3_Cortactin_like', NULL, 'SH3_Cortactin_like', NULL, NULL, NULL, 2),
(13341, NULL, 'cd18828', NULL, NULL, 'GH43_BT3675-like', NULL, 'GH43_BT3675-like', NULL, NULL, NULL, 2),
(13342, NULL, 'cd03323', NULL, NULL, 'D-glucarate_dehydratase', NULL, 'D-glucarate_dehydratase', NULL, NULL, 9508, 2),
(13343, NULL, 'cd09916', NULL, NULL, 'CpxP_like', NULL, 'CpxP_like', NULL, NULL, 13251, 2),
(13344, NULL, 'cd12566', NULL, NULL, 'RRM2_MRD1', NULL, 'RRM2_MRD1', NULL, NULL, NULL, 2),
(13345, NULL, 'cd13123', NULL, NULL, 'MATE_MurJ_like', NULL, 'MATE_MurJ_like', NULL, NULL, 3910, 2),
(13346, NULL, 'cd14507', NULL, NULL, 'PTP-MTM-like', NULL, 'PTP-MTM-like', NULL, NULL, NULL, 2),
(13347, NULL, 'cd11759', NULL, NULL, 'SH3_CRK_C', NULL, 'SH3_CRK_C', NULL, NULL, 20477, 2),
(13348, NULL, 'cd14510', NULL, NULL, 'PTP_VSP_TPTE', NULL, 'PTP_VSP_TPTE', NULL, NULL, 36610, 2),
(13349, NULL, 'cd14520', NULL, NULL, 'DSP_DUSP12', NULL, 'DSP_DUSP12', NULL, NULL, NULL, 2),
(13350, NULL, 'cd00614', NULL, NULL, 'CGS_like', NULL, 'CGS_like', NULL, NULL, 877, 2),
(13351, NULL, 'cd09397', NULL, NULL, 'LIM1_UF1', NULL, 'LIM1_UF1', NULL, NULL, NULL, 2),
(13352, NULL, 'cd01999', NULL, NULL, 'Argininosuccinate_Synthase', NULL, 'Argininosuccinate_Synthase', NULL, NULL, 16396, 2),
(13353, NULL, 'cd18007', NULL, NULL, 'DEXHc_ATRX-like', NULL, 'DEXHc_ATRX-like', NULL, NULL, NULL, 2),
(13354, NULL, 'cd06415', NULL, NULL, 'GH25_Cpl1-like', NULL, 'GH25_Cpl1-like', NULL, NULL, NULL, 2),
(13355, NULL, 'cd07434', NULL, NULL, 'PHP_PolIIIA_DnaE2', NULL, 'PHP_PolIIIA_DnaE2', NULL, NULL, NULL, 2),
(13356, NULL, 'cd16946', NULL, NULL, 'HATPase_BaeS-like', NULL, 'HATPase_BaeS-like', NULL, NULL, NULL, 2),
(13357, NULL, 'cd12746', NULL, NULL, 'RRM2_RBM12B', NULL, 'RRM2_RBM12B', NULL, NULL, 27845, 2),
(13358, NULL, 'cd13234', NULL, NULL, 'PHsplit_PLC_gamma', NULL, 'PHsplit_PLC_gamma', NULL, NULL, NULL, 2),
(13359, NULL, 'cd12869', NULL, NULL, 'MqsR', NULL, 'MqsR', NULL, NULL, 25157, 2),
(13360, NULL, 'cd16096', NULL, NULL, 'IgV_CD79b_beta', NULL, 'IgV_CD79b_beta', NULL, NULL, NULL, 2),
(13361, NULL, 'cd09198', NULL, NULL, 'PLDc_pPLDbeta_1', NULL, 'PLDc_pPLDbeta_1', NULL, NULL, NULL, 2),
(13362, NULL, 'cd13314', NULL, NULL, 'PH_Rpn13', NULL, 'PH_Rpn13', NULL, NULL, NULL, 2),
(13363, NULL, 'cd02585', NULL, NULL, 'HAD_PMM', NULL, 'HAD_PMM', NULL, NULL, 639, 2),
(13364, NULL, 'cd12592', NULL, NULL, 'RRM_RBM7', NULL, 'RRM_RBM7', NULL, NULL, 29757, 2),
(13365, NULL, 'cd16320', NULL, NULL, 'MraZ_N', NULL, 'MraZ_N', NULL, NULL, 32227, 2),
(13366, NULL, 'cd13777', NULL, NULL, 'Aar2_N', NULL, 'Aar2_N', NULL, NULL, 30426, 2),
(13367, NULL, 'cd18739', NULL, NULL, 'PIN_VapC4-5_FitB-like', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, NULL, 2),
(13368, NULL, 'cd17099', NULL, NULL, 'FERM_F1_PTPN14_like', NULL, 'FERM_F1_PTPN14_like', NULL, NULL, NULL, 2);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(13369, NULL, 'cd16671', NULL, NULL, 'RING-H2_DTX1_4', NULL, 'RING-H2_DTX1_4', NULL, NULL, NULL, 2),
(13370, NULL, 'cd19919', NULL, NULL, 'REC_NtrC', NULL, 'REC_NtrC', NULL, NULL, NULL, 2),
(13371, NULL, 'cd09403', NULL, NULL, 'LIM2_CRP', NULL, 'LIM2_CRP', NULL, NULL, NULL, 2),
(13372, NULL, 'cd16780', NULL, NULL, 'mRING-HC-C3HC3D_LNX2', NULL, 'mRING-HC-C3HC3D_LNX2', NULL, NULL, NULL, 2),
(13373, NULL, 'cd16847', NULL, NULL, 'STAT3_DBD', NULL, 'STAT3_DBD', NULL, NULL, NULL, 2),
(13374, NULL, 'cd21408', NULL, NULL, '1B_Sen1p-like', NULL, '1B_Sen1p-like', NULL, NULL, 33533, 2),
(13375, NULL, 'cd06257', NULL, NULL, 'DnaJ', NULL, 'DnaJ', NULL, NULL, 1163, 2),
(13376, NULL, 'cd10549', NULL, NULL, 'MtMvhB_like', NULL, 'MtMvhB_like', NULL, NULL, NULL, 2),
(13377, NULL, 'cd12917', NULL, NULL, 'VKOR_euk', NULL, 'VKOR_euk', NULL, NULL, 36877, 2),
(13378, NULL, 'cd09932', NULL, NULL, 'SH2_C-SH2_PLC_gamma_like', NULL, 'SH2_C-SH2_PLC_gamma_like', NULL, NULL, 20864, 2),
(13379, NULL, 'cd11341', NULL, NULL, 'AmyAc_Pullulanase_LD-like', NULL, 'AmyAc_Pullulanase_LD-like', NULL, NULL, NULL, 2),
(13380, NULL, 'cd09131', NULL, NULL, 'PLDc_unchar3', NULL, 'PLDc_unchar3', NULL, NULL, NULL, 2),
(13381, NULL, 'cd12491', NULL, NULL, 'RRM2_RBM47', NULL, 'RRM2_RBM47', NULL, NULL, 28193, 2),
(13382, NULL, 'cd19811', NULL, NULL, 'Bbox1_TRIM66', NULL, 'Bbox1_TRIM66', NULL, NULL, NULL, 2),
(13383, NULL, 'cd18429', NULL, NULL, 'M14_Nna1-like', NULL, 'M14_Nna1-like', NULL, NULL, NULL, 2),
(13384, NULL, 'cd16834', NULL, NULL, 'CNF1-like', NULL, 'CNF1-like', NULL, NULL, 8767, 2),
(13385, NULL, 'cd18433', NULL, NULL, 'BRCT_Rad4_rpt3', NULL, 'BRCT_Rad4_rpt3', NULL, NULL, NULL, 2),
(13386, NULL, 'cd18466', NULL, NULL, 'BACK_KLHL27_IPP', NULL, 'BACK_KLHL27_IPP', NULL, NULL, NULL, 2),
(13387, NULL, 'cd06960', NULL, NULL, 'NR_DBD_HNF4A', NULL, 'NR_DBD_HNF4A', NULL, NULL, NULL, 2),
(13388, NULL, 'cd15369', NULL, NULL, '7tmA_PAR1', NULL, '7tmA_PAR1', NULL, NULL, NULL, 2),
(13389, NULL, 'cd16524', NULL, NULL, 'RING-HC_NHL-1_like', NULL, 'RING-HC_NHL-1_like', NULL, NULL, NULL, 2),
(13390, NULL, 'cd18717', NULL, NULL, 'PIN_ScNmd4p-like', NULL, 'PIN_ScNmd4p-like', NULL, NULL, NULL, 2),
(13391, NULL, 'cd18119', NULL, NULL, 'ATP-synt_V_A-type_alpha_N', NULL, 'ATP-synt_V_A-type_alpha_N', NULL, NULL, NULL, 2),
(13392, NULL, 'cd11560', NULL, NULL, 'W2_eIF5C_like', NULL, 'W2_eIF5C_like', NULL, NULL, 34574, 2),
(13393, NULL, 'cd11985', NULL, NULL, 'SH3_Stac2_C', NULL, 'SH3_Stac2_C', NULL, NULL, 17988, 2),
(13394, NULL, 'cd09101', NULL, NULL, 'INPP5c_SHIP2-INPPL1', NULL, 'INPP5c_SHIP2-INPPL1', NULL, NULL, NULL, 2),
(13395, NULL, 'cd01671', NULL, NULL, 'CARD', NULL, 'CARD', NULL, NULL, NULL, 2),
(13396, NULL, 'cd00609', NULL, NULL, 'AAT_like', NULL, 'AAT_like', NULL, NULL, NULL, 2),
(13397, NULL, 'cd08466', NULL, NULL, 'PBP2_LeuO', NULL, 'PBP2_LeuO', NULL, NULL, NULL, 2),
(13398, NULL, 'cd09019', NULL, NULL, 'galactose_mutarotase_like', NULL, 'galactose_mutarotase_like', NULL, NULL, NULL, 2),
(13399, NULL, 'cd09595', NULL, NULL, 'M1', NULL, 'M1', NULL, NULL, NULL, 2),
(13400, NULL, 'cd02673', NULL, NULL, 'Peptidase_C19Q', NULL, 'Peptidase_C19Q', NULL, NULL, NULL, 2),
(13401, NULL, 'cd06644', NULL, NULL, 'STKc_STK10', NULL, 'STKc_STK10', NULL, NULL, 35013, 2),
(13402, NULL, 'cd01328', NULL, NULL, 'FSL_SPARC', NULL, 'FSL_SPARC', NULL, NULL, NULL, 2),
(13403, NULL, 'cd11012', NULL, NULL, 'CuRO_6_ceruloplasmin', NULL, 'CuRO_6_ceruloplasmin', NULL, NULL, NULL, 2),
(13404, NULL, 'cd12017', NULL, NULL, 'SH3_Tks_3', NULL, 'SH3_Tks_3', NULL, NULL, NULL, 2),
(13405, NULL, 'cd02974', NULL, NULL, 'AhpF_NTD_N', NULL, 'AhpF_NTD_N', NULL, NULL, 35110, 2),
(13406, NULL, 'cd05018', NULL, NULL, 'CoxG', NULL, 'CoxG', NULL, NULL, 9220, 2),
(13407, NULL, 'cd13192', NULL, NULL, 'FERM_C_FRMD3_FRMD5', NULL, 'FERM_C_FRMD3_FRMD5', NULL, NULL, NULL, 2),
(13408, NULL, 'cd09520', NULL, NULL, 'SAM_BICC1', NULL, 'SAM_BICC1', NULL, NULL, 32089, 2),
(13409, NULL, 'cd10004', NULL, NULL, 'RPD3-like', NULL, 'RPD3-like', NULL, NULL, NULL, 2),
(13410, NULL, 'cd17140', NULL, NULL, 'DCX1_DCLK1', NULL, 'DCX1_DCLK1', NULL, NULL, NULL, 2); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(13411, NULL, 'cd02166', NULL, NULL, 'NMNAT_Archaea', NULL, 'NMNAT_Archaea', NULL, NULL, 6696, 2),
(13412, NULL, 'cd12049', NULL, NULL, 'SH3_DOCK4_B', NULL, 'SH3_DOCK4_B', NULL, NULL, 31782, 2),
(13413, NULL, 'cd15654', NULL, NULL, 'PHD3_NSD2', NULL, 'PHD3_NSD2', NULL, NULL, NULL, 2),
(13414, NULL, 'cd03512', NULL, NULL, 'Alkane-hydroxylase', NULL, 'Alkane-hydroxylase', NULL, NULL, 29135, 2),
(13415, NULL, 'cd16080', NULL, NULL, 'TSP-4cc', NULL, 'TSP-4cc', NULL, NULL, NULL, 2),
(13416, NULL, 'cd05821', NULL, NULL, 'TLP_Transthyretin', NULL, 'TLP_Transthyretin', NULL, NULL, NULL, 2),
(13417, NULL, 'cd03527', NULL, NULL, 'RuBisCO_small', NULL, 'RuBisCO_small', NULL, NULL, 3362, 2),
(13418, NULL, 'cd16094', NULL, NULL, 'IgC_CH3_IgD', NULL, 'IgC_CH3_IgD', NULL, NULL, NULL, 2),
(13419, NULL, 'cd16460', NULL, NULL, 'RING-H2_DZIP3', NULL, 'RING-H2_DZIP3', NULL, NULL, NULL, 2),
(13420, NULL, 'cd06583', NULL, NULL, 'PGRP', NULL, 'PGRP', NULL, NULL, 994, 2),
(13421, NULL, 'cd09709', NULL, NULL, 'Csc2_I-D', NULL, 'Csc2_I-D', NULL, NULL, NULL, 2),
(13422, NULL, 'cd03526', NULL, NULL, 'SQR_QFR_TypeB_TM', NULL, 'SQR_QFR_TypeB_TM', NULL, NULL, NULL, 2),
(13423, NULL, 'cd05284', NULL, NULL, 'arabinose_DH_like', NULL, 'arabinose_DH_like', NULL, NULL, NULL, 2),
(13424, NULL, 'cd19586', NULL, NULL, 'serpin_mimivirus', NULL, 'serpin_mimivirus', NULL, NULL, NULL, 2),
(13425, NULL, 'cd18606', NULL, NULL, 'ABC_6TM_YOR1_D2_like', NULL, 'ABC_6TM_YOR1_D2_like', NULL, NULL, NULL, 2),
(13426, NULL, 'cd04044', NULL, NULL, 'C2A_Tricalbin-like', NULL, 'C2A_Tricalbin-like', NULL, NULL, 32627, 2),
(13427, NULL, 'cd00286', NULL, NULL, 'Tubulin_FtsZ_Cetz-like', NULL, 'Tubulin_FtsZ_Cetz-like', NULL, NULL, NULL, 2),
(13428, NULL, 'cd04042', NULL, NULL, 'C2A_MCTP_PRT', NULL, 'C2A_MCTP_PRT', NULL, NULL, NULL, 2),
(13429, NULL, 'cd17750', NULL, NULL, 'BRCT_SLF1', NULL, 'BRCT_SLF1', NULL, NULL, NULL, 2),
(13430, NULL, 'cd00442', NULL, NULL, 'Lyz-like', NULL, 'Lyz-like', NULL, NULL, NULL, 2),
(13431, NULL, 'cd08989', NULL, NULL, 'GH43_XYL-like', NULL, 'GH43_XYL-like', NULL, NULL, NULL, 2),
(13432, NULL, 'cd15299', NULL, NULL, '7tmA_mAChR_M3', NULL, '7tmA_mAChR_M3', NULL, NULL, NULL, 2),
(13433, NULL, 'cd01271', NULL, NULL, 'PTB2_Fe65', NULL, 'PTB2_Fe65', NULL, NULL, NULL, 2),
(13434, NULL, 'cd16452', NULL, NULL, 'SP-RING_like', NULL, 'SP-RING_like', NULL, NULL, NULL, 2),
(13435, NULL, 'cd15579', NULL, NULL, 'PHD1_PHF19', NULL, 'PHD1_PHF19', NULL, NULL, NULL, 2),
(13436, NULL, 'cd01544', NULL, NULL, 'PBP1_GalR', NULL, 'PBP1_GalR', NULL, NULL, NULL, 2),
(13437, NULL, 'cd04164', NULL, NULL, 'trmE', NULL, 'trmE', NULL, NULL, 25805, 2),
(13438, NULL, 'cd11716', NULL, NULL, 'THUMP_ThiI', NULL, 'THUMP_ThiI', NULL, NULL, NULL, 2),
(13439, NULL, 'cd02998', NULL, NULL, 'PDI_a_ERp38', NULL, 'PDI_a_ERp38', NULL, NULL, NULL, 2),
(13440, NULL, 'cd12717', NULL, NULL, 'RRM_ETP1', NULL, 'RRM_ETP1', NULL, NULL, 29088, 2),
(13441, NULL, 'cd19378', NULL, NULL, 'TGF_beta_DAF7', NULL, 'TGF_beta_DAF7', NULL, NULL, NULL, 2),
(13442, NULL, 'cd00934', NULL, NULL, 'PTB', NULL, 'PTB', NULL, NULL, NULL, 2),
(13443, NULL, 'cd03152', NULL, NULL, 'CD9_LEL', NULL, 'CD9_LEL', NULL, NULL, 31352, 2),
(13444, NULL, 'cd03146', NULL, NULL, 'GAT1_Peptidase_E', NULL, 'GAT1_Peptidase_E', NULL, NULL, 5884, 2),
(13445, NULL, 'cd17944', NULL, NULL, 'DEADc_DDX21_DDX50', NULL, 'DEADc_DDX21_DDX50', NULL, NULL, NULL, 2),
(13446, NULL, 'cd00938', NULL, NULL, 'HisRS_RNA', NULL, 'HisRS_RNA', NULL, NULL, NULL, 2),
(13447, NULL, 'cd17097', NULL, NULL, 'FERM_F1_ERM_like', NULL, 'FERM_F1_ERM_like', NULL, NULL, NULL, 2),
(13448, NULL, 'cd14979', NULL, NULL, '7tmA_NTSR-like', NULL, '7tmA_NTSR-like', NULL, NULL, NULL, 2),
(13449, NULL, 'cd07595', NULL, NULL, 'BAR_RhoGAP_Rich-like', NULL, 'BAR_RhoGAP_Rich-like', NULL, NULL, NULL, 2),
(13450, NULL, 'cd06225', NULL, NULL, 'HAMP', NULL, 'HAMP', NULL, NULL, NULL, 2),
(13451, NULL, 'cd17496', NULL, NULL, 'RMtype1_S_BliBORF2384P-TRD1-CR1_like', NULL, 'RMtype1_S_BliBORF2384P-TRD1-CR1_like', NULL, NULL, NULL, 2),
(13452, NULL, 'cd18893', NULL, NULL, 'TET-like', NULL, 'TET-like', NULL, NULL, NULL, 2); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(13453, NULL, 'cd19597', NULL, NULL, 'serpin28D-like_insects', NULL, 'serpin28D-like_insects', NULL, NULL, NULL, 2),
(13454, NULL, 'cd05903', NULL, NULL, 'CHC_CoA_lg', NULL, 'CHC_CoA_lg', NULL, NULL, NULL, 2),
(13455, NULL, 'cd05381', NULL, NULL, 'CAP_PR-1', NULL, 'CAP_PR-1', NULL, NULL, NULL, 2),
(13456, NULL, 'cd00877', NULL, NULL, 'Ran', NULL, 'Ran', NULL, NULL, NULL, 2),
(13457, NULL, 'cd02681', NULL, NULL, 'MIT_calpain7_1', NULL, 'MIT_calpain7_1', NULL, NULL, NULL, 2),
(13458, NULL, 'cd19765', NULL, NULL, 'Bbox2_TRIM10-like', NULL, 'Bbox2_TRIM10-like', NULL, NULL, NULL, 2),
(13459, NULL, 'cd00126', NULL, NULL, 'PAH', NULL, 'PAH', NULL, NULL, 2149, 2),
(13460, NULL, 'cd17387', NULL, NULL, 'MFS_MFSD14', NULL, 'MFS_MFSD14', NULL, NULL, NULL, 2),
(13461, NULL, 'cd06358', NULL, NULL, 'PBP1_NHase', NULL, 'PBP1_NHase', NULL, NULL, NULL, 2),
(13462, NULL, 'cd11650', NULL, NULL, 'AT4G37440_like', NULL, 'AT4G37440_like', NULL, NULL, 31603, 2),
(13463, NULL, 'cd13413', NULL, NULL, 'TNFRSF12A', NULL, 'TNFRSF12A', NULL, NULL, 15723, 2),
(13464, NULL, 'cd06529', NULL, NULL, 'S24_LexA-like', NULL, 'S24_LexA-like', NULL, NULL, 27864, 2),
(13465, NULL, 'cd07299', NULL, NULL, 'PX_TCGAP', NULL, 'PX_TCGAP', NULL, NULL, NULL, 2),
(13466, NULL, 'cd07701', NULL, NULL, 'Ig1_Necl-3', NULL, 'Ig1_Necl-3', NULL, NULL, NULL, 2),
(13467, NULL, 'cd11268', NULL, NULL, 'Sema_6C', NULL, 'Sema_6C', NULL, NULL, NULL, 2),
(13468, NULL, 'cd09611', NULL, NULL, 'Jacalin_ZG16_like', NULL, 'Jacalin_ZG16_like', NULL, NULL, NULL, 2),
(13469, NULL, 'cd13273', NULL, NULL, 'PH_SWAP-70', NULL, 'PH_SWAP-70', NULL, NULL, NULL, 2),
(13470, NULL, 'cd13932', NULL, NULL, 'HN_RTEL1', NULL, 'HN_RTEL1', NULL, NULL, NULL, 2),
(13471, NULL, 'cd15766', NULL, NULL, 'FYVE_Slp5', NULL, 'FYVE_Slp5', NULL, NULL, 35064, 2),
(13472, NULL, 'cd04865', NULL, NULL, 'LigD_Pol_like_2', NULL, 'LigD_Pol_like_2', NULL, NULL, NULL, 2),
(13473, NULL, 'cd06433', NULL, NULL, 'GT_2_WfgS_like', NULL, 'GT_2_WfgS_like', NULL, NULL, NULL, 2),
(13474, NULL, 'cd08563', NULL, NULL, 'GDPD_TtGDE_like', NULL, 'GDPD_TtGDE_like', NULL, NULL, NULL, 2),
(13475, NULL, 'cd15717', NULL, NULL, 'FYVE_PKHF', NULL, 'FYVE_PKHF', NULL, NULL, NULL, 2),
(13476, NULL, 'cd14376', NULL, NULL, 'CUE_AUP1_AMFR_like', NULL, 'CUE_AUP1_AMFR_like', NULL, NULL, NULL, 2),
(13477, NULL, 'cd12541', NULL, NULL, 'RRM2_La', NULL, 'RRM2_La', NULL, NULL, NULL, 2),
(13478, NULL, 'cd18603', NULL, NULL, 'ABC_6TM_MRP1_2_3_6_D2_like', NULL, 'ABC_6TM_MRP1_2_3_6_D2_like', NULL, NULL, NULL, 2),
(13479, NULL, 'cd03038', NULL, NULL, 'GST_N_etherase_LigE', NULL, 'GST_N_etherase_LigE', NULL, NULL, NULL, 2),
(13480, NULL, 'cd12435', NULL, NULL, 'RRM_GW182_like', NULL, 'RRM_GW182_like', NULL, NULL, NULL, 2),
(13481, NULL, 'cd07694', NULL, NULL, 'Ig2_CD4', NULL, 'Ig2_CD4', NULL, NULL, NULL, 2),
(13482, NULL, 'cd19955', NULL, NULL, 'serpin48-like_insects', NULL, 'serpin48-like_insects', NULL, NULL, NULL, 2),
(13483, NULL, 'cd18408', NULL, NULL, 'BTB_POZ_KCNA7', NULL, 'BTB_POZ_KCNA7', NULL, NULL, NULL, 2),
(13484, NULL, 'cd17516', NULL, NULL, 'RMtype1_S_HinAWORF1578P-TRD2-CR2_like', NULL, 'RMtype1_S_HinAWORF1578P-TRD2-CR2_like', NULL, NULL, NULL, 2),
(13485, NULL, 'cd12934', NULL, NULL, 'LEM', NULL, 'LEM', NULL, NULL, NULL, 2),
(13486, NULL, 'cd02163', NULL, NULL, 'PPAT', NULL, 'PPAT', NULL, NULL, 4360, 2),
(13487, NULL, 'cd13173', NULL, NULL, 'RanBD3_RanBP2_insect-like', NULL, 'RanBD3_RanBP2_insect-like', NULL, NULL, NULL, 2),
(13488, NULL, 'cd07814', NULL, NULL, 'SRPBCC_CalC_Aha1-like', NULL, 'SRPBCC_CalC_Aha1-like', NULL, NULL, NULL, 2),
(13489, NULL, 'cd11849', NULL, NULL, 'SH3_SPIN90', NULL, 'SH3_SPIN90', NULL, NULL, 27553, 2),
(13490, NULL, 'cd13853', NULL, NULL, 'CuRO_1_Tth-MCO_like', NULL, 'CuRO_1_Tth-MCO_like', NULL, NULL, NULL, 2),
(13491, NULL, 'cd14105', NULL, NULL, 'STKc_DAPK', NULL, 'STKc_DAPK', NULL, NULL, 35955, 2),
(13492, NULL, 'cd19588', NULL, NULL, 'serpin_miropin-like', NULL, 'serpin_miropin-like', NULL, NULL, NULL, 2),
(13493, NULL, 'cd09748', NULL, NULL, 'Cmr3_III-B', NULL, 'Cmr3_III-B', NULL, NULL, NULL, 2);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(13494, NULL, 'cd09336', NULL, NULL, 'LIM1_Paxillin_like', NULL, 'LIM1_Paxillin_like', NULL, NULL, NULL, 2),
(13495, NULL, 'cd18235', NULL, NULL, 'BTB_POZ_KLHL2-like', NULL, 'BTB_POZ_KLHL2-like', NULL, NULL, NULL, 2),
(13496, NULL, 'cd20309', NULL, NULL, 'cupin_EcSI', NULL, 'cupin_EcSI', NULL, NULL, NULL, 2),
(13497, NULL, 'cd01438', NULL, NULL, 'tankyrase_like', NULL, 'tankyrase_like', NULL, NULL, NULL, 2),
(13498, NULL, 'cd18939', NULL, NULL, 'bHLH_TS_Msgn1', NULL, 'bHLH_TS_Msgn1', NULL, NULL, NULL, 2),
(13499, NULL, 'cd16450', NULL, NULL, 'mRING-C3HGC3_RFWD3', NULL, 'mRING-C3HGC3_RFWD3', NULL, NULL, NULL, 2),
(13500, NULL, 'cd06928', NULL, NULL, 'RNAP_alpha_NTD', NULL, 'RNAP_alpha_NTD', NULL, NULL, NULL, 2),
(13501, NULL, 'cd14749', NULL, NULL, 'PBP2_XBP1_like', NULL, 'PBP2_XBP1_like', NULL, NULL, NULL, 2),
(13502, NULL, 'cd01683', NULL, NULL, 'EF2_IV_snRNP', NULL, 'EF2_IV_snRNP', NULL, NULL, NULL, 2),
(13503, NULL, 'cd15159', NULL, NULL, '7tmA_EBI2', NULL, '7tmA_EBI2', NULL, NULL, NULL, 2),
(13504, NULL, 'cd11725', NULL, NULL, 'ADDz_Dnmt3', NULL, 'ADDz_Dnmt3', NULL, NULL, NULL, 2),
(13505, NULL, 'cd07255', NULL, NULL, 'VOC_BsCatE_like_N', NULL, 'VOC_BsCatE_like_N', NULL, NULL, NULL, 2),
(13506, NULL, 'cd01459', NULL, NULL, 'vWA_copine_like', NULL, 'vWA_copine_like', NULL, NULL, 9710, 2),
(13507, NULL, 'cd03792', NULL, NULL, 'GT4_trehalose_phosphorylase', NULL, 'GT4_trehalose_phosphorylase', NULL, NULL, NULL, 2),
(13508, NULL, 'cd00167', NULL, NULL, 'SANT', NULL, 'SANT', NULL, NULL, 4393, 2),
(13509, NULL, 'cd05359', NULL, NULL, 'ChcA_like_SDR_c', NULL, 'ChcA_like_SDR_c', NULL, NULL, NULL, 2),
(13510, NULL, 'cd06182', NULL, NULL, 'CYPOR_like', NULL, 'CYPOR_like', NULL, NULL, NULL, 2),
(13511, NULL, 'cd12287', NULL, NULL, 'RRM_U2AF35_like', NULL, 'RRM_U2AF35_like', NULL, NULL, NULL, 2),
(13512, NULL, 'cd13543', NULL, NULL, 'PBP2_Fbp', NULL, 'PBP2_Fbp', NULL, NULL, NULL, 2),
(13513, NULL, 'cd15778', NULL, NULL, 'Lreu_0056_like', NULL, 'Lreu_0056_like', NULL, NULL, NULL, 2),
(13514, NULL, 'cd17573', NULL, NULL, 'REC_HP-RR-like', NULL, 'REC_HP-RR-like', NULL, NULL, NULL, 2),
(13515, NULL, 'cd12333', NULL, NULL, 'RRM2_p54nrb_like', NULL, 'RRM2_p54nrb_like', NULL, NULL, NULL, 2),
(13516, NULL, 'cd17907', NULL, NULL, 'FliY_FliN-Y', NULL, 'FliY_FliN-Y', NULL, NULL, NULL, 2),
(13517, NULL, 'cd18752', NULL, NULL, 'PIN_VapC4-5_FitB-like', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, NULL, 2),
(13518, NULL, 'cd13592', NULL, NULL, 'PBP2_HisGL2', NULL, 'PBP2_HisGL2', NULL, NULL, NULL, 2),
(13519, NULL, 'cd01283', NULL, NULL, 'cytidine_deaminase', NULL, 'cytidine_deaminase', NULL, NULL, NULL, 2),
(13520, NULL, 'cd07668', NULL, NULL, 'BAR_SNX9', NULL, 'BAR_SNX9', NULL, NULL, 33311, 2),
(13521, NULL, 'cd18224', NULL, NULL, 'BTB_POZ_ZBTB39', NULL, 'BTB_POZ_ZBTB39', NULL, NULL, NULL, 2),
(13522, NULL, 'cd00756', NULL, NULL, 'MoaE', NULL, 'MoaE', NULL, NULL, 4313, 2),
(13523, NULL, 'cd17622', NULL, NULL, 'REC_OmpR_kpRstA-like', NULL, 'REC_OmpR_kpRstA-like', NULL, NULL, NULL, 2),
(13524, NULL, 'cd19897', NULL, NULL, 'DSRM_STRBP-like_rpt2', NULL, 'DSRM_STRBP-like_rpt2', NULL, NULL, NULL, 2),
(13525, NULL, 'cd03516', NULL, NULL, 'Link_domain_CD44_like', NULL, 'Link_domain_CD44_like', NULL, NULL, NULL, 2),
(13526, NULL, 'cd13522', NULL, NULL, 'PBP2_ABC_oligosaccharides', NULL, 'PBP2_ABC_oligosaccharides', NULL, NULL, NULL, 2),
(13527, NULL, 'cd04875', NULL, NULL, 'ACT_F4HF-DF', NULL, 'ACT_F4HF-DF', NULL, NULL, 36148, 2),
(13528, NULL, 'cd16964', NULL, NULL, 'YqgF', NULL, 'YqgF', NULL, NULL, 11163, 2),
(13529, NULL, 'cd16181', NULL, NULL, 'EFh_PEF_Group_II_sorcin_like', NULL, 'EFh_PEF_Group_II_sorcin_like', NULL, NULL, NULL, 2),
(13530, NULL, 'cd04041', NULL, NULL, 'C2A_fungal', NULL, 'C2A_fungal', NULL, NULL, 33279, 2),
(13531, NULL, 'cd14317', NULL, NULL, 'UBA_DHX57', NULL, 'UBA_DHX57', NULL, NULL, 35451, 2),
(13532, NULL, 'cd14349', NULL, NULL, 'UBA_CF106', NULL, 'UBA_CF106', NULL, NULL, 33033, 2),
(13533, NULL, 'cd15495', NULL, NULL, 'PHD_ATX3_4_5_like', NULL, 'PHD_ATX3_4_5_like', NULL, NULL, 30228, 2);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(13534, NULL, 'cd03135', NULL, NULL, 'GATase1_DJ-1', NULL, 'GATase1_DJ-1', NULL, NULL, NULL, 2),
(13535, NULL, 'cd11254', NULL, NULL, 'Sema_3F', NULL, 'Sema_3F', NULL, NULL, NULL, 2),
(13536, NULL, 'cd04176', NULL, NULL, 'Rap2', NULL, 'Rap2', NULL, NULL, 30814, 2),
(13537, NULL, 'cd01739', NULL, NULL, 'LSm11_M', NULL, 'LSm11_M', NULL, NULL, 21447, 2),
(13538, NULL, 'cd06937', NULL, NULL, 'NR_LBD_RAR', NULL, 'NR_LBD_RAR', NULL, NULL, NULL, 2),
(13539, NULL, 'cd03357', NULL, NULL, 'LbH_MAT_GAT', NULL, 'LbH_MAT_GAT', NULL, NULL, NULL, 2),
(13540, NULL, 'cd12651', NULL, NULL, 'RRM2_SXL', NULL, 'RRM2_SXL', NULL, NULL, NULL, 2),
(13541, NULL, 'cd07462', NULL, NULL, 'CRD_FZ10', NULL, 'CRD_FZ10', NULL, NULL, NULL, 2),
(13542, NULL, 'cd16266', NULL, NULL, 'IF2_aeIF5B_IV', NULL, 'IF2_aeIF5B_IV', NULL, NULL, NULL, 2),
(13543, NULL, 'cd09426', NULL, NULL, 'LIM2_FHL2', NULL, 'LIM2_FHL2', NULL, NULL, NULL, 2),
(13544, NULL, 'cd13215', NULL, NULL, 'PH-GRAM1_AGT26', NULL, 'PH-GRAM1_AGT26', NULL, NULL, NULL, 2),
(13545, NULL, 'cd20287', NULL, NULL, 'cupin_pirin-like_N', NULL, 'cupin_pirin-like_N', NULL, NULL, NULL, 2),
(13546, NULL, 'cd00998', NULL, NULL, 'PBP2_iGluR_ligand_binding', NULL, 'PBP2_iGluR_ligand_binding', NULL, NULL, NULL, 2),
(13547, NULL, 'cd04736', NULL, NULL, 'MDH_FMN', NULL, 'MDH_FMN', NULL, NULL, NULL, 2),
(13548, NULL, 'cd12369', NULL, NULL, 'RRM4_RBM45', NULL, 'RRM4_RBM45', NULL, NULL, 20893, 2),
(13549, NULL, 'cd07359', NULL, NULL, 'PCA_45_Doxase_B_like', NULL, 'PCA_45_Doxase_B_like', NULL, NULL, NULL, 2),
(13550, NULL, 'cd08926', NULL, NULL, 'Mb', NULL, 'Mb', NULL, NULL, NULL, 2),
(13551, NULL, 'cd00630', NULL, NULL, 'RNAP_largest_subunit_C', NULL, 'RNAP_largest_subunit_C', NULL, NULL, NULL, 2),
(13552, NULL, 'cd04212', NULL, NULL, 'CuRO_UO_II', NULL, 'CuRO_UO_II', NULL, NULL, 18011, 2),
(13553, NULL, 'cd07892', NULL, NULL, 'PolyPPase_VTC2-3_like', NULL, 'PolyPPase_VTC2-3_like', NULL, NULL, NULL, 2),
(13554, NULL, 'cd10225', NULL, NULL, 'MreB_like', NULL, 'MreB_like', NULL, NULL, 5416, 2),
(13555, NULL, 'cd06548', NULL, NULL, 'GH18_chitinase', NULL, 'GH18_chitinase', NULL, NULL, NULL, 2),
(13556, NULL, 'cd08256', NULL, NULL, 'Zn_ADH2', NULL, 'Zn_ADH2', NULL, NULL, NULL, 2),
(13557, NULL, 'cd06453', NULL, NULL, 'SufS_like', NULL, 'SufS_like', NULL, NULL, 2389, 2),
(13558, NULL, 'cd13699', NULL, NULL, 'PBP2_OccT_like', NULL, 'PBP2_OccT_like', NULL, NULL, NULL, 2),
(13559, NULL, 'cd02870', NULL, NULL, 'PseudoU_synth_RsuA_like', NULL, 'PseudoU_synth_RsuA_like', NULL, NULL, NULL, 2),
(13560, NULL, 'cd03748', NULL, NULL, 'Ntn_PGA', NULL, 'Ntn_PGA', NULL, NULL, 29286, 2),
(13561, NULL, 'cd01341', NULL, NULL, 'ADP_ribosyl', NULL, 'ADP_ribosyl', NULL, NULL, NULL, 2),
(13562, NULL, 'cd12387', NULL, NULL, 'RRM3_hnRNPM_like', NULL, 'RRM3_hnRNPM_like', NULL, NULL, NULL, 2),
(13563, NULL, 'cd16272', NULL, NULL, 'RNaseZ_MBL-fold', NULL, 'RNaseZ_MBL-fold', NULL, NULL, NULL, 2),
(13564, NULL, 'cd01489', NULL, NULL, 'Uba2_SUMO', NULL, 'Uba2_SUMO', NULL, NULL, NULL, 2),
(13565, NULL, 'cd14283', NULL, NULL, 'UBA_TNR6C', NULL, 'UBA_TNR6C', NULL, NULL, 30052, 2),
(13566, NULL, 'cd16779', NULL, NULL, 'mRING-HC-C3HC3D_LNX1', NULL, 'mRING-HC-C3HC3D_LNX1', NULL, NULL, NULL, 2),
(13567, NULL, 'cd14602', NULL, NULL, 'PTPc-N22', NULL, 'PTPc-N22', NULL, NULL, NULL, 2),
(13568, NULL, 'cd03771', NULL, NULL, 'MATH_Meprin', NULL, 'MATH_Meprin', NULL, NULL, NULL, 2),
(13569, NULL, 'cd09898', NULL, NULL, 'H3TH_53EXO', NULL, 'H3TH_53EXO', NULL, NULL, 15626, 2),
(13570, NULL, 'cd14678', NULL, NULL, 'PH_DOK4_DOK5_DOK6', NULL, 'PH_DOK4_DOK5_DOK6', NULL, NULL, 31626, 2),
(13571, NULL, 'cd09530', NULL, NULL, 'SAM_Samd14', NULL, 'SAM_Samd14', NULL, NULL, NULL, 2),
(13572, NULL, 'cd04379', NULL, NULL, 'RhoGAP_SYD1', NULL, 'RhoGAP_SYD1', NULL, NULL, NULL, 2),
(13573, NULL, 'cd09078', NULL, NULL, 'nSMase', NULL, 'nSMase', NULL, NULL, 18749, 2),
(13574, NULL, 'cd07069', NULL, NULL, 'NR_LBD_Lrh-1', NULL, 'NR_LBD_Lrh-1', NULL, NULL, NULL, 2),
(13575, NULL, 'cd09351', NULL, NULL, 'LIM1_LPP', NULL, 'LIM1_LPP', NULL, NULL, NULL, 2);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(13576, NULL, 'cd09511', NULL, NULL, 'SAM_CNK1,2,3-suppressor', NULL, 'SAM_CNK1,2,3-suppressor', NULL, NULL, NULL, 2),
(13577, NULL, 'cd17175', NULL, NULL, 'FERM_F0_SHANK1', NULL, 'FERM_F0_SHANK1', NULL, NULL, NULL, 2),
(13578, NULL, 'cd05771', NULL, NULL, 'IgC_Tapasin_R', NULL, 'IgC_Tapasin_R', NULL, NULL, NULL, 2),
(13579, NULL, 'cd15517', NULL, NULL, 'PHD_TCF19_like', NULL, 'PHD_TCF19_like', NULL, NULL, NULL, 2),
(13580, NULL, 'cd02999', NULL, NULL, 'PDI_a_ERp44_like', NULL, 'PDI_a_ERp44_like', NULL, NULL, NULL, 2),
(13581, NULL, 'cd11382', NULL, NULL, 'Ribosomal_S8e', NULL, 'Ribosomal_S8e', NULL, NULL, NULL, 2),
(13582, NULL, 'cd14318', NULL, NULL, 'UBA_Cbl_like', NULL, 'UBA_Cbl_like', NULL, NULL, NULL, 2),
(13583, NULL, 'cd03761', NULL, NULL, 'proteasome_beta_type_5', NULL, 'proteasome_beta_type_5', NULL, NULL, NULL, 2),
(13584, NULL, 'cd15284', NULL, NULL, '7tmC_mGluR_group2', NULL, '7tmC_mGluR_group2', NULL, NULL, NULL, 2),
(13585, NULL, 'cd15472', NULL, NULL, 'Myo5p-like_CBD_Rasip1', NULL, 'Myo5p-like_CBD_Rasip1', NULL, NULL, 27280, 2),
(13586, NULL, 'cd15631', NULL, NULL, 'PHD_PHF23', NULL, 'PHD_PHF23', NULL, NULL, NULL, 2),
(13587, NULL, 'cd09121', NULL, NULL, 'PLDc_DNaseII_2', NULL, 'PLDc_DNaseII_2', NULL, NULL, NULL, 2),
(13588, NULL, 'cd00405', NULL, NULL, 'PRAI', NULL, 'PRAI', NULL, NULL, 2448, 2),
(13589, NULL, 'cd03863', NULL, NULL, 'M14_CPD_II', NULL, 'M14_CPD_II', NULL, NULL, 32883, 2),
(13590, NULL, 'cd12636', NULL, NULL, 'RRM2_Bruno_like', NULL, 'RRM2_Bruno_like', NULL, NULL, NULL, 2),
(13591, NULL, 'cd16737', NULL, NULL, 'RING-HC_PCGF5', NULL, 'RING-HC_PCGF5', NULL, NULL, NULL, 2),
(13592, NULL, 'cd07364', NULL, NULL, 'PCA_45_Dioxygenase_B', NULL, 'PCA_45_Dioxygenase_B', NULL, NULL, 29266, 2),
(13593, NULL, 'cd18534', NULL, NULL, 'DSP_plant_IBR5-like', NULL, 'DSP_plant_IBR5-like', NULL, NULL, NULL, 2),
(13594, NULL, 'cd00202', NULL, NULL, 'ZnF_GATA', NULL, 'ZnF_GATA', NULL, NULL, 3606, 2),
(13595, NULL, 'cd04277', NULL, NULL, 'ZnMc_serralysin_like', NULL, 'ZnMc_serralysin_like', NULL, NULL, 13399, 2),
(13596, NULL, 'cd12283', NULL, NULL, 'RRM1_RBM39_like', NULL, 'RRM1_RBM39_like', NULL, NULL, NULL, 2),
(13597, NULL, 'cd09815', NULL, NULL, 'TP_methylase', NULL, 'TP_methylase', NULL, NULL, NULL, 2),
(13598, NULL, 'cd17403', NULL, NULL, 'MFS_SLCO4_OATP4', NULL, 'MFS_SLCO4_OATP4', NULL, NULL, NULL, 2),
(13599, NULL, 'cd15824', NULL, NULL, 'SPRY_PRY_TRIM22', NULL, 'SPRY_PRY_TRIM22', NULL, NULL, 31080, 2),
(13600, NULL, 'cd13934', NULL, NULL, 'RNase_H_Dikarya_like', NULL, 'RNase_H_Dikarya_like', NULL, NULL, NULL, 2),
(13601, NULL, 'cd18461', NULL, NULL, 'BACK_KLHL22', NULL, 'BACK_KLHL22', NULL, NULL, NULL, 2),
(13602, NULL, 'cd05163', NULL, NULL, 'PIKK_TRRAP', NULL, 'PIKK_TRRAP', NULL, NULL, NULL, 2),
(13603, NULL, 'cd03118', NULL, NULL, 'alpha_CA_V', NULL, 'alpha_CA_V', NULL, NULL, NULL, 2),
(13604, NULL, 'cd05682', NULL, NULL, 'M20_dipept_dapE', NULL, 'M20_dipept_dapE', NULL, NULL, NULL, 2),
(13605, NULL, 'cd15100', NULL, NULL, '7tmA_GPR3_GPR6_GPR12-like', NULL, '7tmA_GPR3_GPR6_GPR12-like', NULL, NULL, NULL, 2),
(13606, NULL, 'cd11372', NULL, NULL, 'RNase_PH_RRP46', NULL, 'RNase_PH_RRP46', NULL, NULL, NULL, 2),
(13607, NULL, 'cd03508', NULL, NULL, 'Delta4-sphingolipid-FADS-like', NULL, 'Delta4-sphingolipid-FADS-like', NULL, NULL, 14741, 2),
(13608, NULL, 'cd06920', NULL, NULL, 'NEAT', NULL, 'NEAT', NULL, NULL, 1008, 2),
(13609, NULL, 'cd07349', NULL, NULL, 'NR_LBD_SHP', NULL, 'NR_LBD_SHP', NULL, NULL, NULL, 2),
(13610, NULL, 'cd12913', NULL, NULL, 'PDC1_MCP_like', NULL, 'PDC1_MCP_like', NULL, NULL, NULL, 2),
(13611, NULL, 'cd04497', NULL, NULL, 'hPOT1_OB1_like', NULL, 'hPOT1_OB1_like', NULL, NULL, NULL, 2),
(13612, NULL, 'cd05134', NULL, NULL, 'RasGAP_RASA3', NULL, 'RasGAP_RASA3', NULL, NULL, NULL, 2),
(13613, NULL, 'cd16268', NULL, NULL, 'EF2_II', NULL, 'EF2_II', NULL, NULL, NULL, 2),
(13614, NULL, 'cd20000', NULL, NULL, 'PBP1_ABC_rhamnose', NULL, 'PBP1_ABC_rhamnose', NULL, NULL, NULL, 2),
(13615, NULL, 'cd07660', NULL, NULL, 'BAR_Arfaptin', NULL, 'BAR_Arfaptin', NULL, NULL, NULL, 2);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(13616, NULL, 'cd08461', NULL, NULL, 'PBP2_DntR_like_3', NULL, 'PBP2_DntR_like_3', NULL, NULL, NULL, 2),
(13617, NULL, 'cd18396', NULL, NULL, 'BTB_POZ_KCTD8', NULL, 'BTB_POZ_KCTD8', NULL, NULL, NULL, 2),
(13618, NULL, 'cd15743', NULL, NULL, 'FYVE_FGD6', NULL, 'FYVE_FGD6', NULL, NULL, NULL, 2),
(13619, NULL, 'cd08928', NULL, NULL, 'KR_fFAS_like_SDR_c_like', NULL, 'KR_fFAS_like_SDR_c_like', NULL, NULL, NULL, 2),
(13620, NULL, 'cd02753', NULL, NULL, 'MopB_Formate-Dh-H', NULL, 'MopB_Formate-Dh-H', NULL, NULL, 30945, 2),
(13621, NULL, 'cd09865', NULL, NULL, 'PIN_ScUtp23p-like', NULL, 'PIN_ScUtp23p-like', NULL, NULL, NULL, 2),
(13622, NULL, 'cd08633', NULL, NULL, 'PI-PLCc_eta2', NULL, 'PI-PLCc_eta2', NULL, NULL, NULL, 2),
(13623, NULL, 'cd08343', NULL, NULL, 'ED_TypeI_classII_C', NULL, 'ED_TypeI_classII_C', NULL, NULL, NULL, 2),
(13624, NULL, 'cd13989', NULL, NULL, 'STKc_IKK', NULL, 'STKc_IKK', NULL, NULL, NULL, 2),
(13625, NULL, 'cd08708', NULL, NULL, 'RGS_FLBA', NULL, 'RGS_FLBA', NULL, NULL, NULL, 2),
(13626, NULL, 'cd04260', NULL, NULL, 'AAK_AKi-DapG-BS', NULL, 'AAK_AKi-DapG-BS', NULL, NULL, NULL, 2),
(13627, NULL, 'cd07446', NULL, NULL, 'CRD_SFRP2', NULL, 'CRD_SFRP2', NULL, NULL, 30281, 2),
(13628, NULL, 'cd00366', NULL, NULL, 'FGGY', NULL, 'FGGY', NULL, NULL, NULL, 2),
(13629, NULL, 'cd11561', NULL, NULL, 'W2_eIF5', NULL, 'W2_eIF5', NULL, NULL, NULL, 2),
(13630, NULL, 'cd16246', NULL, NULL, 'EFh_DMD', NULL, 'EFh_DMD', NULL, NULL, NULL, 2),
(13631, NULL, 'cd16344', NULL, NULL, 'LMWPAP', NULL, 'LMWPAP', NULL, NULL, NULL, 2),
(13632, NULL, 'cd00592', NULL, NULL, 'HTH_MerR-like', NULL, 'HTH_MerR-like', NULL, NULL, NULL, 2),
(13633, NULL, 'cd13117', NULL, NULL, 'POLO_box_2', NULL, 'POLO_box_2', NULL, NULL, 33394, 2),
(13634, NULL, 'cd12249', NULL, NULL, 'RRM1_hnRNPR_like', NULL, 'RRM1_hnRNPR_like', NULL, NULL, NULL, 2),
(13635, NULL, 'cd18617', NULL, NULL, 'GH43_XynB-like', NULL, 'GH43_XynB-like', NULL, NULL, NULL, 2),
(13636, NULL, 'cd11442', NULL, NULL, 'bHLH_AtPRE_like', NULL, 'bHLH_AtPRE_like', NULL, NULL, NULL, 2),
(13637, NULL, 'cd03012', NULL, NULL, 'TlpA_like_DipZ_like', NULL, 'TlpA_like_DipZ_like', NULL, NULL, NULL, 2),
(13638, NULL, 'cd05289', NULL, NULL, 'MDR_like_2', NULL, 'MDR_like_2', NULL, NULL, NULL, 2),
(13639, NULL, 'cd11926', NULL, NULL, 'SH3_SH3RF1_3', NULL, 'SH3_SH3RF1_3', NULL, NULL, NULL, 2),
(13640, NULL, 'cd14161', NULL, NULL, 'STKc_NUAK2', NULL, 'STKc_NUAK2', NULL, NULL, NULL, 2),
(13641, NULL, 'cd06088', NULL, NULL, 'KOW_RPL14', NULL, 'KOW_RPL14', NULL, NULL, 30233, 2),
(13642, NULL, 'cd17223', NULL, NULL, 'RA_RASSF6', NULL, 'RA_RASSF6', NULL, NULL, NULL, 2),
(13643, NULL, 'cd02905', NULL, NULL, 'Macro_GDAP2-like', NULL, 'Macro_GDAP2-like', NULL, NULL, 32628, 2),
(13644, NULL, 'cd18472', NULL, NULL, 'BACK_KLHL33', NULL, 'BACK_KLHL33', NULL, NULL, NULL, 2),
(13645, NULL, 'cd07045', NULL, NULL, 'BMC_CcmK_like', NULL, 'BMC_CcmK_like', NULL, NULL, NULL, 2),
(13646, NULL, 'cd16696', NULL, NULL, 'RING-CH-C4HC3_NFX1', NULL, 'RING-CH-C4HC3_NFX1', NULL, NULL, NULL, 2),
(13647, NULL, 'cd08798', NULL, NULL, 'Death_NFkB2_p100', NULL, 'Death_NFkB2_p100', NULL, NULL, NULL, 2),
(13648, NULL, 'cd05722', NULL, NULL, 'Ig1_Neogenin', NULL, 'Ig1_Neogenin', NULL, NULL, NULL, 2),
(13649, NULL, 'cd05724', NULL, NULL, 'Ig2_Robo', NULL, 'Ig2_Robo', NULL, NULL, NULL, 2),
(13650, NULL, 'cd06955', NULL, NULL, 'NR_DBD_VDR', NULL, 'NR_DBD_VDR', NULL, NULL, 33565, 2),
(13651, NULL, 'cd08800', NULL, NULL, 'Death_UNC5A', NULL, 'Death_UNC5A', NULL, NULL, 33635, 2),
(13652, NULL, 'cd02247', NULL, NULL, 'cupin_pirin_C', NULL, 'cupin_pirin_C', NULL, NULL, NULL, 2),
(13653, NULL, 'cd06876', NULL, NULL, 'PX_MDM1p', NULL, 'PX_MDM1p', NULL, NULL, NULL, 2),
(13654, NULL, 'cd10237', NULL, NULL, 'HSPA13-like_NBD', NULL, 'HSPA13-like_NBD', NULL, NULL, 30239, 2),
(13655, NULL, 'cd10320', NULL, NULL, 'RGL4_N', NULL, 'RGL4_N', NULL, NULL, NULL, 2),
(13656, NULL, 'cd18685', NULL, NULL, 'PIN_VapC-like', NULL, 'PIN_VapC-like', NULL, NULL, NULL, 2),
(13657, NULL, 'cd14743', NULL, NULL, 'PAAR_CT_1', NULL, 'PAAR_CT_1', NULL, NULL, NULL, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(13658, NULL, 'cd17471', NULL, NULL, 'MFS_Set', NULL, 'MFS_Set', NULL, NULL, NULL, 2),
(13659, NULL, 'cd18019', NULL, NULL, 'DEXHc_Brr2_1', NULL, 'DEXHc_Brr2_1', NULL, NULL, NULL, 2),
(13660, NULL, 'cd09105', NULL, NULL, 'PLDc_vPLD1_2_like_2', NULL, 'PLDc_vPLD1_2_like_2', NULL, NULL, NULL, 2),
(13661, NULL, 'cd13714', NULL, NULL, 'PBP2_iGluR_Kainate', NULL, 'PBP2_iGluR_Kainate', NULL, NULL, NULL, 2),
(13662, NULL, 'cd13736', NULL, NULL, 'SPRY_PRY_TRIM25', NULL, 'SPRY_PRY_TRIM25', NULL, NULL, 34964, 2),
(13663, NULL, 'cd09423', NULL, NULL, 'LIM1_FHL3', NULL, 'LIM1_FHL3', NULL, NULL, NULL, 2),
(13664, NULL, 'cd09945', NULL, NULL, 'SH2_SHB_SHD_SHE_SHF_like', NULL, 'SH2_SHB_SHD_SHE_SHF_like', NULL, NULL, NULL, 2),
(13665, NULL, 'cd06155', NULL, NULL, 'eu_AANH_C_1', NULL, 'eu_AANH_C_1', NULL, NULL, NULL, 2),
(13666, NULL, 'cd08226', NULL, NULL, 'PK_STRAD_beta', NULL, 'PK_STRAD_beta', NULL, NULL, NULL, 2),
(13667, NULL, 'cd16117', NULL, NULL, 'UBX_UBXN4', NULL, 'UBX_UBXN4', NULL, NULL, NULL, 2),
(13668, NULL, 'cd18322', NULL, NULL, 'BTB_POZ_SKP1', NULL, 'BTB_POZ_SKP1', NULL, NULL, NULL, 2),
(13669, NULL, 'cd09461', NULL, NULL, 'LIM3_Enigma_like_1', NULL, 'LIM3_Enigma_like_1', NULL, NULL, NULL, 2),
(13670, NULL, 'cd01288', NULL, NULL, 'FabZ', NULL, 'FabZ', NULL, NULL, NULL, 2),
(13671, NULL, 'cd01619', NULL, NULL, 'LDH_like', NULL, 'LDH_like', NULL, NULL, NULL, 2),
(13672, NULL, 'cd03185', NULL, NULL, 'GST_C_Tau', NULL, 'GST_C_Tau', NULL, NULL, 36727, 2),
(13673, NULL, 'cd06387', NULL, NULL, 'PBP1_iGluR_AMPA_GluR3', NULL, 'PBP1_iGluR_AMPA_GluR3', NULL, NULL, NULL, 2),
(13674, NULL, 'cd14437', NULL, NULL, 'nt01cx_1156_like', NULL, 'nt01cx_1156_like', NULL, NULL, NULL, 2),
(13675, NULL, 'cd01811', NULL, NULL, 'Ubl1_OASL', NULL, 'Ubl1_OASL', NULL, NULL, NULL, 2),
(13676, NULL, 'cd11390', NULL, NULL, 'bHLH_TS', NULL, 'bHLH_TS', NULL, NULL, NULL, 2),
(13677, NULL, 'cd04847', NULL, NULL, 'Peptidases_S8_Subtilisin_like_2', NULL, 'Peptidases_S8_Subtilisin_like_2', NULL, NULL, 22264, 2),
(13678, NULL, 'cd19035', NULL, NULL, 'LGIC_ECD_GABAAR_A2', NULL, 'LGIC_ECD_GABAAR_A2', NULL, NULL, NULL, 2),
(13679, NULL, 'cd14703', NULL, NULL, 'bZIP_plant_RF2', NULL, 'bZIP_plant_RF2', NULL, NULL, 34230, 2),
(13680, NULL, 'cd06352', NULL, NULL, 'PBP1_NPR_GC-like', NULL, 'PBP1_NPR_GC-like', NULL, NULL, NULL, 2),
(13681, NULL, 'cd11795', NULL, NULL, 'SH3_DNMBP_N2', NULL, 'SH3_DNMBP_N2', NULL, NULL, 28925, 2),
(13682, NULL, 'cd11541', NULL, NULL, 'NTP-PPase_u4', NULL, 'NTP-PPase_u4', NULL, NULL, 14607, 2),
(13683, NULL, 'cd18085', NULL, NULL, 'TM1570-like', NULL, 'TM1570-like', NULL, NULL, 19224, 2),
(13684, NULL, 'cd11551', NULL, NULL, 'Serine_rich_CASS4', NULL, 'Serine_rich_CASS4', NULL, NULL, NULL, 2),
(13685, NULL, 'cd17467', NULL, NULL, 'T3SS_YscP_C', NULL, 'T3SS_YscP_C', NULL, NULL, NULL, 2),
(13686, NULL, 'cd17562', NULL, NULL, 'REC_CheY4-like', NULL, 'REC_CheY4-like', NULL, NULL, NULL, 2),
(13687, NULL, 'cd11488', NULL, NULL, 'SLC5sbd_SGLT4', NULL, 'SLC5sbd_SGLT4', NULL, NULL, NULL, 2),
(13688, NULL, 'cd05703', NULL, NULL, 'S1_Rrp5_repeat_hs12_sc9', NULL, 'S1_Rrp5_repeat_hs12_sc9', NULL, NULL, NULL, 2),
(13689, NULL, 'cd09442', NULL, NULL, 'LIM_Eplin_like', NULL, 'LIM_Eplin_like', NULL, NULL, NULL, 2),
(13690, NULL, 'cd16984', NULL, NULL, 'CID_Nrd1_like', NULL, 'CID_Nrd1_like', NULL, NULL, NULL, 2),
(13691, NULL, 'cd02929', NULL, NULL, 'TMADH_HD_FMN', NULL, 'TMADH_HD_FMN', NULL, NULL, 29285, 2),
(13692, NULL, 'cd12557', NULL, NULL, 'RRM3_RBM15', NULL, 'RRM3_RBM15', NULL, NULL, 12454, 2),
(13693, NULL, 'cd00429', NULL, NULL, 'RPE', NULL, 'RPE', NULL, NULL, 2990, 2),
(13694, NULL, 'cd19144', NULL, NULL, 'AKR_AKR13A1', NULL, 'AKR_AKR13A1', NULL, NULL, NULL, 2),
(13695, NULL, 'cd19915', NULL, NULL, 'DSRM_DRADA_rpt3', NULL, 'DSRM_DRADA_rpt3', NULL, NULL, 35444, 2),
(13696, NULL, 'cd13723', NULL, NULL, 'PBP2_iGluR_Kainate_GluR7', NULL, 'PBP2_iGluR_Kainate_GluR7', NULL, NULL, NULL, 2),
(13697, NULL, 'cd06910', NULL, NULL, 'M14_ASTE_ASPA-like', NULL, 'M14_ASTE_ASPA-like', NULL, NULL, NULL, 2),
(13698, NULL, 'cd21405', NULL, NULL, 'ZBD_av_Nsp10-like', NULL, 'ZBD_av_Nsp10-like', NULL, NULL, 26536, 2);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(13699, NULL, 'cd04599', NULL, NULL, 'CBS_pair_GGDEF_assoc', NULL, 'CBS_pair_GGDEF_assoc', NULL, NULL, NULL, 2),
(13700, NULL, 'cd12149', NULL, NULL, 'Flavi_E_C', NULL, 'Flavi_E_C', NULL, NULL, 21382, 2),
(13701, NULL, 'cd01394', NULL, NULL, 'radB', NULL, 'radB', NULL, NULL, NULL, 2),
(13702, NULL, 'cd20299', NULL, NULL, 'cupin_YP766765-like', NULL, 'cupin_YP766765-like', NULL, NULL, NULL, 2),
(13703, NULL, 'cd00861', NULL, NULL, 'ProRS_anticodon_short', NULL, 'ProRS_anticodon_short', NULL, NULL, 36478, 2),
(13704, NULL, 'cd16982', NULL, NULL, 'CID_Pcf11', NULL, 'CID_Pcf11', NULL, NULL, NULL, 2),
(13705, NULL, 'cd05664', NULL, NULL, 'M20_Acy1-like', NULL, 'M20_Acy1-like', NULL, NULL, NULL, 2),
(13706, NULL, 'cd08165', NULL, NULL, 'MPP_MPPE1', NULL, 'MPP_MPPE1', NULL, NULL, 33187, 2),
(13707, NULL, 'cd03521', NULL, NULL, 'Link_domain_KIAA0527_like', NULL, 'Link_domain_KIAA0527_like', NULL, NULL, 31836, 2),
(13708, NULL, 'cd05750', NULL, NULL, 'Ig_Pro_neuregulin', NULL, 'Ig_Pro_neuregulin', NULL, NULL, NULL, 2),
(13709, NULL, 'cd06298', NULL, NULL, 'PBP1_CcpA', NULL, 'PBP1_CcpA', NULL, NULL, NULL, 2),
(13710, NULL, 'cd07372', NULL, NULL, '2A5CPDO_B', NULL, '2A5CPDO_B', NULL, NULL, 20196, 2),
(13711, NULL, 'cd06912', NULL, NULL, 'GT_MraY_like', NULL, 'GT_MraY_like', NULL, NULL, NULL, 2),
(13712, NULL, 'cd15152', NULL, NULL, '7tmA_GPR174-like', NULL, '7tmA_GPR174-like', NULL, NULL, NULL, 2),
(13713, NULL, 'cd07638', NULL, NULL, 'BAR_ACAP2', NULL, 'BAR_ACAP2', NULL, NULL, NULL, 2),
(13714, NULL, 'cd13985', NULL, NULL, 'STKc_GAK_like', NULL, 'STKc_GAK_like', NULL, NULL, NULL, 2),
(13715, NULL, 'cd16455', NULL, NULL, 'RING-H2_AMFR', NULL, 'RING-H2_AMFR', NULL, NULL, NULL, 2),
(13716, NULL, 'cd19046', NULL, NULL, 'LGIC_ECD_GABAAR_rho1', NULL, 'LGIC_ECD_GABAAR_rho1', NULL, NULL, NULL, 2),
(13717, NULL, 'cd06219', NULL, NULL, 'DHOD_e_trans_like1', NULL, 'DHOD_e_trans_like1', NULL, NULL, NULL, 2),
(13718, NULL, 'cd02005', NULL, NULL, 'TPP_PDC_IPDC', NULL, 'TPP_PDC_IPDC', NULL, NULL, NULL, 2),
(13719, NULL, 'cd08189', NULL, NULL, 'Fe-ADH-like', NULL, 'Fe-ADH-like', NULL, NULL, NULL, 2),
(13720, NULL, 'cd17596', NULL, NULL, 'REC_HupR', NULL, 'REC_HupR', NULL, NULL, NULL, 2),
(13721, NULL, 'cd06327', NULL, NULL, 'PBP1_SBP-like', NULL, 'PBP1_SBP-like', NULL, NULL, NULL, 2),
(13722, NULL, 'cd13329', NULL, NULL, 'PH_RhoGEF', NULL, 'PH_RhoGEF', NULL, NULL, NULL, 2),
(13723, NULL, 'cd15343', NULL, NULL, '7tmA_LPAR3_Edg7', NULL, '7tmA_LPAR3_Edg7', NULL, NULL, NULL, 2),
(13724, NULL, 'cd17028', NULL, NULL, 'T3SC_IA_SycE_Scc1-like', NULL, 'T3SC_IA_SycE_Scc1-like', NULL, NULL, NULL, 2),
(13725, NULL, 'cd18557', NULL, NULL, 'ABC_6TM_TAP_ABCB8_10_like', NULL, 'ABC_6TM_TAP_ABCB8_10_like', NULL, NULL, NULL, 2),
(13726, NULL, 'cd00995', NULL, NULL, 'PBP2_NikA_DppA_OppA_like', NULL, 'PBP2_NikA_DppA_OppA_like', NULL, NULL, NULL, 2),
(13727, NULL, 'cd19770', NULL, NULL, 'Bbox2_TRIM19_C-V', NULL, 'Bbox2_TRIM19_C-V', NULL, NULL, NULL, 2),
(13728, NULL, 'cd11751', NULL, NULL, 'GH94N_like_4', NULL, 'GH94N_like_4', NULL, NULL, NULL, 2),
(13729, NULL, 'cd15245', NULL, NULL, '7tmF_FZD2', NULL, '7tmF_FZD2', NULL, NULL, NULL, 2),
(13730, NULL, 'cd12307', NULL, NULL, 'RRM_NIFK_like', NULL, 'RRM_NIFK_like', NULL, NULL, NULL, 2),
(13731, NULL, 'cd17366', NULL, NULL, 'MFS_ProP', NULL, 'MFS_ProP', NULL, NULL, NULL, 2),
(13732, NULL, 'cd13361', NULL, NULL, 'PH_PLC_beta', NULL, 'PH_PLC_beta', NULL, NULL, 31623, 2),
(13733, NULL, 'cd19571', NULL, NULL, 'serpinB12_yukopin', NULL, 'serpinB12_yukopin', NULL, NULL, NULL, 2),
(13734, NULL, 'cd07968', NULL, NULL, 'OBF_DNA_ligase_IV', NULL, 'OBF_DNA_ligase_IV', NULL, NULL, NULL, 2),
(13735, NULL, 'cd09700', NULL, NULL, 'Csx10', NULL, 'Csx10', NULL, NULL, NULL, 2),
(13736, NULL, 'cd03327', NULL, NULL, 'MR_like_2', NULL, 'MR_like_2', NULL, NULL, 16222, 2),
(13737, NULL, 'cd14855', NULL, NULL, 'TRAPPC1_MUM2', NULL, 'TRAPPC1_MUM2', NULL, NULL, NULL, 2),
(13738, NULL, 'cd12286', NULL, NULL, 'RRM_Man1', NULL, 'RRM_Man1', NULL, NULL, 741, 2),
(13739, NULL, 'cd08206', NULL, NULL, 'RuBisCO_large_I_II_III', NULL, 'RuBisCO_large_I_II_III', NULL, NULL, NULL, 2);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(13740, NULL, 'cd00383', NULL, NULL, 'trans_reg_C', NULL, 'trans_reg_C', NULL, NULL, 4108, 2),
(13741, NULL, 'cd14714', NULL, NULL, 'bZIP_CEBPD', NULL, 'bZIP_CEBPD', NULL, NULL, NULL, 2),
(13742, NULL, 'cd05072', NULL, NULL, 'PTKc_Lyn', NULL, 'PTKc_Lyn', NULL, NULL, NULL, 2),
(13743, NULL, 'cd14239', NULL, NULL, 'GAT_GGA1_GGA2', NULL, 'GAT_GGA1_GGA2', NULL, NULL, NULL, 2),
(13744, NULL, 'cd15862', NULL, NULL, 'SNARE_Vti1', NULL, 'SNARE_Vti1', NULL, NULL, NULL, 2),
(13745, NULL, 'cd01888', NULL, NULL, 'eIF2_gamma', NULL, 'eIF2_gamma', NULL, NULL, 35974, 2),
(13746, NULL, 'cd18377', NULL, NULL, 'BTB_POZ_Kv1_KCNA', NULL, 'BTB_POZ_Kv1_KCNA', NULL, NULL, NULL, 2),
(13747, NULL, 'cd10042', NULL, NULL, 'Reelin_repeat_6_subrepeat_1', NULL, 'Reelin_repeat_6_subrepeat_1', NULL, NULL, NULL, 2),
(13748, NULL, 'cd07336', NULL, NULL, 'M48B_HtpX_like', NULL, 'M48B_HtpX_like', NULL, NULL, NULL, 2),
(13749, NULL, 'cd13993', NULL, NULL, 'STKc_Pat1_like', NULL, 'STKc_Pat1_like', NULL, NULL, NULL, 2),
(13750, NULL, 'cd02778', NULL, NULL, 'MopB_CT_Thiosulfate-R-like', NULL, 'MopB_CT_Thiosulfate-R-like', NULL, NULL, NULL, 2),
(13751, NULL, 'cd00355', NULL, NULL, 'Ribosomal_L30_like', NULL, 'Ribosomal_L30_like', NULL, NULL, NULL, 2),
(13752, NULL, 'cd21558', NULL, NULL, 'alphaCoV-Nsp6', NULL, 'alphaCoV-Nsp6', NULL, NULL, 35376, 2),
(13753, NULL, 'cd05154', NULL, NULL, 'ACAD10_11_N-like', NULL, 'ACAD10_11_N-like', NULL, NULL, 29909, 2),
(13754, NULL, 'cd13656', NULL, NULL, 'PBP2_MBP', NULL, 'PBP2_MBP', NULL, NULL, NULL, 2),
(13755, NULL, 'cd05594', NULL, NULL, 'STKc_PKB_alpha', NULL, 'STKc_PKB_alpha', NULL, NULL, 20061, 2),
(13756, NULL, 'cd18726', NULL, NULL, 'PIN_LabA-like', NULL, 'PIN_LabA-like', NULL, NULL, NULL, 2),
(13757, NULL, 'cd03049', NULL, NULL, 'GST_N_3', NULL, 'GST_N_3', NULL, NULL, NULL, 2),
(13758, NULL, 'cd03389', NULL, NULL, 'PAP2_lipid_A_1_phosphatase', NULL, 'PAP2_lipid_A_1_phosphatase', NULL, NULL, NULL, 2),
(13759, NULL, 'cd11403', NULL, NULL, 'bHLH_scINO4_like', NULL, 'bHLH_scINO4_like', NULL, NULL, NULL, 2),
(13760, NULL, 'cd01919', NULL, NULL, 'PEPCK', NULL, 'PEPCK', NULL, NULL, NULL, 2),
(13761, NULL, 'cd01129', NULL, NULL, 'PulE-GspE', NULL, 'PulE-GspE', NULL, NULL, NULL, 2),
(13762, NULL, 'cd13683', NULL, NULL, 'PBP2_TRAP_DctP6_7', NULL, 'PBP2_TRAP_DctP6_7', NULL, NULL, NULL, 2),
(13763, NULL, 'cd03271', NULL, NULL, 'ABC_UvrA_II', NULL, 'ABC_UvrA_II', NULL, NULL, NULL, 2),
(13764, NULL, 'cd08833', NULL, NULL, 'ArfGap_GIT', NULL, 'ArfGap_GIT', NULL, NULL, NULL, 2),
(13765, NULL, 'cd18421', NULL, NULL, 'BTB_POZ_KCNG1_2', NULL, 'BTB_POZ_KCNG1_2', NULL, NULL, NULL, 2),
(13766, NULL, 'cd02872', NULL, NULL, 'GH18_chitolectin_chitotriosidase', NULL, 'GH18_chitolectin_chitotriosidase', NULL, NULL, NULL, 2),
(13767, NULL, 'cd12467', NULL, NULL, 'RRM_Srp1p_like', NULL, 'RRM_Srp1p_like', NULL, NULL, 15468, 2),
(13768, NULL, 'cd09947', NULL, NULL, 'Ebola_HIV-1-like_HR1-HR2', NULL, 'Ebola_HIV-1-like_HR1-HR2', NULL, NULL, NULL, 2),
(13769, NULL, 'cd10791', NULL, NULL, 'GH38N_AMII_like_1', NULL, 'GH38N_AMII_like_1', NULL, NULL, NULL, 2),
(13770, NULL, 'cd18547', NULL, NULL, 'ABC_6TM_Tm288_like', NULL, 'ABC_6TM_Tm288_like', NULL, NULL, NULL, 2),
(13771, NULL, 'cd05583', NULL, NULL, 'STKc_MSK_N', NULL, 'STKc_MSK_N', NULL, NULL, NULL, 2),
(13772, NULL, 'cd07379', NULL, NULL, 'MPP_239FB', NULL, 'MPP_239FB', NULL, NULL, NULL, 2),
(13773, NULL, 'cd08157', NULL, NULL, 'catalase_fungal', NULL, 'catalase_fungal', NULL, NULL, NULL, 2),
(13774, NULL, 'cd14548', NULL, NULL, 'R3-PTPc', NULL, 'R3-PTPc', NULL, NULL, NULL, 2),
(13775, NULL, 'cd06153', NULL, NULL, 'YjgF_YER057c_UK114_like_5', NULL, 'YjgF_YER057c_UK114_like_5', NULL, NULL, NULL, 2),
(13776, NULL, 'cd15702', NULL, NULL, 'ePHD_BRPF2', NULL, 'ePHD_BRPF2', NULL, NULL, 30251, 2),
(13777, NULL, 'cd18011', NULL, NULL, 'DEXDc_RapA', NULL, 'DEXDc_RapA', NULL, NULL, NULL, 2),
(13778, NULL, 'cd02588', NULL, NULL, 'HAD_L2-DEX', NULL, 'HAD_L2-DEX', NULL, NULL, 4526, 2),
(13779, NULL, 'cd02930', NULL, NULL, 'DCR_FMN', NULL, 'DCR_FMN', NULL, NULL, NULL, 2),
(13780, NULL, 'cd05763', NULL, NULL, 'Ig_1', NULL, 'Ig_1', NULL, NULL, NULL, 2);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(13781, NULL, 'cd02178', NULL, NULL, 'GH16_beta_agarase', NULL, 'GH16_beta_agarase', NULL, NULL, 19628, 2),
(13782, NULL, 'cd16639', NULL, NULL, 'RING-HC_TRAF2', NULL, 'RING-HC_TRAF2', NULL, NULL, NULL, 2),
(13783, NULL, 'cd04215', NULL, NULL, 'Nitrosocyanin', NULL, 'Nitrosocyanin', NULL, NULL, 14892, 2),
(13784, NULL, 'cd07214', NULL, NULL, 'Pat17_isozyme_like', NULL, 'Pat17_isozyme_like', NULL, NULL, NULL, 2),
(13785, NULL, 'cd07152', NULL, NULL, 'ALDH_BenzADH', NULL, 'ALDH_BenzADH', NULL, NULL, NULL, 2),
(13786, NULL, 'cd08895', NULL, NULL, 'SRPBCC_CalC_Aha1-like_2', NULL, 'SRPBCC_CalC_Aha1-like_2', NULL, NULL, NULL, 2),
(13787, NULL, 'cd10323', NULL, NULL, 'SLC-NCS1sbd', NULL, 'SLC-NCS1sbd', NULL, NULL, NULL, 2),
(13788, NULL, 'cd05330', NULL, NULL, 'cyclohexanol_reductase_SDR_c', NULL, 'cyclohexanol_reductase_SDR_c', NULL, NULL, NULL, 2),
(13789, NULL, 'cd14882', NULL, NULL, 'MYSc_Myo21', NULL, 'MYSc_Myo21', NULL, NULL, NULL, 2),
(13790, NULL, 'cd01249', NULL, NULL, 'BAR-PH_GRAF_family', NULL, 'BAR-PH_GRAF_family', NULL, NULL, NULL, 2),
(13791, NULL, 'cd12619', NULL, NULL, 'RRM2_PUB1', NULL, 'RRM2_PUB1', NULL, NULL, NULL, 2),
(13792, NULL, 'cd14497', NULL, NULL, 'PTP_PTEN-like', NULL, 'PTP_PTEN-like', NULL, NULL, NULL, 2),
(13793, NULL, 'cd05614', NULL, NULL, 'STKc_MSK2_N', NULL, 'STKc_MSK2_N', NULL, NULL, 31059, 2),
(13794, NULL, 'cd19364', NULL, NULL, 'TenA_C_BsTenA-like', NULL, 'TenA_C_BsTenA-like', NULL, NULL, NULL, 2),
(13795, NULL, 'cd00770', NULL, NULL, 'SerRS_core', NULL, 'SerRS_core', NULL, NULL, 32619, 2),
(13796, NULL, 'cd05065', NULL, NULL, 'PTKc_EphR_B', NULL, 'PTKc_EphR_B', NULL, NULL, NULL, 2),
(13797, NULL, 'cd05074', NULL, NULL, 'PTKc_Tyro3', NULL, 'PTKc_Tyro3', NULL, NULL, NULL, 2),
(13798, NULL, 'cd06262', NULL, NULL, 'metallo-hydrolase-like_MBL-fold', NULL, 'metallo-hydrolase-like_MBL-fold', NULL, NULL, NULL, 2),
(13799, NULL, 'cd06114', NULL, NULL, 'EcCS_like', NULL, 'EcCS_like', NULL, NULL, 1810, 2),
(13800, NULL, 'cd03006', NULL, NULL, 'PDI_a_EFP1_N', NULL, 'PDI_a_EFP1_N', NULL, NULL, NULL, 2),
(13801, NULL, 'cd16178', NULL, NULL, 'EFh_HEF_SCGN', NULL, 'EFh_HEF_SCGN', NULL, NULL, 31046, 2),
(13802, NULL, 'cd16525', NULL, NULL, 'RING-HC_PCGF', NULL, 'RING-HC_PCGF', NULL, NULL, NULL, 2),
(13803, NULL, 'cd10372', NULL, NULL, 'SH2_STAT1', NULL, 'SH2_STAT1', NULL, NULL, 32183, 2),
(13804, NULL, 'cd14389', NULL, NULL, 'UBA_AAA_plant', NULL, 'UBA_AAA_plant', NULL, NULL, NULL, 2),
(13805, NULL, 'cd06899', NULL, NULL, 'lectin_legume_LecRK_Arcelin_ConA', NULL, 'lectin_legume_LecRK_Arcelin_ConA', NULL, NULL, 2265, 2),
(13806, NULL, 'cd00397', NULL, NULL, 'DNA_BRE_C', NULL, 'DNA_BRE_C', NULL, NULL, NULL, 2),
(13807, NULL, 'cd15223', NULL, NULL, '7tmA_OR56-like', NULL, '7tmA_OR56-like', NULL, NULL, NULL, 2),
(13808, NULL, 'cd19781', NULL, NULL, 'Bbox2_TRIM40_C-V', NULL, 'Bbox2_TRIM40_C-V', NULL, NULL, NULL, 2),
(13809, NULL, 'cd00021', NULL, NULL, 'Bbox_SF', NULL, 'Bbox_SF', NULL, NULL, NULL, 2),
(13810, NULL, 'cd13624', NULL, NULL, 'PBP2_Arg_Lys_His', NULL, 'PBP2_Arg_Lys_His', NULL, NULL, NULL, 2),
(13811, NULL, 'cd20281', NULL, NULL, 'cupin_QDO_C', NULL, 'cupin_QDO_C', NULL, NULL, NULL, 2),
(13812, NULL, 'cd00916', NULL, NULL, 'Npc2_like', NULL, 'Npc2_like', NULL, NULL, 33115, 2),
(13813, NULL, 'cd10577', NULL, NULL, 'TNFRSF1B', NULL, 'TNFRSF1B', NULL, NULL, 29257, 2),
(13814, NULL, 'cd12293', NULL, NULL, 'RRM_Rrp7p', NULL, 'RRM_Rrp7p', NULL, NULL, NULL, 2),
(13815, NULL, 'cd14656', NULL, NULL, 'Imelysin-like_EfeO', NULL, 'Imelysin-like_EfeO', NULL, NULL, 18199, 2),
(13816, NULL, 'cd04122', NULL, NULL, 'Rab14', NULL, 'Rab14', NULL, NULL, 24233, 2),
(13817, NULL, 'cd17928', NULL, NULL, 'DEXDc_SecA', NULL, 'DEXDc_SecA', NULL, NULL, NULL, 2),
(13818, NULL, 'cd12568', NULL, NULL, 'RRM3_MRD1', NULL, 'RRM3_MRD1', NULL, NULL, 4129, 2),
(13819, NULL, 'cd03698', NULL, NULL, 'eRF3_II_like', NULL, 'eRF3_II_like', NULL, NULL, NULL, 2),
(13820, NULL, 'cd08773', NULL, NULL, 'FpgNei_N', NULL, 'FpgNei_N', NULL, NULL, NULL, 2),
(13821, NULL, 'cd09405', NULL, NULL, 'LIM1_Paxillin', NULL, 'LIM1_Paxillin', NULL, NULL, NULL, 2);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(13822, NULL, 'cd05595', NULL, NULL, 'STKc_PKB_beta', NULL, 'STKc_PKB_beta', NULL, NULL, 17365, 2),
(13823, NULL, 'cd18584', NULL, NULL, 'ABC_6TM_AarD_CydD', NULL, 'ABC_6TM_AarD_CydD', NULL, NULL, NULL, 2),
(13824, NULL, 'cd20225', NULL, NULL, 'PFM_lysenin-like', NULL, 'PFM_lysenin-like', NULL, NULL, NULL, 2),
(13825, NULL, 'cd08026', NULL, NULL, 'DUF326', NULL, 'DUF326', NULL, NULL, 34423, 2),
(13826, NULL, 'cd15103', NULL, NULL, '7tmA_MCR', NULL, '7tmA_MCR', NULL, NULL, NULL, 2),
(13827, NULL, 'cd19116', NULL, NULL, 'AKR_AKR2E1-5', NULL, 'AKR_AKR2E1-5', NULL, NULL, 34594, 2),
(13828, NULL, 'cd13582', NULL, NULL, 'PBP2_AlgQ_like_3', NULL, 'PBP2_AlgQ_like_3', NULL, NULL, NULL, 2),
(13829, NULL, 'cd15996', NULL, NULL, '7tmB2_GPR126', NULL, '7tmB2_GPR126', NULL, NULL, NULL, 2),
(13830, NULL, 'cd15440', NULL, NULL, '7tmB2_latrophilin-like_invertebrate', NULL, '7tmB2_latrophilin-like_invertebrate', NULL, NULL, NULL, 2),
(13831, NULL, 'cd16947', NULL, NULL, 'HATPase_YcbM-like', NULL, 'HATPase_YcbM-like', NULL, NULL, NULL, 2),
(13832, NULL, 'cd09477', NULL, NULL, 'LIM2_TLP', NULL, 'LIM2_TLP', NULL, NULL, NULL, 2),
(13833, NULL, 'cd01658', NULL, NULL, 'Ribosomal_L30', NULL, 'Ribosomal_L30', NULL, NULL, 1445, 2),
(13834, NULL, 'cd11340', NULL, NULL, 'AmyAc_bac_CMD_like_3', NULL, 'AmyAc_bac_CMD_like_3', NULL, NULL, NULL, 2),
(13835, NULL, 'cd01959', NULL, NULL, 'nsLTP2', NULL, 'nsLTP2', NULL, NULL, 30536, 2),
(13836, NULL, 'cd09253', NULL, NULL, 'AP-4_Mu4_Cterm', NULL, 'AP-4_Mu4_Cterm', NULL, NULL, NULL, 2),
(13837, NULL, 'cd17274', NULL, NULL, 'RMtype1_S_Eco540ANI-TRD1-CR1_like', NULL, 'RMtype1_S_Eco540ANI-TRD1-CR1_like', NULL, NULL, NULL, 2),
(13838, NULL, 'cd02966', NULL, NULL, 'TlpA_like_family', NULL, 'TlpA_like_family', NULL, NULL, NULL, 2),
(13839, NULL, 'cd03059', NULL, NULL, 'GST_N_SspA', NULL, 'GST_N_SspA', NULL, NULL, 20385, 2),
(13840, NULL, 'cd01133', NULL, NULL, 'F1-ATPase_beta', NULL, 'F1-ATPase_beta', NULL, NULL, NULL, 2),
(13841, NULL, 'cd15483', NULL, NULL, 'Influenza_NA', NULL, 'Influenza_NA', NULL, NULL, 29461, 2),
(13842, NULL, 'cd13952', NULL, NULL, '7tm_classB', NULL, '7tm_classB', NULL, NULL, NULL, 2),
(13843, NULL, 'cd18484', NULL, NULL, 'BACK_KBTBD11_CMLAP', NULL, 'BACK_KBTBD11_CMLAP', NULL, NULL, NULL, 2),
(13844, NULL, 'cd08514', NULL, NULL, 'PBP2_AppA_like', NULL, 'PBP2_AppA_like', NULL, NULL, NULL, 2),
(13845, NULL, 'cd14190', NULL, NULL, 'STKc_MLCK2', NULL, 'STKc_MLCK2', NULL, NULL, 36757, 2),
(13846, NULL, 'cd09346', NULL, NULL, 'LIM3_FHL', NULL, 'LIM3_FHL', NULL, NULL, NULL, 2),
(13847, NULL, 'cd21165', NULL, NULL, 'M_cv-Nsp15-like', NULL, 'M_cv-Nsp15-like', NULL, NULL, 36228, 2),
(13848, NULL, 'cd09118', NULL, NULL, 'PLDc_yjhR_C_like', NULL, 'PLDc_yjhR_C_like', NULL, NULL, NULL, 2),
(13849, NULL, 'cd11748', NULL, NULL, 'GH94N_NdvB_like', NULL, 'GH94N_NdvB_like', NULL, NULL, 29820, 2),
(13850, NULL, 'cd17636', NULL, NULL, 'PtmA', NULL, 'PtmA', NULL, NULL, NULL, 2),
(13851, NULL, 'cd16451', NULL, NULL, 'mRING_PEX12', NULL, 'mRING_PEX12', NULL, NULL, NULL, 2),
(13852, NULL, 'cd10048', NULL, NULL, 'Reelin_repeat_4_subrepeat_2', NULL, 'Reelin_repeat_4_subrepeat_2', NULL, NULL, NULL, 2),
(13853, NULL, 'cd14750', NULL, NULL, 'PBP2_TMBP', NULL, 'PBP2_TMBP', NULL, NULL, NULL, 2),
(13854, NULL, 'cd18060', NULL, NULL, 'DEXHc_CHD8', NULL, 'DEXHc_CHD8', NULL, NULL, NULL, 2),
(13855, NULL, 'cd00930', NULL, NULL, 'Cyt_c_Oxidase_VIII', NULL, 'Cyt_c_Oxidase_VIII', NULL, NULL, NULL, 2),
(13856, NULL, 'cd14532', NULL, NULL, 'PTP-MTMR6-like', NULL, 'PTP-MTMR6-like', NULL, NULL, NULL, 2),
(13857, NULL, 'cd15691', NULL, NULL, 'PHD1_DPF2_like', NULL, 'PHD1_DPF2_like', NULL, NULL, NULL, 2),
(13858, NULL, 'cd17641', NULL, NULL, 'LC_FACS_bac1', NULL, 'LC_FACS_bac1', NULL, NULL, NULL, 2),
(13859, NULL, 'cd15029', NULL, NULL, '7tm_SRI_SRII', NULL, '7tm_SRI_SRII', NULL, NULL, NULL, 2),
(13860, NULL, 'cd12263', NULL, NULL, 'RRM_ABT1_like', NULL, 'RRM_ABT1_like', NULL, NULL, 861, 2),
(13861, NULL, 'cd03364', NULL, NULL, 'TOPRIM_DnaG_primases', NULL, 'TOPRIM_DnaG_primases', NULL, NULL, 25029, 2);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(13862, NULL, 'cd07167', NULL, NULL, 'NR_DBD_Lrh-1_like', NULL, 'NR_DBD_Lrh-1_like', NULL, NULL, NULL, 2),
(13863, NULL, 'cd05532', NULL, NULL, 'POLBc_alpha', NULL, 'POLBc_alpha', NULL, NULL, 36009, 2),
(13864, NULL, 'cd07871', NULL, NULL, 'STKc_PCTAIRE3', NULL, 'STKc_PCTAIRE3', NULL, NULL, NULL, 2),
(13865, NULL, 'cd17272', NULL, NULL, 'RMtype1_S_Eco2747II-TRD2-CR2-like', NULL, 'RMtype1_S_Eco2747II-TRD2-CR2-like', NULL, NULL, NULL, 2),
(13866, NULL, 'cd12757', NULL, NULL, 'RRM1_hnRNPAB', NULL, 'RRM1_hnRNPAB', NULL, NULL, 33829, 2),
(13867, NULL, 'cd03811', NULL, NULL, 'GT4_GT28_WabH-like', NULL, 'GT4_GT28_WabH-like', NULL, NULL, NULL, 2),
(13868, NULL, 'cd15477', NULL, NULL, 'Myo5b_CBD', NULL, 'Myo5b_CBD', NULL, NULL, 32508, 2),
(13869, NULL, 'cd04117', NULL, NULL, 'Rab15', NULL, 'Rab15', NULL, NULL, 30148, 2),
(13870, NULL, 'cd03523', NULL, NULL, 'NTR_like', NULL, 'NTR_like', NULL, NULL, NULL, 2),
(13871, NULL, 'cd19023', NULL, NULL, 'LGIC_ECD_nAChR_A10', NULL, 'LGIC_ECD_nAChR_A10', NULL, NULL, NULL, 2),
(13872, NULL, 'cd08590', NULL, NULL, 'PI-PLCc_Rv2075c_like', NULL, 'PI-PLCc_Rv2075c_like', NULL, NULL, NULL, 2),
(13873, NULL, 'cd18108', NULL, NULL, 'SpoU-like_NHR', NULL, 'SpoU-like_NHR', NULL, NULL, NULL, 2),
(13874, NULL, 'cd17103', NULL, NULL, 'FERM_F1_FRMD4', NULL, 'FERM_F1_FRMD4', NULL, NULL, NULL, 2),
(13875, NULL, 'cd15770', NULL, NULL, 'FYVE_CARP2', NULL, 'FYVE_CARP2', NULL, NULL, NULL, 2),
(13876, NULL, 'cd00240', NULL, NULL, 'TFIIFa', NULL, 'TFIIFa', NULL, NULL, NULL, 2),
(13877, NULL, 'cd04369', NULL, NULL, 'Bromodomain', NULL, 'Bromodomain', NULL, NULL, NULL, 2),
(13878, NULL, 'cd02958', NULL, NULL, 'UAS', NULL, 'UAS', NULL, NULL, NULL, 2),
(13879, NULL, 'cd01729', NULL, NULL, 'LSm7', NULL, 'LSm7', NULL, NULL, 20808, 2),
(13880, NULL, 'cd01366', NULL, NULL, 'KISc_C_terminal', NULL, 'KISc_C_terminal', NULL, NULL, NULL, 2),
(13881, NULL, 'cd04489', NULL, NULL, 'ExoVII_LU_OBF', NULL, 'ExoVII_LU_OBF', NULL, NULL, 24139, 2),
(13882, NULL, 'cd15564', NULL, NULL, 'PHD1_NSD', NULL, 'PHD1_NSD', NULL, NULL, NULL, 2),
(13883, NULL, 'cd07479', NULL, NULL, 'Peptidases_S8_SKI-1_like', NULL, 'Peptidases_S8_SKI-1_like', NULL, NULL, 22996, 2),
(13884, NULL, 'cd15176', NULL, NULL, '7tmA_ACKR4_CCR11', NULL, '7tmA_ACKR4_CCR11', NULL, NULL, NULL, 2),
(13885, NULL, 'cd15191', NULL, NULL, '7tmA_AT2R', NULL, '7tmA_AT2R', NULL, NULL, NULL, 2),
(13886, NULL, 'cd19365', NULL, NULL, 'TenA_C-like', NULL, 'TenA_C-like', NULL, NULL, NULL, 2),
(13887, NULL, 'cd08410', NULL, NULL, 'C2B_Synaptotagmin-17', NULL, 'C2B_Synaptotagmin-17', NULL, NULL, NULL, 2),
(13888, NULL, 'cd07583', NULL, NULL, 'nitrilase_5', NULL, 'nitrilase_5', NULL, NULL, NULL, 2),
(13889, NULL, 'cd10485', NULL, NULL, 'EphR_LBD_A7', NULL, 'EphR_LBD_A7', NULL, NULL, 27618, 2),
(13890, NULL, 'cd15629', NULL, NULL, 'PHD_BAZ2A', NULL, 'PHD_BAZ2A', NULL, NULL, NULL, 2),
(13891, NULL, 'cd09848', NULL, NULL, 'M28_TfR', NULL, 'M28_TfR', NULL, NULL, NULL, 2),
(13892, NULL, 'cd09264', NULL, NULL, 'AP_Syp1_MHD', NULL, 'AP_Syp1_MHD', NULL, NULL, NULL, 2),
(13893, NULL, 'cd03777', NULL, NULL, 'MATH_TRAF3', NULL, 'MATH_TRAF3', NULL, NULL, 27583, 2),
(13894, NULL, 'cd05864', NULL, NULL, 'Ig_VEGFR-2', NULL, 'Ig_VEGFR-2', NULL, NULL, NULL, 2),
(13895, NULL, 'cd12518', NULL, NULL, 'RRM_SRSF11', NULL, 'RRM_SRSF11', NULL, NULL, NULL, 2),
(13896, NULL, 'cd06852', NULL, NULL, 'GT_MraY', NULL, 'GT_MraY', NULL, NULL, 6217, 2),
(13897, NULL, 'cd16753', NULL, NULL, 'RING-HC_MID1', NULL, 'RING-HC_MID1', NULL, NULL, NULL, 2),
(13898, NULL, 'cd01067', NULL, NULL, 'Globin-like', NULL, 'Globin-like', NULL, NULL, NULL, 2),
(13899, NULL, 'cd12251', NULL, NULL, 'RRM3_hnRNPR_like', NULL, 'RRM3_hnRNPR_like', NULL, NULL, NULL, 2),
(13900, NULL, 'cd04701', NULL, NULL, 'Asparaginase_2', NULL, 'Asparaginase_2', NULL, NULL, NULL, 2),
(13901, NULL, 'cd17488', NULL, NULL, 'MFS_UhpC', NULL, 'MFS_UhpC', NULL, NULL, NULL, 2),
(13902, NULL, 'cd02903', NULL, NULL, 'Macro_BAL-like', NULL, 'Macro_BAL-like', NULL, NULL, NULL, 2),
(13903, NULL, 'cd05104', NULL, NULL, 'PTKc_Kit', NULL, 'PTKc_Kit', NULL, NULL, NULL, 2);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(13904, NULL, 'cd00506', NULL, NULL, 'PseudoU_synth_TruB_like', NULL, 'PseudoU_synth_TruB_like', NULL, NULL, NULL, 2),
(13905, NULL, 'cd14964', NULL, NULL, '7tm_GPCRs', NULL, '7tm_GPCRs', NULL, NULL, NULL, 2),
(13906, NULL, 'cd15380', NULL, NULL, '7tmA_BK-1', NULL, '7tmA_BK-1', NULL, NULL, NULL, 2),
(13907, NULL, 'cd00914', NULL, NULL, 'PCD_DCoH_subfamily_b', NULL, 'PCD_DCoH_subfamily_b', NULL, NULL, NULL, 2),
(13908, NULL, 'cd04249', NULL, NULL, 'AAK_NAGK-NC', NULL, 'AAK_NAGK-NC', NULL, NULL, 30771, 2),
(13909, NULL, 'cd10368', NULL, NULL, 'SH2_Src_Fyn', NULL, 'SH2_Src_Fyn', NULL, NULL, NULL, 2),
(13910, NULL, 'cd19030', NULL, NULL, 'LGIC_ECD_nAChR_E', NULL, 'LGIC_ECD_nAChR_E', NULL, NULL, NULL, 2),
(13911, NULL, 'cd15891', NULL, NULL, 'SNARE_Vti1a', NULL, 'SNARE_Vti1a', NULL, NULL, NULL, 2),
(13912, NULL, 'cd18463', NULL, NULL, 'BACK_KLHL24', NULL, 'BACK_KLHL24', NULL, NULL, NULL, 2),
(13913, NULL, 'cd09099', NULL, NULL, 'INPP5c_Synj2', NULL, 'INPP5c_Synj2', NULL, NULL, NULL, 2),
(13914, NULL, 'cd01019', NULL, NULL, 'ZnuA', NULL, 'ZnuA', NULL, NULL, 33328, 2),
(13915, NULL, 'cd14664', NULL, NULL, 'STK_BAK1_like', NULL, 'STK_BAK1_like', NULL, NULL, NULL, 2),
(13916, NULL, 'cd07731', NULL, NULL, 'ComA-like_MBL-fold', NULL, 'ComA-like_MBL-fold', NULL, NULL, 31394, 2),
(13917, NULL, 'cd10496', NULL, NULL, 'MH2_I-SMAD', NULL, 'MH2_I-SMAD', NULL, NULL, NULL, 2),
(13918, NULL, 'cd05702', NULL, NULL, 'S1_Rrp5_repeat_hs11_sc8', NULL, 'S1_Rrp5_repeat_hs11_sc8', NULL, NULL, NULL, 2),
(13919, NULL, 'cd17124', NULL, NULL, 'Ubl_TECR', NULL, 'Ubl_TECR', NULL, NULL, NULL, 2),
(13920, NULL, 'cd08781', NULL, NULL, 'Death_UNC5-like', NULL, 'Death_UNC5-like', NULL, NULL, NULL, 2),
(13921, NULL, 'cd12655', NULL, NULL, 'RRM3_HuC', NULL, 'RRM3_HuC', NULL, NULL, 11473, 2),
(13922, NULL, 'cd12715', NULL, NULL, 'RRM2_MATR3', NULL, 'RRM2_MATR3', NULL, NULL, 29424, 2),
(13923, NULL, 'cd16685', NULL, NULL, 'RING-H2_UBR1', NULL, 'RING-H2_UBR1', NULL, NULL, NULL, 2),
(13924, NULL, 'cd14056', NULL, NULL, 'STKc_TGFbR_I', NULL, 'STKc_TGFbR_I', NULL, NULL, NULL, 2),
(13925, NULL, 'cd14454', NULL, NULL, 'CuRO_4_FV_like', NULL, 'CuRO_4_FV_like', NULL, NULL, NULL, 2),
(13926, NULL, 'cd03141', NULL, NULL, 'GATase1_Hsp31_like', NULL, 'GATase1_Hsp31_like', NULL, NULL, NULL, 2),
(13927, NULL, 'cd17594', NULL, NULL, 'REC_OmpR_VirG', NULL, 'REC_OmpR_VirG', NULL, NULL, NULL, 2),
(13928, NULL, 'cd01115', NULL, NULL, 'SLC13_permease', NULL, 'SLC13_permease', NULL, NULL, NULL, 2),
(13929, NULL, 'cd19840', NULL, NULL, 'Bbox1_TRIM29', NULL, 'Bbox1_TRIM29', NULL, NULL, NULL, 2),
(13930, NULL, 'cd06541', NULL, NULL, 'ASCH', NULL, 'ASCH', NULL, NULL, NULL, 2),
(13931, NULL, 'cd10918', NULL, NULL, 'CE4_NodB_like_5s_6s', NULL, 'CE4_NodB_like_5s_6s', NULL, NULL, NULL, 2),
(13932, NULL, 'cd07478', NULL, NULL, 'Peptidases_S8_CspA-like', NULL, 'Peptidases_S8_CspA-like', NULL, NULL, 31657, 2),
(13933, NULL, 'cd08547', NULL, NULL, 'Type_II_cohesin', NULL, 'Type_II_cohesin', NULL, NULL, NULL, 2),
(13934, NULL, 'cd13305', NULL, NULL, 'PH_SHARPIN', NULL, 'PH_SHARPIN', NULL, NULL, NULL, 2),
(13935, NULL, 'cd09212', NULL, NULL, 'PUB', NULL, 'PUB', NULL, NULL, NULL, 2),
(13936, NULL, 'cd03125', NULL, NULL, 'alpha_CA_VI', NULL, 'alpha_CA_VI', NULL, NULL, NULL, 2),
(13937, NULL, 'cd01910', NULL, NULL, 'Wali7', NULL, 'Wali7', NULL, NULL, NULL, 2),
(13938, NULL, 'cd08315', NULL, NULL, 'Death_TRAILR_DR4_DR5', NULL, 'Death_TRAILR_DR4_DR5', NULL, NULL, 1601, 2),
(13939, NULL, 'cd15835', NULL, NULL, 'TNFRSF1B_teleost', NULL, 'TNFRSF1B_teleost', NULL, NULL, NULL, 2),
(13940, NULL, 'cd07935', NULL, NULL, 'RHD-n_NFkB1', NULL, 'RHD-n_NFkB1', NULL, NULL, NULL, 2),
(13941, NULL, 'cd02070', NULL, NULL, 'corrinoid_protein_B12-BD', NULL, 'corrinoid_protein_B12-BD', NULL, NULL, NULL, 2),
(13942, NULL, 'cd08036', NULL, NULL, 'LARP_5', NULL, 'LARP_5', NULL, NULL, NULL, 2),
(13943, NULL, 'cd15519', NULL, NULL, 'PHD1_Lid2p_like', NULL, 'PHD1_Lid2p_like', NULL, NULL, NULL, 2),
(13944, NULL, 'cd02959', NULL, NULL, 'ERp19', NULL, 'ERp19', NULL, NULL, 32759, 2),
(13945, NULL, 'cd14970', NULL, NULL, '7tmA_Opioid_R-like', NULL, '7tmA_Opioid_R-like', NULL, NULL, NULL, 2);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(13946, NULL, 'cd05880', NULL, NULL, 'Ig_EVA1', NULL, 'Ig_EVA1', NULL, NULL, NULL, 2),
(13947, NULL, 'cd14516', NULL, NULL, 'DSP_fungal_PPS1', NULL, 'DSP_fungal_PPS1', NULL, NULL, NULL, 2),
(13948, NULL, 'cd20293', NULL, NULL, 'cupin_HutD_N', NULL, 'cupin_HutD_N', NULL, NULL, NULL, 2),
(13949, NULL, 'cd01142', NULL, NULL, 'TroA_e', NULL, 'TroA_e', NULL, NULL, NULL, 2),
(13950, NULL, 'cd05509', NULL, NULL, 'Bromo_gcn5_like', NULL, 'Bromo_gcn5_like', NULL, NULL, NULL, 2),
(13951, NULL, 'cd13749', NULL, NULL, 'Zn-ribbon_TFIIS', NULL, 'Zn-ribbon_TFIIS', NULL, NULL, NULL, 2),
(13952, NULL, 'cd03143', NULL, NULL, 'A4_beta-galactosidase_middle_domain', NULL, 'A4_beta-galactosidase_middle_domain', NULL, NULL, NULL, 2),
(13953, NULL, 'cd02047', NULL, NULL, 'serpinD1_HCF2', NULL, 'serpinD1_HCF2', NULL, NULL, 33390, 2),
(13954, NULL, 'cd01756', NULL, NULL, 'PLAT_repeat', NULL, 'PLAT_repeat', NULL, NULL, NULL, 2),
(13955, NULL, 'cd18196', NULL, NULL, 'BTB_POZ_ZBTB5', NULL, 'BTB_POZ_ZBTB5', NULL, NULL, NULL, 2),
(13956, NULL, 'cd03316', NULL, NULL, 'MR_like', NULL, 'MR_like', NULL, NULL, NULL, 2),
(13957, NULL, 'cd05680', NULL, NULL, 'M20_dipept_like', NULL, 'M20_dipept_like', NULL, NULL, NULL, 2),
(13958, NULL, 'cd17909', NULL, NULL, 'CheC_ClassI', NULL, 'CheC_ClassI', NULL, NULL, NULL, 2),
(13959, NULL, 'cd09563', NULL, NULL, 'SAM_liprin-beta1,2_repeat1', NULL, 'SAM_liprin-beta1,2_repeat1', NULL, NULL, 32497, 2),
(13960, NULL, 'cd08792', NULL, NULL, 'DED_Caspase_8_10_r1', NULL, 'DED_Caspase_8_10_r1', NULL, NULL, NULL, 2),
(13961, NULL, 'cd09805', NULL, NULL, 'type2_17beta_HSD-like_SDR_c', NULL, 'type2_17beta_HSD-like_SDR_c', NULL, NULL, NULL, 2),
(13962, NULL, 'cd18680', NULL, NULL, 'PIN_MtVapC20-like', NULL, 'PIN_MtVapC20-like', NULL, NULL, 33319, 2),
(13963, NULL, 'cd16422', NULL, NULL, 'HAD_Pase_UmpH-like', NULL, 'HAD_Pase_UmpH-like', NULL, NULL, NULL, 2),
(13964, NULL, 'cd08553', NULL, NULL, 'PIN_Fcf1-like', NULL, 'PIN_Fcf1-like', NULL, NULL, NULL, 2),
(13965, NULL, 'cd15839', NULL, NULL, 'TNFRSF_viral', NULL, 'TNFRSF_viral', NULL, NULL, 19813, 2),
(13966, NULL, 'cd17353', NULL, NULL, 'MFS_OFA_like', NULL, 'MFS_OFA_like', NULL, NULL, NULL, 2),
(13967, NULL, 'cd19171', NULL, NULL, 'SET_KMT2C_2D', NULL, 'SET_KMT2C_2D', NULL, NULL, NULL, 2),
(13968, NULL, 'cd11347', NULL, NULL, 'AmyAc_1', NULL, 'AmyAc_1', NULL, NULL, NULL, 2),
(13969, NULL, 'cd09974', NULL, NULL, 'LOTUS_3_TDRD7', NULL, 'LOTUS_3_TDRD7', NULL, NULL, 32336, 2),
(13970, NULL, 'cd13783', NULL, NULL, 'SPACA1', NULL, 'SPACA1', NULL, NULL, 27077, 2),
(13971, NULL, 'cd15314', NULL, NULL, '7tmA_TAAR1', NULL, '7tmA_TAAR1', NULL, NULL, NULL, 2),
(13972, NULL, 'cd17808', NULL, NULL, 'HipA_Ec_like', NULL, 'HipA_Ec_like', NULL, NULL, NULL, 2),
(13973, NULL, 'cd12787', NULL, NULL, 'RasGAP_plexin_B', NULL, 'RasGAP_plexin_B', NULL, NULL, NULL, 2),
(13974, NULL, 'cd08882', NULL, NULL, 'RHO_alpha_C_MupW-like', NULL, 'RHO_alpha_C_MupW-like', NULL, NULL, NULL, 2),
(13975, NULL, 'cd01827', NULL, NULL, 'sialate_O-acetylesterase_like1', NULL, 'sialate_O-acetylesterase_like1', NULL, NULL, NULL, 2),
(13976, NULL, 'cd03157', NULL, NULL, 'TM4SF12_like_LEL', NULL, 'TM4SF12_like_LEL', NULL, NULL, NULL, 2),
(13977, NULL, 'cd11469', NULL, NULL, 'bHLH-PAS_ARNTL2_PASD9', NULL, 'bHLH-PAS_ARNTL2_PASD9', NULL, NULL, NULL, 2),
(13978, NULL, 'cd06659', NULL, NULL, 'STKc_PAK6', NULL, 'STKc_PAK6', NULL, NULL, NULL, 2),
(13979, NULL, 'cd04107', NULL, NULL, 'Rab32_Rab38', NULL, 'Rab32_Rab38', NULL, NULL, 22098, 2),
(13980, NULL, 'cd19557', NULL, NULL, 'serpinA11', NULL, 'serpinA11', NULL, NULL, NULL, 2),
(13981, NULL, 'cd04206', NULL, NULL, 'CuRO_1_LCC_like', NULL, 'CuRO_1_LCC_like', NULL, NULL, NULL, 2),
(13982, NULL, 'cd19866', NULL, NULL, 'DSRM_STRBP_RED-like_rpt2', NULL, 'DSRM_STRBP_RED-like_rpt2', NULL, NULL, NULL, 2),
(13983, NULL, 'cd06399', NULL, NULL, 'PB1_P40', NULL, 'PB1_P40', NULL, NULL, 10316, 2),
(13984, NULL, 'cd06963', NULL, NULL, 'NR_DBD_GR_like', NULL, 'NR_DBD_GR_like', NULL, NULL, NULL, 2),
(13985, NULL, 'cd08731', NULL, NULL, 'RGS_RGS22_1', NULL, 'RGS_RGS22_1', NULL, NULL, NULL, 2);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(13986, NULL, 'cd02079', NULL, NULL, 'P-type_ATPase_HM', NULL, 'P-type_ATPase_HM', NULL, NULL, NULL, 2),
(13987, NULL, 'cd04582', NULL, NULL, 'CBS_pair_ABC_OpuCA_assoc', NULL, 'CBS_pair_ABC_OpuCA_assoc', NULL, NULL, NULL, 2),
(13988, NULL, 'cd17067', NULL, NULL, 'RBD2_RGS12_like', NULL, 'RBD2_RGS12_like', NULL, NULL, NULL, 2),
(13989, NULL, 'cd00949', NULL, NULL, 'FBP_aldolase_I_bact', NULL, 'FBP_aldolase_I_bact', NULL, NULL, 15472, 2),
(13990, NULL, 'cd10474', NULL, NULL, 'EphR_LBD_B4', NULL, 'EphR_LBD_B4', NULL, NULL, 13821, 2),
(13991, NULL, 'cd08018', NULL, NULL, 'M20_Acy1_amhX-like', NULL, 'M20_Acy1_amhX-like', NULL, NULL, 27457, 2),
(13992, NULL, 'cd02637', NULL, NULL, 'R3H_PARN', NULL, 'R3H_PARN', NULL, NULL, 26939, 2),
(13993, NULL, 'cd09102', NULL, NULL, 'PLDc_CDP-OH_P_transf_II_1', NULL, 'PLDc_CDP-OH_P_transf_II_1', NULL, NULL, NULL, 2),
(13994, NULL, 'cd04335', NULL, NULL, 'PrdX_deacylase', NULL, 'PrdX_deacylase', NULL, NULL, NULL, 2),
(13995, NULL, 'cd04640', NULL, NULL, 'CBS_pair_proteobact', NULL, 'CBS_pair_proteobact', NULL, NULL, NULL, 2),
(13996, NULL, 'cd02749', NULL, NULL, 'Macro_SF', NULL, 'Macro_SF', NULL, NULL, NULL, 2),
(13997, NULL, 'cd19963', NULL, NULL, 'PBP1_BMP-like', NULL, 'PBP1_BMP-like', NULL, NULL, NULL, 2),
(13998, NULL, 'cd01317', NULL, NULL, 'DHOase_IIa', NULL, 'DHOase_IIa', NULL, NULL, 3107, 2),
(13999, NULL, 'cd02960', NULL, NULL, 'AGR', NULL, 'AGR', NULL, NULL, NULL, 2),
(14000, NULL, 'cd17200', NULL, NULL, 'FERM_F1_FRMD4B', NULL, 'FERM_F1_FRMD4B', NULL, NULL, NULL, 2),
(14001, NULL, 'cd17246', NULL, NULL, 'RMtype1_S_SonII-TRD2-CR2_like', NULL, 'RMtype1_S_SonII-TRD2-CR2_like', NULL, NULL, NULL, 2),
(14002, NULL, 'cd11257', NULL, NULL, 'Sema_4B', NULL, 'Sema_4B', NULL, NULL, NULL, 2),
(14003, NULL, 'cd13636', NULL, NULL, 'PBP2_Af1704', NULL, 'PBP2_Af1704', NULL, NULL, NULL, 2),
(14004, NULL, 'cd10947', NULL, NULL, 'CE4_SpPgdA_BsYjeA_like', NULL, 'CE4_SpPgdA_BsYjeA_like', NULL, NULL, NULL, 2),
(14005, NULL, 'cd05519', NULL, NULL, 'Bromo_SNF2', NULL, 'Bromo_SNF2', NULL, NULL, NULL, 2),
(14006, NULL, 'cd16631', NULL, NULL, 'mRING-HC-C4C4_RBR_HOIP', NULL, 'mRING-HC-C4C4_RBR_HOIP', NULL, NULL, NULL, 2),
(14007, NULL, 'cd04757', NULL, NULL, 'Commd9', NULL, 'Commd9', NULL, NULL, NULL, 2),
(14008, NULL, 'cd05045', NULL, NULL, 'PTKc_RET', NULL, 'PTKc_RET', NULL, NULL, NULL, 2),
(14009, NULL, 'cd08021', NULL, NULL, 'M20_Acy1_YhaA-like', NULL, 'M20_Acy1_YhaA-like', NULL, NULL, NULL, 2),
(14010, NULL, 'cd14250', NULL, NULL, 'ESP36_like', NULL, 'ESP36_like', NULL, NULL, NULL, 2),
(14011, NULL, 'cd12296', NULL, NULL, 'RRM1_Prp24', NULL, 'RRM1_Prp24', NULL, NULL, 1132, 2),
(14012, NULL, 'cd08194', NULL, NULL, 'Fe-ADH-like', NULL, 'Fe-ADH-like', NULL, NULL, NULL, 2),
(14013, NULL, 'cd06851', NULL, NULL, 'GT_GPT_like', NULL, 'GT_GPT_like', NULL, NULL, NULL, 2),
(14014, NULL, 'cd02224', NULL, NULL, 'cupin_SPO2919-like', NULL, 'cupin_SPO2919-like', NULL, NULL, NULL, 2),
(14015, NULL, 'cd12918', NULL, NULL, 'VKOR_arc', NULL, 'VKOR_arc', NULL, NULL, NULL, 2),
(14016, NULL, 'cd14034', NULL, NULL, 'PK_NRBP1', NULL, 'PK_NRBP1', NULL, NULL, NULL, 2),
(14017, NULL, 'cd00531', NULL, NULL, 'NTF2_like', NULL, 'NTF2_like', NULL, NULL, NULL, 2),
(14018, NULL, 'cd03876', NULL, NULL, 'M28_SGAP_like', NULL, 'M28_SGAP_like', NULL, NULL, 31074, 2),
(14019, NULL, 'cd04250', NULL, NULL, 'AAK_NAGK-C', NULL, 'AAK_NAGK-C', NULL, NULL, 30990, 2),
(14020, NULL, 'cd18805', NULL, NULL, 'SF2_C_suv3', NULL, 'SF2_C_suv3', NULL, NULL, NULL, 2),
(14021, NULL, 'cd17733', NULL, NULL, 'BRCT_Ect2_rpt1', NULL, 'BRCT_Ect2_rpt1', NULL, NULL, NULL, 2),
(14022, NULL, 'cd02620', NULL, NULL, 'Peptidase_C1A_CathepsinB', NULL, 'Peptidase_C1A_CathepsinB', NULL, NULL, NULL, 2),
(14023, NULL, 'cd13917', NULL, NULL, 'CuRO_HCO_II_like_4', NULL, 'CuRO_HCO_II_like_4', NULL, NULL, NULL, 2),
(14024, NULL, 'cd14019', NULL, NULL, 'STKc_Cdc7', NULL, 'STKc_Cdc7', NULL, NULL, NULL, 2),
(14025, NULL, 'cd11462', NULL, NULL, 'bHLH-O_HES7', NULL, 'bHLH-O_HES7', NULL, NULL, NULL, 2),
(14026, NULL, 'cd08227', NULL, NULL, 'PK_STRAD_alpha', NULL, 'PK_STRAD_alpha', NULL, NULL, NULL, 2);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(14027, NULL, 'cd11507', NULL, NULL, 'SLC6sbd_GAT2', NULL, 'SLC6sbd_GAT2', NULL, NULL, NULL, 2),
(14028, NULL, 'cd15144', NULL, NULL, '7tmA_PGE2_EP1', NULL, '7tmA_PGE2_EP1', NULL, NULL, NULL, 2),
(14029, NULL, 'cd04859', NULL, NULL, 'Prim_Pol', NULL, 'Prim_Pol', NULL, NULL, NULL, 2),
(14030, NULL, 'cd11517', NULL, NULL, 'SLC6sbd_B0AT3', NULL, 'SLC6sbd_B0AT3', NULL, NULL, 35775, 2),
(14031, NULL, 'cd07510', NULL, NULL, 'HAD_Pase_UmpH-like', NULL, 'HAD_Pase_UmpH-like', NULL, NULL, NULL, 2),
(14032, NULL, 'cd13333', NULL, NULL, 'FERM_C_JAK2', NULL, 'FERM_C_JAK2', NULL, NULL, 29813, 2),
(14033, NULL, 'cd18345', NULL, NULL, 'BTB_POZ_roadkill-like', NULL, 'BTB_POZ_roadkill-like', NULL, NULL, NULL, 2),
(14034, NULL, 'cd18384', NULL, NULL, 'BTB_POZ_Kv9_KCNS', NULL, 'BTB_POZ_Kv9_KCNS', NULL, NULL, NULL, 2),
(14035, NULL, 'cd02176', NULL, NULL, 'GH16_XET', NULL, 'GH16_XET', NULL, NULL, 15413, 2),
(14036, NULL, 'cd03890', NULL, NULL, 'M20_pepD', NULL, 'M20_pepD', NULL, NULL, 1462, 2),
(14037, NULL, 'cd16429', NULL, NULL, 'VirB10', NULL, 'VirB10', NULL, NULL, 522, 2),
(14038, NULL, 'cd19385', NULL, NULL, 'TGF_beta_TGFB2', NULL, 'TGF_beta_TGFB2', NULL, NULL, NULL, 2),
(14039, NULL, 'cd11772', NULL, NULL, 'SH3_OSTF1', NULL, 'SH3_OSTF1', NULL, NULL, NULL, 2),
(14040, NULL, 'cd06579', NULL, NULL, 'TM_PBP1_transp_AraH_like', NULL, 'TM_PBP1_transp_AraH_like', NULL, NULL, NULL, 2),
(14041, NULL, 'cd02124', NULL, NULL, 'PA_PoS1_like', NULL, 'PA_PoS1_like', NULL, NULL, NULL, 2),
(14042, NULL, 'cd18637', NULL, NULL, 'CD_Swi6_like', NULL, 'CD_Swi6_like', NULL, NULL, NULL, 2),
(14043, NULL, 'cd04026', NULL, NULL, 'C2_PKC_alpha_gamma', NULL, 'C2_PKC_alpha_gamma', NULL, NULL, NULL, 2),
(14044, NULL, 'cd08364', NULL, NULL, 'FosX', NULL, 'FosX', NULL, NULL, 30958, 2),
(14045, NULL, 'cd14696', NULL, NULL, 'bZIP_Jun', NULL, 'bZIP_Jun', NULL, NULL, NULL, 2),
(14046, NULL, 'cd17453', NULL, NULL, 'MFS_MFSD4A', NULL, 'MFS_MFSD4A', NULL, NULL, NULL, 2),
(14047, NULL, 'cd21161', NULL, NULL, 'NendoU_cv_Nsp15-like', NULL, 'NendoU_cv_Nsp15-like', NULL, NULL, 34493, 2),
(14048, NULL, 'cd04243', NULL, NULL, 'AAK_AK-HSDH-like', NULL, 'AAK_AK-HSDH-like', NULL, NULL, NULL, 2),
(14049, NULL, 'cd14803', NULL, NULL, 'RAP', NULL, 'RAP', NULL, NULL, NULL, 2),
(14050, NULL, 'cd07131', NULL, NULL, 'ALDH_AldH-CAJ73105', NULL, 'ALDH_AldH-CAJ73105', NULL, NULL, NULL, 2),
(14051, NULL, 'cd19589', NULL, NULL, 'serpin_tengpin-like', NULL, 'serpin_tengpin-like', NULL, NULL, NULL, 2),
(14052, NULL, 'cd16902', NULL, NULL, 'pesticin_lyz', NULL, 'pesticin_lyz', NULL, NULL, 25992, 2),
(14053, NULL, 'cd17502', NULL, NULL, 'MFS_Azr1_MDR_like', NULL, 'MFS_Azr1_MDR_like', NULL, NULL, NULL, 2),
(14054, NULL, 'cd09515', NULL, NULL, 'SAM_SGMS1-like', NULL, 'SAM_SGMS1-like', NULL, NULL, NULL, 2),
(14055, NULL, 'cd11449', NULL, NULL, 'bHLH_AtAIB_like', NULL, 'bHLH_AtAIB_like', NULL, NULL, NULL, 2),
(14056, NULL, 'cd04030', NULL, NULL, 'C2C_KIAA1228', NULL, 'C2C_KIAA1228', NULL, NULL, 29927, 2),
(14057, NULL, 'cd08272', NULL, NULL, 'MDR6', NULL, 'MDR6', NULL, NULL, NULL, 2),
(14058, NULL, 'cd04667', NULL, NULL, 'Nudix_Hydrolase_10', NULL, 'Nudix_Hydrolase_10', NULL, NULL, NULL, 2),
(14059, NULL, 'cd00077', NULL, NULL, 'HDc', NULL, 'HDc', NULL, NULL, 668, 2),
(14060, NULL, 'cd05593', NULL, NULL, 'STKc_PKB_gamma', NULL, 'STKc_PKB_gamma', NULL, NULL, 18653, 2),
(14061, NULL, 'cd01100', NULL, NULL, 'APPLE_Factor_XI_like', NULL, 'APPLE_Factor_XI_like', NULL, NULL, 1620, 2),
(14062, NULL, 'cd03261', NULL, NULL, 'ABC_Org_Solvent_Resistant', NULL, 'ABC_Org_Solvent_Resistant', NULL, NULL, NULL, 2),
(14063, NULL, 'cd00443', NULL, NULL, 'ADA_AMPD', NULL, 'ADA_AMPD', NULL, NULL, NULL, 2),
(14064, NULL, 'cd09189', NULL, NULL, 'PLDc_DNaseII_alpha_1', NULL, 'PLDc_DNaseII_alpha_1', NULL, NULL, NULL, 2),
(14065, NULL, 'cd13979', NULL, NULL, 'STKc_Mos', NULL, 'STKc_Mos', NULL, NULL, NULL, 2),
(14066, NULL, 'cd00692', NULL, NULL, 'ligninase', NULL, 'ligninase', NULL, NULL, 5001, 2),
(14067, NULL, 'cd16987', NULL, NULL, 'ANTH_N_AP180_plant', NULL, 'ANTH_N_AP180_plant', NULL, NULL, NULL, 2);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(14068, NULL, 'cd17932', NULL, NULL, 'DEXQc_UvrD', NULL, 'DEXQc_UvrD', NULL, NULL, NULL, 2),
(14069, NULL, 'cd13573', NULL, NULL, 'PBP2_PnhD_3', NULL, 'PBP2_PnhD_3', NULL, NULL, NULL, 2),
(14070, NULL, 'cd00796', NULL, NULL, 'INT_Rci_Hp1_C', NULL, 'INT_Rci_Hp1_C', NULL, NULL, NULL, 2),
(14071, NULL, 'cd18441', NULL, NULL, 'BRCT_MDC1_rpt2', NULL, 'BRCT_MDC1_rpt2', NULL, NULL, NULL, 2),
(14072, NULL, 'cd15841', NULL, NULL, 'SNARE_Qc', NULL, 'SNARE_Qc', NULL, NULL, NULL, 2),
(14073, NULL, 'cd00600', NULL, NULL, 'Sm_like', NULL, 'Sm_like', NULL, NULL, NULL, 2),
(14074, NULL, 'cd13671', NULL, NULL, 'PBP2_TRAP_SBP_like_3', NULL, 'PBP2_TRAP_SBP_like_3', NULL, NULL, NULL, 2),
(14075, NULL, 'cd19695', NULL, NULL, 'bHLH_dnHLH_EMC_like', NULL, 'bHLH_dnHLH_EMC_like', NULL, NULL, NULL, 2),
(14076, NULL, 'cd04045', NULL, NULL, 'C2C_Tricalbin-like', NULL, 'C2C_Tricalbin-like', NULL, NULL, 32645, 2),
(14077, NULL, 'cd00716', NULL, NULL, 'creatine_kinase_like', NULL, 'creatine_kinase_like', NULL, NULL, NULL, 2),
(14078, NULL, 'cd12684', NULL, NULL, 'RRM_cpo', NULL, 'RRM_cpo', NULL, NULL, 19036, 2),
(14079, NULL, 'cd18822', NULL, NULL, 'GH43_CtGH43-like', NULL, 'GH43_CtGH43-like', NULL, NULL, NULL, 2),
(14080, NULL, 'cd09521', NULL, NULL, 'SAM_ASZ1', NULL, 'SAM_ASZ1', NULL, NULL, 35843, 2),
(14081, NULL, 'cd14216', NULL, NULL, 'STKc_SRPK1', NULL, 'STKc_SRPK1', NULL, NULL, NULL, 2),
(14082, NULL, 'cd06976', NULL, NULL, 'cupin_MtlR-like_N', NULL, 'cupin_MtlR-like_N', NULL, NULL, NULL, 2),
(14083, NULL, 'cd10525', NULL, NULL, 'SET_SUV39H1', NULL, 'SET_SUV39H1', NULL, NULL, NULL, 2),
(14084, NULL, 'cd11713', NULL, NULL, 'GINS_A_psf3', NULL, 'GINS_A_psf3', NULL, NULL, NULL, 2),
(14085, NULL, 'cd14500', NULL, NULL, 'PTP-IVa', NULL, 'PTP-IVa', NULL, NULL, NULL, 2),
(14086, NULL, 'cd06220', NULL, NULL, 'DHOD_e_trans_like2', NULL, 'DHOD_e_trans_like2', NULL, NULL, NULL, 2),
(14087, NULL, 'cd14724', NULL, NULL, 'ZIP_Gal4-like_1', NULL, 'ZIP_Gal4-like_1', NULL, NULL, NULL, 2),
(14088, NULL, 'cd10812', NULL, NULL, 'GH38N_AMII_ScAms1_like', NULL, 'GH38N_AMII_ScAms1_like', NULL, NULL, NULL, 2),
(14089, NULL, 'cd18551', NULL, NULL, 'ABC_6TM_LmrA_like', NULL, 'ABC_6TM_LmrA_like', NULL, NULL, NULL, 2),
(14090, NULL, 'cd14063', NULL, NULL, 'PK_KSR', NULL, 'PK_KSR', NULL, NULL, NULL, 2),
(14091, NULL, 'cd12909', NULL, NULL, 'SPRY_RanBP9_10', NULL, 'SPRY_RanBP9_10', NULL, NULL, 32023, 2),
(14092, NULL, 'cd09658', NULL, NULL, 'Cas5_I-B', NULL, 'Cas5_I-B', NULL, NULL, NULL, 2),
(14093, NULL, 'cd12376', NULL, NULL, 'RRM2_Hu_like', NULL, 'RRM2_Hu_like', NULL, NULL, NULL, 2),
(14094, NULL, 'cd12686', NULL, NULL, 'RRM1_PTBPH1_PTBPH2', NULL, 'RRM1_PTBPH1_PTBPH2', NULL, NULL, 32442, 2),
(14095, NULL, 'cd01097', NULL, NULL, 'Tetrahydromethanopterin_reductase', NULL, 'Tetrahydromethanopterin_reductase', NULL, NULL, NULL, 2),
(14096, NULL, 'cd02167', NULL, NULL, 'NMNAT_NadR', NULL, 'NMNAT_NadR', NULL, NULL, 30416, 2),
(14097, NULL, 'cd13882', NULL, NULL, 'CuRO_2_Tv-LCC_like', NULL, 'CuRO_2_Tv-LCC_like', NULL, NULL, NULL, 2),
(14098, NULL, 'cd04920', NULL, NULL, 'ACT_AKiii-DAPDC_2', NULL, 'ACT_AKiii-DAPDC_2', NULL, NULL, NULL, 2),
(14099, NULL, 'cd15480', NULL, NULL, 'fMyo2p_CBD', NULL, 'fMyo2p_CBD', NULL, NULL, NULL, 2),
(14100, NULL, 'cd17212', NULL, NULL, 'RA_RGL3', NULL, 'RA_RGL3', NULL, NULL, NULL, 2),
(14101, NULL, 'cd01001', NULL, NULL, 'PBP2_HisJ_LAO_like', NULL, 'PBP2_HisJ_LAO_like', NULL, NULL, NULL, 2),
(14102, NULL, 'cd11723', NULL, NULL, 'YabN_N_like', NULL, 'YabN_N_like', NULL, NULL, 12757, 2),
(14103, NULL, 'cd00308', NULL, NULL, 'enolase_like', NULL, 'enolase_like', NULL, NULL, NULL, 2),
(14104, NULL, 'cd12239', NULL, NULL, 'RRM2_RBM40_like', NULL, 'RRM2_RBM40_like', NULL, NULL, NULL, 2),
(14105, NULL, 'cd14399', NULL, NULL, 'UBA_PLICs', NULL, 'UBA_PLICs', NULL, NULL, NULL, 2),
(14106, NULL, 'cd01479', NULL, NULL, 'Sec24-like', NULL, 'Sec24-like', NULL, NULL, 30061, 2),
(14107, NULL, 'cd05229', NULL, NULL, 'SDR_a3', NULL, 'SDR_a3', NULL, NULL, NULL, 2),
(14108, NULL, 'cd10005', NULL, NULL, 'HDAC3', NULL, 'HDAC3', NULL, NULL, NULL, 2);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(14109, NULL, 'cd09142', NULL, NULL, 'PLDc_pPLD_like_2', NULL, 'PLDc_pPLD_like_2', NULL, NULL, NULL, 2),
(14110, NULL, 'cd00532', NULL, NULL, 'MGS-like', NULL, 'MGS-like', NULL, NULL, NULL, 2),
(14111, NULL, 'cd16848', NULL, NULL, 'STAT4_DBD', NULL, 'STAT4_DBD', NULL, NULL, NULL, 2),
(14112, NULL, 'cd13968', NULL, NULL, 'PKc_like', NULL, 'PKc_like', NULL, NULL, NULL, 2),
(14113, NULL, 'cd19931', NULL, NULL, 'REC_NarL', NULL, 'REC_NarL', NULL, NULL, NULL, 2),
(14114, NULL, 'cd04441', NULL, NULL, 'DEP_2_DEP6', NULL, 'DEP_2_DEP6', NULL, NULL, 27753, 2),
(14115, NULL, 'cd00206', NULL, NULL, 'snake_toxin', NULL, 'snake_toxin', NULL, NULL, 6142, 2),
(14116, NULL, 'cd12434', NULL, NULL, 'RRM_RCAN_like', NULL, 'RRM_RCAN_like', NULL, NULL, NULL, 2),
(14117, NULL, 'cd08383', NULL, NULL, 'C2A_RasGAP', NULL, 'C2A_RasGAP', NULL, NULL, NULL, 2),
(14118, NULL, 'cd18452', NULL, NULL, 'BACK_KLHL12', NULL, 'BACK_KLHL12', NULL, NULL, NULL, 2),
(14119, NULL, 'cd02266', NULL, NULL, 'SDR', NULL, 'SDR', NULL, NULL, NULL, 2),
(14120, NULL, 'cd16586', NULL, NULL, 'RING-HC_TRIM2_like_C-VII', NULL, 'RING-HC_TRIM2_like_C-VII', NULL, NULL, NULL, 2),
(14121, NULL, 'cd03683', NULL, NULL, 'ClC_1_like', NULL, 'ClC_1_like', NULL, NULL, NULL, 2),
(14122, NULL, 'cd15784', NULL, NULL, 'PH_RUTBC', NULL, 'PH_RUTBC', NULL, NULL, 28142, 2),
(14123, NULL, 'cd14780', NULL, NULL, 'HmpPa-globin-like', NULL, 'HmpPa-globin-like', NULL, NULL, NULL, 2),
(14124, NULL, 'cd17268', NULL, NULL, 'RMtype1_S_Ara36733I_TRD1-CR1_like', NULL, 'RMtype1_S_Ara36733I_TRD1-CR1_like', NULL, NULL, NULL, 2),
(14125, NULL, 'cd03372', NULL, NULL, 'TPP_ComE', NULL, 'TPP_ComE', NULL, NULL, 16439, 2),
(14126, NULL, 'cd11017', NULL, NULL, 'Phytocyanin_like_1', NULL, 'Phytocyanin_like_1', NULL, NULL, NULL, 2),
(14127, NULL, 'cd14723', NULL, NULL, 'ZIP_Ppr1', NULL, 'ZIP_Ppr1', NULL, NULL, NULL, 2),
(14128, NULL, 'cd07280', NULL, NULL, 'PX_YPT35', NULL, 'PX_YPT35', NULL, NULL, 31204, 2),
(14129, NULL, 'cd14732', NULL, NULL, 'LodA', NULL, 'LodA', NULL, NULL, 30146, 2),
(14130, NULL, 'cd05051', NULL, NULL, 'PTKc_DDR', NULL, 'PTKc_DDR', NULL, NULL, NULL, 2),
(14131, NULL, 'cd08650', NULL, NULL, 'FMT_core_HypX_N', NULL, 'FMT_core_HypX_N', NULL, NULL, NULL, 2),
(14132, NULL, 'cd11769', NULL, NULL, 'SH3_CSK', NULL, 'SH3_CSK', NULL, NULL, NULL, 2),
(14133, NULL, 'cd06867', NULL, NULL, 'PX_SNX41_42', NULL, 'PX_SNX41_42', NULL, NULL, 35907, 2),
(14134, NULL, 'cd18913', NULL, NULL, 'bHLH-O_hairy_like', NULL, 'bHLH-O_hairy_like', NULL, NULL, NULL, 2),
(14135, NULL, 'cd19617', NULL, NULL, 'FABP12', NULL, 'FABP12', NULL, NULL, NULL, 2),
(14136, NULL, 'cd01909', NULL, NULL, 'betaLS_CarA_N', NULL, 'betaLS_CarA_N', NULL, NULL, NULL, 2),
(14137, NULL, 'cd06557', NULL, NULL, 'KPHMT-like', NULL, 'KPHMT-like', NULL, NULL, 2403, 2),
(14138, NULL, 'cd00258', NULL, NULL, 'GM2-AP', NULL, 'GM2-AP', NULL, NULL, NULL, 2),
(14139, NULL, 'cd12359', NULL, NULL, 'RRM2_VICKZ', NULL, 'RRM2_VICKZ', NULL, NULL, NULL, 2),
(14140, NULL, 'cd07399', NULL, NULL, 'MPP_YvnB', NULL, 'MPP_YvnB', NULL, NULL, NULL, 2),
(14141, NULL, 'cd11927', NULL, NULL, 'SH3_SH3RF1_1', NULL, 'SH3_SH3RF1_1', NULL, NULL, NULL, 2),
(14142, NULL, 'cd12321', NULL, NULL, 'RRM1_TDP43', NULL, 'RRM1_TDP43', NULL, NULL, NULL, 2),
(14143, NULL, 'cd10909', NULL, NULL, 'ChtBD1_GH18_2', NULL, 'ChtBD1_GH18_2', NULL, NULL, NULL, 2),
(14144, NULL, 'cd18109', NULL, NULL, 'SpoU-like_RNA-MTase', NULL, 'SpoU-like_RNA-MTase', NULL, NULL, NULL, 2),
(14145, NULL, 'cd05676', NULL, NULL, 'M20_dipept_like_CNDP', NULL, 'M20_dipept_like_CNDP', NULL, NULL, NULL, 2),
(14146, NULL, 'cd01684', NULL, NULL, 'Tet_like_IV', NULL, 'Tet_like_IV', NULL, NULL, NULL, 2),
(14147, NULL, 'cd08059', NULL, NULL, 'MPN_prok_mb', NULL, 'MPN_prok_mb', NULL, NULL, NULL, 2),
(14148, NULL, 'cd18018', NULL, NULL, 'DEXHc_RecQ4-like', NULL, 'DEXHc_RecQ4-like', NULL, NULL, NULL, 2),
(14149, NULL, 'cd13248', NULL, NULL, 'PH_PEPP1_2_3', NULL, 'PH_PEPP1_2_3', NULL, NULL, 27713, 2),
(14150, NULL, 'cd15234', NULL, NULL, '7tmA_OR7-like', NULL, '7tmA_OR7-like', NULL, NULL, NULL, 2);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(14151, NULL, 'cd19998', NULL, NULL, 'PBP1_ABC_sugar_binding-like', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, NULL, 2),
(14152, NULL, 'cd06284', NULL, NULL, 'PBP1_LacI-like', NULL, 'PBP1_LacI-like', NULL, NULL, NULL, 2),
(14153, NULL, 'cd18976', NULL, NULL, 'CD_POL_like', NULL, 'CD_POL_like', NULL, NULL, NULL, 2),
(14154, NULL, 'cd17293', NULL, NULL, 'RMtype1_S_Ppo21ORF8840P_TRD1-CR1_like', NULL, 'RMtype1_S_Ppo21ORF8840P_TRD1-CR1_like', NULL, NULL, NULL, 2),
(14155, NULL, 'cd05133', NULL, NULL, 'RasGAP_IQGAP1', NULL, 'RasGAP_IQGAP1', NULL, NULL, NULL, 2),
(14156, NULL, 'cd07294', NULL, NULL, 'PX_SNX12', NULL, 'PX_SNX12', NULL, NULL, NULL, 2),
(14157, NULL, 'cd06459', NULL, NULL, 'M3B_PepF', NULL, 'M3B_PepF', NULL, NULL, NULL, 2),
(14158, NULL, 'cd00154', NULL, NULL, 'Rab', NULL, 'Rab', NULL, NULL, NULL, 2),
(14159, NULL, 'cd18941', NULL, NULL, 'bHLH_TS_OLIG3', NULL, 'bHLH_TS_OLIG3', NULL, NULL, NULL, 2),
(14160, NULL, 'cd19596', NULL, NULL, 'serpin_fungal', NULL, 'serpin_fungal', NULL, NULL, NULL, 2),
(14161, NULL, 'cd05706', NULL, NULL, 'S1_Rrp5_repeat_sc10', NULL, 'S1_Rrp5_repeat_sc10', NULL, NULL, NULL, 2),
(14162, NULL, 'cd10354', NULL, NULL, 'SH2_Cterm_RasGAP', NULL, 'SH2_Cterm_RasGAP', NULL, NULL, 29910, 2),
(14163, NULL, 'cd10511', NULL, NULL, 'Zn-ribbon_TFS', NULL, 'Zn-ribbon_TFS', NULL, NULL, NULL, 2),
(14164, NULL, 'cd14736', NULL, NULL, 'BACK_AtBPM-like', NULL, 'BACK_AtBPM-like', NULL, NULL, 29972, 2),
(14165, NULL, 'cd07612', NULL, NULL, 'BAR_Bin2', NULL, 'BAR_Bin2', NULL, NULL, NULL, 2),
(14166, NULL, 'cd02752', NULL, NULL, 'MopB_Formate-Dh-Na-like', NULL, 'MopB_Formate-Dh-Na-like', NULL, NULL, NULL, 2),
(14167, NULL, 'cd13541', NULL, NULL, 'PBP2_ModA_like_2', NULL, 'PBP2_ModA_like_2', NULL, NULL, NULL, 2),
(14168, NULL, 'cd14140', NULL, NULL, 'STKc_ACVR2b', NULL, 'STKc_ACVR2b', NULL, NULL, NULL, 2),
(14169, NULL, 'cd04843', NULL, NULL, 'Peptidases_S8_11', NULL, 'Peptidases_S8_11', NULL, NULL, 22284, 2),
(14170, NULL, 'cd01242', NULL, NULL, 'PH_ROCK', NULL, 'PH_ROCK', NULL, NULL, NULL, 2),
(14171, NULL, 'cd15952', NULL, NULL, '7tmA_OR52E-like', NULL, '7tmA_OR52E-like', NULL, NULL, NULL, 2),
(14172, NULL, 'cd17960', NULL, NULL, 'DEADc_DDX55', NULL, 'DEADc_DDX55', NULL, NULL, NULL, 2),
(14173, NULL, 'cd05061', NULL, NULL, 'PTKc_InsR', NULL, 'PTKc_InsR', NULL, NULL, NULL, 2),
(14174, NULL, 'cd15063', NULL, NULL, '7tmA_Octopamine_R', NULL, '7tmA_Octopamine_R', NULL, NULL, NULL, 2),
(14175, NULL, 'cd04268', NULL, NULL, 'ZnMc_MMP_like', NULL, 'ZnMc_MMP_like', NULL, NULL, NULL, 2),
(14176, NULL, 'cd15279', NULL, NULL, '7tmC_RAIG1_4_GPRC5A_D', NULL, '7tmC_RAIG1_4_GPRC5A_D', NULL, NULL, NULL, 2),
(14177, NULL, 'cd15777', NULL, NULL, 'CRBN_C_like', NULL, 'CRBN_C_like', NULL, NULL, 29624, 2),
(14178, NULL, 'cd02890', NULL, NULL, 'PTase', NULL, 'PTase', NULL, NULL, NULL, 2),
(14179, NULL, 'cd14022', NULL, NULL, 'PK_TRB2', NULL, 'PK_TRB2', NULL, NULL, NULL, 2),
(14180, NULL, 'cd13930', NULL, NULL, 'PT-Tnase', NULL, 'PT-Tnase', NULL, NULL, NULL, 2),
(14181, NULL, 'cd09587', NULL, NULL, 'SAM_HARP', NULL, 'SAM_HARP', NULL, NULL, 33537, 2),
(14182, NULL, 'cd09223', NULL, NULL, 'Photo_RC', NULL, 'Photo_RC', NULL, NULL, NULL, 2),
(14183, NULL, 'cd16439', NULL, NULL, 'beta_Kdo_transferase_KpsC_2', NULL, 'beta_Kdo_transferase_KpsC_2', NULL, NULL, NULL, 2),
(14184, NULL, 'cd13429', NULL, NULL, 'UreI_AmiS_like_2', NULL, 'UreI_AmiS_like_2', NULL, NULL, NULL, 2),
(14185, NULL, 'cd18795', NULL, NULL, 'SF2_C_Ski2', NULL, 'SF2_C_Ski2', NULL, NULL, NULL, 2),
(14186, NULL, 'cd03253', NULL, NULL, 'ABCC_ATM1_transporter', NULL, 'ABCC_ATM1_transporter', NULL, NULL, NULL, 2),
(14187, NULL, 'cd09696', NULL, NULL, 'Cas3_I', NULL, 'Cas3_I', NULL, NULL, NULL, 2),
(14188, NULL, 'cd02168', NULL, NULL, 'NMNAT_Nudix', NULL, 'NMNAT_Nudix', NULL, NULL, 30401, 2),
(14189, NULL, 'cd13546', NULL, NULL, 'PBP2_BitB', NULL, 'PBP2_BitB', NULL, NULL, NULL, 2),
(14190, NULL, 'cd16670', NULL, NULL, 'RING-H2_RNF215', NULL, 'RING-H2_RNF215', NULL, NULL, NULL, 2),
(14191, NULL, 'cd08570', NULL, NULL, 'GDPD_YPL206cp_fungi', NULL, 'GDPD_YPL206cp_fungi', NULL, NULL, NULL, 2);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(14192, NULL, 'cd08986', NULL, NULL, 'GH43-like', NULL, 'GH43-like', NULL, NULL, NULL, 2),
(14193, NULL, 'cd05587', NULL, NULL, 'STKc_cPKC', NULL, 'STKc_cPKC', NULL, NULL, NULL, 2),
(14194, NULL, 'cd11500', NULL, NULL, 'SLC6sbd_PROT', NULL, 'SLC6sbd_PROT', NULL, NULL, NULL, 2),
(14195, NULL, 'cd01177', NULL, NULL, 'IPT_NFkappaB', NULL, 'IPT_NFkappaB', NULL, NULL, 26634, 2),
(14196, NULL, 'cd04029', NULL, NULL, 'C2A_SLP-4_5', NULL, 'C2A_SLP-4_5', NULL, NULL, 31950, 2),
(14197, NULL, 'cd15775', NULL, NULL, 'FYVE2_BSN', NULL, 'FYVE2_BSN', NULL, NULL, NULL, 2),
(14198, NULL, 'cd02508', NULL, NULL, 'ADP_Glucose_PP', NULL, 'ADP_Glucose_PP', NULL, NULL, NULL, 2),
(14199, NULL, 'cd06359', NULL, NULL, 'PBP1_Nba-like', NULL, 'PBP1_Nba-like', NULL, NULL, NULL, 2),
(14200, NULL, 'cd17287', NULL, NULL, 'RMtype1_S_EcoN10ORF171P_TRD2-CR2_like', NULL, 'RMtype1_S_EcoN10ORF171P_TRD2-CR2_like', NULL, NULL, NULL, 2),
(14201, NULL, 'cd05175', NULL, NULL, 'PI3Kc_IA_alpha', NULL, 'PI3Kc_IA_alpha', NULL, NULL, 31323, 2),
(14202, NULL, 'cd19734', NULL, NULL, 'bHLH-PAS_CLOCK', NULL, 'bHLH-PAS_CLOCK', NULL, NULL, NULL, 2),
(14203, NULL, 'cd00002', NULL, NULL, 'YbaK_deacylase', NULL, 'YbaK_deacylase', NULL, NULL, 5348, 2),
(14204, NULL, 'cd07517', NULL, NULL, 'HAD_HPP', NULL, 'HAD_HPP', NULL, NULL, NULL, 2),
(14205, NULL, 'cd12643', NULL, NULL, 'RRM_CFIm68', NULL, 'RRM_CFIm68', NULL, NULL, NULL, 2),
(14206, NULL, 'cd05355', NULL, NULL, 'SDR_c1', NULL, 'SDR_c1', NULL, NULL, NULL, 2),
(14207, NULL, 'cd14955', NULL, NULL, 'NHL_like_4', NULL, 'NHL_like_4', NULL, NULL, NULL, 2),
(14208, NULL, 'cd01641', NULL, NULL, 'Bacterial_IMPase_like_1', NULL, 'Bacterial_IMPase_like_1', NULL, NULL, NULL, 2),
(14209, NULL, 'cd13642', NULL, NULL, 'PBP2_BCP_1', NULL, 'PBP2_BCP_1', NULL, NULL, NULL, 2),
(14210, NULL, 'cd03741', NULL, NULL, 'SOCS_SOCS7', NULL, 'SOCS_SOCS7', NULL, NULL, 27833, 2),
(14211, NULL, 'cd05164', NULL, NULL, 'PIKKc', NULL, 'PIKKc', NULL, NULL, NULL, 2),
(14212, NULL, 'cd11615', NULL, NULL, 'SAF_NeuB_like', NULL, 'SAF_NeuB_like', NULL, NULL, NULL, 2),
(14213, NULL, 'cd16264', NULL, NULL, 'snRNP_III', NULL, 'snRNP_III', NULL, NULL, NULL, 2),
(14214, NULL, 'cd12628', NULL, NULL, 'RRM2_IGF2BP1', NULL, 'RRM2_IGF2BP1', NULL, NULL, 33351, 2),
(14215, NULL, 'cd18624', NULL, NULL, 'GH32_Fruct1-like', NULL, 'GH32_Fruct1-like', NULL, NULL, NULL, 2),
(14216, NULL, 'cd00831', NULL, NULL, 'CHS_like', NULL, 'CHS_like', NULL, NULL, NULL, 2),
(14217, NULL, 'cd06582', NULL, NULL, 'TM_PBP1_LivH_like', NULL, 'TM_PBP1_LivH_like', NULL, NULL, NULL, 2),
(14218, NULL, 'cd08279', NULL, NULL, 'Zn_ADH_class_III', NULL, 'Zn_ADH_class_III', NULL, NULL, NULL, 2),
(14219, NULL, 'cd14847', NULL, NULL, 'DD-carboxypeptidase_like', NULL, 'DD-carboxypeptidase_like', NULL, NULL, NULL, 2),
(14220, NULL, 'cd15283', NULL, NULL, '7tmC_V2R_pheromone', NULL, '7tmC_V2R_pheromone', NULL, NULL, NULL, 2),
(14221, NULL, 'cd15849', NULL, NULL, 'SNARE_Sso1', NULL, 'SNARE_Sso1', NULL, NULL, NULL, 2),
(14222, NULL, 'cd04381', NULL, NULL, 'RhoGap_RalBP1', NULL, 'RhoGap_RalBP1', NULL, NULL, NULL, 2),
(14223, NULL, 'cd07139', NULL, NULL, 'ALDH_AldA-Rv0768', NULL, 'ALDH_AldA-Rv0768', NULL, NULL, NULL, 2),
(14224, NULL, 'cd16490', NULL, NULL, 'RING-CH-C4HC3_FANCL', NULL, 'RING-CH-C4HC3_FANCL', NULL, NULL, NULL, 2),
(14225, NULL, 'cd16937', NULL, NULL, 'HATPase_SMCHD1-like', NULL, 'HATPase_SMCHD1-like', NULL, NULL, NULL, 2),
(14226, NULL, 'cd17359', NULL, NULL, 'MFS_XylE_like', NULL, 'MFS_XylE_like', NULL, NULL, NULL, 2),
(14227, NULL, 'cd02875', NULL, NULL, 'GH18_chitobiase', NULL, 'GH18_chitobiase', NULL, NULL, NULL, 2),
(14228, NULL, 'cd05935', NULL, NULL, 'LC_FACS_like', NULL, 'LC_FACS_like', NULL, NULL, NULL, 2),
(14229, NULL, 'cd04708', NULL, NULL, 'BAH_plantDCM_II', NULL, 'BAH_plantDCM_II', NULL, NULL, NULL, 2),
(14230, NULL, 'cd03703', NULL, NULL, 'aeIF5B_II', NULL, 'aeIF5B_II', NULL, NULL, NULL, 2),
(14231, NULL, 'cd16747', NULL, NULL, 'RING-HC_RNF212B', NULL, 'RING-HC_RNF212B', NULL, NULL, NULL, 2),
(14232, NULL, 'cd17623', NULL, NULL, 'REC_OmpR_CpxR', NULL, 'REC_OmpR_CpxR', NULL, NULL, NULL, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(14233, NULL, 'cd09694', NULL, NULL, 'Csm6_III-A', NULL, 'Csm6_III-A', NULL, NULL, NULL, 2),
(14234, NULL, 'cd06247', NULL, NULL, 'M14_CPO', NULL, 'M14_CPO', NULL, NULL, 32375, 2),
(14235, NULL, 'cd01136', NULL, NULL, 'ATPase_flagellum-secretory_path_III', NULL, 'ATPase_flagellum-secretory_path_III', NULL, NULL, NULL, 2),
(14236, NULL, 'cd15397', NULL, NULL, '7tmA_NPY4R', NULL, '7tmA_NPY4R', NULL, NULL, NULL, 2),
(14237, NULL, 'cd08385', NULL, NULL, 'C2A_Synaptotagmin-1-5-6-9-10', NULL, 'C2A_Synaptotagmin-1-5-6-9-10', NULL, NULL, NULL, 2),
(14238, NULL, 'cd06432', NULL, NULL, 'GT8_HUGT1_C_like', NULL, 'GT8_HUGT1_C_like', NULL, NULL, NULL, 2),
(14239, NULL, 'cd16990', NULL, NULL, 'ENTH_Epsin', NULL, 'ENTH_Epsin', NULL, NULL, NULL, 2),
(14240, NULL, 'cd06571', NULL, NULL, 'Bac_DnaA_C', NULL, 'Bac_DnaA_C', NULL, NULL, 8706, 2),
(14241, NULL, 'cd05652', NULL, NULL, 'M20_ArgE_DapE-like_fungal', NULL, 'M20_ArgE_DapE-like_fungal', NULL, NULL, NULL, 2),
(14242, NULL, 'cd04270', NULL, NULL, 'ZnMc_TACE_like', NULL, 'ZnMc_TACE_like', NULL, NULL, 4495, 2),
(14243, NULL, 'cd11904', NULL, NULL, 'SH3_Nck1_3', NULL, 'SH3_Nck1_3', NULL, NULL, 28260, 2),
(14244, NULL, 'cd14272', NULL, NULL, 'UBA_AMPK-RKs', NULL, 'UBA_AMPK-RKs', NULL, NULL, NULL, 2),
(14245, NULL, 'cd19196', NULL, NULL, 'PR-SET_PRDM12', NULL, 'PR-SET_PRDM12', NULL, NULL, 36484, 2),
(14246, NULL, 'cd17408', NULL, NULL, 'MFS_unc93B1', NULL, 'MFS_unc93B1', NULL, NULL, NULL, 2),
(14247, NULL, 'cd05504', NULL, NULL, 'Bromo_Acf1_like', NULL, 'Bromo_Acf1_like', NULL, NULL, 31726, 2),
(14248, NULL, 'cd05333', NULL, NULL, 'BKR_SDR_c', NULL, 'BKR_SDR_c', NULL, NULL, NULL, 2),
(14249, NULL, 'cd04728', NULL, NULL, 'ThiG', NULL, 'ThiG', NULL, NULL, 7821, 2),
(14250, NULL, 'cd16031', NULL, NULL, 'G6S_like', NULL, 'G6S_like', NULL, NULL, NULL, 2),
(14251, NULL, 'cd01717', NULL, NULL, 'Sm_B', NULL, 'Sm_B', NULL, NULL, NULL, 2),
(14252, NULL, 'cd06169', NULL, NULL, 'BMC', NULL, 'BMC', NULL, NULL, NULL, 2),
(14253, NULL, 'cd18080', NULL, NULL, 'TrmD-like', NULL, 'TrmD-like', NULL, NULL, 2522, 2),
(14254, NULL, 'cd15548', NULL, NULL, 'PHD_ASH1L', NULL, 'PHD_ASH1L', NULL, NULL, 34245, 2),
(14255, NULL, 'cd16315', NULL, NULL, 'EVM-1-like_MBL-B3', NULL, 'EVM-1-like_MBL-B3', NULL, NULL, NULL, 2),
(14256, NULL, 'cd14737', NULL, NULL, 'PAAR_1', NULL, 'PAAR_1', NULL, NULL, NULL, 2),
(14257, NULL, 'cd17943', NULL, NULL, 'DEADc_DDX20', NULL, 'DEADc_DDX20', NULL, NULL, NULL, 2),
(14258, NULL, 'cd07585', NULL, NULL, 'nitrilase_7', NULL, 'nitrilase_7', NULL, NULL, NULL, 2),
(14259, NULL, 'cd15828', NULL, NULL, 'SPRY_PRY_TRIM60', NULL, 'SPRY_PRY_TRIM60', NULL, NULL, 32418, 2),
(14260, NULL, 'cd01132', NULL, NULL, 'F1_ATPase_alpha', NULL, 'F1_ATPase_alpha', NULL, NULL, 32972, 2),
(14261, NULL, 'cd03239', NULL, NULL, 'ABC_SMC_head', NULL, 'ABC_SMC_head', NULL, NULL, NULL, 2),
(14262, NULL, 'cd10304', NULL, NULL, 'GST_C_Arc1p_N_like', NULL, 'GST_C_Arc1p_N_like', NULL, NULL, NULL, 2),
(14263, NULL, 'cd08897', NULL, NULL, 'SRPBCC_CalC_Aha1-like_4', NULL, 'SRPBCC_CalC_Aha1-like_4', NULL, NULL, NULL, 2),
(14264, NULL, 'cd07162', NULL, NULL, 'NR_DBD_PXR', NULL, 'NR_DBD_PXR', NULL, NULL, NULL, 2),
(14265, NULL, 'cd17434', NULL, NULL, 'MFS_GLUT6_Class3', NULL, 'MFS_GLUT6_Class3', NULL, NULL, NULL, 2),
(14266, NULL, 'cd17254', NULL, NULL, 'RMtype1_S_FclI-TRD1-CR1_like', NULL, 'RMtype1_S_FclI-TRD1-CR1_like', NULL, NULL, NULL, 2),
(14267, NULL, 'cd03460', NULL, NULL, '1,2-CTD', NULL, '1,2-CTD', NULL, NULL, 12677, 2),
(14268, NULL, 'cd19465', NULL, NULL, 'CRBP4', NULL, 'CRBP4', NULL, NULL, NULL, 2),
(14269, NULL, 'cd05144', NULL, NULL, 'RIO2_C', NULL, 'RIO2_C', NULL, NULL, 26311, 2),
(14270, NULL, 'cd12001', NULL, NULL, 'SH3_BCAR1', NULL, 'SH3_BCAR1', NULL, NULL, 28365, 2),
(14271, NULL, 'cd02583', NULL, NULL, 'RNAP_III_RPC1_N', NULL, 'RNAP_III_RPC1_N', NULL, NULL, 31190, 2),
(14272, NULL, 'cd08372', NULL, NULL, 'EEP', NULL, 'EEP', NULL, NULL, NULL, 2),
(14273, NULL, 'cd17059', NULL, NULL, 'Ubl_OTU1', NULL, 'Ubl_OTU1', NULL, NULL, NULL, 2),
(14274, NULL, 'cd14367', NULL, NULL, 'CUE_CUED2', NULL, 'CUE_CUED2', NULL, NULL, 27485, 2);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(14275, NULL, 'cd15929', NULL, NULL, '7tmB1_GlucagonR-like', NULL, '7tmB1_GlucagonR-like', NULL, NULL, NULL, 2),
(14276, NULL, 'cd15671', NULL, NULL, 'ePHD_JADE', NULL, 'ePHD_JADE', NULL, NULL, NULL, 2),
(14277, NULL, 'cd15155', NULL, NULL, '7tmA_LPAR4', NULL, '7tmA_LPAR4', NULL, NULL, NULL, 2),
(14278, NULL, 'cd00320', NULL, NULL, 'cpn10', NULL, 'cpn10', NULL, NULL, 14568, 2),
(14279, NULL, 'cd12329', NULL, NULL, 'RRM2_hnRNPD_like', NULL, 'RRM2_hnRNPD_like', NULL, NULL, NULL, 2),
(14280, NULL, 'cd17929', NULL, NULL, 'DEXHc_priA', NULL, 'DEXHc_priA', NULL, NULL, NULL, 2),
(14281, NULL, 'cd16715', NULL, NULL, 'vRING-HC_IRF2BP1', NULL, 'vRING-HC_IRF2BP1', NULL, NULL, NULL, 2),
(14282, NULL, 'cd08476', NULL, NULL, 'PBP2_CrgA_like_7', NULL, 'PBP2_CrgA_like_7', NULL, NULL, NULL, 2),
(14283, NULL, 'cd04664', NULL, NULL, 'Nudix_Hydrolase_7', NULL, 'Nudix_Hydrolase_7', NULL, NULL, NULL, 2),
(14284, NULL, 'cd00310', NULL, NULL, 'ATP-synt_Fo_a_6', NULL, 'ATP-synt_Fo_a_6', NULL, NULL, NULL, 2),
(14285, NULL, 'cd08873', NULL, NULL, 'START_STARD14_15-like', NULL, 'START_STARD14_15-like', NULL, NULL, NULL, 2),
(14286, NULL, 'cd07914', NULL, NULL, 'IGPD', NULL, 'IGPD', NULL, NULL, 4708, 2),
(14287, NULL, 'cd07663', NULL, NULL, 'BAR_SNX5', NULL, 'BAR_SNX5', NULL, NULL, NULL, 2),
(14288, NULL, 'cd00121', NULL, NULL, 'MATH', NULL, 'MATH', NULL, NULL, 1424, 2),
(14289, NULL, 'cd14657', NULL, NULL, 'Imelysin_IrpA-like', NULL, 'Imelysin_IrpA-like', NULL, NULL, NULL, 2),
(14290, NULL, 'cd07334', NULL, NULL, 'M48C_loiP_like', NULL, 'M48C_loiP_like', NULL, NULL, NULL, 2),
(14291, NULL, 'cd10575', NULL, NULL, 'TNFRSF6B', NULL, 'TNFRSF6B', NULL, NULL, 19784, 2),
(14292, NULL, 'cd00003', NULL, NULL, 'PNPsynthase', NULL, 'PNPsynthase', NULL, NULL, 730, 2),
(14293, NULL, 'cd14776', NULL, NULL, 'HmpEc-globin-like', NULL, 'HmpEc-globin-like', NULL, NULL, NULL, 2),
(14294, NULL, 'cd08719', NULL, NULL, 'RGS_SNX13', NULL, 'RGS_SNX13', NULL, NULL, 28532, 2),
(14295, NULL, 'cd01470', NULL, NULL, 'vWA_complement_factors', NULL, 'vWA_complement_factors', NULL, NULL, NULL, 2),
(14296, NULL, 'cd04481', NULL, NULL, 'RPA1_DBD_B_like', NULL, 'RPA1_DBD_B_like', NULL, NULL, NULL, 2),
(14297, NULL, 'cd15917', NULL, NULL, '7tmA_OR51_52-like', NULL, '7tmA_OR51_52-like', NULL, NULL, NULL, 2),
(14298, NULL, 'cd15977', NULL, NULL, '7tmA_ET-CR', NULL, '7tmA_ET-CR', NULL, NULL, NULL, 2),
(14299, NULL, 'cd15898', NULL, NULL, 'EFh_PI-PLC', NULL, 'EFh_PI-PLC', NULL, NULL, NULL, 2),
(14300, NULL, 'cd11289', NULL, NULL, 'gelsolin_S2_like', NULL, 'gelsolin_S2_like', NULL, NULL, NULL, 2),
(14301, NULL, 'cd18043', NULL, NULL, 'DEXXQc_SF1', NULL, 'DEXXQc_SF1', NULL, NULL, NULL, 2),
(14302, NULL, 'cd15402', NULL, NULL, '7tmA_Mel1A', NULL, '7tmA_Mel1A', NULL, NULL, NULL, 2),
(14303, NULL, 'cd13743', NULL, NULL, 'SPRY_PRY_TRIM50', NULL, 'SPRY_PRY_TRIM50', NULL, NULL, NULL, 2),
(14304, NULL, 'cd18679', NULL, NULL, 'PIN_VapC-Af1683-like', NULL, 'PIN_VapC-Af1683-like', NULL, NULL, NULL, 2),
(14305, NULL, 'cd16765', NULL, NULL, 'RING-HC_TIF1beta', NULL, 'RING-HC_TIF1beta', NULL, NULL, 35917, 2),
(14306, NULL, 'cd00649', NULL, NULL, 'catalase_peroxidase_1', NULL, 'catalase_peroxidase_1', NULL, NULL, NULL, 2),
(14307, NULL, 'cd12514', NULL, NULL, 'RRM4_RBM12_like', NULL, 'RRM4_RBM12_like', NULL, NULL, NULL, 2),
(14308, NULL, 'cd03462', NULL, NULL, '1,2-CCD', NULL, '1,2-CCD', NULL, NULL, 12684, 2),
(14309, NULL, 'cd01573', NULL, NULL, 'modD_like', NULL, 'modD_like', NULL, NULL, NULL, 2),
(14310, NULL, 'cd09507', NULL, NULL, 'SAM_DGK-delta-eta', NULL, 'SAM_DGK-delta-eta', NULL, NULL, NULL, 2),
(14311, NULL, 'cd02658', NULL, NULL, 'Peptidase_C19B', NULL, 'Peptidase_C19B', NULL, NULL, NULL, 2),
(14312, NULL, 'cd08486', NULL, NULL, 'PBP2_CbnR', NULL, 'PBP2_CbnR', NULL, NULL, NULL, 2),
(14313, NULL, 'cd03768', NULL, NULL, 'SR_ResInv', NULL, 'SR_ResInv', NULL, NULL, NULL, 2),
(14314, NULL, 'cd08398', NULL, NULL, 'C2_PI3K_class_I_alpha', NULL, 'C2_PI3K_class_I_alpha', NULL, NULL, NULL, 2),
(14315, NULL, 'cd07436', NULL, NULL, 'PHP_PolX', NULL, 'PHP_PolX', NULL, NULL, NULL, 2);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(14316, NULL, 'cd05363', NULL, NULL, 'SDH_SDR_c', NULL, 'SDH_SDR_c', NULL, NULL, NULL, 2),
(14317, NULL, 'cd00896', NULL, NULL, 'PI3Kc_III', NULL, 'PI3Kc_III', NULL, NULL, NULL, 2),
(14318, NULL, 'cd03116', NULL, NULL, 'MobB', NULL, 'MobB', NULL, NULL, NULL, 2),
(14319, NULL, 'cd19916', NULL, NULL, 'OphMA_like', NULL, 'OphMA_like', NULL, NULL, NULL, 2),
(14320, NULL, 'cd08537', NULL, NULL, 'SAM_PNT-ESE-1-like', NULL, 'SAM_PNT-ESE-1-like', NULL, NULL, 35154, 2),
(14321, NULL, 'cd10540', NULL, NULL, 'SET_SpSet7-like', NULL, 'SET_SpSet7-like', NULL, NULL, NULL, 2),
(14322, NULL, 'cd05498', NULL, NULL, 'Bromo_Brdt_II_like', NULL, 'Bromo_Brdt_II_like', NULL, NULL, 34551, 2),
(14323, NULL, 'cd13937', NULL, NULL, 'PANDER_GnT-1_2_like', NULL, 'PANDER_GnT-1_2_like', NULL, NULL, 33237, 2),
(14324, NULL, 'cd09369', NULL, NULL, 'LIM1_Lhx2_Lhx9', NULL, 'LIM1_Lhx2_Lhx9', NULL, NULL, NULL, 2),
(14325, NULL, 'cd16151', NULL, NULL, 'sulfatase_like', NULL, 'sulfatase_like', NULL, NULL, NULL, 2),
(14326, NULL, 'cd07648', NULL, NULL, 'F-BAR_FCHO', NULL, 'F-BAR_FCHO', NULL, NULL, NULL, 2),
(14327, NULL, 'cd18492', NULL, NULL, 'BACK_BTBD16', NULL, 'BACK_BTBD16', NULL, NULL, NULL, 2),
(14328, NULL, 'cd04986', NULL, NULL, 'IgC_CH2_IgA', NULL, 'IgC_CH2_IgA', NULL, NULL, NULL, 2),
(14329, NULL, 'cd08601', NULL, NULL, 'GDPD_SaGlpQ_like', NULL, 'GDPD_SaGlpQ_like', NULL, NULL, NULL, 2),
(14330, NULL, 'cd08910', NULL, NULL, 'START_STARD2-like', NULL, 'START_STARD2-like', NULL, NULL, 30663, 2),
(14331, NULL, 'cd13295', NULL, NULL, 'PH_EFA6', NULL, 'PH_EFA6', NULL, NULL, NULL, 2),
(14332, NULL, 'cd12666', NULL, NULL, 'RRM2_RAVER2', NULL, 'RRM2_RAVER2', NULL, NULL, NULL, 2),
(14333, NULL, 'cd04781', NULL, NULL, 'HTH_MerR-like_sg6', NULL, 'HTH_MerR-like_sg6', NULL, NULL, NULL, 2),
(14334, NULL, 'cd09549', NULL, NULL, 'SAM_EPH-A10', NULL, 'SAM_EPH-A10', NULL, NULL, NULL, 2),
(14335, NULL, 'cd12402', NULL, NULL, 'RRM_eIF4B', NULL, 'RRM_eIF4B', NULL, NULL, NULL, 2),
(14336, NULL, 'cd07607', NULL, NULL, 'BAR_SH3P_plant', NULL, 'BAR_SH3P_plant', NULL, NULL, NULL, 2),
(14337, NULL, 'cd01127', NULL, NULL, 'TrwB', NULL, 'TrwB', NULL, NULL, 13911, 2),
(14338, NULL, 'cd09491', NULL, NULL, 'SAM_Ship2', NULL, 'SAM_Ship2', NULL, NULL, NULL, 2),
(14339, NULL, 'cd03079', NULL, NULL, 'GST_N_Metaxin2', NULL, 'GST_N_Metaxin2', NULL, NULL, NULL, 2),
(14340, NULL, 'cd14501', NULL, NULL, 'PFA-DSP', NULL, 'PFA-DSP', NULL, NULL, NULL, 2),
(14341, NULL, 'cd16438', NULL, NULL, 'beta_Kdo_transferase_KpsS_like', NULL, 'beta_Kdo_transferase_KpsS_like', NULL, NULL, NULL, 2),
(14342, NULL, 'cd18427', NULL, NULL, 'BTB_POZ_KCNS2', NULL, 'BTB_POZ_KCNS2', NULL, NULL, NULL, 2),
(14343, NULL, 'cd19752', NULL, NULL, 'AKR_unchar', NULL, 'AKR_unchar', NULL, NULL, NULL, 2),
(14344, NULL, 'cd04128', NULL, NULL, 'Spg1', NULL, 'Spg1', NULL, NULL, 15386, 2),
(14345, NULL, 'cd15704', NULL, NULL, 'ePHD_JADE1', NULL, 'ePHD_JADE1', NULL, NULL, NULL, 2),
(14346, NULL, 'cd16040', NULL, NULL, 'SPRY_PRY_SNTX', NULL, 'SPRY_PRY_SNTX', NULL, NULL, NULL, 2),
(14347, NULL, 'cd21563', NULL, NULL, 'Macro_cv_SUD-M_Nsp3-like', NULL, 'Macro_cv_SUD-M_Nsp3-like', NULL, NULL, 22380, 2),
(14348, NULL, 'cd06560', NULL, NULL, 'PriL', NULL, 'PriL', NULL, NULL, 16041, 2),
(14349, NULL, 'cd21569', NULL, NULL, 'SARS-like-CoV_M', NULL, 'SARS-like-CoV_M', NULL, NULL, 36360, 2),
(14350, NULL, 'cd14179', NULL, NULL, 'STKc_MSK1_C', NULL, 'STKc_MSK1_C', NULL, NULL, NULL, 2),
(14351, NULL, 'cd15485', NULL, NULL, 'ZIP_Cat8', NULL, 'ZIP_Cat8', NULL, NULL, NULL, 2),
(14352, NULL, 'cd10374', NULL, NULL, 'SH2_STAT3', NULL, 'SH2_STAT3', NULL, NULL, 28350, 2),
(14353, NULL, 'cd02639', NULL, NULL, 'R3H_RRM', NULL, 'R3H_RRM', NULL, NULL, 12886, 2),
(14354, NULL, 'cd13299', NULL, NULL, 'PH2_PH_fungal', NULL, 'PH2_PH_fungal', NULL, NULL, NULL, 2),
(14355, NULL, 'cd16501', NULL, NULL, 'RING-HC_CblA_like', NULL, 'RING-HC_CblA_like', NULL, NULL, NULL, 2),
(14356, NULL, 'cd06181', NULL, NULL, 'BI-1-like', NULL, 'BI-1-like', NULL, NULL, NULL, 2),
(14357, NULL, 'cd06863', NULL, NULL, 'PX_Atg24p', NULL, 'PX_Atg24p', NULL, NULL, NULL, 2);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(14358, NULL, 'cd10283', NULL, NULL, 'MnuA_DNase1-like', NULL, 'MnuA_DNase1-like', NULL, NULL, NULL, 2),
(14359, NULL, 'cd19995', NULL, NULL, 'PBP1_ABC_xylose_binding-like', NULL, 'PBP1_ABC_xylose_binding-like', NULL, NULL, NULL, 2),
(14360, NULL, 'cd15270', NULL, NULL, '7tmB1_GHRHR', NULL, '7tmB1_GHRHR', NULL, NULL, NULL, 2),
(14361, NULL, 'cd11346', NULL, NULL, 'AmyAc_plant_IsoA', NULL, 'AmyAc_plant_IsoA', NULL, NULL, 35471, 2),
(14362, NULL, 'cd19033', NULL, NULL, 'LGIC_ECD_nAChR_proto-like', NULL, 'LGIC_ECD_nAChR_proto-like', NULL, NULL, NULL, 2),
(14363, NULL, 'cd09435', NULL, NULL, 'LIM3_Zyxin', NULL, 'LIM3_Zyxin', NULL, NULL, NULL, 2),
(14364, NULL, 'cd17959', NULL, NULL, 'DEADc_DDX54', NULL, 'DEADc_DDX54', NULL, NULL, NULL, 2),
(14365, NULL, 'cd05928', NULL, NULL, 'MACS_euk', NULL, 'MACS_euk', NULL, NULL, NULL, 2),
(14366, NULL, 'cd16866', NULL, NULL, 'ARID_ARID2', NULL, 'ARID_ARID2', NULL, NULL, NULL, 2),
(14367, NULL, 'cd19194', NULL, NULL, 'PR-SET_PRDM10', NULL, 'PR-SET_PRDM10', NULL, NULL, 36734, 2),
(14368, NULL, 'cd10034', NULL, NULL, 'UDG_BdiUng_like', NULL, 'UDG_BdiUng_like', NULL, NULL, NULL, 2),
(14369, NULL, 'cd15718', NULL, NULL, 'FYVE_WDFY1_like', NULL, 'FYVE_WDFY1_like', NULL, NULL, NULL, 2),
(14370, NULL, 'cd01105', NULL, NULL, 'HTH_GlnR-like', NULL, 'HTH_GlnR-like', NULL, NULL, NULL, 2),
(14371, NULL, 'cd11770', NULL, NULL, 'SH3_Nephrocystin', NULL, 'SH3_Nephrocystin', NULL, NULL, 23533, 2),
(14372, NULL, 'cd16372', NULL, NULL, 'DMSOR_beta_like', NULL, 'DMSOR_beta_like', NULL, NULL, NULL, 2),
(14373, NULL, 'cd16761', NULL, NULL, 'RING-HC_MuRF3', NULL, 'RING-HC_MuRF3', NULL, NULL, 33955, 2),
(14374, NULL, 'cd02895', NULL, NULL, 'GGTase-I', NULL, 'GGTase-I', NULL, NULL, 30993, 2),
(14375, NULL, 'cd18549', NULL, NULL, 'ABC_6TM_YwjA_like', NULL, 'ABC_6TM_YwjA_like', NULL, NULL, NULL, 2),
(14376, NULL, 'cd05385', NULL, NULL, 'CAP_GLIPR1-like', NULL, 'CAP_GLIPR1-like', NULL, NULL, 2645, 2),
(14377, NULL, 'cd01403', NULL, NULL, 'Cyt_c_Oxidase_VIIb', NULL, 'Cyt_c_Oxidase_VIIb', NULL, NULL, 8968, 2),
(14378, NULL, 'cd01484', NULL, NULL, 'E1-2_like', NULL, 'E1-2_like', NULL, NULL, NULL, 2),
(14379, NULL, 'cd07103', NULL, NULL, 'ALDH_F5_SSADH_GabD', NULL, 'ALDH_F5_SSADH_GabD', NULL, NULL, NULL, 2),
(14380, NULL, 'cd07116', NULL, NULL, 'ALDH_ACDHII-AcoD', NULL, 'ALDH_ACDHII-AcoD', NULL, NULL, NULL, 2),
(14381, NULL, 'cd12702', NULL, NULL, 'RRM4_PTBP2', NULL, 'RRM4_PTBP2', NULL, NULL, 32398, 2),
(14382, NULL, 'cd00172', NULL, NULL, 'serpin', NULL, 'serpin', NULL, NULL, NULL, 2),
(14383, NULL, 'cd16408', NULL, NULL, 'ParB_N_like', NULL, 'ParB_N_like', NULL, NULL, NULL, 2),
(14384, NULL, 'cd04193', NULL, NULL, 'UDPGlcNAc_PPase', NULL, 'UDPGlcNAc_PPase', NULL, NULL, NULL, 2),
(14385, NULL, 'cd16167', NULL, NULL, 'OCRE_RBM10', NULL, 'OCRE_RBM10', NULL, NULL, 29487, 2),
(14386, NULL, 'cd00782', NULL, NULL, 'MutL_Trans', NULL, 'MutL_Trans', NULL, NULL, NULL, 2),
(14387, NULL, 'cd11801', NULL, NULL, 'SH3_JIP1_like', NULL, 'SH3_JIP1_like', NULL, NULL, NULL, 2),
(14388, NULL, 'cd03782', NULL, NULL, 'MATH_Meprin_Beta', NULL, 'MATH_Meprin_Beta', NULL, NULL, NULL, 2),
(14389, NULL, 'cd05357', NULL, NULL, 'PR_SDR_c', NULL, 'PR_SDR_c', NULL, NULL, NULL, 2),
(14390, NULL, 'cd06162', NULL, NULL, 'S2P-M50_PDZ_SREBP', NULL, 'S2P-M50_PDZ_SREBP', NULL, NULL, NULL, 2),
(14391, NULL, 'cd12087', NULL, NULL, 'TM_EGFR-like', NULL, 'TM_EGFR-like', NULL, NULL, NULL, 2),
(14392, NULL, 'cd08067', NULL, NULL, 'MPN_2A_DUB', NULL, 'MPN_2A_DUB', NULL, NULL, NULL, 2),
(14393, NULL, 'cd07290', NULL, NULL, 'PX_PI3K_C2_beta', NULL, 'PX_PI3K_C2_beta', NULL, NULL, 37220, 2),
(14394, NULL, 'cd13403', NULL, NULL, 'MLTF-like', NULL, 'MLTF-like', NULL, NULL, NULL, 2),
(14395, NULL, 'cd09764', NULL, NULL, 'Csb3_I-U', NULL, 'Csb3_I-U', NULL, NULL, NULL, 2),
(14396, NULL, 'cd11694', NULL, NULL, 'DHR2_DOCK_D', NULL, 'DHR2_DOCK_D', NULL, NULL, NULL, 2),
(14397, NULL, 'cd15482', NULL, NULL, 'Sialidase_non-viral', NULL, 'Sialidase_non-viral', NULL, NULL, NULL, 2),
(14398, NULL, 'cd01468', NULL, NULL, 'trunk_domain', NULL, 'trunk_domain', NULL, NULL, NULL, 2);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(14399, NULL, 'cd09406', NULL, NULL, 'LIM1_Leupaxin', NULL, 'LIM1_Leupaxin', NULL, NULL, NULL, 2),
(14400, NULL, 'cd12230', NULL, NULL, 'RRM1_U2AF65', NULL, 'RRM1_U2AF65', NULL, NULL, NULL, 2),
(14401, NULL, 'cd15843', NULL, NULL, 'R-SNARE', NULL, 'R-SNARE', NULL, NULL, NULL, 2),
(14402, NULL, 'cd14514', NULL, NULL, 'DUSP14-like', NULL, 'DUSP14-like', NULL, NULL, NULL, 2),
(14403, NULL, 'cd05844', NULL, NULL, 'GT4-like', NULL, 'GT4-like', NULL, NULL, NULL, 2),
(14404, NULL, 'cd09928', NULL, NULL, 'SH2_Cterm_SPT6_like', NULL, 'SH2_Cterm_SPT6_like', NULL, NULL, 20875, 2),
(14405, NULL, 'cd17084', NULL, NULL, 'RAWUL_PCGF5', NULL, 'RAWUL_PCGF5', NULL, NULL, NULL, 2),
(14406, NULL, 'cd12455', NULL, NULL, 'RRM_like_Smg4_UPF3', NULL, 'RRM_like_Smg4_UPF3', NULL, NULL, NULL, 2),
(14407, NULL, 'cd02865', NULL, NULL, 'Heme_Cu_Oxidase_III_2', NULL, 'Heme_Cu_Oxidase_III_2', NULL, NULL, NULL, 2),
(14408, NULL, 'cd18280', NULL, NULL, 'BTB_POZ_BPM_plant', NULL, 'BTB_POZ_BPM_plant', NULL, NULL, NULL, 2),
(14409, NULL, 'cd06216', NULL, NULL, 'FNR_iron_sulfur_binding_2', NULL, 'FNR_iron_sulfur_binding_2', NULL, NULL, NULL, 2),
(14410, NULL, 'cd11524', NULL, NULL, 'SYLF', NULL, 'SYLF', NULL, NULL, NULL, 2),
(14411, NULL, 'cd12498', NULL, NULL, 'RRM3_ACF', NULL, 'RRM3_ACF', NULL, NULL, 1223, 2),
(14412, NULL, 'cd04187', NULL, NULL, 'DPM1_like_bac', NULL, 'DPM1_like_bac', NULL, NULL, NULL, 2),
(14413, NULL, 'cd00458', NULL, NULL, 'SugarP_isomerase', NULL, 'SugarP_isomerase', NULL, NULL, NULL, 2),
(14414, NULL, 'cd00225', NULL, NULL, 'API3', NULL, 'API3', NULL, NULL, NULL, 2),
(14415, NULL, 'cd11780', NULL, NULL, 'SH3_Sorbs_3', NULL, 'SH3_Sorbs_3', NULL, NULL, NULL, 2),
(14416, NULL, 'cd01852', NULL, NULL, 'AIG1', NULL, 'AIG1', NULL, NULL, NULL, 2),
(14417, NULL, 'cd09117', NULL, NULL, 'PLDc_Bfil_DEXD_like', NULL, 'PLDc_Bfil_DEXD_like', NULL, NULL, NULL, 2),
(14418, NULL, 'cd01312', NULL, NULL, 'Met_dep_hydrolase_D', NULL, 'Met_dep_hydrolase_D', NULL, NULL, NULL, 2),
(14419, NULL, 'cd14364', NULL, NULL, 'CUE_ASCC2', NULL, 'CUE_ASCC2', NULL, NULL, 30885, 2),
(14420, NULL, 'cd02922', NULL, NULL, 'FCB2_FMN', NULL, 'FCB2_FMN', NULL, NULL, 31830, 2),
(14421, NULL, 'cd01887', NULL, NULL, 'IF2_eIF5B', NULL, 'IF2_eIF5B', NULL, NULL, NULL, 2),
(14422, NULL, 'cd07576', NULL, NULL, 'R-amidase_like', NULL, 'R-amidase_like', NULL, NULL, 35328, 2),
(14423, NULL, 'cd18486', NULL, NULL, 'BACK_KBTBD13', NULL, 'BACK_KBTBD13', NULL, NULL, NULL, 2),
(14424, NULL, 'cd02790', NULL, NULL, 'MopB_CT_Formate-Dh_H', NULL, 'MopB_CT_Formate-Dh_H', NULL, NULL, 30753, 2),
(14425, NULL, 'cd01840', NULL, NULL, 'SGNH_hydrolase_yrhL_like', NULL, 'SGNH_hydrolase_yrhL_like', NULL, NULL, NULL, 2),
(14426, NULL, 'cd19125', NULL, NULL, 'AKR_AKR4C1-15', NULL, 'AKR_AKR4C1-15', NULL, NULL, 35103, 2),
(14427, NULL, 'cd13233', NULL, NULL, 'PH_ARHGAP9-like', NULL, 'PH_ARHGAP9-like', NULL, NULL, NULL, 2),
(14428, NULL, 'cd13525', NULL, NULL, 'PBP2_ATP-Prtase_HisG', NULL, 'PBP2_ATP-Prtase_HisG', NULL, NULL, NULL, 2),
(14429, NULL, 'cd07523', NULL, NULL, 'HAD_YsbA-like', NULL, 'HAD_YsbA-like', NULL, NULL, NULL, 2),
(14430, NULL, 'cd14570', NULL, NULL, 'DSP_slingshot_1', NULL, 'DSP_slingshot_1', NULL, NULL, NULL, 2),
(14431, NULL, 'cd09938', NULL, NULL, 'SH2_N-SH2_Zap70_Syk_like', NULL, 'SH2_N-SH2_Zap70_Syk_like', NULL, NULL, 31550, 2),
(14432, NULL, 'cd17333', NULL, NULL, 'MFS_FucP_MFSD4_like', NULL, 'MFS_FucP_MFSD4_like', NULL, NULL, NULL, 2),
(14433, NULL, 'cd19795', NULL, NULL, 'Bbox2_TRIM68_C-IV', NULL, 'Bbox2_TRIM68_C-IV', NULL, NULL, NULL, 2),
(14434, NULL, 'cd07072', NULL, NULL, 'NR_LBD_DHR38_like', NULL, 'NR_LBD_DHR38_like', NULL, NULL, NULL, 2),
(14435, NULL, 'cd13967', NULL, NULL, 'PT_UbiA_5', NULL, 'PT_UbiA_5', NULL, NULL, NULL, 2),
(14436, NULL, 'cd19427', NULL, NULL, 'lipocalin_OBP-like', NULL, 'lipocalin_OBP-like', NULL, NULL, NULL, 2),
(14437, NULL, 'cd09843', NULL, NULL, 'PLDc_vPLD2_1', NULL, 'PLDc_vPLD2_1', NULL, NULL, NULL, 2),
(14438, NULL, 'cd10425', NULL, NULL, 'Ephrin-A_Ectodomain', NULL, 'Ephrin-A_Ectodomain', NULL, NULL, 6076, 2);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(14439, NULL, 'cd14778', NULL, NULL, 'VtHb-like_SDgb', NULL, 'VtHb-like_SDgb', NULL, NULL, NULL, 2),
(14440, NULL, 'cd18454', NULL, NULL, 'BACK_KLHL15', NULL, 'BACK_KLHL15', NULL, NULL, NULL, 2),
(14441, NULL, 'cd00008', NULL, NULL, 'PIN_53EXO-like', NULL, 'PIN_53EXO-like', NULL, NULL, NULL, 2),
(14442, NULL, 'cd08409', NULL, NULL, 'C2B_Synaptotagmin-15', NULL, 'C2B_Synaptotagmin-15', NULL, NULL, NULL, 2),
(14443, NULL, 'cd01681', NULL, NULL, 'aeEF2_snRNP_like_IV', NULL, 'aeEF2_snRNP_like_IV', NULL, NULL, NULL, 2),
(14444, NULL, 'cd12767', NULL, NULL, 'RRM2_SRSF1', NULL, 'RRM2_SRSF1', NULL, NULL, NULL, 2),
(14445, NULL, 'cd04265', NULL, NULL, 'DUF619-NAGS-U', NULL, 'DUF619-NAGS-U', NULL, NULL, NULL, 2),
(14446, NULL, 'cd10557', NULL, NULL, 'NarH_beta-like', NULL, 'NarH_beta-like', NULL, NULL, 443, 2),
(14447, NULL, 'cd04278', NULL, NULL, 'ZnMc_MMP', NULL, 'ZnMc_MMP', NULL, NULL, 30923, 2),
(14448, NULL, 'cd21643', NULL, NULL, 'ORF8-Ig_bat_SARS-CoV_HKU3-1_type-III-like', NULL, 'ORF8-Ig_bat_SARS-CoV_HKU3-1_type-III-like', NULL, NULL, 36558, 2),
(14449, NULL, 'cd04478', NULL, NULL, 'RPA2_DBD_D', NULL, 'RPA2_DBD_D', NULL, NULL, NULL, 2),
(14450, NULL, 'cd03700', NULL, NULL, 'EF2_snRNP_like_II', NULL, 'EF2_snRNP_like_II', NULL, NULL, NULL, 2),
(14451, NULL, 'cd03541', NULL, NULL, 'Rieske_RO_Alpha_CMO', NULL, 'Rieske_RO_Alpha_CMO', NULL, NULL, NULL, 2),
(14452, NULL, 'cd12449', NULL, NULL, 'RRM_CIRBP_RBM3', NULL, 'RRM_CIRBP_RBM3', NULL, NULL, 6325, 2),
(14453, NULL, 'cd04201', NULL, NULL, 'CuRO_1_CuNIR_like', NULL, 'CuRO_1_CuNIR_like', NULL, NULL, NULL, 2),
(14454, NULL, 'cd12054', NULL, NULL, 'SH3_CD2AP_2', NULL, 'SH3_CD2AP_2', NULL, NULL, 31984, 2),
(14455, NULL, 'cd14438', NULL, NULL, 'Hip_N', NULL, 'Hip_N', NULL, NULL, 5555, 2),
(14456, NULL, 'cd12040', NULL, NULL, 'SH3_CACNB2', NULL, 'SH3_CACNB2', NULL, NULL, 32518, 2),
(14457, NULL, 'cd03482', NULL, NULL, 'MutL_Trans_MutL', NULL, 'MutL_Trans_MutL', NULL, NULL, NULL, 2),
(14458, NULL, 'cd01196', NULL, NULL, 'INT_C_like_6', NULL, 'INT_C_like_6', NULL, NULL, NULL, 2),
(14459, NULL, 'cd06253', NULL, NULL, 'M14_ASTE_ASPA-like', NULL, 'M14_ASTE_ASPA-like', NULL, NULL, NULL, 2),
(14460, NULL, 'cd12034', NULL, NULL, 'SH3_MPP4', NULL, 'SH3_MPP4', NULL, NULL, 33992, 2),
(14461, NULL, 'cd06607', NULL, NULL, 'STKc_TAO', NULL, 'STKc_TAO', NULL, NULL, NULL, 2),
(14462, NULL, 'cd07623', NULL, NULL, 'BAR_SNX1_2', NULL, 'BAR_SNX1_2', NULL, NULL, NULL, 2),
(14463, NULL, 'cd17520', NULL, NULL, 'RMtype1_S_HmoORF3075P-TRD1-CR1_like', NULL, 'RMtype1_S_HmoORF3075P-TRD1-CR1_like', NULL, NULL, NULL, 2),
(14464, NULL, 'cd09149', NULL, NULL, 'PLDc_vPLD5_2', NULL, 'PLDc_vPLD5_2', NULL, NULL, NULL, 2),
(14465, NULL, 'cd00832', NULL, NULL, 'CLF', NULL, 'CLF', NULL, NULL, NULL, 2),
(14466, NULL, 'cd17244', NULL, NULL, 'RMtype1_S_Apa101655I-TRD2-CR2_like', NULL, 'RMtype1_S_Apa101655I-TRD2-CR2_like', NULL, NULL, NULL, 2),
(14467, NULL, 'cd19779', NULL, NULL, 'Bbox2_TRIM37_C-VIII', NULL, 'Bbox2_TRIM37_C-VIII', NULL, NULL, NULL, 2),
(14468, NULL, 'cd13285', NULL, NULL, 'PH_ORP1', NULL, 'PH_ORP1', NULL, NULL, NULL, 2),
(14469, NULL, 'cd11527', NULL, NULL, 'NTP-PPase_dUTPase', NULL, 'NTP-PPase_dUTPase', NULL, NULL, NULL, 2),
(14470, NULL, 'cd12433', NULL, NULL, 'RRM_Yme2p_like', NULL, 'RRM_Yme2p_like', NULL, NULL, 31832, 2),
(14471, NULL, 'cd05248', NULL, NULL, 'ADP_GME_SDR_e', NULL, 'ADP_GME_SDR_e', NULL, NULL, 12165, 2),
(14472, NULL, 'cd09147', NULL, NULL, 'PLDc_vPLD3_2', NULL, 'PLDc_vPLD3_2', NULL, NULL, NULL, 2),
(14473, NULL, 'cd14149', NULL, NULL, 'STKc_C-Raf', NULL, 'STKc_C-Raf', NULL, NULL, NULL, 2),
(14474, NULL, 'cd03365', NULL, NULL, 'TOPRIM_TopoIIA', NULL, 'TOPRIM_TopoIIA', NULL, NULL, 22511, 2),
(14475, NULL, 'cd15901', NULL, NULL, 'EFh_DMD_DYTN_DTN', NULL, 'EFh_DMD_DYTN_DTN', NULL, NULL, NULL, 2),
(14476, NULL, 'cd05468', NULL, NULL, 'pVHL', NULL, 'pVHL', NULL, NULL, 11373, 2),
(14477, NULL, 'cd15830', NULL, NULL, 'BamD', NULL, 'BamD', NULL, NULL, 17776, 2),
(14478, NULL, 'cd17497', NULL, NULL, 'RMtype1_S_TteMORF1547P-TRD2-CR2_like', NULL, 'RMtype1_S_TteMORF1547P-TRD2-CR2_like', NULL, NULL, NULL, 2);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(14479, NULL, 'cd03529', NULL, NULL, 'Rieske_NirD', NULL, 'Rieske_NirD', NULL, NULL, 9884, 2),
(14480, NULL, 'cd01184', NULL, NULL, 'INT_C_like_1', NULL, 'INT_C_like_1', NULL, NULL, NULL, 2),
(14481, NULL, 'cd11241', NULL, NULL, 'Sema_5', NULL, 'Sema_5', NULL, NULL, NULL, 2),
(14482, NULL, 'cd21478', NULL, NULL, 'HKU1-like_CoV_Spike_S1_RBD', NULL, 'HKU1-like_CoV_Spike_S1_RBD', NULL, NULL, NULL, 2),
(14483, NULL, 'cd17022', NULL, NULL, 'T3SC_IA_SigE-like', NULL, 'T3SC_IA_SigE-like', NULL, NULL, 18792, 2),
(14484, NULL, 'cd10524', NULL, NULL, 'SET_Suv4-20-like', NULL, 'SET_Suv4-20-like', NULL, NULL, NULL, 2),
(14485, NULL, 'cd07382', NULL, NULL, 'MPP_DR1281', NULL, 'MPP_DR1281', NULL, NULL, NULL, 2),
(14486, NULL, 'cd19426', NULL, NULL, 'lipocalin_6', NULL, 'lipocalin_6', NULL, NULL, NULL, 2),
(14487, NULL, 'cd07013', NULL, NULL, 'S14_ClpP', NULL, 'S14_ClpP', NULL, NULL, NULL, 2),
(14488, NULL, 'cd14499', NULL, NULL, 'CDC14_C', NULL, 'CDC14_C', NULL, NULL, 36297, 2),
(14489, NULL, 'cd09148', NULL, NULL, 'PLDc_vPLD4_2', NULL, 'PLDc_vPLD4_2', NULL, NULL, NULL, 2),
(14490, NULL, 'cd18272', NULL, NULL, 'BTB_POZ_KBTBD4', NULL, 'BTB_POZ_KBTBD4', NULL, NULL, 35599, 2),
(14491, NULL, 'cd08776', NULL, NULL, 'DED_Caspase-like_r1', NULL, 'DED_Caspase-like_r1', NULL, NULL, NULL, 2),
(14492, NULL, 'cd04914', NULL, NULL, 'ACT_AKi-DapG-BS_1', NULL, 'ACT_AKi-DapG-BS_1', NULL, NULL, NULL, 2),
(14493, NULL, 'cd05773', NULL, NULL, 'Ig_hNephrin_like', NULL, 'Ig_hNephrin_like', NULL, NULL, NULL, 2),
(14494, NULL, 'cd06364', NULL, NULL, 'PBP1_CaSR', NULL, 'PBP1_CaSR', NULL, NULL, NULL, 2),
(14495, NULL, 'cd18349', NULL, NULL, 'BTB_POZ_BTBD6', NULL, 'BTB_POZ_BTBD6', NULL, NULL, NULL, 2),
(14496, NULL, 'cd02665', NULL, NULL, 'Peptidase_C19I', NULL, 'Peptidase_C19I', NULL, NULL, NULL, 2),
(14497, NULL, 'cd08816', NULL, NULL, 'CARD_RIG-I_r1', NULL, 'CARD_RIG-I_r1', NULL, NULL, NULL, 2),
(14498, NULL, 'cd16208', NULL, NULL, 'EFh_PI-PLCbeta1', NULL, 'EFh_PI-PLCbeta1', NULL, NULL, NULL, 2),
(14499, NULL, 'cd17767', NULL, NULL, 'UP_EcUdp-like', NULL, 'UP_EcUdp-like', NULL, NULL, NULL, 2),
(14500, NULL, 'cd17911', NULL, NULL, 'CheC_ClassIII', NULL, 'CheC_ClassIII', NULL, NULL, NULL, 2),
(14501, NULL, 'cd19687', NULL, NULL, 'bHLHzip_Mlx', NULL, 'bHLHzip_Mlx', NULL, NULL, NULL, 2),
(14502, NULL, 'cd05566', NULL, NULL, 'PTS_IIB_galactitol', NULL, 'PTS_IIB_galactitol', NULL, NULL, NULL, 2),
(14503, NULL, 'cd15328', NULL, NULL, '7tmA_5-HT5', NULL, '7tmA_5-HT5', NULL, NULL, NULL, 2),
(14504, NULL, 'cd10352', NULL, NULL, 'SH2_a2chimerin_b2chimerin', NULL, 'SH2_a2chimerin_b2chimerin', NULL, NULL, 29521, 2),
(14505, NULL, 'cd04739', NULL, NULL, 'DHOD_like', NULL, 'DHOD_like', NULL, NULL, NULL, 2),
(14506, NULL, 'cd14538', NULL, NULL, 'PTPc-N20_13', NULL, 'PTPc-N20_13', NULL, NULL, NULL, 2),
(14507, NULL, 'cd19718', NULL, NULL, 'bHLH_TS_NGN3_ATOH5', NULL, 'bHLH_TS_NGN3_ATOH5', NULL, NULL, NULL, 2),
(14508, NULL, 'cd16021', NULL, NULL, 'ALP_like', NULL, 'ALP_like', NULL, NULL, 3986, 2),
(14509, NULL, 'cd09393', NULL, NULL, 'LIM3_Lrg1p_like', NULL, 'LIM3_Lrg1p_like', NULL, NULL, NULL, 2),
(14510, NULL, 'cd14166', NULL, NULL, 'STKc_CaMKI_gamma', NULL, 'STKc_CaMKI_gamma', NULL, NULL, NULL, 2),
(14511, NULL, 'cd14791', NULL, NULL, 'GH36', NULL, 'GH36', NULL, NULL, 5692, 2),
(14512, NULL, 'cd11288', NULL, NULL, 'gelsolin_S5_like', NULL, 'gelsolin_S5_like', NULL, NULL, NULL, 2),
(14513, NULL, 'cd06317', NULL, NULL, 'PBP1_ABC_sugar_binding-like', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, NULL, 2),
(14514, NULL, 'cd09456', NULL, NULL, 'LIM2_Enigma', NULL, 'LIM2_Enigma', NULL, NULL, NULL, 2),
(14515, NULL, 'cd05538', NULL, NULL, 'POLBc_Pol_II_B', NULL, 'POLBc_Pol_II_B', NULL, NULL, NULL, 2),
(14516, NULL, 'cd00483', NULL, NULL, 'HPPK', NULL, 'HPPK', NULL, NULL, 5865, 2),
(14517, NULL, 'cd19062', NULL, NULL, 'LGIC_TM_GluCl', NULL, 'LGIC_TM_GluCl', NULL, NULL, 34176, 2),
(14518, NULL, 'cd08024', NULL, NULL, 'GH16_CCF', NULL, 'GH16_CCF', NULL, NULL, NULL, 2),
(14519, NULL, 'cd10843', NULL, NULL, 'DSRM_DICER', NULL, 'DSRM_DICER', NULL, NULL, 35191, 2);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(14520, NULL, 'cd17041', NULL, NULL, 'Ubl_WDR48', NULL, 'Ubl_WDR48', NULL, NULL, NULL, 2),
(14521, NULL, 'cd01407', NULL, NULL, 'SIR2-fam', NULL, 'SIR2-fam', NULL, NULL, NULL, 2),
(14522, NULL, 'cd12076', NULL, NULL, 'SH3_Tks4_2', NULL, 'SH3_Tks4_2', NULL, NULL, 16025, 2),
(14523, NULL, 'cd13356', NULL, NULL, 'PH-GRAM_MTMR2_mammal-like', NULL, 'PH-GRAM_MTMR2_mammal-like', NULL, NULL, NULL, 2),
(14524, NULL, 'cd13209', NULL, NULL, 'PH-GRAM_MTMR3_MTMR4', NULL, 'PH-GRAM_MTMR3_MTMR4', NULL, NULL, NULL, 2),
(14525, NULL, 'cd16859', NULL, NULL, 'ING_ING4_5', NULL, 'ING_ING4_5', NULL, NULL, NULL, 2),
(14526, NULL, 'cd16375', NULL, NULL, 'Avd_IVP_like', NULL, 'Avd_IVP_like', NULL, NULL, NULL, 2),
(14527, NULL, 'cd11701', NULL, NULL, 'DHR2_DOCK8', NULL, 'DHR2_DOCK8', NULL, NULL, NULL, 2),
(14528, NULL, 'cd06962', NULL, NULL, 'NR_DBD_FXR', NULL, 'NR_DBD_FXR', NULL, NULL, NULL, 2),
(14529, NULL, 'cd03592', NULL, NULL, 'CLECT_selectins_like', NULL, 'CLECT_selectins_like', NULL, NULL, 22080, 2),
(14530, NULL, 'cd16316', NULL, NULL, 'BlaB-like_MBL-B1', NULL, 'BlaB-like_MBL-B1', NULL, NULL, NULL, 2),
(14531, NULL, 'cd13277', NULL, NULL, 'PH_Bem3', NULL, 'PH_Bem3', NULL, NULL, NULL, 2),
(14532, NULL, 'cd08644', NULL, NULL, 'FMT_core_ArnA_N', NULL, 'FMT_core_ArnA_N', NULL, NULL, NULL, 2),
(14533, NULL, 'cd01648', NULL, NULL, 'TERT', NULL, 'TERT', NULL, NULL, NULL, 2),
(14534, NULL, 'cd00868', NULL, NULL, 'Terpene_cyclase_C1', NULL, 'Terpene_cyclase_C1', NULL, NULL, NULL, 2),
(14535, NULL, 'cd12840', NULL, NULL, 'CarS', NULL, 'CarS', NULL, NULL, 29293, 2),
(14536, NULL, 'cd14279', NULL, NULL, 'CUE', NULL, 'CUE', NULL, NULL, NULL, 2),
(14537, NULL, 'cd14249', NULL, NULL, 'ESP1_like', NULL, 'ESP1_like', NULL, NULL, NULL, 2),
(14538, NULL, 'cd10915', NULL, NULL, 'Peptidase_C25_N_2', NULL, 'Peptidase_C25_N_2', NULL, NULL, NULL, 2),
(14539, NULL, 'cd17247', NULL, NULL, 'RMtype1_S_Eco2747I-TRD2-CR2_like', NULL, 'RMtype1_S_Eco2747I-TRD2-CR2_like', NULL, NULL, NULL, 2),
(14540, NULL, 'cd02156', NULL, NULL, 'nt_trans', NULL, 'nt_trans', NULL, NULL, NULL, 2),
(14541, NULL, 'cd18410', NULL, NULL, 'BTB_POZ_Shaker-like', NULL, 'BTB_POZ_Shaker-like', NULL, NULL, NULL, 2),
(14542, NULL, 'cd04135', NULL, NULL, 'Tc10', NULL, 'Tc10', NULL, NULL, NULL, 2),
(14543, NULL, 'cd06309', NULL, NULL, 'PBP1_galactofuranose_YtfQ-like', NULL, 'PBP1_galactofuranose_YtfQ-like', NULL, NULL, NULL, 2),
(14544, NULL, 'cd19598', NULL, NULL, 'serpin77Ba-like_insects', NULL, 'serpin77Ba-like_insects', NULL, NULL, NULL, 2),
(14545, NULL, 'cd07500', NULL, NULL, 'HAD_PSP', NULL, 'HAD_PSP', NULL, NULL, NULL, 2),
(14546, NULL, 'cd13542', NULL, NULL, 'PBP2_FutA1_ilke', NULL, 'PBP2_FutA1_ilke', NULL, NULL, NULL, 2),
(14547, NULL, 'cd09214', NULL, NULL, 'GH64-like', NULL, 'GH64-like', NULL, NULL, NULL, 2),
(14548, NULL, 'cd19601', NULL, NULL, 'serpin42Da-like', NULL, 'serpin42Da-like', NULL, NULL, NULL, 2),
(14549, NULL, 'cd07989', NULL, NULL, 'LPLAT_AGPAT-like', NULL, 'LPLAT_AGPAT-like', NULL, NULL, NULL, 2),
(14550, NULL, 'cd00897', NULL, NULL, 'UGPase_euk', NULL, 'UGPase_euk', NULL, NULL, 19925, 2),
(14551, NULL, 'cd05578', NULL, NULL, 'STKc_Yank1', NULL, 'STKc_Yank1', NULL, NULL, NULL, 2),
(14552, NULL, 'cd17504', NULL, NULL, 'MFS_MMR_MDR_like', NULL, 'MFS_MMR_MDR_like', NULL, NULL, NULL, 2),
(14553, NULL, 'cd11502', NULL, NULL, 'SLC6sbd_NTT5', NULL, 'SLC6sbd_NTT5', NULL, NULL, NULL, 2),
(14554, NULL, 'cd07963', NULL, NULL, 'Anticodon_Ia_Cys', NULL, 'Anticodon_Ia_Cys', NULL, NULL, NULL, 2),
(14555, NULL, 'cd07930', NULL, NULL, 'bacterial_phosphagen_kinase', NULL, 'bacterial_phosphagen_kinase', NULL, NULL, 16437, 2),
(14556, NULL, 'cd09864', NULL, NULL, 'PIN_Fcf1-like', NULL, 'PIN_Fcf1-like', NULL, NULL, 28249, 2),
(14557, NULL, 'cd08217', NULL, NULL, 'STKc_Nek2', NULL, 'STKc_Nek2', NULL, NULL, NULL, 2),
(14558, NULL, 'cd01042', NULL, NULL, 'DMQH', NULL, 'DMQH', NULL, NULL, 8226, 2),
(14559, NULL, 'cd11684', NULL, NULL, 'DHR2_DOCK', NULL, 'DHR2_DOCK', NULL, NULL, NULL, 2),
(14560, NULL, 'cd13289', NULL, NULL, 'PH_Osh3p_yeast', NULL, 'PH_Osh3p_yeast', NULL, NULL, NULL, 2); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(14561, NULL, 'cd18038', NULL, NULL, 'DEXXQc_Helz-like', NULL, 'DEXXQc_Helz-like', NULL, NULL, NULL, 2),
(14562, NULL, 'cd13153', NULL, NULL, 'KOW_GPKOW_B', NULL, 'KOW_GPKOW_B', NULL, NULL, 30442, 2),
(14563, NULL, 'cd03021', NULL, NULL, 'DsbA_GSTK', NULL, 'DsbA_GSTK', NULL, NULL, 35450, 2),
(14564, NULL, 'cd08324', NULL, NULL, 'CARD_NOD1_CARD4', NULL, 'CARD_NOD1_CARD4', NULL, NULL, NULL, 2),
(14565, NULL, 'cd10581', NULL, NULL, 'TNFRSF11B', NULL, 'TNFRSF11B', NULL, NULL, NULL, 2),
(14566, NULL, 'cd11512', NULL, NULL, 'SLC6sbd_NET', NULL, 'SLC6sbd_NET', NULL, NULL, NULL, 2),
(14567, NULL, 'cd07693', NULL, NULL, 'Ig1_Robo', NULL, 'Ig1_Robo', NULL, NULL, NULL, 2),
(14568, NULL, 'cd18434', NULL, NULL, 'BRCT_TopBP1_rpt5', NULL, 'BRCT_TopBP1_rpt5', NULL, NULL, NULL, 2),
(14569, NULL, 'cd08446', NULL, NULL, 'PBP2_Chlorocatechol', NULL, 'PBP2_Chlorocatechol', NULL, NULL, NULL, 2),
(14570, NULL, 'cd02343', NULL, NULL, 'ZZ_EF', NULL, 'ZZ_EF', NULL, NULL, 30367, 2),
(14571, NULL, 'cd00130', NULL, NULL, 'PAS', NULL, 'PAS', NULL, NULL, 3787, 2),
(14572, NULL, 'cd01398', NULL, NULL, 'RPI_A', NULL, 'RPI_A', NULL, NULL, 5031, 2),
(14573, NULL, 'cd04711', NULL, NULL, 'BAH_Dnmt1_II', NULL, 'BAH_Dnmt1_II', NULL, NULL, NULL, 2),
(14574, NULL, 'cd06817', NULL, NULL, 'PLPDE_III_DSD', NULL, 'PLPDE_III_DSD', NULL, NULL, NULL, 2),
(14575, NULL, 'cd16608', NULL, NULL, 'RING-HC_TRIM62_C-IV', NULL, 'RING-HC_TRIM62_C-IV', NULL, NULL, NULL, 2),
(14576, NULL, 'cd10001', NULL, NULL, 'HDAC_classII_APAH', NULL, 'HDAC_classII_APAH', NULL, NULL, NULL, 2),
(14577, NULL, 'cd13884', NULL, NULL, 'CuRO_2_tcLCC_insect_like', NULL, 'CuRO_2_tcLCC_insect_like', NULL, NULL, NULL, 2),
(14578, NULL, 'cd14812', NULL, NULL, 'bZIP_u3', NULL, 'bZIP_u3', NULL, NULL, NULL, 2),
(14579, NULL, 'cd17301', NULL, NULL, 'PIPKc_PIP5KI', NULL, 'PIPKc_PIP5KI', NULL, NULL, NULL, 2),
(14580, NULL, 'cd18621', NULL, NULL, 'GH32_XdINV-like', NULL, 'GH32_XdINV-like', NULL, NULL, NULL, 2),
(14581, NULL, 'cd18218', NULL, NULL, 'BTB_POZ_ZBTB32_FAZF_TZFP', NULL, 'BTB_POZ_ZBTB32_FAZF_TZFP', NULL, NULL, NULL, 2),
(14582, NULL, 'cd04239', NULL, NULL, 'AAK_UMPK-like', NULL, 'AAK_UMPK-like', NULL, NULL, NULL, 2),
(14583, NULL, 'cd06993', NULL, NULL, 'cupin_CENP-C_C', NULL, 'cupin_CENP-C_C', NULL, NULL, NULL, 2),
(14584, NULL, 'cd11558', NULL, NULL, 'W2_eIF2B_epsilon', NULL, 'W2_eIF2B_epsilon', NULL, NULL, 35179, 2),
(14585, NULL, 'cd08803', NULL, NULL, 'Death_ank3', NULL, 'Death_ank3', NULL, NULL, 27332, 2),
(14586, NULL, 'cd06408', NULL, NULL, 'PB1_NoxR', NULL, 'PB1_NoxR', NULL, NULL, 15976, 2),
(14587, NULL, 'cd19015', NULL, NULL, 'LGIC_ECD_nAChR_A2', NULL, 'LGIC_ECD_nAChR_A2', NULL, NULL, NULL, 2),
(14588, NULL, 'cd18264', NULL, NULL, 'BTB_POZ_KLHL34', NULL, 'BTB_POZ_KLHL34', NULL, NULL, NULL, 2),
(14589, NULL, 'cd16587', NULL, NULL, 'RING-HC_TRIM32_C-VII', NULL, 'RING-HC_TRIM32_C-VII', NULL, NULL, NULL, 2),
(14590, NULL, 'cd01938', NULL, NULL, 'ADPGK_ADPPFK', NULL, 'ADPGK_ADPPFK', NULL, NULL, NULL, 2),
(14591, NULL, 'cd13740', NULL, NULL, 'SPRY_PRY_TRIM7', NULL, 'SPRY_PRY_TRIM7', NULL, NULL, NULL, 2),
(14592, NULL, 'cd12683', NULL, NULL, 'RRM_RBPMS2', NULL, 'RRM_RBPMS2', NULL, NULL, 19119, 2),
(14593, NULL, 'cd06115', NULL, NULL, 'AthCS_per_like', NULL, 'AthCS_per_like', NULL, NULL, NULL, 2),
(14594, NULL, 'cd12236', NULL, NULL, 'RRM_snRNP70', NULL, 'RRM_snRNP70', NULL, NULL, 10402, 2),
(14595, NULL, 'cd04153', NULL, NULL, 'Arl5_Arl8', NULL, 'Arl5_Arl8', NULL, NULL, NULL, 2),
(14596, NULL, 'cd11283', NULL, NULL, 'ADF_GMF-beta_like', NULL, 'ADF_GMF-beta_like', NULL, NULL, 10598, 2),
(14597, NULL, 'cd07284', NULL, NULL, 'PX_SNX7', NULL, 'PX_SNX7', NULL, NULL, 37048, 2),
(14598, NULL, 'cd08976', NULL, NULL, 'BaFpgNei_N_4', NULL, 'BaFpgNei_N_4', NULL, NULL, NULL, 2),
(14599, NULL, 'cd08233', NULL, NULL, 'butanediol_DH_like', NULL, 'butanediol_DH_like', NULL, NULL, NULL, 2),
(14600, NULL, 'cd12590', NULL, NULL, 'RRM2_PSF', NULL, 'RRM2_PSF', NULL, NULL, NULL, 2),
(14601, NULL, 'cd03754', NULL, NULL, 'proteasome_alpha_type_6', NULL, 'proteasome_alpha_type_6', NULL, NULL, 6101, 2);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(14602, NULL, 'cd12458', NULL, NULL, 'RRM_AtC3H46_like', NULL, 'RRM_AtC3H46_like', NULL, NULL, 4019, 2),
(14603, NULL, 'cd15416', NULL, NULL, '7tmA_OR5P-like', NULL, '7tmA_OR5P-like', NULL, NULL, NULL, 2),
(14604, NULL, 'cd16033', NULL, NULL, 'sulfatase_like', NULL, 'sulfatase_like', NULL, NULL, NULL, 2),
(14605, NULL, 'cd01825', NULL, NULL, 'SGNH_hydrolase_peri1', NULL, 'SGNH_hydrolase_peri1', NULL, NULL, NULL, 2),
(14606, NULL, 'cd04461', NULL, NULL, 'S1_Rrp5_repeat_hs8_sc7', NULL, 'S1_Rrp5_repeat_hs8_sc7', NULL, NULL, NULL, 2),
(14607, NULL, 'cd06559', NULL, NULL, 'Endonuclease_V', NULL, 'Endonuclease_V', NULL, NULL, 1950, 2),
(14608, NULL, 'cd09648', NULL, NULL, 'Cas2_I-E', NULL, 'Cas2_I-E', NULL, NULL, NULL, 2),
(14609, NULL, 'cd06633', NULL, NULL, 'STKc_TAO3', NULL, 'STKc_TAO3', NULL, NULL, NULL, 2),
(14610, NULL, 'cd07026', NULL, NULL, 'Ribosomal_L20', NULL, 'Ribosomal_L20', NULL, NULL, 5975, 2),
(14611, NULL, 'cd21587', NULL, NULL, 'gammaCoV_RdRp', NULL, 'gammaCoV_RdRp', NULL, NULL, 35330, 2),
(14612, NULL, 'cd08507', NULL, NULL, 'PBP2_SgrR_like', NULL, 'PBP2_SgrR_like', NULL, NULL, NULL, 2),
(14613, NULL, 'cd07657', NULL, NULL, 'F-BAR_Fes_Fer', NULL, 'F-BAR_Fes_Fer', NULL, NULL, NULL, 2),
(14614, NULL, 'cd15330', NULL, NULL, '7tmA_5-HT1A_vertebrates', NULL, '7tmA_5-HT1A_vertebrates', NULL, NULL, NULL, 2),
(14615, NULL, 'cd11863', NULL, NULL, 'SH3_CACNB', NULL, 'SH3_CACNB', NULL, NULL, NULL, 2),
(14616, NULL, 'cd04080', NULL, NULL, 'CBM6_cellulase-like', NULL, 'CBM6_cellulase-like', NULL, NULL, NULL, 2),
(14617, NULL, 'cd16444', NULL, NULL, 'LipB', NULL, 'LipB', NULL, NULL, 5986, 2),
(14618, NULL, 'cd11600', NULL, NULL, 'HDAC_Clr3', NULL, 'HDAC_Clr3', NULL, NULL, NULL, 2),
(14619, NULL, 'cd14377', NULL, NULL, 'UBA1_Rad23', NULL, 'UBA1_Rad23', NULL, NULL, 30927, 2),
(14620, NULL, 'cd00178', NULL, NULL, 'STI', NULL, 'STI', NULL, NULL, 305, 2),
(14621, NULL, 'cd04402', NULL, NULL, 'RhoGAP_ARHGAP20', NULL, 'RhoGAP_ARHGAP20', NULL, NULL, NULL, 2),
(14622, NULL, 'cd12629', NULL, NULL, 'RRM2_IGF2BP2', NULL, 'RRM2_IGF2BP2', NULL, NULL, NULL, 2),
(14623, NULL, 'cd18625', NULL, NULL, 'GH32_BfrA-like', NULL, 'GH32_BfrA-like', NULL, NULL, NULL, 2),
(14624, NULL, 'cd12882', NULL, NULL, 'SPRY_RNF123', NULL, 'SPRY_RNF123', NULL, NULL, 31826, 2),
(14625, NULL, 'cd04819', NULL, NULL, 'PA_2', NULL, 'PA_2', NULL, NULL, NULL, 2),
(14626, NULL, 'cd07468', NULL, NULL, 'CRD_TK_ROR2', NULL, 'CRD_TK_ROR2', NULL, NULL, NULL, 2),
(14627, NULL, 'cd13271', NULL, NULL, 'PH2_TAPP1_2', NULL, 'PH2_TAPP1_2', NULL, NULL, NULL, 2),
(14628, NULL, 'cd02788', NULL, NULL, 'MopB_CT_NDH-1_NuoG2-N7', NULL, 'MopB_CT_NDH-1_NuoG2-N7', NULL, NULL, NULL, 2),
(14629, NULL, 'cd02858', NULL, NULL, 'E_set_Esterase_N', NULL, 'E_set_Esterase_N', NULL, NULL, NULL, 2),
(14630, NULL, 'cd15371', NULL, NULL, '7tmA_PAR3', NULL, '7tmA_PAR3', NULL, NULL, NULL, 2),
(14631, NULL, 'cd14726', NULL, NULL, 'TraB_PrgY-like', NULL, 'TraB_PrgY-like', NULL, NULL, 37570, 2),
(14632, NULL, 'cd13711', NULL, NULL, 'PBP2_Ngo0372_TcyA', NULL, 'PBP2_Ngo0372_TcyA', NULL, NULL, NULL, 2),
(14633, NULL, 'cd05642', NULL, NULL, 'M28_like', NULL, 'M28_like', NULL, NULL, NULL, 2),
(14634, NULL, 'cd14890', NULL, NULL, 'MYSc_Myo29', NULL, 'MYSc_Myo29', NULL, NULL, NULL, 2),
(14635, NULL, 'cd12159', NULL, NULL, '2-Hacid_dh_2', NULL, '2-Hacid_dh_2', NULL, NULL, NULL, 2),
(14636, NULL, 'cd12077', NULL, NULL, 'SH3_Tks5_2', NULL, 'SH3_Tks5_2', NULL, NULL, 20359, 2),
(14637, NULL, 'cd13143', NULL, NULL, 'MATE_MepA_like', NULL, 'MATE_MepA_like', NULL, NULL, 35716, 2),
(14638, NULL, 'cd04220', NULL, NULL, 'Halocyanin', NULL, 'Halocyanin', NULL, NULL, NULL, 2),
(14639, NULL, 'cd15623', NULL, NULL, 'PHD_TIF1beta', NULL, 'PHD_TIF1beta', NULL, NULL, NULL, 2),
(14640, NULL, 'cd08011', NULL, NULL, 'M20_ArgE_DapE-like', NULL, 'M20_ArgE_DapE-like', NULL, NULL, NULL, 2),
(14641, NULL, 'cd19712', NULL, NULL, 'bHLH_TS_dimmed_like', NULL, 'bHLH_TS_dimmed_like', NULL, NULL, NULL, 2),
(14642, NULL, 'cd00164', NULL, NULL, 'S1_like', NULL, 'S1_like', NULL, NULL, NULL, 2),
(14643, NULL, 'cd15167', NULL, NULL, '7tmA_GPR171', NULL, '7tmA_GPR171', NULL, NULL, NULL, 2);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(14644, NULL, 'cd11587', NULL, NULL, 'Arginase-like', NULL, 'Arginase-like', NULL, NULL, NULL, 2),
(14645, NULL, 'cd11497', NULL, NULL, 'SLC6sbd_SERT-like', NULL, 'SLC6sbd_SERT-like', NULL, NULL, NULL, 2),
(14646, NULL, 'cd14985', NULL, NULL, '7tmA_Angiotensin_R-like', NULL, '7tmA_Angiotensin_R-like', NULL, NULL, NULL, 2),
(14647, NULL, 'cd07603', NULL, NULL, 'BAR_ACAPs', NULL, 'BAR_ACAPs', NULL, NULL, NULL, 2),
(14648, NULL, 'cd19341', NULL, NULL, 'Wnt_Wnt9', NULL, 'Wnt_Wnt9', NULL, NULL, NULL, 2),
(14649, NULL, 'cd01993', NULL, NULL, 'Alpha_ANH_like_II', NULL, 'Alpha_ANH_like_II', NULL, NULL, NULL, 2),
(14650, NULL, 'cd18359', NULL, NULL, 'BTB2_POZ_RHOBTB2', NULL, 'BTB2_POZ_RHOBTB2', NULL, NULL, NULL, 2),
(14651, NULL, 'cd18710', NULL, NULL, 'PIN_VapC-like', NULL, 'PIN_VapC-like', NULL, NULL, NULL, 2),
(14652, NULL, 'cd04618', NULL, NULL, 'CBS_euAMPK_gamma-like_repeat1', NULL, 'CBS_euAMPK_gamma-like_repeat1', NULL, NULL, NULL, 2),
(14653, NULL, 'cd15807', NULL, NULL, 'MDA5_C', NULL, 'MDA5_C', NULL, NULL, NULL, 2),
(14654, NULL, 'cd16999', NULL, NULL, 'VHS_STAM2', NULL, 'VHS_STAM2', NULL, NULL, NULL, 2),
(14655, NULL, 'cd01723', NULL, NULL, 'LSm4', NULL, 'LSm4', NULL, NULL, 11352, 2),
(14656, NULL, 'cd05122', NULL, NULL, 'PKc_STE', NULL, 'PKc_STE', NULL, NULL, NULL, 2),
(14657, NULL, 'cd01561', NULL, NULL, 'CBS_like', NULL, 'CBS_like', NULL, NULL, NULL, 2),
(14658, NULL, 'cd14191', NULL, NULL, 'STKc_MLCK1', NULL, 'STKc_MLCK1', NULL, NULL, 11441, 2),
(14659, NULL, 'cd12947', NULL, NULL, 'NOPS_p54nrb', NULL, 'NOPS_p54nrb', NULL, NULL, NULL, 2),
(14660, NULL, 'cd09110', NULL, NULL, 'PLDc_CLS_1', NULL, 'PLDc_CLS_1', NULL, NULL, NULL, 2),
(14661, NULL, 'cd05636', NULL, NULL, 'LbH_G1P_TT_C_like', NULL, 'LbH_G1P_TT_C_like', NULL, NULL, NULL, 2),
(14662, NULL, 'cd09378', NULL, NULL, 'LIM2_Lmx1a_Lmx1b', NULL, 'LIM2_Lmx1a_Lmx1b', NULL, NULL, NULL, 2),
(14663, NULL, 'cd08940', NULL, NULL, 'HBDH_SDR_c', NULL, 'HBDH_SDR_c', NULL, NULL, NULL, 2),
(14664, NULL, 'cd09862', NULL, NULL, 'PIN_Rrp44-like', NULL, 'PIN_Rrp44-like', NULL, NULL, NULL, 2),
(14665, NULL, 'cd10041', NULL, NULL, 'Reelin_repeat_5_subrepeat_1', NULL, 'Reelin_repeat_5_subrepeat_1', NULL, NULL, NULL, 2),
(14666, NULL, 'cd13196', NULL, NULL, 'FERM_C_JAK', NULL, 'FERM_C_JAK', NULL, NULL, NULL, 2),
(14667, NULL, 'cd18646', NULL, NULL, 'CD_Cbx7', NULL, 'CD_Cbx7', NULL, NULL, NULL, 2),
(14668, NULL, 'cd05927', NULL, NULL, 'LC-FACS_euk', NULL, 'LC-FACS_euk', NULL, NULL, 34259, 2),
(14669, NULL, 'cd07085', NULL, NULL, 'ALDH_F6_MMSDH', NULL, 'ALDH_F6_MMSDH', NULL, NULL, 6151, 2),
(14670, NULL, 'cd08488', NULL, NULL, 'PBP2_AmpR', NULL, 'PBP2_AmpR', NULL, NULL, NULL, 2),
(14671, NULL, 'cd00727', NULL, NULL, 'malate_synt_A', NULL, 'malate_synt_A', NULL, NULL, 3851, 2),
(14672, NULL, 'cd02249', NULL, NULL, 'ZZ', NULL, 'ZZ', NULL, NULL, NULL, 2),
(14673, NULL, 'cd01735', NULL, NULL, 'LSm12_N', NULL, 'LSm12_N', NULL, NULL, NULL, 2),
(14674, NULL, 'cd14479', NULL, NULL, 'SPX-MFS_plant', NULL, 'SPX-MFS_plant', NULL, NULL, 37170, 2),
(14675, NULL, 'cd01630', NULL, NULL, 'HAD_KDO-like', NULL, 'HAD_KDO-like', NULL, NULL, NULL, 2),
(14676, NULL, 'cd06388', NULL, NULL, 'PBP1_iGluR_AMPA_GluR4', NULL, 'PBP1_iGluR_AMPA_GluR4', NULL, NULL, NULL, 2),
(14677, NULL, 'cd15243', NULL, NULL, '7tm_Halorhodopsin', NULL, '7tm_Halorhodopsin', NULL, NULL, NULL, 2),
(14678, NULL, 'cd03454', NULL, NULL, 'YdeM', NULL, 'YdeM', NULL, NULL, NULL, 2),
(14679, NULL, 'cd07091', NULL, NULL, 'ALDH_F1-2_Ald2-like', NULL, 'ALDH_F1-2_Ald2-like', NULL, NULL, NULL, 2),
(14680, NULL, 'cd17962', NULL, NULL, 'DEADc_DDX59', NULL, 'DEADc_DDX59', NULL, NULL, NULL, 2),
(14681, NULL, 'cd16575', NULL, NULL, 'RING-HC_MID_C-I', NULL, 'RING-HC_MID_C-I', NULL, NULL, NULL, 2),
(14682, NULL, 'cd09808', NULL, NULL, 'DHRS-12_like_SDR_c-like', NULL, 'DHRS-12_like_SDR_c-like', NULL, NULL, NULL, 2),
(14683, NULL, 'cd15023', NULL, NULL, '7tm_TAS2R7-like', NULL, '7tm_TAS2R7-like', NULL, NULL, NULL, 2),
(14684, NULL, 'cd12652', NULL, NULL, 'RRM2_Hu', NULL, 'RRM2_Hu', NULL, NULL, NULL, 2),
(14685, NULL, 'cd13866', NULL, NULL, 'CuRO_2_BOD', NULL, 'CuRO_2_BOD', NULL, NULL, NULL, 2);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(14686, NULL, 'cd01174', NULL, NULL, 'ribokinase', NULL, 'ribokinase', NULL, NULL, 14352, 2),
(14687, NULL, 'cd04913', NULL, NULL, 'ACT_AKii-LysC-BS-like_1', NULL, 'ACT_AKii-LysC-BS-like_1', NULL, NULL, NULL, 2),
(14688, NULL, 'cd18930', NULL, NULL, 'bHLHzip_MXI1', NULL, 'bHLHzip_MXI1', NULL, NULL, NULL, 2),
(14689, NULL, 'cd04389', NULL, NULL, 'RhoGAP_KIAA1688', NULL, 'RhoGAP_KIAA1688', NULL, NULL, NULL, 2),
(14690, NULL, 'cd15172', NULL, NULL, '7tmA_CCR6', NULL, '7tmA_CCR6', NULL, NULL, NULL, 2),
(14691, NULL, 'cd00547', NULL, NULL, 'QFR_TypeD_subunitD', NULL, 'QFR_TypeD_subunitD', NULL, NULL, 5171, 2),
(14692, NULL, 'cd06232', NULL, NULL, 'M14-like', NULL, 'M14-like', NULL, NULL, NULL, 2),
(14693, NULL, 'cd15213', NULL, NULL, '7tmA_PSP24-like', NULL, '7tmA_PSP24-like', NULL, NULL, NULL, 2),
(14694, NULL, 'cd18634', NULL, NULL, 'CD_CDY', NULL, 'CD_CDY', NULL, NULL, NULL, 2),
(14695, NULL, 'cd14451', NULL, NULL, 'CuRO_5_FV_like', NULL, 'CuRO_5_FV_like', NULL, NULL, NULL, 2),
(14696, NULL, 'cd00011', NULL, NULL, 'BAR_Arfaptin_like', NULL, 'BAR_Arfaptin_like', NULL, NULL, NULL, 2),
(14697, NULL, 'cd03165', NULL, NULL, 'NET-5_like_LEL', NULL, 'NET-5_like_LEL', NULL, NULL, NULL, 2),
(14698, NULL, 'cd08979', NULL, NULL, 'GH_J', NULL, 'GH_J', NULL, NULL, NULL, 2),
(14699, NULL, 'sd00008', NULL, NULL, 'TPR_YbbN', NULL, 'TPR_YbbN', NULL, NULL, NULL, 2),
(14700, NULL, 'cd14667', NULL, NULL, '3D_containing_proteins', NULL, '3D_containing_proteins', NULL, NULL, NULL, 2),
(14701, NULL, 'cd03490', NULL, NULL, 'Topoisomer_IB_N_1', NULL, 'Topoisomer_IB_N_1', NULL, NULL, NULL, 2),
(14702, NULL, 'cd11014', NULL, NULL, 'Mavicyanin', NULL, 'Mavicyanin', NULL, NULL, 30801, 2),
(14703, NULL, 'cd17057', NULL, NULL, 'Ubl_TMUB1_like', NULL, 'Ubl_TMUB1_like', NULL, NULL, NULL, 2),
(14704, NULL, 'cd07815', NULL, NULL, 'SRPBCC_PITP', NULL, 'SRPBCC_PITP', NULL, NULL, NULL, 2),
(14705, NULL, 'cd04864', NULL, NULL, 'LigD_Pol_like_1', NULL, 'LigD_Pol_like_1', NULL, NULL, NULL, 2),
(14706, NULL, 'cd03108', NULL, NULL, 'AdSS', NULL, 'AdSS', NULL, NULL, 1412, 2),
(14707, NULL, 'cd13536', NULL, NULL, 'PBP2_EcModA', NULL, 'PBP2_EcModA', NULL, NULL, NULL, 2),
(14708, NULL, 'cd01147', NULL, NULL, 'HemV-2', NULL, 'HemV-2', NULL, NULL, NULL, 2),
(14709, NULL, 'cd07565', NULL, NULL, 'aliphatic_amidase', NULL, 'aliphatic_amidase', NULL, NULL, NULL, 2),
(14710, NULL, 'cd06477', NULL, NULL, 'ACD_HspB3_Like', NULL, 'ACD_HspB3_Like', NULL, NULL, 32291, 2),
(14711, NULL, 'cd06611', NULL, NULL, 'STKc_SLK_like', NULL, 'STKc_SLK_like', NULL, NULL, NULL, 2),
(14712, NULL, 'cd17026', NULL, NULL, 'T3SC_IA_SpcU-like', NULL, 'T3SC_IA_SpcU-like', NULL, NULL, NULL, 2),
(14713, NULL, 'cd14020', NULL, NULL, 'STKc_KIS', NULL, 'STKc_KIS', NULL, NULL, NULL, 2),
(14714, NULL, 'cd19569', NULL, NULL, 'serpinB10_bomapin', NULL, 'serpinB10_bomapin', NULL, NULL, NULL, 2),
(14715, NULL, 'cd03468', NULL, NULL, 'PolY_like', NULL, 'PolY_like', NULL, NULL, NULL, 2),
(14716, NULL, 'cd12571', NULL, NULL, 'RRM6_RBM19', NULL, 'RRM6_RBM19', NULL, NULL, 13219, 2),
(14717, NULL, 'cd14375', NULL, NULL, 'CUE2_Cue2p_like', NULL, 'CUE2_Cue2p_like', NULL, NULL, 30834, 2),
(14718, NULL, 'cd18914', NULL, NULL, 'bHLH_AtORG2_like', NULL, 'bHLH_AtORG2_like', NULL, NULL, NULL, 2),
(14719, NULL, 'cd10436', NULL, NULL, 'GIY-YIG_EndoII_Hpy188I_like', NULL, 'GIY-YIG_EndoII_Hpy188I_like', NULL, NULL, 36399, 2),
(14720, NULL, 'cd19831', NULL, NULL, 'Bbox2_MuRF1_C-II', NULL, 'Bbox2_MuRF1_C-II', NULL, NULL, NULL, 2),
(14721, NULL, 'cd14116', NULL, NULL, 'STKc_Aurora-A', NULL, 'STKc_Aurora-A', NULL, NULL, 25122, 2),
(14722, NULL, 'cd09869', NULL, NULL, 'PIN_GEN1', NULL, 'PIN_GEN1', NULL, NULL, NULL, 2),
(14723, NULL, 'cd11964', NULL, NULL, 'SH3_STAM1', NULL, 'SH3_STAM1', NULL, NULL, 33358, 2),
(14724, NULL, 'cd09813', NULL, NULL, '3b-HSD-NSDHL-like_SDR_e', NULL, '3b-HSD-NSDHL-like_SDR_e', NULL, NULL, NULL, 2),
(14725, NULL, 'cd07452', NULL, NULL, 'CRD_sizzled', NULL, 'CRD_sizzled', NULL, NULL, 30452, 2),
(14726, NULL, 'cd12360', NULL, NULL, 'RRM_cwf2', NULL, 'RRM_cwf2', NULL, NULL, 20121, 2); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(14727, NULL, 'cd12679', NULL, NULL, 'RRM_SAFB1_SAFB2', NULL, 'RRM_SAFB1_SAFB2', NULL, NULL, NULL, 2),
(14728, NULL, 'cd01090', NULL, NULL, 'Creatinase', NULL, 'Creatinase', NULL, NULL, 33078, 2),
(14729, NULL, 'cd06335', NULL, NULL, 'PBP1_ABC_ligand_binding-like', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, NULL, 2),
(14730, NULL, 'cd02654', NULL, NULL, 'nuc_hydro_CjNH', NULL, 'nuc_hydro_CjNH', NULL, NULL, NULL, 2),
(14731, NULL, 'cd09457', NULL, NULL, 'LIM2_ENH', NULL, 'LIM2_ENH', NULL, NULL, NULL, 2),
(14732, NULL, 'cd12167', NULL, NULL, '2-Hacid_dh_8', NULL, '2-Hacid_dh_8', NULL, NULL, NULL, 2),
(14733, NULL, 'cd03280', NULL, NULL, 'ABC_MutS2', NULL, 'ABC_MutS2', NULL, NULL, 4909, 2),
(14734, NULL, 'cd02003', NULL, NULL, 'TPP_IolD', NULL, 'TPP_IolD', NULL, NULL, NULL, 2),
(14735, NULL, 'cd01059', NULL, NULL, 'CCC1_like', NULL, 'CCC1_like', NULL, NULL, NULL, 2),
(14736, NULL, 'cd09556', NULL, NULL, 'SAM_VTS1_fungal', NULL, 'SAM_VTS1_fungal', NULL, NULL, 32139, 2),
(14737, NULL, 'cd01443', NULL, NULL, 'Cdc25_Acr2p', NULL, 'Cdc25_Acr2p', NULL, NULL, NULL, 2),
(14738, NULL, 'cd17724', NULL, NULL, 'BRCT_p53bp1_rpt2', NULL, 'BRCT_p53bp1_rpt2', NULL, NULL, NULL, 2),
(14739, NULL, 'cd03324', NULL, NULL, 'rTSbeta_L-fuconate_dehydratase', NULL, 'rTSbeta_L-fuconate_dehydratase', NULL, NULL, 11101, 2),
(14740, NULL, 'cd15199', NULL, NULL, '7tmA_GPR31', NULL, '7tmA_GPR31', NULL, NULL, NULL, 2),
(14741, NULL, 'cd18057', NULL, NULL, 'DEXHc_CHD5', NULL, 'DEXHc_CHD5', NULL, NULL, NULL, 2),
(14742, NULL, 'cd19164', NULL, NULL, 'AKR_ARA2', NULL, 'AKR_ARA2', NULL, NULL, 34125, 2),
(14743, NULL, 'cd06429', NULL, NULL, 'GT8_like_1', NULL, 'GT8_like_1', NULL, NULL, NULL, 2),
(14744, NULL, 'cd13754', NULL, NULL, 'TGF_beta_INHA', NULL, 'TGF_beta_INHA', NULL, NULL, NULL, 2),
(14745, NULL, 'cd18570', NULL, NULL, 'ABC_6TM_PCAT1_LagD_like', NULL, 'ABC_6TM_PCAT1_LagD_like', NULL, NULL, NULL, 2),
(14746, NULL, 'cd14673', NULL, NULL, 'PH_PHLDB1_2', NULL, 'PH_PHLDB1_2', NULL, NULL, 31818, 2),
(14747, NULL, 'cd19568', NULL, NULL, 'serpinB9_CAP-3', NULL, 'serpinB9_CAP-3', NULL, NULL, NULL, 2),
(14748, NULL, 'cd06980', NULL, NULL, 'cupin_bxe_c0505', NULL, 'cupin_bxe_c0505', NULL, NULL, NULL, 2),
(14749, NULL, 'cd08904', NULL, NULL, 'START_STARD6-like', NULL, 'START_STARD6-like', NULL, NULL, NULL, 2),
(14750, NULL, 'cd07962', NULL, NULL, 'Anticodon_Ia_Val', NULL, 'Anticodon_Ia_Val', NULL, NULL, 31924, 2),
(14751, NULL, 'cd09374', NULL, NULL, 'LIM2_Isl', NULL, 'LIM2_Isl', NULL, NULL, NULL, 2),
(14752, NULL, 'cd17289', NULL, NULL, 'RMtype1_S_BamJRS5ORF1993P-TRD1-CR1_like', NULL, 'RMtype1_S_BamJRS5ORF1993P-TRD1-CR1_like', NULL, NULL, NULL, 2),
(14753, NULL, 'cd17536', NULL, NULL, 'REC_YesN-like', NULL, 'REC_YesN-like', NULL, NULL, NULL, 2),
(14754, NULL, 'cd21162', NULL, NULL, 'NendoU_tv_PToV-like', NULL, 'NendoU_tv_PToV-like', NULL, NULL, 34861, 2),
(14755, NULL, 'cd00061', NULL, NULL, 'FN1', NULL, 'FN1', NULL, NULL, 3709, 2),
(14756, NULL, 'cd12196', NULL, NULL, 'MARK1-3_C', NULL, 'MARK1-3_C', NULL, NULL, NULL, 2),
(14757, NULL, 'cd14281', NULL, NULL, 'UBA2_Rad23_like', NULL, 'UBA2_Rad23_like', NULL, NULL, NULL, 2),
(14758, NULL, 'cd13284', NULL, NULL, 'PH_OSBP_ORP4', NULL, 'PH_OSBP_ORP4', NULL, NULL, NULL, 2),
(14759, NULL, 'cd13130', NULL, NULL, 'MATE_rft1', NULL, 'MATE_rft1', NULL, NULL, NULL, 2),
(14760, NULL, 'cd15947', NULL, NULL, '7tmA_OR2B-like', NULL, '7tmA_OR2B-like', NULL, NULL, NULL, 2),
(14761, NULL, 'cd13842', NULL, NULL, 'CuRO_HCO_II_like', NULL, 'CuRO_HCO_II_like', NULL, NULL, NULL, 2),
(14762, NULL, 'cd03180', NULL, NULL, 'GST_C_2', NULL, 'GST_C_2', NULL, NULL, NULL, 2),
(14763, NULL, 'cd12169', NULL, NULL, 'PGDH_like_1', NULL, 'PGDH_like_1', NULL, NULL, NULL, 2),
(14764, NULL, 'cd05226', NULL, NULL, 'SDR_e_a', NULL, 'SDR_e_a', NULL, NULL, NULL, 2),
(14765, NULL, 'cd03391', NULL, NULL, 'PAP2_containing_2_like', NULL, 'PAP2_containing_2_like', NULL, NULL, NULL, 2),
(14766, NULL, 'cd00620', NULL, NULL, 'Methyltransferase_Sun', NULL, 'Methyltransferase_Sun', NULL, NULL, NULL, 2),
(14767, NULL, 'cd04906', NULL, NULL, 'ACT_ThrD-I_1', NULL, 'ACT_ThrD-I_1', NULL, NULL, NULL, 2);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(14768, NULL, 'cd17075', NULL, NULL, 'UBX1_UBXN9', NULL, 'UBX1_UBXN9', NULL, NULL, NULL, 2),
(14769, NULL, 'sd00037', NULL, NULL, 'PASTA', NULL, 'PASTA', NULL, NULL, NULL, 2),
(14770, NULL, 'cd02078', NULL, NULL, 'P-type_ATPase_K', NULL, 'P-type_ATPase_K', NULL, NULL, 5958, 2),
(14771, NULL, 'cd11377', NULL, NULL, 'Pro-peptidase_S53', NULL, 'Pro-peptidase_S53', NULL, NULL, 14162, 2),
(14772, NULL, 'cd13650', NULL, NULL, 'PBP2_THI5', NULL, 'PBP2_THI5', NULL, NULL, NULL, 2),
(14773, NULL, 'cd15520', NULL, NULL, 'PHD3_Lid2p_like', NULL, 'PHD3_Lid2p_like', NULL, NULL, NULL, 2),
(14774, NULL, 'cd03349', NULL, NULL, 'LbH_XAT', NULL, 'LbH_XAT', NULL, NULL, NULL, 2),
(14775, NULL, 'cd00265', NULL, NULL, 'MADS_MEF2_like', NULL, 'MADS_MEF2_like', NULL, NULL, 27344, 2),
(14776, NULL, 'cd11455', NULL, NULL, 'bHLH_AtAIG1_like', NULL, 'bHLH_AtAIG1_like', NULL, NULL, NULL, 2),
(14777, NULL, 'cd12426', NULL, NULL, 'RRM4_PTBPH3', NULL, 'RRM4_PTBPH3', NULL, NULL, NULL, 2),
(14778, NULL, 'cd06551', NULL, NULL, 'LPLAT', NULL, 'LPLAT', NULL, NULL, NULL, 2),
(14779, NULL, 'cd14142', NULL, NULL, 'STKc_ACVR1_ALK1', NULL, 'STKc_ACVR1_ALK1', NULL, NULL, NULL, 2),
(14780, NULL, 'cd14481', NULL, NULL, 'SPX_AtSPX1_like', NULL, 'SPX_AtSPX1_like', NULL, NULL, NULL, 2),
(14781, NULL, 'cd18248', NULL, NULL, 'BTB_POZ_KLHL19_KEAP1', NULL, 'BTB_POZ_KLHL19_KEAP1', NULL, NULL, NULL, 2),
(14782, NULL, 'cd09482', NULL, NULL, 'LIM2_CRP3', NULL, 'LIM2_CRP3', NULL, NULL, NULL, 2),
(14783, NULL, 'cd12338', NULL, NULL, 'RRM1_SRSF1_like', NULL, 'RRM1_SRSF1_like', NULL, NULL, NULL, 2),
(14784, NULL, 'cd10458', NULL, NULL, 'GIY-YIG_NifU', NULL, 'GIY-YIG_NifU', NULL, NULL, NULL, 2),
(14785, NULL, 'cd00593', NULL, NULL, 'RIBOc', NULL, 'RIBOc', NULL, NULL, 80, 2),
(14786, NULL, 'cd16892', NULL, NULL, 'LT_VirB1-like', NULL, 'LT_VirB1-like', NULL, NULL, NULL, 2),
(14787, NULL, 'cd14593', NULL, NULL, 'PTP-MTMR10', NULL, 'PTP-MTMR10', NULL, NULL, NULL, 2),
(14788, NULL, 'cd14862', NULL, NULL, 'Fe-ADH-like', NULL, 'Fe-ADH-like', NULL, NULL, NULL, 2),
(14789, NULL, 'cd13986', NULL, NULL, 'STKc_16', NULL, 'STKc_16', NULL, NULL, NULL, 2),
(14790, NULL, 'cd14889', NULL, NULL, 'MYSc_Myo28', NULL, 'MYSc_Myo28', NULL, NULL, NULL, 2),
(14791, NULL, 'cd15259', NULL, NULL, '7tmB2_GPR124-like_Adhesion_III', NULL, '7tmB2_GPR124-like_Adhesion_III', NULL, NULL, NULL, 2),
(14792, NULL, 'cd11343', NULL, NULL, 'AmyAc_Sucrose_phosphorylase-like', NULL, 'AmyAc_Sucrose_phosphorylase-like', NULL, NULL, NULL, 2),
(14793, NULL, 'cd13594', NULL, NULL, 'PBP2_HisGL4', NULL, 'PBP2_HisGL4', NULL, NULL, NULL, 2),
(14794, NULL, 'cd08752', NULL, NULL, 'RGS_GRK5', NULL, 'RGS_GRK5', NULL, NULL, NULL, 2),
(14795, NULL, 'cd01400', NULL, NULL, '6PGL', NULL, '6PGL', NULL, NULL, 6691, 2),
(14796, NULL, 'cd02972', NULL, NULL, 'DsbA_family', NULL, 'DsbA_family', NULL, NULL, NULL, 2),
(14797, NULL, 'cd04059', NULL, NULL, 'Peptidases_S8_Protein_convertases_Kexins_Furin...', NULL, 'Peptidases_S8_Protein_convertases_Kexins_Furin-like', NULL, NULL, 22613, 2),
(14798, NULL, 'cd05174', NULL, NULL, 'PI3Kc_IA_delta', NULL, 'PI3Kc_IA_delta', NULL, NULL, 31349, 2),
(14799, NULL, 'cd12946', NULL, NULL, 'NOPS_p54nrb_PSF_PSPC1', NULL, 'NOPS_p54nrb_PSF_PSPC1', NULL, NULL, NULL, 2),
(14800, NULL, 'cd17760', NULL, NULL, 'MCM9', NULL, 'MCM9', NULL, NULL, NULL, 2),
(14801, NULL, 'cd14833', NULL, NULL, 'AP2_sigma', NULL, 'AP2_sigma', NULL, NULL, 26778, 2),
(14802, NULL, 'cd13631', NULL, NULL, 'PBP2_Ct-PDT_like', NULL, 'PBP2_Ct-PDT_like', NULL, NULL, NULL, 2),
(14803, NULL, 'cd10579', NULL, NULL, 'TNFRSF6', NULL, 'TNFRSF6', NULL, NULL, 16648, 2),
(14804, NULL, 'cd15038', NULL, NULL, '7tmF_FZD4', NULL, '7tmF_FZD4', NULL, NULL, NULL, 2),
(14805, NULL, 'cd20262', NULL, NULL, 'Complex1_LYR_LYRM2', NULL, 'Complex1_LYR_LYRM2', NULL, NULL, 34385, 2),
(14806, NULL, 'cd19371', NULL, NULL, 'UDG-F1-like', NULL, 'UDG-F1-like', NULL, NULL, NULL, 2),
(14807, NULL, 'cd07367', NULL, NULL, 'CarBb', NULL, 'CarBb', NULL, NULL, 20204, 2),
(14808, NULL, 'cd11859', NULL, NULL, 'SH3_ZO', NULL, 'SH3_ZO', NULL, NULL, NULL, 2);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(14809, NULL, 'cd05931', NULL, NULL, 'FAAL', NULL, 'FAAL', NULL, NULL, 31831, 2),
(14810, NULL, 'cd12004', NULL, NULL, 'SH3_Lyn', NULL, 'SH3_Lyn', NULL, NULL, 28156, 2),
(14811, NULL, 'cd12120', NULL, NULL, 'AMPKA_C_like', NULL, 'AMPKA_C_like', NULL, NULL, NULL, 2),
(14812, NULL, 'cd17209', NULL, NULL, 'RA_RalGDS', NULL, 'RA_RalGDS', NULL, NULL, NULL, 2),
(14813, NULL, 'cd19110', NULL, NULL, 'AKR_AKR1E1-2', NULL, 'AKR_AKR1E1-2', NULL, NULL, 35036, 2),
(14814, NULL, 'cd19880', NULL, NULL, 'DSRM_STAU2_rpt1', NULL, 'DSRM_STAU2_rpt1', NULL, NULL, 34244, 2),
(14815, NULL, 'cd15772', NULL, NULL, 'FYVE2_BSN_PCLO', NULL, 'FYVE2_BSN_PCLO', NULL, NULL, NULL, 2),
(14816, NULL, 'cd04021', NULL, NULL, 'C2_E3_ubiquitin_ligase', NULL, 'C2_E3_ubiquitin_ligase', NULL, NULL, NULL, 2),
(14817, NULL, 'cd08763', NULL, NULL, 'Cyt_b561_CYB561', NULL, 'Cyt_b561_CYB561', NULL, NULL, NULL, 2),
(14818, NULL, 'cd18708', NULL, NULL, 'PIN_VapC-like', NULL, 'PIN_VapC-like', NULL, NULL, NULL, 2),
(14819, NULL, 'cd01156', NULL, NULL, 'IVD', NULL, 'IVD', NULL, NULL, 25699, 2),
(14820, NULL, 'cd14904', NULL, NULL, 'MYSc_Myo43', NULL, 'MYSc_Myo43', NULL, NULL, NULL, 2),
(14821, NULL, 'cd09119', NULL, NULL, 'PLDc_FAM83_N', NULL, 'PLDc_FAM83_N', NULL, NULL, NULL, 2),
(14822, NULL, 'cd18211', NULL, NULL, 'BTB_POZ_ZBTB23_GZF1', NULL, 'BTB_POZ_ZBTB23_GZF1', NULL, NULL, NULL, 2),
(14823, NULL, 'cd00432', NULL, NULL, 'Ribosomal_L18_L5e', NULL, 'Ribosomal_L18_L5e', NULL, NULL, NULL, 2),
(14824, NULL, 'cd07337', NULL, NULL, 'M48B_HtpX_like', NULL, 'M48B_HtpX_like', NULL, NULL, NULL, 2),
(14825, NULL, 'cd07881', NULL, NULL, 'RHD-n_NFAT', NULL, 'RHD-n_NFAT', NULL, NULL, NULL, 2),
(14826, NULL, 'cd16619', NULL, NULL, 'mRING-HC-C4C4_TRIM37_C-VIII', NULL, 'mRING-HC-C4C4_TRIM37_C-VIII', NULL, NULL, NULL, 2),
(14827, NULL, 'cd17190', NULL, NULL, 'FERM_F1_FARP2', NULL, 'FERM_F1_FARP2', NULL, NULL, NULL, 2),
(14828, NULL, 'cd01595', NULL, NULL, 'Adenylsuccinate_lyase_like', NULL, 'Adenylsuccinate_lyase_like', NULL, NULL, NULL, 2),
(14829, NULL, 'cd18088', NULL, NULL, 'Nep1-like', NULL, 'Nep1-like', NULL, NULL, 5319, 2),
(14830, NULL, 'cd12874', NULL, NULL, 'SPRY_PRY', NULL, 'SPRY_PRY', NULL, NULL, NULL, 2),
(14831, NULL, 'cd12584', NULL, NULL, 'RRM2_hnRNPAB', NULL, 'RRM2_hnRNPAB', NULL, NULL, NULL, 2),
(14832, NULL, 'cd16384', NULL, NULL, 'VirB8_like', NULL, 'VirB8_like', NULL, NULL, NULL, 2),
(14833, NULL, 'cd05859', NULL, NULL, 'Ig4_PDGFR', NULL, 'Ig4_PDGFR', NULL, NULL, NULL, 2),
(14834, NULL, 'cd18133', NULL, NULL, 'HLD_clamp', NULL, 'HLD_clamp', NULL, NULL, NULL, 2),
(14835, NULL, 'cd10393', NULL, NULL, 'SH2_RIN1', NULL, 'SH2_RIN1', NULL, NULL, 31562, 2),
(14836, NULL, 'cd03251', NULL, NULL, 'ABCC_MsbA', NULL, 'ABCC_MsbA', NULL, NULL, NULL, 2),
(14837, NULL, 'cd12418', NULL, NULL, 'RRM_Aly_REF_like', NULL, 'RRM_Aly_REF_like', NULL, NULL, NULL, 2),
(14838, NULL, 'cd14084', NULL, NULL, 'STKc_Chk2', NULL, 'STKc_Chk2', NULL, NULL, NULL, 2),
(14839, NULL, 'cd15481', NULL, NULL, 'SRP68-RBD', NULL, 'SRP68-RBD', NULL, NULL, 6113, 2),
(14840, NULL, 'cd03896', NULL, NULL, 'M20_PAAh_like', NULL, 'M20_PAAh_like', NULL, NULL, NULL, 2),
(14841, NULL, 'cd01339', NULL, NULL, 'LDH-like_MDH', NULL, 'LDH-like_MDH', NULL, NULL, 10124, 2),
(14842, NULL, 'cd02134', NULL, NULL, 'NusA_KH', NULL, 'NusA_KH', NULL, NULL, NULL, 2),
(14843, NULL, 'cd06064', NULL, NULL, 'H2MP_F420-Reduc', NULL, 'H2MP_F420-Reduc', NULL, NULL, 5955, 2),
(14844, NULL, 'cd19707', NULL, NULL, 'bHLH_TS_TAL2', NULL, 'bHLH_TS_TAL2', NULL, NULL, NULL, 2),
(14845, NULL, 'cd21594', NULL, NULL, 'deltaCoV_M', NULL, 'deltaCoV_M', NULL, NULL, 34139, 2),
(14846, NULL, 'cd09187', NULL, NULL, 'PLDc_FAM83G_N', NULL, 'PLDc_FAM83G_N', NULL, NULL, NULL, 2),
(14847, NULL, 'cd11892', NULL, NULL, 'SH3_MIA2', NULL, 'SH3_MIA2', NULL, NULL, 33086, 2),
(14848, NULL, 'cd06570', NULL, NULL, 'GH20_chitobiase-like_1', NULL, 'GH20_chitobiase-like_1', NULL, NULL, NULL, 2),
(14849, NULL, 'cd00852', NULL, NULL, 'NifB', NULL, 'NifB', NULL, NULL, 14221, 2),
(14850, NULL, 'cd17874', NULL, NULL, 'FtsY', NULL, 'FtsY', NULL, NULL, NULL, 2);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(14851, NULL, 'cd00487', NULL, NULL, 'Pep_deformylase', NULL, 'Pep_deformylase', NULL, NULL, 6229, 2),
(14852, NULL, 'cd06604', NULL, NULL, 'GH31_glucosidase_II_MalA', NULL, 'GH31_glucosidase_II_MalA', NULL, NULL, NULL, 2),
(14853, NULL, 'cd06617', NULL, NULL, 'PKc_MKK3_6', NULL, 'PKc_MKK3_6', NULL, NULL, NULL, 2),
(14854, NULL, 'cd11383', NULL, NULL, 'YfjP', NULL, 'YfjP', NULL, NULL, NULL, 2),
(14855, NULL, 'cd07901', NULL, NULL, 'Adenylation_DNA_ligase_Arch_LigB', NULL, 'Adenylation_DNA_ligase_Arch_LigB', NULL, NULL, NULL, 2),
(14856, NULL, 'cd09186', NULL, NULL, 'PLDc_FAM83F_N', NULL, 'PLDc_FAM83F_N', NULL, NULL, NULL, 2),
(14857, NULL, 'cd00885', NULL, NULL, 'cinA', NULL, 'cinA', NULL, NULL, 6278, 2),
(14858, NULL, 'cd00656', NULL, NULL, 'Zn-ribbon', NULL, 'Zn-ribbon', NULL, NULL, NULL, 2),
(14859, NULL, 'cd05908', NULL, NULL, 'A_NRPS_MycA_like', NULL, 'A_NRPS_MycA_like', NULL, NULL, NULL, 2),
(14860, NULL, 'cd19904', NULL, NULL, 'DSRM_EIF2AK2_rpt2', NULL, 'DSRM_EIF2AK2_rpt2', NULL, NULL, 36269, 2),
(14861, NULL, 'cd02180', NULL, NULL, 'GH16_fungal_KRE6_glucanase', NULL, 'GH16_fungal_KRE6_glucanase', NULL, NULL, 2702, 2),
(14862, NULL, 'cd18815', NULL, NULL, 'CAP_R3HDML', NULL, 'CAP_R3HDML', NULL, NULL, NULL, 2),
(14863, NULL, 'cd08506', NULL, NULL, 'PBP2_clavulanate_OppA2', NULL, 'PBP2_clavulanate_OppA2', NULL, NULL, NULL, 2),
(14864, NULL, 'cd06452', NULL, NULL, 'SepCysS', NULL, 'SepCysS', NULL, NULL, NULL, 2),
(14865, NULL, 'cd07614', NULL, NULL, 'BAR_Endophilin_A2', NULL, 'BAR_Endophilin_A2', NULL, NULL, NULL, 2),
(14866, NULL, 'cd16289', NULL, NULL, 'L1_POM-1-like_MBL-B3', NULL, 'L1_POM-1-like_MBL-B3', NULL, NULL, NULL, 2),
(14867, NULL, 'cd00264', NULL, NULL, 'BPI', NULL, 'BPI', NULL, NULL, NULL, 2),
(14868, NULL, 'cd12363', NULL, NULL, 'RRM_TRA2', NULL, 'RRM_TRA2', NULL, NULL, NULL, 2),
(14869, NULL, 'cd09412', NULL, NULL, 'LIM4_Leupaxin', NULL, 'LIM4_Leupaxin', NULL, NULL, NULL, 2),
(14870, NULL, 'cd17080', NULL, NULL, 'Ubl_SLD2_Esc2_like', NULL, 'Ubl_SLD2_Esc2_like', NULL, NULL, NULL, 2),
(14871, NULL, 'cd07714', NULL, NULL, 'RNaseJ_MBL-fold', NULL, 'RNaseJ_MBL-fold', NULL, NULL, NULL, 2),
(14872, NULL, 'cd07847', NULL, NULL, 'STKc_CDKL1_4', NULL, 'STKc_CDKL1_4', NULL, NULL, NULL, 2),
(14873, NULL, 'cd14662', NULL, NULL, 'STKc_SnRK2', NULL, 'STKc_SnRK2', NULL, NULL, NULL, 2),
(14874, NULL, 'cd10289', NULL, NULL, 'GST_C_AaRS_like', NULL, 'GST_C_AaRS_like', NULL, NULL, NULL, 2),
(14875, NULL, 'cd08945', NULL, NULL, 'PKR_SDR_c', NULL, 'PKR_SDR_c', NULL, NULL, NULL, 2),
(14876, NULL, 'cd11542', NULL, NULL, 'NTP-PPase_u5', NULL, 'NTP-PPase_u5', NULL, NULL, NULL, 2),
(14877, NULL, 'cd12933', NULL, NULL, 'eIF3G', NULL, 'eIF3G', NULL, NULL, 123, 2),
(14878, NULL, 'cd13641', NULL, NULL, 'PBP2_HisX_like', NULL, 'PBP2_HisX_like', NULL, NULL, NULL, 2),
(14879, NULL, 'cd16707', NULL, NULL, 'RING-HC_CARP2', NULL, 'RING-HC_CARP2', NULL, NULL, NULL, 2),
(14880, NULL, 'cd17869', NULL, NULL, 'TadZ-like', NULL, 'TadZ-like', NULL, NULL, NULL, 2),
(14881, NULL, 'cd13880', NULL, NULL, 'CuRO_2_MaLCC_like', NULL, 'CuRO_2_MaLCC_like', NULL, NULL, NULL, 2),
(14882, NULL, 'cd12728', NULL, NULL, 'RRM_like_Smg4_UPF3B', NULL, 'RRM_like_Smg4_UPF3B', NULL, NULL, 31028, 2),
(14883, NULL, 'cd03015', NULL, NULL, 'PRX_Typ2cys', NULL, 'PRX_Typ2cys', NULL, NULL, NULL, 2),
(14884, NULL, 'cd05890', NULL, NULL, 'Ig2_Nectin-1_like', NULL, 'Ig2_Nectin-1_like', NULL, NULL, 30813, 2),
(14885, NULL, 'cd08676', NULL, NULL, 'C2A_Munc13-like', NULL, 'C2A_Munc13-like', NULL, NULL, NULL, 2),
(14886, NULL, 'cd09584', NULL, NULL, 'SAM_sec23ip', NULL, 'SAM_sec23ip', NULL, NULL, 33508, 2),
(14887, NULL, 'cd09427', NULL, NULL, 'LIM2_FHL3', NULL, 'LIM2_FHL3', NULL, NULL, NULL, 2),
(14888, NULL, 'cd01293', NULL, NULL, 'Bact_CD', NULL, 'Bact_CD', NULL, NULL, NULL, 2),
(14889, NULL, 'cd19037', NULL, NULL, 'LGIC_ECD_GABAAR_A4', NULL, 'LGIC_ECD_GABAAR_A4', NULL, NULL, NULL, 2),
(14890, NULL, 'cd08906', NULL, NULL, 'START_STARD3-like', NULL, 'START_STARD3-like', NULL, NULL, 22245, 2),
(14891, NULL, 'cd13221', NULL, NULL, 'PH-GRAM_GRAMDC4', NULL, 'PH-GRAM_GRAMDC4', NULL, NULL, 32090, 2);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(14892, NULL, 'cd13581', NULL, NULL, 'PBP2_AlgQ_like_2', NULL, 'PBP2_AlgQ_like_2', NULL, NULL, NULL, 2),
(14893, NULL, 'cd07572', NULL, NULL, 'nit', NULL, 'nit', NULL, NULL, 34578, 2),
(14894, NULL, 'cd15703', NULL, NULL, 'ePHD_BRPF3', NULL, 'ePHD_BRPF3', NULL, NULL, 30458, 2),
(14895, NULL, 'cd21666', NULL, NULL, 'betaCoV_Nsp5_Mpro', NULL, 'betaCoV_Nsp5_Mpro', NULL, NULL, 12163, 2),
(14896, NULL, 'cd04890', NULL, NULL, 'ACT_AK-like_1', NULL, 'ACT_AK-like_1', NULL, NULL, NULL, 2),
(14897, NULL, 'cd07545', NULL, NULL, 'P-type_ATPase_Cd-like', NULL, 'P-type_ATPase_Cd-like', NULL, NULL, NULL, 2),
(14898, NULL, 'cd01833', NULL, NULL, 'XynB_like', NULL, 'XynB_like', NULL, NULL, NULL, 2),
(14899, NULL, 'cd01986', NULL, NULL, 'Alpha_ANH_like', NULL, 'Alpha_ANH_like', NULL, NULL, NULL, 2),
(14900, NULL, 'cd20301', NULL, NULL, 'cupin_ChrR', NULL, 'cupin_ChrR', NULL, NULL, 12519, 2),
(14901, NULL, 'cd11429', NULL, NULL, 'bHLH_TS_OLIG', NULL, 'bHLH_TS_OLIG', NULL, NULL, NULL, 2),
(14902, NULL, 'cd13262', NULL, NULL, 'PH_RasSynGAP-like', NULL, 'PH_RasSynGAP-like', NULL, NULL, NULL, 2),
(14903, NULL, 'cd19029', NULL, NULL, 'LGIC_ECD_nAChR_G', NULL, 'LGIC_ECD_nAChR_G', NULL, NULL, NULL, 2),
(14904, NULL, 'cd08818', NULL, NULL, 'CARD_MDA5_r1', NULL, 'CARD_MDA5_r1', NULL, NULL, NULL, 2),
(14905, NULL, 'cd01665', NULL, NULL, 'Cyt_c_Oxidase_III', NULL, 'Cyt_c_Oxidase_III', NULL, NULL, 32298, 2),
(14906, NULL, 'cd08786', NULL, NULL, 'CARD_RIP2_CARD3', NULL, 'CARD_RIP2_CARD3', NULL, NULL, 37435, 2),
(14907, NULL, 'cd07342', NULL, NULL, 'M48C_Oma1_like', NULL, 'M48C_Oma1_like', NULL, NULL, NULL, 2),
(14908, NULL, 'cd17950', NULL, NULL, 'DEADc_DDX39', NULL, 'DEADc_DDX39', NULL, NULL, NULL, 2),
(14909, NULL, 'cd11375', NULL, NULL, 'Peptidase_M54', NULL, 'Peptidase_M54', NULL, NULL, 11824, 2),
(14910, NULL, 'cd12419', NULL, NULL, 'RRM_Ssp2_like', NULL, 'RRM_Ssp2_like', NULL, NULL, 16122, 2),
(14911, NULL, 'cd16198', NULL, NULL, 'EFh_PEF_CAPN1', NULL, 'EFh_PEF_CAPN1', NULL, NULL, NULL, 2),
(14912, NULL, 'cd13340', NULL, NULL, 'PH-GRAM_MTMR5', NULL, 'PH-GRAM_MTMR5', NULL, NULL, NULL, 2),
(14913, NULL, 'cd14733', NULL, NULL, 'BACK', NULL, 'BACK', NULL, NULL, NULL, 2),
(14914, NULL, 'cd06154', NULL, NULL, 'YjgF_YER057c_UK114_like_6', NULL, 'YjgF_YER057c_UK114_like_6', NULL, NULL, NULL, 2),
(14915, NULL, 'cd03501', NULL, NULL, 'SQR_TypeA_SdhC_like', NULL, 'SQR_TypeA_SdhC_like', NULL, NULL, NULL, 2),
(14916, NULL, 'cd02997', NULL, NULL, 'PDI_a_PDIR', NULL, 'PDI_a_PDIR', NULL, NULL, 37446, 2),
(14917, NULL, 'cd17166', NULL, NULL, 'RAWUL_RING1', NULL, 'RAWUL_RING1', NULL, NULL, NULL, 2),
(14918, NULL, 'cd02013', NULL, NULL, 'TPP_Xsc_like', NULL, 'TPP_Xsc_like', NULL, NULL, NULL, 2),
(14919, NULL, 'cd13365', NULL, NULL, 'PH_PLC_plant-like', NULL, 'PH_PLC_plant-like', NULL, NULL, NULL, 2),
(14920, NULL, 'cd18656', NULL, NULL, 'CSD_HP1gamma_Cbx3', NULL, 'CSD_HP1gamma_Cbx3', NULL, NULL, NULL, 2),
(14921, NULL, 'cd07002', NULL, NULL, 'cupin_SznF-like_C', NULL, 'cupin_SznF-like_C', NULL, NULL, NULL, 2),
(14922, NULL, 'cd06426', NULL, NULL, 'NTP_transferase_like_2', NULL, 'NTP_transferase_like_2', NULL, NULL, NULL, 2),
(14923, NULL, 'cd08225', NULL, NULL, 'STKc_Nek5', NULL, 'STKc_Nek5', NULL, NULL, NULL, 2),
(14924, NULL, 'cd03351', NULL, NULL, 'LbH_UDP-GlcNAc_AT', NULL, 'LbH_UDP-GlcNAc_AT', NULL, NULL, 10746, 2),
(14925, NULL, 'cd13267', NULL, NULL, 'PH_DOCK-D', NULL, 'PH_DOCK-D', NULL, NULL, NULL, 2),
(14926, NULL, 'cd07986', NULL, NULL, 'LPLAT_ACT14924-like', NULL, 'LPLAT_ACT14924-like', NULL, NULL, 36212, 2),
(14927, NULL, 'cd08648', NULL, NULL, 'FMT_core_Formyl-FH4-Hydrolase_C', NULL, 'FMT_core_Formyl-FH4-Hydrolase_C', NULL, NULL, 29843, 2),
(14928, NULL, 'cd08732', NULL, NULL, 'RGS-like_4', NULL, 'RGS-like_4', NULL, NULL, NULL, 2),
(14929, NULL, 'cd16499', NULL, NULL, 'RING-HC_BRE1_like', NULL, 'RING-HC_BRE1_like', NULL, NULL, NULL, 2),
(14930, NULL, 'cd04766', NULL, NULL, 'HTH_HspR', NULL, 'HTH_HspR', NULL, NULL, NULL, 2),
(14931, NULL, 'cd17261', NULL, NULL, 'RMtype1_S_EcoKI-TRD2-CR2_like', NULL, 'RMtype1_S_EcoKI-TRD2-CR2_like', NULL, NULL, NULL, 2);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(14932, NULL, 'cd04328', NULL, NULL, 'RNAP_I_Rpa43_N', NULL, 'RNAP_I_Rpa43_N', NULL, NULL, 30684, 2),
(14933, NULL, 'cd16393', NULL, NULL, 'SPO0J_N', NULL, 'SPO0J_N', NULL, NULL, NULL, 2),
(14934, NULL, 'cd08943', NULL, NULL, 'R1PA_ADH_SDR_c', NULL, 'R1PA_ADH_SDR_c', NULL, NULL, NULL, 2),
(14935, NULL, 'cd16203', NULL, NULL, 'EFh_PI-PLCepsilon', NULL, 'EFh_PI-PLCepsilon', NULL, NULL, NULL, 2),
(14936, NULL, 'cd03765', NULL, NULL, 'proteasome_beta_bacterial', NULL, 'proteasome_beta_bacterial', NULL, NULL, NULL, 2),
(14937, NULL, 'cd14111', NULL, NULL, 'STKc_SPEG_rpt2', NULL, 'STKc_SPEG_rpt2', NULL, NULL, NULL, 2),
(14938, NULL, 'cd00005', NULL, NULL, 'CBM9_like_1', NULL, 'CBM9_like_1', NULL, NULL, NULL, 2),
(14939, NULL, 'cd16099', NULL, NULL, 'TenA_PqqC-like', NULL, 'TenA_PqqC-like', NULL, NULL, NULL, 2),
(14940, NULL, 'cd07301', NULL, NULL, 'PX_SNX21', NULL, 'PX_SNX21', NULL, NULL, NULL, 2),
(14941, NULL, 'cd13665', NULL, NULL, 'PBP2_TRAP_Dctp3_4', NULL, 'PBP2_TRAP_Dctp3_4', NULL, NULL, NULL, 2),
(14942, NULL, 'cd16774', NULL, NULL, 'RING-HC_RBR_ANKIB1', NULL, 'RING-HC_RBR_ANKIB1', NULL, NULL, NULL, 2),
(14943, NULL, 'cd01612', NULL, NULL, 'Ubl_ATG12', NULL, 'Ubl_ATG12', NULL, NULL, NULL, 2),
(14944, NULL, 'cd07682', NULL, NULL, 'F-BAR_srGAP2', NULL, 'F-BAR_srGAP2', NULL, NULL, NULL, 2),
(14945, NULL, 'cd16326', NULL, NULL, 'LolB', NULL, 'LolB', NULL, NULL, 577, 2),
(14946, NULL, 'cd13748', NULL, NULL, 'CBM29_CBM65', NULL, 'CBM29_CBM65', NULL, NULL, NULL, 2),
(14947, NULL, 'cd06391', NULL, NULL, 'PBP1_iGluR_delta_2', NULL, 'PBP1_iGluR_delta_2', NULL, NULL, NULL, 2),
(14948, NULL, 'cd15479', NULL, NULL, 'fMyo4p_CBD', NULL, 'fMyo4p_CBD', NULL, NULL, NULL, 2),
(14949, NULL, 'cd19109', NULL, NULL, 'AKR_AKR1D1-3', NULL, 'AKR_AKR1D1-3', NULL, NULL, 34754, 2),
(14950, NULL, 'cd17737', NULL, NULL, 'BRCT_TopBP1_rpt1', NULL, 'BRCT_TopBP1_rpt1', NULL, NULL, 34643, 2),
(14951, NULL, 'cd18047', NULL, NULL, 'DEADc_DDX19', NULL, 'DEADc_DDX19', NULL, NULL, NULL, 2),
(14952, NULL, 'cd05265', NULL, NULL, 'SDR_a1', NULL, 'SDR_a1', NULL, NULL, NULL, 2),
(14953, NULL, 'cd10931', NULL, NULL, 'CE4_u7', NULL, 'CE4_u7', NULL, NULL, NULL, 2),
(14954, NULL, 'cd05400', NULL, NULL, 'NT_2-5OAS_ClassI-CCAase', NULL, 'NT_2-5OAS_ClassI-CCAase', NULL, NULL, 10069, 2),
(14955, NULL, 'cd16334', NULL, NULL, 'LppX-like', NULL, 'LppX-like', NULL, NULL, 13457, 2),
(14956, NULL, 'cd17379', NULL, NULL, 'MFS_SLC22A1_2_3', NULL, 'MFS_SLC22A1_2_3', NULL, NULL, NULL, 2),
(14957, NULL, 'cd02754', NULL, NULL, 'MopB_Nitrate-R-NapA-like', NULL, 'MopB_Nitrate-R-NapA-like', NULL, NULL, NULL, 2),
(14958, NULL, 'cd19189', NULL, NULL, 'PR-SET_PRDM4', NULL, 'PR-SET_PRDM4', NULL, NULL, 36412, 2),
(14959, NULL, 'cd01882', NULL, NULL, 'BMS1', NULL, 'BMS1', NULL, NULL, 27430, 2),
(14960, NULL, 'cd17598', NULL, NULL, 'REC_hyHK', NULL, 'REC_hyHK', NULL, NULL, NULL, 2),
(14961, NULL, 'cd08528', NULL, NULL, 'STKc_Nek10', NULL, 'STKc_Nek10', NULL, NULL, 35903, 2),
(14962, NULL, 'cd05575', NULL, NULL, 'STKc_SGK', NULL, 'STKc_SGK', NULL, NULL, NULL, 2),
(14963, NULL, 'cd03396', NULL, NULL, 'PAP2_like_6', NULL, 'PAP2_like_6', NULL, NULL, NULL, 2),
(14964, NULL, 'cd07353', NULL, NULL, 'harmonin_N', NULL, 'harmonin_N', NULL, NULL, NULL, 2),
(14965, NULL, 'cd21567', NULL, NULL, 'MERS-like-CoV_M', NULL, 'MERS-like-CoV_M', NULL, NULL, 36234, 2),
(14966, NULL, 'cd11533', NULL, NULL, 'NTP-PPase_Af0060_like', NULL, 'NTP-PPase_Af0060_like', NULL, NULL, 35153, 2),
(14967, NULL, 'cd12680', NULL, NULL, 'RRM_THOC4', NULL, 'RRM_THOC4', NULL, NULL, NULL, 2),
(14968, NULL, 'cd07768', NULL, NULL, 'FGGY_RBK_like', NULL, 'FGGY_RBK_like', NULL, NULL, NULL, 2),
(14969, NULL, 'cd03717', NULL, NULL, 'SOCS_SOCS_like', NULL, 'SOCS_SOCS_like', NULL, NULL, NULL, 2),
(14970, NULL, 'cd14992', NULL, NULL, '7tmA_TACR_family', NULL, '7tmA_TACR_family', NULL, NULL, NULL, 2),
(14971, NULL, 'cd17974', NULL, NULL, 'DEXHc_DHX16', NULL, 'DEXHc_DHX16', NULL, NULL, NULL, 2),
(14972, NULL, 'cd01027', NULL, NULL, 'TOPRIM_RNase_M5_like', NULL, 'TOPRIM_RNase_M5_like', NULL, NULL, 5711, 2),
(14973, NULL, 'cd13326', NULL, NULL, 'PH_CNK_insect-like', NULL, 'PH_CNK_insect-like', NULL, NULL, NULL, 2);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(14974, NULL, 'cd00866', NULL, NULL, 'PEBP_euk', NULL, 'PEBP_euk', NULL, NULL, 28661, 2),
(14975, NULL, 'cd14834', NULL, NULL, 'AP3_sigma', NULL, 'AP3_sigma', NULL, NULL, 26574, 2),
(14976, NULL, 'cd03510', NULL, NULL, 'Rhizobitoxine-FADS-like', NULL, 'Rhizobitoxine-FADS-like', NULL, NULL, NULL, 2),
(14977, NULL, 'cd07952', NULL, NULL, 'ED_3B_like', NULL, 'ED_3B_like', NULL, NULL, NULL, 2),
(14978, NULL, 'cd04930', NULL, NULL, 'ACT_TH', NULL, 'ACT_TH', NULL, NULL, NULL, 2),
(14979, NULL, 'cd07311', NULL, NULL, 'terB_like_1', NULL, 'terB_like_1', NULL, NULL, NULL, 2),
(14980, NULL, 'cd11556', NULL, NULL, 'SLC6sbd_SERT-like_u1', NULL, 'SLC6sbd_SERT-like_u1', NULL, NULL, NULL, 2),
(14981, NULL, 'cd07617', NULL, NULL, 'BAR_Endophilin_B2', NULL, 'BAR_Endophilin_B2', NULL, NULL, NULL, 2),
(14982, NULL, 'cd05479', NULL, NULL, 'RP_DDI', NULL, 'RP_DDI', NULL, NULL, 17511, 2),
(14983, NULL, 'cd01269', NULL, NULL, 'PTB_TBC1D1_like', NULL, 'PTB_TBC1D1_like', NULL, NULL, NULL, 2),
(14984, NULL, 'cd08813', NULL, NULL, 'DED_Caspase_8_r2', NULL, 'DED_Caspase_8_r2', NULL, NULL, NULL, 2),
(14985, NULL, 'cd07357', NULL, NULL, 'HN_L-whirlin_R2_like', NULL, 'HN_L-whirlin_R2_like', NULL, NULL, NULL, 2),
(14986, NULL, 'cd16694', NULL, NULL, 'mRING-CH-C4HC2H_ZNRF1', NULL, 'mRING-CH-C4HC2H_ZNRF1', NULL, NULL, NULL, 2),
(14987, NULL, 'cd11339', NULL, NULL, 'AmyAc_bac_CMD_like_2', NULL, 'AmyAc_bac_CMD_like_2', NULL, NULL, NULL, 2),
(14988, NULL, 'cd18597', NULL, NULL, 'ABC_6TM_YOR1_D1_like', NULL, 'ABC_6TM_YOR1_D1_like', NULL, NULL, NULL, 2),
(14989, NULL, 'cd14136', NULL, NULL, 'STKc_SRPK', NULL, 'STKc_SRPK', NULL, NULL, NULL, 2),
(14990, NULL, 'cd03073', NULL, NULL, 'PDI_b''_ERp72_ERp57', NULL, 'PDI_b''_ERp72_ERp57', NULL, NULL, NULL, 2),
(14991, NULL, 'cd00338', NULL, NULL, 'Ser_Recombinase', NULL, 'Ser_Recombinase', NULL, NULL, NULL, 2),
(14992, NULL, 'cd11445', NULL, NULL, 'bHLH_AtPIF_like', NULL, 'bHLH_AtPIF_like', NULL, NULL, NULL, 2),
(14993, NULL, 'cd06372', NULL, NULL, 'PBP1_GC_G-like', NULL, 'PBP1_GC_G-like', NULL, NULL, NULL, 2),
(14994, NULL, 'cd14014', NULL, NULL, 'STKc_PknB_like', NULL, 'STKc_PknB_like', NULL, NULL, NULL, 2),
(14995, NULL, 'cd19570', NULL, NULL, 'serpinB11_epipin', NULL, 'serpinB11_epipin', NULL, NULL, NULL, 2),
(14996, NULL, 'cd16371', NULL, NULL, 'DMSOR_beta_like', NULL, 'DMSOR_beta_like', NULL, NULL, NULL, 2),
(14997, NULL, 'cd14371', NULL, NULL, 'CUE_CID7_like', NULL, 'CUE_CID7_like', NULL, NULL, 30549, 2),
(14998, NULL, 'cd01211', NULL, NULL, 'PTB_Rab6GAP', NULL, 'PTB_Rab6GAP', NULL, NULL, NULL, 2),
(14999, NULL, 'cd12250', NULL, NULL, 'RRM2_hnRNPR_like', NULL, 'RRM2_hnRNPR_like', NULL, NULL, NULL, 2),
(15000, NULL, 'cd18709', NULL, NULL, 'PIN_VapC-like', NULL, 'PIN_VapC-like', NULL, NULL, NULL, 2),
(15001, NULL, 'cd18559', NULL, NULL, 'ABC_6TM_ABCC', NULL, 'ABC_6TM_ABCC', NULL, NULL, NULL, 2),
(15002, NULL, 'cd01868', NULL, NULL, 'Rab11_like', NULL, 'Rab11_like', NULL, NULL, NULL, 2),
(15003, NULL, 'cd06923', NULL, NULL, 'ChtBD1_GH16', NULL, 'ChtBD1_GH16', NULL, NULL, NULL, 2),
(15004, NULL, 'cd15918', NULL, NULL, '7tmA_OR1_7-like', NULL, '7tmA_OR1_7-like', NULL, NULL, NULL, 2),
(15005, NULL, 'cd00170', NULL, NULL, 'SEC14', NULL, 'SEC14', NULL, NULL, 6774, 2),
(15006, NULL, 'cd17418', NULL, NULL, 'MFS_NPF8', NULL, 'MFS_NPF8', NULL, NULL, NULL, 2),
(15007, NULL, 'cd05345', NULL, NULL, 'BKR_3_SDR_c', NULL, 'BKR_3_SDR_c', NULL, NULL, NULL, 2),
(15008, NULL, 'cd11548', NULL, NULL, 'NodZ_like', NULL, 'NodZ_like', NULL, NULL, NULL, 2),
(15009, NULL, 'cd14998', NULL, NULL, '7tmA_GPR153_GPR162-like', NULL, '7tmA_GPR153_GPR162-like', NULL, NULL, NULL, 2),
(15010, NULL, 'cd05736', NULL, NULL, 'Ig2_Follistatin_like', NULL, 'Ig2_Follistatin_like', NULL, NULL, NULL, 2),
(15011, NULL, 'cd09768', NULL, NULL, 'Luminal_EIF2AK3', NULL, 'Luminal_EIF2AK3', NULL, NULL, NULL, 2),
(15012, NULL, 'cd11809', NULL, NULL, 'SH3_srGAP', NULL, 'SH3_srGAP', NULL, NULL, NULL, 2),
(15013, NULL, 'cd18829', NULL, NULL, 'GH43_BsArb43A-like', NULL, 'GH43_BsArb43A-like', NULL, NULL, NULL, 2),
(15014, NULL, 'cd09942', NULL, NULL, 'SH2_nSH2_p85_like', NULL, 'SH2_nSH2_p85_like', NULL, NULL, 20839, 2);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(15015, NULL, 'cd00091', NULL, NULL, 'NUC', NULL, 'NUC', NULL, NULL, NULL, 2),
(15016, NULL, 'cd12964', NULL, NULL, 'CBM-Fa', NULL, 'CBM-Fa', NULL, NULL, NULL, 2),
(15017, NULL, 'cd11866', NULL, NULL, 'SH3_SKAP1-like', NULL, 'SH3_SKAP1-like', NULL, NULL, NULL, 2),
(15018, NULL, 'cd21663', NULL, NULL, 'ORF7a_SARS-CoV-like', NULL, 'ORF7a_SARS-CoV-like', NULL, NULL, NULL, 2),
(15019, NULL, 'cd04476', NULL, NULL, 'RPA1_DBD_C', NULL, 'RPA1_DBD_C', NULL, NULL, 7984, 2),
(15020, NULL, 'cd12609', NULL, NULL, 'RRM2_CoAA', NULL, 'RRM2_CoAA', NULL, NULL, 17204, 2),
(15021, NULL, 'cd15260', NULL, NULL, '7tmB1_NPR_B4_insect-like', NULL, '7tmB1_NPR_B4_insect-like', NULL, NULL, NULL, 2),
(15022, NULL, 'cd05048', NULL, NULL, 'PTKc_Ror', NULL, 'PTKc_Ror', NULL, NULL, NULL, 2),
(15023, NULL, 'cd10293', NULL, NULL, 'GST_C_Ure2p', NULL, 'GST_C_Ure2p', NULL, NULL, NULL, 2),
(15024, NULL, 'cd05113', NULL, NULL, 'PTKc_Btk_Bmx', NULL, 'PTKc_Btk_Bmx', NULL, NULL, NULL, 2),
(15025, NULL, 'cd18802', NULL, NULL, 'SF2_C_dicer', NULL, 'SF2_C_dicer', NULL, NULL, NULL, 2),
(15026, NULL, 'cd02341', NULL, NULL, 'ZZ_ZZZ3', NULL, 'ZZ_ZZZ3', NULL, NULL, 30926, 2),
(15027, NULL, 'cd18655', NULL, NULL, 'CSD_HP1alpha_Cbx5', NULL, 'CSD_HP1alpha_Cbx5', NULL, NULL, NULL, 2),
(15028, NULL, 'cd06167', NULL, NULL, 'PIN_LabA-like', NULL, 'PIN_LabA-like', NULL, NULL, NULL, 2),
(15029, NULL, 'cd12223', NULL, NULL, 'RRM_SR140', NULL, 'RRM_SR140', NULL, NULL, 19738, 2),
(15030, NULL, 'cd14571', NULL, NULL, 'DSP_slingshot_3', NULL, 'DSP_slingshot_3', NULL, NULL, NULL, 2),
(15031, NULL, 'cd04614', NULL, NULL, 'CBS_pair_arch2_repeat2', NULL, 'CBS_pair_arch2_repeat2', NULL, NULL, NULL, 2),
(15032, NULL, 'cd01461', NULL, NULL, 'vWA_interalpha_trypsin_inhibitor', NULL, 'vWA_interalpha_trypsin_inhibitor', NULL, NULL, NULL, 2),
(15033, NULL, 'cd19024', NULL, NULL, 'LGIC_ECD_nAChR_B1', NULL, 'LGIC_ECD_nAChR_B1', NULL, NULL, NULL, 2),
(15034, NULL, 'cd05714', NULL, NULL, 'Ig_CSPGs_LP', NULL, 'Ig_CSPGs_LP', NULL, NULL, NULL, 2),
(15035, NULL, 'cd08851', NULL, NULL, 'ArfGap_ACAP2', NULL, 'ArfGap_ACAP2', NULL, NULL, NULL, 2),
(15036, NULL, 'cd00209', NULL, NULL, 'DHFR', NULL, 'DHFR', NULL, NULL, 3084, 2),
(15037, NULL, 'cd09137', NULL, NULL, 'PLDc_PGS1_euk_2', NULL, 'PLDc_PGS1_euk_2', NULL, NULL, NULL, 2),
(15038, NULL, 'cd10023', NULL, NULL, '14-3-3_theta', NULL, '14-3-3_theta', NULL, NULL, 35606, 2),
(15039, NULL, 'cd11833', NULL, NULL, 'SH3_Stac_1', NULL, 'SH3_Stac_1', NULL, NULL, NULL, 2),
(15040, NULL, 'cd07074', NULL, NULL, 'NR_LBD_PR', NULL, 'NR_LBD_PR', NULL, NULL, NULL, 2),
(15041, NULL, 'cd10299', NULL, NULL, 'GST_C_CLIC3', NULL, 'GST_C_CLIC3', NULL, NULL, NULL, 2),
(15042, NULL, 'cd03061', NULL, NULL, 'GST_N_CLIC', NULL, 'GST_N_CLIC', NULL, NULL, NULL, 2),
(15043, NULL, 'cd21637', NULL, NULL, 'NS7_PDCoV', NULL, 'NS7_PDCoV', NULL, NULL, 36200, 2),
(15044, NULL, 'cd17993', NULL, NULL, 'DEXHc_CHD1_2', NULL, 'DEXHc_CHD1_2', NULL, NULL, NULL, 2),
(15045, NULL, 'cd01248', NULL, NULL, 'PH_PLC_ELMO1', NULL, 'PH_PLC_ELMO1', NULL, NULL, NULL, 2),
(15046, NULL, 'cd16956', NULL, NULL, 'HATPase_YehU-like', NULL, 'HATPase_YehU-like', NULL, NULL, NULL, 2),
(15047, NULL, 'cd17378', NULL, NULL, 'MFS_OCT_plant', NULL, 'MFS_OCT_plant', NULL, NULL, NULL, 2),
(15048, NULL, 'cd15451', NULL, NULL, '7tmC_mGluR7', NULL, '7tmC_mGluR7', NULL, NULL, NULL, 2),
(15049, NULL, 'cd14088', NULL, NULL, 'STKc_CaMK_like', NULL, 'STKc_CaMK_like', NULL, NULL, NULL, 2),
(15050, NULL, 'cd09601', NULL, NULL, 'M1_APN-Q_like', NULL, 'M1_APN-Q_like', NULL, NULL, 24468, 2),
(15051, NULL, 'cd19213', NULL, NULL, 'PR-SET_PRDM16', NULL, 'PR-SET_PRDM16', NULL, NULL, 34520, 2),
(15052, NULL, 'cd09161', NULL, NULL, 'PLDc_PaCLS_like_2', NULL, 'PLDc_PaCLS_like_2', NULL, NULL, NULL, 2),
(15053, NULL, 'cd17053', NULL, NULL, 'Ubl2_FAT10', NULL, 'Ubl2_FAT10', NULL, NULL, NULL, 2),
(15054, NULL, 'cd14151', NULL, NULL, 'STKc_B-Raf', NULL, 'STKc_B-Raf', NULL, NULL, NULL, 2),
(15055, NULL, 'cd07441', NULL, NULL, 'CRD_SFRP3', NULL, 'CRD_SFRP3', NULL, NULL, 31130, 2),
(15056, NULL, 'cd05062', NULL, NULL, 'PTKc_IGF-1R', NULL, 'PTKc_IGF-1R', NULL, NULL, NULL, 2);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(15057, NULL, 'cd07498', NULL, NULL, 'Peptidases_S8_15', NULL, 'Peptidases_S8_15', NULL, NULL, 2446, 2),
(15058, NULL, 'cd10546', NULL, NULL, 'VKOR', NULL, 'VKOR', NULL, NULL, NULL, 2),
(15059, NULL, 'cd01493', NULL, NULL, 'APPBP1_RUB', NULL, 'APPBP1_RUB', NULL, NULL, NULL, 2),
(15060, NULL, 'cd08562', NULL, NULL, 'GDPD_EcUgpQ_like', NULL, 'GDPD_EcUgpQ_like', NULL, NULL, NULL, 2),
(15061, NULL, 'cd13612', NULL, NULL, 'PBP2_ProWX', NULL, 'PBP2_ProWX', NULL, NULL, NULL, 2),
(15062, NULL, 'cd03430', NULL, NULL, 'GDPMH', NULL, 'GDPMH', NULL, NULL, 30079, 2),
(15063, NULL, 'cd09732', NULL, NULL, 'Csx1_III-U', NULL, 'Csx1_III-U', NULL, NULL, NULL, 2),
(15064, NULL, 'cd06204', NULL, NULL, 'CYPOR', NULL, 'CYPOR', NULL, NULL, NULL, 2),
(15065, NULL, 'cd11364', NULL, NULL, 'RNase_PH_PNPase_2', NULL, 'RNase_PH_PNPase_2', NULL, NULL, NULL, 2),
(15066, NULL, 'cd03269', NULL, NULL, 'ABC_putative_ATPase', NULL, 'ABC_putative_ATPase', NULL, NULL, NULL, 2),
(15067, NULL, 'cd04676', NULL, NULL, 'Nudix_Hydrolase_17', NULL, 'Nudix_Hydrolase_17', NULL, NULL, NULL, 2),
(15068, NULL, 'cd07001', NULL, NULL, 'cupin_YbfI-like_N', NULL, 'cupin_YbfI-like_N', NULL, NULL, NULL, 2),
(15069, NULL, 'cd09729', NULL, NULL, 'Cse1_I-E', NULL, 'Cse1_I-E', NULL, NULL, NULL, 2),
(15070, NULL, 'cd06648', NULL, NULL, 'STKc_PAK_II', NULL, 'STKc_PAK_II', NULL, NULL, NULL, 2),
(15071, NULL, 'cd03048', NULL, NULL, 'GST_N_Ure2p_like', NULL, 'GST_N_Ure2p_like', NULL, NULL, NULL, 2),
(15072, NULL, 'cd01289', NULL, NULL, 'FabA_like', NULL, 'FabA_like', NULL, NULL, 15423, 2),
(15073, NULL, 'cd09664', NULL, NULL, 'Cas6_I-E', NULL, 'Cas6_I-E', NULL, NULL, NULL, 2),
(15074, NULL, 'cd20285', NULL, NULL, 'cupin_7S_11S_C', NULL, 'cupin_7S_11S_C', NULL, NULL, NULL, 2),
(15075, NULL, 'cd01492', NULL, NULL, 'Aos1_SUMO', NULL, 'Aos1_SUMO', NULL, NULL, NULL, 2),
(15076, NULL, 'cd01568', NULL, NULL, 'QPRTase_NadC', NULL, 'QPRTase_NadC', NULL, NULL, NULL, 2),
(15077, NULL, 'cd10433', NULL, NULL, 'YccA_like', NULL, 'YccA_like', NULL, NULL, NULL, 2),
(15078, NULL, 'cd01937', NULL, NULL, 'ribokinase_group_D', NULL, 'ribokinase_group_D', NULL, NULL, 16398, 2),
(15079, NULL, 'cd12126', NULL, NULL, 'APC_beta', NULL, 'APC_beta', NULL, NULL, 3657, 2),
(15080, NULL, 'cd14163', NULL, NULL, 'STKc_TSSK3-like', NULL, 'STKc_TSSK3-like', NULL, NULL, 35699, 2),
(15081, NULL, 'cd17492', NULL, NULL, 'toxin_CptN', NULL, 'toxin_CptN', NULL, NULL, NULL, 2),
(15082, NULL, 'cd14880', NULL, NULL, 'MYSc_Myo19', NULL, 'MYSc_Myo19', NULL, NULL, 31980, 2),
(15083, NULL, 'cd06951', NULL, NULL, 'NR_LBD_Dax1_like', NULL, 'NR_LBD_Dax1_like', NULL, NULL, NULL, 2),
(15084, NULL, 'cd19005', NULL, NULL, 'LGIC_ECD_GABAAR_rho', NULL, 'LGIC_ECD_GABAAR_rho', NULL, NULL, NULL, 2),
(15085, NULL, 'cd06170', NULL, NULL, 'LuxR_C_like', NULL, 'LuxR_C_like', NULL, NULL, 6599, 2),
(15086, NULL, 'cd16171', NULL, NULL, 'ARSK', NULL, 'ARSK', NULL, NULL, NULL, 2),
(15087, NULL, 'cd09014', NULL, NULL, 'BphC-JF8_C_like', NULL, 'BphC-JF8_C_like', NULL, NULL, NULL, 2),
(15088, NULL, 'cd09317', NULL, NULL, 'TDT_Mae1_like', NULL, 'TDT_Mae1_like', NULL, NULL, 23887, 2),
(15089, NULL, 'cd14197', NULL, NULL, 'STKc_DRAK1', NULL, 'STKc_DRAK1', NULL, NULL, 35626, 2),
(15090, NULL, 'cd18190', NULL, NULL, 'BTB_POZ_ETO1-like', NULL, 'BTB_POZ_ETO1-like', NULL, NULL, NULL, 2),
(15091, NULL, 'cd15281', NULL, NULL, '7tmC_GPRC6A', NULL, '7tmC_GPRC6A', NULL, NULL, NULL, 2),
(15092, NULL, 'cd16255', NULL, NULL, 'EFh_parvalbumin_beta', NULL, 'EFh_parvalbumin_beta', NULL, NULL, NULL, 2),
(15093, NULL, 'cd13873', NULL, NULL, 'CuRO_2_AAO_like_2', NULL, 'CuRO_2_AAO_like_2', NULL, NULL, NULL, 2),
(15094, NULL, 'cd05262', NULL, NULL, 'SDR_a7', NULL, 'SDR_a7', NULL, NULL, NULL, 2),
(15095, NULL, 'cd16618', NULL, NULL, 'mRING-HC-C4C4_CNOT4', NULL, 'mRING-HC-C4C4_CNOT4', NULL, NULL, 33673, 2),
(15096, NULL, 'cd05570', NULL, NULL, 'STKc_PKC', NULL, 'STKc_PKC', NULL, NULL, NULL, 2),
(15097, NULL, 'cd15431', NULL, NULL, '7tmA_OR13H-like', NULL, '7tmA_OR13H-like', NULL, NULL, NULL, 2),
(15098, NULL, 'cd14311', NULL, NULL, 'UBA_II_E2_UBC1', NULL, 'UBA_II_E2_UBC1', NULL, NULL, NULL, 2);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(15099, NULL, 'cd14951', NULL, NULL, 'NHL-2_like', NULL, 'NHL-2_like', NULL, NULL, 37104, 2),
(15100, NULL, 'cd03866', NULL, NULL, 'M14_CPM', NULL, 'M14_CPM', NULL, NULL, 31979, 2),
(15101, NULL, 'cd06254', NULL, NULL, 'M14_ASTE_ASPA-like', NULL, 'M14_ASTE_ASPA-like', NULL, NULL, NULL, 2),
(15102, NULL, 'cd13195', NULL, NULL, 'FERM_C_MYLIP_IDOL', NULL, 'FERM_C_MYLIP_IDOL', NULL, NULL, 30027, 2),
(15103, NULL, 'cd05052', NULL, NULL, 'PTKc_Abl', NULL, 'PTKc_Abl', NULL, NULL, NULL, 2),
(15104, NULL, 'cd01746', NULL, NULL, 'GATase1_CTP_Synthase', NULL, 'GATase1_CTP_Synthase', NULL, NULL, 30388, 2),
(15105, NULL, 'cd08370', NULL, NULL, 'FMT_C_like', NULL, 'FMT_C_like', NULL, NULL, NULL, 2),
(15106, NULL, 'cd07276', NULL, NULL, 'PX_SNX16', NULL, 'PX_SNX16', NULL, NULL, 31071, 2),
(15107, NULL, 'cd01562', NULL, NULL, 'Thr-dehyd', NULL, 'Thr-dehyd', NULL, NULL, NULL, 2),
(15108, NULL, 'cd00751', NULL, NULL, 'thiolase', NULL, 'thiolase', NULL, NULL, 217, 2),
(15109, NULL, 'cd07029', NULL, NULL, 'RNAP_I_III_AC19', NULL, 'RNAP_I_III_AC19', NULL, NULL, 30466, 2),
(15110, NULL, 'cd10919', NULL, NULL, 'CE4_CDA_like', NULL, 'CE4_CDA_like', NULL, NULL, NULL, 2),
(15111, NULL, 'cd17362', NULL, NULL, 'MFS_GLUT10_12_Class3_like', NULL, 'MFS_GLUT10_12_Class3_like', NULL, NULL, NULL, 2),
(15112, NULL, 'cd17999', NULL, NULL, 'DEXHc_Mot1', NULL, 'DEXHc_Mot1', NULL, NULL, 34838, 2),
(15113, NULL, 'cd19003', NULL, NULL, 'LGIC_ECD_GABAAR_theta', NULL, 'LGIC_ECD_GABAAR_theta', NULL, NULL, NULL, 2),
(15114, NULL, 'cd00136', NULL, NULL, 'PDZ', NULL, 'PDZ', NULL, NULL, NULL, 2),
(15115, NULL, 'cd13603', NULL, NULL, 'PBP2_TRAP_Siap_TeaA_like', NULL, 'PBP2_TRAP_Siap_TeaA_like', NULL, NULL, NULL, 2),
(15116, NULL, 'cd05695', NULL, NULL, 'S1_Rrp5_repeat_hs3', NULL, 'S1_Rrp5_repeat_hs3', NULL, NULL, NULL, 2),
(15117, NULL, 'cd14338', NULL, NULL, 'UBA_SIK', NULL, 'UBA_SIK', NULL, NULL, NULL, 2),
(15118, NULL, 'cd15656', NULL, NULL, 'PHD4_NSD1', NULL, 'PHD4_NSD1', NULL, NULL, NULL, 2),
(15119, NULL, 'cd09184', NULL, NULL, 'PLDc_FAM83D_N', NULL, 'PLDc_FAM83D_N', NULL, NULL, NULL, 2),
(15120, NULL, 'cd15408', NULL, NULL, '7tmA_OR5AK3-like', NULL, '7tmA_OR5AK3-like', NULL, NULL, NULL, 2),
(15121, NULL, 'sd00033', NULL, NULL, 'LRR_RI', NULL, 'LRR_RI', NULL, NULL, NULL, 2),
(15122, NULL, 'cd03869', NULL, NULL, 'M14_CPX_like', NULL, 'M14_CPX_like', NULL, NULL, NULL, 2),
(15123, NULL, 'cd16280', NULL, NULL, 'metallo-hydrolase-like_MBL-fold', NULL, 'metallo-hydrolase-like_MBL-fold', NULL, NULL, NULL, 2),
(15124, NULL, 'cd13838', NULL, NULL, 'RNase_H_like_Prp8_IV', NULL, 'RNase_H_like_Prp8_IV', NULL, NULL, 20495, 2),
(15125, NULL, 'cd12751', NULL, NULL, 'RRM5_RBM12', NULL, 'RRM5_RBM12', NULL, NULL, 8662, 2),
(15126, NULL, 'cd15945', NULL, NULL, '7tmA_OR5C1-like', NULL, '7tmA_OR5C1-like', NULL, NULL, NULL, 2),
(15127, NULL, 'cd04130', NULL, NULL, 'Wrch_1', NULL, 'Wrch_1', NULL, NULL, NULL, 2),
(15128, NULL, 'cd06195', NULL, NULL, 'FNR1', NULL, 'FNR1', NULL, NULL, 31882, 2),
(15129, NULL, 'cd10308', NULL, NULL, 'GST_C_eEF1b_like', NULL, 'GST_C_eEF1b_like', NULL, NULL, NULL, 2),
(15130, NULL, 'cd02213', NULL, NULL, 'cupin_PMI_typeII_C', NULL, 'cupin_PMI_typeII_C', NULL, NULL, NULL, 2),
(15131, NULL, 'cd17500', NULL, NULL, 'RMtype1_S_MmaGORF2198P_TRD1-CR1_like', NULL, 'RMtype1_S_MmaGORF2198P_TRD1-CR1_like', NULL, NULL, NULL, 2),
(15132, NULL, 'cd13564', NULL, NULL, 'PBP2_ThiY_THI5_like', NULL, 'PBP2_ThiY_THI5_like', NULL, NULL, NULL, 2),
(15133, NULL, 'cd09702', NULL, NULL, 'Csx1_III-U', NULL, 'Csx1_III-U', NULL, NULL, NULL, 2),
(15134, NULL, 'cd05477', NULL, NULL, 'gastricsin', NULL, 'gastricsin', NULL, NULL, NULL, 2),
(15135, NULL, 'cd17114', NULL, NULL, 'RA_PLC-epsilon', NULL, 'RA_PLC-epsilon', NULL, NULL, NULL, 2),
(15136, NULL, 'cd06883', NULL, NULL, 'PX_PI3K_C2', NULL, 'PX_PI3K_C2', NULL, NULL, NULL, 2),
(15137, NULL, 'cd18622', NULL, NULL, 'GH32_Inu-like', NULL, 'GH32_Inu-like', NULL, NULL, NULL, 2),
(15138, NULL, 'cd19802', NULL, NULL, 'Bbox1_TRIM8-like', NULL, 'Bbox1_TRIM8-like', NULL, NULL, NULL, 2),
(15139, NULL, 'cd08666', NULL, NULL, 'APC10-HECTD3', NULL, 'APC10-HECTD3', NULL, NULL, NULL, 2);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(15140, NULL, 'cd14506', NULL, NULL, 'PTP_PTPDC1', NULL, 'PTP_PTPDC1', NULL, NULL, NULL, 2),
(15141, NULL, 'cd16635', NULL, NULL, 'mRING-HC-C3HC3D_PHRF1', NULL, 'mRING-HC-C3HC3D_PHRF1', NULL, NULL, NULL, 2),
(15142, NULL, 'cd05137', NULL, NULL, 'RasGAP_CLA2_BUD2', NULL, 'RasGAP_CLA2_BUD2', NULL, NULL, NULL, 2),
(15143, NULL, 'cd05705', NULL, NULL, 'S1_Rrp5_repeat_hs14', NULL, 'S1_Rrp5_repeat_hs14', NULL, NULL, NULL, 2),
(15144, NULL, 'cd18623', NULL, NULL, 'GH32_ScrB-like', NULL, 'GH32_ScrB-like', NULL, NULL, NULL, 2),
(15145, NULL, 'cd02900', NULL, NULL, 'Macro_Appr_pase', NULL, 'Macro_Appr_pase', NULL, NULL, NULL, 2),
(15146, NULL, 'cd06632', NULL, NULL, 'STKc_MEKK1_plant', NULL, 'STKc_MEKK1_plant', NULL, NULL, NULL, 2),
(15147, NULL, 'cd07497', NULL, NULL, 'Peptidases_S8_14', NULL, 'Peptidases_S8_14', NULL, NULL, 24401, 2),
(15148, NULL, 'cd09022', NULL, NULL, 'Aldose_epim_Ec_YihR', NULL, 'Aldose_epim_Ec_YihR', NULL, NULL, 28715, 2),
(15149, NULL, 'cd18414', NULL, NULL, 'BTB_KCNC1_3', NULL, 'BTB_KCNC1_3', NULL, NULL, NULL, 2),
(15150, NULL, 'cd18079', NULL, NULL, 'S-AdoMet_synt', NULL, 'S-AdoMet_synt', NULL, NULL, NULL, 2),
(15151, NULL, 'cd03248', NULL, NULL, 'ABCC_TAP', NULL, 'ABCC_TAP', NULL, NULL, NULL, 2),
(15152, NULL, 'cd15665', NULL, NULL, 'ePHD1_KMT2C_like', NULL, 'ePHD1_KMT2C_like', NULL, NULL, NULL, 2),
(15153, NULL, 'cd15760', NULL, NULL, 'FYVE_scVPS27p_like', NULL, 'FYVE_scVPS27p_like', NULL, NULL, NULL, 2),
(15154, NULL, 'cd08801', NULL, NULL, 'Death_UNC5D', NULL, 'Death_UNC5D', NULL, NULL, 31011, 2),
(15155, NULL, 'cd13298', NULL, NULL, 'PH1_PH_fungal', NULL, 'PH1_PH_fungal', NULL, NULL, NULL, 2),
(15156, NULL, 'cd15961', NULL, NULL, '7tmA_GPR12', NULL, '7tmA_GPR12', NULL, NULL, NULL, 2),
(15157, NULL, 'cd12926', NULL, NULL, 'iSH2_PIK3R2', NULL, 'iSH2_PIK3R2', NULL, NULL, NULL, 2),
(15158, NULL, 'cd13728', NULL, NULL, 'PBP2_iGluR_AMPA_GluR3', NULL, 'PBP2_iGluR_AMPA_GluR3', NULL, NULL, NULL, 2),
(15159, NULL, 'cd05276', NULL, NULL, 'p53_inducible_oxidoreductase', NULL, 'p53_inducible_oxidoreductase', NULL, NULL, 8618, 2),
(15160, NULL, 'cd04842', NULL, NULL, 'Peptidases_S8_Kp43_protease', NULL, 'Peptidases_S8_Kp43_protease', NULL, NULL, 8388, 2),
(15161, NULL, 'cd12039', NULL, NULL, 'SH3_MPP3', NULL, 'SH3_MPP3', NULL, NULL, 28346, 2),
(15162, NULL, 'cd01831', NULL, NULL, 'Endoglucanase_E_like', NULL, 'Endoglucanase_E_like', NULL, NULL, 32636, 2),
(15163, NULL, 'cd01991', NULL, NULL, 'Asn_Synthase_B_C', NULL, 'Asn_Synthase_B_C', NULL, NULL, 2281, 2),
(15164, NULL, 'cd09218', NULL, NULL, 'TLP-PA', NULL, 'TLP-PA', NULL, NULL, NULL, 2),
(15165, NULL, 'cd00283', NULL, NULL, 'GIY-YIG_Cterm', NULL, 'GIY-YIG_Cterm', NULL, NULL, NULL, 2),
(15166, NULL, 'cd10950', NULL, NULL, 'CE4_BsYlxY_like', NULL, 'CE4_BsYlxY_like', NULL, NULL, NULL, 2),
(15167, NULL, 'cd13433', NULL, NULL, 'Na_channel_gate', NULL, 'Na_channel_gate', NULL, NULL, 34931, 2),
(15168, NULL, 'cd00110', NULL, NULL, 'LamG', NULL, 'LamG', NULL, NULL, 3322, 2),
(15169, NULL, 'cd11409', NULL, NULL, 'bHLH-O_DEC', NULL, 'bHLH-O_DEC', NULL, NULL, NULL, 2),
(15170, NULL, 'cd08470', NULL, NULL, 'PBP2_CrgA_like_1', NULL, 'PBP2_CrgA_like_1', NULL, NULL, NULL, 2),
(15171, NULL, 'cd16640', NULL, NULL, 'RING-HC_TRAF3', NULL, 'RING-HC_TRAF3', NULL, NULL, NULL, 2),
(15172, NULL, 'cd09157', NULL, NULL, 'PLDc_CLS_unchar2_1', NULL, 'PLDc_CLS_unchar2_1', NULL, NULL, NULL, 2),
(15173, NULL, 'cd06905', NULL, NULL, 'M14-like', NULL, 'M14-like', NULL, NULL, NULL, 2),
(15174, NULL, 'cd15438', NULL, NULL, '7tmB2_CD97', NULL, '7tmB2_CD97', NULL, NULL, NULL, 2),
(15175, NULL, 'cd16570', NULL, NULL, 'RING-HC_SH3RFs', NULL, 'RING-HC_SH3RFs', NULL, NULL, NULL, 2),
(15176, NULL, 'cd07659', NULL, NULL, 'BAR_PICK1', NULL, 'BAR_PICK1', NULL, NULL, 28374, 2),
(15177, NULL, 'cd12870', NULL, NULL, 'MqsA', NULL, 'MqsA', NULL, NULL, NULL, 2),
(15178, NULL, 'cd12227', NULL, NULL, 'RRM_SCAF4_SCAF8', NULL, 'RRM_SCAF4_SCAF8', NULL, NULL, NULL, 2),
(15179, NULL, 'cd05290', NULL, NULL, 'LDH_3', NULL, 'LDH_3', NULL, NULL, NULL, 2),
(15180, NULL, 'cd18729', NULL, NULL, 'PIN_Zc3h12-like', NULL, 'PIN_Zc3h12-like', NULL, NULL, NULL, 2);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(15181, NULL, 'cd03235', NULL, NULL, 'ABC_Metallic_Cations', NULL, 'ABC_Metallic_Cations', NULL, NULL, NULL, 2),
(15182, NULL, 'cd13170', NULL, NULL, 'RanBD_NUP50', NULL, 'RanBD_NUP50', NULL, NULL, NULL, 2),
(15183, NULL, 'cd16766', NULL, NULL, 'RING-HC_TIF1gamma', NULL, 'RING-HC_TIF1gamma', NULL, NULL, NULL, 2),
(15184, NULL, 'cd11580', NULL, NULL, 'eIF2D_N_like', NULL, 'eIF2D_N_like', NULL, NULL, NULL, 2),
(15185, NULL, 'cd11779', NULL, NULL, 'SH3_Irsp53_BAIAP2L', NULL, 'SH3_Irsp53_BAIAP2L', NULL, NULL, NULL, 2),
(15186, NULL, 'cd00560', NULL, NULL, 'PanC', NULL, 'PanC', NULL, NULL, 2187, 2),
(15187, NULL, 'cd10369', NULL, NULL, 'SH2_Src_Frk', NULL, 'SH2_Src_Frk', NULL, NULL, 27595, 2),
(15188, NULL, 'cd19361', NULL, NULL, 'TenA_C_HP1287-like', NULL, 'TenA_C_HP1287-like', NULL, NULL, NULL, 2),
(15189, NULL, 'cd10412', NULL, NULL, 'SH2_SH2B3', NULL, 'SH2_SH2B3', NULL, NULL, 17455, 2),
(15190, NULL, 'cd09992', NULL, NULL, 'HDAC_classII', NULL, 'HDAC_classII', NULL, NULL, NULL, 2),
(15191, NULL, 'cd12237', NULL, NULL, 'RRM_snRNP35', NULL, 'RRM_snRNP35', NULL, NULL, 10213, 2),
(15192, NULL, 'cd08978', NULL, NULL, 'GH_F', NULL, 'GH_F', NULL, NULL, NULL, 2),
(15193, NULL, 'cd07766', NULL, NULL, 'DHQ_Fe-ADH', NULL, 'DHQ_Fe-ADH', NULL, NULL, NULL, 2),
(15194, NULL, 'cd17639', NULL, NULL, 'LC_FACS_euk1', NULL, 'LC_FACS_euk1', NULL, NULL, NULL, 2),
(15195, NULL, 'cd15726', NULL, NULL, 'FYVE_FYCO1', NULL, 'FYVE_FYCO1', NULL, NULL, NULL, 2),
(15196, NULL, 'cd21570', NULL, NULL, 'batCoV_HKU9-like_M', NULL, 'batCoV_HKU9-like_M', NULL, NULL, 35747, 2),
(15197, NULL, 'cd04175', NULL, NULL, 'Rap1', NULL, 'Rap1', NULL, NULL, 30595, 2),
(15198, NULL, 'cd06946', NULL, NULL, 'NR_LBD_ERR', NULL, 'NR_LBD_ERR', NULL, NULL, NULL, 2),
(15199, NULL, 'cd04657', NULL, NULL, 'Piwi_ago-like', NULL, 'Piwi_ago-like', NULL, NULL, 34191, 2),
(15200, NULL, 'cd14573', NULL, NULL, 'DUSP18_21', NULL, 'DUSP18_21', NULL, NULL, NULL, 2),
(15201, NULL, 'cd07643', NULL, NULL, 'I-BAR_IMD_MIM', NULL, 'I-BAR_IMD_MIM', NULL, NULL, NULL, 2),
(15202, NULL, 'cd17873', NULL, NULL, 'FlhF', NULL, 'FlhF', NULL, NULL, NULL, 2),
(15203, NULL, 'cd10570', NULL, NULL, 'PH-GRAM', NULL, 'PH-GRAM', NULL, NULL, NULL, 2),
(15204, NULL, 'cd15056', NULL, NULL, '7tmA_5-HT4', NULL, '7tmA_5-HT4', NULL, NULL, NULL, 2),
(15205, NULL, 'cd17646', NULL, NULL, 'A_NRPS_AB3403-like', NULL, 'A_NRPS_AB3403-like', NULL, NULL, NULL, 2),
(15206, NULL, 'cd07575', NULL, NULL, 'Xc-1258_like', NULL, 'Xc-1258_like', NULL, NULL, NULL, 2),
(15207, NULL, 'cd09181', NULL, NULL, 'PLDc_FAM83A_N', NULL, 'PLDc_FAM83A_N', NULL, NULL, NULL, 2),
(15208, NULL, 'cd02205', NULL, NULL, 'CBS_pair_SF', NULL, 'CBS_pair_SF', NULL, NULL, NULL, 2),
(15209, NULL, 'cd08505', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_18', NULL, 'PBP2_NikA_DppA_OppA_like_18', NULL, NULL, NULL, 2),
(15210, NULL, 'cd18077', NULL, NULL, 'DEXXQc_HELZ', NULL, 'DEXXQc_HELZ', NULL, NULL, NULL, 2),
(15211, NULL, 'cd19156', NULL, NULL, 'AKR_AKR5A1_2', NULL, 'AKR_AKR5A1_2', NULL, NULL, 35420, 2),
(15212, NULL, 'cd15888', NULL, NULL, 'SNARE_SNAP47N', NULL, 'SNARE_SNAP47N', NULL, NULL, NULL, 2),
(15213, NULL, 'cd08469', NULL, NULL, 'PBP2_PnbR', NULL, 'PBP2_PnbR', NULL, NULL, NULL, 2),
(15214, NULL, 'cd12247', NULL, NULL, 'RRM2_U1A_like', NULL, 'RRM2_U1A_like', NULL, NULL, NULL, 2),
(15215, NULL, 'cd09191', NULL, NULL, 'PLDc_DNaseII_alpha_2', NULL, 'PLDc_DNaseII_alpha_2', NULL, NULL, NULL, 2),
(15216, NULL, 'cd17935', NULL, NULL, 'EEXXQc_AQR', NULL, 'EEXXQc_AQR', NULL, NULL, NULL, 2),
(15217, NULL, 'cd16488', NULL, NULL, 'mRING-H2-C3H3C2_Mio_like', NULL, 'mRING-H2-C3H3C2_Mio_like', NULL, NULL, NULL, 2),
(15218, NULL, 'cd10464', NULL, NULL, 'PUB_RNF31', NULL, 'PUB_RNF31', NULL, NULL, NULL, 2),
(15219, NULL, 'cd18947', NULL, NULL, 'bHLH-PAS_ARNT', NULL, 'bHLH-PAS_ARNT', NULL, NULL, NULL, 2),
(15220, NULL, 'cd08040', NULL, NULL, 'OBF_DNA_ligase_family', NULL, 'OBF_DNA_ligase_family', NULL, NULL, NULL, 2),
(15221, NULL, 'cd11834', NULL, NULL, 'SH3_Stac_2', NULL, 'SH3_Stac_2', NULL, NULL, NULL, 2),
(15222, NULL, 'cd06539', NULL, NULL, 'CIDE_N_A', NULL, 'CIDE_N_A', NULL, NULL, NULL, 2);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(15223, NULL, 'cd00389', NULL, NULL, 'microbial_RNases', NULL, 'microbial_RNases', NULL, NULL, NULL, 2),
(15224, NULL, 'cd12389', NULL, NULL, 'RRM2_RAVER', NULL, 'RRM2_RAVER', NULL, NULL, NULL, 2),
(15225, NULL, 'cd14370', NULL, NULL, 'CUE_DMA', NULL, 'CUE_DMA', NULL, NULL, NULL, 2),
(15226, NULL, 'cd14764', NULL, NULL, 'SSDgbs_2', NULL, 'SSDgbs_2', NULL, NULL, NULL, 2),
(15227, NULL, 'cd02691', NULL, NULL, 'PurM-like2', NULL, 'PurM-like2', NULL, NULL, 9904, 2),
(15228, NULL, 'cd18424', NULL, NULL, 'BTB_POZ_KCNV1', NULL, 'BTB_POZ_KCNV1', NULL, NULL, NULL, 2),
(15229, NULL, 'cd13916', NULL, NULL, 'CuRO_HCO_II_like_1', NULL, 'CuRO_HCO_II_like_1', NULL, NULL, NULL, 2),
(15230, NULL, 'cd09182', NULL, NULL, 'PLDc_FAM83B_N', NULL, 'PLDc_FAM83B_N', NULL, NULL, NULL, 2),
(15231, NULL, 'cd08498', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_2', NULL, 'PBP2_NikA_DppA_OppA_like_2', NULL, NULL, NULL, 2),
(15232, NULL, 'cd17535', NULL, NULL, 'REC_NarL-like', NULL, 'REC_NarL-like', NULL, NULL, NULL, 2),
(15233, NULL, 'cd15653', NULL, NULL, 'PHD3_NSD1', NULL, 'PHD3_NSD1', NULL, NULL, NULL, 2),
(15234, NULL, 'cd08877', NULL, NULL, 'START_2', NULL, 'START_2', NULL, NULL, NULL, 2),
(15235, NULL, 'cd01928', NULL, NULL, 'Cyclophilin_PPIL3_like', NULL, 'Cyclophilin_PPIL3_like', NULL, NULL, NULL, 2),
(15236, NULL, 'cd09937', NULL, NULL, 'SH2_csk_like', NULL, 'SH2_csk_like', NULL, NULL, 13993, 2),
(15237, NULL, 'cd00875', NULL, NULL, 'RNA_Cyclase_Class_I', NULL, 'RNA_Cyclase_Class_I', NULL, NULL, 15415, 2),
(15238, NULL, 'cd09673', NULL, NULL, 'Cas3_Cas2_I-F', NULL, 'Cas3_Cas2_I-F', NULL, NULL, NULL, 2),
(15239, NULL, 'cd15395', NULL, NULL, '7tmA_NPY1R', NULL, '7tmA_NPY1R', NULL, NULL, NULL, 2),
(15240, NULL, 'cd18952', NULL, NULL, 'bHLH_TS_HAND1', NULL, 'bHLH_TS_HAND1', NULL, NULL, NULL, 2),
(15241, NULL, 'cd18360', NULL, NULL, 'BTB2_POZ_RHOBTB3', NULL, 'BTB2_POZ_RHOBTB3', NULL, NULL, NULL, 2),
(15242, NULL, 'cd17978', NULL, NULL, 'DEXHc_DHX33', NULL, 'DEXHc_DHX33', NULL, NULL, NULL, 2),
(15243, NULL, 'cd08656', NULL, NULL, 'M28_like', NULL, 'M28_like', NULL, NULL, NULL, 2),
(15244, NULL, 'cd13349', NULL, NULL, 'PH-GRAM1_TBC1D8', NULL, 'PH-GRAM1_TBC1D8', NULL, NULL, 28025, 2),
(15245, NULL, 'cd16089', NULL, NULL, 'IgV_CRIg', NULL, 'IgV_CRIg', NULL, NULL, 28650, 2),
(15246, NULL, 'cd13840', NULL, NULL, 'SMBP_like', NULL, 'SMBP_like', NULL, NULL, 26829, 2),
(15247, NULL, 'cd14125', NULL, NULL, 'STKc_CK1_delta_epsilon', NULL, 'STKc_CK1_delta_epsilon', NULL, NULL, NULL, 2),
(15248, NULL, 'cd18226', NULL, NULL, 'BTB_POZ_ZBTB41', NULL, 'BTB_POZ_ZBTB41', NULL, NULL, NULL, 2),
(15249, NULL, 'cd14381', NULL, NULL, 'UBA2_Rhp23p_like', NULL, 'UBA2_Rhp23p_like', NULL, NULL, NULL, 2),
(15250, NULL, 'cd00281', NULL, NULL, 'DAP_dppA', NULL, 'DAP_dppA', NULL, NULL, 31599, 2),
(15251, NULL, 'cd04790', NULL, NULL, 'HTH_Cfa-like_unk', NULL, 'HTH_Cfa-like_unk', NULL, NULL, NULL, 2),
(15252, NULL, 'cd12274', NULL, NULL, 'RRM2_NEFsp', NULL, 'RRM2_NEFsp', NULL, NULL, NULL, 2),
(15253, NULL, 'cd03760', NULL, NULL, 'proteasome_beta_type_4', NULL, 'proteasome_beta_type_4', NULL, NULL, 19987, 2),
(15254, NULL, 'cd17116', NULL, NULL, 'RA_Radil_like', NULL, 'RA_Radil_like', NULL, NULL, NULL, 2),
(15255, NULL, 'cd01764', NULL, NULL, 'Ubl_Urm1', NULL, 'Ubl_Urm1', NULL, NULL, 10531, 2),
(15256, NULL, 'cd06575', NULL, NULL, 'PASTA_Pbp2x-like_2', NULL, 'PASTA_Pbp2x-like_2', NULL, NULL, NULL, 2),
(15257, NULL, 'cd16142', NULL, NULL, 'ARS_like', NULL, 'ARS_like', NULL, NULL, NULL, 2),
(15258, NULL, 'cd13697', NULL, NULL, 'PBP2_ArtJ_like', NULL, 'PBP2_ArtJ_like', NULL, NULL, NULL, 2),
(15259, NULL, 'cd17165', NULL, NULL, 'RAWUL_PCGF4', NULL, 'RAWUL_PCGF4', NULL, NULL, NULL, 2),
(15260, NULL, 'cd07485', NULL, NULL, 'Peptidases_S8_Fervidolysin_like', NULL, 'Peptidases_S8_Fervidolysin_like', NULL, NULL, 27952, 2),
(15261, NULL, 'cd02169', NULL, NULL, 'Citrate_lyase_ligase', NULL, 'Citrate_lyase_ligase', NULL, NULL, 10820, 2),
(15262, NULL, 'cd06290', NULL, NULL, 'PBP1_LacI-like', NULL, 'PBP1_LacI-like', NULL, NULL, NULL, 2),
(15263, NULL, 'cd19715', NULL, NULL, 'bHLH_TS_amos_like', NULL, 'bHLH_TS_amos_like', NULL, NULL, NULL, 2);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(15264, NULL, 'cd18586', NULL, NULL, 'ABC_6TM_PrtD_like', NULL, 'ABC_6TM_PrtD_like', NULL, NULL, NULL, 2),
(15265, NULL, 'cd09418', NULL, NULL, 'LIM2_Prickle', NULL, 'LIM2_Prickle', NULL, NULL, 32851, 2),
(15266, NULL, 'cd19043', NULL, NULL, 'LGIC_ECD_GABAAR_G1', NULL, 'LGIC_ECD_GABAAR_G1', NULL, NULL, NULL, 2),
(15267, NULL, 'cd06981', NULL, NULL, 'cupin_reut_a1446', NULL, 'cupin_reut_a1446', NULL, NULL, NULL, 2),
(15268, NULL, 'cd07578', NULL, NULL, 'nitrilase_1_R1', NULL, 'nitrilase_1_R1', NULL, NULL, NULL, 2),
(15269, NULL, 'cd10946', NULL, NULL, 'CE4_Mll8295_like', NULL, 'CE4_Mll8295_like', NULL, NULL, NULL, 2),
(15270, NULL, 'cd07051', NULL, NULL, 'BMC_like_1_repeat1', NULL, 'BMC_like_1_repeat1', NULL, NULL, NULL, 2),
(15271, NULL, 'cd19091', NULL, NULL, 'AKR_PsAKR', NULL, 'AKR_PsAKR', NULL, NULL, NULL, 2),
(15272, NULL, 'cd04785', NULL, NULL, 'HTH_CadR-PbrR-like', NULL, 'HTH_CadR-PbrR-like', NULL, NULL, NULL, 2),
(15273, NULL, 'cd13635', NULL, NULL, 'PBP2_Ttha1568_Mqnd', NULL, 'PBP2_Ttha1568_Mqnd', NULL, NULL, NULL, 2),
(15274, NULL, 'cd02682', NULL, NULL, 'MIT_AAA_Arch', NULL, 'MIT_AAA_Arch', NULL, NULL, NULL, 2),
(15275, NULL, 'cd19380', NULL, NULL, 'TGF_beta_GDNF', NULL, 'TGF_beta_GDNF', NULL, NULL, NULL, 2),
(15276, NULL, 'cd05912', NULL, NULL, 'OSB_CoA_lg', NULL, 'OSB_CoA_lg', NULL, NULL, NULL, 2),
(15277, NULL, 'cd18014', NULL, NULL, 'DEXHc_RecQ5', NULL, 'DEXHc_RecQ5', NULL, NULL, NULL, 2),
(15278, NULL, 'cd12429', NULL, NULL, 'RRM_DNAJC17', NULL, 'RRM_DNAJC17', NULL, NULL, 31755, 2),
(15279, NULL, 'cd05153', NULL, NULL, 'HomoserineK_II', NULL, 'HomoserineK_II', NULL, NULL, 4258, 2),
(15280, NULL, 'cd12481', NULL, NULL, 'RRM2_U2B', NULL, 'RRM2_U2B', NULL, NULL, 3881, 2),
(15281, NULL, 'cd02973', NULL, NULL, 'TRX_GRX_like', NULL, 'TRX_GRX_like', NULL, NULL, NULL, 2),
(15282, NULL, 'cd19394', NULL, NULL, 'TGF_beta_GDF10', NULL, 'TGF_beta_GDF10', NULL, NULL, NULL, 2),
(15283, NULL, 'cd05696', NULL, NULL, 'S1_Rrp5_repeat_hs4', NULL, 'S1_Rrp5_repeat_hs4', NULL, NULL, NULL, 2),
(15284, NULL, 'cd05581', NULL, NULL, 'STKc_PDK1', NULL, 'STKc_PDK1', NULL, NULL, 32690, 2),
(15285, NULL, 'cd11861', NULL, NULL, 'SH3_DLG-like', NULL, 'SH3_DLG-like', NULL, NULL, NULL, 2),
(15286, NULL, 'cd11749', NULL, NULL, 'GH94N_LBP_like', NULL, 'GH94N_LBP_like', NULL, NULL, NULL, 2),
(15287, NULL, 'cd15769', NULL, NULL, 'FYVE_CARP1', NULL, 'FYVE_CARP1', NULL, NULL, NULL, 2),
(15288, NULL, 'cd17158', NULL, NULL, 'DCX3_DCDC5', NULL, 'DCX3_DCDC5', NULL, NULL, NULL, 2),
(15289, NULL, 'cd18751', NULL, NULL, 'PIN_VapC4-5_FitB-like', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, NULL, 2),
(15290, NULL, 'cd10281', NULL, NULL, 'Nape_like_AP-endo', NULL, 'Nape_like_AP-endo', NULL, NULL, NULL, 2),
(15291, NULL, 'cd09156', NULL, NULL, 'PLDc_CLS_unchar1_1', NULL, 'PLDc_CLS_unchar1_1', NULL, NULL, NULL, 2),
(15292, NULL, 'cd04371', NULL, NULL, 'DEP', NULL, 'DEP', NULL, NULL, NULL, 2),
(15293, NULL, 'cd14227', NULL, NULL, 'STKc_HIPK2', NULL, 'STKc_HIPK2', NULL, NULL, NULL, 2),
(15294, NULL, 'cd06642', NULL, NULL, 'STKc_STK25', NULL, 'STKc_STK25', NULL, NULL, 16150, 2),
(15295, NULL, 'cd09334', NULL, NULL, 'LIM4_PINCH', NULL, 'LIM4_PINCH', NULL, NULL, NULL, 2),
(15296, NULL, 'cd08596', NULL, NULL, 'PI-PLCc_epsilon', NULL, 'PI-PLCc_epsilon', NULL, NULL, NULL, 2),
(15297, NULL, 'cd14144', NULL, NULL, 'STKc_BMPR1', NULL, 'STKc_BMPR1', NULL, NULL, NULL, 2),
(15298, NULL, 'cd14494', NULL, NULL, 'PTP_DSP_cys', NULL, 'PTP_DSP_cys', NULL, NULL, NULL, 2),
(15299, NULL, 'cd11837', NULL, NULL, 'SH3_Intersectin_2', NULL, 'SH3_Intersectin_2', NULL, NULL, NULL, 2),
(15300, NULL, 'cd08830', NULL, NULL, 'ArfGap_ArfGap1', NULL, 'ArfGap_ArfGap1', NULL, NULL, NULL, 2),
(15301, NULL, 'cd01233', NULL, NULL, 'PH_KIFIA_KIFIB', NULL, 'PH_KIFIA_KIFIB', NULL, NULL, NULL, 2),
(15302, NULL, 'cd12758', NULL, NULL, 'RRM1_hnRPDL', NULL, 'RRM1_hnRPDL', NULL, NULL, 33956, 2),
(15303, NULL, 'cd00147', NULL, NULL, 'cPLA2_like', NULL, 'cPLA2_like', NULL, NULL, NULL, 2),
(15304, NULL, 'cd16262', NULL, NULL, 'EFG_III', NULL, 'EFG_III', NULL, NULL, 9759, 2);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(15305, NULL, 'cd18960', NULL, NULL, 'CD_HP1_like', NULL, 'CD_HP1_like', NULL, NULL, NULL, 2),
(15306, NULL, 'cd14044', NULL, NULL, 'PK_GC-C', NULL, 'PK_GC-C', NULL, NULL, 35120, 2),
(15307, NULL, 'cd17452', NULL, NULL, 'MFS_MFSD2B', NULL, 'MFS_MFSD2B', NULL, NULL, NULL, 2),
(15308, NULL, 'cd09263', NULL, NULL, 'AP_stonin-2_MHD', NULL, 'AP_stonin-2_MHD', NULL, NULL, NULL, 2),
(15309, NULL, 'cd14082', NULL, NULL, 'STKc_PKD', NULL, 'STKc_PKD', NULL, NULL, NULL, 2),
(15310, NULL, 'cd03715', NULL, NULL, 'RT_ZFREV_like', NULL, 'RT_ZFREV_like', NULL, NULL, NULL, 2),
(15311, NULL, 'cd05795', NULL, NULL, 'Ribosomal_P0_L10e', NULL, 'Ribosomal_P0_L10e', NULL, NULL, NULL, 2),
(15312, NULL, 'cd04156', NULL, NULL, 'ARLTS1', NULL, 'ARLTS1', NULL, NULL, NULL, 2),
(15313, NULL, 'cd14575', NULL, NULL, 'DUPD1', NULL, 'DUPD1', NULL, NULL, NULL, 2),
(15314, NULL, 'cd19190', NULL, NULL, 'PR-SET_PRDM5', NULL, 'PR-SET_PRDM5', NULL, NULL, 35346, 2),
(15315, NULL, 'cd01516', NULL, NULL, 'FBPase_glpX', NULL, 'FBPase_glpX', NULL, NULL, 7391, 2),
(15316, NULL, 'cd01225', NULL, NULL, 'PH_Cool_Pix', NULL, 'PH_Cool_Pix', NULL, NULL, 37624, 2),
(15317, NULL, 'cd11854', NULL, NULL, 'SH3_Fus1p', NULL, 'SH3_Fus1p', NULL, NULL, 27800, 2),
(15318, NULL, 'cd11711', NULL, NULL, 'GINS_A_Sld5', NULL, 'GINS_A_Sld5', NULL, NULL, 28696, 2),
(15319, NULL, 'cd19900', NULL, NULL, 'DSRM_A1CF', NULL, 'DSRM_A1CF', NULL, NULL, 35241, 2),
(15320, NULL, 'cd09473', NULL, NULL, 'LIM2_Lhx4', NULL, 'LIM2_Lhx4', NULL, NULL, NULL, 2),
(15321, NULL, 'cd13760', NULL, NULL, 'TGF_beta_BMP2_like', NULL, 'TGF_beta_BMP2_like', NULL, NULL, NULL, 2),
(15322, NULL, 'cd09580', NULL, NULL, 'SAM_Scm-like-4MBT', NULL, 'SAM_Scm-like-4MBT', NULL, NULL, 33780, 2),
(15323, NULL, 'cd13210', NULL, NULL, 'PH-GRAM_MTMR6-like', NULL, 'PH-GRAM_MTMR6-like', NULL, NULL, NULL, 2),
(15324, NULL, 'cd15005', NULL, NULL, '7tmA_SREB-like', NULL, '7tmA_SREB-like', NULL, NULL, NULL, 2),
(15325, NULL, 'cd04977', NULL, NULL, 'Ig1_NCAM-1_like', NULL, 'Ig1_NCAM-1_like', NULL, NULL, NULL, 2),
(15326, NULL, 'cd17042', NULL, NULL, 'Ubl_TmoB', NULL, 'Ubl_TmoB', NULL, NULL, NULL, 2),
(15327, NULL, 'cd00375', NULL, NULL, 'Urease_alpha', NULL, 'Urease_alpha', NULL, NULL, 5851, 2),
(15328, NULL, 'cd06886', NULL, NULL, 'PX_SNX27', NULL, 'PX_SNX27', NULL, NULL, 31586, 2),
(15329, NULL, 'cd11876', NULL, NULL, 'SH3_MLK', NULL, 'SH3_MLK', NULL, NULL, NULL, 2),
(15330, NULL, 'cd05742', NULL, NULL, 'Ig_VEGFR_like', NULL, 'Ig_VEGFR_like', NULL, NULL, NULL, 2),
(15331, NULL, 'cd18981', NULL, NULL, 'CSD_HP1e_insect', NULL, 'CSD_HP1e_insect', NULL, NULL, NULL, 2),
(15332, NULL, 'cd06430', NULL, NULL, 'GT8_like_2', NULL, 'GT8_like_2', NULL, NULL, NULL, 2),
(15333, NULL, 'cd03515', NULL, NULL, 'Link_domain_TSG_6_like', NULL, 'Link_domain_TSG_6_like', NULL, NULL, NULL, 2),
(15334, NULL, 'cd01926', NULL, NULL, 'cyclophilin_ABH_like', NULL, 'cyclophilin_ABH_like', NULL, NULL, NULL, 2),
(15335, NULL, 'cd02761', NULL, NULL, 'MopB_FmdB-FwdB', NULL, 'MopB_FmdB-FwdB', NULL, NULL, 15246, 2),
(15336, NULL, 'cd11309', NULL, NULL, '14-3-3_fungi', NULL, '14-3-3_fungi', NULL, NULL, NULL, 2),
(15337, NULL, 'cd06223', NULL, NULL, 'PRTases_typeI', NULL, 'PRTases_typeI', NULL, NULL, 4518, 2),
(15338, NULL, 'cd12232', NULL, NULL, 'RRM3_U2AF65', NULL, 'RRM3_U2AF65', NULL, NULL, NULL, 2),
(15339, NULL, 'cd17181', NULL, NULL, 'FERM_F0_KIND2', NULL, 'FERM_F0_KIND2', NULL, NULL, NULL, 2),
(15340, NULL, 'cd08448', NULL, NULL, 'PBP2_LTTR_aromatics_like_2', NULL, 'PBP2_LTTR_aromatics_like_2', NULL, NULL, NULL, 2),
(15341, NULL, 'cd12379', NULL, NULL, 'RRM2_I_PABPs', NULL, 'RRM2_I_PABPs', NULL, NULL, 37230, 2),
(15342, NULL, 'cd02149', NULL, NULL, 'NfsB-like', NULL, 'NfsB-like', NULL, NULL, 30681, 2),
(15343, NULL, 'cd09132', NULL, NULL, 'PLDc_unchar4', NULL, 'PLDc_unchar4', NULL, NULL, NULL, 2),
(15344, NULL, 'cd19693', NULL, NULL, 'bHLH_dnHLH_ID3', NULL, 'bHLH_dnHLH_ID3', NULL, NULL, NULL, 2),
(15345, NULL, 'cd06138', NULL, NULL, 'ExoI_N', NULL, 'ExoI_N', NULL, NULL, NULL, 2),
(15346, NULL, 'cd14473', NULL, NULL, 'FERM_B-lobe', NULL, 'FERM_B-lobe', NULL, NULL, 20805, 2);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(15347, NULL, 'cd12596', NULL, NULL, 'RRM1_SRSF6', NULL, 'RRM1_SRSF6', NULL, NULL, 12299, 2),
(15348, NULL, 'cd01558', NULL, NULL, 'D-AAT_like', NULL, 'D-AAT_like', NULL, NULL, NULL, 2),
(15349, NULL, 'cd11745', NULL, NULL, 'Yos9_DD', NULL, 'Yos9_DD', NULL, NULL, NULL, 2),
(15350, NULL, 'cd14262', NULL, NULL, 'VirB5_like', NULL, 'VirB5_like', NULL, NULL, NULL, 2),
(15351, NULL, 'cd16801', NULL, NULL, 'RING-H2_RNF126', NULL, 'RING-H2_RNF126', NULL, NULL, 27395, 2),
(15352, NULL, 'cd18066', NULL, NULL, 'DEXHc_RAD54B', NULL, 'DEXHc_RAD54B', NULL, NULL, NULL, 2),
(15353, NULL, 'cd19419', NULL, NULL, 'lipocalin_L-PGDS', NULL, 'lipocalin_L-PGDS', NULL, NULL, NULL, 2),
(15354, NULL, 'cd02030', NULL, NULL, 'NDUO42', NULL, 'NDUO42', NULL, NULL, 9973, 2),
(15355, NULL, 'cd01069', NULL, NULL, 'PBP2_PheC', NULL, 'PBP2_PheC', NULL, NULL, 33495, 2),
(15356, NULL, 'cd00834', NULL, NULL, 'KAS_I_II', NULL, 'KAS_I_II', NULL, NULL, 4751, 2),
(15357, NULL, 'cd12099', NULL, NULL, 'DD_RII_PKA', NULL, 'DD_RII_PKA', NULL, NULL, NULL, 2),
(15358, NULL, 'cd18306', NULL, NULL, 'BTB_POZ_NS1BP', NULL, 'BTB_POZ_NS1BP', NULL, NULL, NULL, 2),
(15359, NULL, 'cd16257', NULL, NULL, 'EFG_III-like', NULL, 'EFG_III-like', NULL, NULL, NULL, 2),
(15360, NULL, 'cd19843', NULL, NULL, 'Bbox1_TRIM9_C-I', NULL, 'Bbox1_TRIM9_C-I', NULL, NULL, NULL, 2),
(15361, NULL, 'cd17524', NULL, NULL, 'RMtype1_S_EcoUTORF5051P-TRD2-CR2_like', NULL, 'RMtype1_S_EcoUTORF5051P-TRD2-CR2_like', NULL, NULL, NULL, 2),
(15362, NULL, 'cd15739', NULL, NULL, 'FYVE_RABE_unchar', NULL, 'FYVE_RABE_unchar', NULL, NULL, NULL, 2),
(15363, NULL, 'cd10578', NULL, NULL, 'TNFRSF3', NULL, 'TNFRSF3', NULL, NULL, 22793, 2),
(15364, NULL, 'cd19441', NULL, NULL, 'CRABP', NULL, 'CRABP', NULL, NULL, NULL, 2),
(15365, NULL, 'cd15902', NULL, NULL, 'EFh_HEF', NULL, 'EFh_HEF', NULL, NULL, NULL, 2),
(15366, NULL, 'cd12437', NULL, NULL, 'RRM_BRAP2_like', NULL, 'RRM_BRAP2_like', NULL, NULL, NULL, 2),
(15367, NULL, 'cd15919', NULL, NULL, '7tmA_GPR139', NULL, '7tmA_GPR139', NULL, NULL, 33131, 2),
(15368, NULL, 'cd13556', NULL, NULL, 'PBP2_SsuA_like_1', NULL, 'PBP2_SsuA_like_1', NULL, NULL, NULL, 2),
(15369, NULL, 'cd18803', NULL, NULL, 'SF2_C_secA', NULL, 'SF2_C_secA', NULL, NULL, 36047, 2),
(15370, NULL, 'cd05399', NULL, NULL, 'NT_Rel-Spo_like', NULL, 'NT_Rel-Spo_like', NULL, NULL, 753, 2),
(15371, NULL, 'cd03020', NULL, NULL, 'DsbA_DsbC_DsbG', NULL, 'DsbA_DsbC_DsbG', NULL, NULL, 33374, 2),
(15372, NULL, 'cd03252', NULL, NULL, 'ABCC_Hemolysin', NULL, 'ABCC_Hemolysin', NULL, NULL, NULL, 2),
(15373, NULL, 'cd00386', NULL, NULL, 'Heme_Cu_Oxidase_III_like', NULL, 'Heme_Cu_Oxidase_III_like', NULL, NULL, NULL, 2),
(15374, NULL, 'cd03862', NULL, NULL, 'M14-like', NULL, 'M14-like', NULL, NULL, NULL, 2),
(15375, NULL, 'cd14966', NULL, NULL, '7tmD_STE3', NULL, '7tmD_STE3', NULL, NULL, NULL, 2),
(15376, NULL, 'cd03591', NULL, NULL, 'CLECT_collectin_like', NULL, 'CLECT_collectin_like', NULL, NULL, 28849, 2),
(15377, NULL, 'cd00155', NULL, NULL, 'RasGEF', NULL, 'RasGEF', NULL, NULL, 2167, 2),
(15378, NULL, 'cd09830', NULL, NULL, 'PET_LIMPETin_LIM-9', NULL, 'PET_LIMPETin_LIM-9', NULL, NULL, NULL, 2),
(15379, NULL, 'cd09269', NULL, NULL, 'deoxyribose_mutarotase', NULL, 'deoxyribose_mutarotase', NULL, NULL, NULL, 2),
(15380, NULL, 'cd00135', NULL, NULL, 'PDGF', NULL, 'PDGF', NULL, NULL, 2821, 2),
(15381, NULL, 'cd17614', NULL, NULL, 'REC_OmpR_YycF-like', NULL, 'REC_OmpR_YycF-like', NULL, NULL, NULL, 2),
(15382, NULL, 'cd16355', NULL, NULL, 'VOC_like', NULL, 'VOC_like', NULL, NULL, NULL, 2),
(15383, NULL, 'cd04749', NULL, NULL, 'Commd1_MURR1', NULL, 'Commd1_MURR1', NULL, NULL, 29261, 2),
(15384, NULL, 'cd13246', NULL, NULL, 'PH_Scd1', NULL, 'PH_Scd1', NULL, NULL, 29399, 2),
(15385, NULL, 'cd06384', NULL, NULL, 'PBP1_NPR_B', NULL, 'PBP1_NPR_B', NULL, NULL, NULL, 2),
(15386, NULL, 'cd11428', NULL, NULL, 'bHLH_TS_NGN', NULL, 'bHLH_TS_NGN', NULL, NULL, NULL, 2),
(15387, NULL, 'cd09183', NULL, NULL, 'PLDc_FAM83C_N', NULL, 'PLDc_FAM83C_N', NULL, NULL, NULL, 2),
(15388, NULL, 'cd02069', NULL, NULL, 'methionine_synthase_B12_BD', NULL, 'methionine_synthase_B12_BD', NULL, NULL, 28151, 2);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(15389, NULL, 'cd01238', NULL, NULL, 'PH_Btk', NULL, 'PH_Btk', NULL, NULL, NULL, 2),
(15390, NULL, 'cd01672', NULL, NULL, 'TMPK', NULL, 'TMPK', NULL, NULL, NULL, 2),
(15391, NULL, 'cd11388', NULL, NULL, 'bHLH_ScINO2_like', NULL, 'bHLH_ScINO2_like', NULL, NULL, NULL, 2),
(15392, NULL, 'cd18413', NULL, NULL, 'BTB_POZ_Shab-like', NULL, 'BTB_POZ_Shab-like', NULL, NULL, NULL, 2),
(15393, NULL, 'cd14049', NULL, NULL, 'STKc_EIF2AK1_HRI', NULL, 'STKc_EIF2AK1_HRI', NULL, NULL, NULL, 2),
(15394, NULL, 'cd09246', NULL, NULL, 'BRO1_Alix_like_1', NULL, 'BRO1_Alix_like_1', NULL, NULL, NULL, 2),
(15395, NULL, 'cd18645', NULL, NULL, 'CD_Cbx4', NULL, 'CD_Cbx4', NULL, NULL, NULL, 2),
(15396, NULL, 'cd06594', NULL, NULL, 'GH31_glucosidase_YihQ', NULL, 'GH31_glucosidase_YihQ', NULL, NULL, 35298, 2),
(15397, NULL, 'cd18083', NULL, NULL, 'aTrm56-like', NULL, 'aTrm56-like', NULL, NULL, NULL, 2),
(15398, NULL, 'cd01201', NULL, NULL, 'PH_BEACH', NULL, 'PH_BEACH', NULL, NULL, 19422, 2),
(15399, NULL, 'cd12477', NULL, NULL, 'RRM1_U1A', NULL, 'RRM1_U1A', NULL, NULL, 15479, 2),
(15400, NULL, 'cd13684', NULL, NULL, 'PBP2_TRAP_Dctp5_like', NULL, 'PBP2_TRAP_Dctp5_like', NULL, NULL, NULL, 2),
(15401, NULL, 'cd05172', NULL, NULL, 'PIKKc_DNA-PK', NULL, 'PIKKc_DNA-PK', NULL, NULL, 31117, 2),
(15402, NULL, 'cd14325', NULL, NULL, 'UBA_RNF31', NULL, 'UBA_RNF31', NULL, NULL, NULL, 2),
(15403, NULL, 'cd17230', NULL, NULL, 'TGS_DRG1', NULL, 'TGS_DRG1', NULL, NULL, NULL, 2),
(15404, NULL, 'cd17616', NULL, NULL, 'REC_OmpR_CtrA', NULL, 'REC_OmpR_CtrA', NULL, NULL, NULL, 2),
(15405, NULL, 'cd10520', NULL, NULL, 'PR-SET_PRDM17', NULL, 'PR-SET_PRDM17', NULL, NULL, 35315, 2),
(15406, NULL, 'cd04225', NULL, NULL, 'CuRO_5_ceruloplasmin', NULL, 'CuRO_5_ceruloplasmin', NULL, NULL, NULL, 2),
(15407, NULL, 'cd12955', NULL, NULL, 'SKA2', NULL, 'SKA2', NULL, NULL, NULL, 2),
(15408, NULL, 'cd15300', NULL, NULL, '7tmA_mAChR_M5', NULL, '7tmA_mAChR_M5', NULL, NULL, NULL, 2),
(15409, NULL, 'cd09390', NULL, NULL, 'LIM2_dLMO', NULL, 'LIM2_dLMO', NULL, NULL, NULL, 2),
(15410, NULL, 'cd12570', NULL, NULL, 'RRM5_MRD1', NULL, 'RRM5_MRD1', NULL, NULL, NULL, 2),
(15411, NULL, 'cd03559', NULL, NULL, 'LGIC_TM', NULL, 'LGIC_TM', NULL, NULL, NULL, 2),
(15412, NULL, 'cd07424', NULL, NULL, 'MPP_PrpA_PrpB', NULL, 'MPP_PrpA_PrpB', NULL, NULL, NULL, 2),
(15413, NULL, 'cd05733', NULL, NULL, 'Ig_L1-CAM_like', NULL, 'Ig_L1-CAM_like', NULL, NULL, NULL, 2),
(15414, NULL, 'cd16784', NULL, NULL, 'mRING-HC-C2H2C4_MDM4', NULL, 'mRING-HC-C2H2C4_MDM4', NULL, NULL, NULL, 2),
(15415, NULL, 'cd05822', NULL, NULL, 'TLP_HIUase', NULL, 'TLP_HIUase', NULL, NULL, 9709, 2),
(15416, NULL, 'cd03285', NULL, NULL, 'ABC_MSH2_euk', NULL, 'ABC_MSH2_euk', NULL, NULL, NULL, 2),
(15417, NULL, 'cd13570', NULL, NULL, 'PBP2_TAXI_TRAP_like_2', NULL, 'PBP2_TAXI_TRAP_like_2', NULL, NULL, NULL, 2),
(15418, NULL, 'cd02143', NULL, NULL, 'nitroreductase_FeS-like', NULL, 'nitroreductase_FeS-like', NULL, NULL, NULL, 2),
(15419, NULL, 'cd00273', NULL, NULL, 'Chemokine_CXC', NULL, 'Chemokine_CXC', NULL, NULL, 27191, 2),
(15420, NULL, 'cd07733', NULL, NULL, 'YycJ-like_MBL-fold', NULL, 'YycJ-like_MBL-fold', NULL, NULL, NULL, 2),
(15421, NULL, 'cd03785', NULL, NULL, 'GT28_MurG', NULL, 'GT28_MurG', NULL, NULL, NULL, 2),
(15422, NULL, 'cd17717', NULL, NULL, 'BRCT_DNA_ligase_IV_rpt2', NULL, 'BRCT_DNA_ligase_IV_rpt2', NULL, NULL, NULL, 2),
(15423, NULL, 'cd11856', NULL, NULL, 'SH3_p47phox_like', NULL, 'SH3_p47phox_like', NULL, NULL, NULL, 2),
(15424, NULL, 'cd03408', NULL, NULL, 'SPFH_like_u1', NULL, 'SPFH_like_u1', NULL, NULL, 29144, 2),
(15425, NULL, 'cd10150', NULL, NULL, 'CobN_like', NULL, 'CobN_like', NULL, NULL, 6086, 2),
(15426, NULL, 'cd12415', NULL, NULL, 'RRM3_RBM28_like', NULL, 'RRM3_RBM28_like', NULL, NULL, NULL, 2),
(15427, NULL, 'cd10949', NULL, NULL, 'CE4_BsPdaB_like', NULL, 'CE4_BsPdaB_like', NULL, NULL, NULL, 2),
(15428, NULL, 'cd16235', NULL, NULL, 'EFh_SPARC_SPARC', NULL, 'EFh_SPARC_SPARC', NULL, NULL, NULL, 2),
(15429, NULL, 'cd16732', NULL, NULL, 'RING-HC_MKRN4', NULL, 'RING-HC_MKRN4', NULL, NULL, NULL, 2);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(15430, NULL, 'cd04205', NULL, NULL, 'CuRO_2_LCC_like', NULL, 'CuRO_2_LCC_like', NULL, NULL, NULL, 2),
(15431, NULL, 'cd08327', NULL, NULL, 'CARD_RAIDD', NULL, 'CARD_RAIDD', NULL, NULL, 37261, 2),
(15432, NULL, 'cd12226', NULL, NULL, 'RRM_NOL8', NULL, 'RRM_NOL8', NULL, NULL, 9775, 2),
(15433, NULL, 'cd12398', NULL, NULL, 'RRM_CSTF2_RNA15_like', NULL, 'RRM_CSTF2_RNA15_like', NULL, NULL, NULL, 2),
(15434, NULL, 'cd07506', NULL, NULL, 'HAD_like', NULL, 'HAD_like', NULL, NULL, NULL, 2),
(15435, NULL, 'cd00037', NULL, NULL, 'CLECT', NULL, 'CLECT', NULL, NULL, NULL, 2),
(15436, NULL, 'cd16658', NULL, NULL, 'RING-Ubox_UBE4B', NULL, 'RING-Ubox_UBE4B', NULL, NULL, NULL, 2),
(15437, NULL, 'cd17442', NULL, NULL, 'MFS_SVOPL', NULL, 'MFS_SVOPL', NULL, NULL, NULL, 2),
(15438, NULL, 'cd12256', NULL, NULL, 'RRM2_LKAP', NULL, 'RRM2_LKAP', NULL, NULL, 6052, 2),
(15439, NULL, 'cd15474', NULL, NULL, 'Myo5p-like_CBD_fungal', NULL, 'Myo5p-like_CBD_fungal', NULL, NULL, NULL, 2),
(15440, NULL, 'cd00587', NULL, NULL, 'HCP_like', NULL, 'HCP_like', NULL, NULL, NULL, 2),
(15441, NULL, 'cd03070', NULL, NULL, 'PDI_b_ERp44', NULL, 'PDI_b_ERp44', NULL, NULL, 30903, 2),
(15442, NULL, 'cd05754', NULL, NULL, 'Ig_Perlecan_like', NULL, 'Ig_Perlecan_like', NULL, NULL, NULL, 2),
(15443, NULL, 'cd12539', NULL, NULL, 'RRM_U2AF35B', NULL, 'RRM_U2AF35B', NULL, NULL, NULL, 2),
(15444, NULL, 'cd17914', NULL, NULL, 'DExxQc_SF1-N', NULL, 'DExxQc_SF1-N', NULL, NULL, NULL, 2),
(15445, NULL, 'cd19344', NULL, NULL, 'Wnt_Wnt16', NULL, 'Wnt_Wnt16', NULL, NULL, NULL, 2),
(15446, NULL, 'cd05120', NULL, NULL, 'APH_ChoK_like', NULL, 'APH_ChoK_like', NULL, NULL, NULL, 2),
(15447, NULL, 'cd03531', NULL, NULL, 'Rieske_RO_Alpha_KSH', NULL, 'Rieske_RO_Alpha_KSH', NULL, NULL, NULL, 2),
(15448, NULL, 'cd16976', NULL, NULL, 'HATPase_HupT_MifS-like', NULL, 'HATPase_HupT_MifS-like', NULL, NULL, NULL, 2),
(15449, NULL, 'cd19193', NULL, NULL, 'PR-SET_PRDM7_9', NULL, 'PR-SET_PRDM7_9', NULL, NULL, 36411, 2),
(15450, NULL, 'cd14128', NULL, NULL, 'STKc_CK1_alpha', NULL, 'STKc_CK1_alpha', NULL, NULL, NULL, 2),
(15451, NULL, 'cd02027', NULL, NULL, 'APSK', NULL, 'APSK', NULL, NULL, 6483, 2),
(15452, NULL, 'cd14380', NULL, NULL, 'UBA2_Rad23', NULL, 'UBA2_Rad23', NULL, NULL, NULL, 2),
(15453, NULL, 'cd13533', NULL, NULL, 'PBP2_Yhfz', NULL, 'PBP2_Yhfz', NULL, NULL, NULL, 2),
(15454, NULL, 'cd17965', NULL, NULL, 'DEADc_MRH4', NULL, 'DEADc_MRH4', NULL, NULL, NULL, 2),
(15455, NULL, 'cd13309', NULL, NULL, 'PH_SKIP', NULL, 'PH_SKIP', NULL, NULL, NULL, 2),
(15456, NULL, 'cd00208', NULL, NULL, 'LbetaH', NULL, 'LbetaH', NULL, NULL, NULL, 2),
(15457, NULL, 'cd15493', NULL, NULL, 'PHD_JMJD2', NULL, 'PHD_JMJD2', NULL, NULL, NULL, 2),
(15458, NULL, 'cd01780', NULL, NULL, 'RA2_PLC-epsilon', NULL, 'RA2_PLC-epsilon', NULL, NULL, NULL, 2),
(15459, NULL, 'cd12554', NULL, NULL, 'RRM1_RBM15B', NULL, 'RRM1_RBM15B', NULL, NULL, 12007, 2),
(15460, NULL, 'cd00066', NULL, NULL, 'G-alpha', NULL, 'G-alpha', NULL, NULL, 5409, 2),
(15461, NULL, 'cd20314', NULL, NULL, 'DSRM_EIF2AK2', NULL, 'DSRM_EIF2AK2', NULL, NULL, NULL, 2),
(15462, NULL, 'cd18768', NULL, NULL, 'PIN_MtVapC4-C5-like', NULL, 'PIN_MtVapC4-C5-like', NULL, NULL, NULL, 2),
(15463, NULL, 'cd05815', NULL, NULL, 'CBM20_DPE2_repeat1', NULL, 'CBM20_DPE2_repeat1', NULL, NULL, 8515, 2),
(15464, NULL, 'cd12724', NULL, NULL, 'RRM1_CPEB2_like', NULL, 'RRM1_CPEB2_like', NULL, NULL, NULL, 2),
(15465, NULL, 'cd16721', NULL, NULL, 'RING-HC_MEX3B', NULL, 'RING-HC_MEX3B', NULL, NULL, NULL, 2),
(15466, NULL, 'cd19823', NULL, NULL, 'Bbox2_MID2_C-I', NULL, 'Bbox2_MID2_C-I', NULL, NULL, NULL, 2),
(15467, NULL, 'cd17160', NULL, NULL, 'UBX_UBXN2A', NULL, 'UBX_UBXN2A', NULL, NULL, NULL, 2),
(15468, NULL, 'cd18577', NULL, NULL, 'ABC_6TM_Pgp_ABCB1_D1_like', NULL, 'ABC_6TM_Pgp_ABCB1_D1_like', NULL, NULL, NULL, 2),
(15469, NULL, 'cd15221', NULL, NULL, '7tmA_OR52B-like', NULL, '7tmA_OR52B-like', NULL, NULL, NULL, 2),
(15470, NULL, 'cd17979', NULL, NULL, 'DEXHc_DHX34', NULL, 'DEXHc_DHX34', NULL, NULL, NULL, 2),
(15471, NULL, 'cd00087', NULL, NULL, 'FReD', NULL, 'FReD', NULL, NULL, 5941, 2);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(15472, NULL, 'cd01146', NULL, NULL, 'FhuD', NULL, 'FhuD', NULL, NULL, NULL, 2),
(15473, NULL, 'cd07369', NULL, NULL, 'PydA_Rs_like', NULL, 'PydA_Rs_like', NULL, NULL, 30043, 2),
(15474, NULL, 'cd14623', NULL, NULL, 'R-PTPc-A-2', NULL, 'R-PTPc-A-2', NULL, NULL, NULL, 2),
(15475, NULL, 'cd04693', NULL, NULL, 'Nudix_Hydrolase_34', NULL, 'Nudix_Hydrolase_34', NULL, NULL, NULL, 2),
(15476, NULL, 'cd03746', NULL, NULL, 'SOCS_WSB1_SWIP1', NULL, 'SOCS_WSB1_SWIP1', NULL, NULL, NULL, 2),
(15477, NULL, 'cd04016', NULL, NULL, 'C2_Tollip', NULL, 'C2_Tollip', NULL, NULL, 31752, 2),
(15478, NULL, 'cd08592', NULL, NULL, 'PI-PLCc_gamma', NULL, 'PI-PLCc_gamma', NULL, NULL, NULL, 2),
(15479, NULL, 'cd00332', NULL, NULL, 'PAL-HAL', NULL, 'PAL-HAL', NULL, NULL, 2427, 2),
(15480, NULL, 'cd19775', NULL, NULL, 'Bbox2_TIF1_C-VI', NULL, 'Bbox2_TIF1_C-VI', NULL, NULL, NULL, 2),
(15481, NULL, 'cd02345', NULL, NULL, 'ZZ_dah', NULL, 'ZZ_dah', NULL, NULL, NULL, 2),
(15482, NULL, 'cd19990', NULL, NULL, 'PBP1_GABAb_receptor_plant', NULL, 'PBP1_GABAb_receptor_plant', NULL, NULL, 35505, 2),
(15483, NULL, 'cd15725', NULL, NULL, 'FYVE_PIKfyve_Fab1', NULL, 'FYVE_PIKfyve_Fab1', NULL, NULL, NULL, 2),
(15484, NULL, 'cd19542', NULL, NULL, 'CT_NRPS-like', NULL, 'CT_NRPS-like', NULL, NULL, NULL, 2),
(15485, NULL, 'cd19757', NULL, NULL, 'Bbox1', NULL, 'Bbox1', NULL, NULL, NULL, 2),
(15486, NULL, 'cd17204', NULL, NULL, 'FERM_F1_EPB41L4B', NULL, 'FERM_F1_EPB41L4B', NULL, NULL, NULL, 2),
(15487, NULL, 'cd16729', NULL, NULL, 'RING-HC_RGLG_plant', NULL, 'RING-HC_RGLG_plant', NULL, NULL, 37392, 2),
(15488, NULL, 'cd09631', NULL, NULL, 'DOMON_DOH', NULL, 'DOMON_DOH', NULL, NULL, 37126, 2),
(15489, NULL, 'cd15561', NULL, NULL, 'PHD1_PHF14', NULL, 'PHD1_PHF14', NULL, NULL, NULL, 2),
(15490, NULL, 'cd09013', NULL, NULL, 'BphC-JF8_N_like', NULL, 'BphC-JF8_N_like', NULL, NULL, NULL, 2),
(15491, NULL, 'cd00493', NULL, NULL, 'FabA_FabZ', NULL, 'FabA_FabZ', NULL, NULL, NULL, 2),
(15492, NULL, 'cd01431', NULL, NULL, 'P-type_ATPases', NULL, 'P-type_ATPases', NULL, NULL, NULL, 2),
(15493, NULL, 'cd09988', NULL, NULL, 'Formimidoylglutamase', NULL, 'Formimidoylglutamase', NULL, NULL, NULL, 2),
(15494, NULL, 'cd18305', NULL, NULL, 'BTB_POZ_GCL', NULL, 'BTB_POZ_GCL', NULL, NULL, NULL, 2),
(15495, NULL, 'cd16389', NULL, NULL, 'FIN', NULL, 'FIN', NULL, NULL, 31948, 2),
(15496, NULL, 'cd06417', NULL, NULL, 'GH25_LysA-like', NULL, 'GH25_LysA-like', NULL, NULL, NULL, 2),
(15497, NULL, 'cd06868', NULL, NULL, 'PX_HS1BP3', NULL, 'PX_HS1BP3', NULL, NULL, 28653, 2),
(15498, NULL, 'cd07711', NULL, NULL, 'MBLAC1-like_MBL-fold', NULL, 'MBLAC1-like_MBL-fold', NULL, NULL, NULL, 2),
(15499, NULL, 'cd06998', NULL, NULL, 'cupin_D-LI-like', NULL, 'cupin_D-LI-like', NULL, NULL, NULL, 2),
(15500, NULL, 'cd02009', NULL, NULL, 'TPP_SHCHC_synthase', NULL, 'TPP_SHCHC_synthase', NULL, NULL, NULL, 2),
(15501, NULL, 'cd08855', NULL, NULL, 'ArfGap_AGAP3', NULL, 'ArfGap_AGAP3', NULL, NULL, NULL, 2),
(15502, NULL, 'cd05328', NULL, NULL, '3alpha_HSD_SDR_c', NULL, '3alpha_HSD_SDR_c', NULL, NULL, NULL, 2),
(15503, NULL, 'cd15761', NULL, NULL, 'FYVE1_Vac1p_like', NULL, 'FYVE1_Vac1p_like', NULL, NULL, NULL, 2),
(15504, NULL, 'cd18270', NULL, NULL, 'BTB_POZ_KBTBD2_BKLHD1', NULL, 'BTB_POZ_KBTBD2_BKLHD1', NULL, NULL, NULL, 2),
(15505, NULL, 'cd16918', NULL, NULL, 'HATPase_Glnl-NtrB-like', NULL, 'HATPase_Glnl-NtrB-like', NULL, NULL, NULL, 2),
(15506, NULL, 'cd09904', NULL, NULL, 'H3TH_XPG', NULL, 'H3TH_XPG', NULL, NULL, NULL, 2),
(15507, NULL, 'cd16894', NULL, NULL, 'MltD-like', NULL, 'MltD-like', NULL, NULL, NULL, 2),
(15508, NULL, 'cd17462', NULL, NULL, 'MFS_SLCO4A_OATP4A', NULL, 'MFS_SLCO4A_OATP4A', NULL, NULL, 37750, 2),
(15509, NULL, 'cd13320', NULL, NULL, 'PH_OCRL-like', NULL, 'PH_OCRL-like', NULL, NULL, NULL, 2),
(15510, NULL, 'cd08689', NULL, NULL, 'C2_fungal_Pkc1p', NULL, 'C2_fungal_Pkc1p', NULL, NULL, 28800, 2),
(15511, NULL, 'cd07560', NULL, NULL, 'Peptidase_S41_CPP', NULL, 'Peptidase_S41_CPP', NULL, NULL, 7091, 2),
(15512, NULL, 'cd07661', NULL, NULL, 'BAR_ICA69', NULL, 'BAR_ICA69', NULL, NULL, NULL, 2);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(15513, NULL, 'cd14041', NULL, NULL, 'STKc_TLK2', NULL, 'STKc_TLK2', NULL, NULL, NULL, 2),
(15514, NULL, 'cd00644', NULL, NULL, 'HMG-CoA_reductase_classII', NULL, 'HMG-CoA_reductase_classII', NULL, NULL, 739, 2),
(15515, NULL, 'cd17211', NULL, NULL, 'RA_RGL2', NULL, 'RA_RGL2', NULL, NULL, NULL, 2),
(15516, NULL, 'cd18513', NULL, NULL, 'BACK_KLHL3', NULL, 'BACK_KLHL3', NULL, NULL, NULL, 2),
(15517, NULL, 'cd15574', NULL, NULL, 'PHD_AF10_AF17', NULL, 'PHD_AF10_AF17', NULL, NULL, NULL, 2),
(15518, NULL, 'cd19909', NULL, NULL, 'DSRM_STRBP_rpt1', NULL, 'DSRM_STRBP_rpt1', NULL, NULL, 34296, 2),
(15519, NULL, 'cd04496', NULL, NULL, 'SSB_OBF', NULL, 'SSB_OBF', NULL, NULL, 6581, 2),
(15520, NULL, 'cd08063', NULL, NULL, 'MPN_CSN6', NULL, 'MPN_CSN6', NULL, NULL, 32194, 2),
(15521, NULL, 'cd08950', NULL, NULL, 'KR_fFAS_SDR_c_like', NULL, 'KR_fFAS_SDR_c_like', NULL, NULL, NULL, 2),
(15522, NULL, 'cd04787', NULL, NULL, 'HTH_HMRTR_unk', NULL, 'HTH_HMRTR_unk', NULL, NULL, NULL, 2),
(15523, NULL, 'cd16666', NULL, NULL, 'RING-H2_RNF43_like', NULL, 'RING-H2_RNF43_like', NULL, NULL, NULL, 2),
(15524, NULL, 'cd18504', NULL, NULL, 'BACK_ARIA_like', NULL, 'BACK_ARIA_like', NULL, NULL, NULL, 2),
(15525, NULL, 'cd15419', NULL, NULL, '7tmA_OR9K2-like', NULL, '7tmA_OR9K2-like', NULL, NULL, NULL, 2),
(15526, NULL, 'cd00808', NULL, NULL, 'GluRS_core', NULL, 'GluRS_core', NULL, NULL, 31265, 2),
(15527, NULL, 'cd06226', NULL, NULL, 'M14_CPT_like', NULL, 'M14_CPT_like', NULL, NULL, NULL, 2),
(15528, NULL, 'cd07205', NULL, NULL, 'Pat_PNPLA6_PNPLA7_NTE1_like', NULL, 'Pat_PNPLA6_PNPLA7_NTE1_like', NULL, NULL, NULL, 2),
(15529, NULL, 'cd04472', NULL, NULL, 'S1_PNPase', NULL, 'S1_PNPase', NULL, NULL, NULL, 2),
(15530, NULL, 'cd02878', NULL, NULL, 'GH18_zymocin_alpha', NULL, 'GH18_zymocin_alpha', NULL, NULL, NULL, 2),
(15531, NULL, 'cd04323', NULL, NULL, 'AsnRS_cyto_like_N', NULL, 'AsnRS_cyto_like_N', NULL, NULL, NULL, 2),
(15532, NULL, 'cd16667', NULL, NULL, 'RING-H2_RNF126_like', NULL, 'RING-H2_RNF126_like', NULL, NULL, NULL, 2),
(15533, NULL, 'cd17318', NULL, NULL, 'MFS_SLC17', NULL, 'MFS_SLC17', NULL, NULL, NULL, 2),
(15534, NULL, 'cd10309', NULL, NULL, 'GST_C_GluProRS_N', NULL, 'GST_C_GluProRS_N', NULL, NULL, NULL, 2),
(15535, NULL, 'cd18431', NULL, NULL, 'BRCT_DNA_ligase_III', NULL, 'BRCT_DNA_ligase_III', NULL, NULL, NULL, 2),
(15536, NULL, 'cd16676', NULL, NULL, 'RING-H2_RNF122', NULL, 'RING-H2_RNF122', NULL, NULL, NULL, 2),
(15537, NULL, 'cd15792', NULL, NULL, 'PH1_FGD5', NULL, 'PH1_FGD5', NULL, NULL, NULL, 2),
(15538, NULL, 'cd00129', NULL, NULL, 'PAN_APPLE', NULL, 'PAN_APPLE', NULL, NULL, NULL, 2),
(15539, NULL, 'cd21525', NULL, NULL, 'SUD_C_SARS-CoV_Nsp3', NULL, 'SUD_C_SARS-CoV_Nsp3', NULL, NULL, 16879, 2),
(15540, NULL, 'cd11712', NULL, NULL, 'GINS_A_psf2', NULL, 'GINS_A_psf2', NULL, NULL, NULL, 2),
(15541, NULL, 'cd12653', NULL, NULL, 'RRM3_HuR', NULL, 'RRM3_HuR', NULL, NULL, NULL, 2),
(15542, NULL, 'cd19087', NULL, NULL, 'AKR_AKR12A1_B1_C1', NULL, 'AKR_AKR12A1_B1_C1', NULL, NULL, NULL, 2),
(15543, NULL, 'cd17961', NULL, NULL, 'DEADc_DDX56', NULL, 'DEADc_DDX56', NULL, NULL, NULL, 2),
(15544, NULL, 'cd15124', NULL, NULL, '7tmA_GRPR', NULL, '7tmA_GRPR', NULL, NULL, NULL, 2),
(15545, NULL, 'cd00293', NULL, NULL, 'USP_Like', NULL, 'USP_Like', NULL, NULL, NULL, 2),
(15546, NULL, 'cd03684', NULL, NULL, 'ClC_3_like', NULL, 'ClC_3_like', NULL, NULL, NULL, 2),
(15547, NULL, 'cd04252', NULL, NULL, 'AAK_NAGK-fArgBP', NULL, 'AAK_NAGK-fArgBP', NULL, NULL, 30723, 2),
(15548, NULL, 'cd11439', NULL, NULL, 'bHLH-PAS_SRC', NULL, 'bHLH-PAS_SRC', NULL, NULL, NULL, 2),
(15549, NULL, 'cd18973', NULL, NULL, 'CD_Tf2-1_POL_like', NULL, 'CD_Tf2-1_POL_like', NULL, NULL, NULL, 2),
(15550, NULL, 'cd01187', NULL, NULL, 'INT_tnpB_C_Tn554', NULL, 'INT_tnpB_C_Tn554', NULL, NULL, NULL, 2),
(15551, NULL, 'cd08691', NULL, NULL, 'C2_NEDL1-like', NULL, 'C2_NEDL1-like', NULL, NULL, 32935, 2),
(15552, NULL, 'cd02004', NULL, NULL, 'TPP_BZL_OCoD_HPCL', NULL, 'TPP_BZL_OCoD_HPCL', NULL, NULL, NULL, 2),
(15553, NULL, 'cd17286', NULL, NULL, 'RMtype1_S_Lla161ORF747P_TRD1-CR1_like', NULL, 'RMtype1_S_Lla161ORF747P_TRD1-CR1_like', NULL, NULL, NULL, 2);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(15554, NULL, 'cd03056', NULL, NULL, 'GST_N_4', NULL, 'GST_N_4', NULL, NULL, NULL, 2),
(15555, NULL, 'cd14784', NULL, NULL, 'class1_nsHb-like', NULL, 'class1_nsHb-like', NULL, NULL, NULL, 2),
(15556, NULL, 'cd17336', NULL, NULL, 'MFS_SLCO_OATP', NULL, 'MFS_SLCO_OATP', NULL, NULL, NULL, 2),
(15557, NULL, 'cd19798', NULL, NULL, 'Bbox2_BRAT-like', NULL, 'Bbox2_BRAT-like', NULL, NULL, NULL, 2),
(15558, NULL, 'cd16434', NULL, NULL, 'CheB-CheR_fusion', NULL, 'CheB-CheR_fusion', NULL, NULL, NULL, 2),
(15559, NULL, 'cd17973', NULL, NULL, 'DEXHc_DHX15', NULL, 'DEXHc_DHX15', NULL, NULL, 34202, 2),
(15560, NULL, 'cd18216', NULL, NULL, 'BTB_POZ_ZBTB29-like', NULL, 'BTB_POZ_ZBTB29-like', NULL, NULL, NULL, 2),
(15561, NULL, 'cd12551', NULL, NULL, 'RRM_II_PABPN1L', NULL, 'RRM_II_PABPN1L', NULL, NULL, NULL, 2),
(15562, NULL, 'cd14852', NULL, NULL, 'LD-carboxypeptidase', NULL, 'LD-carboxypeptidase', NULL, NULL, NULL, 2),
(15563, NULL, 'cd07222', NULL, NULL, 'Pat_PNPLA4', NULL, 'Pat_PNPLA4', NULL, NULL, 30311, 2),
(15564, NULL, 'cd13133', NULL, NULL, 'MATE_like_7', NULL, 'MATE_like_7', NULL, NULL, NULL, 2),
(15565, NULL, 'cd07697', NULL, NULL, 'IgC_TCR_gamma', NULL, 'IgC_TCR_gamma', NULL, NULL, NULL, 2),
(15566, NULL, 'cd08862', NULL, NULL, 'SRPBCC_Smu440-like', NULL, 'SRPBCC_Smu440-like', NULL, NULL, NULL, 2),
(15567, NULL, 'cd01582', NULL, NULL, 'Homoaconitase', NULL, 'Homoaconitase', NULL, NULL, NULL, 2),
(15568, NULL, 'cd03739', NULL, NULL, 'SOCS_SOCS5', NULL, 'SOCS_SOCS5', NULL, NULL, 27568, 2),
(15569, NULL, 'cd16309', NULL, NULL, 'BJP-1-like_MBL-B3', NULL, 'BJP-1-like_MBL-B3', NULL, NULL, NULL, 2),
(15570, NULL, 'cd00168', NULL, NULL, 'CAP', NULL, 'CAP', NULL, NULL, NULL, 2),
(15571, NULL, 'cd10337', NULL, NULL, 'SH2_BCAR3', NULL, 'SH2_BCAR3', NULL, NULL, 35011, 2),
(15572, NULL, 'cd01029', NULL, NULL, 'TOPRIM_primases', NULL, 'TOPRIM_primases', NULL, NULL, 25705, 2),
(15573, NULL, 'cd19025', NULL, NULL, 'LGIC_ECD_nAChR_B2', NULL, 'LGIC_ECD_nAChR_B2', NULL, NULL, NULL, 2),
(15574, NULL, 'cd04318', NULL, NULL, 'EcAsnRS_like_N', NULL, 'EcAsnRS_like_N', NULL, NULL, NULL, 2),
(15575, NULL, 'cd17875', NULL, NULL, 'SRP54_G', NULL, 'SRP54_G', NULL, NULL, NULL, 2),
(15576, NULL, 'cd05868', NULL, NULL, 'Ig4_NrCAM', NULL, 'Ig4_NrCAM', NULL, NULL, NULL, 2),
(15577, NULL, 'cd14206', NULL, NULL, 'PTKc_Aatyk3', NULL, 'PTKc_Aatyk3', NULL, NULL, NULL, 2),
(15578, NULL, 'cd20010', NULL, NULL, 'PBP1_AglR-like', NULL, 'PBP1_AglR-like', NULL, NULL, NULL, 2),
(15579, NULL, 'cd09244', NULL, NULL, 'BRO1_Rhophilin', NULL, 'BRO1_Rhophilin', NULL, NULL, NULL, 2),
(15580, NULL, 'cd17660', NULL, NULL, 'PTP_paladin_2', NULL, 'PTP_paladin_2', NULL, NULL, NULL, 2),
(15581, NULL, 'cd02674', NULL, NULL, 'Peptidase_C19R', NULL, 'Peptidase_C19R', NULL, NULL, NULL, 2),
(15582, NULL, 'cd17659', NULL, NULL, 'PTP_paladin_1', NULL, 'PTP_paladin_1', NULL, NULL, NULL, 2),
(15583, NULL, 'cd12503', NULL, NULL, 'RRM1_hnRNPH_GRSF1_like', NULL, 'RRM1_hnRNPH_GRSF1_like', NULL, NULL, NULL, 2),
(15584, NULL, 'cd19706', NULL, NULL, 'bHLH_TS_TAL1', NULL, 'bHLH_TS_TAL1', NULL, NULL, NULL, 2),
(15585, NULL, 'cd03873', NULL, NULL, 'Zinc_peptidase_like', NULL, 'Zinc_peptidase_like', NULL, NULL, NULL, 2),
(15586, NULL, 'cd00465', NULL, NULL, 'URO-D_CIMS_like', NULL, 'URO-D_CIMS_like', NULL, NULL, NULL, 2),
(15587, NULL, 'cd05874', NULL, NULL, 'Ig_NrCAM', NULL, 'Ig_NrCAM', NULL, NULL, NULL, 2),
(15588, NULL, 'cd13336', NULL, NULL, 'FERM-like_C_SNX31', NULL, 'FERM-like_C_SNX31', NULL, NULL, NULL, 2),
(15589, NULL, 'cd15643', NULL, NULL, 'PHD_KDM2A', NULL, 'PHD_KDM2A', NULL, NULL, NULL, 2),
(15590, NULL, 'cd01383', NULL, NULL, 'MYSc_Myo8', NULL, 'MYSc_Myo8', NULL, NULL, 29899, 2),
(15591, NULL, 'cd14549', NULL, NULL, 'R5-PTPc-1', NULL, 'R5-PTPc-1', NULL, NULL, NULL, 2),
(15592, NULL, 'cd00878', NULL, NULL, 'Arf_Arl', NULL, 'Arf_Arl', NULL, NULL, NULL, 2),
(15593, NULL, 'cd07076', NULL, NULL, 'NR_LBD_GR', NULL, 'NR_LBD_GR', NULL, NULL, NULL, 2),
(15594, NULL, 'cd19132', NULL, NULL, 'AKR_AKR5D1_E1', NULL, 'AKR_AKR5D1_E1', NULL, NULL, NULL, 2),
(15595, NULL, 'cd19168', NULL, NULL, 'SET_EZH-like', NULL, 'SET_EZH-like', NULL, NULL, NULL, 2);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(15596, NULL, 'cd11499', NULL, NULL, 'SLC6sbd_GlyT2', NULL, 'SLC6sbd_GlyT2', NULL, NULL, NULL, 2),
(15597, NULL, 'cd12599', NULL, NULL, 'RRM1_SF2_plant_like', NULL, 'RRM1_SF2_plant_like', NULL, NULL, NULL, 2),
(15598, NULL, 'cd01153', NULL, NULL, 'ACAD_fadE5', NULL, 'ACAD_fadE5', NULL, NULL, 2353, 2),
(15599, NULL, 'cd06547', NULL, NULL, 'GH85_ENGase', NULL, 'GH85_ENGase', NULL, NULL, NULL, 2),
(15600, NULL, 'cd16336', NULL, NULL, 'MukE', NULL, 'MukE', NULL, NULL, NULL, 2),
(15601, NULL, 'cd03548', NULL, NULL, 'Rieske_RO_Alpha_OMO_CARDO', NULL, 'Rieske_RO_Alpha_OMO_CARDO', NULL, NULL, NULL, 2),
(15602, NULL, 'cd06448', NULL, NULL, 'L-Ser-dehyd', NULL, 'L-Ser-dehyd', NULL, NULL, NULL, 2),
(15603, NULL, 'cd14831', NULL, NULL, 'AP1_sigma', NULL, 'AP1_sigma', NULL, NULL, 34371, 2),
(15604, NULL, 'cd16706', NULL, NULL, 'RING-HC_CARP1', NULL, 'RING-HC_CARP1', NULL, NULL, NULL, 2),
(15605, NULL, 'cd15642', NULL, NULL, 'PHD_PHF8', NULL, 'PHD_PHF8', NULL, NULL, NULL, 2),
(15606, NULL, 'cd02188', NULL, NULL, 'gamma_tubulin', NULL, 'gamma_tubulin', NULL, NULL, 6642, 2),
(15607, NULL, 'cd08530', NULL, NULL, 'STKc_CNK2-like', NULL, 'STKc_CNK2-like', NULL, NULL, NULL, 2),
(15608, NULL, 'cd05267', NULL, NULL, 'SDR_a6', NULL, 'SDR_a6', NULL, NULL, NULL, 2),
(15609, NULL, 'cd21534', NULL, NULL, 'SARS-CoV-like_E', NULL, 'SARS-CoV-like_E', NULL, NULL, NULL, 2),
(15610, NULL, 'cd15413', NULL, NULL, '7tmA_OR8K-like', NULL, '7tmA_OR8K-like', NULL, NULL, NULL, 2),
(15611, NULL, 'cd11757', NULL, NULL, 'SH3_SH3BP4', NULL, 'SH3_SH3BP4', NULL, NULL, 20293, 2),
(15612, NULL, 'cd15863', NULL, NULL, 'SNARE_GS27', NULL, 'SNARE_GS27', NULL, NULL, NULL, 2),
(15613, NULL, 'cd07430', NULL, NULL, 'GH15_N', NULL, 'GH15_N', NULL, NULL, 10922, 2),
(15614, NULL, 'cd05810', NULL, NULL, 'CBM20_alpha_MTH', NULL, 'CBM20_alpha_MTH', NULL, NULL, NULL, 2),
(15615, NULL, 'cd17188', NULL, NULL, 'FERM_F1_FRMD7', NULL, 'FERM_F1_FRMD7', NULL, NULL, NULL, 2),
(15616, NULL, 'cd13369', NULL, NULL, 'PH_RASAL1', NULL, 'PH_RASAL1', NULL, NULL, NULL, 2),
(15617, NULL, 'cd12906', NULL, NULL, 'SPRY_SOCS1-2-4', NULL, 'SPRY_SOCS1-2-4', NULL, NULL, NULL, 2),
(15618, NULL, 'cd13129', NULL, NULL, 'MATE_epsE_like', NULL, 'MATE_epsE_like', NULL, NULL, NULL, 2),
(15619, NULL, 'cd09293', NULL, NULL, 'AMN1', NULL, 'AMN1', NULL, NULL, NULL, 2),
(15620, NULL, 'cd06314', NULL, NULL, 'PBP1_tmGBP', NULL, 'PBP1_tmGBP', NULL, NULL, NULL, 2),
(15621, NULL, 'cd17450', NULL, NULL, 'MFS_SLC46A2_TSCOT', NULL, 'MFS_SLC46A2_TSCOT', NULL, NULL, NULL, 2),
(15622, NULL, 'cd16397', NULL, NULL, 'IbrB_like', NULL, 'IbrB_like', NULL, NULL, NULL, 2),
(15623, NULL, 'cd09719', NULL, NULL, 'Cas1_I-E', NULL, 'Cas1_I-E', NULL, NULL, 30652, 2),
(15624, NULL, 'cd00603', NULL, NULL, 'IPT_PCSR', NULL, 'IPT_PCSR', NULL, NULL, NULL, 2),
(15625, NULL, 'cd08955', NULL, NULL, 'KR_2_FAS_SDR_x', NULL, 'KR_2_FAS_SDR_x', NULL, NULL, NULL, 2),
(15626, NULL, 'cd18044', NULL, NULL, 'DEXXQc_SMUBP2', NULL, 'DEXXQc_SMUBP2', NULL, NULL, NULL, 2),
(15627, NULL, 'cd02065', NULL, NULL, 'B12-binding_like', NULL, 'B12-binding_like', NULL, NULL, NULL, 2),
(15628, NULL, 'cd01008', NULL, NULL, 'PBP2_NrtA_SsuA_CpmA_like', NULL, 'PBP2_NrtA_SsuA_CpmA_like', NULL, NULL, NULL, 2),
(15629, NULL, 'cd15535', NULL, NULL, 'PHD1_Rco1', NULL, 'PHD1_Rco1', NULL, NULL, NULL, 2),
(15630, NULL, 'cd19951', NULL, NULL, 'HyaA_family_Fer2_BFD-like', NULL, 'HyaA_family_Fer2_BFD-like', NULL, NULL, NULL, 2),
(15631, NULL, 'cd06221', NULL, NULL, 'sulfite_reductase_like', NULL, 'sulfite_reductase_like', NULL, NULL, NULL, 2),
(15632, NULL, 'cd14625', NULL, NULL, 'R-PTPc-S-1', NULL, 'R-PTPc-S-1', NULL, NULL, NULL, 2),
(15633, NULL, 'cd00036', NULL, NULL, 'ChtBD3', NULL, 'ChtBD3', NULL, NULL, NULL, 2),
(15634, NULL, 'cd11546', NULL, NULL, 'NTP-PPase_His4', NULL, 'NTP-PPase_His4', NULL, NULL, NULL, 2),
(15635, NULL, 'cd19999', NULL, NULL, 'PBP1_ABC_sugar_binding-like', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, NULL, 2),
(15636, NULL, 'cd03229', NULL, NULL, 'ABC_Class3', NULL, 'ABC_Class3', NULL, NULL, NULL, 2),
(15637, NULL, 'cd14284', NULL, NULL, 'UBA_GAWKY', NULL, 'UBA_GAWKY', NULL, NULL, 30219, 2);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(15638, NULL, 'cd04735', NULL, NULL, 'OYE_like_4_FMN', NULL, 'OYE_like_4_FMN', NULL, NULL, NULL, 2),
(15639, NULL, 'cd07277', NULL, NULL, 'PX_RUN', NULL, 'PX_RUN', NULL, NULL, 31257, 2),
(15640, NULL, 'cd15295', NULL, NULL, '7tmA_Histamine_H4R', NULL, '7tmA_Histamine_H4R', NULL, NULL, NULL, 2),
(15641, NULL, 'cd21629', NULL, NULL, 'NS6_deltaCoV', NULL, 'NS6_deltaCoV', NULL, NULL, 34577, 2),
(15642, NULL, 'cd03458', NULL, NULL, 'Catechol_intradiol_dioxygenases', NULL, 'Catechol_intradiol_dioxygenases', NULL, NULL, NULL, 2),
(15643, NULL, 'cd12672', NULL, NULL, 'RRM_DAZL', NULL, 'RRM_DAZL', NULL, NULL, 32523, 2),
(15644, NULL, 'cd11461', NULL, NULL, 'bHLH-O_HES5', NULL, 'bHLH-O_HES5', NULL, NULL, NULL, 2),
(15645, NULL, 'cd12198', NULL, NULL, 'MELK_C', NULL, 'MELK_C', NULL, NULL, NULL, 2),
(15646, NULL, 'cd14591', NULL, NULL, 'PTP-MTM1', NULL, 'PTP-MTM1', NULL, NULL, NULL, 2),
(15647, NULL, 'cd15820', NULL, NULL, 'SPRY_PRY_BTN3', NULL, 'SPRY_PRY_BTN3', NULL, NULL, 30968, 2),
(15648, NULL, 'cd05227', NULL, NULL, 'AR_SDR_e', NULL, 'AR_SDR_e', NULL, NULL, NULL, 2),
(15649, NULL, 'cd15060', NULL, NULL, '7tmA_tyramine_octopamine_R-like', NULL, '7tmA_tyramine_octopamine_R-like', NULL, NULL, NULL, 2),
(15650, NULL, 'cd02558', NULL, NULL, 'PSRA_1', NULL, 'PSRA_1', NULL, NULL, NULL, 2),
(15651, NULL, 'cd13334', NULL, NULL, 'FERM_C_JAK3', NULL, 'FERM_C_JAK3', NULL, NULL, NULL, 2),
(15652, NULL, 'cd14987', NULL, NULL, '7tmA_ACKR3_CXCR7', NULL, '7tmA_ACKR3_CXCR7', NULL, NULL, NULL, 2),
(15653, NULL, 'cd18217', NULL, NULL, 'BTB_POZ_ZBTB31_myoneurin', NULL, 'BTB_POZ_ZBTB31_myoneurin', NULL, NULL, NULL, 2),
(15654, NULL, 'cd19384', NULL, NULL, 'TGF_beta_TGFB1', NULL, 'TGF_beta_TGFB1', NULL, NULL, NULL, 2),
(15655, NULL, 'cd13208', NULL, NULL, 'PH-GRAM_MTMR5_MTMR13', NULL, 'PH-GRAM_MTMR5_MTMR13', NULL, NULL, NULL, 2),
(15656, NULL, 'cd01728', NULL, NULL, 'LSm1', NULL, 'LSm1', NULL, NULL, 2896, 2),
(15657, NULL, 'cd07420', NULL, NULL, 'MPP_RdgC', NULL, 'MPP_RdgC', NULL, NULL, NULL, 2),
(15658, NULL, 'cd05338', NULL, NULL, 'DHRS1_HSDL2-like_SDR_c', NULL, 'DHRS1_HSDL2-like_SDR_c', NULL, NULL, NULL, 2),
(15659, NULL, 'cd21635', NULL, NULL, 'ORF7b_SARS-CoV-like', NULL, 'ORF7b_SARS-CoV-like', NULL, NULL, 36488, 2),
(15660, NULL, 'cd11992', NULL, NULL, 'SH3_Intersectin2_3', NULL, 'SH3_Intersectin2_3', NULL, NULL, 28046, 2),
(15661, NULL, 'cd13280', NULL, NULL, 'PH_SIP3', NULL, 'PH_SIP3', NULL, NULL, 30298, 2),
(15662, NULL, 'cd07209', NULL, NULL, 'Pat_hypo_Ecoli_Z1214_like', NULL, 'Pat_hypo_Ecoli_Z1214_like', NULL, NULL, NULL, 2),
(15663, NULL, 'cd16279', NULL, NULL, 'metallo-hydrolase-like_MBL-fold', NULL, 'metallo-hydrolase-like_MBL-fold', NULL, NULL, NULL, 2),
(15664, NULL, 'cd01651', NULL, NULL, 'RT_G2_intron', NULL, 'RT_G2_intron', NULL, NULL, NULL, 2),
(15665, NULL, 'cd03886', NULL, NULL, 'M20_Acy1', NULL, 'M20_Acy1', NULL, NULL, NULL, 2),
(15666, NULL, 'cd14343', NULL, NULL, 'UBA_F100B_like', NULL, 'UBA_F100B_like', NULL, NULL, NULL, 2),
(15667, NULL, 'cd14137', NULL, NULL, 'STKc_GSK3', NULL, 'STKc_GSK3', NULL, NULL, 32826, 2),
(15668, NULL, 'cd18058', NULL, NULL, 'DEXHc_CHD6', NULL, 'DEXHc_CHD6', NULL, NULL, NULL, 2),
(15669, NULL, 'cd14547', NULL, NULL, 'PTPc-KIM', NULL, 'PTPc-KIM', NULL, NULL, NULL, 2),
(15670, NULL, 'cd15669', NULL, NULL, 'ePHD_PHF7_G2E3_like', NULL, 'ePHD_PHF7_G2E3_like', NULL, NULL, 30349, 2),
(15671, NULL, 'cd16475', NULL, NULL, 'RING-H2_RNF121_like', NULL, 'RING-H2_RNF121_like', NULL, NULL, NULL, 2),
(15672, NULL, 'cd13312', NULL, NULL, 'PH_USP37_like', NULL, 'PH_USP37_like', NULL, NULL, 26240, 2),
(15673, NULL, 'cd15889', NULL, NULL, 'SNARE_SNAP25N_23N', NULL, 'SNARE_SNAP25N_23N', NULL, NULL, NULL, 2),
(15674, NULL, 'cd02037', NULL, NULL, 'Mrp_NBP35', NULL, 'Mrp_NBP35', NULL, NULL, NULL, 2),
(15675, NULL, 'cd08612', NULL, NULL, 'GDPD_GDE4', NULL, 'GDPD_GDE4', NULL, NULL, NULL, 2),
(15676, NULL, 'cd13685', NULL, NULL, 'PBP2_iGluR_non_NMDA_like', NULL, 'PBP2_iGluR_non_NMDA_like', NULL, NULL, NULL, 2),
(15677, NULL, 'cd09266', NULL, NULL, 'SGIP1_MHD', NULL, 'SGIP1_MHD', NULL, NULL, 32124, 2);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(15678, NULL, 'cd05893', NULL, NULL, 'Ig_Palladin_C', NULL, 'Ig_Palladin_C', NULL, NULL, 29796, 2),
(15679, NULL, 'cd19716', NULL, NULL, 'bHLH_TS_NGN1_NeuroD3', NULL, 'bHLH_TS_NGN1_NeuroD3', NULL, NULL, NULL, 2),
(15680, NULL, 'cd14244', NULL, NULL, 'GH_101_like', NULL, 'GH_101_like', NULL, NULL, 24577, 2),
(15681, NULL, 'cd09365', NULL, NULL, 'LIM2_LIMK', NULL, 'LIM2_LIMK', NULL, NULL, NULL, 2),
(15682, NULL, 'cd01490', NULL, NULL, 'Ube1_repeat2', NULL, 'Ube1_repeat2', NULL, NULL, NULL, 2),
(15683, NULL, 'cd02133', NULL, NULL, 'PA_C5a_like', NULL, 'PA_C5a_like', NULL, NULL, NULL, 2),
(15684, NULL, 'cd17766', NULL, NULL, 'futalosine_nucleosidase_MqnB', NULL, 'futalosine_nucleosidase_MqnB', NULL, NULL, NULL, 2),
(15685, NULL, 'cd14439', NULL, NULL, 'AlgX_N_like', NULL, 'AlgX_N_like', NULL, NULL, NULL, 2),
(15686, NULL, 'cd07758', NULL, NULL, 'ThTPase', NULL, 'ThTPase', NULL, NULL, 7151, 2),
(15687, NULL, 'cd14008', NULL, NULL, 'STKc_LKB1_CaMKK', NULL, 'STKc_LKB1_CaMKK', NULL, NULL, NULL, 2),
(15688, NULL, 'cd02038', NULL, NULL, 'FlhG-like', NULL, 'FlhG-like', NULL, NULL, 26802, 2),
(15689, NULL, 'cd08269', NULL, NULL, 'Zn_ADH9', NULL, 'Zn_ADH9', NULL, NULL, NULL, 2),
(15690, NULL, 'cd07798', NULL, NULL, 'FGGY_AI-2K_like', NULL, 'FGGY_AI-2K_like', NULL, NULL, NULL, 2),
(15691, NULL, 'cd13207', NULL, NULL, 'FERM-like_C_SNX', NULL, 'FERM-like_C_SNX', NULL, NULL, NULL, 2),
(15692, NULL, 'cd14663', NULL, NULL, 'STKc_SnRK3', NULL, 'STKc_SnRK3', NULL, NULL, NULL, 2),
(15693, NULL, 'cd11960', NULL, NULL, 'SH3_Abp1_eu', NULL, 'SH3_Abp1_eu', NULL, NULL, 31479, 2),
(15694, NULL, 'cd05266', NULL, NULL, 'SDR_a4', NULL, 'SDR_a4', NULL, NULL, NULL, 2),
(15695, NULL, 'cd03600', NULL, NULL, 'CLECT_thrombomodulin_like', NULL, 'CLECT_thrombomodulin_like', NULL, NULL, NULL, 2),
(15696, NULL, 'cd18338', NULL, NULL, 'BTB_POZ_KLHL2_Mayven', NULL, 'BTB_POZ_KLHL2_Mayven', NULL, NULL, 36788, 2),
(15697, NULL, 'cd00926', NULL, NULL, 'Cyt_c_Oxidase_VIb', NULL, 'Cyt_c_Oxidase_VIb', NULL, NULL, 2128, 2),
(15698, NULL, 'cd06813', NULL, NULL, 'PLPDE_III_DSD_D-TA_like_2', NULL, 'PLPDE_III_DSD_D-TA_like_2', NULL, NULL, NULL, 2),
(15699, NULL, 'cd14720', NULL, NULL, 'bZIP_NFE2-like', NULL, 'bZIP_NFE2-like', NULL, NULL, NULL, 2),
(15700, NULL, 'cd16398', NULL, NULL, 'KorB_N_like', NULL, 'KorB_N_like', NULL, NULL, NULL, 2),
(15701, NULL, 'cd07252', NULL, NULL, 'BphC1-RGP6_N_like', NULL, 'BphC1-RGP6_N_like', NULL, NULL, NULL, 2),
(15702, NULL, 'cd05009', NULL, NULL, 'SIS_GlmS_GlmD_2', NULL, 'SIS_GlmS_GlmD_2', NULL, NULL, 33614, 2),
(15703, NULL, 'cd04639', NULL, NULL, 'CBS_pair_peptidase_M50', NULL, 'CBS_pair_peptidase_M50', NULL, NULL, NULL, 2),
(15704, NULL, 'cd08361', NULL, NULL, 'PpCmtC_N', NULL, 'PpCmtC_N', NULL, NULL, NULL, 2),
(15705, NULL, 'cd12211', NULL, NULL, 'Bc2l-C_N', NULL, 'Bc2l-C_N', NULL, NULL, 31369, 2),
(15706, NULL, 'cd11242', NULL, NULL, 'Sema_6', NULL, 'Sema_6', NULL, NULL, NULL, 2),
(15707, NULL, 'cd12289', NULL, NULL, 'RRM_LARP6', NULL, 'RRM_LARP6', NULL, NULL, 9276, 2),
(15708, NULL, 'cd16535', NULL, NULL, 'RING-HC_RNF8', NULL, 'RING-HC_RNF8', NULL, NULL, NULL, 2),
(15709, NULL, 'cd08367', NULL, NULL, 'P53', NULL, 'P53', NULL, NULL, 11561, 2),
(15710, NULL, 'cd13843', NULL, NULL, 'Azurin_like', NULL, 'Azurin_like', NULL, NULL, NULL, 2),
(15711, NULL, 'cd18246', NULL, NULL, 'BTB_POZ_KLHL17_actinfilin', NULL, 'BTB_POZ_KLHL17_actinfilin', NULL, NULL, NULL, 2),
(15712, NULL, 'cd07405', NULL, NULL, 'MPP_UshA_N', NULL, 'MPP_UshA_N', NULL, NULL, NULL, 2),
(15713, NULL, 'cd13889', NULL, NULL, 'CuRO_3_BOD', NULL, 'CuRO_3_BOD', NULL, NULL, NULL, 2),
(15714, NULL, 'cd15200', NULL, NULL, '7tmA_OXER1', NULL, '7tmA_OXER1', NULL, NULL, NULL, 2),
(15715, NULL, 'cd05191', NULL, NULL, 'NAD_bind_amino_acid_DH', NULL, 'NAD_bind_amino_acid_DH', NULL, NULL, NULL, 2),
(15716, NULL, 'cd01773', NULL, NULL, 'UBX_UBXN7', NULL, 'UBX_UBXN7', NULL, NULL, NULL, 2),
(15717, NULL, 'cd09220', NULL, NULL, 'GH64-GluB-like', NULL, 'GH64-GluB-like', NULL, NULL, NULL, 2),
(15718, NULL, 'cd00171', NULL, NULL, 'Sec7', NULL, 'Sec7', NULL, NULL, 3401, 2);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(15719, NULL, 'cd07267', NULL, NULL, 'THT_Oxygenase_N', NULL, 'THT_Oxygenase_N', NULL, NULL, NULL, 2),
(15720, NULL, 'cd03875', NULL, NULL, 'M28_Fxna_like', NULL, 'M28_Fxna_like', NULL, NULL, NULL, 2),
(15721, NULL, 'cd11278', NULL, NULL, 'Sema_MET', NULL, 'Sema_MET', NULL, NULL, NULL, 2),
(15722, NULL, 'cd14923', NULL, NULL, 'MYSc_Myh13', NULL, 'MYSc_Myh13', NULL, NULL, 35518, 2),
(15723, NULL, 'cd16603', NULL, NULL, 'RING-HC_TRIM43_like_C-IV', NULL, 'RING-HC_TRIM43_like_C-IV', NULL, NULL, NULL, 2),
(15724, NULL, 'cd07810', NULL, NULL, 'FGGY_D-XK_2', NULL, 'FGGY_D-XK_2', NULL, NULL, NULL, 2),
(15725, NULL, 'cd20008', NULL, NULL, 'PBP1_ABC_sugar_binding-like', NULL, 'PBP1_ABC_sugar_binding-like', NULL, NULL, NULL, 2),
(15726, NULL, 'cd15217', NULL, NULL, '7tmA_SREB3_GPR173', NULL, '7tmA_SREB3_GPR173', NULL, NULL, NULL, 2),
(15727, NULL, 'cd16920', NULL, NULL, 'HATPase_TmoS-FixL-DctS-like', NULL, 'HATPase_TmoS-FixL-DctS-like', NULL, NULL, NULL, 2),
(15728, NULL, 'cd08197', NULL, NULL, 'DOIS', NULL, 'DOIS', NULL, NULL, NULL, 2),
(15729, NULL, 'cd06597', NULL, NULL, 'GH31_transferase_CtsY', NULL, 'GH31_transferase_CtsY', NULL, NULL, NULL, 2),
(15730, NULL, 'cd15445', NULL, NULL, '7tmB1_CRF-R1', NULL, '7tmB1_CRF-R1', NULL, NULL, NULL, 2),
(15731, NULL, 'cd00267', NULL, NULL, 'ABC_ATPase', NULL, 'ABC_ATPase', NULL, NULL, NULL, 2),
(15732, NULL, 'cd14644', NULL, NULL, 'DSP_DUSP9', NULL, 'DSP_DUSP9', NULL, NULL, NULL, 2),
(15733, NULL, 'cd06116', NULL, NULL, 'CaCS_like', NULL, 'CaCS_like', NULL, NULL, NULL, 2),
(15734, NULL, 'cd06185', NULL, NULL, 'PDR_like', NULL, 'PDR_like', NULL, NULL, NULL, 2),
(15735, NULL, 'cd15347', NULL, NULL, '7tmA_S1PR2_Edg5', NULL, '7tmA_S1PR2_Edg5', NULL, NULL, NULL, 2),
(15736, NULL, 'cd16245', NULL, NULL, 'EFh_DAH', NULL, 'EFh_DAH', NULL, NULL, NULL, 2),
(15737, NULL, 'cd14031', NULL, NULL, 'STKc_WNK3', NULL, 'STKc_WNK3', NULL, NULL, NULL, 2),
(15738, NULL, 'cd19151', NULL, NULL, 'AKR_AKR14A2', NULL, 'AKR_AKR14A2', NULL, NULL, NULL, 2),
(15739, NULL, 'cd17738', NULL, NULL, 'BRCT_TopBP1_rpt7', NULL, 'BRCT_TopBP1_rpt7', NULL, NULL, NULL, 2),
(15740, NULL, 'cd12664', NULL, NULL, 'RRM1_RAVER2', NULL, 'RRM1_RAVER2', NULL, NULL, NULL, 2),
(15741, NULL, 'cd10844', NULL, NULL, 'DSRM_TARBP2_rpt2', NULL, 'DSRM_TARBP2_rpt2', NULL, NULL, 34438, 2),
(15742, NULL, 'cd07124', NULL, NULL, 'ALDH_PutA-P5CDH-RocA', NULL, 'ALDH_PutA-P5CDH-RocA', NULL, NULL, 218, 2),
(15743, NULL, 'cd17968', NULL, NULL, 'DEAHc_DDX11_starthere', NULL, 'DEAHc_DDX11_starthere', NULL, NULL, NULL, 2),
(15744, NULL, 'cd03298', NULL, NULL, 'ABC_ThiQ_thiamine_transporter', NULL, 'ABC_ThiQ_thiamine_transporter', NULL, NULL, NULL, 2),
(15745, NULL, 'cd07938', NULL, NULL, 'DRE_TIM_HMGL', NULL, 'DRE_TIM_HMGL', NULL, NULL, NULL, 2),
(15746, NULL, 'cd06619', NULL, NULL, 'PKc_MKK5', NULL, 'PKc_MKK5', NULL, NULL, NULL, 2),
(15747, NULL, 'cd11897', NULL, NULL, 'SH3_SNX18', NULL, 'SH3_SNX18', NULL, NULL, 33395, 2),
(15748, NULL, 'cd00301', NULL, NULL, 'lipocalin_FABP', NULL, 'lipocalin_FABP', NULL, NULL, NULL, 2),
(15749, NULL, 'cd04147', NULL, NULL, 'Ras_dva', NULL, 'Ras_dva', NULL, NULL, NULL, 2),
(15750, NULL, 'cd08831', NULL, NULL, 'ArfGap_ArfGap2_3_like', NULL, 'ArfGap_ArfGap2_3_like', NULL, NULL, NULL, 2),
(15751, NULL, 'cd19950', NULL, NULL, 'Fer2_BFD-like', NULL, 'Fer2_BFD-like', NULL, NULL, NULL, 2),
(15752, NULL, 'cd20302', NULL, NULL, 'cupin_DAD', NULL, 'cupin_DAD', NULL, NULL, NULL, 2),
(15753, NULL, 'cd08564', NULL, NULL, 'GDPD_GsGDE_like', NULL, 'GDPD_GsGDE_like', NULL, NULL, NULL, 2),
(15754, NULL, 'cd08419', NULL, NULL, 'PBP2_CbbR_RubisCO_like', NULL, 'PBP2_CbbR_RubisCO_like', NULL, NULL, NULL, 2),
(15755, NULL, 'cd07655', NULL, NULL, 'F-BAR_PACSIN', NULL, 'F-BAR_PACSIN', NULL, NULL, NULL, 2),
(15756, NULL, 'cd17170', NULL, NULL, 'FERM_F1_FRMPD4', NULL, 'FERM_F1_FRMPD4', NULL, NULL, NULL, 2),
(15757, NULL, 'cd05364', NULL, NULL, 'SDR_c11', NULL, 'SDR_c11', NULL, NULL, NULL, 2),
(15758, NULL, 'cd12280', NULL, NULL, 'RRM_FET', NULL, 'RRM_FET', NULL, NULL, NULL, 2),
(15759, NULL, 'cd04934', NULL, NULL, 'ACT_AK-Hom3_1', NULL, 'ACT_AK-Hom3_1', NULL, NULL, NULL, 2);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(15760, NULL, 'cd10402', NULL, NULL, 'SH2_C-SH2_Zap70', NULL, 'SH2_C-SH2_Zap70', NULL, NULL, NULL, 2),
(15761, NULL, 'cd04976', NULL, NULL, 'Ig_VEGFR', NULL, 'Ig_VEGFR', NULL, NULL, NULL, 2),
(15762, NULL, 'cd08193', NULL, NULL, 'HVD', NULL, 'HVD', NULL, NULL, NULL, 2),
(15763, NULL, 'cd10576', NULL, NULL, 'TNFRSF1A', NULL, 'TNFRSF1A', NULL, NULL, 32433, 2),
(15764, NULL, 'cd16029', NULL, NULL, '4-S', NULL, '4-S', NULL, NULL, NULL, 2),
(15765, NULL, 'cd12100', NULL, NULL, 'DD_CABYR_SP17', NULL, 'DD_CABYR_SP17', NULL, NULL, NULL, 2),
(15766, NULL, 'cd10932', NULL, NULL, 'CE4_u8', NULL, 'CE4_u8', NULL, NULL, NULL, 2),
(15767, NULL, 'cd06964', NULL, NULL, 'NR_DBD_RAR', NULL, 'NR_DBD_RAR', NULL, NULL, NULL, 2),
(15768, NULL, 'cd07392', NULL, NULL, 'MPP_PAE1087', NULL, 'MPP_PAE1087', NULL, NULL, 29855, 2),
(15769, NULL, 'cd13155', NULL, NULL, 'KOW_KIN17', NULL, 'KOW_KIN17', NULL, NULL, 30341, 2),
(15770, NULL, 'cd09092', NULL, NULL, 'INPP5A', NULL, 'INPP5A', NULL, NULL, NULL, 2),
(15771, NULL, 'cd07207', NULL, NULL, 'Pat_ExoU_VipD_like', NULL, 'Pat_ExoU_VipD_like', NULL, NULL, NULL, 2),
(15772, NULL, 'cd15840', NULL, NULL, 'SNARE_Qa', NULL, 'SNARE_Qa', NULL, NULL, NULL, 2),
(15773, NULL, 'cd17730', NULL, NULL, 'BRCT_PAXIP1_rpt4', NULL, 'BRCT_PAXIP1_rpt4', NULL, NULL, NULL, 2),
(15774, NULL, 'cd12267', NULL, NULL, 'RRM_YRA1_MLO3', NULL, 'RRM_YRA1_MLO3', NULL, NULL, 1123, 2),
(15775, NULL, 'cd20185', NULL, NULL, 'M34_PABD', NULL, 'M34_PABD', NULL, NULL, NULL, 2),
(15776, NULL, 'cd21160', NULL, NULL, 'NendoU_av_Nsp11-like', NULL, 'NendoU_av_Nsp11-like', NULL, NULL, 36287, 2),
(15777, NULL, 'cd15731', NULL, NULL, 'FYVE_LST2', NULL, 'FYVE_LST2', NULL, NULL, 35484, 2),
(15778, NULL, 'cd02020', NULL, NULL, 'CMPK', NULL, 'CMPK', NULL, NULL, 10049, 2),
(15779, NULL, 'cd10573', NULL, NULL, 'PH_DAPP1', NULL, 'PH_DAPP1', NULL, NULL, NULL, 2),
(15780, NULL, 'cd16592', NULL, NULL, 'RING-HC_TRIM7_C-IV', NULL, 'RING-HC_TRIM7_C-IV', NULL, NULL, NULL, 2),
(15781, NULL, 'cd04414', NULL, NULL, 'NDPk6', NULL, 'NDPk6', NULL, NULL, 27712, 2),
(15782, NULL, 'cd17034', NULL, NULL, 'T3SC_IA_ShcO1-like', NULL, 'T3SC_IA_ShcO1-like', NULL, NULL, NULL, 2),
(15783, NULL, 'cd18195', NULL, NULL, 'BTB_POZ_ZBTB4', NULL, 'BTB_POZ_ZBTB4', NULL, NULL, NULL, 2),
(15784, NULL, 'cd06274', NULL, NULL, 'PBP1_FruR', NULL, 'PBP1_FruR', NULL, NULL, NULL, 2),
(15785, NULL, 'cd09469', NULL, NULL, 'LIM1_Lhx2', NULL, 'LIM1_Lhx2', NULL, NULL, NULL, 2),
(15786, NULL, 'cd12350', NULL, NULL, 'RRM3_SHARP', NULL, 'RRM3_SHARP', NULL, NULL, 4068, 2),
(15787, NULL, 'cd17191', NULL, NULL, 'FERM_F1_PTPN14', NULL, 'FERM_F1_PTPN14', NULL, NULL, NULL, 2),
(15788, NULL, 'cd04861', NULL, NULL, 'LigD_Pol_like', NULL, 'LigD_Pol_like', NULL, NULL, NULL, 2),
(15789, NULL, 'cd01823', NULL, NULL, 'SEST_like', NULL, 'SEST_like', NULL, NULL, 32775, 2),
(15790, NULL, 'cd12035', NULL, NULL, 'SH3_MPP1-like', NULL, 'SH3_MPP1-like', NULL, NULL, NULL, 2),
(15791, NULL, 'cd12497', NULL, NULL, 'RRM3_RBM47', NULL, 'RRM3_RBM47', NULL, NULL, 28224, 2),
(15792, NULL, 'cd13682', NULL, NULL, 'PBP2_TRAP_alpha-ketoacid', NULL, 'PBP2_TRAP_alpha-ketoacid', NULL, NULL, 29527, 2),
(15793, NULL, 'cd17038', NULL, NULL, 'Flavi_M', NULL, 'Flavi_M', NULL, NULL, NULL, 2),
(15794, NULL, 'cd01228', NULL, NULL, 'PH_BCR-related', NULL, 'PH_BCR-related', NULL, NULL, NULL, 2),
(15795, NULL, 'cd18348', NULL, NULL, 'BTB_POZ_BTBD3', NULL, 'BTB_POZ_BTBD3', NULL, NULL, NULL, 2),
(15796, NULL, 'cd14997', NULL, NULL, '7tmA_ETH-R', NULL, '7tmA_ETH-R', NULL, NULL, NULL, 2),
(15797, NULL, 'cd12922', NULL, NULL, 'VKOR_5', NULL, 'VKOR_5', NULL, NULL, 30325, 2),
(15798, NULL, 'cd13303', NULL, NULL, 'PH1-like_Rtt106', NULL, 'PH1-like_Rtt106', NULL, NULL, NULL, 2),
(15799, NULL, 'cd17744', NULL, NULL, 'BRCT_MDC1_rpt1', NULL, 'BRCT_MDC1_rpt1', NULL, NULL, NULL, 2),
(15800, NULL, 'cd00945', NULL, NULL, 'Aldolase_Class_I', NULL, 'Aldolase_Class_I', NULL, NULL, NULL, 2),
(15801, NULL, 'cd13141', NULL, NULL, 'MATE_like_13', NULL, 'MATE_like_13', NULL, NULL, NULL, 2),
(15802, NULL, 'cd12409', NULL, NULL, 'RRM1_RRT5', NULL, 'RRM1_RRT5', NULL, NULL, 7169, 2);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(15803, NULL, 'cd14093', NULL, NULL, 'STKc_PhKG', NULL, 'STKc_PhKG', NULL, NULL, NULL, 2),
(15804, NULL, 'cd05313', NULL, NULL, 'NAD_bind_2_Glu_DH', NULL, 'NAD_bind_2_Glu_DH', NULL, NULL, 31282, 2),
(15805, NULL, 'cd02513', NULL, NULL, 'CMP-NeuAc_Synthase', NULL, 'CMP-NeuAc_Synthase', NULL, NULL, NULL, 2),
(15806, NULL, 'cd19065', NULL, NULL, 'LGIC_TM_ZAC', NULL, 'LGIC_TM_ZAC', NULL, NULL, NULL, 2),
(15807, NULL, 'cd12305', NULL, NULL, 'RRM_NELFE', NULL, 'RRM_NELFE', NULL, NULL, 12057, 2),
(15808, NULL, 'cd15816', NULL, NULL, 'SPRY_PRY_TRIM58', NULL, 'SPRY_PRY_TRIM58', NULL, NULL, 32306, 2),
(15809, NULL, 'cd19406', NULL, NULL, 'TGF_beta_INHBC_E', NULL, 'TGF_beta_INHBC_E', NULL, NULL, NULL, 2),
(15810, NULL, 'cd12547', NULL, NULL, 'RRM1_2_PAR10', NULL, 'RRM1_2_PAR10', NULL, NULL, 28256, 2),
(15811, NULL, 'cd04815', NULL, NULL, 'PA_M28_2', NULL, 'PA_M28_2', NULL, NULL, NULL, 2),
(15812, NULL, 'cd05808', NULL, NULL, 'CBM20_alpha_amylase', NULL, 'CBM20_alpha_amylase', NULL, NULL, NULL, 2),
(15813, NULL, 'cd01757', NULL, NULL, 'PLAT_RAB6IP1', NULL, 'PLAT_RAB6IP1', NULL, NULL, NULL, 2),
(15814, NULL, 'cd04583', NULL, NULL, 'CBS_pair_ABC_OpuCA_assoc', NULL, 'CBS_pair_ABC_OpuCA_assoc', NULL, NULL, NULL, 2),
(15815, NULL, 'cd09849', NULL, NULL, 'M20_Acy1L2-like', NULL, 'M20_Acy1L2-like', NULL, NULL, NULL, 2),
(15816, NULL, 'cd09880', NULL, NULL, 'PIN_Smg5-6-like', NULL, 'PIN_Smg5-6-like', NULL, NULL, NULL, 2),
(15817, NULL, 'cd05607', NULL, NULL, 'STKc_GRK7', NULL, 'STKc_GRK7', NULL, NULL, NULL, 2),
(15818, NULL, 'cd00828', NULL, NULL, 'elong_cond_enzymes', NULL, 'elong_cond_enzymes', NULL, NULL, NULL, 2),
(15819, NULL, 'cd02666', NULL, NULL, 'Peptidase_C19J', NULL, 'Peptidase_C19J', NULL, NULL, NULL, 2),
(15820, NULL, 'cd03590', NULL, NULL, 'CLECT_DC-SIGN_like', NULL, 'CLECT_DC-SIGN_like', NULL, NULL, 2367, 2),
(15821, NULL, 'cd13523', NULL, NULL, 'PBP2_polyamines', NULL, 'PBP2_polyamines', NULL, NULL, NULL, 2),
(15822, NULL, 'cd14599', NULL, NULL, 'PTPc-N14', NULL, 'PTPc-N14', NULL, NULL, NULL, 2),
(15823, NULL, 'cd07920', NULL, NULL, 'Pumilio', NULL, 'Pumilio', NULL, NULL, 32859, 2),
(15824, NULL, 'cd04015', NULL, NULL, 'C2_plant_PLD', NULL, 'C2_plant_PLD', NULL, NULL, NULL, 2),
(15825, NULL, 'cd01639', NULL, NULL, 'IMPase', NULL, 'IMPase', NULL, NULL, 29421, 2),
(15826, NULL, 'cd17941', NULL, NULL, 'DEADc_DDX10', NULL, 'DEADc_DDX10', NULL, NULL, NULL, 2),
(15827, NULL, 'cd13197', NULL, NULL, 'FERM_C_CCM1', NULL, 'FERM_C_CCM1', NULL, NULL, 30035, 2),
(15828, NULL, 'cd14444', NULL, NULL, 'AlgX_N_like_1', NULL, 'AlgX_N_like_1', NULL, NULL, NULL, 2),
(15829, NULL, 'cd07215', NULL, NULL, 'Pat17_PNPLA8_PNPLA9_like2', NULL, 'Pat17_PNPLA8_PNPLA9_like2', NULL, NULL, NULL, 2),
(15830, NULL, 'cd07718', NULL, NULL, 'RNaseZ_ELAC1_ELAC2-C-term-like_MBL-fold', NULL, 'RNaseZ_ELAC1_ELAC2-C-term-like_MBL-fold', NULL, NULL, NULL, 2),
(15831, NULL, 'cd13598', NULL, NULL, 'PBP2_lipoprotein_IlpA_like', NULL, 'PBP2_lipoprotein_IlpA_like', NULL, NULL, NULL, 2),
(15832, NULL, 'cd03326', NULL, NULL, 'MR_like_1', NULL, 'MR_like_1', NULL, NULL, NULL, 2),
(15833, NULL, 'cd09680', NULL, NULL, 'Cas10_III', NULL, 'Cas10_III', NULL, NULL, 9196, 2),
(15834, NULL, 'cd04174', NULL, NULL, 'Rnd1_Rho6', NULL, 'Rnd1_Rho6', NULL, NULL, NULL, 2),
(15835, NULL, 'cd05106', NULL, NULL, 'PTKc_CSF-1R', NULL, 'PTKc_CSF-1R', NULL, NULL, NULL, 2),
(15836, NULL, 'cd03017', NULL, NULL, 'PRX_BCP', NULL, 'PRX_BCP', NULL, NULL, NULL, 2),
(15837, NULL, 'cd08462', NULL, NULL, 'PBP2_NodD', NULL, 'PBP2_NodD', NULL, NULL, 30910, 2),
(15838, NULL, 'cd17258', NULL, NULL, 'RMtype1_S_Sau13435ORF2165P-TRD1-CR1_like', NULL, 'RMtype1_S_Sau13435ORF2165P-TRD1-CR1_like', NULL, NULL, NULL, 2),
(15839, NULL, 'cd03514', NULL, NULL, 'CrtR_beta-carotene-hydroxylase', NULL, 'CrtR_beta-carotene-hydroxylase', NULL, NULL, NULL, 2),
(15840, NULL, 'cd17356', NULL, NULL, 'MFS_HXT', NULL, 'MFS_HXT', NULL, NULL, NULL, 2),
(15841, NULL, 'cd04141', NULL, NULL, 'Rit_Rin_Ric', NULL, 'Rit_Rin_Ric', NULL, NULL, NULL, 2),
(15842, NULL, 'cd09711', NULL, NULL, 'Csc1_I-D', NULL, 'Csc1_I-D', NULL, NULL, NULL, 2);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(15843, NULL, 'cd18062', NULL, NULL, 'DEXHc_SMARCA4', NULL, 'DEXHc_SMARCA4', NULL, NULL, NULL, 2),
(15844, NULL, 'cd09445', NULL, NULL, 'LIM_Mical_like_2', NULL, 'LIM_Mical_like_2', NULL, NULL, NULL, 2),
(15845, NULL, 'cd01095', NULL, NULL, 'Nitrilotriacetate_monoxgenase', NULL, 'Nitrilotriacetate_monoxgenase', NULL, NULL, 17236, 2),
(15846, NULL, 'cd10484', NULL, NULL, 'EphR_LBD_A6', NULL, 'EphR_LBD_A6', NULL, NULL, 27857, 2),
(15847, NULL, 'cd18187', NULL, NULL, 'BTB_POZ_Kv_KCTD', NULL, 'BTB_POZ_Kv_KCTD', NULL, NULL, NULL, 2),
(15848, NULL, 'cd09290', NULL, NULL, 'Photo-RC_L', NULL, 'Photo-RC_L', NULL, NULL, 6803, 2),
(15849, NULL, 'cd04937', NULL, NULL, 'ACT_AKi-DapG-BS_2', NULL, 'ACT_AKi-DapG-BS_2', NULL, NULL, NULL, 2),
(15850, NULL, 'cd12612', NULL, NULL, 'RRM2_SECp43', NULL, 'RRM2_SECp43', NULL, NULL, 17466, 2),
(15851, NULL, 'cd17980', NULL, NULL, 'DEXHc_DHX35', NULL, 'DEXHc_DHX35', NULL, NULL, NULL, 2),
(15852, NULL, 'cd15105', NULL, NULL, '7tmA_MrgprA', NULL, '7tmA_MrgprA', NULL, NULL, NULL, 2),
(15853, NULL, 'cd21647', NULL, NULL, 'ORF4b_NS3c-betaCoV', NULL, 'ORF4b_NS3c-betaCoV', NULL, NULL, NULL, 2),
(15854, NULL, 'cd17664', NULL, NULL, 'Mce1_N', NULL, 'Mce1_N', NULL, NULL, NULL, 2),
(15855, NULL, 'cd05169', NULL, NULL, 'PIKKc_TOR', NULL, 'PIKKc_TOR', NULL, NULL, NULL, 2),
(15856, NULL, 'cd17354', NULL, NULL, 'MFS_Mch1p_like', NULL, 'MFS_Mch1p_like', NULL, NULL, NULL, 2),
(15857, NULL, 'cd14541', NULL, NULL, 'PTPc-N3_4', NULL, 'PTPc-N3_4', NULL, NULL, NULL, 2),
(15858, NULL, 'cd04197', NULL, NULL, 'eIF-2B_epsilon_N', NULL, 'eIF-2B_epsilon_N', NULL, NULL, 31751, 2),
(15859, NULL, 'cd15469', NULL, NULL, 'HN', NULL, 'HN', NULL, NULL, 19624, 2),
(15860, NULL, 'cd19854', NULL, NULL, 'DSRM_DHX9_rpt1', NULL, 'DSRM_DHX9_rpt1', NULL, NULL, 35297, 2),
(15861, NULL, 'cd09810', NULL, NULL, 'LPOR_like_SDR_c_like', NULL, 'LPOR_like_SDR_c_like', NULL, NULL, NULL, 2),
(15862, NULL, 'cd02907', NULL, NULL, 'Macro_Af1521_BAL-like', NULL, 'Macro_Af1521_BAL-like', NULL, NULL, NULL, 2),
(15863, NULL, 'cd08299', NULL, NULL, 'alcohol_DH_class_I_II_IV', NULL, 'alcohol_DH_class_I_II_IV', NULL, NULL, NULL, 2),
(15864, NULL, 'cd09597', NULL, NULL, 'M4_TLP', NULL, 'M4_TLP', NULL, NULL, NULL, 2),
(15865, NULL, 'cd18209', NULL, NULL, 'BTB_POZ_ZBTB21_ZNF295', NULL, 'BTB_POZ_ZBTB21_ZNF295', NULL, NULL, NULL, 2),
(15866, NULL, 'cd04907', NULL, NULL, 'ACT_ThrD-I_2', NULL, 'ACT_ThrD-I_2', NULL, NULL, NULL, 2),
(15867, NULL, 'cd02219', NULL, NULL, 'cupin_YjlB-like', NULL, 'cupin_YjlB-like', NULL, NULL, NULL, 2),
(15868, NULL, 'cd16427', NULL, NULL, 'TraM-like', NULL, 'TraM-like', NULL, NULL, NULL, 2),
(15869, NULL, 'cd18672', NULL, NULL, 'PIN_FAM120B-like', NULL, 'PIN_FAM120B-like', NULL, NULL, NULL, 2),
(15870, NULL, 'cd09510', NULL, NULL, 'SAM_aveugle-like', NULL, 'SAM_aveugle-like', NULL, NULL, 29108, 2),
(15871, NULL, 'cd15257', NULL, NULL, '7tmB2_GPR128', NULL, '7tmB2_GPR128', NULL, NULL, NULL, 2),
(15872, NULL, 'cd20260', NULL, NULL, 'Myoregulin', NULL, 'Myoregulin', NULL, NULL, NULL, 2),
(15873, NULL, 'cd04586', NULL, NULL, 'CBS_pair_BON_assoc', NULL, 'CBS_pair_BON_assoc', NULL, NULL, NULL, 2),
(15874, NULL, 'cd16795', NULL, NULL, 'dRING_RMD5B', NULL, 'dRING_RMD5B', NULL, NULL, 27773, 2),
(15875, NULL, 'cd08404', NULL, NULL, 'C2B_Synaptotagmin-4', NULL, 'C2B_Synaptotagmin-4', NULL, NULL, NULL, 2),
(15876, NULL, 'cd14237', NULL, NULL, 'GAT_TM1L1', NULL, 'GAT_TM1L1', NULL, NULL, NULL, 2),
(15877, NULL, 'cd20269', NULL, NULL, 'Complex1_LYR_LYRM9', NULL, 'Complex1_LYR_LYRM9', NULL, NULL, 34306, 2),
(15878, NULL, 'cd00490', NULL, NULL, 'Met_repressor_MetJ', NULL, 'Met_repressor_MetJ', NULL, NULL, 1487, 2),
(15879, NULL, 'cd05631', NULL, NULL, 'STKc_GRK4', NULL, 'STKc_GRK4', NULL, NULL, NULL, 2),
(15880, NULL, 'cd02850', NULL, NULL, 'E_set_Cellulase_N', NULL, 'E_set_Cellulase_N', NULL, NULL, 2534, 2),
(15881, NULL, 'cd02787', NULL, NULL, 'MopB_CT_ydeP', NULL, 'MopB_CT_ydeP', NULL, NULL, 32527, 2),
(15882, NULL, 'cd18644', NULL, NULL, 'CD_polycomb', NULL, 'CD_polycomb', NULL, NULL, NULL, 2),
(15883, NULL, 'cd00150', NULL, NULL, 'PlantTI', NULL, 'PlantTI', NULL, NULL, 6742, 2);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(15884, NULL, 'cd15877', NULL, NULL, 'SNARE_TSNARE1', NULL, 'SNARE_TSNARE1', NULL, NULL, NULL, 2),
(15885, NULL, 'cd01040', NULL, NULL, 'Mb-like', NULL, 'Mb-like', NULL, NULL, 35313, 2),
(15886, NULL, 'cd05970', NULL, NULL, 'MACS_AAE_MA_like', NULL, 'MACS_AAE_MA_like', NULL, NULL, NULL, 2),
(15887, NULL, 'cd00292', NULL, NULL, 'EF1B', NULL, 'EF1B', NULL, NULL, 11032, 2),
(15888, NULL, 'cd01223', NULL, NULL, 'PH_Vav', NULL, 'PH_Vav', NULL, NULL, 31572, 2),
(15889, NULL, 'cd03724', NULL, NULL, 'SOCS_ASB5', NULL, 'SOCS_ASB5', NULL, NULL, 30759, 2),
(15890, NULL, 'cd04720', NULL, NULL, 'BAH_Orc1p_Yeast', NULL, 'BAH_Orc1p_Yeast', NULL, NULL, NULL, 2),
(15891, NULL, 'cd07083', NULL, NULL, 'ALDH_P5CDH', NULL, 'ALDH_P5CDH', NULL, NULL, NULL, 2),
(15892, NULL, 'cd07626', NULL, NULL, 'BAR_SNX9_like', NULL, 'BAR_SNX9_like', NULL, NULL, NULL, 2),
(15893, NULL, 'cd19174', NULL, NULL, 'SET_ASH1L', NULL, 'SET_ASH1L', NULL, NULL, NULL, 2),
(15894, NULL, 'cd16343', NULL, NULL, 'LMWPTP', NULL, 'LMWPTP', NULL, NULL, NULL, 2),
(15895, NULL, 'cd03443', NULL, NULL, 'PaaI_thioesterase', NULL, 'PaaI_thioesterase', NULL, NULL, NULL, 2),
(15896, NULL, 'cd07212', NULL, NULL, 'Pat_PNPLA9', NULL, 'Pat_PNPLA9', NULL, NULL, NULL, 2),
(15897, NULL, 'cd03796', NULL, NULL, 'GT4_PIG-A-like', NULL, 'GT4_PIG-A-like', NULL, NULL, 31310, 2),
(15898, NULL, 'cd06595', NULL, NULL, 'GH31_u1', NULL, 'GH31_u1', NULL, NULL, NULL, 2),
(15899, NULL, 'cd04082', NULL, NULL, 'CBM35_pectate_lyase-like', NULL, 'CBM35_pectate_lyase-like', NULL, NULL, NULL, 2),
(15900, NULL, 'cd19748', NULL, NULL, 'bHLH-O_HEY1', NULL, 'bHLH-O_HEY1', NULL, NULL, NULL, 2),
(15901, NULL, 'cd05470', NULL, NULL, 'pepsin_retropepsin_like', NULL, 'pepsin_retropepsin_like', NULL, NULL, NULL, 2),
(15902, NULL, 'cd18160', NULL, NULL, 'REC_CpdR_CckA-like', NULL, 'REC_CpdR_CckA-like', NULL, NULL, NULL, 2),
(15903, NULL, 'cd19016', NULL, NULL, 'LGIC_ECD_nAChR_A3', NULL, 'LGIC_ECD_nAChR_A3', NULL, NULL, NULL, 2),
(15904, NULL, 'cd00610', NULL, NULL, 'OAT_like', NULL, 'OAT_like', NULL, NULL, 5655, 2),
(15905, NULL, 'cd01473', NULL, NULL, 'vWA_CTRP', NULL, 'vWA_CTRP', NULL, NULL, NULL, 2),
(15906, NULL, 'cd15125', NULL, NULL, '7tmA_NMBR', NULL, '7tmA_NMBR', NULL, NULL, NULL, 2),
(15907, NULL, 'cd18532', NULL, NULL, 'BACK_RHOBTB3', NULL, 'BACK_RHOBTB3', NULL, NULL, NULL, 2),
(15908, NULL, 'cd02117', NULL, NULL, 'NifH-like', NULL, 'NifH-like', NULL, NULL, NULL, 2),
(15909, NULL, 'cd14622', NULL, NULL, 'R-PTPc-E-2', NULL, 'R-PTPc-E-2', NULL, NULL, NULL, 2),
(15910, NULL, 'cd08511', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_5', NULL, 'PBP2_NikA_DppA_OppA_like_5', NULL, NULL, NULL, 2),
(15911, NULL, 'cd14509', NULL, NULL, 'PTP_PTEN', NULL, 'PTP_PTEN', NULL, NULL, 36924, 2),
(15912, NULL, 'cd08504', NULL, NULL, 'PBP2_OppA', NULL, 'PBP2_OppA', NULL, NULL, NULL, 2),
(15913, NULL, 'cd14881', NULL, NULL, 'MYSc_Myo20', NULL, 'MYSc_Myo20', NULL, NULL, 31758, 2),
(15914, NULL, 'cd04179', NULL, NULL, 'DPM_DPG-synthase_like', NULL, 'DPM_DPG-synthase_like', NULL, NULL, NULL, 2),
(15915, NULL, 'cd19210', NULL, NULL, 'SET_NSD1', NULL, 'SET_NSD1', NULL, NULL, NULL, 2),
(15916, NULL, 'cd03198', NULL, NULL, 'GST_C_CLIC', NULL, 'GST_C_CLIC', NULL, NULL, NULL, 2),
(15917, NULL, 'cd17352', NULL, NULL, 'MFS_MCT_SLC16', NULL, 'MFS_MCT_SLC16', NULL, NULL, NULL, 2),
(15918, NULL, 'cd04222', NULL, NULL, 'CuRO_1_ceruloplasmin', NULL, 'CuRO_1_ceruloplasmin', NULL, NULL, NULL, 2),
(15919, NULL, 'cd16102', NULL, NULL, 'RAWUL_PCGF_like', NULL, 'RAWUL_PCGF_like', NULL, NULL, NULL, 2),
(15920, NULL, 'cd03343', NULL, NULL, 'cpn60', NULL, 'cpn60', NULL, NULL, 11675, 2),
(15921, NULL, 'cd09429', NULL, NULL, 'LIM3_FHL1', NULL, 'LIM3_FHL1', NULL, NULL, NULL, 2),
(15922, NULL, 'cd07138', NULL, NULL, 'ALDH_CddD_SSP0762', NULL, 'ALDH_CddD_SSP0762', NULL, NULL, NULL, 2),
(15923, NULL, 'cd21403', NULL, NULL, 'ZBD_tv_SF1_Hel-like', NULL, 'ZBD_tv_SF1_Hel-like', NULL, NULL, 33808, 2),
(15924, NULL, 'cd15594', NULL, NULL, 'PHD2_KMT2C', NULL, 'PHD2_KMT2C', NULL, NULL, NULL, 2),
(15925, NULL, 'cd19921', NULL, NULL, 'REC_1_GGDEF', NULL, 'REC_1_GGDEF', NULL, NULL, NULL, 2);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(15926, NULL, 'cd07977', NULL, NULL, 'TFIIE_beta_winged_helix', NULL, 'TFIIE_beta_winged_helix', NULL, NULL, 1581, 2),
(15927, NULL, 'cd03677', NULL, NULL, 'MM_CoA_mutase_beta', NULL, 'MM_CoA_mutase_beta', NULL, NULL, NULL, 2),
(15928, NULL, 'cd07945', NULL, NULL, 'DRE_TIM_CMS', NULL, 'DRE_TIM_CMS', NULL, NULL, NULL, 2),
(15929, NULL, 'cd15134', NULL, NULL, '7tmA_capaR', NULL, '7tmA_capaR', NULL, NULL, NULL, 2),
(15930, NULL, 'cd11882', NULL, NULL, 'SH3_GRAF-like', NULL, 'SH3_GRAF-like', NULL, NULL, NULL, 2),
(15931, NULL, 'cd17208', NULL, NULL, 'FERM_F1_DdMyo7_like', NULL, 'FERM_F1_DdMyo7_like', NULL, NULL, NULL, 2),
(15932, NULL, 'cd18998', NULL, NULL, 'LGIC_ECD_GABAAR_A', NULL, 'LGIC_ECD_GABAAR_A', NULL, NULL, NULL, 2),
(15933, NULL, 'cd11811', NULL, NULL, 'SH3_CHK', NULL, 'SH3_CHK', NULL, NULL, NULL, 2),
(15934, NULL, 'cd18994', NULL, NULL, 'LGIC_ECD_ZAC', NULL, 'LGIC_ECD_ZAC', NULL, NULL, NULL, 2),
(15935, NULL, 'cd11464', NULL, NULL, 'bHLH_TS_TWIST', NULL, 'bHLH_TS_TWIST', NULL, NULL, NULL, 2),
(15936, NULL, 'cd08362', NULL, NULL, 'BphC5-RrK37_N_like', NULL, 'BphC5-RrK37_N_like', NULL, NULL, NULL, 2),
(15937, NULL, 'cd11948', NULL, NULL, 'SH3_GRAP_N', NULL, 'SH3_GRAP_N', NULL, NULL, 28356, 2),
(15938, NULL, 'cd17922', NULL, NULL, 'DEXHc_LHR-like', NULL, 'DEXHc_LHR-like', NULL, NULL, NULL, 2),
(15939, NULL, 'cd02863', NULL, NULL, 'Ubiquinol_oxidase_III', NULL, 'Ubiquinol_oxidase_III', NULL, NULL, 32002, 2),
(15940, NULL, 'cd14266', NULL, NULL, 'UDPK_IM_PAP2_like', NULL, 'UDPK_IM_PAP2_like', NULL, NULL, NULL, 2),
(15941, NULL, 'cd06431', NULL, NULL, 'GT8_LARGE_C', NULL, 'GT8_LARGE_C', NULL, NULL, NULL, 2),
(15942, NULL, 'cd13613', NULL, NULL, 'PBP2_Opu_like_2', NULL, 'PBP2_Opu_like_2', NULL, NULL, NULL, 2),
(15943, NULL, 'cd15844', NULL, NULL, 'SNARE_syntaxin5', NULL, 'SNARE_syntaxin5', NULL, NULL, NULL, 2),
(15944, NULL, 'cd10910', NULL, NULL, 'PIN_limkain_b1_N_like', NULL, 'PIN_limkain_b1_N_like', NULL, NULL, NULL, 2),
(15945, NULL, 'cd05193', NULL, NULL, 'AR_like_SDR_e', NULL, 'AR_like_SDR_e', NULL, NULL, NULL, 2),
(15946, NULL, 'cd12499', NULL, NULL, 'RRM_EcCsdA_like', NULL, 'RRM_EcCsdA_like', NULL, NULL, 13631, 2),
(15947, NULL, 'cd14888', NULL, NULL, 'MYSc_Myo27', NULL, 'MYSc_Myo27', NULL, NULL, NULL, 2),
(15948, NULL, 'cd05945', NULL, NULL, 'DltA', NULL, 'DltA', NULL, NULL, 36098, 2),
(15949, NULL, 'cd06939', NULL, NULL, 'NR_LBD_ROR_like', NULL, 'NR_LBD_ROR_like', NULL, NULL, NULL, 2),
(15950, NULL, 'cd19206', NULL, NULL, 'SET_KMT2A', NULL, 'SET_KMT2A', NULL, NULL, NULL, 2),
(15951, NULL, 'cd03330', NULL, NULL, 'Macro_Ttha0132-like', NULL, 'Macro_Ttha0132-like', NULL, NULL, NULL, 2),
(15952, NULL, 'cd00051', NULL, NULL, 'EFh', NULL, 'EFh', NULL, NULL, 1368, 2),
(15953, NULL, 'cd04140', NULL, NULL, 'ARHI_like', NULL, 'ARHI_like', NULL, NULL, NULL, 2),
(15954, NULL, 'cd04515', NULL, NULL, 'Alpha_kinase', NULL, 'Alpha_kinase', NULL, NULL, NULL, 2),
(15955, NULL, 'cd03129', NULL, NULL, 'GAT1_Peptidase_E_like', NULL, 'GAT1_Peptidase_E_like', NULL, NULL, NULL, 2),
(15956, NULL, 'cd03455', NULL, NULL, 'SAV4209', NULL, 'SAV4209', NULL, NULL, NULL, 2),
(15957, NULL, 'cd18103', NULL, NULL, 'SpoU-like_RlmB', NULL, 'SpoU-like_RlmB', NULL, NULL, NULL, 2),
(15958, NULL, 'cd02057', NULL, NULL, 'serpinB5_maspin', NULL, 'serpinB5_maspin', NULL, NULL, 31735, 2),
(15959, NULL, 'cd09323', NULL, NULL, 'TDT_SLAC1_like', NULL, 'TDT_SLAC1_like', NULL, NULL, NULL, 2),
(15960, NULL, 'cd13586', NULL, NULL, 'PBP2_Maltose_binding_like', NULL, 'PBP2_Maltose_binding_like', NULL, NULL, NULL, 2),
(15961, NULL, 'cd03692', NULL, NULL, 'mtIF2_IVc', NULL, 'mtIF2_IVc', NULL, NULL, NULL, 2),
(15962, NULL, 'cd08342', NULL, NULL, 'HPPD_N_like', NULL, 'HPPD_N_like', NULL, NULL, 30413, 2),
(15963, NULL, 'cd19200', NULL, NULL, 'PR-SET_PRDM16_PRDM3', NULL, 'PR-SET_PRDM16_PRDM3', NULL, NULL, NULL, 2),
(15964, NULL, 'cd13181', NULL, NULL, 'RanBD_NUP2', NULL, 'RanBD_NUP2', NULL, NULL, NULL, 2),
(15965, NULL, 'cd17880', NULL, NULL, 'D-Ala-D-Ala_dipeptidase', NULL, 'D-Ala-D-Ala_dipeptidase', NULL, NULL, NULL, 2),
(15966, NULL, 'cd09088', NULL, NULL, 'Ape2-like_AP-endo', NULL, 'Ape2-like_AP-endo', NULL, NULL, NULL, 2);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(15967, NULL, 'cd12901', NULL, NULL, 'SPRY_PRY_FSD1', NULL, 'SPRY_PRY_FSD1', NULL, NULL, 28478, 2),
(15968, NULL, 'cd18800', NULL, NULL, 'SF2_C_EcoR124I-like', NULL, 'SF2_C_EcoR124I-like', NULL, NULL, NULL, 2),
(15969, NULL, 'cd14689', NULL, NULL, 'bZIP_CREB3', NULL, 'bZIP_CREB3', NULL, NULL, NULL, 2),
(15970, NULL, 'cd05568', NULL, NULL, 'PTS_IIB_bgl_like', NULL, 'PTS_IIB_bgl_like', NULL, NULL, NULL, 2),
(15971, NULL, 'cd18512', NULL, NULL, 'BACK_KLHL2_Mayven', NULL, 'BACK_KLHL2_Mayven', NULL, NULL, NULL, 2),
(15972, NULL, 'cd08012', NULL, NULL, 'M20_ArgE-related', NULL, 'M20_ArgE-related', NULL, NULL, NULL, 2),
(15973, NULL, 'cd07654', NULL, NULL, 'F-BAR_FCHSD', NULL, 'F-BAR_FCHSD', NULL, NULL, NULL, 2),
(15974, NULL, 'cd09289', NULL, NULL, 'Photosystem-II_D1', NULL, 'Photosystem-II_D1', NULL, NULL, 6523, 2),
(15975, NULL, 'cd19982', NULL, NULL, 'PBP1_ABC_ligand_binding-like', NULL, 'PBP1_ABC_ligand_binding-like', NULL, NULL, NULL, 2),
(15976, NULL, 'cd04863', NULL, NULL, 'MtLigD_Pol_like', NULL, 'MtLigD_Pol_like', NULL, NULL, 27402, 2),
(15977, NULL, 'cd08477', NULL, NULL, 'PBP2_CrgA_like_8', NULL, 'PBP2_CrgA_like_8', NULL, NULL, NULL, 2),
(15978, NULL, 'cd18495', NULL, NULL, 'BACK_GCL', NULL, 'BACK_GCL', NULL, NULL, NULL, 2),
(15979, NULL, 'cd19830', NULL, NULL, 'Bbox2_TIF1g_C-VI', NULL, 'Bbox2_TIF1g_C-VI', NULL, NULL, NULL, 2),
(15980, NULL, 'cd00039', NULL, NULL, 'COLIPASE', NULL, 'COLIPASE', NULL, NULL, 2227, 2),
(15981, NULL, 'cd08729', NULL, NULL, 'RGS_PX', NULL, 'RGS_PX', NULL, NULL, NULL, 2),
(15982, NULL, 'cd16004', NULL, NULL, '7tmA_SKR_NK2R', NULL, '7tmA_SKR_NK2R', NULL, NULL, NULL, 2),
(15983, NULL, 'cd07062', NULL, NULL, 'Peptidase_S66_mccF_like', NULL, 'Peptidase_S66_mccF_like', NULL, NULL, NULL, 2),
(15984, NULL, 'cd04786', NULL, NULL, 'HTH_MerR-like_sg7', NULL, 'HTH_MerR-like_sg7', NULL, NULL, NULL, 2),
(15985, NULL, 'cd04588', NULL, NULL, 'CBS_pair_archHTH_assoc', NULL, 'CBS_pair_archHTH_assoc', NULL, NULL, NULL, 2),
(15986, NULL, 'cd08632', NULL, NULL, 'PI-PLCc_eta1', NULL, 'PI-PLCc_eta1', NULL, NULL, NULL, 2),
(15987, NULL, 'cd09433', NULL, NULL, 'LIM4_FHL2', NULL, 'LIM4_FHL2', NULL, NULL, NULL, 2),
(15988, NULL, 'cd18677', NULL, NULL, 'PIN_MjVapC2-VapC6_like', NULL, 'PIN_MjVapC2-VapC6_like', NULL, NULL, NULL, 2),
(15989, NULL, 'cd04663', NULL, NULL, 'Nudix_Hydrolase_6', NULL, 'Nudix_Hydrolase_6', NULL, NULL, NULL, 2),
(15990, NULL, 'cd05878', NULL, NULL, 'Ig_Aggrecan_like', NULL, 'Ig_Aggrecan_like', NULL, NULL, NULL, 2),
(15991, NULL, 'cd01346', NULL, NULL, 'Maltoporin-like', NULL, 'Maltoporin-like', NULL, NULL, 3069, 2),
(15992, NULL, 'cd16385', NULL, NULL, 'IcmL', NULL, 'IcmL', NULL, NULL, 15377, 2),
(15993, NULL, 'cd07242', NULL, NULL, 'VOC_BsYqjT', NULL, 'VOC_BsYqjT', NULL, NULL, NULL, 2),
(15994, NULL, 'cd12707', NULL, NULL, 'RRM_LARP4', NULL, 'RRM_LARP4', NULL, NULL, 17393, 2),
(15995, NULL, 'cd00012', NULL, NULL, 'NBD_sugar-kinase_HSP70_actin', NULL, 'NBD_sugar-kinase_HSP70_actin', NULL, NULL, NULL, 2),
(15996, NULL, 'cd08896', NULL, NULL, 'SRPBCC_CalC_Aha1-like_3', NULL, 'SRPBCC_CalC_Aha1-like_3', NULL, NULL, NULL, 2),
(15997, NULL, 'cd18809', NULL, NULL, 'SF1_C_RecD', NULL, 'SF1_C_RecD', NULL, NULL, NULL, 2),
(15998, NULL, 'cd03385', NULL, NULL, 'PAP2_BcrC_like', NULL, 'PAP2_BcrC_like', NULL, NULL, 29320, 2),
(15999, NULL, 'cd01275', NULL, NULL, 'FHIT', NULL, 'FHIT', NULL, NULL, 29189, 2),
(16000, NULL, 'cd02657', NULL, NULL, 'Peptidase_C19A', NULL, 'Peptidase_C19A', NULL, NULL, NULL, 2),
(16001, NULL, 'cd07476', NULL, NULL, 'Peptidases_S8_thiazoline_oxidase_subtilisin-li...', NULL, 'Peptidases_S8_thiazoline_oxidase_subtilisin-like_protease', NULL, NULL, 8163, 2),
(16002, NULL, 'cd12546', NULL, NULL, 'RRM_RBM43', NULL, 'RRM_RBM43', NULL, NULL, NULL, 2),
(16003, NULL, 'cd04079', NULL, NULL, 'CBM6_agarase-like', NULL, 'CBM6_agarase-like', NULL, NULL, NULL, 2),
(16004, NULL, 'cd06215', NULL, NULL, 'FNR_iron_sulfur_binding_1', NULL, 'FNR_iron_sulfur_binding_1', NULL, NULL, NULL, 2),
(16005, NULL, 'cd15409', NULL, NULL, '7tmA_OR5H-like', NULL, '7tmA_OR5H-like', NULL, NULL, NULL, 2);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(16006, NULL, 'cd03759', NULL, NULL, 'proteasome_beta_type_3', NULL, 'proteasome_beta_type_3', NULL, NULL, 29107, 2),
(16007, NULL, 'cd08460', NULL, NULL, 'PBP2_DntR_like_1', NULL, 'PBP2_DntR_like_1', NULL, NULL, NULL, 2),
(16008, NULL, 'cd03158', NULL, NULL, 'penumbra_like_LEL', NULL, 'penumbra_like_LEL', NULL, NULL, NULL, 2),
(16009, NULL, 'cd07732', NULL, NULL, 'metallo-hydrolase-like_MBL-fold', NULL, 'metallo-hydrolase-like_MBL-fold', NULL, NULL, NULL, 2),
(16010, NULL, 'cd18485', NULL, NULL, 'BACK_KBTBD12', NULL, 'BACK_KBTBD12', NULL, NULL, NULL, 2),
(16011, NULL, 'cd00476', NULL, NULL, 'SAICAR_synt', NULL, 'SAICAR_synt', NULL, NULL, NULL, 2),
(16012, NULL, 'cd09807', NULL, NULL, 'retinol-DH_like_SDR_c', NULL, 'retinol-DH_like_SDR_c', NULL, NULL, NULL, 2),
(16013, NULL, 'cd04595', NULL, NULL, 'CBS_pair_DHH_polyA_Pol_assoc', NULL, 'CBS_pair_DHH_polyA_Pol_assoc', NULL, NULL, NULL, 2),
(16014, NULL, 'cd06931', NULL, NULL, 'NR_LBD_HNF4_like', NULL, 'NR_LBD_HNF4_like', NULL, NULL, NULL, 2),
(16015, NULL, 'cd15742', NULL, NULL, 'FYVE_FGD5', NULL, 'FYVE_FGD5', NULL, NULL, NULL, 2),
(16016, NULL, 'cd02655', NULL, NULL, 'RNAP_beta''_C', NULL, 'RNAP_beta''_C', NULL, NULL, NULL, 2),
(16017, NULL, 'cd01902', NULL, NULL, 'Ntn_CGH', NULL, 'Ntn_CGH', NULL, NULL, NULL, 2),
(16018, NULL, 'cd04730', NULL, NULL, 'NPD_like', NULL, 'NPD_like', NULL, NULL, 2775, 2),
(16019, NULL, 'cd17549', NULL, NULL, 'REC_DctD-like', NULL, 'REC_DctD-like', NULL, NULL, NULL, 2),
(16020, NULL, 'cd12907', NULL, NULL, 'SPRY_Fbox', NULL, 'SPRY_Fbox', NULL, NULL, 32415, 2),
(16021, NULL, 'cd18307', NULL, NULL, 'BTB_POZ_calicin', NULL, 'BTB_POZ_calicin', NULL, NULL, NULL, 2),
(16022, NULL, 'cd07232', NULL, NULL, 'Pat_PLPL', NULL, 'Pat_PLPL', NULL, NULL, NULL, 2),
(16023, NULL, 'cd00651', NULL, NULL, 'TFold', NULL, 'TFold', NULL, NULL, NULL, 2),
(16024, NULL, 'cd05529', NULL, NULL, 'Bromo_WDR9_I_like', NULL, 'Bromo_WDR9_I_like', NULL, NULL, NULL, 2),
(16025, NULL, 'cd00463', NULL, NULL, 'Ribosomal_L31e', NULL, 'Ribosomal_L31e', NULL, NULL, 2781, 2),
(16026, NULL, 'cd09437', NULL, NULL, 'LIM3_LPP', NULL, 'LIM3_LPP', NULL, NULL, NULL, 2),
(16027, NULL, 'cd07897', NULL, NULL, 'Adenylation_DNA_ligase_Bac1', NULL, 'Adenylation_DNA_ligase_Bac1', NULL, NULL, NULL, 2),
(16028, NULL, 'cd13890', NULL, NULL, 'CuRO_3_CueO_FtsP', NULL, 'CuRO_3_CueO_FtsP', NULL, NULL, NULL, 2),
(16029, NULL, 'cd07397', NULL, NULL, 'MPP_NostocDevT-like', NULL, 'MPP_NostocDevT-like', NULL, NULL, 22548, 2),
(16030, NULL, 'cd15326', NULL, NULL, '7tmA_alpha1B_AR', NULL, '7tmA_alpha1B_AR', NULL, NULL, NULL, 2),
(16031, NULL, 'cd19123', NULL, NULL, 'AKR_AKR3G1', NULL, 'AKR_AKR3G1', NULL, NULL, 34984, 2),
(16032, NULL, 'cd14940', NULL, NULL, '7tmE_cAMP_R_Slime_mold', NULL, '7tmE_cAMP_R_Slime_mold', NULL, NULL, NULL, 2),
(16033, NULL, 'cd09905', NULL, NULL, 'H3TH_GEN1', NULL, 'H3TH_GEN1', NULL, NULL, NULL, 2),
(16034, NULL, 'cd06378', NULL, NULL, 'PBP1_iGluR_NMDA_NR2', NULL, 'PBP1_iGluR_NMDA_NR2', NULL, NULL, NULL, 2),
(16035, NULL, 'cd05086', NULL, NULL, 'PTKc_Aatyk2', NULL, 'PTKc_Aatyk2', NULL, NULL, NULL, 2),
(16036, NULL, 'cd06546', NULL, NULL, 'GH18_CTS3_chitinase', NULL, 'GH18_CTS3_chitinase', NULL, NULL, NULL, 2),
(16037, NULL, 'cd18686', NULL, NULL, 'PIN_VapC-like', NULL, 'PIN_VapC-like', NULL, NULL, NULL, 2),
(16038, NULL, 'cd15147', NULL, NULL, '7tmA_PAFR', NULL, '7tmA_PAFR', NULL, NULL, NULL, 2),
(16039, NULL, 'cd16754', NULL, NULL, 'RING-HC_MID2', NULL, 'RING-HC_MID2', NULL, NULL, NULL, 2),
(16040, NULL, 'cd17169', NULL, NULL, 'FERM_F1_FRMPD3', NULL, 'FERM_F1_FRMPD3', NULL, NULL, NULL, 2),
(16041, NULL, 'cd04722', NULL, NULL, 'TIM_phosphate_binding', NULL, 'TIM_phosphate_binding', NULL, NULL, NULL, 2),
(16042, NULL, 'cd08389', NULL, NULL, 'C2A_Synaptotagmin-14_16', NULL, 'C2A_Synaptotagmin-14_16', NULL, NULL, NULL, 2),
(16043, NULL, 'cd16952', NULL, NULL, 'HATPase_EcPhoR-like', NULL, 'HATPase_EcPhoR-like', NULL, NULL, NULL, 2),
(16044, NULL, 'cd01740', NULL, NULL, 'GATase1_FGAR_AT', NULL, 'GATase1_FGAR_AT', NULL, NULL, NULL, 2),
(16045, NULL, 'cd04896', NULL, NULL, 'ACT_ACR-like_3', NULL, 'ACT_ACR-like_3', NULL, NULL, NULL, 2);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(16046, NULL, 'cd18614', NULL, NULL, 'GH130', NULL, 'GH130', NULL, NULL, NULL, 2),
(16047, NULL, 'cd07100', NULL, NULL, 'ALDH_SSADH1_GabD1', NULL, 'ALDH_SSADH1_GabD1', NULL, NULL, 36293, 2),
(16048, NULL, 'cd05729', NULL, NULL, 'Ig2_FGFR_like', NULL, 'Ig2_FGFR_like', NULL, NULL, NULL, 2),
(16049, NULL, 'cd14296', NULL, NULL, 'UBA1_scUBP14_like', NULL, 'UBA1_scUBP14_like', NULL, NULL, NULL, 2),
(16050, NULL, 'cd11852', NULL, NULL, 'SH3_Kalirin_1', NULL, 'SH3_Kalirin_1', NULL, NULL, NULL, 2),
(16051, NULL, 'cd01286', NULL, NULL, 'deoxycytidylate_deaminase', NULL, 'deoxycytidylate_deaminase', NULL, NULL, 15955, 2),
(16052, NULL, 'cd13722', NULL, NULL, 'PBP2_iGluR_Kainate_GluR5', NULL, 'PBP2_iGluR_Kainate_GluR5', NULL, NULL, NULL, 2),
(16053, NULL, 'cd14302', NULL, NULL, 'UBA_UBXN1', NULL, 'UBA_UBXN1', NULL, NULL, 30278, 2),
(16054, NULL, 'cd07297', NULL, NULL, 'PX_PLD2', NULL, 'PX_PLD2', NULL, NULL, NULL, 2),
(16055, NULL, 'cd07779', NULL, NULL, 'FGGY_ygcE_like', NULL, 'FGGY_ygcE_like', NULL, NULL, NULL, 2),
(16056, NULL, 'cd11355', NULL, NULL, 'AmyAc_Sucrose_phosphorylase', NULL, 'AmyAc_Sucrose_phosphorylase', NULL, NULL, 16272, 2),
(16057, NULL, 'cd01860', NULL, NULL, 'Rab5_related', NULL, 'Rab5_related', NULL, NULL, NULL, 2),
(16058, NULL, 'cd12392', NULL, NULL, 'RRM2_SART3', NULL, 'RRM2_SART3', NULL, NULL, 21424, 2),
(16059, NULL, 'cd10324', NULL, NULL, 'SLC6sbd', NULL, 'SLC6sbd', NULL, NULL, NULL, 2),
(16060, NULL, 'cd10539', NULL, NULL, 'SET_ATXR5_6-like', NULL, 'SET_ATXR5_6-like', NULL, NULL, NULL, 2),
(16061, NULL, 'cd17012', NULL, NULL, 'CID_RPRD1B', NULL, 'CID_RPRD1B', NULL, NULL, NULL, 2),
(16062, NULL, 'cd02108', NULL, NULL, 'bact_SO_family_Moco', NULL, 'bact_SO_family_Moco', NULL, NULL, NULL, 2),
(16063, NULL, 'cd08856', NULL, NULL, 'ArfGap_ARAP2', NULL, 'ArfGap_ARAP2', NULL, NULL, NULL, 2),
(16064, NULL, 'cd06890', NULL, NULL, 'PX_Bem1p', NULL, 'PX_Bem1p', NULL, NULL, 30086, 2),
(16065, NULL, 'cd15357', NULL, NULL, '7tmA_NMU-R2', NULL, '7tmA_NMU-R2', NULL, NULL, NULL, 2),
(16066, NULL, 'cd16686', NULL, NULL, 'RING-H2_UBR2', NULL, 'RING-H2_UBR2', NULL, NULL, NULL, 2),
(16067, NULL, 'cd01306', NULL, NULL, 'PhnM', NULL, 'PhnM', NULL, NULL, 11539, 2),
(16068, NULL, 'cd02395', NULL, NULL, 'SF1_like-KH', NULL, 'SF1_like-KH', NULL, NULL, NULL, 2),
(16069, NULL, 'cd16590', NULL, NULL, 'RING-HC_TRIM4_C-IV_like', NULL, 'RING-HC_TRIM4_C-IV_like', NULL, NULL, NULL, 2),
(16070, NULL, 'cd08740', NULL, NULL, 'RGS_RGS11', NULL, 'RGS_RGS11', NULL, NULL, NULL, 2),
(16071, NULL, 'cd08836', NULL, NULL, 'ArfGap_AGAP', NULL, 'ArfGap_AGAP', NULL, NULL, NULL, 2),
(16072, NULL, 'cd04482', NULL, NULL, 'RPA2_OBF_like', NULL, 'RPA2_OBF_like', NULL, NULL, NULL, 2),
(16073, NULL, 'cd09388', NULL, NULL, 'LIM1_LMO1_LMO3', NULL, 'LIM1_LMO1_LMO3', NULL, NULL, NULL, 2),
(16074, NULL, 'cd18715', NULL, NULL, 'PIN_VapC-like', NULL, 'PIN_VapC-like', NULL, NULL, NULL, 2),
(16075, NULL, 'cd17068', NULL, NULL, 'RBD_PLEKHG5', NULL, 'RBD_PLEKHG5', NULL, NULL, NULL, 2),
(16076, NULL, 'cd13385', NULL, NULL, 'PH_Gab3', NULL, 'PH_Gab3', NULL, NULL, NULL, 2),
(16077, NULL, 'cd18304', NULL, NULL, 'BTB_POZ_M2BP', NULL, 'BTB_POZ_M2BP', NULL, NULL, NULL, 2),
(16078, NULL, 'cd03337', NULL, NULL, 'TCP1_gamma', NULL, 'TCP1_gamma', NULL, NULL, 11914, 2),
(16079, NULL, 'cd01436', NULL, NULL, 'Dipth_tox_like', NULL, 'Dipth_tox_like', NULL, NULL, 8928, 2),
(16080, NULL, 'cd06822', NULL, NULL, 'PLPDE_III_YBL036c_euk', NULL, 'PLPDE_III_YBL036c_euk', NULL, NULL, NULL, 2),
(16081, NULL, 'cd13643', NULL, NULL, 'PBP2_BCP_2', NULL, 'PBP2_BCP_2', NULL, NULL, NULL, 2),
(16082, NULL, 'cd19735', NULL, NULL, 'bHLH-PAS_dCLOCK', NULL, 'bHLH-PAS_dCLOCK', NULL, NULL, NULL, 2),
(16083, NULL, 'cd17759', NULL, NULL, 'MCM8', NULL, 'MCM8', NULL, NULL, NULL, 2),
(16084, NULL, 'cd03753', NULL, NULL, 'proteasome_alpha_type_5', NULL, 'proteasome_alpha_type_5', NULL, NULL, 29417, 2),
(16085, NULL, 'cd10522', NULL, NULL, 'SET_LegAS4-like', NULL, 'SET_LegAS4-like', NULL, NULL, 35391, 2),
(16086, NULL, 'cd09087', NULL, NULL, 'Ape1-like_AP-endo', NULL, 'Ape1-like_AP-endo', NULL, NULL, NULL, 2);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(16087, NULL, 'cd17476', NULL, NULL, 'MFS_Amf1_MDR_like', NULL, 'MFS_Amf1_MDR_like', NULL, NULL, NULL, 2),
(16088, NULL, 'cd01796', NULL, NULL, 'Ubl_Ddi1_like', NULL, 'Ubl_Ddi1_like', NULL, NULL, 31111, 2),
(16089, NULL, 'cd10397', NULL, NULL, 'SH2_Tec_Btk', NULL, 'SH2_Tec_Btk', NULL, NULL, NULL, 2),
(16090, NULL, 'cd05198', NULL, NULL, 'formate_dh_like', NULL, 'formate_dh_like', NULL, NULL, NULL, 2),
(16091, NULL, 'cd18073', NULL, NULL, 'DEXHc_RIG-I_DDX58', NULL, 'DEXHc_RIG-I_DDX58', NULL, NULL, NULL, 2),
(16092, NULL, 'cd10529', NULL, NULL, 'SET_SETD5-like', NULL, 'SET_SETD5-like', NULL, NULL, NULL, 2),
(16093, NULL, 'cd18499', NULL, NULL, 'BACK_RHOBTB', NULL, 'BACK_RHOBTB', NULL, NULL, NULL, 2),
(16094, NULL, 'cd08725', NULL, NULL, 'RGS_RGS22_4', NULL, 'RGS_RGS22_4', NULL, NULL, NULL, 2),
(16095, NULL, 'cd15567', NULL, NULL, 'PHD4_NSD', NULL, 'PHD4_NSD', NULL, NULL, NULL, 2),
(16096, NULL, 'cd00227', NULL, NULL, 'CPT', NULL, 'CPT', NULL, NULL, 12011, 2),
(16097, NULL, 'cd18455', NULL, NULL, 'BACK_KLHL16_gigaxonin', NULL, 'BACK_KLHL16_gigaxonin', NULL, NULL, NULL, 2),
(16098, NULL, 'cd18582', NULL, NULL, 'ABC_6TM_ATM1_ABCB7', NULL, 'ABC_6TM_ATM1_ABCB7', NULL, NULL, NULL, 2),
(16099, NULL, 'cd16875', NULL, NULL, 'ARID_KDM5C_5D', NULL, 'ARID_KDM5C_5D', NULL, NULL, NULL, 2),
(16100, NULL, 'cd19333', NULL, NULL, 'Wnt_Wnt1', NULL, 'Wnt_Wnt1', NULL, NULL, NULL, 2),
(16101, NULL, 'cd01886', NULL, NULL, 'EF-G', NULL, 'EF-G', NULL, NULL, NULL, 2),
(16102, NULL, 'cd02780', NULL, NULL, 'MopB_CT_Tetrathionate_Arsenate-R', NULL, 'MopB_CT_Tetrathionate_Arsenate-R', NULL, NULL, 31998, 2),
(16103, NULL, 'cd12654', NULL, NULL, 'RRM3_HuB', NULL, 'RRM3_HuB', NULL, NULL, 11189, 2),
(16104, NULL, 'cd12741', NULL, NULL, 'RRM2_Fusilli', NULL, 'RRM2_Fusilli', NULL, NULL, 31164, 2),
(16105, NULL, 'cd03740', NULL, NULL, 'SOCS_SOCS6', NULL, 'SOCS_SOCS6', NULL, NULL, 27726, 2),
(16106, NULL, 'cd16298', NULL, NULL, 'SNM1A-like_MBL-fold', NULL, 'SNM1A-like_MBL-fold', NULL, NULL, NULL, 2),
(16107, NULL, 'cd00368', NULL, NULL, 'Molybdopterin-Binding', NULL, 'Molybdopterin-Binding', NULL, NULL, NULL, 2),
(16108, NULL, 'cd04917', NULL, NULL, 'ACT_AKiii-LysC-EC_2', NULL, 'ACT_AKiii-LysC-EC_2', NULL, NULL, NULL, 2),
(16109, NULL, 'cd11719', NULL, NULL, 'FANC', NULL, 'FANC', NULL, NULL, NULL, 2),
(16110, NULL, 'cd15205', NULL, NULL, '7tmA_QRFPR', NULL, '7tmA_QRFPR', NULL, NULL, NULL, 2),
(16111, NULL, 'cd00707', NULL, NULL, 'Pancreat_lipase_like', NULL, 'Pancreat_lipase_like', NULL, NULL, 31361, 2),
(16112, NULL, 'cd13687', NULL, NULL, 'PBP2_iGluR_NMDA', NULL, 'PBP2_iGluR_NMDA', NULL, NULL, NULL, 2),
(16113, NULL, 'cd16284', NULL, NULL, 'UlaG-like_MBL-fold', NULL, 'UlaG-like_MBL-fold', NULL, NULL, NULL, 2),
(16114, NULL, 'cd11319', NULL, NULL, 'AmyAc_euk_AmyA', NULL, 'AmyAc_euk_AmyA', NULL, NULL, NULL, 2),
(16115, NULL, 'cd03132', NULL, NULL, 'GATase1_catalase', NULL, 'GATase1_catalase', NULL, NULL, 29999, 2),
(16116, NULL, 'cd07229', NULL, NULL, 'Pat_TGL3_like', NULL, 'Pat_TGL3_like', NULL, NULL, NULL, 2),
(16117, NULL, 'cd11980', NULL, NULL, 'SH3_VAV2_1', NULL, 'SH3_VAV2_1', NULL, NULL, 27615, 2),
(16118, NULL, 'cd14980', NULL, NULL, '7tmA_Glycoprotein_LRR_R-like', NULL, '7tmA_Glycoprotein_LRR_R-like', NULL, NULL, NULL, 2),
(16119, NULL, 'cd00565', NULL, NULL, 'Ubl_ThiS', NULL, 'Ubl_ThiS', NULL, NULL, NULL, 2),
(16120, NULL, 'cd09725', NULL, NULL, 'Cas2_I_II_III', NULL, 'Cas2_I_II_III', NULL, NULL, 10800, 2),
(16121, NULL, 'cd13443', NULL, NULL, 'CDI_inhibitor_Bp1026b_like', NULL, 'CDI_inhibitor_Bp1026b_like', NULL, NULL, 29096, 2),
(16122, NULL, 'cd07631', NULL, NULL, 'BAR_APPL1', NULL, 'BAR_APPL1', NULL, NULL, 32598, 2),
(16123, NULL, 'cd00192', NULL, NULL, 'PTKc', NULL, 'PTKc', NULL, NULL, NULL, 2),
(16124, NULL, 'cd12345', NULL, NULL, 'RRM2_SECp43_like', NULL, 'RRM2_SECp43_like', NULL, NULL, NULL, 2),
(16125, NULL, 'cd17441', NULL, NULL, 'MFS_SVOP', NULL, 'MFS_SVOP', NULL, NULL, NULL, 2),
(16126, NULL, 'cd06908', NULL, NULL, 'M14_AGBL4_like', NULL, 'M14_AGBL4_like', NULL, NULL, NULL, 2),
(16127, NULL, 'cd18336', NULL, NULL, 'BTB_POZ_KLHL4', NULL, 'BTB_POZ_KLHL4', NULL, NULL, NULL, 2);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(16128, NULL, 'cd19128', NULL, NULL, 'AKR_GlAR-like', NULL, 'AKR_GlAR-like', NULL, NULL, NULL, 2),
(16129, NULL, 'cd11785', NULL, NULL, 'SH3_SH3RF_C', NULL, 'SH3_SH3RF_C', NULL, NULL, 28726, 2),
(16130, NULL, 'cd12967', NULL, NULL, 'CBM_SusE-F_like_u1', NULL, 'CBM_SusE-F_like_u1', NULL, NULL, NULL, 2),
(16131, NULL, 'cd03080', NULL, NULL, 'GST_N_Metaxin_like', NULL, 'GST_N_Metaxin_like', NULL, NULL, NULL, 2),
(16132, NULL, 'cd03577', NULL, NULL, 'NTR_TIMP_like', NULL, 'NTR_TIMP_like', NULL, NULL, NULL, 2),
(16133, NULL, 'cd09737', NULL, NULL, 'Csy3_I-F', NULL, 'Csy3_I-F', NULL, NULL, NULL, 2),
(16134, NULL, 'cd16712', NULL, NULL, 'RING-HC_DTX3L', NULL, 'RING-HC_DTX3L', NULL, NULL, 35421, 2),
(16135, NULL, 'cd02515', NULL, NULL, 'Glyco_transf_6', NULL, 'Glyco_transf_6', NULL, NULL, NULL, 2),
(16136, NULL, 'cd11006', NULL, NULL, 'M35_peptidyl-Lys_like', NULL, 'M35_peptidyl-Lys_like', NULL, NULL, 9940, 2),
(16137, NULL, 'cd13966', NULL, NULL, 'PT_UbiA_4', NULL, 'PT_UbiA_4', NULL, NULL, NULL, 2),
(16138, NULL, 'cd05826', NULL, NULL, 'Sortase_B', NULL, 'Sortase_B', NULL, NULL, 13386, 2),
(16139, NULL, 'cd03370', NULL, NULL, 'nitroreductase', NULL, 'nitroreductase', NULL, NULL, NULL, 2),
(16140, NULL, 'cd05745', NULL, NULL, 'Ig3_Peroxidasin', NULL, 'Ig3_Peroxidasin', NULL, NULL, NULL, 2),
(16141, NULL, 'cd14138', NULL, NULL, 'PTKc_Wee1a', NULL, 'PTKc_Wee1a', NULL, NULL, NULL, 2),
(16142, NULL, 'cd17713', NULL, NULL, 'BRCT_polymerase_mu_like', NULL, 'BRCT_polymerase_mu_like', NULL, NULL, NULL, 2),
(16143, NULL, 'cd04473', NULL, NULL, 'S1_RecJ_like', NULL, 'S1_RecJ_like', NULL, NULL, NULL, 2),
(16144, NULL, 'cd13678', NULL, NULL, 'PBP2_TRAP_DctP10', NULL, 'PBP2_TRAP_DctP10', NULL, NULL, NULL, 2),
(16145, NULL, 'cd02697', NULL, NULL, 'M20_like', NULL, 'M20_like', NULL, NULL, NULL, 2),
(16146, NULL, 'cd16777', NULL, NULL, 'mRING-HC-C4C4_RBR_RNF144A', NULL, 'mRING-HC-C4C4_RBR_RNF144A', NULL, NULL, NULL, 2),
(16147, NULL, 'cd19747', NULL, NULL, 'bHLH_TS_ASCL5', NULL, 'bHLH_TS_ASCL5', NULL, NULL, NULL, 2),
(16148, NULL, 'cd02424', NULL, NULL, 'Peptidase_C39E', NULL, 'Peptidase_C39E', NULL, NULL, NULL, 2),
(16149, NULL, 'cd05896', NULL, NULL, 'Ig1_IL1RAPL-1_like', NULL, 'Ig1_IL1RAPL-1_like', NULL, NULL, NULL, 2),
(16150, NULL, 'cd19886', NULL, NULL, 'DSRM_STAU2_rpt4', NULL, 'DSRM_STAU2_rpt4', NULL, NULL, 34482, 2),
(16151, NULL, 'cd17126', NULL, NULL, 'Ubl_HR23A', NULL, 'Ubl_HR23A', NULL, NULL, NULL, 2),
(16152, NULL, 'cd00872', NULL, NULL, 'PI3Ka_I', NULL, 'PI3Ka_I', NULL, NULL, NULL, 2),
(16153, NULL, 'cd03071', NULL, NULL, 'PDI_b''_NRX', NULL, 'PDI_b''_NRX', NULL, NULL, 30845, 2),
(16154, NULL, 'cd07431', NULL, NULL, 'PHP_PolIIIA', NULL, 'PHP_PolIIIA', NULL, NULL, NULL, 2),
(16155, NULL, 'cd05117', NULL, NULL, 'STKc_CAMK', NULL, 'STKc_CAMK', NULL, NULL, NULL, 2),
(16156, NULL, 'cd07104', NULL, NULL, 'ALDH_BenzADH-like', NULL, 'ALDH_BenzADH-like', NULL, NULL, NULL, 2),
(16157, NULL, 'cd12297', NULL, NULL, 'RRM2_Prp24', NULL, 'RRM2_Prp24', NULL, NULL, 6015, 2),
(16158, NULL, 'cd18443', NULL, NULL, 'BRCT_DNTT', NULL, 'BRCT_DNTT', NULL, NULL, NULL, 2),
(16159, NULL, 'cd03593', NULL, NULL, 'CLECT_NK_receptors_like', NULL, 'CLECT_NK_receptors_like', NULL, NULL, 10576, 2),
(16160, NULL, 'cd08808', NULL, NULL, 'CARD_CARD11_CARMA1', NULL, 'CARD_CARD11_CARMA1', NULL, NULL, 33939, 2),
(16161, NULL, 'cd04611', NULL, NULL, 'CBS_pair_GGDEF_PAS_repeat2', NULL, 'CBS_pair_GGDEF_PAS_repeat2', NULL, NULL, NULL, 2),
(16162, NULL, 'cd15805', NULL, NULL, 'RIG-I_C', NULL, 'RIG-I_C', NULL, NULL, NULL, 2),
(16163, NULL, 'cd03241', NULL, NULL, 'ABC_RecN', NULL, 'ABC_RecN', NULL, NULL, NULL, 2),
(16164, NULL, 'cd07985', NULL, NULL, 'LPLAT_GPAT', NULL, 'LPLAT_GPAT', NULL, NULL, NULL, 2),
(16165, NULL, 'cd00893', NULL, NULL, 'PI4Kc_III', NULL, 'PI4Kc_III', NULL, NULL, NULL, 2),
(16166, NULL, 'cd12888', NULL, NULL, 'SPRY_PRY_TRIM7_like', NULL, 'SPRY_PRY_TRIM7_like', NULL, NULL, NULL, 2),
(16167, NULL, 'cd17930', NULL, NULL, 'DEXHc_cas3', NULL, 'DEXHc_cas3', NULL, NULL, NULL, 2),
(16168, NULL, 'cd12420', NULL, NULL, 'RRM_RBPMS_like', NULL, 'RRM_RBPMS_like', NULL, NULL, NULL, 2);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(16169, NULL, 'cd15362', NULL, NULL, '7tmA_LGR6', NULL, '7tmA_LGR6', NULL, NULL, NULL, 2),
(16170, NULL, 'cd09933', NULL, NULL, 'SH2_Src_family', NULL, 'SH2_Src_family', NULL, NULL, NULL, 2),
(16171, NULL, 'cd07750', NULL, NULL, 'PolyPPase_VTC_like', NULL, 'PolyPPase_VTC_like', NULL, NULL, NULL, 2),
(16172, NULL, 'cd05274', NULL, NULL, 'KR_FAS_SDR_x', NULL, 'KR_FAS_SDR_x', NULL, NULL, NULL, 2),
(16173, NULL, 'cd11646', NULL, NULL, 'Precorrin_3B_C17_MT', NULL, 'Precorrin_3B_C17_MT', NULL, NULL, 5656, 2),
(16174, NULL, 'cd17263', NULL, NULL, 'RMtype1_S_AbaB8300I-TRD1-CR1_like', NULL, 'RMtype1_S_AbaB8300I-TRD1-CR1_like', NULL, NULL, NULL, 2),
(16175, NULL, 'cd01844', NULL, NULL, 'SGNH_hydrolase_like_6', NULL, 'SGNH_hydrolase_like_6', NULL, NULL, NULL, 2),
(16176, NULL, 'cd06610', NULL, NULL, 'STKc_OSR1_SPAK', NULL, 'STKc_OSR1_SPAK', NULL, NULL, NULL, 2),
(16177, NULL, 'cd03259', NULL, NULL, 'ABC_Carb_Solutes_like', NULL, 'ABC_Carb_Solutes_like', NULL, NULL, 13005, 2),
(16178, NULL, 'cd19186', NULL, NULL, 'SET_Suv4-20', NULL, 'SET_Suv4-20', NULL, NULL, 35233, 2),
(16179, NULL, 'cd03382', NULL, NULL, 'PAP2_dolichyldiphosphatase', NULL, 'PAP2_dolichyldiphosphatase', NULL, NULL, 27157, 2),
(16180, NULL, 'cd12657', NULL, NULL, 'RRM1_hnRNPM', NULL, 'RRM1_hnRNPM', NULL, NULL, NULL, 2),
(16181, NULL, 'cd00042', NULL, NULL, 'CY', NULL, 'CY', NULL, NULL, 2507, 2),
(16182, NULL, 'cd15730', NULL, NULL, 'FYVE_EEA1', NULL, 'FYVE_EEA1', NULL, NULL, NULL, 2),
(16183, NULL, 'cd11270', NULL, NULL, 'Sema_6E', NULL, 'Sema_6E', NULL, NULL, NULL, 2),
(16184, NULL, 'cd15466', NULL, NULL, 'CLU-central', NULL, 'CLU-central', NULL, NULL, 27667, 2),
(16185, NULL, 'cd13405', NULL, NULL, 'TNFRSF14_teleost', NULL, 'TNFRSF14_teleost', NULL, NULL, NULL, 2),
(16186, NULL, 'cd18407', NULL, NULL, 'BTB_POZ_KCNA6', NULL, 'BTB_POZ_KCNA6', NULL, NULL, NULL, 2),
(16187, NULL, 'cd12876', NULL, NULL, 'SPRY_SOCS3', NULL, 'SPRY_SOCS3', NULL, NULL, 30675, 2),
(16188, NULL, 'cd07910', NULL, NULL, 'MiaE', NULL, 'MiaE', NULL, NULL, 9264, 2),
(16189, NULL, 'cd14374', NULL, NULL, 'CUE1_Cue2p_like', NULL, 'CUE1_Cue2p_like', NULL, NULL, 30892, 2),
(16190, NULL, 'cd18970', NULL, NULL, 'CD_POL_like', NULL, 'CD_POL_like', NULL, NULL, NULL, 2),
(16191, NULL, 'cd11972', NULL, NULL, 'SH3_Abi2', NULL, 'SH3_Abi2', NULL, NULL, 27575, 2),
(16192, NULL, 'cd01527', NULL, NULL, 'RHOD_YgaP', NULL, 'RHOD_YgaP', NULL, NULL, NULL, 2),
(16193, NULL, 'cd03488', NULL, NULL, 'Topoisomer_IB_N_htopoI_like', NULL, 'Topoisomer_IB_N_htopoI_like', NULL, NULL, NULL, 2),
(16194, NULL, 'cd12606', NULL, NULL, 'RRM1_RBM4', NULL, 'RRM1_RBM4', NULL, NULL, 29132, 2),
(16195, NULL, 'cd03511', NULL, NULL, 'Rhizopine-oxygenase-like', NULL, 'Rhizopine-oxygenase-like', NULL, NULL, 27282, 2),
(16196, NULL, 'cd08298', NULL, NULL, 'CAD2', NULL, 'CAD2', NULL, NULL, 8830, 2),
(16197, NULL, 'cd15737', NULL, NULL, 'FYVE2_Vac1p_like', NULL, 'FYVE2_Vac1p_like', NULL, NULL, NULL, 2),
(16198, NULL, 'cd06613', NULL, NULL, 'STKc_MAP4K3_like', NULL, 'STKc_MAP4K3_like', NULL, NULL, NULL, 2),
(16199, NULL, 'cd11446', NULL, NULL, 'bHLH_AtILR3_like', NULL, 'bHLH_AtILR3_like', NULL, NULL, NULL, 2),
(16200, NULL, 'cd17749', NULL, NULL, 'BRCT_TopBP1_rpt4', NULL, 'BRCT_TopBP1_rpt4', NULL, NULL, NULL, 2),
(16201, NULL, 'cd16319', NULL, NULL, 'MraZ', NULL, 'MraZ', NULL, NULL, NULL, 2),
(16202, NULL, 'cd16088', NULL, NULL, 'IgV_PD1', NULL, 'IgV_PD1', NULL, NULL, NULL, 2),
(16203, NULL, 'cd15683', NULL, NULL, 'PHD_ING2', NULL, 'PHD_ING2', NULL, NULL, 30683, 2),
(16204, NULL, 'cd14480', NULL, NULL, 'SPX_VTC2_like', NULL, 'SPX_VTC2_like', NULL, NULL, NULL, 2),
(16205, NULL, 'cd04780', NULL, NULL, 'HTH_MerR-like_sg5', NULL, 'HTH_MerR-like_sg5', NULL, NULL, NULL, 2),
(16206, NULL, 'cd12665', NULL, NULL, 'RRM2_RAVER1', NULL, 'RRM2_RAVER1', NULL, NULL, NULL, 2),
(16207, NULL, 'cd00099', NULL, NULL, 'IgV', NULL, 'IgV', NULL, NULL, NULL, 2),
(16208, NULL, 'cd03734', NULL, NULL, 'SOCS_CIS1', NULL, 'SOCS_CIS1', NULL, NULL, NULL, 2),
(16209, NULL, 'cd18210', NULL, NULL, 'BTB_POZ_ZBTB22_BING1', NULL, 'BTB_POZ_ZBTB22_BING1', NULL, NULL, NULL, 2);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(16210, NULL, 'cd11981', NULL, NULL, 'SH3_VAV3_1', NULL, 'SH3_VAV3_1', NULL, NULL, NULL, 2),
(16211, NULL, 'cd05384', NULL, NULL, 'CAP_PRY1-like', NULL, 'CAP_PRY1-like', NULL, NULL, NULL, 2),
(16212, NULL, 'cd08176', NULL, NULL, 'LPO', NULL, 'LPO', NULL, NULL, NULL, 2),
(16213, NULL, 'cd13970', NULL, NULL, 'ABC1_ADCK3', NULL, 'ABC1_ADCK3', NULL, NULL, 18580, 2),
(16214, NULL, 'cd16395', NULL, NULL, 'Srx', NULL, 'Srx', NULL, NULL, NULL, 2),
(16215, NULL, 'cd06130', NULL, NULL, 'DNA_pol_III_epsilon_like', NULL, 'DNA_pol_III_epsilon_like', NULL, NULL, NULL, 2),
(16216, NULL, 'cd13569', NULL, NULL, 'PBP2_TAXI_TRAP_like_1', NULL, 'PBP2_TAXI_TRAP_like_1', NULL, NULL, NULL, 2),
(16217, NULL, 'cd06277', NULL, NULL, 'PBP1_LacI-like', NULL, 'PBP1_LacI-like', NULL, NULL, NULL, 2),
(16218, NULL, 'cd13713', NULL, NULL, 'PBP2_Cystine_like_1', NULL, 'PBP2_Cystine_like_1', NULL, NULL, NULL, 2),
(16219, NULL, 'cd02650', NULL, NULL, 'nuc_hydro_CaPnhB', NULL, 'nuc_hydro_CaPnhB', NULL, NULL, NULL, 2),
(16220, NULL, 'cd09029', NULL, NULL, 'ArfGap_ArfGap2', NULL, 'ArfGap_ArfGap2', NULL, NULL, NULL, 2),
(16221, NULL, 'cd17768', NULL, NULL, 'adenosylhopane_nucleosidase_HpnG-like', NULL, 'adenosylhopane_nucleosidase_HpnG-like', NULL, NULL, NULL, 2),
(16222, NULL, 'cd18703', NULL, NULL, 'PIN_VapC-like', NULL, 'PIN_VapC-like', NULL, NULL, NULL, 2),
(16223, NULL, 'cd13738', NULL, NULL, 'SPRY_PRY_TRIM14', NULL, 'SPRY_PRY_TRIM14', NULL, NULL, 37529, 2),
(16224, NULL, 'cd03799', NULL, NULL, 'GT4_AmsK-like', NULL, 'GT4_AmsK-like', NULL, NULL, NULL, 2),
(16225, NULL, 'cd12113', NULL, NULL, 'PHP_PolIIIA_DnaE3', NULL, 'PHP_PolIIIA_DnaE3', NULL, NULL, NULL, 2),
(16226, NULL, 'cd16386', NULL, NULL, 'TcpC_N', NULL, 'TcpC_N', NULL, NULL, NULL, 2),
(16227, NULL, 'cd19883', NULL, NULL, 'DSRM_STAU1_rpt3', NULL, 'DSRM_STAU1_rpt3', NULL, NULL, 34210, 2),
(16228, NULL, 'cd17633', NULL, NULL, 'AFD_YhfT-like', NULL, 'AFD_YhfT-like', NULL, NULL, NULL, 2),
(16229, NULL, 'cd01960', NULL, NULL, 'nsLTP1', NULL, 'nsLTP1', NULL, NULL, NULL, 2),
(16230, NULL, 'cd15254', NULL, NULL, '7tmB2_GPR116_Ig-Hepta', NULL, '7tmB2_GPR116_Ig-Hepta', NULL, NULL, NULL, 2),
(16231, NULL, 'cd07628', NULL, NULL, 'BAR_Atg24p', NULL, 'BAR_Atg24p', NULL, NULL, NULL, 2),
(16232, NULL, 'cd07720', NULL, NULL, 'OPHC2-like_MBL-fold', NULL, 'OPHC2-like_MBL-fold', NULL, NULL, NULL, 2),
(16233, NULL, 'cd14752', NULL, NULL, 'GH31_N', NULL, 'GH31_N', NULL, NULL, NULL, 2),
(16234, NULL, 'cd19591', NULL, NULL, 'serpin_like', NULL, 'serpin_like', NULL, NULL, NULL, 2),
(16235, NULL, 'cd03507', NULL, NULL, 'Delta12-FADS-like', NULL, 'Delta12-FADS-like', NULL, NULL, NULL, 2),
(16236, NULL, 'cd10348', NULL, NULL, 'SH2_Cterm_shark_like', NULL, 'SH2_Cterm_shark_like', NULL, NULL, NULL, 2),
(16237, NULL, 'cd04756', NULL, NULL, 'Commd8', NULL, 'Commd8', NULL, NULL, NULL, 2),
(16238, NULL, 'cd15605', NULL, NULL, 'PHD1_Lid_like', NULL, 'PHD1_Lid_like', NULL, NULL, NULL, 2),
(16239, NULL, 'cd01572', NULL, NULL, 'QPRTase', NULL, 'QPRTase', NULL, NULL, 5540, 2),
(16240, NULL, 'cd04467', NULL, NULL, 'S1_aIF5A', NULL, 'S1_aIF5A', NULL, NULL, NULL, 2),
(16241, NULL, 'cd10566', NULL, NULL, 'MDM2_like', NULL, 'MDM2_like', NULL, NULL, NULL, 2),
(16242, NULL, 'cd03234', NULL, NULL, 'ABCG_White', NULL, 'ABCG_White', NULL, NULL, NULL, 2),
(16243, NULL, 'cd14665', NULL, NULL, 'STKc_SnRK2-3', NULL, 'STKc_SnRK2-3', NULL, NULL, NULL, 2),
(16244, NULL, 'cd13874', NULL, NULL, 'CuRO_2_CopA', NULL, 'CuRO_2_CopA', NULL, NULL, 3104, 2),
(16245, NULL, 'cd02601', NULL, NULL, 'HAD_Eya', NULL, 'HAD_Eya', NULL, NULL, 36053, 2),
(16246, NULL, 'cd19188', NULL, NULL, 'PR-SET_PRDM2', NULL, 'PR-SET_PRDM2', NULL, NULL, 34795, 2),
(16247, NULL, 'cd19975', NULL, NULL, 'PBP1_CcpA-like', NULL, 'PBP1_CcpA-like', NULL, NULL, NULL, 2),
(16248, NULL, 'cd11506', NULL, NULL, 'SLC6sbd_GAT1', NULL, 'SLC6sbd_GAT1', NULL, NULL, 7242, 2),
(16249, NULL, 'cd05639', NULL, NULL, 'M18', NULL, 'M18', NULL, NULL, NULL, 2),
(16250, NULL, 'cd03262', NULL, NULL, 'ABC_HisP_GlnQ', NULL, 'ABC_HisP_GlnQ', NULL, NULL, NULL, 2),
(16251, NULL, 'cd08183', NULL, NULL, 'Fe-ADH-like', NULL, 'Fe-ADH-like', NULL, NULL, NULL, 2);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(16252, NULL, 'cd01878', NULL, NULL, 'HflX', NULL, 'HflX', NULL, NULL, 21566, 2),
(16253, NULL, 'cd18764', NULL, NULL, 'PIN_MtVapC3-like', NULL, 'PIN_MtVapC3-like', NULL, NULL, NULL, 2),
(16254, NULL, 'cd11504', NULL, NULL, 'SLC5sbd_SMVT', NULL, 'SLC5sbd_SMVT', NULL, NULL, NULL, 2),
(16255, NULL, 'cd14708', NULL, NULL, 'bZIP_HBP1b-like', NULL, 'bZIP_HBP1b-like', NULL, NULL, NULL, 2),
(16256, NULL, 'cd17106', NULL, NULL, 'FERM_F1_EPB41L', NULL, 'FERM_F1_EPB41L', NULL, NULL, NULL, 2),
(16257, NULL, 'cd10415', NULL, NULL, 'SH2_Grb10', NULL, 'SH2_Grb10', NULL, NULL, 28341, 2),
(16258, NULL, 'cd07197', NULL, NULL, 'nitrilase', NULL, 'nitrilase', NULL, NULL, NULL, 2),
(16259, NULL, 'cd13216', NULL, NULL, 'PH-GRAM2_AGT26', NULL, 'PH-GRAM2_AGT26', NULL, NULL, NULL, 2),
(16260, NULL, 'cd19343', NULL, NULL, 'Wnt_Wnt11', NULL, 'Wnt_Wnt11', NULL, NULL, NULL, 2),
(16261, NULL, 'cd13147', NULL, NULL, 'MATE_MJ0709_like', NULL, 'MATE_MJ0709_like', NULL, NULL, NULL, 2),
(16262, NULL, 'cd15014', NULL, NULL, '7tm_TAS2R40', NULL, '7tm_TAS2R40', NULL, NULL, NULL, 2),
(16263, NULL, 'cd08791', NULL, NULL, 'DED_DEDD2', NULL, 'DED_DEDD2', NULL, NULL, NULL, 2),
(16264, NULL, 'cd05143', NULL, NULL, 'Barstar_SaI14_like', NULL, 'Barstar_SaI14_like', NULL, NULL, NULL, 2),
(16265, NULL, 'cd15946', NULL, NULL, '7tmA_OR1330-like', NULL, '7tmA_OR1330-like', NULL, NULL, NULL, 2),
(16266, NULL, 'cd08220', NULL, NULL, 'STKc_Nek8', NULL, 'STKc_Nek8', NULL, NULL, 34881, 2),
(16267, NULL, 'cd14487', NULL, NULL, 'AlgX_C', NULL, 'AlgX_C', NULL, NULL, 25754, 2),
(16268, NULL, 'cd15153', NULL, NULL, '7tmA_P2Y10', NULL, '7tmA_P2Y10', NULL, NULL, NULL, 2),
(16269, NULL, 'cd05472', NULL, NULL, 'cnd41_like', NULL, 'cnd41_like', NULL, NULL, 27147, 2),
(16270, NULL, 'cd05629', NULL, NULL, 'STKc_NDR_like_fungal', NULL, 'STKc_NDR_like_fungal', NULL, NULL, NULL, 2),
(16271, NULL, 'cd12883', NULL, NULL, 'SPRY_RING', NULL, 'SPRY_RING', NULL, NULL, 31749, 2),
(16272, NULL, 'cd13741', NULL, NULL, 'SPRY_PRY_TRIM41', NULL, 'SPRY_PRY_TRIM41', NULL, NULL, 35336, 2),
(16273, NULL, 'cd07383', NULL, NULL, 'MPP_Dcr2', NULL, 'MPP_Dcr2', NULL, NULL, NULL, 2),
(16274, NULL, 'cd19096', NULL, NULL, 'AKR_Fe-S_oxidoreductase', NULL, 'AKR_Fe-S_oxidoreductase', NULL, NULL, NULL, 2),
(16275, NULL, 'cd00452', NULL, NULL, 'KDPG_aldolase', NULL, 'KDPG_aldolase', NULL, NULL, 4580, 2),
(16276, NULL, 'cd07573', NULL, NULL, 'CPA', NULL, 'CPA', NULL, NULL, NULL, 2),
(16277, NULL, 'cd01078', NULL, NULL, 'NAD_bind_H4MPT_DH', NULL, 'NAD_bind_H4MPT_DH', NULL, NULL, 19665, 2),
(16278, NULL, 'cd06401', NULL, NULL, 'PB1_TFG', NULL, 'PB1_TFG', NULL, NULL, 19123, 2),
(16279, NULL, 'cd08329', NULL, NULL, 'CARD_BIRC2_BIRC3', NULL, 'CARD_BIRC2_BIRC3', NULL, NULL, NULL, 2),
(16280, NULL, 'cd03148', NULL, NULL, 'GATase1_EcHsp31_like', NULL, 'GATase1_EcHsp31_like', NULL, NULL, NULL, 2),
(16281, NULL, 'cd02892', NULL, NULL, 'SQCY_1', NULL, 'SQCY_1', NULL, NULL, 20195, 2),
(16282, NULL, 'cd18745', NULL, NULL, 'PIN_VapC4-5_FitB-like', NULL, 'PIN_VapC4-5_FitB-like', NULL, NULL, NULL, 2),
(16283, NULL, 'cd11658', NULL, NULL, 'SANT_DMAP1_like', NULL, 'SANT_DMAP1_like', NULL, NULL, NULL, 2),
(16284, NULL, 'cd15287', NULL, NULL, '7tmC_TAS1R2a-like', NULL, '7tmC_TAS1R2a-like', NULL, NULL, NULL, 2),
(16285, NULL, 'cd12945', NULL, NULL, 'NOPS_NONA_like', NULL, 'NOPS_NONA_like', NULL, NULL, NULL, 2),
(16286, NULL, 'cd16855', NULL, NULL, 'STAT5_CCD', NULL, 'STAT5_CCD', NULL, NULL, NULL, 2),
(16287, NULL, 'cd15364', NULL, NULL, '7tmA_GPR132_G2A', NULL, '7tmA_GPR132_G2A', NULL, NULL, NULL, 2),
(16288, NULL, 'cd16998', NULL, NULL, 'VHS_GGA_fungi', NULL, 'VHS_GGA_fungi', NULL, NULL, NULL, 2),
(16289, NULL, 'cd14455', NULL, NULL, 'CuRO_6_FV_like', NULL, 'CuRO_6_FV_like', NULL, NULL, NULL, 2),
(16290, NULL, 'cd18111', NULL, NULL, 'ATP-synt_V_A-type_alpha_C', NULL, 'ATP-synt_V_A-type_alpha_C', NULL, NULL, NULL, 2),
(16291, NULL, 'cd04604', NULL, NULL, 'CBS_pair_SIS_assoc', NULL, 'CBS_pair_SIS_assoc', NULL, NULL, NULL, 2),
(16292, NULL, 'cd17720', NULL, NULL, 'BRCT_Bard1_rpt2', NULL, 'BRCT_Bard1_rpt2', NULL, NULL, NULL, 2);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(16293, NULL, 'cd09352', NULL, NULL, 'LIM1_Ajuba_like', NULL, 'LIM1_Ajuba_like', NULL, NULL, NULL, 2),
(16294, NULL, 'cd18137', NULL, NULL, 'HLD_clamp_pol_III_gamma_tau', NULL, 'HLD_clamp_pol_III_gamma_tau', NULL, NULL, 35597, 2),
(16295, NULL, 'cd11438', NULL, NULL, 'bHLH-PAS_ARNTL_PASD3', NULL, 'bHLH-PAS_ARNTL_PASD3', NULL, NULL, NULL, 2),
(16296, NULL, 'cd09455', NULL, NULL, 'LIM1_Enigma_like_1', NULL, 'LIM1_Enigma_like_1', NULL, NULL, NULL, 2),
(16297, NULL, 'cd16867', NULL, NULL, 'ARID_ARID3', NULL, 'ARID_ARID3', NULL, NULL, NULL, 2),
(16298, NULL, 'cd09322', NULL, NULL, 'TDT_TehA_like', NULL, 'TDT_TehA_like', NULL, NULL, NULL, 2),
(16299, NULL, 'cd08844', NULL, NULL, 'ArfGap_ADAP2', NULL, 'ArfGap_ADAP2', NULL, NULL, NULL, 2),
(16300, NULL, 'cd12448', NULL, NULL, 'RRM2_gar2', NULL, 'RRM2_gar2', NULL, NULL, 6738, 2),
(16301, NULL, 'cd18387', NULL, NULL, 'BTB_POZ_KCTD1', NULL, 'BTB_POZ_KCTD1', NULL, NULL, NULL, 2),
(16302, NULL, 'cd12838', NULL, NULL, 'Killer_toxin_alpha', NULL, 'Killer_toxin_alpha', NULL, NULL, NULL, 2),
(16303, NULL, 'cd13306', NULL, NULL, 'PH1_AFAP', NULL, 'PH1_AFAP', NULL, NULL, NULL, 2),
(16304, NULL, 'cd18771', NULL, NULL, 'PIN_Mut7-C-like', NULL, 'PIN_Mut7-C-like', NULL, NULL, NULL, 2),
(16305, NULL, 'cd01439', NULL, NULL, 'TCCD_inducible_PARP_like', NULL, 'TCCD_inducible_PARP_like', NULL, NULL, NULL, 2),
(16306, NULL, 'cd06821', NULL, NULL, 'PLPDE_III_D-TA', NULL, 'PLPDE_III_D-TA', NULL, NULL, NULL, 2),
(16307, NULL, 'cd10387', NULL, NULL, 'SH2_SOCS6', NULL, 'SH2_SOCS6', NULL, NULL, 31816, 2),
(16308, NULL, 'cd07451', NULL, NULL, 'CRD_SMO', NULL, 'CRD_SMO', NULL, NULL, 30176, 2),
(16309, NULL, 'cd16349', NULL, NULL, 'VOC_like', NULL, 'VOC_like', NULL, NULL, NULL, 2),
(16310, NULL, 'cd15055', NULL, NULL, '7tmA_TAARs', NULL, '7tmA_TAARs', NULL, NULL, NULL, 2),
(16311, NULL, 'cd09120', NULL, NULL, 'PLDc_DNaseII_1', NULL, 'PLDc_DNaseII_1', NULL, NULL, NULL, 2),
(16312, NULL, 'cd12714', NULL, NULL, 'RRM1_MATR3', NULL, 'RRM1_MATR3', NULL, NULL, 11797, 2),
(16313, NULL, 'cd11813', NULL, NULL, 'SH3_SGSM3', NULL, 'SH3_SGSM3', NULL, NULL, 33166, 2),
(16314, NULL, 'cd00236', NULL, NULL, 'FinO_conjug_rep', NULL, 'FinO_conjug_rep', NULL, NULL, NULL, 2),
(16315, NULL, 'cd04779', NULL, NULL, 'HTH_MerR-like_sg4', NULL, 'HTH_MerR-like_sg4', NULL, NULL, NULL, 2),
(16316, NULL, 'cd19077', NULL, NULL, 'AKR_AKR8A1-2', NULL, 'AKR_AKR8A1-2', NULL, NULL, NULL, 2),
(16317, NULL, 'cd15997', NULL, NULL, '7tmB2_GPR112', NULL, '7tmB2_GPR112', NULL, NULL, NULL, 2),
(16318, NULL, 'cd11473', NULL, NULL, 'W2', NULL, 'W2', NULL, NULL, NULL, 2),
(16319, NULL, 'cd00047', NULL, NULL, 'PTPc', NULL, 'PTPc', NULL, NULL, NULL, 2),
(16320, NULL, 'cd12242', NULL, NULL, 'RRM_SLIRP', NULL, 'RRM_SLIRP', NULL, NULL, 14968, 2),
(16321, NULL, 'cd17049', NULL, NULL, 'Ubl_Sacsin', NULL, 'Ubl_Sacsin', NULL, NULL, NULL, 2),
(16322, NULL, 'cd13211', NULL, NULL, 'PH-GRAM_MTMR9', NULL, 'PH-GRAM_MTMR9', NULL, NULL, NULL, 2),
(16323, NULL, 'cd17282', NULL, NULL, 'RMtype1_S_Eco16444ORF1681_TRD1-CR1_like', NULL, 'RMtype1_S_Eco16444ORF1681_TRD1-CR1_like', NULL, NULL, NULL, 2),
(16324, NULL, 'cd04972', NULL, NULL, 'Ig_TrkABC_d4', NULL, 'Ig_TrkABC_d4', NULL, NULL, NULL, 2),
(16325, NULL, 'cd07210', NULL, NULL, 'Pat_hypo_W_succinogenes_WS1459_like', NULL, 'Pat_hypo_W_succinogenes_WS1459_like', NULL, NULL, NULL, 2),
(16326, NULL, 'cd00608', NULL, NULL, 'GalT', NULL, 'GalT', NULL, NULL, 4254, 2),
(16327, NULL, 'cd14592', NULL, NULL, 'PTP-MTMR1', NULL, 'PTP-MTMR1', NULL, NULL, NULL, 2),
(16328, NULL, 'cd15612', NULL, NULL, 'PHD_OBE1_like', NULL, 'PHD_OBE1_like', NULL, NULL, NULL, 2),
(16329, NULL, 'cd16809', NULL, NULL, 'RING_CH-C4HC3_MARCH3', NULL, 'RING_CH-C4HC3_MARCH3', NULL, NULL, NULL, 2),
(16330, NULL, 'cd04280', NULL, NULL, 'ZnMc_astacin_like', NULL, 'ZnMc_astacin_like', NULL, NULL, 19283, 2),
(16331, NULL, 'cd12106', NULL, NULL, 'PARMER_03128_N', NULL, 'PARMER_03128_N', NULL, NULL, 30935, 2),
(16332, NULL, 'cd14103', NULL, NULL, 'STKc_MLCK', NULL, 'STKc_MLCK', NULL, NULL, NULL, 2),
(16333, NULL, 'cd19902', NULL, NULL, 'DSRM_DRADA', NULL, 'DSRM_DRADA', NULL, NULL, NULL, 2); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(16334, NULL, 'cd00874', NULL, NULL, 'RNA_Cyclase_Class_II', NULL, 'RNA_Cyclase_Class_II', NULL, NULL, NULL, 2),
(16335, NULL, 'cd08680', NULL, NULL, 'C2_Kibra', NULL, 'C2_Kibra', NULL, NULL, 30581, 2),
(16336, NULL, 'cd09670', NULL, NULL, 'Cse2_I-E', NULL, 'Cse2_I-E', NULL, NULL, 11211, 2),
(16337, NULL, 'cd07922', NULL, NULL, 'CarBa', NULL, 'CarBa', NULL, NULL, 11598, 2),
(16338, NULL, 'cd16177', NULL, NULL, 'EFh_HEF_CR', NULL, 'EFh_HEF_CR', NULL, NULL, 24562, 2),
(16339, NULL, 'cd05654', NULL, NULL, 'M20_ArgE_RocB', NULL, 'M20_ArgE_RocB', NULL, NULL, NULL, 2),
(16340, NULL, 'cd07990', NULL, NULL, 'LPLAT_LCLAT1-like', NULL, 'LPLAT_LCLAT1-like', NULL, NULL, NULL, 2),
(16341, NULL, 'cd11348', NULL, NULL, 'AmyAc_2', NULL, 'AmyAc_2', NULL, NULL, NULL, 2),
(16342, NULL, 'cd01252', NULL, NULL, 'PH_GRP1-like', NULL, 'PH_GRP1-like', NULL, NULL, NULL, 2),
(16343, NULL, 'cd15979', NULL, NULL, '7tmA_CCK-BR', NULL, '7tmA_CCK-BR', NULL, NULL, NULL, 2),
(16344, NULL, 'cd07539', NULL, NULL, 'P-type_ATPase', NULL, 'P-type_ATPase', NULL, NULL, NULL, 2),
(16345, NULL, 'cd14215', NULL, NULL, 'PKc_CLK2', NULL, 'PKc_CLK2', NULL, NULL, NULL, 2),
(16346, NULL, 'cd02640', NULL, NULL, 'R3H_NRF', NULL, 'R3H_NRF', NULL, NULL, 12974, 2),
(16347, NULL, 'cd05322', NULL, NULL, 'SDH_SDR_c_like', NULL, 'SDH_SDR_c_like', NULL, NULL, NULL, 2),
(16348, NULL, 'cd01450', NULL, NULL, 'vWFA_subfamily_ECM', NULL, 'vWFA_subfamily_ECM', NULL, NULL, NULL, 2),
(16349, NULL, 'cd06614', NULL, NULL, 'STKc_PAK', NULL, 'STKc_PAK', NULL, NULL, NULL, 2),
(16350, NULL, 'cd16936', NULL, NULL, 'HATPase_RsbW-like', NULL, 'HATPase_RsbW-like', NULL, NULL, NULL, 2),
(16351, NULL, 'cd18320', NULL, NULL, 'BTB_POZ_KBTBD13', NULL, 'BTB_POZ_KBTBD13', NULL, NULL, NULL, 2),
(16352, NULL, 'cd08494', NULL, NULL, 'PBP2_NikA_DppA_OppA_like_6', NULL, 'PBP2_NikA_DppA_OppA_like_6', NULL, NULL, NULL, 2),
(16353, NULL, 'cd02092', NULL, NULL, 'P-type_ATPase_FixI-like', NULL, 'P-type_ATPase_FixI-like', NULL, NULL, NULL, 2),
(16354, NULL, 'cd04148', NULL, NULL, 'RGK', NULL, 'RGK', NULL, NULL, NULL, 2),
(16355, NULL, 'cd01896', NULL, NULL, 'DRG', NULL, 'DRG', NULL, NULL, 36547, 2),
(16356, NULL, 'cd19555', NULL, NULL, 'serpinA7_TBG', NULL, 'serpinA7_TBG', NULL, NULL, NULL, 2),
(16357, NULL, 'cd00224', NULL, NULL, 'Mog1', NULL, 'Mog1', NULL, NULL, 636, 2),
(16358, NULL, 'cd05577', NULL, NULL, 'STKc_GRK', NULL, 'STKc_GRK', NULL, NULL, NULL, 2),
(16359, NULL, 'cd08150', NULL, NULL, 'catalase_like', NULL, 'catalase_like', NULL, NULL, NULL, 2),
(16360, NULL, 'cd02072', NULL, NULL, 'Glm_B12_BD', NULL, 'Glm_B12_BD', NULL, NULL, 5647, 2),
(16361, NULL, 'cd00758', NULL, NULL, 'MoCF_BD', NULL, 'MoCF_BD', NULL, NULL, NULL, 2),
(16362, NULL, 'cd11398', NULL, NULL, 'bHLHzip_scCBP1', NULL, 'bHLHzip_scCBP1', NULL, NULL, NULL, 2),
(16363, NULL, 'cd10813', NULL, NULL, 'GH38N_AMII_Man2C1', NULL, 'GH38N_AMII_Man2C1', NULL, NULL, NULL, 2),
(16364, NULL, 'cd06418', NULL, NULL, 'GH25_BacA-like', NULL, 'GH25_BacA-like', NULL, NULL, NULL, 2),
(16365, NULL, 'cd15817', NULL, NULL, 'SPRY_PRY_TRIM60_75', NULL, 'SPRY_PRY_TRIM60_75', NULL, NULL, NULL, 2),
(16366, NULL, 'cd01731', NULL, NULL, 'archaeal_Sm1', NULL, 'archaeal_Sm1', NULL, NULL, 17255, 2),
(16367, NULL, 'cd17712', NULL, NULL, 'BRCT_PAXIP1_rpt5', NULL, 'BRCT_PAXIP1_rpt5', NULL, NULL, NULL, 2),
(16368, NULL, 'cd12908', NULL, NULL, 'SPRYD3', NULL, 'SPRYD3', NULL, NULL, 32247, 2),
(16369, NULL, 'cd18369', NULL, NULL, 'BTB_POZ_KCTD10-like_BACURD', NULL, 'BTB_POZ_KCTD10-like_BACURD', NULL, NULL, NULL, 2),
(16370, NULL, 'cd16402', NULL, NULL, 'ParB_N_like_MT', NULL, 'ParB_N_like_MT', NULL, NULL, NULL, 2),
(16371, NULL, 'cd14096', NULL, NULL, 'STKc_RCK1-like', NULL, 'STKc_RCK1-like', NULL, NULL, NULL, 2),
(16372, NULL, 'cd13445', NULL, NULL, 'CDI_inhibitor_EC869_like', NULL, 'CDI_inhibitor_EC869_like', NULL, NULL, 14400, 2),
(16373, NULL, 'cd01215', NULL, NULL, 'PTB_Dab', NULL, 'PTB_Dab', NULL, NULL, NULL, 2),
(16374, NULL, 'cd12203', NULL, NULL, 'GT1', NULL, 'GT1', NULL, NULL, NULL, 2),
(16375, NULL, 'cd11661', NULL, NULL, 'SANT_MTA3_like', NULL, 'SANT_MTA3_like', NULL, NULL, NULL, 2);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(16376, NULL, 'cd19682', NULL, NULL, 'bHLHzip_MGA_like', NULL, 'bHLHzip_MGA_like', NULL, NULL, NULL, 2),
(16377, NULL, 'cd14814', NULL, NULL, 'Peptidase_M15', NULL, 'Peptidase_M15', NULL, NULL, NULL, 2),
(16378, NULL, 'cd06652', NULL, NULL, 'STKc_MEKK2', NULL, 'STKc_MEKK2', NULL, NULL, NULL, 2),
(16379, NULL, 'cd14911', NULL, NULL, 'MYSc_Myh2_insects_mollusks', NULL, 'MYSc_Myh2_insects_mollusks', NULL, NULL, NULL, 2),
(16380, NULL, 'cd08255', NULL, NULL, '2-desacetyl-2-hydroxyethyl_bacteriochlorophyll...', NULL, '2-desacetyl-2-hydroxyethyl_bacteriochlorophyllide_like', NULL, NULL, NULL, 2),
(16381, NULL, 'cd01884', NULL, NULL, 'EF_Tu', NULL, 'EF_Tu', NULL, NULL, 30584, 2),
(16382, NULL, 'cd02771', NULL, NULL, 'MopB_NDH-1_NuoG2-N7', NULL, 'MopB_NDH-1_NuoG2-N7', NULL, NULL, NULL, 2),
(16383, NULL, 'cd12408', NULL, NULL, 'RRM_eIF3G_like', NULL, 'RRM_eIF3G_like', NULL, NULL, 7122, 2),
(16384, NULL, 'cd12701', NULL, NULL, 'RRM4_PTBP1', NULL, 'RRM4_PTBP1', NULL, NULL, NULL, 2),
(16385, NULL, 'cd14604', NULL, NULL, 'PTPc-N12', NULL, 'PTPc-N12', NULL, NULL, NULL, 2),
(16386, NULL, 'cd11991', NULL, NULL, 'SH3_Intersectin1_3', NULL, 'SH3_Intersectin1_3', NULL, NULL, NULL, 2),
(16387, NULL, 'cd15786', NULL, NULL, 'CPF_1278_like', NULL, 'CPF_1278_like', NULL, NULL, 26364, 2),
(16388, NULL, 'cd14609', NULL, NULL, 'R-PTP-N', NULL, 'R-PTP-N', NULL, NULL, NULL, 2),
(16389, NULL, 'cd08277', NULL, NULL, 'liver_alcohol_DH_like', NULL, 'liver_alcohol_DH_like', NULL, NULL, NULL, 2),
(16390, NULL, 'cd17163', NULL, NULL, 'Ubl_ATG8_GABARAPL2', NULL, 'Ubl_ATG8_GABARAPL2', NULL, NULL, NULL, 2),
(16391, NULL, 'cd16601', NULL, NULL, 'RING-HC_TRIM39_C-IV', NULL, 'RING-HC_TRIM39_C-IV', NULL, NULL, NULL, 2),
(16392, NULL, 'cd19684', NULL, NULL, 'bHLH_dnHLH_ID', NULL, 'bHLH_dnHLH_ID', NULL, NULL, NULL, 2),
(16393, NULL, 'cd15227', NULL, NULL, '7tmA_OR14-like', NULL, '7tmA_OR14-like', NULL, NULL, NULL, 2),
(16394, NULL, 'cd16785', NULL, NULL, 'mRING-HC-C3HC5_NEU1A', NULL, 'mRING-HC-C3HC5_NEU1A', NULL, NULL, NULL, 2),
(16395, NULL, 'cd02751', NULL, NULL, 'MopB_DMSOR-like', NULL, 'MopB_DMSOR-like', NULL, NULL, NULL, 2),
(16396, NULL, 'cd11911', NULL, NULL, 'SH3_CIP4-like', NULL, 'SH3_CIP4-like', NULL, NULL, NULL, 2),
(16397, NULL, 'cd09548', NULL, NULL, 'SAM_EPH-A7', NULL, 'SAM_EPH-A7', NULL, NULL, NULL, 2),
(16398, NULL, 'cd07809', NULL, NULL, 'FGGY_D-XK_1', NULL, 'FGGY_D-XK_1', NULL, NULL, NULL, 2),
(16399, NULL, 'cd03218', NULL, NULL, 'ABC_YhbG', NULL, 'ABC_YhbG', NULL, NULL, 22801, 2),
(16400, NULL, 'cd19865', NULL, NULL, 'DSRM_STRBP_RED-like_rpt1', NULL, 'DSRM_STRBP_RED-like_rpt1', NULL, NULL, NULL, 2),
(16401, NULL, 'cd10147', NULL, NULL, 'Wzt_C-like', NULL, 'Wzt_C-like', NULL, NULL, 25864, 2),
(16402, NULL, 'cd06658', NULL, NULL, 'STKc_PAK5', NULL, 'STKc_PAK5', NULL, NULL, NULL, 2),
(16403, NULL, 'cd06914', NULL, NULL, 'GT8_GNT1', NULL, 'GT8_GNT1', NULL, NULL, NULL, 2),
(16404, NULL, 'cd12545', NULL, NULL, 'RRM_IN35', NULL, 'RRM_IN35', NULL, NULL, NULL, 2),
(16405, NULL, 'cd18830', NULL, NULL, 'GH43_CjArb43A-like', NULL, 'GH43_CjArb43A-like', NULL, NULL, NULL, 2),
(16406, NULL, 'cd19195', NULL, NULL, 'PR-SET_PRDM11', NULL, 'PR-SET_PRDM11', NULL, NULL, 36016, 2),
(16407, NULL, 'cd17222', NULL, NULL, 'RA_RASSF4', NULL, 'RA_RASSF4', NULL, NULL, NULL, 2),
(16408, NULL, 'cd12355', NULL, NULL, 'RRM_RBM18', NULL, 'RRM_RBM18', NULL, NULL, 32702, 2),
(16409, NULL, 'cd18255', NULL, NULL, 'BTB_POZ_KLHL26', NULL, 'BTB_POZ_KLHL26', NULL, NULL, NULL, 2),
(16410, NULL, 'cd16526', NULL, NULL, 'RING-HC_PEX2', NULL, 'RING-HC_PEX2', NULL, NULL, NULL, 2),
(16411, NULL, 'cd05794', NULL, NULL, 'S1_EF-P_repeat_2', NULL, 'S1_EF-P_repeat_2', NULL, NULL, 13812, 2),
(16412, NULL, 'cd14961', NULL, NULL, 'NHL_TRIM32_like', NULL, 'NHL_TRIM32_like', NULL, NULL, NULL, 2),
(16413, NULL, 'cd02987', NULL, NULL, 'Phd_like_Phd', NULL, 'Phd_like_Phd', NULL, NULL, 1413, 2),
(16414, NULL, 'cd03243', NULL, NULL, 'ABC_MutS_homologs', NULL, 'ABC_MutS_homologs', NULL, NULL, NULL, 2),
(16415, NULL, 'cd14366', NULL, NULL, 'CUE_CUED1', NULL, 'CUE_CUED1', NULL, NULL, 28281, 2);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(16416, NULL, 'cd03226', NULL, NULL, 'ABC_cobalt_CbiO_domain2', NULL, 'ABC_cobalt_CbiO_domain2', NULL, NULL, NULL, 2),
(16417, NULL, 'cd18236', NULL, NULL, 'BTB_POZ_KLHL6', NULL, 'BTB_POZ_KLHL6', NULL, NULL, NULL, 2),
(16418, NULL, 'cd13599', NULL, NULL, 'PBP2_lipoprotein_Gna1946', NULL, 'PBP2_lipoprotein_Gna1946', NULL, NULL, NULL, 2),
(16419, NULL, 'cd17618', NULL, NULL, 'REC_OmpR_PhoB', NULL, 'REC_OmpR_PhoB', NULL, NULL, NULL, 2),
(16420, NULL, 'cd01525', NULL, NULL, 'RHOD_Kc', NULL, 'RHOD_Kc', NULL, NULL, NULL, 2),
(16421, NULL, 'cd08478', NULL, NULL, 'PBP2_CrgA', NULL, 'PBP2_CrgA', NULL, NULL, NULL, 2),
(16422, NULL, 'cd09820', NULL, NULL, 'dual_peroxidase_like', NULL, 'dual_peroxidase_like', NULL, NULL, 33915, 2),
(16423, NULL, 'cd18439', NULL, NULL, 'BRCT_BRC1_like_rpt6', NULL, 'BRCT_BRC1_like_rpt6', NULL, NULL, NULL, 2),
(16424, NULL, 'cd11810', NULL, NULL, 'SH3_RUSC1_like', NULL, 'SH3_RUSC1_like', NULL, NULL, NULL, 2),
(16425, NULL, 'cd15981', NULL, NULL, '7tmA_NPFFR1', NULL, '7tmA_NPFFR1', NULL, NULL, NULL, 2),
(16426, NULL, 'cd17281', NULL, NULL, 'RMtype1_S_HpyAXIII_TRD1-CR1_like', NULL, 'RMtype1_S_HpyAXIII_TRD1-CR1_like', NULL, NULL, NULL, 2),
(16427, NULL, 'cd13897', NULL, NULL, 'CuRO_3_LCC_plant', NULL, 'CuRO_3_LCC_plant', NULL, NULL, 24913, 2),
(16428, NULL, 'cd05739', NULL, NULL, 'Ig3_RPTP_IIa_LAR_like', NULL, 'Ig3_RPTP_IIa_LAR_like', NULL, NULL, NULL, 2),
(16429, NULL, 'cd16351', NULL, NULL, 'CheB_like', NULL, 'CheB_like', NULL, NULL, NULL, 2),
(16430, NULL, 'cd15705', NULL, NULL, 'ePHD_JADE2', NULL, 'ePHD_JADE2', NULL, NULL, 31336, 2),
(16431, NULL, 'cd12630', NULL, NULL, 'RRM2_IGF2BP3', NULL, 'RRM2_IGF2BP3', NULL, NULL, 33209, 2),
(16432, NULL, 'cd08405', NULL, NULL, 'C2B_Synaptotagmin-7', NULL, 'C2B_Synaptotagmin-7', NULL, NULL, 28913, 2),
(16433, NULL, 'cd09387', NULL, NULL, 'LIM2_LMO4', NULL, 'LIM2_LMO4', NULL, NULL, NULL, 2),
(16434, NULL, 'cd18540', NULL, NULL, 'ABC_6TM_exporter_like', NULL, 'ABC_6TM_exporter_like', NULL, NULL, NULL, 2),
(16435, NULL, 'cd19028', NULL, NULL, 'LGIC_ECD_nAChR_D', NULL, 'LGIC_ECD_nAChR_D', NULL, NULL, NULL, 2),
(16436, NULL, 'cd02952', NULL, NULL, 'TRP14_like', NULL, 'TRP14_like', NULL, NULL, NULL, 2),
(16437, NULL, 'cd19074', NULL, NULL, 'Aldo_ket_red_shaker-like', NULL, 'Aldo_ket_red_shaker-like', NULL, NULL, NULL, 2),
(16438, NULL, 'cd13574', NULL, NULL, 'PBP2_PnhD_4', NULL, 'PBP2_PnhD_4', NULL, NULL, NULL, 2),
(16439, NULL, 'cd18426', NULL, NULL, 'BTB_POZ_KCNS1', NULL, 'BTB_POZ_KCNS1', NULL, NULL, NULL, 2),
(16440, NULL, 'cd06246', NULL, NULL, 'M14_CPB2', NULL, 'M14_CPB2', NULL, NULL, 32400, 2),
(16441, NULL, 'cd11256', NULL, NULL, 'Sema_4A', NULL, 'Sema_4A', NULL, NULL, NULL, 2),
(16442, NULL, 'cd14450', NULL, NULL, 'CuRO_3_FV_like', NULL, 'CuRO_3_FV_like', NULL, NULL, NULL, 2),
(16443, NULL, 'cd18666', NULL, NULL, 'CD1_tandem_CHD1-2_like', NULL, 'CD1_tandem_CHD1-2_like', NULL, NULL, NULL, 2),
(16444, NULL, 'cd16842', NULL, NULL, 'Ig_SLAM-CD84_like_N', NULL, 'Ig_SLAM-CD84_like_N', NULL, NULL, NULL, 2),
(16445, NULL, 'cd08271', NULL, NULL, 'MDR5', NULL, 'MDR5', NULL, NULL, NULL, 2),
(16446, NULL, 'cd11483', NULL, NULL, 'SLC-NCS1sbd_Mhp1-like', NULL, 'SLC-NCS1sbd_Mhp1-like', NULL, NULL, NULL, 2),
(16447, NULL, 'cd12103', NULL, NULL, 'DD_RIIalpha_PKA', NULL, 'DD_RIIalpha_PKA', NULL, NULL, NULL, 2),
(16448, NULL, 'cd09622', NULL, NULL, 'CBM9_like_HisKa', NULL, 'CBM9_like_HisKa', NULL, NULL, NULL, 2),
(16449, NULL, 'cd03310', NULL, NULL, 'CIMS_like', NULL, 'CIMS_like', NULL, NULL, NULL, 2),
(16450, NULL, 'cd04483', NULL, NULL, 'hOBFC1_like', NULL, 'hOBFC1_like', NULL, NULL, NULL, 2),
(16451, NULL, 'cd14879', NULL, NULL, 'MYSc_Myo17', NULL, 'MYSc_Myo17', NULL, NULL, 31566, 2),
(16452, NULL, 'cd15449', NULL, NULL, '7tmC_mGluR1', NULL, '7tmC_mGluR1', NULL, NULL, NULL, 2),
(16453, NULL, 'cd18779', NULL, NULL, 'ABC_6TM_T1SS_like', NULL, 'ABC_6TM_T1SS_like', NULL, NULL, NULL, 2),
(16454, NULL, 'cd14331', NULL, NULL, 'UBA_HERC1_2', NULL, 'UBA_HERC1_2', NULL, NULL, NULL, 2),
(16455, NULL, 'cd03342', NULL, NULL, 'TCP1_zeta', NULL, 'TCP1_zeta', NULL, NULL, 11950, 2);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(16456, NULL, 'cd13907', NULL, NULL, 'CuRO_3_MCO_like_1', NULL, 'CuRO_3_MCO_like_1', NULL, NULL, NULL, 2),
(16457, NULL, 'cd08380', NULL, NULL, 'C2_PI3K_like', NULL, 'C2_PI3K_like', NULL, NULL, NULL, 2),
(16458, NULL, 'cd05014', NULL, NULL, 'SIS_Kpsf', NULL, 'SIS_Kpsf', NULL, NULL, 28716, 2),
(16459, NULL, 'cd01002', NULL, NULL, 'PBP2_Ehub_like', NULL, 'PBP2_Ehub_like', NULL, NULL, 10208, 2),
(16460, NULL, 'cd13664', NULL, NULL, 'PBP2_PotD_PotF_like_3', NULL, 'PBP2_PotD_PotF_like_3', NULL, NULL, NULL, 2),
(16461, NULL, 'cd17748', NULL, NULL, 'BRCT_DNA_ligase_like', NULL, 'BRCT_DNA_ligase_like', NULL, NULL, NULL, 2),
(16462, NULL, 'cd14280', NULL, NULL, 'UBA1_Rad23_like', NULL, 'UBA1_Rad23_like', NULL, NULL, NULL, 2),
(16463, NULL, 'cd19575', NULL, NULL, 'serpinH2', NULL, 'serpinH2', NULL, NULL, NULL, 2),
(16464, NULL, 'cd19345', NULL, NULL, 'Wnt_Wnt2', NULL, 'Wnt_Wnt2', NULL, NULL, NULL, 2),
(16465, NULL, 'cd07157', NULL, NULL, '2DBD_NR_DBD1', NULL, '2DBD_NR_DBD1', NULL, NULL, NULL, 2),
(16466, NULL, 'cd15675', NULL, NULL, 'ePHD_JMJD2', NULL, 'ePHD_JMJD2', NULL, NULL, NULL, 2),
(16467, NULL, 'cd16649', NULL, NULL, 'mRING-HC-C3HC5_CGRF1_like', NULL, 'mRING-HC-C3HC5_CGRF1_like', NULL, NULL, NULL, 2),
(16468, NULL, 'cd11316', NULL, NULL, 'AmyAc_bac2_AmyA', NULL, 'AmyAc_bac2_AmyA', NULL, NULL, NULL, 2),
(16469, NULL, 'cd00431', NULL, NULL, 'cysteine_hydrolases', NULL, 'cysteine_hydrolases', NULL, NULL, NULL, 2),
(16470, NULL, 'cd16557', NULL, NULL, 'RING-HC_RNF186', NULL, 'RING-HC_RNF186', NULL, NULL, NULL, 2),
(16471, NULL, 'cd09973', NULL, NULL, 'LOTUS_2_TDRD7', NULL, 'LOTUS_2_TDRD7', NULL, NULL, NULL, 2),
(16472, NULL, 'cd18353', NULL, NULL, 'BTB_POZ_RCBTB1_CLLD7', NULL, 'BTB_POZ_RCBTB1_CLLD7', NULL, NULL, NULL, 2),
(16473, NULL, 'cd16837', NULL, NULL, 'BldD_C_like', NULL, 'BldD_C_like', NULL, NULL, 32757, 2),
(16474, NULL, 'cd00781', NULL, NULL, 'ketosteroid_isomerase', NULL, 'ketosteroid_isomerase', NULL, NULL, 32845, 2),
(16475, NULL, 'cd10472', NULL, NULL, 'EphR_LBD_B', NULL, 'EphR_LBD_B', NULL, NULL, NULL, 2),
(16476, NULL, 'Coil', NULL, NULL, NULL, NULL, 'Coil', NULL, NULL, NULL, 3),
(16477, NULL, 'G3DSA:1.20.1070.10:FF:001393', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16478, NULL, 'G3DSA:3.40.50.620:FF:000861', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16479, NULL, 'G3DSA:2.40.50.40:FF:000016', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(16480, NULL, 'G3DSA:3.30.160.60:FF:004795', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16481, NULL, 'G3DSA:3.30.70.100:FF:000088', NULL, NULL, 'Copper chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(16482, NULL, 'G3DSA:1.20.1250.20:FF:001701', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16483, NULL, 'G3DSA:1.20.1440.360:FF:000002', NULL, NULL, 'MAGUK p55 subfamily member 5-A', NULL, NULL, NULL, NULL, NULL, 4),
(16484, NULL, 'G3DSA:3.80.10.10:FF:004290', NULL, NULL, 'AER145Wp', NULL, NULL, NULL, NULL, NULL, 4),
(16485, NULL, 'G3DSA:1.10.287.70:FF:000219', NULL, NULL, 'KCNN (Potassium K ChaNNel, calcium activated)-Like', NULL, NULL, NULL, NULL, NULL, 4),
(16486, NULL, 'G3DSA:2.60.40.10:FF:000545', NULL, NULL, 'Interleukin-11 receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(16487, NULL, 'G3DSA:1.10.30.10:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16488, NULL, 'G3DSA:3.40.50.300:FF:003137', NULL, NULL, 'Splicing endonuclease positive effector sen1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(16489, NULL, 'G3DSA:3.30.70.330:FF:002017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16490, NULL, 'G3DSA:3.30.70.330:FF:002489', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16491, NULL, 'G3DSA:3.80.20.20:FF:000050', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(16492, NULL, 'G3DSA:1.20.120.1900:FF:000077', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(16493, NULL, 'G3DSA:2.60.40.1120:FF:000034', NULL, NULL, 'Outer membrane receptor for ferrienterochelin and colicins', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(16494, NULL, 'G3DSA:3.40.800.20:FF:000036', NULL, NULL, 'Histone deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(16495, NULL, 'G3DSA:2.170.130.10:FF:000084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16496, NULL, 'G3DSA:1.10.135.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16497, NULL, 'G3DSA:1.25.40.10:FF:000904', NULL, NULL, 'CesD/SycD/LcrH family type III secretion system chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(16498, NULL, 'G3DSA:1.10.10.60:FF:000658', NULL, NULL, 'Homeobox and leucine zipper encoding a', NULL, NULL, NULL, NULL, NULL, 4),
(16499, NULL, 'G3DSA:3.30.980.10:FF:000008', NULL, NULL, 'Similar to alanyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(16500, NULL, 'G3DSA:2.40.30.10:FF:000057', NULL, NULL, 'Mitochondrial tRNA-specific 2-thiouridylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(16501, NULL, 'G3DSA:3.30.200.20:FF:001313', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(16502, NULL, 'G3DSA:2.60.120.330:FF:000016', NULL, NULL, 'Naringenin,2-oxoglutarate 3-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(16503, NULL, 'G3DSA:2.60.40.10:FF:000984', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(16504, NULL, 'G3DSA:1.10.1300.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16505, NULL, 'G3DSA:3.30.2140.20:FF:000009', NULL, NULL, 'Arylamine N-acetyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(16506, NULL, 'G3DSA:3.10.450.10:FF:000057', NULL, NULL, 'Ovocalyxin-32', NULL, NULL, NULL, NULL, NULL, 4),
(16507, NULL, 'G3DSA:3.30.200.20:FF:002302', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(16508, NULL, 'G3DSA:2.60.200.10:FF:000026', NULL, NULL, 'K9', NULL, NULL, NULL, NULL, NULL, 4),
(16509, NULL, 'G3DSA:1.20.1250.20:FF:001168', NULL, NULL, 'AGAP005394-PA', NULL, NULL, NULL, NULL, NULL, 4),
(16510, NULL, 'G3DSA:2.60.34.10:FF:000132', NULL, NULL, 'Stress-70 protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(16511, NULL, 'G3DSA:3.40.850.10:FF:000070', NULL, NULL, 'Myosin A', NULL, NULL, NULL, NULL, NULL, 4),
(16512, NULL, 'G3DSA:1.10.510.10:FF:002638', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16513, NULL, 'G3DSA:1.10.540.10:FF:000049', NULL, NULL, 'Dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(16514, NULL, 'G3DSA:2.160.20.110:FF:000003', NULL, NULL, 'Putative GLUG motif protein', NULL, NULL, NULL, NULL, NULL, 4),
(16515, NULL, 'G3DSA:1.10.150.80:FF:000006', NULL, NULL, 'Ribonuclease D', NULL, NULL, NULL, NULL, NULL, 4),
(16516, NULL, 'G3DSA:3.90.810.10:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16517, NULL, 'G3DSA:1.20.1250.20:FF:002157', NULL, NULL, 'Organic anion transporter polypeptide (oatp) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(16518, NULL, 'G3DSA:3.20.20.80:FF:000536', NULL, NULL, 'Beta-xylanase', NULL, NULL, NULL, NULL, NULL, 4),
(16519, NULL, 'G3DSA:1.25.40.10:FF:005255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16520, NULL, 'G3DSA:2.10.25.10:FF:001367', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(16521, NULL, 'G3DSA:3.40.50.1000:FF:000676', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16522, NULL, 'G3DSA:3.40.50.300:FF:008460', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16523, NULL, 'G3DSA:1.20.930.40:FF:000030', NULL, NULL, 'Glutamate carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(16524, NULL, 'G3DSA:3.40.630.10:FF:000379', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16525, NULL, 'G3DSA:3.40.50.300:FF:000383', NULL, NULL, 'Dynamin-like gtpase dnm1', NULL, NULL, NULL, NULL, NULL, 4),
(16526, NULL, 'G3DSA:3.30.450.20:FF:000516', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(16527, NULL, 'G3DSA:3.40.50.720:FF:002038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16528, NULL, 'G3DSA:2.40.70.10:FF:000503', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(16529, NULL, 'G3DSA:3.90.550.10:FF:000120', NULL, NULL, 'Glycosyl transferase, family 2', NULL, NULL, NULL, NULL, NULL, 4),
(16530, NULL, 'G3DSA:3.20.20.100:FF:000001', NULL, NULL, 'voltage-gated potassium channel subunit beta-2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(16531, NULL, 'G3DSA:2.40.160.50:FF:000033', NULL, NULL, 'Surface antigen-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(16532, NULL, 'G3DSA:3.30.420.10:FF:000478', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16533, NULL, 'G3DSA:1.20.920.10:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16534, NULL, 'G3DSA:3.40.140.10:FF:000212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16535, NULL, 'G3DSA:3.30.565.10:FF:000364', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16536, NULL, 'G3DSA:1.10.460.10:FF:000015', NULL, NULL, 'DNA topoisomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(16537, NULL, 'G3DSA:2.40.50.140:FF:000906', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16538, NULL, 'G3DSA:3.90.1150.10:FF:000122', NULL, NULL, 'Dihydrodipicolinate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(16539, NULL, 'G3DSA:3.10.110.10:FF:000066', NULL, NULL, 'IMPACT isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(16540, NULL, 'G3DSA:3.30.2350.10:FF:000045', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(16541, NULL, 'G3DSA:3.30.160.60:FF:005784', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16542, NULL, 'G3DSA:1.20.58.2070:FF:000002', NULL, NULL, 'Checkpoint serine/threonine-protein kinase BUB1', NULL, NULL, NULL, NULL, NULL, 4),
(16543, NULL, 'G3DSA:1.10.8.10:FF:000064', NULL, NULL, 'Similar to CUE domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(16544, NULL, 'G3DSA:3.30.420.10:FF:000006', NULL, NULL, 'Ribonuclease HII', NULL, NULL, NULL, NULL, NULL, 4),
(16545, NULL, 'G3DSA:1.10.1780.10:FF:000010', NULL, NULL, 'ATP-dependent Clp protease ATP-binding subunit CLPT2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(16546, NULL, 'G3DSA:3.40.50.300:FF:007471', NULL, NULL, 'Helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(16547, NULL, 'G3DSA:1.20.920.20:FF:000046', NULL, NULL, 'Dynein heavy chain 3', NULL, NULL, NULL, NULL, NULL, 4),
(16548, NULL, 'G3DSA:3.10.100.10:FF:000301', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16549, NULL, 'G3DSA:1.10.8.710:FF:000008', NULL, NULL, 'Dynein axonemal heavy chain 3', NULL, NULL, NULL, NULL, NULL, 4),
(16550, NULL, 'G3DSA:3.30.160.60:FF:004356', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16551, NULL, 'G3DSA:3.90.950.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16552, NULL, 'G3DSA:3.90.70.10:FF:000263', NULL, NULL, 'Ribosomal-protein-S18p-alanine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(16553, NULL, 'G3DSA:3.90.640.10:FF:000239', NULL, NULL, 'Heat shock protein 70 (HSP70), putative', NULL, NULL, NULL, NULL, NULL, 4),
(16554, NULL, 'G3DSA:3.50.50.60:FF:000727', NULL, NULL, 'Mercuric reductase', NULL, NULL, NULL, NULL, NULL, 4),
(16555, NULL, 'G3DSA:1.10.287.2170:FF:000002', NULL, NULL, 'First ORF in transposon ISC1904', NULL, NULL, NULL, NULL, NULL, 4),
(16556, NULL, 'G3DSA:3.20.20.120:FF:000007', NULL, NULL, 'Mitochondrial enolase superfamily member 1', NULL, NULL, NULL, NULL, NULL, 4),
(16557, NULL, 'G3DSA:2.40.50.140:FF:000586', NULL, NULL, 'Zgc:101853', NULL, NULL, NULL, NULL, NULL, 4),
(16558, NULL, 'G3DSA:3.30.200.20:FF:000796', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(16559, NULL, 'G3DSA:3.40.50.1980:FF:000065', NULL, NULL, 'Iron compound ABC transporter, substrate-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(16560, NULL, 'G3DSA:3.30.1490.80:FF:000002', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(16561, NULL, 'G3DSA:2.70.98.20:FF:000001', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(16562, NULL, 'G3DSA:3.30.230.10:FF:000295', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(16563, NULL, 'G3DSA:3.80.10.10:FF:000748', NULL, NULL, 'Leucine-rich repeat-containing protein 40', NULL, NULL, NULL, NULL, NULL, 4),
(16564, NULL, 'G3DSA:1.25.40.10:FF:001040', NULL, NULL, 'Activator of G protein Signalling', NULL, NULL, NULL, NULL, NULL, 4),
(16565, NULL, 'G3DSA:2.120.10.80:FF:000106', NULL, NULL, 'Transcription factor INI', NULL, NULL, NULL, NULL, NULL, 4),
(16566, NULL, 'G3DSA:3.40.50.10810:FF:000274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16567, NULL, 'G3DSA:1.10.260.40:FF:000082', NULL, NULL, '(S)-2-hydroxypropylphosphonic acid epoxidase', NULL, NULL, NULL, NULL, NULL, 4),
(16568, NULL, 'G3DSA:3.40.1620.60:FF:000011', NULL, NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif A, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(16569, NULL, 'G3DSA:1.20.930.10:FF:000015', NULL, NULL, 'Transcription elongation factor A1', NULL, NULL, NULL, NULL, NULL, 4),
(16570, NULL, 'G3DSA:2.60.40.60:FF:000127', NULL, NULL, 'Protocadherin beta 1', NULL, NULL, NULL, NULL, NULL, 4),
(16571, NULL, 'G3DSA:3.90.290.10:FF:000021', NULL, NULL, 'follistatin-related protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(16572, NULL, 'G3DSA:3.40.50.1000:FF:000204', NULL, NULL, 'Copper-translocating P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(16573, NULL, 'G3DSA:4.10.240.10:FF:000184', NULL, NULL, 'Oleate-activated transcription factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(16574, NULL, 'G3DSA:3.40.50.460:FF:000026', NULL, NULL, '6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(16575, NULL, 'G3DSA:3.10.20.740:FF:000010', NULL, NULL, 'Periplasmic [Fe] hydrogenase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(16576, NULL, 'G3DSA:2.60.40.1510:FF:000061', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(16577, NULL, 'G3DSA:3.20.20.300:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16578, NULL, 'G3DSA:3.30.160.60:FF:006301', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16579, NULL, 'G3DSA:3.30.160.60:FF:000141', NULL, NULL, 'C2H2 zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(16580, NULL, 'G3DSA:2.40.160.20:FF:000018', NULL, NULL, 'Outer membrane protein OmpA', NULL, NULL, NULL, NULL, NULL, 4),
(16581, NULL, 'G3DSA:2.60.120.10:FF:000497', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16582, NULL, 'G3DSA:3.40.50.300:FF:008308', NULL, NULL, 'SNF2 family DNA-dependent ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(16583, NULL, 'G3DSA:3.40.50.300:FF:002148', NULL, NULL, 'Putative dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(16584, NULL, 'G3DSA:3.90.226.10:FF:000114', NULL, NULL, 'DCI1p Peroxisomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(16585, NULL, 'G3DSA:3.40.33.10:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16586, NULL, 'G3DSA:2.10.50.10:FF:000071', NULL, NULL, 'Cysteine repeat modular protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(16587, NULL, 'G3DSA:3.30.230.120:FF:000001', NULL, NULL, 'L-fucose kinase', NULL, NULL, NULL, NULL, NULL, 4),
(16588, NULL, 'G3DSA:1.10.238.10:FF:001196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16589, NULL, 'G3DSA:3.60.40.10:FF:000386', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16590, NULL, 'G3DSA:1.25.10.10:FF:002201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16591, NULL, 'G3DSA:3.40.50.300:FF:005554', NULL, NULL, 'peroxisome biogenesis protein 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(16592, NULL, 'G3DSA:3.30.70.1020:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16593, NULL, 'G3DSA:3.10.20.90:FF:001023', NULL, NULL, 'Polycomb group protein Psc-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(16594, NULL, 'G3DSA:3.30.70.660:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16595, NULL, 'G3DSA:3.10.290.10:FF:000022', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(16596, NULL, 'G3DSA:3.40.532.10:FF:000005', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(16597, NULL, 'G3DSA:3.70.10.10:FF:000097', NULL, NULL, 'Checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(16598, NULL, 'G3DSA:3.40.50.300:FF:001159', NULL, NULL, 'Putative P-loop containing nucleoside triphosphate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(16599, NULL, 'G3DSA:2.60.40.10:FF:003890', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16600, NULL, 'G3DSA:3.30.420.40:FF:000054', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(16601, NULL, 'G3DSA:3.30.160.60:FF:002911', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16602, NULL, 'G3DSA:3.40.50.1480:FF:000005', NULL, NULL, 'Adenosylhomocysteinase', NULL, NULL, NULL, NULL, NULL, 4),
(16603, NULL, 'G3DSA:1.50.40.10:FF:000492', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16604, NULL, 'G3DSA:2.60.120.590:FF:000015', NULL, NULL, 'DNA oxidative demethylase ALKBH2', NULL, NULL, NULL, NULL, NULL, 4),
(16605, NULL, 'G3DSA:3.90.245.10:FF:000006', NULL, NULL, 'Inosine-uridine preferring nucleoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(16606, NULL, 'G3DSA:2.30.29.30:FF:000200', NULL, NULL, 'Rho guanine nucleotide exchange factor (GEF) 10-like a', NULL, NULL, NULL, NULL, NULL, 4),
(16607, NULL, 'G3DSA:3.40.640.10:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16608, NULL, 'G3DSA:3.30.70.1350:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16609, NULL, 'G3DSA:2.30.30.100:FF:000106', NULL, NULL, 'Gem nuclear organelle associated protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(16610, NULL, 'G3DSA:3.90.79.10:FF:000283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16611, NULL, 'G3DSA:2.60.120.200:FF:000236', NULL, NULL, 'Legume lectin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(16612, NULL, 'G3DSA:2.60.120.40:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16613, NULL, 'G3DSA:3.40.30.10:FF:000431', NULL, NULL, 'Thioredoxin superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(16614, NULL, 'G3DSA:3.30.360.10:FF:000068', NULL, NULL, 'Gfo/Idh/MocA family oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(16615, NULL, 'G3DSA:3.30.40.10:FF:002135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16616, NULL, 'G3DSA:3.40.50.300:FF:000703', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(16617, NULL, 'G3DSA:3.30.780.10:FF:000027', NULL, NULL, 'Mitochondrial ribosomal protein L49, putative', NULL, NULL, NULL, NULL, NULL, 4),
(16618, NULL, 'G3DSA:1.20.58.1770:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16619, NULL, 'G3DSA:2.60.40.150:FF:000661', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16620, NULL, 'G3DSA:3.40.50.200:FF:000027', NULL, NULL, 'Peptidase S53 propeptide', NULL, NULL, NULL, NULL, NULL, 4),
(16621, NULL, 'G3DSA:1.25.40.10:FF:003338', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(16622, NULL, 'G3DSA:3.30.470.20:FF:000046', NULL, NULL, 'inactive polyglycylase TTLL10', NULL, NULL, NULL, NULL, NULL, 4),
(16623, NULL, 'G3DSA:1.25.40.10:FF:002349', NULL, NULL, 'Putative pentatricopeptide repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(16624, NULL, 'G3DSA:2.60.40.10:FF:001501', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(16625, NULL, 'G3DSA:3.40.605.10:FF:000074', NULL, NULL, 'Malonic semialdehyde oxidative decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(16626, NULL, 'G3DSA:3.40.50.1240:FF:000164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16627, NULL, 'G3DSA:2.120.10.30:FF:000496', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16628, NULL, 'G3DSA:3.30.43.10:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16629, NULL, 'G3DSA:2.60.120.10:FF:000025', NULL, NULL, 'germin-like protein subfamily 2 member 1', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(16630, NULL, 'G3DSA:2.40.50.140:FF:001103', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16631, NULL, 'G3DSA:3.90.730.10:FF:000038', NULL, NULL, 'Probable ribonuclease HI_0526', NULL, NULL, NULL, NULL, NULL, 4),
(16632, NULL, 'G3DSA:1.10.287.1700:FF:000002', NULL, NULL, 'Flagella biosynthesis chaperone FliJ', NULL, NULL, NULL, NULL, NULL, 4),
(16633, NULL, 'G3DSA:3.30.300.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16634, NULL, 'G3DSA:2.130.10.10:FF:002614', NULL, NULL, 'WD-40 repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(16635, NULL, 'G3DSA:1.20.58.90:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16636, NULL, 'G3DSA:3.40.710.10:FF:000060', NULL, NULL, 'Penicillin-binding protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(16637, NULL, 'G3DSA:2.60.40.10:FF:004727', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16638, NULL, 'G3DSA:3.30.1780.10:FF:000009', NULL, NULL, 'Ornithine cyclodeaminase/mu-crystallin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(16639, NULL, 'G3DSA:3.40.50.720:FF:000273', NULL, NULL, 'Reticulon-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(16640, NULL, 'G3DSA:1.20.120.140:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16641, NULL, 'G3DSA:2.130.10.10:FF:005520', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16642, NULL, 'G3DSA:3.40.50.1820:FF:001731', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(16643, NULL, 'G3DSA:3.80.10.10:FF:001384', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16644, NULL, 'G3DSA:2.170.270.10:FF:000094', NULL, NULL, 'GM20595', NULL, NULL, NULL, NULL, NULL, 4),
(16645, NULL, 'G3DSA:1.10.275.10:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16646, NULL, 'G3DSA:2.60.40.60:FF:000566', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16647, NULL, 'G3DSA:1.25.40.10:FF:002821', NULL, NULL, 'At3g09490', NULL, NULL, NULL, NULL, NULL, 4),
(16648, NULL, 'G3DSA:1.10.1450.10:FF:000137', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(16649, NULL, 'G3DSA:1.10.10.10:FF:002049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16650, NULL, 'G3DSA:2.40.50.90:FF:000037', NULL, NULL, 'Tudor staphylococcal nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(16651, NULL, 'G3DSA:3.30.160.60:FF:005312', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16652, NULL, 'G3DSA:3.40.50.300:FF:003929', NULL, NULL, 'Small GTPase RhoA, putative', NULL, NULL, NULL, NULL, NULL, 4),
(16653, NULL, 'G3DSA:3.30.70.1320:FF:000016', NULL, NULL, 'Heavy metal efflux pump permease component CzcA family', NULL, NULL, NULL, NULL, NULL, 4),
(16654, NULL, 'G3DSA:1.25.40.10:FF:000112', NULL, NULL, 'FAM10 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(16655, NULL, 'G3DSA:1.20.120.20:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16656, NULL, 'G3DSA:2.30.42.10:FF:000006', NULL, NULL, 'Membrane associated guanylate kinase, WW and PDZ domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(16657, NULL, 'G3DSA:2.10.25.10:FF:000911', NULL, NULL, 'LDL receptor protein 1, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(16658, NULL, 'G3DSA:1.25.10.10:FF:000756', NULL, NULL, 'Synembryn', NULL, NULL, NULL, NULL, NULL, 4),
(16659, NULL, 'G3DSA:3.40.50.850:FF:000020', NULL, NULL, 'Nicotinamidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(16660, NULL, 'G3DSA:3.30.160.60:FF:002878', NULL, NULL, 'Zinc finger protein 652', NULL, NULL, NULL, NULL, NULL, 4),
(16661, NULL, 'G3DSA:1.20.58.160:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16662, NULL, 'G3DSA:3.10.20.90:FF:000534', NULL, NULL, 'GD22467', NULL, NULL, NULL, NULL, NULL, 4),
(16663, NULL, 'G3DSA:1.10.3860.10:FF:000011', NULL, NULL, 'L-cystine transporter', NULL, NULL, NULL, NULL, NULL, 4),
(16664, NULL, 'G3DSA:1.10.287.950:FF:000045', NULL, NULL, 'Chemotaxis signal transduction system methyl accepting sensory transducer', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(16665, NULL, 'G3DSA:2.130.10.10:FF:000669', NULL, NULL, 'WD repeat-containing protein 82', NULL, NULL, NULL, NULL, NULL, 4),
(16666, NULL, 'G3DSA:3.40.1110.10:FF:000171', NULL, NULL, 'Phospholipid-transporting P-type ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(16667, NULL, 'G3DSA:2.30.40.10:FF:000024', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(16668, NULL, 'G3DSA:2.30.30.40:FF:000566', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(16669, NULL, 'G3DSA:3.30.60.190:FF:000011', NULL, NULL, 'Zinc finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(16670, NULL, 'G3DSA:1.20.120.1750:FF:000043', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(16671, NULL, 'G3DSA:3.40.50.300:FF:004565', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16672, NULL, 'G3DSA:3.30.70.330:FF:001680', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16673, NULL, 'G3DSA:3.40.525.10:FF:000073', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(16674, NULL, 'G3DSA:3.40.50.1820:FF:001198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16675, NULL, 'G3DSA:1.10.510.10:FF:001649', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(16676, NULL, 'G3DSA:3.40.630.30:FF:000565', NULL, NULL, 'Acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(16677, NULL, 'G3DSA:1.20.1250.10:FF:000030', NULL, NULL, 'Type I interferon', NULL, NULL, NULL, NULL, NULL, 4),
(16678, NULL, 'G3DSA:3.30.160.60:FF:003367', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(16679, NULL, 'G3DSA:1.20.1280.180:FF:000001', NULL, NULL, 'Carnitine O-palmitoyltransferase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(16680, NULL, 'G3DSA:3.40.50.10490:FF:000015', NULL, NULL, 'Glucose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(16681, NULL, 'G3DSA:3.30.420.40:FF:001010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16682, NULL, 'G3DSA:3.40.50.300:FF:005054', NULL, NULL, 'Elongator complex protein 6-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(16683, NULL, 'G3DSA:3.40.50.11210:FF:000001', NULL, NULL, 'Ral GTPase-activating protein subunit alpha-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(16684, NULL, 'G3DSA:3.30.1330.20:FF:000018', NULL, NULL, 'Tubulin gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(16685, NULL, 'G3DSA:1.25.10.10:FF:002701', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16686, NULL, 'G3DSA:1.10.533.10:FF:000084', NULL, NULL, 'Interferon-induced with helicase C domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(16687, NULL, 'G3DSA:3.30.1680.10:FF:000064', NULL, NULL, 'Semaphorin-4D', NULL, NULL, NULL, NULL, NULL, 4),
(16688, NULL, 'G3DSA:1.20.58.1210:FF:000008', NULL, NULL, 'AGAP004207-PA', NULL, NULL, NULL, NULL, NULL, 4),
(16689, NULL, 'G3DSA:3.90.150.10:FF:000011', NULL, NULL, 'Variant surface glycoprotein (VSG, atypical), putative', NULL, NULL, NULL, NULL, NULL, 4),
(16690, NULL, 'G3DSA:3.30.70.1730:FF:000049', NULL, NULL, '50S ribosomal protein L10', NULL, NULL, NULL, NULL, NULL, 4),
(16691, NULL, 'G3DSA:1.10.1520.10:FF:000053', NULL, NULL, 'Dicer-like 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(16692, NULL, 'G3DSA:1.25.40.20:FF:000733', NULL, NULL, 'Water witch, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(16693, NULL, 'G3DSA:3.30.160.60:FF:001130', NULL, NULL, 'Zinc finger protein 219', NULL, NULL, NULL, NULL, NULL, 4),
(16694, NULL, 'G3DSA:3.80.10.10:FF:003654', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16695, NULL, 'G3DSA:3.40.47.10:FF:000054', NULL, NULL, 'Acetyl-CoA C-acetyltransferase VraB', NULL, NULL, NULL, NULL, NULL, 4),
(16696, NULL, 'G3DSA:3.30.70.330:FF:003006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16697, NULL, 'G3DSA:3.30.450.20:FF:000163', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(16698, NULL, 'G3DSA:3.40.50.1820:FF:001259', NULL, NULL, 'Protein phosphatase methylesterase 1', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(16699, NULL, 'G3DSA:3.20.20.70:FF:000207', NULL, NULL, 'Anaerobic sulfatase maturase AslB', NULL, NULL, NULL, NULL, NULL, 4),
(16700, NULL, 'G3DSA:2.60.40.150:FF:000189', NULL, NULL, 'X-linked retinitis pigmentosa GTPase regulator-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(16701, NULL, 'G3DSA:3.40.190.10:FF:000362', NULL, NULL, 'Nickel ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(16702, NULL, 'G3DSA:2.60.40.150:FF:000509', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(16703, NULL, 'G3DSA:1.20.1250.20:FF:000712', NULL, NULL, 'Transporter, MFS superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(16704, NULL, 'G3DSA:1.10.240.10:FF:000004', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(16705, NULL, 'G3DSA:3.50.4.10:FF:000017', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(16706, NULL, 'G3DSA:1.20.58.2220:FF:000036', NULL, NULL, 'Formin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(16707, NULL, 'G3DSA:1.10.10.60:FF:001294', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16708, NULL, 'G3DSA:2.60.40.10:FF:001181', NULL, NULL, 'Immunoglobulin lambda variable 9-49', NULL, NULL, NULL, NULL, NULL, 4),
(16709, NULL, 'G3DSA:1.10.10.60:FF:001114', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16710, NULL, 'G3DSA:3.30.200.210:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16711, NULL, 'G3DSA:2.60.120.10:FF:000525', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16712, NULL, 'G3DSA:1.10.132.30:FF:000023', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(16713, NULL, 'G3DSA:3.30.1240.10:FF:000042', NULL, NULL, '5-amino-6-(5-phospho-D-ribitylamino)uracil phosphatase YitU', NULL, NULL, NULL, NULL, NULL, 4),
(16714, NULL, 'G3DSA:1.25.10.10:FF:000695', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(16715, NULL, 'G3DSA:2.120.10.80:FF:000078', NULL, NULL, 'Kelch like family member 8', NULL, NULL, NULL, NULL, NULL, 4),
(16716, NULL, 'G3DSA:1.10.10.10:FF:000284', NULL, NULL, 'Anaphase-promoting complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(16717, NULL, 'G3DSA:1.10.10.10:FF:000104', NULL, NULL, 'AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(16718, NULL, 'G3DSA:3.40.120.10:FF:000088', NULL, NULL, 'Phosphoglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(16719, NULL, 'G3DSA:2.60.120.620:FF:000159', NULL, NULL, 'Prolyl 4-hydroxylase alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(16720, NULL, 'G3DSA:3.60.21.10:FF:000494', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(16721, NULL, 'G3DSA:3.40.190.10:FF:000423', NULL, NULL, 'Transcriptional regulator LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(16722, NULL, 'G3DSA:3.30.1490.100:FF:000017', NULL, NULL, 'DNA polymerase kappa, putative', NULL, NULL, NULL, NULL, NULL, 4),
(16723, NULL, 'G3DSA:2.160.20.10:FF:000163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16724, NULL, 'G3DSA:3.50.50.60:FF:000374', NULL, NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(16725, NULL, 'G3DSA:1.10.510.10:FF:003566', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16726, NULL, 'G3DSA:2.60.40.10:FF:001001', NULL, NULL, 'Uncharacterized protein, isoform I', NULL, NULL, NULL, NULL, NULL, 4),
(16727, NULL, 'G3DSA:3.30.160.60:FF:003867', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16728, NULL, 'G3DSA:1.25.40.20:FF:000441', NULL, NULL, 'Protein CbxX, chromosomal', NULL, NULL, NULL, NULL, NULL, 4),
(16729, NULL, 'G3DSA:1.10.238.10:FF:001224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16730, NULL, 'G3DSA:1.50.10.20:FF:000021', NULL, NULL, 'Geranylgeranyl transferase type-1 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(16731, NULL, 'G3DSA:2.130.10.10:FF:002586', NULL, NULL, 'WD-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(16732, NULL, 'G3DSA:3.30.930.10:FF:000269', NULL, NULL, 'AGAP000979-PA', NULL, NULL, NULL, NULL, NULL, 4),
(16733, NULL, 'G3DSA:2.40.70.10:FF:000183', NULL, NULL, 'Plasmepsin VIII', NULL, NULL, NULL, NULL, NULL, 4),
(16734, NULL, 'G3DSA:3.40.1840.10:FF:000001', NULL, NULL, 'YNR034W-A-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(16735, NULL, 'G3DSA:2.40.10.10:FF:000174', NULL, NULL, 'Possible protease', NULL, NULL, NULL, NULL, NULL, 4),
(16736, NULL, 'G3DSA:3.30.470.20:FF:000107', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(16737, NULL, 'G3DSA:1.10.560.10:FF:000079', NULL, NULL, '60 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(16738, NULL, 'G3DSA:3.10.490.10:FF:000003', NULL, NULL, 'Gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(16739, NULL, 'G3DSA:3.40.640.10:FF:000144', NULL, NULL, 'Phosphoserine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(16740, NULL, 'G3DSA:3.40.50.2020:FF:000061', NULL, NULL, 'PRS5p 5-phospho-ribosyl-1(Alpha)-pyrophosphate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(16741, NULL, 'G3DSA:3.40.50.720:FF:002510', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16742, NULL, 'G3DSA:3.30.70.330:FF:002961', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16743, NULL, 'G3DSA:2.60.120.920:FF:000098', NULL, NULL, 'SPRY_domain/HECT-domain_(Ubiquitin-transferase)_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(16744, NULL, 'G3DSA:1.25.40.10:FF:001101', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(16745, NULL, 'G3DSA:3.100.10.10:FF:000021', NULL, NULL, '50S ribosomal protein L15', NULL, NULL, NULL, NULL, NULL, 4),
(16746, NULL, 'G3DSA:3.20.20.140:FF:000165', NULL, NULL, 'AMP deaminase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(16747, NULL, 'G3DSA:3.30.200.20:FF:000824', NULL, NULL, 'Serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(16748, NULL, 'G3DSA:2.40.10.10:FF:000466', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16749, NULL, 'G3DSA:4.10.280.10:FF:000158', NULL, NULL, 'Sterol regulatory element Binding Protein', NULL, NULL, NULL, NULL, NULL, 4),
(16750, NULL, 'G3DSA:3.30.230.10:FF:000323', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16751, NULL, 'G3DSA:3.10.450.320:FF:000002', NULL, NULL, 'Mitochondrial import inner membrane translocase subunit tim21', NULL, NULL, NULL, NULL, NULL, 4),
(16752, NULL, 'G3DSA:2.130.10.10:FF:002294', NULL, NULL, 'CG10144', NULL, NULL, NULL, NULL, NULL, 4),
(16753, NULL, 'G3DSA:1.20.58.340:FF:000058', NULL, NULL, 'CorA family metal ion transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(16754, NULL, 'G3DSA:3.20.20.220:FF:000071', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(16755, NULL, 'G3DSA:2.40.70.10:FF:000003', NULL, NULL, 'Beta-secretase 1', NULL, NULL, NULL, NULL, NULL, 4),
(16756, NULL, 'G3DSA:2.30.29.240:FF:000016', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(16757, NULL, 'G3DSA:3.10.129.10:FF:000204', NULL, NULL, 'Biosynthesis cluster domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(16758, NULL, 'G3DSA:3.40.50.300:FF:007971', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16759, NULL, 'G3DSA:2.10.220.10:FF:000055', NULL, NULL, 'Furin-like protease 2', NULL, NULL, NULL, NULL, NULL, 4),
(16760, NULL, 'G3DSA:3.30.497.10:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16761, NULL, 'G3DSA:1.20.1250.20:FF:001668', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16762, NULL, 'G3DSA:1.10.10.900:FF:000002', NULL, NULL, 'Sdo1p', NULL, NULL, NULL, NULL, NULL, 4),
(16763, NULL, 'G3DSA:3.30.450.40:FF:000202', NULL, NULL, 'Sensor cyclic diguanylate phosphodiesterase, GAF and GAF domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(16764, NULL, 'G3DSA:1.25.10.10:FF:001684', NULL, NULL, 'Puf protein', NULL, NULL, NULL, NULL, NULL, 4),
(16765, NULL, 'G3DSA:2.60.40.150:FF:000009', NULL, NULL, 'dysferlin isoform X2', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(16766, NULL, 'G3DSA:3.30.260.10:FF:000004', NULL, NULL, 'T-complex protein 1 subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(16767, NULL, 'G3DSA:3.30.40.10:FF:001938', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16768, NULL, 'G3DSA:1.10.10.60:FF:000597', NULL, NULL, 'Putative DNAj-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(16769, NULL, 'G3DSA:3.20.20.450:FF:000022', NULL, NULL, 'Diguanylate cyclase/phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(16770, NULL, 'G3DSA:3.10.20.90:FF:000034', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 13', NULL, NULL, NULL, NULL, NULL, 4),
(16771, NULL, 'G3DSA:1.10.8.60:FF:000146', NULL, NULL, 'Vesicle-fusing ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(16772, NULL, 'G3DSA:1.25.40.10:FF:000084', NULL, NULL, 'CTR9 homolog, Paf1/RNA polymerase II complex component', NULL, NULL, NULL, NULL, NULL, 4),
(16773, NULL, 'G3DSA:1.25.40.20:FF:001722', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16774, NULL, 'G3DSA:3.50.50.60:FF:001363', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(16775, NULL, 'G3DSA:3.30.530.20:FF:000017', NULL, NULL, 'Phosphatidylcholine transfer protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(16776, NULL, 'G3DSA:2.40.10.10:FF:000027', NULL, NULL, 'Haptoglobin', NULL, NULL, NULL, NULL, NULL, 4),
(16777, NULL, 'G3DSA:3.90.1170.10:FF:000005', NULL, NULL, '39S ribosomal protein L16, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(16778, NULL, 'G3DSA:1.10.640.10:FF:000052', NULL, NULL, 'AGAP009033-PA', NULL, NULL, NULL, NULL, NULL, 4),
(16779, NULL, 'G3DSA:1.20.1250.20:FF:001640', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16780, NULL, 'G3DSA:3.60.21.10:FF:000347', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(16781, NULL, 'G3DSA:3.40.630.30:FF:000065', NULL, NULL, 'N-terminal acetyltransferase complex ARD1 subunit homolog', NULL, NULL, NULL, NULL, NULL, 4),
(16782, NULL, 'G3DSA:4.10.280.10:FF:000130', NULL, NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(16783, NULL, 'G3DSA:1.20.5.170:FF:000277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16784, NULL, 'G3DSA:3.30.160.60:FF:001630', NULL, NULL, 'Zinc finger protein 888', NULL, NULL, NULL, NULL, NULL, 4),
(16785, NULL, 'G3DSA:3.30.160.60:FF:002439', NULL, NULL, 'Zinc finger protein 646', NULL, NULL, NULL, NULL, NULL, 4),
(16786, NULL, 'G3DSA:1.20.1440.100:FF:000003', NULL, NULL, 'HAD-superfamily hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(16787, NULL, 'G3DSA:1.10.60.30:FF:000001', NULL, NULL, 'UPF0307 protein YjgA', NULL, NULL, NULL, NULL, NULL, 4),
(16788, NULL, 'G3DSA:1.10.20.10:FF:000369', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16789, NULL, 'G3DSA:3.40.50.150:FF:001597', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16790, NULL, 'G3DSA:1.25.10.10:FF:000256', NULL, NULL, 'Sterile alpha and TIR motif containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(16791, NULL, 'G3DSA:6.20.220.20:FF:000001', NULL, NULL, 'DNA repair protein RecO', NULL, NULL, NULL, NULL, NULL, 4),
(16792, NULL, 'G3DSA:4.10.1000.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16793, NULL, 'G3DSA:3.90.226.10:FF:000086', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(16794, NULL, 'G3DSA:1.10.510.10:FF:002285', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16795, NULL, 'G3DSA:3.40.50.2300:FF:000959', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16796, NULL, 'G3DSA:2.130.10.10:FF:005048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16797, NULL, 'G3DSA:1.10.8.60:FF:000438', NULL, NULL, 'Peroxisomal acyl-coenzyme A oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(16798, NULL, 'G3DSA:2.10.110.10:FF:000165', NULL, NULL, 'Protein CBG12788', NULL, NULL, NULL, NULL, NULL, 4),
(16799, NULL, 'G3DSA:1.10.150.770:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(16800, NULL, 'G3DSA:2.60.120.10:FF:000817', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16801, NULL, 'G3DSA:3.40.30.10:FF:001179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16802, NULL, 'G3DSA:2.130.10.10:FF:001125', NULL, NULL, 'Kinesin family member 21A', NULL, NULL, NULL, NULL, NULL, 4),
(16803, NULL, 'G3DSA:1.20.58.390:FF:000112', NULL, NULL, 'Acetylcholine receptor subunit alpha-type unc-63', NULL, NULL, NULL, NULL, NULL, 4),
(16804, NULL, 'G3DSA:3.40.50.1820:FF:001698', NULL, NULL, 'Glycine-AMP ligase', NULL, NULL, NULL, NULL, NULL, 4),
(16805, NULL, 'G3DSA:1.20.1070.10:FF:001454', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16806, NULL, 'G3DSA:2.60.120.1030:FF:000001', NULL, NULL, 'Protein CLP1 homolog 5', NULL, NULL, NULL, NULL, NULL, 4),
(16807, NULL, 'G3DSA:3.90.230.10:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16808, NULL, 'G3DSA:3.40.50.720:FF:000565', NULL, NULL, 'Retinol dehydrogenase 10', NULL, NULL, NULL, NULL, NULL, 4),
(16809, NULL, 'G3DSA:2.130.10.10:FF:004531', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16810, NULL, 'G3DSA:3.40.50.880:FF:000208', NULL, NULL, 'Anthranilate synthase component II', NULL, NULL, NULL, NULL, NULL, 4),
(16811, NULL, 'G3DSA:3.80.10.10:FF:001237', NULL, NULL, 'Putative leucine-rich repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(16812, NULL, 'G3DSA:1.25.40.10:FF:004266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16813, NULL, 'G3DSA:1.20.1250.70:FF:000002', NULL, NULL, 'Interleukin', NULL, NULL, NULL, NULL, NULL, 4),
(16814, NULL, 'G3DSA:3.30.420.40:FF:000493', NULL, NULL, 'Putative NBD/HSP70 family sugar kinase', NULL, NULL, NULL, NULL, NULL, 4),
(16815, NULL, 'G3DSA:3.30.40.10:FF:000218', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(16816, NULL, 'G3DSA:2.60.40.1170:FF:000088', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16817, NULL, 'G3DSA:3.40.50.300:FF:006482', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16818, NULL, 'G3DSA:2.60.40.10:FF:005716', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16819, NULL, 'G3DSA:1.10.3500.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16820, NULL, 'G3DSA:1.10.510.10:FF:000840', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(16821, NULL, 'G3DSA:3.40.50.300:FF:004918', NULL, NULL, 'Elongator complex protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(16822, NULL, 'G3DSA:3.30.1390.20:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16823, NULL, 'G3DSA:3.80.10.10:FF:001676', NULL, NULL, 'Os02g0215700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(16824, NULL, 'G3DSA:3.40.50.2300:FF:000667', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16825, NULL, 'G3DSA:3.40.1170.10:FF:000028', NULL, NULL, 'DNA mismatch repair protein MSH3', NULL, NULL, NULL, NULL, NULL, 4),
(16826, NULL, 'G3DSA:1.20.1050.10:FF:000082', NULL, NULL, 'Glutathione transferase32', NULL, NULL, NULL, NULL, NULL, 4),
(16827, NULL, 'G3DSA:3.20.20.70:FF:000679', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16828, NULL, 'G3DSA:2.70.98.110:FF:000004', NULL, NULL, 'Mannosyl-oligosaccharide glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(16829, NULL, 'G3DSA:1.10.10.1140:FF:000001', NULL, NULL, 'Glutamine-dependent NAD(+) synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(16830, NULL, 'G3DSA:3.40.50.300:FF:001400', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(16831, NULL, 'G3DSA:1.10.400.10:FF:000039', NULL, NULL, 'Guanine nucleotide-binding protein G, putative', NULL, NULL, NULL, NULL, NULL, 4),
(16832, NULL, 'G3DSA:3.40.50.300:FF:003637', NULL, NULL, 'Uncharacterized protein YpbR', NULL, NULL, NULL, NULL, NULL, 4),
(16833, NULL, 'G3DSA:1.20.140.150:FF:000010', NULL, NULL, 'transmembrane protein 47', NULL, NULL, NULL, NULL, NULL, 4),
(16834, NULL, 'G3DSA:3.40.50.1100:FF:000088', NULL, NULL, 'Cystathionine beta-synthase, putative', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(16835, NULL, 'G3DSA:3.30.70.330:FF:002989', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16836, NULL, 'G3DSA:3.40.50.300:FF:005846', NULL, NULL, 'p-glycoprotein 2 putative', NULL, NULL, NULL, NULL, NULL, 4),
(16837, NULL, 'G3DSA:1.10.238.10:FF:000740', NULL, NULL, 'WD-40 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(16838, NULL, 'G3DSA:2.130.10.10:FF:003603', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(16839, NULL, 'G3DSA:1.25.40.190:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16840, NULL, 'G3DSA:3.40.50.2300:FF:001595', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16841, NULL, 'G3DSA:1.10.20.10:FF:000341', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16842, NULL, 'G3DSA:2.30.42.10:FF:000478', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16843, NULL, 'G3DSA:3.30.530.20:FF:000197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16844, NULL, 'G3DSA:3.30.40.10:FF:001146', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(16845, NULL, 'G3DSA:3.30.300.180:FF:000013', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(16846, NULL, 'G3DSA:3.20.70.20:FF:000044', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(16847, NULL, 'G3DSA:1.10.880.10:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16848, NULL, 'G3DSA:3.30.160.60:FF:001922', NULL, NULL, 'Zinc finger protein 658', NULL, NULL, NULL, NULL, NULL, 4),
(16849, NULL, 'G3DSA:3.30.310.50:FF:000049', NULL, NULL, 'Phosphoglucomutase', NULL, NULL, NULL, NULL, NULL, 4),
(16850, NULL, 'G3DSA:4.10.830.10:FF:000004', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] iron-sulfur subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(16851, NULL, 'G3DSA:3.20.20.60:FF:000058', NULL, NULL, 'Isocitrate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(16852, NULL, 'G3DSA:2.120.10.30:FF:000524', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16853, NULL, 'G3DSA:1.10.287.110:FF:000232', NULL, NULL, 'DnaJ-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(16854, NULL, 'G3DSA:3.90.550.10:FF:000592', NULL, NULL, '3-deoxy-manno-octulosonate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(16855, NULL, 'G3DSA:3.30.70.870:FF:000032', NULL, NULL, 'Translation elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(16856, NULL, 'G3DSA:1.10.150.20:FF:000034', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(16857, NULL, 'G3DSA:3.30.110.20:FF:000025', NULL, NULL, 'Putative beta-14-xylosyltransferase IRX10L', NULL, NULL, NULL, NULL, NULL, 4),
(16858, NULL, 'G3DSA:2.10.25.10:FF:000883', NULL, NULL, 'Delta/notch-like EGF repeat containing', NULL, NULL, NULL, NULL, NULL, 4),
(16859, NULL, 'G3DSA:1.25.40.270:FF:000005', NULL, NULL, 'Protein HOMOLOG OF MAMMALIAN LYST-INTERACTING PROTEIN 5', NULL, NULL, NULL, NULL, NULL, 4),
(16860, NULL, 'G3DSA:4.10.60.10:FF:000224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16861, NULL, 'G3DSA:2.60.40.10:FF:002462', NULL, NULL, 'PKHD1 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(16862, NULL, 'G3DSA:1.10.150.810:FF:000004', NULL, NULL, 'DNA polymerase kappa, putative', NULL, NULL, NULL, NULL, NULL, 4),
(16863, NULL, 'G3DSA:2.60.120.920:FF:000070', NULL, NULL, 'Neuralized E3 ubiquitin protein ligase 2', NULL, NULL, NULL, NULL, NULL, 4),
(16864, NULL, 'G3DSA:2.10.10.10:FF:000006', NULL, NULL, 'Insulin-like growth factor 2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(16865, NULL, 'G3DSA:2.110.10.10:FF:000007', NULL, NULL, 'stromelysin-3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(16866, NULL, 'G3DSA:3.40.50.261:FF:000035', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(16867, NULL, 'G3DSA:2.10.60.10:FF:000009', NULL, NULL, 'TGF-beta receptor type-2', NULL, NULL, NULL, NULL, NULL, 4),
(16868, NULL, 'G3DSA:3.20.20.80:FF:000036', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(16869, NULL, 'G3DSA:2.60.40.420:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16870, NULL, 'G3DSA:1.10.630.10:FF:000787', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16871, NULL, 'G3DSA:1.10.150.50:FF:000110', NULL, NULL, 'Mammalian ZAK kinase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(16872, NULL, 'G3DSA:2.60.40.10:FF:004699', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16873, NULL, 'G3DSA:2.70.20.10:FF:000021', NULL, NULL, 'DNA topoisomerase 3', NULL, NULL, NULL, NULL, NULL, 4),
(16874, NULL, 'G3DSA:3.40.1090.10:FF:000027', NULL, NULL, 'Patatin like phospholipase domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(16875, NULL, 'G3DSA:3.80.10.10:FF:003362', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16876, NULL, 'G3DSA:3.30.160.60:FF:003075', NULL, NULL, 'GM13856', NULL, NULL, NULL, NULL, NULL, 4),
(16877, NULL, 'G3DSA:3.10.20.90:FF:000826', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16878, NULL, 'G3DSA:3.30.60.20:FF:000077', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(16879, NULL, 'G3DSA:3.40.50.300:FF:003076', NULL, NULL, 'Rho family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(16880, NULL, 'G3DSA:2.60.40.10:FF:001973', NULL, NULL, 'Plexin A4, B', NULL, NULL, NULL, NULL, NULL, 4),
(16881, NULL, 'G3DSA:3.40.390.10:FF:000051', NULL, NULL, 'ADAM metallopeptidase domain 17', NULL, NULL, NULL, NULL, NULL, 4),
(16882, NULL, 'G3DSA:2.130.10.10:FF:005992', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16883, NULL, 'G3DSA:3.40.50.150:FF:000669', NULL, NULL, 'Cyanobacterial-type MPBQ/MSBQ methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(16884, NULL, 'G3DSA:3.30.1490.190:FF:000004', NULL, NULL, 'Transcriptional regulator (Fur family)', NULL, NULL, NULL, NULL, NULL, 4),
(16885, NULL, 'G3DSA:3.30.70.330:FF:000191', NULL, NULL, 'Oligouridylate-binding protein 1C', NULL, NULL, NULL, NULL, NULL, 4),
(16886, NULL, 'G3DSA:3.30.160.60:FF:005284', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16887, NULL, 'G3DSA:2.30.30.100:FF:000078', NULL, NULL, 'Small nuclear ribonucleoprotein E', NULL, NULL, NULL, NULL, NULL, 4),
(16888, NULL, 'G3DSA:2.60.120.260:FF:000208', NULL, NULL, 'von Willebrand factor D and EGF domains', NULL, NULL, NULL, NULL, NULL, 4),
(16889, NULL, 'G3DSA:1.10.510.10:FF:001357', NULL, NULL, 'Serine/threonine protein kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(16890, NULL, 'G3DSA:3.30.1060.10:FF:000005', NULL, NULL, 'Peptide methionine sulfoxide reductase MsrA', NULL, NULL, NULL, NULL, NULL, 4),
(16891, NULL, 'G3DSA:1.10.340.70:FF:000007', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(16892, NULL, 'G3DSA:2.60.40.790:FF:000145', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16893, NULL, 'G3DSA:2.170.210.20:FF:000003', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(16894, NULL, 'G3DSA:3.40.50.360:FF:000114', NULL, NULL, 'FMN-dependent NADH-azoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(16895, NULL, 'G3DSA:3.10.600.10:FF:000002', NULL, NULL, 'Pyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(16896, NULL, 'G3DSA:3.40.50.1820:FF:001670', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16897, NULL, 'G3DSA:3.40.50.2000:FF:000167', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(16898, NULL, 'G3DSA:1.10.10.600:FF:000002', NULL, NULL, 'FeS assembly protein IscX', NULL, NULL, NULL, NULL, NULL, 4),
(16899, NULL, 'G3DSA:1.10.287.1490:FF:000017', NULL, NULL, 'Repeat organellar protein', NULL, NULL, NULL, NULL, NULL, 4),
(16900, NULL, 'G3DSA:2.60.40.10:FF:000837', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', NULL, NULL, NULL, NULL, NULL, 4),
(16901, NULL, 'G3DSA:3.30.70.1620:FF:000016', NULL, NULL, 'Chromosome partition protein Smc', NULL, NULL, NULL, NULL, NULL, 4),
(16902, NULL, 'G3DSA:2.60.40.10:FF:000253', NULL, NULL, 'Sidekick cell adhesion molecule 1', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(16903, NULL, 'G3DSA:2.30.29.30:FF:000700', NULL, NULL, 'Probable serine/threonine-protein kinase DDB_G0272282', NULL, NULL, NULL, NULL, NULL, 4),
(16904, NULL, 'G3DSA:3.30.870.10:FF:000118', NULL, NULL, 'Phospholipase D/Transphosphatidylase', NULL, NULL, NULL, NULL, NULL, 4),
(16905, NULL, 'G3DSA:4.10.400.10:FF:000039', NULL, NULL, 'Sortilin related receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(16906, NULL, 'G3DSA:3.40.50.300:FF:000675', NULL, NULL, 'V-type ATP synthase alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(16907, NULL, 'G3DSA:1.20.1050.10:FF:000110', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(16908, NULL, 'G3DSA:3.30.60.20:FF:000138', NULL, NULL, 'Thymidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(16909, NULL, 'G3DSA:3.80.10.10:FF:001445', NULL, NULL, 'F-box protein At5g51380', NULL, NULL, NULL, NULL, NULL, 4),
(16910, NULL, 'G3DSA:1.25.10.10:FF:002229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16911, NULL, 'G3DSA:2.130.10.10:FF:004031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16912, NULL, 'G3DSA:2.60.200.20:FF:000208', NULL, NULL, 'Fork head protein homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(16913, NULL, 'G3DSA:3.30.310.50:FF:000021', NULL, NULL, 'GlcNAc phosphomutase', NULL, NULL, NULL, NULL, NULL, 4),
(16914, NULL, 'G3DSA:3.30.200.20:FF:001021', NULL, NULL, 'Hypoxia Inhibited Receptor tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(16915, NULL, 'G3DSA:3.30.70.240:FF:000017', NULL, NULL, 'TetQ family GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(16916, NULL, 'G3DSA:1.25.40.10:FF:003310', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g62260, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(16917, NULL, 'G3DSA:3.40.50.300:FF:000203', NULL, NULL, 'Putative ras-related protein ral-a', NULL, NULL, NULL, NULL, NULL, 4),
(16918, NULL, 'G3DSA:1.20.5.190:FF:000024', NULL, NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(16919, NULL, 'G3DSA:2.60.40.10:FF:003390', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16920, NULL, 'G3DSA:3.50.50.60:FF:001155', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(16921, NULL, 'G3DSA:3.40.50.300:FF:004418', NULL, NULL, 'Dephospho-CoA kinase', NULL, NULL, NULL, NULL, NULL, 4),
(16922, NULL, 'G3DSA:1.50.40.10:FF:000520', NULL, NULL, 'Mitochondrial glycine transporter', NULL, NULL, NULL, NULL, NULL, 4),
(16923, NULL, 'G3DSA:3.30.210.10:FF:000001', NULL, NULL, 'DNA polymerase lambda', NULL, NULL, NULL, NULL, NULL, 4),
(16924, NULL, 'G3DSA:1.10.3720.10:FF:000029', NULL, NULL, 'Spermidine/putrescine ABC transporter permease PotB', NULL, NULL, NULL, NULL, NULL, 4),
(16925, NULL, 'G3DSA:3.40.50.720:FF:000773', NULL, NULL, 'High chlorophyll fluorescence phenotype 173', NULL, NULL, NULL, NULL, NULL, 4),
(16926, NULL, 'G3DSA:2.60.40.2030:FF:000003', NULL, NULL, 'Fraser extracellular matrix complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(16927, NULL, 'G3DSA:1.10.510.10:FF:000901', NULL, NULL, 'Maternal embryonic leucine zipper kinase', NULL, NULL, NULL, NULL, NULL, 4),
(16928, NULL, 'G3DSA:1.10.10.60:FF:000366', NULL, NULL, 'Transcriptional coactivator ADA2', NULL, NULL, NULL, NULL, NULL, 4),
(16929, NULL, 'G3DSA:1.10.287.70:FF:000399', NULL, NULL, 'G protein-activated inward rectifier potassium channel 4', NULL, NULL, NULL, NULL, NULL, 4),
(16930, NULL, 'G3DSA:3.40.30.10:FF:000931', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16931, NULL, 'G3DSA:3.30.160.60:FF:002939', NULL, NULL, 'Protein CBR-BLMP-1', NULL, NULL, NULL, NULL, NULL, 4),
(16932, NULL, 'G3DSA:3.60.130.10:FF:000016', NULL, NULL, 'YHL021C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(16933, NULL, 'G3DSA:3.80.10.10:FF:004110', NULL, NULL, 'Immunoglobulin superfamily member 10', NULL, NULL, NULL, NULL, NULL, 4),
(16934, NULL, 'G3DSA:1.25.40.10:FF:002321', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g18970', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(16935, NULL, 'G3DSA:3.30.1300.10:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16936, NULL, 'G3DSA:1.10.287.600:FF:000019', NULL, NULL, 'Tubulin alpha-1 chain', NULL, NULL, NULL, NULL, NULL, 4),
(16937, NULL, 'G3DSA:2.60.40.60:FF:000274', NULL, NULL, 'neural-cadherin isoform X9', NULL, NULL, NULL, NULL, NULL, 4),
(16938, NULL, 'G3DSA:3.90.70.10:FF:000555', NULL, NULL, 'Calpain-3', NULL, NULL, NULL, NULL, NULL, 4),
(16939, NULL, 'G3DSA:2.40.10.10:FF:000674', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16940, NULL, 'G3DSA:3.30.750.24:FF:000010', NULL, NULL, 'Solute carrier family 26 member 9', NULL, NULL, NULL, NULL, NULL, 4),
(16941, NULL, 'G3DSA:2.30.30.40:FF:000066', NULL, NULL, 'dynamin-binding protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(16942, NULL, 'G3DSA:1.20.1310.10:FF:000029', NULL, NULL, 'Cullin homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(16943, NULL, 'G3DSA:2.130.10.10:FF:000377', NULL, NULL, 'uncharacterized protein LOC108094137 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(16944, NULL, 'G3DSA:2.170.130.20:FF:000002', NULL, NULL, 'Discoidin, CUB and LCCL domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(16945, NULL, 'G3DSA:3.30.70.330:FF:000752', NULL, NULL, 'Peroxisome proliferator-activated receptor gamma, coactivator 1 alpha', NULL, NULL, NULL, NULL, NULL, 4),
(16946, NULL, 'G3DSA:3.40.50.300:FF:007499', NULL, NULL, 'ATP-dependent RNA helicase dbp10', NULL, NULL, NULL, NULL, NULL, 4),
(16947, NULL, 'G3DSA:1.10.287.40:FF:000031', NULL, NULL, 'Serine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(16948, NULL, 'G3DSA:1.20.120.1760:FF:000080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16949, NULL, 'G3DSA:3.90.550.10:FF:000412', NULL, NULL, 'Asparagine Linked Glycosylation (ALG) homolog, Nematode', NULL, NULL, NULL, NULL, NULL, 4),
(16950, NULL, 'G3DSA:1.10.287.940:FF:000008', NULL, NULL, 'P2X purinoceptor', NULL, NULL, NULL, NULL, NULL, 4),
(16951, NULL, 'G3DSA:3.10.110.10:FF:000358', NULL, NULL, 'Ubiquitin-conjugating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(16952, NULL, 'G3DSA:1.20.58.60:FF:000431', NULL, NULL, 'Spectrin, beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(16953, NULL, 'G3DSA:2.40.50.140:FF:000614', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(16954, NULL, 'G3DSA:3.30.505.10:FF:000063', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(16955, NULL, 'G3DSA:3.30.750.44:FF:000016', NULL, NULL, 'Os02g0815700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(16956, NULL, 'G3DSA:3.90.600.10:FF:000001', NULL, NULL, 'Trifunctional purine biosynthetic protein adenosine-3', NULL, NULL, NULL, NULL, NULL, 4),
(16957, NULL, 'G3DSA:2.60.40.150:FF:000689', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(16958, NULL, 'G3DSA:2.30.42.10:FF:000186', NULL, NULL, 'Big bang, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(16959, NULL, 'G3DSA:3.30.497.10:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16960, NULL, 'G3DSA:3.40.50.720:FF:002010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16961, NULL, 'G3DSA:3.90.1200.10:FF:000003', NULL, NULL, 'fructosamine-3-kinase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(16962, NULL, 'G3DSA:3.30.40.10:FF:002282', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(16963, NULL, 'G3DSA:3.30.160.60:FF:000433', NULL, NULL, 'zinc finger protein 384 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(16964, NULL, 'G3DSA:3.30.200.20:FF:000032', NULL, NULL, 'Serine/threonine-protein kinase D6PK-like', NULL, NULL, NULL, NULL, NULL, 4),
(16965, NULL, 'G3DSA:1.25.40.20:FF:000233', NULL, NULL, 'SH3 and multiple ankyrin repeat domains protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(16966, NULL, 'G3DSA:3.20.20.70:FF:000387', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(16967, NULL, 'G3DSA:2.30.30.1190:FF:000011', NULL, NULL, 'cDNA clone:002-103-E06, full insert sequence', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(16968, NULL, 'G3DSA:1.20.58.340:FF:000030', NULL, NULL, 'Magnesium transporter MRS2-3', NULL, NULL, NULL, NULL, NULL, 4),
(16969, NULL, 'G3DSA:1.10.150.210:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16970, NULL, 'G3DSA:1.10.10.1050:FF:000007', NULL, NULL, 'Unplaced genomic scaffold supercont1.26, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(16971, NULL, 'G3DSA:2.170.270.10:FF:000122', NULL, NULL, 'SET (Trithorax/polycomb) domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(16972, NULL, 'G3DSA:3.40.50.1820:FF:001759', NULL, NULL, 'Beta-hydroxypalmitic acid methyl ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(16973, NULL, 'G3DSA:3.40.50.720:FF:001762', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16974, NULL, 'G3DSA:1.10.472.80:FF:000035', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(16975, NULL, 'G3DSA:2.60.200.20:FF:000063', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(16976, NULL, 'G3DSA:3.30.160.60:FF:000169', NULL, NULL, 'transcriptional repressor scratch 2', NULL, NULL, NULL, NULL, NULL, 4),
(16977, NULL, 'G3DSA:1.10.510.10:FF:002346', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16978, NULL, 'G3DSA:1.10.510.10:FF:003066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16979, NULL, 'G3DSA:3.40.1390.10:FF:000011', NULL, NULL, 'UDP-N-acetylmuramoyl-L-alanyl-D-glutamate--2,6-diaminopimelate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(16980, NULL, 'G3DSA:3.40.50.970:FF:000090', NULL, NULL, 'Sulfoacetaldehyde acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(16981, NULL, 'G3DSA:2.130.10.10:FF:002322', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit WDR4', NULL, NULL, NULL, NULL, NULL, 4),
(16982, NULL, 'G3DSA:1.10.8.10:FF:000356', NULL, NULL, 'UBA domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(16983, NULL, 'G3DSA:3.30.1330.30:FF:000055', NULL, NULL, 'Group 3 RNA methyltransferase TrmH', NULL, NULL, NULL, NULL, NULL, 4),
(16984, NULL, 'G3DSA:3.80.10.10:FF:003154', NULL, NULL, 'F-box protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(16985, NULL, 'G3DSA:1.10.8.70:FF:000003', NULL, NULL, 'Glutamate--tRNA ligase 1', NULL, NULL, NULL, NULL, NULL, 4),
(16986, NULL, 'G3DSA:2.40.50.140:FF:000878', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16987, NULL, 'G3DSA:1.25.10.10:FF:000195', NULL, NULL, 'Importin subunit beta-4', NULL, NULL, NULL, NULL, NULL, 4),
(16988, NULL, 'G3DSA:2.60.120.650:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16989, NULL, 'G3DSA:1.10.150.130:FF:000014', NULL, NULL, 'Putative integrase', NULL, NULL, NULL, NULL, NULL, 4),
(16990, NULL, 'G3DSA:3.30.450.40:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16991, NULL, 'G3DSA:3.40.1810.10:FF:000084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16992, NULL, 'G3DSA:1.20.1070.10:FF:001685', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(16993, NULL, 'G3DSA:1.50.10.20:FF:000049', NULL, NULL, 'Putative cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(16994, NULL, 'G3DSA:2.60.40.10:FF:001029', NULL, NULL, 'Macrophage colony-stimulating factor 1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(16995, NULL, 'G3DSA:3.90.950.10:FF:000021', NULL, NULL, 'Maf-like protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(16996, NULL, 'G3DSA:1.10.510.10:FF:004494', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16997, NULL, 'G3DSA:3.30.70.330:FF:002309', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(16998, NULL, 'G3DSA:3.30.40.10:FF:001707', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(16999, NULL, 'G3DSA:3.10.100.10:FF:000329', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17000, NULL, 'G3DSA:1.10.10.10:FF:001032', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(17001, NULL, 'G3DSA:3.30.559.30:FF:000018', NULL, NULL, 'Nonribosomal siderophore peptide synthase SidC', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(17002, NULL, 'G3DSA:2.60.220.50:FF:000022', NULL, NULL, 'Adhesion G protein-coupled receptor E3', NULL, NULL, NULL, NULL, NULL, 4),
(17003, NULL, 'G3DSA:3.30.160.60:FF:005492', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17004, NULL, 'G3DSA:1.10.150.240:FF:000108', NULL, NULL, 'Slr0586 protein', NULL, NULL, NULL, NULL, NULL, 4),
(17005, NULL, 'G3DSA:3.30.160.60:FF:004064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17006, NULL, 'G3DSA:3.80.10.10:FF:003862', NULL, NULL, 'Leucine-rich repeat receptor protein kinase MSL1', NULL, NULL, NULL, NULL, NULL, 4),
(17007, NULL, 'G3DSA:2.60.120.10:FF:000789', NULL, NULL, 'Cyclic nucleotide-binding', NULL, NULL, NULL, NULL, NULL, 4),
(17008, NULL, 'G3DSA:3.40.50.1000:FF:000176', NULL, NULL, '5''-nucleotidase domain-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17009, NULL, 'G3DSA:4.10.280.110:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17010, NULL, 'G3DSA:3.30.70.2600:FF:000001', NULL, NULL, 'Dipeptidyl peptidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(17011, NULL, 'G3DSA:1.20.58.60:FF:000200', NULL, NULL, 'Karst, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(17012, NULL, 'G3DSA:2.60.210.10:FF:000032', NULL, NULL, 'TRAF-like family protein', NULL, NULL, NULL, NULL, NULL, 4),
(17013, NULL, 'G3DSA:1.25.40.20:FF:000941', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17014, NULL, 'G3DSA:1.10.510.10:FF:003774', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17015, NULL, 'G3DSA:1.10.510.10:FF:002610', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17016, NULL, 'G3DSA:3.40.47.10:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17017, NULL, 'G3DSA:1.10.10.10:FF:000312', NULL, NULL, 'Pleckstrin 2', NULL, NULL, NULL, NULL, NULL, 4),
(17018, NULL, 'G3DSA:1.10.1170.10:FF:000008', NULL, NULL, 'Putative e3 ubiquitin-protein ligase xiap', NULL, NULL, NULL, NULL, NULL, 4),
(17019, NULL, 'G3DSA:1.10.20.120:FF:000017', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17020, NULL, 'G3DSA:2.60.40.10:FF:003710', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17021, NULL, 'G3DSA:1.10.630.10:FF:000107', NULL, NULL, 'Benzoate 4-monooxygenase cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(17022, NULL, 'G3DSA:3.40.50.620:FF:000889', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17023, NULL, 'G3DSA:3.40.395.10:FF:000039', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17024, NULL, 'G3DSA:1.25.10.10:FF:002381', NULL, NULL, 'AGAP004322-PA', NULL, NULL, NULL, NULL, NULL, 4),
(17025, NULL, 'G3DSA:1.10.10.410:FF:000012', NULL, NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit E', NULL, NULL, NULL, NULL, NULL, 4),
(17026, NULL, 'G3DSA:3.40.50.10330:FF:000080', NULL, NULL, 'Sphingosine kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(17027, NULL, 'G3DSA:2.60.40.60:FF:001055', NULL, NULL, 'R-cadherin', NULL, NULL, NULL, NULL, NULL, 4),
(17028, NULL, 'G3DSA:3.30.450.20:FF:000016', NULL, NULL, 'Circadian locomoter output cycles protein', NULL, NULL, NULL, NULL, NULL, 4),
(17029, NULL, 'G3DSA:3.40.50.2300:FF:001448', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17030, NULL, 'G3DSA:3.30.56.10:FF:000030', NULL, NULL, 'Phenylalanyl-tRNA synthetase beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(17031, NULL, 'G3DSA:1.20.1560.10:FF:000340', NULL, NULL, 'Multiple drug resistance-associated protein-like transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(17032, NULL, 'G3DSA:2.170.150.80:FF:000027', NULL, NULL, 'NAC domain transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(17033, NULL, 'G3DSA:3.90.810.10:FF:000011', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17034, NULL, 'G3DSA:2.60.120.1330:FF:000001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17035, NULL, 'G3DSA:3.40.1410.10:FF:000036', NULL, NULL, 'HTH-type transcriptional repressor YvoA', NULL, NULL, NULL, NULL, NULL, 4),
(17036, NULL, 'G3DSA:3.40.50.300:FF:007763', NULL, NULL, 'Protein CBG01006', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(17037, NULL, 'G3DSA:3.50.50.60:FF:000435', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(17038, NULL, 'G3DSA:3.30.1120.90:FF:000012', NULL, NULL, 'Nucleosome assembly protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(17039, NULL, 'G3DSA:1.10.533.20:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17040, NULL, 'G3DSA:3.40.50.300:FF:000883', NULL, NULL, 'Multidrug ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(17041, NULL, 'G3DSA:1.20.140.40:FF:000082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17042, NULL, 'G3DSA:3.30.40.10:FF:002074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17043, NULL, 'G3DSA:3.40.50.150:FF:001125', NULL, NULL, 'Mitochondrial transcription factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(17044, NULL, 'G3DSA:3.40.50.300:FF:006774', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17045, NULL, 'G3DSA:2.130.10.10:FF:003311', NULL, NULL, 'Protein CBG01041', NULL, NULL, NULL, NULL, NULL, 4),
(17046, NULL, 'G3DSA:3.20.20.10:FF:000004', NULL, NULL, 'Pyridoxal phosphate homeostasis protein', NULL, NULL, NULL, NULL, NULL, 4),
(17047, NULL, 'G3DSA:3.40.50.2300:FF:000375', NULL, NULL, 'Hybrid signal transduction histidine kinase K', NULL, NULL, NULL, NULL, NULL, 4),
(17048, NULL, 'G3DSA:3.30.200.20:FF:000616', NULL, NULL, 'AKT serine/threonine kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(17049, NULL, 'G3DSA:1.10.10.10:FF:000076', NULL, NULL, 'Forkhead box protein D3', NULL, NULL, NULL, NULL, NULL, 4),
(17050, NULL, 'G3DSA:3.40.50.720:FF:002482', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17051, NULL, 'G3DSA:3.40.50.300:FF:004626', NULL, NULL, 'Probable ATP-binding component of ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(17052, NULL, 'G3DSA:1.10.510.10:FF:001621', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17053, NULL, 'G3DSA:1.10.10.10:FF:000784', NULL, NULL, 'Protein CBR-TAG-97', NULL, NULL, NULL, NULL, NULL, 4),
(17054, NULL, 'G3DSA:1.25.10.10:FF:002965', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17055, NULL, 'G3DSA:3.30.420.40:FF:000785', NULL, NULL, 'AaceriABR084Wp', NULL, NULL, NULL, NULL, NULL, 4),
(17056, NULL, 'G3DSA:2.60.40.60:FF:000066', NULL, NULL, 'FAT atypical cadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(17057, NULL, 'G3DSA:3.40.50.12550:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17058, NULL, 'G3DSA:2.60.40.10:FF:000484', NULL, NULL, 'Tyrosine-protein kinase receptor TYRO3', NULL, NULL, NULL, NULL, NULL, 4),
(17059, NULL, 'G3DSA:3.10.100.10:FF:000273', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17060, NULL, 'G3DSA:2.60.40.420:FF:000085', NULL, NULL, 'Multicopper oxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17061, NULL, 'G3DSA:3.90.1750.10:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17062, NULL, 'G3DSA:3.40.1190.20:FF:000212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17063, NULL, 'G3DSA:2.10.25.10:FF:000939', NULL, NULL, 'Low-density lipoprotein receptor-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(17064, NULL, 'G3DSA:3.90.1420.10:FF:000014', NULL, NULL, '[Ribulose-bisphosphate-carboxylase]-lysine N-methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17065, NULL, 'G3DSA:3.30.70.1400:FF:000006', NULL, NULL, 'Glycine cleavage system T protein', NULL, NULL, NULL, NULL, NULL, 4),
(17066, NULL, 'G3DSA:1.10.238.10:FF:000499', NULL, NULL, 'Dual oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(17067, NULL, 'G3DSA:2.60.40.10:FF:002018', NULL, NULL, 'Jitterbug, isoform M', NULL, NULL, NULL, NULL, NULL, 4),
(17068, NULL, 'G3DSA:3.90.1290.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17069, NULL, 'G3DSA:3.40.50.300:FF:007027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17070, NULL, 'G3DSA:2.20.100.10:FF:000230', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs gon-1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(17071, NULL, 'G3DSA:1.20.58.60:FF:000167', NULL, NULL, 'microtubule-actin cross-linking factor 1 isoform X9', NULL, NULL, NULL, NULL, NULL, 4),
(17072, NULL, 'G3DSA:1.25.10.10:FF:003218', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17073, NULL, 'G3DSA:3.30.200.20:FF:000296', NULL, NULL, 'Receptor-like kinase LRK10', NULL, NULL, NULL, NULL, NULL, 4),
(17074, NULL, 'G3DSA:2.70.170.10:FF:000071', NULL, NULL, 'Nicotinic acetylcholine receptor Dalpha7 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(17075, NULL, 'G3DSA:3.30.572.10:FF:000004', NULL, NULL, 'Bifunctional dihydrofolate reductase-thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(17076, NULL, 'G3DSA:3.10.520.10:FF:000001', NULL, NULL, 'FAD:protein FMN transferase', NULL, NULL, NULL, NULL, NULL, 4),
(17077, NULL, 'G3DSA:1.20.58.390:FF:000292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17078, NULL, 'G3DSA:3.30.50.10:FF:000163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17079, NULL, 'G3DSA:1.10.510.10:FF:002138', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(17080, NULL, 'G3DSA:3.30.70.1730:FF:000021', NULL, NULL, '60S acidic ribosomal protein P0', NULL, NULL, NULL, NULL, NULL, 4),
(17081, NULL, 'G3DSA:3.10.20.90:FF:000798', NULL, NULL, 'UBX domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(17082, NULL, 'G3DSA:1.20.5.340:FF:000058', NULL, NULL, 'MYO-2', NULL, NULL, NULL, NULL, NULL, 4),
(17083, NULL, 'G3DSA:2.40.240.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17084, NULL, 'G3DSA:2.60.40.150:FF:000161', NULL, NULL, 'Synaptotagmin 15', NULL, NULL, NULL, NULL, NULL, 4),
(17085, NULL, 'G3DSA:2.40.30.170:FF:000001', NULL, NULL, 'Multidrug resistance efflux transporter MdtE', NULL, NULL, NULL, NULL, NULL, 4),
(17086, NULL, 'G3DSA:3.40.630.10:FF:000087', NULL, NULL, 'Probable cytosol aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(17087, NULL, 'G3DSA:3.40.50.300:FF:006251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17088, NULL, 'G3DSA:3.40.630.10:FF:000407', NULL, NULL, 'Succinyl-diaminopimelate desuccinylase', NULL, NULL, NULL, NULL, NULL, 4),
(17089, NULL, 'G3DSA:3.40.50.410:FF:000152', NULL, NULL, 'TFIIH P44', NULL, NULL, NULL, NULL, NULL, 4),
(17090, NULL, 'G3DSA:1.20.1250.20:FF:001229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17091, NULL, 'G3DSA:3.30.500.10:FF:000012', NULL, NULL, 'Glycoprotein UL18', NULL, NULL, NULL, NULL, NULL, 4),
(17092, NULL, 'G3DSA:3.40.710.10:FF:000088', NULL, NULL, 'Cell division protein', NULL, NULL, NULL, NULL, NULL, 4),
(17093, NULL, 'G3DSA:2.130.10.10:FF:000641', NULL, NULL, 'F-box/WD repeat-containing protein 9 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(17094, NULL, 'G3DSA:2.120.10.30:FF:000232', NULL, NULL, 'Protein CBR-DPF-5', NULL, NULL, NULL, NULL, NULL, 4),
(17095, NULL, 'G3DSA:3.60.10.10:FF:000266', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17096, NULL, 'G3DSA:1.10.10.10:FF:002021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17097, NULL, 'G3DSA:2.60.260.20:FF:000072', NULL, NULL, 'Chaperone protein DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(17098, NULL, 'G3DSA:2.60.40.60:FF:000627', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17099, NULL, 'G3DSA:1.10.8.500:FF:000002', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(17100, NULL, 'G3DSA:1.10.10.60:FF:000630', NULL, NULL, 'Photoperiod independent early flowering protein', NULL, NULL, NULL, NULL, NULL, 4),
(17101, NULL, 'G3DSA:2.130.10.10:FF:003250', NULL, NULL, 'LD47550p', NULL, NULL, NULL, NULL, NULL, 4),
(17102, NULL, 'G3DSA:3.30.70.330:FF:002197', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17103, NULL, 'G3DSA:2.40.10.120:FF:000027', NULL, NULL, 'Trypsin domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(17104, NULL, 'G3DSA:1.10.167.10:FF:000069', NULL, NULL, 'Sorting nexin-12', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(17105, NULL, 'G3DSA:2.40.30.10:FF:000118', NULL, NULL, 'Translation elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(17106, NULL, 'G3DSA:3.30.70.330:FF:002517', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17107, NULL, 'G3DSA:1.10.510.10:FF:003274', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17108, NULL, 'G3DSA:1.10.1670.40:FF:000016', NULL, NULL, 'DNA-3-methyladenine glycosylase II, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17109, NULL, 'G3DSA:3.30.70.370:FF:000005', NULL, NULL, 'DNA polymerase theta', NULL, NULL, NULL, NULL, NULL, 4),
(17110, NULL, 'G3DSA:3.30.160.60:FF:006273', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17111, NULL, 'G3DSA:1.10.10.10:FF:000576', NULL, NULL, 'Transcriptional regulator HosA', NULL, NULL, NULL, NULL, NULL, 4),
(17112, NULL, 'G3DSA:1.50.40.10:FF:000284', NULL, NULL, 'Mitochondrial carrier protein (Rim2), putative (AFU_orthologue AFUA_3G06950)', NULL, NULL, NULL, NULL, NULL, 4),
(17113, NULL, 'G3DSA:4.10.970.10:FF:000014', NULL, NULL, 'Ku70-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(17114, NULL, 'G3DSA:3.30.420.40:FF:000993', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17115, NULL, 'G3DSA:3.30.420.110:FF:000047', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(17116, NULL, 'G3DSA:3.90.980.20:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17117, NULL, 'G3DSA:1.20.1070.10:FF:000757', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17118, NULL, 'G3DSA:3.40.50.300:FF:002209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17119, NULL, 'G3DSA:3.90.1150.10:FF:000089', NULL, NULL, 'Threonine aldolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17120, NULL, 'G3DSA:3.30.160.20:FF:000005', NULL, NULL, 'Putative double-stranded RNA-specific adenosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(17121, NULL, 'G3DSA:3.30.160.60:FF:000933', NULL, NULL, 'zinc finger protein 771', NULL, NULL, NULL, NULL, NULL, 4),
(17122, NULL, 'G3DSA:3.40.50.1820:FF:000742', NULL, NULL, 'Putative inactive methylesterase 20', NULL, NULL, NULL, NULL, NULL, 4),
(17123, NULL, 'G3DSA:2.130.10.10:FF:006037', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17124, NULL, 'G3DSA:2.60.40.10:FF:005508', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17125, NULL, 'G3DSA:1.10.418.10:FF:000041', NULL, NULL, 'Fimbrin-2 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(17126, NULL, 'G3DSA:1.25.40.10:FF:004474', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17127, NULL, 'G3DSA:2.60.40.820:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17128, NULL, 'G3DSA:3.80.10.10:FF:002373', NULL, NULL, 'Os03g0400800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(17129, NULL, 'G3DSA:1.10.150.390:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17130, NULL, 'G3DSA:1.20.1070.10:FF:000173', NULL, NULL, 'Free fatty acid receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(17131, NULL, 'G3DSA:3.40.50.300:FF:006982', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17132, NULL, 'G3DSA:3.40.640.10:FF:000436', NULL, NULL, 'Transcriptional regulator (DegT/DnrJ/Eryc1 family)', NULL, NULL, NULL, NULL, NULL, 4),
(17133, NULL, 'G3DSA:1.25.10.10:FF:000548', NULL, NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(17134, NULL, 'G3DSA:2.60.40.10:FF:004227', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17135, NULL, 'G3DSA:3.30.2320.40:FF:000001', NULL, NULL, 'Capsid vertex protein', NULL, NULL, NULL, NULL, NULL, 4),
(17136, NULL, 'G3DSA:2.130.10.10:FF:003103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17137, NULL, 'G3DSA:2.60.40.10:FF:002518', NULL, NULL, 'Protein sidekick homolog', NULL, NULL, NULL, NULL, NULL, 4),
(17138, NULL, 'G3DSA:1.20.1280.50:FF:000083', NULL, NULL, 'Lysine (K)-specific demethylase 2B', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(17139, NULL, 'G3DSA:3.30.200.20:FF:002241', NULL, NULL, 'Zgc:171775', NULL, NULL, NULL, NULL, NULL, 4),
(17140, NULL, 'G3DSA:3.30.559.10:FF:000182', NULL, NULL, 'HC-toxin synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(17141, NULL, 'G3DSA:1.25.40.10:FF:004327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17142, NULL, 'G3DSA:3.30.900.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17143, NULL, 'G3DSA:2.30.250.10:FF:000013', NULL, NULL, 'Clan MH, family M18, aspartyl aminopeptidase-like metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(17144, NULL, 'G3DSA:3.40.50.300:FF:001900', NULL, NULL, 'Multidrug resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(17145, NULL, 'G3DSA:3.40.50.300:FF:005346', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17146, NULL, 'G3DSA:3.50.50.60:FF:000227', NULL, NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(17147, NULL, 'G3DSA:1.20.1740.10:FF:000258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17148, NULL, 'G3DSA:1.20.1270.10:FF:000093', NULL, NULL, 'Hsp70 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17149, NULL, 'G3DSA:3.30.40.10:FF:001354', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(17150, NULL, 'G3DSA:3.40.50.720:FF:000065', NULL, NULL, 'UDP-glucuronic acid decarboxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(17151, NULL, 'G3DSA:3.10.50.10:FF:000057', NULL, NULL, 'Chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17152, NULL, 'G3DSA:3.30.450.30:FF:000053', NULL, NULL, 'GEO02361p1', NULL, NULL, NULL, NULL, NULL, 4),
(17153, NULL, 'G3DSA:1.20.120.1190:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17154, NULL, 'G3DSA:1.20.1250.20:FF:000151', NULL, NULL, 'Sugar efflux transporter SetB', NULL, NULL, NULL, NULL, NULL, 4),
(17155, NULL, 'G3DSA:1.10.510.10:FF:002869', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(17156, NULL, 'G3DSA:3.40.720.10:FF:000178', NULL, NULL, 'N-acetylgalactosamine-6-sulfatase (GALNS)', NULL, NULL, NULL, NULL, NULL, 4),
(17157, NULL, 'G3DSA:3.30.300.90:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17158, NULL, 'G3DSA:3.40.630.10:FF:000351', NULL, NULL, 'Carboxypeptidase Z', NULL, NULL, NULL, NULL, NULL, 4),
(17159, NULL, 'G3DSA:3.10.20.90:FF:000326', NULL, NULL, 'Inhibitor of kappa light polypeptide gene enhancer in B-cells, kinase beta', NULL, NULL, NULL, NULL, NULL, 4),
(17160, NULL, 'G3DSA:1.25.40.180:FF:000158', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17161, NULL, 'G3DSA:3.40.50.11980:FF:000006', NULL, NULL, 'AGAP001968-PB', NULL, NULL, NULL, NULL, NULL, 4),
(17162, NULL, 'G3DSA:1.10.10.2480:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17163, NULL, 'G3DSA:3.30.710.10:FF:000225', NULL, NULL, 'Phototropic-responsive NPH3 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(17164, NULL, 'G3DSA:3.40.50.2300:FF:000167', NULL, NULL, 'Two-component response regulator GlrR', NULL, NULL, NULL, NULL, NULL, 4),
(17165, NULL, 'G3DSA:3.65.10.20:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17166, NULL, 'G3DSA:1.20.80.10:FF:000029', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(17167, NULL, 'G3DSA:3.60.10.10:FF:000058', NULL, NULL, 'Tyrosyl-DNA phosphodiesterase 2', NULL, NULL, NULL, NULL, NULL, 4),
(17168, NULL, 'G3DSA:3.80.10.10:FF:001092', NULL, NULL, 'NACHT, LRR and PYD domains-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(17169, NULL, 'G3DSA:3.40.50.300:FF:006835', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17170, NULL, 'G3DSA:3.90.550.10:FF:000092', NULL, NULL, 'Glycogenin 2', NULL, NULL, NULL, NULL, NULL, 4),
(17171, NULL, 'G3DSA:3.90.550.10:FF:000148', NULL, NULL, 'Glg2p', NULL, NULL, NULL, NULL, NULL, 4),
(17172, NULL, 'G3DSA:3.30.450.50:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(17173, NULL, 'G3DSA:2.10.25.10:FF:000439', NULL, NULL, 'Netrin G2', NULL, NULL, NULL, NULL, NULL, 4),
(17174, NULL, 'G3DSA:3.90.570.10:FF:000003', NULL, NULL, 'Amyloid beta precursor like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(17175, NULL, 'G3DSA:2.30.36.70:FF:000004', NULL, NULL, 'Actin-like 6A, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(17176, NULL, 'G3DSA:1.25.40.70:FF:000023', NULL, NULL, 'Phosphatidylinositol 3-kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(17177, NULL, 'G3DSA:3.30.420.40:FF:000846', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(17178, NULL, 'G3DSA:1.25.40.10:FF:003046', NULL, NULL, 'ERAD-associated E3 ubiquitin-protein ligase component HRD3A', NULL, NULL, NULL, NULL, NULL, 4),
(17179, NULL, 'G3DSA:2.60.40.10:FF:002670', NULL, NULL, 'Fibronectin 1a', NULL, NULL, NULL, NULL, NULL, 4),
(17180, NULL, 'G3DSA:2.120.10.30:FF:000024', NULL, NULL, 'Low-density lipoprotein receptor-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(17181, NULL, 'G3DSA:3.40.50.300:FF:004065', NULL, NULL, 'Actin cross-linking, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17182, NULL, 'G3DSA:1.10.510.10:FF:000340', NULL, NULL, 'Serine threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(17183, NULL, 'G3DSA:3.40.50.620:FF:000389', NULL, NULL, 'Tyrosyl-tRNA synthetase putative', NULL, NULL, NULL, NULL, NULL, 4),
(17184, NULL, 'G3DSA:4.10.800.20:FF:000005', NULL, NULL, 'Adenosine monophosphate deaminase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17185, NULL, 'G3DSA:1.10.1200.10:FF:000006', NULL, NULL, 'Acyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(17186, NULL, 'G3DSA:3.30.160.60:FF:002378', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17187, NULL, 'G3DSA:1.10.287.110:FF:000440', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17188, NULL, 'G3DSA:2.60.40.10:FF:001765', NULL, NULL, 'Cruciform DNA-recognizing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(17189, NULL, 'G3DSA:1.25.40.10:FF:001865', NULL, NULL, 'AGAP000119-PA', NULL, NULL, NULL, NULL, NULL, 4),
(17190, NULL, 'G3DSA:2.70.98.10:FF:000083', NULL, NULL, 'Rhamnogalacturonate lyase B', NULL, NULL, NULL, NULL, NULL, 4),
(17191, NULL, 'G3DSA:3.40.30.10:FF:000459', NULL, NULL, 'Cytochrome c oxidase assembly factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(17192, NULL, 'G3DSA:1.20.1560.10:FF:000401', NULL, NULL, 'ATP-binding cassette transporter (ABC transporter) family C member 11', NULL, NULL, NULL, NULL, NULL, 4),
(17193, NULL, 'G3DSA:1.20.58.70:FF:000057', NULL, NULL, 'Syntaxin 1-2', NULL, NULL, NULL, NULL, NULL, 4),
(17194, NULL, 'G3DSA:2.20.100.10:FF:000022', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 3', NULL, NULL, NULL, NULL, NULL, 4),
(17195, NULL, 'G3DSA:3.40.630.30:FF:000357', NULL, NULL, 'CurA', NULL, NULL, NULL, NULL, NULL, 4),
(17196, NULL, 'G3DSA:3.30.70.330:FF:001180', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(17197, NULL, 'G3DSA:3.10.150.10:FF:000012', NULL, NULL, 'Beta sliding clamp', NULL, NULL, NULL, NULL, NULL, 4),
(17198, NULL, 'G3DSA:3.30.30.30:FF:000050', NULL, NULL, 'Protein CBG03751', NULL, NULL, NULL, NULL, NULL, 4),
(17199, NULL, 'G3DSA:1.10.630.10:FF:000579', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17200, NULL, 'G3DSA:1.10.437.10:FF:000017', NULL, NULL, 'MCL1, BCL2 family apoptosis regulator', NULL, NULL, NULL, NULL, NULL, 4),
(17201, NULL, 'G3DSA:1.20.1250.20:FF:001729', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17202, NULL, 'G3DSA:2.70.98.20:FF:000029', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(17203, NULL, 'G3DSA:1.25.50.20:FF:000059', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(17204, NULL, 'G3DSA:1.10.357.10:FF:000016', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(17205, NULL, 'G3DSA:3.40.50.10610:FF:000006', NULL, NULL, 'Penicillin-binding protein activator LpoB', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(17206, NULL, 'G3DSA:1.25.40.90:FF:000029', NULL, NULL, 'AP-4 complex accessory subunit Tepsin', NULL, NULL, NULL, NULL, NULL, 4),
(17207, NULL, 'G3DSA:3.60.20.10:FF:000031', NULL, NULL, 'Proteasome subunit alpha type', NULL, NULL, NULL, NULL, NULL, 4),
(17208, NULL, 'G3DSA:3.50.50.100:FF:000006', NULL, NULL, 'apoptosis-inducing factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(17209, NULL, 'G3DSA:3.50.30.50:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17210, NULL, 'G3DSA:1.50.40.10:FF:000020', NULL, NULL, 'mitochondrial uncoupling protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(17211, NULL, 'G3DSA:3.30.70.330:FF:002461', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17212, NULL, 'G3DSA:3.30.428.10:FF:000035', NULL, NULL, 'Scavenger mRNA decapping enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17213, NULL, 'G3DSA:3.40.140.10:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17214, NULL, 'G3DSA:3.90.650.10:FF:000004', NULL, NULL, 'Selenide, water dikinase', NULL, NULL, NULL, NULL, NULL, 4),
(17215, NULL, 'G3DSA:2.60.120.260:FF:000147', NULL, NULL, 'Mannosidase beta', NULL, NULL, NULL, NULL, NULL, 4),
(17216, NULL, 'G3DSA:3.30.160.60:FF:004587', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17217, NULL, 'G3DSA:3.10.250.10:FF:000076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17218, NULL, 'G3DSA:3.60.21.10:FF:000286', NULL, NULL, 'Metallophosphoesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(17219, NULL, 'G3DSA:2.60.120.10:FF:000317', NULL, NULL, 'Lysophospholipase NTE1', NULL, NULL, NULL, NULL, NULL, 4),
(17220, NULL, 'G3DSA:1.25.40.10:FF:003810', NULL, NULL, 'Beta-lactamase HcpB', NULL, NULL, NULL, NULL, NULL, 4),
(17221, NULL, 'G3DSA:2.40.40.20:FF:000004', NULL, NULL, 'Aspartate 1-decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(17222, NULL, 'G3DSA:3.90.70.10:FF:000616', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(17223, NULL, 'G3DSA:3.30.160.60:FF:003659', NULL, NULL, 'LD28458p', NULL, NULL, NULL, NULL, NULL, 4),
(17224, NULL, 'G3DSA:2.120.10.80:FF:000286', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(17225, NULL, 'G3DSA:1.10.238.10:FF:001016', NULL, NULL, 'NADPH oxidase 5', NULL, NULL, NULL, NULL, NULL, 4),
(17226, NULL, 'G3DSA:1.10.3720.10:FF:000181', NULL, NULL, 'ABC transporter permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(17227, NULL, 'G3DSA:1.10.533.10:FF:000229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17228, NULL, 'G3DSA:2.60.40.4100:FF:000001', NULL, NULL, 'alpha-tectorin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(17229, NULL, 'G3DSA:3.40.50.300:FF:000411', NULL, NULL, 'dynein heavy chain 17, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(17230, NULL, 'G3DSA:3.90.70.10:FF:000763', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17231, NULL, 'G3DSA:1.10.472.10:FF:000183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17232, NULL, 'G3DSA:1.10.287.70:FF:000719', NULL, NULL, 'Cyclic nucleotide-gated potassium channel', NULL, NULL, NULL, NULL, NULL, 4),
(17233, NULL, 'G3DSA:1.25.40.10:FF:001601', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17234, NULL, 'G3DSA:2.10.25.10:FF:001159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17235, NULL, 'G3DSA:3.30.60.30:FF:000198', NULL, NULL, 'Organic anion transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17236, NULL, 'G3DSA:2.60.120.620:FF:000098', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17237, NULL, 'G3DSA:3.40.50.2000:FF:000667', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17238, NULL, 'G3DSA:1.20.1290.10:FF:000004', NULL, NULL, 'Alkyl hydroperoxide reductase AhpD', NULL, NULL, NULL, NULL, NULL, 4),
(17239, NULL, 'G3DSA:2.130.10.10:FF:002794', NULL, NULL, 'Transcriptional corepressor LEUNIG', NULL, NULL, NULL, NULL, NULL, 4),
(17240, NULL, 'G3DSA:1.10.1410.10:FF:000016', NULL, NULL, 'Poly(A) polymerase, putative', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(17241, NULL, 'G3DSA:1.10.10.2660:FF:000030', NULL, NULL, 'SUMO-activating enzyme subunit', NULL, NULL, NULL, NULL, NULL, 4),
(17242, NULL, 'G3DSA:3.30.70.260:FF:000175', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17243, NULL, 'G3DSA:3.40.50.300:FF:002620', NULL, NULL, 'Elongator complex protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(17244, NULL, 'G3DSA:2.60.120.330:FF:000224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17245, NULL, 'G3DSA:2.40.50.140:FF:000114', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(17246, NULL, 'G3DSA:3.40.30.10:FF:000723', NULL, NULL, 'Grx_C3-glutaredoxin subgroup I', NULL, NULL, NULL, NULL, NULL, 4),
(17247, NULL, 'G3DSA:2.130.10.10:FF:002086', NULL, NULL, 'Dynein intermediate chain at 61B, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(17248, NULL, 'G3DSA:3.50.80.10:FF:000001', NULL, NULL, 'D-aminoacyl-tRNA deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(17249, NULL, 'G3DSA:1.25.40.420:FF:000011', NULL, NULL, 'gigaxonin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(17250, NULL, 'G3DSA:3.60.40.10:FF:000094', NULL, NULL, 'Protein phosphatase PPM5', NULL, NULL, NULL, NULL, NULL, 4),
(17251, NULL, 'G3DSA:3.30.200.20:FF:001521', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17252, NULL, 'G3DSA:1.20.1270.60:FF:000203', NULL, NULL, 'rho GTPase-activating protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(17253, NULL, 'G3DSA:3.30.420.10:FF:000214', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(17254, NULL, 'G3DSA:1.10.1450.10:FF:000081', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(17255, NULL, 'G3DSA:3.80.10.10:FF:000164', NULL, NULL, 'podocan', NULL, NULL, NULL, NULL, NULL, 4),
(17256, NULL, 'G3DSA:3.90.70.10:FF:000055', NULL, NULL, 'cysteine protease XCP2', NULL, NULL, NULL, NULL, NULL, 4),
(17257, NULL, 'G3DSA:2.60.40.790:FF:000206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17258, NULL, 'G3DSA:3.40.1370.10:FF:000009', NULL, NULL, '50S ribosomal protein L4', NULL, NULL, NULL, NULL, NULL, 4),
(17259, NULL, 'G3DSA:1.25.40.10:FF:002118', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g13650', NULL, NULL, NULL, NULL, NULL, 4),
(17260, NULL, 'G3DSA:3.30.460.10:FF:000132', NULL, NULL, 'Bifunctional uridylyltransferase/uridylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(17261, NULL, 'G3DSA:2.130.10.10:FF:002906', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit wdr4', NULL, NULL, NULL, NULL, NULL, 4),
(17262, NULL, 'G3DSA:2.20.70.10:FF:000285', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(17263, NULL, 'G3DSA:2.20.70.10:FF:000021', NULL, NULL, 'E3 ubiquitin-protein ligase NEDD4', NULL, NULL, NULL, NULL, NULL, 4),
(17264, NULL, 'G3DSA:1.10.10.2330:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17265, NULL, 'G3DSA:1.10.472.80:FF:000243', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17266, NULL, 'G3DSA:1.20.1310.10:FF:000181', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17267, NULL, 'G3DSA:3.40.50.720:FF:001554', NULL, NULL, 'Pteridine reductase 1-possibly short-chain dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(17268, NULL, 'G3DSA:3.40.190.10:FF:000070', NULL, NULL, 'HTH-type transcriptional regulator SgrR', NULL, NULL, NULL, NULL, NULL, 4),
(17269, NULL, 'G3DSA:2.60.40.150:FF:000217', NULL, NULL, 'Tcb1p', NULL, NULL, NULL, NULL, NULL, 4),
(17270, NULL, 'G3DSA:1.25.10.10:FF:001212', NULL, NULL, 'Early embryogenesis protein zyg-11', NULL, NULL, NULL, NULL, NULL, 4),
(17271, NULL, 'G3DSA:3.20.20.70:FF:000179', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(17272, NULL, 'G3DSA:1.25.40.10:FF:000584', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(17273, NULL, 'G3DSA:3.40.50.2300:FF:001656', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17274, NULL, 'G3DSA:3.40.50.2300:FF:001095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(17275, NULL, 'G3DSA:3.30.70.330:FF:000252', NULL, NULL, 'RNA binding motif protein 41', NULL, NULL, NULL, NULL, NULL, 4),
(17276, NULL, 'G3DSA:1.20.210.10:FF:000039', NULL, NULL, 'Nitric oxide reductase QnorB', NULL, NULL, NULL, NULL, NULL, 4),
(17277, NULL, 'G3DSA:3.40.50.2000:FF:000403', NULL, NULL, 'Glycosyltransferase family 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(17278, NULL, 'G3DSA:2.40.50.100:FF:000214', NULL, NULL, 'ABC-type iron(III) transport system, ATPase component', NULL, NULL, NULL, NULL, NULL, 4),
(17279, NULL, 'G3DSA:3.30.720.210:FF:000021', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(17280, NULL, 'G3DSA:1.10.10.10:FF:001240', NULL, NULL, 'Anaphase-promoting complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(17281, NULL, 'G3DSA:3.30.230.10:FF:000087', NULL, NULL, 'Diphosphomevalonate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(17282, NULL, 'G3DSA:1.10.10.1440:FF:000001', NULL, NULL, 'phosphorylated adapter RNA export protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(17283, NULL, 'G3DSA:2.40.10.10:FF:000527', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17284, NULL, 'G3DSA:3.40.50.1820:FF:000478', NULL, NULL, 'Alpha/beta-hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(17285, NULL, 'G3DSA:2.30.30.140:FF:000011', NULL, NULL, 'Zinc finger MYND domain-containing protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(17286, NULL, 'G3DSA:1.25.40.10:FF:002793', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17287, NULL, 'G3DSA:1.25.40.570:FF:000005', NULL, NULL, '26S proteasome regulatory subunit N7', NULL, NULL, NULL, NULL, NULL, 4),
(17288, NULL, 'G3DSA:2.40.50.140:FF:000378', NULL, NULL, 'Replication protein A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(17289, NULL, 'G3DSA:2.30.30.490:FF:000032', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(17290, NULL, 'G3DSA:2.60.120.920:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17291, NULL, 'G3DSA:2.30.30.40:FF:000274', NULL, NULL, '[PSI+] inducibility protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(17292, NULL, 'G3DSA:3.30.200.20:FF:001785', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17293, NULL, 'G3DSA:1.25.10.10:FF:003421', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17294, NULL, 'G3DSA:3.40.50.300:FF:008516', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17295, NULL, 'G3DSA:3.40.50.1000:FF:000412', NULL, NULL, 'HAD-superfamily hydrolase, subfamily IA, variant 3 containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(17296, NULL, 'G3DSA:1.20.90.10:FF:000002', NULL, NULL, 'Phospholipase A2 group III', NULL, NULL, NULL, NULL, NULL, 4),
(17297, NULL, 'G3DSA:3.90.70.10:FF:000408', NULL, NULL, 'Mexicain', NULL, NULL, NULL, NULL, NULL, 4),
(17298, NULL, 'G3DSA:1.20.5.500:FF:000005', NULL, NULL, 'Keratin 23', NULL, NULL, NULL, NULL, NULL, 4),
(17299, NULL, 'G3DSA:3.30.1510.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17300, NULL, 'G3DSA:2.60.120.260:FF:000355', NULL, NULL, 'proprotein convertase subtilisin/kexin type 7-like', NULL, NULL, NULL, NULL, NULL, 4),
(17301, NULL, 'G3DSA:1.10.246.120:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17302, NULL, 'G3DSA:3.30.160.60:FF:005929', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17303, NULL, 'G3DSA:2.40.30.30:FF:000012', NULL, NULL, 'Riboflavin biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(17304, NULL, 'G3DSA:3.30.420.340:FF:000003', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4),
(17305, NULL, 'G3DSA:1.20.58.1880:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17306, NULL, 'G3DSA:3.40.630.10:FF:000290', NULL, NULL, 'Aspartyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(17307, NULL, 'G3DSA:2.40.20.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(17308, NULL, 'G3DSA:2.40.30.130:FF:000045', NULL, NULL, 'Alanyl-tRNA synthetase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(17309, NULL, 'G3DSA:3.40.30.10:FF:001095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17310, NULL, 'G3DSA:1.25.10.10:FF:002465', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17311, NULL, 'G3DSA:1.10.630.10:FF:000079', NULL, NULL, 'Cytochrome P450 71A26', NULL, NULL, NULL, NULL, NULL, 4),
(17312, NULL, 'G3DSA:3.40.30.10:FF:001151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17313, NULL, 'G3DSA:3.30.2160.10:FF:000007', NULL, NULL, 'E3 ubiquitin-protein ligase HUWE1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(17314, NULL, 'G3DSA:3.40.50.880:FF:000124', NULL, NULL, 'CTP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(17315, NULL, 'G3DSA:1.10.510.10:FF:001065', NULL, NULL, 'Serine/threonine-protein kinase spk-1', NULL, NULL, NULL, NULL, NULL, 4),
(17316, NULL, 'G3DSA:3.40.50.11720:FF:000007', NULL, NULL, '3-deoxy-D-manno-octulosonic acid transferase', NULL, NULL, NULL, NULL, NULL, 4),
(17317, NULL, 'G3DSA:3.10.450.50:FF:000018', NULL, NULL, 'mRNA transport regulator', NULL, NULL, NULL, NULL, NULL, 4),
(17318, NULL, 'G3DSA:1.20.1070.10:FF:001977', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17319, NULL, 'G3DSA:1.10.10.60:FF:000074', NULL, NULL, 'Distal-less homeobox 1', NULL, NULL, NULL, NULL, NULL, 4),
(17320, NULL, 'G3DSA:1.10.510.10:FF:001121', NULL, NULL, 'Kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(17321, NULL, 'G3DSA:3.60.20.10:FF:000115', NULL, NULL, 'Probable asparagine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(17322, NULL, 'G3DSA:1.20.58.60:FF:000228', NULL, NULL, 'Uncharacterized protein, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(17323, NULL, 'G3DSA:3.40.50.2300:FF:001387', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17324, NULL, 'G3DSA:2.30.29.220:FF:000005', NULL, NULL, 'FACT complex subunit SSRP1', NULL, NULL, NULL, NULL, NULL, 4),
(17325, NULL, 'G3DSA:3.90.70.10:FF:000847', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17326, NULL, 'G3DSA:2.60.40.10:FF:003210', NULL, NULL, 'Cytochrome c oxidase accessory protein CcoG', NULL, NULL, NULL, NULL, NULL, 4),
(17327, NULL, 'G3DSA:3.20.20.20:FF:000041', NULL, NULL, 'Methionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(17328, NULL, 'G3DSA:2.40.50.140:FF:000322', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(17329, NULL, 'G3DSA:1.10.357.150:FF:000002', NULL, NULL, 'Centromere/kinetochore protein zw10-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(17330, NULL, 'G3DSA:1.25.40.20:FF:001458', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17331, NULL, 'G3DSA:3.90.550.10:FF:000704', NULL, NULL, 'Probable UDP-N-acetylglucosamine pyrophosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(17332, NULL, 'G3DSA:3.50.50.60:FF:001447', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17333, NULL, 'G3DSA:2.20.70.10:FF:000077', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(17334, NULL, 'G3DSA:1.10.8.720:FF:000068', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(17335, NULL, 'G3DSA:1.10.510.10:FF:004347', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17336, NULL, 'G3DSA:3.40.50.300:FF:006751', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17337, NULL, 'G3DSA:3.30.200.20:FF:000116', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(17338, NULL, 'G3DSA:3.40.50.2300:FF:000875', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17339, NULL, 'G3DSA:2.10.69.10:FF:000001', NULL, NULL, 'Bowman-Birk type proteinase inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(17340, NULL, 'G3DSA:1.20.120.1530:FF:000005', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(17341, NULL, 'G3DSA:3.30.160.60:FF:001714', NULL, NULL, 'Zinc finger protein 774', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(17342, NULL, 'G3DSA:3.80.10.10:FF:001592', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase PEPR2', NULL, NULL, NULL, NULL, NULL, 4),
(17343, NULL, 'G3DSA:3.40.50.720:FF:001470', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17344, NULL, 'G3DSA:3.40.50.1100:FF:000296', NULL, NULL, 'Protein CBG27484', NULL, NULL, NULL, NULL, NULL, 4),
(17345, NULL, 'G3DSA:2.30.31.40:FF:000001', NULL, NULL, 'Mitochondrial RNA binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(17346, NULL, 'G3DSA:2.40.180.10:FF:000016', NULL, NULL, 'Catalase', NULL, NULL, NULL, NULL, NULL, 4),
(17347, NULL, 'G3DSA:2.60.40.10:FF:004935', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17348, NULL, 'G3DSA:2.170.270.10:FF:000206', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(17349, NULL, 'G3DSA:3.90.79.10:FF:000052', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(17350, NULL, 'G3DSA:3.30.70.330:FF:000836', NULL, NULL, 'Nab6p', NULL, NULL, NULL, NULL, NULL, 4),
(17351, NULL, 'G3DSA:2.30.39.10:FF:000010', NULL, NULL, 'Serpin family F member 2', NULL, NULL, NULL, NULL, NULL, 4),
(17352, NULL, 'G3DSA:3.60.21.10:FF:000263', NULL, NULL, 'Metallo-phosphoesterase', NULL, NULL, NULL, NULL, NULL, 4),
(17353, NULL, 'G3DSA:1.20.120.980:FF:000013', NULL, NULL, 'Clan SC, family S28, unassigned serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(17354, NULL, 'G3DSA:3.40.50.300:FF:004773', NULL, NULL, 'DExH-box ATP-dependent RNA helicase DExH18 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(17355, NULL, 'G3DSA:3.40.50.2000:FF:000903', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17356, NULL, 'G3DSA:2.40.50.140:FF:000850', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17357, NULL, 'G3DSA:1.20.140.150:FF:000038', NULL, NULL, 'Voltage-dependent calcium channel gamma-6 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(17358, NULL, 'G3DSA:3.30.40.10:FF:001910', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17359, NULL, 'G3DSA:1.10.510.10:FF:000076', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase', NULL, NULL, NULL, NULL, NULL, 4),
(17360, NULL, 'G3DSA:3.40.50.10090:FF:000075', NULL, NULL, 'Chromosome 12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(17361, NULL, 'G3DSA:3.30.70.3040:FF:000009', NULL, NULL, 'Cell division protein FtsX', NULL, NULL, NULL, NULL, NULL, 4),
(17362, NULL, 'G3DSA:2.60.40.60:FF:000358', NULL, NULL, 'Si:dkey-30k22.7', NULL, NULL, NULL, NULL, NULL, 4),
(17363, NULL, 'G3DSA:3.30.70.330:FF:000460', NULL, NULL, 'Polyadenylate-binding protein RBP47B', NULL, NULL, NULL, NULL, NULL, 4),
(17364, NULL, 'G3DSA:3.30.750.24:FF:000038', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(17365, NULL, 'G3DSA:2.30.30.40:FF:000358', NULL, NULL, 'Putative N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(17366, NULL, 'G3DSA:3.40.850.10:FF:000126', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(17367, NULL, 'G3DSA:3.40.309.10:FF:000003', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(17368, NULL, 'G3DSA:1.25.10.10:FF:001004', NULL, NULL, 'Integrator complex subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(17369, NULL, 'G3DSA:1.10.20.10:FF:000138', NULL, NULL, 'TAF (TBP-associated transcription factor) family', NULL, NULL, NULL, NULL, NULL, 4),
(17370, NULL, 'G3DSA:1.10.220.150:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17371, NULL, 'G3DSA:2.40.170.20:FF:000047', NULL, NULL, 'TonB-dependent siderophore receptor', NULL, NULL, NULL, NULL, NULL, 4),
(17372, NULL, 'G3DSA:3.30.710.10:FF:000141', NULL, NULL, 'Radish, isoform N', NULL, NULL, NULL, NULL, NULL, 4),
(17373, NULL, 'G3DSA:1.25.40.10:FF:002557', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(17374, NULL, 'G3DSA:1.10.150.670:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(17375, NULL, 'G3DSA:3.30.1490.120:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17376, NULL, 'G3DSA:1.25.40.10:FF:002613', NULL, NULL, 'CCR4-NOT transcription complex subunit 10', NULL, NULL, NULL, NULL, NULL, 4),
(17377, NULL, 'G3DSA:3.40.390.10:FF:000135', NULL, NULL, 'Matrix metallopeptidase 11b', NULL, NULL, NULL, NULL, NULL, 4),
(17378, NULL, 'G3DSA:2.130.10.10:FF:000085', NULL, NULL, 'WD repeat domain 33', NULL, NULL, NULL, NULL, NULL, 4),
(17379, NULL, 'G3DSA:3.40.50.1760:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17380, NULL, 'G3DSA:3.40.47.10:FF:000262', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17381, NULL, 'G3DSA:3.30.40.10:FF:000898', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(17382, NULL, 'G3DSA:1.25.40.20:FF:000525', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(17383, NULL, 'G3DSA:3.40.50.300:FF:000967', NULL, NULL, 'ABC multidrug transporter mdr4', NULL, NULL, NULL, NULL, NULL, 4),
(17384, NULL, 'G3DSA:3.30.230.70:FF:000003', NULL, NULL, 'Ribonuclease PH', NULL, NULL, NULL, NULL, NULL, 4),
(17385, NULL, 'G3DSA:3.80.10.10:FF:003446', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17386, NULL, 'G3DSA:3.30.160.60:FF:001658', NULL, NULL, 'Zinc finger protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(17387, NULL, 'G3DSA:3.10.20.90:FF:000742', NULL, NULL, 'Neutrophil cytosol factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(17388, NULL, 'G3DSA:1.10.287.80:FF:000020', NULL, NULL, 'ATP synthase gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(17389, NULL, 'G3DSA:3.50.7.10:FF:000081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17390, NULL, 'G3DSA:2.60.40.10:FF:003682', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17391, NULL, 'G3DSA:3.40.50.450:FF:000080', NULL, NULL, '6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(17392, NULL, 'G3DSA:1.20.1110.10:FF:000109', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17393, NULL, 'G3DSA:1.50.40.10:FF:000604', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17394, NULL, 'G3DSA:2.130.10.30:FF:000147', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17395, NULL, 'G3DSA:3.30.420.80:FF:000015', NULL, NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(17396, NULL, 'G3DSA:3.40.50.2300:FF:000931', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17397, NULL, 'G3DSA:3.40.190.10:FF:000154', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(17398, NULL, 'G3DSA:2.130.10.10:FF:002030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17399, NULL, 'G3DSA:3.10.50.10:FF:000001', NULL, NULL, 'Chitinase 3-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(17400, NULL, 'G3DSA:2.60.260.20:FF:000095', NULL, NULL, 'Radial spoke protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(17401, NULL, 'G3DSA:2.60.40.60:FF:000835', NULL, NULL, 'Protocadherin beta 2', NULL, NULL, NULL, NULL, NULL, 4),
(17402, NULL, 'G3DSA:1.25.70.10:FF:000024', NULL, NULL, 'Transcription termination factor, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(17403, NULL, 'G3DSA:1.10.287.1060:FF:000006', NULL, NULL, 'ESAT-6-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(17404, NULL, 'G3DSA:3.30.420.10:FF:000747', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17405, NULL, 'G3DSA:2.60.120.10:FF:000609', NULL, NULL, 'Mannose-6-phosphate isomerase, class I family protein', NULL, NULL, NULL, NULL, NULL, 4),
(17406, NULL, 'G3DSA:2.60.40.790:FF:000061', NULL, NULL, 'Low molecular weight heat shock protein', NULL, NULL, NULL, NULL, NULL, 4),
(17407, NULL, 'G3DSA:1.10.510.10:FF:003482', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17408, NULL, 'G3DSA:3.40.50.300:FF:002912', NULL, NULL, 'Rab family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(17409, NULL, 'G3DSA:1.20.1530.20:FF:000110', NULL, NULL, 'Na(+)/H(+) antiporter 1', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(17410, NULL, 'G3DSA:2.10.25.10:FF:001636', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(17411, NULL, 'G3DSA:1.25.10.10:FF:002729', NULL, NULL, 'Transportin', NULL, NULL, NULL, NULL, NULL, 4),
(17412, NULL, 'G3DSA:3.20.20.80:FF:000800', NULL, NULL, 'Protein CBG10890', NULL, NULL, NULL, NULL, NULL, 4),
(17413, NULL, 'G3DSA:3.30.565.10:FF:000095', NULL, NULL, 'PAS domain-containing sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(17414, NULL, 'G3DSA:1.10.10.60:FF:001030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17415, NULL, 'G3DSA:1.25.10.10:FF:000048', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(17416, NULL, 'G3DSA:3.40.50.150:FF:000905', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17417, NULL, 'G3DSA:1.20.1070.10:FF:001185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17418, NULL, 'G3DSA:2.60.40.10:FF:000753', NULL, NULL, 'Paired immunoglobulin-like type 2 receptor alpha', NULL, NULL, NULL, NULL, NULL, 4),
(17419, NULL, 'G3DSA:2.60.470.10:FF:000017', NULL, NULL, 'pickpocket protein 28', NULL, NULL, NULL, NULL, NULL, 4),
(17420, NULL, 'G3DSA:3.40.50.300:FF:002856', NULL, NULL, 'Dynein heavy chain 11', NULL, NULL, NULL, NULL, NULL, 4),
(17421, NULL, 'G3DSA:3.40.50.10810:FF:000010', NULL, NULL, 'DNA repair and recombination protein RAD54-like', NULL, NULL, NULL, NULL, NULL, 4),
(17422, NULL, 'G3DSA:3.90.1150.10:FF:000353', NULL, NULL, 'Beta-eliminating lyase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(17423, NULL, 'G3DSA:1.10.10.60:FF:000866', NULL, NULL, 'Dharma', NULL, NULL, NULL, NULL, NULL, 4),
(17424, NULL, 'G3DSA:3.40.1380.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17425, NULL, 'G3DSA:3.40.50.300:FF:007999', NULL, NULL, 'Methylenetetrahydrofolate dehydrogenase (NADP+-dependent) 1a, methenyltetrahydrofolate cyclohydrolase, formyltetrahydrofolate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(17426, NULL, 'G3DSA:2.40.50.100:FF:000097', NULL, NULL, 'Exosome complex component RRP40', NULL, NULL, NULL, NULL, NULL, 4),
(17427, NULL, 'G3DSA:3.10.110.10:FF:000330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17428, NULL, 'G3DSA:1.10.287.70:FF:000427', NULL, NULL, 'Cyclic nucleotide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(17429, NULL, 'G3DSA:2.40.50.1000:FF:000014', NULL, NULL, '40S ribosomal protein S11-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(17430, NULL, 'G3DSA:1.10.150.170:FF:000003', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase H', NULL, NULL, NULL, NULL, NULL, 4),
(17431, NULL, 'G3DSA:3.90.190.20:FF:000022', NULL, NULL, 'Putative dihydrofolate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(17432, NULL, 'G3DSA:1.20.120.1770:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17433, NULL, 'G3DSA:1.10.150.190:FF:000009', NULL, NULL, 'Eukaryotic translation initiation factor 2 subunit alpha, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17434, NULL, 'G3DSA:2.40.10.10:FF:000258', NULL, NULL, 'Anionic trypsin isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(17435, NULL, 'G3DSA:3.30.1330.30:FF:000139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17436, NULL, 'G3DSA:3.80.10.10:FF:002581', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17437, NULL, 'G3DSA:3.30.420.40:FF:000762', NULL, NULL, 'Actin-related protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(17438, NULL, 'G3DSA:3.30.1370.10:FF:000023', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein K, like', NULL, NULL, NULL, NULL, NULL, 4),
(17439, NULL, 'G3DSA:1.10.510.10:FF:003010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17440, NULL, 'G3DSA:4.10.410.50:FF:000001', NULL, NULL, 'Small archaeal modifier protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(17441, NULL, 'G3DSA:1.25.40.20:FF:000997', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17442, NULL, 'G3DSA:1.20.5.110:FF:000074', NULL, NULL, 't-SNARE domain-containing protein 1 isoform X4', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(17443, NULL, 'G3DSA:1.20.1250.20:FF:001876', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17444, NULL, 'G3DSA:2.60.40.10:FF:004019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17445, NULL, 'G3DSA:3.40.50.11660:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17446, NULL, 'G3DSA:1.25.40.10:FF:005047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17447, NULL, 'G3DSA:3.40.50.300:FF:000175', NULL, NULL, 'ATP-dependent zinc metalloprotease FTSH 4', NULL, NULL, NULL, NULL, NULL, 4),
(17448, NULL, 'G3DSA:1.20.1250.20:FF:000976', NULL, NULL, 'YALI0A00869p', NULL, NULL, NULL, NULL, NULL, 4),
(17449, NULL, 'G3DSA:3.40.250.10:FF:000069', NULL, NULL, 'Sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(17450, NULL, 'G3DSA:3.30.830.10:FF:000144', NULL, NULL, 'Metalloprotease, insulinase family', NULL, NULL, NULL, NULL, NULL, 4),
(17451, NULL, 'G3DSA:1.10.490.10:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17452, NULL, 'G3DSA:3.40.50.10420:FF:000039', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17453, NULL, 'G3DSA:3.30.2160.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17454, NULL, 'G3DSA:2.130.10.10:FF:005312', NULL, NULL, 'U3 small nucleolar RNA-associated protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(17455, NULL, 'G3DSA:3.30.565.10:FF:000100', NULL, NULL, 'Signal transduction histidine-protein kinase AtoS', NULL, NULL, NULL, NULL, NULL, 4),
(17456, NULL, 'G3DSA:2.60.120.1560:FF:000008', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17457, NULL, 'G3DSA:1.20.120.80:FF:000008', NULL, NULL, 'Cytochrome c oxidase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(17458, NULL, 'G3DSA:2.70.170.10:FF:000099', NULL, NULL, 'Gamma-aminobutyric acid type A receptor rho1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(17459, NULL, 'G3DSA:1.10.150.20:FF:000326', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17460, NULL, 'G3DSA:3.90.1150.10:FF:000330', NULL, NULL, 'Adenosylmethionine-8-amino-7-oxononanoate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(17461, NULL, 'G3DSA:3.30.930.10:FF:000180', NULL, NULL, 'Alanyl tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(17462, NULL, 'G3DSA:1.10.8.1220:FF:000020', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17463, NULL, 'G3DSA:2.70.130.10:FF:000153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17464, NULL, 'G3DSA:1.20.1250.20:FF:001376', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17465, NULL, 'G3DSA:1.10.720.30:FF:000064', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17466, NULL, 'G3DSA:3.90.550.10:FF:000648', NULL, NULL, 'Cellulose synthase-like protein D3', NULL, NULL, NULL, NULL, NULL, 4),
(17467, NULL, 'G3DSA:2.130.10.10:FF:002822', NULL, NULL, 'Subunit of anaphase promoting complex', NULL, NULL, NULL, NULL, NULL, 4),
(17468, NULL, 'G3DSA:3.40.50.300:FF:007263', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17469, NULL, 'G3DSA:3.10.170.20:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17470, NULL, 'G3DSA:2.60.40.1910:FF:000001', NULL, NULL, 'Leucyl-cystinyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(17471, NULL, 'G3DSA:2.130.10.10:FF:001041', NULL, NULL, 'CTF4p Chromatin-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(17472, NULL, 'G3DSA:3.30.160.60:FF:004564', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17473, NULL, 'G3DSA:3.30.70.330:FF:000308', NULL, NULL, 'Serine/arginine-rich splicing factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(17474, NULL, 'G3DSA:3.90.70.10:FF:000471', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17475, NULL, 'G3DSA:1.20.1560.10:FF:000901', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17476, NULL, 'G3DSA:3.50.50.60:FF:000935', NULL, NULL, 'Thioredoxin reductase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(17477, NULL, 'G3DSA:3.40.50.620:FF:000153', NULL, NULL, 'Phosphoadenosine phosphosulfate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(17478, NULL, 'G3DSA:1.25.10.10:FF:000172', NULL, NULL, 'Armadillo repeat-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(17479, NULL, 'G3DSA:3.40.50.10190:FF:000279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17480, NULL, 'G3DSA:1.10.8.20:FF:000005', NULL, NULL, 'SEC14 cytosolic factor', NULL, NULL, NULL, NULL, NULL, 4),
(17481, NULL, 'G3DSA:3.30.9.10:FF:000096', NULL, NULL, 'NAD FAD-dependent dehydrogenase putative', NULL, NULL, NULL, NULL, NULL, 4),
(17482, NULL, 'G3DSA:3.90.550.50:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17483, NULL, 'G3DSA:3.40.50.10810:FF:000066', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(17484, NULL, 'G3DSA:3.40.50.1110:FF:000029', NULL, NULL, 'Unplaced genomic scaffold supercont2.12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(17485, NULL, 'G3DSA:3.30.160.60:FF:000669', NULL, NULL, 'zinc finger protein 64 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(17486, NULL, 'G3DSA:1.10.8.60:FF:000354', NULL, NULL, 'Pre-initiation complex, subunit CDC6', NULL, NULL, NULL, NULL, NULL, 4),
(17487, NULL, 'G3DSA:2.60.120.10:FF:000289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17488, NULL, 'G3DSA:3.10.50.40:FF:000072', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(17489, NULL, 'G3DSA:2.130.10.10:FF:002878', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17490, NULL, 'G3DSA:3.80.10.10:FF:000956', NULL, NULL, 'Nud1p', NULL, NULL, NULL, NULL, NULL, 4),
(17491, NULL, 'G3DSA:3.40.50.300:FF:001131', NULL, NULL, 'DNA polymerase III subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(17492, NULL, 'G3DSA:2.40.50.140:FF:000794', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17493, NULL, 'G3DSA:3.30.200.20:FF:002477', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17494, NULL, 'G3DSA:3.80.10.10:FF:001968', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17495, NULL, 'G3DSA:3.40.50.720:FF:001846', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(17496, NULL, 'G3DSA:3.30.390.60:FF:000006', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(17497, NULL, 'G3DSA:2.60.120.260:FF:000411', NULL, NULL, 'Putative secreted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17498, NULL, 'G3DSA:3.30.565.10:FF:000156', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(17499, NULL, 'G3DSA:3.40.50.720:FF:002246', NULL, NULL, 'Alanine dehydrogenase 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17500, NULL, 'G3DSA:3.40.50.800:FF:000027', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(17501, NULL, 'G3DSA:2.60.40.10:FF:003154', NULL, NULL, 'Titin, tandem duplicate 1', NULL, NULL, NULL, NULL, NULL, 4),
(17502, NULL, 'G3DSA:3.40.50.1820:FF:001170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17503, NULL, 'G3DSA:3.30.420.80:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17504, NULL, 'G3DSA:1.10.579.10:FF:000009', NULL, NULL, 'Cryptochrome DASH', NULL, NULL, NULL, NULL, NULL, 4),
(17505, NULL, 'G3DSA:2.60.200.20:FF:000147', NULL, NULL, 'Fork-head transcriptional regulator 2', NULL, NULL, NULL, NULL, NULL, 4),
(17506, NULL, 'G3DSA:2.30.33.40:FF:000016', NULL, NULL, '10 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(17507, NULL, 'G3DSA:3.30.70.1450:FF:000027', NULL, NULL, 'Sodium/sulfate symporter', NULL, NULL, NULL, NULL, NULL, 4),
(17508, NULL, 'G3DSA:1.10.730.10:FF:000120', NULL, NULL, 'Leucine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(17509, NULL, 'G3DSA:1.10.510.10:FF:003858', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17510, NULL, 'G3DSA:2.60.40.1170:FF:000060', NULL, NULL, 'Coatomer subunit delta', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(17511, NULL, 'G3DSA:2.20.150.10:FF:000002', NULL, NULL, 'Sugar kinase, pfkB family', NULL, NULL, NULL, NULL, NULL, 4),
(17512, NULL, 'G3DSA:3.60.60.10:FF:000005', NULL, NULL, 'Dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(17513, NULL, 'G3DSA:2.10.25.10:FF:000350', NULL, NULL, 'Eater', NULL, NULL, NULL, NULL, NULL, 4),
(17514, NULL, 'G3DSA:3.40.109.10:FF:000022', NULL, NULL, 'Probable nitroreductase', NULL, NULL, NULL, NULL, NULL, 4),
(17515, NULL, 'G3DSA:3.40.30.10:FF:000223', NULL, NULL, 'protein disulfide-isomerase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(17516, NULL, 'G3DSA:4.10.1030.10:FF:000002', NULL, NULL, 'cullin homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(17517, NULL, 'G3DSA:1.10.287.370:FF:000023', NULL, NULL, 'Pfd1p', NULL, NULL, NULL, NULL, NULL, 4),
(17518, NULL, 'G3DSA:1.20.1740.10:FF:000022', NULL, NULL, 'Bumetanide-sensitive na-k-cl cotransport protein', NULL, NULL, NULL, NULL, NULL, 4),
(17519, NULL, 'G3DSA:1.25.10.10:FF:002881', NULL, NULL, 'Importin subunit beta-1', NULL, NULL, NULL, NULL, NULL, 4),
(17520, NULL, 'G3DSA:1.10.630.10:FF:000495', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17521, NULL, 'G3DSA:2.10.70.10:FF:000162', NULL, NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(17522, NULL, 'G3DSA:1.20.1250.20:FF:000443', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(17523, NULL, 'G3DSA:3.90.228.10:FF:000040', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(17524, NULL, 'G3DSA:1.20.1280.50:FF:000228', NULL, NULL, 'F-box protein PP2-B7', NULL, NULL, NULL, NULL, NULL, 4),
(17525, NULL, 'G3DSA:1.25.10.10:FF:003393', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17526, NULL, 'G3DSA:3.90.470.20:FF:000004', NULL, NULL, 'Holo-(Acyl carrier protein) synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(17527, NULL, 'G3DSA:2.60.120.200:FF:000028', NULL, NULL, 'Blast:Protein ERGIC-53', NULL, NULL, NULL, NULL, NULL, 4),
(17528, NULL, 'G3DSA:2.30.42.10:FF:000450', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17529, NULL, 'G3DSA:3.30.40.10:FF:001062', NULL, NULL, 'PHD-finger family protein', NULL, NULL, NULL, NULL, NULL, 4),
(17530, NULL, 'G3DSA:3.30.160.60:FF:006329', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17531, NULL, 'G3DSA:1.20.1050.10:FF:000166', NULL, NULL, 'chloride intracellular channel protein 5-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(17532, NULL, 'G3DSA:3.30.160.60:FF:002294', NULL, NULL, 'zinc finger protein 197 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(17533, NULL, 'G3DSA:2.170.160.10:FF:000001', NULL, NULL, 'Cellulose 1,4-beta-cellobiosidase', NULL, NULL, NULL, NULL, NULL, 4),
(17534, NULL, 'G3DSA:2.130.10.10:FF:002406', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17535, NULL, 'G3DSA:3.40.50.300:FF:002592', NULL, NULL, 'SNF2 family helicase Ino80', NULL, NULL, NULL, NULL, NULL, 4),
(17536, NULL, 'G3DSA:3.10.430.100:FF:000011', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(17537, NULL, 'G3DSA:3.30.200.20:FF:000532', NULL, NULL, 'Receptor like protein kinase S.2', NULL, NULL, NULL, NULL, NULL, 4),
(17538, NULL, 'G3DSA:3.40.50.970:FF:000151', NULL, NULL, '2-oxoisovalerate dehydrogenase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(17539, NULL, 'G3DSA:3.40.50.2000:FF:000875', NULL, NULL, 'Glycogen [starch] synthase', NULL, NULL, NULL, NULL, NULL, 4),
(17540, NULL, 'G3DSA:1.25.10.10:FF:001009', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(17541, NULL, 'G3DSA:3.30.230.10:FF:000031', NULL, NULL, 'DNA repair protein RadA', NULL, NULL, NULL, NULL, NULL, 4),
(17542, NULL, 'G3DSA:3.30.2130.30:FF:000012', NULL, NULL, 'RNA methylase, PF01170 family', NULL, NULL, NULL, NULL, NULL, 4),
(17543, NULL, 'G3DSA:3.80.10.10:FF:000664', NULL, NULL, 'F-box and leucine rich repeat protein 5', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(17544, NULL, 'G3DSA:3.40.50.1820:FF:000506', NULL, NULL, 'Cephalosporin-C deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(17545, NULL, 'G3DSA:1.25.40.10:FF:004035', NULL, NULL, 'Os12g0562300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(17546, NULL, 'G3DSA:3.30.420.130:FF:000002', NULL, NULL, 'Nitrogenase molybdenum-iron protein NifX', NULL, NULL, NULL, NULL, NULL, 4),
(17547, NULL, 'G3DSA:1.10.287.520:FF:000001', NULL, NULL, 'Noggin', NULL, NULL, NULL, NULL, NULL, 4),
(17548, NULL, 'G3DSA:2.60.40.640:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17549, NULL, 'G3DSA:2.40.170.20:FF:000108', NULL, NULL, 'TonB-dependent receptor', NULL, NULL, NULL, NULL, NULL, 4),
(17550, NULL, 'G3DSA:1.10.533.10:FF:000168', NULL, NULL, 'NOD2b protein', NULL, NULL, NULL, NULL, NULL, 4),
(17551, NULL, 'G3DSA:3.40.50.300:FF:000911', NULL, NULL, 'Nucleolar RNA helicase II', NULL, NULL, NULL, NULL, NULL, 4),
(17552, NULL, 'G3DSA:2.130.10.10:FF:001389', NULL, NULL, 'UTP13p Nucleolar protein', NULL, NULL, NULL, NULL, NULL, 4),
(17553, NULL, 'G3DSA:3.40.1180.10:FF:000001', NULL, NULL, '(2E,6E)-farnesyl-diphosphate-specific ditrans,polycis-undecaprenyl-diphosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(17554, NULL, 'G3DSA:3.60.15.10:FF:000226', NULL, NULL, 'Artemis-related DNA-crosslink repair exonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(17555, NULL, 'G3DSA:3.30.70.330:FF:001764', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17556, NULL, 'G3DSA:3.10.100.10:FF:000065', NULL, NULL, 'C-type lectin domain family 5 member A', NULL, NULL, NULL, NULL, NULL, 4),
(17557, NULL, 'G3DSA:2.60.120.10:FF:000761', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17558, NULL, 'G3DSA:3.30.70.3220:FF:000002', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(17559, NULL, 'G3DSA:3.40.190.10:FF:000570', NULL, NULL, 'NMDA class glutamate Receptor', NULL, NULL, NULL, NULL, NULL, 4),
(17560, NULL, 'G3DSA:3.10.10.10:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17561, NULL, 'G3DSA:2.130.10.10:FF:001097', NULL, NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(17562, NULL, 'G3DSA:1.25.40.10:FF:000376', NULL, NULL, 'tetratricopeptide repeat protein 21B isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(17563, NULL, 'G3DSA:3.30.70.330:FF:001472', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17564, NULL, 'G3DSA:3.80.10.10:FF:002957', NULL, NULL, 'Putative disease resistance protein At4g11170', NULL, NULL, NULL, NULL, NULL, 4),
(17565, NULL, 'G3DSA:1.20.900.10:FF:000098', NULL, NULL, 'AT26020p', NULL, NULL, NULL, NULL, NULL, 4),
(17566, NULL, 'G3DSA:2.60.40.10:FF:002226', NULL, NULL, 'Twitchin', NULL, NULL, NULL, NULL, NULL, 4),
(17567, NULL, 'G3DSA:1.20.1280.290:FF:000011', NULL, NULL, 'PQ loop repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(17568, NULL, 'G3DSA:1.10.565.10:FF:000163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17569, NULL, 'G3DSA:1.20.1270.280:FF:000057', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17570, NULL, 'G3DSA:3.30.160.60:FF:002642', NULL, NULL, 'Zinc finger protein 517', NULL, NULL, NULL, NULL, NULL, 4),
(17571, NULL, 'G3DSA:2.120.10.30:FF:000608', NULL, NULL, 'Acylamino acid-releasing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(17572, NULL, 'G3DSA:1.10.287.1770:FF:000011', NULL, NULL, 'Ferrous iron transport protein B', NULL, NULL, NULL, NULL, NULL, 4),
(17573, NULL, 'G3DSA:1.10.10.440:FF:000055', NULL, NULL, 'Pre-mRNA-processing protein 40C', NULL, NULL, NULL, NULL, NULL, 4),
(17574, NULL, 'G3DSA:3.30.40.10:FF:000926', NULL, NULL, 'TNF receptor-associated factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17575, NULL, 'G3DSA:1.10.3200.20:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17576, NULL, 'G3DSA:2.60.40.60:FF:000774', NULL, NULL, 'Cadherin', NULL, NULL, NULL, NULL, NULL, 4),
(17577, NULL, 'G3DSA:3.30.310.10:FF:000065', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(17578, NULL, 'G3DSA:2.60.40.650:FF:000013', NULL, NULL, 'Nitrate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(17579, NULL, 'G3DSA:3.90.1150.210:FF:000013', NULL, NULL, 'F-actin-capping protein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(17580, NULL, 'G3DSA:3.40.50.300:FF:002120', NULL, NULL, 'DNA2/NAM7 helicase', NULL, NULL, NULL, NULL, NULL, 4),
(17581, NULL, 'G3DSA:3.20.20.70:FF:000123', NULL, NULL, 'Dihydroorotate dehydrogenase (quinone)', NULL, NULL, NULL, NULL, NULL, 4),
(17582, NULL, 'G3DSA:1.10.8.160:FF:000001', NULL, NULL, 'DNA primase small subunit PriS', NULL, NULL, NULL, NULL, NULL, 4),
(17583, NULL, 'G3DSA:1.10.510.10:FF:001060', NULL, NULL, 'Probable serine/threonine-protein kinase DDB_G0278535', NULL, NULL, NULL, NULL, NULL, 4),
(17584, NULL, 'G3DSA:3.40.50.1460:FF:000027', NULL, NULL, 'GM16490', NULL, NULL, NULL, NULL, NULL, 4),
(17585, NULL, 'G3DSA:3.40.30.10:FF:000167', NULL, NULL, 'Protein disulfide isomerase like, testis expressed', NULL, NULL, NULL, NULL, NULL, 4),
(17586, NULL, 'G3DSA:3.30.70.330:FF:001269', NULL, NULL, 'RNA Binding Motif protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(17587, NULL, 'G3DSA:2.60.40.1730:FF:000071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17588, NULL, 'G3DSA:3.80.10.10:FF:000720', NULL, NULL, 'Carboxypeptidase N subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(17589, NULL, 'G3DSA:3.30.830.10:FF:000088', NULL, NULL, 'Zinc protease, insulinase family', NULL, NULL, NULL, NULL, NULL, 4),
(17590, NULL, 'G3DSA:1.10.287.70:FF:000135', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(17591, NULL, 'G3DSA:2.60.40.10:FF:000337', NULL, NULL, 'fibronectin type-III domain-containing protein 3A isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(17592, NULL, 'G3DSA:1.10.110.10:FF:000023', NULL, NULL, '2S albumin', NULL, NULL, NULL, NULL, NULL, 4),
(17593, NULL, 'G3DSA:1.25.40.10:FF:004182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17594, NULL, 'G3DSA:1.20.1250.20:FF:000920', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(17595, NULL, 'G3DSA:3.30.70.330:FF:002725', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17596, NULL, 'G3DSA:3.40.50.1820:FF:000978', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(17597, NULL, 'G3DSA:1.20.58.530:FF:000025', NULL, NULL, 'Myosin-2 heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(17598, NULL, 'G3DSA:1.10.10.10:FF:001857', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17599, NULL, 'G3DSA:3.30.200.20:FF:001993', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17600, NULL, 'G3DSA:1.20.1250.20:FF:001932', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17601, NULL, 'G3DSA:3.30.160.60:FF:002147', NULL, NULL, 'Zinc finger, C2H2 type', NULL, NULL, NULL, NULL, NULL, 4),
(17602, NULL, 'G3DSA:1.20.1270.60:FF:000259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17603, NULL, 'G3DSA:2.130.10.10:FF:000113', NULL, NULL, 'U4/U6 small nuclear ribonucleoprotein Prp4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(17604, NULL, 'G3DSA:1.20.1070.10:FF:000673', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17605, NULL, 'G3DSA:2.60.40.10:FF:001265', NULL, NULL, 'Leukemia inhibitory factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(17606, NULL, 'G3DSA:3.30.160.60:FF:003603', NULL, NULL, 'zinc finger protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(17607, NULL, 'G3DSA:1.20.58.80:FF:000094', NULL, NULL, 'Sorting nexin 15', NULL, NULL, NULL, NULL, NULL, 4),
(17608, NULL, 'G3DSA:3.30.70.270:FF:000301', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17609, NULL, 'G3DSA:3.40.50.1820:FF:000950', NULL, NULL, 'Alpha/Beta hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(17610, NULL, 'G3DSA:1.20.5.190:FF:000108', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17611, NULL, 'G3DSA:3.20.20.80:FF:000744', NULL, NULL, 'Si:dkey-224e22.2', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(17612, NULL, 'G3DSA:3.40.120.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17613, NULL, 'G3DSA:2.40.340.10:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17614, NULL, 'G3DSA:1.10.10.10:FF:001296', NULL, NULL, 'UPF0122 protein A6J86_005860', NULL, NULL, NULL, NULL, NULL, 4),
(17615, NULL, 'G3DSA:2.60.120.200:FF:000180', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(17616, NULL, 'G3DSA:1.50.40.10:FF:000548', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17617, NULL, 'G3DSA:2.60.40.10:FF:005896', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17618, NULL, 'G3DSA:1.10.10.10:FF:000368', NULL, NULL, 'vacuolar protein sorting-associated protein 36-like', NULL, NULL, NULL, NULL, NULL, 4),
(17619, NULL, 'G3DSA:3.30.160.60:FF:006481', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17620, NULL, 'G3DSA:1.20.1070.10:FF:000965', NULL, NULL, 'Gll0198 protein', NULL, NULL, NULL, NULL, NULL, 4),
(17621, NULL, 'G3DSA:1.10.472.10:FF:000059', NULL, NULL, 'RB transcriptional corepressor like 1', NULL, NULL, NULL, NULL, NULL, 4),
(17622, NULL, 'G3DSA:2.60.40.1180:FF:000153', NULL, NULL, 'Alpha-L-fucosidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(17623, NULL, 'G3DSA:4.10.400.10:FF:000011', NULL, NULL, 'Low-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(17624, NULL, 'G3DSA:1.10.730.10:FF:000148', NULL, NULL, 'Putative leucine--tRNA ligase, mitochondrial-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(17625, NULL, 'G3DSA:2.60.410.10:FF:000008', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(17626, NULL, 'G3DSA:3.30.200.20:FF:000908', NULL, NULL, 'CBN-DDR-2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(17627, NULL, 'G3DSA:1.25.40.20:FF:001453', NULL, NULL, 'Espin-like a', NULL, NULL, NULL, NULL, NULL, 4),
(17628, NULL, 'G3DSA:3.30.230.10:FF:000407', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17629, NULL, 'G3DSA:3.40.30.10:FF:000959', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(17630, NULL, 'G3DSA:1.25.40.10:FF:002293', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17631, NULL, 'G3DSA:3.40.50.620:FF:000417', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17632, NULL, 'G3DSA:3.30.40.10:FF:000893', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(17633, NULL, 'G3DSA:3.40.50.12780:FF:000056', NULL, NULL, 'Nonribosomal siderophore peptide synthase SidC', NULL, NULL, NULL, NULL, NULL, 4),
(17634, NULL, 'G3DSA:3.30.160.60:FF:000725', NULL, NULL, 'zinc finger protein 205 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(17635, NULL, 'G3DSA:1.10.8.60:FF:000410', NULL, NULL, 'ATPase family, AAA domain-containing 2B', NULL, NULL, NULL, NULL, NULL, 4),
(17636, NULL, 'G3DSA:3.30.60.30:FF:000175', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(17637, NULL, 'G3DSA:3.30.1460.50:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17638, NULL, 'G3DSA:3.40.50.300:FF:002709', NULL, NULL, 'Probable iron inhibited ABC transporter 2', NULL, NULL, NULL, NULL, NULL, 4),
(17639, NULL, 'G3DSA:1.20.1250.10:FF:000114', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17640, NULL, 'G3DSA:2.10.110.10:FF:000081', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(17641, NULL, 'G3DSA:1.25.40.10:FF:004119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17642, NULL, 'G3DSA:1.10.287.130:FF:000210', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(17643, NULL, 'G3DSA:2.60.40.2080:FF:000001', NULL, NULL, 'Discoidin-1 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(17644, NULL, 'G3DSA:2.170.240.10:FF:000002', NULL, NULL, 'Collagen type IV alpha 6 chain', NULL, NULL, NULL, NULL, NULL, 4),
(17645, NULL, 'G3DSA:3.30.300.350:FF:000002', NULL, NULL, 'GTPase Obg', NULL, NULL, NULL, NULL, NULL, 4),
(17646, NULL, 'G3DSA:2.60.40.10:FF:005008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(17647, NULL, 'G3DSA:3.90.740.10:FF:000011', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(17648, NULL, 'G3DSA:3.30.420.40:FF:000346', NULL, NULL, 'Lumenal Hsp70 protein', NULL, NULL, NULL, NULL, NULL, 4),
(17649, NULL, 'G3DSA:3.30.70.100:FF:000060', NULL, NULL, 'Antibiotic biosynthesis monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(17650, NULL, 'G3DSA:1.25.40.20:FF:000469', NULL, NULL, 'rabankyrin-5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(17651, NULL, 'G3DSA:3.40.50.300:FF:006335', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17652, NULL, 'G3DSA:3.10.260.40:FF:000001', NULL, NULL, 'BCL-6 corepressor isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(17653, NULL, 'G3DSA:2.140.10.30:FF:000006', NULL, NULL, 'Dipeptidyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(17654, NULL, 'G3DSA:1.10.287.1660:FF:000001', NULL, NULL, 'Erythrocyte binding antigen 175', NULL, NULL, NULL, NULL, NULL, 4),
(17655, NULL, 'G3DSA:3.40.50.1000:FF:000468', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17656, NULL, 'G3DSA:3.80.10.10:FF:004407', NULL, NULL, 'F-box family protein', NULL, NULL, NULL, NULL, NULL, 4),
(17657, NULL, 'G3DSA:1.10.8.1220:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17658, NULL, 'G3DSA:1.25.40.10:FF:004827', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17659, NULL, 'G3DSA:3.30.40.10:FF:001854', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17660, NULL, 'G3DSA:3.30.160.60:FF:004620', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17661, NULL, 'G3DSA:2.30.30.30:FF:000153', NULL, NULL, 'Mitochondrial ribosomal protein L24', NULL, NULL, NULL, NULL, NULL, 4),
(17662, NULL, 'G3DSA:4.10.320.10:FF:000010', NULL, NULL, 'Acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(17663, NULL, 'G3DSA:2.70.170.10:FF:000155', NULL, NULL, 'Nicotinic acetylcyoline receptor Dalpha 4 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(17664, NULL, 'G3DSA:1.10.10.10:FF:001329', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(17665, NULL, 'G3DSA:1.20.5.110:FF:000102', NULL, NULL, '60S ribosomal protein L13', NULL, NULL, NULL, NULL, NULL, 4),
(17666, NULL, 'G3DSA:3.30.160.60:FF:005020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17667, NULL, 'G3DSA:1.25.40.120:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17668, NULL, 'G3DSA:3.80.10.10:FF:003885', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17669, NULL, 'G3DSA:3.30.505.10:FF:000271', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17670, NULL, 'G3DSA:3.30.460.20:FF:000017', NULL, NULL, 'CorA family metal ion transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(17671, NULL, 'G3DSA:1.10.150.20:FF:000298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17672, NULL, 'G3DSA:2.60.120.740:FF:000021', NULL, NULL, 'Latrophilin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17673, NULL, 'G3DSA:2.70.70.10:FF:000024', NULL, NULL, 'Peptidase, M23 family', NULL, NULL, NULL, NULL, NULL, 4),
(17674, NULL, 'G3DSA:3.40.50.300:FF:002064', NULL, NULL, 'Multidrug resistance protein 1, 2, 3', NULL, NULL, NULL, NULL, NULL, 4),
(17675, NULL, 'G3DSA:3.20.20.100:FF:000029', NULL, NULL, 'Aldo-keto reductase', NULL, NULL, NULL, NULL, NULL, 4),
(17676, NULL, 'G3DSA:1.25.40.1010:FF:000011', NULL, NULL, 'N-alpha-acetyltransferase 16, NatA auxiliary subunit', NULL, NULL, NULL, NULL, NULL, 4),
(17677, NULL, 'G3DSA:1.10.287.2720:FF:000004', NULL, NULL, 'Unplaced genomic scaffold supercont1.15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(17678, NULL, 'G3DSA:1.25.40.120:FF:000011', NULL, NULL, 'Prenyltransferase alpha subunit repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(17679, NULL, 'G3DSA:3.40.390.10:FF:000079', NULL, NULL, 'Gone early, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(17680, NULL, 'G3DSA:2.40.50.100:FF:000153', NULL, NULL, 'Multidrug resistance protein VceA', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(17681, NULL, 'G3DSA:1.10.10.10:FF:001301', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(17682, NULL, 'G3DSA:3.20.20.70:FF:000090', NULL, NULL, 'Nicotinate-nucleotide pyrophosphorylase [carboxylating]', NULL, NULL, NULL, NULL, NULL, 4),
(17683, NULL, 'G3DSA:2.10.220.10:FF:000139', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(17684, NULL, 'G3DSA:4.10.1000.10:FF:000146', NULL, NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(17685, NULL, 'G3DSA:3.30.1010.10:FF:000002', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', NULL, NULL, NULL, NULL, NULL, 4),
(17686, NULL, 'G3DSA:2.70.160.11:FF:000015', NULL, NULL, 'Probable protein arginine N-methyltransferase 3', NULL, NULL, NULL, NULL, NULL, 4),
(17687, NULL, 'G3DSA:2.60.40.60:FF:000830', NULL, NULL, 'Proto-oncogene tyrosine-protein kinase receptor Ret', NULL, NULL, NULL, NULL, NULL, 4),
(17688, NULL, 'G3DSA:3.30.250.20:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17689, NULL, 'G3DSA:2.40.30.10:FF:000349', NULL, NULL, '60S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(17690, NULL, 'G3DSA:3.90.1180.10:FF:000006', NULL, NULL, '50S ribosomal protein L13', NULL, NULL, NULL, NULL, NULL, 4),
(17691, NULL, 'G3DSA:3.40.50.2300:FF:000403', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(17692, NULL, 'G3DSA:3.30.160.60:FF:002586', NULL, NULL, 'Zinc finger protein 787', NULL, NULL, NULL, NULL, NULL, 4),
(17693, NULL, 'G3DSA:2.60.40.150:FF:000392', NULL, NULL, 'Coiled-coil and C2 domain-containing protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(17694, NULL, 'G3DSA:1.25.40.790:FF:000015', NULL, NULL, 'CCR4-NOT core subunit', NULL, NULL, NULL, NULL, NULL, 4),
(17695, NULL, 'G3DSA:1.10.510.10:FF:000132', NULL, NULL, 'Serine/threonine-protein kinase SRK2A', NULL, NULL, NULL, NULL, NULL, 4),
(17696, NULL, 'G3DSA:3.30.230.10:FF:000059', NULL, NULL, '30S small subunit ribosomal protein S5', NULL, NULL, NULL, NULL, NULL, 4),
(17697, NULL, 'G3DSA:1.10.10.1740:FF:000001', NULL, NULL, 'Transmembrane protein 14A', NULL, NULL, NULL, NULL, NULL, 4),
(17698, NULL, 'G3DSA:1.10.510.10:FF:002554', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17699, NULL, 'G3DSA:3.30.420.150:FF:000008', NULL, NULL, 'Apyrase 1', NULL, NULL, NULL, NULL, NULL, 4),
(17700, NULL, 'G3DSA:1.10.510.10:FF:002369', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17701, NULL, 'G3DSA:1.10.1510.30:FF:000002', NULL, NULL, 'Probable tRNA pseudouridine synthase D', NULL, NULL, NULL, NULL, NULL, 4),
(17702, NULL, 'G3DSA:3.40.50.2000:FF:001095', NULL, NULL, 'Sulfoquinovosyl transferase SQD2', NULL, NULL, NULL, NULL, NULL, 4),
(17703, NULL, 'G3DSA:3.80.10.10:FF:004374', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17704, NULL, 'G3DSA:1.10.287.1060:FF:000001', NULL, NULL, 'Charged multivesicular body protein 4b', NULL, NULL, NULL, NULL, NULL, 4),
(17705, NULL, 'G3DSA:3.90.190.10:FF:000249', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17706, NULL, 'G3DSA:1.25.40.210:FF:000010', NULL, NULL, 'Telomeric repeat-binding factor a', NULL, NULL, NULL, NULL, NULL, 4),
(17707, NULL, 'G3DSA:3.40.50.1000:FF:000092', NULL, NULL, 'copper-transporting ATPase 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(17708, NULL, 'G3DSA:3.90.640.10:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17709, NULL, 'G3DSA:2.20.230.10:FF:000003', NULL, NULL, 'Resuscitation-promoting factor RpfB', NULL, NULL, NULL, NULL, NULL, 4),
(17710, NULL, 'G3DSA:2.30.29.30:FF:001212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17711, NULL, 'G3DSA:3.90.226.10:FF:000350', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17712, NULL, 'G3DSA:3.20.20.80:FF:000828', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(17713, NULL, 'G3DSA:3.10.660.10:FF:000011', NULL, NULL, 'Putative chaperone protein DNAj', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(17714, NULL, 'G3DSA:1.20.5.470:FF:000013', NULL, NULL, 'Argininosuccinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(17715, NULL, 'G3DSA:2.130.10.10:FF:003991', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17716, NULL, 'G3DSA:2.40.420.20:FF:000033', NULL, NULL, 'Periplasmic component of efflux system', NULL, NULL, NULL, NULL, NULL, 4),
(17717, NULL, 'G3DSA:2.60.40.10:FF:003007', NULL, NULL, 'Glycoside hydrolase family 2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(17718, NULL, 'G3DSA:1.25.40.990:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17719, NULL, 'G3DSA:3.40.50.720:FF:001285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17720, NULL, 'G3DSA:1.10.1060.10:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17721, NULL, 'G3DSA:3.40.50.720:FF:000301', NULL, NULL, 'Hydroxysteroid dehydrogenase like 2', NULL, NULL, NULL, NULL, NULL, 4),
(17722, NULL, 'G3DSA:3.80.10.10:FF:001940', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(17723, NULL, 'G3DSA:1.10.12.10:FF:000030', NULL, NULL, 'Putative enoyl-hydratase isomerase protein', NULL, NULL, NULL, NULL, NULL, 4),
(17724, NULL, 'G3DSA:3.30.160.360:FF:000005', NULL, NULL, 'Putative lysine-specific demethylase JMJ16', NULL, NULL, NULL, NULL, NULL, 4),
(17725, NULL, 'G3DSA:1.25.40.10:FF:003782', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17726, NULL, 'G3DSA:3.90.226.10:FF:000294', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(17727, NULL, 'G3DSA:2.60.120.260:FF:000063', NULL, NULL, 'Putative alpha-L-arabinofuranosidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(17728, NULL, 'G3DSA:3.30.1330.60:FF:000007', NULL, NULL, 'Flagellar motor protein MotB', NULL, NULL, NULL, NULL, NULL, 4),
(17729, NULL, 'G3DSA:3.30.1370.10:FF:000107', NULL, NULL, 'Scp160p', NULL, NULL, NULL, NULL, NULL, 4),
(17730, NULL, 'G3DSA:3.40.50.11980:FF:000001', NULL, NULL, 'ZC3H12A isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(17731, NULL, 'G3DSA:3.40.50.300:FF:008224', NULL, NULL, 'Cytoplasmic dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17732, NULL, 'G3DSA:1.25.10.10:FF:002173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17733, NULL, 'G3DSA:3.30.160.60:FF:001366', NULL, NULL, 'Zinc finger protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(17734, NULL, 'G3DSA:3.80.10.10:FF:001884', NULL, NULL, 'SUMO-specific peptidase 7a', NULL, NULL, NULL, NULL, NULL, 4),
(17735, NULL, 'G3DSA:2.30.29.30:FF:001156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17736, NULL, 'G3DSA:3.40.630.30:FF:000626', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17737, NULL, 'G3DSA:3.40.33.10:FF:000168', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17738, NULL, 'G3DSA:3.40.50.1000:FF:000440', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(17739, NULL, 'G3DSA:3.75.10.10:FF:000002', NULL, NULL, 'Arginine deiminase', NULL, NULL, NULL, NULL, NULL, 4),
(17740, NULL, 'G3DSA:1.10.287.10:FF:000016', NULL, NULL, 'RNA polymerase II CTD phosphatase Fcp1', NULL, NULL, NULL, NULL, NULL, 4),
(17741, NULL, 'G3DSA:1.10.1420.10:FF:000017', NULL, NULL, 'DNA mismatch repair protein Msh2', NULL, NULL, NULL, NULL, NULL, 4),
(17742, NULL, 'G3DSA:2.40.50.140:FF:000030', NULL, NULL, '26S protease regulatory subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(17743, NULL, 'G3DSA:2.60.120.260:FF:000591', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17744, NULL, 'G3DSA:3.30.930.10:FF:000213', NULL, NULL, 'Probable threonine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(17745, NULL, 'G3DSA:3.40.50.1000:FF:000384', NULL, NULL, 'Trehalose 6-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(17746, NULL, 'G3DSA:3.30.200.20:FF:001549', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(17747, NULL, 'G3DSA:1.10.10.10:FF:000992', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(17748, NULL, 'G3DSA:1.20.120.1490:FF:000004', NULL, NULL, 'LTXXQ domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(17749, NULL, 'G3DSA:1.25.40.10:FF:000612', NULL, NULL, 'Protein prenylyltransferase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(17750, NULL, 'G3DSA:3.30.160.60:FF:001422', NULL, NULL, 'replication initiator 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(17751, NULL, 'G3DSA:3.30.360.50:FF:000001', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(17752, NULL, 'G3DSA:3.30.160.60:FF:005109', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17753, NULL, 'G3DSA:3.40.50.1100:FF:000116', NULL, NULL, 'Threonine dehydratase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17754, NULL, 'G3DSA:3.30.430.20:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17755, NULL, 'G3DSA:2.120.10.90:FF:000019', NULL, NULL, 'Type 2 topoisomerase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(17756, NULL, 'G3DSA:3.30.70.980:FF:000042', NULL, NULL, 'Translational activator of mitochondrially encoded cytochrome c oxidase I', NULL, NULL, NULL, NULL, NULL, 4),
(17757, NULL, 'G3DSA:3.40.630.30:FF:000481', NULL, NULL, 'Acetyltransferase, GNAT family protein', NULL, NULL, NULL, NULL, NULL, 4),
(17758, NULL, 'G3DSA:2.70.150.10:FF:000244', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(17759, NULL, 'G3DSA:3.40.190.10:FF:000007', NULL, NULL, 'Putative glutamate receptor ionotropic NMDA 2B', NULL, NULL, NULL, NULL, NULL, 4),
(17760, NULL, 'G3DSA:3.90.660.10:FF:000010', NULL, NULL, 'Amine oxidase [flavin-containing] B', NULL, NULL, NULL, NULL, NULL, 4),
(17761, NULL, 'G3DSA:2.160.20.80:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17762, NULL, 'G3DSA:3.10.20.90:FF:000450', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(17763, NULL, 'G3DSA:1.25.40.20:FF:001166', NULL, NULL, 'Arginine N-methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(17764, NULL, 'G3DSA:3.40.50.300:FF:006566', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17765, NULL, 'G3DSA:3.30.40.10:FF:000134', NULL, NULL, 'Ring finger protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(17766, NULL, 'G3DSA:1.25.40.10:FF:001124', NULL, NULL, 'Os11g0483950 protein', NULL, NULL, NULL, NULL, NULL, 4),
(17767, NULL, 'G3DSA:1.10.3260.10:FF:000038', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(17768, NULL, 'G3DSA:3.40.30.10:FF:001004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17769, NULL, 'G3DSA:3.30.70.580:FF:000006', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(17770, NULL, 'G3DSA:3.30.420.40:FF:000577', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17771, NULL, 'G3DSA:3.50.50.100:FF:000034', NULL, NULL, 'Pyridine nucleotide-disulphide oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17772, NULL, 'G3DSA:3.30.710.10:FF:000433', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17773, NULL, 'G3DSA:1.10.510.10:FF:002841', NULL, NULL, 'Serine/threonine-protein kinase NEK', NULL, NULL, NULL, NULL, NULL, 4),
(17774, NULL, 'G3DSA:3.40.50.1440:FF:000049', NULL, NULL, 'Tubulin gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(17775, NULL, 'G3DSA:3.10.20.30:FF:000095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17776, NULL, 'G3DSA:3.90.79.10:FF:000136', NULL, NULL, 'mRNA-decapping enzyme subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(17777, NULL, 'G3DSA:1.20.142.10:FF:000021', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(17778, NULL, 'G3DSA:1.10.274.30:FF:000015', NULL, NULL, 'Mortality factor 4-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(17779, NULL, 'G3DSA:1.10.472.10:FF:000711', NULL, NULL, 'WNK lysine deficient protein kinase 4', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(17780, NULL, 'G3DSA:1.10.8.270:FF:000034', NULL, NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', NULL, NULL, NULL, NULL, NULL, 4),
(17781, NULL, 'G3DSA:3.30.450.50:FF:000031', NULL, NULL, 'Longin-type vesicle-associated membrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17782, NULL, 'G3DSA:3.30.70.270:FF:000032', NULL, NULL, 'Cyclic di-GMP phosphodiesterase Gmr', NULL, NULL, NULL, NULL, NULL, 4),
(17783, NULL, 'G3DSA:1.20.1070.10:FF:002146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17784, NULL, 'G3DSA:3.90.70.80:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17785, NULL, 'G3DSA:3.40.50.300:FF:004481', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(17786, NULL, 'G3DSA:1.25.10.10:FF:003426', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17787, NULL, 'G3DSA:1.10.150.20:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17788, NULL, 'G3DSA:3.40.1770.10:FF:000001', NULL, NULL, 'Urocanate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(17789, NULL, 'G3DSA:1.10.132.50:FF:000006', NULL, NULL, 'V-type proton ATPase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(17790, NULL, 'G3DSA:1.25.40.10:FF:005339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17791, NULL, 'G3DSA:2.10.25.10:FF:001075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17792, NULL, 'G3DSA:3.40.50.150:FF:000433', NULL, NULL, 'Protein arginine N-methyltransferase 7', NULL, NULL, NULL, NULL, NULL, 4),
(17793, NULL, 'G3DSA:2.10.25.10:FF:001131', NULL, NULL, 'pro-neuregulin-3, membrane-bound isoform', NULL, NULL, NULL, NULL, NULL, 4),
(17794, NULL, 'G3DSA:3.30.450.70:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17795, NULL, 'G3DSA:1.20.1270.60:FF:000231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17796, NULL, 'G3DSA:3.30.200.20:FF:001605', NULL, NULL, 'Kinase-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(17797, NULL, 'G3DSA:1.25.40.820:FF:000007', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(17798, NULL, 'G3DSA:3.30.70.2280:FF:000006', NULL, NULL, 'Nucleolar RNA helicase II, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17799, NULL, 'G3DSA:2.30.180.10:FF:000013', NULL, NULL, 'Fasciclin-like arabinogalactan protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(17800, NULL, 'G3DSA:3.30.497.10:FF:000054', NULL, NULL, 'Serpin peptidase inhibitor, clade E (nexin, plasminogen activator inhibitor type 1), member 3', NULL, NULL, NULL, NULL, NULL, 4),
(17801, NULL, 'G3DSA:3.10.25.10:FF:000021', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17802, NULL, 'G3DSA:1.25.40.90:FF:000001', NULL, NULL, 'phosphatidylinositol-binding clathrin assembly protein-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(17803, NULL, 'G3DSA:1.20.1070.10:FF:000257', NULL, NULL, 'Histamine H4 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(17804, NULL, 'G3DSA:3.30.505.10:FF:000208', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17805, NULL, 'G3DSA:1.20.1250.20:FF:000212', NULL, NULL, 'Solute carrier family 15 member 4', NULL, NULL, NULL, NULL, NULL, 4),
(17806, NULL, 'G3DSA:2.130.10.10:FF:003042', NULL, NULL, 'YALI0D06435p', NULL, NULL, NULL, NULL, NULL, 4),
(17807, NULL, 'G3DSA:3.40.50.2300:FF:001100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17808, NULL, 'G3DSA:1.10.840.10:FF:000033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17809, NULL, 'G3DSA:2.70.150.10:FF:000300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17810, NULL, 'G3DSA:3.10.180.10:FF:000076', NULL, NULL, 'Uncharacterized protein At5g48480', NULL, NULL, NULL, NULL, NULL, 4),
(17811, NULL, 'G3DSA:3.40.50.1820:FF:000242', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(17812, NULL, 'G3DSA:1.20.1070.10:FF:001038', NULL, NULL, 'Adhesion G protein-coupled receptor G7, tandem duplicate 2', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(17813, NULL, 'G3DSA:1.10.510.10:FF:000368', NULL, NULL, 'cold-responsive protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(17814, NULL, 'G3DSA:3.30.800.10:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17815, NULL, 'G3DSA:3.40.50.1240:FF:000017', NULL, NULL, 'Histidine acid phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(17816, NULL, 'G3DSA:2.130.10.10:FF:001861', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(17817, NULL, 'G3DSA:3.40.1110.10:FF:000255', NULL, NULL, 'Cu-transporting ATPase type-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17818, NULL, 'G3DSA:1.10.510.10:FF:001149', NULL, NULL, 'Alk1p', NULL, NULL, NULL, NULL, NULL, 4),
(17819, NULL, 'G3DSA:1.10.418.10:FF:000069', NULL, NULL, 'p-loop nucleoside triphosphate hydrolase superfamily protein with CH (Calponin Homology) domain', NULL, NULL, NULL, NULL, NULL, 4),
(17820, NULL, 'G3DSA:1.20.5.1500:FF:000005', NULL, NULL, 'Nucleosome assembly protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(17821, NULL, 'G3DSA:3.30.70.330:FF:000488', NULL, NULL, 'Poly(A)-specific ribonuclease PARN', NULL, NULL, NULL, NULL, NULL, 4),
(17822, NULL, 'G3DSA:1.10.760.10:FF:000032', NULL, NULL, 'L-cysteine S-thiosulfotransferase subunit SoxA', NULL, NULL, NULL, NULL, NULL, 4),
(17823, NULL, 'G3DSA:1.10.730.10:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17824, NULL, 'G3DSA:3.90.70.10:FF:000324', NULL, NULL, 'Calpain-like cysteine peptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17825, NULL, 'G3DSA:2.60.120.200:FF:000472', NULL, NULL, 'Plasminogen', NULL, NULL, NULL, NULL, NULL, 4),
(17826, NULL, 'G3DSA:3.40.50.300:FF:006190', NULL, NULL, 'Translation initiation factor IF-2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(17827, NULL, 'G3DSA:1.50.40.10:FF:000256', NULL, NULL, 'GD24129', NULL, NULL, NULL, NULL, NULL, 4),
(17828, NULL, 'G3DSA:1.50.40.10:FF:000312', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17829, NULL, 'G3DSA:3.20.20.80:FF:000452', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17830, NULL, 'G3DSA:4.10.400.10:FF:000303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17831, NULL, 'G3DSA:3.40.50.740:FF:000043', NULL, NULL, 'NADH dehydrogenase I, G subunit', NULL, NULL, NULL, NULL, NULL, 4),
(17832, NULL, 'G3DSA:3.30.70.1150:FF:000004', NULL, NULL, 'Putative nickel-responsive regulator', NULL, NULL, NULL, NULL, NULL, 4),
(17833, NULL, 'G3DSA:2.40.160.60:FF:000007', NULL, NULL, 'Long-chain fatty acid transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(17834, NULL, 'G3DSA:1.10.238.20:FF:000041', NULL, NULL, 'Odorant binding protein 20', NULL, NULL, NULL, NULL, NULL, 4),
(17835, NULL, 'G3DSA:1.10.10.60:FF:001086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17836, NULL, 'G3DSA:3.40.50.970:FF:000179', NULL, NULL, 'Probable 2-oxoglutarate dehydrogenase E1 component DHKTD1 homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(17837, NULL, 'G3DSA:3.40.50.10470:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17838, NULL, 'G3DSA:1.10.238.10:FF:000504', NULL, NULL, 'Protein CBG11013', NULL, NULL, NULL, NULL, NULL, 4),
(17839, NULL, 'G3DSA:1.10.30.10:FF:000083', NULL, NULL, 'High mobility group B protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(17840, NULL, 'G3DSA:4.10.400.10:FF:000247', NULL, NULL, 'LDL receptor protein 1, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(17841, NULL, 'G3DSA:2.40.155.10:FF:000003', NULL, NULL, 'Green fluorescent protein', NULL, NULL, NULL, NULL, NULL, 4),
(17842, NULL, 'G3DSA:2.130.10.10:FF:004823', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17843, NULL, 'G3DSA:2.60.120.260:FF:000439', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17844, NULL, 'G3DSA:3.20.20.140:FF:000249', NULL, NULL, 'Formimidoylglutamate deiminase', NULL, NULL, NULL, NULL, NULL, 4),
(17845, NULL, 'G3DSA:3.40.50.80:FF:000054', NULL, NULL, 'Ferric reduction oxidase 7', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(17846, NULL, 'G3DSA:3.40.50.10310:FF:000006', NULL, NULL, 'Creatinine amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(17847, NULL, 'G3DSA:3.30.559.10:FF:000187', NULL, NULL, 'HXXXD-type acyl-transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(17848, NULL, 'G3DSA:3.30.40.10:FF:000421', NULL, NULL, 'Cell growth regulator with ring finger domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(17849, NULL, 'G3DSA:2.130.10.10:FF:003839', NULL, NULL, 'Ectopic P granules protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(17850, NULL, 'G3DSA:1.20.1560.10:FF:000396', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17851, NULL, 'G3DSA:1.10.560.10:FF:000051', NULL, NULL, 'Thermosome subunit', NULL, NULL, NULL, NULL, NULL, 4),
(17852, NULL, 'G3DSA:1.10.287.130:FF:000007', NULL, NULL, 'Sensor histidine kinase CpxA', NULL, NULL, NULL, NULL, NULL, 4),
(17853, NULL, 'G3DSA:3.30.479.20:FF:000043', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(17854, NULL, 'G3DSA:1.10.510.10:FF:000424', NULL, NULL, 'Putative interleukin-1 receptor-associated kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(17855, NULL, 'G3DSA:3.40.1110.10:FF:000199', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(17856, NULL, 'G3DSA:3.30.40.10:FF:000365', NULL, NULL, 'Zinc finger family protein', NULL, NULL, NULL, NULL, NULL, 4),
(17857, NULL, 'G3DSA:2.40.50.140:FF:000406', NULL, NULL, 'Breast and ovarian cancer susceptibility protein 2 truncated variant', NULL, NULL, NULL, NULL, NULL, 4),
(17858, NULL, 'G3DSA:3.30.160.60:FF:003131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17859, NULL, 'G3DSA:3.30.559.10:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17860, NULL, 'G3DSA:1.10.10.60:FF:000158', NULL, NULL, 'MYB transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(17861, NULL, 'G3DSA:1.20.58.100:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17862, NULL, 'G3DSA:3.30.230.10:FF:000115', NULL, NULL, '40S ribosomal protein S16 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(17863, NULL, 'G3DSA:2.60.40.10:FF:001681', NULL, NULL, 'filamin-A isoform X7', NULL, NULL, NULL, NULL, NULL, 4),
(17864, NULL, 'G3DSA:3.30.457.60:FF:000010', NULL, NULL, 'AGAP006632-PA', NULL, NULL, NULL, NULL, NULL, 4),
(17865, NULL, 'G3DSA:1.20.1250.20:FF:000156', NULL, NULL, 'monocarboxylate transporter 8 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(17866, NULL, 'G3DSA:2.40.10.10:FF:000443', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17867, NULL, 'G3DSA:1.20.80.10:FF:000001', NULL, NULL, 'Erythrocyte membrane protein band 4.1', NULL, NULL, NULL, NULL, NULL, 4),
(17868, NULL, 'G3DSA:3.40.50.300:FF:001928', NULL, NULL, 'V-Ha-ras Harvey rat sarcoma viral oncogene-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(17869, NULL, 'G3DSA:3.40.50.970:FF:000235', NULL, NULL, 'Oxoglutarate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(17870, NULL, 'G3DSA:2.20.100.10:FF:000106', NULL, NULL, 'Spondin-1', NULL, NULL, NULL, NULL, NULL, 4),
(17871, NULL, 'G3DSA:3.40.50.2000:FF:000959', NULL, NULL, 'Mannosyltransferase B', NULL, NULL, NULL, NULL, NULL, 4),
(17872, NULL, 'G3DSA:3.30.70.330:FF:000544', NULL, NULL, 'eukaryotic translation initiation factor 4B isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(17873, NULL, 'G3DSA:3.80.20.20:FF:000078', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(17874, NULL, 'G3DSA:3.30.200.20:FF:000301', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(17875, NULL, 'G3DSA:3.30.160.60:FF:003311', NULL, NULL, 'GD19232', NULL, NULL, NULL, NULL, NULL, 4),
(17876, NULL, 'G3DSA:2.60.40.10:FF:002193', NULL, NULL, 'Polycystin 1, transient receptor potential channel interacting', NULL, NULL, NULL, NULL, NULL, 4),
(17877, NULL, 'G3DSA:3.40.50.2300:FF:001572', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17878, NULL, 'G3DSA:3.90.640.10:FF:000211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(17879, NULL, 'G3DSA:2.60.220.20:FF:000002', NULL, NULL, 'Glycoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(17880, NULL, 'G3DSA:1.25.40.10:FF:000292', NULL, NULL, 'Serine/threonine-protein phosphatase 5', NULL, NULL, NULL, NULL, NULL, 4),
(17881, NULL, 'G3DSA:1.25.40.10:FF:004558', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g67570, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(17882, NULL, 'G3DSA:2.130.10.10:FF:000169', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(17883, NULL, 'G3DSA:2.60.120.200:FF:000505', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(17884, NULL, 'G3DSA:2.60.40.10:FF:005424', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17885, NULL, 'G3DSA:3.90.180.10:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17886, NULL, 'G3DSA:3.80.10.10:FF:000248', NULL, NULL, 'Leucine rich repeat containing 39', NULL, NULL, NULL, NULL, NULL, 4),
(17887, NULL, 'G3DSA:1.25.10.10:FF:001768', NULL, NULL, 'Transportin-3', NULL, NULL, NULL, NULL, NULL, 4),
(17888, NULL, 'G3DSA:1.10.510.10:FF:002785', NULL, NULL, 'IkB kinase', NULL, NULL, NULL, NULL, NULL, 4),
(17889, NULL, 'G3DSA:1.20.5.170:FF:000193', NULL, NULL, 'Tropomyosin-1, isoforms 9A/A/B-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(17890, NULL, 'G3DSA:2.130.10.10:FF:005548', NULL, NULL, 'zinc finger protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(17891, NULL, 'G3DSA:1.25.40.180:FF:000074', NULL, NULL, 'Unplaced genomic scaffold supercont1.20, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(17892, NULL, 'G3DSA:1.10.287.160:FF:000022', NULL, NULL, 'Protein kinase N1', NULL, NULL, NULL, NULL, NULL, 4),
(17893, NULL, 'G3DSA:3.30.160.60:FF:004912', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17894, NULL, 'G3DSA:1.20.1250.20:FF:001140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17895, NULL, 'G3DSA:1.20.58.70:FF:000052', NULL, NULL, 'Syntaxin 5 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(17896, NULL, 'G3DSA:1.25.10.10:FF:000520', NULL, NULL, 'Exportin-7-A', NULL, NULL, NULL, NULL, NULL, 4),
(17897, NULL, 'G3DSA:2.70.150.10:FF:000064', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(17898, NULL, 'G3DSA:3.40.850.10:FF:000362', NULL, NULL, 'Heavy chain, Unconventional Myosin', NULL, NULL, NULL, NULL, NULL, 4),
(17899, NULL, 'G3DSA:3.40.50.1780:FF:000005', NULL, NULL, 'Fe-hydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17900, NULL, 'G3DSA:3.40.50.1820:FF:000186', NULL, NULL, 'Protein phosphatase methylesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(17901, NULL, 'G3DSA:3.30.420.10:FF:000186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17902, NULL, 'G3DSA:4.10.240.10:FF:000004', NULL, NULL, 'Xylanolytic transcriptional activator XlnR', NULL, NULL, NULL, NULL, NULL, 4),
(17903, NULL, 'G3DSA:1.20.58.60:FF:000195', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(17904, NULL, 'G3DSA:3.40.50.1000:FF:000704', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17905, NULL, 'G3DSA:1.10.238.10:FF:000471', NULL, NULL, 'Calcineurin b subunit', NULL, NULL, NULL, NULL, NULL, 4),
(17906, NULL, 'G3DSA:2.10.25.160:FF:000011', NULL, NULL, 'Cysteine endopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(17907, NULL, 'G3DSA:3.40.50.150:FF:000377', NULL, NULL, '50S ribosomal protein L11 methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(17908, NULL, 'G3DSA:1.10.1670.10:FF:000064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17909, NULL, 'G3DSA:2.30.42.10:FF:000394', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17910, NULL, 'G3DSA:1.20.1070.10:FF:001370', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17911, NULL, 'G3DSA:1.10.405.20:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17912, NULL, 'G3DSA:3.40.50.300:FF:001895', NULL, NULL, 'Putative translation initiation factor IF-2', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(17913, NULL, 'G3DSA:3.80.10.10:FF:003593', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17914, NULL, 'G3DSA:3.30.40.10:FF:001438', NULL, NULL, 'TNF receptor-associated factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(17915, NULL, 'G3DSA:1.20.1270.60:FF:000175', NULL, NULL, 'SH3 domain signalling protein (AFU_orthologue AFUA_5G07670)', NULL, NULL, NULL, NULL, NULL, 4),
(17916, NULL, 'G3DSA:3.90.1140.10:FF:000032', NULL, NULL, 'U6 snRNA phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(17917, NULL, 'G3DSA:3.40.50.1010:FF:000241', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17918, NULL, 'G3DSA:3.30.230.130:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17919, NULL, 'G3DSA:3.40.5.50:FF:000003', NULL, NULL, 'DNA replication complex GINS protein PSF2', NULL, NULL, NULL, NULL, NULL, 4),
(17920, NULL, 'G3DSA:3.40.50.1980:FF:000149', NULL, NULL, 'Iron ABC transporter, periplasmic substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(17921, NULL, 'G3DSA:1.25.40.20:FF:001222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17922, NULL, 'G3DSA:2.60.40.10:FF:002754', NULL, NULL, 'One IG domain', NULL, NULL, NULL, NULL, NULL, 4),
(17923, NULL, 'G3DSA:2.30.30.40:FF:000302', NULL, NULL, 'Abp1p', NULL, NULL, NULL, NULL, NULL, 4),
(17924, NULL, 'G3DSA:3.20.20.70:FF:000595', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17925, NULL, 'G3DSA:1.10.472.10:FF:000475', NULL, NULL, 'Cyclin superfamily protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17926, NULL, 'G3DSA:1.20.1070.10:FF:001893', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17927, NULL, 'G3DSA:3.90.550.10:FF:000620', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17928, NULL, 'G3DSA:3.40.50.12780:FF:000112', NULL, NULL, 'Nonribosomal peptide synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17929, NULL, 'G3DSA:1.20.58.60:FF:000700', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17930, NULL, 'G3DSA:1.10.510.10:FF:002077', NULL, NULL, 'Protein CBG07288', NULL, NULL, NULL, NULL, NULL, 4),
(17931, NULL, 'G3DSA:3.40.390.10:FF:000282', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17932, NULL, 'G3DSA:3.30.160.60:FF:000641', NULL, NULL, 'zinc finger protein 317 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(17933, NULL, 'G3DSA:3.40.50.300:FF:003553', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17934, NULL, 'G3DSA:1.10.8.10:FF:000148', NULL, NULL, 'Auxilin-like clathrin uncoating factor SWA2', NULL, NULL, NULL, NULL, NULL, 4),
(17935, NULL, 'G3DSA:2.10.70.80:FF:000014', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(17936, NULL, 'G3DSA:2.20.25.10:FF:000006', NULL, NULL, 'Tenascin C', NULL, NULL, NULL, NULL, NULL, 4),
(17937, NULL, 'G3DSA:3.40.50.300:FF:006279', NULL, NULL, 'Replication factor C subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(17938, NULL, 'G3DSA:3.30.428.70:FF:000007', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17939, NULL, 'G3DSA:2.10.25.10:FF:000203', NULL, NULL, 'oncoprotein-induced transcript 3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(17940, NULL, 'G3DSA:3.40.50.1440:FF:000105', NULL, NULL, 'Polynucleotide adenylyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(17941, NULL, 'G3DSA:3.40.50.1220:FF:000006', NULL, NULL, '2-hydroxyacyl-CoA lyase 1', NULL, NULL, NULL, NULL, NULL, 4),
(17942, NULL, 'G3DSA:2.60.40.1220:FF:000002', NULL, NULL, 'Internalin A', NULL, NULL, NULL, NULL, NULL, 4),
(17943, NULL, 'G3DSA:3.30.70.2820:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17944, NULL, 'G3DSA:1.20.1090.10:FF:000056', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(17945, NULL, 'G3DSA:1.10.287.380:FF:000032', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17946, NULL, 'G3DSA:2.60.40.60:FF:000919', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17947, NULL, 'G3DSA:1.10.287.690:FF:000006', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(17948, NULL, 'G3DSA:2.40.160.10:FF:000077', NULL, NULL, 'Mitochondrial import receptor subunit TOM40 homolog 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(17949, NULL, 'G3DSA:1.20.1250.20:FF:002101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17950, NULL, 'G3DSA:3.40.50.300:FF:008044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17951, NULL, 'G3DSA:1.10.287.3990:FF:000003', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(17952, NULL, 'G3DSA:3.40.140.10:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17953, NULL, 'G3DSA:3.30.1490.40:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17954, NULL, 'G3DSA:3.80.10.10:FF:001029', NULL, NULL, 'Blast:Chaoptin', NULL, NULL, NULL, NULL, NULL, 4),
(17955, NULL, 'G3DSA:2.60.120.10:FF:000233', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(17956, NULL, 'G3DSA:3.90.930.40:FF:000001', NULL, NULL, 'ribosomal oxygenase 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(17957, NULL, 'G3DSA:3.40.50.300:FF:007768', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17958, NULL, 'G3DSA:1.25.40.20:FF:000238', NULL, NULL, 'Unplaced genomic scaffold supercont1.20, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(17959, NULL, 'G3DSA:3.40.140.10:FF:000095', NULL, NULL, 'COP9 signalosome complex subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(17960, NULL, 'G3DSA:3.40.50.300:FF:005638', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17961, NULL, 'G3DSA:1.10.630.10:FF:000023', NULL, NULL, 'Cytochrome P450 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(17962, NULL, 'G3DSA:3.30.70.890:FF:000015', NULL, NULL, 'Diphosphomevalonate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(17963, NULL, 'G3DSA:2.60.220.50:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17964, NULL, 'G3DSA:3.40.50.720:FF:000357', NULL, NULL, 'Methionine adenosyltransferase 2 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(17965, NULL, 'G3DSA:3.40.50.2000:FF:000111', NULL, NULL, 'Monogalactosyldiacylglycerol synthase 3, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(17966, NULL, 'G3DSA:2.130.10.10:FF:002114', NULL, NULL, 'Os03g0151700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(17967, NULL, 'G3DSA:2.40.50.140:FF:000086', NULL, NULL, 'Cold shock domain-containing protein C2', NULL, NULL, NULL, NULL, NULL, 4),
(17968, NULL, 'G3DSA:3.40.30.10:FF:000695', NULL, NULL, 'Thiol:disulfide interchange protein DsbD', NULL, NULL, NULL, NULL, NULL, 4),
(17969, NULL, 'G3DSA:1.10.472.130:FF:000082', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(17970, NULL, 'G3DSA:1.20.120.1900:FF:000021', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(17971, NULL, 'G3DSA:1.20.1640.10:FF:000110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17972, NULL, 'G3DSA:2.40.33.10:FF:000007', NULL, NULL, 'Pyruvate kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(17973, NULL, 'G3DSA:3.40.50.300:FF:001423', NULL, NULL, 'Ras family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(17974, NULL, 'G3DSA:1.10.630.10:FF:000551', NULL, NULL, 'Putative cytochrome P450 superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(17975, NULL, 'G3DSA:3.30.300.30:FF:000161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17976, NULL, 'G3DSA:3.40.50.720:FF:001993', NULL, NULL, 'Short chain alcohol dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(17977, NULL, 'G3DSA:2.130.10.10:FF:000877', NULL, NULL, 'POC1 centriolar protein homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(17978, NULL, 'G3DSA:3.30.1360.120:FF:000045', NULL, NULL, 'Glycine cleavage T protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(17979, NULL, 'G3DSA:3.40.220.10:FF:000005', NULL, NULL, 'cytosol aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(17980, NULL, 'G3DSA:3.40.50.150:FF:001209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(17981, NULL, 'G3DSA:2.30.180.10:FF:000069', NULL, NULL, 'AGAP004426-PA', NULL, NULL, NULL, NULL, NULL, 4),
(17982, NULL, 'G3DSA:2.170.150.20:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17983, NULL, 'G3DSA:2.60.40.10:FF:002698', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(17984, NULL, 'G3DSA:3.80.10.10:FF:001176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17985, NULL, 'G3DSA:3.40.190.10:FF:000715', NULL, NULL, 'Sll0064 protein', NULL, NULL, NULL, NULL, NULL, 4),
(17986, NULL, 'G3DSA:3.30.70.920:FF:000007', NULL, NULL, 'AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(17987, NULL, 'G3DSA:2.60.40.10:FF:003715', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17988, NULL, 'G3DSA:2.30.30.100:FF:000022', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm8', NULL, NULL, NULL, NULL, NULL, 4),
(17989, NULL, 'G3DSA:1.25.40.10:FF:001629', NULL, NULL, 'Pentatricopeptide repeat domain-containing protein 3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(17990, NULL, 'G3DSA:3.30.160.60:FF:006037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17991, NULL, 'G3DSA:2.10.25.10:FF:000147', NULL, NULL, 'Disintegrin and metalloproteinase domain-containing protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(17992, NULL, 'G3DSA:2.30.29.30:FF:000228', NULL, NULL, 'ran-binding protein 3-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(17993, NULL, 'G3DSA:3.30.30.30:FF:000078', NULL, NULL, 'Heat shock protein 4b', NULL, NULL, NULL, NULL, NULL, 4),
(17994, NULL, 'G3DSA:1.20.1070.10:FF:001746', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(17995, NULL, 'G3DSA:3.30.70.20:FF:000139', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(17996, NULL, 'G3DSA:1.10.287.770:FF:000019', NULL, NULL, 'Blast:Pickpocket protein 28', NULL, NULL, NULL, NULL, NULL, 4),
(17997, NULL, 'G3DSA:2.60.40.10:FF:000192', NULL, NULL, 'Myomesin 1', NULL, NULL, NULL, NULL, NULL, 4),
(17998, NULL, 'G3DSA:3.90.640.60:FF:000001', NULL, NULL, 'Chromatin remodeling complex subunit (Arp9), putative', NULL, NULL, NULL, NULL, NULL, 4),
(17999, NULL, 'G3DSA:2.60.40.10:FF:000568', NULL, NULL, 'Leptin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(18000, NULL, 'G3DSA:1.10.510.10:FF:001913', NULL, NULL, 'Serine/threonine-protein kinase, putative (AFU_orthologue AFUA_6G02242)', NULL, NULL, NULL, NULL, NULL, 4),
(18001, NULL, 'G3DSA:1.10.10.60:FF:000361', NULL, NULL, 'ESX homeobox 1', NULL, NULL, NULL, NULL, NULL, 4),
(18002, NULL, 'G3DSA:2.30.29.30:FF:000431', NULL, NULL, 'Unplaced genomic scaffold supercont1.6, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(18003, NULL, 'G3DSA:3.30.300.30:FF:000014', NULL, NULL, 'acyl-CoA synthetase family member 4', NULL, NULL, NULL, NULL, NULL, 4),
(18004, NULL, 'G3DSA:1.10.287.110:FF:000468', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18005, NULL, 'G3DSA:1.10.510.10:FF:004263', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18006, NULL, 'G3DSA:3.90.550.10:FF:000384', NULL, NULL, 'Galactosyl transferase paralog', NULL, NULL, NULL, NULL, NULL, 4),
(18007, NULL, 'G3DSA:3.40.50.11380:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18008, NULL, 'G3DSA:3.40.50.720:FF:001318', NULL, NULL, 'Long-chain acyl-[acyl-carrier-protein] reductase', NULL, NULL, NULL, NULL, NULL, 4),
(18009, NULL, 'G3DSA:3.40.720.10:FF:000206', NULL, NULL, 'GPI ethanolamine phosphate transferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(18010, NULL, 'G3DSA:3.40.50.620:FF:000097', NULL, NULL, 'valine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(18011, NULL, 'G3DSA:3.30.450.20:FF:000432', NULL, NULL, 'Aryl-hydrocarbon receptor repressor a', NULL, NULL, NULL, NULL, NULL, 4),
(18012, NULL, 'G3DSA:3.30.40.10:FF:001590', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(18013, NULL, 'G3DSA:2.130.10.10:FF:000405', NULL, NULL, 'rho guanine nucleotide exchange factor 10-like protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(18014, NULL, 'G3DSA:1.10.472.10:FF:000531', NULL, NULL, 'cyclin-A2-1', NULL, NULL, NULL, NULL, NULL, 4),
(18015, NULL, 'G3DSA:1.10.510.10:FF:001857', NULL, NULL, 'Interleukin-1 receptor-associated kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(18016, NULL, 'G3DSA:3.40.50.300:FF:008191', NULL, NULL, 'Dynein, axonemal, heavy chain 5', NULL, NULL, NULL, NULL, NULL, 4),
(18017, NULL, 'G3DSA:3.40.190.10:FF:000862', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18018, NULL, 'G3DSA:1.10.150.240:FF:000047', NULL, NULL, 'BnaAnng05460D protein', NULL, NULL, NULL, NULL, NULL, 4),
(18019, NULL, 'G3DSA:3.30.710.10:FF:000197', NULL, NULL, 'Root phototropism protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(18020, NULL, 'G3DSA:3.40.50.880:FF:000091', NULL, NULL, 'Aminodeoxychorismate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(18021, NULL, 'G3DSA:1.20.58.1070:FF:000011', NULL, NULL, 'Gem-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(18022, NULL, 'G3DSA:3.90.1170.40:FF:000020', NULL, NULL, 'Molybdopterin biosynthesis MoaE protein', NULL, NULL, NULL, NULL, NULL, 4),
(18023, NULL, 'G3DSA:3.40.50.10190:FF:000195', NULL, NULL, 'DNA damage response protein Mdb1', NULL, NULL, NULL, NULL, NULL, 4),
(18024, NULL, 'G3DSA:3.10.129.110:FF:000023', NULL, NULL, 'Asperfuranone polyketide synthase afoG', NULL, NULL, NULL, NULL, NULL, 4),
(18025, NULL, 'G3DSA:1.20.1560.10:FF:000429', NULL, NULL, 'ATP-binding cassette alpha-factor transporter', NULL, NULL, NULL, NULL, NULL, 4),
(18026, NULL, 'G3DSA:2.60.40.10:FF:004463', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18027, NULL, 'G3DSA:1.25.40.610:FF:000006', NULL, NULL, 'latrophilin Cirl isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(18028, NULL, 'G3DSA:2.20.25.80:FF:000010', NULL, NULL, 'Putative WRKY transcription factor 69', NULL, NULL, NULL, NULL, NULL, 4),
(18029, NULL, 'G3DSA:3.30.160.60:FF:005076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18030, NULL, 'G3DSA:3.30.160.60:FF:002350', NULL, NULL, 'CG10321', NULL, NULL, NULL, NULL, NULL, 4),
(18031, NULL, 'G3DSA:1.20.1280.130:FF:000003', NULL, NULL, 'Vacuolar protein sorting-associated protein 54', NULL, NULL, NULL, NULL, NULL, 4),
(18032, NULL, 'G3DSA:2.120.10.30:FF:000316', NULL, NULL, 'SMP-30/Gluconolaconase/LRE-like region, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18033, NULL, 'G3DSA:3.60.15.10:FF:000081', NULL, NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(18034, NULL, 'G3DSA:3.80.10.10:FF:002665', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', NULL, NULL, NULL, NULL, NULL, 4),
(18035, NULL, 'G3DSA:3.50.50.60:FF:001071', NULL, NULL, 'Mitochondrial tRNA translation optimization 1', NULL, NULL, NULL, NULL, NULL, 4),
(18036, NULL, 'G3DSA:3.30.420.210:FF:000015', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18037, NULL, 'G3DSA:3.40.50.2000:FF:000583', NULL, NULL, 'Beta-1,6-galactofuranosyltransferase WbbI', NULL, NULL, NULL, NULL, NULL, 4),
(18038, NULL, 'G3DSA:3.10.530.10:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18039, NULL, 'G3DSA:1.25.40.10:FF:000668', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(18040, NULL, 'G3DSA:2.40.70.10:FF:000475', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18041, NULL, 'G3DSA:3.30.160.60:FF:004295', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18042, NULL, 'G3DSA:2.130.10.10:FF:004587', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18043, NULL, 'G3DSA:3.40.190.10:FF:000659', NULL, NULL, 'Oligopeptide-binding protein AppA', NULL, NULL, NULL, NULL, NULL, 4),
(18044, NULL, 'G3DSA:3.50.50.60:FF:000290', NULL, NULL, 'Lysine-specific histone demethylase 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18045, NULL, 'G3DSA:3.10.450.10:FF:000001', NULL, NULL, 'Cystatin-A', NULL, NULL, NULL, NULL, NULL, 4),
(18046, NULL, 'G3DSA:1.10.340.30:FF:000023', NULL, NULL, 'A/G specific adenine glycosylase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(18047, NULL, 'G3DSA:2.80.10.50:FF:000015', NULL, NULL, 'Fascin', NULL, NULL, NULL, NULL, NULL, 4),
(18048, NULL, 'G3DSA:1.25.10.10:FF:001392', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(18049, NULL, 'G3DSA:1.20.120.550:FF:000002', NULL, NULL, 'Microsomal glutathione S-transferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(18050, NULL, 'G3DSA:2.60.40.60:FF:001139', NULL, NULL, 'Flamingo-like protein celsr2', NULL, NULL, NULL, NULL, NULL, 4),
(18051, NULL, 'G3DSA:2.130.10.120:FF:000011', NULL, NULL, 'Oligopeptidase B', NULL, NULL, NULL, NULL, NULL, 4),
(18052, NULL, 'G3DSA:3.40.50.410:FF:000236', NULL, NULL, 'von Willebrand factor type A domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18053, NULL, 'G3DSA:3.30.565.10:FF:000387', NULL, NULL, 'DNA topoisomerase/DNA mismatch repair family protein, transducer domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(18054, NULL, 'G3DSA:1.10.4160.10:FF:000003', NULL, NULL, 'Cytosine permease', NULL, NULL, NULL, NULL, NULL, 4),
(18055, NULL, 'G3DSA:3.90.1150.10:FF:000061', NULL, NULL, 'dTDP-4-amino-4,6-dideoxygalactose transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(18056, NULL, 'G3DSA:1.20.120.720:FF:000042', NULL, NULL, 'Myosin XXI', NULL, NULL, NULL, NULL, NULL, 4),
(18057, NULL, 'G3DSA:1.10.10.10:FF:002026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18058, NULL, 'G3DSA:3.30.450.190:FF:000009', NULL, NULL, 'Ras-related GTP-binding protein A', NULL, NULL, NULL, NULL, NULL, 4),
(18059, NULL, 'G3DSA:3.20.20.150:FF:000022', NULL, NULL, 'D-psicose 3-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(18060, NULL, 'G3DSA:2.130.10.10:FF:004767', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18061, NULL, 'G3DSA:3.40.50.300:FF:005262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18062, NULL, 'G3DSA:3.30.70.330:FF:000691', NULL, NULL, 'Serine/arginine-rich splicing factor 12', NULL, NULL, NULL, NULL, NULL, 4),
(18063, NULL, 'G3DSA:3.30.230.70:FF:000150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18064, NULL, 'G3DSA:2.120.10.30:FF:000501', NULL, NULL, 'ABC transporter permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(18065, NULL, 'G3DSA:2.40.150.20:FF:000017', NULL, NULL, 'S60 ribosomal protein L23', NULL, NULL, NULL, NULL, NULL, 4),
(18066, NULL, 'G3DSA:3.90.190.10:FF:000160', NULL, NULL, 'GM15704', NULL, NULL, NULL, NULL, NULL, 4),
(18067, NULL, 'G3DSA:2.40.50.730:FF:000021', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(18068, NULL, 'G3DSA:1.10.10.10:FF:000604', NULL, NULL, 'Caffeic acid 3-O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(18069, NULL, 'G3DSA:2.60.40.2440:FF:000008', NULL, NULL, 'Type-1 protein phosphatase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(18070, NULL, 'G3DSA:1.10.238.10:FF:000976', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18071, NULL, 'G3DSA:1.10.10.60:FF:000922', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18072, NULL, 'G3DSA:3.50.50.60:FF:000143', NULL, NULL, 'FAD-dependent oxidoreductase domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(18073, NULL, 'G3DSA:1.10.3380.30:FF:000031', NULL, NULL, 'ATP-dependent DNA helicase Hel308', NULL, NULL, NULL, NULL, NULL, 4),
(18074, NULL, 'G3DSA:1.20.140.100:FF:000017', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18075, NULL, 'G3DSA:2.60.40.60:FF:000543', NULL, NULL, 'Cadherin 17, LI cadherin (liver-intestine)', NULL, NULL, NULL, NULL, NULL, 4),
(18076, NULL, 'G3DSA:1.10.510.10:FF:000896', NULL, NULL, 'CMGC/DYRK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(18077, NULL, 'G3DSA:3.30.1640.10:FF:000090', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(18078, NULL, 'G3DSA:1.25.40.470:FF:000037', NULL, NULL, 'Intraflagellar transport protein 122 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(18079, NULL, 'G3DSA:3.40.50.300:FF:005970', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(18080, NULL, 'G3DSA:3.30.160.60:FF:004148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18081, NULL, 'G3DSA:1.10.1130.10:FF:000006', NULL, NULL, 'C-type polyheme cytochrome OmcB', NULL, NULL, NULL, NULL, NULL, 4),
(18082, NULL, 'G3DSA:3.40.50.150:FF:001541', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18083, NULL, 'G3DSA:3.90.1070.20:FF:000006', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(18084, NULL, 'G3DSA:3.40.50.300:FF:004149', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18085, NULL, 'G3DSA:1.10.287.70:FF:000394', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18086, NULL, 'G3DSA:1.10.418.10:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18087, NULL, 'G3DSA:3.30.70.330:FF:000016', NULL, NULL, 'CUGBP Elav-like family member 1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(18088, NULL, 'G3DSA:3.40.190.10:FF:000098', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(18089, NULL, 'G3DSA:3.40.50.150:FF:000613', NULL, NULL, 'L-isoaspartate O-methyltransferase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(18090, NULL, 'G3DSA:3.40.50.300:FF:004334', NULL, NULL, 'Iron(III) ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(18091, NULL, 'G3DSA:3.40.50.720:FF:002302', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(18092, NULL, 'G3DSA:3.60.21.50:FF:000011', NULL, NULL, 'DNA polymerase delta subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(18093, NULL, 'G3DSA:2.60.120.290:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18094, NULL, 'G3DSA:3.40.640.10:FF:000352', NULL, NULL, 'DegT/DnrJ/EryC1/StrS aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(18095, NULL, 'G3DSA:1.20.1720.10:FF:000111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18096, NULL, 'G3DSA:3.20.20.190:FF:000039', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(18097, NULL, 'G3DSA:1.10.510.10:FF:000929', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(18098, NULL, 'G3DSA:1.10.472.10:FF:000003', NULL, NULL, 'G1/S-specific cyclin-D2', NULL, NULL, NULL, NULL, NULL, 4),
(18099, NULL, 'G3DSA:2.130.10.10:FF:000372', NULL, NULL, 'Peroxisomal biogenesis factor 7', NULL, NULL, NULL, NULL, NULL, 4),
(18100, NULL, 'G3DSA:1.10.150.510:FF:000004', NULL, NULL, 'Receptor activity modifying protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(18101, NULL, 'G3DSA:2.10.25.10:FF:001783', NULL, NULL, 'Matrilin 3a', NULL, NULL, NULL, NULL, NULL, 4),
(18102, NULL, 'G3DSA:1.20.210.10:FF:000011', NULL, NULL, 'Cytochrome c oxidase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(18103, NULL, 'G3DSA:3.40.50.300:FF:000591', NULL, NULL, 'Cystic fibrosis transmembrane conductance regulator', NULL, NULL, NULL, NULL, NULL, 4),
(18104, NULL, 'G3DSA:3.80.10.10:FF:001361', NULL, NULL, '2mit, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(18105, NULL, 'G3DSA:1.20.1070.10:FF:000201', NULL, NULL, 'Bradykinin receptor B2', NULL, NULL, NULL, NULL, NULL, 4),
(18106, NULL, 'G3DSA:3.10.110.10:FF:000127', NULL, NULL, 'Component of the ESCRT-I complex', NULL, NULL, NULL, NULL, NULL, 4),
(18107, NULL, 'G3DSA:1.10.3210.10:FF:000035', NULL, NULL, 'HD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(18108, NULL, 'G3DSA:3.30.160.60:FF:004856', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18109, NULL, 'G3DSA:3.30.70.100:FF:000149', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18110, NULL, 'G3DSA:3.30.160.150:FF:000004', NULL, NULL, 'LPS-assembly lipoprotein LptE', NULL, NULL, NULL, NULL, NULL, 4),
(18111, NULL, 'G3DSA:1.10.8.50:FF:000025', NULL, NULL, '30S ribosomal protein S13', NULL, NULL, NULL, NULL, NULL, 4),
(18112, NULL, 'G3DSA:3.40.50.300:FF:004857', NULL, NULL, 'YALI0D23881p', NULL, NULL, NULL, NULL, NULL, 4),
(18113, NULL, 'G3DSA:2.130.10.10:FF:005604', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(18114, NULL, 'G3DSA:1.10.4080.10:FF:000002', NULL, NULL, 'ADP-ribosylarginine hydrolase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(18115, NULL, 'G3DSA:3.30.200.20:FF:002533', NULL, NULL, 'Os12g0149700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(18116, NULL, 'G3DSA:3.40.50.2300:FF:000083', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(18117, NULL, 'G3DSA:1.20.1080.10:FF:000027', NULL, NULL, 'MIP aquaporin', NULL, NULL, NULL, NULL, NULL, 4),
(18118, NULL, 'G3DSA:1.20.900.10:FF:000042', NULL, NULL, 'uncharacterized protein LOC108093793 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(18119, NULL, 'G3DSA:3.30.70.330:FF:001000', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(18120, NULL, 'G3DSA:1.25.40.180:FF:000130', NULL, NULL, 'Eukaryotic translation initiation factor', NULL, NULL, NULL, NULL, NULL, 4),
(18121, NULL, 'G3DSA:1.20.5.110:FF:000158', NULL, NULL, 'Syntaxin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18122, NULL, 'G3DSA:3.40.50.2300:FF:000459', NULL, NULL, 'Probable two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(18123, NULL, 'G3DSA:3.30.60.60:FF:000010', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(18124, NULL, 'G3DSA:2.60.40.10:FF:004643', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18125, NULL, 'G3DSA:3.90.70.80:FF:000031', NULL, NULL, 'OTU family cysteine protease', NULL, NULL, NULL, NULL, NULL, 4),
(18126, NULL, 'G3DSA:3.90.640.80:FF:000007', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(18127, NULL, 'G3DSA:3.10.310.50:FF:000003', NULL, NULL, 'UPF0603 protein At1g54780, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(18128, NULL, 'G3DSA:1.20.120.420:FF:000014', NULL, NULL, 'Methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(18129, NULL, 'G3DSA:3.40.350.10:FF:000009', NULL, NULL, 'Xaa-Pro aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(18130, NULL, 'G3DSA:2.130.10.10:FF:001333', NULL, NULL, 'Vacuolar sorting protein', NULL, NULL, NULL, NULL, NULL, 4),
(18131, NULL, 'G3DSA:1.25.40.10:FF:001596', NULL, NULL, 'Mitochondrial RNA binding complex 1 subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18132, NULL, 'G3DSA:2.30.30.140:FF:000039', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(18133, NULL, 'G3DSA:1.10.287.730:FF:000002', NULL, NULL, 'Fmu (Sun) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(18134, NULL, 'G3DSA:2.130.10.10:FF:003659', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18135, NULL, 'G3DSA:3.30.40.10:FF:002219', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18136, NULL, 'G3DSA:3.80.10.10:FF:001737', NULL, NULL, 'SNRPA1 isoform 9', NULL, NULL, NULL, NULL, NULL, 4),
(18137, NULL, 'G3DSA:3.50.50.60:FF:000519', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(18138, NULL, 'G3DSA:1.20.920.40:FF:000001', NULL, NULL, 'RNA-induced transcriptional silencing complex protein tas3', NULL, NULL, NULL, NULL, NULL, 4),
(18139, NULL, 'G3DSA:1.10.238.10:FF:000268', NULL, NULL, 'Centrin 2', NULL, NULL, NULL, NULL, NULL, 4),
(18140, NULL, 'G3DSA:1.10.1050.10:FF:000005', NULL, NULL, '30S ribosomal protein S4', NULL, NULL, NULL, NULL, NULL, 4),
(18141, NULL, 'G3DSA:1.10.150.240:FF:000103', NULL, NULL, 'Phosphoglycolate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(18142, NULL, 'G3DSA:1.20.1250.20:FF:001084', NULL, NULL, 'Uncharacterized MFS-type transporter C330.07c', NULL, NULL, NULL, NULL, NULL, 4),
(18143, NULL, 'G3DSA:3.40.50.150:FF:000580', NULL, NULL, 'Class I SAM-dependent methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(18144, NULL, 'G3DSA:1.25.10.10:FF:000464', NULL, NULL, 'TORTIFOLIA1-like protein 3 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(18145, NULL, 'G3DSA:1.25.10.10:FF:000279', NULL, NULL, 'Importin beta, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18146, NULL, 'G3DSA:2.130.10.10:FF:000933', NULL, NULL, 'Vacuolar protein sorting-associated protein 41', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(18147, NULL, 'G3DSA:3.30.200.20:FF:000588', NULL, NULL, 'CTD kinase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(18148, NULL, 'G3DSA:3.40.50.1820:FF:001675', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18149, NULL, 'G3DSA:3.10.110.10:FF:000274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18150, NULL, 'G3DSA:1.20.870.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18151, NULL, 'G3DSA:3.40.50.300:FF:000439', NULL, NULL, 'ATP-dependent RNA helicase HrpA', NULL, NULL, NULL, NULL, NULL, 4),
(18152, NULL, 'G3DSA:3.80.10.10:FF:002137', NULL, NULL, 'Leucine-rich repeat-containing 51', NULL, NULL, NULL, NULL, NULL, 4),
(18153, NULL, 'G3DSA:3.90.550.10:FF:000417', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18154, NULL, 'G3DSA:3.90.740.10:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18155, NULL, 'G3DSA:3.30.160.60:FF:000438', NULL, NULL, 'Zinc finger transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(18156, NULL, 'G3DSA:3.40.50.12280:FF:000001', NULL, NULL, 'NADH-quinone oxidoreductase subunit B 2', NULL, NULL, NULL, NULL, NULL, 4),
(18157, NULL, 'G3DSA:3.20.20.300:FF:000033', NULL, NULL, 'Beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(18158, NULL, 'G3DSA:2.130.10.10:FF:004059', NULL, NULL, 'Semaphorin 4A', NULL, NULL, NULL, NULL, NULL, 4),
(18159, NULL, 'G3DSA:3.40.50.1010:FF:000089', NULL, NULL, 'exosome complex exonuclease RRP44 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(18160, NULL, 'G3DSA:1.25.40.10:FF:000409', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(18161, NULL, 'G3DSA:3.30.70.330:FF:002545', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18162, NULL, 'G3DSA:3.40.50.1000:FF:000148', NULL, NULL, 'Haloacid dehalogenase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(18163, NULL, 'G3DSA:4.10.400.10:FF:000275', NULL, NULL, 'GM17661', NULL, NULL, NULL, NULL, NULL, 4),
(18164, NULL, 'G3DSA:1.20.1250.20:FF:001645', NULL, NULL, 'Transporter, MFS family protein', NULL, NULL, NULL, NULL, NULL, 4),
(18165, NULL, 'G3DSA:3.30.70.330:FF:001505', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18166, NULL, 'G3DSA:2.130.10.10:FF:004907', NULL, NULL, 'Protein HIRA', NULL, NULL, NULL, NULL, NULL, 4),
(18167, NULL, 'G3DSA:2.30.29.30:FF:000936', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18168, NULL, 'G3DSA:2.40.30.170:FF:000006', NULL, NULL, 'Multidrug resistance protein MdtA', NULL, NULL, NULL, NULL, NULL, 4),
(18169, NULL, 'G3DSA:3.30.160.60:FF:001074', NULL, NULL, 'zinc finger protein 317', NULL, NULL, NULL, NULL, NULL, 4),
(18170, NULL, 'G3DSA:2.60.40.10:FF:005340', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18171, NULL, 'G3DSA:1.10.600.10:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18172, NULL, 'G3DSA:3.30.70.100:FF:000144', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18173, NULL, 'G3DSA:3.30.300.180:FF:000018', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(18174, NULL, 'G3DSA:1.10.10.60:FF:000714', NULL, NULL, 'Sigma-54 dependent transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(18175, NULL, 'G3DSA:1.10.150.20:FF:000039', NULL, NULL, 'Polymerase (DNA directed) kappa', NULL, NULL, NULL, NULL, NULL, 4),
(18176, NULL, 'G3DSA:2.70.98.10:FF:000088', NULL, NULL, 'Aldose 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(18177, NULL, 'G3DSA:3.40.50.720:FF:001577', NULL, NULL, 'Short-chain dehydrogenase/reductase family member NovK', NULL, NULL, NULL, NULL, NULL, 4),
(18178, NULL, 'G3DSA:2.30.30.230:FF:000010', NULL, NULL, 'Fumarylacetoacetase', NULL, NULL, NULL, NULL, NULL, 4),
(18179, NULL, 'G3DSA:3.40.50.300:FF:002625', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(18180, NULL, 'G3DSA:3.20.20.80:FF:000008', NULL, NULL, 'Glucan endo-1,3-beta-glucosidase 5', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(18181, NULL, 'G3DSA:1.25.40.660:FF:000004', NULL, NULL, 'Vacuolar protein sorting-associated protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(18182, NULL, 'G3DSA:1.25.40.10:FF:000848', NULL, NULL, 'transmembrane and TPR repeat-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(18183, NULL, 'G3DSA:1.20.272.10:FF:000025', NULL, NULL, 'DNA polymerase III subunit gamma/tau', NULL, NULL, NULL, NULL, NULL, 4),
(18184, NULL, 'G3DSA:3.40.47.10:FF:000110', NULL, NULL, 'Fatty acid synthase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(18185, NULL, 'G3DSA:1.10.640.10:FF:000057', NULL, NULL, 'Oxidase/peroxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18186, NULL, 'G3DSA:3.40.50.300:FF:006858', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(18187, NULL, 'G3DSA:3.90.1290.10:FF:000076', NULL, NULL, 'Microtubule-actin crosslinking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(18188, NULL, 'G3DSA:1.20.810.10:FF:000012', NULL, NULL, 'Cytochrome b/b6 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(18189, NULL, 'G3DSA:3.40.190.290:FF:000027', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(18190, NULL, 'G3DSA:3.30.200.20:FF:000801', NULL, NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At2g02780', NULL, NULL, NULL, NULL, NULL, 4),
(18191, NULL, 'G3DSA:1.10.560.10:FF:000056', NULL, NULL, 'T-complex protein 1 beta subunit putative', NULL, NULL, NULL, NULL, NULL, 4),
(18192, NULL, 'G3DSA:1.10.580.10:FF:000018', NULL, NULL, 'Citrate synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(18193, NULL, 'G3DSA:2.60.40.10:FF:000068', NULL, NULL, 'receptor-type tyrosine-protein phosphatase delta isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(18194, NULL, 'G3DSA:3.40.50.1390:FF:000006', NULL, NULL, 'Resolvase family site-specific recombinase', NULL, NULL, NULL, NULL, NULL, 4),
(18195, NULL, 'G3DSA:3.30.540.10:FF:000009', NULL, NULL, 'Fructose-1,6-bisphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(18196, NULL, 'G3DSA:2.60.40.4100:FF:000006', NULL, NULL, 'beta-tectorin', NULL, NULL, NULL, NULL, NULL, 4),
(18197, NULL, 'G3DSA:2.60.120.680:FF:000014', NULL, NULL, 'CRE-CGR-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(18198, NULL, 'G3DSA:3.30.230.10:FF:000300', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18199, NULL, 'G3DSA:3.30.300.130:FF:000015', NULL, NULL, 'NifU-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18200, NULL, 'G3DSA:1.10.510.10:FF:000396', NULL, NULL, 'Serine/threonine-protein kinase 16', NULL, NULL, NULL, NULL, NULL, 4),
(18201, NULL, 'G3DSA:3.90.226.10:FF:000058', NULL, NULL, 'Enoyl-CoA hydratase/isomerase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(18202, NULL, 'G3DSA:3.30.160.60:FF:000517', NULL, NULL, 'Zinc finger protein 24 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(18203, NULL, 'G3DSA:3.30.160.60:FF:004851', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18204, NULL, 'G3DSA:1.10.472.170:FF:000020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18205, NULL, 'G3DSA:1.20.1280.20:FF:000012', NULL, NULL, 'GM25599', NULL, NULL, NULL, NULL, NULL, 4),
(18206, NULL, 'G3DSA:3.30.460.10:FF:000008', NULL, NULL, 'Ribosomal silencing factor RsfS', NULL, NULL, NULL, NULL, NULL, 4),
(18207, NULL, 'G3DSA:3.60.110.10:FF:000105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18208, NULL, 'G3DSA:3.40.1410.10:FF:000008', NULL, NULL, 'Transcriptional regulator, GntR family', NULL, NULL, NULL, NULL, NULL, 4),
(18209, NULL, 'G3DSA:1.25.40.20:FF:000789', NULL, NULL, 'Protein 21.1', NULL, NULL, NULL, NULL, NULL, 4),
(18210, NULL, 'G3DSA:3.40.1050.10:FF:000025', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(18211, NULL, 'G3DSA:3.80.10.10:FF:000012', NULL, NULL, 'Leucine rich repeat containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(18212, NULL, 'G3DSA:2.170.270.10:FF:000150', NULL, NULL, 'PR/SET domain 13', NULL, NULL, NULL, NULL, NULL, 4),
(18213, NULL, 'G3DSA:2.10.25.10:FF:001423', NULL, NULL, 'Cdh-4', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(18214, NULL, 'G3DSA:2.10.25.10:FF:000855', NULL, NULL, 'delta-like protein C', NULL, NULL, NULL, NULL, NULL, 4),
(18215, NULL, 'G3DSA:2.130.10.10:FF:002119', NULL, NULL, 'Serine/threonine-protein kinase/endoribonuclease ire-1', NULL, NULL, NULL, NULL, NULL, 4),
(18216, NULL, 'G3DSA:3.30.70.330:FF:001556', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18217, NULL, 'G3DSA:1.20.1070.10:FF:000460', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18218, NULL, 'G3DSA:3.100.10.10:FF:000026', NULL, NULL, '60S ribosomal protein L18', NULL, NULL, NULL, NULL, NULL, 4),
(18219, NULL, 'G3DSA:1.20.58.60:FF:000083', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(18220, NULL, 'G3DSA:3.30.200.20:FF:000060', NULL, NULL, 'Serine/threonine-protein kinase isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(18221, NULL, 'G3DSA:3.90.190.10:FF:000401', NULL, NULL, 'Cell division cycle 14A', NULL, NULL, NULL, NULL, NULL, 4),
(18222, NULL, 'G3DSA:3.40.50.2000:FF:001128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18223, NULL, 'G3DSA:3.10.110.10:FF:000122', NULL, NULL, 'Ubiquitin-fold modifier-conjugating enzyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(18224, NULL, 'G3DSA:1.25.40.10:FF:002877', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18225, NULL, 'G3DSA:3.40.850.10:FF:000446', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18226, NULL, 'G3DSA:1.10.1600.10:FF:000031', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18227, NULL, 'G3DSA:1.20.1060.20:FF:000001', NULL, NULL, 'Structural maintenance of chromosomes 1A', NULL, NULL, NULL, NULL, NULL, 4),
(18228, NULL, 'G3DSA:3.40.50.300:FF:006419', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18229, NULL, 'G3DSA:2.160.20.10:FF:000186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18230, NULL, 'G3DSA:2.30.29.30:FF:000987', NULL, NULL, 'YALI0C14828p', NULL, NULL, NULL, NULL, NULL, 4),
(18231, NULL, 'G3DSA:3.40.50.10800:FF:000001', NULL, NULL, 'Quinolinate synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(18232, NULL, 'G3DSA:3.30.40.10:FF:001270', NULL, NULL, 'AGAP006402-PA', NULL, NULL, NULL, NULL, NULL, 4),
(18233, NULL, 'G3DSA:2.60.40.60:FF:000622', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18234, NULL, 'G3DSA:3.30.160.60:FF:005840', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18235, NULL, 'G3DSA:3.30.70.270:FF:000116', NULL, NULL, 'Sensory box/GGDEF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(18236, NULL, 'G3DSA:3.60.20.30:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18237, NULL, 'G3DSA:2.40.10.10:FF:000590', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18238, NULL, 'G3DSA:3.50.50.60:FF:000351', NULL, NULL, 'Glutamate synthase, small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(18239, NULL, 'G3DSA:2.10.25.10:FF:000063', NULL, NULL, 'Slit guidance ligand 2', NULL, NULL, NULL, NULL, NULL, 4),
(18240, NULL, 'G3DSA:3.30.559.10:FF:000215', NULL, NULL, 'Non-ribosomal peptide synthetase OfaA', NULL, NULL, NULL, NULL, NULL, 4),
(18241, NULL, 'G3DSA:3.40.605.10:FF:000130', NULL, NULL, 'Delta-1-pyrroline-5-carboxylate synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(18242, NULL, 'G3DSA:1.25.40.20:FF:000738', NULL, NULL, 'Transient receptor potential cation channel subfamily A member 1', NULL, NULL, NULL, NULL, NULL, 4),
(18243, NULL, 'G3DSA:1.10.8.60:FF:000562', NULL, NULL, 'CDC48/VCP homolog, AAA superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(18244, NULL, 'G3DSA:2.130.10.10:FF:000725', NULL, NULL, 'Nuclear pore complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(18245, NULL, 'G3DSA:2.40.10.350:FF:000006', NULL, NULL, 'Rod shape-determining protein MreC', NULL, NULL, NULL, NULL, NULL, 4),
(18246, NULL, 'G3DSA:3.60.10.10:FF:000182', NULL, NULL, 'DNA-(Apurinic or apyrimidinic site) lyase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(18247, NULL, 'G3DSA:3.40.50.150:FF:000372', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(18248, NULL, 'G3DSA:1.25.10.10:FF:000380', NULL, NULL, 'DNA-dependent protein kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(18249, NULL, 'G3DSA:1.20.910.10:FF:000008', NULL, NULL, 'Heme oxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(18250, NULL, 'G3DSA:3.30.1640.10:FF:000095', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(18251, NULL, 'G3DSA:3.20.20.60:FF:000053', NULL, NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(18252, NULL, 'G3DSA:3.40.50.2300:FF:000611', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18253, NULL, 'G3DSA:3.80.10.10:FF:002249', NULL, NULL, 'F-box/LRR-repeat protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(18254, NULL, 'G3DSA:1.20.1070.10:FF:001870', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18255, NULL, 'G3DSA:3.30.160.60:FF:004800', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18256, NULL, 'G3DSA:3.30.200.20:FF:001257', NULL, NULL, 'AGAP002515-PA', NULL, NULL, NULL, NULL, NULL, 4),
(18257, NULL, 'G3DSA:3.20.20.70:FF:000735', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18258, NULL, 'G3DSA:3.80.10.10:FF:003677', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18259, NULL, 'G3DSA:1.10.10.10:FF:000109', NULL, NULL, 'DNA-binding transcriptional regulator KdgR', NULL, NULL, NULL, NULL, NULL, 4),
(18260, NULL, 'G3DSA:3.60.21.10:FF:000319', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(18261, NULL, 'G3DSA:1.10.472.10:FF:000470', NULL, NULL, 'Transcription initiation factor IIB 1', NULL, NULL, NULL, NULL, NULL, 4),
(18262, NULL, 'G3DSA:2.60.40.10:FF:000017', NULL, NULL, 'Down syndrome cell adhesion molecule b', NULL, NULL, NULL, NULL, NULL, 4),
(18263, NULL, 'G3DSA:3.30.160.60:FF:001978', NULL, NULL, 'Zinc finger protein 619', NULL, NULL, NULL, NULL, NULL, 4),
(18264, NULL, 'G3DSA:3.40.50.300:FF:006807', NULL, NULL, 'Minichromosome maintenance 8 homologous recombination repair factor', NULL, NULL, NULL, NULL, NULL, 4),
(18265, NULL, 'G3DSA:2.40.70.10:FF:000059', NULL, NULL, 'Napsin A aspartic peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(18266, NULL, 'G3DSA:3.40.1380.20:FF:000047', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(18267, NULL, 'G3DSA:3.40.50.1820:FF:001754', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18268, NULL, 'G3DSA:1.10.486.10:FF:000001', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(18269, NULL, 'G3DSA:3.90.15.10:FF:000006', NULL, NULL, 'Topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(18270, NULL, 'G3DSA:2.60.450.20:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18271, NULL, 'G3DSA:3.40.50.300:FF:005610', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(18272, NULL, 'G3DSA:3.40.50.1980:FF:000121', NULL, NULL, 'Iron(III) ABC transporter, solute-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(18273, NULL, 'G3DSA:3.30.230.10:FF:000351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18274, NULL, 'G3DSA:2.40.50.140:FF:001098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18275, NULL, 'G3DSA:1.10.630.10:FF:000343', NULL, NULL, 'Benzoate 4-monooxygenase cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(18276, NULL, 'G3DSA:1.50.40.10:FF:000368', NULL, NULL, 'Carnitine/acylcarnitine translocase', NULL, NULL, NULL, NULL, NULL, 4),
(18277, NULL, 'G3DSA:3.40.190.290:FF:000078', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(18278, NULL, 'G3DSA:3.30.200.20:FF:000852', NULL, NULL, 'Os01g0927500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(18279, NULL, 'G3DSA:3.80.10.10:FF:003626', NULL, NULL, 'Follicle-stimulating hormone receptor', NULL, NULL, NULL, NULL, NULL, 4),
(18280, NULL, 'G3DSA:1.10.510.10:FF:001352', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(18281, NULL, 'G3DSA:1.25.40.40:FF:000003', NULL, NULL, 'Cytochrome c oxidase subunit 5A, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(18282, NULL, 'G3DSA:1.20.1070.10:FF:001769', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18283, NULL, 'G3DSA:3.20.20.70:FF:000331', NULL, NULL, 'Dihydroorotate dehydrogenase (quinone)', NULL, NULL, NULL, NULL, NULL, 4),
(18284, NULL, 'G3DSA:3.30.70.330:FF:000196', NULL, NULL, 'Poly(A)-specific ribonuclease PARN', NULL, NULL, NULL, NULL, NULL, 4),
(18285, NULL, 'G3DSA:3.30.160.60:FF:003491', NULL, NULL, 'Zinc finger protein 672', NULL, NULL, NULL, NULL, NULL, 4),
(18286, NULL, 'G3DSA:1.10.287.390:FF:000001', NULL, NULL, 'CesT family type III secretion system chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(18287, NULL, 'G3DSA:3.40.50.300:FF:006066', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18288, NULL, 'G3DSA:3.30.800.10:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18289, NULL, 'G3DSA:1.10.287.110:FF:000237', NULL, NULL, 'DnaJ domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18290, NULL, 'G3DSA:3.40.390.10:FF:000315', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18291, NULL, 'G3DSA:1.10.260.170:FF:000005', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', NULL, NULL, NULL, NULL, NULL, 4),
(18292, NULL, 'G3DSA:3.80.10.10:FF:000804', NULL, NULL, 'Receptor-like protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(18293, NULL, 'G3DSA:2.30.30.40:FF:000538', NULL, NULL, 'SH3 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(18294, NULL, 'G3DSA:3.10.129.10:FF:000209', NULL, NULL, 'Blr5584 protein', NULL, NULL, NULL, NULL, NULL, 4),
(18295, NULL, 'G3DSA:3.40.50.300:FF:001283', NULL, NULL, 'Eukaryotic translation elongation factor 1 alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(18296, NULL, 'G3DSA:2.40.50.140:FF:000642', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18297, NULL, 'G3DSA:3.20.20.70:FF:000382', NULL, NULL, 'Thiazole tautomerase', NULL, NULL, NULL, NULL, NULL, 4),
(18298, NULL, 'G3DSA:2.30.30.1190:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18299, NULL, 'G3DSA:3.70.10.10:FF:000041', NULL, NULL, 'DNA repair protein rad9', NULL, NULL, NULL, NULL, NULL, 4),
(18300, NULL, 'G3DSA:2.40.50.140:FF:000530', NULL, NULL, 'RNA guanylyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18301, NULL, 'G3DSA:3.40.50.2300:FF:001179', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18302, NULL, 'G3DSA:3.40.30.10:FF:000307', NULL, NULL, 'Thioredoxin-like protein 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18303, NULL, 'G3DSA:1.25.10.10:FF:002145', NULL, NULL, 'Condensin complex subunit capg-1', NULL, NULL, NULL, NULL, NULL, 4),
(18304, NULL, 'G3DSA:3.30.40.10:FF:001674', NULL, NULL, 'TNF receptor-associated factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(18305, NULL, 'G3DSA:3.30.450.40:FF:000207', NULL, NULL, 'Stage II sporulation E family protein', NULL, NULL, NULL, NULL, NULL, 4),
(18306, NULL, 'G3DSA:1.25.10.10:FF:002257', NULL, NULL, 'HEAT repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(18307, NULL, 'G3DSA:2.60.120.260:FF:000563', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18308, NULL, 'G3DSA:3.10.100.10:FF:000296', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18309, NULL, 'G3DSA:2.10.10.10:FF:000001', NULL, NULL, 'Fibronectin 1a isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(18310, NULL, 'G3DSA:3.40.50.2000:FF:000139', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(18311, NULL, 'G3DSA:3.40.50.300:FF:002204', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(18312, NULL, 'G3DSA:2.60.120.970:FF:000096', NULL, NULL, 'Dauer larva development regulatory growth factor daf-7', NULL, NULL, NULL, NULL, NULL, 4),
(18313, NULL, 'G3DSA:3.40.33.10:FF:000140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18314, NULL, 'G3DSA:2.60.40.10:FF:003002', NULL, NULL, 'Vasorin a', NULL, NULL, NULL, NULL, NULL, 4),
(18315, NULL, 'G3DSA:2.40.50.90:FF:000161', NULL, NULL, 'Chromosome 3 open reading frame 33', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(18316, NULL, 'G3DSA:2.30.29.240:FF:000011', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(18317, NULL, 'G3DSA:4.10.280.10:FF:000186', NULL, NULL, 'Transcriptional regulator of yeast form adherence 6', NULL, NULL, NULL, NULL, NULL, 4),
(18318, NULL, 'G3DSA:1.20.1070.10:FF:001718', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18319, NULL, 'G3DSA:1.25.10.10:FF:002196', NULL, NULL, 'Uncharacterized protein C1105.01', NULL, NULL, NULL, NULL, NULL, 4),
(18320, NULL, 'G3DSA:1.20.1440.150:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18321, NULL, 'G3DSA:3.30.70.1230:FF:000017', NULL, NULL, 'Adenylate cyclase type 10', NULL, NULL, NULL, NULL, NULL, 4),
(18322, NULL, 'G3DSA:3.40.850.10:FF:000334', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(18323, NULL, 'G3DSA:3.90.70.10:FF:000139', NULL, NULL, 'Dipeptidyl aminopeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(18324, NULL, 'G3DSA:1.20.1510.10:FF:000005', NULL, NULL, 'Putative Cation diffusion facilitator 1', NULL, NULL, NULL, NULL, NULL, 4),
(18325, NULL, 'G3DSA:2.10.25.10:FF:000967', NULL, NULL, 'Netrin G2', NULL, NULL, NULL, NULL, NULL, 4),
(18326, NULL, 'G3DSA:1.10.510.10:FF:004499', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18327, NULL, 'G3DSA:2.60.120.260:FF:000624', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18328, NULL, 'G3DSA:1.10.10.10:FF:002077', NULL, NULL, 'EAP30 subunit of ELL complex, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18329, NULL, 'G3DSA:2.130.10.10:FF:004536', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18330, NULL, 'G3DSA:3.40.50.2300:FF:000662', NULL, NULL, 'Sensor histidine kinase, PAS domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(18331, NULL, 'G3DSA:2.40.70.10:FF:000008', NULL, NULL, 'Cathepsin D', NULL, NULL, NULL, NULL, NULL, 4),
(18332, NULL, 'G3DSA:3.40.30.10:FF:000728', NULL, NULL, 'Thioredoxin-dependent peroxide reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18333, NULL, 'G3DSA:3.40.50.1220:FF:000034', NULL, NULL, 'NAD-dependent histone deacetylase HST3', NULL, NULL, NULL, NULL, NULL, 4),
(18334, NULL, 'G3DSA:3.40.50.1000:FF:000199', NULL, NULL, 'Nuclear envelope morphology', NULL, NULL, NULL, NULL, NULL, 4),
(18335, NULL, 'G3DSA:3.40.50.150:FF:000321', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(18336, NULL, 'G3DSA:3.80.10.10:FF:004115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18337, NULL, 'G3DSA:3.40.50.1980:FF:000088', NULL, NULL, 'Uncharacterized ABC transporter substrate-binding lipoprotein YvrC', NULL, NULL, NULL, NULL, NULL, 4),
(18338, NULL, 'G3DSA:2.60.420.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18339, NULL, 'G3DSA:1.25.10.10:FF:002206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18340, NULL, 'G3DSA:3.10.100.10:FF:000245', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18341, NULL, 'G3DSA:3.40.50.1820:FF:001703', NULL, NULL, '1H-3-hydroxy-4-oxoquinoline 2,4-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(18342, NULL, 'G3DSA:3.30.428.10:FF:000012', NULL, NULL, 'HIT domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(18343, NULL, 'G3DSA:1.50.10.20:FF:000044', NULL, NULL, 'Lupeol synthase', NULL, NULL, NULL, NULL, NULL, 4),
(18344, NULL, 'G3DSA:1.20.1740.10:FF:000202', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18345, NULL, 'G3DSA:3.30.50.10:FF:000039', NULL, NULL, 'Siderophore transcription factor SreA', NULL, NULL, NULL, NULL, NULL, 4),
(18346, NULL, 'G3DSA:3.40.50.1820:FF:000798', NULL, NULL, 'Prolyl oligopeptidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(18347, NULL, 'G3DSA:1.10.510.10:FF:002262', NULL, NULL, 'Mitosis inhibitor protein kinase mik1', NULL, NULL, NULL, NULL, NULL, 4),
(18348, NULL, 'G3DSA:1.20.1070.10:FF:000021', NULL, NULL, 'Corticotropin releasing factor receptor 2', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(18349, NULL, 'G3DSA:1.10.8.10:FF:000120', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(18350, NULL, 'G3DSA:3.30.310.80:FF:000041', NULL, NULL, 'Serine/threonine-protein kinase Chk1', NULL, NULL, NULL, NULL, NULL, 4),
(18351, NULL, 'G3DSA:1.10.418.10:FF:000209', NULL, NULL, 'EB1-like C-terminal motif containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18352, NULL, 'G3DSA:3.40.50.2300:FF:000723', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18353, NULL, 'G3DSA:2.30.29.30:FF:000195', NULL, NULL, 'Unconventional myosin-X', NULL, NULL, NULL, NULL, NULL, 4),
(18354, NULL, 'G3DSA:3.40.50.720:FF:001138', NULL, NULL, 'Ubiquitin-activating enzyme E1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18355, NULL, 'G3DSA:2.160.10.10:FF:000050', NULL, NULL, 'eIF2B-gamma protein', NULL, NULL, NULL, NULL, NULL, 4),
(18356, NULL, 'G3DSA:3.30.40.10:FF:000213', NULL, NULL, 'Breast cancer type 1 susceptibility protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(18357, NULL, 'G3DSA:3.10.129.10:FF:000148', NULL, NULL, 'Thioesterase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(18358, NULL, 'G3DSA:1.20.1050.40:FF:000001', NULL, NULL, 'Thimet oligopeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(18359, NULL, 'G3DSA:2.60.40.60:FF:001027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18360, NULL, 'G3DSA:3.30.470.20:FF:000170', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18361, NULL, 'G3DSA:2.60.40.10:FF:004351', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18362, NULL, 'G3DSA:2.40.50.140:FF:000581', NULL, NULL, 'Ribosomal protein L8', NULL, NULL, NULL, NULL, NULL, 4),
(18363, NULL, 'G3DSA:2.60.34.10:FF:000076', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18364, NULL, 'G3DSA:1.10.1420.10:FF:000045', NULL, NULL, 'DNA mismatch repair protein Msh6', NULL, NULL, NULL, NULL, NULL, 4),
(18365, NULL, 'G3DSA:3.30.200.20:FF:001369', NULL, NULL, 'Membrane-associated tyrosine- and threonine-specific cdc2-inhibitory kinase wee-1.3', NULL, NULL, NULL, NULL, NULL, 4),
(18366, NULL, 'G3DSA:1.10.268.10:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18367, NULL, 'G3DSA:3.30.160.60:FF:001866', NULL, NULL, 'Zinc finger protein 628', NULL, NULL, NULL, NULL, NULL, 4),
(18368, NULL, 'G3DSA:3.40.50.1110:FF:000001', NULL, NULL, 'Multifunctional acyl-CoA thioesterase I', NULL, NULL, NULL, NULL, NULL, 4),
(18369, NULL, 'G3DSA:2.160.20.10:FF:000135', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(18370, NULL, 'G3DSA:3.30.420.40:FF:000610', NULL, NULL, 'Glucokinase regulator family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18371, NULL, 'G3DSA:2.60.40.1910:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18372, NULL, 'G3DSA:3.40.630.10:FF:000435', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18373, NULL, 'G3DSA:1.10.10.750:FF:000024', NULL, NULL, 'TBC1 domain family member 12', NULL, NULL, NULL, NULL, NULL, 4),
(18374, NULL, 'G3DSA:1.10.10.60:FF:001119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18375, NULL, 'G3DSA:2.10.109.10:FF:000072', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(18376, NULL, 'G3DSA:3.40.50.12620:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18377, NULL, 'G3DSA:1.10.510.10:FF:003622', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18378, NULL, 'G3DSA:3.30.428.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18379, NULL, 'G3DSA:2.60.120.10:FF:000469', NULL, NULL, 'Mannose-6-phosphate isomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(18380, NULL, 'G3DSA:3.40.47.10:FF:000031', NULL, NULL, 'Sterigmatocystin biosynthesis polyketide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(18381, NULL, 'G3DSA:3.20.20.80:FF:000660', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18382, NULL, 'G3DSA:1.25.10.10:FF:002645', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(18383, NULL, 'G3DSA:3.30.70.330:FF:003001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18384, NULL, 'G3DSA:1.10.1140.10:FF:000012', NULL, NULL, 'V-type proton ATPase catalytic subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(18385, NULL, 'G3DSA:1.10.10.10:FF:000048', NULL, NULL, 'Pyruvate dehydrogenase complex transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(18386, NULL, 'G3DSA:3.40.50.300:FF:005110', NULL, NULL, 'Putative DNA-dependent ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(18387, NULL, 'G3DSA:3.50.50.60:FF:000430', NULL, NULL, 'Farnesylcysteine lyase', NULL, NULL, NULL, NULL, NULL, 4),
(18388, NULL, 'G3DSA:3.40.50.10190:FF:000251', NULL, NULL, 'PIS (Pax-2, IA-1/6, Smad-2 interacting protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(18389, NULL, 'G3DSA:3.30.70.2510:FF:000002', NULL, NULL, 'tRNA pseudouridine(54/55) synthase', NULL, NULL, NULL, NULL, NULL, 4),
(18390, NULL, 'G3DSA:3.40.50.1820:FF:001254', NULL, NULL, 'Lipase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18391, NULL, 'G3DSA:2.60.40.10:FF:000961', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(18392, NULL, 'G3DSA:3.40.50.300:FF:004542', NULL, NULL, 'Deoxycytidylate deaminase-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(18393, NULL, 'G3DSA:3.30.1370.10:FF:000231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18394, NULL, 'G3DSA:3.40.50.150:FF:001310', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18395, NULL, 'G3DSA:1.10.472.80:FF:000119', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(18396, NULL, 'G3DSA:1.10.3720.10:FF:000006', NULL, NULL, 'Glutamate/aspartate ABC transporter, permease protein GltK', NULL, NULL, NULL, NULL, NULL, 4),
(18397, NULL, 'G3DSA:2.60.120.920:FF:000103', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18398, NULL, 'G3DSA:3.30.2350.10:FF:000022', NULL, NULL, 'RNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(18399, NULL, 'G3DSA:1.20.210.10:FF:000034', NULL, NULL, 'Cytochrome c oxidase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(18400, NULL, 'G3DSA:1.20.1440.170:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18401, NULL, 'G3DSA:3.40.50.150:FF:001602', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18402, NULL, 'G3DSA:3.30.2310.10:FF:000008', NULL, NULL, 'Methyltransferase, YaeB family', NULL, NULL, NULL, NULL, NULL, 4),
(18403, NULL, 'G3DSA:2.30.230.10:FF:000006', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(18404, NULL, 'G3DSA:3.40.50.1240:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18405, NULL, 'G3DSA:3.90.190.10:FF:000513', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18406, NULL, 'G3DSA:3.10.50.40:FF:000156', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(18407, NULL, 'G3DSA:2.130.10.10:FF:005104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18408, NULL, 'G3DSA:2.120.10.30:FF:000468', NULL, NULL, 'Uncharacterized protein LRP2', NULL, NULL, NULL, NULL, NULL, 4),
(18409, NULL, 'G3DSA:3.40.850.10:FF:000093', NULL, NULL, 'CENP-meta, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(18410, NULL, 'G3DSA:3.40.50.150:FF:000293', NULL, NULL, 'N-methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(18411, NULL, 'G3DSA:3.30.420.40:FF:001066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18412, NULL, 'G3DSA:3.50.30.30:FF:000032', NULL, NULL, 'Vacuolar-sorting receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(18413, NULL, 'G3DSA:3.40.50.11030:FF:000008', NULL, NULL, 'Sua5/YciO/YrdC/YwlC family protein, variant', NULL, NULL, NULL, NULL, NULL, 4),
(18414, NULL, 'G3DSA:1.25.10.10:FF:000751', NULL, NULL, 'IMportin Beta family', NULL, NULL, NULL, NULL, NULL, 4),
(18415, NULL, 'G3DSA:1.10.472.10:FF:000391', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18416, NULL, 'G3DSA:2.120.10.80:FF:000281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(18417, NULL, 'G3DSA:3.80.10.10:FF:003710', NULL, NULL, 'F-box protein At3g58530', NULL, NULL, NULL, NULL, NULL, 4),
(18418, NULL, 'G3DSA:1.10.630.10:FF:000843', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18419, NULL, 'G3DSA:3.10.450.40:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18420, NULL, 'G3DSA:1.20.120.1750:FF:000015', NULL, NULL, 'E3 ubiquitin-protein ligase RNF31 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(18421, NULL, 'G3DSA:2.20.70.10:FF:000257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18422, NULL, 'G3DSA:2.30.130.10:FF:000010', NULL, NULL, 'Probable tRNA pseudouridine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(18423, NULL, 'G3DSA:1.10.150.900:FF:000003', NULL, NULL, 'N-fatty-acyl-amino acid synthase/hydrolase PM20D1', NULL, NULL, NULL, NULL, NULL, 4),
(18424, NULL, 'G3DSA:1.20.1250.20:FF:001584', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18425, NULL, 'G3DSA:3.40.50.670:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18426, NULL, 'G3DSA:3.10.130.10:FF:000005', NULL, NULL, 'Ribonuclease-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(18427, NULL, 'G3DSA:2.40.10.10:FF:000522', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18428, NULL, 'G3DSA:1.10.730.10:FF:000227', NULL, NULL, 'Methionine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(18429, NULL, 'G3DSA:1.25.40.550:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18430, NULL, 'G3DSA:3.30.1140.60:FF:000004', NULL, NULL, 'F-actin-capping protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(18431, NULL, 'G3DSA:1.10.238.10:FF:000263', NULL, NULL, 'plastin-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(18432, NULL, 'G3DSA:2.60.40.1480:FF:000001', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(18433, NULL, 'G3DSA:1.20.1250.20:FF:001292', NULL, NULL, 'Os01g0960900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(18434, NULL, 'G3DSA:3.20.20.150:FF:000027', NULL, NULL, 'Putative hexulose-6-phosphate isomerase SgbU', NULL, NULL, NULL, NULL, NULL, 4),
(18435, NULL, 'G3DSA:1.10.10.10:FF:000099', NULL, NULL, 'Two-component system response regulator TorR', NULL, NULL, NULL, NULL, NULL, 4),
(18436, NULL, 'G3DSA:2.120.10.80:FF:000230', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18437, NULL, 'G3DSA:2.60.40.10:FF:004851', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18438, NULL, 'G3DSA:3.30.160.60:FF:000017', NULL, NULL, 'zinc finger protein 62 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(18439, NULL, 'G3DSA:3.30.420.40:FF:001015', NULL, NULL, 'Protein CBG13232', NULL, NULL, NULL, NULL, NULL, 4),
(18440, NULL, 'G3DSA:1.20.1070.10:FF:001802', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18441, NULL, 'G3DSA:3.30.9.10:FF:000129', NULL, NULL, 'FAD-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(18442, NULL, 'G3DSA:3.40.720.10:FF:000381', NULL, NULL, 'Phosphopentomutase', NULL, NULL, NULL, NULL, NULL, 4),
(18443, NULL, 'G3DSA:3.10.105.10:FF:000093', NULL, NULL, 'Extracellular solute-binding protein family 5', NULL, NULL, NULL, NULL, NULL, 4),
(18444, NULL, 'G3DSA:3.40.640.10:FF:000380', NULL, NULL, 'Probable glycine dehydrogenase (decarboxylating) subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(18445, NULL, 'G3DSA:3.80.10.10:FF:000400', NULL, NULL, 'Nuclear pore complex protein NUP107', NULL, NULL, NULL, NULL, NULL, 4),
(18446, NULL, 'G3DSA:1.25.10.10:FF:002937', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18447, NULL, 'G3DSA:3.40.50.1980:FF:000037', NULL, NULL, 'Iron ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(18448, NULL, 'G3DSA:3.40.50.1820:FF:000686', NULL, NULL, 'Possible esterase LipW', NULL, NULL, NULL, NULL, NULL, 4),
(18449, NULL, 'G3DSA:1.20.90.10:FF:000007', NULL, NULL, 'Acidic phospholipase A2', NULL, NULL, NULL, NULL, NULL, 4),
(18450, NULL, 'G3DSA:2.130.10.10:FF:003547', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(18451, NULL, 'G3DSA:2.130.10.10:FF:002642', NULL, NULL, 'Semaphorin 3C', NULL, NULL, NULL, NULL, NULL, 4),
(18452, NULL, 'G3DSA:1.10.287.10:FF:000011', NULL, NULL, '30S ribosomal protein S15, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(18453, NULL, 'G3DSA:1.10.472.10:FF:000239', NULL, NULL, 'Cyclin-D6-1', NULL, NULL, NULL, NULL, NULL, 4),
(18454, NULL, 'G3DSA:3.30.1360.120:FF:000073', NULL, NULL, 'Sarcosine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(18455, NULL, 'G3DSA:2.40.10.170:FF:000025', NULL, NULL, 'ATP synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(18456, NULL, 'G3DSA:2.40.50.40:FF:000011', NULL, NULL, 'chromodomain-helicase-DNA-binding protein 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(18457, NULL, 'G3DSA:1.10.10.580:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18458, NULL, 'G3DSA:1.20.1070.10:FF:001269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18459, NULL, 'G3DSA:3.40.50.2300:FF:000223', NULL, NULL, 'Trehalose operon transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(18460, NULL, 'G3DSA:3.70.10.10:FF:000092', NULL, NULL, 'Checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(18461, NULL, 'G3DSA:1.20.58.60:FF:000015', NULL, NULL, 'triple functional domain protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(18462, NULL, 'G3DSA:1.10.1220.10:FF:000013', NULL, NULL, 'Putative antitoxin VapB10', NULL, NULL, NULL, NULL, NULL, 4),
(18463, NULL, 'G3DSA:3.40.1400.10:FF:000002', NULL, NULL, 'Ribose-5-phosphate isomerase B', NULL, NULL, NULL, NULL, NULL, 4),
(18464, NULL, 'G3DSA:3.30.40.10:FF:000713', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 8', NULL, NULL, NULL, NULL, NULL, 4),
(18465, NULL, 'G3DSA:2.130.10.10:FF:004036', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(18466, NULL, 'G3DSA:3.30.160.40:FF:000011', NULL, NULL, 'GD13613', NULL, NULL, NULL, NULL, NULL, 4),
(18467, NULL, 'G3DSA:1.10.287.1490:FF:000045', NULL, NULL, 'LOC557176 protein', NULL, NULL, NULL, NULL, NULL, 4),
(18468, NULL, 'G3DSA:3.30.2350.10:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18469, NULL, 'G3DSA:1.25.10.10:FF:003213', NULL, NULL, 'GTP binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(18470, NULL, 'G3DSA:3.40.1450.10:FF:000005', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18471, NULL, 'G3DSA:1.10.418.50:FF:000002', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(18472, NULL, 'G3DSA:1.20.120.1750:FF:000066', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(18473, NULL, 'G3DSA:2.170.130.10:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18474, NULL, 'G3DSA:3.30.160.60:FF:006245', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18475, NULL, 'G3DSA:3.30.930.10:FF:000421', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(18476, NULL, 'G3DSA:2.60.120.260:FF:000271', NULL, NULL, 'DNA repair protein XRCC1', NULL, NULL, NULL, NULL, NULL, 4),
(18477, NULL, 'G3DSA:1.25.40.10:FF:004794', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18478, NULL, 'G3DSA:1.10.238.10:FF:000212', NULL, NULL, 'Mitochondrial Rho GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(18479, NULL, 'G3DSA:2.60.120.200:FF:000360', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(18480, NULL, 'G3DSA:1.25.10.10:FF:002549', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18481, NULL, 'G3DSA:1.10.630.10:FF:000051', NULL, NULL, 'Cytochrome P450 monooxygenase (Fum15)', NULL, NULL, NULL, NULL, NULL, 4),
(18482, NULL, 'G3DSA:2.20.70.30:FF:000004', NULL, NULL, 'Nascent polypeptide-associated complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(18483, NULL, 'G3DSA:1.20.1310.10:FF:000006', NULL, NULL, 'Cullin 3', NULL, NULL, NULL, NULL, NULL, 4),
(18484, NULL, 'G3DSA:3.40.50.300:FF:005498', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(18485, NULL, 'G3DSA:4.10.710.10:FF:000001', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(18486, NULL, 'G3DSA:2.60.40.10:FF:000809', NULL, NULL, 'Sallimus, isoform Q', NULL, NULL, NULL, NULL, NULL, 4),
(18487, NULL, 'G3DSA:2.60.200.30:FF:000009', NULL, NULL, 'Poly(P)/ATP NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(18488, NULL, 'G3DSA:3.50.4.10:FF:000012', NULL, NULL, 'Apical membrane antigen 1', NULL, NULL, NULL, NULL, NULL, 4),
(18489, NULL, 'G3DSA:3.30.70.3490:FF:000066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18490, NULL, 'G3DSA:3.30.360.10:FF:000124', NULL, NULL, 'Inositol-3-phosphate synthase isozyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(18491, NULL, 'G3DSA:1.10.10.160:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18492, NULL, 'G3DSA:1.10.10.10:FF:001116', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(18493, NULL, 'G3DSA:1.25.40.20:FF:001306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18494, NULL, 'G3DSA:3.40.50.150:FF:001653', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18495, NULL, 'G3DSA:2.60.200.10:FF:000003', NULL, NULL, 'Interferon regulatory factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(18496, NULL, 'G3DSA:3.80.10.10:FF:001709', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18497, NULL, 'G3DSA:1.10.760.10:FF:000004', NULL, NULL, 'Cytochrome c peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(18498, NULL, 'G3DSA:3.40.50.1240:FF:000141', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18499, NULL, 'G3DSA:1.10.150.60:FF:000023', NULL, NULL, 'CRE-LET-526 protein', NULL, NULL, NULL, NULL, NULL, 4),
(18500, NULL, 'G3DSA:2.60.40.10:FF:002838', NULL, NULL, 'Protein tyrosine phosphatase, receptor-type, Z polypeptide 1a', NULL, NULL, NULL, NULL, NULL, 4),
(18501, NULL, 'G3DSA:1.25.40.10:FF:003041', NULL, NULL, 'Os07g0436600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(18502, NULL, 'G3DSA:3.40.640.10:FF:000228', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(18503, NULL, 'G3DSA:3.30.450.380:FF:000004', NULL, NULL, 'Type II secretion system protein E', NULL, NULL, NULL, NULL, NULL, 4),
(18504, NULL, 'G3DSA:1.10.533.10:FF:000140', NULL, NULL, 'Death domain-containing membrane protein NRADD', NULL, NULL, NULL, NULL, NULL, 4),
(18505, NULL, 'G3DSA:1.10.150.80:FF:000029', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(18506, NULL, 'G3DSA:3.30.70.330:FF:000128', NULL, NULL, 'Nuclear cap-binding protein subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(18507, NULL, 'G3DSA:3.30.160.60:FF:003423', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18508, NULL, 'G3DSA:1.20.5.340:FF:000053', NULL, NULL, 'Tpm1p', NULL, NULL, NULL, NULL, NULL, 4),
(18509, NULL, 'G3DSA:3.40.50.300:FF:003109', NULL, NULL, 'Replication factor C large subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18510, NULL, 'G3DSA:1.25.50.20:FF:000003', NULL, NULL, 'Leucyl-cystinyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(18511, NULL, 'G3DSA:3.40.605.10:FF:000079', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18512, NULL, 'G3DSA:1.20.1310.10:FF:000057', NULL, NULL, 'Cullin-4', NULL, NULL, NULL, NULL, NULL, 4),
(18513, NULL, 'G3DSA:1.20.5.4130:FF:000002', NULL, NULL, 'Disease resistance protein RPP8', NULL, NULL, NULL, NULL, NULL, 4),
(18514, NULL, 'G3DSA:2.60.40.150:FF:000245', NULL, NULL, 'Copine VIII', NULL, NULL, NULL, NULL, NULL, 4),
(18515, NULL, 'G3DSA:3.10.310.10:FF:000042', NULL, NULL, '4-oxalomesaconate tautomerase', NULL, NULL, NULL, NULL, NULL, 4),
(18516, NULL, 'G3DSA:3.30.160.60:FF:002934', NULL, NULL, 'Zinc finger protein 513', NULL, NULL, NULL, NULL, NULL, 4),
(18517, NULL, 'G3DSA:1.20.5.110:FF:000282', NULL, NULL, 'AER438Cp', NULL, NULL, NULL, NULL, NULL, 4),
(18518, NULL, 'G3DSA:1.10.150.80:FF:000001', NULL, NULL, 'Putative exosome component 10', NULL, NULL, NULL, NULL, NULL, 4),
(18519, NULL, 'G3DSA:2.130.10.10:FF:004828', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(18520, NULL, 'G3DSA:3.40.50.1360:FF:000059', NULL, NULL, 'Glucosamine-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(18521, NULL, 'G3DSA:3.90.79.10:FF:000288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18522, NULL, 'G3DSA:3.40.50.300:FF:004621', NULL, NULL, 'Transcription regulatory protein SNF2', NULL, NULL, NULL, NULL, NULL, 4),
(18523, NULL, 'G3DSA:3.30.310.130:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18524, NULL, 'G3DSA:1.20.1050.90:FF:000004', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(18525, NULL, 'G3DSA:3.30.160.60:FF:006296', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18526, NULL, 'G3DSA:3.30.565.10:FF:000420', NULL, NULL, 'Two component system histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(18527, NULL, 'G3DSA:1.10.8.60:FF:000062', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(18528, NULL, 'G3DSA:3.10.20.90:FF:000478', NULL, NULL, 'Protein LAX PANICLE 2', NULL, NULL, NULL, NULL, NULL, 4),
(18529, NULL, 'G3DSA:1.10.510.10:FF:001705', NULL, NULL, 'IQ calmodulin-binding motif family protein', NULL, NULL, NULL, NULL, NULL, 4),
(18530, NULL, 'G3DSA:3.30.40.10:FF:002130', NULL, NULL, 'General transcription and DNA repair factor IIH', NULL, NULL, NULL, NULL, NULL, 4),
(18531, NULL, 'G3DSA:1.25.40.10:FF:004451', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At3g08820', NULL, NULL, NULL, NULL, NULL, 4),
(18532, NULL, 'G3DSA:2.130.10.10:FF:004087', NULL, NULL, 'Major facilitator superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(18533, NULL, 'G3DSA:3.30.200.20:FF:002246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18534, NULL, 'G3DSA:3.90.226.10:FF:000119', NULL, NULL, 'Probable enoyl-CoA hydratase echA7', NULL, NULL, NULL, NULL, NULL, 4),
(18535, NULL, 'G3DSA:2.130.10.10:FF:003598', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18536, NULL, 'G3DSA:3.30.200.20:FF:001757', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18537, NULL, 'G3DSA:3.80.10.10:FF:001861', NULL, NULL, 'Ribonuclease inhibitor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(18538, NULL, 'G3DSA:1.25.40.10:FF:002765', NULL, NULL, 'Sel1 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(18539, NULL, 'G3DSA:3.30.160.60:FF:001574', NULL, NULL, 'Zinc finger protein 366', NULL, NULL, NULL, NULL, NULL, 4),
(18540, NULL, 'G3DSA:3.80.10.10:FF:000451', NULL, NULL, 'EIN3-binding F-box protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(18541, NULL, 'G3DSA:4.10.1240.10:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18542, NULL, 'G3DSA:3.30.40.10:FF:001382', NULL, NULL, 'Ring finger domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18543, NULL, 'G3DSA:1.25.40.10:FF:003254', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(18544, NULL, 'G3DSA:1.10.760.10:FF:000055', NULL, NULL, 'PQQ-dependent dehydrogenase, methanol/ethanol family', NULL, NULL, NULL, NULL, NULL, 4),
(18545, NULL, 'G3DSA:1.20.5.4770:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18546, NULL, 'G3DSA:1.10.10.1050:FF:000002', NULL, NULL, 'mRNA-decapping enzyme subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(18547, NULL, 'G3DSA:1.10.3720.10:FF:000057', NULL, NULL, 'Putative glycerol-3-phosphate ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(18548, NULL, 'G3DSA:3.40.50.300:FF:003261', NULL, NULL, '3''-5'' exonuclease DinG', NULL, NULL, NULL, NULL, NULL, 4),
(18549, NULL, 'G3DSA:1.20.930.10:FF:000010', NULL, NULL, 'elongin-A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(18550, NULL, 'G3DSA:2.60.40.1120:FF:000039', NULL, NULL, 'Silver, isoform N', NULL, NULL, NULL, NULL, NULL, 4),
(18551, NULL, 'G3DSA:2.60.40.60:FF:000122', NULL, NULL, 'Cadherin-related family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(18552, NULL, 'G3DSA:3.20.20.150:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(18553, NULL, 'G3DSA:3.15.10.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18554, NULL, 'G3DSA:3.40.50.2000:FF:000791', NULL, NULL, 'Glycosyltransferase family 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(18555, NULL, 'G3DSA:3.40.50.720:FF:001526', NULL, NULL, 'YALI0A02046p', NULL, NULL, NULL, NULL, NULL, 4),
(18556, NULL, 'G3DSA:1.10.560.10:FF:000135', NULL, NULL, 'T-complex polypeptide 1', NULL, NULL, NULL, NULL, NULL, 4),
(18557, NULL, 'G3DSA:3.55.40.20:FF:000002', NULL, NULL, 'Superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(18558, NULL, 'G3DSA:3.40.850.10:FF:000042', NULL, NULL, 'Kinesin family member 14', NULL, NULL, NULL, NULL, NULL, 4),
(18559, NULL, 'G3DSA:1.10.510.10:FF:000345', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(18560, NULL, 'G3DSA:2.30.29.30:FF:001072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18561, NULL, 'G3DSA:3.40.50.720:FF:002015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18562, NULL, 'G3DSA:2.80.10.50:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18563, NULL, 'G3DSA:3.30.160.60:FF:003783', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18564, NULL, 'G3DSA:2.130.10.10:FF:004615', NULL, NULL, 'WD repeat-containing protein 52-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(18565, NULL, 'G3DSA:2.30.29.30:FF:000644', NULL, NULL, 'Phosphatidylinositol transfer protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(18566, NULL, 'G3DSA:3.30.1730.10:FF:000001', NULL, NULL, 'AMP nucleosidase', NULL, NULL, NULL, NULL, NULL, 4),
(18567, NULL, 'G3DSA:3.20.20.70:FF:000831', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18568, NULL, 'G3DSA:1.20.58.70:FF:000001', NULL, NULL, 'Syntaxin 3', NULL, NULL, NULL, NULL, NULL, 4),
(18569, NULL, 'G3DSA:2.30.30.100:FF:000134', NULL, NULL, 'Probable U6 snRNA-associated Sm-like protein LSm2', NULL, NULL, NULL, NULL, NULL, 4),
(18570, NULL, 'G3DSA:3.10.290.10:FF:000106', NULL, NULL, 'Putative ribosomal protein S4 (RPS4A) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(18571, NULL, 'G3DSA:3.40.50.720:FF:000245', NULL, NULL, 'Short chain dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18572, NULL, 'G3DSA:1.20.1080.10:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18573, NULL, 'G3DSA:2.60.40.10:FF:005632', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18574, NULL, 'G3DSA:2.10.70.10:FF:000038', NULL, NULL, 'Complement component receptor type 1', NULL, NULL, NULL, NULL, NULL, 4),
(18575, NULL, 'G3DSA:2.10.90.10:FF:000101', NULL, NULL, 'Glycoprotein hormone alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(18576, NULL, 'G3DSA:1.10.238.10:FF:000824', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18577, NULL, 'G3DSA:1.25.10.10:FF:002757', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18578, NULL, 'G3DSA:1.10.730.20:FF:000005', NULL, NULL, 'Mitochondrial isoleucyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(18579, NULL, 'G3DSA:3.30.70.330:FF:001213', NULL, NULL, 'heterogeneous nuclear ribonucleoprotein M isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(18580, NULL, 'G3DSA:1.10.510.10:FF:003510', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18581, NULL, 'G3DSA:2.60.40.10:FF:003502', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18582, NULL, 'G3DSA:2.60.40.10:FF:000309', NULL, NULL, 'Fibronectin type III domain containing 3B', NULL, NULL, NULL, NULL, NULL, 4),
(18583, NULL, 'G3DSA:3.40.50.2000:FF:000223', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(18584, NULL, 'G3DSA:1.10.1040.10:FF:000027', NULL, NULL, 'L-carnitine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(18585, NULL, 'G3DSA:1.25.40.10:FF:000117', NULL, NULL, 'Crooked neck pre-mRNA-splicing factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(18586, NULL, 'G3DSA:4.10.60.10:FF:000201', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(18587, NULL, 'G3DSA:3.30.160.60:FF:000809', NULL, NULL, 'Zinc finger and BTB domain-containing 48', NULL, NULL, NULL, NULL, NULL, 4),
(18588, NULL, 'G3DSA:1.10.287.130:FF:000070', NULL, NULL, 'Histidine kinase sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(18589, NULL, 'G3DSA:3.90.1860.10:FF:000013', NULL, NULL, 'Putative RctB family protein', NULL, NULL, NULL, NULL, NULL, 4),
(18590, NULL, 'G3DSA:3.30.200.20:FF:002538', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18591, NULL, 'G3DSA:3.10.20.90:FF:000978', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18592, NULL, 'G3DSA:3.30.200.20:FF:000408', NULL, NULL, 'Serine/threonine-protein kinase RIM15', NULL, NULL, NULL, NULL, NULL, 4),
(18593, NULL, 'G3DSA:2.40.30.10:FF:000293', NULL, NULL, '3-dehydro-bile acid delta(4,6)-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(18594, NULL, 'G3DSA:2.30.110.10:FF:000059', NULL, NULL, 'Hypthetical protein SCD63.18c', NULL, NULL, NULL, NULL, NULL, 4),
(18595, NULL, 'G3DSA:3.30.160.60:FF:000910', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18596, NULL, 'G3DSA:3.30.450.60:FF:000040', NULL, NULL, 'Signal recognition particle receptor alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(18597, NULL, 'G3DSA:3.40.50.300:FF:006127', NULL, NULL, 'ATP-dependent DEAD/H RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18598, NULL, 'G3DSA:3.40.50.1240:FF:000080', NULL, NULL, 'Alpha-ribazole-5`-phosphate phosphatase CobC', NULL, NULL, NULL, NULL, NULL, 4),
(18599, NULL, 'G3DSA:2.120.10.30:FF:000052', NULL, NULL, 'Soluble aldose sugar dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(18600, NULL, 'G3DSA:3.30.1330.30:FF:000111', NULL, NULL, 'Protein pelota homolog', NULL, NULL, NULL, NULL, NULL, 4),
(18601, NULL, 'G3DSA:1.25.40.700:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18602, NULL, 'G3DSA:3.30.930.10:FF:000264', NULL, NULL, 'Alanine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(18603, NULL, 'G3DSA:1.20.1250.20:FF:001353', NULL, NULL, 'Sodium:galactoside symporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(18604, NULL, 'G3DSA:4.10.1060.10:FF:000043', NULL, NULL, 'Mitochondrial RNA binding complex 1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(18605, NULL, 'G3DSA:3.40.50.300:FF:002917', NULL, NULL, 'Mitochondrial ribosomal small subunit component', NULL, NULL, NULL, NULL, NULL, 4),
(18606, NULL, 'G3DSA:4.10.410.10:FF:000068', NULL, NULL, 'Serine protease inhibitor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18607, NULL, 'G3DSA:1.10.1410.40:FF:000003', NULL, NULL, 'Mitochondrial dynamics protein MID51', NULL, NULL, NULL, NULL, NULL, 4),
(18608, NULL, 'G3DSA:2.60.120.10:FF:000020', NULL, NULL, 'Cyclic nucleotide-gated channel beta 3', NULL, NULL, NULL, NULL, NULL, 4),
(18609, NULL, 'G3DSA:2.60.40.60:FF:000330', NULL, NULL, 'CaDHerin family', NULL, NULL, NULL, NULL, NULL, 4),
(18610, NULL, 'G3DSA:3.40.50.10240:FF:000030', NULL, NULL, 'Thiamine pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(18611, NULL, 'G3DSA:2.40.100.10:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18612, NULL, 'G3DSA:3.90.980.20:FF:000003', NULL, NULL, 'Putative PHD finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(18613, NULL, 'G3DSA:1.10.287.110:FF:000316', NULL, NULL, 'Chaperone protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18614, NULL, 'G3DSA:4.10.280.10:FF:000006', NULL, NULL, 'Neurogenic differentiation factor', NULL, NULL, NULL, NULL, NULL, 4),
(18615, NULL, 'G3DSA:1.20.5.30:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18616, NULL, 'G3DSA:2.40.30.10:FF:000405', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18617, NULL, 'G3DSA:3.80.10.10:FF:003098', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18618, NULL, 'G3DSA:3.40.120.10:FF:000065', NULL, NULL, 'Phosphoglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(18619, NULL, 'G3DSA:3.90.930.12:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(18620, NULL, 'G3DSA:3.30.1370.240:FF:000004', NULL, NULL, 'Phenylalanine-tRNA ligase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(18621, NULL, 'G3DSA:3.40.1190.20:FF:000004', NULL, NULL, 'Inosine-guanosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(18622, NULL, 'G3DSA:3.30.70.360:FF:000031', NULL, NULL, 'Acetylornithine deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(18623, NULL, 'G3DSA:2.30.29.30:FF:000015', NULL, NULL, 'Rho guanine nucleotide exchange factor 9', NULL, NULL, NULL, NULL, NULL, 4),
(18624, NULL, 'G3DSA:1.25.40.20:FF:000177', NULL, NULL, 'Transient receptor potential cation channel subfamily V member 6', NULL, NULL, NULL, NULL, NULL, 4),
(18625, NULL, 'G3DSA:3.30.420.110:FF:000024', NULL, NULL, 'DNA mismatch repair protein MSH4', NULL, NULL, NULL, NULL, NULL, 4),
(18626, NULL, 'G3DSA:1.20.1250.20:FF:002360', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18627, NULL, 'G3DSA:1.10.3120.10:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18628, NULL, 'G3DSA:2.80.10.50:FF:000274', NULL, NULL, 'Glucosylceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(18629, NULL, 'G3DSA:3.40.50.1820:FF:001815', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18630, NULL, 'G3DSA:2.60.40.150:FF:000425', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18631, NULL, 'G3DSA:3.40.50.300:FF:002176', NULL, NULL, 'Similar to cation ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(18632, NULL, 'G3DSA:3.40.50.300:FF:006515', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18633, NULL, 'G3DSA:2.40.50.1000:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18634, NULL, 'G3DSA:1.25.40.20:FF:000497', NULL, NULL, 'Receptor-interacting serine/threonine-protein kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(18635, NULL, 'G3DSA:3.90.25.10:FF:000012', NULL, NULL, 'Nitrogen metabolite repression regulator NmrA', NULL, NULL, NULL, NULL, NULL, 4),
(18636, NULL, 'G3DSA:2.130.10.10:FF:000664', NULL, NULL, 'Autophagy-related 18a, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(18637, NULL, 'G3DSA:1.20.990.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18638, NULL, 'G3DSA:3.30.1520.10:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18639, NULL, 'G3DSA:2.120.10.30:FF:000529', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18640, NULL, 'G3DSA:1.25.40.10:FF:002265', NULL, NULL, 'Dynein binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18641, NULL, 'G3DSA:3.40.50.150:FF:000664', NULL, NULL, 'Protein arginine methyltransferase 3', NULL, NULL, NULL, NULL, NULL, 4),
(18642, NULL, 'G3DSA:3.50.50.60:FF:001099', NULL, NULL, 'Baeyer-Villiger monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(18643, NULL, 'G3DSA:1.20.5.10:FF:000001', NULL, NULL, 'thrombospondin-3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(18644, NULL, 'G3DSA:1.10.510.10:FF:000845', NULL, NULL, 'Probable bifunctional tRNA threonylcarbamoyladenosine biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(18645, NULL, 'G3DSA:3.20.110.10:FF:000018', NULL, NULL, 'Mannosidase, alpha, class 2A, member 1', NULL, NULL, NULL, NULL, NULL, 4),
(18646, NULL, 'G3DSA:1.10.455.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18647, NULL, 'G3DSA:3.30.1370.10:FF:000170', NULL, NULL, 'Vigilin 1', NULL, NULL, NULL, NULL, NULL, 4),
(18648, NULL, 'G3DSA:3.40.950.10:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18649, NULL, 'G3DSA:1.10.238.10:FF:000184', NULL, NULL, 'cell growth regulator with EF hand domain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(18650, NULL, 'G3DSA:2.40.50.140:FF:000081', NULL, NULL, 'Exoribonuclease 2', NULL, NULL, NULL, NULL, NULL, 4),
(18651, NULL, 'G3DSA:1.25.40.180:FF:000282', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18652, NULL, 'G3DSA:3.30.200.20:FF:000352', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase kinase 4', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(18653, NULL, 'G3DSA:3.30.110.20:FF:000002', NULL, NULL, 'Ribonuclease P protein subunit p20', NULL, NULL, NULL, NULL, NULL, 4),
(18654, NULL, 'G3DSA:1.25.40.20:FF:001014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18655, NULL, 'G3DSA:1.10.510.10:FF:002993', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18656, NULL, 'G3DSA:2.60.40.10:FF:002546', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(18657, NULL, 'G3DSA:3.40.50.10260:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18658, NULL, 'G3DSA:3.30.160.60:FF:003991', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18659, NULL, 'G3DSA:3.30.70.590:FF:000015', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18660, NULL, 'G3DSA:1.10.357.40:FF:000003', NULL, NULL, 'Protein CBG02959', NULL, NULL, NULL, NULL, NULL, 4),
(18661, NULL, 'G3DSA:1.10.10.60:FF:000102', NULL, NULL, 'Aristaless related homeobox', NULL, NULL, NULL, NULL, NULL, 4),
(18662, NULL, 'G3DSA:1.10.150.20:FF:000011', NULL, NULL, 'exonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(18663, NULL, 'G3DSA:1.20.120.1900:FF:000049', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(18664, NULL, 'G3DSA:2.40.50.150:FF:000027', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(18665, NULL, 'G3DSA:1.10.1300.10:FF:000014', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(18666, NULL, 'G3DSA:2.60.40.10:FF:004694', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18667, NULL, 'G3DSA:3.40.50.720:FF:001869', NULL, NULL, 'Actin regulatory protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18668, NULL, 'G3DSA:1.25.40.10:FF:002585', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g22830', NULL, NULL, NULL, NULL, NULL, 4),
(18669, NULL, 'G3DSA:3.30.740.10:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18670, NULL, 'G3DSA:1.10.287.690:FF:000001', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(18671, NULL, 'G3DSA:3.30.710.10:FF:000202', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18672, NULL, 'G3DSA:2.30.29.30:FF:001364', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(18673, NULL, 'G3DSA:3.90.1520.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18674, NULL, 'G3DSA:1.20.120.350:FF:000094', NULL, NULL, 'Voltage-dependent P/Q-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(18675, NULL, 'G3DSA:2.60.40.3710:FF:000007', NULL, NULL, 'L,D-transpeptidase 4', NULL, NULL, NULL, NULL, NULL, 4),
(18676, NULL, 'G3DSA:3.90.550.10:FF:000709', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18677, NULL, 'G3DSA:3.30.160.60:FF:005789', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18678, NULL, 'G3DSA:2.40.70.10:FF:000470', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18679, NULL, 'G3DSA:2.60.40.10:FF:004912', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18680, NULL, 'G3DSA:1.10.3720.10:FF:000237', NULL, NULL, 'Blr1679 protein', NULL, NULL, NULL, NULL, NULL, 4),
(18681, NULL, 'G3DSA:2.130.10.10:FF:001102', NULL, NULL, 'Nitrous-oxide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(18682, NULL, 'G3DSA:2.60.40.10:FF:000517', NULL, NULL, 'Carcinoembryonic antigen-related cell adhesion molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(18683, NULL, 'G3DSA:2.130.10.10:FF:004879', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18684, NULL, 'G3DSA:2.10.25.10:FF:000142', NULL, NULL, 'Crumbs cell polarity complex component 2', NULL, NULL, NULL, NULL, NULL, 4),
(18685, NULL, 'G3DSA:3.60.15.10:FF:000086', NULL, NULL, 'Ribonuclease Z', NULL, NULL, NULL, NULL, NULL, 4),
(18686, NULL, 'G3DSA:1.10.510.10:FF:003830', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18687, NULL, 'G3DSA:2.30.280.10:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18688, NULL, 'G3DSA:3.30.900.10:FF:000032', NULL, NULL, 'Him-Three Paralog', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(18689, NULL, 'G3DSA:3.30.200.20:FF:000740', NULL, NULL, 'Putative S-receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(18690, NULL, 'G3DSA:3.30.430.20:FF:000009', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 28', NULL, NULL, NULL, NULL, NULL, 4),
(18691, NULL, 'G3DSA:3.30.160.60:FF:003715', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18692, NULL, 'G3DSA:3.30.160.70:FF:000003', NULL, NULL, 'Methylated-DNA--protein-cysteine S-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(18693, NULL, 'G3DSA:1.25.40.10:FF:004682', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(18694, NULL, 'G3DSA:3.90.780.10:FF:000013', NULL, NULL, 'Trifunctional nucleotide phosphoesterase protein YfkN', NULL, NULL, NULL, NULL, NULL, 4),
(18695, NULL, 'G3DSA:3.10.450.10:FF:000052', NULL, NULL, 'Cysteine proteinase inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(18696, NULL, 'G3DSA:3.40.50.10190:FF:000043', NULL, NULL, 'PAX interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(18697, NULL, 'G3DSA:1.10.287.70:FF:000214', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha-1S', NULL, NULL, NULL, NULL, NULL, 4),
(18698, NULL, 'G3DSA:2.60.40.10:FF:002726', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18699, NULL, 'G3DSA:2.130.10.10:FF:004328', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18700, NULL, 'G3DSA:1.50.10.20:FF:000105', NULL, NULL, 'Meiotically up-regulated gene 191 protein', NULL, NULL, NULL, NULL, NULL, 4),
(18701, NULL, 'G3DSA:2.40.30.130:FF:000040', NULL, NULL, 'Cytoplasm protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18702, NULL, 'G3DSA:2.30.310.10:FF:000007', NULL, NULL, 'Protein CBG11722', NULL, NULL, NULL, NULL, NULL, 4),
(18703, NULL, 'G3DSA:1.10.472.130:FF:000087', NULL, NULL, 'Cytoplasmic dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18704, NULL, 'G3DSA:2.60.15.10:FF:000004', NULL, NULL, 'ATP synthase subunit delta, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(18705, NULL, 'G3DSA:2.60.120.380:FF:000014', NULL, NULL, 'Putative calpain-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(18706, NULL, 'G3DSA:3.60.10.10:FF:000002', NULL, NULL, 'CCR4-NOT transcription complex subunit 6 like', NULL, NULL, NULL, NULL, NULL, 4),
(18707, NULL, 'G3DSA:3.40.50.10190:FF:000200', NULL, NULL, 'DNA ligase 4', NULL, NULL, NULL, NULL, NULL, 4),
(18708, NULL, 'G3DSA:3.60.10.10:FF:000114', NULL, NULL, 'Sphingomyelin phosphodiesterase 5', NULL, NULL, NULL, NULL, NULL, 4),
(18709, NULL, 'G3DSA:3.40.50.300:FF:001395', NULL, NULL, 'Structural maintenance of chromosomes protein', NULL, NULL, NULL, NULL, NULL, 4),
(18710, NULL, 'G3DSA:2.30.30.140:FF:000298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18711, NULL, 'G3DSA:3.40.50.300:FF:008275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18712, NULL, 'G3DSA:2.60.120.620:FF:000075', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18713, NULL, 'G3DSA:3.30.40.10:FF:001562', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18714, NULL, 'G3DSA:2.60.40.60:FF:000914', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18715, NULL, 'G3DSA:2.130.10.10:FF:006009', NULL, NULL, 'WD repeat domain 90', NULL, NULL, NULL, NULL, NULL, 4),
(18716, NULL, 'G3DSA:2.60.40.150:FF:000037', NULL, NULL, 'dysferlin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(18717, NULL, 'G3DSA:2.70.98.10:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18718, NULL, 'G3DSA:1.10.1240.60:FF:000001', NULL, NULL, 'Regulator of G-protein signaling 6', NULL, NULL, NULL, NULL, NULL, 4),
(18719, NULL, 'G3DSA:1.10.167.10:FF:000013', NULL, NULL, 'sorting nexin-25 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(18720, NULL, 'G3DSA:2.30.29.30:FF:000291', NULL, NULL, 'insulin receptor substrate 2', NULL, NULL, NULL, NULL, NULL, 4),
(18721, NULL, 'G3DSA:1.20.1250.20:FF:002152', NULL, NULL, 'Os09g0452300 protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(18722, NULL, 'G3DSA:3.40.50.720:FF:001234', NULL, NULL, 'C-terminal-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(18723, NULL, 'G3DSA:1.10.10.10:FF:000609', NULL, NULL, 'Transcriptional regulator, MarR family', NULL, NULL, NULL, NULL, NULL, 4),
(18724, NULL, 'G3DSA:3.40.190.170:FF:000008', NULL, NULL, 'C4-dicarboxylate ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(18725, NULL, 'G3DSA:1.10.8.720:FF:000040', NULL, NULL, 'Dynein alpha chain, flagellar outer arm', NULL, NULL, NULL, NULL, NULL, 4),
(18726, NULL, 'G3DSA:3.30.465.10:FF:000031', NULL, NULL, 'FAD binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(18727, NULL, 'G3DSA:1.25.40.20:FF:000289', NULL, NULL, 'Ankyrin repeat domain 33', NULL, NULL, NULL, NULL, NULL, 4),
(18728, NULL, 'G3DSA:3.40.1280.10:FF:000126', NULL, NULL, 'SPOUT domain-containing methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(18729, NULL, 'G3DSA:3.90.1150.10:FF:000206', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(18730, NULL, 'G3DSA:2.130.10.10:FF:002850', NULL, NULL, 'Regulator of COP-II vesicle coat', NULL, NULL, NULL, NULL, NULL, 4),
(18731, NULL, 'G3DSA:2.30.42.10:FF:000034', NULL, NULL, 'Glutamate receptor interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(18732, NULL, 'G3DSA:2.60.40.10:FF:002142', NULL, NULL, 'Immunoglobulin heavy variable 3-38 (non-functional)', NULL, NULL, NULL, NULL, NULL, 4),
(18733, NULL, 'G3DSA:3.40.50.1000:FF:000209', NULL, NULL, 'Guanylyl cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(18734, NULL, 'G3DSA:2.60.40.150:FF:000537', NULL, NULL, 'E3 ubiquitin ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18735, NULL, 'G3DSA:3.40.47.10:FF:000082', NULL, NULL, 'GD13606', NULL, NULL, NULL, NULL, NULL, 4),
(18736, NULL, 'G3DSA:4.10.260.10:FF:000011', NULL, NULL, 'Guanine nucleotide-binding protein subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(18737, NULL, 'G3DSA:1.20.50.20:FF:000002', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(18738, NULL, 'G3DSA:3.40.190.10:FF:000710', NULL, NULL, 'Molybdate ABC transporter, periplasmic molybdate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(18739, NULL, 'G3DSA:4.10.49.10:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18740, NULL, 'G3DSA:2.120.10.80:FF:000342', NULL, NULL, 'tRNA wybutosine-synthesizing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(18741, NULL, 'G3DSA:3.40.525.10:FF:000045', NULL, NULL, 'Phosphatidylinositol transfer protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(18742, NULL, 'G3DSA:2.30.180.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18743, NULL, 'G3DSA:3.40.50.300:FF:000855', NULL, NULL, 'Guanylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(18744, NULL, 'G3DSA:3.40.50.300:FF:000731', NULL, NULL, 'Fanconi anemia group J protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(18745, NULL, 'G3DSA:1.20.1560.10:FF:000008', NULL, NULL, 'Lipid A export ATP-binding/permease protein MsbA', NULL, NULL, NULL, NULL, NULL, 4),
(18746, NULL, 'G3DSA:1.10.20.10:FF:000285', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18747, NULL, 'G3DSA:1.10.3430.10:FF:000018', NULL, NULL, 'Rhesus-like glycoprotein B', NULL, NULL, NULL, NULL, NULL, 4),
(18748, NULL, 'G3DSA:3.90.1070.20:FF:000001', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(18749, NULL, 'G3DSA:3.30.43.10:FF:000023', NULL, NULL, 'Indole-3-acetaldehyde oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(18750, NULL, 'G3DSA:1.20.1250.20:FF:000004', NULL, NULL, 'vesicular glutamate transporter 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(18751, NULL, 'G3DSA:1.10.287.4070:FF:000016', NULL, NULL, 'U4/U6-U5 snRNP complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(18752, NULL, 'G3DSA:3.40.50.2300:FF:000111', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(18753, NULL, 'G3DSA:1.10.510.10:FF:000637', NULL, NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 64', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(18754, NULL, 'G3DSA:3.40.50.620:FF:000092', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(18755, NULL, 'G3DSA:3.40.50.460:FF:000021', NULL, NULL, '6-phosphofructokinase type C-like', NULL, NULL, NULL, NULL, NULL, 4),
(18756, NULL, 'G3DSA:3.30.200.20:FF:000240', NULL, NULL, 'Serine/threonine-protein kinase Nek7', NULL, NULL, NULL, NULL, NULL, 4),
(18757, NULL, 'G3DSA:3.50.50.60:FF:001211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18758, NULL, 'G3DSA:2.40.10.10:FF:000022', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(18759, NULL, 'G3DSA:1.10.10.10:FF:001560', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18760, NULL, 'G3DSA:1.20.5.1160:FF:000004', NULL, NULL, 'Enah/Vasp-like, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(18761, NULL, 'G3DSA:3.30.70.330:FF:000696', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18762, NULL, 'G3DSA:3.80.10.10:FF:004054', NULL, NULL, 'Putative pre-mRNA-splicing factor ATP-dependent RNA helicase DEAH9', NULL, NULL, NULL, NULL, NULL, 4),
(18763, NULL, 'G3DSA:3.40.50.150:FF:000872', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18764, NULL, 'G3DSA:3.30.420.60:FF:000004', NULL, NULL, 'Protein DOM34 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(18765, NULL, 'G3DSA:3.40.50.300:FF:004593', NULL, NULL, 'Disease resistance protein (TIR-NBS class)', NULL, NULL, NULL, NULL, NULL, 4),
(18766, NULL, 'G3DSA:2.40.160.110:FF:000019', NULL, NULL, 'LAMP family protein lmp-1', NULL, NULL, NULL, NULL, NULL, 4),
(18767, NULL, 'G3DSA:3.30.160.60:FF:002355', NULL, NULL, 'Zinc finger protein 623', NULL, NULL, NULL, NULL, NULL, 4),
(18768, NULL, 'G3DSA:3.10.20.870:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18769, NULL, 'G3DSA:3.30.230.10:FF:000290', NULL, NULL, 'Mismatch repair endonuclease pms1', NULL, NULL, NULL, NULL, NULL, 4),
(18770, NULL, 'G3DSA:3.30.1360.200:FF:000007', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(18771, NULL, 'G3DSA:3.90.70.10:FF:000499', NULL, NULL, 'Ubiquitin specific peptidase 50', NULL, NULL, NULL, NULL, NULL, 4),
(18772, NULL, 'G3DSA:1.25.40.10:FF:002473', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(18773, NULL, 'G3DSA:3.40.1000.50:FF:000011', NULL, NULL, 'Maf1 regulator protein', NULL, NULL, NULL, NULL, NULL, 4),
(18774, NULL, 'G3DSA:3.40.50.1100:FF:000240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18775, NULL, 'G3DSA:4.10.400.10:FF:000163', NULL, NULL, 'Complement factor I', NULL, NULL, NULL, NULL, NULL, 4),
(18776, NULL, 'G3DSA:3.30.70.600:FF:000024', NULL, NULL, '40S ribosomal protein S20', NULL, NULL, NULL, NULL, NULL, 4),
(18777, NULL, 'G3DSA:3.30.160.60:FF:001006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18778, NULL, 'G3DSA:3.40.80.10:FF:000018', NULL, NULL, 'Peptidoglycan-recognition protein LF', NULL, NULL, NULL, NULL, NULL, 4),
(18779, NULL, 'G3DSA:1.10.30.10:FF:000111', NULL, NULL, 'Protein CBG16744', NULL, NULL, NULL, NULL, NULL, 4),
(18780, NULL, 'G3DSA:3.10.110.10:FF:000043', NULL, NULL, 'ubiquitin-conjugating enzyme E2 J1', NULL, NULL, NULL, NULL, NULL, 4),
(18781, NULL, 'G3DSA:1.20.1060.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18782, NULL, 'G3DSA:1.20.1070.10:FF:000813', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18783, NULL, 'G3DSA:3.40.50.300:FF:001075', NULL, NULL, 'ATP dependent RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18784, NULL, 'G3DSA:1.10.1450.10:FF:000114', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(18785, NULL, 'G3DSA:3.40.50.300:FF:005402', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18786, NULL, 'G3DSA:4.10.240.10:FF:000009', NULL, NULL, 'C6 transcription factor (Gal4)', NULL, NULL, NULL, NULL, NULL, 4),
(18787, NULL, 'G3DSA:1.10.238.10:FF:000420', NULL, NULL, 'Ferric reductase/NADPH oxidase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(18788, NULL, 'G3DSA:3.40.50.2300:FF:001128', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18789, NULL, 'G3DSA:1.10.246.60:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18790, NULL, 'G3DSA:1.25.40.10:FF:002085', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g41720', NULL, NULL, NULL, NULL, NULL, 4),
(18791, NULL, 'G3DSA:1.20.1110.10:FF:000076', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(18792, NULL, 'G3DSA:3.30.342.10:FF:000015', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(18793, NULL, 'G3DSA:1.10.287.110:FF:000029', NULL, NULL, 'DnaJ homolog subfamily C member 10', NULL, NULL, NULL, NULL, NULL, 4),
(18794, NULL, 'G3DSA:3.30.1610.10:FF:000003', NULL, NULL, 'Nucleoporin SONB, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18795, NULL, 'G3DSA:1.10.630.10:FF:000500', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18796, NULL, 'G3DSA:3.40.50.300:FF:008483', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18797, NULL, 'G3DSA:2.60.40.10:FF:001821', NULL, NULL, 'Beta-galactosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18798, NULL, 'G3DSA:2.60.40.60:FF:000094', NULL, NULL, 'protocadherin gamma-C4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(18799, NULL, 'G3DSA:2.60.40.10:FF:003895', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18800, NULL, 'G3DSA:1.10.510.10:FF:000284', NULL, NULL, 'Putative receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(18801, NULL, 'G3DSA:1.10.8.710:FF:000003', NULL, NULL, 'Dynein axonemal heavy chain 5', NULL, NULL, NULL, NULL, NULL, 4),
(18802, NULL, 'G3DSA:2.30.42.10:FF:000158', NULL, NULL, 'PDZ domain containing 8 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(18803, NULL, 'G3DSA:3.40.50.2000:FF:000347', NULL, NULL, 'Glycosyl transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(18804, NULL, 'G3DSA:1.10.8.10:FF:000300', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(18805, NULL, 'G3DSA:3.80.10.10:FF:003598', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18806, NULL, 'G3DSA:2.20.130.20:FF:000004', NULL, NULL, 'PZP, alpha-2-macroglobulin like', NULL, NULL, NULL, NULL, NULL, 4),
(18807, NULL, 'G3DSA:1.10.510.10:FF:003330', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18808, NULL, 'G3DSA:1.10.510.10:FF:001301', NULL, NULL, 'NIMA-related kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(18809, NULL, 'G3DSA:3.30.230.70:FF:000178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18810, NULL, 'G3DSA:1.25.40.20:FF:000677', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(18811, NULL, 'G3DSA:1.25.40.10:FF:000056', NULL, NULL, 'Tetratricopeptide repeat domain 28', NULL, NULL, NULL, NULL, NULL, 4),
(18812, NULL, 'G3DSA:3.30.710.10:FF:000489', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18813, NULL, 'G3DSA:2.10.70.80:FF:000019', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(18814, NULL, 'G3DSA:2.110.10.10:FF:000035', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(18815, NULL, 'G3DSA:2.70.130.10:FF:000029', NULL, NULL, 'uncharacterized protein LOC100184158', NULL, NULL, NULL, NULL, NULL, 4),
(18816, NULL, 'G3DSA:3.40.50.720:FF:001026', NULL, NULL, 'Gfo/Idh/MocA family oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(18817, NULL, 'G3DSA:3.30.40.10:FF:001882', NULL, NULL, 'E3 ubiquitin-protein ligase complex slx8-rfp subunit slx8', NULL, NULL, NULL, NULL, NULL, 4),
(18818, NULL, 'G3DSA:1.10.720.40:FF:000005', NULL, NULL, 'Emerin', NULL, NULL, NULL, NULL, NULL, 4),
(18819, NULL, 'G3DSA:3.30.160.60:FF:004772', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18820, NULL, 'G3DSA:1.20.140.150:FF:000066', NULL, NULL, 'Claudin', NULL, NULL, NULL, NULL, NULL, 4),
(18821, NULL, 'G3DSA:1.10.238.260:FF:000003', NULL, NULL, '2-isopropylmalate synthase 1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(18822, NULL, 'G3DSA:3.40.390.10:FF:000287', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18823, NULL, 'G3DSA:3.90.70.10:FF:000583', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(18824, NULL, 'G3DSA:1.20.1260.10:FF:000064', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(18825, NULL, 'G3DSA:2.40.10.10:FF:000230', NULL, NULL, 'Serine protease 53', NULL, NULL, NULL, NULL, NULL, 4),
(18826, NULL, 'G3DSA:3.40.20.10:FF:000110', NULL, NULL, 'Scinderin like a', NULL, NULL, NULL, NULL, NULL, 4),
(18827, NULL, 'G3DSA:3.30.160.60:FF:006088', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18828, NULL, 'G3DSA:4.10.280.10:FF:000074', NULL, NULL, 'Transcription factor ORG2', NULL, NULL, NULL, NULL, NULL, 4),
(18829, NULL, 'G3DSA:2.10.25.10:FF:000759', NULL, NULL, 'Neurogenic locus notch homolog protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(18830, NULL, 'G3DSA:1.25.10.10:FF:001740', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18831, NULL, 'G3DSA:6.10.140.2220:FF:000039', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(18832, NULL, 'G3DSA:3.90.230.10:FF:000068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18833, NULL, 'G3DSA:3.80.10.10:FF:001468', NULL, NULL, 'Connectin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(18834, NULL, 'G3DSA:1.20.5.190:FF:000047', NULL, NULL, 'Myosin-VIIa', NULL, NULL, NULL, NULL, NULL, 4),
(18835, NULL, 'G3DSA:3.30.200.20:FF:002038', NULL, NULL, 'Inhibitor of nuclear factor kappa-B kinase epsilon subunit homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(18836, NULL, 'G3DSA:2.10.25.10:FF:001491', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18837, NULL, 'G3DSA:3.40.640.10:FF:000060', NULL, NULL, 'Serine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(18838, NULL, 'G3DSA:2.130.10.10:FF:002350', NULL, NULL, 'Putative WD-repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(18839, NULL, 'G3DSA:3.40.190.10:FF:000367', NULL, NULL, 'Serotransferrin', NULL, NULL, NULL, NULL, NULL, 4),
(18840, NULL, 'G3DSA:3.30.1520.10:FF:000108', NULL, NULL, 'Sorting nexin 7', NULL, NULL, NULL, NULL, NULL, 4),
(18841, NULL, 'G3DSA:2.60.40.10:FF:004171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18842, NULL, 'G3DSA:3.80.10.10:FF:000243', NULL, NULL, 'NLR family CARD domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(18843, NULL, 'G3DSA:3.40.50.2000:FF:000291', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(18844, NULL, 'G3DSA:2.40.30.300:FF:000001', NULL, NULL, 'Mtr4 exosome RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(18845, NULL, 'G3DSA:3.40.1110.10:FF:000468', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18846, NULL, 'G3DSA:2.30.29.30:FF:001184', NULL, NULL, 'YL1 nuclear protein Cterminal domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(18847, NULL, 'G3DSA:1.10.10.60:FF:000653', NULL, NULL, 'GARP-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(18848, NULL, 'G3DSA:2.60.40.10:FF:003266', NULL, NULL, 'GM10182', NULL, NULL, NULL, NULL, NULL, 4),
(18849, NULL, 'G3DSA:2.30.29.30:FF:000083', NULL, NULL, 'Pleckstrin homology domain-containing family A member 5', NULL, NULL, NULL, NULL, NULL, 4),
(18850, NULL, 'G3DSA:3.30.70.270:FF:000088', NULL, NULL, 'GGDEF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(18851, NULL, 'G3DSA:1.10.486.10:FF:000029', NULL, NULL, 'PROBABLE ATP-DEPENDENT DNA HELICASE', NULL, NULL, NULL, NULL, NULL, 4),
(18852, NULL, 'G3DSA:3.40.50.1000:FF:000709', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18853, NULL, 'G3DSA:2.40.20.10:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18854, NULL, 'G3DSA:3.40.50.300:FF:001979', NULL, NULL, '6-phosphofructo-2-kinase/fructose-2,6-bisphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(18855, NULL, 'G3DSA:3.40.50.12780:FF:000117', NULL, NULL, 'Acyl-CoA synthetase medium chain family member 5', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(18856, NULL, 'G3DSA:3.10.250.10:FF:000109', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18857, NULL, 'G3DSA:1.20.1560.10:FF:000216', NULL, NULL, 'HAlF transporter (PGP related)', NULL, NULL, NULL, NULL, NULL, 4),
(18858, NULL, 'G3DSA:3.30.420.10:FF:000742', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18859, NULL, 'G3DSA:2.160.20.10:FF:000247', NULL, NULL, 'Os04g0513301 protein', NULL, NULL, NULL, NULL, NULL, 4),
(18860, NULL, 'G3DSA:3.40.50.720:FF:001369', NULL, NULL, 'UDP-galactopyranose mutase Glf', NULL, NULL, NULL, NULL, NULL, 4),
(18861, NULL, 'G3DSA:1.25.10.10:FF:002437', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18862, NULL, 'G3DSA:1.10.418.40:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18863, NULL, 'G3DSA:2.60.40.10:FF:000461', NULL, NULL, 'Sortilin related receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(18864, NULL, 'G3DSA:3.30.1240.10:FF:000014', NULL, NULL, 'Cof-type HAD-IIB family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(18865, NULL, 'G3DSA:3.30.428.70:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18866, NULL, 'G3DSA:1.20.58.2220:FF:000064', NULL, NULL, 'Formin-C', NULL, NULL, NULL, NULL, NULL, 4),
(18867, NULL, 'G3DSA:2.60.40.1170:FF:000032', NULL, NULL, 'AP-1 complex subunit mu-1', NULL, NULL, NULL, NULL, NULL, 4),
(18868, NULL, 'G3DSA:3.30.2130.30:FF:000017', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18869, NULL, 'G3DSA:2.60.40.60:FF:001111', NULL, NULL, 'Novel protein similar to human procadherin 15 (PCDH15)', NULL, NULL, NULL, NULL, NULL, 4),
(18870, NULL, 'G3DSA:3.50.50.60:FF:000582', NULL, NULL, 'Probable lysine-specific histone demethylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(18871, NULL, 'G3DSA:2.70.170.10:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18872, NULL, 'G3DSA:1.25.40.990:FF:000047', NULL, NULL, 'Protein xmas-2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(18873, NULL, 'G3DSA:1.25.40.10:FF:000617', NULL, NULL, 'UTP6, small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4),
(18874, NULL, 'G3DSA:1.20.120.350:FF:000206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18875, NULL, 'G3DSA:3.40.50.1820:FF:001462', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18876, NULL, 'G3DSA:1.10.3650.10:FF:000001', NULL, NULL, 'Respiratory nitrate reductase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(18877, NULL, 'G3DSA:2.130.10.130:FF:000008', NULL, NULL, 'Integrin subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(18878, NULL, 'G3DSA:2.60.40.10:FF:002485', NULL, NULL, 'AGAP004902-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(18879, NULL, 'G3DSA:3.40.190.10:FF:000631', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(18880, NULL, 'G3DSA:2.60.40.10:FF:005132', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18881, NULL, 'G3DSA:3.30.260.10:FF:000027', NULL, NULL, 'T-complex protein 1 subunit theta-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(18882, NULL, 'G3DSA:1.10.760.10:FF:000116', NULL, NULL, 'Diheme cytochrome c SoxD', NULL, NULL, NULL, NULL, NULL, 4),
(18883, NULL, 'G3DSA:1.25.40.10:FF:000399', NULL, NULL, 'TPR-repeat-containing chaperone protein DNAJ', NULL, NULL, NULL, NULL, NULL, 4),
(18884, NULL, 'G3DSA:3.40.850.10:FF:000103', NULL, NULL, 'Kinesin-like protein KIN-14A', NULL, NULL, NULL, NULL, NULL, 4),
(18885, NULL, 'G3DSA:1.10.20.10:FF:000217', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18886, NULL, 'G3DSA:1.10.418.20:FF:000010', NULL, NULL, 'sentrin-specific protease 6 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(18887, NULL, 'G3DSA:3.30.360.10:FF:000012', NULL, NULL, 'Aspartate-semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(18888, NULL, 'G3DSA:1.10.630.10:FF:000635', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18889, NULL, 'G3DSA:1.25.40.10:FF:003102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(18890, NULL, 'G3DSA:1.25.10.10:FF:000228', NULL, NULL, 'armadillo repeat-containing protein 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(18891, NULL, 'G3DSA:3.40.30.10:FF:000015', NULL, NULL, 'NADH-quinone oxidoreductase subunit E', NULL, NULL, NULL, NULL, NULL, 4),
(18892, NULL, 'G3DSA:3.30.200.20:FF:001818', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18893, NULL, 'G3DSA:1.20.1250.20:FF:000448', NULL, NULL, 'Major facilitator superfamily domain containing 4B', NULL, NULL, NULL, NULL, NULL, 4),
(18894, NULL, 'G3DSA:3.10.450.50:FF:000081', NULL, NULL, 'calcium/calmodulin-dependent protein kinase type II delta chain', NULL, NULL, NULL, NULL, NULL, 4),
(18895, NULL, 'G3DSA:3.30.160.60:FF:002434', NULL, NULL, 'Zinc finger protein 1168', NULL, NULL, NULL, NULL, NULL, 4),
(18896, NULL, 'G3DSA:3.40.630.30:FF:000621', NULL, NULL, 'Long-chain N-acyl amino acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(18897, NULL, 'G3DSA:2.60.40.2380:FF:000001', NULL, NULL, '7TM diverse intracellular signaling', NULL, NULL, NULL, NULL, NULL, 4),
(18898, NULL, 'G3DSA:1.20.1270.60:FF:000091', NULL, NULL, 'Sorting nexin 1', NULL, NULL, NULL, NULL, NULL, 4),
(18899, NULL, 'G3DSA:1.10.3470.10:FF:000015', NULL, NULL, 'Zinc ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(18900, NULL, 'G3DSA:3.20.100.10:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18901, NULL, 'G3DSA:3.40.50.150:FF:001102', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18902, NULL, 'G3DSA:3.90.1030.20:FF:000004', NULL, NULL, 'DNA polymerase delta subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(18903, NULL, 'G3DSA:1.25.40.10:FF:002826', NULL, NULL, 'Os02g0680500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(18904, NULL, 'G3DSA:3.90.1180.10:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18905, NULL, 'G3DSA:2.130.10.110:FF:000002', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(18906, NULL, 'G3DSA:1.10.10.60:FF:000389', NULL, NULL, 'Transcriptional regulator, AraC family', NULL, NULL, NULL, NULL, NULL, 4),
(18907, NULL, 'G3DSA:3.40.50.300:FF:008140', NULL, NULL, 'Probable serine/threonine-protein kinase roco5', NULL, NULL, NULL, NULL, NULL, 4),
(18908, NULL, 'G3DSA:1.10.238.10:FF:000763', NULL, NULL, 'N-terminal EF-hand calcium binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(18909, NULL, 'G3DSA:1.10.10.440:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18910, NULL, 'G3DSA:3.30.160.60:FF:005868', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18911, NULL, 'G3DSA:1.20.1540.10:FF:000041', NULL, NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(18912, NULL, 'G3DSA:1.20.1240.10:FF:000001', NULL, NULL, 'Photosystem I reaction center subunit XI', NULL, NULL, NULL, NULL, NULL, 4),
(18913, NULL, 'G3DSA:3.40.50.300:FF:006307', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18914, NULL, 'G3DSA:3.40.140.20:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18915, NULL, 'G3DSA:2.30.40.10:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18916, NULL, 'G3DSA:1.10.238.10:FF:001201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18917, NULL, 'G3DSA:3.90.550.10:FF:000204', NULL, NULL, 'Hyaluronan synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(18918, NULL, 'G3DSA:1.20.5.340:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18919, NULL, 'G3DSA:1.20.1070.10:FF:000252', NULL, NULL, 'Adhesion G protein-coupled receptor D2', NULL, NULL, NULL, NULL, NULL, 4),
(18920, NULL, 'G3DSA:2.40.30.10:FF:000473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18921, NULL, 'G3DSA:2.60.120.260:FF:000332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18922, NULL, 'G3DSA:1.20.1250.20:FF:001696', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18923, NULL, 'G3DSA:2.40.70.10:FF:000391', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(18924, NULL, 'G3DSA:1.25.40.1030:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18925, NULL, 'G3DSA:3.60.21.10:FF:000471', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(18926, NULL, 'G3DSA:2.40.50.140:FF:000822', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18927, NULL, 'G3DSA:3.90.1150.10:FF:000274', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18928, NULL, 'G3DSA:2.60.260.20:FF:000128', NULL, NULL, 'AGAP005908-PA', NULL, NULL, NULL, NULL, NULL, 4),
(18929, NULL, 'G3DSA:3.30.70.890:FF:000066', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(18930, NULL, 'G3DSA:2.130.10.10:FF:002530', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18931, NULL, 'G3DSA:2.60.120.330:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18932, NULL, 'G3DSA:3.90.105.10:FF:000024', NULL, NULL, 'Molybdenum cofactor synthesis protein cinnamon', NULL, NULL, NULL, NULL, NULL, 4),
(18933, NULL, 'G3DSA:3.10.20.90:FF:000854', NULL, NULL, 'Nuclear protein localization protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(18934, NULL, 'G3DSA:3.20.20.60:FF:000002', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(18935, NULL, 'G3DSA:1.10.510.10:FF:002493', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18936, NULL, 'G3DSA:2.130.10.10:FF:005964', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18937, NULL, 'G3DSA:2.60.34.10:FF:000008', NULL, NULL, 'Stromal 70 kDa heat shock-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(18938, NULL, 'G3DSA:3.60.21.10:FF:000139', NULL, NULL, 'SA0140 protein', NULL, NULL, NULL, NULL, NULL, 4),
(18939, NULL, 'G3DSA:3.30.420.40:FF:000902', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18940, NULL, 'G3DSA:2.40.70.10:FF:000239', NULL, NULL, 'Related to aspartyl proteinase SAP3', NULL, NULL, NULL, NULL, NULL, 4),
(18941, NULL, 'G3DSA:3.30.160.60:FF:006306', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18942, NULL, 'G3DSA:3.30.160.60:FF:000225', NULL, NULL, 'zinc finger and BTB domain-containing protein 17 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(18943, NULL, 'G3DSA:1.20.5.170:FF:000221', NULL, NULL, 'Transcription factor AP-1', NULL, NULL, NULL, NULL, NULL, 4),
(18944, NULL, 'G3DSA:3.40.390.10:FF:000023', NULL, NULL, 'Matrix metalloproteinase-14 preproprotein', NULL, NULL, NULL, NULL, NULL, 4),
(18945, NULL, 'G3DSA:3.30.230.70:FF:000054', NULL, NULL, 'Exosome complex component RRP46', NULL, NULL, NULL, NULL, NULL, 4),
(18946, NULL, 'G3DSA:1.25.10.10:FF:001476', NULL, NULL, 'HEAT repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(18947, NULL, 'G3DSA:3.50.50.60:FF:000879', NULL, NULL, 'Salicylate hydroxylase, putative (AFU_orthologue AFUA_8G06050)', NULL, NULL, NULL, NULL, NULL, 4),
(18948, NULL, 'G3DSA:1.20.1280.50:FF:000116', NULL, NULL, 'SCF ubiquitin ligase complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(18949, NULL, 'G3DSA:3.60.15.10:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18950, NULL, 'G3DSA:3.30.200.20:FF:000560', NULL, NULL, 'Receptor like protein kinase S.2', NULL, NULL, NULL, NULL, NULL, 4),
(18951, NULL, 'G3DSA:3.10.380.10:FF:000001', NULL, NULL, 'Colicin-E3', NULL, NULL, NULL, NULL, NULL, 4),
(18952, NULL, 'G3DSA:2.60.40.10:FF:000129', NULL, NULL, 'CLUMA_CG018772, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(18953, NULL, 'G3DSA:3.40.30.10:FF:000279', NULL, NULL, 'Thioredoxin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(18954, NULL, 'G3DSA:1.25.40.20:FF:001514', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18955, NULL, 'G3DSA:3.20.20.190:FF:000011', NULL, NULL, 'Glycerophosphodiester phosphodiesterase GDPDL3', NULL, NULL, NULL, NULL, NULL, 4),
(18956, NULL, 'G3DSA:3.30.40.10:FF:000505', NULL, NULL, 'NEP1-interacting protein-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(18957, NULL, 'G3DSA:3.40.50.300:FF:001636', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(18958, NULL, 'G3DSA:3.30.70.330:FF:001477', NULL, NULL, 'FOG-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(18959, NULL, 'G3DSA:3.40.50.2300:FF:000431', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(18960, NULL, 'G3DSA:2.60.40.420:FF:000141', NULL, NULL, 'Spore coat protein A', NULL, NULL, NULL, NULL, NULL, 4),
(18961, NULL, 'G3DSA:2.30.39.10:FF:000015', NULL, NULL, 'Serpin family G member 1', NULL, NULL, NULL, NULL, NULL, 4),
(18962, NULL, 'G3DSA:2.30.30.30:FF:000029', NULL, NULL, 'Transcription elongation factor SPT5', NULL, NULL, NULL, NULL, NULL, 4),
(18963, NULL, 'G3DSA:2.130.10.10:FF:000321', NULL, NULL, 'DDB1- and CUL4-associated factor 10', NULL, NULL, NULL, NULL, NULL, 4),
(18964, NULL, 'G3DSA:3.80.10.10:FF:003334', NULL, NULL, 'Si:dkey-286j17.4', NULL, NULL, NULL, NULL, NULL, 4),
(18965, NULL, 'G3DSA:3.20.20.80:FF:000160', NULL, NULL, 'Probable beta-glucosidase btgE', NULL, NULL, NULL, NULL, NULL, 4),
(18966, NULL, 'G3DSA:3.20.20.70:FF:000623', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18967, NULL, 'G3DSA:3.30.70.330:FF:002837', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18968, NULL, 'G3DSA:3.40.630.40:FF:000006', NULL, NULL, 'Amidase', NULL, NULL, NULL, NULL, NULL, 4),
(18969, NULL, 'G3DSA:2.30.30.40:FF:000089', NULL, NULL, 'SH3 domain-containing kinase-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(18970, NULL, 'G3DSA:1.20.58.760:FF:000004', NULL, NULL, 'paraplegin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(18971, NULL, 'G3DSA:1.10.10.60:FF:000310', NULL, NULL, 'MYB transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(18972, NULL, 'G3DSA:3.40.250.10:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18973, NULL, 'G3DSA:3.30.830.10:FF:000200', NULL, NULL, 'Metalloprotease, insulinase family', NULL, NULL, NULL, NULL, NULL, 4),
(18974, NULL, 'G3DSA:1.10.10.10:FF:000840', NULL, NULL, 'Cul3p', NULL, NULL, NULL, NULL, NULL, 4),
(18975, NULL, 'G3DSA:1.20.1070.10:FF:001477', NULL, NULL, 'Opsin (Rh7-like sensitive)', NULL, NULL, NULL, NULL, NULL, 4),
(18976, NULL, 'G3DSA:3.40.309.10:FF:000054', NULL, NULL, 'Carnitine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(18977, NULL, 'G3DSA:1.10.238.10:FF:000532', NULL, NULL, 'CALB1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(18978, NULL, 'G3DSA:2.40.160.10:FF:000009', NULL, NULL, 'Mitochondrial import receptor subunit TOM40', NULL, NULL, NULL, NULL, NULL, 4),
(18979, NULL, 'G3DSA:1.20.1560.10:FF:000896', NULL, NULL, 'Os04g0481700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(18980, NULL, 'G3DSA:3.80.10.10:FF:004402', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18981, NULL, 'G3DSA:2.20.110.10:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18982, NULL, 'G3DSA:2.130.10.10:FF:003811', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18983, NULL, 'G3DSA:2.60.40.10:FF:005868', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18984, NULL, 'G3DSA:1.10.4160.10:FF:000031', NULL, NULL, 'NCS1 nucleoside transporter family', NULL, NULL, NULL, NULL, NULL, 4),
(18985, NULL, 'G3DSA:2.60.40.10:FF:005924', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18986, NULL, 'G3DSA:2.10.25.10:FF:000698', NULL, NULL, 'Blast:Prolow-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(18987, NULL, 'G3DSA:1.25.40.10:FF:003602', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18988, NULL, 'G3DSA:1.10.287.550:FF:000021', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18989, NULL, 'G3DSA:3.40.50.300:FF:005234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18990, NULL, 'G3DSA:3.10.580.10:FF:000089', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(18991, NULL, 'G3DSA:2.30.30.40:FF:000307', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(18992, NULL, 'G3DSA:1.20.1560.10:FF:000952', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(18993, NULL, 'G3DSA:1.20.1250.10:FF:000119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18994, NULL, 'G3DSA:1.20.1720.10:FF:000083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(18995, NULL, 'G3DSA:1.10.238.10:FF:000476', NULL, NULL, 'Polcalcin Jun o 2', NULL, NULL, NULL, NULL, NULL, 4),
(18996, NULL, 'G3DSA:1.20.1050.10:FF:000290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18997, NULL, 'G3DSA:1.20.140.150:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(18998, NULL, 'G3DSA:3.30.160.60:FF:002703', NULL, NULL, 'Zinc finger protein 790', NULL, NULL, NULL, NULL, NULL, 4),
(18999, NULL, 'G3DSA:1.25.40.10:FF:004114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19000, NULL, 'G3DSA:2.60.40.1730:FF:000003', NULL, NULL, 'Transcription initiation factor TFIID subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(19001, NULL, 'G3DSA:2.30.29.30:FF:000352', NULL, NULL, 'FACT complex subunit SSRP1', NULL, NULL, NULL, NULL, NULL, 4),
(19002, NULL, 'G3DSA:3.30.590.10:FF:000052', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(19003, NULL, 'G3DSA:1.20.1310.10:FF:000214', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19004, NULL, 'G3DSA:3.40.50.970:FF:000230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19005, NULL, 'G3DSA:3.80.10.10:FF:003834', NULL, NULL, 'F-box and leucine rich repeat protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(19006, NULL, 'G3DSA:3.60.40.10:FF:000122', NULL, NULL, 'Adenylate cyclase (ATP pyrophosphate-lyase), putative', NULL, NULL, NULL, NULL, NULL, 4),
(19007, NULL, 'G3DSA:3.40.50.970:FF:000174', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(19008, NULL, 'G3DSA:3.30.160.60:FF:003215', NULL, NULL, 'Transcriptional regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19009, NULL, 'G3DSA:1.25.40.10:FF:000792', NULL, NULL, 'tetratricopeptide repeat protein 28', NULL, NULL, NULL, NULL, NULL, 4),
(19010, NULL, 'G3DSA:3.30.1050.10:FF:000027', NULL, NULL, 'Alkyl/aryl-sulfatase BDS1', NULL, NULL, NULL, NULL, NULL, 4),
(19011, NULL, 'G3DSA:1.25.40.10:FF:004058', NULL, NULL, 'Glr1376 protein', NULL, NULL, NULL, NULL, NULL, 4),
(19012, NULL, 'G3DSA:1.20.80.10:FF:000024', NULL, NULL, 'acyl-CoA-binding domain-containing protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(19013, NULL, 'G3DSA:2.60.120.200:FF:000005', NULL, NULL, 'neurexin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(19014, NULL, 'G3DSA:1.10.10.10:FF:001801', NULL, NULL, 'Selenocysteine-specific translation elongation factor', NULL, NULL, NULL, NULL, NULL, 4),
(19015, NULL, 'G3DSA:3.30.40.10:FF:000426', NULL, NULL, 'DMA1p Ubiquitin-protein ligase (E3)', NULL, NULL, NULL, NULL, NULL, 4),
(19016, NULL, 'G3DSA:2.120.10.30:FF:000288', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM71', NULL, NULL, NULL, NULL, NULL, 4),
(19017, NULL, 'G3DSA:1.10.10.10:FF:001796', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19018, NULL, 'G3DSA:1.10.238.10:FF:001044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19019, NULL, 'G3DSA:1.10.10.820:FF:000017', NULL, NULL, 'Myosin C', NULL, NULL, NULL, NULL, NULL, 4),
(19020, NULL, 'G3DSA:2.130.10.10:FF:004323', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19021, NULL, 'G3DSA:3.40.50.2000:FF:000459', NULL, NULL, 'Protein CBR-UGT-59', NULL, NULL, NULL, NULL, NULL, 4),
(19022, NULL, 'G3DSA:1.25.40.10:FF:003546', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19023, NULL, 'G3DSA:3.40.50.1820:FF:001523', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19024, NULL, 'G3DSA:3.40.50.150:FF:000085', NULL, NULL, 'Anamorsin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(19025, NULL, 'G3DSA:2.10.25.10:FF:000703', NULL, NULL, 'Delta/notch like EGF repeat containing', NULL, NULL, NULL, NULL, NULL, 4),
(19026, NULL, 'G3DSA:1.25.10.10:FF:000964', NULL, NULL, 'Apoptosis inhibitory protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(19027, NULL, 'G3DSA:1.10.287.110:FF:000024', NULL, NULL, 'DnaJ (Hsp40) homolog, subfamily C, member 2', NULL, NULL, NULL, NULL, NULL, 4),
(19028, NULL, 'G3DSA:3.30.457.60:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19029, NULL, 'G3DSA:2.30.29.30:FF:000307', NULL, NULL, 'Beta-1-syntrophin isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(19030, NULL, 'G3DSA:2.60.40.10:FF:002198', NULL, NULL, 'Immunoglobulin heavy variable 5-2', NULL, NULL, NULL, NULL, NULL, 4),
(19031, NULL, 'G3DSA:3.40.50.11840:FF:000021', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(19032, NULL, 'G3DSA:3.10.20.90:FF:000298', NULL, NULL, 'BAG family molecular chaperone regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(19033, NULL, 'G3DSA:1.10.510.10:FF:001981', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(19034, NULL, 'G3DSA:3.30.70.1450:FF:000004', NULL, NULL, 'Putative transport protein YidE', NULL, NULL, NULL, NULL, NULL, 4),
(19035, NULL, 'G3DSA:3.40.30.10:FF:000690', NULL, NULL, 'Protein disulfide-isomerase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(19036, NULL, 'G3DSA:3.40.50.720:FF:000060', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(19037, NULL, 'G3DSA:2.60.40.10:FF:002254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19038, NULL, 'G3DSA:3.10.20.90:FF:000354', NULL, NULL, 'Homocysteine-responsive endoplasmic reticulum-resident ubiquitin-like domain member 2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(19039, NULL, 'G3DSA:3.30.70.1230:FF:000225', NULL, NULL, 'AGAP012805-PA', NULL, NULL, NULL, NULL, NULL, 4),
(19040, NULL, 'G3DSA:3.40.630.150:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19041, NULL, 'G3DSA:3.40.630.30:FF:000385', NULL, NULL, 'N-acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19042, NULL, 'G3DSA:3.40.50.1970:FF:000023', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(19043, NULL, 'G3DSA:3.90.780.10:FF:000036', NULL, NULL, '5'' nucleotidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(19044, NULL, 'G3DSA:1.25.10.10:FF:002414', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19045, NULL, 'G3DSA:2.120.10.30:FF:000237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19046, NULL, 'G3DSA:3.30.160.60:FF:005520', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19047, NULL, 'G3DSA:3.40.50.2000:FF:000408', NULL, NULL, 'Glycosyltransferase family 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(19048, NULL, 'G3DSA:3.40.50.740:FF:000048', NULL, NULL, 'NADPH-Fe(3+) oxidoreductase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(19049, NULL, 'G3DSA:3.30.519.10:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19050, NULL, 'G3DSA:3.30.420.40:FF:000285', NULL, NULL, 'Pantothenate kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19051, NULL, 'G3DSA:3.90.640.10:FF:000150', NULL, NULL, 'Actin', NULL, NULL, NULL, NULL, NULL, 4),
(19052, NULL, 'G3DSA:2.130.10.10:FF:003070', NULL, NULL, 'WD repeat-containing protein 46 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(19053, NULL, 'G3DSA:3.90.550.50:FF:000025', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(19054, NULL, 'G3DSA:3.30.160.20:FF:000180', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(19055, NULL, 'G3DSA:3.40.50.1820:FF:001467', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19056, NULL, 'G3DSA:2.60.40.150:FF:000717', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19057, NULL, 'G3DSA:1.20.1280.50:FF:000167', NULL, NULL, 'F-box domain protein (AFU_orthologue AFUA_3G00440)', NULL, NULL, NULL, NULL, NULL, 4),
(19058, NULL, 'G3DSA:1.10.8.460:FF:000001', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(19059, NULL, 'G3DSA:3.40.50.1820:FF:000181', NULL, NULL, 'valacyclovir hydrolase isoform X2', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(19060, NULL, 'G3DSA:2.60.40.10:FF:005183', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19061, NULL, 'G3DSA:3.40.50.2300:FF:000454', NULL, NULL, 'Putative chemotaxis protein CheV', NULL, NULL, NULL, NULL, NULL, 4),
(19062, NULL, 'G3DSA:1.20.5.1200:FF:000005', NULL, NULL, 'Alpha-tocopherol transfer protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(19063, NULL, 'G3DSA:2.120.10.30:FF:000344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19064, NULL, 'G3DSA:2.40.160.10:FF:000072', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(19065, NULL, 'G3DSA:3.40.50.2000:FF:000515', NULL, NULL, 'Glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(19066, NULL, 'G3DSA:1.20.5.1160:FF:000027', NULL, NULL, 'Lamin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(19067, NULL, 'G3DSA:3.40.50.1440:FF:000100', NULL, NULL, 'Iota_tubulin,putative', NULL, NULL, NULL, NULL, NULL, 4),
(19068, NULL, 'G3DSA:3.30.160.60:FF:002698', NULL, NULL, 'Zinc finger protein 985', NULL, NULL, NULL, NULL, NULL, 4),
(19069, NULL, 'G3DSA:3.30.160.60:FF:003159', NULL, NULL, 'FI06716p', NULL, NULL, NULL, NULL, NULL, 4),
(19070, NULL, 'G3DSA:3.80.10.10:FF:001529', NULL, NULL, 'Slit guidance ligand 1', NULL, NULL, NULL, NULL, NULL, 4),
(19071, NULL, 'G3DSA:1.20.1250.20:FF:000504', NULL, NULL, 'Similar to MFS multidrug transporter', NULL, NULL, NULL, NULL, NULL, 4),
(19072, NULL, 'G3DSA:3.30.465.10:FF:000036', NULL, NULL, 'Putative FAD-linked oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(19073, NULL, 'G3DSA:1.20.1640.10:FF:000082', NULL, NULL, 'Protein patched', NULL, NULL, NULL, NULL, NULL, 4),
(19074, NULL, 'G3DSA:3.40.630.10:FF:000227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19075, NULL, 'G3DSA:1.20.1740.10:FF:000090', NULL, NULL, 'Solute carrier family 12 member 7', NULL, NULL, NULL, NULL, NULL, 4),
(19076, NULL, 'G3DSA:2.130.10.10:FF:000956', NULL, NULL, 'CPSF (Cleavage and polyadenylation specific factor)', NULL, NULL, NULL, NULL, NULL, 4),
(19077, NULL, 'G3DSA:2.130.10.10:FF:004267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19078, NULL, 'G3DSA:3.90.1140.10:FF:000037', NULL, NULL, 'DUF455 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(19079, NULL, 'G3DSA:1.10.565.10:FF:000039', NULL, NULL, 'Nuclear receptor subfamily 1, group D, member 4b', NULL, NULL, NULL, NULL, NULL, 4),
(19080, NULL, 'G3DSA:2.60.200.20:FF:000124', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19081, NULL, 'G3DSA:3.30.230.130:FF:000043', NULL, NULL, 'Cullin-4', NULL, NULL, NULL, NULL, NULL, 4),
(19082, NULL, 'G3DSA:3.90.550.10:FF:000209', NULL, NULL, 'Unplaced genomic scaffold supercont1.20, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(19083, NULL, 'G3DSA:3.30.1010.10:FF:000025', NULL, NULL, 'PIKK family atypical protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(19084, NULL, 'G3DSA:3.30.200.20:FF:001577', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19085, NULL, 'G3DSA:1.10.287.70:FF:000551', NULL, NULL, 'Probable cyclic nucleotide-gated ion channel 12', NULL, NULL, NULL, NULL, NULL, 4),
(19086, NULL, 'G3DSA:3.40.50.300:FF:002468', NULL, NULL, 'Suppressor of ascus dominance 3', NULL, NULL, NULL, NULL, NULL, 4),
(19087, NULL, 'G3DSA:2.130.10.10:FF:005784', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(19088, NULL, 'G3DSA:3.90.660.10:FF:000089', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19089, NULL, 'G3DSA:3.30.60.60:FF:000015', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(19090, NULL, 'G3DSA:3.30.710.10:FF:000438', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19091, NULL, 'G3DSA:1.10.510.10:FF:003886', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19092, NULL, 'G3DSA:1.10.150.20:FF:000303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19093, NULL, 'G3DSA:3.40.109.10:FF:000050', NULL, NULL, 'Nitroreductase NfnB', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(19094, NULL, 'G3DSA:1.25.40.10:FF:001129', NULL, NULL, 'RNA polymerase-associated protein CTR9, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19095, NULL, 'G3DSA:1.10.12.10:FF:000002', NULL, NULL, '1,4-dihydroxy-2-naphthoyl-CoA synthase', NULL, NULL, NULL, NULL, NULL, 4),
(19096, NULL, 'G3DSA:3.30.1330.10:FF:000009', NULL, NULL, 'Probable phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(19097, NULL, 'G3DSA:3.30.70.1450:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19098, NULL, 'G3DSA:1.10.10.10:FF:001060', NULL, NULL, 'Cullin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(19099, NULL, 'G3DSA:2.30.42.10:FF:000219', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(19100, NULL, 'G3DSA:3.30.70.330:FF:001713', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19101, NULL, 'G3DSA:3.20.20.140:FF:000485', NULL, NULL, '2-amino-3-carboxymuconate-6-semialdehyde decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(19102, NULL, 'G3DSA:3.30.870.10:FF:000034', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(19103, NULL, 'G3DSA:1.10.510.10:FF:004050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19104, NULL, 'G3DSA:3.40.50.620:FF:000653', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(19105, NULL, 'G3DSA:3.50.50.60:FF:000986', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(19106, NULL, 'G3DSA:2.130.10.10:FF:001338', NULL, NULL, 'U3 small nucleolar RNA-associated protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(19107, NULL, 'G3DSA:3.40.50.720:FF:000857', NULL, NULL, 'Ubiquitin-activating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(19108, NULL, 'G3DSA:3.30.70.330:FF:001769', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19109, NULL, 'G3DSA:3.30.160.60:FF:006065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19110, NULL, 'G3DSA:1.25.40.10:FF:004906', NULL, NULL, 'Putative pentatricopeptide repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(19111, NULL, 'G3DSA:1.20.200.10:FF:000033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(19112, NULL, 'G3DSA:3.40.50.1440:FF:000044', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(19113, NULL, 'G3DSA:3.30.70.1660:FF:000005', NULL, NULL, 'Peptide chain release factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(19114, NULL, 'G3DSA:3.30.70.330:FF:002169', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19115, NULL, 'G3DSA:1.10.12.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19116, NULL, 'G3DSA:3.40.50.300:FF:002417', NULL, NULL, 'Methyl coenzyme M reductase system component A2', NULL, NULL, NULL, NULL, NULL, 4),
(19117, NULL, 'G3DSA:1.20.1420.30:FF:000049', NULL, NULL, 'Ca(2+)/H(+) antiporter', NULL, NULL, NULL, NULL, NULL, 4),
(19118, NULL, 'G3DSA:2.40.50.180:FF:000019', NULL, NULL, 'Scaffold protein CheW associated with MCPs of class 44H', NULL, NULL, NULL, NULL, NULL, 4),
(19119, NULL, 'G3DSA:2.160.20.10:FF:000011', NULL, NULL, 'F-box only protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(19120, NULL, 'G3DSA:3.20.20.100:FF:000108', NULL, NULL, 'Chromosome 21, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(19121, NULL, 'G3DSA:1.25.40.10:FF:004007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19122, NULL, 'G3DSA:3.80.10.10:FF:003093', NULL, NULL, 'Lipid-anchored plasma membrane glycoprotein 130', NULL, NULL, NULL, NULL, NULL, 4),
(19123, NULL, 'G3DSA:3.30.70.920:FF:000002', NULL, NULL, 'Transcriptional regulator AsnC', NULL, NULL, NULL, NULL, NULL, 4),
(19124, NULL, 'G3DSA:1.20.1090.10:FF:000028', NULL, NULL, 'Iron-containing alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(19125, NULL, 'G3DSA:3.80.10.10:FF:002878', NULL, NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase At5g58150', NULL, NULL, NULL, NULL, NULL, 4),
(19126, NULL, 'G3DSA:3.40.50.1000:FF:000884', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(19127, NULL, 'G3DSA:3.30.160.60:FF:000793', NULL, NULL, 'C2H2 finger domain protein FlbC', NULL, NULL, NULL, NULL, NULL, 4),
(19128, NULL, 'G3DSA:1.10.10.60:FF:000990', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19129, NULL, 'G3DSA:3.30.1140.32:FF:000003', NULL, NULL, '30S ribosomal protein S3, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(19130, NULL, 'G3DSA:3.40.50.720:FF:002370', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19131, NULL, 'G3DSA:1.20.1280.50:FF:000223', NULL, NULL, 'Putative F-box/LRR-repeat protein At5g25860', NULL, NULL, NULL, NULL, NULL, 4),
(19132, NULL, 'G3DSA:3.40.50.1820:FF:000006', NULL, NULL, 'NDRG family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(19133, NULL, 'G3DSA:1.10.150.110:FF:000036', NULL, NULL, 'Polymerase (DNA directed), mu', NULL, NULL, NULL, NULL, NULL, 4),
(19134, NULL, 'G3DSA:3.40.350.10:FF:000077', NULL, NULL, 'Dimethlysulfonioproprionate lyase DddP', NULL, NULL, NULL, NULL, NULL, 4),
(19135, NULL, 'G3DSA:3.40.630.10:FF:000059', NULL, NULL, 'Glutamate carboxypeptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(19136, NULL, 'G3DSA:3.20.20.80:FF:000328', NULL, NULL, 'Hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(19137, NULL, 'G3DSA:3.90.660.10:FF:000033', NULL, NULL, 'Protein anon-37Cs', NULL, NULL, NULL, NULL, NULL, 4),
(19138, NULL, 'G3DSA:1.20.5.170:FF:000041', NULL, NULL, 'Cyclic AMP-dependent transcription factor ATF-6 beta', NULL, NULL, NULL, NULL, NULL, 4),
(19139, NULL, 'G3DSA:1.20.1250.20:FF:002365', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19140, NULL, 'G3DSA:3.40.50.300:FF:008252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19141, NULL, 'G3DSA:3.10.20.70:FF:000028', NULL, NULL, 'Glutamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(19142, NULL, 'G3DSA:2.10.50.10:FF:000104', NULL, NULL, 'TvbS1', NULL, NULL, NULL, NULL, NULL, 4),
(19143, NULL, 'G3DSA:3.75.10.10:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19144, NULL, 'G3DSA:1.20.120.1320:FF:000004', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(19145, NULL, 'G3DSA:3.30.160.60:FF:005576', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19146, NULL, 'G3DSA:1.10.3210.10:FF:000030', NULL, NULL, 'Deoxynucleoside triphosphate triphosphohydrolase SAMHD1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(19147, NULL, 'G3DSA:3.40.50.300:FF:005341', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(19148, NULL, 'G3DSA:1.20.58.60:FF:000291', NULL, NULL, 'Dystonin', NULL, NULL, NULL, NULL, NULL, 4),
(19149, NULL, 'G3DSA:3.30.70.270:FF:000324', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19150, NULL, 'G3DSA:3.30.505.10:FF:000203', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19151, NULL, 'G3DSA:2.60.40.10:FF:005975', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19152, NULL, 'G3DSA:3.30.300.210:FF:000005', NULL, NULL, 'Spore germination protein GerLC', NULL, NULL, NULL, NULL, NULL, 4),
(19153, NULL, 'G3DSA:3.40.50.2030:FF:000002', NULL, NULL, 'Hydroxylamine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(19154, NULL, 'G3DSA:3.30.70.1230:FF:000169', NULL, NULL, 'Adenylyl cyclase class-3/4/guanylyl cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(19155, NULL, 'G3DSA:2.60.40.3500:FF:000006', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase AmiC', NULL, NULL, NULL, NULL, NULL, 4),
(19156, NULL, 'G3DSA:2.60.200.20:FF:000175', NULL, NULL, 'Kinesin family member 16B', NULL, NULL, NULL, NULL, NULL, 4),
(19157, NULL, 'G3DSA:3.40.30.20:FF:000001', NULL, NULL, '3-hydroxybenzoate 4-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(19158, NULL, 'G3DSA:3.30.465.10:FF:000087', NULL, NULL, 'Alkyl-dihydroxyacetone phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(19159, NULL, 'G3DSA:3.40.50.150:FF:001389', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19160, NULL, 'G3DSA:3.90.180.10:FF:000007', NULL, NULL, 'Alcohol dehydrogenase 6', NULL, NULL, NULL, NULL, NULL, 4),
(19161, NULL, 'G3DSA:3.40.50.300:FF:006627', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(19162, NULL, 'G3DSA:3.30.63.20:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19163, NULL, 'G3DSA:2.40.50.140:FF:001255', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19164, NULL, 'G3DSA:2.60.40.1520:FF:000002', NULL, NULL, 'Larval serum protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(19165, NULL, 'G3DSA:3.80.10.10:FF:003042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19166, NULL, 'G3DSA:3.30.40.10:FF:002287', NULL, NULL, 'Ring finger protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(19167, NULL, 'G3DSA:1.20.1250.20:FF:001016', NULL, NULL, 'Solute carrier family 16 member 2', NULL, NULL, NULL, NULL, NULL, 4),
(19168, NULL, 'G3DSA:1.20.1050.10:FF:000138', NULL, NULL, 'Glutathione S-transferase like protein', NULL, NULL, NULL, NULL, NULL, 4),
(19169, NULL, 'G3DSA:1.10.10.10:FF:001745', NULL, NULL, 'Vacuolar-sorting protein SNF8', NULL, NULL, NULL, NULL, NULL, 4),
(19170, NULL, 'G3DSA:3.60.10.10:FF:000390', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(19171, NULL, 'G3DSA:3.80.10.10:FF:001417', NULL, NULL, 'Flagellar Member 4', NULL, NULL, NULL, NULL, NULL, 4),
(19172, NULL, 'G3DSA:1.10.287.130:FF:000131', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(19173, NULL, 'G3DSA:3.40.50.300:FF:000670', NULL, NULL, 'Putative ATP-dependent RNA helicase DHX36', NULL, NULL, NULL, NULL, NULL, 4),
(19174, NULL, 'G3DSA:3.10.180.10:FF:000053', NULL, NULL, 'Lactoylglutathione lyase', NULL, NULL, NULL, NULL, NULL, 4),
(19175, NULL, 'G3DSA:2.60.120.260:FF:000091', NULL, NULL, 'DUF642 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(19176, NULL, 'G3DSA:3.40.50.1010:FF:000269', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19177, NULL, 'G3DSA:3.80.10.10:FF:000220', NULL, NULL, 'Adenylate cyclase AcyA', NULL, NULL, NULL, NULL, NULL, 4),
(19178, NULL, 'G3DSA:3.40.1280.10:FF:000065', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4),
(19179, NULL, 'G3DSA:3.40.50.300:FF:002356', NULL, NULL, 'U3 small nucleolar RNA-associated protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(19180, NULL, 'G3DSA:2.130.10.10:FF:005672', NULL, NULL, 'Eukaryotic initiation factor', NULL, NULL, NULL, NULL, NULL, 4),
(19181, NULL, 'G3DSA:3.40.1260.20:FF:000004', NULL, NULL, 'Ribonuclease G', NULL, NULL, NULL, NULL, NULL, 4),
(19182, NULL, 'G3DSA:3.90.740.10:FF:000039', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(19183, NULL, 'G3DSA:3.40.50.300:FF:004834', NULL, NULL, 'Mitochondrial Rho GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(19184, NULL, 'G3DSA:1.20.58.70:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19185, NULL, 'G3DSA:3.90.70.10:FF:000476', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19186, NULL, 'G3DSA:3.10.110.10:FF:000279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19187, NULL, 'G3DSA:2.40.100.10:FF:000068', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase D', NULL, NULL, NULL, NULL, NULL, 4),
(19188, NULL, 'G3DSA:3.30.750.24:FF:000033', NULL, NULL, 'STAS domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(19189, NULL, 'G3DSA:2.130.10.10:FF:000164', NULL, NULL, 'Kinesin family member 21A', NULL, NULL, NULL, NULL, NULL, 4),
(19190, NULL, 'G3DSA:3.40.50.10470:FF:000037', NULL, NULL, 'Eukaryotic translation initiation factor 2B, subunit 2 beta', NULL, NULL, NULL, NULL, NULL, 4),
(19191, NULL, 'G3DSA:3.10.110.10:FF:000335', NULL, NULL, 'Ubiquitin-conjugating enzyme 15', NULL, NULL, NULL, NULL, NULL, 4),
(19192, NULL, 'G3DSA:2.60.40.420:FF:000080', NULL, NULL, 'Cation transporter E1-E2 family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(19193, NULL, 'G3DSA:3.30.70.330:FF:000483', NULL, NULL, 'Cytoplasmic polyadenylation element-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(19194, NULL, 'G3DSA:3.40.50.12110:FF:000001', NULL, NULL, 'Spore photoproduct lyase', NULL, NULL, NULL, NULL, NULL, 4),
(19195, NULL, 'G3DSA:3.10.580.10:FF:000033', NULL, NULL, 'Nuclear protein SNF4', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(19196, NULL, 'G3DSA:3.30.2310.20:FF:000017', NULL, NULL, 'Toxin-antitoxin system toxin component RelE family', NULL, NULL, NULL, NULL, NULL, 4),
(19197, NULL, 'G3DSA:3.30.559.10:FF:000035', NULL, NULL, 'Phenolic glucoside malonyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(19198, NULL, 'G3DSA:3.90.70.10:FF:000768', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19199, NULL, 'G3DSA:3.40.50.12580:FF:000001', NULL, NULL, 'Glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(19200, NULL, 'G3DSA:3.80.10.10:FF:004458', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(19201, NULL, 'G3DSA:1.10.510.10:FF:002470', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19202, NULL, 'G3DSA:1.10.3470.10:FF:000060', NULL, NULL, 'Iron ABC transporter, permease', NULL, NULL, NULL, NULL, NULL, 4),
(19203, NULL, 'G3DSA:2.40.100.10:FF:000124', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase CYP95 isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(19204, NULL, 'G3DSA:1.10.1670.10:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19205, NULL, 'G3DSA:1.10.10.2330:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19206, NULL, 'G3DSA:3.30.2160.10:FF:000075', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(19207, NULL, 'G3DSA:1.20.1540.10:FF:000046', NULL, NULL, 'Rhomboid family protein', NULL, NULL, NULL, NULL, NULL, 4),
(19208, NULL, 'G3DSA:2.60.40.60:FF:000335', NULL, NULL, 'CaDHerin family', NULL, NULL, NULL, NULL, NULL, 4),
(19209, NULL, 'G3DSA:3.60.21.50:FF:000016', NULL, NULL, 'Novel protein similar to human DNA directed polymerase delta 2, regulatory subunit (50kD) (POLD2)', NULL, NULL, NULL, NULL, NULL, 4),
(19210, NULL, 'G3DSA:1.20.1080.10:FF:000022', NULL, NULL, 'MIP aquaporin', NULL, NULL, NULL, NULL, NULL, 4),
(19211, NULL, 'G3DSA:2.10.50.10:FF:000099', NULL, NULL, 'Zgc:163064 protein', NULL, NULL, NULL, NULL, NULL, 4),
(19212, NULL, 'G3DSA:3.30.420.40:FF:000262', NULL, NULL, 'Heat shock protein 110, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19213, NULL, 'G3DSA:3.40.50.300:FF:000563', NULL, NULL, 'Guanine nucleotide-binding protein alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(19214, NULL, 'G3DSA:3.90.79.10:FF:000075', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(19215, NULL, 'G3DSA:3.90.70.10:FF:000824', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(19216, NULL, 'G3DSA:3.90.930.12:FF:000005', NULL, NULL, '60S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(19217, NULL, 'G3DSA:3.40.50.720:FF:002307', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19218, NULL, 'G3DSA:3.90.79.10:FF:000131', NULL, NULL, 'MutT/nudix family protein', NULL, NULL, NULL, NULL, NULL, 4),
(19219, NULL, 'G3DSA:3.60.40.10:FF:000234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19220, NULL, 'G3DSA:1.10.220.150:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19221, NULL, 'G3DSA:3.40.50.2030:FF:000007', NULL, NULL, 'Hydroxylamine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(19222, NULL, 'G3DSA:2.60.40.60:FF:000279', NULL, NULL, 'Protocadherin-16, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19223, NULL, 'G3DSA:3.30.110.10:FF:000016', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(19224, NULL, 'G3DSA:3.30.40.10:FF:002051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19225, NULL, 'G3DSA:2.10.25.10:FF:001136', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(19226, NULL, 'G3DSA:1.10.230.10:FF:000026', NULL, NULL, 'Citrate synthase-related protein DDB_G0287281', NULL, NULL, NULL, NULL, NULL, 4),
(19227, NULL, 'G3DSA:2.40.50.100:FF:000074', NULL, NULL, 'Glycine cleavage system H protein', NULL, NULL, NULL, NULL, NULL, 4),
(19228, NULL, 'G3DSA:3.30.870.10:FF:000039', NULL, NULL, 'Probable tyrosyl-DNA phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(19229, NULL, 'G3DSA:3.90.190.10:FF:000165', NULL, NULL, 'Formin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(19230, NULL, 'G3DSA:1.10.8.270:FF:000039', NULL, NULL, 'Cell division control protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(19231, NULL, 'G3DSA:3.30.519.10:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19232, NULL, 'G3DSA:3.30.200.160:FF:000001', NULL, NULL, 'General transcription factor IIIC subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(19233, NULL, 'G3DSA:3.40.50.150:FF:000933', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19234, NULL, 'G3DSA:3.40.50.1970:FF:000028', NULL, NULL, 'Iron-containing alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(19235, NULL, 'G3DSA:3.30.40.10:FF:002343', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(19236, NULL, 'G3DSA:2.60.40.10:FF:004519', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19237, NULL, 'G3DSA:3.40.190.10:FF:000075', NULL, NULL, 'glutamate receptor ionotropic, kainate 4', NULL, NULL, NULL, NULL, NULL, 4),
(19238, NULL, 'G3DSA:2.170.300.10:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19239, NULL, 'G3DSA:1.10.400.10:FF:000011', NULL, NULL, 'Guanine nucleotide-binding protein alpha-1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(19240, NULL, 'G3DSA:1.20.120.420:FF:000019', NULL, NULL, 'Translation initiation factor eIF-2B subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(19241, NULL, 'G3DSA:4.10.60.10:FF:000140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19242, NULL, 'G3DSA:3.80.10.10:FF:002081', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(19243, NULL, 'G3DSA:1.25.10.10:FF:001976', NULL, NULL, 'SNF2 superfamily chromatin remodeling protein', NULL, NULL, NULL, NULL, NULL, 4),
(19244, NULL, 'G3DSA:1.10.510.10:FF:000924', NULL, NULL, 'Cell division protein kinase (Ctk1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(19245, NULL, 'G3DSA:1.20.1290.10:FF:000009', NULL, NULL, 'Alkyl hydroperoxide reductase AhpD', NULL, NULL, NULL, NULL, NULL, 4),
(19246, NULL, 'G3DSA:3.30.420.10:FF:000686', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19247, NULL, 'G3DSA:3.90.1150.10:FF:000381', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19248, NULL, 'G3DSA:3.40.30.10:FF:000515', NULL, NULL, 'Peroxiredoxin (Alkyl hydroperoxide reductase subunit C)', NULL, NULL, NULL, NULL, NULL, 4),
(19249, NULL, 'G3DSA:2.60.200.60:FF:000001', NULL, NULL, 'Putative phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(19250, NULL, 'G3DSA:3.30.70.270:FF:000329', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19251, NULL, 'G3DSA:3.40.630.170:FF:000008', NULL, NULL, 'Glycylpeptide N-tetradecanoyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(19252, NULL, 'G3DSA:2.60.40.60:FF:000386', NULL, NULL, 'Protocadherin 12', NULL, NULL, NULL, NULL, NULL, 4),
(19253, NULL, 'G3DSA:3.40.50.300:FF:002412', NULL, NULL, 'Predicted kinase', NULL, NULL, NULL, NULL, NULL, 4),
(19254, NULL, 'G3DSA:3.10.129.10:FF:000092', NULL, NULL, 'Putative 4-hydroxybenzoyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(19255, NULL, 'G3DSA:2.70.150.10:FF:000036', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(19256, NULL, 'G3DSA:3.30.70.80:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19257, NULL, 'G3DSA:3.40.50.880:FF:000129', NULL, NULL, 'Protein DJ-1-like C isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(19258, NULL, 'G3DSA:1.20.144.10:FF:000099', NULL, NULL, 'LOC100158576 protein', NULL, NULL, NULL, NULL, NULL, 4),
(19259, NULL, 'G3DSA:1.10.510.10:FF:004235', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19260, NULL, 'G3DSA:2.60.40.1220:FF:000007', NULL, NULL, 'Copper resistance domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(19261, NULL, 'G3DSA:3.40.50.720:FF:001346', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(19262, NULL, 'G3DSA:1.20.120.720:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(19263, NULL, 'G3DSA:3.40.50.11610:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19264, NULL, 'G3DSA:3.30.200.20:FF:000184', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(19265, NULL, 'G3DSA:1.20.58.60:FF:000695', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19266, NULL, 'G3DSA:2.20.100.10:FF:000050', NULL, NULL, 'Thrombospondin type 1 domain containing 7B', NULL, NULL, NULL, NULL, NULL, 4),
(19267, NULL, 'G3DSA:3.40.30.10:FF:001072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19268, NULL, 'G3DSA:3.40.50.150:FF:000585', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase G', NULL, NULL, NULL, NULL, NULL, 4),
(19269, NULL, 'G3DSA:1.20.58.760:FF:000009', NULL, NULL, 'Translation initiation factor 3 subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(19270, NULL, 'G3DSA:1.25.10.10:FF:001420', NULL, NULL, 'HEAT repeat protein (DRIM), putative', NULL, NULL, NULL, NULL, NULL, 4),
(19271, NULL, 'G3DSA:1.10.472.10:FF:000008', NULL, NULL, 'Transcription initiation factor IIB', NULL, NULL, NULL, NULL, NULL, 4),
(19272, NULL, 'G3DSA:2.40.128.180:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19273, NULL, 'G3DSA:1.20.870.10:FF:000049', NULL, NULL, 'Ras guanine nucleotide exchange factor E', NULL, NULL, NULL, NULL, NULL, 4),
(19274, NULL, 'G3DSA:1.10.472.10:FF:000683', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19275, NULL, 'G3DSA:1.20.58.480:FF:000015', NULL, NULL, 'Indoleamine 2,3-dioxygenase beta type', NULL, NULL, NULL, NULL, NULL, 4),
(19276, NULL, 'G3DSA:2.130.10.10:FF:003255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19277, NULL, 'G3DSA:3.40.50.11720:FF:000002', NULL, NULL, '3-deoxy-D-manno-octulosonic acid transferase', NULL, NULL, NULL, NULL, NULL, 4),
(19278, NULL, 'G3DSA:3.40.190.10:FF:000182', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(19279, NULL, 'G3DSA:2.60.40.10:FF:003558', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19280, NULL, 'G3DSA:1.20.1540.10:FF:000102', NULL, NULL, 'Rhomboid family protein', NULL, NULL, NULL, NULL, NULL, 4),
(19281, NULL, 'G3DSA:2.130.10.10:FF:000849', NULL, NULL, 'WD repeat-containing protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(19282, NULL, 'G3DSA:3.30.390.10:FF:000008', NULL, NULL, 'L-talarate/galactarate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(19283, NULL, 'G3DSA:1.10.287.1010:FF:000003', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(19284, NULL, 'G3DSA:2.30.42.10:FF:000214', NULL, NULL, 'Discs large MAGUK scaffold protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(19285, NULL, 'G3DSA:1.10.10.60:FF:000945', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19286, NULL, 'G3DSA:3.10.180.10:FF:000008', NULL, NULL, '4-hydroxyphenylpyruvate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(19287, NULL, 'G3DSA:3.30.2350.20:FF:000019', NULL, NULL, 'U2 snRNA/tRNA pseudouridine synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19288, NULL, 'G3DSA:1.10.10.60:FF:000838', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19289, NULL, 'G3DSA:2.130.10.10:FF:003867', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 16', NULL, NULL, NULL, NULL, NULL, 4),
(19290, NULL, 'G3DSA:1.25.10.10:FF:001072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19291, NULL, 'G3DSA:1.20.120.980:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19292, NULL, 'G3DSA:3.30.200.20:FF:000583', NULL, NULL, 'Polo', NULL, NULL, NULL, NULL, NULL, 4),
(19293, NULL, 'G3DSA:1.10.8.100:FF:000034', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(19294, NULL, 'G3DSA:1.20.140.90:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19295, NULL, 'G3DSA:2.30.30.40:FF:000482', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19296, NULL, 'G3DSA:1.10.20.10:FF:000262', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(19297, NULL, 'G3DSA:1.10.8.140:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19298, NULL, 'G3DSA:3.30.420.40:FF:000841', NULL, NULL, 'Actin-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(19299, NULL, 'G3DSA:1.20.900.10:FF:000103', NULL, NULL, 'Meiotically up-regulated gene 10 protein', NULL, NULL, NULL, NULL, NULL, 4),
(19300, NULL, 'G3DSA:3.10.20.30:FF:000090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19301, NULL, 'G3DSA:3.40.50.300:FF:008196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19302, NULL, 'G3DSA:2.70.150.10:FF:000087', NULL, NULL, 'Phospholipid-transporting P-type ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19303, NULL, 'G3DSA:2.60.40.10:FF:003159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19304, NULL, 'G3DSA:1.20.1420.30:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19305, NULL, 'G3DSA:3.30.420.110:FF:000075', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(19306, NULL, 'G3DSA:1.10.285.10:FF:000006', NULL, NULL, 'NADP-specific glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(19307, NULL, 'G3DSA:1.10.1370.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19308, NULL, 'G3DSA:2.60.40.10:FF:000629', NULL, NULL, 'Titin b', NULL, NULL, NULL, NULL, NULL, 4),
(19309, NULL, 'G3DSA:3.20.20.140:FF:000081', NULL, NULL, 'RNase MRP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(19310, NULL, 'G3DSA:3.50.50.60:FF:000019', NULL, NULL, 'Alkyl hydroperoxide reductase subunit F', NULL, NULL, NULL, NULL, NULL, 4),
(19311, NULL, 'G3DSA:1.20.1250.20:FF:001853', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19312, NULL, 'G3DSA:3.90.1150.10:FF:000229', NULL, NULL, 'Aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(19313, NULL, 'G3DSA:2.60.40.10:FF:004620', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19314, NULL, 'G3DSA:2.30.30.140:FF:000247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19315, NULL, 'G3DSA:3.50.50.60:FF:000694', NULL, NULL, 'Thiol-specific monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19316, NULL, 'G3DSA:3.40.50.150:FF:000080', NULL, NULL, 'tRNA U34 carboxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(19317, NULL, 'G3DSA:1.20.1250.20:FF:002073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19318, NULL, 'G3DSA:1.10.150.20:FF:000247', NULL, NULL, 'DNA polymerase theta', NULL, NULL, NULL, NULL, NULL, 4),
(19319, NULL, 'G3DSA:3.40.50.300:FF:008544', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(19320, NULL, 'G3DSA:3.60.15.10:FF:000142', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(19321, NULL, 'G3DSA:3.30.70.330:FF:002337', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19322, NULL, 'G3DSA:3.30.200.20:FF:002033', NULL, NULL, 'AGAP004112-PA', NULL, NULL, NULL, NULL, NULL, 4),
(19323, NULL, 'G3DSA:1.10.10.350:FF:000005', NULL, NULL, 'Glutamate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(19324, NULL, 'G3DSA:1.20.1110.10:FF:000233', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(19325, NULL, 'G3DSA:2.20.25.190:FF:000001', NULL, NULL, 'Transcription elongation factor 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(19326, NULL, 'G3DSA:2.60.40.1660:FF:000027', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(19327, NULL, 'G3DSA:1.10.510.10:FF:002318', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19328, NULL, 'G3DSA:3.40.50.720:FF:000913', NULL, NULL, 'UDP-glucose 4-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(19329, NULL, 'G3DSA:1.10.1070.11:FF:000013', NULL, NULL, 'Phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(19330, NULL, 'G3DSA:1.10.8.720:FF:000045', NULL, NULL, 'Putative dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(19331, NULL, 'G3DSA:2.130.10.10:FF:000905', NULL, NULL, 'Unplaced genomic scaffold supercont1.13, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(19332, NULL, 'G3DSA:1.20.5.4090:FF:000001', NULL, NULL, 'leucine-rich repeat flightless-interacting protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(19333, NULL, 'G3DSA:1.10.150.50:FF:000138', NULL, NULL, 'E74-like factor 3 (ets domain transcription factor, epithelial-specific )', NULL, NULL, NULL, NULL, NULL, 4),
(19334, NULL, 'G3DSA:1.20.5.110:FF:000006', NULL, NULL, 'Syntaxin 6', NULL, NULL, NULL, NULL, NULL, 4),
(19335, NULL, 'G3DSA:3.40.50.10810:FF:000061', NULL, NULL, 'DNA repair protein rhp16', NULL, NULL, NULL, NULL, NULL, 4),
(19336, NULL, 'G3DSA:1.25.40.10:FF:002641', NULL, NULL, 'Membrane anchored protein with DUF2133 domain', NULL, NULL, NULL, NULL, NULL, 4),
(19337, NULL, 'G3DSA:3.40.1280.10:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19338, NULL, 'G3DSA:1.10.530.10:FF:000015', NULL, NULL, 'Resuscitation-promoting factor RpfB', NULL, NULL, NULL, NULL, NULL, 4),
(19339, NULL, 'G3DSA:1.10.555.10:FF:000218', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19340, NULL, 'G3DSA:2.20.110.10:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19341, NULL, 'G3DSA:2.120.10.80:FF:000050', NULL, NULL, 'Putative LOV domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(19342, NULL, 'G3DSA:3.30.70.240:FF:000045', NULL, NULL, 'U5 snRNP GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(19343, NULL, 'G3DSA:2.60.40.10:FF:003507', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19344, NULL, 'G3DSA:3.40.190.10:FF:000654', NULL, NULL, 'Peptide ABC transporter, periplasmic peptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(19345, NULL, 'G3DSA:1.25.40.180:FF:000006', NULL, NULL, 'Basic leucine zipper and W2 domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(19346, NULL, 'G3DSA:2.130.10.10:FF:005380', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19347, NULL, 'G3DSA:2.10.25.10:FF:001659', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19348, NULL, 'G3DSA:3.40.50.300:FF:004885', NULL, NULL, 'General secretion pathway protein E', NULL, NULL, NULL, NULL, NULL, 4),
(19349, NULL, 'G3DSA:3.90.660.10:FF:000038', NULL, NULL, 'Polyamine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(19350, NULL, 'G3DSA:3.40.50.300:FF:001052', NULL, NULL, 'Probable transmembrane GTPase FZO-like, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(19351, NULL, 'G3DSA:3.50.7.10:FF:000086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19352, NULL, 'G3DSA:3.80.10.10:FF:002873', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19353, NULL, 'G3DSA:1.20.1070.10:FF:002090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19354, NULL, 'G3DSA:3.30.565.10:FF:000544', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(19355, NULL, 'G3DSA:1.20.1070.10:FF:001538', NULL, NULL, 'D(1A) dopamine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(19356, NULL, 'G3DSA:2.10.25.10:FF:000647', NULL, NULL, 'neurogenic locus notch homolog protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(19357, NULL, 'G3DSA:3.30.450.40:FF:000090', NULL, NULL, 'Putative transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(19358, NULL, 'G3DSA:3.30.40.10:FF:002394', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19359, NULL, 'G3DSA:1.20.1250.20:FF:001308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19360, NULL, 'G3DSA:1.10.150.50:FF:000189', NULL, NULL, 'Caskin-1', NULL, NULL, NULL, NULL, NULL, 4),
(19361, NULL, 'G3DSA:1.10.10.60:FF:000153', NULL, NULL, 'HTH-type transcriptional regulator EutR', NULL, NULL, NULL, NULL, NULL, 4),
(19362, NULL, 'G3DSA:3.30.160.60:FF:005632', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19363, NULL, 'G3DSA:1.10.555.10:FF:000269', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19364, NULL, 'G3DSA:3.40.50.150:FF:000641', NULL, NULL, 'Putative tRNA m5C-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(19365, NULL, 'G3DSA:3.40.190.10:FF:000131', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(19366, NULL, 'G3DSA:1.10.510.10:FF:001144', NULL, NULL, 'CMGC protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(19367, NULL, 'G3DSA:3.40.50.170:FF:000035', NULL, NULL, 'Methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(19368, NULL, 'G3DSA:3.90.190.10:FF:000221', NULL, NULL, 'Dual specificity phosphatase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(19369, NULL, 'G3DSA:3.40.50.150:FF:001041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19370, NULL, 'G3DSA:2.40.33.10:FF:000035', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(19371, NULL, 'G3DSA:1.10.510.10:FF:004055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19372, NULL, 'G3DSA:1.25.40.10:FF:002242', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(19373, NULL, 'G3DSA:3.40.50.620:FF:000597', NULL, NULL, 'Tryptophan--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(19374, NULL, 'G3DSA:3.30.160.60:FF:000961', NULL, NULL, 'Spalt like transcription factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(19375, NULL, 'G3DSA:1.25.40.10:FF:001753', NULL, NULL, 'GM24661', NULL, NULL, NULL, NULL, NULL, 4),
(19376, NULL, 'G3DSA:3.40.50.300:FF:000962', NULL, NULL, 'digestive organ expansion factor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(19377, NULL, 'G3DSA:3.40.50.300:FF:004273', NULL, NULL, 'Prosalusin', NULL, NULL, NULL, NULL, NULL, 4),
(19378, NULL, 'G3DSA:2.60.40.10:FF:004671', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19379, NULL, 'G3DSA:3.30.160.60:FF:004272', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19380, NULL, 'G3DSA:2.60.40.10:FF:005071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19381, NULL, 'G3DSA:1.10.510.10:FF:000868', NULL, NULL, 'Myosin light chain kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19382, NULL, 'G3DSA:1.20.120.720:FF:000014', NULL, NULL, 'Unconventional myosin-X', NULL, NULL, NULL, NULL, NULL, 4),
(19383, NULL, 'G3DSA:3.90.70.10:FF:000083', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(19384, NULL, 'G3DSA:3.30.70.370:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19385, NULL, 'G3DSA:3.40.1110.10:FF:000463', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19386, NULL, 'G3DSA:3.40.50.2300:FF:001628', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19387, NULL, 'G3DSA:3.40.190.10:FF:000867', NULL, NULL, 'Mutant transferrin', NULL, NULL, NULL, NULL, NULL, 4),
(19388, NULL, 'G3DSA:2.60.40.60:FF:000858', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19389, NULL, 'G3DSA:1.10.510.10:FF:003779', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19390, NULL, 'G3DSA:2.40.20.10:FF:000079', NULL, NULL, 'Plasminogen activator, urokinase a', NULL, NULL, NULL, NULL, NULL, 4),
(19391, NULL, 'G3DSA:3.30.160.60:FF:001361', NULL, NULL, 'Zinc finger protein 585A', NULL, NULL, NULL, NULL, NULL, 4),
(19392, NULL, 'G3DSA:1.20.1540.10:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19393, NULL, 'G3DSA:3.50.50.60:FF:000082', NULL, NULL, 'protein MTO1 homolog, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(19394, NULL, 'G3DSA:2.10.90.10:FF:000045', NULL, NULL, 'DAN domain BMP antagonist family member 5', NULL, NULL, NULL, NULL, NULL, 4),
(19395, NULL, 'G3DSA:2.10.25.10:FF:001608', NULL, NULL, 'Putative WAK family receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(19396, NULL, 'G3DSA:1.20.1560.10:FF:000660', NULL, NULL, 'Os01g0534700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(19397, NULL, 'G3DSA:1.10.238.10:FF:000768', NULL, NULL, 'GM15947', NULL, NULL, NULL, NULL, NULL, 4),
(19398, NULL, 'G3DSA:1.10.533.10:FF:000089', NULL, NULL, 'E3 ubiquitin-protein ligase TTC3', NULL, NULL, NULL, NULL, NULL, 4),
(19399, NULL, 'G3DSA:3.40.50.1820:FF:000630', NULL, NULL, 'Coronamic acid synthetase, thioesterase component', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(19400, NULL, 'G3DSA:2.60.40.1180:FF:000181', NULL, NULL, 'Calpain-like cysteine peptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19401, NULL, 'G3DSA:3.40.1110.10:FF:000412', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19402, NULL, 'G3DSA:3.40.140.10:FF:000027', NULL, NULL, 'Sulfur carrier protein FdhD', NULL, NULL, NULL, NULL, NULL, 4),
(19403, NULL, 'G3DSA:3.40.225.10:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19404, NULL, 'G3DSA:1.25.40.10:FF:003838', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19405, NULL, 'G3DSA:3.40.50.1580:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19406, NULL, 'G3DSA:1.20.1070.10:FF:000701', NULL, NULL, 'Olfactory receptor family 10 subfamily J member 1', NULL, NULL, NULL, NULL, NULL, 4),
(19407, NULL, 'G3DSA:2.60.120.200:FF:000680', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19408, NULL, 'G3DSA:2.70.70.10:FF:000047', NULL, NULL, 'M23 family peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(19409, NULL, 'G3DSA:1.25.50.20:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19410, NULL, 'G3DSA:2.130.10.10:FF:004559', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19411, NULL, 'G3DSA:3.40.50.1820:FF:001175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19412, NULL, 'G3DSA:2.160.20.60:FF:000009', NULL, NULL, 'Ferredoxin-dependent glutamate synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(19413, NULL, 'G3DSA:3.30.450.20:FF:000168', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(19414, NULL, 'G3DSA:2.30.40.10:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19415, NULL, 'G3DSA:3.90.120.10:FF:000003', NULL, NULL, 'DNA (cytosine-5)-methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(19416, NULL, 'G3DSA:1.20.58.1380:FF:000008', NULL, NULL, 'YALI0A03883p', NULL, NULL, NULL, NULL, NULL, 4),
(19417, NULL, 'G3DSA:2.40.10.10:FF:000235', NULL, NULL, 'Atrial natriuretic peptide-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(19418, NULL, 'G3DSA:1.25.70.10:FF:000052', NULL, NULL, 'mTERF2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(19419, NULL, 'G3DSA:3.30.450.20:FF:000224', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(19420, NULL, 'G3DSA:3.40.50.12790:FF:000002', NULL, NULL, 'EscV/YscV/HrcV family type III secretion system export apparatus protein', NULL, NULL, NULL, NULL, NULL, 4),
(19421, NULL, 'G3DSA:3.90.1410.10:FF:000036', NULL, NULL, '[Ribulose-bisphosphate-carboxylase]-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(19422, NULL, 'G3DSA:3.40.50.150:FF:001333', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19423, NULL, 'G3DSA:2.60.120.330:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19424, NULL, 'G3DSA:3.40.50.300:FF:003429', NULL, NULL, 'Vacuolar ATP synthase catalytic subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(19425, NULL, 'G3DSA:3.30.60.30:FF:000147', NULL, NULL, 'Proteinase inhibitor PSKP-1', NULL, NULL, NULL, NULL, NULL, 4),
(19426, NULL, 'G3DSA:3.30.830.10:FF:000149', NULL, NULL, 'Insulinase family metalloprotease', NULL, NULL, NULL, NULL, NULL, 4),
(19427, NULL, 'G3DSA:3.40.50.2300:FF:000162', NULL, NULL, 'Receptor-type adenylate cyclase GRESAG 4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19428, NULL, 'G3DSA:3.30.160.60:FF:003608', NULL, NULL, 'Zinc finger and BTB domain-containing 32', NULL, NULL, NULL, NULL, NULL, 4),
(19429, NULL, 'G3DSA:3.90.190.20:FF:000050', NULL, NULL, 'FolC bifunctional protein', NULL, NULL, NULL, NULL, NULL, 4),
(19430, NULL, 'G3DSA:3.20.20.120:FF:000035', NULL, NULL, 'D-Ala-D/L-Ala epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(19431, NULL, 'G3DSA:3.40.50.150:FF:000821', NULL, NULL, 'rRNA methyltransferase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(19432, NULL, 'G3DSA:1.25.40.20:FF:001806', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(19433, NULL, 'G3DSA:3.90.1310.10:FF:000040', NULL, NULL, 'Penicillin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(19434, NULL, 'G3DSA:1.10.533.10:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19435, NULL, 'G3DSA:2.60.40.150:FF:000268', NULL, NULL, 'RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19436, NULL, 'G3DSA:4.10.60.10:FF:000252', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(19437, NULL, 'G3DSA:3.40.50.1700:FF:000032', NULL, NULL, 'Beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(19438, NULL, 'G3DSA:1.20.120.1750:FF:000127', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(19439, NULL, 'G3DSA:2.60.40.640:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19440, NULL, 'G3DSA:1.25.10.10:FF:003269', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(19441, NULL, 'G3DSA:3.40.50.620:FF:000029', NULL, NULL, 'tRNA sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(19442, NULL, 'G3DSA:2.60.40.10:FF:000692', NULL, NULL, 'basement membrane-specific heparan sulfate proteoglycan core protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(19443, NULL, 'G3DSA:1.10.510.10:FF:001413', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(19444, NULL, 'G3DSA:1.25.10.10:FF:001240', NULL, NULL, 'Crescerin-like protein che-12', NULL, NULL, NULL, NULL, NULL, 4),
(19445, NULL, 'G3DSA:3.50.50.60:FF:000643', NULL, NULL, 'Rab escort protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(19446, NULL, 'G3DSA:2.60.220.50:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19447, NULL, 'G3DSA:3.40.718.10:FF:000061', NULL, NULL, 'Isocitrate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(19448, NULL, 'G3DSA:2.60.40.1170:FF:000083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19449, NULL, 'G3DSA:1.10.150.220:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19450, NULL, 'G3DSA:3.40.50.2000:FF:000116', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(19451, NULL, 'G3DSA:1.25.40.10:FF:000224', NULL, NULL, 'DnaJ and TPR domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(19452, NULL, 'G3DSA:2.30.29.30:FF:000695', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(19453, NULL, 'G3DSA:3.40.50.300:FF:003761', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19454, NULL, 'G3DSA:1.25.10.10:FF:002706', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(19455, NULL, 'G3DSA:1.20.1050.40:FF:000006', NULL, NULL, 'Peptidyl-dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(19456, NULL, 'G3DSA:1.10.1450.10:FF:000053', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(19457, NULL, 'G3DSA:1.10.275.30:FF:000006', NULL, NULL, 'General transcription and DNA repair factor IIH helicase subunit XPD', NULL, NULL, NULL, NULL, NULL, 4),
(19458, NULL, 'G3DSA:1.20.5.340:FF:000002', NULL, NULL, 'Myosin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(19459, NULL, 'G3DSA:1.25.10.10:FF:000672', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(19460, NULL, 'G3DSA:3.20.20.70:FF:000674', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19461, NULL, 'G3DSA:3.30.200.20:FF:001925', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19462, NULL, 'G3DSA:1.20.5.4770:FF:000014', NULL, NULL, 'AN1-type zinc finger protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(19463, NULL, 'G3DSA:3.30.60.30:FF:000203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19464, NULL, 'G3DSA:3.30.830.10:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19465, NULL, 'G3DSA:2.60.40.10:FF:001978', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(19466, NULL, 'G3DSA:3.40.50.410:FF:000360', NULL, NULL, 'TFIIH 34kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(19467, NULL, 'G3DSA:3.30.530.20:FF:000169', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(19468, NULL, 'G3DSA:3.90.75.20:FF:000001', NULL, NULL, 'H-N-H endonuclease F-TflII', NULL, NULL, NULL, NULL, NULL, 4),
(19469, NULL, 'G3DSA:3.80.10.10:FF:000456', NULL, NULL, 'Ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(19470, NULL, 'G3DSA:3.40.140.10:FF:000072', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(19471, NULL, 'G3DSA:3.40.50.300:FF:001631', NULL, NULL, 'Shs1p', NULL, NULL, NULL, NULL, NULL, 4),
(19472, NULL, 'G3DSA:3.30.565.10:FF:000072', NULL, NULL, 'Sensor histidine kinase GlrK', NULL, NULL, NULL, NULL, NULL, 4),
(19473, NULL, 'G3DSA:3.90.730.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19474, NULL, 'G3DSA:2.10.25.10:FF:001715', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19475, NULL, 'G3DSA:1.10.2000.10:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19476, NULL, 'G3DSA:3.80.10.10:FF:003385', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19477, NULL, 'G3DSA:3.30.200.20:FF:001869', NULL, NULL, 'Ribosomal protein S6 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(19478, NULL, 'G3DSA:3.40.50.850:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19479, NULL, 'G3DSA:1.10.510.10:FF:000688', NULL, NULL, 'RIM11p Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(19480, NULL, 'G3DSA:1.20.58.390:FF:000084', NULL, NULL, 'Glutamate-gated chloride channel subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(19481, NULL, 'G3DSA:2.60.40.1910:FF:000006', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(19482, NULL, 'G3DSA:3.40.850.10:FF:000154', NULL, NULL, 'Myosin XXI', NULL, NULL, NULL, NULL, NULL, 4),
(19483, NULL, 'G3DSA:3.20.20.20:FF:000013', NULL, NULL, 'Dihydropteroate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(19484, NULL, 'G3DSA:3.40.1370.10:FF:000004', NULL, NULL, '50S ribosomal protein L4', NULL, NULL, NULL, NULL, NULL, 4),
(19485, NULL, 'G3DSA:3.40.50.2000:FF:000807', NULL, NULL, 'Alpha-glucan phosphorylase 2, cytosolic', NULL, NULL, NULL, NULL, NULL, 4),
(19486, NULL, 'G3DSA:3.30.70.3490:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19487, NULL, 'G3DSA:2.60.40.10:FF:006088', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19488, NULL, 'G3DSA:3.90.650.10:FF:000032', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(19489, NULL, 'G3DSA:2.130.10.10:FF:000433', NULL, NULL, 'WD repeat and FYVE domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(19490, NULL, 'G3DSA:2.160.10.10:FF:000073', NULL, NULL, 'Putative nonribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(19491, NULL, 'G3DSA:2.10.25.10:FF:000411', NULL, NULL, 'Crumbs cell polarity complex component 2', NULL, NULL, NULL, NULL, NULL, 4),
(19492, NULL, 'G3DSA:3.10.50.40:FF:000077', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(19493, NULL, 'G3DSA:2.30.33.40:FF:000011', NULL, NULL, 'Heat shock protein family E (Hsp10) member 1', NULL, NULL, NULL, NULL, NULL, 4),
(19494, NULL, 'G3DSA:3.40.50.300:FF:005902', NULL, NULL, 'GTPase mss1/trme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19495, NULL, 'G3DSA:3.40.390.10:FF:000074', NULL, NULL, 'Metalloprotease', NULL, NULL, NULL, NULL, NULL, 4),
(19496, NULL, 'G3DSA:3.30.420.390:FF:000001', NULL, NULL, 'DNA polymerase gamma, catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(19497, NULL, 'G3DSA:2.130.10.10:FF:003362', NULL, NULL, 'Probable serine/threonine-protein kinase roco4', NULL, NULL, NULL, NULL, NULL, 4),
(19498, NULL, 'G3DSA:2.60.40.10:FF:002777', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19499, NULL, 'G3DSA:3.90.228.10:FF:000068', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(19500, NULL, 'G3DSA:3.40.50.11210:FF:000006', NULL, NULL, 'GTPase-activating Rap/Ran-GAP domain-like protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(19501, NULL, 'G3DSA:1.10.10.60:FF:000422', NULL, NULL, 'Transcriptional regulator, Fis family', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(19502, NULL, 'G3DSA:3.30.200.20:FF:001072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19503, NULL, 'G3DSA:3.40.190.290:FF:000022', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(19504, NULL, 'G3DSA:3.20.20.140:FF:000373', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19505, NULL, 'G3DSA:3.30.450.20:FF:000511', NULL, NULL, 'ACR218Wp', NULL, NULL, NULL, NULL, NULL, 4),
(19506, NULL, 'G3DSA:3.30.160.60:FF:006413', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19507, NULL, 'G3DSA:1.20.930.40:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19508, NULL, 'G3DSA:3.10.20.90:FF:000747', NULL, NULL, 'AT07671p', NULL, NULL, NULL, NULL, NULL, 4),
(19509, NULL, 'G3DSA:1.10.510.10:FF:004286', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19510, NULL, 'G3DSA:3.40.50.720:FF:000621', NULL, NULL, '3-ketoacyl-CoA reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19511, NULL, 'G3DSA:3.50.50.60:FF:000930', NULL, NULL, 'Bis-gamma-glutamylcystine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(19512, NULL, 'G3DSA:3.40.50.300:FF:002069', NULL, NULL, 'Pre-mRNA splicing factor RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19513, NULL, 'G3DSA:2.60.40.10:FF:003215', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19514, NULL, 'G3DSA:3.40.50.1100:FF:000291', NULL, NULL, 'Putative S-sulfocysteine synthase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(19515, NULL, 'G3DSA:2.60.120.200:FF:000348', NULL, NULL, 'InTestinal NeureXin-like', NULL, NULL, NULL, NULL, NULL, 4),
(19516, NULL, 'G3DSA:2.40.50.140:FF:000294', NULL, NULL, 'Single-stranded DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(19517, NULL, 'G3DSA:3.10.100.10:FF:000060', NULL, NULL, 'Lymphocyte antigen 75', NULL, NULL, NULL, NULL, NULL, 4),
(19518, NULL, 'G3DSA:1.25.40.10:FF:001860', NULL, NULL, 'Protein FLUORESCENT IN BLUE LIGHT, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(19519, NULL, 'G3DSA:1.20.5.1700:FF:000009', NULL, NULL, 'Homer homolog 2 (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(19520, NULL, 'G3DSA:2.30.30.140:FF:000303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19521, NULL, 'G3DSA:1.10.8.10:FF:000305', NULL, NULL, 'UBX domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(19522, NULL, 'G3DSA:3.40.50.300:FF:008488', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19523, NULL, 'G3DSA:1.25.10.10:FF:001925', NULL, NULL, 'AGAP007143-PA', NULL, NULL, NULL, NULL, NULL, 4),
(19524, NULL, 'G3DSA:1.20.120.1080:FF:000123', NULL, NULL, 'AGAP007953-PA', NULL, NULL, NULL, NULL, NULL, 4),
(19525, NULL, 'G3DSA:3.40.50.300:FF:004093', NULL, NULL, 'CG41497', NULL, NULL, NULL, NULL, NULL, 4),
(19526, NULL, 'G3DSA:3.40.50.300:FF:008432', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19527, NULL, 'G3DSA:1.10.418.10:FF:000193', NULL, NULL, 'Girdin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19528, NULL, 'G3DSA:3.40.390.10:FF:000130', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(19529, NULL, 'G3DSA:3.40.50.720:FF:001970', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(19530, NULL, 'G3DSA:1.25.40.10:FF:002534', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g16010', NULL, NULL, NULL, NULL, NULL, 4),
(19531, NULL, 'G3DSA:1.10.630.10:FF:000231', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(19532, NULL, 'G3DSA:3.90.70.10:FF:000875', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19533, NULL, 'G3DSA:3.40.720.10:FF:000330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19534, NULL, 'G3DSA:3.40.50.300:FF:007976', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19535, NULL, 'G3DSA:1.10.1300.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19536, NULL, 'G3DSA:1.25.40.10:FF:000909', NULL, NULL, 'YDR161W-like protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(19537, NULL, 'G3DSA:3.30.200.20:FF:002325', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19538, NULL, 'G3DSA:3.80.20.20:FF:000055', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(19539, NULL, 'G3DSA:1.25.40.20:FF:000446', NULL, NULL, 'Arginine N-methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(19540, NULL, 'G3DSA:3.40.850.10:FF:000210', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(19541, NULL, 'G3DSA:1.20.1560.10:FF:000553', NULL, NULL, 'ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(19542, NULL, 'G3DSA:3.40.50.720:FF:001077', NULL, NULL, 'GM12822', NULL, NULL, NULL, NULL, NULL, 4),
(19543, NULL, 'G3DSA:2.30.29.30:FF:000751', NULL, NULL, 'Kinesin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19544, NULL, 'G3DSA:3.40.1000.10:FF:000022', NULL, NULL, 'Photosystem II reaction center PsbP family protein', NULL, NULL, NULL, NULL, NULL, 4),
(19545, NULL, 'G3DSA:3.30.70.330:FF:002045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19546, NULL, 'G3DSA:2.10.25.10:FF:000355', NULL, NULL, 'Wall-associated receptor kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(19547, NULL, 'G3DSA:2.10.25.10:FF:001760', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19548, NULL, 'G3DSA:3.30.160.60:FF:001810', NULL, NULL, 'General transcription factor IIIA', NULL, NULL, NULL, NULL, NULL, 4),
(19549, NULL, 'G3DSA:3.40.190.10:FF:000923', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19550, NULL, 'G3DSA:2.60.40.290:FF:000006', NULL, NULL, 'Chitinase B', NULL, NULL, NULL, NULL, NULL, 4),
(19551, NULL, 'G3DSA:3.90.470.20:FF:000032', NULL, NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(19552, NULL, 'G3DSA:3.90.550.20:FF:000033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(19553, NULL, 'G3DSA:3.30.160.60:FF:005340', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19554, NULL, 'G3DSA:3.30.70.3400:FF:000016', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(19555, NULL, 'G3DSA:2.102.10.10:FF:000036', NULL, NULL, 'Cholesterol 7-desaturase', NULL, NULL, NULL, NULL, NULL, 4),
(19556, NULL, 'G3DSA:3.30.70.330:FF:001320', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(19557, NULL, 'G3DSA:2.40.30.170:FF:000029', NULL, NULL, 'Probable Resistance-Nodulation-Cell Division (RND) efflux membrane fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(19558, NULL, 'G3DSA:1.10.1450.10:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19559, NULL, 'G3DSA:1.25.40.10:FF:005171', NULL, NULL, 'E3 ubiquitin-protein ligase CHIP', NULL, NULL, NULL, NULL, NULL, 4),
(19560, NULL, 'G3DSA:1.25.40.10:FF:000168', NULL, NULL, 'tetratricopeptide repeat protein 8 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(19561, NULL, 'G3DSA:3.10.20.90:FF:000186', NULL, NULL, 'RWP-RK domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(19562, NULL, 'G3DSA:1.10.486.10:FF:000024', NULL, NULL, 'ATP-dependent DNA helicase UvrD2', NULL, NULL, NULL, NULL, NULL, 4),
(19563, NULL, 'G3DSA:2.30.30.240:FF:000002', NULL, NULL, 'Ribosome maturation factor rimM', NULL, NULL, NULL, NULL, NULL, 4),
(19564, NULL, 'G3DSA:3.40.1810.10:FF:000033', NULL, NULL, 'Agamous-like MADS-box protein AGL53', NULL, NULL, NULL, NULL, NULL, 4),
(19565, NULL, 'G3DSA:3.30.70.260:FF:000091', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(19566, NULL, 'G3DSA:3.40.50.720:FF:001818', NULL, NULL, '2-C-methyl-D-erythritol 4-phosphate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(19567, NULL, 'G3DSA:1.10.1320.10:FF:000009', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(19568, NULL, 'G3DSA:3.80.10.10:FF:003441', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19569, NULL, 'G3DSA:3.30.200.20:FF:001813', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase GSO1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(19570, NULL, 'G3DSA:1.10.2000.10:FF:000087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19571, NULL, 'G3DSA:3.30.420.40:FF:000734', NULL, NULL, 'Actin4-1', NULL, NULL, NULL, NULL, NULL, 4),
(19572, NULL, 'G3DSA:2.60.40.10:FF:004963', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19573, NULL, 'G3DSA:1.20.1000.10:FF:000011', NULL, NULL, 'Guanylate-binding family protein', NULL, NULL, NULL, NULL, NULL, 4),
(19574, NULL, 'G3DSA:1.10.10.60:FF:000097', NULL, NULL, 'barH-like 2 homeobox protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(19575, NULL, 'G3DSA:1.10.520.40:FF:000001', NULL, NULL, 'CRISPR system Cascade subunit CasB', NULL, NULL, NULL, NULL, NULL, 4),
(19576, NULL, 'G3DSA:3.40.1390.20:FF:000008', NULL, NULL, 'HPr kinase/phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(19577, NULL, 'G3DSA:1.10.510.10:FF:000576', NULL, NULL, 'Serine/threonine-protein kinase PLK4', NULL, NULL, NULL, NULL, NULL, 4),
(19578, NULL, 'G3DSA:4.10.60.10:FF:000196', NULL, NULL, 'Cold shock domain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(19579, NULL, 'G3DSA:2.130.10.10:FF:004379', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19580, NULL, 'G3DSA:3.40.50.1910:FF:000033', NULL, NULL, 'Vacuolar protein sorting-associated protein 33B', NULL, NULL, NULL, NULL, NULL, 4),
(19581, NULL, 'G3DSA:3.30.160.60:FF:002142', NULL, NULL, 'Zinc finger protein 567', NULL, NULL, NULL, NULL, NULL, 4),
(19582, NULL, 'G3DSA:2.130.10.10:FF:000613', NULL, NULL, 'YKL121W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(19583, NULL, 'G3DSA:1.20.1070.10:FF:001246', NULL, NULL, 'Latrophilin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19584, NULL, 'G3DSA:3.90.550.50:FF:000137', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(19585, NULL, 'G3DSA:2.30.30.930:FF:000001', NULL, NULL, 'RNA polymerase-associated protein RapA', NULL, NULL, NULL, NULL, NULL, 4),
(19586, NULL, 'G3DSA:2.10.25.10:FF:001428', NULL, NULL, 'Starry night', NULL, NULL, NULL, NULL, NULL, 4),
(19587, NULL, 'G3DSA:3.30.1490.120:FF:000023', NULL, NULL, 'Os06g0168400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(19588, NULL, 'G3DSA:3.90.226.10:FF:000226', NULL, NULL, 'Enoyl-CoA hydratase/isomerase family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19589, NULL, 'G3DSA:3.40.50.300:FF:001344', NULL, NULL, 'Related to ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(19590, NULL, 'G3DSA:1.10.3730.10:FF:000007', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(19591, NULL, 'G3DSA:4.10.240.30:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19592, NULL, 'G3DSA:3.30.1370.10:FF:000175', NULL, NULL, 'Tudor and KH domain-containing protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(19593, NULL, 'G3DSA:3.40.50.410:FF:000028', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(19594, NULL, 'G3DSA:2.60.120.1000:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19595, NULL, 'G3DSA:2.10.110.10:FF:000160', NULL, NULL, 'Signal transducer, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19596, NULL, 'G3DSA:3.20.110.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19597, NULL, 'G3DSA:1.25.10.10:FF:001184', NULL, NULL, 'Condensin-2 complex subunit D3', NULL, NULL, NULL, NULL, NULL, 4),
(19598, NULL, 'G3DSA:3.50.50.60:FF:000587', NULL, NULL, 'Guanosine nucleotide diphosphate dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(19599, NULL, 'G3DSA:3.40.50.300:FF:004778', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(19600, NULL, 'G3DSA:2.10.50.10:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19601, NULL, 'G3DSA:1.20.140.150:FF:000015', NULL, NULL, 'Claudin', NULL, NULL, NULL, NULL, NULL, 4),
(19602, NULL, 'G3DSA:1.10.510.10:FF:002762', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19603, NULL, 'G3DSA:1.10.1410.10:FF:000112', NULL, NULL, 'Caffeine Induced Death (S. pombe Cid) homolog', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(19604, NULL, 'G3DSA:3.40.630.10:FF:000458', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19605, NULL, 'G3DSA:1.20.58.80:FF:000066', NULL, NULL, 'Sorting nexin 15', NULL, NULL, NULL, NULL, NULL, 4),
(19606, NULL, 'G3DSA:3.30.70.580:FF:000029', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(19607, NULL, 'G3DSA:3.40.47.10:FF:000267', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19608, NULL, 'G3DSA:1.20.1070.10:FF:000521', NULL, NULL, 'Putative octopamine/tyramine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(19609, NULL, 'G3DSA:3.40.50.1580:FF:000001', NULL, NULL, 'MTA/SAH nucleosidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(19610, NULL, 'G3DSA:2.60.120.330:FF:000140', NULL, NULL, 'Oxidoreductase, 2OG-Fe(II) oxygenase family, putative (AFU_orthologue AFUA_5G12242)', NULL, NULL, NULL, NULL, NULL, 4),
(19611, NULL, 'G3DSA:1.25.40.20:FF:000969', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19612, NULL, 'G3DSA:3.40.50.300:FF:002704', NULL, NULL, 'Unplaced genomic scaffold supercont1.17, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(19613, NULL, 'G3DSA:1.10.238.10:FF:000712', NULL, NULL, 'EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(19614, NULL, 'G3DSA:3.60.40.10:FF:000178', NULL, NULL, 'WGS project CABT00000000 data, contig 2.1', NULL, NULL, NULL, NULL, NULL, 4),
(19615, NULL, 'G3DSA:3.40.50.1010:FF:000033', NULL, NULL, 'Blast:Protein SMG5', NULL, NULL, NULL, NULL, NULL, 4),
(19616, NULL, 'G3DSA:2.30.29.70:FF:000004', NULL, NULL, 'Unplaced genomic scaffold supercont1.163, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(19617, NULL, 'G3DSA:3.40.50.1760:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19618, NULL, 'G3DSA:1.20.58.60:FF:000060', NULL, NULL, 'dystonin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(19619, NULL, 'G3DSA:2.60.40.10:FF:001473', NULL, NULL, 'Jitterbug, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(19620, NULL, 'G3DSA:1.10.510.10:FF:000632', NULL, NULL, 'leucine-rich repeat receptor-like protein kinase TDR', NULL, NULL, NULL, NULL, NULL, 4),
(19621, NULL, 'G3DSA:3.30.70.270:FF:000037', NULL, NULL, 'Sensory box/GGDEF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(19622, NULL, 'G3DSA:3.30.40.10:FF:001831', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19623, NULL, 'G3DSA:1.50.40.10:FF:000104', NULL, NULL, 'Iron transporter', NULL, NULL, NULL, NULL, NULL, 4),
(19624, NULL, 'G3DSA:2.30.30.30:FF:000092', NULL, NULL, 'Transcription initiation factor SPT5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19625, NULL, 'G3DSA:3.80.10.10:FF:003946', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19626, NULL, 'G3DSA:3.40.30.10:FF:000807', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(19627, NULL, 'G3DSA:3.40.50.300:FF:002648', NULL, NULL, 'bifunctional heparan sulfate N-deacetylase/N-sulfotransferase 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(19628, NULL, 'G3DSA:1.50.40.10:FF:000048', NULL, NULL, 'mitochondrial 2-oxodicarboxylate carrier isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(19629, NULL, 'G3DSA:1.10.10.60:FF:000602', NULL, NULL, 'Chitin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(19630, NULL, 'G3DSA:3.30.420.40:FF:000554', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(19631, NULL, 'G3DSA:2.30.42.10:FF:000506', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19632, NULL, 'G3DSA:3.30.160.60:FF:003103', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19633, NULL, 'G3DSA:1.25.40.10:FF:003658', NULL, NULL, 'Tetratricopeptide repeat protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(19634, NULL, 'G3DSA:2.60.120.620:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19635, NULL, 'G3DSA:1.10.287.130:FF:000182', NULL, NULL, 'Histidine kinase sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(19636, NULL, 'G3DSA:3.30.40.10:FF:000157', NULL, NULL, 'Lysine (K)-specific demethylase 5A', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(19637, NULL, 'G3DSA:1.10.287.70:FF:000107', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(19638, NULL, 'G3DSA:3.30.200.40:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19639, NULL, 'G3DSA:3.30.505.10:FF:000147', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19640, NULL, 'G3DSA:3.40.50.1820:FF:000394', NULL, NULL, 'Alpha/beta fold hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(19641, NULL, 'G3DSA:3.90.70.10:FF:000532', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(19642, NULL, 'G3DSA:1.25.40.10:FF:004951', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19643, NULL, 'G3DSA:2.60.120.260:FF:000040', NULL, NULL, 'Reelin', NULL, NULL, NULL, NULL, NULL, 4),
(19644, NULL, 'G3DSA:3.40.50.300:FF:006015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19645, NULL, 'G3DSA:3.40.30.10:FF:001027', NULL, NULL, 'Thioredoxin-like 4B', NULL, NULL, NULL, NULL, NULL, 4),
(19646, NULL, 'G3DSA:1.20.58.390:FF:000264', NULL, NULL, 'Glutamate-gated chloride channel, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19647, NULL, 'G3DSA:3.60.10.10:FF:000007', NULL, NULL, 'Deoxyribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(19648, NULL, 'G3DSA:1.10.287.950:FF:000040', NULL, NULL, 'Methyl-accepting chemotaxis sensory transducer', NULL, NULL, NULL, NULL, NULL, 4),
(19649, NULL, 'G3DSA:1.20.1270.60:FF:000107', NULL, NULL, 'Slit-Robo GAP homolog', NULL, NULL, NULL, NULL, NULL, 4),
(19650, NULL, 'G3DSA:2.80.10.50:FF:000279', NULL, NULL, 'Cellulase containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(19651, NULL, 'G3DSA:3.40.50.1820:FF:001411', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19652, NULL, 'G3DSA:3.90.1640.10:FF:000025', NULL, NULL, 'Putative exopolyphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(19653, NULL, 'G3DSA:3.80.10.10:FF:001816', NULL, NULL, 'Leucine-rich repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(19654, NULL, 'G3DSA:3.30.70.380:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19655, NULL, 'G3DSA:1.20.58.60:FF:000307', NULL, NULL, 'Spectrin beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(19656, NULL, 'G3DSA:2.60.120.650:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19657, NULL, 'G3DSA:3.30.1370.50:FF:000007', NULL, NULL, 'Transcriptional repressor NF-X1', NULL, NULL, NULL, NULL, NULL, 4),
(19658, NULL, 'G3DSA:1.20.1070.10:FF:001426', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(19659, NULL, 'G3DSA:3.40.50.720:FF:001638', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19660, NULL, 'G3DSA:1.10.30.10:FF:000162', NULL, NULL, 'HMG box-containing protein C19G7.04', NULL, NULL, NULL, NULL, NULL, 4),
(19661, NULL, 'G3DSA:3.30.420.10:FF:000394', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19662, NULL, 'G3DSA:2.60.470.10:FF:000012', NULL, NULL, 'Pickpocket 7', NULL, NULL, NULL, NULL, NULL, 4),
(19663, NULL, 'G3DSA:2.30.110.10:FF:000003', NULL, NULL, 'UPF0306 protein YhbP', NULL, NULL, NULL, NULL, NULL, 4),
(19664, NULL, 'G3DSA:1.20.920.10:FF:000161', NULL, NULL, 'SNF2-family ATP dependent chromatin remodeling factor snf21', NULL, NULL, NULL, NULL, NULL, 4),
(19665, NULL, 'G3DSA:1.25.40.10:FF:000348', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(19666, NULL, 'G3DSA:2.30.30.40:FF:000038', NULL, NULL, 'kalirin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(19667, NULL, 'G3DSA:2.40.30.10:FF:000181', NULL, NULL, 'Vibriobactin utilization protein ViuB', NULL, NULL, NULL, NULL, NULL, 4),
(19668, NULL, 'G3DSA:3.80.10.10:FF:003603', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19669, NULL, 'G3DSA:3.30.1360.180:FF:000012', NULL, NULL, 'Secreted ectonucleotide pyrophosphatase/phosphodiesterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19670, NULL, 'G3DSA:2.30.30.40:FF:000190', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(19671, NULL, 'G3DSA:1.25.40.10:FF:004619', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19672, NULL, 'G3DSA:3.80.10.10:FF:002985', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19673, NULL, 'G3DSA:2.60.120.650:FF:000230', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(19674, NULL, 'G3DSA:1.10.530.40:FF:000007', NULL, NULL, 'Peptidoglycan hydrolase gp36', NULL, NULL, NULL, NULL, NULL, 4),
(19675, NULL, 'G3DSA:3.40.50.300:FF:007139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19676, NULL, 'G3DSA:3.30.70.20:FF:000083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19677, NULL, 'G3DSA:3.30.420.10:FF:000450', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19678, NULL, 'G3DSA:2.60.34.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19679, NULL, 'G3DSA:3.30.200.20:FF:002269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19680, NULL, 'G3DSA:3.40.50.150:FF:000877', NULL, NULL, 'Toxin biosynthesis regulatory protein AflJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19681, NULL, 'G3DSA:3.90.190.10:FF:000457', NULL, NULL, 'Protein-tyrosine-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(19682, NULL, 'G3DSA:3.40.50.1000:FF:000592', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19683, NULL, 'G3DSA:3.40.50.300:FF:001687', NULL, NULL, 'Probable ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(19684, NULL, 'G3DSA:3.30.497.10:FF:000082', NULL, NULL, 'Serine proteinase inhibitor, clade B, member 1', NULL, NULL, NULL, NULL, NULL, 4),
(19685, NULL, 'G3DSA:3.80.10.10:FF:004166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19686, NULL, 'G3DSA:3.30.200.20:FF:000291', NULL, NULL, 'STE20-related kinase adapter protein beta isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(19687, NULL, 'G3DSA:3.10.100.10:FF:000222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19688, NULL, 'G3DSA:3.30.1680.10:FF:000041', NULL, NULL, 'Semaphorin-5c', NULL, NULL, NULL, NULL, NULL, 4),
(19689, NULL, 'G3DSA:3.40.50.620:FF:000361', NULL, NULL, 'Putative carbamoyl-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(19690, NULL, 'G3DSA:1.10.167.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19691, NULL, 'G3DSA:1.25.40.20:FF:001245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19692, NULL, 'G3DSA:3.30.1310.10:FF:000014', NULL, NULL, 'Nucleoid-associated protein slr1847', NULL, NULL, NULL, NULL, NULL, 4),
(19693, NULL, 'G3DSA:3.40.50.300:FF:006690', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19694, NULL, 'G3DSA:3.10.20.90:FF:000803', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19695, NULL, 'G3DSA:3.60.10.10:FF:000406', NULL, NULL, 'Type I inositol polyphosphate 5-phosphatase 2', NULL, NULL, NULL, NULL, NULL, 4),
(19696, NULL, 'G3DSA:3.90.260.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19697, NULL, 'G3DSA:3.30.1370.30:FF:000001', NULL, NULL, '40S ribosomal protein S15a', NULL, NULL, NULL, NULL, NULL, 4),
(19698, NULL, 'G3DSA:3.30.1360.10:FF:000017', NULL, NULL, 'DNA-directed RNA polymerase I-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(19699, NULL, 'G3DSA:3.30.530.20:FF:000045', NULL, NULL, 'BnaA09g52170D protein', NULL, NULL, NULL, NULL, NULL, 4),
(19700, NULL, 'G3DSA:1.20.140.10:FF:000039', NULL, NULL, 'Acyl-CoA dehydrogenase FadE14', NULL, NULL, NULL, NULL, NULL, 4),
(19701, NULL, 'G3DSA:3.40.50.150:FF:001153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19702, NULL, 'G3DSA:3.90.180.10:FF:000052', NULL, NULL, 'Alcohol dehydrogenase, zinc-containing', NULL, NULL, NULL, NULL, NULL, 4),
(19703, NULL, 'G3DSA:1.20.58.1120:FF:000021', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(19704, NULL, 'G3DSA:3.30.420.40:FF:000498', NULL, NULL, 'DnaK-type molecular chaperone', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(19705, NULL, 'G3DSA:3.40.1090.10:FF:000022', NULL, NULL, 'Neuropathy target esterase sws', NULL, NULL, NULL, NULL, NULL, 4),
(19706, NULL, 'G3DSA:2.60.40.10:FF:005688', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19707, NULL, 'G3DSA:3.55.40.20:FF:000025', NULL, NULL, 'Bll8073 protein', NULL, NULL, NULL, NULL, NULL, 4),
(19708, NULL, 'G3DSA:1.20.1310.10:FF:000001', NULL, NULL, 'Cullin 3', NULL, NULL, NULL, NULL, NULL, 4),
(19709, NULL, 'G3DSA:1.25.40.10:FF:004390', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19710, NULL, 'G3DSA:2.20.70.10:FF:000072', NULL, NULL, 'Rho GTPase activating protein 12b', NULL, NULL, NULL, NULL, NULL, 4),
(19711, NULL, 'G3DSA:3.30.70.330:FF:001825', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19712, NULL, 'G3DSA:2.60.40.1180:FF:000029', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(19713, NULL, 'G3DSA:3.40.50.2300:FF:000903', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19714, NULL, 'G3DSA:3.10.10.10:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19715, NULL, 'G3DSA:3.40.50.360:FF:000030', NULL, NULL, 'ribosyldihydronicotinamide dehydrogenase [quinone]', NULL, NULL, NULL, NULL, NULL, 4),
(19716, NULL, 'G3DSA:2.60.120.260:FF:000383', NULL, NULL, 'Disintegrin and metalloproteinase domain-containing protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(19717, NULL, 'G3DSA:1.25.40.10:FF:003990', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(19718, NULL, 'G3DSA:1.10.510.10:FF:004342', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19719, NULL, 'G3DSA:3.30.450.350:FF:000001', NULL, NULL, 'Histidine kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(19720, NULL, 'G3DSA:2.20.70.10:FF:000234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19721, NULL, 'G3DSA:2.60.220.30:FF:000016', NULL, NULL, 'MET transcriptional regulator MACC1', NULL, NULL, NULL, NULL, NULL, 4),
(19722, NULL, 'G3DSA:1.10.630.10:FF:000287', NULL, NULL, 'Cytochrome P-450 IIC5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19723, NULL, 'G3DSA:3.40.50.620:FF:000541', NULL, NULL, 'tRNA glutamyl-Q(34) synthetase GluQRS', NULL, NULL, NULL, NULL, NULL, 4),
(19724, NULL, 'G3DSA:1.10.3720.10:FF:000001', NULL, NULL, 'Glycine betaine ABC transporter, permease', NULL, NULL, NULL, NULL, NULL, 4),
(19725, NULL, 'G3DSA:3.40.50.1820:FF:001810', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19726, NULL, 'G3DSA:3.10.20.870:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19727, NULL, 'G3DSA:3.40.50.300:FF:002980', NULL, NULL, 'ABC transporter C family member 9', NULL, NULL, NULL, NULL, NULL, 4),
(19728, NULL, 'G3DSA:3.30.1380.10:FF:000001', NULL, NULL, 'Indian hedgehog', NULL, NULL, NULL, NULL, NULL, 4),
(19729, NULL, 'G3DSA:1.50.40.10:FF:000380', NULL, NULL, 'Peroxisomal membrane protein PMP34', NULL, NULL, NULL, NULL, NULL, 4),
(19730, NULL, 'G3DSA:3.40.50.12780:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19731, NULL, 'G3DSA:3.30.870.10:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19732, NULL, 'G3DSA:3.30.160.60:FF:002086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19733, NULL, 'G3DSA:1.20.1070.10:FF:001825', NULL, NULL, 'Opsin', NULL, NULL, NULL, NULL, NULL, 4),
(19734, NULL, 'G3DSA:2.130.10.10:FF:002581', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19735, NULL, 'G3DSA:3.30.230.10:FF:000183', NULL, NULL, 'UTP--glucose-1-phosphate uridylyltransferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(19736, NULL, 'G3DSA:1.10.10.10:FF:000492', NULL, NULL, 'Transcriptional regulator, AsnC family', NULL, NULL, NULL, NULL, NULL, 4),
(19737, NULL, 'G3DSA:1.20.5.550:FF:000003', NULL, NULL, 'Bifunctional protein PutA', NULL, NULL, NULL, NULL, NULL, 4),
(19738, NULL, 'G3DSA:3.30.70.330:FF:002225', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19739, NULL, 'G3DSA:1.20.1250.20:FF:000235', NULL, NULL, 'Solute carrier family 43 (amino acid system L transporter), member 2b', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(19740, NULL, 'G3DSA:3.30.2410.10:FF:000016', NULL, NULL, 'E3 ubiquitin-protein ligase HACE1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(19741, NULL, 'G3DSA:2.40.110.10:FF:000006', NULL, NULL, 'very long-chain specific acyl-CoA dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(19742, NULL, 'G3DSA:2.160.20.160:FF:000001', NULL, NULL, 'RTX toxin', NULL, NULL, NULL, NULL, NULL, 4),
(19743, NULL, 'G3DSA:2.60.200.20:FF:000068', NULL, NULL, 'TIFA inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(19744, NULL, 'G3DSA:2.60.40.50:FF:000001', NULL, NULL, 'Transcription attenuation protein MtrB', NULL, NULL, NULL, NULL, NULL, 4),
(19745, NULL, 'G3DSA:3.40.850.10:FF:000098', NULL, NULL, 'Kinesin-like protein KIN-10C', NULL, NULL, NULL, NULL, NULL, 4),
(19746, NULL, 'G3DSA:1.20.58.110:FF:000006', NULL, NULL, '30S ribosomal protein S20', NULL, NULL, NULL, NULL, NULL, 4),
(19747, NULL, 'G3DSA:2.40.180.10:FF:000011', NULL, NULL, 'Lipoxygenase homology domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(19748, NULL, 'G3DSA:3.10.310.10:FF:000047', NULL, NULL, 'Diaminopimelate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(19749, NULL, 'G3DSA:3.40.50.720:FF:000801', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(19750, NULL, 'G3DSA:3.40.50.1820:FF:000118', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(19751, NULL, 'G3DSA:1.25.40.10:FF:000404', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(19752, NULL, 'G3DSA:3.30.160.60:FF:006357', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19753, NULL, 'G3DSA:1.20.1160.11:FF:000001', NULL, NULL, 'Paired amphipathic helix protein Sin3', NULL, NULL, NULL, NULL, NULL, 4),
(19754, NULL, 'G3DSA:3.40.50.12650:FF:000045', NULL, NULL, 'Sterile alpha motif (SAM) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(19755, NULL, 'G3DSA:3.40.50.300:FF:006358', NULL, NULL, 'Gluconokinase', NULL, NULL, NULL, NULL, NULL, 4),
(19756, NULL, 'G3DSA:3.30.360.10:FF:000063', NULL, NULL, 'Oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(19757, NULL, 'G3DSA:1.20.58.390:FF:000320', NULL, NULL, 'Glycine receptor alpha 4b subunit', NULL, NULL, NULL, NULL, NULL, 4),
(19758, NULL, 'G3DSA:3.50.50.100:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19759, NULL, 'G3DSA:1.25.10.10:FF:002488', NULL, NULL, 'Armadillo repeat-containing protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(19760, NULL, 'G3DSA:3.30.70.330:FF:000988', NULL, NULL, 'Developmentally regulated RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(19761, NULL, 'G3DSA:3.40.50.150:FF:001097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19762, NULL, 'G3DSA:3.40.50.720:FF:002190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19763, NULL, 'G3DSA:3.30.559.30:FF:000081', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(19764, NULL, 'G3DSA:3.10.20.90:FF:000242', NULL, NULL, 'Putative polycomb group RING finger protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(19765, NULL, 'G3DSA:3.30.70.330:FF:001264', NULL, NULL, 'tRNA selenocysteine 1 associated protein 1b', NULL, NULL, NULL, NULL, NULL, 4),
(19766, NULL, 'G3DSA:1.10.10.10:FF:001453', NULL, NULL, 'Meiotic recombination protein Spo11', NULL, NULL, NULL, NULL, NULL, 4),
(19767, NULL, 'G3DSA:3.40.50.150:FF:001838', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19768, NULL, 'G3DSA:2.40.10.10:FF:000179', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(19769, NULL, 'G3DSA:3.30.1520.10:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19770, NULL, 'G3DSA:3.40.630.30:FF:000273', NULL, NULL, 'Os12g0561600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(19771, NULL, 'G3DSA:3.40.50.620:FF:000209', NULL, NULL, 'Electron transfer flavoprotein subunit alpha, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(19772, NULL, 'G3DSA:2.40.50.140:FF:000350', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(19773, NULL, 'G3DSA:3.30.310.10:FF:000060', NULL, NULL, 'Ribonuclease HIII', NULL, NULL, NULL, NULL, NULL, 4),
(19774, NULL, 'G3DSA:3.30.160.60:FF:002647', NULL, NULL, 'Protein CBG05518', NULL, NULL, NULL, NULL, NULL, 4),
(19775, NULL, 'G3DSA:3.40.50.1980:FF:000014', NULL, NULL, 'Ferrienterobactin-binding periplasmic protein FepB', NULL, NULL, NULL, NULL, NULL, 4),
(19776, NULL, 'G3DSA:2.60.40.150:FF:000829', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19777, NULL, 'G3DSA:3.50.50.60:FF:001368', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19778, NULL, 'G3DSA:3.30.310.20:FF:000006', NULL, NULL, 'DNA methylation and regulatory protein Ada', NULL, NULL, NULL, NULL, NULL, 4),
(19779, NULL, 'G3DSA:2.60.40.10:FF:002434', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(19780, NULL, 'G3DSA:2.40.50.140:FF:000474', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(19781, NULL, 'G3DSA:3.80.10.10:FF:000512', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3', NULL, NULL, NULL, NULL, NULL, 4),
(19782, NULL, 'G3DSA:3.30.70.1700:FF:000001', NULL, NULL, 'Phage minor tail protein', NULL, NULL, NULL, NULL, NULL, 4),
(19783, NULL, 'G3DSA:1.25.40.10:FF:003097', NULL, NULL, 'YALI0A10296p', NULL, NULL, NULL, NULL, NULL, 4),
(19784, NULL, 'G3DSA:3.40.50.1820:FF:000450', NULL, NULL, 'PAF acetylhydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(19785, NULL, 'G3DSA:1.10.10.10:FF:001852', NULL, NULL, 'Topoisomerase-like enzyme1', NULL, NULL, NULL, NULL, NULL, 4),
(19786, NULL, 'G3DSA:3.30.420.10:FF:000118', NULL, NULL, 'Poly(A)-specific ribonuclease PARN, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19787, NULL, 'G3DSA:3.30.40.10:FF:000718', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(19788, NULL, 'G3DSA:3.30.160.60:FF:003047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19789, NULL, 'G3DSA:3.40.33.10:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19790, NULL, 'G3DSA:3.30.1460.10:FF:000002', NULL, NULL, 'Exoenzyme S synthesis protein C', NULL, NULL, NULL, NULL, NULL, 4),
(19791, NULL, 'G3DSA:1.25.10.10:FF:001689', NULL, NULL, 'Vacuolar protein 14 C-terminal Fig4p binding, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19792, NULL, 'G3DSA:1.20.1070.10:FF:000465', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(19793, NULL, 'G3DSA:2.30.42.10:FF:000326', NULL, NULL, 'Syntenin-1', NULL, NULL, NULL, NULL, NULL, 4),
(19794, NULL, 'G3DSA:1.10.540.10:FF:000128', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(19795, NULL, 'G3DSA:3.30.200.20:FF:002089', NULL, NULL, 'Cyclin dependent kinase', NULL, NULL, NULL, NULL, NULL, 4),
(19796, NULL, 'G3DSA:3.40.630.10:FF:000115', NULL, NULL, 'Nicalin-1', NULL, NULL, NULL, NULL, NULL, 4),
(19797, NULL, 'G3DSA:3.40.50.1000:FF:000316', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(19798, NULL, 'G3DSA:1.25.10.10:FF:002089', NULL, NULL, 'U3 small nucleolar RNA-associated protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(19799, NULL, 'G3DSA:3.30.360.20:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19800, NULL, 'G3DSA:3.20.20.100:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19801, NULL, 'G3DSA:1.20.120.220:FF:000010', NULL, NULL, 'ATP synthase subunit a', NULL, NULL, NULL, NULL, NULL, 4),
(19802, NULL, 'G3DSA:3.40.50.300:FF:006919', NULL, NULL, 'Lipoprotein-releasing system ATP-binding protein LolD', NULL, NULL, NULL, NULL, NULL, 4),
(19803, NULL, 'G3DSA:1.10.268.10:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19804, NULL, 'G3DSA:3.40.140.10:FF:000263', NULL, NULL, 'CMP/dCMP deaminase zinc-binding', NULL, NULL, NULL, NULL, NULL, 4),
(19805, NULL, 'G3DSA:3.10.129.10:FF:000272', NULL, NULL, 'Acyl coenzyme A thioester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(19806, NULL, 'G3DSA:1.10.10.10:FF:000172', NULL, NULL, 'Arginine repressor', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(19807, NULL, 'G3DSA:2.40.70.10:FF:000554', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19808, NULL, 'G3DSA:3.90.550.10:FF:000171', NULL, NULL, 'Glycosyl transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(19809, NULL, 'G3DSA:1.20.5.340:FF:000081', NULL, NULL, 'AGR282Wp', NULL, NULL, NULL, NULL, NULL, 4),
(19810, NULL, 'G3DSA:2.60.40.60:FF:000515', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19811, NULL, 'G3DSA:2.10.25.10:FF:001788', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19812, NULL, 'G3DSA:2.60.15.10:FF:000009', NULL, NULL, 'ATP synthase F1 subcomplex epsilon subunit', NULL, NULL, NULL, NULL, NULL, 4),
(19813, NULL, 'G3DSA:3.30.420.40:FF:000925', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19814, NULL, 'G3DSA:1.20.58.60:FF:000190', NULL, NULL, 'Nesprin-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(19815, NULL, 'G3DSA:2.40.10.240:FF:000001', NULL, NULL, 'S-adenosylmethionine:tRNA ribosyltransferase-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(19816, NULL, 'G3DSA:1.10.10.60:FF:001226', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19817, NULL, 'G3DSA:3.30.70.330:FF:003057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19818, NULL, 'G3DSA:2.130.10.10:FF:002226', NULL, NULL, 'Uncharacterized WD repeat-containing protein C343.17c', NULL, NULL, NULL, NULL, NULL, 4),
(19819, NULL, 'G3DSA:3.40.50.150:FF:000618', NULL, NULL, 'Putative mRNA capping methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(19820, NULL, 'G3DSA:3.40.190.10:FF:000311', NULL, NULL, 'Glycine/betaine ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(19821, NULL, 'G3DSA:3.80.10.10:FF:003250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19822, NULL, 'G3DSA:4.10.240.10:FF:000133', NULL, NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(19823, NULL, 'G3DSA:3.50.50.60:FF:000295', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(19824, NULL, 'G3DSA:1.10.3460.10:FF:000014', NULL, NULL, 'BnaA08g04420D protein', NULL, NULL, NULL, NULL, NULL, 4),
(19825, NULL, 'G3DSA:2.60.120.620:FF:000047', NULL, NULL, 'Multifunctional procollagen lysine hydroxylase and glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(19826, NULL, 'G3DSA:1.10.510.10:FF:003206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19827, NULL, 'G3DSA:1.25.40.10:FF:005204', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(19828, NULL, 'G3DSA:3.40.190.10:FF:000783', NULL, NULL, 'Similar to periplasmic dipeptide transport protein (Dipeptide-binding protein) (DBP)-putative secreted, membrane associated or paryphoplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(19829, NULL, 'G3DSA:1.20.1250.20:FF:001117', NULL, NULL, 'Putative allantoate permease of the major facilitator superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(19830, NULL, 'G3DSA:3.30.70.100:FF:000200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19831, NULL, 'G3DSA:1.20.1250.20:FF:000128', NULL, NULL, 'monocarboxylate transporter 12 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(19832, NULL, 'G3DSA:2.40.70.10:FF:000115', NULL, NULL, 'Lysosomal aspartic protease', NULL, NULL, NULL, NULL, NULL, 4),
(19833, NULL, 'G3DSA:2.40.37.10:FF:000027', NULL, NULL, 'Antizyme inhibitor 1a', NULL, NULL, NULL, NULL, NULL, 4),
(19834, NULL, 'G3DSA:3.30.160.60:FF:003316', NULL, NULL, 'Zinc finger protein 433', NULL, NULL, NULL, NULL, NULL, 4),
(19835, NULL, 'G3DSA:2.130.10.10:FF:003171', NULL, NULL, 'Periodic tryptophan protein 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(19836, NULL, 'G3DSA:3.10.100.10:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19837, NULL, 'G3DSA:1.10.10.2660:FF:000007', NULL, NULL, 'SUMO-activating enzyme subunit', NULL, NULL, NULL, NULL, NULL, 4),
(19838, NULL, 'G3DSA:3.80.10.10:FF:002305', NULL, NULL, 'Centrosomal protein 78', NULL, NULL, NULL, NULL, NULL, 4),
(19839, NULL, 'G3DSA:2.130.10.10:FF:002182', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(19840, NULL, 'G3DSA:3.80.10.10:FF:002261', NULL, NULL, 'Leucine-rich repeat-containing protein ODA7', NULL, NULL, NULL, NULL, NULL, 4),
(19841, NULL, 'G3DSA:1.10.20.130:FF:000003', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(19842, NULL, 'G3DSA:2.10.25.10:FF:000170', NULL, NULL, 'thrombospondin-3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(19843, NULL, 'G3DSA:3.30.540.10:FF:000054', NULL, NULL, 'Fructose-1,6-bisphosphatase 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(19844, NULL, 'G3DSA:1.10.510.10:FF:002217', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(19845, NULL, 'G3DSA:1.10.1300.10:FF:000093', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(19846, NULL, 'G3DSA:3.10.105.10:FF:000065', NULL, NULL, 'ABC transporter, oligopeptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(19847, NULL, 'G3DSA:3.30.70.330:FF:002068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19848, NULL, 'G3DSA:3.30.70.330:FF:001449', NULL, NULL, 'RNA-binding_protein_38', NULL, NULL, NULL, NULL, NULL, 4),
(19849, NULL, 'G3DSA:3.10.390.10:FF:000018', NULL, NULL, 'Nuclear autoantigen Sp-100', NULL, NULL, NULL, NULL, NULL, 4),
(19850, NULL, 'G3DSA:1.20.120.1200:FF:000013', NULL, NULL, 'NADH-quinone oxidoreductase subunit J', NULL, NULL, NULL, NULL, NULL, 4),
(19851, NULL, 'G3DSA:1.25.40.10:FF:001944', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g66520 family', NULL, NULL, NULL, NULL, NULL, 4),
(19852, NULL, 'G3DSA:4.10.90.10:FF:000001', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(19853, NULL, 'G3DSA:1.20.1730.10:FF:000061', NULL, NULL, 'Probable sodium/proline symporter (Proline permease)', NULL, NULL, NULL, NULL, NULL, 4),
(19854, NULL, 'G3DSA:2.60.40.60:FF:000987', NULL, NULL, 'Protein CBR-CDH-12', NULL, NULL, NULL, NULL, NULL, 4),
(19855, NULL, 'G3DSA:1.10.10.10:FF:001161', NULL, NULL, 'Leucine-rich repeat serine/threonine-protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(19856, NULL, 'G3DSA:3.30.460.10:FF:000020', NULL, NULL, 'DNA polymerase lambda', NULL, NULL, NULL, NULL, NULL, 4),
(19857, NULL, 'G3DSA:3.40.50.80:FF:000133', NULL, NULL, 'Methionine synthase reductase, mitochondrial-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(19858, NULL, 'G3DSA:1.10.238.10:FF:000639', NULL, NULL, 'Centrin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19859, NULL, 'G3DSA:1.10.10.60:FF:000607', NULL, NULL, 'DNA-binding protein SATB1', NULL, NULL, NULL, NULL, NULL, 4),
(19860, NULL, 'G3DSA:1.10.510.10:FF:000891', NULL, NULL, 'SK22 like MAPKK kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19861, NULL, 'G3DSA:2.40.290.30:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19862, NULL, 'G3DSA:3.30.830.10:FF:000301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19863, NULL, 'G3DSA:2.60.40.10:FF:000124', NULL, NULL, 'Myomesin 1', NULL, NULL, NULL, NULL, NULL, 4),
(19864, NULL, 'G3DSA:3.30.160.60:FF:001029', NULL, NULL, 'PR domain containing 14', NULL, NULL, NULL, NULL, NULL, 4),
(19865, NULL, 'G3DSA:1.10.1000.11:FF:000026', NULL, NULL, 'ArfGEF', NULL, NULL, NULL, NULL, NULL, 4),
(19866, NULL, 'G3DSA:3.40.50.300:FF:005133', NULL, NULL, 'Signal recognition particle receptor beta subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19867, NULL, 'G3DSA:1.20.58.390:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19868, NULL, 'G3DSA:1.25.40.690:FF:000007', NULL, NULL, 'Nucleoporin NUP145', NULL, NULL, NULL, NULL, NULL, 4),
(19869, NULL, 'G3DSA:2.60.40.10:FF:005767', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19870, NULL, 'G3DSA:3.40.50.11030:FF:000003', NULL, NULL, 'Threonylcarbamoyl-AMP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(19871, NULL, 'G3DSA:1.10.287.110:FF:000344', NULL, NULL, 'Chaperone protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19872, NULL, 'G3DSA:3.30.40.10:FF:000269', NULL, NULL, 'Transcription initiation factor IIE subunit alpha', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(19873, NULL, 'G3DSA:2.40.50.40:FF:000067', NULL, NULL, 'LytTR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(19874, NULL, 'G3DSA:1.20.1270.10:FF:000025', NULL, NULL, 'heat shock 70 kDa protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(19875, NULL, 'G3DSA:3.30.930.10:FF:000348', NULL, NULL, 'Aspartate--tRNA ligase chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(19876, NULL, 'G3DSA:3.10.28.10:FF:000045', NULL, NULL, 'Vitamin B12-dependent ribonucleotide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(19877, NULL, 'G3DSA:3.20.20.80:FF:000115', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(19878, NULL, 'G3DSA:3.80.10.10:FF:001316', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(19879, NULL, 'G3DSA:3.40.50.620:FF:000001', NULL, NULL, 'GMP synthase [glutamine-hydrolyzing]', NULL, NULL, NULL, NULL, NULL, 4),
(19880, NULL, 'G3DSA:2.30.30.40:FF:000645', NULL, NULL, 'Myosin-1', NULL, NULL, NULL, NULL, NULL, 4),
(19881, NULL, 'G3DSA:1.25.10.10:FF:001324', NULL, NULL, 'Exonuclease 3''-5'' domain-containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(19882, NULL, 'G3DSA:3.40.50.2300:FF:001544', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19883, NULL, 'G3DSA:3.40.50.300:FF:001108', NULL, NULL, 'DNA polymerase III subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(19884, NULL, 'G3DSA:3.40.50.300:FF:006914', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19885, NULL, 'G3DSA:2.40.10.10:FF:000106', NULL, NULL, 'Probable threonine protease PRSS50', NULL, NULL, NULL, NULL, NULL, 4),
(19886, NULL, 'G3DSA:3.40.525.10:FF:000022', NULL, NULL, 'SEC14 cytosolic factor family protein', NULL, NULL, NULL, NULL, NULL, 4),
(19887, NULL, 'G3DSA:3.30.1680.10:FF:000013', NULL, NULL, 'Semaphorin 4D', NULL, NULL, NULL, NULL, NULL, 4),
(19888, NULL, 'G3DSA:1.25.40.10:FF:002450', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g05670, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(19889, NULL, 'G3DSA:1.10.418.10:FF:000254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19890, NULL, 'G3DSA:2.40.10.10:FF:000095', NULL, NULL, 'Kallikrein related-peptidase 12', NULL, NULL, NULL, NULL, NULL, 4),
(19891, NULL, 'G3DSA:3.40.50.2000:FF:000263', NULL, NULL, 'Glycogen synthase', NULL, NULL, NULL, NULL, NULL, 4),
(19892, NULL, 'G3DSA:3.30.420.60:FF:000009', NULL, NULL, 'Protein pelota homolog', NULL, NULL, NULL, NULL, NULL, 4),
(19893, NULL, 'G3DSA:1.10.10.10:FF:001953', NULL, NULL, 'Histone H1-II-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19894, NULL, 'G3DSA:3.40.1110.10:FF:000120', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(19895, NULL, 'G3DSA:2.30.42.10:FF:000427', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19896, NULL, 'G3DSA:2.40.290.10:FF:000002', NULL, NULL, 'Spen family transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(19897, NULL, 'G3DSA:1.10.10.1100:FF:000017', NULL, NULL, 'FAD/NAD(P)-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(19898, NULL, 'G3DSA:2.60.120.590:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19899, NULL, 'G3DSA:2.30.30.40:FF:000162', NULL, NULL, 'MIA SH3 domain ER export factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(19900, NULL, 'G3DSA:3.40.50.800:FF:000050', NULL, NULL, 'Threonine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(19901, NULL, 'G3DSA:1.25.40.10:FF:004687', NULL, NULL, 'Anaphase-promoting complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(19902, NULL, 'G3DSA:2.130.10.10:FF:000618', NULL, NULL, 'WD repeat-containing protein 75', NULL, NULL, NULL, NULL, NULL, 4),
(19903, NULL, 'G3DSA:2.60.40.1170:FF:000037', NULL, NULL, 'AP-3 complex subunit mu, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19904, NULL, 'G3DSA:2.40.30.10:FF:000006', NULL, NULL, 'Elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(19905, NULL, 'G3DSA:1.10.510.10:FF:003162', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(19906, NULL, 'G3DSA:3.30.70.2760:FF:000004', NULL, NULL, 'HD domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(19907, NULL, 'G3DSA:2.30.30.100:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19908, NULL, 'G3DSA:3.10.110.10:FF:000015', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 N', NULL, NULL, NULL, NULL, NULL, 4),
(19909, NULL, 'G3DSA:3.40.50.300:FF:004986', NULL, NULL, 'Heparan SulphoTransferase', NULL, NULL, NULL, NULL, NULL, 4),
(19910, NULL, 'G3DSA:2.30.110.10:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19911, NULL, 'G3DSA:3.60.130.20:FF:000002', NULL, NULL, 'Prolyl 3,4-dihydroxylase TPA1', NULL, NULL, NULL, NULL, NULL, 4),
(19912, NULL, 'G3DSA:1.10.510.10:FF:000289', NULL, NULL, 'cyclin-dependent kinase 10 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(19913, NULL, 'G3DSA:1.10.510.10:FF:004504', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19914, NULL, 'G3DSA:3.40.50.720:FF:000161', NULL, NULL, 'UDP-N-acetylmuramate--L-alanyl-gamma-D-glutamyl-meso-2,6-diaminoheptandioate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(19915, NULL, 'G3DSA:2.10.50.10:FF:000003', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 19', NULL, NULL, NULL, NULL, NULL, 4),
(19916, NULL, 'G3DSA:3.40.630.30:FF:000014', NULL, NULL, 'N-alpha-acetyltransferase 10 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(19917, NULL, 'G3DSA:1.25.40.70:FF:000074', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(19918, NULL, 'G3DSA:1.20.1250.20:FF:001909', NULL, NULL, 'Protein NUCLEAR FUSION DEFECTIVE 4', NULL, NULL, NULL, NULL, NULL, 4),
(19919, NULL, 'G3DSA:2.60.40.1090:FF:000002', NULL, NULL, 'Fimbrial protein YadN', NULL, NULL, NULL, NULL, NULL, 4),
(19920, NULL, 'G3DSA:1.20.58.2190:FF:000004', NULL, NULL, 'E3 ubiquitin-protein ligase RNF31', NULL, NULL, NULL, NULL, NULL, 4),
(19921, NULL, 'G3DSA:2.30.42.10:FF:000057', NULL, NULL, 'multiple PDZ domain protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(19922, NULL, 'G3DSA:2.10.25.10:FF:000962', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19923, NULL, 'G3DSA:4.10.410.10:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19924, NULL, 'G3DSA:3.40.50.960:FF:000002', NULL, NULL, '6,7-dimethyl-8-ribityllumazine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(19925, NULL, 'G3DSA:1.25.10.10:FF:000705', NULL, NULL, 'Pumilio domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(19926, NULL, 'G3DSA:1.25.10.10:FF:003241', NULL, NULL, 'Cullin-associated NEDD8-dissociated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(19927, NULL, 'G3DSA:3.30.760.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19928, NULL, 'G3DSA:3.40.190.290:FF:000134', NULL, NULL, 'Uncharacterized HTH-type transcriptional regulator HI_1364', NULL, NULL, NULL, NULL, NULL, 4),
(19929, NULL, 'G3DSA:1.25.40.10:FF:004378', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19930, NULL, 'G3DSA:3.10.50.40:FF:000049', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(19931, NULL, 'G3DSA:1.10.287.70:FF:000450', NULL, NULL, 'Voltage-dependent calcium channel subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(19932, NULL, 'G3DSA:3.40.50.1820:FF:000219', NULL, NULL, 'ECM18p protein', NULL, NULL, NULL, NULL, NULL, 4),
(19933, NULL, 'G3DSA:3.30.200.20:FF:000392', NULL, NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(19934, NULL, 'G3DSA:3.10.20.90:FF:000894', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19935, NULL, 'G3DSA:2.60.120.290:FF:000111', NULL, NULL, 'Suppressor of lurcher protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(19936, NULL, 'G3DSA:3.10.20.10:FF:000016', NULL, NULL, 'DNAation factor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(19937, NULL, 'G3DSA:1.10.3260.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(19938, NULL, 'G3DSA:2.40.50.140:FF:000518', NULL, NULL, 'Putative Inner membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(19939, NULL, 'G3DSA:3.20.20.70:FF:000258', NULL, NULL, 'Isopentenyl-diphosphate delta-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(19940, NULL, 'G3DSA:3.30.70.250:FF:000003', NULL, NULL, 'Polyketide beta-ketoacyl synthase Pks3', NULL, NULL, NULL, NULL, NULL, 4),
(19941, NULL, 'G3DSA:2.60.120.200:FF:000820', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19942, NULL, 'G3DSA:2.30.30.40:FF:000515', NULL, NULL, 'Rho GTPase-activating protein 33', NULL, NULL, NULL, NULL, NULL, 4),
(19943, NULL, 'G3DSA:2.60.40.10:FF:003530', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19944, NULL, 'G3DSA:3.30.70.2120:FF:000003', NULL, NULL, 'Flagellin', NULL, NULL, NULL, NULL, NULL, 4),
(19945, NULL, 'G3DSA:1.10.455.10:FF:000014', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(19946, NULL, 'G3DSA:3.40.47.10:FF:000003', NULL, NULL, '3-ketoacyl-CoA thiolase', NULL, NULL, NULL, NULL, NULL, 4),
(19947, NULL, 'G3DSA:3.30.413.10:FF:000023', NULL, NULL, '4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase (flavodoxin)', NULL, NULL, NULL, NULL, NULL, 4),
(19948, NULL, 'G3DSA:3.30.1330.60:FF:000002', NULL, NULL, 'Peptidoglycan-associated lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(19949, NULL, 'G3DSA:3.10.20.90:FF:000585', NULL, NULL, 'DUF2407 ubiquitin-like domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(19950, NULL, 'G3DSA:3.30.310.80:FF:000013', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(19951, NULL, 'G3DSA:1.20.910.10:FF:000020', NULL, NULL, 'Aminopyrimidine aminohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(19952, NULL, 'G3DSA:3.40.50.300:FF:007050', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(19953, NULL, 'G3DSA:3.40.50.300:FF:002732', NULL, NULL, 'Torsin family 4, member Ab', NULL, NULL, NULL, NULL, NULL, 4),
(19954, NULL, 'G3DSA:3.30.70.270:FF:000009', NULL, NULL, 'Protein P', NULL, NULL, NULL, NULL, NULL, 4),
(19955, NULL, 'G3DSA:1.25.40.10:FF:000516', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(19956, NULL, 'G3DSA:3.40.50.300:FF:004514', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(19957, NULL, 'G3DSA:1.20.1070.10:FF:000706', NULL, NULL, 'Neuropeptide Y receptor', NULL, NULL, NULL, NULL, NULL, 4),
(19958, NULL, 'G3DSA:3.30.160.60:FF:002018', NULL, NULL, 'Zinc finger protein 556', NULL, NULL, NULL, NULL, NULL, 4),
(19959, NULL, 'G3DSA:3.40.50.300:FF:005003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19960, NULL, 'G3DSA:1.20.58.70:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19961, NULL, 'G3DSA:3.30.900.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19962, NULL, 'G3DSA:1.20.144.10:FF:000031', NULL, NULL, 'PhosphoLipid PhosPhatase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(19963, NULL, 'G3DSA:3.30.70.330:FF:000640', NULL, NULL, 'UBP1-associated protein 2C', NULL, NULL, NULL, NULL, NULL, 4),
(19964, NULL, 'G3DSA:1.25.10.10:FF:001796', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(19965, NULL, 'G3DSA:1.20.1250.20:FF:001752', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19966, NULL, 'G3DSA:2.60.40.1120:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19967, NULL, 'G3DSA:1.20.1070.10:FF:001342', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19968, NULL, 'G3DSA:3.40.30.10:FF:000482', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(19969, NULL, 'G3DSA:3.40.50.620:FF:000810', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(19970, NULL, 'G3DSA:2.60.120.650:FF:000062', NULL, NULL, 'Probable inactive lysine-specific demethylase JMJ19', NULL, NULL, NULL, NULL, NULL, 4),
(19971, NULL, 'G3DSA:1.20.58.60:FF:000543', NULL, NULL, 'Protein CBG15811', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(19972, NULL, 'G3DSA:3.90.226.10:FF:000165', NULL, NULL, 'Fatty acid oxidation complex alpha-subunit', NULL, NULL, NULL, NULL, NULL, 4),
(19973, NULL, 'G3DSA:3.40.50.620:FF:000440', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(19974, NULL, 'G3DSA:3.90.550.10:FF:000524', NULL, NULL, 'Glycosyl transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(19975, NULL, 'G3DSA:2.60.40.1390:FF:000002', NULL, NULL, 'PhoG like DNA-binding family protein', NULL, NULL, NULL, NULL, NULL, 4),
(19976, NULL, 'G3DSA:1.10.760.10:FF:000009', NULL, NULL, 'Cytochrome bc1 complex cytochrome c subunit', NULL, NULL, NULL, NULL, NULL, 4),
(19977, NULL, 'G3DSA:1.25.40.10:FF:001152', NULL, NULL, 'Os07g0244400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(19978, NULL, 'G3DSA:3.40.50.150:FF:001237', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(19979, NULL, 'G3DSA:3.40.50.1460:FF:000050', NULL, NULL, 'Phosphatidylinositol glycan', NULL, NULL, NULL, NULL, NULL, 4),
(19980, NULL, 'G3DSA:1.10.238.10:FF:001145', NULL, NULL, 'WD repeat domain 66', NULL, NULL, NULL, NULL, NULL, 4),
(19981, NULL, 'G3DSA:2.40.70.10:FF:000071', NULL, NULL, 'Aspartic proteinase PCS1', NULL, NULL, NULL, NULL, NULL, 4),
(19982, NULL, 'G3DSA:3.30.1490.140:FF:000001', NULL, NULL, 'Amyloid beta (A4) protein b', NULL, NULL, NULL, NULL, NULL, 4),
(19983, NULL, 'G3DSA:2.60.120.10:FF:000076', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(19984, NULL, 'G3DSA:3.40.50.10470:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19985, NULL, 'G3DSA:3.40.50.300:FF:001743', NULL, NULL, 'Putative DEAD/DEAH box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(19986, NULL, 'G3DSA:3.10.310.40:FF:000011', NULL, NULL, 'Threonyl/alanyl tRNA synthetase SAD', NULL, NULL, NULL, NULL, NULL, 4),
(19987, NULL, 'G3DSA:1.25.40.10:FF:003759', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19988, NULL, 'G3DSA:3.30.530.20:FF:000129', NULL, NULL, 'Collagen type IV alpha-3-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(19989, NULL, 'G3DSA:2.120.10.80:FF:000157', NULL, NULL, 'leucine-zipper-like transcriptional regulator 1 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(19990, NULL, 'G3DSA:3.30.70.660:FF:000036', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(19991, NULL, 'G3DSA:3.30.160.60:FF:002327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(19992, NULL, 'G3DSA:1.20.85.10:FF:000001', NULL, NULL, 'photosystem II D2 protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(19993, NULL, 'G3DSA:1.10.510.10:FF:000452', NULL, NULL, 'Tau tubulin kinase 2b', NULL, NULL, NULL, NULL, NULL, 4),
(19994, NULL, 'G3DSA:1.20.1050.10:FF:000014', NULL, NULL, 'GSH-dependent disulfide bond oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(19995, NULL, 'G3DSA:1.10.630.10:FF:000719', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(19996, NULL, 'G3DSA:1.20.120.1900:FF:000026', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(19997, NULL, 'G3DSA:2.30.130.40:FF:000013', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(19998, NULL, 'G3DSA:2.120.10.30:FF:000136', NULL, NULL, 'CRE-LIN-41 protein', NULL, NULL, NULL, NULL, NULL, 4),
(19999, NULL, 'G3DSA:1.10.510.10:FF:000761', NULL, NULL, 'SRSF protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(20000, NULL, 'G3DSA:2.20.100.10:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20001, NULL, 'G3DSA:1.25.40.10:FF:003389', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(20002, NULL, 'G3DSA:1.10.287.3990:FF:000008', NULL, NULL, 'Proteasome (Prosome, macropain) 26S subunit, non-ATPase, 4', NULL, NULL, NULL, NULL, NULL, 4),
(20003, NULL, 'G3DSA:2.90.10.10:FF:000025', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(20004, NULL, 'G3DSA:3.30.1520.10:FF:000092', NULL, NULL, 'Sorting nexin-2', NULL, NULL, NULL, NULL, NULL, 4),
(20005, NULL, 'G3DSA:3.40.50.300:FF:006094', NULL, NULL, 'AGAP009548-PA', NULL, NULL, NULL, NULL, NULL, 4),
(20006, NULL, 'G3DSA:3.30.1520.10:FF:000103', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20007, NULL, 'G3DSA:1.10.640.10:FF:000001', NULL, NULL, 'Peroxidasin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(20008, NULL, 'G3DSA:2.130.10.10:FF:002665', NULL, NULL, 'WD repeat-containing protein 76', NULL, NULL, NULL, NULL, NULL, 4),
(20009, NULL, 'G3DSA:3.10.330.10:FF:000009', NULL, NULL, 'Vesicular-fusion protein sec18', NULL, NULL, NULL, NULL, NULL, 4),
(20010, NULL, 'G3DSA:2.30.29.150:FF:000012', NULL, NULL, 'FACT complex subunit SSRP1', NULL, NULL, NULL, NULL, NULL, 4),
(20011, NULL, 'G3DSA:1.10.510.10:FF:002689', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20012, NULL, 'G3DSA:3.30.70.360:FF:000036', NULL, NULL, 'Amidohydrolase amhX', NULL, NULL, NULL, NULL, NULL, 4),
(20013, NULL, 'G3DSA:1.20.5.1300:FF:000013', NULL, NULL, 'Histidinol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(20014, NULL, 'G3DSA:3.40.33.10:FF:000196', NULL, NULL, 'Protein CBR-TAG-254', NULL, NULL, NULL, NULL, NULL, 4),
(20015, NULL, 'G3DSA:3.30.160.60:FF:006189', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20016, NULL, 'G3DSA:3.30.710.10:FF:000354', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20017, NULL, 'G3DSA:2.40.30.330:FF:000004', NULL, NULL, 'mRNA cleavage and polyadenylation factor CLP1', NULL, NULL, NULL, NULL, NULL, 4),
(20018, NULL, 'G3DSA:1.10.510.10:FF:002998', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20019, NULL, 'G3DSA:2.20.70.110:FF:000001', NULL, NULL, 'Similar to Bacterial transferase hexapeptide', NULL, NULL, NULL, NULL, NULL, 4),
(20020, NULL, 'G3DSA:3.50.40.10:FF:000004', NULL, NULL, 'Leucine rich repeat containing 47', NULL, NULL, NULL, NULL, NULL, 4),
(20021, NULL, 'G3DSA:2.30.29.30:FF:000190', NULL, NULL, 'myosin phosphatase Rho-interacting protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(20022, NULL, 'G3DSA:1.10.870.10:FF:000001', NULL, NULL, 'HLA class II histocompatibility antigen gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(20023, NULL, 'G3DSA:2.60.40.1180:FF:000057', NULL, NULL, 'Sugar hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20024, NULL, 'G3DSA:1.10.510.10:FF:004134', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20025, NULL, 'G3DSA:3.10.20.90:FF:000085', NULL, NULL, 'Dual specificity mitogen-activated protein kinase kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(20026, NULL, 'G3DSA:2.60.120.260:FF:000231', NULL, NULL, 'CocE/NonD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(20027, NULL, 'G3DSA:1.10.246.60:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20028, NULL, 'G3DSA:3.40.430.10:FF:000010', NULL, NULL, 'Dihydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(20029, NULL, 'G3DSA:4.10.260.10:FF:000016', NULL, NULL, 'Guanine nucleotide-binding protein (G protein), gamma 12a', NULL, NULL, NULL, NULL, NULL, 4),
(20030, NULL, 'G3DSA:1.20.58.390:FF:000163', NULL, NULL, 'Acetylcholine receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(20031, NULL, 'G3DSA:2.60.40.10:FF:000433', NULL, NULL, 'fibronectin isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(20032, NULL, 'G3DSA:1.10.420.10:FF:000018', NULL, NULL, 'Related to beta-1, 3 exoglucanase', NULL, NULL, NULL, NULL, NULL, 4),
(20033, NULL, 'G3DSA:3.20.20.80:FF:000132', NULL, NULL, 'Beta-galactosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20034, NULL, 'G3DSA:3.40.50.11030:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20035, NULL, 'G3DSA:3.30.160.60:FF:001973', NULL, NULL, 'replication initiator 1', NULL, NULL, NULL, NULL, NULL, 4),
(20036, NULL, 'G3DSA:3.40.50.300:FF:003025', NULL, NULL, 'GTP-binding protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(20037, NULL, 'G3DSA:3.30.70.1230:FF:000192', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(20038, NULL, 'G3DSA:2.130.10.10:FF:001737', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(20039, NULL, 'G3DSA:1.20.1560.10:FF:000244', NULL, NULL, 'ATP-binding cassette protein subfamily B, member 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20040, NULL, 'G3DSA:1.10.10.60:FF:000546', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(20041, NULL, 'G3DSA:3.30.530.20:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20042, NULL, 'G3DSA:3.40.50.1000:FF:000272', NULL, NULL, 'GM16616', NULL, NULL, NULL, NULL, NULL, 4),
(20043, NULL, 'G3DSA:1.20.1050.10:FF:000031', NULL, NULL, 'Glutathione S-Transferase', NULL, NULL, NULL, NULL, NULL, 4),
(20044, NULL, 'G3DSA:1.10.630.10:FF:000736', NULL, NULL, 'Cytochrome P450, family 3, subfamily c, polypeptide 1', NULL, NULL, NULL, NULL, NULL, 4),
(20045, NULL, 'G3DSA:3.30.160.60:FF:001490', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM50', NULL, NULL, NULL, NULL, NULL, 4),
(20046, NULL, 'G3DSA:3.40.50.2020:FF:000010', NULL, NULL, 'Uridine-cytidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(20047, NULL, 'G3DSA:3.40.1130.10:FF:000003', NULL, NULL, 'Putative glycerol-3-phosphate 1-O-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(20048, NULL, 'G3DSA:3.40.190.10:FF:000002', NULL, NULL, 'Glutamine ABC transporter periplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(20049, NULL, 'G3DSA:3.40.850.10:FF:000002', NULL, NULL, 'Unconventional myosin IC', NULL, NULL, NULL, NULL, NULL, 4),
(20050, NULL, 'G3DSA:2.60.120.330:FF:000084', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20051, NULL, 'G3DSA:2.40.10.10:FF:000123', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(20052, NULL, 'G3DSA:3.30.200.20:FF:001201', NULL, NULL, 'serine/threonine-protein kinase D6PK-like', NULL, NULL, NULL, NULL, NULL, 4),
(20053, NULL, 'G3DSA:3.40.50.300:FF:004194', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(20054, NULL, 'G3DSA:3.40.1110.10:FF:000103', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(20055, NULL, 'G3DSA:3.40.50.2000:FF:000246', NULL, NULL, 'ALG1, chitobiosyldiphosphodolichol beta-mannosyltransferase like', NULL, NULL, NULL, NULL, NULL, 4),
(20056, NULL, 'G3DSA:3.40.50.150:FF:000748', NULL, NULL, 'MEthylTransferase Like', NULL, NULL, NULL, NULL, NULL, 4),
(20057, NULL, 'G3DSA:1.20.970.10:FF:000012', NULL, NULL, 'Thymidine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(20058, NULL, 'G3DSA:1.10.10.2360:FF:000007', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20059, NULL, 'G3DSA:2.10.25.10:FF:001479', NULL, NULL, 'low-density lipoprotein receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(20060, NULL, 'G3DSA:1.25.40.820:FF:000002', NULL, NULL, 'RTR1p CTD phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(20061, NULL, 'G3DSA:1.10.238.10:FF:000948', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20062, NULL, 'G3DSA:1.10.8.60:FF:000197', NULL, NULL, 'Peroxisomal biogenesis factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(20063, NULL, 'G3DSA:2.40.160.60:FF:000002', NULL, NULL, 'Outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(20064, NULL, 'G3DSA:1.10.1660.10:FF:000012', NULL, NULL, 'DNA-binding protein, excisionase family', NULL, NULL, NULL, NULL, NULL, 4),
(20065, NULL, 'G3DSA:3.40.50.80:FF:000003', NULL, NULL, 'Nitric oxide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(20066, NULL, 'G3DSA:1.20.1070.10:FF:001325', NULL, NULL, 'Olfactory receptor C3', NULL, NULL, NULL, NULL, NULL, 4),
(20067, NULL, 'G3DSA:3.40.630.10:FF:000267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20068, NULL, 'G3DSA:3.40.47.40:FF:000001', NULL, NULL, 'Stage V sporulation protein AD', NULL, NULL, NULL, NULL, NULL, 4),
(20069, NULL, 'G3DSA:3.40.50.300:FF:000271', NULL, NULL, 'ATP-dependent Clp protease ATP-binding subunit ClpA', NULL, NULL, NULL, NULL, NULL, 4),
(20070, NULL, 'G3DSA:3.30.450.20:FF:000404', NULL, NULL, 'Sensor histidine kinase, PAS, PAS and PAS domain-containing', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(20071, NULL, 'G3DSA:3.20.20.30:FF:000033', NULL, NULL, 'Alkanesulfonate monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(20072, NULL, 'G3DSA:3.90.226.10:FF:000035', NULL, NULL, 'ATP-dependent Clp protease proteolytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(20073, NULL, 'G3DSA:1.10.340.70:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20074, NULL, 'G3DSA:3.30.70.960:FF:000019', NULL, NULL, 'Serine protease H129', NULL, NULL, NULL, NULL, NULL, 4),
(20075, NULL, 'G3DSA:2.160.20.10:FF:000112', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(20076, NULL, 'G3DSA:3.40.50.300:FF:005503', NULL, NULL, 'ATP-dependent RNA helicase A', NULL, NULL, NULL, NULL, NULL, 4),
(20077, NULL, 'G3DSA:3.40.50.300:FF:004969', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20078, NULL, 'G3DSA:1.10.357.50:FF:000028', NULL, NULL, 'Component of the exocyst complex', NULL, NULL, NULL, NULL, NULL, 4),
(20079, NULL, 'G3DSA:2.120.10.80:FF:000027', NULL, NULL, 'Influenza virus NS1A-binding protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(20080, NULL, 'G3DSA:2.70.170.10:FF:000279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20081, NULL, 'G3DSA:3.60.21.10:FF:000443', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20082, NULL, 'G3DSA:4.10.1240.10:FF:000068', NULL, NULL, 'Gastric inhibitory polypeptide receptor', NULL, NULL, NULL, NULL, NULL, 4),
(20083, NULL, 'G3DSA:3.40.50.300:FF:008229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20084, NULL, 'G3DSA:3.40.50.300:FF:007403', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20085, NULL, 'G3DSA:2.60.40.60:FF:000206', NULL, NULL, 'cadherin-23 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(20086, NULL, 'G3DSA:2.170.270.10:FF:000026', NULL, NULL, 'PR domain zinc finger protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(20087, NULL, 'G3DSA:1.25.10.10:FF:000352', NULL, NULL, 'Serine/threonine-protein phosphatase 4 regulatory subunit 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(20088, NULL, 'G3DSA:1.25.40.20:FF:000784', NULL, NULL, 'Ankyrin_repeats_(3_copies)/Ankyrin_repeats_(Many_ copies)/Ankyrin_repeat/DHHC_palmitoyltransferase_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(20089, NULL, 'G3DSA:3.30.70.2460:FF:000004', NULL, NULL, 'Rad4-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(20090, NULL, 'G3DSA:3.90.1150.10:FF:000482', NULL, NULL, 'Kynureninase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20091, NULL, 'G3DSA:2.130.10.10:FF:000557', NULL, NULL, 'WD repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(20092, NULL, 'G3DSA:1.10.3460.10:FF:000031', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20093, NULL, 'G3DSA:3.30.590.50:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20094, NULL, 'G3DSA:2.60.120.200:FF:000157', NULL, NULL, 'Beta-glucan synthesis-associated protein SKN1', NULL, NULL, NULL, NULL, NULL, 4),
(20095, NULL, 'G3DSA:3.30.450.20:FF:000112', NULL, NULL, 'Taiman, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(20096, NULL, 'G3DSA:3.80.10.10:FF:003233', NULL, NULL, 'Protein CBG25032', NULL, NULL, NULL, NULL, NULL, 4),
(20097, NULL, 'G3DSA:3.30.760.10:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20098, NULL, 'G3DSA:3.30.70.330:FF:000140', NULL, NULL, 'CUGBP Elav-like family member 4 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(20099, NULL, 'G3DSA:3.30.300.10:FF:000008', NULL, NULL, 'GMP synthase [glutamine-hydrolyzing]', NULL, NULL, NULL, NULL, NULL, 4),
(20100, NULL, 'G3DSA:1.10.3730.20:FF:000044', NULL, NULL, 'Integral membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(20101, NULL, 'G3DSA:3.40.50.920:FF:000001', NULL, NULL, 'Pyruvate dehydrogenase E1 beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(20102, NULL, 'G3DSA:2.130.10.10:FF:004143', NULL, NULL, 'Block of proliferation protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20103, NULL, 'G3DSA:2.60.120.920:FF:000047', NULL, NULL, 'SPRY domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(20104, NULL, 'G3DSA:3.40.640.10:FF:000195', NULL, NULL, 'ARO9p Aromatic aminotransferase II', NULL, NULL, NULL, NULL, NULL, 4),
(20105, NULL, 'G3DSA:1.10.287.70:FF:000579', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20106, NULL, 'G3DSA:2.60.40.10:FF:004356', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20107, NULL, 'G3DSA:3.30.420.140:FF:000011', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(20108, NULL, 'G3DSA:3.80.10.10:FF:001333', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase EFR', NULL, NULL, NULL, NULL, NULL, 4),
(20109, NULL, 'G3DSA:1.10.510.10:FF:001380', NULL, NULL, 'Checkpoint kinase 2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(20110, NULL, 'G3DSA:1.20.1070.10:FF:000044', NULL, NULL, 'Opsin, ultraviolet-sensitive', NULL, NULL, NULL, NULL, NULL, 4),
(20111, NULL, 'G3DSA:3.40.50.12780:FF:000224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20112, NULL, 'G3DSA:2.10.25.10:FF:001007', NULL, NULL, 'GD14540', NULL, NULL, NULL, NULL, NULL, 4),
(20113, NULL, 'G3DSA:2.30.29.30:FF:001369', NULL, NULL, 'Exocyst complex component exo84', NULL, NULL, NULL, NULL, NULL, 4),
(20114, NULL, 'G3DSA:3.30.200.20:FF:001673', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20115, NULL, 'G3DSA:1.10.1600.10:FF:000003', NULL, NULL, 'ATP-dependent DNA helicase 2 subunit KU70', NULL, NULL, NULL, NULL, NULL, 4),
(20116, NULL, 'G3DSA:2.10.50.30:FF:000009', NULL, NULL, 'Vomeronasal 2, receptor 66', NULL, NULL, NULL, NULL, NULL, 4),
(20117, NULL, 'G3DSA:3.30.40.10:FF:002214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20118, NULL, 'G3DSA:2.40.10.10:FF:000415', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20119, NULL, 'G3DSA:1.20.140.20:FF:000003', NULL, NULL, '[Pyruvate dehydrogenase (Acetyl-transferring)] kinase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(20120, NULL, 'G3DSA:3.40.120.10:FF:000037', NULL, NULL, 'Pgm3p', NULL, NULL, NULL, NULL, NULL, 4),
(20121, NULL, 'G3DSA:3.10.490.10:FF:000054', NULL, NULL, 'Gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(20122, NULL, 'G3DSA:3.30.830.10:FF:000273', NULL, NULL, 'Insulin-degrading enzyme homolog', NULL, NULL, NULL, NULL, NULL, 4),
(20123, NULL, 'G3DSA:1.20.1730.10:FF:000044', NULL, NULL, 'Urea transporter/permease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20124, NULL, 'G3DSA:3.30.70.330:FF:002085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20125, NULL, 'G3DSA:2.130.10.10:FF:003963', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20126, NULL, 'G3DSA:1.20.1250.20:FF:001089', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20127, NULL, 'G3DSA:3.40.850.10:FF:000339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20128, NULL, 'G3DSA:2.130.10.10:FF:002535', NULL, NULL, 'F-box and WD repeat domain containing 9', NULL, NULL, NULL, NULL, NULL, 4),
(20129, NULL, 'G3DSA:3.40.30.10:FF:000835', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(20130, NULL, 'G3DSA:3.30.70.330:FF:000623', NULL, NULL, 'Splicing factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(20131, NULL, 'G3DSA:1.25.10.10:FF:000835', NULL, NULL, 'Protein TPLATE', NULL, NULL, NULL, NULL, NULL, 4),
(20132, NULL, 'G3DSA:3.30.160.60:FF:001046', NULL, NULL, 'Zinc finger and BTB domain containing 46', NULL, NULL, NULL, NULL, NULL, 4),
(20133, NULL, 'G3DSA:1.20.58.60:FF:000560', NULL, NULL, 'Plectin', NULL, NULL, NULL, NULL, NULL, 4),
(20134, NULL, 'G3DSA:1.10.940.10:FF:000029', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase B', NULL, NULL, NULL, NULL, NULL, 4),
(20135, NULL, 'G3DSA:3.20.190.10:FF:000001', NULL, NULL, 'Formamidopyrimidine-DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(20136, NULL, 'G3DSA:3.40.430.10:FF:000038', NULL, NULL, 'DHFR, dihydrofolate reductase, cytosolic form (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(20137, NULL, 'G3DSA:1.10.238.10:FF:001128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(20138, NULL, 'G3DSA:1.10.287.3440:FF:000001', NULL, NULL, 'Biosynthetic arginine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(20139, NULL, 'G3DSA:3.40.50.12710:FF:000001', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7', NULL, NULL, NULL, NULL, NULL, 4),
(20140, NULL, 'G3DSA:3.30.2010.10:FF:000019', NULL, NULL, 'Peptidase family M48 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(20141, NULL, 'G3DSA:2.10.110.10:FF:000114', NULL, NULL, 'Apterous, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(20142, NULL, 'G3DSA:2.130.10.10:FF:004891', NULL, NULL, 'IP10750p', NULL, NULL, NULL, NULL, NULL, 4),
(20143, NULL, 'G3DSA:1.10.238.10:FF:000156', NULL, NULL, 'Actinin alpha 4', NULL, NULL, NULL, NULL, NULL, 4),
(20144, NULL, 'G3DSA:3.40.50.1240:FF:000085', NULL, NULL, 'Multiple inositol polyphosphate phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20145, NULL, 'G3DSA:3.70.10.10:FF:000029', NULL, NULL, 'DNA damage checkpoint control protein rad1', NULL, NULL, NULL, NULL, NULL, 4),
(20146, NULL, 'G3DSA:3.80.10.10:FF:004059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20147, NULL, 'G3DSA:3.40.50.300:FF:003660', NULL, NULL, 'Regulator of telomere elongation helicase rtel1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20148, NULL, 'G3DSA:3.10.20.90:FF:000877', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20149, NULL, 'G3DSA:1.10.510.10:FF:000109', NULL, NULL, 'Ribosomal protein S6 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(20150, NULL, 'G3DSA:3.40.50.300:FF:006122', NULL, NULL, 'RAS, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20151, NULL, 'G3DSA:1.25.40.20:FF:001138', NULL, NULL, 'Protein shank', NULL, NULL, NULL, NULL, NULL, 4),
(20152, NULL, 'G3DSA:3.40.390.30:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20153, NULL, 'G3DSA:3.30.70.2850:FF:000031', NULL, NULL, 'Putative mediator of RNA polymerase II transcription subunit 12', NULL, NULL, NULL, NULL, NULL, 4),
(20154, NULL, 'G3DSA:2.40.128.20:FF:000022', NULL, NULL, 'Outer membrane lipoprotein Blc', NULL, NULL, NULL, NULL, NULL, 4),
(20155, NULL, 'G3DSA:2.60.120.970:FF:000101', NULL, NULL, 'Bone morphogenetic protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(20156, NULL, 'G3DSA:1.10.287.90:FF:000017', NULL, NULL, 'Cytochrome c oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(20157, NULL, 'G3DSA:1.10.3730.20:FF:000027', NULL, NULL, 'Yeast Homolog UDP-Gal Transporter', NULL, NULL, NULL, NULL, NULL, 4),
(20158, NULL, 'G3DSA:3.30.160.60:FF:002799', NULL, NULL, 'Zinc finger protein 737', NULL, NULL, NULL, NULL, NULL, 4),
(20159, NULL, 'G3DSA:1.10.1670.10:FF:000069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20160, NULL, 'G3DSA:2.10.110.10:FF:000244', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(20161, NULL, 'G3DSA:2.60.120.260:FF:000259', NULL, NULL, 'SUN domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(20162, NULL, 'G3DSA:1.10.287.380:FF:000037', NULL, NULL, 'ABC transporter, ATP-binding protein, EF-3 family', NULL, NULL, NULL, NULL, NULL, 4),
(20163, NULL, 'G3DSA:1.25.40.10:FF:000180', NULL, NULL, 'Related to UDP-N-acetylglucosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(20164, NULL, 'G3DSA:2.10.50.30:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20165, NULL, 'G3DSA:2.60.40.10:FF:001613', NULL, NULL, 'Interleukin 12 receptor subunit beta 1', NULL, NULL, NULL, NULL, NULL, 4),
(20166, NULL, 'G3DSA:1.20.1720.10:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20167, NULL, 'G3DSA:1.10.510.10:FF:003515', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20168, NULL, 'G3DSA:3.40.50.300:FF:000815', NULL, NULL, 'Dynein heavy chain 2, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(20169, NULL, 'G3DSA:3.40.50.150:FF:000309', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(20170, NULL, 'G3DSA:3.40.50.300:FF:006431', NULL, NULL, 'Septin 7b', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(20171, NULL, 'G3DSA:3.30.710.10:FF:000337', NULL, NULL, 'Mg2+ transporter protein, CorA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(20172, NULL, 'G3DSA:2.10.50.10:FF:000020', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 1A', NULL, NULL, NULL, NULL, NULL, 4),
(20173, NULL, 'G3DSA:1.20.120.350:FF:000049', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(20174, NULL, 'G3DSA:1.10.510.10:FF:002717', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20175, NULL, 'G3DSA:3.40.50.300:FF:003997', NULL, NULL, 'GTP-binding nuclear protein Ran', NULL, NULL, NULL, NULL, NULL, 4),
(20176, NULL, 'G3DSA:2.130.10.10:FF:004582', NULL, NULL, 'Ribosomal large subunit assembly and maintenance-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20177, NULL, 'G3DSA:2.60.40.10:FF:001052', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(20178, NULL, 'G3DSA:2.60.120.260:FF:000568', NULL, NULL, 'Putative secreted beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(20179, NULL, 'G3DSA:1.10.510.10:FF:004151', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20180, NULL, 'G3DSA:2.130.10.10:FF:002682', NULL, NULL, 'DDB1- and CUL4-associated factor 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(20181, NULL, 'G3DSA:2.60.40.60:FF:001134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20182, NULL, 'G3DSA:3.20.20.140:FF:000114', NULL, NULL, 'Hydrolase, TatD family', NULL, NULL, NULL, NULL, NULL, 4),
(20183, NULL, 'G3DSA:3.40.50.300:FF:008359', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20184, NULL, 'G3DSA:3.10.100.10:FF:000413', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20185, NULL, 'G3DSA:1.50.10.20:FF:000100', NULL, NULL, 'Mannan endo-1,6-alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(20186, NULL, 'G3DSA:1.20.120.330:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20187, NULL, 'G3DSA:1.10.520.10:FF:000054', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(20188, NULL, 'G3DSA:1.50.40.10:FF:000571', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20189, NULL, 'G3DSA:1.10.8.270:FF:000062', NULL, NULL, 'GTPase activating protein, conserved', NULL, NULL, NULL, NULL, NULL, 4),
(20190, NULL, 'G3DSA:1.20.1560.10:FF:000261', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20191, NULL, 'G3DSA:3.30.160.60:FF:005896', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20192, NULL, 'G3DSA:2.40.20.10:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20193, NULL, 'G3DSA:3.30.70.1070:FF:000019', NULL, NULL, 'Endolytic peptidoglycan transglycosylase RlpA', NULL, NULL, NULL, NULL, NULL, 4),
(20194, NULL, 'G3DSA:3.30.420.40:FF:000133', NULL, NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(20195, NULL, 'G3DSA:2.30.29.30:FF:000088', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(20196, NULL, 'G3DSA:2.10.25.10:FF:000299', NULL, NULL, 'Notch receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(20197, NULL, 'G3DSA:2.60.120.330:FF:000067', NULL, NULL, 'Probable flavonol synthase 5', NULL, NULL, NULL, NULL, NULL, 4),
(20198, NULL, 'G3DSA:3.40.50.300:FF:001451', NULL, NULL, 'Dynamin GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(20199, NULL, 'G3DSA:2.130.10.10:FF:005099', NULL, NULL, 'WD40 repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(20200, NULL, 'G3DSA:1.10.472.80:FF:000086', NULL, NULL, 'TBC1 domain family, member 25', NULL, NULL, NULL, NULL, NULL, 4),
(20201, NULL, 'G3DSA:2.160.20.10:FF:000242', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(20202, NULL, 'G3DSA:3.40.50.300:FF:001760', NULL, NULL, 'ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(20203, NULL, 'G3DSA:1.20.58.1030:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20204, NULL, 'G3DSA:1.10.150.240:FF:000131', NULL, NULL, 'Protein CBG00583', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(20205, NULL, 'G3DSA:3.40.50.150:FF:001254', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20206, NULL, 'G3DSA:1.10.8.10:FF:000013', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(20207, NULL, 'G3DSA:3.40.50.1820:FF:001490', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20208, NULL, 'G3DSA:2.130.10.10:FF:005071', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(20209, NULL, 'G3DSA:2.60.120.1190:FF:000004', NULL, NULL, 'Discoidin domain receptor tyrosine kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(20210, NULL, 'G3DSA:3.40.50.300:FF:003688', NULL, NULL, 'Dynein alpha chain, flagellar outer arm', NULL, NULL, NULL, NULL, NULL, 4),
(20211, NULL, 'G3DSA:3.30.70.260:FF:000023', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(20212, NULL, 'G3DSA:3.40.50.300:FF:004177', NULL, NULL, 'DNA helicase INO80', NULL, NULL, NULL, NULL, NULL, 4),
(20213, NULL, 'G3DSA:3.40.50.10260:FF:000013', NULL, NULL, 'NAD(P)H-hydrate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(20214, NULL, 'G3DSA:3.30.260.10:FF:000055', NULL, NULL, 'T-complex protein 1 subunit eta', NULL, NULL, NULL, NULL, NULL, 4),
(20215, NULL, 'G3DSA:1.10.10.10:FF:000508', NULL, NULL, 'Segregation and condensation protein B', NULL, NULL, NULL, NULL, NULL, 4),
(20216, NULL, 'G3DSA:2.60.40.1690:FF:000002', NULL, NULL, 'Fusion glycoprotein F0', NULL, NULL, NULL, NULL, NULL, 4),
(20217, NULL, 'G3DSA:2.60.40.10:FF:002439', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(20218, NULL, 'G3DSA:2.60.120.10:FF:000637', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20219, NULL, 'G3DSA:1.25.10.10:FF:000627', NULL, NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(20220, NULL, 'G3DSA:2.60.40.10:FF:004047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20221, NULL, 'G3DSA:2.40.50.90:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20222, NULL, 'G3DSA:3.40.50.300:FF:002277', NULL, NULL, 'Meiotic spindle formation protein mei-1', NULL, NULL, NULL, NULL, NULL, 4),
(20223, NULL, 'G3DSA:3.30.420.10:FF:000719', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20224, NULL, 'G3DSA:3.30.390.30:FF:000031', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(20225, NULL, 'G3DSA:3.30.420.10:FF:000135', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(20226, NULL, 'G3DSA:1.10.20.10:FF:000009', NULL, NULL, 'Histone H2A', NULL, NULL, NULL, NULL, NULL, 4),
(20227, NULL, 'G3DSA:2.60.40.420:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20228, NULL, 'G3DSA:3.30.70.330:FF:000595', NULL, NULL, 'UBP1-associated protein 2C-like', NULL, NULL, NULL, NULL, NULL, 4),
(20229, NULL, 'G3DSA:3.90.660.10:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20230, NULL, 'G3DSA:3.20.20.70:FF:000819', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20231, NULL, 'G3DSA:1.10.510.10:FF:000317', NULL, NULL, 'PTI1-like tyrosine-protein kinase At3g15890', NULL, NULL, NULL, NULL, NULL, 4),
(20232, NULL, 'G3DSA:1.20.1510.10:FF:000078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20233, NULL, 'G3DSA:1.20.1070.10:FF:000061', NULL, NULL, 'Adenosine receptor A2', NULL, NULL, NULL, NULL, NULL, 4),
(20234, NULL, 'G3DSA:4.10.800.10:FF:000036', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20235, NULL, 'G3DSA:1.20.1270.280:FF:000080', NULL, NULL, 'Dynein, axonemal, heavy chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(20236, NULL, 'G3DSA:3.90.1310.10:FF:000028', NULL, NULL, 'Stage V sporulation protein D', NULL, NULL, NULL, NULL, NULL, 4),
(20237, NULL, 'G3DSA:3.30.160.60:FF:003979', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20238, NULL, 'G3DSA:3.30.160.60:FF:005071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20239, NULL, 'G3DSA:2.10.10.100:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(20240, NULL, 'G3DSA:3.30.310.40:FF:000012', NULL, NULL, '8-oxoguanine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(20241, NULL, 'G3DSA:2.130.10.10:FF:000765', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(20242, NULL, 'G3DSA:4.10.60.10:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20243, NULL, 'G3DSA:2.70.160.11:FF:000083', NULL, NULL, 'E3 ubiquitin-protein ligase CCNB1IP1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(20244, NULL, 'G3DSA:1.25.10.10:FF:000043', NULL, NULL, 'Unc-45 myosin chaperone B', NULL, NULL, NULL, NULL, NULL, 4),
(20245, NULL, 'G3DSA:2.170.16.10:FF:000012', NULL, NULL, 'Replication factor C small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(20246, NULL, 'G3DSA:3.30.420.40:FF:000150', NULL, NULL, 'Actin-related protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(20247, NULL, 'G3DSA:1.10.510.10:FF:000744', NULL, NULL, 'Putative mitogen activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(20248, NULL, 'G3DSA:2.30.42.10:FF:000618', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20249, NULL, 'G3DSA:1.25.40.20:FF:000654', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20250, NULL, 'G3DSA:2.10.25.10:FF:001024', NULL, NULL, 'Crumbs-like protein 2b', NULL, NULL, NULL, NULL, NULL, 4),
(20251, NULL, 'G3DSA:1.20.5.170:FF:000018', NULL, NULL, 'AAA ATPase forming ring-shaped complexes', NULL, NULL, NULL, NULL, NULL, 4),
(20252, NULL, 'G3DSA:6.20.10.30:FF:000014', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(20253, NULL, 'G3DSA:2.160.10.10:FF:000022', NULL, NULL, 'Glucose-1-phosphate adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(20254, NULL, 'G3DSA:1.10.510.10:FF:000789', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(20255, NULL, 'G3DSA:3.30.505.10:FF:000259', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20256, NULL, 'G3DSA:3.40.366.10:FF:000006', NULL, NULL, 'Fatty acid synthase beta subunit dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(20257, NULL, 'G3DSA:3.30.200.20:FF:000936', NULL, NULL, 'Cyclin-dependent kinase A-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20258, NULL, 'G3DSA:1.20.5.430:FF:000001', NULL, NULL, 'Nuclear receptor corepressor 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(20259, NULL, 'G3DSA:3.30.780.10:FF:000050', NULL, NULL, 'Translation initiation factor sui1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(20260, NULL, 'G3DSA:1.20.1250.20:FF:000263', NULL, NULL, 'Proton-coupled folate transporter isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(20261, NULL, 'G3DSA:3.40.630.10:FF:000475', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20262, NULL, 'G3DSA:2.10.25.10:FF:000035', NULL, NULL, 'Signal peptide, CUB domain and EGF-like domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(20263, NULL, 'G3DSA:2.130.10.110:FF:000025', NULL, NULL, 'Clathrin heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20264, NULL, 'G3DSA:1.20.1050.130:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20265, NULL, 'G3DSA:2.30.29.30:FF:000116', NULL, NULL, 'Rho GTPase activating protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(20266, NULL, 'G3DSA:1.25.40.10:FF:004350', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(20267, NULL, 'G3DSA:3.30.930.10:FF:000320', NULL, NULL, 'Phenylalanine--tRNA ligase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(20268, NULL, 'G3DSA:2.130.10.10:FF:003946', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20269, NULL, 'G3DSA:1.25.40.10:FF:003889', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20270, NULL, 'G3DSA:3.30.160.60:FF:004452', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20271, NULL, 'G3DSA:2.60.40.60:FF:000650', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20272, NULL, 'G3DSA:1.10.238.10:FF:000717', NULL, NULL, 'Endocytic protein, putative', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(20273, NULL, 'G3DSA:3.40.50.720:FF:000352', NULL, NULL, '3-sulfolactaldehyde reductase', NULL, NULL, NULL, NULL, NULL, 4),
(20274, NULL, 'G3DSA:3.10.20.90:FF:000646', NULL, NULL, 'Autophagy-related protein 8-like protein DDB_G0290491', NULL, NULL, NULL, NULL, NULL, 4),
(20275, NULL, 'G3DSA:1.50.40.10:FF:000363', NULL, NULL, 'Solute carrier family 25 member 33', NULL, NULL, NULL, NULL, NULL, 4),
(20276, NULL, 'G3DSA:2.30.30.100:FF:000027', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm8', NULL, NULL, NULL, NULL, NULL, 4),
(20277, NULL, 'G3DSA:1.10.10.60:FF:001035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20278, NULL, 'G3DSA:1.10.510.10:FF:002026', NULL, NULL, 'Serine/threonine-protein kinase pink-1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(20279, NULL, 'G3DSA:3.60.110.10:FF:000021', NULL, NULL, 'Nit3p', NULL, NULL, NULL, NULL, NULL, 4),
(20280, NULL, 'G3DSA:1.25.40.20:FF:000553', NULL, NULL, 'Protein HOS4', NULL, NULL, NULL, NULL, NULL, 4),
(20281, NULL, 'G3DSA:3.30.70.330:FF:000168', NULL, NULL, 'RNA binding motif protein 46', NULL, NULL, NULL, NULL, NULL, 4),
(20282, NULL, 'G3DSA:3.40.390.10:FF:000231', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20283, NULL, 'G3DSA:3.30.559.10:FF:000030', NULL, NULL, 'Carnitine O-palmitoyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(20284, NULL, 'G3DSA:3.40.50.1820:FF:001282', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20285, NULL, 'G3DSA:3.30.70.2850:FF:000014', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(20286, NULL, 'G3DSA:3.30.200.20:FF:002162', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(20287, NULL, 'G3DSA:1.10.1220.170:FF:000001', NULL, NULL, 'Antitoxin', NULL, NULL, NULL, NULL, NULL, 4),
(20288, NULL, 'G3DSA:2.60.40.10:FF:002350', NULL, NULL, 'Immunoglobulin heavy variable 1-4', NULL, NULL, NULL, NULL, NULL, 4),
(20289, NULL, 'G3DSA:2.10.110.10:FF:000261', NULL, NULL, 'Putative lim domain binding protein ldb1/nli/clim', NULL, NULL, NULL, NULL, NULL, 4),
(20290, NULL, 'G3DSA:3.40.630.30:FF:000677', NULL, NULL, 'Diamine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(20291, NULL, 'G3DSA:2.60.40.10:FF:001260', NULL, NULL, 'Sodium channel subunit beta-4', NULL, NULL, NULL, NULL, NULL, 4),
(20292, NULL, 'G3DSA:1.10.472.10:FF:000424', NULL, NULL, 'CYCLIN D71', NULL, NULL, NULL, NULL, NULL, 4),
(20293, NULL, 'G3DSA:3.30.160.60:FF:000753', NULL, NULL, 'zinc finger protein 236 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(20294, NULL, 'G3DSA:3.30.70.330:FF:001112', NULL, NULL, 'U1 small nuclear ribonucleoprotein usp102', NULL, NULL, NULL, NULL, NULL, 4),
(20295, NULL, 'G3DSA:1.10.40.30:FF:000022', NULL, NULL, 'Adenylosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(20296, NULL, 'G3DSA:1.20.1080.10:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20297, NULL, 'G3DSA:1.10.10.980:FF:000003', NULL, NULL, 'CST complex subunit STN1', NULL, NULL, NULL, NULL, NULL, 4),
(20298, NULL, 'G3DSA:3.40.50.10990:FF:000007', NULL, NULL, '3,4-dihydroxy-2-butanone 4-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(20299, NULL, 'G3DSA:1.20.1270.60:FF:000124', NULL, NULL, 'Endophilin-A homolog', NULL, NULL, NULL, NULL, NULL, 4),
(20300, NULL, 'G3DSA:3.90.1290.10:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20301, NULL, 'G3DSA:2.10.220.10:FF:000134', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(20302, NULL, 'G3DSA:2.60.120.10:FF:000593', NULL, NULL, 'AGAP000467-PA', NULL, NULL, NULL, NULL, NULL, 4),
(20303, NULL, 'G3DSA:1.20.120.1370:FF:000002', NULL, NULL, 'Regulator of sigma D', NULL, NULL, NULL, NULL, NULL, 4),
(20304, NULL, 'G3DSA:1.10.287.110:FF:000209', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(20305, NULL, 'G3DSA:2.40.170.20:FF:000075', NULL, NULL, 'SusC/RagA family TonB-linked outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(20306, NULL, 'G3DSA:3.40.50.1220:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20307, NULL, 'G3DSA:1.25.40.10:FF:000764', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(20308, NULL, 'G3DSA:3.30.160.60:FF:001473', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20309, NULL, 'G3DSA:3.30.70.330:FF:002629', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20310, NULL, 'G3DSA:3.40.50.2000:FF:000015', NULL, NULL, 'Bifunctional UDP-N-acetylglucosamine 2-epimerase/N-acetylmannosamine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(20311, NULL, 'G3DSA:2.60.120.10:FF:000385', NULL, NULL, 'Cruciferin 3', NULL, NULL, NULL, NULL, NULL, 4),
(20312, NULL, 'G3DSA:3.40.50.20:FF:000031', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(20313, NULL, 'G3DSA:3.80.10.10:FF:000035', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(20314, NULL, 'G3DSA:2.60.40.10:FF:005784', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20315, NULL, 'G3DSA:3.60.20.30:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20316, NULL, 'G3DSA:2.130.10.10:FF:004935', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20317, NULL, 'G3DSA:3.40.50.1440:FF:000156', NULL, NULL, 'Tubulin', NULL, NULL, NULL, NULL, NULL, 4),
(20318, NULL, 'G3DSA:3.40.50.880:FF:000028', NULL, NULL, 'Imidazole glycerol phosphate synthase subunit HisH', NULL, NULL, NULL, NULL, NULL, 4),
(20319, NULL, 'G3DSA:1.20.1250.20:FF:001561', NULL, NULL, 'MFS alpha-glucoside transporter, putative (AFU_orthologue AFUA_5G00500)', NULL, NULL, NULL, NULL, NULL, 4),
(20320, NULL, 'G3DSA:2.40.30.10:FF:000450', NULL, NULL, 'Protein CBG00492', NULL, NULL, NULL, NULL, NULL, 4),
(20321, NULL, 'G3DSA:3.40.50.300:FF:005150', NULL, NULL, 'ADP-ribosylation factor', NULL, NULL, NULL, NULL, NULL, 4),
(20322, NULL, 'G3DSA:1.20.1050.10:FF:000262', NULL, NULL, 'Glutathione S-transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20323, NULL, 'G3DSA:4.10.400.10:FF:000359', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20324, NULL, 'G3DSA:3.30.457.50:FF:000001', NULL, NULL, 'Probable kinetochore protein spc25', NULL, NULL, NULL, NULL, NULL, 4),
(20325, NULL, 'G3DSA:3.60.40.10:FF:000026', NULL, NULL, 'probable protein phosphatase 2C 52', NULL, NULL, NULL, NULL, NULL, 4),
(20326, NULL, 'G3DSA:2.130.10.10:FF:004351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20327, NULL, 'G3DSA:1.10.10.60:FF:000754', NULL, NULL, 'RCOR (REST CO-Repressor) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(20328, NULL, 'G3DSA:1.25.40.10:FF:001489', NULL, NULL, 'Pentatricopeptide repeat-containing protein CRP1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(20329, NULL, 'G3DSA:2.60.40.10:FF:000641', NULL, NULL, 'Intercellular adhesion molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(20330, NULL, 'G3DSA:3.30.160.60:FF:002198', NULL, NULL, 'Zinc finger protein 114', NULL, NULL, NULL, NULL, NULL, 4),
(20331, NULL, 'G3DSA:1.10.1410.10:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20332, NULL, 'G3DSA:1.25.10.10:FF:001341', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(20333, NULL, 'G3DSA:2.20.20.10:FF:000006', NULL, NULL, 'U-actitoxin-Bcs2a', NULL, NULL, NULL, NULL, NULL, 4),
(20334, NULL, 'G3DSA:3.40.50.2300:FF:001527', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20335, NULL, 'G3DSA:1.10.520.10:FF:000037', NULL, NULL, 'Cationic peroxidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(20336, NULL, 'G3DSA:2.20.25.10:FF:000057', NULL, NULL, 'Organic hydroperoxide resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(20337, NULL, 'G3DSA:3.20.20.60:FF:000137', NULL, NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(20338, NULL, 'G3DSA:3.30.930.10:FF:000365', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20339, NULL, 'G3DSA:1.25.40.10:FF:000455', NULL, NULL, 'Cell cycle inhibitor Nif1, putative', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(20340, NULL, 'G3DSA:4.10.860.120:FF:000006', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(20341, NULL, 'G3DSA:1.10.1420.10:FF:000169', NULL, NULL, 'Putative MSH5, mismatch repair ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(20342, NULL, 'G3DSA:2.40.50.140:FF:000182', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(20343, NULL, 'G3DSA:3.40.50.300:FF:003008', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(20344, NULL, 'G3DSA:3.50.50.60:FF:001475', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20345, NULL, 'G3DSA:2.60.40.10:FF:002703', NULL, NULL, 'GD26007', NULL, NULL, NULL, NULL, NULL, 4),
(20346, NULL, 'G3DSA:3.30.200.20:FF:000728', NULL, NULL, 'Putative Raf proto-oncogene serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(20347, NULL, 'G3DSA:1.10.472.10:FF:000115', NULL, NULL, 'Os02g0607400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(20348, NULL, 'G3DSA:3.90.1170.50:FF:000017', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20349, NULL, 'G3DSA:1.25.40.20:FF:001273', NULL, NULL, 'Ankyrin repeat-containing protein P1E11.10', NULL, NULL, NULL, NULL, NULL, 4),
(20350, NULL, 'G3DSA:1.10.10.10:FF:001936', NULL, NULL, 'Winged-helix DNA-binding transcription factor family protein', NULL, NULL, NULL, NULL, NULL, 4),
(20351, NULL, 'G3DSA:3.90.1150.210:FF:000018', NULL, NULL, 'F-actin-capping protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(20352, NULL, 'G3DSA:1.10.540.10:FF:000145', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(20353, NULL, 'G3DSA:3.40.50.150:FF:000720', NULL, NULL, 'Nop2 (NOP2)/SUN domain family member', NULL, NULL, NULL, NULL, NULL, 4),
(20354, NULL, 'G3DSA:3.30.2230.10:FF:000002', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(20355, NULL, 'G3DSA:1.10.10.60:FF:000046', NULL, NULL, 'SIX homeobox 3', NULL, NULL, NULL, NULL, NULL, 4),
(20356, NULL, 'G3DSA:3.30.200.20:FF:001656', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(20357, NULL, 'G3DSA:1.20.120.560:FF:000011', NULL, NULL, 'Enhancer of Glp-One (Glp-1)', NULL, NULL, NULL, NULL, NULL, 4),
(20358, NULL, 'G3DSA:2.130.10.10:FF:005863', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20359, NULL, 'G3DSA:3.20.20.70:FF:000567', NULL, NULL, 'GTP 3'',8-cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(20360, NULL, 'G3DSA:3.30.390.110:FF:000004', NULL, NULL, 'Large subunit ribosomal protein L28e', NULL, NULL, NULL, NULL, NULL, 4),
(20361, NULL, 'G3DSA:2.130.10.10:FF:000057', NULL, NULL, 'Activating molecule in BECN1-regulated autophagy protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(20362, NULL, 'G3DSA:2.60.40.10:FF:005312', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20363, NULL, 'G3DSA:3.65.10.10:FF:000036', NULL, NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(20364, NULL, 'G3DSA:2.130.10.10:FF:004660', NULL, NULL, 'Ribosome biogenesis protein WDR12 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(20365, NULL, 'G3DSA:1.25.40.990:FF:000024', NULL, NULL, 'GM24869', NULL, NULL, NULL, NULL, NULL, 4),
(20366, NULL, 'G3DSA:2.30.29.30:FF:000543', NULL, NULL, 'Unplaced genomic scaffold supercont2.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(20367, NULL, 'G3DSA:3.40.190.290:FF:000073', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(20368, NULL, 'G3DSA:3.30.380.10:FF:000002', NULL, NULL, 'Capsid protein', NULL, NULL, NULL, NULL, NULL, 4),
(20369, NULL, 'G3DSA:1.20.120.1240:FF:000014', NULL, NULL, 'Dynamin 2b', NULL, NULL, NULL, NULL, NULL, 4),
(20370, NULL, 'G3DSA:3.10.310.20:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20371, NULL, 'G3DSA:1.25.40.10:FF:004507', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20372, NULL, 'G3DSA:3.40.50.300:FF:008437', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(20373, NULL, 'G3DSA:3.30.160.60:FF:000545', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20374, NULL, 'G3DSA:3.30.160.60:FF:005216', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20375, NULL, 'G3DSA:3.40.1490.10:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20376, NULL, 'G3DSA:3.10.200.10:FF:000005', NULL, NULL, 'receptor-type tyrosine-protein phosphatase gamma isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(20377, NULL, 'G3DSA:3.40.1160.10:FF:000022', NULL, NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(20378, NULL, 'G3DSA:3.90.70.10:FF:000375', NULL, NULL, 'AGAP003875-PA', NULL, NULL, NULL, NULL, NULL, 4),
(20379, NULL, 'G3DSA:1.10.287.70:FF:000787', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20380, NULL, 'G3DSA:3.30.10.20:FF:000006', NULL, NULL, 'Serine/threonine-protein kinase StkP', NULL, NULL, NULL, NULL, NULL, 4),
(20381, NULL, 'G3DSA:2.60.40.10:FF:005003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20382, NULL, 'G3DSA:1.50.10.20:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20383, NULL, 'G3DSA:3.40.50.300:FF:007611', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20384, NULL, 'G3DSA:1.25.40.10:FF:000663', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20385, NULL, 'G3DSA:1.20.120.980:FF:000018', NULL, NULL, 'Putative serine protease K12H4.7', NULL, NULL, NULL, NULL, NULL, 4),
(20386, NULL, 'G3DSA:3.40.50.1000:FF:000547', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20387, NULL, 'G3DSA:1.10.1070.11:FF:000081', NULL, NULL, 'Phosphatidylinositol kinase domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20388, NULL, 'G3DSA:3.30.160.60:FF:000854', NULL, NULL, 'zinc finger and BTB domain-containing protein 20 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(20389, NULL, 'G3DSA:3.40.50.2300:FF:000908', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20390, NULL, 'G3DSA:3.90.640.10:FF:000262', NULL, NULL, 'Heat shock protein 70D', NULL, NULL, NULL, NULL, NULL, 4),
(20391, NULL, 'G3DSA:3.40.1000.30:FF:000005', NULL, NULL, 'Probable proteasome inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(20392, NULL, 'G3DSA:1.25.40.90:FF:000052', NULL, NULL, 'BnaC05g37120D protein', NULL, NULL, NULL, NULL, NULL, 4),
(20393, NULL, 'G3DSA:1.10.357.70:FF:000006', NULL, NULL, 'Exocyst complex component 3 like 4', NULL, NULL, NULL, NULL, NULL, 4),
(20394, NULL, 'G3DSA:2.40.50.40:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20395, NULL, 'G3DSA:2.60.40.10:FF:005576', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20396, NULL, 'G3DSA:1.25.40.10:FF:000972', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(20397, NULL, 'G3DSA:3.40.50.1010:FF:000084', NULL, NULL, 'Ribonuclease VapC', NULL, NULL, NULL, NULL, NULL, 4),
(20398, NULL, 'G3DSA:1.10.510.10:FF:001037', NULL, NULL, 'SRSF protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(20399, NULL, 'G3DSA:2.10.25.140:FF:000005', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(20400, NULL, 'G3DSA:2.40.160.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20401, NULL, 'G3DSA:1.10.3370.10:FF:000024', NULL, NULL, 'SecY protein transport family protein', NULL, NULL, NULL, NULL, NULL, 4),
(20402, NULL, 'G3DSA:2.60.40.10:FF:003058', NULL, NULL, 'Limbic system-associated membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(20403, NULL, 'G3DSA:2.40.50.140:FF:000243', NULL, NULL, 'Elongation factor P', NULL, NULL, NULL, NULL, NULL, 4),
(20404, NULL, 'G3DSA:2.60.120.650:FF:000123', NULL, NULL, 'Lysine-specific demethylase 8', NULL, NULL, NULL, NULL, NULL, 4),
(20405, NULL, 'G3DSA:3.30.160.60:FF:005525', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20406, NULL, 'G3DSA:1.20.140.10:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(20407, NULL, 'G3DSA:2.170.120.40:FF:000002', NULL, NULL, 'YbbR-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(20408, NULL, 'G3DSA:1.10.3210.10:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20409, NULL, 'G3DSA:3.30.1460.20:FF:000022', NULL, NULL, 'Arp2/3 complex 34 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(20410, NULL, 'G3DSA:3.30.870.10:FF:000186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20411, NULL, 'G3DSA:1.20.1070.10:FF:001797', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20412, NULL, 'G3DSA:3.40.50.80:FF:000150', NULL, NULL, 'Cytochrome b5 reductase 4', NULL, NULL, NULL, NULL, NULL, 4),
(20413, NULL, 'G3DSA:3.40.50.1820:FF:001838', NULL, NULL, 'Acylamino-acid-releasing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(20414, NULL, 'G3DSA:2.20.70.10:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20415, NULL, 'G3DSA:1.20.1720.10:FF:000015', NULL, NULL, 'Quinolone resistance protein NorB', NULL, NULL, NULL, NULL, NULL, 4),
(20416, NULL, 'G3DSA:1.25.10.10:FF:002061', NULL, NULL, 'Condensin-2 complex subunit D3', NULL, NULL, NULL, NULL, NULL, 4),
(20417, NULL, 'G3DSA:1.10.30.10:FF:000055', NULL, NULL, 'High mobility group B protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(20418, NULL, 'G3DSA:2.60.40.150:FF:000138', NULL, NULL, 'Fer-1-like family member 6', NULL, NULL, NULL, NULL, NULL, 4),
(20419, NULL, 'G3DSA:3.90.70.10:FF:000184', NULL, NULL, 'Cysteine protease', NULL, NULL, NULL, NULL, NULL, 4),
(20420, NULL, 'G3DSA:3.40.50.720:FF:000705', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(20421, NULL, 'G3DSA:1.10.486.10:FF:000041', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(20422, NULL, 'G3DSA:3.80.10.10:FF:004514', NULL, NULL, 'Putative inactive leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(20423, NULL, 'G3DSA:3.30.70.330:FF:000831', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(20424, NULL, 'G3DSA:2.40.70.10:FF:000424', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20425, NULL, 'G3DSA:1.20.5.130:FF:000001', NULL, NULL, 'Bacteriocin hiracin-JM79', NULL, NULL, NULL, NULL, NULL, 4),
(20426, NULL, 'G3DSA:1.20.1300.10:FF:000023', NULL, NULL, 'Cytochrome b560 subunit of succinate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(20427, NULL, 'G3DSA:1.10.555.10:FF:000078', NULL, NULL, 'RhoGAP domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(20428, NULL, 'G3DSA:3.30.465.10:FF:000008', NULL, NULL, 'Berberine bridge enzyme-like 15', NULL, NULL, NULL, NULL, NULL, 4),
(20429, NULL, 'G3DSA:3.30.70.330:FF:001921', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20430, NULL, 'G3DSA:2.120.10.30:FF:000367', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20431, NULL, 'G3DSA:2.60.40.2860:FF:000022', NULL, NULL, '6-cysteine protein', NULL, NULL, NULL, NULL, NULL, 4),
(20432, NULL, 'G3DSA:3.40.930.10:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20433, NULL, 'G3DSA:3.40.50.1100:FF:000228', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20434, NULL, 'G3DSA:3.80.10.10:FF:002614', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20435, NULL, 'G3DSA:3.40.630.10:FF:000166', NULL, NULL, 'Carboxypeptidase T, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20436, NULL, 'G3DSA:3.40.50.1000:FF:000608', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20437, NULL, 'G3DSA:3.40.50.150:FF:001445', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20438, NULL, 'G3DSA:3.10.20.90:FF:000910', NULL, NULL, 'Ubiquitin D', NULL, NULL, NULL, NULL, NULL, 4),
(20439, NULL, 'G3DSA:2.60.40.10:FF:003322', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(20440, NULL, 'G3DSA:2.130.10.10:FF:004008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20441, NULL, 'G3DSA:2.60.34.10:FF:000020', NULL, NULL, 'Heat shock SSE1', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(20442, NULL, 'G3DSA:3.40.50.2300:FF:000807', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20443, NULL, 'G3DSA:3.90.20.20:FF:000021', NULL, NULL, 'GrpE protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(20444, NULL, 'G3DSA:3.40.640.10:FF:000301', NULL, NULL, '4-aminobutyrate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(20445, NULL, 'G3DSA:2.60.40.10:FF:002911', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(20446, NULL, 'G3DSA:3.40.50.300:FF:003216', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(20447, NULL, 'G3DSA:2.20.100.10:FF:000151', NULL, NULL, 'SPONdin (Extracellular matrix glycoprotein) family', NULL, NULL, NULL, NULL, NULL, 4),
(20448, NULL, 'G3DSA:1.10.1450.10:FF:000058', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(20449, NULL, 'G3DSA:3.90.920.10:FF:000008', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(20450, NULL, 'G3DSA:1.10.533.10:FF:000033', NULL, NULL, 'p53-induced death domain-containing protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(20451, NULL, 'G3DSA:1.25.40.20:FF:001481', NULL, NULL, 'Si:ch211-209a2.2', NULL, NULL, NULL, NULL, NULL, 4),
(20452, NULL, 'G3DSA:3.30.70.270:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20453, NULL, 'G3DSA:2.40.50.100:FF:000181', NULL, NULL, 'RND efflux system, membrane fusion protein CmeA', NULL, NULL, NULL, NULL, NULL, 4),
(20454, NULL, 'G3DSA:3.40.50.300:FF:000799', NULL, NULL, 'ras-related protein Rab-24 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(20455, NULL, 'G3DSA:2.10.60.10:FF:000077', NULL, NULL, 'Serine/threonine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(20456, NULL, 'G3DSA:2.60.40.4370:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20457, NULL, 'G3DSA:2.60.40.10:FF:000916', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase beta', NULL, NULL, NULL, NULL, NULL, 4),
(20458, NULL, 'G3DSA:3.40.50.300:FF:000607', NULL, NULL, 'chromodomain-helicase-DNA-binding protein 1-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(20459, NULL, 'G3DSA:3.40.50.620:FF:000310', NULL, NULL, 'Adenine nucleotide alpha hydrolases-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(20460, NULL, 'G3DSA:3.30.160.60:FF:005424', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20461, NULL, 'G3DSA:3.40.140.70:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20462, NULL, 'G3DSA:3.30.160.60:FF:006144', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20463, NULL, 'G3DSA:3.20.20.140:FF:000322', NULL, NULL, 'Dihydroorotase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20464, NULL, 'G3DSA:2.40.50.140:FF:000035', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(20465, NULL, 'G3DSA:1.25.40.10:FF:004715', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20466, NULL, 'G3DSA:3.10.290.10:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20467, NULL, 'G3DSA:2.30.30.30:FF:000041', NULL, NULL, '40S ribosomal protein S4', NULL, NULL, NULL, NULL, NULL, 4),
(20468, NULL, 'G3DSA:3.40.850.10:FF:000250', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20469, NULL, 'G3DSA:2.40.70.10:FF:000571', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20470, NULL, 'G3DSA:3.40.50.300:FF:003789', NULL, NULL, 'DNA replication licensing factor MCM3', NULL, NULL, NULL, NULL, NULL, 4),
(20471, NULL, 'G3DSA:3.40.50.150:FF:000265', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(20472, NULL, 'G3DSA:2.40.50.700:FF:000001', NULL, NULL, 'Exosome complex exonuclease exoribonuclease (Rrp44)', NULL, NULL, NULL, NULL, NULL, 4),
(20473, NULL, 'G3DSA:3.40.50.1820:FF:001591', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20474, NULL, 'G3DSA:3.90.870.20:FF:000001', NULL, NULL, 'Decarbamoylnovobiocin carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(20475, NULL, 'G3DSA:1.20.58.60:FF:000751', NULL, NULL, 'ACF7 protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(20476, NULL, 'G3DSA:2.60.40.10:FF:005076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20477, NULL, 'G3DSA:3.40.190.10:FF:000766', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20478, NULL, 'G3DSA:2.40.10.10:FF:000550', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20479, NULL, 'G3DSA:2.60.40.10:FF:004811', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20480, NULL, 'G3DSA:3.40.50.800:FF:000078', NULL, NULL, 'Threonine--tRNA ligase 2, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(20481, NULL, 'G3DSA:2.60.120.10:FF:000284', NULL, NULL, 'Cyclic nucleotide-gated potassium channel mll3241', NULL, NULL, NULL, NULL, NULL, 4),
(20482, NULL, 'G3DSA:2.130.10.10:FF:000309', NULL, NULL, 'WD repeat domain 11', NULL, NULL, NULL, NULL, NULL, 4),
(20483, NULL, 'G3DSA:1.20.1170.10:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20484, NULL, 'G3DSA:3.30.60.20:FF:000161', NULL, NULL, 'SH3 and cysteine rich domain', NULL, NULL, NULL, NULL, NULL, 4),
(20485, NULL, 'G3DSA:3.40.50.10810:FF:000206', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20486, NULL, 'G3DSA:3.30.1370.120:FF:000013', NULL, NULL, 'Type II secretion system protein', NULL, NULL, NULL, NULL, NULL, 4),
(20487, NULL, 'G3DSA:1.10.418.10:FF:000176', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20488, NULL, 'G3DSA:2.60.40.60:FF:000195', NULL, NULL, 'Cadherin 16', NULL, NULL, NULL, NULL, NULL, 4),
(20489, NULL, 'G3DSA:3.90.550.50:FF:000188', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20490, NULL, 'G3DSA:1.50.10.130:FF:000009', NULL, NULL, 'Terpenoid synthase 26', NULL, NULL, NULL, NULL, NULL, 4),
(20491, NULL, 'G3DSA:3.10.20.10:FF:000033', NULL, NULL, 'DNA fragmentation factor, 40kDa, beta polypeptide (caspase-activated DNase)', NULL, NULL, NULL, NULL, NULL, 4),
(20492, NULL, 'G3DSA:3.30.70.980:FF:000014', NULL, NULL, 'Probable transcriptional regulatory protein VV2_1184', NULL, NULL, NULL, NULL, NULL, 4),
(20493, NULL, 'G3DSA:1.10.472.130:FF:000031', NULL, NULL, 'AGAP011441-PA', NULL, NULL, NULL, NULL, NULL, 4),
(20494, NULL, 'G3DSA:3.40.50.1000:FF:000755', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20495, NULL, 'G3DSA:3.30.70.330:FF:002540', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20496, NULL, 'G3DSA:1.20.1070.10:FF:001134', NULL, NULL, 'Si:dkey-165a24.9', NULL, NULL, NULL, NULL, NULL, 4),
(20497, NULL, 'G3DSA:1.10.720.30:FF:000013', NULL, NULL, 'SAP domain-containing ribonucleoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(20498, NULL, 'G3DSA:3.90.550.10:FF:000732', NULL, NULL, 'N-acetylgalactosaminyl transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20499, NULL, 'G3DSA:3.40.50.10330:FF:000012', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(20500, NULL, 'G3DSA:3.10.450.700:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20501, NULL, 'G3DSA:3.40.50.1240:FF:000113', NULL, NULL, '6-phosphofructo-2-kinase/fructose-2,6-biphosphatase 3', NULL, NULL, NULL, NULL, NULL, 4),
(20502, NULL, 'G3DSA:3.40.50.300:FF:004385', NULL, NULL, 'Rab_A23 protein', NULL, NULL, NULL, NULL, NULL, 4),
(20503, NULL, 'G3DSA:3.30.160.60:FF:005997', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20504, NULL, 'G3DSA:4.10.60.10:FF:000084', NULL, NULL, 'Zinc knuckle domain protein (Byr3), putative', NULL, NULL, NULL, NULL, NULL, 4),
(20505, NULL, 'G3DSA:3.40.630.30:FF:000222', NULL, NULL, 'Putative acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(20506, NULL, 'G3DSA:2.130.10.10:FF:002873', NULL, NULL, 'WD repeat-containing protein 90', NULL, NULL, NULL, NULL, NULL, 4),
(20507, NULL, 'G3DSA:3.30.160.60:FF:004805', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20508, NULL, 'G3DSA:3.30.30.30:FF:000027', NULL, NULL, 'Heat shock protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20509, NULL, 'G3DSA:3.10.20.90:FF:000455', NULL, NULL, 'Phosphatidylinositol 4-kinase gamma 4', NULL, NULL, NULL, NULL, NULL, 4),
(20510, NULL, 'G3DSA:3.30.70.580:FF:000001', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(20511, NULL, 'G3DSA:3.80.10.10:FF:001125', NULL, NULL, 'Inactive leucine-rich repeat receptor-like protein kinase isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(20512, NULL, 'G3DSA:3.30.420.100:FF:000010', NULL, NULL, 'F14B2.25/F14B2.25', NULL, NULL, NULL, NULL, NULL, 4),
(20513, NULL, 'G3DSA:3.30.40.10:FF:001697', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20514, NULL, 'G3DSA:3.30.710.10:FF:000146', NULL, NULL, 'Potassium voltage-gated channel subfamily A member 3', NULL, NULL, NULL, NULL, NULL, 4),
(20515, NULL, 'G3DSA:3.30.160.60:FF:000192', NULL, NULL, 'Mds1 and evi1 complex locus protein', NULL, NULL, NULL, NULL, NULL, 4),
(20516, NULL, 'G3DSA:1.10.560.10:FF:000163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20517, NULL, 'G3DSA:3.40.720.10:FF:000257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20518, NULL, 'G3DSA:3.30.420.40:FF:000717', NULL, NULL, 'SWI/SNF and RSC complexes subunit arp42', NULL, NULL, NULL, NULL, NULL, 4),
(20519, NULL, 'G3DSA:3.10.129.10:FF:000064', NULL, NULL, 'Acyl-CoA thioester hydrolase, YbgC/YbaW family', NULL, NULL, NULL, NULL, NULL, 4),
(20520, NULL, 'G3DSA:1.25.40.180:FF:000181', NULL, NULL, 'mRNA cap-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(20521, NULL, 'G3DSA:2.70.170.10:FF:000150', NULL, NULL, 'CHRNA7-FAM7A fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(20522, NULL, 'G3DSA:2.60.220.50:FF:000090', NULL, NULL, 'Adhesion G-protein coupled receptor D1', NULL, NULL, NULL, NULL, NULL, 4),
(20523, NULL, 'G3DSA:3.90.550.10:FF:000069', NULL, NULL, 'Glycosyltransferase 8 domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(20524, NULL, 'G3DSA:2.60.40.1660:FF:000004', NULL, NULL, 'sodium/potassium-transporting ATPase subunit beta-2', NULL, NULL, NULL, NULL, NULL, 4),
(20525, NULL, 'G3DSA:3.30.50.10:FF:000034', NULL, NULL, 'CLUMA_CG002674, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(20526, NULL, 'G3DSA:3.80.10.10:FF:001788', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20527, NULL, 'G3DSA:3.30.1520.10:FF:000075', NULL, NULL, 'Mdm1p', NULL, NULL, NULL, NULL, NULL, 4),
(20528, NULL, 'G3DSA:3.90.340.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20529, NULL, 'G3DSA:3.10.100.10:FF:000205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20530, NULL, 'G3DSA:3.40.50.1380:FF:000014', NULL, NULL, 'Carbamoyl-phosphate synthase (glutamine-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4),
(20531, NULL, 'G3DSA:2.120.10.30:FF:000153', NULL, NULL, 'Receptor Mediated Endocytosis', NULL, NULL, NULL, NULL, NULL, 4),
(20532, NULL, 'G3DSA:3.40.50.410:FF:000287', NULL, NULL, 'KU70 protein', NULL, NULL, NULL, NULL, NULL, 4),
(20533, NULL, 'G3DSA:3.30.40.10:FF:000769', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(20534, NULL, 'G3DSA:1.20.1540.10:FF:000018', NULL, NULL, 'RHOMBOID-like protein 12, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(20535, NULL, 'G3DSA:2.60.40.10:FF:000096', NULL, NULL, 'filamin-C isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(20536, NULL, 'G3DSA:2.60.40.150:FF:000240', NULL, NULL, 'BnaA03g50900D protein', NULL, NULL, NULL, NULL, NULL, 4),
(20537, NULL, 'G3DSA:4.10.640.10:FF:000034', NULL, NULL, 'YALI0E30371p', NULL, NULL, NULL, NULL, NULL, 4),
(20538, NULL, 'G3DSA:3.40.190.10:FF:000103', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(20539, NULL, 'G3DSA:3.30.160.60:FF:004952', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20540, NULL, 'G3DSA:3.40.630.30:FF:000486', NULL, NULL, 'GCN5-related N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(20541, NULL, 'G3DSA:2.160.20.10:FF:000303', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20542, NULL, 'G3DSA:2.60.60.30:FF:000002', NULL, NULL, 'Stress response protein SCP2', NULL, NULL, NULL, NULL, NULL, 4),
(20543, NULL, 'G3DSA:3.30.1370.10:FF:000158', NULL, NULL, 'Drosophila dodeca-satellite protein 1', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(20544, NULL, 'G3DSA:3.90.226.10:FF:000243', NULL, NULL, 'ClpP/crotonase-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(20545, NULL, 'G3DSA:1.20.1250.20:FF:000471', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20546, NULL, 'G3DSA:3.30.70.330:FF:002438', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20547, NULL, 'G3DSA:3.40.50.720:FF:001678', NULL, NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase NAD-binding', NULL, NULL, NULL, NULL, NULL, 4),
(20548, NULL, 'G3DSA:3.90.1150.220:FF:000010', NULL, NULL, 'Putative non-structural maintenance of chromosomes element 1', NULL, NULL, NULL, NULL, NULL, 4),
(20549, NULL, 'G3DSA:3.30.450.20:FF:000084', NULL, NULL, 'Sensor histidine kinase CitA', NULL, NULL, NULL, NULL, NULL, 4),
(20550, NULL, 'G3DSA:4.10.75.10:FF:000005', NULL, NULL, 'WAP four-disulfide core domain protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(20551, NULL, 'G3DSA:1.10.1320.10:FF:000004', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(20552, NULL, 'G3DSA:3.40.190.10:FF:000811', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20553, NULL, 'G3DSA:1.25.40.20:FF:000862', NULL, NULL, 'Ankyrin 2, isoform X', NULL, NULL, NULL, NULL, NULL, 4),
(20554, NULL, 'G3DSA:3.90.1150.10:FF:000010', NULL, NULL, 'Alanine aminotransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(20555, NULL, 'G3DSA:2.30.30.100:FF:000235', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm1', NULL, NULL, NULL, NULL, NULL, 4),
(20556, NULL, 'G3DSA:1.10.510.10:FF:000008', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(20557, NULL, 'G3DSA:3.30.365.10:FF:000040', NULL, NULL, 'Glyceraldehyde dehydrogenase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(20558, NULL, 'G3DSA:3.30.460.80:FF:000012', NULL, NULL, 'Os12g0422971 protein', NULL, NULL, NULL, NULL, NULL, 4),
(20559, NULL, 'G3DSA:1.25.10.10:FF:000936', NULL, NULL, 'Importin beta11', NULL, NULL, NULL, NULL, NULL, 4),
(20560, NULL, 'G3DSA:1.25.10.10:FF:002622', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20561, NULL, 'G3DSA:1.10.630.10:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20562, NULL, 'G3DSA:1.10.357.90:FF:000001', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(20563, NULL, 'G3DSA:3.40.50.720:FF:000144', NULL, NULL, 'Malate dehydrogenase [NADP]', NULL, NULL, NULL, NULL, NULL, 4),
(20564, NULL, 'G3DSA:2.130.10.10:FF:001237', NULL, NULL, 'Topless-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(20565, NULL, 'G3DSA:2.70.150.10:FF:000148', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(20566, NULL, 'G3DSA:1.10.3720.10:FF:000214', NULL, NULL, 'Binding-protein-dependent transport systems inner membrane component', NULL, NULL, NULL, NULL, NULL, 4),
(20567, NULL, 'G3DSA:1.10.1160.10:FF:000002', NULL, NULL, 'Glutamate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(20568, NULL, 'G3DSA:1.10.8.60:FF:000298', NULL, NULL, 'ATPase, AAA family', NULL, NULL, NULL, NULL, NULL, 4),
(20569, NULL, 'G3DSA:2.60.260.20:FF:000004', NULL, NULL, 'Molecular chaperone DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(20570, NULL, 'G3DSA:3.30.160.60:FF:004244', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20571, NULL, 'G3DSA:1.20.140.150:FF:000122', NULL, NULL, 'Pickel, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(20572, NULL, 'G3DSA:3.90.1440.10:FF:000009', NULL, NULL, 'Si:dkey-187j14.8', NULL, NULL, NULL, NULL, NULL, 4),
(20573, NULL, 'G3DSA:1.20.20.10:FF:000020', NULL, NULL, 'ATP synthase subunit 9, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(20574, NULL, 'G3DSA:3.50.50.60:FF:000615', NULL, NULL, 'Prenylcysteine oxidase/farnesylcysteine lyase', NULL, NULL, NULL, NULL, NULL, 4),
(20575, NULL, 'G3DSA:1.20.5.190:FF:000103', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20576, NULL, 'G3DSA:3.30.2130.30:FF:000040', NULL, NULL, 'Probable tRNA sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(20577, NULL, 'G3DSA:1.10.287.1490:FF:000040', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(20578, NULL, 'G3DSA:1.10.472.10:FF:000216', NULL, NULL, 'TFIIB zinc-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(20579, NULL, 'G3DSA:2.80.10.50:FF:000066', NULL, NULL, 'Interleukin-18', NULL, NULL, NULL, NULL, NULL, 4),
(20580, NULL, 'G3DSA:2.60.40.10:FF:003631', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20581, NULL, 'G3DSA:3.90.470.10:FF:000018', NULL, NULL, '60S ribosomal protein L17, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20582, NULL, 'G3DSA:1.20.1410.10:FF:000014', NULL, NULL, 'ENTH domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(20583, NULL, 'G3DSA:1.10.10.10:FF:000964', NULL, NULL, 'Phosphate regulon transcriptional regulatory protein PhoB', NULL, NULL, NULL, NULL, NULL, 4),
(20584, NULL, 'G3DSA:2.60.120.200:FF:000365', NULL, NULL, 'Zonadhesin', NULL, NULL, NULL, NULL, NULL, 4),
(20585, NULL, 'G3DSA:3.40.50.150:FF:000826', NULL, NULL, 'Methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20586, NULL, 'G3DSA:3.90.190.10:FF:000406', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20587, NULL, 'G3DSA:3.30.1490.110:FF:000003', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(20588, NULL, 'G3DSA:1.20.58.1080:FF:000020', NULL, NULL, 'AGAP012862-PA', NULL, NULL, NULL, NULL, NULL, 4),
(20589, NULL, 'G3DSA:3.30.40.10:FF:002006', NULL, NULL, 'AGAP003561-PA', NULL, NULL, NULL, NULL, NULL, 4),
(20590, NULL, 'G3DSA:3.10.105.10:FF:000048', NULL, NULL, 'Nickel ABC transporter, nickel/metallophore periplasmic binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(20591, NULL, 'G3DSA:1.20.272.10:FF:000070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20592, NULL, 'G3DSA:1.20.1250.20:FF:001297', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(20593, NULL, 'G3DSA:3.40.630.10:FF:000019', NULL, NULL, 'Aminoacylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(20594, NULL, 'G3DSA:3.30.200.20:FF:000375', NULL, NULL, 'Cell division related protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(20595, NULL, 'G3DSA:1.20.120.1220:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20596, NULL, 'G3DSA:3.40.50.200:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20597, NULL, 'G3DSA:3.40.50.2300:FF:000246', NULL, NULL, 'Atrial natriuretic peptide receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(20598, NULL, 'G3DSA:2.60.40.150:FF:000801', NULL, NULL, 'Extended synaptotagmin-like protein 2a', NULL, NULL, NULL, NULL, NULL, 4),
(20599, NULL, 'G3DSA:2.60.40.3430:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20600, NULL, 'G3DSA:3.30.200.20:FF:002370', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20601, NULL, 'G3DSA:3.30.200.20:FF:002061', NULL, NULL, 'Probable serine/threonine-protein kinase clkA', NULL, NULL, NULL, NULL, NULL, 4),
(20602, NULL, 'G3DSA:3.60.21.60:FF:000008', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(20603, NULL, 'G3DSA:1.10.510.10:FF:000683', NULL, NULL, 'Protein kinase and PP2C-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(20604, NULL, 'G3DSA:2.60.40.60:FF:000307', NULL, NULL, 'Zgc:123181', NULL, NULL, NULL, NULL, NULL, 4),
(20605, NULL, 'G3DSA:3.60.40.10:FF:000127', NULL, NULL, 'Probable protein phosphatase DDB_G0279461', NULL, NULL, NULL, NULL, NULL, 4),
(20606, NULL, 'G3DSA:1.20.120.1630:FF:000024', NULL, NULL, 'Phosphatidylethanolamine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(20607, NULL, 'G3DSA:3.30.40.10:FF:002315', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20608, NULL, 'G3DSA:2.60.120.200:FF:000056', NULL, NULL, 'Laminin subunit alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(20609, NULL, 'G3DSA:2.130.10.10:FF:003755', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20610, NULL, 'G3DSA:2.60.40.10:FF:004148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(20611, NULL, 'G3DSA:3.50.50.60:FF:000306', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(20612, NULL, 'G3DSA:1.20.58.60:FF:000088', NULL, NULL, 'microtubule-actin cross-linking factor 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(20613, NULL, 'G3DSA:1.10.10.10:FF:000655', NULL, NULL, 'Type 2 DNA topoisomerase 6 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(20614, NULL, 'G3DSA:3.40.30.10:FF:000583', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(20615, NULL, 'G3DSA:1.25.10.10:FF:000913', NULL, NULL, 'GM10891', NULL, NULL, NULL, NULL, NULL, 4),
(20616, NULL, 'G3DSA:1.20.58.480:FF:000010', NULL, NULL, 'Indoleamine 2,3-dioxygenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(20617, NULL, 'G3DSA:3.40.50.10090:FF:000024', NULL, NULL, 'Uroporphyrinogen-III synthase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(20618, NULL, 'G3DSA:3.30.565.10:FF:000521', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(20619, NULL, 'G3DSA:3.40.50.300:FF:001007', NULL, NULL, 'putative pre-mRNA-splicing factor ATP-dependent RNA helicase DHX32', NULL, NULL, NULL, NULL, NULL, 4),
(20620, NULL, 'G3DSA:3.30.565.10:FF:000527', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(20621, NULL, 'G3DSA:1.10.8.270:FF:000163', NULL, NULL, 'Growth hormone-regulated TBC protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20622, NULL, 'G3DSA:1.25.40.1040:FF:000031', NULL, NULL, 'YALI0B11836p', NULL, NULL, NULL, NULL, NULL, 4),
(20623, NULL, 'G3DSA:3.40.50.880:FF:000068', NULL, NULL, 'Anthranilate synthase component II', NULL, NULL, NULL, NULL, NULL, 4),
(20624, NULL, 'G3DSA:3.30.750.24:FF:000089', NULL, NULL, 'Putative sulfate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(20625, NULL, 'G3DSA:3.30.200.20:FF:000167', NULL, NULL, 'Putative inactive tyrosine-protein kinase 7', NULL, NULL, NULL, NULL, NULL, 4),
(20626, NULL, 'G3DSA:1.25.10.10:FF:002521', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20627, NULL, 'G3DSA:1.10.630.10:FF:000135', NULL, NULL, 'Cytochrome P450 family 26 subfamily C member 1', NULL, NULL, NULL, NULL, NULL, 4),
(20628, NULL, 'G3DSA:1.10.940.10:FF:000001', NULL, NULL, 'Transcription antitermination factor NusB', NULL, NULL, NULL, NULL, NULL, 4),
(20629, NULL, 'G3DSA:1.10.287.550:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20630, NULL, 'G3DSA:2.20.70.10:FF:000026', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(20631, NULL, 'G3DSA:3.30.200.20:FF:000161', NULL, NULL, 'PX domain-containing protein kinase-like protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(20632, NULL, 'G3DSA:3.40.50.300:FF:002480', NULL, NULL, 'Dicer-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(20633, NULL, 'G3DSA:3.40.50.300:FF:006330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20634, NULL, 'G3DSA:3.20.20.70:FF:000483', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20635, NULL, 'G3DSA:3.30.160.60:FF:003171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20636, NULL, 'G3DSA:2.40.160.10:FF:000021', NULL, NULL, 'Mitochondrial Protein Translocase (MPT) Family', NULL, NULL, NULL, NULL, NULL, 4),
(20637, NULL, 'G3DSA:3.30.497.10:FF:000014', NULL, NULL, 'Serpin family E member 3', NULL, NULL, NULL, NULL, NULL, 4),
(20638, NULL, 'G3DSA:1.20.1250.20:FF:000499', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(20639, NULL, 'G3DSA:3.30.420.40:FF:000341', NULL, NULL, 'Carbohydrate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(20640, NULL, 'G3DSA:2.60.40.10:FF:004250', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20641, NULL, 'G3DSA:3.20.20.70:FF:000011', NULL, NULL, 'Biotin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(20642, NULL, 'G3DSA:1.10.510.10:FF:000992', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase nsy-1', NULL, NULL, NULL, NULL, NULL, 4),
(20643, NULL, 'G3DSA:3.10.20.90:FF:000793', NULL, NULL, 'Ubiquitin-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(20644, NULL, 'G3DSA:3.20.20.220:FF:000048', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(20645, NULL, 'G3DSA:2.30.42.10:FF:000282', NULL, NULL, 'Varicose, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(20646, NULL, 'G3DSA:3.50.50.60:FF:000250', NULL, NULL, 'NAD(P)H-dependent glutamate synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20647, NULL, 'G3DSA:1.20.58.390:FF:000269', NULL, NULL, 'Zinc activated ion channel', NULL, NULL, NULL, NULL, NULL, 4),
(20648, NULL, 'G3DSA:3.40.50.2300:FF:000347', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(20649, NULL, 'G3DSA:3.40.50.300:FF:001535', NULL, NULL, 'Interferon induced protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(20650, NULL, 'G3DSA:2.60.40.10:FF:002586', NULL, NULL, 'Complement C4', NULL, NULL, NULL, NULL, NULL, 4),
(20651, NULL, 'G3DSA:2.130.10.10:FF:002081', NULL, NULL, 'WD_domain_-_G-beta_repeat_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(20652, NULL, 'G3DSA:3.40.50.300:FF:007948', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20653, NULL, 'G3DSA:3.40.50.150:FF:000517', NULL, NULL, 'YJR129C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(20654, NULL, 'G3DSA:3.90.190.10:FF:000300', NULL, NULL, 'DnaJ heat shock protein family (Hsp40) member C6', NULL, NULL, NULL, NULL, NULL, 4),
(20655, NULL, 'G3DSA:1.10.10.60:FF:000181', NULL, NULL, 'HTH-type transcriptional activator RhaS', NULL, NULL, NULL, NULL, NULL, 4),
(20656, NULL, 'G3DSA:1.25.10.10:FF:001425', NULL, NULL, 'WGS project CABT00000000 data, contig 2.36', NULL, NULL, NULL, NULL, NULL, 4),
(20657, NULL, 'G3DSA:3.40.309.10:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20658, NULL, 'G3DSA:1.10.287.850:FF:000004', NULL, NULL, 'PE family protein', NULL, NULL, NULL, NULL, NULL, 4),
(20659, NULL, 'G3DSA:1.25.40.1010:FF:000016', NULL, NULL, 'Tetratricopeptide repeat (TPR)-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(20660, NULL, 'G3DSA:3.60.20.10:FF:000160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20661, NULL, 'G3DSA:1.20.1070.10:FF:001926', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20662, NULL, 'G3DSA:3.40.50.300:FF:006223', NULL, NULL, 'GTP-binding elongation factor', NULL, NULL, NULL, NULL, NULL, 4),
(20663, NULL, 'G3DSA:3.10.129.10:FF:000171', NULL, NULL, 'PaaI family thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(20664, NULL, 'G3DSA:2.40.100.10:FF:000045', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase D', NULL, NULL, NULL, NULL, NULL, 4),
(20665, NULL, 'G3DSA:3.40.50.1820:FF:001855', NULL, NULL, 'Putative phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(20666, NULL, 'G3DSA:1.10.8.1310:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20667, NULL, 'G3DSA:1.25.40.10:FF:003653', NULL, NULL, 'NRDE-2, necessary for RNA interference, domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(20668, NULL, 'G3DSA:3.30.830.10:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20669, NULL, 'G3DSA:3.40.50.2000:FF:000038', NULL, NULL, 'UDP-GlucuronosylTransferase', NULL, NULL, NULL, NULL, NULL, 4),
(20670, NULL, 'G3DSA:1.20.1250.20:FF:001808', NULL, NULL, 'Major facilitator superfamily MFS_1', NULL, NULL, NULL, NULL, NULL, 4),
(20671, NULL, 'G3DSA:2.20.70.10:FF:000133', NULL, NULL, 'TransCription Elongation Regulator homolog', NULL, NULL, NULL, NULL, NULL, 4),
(20672, NULL, 'G3DSA:2.130.10.10:FF:004374', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20673, NULL, 'G3DSA:1.20.58.60:FF:000335', NULL, NULL, 'SMAll', NULL, NULL, NULL, NULL, NULL, 4),
(20674, NULL, 'G3DSA:3.40.50.150:FF:001029', NULL, NULL, 'Erythromycin 3''''-O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(20675, NULL, 'G3DSA:1.25.10.10:FF:002044', NULL, NULL, 'Importin subunit alpha-1', NULL, NULL, NULL, NULL, NULL, 4),
(20676, NULL, 'G3DSA:1.20.1300.10:FF:000040', NULL, NULL, 'Succinate dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(20677, NULL, 'G3DSA:3.30.1640.30:FF:000005', NULL, NULL, 'Serine protease easter', NULL, NULL, NULL, NULL, NULL, 4),
(20678, NULL, 'G3DSA:2.70.160.11:FF:000010', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(20679, NULL, 'G3DSA:1.10.3210.10:FF:000086', NULL, NULL, 'HD domain-containing protein 2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(20680, NULL, 'G3DSA:1.10.530.10:FF:000083', NULL, NULL, 'Transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(20681, NULL, 'G3DSA:3.40.50.150:FF:000956', NULL, NULL, 'Crg1p', NULL, NULL, NULL, NULL, NULL, 4),
(20682, NULL, 'G3DSA:3.10.20.90:FF:000686', NULL, NULL, 'Ubiquitin-60S ribosomal protein L40', NULL, NULL, NULL, NULL, NULL, 4),
(20683, NULL, 'G3DSA:1.10.8.370:FF:000002', NULL, NULL, 'Polyprotein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(20684, NULL, 'G3DSA:2.60.130.10:FF:000003', NULL, NULL, 'Catechol 1,2-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(20685, NULL, 'G3DSA:2.30.30.40:FF:000414', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20686, NULL, 'G3DSA:3.90.740.10:FF:000016', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(20687, NULL, 'G3DSA:1.25.10.10:FF:001908', NULL, NULL, 'Arm repeat-containing protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(20688, NULL, 'G3DSA:2.40.170.20:FF:000103', NULL, NULL, 'SusC homolog', NULL, NULL, NULL, NULL, NULL, 4),
(20689, NULL, 'G3DSA:3.80.10.10:FF:002406', NULL, NULL, 'PH domain and leucine rich repeat protein phosphatase 2', NULL, NULL, NULL, NULL, NULL, 4),
(20690, NULL, 'G3DSA:2.60.120.260:FF:000462', NULL, NULL, 'Acetylxylan esterase / glucomannan deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(20691, NULL, 'G3DSA:1.10.1420.10:FF:000146', NULL, NULL, 'Putative MSH3, mismatch repair ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(20692, NULL, 'G3DSA:1.25.40.180:FF:000310', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20693, NULL, 'G3DSA:2.60.120.330:FF:000168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20694, NULL, 'G3DSA:1.10.10.10:FF:000863', NULL, NULL, 'Cholera toxin transcriptional activator', NULL, NULL, NULL, NULL, NULL, 4),
(20695, NULL, 'G3DSA:1.10.3080.10:FF:000069', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(20696, NULL, 'G3DSA:3.40.50.300:FF:004278', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(20697, NULL, 'G3DSA:3.50.50.60:FF:000407', NULL, NULL, 'Nitrite reductase NiiA', NULL, NULL, NULL, NULL, NULL, 4),
(20698, NULL, 'G3DSA:1.20.1250.20:FF:000027', NULL, NULL, 'Sialic acid transporter NanT', NULL, NULL, NULL, NULL, NULL, 4),
(20699, NULL, 'G3DSA:3.80.10.10:FF:002160', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(20700, NULL, 'G3DSA:3.80.10.10:FF:003339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20701, NULL, 'G3DSA:3.20.20.80:FF:000379', NULL, NULL, 'DUF4434 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(20702, NULL, 'G3DSA:3.40.50.2300:FF:000824', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20703, NULL, 'G3DSA:3.30.200.20:FF:000700', NULL, NULL, 'Discoidin domain receptor, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(20704, NULL, 'G3DSA:2.20.100.10:FF:000235', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs gon-1', NULL, NULL, NULL, NULL, NULL, 4),
(20705, NULL, 'G3DSA:1.25.40.180:FF:000001', NULL, NULL, 'Eukaryotic translation initiation factor 4 gamma, 3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20706, NULL, 'G3DSA:1.10.510.10:FF:000553', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(20707, NULL, 'G3DSA:1.25.40.20:FF:000418', NULL, NULL, 'KiDINs220 (Vertebrate scaffold protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(20708, NULL, 'G3DSA:2.40.50.140:FF:000373', NULL, NULL, '30S ribosomal protein S17', NULL, NULL, NULL, NULL, NULL, 4),
(20709, NULL, 'G3DSA:1.25.40.10:FF:001360', NULL, NULL, 'Pentatricopeptide (PPR) repeat-containing protein-like', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(20710, NULL, 'G3DSA:3.20.20.140:FF:000013', NULL, NULL, 'Allantoinase', NULL, NULL, NULL, NULL, NULL, 4),
(20711, NULL, 'G3DSA:3.10.450.50:FF:000069', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20712, NULL, 'G3DSA:3.10.196.10:FF:000005', NULL, NULL, 'Probable methionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(20713, NULL, 'G3DSA:1.25.40.10:FF:001253', NULL, NULL, 'TPR domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(20714, NULL, 'G3DSA:2.130.10.10:FF:002766', NULL, NULL, 'Chromatin assembly factor 1 subunit B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20715, NULL, 'G3DSA:3.30.565.10:FF:000044', NULL, NULL, 'Phytochrome', NULL, NULL, NULL, NULL, NULL, 4),
(20716, NULL, 'G3DSA:3.30.160.20:FF:000073', NULL, NULL, 'Double-stranded RNA-binding protein Staufen homolog', NULL, NULL, NULL, NULL, NULL, 4),
(20717, NULL, 'G3DSA:1.10.510.10:FF:000660', NULL, NULL, 'Mitogen-activated protein kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(20718, NULL, 'G3DSA:2.160.20.10:FF:000343', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20719, NULL, 'G3DSA:2.40.50.140:FF:000266', NULL, NULL, 'rRNA biogenesis protein rrp5', NULL, NULL, NULL, NULL, NULL, 4),
(20720, NULL, 'G3DSA:1.20.1070.10:FF:001550', NULL, NULL, 'Zg07', NULL, NULL, NULL, NULL, NULL, 4),
(20721, NULL, 'G3DSA:3.40.470.10:FF:000029', NULL, NULL, 'Uracil-DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(20722, NULL, 'G3DSA:1.10.8.10:FF:000221', NULL, NULL, 'Holliday junction ATP-dependent DNA helicase RuvA', NULL, NULL, NULL, NULL, NULL, 4),
(20723, NULL, 'G3DSA:1.25.10.10:FF:001897', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20724, NULL, 'G3DSA:3.40.50.1000:FF:000524', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20725, NULL, 'G3DSA:3.40.980.10:FF:000006', NULL, NULL, 'Molybdenum cofactor biosynthesis protein B', NULL, NULL, NULL, NULL, NULL, 4),
(20726, NULL, 'G3DSA:3.30.70.330:FF:002293', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20727, NULL, 'G3DSA:1.10.10.10:FF:000424', NULL, NULL, 'Pur operon repressor', NULL, NULL, NULL, NULL, NULL, 4),
(20728, NULL, 'G3DSA:1.20.144.10:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20729, NULL, 'G3DSA:2.60.490.10:FF:000024', NULL, NULL, 'p2X purinoceptor 5', NULL, NULL, NULL, NULL, NULL, 4),
(20730, NULL, 'G3DSA:3.40.50.300:FF:008128', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(20731, NULL, 'G3DSA:1.10.1510.30:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20732, NULL, 'G3DSA:3.20.20.80:FF:000340', NULL, NULL, 'Glycosyl hydrolase family 17 protein', NULL, NULL, NULL, NULL, NULL, 4),
(20733, NULL, 'G3DSA:2.40.240.130:FF:000010', NULL, NULL, 'Axin-1', NULL, NULL, NULL, NULL, NULL, 4),
(20734, NULL, 'G3DSA:3.20.20.80:FF:000688', NULL, NULL, 'Putative glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(20735, NULL, 'G3DSA:3.30.300.30:FF:000065', NULL, NULL, 'Phenyloxazoline synthase MbtB', NULL, NULL, NULL, NULL, NULL, 4),
(20736, NULL, 'G3DSA:2.40.10.10:FF:000331', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20737, NULL, 'G3DSA:1.25.40.20:FF:000098', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(20738, NULL, 'G3DSA:2.40.70.10:FF:000346', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20739, NULL, 'G3DSA:3.80.10.10:FF:000271', NULL, NULL, 'F-box/LRR-repeat protein 20 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(20740, NULL, 'G3DSA:1.10.533.10:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20741, NULL, 'G3DSA:3.40.140.10:FF:000055', NULL, NULL, 'COP9 signalosome complex subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(20742, NULL, 'G3DSA:3.40.50.150:FF:001338', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20743, NULL, 'G3DSA:3.40.50.300:FF:004880', NULL, NULL, 'DEAH-box helicase 35', NULL, NULL, NULL, NULL, NULL, 4),
(20744, NULL, 'G3DSA:1.20.58.1780:FF:000016', NULL, NULL, 'YALI0E02706p', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(20745, NULL, 'G3DSA:3.90.1420.10:FF:000019', NULL, NULL, 'Histone-lysine N-methyltransferase setd3', NULL, NULL, NULL, NULL, NULL, 4),
(20746, NULL, 'G3DSA:3.40.640.10:FF:000520', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20747, NULL, 'G3DSA:1.10.357.10:FF:000011', NULL, NULL, 'Transcriptional regulator, TetR family', NULL, NULL, NULL, NULL, NULL, 4),
(20748, NULL, 'G3DSA:3.40.190.10:FF:000575', NULL, NULL, 'Prephenate dehydratase-like', NULL, NULL, NULL, NULL, NULL, 4),
(20749, NULL, 'G3DSA:2.30.170.40:FF:000004', NULL, NULL, '50S ribosomal protein L28', NULL, NULL, NULL, NULL, NULL, 4),
(20750, NULL, 'G3DSA:1.20.5.730:FF:000001', NULL, NULL, 'rho-associated protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(20751, NULL, 'G3DSA:2.120.10.80:FF:000365', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20752, NULL, 'G3DSA:3.40.5.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20753, NULL, 'G3DSA:1.10.10.60:FF:000506', NULL, NULL, 'NK6 homeobox 1', NULL, NULL, NULL, NULL, NULL, 4),
(20754, NULL, 'G3DSA:3.80.10.10:FF:002053', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20755, NULL, 'G3DSA:3.40.50.2000:FF:000690', NULL, NULL, 'Mannosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(20756, NULL, 'G3DSA:3.40.50.720:FF:001425', NULL, NULL, 'Polyketide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(20757, NULL, 'G3DSA:3.30.160.60:FF:000298', NULL, NULL, 'zinc finger protein 280D isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(20758, NULL, 'G3DSA:3.10.110.10:FF:000381', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20759, NULL, 'G3DSA:2.40.50.100:FF:000046', NULL, NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(20760, NULL, 'G3DSA:3.50.50.60:FF:001020', NULL, NULL, 'Dihydropyrimidine dehydrogenase [NADP(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(20761, NULL, 'G3DSA:2.130.10.10:FF:001462', NULL, NULL, 'COMPASS-like H3K4 histone methylase component WDR5B', NULL, NULL, NULL, NULL, NULL, 4),
(20762, NULL, 'G3DSA:3.30.420.40:FF:000234', NULL, NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(20763, NULL, 'G3DSA:1.25.40.10:FF:001736', NULL, NULL, 'lysine-specific demethylase 6A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(20764, NULL, 'G3DSA:1.10.10.790:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20765, NULL, 'G3DSA:3.40.50.2000:FF:000162', NULL, NULL, 'Beta-1,4-mannosyltransferase (Alg1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(20766, NULL, 'G3DSA:3.80.10.10:FF:003941', NULL, NULL, 'Os01g0515300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(20767, NULL, 'G3DSA:3.40.50.880:FF:000175', NULL, NULL, 'AGAP000705-PA', NULL, NULL, NULL, NULL, NULL, 4),
(20768, NULL, 'G3DSA:3.40.190.10:FF:000210', NULL, NULL, 'Glutamate receptor ionotropic, kainate 1', NULL, NULL, NULL, NULL, NULL, 4),
(20769, NULL, 'G3DSA:3.30.160.60:FF:001282', NULL, NULL, 'Zinc finger and BTB domain-containing protein 41', NULL, NULL, NULL, NULL, NULL, 4),
(20770, NULL, 'G3DSA:2.40.100.10:FF:000152', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(20771, NULL, 'G3DSA:1.25.40.10:FF:002664', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20772, NULL, 'G3DSA:2.40.170.20:FF:000092', NULL, NULL, 'Transporter, outer membrane receptor (OMR) family', NULL, NULL, NULL, NULL, NULL, 4),
(20773, NULL, 'G3DSA:1.10.287.40:FF:000008', NULL, NULL, 'Serine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(20774, NULL, 'G3DSA:2.60.40.60:FF:000779', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20775, NULL, 'G3DSA:1.20.58.1080:FF:000008', NULL, NULL, 'Putative RNA helicase (Putative mitochondrial)', NULL, NULL, NULL, NULL, NULL, 4),
(20776, NULL, 'G3DSA:2.40.100.10:FF:000175', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(20777, NULL, 'G3DSA:2.30.180.10:FF:000092', NULL, NULL, 'Fasciclin-1 fasciclin i fas i fcn', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(20778, NULL, 'G3DSA:3.30.160.60:FF:000309', NULL, NULL, 'zinc finger X-chromosomal protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(20779, NULL, 'G3DSA:1.25.10.10:FF:001532', NULL, NULL, 'AP-1 complex subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(20780, NULL, 'G3DSA:3.90.700.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20781, NULL, 'G3DSA:1.10.287.1490:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20782, NULL, 'G3DSA:2.130.10.10:FF:003862', NULL, NULL, 'AGAP004756-PA', NULL, NULL, NULL, NULL, NULL, 4),
(20783, NULL, 'G3DSA:2.60.40.10:FF:000332', NULL, NULL, 'neuronal cell adhesion molecule isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(20784, NULL, 'G3DSA:3.40.50.40:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20785, NULL, 'G3DSA:3.40.50.300:FF:005711', NULL, NULL, 'Exodeoxyribonuclease V gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(20786, NULL, 'G3DSA:3.90.550.10:FF:000272', NULL, NULL, 'Dolichol-P-glucose synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(20787, NULL, 'G3DSA:2.10.70.10:FF:000111', NULL, NULL, 'Coagulation factor XIII B chain', NULL, NULL, NULL, NULL, NULL, 4),
(20788, NULL, 'G3DSA:1.20.140.180:FF:000002', NULL, NULL, 'Dermonecrotic toxin', NULL, NULL, NULL, NULL, NULL, 4),
(20789, NULL, 'G3DSA:3.40.50.300:FF:007639', NULL, NULL, 'Putative ATP dependent DEAD-box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(20790, NULL, 'G3DSA:1.10.238.10:FF:000847', NULL, NULL, 'uncharacterized protein LOC100175312 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(20791, NULL, 'G3DSA:2.70.150.10:FF:000160', NULL, NULL, 'Sarcoplasmic/endoplasmic reticulum calcium ATPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(20792, NULL, 'G3DSA:2.60.40.10:FF:004603', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20793, NULL, 'G3DSA:3.40.50.300:FF:001316', NULL, NULL, 'Nitric oxide associated 1 A', NULL, NULL, NULL, NULL, NULL, 4),
(20794, NULL, 'G3DSA:1.10.510.10:FF:003061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20795, NULL, 'G3DSA:3.30.40.10:FF:001798', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20796, NULL, 'G3DSA:3.30.60.90:FF:000030', NULL, NULL, 'Transcriptional adapter', NULL, NULL, NULL, NULL, NULL, 4),
(20797, NULL, 'G3DSA:1.20.1560.10:FF:000036', NULL, NULL, 'ATP-binding cassette sub-family D member 3', NULL, NULL, NULL, NULL, NULL, 4),
(20798, NULL, 'G3DSA:1.20.120.1760:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20799, NULL, 'G3DSA:3.80.10.10:FF:001541', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20800, NULL, 'G3DSA:3.30.450.20:FF:000320', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(20801, NULL, 'G3DSA:2.130.10.10:FF:000517', NULL, NULL, 'WD repeat-containing protein 43', NULL, NULL, NULL, NULL, NULL, 4),
(20802, NULL, 'G3DSA:3.40.50.300:FF:000916', NULL, NULL, 'ABC transporter B family member 9', NULL, NULL, NULL, NULL, NULL, 4),
(20803, NULL, 'G3DSA:3.40.50.720:FF:000806', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] reductase FabG', NULL, NULL, NULL, NULL, NULL, 4),
(20804, NULL, 'G3DSA:1.10.472.10:FF:000571', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20805, NULL, 'G3DSA:3.80.30.20:FF:000016', NULL, NULL, 'Oxygen-independent coproporphyrinogen III oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(20806, NULL, 'G3DSA:3.80.10.10:FF:002030', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20807, NULL, 'G3DSA:2.60.40.60:FF:000414', NULL, NULL, 'Dachsous, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(20808, NULL, 'G3DSA:2.30.40.10:FF:000120', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20809, NULL, 'G3DSA:2.60.40.640:FF:000044', NULL, NULL, 'Aly1p', NULL, NULL, NULL, NULL, NULL, 4),
(20810, NULL, 'G3DSA:1.10.287.20:FF:000002', NULL, NULL, 'Cytochrome b-c1 complex subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(20811, NULL, 'G3DSA:3.30.530.20:FF:000040', NULL, NULL, 'MLP-like protein 329', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(20812, NULL, 'G3DSA:3.40.50.300:FF:008584', NULL, NULL, '26S proteasome regulatory subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20813, NULL, 'G3DSA:3.40.50.1910:FF:000005', NULL, NULL, 'vacuolar protein sorting-associated protein 33A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(20814, NULL, 'G3DSA:3.30.200.20:FF:001465', NULL, NULL, 'U-box domain-containing protein 57', NULL, NULL, NULL, NULL, NULL, 4),
(20815, NULL, 'G3DSA:2.40.10.10:FF:000207', NULL, NULL, 'Lysyl endopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(20816, NULL, 'G3DSA:2.130.10.10:FF:001838', NULL, NULL, 'WD repeat containing protein 48', NULL, NULL, NULL, NULL, NULL, 4),
(20817, NULL, 'G3DSA:3.30.505.10:FF:000068', NULL, NULL, 'ras and Rab interactor 1', NULL, NULL, NULL, NULL, NULL, 4),
(20818, NULL, 'G3DSA:3.40.50.300:FF:002171', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(20819, NULL, 'G3DSA:2.60.40.10:FF:006065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20820, NULL, 'G3DSA:3.40.50.2300:FF:001336', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20821, NULL, 'G3DSA:1.10.150.130:FF:000019', NULL, NULL, 'Site-specific recombinase, phage integrase family', NULL, NULL, NULL, NULL, NULL, 4),
(20822, NULL, 'G3DSA:2.10.110.10:FF:000345', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20823, NULL, 'G3DSA:3.30.160.60:FF:001254', NULL, NULL, 'Zinc finger protein 564', NULL, NULL, NULL, NULL, NULL, 4),
(20824, NULL, 'G3DSA:1.10.220.30:FF:000003', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(20825, NULL, 'G3DSA:3.90.1530.10:FF:000011', NULL, NULL, 'Sulfiredoxin chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(20826, NULL, 'G3DSA:3.40.50.2000:FF:000471', NULL, NULL, 'UDP-N-acetylglucosamine transferase subunit ALG14-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(20827, NULL, 'G3DSA:3.30.420.270:FF:000027', NULL, NULL, 'Biopolymer transport protein ExbD/TolR', NULL, NULL, NULL, NULL, NULL, 4),
(20828, NULL, 'G3DSA:2.10.25.10:FF:001215', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(20829, NULL, 'G3DSA:1.20.1070.10:FF:000145', NULL, NULL, 'Oxytocin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(20830, NULL, 'G3DSA:1.25.40.20:FF:001037', NULL, NULL, 'Espin like', NULL, NULL, NULL, NULL, NULL, 4),
(20831, NULL, 'G3DSA:3.40.50.150:FF:000164', NULL, NULL, 'Methyltransferase NSUN5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20832, NULL, 'G3DSA:3.30.50.10:FF:000135', NULL, NULL, 'Nuclear receptor subfamily 4 group A member 1', NULL, NULL, NULL, NULL, NULL, 4),
(20833, NULL, 'G3DSA:1.25.40.20:FF:000637', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20834, NULL, 'G3DSA:3.60.15.10:FF:000058', NULL, NULL, 'DNA repair metallo-beta-lactamase-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(20835, NULL, 'G3DSA:1.10.287.70:FF:000478', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20836, NULL, 'G3DSA:3.40.50.300:FF:006678', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20837, NULL, 'G3DSA:3.40.50.1820:FF:001602', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20838, NULL, 'G3DSA:3.30.2350.20:FF:000031', NULL, NULL, 'tRNA pseudouridine synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20839, NULL, 'G3DSA:3.30.1370.240:FF:000009', NULL, NULL, 'Phenylalanine--tRNA ligase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(20840, NULL, 'G3DSA:2.70.130.10:FF:000158', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20841, NULL, 'G3DSA:1.10.730.10:FF:000064', NULL, NULL, 'Probable arginine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(20842, NULL, 'G3DSA:1.25.10.10:FF:002297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20843, NULL, 'G3DSA:1.20.58.60:FF:000644', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20844, NULL, 'G3DSA:1.25.40.10:FF:003962', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(20845, NULL, 'G3DSA:2.60.120.200:FF:000612', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20846, NULL, 'G3DSA:3.40.50.2300:FF:000038', NULL, NULL, 'Galactose ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(20847, NULL, 'G3DSA:1.10.101.10:FF:000013', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(20848, NULL, 'G3DSA:2.60.40.10:FF:005992', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20849, NULL, 'G3DSA:3.40.50.1440:FF:000072', NULL, NULL, 'Tubulin, alpha 8-like 4', NULL, NULL, NULL, NULL, NULL, 4),
(20850, NULL, 'G3DSA:3.40.50.970:FF:000095', NULL, NULL, 'Sulfopyruvate decarboxylase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(20851, NULL, 'G3DSA:2.60.260.20:FF:000105', NULL, NULL, 'AT19485p', NULL, NULL, NULL, NULL, NULL, 4),
(20852, NULL, 'G3DSA:1.20.58.1470:FF:000002', NULL, NULL, 'Alpha-ketoglutarate-dependent dioxygenase FTO', NULL, NULL, NULL, NULL, NULL, 4),
(20853, NULL, 'G3DSA:3.90.550.10:FF:000277', NULL, NULL, 'Glycosyltransferase-like protein, family 2', NULL, NULL, NULL, NULL, NULL, 4),
(20854, NULL, 'G3DSA:1.10.490.10:FF:000056', NULL, NULL, 'Globin-coupled histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(20855, NULL, 'G3DSA:1.10.1420.10:FF:000129', NULL, NULL, 'DNA mismatch repair protein MSH4', NULL, NULL, NULL, NULL, NULL, 4),
(20856, NULL, 'G3DSA:2.40.50.90:FF:000060', NULL, NULL, 'Tudor domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(20857, NULL, 'G3DSA:3.80.10.10:FF:001996', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase PEPR1', NULL, NULL, NULL, NULL, NULL, 4),
(20858, NULL, 'G3DSA:1.20.1250.20:FF:001191', NULL, NULL, 'Multidrug MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(20859, NULL, 'G3DSA:2.60.40.10:FF:002333', NULL, NULL, 'Myotactin form A', NULL, NULL, NULL, NULL, NULL, 4),
(20860, NULL, 'G3DSA:2.30.29.30:FF:001268', NULL, NULL, 'Roco6, ROCO family protein', NULL, NULL, NULL, NULL, NULL, 4),
(20861, NULL, 'G3DSA:3.40.50.360:FF:000002', NULL, NULL, 'Flavodoxin', NULL, NULL, NULL, NULL, NULL, 4),
(20862, NULL, 'G3DSA:3.30.200.20:FF:001100', NULL, NULL, 'G protein-coupled receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(20863, NULL, 'G3DSA:1.20.58.60:FF:000116', NULL, NULL, 'Microtubule-actin cross-linking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(20864, NULL, 'G3DSA:3.30.40.10:FF:000314', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM32', NULL, NULL, NULL, NULL, NULL, 4),
(20865, NULL, 'G3DSA:3.30.420.40:FF:000689', NULL, NULL, 'Carbohydrate kinase, FGGY family', NULL, NULL, NULL, NULL, NULL, 4),
(20866, NULL, 'G3DSA:1.25.40.10:FF:002669', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20867, NULL, 'G3DSA:1.20.1560.10:FF:000345', NULL, NULL, 'ATP-binding cassette protein subfamily C, member 8', NULL, NULL, NULL, NULL, NULL, 4),
(20868, NULL, 'G3DSA:3.40.5.10:FF:000019', NULL, NULL, 'Ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(20869, NULL, 'G3DSA:3.30.40.10:FF:001489', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20870, NULL, 'G3DSA:3.20.20.70:FF:000466', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20871, NULL, 'G3DSA:1.10.10.10:FF:001728', NULL, NULL, 'Phosphate regulon transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(20872, NULL, 'G3DSA:2.120.10.30:FF:000361', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20873, NULL, 'G3DSA:2.120.10.30:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20874, NULL, 'G3DSA:3.20.20.120:FF:000030', NULL, NULL, 'L-Lys-D/L-Arg epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(20875, NULL, 'G3DSA:3.30.559.70:FF:000002', NULL, NULL, 'Carnitine O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(20876, NULL, 'G3DSA:1.25.10.10:FF:002830', NULL, NULL, 'Maestro heat-like repeat-containing protein family member 2B', NULL, NULL, NULL, NULL, NULL, 4),
(20877, NULL, 'G3DSA:2.130.10.10:FF:000512', NULL, NULL, 'WD-40 repeat-containing protein MSI1', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(20878, NULL, 'G3DSA:1.25.40.20:FF:001582', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20879, NULL, 'G3DSA:3.40.50.300:FF:001788', NULL, NULL, 'Axonemal dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(20880, NULL, 'G3DSA:3.40.50.1460:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20881, NULL, 'G3DSA:2.60.120.1040:FF:000010', NULL, NULL, 'Zinc-finger protein zpr1', NULL, NULL, NULL, NULL, NULL, 4),
(20882, NULL, 'G3DSA:3.90.1480.20:FF:000015', NULL, NULL, 'Lactosylceramide alpha-2,3-sialyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(20883, NULL, 'G3DSA:1.10.12.10:FF:000007', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(20884, NULL, 'G3DSA:3.10.450.10:FF:000080', NULL, NULL, 'Antihemorrhagic factor BJ46a', NULL, NULL, NULL, NULL, NULL, 4),
(20885, NULL, 'G3DSA:1.10.3720.10:FF:000097', NULL, NULL, 'Phosphate transport system permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(20886, NULL, 'G3DSA:3.30.40.10:FF:000842', NULL, NULL, 'E3 ubiquitin-protein ligase RMA1H1', NULL, NULL, NULL, NULL, NULL, 4),
(20887, NULL, 'G3DSA:3.40.718.10:FF:000066', NULL, NULL, 'Isocitrate dehydrogenase [NADP]', NULL, NULL, NULL, NULL, NULL, 4),
(20888, NULL, 'G3DSA:3.30.200.20:FF:002426', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20889, NULL, 'G3DSA:1.10.287.70:FF:000006', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(20890, NULL, 'G3DSA:1.10.3290.10:FF:000006', NULL, NULL, 'Protein adenylyltransferase and cysteine protease IbpA', NULL, NULL, NULL, NULL, NULL, 4),
(20891, NULL, 'G3DSA:1.10.10.60:FF:000501', NULL, NULL, 'Unplaced genomic scaffold supercont1.172, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(20892, NULL, 'G3DSA:3.30.160.60:FF:000293', NULL, NULL, 'zinc finger protein 385B isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(20893, NULL, 'G3DSA:2.60.40.10:FF:002810', NULL, NULL, 'Insulin-like growth factor 1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(20894, NULL, 'G3DSA:3.30.450.20:FF:000292', NULL, NULL, 'Response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(20895, NULL, 'G3DSA:1.25.40.20:FF:001054', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(20896, NULL, 'G3DSA:2.130.10.130:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20897, NULL, 'G3DSA:2.60.40.60:FF:001050', NULL, NULL, 'Protocadherin fat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20898, NULL, 'G3DSA:1.10.30.10:FF:000190', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20899, NULL, 'G3DSA:3.40.430.10:FF:000055', NULL, NULL, 'Bifunctional dihydrofolate reductase-thymidylate synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(20900, NULL, 'G3DSA:3.30.465.10:FF:000115', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20901, NULL, 'G3DSA:1.20.1250.20:FF:002180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20902, NULL, 'G3DSA:3.20.20.80:FF:000795', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20903, NULL, 'G3DSA:3.40.1260.10:FF:000007', NULL, NULL, 'Sulfur relay protein TusB', NULL, NULL, NULL, NULL, NULL, 4),
(20904, NULL, 'G3DSA:1.25.40.20:FF:000109', NULL, NULL, 'Kinase D-interacting substrate of 220 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(20905, NULL, 'G3DSA:3.40.1190.20:FF:000072', NULL, NULL, 'AT09463p', NULL, NULL, NULL, NULL, NULL, 4),
(20906, NULL, 'G3DSA:3.40.50.1000:FF:000417', NULL, NULL, 'Haloacid dehalogenase', NULL, NULL, NULL, NULL, NULL, 4),
(20907, NULL, 'G3DSA:1.25.40.10:FF:004581', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20908, NULL, 'G3DSA:1.40.20.10:FF:000002', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(20909, NULL, 'G3DSA:3.40.50.300:FF:007151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20910, NULL, 'G3DSA:1.10.443.10:FF:000009', NULL, NULL, 'Prophage DLP12 integrase', NULL, NULL, NULL, NULL, NULL, 4),
(20911, NULL, 'G3DSA:3.90.640.10:FF:000071', NULL, NULL, 'Actin-related protein 7', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(20912, NULL, 'G3DSA:3.80.10.10:FF:004323', NULL, NULL, 'Toll-like receptor 4b, duplicate b', NULL, NULL, NULL, NULL, NULL, 4),
(20913, NULL, 'G3DSA:3.40.50.12160:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20914, NULL, 'G3DSA:3.30.1010.10:FF:000093', NULL, NULL, 'Phosphatidylinositol 3 and 4-kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(20915, NULL, 'G3DSA:4.10.51.10:FF:000001', NULL, NULL, 'Cytochrome c oxidase subunit 7B, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(20916, NULL, 'G3DSA:1.25.40.10:FF:000871', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(20917, NULL, 'G3DSA:1.25.40.540:FF:000013', NULL, NULL, 'TOR signaling pathway regulator', NULL, NULL, NULL, NULL, NULL, 4),
(20918, NULL, 'G3DSA:2.40.110.10:FF:000001', NULL, NULL, 'Acyl-CoA dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(20919, NULL, 'G3DSA:3.40.1090.10:FF:000050', NULL, NULL, 'Patanin-like phospholipase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(20920, NULL, 'G3DSA:3.10.580.10:FF:000084', NULL, NULL, 'Domain_of_uncharacterized_function_DUF21', NULL, NULL, NULL, NULL, NULL, 4),
(20921, NULL, 'G3DSA:1.20.5.710:FF:000006', NULL, NULL, '39S ribosomal protein L12, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(20922, NULL, 'G3DSA:1.25.40.20:FF:001402', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20923, NULL, 'G3DSA:2.30.42.10:FF:000321', NULL, NULL, 'MAGI family member, X-linked b', NULL, NULL, NULL, NULL, NULL, 4),
(20924, NULL, 'G3DSA:3.40.50.10900:FF:000014', NULL, NULL, 'Putative enzyme (ATP-grasp superfamily)', NULL, NULL, NULL, NULL, NULL, 4),
(20925, NULL, 'G3DSA:3.30.450.40:FF:000298', NULL, NULL, 'Glr3986 protein', NULL, NULL, NULL, NULL, NULL, 4),
(20926, NULL, 'G3DSA:2.60.40.150:FF:000329', NULL, NULL, 'SyNapTotagmin', NULL, NULL, NULL, NULL, NULL, 4),
(20927, NULL, 'G3DSA:4.10.800.10:FF:000013', NULL, NULL, 'Thyroglobulin', NULL, NULL, NULL, NULL, NULL, 4),
(20928, NULL, 'G3DSA:1.10.10.10:FF:001245', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(20929, NULL, 'G3DSA:1.10.287.3160:FF:000001', NULL, NULL, 'Thymopoietin isoform alpha', NULL, NULL, NULL, NULL, NULL, 4),
(20930, NULL, 'G3DSA:1.20.1250.20:FF:000572', NULL, NULL, 'Unplaced genomic scaffold supercont1.204, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(20931, NULL, 'G3DSA:3.80.10.10:FF:000136', NULL, NULL, 'leucine-rich melanocyte differentiation-associated protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(20932, NULL, 'G3DSA:3.40.50.620:FF:000546', NULL, NULL, 'Arginosuccinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(20933, NULL, 'G3DSA:3.30.559.30:FF:000086', NULL, NULL, 'Nonribosomal peptide synthase nlsA', NULL, NULL, NULL, NULL, NULL, 4),
(20934, NULL, 'G3DSA:1.20.58.1380:FF:000003', NULL, NULL, 'Nuclear pore complex subunit Nup133, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20935, NULL, 'G3DSA:3.30.200.20:FF:002084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20936, NULL, 'G3DSA:3.40.50.150:FF:000849', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20937, NULL, 'G3DSA:2.60.40.150:FF:000785', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20938, NULL, 'G3DSA:3.30.70.1630:FF:000002', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(20939, NULL, 'G3DSA:3.60.15.10:FF:000277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20940, NULL, 'G3DSA:3.30.1330.10:FF:000021', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase subunit PurL', NULL, NULL, NULL, NULL, NULL, 4),
(20941, NULL, 'G3DSA:2.130.10.10:FF:002457', NULL, NULL, 'Cleavage and polyadenylation specific factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(20942, NULL, 'G3DSA:1.10.533.10:FF:000224', NULL, NULL, 'Importin subunit alpha-7', NULL, NULL, NULL, NULL, NULL, 4),
(20943, NULL, 'G3DSA:3.30.200.20:FF:000476', NULL, NULL, 'Probable L-type lectin-domain containing receptor kinase S.5', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(20944, NULL, 'G3DSA:1.10.287.570:FF:000004', NULL, NULL, 'probable boron transporter 2', NULL, NULL, NULL, NULL, NULL, 4),
(20945, NULL, 'G3DSA:2.60.120.10:FF:000177', NULL, NULL, 'Cyclic nucleotide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(20946, NULL, 'G3DSA:2.60.40.150:FF:000824', NULL, NULL, 'Uncharacterized protein PYUK71.03c', NULL, NULL, NULL, NULL, NULL, 4),
(20947, NULL, 'G3DSA:1.10.238.10:FF:000408', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(20948, NULL, 'G3DSA:1.10.238.10:FF:000611', NULL, NULL, 'Cell division control protein Cdc31, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20949, NULL, 'G3DSA:3.40.30.10:FF:000274', NULL, NULL, 'PRDX1 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(20950, NULL, 'G3DSA:3.30.160.60:FF:003390', NULL, NULL, 'Zinc finger Y-chromosomal protein-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(20951, NULL, 'G3DSA:1.25.10.10:FF:000604', NULL, NULL, 'armadillo repeat-containing protein 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(20952, NULL, 'G3DSA:3.40.50.720:FF:000121', NULL, NULL, 'Prostaglandin reductase 2', NULL, NULL, NULL, NULL, NULL, 4),
(20953, NULL, 'G3DSA:2.60.40.10:FF:001630', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(20954, NULL, 'G3DSA:3.80.10.10:FF:000613', NULL, NULL, 'Leucine-rich repeat protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(20955, NULL, 'G3DSA:1.10.510.10:FF:002897', NULL, NULL, 'Probable serine/threonine-protein kinase fhkE', NULL, NULL, NULL, NULL, NULL, 4),
(20956, NULL, 'G3DSA:3.40.50.300:FF:006206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20957, NULL, 'G3DSA:1.10.275.20:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20958, NULL, 'G3DSA:3.30.70.330:FF:001820', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20959, NULL, 'G3DSA:3.30.230.10:FF:000082', NULL, NULL, 'Ribonuclease P protein component', NULL, NULL, NULL, NULL, NULL, 4),
(20960, NULL, 'G3DSA:1.10.730.10:FF:000171', NULL, NULL, 'Methionine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(20961, NULL, 'G3DSA:3.30.40.10:FF:001803', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(20962, NULL, 'G3DSA:3.30.160.60:FF:002243', NULL, NULL, 'zinc finger protein 646', NULL, NULL, NULL, NULL, NULL, 4),
(20963, NULL, 'G3DSA:1.20.1310.10:FF:000097', NULL, NULL, 'Cullin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(20964, NULL, 'G3DSA:1.10.287.1490:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20965, NULL, 'G3DSA:3.30.565.10:FF:000151', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(20966, NULL, 'G3DSA:2.60.40.60:FF:000431', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor', NULL, NULL, NULL, NULL, NULL, 4),
(20967, NULL, 'G3DSA:2.130.10.10:FF:001046', NULL, NULL, 'WD repeat-containing protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(20968, NULL, 'G3DSA:3.90.1580.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20969, NULL, 'G3DSA:1.20.1160.11:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20970, NULL, 'G3DSA:2.130.10.10:FF:005969', NULL, NULL, 'phosphoinositide 3-kinase regulatory subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(20971, NULL, 'G3DSA:3.40.1360.10:FF:000043', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(20972, NULL, 'G3DSA:1.20.1530.20:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20973, NULL, 'G3DSA:3.30.750.70:FF:000003', NULL, NULL, 'Succinate CoA transferase', NULL, NULL, NULL, NULL, NULL, 4),
(20974, NULL, 'G3DSA:3.30.565.10:FF:000499', NULL, NULL, 'Heat shock protein 90-5 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(20975, NULL, 'G3DSA:1.20.5.170:FF:000120', NULL, NULL, 'CREB Homolog', NULL, NULL, NULL, NULL, NULL, 4),
(20976, NULL, 'G3DSA:2.60.450.10:FF:000022', NULL, NULL, 'Lipopolysaccharide export system protein LptC', NULL, NULL, NULL, NULL, NULL, 4),
(20977, NULL, 'G3DSA:2.30.29.30:FF:000796', NULL, NULL, 'Oxysterol-binding protein related protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(20978, NULL, 'G3DSA:3.10.50.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20979, NULL, 'G3DSA:3.30.470.160:FF:000015', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(20980, NULL, 'G3DSA:3.30.1330.40:FF:000041', NULL, NULL, 'Translation initiation inhibitor UK114/IBM1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(20981, NULL, 'G3DSA:4.10.60.10:FF:000191', NULL, NULL, 'Replication protein A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(20982, NULL, 'G3DSA:1.20.1270.50:FF:000003', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(20983, NULL, 'G3DSA:3.30.70.330:FF:001365', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(20984, NULL, 'G3DSA:3.40.50.1110:FF:000102', NULL, NULL, 'Lipase', NULL, NULL, NULL, NULL, NULL, 4),
(20985, NULL, 'G3DSA:1.10.238.10:FF:000864', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(20986, NULL, 'G3DSA:3.30.420.40:FF:000711', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(20987, NULL, 'G3DSA:1.10.287.940:FF:000003', NULL, NULL, 'P2X purinoceptor', NULL, NULL, NULL, NULL, NULL, 4),
(20988, NULL, 'G3DSA:2.60.40.3180:FF:000011', NULL, NULL, 'AGAP011436-PA', NULL, NULL, NULL, NULL, NULL, 4),
(20989, NULL, 'G3DSA:3.30.10.20:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20990, NULL, 'G3DSA:2.60.200.20:FF:000192', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(20991, NULL, 'G3DSA:3.40.50.1000:FF:000833', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20992, NULL, 'G3DSA:3.40.50.1010:FF:000185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20993, NULL, 'G3DSA:1.20.1070.10:FF:001241', NULL, NULL, 'Putative frizzled receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(20994, NULL, 'G3DSA:3.30.70.270:FF:000245', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(20995, NULL, 'G3DSA:3.40.50.1820:FF:000113', NULL, NULL, 'Putative hydrolase RBBP9', NULL, NULL, NULL, NULL, NULL, 4),
(20996, NULL, 'G3DSA:3.30.470.30:FF:000088', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(20997, NULL, 'G3DSA:3.30.200.110:FF:000003', NULL, NULL, 'Inositol-pentakisphosphate 2-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(20998, NULL, 'G3DSA:2.60.40.420:FF:000017', NULL, NULL, 'ephrin-A1', NULL, NULL, NULL, NULL, NULL, 4),
(20999, NULL, 'G3DSA:2.170.140.10:FF:000017', NULL, NULL, 'Chitinase 6, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(21000, NULL, 'G3DSA:2.40.70.10:FF:000216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21001, NULL, 'G3DSA:1.20.1250.20:FF:000044', NULL, NULL, 'Hexose transporter Hxt3p', NULL, NULL, NULL, NULL, NULL, 4),
(21002, NULL, 'G3DSA:3.30.160.60:FF:004036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21003, NULL, 'G3DSA:3.30.420.220:FF:000001', NULL, NULL, 'Pre-mRNA processing ribonucleoprotein, binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(21004, NULL, 'G3DSA:2.110.10.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21005, NULL, 'G3DSA:3.30.230.70:FF:000077', NULL, NULL, 'Eukaryotic exosome, 3''-5'' exoribonuclease subunit MTR3', NULL, NULL, NULL, NULL, NULL, 4),
(21006, NULL, 'G3DSA:3.50.50.60:FF:000031', NULL, NULL, 'Oxygen-dependent choline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(21007, NULL, 'G3DSA:3.40.1230.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21008, NULL, 'G3DSA:3.40.50.1820:FF:000074', NULL, NULL, 'Abhydrolase domain containing 16A', NULL, NULL, NULL, NULL, NULL, 4),
(21009, NULL, 'G3DSA:3.30.505.10:FF:000175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21010, NULL, 'G3DSA:3.90.1410.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21011, NULL, 'G3DSA:3.90.320.10:FF:000007', NULL, NULL, 'Recombinase RecB', NULL, NULL, NULL, NULL, NULL, 4),
(21012, NULL, 'G3DSA:3.40.50.10490:FF:000144', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(21013, NULL, 'G3DSA:2.40.10.10:FF:000679', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21014, NULL, 'G3DSA:3.40.50.1820:FF:000422', NULL, NULL, 'Probable epoxide hydrolase ephC', NULL, NULL, NULL, NULL, NULL, 4),
(21015, NULL, 'G3DSA:3.90.1110.10:FF:000024', NULL, NULL, 'DNA-directed RNA polymerase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(21016, NULL, 'G3DSA:3.40.50.720:FF:002414', NULL, NULL, 'Nucleoside-diphosphate-sugar epimerase family protein (AFU_orthologue AFUA_6G11740)', NULL, NULL, NULL, NULL, NULL, 4),
(21017, NULL, 'G3DSA:3.30.2350.20:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21018, NULL, 'G3DSA:2.70.70.10:FF:000075', NULL, NULL, 'Glr0834 protein', NULL, NULL, NULL, NULL, NULL, 4),
(21019, NULL, 'G3DSA:3.20.140.10:FF:000026', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(21020, NULL, 'G3DSA:1.25.10.10:FF:003477', NULL, NULL, 'eIF-2-alpha kinase activator GCN1', NULL, NULL, NULL, NULL, NULL, 4),
(21021, NULL, 'G3DSA:3.40.50.620:FF:000237', NULL, NULL, 'Putative Valyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(21022, NULL, 'G3DSA:1.25.40.10:FF:004142', NULL, NULL, 'Mitochondrial group I intron splicing factor CCM1', NULL, NULL, NULL, NULL, NULL, 4),
(21023, NULL, 'G3DSA:3.80.10.10:FF:000052', NULL, NULL, 'Leucine rich repeat containing 6', NULL, NULL, NULL, NULL, NULL, 4),
(21024, NULL, 'G3DSA:3.30.870.10:FF:000085', NULL, NULL, 'Cardiolipin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(21025, NULL, 'G3DSA:3.40.1190.20:FF:000105', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(21026, NULL, 'G3DSA:1.20.1050.10:FF:000059', NULL, NULL, 'Putative cell wall organization protein/glutathione transferase', NULL, NULL, NULL, NULL, NULL, 4),
(21027, NULL, 'G3DSA:1.10.246.220:FF:000003', NULL, NULL, 'TRF-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(21028, NULL, 'G3DSA:1.20.140.140:FF:000001', NULL, NULL, 'Calcium release-activated calcium modulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(21029, NULL, 'G3DSA:1.20.1070.10:FF:000622', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(21030, NULL, 'G3DSA:3.90.79.10:FF:000024', NULL, NULL, 'ADP-ribose pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(21031, NULL, 'G3DSA:1.25.10.10:FF:002858', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21032, NULL, 'G3DSA:1.50.40.10:FF:000599', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21033, NULL, 'G3DSA:3.30.360.10:FF:000091', NULL, NULL, 'Aspartate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(21034, NULL, 'G3DSA:2.60.120.650:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21035, NULL, 'G3DSA:2.60.40.10:FF:005683', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21036, NULL, 'G3DSA:2.60.120.650:FF:000022', NULL, NULL, 'tRNA wybutosine-synthesizing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(21037, NULL, 'G3DSA:1.25.40.10:FF:000432', NULL, NULL, 'coatomer subunit epsilon isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(21038, NULL, 'G3DSA:3.40.1060.10:FF:000003', NULL, NULL, 'Aconitate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(21039, NULL, 'G3DSA:2.30.29.30:FF:001285', NULL, NULL, 'Sterol 3-beta-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(21040, NULL, 'G3DSA:3.20.20.60:FF:000154', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(21041, NULL, 'G3DSA:1.20.1070.10:FF:000280', NULL, NULL, 'probable G-protein coupled receptor 135', NULL, NULL, NULL, NULL, NULL, 4),
(21042, NULL, 'G3DSA:3.10.129.10:FF:000041', NULL, NULL, 'Cof-type HAD-IIB family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(21043, NULL, 'G3DSA:1.10.510.10:FF:001969', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(21044, NULL, 'G3DSA:1.50.10.10:FF:000052', NULL, NULL, 'Alpha-L-rhamnosidase B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(21045, NULL, 'G3DSA:1.20.120.520:FF:000010', NULL, NULL, 'Nitroreductase family deazaflavin-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(21046, NULL, 'G3DSA:3.20.20.100:FF:000125', NULL, NULL, 'Galactose dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(21047, NULL, 'G3DSA:1.25.40.10:FF:004923', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(21048, NULL, 'G3DSA:3.30.559.10:FF:000114', NULL, NULL, 'Transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(21049, NULL, 'G3DSA:2.40.30.10:FF:000186', NULL, NULL, 'Mycobactin utilization protein ViuB', NULL, NULL, NULL, NULL, NULL, 4),
(21050, NULL, 'G3DSA:3.40.1500.10:FF:000015', NULL, NULL, 'Coproporphyrinogen-III oxidase 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(21051, NULL, 'G3DSA:3.40.50.300:FF:008331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21052, NULL, 'G3DSA:3.30.40.10:FF:000533', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM36', NULL, NULL, NULL, NULL, NULL, 4),
(21053, NULL, 'G3DSA:3.40.50.1820:FF:000293', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(21054, NULL, 'G3DSA:1.25.40.10:FF:000741', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g25580', NULL, NULL, NULL, NULL, NULL, 4),
(21055, NULL, 'G3DSA:1.20.140.40:FF:000014', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(21056, NULL, 'G3DSA:3.30.160.60:FF:002462', NULL, NULL, 'Zinc finger protein 611', NULL, NULL, NULL, NULL, NULL, 4),
(21057, NULL, 'G3DSA:1.20.140.160:FF:000007', NULL, NULL, 'RNA polymerase sigma factor RpoH', NULL, NULL, NULL, NULL, NULL, 4),
(21058, NULL, 'G3DSA:3.60.15.10:FF:000193', NULL, NULL, 'Flavo-diiron protein FprA1', NULL, NULL, NULL, NULL, NULL, 4),
(21059, NULL, 'G3DSA:3.40.50.1370:FF:000040', NULL, NULL, 'Aspartate carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(21060, NULL, 'G3DSA:3.40.50.20:FF:000019', NULL, NULL, 'Carbamoyl phosphate synthetase II', NULL, NULL, NULL, NULL, NULL, 4),
(21061, NULL, 'G3DSA:3.30.40.10:FF:000494', NULL, NULL, 'Acyl-CoA N-acyltransferase with RING/FYVE/PHD-type zinc finger domain', NULL, NULL, NULL, NULL, NULL, 4),
(21062, NULL, 'G3DSA:1.25.40.20:FF:000093', NULL, NULL, 'ankyrin repeat domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(21063, NULL, 'G3DSA:3.30.40.10:FF:000185', NULL, NULL, 'RING finger protein nhl-1', NULL, NULL, NULL, NULL, NULL, 4),
(21064, NULL, 'G3DSA:3.30.450.20:FF:000668', NULL, NULL, 'Blue-light receptor phototropin 2', NULL, NULL, NULL, NULL, NULL, 4),
(21065, NULL, 'G3DSA:3.30.160.60:FF:002771', NULL, NULL, 'Zinc finger protein 593', NULL, NULL, NULL, NULL, NULL, 4),
(21066, NULL, 'G3DSA:1.25.40.10:FF:005103', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(21067, NULL, 'G3DSA:3.30.1120.30:FF:000005', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(21068, NULL, 'G3DSA:3.40.640.10:FF:000065', NULL, NULL, 'Serine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(21069, NULL, 'G3DSA:1.10.10.10:FF:000317', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(21070, NULL, 'G3DSA:1.25.40.10:FF:000556', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(21071, NULL, 'G3DSA:1.20.5.190:FF:000092', NULL, NULL, 'CAMTA (CAlModulin-binding Transcriptional activator)', NULL, NULL, NULL, NULL, NULL, 4),
(21072, NULL, 'G3DSA:1.10.565.10:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21073, NULL, 'G3DSA:4.10.60.10:FF:000061', NULL, NULL, 'X16 splicing factor, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(21074, NULL, 'G3DSA:2.70.40.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21075, NULL, 'G3DSA:4.10.860.10:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21076, NULL, 'G3DSA:1.25.40.10:FF:004614', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21077, NULL, 'G3DSA:3.40.50.12780:FF:000005', NULL, NULL, 'Solute carrier family 27 member 6', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(21078, NULL, 'G3DSA:3.30.40.10:FF:000078', NULL, NULL, 'E3 ubiquitin-protein ligase MYCBP2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(21079, NULL, 'G3DSA:3.10.20.90:FF:000539', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21080, NULL, 'G3DSA:3.90.180.10:FF:000024', NULL, NULL, 'Glutathione-independent formaldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(21081, NULL, 'G3DSA:3.90.1150.10:FF:000257', NULL, NULL, 'Adenosylmethionine-8-amino-7-oxononanoate transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(21082, NULL, 'G3DSA:2.60.40.790:FF:000201', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21083, NULL, 'G3DSA:3.60.21.10:FF:000134', NULL, NULL, 'UDP-sugar hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(21084, NULL, 'G3DSA:3.40.50.300:FF:001187', NULL, NULL, 'ATP-dependent helicase/nuclease subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(21085, NULL, 'G3DSA:1.20.1110.10:FF:000188', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21086, NULL, 'G3DSA:2.60.40.10:FF:002934', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(21087, NULL, 'G3DSA:3.30.160.60:FF:003507', NULL, NULL, 'Zinc finger protein 226-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(21088, NULL, 'G3DSA:3.40.850.10:FF:000255', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(21089, NULL, 'G3DSA:3.10.100.10:FF:000430', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21090, NULL, 'G3DSA:1.20.5.1040:FF:000002', NULL, NULL, 'Sensor histidine kinase QseC', NULL, NULL, NULL, NULL, NULL, 4),
(21091, NULL, 'G3DSA:3.50.50.60:FF:001104', NULL, NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(21092, NULL, 'G3DSA:3.30.230.10:FF:000008', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(21093, NULL, 'G3DSA:3.30.70.1050:FF:000008', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(21094, NULL, 'G3DSA:1.10.10.650:FF:000005', NULL, NULL, 'Transcription elongation factor SPT6', NULL, NULL, NULL, NULL, NULL, 4),
(21095, NULL, 'G3DSA:3.30.1250.10:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21096, NULL, 'G3DSA:3.30.70.920:FF:000030', NULL, NULL, 'AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(21097, NULL, 'G3DSA:3.30.830.10:FF:000048', NULL, NULL, 'Mitochondrial processing peptidase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(21098, NULL, 'G3DSA:2.40.160.210:FF:000010', NULL, NULL, 'AP005220 putative acyl-CoA thiolesterase', NULL, NULL, NULL, NULL, NULL, 4),
(21099, NULL, 'G3DSA:3.40.630.10:FF:000036', NULL, NULL, 'Carboxypeptidase Q', NULL, NULL, NULL, NULL, NULL, 4),
(21100, NULL, 'G3DSA:1.50.10.130:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21101, NULL, 'G3DSA:1.20.1050.80:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21102, NULL, 'G3DSA:3.30.1390.20:FF:000022', NULL, NULL, 'Ribosome biogenesis protein RLP7', NULL, NULL, NULL, NULL, NULL, 4),
(21103, NULL, 'G3DSA:3.40.50.1820:FF:001708', NULL, NULL, 'Uncharacterized conserved protein UCP031088 alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(21104, NULL, 'G3DSA:3.30.1330.20:FF:000046', NULL, NULL, 'Tubulin gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(21105, NULL, 'G3DSA:1.10.274.100:FF:000023', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(21106, NULL, 'G3DSA:2.30.130.40:FF:000030', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(21107, NULL, 'G3DSA:3.90.1800.10:FF:000004', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(21108, NULL, 'G3DSA:1.25.40.10:FF:002214', NULL, NULL, 'Mitochondrial fission 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(21109, NULL, 'G3DSA:1.10.287.130:FF:000114', NULL, NULL, 'Sensor histidine kinase RegB', NULL, NULL, NULL, NULL, NULL, 4),
(21110, NULL, 'G3DSA:1.20.1280.50:FF:000195', NULL, NULL, 'Ubiquitin-conjugating enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(21111, NULL, 'G3DSA:3.30.70.1030:FF:000002', NULL, NULL, 'Chlorite dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(21112, NULL, 'G3DSA:3.90.215.10:FF:000010', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(21113, NULL, 'G3DSA:3.40.50.150:FF:000181', NULL, NULL, 'tRNA (Adenine(58)-N(1))-methyltransferase, mitochondrial isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(21114, NULL, 'G3DSA:3.80.10.10:FF:003486', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21115, NULL, 'G3DSA:3.10.20.70:FF:000005', NULL, NULL, 'Glutamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(21116, NULL, 'G3DSA:2.60.40.10:FF:001405', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(21117, NULL, 'G3DSA:1.10.1030.10:FF:000010', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(21118, NULL, 'G3DSA:3.15.10.20:FF:000002', NULL, NULL, 'Activator of Hsp90 ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(21119, NULL, 'G3DSA:3.40.50.720:FF:002375', NULL, NULL, 'Zinc-type alcohol dehydrogenase-like protein C2E1P3.01', NULL, NULL, NULL, NULL, NULL, 4),
(21120, NULL, 'G3DSA:3.40.50.2300:FF:000802', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(21121, NULL, 'G3DSA:1.20.120.20:FF:000018', NULL, NULL, 'Plant Late Embryo Abundant (LEA) related', NULL, NULL, NULL, NULL, NULL, 4),
(21122, NULL, 'G3DSA:3.30.50.10:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21123, NULL, 'G3DSA:1.25.40.20:FF:000076', NULL, NULL, 'Fem-1 homolog c (C.elegans)', NULL, NULL, NULL, NULL, NULL, 4),
(21124, NULL, 'G3DSA:3.90.230.10:FF:000040', NULL, NULL, 'Proliferation-associated 2G4, b', NULL, NULL, NULL, NULL, NULL, 4),
(21125, NULL, 'G3DSA:3.30.160.60:FF:006149', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21126, NULL, 'G3DSA:2.20.70.10:FF:000280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21127, NULL, 'G3DSA:2.60.40.790:FF:000190', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21128, NULL, 'G3DSA:3.40.50.300:FF:006459', NULL, NULL, 'Putative ABC transporter ATP-binding protein MG303', NULL, NULL, NULL, NULL, NULL, 4),
(21129, NULL, 'G3DSA:2.20.70.10:FF:000173', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(21130, NULL, 'G3DSA:3.30.160.60:FF:006060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21131, NULL, 'G3DSA:3.40.980.10:FF:000023', NULL, NULL, 'Molybdenum cofactor biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(21132, NULL, 'G3DSA:3.40.50.300:FF:000568', NULL, NULL, 'Putative Ras-related protein Rab-12', NULL, NULL, NULL, NULL, NULL, 4),
(21133, NULL, 'G3DSA:3.30.420.10:FF:000618', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21134, NULL, 'G3DSA:1.20.1250.20:FF:001988', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21135, NULL, 'G3DSA:2.40.30.330:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21136, NULL, 'G3DSA:3.40.1360.10:FF:000026', NULL, NULL, 'Meiotic recombination protein spo-11', NULL, NULL, NULL, NULL, NULL, 4),
(21137, NULL, 'G3DSA:2.60.120.200:FF:000051', NULL, NULL, 'L-type lectin-domain containing receptor kinase V.9', NULL, NULL, NULL, NULL, NULL, 4),
(21138, NULL, 'G3DSA:1.10.510.10:FF:004387', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21139, NULL, 'G3DSA:2.60.120.260:FF:000484', NULL, NULL, 'Uncharacterized protein C4D7.07c', NULL, NULL, NULL, NULL, NULL, 4),
(21140, NULL, 'G3DSA:3.40.50.300:FF:003441', NULL, NULL, 'ESX-4 secretion system protein EccC4', NULL, NULL, NULL, NULL, NULL, 4),
(21141, NULL, 'G3DSA:2.60.120.10:FF:000738', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21142, NULL, 'G3DSA:2.40.50.140:FF:000934', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21143, NULL, 'G3DSA:2.40.33.10:FF:000030', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(21144, NULL, 'G3DSA:2.30.30.170:FF:000003', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(21145, NULL, 'G3DSA:3.30.70.1450:FF:000050', NULL, NULL, 'Trk system potassium uptake protein trkA', NULL, NULL, NULL, NULL, NULL, 4),
(21146, NULL, 'G3DSA:2.130.10.10:FF:005172', NULL, NULL, 'U3 small nucleolar RNA-associated protein 4 homolog isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(21147, NULL, 'G3DSA:2.60.40.10:FF:004587', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21148, NULL, 'G3DSA:1.10.510.10:FF:003881', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21149, NULL, 'G3DSA:3.30.70.330:FF:002202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21150, NULL, 'G3DSA:3.30.870.10:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21151, NULL, 'G3DSA:1.25.40.10:FF:003198', NULL, NULL, 'Os05g0581300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(21152, NULL, 'G3DSA:2.170.300.10:FF:000024', NULL, NULL, 'N-acetylglucosamine-1-phosphodiester alpha-N-acetylglucosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(21153, NULL, 'G3DSA:2.60.40.150:FF:000369', NULL, NULL, 'Phorbol ester/diacylglycerol-binding protein unc-13', NULL, NULL, NULL, NULL, NULL, 4),
(21154, NULL, 'G3DSA:1.10.1200.10:FF:000130', NULL, NULL, 'Nonribosomal peptide synthetase easA', NULL, NULL, NULL, NULL, NULL, 4),
(21155, NULL, 'G3DSA:3.60.21.10:FF:000027', NULL, NULL, 'Purple acid phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(21156, NULL, 'G3DSA:3.30.470.20:FF:000175', NULL, NULL, 'Uncharacterized protein MJ0776', NULL, NULL, NULL, NULL, NULL, 4),
(21157, NULL, 'G3DSA:3.90.70.10:FF:000611', NULL, NULL, 'Ubiquitin-specific peptidase 28', NULL, NULL, NULL, NULL, NULL, 4),
(21158, NULL, 'G3DSA:3.40.50.12430:FF:000007', NULL, NULL, 'Folliculin', NULL, NULL, NULL, NULL, NULL, 4),
(21159, NULL, 'G3DSA:3.90.226.10:FF:000018', NULL, NULL, 'Fatty acid oxidation complex subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(21160, NULL, 'G3DSA:3.50.50.60:FF:000486', NULL, NULL, 'Ferredoxin--NADP reductase', NULL, NULL, NULL, NULL, NULL, 4),
(21161, NULL, 'G3DSA:2.60.120.380:FF:000065', NULL, NULL, 'Calpain-like cysteine peptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(21162, NULL, 'G3DSA:3.40.50.2300:FF:000010', NULL, NULL, 'Glutamate ionotropic receptor kainate type subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(21163, NULL, 'G3DSA:3.30.70.120:FF:000015', NULL, NULL, 'Nitrogen regulatory protein P-II homolog', NULL, NULL, NULL, NULL, NULL, 4),
(21164, NULL, 'G3DSA:1.20.1050.60:FF:000012', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(21165, NULL, 'G3DSA:3.30.1230.20:FF:000005', NULL, NULL, '40S ribosomal protein S21', NULL, NULL, NULL, NULL, NULL, 4),
(21166, NULL, 'G3DSA:3.30.9.10:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21167, NULL, 'G3DSA:3.40.50.300:FF:007712', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21168, NULL, 'G3DSA:3.30.60.30:FF:000046', NULL, NULL, 'Complement component C6', NULL, NULL, NULL, NULL, NULL, 4),
(21169, NULL, 'G3DSA:1.10.10.10:FF:001352', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(21170, NULL, 'G3DSA:3.30.70.20:FF:000015', NULL, NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(21171, NULL, 'G3DSA:3.40.50.720:FF:000722', NULL, NULL, 'Phosphoglycerate dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(21172, NULL, 'G3DSA:1.10.238.10:FF:000291', NULL, NULL, 'Calcium-dependent protein kinase SK5', NULL, NULL, NULL, NULL, NULL, 4),
(21173, NULL, 'G3DSA:1.10.472.10:FF:000655', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(21174, NULL, 'G3DSA:3.30.200.20:FF:000245', NULL, NULL, 'Integrin-linked protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(21175, NULL, 'G3DSA:1.25.40.150:FF:000003', NULL, NULL, 'V-type proton ATPase subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(21176, NULL, 'G3DSA:1.10.555.10:FF:000050', NULL, NULL, 'GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(21177, NULL, 'G3DSA:3.30.70.2740:FF:000009', NULL, NULL, 'FAD linked oxidase, C-terminal domain protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(21178, NULL, 'G3DSA:1.25.10.10:FF:002066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21179, NULL, 'G3DSA:3.30.465.10:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21180, NULL, 'G3DSA:3.90.470.10:FF:000035', NULL, NULL, '50S ribosomal protein L22', NULL, NULL, NULL, NULL, NULL, 4),
(21181, NULL, 'G3DSA:1.25.40.180:FF:000107', NULL, NULL, 'Protein CBG19247', NULL, NULL, NULL, NULL, NULL, 4),
(21182, NULL, 'G3DSA:3.30.70.330:FF:001893', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21183, NULL, 'G3DSA:1.25.10.10:FF:003005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21184, NULL, 'G3DSA:3.30.230.120:FF:000006', NULL, NULL, 'L-fucose kinase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(21185, NULL, 'G3DSA:3.30.40.10:FF:001461', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21186, NULL, 'G3DSA:1.25.40.10:FF:000325', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g14820', NULL, NULL, NULL, NULL, NULL, 4),
(21187, NULL, 'G3DSA:1.25.10.10:FF:002605', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21188, NULL, 'G3DSA:3.30.160.60:FF:004351', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21189, NULL, 'G3DSA:3.80.10.10:FF:004430', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21190, NULL, 'G3DSA:1.10.10.60:FF:001142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21191, NULL, 'G3DSA:3.40.390.10:FF:000006', NULL, NULL, 'Thimet oligopeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(21192, NULL, 'G3DSA:3.90.70.10:FF:000504', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21193, NULL, 'G3DSA:3.40.50.300:FF:002968', NULL, NULL, 'ABC-F type ribosomal protection protein', NULL, NULL, NULL, NULL, NULL, 4),
(21194, NULL, 'G3DSA:3.30.950.10:FF:000012', NULL, NULL, 'Uroporphyrinogen-III C-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(21195, NULL, 'G3DSA:3.40.50.1820:FF:000894', NULL, NULL, 'FAM172 family protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(21196, NULL, 'G3DSA:3.30.230.70:FF:000094', NULL, NULL, 'YALI0B14905p', NULL, NULL, NULL, NULL, NULL, 4),
(21197, NULL, 'G3DSA:2.40.30.300:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21198, NULL, 'G3DSA:2.10.220.10:FF:000027', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(21199, NULL, 'G3DSA:2.30.30.210:FF:000015', NULL, NULL, 'Ribonuclease P protein component 1', NULL, NULL, NULL, NULL, NULL, 4),
(21200, NULL, 'G3DSA:4.10.640.40:FF:000004', NULL, NULL, 'Cytoplasmic polyadenylation element-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(21201, NULL, 'G3DSA:2.60.40.10:FF:001153', NULL, NULL, 'Sallimus, isoform P', NULL, NULL, NULL, NULL, NULL, 4),
(21202, NULL, 'G3DSA:4.10.60.10:FF:000044', NULL, NULL, 'Putative universal minicircle sequence binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(21203, NULL, 'G3DSA:3.30.230.10:FF:000227', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(21204, NULL, 'G3DSA:3.40.50.1370:FF:000023', NULL, NULL, 'Ornithine carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(21205, NULL, 'G3DSA:1.10.20.10:FF:000234', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21206, NULL, 'G3DSA:3.40.640.10:FF:000329', NULL, NULL, 'Glutamate decarboxylase 1b', NULL, NULL, NULL, NULL, NULL, 4),
(21207, NULL, 'G3DSA:3.30.559.10:FF:000131', NULL, NULL, 'Nonribosomal peptide synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(21208, NULL, 'G3DSA:1.10.287.820:FF:000006', NULL, NULL, 'Amiloride-sensitive sodium channel subunit beta-2', NULL, NULL, NULL, NULL, NULL, 4),
(21209, NULL, 'G3DSA:3.40.50.300:FF:003132', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(21210, NULL, 'G3DSA:2.60.40.150:FF:000476', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(21211, NULL, 'G3DSA:3.10.20.90:FF:000871', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(21212, NULL, 'G3DSA:3.40.50.2300:FF:000263', NULL, NULL, 'Two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(21213, NULL, 'G3DSA:2.40.10.10:FF:000078', NULL, NULL, 'Serine protease H137', NULL, NULL, NULL, NULL, NULL, 4),
(21214, NULL, 'G3DSA:3.80.10.10:FF:000580', NULL, NULL, 'Adenylate cyclase AcyA', NULL, NULL, NULL, NULL, NULL, 4),
(21215, NULL, 'G3DSA:3.90.70.10:FF:000870', NULL, NULL, 'AGR370Wp', NULL, NULL, NULL, NULL, NULL, 4),
(21216, NULL, 'G3DSA:2.120.10.30:FF:000283', NULL, NULL, 'NHL repeat containing E3 ubiquitin protein ligase 1', NULL, NULL, NULL, NULL, NULL, 4),
(21217, NULL, 'G3DSA:1.20.1280.50:FF:000088', NULL, NULL, 'Cell division control protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(21218, NULL, 'G3DSA:1.10.287.1490:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21219, NULL, 'G3DSA:2.60.40.10:FF:004839', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21220, NULL, 'G3DSA:3.60.10.10:FF:000215', NULL, NULL, 'Inositol polyphosphate-5-phosphatase, 40kDa, gene 2', NULL, NULL, NULL, NULL, NULL, 4),
(21221, NULL, 'G3DSA:3.90.1640.10:FF:000002', NULL, NULL, 'Cyclic-di-AMP phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(21222, NULL, 'G3DSA:3.20.20.30:FF:000010', NULL, NULL, 'LLM class F420-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(21223, NULL, 'G3DSA:1.20.5.170:FF:000226', NULL, NULL, 'SNF2-family ATP dependent chromatin remodeling factor snf21', NULL, NULL, NULL, NULL, NULL, 4),
(21224, NULL, 'G3DSA:2.40.50.140:FF:000827', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21225, NULL, 'G3DSA:2.10.109.10:FF:000044', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(21226, NULL, 'G3DSA:3.30.710.10:FF:000253', NULL, NULL, 'BTB/POZ domain-containing protein At5g66560', NULL, NULL, NULL, NULL, NULL, 4),
(21227, NULL, 'G3DSA:1.20.120.1080:FF:000022', NULL, NULL, 'DExH-box ATP-dependent RNA helicase DExH7 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(21228, NULL, 'G3DSA:3.80.10.10:FF:003811', NULL, NULL, 'CPN2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(21229, NULL, 'G3DSA:3.40.50.11080:FF:000001', NULL, NULL, 'DNA repair and telomere maintenance protein nbs1', NULL, NULL, NULL, NULL, NULL, 4),
(21230, NULL, 'G3DSA:2.120.10.30:FF:000592', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21231, NULL, 'G3DSA:3.30.70.330:FF:003130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21232, NULL, 'G3DSA:2.40.70.10:FF:000531', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21233, NULL, 'G3DSA:2.70.150.10:FF:000188', NULL, NULL, 'Putative calcium-transporting atpase sarcoplasmic/endoplasmic reticulum type', NULL, NULL, NULL, NULL, NULL, 4),
(21234, NULL, 'G3DSA:3.10.20.770:FF:000002', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(21235, NULL, 'G3DSA:1.10.10.10:FF:000733', NULL, NULL, 'Unplaced genomic scaffold supercont2.3, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(21236, NULL, 'G3DSA:3.30.70.330:FF:001904', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21237, NULL, 'G3DSA:3.30.70.270:FF:000228', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21238, NULL, 'G3DSA:3.40.50.300:FF:006987', NULL, NULL, 'Protein P9', NULL, NULL, NULL, NULL, NULL, 4),
(21239, NULL, 'G3DSA:2.60.220.50:FF:000073', NULL, NULL, 'Adhesion G protein-coupled receptor G1', NULL, NULL, NULL, NULL, NULL, 4),
(21240, NULL, 'G3DSA:2.170.120.12:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21241, NULL, 'G3DSA:3.40.50.300:FF:002513', NULL, NULL, 'ATP-dependent dethiobiotin synthetase BioD', NULL, NULL, NULL, NULL, NULL, 4),
(21242, NULL, 'G3DSA:3.30.70.330:FF:001584', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(21243, NULL, 'G3DSA:3.30.1010.10:FF:000109', NULL, NULL, 'PIKK family atypical protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(21244, NULL, 'G3DSA:3.40.50.300:FF:004205', NULL, NULL, 'ATP-dependent helicase hrpA', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(21245, NULL, 'G3DSA:1.10.510.10:FF:002661', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21246, NULL, 'G3DSA:2.60.40.10:FF:001714', NULL, NULL, 'Echinoid, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(21247, NULL, 'G3DSA:3.40.50.300:FF:005239', NULL, NULL, 'Cell division control protein', NULL, NULL, NULL, NULL, NULL, 4),
(21248, NULL, 'G3DSA:3.40.30.10:FF:001128', NULL, NULL, 'Glutathione S-transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(21249, NULL, 'G3DSA:3.30.160.60:FF:004019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21250, NULL, 'G3DSA:3.40.640.10:FF:000296', NULL, NULL, 'Hercynylcysteine sulfoxide lyase', NULL, NULL, NULL, NULL, NULL, 4),
(21251, NULL, 'G3DSA:3.40.190.80:FF:000079', NULL, NULL, 'Probable inorganic polyphosphate/ATP-NAD kinase (Poly(P)/ATP NAD kinase)', NULL, NULL, NULL, NULL, NULL, 4),
(21252, NULL, 'G3DSA:2.170.140.10:FF:000034', NULL, NULL, 'GM24482', NULL, NULL, NULL, NULL, NULL, 4),
(21253, NULL, 'G3DSA:1.20.1250.40:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21254, NULL, 'G3DSA:1.25.40.10:FF:002686', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21255, NULL, 'G3DSA:2.130.10.10:FF:003154', NULL, NULL, 'Vacuolar protein sorting-associated protein 41-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(21256, NULL, 'G3DSA:1.10.8.710:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21257, NULL, 'G3DSA:3.40.640.10:FF:000172', NULL, NULL, 'Pyridoxal phosphate-dependent aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(21258, NULL, 'G3DSA:1.10.560.10:FF:000028', NULL, NULL, 'T-complex protein 1 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(21259, NULL, 'G3DSA:3.40.50.790:FF:000029', NULL, NULL, 'Ribosomal protein L1', NULL, NULL, NULL, NULL, NULL, 4),
(21260, NULL, 'G3DSA:1.10.1620.20:FF:000007', NULL, NULL, 'ATP synthase subunit epsilon, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(21261, NULL, 'G3DSA:1.10.238.10:FF:000072', NULL, NULL, 'Hippocalcin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(21262, NULL, 'G3DSA:3.40.50.2000:FF:000510', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(21263, NULL, 'G3DSA:1.10.10.1940:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21264, NULL, 'G3DSA:3.20.20.10:FF:000055', NULL, NULL, 'Diaminopimelate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(21265, NULL, 'G3DSA:2.60.40.10:FF:002569', NULL, NULL, 'Pyruvate dehydrogenase E1 component subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(21266, NULL, 'G3DSA:3.30.450.20:FF:000067', NULL, NULL, 'PAS domain S-box protein', NULL, NULL, NULL, NULL, NULL, 4),
(21267, NULL, 'G3DSA:3.30.160.60:FF:002693', NULL, NULL, 'PR domain zinc finger protein 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(21268, NULL, 'G3DSA:3.80.10.10:FF:001232', NULL, NULL, 'F-box/LRR-repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(21269, NULL, 'G3DSA:1.20.1740.10:FF:000106', NULL, NULL, 'Methionine transporter, putative (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(21270, NULL, 'G3DSA:2.180.10.10:FF:000004', NULL, NULL, 'Teneurin transmembrane protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(21271, NULL, 'G3DSA:4.10.400.10:FF:000270', NULL, NULL, 'LDL receptor repeat-containing protein egg-2', NULL, NULL, NULL, NULL, NULL, 4),
(21272, NULL, 'G3DSA:1.10.287.3240:FF:000014', NULL, NULL, 'V-type ATP synthase subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(21273, NULL, 'G3DSA:3.50.50.60:FF:000722', NULL, NULL, 'Worm AIF (Apoptosis inducing factor) Homolog', NULL, NULL, NULL, NULL, NULL, 4),
(21274, NULL, 'G3DSA:1.10.10.980:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21275, NULL, 'G3DSA:1.10.10.60:FF:000490', NULL, NULL, 'Transcription activator snf2l1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(21276, NULL, 'G3DSA:1.10.890.20:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21277, NULL, 'G3DSA:1.10.150.20:FF:000219', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(21278, NULL, 'G3DSA:3.40.50.10240:FF:000013', NULL, NULL, 'Thiamin pyrophosphokinase, catalytic domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(21279, NULL, 'G3DSA:2.60.40.2030:FF:000026', NULL, NULL, 'Adhesion G protein-coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(21280, NULL, 'G3DSA:2.40.30.10:FF:000422', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21281, NULL, 'G3DSA:1.25.40.10:FF:002580', NULL, NULL, 'pentatricopeptide repeat-containing protein At4g13650 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(21282, NULL, 'G3DSA:4.10.280.10:FF:000023', NULL, NULL, 'MAX isoform 13', NULL, NULL, NULL, NULL, NULL, 4),
(21283, NULL, 'G3DSA:1.20.930.40:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21284, NULL, 'G3DSA:3.30.160.60:FF:004727', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21285, NULL, 'G3DSA:3.90.230.10:FF:000017', NULL, NULL, 'Ectoine hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(21286, NULL, 'G3DSA:1.10.510.10:FF:002818', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21287, NULL, 'G3DSA:3.50.4.10:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21288, NULL, 'G3DSA:3.30.365.10:FF:000079', NULL, NULL, 'Caffeine dehydrogenase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(21289, NULL, 'G3DSA:1.20.5.2480:FF:000001', NULL, NULL, 'Reticulon', NULL, NULL, NULL, NULL, NULL, 4),
(21290, NULL, 'G3DSA:2.60.120.280:FF:000001', NULL, NULL, 'Arabinose operon regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(21291, NULL, 'G3DSA:3.90.190.20:FF:000073', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(21292, NULL, 'G3DSA:3.30.450.20:FF:000303', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(21293, NULL, 'G3DSA:1.20.950.20:FF:000014', NULL, NULL, 'Cytochrome B561', NULL, NULL, NULL, NULL, NULL, 4),
(21294, NULL, 'G3DSA:1.10.8.60:FF:000303', NULL, NULL, 'Cell division cycle 48C', NULL, NULL, NULL, NULL, NULL, 4),
(21295, NULL, 'G3DSA:3.40.50.300:FF:000259', NULL, NULL, 'UvrABC system protein A', NULL, NULL, NULL, NULL, NULL, 4),
(21296, NULL, 'G3DSA:3.30.200.20:FF:001572', NULL, NULL, 'Protein CBG00227', NULL, NULL, NULL, NULL, NULL, 4),
(21297, NULL, 'G3DSA:3.30.70.3270:FF:000005', NULL, NULL, 'Formate hydrogenlyase complex iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4),
(21298, NULL, 'G3DSA:1.10.1200.10:FF:000057', NULL, NULL, 'Peptide synthetase nrp', NULL, NULL, NULL, NULL, NULL, 4),
(21299, NULL, 'G3DSA:3.40.50.10540:FF:000002', NULL, NULL, 'Formyl-CoA:oxalate CoA-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(21300, NULL, 'G3DSA:1.10.472.10:FF:000346', NULL, NULL, 'Putative mitotic cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(21301, NULL, 'G3DSA:3.40.50.2000:FF:000055', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(21302, NULL, 'G3DSA:1.20.1560.10:FF:000828', NULL, NULL, 'ATP-binding cassette, sub-family B (MDR/TAP), member 4', NULL, NULL, NULL, NULL, NULL, 4),
(21303, NULL, 'G3DSA:2.10.110.10:FF:000221', NULL, NULL, 'Rho-GTPase-activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(21304, NULL, 'G3DSA:1.25.40.10:FF:002433', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(21305, NULL, 'G3DSA:3.40.50.1100:FF:000083', NULL, NULL, 'Cysteine synthase/cystathionine beta-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(21306, NULL, 'G3DSA:1.20.58.160:FF:000004', NULL, NULL, 'TOM1-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(21307, NULL, 'G3DSA:1.10.1090.10:FF:000002', NULL, NULL, 'Cytochrome b-c1 complex subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(21308, NULL, 'G3DSA:3.20.180.20:FF:000048', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(21309, NULL, 'G3DSA:3.40.720.10:FF:000010', NULL, NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(21310, NULL, 'G3DSA:2.10.110.10:FF:000036', NULL, NULL, 'LIM domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(21311, NULL, 'G3DSA:1.20.930.20:FF:000001', NULL, NULL, 'E3 ubiquitin-protein ligase CBL', NULL, NULL, NULL, NULL, NULL, 4),
(21312, NULL, 'G3DSA:3.40.630.30:FF:000593', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21313, NULL, 'G3DSA:3.30.1370.10:FF:000130', NULL, NULL, 'YLL032C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(21314, NULL, 'G3DSA:3.40.50.10260:FF:000019', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(21315, NULL, 'G3DSA:3.30.70.330:FF:002854', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21316, NULL, 'G3DSA:3.30.1370.210:FF:000012', NULL, NULL, 'Zinc finger CCCH domain-containing protein 28', NULL, NULL, NULL, NULL, NULL, 4),
(21317, NULL, 'G3DSA:2.30.39.10:FF:000066', NULL, NULL, 'Serpin 42Dc, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(21318, NULL, 'G3DSA:3.10.20.90:FF:000562', NULL, NULL, 'Polyubiquitin 8', NULL, NULL, NULL, NULL, NULL, 4),
(21319, NULL, 'G3DSA:1.20.1250.20:FF:002045', NULL, NULL, 'Uncharacterized membrane protein YNR062C', NULL, NULL, NULL, NULL, NULL, 4),
(21320, NULL, 'G3DSA:3.40.47.10:FF:000222', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21321, NULL, 'G3DSA:2.40.30.10:FF:000080', NULL, NULL, 'Selenocysteine-specific translation elongation factor', NULL, NULL, NULL, NULL, NULL, 4),
(21322, NULL, 'G3DSA:3.30.160.60:FF:001602', NULL, NULL, 'Zinc finger protein 490', NULL, NULL, NULL, NULL, NULL, 4),
(21323, NULL, 'G3DSA:1.10.10.10:FF:000880', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21324, NULL, 'G3DSA:3.50.50.60:FF:001470', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21325, NULL, 'G3DSA:2.60.200.20:FF:000203', NULL, NULL, 'Probable serine/threonine-protein kinase fhkD', NULL, NULL, NULL, NULL, NULL, 4),
(21326, NULL, 'G3DSA:1.10.510.10:FF:003987', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21327, NULL, 'G3DSA:3.30.420.40:FF:000942', NULL, NULL, 'Heat shock protein 70D', NULL, NULL, NULL, NULL, NULL, 4),
(21328, NULL, 'G3DSA:1.10.287.110:FF:000092', NULL, NULL, 'Type II HSP40 co-chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(21329, NULL, 'G3DSA:3.30.420.10:FF:000130', NULL, NULL, 'CAF1 family ribonuclease containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(21330, NULL, 'G3DSA:3.40.50.300:FF:004733', NULL, NULL, 'Elongation factor 1-alpha (EF-1-alpha)', NULL, NULL, NULL, NULL, NULL, 4),
(21331, NULL, 'G3DSA:1.25.40.10:FF:001961', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21332, NULL, 'G3DSA:2.70.170.10:FF:000043', NULL, NULL, 'Gamma-aminobutyric acid receptor alpha-like', NULL, NULL, NULL, NULL, NULL, 4),
(21333, NULL, 'G3DSA:3.30.160.60:FF:004480', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21334, NULL, 'G3DSA:3.65.10.10:FF:000031', NULL, NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(21335, NULL, 'G3DSA:1.10.630.10:FF:000152', NULL, NULL, 'Cytochrome P450 711A1', NULL, NULL, NULL, NULL, NULL, 4),
(21336, NULL, 'G3DSA:3.10.400.10:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21337, NULL, 'G3DSA:1.10.3460.10:FF:000037', NULL, NULL, 'Os01g0589800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(21338, NULL, 'G3DSA:1.10.10.520:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21339, NULL, 'G3DSA:3.80.10.10:FF:001917', NULL, NULL, 'Pkd1', NULL, NULL, NULL, NULL, NULL, 4),
(21340, NULL, 'G3DSA:3.30.390.30:FF:000014', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(21341, NULL, 'G3DSA:3.60.40.10:FF:000043', NULL, NULL, 'Probable protein phosphatase 2C 40', NULL, NULL, NULL, NULL, NULL, 4),
(21342, NULL, 'G3DSA:2.130.10.10:FF:001153', NULL, NULL, 'Protein will die slowly-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(21343, NULL, 'G3DSA:3.40.250.10:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21344, NULL, 'G3DSA:3.40.50.720:FF:000014', NULL, NULL, 'C-terminal-binding protein 1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(21345, NULL, 'G3DSA:3.30.70.60:FF:000016', NULL, NULL, 'Apicoplast ribosomal protein S6', NULL, NULL, NULL, NULL, NULL, 4),
(21346, NULL, 'G3DSA:1.20.58.390:FF:000308', NULL, NULL, 'Protein CBR-ACR-3', NULL, NULL, NULL, NULL, NULL, 4),
(21347, NULL, 'G3DSA:1.25.10.10:FF:002752', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21348, NULL, 'G3DSA:3.30.780.10:FF:000055', NULL, NULL, 'Translation machinery-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(21349, NULL, 'G3DSA:3.40.50.410:FF:000040', NULL, NULL, '60 kDa SS-A/Ro ribonucleoprotein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(21350, NULL, 'G3DSA:1.20.1640.10:FF:000054', NULL, NULL, 'Protein CBR-NCR-1', NULL, NULL, NULL, NULL, NULL, 4),
(21351, NULL, 'G3DSA:2.60.120.1440:FF:000006', NULL, NULL, 'Sigma factor regulator, VreR', NULL, NULL, NULL, NULL, NULL, 4),
(21352, NULL, 'G3DSA:3.90.190.10:FF:000322', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(21353, NULL, 'G3DSA:3.40.50.1820:FF:001147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21354, NULL, 'G3DSA:3.10.450.50:FF:000041', NULL, NULL, 'Nuclear transport factor 2 family export factor 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(21355, NULL, 'G3DSA:2.60.40.10:FF:004278', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21356, NULL, 'G3DSA:3.30.379.10:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21357, NULL, 'G3DSA:1.10.1420.10:FF:000040', NULL, NULL, 'Mismatch repair ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(21358, NULL, 'G3DSA:3.20.20.70:FF:000230', NULL, NULL, 'Putative dihydrouridine synthase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(21359, NULL, 'G3DSA:1.20.1050.10:FF:000037', NULL, NULL, 'Glutathione S-transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(21360, NULL, 'G3DSA:1.20.1270.10:FF:000042', NULL, NULL, 'Chaperone protein DnaK', NULL, NULL, NULL, NULL, NULL, 4),
(21361, NULL, 'G3DSA:3.40.1800.20:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21362, NULL, 'G3DSA:3.40.50.300:FF:001552', NULL, NULL, 'Mismatch repair ATPase (MutS family)', NULL, NULL, NULL, NULL, NULL, 4),
(21363, NULL, 'G3DSA:3.30.200.20:FF:000953', NULL, NULL, 'Si:ch211-220i18.4', NULL, NULL, NULL, NULL, NULL, 4),
(21364, NULL, 'G3DSA:2.60.120.10:FF:000632', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(21365, NULL, 'G3DSA:3.30.160.60:FF:000984', NULL, NULL, 'zinc finger protein 205 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(21366, NULL, 'G3DSA:3.80.10.10:FF:001760', NULL, NULL, 'Tehao, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(21367, NULL, 'G3DSA:1.10.1370.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21368, NULL, 'G3DSA:2.40.10.230:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21369, NULL, 'G3DSA:3.40.50.300:FF:000462', NULL, NULL, 'Vitamin B12 import ATP-binding protein BtuD', NULL, NULL, NULL, NULL, NULL, 4),
(21370, NULL, 'G3DSA:2.130.10.10:FF:005880', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21371, NULL, 'G3DSA:2.130.10.10:FF:004790', NULL, NULL, 'Ribosome biogenesis protein WDR12 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(21372, NULL, 'G3DSA:3.40.50.300:FF:003896', NULL, NULL, 'Sodium ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(21373, NULL, 'G3DSA:3.30.160.20:FF:000112', NULL, NULL, 'Ribonuclease 3-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(21374, NULL, 'G3DSA:6.10.140.2220:FF:000011', NULL, NULL, 'Tudor domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(21375, NULL, 'G3DSA:2.40.40.20:FF:000055', NULL, NULL, 'Vesicular-fusion protein nsf, putative', NULL, NULL, NULL, NULL, NULL, 4),
(21376, NULL, 'G3DSA:3.90.70.10:FF:000291', NULL, NULL, 'Deubiquitylating with USP/UBP and OTU domains', NULL, NULL, NULL, NULL, NULL, 4),
(21377, NULL, 'G3DSA:1.10.238.10:FF:001252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(21378, NULL, 'G3DSA:3.30.1330.120:FF:000005', NULL, NULL, 'Catabolic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(21379, NULL, 'G3DSA:3.60.110.10:FF:000004', NULL, NULL, 'Carbon-nitrogen hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(21380, NULL, 'G3DSA:3.40.50.80:FF:000234', NULL, NULL, 'NADH--cytochrome b5 reductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(21381, NULL, 'G3DSA:3.30.160.60:FF:005441', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21382, NULL, 'G3DSA:3.40.50.80:FF:000110', NULL, NULL, 'Respiratory burst oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(21383, NULL, 'G3DSA:3.10.450.40:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21384, NULL, 'G3DSA:2.40.50.90:FF:000082', NULL, NULL, 'Staphylococcal nuclease domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(21385, NULL, 'G3DSA:3.90.70.10:FF:000268', NULL, NULL, 'Cysteine protease 19', NULL, NULL, NULL, NULL, NULL, 4),
(21386, NULL, 'G3DSA:2.60.40.10:FF:000225', NULL, NULL, 'Myosin-binding protein C, cardiac-type', NULL, NULL, NULL, NULL, NULL, 4),
(21387, NULL, 'G3DSA:3.40.850.10:FF:000233', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(21388, NULL, 'G3DSA:1.20.1510.10:FF:000050', NULL, NULL, 'Cation efflux family protein', NULL, NULL, NULL, NULL, NULL, 4),
(21389, NULL, 'G3DSA:3.10.290.10:FF:000090', NULL, NULL, '30S ribosomal protein S4, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(21390, NULL, 'G3DSA:2.130.10.10:FF:000192', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(21391, NULL, 'G3DSA:2.30.29.30:FF:000560', NULL, NULL, 'Sterol 3-beta-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(21392, NULL, 'G3DSA:1.10.510.10:FF:002442', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21393, NULL, 'G3DSA:3.90.550.10:FF:000199', NULL, NULL, 'Molybdenum cofactor guanylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(21394, NULL, 'G3DSA:1.10.3090.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21395, NULL, 'G3DSA:3.40.50.2300:FF:000791', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21396, NULL, 'G3DSA:3.40.630.170:FF:000003', NULL, NULL, 'Glycylpeptide N-tetradecanoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(21397, NULL, 'G3DSA:1.20.1560.10:FF:000452', NULL, NULL, 'Bacterial MDR-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(21398, NULL, 'G3DSA:1.10.240.10:FF:000009', NULL, NULL, 'Tryptophan-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(21399, NULL, 'G3DSA:3.30.70.660:FF:000019', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(21400, NULL, 'G3DSA:3.40.50.2300:FF:000116', NULL, NULL, 'HTH-type transcriptional repressor CytR', NULL, NULL, NULL, NULL, NULL, 4),
(21401, NULL, 'G3DSA:2.130.10.10:FF:000534', NULL, NULL, 'Xyloglucanase Xgh74A', NULL, NULL, NULL, NULL, NULL, 4),
(21402, NULL, 'G3DSA:3.30.470.20:FF:000102', NULL, NULL, 'Tubulin glycylase 3B', NULL, NULL, NULL, NULL, NULL, 4),
(21403, NULL, 'G3DSA:3.40.50.300:FF:000838', NULL, NULL, 'ABC multidrug transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(21404, NULL, 'G3DSA:2.60.40.60:FF:000178', NULL, NULL, 'Protocadherin Fat 2', NULL, NULL, NULL, NULL, NULL, 4),
(21405, NULL, 'G3DSA:3.90.380.10:FF:000005', NULL, NULL, 'Rieske 2Fe-2S family protein', NULL, NULL, NULL, NULL, NULL, 4),
(21406, NULL, 'G3DSA:3.40.50.2300:FF:000482', NULL, NULL, 'Glutamate receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(21407, NULL, 'G3DSA:3.30.160.60:FF:000770', NULL, NULL, 'zinc finger protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(21408, NULL, 'G3DSA:3.30.40.10:FF:002186', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(21409, NULL, 'G3DSA:3.30.40.10:FF:001567', NULL, NULL, 'U-box domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(21410, NULL, 'G3DSA:1.20.120.140:FF:000020', NULL, NULL, 'Signal recognition particle receptor FtsY', NULL, NULL, NULL, NULL, NULL, 4),
(21411, NULL, 'G3DSA:3.40.50.300:FF:008567', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(21412, NULL, 'G3DSA:3.10.180.10:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21413, NULL, 'G3DSA:1.10.510.10:FF:001514', NULL, NULL, 'Kinase, STE STE20', NULL, NULL, NULL, NULL, NULL, 4),
(21414, NULL, 'G3DSA:1.10.3120.10:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21415, NULL, 'G3DSA:1.10.357.70:FF:000023', NULL, NULL, 'Exocyst complex component Sec6, putative', NULL, NULL, NULL, NULL, NULL, 4),
(21416, NULL, 'G3DSA:3.30.43.10:FF:000006', NULL, NULL, 'UDP-N-acetylenolpyruvoylglucosamine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(21417, NULL, 'G3DSA:2.120.10.80:FF:000235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21418, NULL, 'G3DSA:1.10.510.10:FF:002133', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21419, NULL, 'G3DSA:2.130.10.10:FF:005205', NULL, NULL, 'Uncharacterized WD repeat-containing protein C343.04c', NULL, NULL, NULL, NULL, NULL, 4),
(21420, NULL, 'G3DSA:1.10.238.10:FF:001229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21421, NULL, 'G3DSA:3.30.519.10:FF:000010', NULL, NULL, 'Rab proteins geranylgeranyltransferase component A', NULL, NULL, NULL, NULL, NULL, 4),
(21422, NULL, 'G3DSA:3.30.40.10:FF:001258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21423, NULL, 'G3DSA:3.40.1110.10:FF:000311', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21424, NULL, 'G3DSA:3.40.50.1220:FF:000135', NULL, NULL, 'Sirtuin 7', NULL, NULL, NULL, NULL, NULL, 4),
(21425, NULL, 'G3DSA:1.10.8.10:FF:000204', NULL, NULL, 'Ubiquitin associated and SH3 domain containing Bb', NULL, NULL, NULL, NULL, NULL, 4),
(21426, NULL, 'G3DSA:3.40.50.11050:FF:000003', NULL, NULL, 'TcdA protein', NULL, NULL, NULL, NULL, NULL, 4),
(21427, NULL, 'G3DSA:2.60.40.10:FF:003283', NULL, NULL, 'Mcam protein', NULL, NULL, NULL, NULL, NULL, 4),
(21428, NULL, 'G3DSA:3.40.50.720:FF:001902', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(21429, NULL, 'G3DSA:1.20.120.350:FF:000077', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(21430, NULL, 'G3DSA:2.40.50.90:FF:000205', NULL, NULL, 'Probable ATP-dependent RNA helicase spindle-E', NULL, NULL, NULL, NULL, NULL, 4),
(21431, NULL, 'G3DSA:3.30.70.330:FF:000724', NULL, NULL, 'Putative RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(21432, NULL, 'G3DSA:3.40.190.10:FF:000682', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21433, NULL, 'G3DSA:3.50.50.60:FF:000851', NULL, NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(21434, NULL, 'G3DSA:3.30.200.20:FF:001881', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(21435, NULL, 'G3DSA:1.10.10.60:FF:000523', NULL, NULL, 'Homeobox protein egl-5', NULL, NULL, NULL, NULL, NULL, 4),
(21436, NULL, 'G3DSA:2.60.40.60:FF:000886', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(21437, NULL, 'G3DSA:3.90.940.20:FF:000001', NULL, NULL, 'DNA-directed RNA polymerases I, II, and III subunit RPABC1', NULL, NULL, NULL, NULL, NULL, 4),
(21438, NULL, 'G3DSA:1.25.40.470:FF:000060', NULL, NULL, 'Intraflagellar transport protein 172', NULL, NULL, NULL, NULL, NULL, 4),
(21439, NULL, 'G3DSA:3.10.110.10:FF:000150', NULL, NULL, 'Ubiquitin-conjugating enzyme E2-17 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(21440, NULL, 'G3DSA:1.10.510.10:FF:000188', NULL, NULL, 'CaM kinase-like vesicle-associated, like', NULL, NULL, NULL, NULL, NULL, 4),
(21441, NULL, 'G3DSA:3.40.140.10:FF:000280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21442, NULL, 'G3DSA:3.80.10.10:FF:002721', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(21443, NULL, 'G3DSA:1.20.1250.20:FF:001792', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21444, NULL, 'G3DSA:3.40.50.2000:FF:000240', NULL, NULL, 'Alpha-1,2-mannosyltransferase (Alg2)', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(21445, NULL, 'G3DSA:1.10.1410.10:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21446, NULL, 'G3DSA:3.90.120.10:FF:000026', NULL, NULL, 'DNA (cytosine-5)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(21447, NULL, 'G3DSA:3.90.1150.10:FF:000038', NULL, NULL, '1-aminocyclopropane-1-carboxylate synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(21448, NULL, 'G3DSA:1.20.1070.10:FF:000600', NULL, NULL, 'Retinal G-protein-coupled receptor', NULL, NULL, NULL, NULL, NULL, 4),
(21449, NULL, 'G3DSA:1.10.10.60:FF:000737', NULL, NULL, 'Homeobox protein DBX1', NULL, NULL, NULL, NULL, NULL, 4),
(21450, NULL, 'G3DSA:3.60.20.10:FF:000244', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21451, NULL, 'G3DSA:3.40.50.2000:FF:000616', NULL, NULL, 'Slr1063 protein', NULL, NULL, NULL, NULL, NULL, 4),
(21452, NULL, 'G3DSA:1.10.510.10:FF:001481', NULL, NULL, 'Serine/threonine protein kinase MARK2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(21453, NULL, 'G3DSA:2.120.10.80:FF:000382', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(21454, NULL, 'G3DSA:3.90.132.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21455, NULL, 'G3DSA:3.60.20.40:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21456, NULL, 'G3DSA:3.40.50.720:FF:001650', NULL, NULL, 'YALI0B21692p', NULL, NULL, NULL, NULL, NULL, 4),
(21457, NULL, 'G3DSA:3.40.50.1820:FF:001366', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(21458, NULL, 'G3DSA:1.10.510.10:FF:001172', NULL, NULL, 'Cytoplasmic export protein', NULL, NULL, NULL, NULL, NULL, 4),
(21459, NULL, 'G3DSA:2.30.30.940:FF:000015', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(21460, NULL, 'G3DSA:1.25.10.10:FF:001116', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(21461, NULL, 'G3DSA:2.10.25.10:FF:001108', NULL, NULL, 'C-type LECtin', NULL, NULL, NULL, NULL, NULL, 4),
(21462, NULL, 'G3DSA:3.40.50.970:FF:000106', NULL, NULL, 'Pyruvate:ferredoxin (Flavodoxin) oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(21463, NULL, 'G3DSA:1.20.1250.20:FF:001336', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21464, NULL, 'G3DSA:2.130.10.10:FF:000748', NULL, NULL, 'U3 snoRNA-associated small subunit rRNA processing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(21465, NULL, 'G3DSA:2.40.10.10:FF:000314', NULL, NULL, 'elastase-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(21466, NULL, 'G3DSA:1.25.10.10:FF:000588', NULL, NULL, 'exportin-5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(21467, NULL, 'G3DSA:3.30.70.330:FF:000415', NULL, NULL, 'Flowering time control protein FPA', NULL, NULL, NULL, NULL, NULL, 4),
(21468, NULL, 'G3DSA:3.50.7.10:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21469, NULL, 'G3DSA:2.10.25.10:FF:001816', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21470, NULL, 'G3DSA:1.10.1370.30:FF:000035', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(21471, NULL, 'G3DSA:3.40.50.10140:FF:000062', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(21472, NULL, 'G3DSA:3.30.450.40:FF:000062', NULL, NULL, 'Adenylate/guanylate cyclase catalytic domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(21473, NULL, 'G3DSA:3.40.50.2300:FF:001443', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21474, NULL, 'G3DSA:3.30.70.330:FF:000600', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(21475, NULL, 'G3DSA:2.130.10.10:FF:004244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21476, NULL, 'G3DSA:2.60.40.10:FF:003659', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21477, NULL, 'G3DSA:3.40.50.720:FF:001341', NULL, NULL, '3-oxoacyl-[acyl-carrier protein] reductase', NULL, NULL, NULL, NULL, NULL, 4),
(21478, NULL, 'G3DSA:3.40.50.450:FF:000057', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(21479, NULL, 'G3DSA:2.60.40.10:FF:004834', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21480, NULL, 'G3DSA:3.30.590.50:FF:000013', NULL, NULL, 'Glutamate-cysteine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(21481, NULL, 'G3DSA:1.20.120.850:FF:000002', NULL, NULL, 'DNA repair and recombination protein RAD54-like', NULL, NULL, NULL, NULL, NULL, 4),
(21482, NULL, 'G3DSA:3.90.1170.10:FF:000028', NULL, NULL, 'Ribosomal protein L16', NULL, NULL, NULL, NULL, NULL, 4),
(21483, NULL, 'G3DSA:3.50.50.60:FF:000834', NULL, NULL, 'YALI0D21076p', NULL, NULL, NULL, NULL, NULL, 4),
(21484, NULL, 'G3DSA:3.80.10.10:FF:001209', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(21485, NULL, 'G3DSA:2.130.10.10:FF:005413', NULL, NULL, 'Adipose protein', NULL, NULL, NULL, NULL, NULL, 4),
(21486, NULL, 'G3DSA:3.65.10.10:FF:000014', NULL, NULL, 'UDP-N-acetylglucosamine 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(21487, NULL, 'G3DSA:3.40.50.10380:FF:000010', NULL, NULL, 'NADP-dependent malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(21488, NULL, 'G3DSA:1.20.1250.20:FF:000605', NULL, NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(21489, NULL, 'G3DSA:2.60.40.10:FF:001057', NULL, NULL, 'PKHD1 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(21490, NULL, 'G3DSA:2.60.40.150:FF:000554', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21491, NULL, 'G3DSA:1.50.10.10:FF:000187', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(21492, NULL, 'G3DSA:3.90.1150.10:FF:000015', NULL, NULL, 'Alanine aminotransferase AlaC', NULL, NULL, NULL, NULL, NULL, 4),
(21493, NULL, 'G3DSA:2.30.180.10:FF:000193', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21494, NULL, 'G3DSA:1.10.132.60:FF:000043', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(21495, NULL, 'G3DSA:3.20.20.30:FF:000038', NULL, NULL, 'Alkanal monooxygenase beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(21496, NULL, 'G3DSA:3.40.50.1100:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21497, NULL, 'G3DSA:3.40.50.2000:FF:000370', NULL, NULL, 'GM19574', NULL, NULL, NULL, NULL, NULL, 4),
(21498, NULL, 'G3DSA:4.10.1240.10:FF:000063', NULL, NULL, 'Contactin-6', NULL, NULL, NULL, NULL, NULL, 4),
(21499, NULL, 'G3DSA:3.40.50.1820:FF:000326', NULL, NULL, 'Putative esterase', NULL, NULL, NULL, NULL, NULL, 4),
(21500, NULL, 'G3DSA:3.40.850.10:FF:000025', NULL, NULL, 'kinesin-like protein KIF27 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(21501, NULL, 'G3DSA:3.90.550.50:FF:000177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21502, NULL, 'G3DSA:3.30.160.60:FF:005891', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21503, NULL, 'G3DSA:3.30.70.890:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21504, NULL, 'G3DSA:1.20.1280.290:FF:000039', NULL, NULL, 'Integral membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(21505, NULL, 'G3DSA:3.30.200.20:FF:001206', NULL, NULL, 'Os07g0301500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(21506, NULL, 'G3DSA:3.40.50.620:FF:000333', NULL, NULL, 'Nicotinamide mononucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(21507, NULL, 'G3DSA:1.25.40.10:FF:002456', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(21508, NULL, 'G3DSA:2.70.130.10:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21509, NULL, 'G3DSA:3.40.50.720:FF:001998', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21510, NULL, 'G3DSA:3.40.50.80:FF:000026', NULL, NULL, 'Putative respiratory burst oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(21511, NULL, 'G3DSA:1.25.40.10:FF:005311', NULL, NULL, 'Penicillin-binding protein activator LpoA', NULL, NULL, NULL, NULL, NULL, 4),
(21512, NULL, 'G3DSA:3.30.160.60:FF:000085', NULL, NULL, 'Snail zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(21513, NULL, 'G3DSA:2.130.10.10:FF:006032', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(21514, NULL, 'G3DSA:3.40.50.720:FF:001094', NULL, NULL, 'NAD(P)-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(21515, NULL, 'G3DSA:3.40.190.10:FF:000890', NULL, NULL, 'Fe(III)-induced transcriptional regulator IfcR', NULL, NULL, NULL, NULL, NULL, 4),
(21516, NULL, 'G3DSA:3.90.470.10:FF:000012', NULL, NULL, '60S ribosomal protein L17', NULL, NULL, NULL, NULL, NULL, 4),
(21517, NULL, 'G3DSA:3.40.50.1780:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21518, NULL, 'G3DSA:1.25.10.10:FF:002628', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21519, NULL, 'G3DSA:1.25.10.10:FF:003134', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(21520, NULL, 'G3DSA:1.20.1070.10:FF:000830', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21521, NULL, 'G3DSA:3.40.930.10:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21522, NULL, 'G3DSA:3.10.330.10:FF:000003', NULL, NULL, 'vesicle-fusing ATPase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(21523, NULL, 'G3DSA:3.30.40.10:FF:002079', NULL, NULL, 'E3 ubiquitin-protein ligase RNF13', NULL, NULL, NULL, NULL, NULL, 4),
(21524, NULL, 'G3DSA:2.40.70.10:FF:000447', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21525, NULL, 'G3DSA:1.10.472.10:FF:000082', NULL, NULL, 'retinoblastoma-like protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(21526, NULL, 'G3DSA:3.40.50.1820:FF:001271', NULL, NULL, 'Protein phosphatase methylesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(21527, NULL, 'G3DSA:3.30.70.330:FF:000516', NULL, NULL, 'RNA-binding motif protein 15B', NULL, NULL, NULL, NULL, NULL, 4),
(21528, NULL, 'G3DSA:1.20.272.10:FF:000076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21529, NULL, 'G3DSA:3.40.640.10:FF:000312', NULL, NULL, 'Pyridoxal phosphate-dependent aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(21530, NULL, 'G3DSA:3.30.530.20:FF:000141', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(21531, NULL, 'G3DSA:2.30.42.10:FF:000534', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21532, NULL, 'G3DSA:2.60.40.10:FF:003878', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21533, NULL, 'G3DSA:3.30.160.60:FF:004249', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21534, NULL, 'G3DSA:3.40.50.300:FF:007847', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21535, NULL, 'G3DSA:1.10.287.70:FF:000231', NULL, NULL, 'Glutamate receptor ionotropic, kainate 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(21536, NULL, 'G3DSA:3.30.780.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21537, NULL, 'G3DSA:2.40.30.10:FF:000113', NULL, NULL, 'Translation initiation factor IF-2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(21538, NULL, 'G3DSA:1.10.287.1080:FF:000012', NULL, NULL, 'MazG nucleotide pyrophosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(21539, NULL, 'G3DSA:3.30.200.20:FF:002297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21540, NULL, 'G3DSA:2.60.120.620:FF:000154', NULL, NULL, 'Prolyl 4-hydroxylase alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(21541, NULL, 'G3DSA:3.30.2090.10:FF:000002', NULL, NULL, 'Efflux pump membrane transporter', NULL, NULL, NULL, NULL, NULL, 4),
(21542, NULL, 'G3DSA:1.20.1250.20:FF:001224', NULL, NULL, 'Protein NRT1/ PTR FAMILY 5.10', NULL, NULL, NULL, NULL, NULL, 4),
(21543, NULL, 'G3DSA:3.30.420.40:FF:000818', NULL, NULL, 'Major heat shock 70 kDa protein Ab-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(21544, NULL, 'G3DSA:1.25.40.20:FF:001615', NULL, NULL, 'Asparaginase', NULL, NULL, NULL, NULL, NULL, 4),
(21545, NULL, 'G3DSA:1.20.1250.40:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21546, NULL, 'G3DSA:1.25.40.540:FF:000002', NULL, NULL, 'PP2A regulatory subunit TAP46', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(21547, NULL, 'G3DSA:3.30.160.60:FF:003070', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(21548, NULL, 'G3DSA:3.40.630.10:FF:000486', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21549, NULL, 'G3DSA:2.60.40.420:FF:000220', NULL, NULL, 'Coagulation factor V', NULL, NULL, NULL, NULL, NULL, 4),
(21550, NULL, 'G3DSA:1.10.340.70:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21551, NULL, 'G3DSA:3.30.360.10:FF:000080', NULL, NULL, '4-hydroxy-tetrahydrodipicolinate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(21552, NULL, 'G3DSA:2.10.70.10:FF:000010', NULL, NULL, 'Seizure related 6 homolog like', NULL, NULL, NULL, NULL, NULL, 4),
(21553, NULL, 'G3DSA:1.10.287.470:FF:000087', NULL, NULL, 'Multidrug resistance efflux pump, RND family, membrane fusion protein EmrA', NULL, NULL, NULL, NULL, NULL, 4),
(21554, NULL, 'G3DSA:2.60.120.560:FF:000012', NULL, NULL, 'Levanase (2,6-beta-D-fructofuranosidase)', NULL, NULL, NULL, NULL, NULL, 4),
(21555, NULL, 'G3DSA:2.130.10.10:FF:004475', NULL, NULL, 'Striatin, calmodulin-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(21556, NULL, 'G3DSA:2.40.50.140:FF:000951', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21557, NULL, 'G3DSA:1.10.10.10:FF:000548', NULL, NULL, 'Cyclic di-GMP phosphodiesterase yahA', NULL, NULL, NULL, NULL, NULL, 4),
(21558, NULL, 'G3DSA:3.20.20.70:FF:000691', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21559, NULL, 'G3DSA:1.20.1080.10:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21560, NULL, 'G3DSA:3.30.200.20:FF:001892', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(21561, NULL, 'G3DSA:1.10.238.10:FF:000280', NULL, NULL, 'Calcium-binding EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(21562, NULL, 'G3DSA:3.30.70.960:FF:000014', NULL, NULL, 'Transmembrane protease serine 11G', NULL, NULL, NULL, NULL, NULL, 4),
(21563, NULL, 'G3DSA:1.10.510.10:FF:000784', NULL, NULL, 'Os07g0534300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(21564, NULL, 'G3DSA:1.10.10.10:FF:001588', NULL, NULL, 'Putative O-methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(21565, NULL, 'G3DSA:3.40.50.300:FF:006650', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21566, NULL, 'G3DSA:3.10.290.10:FF:000078', NULL, NULL, 'Uncharacterized RNA pseudouridine synthase Caur_0901', NULL, NULL, NULL, NULL, NULL, 4),
(21567, NULL, 'G3DSA:1.10.150.240:FF:000024', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(21568, NULL, 'G3DSA:3.40.50.720:FF:002403', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21569, NULL, 'G3DSA:1.20.120.1630:FF:000013', NULL, NULL, 'Lamin-B receptor-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(21570, NULL, 'G3DSA:3.30.420.10:FF:000585', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21571, NULL, 'G3DSA:3.40.50.11380:FF:000001', NULL, NULL, 'UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase 110 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(21572, NULL, 'G3DSA:3.30.1370.10:FF:000147', NULL, NULL, 'FUBP1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(21573, NULL, 'G3DSA:2.60.34.10:FF:000025', NULL, NULL, 'Heat shock 70 kDa protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(21574, NULL, 'G3DSA:2.40.50.120:FF:000052', NULL, NULL, 'Tissue inhibitor of metalloproteinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(21575, NULL, 'G3DSA:1.10.10.60:FF:000282', NULL, NULL, 'Tigger transposable element derived 5', NULL, NULL, NULL, NULL, NULL, 4),
(21576, NULL, 'G3DSA:2.40.110.10:FF:000074', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(21577, NULL, 'G3DSA:1.25.40.90:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21578, NULL, 'G3DSA:1.10.510.10:FF:001273', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(21579, NULL, 'G3DSA:3.40.50.720:FF:000149', NULL, NULL, '15-hydroxyprostaglandin dehydrogenase [NAD(+)]', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(21580, NULL, 'G3DSA:2.30.42.10:FF:000181', NULL, NULL, 'Putative serine protease HTRA3', NULL, NULL, NULL, NULL, NULL, 4),
(21581, NULL, 'G3DSA:3.50.50.60:FF:001239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21582, NULL, 'G3DSA:1.20.58.390:FF:000168', NULL, NULL, 'Cholinergic receptor nicotinic beta 1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(21583, NULL, 'G3DSA:3.90.1310.10:FF:000017', NULL, NULL, 'Penicillin-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(21584, NULL, 'G3DSA:1.10.510.10:FF:004139', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21585, NULL, 'G3DSA:2.60.40.10:FF:004042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21586, NULL, 'G3DSA:3.40.50.150:FF:000725', NULL, NULL, 'Glutathione S-transferase, C-terminal domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(21587, NULL, 'G3DSA:1.25.40.10:FF:001837', NULL, NULL, 'ERAD-associated E3 ubiquitin-protein ligase component HRD3A', NULL, NULL, NULL, NULL, NULL, 4),
(21588, NULL, 'G3DSA:3.30.160.60:FF:001506', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(21589, NULL, 'G3DSA:3.90.190.10:FF:000081', NULL, NULL, 'Tyrosine phosphatase type IVA', NULL, NULL, NULL, NULL, NULL, 4),
(21590, NULL, 'G3DSA:1.10.357.50:FF:000023', NULL, NULL, 'Exocyst complex component 3', NULL, NULL, NULL, NULL, NULL, 4),
(21591, NULL, 'G3DSA:1.25.10.10:FF:001105', NULL, NULL, 'Protein CBR-RME-8, isoform b', NULL, NULL, NULL, NULL, NULL, 4),
(21592, NULL, 'G3DSA:3.30.40.10:FF:000634', NULL, NULL, 'Peroxisome assembly protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(21593, NULL, 'G3DSA:1.20.1070.10:FF:001218', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(21594, NULL, 'G3DSA:1.25.10.10:FF:001217', NULL, NULL, 'Protein CELLULOSE SYNTHASE INTERACTIVE 1', NULL, NULL, NULL, NULL, NULL, 4),
(21595, NULL, 'G3DSA:2.130.10.10:FF:000304', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(21596, NULL, 'G3DSA:1.10.10.10:FF:000969', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(21597, NULL, 'G3DSA:2.60.120.200:FF:000601', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21598, NULL, 'G3DSA:3.40.50.300:FF:005026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21599, NULL, 'G3DSA:2.20.28.10:FF:000007', NULL, NULL, 'DNA helicase MCM8 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(21600, NULL, 'G3DSA:3.90.550.10:FF:000064', NULL, NULL, 'Glycosyltransferases', NULL, NULL, NULL, NULL, NULL, 4),
(21601, NULL, 'G3DSA:2.30.30.100:FF:000230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21602, NULL, 'G3DSA:3.90.79.10:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21603, NULL, 'G3DSA:3.30.310.50:FF:000026', NULL, NULL, 'Phosphoglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(21604, NULL, 'G3DSA:3.10.310.20:FF:000011', NULL, NULL, 'DHH phosphoesterase', NULL, NULL, NULL, NULL, NULL, 4),
(21605, NULL, 'G3DSA:2.130.10.10:FF:004115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21606, NULL, 'G3DSA:1.20.58.390:FF:000056', NULL, NULL, '5-hydroxytryptamine receptor 3B', NULL, NULL, NULL, NULL, NULL, 4),
(21607, NULL, 'G3DSA:1.10.20.40:FF:000001', NULL, NULL, 'Diaphanous related formin 2', NULL, NULL, NULL, NULL, NULL, 4),
(21608, NULL, 'G3DSA:2.60.40.150:FF:000133', NULL, NULL, 'Pre-mRNA splicing helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(21609, NULL, 'G3DSA:3.50.50.60:FF:000042', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(21610, NULL, 'G3DSA:2.60.120.260:FF:000254', NULL, NULL, 'Furin putative serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(21611, NULL, 'G3DSA:3.90.70.10:FF:000509', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21612, NULL, 'G3DSA:1.10.486.10:FF:000052', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(21613, NULL, 'G3DSA:3.10.680.10:FF:000001', NULL, NULL, 'Photosystem II CP47 reaction center protein', NULL, NULL, NULL, NULL, NULL, 4),
(21614, NULL, 'G3DSA:2.130.10.10:FF:000293', NULL, NULL, 'WD repeat and FYVE domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(21615, NULL, 'G3DSA:1.25.40.10:FF:004373', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21616, NULL, 'G3DSA:3.10.350.10:FF:000016', NULL, NULL, 'Immunoglobulin G-binding protein A', NULL, NULL, NULL, NULL, NULL, 4),
(21617, NULL, 'G3DSA:2.60.40.1180:FF:000052', NULL, NULL, 'Uncharacterized glycosyl hydrolase YIR007W', NULL, NULL, NULL, NULL, NULL, 4),
(21618, NULL, 'G3DSA:1.10.510.10:FF:000328', NULL, NULL, 'Cyclin-dependent kinase 20 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(21619, NULL, 'G3DSA:1.20.1080.10:FF:000095', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(21620, NULL, 'G3DSA:2.70.70.10:FF:000064', NULL, NULL, 'PTS sugar transporter subunit IIA', NULL, NULL, NULL, NULL, NULL, 4),
(21621, NULL, 'G3DSA:1.10.1070.20:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21622, NULL, 'G3DSA:1.20.1280.50:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21623, NULL, 'G3DSA:3.40.50.2300:FF:000139', NULL, NULL, 'Serine threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(21624, NULL, 'G3DSA:3.30.559.30:FF:000013', NULL, NULL, 'Phthiocerol/phthiodiolone dimycocerosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(21625, NULL, 'G3DSA:1.20.120.230:FF:000024', NULL, NULL, 'Vinculin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(21626, NULL, 'G3DSA:1.10.10.10:FF:001037', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(21627, NULL, 'G3DSA:2.60.40.60:FF:000190', NULL, NULL, 'Protocadherin 12', NULL, NULL, NULL, NULL, NULL, 4),
(21628, NULL, 'G3DSA:2.40.30.170:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21629, NULL, 'G3DSA:4.10.60.10:FF:000168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21630, NULL, 'G3DSA:2.60.40.10:FF:003406', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21631, NULL, 'G3DSA:1.20.58.340:FF:000086', NULL, NULL, 'Metal ion transporter', NULL, NULL, NULL, NULL, NULL, 4),
(21632, NULL, 'G3DSA:1.10.20.10:FF:000346', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21633, NULL, 'G3DSA:2.60.40.10:FF:003311', NULL, NULL, 'Neural cell adhesion molecule 3', NULL, NULL, NULL, NULL, NULL, 4),
(21634, NULL, 'G3DSA:2.60.40.10:FF:002917', NULL, NULL, 'Probable beta-D-xylosidase 7', NULL, NULL, NULL, NULL, NULL, 4),
(21635, NULL, 'G3DSA:1.50.10.160:FF:000001', NULL, NULL, 'Ent-copalyl diphosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(21636, NULL, 'G3DSA:3.30.1330.60:FF:000030', NULL, NULL, 'Outer membrane porin F', NULL, NULL, NULL, NULL, NULL, 4),
(21637, NULL, 'G3DSA:3.90.650.10:FF:000009', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase subunit PurL', NULL, NULL, NULL, NULL, NULL, 4),
(21638, NULL, 'G3DSA:1.20.140.40:FF:000003', NULL, NULL, 'Invertase/pectin methylesterase inhibitor family protein', NULL, NULL, NULL, NULL, NULL, 4),
(21639, NULL, 'G3DSA:3.90.1410.10:FF:000053', NULL, NULL, 'Rubisco small subunit small subunit n-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(21640, NULL, 'G3DSA:3.40.50.150:FF:001361', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21641, NULL, 'G3DSA:2.30.30.40:FF:000381', NULL, NULL, 'NCK (Non-Catalytic region of tyrosine Kinase) adaptor protein family', NULL, NULL, NULL, NULL, NULL, 4),
(21642, NULL, 'G3DSA:3.40.50.1000:FF:000732', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21643, NULL, 'G3DSA:3.30.200.20:FF:001678', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(21644, NULL, 'G3DSA:4.10.860.10:FF:000017', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4),
(21645, NULL, 'G3DSA:2.20.25.350:FF:000004', NULL, NULL, 'Putative eukaryotic translation initiation factor 5', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(21646, NULL, 'G3DSA:2.60.40.420:FF:000006', NULL, NULL, 'Cell division protein FtsP', NULL, NULL, NULL, NULL, NULL, 4),
(21647, NULL, 'G3DSA:2.170.120.12:FF:000001', NULL, NULL, 'DNA-directed RNA polymerase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(21648, NULL, 'G3DSA:3.40.50.2000:FF:000723', NULL, NULL, 'ADP-heptose--lipopolysaccharide heptosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(21649, NULL, 'G3DSA:3.10.20.10:FF:000010', NULL, NULL, '60S ribosomal protein L18a', NULL, NULL, NULL, NULL, NULL, 4),
(21650, NULL, 'G3DSA:3.30.200.20:FF:000268', NULL, NULL, 'probable receptor-like serine/threonine-protein kinase At5g57670', NULL, NULL, NULL, NULL, NULL, 4),
(21651, NULL, 'G3DSA:3.10.20.30:FF:000016', NULL, NULL, 'Developmentally-regulated GTP-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(21652, NULL, 'G3DSA:1.25.40.990:FF:000002', NULL, NULL, 'Leukocyte receptor cluster member 8 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(21653, NULL, 'G3DSA:2.60.40.2070:FF:000010', NULL, NULL, 'Heat shock protein E', NULL, NULL, NULL, NULL, NULL, 4),
(21654, NULL, 'G3DSA:3.30.160.60:FF:002451', NULL, NULL, 'Zinc finger and SCAN domain containing 26', NULL, NULL, NULL, NULL, NULL, 4),
(21655, NULL, 'G3DSA:3.90.70.10:FF:000723', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21656, NULL, 'G3DSA:1.20.58.860:FF:000017', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase isozyme L5', NULL, NULL, NULL, NULL, NULL, 4),
(21657, NULL, 'G3DSA:1.25.40.10:FF:005199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21658, NULL, 'G3DSA:2.40.50.140:FF:000058', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(21659, NULL, 'G3DSA:3.30.2350.20:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21660, NULL, 'G3DSA:3.30.830.10:FF:000296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21661, NULL, 'G3DSA:2.30.130.110:FF:000004', NULL, NULL, 'Altronate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(21662, NULL, 'G3DSA:1.10.510.10:FF:004370', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21663, NULL, 'G3DSA:3.30.70.3290:FF:000011', NULL, NULL, '6-deoxyerythronolide-B synthase EryA2, modules 3 and 4', NULL, NULL, NULL, NULL, NULL, 4),
(21664, NULL, 'G3DSA:3.90.290.10:FF:000026', NULL, NULL, 'Fibrillin-1', NULL, NULL, NULL, NULL, NULL, 4),
(21665, NULL, 'G3DSA:3.10.330.20:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(21666, NULL, 'G3DSA:1.20.1070.10:FF:001561', NULL, NULL, 'Odorant receptor, family C, subfamily 104, member 2', NULL, NULL, NULL, NULL, NULL, 4),
(21667, NULL, 'G3DSA:3.90.1440.10:FF:000004', NULL, NULL, 'Protein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(21668, NULL, 'G3DSA:3.40.50.720:FF:001217', NULL, NULL, 'Probable NADH2 dehydrogenase (Ubiquinone) 40K chain', NULL, NULL, NULL, NULL, NULL, 4),
(21669, NULL, 'G3DSA:2.40.10.10:FF:000651', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21670, NULL, 'G3DSA:3.100.10.10:FF:000009', NULL, NULL, '50S ribosomal protein L15, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(21671, NULL, 'G3DSA:3.40.50.720:FF:001447', NULL, NULL, 'Methylenetetrahydrofolate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(21672, NULL, 'G3DSA:3.20.20.140:FF:000221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21673, NULL, 'G3DSA:3.50.80.10:FF:000006', NULL, NULL, 'D-aminoacyl-tRNA deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(21674, NULL, 'G3DSA:3.10.350.10:FF:000033', NULL, NULL, 'Putative membrane bound murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(21675, NULL, 'G3DSA:3.30.160.60:FF:004379', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21676, NULL, 'G3DSA:2.30.30.490:FF:000060', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(21677, NULL, 'G3DSA:3.20.140.10:FF:000037', NULL, NULL, 'NAPRTase', NULL, NULL, NULL, NULL, NULL, 4),
(21678, NULL, 'G3DSA:2.60.40.10:FF:000085', NULL, NULL, 'Myosin-binding protein C, slow type', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(21679, NULL, 'G3DSA:3.40.920.10:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21680, NULL, 'G3DSA:1.25.40.10:FF:000769', NULL, NULL, 'Pre-mRNA-processing factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(21681, NULL, 'G3DSA:2.40.50.140:FF:000142', NULL, NULL, 'sn-glycerol-3-phosphate import ATP-binding protein UgpC', NULL, NULL, NULL, NULL, NULL, 4),
(21682, NULL, 'G3DSA:2.120.10.80:FF:000134', NULL, NULL, 'Kelch domain-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(21683, NULL, 'G3DSA:3.40.50.150:FF:001018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21684, NULL, 'G3DSA:1.20.930.60:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21685, NULL, 'G3DSA:3.30.70.20:FF:000010', NULL, NULL, 'Respiratory nitrate reductase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(21686, NULL, 'G3DSA:3.30.70.330:FF:002433', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21687, NULL, 'G3DSA:1.10.455.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21688, NULL, 'G3DSA:2.130.10.10:FF:000742', NULL, NULL, 'WD repeat domain 90', NULL, NULL, NULL, NULL, NULL, 4),
(21689, NULL, 'G3DSA:1.10.510.10:FF:001722', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase B120', NULL, NULL, NULL, NULL, NULL, 4),
(21690, NULL, 'G3DSA:2.60.40.10:FF:003423', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21691, NULL, 'G3DSA:1.10.8.60:FF:000545', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(21692, NULL, 'G3DSA:2.10.25.10:FF:000046', NULL, NULL, 'Latent-transforming growth factor beta-binding protein 1 isoform x2', NULL, NULL, NULL, NULL, NULL, 4),
(21693, NULL, 'G3DSA:3.40.190.10:FF:000238', NULL, NULL, 'ABC transporter, periplasmic substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(21694, NULL, 'G3DSA:3.40.50.2000:FF:000482', NULL, NULL, 'Glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(21695, NULL, 'G3DSA:3.40.50.11350:FF:000003', NULL, NULL, 'GDP-fucose protein O-fucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(21696, NULL, 'G3DSA:3.30.40.10:FF:001253', NULL, NULL, 'RING/U-box superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(21697, NULL, 'G3DSA:2.60.40.150:FF:000684', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(21698, NULL, 'G3DSA:3.40.50.300:FF:000698', NULL, NULL, 'Leucine-rich repeat serine/threonine-protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(21699, NULL, 'G3DSA:3.60.10.10:FF:000210', NULL, NULL, 'DNA-(apurinic or apyrimidinic site) lyase', NULL, NULL, NULL, NULL, NULL, 4),
(21700, NULL, 'G3DSA:3.40.50.2300:FF:001549', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21701, NULL, 'G3DSA:3.40.640.10:FF:000537', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21702, NULL, 'G3DSA:3.40.50.20:FF:000036', NULL, NULL, 'Aspartate carbamoyltransferase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(21703, NULL, 'G3DSA:3.10.28.10:FF:000022', NULL, NULL, 'Intron-encoded DNA endonuclease I-AniI', NULL, NULL, NULL, NULL, NULL, 4),
(21704, NULL, 'G3DSA:2.60.40.10:FF:004704', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21705, NULL, 'G3DSA:1.25.40.10:FF:002326', NULL, NULL, 'Tetratricopeptide repeat domain 8', NULL, NULL, NULL, NULL, NULL, 4),
(21706, NULL, 'G3DSA:3.10.310.10:FF:000019', NULL, NULL, 'Proline racemase', NULL, NULL, NULL, NULL, NULL, 4),
(21707, NULL, 'G3DSA:2.130.10.10:FF:004924', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21708, NULL, 'G3DSA:2.40.160.50:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21709, NULL, 'G3DSA:3.80.10.10:FF:000372', NULL, NULL, 'X-ray radiation resistance associated 1', NULL, NULL, NULL, NULL, NULL, 4),
(21710, NULL, 'G3DSA:4.10.950.10:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21711, NULL, 'G3DSA:1.10.472.10:FF:000110', NULL, NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(21712, NULL, 'G3DSA:3.30.160.60:FF:000197', NULL, NULL, 'Zinc finger protein 606', NULL, NULL, NULL, NULL, NULL, 4),
(21713, NULL, 'G3DSA:2.40.160.210:FF:000015', NULL, NULL, 'Protein CBG22797', NULL, NULL, NULL, NULL, NULL, 4),
(21714, NULL, 'G3DSA:3.40.50.720:FF:001886', NULL, NULL, 'Ketol-acid reductoisomerase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(21715, NULL, 'G3DSA:3.30.470.30:FF:000060', NULL, NULL, 'mRNA-capping enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(21716, NULL, 'G3DSA:1.25.40.10:FF:000539', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21717, NULL, 'G3DSA:3.40.1650.10:FF:000003', NULL, NULL, 'D-ribose pyranase', NULL, NULL, NULL, NULL, NULL, 4),
(21718, NULL, 'G3DSA:3.40.30.10:FF:000616', NULL, NULL, 'Protein disulfide isomerase-like 1-2', NULL, NULL, NULL, NULL, NULL, 4),
(21719, NULL, 'G3DSA:3.30.160.60:FF:003732', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21720, NULL, 'G3DSA:1.20.144.10:FF:000003', NULL, NULL, 'Dolichyldiphosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(21721, NULL, 'G3DSA:3.40.140.10:FF:000286', NULL, NULL, 'Cytidine deaminase 3', NULL, NULL, NULL, NULL, NULL, 4),
(21722, NULL, 'G3DSA:3.40.50.300:FF:007055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21723, NULL, 'G3DSA:1.10.150.20:FF:000118', NULL, NULL, 'flap endonuclease GEN-like 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(21724, NULL, 'G3DSA:3.40.50.1000:FF:000069', NULL, NULL, 'HAD-superfamily subfamily IIA hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(21725, NULL, 'G3DSA:3.30.1370.50:FF:000035', NULL, NULL, 'RNA-binding post-transcriptional regulator cip2', NULL, NULL, NULL, NULL, NULL, 4),
(21726, NULL, 'G3DSA:1.20.120.20:FF:000013', NULL, NULL, 'Zeo1p', NULL, NULL, NULL, NULL, NULL, 4),
(21727, NULL, 'G3DSA:3.20.20.70:FF:000814', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21728, NULL, 'G3DSA:1.25.10.10:FF:000700', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(21729, NULL, 'G3DSA:3.40.50.720:FF:002162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21730, NULL, 'G3DSA:1.10.4160.10:FF:000008', NULL, NULL, 'Allantoin permease', NULL, NULL, NULL, NULL, NULL, 4),
(21731, NULL, 'G3DSA:2.150.10.10:FF:000011', NULL, NULL, 'Os03g0788300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(21732, NULL, 'G3DSA:3.40.50.1010:FF:000168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21733, NULL, 'G3DSA:1.25.40.90:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21734, NULL, 'G3DSA:2.60.120.260:FF:000124', NULL, NULL, 'Anaphase promoting complex subunit 10 (APC10)', NULL, NULL, NULL, NULL, NULL, 4),
(21735, NULL, 'G3DSA:3.30.70.330:FF:000179', NULL, NULL, 'APOBEC1 complementation factor isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(21736, NULL, 'G3DSA:3.40.50.720:FF:002066', NULL, NULL, 'Os05g0203400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(21737, NULL, 'G3DSA:3.30.190.20:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21738, NULL, 'G3DSA:3.90.70.10:FF:000639', NULL, NULL, 'Deubiquitylating with USP/UBP and OTU domains', NULL, NULL, NULL, NULL, NULL, 4),
(21739, NULL, 'G3DSA:1.10.10.60:FF:000731', NULL, NULL, 'Nkx1-1', NULL, NULL, NULL, NULL, NULL, 4),
(21740, NULL, 'G3DSA:2.40.37.10:FF:000022', NULL, NULL, 'Alanine racemase', NULL, NULL, NULL, NULL, NULL, 4),
(21741, NULL, 'G3DSA:3.40.50.300:FF:006779', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21742, NULL, 'G3DSA:3.40.1110.10:FF:000098', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(21743, NULL, 'G3DSA:3.40.50.300:FF:003210', NULL, NULL, 'RNA helicase aquarius', NULL, NULL, NULL, NULL, NULL, 4),
(21744, NULL, 'G3DSA:3.30.40.10:FF:002107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21745, NULL, 'G3DSA:3.40.50.410:FF:000051', NULL, NULL, 'Collagen type XXVIII alpha 1 chain', NULL, NULL, NULL, NULL, NULL, 4),
(21746, NULL, 'G3DSA:3.60.20.40:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(21747, NULL, 'G3DSA:1.20.920.30:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21748, NULL, 'G3DSA:2.60.120.920:FF:000154', NULL, NULL, 'Si:dkey-156k2.4', NULL, NULL, NULL, NULL, NULL, 4),
(21749, NULL, 'G3DSA:3.40.50.970:FF:000207', NULL, NULL, 'Pyruvate ferredoxin oxidoreductase B', NULL, NULL, NULL, NULL, NULL, 4),
(21750, NULL, 'G3DSA:3.80.10.10:FF:003126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21751, NULL, 'G3DSA:3.40.1690.20:FF:000020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(21752, NULL, 'G3DSA:1.10.10.10:FF:000632', NULL, NULL, 'Vacuolar-sorting protein SNF8', NULL, NULL, NULL, NULL, NULL, 4),
(21753, NULL, 'G3DSA:3.30.160.60:FF:006166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21754, NULL, 'G3DSA:1.25.40.10:FF:001388', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(21755, NULL, 'G3DSA:2.60.120.200:FF:000264', NULL, NULL, 'Laminin-like protein epi-1', NULL, NULL, NULL, NULL, NULL, 4),
(21756, NULL, 'G3DSA:1.25.40.20:FF:000429', NULL, NULL, 'Oxysterol-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(21757, NULL, 'G3DSA:1.25.10.10:FF:003117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21758, NULL, 'G3DSA:1.10.555.10:FF:000185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21759, NULL, 'G3DSA:3.40.50.1000:FF:000620', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21760, NULL, 'G3DSA:1.10.472.170:FF:000003', NULL, NULL, 'Transcription initiation factor IIB', NULL, NULL, NULL, NULL, NULL, 4),
(21761, NULL, 'G3DSA:2.60.40.1120:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21762, NULL, 'G3DSA:1.10.510.10:FF:002684', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21763, NULL, 'G3DSA:3.80.10.10:FF:003918', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21764, NULL, 'G3DSA:1.10.10.10:FF:002094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21765, NULL, 'G3DSA:2.40.50.140:FF:000721', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21766, NULL, 'G3DSA:3.40.50.300:FF:007398', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21767, NULL, 'G3DSA:1.10.238.10:FF:000392', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21768, NULL, 'G3DSA:3.40.50.2300:FF:001651', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21769, NULL, 'G3DSA:3.40.30.10:FF:001235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21770, NULL, 'G3DSA:1.50.10.150:FF:000009', NULL, NULL, 'C4-dicarboxylate ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(21771, NULL, 'G3DSA:3.40.50.1240:FF:000220', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21772, NULL, 'G3DSA:2.30.42.10:FF:000051', NULL, NULL, 'Multiple PDZ domain protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(21773, NULL, 'G3DSA:1.25.40.10:FF:003866', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21774, NULL, 'G3DSA:1.20.1250.10:FF:000035', NULL, NULL, 'Interleukin-27 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(21775, NULL, 'G3DSA:1.10.390.20:FF:000001', NULL, NULL, 'Microbial collagenase', NULL, NULL, NULL, NULL, NULL, 4),
(21776, NULL, 'G3DSA:1.10.510.10:FF:003190', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21777, NULL, 'G3DSA:3.90.226.10:FF:000142', NULL, NULL, 'Carbamoyl-phosphate synthase L chain, ATP-binding', NULL, NULL, NULL, NULL, NULL, 4),
(21778, NULL, 'G3DSA:3.30.160.60:FF:005317', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21779, NULL, 'G3DSA:3.30.1010.10:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21780, NULL, 'G3DSA:3.10.150.10:FF:000017', NULL, NULL, 'DNA polymerase III subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(21781, NULL, 'G3DSA:1.10.540.10:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21782, NULL, 'G3DSA:1.50.10.20:FF:000061', NULL, NULL, 'Transcobalamin II', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(21783, NULL, 'G3DSA:3.10.330.40:FF:000001', NULL, NULL, '2-dehydro-3-deoxy-D-arabinonate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(21784, NULL, 'G3DSA:3.20.180.20:FF:000037', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(21785, NULL, 'G3DSA:3.40.30.10:FF:000487', NULL, NULL, 'NADH-ubiquinone oxidoreductase subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(21786, NULL, 'G3DSA:3.40.50.1000:FF:000648', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21787, NULL, 'G3DSA:2.40.320.10:FF:000011', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 18', NULL, NULL, NULL, NULL, NULL, 4),
(21788, NULL, 'G3DSA:1.50.10.130:FF:000003', NULL, NULL, 'Ent-cassa-12,15-diene synthase', NULL, NULL, NULL, NULL, NULL, 4),
(21789, NULL, 'G3DSA:3.40.50.1380:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21790, NULL, 'G3DSA:2.30.30.490:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21791, NULL, 'G3DSA:3.40.50.300:FF:005138', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(21792, NULL, 'G3DSA:1.20.910.10:FF:000025', NULL, NULL, 'Aminopyrimidine aminohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(21793, NULL, 'G3DSA:3.40.50.300:FF:001215', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(21794, NULL, 'G3DSA:3.30.1370.120:FF:000002', NULL, NULL, 'General secretion pathway protein D', NULL, NULL, NULL, NULL, NULL, 4),
(21795, NULL, 'G3DSA:1.10.10.10:FF:001700', NULL, NULL, 'Helix-turn-helix transcriptional regulator with aminotransferase domain, GntR family', NULL, NULL, NULL, NULL, NULL, 4),
(21796, NULL, 'G3DSA:1.20.1560.10:FF:000025', NULL, NULL, 'ABC transporter B family member 9', NULL, NULL, NULL, NULL, NULL, 4),
(21797, NULL, 'G3DSA:3.80.10.10:FF:002300', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(21798, NULL, 'G3DSA:3.40.50.1360:FF:000031', NULL, NULL, '6-phosphogluconolactonase', NULL, NULL, NULL, NULL, NULL, 4),
(21799, NULL, 'G3DSA:1.20.1560.10:FF:000688', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(21800, NULL, 'G3DSA:2.30.29.30:FF:000436', NULL, NULL, 'CLNS1A isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(21801, NULL, 'G3DSA:2.60.40.10:FF:000989', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', NULL, NULL, NULL, NULL, NULL, 4),
(21802, NULL, 'G3DSA:3.40.50.2300:FF:000240', NULL, NULL, 'Ethylene receptor', NULL, NULL, NULL, NULL, NULL, 4),
(21803, NULL, 'G3DSA:1.10.238.10:FF:001140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21804, NULL, 'G3DSA:3.40.50.2300:FF:000370', NULL, NULL, 'L-arabinose-binding periplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(21805, NULL, 'G3DSA:2.20.28.30:FF:000002', NULL, NULL, 'DNA-directed RNA polymerases II, IV and V subunit 12', NULL, NULL, NULL, NULL, NULL, 4),
(21806, NULL, 'G3DSA:3.40.50.1100:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21807, NULL, 'G3DSA:1.10.506.10:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21808, NULL, 'G3DSA:3.90.70.10:FF:000740', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21809, NULL, 'G3DSA:3.40.525.10:FF:000028', NULL, NULL, 'GH16843p', NULL, NULL, NULL, NULL, NULL, 4),
(21810, NULL, 'G3DSA:3.60.40.10:FF:000251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21811, NULL, 'G3DSA:1.20.1510.10:FF:000073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21812, NULL, 'G3DSA:3.30.390.50:FF:000014', NULL, NULL, 'Nicotinate dehydrogenase FAD-subunit', NULL, NULL, NULL, NULL, NULL, 4),
(21813, NULL, 'G3DSA:1.10.10.750:FF:000041', NULL, NULL, 'AaceriADR213Cp', NULL, NULL, NULL, NULL, NULL, 4),
(21814, NULL, 'G3DSA:3.90.1750.10:FF:000095', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(21815, NULL, 'G3DSA:3.30.420.10:FF:000242', NULL, NULL, 'Ribonuclease HII', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(21816, NULL, 'G3DSA:2.10.109.10:FF:000055', NULL, NULL, 'Mitochondrial inner membrane protease subunit', NULL, NULL, NULL, NULL, NULL, 4),
(21817, NULL, 'G3DSA:3.30.450.20:FF:000640', NULL, NULL, 'Glr3986 protein', NULL, NULL, NULL, NULL, NULL, 4),
(21818, NULL, 'G3DSA:2.30.29.30:FF:000223', NULL, NULL, 'Pleckstrin', NULL, NULL, NULL, NULL, NULL, 4),
(21819, NULL, 'G3DSA:3.90.79.10:FF:000260', NULL, NULL, 'Pre-mRNA cleavage factor I 25 kDa subunit putative', NULL, NULL, NULL, NULL, NULL, 4),
(21820, NULL, 'G3DSA:3.40.710.10:FF:000195', NULL, NULL, 'Penicillin-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(21821, NULL, 'G3DSA:1.10.287.3550:FF:000006', NULL, NULL, 'Stromal interaction molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(21822, NULL, 'G3DSA:3.40.630.30:FF:000121', NULL, NULL, 'Acetyltransferase, GNAT family', NULL, NULL, NULL, NULL, NULL, 4),
(21823, NULL, 'G3DSA:1.25.40.70:FF:000079', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(21824, NULL, 'G3DSA:2.30.30.550:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21825, NULL, 'G3DSA:1.10.510.10:FF:002341', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(21826, NULL, 'G3DSA:1.20.930.40:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21827, NULL, 'G3DSA:2.60.40.10:FF:005323', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21828, NULL, 'G3DSA:2.130.10.10:FF:000872', NULL, NULL, 'WD repeat domain 37', NULL, NULL, NULL, NULL, NULL, 4),
(21829, NULL, 'G3DSA:3.40.50.300:FF:007959', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21830, NULL, 'G3DSA:3.40.50.300:FF:006083', NULL, NULL, 'Small GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(21831, NULL, 'G3DSA:2.60.120.10:FF:000492', NULL, NULL, 'Homogentisate 1,2-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(21832, NULL, 'G3DSA:2.130.10.10:FF:001361', NULL, NULL, 'WD repeat domain 55', NULL, NULL, NULL, NULL, NULL, 4),
(21833, NULL, 'G3DSA:1.10.1370.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21834, NULL, 'G3DSA:3.40.630.10:FF:000143', NULL, NULL, 'Zinc carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(21835, NULL, 'G3DSA:3.40.47.10:FF:000008', NULL, NULL, '3-hydroxy-3-methylglutaryl coenzyme A synthase', NULL, NULL, NULL, NULL, NULL, 4),
(21836, NULL, 'G3DSA:2.120.10.30:FF:000029', NULL, NULL, 'LDL receptor related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(21837, NULL, 'G3DSA:3.80.10.10:FF:001552', NULL, NULL, 'Calpain-like cysteine peptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(21838, NULL, 'G3DSA:1.10.560.10:FF:000039', NULL, NULL, 'Chaperonin containing TCP1 subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(21839, NULL, 'G3DSA:1.10.287.660:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21840, NULL, 'G3DSA:3.30.40.10:FF:000281', NULL, NULL, 'E3 ubiquitin-protein ligase SIS3', NULL, NULL, NULL, NULL, NULL, 4),
(21841, NULL, 'G3DSA:1.10.287.70:FF:000798', NULL, NULL, 'Small conductance calcium-activated potassium channel protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(21842, NULL, 'G3DSA:3.30.160.20:FF:000213', NULL, NULL, 'Double-stranded RNA-specific editase Adar-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(21843, NULL, 'G3DSA:2.60.40.640:FF:000055', NULL, NULL, 'Vacuolar sorting protein 26, putative', NULL, NULL, NULL, NULL, NULL, 4),
(21844, NULL, 'G3DSA:2.20.100.10:FF:000027', NULL, NULL, 'Thrombospondin type 1 domain containing 7A', NULL, NULL, NULL, NULL, NULL, 4),
(21845, NULL, 'G3DSA:2.120.10.30:FF:000389', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(21846, NULL, 'G3DSA:3.40.640.10:FF:000200', NULL, NULL, 'Threonine aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(21847, NULL, 'G3DSA:1.10.630.10:FF:000360', NULL, NULL, 'Cytochrome P450, putative (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(21848, NULL, 'G3DSA:3.10.450.700:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(21849, NULL, 'G3DSA:2.40.10.10:FF:000090', NULL, NULL, 'serine protease hepsin', NULL, NULL, NULL, NULL, NULL, 4),
(21850, NULL, 'G3DSA:3.40.50.300:FF:004981', NULL, NULL, 'Guanylate-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(21851, NULL, 'G3DSA:3.30.160.60:FF:000989', NULL, NULL, 'Spalt like transcription factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(21852, NULL, 'G3DSA:3.40.50.11370:FF:000009', NULL, NULL, 'Inositol-tetrakisphosphate 1-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(21853, NULL, 'G3DSA:2.40.30.10:FF:000534', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21854, NULL, 'G3DSA:3.30.40.10:FF:001691', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(21855, NULL, 'G3DSA:3.30.760.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21856, NULL, 'G3DSA:3.40.140.10:FF:000156', NULL, NULL, 'Deoxycytidylate deaminase-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(21857, NULL, 'G3DSA:3.10.20.90:FF:000118', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(21858, NULL, 'G3DSA:1.25.40.180:FF:000102', NULL, NULL, 'GM11217', NULL, NULL, NULL, NULL, NULL, 4),
(21859, NULL, 'G3DSA:2.60.120.590:FF:000010', NULL, NULL, 'GRF zinc finger domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(21860, NULL, 'G3DSA:2.60.40.10:FF:000652', NULL, NULL, 'obscurin isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(21861, NULL, 'G3DSA:1.10.287.4270:FF:000003', NULL, NULL, 'Serine/threonine-protein kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(21862, NULL, 'G3DSA:1.10.418.10:FF:000277', NULL, NULL, 'Plastin 1', NULL, NULL, NULL, NULL, NULL, 4),
(21863, NULL, 'G3DSA:1.25.40.10:FF:001045', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(21864, NULL, 'G3DSA:3.40.630.30:FF:000149', NULL, NULL, 'Aminoglycoside 2''-N-acetyltransferase AAC (AAC(2'')-IC)', NULL, NULL, NULL, NULL, NULL, 4),
(21865, NULL, 'G3DSA:1.10.287.110:FF:000097', NULL, NULL, 'Chaperone protein dnaJ 16', NULL, NULL, NULL, NULL, NULL, 4),
(21866, NULL, 'G3DSA:2.30.42.10:FF:000079', NULL, NULL, 'Whirlin a', NULL, NULL, NULL, NULL, NULL, 4),
(21867, NULL, 'G3DSA:2.90.10.10:FF:000020', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(21868, NULL, 'G3DSA:3.30.1330.50:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21869, NULL, 'G3DSA:2.60.200.20:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21870, NULL, 'G3DSA:3.20.20.100:FF:000136', NULL, NULL, 'dTDP-4-keto-L-6-deoxy-hexose 2,3-reductase-putative a NADP-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(21871, NULL, 'G3DSA:2.170.270.10:FF:000021', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(21872, NULL, 'G3DSA:1.20.58.2140:FF:000006', NULL, NULL, 'Putative RNA-binding protein of the translin family', NULL, NULL, NULL, NULL, NULL, 4),
(21873, NULL, 'G3DSA:3.40.50.300:FF:000147', NULL, NULL, 'EH domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(21874, NULL, 'G3DSA:2.10.25.10:FF:001552', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(21875, NULL, 'G3DSA:2.60.40.10:FF:003974', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21876, NULL, 'G3DSA:3.30.420.40:FF:000138', NULL, NULL, 'Exopolyphosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(21877, NULL, 'G3DSA:3.40.50.150:FF:000276', NULL, NULL, 'Methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(21878, NULL, 'G3DSA:3.30.70.330:FF:001685', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21879, NULL, 'G3DSA:3.40.532.10:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21880, NULL, 'G3DSA:3.30.730.10:FF:000001', NULL, NULL, 'Ethylene-responsive transcription factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(21881, NULL, 'G3DSA:1.50.40.10:FF:000464', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21882, NULL, 'G3DSA:1.20.120.1760:FF:000035', NULL, NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(21883, NULL, 'G3DSA:2.60.40.790:FF:000089', NULL, NULL, 'Co-chaperone p23', NULL, NULL, NULL, NULL, NULL, 4),
(21884, NULL, 'G3DSA:2.70.150.10:FF:000295', NULL, NULL, 'ATPase phospholipid transporting 8B3', NULL, NULL, NULL, NULL, NULL, 4),
(21885, NULL, 'G3DSA:3.90.640.10:FF:000054', NULL, NULL, 'Actin-like ATPase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(21886, NULL, 'G3DSA:3.40.50.300:FF:003340', NULL, NULL, 'Cell division control protein 42, putative', NULL, NULL, NULL, NULL, NULL, 4),
(21887, NULL, 'G3DSA:1.20.58.1030:FF:000022', NULL, NULL, 'AGAP010835-PA', NULL, NULL, NULL, NULL, NULL, 4),
(21888, NULL, 'G3DSA:1.25.10.70:FF:000010', NULL, NULL, 'Chromosome 21, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(21889, NULL, 'G3DSA:2.30.30.40:FF:000510', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(21890, NULL, 'G3DSA:1.10.3210.10:FF:000007', NULL, NULL, 'GTP pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(21891, NULL, 'G3DSA:3.30.70.2170:FF:000001', NULL, NULL, 'V-type ATP synthase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(21892, NULL, 'G3DSA:1.10.10.60:FF:000962', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21893, NULL, 'G3DSA:3.60.10.10:FF:000322', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21894, NULL, 'G3DSA:3.60.10.10:FF:000423', NULL, NULL, 'Endonuclease/exonuclease/phosphatase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(21895, NULL, 'G3DSA:3.40.50.1220:FF:000130', NULL, NULL, 'NAD-dependent deacetylase sir2B', NULL, NULL, NULL, NULL, NULL, 4),
(21896, NULL, 'G3DSA:3.40.50.1820:FF:000669', NULL, NULL, 'GLIoTactin (Drosophila neuroligin-like) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(21897, NULL, 'G3DSA:1.20.1050.10:FF:000054', NULL, NULL, 'Methionine-tRNA ligase, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(21898, NULL, 'G3DSA:2.60.40.10:FF:004480', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21899, NULL, 'G3DSA:2.70.40.10:FF:000011', NULL, NULL, 'dUTPase', NULL, NULL, NULL, NULL, NULL, 4),
(21900, NULL, 'G3DSA:3.20.20.190:FF:000112', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21901, NULL, 'G3DSA:3.30.310.80:FF:000024', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(21902, NULL, 'G3DSA:1.25.40.10:FF:003411', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(21903, NULL, 'G3DSA:1.25.10.10:FF:003230', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(21904, NULL, 'G3DSA:1.10.510.10:FF:000216', NULL, NULL, 'Tyrosine-protein kinase SYK', NULL, NULL, NULL, NULL, NULL, 4),
(21905, NULL, 'G3DSA:3.30.450.30:FF:000076', NULL, NULL, 'Profilin', NULL, NULL, NULL, NULL, NULL, 4),
(21906, NULL, 'G3DSA:3.30.870.10:FF:000062', NULL, NULL, 'Tyrosyl-DNA phosphodiesterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(21907, NULL, 'G3DSA:2.60.120.290:FF:000116', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(21908, NULL, 'G3DSA:2.60.120.580:FF:000001', NULL, NULL, 'Formamidase FmdS', NULL, NULL, NULL, NULL, NULL, 4),
(21909, NULL, 'G3DSA:3.60.110.10:FF:000009', NULL, NULL, 'Beta-ureidopropionase 1', NULL, NULL, NULL, NULL, NULL, 4),
(21910, NULL, 'G3DSA:3.30.70.2190:FF:000007', NULL, NULL, 'FAD-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(21911, NULL, 'G3DSA:3.30.200.20:FF:000509', NULL, NULL, 'Tyrosine-protein kinase receptor UFO', NULL, NULL, NULL, NULL, NULL, 4),
(21912, NULL, 'G3DSA:2.130.10.10:FF:005655', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21913, NULL, 'G3DSA:3.90.70.80:FF:000036', NULL, NULL, 'Zn-finger in Ran binding protein and others/OTU-like cysteine protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(21914, NULL, 'G3DSA:3.40.390.10:FF:000219', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21915, NULL, 'G3DSA:2.130.10.10:FF:004019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(21916, NULL, 'G3DSA:1.20.5.460:FF:000004', NULL, NULL, 'Death-associated protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(21917, NULL, 'G3DSA:2.120.10.30:FF:000491', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(21918, NULL, 'G3DSA:3.30.160.60:FF:001849', NULL, NULL, 'Zinc finger CCCH domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(21919, NULL, 'G3DSA:2.60.40.820:FF:000002', NULL, NULL, 'T-box transcription factor Brachyury', NULL, NULL, NULL, NULL, NULL, 4),
(21920, NULL, 'G3DSA:1.20.1420.30:FF:000072', NULL, NULL, 'Na+/Ca+ antiporter, CaCA family', NULL, NULL, NULL, NULL, NULL, 4),
(21921, NULL, 'G3DSA:1.25.10.10:FF:002280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21922, NULL, 'G3DSA:3.40.50.11320:FF:000011', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(21923, NULL, 'G3DSA:3.30.160.60:FF:004704', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21924, NULL, 'G3DSA:1.20.1070.10:FF:001578', NULL, NULL, 'AGAP012698-PA', NULL, NULL, NULL, NULL, NULL, 4),
(21925, NULL, 'G3DSA:3.30.420.40:FF:000239', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(21926, NULL, 'G3DSA:2.40.320.10:FF:000028', NULL, NULL, 'CYTH domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(21927, NULL, 'G3DSA:2.10.70.10:FF:000139', NULL, NULL, 'Blast:Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(21928, NULL, 'G3DSA:1.25.10.10:FF:000728', NULL, NULL, 'Blast:Integrator complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(21929, NULL, 'G3DSA:3.30.870.10:FF:000163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21930, NULL, 'G3DSA:3.20.20.80:FF:000351', NULL, NULL, 'Glycosyl hydrolase family protein with chitinase insertion domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(21931, NULL, 'G3DSA:3.40.50.11340:FF:000017', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(21932, NULL, 'G3DSA:3.30.200.20:FF:002393', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21933, NULL, 'G3DSA:3.40.720.10:FF:000122', NULL, NULL, 'Sulfatase 2a', NULL, NULL, NULL, NULL, NULL, 4),
(21934, NULL, 'G3DSA:3.40.190.10:FF:000446', NULL, NULL, 'Molybdenum ABC transporter, periplasmic molybdenum-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(21935, NULL, 'G3DSA:3.30.260.10:FF:000050', NULL, NULL, 'Mitochondrial chaperone TCM62', NULL, NULL, NULL, NULL, NULL, 4),
(21936, NULL, 'G3DSA:2.60.40.10:FF:005211', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21937, NULL, 'G3DSA:3.30.40.10:FF:001814', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21938, NULL, 'G3DSA:1.10.472.80:FF:000187', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21939, NULL, 'G3DSA:2.130.10.10:FF:005756', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21940, NULL, 'G3DSA:2.60.40.10:FF:003070', NULL, NULL, 'Protein sax-3', NULL, NULL, NULL, NULL, NULL, 4),
(21941, NULL, 'G3DSA:3.40.50.300:FF:002721', NULL, NULL, 'Calcium Channel, Beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(21942, NULL, 'G3DSA:3.30.420.40:FF:000470', NULL, NULL, 'Heat shock protein 70 putative', NULL, NULL, NULL, NULL, NULL, 4),
(21943, NULL, 'G3DSA:1.20.1250.20:FF:000948', NULL, NULL, 'Sugar phosphate permease', NULL, NULL, NULL, NULL, NULL, 4),
(21944, NULL, 'G3DSA:2.30.130.40:FF:000036', NULL, NULL, 'Protein cereblon', NULL, NULL, NULL, NULL, NULL, 4),
(21945, NULL, 'G3DSA:3.40.50.1240:FF:000124', NULL, NULL, 'Phosphoglycerate mutase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(21946, NULL, 'G3DSA:2.120.10.30:FF:000159', NULL, NULL, 'Nhl repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(21947, NULL, 'G3DSA:3.30.413.10:FF:000001', NULL, NULL, '4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase (flavodoxin)', NULL, NULL, NULL, NULL, NULL, 4),
(21948, NULL, 'G3DSA:3.40.50.10810:FF:000089', NULL, NULL, 'DNA repair protein RAD5B', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(21949, NULL, 'G3DSA:1.20.1250.20:FF:001196', NULL, NULL, 'Signal transducer', NULL, NULL, NULL, NULL, NULL, 4),
(21950, NULL, 'G3DSA:1.25.40.280:FF:000014', NULL, NULL, 'Rim20p', NULL, NULL, NULL, NULL, NULL, 4),
(21951, NULL, 'G3DSA:3.30.160.60:FF:002563', NULL, NULL, 'Zinc finger protein 296', NULL, NULL, NULL, NULL, NULL, 4),
(21952, NULL, 'G3DSA:3.20.20.80:FF:000137', NULL, NULL, 'inactive heparanase-2 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(21953, NULL, 'G3DSA:3.30.450.40:FF:000067', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(21954, NULL, 'G3DSA:3.30.420.510:FF:000015', NULL, NULL, 'Pantothenate kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(21955, NULL, 'G3DSA:3.50.40.10:FF:000009', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(21956, NULL, 'G3DSA:3.40.50.2000:FF:000611', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(21957, NULL, 'G3DSA:3.30.420.10:FF:000034', NULL, NULL, '3''-5'' exoribonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(21958, NULL, 'G3DSA:2.60.40.840:FF:000008', NULL, NULL, 'Arrestin beta 2', NULL, NULL, NULL, NULL, NULL, 4),
(21959, NULL, 'G3DSA:3.40.50.2300:FF:001196', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21960, NULL, 'G3DSA:3.50.50.60:FF:000379', NULL, NULL, 'Mercuric reductase', NULL, NULL, NULL, NULL, NULL, 4),
(21961, NULL, 'G3DSA:1.10.3720.10:FF:000080', NULL, NULL, 'Amino acid ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(21962, NULL, 'G3DSA:2.60.40.150:FF:000116', NULL, NULL, 'Phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(21963, NULL, 'G3DSA:3.30.160.60:FF:000326', NULL, NULL, 'Zinc finger protein 521', NULL, NULL, NULL, NULL, NULL, 4),
(21964, NULL, 'G3DSA:2.130.10.10:FF:004132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21965, NULL, 'G3DSA:2.30.30.40:FF:000297', NULL, NULL, 'CheA signal transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(21966, NULL, 'G3DSA:3.30.1330.90:FF:000022', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(21967, NULL, 'G3DSA:2.30.42.10:FF:000630', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21968, NULL, 'G3DSA:1.25.40.10:FF:002905', NULL, NULL, 'Tetratricopeptide repeat domain 25', NULL, NULL, NULL, NULL, NULL, 4),
(21969, NULL, 'G3DSA:3.90.550.10:FF:000305', NULL, NULL, 'Putative glycosyltransferase WbgO', NULL, NULL, NULL, NULL, NULL, 4),
(21970, NULL, 'G3DSA:3.40.50.300:FF:004750', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21971, NULL, 'G3DSA:1.20.1640.10:FF:000059', NULL, NULL, 'PaTched Related family', NULL, NULL, NULL, NULL, NULL, 4),
(21972, NULL, 'G3DSA:2.60.120.1190:FF:000009', NULL, NULL, 'Tyrosine-protein kinase Abl-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(21973, NULL, 'G3DSA:1.20.58.60:FF:000324', NULL, NULL, 'SMAll', NULL, NULL, NULL, NULL, NULL, 4),
(21974, NULL, 'G3DSA:2.30.29.30:FF:000324', NULL, NULL, 'Phosphoinositide-dependent kinase 1, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(21975, NULL, 'G3DSA:1.20.1250.20:FF:001567', NULL, NULL, 'MFS transporter, putative (AFU_orthologue AFUA_5G00430)', NULL, NULL, NULL, NULL, NULL, 4),
(21976, NULL, 'G3DSA:3.40.630.10:FF:000374', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21977, NULL, 'G3DSA:3.60.21.10:FF:000342', NULL, NULL, 'Alkaline phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(21978, NULL, 'G3DSA:3.40.50.720:FF:001655', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(21979, NULL, 'G3DSA:2.130.10.10:FF:000080', NULL, NULL, 'WD repeat-containing protein 37', NULL, NULL, NULL, NULL, NULL, 4),
(21980, NULL, 'G3DSA:1.20.1310.10:FF:000080', NULL, NULL, 'Cullin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(21981, NULL, 'G3DSA:1.20.1070.10:FF:000381', NULL, NULL, 'DOPamine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(21982, NULL, 'G3DSA:2.40.160.50:FF:000010', NULL, NULL, 'Heme utilization protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(21983, NULL, 'G3DSA:2.40.100.10:FF:000028', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(21984, NULL, 'G3DSA:1.10.287.100:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21985, NULL, 'G3DSA:1.10.540.10:FF:000044', NULL, NULL, 'Acyl-CoA dehydrogenase NM domain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(21986, NULL, 'G3DSA:3.40.47.10:FF:000239', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21987, NULL, 'G3DSA:1.25.40.20:FF:000761', NULL, NULL, 'RFXANK isoform 10', NULL, NULL, NULL, NULL, NULL, 4),
(21988, NULL, 'G3DSA:3.30.70.330:FF:000275', NULL, NULL, 'oligouridylate-binding protein 1B-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(21989, NULL, 'G3DSA:3.80.10.10:FF:004306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21990, NULL, 'G3DSA:3.30.70.330:FF:002641', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(21991, NULL, 'G3DSA:3.40.30.10:FF:001105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21992, NULL, 'G3DSA:2.40.70.10:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21993, NULL, 'G3DSA:3.40.50.300:FF:000355', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein U-like 1, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(21994, NULL, 'G3DSA:1.25.40.10:FF:002894', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21995, NULL, 'G3DSA:1.10.8.270:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(21996, NULL, 'G3DSA:2.30.30.40:FF:000173', NULL, NULL, 'E3 ubiquitin-protein ligase SH3RF2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(21997, NULL, 'G3DSA:3.30.70.270:FF:000133', NULL, NULL, 'Diguanylate cyclase (GGDEF) domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(21998, NULL, 'G3DSA:3.30.497.10:FF:000003', NULL, NULL, 'Serpin family F member 1', NULL, NULL, NULL, NULL, NULL, 4),
(21999, NULL, 'G3DSA:3.90.190.10:FF:000305', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(22000, NULL, 'G3DSA:2.130.10.10:FF:004227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22001, NULL, 'G3DSA:3.30.70.330:FF:001005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22002, NULL, 'G3DSA:3.30.230.10:FF:000328', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22003, NULL, 'G3DSA:3.40.50.150:FF:001698', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22004, NULL, 'G3DSA:3.30.230.130:FF:000015', NULL, NULL, 'Cullin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(22005, NULL, 'G3DSA:3.20.180.20:FF:000020', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(22006, NULL, 'G3DSA:2.40.50.100:FF:000158', NULL, NULL, 'Ribosomal RNA processing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(22007, NULL, 'G3DSA:3.40.1110.10:FF:000204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22008, NULL, 'G3DSA:2.40.30.10:FF:000085', NULL, NULL, 'Elongation factor Tu', NULL, NULL, NULL, NULL, NULL, 4),
(22009, NULL, 'G3DSA:2.130.10.10:FF:000973', NULL, NULL, 'G-beta repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22010, NULL, 'G3DSA:3.20.20.80:FF:000031', NULL, NULL, 'Glycogen debranching enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(22011, NULL, 'G3DSA:3.40.50.150:FF:001001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22012, NULL, 'G3DSA:1.25.40.20:FF:000885', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22013, NULL, 'G3DSA:3.90.79.10:FF:000029', NULL, NULL, 'Mutator mutT protein', NULL, NULL, NULL, NULL, NULL, 4),
(22014, NULL, 'G3DSA:2.160.20.10:FF:000326', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22015, NULL, 'G3DSA:3.80.10.10:FF:001777', NULL, NULL, 'F-box/LRR-repeat protein 20-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(22016, NULL, 'G3DSA:2.40.50.90:FF:000065', NULL, NULL, 'tudor and KH domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(22017, NULL, 'G3DSA:2.30.29.30:FF:001055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22018, NULL, 'G3DSA:2.60.40.180:FF:000001', NULL, NULL, '5-hydroxyisourate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(22019, NULL, 'G3DSA:3.40.309.10:FF:000133', NULL, NULL, 'Aldehyde dehydrogenase3', NULL, NULL, NULL, NULL, NULL, 4),
(22020, NULL, 'G3DSA:3.70.10.10:FF:000018', NULL, NULL, 'Checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(22021, NULL, 'G3DSA:4.10.1030.10:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22022, NULL, 'G3DSA:3.30.70.1230:FF:000197', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(22023, NULL, 'G3DSA:3.40.50.720:FF:002274', NULL, NULL, 'D-2-hydroxy-acid dehydrogenase-like', NULL, NULL, NULL, NULL, NULL, 4),
(22024, NULL, 'G3DSA:1.10.560.10:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22025, NULL, 'G3DSA:3.30.429.10:FF:000003', NULL, NULL, 'D-dopachrome decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(22026, NULL, 'G3DSA:3.40.50.970:FF:000078', NULL, NULL, 'Sulfite reductase (NADPH) hemoprotein, beta-component', NULL, NULL, NULL, NULL, NULL, 4),
(22027, NULL, 'G3DSA:3.30.565.10:FF:000280', NULL, NULL, 'Phosphate regulon, two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(22028, NULL, 'G3DSA:2.60.40.10:FF:000208', NULL, NULL, 'Butyrophilin subfamily 1 member A1', NULL, NULL, NULL, NULL, NULL, 4),
(22029, NULL, 'G3DSA:3.10.20.310:FF:000027', NULL, NULL, 'Outer membrane protein assembly factor BamA', NULL, NULL, NULL, NULL, NULL, 4),
(22030, NULL, 'G3DSA:3.30.50.10:FF:000011', NULL, NULL, 'Thyroid hormone receptor beta isoform', NULL, NULL, NULL, NULL, NULL, 4),
(22031, NULL, 'G3DSA:1.25.40.10:FF:004131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22032, NULL, 'G3DSA:1.10.1660.10:FF:000018', NULL, NULL, 'Cu(I)-responsive transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(22033, NULL, 'G3DSA:2.130.10.10:FF:001810', NULL, NULL, 'Putative katanin', NULL, NULL, NULL, NULL, NULL, 4),
(22034, NULL, 'G3DSA:2.60.120.1000:FF:000009', NULL, NULL, 'Axotactin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(22035, NULL, 'G3DSA:2.10.110.10:FF:000249', NULL, NULL, 'LIM domain transcription factor LMO4-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(22036, NULL, 'G3DSA:2.60.120.260:FF:000012', NULL, NULL, 'F-box only protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(22037, NULL, 'G3DSA:2.40.70.10:FF:000559', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22038, NULL, 'G3DSA:3.40.50.300:FF:002384', NULL, NULL, 'Endonuclease MutS2', NULL, NULL, NULL, NULL, NULL, 4),
(22039, NULL, 'G3DSA:1.20.120.1900:FF:000004', NULL, NULL, 'gamma-tubulin complex component 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(22040, NULL, 'G3DSA:3.40.30.10:FF:000824', NULL, NULL, 'Glrx-3', NULL, NULL, NULL, NULL, NULL, 4),
(22041, NULL, 'G3DSA:1.20.1270.60:FF:000023', NULL, NULL, 'Interacting with PRKCA', NULL, NULL, NULL, NULL, NULL, 4),
(22042, NULL, 'G3DSA:3.40.50.300:FF:003002', NULL, NULL, 'Cytidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(22043, NULL, 'G3DSA:3.40.50.1820:FF:001383', NULL, NULL, 'NDRG family member 4', NULL, NULL, NULL, NULL, NULL, 4),
(22044, NULL, 'G3DSA:3.40.50.300:FF:002608', NULL, NULL, 'Small GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22045, NULL, 'G3DSA:3.30.160.780:FF:000002', NULL, NULL, 'Envoplakin b', NULL, NULL, NULL, NULL, NULL, 4),
(22046, NULL, 'G3DSA:3.80.10.10:FF:002272', NULL, NULL, 'Leucine-rich repeat-containing protein ODA7', NULL, NULL, NULL, NULL, NULL, 4),
(22047, NULL, 'G3DSA:1.10.357.10:FF:000039', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(22048, NULL, 'G3DSA:1.10.287.940:FF:000020', NULL, NULL, 'P2X purinoceptor', NULL, NULL, NULL, NULL, NULL, 4),
(22049, NULL, 'G3DSA:3.10.100.10:FF:000306', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22050, NULL, 'G3DSA:3.30.70.330:FF:000387', NULL, NULL, 'RNA binding motif protein 19', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(22051, NULL, 'G3DSA:3.30.1010.10:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22052, NULL, 'G3DSA:3.40.50.1240:FF:000012', NULL, NULL, 'Phosphoglycerate mutase 1', NULL, NULL, NULL, NULL, NULL, 4),
(22053, NULL, 'G3DSA:2.130.10.120:FF:000016', NULL, NULL, 'Dipeptidyl aminopeptidase BI', NULL, NULL, NULL, NULL, NULL, 4),
(22054, NULL, 'G3DSA:2.60.40.10:FF:000197', NULL, NULL, 'Myomesin 1', NULL, NULL, NULL, NULL, NULL, 4),
(22055, NULL, 'G3DSA:2.60.40.10:FF:003766', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22056, NULL, 'G3DSA:1.10.510.10:FF:003982', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22057, NULL, 'G3DSA:1.25.40.10:FF:001500', NULL, NULL, 'Pentatricopeptide repeat (PPR-like) superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(22058, NULL, 'G3DSA:1.25.40.10:FF:004934', NULL, NULL, 'RNA polymerase II transcription elongation factor (Ctr9), putative (AFU_orthologue AFUA_5G05870)', NULL, NULL, NULL, NULL, NULL, 4),
(22059, NULL, 'G3DSA:1.10.3180.10:FF:000004', NULL, NULL, 'Os07g0272500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(22060, NULL, 'G3DSA:1.10.940.10:FF:000018', NULL, NULL, 'Transcription antitermination protein NusB', NULL, NULL, NULL, NULL, NULL, 4),
(22061, NULL, 'G3DSA:1.10.8.60:FF:000539', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22062, NULL, 'G3DSA:1.10.101.10:FF:000030', NULL, NULL, 'Lytic murein transglycosylase B', NULL, NULL, NULL, NULL, NULL, 4),
(22063, NULL, 'G3DSA:1.20.80.10:FF:000052', NULL, NULL, 'Acyl-CoA-binding domain 3', NULL, NULL, NULL, NULL, NULL, 4),
(22064, NULL, 'G3DSA:1.10.10.10:FF:000520', NULL, NULL, 'RNA polymerase sigma factor sigA-like', NULL, NULL, NULL, NULL, NULL, 4),
(22065, NULL, 'G3DSA:1.20.930.80:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22066, NULL, 'G3DSA:3.30.2010.10:FF:000008', NULL, NULL, 'Protease HtpX homolog', NULL, NULL, NULL, NULL, NULL, 4),
(22067, NULL, 'G3DSA:3.90.1140.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22068, NULL, 'G3DSA:3.30.160.60:FF:003182', NULL, NULL, 'Zinc finger protein 682', NULL, NULL, NULL, NULL, NULL, 4),
(22069, NULL, 'G3DSA:3.30.160.60:FF:006374', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22070, NULL, 'G3DSA:1.25.10.10:FF:000357', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(22071, NULL, 'G3DSA:1.20.5.110:FF:000265', NULL, NULL, 'Culmination specific protein 37D', NULL, NULL, NULL, NULL, NULL, 4),
(22072, NULL, 'G3DSA:3.30.470.20:FF:000074', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(22073, NULL, 'G3DSA:1.20.1070.10:FF:000049', NULL, NULL, 'G-protein coupled receptor 87', NULL, NULL, NULL, NULL, NULL, 4),
(22074, NULL, 'G3DSA:1.10.510.10:FF:001964', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22075, NULL, 'G3DSA:3.90.76.10:FF:000006', NULL, NULL, 'Monoacyl phosphatidylinositol tetramannoside-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(22076, NULL, 'G3DSA:3.90.1150.10:FF:000145', NULL, NULL, 'Class V aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(22077, NULL, 'G3DSA:3.40.50.300:FF:006436', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(22078, NULL, 'G3DSA:2.60.120.260:FF:000467', NULL, NULL, 'EPH receptor B4', NULL, NULL, NULL, NULL, NULL, 4),
(22079, NULL, 'G3DSA:2.20.70.10:FF:000150', NULL, NULL, 'E3 ubiquitin-protein ligase hecw-1', NULL, NULL, NULL, NULL, NULL, 4),
(22080, NULL, 'G3DSA:1.25.40.10:FF:000185', NULL, NULL, 'NRDE-2, necessary for RNA interference, domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(22081, NULL, 'G3DSA:3.10.20.90:FF:000899', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22082, NULL, 'G3DSA:3.30.70.330:FF:001909', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22083, NULL, 'G3DSA:2.130.10.10:FF:004683', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22084, NULL, 'G3DSA:3.10.20.90:FF:000669', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(22085, NULL, 'G3DSA:3.90.180.10:FF:000136', NULL, NULL, 'Alcohol dehydrogenase, putative (AFU_orthologue AFUA_2G04590)', NULL, NULL, NULL, NULL, NULL, 4),
(22086, NULL, 'G3DSA:3.10.590.10:FF:000011', NULL, NULL, 'thymocyte nuclear protein 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(22087, NULL, 'G3DSA:1.10.275.40:FF:000020', NULL, NULL, 'Helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22088, NULL, 'G3DSA:3.40.50.300:FF:008336', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(22089, NULL, 'G3DSA:1.20.1250.20:FF:001775', NULL, NULL, 'Major facilitator superfamily transporter', NULL, NULL, NULL, NULL, NULL, 4),
(22090, NULL, 'G3DSA:1.20.1250.20:FF:002281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22091, NULL, 'G3DSA:1.10.3210.10:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22092, NULL, 'G3DSA:1.10.390.10:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22093, NULL, 'G3DSA:3.40.50.1820:FF:000214', NULL, NULL, 'Toxin biosynthesis protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22094, NULL, 'G3DSA:1.25.10.10:FF:002049', NULL, NULL, 'Translational activator GCN1', NULL, NULL, NULL, NULL, NULL, 4),
(22095, NULL, 'G3DSA:3.40.50.10490:FF:000043', NULL, NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', NULL, NULL, NULL, NULL, NULL, 4),
(22096, NULL, 'G3DSA:4.10.410.10:FF:000091', NULL, NULL, 'Serine protease inhibitor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22097, NULL, 'G3DSA:2.130.10.10:FF:001602', NULL, NULL, 'Eukaryotic translation initiation factor 2A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22098, NULL, 'G3DSA:3.40.50.620:FF:000445', NULL, NULL, 'Probable FAD synthase', NULL, NULL, NULL, NULL, NULL, 4),
(22099, NULL, 'G3DSA:1.20.85.10:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22100, NULL, 'G3DSA:3.40.1110.10:FF:000339', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22101, NULL, 'G3DSA:2.40.50.140:FF:000390', NULL, NULL, 'Single-stranded DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(22102, NULL, 'G3DSA:3.80.10.10:FF:001569', NULL, NULL, 'Toll-9, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(22103, NULL, 'G3DSA:3.30.540.10:FF:000077', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(22104, NULL, 'G3DSA:3.30.40.10:FF:001011', NULL, NULL, 'PINEAPPLE EYE', NULL, NULL, NULL, NULL, NULL, 4),
(22105, NULL, 'G3DSA:1.10.287.90:FF:000006', NULL, NULL, 'Cytochrome c oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(22106, NULL, 'G3DSA:1.10.287.130:FF:000002', NULL, NULL, 'Two-component osmosensing histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(22107, NULL, 'G3DSA:3.40.50.300:FF:000810', NULL, NULL, 'probable helicase senataxin', NULL, NULL, NULL, NULL, NULL, 4),
(22108, NULL, 'G3DSA:1.10.1370.30:FF:000018', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(22109, NULL, 'G3DSA:2.40.180.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22110, NULL, 'G3DSA:1.25.10.10:FF:003342', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22111, NULL, 'G3DSA:3.30.70.2470:FF:000001', NULL, NULL, 'receptor-type tyrosine-protein phosphatase-like N isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(22112, NULL, 'G3DSA:2.160.20.10:FF:000118', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(22113, NULL, 'G3DSA:3.40.190.290:FF:000050', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(22114, NULL, 'G3DSA:1.20.1690.10:FF:000006', NULL, NULL, 'V-type proton ATPase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(22115, NULL, 'G3DSA:3.20.20.70:FF:000359', NULL, NULL, 'Radical SAM domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(22116, NULL, 'G3DSA:3.40.50.80:FF:000138', NULL, NULL, 'Metalloreductase Fre8', NULL, NULL, NULL, NULL, NULL, 4),
(22117, NULL, 'G3DSA:1.20.140.10:FF:000011', NULL, NULL, 'Medium-chain specific acyl-CoA dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(22118, NULL, 'G3DSA:3.30.1330.60:FF:000024', NULL, NULL, 'Peptidoglycan-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(22119, NULL, 'G3DSA:1.10.510.10:FF:003201', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22120, NULL, 'G3DSA:1.10.1040.10:FF:000050', NULL, NULL, 'Probable 3-hydroxyisobutyrate dehydrogenase-like 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(22121, NULL, 'G3DSA:2.30.29.30:FF:000335', NULL, NULL, 'Pleckstrin homology domain-containing family H member 2', NULL, NULL, NULL, NULL, NULL, 4),
(22122, NULL, 'G3DSA:1.25.40.1040:FF:000014', NULL, NULL, 'N-alpha-acetyltransferase 15, NatA auxiliary subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22123, NULL, 'G3DSA:3.20.20.300:FF:000084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22124, NULL, 'G3DSA:1.20.1250.20:FF:000252', NULL, NULL, 'Quinolone resistance protein NorB', NULL, NULL, NULL, NULL, NULL, 4),
(22125, NULL, 'G3DSA:3.40.50.300:FF:006195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22126, NULL, 'G3DSA:1.20.1090.10:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22127, NULL, 'G3DSA:3.40.50.620:FF:000788', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22128, NULL, 'G3DSA:1.10.443.10:FF:000003', NULL, NULL, 'Type 1 fimbriae regulatory protein FimE', NULL, NULL, NULL, NULL, NULL, 4),
(22129, NULL, 'G3DSA:3.40.50.2000:FF:000931', NULL, NULL, 'ADP-heptose--lipopolysaccharide heptosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22130, NULL, 'G3DSA:3.40.50.300:FF:000708', NULL, NULL, 'ATP-dependent RNA helicase DDX1', NULL, NULL, NULL, NULL, NULL, 4),
(22131, NULL, 'G3DSA:1.20.1160.11:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22132, NULL, 'G3DSA:1.10.10.10:FF:000177', NULL, NULL, 'Transcription initiation factor IIE subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(22133, NULL, 'G3DSA:1.10.510.10:FF:002925', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22134, NULL, 'G3DSA:3.40.630.10:FF:000031', NULL, NULL, 'cytosol aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(22135, NULL, 'G3DSA:2.60.40.60:FF:000526', NULL, NULL, 'Dachsous cadherin-related 1a', NULL, NULL, NULL, NULL, NULL, 4),
(22136, NULL, 'G3DSA:1.25.40.10:FF:000640', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(22137, NULL, 'G3DSA:1.10.1170.10:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22138, NULL, 'G3DSA:3.80.10.10:FF:001653', NULL, NULL, 'Receptor-like protein kinase HSL1', NULL, NULL, NULL, NULL, NULL, 4),
(22139, NULL, 'G3DSA:2.60.40.420:FF:000118', NULL, NULL, 'Cupredoxin superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(22140, NULL, 'G3DSA:2.40.30.10:FF:000326', NULL, NULL, 'NADPH--cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(22141, NULL, 'G3DSA:3.90.25.10:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22142, NULL, 'G3DSA:3.30.40.10:FF:000393', NULL, NULL, 'CLUMA_CG014158, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(22143, NULL, 'G3DSA:3.30.160.60:FF:003283', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22144, NULL, 'G3DSA:2.130.10.10:FF:000984', NULL, NULL, 'WD repeat-containing protein 48 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(22145, NULL, 'G3DSA:1.10.10.60:FF:000973', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22146, NULL, 'G3DSA:1.10.274.100:FF:000006', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(22147, NULL, 'G3DSA:1.20.58.400:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22148, NULL, 'G3DSA:2.120.10.30:FF:000597', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22149, NULL, 'G3DSA:3.30.160.60:FF:000877', NULL, NULL, 'zinc finger protein 599', NULL, NULL, NULL, NULL, NULL, 4),
(22150, NULL, 'G3DSA:3.90.1290.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(22151, NULL, 'G3DSA:3.30.40.10:FF:000073', NULL, NULL, 'myotubularin-related protein 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(22152, NULL, 'G3DSA:1.25.10.10:FF:000149', NULL, NULL, 'Serine/threonine-protein kinase ATR', NULL, NULL, NULL, NULL, NULL, 4),
(22153, NULL, 'G3DSA:3.30.1640.10:FF:000027', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(22154, NULL, 'G3DSA:1.20.1070.10:FF:001909', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(22155, NULL, 'G3DSA:2.60.40.10:FF:000540', NULL, NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein', NULL, NULL, NULL, NULL, NULL, 4),
(22156, NULL, 'G3DSA:1.10.287.70:FF:000686', NULL, NULL, 'Glutamate receptor ionotropic N-methyl D-aspartate 1 b', NULL, NULL, NULL, NULL, NULL, 4),
(22157, NULL, 'G3DSA:1.25.40.180:FF:000214', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22158, NULL, 'G3DSA:1.25.40.20:FF:001149', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(22159, NULL, 'G3DSA:3.30.160.60:FF:001153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22160, NULL, 'G3DSA:3.30.70.20:FF:000111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22161, NULL, 'G3DSA:3.60.150.10:FF:000006', NULL, NULL, 'Chorismate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(22162, NULL, 'G3DSA:3.40.140.10:FF:000044', NULL, NULL, 'Apolipoprotein B mRNA editing enzyme catalytic subunit 3B', NULL, NULL, NULL, NULL, NULL, 4),
(22163, NULL, 'G3DSA:2.40.160.10:FF:000026', NULL, NULL, 'Voltage-dependent anion-selective channel protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(22164, NULL, 'G3DSA:3.40.1000.10:FF:000005', NULL, NULL, 'Oxygen-evolving enhancer protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(22165, NULL, 'G3DSA:1.20.120.1750:FF:000144', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(22166, NULL, 'G3DSA:3.30.420.40:FF:000594', NULL, NULL, 'Heat shock protein 70 homolog LHS1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22167, NULL, 'G3DSA:2.10.25.10:FF:000838', NULL, NULL, 'Latent transforming growth factor beta binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(22168, NULL, 'G3DSA:3.60.40.10:FF:000150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22169, NULL, 'G3DSA:3.30.70.2460:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22170, NULL, 'G3DSA:2.30.30.30:FF:000052', NULL, NULL, '50S ribosomal protein L24', NULL, NULL, NULL, NULL, NULL, 4),
(22171, NULL, 'G3DSA:3.75.10.10:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22172, NULL, 'G3DSA:2.60.40.790:FF:000173', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22173, NULL, 'G3DSA:1.10.1600.10:FF:000008', NULL, NULL, 'ATP-dependent DNA helicase II subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(22174, NULL, 'G3DSA:1.20.1250.20:FF:000813', NULL, NULL, 'Solute carrier family 15 member 4', NULL, NULL, NULL, NULL, NULL, 4),
(22175, NULL, 'G3DSA:2.10.25.10:FF:001468', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(22176, NULL, 'G3DSA:1.20.1560.10:FF:000800', NULL, NULL, 'AGAP004600-PA', NULL, NULL, NULL, NULL, NULL, 4),
(22177, NULL, 'G3DSA:3.30.160.60:FF:005205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22178, NULL, 'G3DSA:3.40.50.300:FF:001327', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(22179, NULL, 'G3DSA:1.25.40.10:FF:003754', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22180, NULL, 'G3DSA:1.10.238.10:FF:000616', NULL, NULL, 'Fimbrin', NULL, NULL, NULL, NULL, NULL, 4),
(22181, NULL, 'G3DSA:3.30.160.60:FF:004463', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22182, NULL, 'G3DSA:3.40.50.150:FF:000973', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22183, NULL, 'G3DSA:3.10.580.10:FF:000185', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(22184, NULL, 'G3DSA:3.90.20.20:FF:000010', NULL, NULL, 'Protein GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(22185, NULL, 'G3DSA:1.25.10.10:FF:000251', NULL, NULL, 'AP-3 complex subunit delta', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(22186, NULL, 'G3DSA:2.130.10.10:FF:001945', NULL, NULL, 'GD25070', NULL, NULL, NULL, NULL, NULL, 4),
(22187, NULL, 'G3DSA:3.40.50.720:FF:002515', NULL, NULL, 'Calcium-gated potassium channel MthK', NULL, NULL, NULL, NULL, NULL, 4),
(22188, NULL, 'G3DSA:2.60.120.970:FF:000028', NULL, NULL, 'Inhibin subunit beta C', NULL, NULL, NULL, NULL, NULL, 4),
(22189, NULL, 'G3DSA:1.10.1300.10:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22190, NULL, 'G3DSA:1.20.58.830:FF:000025', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(22191, NULL, 'G3DSA:1.10.40.30:FF:000011', NULL, NULL, 'Adenylosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(22192, NULL, 'G3DSA:3.90.70.10:FF:000398', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22193, NULL, 'G3DSA:3.40.50.300:FF:007156', NULL, NULL, 'ABC transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(22194, NULL, 'G3DSA:1.10.10.2660:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22195, NULL, 'G3DSA:3.30.590.10:FF:000012', NULL, NULL, 'Glutamate-ammonia ligase', NULL, NULL, NULL, NULL, NULL, 4),
(22196, NULL, 'G3DSA:3.40.50.12190:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22197, NULL, 'G3DSA:2.160.10.10:FF:000033', NULL, NULL, 'Eukaryotic translation initiation factor 2B subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(22198, NULL, 'G3DSA:3.90.80.10:FF:000016', NULL, NULL, 'Inorganic pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(22199, NULL, 'G3DSA:3.80.10.10:FF:003025', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(22200, NULL, 'G3DSA:3.30.200.20:FF:000717', NULL, NULL, 'AGC protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(22201, NULL, 'G3DSA:1.25.40.20:FF:001262', NULL, NULL, 'Zgc:113279', NULL, NULL, NULL, NULL, NULL, 4),
(22202, NULL, 'G3DSA:1.20.1560.10:FF:000137', NULL, NULL, 'Putative ABC transporter, (TAP family)', NULL, NULL, NULL, NULL, NULL, 4),
(22203, NULL, 'G3DSA:3.50.50.60:FF:000273', NULL, NULL, 'Gamma-glutamylputrescine oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(22204, NULL, 'G3DSA:1.10.510.10:FF:000536', NULL, NULL, 'Cyclin-dependent kinase WEE1', NULL, NULL, NULL, NULL, NULL, 4),
(22205, NULL, 'G3DSA:2.60.40.10:FF:006048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22206, NULL, 'G3DSA:2.60.40.60:FF:000982', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22207, NULL, 'G3DSA:3.30.1680.10:FF:000024', NULL, NULL, 'semaphorin-2A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(22208, NULL, 'G3DSA:2.130.10.10:FF:002221', NULL, NULL, 'regulatory-associated protein of mTOR-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(22209, NULL, 'G3DSA:1.20.120.350:FF:000173', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22210, NULL, 'G3DSA:2.60.40.10:FF:005109', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22211, NULL, 'G3DSA:3.40.50.10420:FF:000062', NULL, NULL, 'Predicted gene 29094', NULL, NULL, NULL, NULL, NULL, 4),
(22212, NULL, 'G3DSA:2.60.34.10:FF:000031', NULL, NULL, 'Heat shock 70 kDa protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(22213, NULL, 'G3DSA:1.25.40.10:FF:004030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22214, NULL, 'G3DSA:2.10.25.10:FF:001344', NULL, NULL, 'Fibulin-1', NULL, NULL, NULL, NULL, NULL, 4),
(22215, NULL, 'G3DSA:3.40.50.880:FF:000040', NULL, NULL, 'Gamma-glutamyl peptidase 5', NULL, NULL, NULL, NULL, NULL, 4),
(22216, NULL, 'G3DSA:1.10.472.130:FF:000019', NULL, NULL, 'Dynein heavy chain at 36C', NULL, NULL, NULL, NULL, NULL, 4),
(22217, NULL, 'G3DSA:1.10.510.10:FF:004027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22218, NULL, 'G3DSA:3.40.30.10:FF:000588', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22219, NULL, 'G3DSA:3.30.46.10:FF:000001', NULL, NULL, 'Glycine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(22220, NULL, 'G3DSA:2.30.40.10:FF:000131', NULL, NULL, 'Guanine deaminase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(22221, NULL, 'G3DSA:2.60.40.10:FF:002794', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22222, NULL, 'G3DSA:3.40.50.300:FF:002485', NULL, NULL, 'T0136454 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(22223, NULL, 'G3DSA:3.40.50.150:FF:001810', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22224, NULL, 'G3DSA:3.80.10.10:FF:004183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22225, NULL, 'G3DSA:3.40.190.10:FF:000322', NULL, NULL, 'Porphobilinogen deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(22226, NULL, 'G3DSA:3.30.860.10:FF:000005', NULL, NULL, 'Putative ribosomal protein S19/S15', NULL, NULL, NULL, NULL, NULL, 4),
(22227, NULL, 'G3DSA:2.10.25.10:FF:001687', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(22228, NULL, 'G3DSA:3.60.21.10:FF:000448', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(22229, NULL, 'G3DSA:3.30.230.130:FF:000026', NULL, NULL, 'Cullin-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22230, NULL, 'G3DSA:1.20.1740.10:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22231, NULL, 'G3DSA:1.20.144.10:FF:000115', NULL, NULL, 'AGAP008666-PA', NULL, NULL, NULL, NULL, NULL, 4),
(22232, NULL, 'G3DSA:1.20.1070.10:FF:002062', NULL, NULL, 'G protein-coupled receptor 33', NULL, NULL, NULL, NULL, NULL, 4),
(22233, NULL, 'G3DSA:1.25.10.10:FF:000812', NULL, NULL, '26S proteasome non-ATPase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(22234, NULL, 'G3DSA:3.40.50.1000:FF:000277', NULL, NULL, 'Bifunctional polynucleotide phosphatase/kinase', NULL, NULL, NULL, NULL, NULL, 4),
(22235, NULL, 'G3DSA:1.25.10.10:FF:003022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22236, NULL, 'G3DSA:1.20.58.60:FF:000223', NULL, NULL, 'Alpha spectrin, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(22237, NULL, 'G3DSA:2.60.40.10:FF:002338', NULL, NULL, 'Sensory AXon guidance', NULL, NULL, NULL, NULL, NULL, 4),
(22238, NULL, 'G3DSA:1.20.5.110:FF:000130', NULL, NULL, 'VAMP (Vesicle Associated Membrane Protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(22239, NULL, 'G3DSA:1.20.1260.140:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22240, NULL, 'G3DSA:2.60.120.40:FF:000045', NULL, NULL, 'Cytosolic endo-beta-N-acetylglucosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(22241, NULL, 'G3DSA:3.10.129.10:FF:000283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22242, NULL, 'G3DSA:2.10.55.10:FF:000003', NULL, NULL, 'MSP-A1 surface protease homolog', NULL, NULL, NULL, NULL, NULL, 4),
(22243, NULL, 'G3DSA:3.30.160.750:FF:000004', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(22244, NULL, 'G3DSA:3.30.70.330:FF:000960', NULL, NULL, 'SRA stem-loop-interacting RNA-binding protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(22245, NULL, 'G3DSA:2.40.50.770:FF:000005', NULL, NULL, 'Rmi1p', NULL, NULL, NULL, NULL, NULL, 4),
(22246, NULL, 'G3DSA:3.40.50.300:FF:000012', NULL, NULL, 'Transitional endoplasmic reticulum ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(22247, NULL, 'G3DSA:2.30.30.380:FF:000055', NULL, NULL, 'Ubiquitin thioesterase zranb1-B', NULL, NULL, NULL, NULL, NULL, 4),
(22248, NULL, 'G3DSA:1.20.1250.20:FF:001432', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22249, NULL, 'G3DSA:2.60.40.10:FF:000438', NULL, NULL, 'CD276 antigen', NULL, NULL, NULL, NULL, NULL, 4),
(22250, NULL, 'G3DSA:3.40.33.10:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22251, NULL, 'G3DSA:2.60.120.1020:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22252, NULL, 'G3DSA:2.30.30.40:FF:000398', NULL, NULL, 'Hematopoietic cell-specific Lyn substrate 1', NULL, NULL, NULL, NULL, NULL, 4),
(22253, NULL, 'G3DSA:1.20.1250.20:FF:000139', NULL, NULL, 'Solute carrier family 40 protein', NULL, NULL, NULL, NULL, NULL, 4),
(22254, NULL, 'G3DSA:1.10.287.110:FF:000108', NULL, NULL, 'DnaJ protein, putative', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(22255, NULL, 'G3DSA:3.40.50.1820:FF:000877', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22256, NULL, 'G3DSA:3.30.230.10:FF:000222', NULL, NULL, 'DNA repair protein RadA', NULL, NULL, NULL, NULL, NULL, 4),
(22257, NULL, 'G3DSA:1.20.1070.10:FF:001786', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22258, NULL, 'G3DSA:3.30.70.330:FF:000628', NULL, NULL, 'RNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(22259, NULL, 'G3DSA:3.30.70.330:FF:000067', NULL, NULL, 'regulator of nonsense transcripts 3A isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(22260, NULL, 'G3DSA:3.30.200.20:FF:001212', NULL, NULL, 'TANK binding kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(22261, NULL, 'G3DSA:2.60.120.290:FF:000010', NULL, NULL, 'Neuropilin', NULL, NULL, NULL, NULL, NULL, 4),
(22262, NULL, 'G3DSA:3.90.830.10:FF:000001', NULL, NULL, 'syntaxin-binding protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(22263, NULL, 'G3DSA:2.130.10.30:FF:000170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22264, NULL, 'G3DSA:2.120.10.80:FF:000022', NULL, NULL, 'Attractin like 1', NULL, NULL, NULL, NULL, NULL, 4),
(22265, NULL, 'G3DSA:3.90.950.10:FF:000044', NULL, NULL, 'Probable inosine/xanthosine triphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(22266, NULL, 'G3DSA:1.10.287.70:FF:000343', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22267, NULL, 'G3DSA:1.10.1220.190:FF:000001', NULL, NULL, 'Protein virC2', NULL, NULL, NULL, NULL, NULL, 4),
(22268, NULL, 'G3DSA:3.80.10.10:FF:002749', NULL, NULL, 'F-box and leucine-rich repeat protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(22269, NULL, 'G3DSA:3.30.830.10:FF:000065', NULL, NULL, 'Unplaced genomic scaffold supercont2.12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(22270, NULL, 'G3DSA:1.25.40.10:FF:000983', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(22271, NULL, 'G3DSA:3.30.200.20:FF:002185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22272, NULL, 'G3DSA:2.60.120.260:FF:000023', NULL, NULL, 'Ephrin type-A receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(22273, NULL, 'G3DSA:2.40.70.10:FF:000082', NULL, NULL, 'Plasmepsin X', NULL, NULL, NULL, NULL, NULL, 4),
(22274, NULL, 'G3DSA:1.20.1600.10:FF:000063', NULL, NULL, 'Putative outer membrane heavy metal efflux protein', NULL, NULL, NULL, NULL, NULL, 4),
(22275, NULL, 'G3DSA:2.40.50.140:FF:000513', NULL, NULL, 'Putative_tRNA_binding_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(22276, NULL, 'G3DSA:1.20.80.10:FF:000041', NULL, NULL, 'TaLiN', NULL, NULL, NULL, NULL, NULL, 4),
(22277, NULL, 'G3DSA:2.130.10.10:FF:003047', NULL, NULL, 'Transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22278, NULL, 'G3DSA:3.30.70.330:FF:002062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22279, NULL, 'G3DSA:3.90.550.10:FF:000513', NULL, NULL, 'Glycoside transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(22280, NULL, 'G3DSA:1.25.40.20:FF:001823', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22281, NULL, 'G3DSA:3.30.1330.10:FF:000026', NULL, NULL, 'phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(22282, NULL, 'G3DSA:3.30.160.60:FF:000534', NULL, NULL, 'zinc finger protein 674', NULL, NULL, NULL, NULL, NULL, 4),
(22283, NULL, 'G3DSA:2.30.42.10:FF:000422', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22284, NULL, 'G3DSA:1.20.120.1910:FF:000018', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(22285, NULL, 'G3DSA:3.40.50.2000:FF:000268', NULL, NULL, 'Glycosyltransferase family 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(22286, NULL, 'G3DSA:1.25.10.10:FF:001785', NULL, NULL, 'YALI0B20680p', NULL, NULL, NULL, NULL, NULL, 4),
(22287, NULL, 'G3DSA:1.20.1070.10:FF:001662', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22288, NULL, 'G3DSA:3.30.40.10:FF:001915', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(22289, NULL, 'G3DSA:2.130.10.10:FF:004795', NULL, NULL, 'Suppressor of mec-8 and unc-52 protein homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(22290, NULL, 'G3DSA:1.20.120.350:FF:000178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22291, NULL, 'G3DSA:3.30.160.60:FF:006397', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22292, NULL, 'G3DSA:1.10.287.110:FF:000445', NULL, NULL, 'DnaJ heat shock protein family (Hsp40) member C9', NULL, NULL, NULL, NULL, NULL, 4),
(22293, NULL, 'G3DSA:1.20.920.10:FF:000088', NULL, NULL, 'Tat-binding homolog 7', NULL, NULL, NULL, NULL, NULL, 4),
(22294, NULL, 'G3DSA:3.40.50.720:FF:000481', NULL, NULL, 'Alcohol dehydrogenase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(22295, NULL, 'G3DSA:2.60.40.10:FF:004828', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22296, NULL, 'G3DSA:3.80.10.10:FF:001097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22297, NULL, 'G3DSA:2.60.120.200:FF:000500', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(22298, NULL, 'G3DSA:4.10.1240.10:FF:000057', NULL, NULL, 'Latrophilin-like protein LAT-2', NULL, NULL, NULL, NULL, NULL, 4),
(22299, NULL, 'G3DSA:1.10.8.720:FF:000017', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22300, NULL, 'G3DSA:1.10.10.10:FF:000756', NULL, NULL, 'Z-DNA binding protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(22301, NULL, 'G3DSA:1.25.10.10:FF:002960', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22302, NULL, 'G3DSA:3.40.50.1820:FF:000427', NULL, NULL, 'YOR022C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(22303, NULL, 'G3DSA:3.30.420.10:FF:000377', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22304, NULL, 'G3DSA:1.10.287.70:FF:000130', NULL, NULL, 'Potassium calcium-activated channel subfamily U member 1', NULL, NULL, NULL, NULL, NULL, 4),
(22305, NULL, 'G3DSA:3.40.50.300:FF:002047', NULL, NULL, 'AAA family ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22306, NULL, 'G3DSA:1.25.40.10:FF:004586', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22307, NULL, 'G3DSA:1.10.510.10:FF:000559', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(22308, NULL, 'G3DSA:2.60.40.150:FF:000560', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(22309, NULL, 'G3DSA:3.30.40.10:FF:001466', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22310, NULL, 'G3DSA:1.10.238.10:FF:000971', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22311, NULL, 'G3DSA:3.40.640.10:FF:000413', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(22312, NULL, 'G3DSA:3.10.100.10:FF:000088', NULL, NULL, 'Mannose-binding protein A', NULL, NULL, NULL, NULL, NULL, 4),
(22313, NULL, 'G3DSA:2.30.30.560:FF:000002', NULL, NULL, 'Major vault protein-alpha', NULL, NULL, NULL, NULL, NULL, 4),
(22314, NULL, 'G3DSA:3.20.20.70:FF:000578', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22315, NULL, 'G3DSA:2.120.10.80:FF:000258', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(22316, NULL, 'G3DSA:3.10.20.770:FF:000007', NULL, NULL, 'Phosphatidylinositol 3-kinase age-1', NULL, NULL, NULL, NULL, NULL, 4),
(22317, NULL, 'G3DSA:1.10.472.130:FF:000014', NULL, NULL, 'Dynein beta chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22318, NULL, 'G3DSA:1.10.510.10:FF:003307', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22319, NULL, 'G3DSA:3.30.160.60:FF:001607', NULL, NULL, 'zinc finger protein 568 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(22320, NULL, 'G3DSA:1.20.1250.20:FF:000021', NULL, NULL, 'Putative multidrug resistance protein MdtD', NULL, NULL, NULL, NULL, NULL, 4),
(22321, NULL, 'G3DSA:3.40.50.12780:FF:000084', NULL, NULL, 'Anthranilate--CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(22322, NULL, 'G3DSA:1.20.1250.40:FF:000027', NULL, NULL, 'HRDC-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(22323, NULL, 'G3DSA:1.10.238.10:FF:000055', NULL, NULL, 'Intersectin-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(22324, NULL, 'G3DSA:1.10.287.820:FF:000001', NULL, NULL, 'acid-sensing ion channel 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(22325, NULL, 'G3DSA:1.20.58.150:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22326, NULL, 'G3DSA:2.60.40.150:FF:000453', NULL, NULL, 'RPGR-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(22327, NULL, 'G3DSA:2.60.40.10:FF:001158', NULL, NULL, 'NPHS1, nephrin', NULL, NULL, NULL, NULL, NULL, 4),
(22328, NULL, 'G3DSA:3.10.100.10:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22329, NULL, 'G3DSA:1.10.20.10:FF:000245', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22330, NULL, 'G3DSA:3.30.160.60:FF:002226', NULL, NULL, 'Zinc finger protein 764', NULL, NULL, NULL, NULL, NULL, 4),
(22331, NULL, 'G3DSA:3.40.640.10:FF:000306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22332, NULL, 'G3DSA:4.10.240.10:FF:000032', NULL, NULL, 'Related to ARO80-positive transcription regulator of ARO9 and ARO10', NULL, NULL, NULL, NULL, NULL, 4),
(22333, NULL, 'G3DSA:2.70.170.10:FF:000048', NULL, NULL, 'Cholinergic receptor nicotinic alpha 1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(22334, NULL, 'G3DSA:1.25.40.10:FF:000308', NULL, NULL, 'Transmembrane and tetratricopeptide repeat-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(22335, NULL, 'G3DSA:3.40.50.300:FF:002963', NULL, NULL, 'AGAP009622-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(22336, NULL, 'G3DSA:1.10.287.690:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22337, NULL, 'G3DSA:3.30.70.330:FF:002646', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22338, NULL, 'G3DSA:1.20.1600.10:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22339, NULL, 'G3DSA:3.40.1190.20:FF:000100', NULL, NULL, 'adenosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(22340, NULL, 'G3DSA:1.20.1250.20:FF:001544', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22341, NULL, 'G3DSA:2.130.10.10:FF:004800', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22342, NULL, 'G3DSA:3.20.20.70:FF:000590', NULL, NULL, 'Acetyl-CoA carboxylase/pyruvate carboxylase fusion protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22343, NULL, 'G3DSA:2.130.10.10:FF:001029', NULL, NULL, 'APC/C activator protein CDH1', NULL, NULL, NULL, NULL, NULL, 4),
(22344, NULL, 'G3DSA:1.10.1370.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22345, NULL, 'G3DSA:1.10.30.10:FF:000066', NULL, NULL, 'High mobility group family', NULL, NULL, NULL, NULL, NULL, 4),
(22346, NULL, 'G3DSA:1.20.120.1950:FF:000002', NULL, NULL, 'Programmed cell death protein 10 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(22347, NULL, 'G3DSA:3.30.40.10:FF:001359', NULL, NULL, 'Probable histone-lysine N-methyltransferase lin-59', NULL, NULL, NULL, NULL, NULL, 4),
(22348, NULL, 'G3DSA:3.40.50.300:FF:001428', NULL, NULL, 'putative Ras-related protein Rab-42', NULL, NULL, NULL, NULL, NULL, 4),
(22349, NULL, 'G3DSA:3.30.160.60:FF:002119', NULL, NULL, 'Endolytic murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(22350, NULL, 'G3DSA:1.25.40.10:FF:003967', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22351, NULL, 'G3DSA:1.10.490.10:FF:000039', NULL, NULL, 'Globin-1', NULL, NULL, NULL, NULL, NULL, 4),
(22352, NULL, 'G3DSA:1.25.40.10:FF:000320', NULL, NULL, 'CCR4-NOT transcription complex subunit 10', NULL, NULL, NULL, NULL, NULL, 4),
(22353, NULL, 'G3DSA:2.30.30.1150:FF:000004', NULL, NULL, 'E3 ubiquitin-protein ligase UHRF1', NULL, NULL, NULL, NULL, NULL, 4),
(22354, NULL, 'G3DSA:1.10.630.10:FF:000028', NULL, NULL, 'Cytochrome p450 51g1', NULL, NULL, NULL, NULL, NULL, 4),
(22355, NULL, 'G3DSA:3.40.50.300:FF:008561', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22356, NULL, 'G3DSA:3.30.40.10:FF:000180', NULL, NULL, 'Early endosome antigen 1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(22357, NULL, 'G3DSA:3.40.50.2000:FF:000032', NULL, NULL, '3-deoxy-D-manno-octulosonic acid transferase', NULL, NULL, NULL, NULL, NULL, 4),
(22358, NULL, 'G3DSA:1.50.40.10:FF:000121', NULL, NULL, 'Ornithine carrier protein AmcA/Ort1', NULL, NULL, NULL, NULL, NULL, 4),
(22359, NULL, 'G3DSA:1.10.238.150:FF:000009', NULL, NULL, 'CYtoKinesis defect', NULL, NULL, NULL, NULL, NULL, 4),
(22360, NULL, 'G3DSA:3.40.850.10:FF:000019', NULL, NULL, 'Kinesin-like protein KIN-5D', NULL, NULL, NULL, NULL, NULL, 4),
(22361, NULL, 'G3DSA:4.10.640.10:FF:000017', NULL, NULL, 'Related to 30s ribosomal protein s18', NULL, NULL, NULL, NULL, NULL, 4),
(22362, NULL, 'G3DSA:3.40.50.150:FF:001462', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22363, NULL, 'G3DSA:1.10.472.10:FF:000559', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22364, NULL, 'G3DSA:1.25.40.10:FF:003170', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(22365, NULL, 'G3DSA:1.25.40.10:FF:005098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22366, NULL, 'G3DSA:2.60.40.10:FF:004143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22367, NULL, 'G3DSA:3.30.379.10:FF:000010', NULL, NULL, 'Beta-N-acetylhexosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(22368, NULL, 'G3DSA:3.30.559.30:FF:000114', NULL, NULL, 'Putative peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(22369, NULL, 'G3DSA:1.25.40.240:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22370, NULL, 'G3DSA:2.40.30.10:FF:000433', NULL, NULL, 'Elongation factor Tu mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(22371, NULL, 'G3DSA:1.25.10.10:FF:000487', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(22372, NULL, 'G3DSA:2.60.40.10:FF:006060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22373, NULL, 'G3DSA:3.50.50.60:FF:000514', NULL, NULL, 'D-amino acid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(22374, NULL, 'G3DSA:1.10.390.10:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22375, NULL, 'G3DSA:3.30.9.10:FF:000101', NULL, NULL, 'Putative sarcosine oxidase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(22376, NULL, 'G3DSA:2.60.120.230:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22377, NULL, 'G3DSA:1.25.10.10:FF:001111', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(22378, NULL, 'G3DSA:3.90.70.10:FF:000515', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22379, NULL, 'G3DSA:3.30.160.60:FF:005211', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22380, NULL, 'G3DSA:1.10.357.30:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22381, NULL, 'G3DSA:3.40.50.10240:FF:000002', NULL, NULL, 'Thiamine pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(22382, NULL, 'G3DSA:1.20.5.430:FF:000006', NULL, NULL, 'Heat shock factor binding 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(22383, NULL, 'G3DSA:2.60.40.150:FF:000346', NULL, NULL, 'Extended synaptotagmin-like protein 2a', NULL, NULL, NULL, NULL, NULL, 4),
(22384, NULL, 'G3DSA:2.30.40.10:FF:000125', NULL, NULL, 'Imidazolonepropionase', NULL, NULL, NULL, NULL, NULL, 4),
(22385, NULL, 'G3DSA:1.20.1070.10:FF:000605', NULL, NULL, 'Melanin-concentrating hormone receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(22386, NULL, 'G3DSA:1.10.720.60:FF:000016', NULL, NULL, 'Enolase-phosphatase E1', NULL, NULL, NULL, NULL, NULL, 4),
(22387, NULL, 'G3DSA:3.50.7.10:FF:000069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22388, NULL, 'G3DSA:3.30.70.330:FF:002753', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22389, NULL, 'G3DSA:3.30.70.260:FF:000012', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(22390, NULL, 'G3DSA:3.30.40.10:FF:000050', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(22391, NULL, 'G3DSA:1.10.472.10:FF:000666', NULL, NULL, 'Cyclin D2, a', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(22392, NULL, 'G3DSA:2.60.120.10:FF:000733', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22393, NULL, 'G3DSA:3.30.200.20:FF:002510', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(22394, NULL, 'G3DSA:1.20.1250.20:FF:001325', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(22395, NULL, 'G3DSA:1.20.1250.20:FF:001437', NULL, NULL, 'MFS sugar transporter, putative (AFU_orthologue AFUA_3G02890)', NULL, NULL, NULL, NULL, NULL, 4),
(22396, NULL, 'G3DSA:3.40.50.720:FF:001897', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(22397, NULL, 'G3DSA:1.20.5.2440:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22398, NULL, 'G3DSA:3.30.1330.20:FF:000041', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(22399, NULL, 'G3DSA:1.10.3290.10:FF:000001', NULL, NULL, 'adenosine monophosphate-protein transferase FICD', NULL, NULL, NULL, NULL, NULL, 4),
(22400, NULL, 'G3DSA:1.20.5.190:FF:000120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22401, NULL, 'G3DSA:3.30.200.20:FF:001886', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3', NULL, NULL, NULL, NULL, NULL, 4),
(22402, NULL, 'G3DSA:2.80.10.50:FF:000083', NULL, NULL, 'Alpha-amylase/subtilisin inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(22403, NULL, 'G3DSA:2.170.140.10:FF:000011', NULL, NULL, 'CSON009188 protein', NULL, NULL, NULL, NULL, NULL, 4),
(22404, NULL, 'G3DSA:2.80.10.50:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22405, NULL, 'G3DSA:3.40.50.620:FF:000125', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(22406, NULL, 'G3DSA:1.10.533.10:FF:000241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22407, NULL, 'G3DSA:3.40.50.2020:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22408, NULL, 'G3DSA:3.40.50.720:FF:001785', NULL, NULL, 'Putative 2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(22409, NULL, 'G3DSA:1.25.10.10:FF:002853', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22410, NULL, 'G3DSA:3.30.1370.10:FF:000153', NULL, NULL, 'KH domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22411, NULL, 'G3DSA:2.60.40.2070:FF:000004', NULL, NULL, 'Fimbrial biogenesis outer membrane usher protein', NULL, NULL, NULL, NULL, NULL, 4),
(22412, NULL, 'G3DSA:1.20.58.1080:FF:000003', NULL, NULL, 'DExH-box ATP-dependent RNA helicase DExH16 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(22413, NULL, 'G3DSA:3.80.10.10:FF:004082', NULL, NULL, 'Leucine-rich repeats and immunoglobulin-like domains 2', NULL, NULL, NULL, NULL, NULL, 4),
(22414, NULL, 'G3DSA:3.30.60.30:FF:000063', NULL, NULL, 'Insulin-like growth factor-binding protein-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(22415, NULL, 'G3DSA:3.30.2350.20:FF:000036', NULL, NULL, 'tRNA pseudouridine synthase d domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(22416, NULL, 'G3DSA:1.10.150.50:FF:000211', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(22417, NULL, 'G3DSA:1.25.40.20:FF:001161', NULL, NULL, 'Ankyrin repeat, SAM and basic leucine zipper domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(22418, NULL, 'G3DSA:3.40.50.1820:FF:000534', NULL, NULL, 'Serine_hydrolase_(FSH1)/50S_ribosome-binding_GTPase/GTPase_of_uncharacterized_function_C-terminal_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(22419, NULL, 'G3DSA:3.30.160.60:FF:003524', NULL, NULL, 'AGAP002041-PB', NULL, NULL, NULL, NULL, NULL, 4),
(22420, NULL, 'G3DSA:3.30.70.330:FF:001348', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22421, NULL, 'G3DSA:3.30.710.10:FF:000129', NULL, NULL, 'BTB/POZ domain-containing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(22422, NULL, 'G3DSA:3.30.200.20:FF:001105', NULL, NULL, 'Serine/threonine-protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(22423, NULL, 'G3DSA:2.10.110.10:FF:000013', NULL, NULL, 'Four and a half LIM domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(22424, NULL, 'G3DSA:3.90.180.10:FF:000035', NULL, NULL, 'Multifunctional mycocerosic acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(22425, NULL, 'G3DSA:1.25.40.20:FF:001031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22426, NULL, 'G3DSA:1.25.40.10:FF:002225', NULL, NULL, 'Alpha-snap', NULL, NULL, NULL, NULL, NULL, 4),
(22427, NULL, 'G3DSA:2.60.120.260:FF:000248', NULL, NULL, 'Spindle pole body-associated protein sad1', NULL, NULL, NULL, NULL, NULL, 4),
(22428, NULL, 'G3DSA:2.40.70.10:FF:000323', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22429, NULL, 'G3DSA:3.30.470.20:FF:000203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22430, NULL, 'G3DSA:3.30.70.330:FF:000729', NULL, NULL, 'Blast:Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(22431, NULL, 'G3DSA:3.40.50.620:FF:000102', NULL, NULL, 'Choline-phosphate cytidylyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(22432, NULL, 'G3DSA:3.40.390.10:FF:000091', NULL, NULL, 'Matrix metalloproteinase-16-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(22433, NULL, 'G3DSA:3.40.630.40:FF:000023', NULL, NULL, 'N-acetylmuramoyl alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(22434, NULL, 'G3DSA:1.10.486.10:FF:000046', NULL, NULL, 'PCNA-interacting partner', NULL, NULL, NULL, NULL, NULL, 4),
(22435, NULL, 'G3DSA:2.60.40.1180:FF:000046', NULL, NULL, 'Domain_of_uncharacterized_function_(DUF1935)_-_pu tative', NULL, NULL, NULL, NULL, NULL, 4),
(22436, NULL, 'G3DSA:2.30.29.30:FF:000779', NULL, NULL, 'YALI0F15719p', NULL, NULL, NULL, NULL, NULL, 4),
(22437, NULL, 'G3DSA:1.20.120.1750:FF:000167', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(22438, NULL, 'G3DSA:1.10.510.10:FF:004471', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22439, NULL, 'G3DSA:3.40.30.10:FF:001100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22440, NULL, 'G3DSA:3.40.50.2300:FF:000015', NULL, NULL, 'Two-component response regulator UvrY', NULL, NULL, NULL, NULL, NULL, 4),
(22441, NULL, 'G3DSA:3.40.50.300:FF:003901', NULL, NULL, 'Molybdopterin_guanine_dinucleotide_synthesis_protein_B_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(22442, NULL, 'G3DSA:3.40.140.10:FF:000050', NULL, NULL, 'tRNA-specific adenosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(22443, NULL, 'G3DSA:1.10.287.990:FF:000006', NULL, NULL, 'Superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(22444, NULL, 'G3DSA:3.90.470.20:FF:000009', NULL, NULL, 'Phosphopantetheine-protein transferase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(22445, NULL, 'G3DSA:3.80.10.10:FF:001108', NULL, NULL, 'Leucine rich repeat protein phosphatase 2c domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(22446, NULL, 'G3DSA:3.30.710.10:FF:000017', NULL, NULL, 'BTB/POZ domain-containing protein 10 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(22447, NULL, 'G3DSA:1.10.238.10:FF:000841', NULL, NULL, 'Mitochondrial calcium uptake 1', NULL, NULL, NULL, NULL, NULL, 4),
(22448, NULL, 'G3DSA:3.40.50.80:FF:000239', NULL, NULL, 'Cytochrome b5 reductase 3', NULL, NULL, NULL, NULL, NULL, 4),
(22449, NULL, 'G3DSA:1.20.930.20:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22450, NULL, 'G3DSA:2.90.10.30:FF:000003', NULL, NULL, 'Os04g0303100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(22451, NULL, 'G3DSA:2.130.10.10:FF:004688', NULL, NULL, 'Cleavage and polyadenylation specificity factor-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22452, NULL, 'G3DSA:3.40.50.1000:FF:000856', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22453, NULL, 'G3DSA:3.40.50.1820:FF:001046', NULL, NULL, 'Os01g0317500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(22454, NULL, 'G3DSA:1.10.287.520:FF:000006', NULL, NULL, 'Noggin-3', NULL, NULL, NULL, NULL, NULL, 4),
(22455, NULL, 'G3DSA:1.20.1250.20:FF:002056', NULL, NULL, 'Os04g0464400 protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(22456, NULL, 'G3DSA:2.130.10.10:FF:003502', NULL, NULL, 'Peptidylprolyl isomerase domain and WD repeat-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(22457, NULL, 'G3DSA:2.60.40.10:FF:002693', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(22458, NULL, 'G3DSA:2.60.40.10:FF:003979', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22459, NULL, 'G3DSA:1.10.287.130:FF:000103', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(22460, NULL, 'G3DSA:1.10.10.10:FF:000975', NULL, NULL, 'Putative casein kinase I', NULL, NULL, NULL, NULL, NULL, 4),
(22461, NULL, 'G3DSA:3.40.850.10:FF:000238', NULL, NULL, 'Kinesin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22462, NULL, 'G3DSA:3.90.320.10:FF:000024', NULL, NULL, 'ATP-dependent helicase/nuclease subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(22463, NULL, 'G3DSA:3.10.100.10:FF:000082', NULL, NULL, 'CD302 antigen isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(22464, NULL, 'G3DSA:1.10.287.70:FF:000023', NULL, NULL, 'Voltage-dependent R-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(22465, NULL, 'G3DSA:1.20.1300.10:FF:000028', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(22466, NULL, 'G3DSA:1.25.10.10:FF:000599', NULL, NULL, 'Protein STU2', NULL, NULL, NULL, NULL, NULL, 4),
(22467, NULL, 'G3DSA:1.25.40.280:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22468, NULL, 'G3DSA:1.10.418.10:FF:000046', NULL, NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(22469, NULL, 'G3DSA:3.30.160.60:FF:005885', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22470, NULL, 'G3DSA:2.130.10.10:FF:002327', NULL, NULL, 'WD repeat-containing protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(22471, NULL, 'G3DSA:2.170.270.10:FF:000127', NULL, NULL, 'Histone-lysine N-methyltransferase Clr4 (AFU_orthologue AFUA_1G11090)', NULL, NULL, NULL, NULL, NULL, 4),
(22472, NULL, 'G3DSA:3.40.720.10:FF:000358', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(22473, NULL, 'G3DSA:1.20.5.110:FF:000023', NULL, NULL, 'Syntaxin 3', NULL, NULL, NULL, NULL, NULL, 4),
(22474, NULL, 'G3DSA:3.30.1330.40:FF:000024', NULL, NULL, 'Enamine deaminase RidA', NULL, NULL, NULL, NULL, NULL, 4),
(22475, NULL, 'G3DSA:2.30.170.20:FF:000021', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(22476, NULL, 'G3DSA:1.20.1420.30:FF:000077', NULL, NULL, 'Ca(2+)/H(+) antiporter', NULL, NULL, NULL, NULL, NULL, 4),
(22477, NULL, 'G3DSA:3.60.10.10:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22478, NULL, 'G3DSA:1.20.5.710:FF:000001', NULL, NULL, '50S ribosomal protein L7/L12', NULL, NULL, NULL, NULL, NULL, 4),
(22479, NULL, 'G3DSA:1.10.1170.10:FF:000031', NULL, NULL, 'Apoptosis 2 inhibitor-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(22480, NULL, 'G3DSA:2.40.170.20:FF:000098', NULL, NULL, 'Ligand-gated TonB-dependent outer membrane channel', NULL, NULL, NULL, NULL, NULL, 4),
(22481, NULL, 'G3DSA:2.40.30.10:FF:000214', NULL, NULL, 'U5 snRNP-specific protein', NULL, NULL, NULL, NULL, NULL, 4),
(22482, NULL, 'G3DSA:3.80.10.10:FF:003469', NULL, NULL, 'AT19096p', NULL, NULL, NULL, NULL, NULL, 4),
(22483, NULL, 'G3DSA:1.10.730.10:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22484, NULL, 'G3DSA:3.30.559.10:FF:000007', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(22485, NULL, 'G3DSA:2.30.29.30:FF:001392', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22486, NULL, 'G3DSA:3.40.1280.10:FF:000093', NULL, NULL, 'RNA methyltransferase, TrmH family protein', NULL, NULL, NULL, NULL, NULL, 4),
(22487, NULL, 'G3DSA:3.30.450.40:FF:000303', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(22488, NULL, 'G3DSA:3.90.550.10:FF:000625', NULL, NULL, 'Molybdenum cofactor guanylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(22489, NULL, 'G3DSA:1.20.1070.10:FF:001555', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22490, NULL, 'G3DSA:3.30.460.10:FF:000031', NULL, NULL, 'Topoisomerase family protein Trf4', NULL, NULL, NULL, NULL, NULL, 4),
(22491, NULL, 'G3DSA:3.40.50.300:FF:002940', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(22492, NULL, 'G3DSA:3.30.70.20:FF:000004', NULL, NULL, '4Fe-4S ferredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(22493, NULL, 'G3DSA:3.10.20.90:FF:000663', NULL, NULL, 'Ubiquitin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(22494, NULL, 'G3DSA:3.20.20.140:FF:000457', NULL, NULL, 'Guanine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(22495, NULL, 'G3DSA:1.10.150.670:FF:000035', NULL, NULL, 'Crossover junction endonuclease MUS81-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(22496, NULL, 'G3DSA:1.25.40.180:FF:000315', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22497, NULL, 'G3DSA:2.10.25.10:FF:001682', NULL, NULL, 'Transmembrane cell adhesion receptor mua-3', NULL, NULL, NULL, NULL, NULL, 4),
(22498, NULL, 'G3DSA:1.10.287.990:FF:000001', NULL, NULL, 'Superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(22499, NULL, 'G3DSA:1.10.510.10:FF:000429', NULL, NULL, 'SRSF protein kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(22500, NULL, 'G3DSA:3.30.70.330:FF:000044', NULL, NULL, 'Putative ccr4-not transcription complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(22501, NULL, 'G3DSA:1.10.287.1490:FF:000129', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(22502, NULL, 'G3DSA:2.160.20.10:FF:000219', NULL, NULL, 'PolyMG-specific alginate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(22503, NULL, 'G3DSA:3.40.50.1820:FF:001832', NULL, NULL, 'Carboxylesterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22504, NULL, 'G3DSA:3.30.1840.10:FF:000003', NULL, NULL, 'Polyphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(22505, NULL, 'G3DSA:1.20.1070.10:FF:002067', NULL, NULL, 'Novopsin-10', NULL, NULL, NULL, NULL, NULL, 4),
(22506, NULL, 'G3DSA:3.40.1810.10:FF:000016', NULL, NULL, 'MADS-box transcription factor 16', NULL, NULL, NULL, NULL, NULL, 4),
(22507, NULL, 'G3DSA:3.30.830.10:FF:000172', NULL, NULL, 'cytochrome b-c1 complex subunit 2, mitochondrial-like', NULL, NULL, NULL, NULL, NULL, 4),
(22508, NULL, 'G3DSA:2.40.50.140:FF:001238', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22509, NULL, 'G3DSA:1.20.5.1160:FF:000044', NULL, NULL, 'Glial fibrillary acidic protein', NULL, NULL, NULL, NULL, NULL, 4),
(22510, NULL, 'G3DSA:1.20.140.100:FF:000012', NULL, NULL, 'Axonemal dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(22511, NULL, 'G3DSA:3.40.630.30:FF:000694', NULL, NULL, 'N-acetyl-transferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(22512, NULL, 'G3DSA:1.20.1280.50:FF:000184', NULL, NULL, 'F-box/LRR-repeat protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(22513, NULL, 'G3DSA:3.40.390.10:FF:000214', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22514, NULL, 'G3DSA:3.40.50.2000:FF:000824', NULL, NULL, 'Trehalose-6-phosphate synthase/phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(22515, NULL, 'G3DSA:3.20.80.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22516, NULL, 'G3DSA:1.10.472.10:FF:000211', NULL, NULL, 'Cyclin domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(22517, NULL, 'G3DSA:3.40.50.10190:FF:000296', NULL, NULL, 'DNA topoisomerase 2-binding protein 1-A-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(22518, NULL, 'G3DSA:3.40.50.150:FF:000512', NULL, NULL, 'Putative methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(22519, NULL, 'G3DSA:1.10.472.10:FF:000099', NULL, NULL, 'G1/S-specific cyclin-D3 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(22520, NULL, 'G3DSA:1.10.238.10:FF:000167', NULL, NULL, 'Protein S100-A10', NULL, NULL, NULL, NULL, NULL, 4),
(22521, NULL, 'G3DSA:1.20.58.1880:FF:000035', NULL, NULL, 'REST corepressor spr-1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(22522, NULL, 'G3DSA:2.80.10.50:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22523, NULL, 'G3DSA:3.40.50.300:FF:004306', NULL, NULL, 'Small GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22524, NULL, 'G3DSA:3.40.50.1000:FF:000171', NULL, NULL, 'Nuclear lim interactor-interacting factor,putative', NULL, NULL, NULL, NULL, NULL, 4),
(22525, NULL, 'G3DSA:1.20.1070.10:FF:001903', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22526, NULL, 'G3DSA:3.30.160.60:FF:004143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22527, NULL, 'G3DSA:2.60.40.10:FF:003075', NULL, NULL, 'CD226 antigen (Predicted), isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(22528, NULL, 'G3DSA:1.20.120.350:FF:000066', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(22529, NULL, 'G3DSA:3.40.50.150:FF:001024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22530, NULL, 'G3DSA:3.40.50.150:FF:000405', NULL, NULL, 'Carminomycin 4-O-methyltransferase DnrK', NULL, NULL, NULL, NULL, NULL, 4),
(22531, NULL, 'G3DSA:3.40.50.300:FF:004649', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22532, NULL, 'G3DSA:1.10.1200.10:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22533, NULL, 'G3DSA:2.60.40.150:FF:000341', NULL, NULL, 'Tcb3p', NULL, NULL, NULL, NULL, NULL, 4),
(22534, NULL, 'G3DSA:3.40.1690.20:FF:000014', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(22535, NULL, 'G3DSA:3.30.40.10:FF:000977', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(22536, NULL, 'G3DSA:2.60.40.10:FF:000091', NULL, NULL, 'Leucine-rich repeat and fibronectin type III domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(22537, NULL, 'G3DSA:2.10.25.10:FF:001575', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22538, NULL, 'G3DSA:2.40.50.140:FF:000619', NULL, NULL, 'Exosome complex exonuclease RRP44 A', NULL, NULL, NULL, NULL, NULL, 4),
(22539, NULL, 'G3DSA:3.90.1150.10:FF:000246', NULL, NULL, 'Selenocysteine lyase', NULL, NULL, NULL, NULL, NULL, 4),
(22540, NULL, 'G3DSA:2.130.10.10:FF:005200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22541, NULL, 'G3DSA:3.40.50.880:FF:000045', NULL, NULL, 'glutamine amidotransferase-like class 1 domain-containing protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(22542, NULL, 'G3DSA:3.30.160.60:FF:004828', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22543, NULL, 'G3DSA:3.90.1170.20:FF:000014', NULL, NULL, 'Nicotinate-nucleotide pyrophosphorylase [carboxylating]', NULL, NULL, NULL, NULL, NULL, 4),
(22544, NULL, 'G3DSA:1.20.1070.10:FF:002174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22545, NULL, 'G3DSA:3.30.1370.100:FF:000007', NULL, NULL, 'MUTL protein homolog 3', NULL, NULL, NULL, NULL, NULL, 4),
(22546, NULL, 'G3DSA:3.30.160.60:FF:005104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22547, NULL, 'G3DSA:2.80.10.50:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22548, NULL, 'G3DSA:2.70.150.10:FF:000272', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(22549, NULL, 'G3DSA:3.40.47.10:FF:000138', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(22550, NULL, 'G3DSA:3.90.120.10:FF:000020', NULL, NULL, 'DNA (cytosine-5)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(22551, NULL, 'G3DSA:3.60.20.10:FF:000036', NULL, NULL, 'Proteasome subunit alpha type', NULL, NULL, NULL, NULL, NULL, 4),
(22552, NULL, 'G3DSA:3.30.590.10:FF:000035', NULL, NULL, 'Glutamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(22553, NULL, 'G3DSA:3.40.50.1370:FF:000028', NULL, NULL, 'Putrescine carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(22554, NULL, 'G3DSA:1.10.730.10:FF:000199', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(22555, NULL, 'G3DSA:1.10.580.10:FF:000041', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(22556, NULL, 'G3DSA:3.40.50.1820:FF:001158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22557, NULL, 'G3DSA:1.20.1070.10:FF:001898', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(22558, NULL, 'G3DSA:1.20.5.170:FF:000013', NULL, NULL, 'RUN and FYVE domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(22559, NULL, 'G3DSA:1.10.287.70:FF:000242', NULL, NULL, 'Potassium voltage-gated channel subfamily A member 1', NULL, NULL, NULL, NULL, NULL, 4),
(22560, NULL, 'G3DSA:3.40.50.300:FF:000939', NULL, NULL, 'Probable ATP-dependent RNA helicase DDX56', NULL, NULL, NULL, NULL, NULL, 4),
(22561, NULL, 'G3DSA:3.40.50.300:FF:003345', NULL, NULL, 'Hydrolase, P-loop family', NULL, NULL, NULL, NULL, NULL, 4),
(22562, NULL, 'G3DSA:2.40.10.10:FF:000319', NULL, NULL, 'AGAP011918-PA', NULL, NULL, NULL, NULL, NULL, 4),
(22563, NULL, 'G3DSA:1.10.472.10:FF:000104', NULL, NULL, 'cyclin-T1-3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(22564, NULL, 'G3DSA:1.10.720.60:FF:000011', NULL, NULL, 'enolase-phosphatase E1-like', NULL, NULL, NULL, NULL, NULL, 4),
(22565, NULL, 'G3DSA:1.20.1110.10:FF:000216', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22566, NULL, 'G3DSA:1.10.1370.30:FF:000030', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(22567, NULL, 'G3DSA:2.60.40.60:FF:000881', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22568, NULL, 'G3DSA:3.40.50.2000:FF:001100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22569, NULL, 'G3DSA:3.40.120.10:FF:000048', NULL, NULL, 'Phosphoglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(22570, NULL, 'G3DSA:3.90.550.50:FF:000053', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(22571, NULL, 'G3DSA:3.40.50.10860:FF:000064', NULL, NULL, 'Methylenetetrahydrofolate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(22572, NULL, 'G3DSA:3.40.190.10:FF:000339', NULL, NULL, 'Spermidine-binding periplasmic protein SpuE', NULL, NULL, NULL, NULL, NULL, 4),
(22573, NULL, 'G3DSA:3.10.600.10:FF:000007', NULL, NULL, 'Pyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(22574, NULL, 'G3DSA:2.60.40.790:FF:000066', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(22575, NULL, 'G3DSA:2.60.40.10:FF:004036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22576, NULL, 'G3DSA:2.30.130.10:FF:000038', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(22577, NULL, 'G3DSA:1.20.120.160:FF:000003', NULL, NULL, 'Aerobic respiration control sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(22578, NULL, 'G3DSA:3.60.20.10:FF:000143', NULL, NULL, 'Glucosamine/fructose-6-phosphate aminotransferase, isomerizing', NULL, NULL, NULL, NULL, NULL, 4),
(22579, NULL, 'G3DSA:1.25.40.10:FF:002681', NULL, NULL, 'Os12g0130900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(22580, NULL, 'G3DSA:2.40.180.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22581, NULL, 'G3DSA:2.60.300.12:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22582, NULL, 'G3DSA:1.50.40.10:FF:000469', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(22583, NULL, 'G3DSA:3.40.50.300:FF:008016', NULL, NULL, 'Protein translocase subunit SECA1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(22584, NULL, 'G3DSA:1.10.510.10:FF:002902', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22585, NULL, 'G3DSA:2.10.70.10:FF:000246', NULL, NULL, 'Putative eel-fucolectin tachylectin-4 pentaxrin-1 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(22586, NULL, 'G3DSA:2.102.10.10:FF:000019', NULL, NULL, 'Rieske iron-sulfur protein', NULL, NULL, NULL, NULL, NULL, 4),
(22587, NULL, 'G3DSA:3.90.226.10:FF:000266', NULL, NULL, 'Protein CBG25649', NULL, NULL, NULL, NULL, NULL, 4),
(22588, NULL, 'G3DSA:1.10.150.530:FF:000010', NULL, NULL, 'Probable dual-specificity RNA methyltransferase RlmN', NULL, NULL, NULL, NULL, NULL, 4),
(22589, NULL, 'G3DSA:3.10.110.10:FF:000251', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(22590, NULL, 'G3DSA:2.10.90.10:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22591, NULL, 'G3DSA:3.30.160.60:FF:004699', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22592, NULL, 'G3DSA:2.10.25.10:FF:001232', NULL, NULL, 'FI15785p1', NULL, NULL, NULL, NULL, NULL, 4),
(22593, NULL, 'G3DSA:1.10.357.50:FF:000017', NULL, NULL, 'SEC6', NULL, NULL, NULL, NULL, NULL, 4),
(22594, NULL, 'G3DSA:2.130.10.10:FF:000068', NULL, NULL, 'Pre-mRNA-splicing factor rse1, variant', NULL, NULL, NULL, NULL, NULL, 4),
(22595, NULL, 'G3DSA:3.80.10.10:FF:002165', NULL, NULL, 'F-box protein', NULL, NULL, NULL, NULL, NULL, 4),
(22596, NULL, 'G3DSA:4.10.400.10:FF:000371', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22597, NULL, 'G3DSA:1.10.10.60:FF:001018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22598, NULL, 'G3DSA:1.10.510.10:FF:002009', NULL, NULL, 'CDK16 isoform 6', NULL, NULL, NULL, NULL, NULL, 4),
(22599, NULL, 'G3DSA:3.90.70.10:FF:000392', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(22600, NULL, 'G3DSA:1.10.472.10:FF:000554', NULL, NULL, 'Cyclin B2', NULL, NULL, NULL, NULL, NULL, 4),
(22601, NULL, 'G3DSA:3.90.1150.10:FF:000465', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(22602, NULL, 'G3DSA:3.60.130.10:FF:000011', NULL, NULL, 'Taurine catabolism dioxygenase TauD', NULL, NULL, NULL, NULL, NULL, 4),
(22603, NULL, 'G3DSA:3.40.309.10:FF:000026', NULL, NULL, 'Aldehyde dehydrogenase 22A1', NULL, NULL, NULL, NULL, NULL, 4),
(22604, NULL, 'G3DSA:3.40.50.300:FF:000467', NULL, NULL, 'ATP-binding cassette sub-family F member 2', NULL, NULL, NULL, NULL, NULL, 4),
(22605, NULL, 'G3DSA:1.10.510.10:FF:003302', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22606, NULL, 'G3DSA:2.170.8.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22607, NULL, 'G3DSA:3.30.450.20:FF:000308', NULL, NULL, 'Sporulation-specific ATP-dependent proteinhistidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(22608, NULL, 'G3DSA:3.80.10.10:FF:001889', NULL, NULL, 'Leucine rich repeat containing G protein-coupled receptor 6', NULL, NULL, NULL, NULL, NULL, 4),
(22609, NULL, 'G3DSA:1.20.950.20:FF:000019', NULL, NULL, 'Ni/Fe-hydrogenase, b-type cytochrome subunit', NULL, NULL, NULL, NULL, NULL, 4),
(22610, NULL, 'G3DSA:3.90.1280.20:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22611, NULL, 'G3DSA:2.60.220.50:FF:000101', NULL, NULL, 'Adhesion G protein-coupled receptor G7, tandem duplicate 2', NULL, NULL, NULL, NULL, NULL, 4),
(22612, NULL, 'G3DSA:3.30.1370.10:FF:000046', NULL, NULL, 'High density lipoprotein binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(22613, NULL, 'G3DSA:3.90.360.10:FF:000021', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(22614, NULL, 'G3DSA:3.80.10.10:FF:002513', NULL, NULL, 'Leucine-rich repeat-containing G-protein coupled receptor 5-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(22615, NULL, 'G3DSA:3.40.50.410:FF:000045', NULL, NULL, 'general transcription factor IIH subunit 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(22616, NULL, 'G3DSA:2.60.40.640:FF:000049', NULL, NULL, 'Arrestin domain-containing protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(22617, NULL, 'G3DSA:2.60.40.4270:FF:000001', NULL, NULL, 'Internalin A', NULL, NULL, NULL, NULL, NULL, 4),
(22618, NULL, 'G3DSA:2.60.40.10:FF:001400', NULL, NULL, 'Titin a', NULL, NULL, NULL, NULL, NULL, 4),
(22619, NULL, 'G3DSA:3.80.10.10:FF:001546', NULL, NULL, 'Cyclic nucleotide-binding domain protein (AFU_orthologue AFUA_2G03170)', NULL, NULL, NULL, NULL, NULL, 4),
(22620, NULL, 'G3DSA:3.20.180.20:FF:000043', NULL, NULL, 'Si:dkey-11m19.5', NULL, NULL, NULL, NULL, NULL, 4),
(22621, NULL, 'G3DSA:3.90.1100.10:FF:000063', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(22622, NULL, 'G3DSA:2.40.100.10:FF:000040', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase B', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(22623, NULL, 'G3DSA:1.25.40.10:FF:002006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22624, NULL, 'G3DSA:3.30.390.50:FF:000020', NULL, NULL, 'Xanthine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(22625, NULL, 'G3DSA:3.40.50.2020:FF:000038', NULL, NULL, 'Hypoxanthine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(22626, NULL, 'G3DSA:1.20.144.10:FF:000138', NULL, NULL, 'Putative phosphatidate phosphatase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(22627, NULL, 'G3DSA:1.10.10.10:FF:000071', NULL, NULL, 'Forkhead box F1', NULL, NULL, NULL, NULL, NULL, 4),
(22628, NULL, 'G3DSA:2.60.40.790:FF:000196', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22629, NULL, 'G3DSA:3.40.50.150:FF:000057', NULL, NULL, 'O-methyltransferase ZRP4', NULL, NULL, NULL, NULL, NULL, 4),
(22630, NULL, 'G3DSA:1.10.8.270:FF:000186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22631, NULL, 'G3DSA:2.40.30.10:FF:000321', NULL, NULL, 'tRNA-specific 2-thiouridylase MnmA 1', NULL, NULL, NULL, NULL, NULL, 4),
(22632, NULL, 'G3DSA:3.40.47.10:FF:000014', NULL, NULL, 'Chalcone synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(22633, NULL, 'G3DSA:1.10.1200.80:FF:000010', NULL, NULL, 'tRNA-dihydrouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(22634, NULL, 'G3DSA:2.60.210.10:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22635, NULL, 'G3DSA:1.20.900.10:FF:000070', NULL, NULL, 'FERM domain (Protein4.1-ezrin-radixin-moesin) family', NULL, NULL, NULL, NULL, NULL, 4),
(22636, NULL, 'G3DSA:1.10.287.370:FF:000040', NULL, NULL, 'PREFOLDIN 1', NULL, NULL, NULL, NULL, NULL, 4),
(22637, NULL, 'G3DSA:2.10.109.10:FF:000049', NULL, NULL, 'Putative RulA protein', NULL, NULL, NULL, NULL, NULL, 4),
(22638, NULL, 'G3DSA:3.40.50.300:FF:004525', NULL, NULL, 'WGS project CABT00000000 data, contig 2.23', NULL, NULL, NULL, NULL, NULL, 4),
(22639, NULL, 'G3DSA:2.60.40.10:FF:000776', NULL, NULL, 'Platelet-derived growth factor receptor alpha', NULL, NULL, NULL, NULL, NULL, 4),
(22640, NULL, 'G3DSA:3.40.50.1240:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22641, NULL, 'G3DSA:1.10.20.10:FF:000026', NULL, NULL, 'Histone H2A', NULL, NULL, NULL, NULL, NULL, 4),
(22642, NULL, 'G3DSA:2.10.25.10:FF:000271', NULL, NULL, 'Terribly reduced optic lobes, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(22643, NULL, 'G3DSA:3.20.20.105:FF:000007', NULL, NULL, 'Queuine tRNA-ribosyltransferase accessory subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(22644, NULL, 'G3DSA:2.60.40.1730:FF:000020', NULL, NULL, 'Transcription initiation factor TFIId 127kD subunit', NULL, NULL, NULL, NULL, NULL, 4),
(22645, NULL, 'G3DSA:3.40.50.2300:FF:001319', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22646, NULL, 'G3DSA:3.40.190.10:FF:000558', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(22647, NULL, 'G3DSA:1.10.10.60:FF:000057', NULL, NULL, 'Short stature homeobox 2', NULL, NULL, NULL, NULL, NULL, 4),
(22648, NULL, 'G3DSA:1.10.510.10:FF:001048', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(22649, NULL, 'G3DSA:1.10.418.10:FF:000153', NULL, NULL, 'Sperm antigen with calponin homology and coiled-coil domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(22650, NULL, 'G3DSA:3.30.565.10:FF:000049', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(22651, NULL, 'G3DSA:3.40.50.970:FF:000191', NULL, NULL, 'Sulfite reductase [NADPH] subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(22652, NULL, 'G3DSA:4.10.860.120:FF:000023', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(22653, NULL, 'G3DSA:3.30.160.60:FF:000776', NULL, NULL, 'Zinc finger protein 639', NULL, NULL, NULL, NULL, NULL, 4),
(22654, NULL, 'G3DSA:3.30.70.3250:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22655, NULL, 'G3DSA:3.30.160.60:FF:005992', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22656, NULL, 'G3DSA:3.40.50.720:FF:001892', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(22657, NULL, 'G3DSA:3.30.200.20:FF:002409', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22658, NULL, 'G3DSA:1.25.40.10:FF:004479', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22659, NULL, 'G3DSA:2.30.36.70:FF:000009', NULL, NULL, 'AGAP008687-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(22660, NULL, 'G3DSA:1.10.10.60:FF:000861', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22661, NULL, 'G3DSA:3.40.50.150:FF:000950', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22662, NULL, 'G3DSA:3.90.190.10:FF:000530', NULL, NULL, 'Receptor tyrosine phosphatase type r2b, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22663, NULL, 'G3DSA:3.30.160.60:FF:001265', NULL, NULL, 'Zinc finger protein 366', NULL, NULL, NULL, NULL, NULL, 4),
(22664, NULL, 'G3DSA:3.30.930.10:FF:000112', NULL, NULL, 'Histidine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(22665, NULL, 'G3DSA:1.10.510.10:FF:004364', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22666, NULL, 'G3DSA:2.70.98.10:FF:000060', NULL, NULL, 'Glycoside hydrolase family 92 protein', NULL, NULL, NULL, NULL, NULL, 4),
(22667, NULL, 'G3DSA:3.90.550.10:FF:000755', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(22668, NULL, 'G3DSA:3.40.50.300:FF:000254', NULL, NULL, 'U5 small nuclear ribonucleoprotein helicase', NULL, NULL, NULL, NULL, NULL, 4),
(22669, NULL, 'G3DSA:2.60.40.10:FF:004486', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22670, NULL, 'G3DSA:3.30.200.20:FF:000037', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(22671, NULL, 'G3DSA:3.40.50.1110:FF:000097', NULL, NULL, 'GD23360', NULL, NULL, NULL, NULL, NULL, 4),
(22672, NULL, 'G3DSA:1.20.140.70:FF:000001', NULL, NULL, 'Oligoendopeptidase F', NULL, NULL, NULL, NULL, NULL, 4),
(22673, NULL, 'G3DSA:1.25.40.10:FF:004928', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22674, NULL, 'G3DSA:3.40.50.300:FF:005470', NULL, NULL, 'ATP-dependent RNA helicase DeaD', NULL, NULL, NULL, NULL, NULL, 4),
(22675, NULL, 'G3DSA:2.60.120.200:FF:000152', NULL, NULL, 'Cell wall glucanase', NULL, NULL, NULL, NULL, NULL, 4),
(22676, NULL, 'G3DSA:3.30.160.60:FF:006161', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22677, NULL, 'G3DSA:1.20.58.340:FF:000081', NULL, NULL, 'Magnesium transporter MRS2-6, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(22678, NULL, 'G3DSA:2.170.270.10:FF:000015', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(22679, NULL, 'G3DSA:3.40.50.12160:FF:000027', NULL, NULL, 'RNA modification enzyme, MiaB family', NULL, NULL, NULL, NULL, NULL, 4),
(22680, NULL, 'G3DSA:3.30.450.60:FF:000079', NULL, NULL, 'Zeta-coat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22681, NULL, 'G3DSA:3.30.70.20:FF:000116', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22682, NULL, 'G3DSA:2.130.10.10:FF:005649', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22683, NULL, 'G3DSA:3.30.70.1070:FF:000014', NULL, NULL, 'Endolytic peptidoglycan transglycosylase RlpA', NULL, NULL, NULL, NULL, NULL, 4),
(22684, NULL, 'G3DSA:3.40.50.1820:FF:000085', NULL, NULL, '2-hydroxy-6-oxononadienedioate/2-hydroxy-6-oxononatrienedioate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(22685, NULL, 'G3DSA:3.40.630.60:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22686, NULL, 'G3DSA:3.40.190.10:FF:000108', NULL, NULL, 'melanotransferrin', NULL, NULL, NULL, NULL, NULL, 4),
(22687, NULL, 'G3DSA:3.30.450.40:FF:000073', NULL, NULL, 'Stage II sporulation protein E', NULL, NULL, NULL, NULL, NULL, 4),
(22688, NULL, 'G3DSA:2.90.10.10:FF:000014', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(22689, NULL, 'G3DSA:3.70.10.10:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22690, NULL, 'G3DSA:1.10.357.90:FF:000006', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(22691, NULL, 'G3DSA:1.10.287.130:FF:000215', NULL, NULL, 'Sensory box histidine kinase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(22692, NULL, 'G3DSA:3.10.100.10:FF:000436', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22693, NULL, 'G3DSA:3.30.310.80:FF:000018', NULL, NULL, 'Serine/threonine-protein kinase grp', NULL, NULL, NULL, NULL, NULL, 4),
(22694, NULL, 'G3DSA:2.40.50.100:FF:000057', NULL, NULL, 'Exosome complex component CSL4', NULL, NULL, NULL, NULL, NULL, 4),
(22695, NULL, 'G3DSA:2.60.120.290:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22696, NULL, 'G3DSA:3.20.20.80:FF:000244', NULL, NULL, 'O-Glycosyl hydrolases family 17 protein', NULL, NULL, NULL, NULL, NULL, 4),
(22697, NULL, 'G3DSA:1.20.1560.10:FF:000132', NULL, NULL, 'ABC transporter B family member 5', NULL, NULL, NULL, NULL, NULL, 4),
(22698, NULL, 'G3DSA:3.30.830.10:FF:000060', NULL, NULL, 'Putative mitochondrial processing peptidase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(22699, NULL, 'G3DSA:2.60.40.60:FF:000751', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(22700, NULL, 'G3DSA:3.10.129.10:FF:000069', NULL, NULL, '4-hydroxybenzoyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(22701, NULL, 'G3DSA:2.60.40.150:FF:000796', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22702, NULL, 'G3DSA:1.10.287.40:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22703, NULL, 'G3DSA:3.40.50.2300:FF:000583', NULL, NULL, 'Gamma-glutamyltranspeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(22704, NULL, 'G3DSA:1.10.472.10:FF:000323', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22705, NULL, 'G3DSA:3.40.50.12440:FF:000004', NULL, NULL, 'Anaerobic dimethyl sulfoxide reductase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(22706, NULL, 'G3DSA:1.10.150.560:FF:000002', NULL, NULL, 'Major DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(22707, NULL, 'G3DSA:3.40.30.10:FF:000830', NULL, NULL, 'Protein disulfide-isomerase 5-2 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(22708, NULL, 'G3DSA:1.10.3720.10:FF:000074', NULL, NULL, 'Glycerol-3-phosphate ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(22709, NULL, 'G3DSA:3.40.50.300:FF:004519', NULL, NULL, 'DEAD-box ATP-dependent RNA helicase 1', NULL, NULL, NULL, NULL, NULL, 4),
(22710, NULL, 'G3DSA:3.40.50.200:FF:000100', NULL, NULL, 'Nucleobase-ascorbate transporter 12', NULL, NULL, NULL, NULL, NULL, 4),
(22711, NULL, 'G3DSA:3.75.10.10:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22712, NULL, 'G3DSA:2.60.40.1360:FF:000004', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(22713, NULL, 'G3DSA:3.30.470.30:FF:000083', NULL, NULL, 'Putative DNA ligase 4', NULL, NULL, NULL, NULL, NULL, 4),
(22714, NULL, 'G3DSA:3.40.50.1000:FF:000283', NULL, NULL, 'Phosphoserine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(22715, NULL, 'G3DSA:3.80.10.10:FF:000260', NULL, NULL, 'F-box/LRR-repeat protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(22716, NULL, 'G3DSA:2.60.40.10:FF:005104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22717, NULL, 'G3DSA:2.40.50.140:FF:000507', NULL, NULL, 'Os09g0560200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(22718, NULL, 'G3DSA:3.30.505.10:FF:000170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22719, NULL, 'G3DSA:1.10.150.120:FF:000005', NULL, NULL, 'Aldehyde dehydrogenase iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4),
(22720, NULL, 'G3DSA:3.40.50.2300:FF:000690', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22721, NULL, 'G3DSA:3.30.200.20:FF:001448', NULL, NULL, 'CAMK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(22722, NULL, 'G3DSA:3.40.1380.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22723, NULL, 'G3DSA:1.10.3210.10:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22724, NULL, 'G3DSA:1.10.10.60:FF:000529', NULL, NULL, 'upstream activation factor subunit spp27', NULL, NULL, NULL, NULL, NULL, 4),
(22725, NULL, 'G3DSA:2.60.40.2860:FF:000027', NULL, NULL, 'Transmission-blocking target antigen s230', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(22726, NULL, 'G3DSA:3.30.160.60:FF:002794', NULL, NULL, 'Zinc finger protein 1060', NULL, NULL, NULL, NULL, NULL, 4),
(22727, NULL, 'G3DSA:3.10.110.10:FF:000026', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 variant', NULL, NULL, NULL, NULL, NULL, 4),
(22728, NULL, 'G3DSA:1.20.58.1770:FF:000002', NULL, NULL, 'RILP-like protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(22729, NULL, 'G3DSA:2.60.120.290:FF:000015', NULL, NULL, 'Seizure protein 6 homolog isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(22730, NULL, 'G3DSA:3.30.300.30:FF:000082', NULL, NULL, 'Putative long-chain-fatty-acid-CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(22731, NULL, 'G3DSA:3.30.2010.10:FF:000014', NULL, NULL, 'Peptidase M48 Ste24p', NULL, NULL, NULL, NULL, NULL, 4),
(22732, NULL, 'G3DSA:2.40.30.330:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22733, NULL, 'G3DSA:2.120.10.30:FF:000384', NULL, NULL, 'Vitellogenin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(22734, NULL, 'G3DSA:2.130.10.10:FF:000181', NULL, NULL, 'Proteasomal ATPase associated factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(22735, NULL, 'G3DSA:1.20.1050.10:FF:000161', NULL, NULL, 'Glutathione S-transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22736, NULL, 'G3DSA:2.130.10.130:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22737, NULL, 'G3DSA:1.10.510.10:FF:002453', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22738, NULL, 'G3DSA:3.30.70.330:FF:002298', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22739, NULL, 'G3DSA:3.90.70.10:FF:000167', NULL, NULL, 'Ubiquitin specific peptidase 18', NULL, NULL, NULL, NULL, NULL, 4),
(22740, NULL, 'G3DSA:3.40.50.720:FF:001442', NULL, NULL, 'PKS-NRPS hybrid synthetase psoA', NULL, NULL, NULL, NULL, NULL, 4),
(22741, NULL, 'G3DSA:2.60.40.10:FF:005997', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22742, NULL, 'G3DSA:2.60.40.10:FF:001506', NULL, NULL, 'semaphorin-2A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(22743, NULL, 'G3DSA:3.40.50.150:FF:000169', NULL, NULL, 'Tellurite resistance methyltransferase TehB', NULL, NULL, NULL, NULL, NULL, 4),
(22744, NULL, 'G3DSA:2.60.40.10:FF:000888', NULL, NULL, 'Roundabout guidance receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(22745, NULL, 'G3DSA:3.30.420.40:FF:000245', NULL, NULL, 'Heat shock protein 70 putative', NULL, NULL, NULL, NULL, NULL, 4),
(22746, NULL, 'G3DSA:2.10.25.10:FF:001451', NULL, NULL, 'Neurogenic locus notch homolog protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(22747, NULL, 'G3DSA:3.50.50.60:FF:000166', NULL, NULL, 'Squalene monooxygenase Erg1', NULL, NULL, NULL, NULL, NULL, 4),
(22748, NULL, 'G3DSA:3.30.70.330:FF:001792', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22749, NULL, 'G3DSA:1.10.506.10:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22750, NULL, 'G3DSA:3.30.160.330:FF:000002', NULL, NULL, 'Protein E7', NULL, NULL, NULL, NULL, NULL, 4),
(22751, NULL, 'G3DSA:2.70.40.10:FF:000005', NULL, NULL, 'dCTP deaminase, dUMP-forming', NULL, NULL, NULL, NULL, NULL, 4),
(22752, NULL, 'G3DSA:3.50.50.60:FF:001003', NULL, NULL, 'Dihydropyrimidine dehydrogenase [NADP(+)]-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(22753, NULL, 'G3DSA:1.20.1070.10:FF:001792', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(22754, NULL, 'G3DSA:2.60.40.60:FF:000419', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22755, NULL, 'G3DSA:1.10.10.200:FF:000011', NULL, NULL, 'Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(22756, NULL, 'G3DSA:3.30.519.10:FF:000016', NULL, NULL, 'RAB GDP-dissociation inhibitor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22757, NULL, 'G3DSA:3.30.1010.10:FF:000103', NULL, NULL, 'UVSB', NULL, NULL, NULL, NULL, NULL, 4),
(22758, NULL, 'G3DSA:1.10.3260.10:FF:000050', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(22759, NULL, 'G3DSA:3.40.50.300:FF:008123', NULL, NULL, 'Cytoplasmic dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(22760, NULL, 'G3DSA:3.50.50.60:FF:000059', NULL, NULL, 'polyamine oxidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(22761, NULL, 'G3DSA:3.30.50.10:FF:000112', NULL, NULL, 'GATA zinc finger domain-containing protein C1393.08', NULL, NULL, NULL, NULL, NULL, 4),
(22762, NULL, 'G3DSA:3.30.160.60:FF:000646', NULL, NULL, 'Myeloid zinc finger 1', NULL, NULL, NULL, NULL, NULL, 4),
(22763, NULL, 'G3DSA:1.20.58.1480:FF:000016', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(22764, NULL, 'G3DSA:3.30.565.10:FF:000179', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(22765, NULL, 'G3DSA:2.130.10.10:FF:004452', NULL, NULL, 'General transcription factor IIIC, polypeptide 2, beta', NULL, NULL, NULL, NULL, NULL, 4),
(22766, NULL, 'G3DSA:2.40.30.170:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22767, NULL, 'G3DSA:2.60.11.10:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22768, NULL, 'G3DSA:3.40.50.620:FF:000670', NULL, NULL, 'Bifunctional riboflavin kinase/FMN adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(22769, NULL, 'G3DSA:2.40.10.340:FF:000014', NULL, NULL, 'Cell shape-determining protein MreC', NULL, NULL, NULL, NULL, NULL, 4),
(22770, NULL, 'G3DSA:3.30.420.40:FF:001083', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(22771, NULL, 'G3DSA:2.60.40.10:FF:003867', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22772, NULL, 'G3DSA:3.40.710.10:FF:000189', NULL, NULL, 'Lpc53E1', NULL, NULL, NULL, NULL, NULL, 4),
(22773, NULL, 'G3DSA:3.90.79.10:FF:000035', NULL, NULL, 'Uridine diphosphate glucose pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(22774, NULL, 'G3DSA:1.20.1310.10:FF:000074', NULL, NULL, 'Cullin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(22775, NULL, 'G3DSA:3.60.21.10:FF:000454', NULL, NULL, '2`,3`-cyclic-nucleotide 2`-phosphodiesterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22776, NULL, 'G3DSA:1.20.1280.290:FF:000034', NULL, NULL, 'PQ loop repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(22777, NULL, 'G3DSA:2.30.30.40:FF:000167', NULL, NULL, 'SH3 and cysteine-rich domain-containing protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(22778, NULL, 'G3DSA:2.10.25.10:FF:000720', NULL, NULL, 'Multiple EGF like domains 9', NULL, NULL, NULL, NULL, NULL, 4),
(22779, NULL, 'G3DSA:2.30.29.30:FF:000330', NULL, NULL, 'TBC1 (tre-2/USP6, BUB2, cdc16) domain family, member 1', NULL, NULL, NULL, NULL, NULL, 4),
(22780, NULL, 'G3DSA:3.80.10.10:FF:000147', NULL, NULL, 'Erbin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(22781, NULL, 'G3DSA:3.40.50.880:FF:000152', NULL, NULL, '4-methyl-5-thiazole monophosphate biosynthesis enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(22782, NULL, 'G3DSA:3.30.160.60:FF:001158', NULL, NULL, 'zinc finger protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(22783, NULL, 'G3DSA:3.30.200.20:FF:001780', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22784, NULL, 'G3DSA:3.40.50.300:FF:004756', NULL, NULL, 'CTP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(22785, NULL, 'G3DSA:2.60.120.1190:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22786, NULL, 'G3DSA:3.40.50.720:FF:002061', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(22787, NULL, 'G3DSA:3.40.50.2000:FF:000375', NULL, NULL, 'Glycosyltransferase WbpX', NULL, NULL, NULL, NULL, NULL, 4),
(22788, NULL, 'G3DSA:3.30.160.60:FF:004935', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22789, NULL, 'G3DSA:1.20.5.110:FF:000259', NULL, NULL, 'Synaptobrevin 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(22790, NULL, 'G3DSA:1.20.80.10:FF:000046', NULL, NULL, 'Protein CBG13772', NULL, NULL, NULL, NULL, NULL, 4),
(22791, NULL, 'G3DSA:1.20.272.10:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22792, NULL, 'G3DSA:3.40.50.620:FF:000338', NULL, NULL, 'Leucine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(22793, NULL, 'G3DSA:3.30.70.260:FF:000124', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(22794, NULL, 'G3DSA:3.30.910.20:FF:000007', NULL, NULL, 'Cationic outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(22795, NULL, 'G3DSA:3.10.129.10:FF:000176', NULL, NULL, 'Acyl-[acyl-carrier-protein] hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(22796, NULL, 'G3DSA:1.10.10.60:FF:000170', NULL, NULL, 'Transcriptional adapter', NULL, NULL, NULL, NULL, NULL, 4),
(22797, NULL, 'G3DSA:3.40.50.720:FF:000037', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] reductase FabG', NULL, NULL, NULL, NULL, NULL, 4),
(22798, NULL, 'G3DSA:3.10.20.90:FF:000219', NULL, NULL, 'E3 ubiquitin-protein ligase RING1', NULL, NULL, NULL, NULL, NULL, 4),
(22799, NULL, 'G3DSA:1.25.40.20:FF:001374', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(22800, NULL, 'G3DSA:2.40.70.10:FF:000099', NULL, NULL, 'Putative aspartyl protease', NULL, NULL, NULL, NULL, NULL, 4),
(22801, NULL, 'G3DSA:3.30.230.70:FF:000071', NULL, NULL, 'GM01970p', NULL, NULL, NULL, NULL, NULL, 4),
(22802, NULL, 'G3DSA:1.25.40.10:FF:001949', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22803, NULL, 'G3DSA:1.25.40.10:FF:002113', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(22804, NULL, 'G3DSA:3.30.200.20:FF:000829', NULL, NULL, 'CAMK/CDPK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(22805, NULL, 'G3DSA:1.10.287.950:FF:000017', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(22806, NULL, 'G3DSA:3.30.160.60:FF:003176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22807, NULL, 'G3DSA:1.25.10.10:FF:000363', NULL, NULL, 'Nuclear condensin complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(22808, NULL, 'G3DSA:2.120.10.30:FF:000260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22809, NULL, 'G3DSA:1.10.510.10:FF:000997', NULL, NULL, 'Kinase, AGC NDR', NULL, NULL, NULL, NULL, NULL, 4),
(22810, NULL, 'G3DSA:1.20.1740.10:FF:000230', NULL, NULL, 'Amino acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(22811, NULL, 'G3DSA:3.30.40.10:FF:000522', NULL, NULL, 'RING-H2 finger protein ATL5', NULL, NULL, NULL, NULL, NULL, 4),
(22812, NULL, 'G3DSA:3.40.190.10:FF:000215', NULL, NULL, 'Peptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(22813, NULL, 'G3DSA:3.90.550.10:FF:000176', NULL, NULL, 'Cellulose synthase-like protein B3', NULL, NULL, NULL, NULL, NULL, 4),
(22814, NULL, 'G3DSA:3.80.10.10:FF:002401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22815, NULL, 'G3DSA:3.40.720.10:FF:000021', NULL, NULL, 'Galactosamine (N-acetyl)-6-sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(22816, NULL, 'G3DSA:1.20.144.10:FF:000008', NULL, NULL, 'Phosphatidylglycerophosphatase B', NULL, NULL, NULL, NULL, NULL, 4),
(22817, NULL, 'G3DSA:3.60.20.40:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22818, NULL, 'G3DSA:3.40.630.10:FF:000244', NULL, NULL, 'Os03g0836800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(22819, NULL, 'G3DSA:1.20.1640.10:FF:000065', NULL, NULL, 'PaTched Related family', NULL, NULL, NULL, NULL, NULL, 4),
(22820, NULL, 'G3DSA:1.10.640.10:FF:000080', NULL, NULL, 'Oxidase/peroxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22821, NULL, 'G3DSA:3.80.10.10:FF:002058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22822, NULL, 'G3DSA:1.20.120.1920:FF:000004', NULL, NULL, 'GG24751', NULL, NULL, NULL, NULL, NULL, 4),
(22823, NULL, 'G3DSA:3.10.20.90:FF:000770', NULL, NULL, 'Talin', NULL, NULL, NULL, NULL, NULL, 4),
(22824, NULL, 'G3DSA:3.40.47.10:FF:000245', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22825, NULL, 'G3DSA:3.80.10.10:FF:003817', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22826, NULL, 'G3DSA:3.30.565.10:FF:000504', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22827, NULL, 'G3DSA:4.10.400.10:FF:000146', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(22828, NULL, 'G3DSA:3.30.260.10:FF:000044', NULL, NULL, 'T-complex protein 1 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(22829, NULL, 'G3DSA:1.10.10.60:FF:001243', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22830, NULL, 'G3DSA:3.30.200.20:FF:000144', NULL, NULL, 'Cyclin-dependent kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(22831, NULL, 'G3DSA:3.30.590.10:FF:000029', NULL, NULL, 'Creatine kinase, mitochondrial 2b (sarcomeric)', NULL, NULL, NULL, NULL, NULL, 4),
(22832, NULL, 'G3DSA:2.30.30.30:FF:000069', NULL, NULL, '30S ribosomal protein S4e', NULL, NULL, NULL, NULL, NULL, 4),
(22833, NULL, 'G3DSA:3.90.1150.10:FF:000358', NULL, NULL, 'Perosamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(22834, NULL, 'G3DSA:3.80.10.10:FF:001783', NULL, NULL, 'Leucine-rich HEV glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(22835, NULL, 'G3DSA:3.10.20.90:FF:000438', NULL, NULL, 'Plexin-B1', NULL, NULL, NULL, NULL, NULL, 4),
(22836, NULL, 'G3DSA:2.70.130.10:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22837, NULL, 'G3DSA:3.40.50.10810:FF:000201', NULL, NULL, 'SNF2 family DNA-dependent ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(22838, NULL, 'G3DSA:1.20.1690.10:FF:000012', NULL, NULL, 'V-type proton ATPase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(22839, NULL, 'G3DSA:1.10.238.10:FF:000509', NULL, NULL, 'EF-hand calcium-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(22840, NULL, 'G3DSA:2.60.34.10:FF:000048', NULL, NULL, 'Protein CBG02604', NULL, NULL, NULL, NULL, NULL, 4),
(22841, NULL, 'G3DSA:1.25.10.10:FF:001892', NULL, NULL, 'U3 small nucleolar RNA-associated protein 20', NULL, NULL, NULL, NULL, NULL, 4),
(22842, NULL, 'G3DSA:1.20.58.1020:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22843, NULL, 'G3DSA:2.60.40.10:FF:003182', NULL, NULL, 'Insulin-like receptor', NULL, NULL, NULL, NULL, NULL, 4),
(22844, NULL, 'G3DSA:2.130.10.30:FF:000063', NULL, NULL, 'GG11698', NULL, NULL, NULL, NULL, NULL, 4),
(22845, NULL, 'G3DSA:3.30.420.80:FF:000010', NULL, NULL, '30S ribosomal protein S11', NULL, NULL, NULL, NULL, NULL, 4),
(22846, NULL, 'G3DSA:3.30.30.10:FF:000004', NULL, NULL, 'Defensin-like protein CAL1', NULL, NULL, NULL, NULL, NULL, 4),
(22847, NULL, 'G3DSA:1.20.1250.20:FF:000364', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(22848, NULL, 'G3DSA:3.40.50.1820:FF:001607', NULL, NULL, 'Os06g0519700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(22849, NULL, 'G3DSA:1.10.1820.10:FF:000014', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(22850, NULL, 'G3DSA:1.10.510.10:FF:001161', NULL, NULL, 'Os11g0601500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(22851, NULL, 'G3DSA:3.50.50.60:FF:000278', NULL, NULL, 'Polyamine oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(22852, NULL, 'G3DSA:3.20.20.70:FF:000022', NULL, NULL, '3-keto-L-gulonate-6-phosphate decarboxylase UlaD', NULL, NULL, NULL, NULL, NULL, 4),
(22853, NULL, 'G3DSA:1.25.10.10:FF:000144', NULL, NULL, 'rap1 GTPase-GDP dissociation stimulator 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(22854, NULL, 'G3DSA:3.30.1640.10:FF:000022', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(22855, NULL, 'G3DSA:1.20.58.1040:FF:000019', NULL, NULL, 'Beta-1, 3-glucanase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(22856, NULL, 'G3DSA:3.30.930.10:FF:000005', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(22857, NULL, 'G3DSA:1.10.510.10:FF:002234', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22858, NULL, 'G3DSA:1.10.1420.10:FF:000141', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(22859, NULL, 'G3DSA:1.20.1110.10:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22860, NULL, 'G3DSA:1.20.1720.10:FF:000010', NULL, NULL, 'Multidrug resistance protein MdtM', NULL, NULL, NULL, NULL, NULL, 4),
(22861, NULL, 'G3DSA:3.30.40.10:FF:001808', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(22862, NULL, 'G3DSA:3.40.50.720:FF:000930', NULL, NULL, 'Vibriobactin-specific 2,3-dihydro-2,3-dihydroxybenzoate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(22863, NULL, 'G3DSA:1.10.472.10:FF:000447', NULL, NULL, 'Cyclin G1', NULL, NULL, NULL, NULL, NULL, 4),
(22864, NULL, 'G3DSA:3.40.50.10810:FF:000190', NULL, NULL, 'Excision repair cross-complementation group 6-like', NULL, NULL, NULL, NULL, NULL, 4),
(22865, NULL, 'G3DSA:3.10.450.50:FF:000064', NULL, NULL, 'De-ubiquitination complex subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22866, NULL, 'G3DSA:1.10.340.30:FF:000046', NULL, NULL, 'DNA-(Apurinic or apyrimidinic site) lyase', NULL, NULL, NULL, NULL, NULL, 4),
(22867, NULL, 'G3DSA:2.60.40.10:FF:004379', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22868, NULL, 'G3DSA:2.60.40.10:FF:004255', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22869, NULL, 'G3DSA:2.10.25.10:FF:001119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22870, NULL, 'G3DSA:2.40.37.20:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22871, NULL, 'G3DSA:1.10.580.10:FF:000035', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(22872, NULL, 'G3DSA:3.30.200.20:FF:002292', NULL, NULL, 'Uncharacterized protein DR_0394', NULL, NULL, NULL, NULL, NULL, 4),
(22873, NULL, 'G3DSA:1.10.8.270:FF:000079', NULL, NULL, 'Rab GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22874, NULL, 'G3DSA:3.40.109.10:FF:000027', NULL, NULL, 'Nitroreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(22875, NULL, 'G3DSA:3.40.50.720:FF:001661', NULL, NULL, 'Os02g0640600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(22876, NULL, 'G3DSA:3.40.630.30:FF:000469', NULL, NULL, 'GNAT family acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(22877, NULL, 'G3DSA:3.40.50.300:FF:005363', NULL, NULL, 'Structural maintenance of chromosomes 3', NULL, NULL, NULL, NULL, NULL, 4),
(22878, NULL, 'G3DSA:1.20.58.60:FF:000330', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(22879, NULL, 'G3DSA:1.20.1560.10:FF:000929', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(22880, NULL, 'G3DSA:2.160.20.10:FF:000320', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22881, NULL, 'G3DSA:3.30.460.10:FF:000025', NULL, NULL, 'probable GTP diphosphokinase CRSH, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(22882, NULL, 'G3DSA:1.10.20.140:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22883, NULL, 'G3DSA:1.25.40.10:FF:000876', NULL, NULL, 'crooked neck-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(22884, NULL, 'G3DSA:3.30.70.330:FF:001573', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22885, NULL, 'G3DSA:2.40.50.40:FF:000084', NULL, NULL, 'Interleukin-8', NULL, NULL, NULL, NULL, NULL, 4),
(22886, NULL, 'G3DSA:1.50.40.10:FF:000576', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22887, NULL, 'G3DSA:1.10.10.10:FF:001144', NULL, NULL, 'Molybdenum transport operon repressor MopA', NULL, NULL, NULL, NULL, NULL, 4),
(22888, NULL, 'G3DSA:2.40.128.130:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22889, NULL, 'G3DSA:3.30.2090.10:FF:000007', NULL, NULL, 'Efflux pump membrane transporter', NULL, NULL, NULL, NULL, NULL, 4),
(22890, NULL, 'G3DSA:2.70.150.10:FF:000165', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(22891, NULL, 'G3DSA:2.70.170.10:FF:000178', NULL, NULL, 'Glycine receptor alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(22892, NULL, 'G3DSA:3.30.450.40:FF:000197', NULL, NULL, 'Polyketide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(22893, NULL, 'G3DSA:3.30.70.2000:FF:000001', NULL, NULL, 'Potassium channel tetramerization domain-containing 17', NULL, NULL, NULL, NULL, NULL, 4),
(22894, NULL, 'G3DSA:1.25.40.990:FF:000007', NULL, NULL, 'SAC3 domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(22895, NULL, 'G3DSA:3.10.330.10:FF:000026', NULL, NULL, 'ATPase of the AAA+ class Posttranslational modification protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(22896, NULL, 'G3DSA:2.130.10.10:FF:001254', NULL, NULL, 'BnaC01g39200D protein', NULL, NULL, NULL, NULL, NULL, 4),
(22897, NULL, 'G3DSA:2.60.40.10:FF:000669', NULL, NULL, 'Vascular endothelial growth factor receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(22898, NULL, 'G3DSA:3.30.420.40:FF:000026', NULL, NULL, 'Heat shock protein 70', NULL, NULL, NULL, NULL, NULL, 4),
(22899, NULL, 'G3DSA:1.20.120.1750:FF:000150', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(22900, NULL, 'G3DSA:1.10.10.10:FF:000868', NULL, NULL, 'ECF RNA polymerase sigma factor SigK', NULL, NULL, NULL, NULL, NULL, 4),
(22901, NULL, 'G3DSA:1.25.70.10:FF:000029', NULL, NULL, 'Os05g0403600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(22902, NULL, 'G3DSA:3.20.20.70:FF:000707', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22903, NULL, 'G3DSA:3.30.40.10:FF:000741', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(22904, NULL, 'G3DSA:1.10.287.110:FF:000333', NULL, NULL, 'Mitochondrial import inner membrane translocase subunit TIM16', NULL, NULL, NULL, NULL, NULL, 4),
(22905, NULL, 'G3DSA:3.10.310.20:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22906, NULL, 'G3DSA:3.40.50.300:FF:003452', NULL, NULL, '26S protease regulatory subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(22907, NULL, 'G3DSA:3.40.250.10:FF:000041', NULL, NULL, 'Sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(22908, NULL, 'G3DSA:1.25.40.10:FF:000191', NULL, NULL, 'Signal recognition particle subunit SRP72', NULL, NULL, NULL, NULL, NULL, 4),
(22909, NULL, 'G3DSA:3.30.1460.50:FF:000019', NULL, NULL, 'Autophagy-related protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(22910, NULL, 'G3DSA:1.25.40.510:FF:000010', NULL, NULL, 'Nucleoporin GLE1', NULL, NULL, NULL, NULL, NULL, 4),
(22911, NULL, 'G3DSA:2.30.30.40:FF:000622', NULL, NULL, 'Src kinase associated phosphoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(22912, NULL, 'G3DSA:3.30.160.60:FF:001501', NULL, NULL, 'Zinc finger protein 483', NULL, NULL, NULL, NULL, NULL, 4),
(22913, NULL, 'G3DSA:1.10.287.90:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22914, NULL, 'G3DSA:1.10.20.10:FF:000133', NULL, NULL, 'Dls1p', NULL, NULL, NULL, NULL, NULL, 4),
(22915, NULL, 'G3DSA:2.60.40.10:FF:005216', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22916, NULL, 'G3DSA:1.20.1050.10:FF:000267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22917, NULL, 'G3DSA:2.130.10.10:FF:000978', NULL, NULL, 'U3 small nucleolar RNA-associated protein 15 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(22918, NULL, 'G3DSA:2.70.70.10:FF:000070', NULL, NULL, 'Peptidase M23B', NULL, NULL, NULL, NULL, NULL, 4),
(22919, NULL, 'G3DSA:3.60.15.10:FF:000182', NULL, NULL, 'Acylhomoserine lactonase', NULL, NULL, NULL, NULL, NULL, 4),
(22920, NULL, 'G3DSA:1.20.120.1900:FF:000009', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(22921, NULL, 'G3DSA:2.30.180.10:FF:000081', NULL, NULL, 'Fasciclin domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(22922, NULL, 'G3DSA:3.30.450.20:FF:000191', NULL, NULL, 'Two-component system sensor', NULL, NULL, NULL, NULL, NULL, 4),
(22923, NULL, 'G3DSA:3.10.450.710:FF:000001', NULL, NULL, 'ABC transporter substrate-binding protein MlaC', NULL, NULL, NULL, NULL, NULL, 4),
(22924, NULL, 'G3DSA:2.40.50.140:FF:000726', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22925, NULL, 'G3DSA:3.40.50.2300:FF:000471', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22926, NULL, 'G3DSA:3.30.1600.10:FF:000025', NULL, NULL, 'Sirtuin type 2', NULL, NULL, NULL, NULL, NULL, 4),
(22927, NULL, 'G3DSA:3.40.1410.10:FF:000031', NULL, NULL, 'Probable chorismate pyruvate-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(22928, NULL, 'G3DSA:3.30.40.10:FF:001247', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(22929, NULL, 'G3DSA:2.60.40.10:FF:002563', NULL, NULL, 'Neural cell adhesion molecule L1', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(22930, NULL, 'G3DSA:1.10.8.60:FF:000202', NULL, NULL, 'Putative conserved atpase', NULL, NULL, NULL, NULL, NULL, 4),
(22931, NULL, 'G3DSA:1.10.357.20:FF:000025', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(22932, NULL, 'G3DSA:2.60.200.20:FF:000091', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22933, NULL, 'G3DSA:3.40.390.10:FF:000107', NULL, NULL, 'Extracellular metalloprotease 1', NULL, NULL, NULL, NULL, NULL, 4),
(22934, NULL, 'G3DSA:3.30.160.60:FF:002338', NULL, NULL, 'Zinc finger, imprinted 1', NULL, NULL, NULL, NULL, NULL, 4),
(22935, NULL, 'G3DSA:1.10.1170.10:FF:000048', NULL, NULL, 'baculoviral IAP repeat-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(22936, NULL, 'G3DSA:3.40.50.1820:FF:000321', NULL, NULL, 'Lipase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(22937, NULL, 'G3DSA:2.60.40.10:FF:005559', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22938, NULL, 'G3DSA:3.30.60.30:FF:000170', NULL, NULL, 'Agr-1', NULL, NULL, NULL, NULL, NULL, 4),
(22939, NULL, 'G3DSA:3.90.1750.10:FF:000106', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(22940, NULL, 'G3DSA:3.40.525.10:FF:000005', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type 9', NULL, NULL, NULL, NULL, NULL, 4),
(22941, NULL, 'G3DSA:2.60.40.1180:FF:000158', NULL, NULL, 'Glycoside hydrolase superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(22942, NULL, 'G3DSA:3.40.630.20:FF:000028', NULL, NULL, 'Pyroglutamyl-peptidase I (C15 family)', NULL, NULL, NULL, NULL, NULL, 4),
(22943, NULL, 'G3DSA:3.30.470.160:FF:000010', NULL, NULL, 'Kinase', NULL, NULL, NULL, NULL, NULL, 4),
(22944, NULL, 'G3DSA:1.25.40.10:FF:003861', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22945, NULL, 'G3DSA:3.20.20.100:FF:000024', NULL, NULL, 'Aryl-alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(22946, NULL, 'G3DSA:2.40.50.150:FF:000044', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(22947, NULL, 'G3DSA:3.30.160.60:FF:003631', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22948, NULL, 'G3DSA:1.10.10.60:FF:000967', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22949, NULL, 'G3DSA:2.130.10.10:FF:003738', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22950, NULL, 'G3DSA:1.25.40.530:FF:000016', NULL, NULL, 'Myosin 10A, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(22951, NULL, 'G3DSA:3.40.1090.10:FF:000151', NULL, NULL, 'Phospholipase A2', NULL, NULL, NULL, NULL, NULL, 4),
(22952, NULL, 'G3DSA:1.10.530.10:FF:000088', NULL, NULL, 'Lysozyme like 4', NULL, NULL, NULL, NULL, NULL, 4),
(22953, NULL, 'G3DSA:2.170.120.12:FF:000018', NULL, NULL, 'DNA-directed RNA polymerase RPB3', NULL, NULL, NULL, NULL, NULL, 4),
(22954, NULL, 'G3DSA:3.30.70.330:FF:002192', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22955, NULL, 'G3DSA:3.40.30.10:FF:000936', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(22956, NULL, 'G3DSA:2.130.10.10:FF:002890', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22957, NULL, 'G3DSA:3.40.30.10:FF:000594', NULL, NULL, 'GD16632', NULL, NULL, NULL, NULL, NULL, 4),
(22958, NULL, 'G3DSA:3.30.160.60:FF:003974', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22959, NULL, 'G3DSA:1.20.58.60:FF:000779', NULL, NULL, 'Spectrin repeat containing nuclear envelope protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(22960, NULL, 'G3DSA:1.10.565.10:FF:000011', NULL, NULL, 'Nuclear receptor subfamily 5, group A, member 2', NULL, NULL, NULL, NULL, NULL, 4),
(22961, NULL, 'G3DSA:3.30.160.60:FF:006380', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22962, NULL, 'G3DSA:1.10.10.10:FF:000525', NULL, NULL, 'Z-DNA binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(22963, NULL, 'G3DSA:1.10.132.130:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22964, NULL, 'G3DSA:1.20.1530.20:FF:000077', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(22965, NULL, 'G3DSA:1.10.10.10:FF:002105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22966, NULL, 'G3DSA:3.30.70.1230:FF:000085', NULL, NULL, 'Adenylate/guanylate cyclase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(22967, NULL, 'G3DSA:3.30.710.10:FF:000461', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22968, NULL, 'G3DSA:3.40.50.1390:FF:000023', NULL, NULL, 'Sll0177 protein', NULL, NULL, NULL, NULL, NULL, 4),
(22969, NULL, 'G3DSA:3.90.1170.50:FF:000012', NULL, NULL, 'Gad-3', NULL, NULL, NULL, NULL, NULL, 4),
(22970, NULL, 'G3DSA:3.30.1330.10:FF:000032', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase subunit PurL', NULL, NULL, NULL, NULL, NULL, 4),
(22971, NULL, 'G3DSA:4.10.800.10:FF:000019', NULL, NULL, 'Proteoglycan Cow', NULL, NULL, NULL, NULL, NULL, 4),
(22972, NULL, 'G3DSA:1.10.940.10:FF:000024', NULL, NULL, '16S rRNA (cytosine(967)-C(5))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(22973, NULL, 'G3DSA:2.30.29.30:FF:000329', NULL, NULL, 'alpha-1-syntrophin', NULL, NULL, NULL, NULL, NULL, 4),
(22974, NULL, 'G3DSA:3.40.50.300:FF:004413', NULL, NULL, 'Putative Rho-related GTP-binding protein RhoU', NULL, NULL, NULL, NULL, NULL, 4),
(22975, NULL, 'G3DSA:3.40.228.10:FF:000006', NULL, NULL, 'Formate dehydrogenase, alpha subunit, selenocysteine-containing', NULL, NULL, NULL, NULL, NULL, 4),
(22976, NULL, 'G3DSA:1.10.10.10:FF:001829', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(22977, NULL, 'G3DSA:2.60.40.420:FF:000225', NULL, NULL, 'Periplasmic cell division protein (SufI)', NULL, NULL, NULL, NULL, NULL, 4),
(22978, NULL, 'G3DSA:3.40.50.300:FF:002272', NULL, NULL, 'protein PHOTOPERIOD-INDEPENDENT EARLY FLOWERING 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(22979, NULL, 'G3DSA:2.20.20.110:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22980, NULL, 'G3DSA:3.40.50.10190:FF:000060', NULL, NULL, 'G1/S regulator NimO, putative', NULL, NULL, NULL, NULL, NULL, 4),
(22981, NULL, 'G3DSA:3.30.160.20:FF:000101', NULL, NULL, 'Loquacious, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(22982, NULL, 'G3DSA:3.30.70.1350:FF:000008', NULL, NULL, 'Metal tolerance protein C1', NULL, NULL, NULL, NULL, NULL, 4),
(22983, NULL, 'G3DSA:2.10.110.10:FF:000137', NULL, NULL, 'Mechanosensory protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(22984, NULL, 'G3DSA:1.20.1610.10:FF:000018', NULL, NULL, 'Alpha-1,2-mannosidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(22985, NULL, 'G3DSA:2.130.10.10:FF:002777', NULL, NULL, 'BUB3 mitotic checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(22986, NULL, 'G3DSA:1.25.40.10:FF:003529', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22987, NULL, 'G3DSA:3.30.70.1050:FF:000019', NULL, NULL, 'Chloroplast trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(22988, NULL, 'G3DSA:3.40.30.10:FF:000032', NULL, NULL, 'Protein disulfide-isomerase A6 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(22989, NULL, 'G3DSA:3.90.760.10:FF:000001', NULL, NULL, 'Flavocytochrome C flavoprotein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(22990, NULL, 'G3DSA:3.30.40.10:FF:000286', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(22991, NULL, 'G3DSA:1.25.40.10:FF:004367', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22992, NULL, 'G3DSA:3.80.10.10:FF:003019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(22993, NULL, 'G3DSA:3.30.160.60:FF:002670', NULL, NULL, 'D19A', NULL, NULL, NULL, NULL, NULL, 4),
(22994, NULL, 'G3DSA:1.25.40.10:FF:000533', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(22995, NULL, 'G3DSA:3.30.310.10:FF:000037', NULL, NULL, 'Adaptin N terminal region family protein', NULL, NULL, NULL, NULL, NULL, 4),
(22996, NULL, 'G3DSA:3.40.640.10:FF:000088', NULL, NULL, 'Bifunctional dethiobiotin synthetase/7,8-diamino-pelargonic acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(22997, NULL, 'G3DSA:1.25.40.10:FF:004822', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(22998, NULL, 'G3DSA:2.60.40.10:FF:005891', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(22999, NULL, 'G3DSA:2.170.300.10:FF:000013', NULL, NULL, 'Scavenger receptor class F, member 2', NULL, NULL, NULL, NULL, NULL, 4),
(23000, NULL, 'G3DSA:3.40.50.12780:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23001, NULL, 'G3DSA:1.10.510.10:FF:002577', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23002, NULL, 'G3DSA:3.30.60.20:FF:000054', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(23003, NULL, 'G3DSA:2.130.10.10:FF:002215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23004, NULL, 'G3DSA:3.90.550.50:FF:000160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23005, NULL, 'G3DSA:1.20.1250.10:FF:000142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23006, NULL, 'G3DSA:2.60.40.10:FF:004598', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23007, NULL, 'G3DSA:3.30.559.10:FF:000119', NULL, NULL, 'Carnitine O-octanoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(23008, NULL, 'G3DSA:1.20.1250.20:FF:000600', NULL, NULL, 'Blast:Putative inorganic phosphate cotransporter', NULL, NULL, NULL, NULL, NULL, 4),
(23009, NULL, 'G3DSA:2.30.29.30:FF:001280', NULL, NULL, 'FERM domain-containing protein A', NULL, NULL, NULL, NULL, NULL, 4),
(23010, NULL, 'G3DSA:3.80.10.10:FF:001440', NULL, NULL, 'F-box/LRR-repeat protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(23011, NULL, 'G3DSA:1.20.58.60:FF:000436', NULL, NULL, 'Spectrin beta non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(23012, NULL, 'G3DSA:2.60.120.650:FF:000045', NULL, NULL, 'F-box protein At1g78280', NULL, NULL, NULL, NULL, NULL, 4),
(23013, NULL, 'G3DSA:3.40.50.300:FF:007162', NULL, NULL, 'RecA protein', NULL, NULL, NULL, NULL, NULL, 4),
(23014, NULL, 'G3DSA:1.20.5.420:FF:000015', NULL, NULL, 'Protein CBR-SGT-1', NULL, NULL, NULL, NULL, NULL, 4),
(23015, NULL, 'G3DSA:2.60.40.10:FF:002125', NULL, NULL, 'Netrin receptor UNC5D', NULL, NULL, NULL, NULL, NULL, 4),
(23016, NULL, 'G3DSA:3.90.226.10:FF:000030', NULL, NULL, 'Acetyl-CoA carboxylase carboxyltransferase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(23017, NULL, 'G3DSA:3.30.750.24:FF:000117', NULL, NULL, 'Ssr1600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(23018, NULL, 'G3DSA:2.10.50.30:FF:000003', NULL, NULL, 'Vomeronasal 2, receptor 120', NULL, NULL, NULL, NULL, NULL, 4),
(23019, NULL, 'G3DSA:1.10.3080.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23020, NULL, 'G3DSA:3.40.30.10:FF:000375', NULL, NULL, 'YGR201C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(23021, NULL, 'G3DSA:3.20.20.220:FF:000043', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(23022, NULL, 'G3DSA:2.60.40.10:FF:001849', NULL, NULL, 'Sidekick, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(23023, NULL, 'G3DSA:3.40.850.10:FF:000463', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(23024, NULL, 'G3DSA:3.40.50.1000:FF:000064', NULL, NULL, 'HAD hydrolase, family IA', NULL, NULL, NULL, NULL, NULL, 4),
(23025, NULL, 'G3DSA:1.10.1600.10:FF:000014', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(23026, NULL, 'G3DSA:3.10.20.360:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23027, NULL, 'G3DSA:3.80.10.10:FF:003570', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23028, NULL, 'G3DSA:2.30.30.40:FF:000061', NULL, NULL, 'Cytoplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(23029, NULL, 'G3DSA:1.20.120.230:FF:000047', NULL, NULL, 'Probable vinculin', NULL, NULL, NULL, NULL, NULL, 4),
(23030, NULL, 'G3DSA:1.10.510.10:FF:003414', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23031, NULL, 'G3DSA:2.10.110.10:FF:000356', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(23032, NULL, 'G3DSA:2.60.120.260:FF:000017', NULL, NULL, 'Laminin subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(23033, NULL, 'G3DSA:3.30.2160.10:FF:000002', NULL, NULL, 'Putative Ubiquitin-protein ligase E3C', NULL, NULL, NULL, NULL, NULL, 4),
(23034, NULL, 'G3DSA:3.90.20.10:FF:000001', NULL, NULL, 'Hemagglutinin', NULL, NULL, NULL, NULL, NULL, 4),
(23035, NULL, 'G3DSA:3.30.160.60:FF:000540', NULL, NULL, 'zinc finger protein 263 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(23036, NULL, 'G3DSA:3.30.1330.30:FF:000038', NULL, NULL, 'TrmH family tRNA/rRNA methyltransferase YacO', NULL, NULL, NULL, NULL, NULL, 4),
(23037, NULL, 'G3DSA:3.30.200.20:FF:002398', NULL, NULL, 'Muscle-associated receptor tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(23038, NULL, 'G3DSA:4.10.60.10:FF:000067', NULL, NULL, 'Air2p', NULL, NULL, NULL, NULL, NULL, 4),
(23039, NULL, 'G3DSA:1.10.630.10:FF:000596', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23040, NULL, 'G3DSA:3.30.230.10:FF:000216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23041, NULL, 'G3DSA:1.25.40.10:FF:004243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23042, NULL, 'G3DSA:3.40.50.620:FF:000232', NULL, NULL, 'Isoleucine--tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23043, NULL, 'G3DSA:2.30.30.40:FF:000403', NULL, NULL, 'Rho GTPase-activating protein 27,-like', NULL, NULL, NULL, NULL, NULL, 4),
(23044, NULL, 'G3DSA:3.40.50.300:FF:006886', NULL, NULL, 'Probable ABC transporter ATP-binding protein p29', NULL, NULL, NULL, NULL, NULL, 4),
(23045, NULL, 'G3DSA:2.60.120.200:FF:000713', NULL, NULL, 'Laminin subunit alpha 5', NULL, NULL, NULL, NULL, NULL, 4),
(23046, NULL, 'G3DSA:3.40.50.300:FF:001996', NULL, NULL, 'DNA helicase MCM8, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23047, NULL, 'G3DSA:3.40.30.10:FF:001212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23048, NULL, 'G3DSA:2.40.70.10:FF:000211', NULL, NULL, 'Endopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(23049, NULL, 'G3DSA:3.40.50.360:FF:000007', NULL, NULL, 'Drug activity modulator B', NULL, NULL, NULL, NULL, NULL, 4),
(23050, NULL, 'G3DSA:1.20.1070.10:FF:001117', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(23051, NULL, 'G3DSA:3.30.70.660:FF:000031', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(23052, NULL, 'G3DSA:2.30.42.10:FF:000293', NULL, NULL, 'Inactivation-no-after-potential D protein', NULL, NULL, NULL, NULL, NULL, 4),
(23053, NULL, 'G3DSA:3.30.497.10:FF:000115', NULL, NULL, 'SeRPin', NULL, NULL, NULL, NULL, NULL, 4),
(23054, NULL, 'G3DSA:1.10.10.10:FF:000183', NULL, NULL, 'Cullin 3', NULL, NULL, NULL, NULL, NULL, 4),
(23055, NULL, 'G3DSA:3.10.20.340:FF:000002', NULL, NULL, 'Arginine biosynthesis bifunctional protein ArgJ, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(23056, NULL, 'G3DSA:1.20.58.70:FF:000097', NULL, NULL, 'Syntaxin 4-2', NULL, NULL, NULL, NULL, NULL, 4),
(23057, NULL, 'G3DSA:2.130.10.10:FF:001597', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(23058, NULL, 'G3DSA:3.30.420.40:FF:000369', NULL, NULL, 'WGS project CABT00000000 data, contig 2.85', NULL, NULL, NULL, NULL, NULL, 4),
(23059, NULL, 'G3DSA:3.80.10.10:FF:003694', NULL, NULL, 'Si:ch211-213a13.2', NULL, NULL, NULL, NULL, NULL, 4),
(23060, NULL, 'G3DSA:3.40.50.720:FF:002167', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(23061, NULL, 'G3DSA:3.40.50.300:FF:006543', NULL, NULL, 'SD07888p', NULL, NULL, NULL, NULL, NULL, 4),
(23062, NULL, 'G3DSA:1.25.40.20:FF:000992', NULL, NULL, 'Os05g0427600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(23063, NULL, 'G3DSA:2.60.120.1020:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23064, NULL, 'G3DSA:1.20.5.190:FF:000007', NULL, NULL, 'Myosin-ib isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(23065, NULL, 'G3DSA:3.30.70.330:FF:002410', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(23066, NULL, 'G3DSA:2.130.10.10:FF:005868', NULL, NULL, 'Putative CPSF-domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(23067, NULL, 'G3DSA:1.10.238.10:FF:000403', NULL, NULL, 'Troponin C, skeletal muscle', NULL, NULL, NULL, NULL, NULL, 4),
(23068, NULL, 'G3DSA:2.60.260.20:FF:000100', NULL, NULL, 'DnaJ heat shock protein family (Hsp40) member A2b', NULL, NULL, NULL, NULL, NULL, 4),
(23069, NULL, 'G3DSA:3.60.21.10:FF:000235', NULL, NULL, 'Metallophosphoesterase', NULL, NULL, NULL, NULL, NULL, 4),
(23070, NULL, 'G3DSA:3.30.342.10:FF:000032', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(23071, NULL, 'G3DSA:3.30.460.90:FF:000009', NULL, NULL, 'Cyclic GMP-AMP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(23072, NULL, 'G3DSA:2.40.320.10:FF:000034', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 18', NULL, NULL, NULL, NULL, NULL, 4),
(23073, NULL, 'G3DSA:3.30.40.10:FF:001702', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 33', NULL, NULL, NULL, NULL, NULL, 4),
(23074, NULL, 'G3DSA:1.10.287.550:FF:000004', NULL, NULL, 'Arylsulfatase H', NULL, NULL, NULL, NULL, NULL, 4),
(23075, NULL, 'G3DSA:3.80.10.10:FF:004531', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23076, NULL, 'G3DSA:1.20.140.20:FF:000008', NULL, NULL, 'Probable [pyruvate dehydrogenase (acetyl-transferring)] kinase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(23077, NULL, 'G3DSA:1.10.730.10:FF:000087', NULL, NULL, 'probable arginine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(23078, NULL, 'G3DSA:3.30.365.10:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23079, NULL, 'G3DSA:1.20.920.20:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23080, NULL, 'G3DSA:3.30.70.270:FF:000240', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23081, NULL, 'G3DSA:1.10.510.10:FF:003757', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23082, NULL, 'G3DSA:1.25.40.20:FF:001610', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23083, NULL, 'G3DSA:2.40.160.10:FF:000032', NULL, NULL, 'Outer membrane porin', NULL, NULL, NULL, NULL, NULL, 4),
(23084, NULL, 'G3DSA:3.20.20.80:FF:000587', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23085, NULL, 'G3DSA:3.30.200.20:FF:000723', NULL, NULL, 'U-box domain-containing protein 51', NULL, NULL, NULL, NULL, NULL, 4),
(23086, NULL, 'G3DSA:2.20.70.10:FF:000049', NULL, NULL, 'Transcription elongation regulator 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(23087, NULL, 'G3DSA:2.30.42.10:FF:000074', NULL, NULL, 'protein scribble homolog isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(23088, NULL, 'G3DSA:3.60.15.10:FF:000069', NULL, NULL, 'ElaC ribonuclease Z 1', NULL, NULL, NULL, NULL, NULL, 4),
(23089, NULL, 'G3DSA:3.40.50.1000:FF:000625', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23090, NULL, 'G3DSA:2.20.25.10:FF:000074', NULL, NULL, 'DNA-directed RNA polymerase I subunit', NULL, NULL, NULL, NULL, NULL, 4),
(23091, NULL, 'G3DSA:1.10.1040.10:FF:000044', NULL, NULL, 'Putative 3-hydroxyisobutyrate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(23092, NULL, 'G3DSA:2.60.40.150:FF:000577', NULL, NULL, 'Regulating synaptic membrane exocytosis protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(23093, NULL, 'G3DSA:3.40.50.300:FF:006667', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23094, NULL, 'G3DSA:2.170.270.10:FF:000234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23095, NULL, 'G3DSA:3.40.50.300:FF:002833', NULL, NULL, 'Pleiotropic drug resistance protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(23096, NULL, 'G3DSA:1.20.5.170:FF:000125', NULL, NULL, 'LAS1-like, ribosome biogenesis factor', NULL, NULL, NULL, NULL, NULL, 4),
(23097, NULL, 'G3DSA:2.30.42.10:FF:000635', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23098, NULL, 'G3DSA:1.10.600.10:FF:000083', NULL, NULL, 'Squalene synthase HpnC', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(23099, NULL, 'G3DSA:2.40.50.140:FF:001002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23100, NULL, 'G3DSA:2.130.10.10:FF:002558', NULL, NULL, 'WD40-repeat-containing subunit of the 18S rRNA processing complex', NULL, NULL, NULL, NULL, NULL, 4),
(23101, NULL, 'G3DSA:2.130.10.10:FF:002434', NULL, NULL, 'RaBConnectin related', NULL, NULL, NULL, NULL, NULL, 4),
(23102, NULL, 'G3DSA:3.80.10.10:FF:000821', NULL, NULL, 'NB-ARC domain containing protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(23103, NULL, 'G3DSA:3.40.50.300:FF:003233', NULL, NULL, 'ATP-binding cassette sub-family C member 8', NULL, NULL, NULL, NULL, NULL, 4),
(23104, NULL, 'G3DSA:3.10.20.770:FF:000013', NULL, NULL, 'Phosphatidylinositol 3-kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(23105, NULL, 'G3DSA:2.40.50.140:FF:000165', NULL, NULL, 'Chaperone CsaA', NULL, NULL, NULL, NULL, NULL, 4),
(23106, NULL, 'G3DSA:3.30.1490.20:FF:000086', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(23107, NULL, 'G3DSA:1.20.1070.10:FF:000156', NULL, NULL, 'Lutropin-choriogonadotropic hormone receptor', NULL, NULL, NULL, NULL, NULL, 4),
(23108, NULL, 'G3DSA:3.40.50.300:FF:002491', NULL, NULL, 'Ras family gtpase', NULL, NULL, NULL, NULL, NULL, 4),
(23109, NULL, 'G3DSA:3.30.40.10:FF:000409', NULL, NULL, 'probable E3 ubiquitin-protein ligase RNF183', NULL, NULL, NULL, NULL, NULL, 4),
(23110, NULL, 'G3DSA:3.80.10.10:FF:003238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23111, NULL, 'G3DSA:3.40.50.2060:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23112, NULL, 'G3DSA:1.10.8.710:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23113, NULL, 'G3DSA:3.40.50.300:FF:007504', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(23114, NULL, 'G3DSA:3.30.1680.10:FF:000018', NULL, NULL, 'semaphorin-4C-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(23115, NULL, 'G3DSA:3.30.1370.50:FF:000030', NULL, NULL, 'Benign gonial cell neoplasm', NULL, NULL, NULL, NULL, NULL, 4),
(23116, NULL, 'G3DSA:1.25.10.10:FF:002274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23117, NULL, 'G3DSA:3.65.10.10:FF:000019', NULL, NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(23118, NULL, 'G3DSA:3.90.70.10:FF:000403', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(23119, NULL, 'G3DSA:3.40.50.790:FF:000018', NULL, NULL, '50S ribosomal protein L1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(23120, NULL, 'G3DSA:1.25.40.20:FF:000317', NULL, NULL, 'Ankyrin repeat domain-containing protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(23121, NULL, 'G3DSA:1.10.533.10:FF:000016', NULL, NULL, 'CASP8 and FADD-like apoptosis regulator', NULL, NULL, NULL, NULL, NULL, 4),
(23122, NULL, 'G3DSA:4.10.410.10:FF:000085', NULL, NULL, 'Protein CBR-MEC-9', NULL, NULL, NULL, NULL, NULL, 4),
(23123, NULL, 'G3DSA:3.30.413.10:FF:000006', NULL, NULL, '4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase (flavodoxin)', NULL, NULL, NULL, NULL, NULL, 4),
(23124, NULL, 'G3DSA:1.10.150.20:FF:000051', NULL, NULL, 'Endonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23125, NULL, 'G3DSA:3.30.40.10:FF:001955', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23126, NULL, 'G3DSA:4.10.1240.50:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23127, NULL, 'G3DSA:1.10.287.110:FF:000395', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23128, NULL, 'G3DSA:2.60.120.650:FF:000011', NULL, NULL, 'PHD finger protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(23129, NULL, 'G3DSA:3.30.450.150:FF:000008', NULL, NULL, 'Uncharacterized protein CaJ7.0438', NULL, NULL, NULL, NULL, NULL, 4),
(23130, NULL, 'G3DSA:3.90.1110.10:FF:000013', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(23131, NULL, 'G3DSA:3.40.1480.10:FF:000001', NULL, NULL, 'Glycerate kinase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(23132, NULL, 'G3DSA:1.10.510.10:FF:002594', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23133, NULL, 'G3DSA:1.20.1310.10:FF:000164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23134, NULL, 'G3DSA:3.30.710.10:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23135, NULL, 'G3DSA:3.30.930.10:FF:000399', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23136, NULL, 'G3DSA:1.25.40.10:FF:004636', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23137, NULL, 'G3DSA:3.90.1600.10:FF:000034', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(23138, NULL, 'G3DSA:3.30.160.60:FF:004839', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23139, NULL, 'G3DSA:1.10.20.10:FF:000239', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23140, NULL, 'G3DSA:2.40.10.10:FF:000483', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23141, NULL, 'G3DSA:3.30.420.40:FF:000863', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23142, NULL, 'G3DSA:2.60.40.1400:FF:000011', NULL, NULL, 'Potassium inwardly-rectifying channel', NULL, NULL, NULL, NULL, NULL, 4),
(23143, NULL, 'G3DSA:3.90.1530.10:FF:000005', NULL, NULL, 'Sulfiredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(23144, NULL, 'G3DSA:3.10.20.90:FF:000197', NULL, NULL, 'afadin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(23145, NULL, 'G3DSA:3.30.160.100:FF:000023', NULL, NULL, 'Ribosome hibernation promoting factor', NULL, NULL, NULL, NULL, NULL, 4),
(23146, NULL, 'G3DSA:3.50.50.60:FF:001346', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23147, NULL, 'G3DSA:2.60.40.2960:FF:000001', NULL, NULL, 'Type 2 DNA topoisomerase 6 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(23148, NULL, 'G3DSA:1.25.40.630:FF:000001', NULL, NULL, 'Cleavage stimulation factor subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(23149, NULL, 'G3DSA:2.60.40.150:FF:000498', NULL, NULL, 'Phosphatidylserine decarboxylase proenzyme 2', NULL, NULL, NULL, NULL, NULL, 4),
(23150, NULL, 'G3DSA:4.10.1240.30:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23151, NULL, 'G3DSA:1.20.5.110:FF:000349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23152, NULL, 'G3DSA:3.40.50.300:FF:006852', NULL, NULL, 'GPN-loop GTPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(23153, NULL, 'G3DSA:3.30.160.60:FF:001613', NULL, NULL, 'Zinc finger protein 446', NULL, NULL, NULL, NULL, NULL, 4),
(23154, NULL, 'G3DSA:3.10.100.10:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23155, NULL, 'G3DSA:3.30.160.60:FF:000624', NULL, NULL, 'zinc finger protein 697', NULL, NULL, NULL, NULL, NULL, 4),
(23156, NULL, 'G3DSA:1.25.40.10:FF:000893', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(23157, NULL, 'G3DSA:1.10.472.10:FF:000458', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23158, NULL, 'G3DSA:2.120.10.30:FF:000187', NULL, NULL, 'S9 family peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(23159, NULL, 'G3DSA:3.40.50.1820:FF:000433', NULL, NULL, 'Putative triglyceride lipase', NULL, NULL, NULL, NULL, NULL, 4),
(23160, NULL, 'G3DSA:3.40.50.10190:FF:000178', NULL, NULL, 'Chromodomain-helicase-DNA-binding protein 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(23161, NULL, 'G3DSA:3.30.70.330:FF:000409', NULL, NULL, 'U11/U12 small nuclear ribonucleoprotein 65 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(23162, NULL, 'G3DSA:1.25.40.20:FF:000896', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(23163, NULL, 'G3DSA:1.20.870.10:FF:000027', NULL, NULL, 'GD11282', NULL, NULL, NULL, NULL, NULL, 4),
(23164, NULL, 'G3DSA:1.20.120.830:FF:000002', NULL, NULL, 'Neural cell expressed, developmentally down-regulated 9', NULL, NULL, NULL, NULL, NULL, 4),
(23165, NULL, 'G3DSA:3.40.50.720:FF:002201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23166, NULL, 'G3DSA:3.10.20.90:FF:000843', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(23167, NULL, 'G3DSA:1.20.58.390:FF:000275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23168, NULL, 'G3DSA:1.25.40.20:FF:001413', NULL, NULL, 'Exodeoxyribonuclease V', NULL, NULL, NULL, NULL, NULL, 4),
(23169, NULL, 'G3DSA:1.20.58.60:FF:000329', NULL, NULL, 'SMAll', NULL, NULL, NULL, NULL, NULL, 4),
(23170, NULL, 'G3DSA:1.10.510.10:FF:004246', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23171, NULL, 'G3DSA:2.60.120.10:FF:000834', NULL, NULL, 'Transcriptional regulator AraC family', NULL, NULL, NULL, NULL, NULL, 4),
(23172, NULL, 'G3DSA:2.40.70.10:FF:000492', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23173, NULL, 'G3DSA:3.40.390.10:FF:000034', NULL, NULL, 'Sol narae, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(23174, NULL, 'G3DSA:3.40.50.1820:FF:001861', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23175, NULL, 'G3DSA:1.25.10.10:FF:003027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23176, NULL, 'G3DSA:1.10.1740.10:FF:000047', NULL, NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(23177, NULL, 'G3DSA:2.130.10.10:FF:004901', NULL, NULL, 'Cleavage and polyadenylation-specific factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(23178, NULL, 'G3DSA:1.10.510.10:FF:001020', NULL, NULL, 'Transmembrane ion channel', NULL, NULL, NULL, NULL, NULL, 4),
(23179, NULL, 'G3DSA:2.30.30.40:FF:000257', NULL, NULL, 'Abl interactor 2', NULL, NULL, NULL, NULL, NULL, 4),
(23180, NULL, 'G3DSA:1.20.1070.10:FF:001437', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23181, NULL, 'G3DSA:3.90.1030.10:FF:000012', NULL, NULL, '50S ribosomal protein L17, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23182, NULL, 'G3DSA:3.30.750.24:FF:000139', NULL, NULL, 'AGAP001531-PA', NULL, NULL, NULL, NULL, NULL, 4),
(23183, NULL, 'G3DSA:3.20.20.40:FF:000002', NULL, NULL, 'Glucanase', NULL, NULL, NULL, NULL, NULL, 4),
(23184, NULL, 'G3DSA:2.60.120.10:FF:000508', NULL, NULL, 'cGMP-dependent protein kinase, isozyme 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(23185, NULL, 'G3DSA:3.40.50.300:FF:008297', NULL, NULL, 'GTP binding protein 3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(23186, NULL, 'G3DSA:1.20.1280.290:FF:000051', NULL, NULL, 'Mannose-P-dolichol utilization defect 1 protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(23187, NULL, 'G3DSA:3.10.129.10:FF:000221', NULL, NULL, 'Protein CBG14719', NULL, NULL, NULL, NULL, NULL, 4),
(23188, NULL, 'G3DSA:2.130.10.10:FF:004694', NULL, NULL, 'Uncharacterized WD repeat-containing protein C26H5.03', NULL, NULL, NULL, NULL, NULL, 4),
(23189, NULL, 'G3DSA:2.60.40.10:FF:001164', NULL, NULL, 'Uncharacterized protein, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(23190, NULL, 'G3DSA:1.10.10.10:FF:000593', NULL, NULL, '40S ribosomal protein S19 protein', NULL, NULL, NULL, NULL, NULL, 4),
(23191, NULL, 'G3DSA:1.25.10.10:FF:002364', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23192, NULL, 'G3DSA:2.120.10.80:FF:000095', NULL, NULL, 'Actin-binding protein IPP', NULL, NULL, NULL, NULL, NULL, 4),
(23193, NULL, 'G3DSA:1.10.1170.10:FF:000025', NULL, NULL, 'Baculoviral IAP repeat containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(23194, NULL, 'G3DSA:1.20.1560.10:FF:000795', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23195, NULL, 'G3DSA:3.30.160.60:FF:002069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23196, NULL, 'G3DSA:3.30.559.70:FF:000019', NULL, NULL, 'GM16326', NULL, NULL, NULL, NULL, NULL, 4),
(23197, NULL, 'G3DSA:3.40.50.880:FF:000225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23198, NULL, 'G3DSA:2.60.40.60:FF:001072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23199, NULL, 'G3DSA:2.170.120.30:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23200, NULL, 'G3DSA:3.30.70.580:FF:000052', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(23201, NULL, 'G3DSA:3.10.350.10:FF:000010', NULL, NULL, 'LysM and putative peptidoglycan-binding domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(23202, NULL, 'G3DSA:3.30.70.270:FF:000110', NULL, NULL, 'DNApol-iota, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(23203, NULL, 'G3DSA:3.30.1490.100:FF:000034', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(23204, NULL, 'G3DSA:3.40.190.10:FF:000406', NULL, NULL, 'Amino acid ABC transporter amino acid-binding portion', NULL, NULL, NULL, NULL, NULL, 4),
(23205, NULL, 'G3DSA:1.25.10.10:FF:002038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23206, NULL, 'G3DSA:3.80.10.10:FF:001693', NULL, NULL, 'ELRR (Extracellular Leucine-Rich Repeat) ONly', NULL, NULL, NULL, NULL, NULL, 4),
(23207, NULL, 'G3DSA:2.60.120.260:FF:000310', NULL, NULL, 'Endoprotease bli-4', NULL, NULL, NULL, NULL, NULL, 4),
(23208, NULL, 'G3DSA:2.170.120.20:FF:000013', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(23209, NULL, 'G3DSA:2.160.20.10:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23210, NULL, 'G3DSA:3.40.50.720:FF:000110', NULL, NULL, 'Glyoxylate/hydroxypyruvate reductase A', NULL, NULL, NULL, NULL, NULL, 4),
(23211, NULL, 'G3DSA:3.30.56.10:FF:000013', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(23212, NULL, 'G3DSA:1.25.40.10:FF:001410', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(23213, NULL, 'G3DSA:2.60.40.770:FF:000004', NULL, NULL, 'Phosphatidylglycerol/phosphatidylinositol transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(23214, NULL, 'G3DSA:2.130.10.10:FF:003120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23215, NULL, 'G3DSA:3.90.1100.10:FF:000041', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(23216, NULL, 'G3DSA:3.30.450.30:FF:000036', NULL, NULL, 'GD11487', NULL, NULL, NULL, NULL, NULL, 4),
(23217, NULL, 'G3DSA:1.10.3470.10:FF:000037', NULL, NULL, 'Putative iron ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(23218, NULL, 'G3DSA:3.30.1520.10:FF:000041', NULL, NULL, 'Protein kinase activator Bem1', NULL, NULL, NULL, NULL, NULL, 4),
(23219, NULL, 'G3DSA:2.40.70.10:FF:000166', NULL, NULL, 'Eukaryotic aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(23220, NULL, 'G3DSA:1.10.10.10:FF:000913', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(23221, NULL, 'G3DSA:2.40.50.100:FF:000198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23222, NULL, 'G3DSA:2.60.40.10:FF:005233', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23223, NULL, 'G3DSA:3.40.50.2300:FF:000504', NULL, NULL, 'Serine/threonine-protein kinase RIM15', NULL, NULL, NULL, NULL, NULL, 4),
(23224, NULL, 'G3DSA:3.40.50.300:FF:008617', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23225, NULL, 'G3DSA:2.60.40.10:FF:002592', NULL, NULL, 'Complement C4', NULL, NULL, NULL, NULL, NULL, 4),
(23226, NULL, 'G3DSA:2.120.10.80:FF:000415', NULL, NULL, 'Kelch like ECH associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(23227, NULL, 'G3DSA:3.30.450.20:FF:000033', NULL, NULL, 'Nitrogen regulation protein NR(II)', NULL, NULL, NULL, NULL, NULL, 4),
(23228, NULL, 'G3DSA:1.20.58.1480:FF:000027', NULL, NULL, 'Protein cereblon', NULL, NULL, NULL, NULL, NULL, 4),
(23229, NULL, 'G3DSA:3.40.50.720:FF:001684', NULL, NULL, 'Glyoxylate/hydroxypyruvate reductase A', NULL, NULL, NULL, NULL, NULL, 4),
(23230, NULL, 'G3DSA:3.30.450.40:FF:000039', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(23231, NULL, 'G3DSA:3.40.50.150:FF:001142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23232, NULL, 'G3DSA:2.60.40.760:FF:000001', NULL, NULL, 'Expansin', NULL, NULL, NULL, NULL, NULL, 4),
(23233, NULL, 'G3DSA:3.90.850.10:FF:000002', NULL, NULL, '2-hydroxyhepta-2,4-diene-1,7-dioate isomerase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(23234, NULL, 'G3DSA:3.50.50.60:FF:000244', NULL, NULL, 'Renalase isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(23235, NULL, 'G3DSA:2.30.30.210:FF:000010', NULL, NULL, 'Ribonuclease P protein subunit p29', NULL, NULL, NULL, NULL, NULL, 4),
(23236, NULL, 'G3DSA:2.20.110.10:FF:000011', NULL, NULL, 'MORN repeat-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(23237, NULL, 'G3DSA:1.10.1070.11:FF:000058', NULL, NULL, 'MTOR isoform 6', NULL, NULL, NULL, NULL, NULL, 4),
(23238, NULL, 'G3DSA:3.40.50.1440:FF:000089', NULL, NULL, 'Tubulin, beta 6 class V', NULL, NULL, NULL, NULL, NULL, 4),
(23239, NULL, 'G3DSA:1.10.1200.30:FF:000001', NULL, NULL, 'Gag polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(23240, NULL, 'G3DSA:3.40.50.300:FF:007954', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(23241, NULL, 'G3DSA:3.40.50.2300:FF:000184', NULL, NULL, 'Response regulator 3', NULL, NULL, NULL, NULL, NULL, 4),
(23242, NULL, 'G3DSA:3.30.160.60:FF:002748', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23243, NULL, 'G3DSA:3.10.100.10:FF:000290', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23244, NULL, 'G3DSA:1.10.15.30:FF:000003', NULL, NULL, '50S ribosomal protein L30', NULL, NULL, NULL, NULL, NULL, 4),
(23245, NULL, 'G3DSA:3.80.10.10:FF:002210', NULL, NULL, 'Leucine-rich transmembrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23246, NULL, 'G3DSA:3.40.50.300:FF:004609', NULL, NULL, 'ATP-dependent DNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23247, NULL, 'G3DSA:3.30.420.40:FF:000537', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(23248, NULL, 'G3DSA:3.40.50.720:FF:001419', NULL, NULL, 'ThiF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(23249, NULL, 'G3DSA:2.170.270.10:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23250, NULL, 'G3DSA:3.40.50.300:FF:006526', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23251, NULL, 'G3DSA:1.20.144.10:FF:000082', NULL, NULL, 'PAP2 superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(23252, NULL, 'G3DSA:2.70.70.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23253, NULL, 'G3DSA:2.60.120.650:FF:000157', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(23254, NULL, 'G3DSA:1.20.1070.10:FF:001763', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23255, NULL, 'G3DSA:2.130.10.10:FF:002923', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23256, NULL, 'G3DSA:3.30.70.330:FF:000735', NULL, NULL, 'Cytoplasmic protein, variant', NULL, NULL, NULL, NULL, NULL, 4),
(23257, NULL, 'G3DSA:1.20.5.4010:FF:000005', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(23258, NULL, 'G3DSA:1.20.1250.20:FF:000403', NULL, NULL, 'Fosmidomycin resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(23259, NULL, 'G3DSA:1.25.40.10:FF:000567', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(23260, NULL, 'G3DSA:2.60.40.10:FF:004570', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23261, NULL, 'G3DSA:1.10.287.40:FF:000014', NULL, NULL, 'Seryl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(23262, NULL, 'G3DSA:2.10.25.10:FF:001530', NULL, NULL, 'Netrin-G2', NULL, NULL, NULL, NULL, NULL, 4),
(23263, NULL, 'G3DSA:3.30.40.10:FF:001629', NULL, NULL, 'DNA repair-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23264, NULL, 'G3DSA:2.10.25.10:FF:001058', NULL, NULL, 'Abnormal pharyngeal pumping eat-20', NULL, NULL, NULL, NULL, NULL, 4),
(23265, NULL, 'G3DSA:1.10.274.100:FF:000028', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(23266, NULL, 'G3DSA:2.60.40.10:FF:000175', NULL, NULL, 'Fibronectin type III domain containing 3A', NULL, NULL, NULL, NULL, NULL, 4),
(23267, NULL, 'G3DSA:2.130.10.10:FF:005211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(23268, NULL, 'G3DSA:3.40.50.1820:FF:000107', NULL, NULL, 'Palmitoyl-protein thioesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(23269, NULL, 'G3DSA:4.10.60.10:FF:000241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23270, NULL, 'G3DSA:3.40.190.10:FF:000053', NULL, NULL, 'Membrane-bound lytic murein transglycosylase F', NULL, NULL, NULL, NULL, NULL, 4),
(23271, NULL, 'G3DSA:1.10.238.10:FF:000870', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23272, NULL, 'G3DSA:3.40.640.10:FF:000514', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23273, NULL, 'G3DSA:1.20.1110.10:FF:000183', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23274, NULL, 'G3DSA:2.130.10.10:FF:000832', NULL, NULL, 'striatin-3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(23275, NULL, 'G3DSA:1.25.70.10:FF:000069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23276, NULL, 'G3DSA:1.10.510.10:FF:002268', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23277, NULL, 'G3DSA:2.10.110.10:FF:000182', NULL, NULL, 'Putative actin-binding protein UNC-115', NULL, NULL, NULL, NULL, NULL, 4),
(23278, NULL, 'G3DSA:1.25.40.240:FF:000007', NULL, NULL, 'ATP-dependent DNA helicase II subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(23279, NULL, 'G3DSA:3.40.50.300:FF:008090', NULL, NULL, 'Uvrd / recb / pcra DNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23280, NULL, 'G3DSA:1.10.10.60:FF:000821', NULL, NULL, 'Notochord homeobox', NULL, NULL, NULL, NULL, NULL, 4),
(23281, NULL, 'G3DSA:1.10.1030.10:FF:000015', NULL, NULL, 'CPSase', NULL, NULL, NULL, NULL, NULL, 4),
(23282, NULL, 'G3DSA:3.40.50.1580:FF:000052', NULL, NULL, 'S-methyl-5''-thioadenosine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(23283, NULL, 'G3DSA:1.10.510.10:FF:000177', NULL, NULL, 'Mast/stem cell growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(23284, NULL, 'G3DSA:2.40.50.90:FF:000200', NULL, NULL, 'Qin', NULL, NULL, NULL, NULL, NULL, 4),
(23285, NULL, 'G3DSA:2.120.10.30:FF:000507', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23286, NULL, 'G3DSA:2.60.40.10:FF:002945', NULL, NULL, 'Fibronectin_type_III_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(23287, NULL, 'G3DSA:1.10.730.10:FF:000042', NULL, NULL, 'Leucine--tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23288, NULL, 'G3DSA:2.160.10.10:FF:000056', NULL, NULL, 'Serine O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(23289, NULL, 'G3DSA:1.20.1250.20:FF:001538', NULL, NULL, 'Disrupted in renal carcinoma protein', NULL, NULL, NULL, NULL, NULL, 4),
(23290, NULL, 'G3DSA:1.25.40.570:FF:000022', NULL, NULL, 'COP9 signalosome complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(23291, NULL, 'G3DSA:3.30.420.110:FF:000064', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(23292, NULL, 'G3DSA:3.40.50.300:FF:004935', NULL, NULL, 'Small GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23293, NULL, 'G3DSA:2.60.40.60:FF:000936', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23294, NULL, 'G3DSA:3.30.450.190:FF:000026', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(23295, NULL, 'G3DSA:1.25.40.990:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23296, NULL, 'G3DSA:3.40.470.10:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23297, NULL, 'G3DSA:3.70.10.10:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23298, NULL, 'G3DSA:3.30.870.10:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23299, NULL, 'G3DSA:3.40.190.10:FF:000732', NULL, NULL, 'AGAP011968-PA', NULL, NULL, NULL, NULL, NULL, 4),
(23300, NULL, 'G3DSA:3.40.50.80:FF:000245', NULL, NULL, 'NADPH oxidase 5', NULL, NULL, NULL, NULL, NULL, 4),
(23301, NULL, 'G3DSA:2.40.20.10:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(23302, NULL, 'G3DSA:2.10.25.10:FF:001737', NULL, NULL, 'Transmembrane cell adhesion receptor mua-3', NULL, NULL, NULL, NULL, NULL, 4),
(23303, NULL, 'G3DSA:1.25.10.10:FF:002690', NULL, NULL, 'ARVCF delta catenin family member b', NULL, NULL, NULL, NULL, NULL, 4),
(23304, NULL, 'G3DSA:2.60.40.10:FF:000854', NULL, NULL, 'Prostaglandin F2 receptor negative regulator', NULL, NULL, NULL, NULL, NULL, 4),
(23305, NULL, 'G3DSA:1.25.10.10:FF:000386', NULL, NULL, '26S proteasome regulatory subunit RPN1', NULL, NULL, NULL, NULL, NULL, 4),
(23306, NULL, 'G3DSA:1.10.100.10:FF:000011', NULL, NULL, 'Insulin-like peptide 2', NULL, NULL, NULL, NULL, NULL, 4),
(23307, NULL, 'G3DSA:1.25.40.10:FF:004283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23308, NULL, 'G3DSA:3.40.50.150:FF:001788', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23309, NULL, 'G3DSA:1.10.10.10:FF:000267', NULL, NULL, 'HTH-type transcriptional regulator DctR', NULL, NULL, NULL, NULL, NULL, 4),
(23310, NULL, 'G3DSA:1.10.472.130:FF:000008', NULL, NULL, 'Dynein axonemal heavy chain 3', NULL, NULL, NULL, NULL, NULL, 4),
(23311, NULL, 'G3DSA:3.30.160.60:FF:003530', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23312, NULL, 'G3DSA:1.20.1460.20:FF:000003', NULL, NULL, 'V-type ATP synthase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(23313, NULL, 'G3DSA:3.80.10.10:FF:003345', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23314, NULL, 'G3DSA:2.60.40.150:FF:000818', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23315, NULL, 'G3DSA:2.40.30.10:FF:000427', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23316, NULL, 'G3DSA:1.10.3720.10:FF:000164', NULL, NULL, 'Thiamin ABC transporter transmembrane component', NULL, NULL, NULL, NULL, NULL, 4),
(23317, NULL, 'G3DSA:3.30.200.20:FF:002078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23318, NULL, 'G3DSA:1.20.1070.10:FF:000302', NULL, NULL, 'G protein-coupled receptor 39', NULL, NULL, NULL, NULL, NULL, 4),
(23319, NULL, 'G3DSA:3.20.20.80:FF:000053', NULL, NULL, 'Alpha-xylosidase YicI', NULL, NULL, NULL, NULL, NULL, 4),
(23320, NULL, 'G3DSA:3.40.50.2300:FF:001639', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23321, NULL, 'G3DSA:1.25.40.20:FF:000424', NULL, NULL, 'Caskin-1', NULL, NULL, NULL, NULL, NULL, 4),
(23322, NULL, 'G3DSA:1.20.1280.50:FF:000066', NULL, NULL, 'F-box protein SNE', NULL, NULL, NULL, NULL, NULL, 4),
(23323, NULL, 'G3DSA:3.40.50.1820:FF:001568', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23324, NULL, 'G3DSA:2.40.128.330:FF:000003', NULL, NULL, 'Magnesium transporter MRS2 homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(23325, NULL, 'G3DSA:3.40.50.261:FF:000018', NULL, NULL, 'Acetyl coenzyme A synthetase (ADP forming), alpha domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(23326, NULL, 'G3DSA:1.10.400.10:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23327, NULL, 'G3DSA:1.25.40.10:FF:000421', NULL, NULL, 'Tetratricopeptide repeat domain 7B', NULL, NULL, NULL, NULL, NULL, 4),
(23328, NULL, 'G3DSA:3.40.309.10:FF:000104', NULL, NULL, 'Aldehyde dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(23329, NULL, 'G3DSA:3.30.760.10:FF:000014', NULL, NULL, 'Eukaryotic translation initiation factor 4E-4', NULL, NULL, NULL, NULL, NULL, 4),
(23330, NULL, 'G3DSA:2.60.120.200:FF:000106', NULL, NULL, 'Adhesion G-protein coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(23331, NULL, 'G3DSA:3.40.50.300:FF:002783', NULL, NULL, 'ATP-dependent RNA helicase DBP9', NULL, NULL, NULL, NULL, NULL, 4),
(23332, NULL, 'G3DSA:3.10.450.50:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23333, NULL, 'G3DSA:2.60.40.60:FF:000257', NULL, NULL, 'neural-cadherin isoform X11', NULL, NULL, NULL, NULL, NULL, 4),
(23334, NULL, 'G3DSA:1.10.472.170:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(23335, NULL, 'G3DSA:3.30.160.60:FF:000950', NULL, NULL, 'Zinc finger protein 48', NULL, NULL, NULL, NULL, NULL, 4),
(23336, NULL, 'G3DSA:1.25.40.10:FF:002512', NULL, NULL, 'PROBABLE TRANSCRIPTIONAL REGULATORY PROTEIN (LUXR-FAMILY)', NULL, NULL, NULL, NULL, NULL, 4),
(23337, NULL, 'G3DSA:2.40.240.130:FF:000004', NULL, NULL, 'Axin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(23338, NULL, 'G3DSA:3.90.132.10:FF:000008', NULL, NULL, 'GP63-like', NULL, NULL, NULL, NULL, NULL, 4),
(23339, NULL, 'G3DSA:3.30.200.20:FF:002139', NULL, NULL, 'Glycogen synthase kinase-3 alpha, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23340, NULL, 'G3DSA:1.10.472.110:FF:000002', NULL, NULL, 'Transcription factor TFIIB-like', NULL, NULL, NULL, NULL, NULL, 4),
(23341, NULL, 'G3DSA:1.25.40.10:FF:002192', NULL, NULL, 'Transcriptional activator domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(23342, NULL, 'G3DSA:3.40.50.300:FF:004874', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23343, NULL, 'G3DSA:2.60.40.10:FF:002327', NULL, NULL, 'Polymeric immunoglobulin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(23344, NULL, 'G3DSA:1.10.10.60:FF:000349', NULL, NULL, 'Transcription factor MYB39', NULL, NULL, NULL, NULL, NULL, 4),
(23345, NULL, 'G3DSA:3.30.70.870:FF:000015', NULL, NULL, 'Translation elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(23346, NULL, 'G3DSA:1.20.58.60:FF:000122', NULL, NULL, 'dystonin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(23347, NULL, 'G3DSA:2.30.30.910:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23348, NULL, 'G3DSA:3.90.550.10:FF:000283', NULL, NULL, 'UDP-glucose:glycoprotein glucosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23349, NULL, 'G3DSA:1.10.460.10:FF:000032', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(23350, NULL, 'G3DSA:2.60.120.200:FF:000606', NULL, NULL, 'Growth arrest-specific protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(23351, NULL, 'G3DSA:1.20.1070.10:FF:002073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23352, NULL, 'G3DSA:3.90.1150.10:FF:000431', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23353, NULL, 'G3DSA:3.40.630.10:FF:000216', NULL, NULL, 'Vacuolar aminopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23354, NULL, 'G3DSA:3.30.40.10:FF:001781', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23355, NULL, 'G3DSA:1.10.3110.10:FF:000016', NULL, NULL, 'Protoporphyrinogen oxidase 1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(23356, NULL, 'G3DSA:2.130.10.10:FF:000686', NULL, NULL, 'WD repeat-containing protein 72', NULL, NULL, NULL, NULL, NULL, 4),
(23357, NULL, 'G3DSA:3.40.50.720:FF:001745', NULL, NULL, 'Zinc-binding alcohol dehydrogenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(23358, NULL, 'G3DSA:3.30.1050.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23359, NULL, 'G3DSA:1.25.10.10:FF:000739', NULL, NULL, 'VAC14p Enzyme regulator', NULL, NULL, NULL, NULL, NULL, 4),
(23360, NULL, 'G3DSA:1.20.144.10:FF:000110', NULL, NULL, 'Phosphatidate phosphatase PPAPDC1A-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(23361, NULL, 'G3DSA:2.60.200.20:FF:000046', NULL, NULL, 'Putative ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(23362, NULL, 'G3DSA:3.10.10.10:FF:000010', NULL, NULL, 'Gag-Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(23363, NULL, 'G3DSA:3.30.160.60:FF:005767', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23364, NULL, 'G3DSA:3.30.505.10:FF:000046', NULL, NULL, 'RAS p21 protein activator 1', NULL, NULL, NULL, NULL, NULL, 4),
(23365, NULL, 'G3DSA:2.60.40.10:FF:002619', NULL, NULL, 'Isoamylase 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(23366, NULL, 'G3DSA:2.70.170.10:FF:000228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23367, NULL, 'G3DSA:3.90.70.10:FF:000246', NULL, NULL, 'Cysteine protease putative', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(23368, NULL, 'G3DSA:3.90.550.10:FF:000575', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23369, NULL, 'G3DSA:3.30.200.20:FF:002432', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23370, NULL, 'G3DSA:2.60.40.420:FF:000130', NULL, NULL, 'SKU5 similar 16', NULL, NULL, NULL, NULL, NULL, 4),
(23371, NULL, 'G3DSA:2.60.120.260:FF:000517', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(23372, NULL, 'G3DSA:3.40.50.11860:FF:000010', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(23373, NULL, 'G3DSA:3.30.1680.10:FF:000047', NULL, NULL, 'MET proto-oncogene, receptor tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(23374, NULL, 'G3DSA:2.60.40.10:FF:001956', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(23375, NULL, 'G3DSA:3.40.50.150:FF:000978', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23376, NULL, 'G3DSA:1.10.510.10:FF:003083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23377, NULL, 'G3DSA:3.30.230.70:FF:000043', NULL, NULL, 'Unplaced genomic scaffold supercont2.9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(23378, NULL, 'G3DSA:3.40.50.1980:FF:000082', NULL, NULL, 'Possible binding-protein-dependent transport lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(23379, NULL, 'G3DSA:3.30.160.60:FF:003204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23380, NULL, 'G3DSA:2.60.40.10:FF:002799', NULL, NULL, 'Beta-glucosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23381, NULL, 'G3DSA:1.10.472.10:FF:000284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23382, NULL, 'G3DSA:3.10.320.10:FF:000003', NULL, NULL, 'HLA class II histocompatibility antigen, DM alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(23383, NULL, 'G3DSA:1.20.58.1780:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23384, NULL, 'G3DSA:1.10.510.10:FF:002329', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23385, NULL, 'G3DSA:1.10.3730.20:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23386, NULL, 'G3DSA:2.60.220.50:FF:000005', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(23387, NULL, 'G3DSA:1.10.620.20:FF:000042', NULL, NULL, 'Ribonucleoside-diphosphate reductase subunit M2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(23388, NULL, 'G3DSA:3.40.50.300:FF:004256', NULL, NULL, 'SWI/SNF family DNA-dependent ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23389, NULL, 'G3DSA:3.30.160.60:FF:002541', NULL, NULL, 'Zinc finger protein 732', NULL, NULL, NULL, NULL, NULL, 4),
(23390, NULL, 'G3DSA:2.40.30.10:FF:000366', NULL, NULL, 'NADPH--cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(23391, NULL, 'G3DSA:3.40.50.150:FF:000686', NULL, NULL, 'Uncharacterized methyltransferase B4417_0689', NULL, NULL, NULL, NULL, NULL, 4),
(23392, NULL, 'G3DSA:1.20.1070.10:FF:000274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23393, NULL, 'G3DSA:3.30.1060.10:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23394, NULL, 'G3DSA:3.30.1370.240:FF:000015', NULL, NULL, 'Phenylalanine--tRNA ligase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(23395, NULL, 'G3DSA:1.20.58.190:FF:000007', NULL, NULL, 'FI16517p1', NULL, NULL, NULL, NULL, NULL, 4),
(23396, NULL, 'G3DSA:2.60.120.260:FF:000282', NULL, NULL, 'Putative secreted protein', NULL, NULL, NULL, NULL, NULL, 4),
(23397, NULL, 'G3DSA:3.40.50.460:FF:000043', NULL, NULL, 'Os06g0151900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(23398, NULL, 'G3DSA:2.60.40.60:FF:001100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23399, NULL, 'G3DSA:3.40.800.10:FF:000016', NULL, NULL, 'Formimidoylglutamase', NULL, NULL, NULL, NULL, NULL, 4),
(23400, NULL, 'G3DSA:1.10.10.60:FF:000675', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(23401, NULL, 'G3DSA:2.60.210.10:FF:000015', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(23402, NULL, 'G3DSA:3.40.30.10:FF:000886', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23403, NULL, 'G3DSA:3.80.10.10:FF:003845', NULL, NULL, 'PH domain and leucine-rich repeat protein phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(23404, NULL, 'G3DSA:3.40.50.880:FF:000079', NULL, NULL, 'Gamma-glutamyl peptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(23405, NULL, 'G3DSA:3.30.70.330:FF:002326', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23406, NULL, 'G3DSA:3.40.50.720:FF:002408', NULL, NULL, 'dTDP-4-dehydro-6-deoxyglucose reductase', NULL, NULL, NULL, NULL, NULL, 4),
(23407, NULL, 'G3DSA:1.20.1070.10:FF:001376', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23408, NULL, 'G3DSA:1.20.58.220:FF:000005', NULL, NULL, 'Phosphate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(23409, NULL, 'G3DSA:3.90.1300.10:FF:000022', NULL, NULL, 'Indole acetamide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(23410, NULL, 'G3DSA:1.20.1440.130:FF:000001', NULL, NULL, 'Vitamin K epoxide reductase complex subunit 1-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(23411, NULL, 'G3DSA:1.25.40.20:FF:000924', NULL, NULL, 'Os02g0257950 protein', NULL, NULL, NULL, NULL, NULL, 4),
(23412, NULL, 'G3DSA:1.10.510.10:FF:002947', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23413, NULL, 'G3DSA:2.30.30.100:FF:000123', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23414, NULL, 'G3DSA:2.60.40.790:FF:000162', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23415, NULL, 'G3DSA:3.40.50.1820:FF:001361', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23416, NULL, 'G3DSA:3.30.70.330:FF:000089', NULL, NULL, 'RNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(23417, NULL, 'G3DSA:3.30.160.60:FF:006464', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23418, NULL, 'G3DSA:2.70.40.10:FF:000034', NULL, NULL, 'Deoxyuridine 5''-triphosphate nucleotidohydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(23419, NULL, 'G3DSA:3.30.200.20:FF:001004', NULL, NULL, 'Probable inactive leucine-rich repeat receptor-like protein kinase At1g66830', NULL, NULL, NULL, NULL, NULL, 4),
(23420, NULL, 'G3DSA:1.25.40.10:FF:000921', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g48910', NULL, NULL, NULL, NULL, NULL, 4),
(23421, NULL, 'G3DSA:2.130.10.10:FF:004840', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23422, NULL, 'G3DSA:2.40.50.140:FF:000277', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(23423, NULL, 'G3DSA:3.40.50.150:FF:001203', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23424, NULL, 'G3DSA:1.20.120.790:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23425, NULL, 'G3DSA:2.60.40.1120:FF:000051', NULL, NULL, 'Carboxypeptidase M', NULL, NULL, NULL, NULL, NULL, 4),
(23426, NULL, 'G3DSA:3.80.10.10:FF:002182', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(23427, NULL, 'G3DSA:1.10.510.10:FF:000823', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(23428, NULL, 'G3DSA:1.20.1420.30:FF:000032', NULL, NULL, 'Ca2: Cation Antiporter (CaCA) Family', NULL, NULL, NULL, NULL, NULL, 4),
(23429, NULL, 'G3DSA:3.40.800.20:FF:000019', NULL, NULL, 'histone deacetylase 8 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(23430, NULL, 'G3DSA:1.10.510.10:FF:004185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23431, NULL, 'G3DSA:3.80.20.20:FF:000033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(23432, NULL, 'G3DSA:3.40.50.360:FF:000131', NULL, NULL, 'NADPH-dependent azoreductase Azr', NULL, NULL, NULL, NULL, NULL, 4),
(23433, NULL, 'G3DSA:2.30.30.70:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(23434, NULL, 'G3DSA:3.55.50.30:FF:000017', NULL, NULL, 'Probable transmembrane sensor', NULL, NULL, NULL, NULL, NULL, 4),
(23435, NULL, 'G3DSA:2.30.29.30:FF:000037', NULL, NULL, 'Fermitin family homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(23436, NULL, 'G3DSA:3.40.50.300:FF:002457', NULL, NULL, '26S proteasome regulatory subunit 8', NULL, NULL, NULL, NULL, NULL, 4),
(23437, NULL, 'G3DSA:1.25.40.20:FF:001060', NULL, NULL, 'Mitogen activated protein kinase kinase kinase 3, MAPKKK3, MEKK3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23438, NULL, 'G3DSA:3.40.50.2300:FF:000330', NULL, NULL, 'Sugar ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(23439, NULL, 'G3DSA:3.40.50.1000:FF:000513', NULL, NULL, 'Glucosyl-3-phosphoglycerate/mannosyl-3-phosphoglycerate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(23440, NULL, 'G3DSA:1.20.1270.420:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23441, NULL, 'G3DSA:3.30.450.240:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23442, NULL, 'G3DSA:2.60.200.10:FF:000043', NULL, NULL, 'Interferon regulatory factor 8', NULL, NULL, NULL, NULL, NULL, 4),
(23443, NULL, 'G3DSA:1.25.40.180:FF:000321', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23444, NULL, 'G3DSA:1.20.1050.10:FF:000065', NULL, NULL, 'Glutathione S-transferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(23445, NULL, 'G3DSA:1.10.10.10:FF:000767', NULL, NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(23446, NULL, 'G3DSA:2.40.100.10:FF:000023', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(23447, NULL, 'G3DSA:3.40.30.10:FF:000914', NULL, NULL, 'RE05501p', NULL, NULL, NULL, NULL, NULL, 4),
(23448, NULL, 'G3DSA:3.40.5.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23449, NULL, 'G3DSA:3.10.110.10:FF:000375', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(23450, NULL, 'G3DSA:2.60.40.10:FF:003081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23451, NULL, 'G3DSA:3.30.160.60:FF:004665', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23452, NULL, 'G3DSA:3.90.70.10:FF:000572', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23453, NULL, 'G3DSA:1.20.1250.20:FF:001185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23454, NULL, 'G3DSA:3.50.50.60:FF:000418', NULL, NULL, '2-octaprenyl-6-methoxyphenyl hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(23455, NULL, 'G3DSA:3.30.260.10:FF:000021', NULL, NULL, 'Chaperonin CPN60, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(23456, NULL, 'G3DSA:3.20.20.450:FF:000005', NULL, NULL, 'Cyclic di-GMP regulator CdgR', NULL, NULL, NULL, NULL, NULL, 4),
(23457, NULL, 'G3DSA:2.60.40.60:FF:000549', NULL, NULL, 'Protein CBG11506', NULL, NULL, NULL, NULL, NULL, 4),
(23458, NULL, 'G3DSA:3.40.50.1860:FF:000012', NULL, NULL, 'Aspartate-glutamate racemase family', NULL, NULL, NULL, NULL, NULL, 4),
(23459, NULL, 'G3DSA:3.30.565.10:FF:000381', NULL, NULL, 'Protein CBR-MORC-1', NULL, NULL, NULL, NULL, NULL, 4),
(23460, NULL, 'G3DSA:1.10.274.30:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23461, NULL, 'G3DSA:2.60.40.10:FF:004744', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23462, NULL, 'G3DSA:3.90.1150.10:FF:000105', NULL, NULL, 'alanine--glyoxylate aminotransferase 2, mitochondrial isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(23463, NULL, 'G3DSA:3.10.110.10:FF:000083', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(23464, NULL, 'G3DSA:3.90.228.20:FF:000003', NULL, NULL, 'Phosphoenolpyruvate carboxykinase [GTP]', NULL, NULL, NULL, NULL, NULL, 4),
(23465, NULL, 'G3DSA:1.25.40.10:FF:000393', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g20230', NULL, NULL, NULL, NULL, NULL, 4),
(23466, NULL, 'G3DSA:2.60.120.290:FF:000032', NULL, NULL, 'Suppressor of tumorigenicity 14 protein homolog', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(23467, NULL, 'G3DSA:3.40.350.10:FF:000060', NULL, NULL, 'AGAP004109-PA', NULL, NULL, NULL, NULL, NULL, 4),
(23468, NULL, 'G3DSA:1.10.510.10:FF:002740', NULL, NULL, 'Adhesion G protein-coupled receptor G1', NULL, NULL, NULL, NULL, NULL, 4),
(23469, NULL, 'G3DSA:3.10.20.90:FF:000517', NULL, NULL, 'Protein DNA-DAMAGE INDUCIBLE 1', NULL, NULL, NULL, NULL, NULL, 4),
(23470, NULL, 'G3DSA:1.20.1070.10:FF:001937', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23471, NULL, 'G3DSA:3.30.40.10:FF:001455', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23472, NULL, 'G3DSA:3.30.300.30:FF:000115', NULL, NULL, 'Acyl-CoA synthetase medium chain family member 5', NULL, NULL, NULL, NULL, NULL, 4),
(23473, NULL, 'G3DSA:1.25.40.10:FF:002219', NULL, NULL, 'Secretory immunoglobulin A-binding protein EsiB', NULL, NULL, NULL, NULL, NULL, 4),
(23474, NULL, 'G3DSA:3.80.10.10:FF:000265', NULL, NULL, 'Leucine-rich repeat-containing protein 40', NULL, NULL, NULL, NULL, NULL, 4),
(23475, NULL, 'G3DSA:3.40.50.2300:FF:000004', NULL, NULL, 'Glutamate receptor, ionotropic, AMPA 2', NULL, NULL, NULL, NULL, NULL, 4),
(23476, NULL, 'G3DSA:3.40.50.300:FF:004582', NULL, NULL, 'SNF2 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(23477, NULL, 'G3DSA:3.30.50.10:FF:000146', NULL, NULL, 'GATA-type transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(23478, NULL, 'G3DSA:3.40.50.2300:FF:001286', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23479, NULL, 'G3DSA:2.60.40.10:FF:002771', NULL, NULL, 'Amalgam, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(23480, NULL, 'G3DSA:3.90.1140.10:FF:000015', NULL, NULL, 'U6 snRNA phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(23481, NULL, 'G3DSA:3.90.1800.10:FF:000015', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(23482, NULL, 'G3DSA:3.40.50.1240:FF:000208', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23483, NULL, 'G3DSA:3.30.420.40:FF:000184', NULL, NULL, 'NuA4 histone acetyltransferase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(23484, NULL, 'G3DSA:3.30.160.60:FF:004339', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23485, NULL, 'G3DSA:1.10.1370.30:FF:000013', NULL, NULL, 'Peptidase family M2', NULL, NULL, NULL, NULL, NULL, 4),
(23486, NULL, 'G3DSA:1.10.600.10:FF:000004', NULL, NULL, 'Phytoene synthase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(23487, NULL, 'G3DSA:1.10.260.90:FF:000001', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(23488, NULL, 'G3DSA:3.90.550.50:FF:000036', NULL, NULL, 'Putative glycosyltransferase family 31 protein', NULL, NULL, NULL, NULL, NULL, 4),
(23489, NULL, 'G3DSA:3.40.50.1910:FF:000016', NULL, NULL, 'SNARE docking complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(23490, NULL, 'G3DSA:3.30.230.130:FF:000021', NULL, NULL, 'Cullin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(23491, NULL, 'G3DSA:2.120.10.30:FF:000215', NULL, NULL, 'Si:dkey-237h12.3', NULL, NULL, NULL, NULL, NULL, 4),
(23492, NULL, 'G3DSA:3.40.50.920:FF:000052', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(23493, NULL, 'G3DSA:3.40.630.30:FF:000548', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23494, NULL, 'G3DSA:3.40.47.10:FF:000071', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 3', NULL, NULL, NULL, NULL, NULL, 4),
(23495, NULL, 'G3DSA:1.20.1560.10:FF:000210', NULL, NULL, 'ATP-binding cassette, sub-family B (MDR/TAP), member 9', NULL, NULL, NULL, NULL, NULL, 4),
(23496, NULL, 'G3DSA:3.40.190.10:FF:000345', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(23497, NULL, 'G3DSA:3.40.50.300:FF:008325', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23498, NULL, 'G3DSA:1.25.40.20:FF:000396', NULL, NULL, 'serine/threonine-protein kinase TNNI3K isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(23499, NULL, 'G3DSA:3.80.10.10:FF:003671', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23500, NULL, 'G3DSA:3.10.400.20:FF:000012', NULL, NULL, 'Translation machinery-associated protein, putative', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(23501, NULL, 'G3DSA:4.10.520.10:FF:000003', NULL, NULL, 'Integration host factor subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(23502, NULL, 'G3DSA:3.30.40.10:FF:000527', NULL, NULL, 'Neuralized E3 ubiquitin protein ligase 3', NULL, NULL, NULL, NULL, NULL, 4),
(23503, NULL, 'G3DSA:3.10.20.90:FF:000697', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23504, NULL, 'G3DSA:1.20.120.160:FF:000020', NULL, NULL, 'Histidine phosphotransferase-1, variant 1', NULL, NULL, NULL, NULL, NULL, 4),
(23505, NULL, 'G3DSA:1.25.40.20:FF:000750', NULL, NULL, 'Ankyrin repeat domain 17', NULL, NULL, NULL, NULL, NULL, 4),
(23506, NULL, 'G3DSA:1.10.510.10:FF:000531', NULL, NULL, 'Wee1-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(23507, NULL, 'G3DSA:3.40.50.2000:FF:000212', NULL, NULL, 'Glycosyl transferase family 1', NULL, NULL, NULL, NULL, NULL, 4),
(23508, NULL, 'G3DSA:3.40.33.10:FF:000067', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(23509, NULL, 'G3DSA:3.40.50.300:FF:006173', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(23510, NULL, 'G3DSA:3.40.190.10:FF:000906', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23511, NULL, 'G3DSA:3.30.710.10:FF:000303', NULL, NULL, 'BTB/POZ and TAZ domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(23512, NULL, 'G3DSA:3.40.532.10:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23513, NULL, 'G3DSA:3.40.50.720:FF:001184', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(23514, NULL, 'G3DSA:3.30.160.60:FF:004486', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23515, NULL, 'G3DSA:3.60.40.10:FF:000369', NULL, NULL, 'Putative protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(23516, NULL, 'G3DSA:1.20.58.2220:FF:000019', NULL, NULL, 'Formin 1', NULL, NULL, NULL, NULL, NULL, 4),
(23517, NULL, 'G3DSA:1.10.12.70:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23518, NULL, 'G3DSA:1.10.720.50:FF:000002', NULL, NULL, 'DNA methyltransferase 3 alpha', NULL, NULL, NULL, NULL, NULL, 4),
(23519, NULL, 'G3DSA:1.10.10.10:FF:000413', NULL, NULL, 'Ribokinase', NULL, NULL, NULL, NULL, NULL, 4),
(23520, NULL, 'G3DSA:2.40.50.180:FF:000002', NULL, NULL, 'Chemotaxis protein CheW', NULL, NULL, NULL, NULL, NULL, 4),
(23521, NULL, 'G3DSA:2.130.10.10:FF:004222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23522, NULL, 'G3DSA:3.40.50.300:FF:002811', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(23523, NULL, 'G3DSA:3.30.70.1450:FF:000044', NULL, NULL, 'Sulfur deprivation response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(23524, NULL, 'G3DSA:3.30.70.330:FF:002652', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23525, NULL, 'G3DSA:3.40.50.1100:FF:000190', NULL, NULL, 'Threonine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(23526, NULL, 'G3DSA:3.30.70.330:FF:002034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23527, NULL, 'G3DSA:2.30.29.30:FF:001139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23528, NULL, 'G3DSA:3.40.1230.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23529, NULL, 'G3DSA:1.10.720.60:FF:000005', NULL, NULL, 'Enolase-phosphatase E1', NULL, NULL, NULL, NULL, NULL, 4),
(23530, NULL, 'G3DSA:3.40.50.300:FF:005071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23531, NULL, 'G3DSA:3.40.50.970:FF:000134', NULL, NULL, 'Pyruvate dehydrogenase E1 component subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(23532, NULL, 'G3DSA:1.20.1250.20:FF:000050', NULL, NULL, 'glucose-6-phosphate exchanger SLC37A2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(23533, NULL, 'G3DSA:1.20.120.1900:FF:000094', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(23534, NULL, 'G3DSA:2.60.120.40:FF:000023', NULL, NULL, 'tumor necrosis factor ligand superfamily member 8', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(23535, NULL, 'G3DSA:3.60.21.10:FF:000477', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(23536, NULL, 'G3DSA:3.10.20.90:FF:001006', NULL, NULL, 'Erythrocyte membrane protein band 4.1-like 5', NULL, NULL, NULL, NULL, NULL, 4),
(23537, NULL, 'G3DSA:3.30.830.10:FF:000043', NULL, NULL, 'Protease 3', NULL, NULL, NULL, NULL, NULL, 4),
(23538, NULL, 'G3DSA:3.40.1410.10:FF:000053', NULL, NULL, 'Transcriptional regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23539, NULL, 'G3DSA:1.25.10.10:FF:002864', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23540, NULL, 'G3DSA:1.10.630.10:FF:000478', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(23541, NULL, 'G3DSA:1.10.1600.10:FF:000037', NULL, NULL, 'Inverted repeat-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(23542, NULL, 'G3DSA:1.25.40.10:FF:002366', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g42450, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(23543, NULL, 'G3DSA:2.40.50.140:FF:001120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23544, NULL, 'G3DSA:3.40.640.10:FF:000161', NULL, NULL, 'Unplaced genomic scaffold supercont1.20, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(23545, NULL, 'G3DSA:3.30.559.10:FF:000260', NULL, NULL, 'Pelargonidin 3-O-(6-caffeoylglucoside) 5-O-(6-O-malonylglucoside) 4''''''-malonyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(23546, NULL, 'G3DSA:3.30.200.20:FF:001330', NULL, NULL, 'Kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(23547, NULL, 'G3DSA:2.130.10.10:FF:004429', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(23548, NULL, 'G3DSA:2.40.10.10:FF:000157', NULL, NULL, 'GH18608p', NULL, NULL, NULL, NULL, NULL, 4),
(23549, NULL, 'G3DSA:1.25.10.10:FF:000094', NULL, NULL, 'Serine/threonine-protein kinase mTOR', NULL, NULL, NULL, NULL, NULL, 4),
(23550, NULL, 'G3DSA:2.130.10.10:FF:001788', NULL, NULL, 'WD repeat-containing protein 91', NULL, NULL, NULL, NULL, NULL, 4),
(23551, NULL, 'G3DSA:3.40.50.300:FF:006791', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23552, NULL, 'G3DSA:1.10.10.10:FF:001695', NULL, NULL, 'Regulatory protein ArsR', NULL, NULL, NULL, NULL, NULL, 4),
(23553, NULL, 'G3DSA:1.20.1200.10:FF:000009', NULL, NULL, 'ATP/cobalamin adenosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(23554, NULL, 'G3DSA:2.10.110.10:FF:000210', NULL, NULL, 'Actin-binding LIM protein family, member 3', NULL, NULL, NULL, NULL, NULL, 4),
(23555, NULL, 'G3DSA:3.80.10.10:FF:003519', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23556, NULL, 'G3DSA:3.40.50.300:FF:000866', NULL, NULL, 'Molybdate ABC transporter ATP-binding protein ModF', NULL, NULL, NULL, NULL, NULL, 4),
(23557, NULL, 'G3DSA:3.40.50.300:FF:003300', NULL, NULL, 'Dynamin GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23558, NULL, 'G3DSA:1.10.1670.10:FF:000018', NULL, NULL, 'Endonuclease III', NULL, NULL, NULL, NULL, NULL, 4),
(23559, NULL, 'G3DSA:3.30.40.10:FF:002091', NULL, NULL, 'Putative E3 ubiquitin-protein ligase C36B7.05c', NULL, NULL, NULL, NULL, NULL, 4),
(23560, NULL, 'G3DSA:1.20.1730.10:FF:000010', NULL, NULL, 'Solute carrier family 5 member 2', NULL, NULL, NULL, NULL, NULL, 4),
(23561, NULL, 'G3DSA:2.60.40.150:FF:000644', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23562, NULL, 'G3DSA:3.80.10.10:FF:004008', NULL, NULL, 'Autophagy-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(23563, NULL, 'G3DSA:3.30.43.10:FF:000034', NULL, NULL, 'Purine hydroxylase gamma subunit apoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(23564, NULL, 'G3DSA:2.130.10.10:FF:000506', NULL, NULL, 'Protein NEDD1', NULL, NULL, NULL, NULL, NULL, 4),
(23565, NULL, 'G3DSA:2.130.10.10:FF:002277', NULL, NULL, 'WD domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(23566, NULL, 'G3DSA:2.170.270.10:FF:000077', NULL, NULL, 'protein msta', NULL, NULL, NULL, NULL, NULL, 4),
(23567, NULL, 'G3DSA:3.40.50.2000:FF:000830', NULL, NULL, 'Cell wall alpha-1,3-glucan synthase mok12', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(23568, NULL, 'G3DSA:3.40.50.720:FF:000610', NULL, NULL, 'Quinate 5-dehydrogenase QutB', NULL, NULL, NULL, NULL, NULL, 4),
(23569, NULL, 'G3DSA:3.40.50.10540:FF:000007', NULL, NULL, 'Cinnamoyl-CoA:phenyllactate CoA-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(23570, NULL, 'G3DSA:3.80.10.10:FF:001367', NULL, NULL, 'Leucine-rich repeat-containing protein 70', NULL, NULL, NULL, NULL, NULL, 4),
(23571, NULL, 'G3DSA:3.30.40.10:FF:000320', NULL, NULL, 'E3 ubiquitin-protein ligase RNF103 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(23572, NULL, 'G3DSA:1.10.10.10:FF:001610', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23573, NULL, 'G3DSA:3.90.1150.10:FF:000252', NULL, NULL, 'Aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(23574, NULL, 'G3DSA:3.30.420.10:FF:000669', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23575, NULL, 'G3DSA:1.25.10.10:FF:001667', NULL, NULL, 'Cullin-associated NEDD8-dissociated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(23576, NULL, 'G3DSA:2.170.260.40:FF:000001', NULL, NULL, '5''-3'' exoribonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(23577, NULL, 'G3DSA:3.90.550.10:FF:000457', NULL, NULL, 'Isoprenoid synthase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(23578, NULL, 'G3DSA:1.20.1070.10:FF:002191', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(23579, NULL, 'G3DSA:3.10.20.90:FF:000489', NULL, NULL, 'band 4.1-like protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(23580, NULL, 'G3DSA:1.25.40.10:FF:002804', NULL, NULL, 'Signal recognition particle subunit SRP72', NULL, NULL, NULL, NULL, NULL, 4),
(23581, NULL, 'G3DSA:1.20.1560.10:FF:000710', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23582, NULL, 'G3DSA:1.20.120.20:FF:000024', NULL, NULL, 'YALI0F24409p', NULL, NULL, NULL, NULL, NULL, 4),
(23583, NULL, 'G3DSA:1.10.10.10:FF:002066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23584, NULL, 'G3DSA:3.30.1360.10:FF:000034', NULL, NULL, 'DNA-directed RNA polymerase I and III 14 kDa polypeptide (AFU_orthologue AFUA_6G04610)', NULL, NULL, NULL, NULL, NULL, 4),
(23585, NULL, 'G3DSA:3.80.10.10:FF:003492', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(23586, NULL, 'G3DSA:2.130.10.10:FF:003997', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23587, NULL, 'G3DSA:3.30.200.20:FF:002550', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23588, NULL, 'G3DSA:2.120.10.30:FF:000541', NULL, NULL, 'Low density lipoprotein receptor-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(23589, NULL, 'G3DSA:2.60.120.650:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23590, NULL, 'G3DSA:3.40.50.300:FF:004374', NULL, NULL, 'Ribosylnicotinamide kinase', NULL, NULL, NULL, NULL, NULL, 4),
(23591, NULL, 'G3DSA:3.50.7.10:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23592, NULL, 'G3DSA:3.30.505.10:FF:000164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23593, NULL, 'G3DSA:1.25.40.10:FF:002692', NULL, NULL, 'Small glutamine-rich tetratricopeptide repeat-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(23594, NULL, 'G3DSA:1.10.150.240:FF:000064', NULL, NULL, 'Putative phosphoglycolate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(23595, NULL, 'G3DSA:2.60.40.3510:FF:000026', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(23596, NULL, 'G3DSA:2.40.160.210:FF:000004', NULL, NULL, 'Acyl-CoA thioesterase 2', NULL, NULL, NULL, NULL, NULL, 4),
(23597, NULL, 'G3DSA:2.30.40.10:FF:000041', NULL, NULL, 'Imidazolonepropionase', NULL, NULL, NULL, NULL, NULL, 4),
(23598, NULL, 'G3DSA:2.60.40.10:FF:000793', NULL, NULL, 'pikachurin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(23599, NULL, 'G3DSA:3.90.640.10:FF:000110', NULL, NULL, 'Chaperone protein DNAK, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23600, NULL, 'G3DSA:4.10.60.10:FF:000207', NULL, NULL, 'Branchpoint-bridging protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(23601, NULL, 'G3DSA:1.25.40.10:FF:002220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23602, NULL, 'G3DSA:3.40.50.2300:FF:000212', NULL, NULL, 'Stress response regulator/HFS transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(23603, NULL, 'G3DSA:3.10.20.30:FF:000106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23604, NULL, 'G3DSA:2.40.160.200:FF:000001', NULL, NULL, 'LURP-one-like protein (DUF567)', NULL, NULL, NULL, NULL, NULL, 4),
(23605, NULL, 'G3DSA:3.20.20.70:FF:000781', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23606, NULL, 'G3DSA:3.40.50.300:FF:001237', NULL, NULL, 'Dynamin-related protein 4C', NULL, NULL, NULL, NULL, NULL, 4),
(23607, NULL, 'G3DSA:3.30.70.20:FF:000066', NULL, NULL, 'Ferredoxin III', NULL, NULL, NULL, NULL, NULL, 4),
(23608, NULL, 'G3DSA:3.30.40.10:FF:001663', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23609, NULL, 'G3DSA:2.30.30.40:FF:000549', NULL, NULL, 'Discs, large homolog 4', NULL, NULL, NULL, NULL, NULL, 4),
(23610, NULL, 'G3DSA:1.20.1070.10:FF:001729', NULL, NULL, 'Calcitonin receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23611, NULL, 'G3DSA:3.40.50.10810:FF:000139', NULL, NULL, 'ATP-dependent helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23612, NULL, 'G3DSA:2.130.10.10:FF:004076', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(23613, NULL, 'G3DSA:3.30.160.60:FF:003030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23614, NULL, 'G3DSA:3.50.50.60:FF:000536', NULL, NULL, 'Thioredoxin reductase GliT', NULL, NULL, NULL, NULL, NULL, 4),
(23615, NULL, 'G3DSA:2.70.20.10:FF:000004', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(23616, NULL, 'G3DSA:3.80.10.10:FF:000939', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase GSO1', NULL, NULL, NULL, NULL, NULL, 4),
(23617, NULL, 'G3DSA:3.90.640.90:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23618, NULL, 'G3DSA:3.30.390.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23619, NULL, 'G3DSA:3.50.50.60:FF:000065', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(23620, NULL, 'G3DSA:1.10.510.10:FF:001312', NULL, NULL, 'Putative serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(23621, NULL, 'G3DSA:3.40.630.50:FF:000003', NULL, NULL, 'D-aminoacyl-tRNA deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(23622, NULL, 'G3DSA:3.30.60.20:FF:000094', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(23623, NULL, 'G3DSA:3.40.50.12780:FF:000011', NULL, NULL, 'Acetyl-coenzyme A synthetase 2-like, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(23624, NULL, 'G3DSA:3.40.50.300:FF:005037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23625, NULL, 'G3DSA:2.40.100.10:FF:000141', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(23626, NULL, 'G3DSA:2.130.10.10:FF:002895', NULL, NULL, 'Suppressor of mec-8 and unc-52 protein homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(23627, NULL, 'G3DSA:1.20.58.530:FF:000008', NULL, NULL, 'unconventional myosin-VIIa', NULL, NULL, NULL, NULL, NULL, 4),
(23628, NULL, 'G3DSA:3.30.200.20:FF:001976', NULL, NULL, 'Probable serine/threonine-protein kinase DDB_G0283301', NULL, NULL, NULL, NULL, NULL, 4),
(23629, NULL, 'G3DSA:2.60.40.150:FF:000318', NULL, NULL, 'AGAP000124-PA', NULL, NULL, NULL, NULL, NULL, 4),
(23630, NULL, 'G3DSA:1.10.3210.10:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23631, NULL, 'G3DSA:3.30.9.10:FF:000287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23632, NULL, 'G3DSA:3.40.50.720:FF:001863', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23633, NULL, 'G3DSA:2.60.200.20:FF:000164', NULL, NULL, 'nibrin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(23634, NULL, 'G3DSA:3.30.60.30:FF:000097', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(23635, NULL, 'G3DSA:2.60.120.260:FF:000490', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23636, NULL, 'G3DSA:3.40.50.1580:FF:000018', NULL, NULL, '5''-methylthioadenosine/S-adenosylhomocysteine nucleosidase', NULL, NULL, NULL, NULL, NULL, 4),
(23637, NULL, 'G3DSA:2.60.120.260:FF:000602', NULL, NULL, 'RING zinc finger-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(23638, NULL, 'G3DSA:2.60.40.790:FF:000044', NULL, NULL, 'Co-chaperone p23', NULL, NULL, NULL, NULL, NULL, 4),
(23639, NULL, 'G3DSA:3.30.2090.10:FF:000024', NULL, NULL, 'Transporter, AcrB/D/F family', NULL, NULL, NULL, NULL, NULL, 4),
(23640, NULL, 'G3DSA:3.40.50.360:FF:000013', NULL, NULL, 'Glutathione-regulated potassium-efflux system ancillary protein KefG', NULL, NULL, NULL, NULL, NULL, 4),
(23641, NULL, 'G3DSA:3.30.40.10:FF:000027', NULL, NULL, 'Pre-mRNA-processing factor 19, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23642, NULL, 'G3DSA:1.25.10.10:FF:002656', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23643, NULL, 'G3DSA:3.40.30.10:FF:000768', NULL, NULL, 'Iodothyronine deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(23644, NULL, 'G3DSA:3.40.50.1480:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23645, NULL, 'G3DSA:2.60.40.1180:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23646, NULL, 'G3DSA:1.20.200.10:FF:000022', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(23647, NULL, 'G3DSA:3.40.50.300:FF:006465', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23648, NULL, 'G3DSA:3.40.50.720:FF:001392', NULL, NULL, 'YALI0E20735p', NULL, NULL, NULL, NULL, NULL, 4),
(23649, NULL, 'G3DSA:1.10.10.10:FF:000885', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(23650, NULL, 'G3DSA:3.40.50.1440:FF:000061', NULL, NULL, 'Epsilon tubulin', NULL, NULL, NULL, NULL, NULL, 4),
(23651, NULL, 'G3DSA:3.40.50.1240:FF:000181', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23652, NULL, 'G3DSA:3.30.70.330:FF:002152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23653, NULL, 'G3DSA:2.60.40.10:FF:000736', NULL, NULL, 'Junctional adhesion molecule-like', NULL, NULL, NULL, NULL, NULL, 4),
(23654, NULL, 'G3DSA:3.30.1640.10:FF:000016', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(23655, NULL, 'G3DSA:2.70.240.20:FF:000001', NULL, NULL, 'Heat-labile hemolysin', NULL, NULL, NULL, NULL, NULL, 4),
(23656, NULL, 'G3DSA:3.90.70.10:FF:000807', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23657, NULL, 'G3DSA:3.60.10.10:FF:000221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23658, NULL, 'G3DSA:3.30.540.10:FF:000088', NULL, NULL, 'Nucleotidase 4F8, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23659, NULL, 'G3DSA:4.10.60.10:FF:000095', NULL, NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(23660, NULL, 'G3DSA:3.30.2160.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23661, NULL, 'G3DSA:3.30.450.20:FF:000325', NULL, NULL, 'Period circadian protein homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(23662, NULL, 'G3DSA:3.40.630.60:FF:000006', NULL, NULL, 'Ornithine decarboxylase antizyme', NULL, NULL, NULL, NULL, NULL, 4),
(23663, NULL, 'G3DSA:3.30.230.10:FF:000014', NULL, NULL, 'DNA mismatch repair protein Mlh1', NULL, NULL, NULL, NULL, NULL, 4),
(23664, NULL, 'G3DSA:3.40.50.720:FF:001919', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23665, NULL, 'G3DSA:1.10.10.10:FF:000621', NULL, NULL, 'DEAD/DEAH box helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23666, NULL, 'G3DSA:2.120.10.80:FF:000387', NULL, NULL, 'Tip elongation aberrant protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(23667, NULL, 'G3DSA:1.25.40.10:FF:004018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23668, NULL, 'G3DSA:3.40.640.10:FF:000127', NULL, NULL, 'Aromatic amino acid aminotransferase C56E4.03', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(23669, NULL, 'G3DSA:3.90.1410.10:FF:000143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23670, NULL, 'G3DSA:2.130.10.10:FF:003412', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase, putative (AFU_orthologue AFUA_1G01750)', NULL, NULL, NULL, NULL, NULL, 4),
(23671, NULL, 'G3DSA:2.60.40.10:FF:002827', NULL, NULL, 'Semaphorin-2A', NULL, NULL, NULL, NULL, NULL, 4),
(23672, NULL, 'G3DSA:3.30.200.20:FF:001122', NULL, NULL, 'Serine/threonine-protein kinase par-4', NULL, NULL, NULL, NULL, NULL, 4),
(23673, NULL, 'G3DSA:3.40.190.80:FF:000085', NULL, NULL, 'Inositol monophosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(23674, NULL, 'G3DSA:3.40.50.1000:FF:000485', NULL, NULL, 'GH05933p', NULL, NULL, NULL, NULL, NULL, 4),
(23675, NULL, 'G3DSA:3.40.630.70:FF:000009', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(23676, NULL, 'G3DSA:1.10.10.10:FF:001402', NULL, NULL, 'Repressor protein c', NULL, NULL, NULL, NULL, NULL, 4),
(23677, NULL, 'G3DSA:1.25.10.10:FF:001993', NULL, NULL, 'U3 small nucleolar RNA-associated protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(23678, NULL, 'G3DSA:3.80.10.10:FF:002064', NULL, NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', NULL, NULL, NULL, NULL, NULL, 4),
(23679, NULL, 'G3DSA:2.130.10.10:FF:002631', NULL, NULL, 'Wdr36 protein', NULL, NULL, NULL, NULL, NULL, 4),
(23680, NULL, 'G3DSA:3.40.850.10:FF:000261', NULL, NULL, 'Kinesin-6 like protein', NULL, NULL, NULL, NULL, NULL, 4),
(23681, NULL, 'G3DSA:1.20.272.10:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23682, NULL, 'G3DSA:3.40.50.300:FF:008589', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23683, NULL, 'G3DSA:1.25.40.10:FF:000067', NULL, NULL, 'Cell division cycle protein 16 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(23684, NULL, 'G3DSA:1.10.287.130:FF:000108', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(23685, NULL, 'G3DSA:1.20.1560.10:FF:000031', NULL, NULL, 'ATP-binding cassette sub-family B member 9', NULL, NULL, NULL, NULL, NULL, 4),
(23686, NULL, 'G3DSA:3.10.129.10:FF:000075', NULL, NULL, 'Thioesterase family protein, putaive', NULL, NULL, NULL, NULL, NULL, 4),
(23687, NULL, 'G3DSA:2.60.40.10:FF:002119', NULL, NULL, 'Matrix remodeling associated 5', NULL, NULL, NULL, NULL, NULL, 4),
(23688, NULL, 'G3DSA:1.25.10.10:FF:000947', NULL, NULL, 'Ubiquitin-binding TORC1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(23689, NULL, 'G3DSA:2.20.70.10:FF:000122', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(23690, NULL, 'G3DSA:1.20.1280.20:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23691, NULL, 'G3DSA:2.70.150.10:FF:000137', NULL, NULL, 'Sarcoplasmic/endoplasmic reticulum calcium ATPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(23692, NULL, 'G3DSA:1.20.1250.20:FF:001685', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23693, NULL, 'G3DSA:3.30.565.10:FF:000555', NULL, NULL, 'Coatomer subunit beta''-3', NULL, NULL, NULL, NULL, NULL, 4),
(23694, NULL, 'G3DSA:3.30.160.60:FF:004873', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23695, NULL, 'G3DSA:3.40.50.720:FF:002173', NULL, NULL, 'Os07g0674100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(23696, NULL, 'G3DSA:3.30.2130.10:FF:000017', NULL, NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(23697, NULL, 'G3DSA:1.10.150.20:FF:000017', NULL, NULL, 'DNA excision repair protein ERCC-1', NULL, NULL, NULL, NULL, NULL, 4),
(23698, NULL, 'G3DSA:3.30.200.20:FF:000195', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(23699, NULL, 'G3DSA:3.90.470.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23700, NULL, 'G3DSA:3.40.50.12230:FF:000020', NULL, NULL, 'Methionyl-trna formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(23701, NULL, 'G3DSA:1.25.40.180:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(23702, NULL, 'G3DSA:3.40.50.300:FF:006408', NULL, NULL, 'RAB20, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(23703, NULL, 'G3DSA:3.40.50.720:FF:001599', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(23704, NULL, 'G3DSA:2.70.150.10:FF:000019', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(23705, NULL, 'G3DSA:1.10.472.10:FF:000604', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23706, NULL, 'G3DSA:3.50.50.60:FF:000744', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(23707, NULL, 'G3DSA:1.20.1560.10:FF:000502', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(23708, NULL, 'G3DSA:6.20.50.160:FF:000002', NULL, NULL, 'Thioester-containing protein 2, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(23709, NULL, 'G3DSA:3.30.160.60:FF:002687', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23710, NULL, 'G3DSA:1.10.730.10:FF:000160', NULL, NULL, 'Methionine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(23711, NULL, 'G3DSA:3.40.50.2300:FF:000476', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(23712, NULL, 'G3DSA:2.60.40.60:FF:000375', NULL, NULL, 'Protocadherin 12', NULL, NULL, NULL, NULL, NULL, 4),
(23713, NULL, 'G3DSA:3.40.50.300:FF:001029', NULL, NULL, 'NLR family member X1', NULL, NULL, NULL, NULL, NULL, 4),
(23714, NULL, 'G3DSA:1.10.30.10:FF:000089', NULL, NULL, 'high mobility group B protein 7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(23715, NULL, 'G3DSA:2.60.40.2030:FF:000048', NULL, NULL, 'Adhesion G-protein coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(23716, NULL, 'G3DSA:1.10.8.270:FF:000141', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(23717, NULL, 'G3DSA:3.20.100.10:FF:000001', NULL, NULL, 'mRNA-capping enzyme subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(23718, NULL, 'G3DSA:2.60.120.260:FF:000309', NULL, NULL, 'M28 family peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(23719, NULL, 'G3DSA:3.30.40.10:FF:000292', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(23720, NULL, 'G3DSA:1.10.3970.10:FF:000002', NULL, NULL, 'Putative RNA polymerase II transcription factor B subunit 1-1', NULL, NULL, NULL, NULL, NULL, 4),
(23721, NULL, 'G3DSA:3.40.50.2000:FF:000504', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(23722, NULL, 'G3DSA:2.60.34.10:FF:000054', NULL, NULL, 'Heat shock protein family A (Hsp70) member 4', NULL, NULL, NULL, NULL, NULL, 4),
(23723, NULL, 'G3DSA:3.10.100.10:FF:000172', NULL, NULL, 'macrophage mannose receptor 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(23724, NULL, 'G3DSA:1.25.10.10:FF:000239', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(23725, NULL, 'G3DSA:2.120.10.80:FF:000180', NULL, NULL, 'Kelch motif family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(23726, NULL, 'G3DSA:1.20.5.880:FF:000001', NULL, NULL, 'Photosystem II reaction center protein H', NULL, NULL, NULL, NULL, NULL, 4),
(23727, NULL, 'G3DSA:3.30.420.40:FF:000419', NULL, NULL, 'Actin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23728, NULL, 'G3DSA:3.40.190.10:FF:000171', NULL, NULL, 'Transcriptional regulator LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(23729, NULL, 'G3DSA:2.120.10.80:FF:000123', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(23730, NULL, 'G3DSA:3.90.226.10:FF:000069', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(23731, NULL, 'G3DSA:3.40.50.620:FF:000344', NULL, NULL, 'Isoleucine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(23732, NULL, 'G3DSA:2.130.10.10:FF:005975', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23733, NULL, 'G3DSA:2.170.140.10:FF:000040', NULL, NULL, 'peritrophin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(23734, NULL, 'G3DSA:1.10.1820.10:FF:000020', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(23735, NULL, 'G3DSA:2.30.30.210:FF:000009', NULL, NULL, 'Ribonuclease P protein subunit POP4', NULL, NULL, NULL, NULL, NULL, 4),
(23736, NULL, 'G3DSA:3.10.350.10:FF:000038', NULL, NULL, 'Morphogenetic protein associated', NULL, NULL, NULL, NULL, NULL, 4),
(23737, NULL, 'G3DSA:3.90.550.10:FF:000249', NULL, NULL, 'Procollagen-lysine,2-oxoglutarate 5-dioxygenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(23738, NULL, 'G3DSA:3.30.160.60:FF:000478', NULL, NULL, 'Zinc finger protein 133', NULL, NULL, NULL, NULL, NULL, 4),
(23739, NULL, 'G3DSA:3.30.300.130:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23740, NULL, 'G3DSA:1.10.287.1490:FF:000118', NULL, NULL, 'Viral A-type inclusion protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23741, NULL, 'G3DSA:3.80.10.10:FF:003963', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23742, NULL, 'G3DSA:1.10.238.10:FF:000869', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23743, NULL, 'G3DSA:3.40.20.10:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23744, NULL, 'G3DSA:1.25.10.10:FF:002538', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(23745, NULL, 'G3DSA:1.10.286.10:FF:000008', NULL, NULL, 'GTP cyclohydrolase I 1', NULL, NULL, NULL, NULL, NULL, 4),
(23746, NULL, 'G3DSA:3.60.21.10:FF:000185', NULL, NULL, '5-nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(23747, NULL, 'G3DSA:3.30.830.10:FF:000335', NULL, NULL, 'Proteasome 26S subunit, ATPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(23748, NULL, 'G3DSA:1.10.238.10:FF:000605', NULL, NULL, 'EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(23749, NULL, 'G3DSA:1.25.40.20:FF:001059', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(23750, NULL, 'G3DSA:1.20.1070.10:FF:000948', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23751, NULL, 'G3DSA:2.130.10.10:FF:003620', NULL, NULL, 'WD repeat-containing protein DDB_G0290555', NULL, NULL, NULL, NULL, NULL, 4),
(23752, NULL, 'G3DSA:3.30.70.330:FF:002360', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23753, NULL, 'G3DSA:2.60.120.200:FF:000045', NULL, NULL, 'Transmembrane agrin', NULL, NULL, NULL, NULL, NULL, 4),
(23754, NULL, 'G3DSA:3.30.160.20:FF:000106', NULL, NULL, 'R2D2', NULL, NULL, NULL, NULL, NULL, 4),
(23755, NULL, 'G3DSA:1.10.220.160:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23756, NULL, 'G3DSA:3.10.28.10:FF:000011', NULL, NULL, 'Intron-encoded DNA endonuclease aI3', NULL, NULL, NULL, NULL, NULL, 4),
(23757, NULL, 'G3DSA:3.90.930.12:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23758, NULL, 'G3DSA:3.40.309.10:FF:000043', NULL, NULL, '10-formyltetrahydrofolate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(23759, NULL, 'G3DSA:1.10.246.130:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23760, NULL, 'G3DSA:3.30.70.330:FF:002208', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23761, NULL, 'G3DSA:3.40.50.300:FF:002665', NULL, NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(23762, NULL, 'G3DSA:1.10.220.150:FF:000025', NULL, NULL, 'GTPase-activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23763, NULL, 'G3DSA:3.40.1350.10:FF:000048', NULL, NULL, 'Heat shock 70 kDa protein cognate 4-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(23764, NULL, 'G3DSA:2.30.30.30:FF:000075', NULL, NULL, 'Transcription termination/antitermination protein NusG', NULL, NULL, NULL, NULL, NULL, 4),
(23765, NULL, 'G3DSA:3.30.40.10:FF:000235', NULL, NULL, 'E3 ubiquitin-protein ligase ZNRF1', NULL, NULL, NULL, NULL, NULL, 4),
(23766, NULL, 'G3DSA:1.25.40.10:FF:003001', NULL, NULL, 'Os10g0442700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(23767, NULL, 'G3DSA:1.10.510.10:FF:002447', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23768, NULL, 'G3DSA:3.30.497.10:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23769, NULL, 'G3DSA:3.40.50.300:FF:001501', NULL, NULL, 'Chromatin remodeling factor18', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(23770, NULL, 'G3DSA:3.30.70.980:FF:000048', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(23771, NULL, 'G3DSA:1.10.418.10:FF:000142', NULL, NULL, 'Neuron navigator 2', NULL, NULL, NULL, NULL, NULL, 4),
(23772, NULL, 'G3DSA:2.60.40.10:FF:004418', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23773, NULL, 'G3DSA:3.30.420.40:FF:000571', NULL, NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(23774, NULL, 'G3DSA:3.40.640.10:FF:000335', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23775, NULL, 'G3DSA:2.40.128.630:FF:000003', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(23776, NULL, 'G3DSA:3.30.40.10:FF:002326', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23777, NULL, 'G3DSA:2.60.40.10:FF:004536', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23778, NULL, 'G3DSA:3.30.1520.10:FF:000007', NULL, NULL, 'sorting nexin-14 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(23779, NULL, 'G3DSA:2.130.10.10:FF:004194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23780, NULL, 'G3DSA:3.30.200.20:FF:000307', NULL, NULL, 'pollen receptor-like kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(23781, NULL, 'G3DSA:3.40.220.10:FF:000022', NULL, NULL, 'Blast:O-acetyl-ADP-ribose deacetylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(23782, NULL, 'G3DSA:3.40.50.300:FF:000574', NULL, NULL, '116 kDa U5 small nuclear ribonucleoprotein component', NULL, NULL, NULL, NULL, NULL, 4),
(23783, NULL, 'G3DSA:3.30.890.10:FF:000018', NULL, NULL, 'Methyl-CpG-binding domain protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(23784, NULL, 'G3DSA:3.90.1640.10:FF:000008', NULL, NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(23785, NULL, 'G3DSA:3.80.10.10:FF:001193', NULL, NULL, 'Leucine-rich repeat receptor protein kinase EMS1', NULL, NULL, NULL, NULL, NULL, 4),
(23786, NULL, 'G3DSA:3.30.1320.10:FF:000026', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(23787, NULL, 'G3DSA:3.30.1600.10:FF:000008', NULL, NULL, 'NAD-dependent protein deacetylase sirtuin-1', NULL, NULL, NULL, NULL, NULL, 4),
(23788, NULL, 'G3DSA:3.40.630.10:FF:000396', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(23789, NULL, 'G3DSA:1.10.10.2830:FF:000002', NULL, NULL, 'ParB-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(23790, NULL, 'G3DSA:1.20.5.320:FF:000002', NULL, NULL, '6-phosphogluconate dehydrogenase, decarboxylating', NULL, NULL, NULL, NULL, NULL, 4),
(23791, NULL, 'G3DSA:1.10.10.2840:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23792, NULL, 'G3DSA:3.30.160.60:FF:002833', NULL, NULL, 'GL12085', NULL, NULL, NULL, NULL, NULL, 4),
(23793, NULL, 'G3DSA:3.10.110.10:FF:000049', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(23794, NULL, 'G3DSA:3.10.330.10:FF:000032', NULL, NULL, 'Ubiquitin fusion degradation protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23795, NULL, 'G3DSA:3.40.630.10:FF:000508', NULL, NULL, 'Protein CBG24539', NULL, NULL, NULL, NULL, NULL, 4),
(23796, NULL, 'G3DSA:3.90.79.10:FF:000119', NULL, NULL, 'Pre-mRNA cleavage factor I 25 kDa subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23797, NULL, 'G3DSA:1.20.58.860:FF:000023', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(23798, NULL, 'G3DSA:3.30.565.10:FF:000347', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One component system)', NULL, NULL, NULL, NULL, NULL, 4),
(23799, NULL, 'G3DSA:2.30.42.10:FF:000023', NULL, NULL, 'Glutamate receptor interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(23800, NULL, 'G3DSA:3.40.390.10:FF:000152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23801, NULL, 'G3DSA:2.40.10.10:FF:000365', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23802, NULL, 'G3DSA:3.40.50.10240:FF:000007', NULL, NULL, 'Thiamine pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(23803, NULL, 'G3DSA:2.130.10.10:FF:005003', NULL, NULL, 'Probable cytosolic iron-sulfur protein assembly protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(23804, NULL, 'G3DSA:1.20.1250.20:FF:001477', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23805, NULL, 'G3DSA:1.25.40.10:FF:002427', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(23806, NULL, 'G3DSA:3.40.50.150:FF:000506', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(23807, NULL, 'G3DSA:3.40.525.10:FF:000056', NULL, NULL, 'Protein tyrosine phosphatase, non-receptor type 9', NULL, NULL, NULL, NULL, NULL, 4),
(23808, NULL, 'G3DSA:3.10.20.90:FF:000725', NULL, NULL, 'Polyubiquitin 8', NULL, NULL, NULL, NULL, NULL, 4),
(23809, NULL, 'G3DSA:2.60.40.60:FF:000583', NULL, NULL, 'FAT atypical cadherin 1b', NULL, NULL, NULL, NULL, NULL, 4),
(23810, NULL, 'G3DSA:1.20.58.60:FF:000886', NULL, NULL, 'Dystrophin isoform Dp116', NULL, NULL, NULL, NULL, NULL, 4),
(23811, NULL, 'G3DSA:1.20.1250.20:FF:001831', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23812, NULL, 'G3DSA:1.10.30.50:FF:000022', NULL, NULL, 'Gll1669 protein', NULL, NULL, NULL, NULL, NULL, 4),
(23813, NULL, 'G3DSA:3.40.50.300:FF:000984', NULL, NULL, 'Chromosome partition protein Smc', NULL, NULL, NULL, NULL, NULL, 4),
(23814, NULL, 'G3DSA:4.10.410.20:FF:000003', NULL, NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(23815, NULL, 'G3DSA:3.90.190.10:FF:000120', NULL, NULL, 'MAP kinase phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23816, NULL, 'G3DSA:3.80.10.10:FF:001754', NULL, NULL, 'Putative disease resistance protein At3g14460', NULL, NULL, NULL, NULL, NULL, 4),
(23817, NULL, 'G3DSA:2.60.40.150:FF:000583', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(23818, NULL, 'G3DSA:1.20.1560.10:FF:000002', NULL, NULL, 'ABC transporter C family member 5', NULL, NULL, NULL, NULL, NULL, 4),
(23819, NULL, 'G3DSA:1.10.340.30:FF:000063', NULL, NULL, '8-oxoguanine DNA glycosylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23820, NULL, 'G3DSA:1.10.260.40:FF:000008', NULL, NULL, 'Fructose repressor (Catabolite repressor/activator)', NULL, NULL, NULL, NULL, NULL, 4),
(23821, NULL, 'G3DSA:3.30.530.20:FF:000208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23822, NULL, 'G3DSA:1.25.10.10:FF:000447', NULL, NULL, 'RIC8 guanine nucleotide exchange factor A', NULL, NULL, NULL, NULL, NULL, 4),
(23823, NULL, 'G3DSA:2.160.10.10:FF:000090', NULL, NULL, '2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(23824, NULL, 'G3DSA:1.20.120.1750:FF:000088', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(23825, NULL, 'G3DSA:3.90.226.10:FF:000277', NULL, NULL, 'Enoyl-CoA hydratase/isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(23826, NULL, 'G3DSA:1.10.1140.10:FF:000018', NULL, NULL, 'V-type proton ATPase catalytic subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(23827, NULL, 'G3DSA:3.30.200.20:FF:002140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23828, NULL, 'G3DSA:2.60.40.1510:FF:000044', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(23829, NULL, 'G3DSA:3.40.50.2000:FF:000004', NULL, NULL, 'Sucrose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(23830, NULL, 'G3DSA:2.40.50.40:FF:000090', NULL, NULL, 'Viral macrophage inflammatory protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(23831, NULL, 'G3DSA:3.50.30.30:FF:000167', NULL, NULL, 'Probable aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(23832, NULL, 'G3DSA:2.60.60.20:FF:000010', NULL, NULL, 'hepatic triacylglycerol lipase', NULL, NULL, NULL, NULL, NULL, 4),
(23833, NULL, 'G3DSA:2.40.50.40:FF:000033', NULL, NULL, 'C-C motif chemokine 1', NULL, NULL, NULL, NULL, NULL, 4),
(23834, NULL, 'G3DSA:3.90.1150.10:FF:000044', NULL, NULL, 'Low-specificity L-threonine aldolase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(23835, NULL, 'G3DSA:2.60.40.640:FF:000050', NULL, NULL, 'Vacuolar sorting protein 26, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23836, NULL, 'G3DSA:3.40.50.720:FF:002116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23837, NULL, 'G3DSA:3.30.70.60:FF:000022', NULL, NULL, 'Mitochondrial Ribosomal Protein, Small', NULL, NULL, NULL, NULL, NULL, 4),
(23838, NULL, 'G3DSA:1.10.490.160:FF:000003', NULL, NULL, 'Ryanodine receptor, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(23839, NULL, 'G3DSA:1.10.4160.10:FF:000020', NULL, NULL, 'Putative cytosine permease', NULL, NULL, NULL, NULL, NULL, 4),
(23840, NULL, 'G3DSA:3.10.129.10:FF:000193', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(23841, NULL, 'G3DSA:1.10.357.10:FF:000062', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(23842, NULL, 'G3DSA:3.80.10.10:FF:003553', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23843, NULL, 'G3DSA:3.40.1280.10:FF:000020', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4),
(23844, NULL, 'G3DSA:3.50.50.60:FF:000126', NULL, NULL, '3-(3-hydroxy-phenyl)propionate/3-hydroxycinnamic acid hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(23845, NULL, 'G3DSA:3.40.50.300:FF:004727', NULL, NULL, 'ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23846, NULL, 'G3DSA:3.30.1370.10:FF:000124', NULL, NULL, 'Scp160p', NULL, NULL, NULL, NULL, NULL, 4),
(23847, NULL, 'G3DSA:1.10.3080.10:FF:000047', NULL, NULL, 'Sll0855 protein', NULL, NULL, NULL, NULL, NULL, 4),
(23848, NULL, 'G3DSA:3.40.50.300:FF:001030', NULL, NULL, 'Dynamin-related protein 5A', NULL, NULL, NULL, NULL, NULL, 4),
(23849, NULL, 'G3DSA:2.30.42.10:FF:000641', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23850, NULL, 'G3DSA:1.20.1250.20:FF:000049', NULL, NULL, 'Solute carrier family 15 member 2', NULL, NULL, NULL, NULL, NULL, 4),
(23851, NULL, 'G3DSA:1.25.40.20:FF:000632', NULL, NULL, 'Acyl-CoA-binding domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(23852, NULL, 'G3DSA:3.30.160.60:FF:001405', NULL, NULL, 'Zinc finger protein 398', NULL, NULL, NULL, NULL, NULL, 4),
(23853, NULL, 'G3DSA:3.40.47.10:FF:000216', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23854, NULL, 'G3DSA:3.40.50.1000:FF:000367', NULL, NULL, 'Haloacid dehalogenase family hydrolase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(23855, NULL, 'G3DSA:1.10.60.10:FF:000006', NULL, NULL, 'DtxR family iron (Metal) dependent repressor', NULL, NULL, NULL, NULL, NULL, 4),
(23856, NULL, 'G3DSA:1.10.560.10:FF:000034', NULL, NULL, 'T-complex protein 1 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(23857, NULL, 'G3DSA:1.10.287.10:FF:000033', NULL, NULL, 'Prolyl Amino-acyl tRNA Synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(23858, NULL, 'G3DSA:1.10.10.10:FF:000475', NULL, NULL, 'HTH-type transcriptional regulator mcbR', NULL, NULL, NULL, NULL, NULL, 4),
(23859, NULL, 'G3DSA:3.30.1640.10:FF:000073', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(23860, NULL, 'G3DSA:1.10.10.1070:FF:000002', NULL, NULL, 'Hermes transposase', NULL, NULL, NULL, NULL, NULL, 4),
(23861, NULL, 'G3DSA:1.10.1300.10:FF:000025', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(23862, NULL, 'G3DSA:2.130.10.10:FF:002485', NULL, NULL, 'VPS10 homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(23863, NULL, 'G3DSA:3.50.50.60:FF:000183', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(23864, NULL, 'G3DSA:2.120.10.80:FF:000241', NULL, NULL, 'tRNA wybutosine-synthesizing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(23865, NULL, 'G3DSA:1.20.120.230:FF:000064', NULL, NULL, 'Vinculin', NULL, NULL, NULL, NULL, NULL, 4),
(23866, NULL, 'G3DSA:2.170.120.12:FF:000024', NULL, NULL, 'RNA polymerase Rpb3/RpoA insert domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(23867, NULL, 'G3DSA:3.90.45.10:FF:000002', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(23868, NULL, 'G3DSA:2.40.30.10:FF:000074', NULL, NULL, '50S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(23869, NULL, 'G3DSA:1.10.287.1080:FF:000001', NULL, NULL, 'Nucleoside triphosphate pyrophosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(23870, NULL, 'G3DSA:3.80.10.10:FF:004216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23871, NULL, 'G3DSA:3.40.50.1820:FF:001097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23872, NULL, 'G3DSA:3.30.200.20:FF:000341', NULL, NULL, 'MAP kinase kinase PBS2', NULL, NULL, NULL, NULL, NULL, 4),
(23873, NULL, 'G3DSA:3.30.1140.32:FF:000020', NULL, NULL, '40S ribosomal protein S3-3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23874, NULL, 'G3DSA:4.10.860.10:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23875, NULL, 'G3DSA:1.25.10.10:FF:002802', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23876, NULL, 'G3DSA:3.30.230.10:FF:000132', NULL, NULL, 'MeValonate Kinase', NULL, NULL, NULL, NULL, NULL, 4),
(23877, NULL, 'G3DSA:2.60.40.1080:FF:000016', NULL, NULL, 'Peptidase, S8/S53 family', NULL, NULL, NULL, NULL, NULL, 4),
(23878, NULL, 'G3DSA:2.60.120.290:FF:000240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23879, NULL, 'G3DSA:3.30.70.330:FF:000090', NULL, NULL, 'RNA-binding protein 39 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(23880, NULL, 'G3DSA:3.10.310.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23881, NULL, 'G3DSA:1.25.40.10:FF:004075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23882, NULL, 'G3DSA:2.10.25.10:FF:001092', NULL, NULL, 'Stabilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(23883, NULL, 'G3DSA:2.170.140.10:FF:000039', NULL, NULL, 'Mucin related 89F, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(23884, NULL, 'G3DSA:2.60.40.10:FF:000675', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(23885, NULL, 'G3DSA:2.40.50.100:FF:000052', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(23886, NULL, 'G3DSA:3.30.70.330:FF:001955', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23887, NULL, 'G3DSA:1.20.5.220:FF:000005', NULL, NULL, 'cytochrome b-c1 complex subunit 10', NULL, NULL, NULL, NULL, NULL, 4),
(23888, NULL, 'G3DSA:2.130.10.10:FF:001203', NULL, NULL, 'F-box/WD repeat-containing protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(23889, NULL, 'G3DSA:1.10.510.10:FF:002655', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23890, NULL, 'G3DSA:1.20.930.40:FF:000013', NULL, NULL, 'putative N-acetylated-alpha-linked acidic dipeptidase isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(23891, NULL, 'G3DSA:2.130.10.10:FF:001260', NULL, NULL, 'UTP9p Nucleolar protein', NULL, NULL, NULL, NULL, NULL, 4),
(23892, NULL, 'G3DSA:3.40.50.300:FF:003800', NULL, NULL, 'Guanine nucleotide-binding protein G(k) subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(23893, NULL, 'G3DSA:1.10.470.10:FF:000004', NULL, NULL, 'Variant surface glycoprotein (VSG), putative', NULL, NULL, NULL, NULL, NULL, 4),
(23894, NULL, 'G3DSA:1.25.40.930:FF:000001', NULL, NULL, 'Spindle checkpoint complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(23895, NULL, 'G3DSA:3.90.79.10:FF:000209', NULL, NULL, 'A/G-specific adenine glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(23896, NULL, 'G3DSA:1.20.1000.10:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23897, NULL, 'G3DSA:1.10.340.30:FF:000006', NULL, NULL, 'N-glycosylase/DNA lyase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(23898, NULL, 'G3DSA:3.40.50.300:FF:004520', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(23899, NULL, 'G3DSA:1.25.40.20:FF:000278', NULL, NULL, 'espin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(23900, NULL, 'G3DSA:1.25.10.10:FF:001875', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23901, NULL, 'G3DSA:2.120.10.30:FF:000333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(23902, NULL, 'G3DSA:3.80.10.10:FF:003199', NULL, NULL, 'AT02038p', NULL, NULL, NULL, NULL, NULL, 4),
(23903, NULL, 'G3DSA:3.10.20.90:FF:000635', NULL, NULL, 'Autophagy-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(23904, NULL, 'G3DSA:1.10.510.10:FF:001520', NULL, NULL, 'Tyrosine-protein kinase Wsck', NULL, NULL, NULL, NULL, NULL, 4),
(23905, NULL, 'G3DSA:3.90.70.10:FF:000454', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23906, NULL, 'G3DSA:2.130.10.30:FF:000080', NULL, NULL, 'E3 ubiquitin-protein ligase rpm-1', NULL, NULL, NULL, NULL, NULL, 4),
(23907, NULL, 'G3DSA:3.50.7.10:FF:000007', NULL, NULL, '1-phosphatidylinositol 3-phosphate 5-kinase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(23908, NULL, 'G3DSA:3.40.50.1000:FF:000721', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23909, NULL, 'G3DSA:2.40.50.140:FF:000423', NULL, NULL, 'rRNA biogenesis protein RRP5', NULL, NULL, NULL, NULL, NULL, 4),
(23910, NULL, 'G3DSA:3.30.450.20:FF:000207', NULL, NULL, 'Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(23911, NULL, 'G3DSA:1.10.510.10:FF:002094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23912, NULL, 'G3DSA:3.40.630.30:FF:000666', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(23913, NULL, 'G3DSA:3.30.70.2760:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23914, NULL, 'G3DSA:2.30.170.40:FF:000010', NULL, NULL, '50S ribosomal protein L28', NULL, NULL, NULL, NULL, NULL, 4),
(23915, NULL, 'G3DSA:3.60.10.10:FF:000103', NULL, NULL, 'Type I inositol-1,4,5-trisphosphate 5-phosphatase CVP2', NULL, NULL, NULL, NULL, NULL, 4),
(23916, NULL, 'G3DSA:3.90.550.50:FF:000154', NULL, NULL, 'Fringe-related-like', NULL, NULL, NULL, NULL, NULL, 4),
(23917, NULL, 'G3DSA:2.30.42.10:FF:000080', NULL, NULL, 'Syntrophin gamma 1', NULL, NULL, NULL, NULL, NULL, 4),
(23918, NULL, 'G3DSA:3.40.50.10140:FF:000011', NULL, NULL, 'single Ig IL-1-related receptor isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(23919, NULL, 'G3DSA:2.10.25.10:FF:001822', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23920, NULL, 'G3DSA:3.40.50.300:FF:006673', NULL, NULL, 'ADP ribosylation factor-like GTPase 6', NULL, NULL, NULL, NULL, NULL, 4),
(23921, NULL, 'G3DSA:1.25.40.20:FF:001205', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(23922, NULL, 'G3DSA:1.10.472.10:FF:000492', NULL, NULL, 'Cyclin A3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23923, NULL, 'G3DSA:3.40.390.10:FF:000242', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23924, NULL, 'G3DSA:1.10.20.10:FF:000240', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23925, NULL, 'G3DSA:3.30.160.60:FF:005093', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23926, NULL, 'G3DSA:2.40.70.10:FF:000458', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23927, NULL, 'G3DSA:3.30.160.60:FF:004278', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23928, NULL, 'G3DSA:2.40.37.10:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23929, NULL, 'G3DSA:1.10.510.10:FF:001166', NULL, NULL, 'Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(23930, NULL, 'G3DSA:1.10.533.10:FF:000067', NULL, NULL, 'NLR family pyrin domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(23931, NULL, 'G3DSA:3.30.200.20:FF:000902', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(23932, NULL, 'G3DSA:3.90.550.10:FF:000603', NULL, NULL, 'Probable beta-1,4 N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(23933, NULL, 'G3DSA:2.20.25.210:FF:000002', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(23934, NULL, 'G3DSA:2.60.40.150:FF:000526', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23935, NULL, 'G3DSA:2.160.20.10:FF:000028', NULL, NULL, 'Polygalacturonase QRT2', NULL, NULL, NULL, NULL, NULL, 4),
(23936, NULL, 'G3DSA:1.20.150.30:FF:000001', NULL, NULL, 'Hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(23937, NULL, 'G3DSA:3.40.50.880:FF:000017', NULL, NULL, 'Type 1 glutamine amidotransferase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(23938, NULL, 'G3DSA:2.60.40.10:FF:000528', NULL, NULL, 'Neural cell adhesion molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(23939, NULL, 'G3DSA:3.40.140.10:FF:000134', NULL, NULL, 'Riboflavin biosynthesis protein RibD', NULL, NULL, NULL, NULL, NULL, 4),
(23940, NULL, 'G3DSA:2.40.50.140:FF:000069', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(23941, NULL, 'G3DSA:3.90.960.10:FF:000005', NULL, NULL, 'Putative prolyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(23942, NULL, 'G3DSA:3.30.160.60:FF:003968', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23943, NULL, 'G3DSA:3.20.110.10:FF:000030', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(23944, NULL, 'G3DSA:3.40.50.300:FF:008117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23945, NULL, 'G3DSA:2.170.150.10:FF:000012', NULL, NULL, 'Translationally-controlled tumor protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23946, NULL, 'G3DSA:3.40.50.150:FF:000299', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(23947, NULL, 'G3DSA:3.30.70.141:FF:000016', NULL, NULL, 'Nucleoside diphosphate kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23948, NULL, 'G3DSA:1.25.40.10:FF:001202', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(23949, NULL, 'G3DSA:3.30.830.10:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23950, NULL, 'G3DSA:3.30.465.10:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23951, NULL, 'G3DSA:3.30.70.1350:FF:000014', NULL, NULL, 'Cation efflux system protein', NULL, NULL, NULL, NULL, NULL, 4),
(23952, NULL, 'G3DSA:3.30.70.330:FF:002770', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23953, NULL, 'G3DSA:3.40.50.880:FF:000107', NULL, NULL, 'DJ-1/PfpI family protein', NULL, NULL, NULL, NULL, NULL, 4),
(23954, NULL, 'G3DSA:1.10.510.10:FF:003111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23955, NULL, 'G3DSA:1.20.1050.10:FF:000273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23956, NULL, 'G3DSA:2.60.220.50:FF:000123', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(23957, NULL, 'G3DSA:1.10.510.10:FF:004393', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23958, NULL, 'G3DSA:1.10.1200.240:FF:000001', NULL, NULL, 'Ribosomal protein L19', NULL, NULL, NULL, NULL, NULL, 4),
(23959, NULL, 'G3DSA:1.10.1420.10:FF:000091', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(23960, NULL, 'G3DSA:1.10.10.820:FF:000028', NULL, NULL, 'Chitin synthase 8', NULL, NULL, NULL, NULL, NULL, 4),
(23961, NULL, 'G3DSA:3.40.50.80:FF:000071', NULL, NULL, 'Cell surface metalloreductase (FreA), putative', NULL, NULL, NULL, NULL, NULL, 4),
(23962, NULL, 'G3DSA:2.60.120.10:FF:000716', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(23963, NULL, 'G3DSA:3.40.50.2300:FF:000830', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23964, NULL, 'G3DSA:2.130.10.10:FF:002395', NULL, NULL, 'Vacuolar protein sorting-associated protein 41 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(23965, NULL, 'G3DSA:3.30.70.1990:FF:000003', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(23966, NULL, 'G3DSA:1.25.40.10:FF:002484', NULL, NULL, 'AGAP000136-PA', NULL, NULL, NULL, NULL, NULL, 4),
(23967, NULL, 'G3DSA:2.30.30.40:FF:000583', NULL, NULL, 'Protein CBR-DLG-1', NULL, NULL, NULL, NULL, NULL, 4),
(23968, NULL, 'G3DSA:3.30.1360.120:FF:000028', NULL, NULL, 'Putative transferase caf17, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(23969, NULL, 'G3DSA:2.40.10.10:FF:000275', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23970, NULL, 'G3DSA:1.10.600.10:FF:000122', NULL, NULL, 'Os02g0572050 protein', NULL, NULL, NULL, NULL, NULL, 4),
(23971, NULL, 'G3DSA:3.40.605.10:FF:000057', NULL, NULL, 'Succinate-semialdehyde dehydrogenase mitochondrial', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(23972, NULL, 'G3DSA:3.40.50.1240:FF:000147', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23973, NULL, 'G3DSA:1.20.120.2010:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23974, NULL, 'G3DSA:3.80.20.20:FF:000095', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(23975, NULL, 'G3DSA:2.170.150.20:FF:000015', NULL, NULL, 'Protein CBG06233', NULL, NULL, NULL, NULL, NULL, 4),
(23976, NULL, 'G3DSA:2.60.40.10:FF:005441', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23977, NULL, 'G3DSA:3.40.50.1820:FF:001714', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(23978, NULL, 'G3DSA:3.40.449.10:FF:000019', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(23979, NULL, 'G3DSA:1.10.1200.260:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23980, NULL, 'G3DSA:2.130.10.10:FF:004340', NULL, NULL, 'WD-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(23981, NULL, 'G3DSA:2.60.200.10:FF:000009', NULL, NULL, 'interferon regulatory factor 9 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(23982, NULL, 'G3DSA:3.30.70.330:FF:000561', NULL, NULL, 'RNA-binding protein 34 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(23983, NULL, 'G3DSA:1.25.40.10:FF:000275', NULL, NULL, 'pentatricopeptide repeat-containing protein 1, mitochondrial isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(23984, NULL, 'G3DSA:1.25.40.10:FF:000359', NULL, NULL, 'Intraflagellar transport protein 88 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(23985, NULL, 'G3DSA:3.10.110.10:FF:000167', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 D3', NULL, NULL, NULL, NULL, NULL, 4),
(23986, NULL, 'G3DSA:1.20.1250.20:FF:000611', NULL, NULL, 'Siderochrome-iron transporter MirC', NULL, NULL, NULL, NULL, NULL, 4),
(23987, NULL, 'G3DSA:3.90.310.10:FF:000001', NULL, NULL, 'Envelope glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(23988, NULL, 'G3DSA:2.70.130.10:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(23989, NULL, 'G3DSA:1.10.10.1410:FF:000003', NULL, NULL, '60S acidic ribosomal protein P1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(23990, NULL, 'G3DSA:2.60.40.60:FF:000465', NULL, NULL, 'Dachsous cadherin-related 1a', NULL, NULL, NULL, NULL, NULL, 4),
(23991, NULL, 'G3DSA:1.10.10.1420:FF:000006', NULL, NULL, 'Chromatin licensing and DNA replication factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(23992, NULL, 'G3DSA:1.20.140.150:FF:000083', NULL, NULL, 'uncharacterized protein LOC100184513', NULL, NULL, NULL, NULL, NULL, 4),
(23993, NULL, 'G3DSA:2.60.40.60:FF:000521', NULL, NULL, 'Protocadherin 20', NULL, NULL, NULL, NULL, NULL, 4),
(23994, NULL, 'G3DSA:2.130.10.10:FF:000568', NULL, NULL, 'Cilia-and flagella-associated protein 52', NULL, NULL, NULL, NULL, NULL, 4),
(23995, NULL, 'G3DSA:3.90.550.10:FF:000693', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23996, NULL, 'G3DSA:3.40.50.720:FF:001627', NULL, NULL, 'SUMO-activating enzyme subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(23997, NULL, 'G3DSA:3.30.1510.10:FF:000012', NULL, NULL, 'Formate-tetrahydrofolate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(23998, NULL, 'G3DSA:2.130.10.10:FF:002715', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(23999, NULL, 'G3DSA:3.30.70.330:FF:001399', NULL, NULL, 'Poly(A) binding protein, cytoplasmic 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(24000, NULL, 'G3DSA:3.40.50.1370:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24001, NULL, 'G3DSA:2.60.40.60:FF:000993', NULL, NULL, 'Protein CBR-CDH-12', NULL, NULL, NULL, NULL, NULL, 4),
(24002, NULL, 'G3DSA:3.40.190.10:FF:000261', NULL, NULL, 'Sulfate ABC transporter substrate-binding lipoprotein SubI', NULL, NULL, NULL, NULL, NULL, 4),
(24003, NULL, 'G3DSA:3.40.50.300:FF:006908', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24004, NULL, 'G3DSA:1.25.10.10:FF:000857', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(24005, NULL, 'G3DSA:3.90.550.10:FF:000165', NULL, NULL, 'Nonspecific UDP-sugar pyrophosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(24006, NULL, 'G3DSA:1.25.40.10:FF:001938', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(24007, NULL, 'G3DSA:3.40.350.10:FF:000026', NULL, NULL, 'Fra1p', NULL, NULL, NULL, NULL, NULL, 4),
(24008, NULL, 'G3DSA:3.30.565.10:FF:000465', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24009, NULL, 'G3DSA:3.65.10.10:FF:000008', NULL, NULL, 'Pentafunctional AROM polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(24010, NULL, 'G3DSA:3.30.70.330:FF:001455', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(24011, NULL, 'G3DSA:1.20.1070.10:FF:001971', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24012, NULL, 'G3DSA:3.40.140.10:FF:000257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24013, NULL, 'G3DSA:2.60.120.1190:FF:000010', NULL, NULL, 'Ddr-2', NULL, NULL, NULL, NULL, NULL, 4),
(24014, NULL, 'G3DSA:1.25.10.10:FF:000329', NULL, NULL, 'Splicing factor 3b, subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(24015, NULL, 'G3DSA:3.40.50.2000:FF:000420', NULL, NULL, 'GD25117', NULL, NULL, NULL, NULL, NULL, 4),
(24016, NULL, 'G3DSA:3.30.230.130:FF:000049', NULL, NULL, 'Cullin', NULL, NULL, NULL, NULL, NULL, 4),
(24017, NULL, 'G3DSA:3.30.200.20:FF:000223', NULL, NULL, 'Mitogen-activated protein kinase 6', NULL, NULL, NULL, NULL, NULL, 4),
(24018, NULL, 'G3DSA:1.10.418.10:FF:000260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24019, NULL, 'G3DSA:3.40.50.2300:FF:001494', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24020, NULL, 'G3DSA:2.60.40.1760:FF:000006', NULL, NULL, 'Alpha-glucosidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(24021, NULL, 'G3DSA:1.25.40.20:FF:000839', NULL, NULL, '60 kDa lysophospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(24022, NULL, 'G3DSA:1.20.1250.20:FF:001067', NULL, NULL, 'Major facilitator superfamily citrate-proton symporter', NULL, NULL, NULL, NULL, NULL, 4),
(24023, NULL, 'G3DSA:2.130.10.10:FF:000624', NULL, NULL, 'DENN domain and WD repeat-containing protein SCD1', NULL, NULL, NULL, NULL, NULL, 4),
(24024, NULL, 'G3DSA:3.30.230.10:FF:000250', NULL, NULL, 'Diphosphomevalonate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(24025, NULL, 'G3DSA:3.30.160.20:FF:000022', NULL, NULL, '28S ribosomal protein S5, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(24026, NULL, 'G3DSA:2.60.40.420:FF:000012', NULL, NULL, 'Monocopper oxidase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(24027, NULL, 'G3DSA:1.10.20.10:FF:000094', NULL, NULL, 'CCAAT-binding transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24028, NULL, 'G3DSA:1.20.1250.20:FF:001595', NULL, NULL, 'Solute carrier organic anion transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24029, NULL, 'G3DSA:2.10.25.10:FF:000220', NULL, NULL, 'pikachurin isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(24030, NULL, 'G3DSA:3.30.200.20:FF:000751', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(24031, NULL, 'G3DSA:2.30.29.30:FF:000886', NULL, NULL, 'Putative surface protein bspA-like', NULL, NULL, NULL, NULL, NULL, 4),
(24032, NULL, 'G3DSA:3.20.130.10:FF:000003', NULL, NULL, 'Fumarate hydratase class I', NULL, NULL, NULL, NULL, NULL, 4),
(24033, NULL, 'G3DSA:2.60.40.10:FF:000646', NULL, NULL, 'Myosin binding protein C, fast type', NULL, NULL, NULL, NULL, NULL, 4),
(24034, NULL, 'G3DSA:3.90.1010.10:FF:000011', NULL, NULL, 'Nitrogen fixation protein NifU', NULL, NULL, NULL, NULL, NULL, 4),
(24035, NULL, 'G3DSA:1.25.40.10:FF:004491', NULL, NULL, 'Uncharacterized Sel1-like repeat-containing protein C1B3.10c', NULL, NULL, NULL, NULL, NULL, 4),
(24036, NULL, 'G3DSA:1.20.1070.10:FF:000510', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24037, NULL, 'G3DSA:1.10.10.60:FF:000557', NULL, NULL, 'Unplaced genomic scaffold supercont2.9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(24038, NULL, 'G3DSA:1.10.10.60:FF:000759', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24039, NULL, 'G3DSA:3.30.830.10:FF:000251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24040, NULL, 'G3DSA:2.60.40.1120:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24041, NULL, 'G3DSA:1.20.58.80:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24042, NULL, 'G3DSA:3.40.50.1100:FF:000189', NULL, NULL, 'Pyridoxal-phosphate dependent enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(24043, NULL, 'G3DSA:3.60.15.10:FF:000007', NULL, NULL, 'Metallo-beta-lactamase NDM-1', NULL, NULL, NULL, NULL, NULL, 4),
(24044, NULL, 'G3DSA:2.160.20.10:FF:000236', NULL, NULL, 'Polygalacturonase', NULL, NULL, NULL, NULL, NULL, 4),
(24045, NULL, 'G3DSA:3.40.50.720:FF:000374', NULL, NULL, '3-oxoacyl-(Acyl-carrier-protein) reductase', NULL, NULL, NULL, NULL, NULL, 4),
(24046, NULL, 'G3DSA:1.20.1080.10:FF:000005', NULL, NULL, 'Aquaporin 3', NULL, NULL, NULL, NULL, NULL, 4),
(24047, NULL, 'G3DSA:3.40.50.1000:FF:000777', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24048, NULL, 'G3DSA:1.20.1070.10:FF:000190', NULL, NULL, 'Vasopressin V2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(24049, NULL, 'G3DSA:3.30.160.60:FF:004750', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24050, NULL, 'G3DSA:3.90.79.10:FF:000058', NULL, NULL, 'NUDIX domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(24051, NULL, 'G3DSA:3.30.530.20:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24052, NULL, 'G3DSA:3.30.160.60:FF:000888', NULL, NULL, 'zinc finger and BTB domain-containing protein 41', NULL, NULL, NULL, NULL, NULL, 4),
(24053, NULL, 'G3DSA:3.40.50.2000:FF:000622', NULL, NULL, 'Sll1528 protein', NULL, NULL, NULL, NULL, NULL, 4),
(24054, NULL, 'G3DSA:3.50.30.10:FF:000009', NULL, NULL, 'Pyruvate, phosphate dikinase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(24055, NULL, 'G3DSA:2.60.40.10:FF:002535', NULL, NULL, 'Protein CBG19196', NULL, NULL, NULL, NULL, NULL, 4),
(24056, NULL, 'G3DSA:2.40.10.10:FF:000426', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24057, NULL, 'G3DSA:1.10.10.10:FF:000059', NULL, NULL, 'ETS translocation variant 3', NULL, NULL, NULL, NULL, NULL, 4),
(24058, NULL, 'G3DSA:3.30.540.10:FF:000060', NULL, NULL, 'Fructose-1,6-bisphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(24059, NULL, 'G3DSA:3.10.180.10:FF:000115', NULL, NULL, 'Putative 4-hydroxyphenylpyruvic acid dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(24060, NULL, 'G3DSA:3.40.50.970:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24061, NULL, 'G3DSA:1.10.8.270:FF:000056', NULL, NULL, 'Plasma membrane ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(24062, NULL, 'G3DSA:3.30.70.330:FF:001781', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24063, NULL, 'G3DSA:3.40.50.800:FF:000100', NULL, NULL, 'ATP phosphoribosyltransferase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(24064, NULL, 'G3DSA:3.30.70.1170:FF:000027', NULL, NULL, 'tRNA (cytosine(48)-C(5))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(24065, NULL, 'G3DSA:3.40.190.10:FF:000940', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(24066, NULL, 'G3DSA:3.80.10.10:FF:001159', NULL, NULL, 'Fish-lips, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(24067, NULL, 'G3DSA:2.120.10.30:FF:000451', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24068, NULL, 'G3DSA:3.40.50.300:FF:003238', NULL, NULL, '6-phosphofructo-2-kinase/fructose-2, 6-biphosphatase 4', NULL, NULL, NULL, NULL, NULL, 4),
(24069, NULL, 'G3DSA:1.10.418.10:FF:000108', NULL, NULL, 'Fimbrin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24070, NULL, 'G3DSA:1.10.3120.10:FF:000017', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(24071, NULL, 'G3DSA:3.40.1710.10:FF:000003', NULL, NULL, 'ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(24072, NULL, 'G3DSA:1.10.238.10:FF:001302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(24073, NULL, 'G3DSA:1.20.120.1750:FF:000116', NULL, NULL, 'Probable E3 ubiquitin-protein ligase ARI14', NULL, NULL, NULL, NULL, NULL, 4),
(24074, NULL, 'G3DSA:2.60.120.730:FF:000001', NULL, NULL, 'Major capsid protein P2', NULL, NULL, NULL, NULL, NULL, 4),
(24075, NULL, 'G3DSA:1.25.40.10:FF:002720', NULL, NULL, 'YALI0C02453p', NULL, NULL, NULL, NULL, NULL, 4),
(24076, NULL, 'G3DSA:2.60.40.2130:FF:000016', NULL, NULL, 'HL01082p', NULL, NULL, NULL, NULL, NULL, 4),
(24077, NULL, 'G3DSA:3.40.50.300:FF:006588', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24078, NULL, 'G3DSA:2.30.30.40:FF:000049', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit beta-3', NULL, NULL, NULL, NULL, NULL, 4),
(24079, NULL, 'G3DSA:2.60.120.740:FF:000004', NULL, NULL, 'Protein eva-1 homolog C', NULL, NULL, NULL, NULL, NULL, 4),
(24080, NULL, 'G3DSA:3.90.550.10:FF:000367', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24081, NULL, 'G3DSA:3.40.50.2300:FF:000066', NULL, NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase SSU72', NULL, NULL, NULL, NULL, NULL, 4),
(24082, NULL, 'G3DSA:1.20.1050.130:FF:000013', NULL, NULL, 'Elongation factor 1-beta (Ef-1-beta), putative', NULL, NULL, NULL, NULL, NULL, 4),
(24083, NULL, 'G3DSA:1.10.510.10:FF:000295', NULL, NULL, 'Serine/threonine-protein kinase AGC1-7', NULL, NULL, NULL, NULL, NULL, 4),
(24084, NULL, 'G3DSA:3.90.1150.10:FF:000167', NULL, NULL, 'Glycine cleavage system P protein', NULL, NULL, NULL, NULL, NULL, 4),
(24085, NULL, 'G3DSA:2.60.40.10:FF:004626', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24086, NULL, 'G3DSA:1.25.40.20:FF:001621', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24087, NULL, 'G3DSA:3.10.110.10:FF:000021', NULL, NULL, 'Putative ubiquitin-conjugating enzyme e2 k', NULL, NULL, NULL, NULL, NULL, 4),
(24088, NULL, 'G3DSA:3.40.50.300:FF:004992', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24089, NULL, 'G3DSA:2.70.170.10:FF:000262', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(24090, NULL, 'G3DSA:2.60.260.20:FF:000139', NULL, NULL, 'DnaJ-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(24091, NULL, 'G3DSA:2.160.10.10:FF:000027', NULL, NULL, 'Translation initiation factor eIF-2B subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(24092, NULL, 'G3DSA:2.60.200.20:FF:000080', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(24093, NULL, 'G3DSA:3.30.200.20:FF:000425', NULL, NULL, 'Putative calcium/calmodulin-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(24094, NULL, 'G3DSA:3.30.160.390:FF:000003', NULL, NULL, 'Putative integrase', NULL, NULL, NULL, NULL, NULL, 4),
(24095, NULL, 'G3DSA:2.60.40.10:FF:005115', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24096, NULL, 'G3DSA:2.40.30.10:FF:000309', NULL, NULL, 'Predicted dual oxidase-D', NULL, NULL, NULL, NULL, NULL, 4),
(24097, NULL, 'G3DSA:3.30.40.10:FF:002236', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(24098, NULL, 'G3DSA:3.30.420.140:FF:000022', NULL, NULL, 'Putative pre-16S rRNA nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(24099, NULL, 'G3DSA:1.25.40.90:FF:000080', NULL, NULL, 'YALI0C14476p', NULL, NULL, NULL, NULL, NULL, 4),
(24100, NULL, 'G3DSA:3.40.50.1240:FF:000091', NULL, NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(24101, NULL, 'G3DSA:3.30.70.330:FF:000151', NULL, NULL, 'matrin-3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(24102, NULL, 'G3DSA:1.25.40.20:FF:000688', NULL, NULL, 'Ankyrin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(24103, NULL, 'G3DSA:3.30.160.60:FF:002333', NULL, NULL, 'Zinc finger protein 668', NULL, NULL, NULL, NULL, NULL, 4),
(24104, NULL, 'G3DSA:2.130.10.10:FF:000950', NULL, NULL, 'Phospholipase A-2-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(24105, NULL, 'G3DSA:3.30.420.150:FF:000025', NULL, NULL, 'Golgi apyrase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(24106, NULL, 'G3DSA:1.10.510.10:FF:002386', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24107, NULL, 'G3DSA:3.30.470.20:FF:000208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24108, NULL, 'G3DSA:1.20.1640.10:FF:000088', NULL, NULL, 'Hopanoid biosynthesis associated RND transporter like protein HpnN', NULL, NULL, NULL, NULL, NULL, 4),
(24109, NULL, 'G3DSA:1.25.40.10:FF:002074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24110, NULL, 'G3DSA:3.90.70.10:FF:000690', NULL, NULL, 'Clan CA, family C1, cathepsin L-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(24111, NULL, 'G3DSA:2.130.10.10:FF:002513', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', NULL, NULL, NULL, NULL, NULL, 4),
(24112, NULL, 'G3DSA:2.30.30.650:FF:000001', NULL, NULL, 'V-type ATP synthase alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(24113, NULL, 'G3DSA:1.10.10.1970:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24114, NULL, 'G3DSA:3.40.30.10:FF:000476', NULL, NULL, 'Pyrimidodiazepine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(24115, NULL, 'G3DSA:3.30.720.10:FF:000006', NULL, NULL, 'Signal recognition particle 14kD protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24116, NULL, 'G3DSA:3.90.950.10:FF:000004', NULL, NULL, 'dTTP/UTP pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(24117, NULL, 'G3DSA:1.25.40.10:FF:000685', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(24118, NULL, 'G3DSA:2.30.30.30:FF:000046', NULL, NULL, 'Putative 60S ribosomal protein L6', NULL, NULL, NULL, NULL, NULL, 4),
(24119, NULL, 'G3DSA:3.40.1580.10:FF:000003', NULL, NULL, 'Putative spore coat protein', NULL, NULL, NULL, NULL, NULL, 4),
(24120, NULL, 'G3DSA:3.80.10.10:FF:001962', NULL, NULL, 'Phytosulfokine receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(24121, NULL, 'G3DSA:1.10.472.10:FF:000076', NULL, NULL, 'RNA polymerase II holoenzyme cyclin-like subunit', NULL, NULL, NULL, NULL, NULL, 4),
(24122, NULL, 'G3DSA:1.25.10.10:FF:002572', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24123, NULL, 'G3DSA:3.90.70.10:FF:000162', NULL, NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', NULL, NULL, NULL, NULL, NULL, 4),
(24124, NULL, 'G3DSA:3.90.550.10:FF:000491', NULL, NULL, 'UDP-glucose glycoprotein glucosyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(24125, NULL, 'G3DSA:1.20.120.330:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24126, NULL, 'G3DSA:1.10.238.10:FF:000162', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(24127, NULL, 'G3DSA:2.30.38.10:FF:000007', NULL, NULL, 'Peptide synthetase mbtE', NULL, NULL, NULL, NULL, NULL, 4),
(24128, NULL, 'G3DSA:1.10.760.10:FF:000015', NULL, NULL, 'Cbb3-type cytochrome c oxidase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(24129, NULL, 'G3DSA:3.30.40.10:FF:001747', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24130, NULL, 'G3DSA:1.20.1250.20:FF:001915', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24131, NULL, 'G3DSA:1.20.58.70:FF:000074', NULL, NULL, 'Tlg2p', NULL, NULL, NULL, NULL, NULL, 4),
(24132, NULL, 'G3DSA:2.30.29.30:FF:000301', NULL, NULL, 'Neurobeachin-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(24133, NULL, 'G3DSA:3.40.120.10:FF:000043', NULL, NULL, 'Putative phosphoglucomutase', NULL, NULL, NULL, NULL, NULL, 4),
(24134, NULL, 'G3DSA:1.20.1070.10:FF:001494', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24135, NULL, 'G3DSA:2.10.70.10:FF:000229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24136, NULL, 'G3DSA:3.30.160.60:FF:006346', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24137, NULL, 'G3DSA:3.40.50.300:FF:004817', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24138, NULL, 'G3DSA:2.60.40.790:FF:000128', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(24139, NULL, 'G3DSA:2.60.120.260:FF:000102', NULL, NULL, 'Rhamnogalacturonate lyase A', NULL, NULL, NULL, NULL, NULL, 4),
(24140, NULL, 'G3DSA:2.40.50.730:FF:000004', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(24141, NULL, 'G3DSA:3.50.50.60:FF:000036', NULL, NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(24142, NULL, 'G3DSA:3.30.70.100:FF:000189', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24143, NULL, 'G3DSA:2.60.120.200:FF:000163', NULL, NULL, 'Lectin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24144, NULL, 'G3DSA:3.10.310.20:FF:000005', NULL, NULL, 'Manganese-dependent inorganic pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(24145, NULL, 'G3DSA:2.60.120.10:FF:000598', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24146, NULL, 'G3DSA:3.30.70.660:FF:000042', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(24147, NULL, 'G3DSA:1.20.1540.10:FF:000029', NULL, NULL, 'Rhomboid protease 2', NULL, NULL, NULL, NULL, NULL, 4),
(24148, NULL, 'G3DSA:2.40.50.740:FF:000007', NULL, NULL, '30S ribosomal protein S4e', NULL, NULL, NULL, NULL, NULL, 4),
(24149, NULL, 'G3DSA:3.40.47.10:FF:000306', NULL, NULL, 'Probable polyketide synthase 37', NULL, NULL, NULL, NULL, NULL, 4),
(24150, NULL, 'G3DSA:3.20.20.60:FF:000098', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(24151, NULL, 'G3DSA:1.10.472.130:FF:000065', NULL, NULL, 'Dynein heavy chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(24152, NULL, 'G3DSA:3.90.226.10:FF:000159', NULL, NULL, 'Peroxisomal enoyl-coa hydratase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24153, NULL, 'G3DSA:3.30.60.20:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24154, NULL, 'G3DSA:1.20.58.830:FF:000008', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(24155, NULL, 'G3DSA:3.80.10.10:FF:000501', NULL, NULL, 'GL19312', NULL, NULL, NULL, NULL, NULL, 4),
(24156, NULL, 'G3DSA:3.10.28.10:FF:000039', NULL, NULL, 'Probable intron-encoded DNA endonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(24157, NULL, 'G3DSA:2.10.25.10:FF:000164', NULL, NULL, 'Attractin like 1', NULL, NULL, NULL, NULL, NULL, 4),
(24158, NULL, 'G3DSA:3.10.20.90:FF:000961', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24159, NULL, 'G3DSA:1.10.760.10:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24160, NULL, 'G3DSA:3.30.519.10:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24161, NULL, 'G3DSA:3.30.200.20:FF:002050', NULL, NULL, 'Serine/threonine-protein kinase srb10', NULL, NULL, NULL, NULL, NULL, 4),
(24162, NULL, 'G3DSA:3.30.430.20:FF:000032', NULL, NULL, 'Putative DUF26-domain protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(24163, NULL, 'G3DSA:2.60.120.830:FF:000003', NULL, NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 13', NULL, NULL, NULL, NULL, NULL, 4),
(24164, NULL, 'G3DSA:3.30.420.40:FF:000599', NULL, NULL, 'Actin-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(24165, NULL, 'G3DSA:2.130.10.10:FF:001411', NULL, NULL, 'Protein SOF1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24166, NULL, 'G3DSA:3.40.50.300:FF:001440', NULL, NULL, 'ATPase, AAA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(24167, NULL, 'G3DSA:2.60.40.10:FF:005025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24168, NULL, 'G3DSA:3.30.60.30:FF:000158', NULL, NULL, 'Follistatin', NULL, NULL, NULL, NULL, NULL, 4),
(24169, NULL, 'G3DSA:3.90.1310.10:FF:000023', NULL, NULL, 'Penicillin-binding protein 2X', NULL, NULL, NULL, NULL, NULL, 4),
(24170, NULL, 'G3DSA:1.10.3720.10:FF:000046', NULL, NULL, 'Oligopeptide ABC transporter, permease', NULL, NULL, NULL, NULL, NULL, 4),
(24171, NULL, 'G3DSA:1.10.287.1040:FF:000006', NULL, NULL, 'Exodeoxyribonuclease 7 small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(24172, NULL, 'G3DSA:1.10.630.10:FF:000040', NULL, NULL, 'Bifunctional cytochrome P450/NADPH--P450 reductase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(24173, NULL, 'G3DSA:3.90.70.10:FF:000538', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(24174, NULL, 'G3DSA:2.70.150.10:FF:000227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24175, NULL, 'G3DSA:3.40.570.10:FF:000014', NULL, NULL, 'Endonuclease G', NULL, NULL, NULL, NULL, NULL, 4),
(24176, NULL, 'G3DSA:3.50.50.60:FF:000626', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(24177, NULL, 'G3DSA:3.10.310.10:FF:000002', NULL, NULL, 'Diaminopimelate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(24178, NULL, 'G3DSA:3.90.20.20:FF:000015', NULL, NULL, 'GrpE protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(24179, NULL, 'G3DSA:3.80.10.10:FF:000181', NULL, NULL, 'amphoterin-induced protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(24180, NULL, 'G3DSA:3.30.70.1230:FF:000186', NULL, NULL, 'Mitogen-activated protein kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(24181, NULL, 'G3DSA:2.60.120.650:FF:000073', NULL, NULL, 'Cupin_superfamily_protein/Cupin-like_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(24182, NULL, 'G3DSA:3.40.50.1780:FF:000022', NULL, NULL, 'Hydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(24183, NULL, 'G3DSA:1.20.1310.10:FF:000046', NULL, NULL, 'CDC53p Cullin', NULL, NULL, NULL, NULL, NULL, 4),
(24184, NULL, 'G3DSA:2.30.30.30:FF:000136', NULL, NULL, 'Transcription elongation factor SPT5', NULL, NULL, NULL, NULL, NULL, 4),
(24185, NULL, 'G3DSA:2.30.30.40:FF:000139', NULL, NULL, 'Hematopoietic cell-specific Lyn substrate 1', NULL, NULL, NULL, NULL, NULL, 4),
(24186, NULL, 'G3DSA:3.30.870.10:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24187, NULL, 'G3DSA:3.30.260.10:FF:000049', NULL, NULL, 'T-complex protein 1 subunit eta', NULL, NULL, NULL, NULL, NULL, 4),
(24188, NULL, 'G3DSA:2.60.200.20:FF:000282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24189, NULL, 'G3DSA:3.30.160.60:FF:000388', NULL, NULL, 'zinc finger protein 567', NULL, NULL, NULL, NULL, NULL, 4),
(24190, NULL, 'G3DSA:3.30.40.10:FF:001837', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(24191, NULL, 'G3DSA:2.40.110.10:FF:000052', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(24192, NULL, 'G3DSA:3.90.550.10:FF:000339', NULL, NULL, 'Molybdenum cofactor guanylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(24193, NULL, 'G3DSA:3.30.800.10:FF:000007', NULL, NULL, 'Putative 1-phosphatidylinositol-4-phosphate 5-kinase/ zinc ion binding family', NULL, NULL, NULL, NULL, NULL, 4),
(24194, NULL, 'G3DSA:3.30.70.330:FF:002091', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24195, NULL, 'G3DSA:3.30.460.80:FF:000001', NULL, NULL, 'NADH-quinone oxidoreductase subunit C/D', NULL, NULL, NULL, NULL, NULL, 4),
(24196, NULL, 'G3DSA:1.10.8.270:FF:000051', NULL, NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', NULL, NULL, NULL, NULL, NULL, 4),
(24197, NULL, 'G3DSA:2.30.30.40:FF:000375', NULL, NULL, 'Putative purine-binding chemotaxis protein Chew', NULL, NULL, NULL, NULL, NULL, 4),
(24198, NULL, 'G3DSA:3.40.50.620:FF:000018', NULL, NULL, 'Methionyl-tRNA synthetase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(24199, NULL, 'G3DSA:2.40.50.140:FF:000631', NULL, NULL, 'KARS isoform 7', NULL, NULL, NULL, NULL, NULL, 4),
(24200, NULL, 'G3DSA:3.30.70.330:FF:001871', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24201, NULL, 'G3DSA:1.25.40.10:FF:002630', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g31850, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(24202, NULL, 'G3DSA:2.40.50.100:FF:000136', NULL, NULL, 'RND family efflux transporter, MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(24203, NULL, 'G3DSA:3.30.420.40:FF:000268', NULL, NULL, 'Rhamnulokinase', NULL, NULL, NULL, NULL, NULL, 4),
(24204, NULL, 'G3DSA:1.20.5.620:FF:000002', NULL, NULL, 'ATP synthase subunit b', NULL, NULL, NULL, NULL, NULL, 4),
(24205, NULL, 'G3DSA:3.80.10.10:FF:001283', NULL, NULL, 'Lysine (K)-specific demethylase 2B', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(24206, NULL, 'G3DSA:1.25.40.10:FF:000303', NULL, NULL, 'Probable UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SEC', NULL, NULL, NULL, NULL, NULL, 4),
(24207, NULL, 'G3DSA:1.10.510.10:FF:004128', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24208, NULL, 'G3DSA:2.40.10.10:FF:000421', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24209, NULL, 'G3DSA:3.40.1190.20:FF:000021', NULL, NULL, 'Fructokinase-like 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(24210, NULL, 'G3DSA:3.30.1150.10:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24211, NULL, 'G3DSA:3.30.420.40:FF:000453', NULL, NULL, 'Actin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24212, NULL, 'G3DSA:1.25.40.20:FF:000778', NULL, NULL, 'Ankyrin repeat domain 2 (stretch responsive muscle)', NULL, NULL, NULL, NULL, NULL, 4),
(24213, NULL, 'G3DSA:3.90.25.10:FF:000001', NULL, NULL, 'UDP-glucose 4-epimerase GalE', NULL, NULL, NULL, NULL, NULL, 4),
(24214, NULL, 'G3DSA:3.40.50.620:FF:000260', NULL, NULL, 'Ethanolamine-phosphate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(24215, NULL, 'G3DSA:3.30.300.320:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24216, NULL, 'G3DSA:1.25.40.10:FF:000831', NULL, NULL, 'PPR repeat family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24217, NULL, 'G3DSA:3.80.10.10:FF:003699', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24218, NULL, 'G3DSA:1.10.510.10:FF:000385', NULL, NULL, 'serine/threonine-protein kinase Aurora-1', NULL, NULL, NULL, NULL, NULL, 4),
(24219, NULL, 'G3DSA:1.20.120.1200:FF:000002', NULL, NULL, 'NAD(P)H-quinone oxidoreductase subunit 6, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(24220, NULL, 'G3DSA:2.130.10.10:FF:002193', NULL, NULL, 'Neutral sphingomyelinase activation-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(24221, NULL, 'G3DSA:1.25.10.10:FF:002156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24222, NULL, 'G3DSA:3.30.460.90:FF:000004', NULL, NULL, 'Mitochondrial elongation factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(24223, NULL, 'G3DSA:3.80.10.10:FF:001631', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24224, NULL, 'G3DSA:3.40.50.880:FF:000141', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(24225, NULL, 'G3DSA:1.10.10.10:FF:000149', NULL, NULL, 'Multiple antibiotic resistance transcriptional regulator MarR', NULL, NULL, NULL, NULL, NULL, 4),
(24226, NULL, 'G3DSA:3.40.50.10190:FF:000301', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(24227, NULL, 'G3DSA:1.20.1310.20:FF:000049', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(24228, NULL, 'G3DSA:3.30.710.10:FF:000360', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24229, NULL, 'G3DSA:3.30.420.40:FF:000801', NULL, NULL, 'Actin-Related Proteins', NULL, NULL, NULL, NULL, NULL, 4),
(24230, NULL, 'G3DSA:3.30.1010.10:FF:000042', NULL, NULL, 'PhosphoInositide Four Kinase (PI-4 Kinase)', NULL, NULL, NULL, NULL, NULL, 4),
(24231, NULL, 'G3DSA:1.10.150.240:FF:000125', NULL, NULL, 'Phosphoglycolate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(24232, NULL, 'G3DSA:3.60.21.10:FF:000393', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(24233, NULL, 'G3DSA:2.30.29.30:FF:001375', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(24234, NULL, 'G3DSA:3.30.160.60:FF:002187', NULL, NULL, 'RE1-silencing transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(24235, NULL, 'G3DSA:1.20.58.810:FF:000002', NULL, NULL, 'Photosystem II D1 processing protein PSB27-H2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(24236, NULL, 'G3DSA:2.60.120.260:FF:000225', NULL, NULL, 'Laminin subunit beta-1', NULL, NULL, NULL, NULL, NULL, 4),
(24237, NULL, 'G3DSA:2.60.40.150:FF:000734', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(24238, NULL, 'G3DSA:1.25.10.10:FF:002482', NULL, NULL, 'Sister chromatid cohesion protein pds5', NULL, NULL, NULL, NULL, NULL, 4),
(24239, NULL, 'G3DSA:3.40.50.300:FF:002991', NULL, NULL, 'Helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24240, NULL, 'G3DSA:1.20.5.340:FF:000098', NULL, NULL, 'rho-associated protein kinase 2 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(24241, NULL, 'G3DSA:1.25.10.10:FF:002774', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24242, NULL, 'G3DSA:2.60.40.10:FF:003024', NULL, NULL, 'Beta-Mannosidase, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(24243, NULL, 'G3DSA:3.90.70.10:FF:000717', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24244, NULL, 'G3DSA:3.40.630.10:FF:000273', NULL, NULL, 'Carboxypeptidase SOL1', NULL, NULL, NULL, NULL, NULL, 4),
(24245, NULL, 'G3DSA:2.30.30.140:FF:000112', NULL, NULL, 'SAGA-associated factor 29', NULL, NULL, NULL, NULL, NULL, 4),
(24246, NULL, 'G3DSA:1.25.40.20:FF:000834', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(24247, NULL, 'G3DSA:1.10.238.10:FF:000813', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24248, NULL, 'G3DSA:2.60.120.260:FF:000046', NULL, NULL, 'Cullin 9', NULL, NULL, NULL, NULL, NULL, 4),
(24249, NULL, 'G3DSA:3.80.10.10:FF:003755', NULL, NULL, 'Protein CBG20033', NULL, NULL, NULL, NULL, NULL, 4),
(24250, NULL, 'G3DSA:3.40.50.720:FF:000520', NULL, NULL, 'NAD(P)(+) transhydrogenase (AB-specific), alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(24251, NULL, 'G3DSA:1.10.1070.11:FF:000143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24252, NULL, 'G3DSA:3.40.50.80:FF:000037', NULL, NULL, 'Metalloreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24253, NULL, 'G3DSA:1.10.418.10:FF:000232', NULL, NULL, 'Microtubule-actin crosslinking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(24254, NULL, 'G3DSA:2.40.50.140:FF:000013', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(24255, NULL, 'G3DSA:2.10.25.10:FF:001529', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24256, NULL, 'G3DSA:1.25.40.10:FF:001000', NULL, NULL, 'ER membrane protein complex subunit 2-A', NULL, NULL, NULL, NULL, NULL, 4),
(24257, NULL, 'G3DSA:2.10.25.10:FF:001619', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(24258, NULL, 'G3DSA:1.25.40.20:FF:001003', NULL, NULL, 'AT4g05040 protein', NULL, NULL, NULL, NULL, NULL, 4),
(24259, NULL, 'G3DSA:3.40.50.2300:FF:000622', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(24260, NULL, 'G3DSA:2.60.40.10:FF:001282', NULL, NULL, 'carcinoembryonic antigen-related cell adhesion molecule 16', NULL, NULL, NULL, NULL, NULL, 4),
(24261, NULL, 'G3DSA:3.90.70.10:FF:000864', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24262, NULL, 'G3DSA:2.30.130.40:FF:000007', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(24263, NULL, 'G3DSA:3.40.630.30:FF:000464', NULL, NULL, 'N-acetyltransferase 9-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(24264, NULL, 'G3DSA:3.30.40.10:FF:000443', NULL, NULL, 'PHD finger protein 7 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(24265, NULL, 'G3DSA:1.25.40.10:FF:000775', NULL, NULL, 'Tetratricopeptide repeat domain 21A', NULL, NULL, NULL, NULL, NULL, 4),
(24266, NULL, 'G3DSA:3.40.640.10:FF:000245', NULL, NULL, 'Kynureninase', NULL, NULL, NULL, NULL, NULL, 4),
(24267, NULL, 'G3DSA:2.60.40.10:FF:002709', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(24268, NULL, 'G3DSA:3.40.718.10:FF:000015', NULL, NULL, 'Phosphate butyryltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(24269, NULL, 'G3DSA:3.40.50.1820:FF:000551', NULL, NULL, 'Epoxide hydrolase EphA', NULL, NULL, NULL, NULL, NULL, 4),
(24270, NULL, 'G3DSA:1.10.10.1420:FF:000001', NULL, NULL, 'Chromatin licensing and DNA replication factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(24271, NULL, 'G3DSA:3.10.100.10:FF:000407', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(24272, NULL, 'G3DSA:3.30.63.10:FF:000007', NULL, NULL, 'Membrane-associated guanylate kinase, WW and PDZ domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(24273, NULL, 'G3DSA:1.10.1820.10:FF:000019', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(24274, NULL, 'G3DSA:3.40.50.11660:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24275, NULL, 'G3DSA:3.40.228.10:FF:000017', NULL, NULL, 'Acetylene hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(24276, NULL, 'G3DSA:3.30.70.330:FF:000527', NULL, NULL, 'RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(24277, NULL, 'G3DSA:1.10.10.60:FF:000383', NULL, NULL, 'box A-binding factor', NULL, NULL, NULL, NULL, NULL, 4),
(24278, NULL, 'G3DSA:3.10.20.90:FF:000433', NULL, NULL, 'Autophagy-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(24279, NULL, 'G3DSA:3.40.50.300:FF:002749', NULL, NULL, 'Metal ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(24280, NULL, 'G3DSA:3.40.50.300:FF:005155', NULL, NULL, 'ABC-type transport system ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(24281, NULL, 'G3DSA:3.10.20.30:FF:000078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24282, NULL, 'G3DSA:1.20.5.340:FF:000070', NULL, NULL, 'CBN-UNC-54 protein', NULL, NULL, NULL, NULL, NULL, 4),
(24283, NULL, 'G3DSA:2.130.10.10:FF:000394', NULL, NULL, 'Peptidylprolyl isomerase domain and WD repeat-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(24284, NULL, 'G3DSA:3.40.50.20:FF:000042', NULL, NULL, 'RimK-related lysine biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(24285, NULL, 'G3DSA:3.40.50.1260:FF:000012', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(24286, NULL, 'G3DSA:2.40.70.10:FF:000402', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24287, NULL, 'G3DSA:1.25.40.10:FF:000157', NULL, NULL, 'protein TSS isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(24288, NULL, 'G3DSA:1.20.1270.370:FF:000005', NULL, NULL, '3-hydroxyacyl-ACP dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(24289, NULL, 'G3DSA:3.40.630.10:FF:000306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24290, NULL, 'G3DSA:2.170.270.10:FF:000167', NULL, NULL, 'Nuclear receptor binding SET domain protein 1b', NULL, NULL, NULL, NULL, NULL, 4),
(24291, NULL, 'G3DSA:3.40.50.300:FF:006644', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24292, NULL, 'G3DSA:3.30.1010.10:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24293, NULL, 'G3DSA:2.130.10.10:FF:002805', NULL, NULL, 'Polycomb protein eed-A', NULL, NULL, NULL, NULL, NULL, 4),
(24294, NULL, 'G3DSA:3.40.640.10:FF:000099', NULL, NULL, 'LL-diaminopimelate aminotransferase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(24295, NULL, 'G3DSA:3.40.50.300:FF:007280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24296, NULL, 'G3DSA:2.10.25.10:FF:000310', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(24297, NULL, 'G3DSA:3.30.710.10:FF:000034', NULL, NULL, 'RCC1 and BTB domain-containing protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(24298, NULL, 'G3DSA:3.20.20.300:FF:000011', NULL, NULL, 'Glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(24299, NULL, 'G3DSA:3.30.420.10:FF:000579', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24300, NULL, 'G3DSA:2.40.30.10:FF:000282', NULL, NULL, 'Dual oxidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(24301, NULL, 'G3DSA:3.40.50.300:FF:001445', NULL, NULL, 'Chromatin-remodeling ATPase INO80', NULL, NULL, NULL, NULL, NULL, 4),
(24302, NULL, 'G3DSA:3.40.50.300:FF:007100', NULL, NULL, 'Gluconokinase', NULL, NULL, NULL, NULL, NULL, 4),
(24303, NULL, 'G3DSA:3.40.50.720:FF:002291', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(24304, NULL, 'G3DSA:1.10.510.10:FF:001402', NULL, NULL, 'Mammalian ZAK kinase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(24305, NULL, 'G3DSA:1.20.1250.20:FF:001623', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(24306, NULL, 'G3DSA:3.90.1290.10:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24307, NULL, 'G3DSA:3.40.390.10:FF:000118', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(24308, NULL, 'G3DSA:3.40.1280.10:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24309, NULL, 'G3DSA:3.40.50.11260:FF:000010', NULL, NULL, 'Endoplasmin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24310, NULL, 'G3DSA:1.20.140.40:FF:000065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24311, NULL, 'G3DSA:1.20.910.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24312, NULL, 'G3DSA:1.10.10.440:FF:000038', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(24313, NULL, 'G3DSA:3.40.50.620:FF:000170', NULL, NULL, '7-cyano-7-deazaguanine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(24314, NULL, 'G3DSA:3.40.50.300:FF:002373', NULL, NULL, 'Vesicle-fusing ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24315, NULL, 'G3DSA:3.80.10.10:FF:003429', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24316, NULL, 'G3DSA:2.80.10.50:FF:000178', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(24317, NULL, 'G3DSA:3.10.490.10:FF:000048', NULL, NULL, 'Glr1397 protein', NULL, NULL, NULL, NULL, NULL, 4),
(24318, NULL, 'G3DSA:3.30.420.40:FF:000655', NULL, NULL, 'Actin-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(24319, NULL, 'G3DSA:2.130.10.10:FF:001698', NULL, NULL, 'Small nucleolar ribonucleoprotein complex subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24320, NULL, 'G3DSA:3.40.1050.10:FF:000036', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(24321, NULL, 'G3DSA:3.40.50.10810:FF:000049', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(24322, NULL, 'G3DSA:1.25.40.10:FF:004428', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24323, NULL, 'G3DSA:1.10.287.70:FF:000500', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24324, NULL, 'G3DSA:2.40.50.140:FF:000541', NULL, NULL, 'Telomere-binding protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(24325, NULL, 'G3DSA:3.30.160.60:FF:000416', NULL, NULL, 'zinc finger protein 879 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(24326, NULL, 'G3DSA:3.30.470.30:FF:000037', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(24327, NULL, 'G3DSA:1.25.40.10:FF:000505', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(24328, NULL, 'G3DSA:2.30.42.10:FF:000231', NULL, NULL, 'ZO-1 (Zonula Occludens tight junctional protein) Ortholog', NULL, NULL, NULL, NULL, NULL, 4),
(24329, NULL, 'G3DSA:3.90.550.50:FF:000093', NULL, NULL, 'GD23187', NULL, NULL, NULL, NULL, NULL, 4),
(24330, NULL, 'G3DSA:3.40.50.1220:FF:000023', NULL, NULL, 'Electron transfer flavoprotein, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(24331, NULL, 'G3DSA:3.30.420.40:FF:000127', NULL, NULL, 'actin-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(24332, NULL, 'G3DSA:2.60.120.1310:FF:000001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24333, NULL, 'G3DSA:3.10.20.230:FF:000020', NULL, NULL, 'Apicortin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24334, NULL, 'G3DSA:1.10.510.10:FF:003965', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24335, NULL, 'G3DSA:1.10.8.60:FF:000101', NULL, NULL, 'ATP-dependent zinc metalloprotease FTSH 12, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(24336, NULL, 'G3DSA:3.30.559.10:FF:000024', NULL, NULL, 'Carnitine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(24337, NULL, 'G3DSA:2.30.30.40:FF:000465', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24338, NULL, 'G3DSA:2.120.10.30:FF:000395', NULL, NULL, 'Vitellogenin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(24339, NULL, 'G3DSA:3.30.465.10:FF:000019', NULL, NULL, 'UDP-N-acetylenolpyruvoylglucosamine reductase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(24340, NULL, 'G3DSA:3.40.50.720:FF:001829', NULL, NULL, 'NRPS-like enzyme, putative (JCVI)', NULL, NULL, NULL, NULL, NULL, 4),
(24341, NULL, 'G3DSA:1.25.40.20:FF:000508', NULL, NULL, 'Ankyrin repeat domain 28, isoform CRA_c', NULL, NULL, NULL, NULL, NULL, 4),
(24342, NULL, 'G3DSA:3.40.50.1820:FF:001653', NULL, NULL, 'Triacylglycerol lipase', NULL, NULL, NULL, NULL, NULL, 4),
(24343, NULL, 'G3DSA:1.20.1070.10:FF:001292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24344, NULL, 'G3DSA:3.90.226.10:FF:000305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24345, NULL, 'G3DSA:2.160.20.10:FF:000146', NULL, NULL, 'Cell surface glycoprotein (S-layer protein)', NULL, NULL, NULL, NULL, NULL, 4),
(24346, NULL, 'G3DSA:3.40.630.40:FF:000028', NULL, NULL, 'Cell wall hydrolase/autolysin', NULL, NULL, NULL, NULL, NULL, 4),
(24347, NULL, 'G3DSA:3.30.230.10:FF:000340', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24348, NULL, 'G3DSA:1.50.40.10:FF:000239', NULL, NULL, 'Mitochondrial carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24349, NULL, 'G3DSA:3.30.870.10:FF:000051', NULL, NULL, 'Probable tyrosyl-DNA phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(24350, NULL, 'G3DSA:1.10.510.10:FF:002863', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24351, NULL, 'G3DSA:2.60.40.150:FF:000083', NULL, NULL, 'Copine 4', NULL, NULL, NULL, NULL, NULL, 4),
(24352, NULL, 'G3DSA:3.30.200.20:FF:000841', NULL, NULL, 'Checkpoint kinase 2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(24353, NULL, 'G3DSA:3.40.50.1000:FF:000249', NULL, NULL, 'Phosphomannomutase', NULL, NULL, NULL, NULL, NULL, 4),
(24354, NULL, 'G3DSA:1.10.10.10:FF:000677', NULL, NULL, 'DDRGK domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(24355, NULL, 'G3DSA:1.20.58.60:FF:000245', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(24356, NULL, 'G3DSA:3.90.226.10:FF:000215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24357, NULL, 'G3DSA:1.10.640.10:FF:000012', NULL, NULL, 'Blast:Peroxidasin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(24358, NULL, 'G3DSA:3.40.50.12780:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24359, NULL, 'G3DSA:3.40.50.2300:FF:000061', NULL, NULL, 'Amino acid ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(24360, NULL, 'G3DSA:2.60.40.10:FF:002861', NULL, NULL, 'Sialoadhesin', NULL, NULL, NULL, NULL, NULL, 4),
(24361, NULL, 'G3DSA:2.130.10.10:FF:004930', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24362, NULL, 'G3DSA:1.10.287.130:FF:000024', NULL, NULL, 'Sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(24363, NULL, 'G3DSA:3.40.50.1000:FF:000159', NULL, NULL, 'TFIIF-stimulated CTD phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(24364, NULL, 'G3DSA:3.40.50.11960:FF:000006', NULL, NULL, 'Increased recombination centers protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(24365, NULL, 'G3DSA:1.25.10.10:FF:002246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24366, NULL, 'G3DSA:3.40.50.10990:FF:000002', NULL, NULL, 'GTP cyclohydrolase-2', NULL, NULL, NULL, NULL, NULL, 4),
(24367, NULL, 'G3DSA:2.10.50.30:FF:000032', NULL, NULL, 'Metabotropic glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(24368, NULL, 'G3DSA:1.10.3430.10:FF:000029', NULL, NULL, 'Ammonium tramsporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24369, NULL, 'G3DSA:1.10.150.170:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24370, NULL, 'G3DSA:2.130.10.10:FF:003204', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1', NULL, NULL, NULL, NULL, NULL, 4),
(24371, NULL, 'G3DSA:3.40.50.1000:FF:000867', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24372, NULL, 'G3DSA:3.40.50.11950:FF:000003', NULL, NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(24373, NULL, 'G3DSA:3.30.160.60:FF:002277', NULL, NULL, 'FLT3-interacting zinc finger 1', NULL, NULL, NULL, NULL, NULL, 4),
(24374, NULL, 'G3DSA:3.30.470.20:FF:000124', NULL, NULL, 'Glutathione biosynthesis bifunctional protein GshAB', NULL, NULL, NULL, NULL, NULL, 4),
(24375, NULL, 'G3DSA:3.90.550.50:FF:000183', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(24376, NULL, 'G3DSA:3.40.50.300:FF:006734', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24377, NULL, 'G3DSA:3.30.200.20:FF:000133', NULL, NULL, 'LOV domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(24378, NULL, 'G3DSA:1.25.40.10:FF:004518', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24379, NULL, 'G3DSA:3.30.40.10:FF:001545', NULL, NULL, 'TFIIE alpha subunit-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(24380, NULL, 'G3DSA:3.40.50.2300:FF:000712', NULL, NULL, 'Aliphatic amidase expression-regulating protein', NULL, NULL, NULL, NULL, NULL, 4),
(24381, NULL, 'G3DSA:2.40.320.10:FF:000005', NULL, NULL, 'Thiamine-triphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(24382, NULL, 'G3DSA:3.55.10.10:FF:000003', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(24383, NULL, 'G3DSA:3.30.420.40:FF:000745', NULL, NULL, 'Actin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24384, NULL, 'G3DSA:3.20.20.70:FF:000808', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24385, NULL, 'G3DSA:4.10.640.10:FF:000012', NULL, NULL, '30S ribosomal protein S18', NULL, NULL, NULL, NULL, NULL, 4),
(24386, NULL, 'G3DSA:2.30.42.10:FF:000141', NULL, NULL, 'Phosphatidylinositol-3,4,5-trisphosphate dependent Rac exchange factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(24387, NULL, 'G3DSA:3.40.50.1820:FF:000023', NULL, NULL, 'thymus-specific serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(24388, NULL, 'G3DSA:3.90.110.10:FF:000019', NULL, NULL, 'L-lactate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(24389, NULL, 'G3DSA:1.20.120.1760:FF:000029', NULL, NULL, 'CDP-alcohol phosphatidyltransferase protein', NULL, NULL, NULL, NULL, NULL, 4),
(24390, NULL, 'G3DSA:2.60.40.10:FF:002389', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(24391, NULL, 'G3DSA:3.90.1150.10:FF:000313', NULL, NULL, 'Uncharacterized aminotransferase C777.03c', NULL, NULL, NULL, NULL, NULL, 4),
(24392, NULL, 'G3DSA:1.20.1530.20:FF:000088', NULL, NULL, 'Transporter, arsenite efflux pump ACR3 family', NULL, NULL, NULL, NULL, NULL, 4),
(24393, NULL, 'G3DSA:3.40.50.300:FF:000097', NULL, NULL, 'Regulator of nonsense transcripts 1', NULL, NULL, NULL, NULL, NULL, 4),
(24394, NULL, 'G3DSA:2.10.10.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24395, NULL, 'G3DSA:1.20.1270.280:FF:000074', NULL, NULL, 'Dynein, axonemal, heavy chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(24396, NULL, 'G3DSA:2.70.70.10:FF:000041', NULL, NULL, 'Peptidase, M23/M37 family', NULL, NULL, NULL, NULL, NULL, 4),
(24397, NULL, 'G3DSA:2.30.29.30:FF:000122', NULL, NULL, 'Actin filament associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(24398, NULL, 'G3DSA:1.10.287.110:FF:000159', NULL, NULL, 'Related to DnaJ protein', NULL, NULL, NULL, NULL, NULL, 4),
(24399, NULL, 'G3DSA:3.10.100.10:FF:000380', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24400, NULL, 'G3DSA:1.10.287.110:FF:000215', NULL, NULL, 'DnaJ domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(24401, NULL, 'G3DSA:2.60.40.10:FF:002445', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24402, NULL, 'G3DSA:2.10.110.10:FF:000148', NULL, NULL, 'Protein CBR-ZYX-1', NULL, NULL, NULL, NULL, NULL, 4),
(24403, NULL, 'G3DSA:3.40.1280.10:FF:000019', NULL, NULL, 'Putative tRNA/rRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(24404, NULL, 'G3DSA:3.30.160.60:FF:004547', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24405, NULL, 'G3DSA:3.30.450.40:FF:000129', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(24406, NULL, 'G3DSA:3.30.420.40:FF:000094', NULL, NULL, 'actin-like protein 7A', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(24407, NULL, 'G3DSA:1.20.120.1750:FF:000026', NULL, NULL, 'RANBP2-type and C3HC4-type zinc finger containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(24408, NULL, 'G3DSA:3.30.70.1390:FF:000003', NULL, NULL, 'Malignant fibrous histiocytoma-amplified sequence 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(24409, NULL, 'G3DSA:2.50.20.10:FF:000022', NULL, NULL, 'Sigma E factor regulatory protein RseB', NULL, NULL, NULL, NULL, NULL, 4),
(24410, NULL, 'G3DSA:3.10.100.10:FF:000374', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24411, NULL, 'G3DSA:2.40.70.10:FF:000256', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24412, NULL, 'G3DSA:1.50.10.20:FF:000004', NULL, NULL, 'Geranylgeranyl transferase type-2 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(24413, NULL, 'G3DSA:2.10.25.10:FF:000512', NULL, NULL, 'Laminin subunit alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(24414, NULL, 'G3DSA:1.25.10.10:FF:002807', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24415, NULL, 'G3DSA:2.40.70.10:FF:000312', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24416, NULL, 'G3DSA:3.40.366.10:FF:000012', NULL, NULL, 'Malonyl CoA-acyl carrier protein transacylase', NULL, NULL, NULL, NULL, NULL, 4),
(24417, NULL, 'G3DSA:3.30.450.20:FF:000123', NULL, NULL, 'Dysfusion, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(24418, NULL, 'G3DSA:1.25.40.530:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24419, NULL, 'G3DSA:1.10.340.30:FF:000001', NULL, NULL, 'Endonuclease III', NULL, NULL, NULL, NULL, NULL, 4),
(24420, NULL, 'G3DSA:1.50.10.10:FF:000001', NULL, NULL, 'probable alkaline/neutral invertase B', NULL, NULL, NULL, NULL, NULL, 4),
(24421, NULL, 'G3DSA:2.60.40.60:FF:000813', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(24422, NULL, 'G3DSA:4.10.60.10:FF:000151', NULL, NULL, 'RecQ helicase-like 4', NULL, NULL, NULL, NULL, NULL, 4),
(24423, NULL, 'G3DSA:1.20.1070.10:FF:001640', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24424, NULL, 'G3DSA:2.120.10.30:FF:000007', NULL, NULL, 'Putative tripartite motif-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(24425, NULL, 'G3DSA:3.80.10.10:FF:000411', NULL, NULL, 'Leucine-rich repeat-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(24426, NULL, 'G3DSA:3.60.15.10:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24427, NULL, 'G3DSA:3.40.1370.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24428, NULL, 'G3DSA:1.10.357.10:FF:000090', NULL, NULL, 'Putative transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(24429, NULL, 'G3DSA:2.30.30.40:FF:000611', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(24430, NULL, 'G3DSA:3.10.129.10:FF:000131', NULL, NULL, 'YBL095W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(24431, NULL, 'G3DSA:2.40.30.10:FF:000192', NULL, NULL, 'Sulfate adenylyltransferase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(24432, NULL, 'G3DSA:1.20.1510.10:FF:000084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24433, NULL, 'G3DSA:2.30.42.10:FF:000085', NULL, NULL, 'Phosphatidylinositol-3,4,5-trisphosphate dependent Rac exchange factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(24434, NULL, 'G3DSA:1.25.40.10:FF:003939', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24435, NULL, 'G3DSA:2.130.10.10:FF:002367', NULL, NULL, 'DDB1-and CUL4-associated factor 11 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(24436, NULL, 'G3DSA:1.25.50.20:FF:000099', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(24437, NULL, 'G3DSA:2.40.50.140:FF:000395', NULL, NULL, 'Replication protein A3', NULL, NULL, NULL, NULL, NULL, 4),
(24438, NULL, 'G3DSA:2.40.100.10:FF:000079', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(24439, NULL, 'G3DSA:1.20.1250.20:FF:000898', NULL, NULL, 'Proton-dependent oligopeptide transporter, POT family', NULL, NULL, NULL, NULL, NULL, 4),
(24440, NULL, 'G3DSA:3.40.190.290:FF:000123', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(24441, NULL, 'G3DSA:3.30.428.10:FF:000052', NULL, NULL, 'Histidine triad (HIT) protein', NULL, NULL, NULL, NULL, NULL, 4),
(24442, NULL, 'G3DSA:3.40.50.880:FF:000197', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(24443, NULL, 'G3DSA:3.90.980.20:FF:000009', NULL, NULL, 'Polycomblike, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(24444, NULL, 'G3DSA:3.40.225.10:FF:000011', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(24445, NULL, 'G3DSA:3.30.1120.160:FF:000003', NULL, NULL, 'GTPase-activating Rap/Ran-GAP domain-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(24446, NULL, 'G3DSA:3.30.300.20:FF:000079', NULL, NULL, 'Gtp-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(24447, NULL, 'G3DSA:1.20.120.1750:FF:000083', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(24448, NULL, 'G3DSA:1.10.287.70:FF:000028', NULL, NULL, 'potassium voltage-gated channel subfamily D member 3', NULL, NULL, NULL, NULL, NULL, 4),
(24449, NULL, 'G3DSA:3.30.70.370:FF:000022', NULL, NULL, 'DNA polymerase nu', NULL, NULL, NULL, NULL, NULL, 4),
(24450, NULL, 'G3DSA:1.10.238.10:FF:000667', NULL, NULL, 'probable calcium-binding protein CML41', NULL, NULL, NULL, NULL, NULL, 4),
(24451, NULL, 'G3DSA:1.10.287.70:FF:000793', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24452, NULL, 'G3DSA:2.120.10.10:FF:000001', NULL, NULL, 'Neuraminidase', NULL, NULL, NULL, NULL, NULL, 4),
(24453, NULL, 'G3DSA:3.40.190.290:FF:000067', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(24454, NULL, 'G3DSA:1.10.260.50:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24455, NULL, 'G3DSA:3.40.50.2000:FF:000274', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(24456, NULL, 'G3DSA:2.70.98.10:FF:000009', NULL, NULL, 'Putative aldose-1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(24457, NULL, 'G3DSA:1.20.120.1760:FF:000086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24458, NULL, 'G3DSA:3.90.980.10:FF:000006', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(24459, NULL, 'G3DSA:3.30.160.60:FF:000860', NULL, NULL, 'zinc finger protein SNAI2', NULL, NULL, NULL, NULL, NULL, 4),
(24460, NULL, 'G3DSA:2.170.130.10:FF:000011', NULL, NULL, 'TonB-dependent siderophore receptor', NULL, NULL, NULL, NULL, NULL, 4),
(24461, NULL, 'G3DSA:3.40.50.280:FF:000017', NULL, NULL, 'Corrinoid protein', NULL, NULL, NULL, NULL, NULL, 4),
(24462, NULL, 'G3DSA:1.10.260.40:FF:000003', NULL, NULL, 'DNA-binding protein SATB', NULL, NULL, NULL, NULL, NULL, 4),
(24463, NULL, 'G3DSA:2.60.40.630:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24464, NULL, 'G3DSA:2.130.10.10:FF:000714', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(24465, NULL, 'G3DSA:3.30.210.10:FF:000007', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(24466, NULL, 'G3DSA:3.30.200.20:FF:000515', NULL, NULL, 'Inactive serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(24467, NULL, 'G3DSA:1.25.10.10:FF:001026', NULL, NULL, 'GM17740', NULL, NULL, NULL, NULL, NULL, 4),
(24468, NULL, 'G3DSA:3.30.2350.10:FF:000005', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(24469, NULL, 'G3DSA:1.10.10.60:FF:000760', NULL, NULL, 'Mu phage middle operon regulator Mor', NULL, NULL, NULL, NULL, NULL, 4),
(24470, NULL, 'G3DSA:1.10.420.10:FF:000029', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(24471, NULL, 'G3DSA:2.30.29.30:FF:001049', NULL, NULL, 'Uncharacterized PH domain-containing protein C19A8.02', NULL, NULL, NULL, NULL, NULL, 4),
(24472, NULL, 'G3DSA:3.90.260.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24473, NULL, 'G3DSA:3.40.50.2000:FF:000330', NULL, NULL, 'UDP-N-acetylglucosamine transferase subunit ALG14, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24474, NULL, 'G3DSA:3.30.310.40:FF:000006', NULL, NULL, 'AER127Cp', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(24475, NULL, 'G3DSA:2.60.40.640:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24476, NULL, 'G3DSA:2.40.10.10:FF:000191', NULL, NULL, 'GM21018', NULL, NULL, NULL, NULL, NULL, 4),
(24477, NULL, 'G3DSA:1.25.40.10:FF:002158', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(24478, NULL, 'G3DSA:1.20.5.170:FF:000024', NULL, NULL, 'VHS domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(24479, NULL, 'G3DSA:3.30.2350.20:FF:000008', NULL, NULL, 'tRNA pseudouridine synthase D', NULL, NULL, NULL, NULL, NULL, 4),
(24480, NULL, 'G3DSA:2.60.40.10:FF:000259', NULL, NULL, 'Host cell factor 1 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(24481, NULL, 'G3DSA:3.10.100.10:FF:000048', NULL, NULL, 'Multiplexin collagen isoform Ap3', NULL, NULL, NULL, NULL, NULL, 4),
(24482, NULL, 'G3DSA:2.60.40.10:FF:000298', NULL, NULL, 'Nectin cell adhesion molecule 3', NULL, NULL, NULL, NULL, NULL, 4),
(24483, NULL, 'G3DSA:1.50.40.10:FF:000565', NULL, NULL, 'Mitochondrial carrier protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(24484, NULL, 'G3DSA:3.30.310.50:FF:000009', NULL, NULL, 'Probable phosphoglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(24485, NULL, 'G3DSA:2.130.10.10:FF:000771', NULL, NULL, 'Elongator acetyltransferase complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(24486, NULL, 'G3DSA:2.20.90.10:FF:000005', NULL, NULL, 'Vitellogenin 5', NULL, NULL, NULL, NULL, NULL, 4),
(24487, NULL, 'G3DSA:2.130.10.10:FF:000478', NULL, NULL, 'WD repeat and HMG-box DNA binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(24488, NULL, 'G3DSA:2.20.70.10:FF:000004', NULL, NULL, 'dystrophin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(24489, NULL, 'G3DSA:2.30.30.380:FF:000038', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(24490, NULL, 'G3DSA:3.30.2350.20:FF:000065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24491, NULL, 'G3DSA:2.30.36.70:FF:000021', NULL, NULL, 'AGAP004488-PA', NULL, NULL, NULL, NULL, NULL, 4),
(24492, NULL, 'G3DSA:2.170.270.10:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24493, NULL, 'G3DSA:2.130.10.10:FF:005857', NULL, NULL, 'Probable Methylamine utilization protein mauG', NULL, NULL, NULL, NULL, NULL, 4),
(24494, NULL, 'G3DSA:1.25.40.10:FF:000449', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(24495, NULL, 'G3DSA:2.40.10.10:FF:000567', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24496, NULL, 'G3DSA:1.20.1070.10:FF:001527', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24497, NULL, 'G3DSA:2.60.40.3180:FF:000005', NULL, NULL, 'EBF transcription factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(24498, NULL, 'G3DSA:3.40.1190.20:FF:000111', NULL, NULL, 'Ribokinase', NULL, NULL, NULL, NULL, NULL, 4),
(24499, NULL, 'G3DSA:3.10.440.10:FF:000006', NULL, NULL, 'Ribosomal protein L31e, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24500, NULL, 'G3DSA:1.10.510.10:FF:000059', NULL, NULL, 'Casein kinase II subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(24501, NULL, 'G3DSA:3.40.1090.10:FF:000067', NULL, NULL, 'Lysophospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(24502, NULL, 'G3DSA:3.30.2350.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24503, NULL, 'G3DSA:2.40.160.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24504, NULL, 'G3DSA:3.40.50.300:FF:006818', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24505, NULL, 'G3DSA:3.20.20.70:FF:000573', NULL, NULL, 'Peroxisomal (S)-2-hydroxy-acid oxidase GLO1', NULL, NULL, NULL, NULL, NULL, 4),
(24506, NULL, 'G3DSA:3.40.50.300:FF:004172', NULL, NULL, 'Guanylate-binding protein family member 6', NULL, NULL, NULL, NULL, NULL, 4),
(24507, NULL, 'G3DSA:3.30.420.40:FF:000829', NULL, NULL, 'ARP5 actin related protein 5 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(24508, NULL, 'G3DSA:3.40.50.150:FF:001052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(24509, NULL, 'G3DSA:3.40.50.720:FF:001537', NULL, NULL, 'Trans-2-enoyl-CoA reductase [NADH]', NULL, NULL, NULL, NULL, NULL, 4),
(24510, NULL, 'G3DSA:3.30.70.330:FF:000853', NULL, NULL, 'U1 70K', NULL, NULL, NULL, NULL, NULL, 4),
(24511, NULL, 'G3DSA:3.20.20.70:FF:000140', NULL, NULL, 'Fructose-bisphosphate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(24512, NULL, 'G3DSA:3.30.1520.10:FF:000125', NULL, NULL, 'AER438Cp', NULL, NULL, NULL, NULL, NULL, 4),
(24513, NULL, 'G3DSA:2.70.160.11:FF:000032', NULL, NULL, 'Arginine N-methyltransferase 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24514, NULL, 'G3DSA:3.30.200.20:FF:001768', NULL, NULL, 'Integrin-linked protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(24515, NULL, 'G3DSA:3.40.50.300:FF:002547', NULL, NULL, 'Pre-mRNA-processing ATP-dependent RNA helicase PRP5', NULL, NULL, NULL, NULL, NULL, 4),
(24516, NULL, 'G3DSA:2.40.170.20:FF:000069', NULL, NULL, 'SusC homolog', NULL, NULL, NULL, NULL, NULL, 4),
(24517, NULL, 'G3DSA:3.20.20.80:FF:000143', NULL, NULL, 'Pullulanase, type I', NULL, NULL, NULL, NULL, NULL, 4),
(24518, NULL, 'G3DSA:3.40.50.150:FF:001703', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24519, NULL, 'G3DSA:2.10.25.10:FF:001294', NULL, NULL, 'AGAP003506-PA', NULL, NULL, NULL, NULL, NULL, 4),
(24520, NULL, 'G3DSA:2.30.240.10:FF:000001', NULL, NULL, 'At1g56580/F25P12_18', NULL, NULL, NULL, NULL, NULL, 4),
(24521, NULL, 'G3DSA:2.60.40.2070:FF:000009', NULL, NULL, 'Outer membrane usher protein SfmD', NULL, NULL, NULL, NULL, NULL, 4),
(24522, NULL, 'G3DSA:2.60.40.150:FF:000588', NULL, NULL, 'Plant synaptotagmin: integral membrane double C2 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(24523, NULL, 'G3DSA:3.30.559.30:FF:000092', NULL, NULL, 'Plipastatin synthase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(24524, NULL, 'G3DSA:1.20.1250.20:FF:000521', NULL, NULL, 'YJR124C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(24525, NULL, 'G3DSA:2.60.40.10:FF:006043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24526, NULL, 'G3DSA:3.10.20.90:FF:000809', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24527, NULL, 'G3DSA:3.90.226.10:FF:000131', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(24528, NULL, 'G3DSA:1.20.1510.10:FF:000027', NULL, NULL, 'Zinc transporter ttm-1', NULL, NULL, NULL, NULL, NULL, 4),
(24529, NULL, 'G3DSA:1.20.58.760:FF:000021', NULL, NULL, 'Cell division protein FstH', NULL, NULL, NULL, NULL, NULL, 4),
(24530, NULL, 'G3DSA:2.60.120.10:FF:000688', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24531, NULL, 'G3DSA:2.130.10.10:FF:004514', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24532, NULL, 'G3DSA:1.20.920.10:FF:000003', NULL, NULL, 'Bromodomain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(24533, NULL, 'G3DSA:3.40.30.10:FF:000706', NULL, NULL, 'Glutathione S-transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24534, NULL, 'G3DSA:1.20.920.20:FF:000006', NULL, NULL, 'Dynein, axonemal, heavy chain 6', NULL, NULL, NULL, NULL, NULL, 4),
(24535, NULL, 'G3DSA:3.40.50.300:FF:006257', NULL, NULL, 'Chromodomain helicase DNA-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(24536, NULL, 'G3DSA:3.40.800.10:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24537, NULL, 'G3DSA:1.25.40.10:FF:003737', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24538, NULL, 'G3DSA:3.30.160.60:FF:006256', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24539, NULL, 'G3DSA:1.25.40.390:FF:000002', NULL, NULL, 'SusD-like protein BACOVA_02651', NULL, NULL, NULL, NULL, NULL, 4),
(24540, NULL, 'G3DSA:1.20.1070.10:FF:001584', NULL, NULL, 'MAS-related 7-transmembrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(24541, NULL, 'G3DSA:2.120.10.80:FF:000179', NULL, NULL, 'kelch repeat and BTB domain-containing protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(24542, NULL, 'G3DSA:2.60.40.10:FF:005879', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(24543, NULL, 'G3DSA:2.60.120.260:FF:000372', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(24544, NULL, 'G3DSA:2.60.40.640:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24545, NULL, 'G3DSA:3.40.800.20:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24546, NULL, 'G3DSA:3.40.50.720:FF:001594', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24547, NULL, 'G3DSA:1.25.40.10:FF:004721', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24548, NULL, 'G3DSA:1.10.238.150:FF:000004', NULL, NULL, 'Blast:Disheveled-associated activator of morphogenesis 1', NULL, NULL, NULL, NULL, NULL, 4),
(24549, NULL, 'G3DSA:2.60.40.10:FF:004098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24550, NULL, 'G3DSA:3.30.720.200:FF:000001', NULL, NULL, 'Glycine--tRNA ligase 2', NULL, NULL, NULL, NULL, NULL, 4),
(24551, NULL, 'G3DSA:1.10.10.60:FF:000467', NULL, NULL, 'Os03g0412900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(24552, NULL, 'G3DSA:2.30.30.40:FF:000196', NULL, NULL, 'Chemotaxis protein CheV', NULL, NULL, NULL, NULL, NULL, 4),
(24553, NULL, 'G3DSA:3.30.720.210:FF:000004', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(24554, NULL, 'G3DSA:1.20.920.30:FF:000009', NULL, NULL, 'Dynein heavy chain 9', NULL, NULL, NULL, NULL, NULL, 4),
(24555, NULL, 'G3DSA:3.10.330.10:FF:000037', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(24556, NULL, 'G3DSA:3.30.559.70:FF:000053', NULL, NULL, 'Carnitine acyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24557, NULL, 'G3DSA:2.70.170.10:FF:000077', NULL, NULL, 'Acetylcholine-gated chloride channel subunit acc-3', NULL, NULL, NULL, NULL, NULL, 4),
(24558, NULL, 'G3DSA:3.40.50.300:FF:003154', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(24559, NULL, 'G3DSA:3.80.10.10:FF:004211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24560, NULL, 'G3DSA:3.30.1540.20:FF:000017', NULL, NULL, 'MutL-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(24561, NULL, 'G3DSA:1.20.58.60:FF:000301', NULL, NULL, 'Spectrin beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(24562, NULL, 'G3DSA:2.160.10.10:FF:000117', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(24563, NULL, 'G3DSA:3.40.930.10:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24564, NULL, 'G3DSA:3.80.10.10:FF:003227', NULL, NULL, 'AGAP009026-PA', NULL, NULL, NULL, NULL, NULL, 4),
(24565, NULL, 'G3DSA:1.20.120.230:FF:000002', NULL, NULL, 'Talin 2', NULL, NULL, NULL, NULL, NULL, 4),
(24566, NULL, 'G3DSA:1.25.40.10:FF:004344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24567, NULL, 'G3DSA:1.10.20.10:FF:000324', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24568, NULL, 'G3DSA:2.60.34.10:FF:000115', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(24569, NULL, 'G3DSA:2.30.42.10:FF:000315', NULL, NULL, 'AGAP011205-PA', NULL, NULL, NULL, NULL, NULL, 4),
(24570, NULL, 'G3DSA:2.130.10.10:FF:002569', NULL, NULL, 'Intraflagellar transport 122', NULL, NULL, NULL, NULL, NULL, 4),
(24571, NULL, 'G3DSA:3.30.160.60:FF:000708', NULL, NULL, 'Sal-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(24572, NULL, 'G3DSA:3.40.850.10:FF:000053', NULL, NULL, 'Kinesin family', NULL, NULL, NULL, NULL, NULL, 4),
(24573, NULL, 'G3DSA:1.20.1250.20:FF:002174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24574, NULL, 'G3DSA:3.80.10.10:FF:003284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24575, NULL, 'G3DSA:2.40.30.10:FF:000456', NULL, NULL, 'Cytochrome b5 reductase 4-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(24576, NULL, 'G3DSA:1.10.238.10:FF:000780', NULL, NULL, 'CALUmenin (Calcium-binding protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(24577, NULL, 'G3DSA:3.30.160.60:FF:005003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(24578, NULL, 'G3DSA:1.10.472.10:FF:000166', NULL, NULL, 'Unplaced genomic scaffold supercont1.8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(24579, NULL, 'G3DSA:1.10.10.10:FF:001987', NULL, NULL, 'ISSpo6, transposase orf A', NULL, NULL, NULL, NULL, NULL, 4),
(24580, NULL, 'G3DSA:3.40.50.620:FF:000462', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(24581, NULL, 'G3DSA:1.10.238.10:FF:000723', NULL, NULL, 'Centrin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24582, NULL, 'G3DSA:2.130.10.10:FF:002480', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24583, NULL, 'G3DSA:3.30.1140.40:FF:000004', NULL, NULL, 'Putative dynein light chain', NULL, NULL, NULL, NULL, NULL, 4),
(24584, NULL, 'G3DSA:3.60.15.10:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24585, NULL, 'G3DSA:3.30.70.560:FF:000012', NULL, NULL, 'Folic acid synthesis protein FOL1', NULL, NULL, NULL, NULL, NULL, 4),
(24586, NULL, 'G3DSA:1.10.30.10:FF:000061', NULL, NULL, 'High mobility group protein B3', NULL, NULL, NULL, NULL, NULL, 4),
(24587, NULL, 'G3DSA:3.40.50.1000:FF:000693', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24588, NULL, 'G3DSA:1.20.1540.10:FF:000001', NULL, NULL, 'Putative inactive rhomboid protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(24589, NULL, 'G3DSA:2.130.10.10:FF:002423', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24590, NULL, 'G3DSA:3.30.40.10:FF:001129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24591, NULL, 'G3DSA:1.10.730.10:FF:000098', NULL, NULL, 'Leucine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(24592, NULL, 'G3DSA:3.90.70.10:FF:000780', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24593, NULL, 'G3DSA:2.40.50.770:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24594, NULL, 'G3DSA:1.25.40.10:FF:002922', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24595, NULL, 'G3DSA:2.10.25.10:FF:001440', NULL, NULL, 'Netrin-5', NULL, NULL, NULL, NULL, NULL, 4),
(24596, NULL, 'G3DSA:2.60.40.10:FF:004952', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24597, NULL, 'G3DSA:3.30.200.60:FF:000010', NULL, NULL, 'OTU deubiquitinase, ubiquitin aldehyde binding 2', NULL, NULL, NULL, NULL, NULL, 4),
(24598, NULL, 'G3DSA:3.40.50.300:FF:004548', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(24599, NULL, 'G3DSA:3.30.200.20:FF:000279', NULL, NULL, 'Calcium/calmodulin-dependent protein kinase type IV', NULL, NULL, NULL, NULL, NULL, 4),
(24600, NULL, 'G3DSA:2.60.34.10:FF:000059', NULL, NULL, 'Heat shock 70kDa protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(24601, NULL, 'G3DSA:2.10.25.10:FF:001384', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24602, NULL, 'G3DSA:3.30.260.10:FF:000105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24603, NULL, 'G3DSA:3.30.1890.10:FF:000001', NULL, NULL, 'ECA polysaccharide chain length modulation protein', NULL, NULL, NULL, NULL, NULL, 4),
(24604, NULL, 'G3DSA:3.40.850.10:FF:000143', NULL, NULL, 'Unplaced genomic scaffold supercont2.12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(24605, NULL, 'G3DSA:1.10.287.1490:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24606, NULL, 'G3DSA:3.90.1200.10:FF:000020', NULL, NULL, 'Homoserine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(24607, NULL, 'G3DSA:3.40.50.2300:FF:001078', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(24608, NULL, 'G3DSA:1.25.40.20:FF:001531', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(24609, NULL, 'G3DSA:3.40.50.300:FF:004790', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24610, NULL, 'G3DSA:3.30.50.10:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24611, NULL, 'G3DSA:1.20.1530.20:FF:000032', NULL, NULL, 'Integral membrane transport protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(24612, NULL, 'G3DSA:2.60.40.150:FF:000442', NULL, NULL, 'YALI0A17985p', NULL, NULL, NULL, NULL, NULL, 4),
(24613, NULL, 'G3DSA:3.40.30.10:FF:001257', NULL, NULL, 'Thioredoxin domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(24614, NULL, 'G3DSA:1.10.510.10:FF:002476', NULL, NULL, 'Serine/threonine-protein kinase ppk34', NULL, NULL, NULL, NULL, NULL, 4),
(24615, NULL, 'G3DSA:1.10.472.10:FF:000402', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24616, NULL, 'G3DSA:1.10.1450.10:FF:000064', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(24617, NULL, 'G3DSA:1.10.510.10:FF:002532', NULL, NULL, 'serine/threonine-protein kinase Nek3-like', NULL, NULL, NULL, NULL, NULL, 4),
(24618, NULL, 'G3DSA:3.40.50.300:FF:008533', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24619, NULL, 'G3DSA:1.10.20.10:FF:000268', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24620, NULL, 'G3DSA:3.40.50.300:FF:000804', NULL, NULL, 'E3 ubiquitin-protein ligase RNF213', NULL, NULL, NULL, NULL, NULL, 4),
(24621, NULL, 'G3DSA:1.25.40.10:FF:002719', NULL, NULL, 'Coatomer subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(24622, NULL, 'G3DSA:3.30.70.330:FF:000235', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(24623, NULL, 'G3DSA:1.10.510.10:FF:000677', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(24624, NULL, 'G3DSA:2.60.260.20:FF:000055', NULL, NULL, 'Chaperone protein DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(24625, NULL, 'G3DSA:3.40.50.300:FF:008590', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24626, NULL, 'G3DSA:2.60.40.10:FF:004805', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24627, NULL, 'G3DSA:3.40.47.10:FF:000037', NULL, NULL, '3-oxoacyl-ACP synthase III', NULL, NULL, NULL, NULL, NULL, 4),
(24628, NULL, 'G3DSA:2.40.70.10:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24629, NULL, 'G3DSA:1.10.10.10:FF:000823', NULL, NULL, 'Possible hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(24630, NULL, 'G3DSA:3.30.160.60:FF:001057', NULL, NULL, 'zinc finger protein 358', NULL, NULL, NULL, NULL, NULL, 4),
(24631, NULL, 'G3DSA:1.20.1070.10:FF:000420', NULL, NULL, 'OCTopamine Receptor (GPCR)', NULL, NULL, NULL, NULL, NULL, 4),
(24632, NULL, 'G3DSA:3.80.10.10:FF:003901', NULL, NULL, 'AGAP011649-PA', NULL, NULL, NULL, NULL, NULL, 4),
(24633, NULL, 'G3DSA:3.30.200.20:FF:001971', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24634, NULL, 'G3DSA:1.20.1250.20:FF:001954', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(24635, NULL, 'G3DSA:3.40.50.960:FF:000013', NULL, NULL, '6,7-dimethyl-8-ribityllumazine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(24636, NULL, 'G3DSA:2.40.100.10:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24637, NULL, 'G3DSA:3.30.450.40:FF:000096', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(24638, NULL, 'G3DSA:2.60.40.1170:FF:000015', NULL, NULL, 'Coatomer subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(24639, NULL, 'G3DSA:3.10.580.10:FF:000168', NULL, NULL, 'Chloride channel protein B', NULL, NULL, NULL, NULL, NULL, 4),
(24640, NULL, 'G3DSA:1.10.238.10:FF:001033', NULL, NULL, 'Ustilago maydis induced12', NULL, NULL, NULL, NULL, NULL, 4),
(24641, NULL, 'G3DSA:2.130.10.10:FF:000063', NULL, NULL, 'SEH1 like nucleoporin', NULL, NULL, NULL, NULL, NULL, 4),
(24642, NULL, 'G3DSA:3.30.70.330:FF:000292', NULL, NULL, 'RNA-binding motif protein 45', NULL, NULL, NULL, NULL, NULL, 4),
(24643, NULL, 'G3DSA:1.25.40.90:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24644, NULL, 'G3DSA:1.20.120.1240:FF:000020', NULL, NULL, 'Dynamin 2', NULL, NULL, NULL, NULL, NULL, 4),
(24645, NULL, 'G3DSA:1.10.510.10:FF:001082', NULL, NULL, 'Probable transmembrane serine/threonine-protein kinase I pknI', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(24646, NULL, 'G3DSA:3.30.40.10:FF:002242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24647, NULL, 'G3DSA:3.10.20.70:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24648, NULL, 'G3DSA:3.40.50.300:FF:000658', NULL, NULL, 'ADP-ribosylation factor-like protein 4A', NULL, NULL, NULL, NULL, NULL, 4),
(24649, NULL, 'G3DSA:3.90.650.10:FF:000021', NULL, NULL, 'selenide, water dikinase 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(24650, NULL, 'G3DSA:3.30.160.60:FF:001203', NULL, NULL, 'zinc finger protein 668', NULL, NULL, NULL, NULL, NULL, 4),
(24651, NULL, 'G3DSA:3.30.700.10:FF:000005', NULL, NULL, 'MSHA major pilin subunit MshA', NULL, NULL, NULL, NULL, NULL, 4),
(24652, NULL, 'G3DSA:3.90.76.10:FF:000057', NULL, NULL, 'Maltose ABC transporter, maltose binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(24653, NULL, 'G3DSA:2.120.10.80:FF:000269', NULL, NULL, 'F-box/kelch-repeat protein At2g44130', NULL, NULL, NULL, NULL, NULL, 4),
(24654, NULL, 'G3DSA:3.90.110.10:FF:000020', NULL, NULL, '6-phospho-beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(24655, NULL, 'G3DSA:3.40.50.2000:FF:000184', NULL, NULL, 'Glycosyl transferase, group 1', NULL, NULL, NULL, NULL, NULL, 4),
(24656, NULL, 'G3DSA:3.90.550.50:FF:000238', NULL, NULL, 'Beta-3-glucosyltransferase a', NULL, NULL, NULL, NULL, NULL, 4),
(24657, NULL, 'G3DSA:3.30.230.70:FF:000127', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(24658, NULL, 'G3DSA:2.60.40.10:FF:006099', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24659, NULL, 'G3DSA:3.80.10.10:FF:001575', NULL, NULL, 'Putative dual specificity protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(24660, NULL, 'G3DSA:3.30.40.10:FF:000112', NULL, NULL, 'RING finger protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(24661, NULL, 'G3DSA:3.30.160.60:FF:003002', NULL, NULL, 'zinc finger protein 853', NULL, NULL, NULL, NULL, NULL, 4),
(24662, NULL, 'G3DSA:3.80.10.10:FF:001518', NULL, NULL, 'Insulin-like growth factor-binding protein complex acid labile subunit', NULL, NULL, NULL, NULL, NULL, 4),
(24663, NULL, 'G3DSA:1.10.390.10:FF:000088', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(24664, NULL, 'G3DSA:3.30.70.270:FF:000138', NULL, NULL, 'Pro-Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(24665, NULL, 'G3DSA:2.30.30.40:FF:000667', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24666, NULL, 'G3DSA:2.130.10.10:FF:004278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24667, NULL, 'G3DSA:3.30.450.20:FF:000090', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(24668, NULL, 'G3DSA:3.30.450.30:FF:000093', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(24669, NULL, 'G3DSA:1.10.10.60:FF:000703', NULL, NULL, 'Putative SNF2 family helicase', NULL, NULL, NULL, NULL, NULL, 4),
(24670, NULL, 'G3DSA:2.60.40.10:FF:003316', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(24671, NULL, 'G3DSA:3.40.50.300:FF:002603', NULL, NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 10, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(24672, NULL, 'G3DSA:3.90.420.10:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24673, NULL, 'G3DSA:3.30.300.130:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24674, NULL, 'G3DSA:2.130.10.10:FF:003497', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(24675, NULL, 'G3DSA:2.10.25.10:FF:001327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24676, NULL, 'G3DSA:1.20.85.10:FF:000006', NULL, NULL, 'Photosynthetic reaction center subunit L', NULL, NULL, NULL, NULL, NULL, 4),
(24677, NULL, 'G3DSA:3.40.50.300:FF:008443', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24678, NULL, 'G3DSA:3.30.200.20:FF:001858', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(24679, NULL, 'G3DSA:2.60.40.60:FF:000291', NULL, NULL, 'Cadherin related family member 4', NULL, NULL, NULL, NULL, NULL, 4),
(24680, NULL, 'G3DSA:1.25.40.10:FF:002809', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(24681, NULL, 'G3DSA:3.30.590.20:FF:000009', NULL, NULL, 'Putative glutamate--cysteine ligase 2', NULL, NULL, NULL, NULL, NULL, 4),
(24682, NULL, 'G3DSA:2.40.30.130:FF:000023', NULL, NULL, 'Alanyl-tRNA synthetase-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24683, NULL, 'G3DSA:2.60.40.2660:FF:000001', NULL, NULL, 'Ankyrin-3 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(24684, NULL, 'G3DSA:2.60.40.60:FF:000049', NULL, NULL, 'protocadherin-15 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(24685, NULL, 'G3DSA:1.25.40.10:FF:002304', NULL, NULL, 'Bardet-Biedl syndrome 4 protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(24686, NULL, 'G3DSA:3.30.450.40:FF:000281', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(24687, NULL, 'G3DSA:2.60.40.60:FF:000667', NULL, NULL, 'Cadherin 16', NULL, NULL, NULL, NULL, NULL, 4),
(24688, NULL, 'G3DSA:2.40.30.10:FF:000512', NULL, NULL, 'NADPH--cytochrome P450 reductase 2', NULL, NULL, NULL, NULL, NULL, 4),
(24689, NULL, 'G3DSA:3.30.590.10:FF:000006', NULL, NULL, 'Arginine kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(24690, NULL, 'G3DSA:3.30.160.60:FF:000186', NULL, NULL, 'Zinc finger protein 366', NULL, NULL, NULL, NULL, NULL, 4),
(24691, NULL, 'G3DSA:2.10.25.10:FF:001474', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24692, NULL, 'G3DSA:3.40.50.11610:FF:000014', NULL, NULL, 'Oxoglutarate (alpha-ketoglutarate) dehydrogenase b (lipoamide)', NULL, NULL, NULL, NULL, NULL, 4),
(24693, NULL, 'G3DSA:3.10.20.90:FF:000287', NULL, NULL, 'Ubiquitin domain-containing protein DSK2,putative', NULL, NULL, NULL, NULL, NULL, 4),
(24694, NULL, 'G3DSA:2.60.40.10:FF:004862', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24695, NULL, 'G3DSA:2.60.40.10:FF:002299', NULL, NULL, 'AGAP003656-PA', NULL, NULL, NULL, NULL, NULL, 4),
(24696, NULL, 'G3DSA:3.90.1150.10:FF:000223', NULL, NULL, 'Probable glycine dehydrogenase (decarboxylating) subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(24697, NULL, 'G3DSA:1.10.10.60:FF:000052', NULL, NULL, 'Arginine-glutamic acid dipeptide (RE) repeats', NULL, NULL, NULL, NULL, NULL, 4),
(24698, NULL, 'G3DSA:1.20.1250.20:FF:001393', NULL, NULL, 'Major facilitator superfamily transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(24699, NULL, 'G3DSA:3.30.565.10:FF:000263', NULL, NULL, 'YALI0C10032p', NULL, NULL, NULL, NULL, NULL, 4),
(24700, NULL, 'G3DSA:1.25.10.10:FF:000773', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(24701, NULL, 'G3DSA:1.10.1450.10:FF:000154', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(24702, NULL, 'G3DSA:2.60.40.10:FF:000591', NULL, NULL, 'tyrosine-protein kinase receptor Tie-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(24703, NULL, 'G3DSA:3.40.190.10:FF:000463', NULL, NULL, 'sn-glycerol-3-phosphate ABC transporter substrate-binding lipoprotein UgpB', NULL, NULL, NULL, NULL, NULL, 4),
(24704, NULL, 'G3DSA:1.10.3380.10:FF:000002', NULL, NULL, 'Activating signal cointegrator 1 complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(24705, NULL, 'G3DSA:2.70.130.10:FF:000136', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24706, NULL, 'G3DSA:2.10.110.10:FF:000002', NULL, NULL, 'LIM domain and actin-binding 1', NULL, NULL, NULL, NULL, NULL, 4),
(24707, NULL, 'G3DSA:1.20.1600.10:FF:000057', NULL, NULL, 'Protein CyaE', NULL, NULL, NULL, NULL, NULL, 4),
(24708, NULL, 'G3DSA:1.10.287.110:FF:000069', NULL, NULL, 'ER associated DnaJ chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(24709, NULL, 'G3DSA:2.130.10.10:FF:004929', NULL, NULL, 'Uncharacterized RWD, RING finger and WD repeat-containing protein C11E3.05', NULL, NULL, NULL, NULL, NULL, 4),
(24710, NULL, 'G3DSA:1.20.930.10:FF:000032', NULL, NULL, 'Protein IWS1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(24711, NULL, 'G3DSA:2.10.110.20:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(24712, NULL, 'G3DSA:3.30.160.60:FF:001170', NULL, NULL, 'GDNF inducible zinc finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(24713, NULL, 'G3DSA:3.40.640.10:FF:000043', NULL, NULL, 'Cystathionine gamma-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(24714, NULL, 'G3DSA:3.20.180.20:FF:000014', NULL, NULL, 'Putative dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(24715, NULL, 'G3DSA:3.80.10.10:FF:001485', NULL, NULL, 'Protein CBR-DMA-1', NULL, NULL, NULL, NULL, NULL, 4),
(24716, NULL, 'G3DSA:2.40.30.270:FF:000014', NULL, NULL, 'DNA helicase HCS1', NULL, NULL, NULL, NULL, NULL, 4),
(24717, NULL, 'G3DSA:3.40.50.980:FF:000019', NULL, NULL, 'Nonribosomal peptide synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(24718, NULL, 'G3DSA:3.40.50.150:FF:000832', NULL, NULL, 'Betaine lipid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(24719, NULL, 'G3DSA:3.30.70.330:FF:000325', NULL, NULL, 'splicing regulator RBM11 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(24720, NULL, 'G3DSA:2.60.120.590:FF:000032', NULL, NULL, 'RNA demethylase ALKBH10B', NULL, NULL, NULL, NULL, NULL, 4),
(24721, NULL, 'G3DSA:3.30.530.20:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24722, NULL, 'G3DSA:1.20.58.1590:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24723, NULL, 'G3DSA:3.40.50.970:FF:000016', NULL, NULL, 'Acetolactate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(24724, NULL, 'G3DSA:1.10.3460.10:FF:000003', NULL, NULL, 'Chlorophyll a-b binding protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(24725, NULL, 'G3DSA:3.40.50.300:FF:001114', NULL, NULL, 'NLR family CARD domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(24726, NULL, 'G3DSA:3.40.50.300:FF:008387', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(24727, NULL, 'G3DSA:3.30.160.60:FF:001113', NULL, NULL, 'Zinc finger and BTB domain containing 48', NULL, NULL, NULL, NULL, NULL, 4),
(24728, NULL, 'G3DSA:2.60.40.10:FF:004334', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24729, NULL, 'G3DSA:2.60.40.60:FF:000852', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24730, NULL, 'G3DSA:3.30.1370.120:FF:000007', NULL, NULL, 'Type II secretion system protein D', NULL, NULL, NULL, NULL, NULL, 4),
(24731, NULL, 'G3DSA:1.25.40.10:FF:002248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24732, NULL, 'G3DSA:3.10.290.10:FF:000067', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(24733, NULL, 'G3DSA:1.20.5.1160:FF:000021', NULL, NULL, 'Coiled-coil domain-containing protein 61 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(24734, NULL, 'G3DSA:1.20.1250.20:FF:002320', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24735, NULL, 'G3DSA:3.90.470.20:FF:000077', NULL, NULL, 'Aminoadipate-semialdehyde dehydrogenase-phosphopantetheinyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(24736, NULL, 'G3DSA:3.30.160.60:FF:001023', NULL, NULL, 'MEFV, pyrin innate immunity regulator', NULL, NULL, NULL, NULL, NULL, 4),
(24737, NULL, 'G3DSA:3.30.830.10:FF:000161', NULL, NULL, 'Zinc protease PQQL-like', NULL, NULL, NULL, NULL, NULL, 4),
(24738, NULL, 'G3DSA:1.10.10.60:FF:000613', NULL, NULL, 'Probable transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(24739, NULL, 'G3DSA:2.40.50.90:FF:000115', NULL, NULL, 'Tudor, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(24740, NULL, 'G3DSA:1.20.1250.20:FF:002230', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(24741, NULL, 'G3DSA:1.10.275.40:FF:000003', NULL, NULL, 'DNA repair helicase RAD3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24742, NULL, 'G3DSA:3.80.10.10:FF:001428', NULL, NULL, 'Probable disease resistance protein At5g04720', NULL, NULL, NULL, NULL, NULL, 4),
(24743, NULL, 'G3DSA:3.30.160.60:FF:000747', NULL, NULL, 'Probable lysine-specific demethylase ELF6', NULL, NULL, NULL, NULL, NULL, 4),
(24744, NULL, 'G3DSA:3.90.1150.10:FF:000370', NULL, NULL, 'L-allo-threonine aldolase, stereospecific', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(24745, NULL, 'G3DSA:3.40.50.150:FF:000922', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24746, NULL, 'G3DSA:1.20.144.10:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24747, NULL, 'G3DSA:3.40.50.300:FF:000748', NULL, NULL, 'ras-related protein Rab-34 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(24748, NULL, 'G3DSA:1.10.20.10:FF:000178', NULL, NULL, 'Histone H2B', NULL, NULL, NULL, NULL, NULL, 4),
(24749, NULL, 'G3DSA:3.90.550.10:FF:000726', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(24750, NULL, 'G3DSA:2.130.10.10:FF:004368', NULL, NULL, 'Si:ch211-129c21.1', NULL, NULL, NULL, NULL, NULL, 4),
(24751, NULL, 'G3DSA:2.120.10.80:FF:000325', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(24752, NULL, 'G3DSA:2.60.40.1770:FF:000009', NULL, NULL, 'ephrin type-A receptor 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(24753, NULL, 'G3DSA:1.25.40.10:FF:001995', NULL, NULL, 'RNA polymerase-associated protein CTR9', NULL, NULL, NULL, NULL, NULL, 4),
(24754, NULL, 'G3DSA:3.40.190.10:FF:000316', NULL, NULL, 'Transcriptional regulator LysR', NULL, NULL, NULL, NULL, NULL, 4),
(24755, NULL, 'G3DSA:1.20.1300.10:FF:000017', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(24756, NULL, 'G3DSA:3.30.40.10:FF:002152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24757, NULL, 'G3DSA:3.40.50.150:FF:000271', NULL, NULL, 'NOL1/NOP2/Sun family protein', NULL, NULL, NULL, NULL, NULL, 4),
(24758, NULL, 'G3DSA:3.50.50.60:FF:000452', NULL, NULL, 'Dihydropyrimidine dehydrogenase [NADP(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(24759, NULL, 'G3DSA:3.40.50.720:FF:000048', NULL, NULL, '4-hydroxy-tetrahydrodipicolinate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(24760, NULL, 'G3DSA:2.60.40.10:FF:004244', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24761, NULL, 'G3DSA:1.10.3380.20:FF:000005', NULL, NULL, 'DNA-directed DNA polymerase theta, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24762, NULL, 'G3DSA:3.40.50.2300:FF:000392', NULL, NULL, 'LppC family lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(24763, NULL, 'G3DSA:1.10.3380.30:FF:000008', NULL, NULL, 'Helicase with Zn-finger motif, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24764, NULL, 'G3DSA:3.30.1050.10:FF:000016', NULL, NULL, 'Uncharacterized N-acetyltransferase CLW02_3581', NULL, NULL, NULL, NULL, NULL, 4),
(24765, NULL, 'G3DSA:3.30.50.10:FF:000028', NULL, NULL, 'Nuclear receptor subfamily 2, group E, member 3', NULL, NULL, NULL, NULL, NULL, 4),
(24766, NULL, 'G3DSA:3.30.200.20:FF:002224', NULL, NULL, 'Mitogen-activated protein kinase, long flagella protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(24767, NULL, 'G3DSA:3.30.160.60:FF:001731', NULL, NULL, 'Crooked legs, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(24768, NULL, 'G3DSA:1.10.472.10:FF:000312', NULL, NULL, 'AGAP006477-PA', NULL, NULL, NULL, NULL, NULL, 4),
(24769, NULL, 'G3DSA:1.20.1050.20:FF:000006', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(24770, NULL, 'G3DSA:3.40.50.10420:FF:000056', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(24771, NULL, 'G3DSA:3.30.565.10:FF:000078', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(24772, NULL, 'G3DSA:2.20.25.30:FF:000001', NULL, NULL, 'Ribosomal protein L37', NULL, NULL, NULL, NULL, NULL, 4),
(24773, NULL, 'G3DSA:1.10.238.10:FF:000577', NULL, NULL, 'Putative calmodulin-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(24774, NULL, 'G3DSA:3.40.50.300:FF:004458', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24775, NULL, 'G3DSA:3.40.50.1100:FF:000279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24776, NULL, 'G3DSA:3.30.160.60:FF:004457', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24777, NULL, 'G3DSA:3.40.50.720:FF:000290', NULL, NULL, 'SDR family oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(24778, NULL, 'G3DSA:3.40.50.1460:FF:000100', NULL, NULL, 'AGAP010826-PA', NULL, NULL, NULL, NULL, NULL, 4),
(24779, NULL, 'G3DSA:1.10.510.10:FF:000587', NULL, NULL, 'Phosphoinositide-dependent kinase 1, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(24780, NULL, 'G3DSA:3.30.70.1400:FF:000023', NULL, NULL, 'Sarcosine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(24781, NULL, 'G3DSA:1.20.1050.10:FF:000003', NULL, NULL, 'Glutathione S-transferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(24782, NULL, 'G3DSA:3.80.10.10:FF:000063', NULL, NULL, 'Lumican', NULL, NULL, NULL, NULL, NULL, 4),
(24783, NULL, 'G3DSA:1.10.510.10:FF:002650', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24784, NULL, 'G3DSA:2.40.160.120:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24785, NULL, 'G3DSA:3.30.565.10:FF:000471', NULL, NULL, 'Sensory histidine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(24786, NULL, 'G3DSA:1.20.1250.20:FF:001707', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24787, NULL, 'G3DSA:1.10.10.820:FF:000023', NULL, NULL, 'Class II myosin', NULL, NULL, NULL, NULL, NULL, 4),
(24788, NULL, 'G3DSA:3.40.50.300:FF:004672', NULL, NULL, 'Peroxisomal biogenesis factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(24789, NULL, 'G3DSA:3.40.50.300:FF:000389', NULL, NULL, 'Small ribosomal subunit biogenesis GTPase RsgA', NULL, NULL, NULL, NULL, NULL, 4),
(24790, NULL, 'G3DSA:2.60.40.10:FF:002097', NULL, NULL, 'CD160 antigen', NULL, NULL, NULL, NULL, NULL, 4),
(24791, NULL, 'G3DSA:2.40.160.110:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24792, NULL, 'G3DSA:3.30.70.1230:FF:000068', NULL, NULL, 'Putative ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(24793, NULL, 'G3DSA:1.10.1240.30:FF:000003', NULL, NULL, 'Circadian clock protein KaiA', NULL, NULL, NULL, NULL, NULL, 4),
(24794, NULL, 'G3DSA:3.40.50.880:FF:000074', NULL, NULL, 'Transcriptional regulator ArgR', NULL, NULL, NULL, NULL, NULL, 4),
(24795, NULL, 'G3DSA:1.25.40.10:FF:003496', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(24796, NULL, 'G3DSA:3.10.110.10:FF:000173', NULL, NULL, 'Ubiquitin conjugating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(24797, NULL, 'G3DSA:1.20.120.1240:FF:000019', NULL, NULL, 'Dynamin 2', NULL, NULL, NULL, NULL, NULL, 4),
(24798, NULL, 'G3DSA:1.10.4160.10:FF:000025', NULL, NULL, 'Putative purine-cytosine permease YxlA', NULL, NULL, NULL, NULL, NULL, 4),
(24799, NULL, 'G3DSA:1.20.120.980:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24800, NULL, 'G3DSA:1.20.1270.60:FF:000040', NULL, NULL, 'GEM-interacting protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(24801, NULL, 'G3DSA:3.40.50.300:FF:006796', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24802, NULL, 'G3DSA:3.40.50.1950:FF:000011', NULL, NULL, 'Flavin prenyltransferase UbiX', NULL, NULL, NULL, NULL, NULL, 4),
(24803, NULL, 'G3DSA:2.40.50.1070:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24804, NULL, 'G3DSA:3.40.30.10:FF:001201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24805, NULL, 'G3DSA:1.10.472.10:FF:000514', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24806, NULL, 'G3DSA:3.40.50.720:FF:002083', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(24807, NULL, 'G3DSA:3.40.47.10:FF:000161', NULL, NULL, 'Putative polyketide beta-ketoacyl synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(24808, NULL, 'G3DSA:1.25.40.10:FF:004108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24809, NULL, 'G3DSA:2.40.50.1060:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24810, NULL, 'G3DSA:4.10.520.10:FF:000008', NULL, NULL, 'Integration host factor subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(24811, NULL, 'G3DSA:3.40.50.1970:FF:000017', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(24812, NULL, 'G3DSA:3.40.50.970:FF:000224', NULL, NULL, 'Pyruvate dehydrogenase E1 alpha 1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(24813, NULL, 'G3DSA:3.10.20.90:FF:000692', NULL, NULL, 'NSFL1 cofactor p47', NULL, NULL, NULL, NULL, NULL, 4),
(24814, NULL, 'G3DSA:1.20.58.400:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24815, NULL, 'G3DSA:3.90.70.10:FF:000370', NULL, NULL, 'Cytoskeleton-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(24816, NULL, 'G3DSA:3.90.1140.10:FF:000043', NULL, NULL, 'A-kinase anchor protein 7, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24817, NULL, 'G3DSA:3.40.50.12390:FF:000012', NULL, NULL, 'XRN 5''-3'' exonuclease N-terminus, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24818, NULL, 'G3DSA:3.90.70.200:FF:000003', NULL, NULL, 'RNA polymerase-associated protein RTF1', NULL, NULL, NULL, NULL, NULL, 4),
(24819, NULL, 'G3DSA:3.40.309.10:FF:000048', NULL, NULL, 'NADP-dependent glyceraldehyde-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(24820, NULL, 'G3DSA:1.20.920.30:FF:000043', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(24821, NULL, 'G3DSA:2.130.10.30:FF:000102', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24822, NULL, 'G3DSA:3.30.420.40:FF:000335', NULL, NULL, 'Ectonucleoside triphosphate diphosphohydrolase 3', NULL, NULL, NULL, NULL, NULL, 4),
(24823, NULL, 'G3DSA:3.10.196.10:FF:000011', NULL, NULL, 'Methionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(24824, NULL, 'G3DSA:1.10.1420.10:FF:000096', NULL, NULL, 'MutS homolog, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24825, NULL, 'G3DSA:3.80.10.10:FF:003840', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24826, NULL, 'G3DSA:3.40.50.200:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24827, NULL, 'G3DSA:3.30.519.10:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24828, NULL, 'G3DSA:3.20.190.10:FF:000006', NULL, NULL, 'Formamidopyrimidine-DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(24829, NULL, 'G3DSA:1.10.560.10:FF:000118', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(24830, NULL, 'G3DSA:3.40.50.1440:FF:000145', NULL, NULL, 'Protein DML1', NULL, NULL, NULL, NULL, NULL, 4),
(24831, NULL, 'G3DSA:3.30.230.70:FF:000048', NULL, NULL, 'Exosome complex component RRP43', NULL, NULL, NULL, NULL, NULL, 4),
(24832, NULL, 'G3DSA:2.60.40.60:FF:000459', NULL, NULL, 'Protein dachsous-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(24833, NULL, 'G3DSA:1.10.418.10:FF:000198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24834, NULL, 'G3DSA:2.60.40.10:FF:004188', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24835, NULL, 'G3DSA:2.60.210.10:FF:000010', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(24836, NULL, 'G3DSA:3.40.50.2000:FF:000509', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(24837, NULL, 'G3DSA:2.60.40.10:FF:005874', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24838, NULL, 'G3DSA:3.40.50.10050:FF:000012', NULL, NULL, 'AAEL009241-PA', NULL, NULL, NULL, NULL, NULL, 4),
(24839, NULL, 'G3DSA:1.10.1240.40:FF:000006', NULL, NULL, 'ENT domain containing protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(24840, NULL, 'G3DSA:3.40.630.10:FF:000340', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24841, NULL, 'G3DSA:2.120.10.30:FF:000338', NULL, NULL, 'Peptidase S9 prolyl oligopeptidase active site domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(24842, NULL, 'G3DSA:2.20.70.10:FF:000127', NULL, NULL, 'Pre-mRNA-processing protein 40A', NULL, NULL, NULL, NULL, NULL, 4),
(24843, NULL, 'G3DSA:3.40.50.300:FF:002581', NULL, NULL, 'Guanylate-binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(24844, NULL, 'G3DSA:3.90.1010.10:FF:000005', NULL, NULL, 'Iron-sulfur cluster assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(24845, NULL, 'G3DSA:3.40.50.300:FF:007313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(24846, NULL, 'G3DSA:2.60.40.2030:FF:000043', NULL, NULL, 'Adhesion G-protein coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(24847, NULL, 'G3DSA:3.90.226.10:FF:000221', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(24848, NULL, 'G3DSA:3.40.50.720:FF:000380', NULL, NULL, 'Acetyltransferase, GNAT family', NULL, NULL, NULL, NULL, NULL, 4),
(24849, NULL, 'G3DSA:2.60.120.260:FF:000512', NULL, NULL, 'Beta-galactosidase 17', NULL, NULL, NULL, NULL, NULL, 4),
(24850, NULL, 'G3DSA:1.25.40.20:FF:000952', NULL, NULL, 'Ankyrin repeat domain-containing protein 13C', NULL, NULL, NULL, NULL, NULL, 4),
(24851, NULL, 'G3DSA:1.20.120.520:FF:000004', NULL, NULL, 'F-box/LRR-repeat protein 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(24852, NULL, 'G3DSA:3.40.50.720:FF:000054', NULL, NULL, 'Enoyl-[acyl-carrier-protein] reductase [NADH]', NULL, NULL, NULL, NULL, NULL, 4),
(24853, NULL, 'G3DSA:3.40.630.10:FF:000391', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24854, NULL, 'G3DSA:1.20.58.120:FF:000003', NULL, NULL, 'BAG family molecular chaperone regulator 5', NULL, NULL, NULL, NULL, NULL, 4),
(24855, NULL, 'G3DSA:2.130.10.10:FF:004424', NULL, NULL, 'Protein DSE1', NULL, NULL, NULL, NULL, NULL, 4),
(24856, NULL, 'G3DSA:2.10.25.10:FF:001209', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(24857, NULL, 'G3DSA:3.90.226.10:FF:000007', NULL, NULL, 'Methylcrotonoyl-CoA carboxylase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(24858, NULL, 'G3DSA:1.20.920.20:FF:000040', NULL, NULL, 'Cytoplasmic dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24859, NULL, 'G3DSA:3.30.160.60:FF:003209', NULL, NULL, 'Zinc finger protein 658B', NULL, NULL, NULL, NULL, NULL, 4),
(24860, NULL, 'G3DSA:3.40.50.300:FF:000338', NULL, NULL, 'GPN-loop GTPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(24861, NULL, 'G3DSA:3.90.950.10:FF:000010', NULL, NULL, 'Nucleoside triphosphate pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(24862, NULL, 'G3DSA:3.40.1110.10:FF:000013', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(24863, NULL, 'G3DSA:3.30.70.330:FF:000033', NULL, NULL, 'heterogeneous nuclear ribonucleoprotein M isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(24864, NULL, 'G3DSA:3.30.470.20:FF:000040', NULL, NULL, 'Carnosine synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(24865, NULL, 'G3DSA:2.40.128.680:FF:000001', NULL, NULL, 'Ribonuclease H2 subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(24866, NULL, 'G3DSA:1.10.357.10:FF:000005', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(24867, NULL, 'G3DSA:3.40.50.1820:FF:000231', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(24868, NULL, 'G3DSA:3.30.9.10:FF:000197', NULL, NULL, 'D-amino acid dehydrogenase small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(24869, NULL, 'G3DSA:1.10.510.10:FF:000407', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(24870, NULL, 'G3DSA:3.40.190.10:FF:000204', NULL, NULL, 'Phosphate ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(24871, NULL, 'G3DSA:3.30.1140.40:FF:000009', NULL, NULL, 'GM25527', NULL, NULL, NULL, NULL, NULL, 4),
(24872, NULL, 'G3DSA:3.30.40.10:FF:000325', NULL, NULL, 'RING finger protein 122', NULL, NULL, NULL, NULL, NULL, 4),
(24873, NULL, 'G3DSA:3.90.550.10:FF:000159', NULL, NULL, 'Unplaced genomic scaffold supercont1.48, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(24874, NULL, 'G3DSA:1.10.640.10:FF:000006', NULL, NULL, 'Double oxidase: two peroxidase domains', NULL, NULL, NULL, NULL, NULL, 4),
(24875, NULL, 'G3DSA:3.40.50.10490:FF:000060', NULL, NULL, 'Glucose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(24876, NULL, 'G3DSA:3.30.160.60:FF:000568', NULL, NULL, 'zinc finger protein 90 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(24877, NULL, 'G3DSA:1.20.1250.20:FF:000173', NULL, NULL, 'Hexuronate transporter', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(24878, NULL, 'G3DSA:2.60.40.60:FF:000408', NULL, NULL, 'Cadherin 3', NULL, NULL, NULL, NULL, NULL, 4),
(24879, NULL, 'G3DSA:3.90.550.10:FF:000547', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24880, NULL, 'G3DSA:1.10.357.20:FF:000008', NULL, NULL, 'Solute carrier family 41 member 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24881, NULL, 'G3DSA:3.30.230.70:FF:000099', NULL, NULL, 'Exosome complex exonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(24882, NULL, 'G3DSA:3.40.50.880:FF:000023', NULL, NULL, 'Imidazole glycerol phosphate synthase subunit HisH', NULL, NULL, NULL, NULL, NULL, 4),
(24883, NULL, 'G3DSA:2.60.200.20:FF:000074', NULL, NULL, 'Protein serine-threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(24884, NULL, 'G3DSA:1.10.506.10:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24885, NULL, 'G3DSA:2.70.98.10:FF:000037', NULL, NULL, 'LG27/30-like gene', NULL, NULL, NULL, NULL, NULL, 4),
(24886, NULL, 'G3DSA:2.30.29.30:FF:000453', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(24887, NULL, 'G3DSA:3.40.640.10:FF:000458', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24888, NULL, 'G3DSA:3.30.470.30:FF:000043', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(24889, NULL, 'G3DSA:3.30.70.330:FF:002124', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24890, NULL, 'G3DSA:2.20.25.420:FF:000003', NULL, NULL, 'zinc finger protein ZPR1', NULL, NULL, NULL, NULL, NULL, 4),
(24891, NULL, 'G3DSA:3.40.50.10810:FF:000167', NULL, NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily-related, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24892, NULL, 'G3DSA:2.60.40.10:FF:005969', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24893, NULL, 'G3DSA:1.20.120.530:FF:000007', NULL, NULL, 'DNA-binding transcriptional regulator CsiR', NULL, NULL, NULL, NULL, NULL, 4),
(24894, NULL, 'G3DSA:2.70.170.10:FF:000256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24895, NULL, 'G3DSA:2.60.120.40:FF:000028', NULL, NULL, 'Multimerin 2', NULL, NULL, NULL, NULL, NULL, 4),
(24896, NULL, 'G3DSA:3.90.550.10:FF:000373', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(24897, NULL, 'G3DSA:3.40.5.10:FF:000020', NULL, NULL, 'Plastid ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(24898, NULL, 'G3DSA:3.90.550.10:FF:000485', NULL, NULL, 'Ceramide glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(24899, NULL, 'G3DSA:3.30.450.330:FF:000001', NULL, NULL, 'Peptidoglycan D,D-transpeptidase FtsI', NULL, NULL, NULL, NULL, NULL, 4),
(24900, NULL, 'G3DSA:3.40.190.10:FF:000581', NULL, NULL, 'Oligopeptide ABC transporter periplasmic oligopeptide-binding protein OppA', NULL, NULL, NULL, NULL, NULL, 4),
(24901, NULL, 'G3DSA:3.30.565.10:FF:000319', NULL, NULL, 'Two-component system sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(24902, NULL, 'G3DSA:2.60.40.10:FF:001315', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(24903, NULL, 'G3DSA:1.10.510.10:FF:002324', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24904, NULL, 'G3DSA:1.25.40.10:FF:005002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24905, NULL, 'G3DSA:3.90.660.20:FF:000024', NULL, NULL, 'Os04g0490000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(24906, NULL, 'G3DSA:3.30.70.1450:FF:000049', NULL, NULL, 'Transporter, divalent anion:sodium symporter family', NULL, NULL, NULL, NULL, NULL, 4),
(24907, NULL, 'G3DSA:1.25.40.990:FF:000053', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(24908, NULL, 'G3DSA:2.90.10.10:FF:000048', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase SD1-1', NULL, NULL, NULL, NULL, NULL, 4),
(24909, NULL, 'G3DSA:2.70.150.10:FF:000261', NULL, NULL, 'Putative phospholipid-transporting ATPase C821.13c', NULL, NULL, NULL, NULL, NULL, 4),
(24910, NULL, 'G3DSA:2.30.42.10:FF:000225', NULL, NULL, 'AHNAK2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(24911, NULL, 'G3DSA:3.30.1360.10:FF:000062', NULL, NULL, 'RNApolymerase 14 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(24912, NULL, 'G3DSA:1.10.510.10:FF:004448', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24913, NULL, 'G3DSA:2.20.70.10:FF:000178', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(24914, NULL, 'G3DSA:2.60.120.200:FF:000230', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(24915, NULL, 'G3DSA:3.30.420.40:FF:000661', NULL, NULL, 'Actin-related protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(24916, NULL, 'G3DSA:3.40.630.10:FF:000014', NULL, NULL, 'Cytosolic non-specific dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(24917, NULL, 'G3DSA:1.50.40.10:FF:000498', NULL, NULL, 'Uncharacterized mitochondrial carrier C1604.04', NULL, NULL, NULL, NULL, NULL, 4),
(24918, NULL, 'G3DSA:2.40.10.10:FF:000685', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24919, NULL, 'G3DSA:3.30.70.340:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24920, NULL, 'G3DSA:3.30.50.10:FF:000202', NULL, NULL, 'E78 nuclear receptor', NULL, NULL, NULL, NULL, NULL, 4),
(24921, NULL, 'G3DSA:3.30.450.40:FF:000163', NULL, NULL, 'PAS/PAC sensor-containing diguanylate cyclase/phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(24922, NULL, 'G3DSA:1.25.40.10:FF:004434', NULL, NULL, 'Anaphase-promoting complex subunit 8', NULL, NULL, NULL, NULL, NULL, 4),
(24923, NULL, 'G3DSA:1.10.340.30:FF:000068', NULL, NULL, 'Endonuclease III homolog', NULL, NULL, NULL, NULL, NULL, 4),
(24924, NULL, 'G3DSA:3.40.228.10:FF:000023', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(24925, NULL, 'G3DSA:1.10.10.10:FF:001897', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24926, NULL, 'G3DSA:3.60.15.10:FF:000215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24927, NULL, 'G3DSA:3.40.50.300:FF:003244', NULL, NULL, 'Si:dkey-120c6.5', NULL, NULL, NULL, NULL, NULL, 4),
(24928, NULL, 'G3DSA:3.30.160.20:FF:000230', NULL, NULL, 'Double-strand-specific pac1 ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(24929, NULL, 'G3DSA:2.60.40.10:FF:004446', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24930, NULL, 'G3DSA:1.25.40.730:FF:000003', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(24931, NULL, 'G3DSA:1.10.472.10:FF:000256', NULL, NULL, 'Cyclin A3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24932, NULL, 'G3DSA:3.30.160.60:FF:002546', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(24933, NULL, 'G3DSA:3.80.10.10:FF:001423', NULL, NULL, 'Leucine rich repeat containing 39', NULL, NULL, NULL, NULL, NULL, 4),
(24934, NULL, 'G3DSA:2.10.25.10:FF:000012', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(24935, NULL, 'G3DSA:2.60.200.20:FF:000169', NULL, NULL, 'Serine phosphatase RsbU, regulator of sigma subunit', NULL, NULL, NULL, NULL, NULL, 4),
(24936, NULL, 'G3DSA:3.40.1230.10:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24937, NULL, 'G3DSA:3.40.50.300:FF:004379', NULL, NULL, 'Dethiobiotin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(24938, NULL, 'G3DSA:3.20.20.70:FF:000786', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24939, NULL, 'G3DSA:3.40.50.1240:FF:000203', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24940, NULL, 'G3DSA:3.20.20.300:FF:000050', NULL, NULL, 'Beta-n-acetylglucosaminidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24941, NULL, 'G3DSA:3.40.50.1820:FF:001692', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24942, NULL, 'G3DSA:1.25.40.90:FF:000023', NULL, NULL, 'polyadenylation and cleavage factor homolog 4', NULL, NULL, NULL, NULL, NULL, 4),
(24943, NULL, 'G3DSA:2.130.10.10:FF:003064', NULL, NULL, 'WD repeat-containing protein 55', NULL, NULL, NULL, NULL, NULL, 4),
(24944, NULL, 'G3DSA:1.10.555.10:FF:000168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24945, NULL, 'G3DSA:2.10.25.10:FF:000597', NULL, NULL, 'Delta/notch-like EGF repeat containing', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(24946, NULL, 'G3DSA:3.40.50.720:FF:001189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24947, NULL, 'G3DSA:3.30.710.10:FF:000040', NULL, NULL, 'RCC1 and BTB domain-containing protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(24948, NULL, 'G3DSA:2.60.120.200:FF:000281', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(24949, NULL, 'G3DSA:3.40.50.300:FF:000664', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(24950, NULL, 'G3DSA:3.30.70.100:FF:000195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24951, NULL, 'G3DSA:1.10.10.10:FF:000391', NULL, NULL, 'Central glycolytic genes regulator', NULL, NULL, NULL, NULL, NULL, 4),
(24952, NULL, 'G3DSA:1.10.150.20:FF:000202', NULL, NULL, 'Nucleotide excision repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(24953, NULL, 'G3DSA:2.60.40.1180:FF:000198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24954, NULL, 'G3DSA:3.40.50.720:FF:002032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24955, NULL, 'G3DSA:2.60.40.820:FF:000036', NULL, NULL, 'transcription factor protein', NULL, NULL, NULL, NULL, NULL, 4),
(24956, NULL, 'G3DSA:3.40.30.10:FF:001252', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(24957, NULL, 'G3DSA:3.40.630.10:FF:000065', NULL, NULL, 'Transferrin receptor 1b', NULL, NULL, NULL, NULL, NULL, 4),
(24958, NULL, 'G3DSA:2.40.50.90:FF:000031', NULL, NULL, 'Tudor domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(24959, NULL, 'G3DSA:3.40.50.300:FF:002755', NULL, NULL, 'ATP-dependent dethiobiotin synthetase BioD', NULL, NULL, NULL, NULL, NULL, 4),
(24960, NULL, 'G3DSA:3.50.50.60:FF:000188', NULL, NULL, 'Prenylcysteine oxidase 1 like', NULL, NULL, NULL, NULL, NULL, 4),
(24961, NULL, 'G3DSA:3.90.180.10:FF:000153', NULL, NULL, 'Putative oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(24962, NULL, 'G3DSA:2.130.10.10:FF:002075', NULL, NULL, '57.7 kDa trp-asp repeats containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24963, NULL, 'G3DSA:3.50.50.60:FF:000413', NULL, NULL, 'Phytoene desaturase (lycopene-forming)', NULL, NULL, NULL, NULL, NULL, 4),
(24964, NULL, 'G3DSA:1.10.238.10:FF:000375', NULL, NULL, 'EF-hand domain-containing family member C2', NULL, NULL, NULL, NULL, NULL, 4),
(24965, NULL, 'G3DSA:1.10.150.50:FF:000003', NULL, NULL, 'liprin-alpha-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(24966, NULL, 'G3DSA:2.30.18.10:FF:000006', NULL, NULL, 'Transcription factor TFIIA complex subunit Toa1', NULL, NULL, NULL, NULL, NULL, 4),
(24967, NULL, 'G3DSA:3.20.20.80:FF:000789', NULL, NULL, 'Glucosidase, alpha; acid (Pompe disease, glycogen storage disease type II)', NULL, NULL, NULL, NULL, NULL, 4),
(24968, NULL, 'G3DSA:3.30.70.330:FF:002450', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24969, NULL, 'G3DSA:3.30.497.10:FF:000183', NULL, NULL, 'Serpin-Z1', NULL, NULL, NULL, NULL, NULL, 4),
(24970, NULL, 'G3DSA:3.40.30.10:FF:000358', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(24971, NULL, 'G3DSA:1.10.150.60:FF:000006', NULL, NULL, 'AT-rich interactive domain-containing protein 3A', NULL, NULL, NULL, NULL, NULL, 4),
(24972, NULL, 'G3DSA:1.20.1070.10:FF:001932', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24973, NULL, 'G3DSA:3.40.50.150:FF:000776', NULL, NULL, 'Methyltransferase like 15', NULL, NULL, NULL, NULL, NULL, 4),
(24974, NULL, 'G3DSA:3.40.190.10:FF:000081', NULL, NULL, 'HTH-type transcriptional regulator LeuO', NULL, NULL, NULL, NULL, NULL, 4),
(24975, NULL, 'G3DSA:3.30.1370.10:FF:000001', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(24976, NULL, 'G3DSA:3.30.70.330:FF:000084', NULL, NULL, 'Serine/arginine-rich splicing factor 11 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(24977, NULL, 'G3DSA:3.30.160.60:FF:002597', NULL, NULL, 'Zinc finger protein 263', NULL, NULL, NULL, NULL, NULL, 4),
(24978, NULL, 'G3DSA:3.40.50.1370:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(24979, NULL, 'G3DSA:1.20.1310.30:FF:000001', NULL, NULL, 'Exocyst complex component EXO70', NULL, NULL, NULL, NULL, NULL, 4),
(24980, NULL, 'G3DSA:3.30.420.150:FF:000019', NULL, NULL, 'Nucleoside triphosphate diphosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(24981, NULL, 'G3DSA:3.30.420.40:FF:000386', NULL, NULL, 'Actin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(24982, NULL, 'G3DSA:3.40.50.2000:FF:000414', NULL, NULL, 'Autotransporter strand-loop-strand O-heptosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(24983, NULL, 'G3DSA:3.10.20.70:FF:000034', NULL, NULL, 'Glutamine synthetase III', NULL, NULL, NULL, NULL, NULL, 4),
(24984, NULL, 'G3DSA:3.30.70.330:FF:000145', NULL, NULL, 'Putative RNP domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(24985, NULL, 'G3DSA:3.40.50.10810:FF:000229', NULL, NULL, 'Type III restriction enzyme, res subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(24986, NULL, 'G3DSA:2.130.10.10:FF:004166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24987, NULL, 'G3DSA:1.25.40.820:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24988, NULL, 'G3DSA:1.25.40.10:FF:004159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24989, NULL, 'G3DSA:1.20.1560.10:FF:000154', NULL, NULL, 'HAlF transporter (PGP related)', NULL, NULL, NULL, NULL, NULL, 4),
(24990, NULL, 'G3DSA:3.30.160.60:FF:001411', NULL, NULL, 'insulinoma-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(24991, NULL, 'G3DSA:3.30.780.10:FF:000021', NULL, NULL, 'Density-regulated protein related to translation initiation factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(24992, NULL, 'G3DSA:1.10.510.10:FF:000733', NULL, NULL, 'serine/threonine-protein kinase 16 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(24993, NULL, 'G3DSA:3.40.1090.10:FF:000134', NULL, NULL, 'Probable triacylglycerol lipase C1450.16c', NULL, NULL, NULL, NULL, NULL, 4),
(24994, NULL, 'G3DSA:3.10.20.90:FF:000399', NULL, NULL, 'Ubiquitin-like domain-containing CTD phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(24995, NULL, 'G3DSA:3.30.420.140:FF:000016', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(24996, NULL, 'G3DSA:1.10.420.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(24997, NULL, 'G3DSA:2.40.10.10:FF:000634', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24998, NULL, 'G3DSA:1.10.510.10:FF:002824', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(24999, NULL, 'G3DSA:3.30.60.60:FF:000021', NULL, NULL, 'K(lysine) acetyltransferase 7a', NULL, NULL, NULL, NULL, NULL, 4),
(25000, NULL, 'G3DSA:1.25.40.10:FF:004013', NULL, NULL, 'Regulator of microtubule dynamics protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(25001, NULL, 'G3DSA:3.30.200.20:FF:000638', NULL, NULL, 'serine/threonine-protein kinase-like protein ACR4', NULL, NULL, NULL, NULL, NULL, 4),
(25002, NULL, 'G3DSA:1.25.40.20:FF:001183', NULL, NULL, 'Ion channel NompC', NULL, NULL, NULL, NULL, NULL, 4),
(25003, NULL, 'G3DSA:1.20.1250.20:FF:001533', NULL, NULL, 'D-xylose-proton symporter', NULL, NULL, NULL, NULL, NULL, 4),
(25004, NULL, 'G3DSA:3.40.50.300:FF:004604', NULL, NULL, 'Superfamily I DNA and/or RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(25005, NULL, 'G3DSA:3.40.630.10:FF:000452', NULL, NULL, 'Carboxypeptidase A', NULL, NULL, NULL, NULL, NULL, 4),
(25006, NULL, 'G3DSA:2.40.30.170:FF:000074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25007, NULL, 'G3DSA:3.10.20.90:FF:000427', NULL, NULL, 'Putative Polyubiquitin-C', NULL, NULL, NULL, NULL, NULL, 4),
(25008, NULL, 'G3DSA:1.10.1820.10:FF:000025', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(25009, NULL, 'G3DSA:2.130.10.10:FF:000158', NULL, NULL, 'Kinesin family member 21A', NULL, NULL, NULL, NULL, NULL, 4),
(25010, NULL, 'G3DSA:1.20.120.430:FF:000028', NULL, NULL, 'tRNA modification GTPase trmE', NULL, NULL, NULL, NULL, NULL, 4),
(25011, NULL, 'G3DSA:3.90.1150.10:FF:000375', NULL, NULL, 'Ornithine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(25012, NULL, 'G3DSA:2.40.170.20:FF:000070', NULL, NULL, 'TonB-dependent receptor', NULL, NULL, NULL, NULL, NULL, 4),
(25013, NULL, 'G3DSA:3.40.50.1820:FF:000017', NULL, NULL, 'Abhydrolase domain containing 8', NULL, NULL, NULL, NULL, NULL, 4),
(25014, NULL, 'G3DSA:3.90.550.10:FF:000047', NULL, NULL, 'Glucans biosynthesis glucosyltransferase H', NULL, NULL, NULL, NULL, NULL, 4),
(25015, NULL, 'G3DSA:3.30.160.60:FF:000394', NULL, NULL, 'Zinc finger protein 836', NULL, NULL, NULL, NULL, NULL, 4),
(25016, NULL, 'G3DSA:4.10.80.160:FF:000001', NULL, NULL, 'Nonsense-mediated mRNA decay factor (Upf2)', NULL, NULL, NULL, NULL, NULL, 4),
(25017, NULL, 'G3DSA:2.40.50.90:FF:000110', NULL, NULL, 'Transcription factor, Tudor domain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(25018, NULL, 'G3DSA:2.60.120.650:FF:000067', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(25019, NULL, 'G3DSA:3.40.50.1780:FF:000016', NULL, NULL, 'Iron hydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(25020, NULL, 'G3DSA:1.10.8.1080:FF:000005', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(25021, NULL, 'G3DSA:3.30.70.330:FF:000533', NULL, NULL, 'Chromosome 16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(25022, NULL, 'G3DSA:1.20.144.10:FF:000054', NULL, NULL, 'Related to AUR1-inositol phosphorylceramide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(25023, NULL, 'G3DSA:3.10.110.10:FF:000285', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 J1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(25024, NULL, 'G3DSA:3.30.420.40:FF:000509', NULL, NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(25025, NULL, 'G3DSA:2.30.180.10:FF:000176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25026, NULL, 'G3DSA:3.40.630.30:FF:000458', NULL, NULL, 'Alpha-tubulin N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(25027, NULL, 'G3DSA:3.30.450.30:FF:000008', NULL, NULL, 'Profilin', NULL, NULL, NULL, NULL, NULL, 4),
(25028, NULL, 'G3DSA:3.40.50.980:FF:000053', NULL, NULL, 'Enniatin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(25029, NULL, 'G3DSA:3.30.420.40:FF:000739', NULL, NULL, 'Actin5-3 (Actin-related protein 1-3)', NULL, NULL, NULL, NULL, NULL, 4),
(25030, NULL, 'G3DSA:3.40.50.620:FF:000024', NULL, NULL, 'Tryptophan--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(25031, NULL, 'G3DSA:3.30.2160.10:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25032, NULL, 'G3DSA:2.40.70.10:FF:000138', NULL, NULL, 'Aspartic protease 3', NULL, NULL, NULL, NULL, NULL, 4),
(25033, NULL, 'G3DSA:3.90.1410.10:FF:000148', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(25034, NULL, 'G3DSA:3.40.190.10:FF:000176', NULL, NULL, 'Ionotropic receptor 25a', NULL, NULL, NULL, NULL, NULL, 4),
(25035, NULL, 'G3DSA:3.40.50.720:FF:000115', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] reductase FabG', NULL, NULL, NULL, NULL, NULL, 4),
(25036, NULL, 'G3DSA:4.10.640.10:FF:000006', NULL, NULL, '30S ribosomal protein S18', NULL, NULL, NULL, NULL, NULL, 4),
(25037, NULL, 'G3DSA:3.40.50.620:FF:000203', NULL, NULL, 'Leucine--tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(25038, NULL, 'G3DSA:3.90.70.10:FF:000774', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25039, NULL, 'G3DSA:2.40.30.10:FF:000517', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25040, NULL, 'G3DSA:3.90.70.10:FF:000482', NULL, NULL, 'AGAP000269-PA', NULL, NULL, NULL, NULL, NULL, 4),
(25041, NULL, 'G3DSA:3.40.140.10:FF:000139', NULL, NULL, 'Cytidine deaminase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(25042, NULL, 'G3DSA:1.10.533.10:FF:000218', NULL, NULL, 'Ankyrin-3', NULL, NULL, NULL, NULL, NULL, 4),
(25043, NULL, 'G3DSA:3.40.50.2300:FF:000274', NULL, NULL, 'Low molecular weight phosphotyrosine protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(25044, NULL, 'G3DSA:2.60.40.10:FF:003957', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(25045, NULL, 'G3DSA:3.90.550.10:FF:000098', NULL, NULL, 'xyloside xylosyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(25046, NULL, 'G3DSA:3.30.160.60:FF:000629', NULL, NULL, 'zinc finger protein 333 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(25047, NULL, 'G3DSA:3.30.70.330:FF:001668', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25048, NULL, 'G3DSA:3.30.160.60:FF:004963', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25049, NULL, 'G3DSA:2.20.25.160:FF:000003', NULL, NULL, 'Probable aspartoacylase', NULL, NULL, NULL, NULL, NULL, 4),
(25050, NULL, 'G3DSA:3.40.50.970:FF:000050', NULL, NULL, '2-hydroxyacyl-CoA lyase', NULL, NULL, NULL, NULL, NULL, 4),
(25051, NULL, 'G3DSA:3.40.190.10:FF:000530', NULL, NULL, 'Phosphate-binding protein PstS 1', NULL, NULL, NULL, NULL, NULL, 4),
(25052, NULL, 'G3DSA:3.30.260.10:FF:000111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25053, NULL, 'G3DSA:3.40.30.10:FF:000796', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(25054, NULL, 'G3DSA:1.20.1730.10:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25055, NULL, 'G3DSA:1.10.1330.10:FF:000004', NULL, NULL, 'Alkaline phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(25056, NULL, 'G3DSA:3.40.50.300:FF:002693', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(25057, NULL, 'G3DSA:3.30.565.10:FF:000550', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25058, NULL, 'G3DSA:3.40.190.10:FF:000822', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25059, NULL, 'G3DSA:3.30.110.110:FF:000005', NULL, NULL, 'Double-strand break repair protein MRE11', NULL, NULL, NULL, NULL, NULL, 4),
(25060, NULL, 'G3DSA:2.130.10.10:FF:004492', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25061, NULL, 'G3DSA:2.10.109.10:FF:000021', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(25062, NULL, 'G3DSA:3.60.21.10:FF:000387', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25063, NULL, 'G3DSA:3.30.70.330:FF:001994', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25064, NULL, 'G3DSA:1.10.10.60:FF:000439', NULL, NULL, 'Cramped chromatin regulator homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(25065, NULL, 'G3DSA:3.30.420.10:FF:000500', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25066, NULL, 'G3DSA:2.40.30.170:FF:000023', NULL, NULL, 'HAE1 family efflux pump MFP component', NULL, NULL, NULL, NULL, NULL, 4),
(25067, NULL, 'G3DSA:3.40.1260.10:FF:000013', NULL, NULL, 'Intracellular sulfur oxidation protein DsrH', NULL, NULL, NULL, NULL, NULL, 4),
(25068, NULL, 'G3DSA:3.80.10.10:FF:003609', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25069, NULL, 'G3DSA:1.10.472.30:FF:000003', NULL, NULL, 'Transcription elongation factor S-II', NULL, NULL, NULL, NULL, NULL, 4),
(25070, NULL, 'G3DSA:3.40.50.300:FF:004879', NULL, NULL, 'Putative ATP-dependent RNA helicase rha-2', NULL, NULL, NULL, NULL, NULL, 4),
(25071, NULL, 'G3DSA:3.40.50.11610:FF:000019', NULL, NULL, 'Alpha-ketoglutarate dehydrogenase E1', NULL, NULL, NULL, NULL, NULL, 4),
(25072, NULL, 'G3DSA:2.130.10.10:FF:002187', NULL, NULL, 'DDB1 and CUL4 associated factor 11', NULL, NULL, NULL, NULL, NULL, 4),
(25073, NULL, 'G3DSA:4.10.400.10:FF:000354', NULL, NULL, 'SCO-spondin', NULL, NULL, NULL, NULL, NULL, 4),
(25074, NULL, 'G3DSA:1.10.510.10:FF:004241', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25075, NULL, 'G3DSA:3.30.70.330:FF:002562', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25076, NULL, 'G3DSA:1.10.510.10:FF:003959', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25077, NULL, 'G3DSA:3.30.160.60:FF:002193', NULL, NULL, 'Unplaced genomic scaffold supercont1.32, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(25078, NULL, 'G3DSA:3.30.70.1350:FF:000019', NULL, NULL, 'Cation diffusion facilitator family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(25079, NULL, 'G3DSA:1.10.150.120:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(25080, NULL, 'G3DSA:1.10.510.10:FF:000475', NULL, NULL, 'Calcium-dependent protein kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(25081, NULL, 'G3DSA:2.40.10.10:FF:000067', NULL, NULL, 'Complement C1s subcomponent', NULL, NULL, NULL, NULL, NULL, 4),
(25082, NULL, 'G3DSA:2.60.40.4100:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25083, NULL, 'G3DSA:2.60.40.150:FF:000728', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(25084, NULL, 'G3DSA:1.10.132.60:FF:000026', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(25085, NULL, 'G3DSA:4.10.1000.10:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25086, NULL, 'G3DSA:3.30.450.20:FF:000005', NULL, NULL, 'Hypoxia-inducible factor 1 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(25087, NULL, 'G3DSA:3.40.50.2000:FF:000302', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(25088, NULL, 'G3DSA:3.30.870.10:FF:000045', NULL, NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(25089, NULL, 'G3DSA:3.30.160.60:FF:003440', NULL, NULL, 'Zinc finger protein 749', NULL, NULL, NULL, NULL, NULL, 4),
(25090, NULL, 'G3DSA:3.30.40.10:FF:000151', NULL, NULL, 'Zinc finger family protein', NULL, NULL, NULL, NULL, NULL, 4),
(25091, NULL, 'G3DSA:3.90.1150.10:FF:000083', NULL, NULL, 'O-acetylhomoserine sulfhydrylase', NULL, NULL, NULL, NULL, NULL, 4),
(25092, NULL, 'G3DSA:2.120.10.30:FF:000131', NULL, NULL, 'NHL repeat containing E3 ubiquitin protein ligase 1', NULL, NULL, NULL, NULL, NULL, 4),
(25093, NULL, 'G3DSA:3.40.50.300:FF:001232', NULL, NULL, 'Erythrocyte membrane-associated antigen, putative', NULL, NULL, NULL, NULL, NULL, 4),
(25094, NULL, 'G3DSA:1.10.10.60:FF:000198', NULL, NULL, 'MYB transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(25095, NULL, 'G3DSA:1.20.920.10:FF:000211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25096, NULL, 'G3DSA:1.10.8.60:FF:000011', NULL, NULL, 'ATP-dependent Clp protease ATP-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(25097, NULL, 'G3DSA:1.10.490.10:FF:000011', NULL, NULL, 'Nitric oxide dioxygenase (Pi-NOD1)', NULL, NULL, NULL, NULL, NULL, 4),
(25098, NULL, 'G3DSA:3.40.50.620:FF:000254', NULL, NULL, 'Probable nicotinate-nucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(25099, NULL, 'G3DSA:3.10.20.90:FF:000753', NULL, NULL, 'Phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit alpha-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(25100, NULL, 'G3DSA:3.30.70.330:FF:000207', NULL, NULL, 'RNA-binding region (RNP1, RRM)-containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(25101, NULL, 'G3DSA:2.60.120.200:FF:000522', NULL, NULL, 'Emp46p', NULL, NULL, NULL, NULL, NULL, 4),
(25102, NULL, 'G3DSA:2.60.40.10:FF:004800', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25103, NULL, 'G3DSA:2.60.120.260:FF:000607', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25104, NULL, 'G3DSA:1.10.150.20:FF:000253', NULL, NULL, 'YALI0C01573p', NULL, NULL, NULL, NULL, NULL, 4),
(25105, NULL, 'G3DSA:1.10.287.110:FF:000193', NULL, NULL, 'Chaperone protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(25106, NULL, 'G3DSA:2.10.25.10:FF:001586', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25107, NULL, 'G3DSA:3.90.550.10:FF:000659', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25108, NULL, 'G3DSA:3.30.710.10:FF:000270', NULL, NULL, 'S-phase kinase-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(25109, NULL, 'G3DSA:2.40.70.10:FF:000582', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25110, NULL, 'G3DSA:3.30.160.60:FF:000068', NULL, NULL, 'GLI family zinc finger 3', NULL, NULL, NULL, NULL, NULL, 4),
(25111, NULL, 'G3DSA:3.40.50.1820:FF:001866', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25112, NULL, 'G3DSA:2.60.40.60:FF:000785', NULL, NULL, 'Pcdhgb1 protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(25113, NULL, 'G3DSA:3.90.70.10:FF:000156', NULL, NULL, 'UBP6p Ubiquitin-specific protease', NULL, NULL, NULL, NULL, NULL, 4),
(25114, NULL, 'G3DSA:2.60.40.1510:FF:000016', NULL, NULL, 'Integrin subunit alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(25115, NULL, 'G3DSA:2.40.70.10:FF:000290', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25116, NULL, 'G3DSA:3.40.50.300:FF:002367', NULL, NULL, 'Putative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(25117, NULL, 'G3DSA:3.10.20.30:FF:000084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25118, NULL, 'G3DSA:1.10.8.60:FF:000399', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25119, NULL, 'G3DSA:3.30.160.60:FF:005969', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25120, NULL, 'G3DSA:2.60.120.1540:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25121, NULL, 'G3DSA:2.10.25.10:FF:000304', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(25122, NULL, 'G3DSA:3.10.100.10:FF:000228', NULL, NULL, 'Lymphocyte antigen 75', NULL, NULL, NULL, NULL, NULL, 4),
(25123, NULL, 'G3DSA:3.40.50.300:FF:000956', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(25124, NULL, 'G3DSA:3.30.565.10:FF:000145', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(25125, NULL, 'G3DSA:3.30.470.20:FF:000214', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(25126, NULL, 'G3DSA:1.10.20.10:FF:000329', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25127, NULL, 'G3DSA:3.30.160.60:FF:000955', NULL, NULL, 'Zinc finger and SCAN domain-containing protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(25128, NULL, 'G3DSA:3.90.640.10:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25129, NULL, 'G3DSA:1.20.1070.10:FF:000004', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(25130, NULL, 'G3DSA:1.10.510.10:FF:001290', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(25131, NULL, 'G3DSA:2.60.40.2880:FF:000005', NULL, NULL, 'Probable transport accessory protein MmpS2', NULL, NULL, NULL, NULL, NULL, 4),
(25132, NULL, 'G3DSA:3.30.470.20:FF:000091', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(25133, NULL, 'G3DSA:1.25.40.10:FF:003203', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(25134, NULL, 'G3DSA:1.20.1280.50:FF:000268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25135, NULL, 'G3DSA:2.30.29.30:FF:000127', NULL, NULL, 'Neuronal guanine nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(25136, NULL, 'G3DSA:2.30.30.40:FF:000252', NULL, NULL, 'HECT domain and RCC1 family domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(25137, NULL, 'G3DSA:3.90.1150.210:FF:000030', NULL, NULL, 'F-actin-capping protein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(25138, NULL, 'G3DSA:1.20.1050.10:FF:000121', NULL, NULL, 'Glutathione S-transferase parC, putative, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(25139, NULL, 'G3DSA:3.40.50.2000:FF:000740', NULL, NULL, 'UDP-glucose iridoid glucosyltransferase-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(25140, NULL, 'G3DSA:3.30.450.150:FF:000003', NULL, NULL, 'UPF0303 protein YPTS_2661', NULL, NULL, NULL, NULL, NULL, 4),
(25141, NULL, 'G3DSA:3.40.366.10:FF:000017', NULL, NULL, 'Non-reducing polyketide synthase aptA', NULL, NULL, NULL, NULL, NULL, 4),
(25142, NULL, 'G3DSA:3.40.50.1000:FF:000491', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25143, NULL, 'G3DSA:3.30.470.30:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25144, NULL, 'G3DSA:1.10.418.60:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25145, NULL, 'G3DSA:1.10.287.70:FF:000152', NULL, NULL, 'Small conductance calcium-activated potassium channel protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(25146, NULL, 'G3DSA:1.10.10.60:FF:000147', NULL, NULL, 'GS homeobox 2', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(25147, NULL, 'G3DSA:3.30.450.20:FF:000331', NULL, NULL, 'Hybrid signal transduction histidine', NULL, NULL, NULL, NULL, NULL, 4),
(25148, NULL, 'G3DSA:3.40.50.300:FF:006296', NULL, NULL, 'DEAD/DEAH box helicase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(25149, NULL, 'G3DSA:1.20.58.1880:FF:000001', NULL, NULL, 'REST corepressor 1', NULL, NULL, NULL, NULL, NULL, 4),
(25150, NULL, 'G3DSA:3.40.50.300:FF:000776', NULL, NULL, 'Guanylate kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(25151, NULL, 'G3DSA:2.60.120.650:FF:000016', NULL, NULL, 'Lysine-specific demethylase isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(25152, NULL, 'G3DSA:1.25.40.10:FF:002714', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25153, NULL, 'G3DSA:3.30.420.40:FF:000835', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(25154, NULL, 'G3DSA:3.30.565.10:FF:000196', NULL, NULL, 'Sensory box sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(25155, NULL, 'G3DSA:1.20.58.1930:FF:000005', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(25156, NULL, 'G3DSA:3.30.505.10:FF:000248', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25157, NULL, 'G3DSA:3.30.1380.10:FF:000007', NULL, NULL, 'Sonic hedgehog', NULL, NULL, NULL, NULL, NULL, 4),
(25158, NULL, 'G3DSA:1.25.40.10:FF:003996', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25159, NULL, 'G3DSA:3.30.420.110:FF:000069', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(25160, NULL, 'G3DSA:2.40.10.10:FF:000393', NULL, NULL, 'LP05421p', NULL, NULL, NULL, NULL, NULL, 4),
(25161, NULL, 'G3DSA:2.60.40.10:FF:003114', NULL, NULL, 'Plexin B, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(25162, NULL, 'G3DSA:1.20.120.80:FF:000019', NULL, NULL, 'Cytochrome C oxidase subunit I /III', NULL, NULL, NULL, NULL, NULL, 4),
(25163, NULL, 'G3DSA:2.170.130.10:FF:000005', NULL, NULL, 'Ferrienterobactin outer membrane receptor', NULL, NULL, NULL, NULL, NULL, 4),
(25164, NULL, 'G3DSA:3.90.290.10:FF:000009', NULL, NULL, 'Fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(25165, NULL, 'G3DSA:3.30.1370.50:FF:000001', NULL, NULL, 'R3H domain-containing protein 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(25166, NULL, 'G3DSA:1.20.58.2050:FF:000002', NULL, NULL, 'DNA replication complex GINS protein PSF3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(25167, NULL, 'G3DSA:3.90.470.20:FF:000049', NULL, NULL, 'Probable phosphopantetheinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(25168, NULL, 'G3DSA:3.30.70.2760:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25169, NULL, 'G3DSA:2.60.40.60:FF:000734', NULL, NULL, 'Cadherin-4', NULL, NULL, NULL, NULL, NULL, 4),
(25170, NULL, 'G3DSA:2.160.20.10:FF:000056', NULL, NULL, 'Pectin lyase-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(25171, NULL, 'G3DSA:1.10.287.1490:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25172, NULL, 'G3DSA:1.10.10.60:FF:001041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25173, NULL, 'G3DSA:2.130.10.10:FF:005498', NULL, NULL, 'WD repeat domain 90', NULL, NULL, NULL, NULL, NULL, 4),
(25174, NULL, 'G3DSA:3.80.10.10:FF:003761', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25175, NULL, 'G3DSA:3.40.50.880:FF:000135', NULL, NULL, 'Imidazole glycerol phosphate synthase subunit HisH', NULL, NULL, NULL, NULL, NULL, 4),
(25176, NULL, 'G3DSA:3.30.1370.60:FF:000004', NULL, NULL, 'Ureidoglycolate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(25177, NULL, 'G3DSA:1.10.10.60:FF:000765', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25178, NULL, 'G3DSA:1.25.40.20:FF:000840', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(25179, NULL, 'G3DSA:1.10.1900.10:FF:000026', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(25180, NULL, 'G3DSA:2.120.10.30:FF:000182', NULL, NULL, 'DPP6 amino-terminal domain protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(25181, NULL, 'G3DSA:3.40.50.300:FF:002985', NULL, NULL, 'ClpB protein', NULL, NULL, NULL, NULL, NULL, 4),
(25182, NULL, 'G3DSA:3.10.120.10:FF:000050', NULL, NULL, 'Putative nitrate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(25183, NULL, 'G3DSA:1.20.120.1350:FF:000002', NULL, NULL, 'Zinc finger CCCH domain-containing protein 46', NULL, NULL, NULL, NULL, NULL, 4),
(25184, NULL, 'G3DSA:3.40.50.300:FF:005161', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(25185, NULL, 'G3DSA:4.10.60.10:FF:000089', NULL, NULL, 'RNA-binding protein lark', NULL, NULL, NULL, NULL, NULL, 4),
(25186, NULL, 'G3DSA:3.40.50.720:FF:000166', NULL, NULL, 'Glutathione-independent formaldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(25187, NULL, 'G3DSA:1.10.238.10:FF:000549', NULL, NULL, 'Calpain 12', NULL, NULL, NULL, NULL, NULL, 4),
(25188, NULL, 'G3DSA:1.10.3480.10:FF:000004', NULL, NULL, 'Nitrate reductase molybdenum cofactor assembly chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(25189, NULL, 'G3DSA:3.30.70.330:FF:001022', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(25190, NULL, 'G3DSA:1.20.272.10:FF:000042', NULL, NULL, 'DNA polymerase III subunit gamma/tau', NULL, NULL, NULL, NULL, NULL, 4),
(25191, NULL, 'G3DSA:2.30.30.40:FF:000555', NULL, NULL, 'Putative truncated guanine nucleotide exchange factor YLL017W', NULL, NULL, NULL, NULL, NULL, 4),
(25192, NULL, 'G3DSA:1.10.238.10:FF:001038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25193, NULL, 'G3DSA:3.40.190.10:FF:000255', NULL, NULL, 'GLutamate Receptor family (AMPA)', NULL, NULL, NULL, NULL, NULL, 4),
(25194, NULL, 'G3DSA:2.130.10.10:FF:000776', NULL, NULL, 'mRNA export factor', NULL, NULL, NULL, NULL, NULL, 4),
(25195, NULL, 'G3DSA:1.25.10.10:FF:001234', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(25196, NULL, 'G3DSA:3.40.50.150:FF:000708', NULL, NULL, 'Os06g0322400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(25197, NULL, 'G3DSA:2.40.50.140:FF:000193', NULL, NULL, 'Exosome complex exonuclease RRP44 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(25198, NULL, 'G3DSA:3.40.50.300:FF:006521', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25199, NULL, 'G3DSA:1.20.140.40:FF:000071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25200, NULL, 'G3DSA:3.90.1600.10:FF:000062', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(25201, NULL, 'G3DSA:3.30.1370.70:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25202, NULL, 'G3DSA:3.60.110.10:FF:000026', NULL, NULL, 'Blast:Omega-amidase NIT2', NULL, NULL, NULL, NULL, NULL, 4),
(25203, NULL, 'G3DSA:1.10.150.240:FF:000092', NULL, NULL, 'Hydrolase haloacid dehalogenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(25204, NULL, 'G3DSA:3.30.2170.10:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25205, NULL, 'G3DSA:2.60.40.1660:FF:000033', NULL, NULL, 'ATPase Na+/K+-transporting subunit beta 3a', NULL, NULL, NULL, NULL, NULL, 4),
(25206, NULL, 'G3DSA:2.170.130.20:FF:000008', NULL, NULL, 'YIL067C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(25207, NULL, 'G3DSA:3.90.470.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25208, NULL, 'G3DSA:3.40.50.80:FF:000043', NULL, NULL, 'NADH-cytochrome b5 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(25209, NULL, 'G3DSA:2.10.25.10:FF:001535', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(25210, NULL, 'G3DSA:2.130.10.10:FF:002928', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25211, NULL, 'G3DSA:3.40.50.10810:FF:000055', NULL, NULL, 'Protein CHROMATIN REMODELING 24', NULL, NULL, NULL, NULL, NULL, 4),
(25212, NULL, 'G3DSA:2.130.10.10:FF:001052', NULL, NULL, 'Mitochondrial division protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(25213, NULL, 'G3DSA:1.25.40.90:FF:000102', NULL, NULL, 'Regulation of nuclear pre-mRNA domain-containing 2b', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(25214, NULL, 'G3DSA:3.30.200.20:FF:000190', NULL, NULL, 'Putative cyclin-dependent kinase 7', NULL, NULL, NULL, NULL, NULL, 4),
(25215, NULL, 'G3DSA:2.130.10.10:FF:000276', NULL, NULL, 'WD repeat-containing protein 91', NULL, NULL, NULL, NULL, NULL, 4),
(25216, NULL, 'G3DSA:1.20.5.170:FF:000030', NULL, NULL, 'RUN and FYVE domain-containing protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(25217, NULL, 'G3DSA:1.10.340.70:FF:000001', NULL, NULL, 'Retrovirus-related Pol polyprotein from transposon gypsy-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(25218, NULL, 'G3DSA:3.40.718.10:FF:000010', NULL, NULL, '4-hydroxythreonine-4-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(25219, NULL, 'G3DSA:1.20.1530.20:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25220, NULL, 'G3DSA:2.60.40.10:FF:002940', NULL, NULL, 'Immunoglobulin domain-containing protein Y54G2A.25', NULL, NULL, NULL, NULL, NULL, 4),
(25221, NULL, 'G3DSA:1.20.1510.10:FF:000090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25222, NULL, 'G3DSA:3.30.70.330:FF:000651', NULL, NULL, 'Poly(A) binding protein cytoplasmic 1 like', NULL, NULL, NULL, NULL, NULL, 4),
(25223, NULL, 'G3DSA:3.90.1800.10:FF:000010', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(25224, NULL, 'G3DSA:2.40.50.430:FF:000010', NULL, NULL, 'DNA polymerase delta subunit 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(25225, NULL, 'G3DSA:1.25.40.10:FF:002309', NULL, NULL, 'Pre-mRNA splicing factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(25226, NULL, 'G3DSA:2.60.40.60:FF:000173', NULL, NULL, 'Cadherin 23', NULL, NULL, NULL, NULL, NULL, 4),
(25227, NULL, 'G3DSA:1.10.533.10:FF:000095', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(25228, NULL, 'G3DSA:1.20.120.320:FF:000001', NULL, NULL, 'Pollen allergen Phl p 5b', NULL, NULL, NULL, NULL, NULL, 4),
(25229, NULL, 'G3DSA:3.30.40.10:FF:000084', NULL, NULL, 'Zinc finger, FYVE domain-containing 9b', NULL, NULL, NULL, NULL, NULL, 4),
(25230, NULL, 'G3DSA:1.25.10.10:FF:000571', NULL, NULL, 'cullin-associated NEDD8-dissociated protein 2 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(25231, NULL, 'G3DSA:3.40.50.300:FF:002816', NULL, NULL, 'Os03g0282700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(25232, NULL, 'G3DSA:3.90.79.10:FF:000243', NULL, NULL, 'Hydrolase, NUDIX family protein', NULL, NULL, NULL, NULL, NULL, 4),
(25233, NULL, 'G3DSA:3.40.30.10:FF:000919', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25234, NULL, 'G3DSA:3.40.50.2300:FF:000156', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(25235, NULL, 'G3DSA:2.40.10.10:FF:000185', NULL, NULL, 'Protease Do-like 5, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(25236, NULL, 'G3DSA:3.90.1410.10:FF:000087', NULL, NULL, 'Protein-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(25237, NULL, 'G3DSA:3.40.50.11210:FF:000012', NULL, NULL, 'AGAP007925-PA', NULL, NULL, NULL, NULL, NULL, 4),
(25238, NULL, 'G3DSA:3.90.170.10:FF:000001', NULL, NULL, 'Adenylosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(25239, NULL, 'G3DSA:3.90.70.10:FF:000662', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25240, NULL, 'G3DSA:1.10.150.240:FF:000120', NULL, NULL, '2-phosphoglycolate phosphatase family', NULL, NULL, NULL, NULL, NULL, 4),
(25241, NULL, 'G3DSA:2.10.110.10:FF:000154', NULL, NULL, 'LIM and senescent cell antigen-like-containing domain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(25242, NULL, 'G3DSA:3.40.50.620:FF:000136', NULL, NULL, 'Probable phosphoadenosine phosphosulfate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(25243, NULL, 'G3DSA:3.30.420.40:FF:000627', NULL, NULL, 'Mitochondrion protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(25244, NULL, 'G3DSA:1.10.3730.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25245, NULL, 'G3DSA:3.90.70.10:FF:000605', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(25246, NULL, 'G3DSA:1.10.418.10:FF:000018', NULL, NULL, 'Neuron navigator 2', NULL, NULL, NULL, NULL, NULL, 4),
(25247, NULL, 'G3DSA:3.10.170.10:FF:000002', NULL, NULL, 'Elastase', NULL, NULL, NULL, NULL, NULL, 4),
(25248, NULL, 'G3DSA:2.70.150.10:FF:000194', NULL, NULL, 'Cadmium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(25249, NULL, 'G3DSA:3.30.60.20:FF:000037', NULL, NULL, 'RAS guanyl releasing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(25250, NULL, 'G3DSA:3.30.160.60:FF:000798', NULL, NULL, 'zinc finger protein 64 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(25251, NULL, 'G3DSA:3.50.4.10:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25252, NULL, 'G3DSA:2.10.25.10:FF:001614', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25253, NULL, 'G3DSA:1.25.40.10:FF:003788', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25254, NULL, 'G3DSA:3.90.650.10:FF:000026', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase subunit PurL', NULL, NULL, NULL, NULL, NULL, 4),
(25255, NULL, 'G3DSA:3.40.225.10:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25256, NULL, 'G3DSA:3.30.420.40:FF:000740', NULL, NULL, 'Actin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(25257, NULL, 'G3DSA:1.20.900.10:FF:000002', NULL, NULL, 'Rho guanine nucleotide exchange factor 9', NULL, NULL, NULL, NULL, NULL, 4),
(25258, NULL, 'G3DSA:1.25.40.250:FF:000005', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit K', NULL, NULL, NULL, NULL, NULL, 4),
(25259, NULL, 'G3DSA:2.30.29.30:FF:001263', NULL, NULL, 'pleckstrin homology domain-containing family A member 8 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(25260, NULL, 'G3DSA:2.130.10.10:FF:004716', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25261, NULL, 'G3DSA:3.40.50.300:FF:004907', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25262, NULL, 'G3DSA:1.25.40.10:FF:003945', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25263, NULL, 'G3DSA:3.30.710.10:FF:000101', NULL, NULL, 'kelch-like protein 10 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(25264, NULL, 'G3DSA:1.20.1530.20:FF:000037', NULL, NULL, 'Sodium/hydrogen exchanger', NULL, NULL, NULL, NULL, NULL, 4),
(25265, NULL, 'G3DSA:1.10.10.10:FF:000565', NULL, NULL, 'RNA polymerase sigma factor SigJ', NULL, NULL, NULL, NULL, NULL, 4),
(25266, NULL, 'G3DSA:2.60.40.290:FF:000012', NULL, NULL, 'Endo-1,4-beta-xylanase A', NULL, NULL, NULL, NULL, NULL, 4),
(25267, NULL, 'G3DSA:1.10.10.60:FF:000265', NULL, NULL, 'CASP8-associated protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(25268, NULL, 'G3DSA:2.120.10.80:FF:000067', NULL, NULL, 'N-acetylneuraminate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(25269, NULL, 'G3DSA:3.30.70.330:FF:002096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25270, NULL, 'G3DSA:2.40.10.310:FF:000005', NULL, NULL, 'CMV 1a interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(25271, NULL, 'G3DSA:1.10.730.10:FF:000047', NULL, NULL, 'Arginine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(25272, NULL, 'G3DSA:1.25.40.240:FF:000002', NULL, NULL, 'ATP-dependent DNA helicase II subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(25273, NULL, 'G3DSA:3.40.50.300:FF:002873', NULL, NULL, 'PROBABLE ATP-DEPENDENT DNA HELICASE', NULL, NULL, NULL, NULL, NULL, 4),
(25274, NULL, 'G3DSA:3.30.830.10:FF:000099', NULL, NULL, 'Zn-dependent peptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(25275, NULL, 'G3DSA:2.60.40.150:FF:000650', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25276, NULL, 'G3DSA:3.20.20.70:FF:000668', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25277, NULL, 'G3DSA:3.40.50.300:FF:001350', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(25278, NULL, 'G3DSA:1.10.3380.30:FF:000014', NULL, NULL, 'DExH-box ATP-dependent RNA helicase DExH11', NULL, NULL, NULL, NULL, NULL, 4),
(25279, NULL, 'G3DSA:3.40.640.10:FF:000166', NULL, NULL, 'Cysteine desulfurase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(25280, NULL, 'G3DSA:1.25.10.10:FF:002920', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25281, NULL, 'G3DSA:2.60.40.10:FF:003440', NULL, NULL, 'Exo-alpha-sialidase', NULL, NULL, NULL, NULL, NULL, 4),
(25282, NULL, 'G3DSA:3.90.440.10:FF:000005', NULL, NULL, 'Nitric oxide synthase, inducible', NULL, NULL, NULL, NULL, NULL, 4),
(25283, NULL, 'G3DSA:2.10.110.10:FF:000204', NULL, NULL, 'LIM homeobox transcription factor 1, alpha', NULL, NULL, NULL, NULL, NULL, 4),
(25284, NULL, 'G3DSA:1.10.20.10:FF:000116', NULL, NULL, 'Transcription initiation factor TFIID subunit 8', NULL, NULL, NULL, NULL, NULL, 4),
(25285, NULL, 'G3DSA:3.30.1390.20:FF:000016', NULL, NULL, 'Putative 60S ribosomal protein L7', NULL, NULL, NULL, NULL, NULL, 4),
(25286, NULL, 'G3DSA:1.10.10.10:FF:000941', NULL, NULL, 'XylR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(25287, NULL, 'G3DSA:3.40.850.10:FF:000204', NULL, NULL, 'Kinesin motor domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(25288, NULL, 'G3DSA:2.40.30.10:FF:000394', NULL, NULL, 'Elongation factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(25289, NULL, 'G3DSA:3.30.60.20:FF:000150', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(25290, NULL, 'G3DSA:1.10.3380.20:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25291, NULL, 'G3DSA:1.25.40.10:FF:002635', NULL, NULL, 'Response regulator receiver and SARP domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(25292, NULL, 'G3DSA:3.80.10.10:FF:003435', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(25293, NULL, 'G3DSA:4.10.60.10:FF:000038', NULL, NULL, 'CCHC-type zinc finger, nucleic acid-binding protein a', NULL, NULL, NULL, NULL, NULL, 4),
(25294, NULL, 'G3DSA:3.30.60.30:FF:000153', NULL, NULL, 'Proteinase inhibitor type-2 CEVI57', NULL, NULL, NULL, NULL, NULL, 4),
(25295, NULL, 'G3DSA:1.20.1270.280:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25296, NULL, 'G3DSA:3.30.1390.10:FF:000013', NULL, NULL, '50S ribosomal protein L7/L12', NULL, NULL, NULL, NULL, NULL, 4),
(25297, NULL, 'G3DSA:3.40.390.10:FF:000124', NULL, NULL, 'Archaemetzincin', NULL, NULL, NULL, NULL, NULL, 4),
(25298, NULL, 'G3DSA:1.10.510.10:FF:002616', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25299, NULL, 'G3DSA:3.20.20.100:FF:000041', NULL, NULL, 'D-arabinose 1-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(25300, NULL, 'G3DSA:3.10.20.10:FF:000044', NULL, NULL, 'Cell death-inducing DFFA-like effector a', NULL, NULL, NULL, NULL, NULL, 4),
(25301, NULL, 'G3DSA:2.60.120.200:FF:000730', NULL, NULL, 'ABR243Wp', NULL, NULL, NULL, NULL, NULL, 4),
(25302, NULL, 'G3DSA:2.40.10.10:FF:000573', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25303, NULL, 'G3DSA:3.90.1750.10:FF:000078', NULL, NULL, 'Ubiquitin-protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(25304, NULL, 'G3DSA:3.40.50.720:FF:000615', NULL, NULL, '17-beta-hydroxysteroid dehydrogenase 13 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(25305, NULL, 'G3DSA:3.80.10.10:FF:001069', NULL, NULL, 'Disease resistance protein (TIR-NBS-LRR class)', NULL, NULL, NULL, NULL, NULL, 4),
(25306, NULL, 'G3DSA:2.20.90.10:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25307, NULL, 'G3DSA:3.90.1150.10:FF:000111', NULL, NULL, 'Transcriptional regulator, GntR family', NULL, NULL, NULL, NULL, NULL, 4),
(25308, NULL, 'G3DSA:2.60.120.260:FF:000433', NULL, NULL, 'Glycoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(25309, NULL, 'G3DSA:1.10.150.20:FF:000135', NULL, NULL, 'Mitochondrial DNA polymerase beta-PAK, putative', NULL, NULL, NULL, NULL, NULL, 4),
(25310, NULL, 'G3DSA:2.60.40.60:FF:000493', NULL, NULL, 'Cadherin 17, LI cadherin (Liver-intestine)', NULL, NULL, NULL, NULL, NULL, 4),
(25311, NULL, 'G3DSA:3.40.50.300:FF:003710', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25312, NULL, 'G3DSA:3.40.1090.10:FF:000073', NULL, NULL, 'Patatin-like phospholipase domain-containing 6', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(25313, NULL, 'G3DSA:1.10.100.10:FF:000016', NULL, NULL, 'GM25185', NULL, NULL, NULL, NULL, NULL, 4),
(25314, NULL, 'G3DSA:2.70.170.10:FF:000026', NULL, NULL, '5-hydroxytryptamine receptor 3C', NULL, NULL, NULL, NULL, NULL, 4),
(25315, NULL, 'G3DSA:2.130.10.10:FF:000484', NULL, NULL, 'WD repeat domain, phosphoinositide interacting 2, isoform CRA_c', NULL, NULL, NULL, NULL, NULL, 4),
(25316, NULL, 'G3DSA:2.70.170.10:FF:000138', NULL, NULL, 'Transmembrane ion channel', NULL, NULL, NULL, NULL, NULL, 4),
(25317, NULL, 'G3DSA:1.10.8.10:FF:000199', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(25318, NULL, 'G3DSA:1.20.1200.10:FF:000004', NULL, NULL, 'Cobalamin adenosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(25319, NULL, 'G3DSA:3.20.20.40:FF:000007', NULL, NULL, 'Glucanase', NULL, NULL, NULL, NULL, NULL, 4),
(25320, NULL, 'G3DSA:2.130.10.10:FF:002693', NULL, NULL, 'YALI0A08646p', NULL, NULL, NULL, NULL, NULL, 4),
(25321, NULL, 'G3DSA:2.20.70.10:FF:000066', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(25322, NULL, 'G3DSA:1.25.40.10:FF:002540', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(25323, NULL, 'G3DSA:1.10.287.110:FF:000485', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25324, NULL, 'G3DSA:3.30.1540.10:FF:000008', NULL, NULL, 'Cinnamoyl-CoA:phenyllactate CoA-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(25325, NULL, 'G3DSA:3.40.50.620:FF:000411', NULL, NULL, 'Tryptophan--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(25326, NULL, 'G3DSA:1.10.630.10:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25327, NULL, 'G3DSA:4.10.240.30:FF:000004', NULL, NULL, 'tumor necrosis factor alpha-induced protein 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(25328, NULL, 'G3DSA:3.40.50.1000:FF:000665', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25329, NULL, 'G3DSA:1.25.40.10:FF:000511', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(25330, NULL, 'G3DSA:3.10.100.10:FF:000054', NULL, NULL, 'C-type lectin domain family 11 member A', NULL, NULL, NULL, NULL, NULL, 4),
(25331, NULL, 'G3DSA:1.10.510.10:FF:002599', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25332, NULL, 'G3DSA:1.25.10.10:FF:000296', NULL, NULL, 'Related to transport protein USO1', NULL, NULL, NULL, NULL, NULL, 4),
(25333, NULL, 'G3DSA:2.60.40.150:FF:000375', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(25334, NULL, 'G3DSA:1.10.600.10:FF:000009', NULL, NULL, 'Geranylgeranyl pyrophosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(25335, NULL, 'G3DSA:3.30.70.120:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25336, NULL, 'G3DSA:3.30.460.30:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25337, NULL, 'G3DSA:1.20.120.350:FF:000274', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25338, NULL, 'G3DSA:3.30.420.40:FF:000947', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25339, NULL, 'G3DSA:2.130.10.10:FF:002575', NULL, NULL, 'WD repeat domain 82', NULL, NULL, NULL, NULL, NULL, 4),
(25340, NULL, 'G3DSA:2.60.40.1170:FF:000077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25341, NULL, 'G3DSA:3.30.200.20:FF:000077', NULL, NULL, 'Putative Serine/threonine-protein kinase/endoribonuclease IRE1', NULL, NULL, NULL, NULL, NULL, 4),
(25342, NULL, 'G3DSA:3.10.20.90:FF:000192', NULL, NULL, 'Rap guanine nucleotide exchange factor (GEF) 3', NULL, NULL, NULL, NULL, NULL, 4),
(25343, NULL, 'G3DSA:1.25.40.10:FF:005120', NULL, NULL, 'TPR-repeat-containing chaperone protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(25344, NULL, 'G3DSA:1.10.150.50:FF:000088', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(25345, NULL, 'G3DSA:1.50.40.10:FF:000559', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(25346, NULL, 'G3DSA:2.10.25.10:FF:001709', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(25347, NULL, 'G3DSA:3.30.70.270:FF:000200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25348, NULL, 'G3DSA:1.10.287.110:FF:000428', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25349, NULL, 'G3DSA:1.20.58.390:FF:000270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25350, NULL, 'G3DSA:1.10.15.30:FF:000008', NULL, NULL, 'Ribosomal protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(25351, NULL, 'G3DSA:2.80.10.70:FF:000004', NULL, NULL, 'Predicted gene, 21778', NULL, NULL, NULL, NULL, NULL, 4),
(25352, NULL, 'G3DSA:2.160.20.10:FF:000348', NULL, NULL, 'F-box protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(25353, NULL, 'G3DSA:3.30.40.210:FF:000002', NULL, NULL, 'Transcription elongation factor SPT4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(25354, NULL, 'G3DSA:1.10.10.60:FF:000473', NULL, NULL, 'Transcriptional regulator, AraC family', NULL, NULL, NULL, NULL, NULL, 4),
(25355, NULL, 'G3DSA:3.10.110.10:FF:000234', NULL, NULL, 'Probable ubiquitin-conjugating enzyme E2 C', NULL, NULL, NULL, NULL, NULL, 4),
(25356, NULL, 'G3DSA:1.10.730.10:FF:000165', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(25357, NULL, 'G3DSA:3.40.140.10:FF:000078', NULL, NULL, 'Cytidine/deoxycytidylate deaminase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(25358, NULL, 'G3DSA:3.40.30.10:FF:001134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25359, NULL, 'G3DSA:2.70.170.10:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25360, NULL, 'G3DSA:1.20.1250.20:FF:001628', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25361, NULL, 'G3DSA:2.40.50.140:FF:000125', NULL, NULL, 'exosome complex exonuclease RRP44 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(25362, NULL, 'G3DSA:3.20.20.220:FF:000026', NULL, NULL, 'Proline dehydrogenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(25363, NULL, 'G3DSA:3.40.50.2300:FF:000509', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25364, NULL, 'G3DSA:1.10.238.10:FF:000993', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(25365, NULL, 'G3DSA:3.10.450.50:FF:000035', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(25366, NULL, 'G3DSA:2.40.10.10:FF:000516', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25367, NULL, 'G3DSA:1.10.1450.10:FF:000159', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(25368, NULL, 'G3DSA:2.60.120.260:FF:000158', NULL, NULL, 'Protein CBG16940', NULL, NULL, NULL, NULL, NULL, 4),
(25369, NULL, 'G3DSA:2.60.40.720:FF:000006', NULL, NULL, 'CRE-RNT-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(25370, NULL, 'G3DSA:1.10.400.10:FF:000028', NULL, NULL, 'Guanine nucleotide-binding protein alpha-5 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(25371, NULL, 'G3DSA:1.10.10.1020:FF:000004', NULL, NULL, 'RecBCD enzyme subunit RecD', NULL, NULL, NULL, NULL, NULL, 4),
(25372, NULL, 'G3DSA:1.20.90.10:FF:000013', NULL, NULL, 'Phospholipase A2', NULL, NULL, NULL, NULL, NULL, 4),
(25373, NULL, 'G3DSA:3.30.160.60:FF:005334', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25374, NULL, 'G3DSA:3.30.1490.20:FF:000069', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(25375, NULL, 'G3DSA:3.10.20.90:FF:000933', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(25376, NULL, 'G3DSA:3.40.50.150:FF:001147', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25377, NULL, 'G3DSA:1.10.630.10:FF:000798', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25378, NULL, 'G3DSA:3.40.50.300:FF:007021', NULL, NULL, 'Uncharacterized protein MJECL10', NULL, NULL, NULL, NULL, NULL, 4),
(25379, NULL, 'G3DSA:3.40.30.10:FF:000976', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(25380, NULL, 'G3DSA:1.20.1050.60:FF:000006', NULL, NULL, 'Putative secreted protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(25381, NULL, 'G3DSA:2.130.10.10:FF:002636', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25382, NULL, 'G3DSA:2.30.30.40:FF:000605', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25383, NULL, 'G3DSA:3.40.50.261:FF:000046', NULL, NULL, 'Acetyl-CoA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(25384, NULL, 'G3DSA:2.60.40.10:FF:006037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25385, NULL, 'G3DSA:3.20.20.30:FF:000004', NULL, NULL, 'F420-dependent glucose-6-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(25386, NULL, 'G3DSA:3.40.50.300:FF:004166', NULL, NULL, 'Zinc finger, NFX1-type-containing 1, gene 2', NULL, NULL, NULL, NULL, NULL, 4),
(25387, NULL, 'G3DSA:3.40.50.1820:FF:000343', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25388, NULL, 'G3DSA:3.90.260.10:FF:000058', NULL, NULL, 'DNA repair protein rhp42', NULL, NULL, NULL, NULL, NULL, 4),
(25389, NULL, 'G3DSA:1.25.40.10:FF:000915', NULL, NULL, 'MAU2 chromatid cohesion factor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(25390, NULL, 'G3DSA:3.30.40.10:FF:001399', NULL, NULL, 'DNA-binding E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(25391, NULL, 'G3DSA:1.25.40.10:FF:004226', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(25392, NULL, 'G3DSA:1.20.1070.10:FF:001089', NULL, NULL, 'Prostaglandin E2 receptor EP3 subtype', NULL, NULL, NULL, NULL, NULL, 4),
(25393, NULL, 'G3DSA:3.20.20.210:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25394, NULL, 'G3DSA:3.80.10.10:FF:003839', NULL, NULL, 'Leucine rich repeat containing 8 VRAC subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(25395, NULL, 'G3DSA:3.90.70.10:FF:000869', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25396, NULL, 'G3DSA:2.60.210.10:FF:000009', NULL, NULL, 'Meprin A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(25397, NULL, 'G3DSA:3.15.10.30:FF:000011', NULL, NULL, 'AGAP009383-PA', NULL, NULL, NULL, NULL, NULL, 4),
(25398, NULL, 'G3DSA:1.25.40.20:FF:000918', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25399, NULL, 'G3DSA:3.30.40.230:FF:000008', NULL, NULL, 'Glycine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(25400, NULL, 'G3DSA:3.30.565.10:FF:000437', NULL, NULL, 'Two-component signal transduction', NULL, NULL, NULL, NULL, NULL, 4),
(25401, NULL, 'G3DSA:3.40.50.300:FF:004784', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(25402, NULL, 'G3DSA:2.130.10.10:FF:004727', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25403, NULL, 'G3DSA:1.20.120.220:FF:000004', NULL, NULL, 'ATP synthase subunit a', NULL, NULL, NULL, NULL, NULL, 4),
(25404, NULL, 'G3DSA:2.60.110.10:FF:000013', NULL, NULL, 'Pathogenesis-related thaumatin superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(25405, NULL, 'G3DSA:3.30.530.20:FF:000096', NULL, NULL, 'Cytoplasmic phosphatidylinositol transfer protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(25406, NULL, 'G3DSA:1.25.10.10:FF:003151', NULL, NULL, 'EXPOrtin (Nuclear export receptor)', NULL, NULL, NULL, NULL, NULL, 4),
(25407, NULL, 'G3DSA:1.20.58.80:FF:000072', NULL, NULL, 'STAM-binding protein b', NULL, NULL, NULL, NULL, NULL, 4),
(25408, NULL, 'G3DSA:1.20.1280.290:FF:000056', NULL, NULL, 'Sugar transporter SWEET1', NULL, NULL, NULL, NULL, NULL, 4),
(25409, NULL, 'G3DSA:3.60.10.10:FF:000013', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 5-phosphatase A', NULL, NULL, NULL, NULL, NULL, 4),
(25410, NULL, 'G3DSA:3.40.50.720:FF:000407', NULL, NULL, 'Oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(25411, NULL, 'G3DSA:1.20.1250.20:FF:000381', NULL, NULL, 'Siderophore iron transporter mirB', NULL, NULL, NULL, NULL, NULL, 4),
(25412, NULL, 'G3DSA:2.60.40.60:FF:000285', NULL, NULL, 'Calsyntenin-1, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(25413, NULL, 'G3DSA:3.40.47.10:FF:000273', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(25414, NULL, 'G3DSA:2.120.10.30:FF:000423', NULL, NULL, 'Low density lipoprotein receptor', NULL, NULL, NULL, NULL, NULL, 4),
(25415, NULL, 'G3DSA:3.40.50.150:FF:001501', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25416, NULL, 'G3DSA:1.20.5.170:FF:000142', NULL, NULL, 'CCR4-associated factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(25417, NULL, 'G3DSA:1.20.120.230:FF:000007', NULL, NULL, 'Catenin alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(25418, NULL, 'G3DSA:3.30.1390.10:FF:000002', NULL, NULL, 'ATP-dependent Clp protease adapter protein ClpS', NULL, NULL, NULL, NULL, NULL, 4),
(25419, NULL, 'G3DSA:1.10.730.10:FF:000126', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(25420, NULL, 'G3DSA:2.10.25.10:FF:001378', NULL, NULL, 'Growth arrest-specific 6', NULL, NULL, NULL, NULL, NULL, 4),
(25421, NULL, 'G3DSA:3.40.50.720:FF:001689', NULL, NULL, 'Ifm3p', NULL, NULL, NULL, NULL, NULL, 4),
(25422, NULL, 'G3DSA:3.30.1370.10:FF:000181', NULL, NULL, 'Tudor and KH domain-containing protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(25423, NULL, 'G3DSA:2.130.10.10:FF:001501', NULL, NULL, 'Cleavage and polyadenylation specificity factor subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(25424, NULL, 'G3DSA:1.25.40.10:FF:001579', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(25425, NULL, 'G3DSA:2.30.42.10:FF:000551', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25426, NULL, 'G3DSA:1.25.40.430:FF:000003', NULL, NULL, 'Checkpoint serine/threonine-protein kinase BUB1', NULL, NULL, NULL, NULL, NULL, 4),
(25427, NULL, 'G3DSA:3.30.497.10:FF:000037', NULL, NULL, 'Serpin peptidase inhibitor 22', NULL, NULL, NULL, NULL, NULL, 4),
(25428, NULL, 'G3DSA:3.90.550.50:FF:000244', NULL, NULL, 'Beta 3-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(25429, NULL, 'G3DSA:2.120.10.80:FF:000331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25430, NULL, 'G3DSA:1.10.418.10:FF:000086', NULL, NULL, 'Fimbrin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(25431, NULL, 'G3DSA:3.10.110.10:FF:000291', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25432, NULL, 'G3DSA:3.40.1090.10:FF:000016', NULL, NULL, 'Patatin like phospholipase domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(25433, NULL, 'G3DSA:3.30.420.40:FF:000447', NULL, NULL, 'Heat shock protein 70kD, putative', NULL, NULL, NULL, NULL, NULL, 4),
(25434, NULL, 'G3DSA:1.25.40.20:FF:000391', NULL, NULL, 'L-asparaginase 1', NULL, NULL, NULL, NULL, NULL, 4),
(25435, NULL, 'G3DSA:1.20.1070.10:FF:001078', NULL, NULL, 'Somatostatin receptor type 4', NULL, NULL, NULL, NULL, NULL, 4),
(25436, NULL, 'G3DSA:3.30.200.20:FF:000285', NULL, NULL, 'Putative inactive leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(25437, NULL, 'G3DSA:3.40.50.300:FF:000456', NULL, NULL, 'Ras-related protein RABC1', NULL, NULL, NULL, NULL, NULL, 4),
(25438, NULL, 'G3DSA:1.10.418.10:FF:000029', NULL, NULL, 'plectin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(25439, NULL, 'G3DSA:3.40.50.2000:FF:000061', NULL, NULL, 'UDP-glycosyltransferase 83A1', NULL, NULL, NULL, NULL, NULL, 4),
(25440, NULL, 'G3DSA:1.10.1500.10:FF:000001', NULL, NULL, 'Glutaminase', NULL, NULL, NULL, NULL, NULL, 4),
(25441, NULL, 'G3DSA:1.10.30.10:FF:000156', NULL, NULL, 'SRY-box 18', NULL, NULL, NULL, NULL, NULL, 4),
(25442, NULL, 'G3DSA:3.30.1120.10:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25443, NULL, 'G3DSA:3.90.1150.10:FF:000100', NULL, NULL, 'Cysteine desulfurase IscS', NULL, NULL, NULL, NULL, NULL, 4),
(25444, NULL, 'G3DSA:3.40.190.10:FF:000137', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(25445, NULL, 'G3DSA:1.20.5.190:FF:000148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25446, NULL, 'G3DSA:1.20.58.60:FF:000453', NULL, NULL, 'Spectrin beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(25447, NULL, 'G3DSA:3.40.50.300:FF:005689', NULL, NULL, 'Dynein-1-beta heavy chain, flagellar inner arm I1 complex', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(25448, NULL, 'G3DSA:3.40.50.300:FF:008095', NULL, NULL, 'UPF1 regulator of nonsense transcripts homolog', NULL, NULL, NULL, NULL, NULL, 4),
(25449, NULL, 'G3DSA:3.40.50.720:FF:002206', NULL, NULL, 'Uncharacterized oxidoreductase C736.13', NULL, NULL, NULL, NULL, NULL, 4),
(25450, NULL, 'G3DSA:3.40.800.10:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25451, NULL, 'G3DSA:3.40.800.20:FF:000047', NULL, NULL, 'Histone deacetylase 3', NULL, NULL, NULL, NULL, NULL, 4),
(25452, NULL, 'G3DSA:3.40.30.10:FF:000858', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25453, NULL, 'G3DSA:1.20.1070.10:FF:001432', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25454, NULL, 'G3DSA:3.30.750.24:FF:000134', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(25455, NULL, 'G3DSA:3.30.160.60:FF:004334', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25456, NULL, 'G3DSA:3.90.79.10:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25457, NULL, 'G3DSA:3.80.10.10:FF:001923', NULL, NULL, 'Malignant fibrous histiocytoma-amplified sequence 1', NULL, NULL, NULL, NULL, NULL, 4),
(25458, NULL, 'G3DSA:1.20.1420.20:FF:000001', NULL, NULL, 'Iron uptake system component EfeO', NULL, NULL, NULL, NULL, NULL, 4),
(25459, NULL, 'G3DSA:3.30.110.30:FF:000016', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(25460, NULL, 'G3DSA:3.30.160.60:FF:002872', NULL, NULL, 'Trade embargo', NULL, NULL, NULL, NULL, NULL, 4),
(25461, NULL, 'G3DSA:2.60.200.40:FF:000001', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(25462, NULL, 'G3DSA:2.40.180.10:FF:000005', NULL, NULL, 'lipoxygenase homology domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(25463, NULL, 'G3DSA:3.30.160.60:FF:005126', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25464, NULL, 'G3DSA:1.10.287.130:FF:000232', NULL, NULL, 'Globin-coupled histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(25465, NULL, 'G3DSA:2.40.10.10:FF:000308', NULL, NULL, 'Protease Do-like 5, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(25466, NULL, 'G3DSA:2.60.34.10:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25467, NULL, 'G3DSA:1.25.40.820:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25468, NULL, 'G3DSA:1.10.472.10:FF:000306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25469, NULL, 'G3DSA:3.30.70.560:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25470, NULL, 'G3DSA:2.10.110.10:FF:000272', NULL, NULL, 'LIM and senescent cell antigen-like-containing domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(25471, NULL, 'G3DSA:1.25.40.20:FF:001391', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25472, NULL, 'G3DSA:2.60.40.150:FF:000493', NULL, NULL, 'Synaptotagmin-like 2a', NULL, NULL, NULL, NULL, NULL, 4),
(25473, NULL, 'G3DSA:3.30.70.330:FF:002039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25474, NULL, 'G3DSA:3.80.30.20:FF:000011', NULL, NULL, 'Elongator complex', NULL, NULL, NULL, NULL, NULL, 4),
(25475, NULL, 'G3DSA:2.20.70.10:FF:000009', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(25476, NULL, 'G3DSA:3.30.300.30:FF:000110', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(25477, NULL, 'G3DSA:1.20.1070.10:FF:000072', NULL, NULL, 'Cannabinoid receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(25478, NULL, 'G3DSA:3.30.1390.20:FF:000005', NULL, NULL, '39S ribosomal protein L30, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(25479, NULL, 'G3DSA:3.10.20.620:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25480, NULL, 'G3DSA:2.60.40.150:FF:000436', NULL, NULL, 'Phosphatidylserine decarboxylase proenzyme 2', NULL, NULL, NULL, NULL, NULL, 4),
(25481, NULL, 'G3DSA:3.40.50.300:FF:006583', NULL, NULL, 'Septin homolog spn7', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(25482, NULL, 'G3DSA:3.80.20.20:FF:000061', NULL, NULL, 'receptor tyrosine-protein kinase erbB-3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(25483, NULL, 'G3DSA:3.30.200.60:FF:000004', NULL, NULL, 'Ubiquitin thiolesterase', NULL, NULL, NULL, NULL, NULL, 4),
(25484, NULL, 'G3DSA:2.60.40.10:FF:000860', NULL, NULL, 'natural cytotoxicity triggering receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(25485, NULL, 'G3DSA:3.30.70.920:FF:000047', NULL, NULL, 'Transcriptional regulator, AsnC family', NULL, NULL, NULL, NULL, NULL, 4),
(25486, NULL, 'G3DSA:1.10.3210.10:FF:000075', NULL, NULL, 'Two-component signal transduction', NULL, NULL, NULL, NULL, NULL, 4),
(25487, NULL, 'G3DSA:2.20.70.10:FF:000240', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(25488, NULL, 'G3DSA:2.10.110.10:FF:000215', NULL, NULL, 'LIM domain-containing protein pin-2', NULL, NULL, NULL, NULL, NULL, 4),
(25489, NULL, 'G3DSA:1.20.1420.30:FF:000004', NULL, NULL, 'Sodium/potassium/calcium exchanger 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(25490, NULL, 'G3DSA:3.30.2020.30:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25491, NULL, 'G3DSA:1.25.40.10:FF:004726', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25492, NULL, 'G3DSA:3.40.50.1820:FF:001804', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(25493, NULL, 'G3DSA:3.30.200.20:FF:000009', NULL, NULL, 'Glycogen synthase kinase-3 beta', NULL, NULL, NULL, NULL, NULL, 4),
(25494, NULL, 'G3DSA:1.20.58.1780:FF:000022', NULL, NULL, 'Nuclear pore complex protein (NUP155), putative', NULL, NULL, NULL, NULL, NULL, 4),
(25495, NULL, 'G3DSA:2.60.200.20:FF:000254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25496, NULL, 'G3DSA:3.20.20.100:FF:000102', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(25497, NULL, 'G3DSA:1.20.58.570:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25498, NULL, 'G3DSA:3.10.20.90:FF:000579', NULL, NULL, 'Autophagy-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(25499, NULL, 'G3DSA:3.40.50.11610:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25500, NULL, 'G3DSA:3.30.1220.10:FF:000001', NULL, NULL, 'GTP-binding protein YjiA', NULL, NULL, NULL, NULL, NULL, 4),
(25501, NULL, 'G3DSA:1.20.1070.10:FF:001819', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25502, NULL, 'G3DSA:2.40.70.10:FF:000514', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25503, NULL, 'G3DSA:2.60.40.10:FF:000585', NULL, NULL, 'mucosa-associated lymphoid tissue lymphoma translocation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(25504, NULL, 'G3DSA:3.90.190.10:FF:000007', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase alpha', NULL, NULL, NULL, NULL, NULL, 4),
(25505, NULL, 'G3DSA:2.60.40.10:FF:001023', NULL, NULL, 'usherin', NULL, NULL, NULL, NULL, NULL, 4),
(25506, NULL, 'G3DSA:2.60.40.60:FF:000673', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25507, NULL, 'G3DSA:1.20.1250.20:FF:001741', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25508, NULL, 'G3DSA:1.20.1070.10:FF:001639', NULL, NULL, 'Pyroglutamylated RFamide peptide receptor a', NULL, NULL, NULL, NULL, NULL, 4),
(25509, NULL, 'G3DSA:1.20.1550.10:FF:000002', NULL, NULL, 'Protein-disulfide oxidoreductase DsbI', NULL, NULL, NULL, NULL, NULL, 4),
(25510, NULL, 'G3DSA:1.10.287.110:FF:000075', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(25511, NULL, 'G3DSA:3.40.50.80:FF:000104', NULL, NULL, 'BauF', NULL, NULL, NULL, NULL, NULL, 4),
(25512, NULL, 'G3DSA:2.130.10.10:FF:001170', NULL, NULL, 'Chromatin assembly factor-I p50 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(25513, NULL, 'G3DSA:1.25.10.10:FF:002095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25514, NULL, 'G3DSA:3.50.50.60:FF:001498', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(25515, NULL, 'G3DSA:2.30.42.10:FF:000113', NULL, NULL, 'Membrane associated guanylate kinase, WW and PDZ domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(25516, NULL, 'G3DSA:3.50.50.60:FF:000800', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(25517, NULL, 'G3DSA:1.10.510.10:FF:004336', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25518, NULL, 'G3DSA:3.40.50.300:FF:002255', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(25519, NULL, 'G3DSA:3.30.450.40:FF:000275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25520, NULL, 'G3DSA:3.30.565.10:FF:000257', NULL, NULL, 'Putative mismatch repair protein PMS1', NULL, NULL, NULL, NULL, NULL, 4),
(25521, NULL, 'G3DSA:3.40.50.10860:FF:000042', NULL, NULL, 'Shikimate 5-dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(25522, NULL, 'G3DSA:3.30.9.10:FF:000079', NULL, NULL, 'Gamma-glutamylputrescine oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(25523, NULL, 'G3DSA:2.60.40.10:FF:002440', NULL, NULL, 'Lymphocyte activation gene 3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(25524, NULL, 'G3DSA:3.40.50.10810:FF:000173', NULL, NULL, 'Uncharacterized protein, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(25525, NULL, 'G3DSA:1.20.1250.20:FF:000105', NULL, NULL, 'proton myo-inositol cotransporter isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(25526, NULL, 'G3DSA:3.60.15.10:FF:000041', NULL, NULL, 'Metallo-beta-lactamase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(25527, NULL, 'G3DSA:3.30.200.20:FF:002437', NULL, NULL, 'MAP kinase-activated protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(25528, NULL, 'G3DSA:1.10.1420.10:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25529, NULL, 'G3DSA:3.30.565.10:FF:000027', NULL, NULL, 'MORC family CW-type zinc finger protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(25530, NULL, 'G3DSA:3.30.559.10:FF:000136', NULL, NULL, 'Protein ECERIFERUM 26-like', NULL, NULL, NULL, NULL, NULL, 4),
(25531, NULL, 'G3DSA:3.30.360.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25532, NULL, 'G3DSA:1.20.59.10:FF:000002', NULL, NULL, 'Chorismate mutase/prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(25533, NULL, 'G3DSA:3.40.50.300:FF:003070', NULL, NULL, 'Ferrous iron transport protein B', NULL, NULL, NULL, NULL, NULL, 4),
(25534, NULL, 'G3DSA:3.30.870.10:FF:000197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25535, NULL, 'G3DSA:3.40.30.10:FF:001173', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(25536, NULL, 'G3DSA:3.30.1050.10:FF:000022', NULL, NULL, 'Alkyl sulfatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(25537, NULL, 'G3DSA:2.40.70.10:FF:000172', NULL, NULL, 'ASpartyl Protease', NULL, NULL, NULL, NULL, NULL, 4),
(25538, NULL, 'G3DSA:2.60.40.10:FF:001080', NULL, NULL, 'protein turtle isoform X10', NULL, NULL, NULL, NULL, NULL, 4),
(25539, NULL, 'G3DSA:1.10.150.240:FF:000007', NULL, NULL, 'Sugar phosphatase YfbT', NULL, NULL, NULL, NULL, NULL, 4),
(25540, NULL, 'G3DSA:3.90.226.10:FF:000333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25541, NULL, 'G3DSA:2.40.50.40:FF:000123', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(25542, NULL, 'G3DSA:3.30.420.40:FF:000009', NULL, NULL, 'Heat shock protein 70', NULL, NULL, NULL, NULL, NULL, 4),
(25543, NULL, 'G3DSA:1.10.238.10:FF:000925', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25544, NULL, 'G3DSA:3.40.190.10:FF:000412', NULL, NULL, 'HTH-type transcriptional activator AmpR', NULL, NULL, NULL, NULL, NULL, 4),
(25545, NULL, 'G3DSA:3.40.50.80:FF:000161', NULL, NULL, 'NADH-dependent ferredoxin:NADP+ oxidoreductase, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(25546, NULL, 'G3DSA:1.20.1080.10:FF:000123', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(25547, NULL, 'G3DSA:2.10.25.10:FF:001653', NULL, NULL, 'Protein crumbs-like Protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(25548, NULL, 'G3DSA:1.20.5.270:FF:000003', NULL, NULL, 'Cytochrome b-c1 complex subunit Rieske, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(25549, NULL, 'G3DSA:2.60.40.60:FF:000616', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25550, NULL, 'G3DSA:1.25.10.10:FF:000560', NULL, NULL, 'Importin 13, putative', NULL, NULL, NULL, NULL, NULL, 4),
(25551, NULL, 'G3DSA:3.30.470.10:FF:000003', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(25552, NULL, 'G3DSA:1.10.287.70:FF:000034', NULL, NULL, 'Potassium voltage-gated channel subfamily B member', NULL, NULL, NULL, NULL, NULL, 4),
(25553, NULL, 'G3DSA:1.25.40.20:FF:001115', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(25554, NULL, 'G3DSA:1.25.10.10:FF:002712', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25555, NULL, 'G3DSA:3.10.120.10:FF:000049', NULL, NULL, 'Chitin synthase-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(25556, NULL, 'G3DSA:3.40.30.10:FF:000678', NULL, NULL, 'Glutathione S-transferase P 1', NULL, NULL, NULL, NULL, NULL, 4),
(25557, NULL, 'G3DSA:1.10.620.20:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25558, NULL, 'G3DSA:3.30.1370.10:FF:000068', NULL, NULL, 'IGF-II mRNA-binding protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(25559, NULL, 'G3DSA:3.30.470.20:FF:000006', NULL, NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(25560, NULL, 'G3DSA:2.60.210.10:FF:000077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25561, NULL, 'G3DSA:3.40.50.300:FF:008207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25562, NULL, 'G3DSA:1.10.10.60:FF:000883', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25563, NULL, 'G3DSA:3.40.50.1100:FF:000066', NULL, NULL, 'L-serine dehydratase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(25564, NULL, 'G3DSA:3.30.70.330:FF:000319', NULL, NULL, 'Polyadenylate-binding protein RBP47B', NULL, NULL, NULL, NULL, NULL, 4),
(25565, NULL, 'G3DSA:2.30.130.40:FF:000002', NULL, NULL, 'Cereblon, isoform CRA_c', NULL, NULL, NULL, NULL, NULL, 4),
(25566, NULL, 'G3DSA:1.10.1170.10:FF:000020', NULL, NULL, 'Bir1p', NULL, NULL, NULL, NULL, NULL, 4),
(25567, NULL, 'G3DSA:2.60.40.150:FF:000616', NULL, NULL, 'Synaptotagmin 1e', NULL, NULL, NULL, NULL, NULL, 4),
(25568, NULL, 'G3DSA:2.40.110.10:FF:000057', NULL, NULL, 'Probable acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(25569, NULL, 'G3DSA:3.40.50.920:FF:000024', NULL, NULL, '1-deoxy-D-xylulose 5-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(25570, NULL, 'G3DSA:3.30.470.30:FF:000009', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(25571, NULL, 'G3DSA:4.10.60.10:FF:000246', NULL, NULL, 'Alternative splicing factor SRp20/9G8, putative', NULL, NULL, NULL, NULL, NULL, 4),
(25572, NULL, 'G3DSA:1.20.58.390:FF:000039', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(25573, NULL, 'G3DSA:2.130.10.10:FF:000894', NULL, NULL, 'Compass component swd2', NULL, NULL, NULL, NULL, NULL, 4),
(25574, NULL, 'G3DSA:2.120.10.30:FF:000243', NULL, NULL, 'DPP6 amino-terminal domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(25575, NULL, 'G3DSA:3.30.530.20:FF:000175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25576, NULL, 'G3DSA:3.40.50.150:FF:000484', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25577, NULL, 'G3DSA:3.30.450.20:FF:000117', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(25578, NULL, 'G3DSA:3.80.10.10:FF:001698', NULL, NULL, 'F-box/LRR-repeat protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(25579, NULL, 'G3DSA:2.60.40.10:FF:002647', NULL, NULL, 'AGAP002949-PA', NULL, NULL, NULL, NULL, NULL, 4),
(25580, NULL, 'G3DSA:3.30.530.20:FF:000118', NULL, NULL, 'Thebaine synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(25581, NULL, 'G3DSA:1.10.472.10:FF:000582', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(25582, NULL, 'G3DSA:3.90.70.10:FF:000364', NULL, NULL, 'Dipeptidyl aminopeptidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(25583, NULL, 'G3DSA:1.10.287.110:FF:000417', NULL, NULL, 'DnaJ-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(25584, NULL, 'G3DSA:2.30.29.30:FF:000245', NULL, NULL, 'Ran-binding protein 1 b', NULL, NULL, NULL, NULL, NULL, 4),
(25585, NULL, 'G3DSA:3.40.50.11660:FF:000006', NULL, NULL, 'Alpha-(1,3)-fucosyltransferase C', NULL, NULL, NULL, NULL, NULL, 4),
(25586, NULL, 'G3DSA:1.10.400.10:FF:000017', NULL, NULL, 'Guanine nucleotide-binding protein (G protein), alpha 11a (Gq class)', NULL, NULL, NULL, NULL, NULL, 4),
(25587, NULL, 'G3DSA:3.40.50.960:FF:000007', NULL, NULL, '6,7-dimethyl-8-ribityllumazine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(25588, NULL, 'G3DSA:2.10.25.10:FF:001322', NULL, NULL, 'Schwann cell-specific EGF-like repeat autocrine factor', NULL, NULL, NULL, NULL, NULL, 4),
(25589, NULL, 'G3DSA:3.80.10.10:FF:000113', NULL, NULL, 'F-box/LRR-repeat protein 15 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(25590, NULL, 'G3DSA:2.40.30.170:FF:000012', NULL, NULL, 'Cation efflux system protein CusB', NULL, NULL, NULL, NULL, NULL, 4),
(25591, NULL, 'G3DSA:1.20.58.60:FF:000240', NULL, NULL, 'Microtubule-actin cross-linking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(25592, NULL, 'G3DSA:1.10.3460.10:FF:000008', NULL, NULL, 'Photosystem II 22 kDa protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(25593, NULL, 'G3DSA:3.40.630.10:FF:000334', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25594, NULL, 'G3DSA:3.40.50.1000:FF:000098', NULL, NULL, 'RNA polymerase II C-terminal domain phosphatase-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(25595, NULL, 'G3DSA:2.40.40.50:FF:000002', NULL, NULL, 'Ubiquitin fusion degradation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(25596, NULL, 'G3DSA:1.10.472.10:FF:000520', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(25597, NULL, 'G3DSA:2.40.30.180:FF:000015', NULL, NULL, 'Ubiquitin activating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(25598, NULL, 'G3DSA:2.60.120.650:FF:000005', NULL, NULL, 'lysine-specific demethylase 2A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(25599, NULL, 'G3DSA:1.10.10.60:FF:000708', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25600, NULL, 'G3DSA:2.60.40.10:FF:002209', NULL, NULL, 'Cell adhesion molecule L1-like b', NULL, NULL, NULL, NULL, NULL, 4),
(25601, NULL, 'G3DSA:3.10.20.90:FF:000309', NULL, NULL, 'Autophagy-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(25602, NULL, 'G3DSA:3.60.20.10:FF:000053', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(25603, NULL, 'G3DSA:1.20.5.520:FF:000005', NULL, NULL, 'Thymosin beta HOMOLOGUE', NULL, NULL, NULL, NULL, NULL, 4),
(25604, NULL, 'G3DSA:3.40.630.10:FF:000278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25605, NULL, 'G3DSA:3.30.160.60:FF:004901', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25606, NULL, 'G3DSA:2.40.50.140:FF:000743', NULL, NULL, 'AGAP007032-PA', NULL, NULL, NULL, NULL, NULL, 4),
(25607, NULL, 'G3DSA:3.30.40.10:FF:001961', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25608, NULL, 'G3DSA:3.80.10.10:FF:000057', NULL, NULL, 'Centrosomal protein of 78 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(25609, NULL, 'G3DSA:2.170.270.10:FF:000195', NULL, NULL, 'SET domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(25610, NULL, 'G3DSA:3.30.1520.10:FF:000002', NULL, NULL, 'Sorting nexin 12', NULL, NULL, NULL, NULL, NULL, 4),
(25611, NULL, 'G3DSA:3.90.226.10:FF:000064', NULL, NULL, 'Enoyl-CoA hydratase EchA20', NULL, NULL, NULL, NULL, NULL, 4),
(25612, NULL, 'G3DSA:3.30.70.1890:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25613, NULL, 'G3DSA:3.30.160.60:FF:004845', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25614, NULL, 'G3DSA:1.25.10.10:FF:003033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(25615, NULL, 'G3DSA:2.10.25.10:FF:001266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25616, NULL, 'G3DSA:3.40.50.300:FF:006813', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25617, NULL, 'G3DSA:2.30.30.210:FF:000004', NULL, NULL, 'Ribonuclease P protein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(25618, NULL, 'G3DSA:3.30.70.330:FF:000297', NULL, NULL, 'RNA binding motif protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(25619, NULL, 'G3DSA:3.30.200.20:FF:002252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25620, NULL, 'G3DSA:3.40.30.10:FF:001139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25621, NULL, 'G3DSA:3.40.50.720:FF:001532', NULL, NULL, 'Acetoacetyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(25622, NULL, 'G3DSA:2.30.36.70:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25623, NULL, 'G3DSA:3.30.930.10:FF:000022', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(25624, NULL, 'G3DSA:3.30.420.40:FF:000392', NULL, NULL, 'pantothenate kinase 3-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(25625, NULL, 'G3DSA:3.80.10.10:FF:002204', NULL, NULL, 'DmMstProx', NULL, NULL, NULL, NULL, NULL, 4),
(25626, NULL, 'G3DSA:3.30.559.70:FF:000025', NULL, NULL, 'carnitine O-palmitoyltransferase 1, liver isoform-like', NULL, NULL, NULL, NULL, NULL, 4),
(25627, NULL, 'G3DSA:2.70.98.10:FF:000043', NULL, NULL, 'Putative conserved exported protein', NULL, NULL, NULL, NULL, NULL, 4),
(25628, NULL, 'G3DSA:2.40.50.140:FF:001199', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25629, NULL, 'G3DSA:3.40.47.10:FF:000211', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25630, NULL, 'G3DSA:1.10.472.10:FF:000464', NULL, NULL, 'CCNB1 isoform 6', NULL, NULL, NULL, NULL, NULL, 4),
(25631, NULL, 'G3DSA:3.40.1090.10:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25632, NULL, 'G3DSA:3.30.160.60:FF:002754', NULL, NULL, 'Zinc finger protein 705A', NULL, NULL, NULL, NULL, NULL, 4),
(25633, NULL, 'G3DSA:3.30.70.330:FF:002118', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25634, NULL, 'G3DSA:1.10.10.10:FF:001689', NULL, NULL, 'Heat shock transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(25635, NULL, 'G3DSA:3.40.50.300:FF:003036', NULL, NULL, 'RAB30 isoform 15', NULL, NULL, NULL, NULL, NULL, 4),
(25636, NULL, 'G3DSA:1.20.1250.20:FF:001746', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25637, NULL, 'G3DSA:3.30.40.10:FF:000319', NULL, NULL, 'E3 ubiquitin-protein ligase RNF182', NULL, NULL, NULL, NULL, NULL, 4),
(25638, NULL, 'G3DSA:3.40.50.300:FF:004722', NULL, NULL, 'ATP-binding cassette, sub-family A (ABC1), member 4b', NULL, NULL, NULL, NULL, NULL, 4),
(25639, NULL, 'G3DSA:1.25.40.10:FF:004165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25640, NULL, 'G3DSA:3.10.450.580:FF:000018', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(25641, NULL, 'G3DSA:3.30.70.330:FF:002444', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25642, NULL, 'G3DSA:1.10.10.10:FF:000273', NULL, NULL, 'DNA-binding response regulator RprY', NULL, NULL, NULL, NULL, NULL, 4),
(25643, NULL, 'G3DSA:2.130.10.10:FF:004430', NULL, NULL, 'WD repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(25644, NULL, 'G3DSA:3.30.70.330:FF:001876', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25645, NULL, 'G3DSA:3.10.110.10:FF:000116', NULL, NULL, 'ubiquitin-conjugating enzyme E2 G1', NULL, NULL, NULL, NULL, NULL, 4),
(25646, NULL, 'G3DSA:2.130.10.10:FF:002069', NULL, NULL, 'Related to transcription factor SPT8', NULL, NULL, NULL, NULL, NULL, 4),
(25647, NULL, 'G3DSA:3.80.10.10:FF:003727', NULL, NULL, 'AGAP007451-PA', NULL, NULL, NULL, NULL, NULL, 4),
(25648, NULL, 'G3DSA:3.30.160.60:FF:001175', NULL, NULL, 'Zinc finger, C2H2 type', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(25649, NULL, 'G3DSA:3.60.21.10:FF:000269', NULL, NULL, 'Serine/threonine-protein phosphatase with EF-hands', NULL, NULL, NULL, NULL, NULL, 4),
(25650, NULL, 'G3DSA:3.90.920.10:FF:000025', NULL, NULL, 'DNA primase small subunit PriS', NULL, NULL, NULL, NULL, NULL, 4),
(25651, NULL, 'G3DSA:1.10.510.10:FF:001014', NULL, NULL, 'AGC protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(25652, NULL, 'G3DSA:1.25.10.10:FF:002358', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25653, NULL, 'G3DSA:1.20.1050.10:FF:000008', NULL, NULL, 'Glutathione S-transferase theta-1', NULL, NULL, NULL, NULL, NULL, 4),
(25654, NULL, 'G3DSA:2.40.10.10:FF:000628', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25655, NULL, 'G3DSA:1.25.10.10:FF:000234', NULL, NULL, 'Golgin candidate 6', NULL, NULL, NULL, NULL, NULL, 4),
(25656, NULL, 'G3DSA:1.10.238.100:FF:000006', NULL, NULL, 'Fluconazole resistance protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(25657, NULL, 'G3DSA:3.100.10.10:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25658, NULL, 'G3DSA:2.60.40.820:FF:000042', NULL, NULL, 'Protein CBG26077', NULL, NULL, NULL, NULL, NULL, 4),
(25659, NULL, 'G3DSA:3.30.70.270:FF:000262', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25660, NULL, 'G3DSA:1.20.1560.10:FF:000789', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(25661, NULL, 'G3DSA:1.20.58.1190:FF:000002', NULL, NULL, 'Toxin A', NULL, NULL, NULL, NULL, NULL, 4),
(25662, NULL, 'G3DSA:3.40.50.1000:FF:000047', NULL, NULL, 'Sodium P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(25663, NULL, 'G3DSA:3.80.10.10:FF:001636', NULL, NULL, 'Insulin like growth factor binding protein acid labile subunit', NULL, NULL, NULL, NULL, NULL, 4),
(25664, NULL, 'G3DSA:3.30.160.60:FF:003322', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25665, NULL, 'G3DSA:2.40.50.40:FF:000117', NULL, NULL, 'Heterochromatin protein 1e', NULL, NULL, NULL, NULL, NULL, 4),
(25666, NULL, 'G3DSA:2.40.50.140:FF:000636', NULL, NULL, 'Minichromosome maintenance complex component 4', NULL, NULL, NULL, NULL, NULL, 4),
(25667, NULL, 'G3DSA:3.40.50.300:FF:002575', NULL, NULL, 'NFX1-type zinc finger-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(25668, NULL, 'G3DSA:3.50.50.60:FF:000205', NULL, NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(25669, NULL, 'G3DSA:1.20.1050.10:FF:000183', NULL, NULL, 'Glutathione S-transferase P 1', NULL, NULL, NULL, NULL, NULL, 4),
(25670, NULL, 'G3DSA:3.30.230.10:FF:000345', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25671, NULL, 'G3DSA:2.40.50.910:FF:000002', NULL, NULL, 'ESX-5 secretion system ATPase EccB5', NULL, NULL, NULL, NULL, NULL, 4),
(25672, NULL, 'G3DSA:3.30.70.330:FF:000353', NULL, NULL, 'PPARG coactivator 1 beta', NULL, NULL, NULL, NULL, NULL, 4),
(25673, NULL, 'G3DSA:1.20.1070.10:FF:000015', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(25674, NULL, 'G3DSA:4.10.280.30:FF:000001', NULL, NULL, 'breakpoint cluster region protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(25675, NULL, 'G3DSA:1.10.150.60:FF:000012', NULL, NULL, 'Blast:Protein Jumonji', NULL, NULL, NULL, NULL, NULL, 4),
(25676, NULL, 'G3DSA:3.40.47.10:FF:000155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25677, NULL, 'G3DSA:2.60.40.10:FF:004452', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25678, NULL, 'G3DSA:2.10.220.10:FF:000095', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 6', NULL, NULL, NULL, NULL, NULL, 4),
(25679, NULL, 'G3DSA:3.40.50.1000:FF:000154', NULL, NULL, 'Trehalose-6-phosphate synthase 10', NULL, NULL, NULL, NULL, NULL, 4),
(25680, NULL, 'G3DSA:2.60.40.4100:FF:000012', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(25681, NULL, 'G3DSA:1.10.600.10:FF:000010', NULL, NULL, 'Squalene synthase HpnD', NULL, NULL, NULL, NULL, NULL, 4),
(25682, NULL, 'G3DSA:3.30.160.60:FF:001231', NULL, NULL, 'Zinc finger protein 574', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(25683, NULL, 'G3DSA:1.10.510.10:FF:004398', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25684, NULL, 'G3DSA:3.30.470.20:FF:000001', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(25685, NULL, 'G3DSA:1.25.40.10:FF:000803', NULL, NULL, 'Tetratricopeptide repeat domain 21A', NULL, NULL, NULL, NULL, NULL, 4),
(25686, NULL, 'G3DSA:3.60.15.10:FF:000209', NULL, NULL, 'Artemis-related DNA-crosslink repair exonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(25687, NULL, 'G3DSA:2.70.98.10:FF:000094', NULL, NULL, 'NDH-dependent cyclic electron flow 1', NULL, NULL, NULL, NULL, NULL, 4),
(25688, NULL, 'G3DSA:3.30.60.230:FF:000001', NULL, NULL, 'Nucleoid-associated protein Lsr2', NULL, NULL, NULL, NULL, NULL, 4),
(25689, NULL, 'G3DSA:1.10.510.10:FF:003105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25690, NULL, 'G3DSA:1.10.238.10:FF:000369', NULL, NULL, 'Probable calcium-binding mitochondrial carrier CBG00135', NULL, NULL, NULL, NULL, NULL, 4),
(25691, NULL, 'G3DSA:1.25.40.10:FF:004221', NULL, NULL, 'Pentatricopeptide repeat-containing protein PET309, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(25692, NULL, 'G3DSA:3.90.1600.10:FF:000028', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(25693, NULL, 'G3DSA:3.30.420.110:FF:000070', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(25694, NULL, 'G3DSA:3.40.50.300:FF:004666', NULL, NULL, 'AAA ATPase central domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(25695, NULL, 'G3DSA:3.10.450.50:FF:000030', NULL, NULL, 'Conidial pigment biosynthesis scytalone dehydratase Arp1', NULL, NULL, NULL, NULL, NULL, 4),
(25696, NULL, 'G3DSA:1.10.238.10:FF:001100', NULL, NULL, 'Serine/threonine-protein phosphatase with EF-hands', NULL, NULL, NULL, NULL, NULL, 4),
(25697, NULL, 'G3DSA:1.20.1070.10:FF:001589', NULL, NULL, 'Odorant receptor S51', NULL, NULL, NULL, NULL, NULL, 4),
(25698, NULL, 'G3DSA:1.20.1070.10:FF:001645', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25699, NULL, 'G3DSA:2.30.30.30:FF:000108', NULL, NULL, '50S ribosomal protein L24', NULL, NULL, NULL, NULL, NULL, 4),
(25700, NULL, 'G3DSA:3.30.160.60:FF:006195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25701, NULL, 'G3DSA:1.25.40.10:FF:004844', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25702, NULL, 'G3DSA:2.40.10.10:FF:000691', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25703, NULL, 'G3DSA:1.10.418.40:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25704, NULL, 'G3DSA:3.60.21.10:FF:000218', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(25705, NULL, 'G3DSA:3.20.20.100:FF:000046', NULL, NULL, 'Aldo-keto reductase family 1, member B10 (aldose reductase)', NULL, NULL, NULL, NULL, NULL, 4),
(25706, NULL, 'G3DSA:3.30.70.330:FF:001657', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25707, NULL, 'G3DSA:2.60.40.10:FF:000293', NULL, NULL, 'Tenascin C', NULL, NULL, NULL, NULL, NULL, 4),
(25708, NULL, 'G3DSA:1.10.418.60:FF:000016', NULL, NULL, 'Nuf2 family-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(25709, NULL, 'G3DSA:3.30.505.10:FF:000198', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25710, NULL, 'G3DSA:3.90.1800.10:FF:000009', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(25711, NULL, 'G3DSA:2.130.10.10:FF:002917', NULL, NULL, 'Bromodomain and WD repeat domain-containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(25712, NULL, 'G3DSA:3.30.160.60:FF:006251', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25713, NULL, 'G3DSA:1.25.40.10:FF:004900', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At3g47840', NULL, NULL, NULL, NULL, NULL, 4),
(25714, NULL, 'G3DSA:2.60.40.10:FF:003103', NULL, NULL, 'Immunoglobulin domain-containing protein Y54G2A.25', NULL, NULL, NULL, NULL, NULL, 4),
(25715, NULL, 'G3DSA:3.40.50.1820:FF:001574', NULL, NULL, 'Cutinase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(25716, NULL, 'G3DSA:2.70.150.10:FF:000255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25717, NULL, 'G3DSA:3.90.70.10:FF:000038', NULL, NULL, 'Calpain-type cysteine protease DEK1', NULL, NULL, NULL, NULL, NULL, 4),
(25718, NULL, 'G3DSA:3.30.1010.10:FF:000070', NULL, NULL, 'phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit alpha-like', NULL, NULL, NULL, NULL, NULL, 4),
(25719, NULL, 'G3DSA:3.30.505.10:FF:000254', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25720, NULL, 'G3DSA:1.10.274.30:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25721, NULL, 'G3DSA:2.130.10.10:FF:005739', NULL, NULL, 'AT07759p', NULL, NULL, NULL, NULL, NULL, 4),
(25722, NULL, 'G3DSA:2.60.480.10:FF:000001', NULL, NULL, 'Stage V sporulation protein AA', NULL, NULL, NULL, NULL, NULL, 4),
(25723, NULL, 'G3DSA:1.25.10.10:FF:000178', NULL, NULL, 'hsp70-binding protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(25724, NULL, 'G3DSA:1.25.40.10:FF:000573', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(25725, NULL, 'G3DSA:3.60.90.10:FF:000001', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(25726, NULL, 'G3DSA:1.25.40.20:FF:000576', NULL, NULL, 'ankyrin repeat and SAM domain-containing protein 6 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(25727, NULL, 'G3DSA:1.10.472.10:FF:000138', NULL, NULL, 'Transcription initiation factor IIB, putative', NULL, NULL, NULL, NULL, NULL, 4),
(25728, NULL, 'G3DSA:3.40.50.300:FF:003362', NULL, NULL, 'RNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(25729, NULL, 'G3DSA:1.10.1380.10:FF:000007', NULL, NULL, 'Blast:Membrane metallo-endopeptidase-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(25730, NULL, 'G3DSA:3.40.50.1820:FF:000225', NULL, NULL, 'Os07g0687100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(25731, NULL, 'G3DSA:3.30.200.20:FF:002145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25732, NULL, 'G3DSA:1.10.510.10:FF:002537', NULL, NULL, 'Serine/threonine-protein kinase PDIK1L', NULL, NULL, NULL, NULL, NULL, 4),
(25733, NULL, 'G3DSA:3.30.70.920:FF:000053', NULL, NULL, 'Transcriptional regulator, AsnC family', NULL, NULL, NULL, NULL, NULL, 4),
(25734, NULL, 'G3DSA:2.60.120.200:FF:000112', NULL, NULL, 'L-type lectin-domain containing receptor kinase V.9', NULL, NULL, NULL, NULL, NULL, 4),
(25735, NULL, 'G3DSA:3.40.50.300:FF:007521', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25736, NULL, 'G3DSA:3.40.50.2060:FF:000005', NULL, NULL, 'vacuolar protein sorting-associated protein 33B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(25737, NULL, 'G3DSA:3.90.79.10:FF:000182', NULL, NULL, 'Isopentenyl-diphosphate delta-isomerase, type 1', NULL, NULL, NULL, NULL, NULL, 4),
(25738, NULL, 'G3DSA:2.40.70.10:FF:000284', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25739, NULL, 'G3DSA:2.60.40.790:FF:000156', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25740, NULL, 'G3DSA:4.10.91.10:FF:000003', NULL, NULL, 'Cytochrome c oxidase subunit 7A2a', NULL, NULL, NULL, NULL, NULL, 4),
(25741, NULL, 'G3DSA:2.20.70.10:FF:000184', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(25742, NULL, 'G3DSA:3.40.50.720:FF:002240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25743, NULL, 'G3DSA:3.40.50.2000:FF:001078', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(25744, NULL, 'G3DSA:3.30.230.70:FF:000009', NULL, NULL, 'Exosome complex component RRP42', NULL, NULL, NULL, NULL, NULL, 4),
(25745, NULL, 'G3DSA:1.10.238.10:FF:001151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25746, NULL, 'G3DSA:1.10.3720.10:FF:000170', NULL, NULL, 'ABC transporter permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(25747, NULL, 'G3DSA:3.40.109.10:FF:000005', NULL, NULL, 'NAD(P)H nitroreductase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(25748, NULL, 'G3DSA:1.20.1050.10:FF:000301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25749, NULL, 'G3DSA:2.130.10.10:FF:004542', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(25750, NULL, 'G3DSA:3.20.190.10:FF:000012', NULL, NULL, 'Formamidopyrimidine-DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(25751, NULL, 'G3DSA:3.90.226.10:FF:000283', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(25752, NULL, 'G3DSA:3.30.310.40:FF:000001', NULL, NULL, 'N-glycosylase/DNA lyase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(25753, NULL, 'G3DSA:3.30.70.330:FF:002332', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25754, NULL, 'G3DSA:3.30.310.50:FF:000004', NULL, NULL, 'Alpha-D-glucose phosphate-specific phosphoglucomutase', NULL, NULL, NULL, NULL, NULL, 4),
(25755, NULL, 'G3DSA:3.40.640.10:FF:000048', NULL, NULL, 'tyrosine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(25756, NULL, 'G3DSA:1.20.120.1750:FF:000021', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(25757, NULL, 'G3DSA:1.10.10.10:FF:000385', NULL, NULL, 'Poly-beta-hydroxybutyrate-responsive repressor', NULL, NULL, NULL, NULL, NULL, 4),
(25758, NULL, 'G3DSA:3.90.180.10:FF:000001', NULL, NULL, 'S-(hydroxymethyl)glutathione dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(25759, NULL, 'G3DSA:3.80.10.10:FF:000006', NULL, NULL, 'Tropomodulin 2', NULL, NULL, NULL, NULL, NULL, 4),
(25760, NULL, 'G3DSA:3.40.50.300:FF:004941', NULL, NULL, 'Si:dkeyp-9d4.2', NULL, NULL, NULL, NULL, NULL, 4),
(25761, NULL, 'G3DSA:3.40.50.300:FF:008089', NULL, NULL, 'Replication factor C small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(25762, NULL, 'G3DSA:3.90.226.10:FF:000013', NULL, NULL, 'Acetyl-coenzyme A carboxylase carboxyl transferase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(25763, NULL, 'G3DSA:2.30.29.240:FF:000005', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(25764, NULL, 'G3DSA:3.40.50.2300:FF:000510', NULL, NULL, 'Probable sensor/response regulator hybrid', NULL, NULL, NULL, NULL, NULL, 4),
(25765, NULL, 'G3DSA:3.40.50.1440:FF:000095', NULL, NULL, 'Cell division protein FtsZ', NULL, NULL, NULL, NULL, NULL, 4),
(25766, NULL, 'G3DSA:3.10.129.10:FF:000215', NULL, NULL, '4-hydroxybenzoyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(25767, NULL, 'G3DSA:2.10.220.10:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25768, NULL, 'G3DSA:2.130.10.10:FF:000271', NULL, NULL, 'cilia- and flagella-associated protein 57', NULL, NULL, NULL, NULL, NULL, 4),
(25769, NULL, 'G3DSA:2.120.10.70:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25770, NULL, 'G3DSA:3.40.50.12780:FF:000016', NULL, NULL, 'Phenylacetate-coenzyme A ligase', NULL, NULL, NULL, NULL, NULL, 4),
(25771, NULL, 'G3DSA:2.120.10.30:FF:000069', NULL, NULL, 'Blast:Prolow-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(25772, NULL, 'G3DSA:2.120.10.80:FF:000005', NULL, NULL, 'Putative LOV domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(25773, NULL, 'G3DSA:3.90.1600.10:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25774, NULL, 'G3DSA:1.20.1720.10:FF:000032', NULL, NULL, 'Putative multidrug transporter', NULL, NULL, NULL, NULL, NULL, 4),
(25775, NULL, 'G3DSA:1.20.1050.10:FF:000071', NULL, NULL, 'Omega-class glutathione transferase', NULL, NULL, NULL, NULL, NULL, 4),
(25776, NULL, 'G3DSA:1.10.510.10:FF:003431', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25777, NULL, 'G3DSA:3.30.70.330:FF:000027', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein q isoform', NULL, NULL, NULL, NULL, NULL, 4),
(25778, NULL, 'G3DSA:2.60.120.430:FF:000001', NULL, NULL, 'Receptor-like protein kinase FERONIA', NULL, NULL, NULL, NULL, NULL, 4),
(25779, NULL, 'G3DSA:3.80.10.10:FF:003497', NULL, NULL, 'Leucine rich repeat containing 40', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(25780, NULL, 'G3DSA:2.30.29.230:FF:000002', NULL, NULL, 'TBC1 domain family member 16 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(25781, NULL, 'G3DSA:3.30.160.60:FF:002479', NULL, NULL, 'Si:ch211-216l23.1', NULL, NULL, NULL, NULL, NULL, 4),
(25782, NULL, 'G3DSA:1.10.3260.10:FF:000027', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(25783, NULL, 'G3DSA:2.30.42.10:FF:000433', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25784, NULL, 'G3DSA:3.40.50.1000:FF:000480', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25785, NULL, 'G3DSA:3.30.200.20:FF:002196', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(25786, NULL, 'G3DSA:3.30.590.20:FF:000004', NULL, NULL, 'Putative glutamate--cysteine ligase 2', NULL, NULL, NULL, NULL, NULL, 4),
(25787, NULL, 'G3DSA:2.30.30.40:FF:000544', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25788, NULL, 'G3DSA:3.30.230.70:FF:000161', NULL, NULL, 'Exosome non-catalytic core subunit', NULL, NULL, NULL, NULL, NULL, 4),
(25789, NULL, 'G3DSA:3.40.630.10:FF:000008', NULL, NULL, 'Endoplasmic reticulum metallopeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(25790, NULL, 'G3DSA:2.60.40.10:FF:002939', NULL, NULL, 'Protein sevenless', NULL, NULL, NULL, NULL, NULL, 4),
(25791, NULL, 'G3DSA:2.60.40.10:FF:004564', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25792, NULL, 'G3DSA:2.30.30.40:FF:000263', NULL, NULL, 'SH3 domain-containing protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(25793, NULL, 'G3DSA:1.10.238.10:FF:000257', NULL, NULL, 'Calmodulin', NULL, NULL, NULL, NULL, NULL, 4),
(25794, NULL, 'G3DSA:3.30.420.40:FF:000329', NULL, NULL, 'ROK family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(25795, NULL, 'G3DSA:3.40.462.20:FF:000002', NULL, NULL, 'Possible oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(25796, NULL, 'G3DSA:3.40.50.720:FF:001476', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(25797, NULL, 'G3DSA:3.30.590.10:FF:000001', NULL, NULL, 'Glutamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(25798, NULL, 'G3DSA:3.90.640.10:FF:000020', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(25799, NULL, 'G3DSA:2.60.40.10:FF:002384', NULL, NULL, 'Stretchin-Mlck, isoform S', NULL, NULL, NULL, NULL, NULL, 4),
(25800, NULL, 'G3DSA:3.10.100.10:FF:000402', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25801, NULL, 'G3DSA:1.20.920.30:FF:000037', NULL, NULL, 'Dynein, axonemal, heavy chain 14', NULL, NULL, NULL, NULL, NULL, 4),
(25802, NULL, 'G3DSA:1.25.40.20:FF:001407', NULL, NULL, 'CAMTA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(25803, NULL, 'G3DSA:3.30.1010.10:FF:000137', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', NULL, NULL, NULL, NULL, NULL, 4),
(25804, NULL, 'G3DSA:1.20.1310.10:FF:000170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25805, NULL, 'G3DSA:1.10.10.10:FF:000054', NULL, NULL, 'Two-component system response regulator ArcA', NULL, NULL, NULL, NULL, NULL, 4),
(25806, NULL, 'G3DSA:3.90.190.10:FF:000114', NULL, NULL, 'Tyrosine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(25807, NULL, 'G3DSA:2.30.160.11:FF:000002', NULL, NULL, 'Methuselah-like 8, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(25808, NULL, 'G3DSA:3.30.160.60:FF:004957', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25809, NULL, 'G3DSA:3.30.160.60:FF:004671', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25810, NULL, 'G3DSA:2.40.170.20:FF:000064', NULL, NULL, 'TonB-dependent outer membrane receptor', NULL, NULL, NULL, NULL, NULL, 4),
(25811, NULL, 'G3DSA:3.40.630.10:FF:000222', NULL, NULL, 'Protein CBG05160', NULL, NULL, NULL, NULL, NULL, 4),
(25812, NULL, 'G3DSA:2.60.120.10:FF:000475', NULL, NULL, 'Cysteine dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(25813, NULL, 'G3DSA:1.25.10.10:FF:000745', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(25814, NULL, 'G3DSA:2.30.29.30:FF:000240', NULL, NULL, 'Myotubularin-related protein 9', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(25815, NULL, 'G3DSA:3.60.110.10:FF:000032', NULL, NULL, 'Glutamine-dependent NAD(+) synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(25816, NULL, 'G3DSA:1.10.1410.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25817, NULL, 'G3DSA:3.40.50.300:FF:001119', NULL, NULL, 'Iron-sulfur cluster carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(25818, NULL, 'G3DSA:1.20.144.10:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25819, NULL, 'G3DSA:1.25.10.10:FF:000801', NULL, NULL, 'Putative tubulin folding cofactor D', NULL, NULL, NULL, NULL, NULL, 4),
(25820, NULL, 'G3DSA:3.40.50.720:FF:002021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25821, NULL, 'G3DSA:3.30.70.270:FF:000043', NULL, NULL, 'Diguanylate cyclase (GGDEF) domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(25822, NULL, 'G3DSA:1.20.144.10:FF:000048', NULL, NULL, 'Chromosome 12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(25823, NULL, 'G3DSA:1.10.10.60:FF:000260', NULL, NULL, 'Fis family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(25824, NULL, 'G3DSA:3.40.50.300:FF:004492', NULL, NULL, 'Cobalt ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(25825, NULL, 'G3DSA:2.30.38.10:FF:000002', NULL, NULL, 'Enterobactin synthase component F', NULL, NULL, NULL, NULL, NULL, 4),
(25826, NULL, 'G3DSA:1.20.1070.10:FF:001319', NULL, NULL, 'LOC561989 protein', NULL, NULL, NULL, NULL, NULL, 4),
(25827, NULL, 'G3DSA:1.25.10.10:FF:001021', NULL, NULL, 'Exportin T, putative', NULL, NULL, NULL, NULL, NULL, 4),
(25828, NULL, 'G3DSA:3.40.50.2300:FF:000324', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(25829, NULL, 'G3DSA:1.10.238.10:FF:000662', NULL, NULL, 'RE52086p', NULL, NULL, NULL, NULL, NULL, 4),
(25830, NULL, 'G3DSA:1.10.510.10:FF:001200', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(25831, NULL, 'G3DSA:2.60.40.10:FF:001523', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(25832, NULL, 'G3DSA:3.40.50.300:FF:007302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25833, NULL, 'G3DSA:3.80.10.10:FF:000001', NULL, NULL, 'SLIT and NTRK-like family, member 1', NULL, NULL, NULL, NULL, NULL, 4),
(25834, NULL, 'G3DSA:3.40.50.2300:FF:000268', NULL, NULL, 'Low molecular weight protein-tyrosine-phosphatase PtpA', NULL, NULL, NULL, NULL, NULL, 4),
(25835, NULL, 'G3DSA:3.40.50.1820:FF:000500', NULL, NULL, 'Esterase/lipase/thioesterase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(25836, NULL, 'G3DSA:3.30.160.60:FF:002535', NULL, NULL, 'zinc finger protein Xfin', NULL, NULL, NULL, NULL, NULL, 4),
(25837, NULL, 'G3DSA:1.10.560.10:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25838, NULL, 'G3DSA:1.10.418.10:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25839, NULL, 'G3DSA:1.20.58.390:FF:000157', NULL, NULL, 'Ionotropic GABA receptor subunit UNC-49C', NULL, NULL, NULL, NULL, NULL, 4),
(25840, NULL, 'G3DSA:2.60.40.10:FF:004177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25841, NULL, 'G3DSA:3.30.40.10:FF:001775', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(25842, NULL, 'G3DSA:3.30.2350.10:FF:000067', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(25843, NULL, 'G3DSA:3.30.70.120:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25844, NULL, 'G3DSA:2.120.10.30:FF:000125', NULL, NULL, 'Sugar lactone lactonase YvrE', NULL, NULL, NULL, NULL, NULL, 4),
(25845, NULL, 'G3DSA:3.40.190.10:FF:000468', NULL, NULL, 'Putative Dipeptide ABC transporter, periplasmic dipeptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(25846, NULL, 'G3DSA:3.40.50.720:FF:001751', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25847, NULL, 'G3DSA:3.30.60.20:FF:000032', NULL, NULL, 'rho guanine nucleotide exchange factor 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(25848, NULL, 'G3DSA:3.40.50.300:FF:003031', NULL, NULL, 'ATP-dependent 26S proteasome regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(25849, NULL, 'G3DSA:3.40.50.1820:FF:001299', NULL, NULL, 'Glr0885 protein', NULL, NULL, NULL, NULL, NULL, 4),
(25850, NULL, 'G3DSA:1.10.533.10:FF:000275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25851, NULL, 'G3DSA:3.40.50.300:FF:005104', NULL, NULL, 'Rad51, putative', NULL, NULL, NULL, NULL, NULL, 4),
(25852, NULL, 'G3DSA:3.90.132.10:FF:000014', NULL, NULL, 'GP63-like', NULL, NULL, NULL, NULL, NULL, 4),
(25853, NULL, 'G3DSA:1.10.150.240:FF:000002', NULL, NULL, 'Fructose-1-phosphate/6-phosphogluconate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(25854, NULL, 'G3DSA:3.30.70.3250:FF:000005', NULL, NULL, 'Ribonuclease P/MRP protein subunit POP5', NULL, NULL, NULL, NULL, NULL, 4),
(25855, NULL, 'G3DSA:3.50.50.60:FF:000424', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(25856, NULL, 'G3DSA:2.60.40.10:FF:004126', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25857, NULL, 'G3DSA:3.30.230.10:FF:000019', NULL, NULL, 'Lon protease homolog 2, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(25858, NULL, 'G3DSA:3.30.160.60:FF:003092', NULL, NULL, 'Si:dkey-14o6.4', NULL, NULL, NULL, NULL, NULL, 4),
(25859, NULL, 'G3DSA:3.30.830.10:FF:000037', NULL, NULL, 'Presequence protease 1', NULL, NULL, NULL, NULL, NULL, 4),
(25860, NULL, 'G3DSA:1.20.1250.20:FF:001179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25861, NULL, 'G3DSA:2.130.10.10:FF:004435', NULL, NULL, 'Actin-related protein 2/3 complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(25862, NULL, 'G3DSA:1.10.1380.10:FF:000002', NULL, NULL, 'Membrane metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(25863, NULL, 'G3DSA:3.20.20.140:FF:000030', NULL, NULL, 'Dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(25864, NULL, 'G3DSA:1.20.1220.12:FF:000002', NULL, NULL, 'Malate synthase G', NULL, NULL, NULL, NULL, NULL, 4),
(25865, NULL, 'G3DSA:3.30.428.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25866, NULL, 'G3DSA:2.60.210.10:FF:000072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25867, NULL, 'G3DSA:2.40.10.10:FF:000073', NULL, NULL, 'Trypsin alpha', NULL, NULL, NULL, NULL, NULL, 4),
(25868, NULL, 'G3DSA:3.30.160.60:FF:000686', NULL, NULL, 'Zinc finger protein 236 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(25869, NULL, 'G3DSA:3.30.40.10:FF:000207', NULL, NULL, 'RING-H2 finger protein ATL46-like', NULL, NULL, NULL, NULL, NULL, 4),
(25870, NULL, 'G3DSA:3.10.450.50:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25871, NULL, 'G3DSA:3.40.50.1100:FF:000184', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(25872, NULL, 'G3DSA:3.30.70.260:FF:000040', NULL, NULL, 'Glycine cleavage system transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(25873, NULL, 'G3DSA:2.40.160.110:FF:000025', NULL, NULL, 'AGAP001624-PA', NULL, NULL, NULL, NULL, NULL, 4),
(25874, NULL, 'G3DSA:3.20.20.150:FF:000033', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(25875, NULL, 'G3DSA:2.160.20.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25876, NULL, 'G3DSA:2.60.40.60:FF:000728', NULL, NULL, 'Si:dkey-22o22.2', NULL, NULL, NULL, NULL, NULL, 4),
(25877, NULL, 'G3DSA:3.40.1000.50:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25878, NULL, 'G3DSA:3.40.190.10:FF:000816', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25879, NULL, 'G3DSA:3.90.70.10:FF:000369', NULL, NULL, 'Deubiquitylating with USP/UBP and OTU domains', NULL, NULL, NULL, NULL, NULL, 4),
(25880, NULL, 'G3DSA:3.30.830.10:FF:000329', NULL, NULL, 'Pitrilysin metallepetidase 1 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(25881, NULL, 'G3DSA:1.25.40.10:FF:002186', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g18110, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(25882, NULL, 'G3DSA:1.10.400.10:FF:000062', NULL, NULL, 'Protein spalten', NULL, NULL, NULL, NULL, NULL, 4),
(25883, NULL, 'G3DSA:3.30.200.20:FF:002471', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25884, NULL, 'G3DSA:3.40.50.970:FF:000044', NULL, NULL, 'Putative acetolactate synthase IlvG', NULL, NULL, NULL, NULL, NULL, 4),
(25885, NULL, 'G3DSA:3.40.50.980:FF:000047', NULL, NULL, '4-chlorobenzoate--CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(25886, NULL, 'G3DSA:3.30.1360.200:FF:000013', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(25887, NULL, 'G3DSA:1.25.10.10:FF:002600', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25888, NULL, 'G3DSA:3.40.50.11900:FF:000005', NULL, NULL, '3-hydroxyacyl-ACP dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(25889, NULL, 'G3DSA:2.60.210.10:FF:000021', NULL, NULL, 'Tumor necrosis factor receptor-associated factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(25890, NULL, 'G3DSA:3.20.20.80:FF:000261', NULL, NULL, '4-alpha-glucanotransferase DPE2', NULL, NULL, NULL, NULL, NULL, 4),
(25891, NULL, 'G3DSA:3.30.499.10:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25892, NULL, 'G3DSA:3.80.10.10:FF:002423', NULL, NULL, 'Receptor like protein 45', NULL, NULL, NULL, NULL, NULL, 4),
(25893, NULL, 'G3DSA:3.40.50.150:FF:001260', NULL, NULL, 'Putative ribosomal RNA methyltransferase NOP2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(25894, NULL, 'G3DSA:1.10.510.10:FF:000525', NULL, NULL, 'SRSF protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(25895, NULL, 'G3DSA:2.40.50.140:FF:000305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25896, NULL, 'G3DSA:3.30.40.10:FF:001668', NULL, NULL, 'E3 ubiquitin-protein ligase CBL', NULL, NULL, NULL, NULL, NULL, 4),
(25897, NULL, 'G3DSA:3.30.70.850:FF:000003', NULL, NULL, 'neuroendocrine convertase 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(25898, NULL, 'G3DSA:3.90.1150.210:FF:000024', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(25899, NULL, 'G3DSA:2.60.220.50:FF:000011', NULL, NULL, 'adhesion G protein-coupled receptor A3', NULL, NULL, NULL, NULL, NULL, 4),
(25900, NULL, 'G3DSA:3.30.160.60:FF:000742', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25901, NULL, 'G3DSA:3.40.1000.30:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25902, NULL, 'G3DSA:1.20.1110.10:FF:000177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25903, NULL, 'G3DSA:3.90.550.10:FF:000721', NULL, NULL, 'Glycoside transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(25904, NULL, 'G3DSA:3.30.70.860:FF:000006', NULL, NULL, 'DUF406 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(25905, NULL, 'G3DSA:3.40.190.10:FF:000524', NULL, NULL, 'Putative glutamate receptor ionotropic kainate 5', NULL, NULL, NULL, NULL, NULL, 4),
(25906, NULL, 'G3DSA:2.60.40.3210:FF:000026', NULL, NULL, 'Zona pellucida glycoprotein 3a', NULL, NULL, NULL, NULL, NULL, 4),
(25907, NULL, 'G3DSA:1.20.1280.50:FF:000274', NULL, NULL, 'F-box/TPR repeat protein pof3', NULL, NULL, NULL, NULL, NULL, 4),
(25908, NULL, 'G3DSA:3.60.21.10:FF:000095', NULL, NULL, 'RNA lariat debranching enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(25909, NULL, 'G3DSA:3.80.10.10:FF:002530', NULL, NULL, 'Tubulin folding cofactor E', NULL, NULL, NULL, NULL, NULL, 4),
(25910, NULL, 'G3DSA:3.40.50.150:FF:000984', NULL, NULL, 'Malonyl-[acyl-carrier protein] O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(25911, NULL, 'G3DSA:1.10.10.10:FF:000447', NULL, NULL, 'RNA polymerase sigma factor SigF', NULL, NULL, NULL, NULL, NULL, 4),
(25912, NULL, 'G3DSA:3.40.50.10310:FF:000017', NULL, NULL, 'Creatininase', NULL, NULL, NULL, NULL, NULL, 4),
(25913, NULL, 'G3DSA:3.30.70.330:FF:002270', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25914, NULL, 'G3DSA:3.30.70.870:FF:000009', NULL, NULL, 'Translation elongation factor G', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(25915, NULL, 'G3DSA:1.10.287.1480:FF:000003', NULL, NULL, '28S ribosomal protein S14, mitochondrial-like', NULL, NULL, NULL, NULL, NULL, 4),
(25916, NULL, 'G3DSA:2.60.40.1760:FF:000001', NULL, NULL, 'Maltase-glucoamylase, intestinal', NULL, NULL, NULL, NULL, NULL, 4),
(25917, NULL, 'G3DSA:2.130.10.10:FF:004761', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25918, NULL, 'G3DSA:3.30.70.141:FF:000011', NULL, NULL, 'Nucleoside diphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(25919, NULL, 'G3DSA:1.10.510.10:FF:004454', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25920, NULL, 'G3DSA:3.50.4.10:FF:000006', NULL, NULL, 'Hepatocyte growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(25921, NULL, 'G3DSA:3.30.160.60:FF:004519', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25922, NULL, 'G3DSA:1.10.287.110:FF:000187', NULL, NULL, 'DPH4-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(25923, NULL, 'G3DSA:3.30.50.10:FF:000152', NULL, NULL, 'GATA zinc finger family protein', NULL, NULL, NULL, NULL, NULL, 4),
(25924, NULL, 'G3DSA:1.20.1250.20:FF:001797', NULL, NULL, 'Permease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(25925, NULL, 'G3DSA:2.60.40.60:FF:000791', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25926, NULL, 'G3DSA:2.40.70.10:FF:000576', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25927, NULL, 'G3DSA:3.55.50.30:FF:000023', NULL, NULL, 'Ferrioxamine B receptor', NULL, NULL, NULL, NULL, NULL, 4),
(25928, NULL, 'G3DSA:2.60.260.20:FF:000027', NULL, NULL, 'Chaperone protein dnaJ GFA2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(25929, NULL, 'G3DSA:2.70.150.10:FF:000143', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(25930, NULL, 'G3DSA:1.10.510.10:FF:000469', NULL, NULL, 'Serine/threonine-protein kinase 32B', NULL, NULL, NULL, NULL, NULL, 4),
(25931, NULL, 'G3DSA:1.10.510.10:FF:000183', NULL, NULL, 'Serine/threonine-protein kinase hal4', NULL, NULL, NULL, NULL, NULL, 4),
(25932, NULL, 'G3DSA:1.10.10.10:FF:000380', NULL, NULL, 'Transcription factor SKN7', NULL, NULL, NULL, NULL, NULL, 4),
(25933, NULL, 'G3DSA:1.10.10.1460:FF:000001', NULL, NULL, 'DNA replication regulator Sld2', NULL, NULL, NULL, NULL, NULL, 4),
(25934, NULL, 'G3DSA:2.60.40.10:FF:000815', NULL, NULL, 'Mast/stem cell growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(25935, NULL, 'G3DSA:2.60.40.10:FF:005020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25936, NULL, 'G3DSA:1.25.40.10:FF:002372', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At3g15200', NULL, NULL, NULL, NULL, NULL, 4),
(25937, NULL, 'G3DSA:2.60.40.10:FF:004738', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25938, NULL, 'G3DSA:3.40.50.670:FF:000016', NULL, NULL, 'DNA topoisomerase (ATP-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4),
(25939, NULL, 'G3DSA:3.40.50.1820:FF:001029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25940, NULL, 'G3DSA:3.40.50.300:FF:008382', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25941, NULL, 'G3DSA:1.20.58.1030:FF:000033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(25942, NULL, 'G3DSA:3.30.200.20:FF:002319', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25943, NULL, 'G3DSA:1.25.10.10:FF:000127', NULL, NULL, 'rap1 GTPase-GDP dissociation stimulator 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(25944, NULL, 'G3DSA:2.60.40.1450:FF:000003', NULL, NULL, 'Related to J kappa-recombination signal binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(25945, NULL, 'G3DSA:2.60.40.10:FF:004396', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25946, NULL, 'G3DSA:1.25.70.10:FF:000007', NULL, NULL, 'Mitochondrial transcription termination factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(25947, NULL, 'G3DSA:3.90.730.10:FF:000027', NULL, NULL, 'Ribonuclease 2', NULL, NULL, NULL, NULL, NULL, 4),
(25948, NULL, 'G3DSA:3.40.50.1000:FF:000603', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(25949, NULL, 'G3DSA:1.20.920.20:FF:000001', NULL, NULL, 'dynein heavy chain 2, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(25950, NULL, 'G3DSA:3.30.565.10:FF:000139', NULL, NULL, 'DNA mismatch repair protein (Mlh3), putative', NULL, NULL, NULL, NULL, NULL, 4),
(25951, NULL, 'G3DSA:2.60.40.1460:FF:000006', NULL, NULL, 'Integrin subunit alpha 11', NULL, NULL, NULL, NULL, NULL, 4),
(25952, NULL, 'G3DSA:3.90.25.70:FF:000002', NULL, NULL, 'Fatty acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(25953, NULL, 'G3DSA:2.60.40.790:FF:000049', NULL, NULL, 'Increased DNA methylation 3', NULL, NULL, NULL, NULL, NULL, 4),
(25954, NULL, 'G3DSA:1.25.40.10:FF:002927', NULL, NULL, 'RE67794p', NULL, NULL, NULL, NULL, NULL, 4),
(25955, NULL, 'G3DSA:3.90.79.10:FF:000294', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(25956, NULL, 'G3DSA:3.30.450.40:FF:000157', NULL, NULL, 'Histidine kinase osmosensor and regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(25957, NULL, 'G3DSA:3.90.550.10:FF:000665', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(25958, NULL, 'G3DSA:3.40.50.150:FF:000366', NULL, NULL, 'Chemotaxis protein methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(25959, NULL, 'G3DSA:1.20.58.670:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25960, NULL, 'G3DSA:1.10.274.100:FF:000034', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(25961, NULL, 'G3DSA:3.40.190.290:FF:000128', NULL, NULL, 'Transcriptional regulator of L-lactate utilization LldR', NULL, NULL, NULL, NULL, NULL, 4),
(25962, NULL, 'G3DSA:3.30.40.10:FF:002124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25963, NULL, 'G3DSA:1.10.472.10:FF:000245', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(25964, NULL, 'G3DSA:2.40.50.140:FF:000187', NULL, NULL, 'Replication protein A 14 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(25965, NULL, 'G3DSA:1.10.10.10:FF:000503', NULL, NULL, 'Cullin-1', NULL, NULL, NULL, NULL, NULL, 4),
(25966, NULL, 'G3DSA:3.30.830.10:FF:000256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25967, NULL, 'G3DSA:2.60.40.10:FF:003108', NULL, NULL, 'Sialic-acid binding protein-4', NULL, NULL, NULL, NULL, NULL, 4),
(25968, NULL, 'G3DSA:2.40.100.10:FF:000017', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(25969, NULL, 'G3DSA:3.40.50.2300:FF:000217', NULL, NULL, 'Piwi like RNA-mediated gene silencing 4', NULL, NULL, NULL, NULL, NULL, 4),
(25970, NULL, 'G3DSA:4.10.400.10:FF:000348', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25971, NULL, 'G3DSA:2.130.10.10:FF:004834', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25972, NULL, 'G3DSA:2.60.40.10:FF:001304', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(25973, NULL, 'G3DSA:3.40.1310.30:FF:000001', NULL, NULL, 'Replication protein RepB', NULL, NULL, NULL, NULL, NULL, 4),
(25974, NULL, 'G3DSA:2.40.30.130:FF:000028', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(25975, NULL, 'G3DSA:3.40.140.10:FF:000252', NULL, NULL, 'Putative deoxycytidylate deaminase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(25976, NULL, 'G3DSA:3.30.200.20:FF:001763', NULL, NULL, 'Inactive serine/threonine-protein kinase VRK3', NULL, NULL, NULL, NULL, NULL, 4),
(25977, NULL, 'G3DSA:2.60.120.20:FF:000011', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(25978, NULL, 'G3DSA:3.40.50.300:FF:004615', NULL, NULL, 'Xeroderma pigmentosum D', NULL, NULL, NULL, NULL, NULL, 4),
(25979, NULL, 'G3DSA:3.40.50.150:FF:000147', NULL, NULL, 'Caffeoyl-CoA O-methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(25980, NULL, 'G3DSA:2.60.120.40:FF:000017', NULL, NULL, 'Tumor necrosis factor ligand superfamily member 6', NULL, NULL, NULL, NULL, NULL, 4),
(25981, NULL, 'G3DSA:3.40.50.2000:FF:000122', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(25982, NULL, 'G3DSA:3.40.50.720:FF:000172', NULL, NULL, 'Bifunctional 3-dehydroquinate dehydratase/shikimate dehydrogenase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(25983, NULL, 'G3DSA:2.60.40.60:FF:001010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25984, NULL, 'G3DSA:1.20.1250.20:FF:002202', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(25985, NULL, 'G3DSA:1.10.490.10:FF:000005', NULL, NULL, 'Cytoglobin', NULL, NULL, NULL, NULL, NULL, 4),
(25986, NULL, 'G3DSA:3.40.47.10:FF:000104', NULL, NULL, 'Bisdemethoxycurcumin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(25987, NULL, 'G3DSA:3.30.160.60:FF:004396', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(25988, NULL, 'G3DSA:2.130.10.10:FF:000719', NULL, NULL, 'WD repeat-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(25989, NULL, 'G3DSA:2.60.40.2130:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25990, NULL, 'G3DSA:3.40.50.2000:FF:000392', NULL, NULL, '2-deoxystreptamine N-acetyl-D-glucosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(25991, NULL, 'G3DSA:2.130.10.10:FF:004216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(25992, NULL, 'G3DSA:3.30.200.20:FF:000346', NULL, NULL, 'PAS domain-containing serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(25993, NULL, 'G3DSA:1.10.1370.30:FF:000007', NULL, NULL, 'Dipeptidyl carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(25994, NULL, 'G3DSA:1.10.1070.11:FF:000064', NULL, NULL, 'PIKK family atypical protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(25995, NULL, 'G3DSA:2.30.250.10:FF:000002', NULL, NULL, 'Aspartyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(25996, NULL, 'G3DSA:3.30.160.60:FF:003210', NULL, NULL, 'GM26384', NULL, NULL, NULL, NULL, NULL, 4),
(25997, NULL, 'G3DSA:2.40.50.40:FF:000005', NULL, NULL, 'chromodomain-helicase-DNA-binding protein 8 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(25998, NULL, 'G3DSA:3.70.10.10:FF:000086', NULL, NULL, 'DNA repair protein rad9, putative', NULL, NULL, NULL, NULL, NULL, 4),
(25999, NULL, 'G3DSA:2.130.10.10:FF:000563', NULL, NULL, 'DDB1-and CUL4-associated factor 10', NULL, NULL, NULL, NULL, NULL, 4),
(26000, NULL, 'G3DSA:3.30.40.10:FF:001449', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26001, NULL, 'G3DSA:3.40.50.1440:FF:000151', NULL, NULL, 'Protein dml1', NULL, NULL, NULL, NULL, NULL, 4),
(26002, NULL, 'G3DSA:3.40.50.150:FF:000765', NULL, NULL, 'tRNA (guanine(37)-N1)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(26003, NULL, 'G3DSA:3.40.50.1820:FF:001248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26004, NULL, 'G3DSA:3.40.50.2020:FF:000128', NULL, NULL, 'Uracil phosphoribosyltransferase-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(26005, NULL, 'G3DSA:1.10.10.60:FF:000552', NULL, NULL, 'LIM homeobox transcription factor 1 beta', NULL, NULL, NULL, NULL, NULL, 4),
(26006, NULL, 'G3DSA:2.130.10.10:FF:004486', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(26007, NULL, 'G3DSA:3.40.50.880:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26008, NULL, 'G3DSA:1.10.510.10:FF:004179', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26009, NULL, 'G3DSA:3.40.50.10130:FF:000059', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(26010, NULL, 'G3DSA:2.10.25.10:FF:001592', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26011, NULL, 'G3DSA:1.10.150.60:FF:000017', NULL, NULL, 'ARID/BRIGHT domain protein (SWI1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(26012, NULL, 'G3DSA:1.10.1370.10:FF:000001', NULL, NULL, 'Thimet oligopeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(26013, NULL, 'G3DSA:1.25.10.10:FF:002651', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26014, NULL, 'G3DSA:3.30.70.20:FF:000038', NULL, NULL, 'Adenylylsulfate reductase subunit beta', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(26015, NULL, 'G3DSA:1.10.420.10:FF:000024', NULL, NULL, 'L-ascorbate peroxidase 2 cytosolic', NULL, NULL, NULL, NULL, NULL, 4),
(26016, NULL, 'G3DSA:1.20.1070.10:FF:000010', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(26017, NULL, 'G3DSA:2.60.40.10:FF:000467', NULL, NULL, 'Myomesin 1', NULL, NULL, NULL, NULL, NULL, 4),
(26018, NULL, 'G3DSA:3.10.20.90:FF:000079', NULL, NULL, 'Putative FERM domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(26019, NULL, 'G3DSA:1.20.120.1240:FF:000025', NULL, NULL, 'Dynamin-related protein 1E', NULL, NULL, NULL, NULL, NULL, 4),
(26020, NULL, 'G3DSA:3.40.50.11960:FF:000001', NULL, NULL, 'alpha- and gamma-adaptin-binding protein p34 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(26021, NULL, 'G3DSA:3.90.79.10:FF:000237', NULL, NULL, 'Hydrolase, NUDIX family protein', NULL, NULL, NULL, NULL, NULL, 4),
(26022, NULL, 'G3DSA:2.40.50.140:FF:000018', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(26023, NULL, 'G3DSA:1.20.1250.20:FF:001415', NULL, NULL, 'Major facilitator superfamily MFS_1', NULL, NULL, NULL, NULL, NULL, 4),
(26024, NULL, 'G3DSA:3.40.50.300:FF:007072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26025, NULL, 'G3DSA:2.40.50.430:FF:000004', NULL, NULL, 'Related to HYS2-DNA-directed DNA polymerase delta, 55 KD subunit', NULL, NULL, NULL, NULL, NULL, 4),
(26026, NULL, 'G3DSA:3.30.40.10:FF:002231', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(26027, NULL, 'G3DSA:3.40.50.300:FF:004380', NULL, NULL, 'Rab_C52 protein', NULL, NULL, NULL, NULL, NULL, 4),
(26028, NULL, 'G3DSA:3.30.160.60:FF:005121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26029, NULL, 'G3DSA:2.80.10.50:FF:000173', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(26030, NULL, 'G3DSA:2.60.260.20:FF:000173', NULL, NULL, 'Dnaj-like protein subfamily B member 1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(26031, NULL, 'G3DSA:3.40.50.11660:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26032, NULL, 'G3DSA:1.10.150.240:FF:000058', NULL, NULL, 'Trehalose-6-phosphate phosphatase OtsB', NULL, NULL, NULL, NULL, NULL, 4),
(26033, NULL, 'G3DSA:3.30.200.20:FF:002544', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26034, NULL, 'G3DSA:1.20.1250.20:FF:001359', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26035, NULL, 'G3DSA:3.30.70.330:FF:000645', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(26036, NULL, 'G3DSA:1.20.120.20:FF:000030', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(26037, NULL, 'G3DSA:1.10.10.10:FF:002072', NULL, NULL, 'Transcriptional activator of tryptophan biosynthesis TrpI', NULL, NULL, NULL, NULL, NULL, 4),
(26038, NULL, 'G3DSA:1.10.510.10:FF:002942', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26039, NULL, 'G3DSA:2.130.10.10:FF:004609', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26040, NULL, 'G3DSA:1.10.1200.270:FF:000038', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(26041, NULL, 'G3DSA:3.90.70.10:FF:000656', NULL, NULL, 'PAN2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(26042, NULL, 'G3DSA:2.10.50.30:FF:000037', NULL, NULL, 'Si:ch1073-155h21.1', NULL, NULL, NULL, NULL, NULL, 4),
(26043, NULL, 'G3DSA:3.40.50.150:FF:000771', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26044, NULL, 'G3DSA:3.30.70.330:FF:000701', NULL, NULL, 'Putative RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(26045, NULL, 'G3DSA:3.30.200.20:FF:001982', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26046, NULL, 'G3DSA:1.10.10.10:FF:000891', NULL, NULL, 'DeoR/GlpR transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(26047, NULL, 'G3DSA:3.30.70.60:FF:000027', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(26048, NULL, 'G3DSA:1.25.40.10:FF:001697', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(26049, NULL, 'G3DSA:1.10.418.10:FF:000024', NULL, NULL, 'Hook homolog 3 (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(26050, NULL, 'G3DSA:3.40.50.720:FF:001925', NULL, NULL, 'Ornithine cyclodeaminase (ArcB)', NULL, NULL, NULL, NULL, NULL, 4),
(26051, NULL, 'G3DSA:2.120.10.80:FF:000393', NULL, NULL, 'Klhl4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(26052, NULL, 'G3DSA:2.30.180.10:FF:000058', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(26053, NULL, 'G3DSA:2.60.40.60:FF:000167', NULL, NULL, 'Cadherin 16', NULL, NULL, NULL, NULL, NULL, 4),
(26054, NULL, 'G3DSA:1.10.510.10:FF:001306', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase TDR', NULL, NULL, NULL, NULL, NULL, 4),
(26055, NULL, 'G3DSA:3.40.50.300:FF:008595', NULL, NULL, 'AGAP012537-PA', NULL, NULL, NULL, NULL, NULL, 4),
(26056, NULL, 'G3DSA:3.80.10.10:FF:003109', NULL, NULL, 'Os08g0191300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(26057, NULL, 'G3DSA:3.30.40.10:FF:000090', NULL, NULL, 'Mex-3 RNA-binding family member C', NULL, NULL, NULL, NULL, NULL, 4),
(26058, NULL, 'G3DSA:3.90.25.10:FF:000006', NULL, NULL, 'GDP-mannose 3,5-epimerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(26059, NULL, 'G3DSA:3.40.50.1820:FF:001809', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26060, NULL, 'G3DSA:2.60.40.10:FF:000742', NULL, NULL, 'neural cell adhesion molecule L1-like protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(26061, NULL, 'G3DSA:3.40.50.300:FF:002867', NULL, NULL, 'Serine/threonine-protein kinase PknK', NULL, NULL, NULL, NULL, NULL, 4),
(26062, NULL, 'G3DSA:1.10.3710.10:FF:000006', NULL, NULL, 'MgsA AAA+ ATPase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(26063, NULL, 'G3DSA:1.20.1250.20:FF:002022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26064, NULL, 'G3DSA:1.20.120.330:FF:000037', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(26065, NULL, 'G3DSA:3.30.420.100:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26066, NULL, 'G3DSA:3.40.50.10860:FF:000047', NULL, NULL, 'Shikimate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(26067, NULL, 'G3DSA:1.10.510.10:FF:000851', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(26068, NULL, 'G3DSA:2.40.30.10:FF:000304', NULL, NULL, 'Putative translation elongation/initiation factor family protein', NULL, NULL, NULL, NULL, NULL, 4),
(26069, NULL, 'G3DSA:3.30.200.20:FF:000397', NULL, NULL, 'Serine/threonine-protein kinase LATS1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(26070, NULL, 'G3DSA:3.40.50.920:FF:000018', NULL, NULL, 'Pyruvate dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(26071, NULL, 'G3DSA:3.80.10.10:FF:001928', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26072, NULL, 'G3DSA:1.25.40.10:FF:001062', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(26073, NULL, 'G3DSA:6.20.370.150:FF:000001', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(26074, NULL, 'G3DSA:1.10.3630.10:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26075, NULL, 'G3DSA:1.20.1080.10:FF:000128', NULL, NULL, 'Aquaporin PIP1-6', NULL, NULL, NULL, NULL, NULL, 4),
(26076, NULL, 'G3DSA:2.40.330.10:FF:000006', NULL, NULL, 'B3 domain-containing transcription repressor VAL1', NULL, NULL, NULL, NULL, NULL, 4),
(26077, NULL, 'G3DSA:1.10.238.10:FF:000818', NULL, NULL, 'Calmodulin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(26078, NULL, 'G3DSA:3.10.350.10:FF:000100', NULL, NULL, 'Lipoprotein NlpD', NULL, NULL, NULL, NULL, NULL, 4),
(26079, NULL, 'G3DSA:3.40.50.10540:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26080, NULL, 'G3DSA:2.60.120.260:FF:000220', NULL, NULL, 'E3 ubiquitin-protein ligase HERC2', NULL, NULL, NULL, NULL, NULL, 4),
(26081, NULL, 'G3DSA:2.30.30.100:FF:000033', NULL, NULL, 'Trailer hitch, isoform C', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(26082, NULL, 'G3DSA:2.60.260.20:FF:000134', NULL, NULL, 'Chaperone protein DNAj, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26083, NULL, 'G3DSA:2.60.40.10:FF:000416', NULL, NULL, 'Sortilin related receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(26084, NULL, 'G3DSA:3.90.550.10:FF:000608', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26085, NULL, 'G3DSA:1.25.40.10:FF:004513', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26086, NULL, 'G3DSA:2.60.40.1260:FF:000008', NULL, NULL, 'Lamin tail domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(26087, NULL, 'G3DSA:2.60.120.260:FF:000164', NULL, NULL, 'Stage II sporulation protein E', NULL, NULL, NULL, NULL, NULL, 4),
(26088, NULL, 'G3DSA:3.40.50.300:FF:008269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26089, NULL, 'G3DSA:2.130.10.10:FF:001001', NULL, NULL, 'Nup133', NULL, NULL, NULL, NULL, NULL, 4),
(26090, NULL, 'G3DSA:3.90.1150.10:FF:000162', NULL, NULL, 'Serine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(26091, NULL, 'G3DSA:3.40.50.2300:FF:001634', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26092, NULL, 'G3DSA:3.30.40.10:FF:000033', NULL, NULL, 'Polycomb group RING finger protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(26093, NULL, 'G3DSA:3.40.50.300:FF:002923', NULL, NULL, 'Structural maintenance of chromosomes protein', NULL, NULL, NULL, NULL, NULL, 4),
(26094, NULL, 'G3DSA:2.120.10.80:FF:000117', NULL, NULL, 'Negative regulator of sporulation MDS3', NULL, NULL, NULL, NULL, NULL, 4),
(26095, NULL, 'G3DSA:4.10.260.20:FF:000002', NULL, NULL, 'Periplasmic [Fe] hydrogenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(26096, NULL, 'G3DSA:2.40.70.10:FF:000407', NULL, NULL, 'Aspartic peptidase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(26097, NULL, 'G3DSA:3.30.160.60:FF:000916', NULL, NULL, 'Zinc finger protein 668', NULL, NULL, NULL, NULL, NULL, 4),
(26098, NULL, 'G3DSA:2.30.29.30:FF:000801', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(26099, NULL, 'G3DSA:1.10.510.10:FF:002829', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26100, NULL, 'G3DSA:2.130.10.10:FF:004722', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26101, NULL, 'G3DSA:3.30.70.2760:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26102, NULL, 'G3DSA:1.10.10.2590:FF:000003', NULL, NULL, 'BEN domain-containing protein 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(26103, NULL, 'G3DSA:3.30.497.10:FF:000149', NULL, NULL, 'Serine (or cysteine) peptidase inhibitor, clade B, member 9c', NULL, NULL, NULL, NULL, NULL, 4),
(26104, NULL, 'G3DSA:3.80.10.10:FF:004003', NULL, NULL, 'Zgc:77346', NULL, NULL, NULL, NULL, NULL, 4),
(26105, NULL, 'G3DSA:3.30.2090.10:FF:000030', NULL, NULL, 'Heavy metal efflux pump permease component CzcA family', NULL, NULL, NULL, NULL, NULL, 4),
(26106, NULL, 'G3DSA:3.40.50.720:FF:002532', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26107, NULL, 'G3DSA:3.40.50.300:FF:008319', NULL, NULL, 'NLR family, CARD domain-containing 3-like', NULL, NULL, NULL, NULL, NULL, 4),
(26108, NULL, 'G3DSA:3.40.50.150:FF:000714', NULL, NULL, 'Defense against restriction protein B', NULL, NULL, NULL, NULL, NULL, 4),
(26109, NULL, 'G3DSA:1.20.140.40:FF:000037', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(26110, NULL, 'G3DSA:3.60.15.10:FF:000092', NULL, NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(26111, NULL, 'G3DSA:3.30.1370.10:FF:000063', NULL, NULL, 'A-kinase anchor protein 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(26112, NULL, 'G3DSA:3.30.40.10:FF:001337', NULL, NULL, 'PHD transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(26113, NULL, 'G3DSA:1.10.3430.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26114, NULL, 'G3DSA:2.40.30.10:FF:000248', NULL, NULL, 'G1 to S phase transition protein 1, putative', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(26115, NULL, 'G3DSA:2.60.120.260:FF:000107', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(26116, NULL, 'G3DSA:3.30.40.10:FF:002118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26117, NULL, 'G3DSA:3.10.20.90:FF:000927', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26118, NULL, 'G3DSA:1.25.40.20:FF:001121', NULL, NULL, 'Kinase, NEK-frag', NULL, NULL, NULL, NULL, NULL, 4),
(26119, NULL, 'G3DSA:3.30.160.60:FF:005008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26120, NULL, 'G3DSA:3.40.50.300:FF:000782', NULL, NULL, 'Putative ABC transporter ATP-binding component', NULL, NULL, NULL, NULL, NULL, 4),
(26121, NULL, 'G3DSA:3.30.160.60:FF:001523', NULL, NULL, 'Zinc finger and BTB domain containing 12', NULL, NULL, NULL, NULL, NULL, 4),
(26122, NULL, 'G3DSA:3.90.190.20:FF:000005', NULL, NULL, 'Dihydrofolate synthase/folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(26123, NULL, 'G3DSA:3.40.50.80:FF:000155', NULL, NULL, 'NADH-cytochrome b5 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(26124, NULL, 'G3DSA:2.60.40.10:FF:001310', NULL, NULL, 'HERV-H LTR-associating 2', NULL, NULL, NULL, NULL, NULL, 4),
(26125, NULL, 'G3DSA:3.50.7.10:FF:000092', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26126, NULL, 'G3DSA:1.25.10.10:FF:000565', NULL, NULL, 'Importin beta-like', NULL, NULL, NULL, NULL, NULL, 4),
(26127, NULL, 'G3DSA:2.60.40.1250:FF:000005', NULL, NULL, 'Thiol:disulfide interchange protein DsbD', NULL, NULL, NULL, NULL, NULL, 4),
(26128, NULL, 'G3DSA:3.30.1370.10:FF:000006', NULL, NULL, 'Ribonuclease Y', NULL, NULL, NULL, NULL, NULL, 4),
(26129, NULL, 'G3DSA:1.10.510.10:FF:000795', NULL, NULL, 'CAMK/CAMKL protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(26130, NULL, 'G3DSA:1.10.1420.10:FF:000118', NULL, NULL, 'DNA mismatch repair protein MSH3', NULL, NULL, NULL, NULL, NULL, 4),
(26131, NULL, 'G3DSA:2.40.50.140:FF:000131', NULL, NULL, 'Eukaryotic translation initiation factor 1A', NULL, NULL, NULL, NULL, NULL, 4),
(26132, NULL, 'G3DSA:1.10.510.10:FF:000738', NULL, NULL, 'Cdc2-related protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(26133, NULL, 'G3DSA:2.40.30.10:FF:000287', NULL, NULL, 'RPL3 isoform 5', NULL, NULL, NULL, NULL, NULL, 4),
(26134, NULL, 'G3DSA:3.90.190.10:FF:000002', NULL, NULL, 'receptor-type tyrosine-protein phosphatase delta isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(26135, NULL, 'G3DSA:3.50.7.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26136, NULL, 'G3DSA:3.10.120.10:FF:000055', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(26137, NULL, 'G3DSA:3.40.50.720:FF:000402', NULL, NULL, 'NAD-dependent dihydrogenase, Gfo/Idh/MocA family', NULL, NULL, NULL, NULL, NULL, 4),
(26138, NULL, 'G3DSA:1.10.238.10:FF:000931', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26139, NULL, 'G3DSA:1.25.10.10:FF:001869', NULL, NULL, 'Anaphase-promoting complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(26140, NULL, 'G3DSA:1.10.287.110:FF:000479', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26141, NULL, 'G3DSA:2.130.10.10:FF:006015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26142, NULL, 'G3DSA:1.10.287.110:FF:000367', NULL, NULL, 'DnaJ-like protein subfamily C member 3', NULL, NULL, NULL, NULL, NULL, 4),
(26143, NULL, 'G3DSA:3.50.50.60:FF:000750', NULL, NULL, 'Dihydropyrimidine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(26144, NULL, 'G3DSA:3.30.110.30:FF:000011', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(26145, NULL, 'G3DSA:1.25.40.20:FF:001008', NULL, NULL, 'Trpv6 protein', NULL, NULL, NULL, NULL, NULL, 4),
(26146, NULL, 'G3DSA:1.10.220.10:FF:000076', NULL, NULL, 'AGAP012930-PA', NULL, NULL, NULL, NULL, NULL, 4),
(26147, NULL, 'G3DSA:3.40.50.2000:FF:000009', NULL, NULL, 'Sterol 3-beta-glucosyltransferase UGT80A2', NULL, NULL, NULL, NULL, NULL, 4),
(26148, NULL, 'G3DSA:1.10.20.10:FF:000099', NULL, NULL, 'nuclear transcription factor Y subunit beta', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(26149, NULL, 'G3DSA:1.10.530.10:FF:000066', NULL, NULL, 'Probable endopeptidase YddH', NULL, NULL, NULL, NULL, NULL, 4),
(26150, NULL, 'G3DSA:2.30.29.30:FF:001370', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(26151, NULL, 'G3DSA:2.60.40.10:FF:002597', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(26152, NULL, 'G3DSA:1.10.3430.10:FF:000024', NULL, NULL, 'Putative ammonium transporter 4 member 1', NULL, NULL, NULL, NULL, NULL, 4),
(26153, NULL, 'G3DSA:3.30.160.60:FF:004227', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26154, NULL, 'G3DSA:1.25.40.690:FF:000002', NULL, NULL, 'Nuclear pore complex protein NUP96', NULL, NULL, NULL, NULL, NULL, 4),
(26155, NULL, 'G3DSA:1.20.58.2050:FF:000007', NULL, NULL, 'DNA replication complex GINS protein PSF3', NULL, NULL, NULL, NULL, NULL, 4),
(26156, NULL, 'G3DSA:2.40.70.10:FF:000464', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26157, NULL, 'G3DSA:3.40.50.300:FF:008376', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(26158, NULL, 'G3DSA:3.40.50.150:FF:000658', NULL, NULL, 'Anamorsin', NULL, NULL, NULL, NULL, NULL, 4),
(26159, NULL, 'G3DSA:2.60.40.1460:FF:000012', NULL, NULL, 'Integrin alpha ina-1', NULL, NULL, NULL, NULL, NULL, 4),
(26160, NULL, 'G3DSA:3.80.10.10:FF:001075', NULL, NULL, 'Leucine rich repeat containing 8 VRAC subunit Db', NULL, NULL, NULL, NULL, NULL, 4),
(26161, NULL, 'G3DSA:3.80.10.10:FF:001187', NULL, NULL, 'Acid labile subunit', NULL, NULL, NULL, NULL, NULL, 4),
(26162, NULL, 'G3DSA:2.20.100.10:FF:000044', NULL, NULL, 'Thrombospondin type 1 domain containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(26163, NULL, 'G3DSA:2.130.10.10:FF:002687', NULL, NULL, 'Wdr-12', NULL, NULL, NULL, NULL, NULL, 4),
(26164, NULL, 'G3DSA:1.10.472.10:FF:000071', NULL, NULL, 'cyclin-related protein FAM58A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(26165, NULL, 'G3DSA:3.20.20.210:FF:000017', NULL, NULL, 'Uroporphyrinogen decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(26166, NULL, 'G3DSA:1.10.287.70:FF:000669', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26167, NULL, 'G3DSA:3.30.160.60:FF:005975', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26168, NULL, 'G3DSA:1.25.40.10:FF:002422', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(26169, NULL, 'G3DSA:3.10.450.10:FF:000046', NULL, NULL, 'AGAP002879-PA', NULL, NULL, NULL, NULL, NULL, 4),
(26170, NULL, 'G3DSA:1.25.40.10:FF:004496', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26171, NULL, 'G3DSA:1.10.10.60:FF:000259', NULL, NULL, 'MYB transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(26172, NULL, 'G3DSA:3.40.50.150:FF:000439', NULL, NULL, 'Anamorsin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(26173, NULL, 'G3DSA:3.90.550.10:FF:000715', NULL, NULL, 'Putative polyprenol phosphate mannosyl transferase 1 (Ppm1)', NULL, NULL, NULL, NULL, NULL, 4),
(26174, NULL, 'G3DSA:1.20.1250.10:FF:000052', NULL, NULL, 'Interleukin-3', NULL, NULL, NULL, NULL, NULL, 4),
(26175, NULL, 'G3DSA:2.30.30.140:FF:000197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26176, NULL, 'G3DSA:3.20.140.10:FF:000003', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(26177, NULL, 'G3DSA:1.25.40.180:FF:000231', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26178, NULL, 'G3DSA:3.90.290.10:FF:000004', NULL, NULL, 'latent-transforming growth factor beta-binding protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(26179, NULL, 'G3DSA:3.40.50.300:FF:005796', NULL, NULL, 'DNA replication licensing factor, MCM2/3/5 family', NULL, NULL, NULL, NULL, NULL, 4),
(26180, NULL, 'G3DSA:2.120.10.80:FF:000336', NULL, NULL, 'Novel protein', NULL, NULL, NULL, NULL, NULL, 4),
(26181, NULL, 'G3DSA:2.70.170.10:FF:000144', NULL, NULL, 'Transmembrane ion channel', NULL, NULL, NULL, NULL, NULL, 4),
(26182, NULL, 'G3DSA:1.20.1250.20:FF:000055', NULL, NULL, 'Facilitated trehalose transporter Tret1-2 homolog', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(26183, NULL, 'G3DSA:1.10.10.10:FF:000672', NULL, NULL, 'Iron dependent repressor', NULL, NULL, NULL, NULL, NULL, 4),
(26184, NULL, 'G3DSA:3.40.50.80:FF:000211', NULL, NULL, 'Iron-chelator utilization protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26185, NULL, 'G3DSA:1.10.238.10:FF:000875', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26186, NULL, 'G3DSA:1.10.10.10:FF:000615', NULL, NULL, 'Transcriptional regulator, AsnC family', NULL, NULL, NULL, NULL, NULL, 4),
(26187, NULL, 'G3DSA:1.20.1250.20:FF:001691', NULL, NULL, 'Esterase-6-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(26188, NULL, 'G3DSA:2.60.40.10:FF:000523', NULL, NULL, 'obscurin isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(26189, NULL, 'G3DSA:3.40.50.300:FF:004048', NULL, NULL, 'Circularly permutated Ras protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(26190, NULL, 'G3DSA:2.60.40.10:FF:001130', NULL, NULL, 'tyrosine-protein phosphatase Lar isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(26191, NULL, 'G3DSA:3.40.50.2000:FF:000066', NULL, NULL, 'UDP-glucuronosyltransferase 1-1', NULL, NULL, NULL, NULL, NULL, 4),
(26192, NULL, 'G3DSA:3.40.140.10:FF:000196', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(26193, NULL, 'G3DSA:2.40.40.10:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26194, NULL, 'G3DSA:2.60.40.60:FF:000908', NULL, NULL, 'Protocadherin 20', NULL, NULL, NULL, NULL, NULL, 4),
(26195, NULL, 'G3DSA:3.30.1390.10:FF:000007', NULL, NULL, '50S ribosomal protein L12, apicoplast', NULL, NULL, NULL, NULL, NULL, 4),
(26196, NULL, 'G3DSA:1.25.10.10:FF:000852', NULL, NULL, 'Importin alpha re-exporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26197, NULL, 'G3DSA:1.25.40.630:FF:000006', NULL, NULL, 'Cleavage and termination factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(26198, NULL, 'G3DSA:3.40.190.10:FF:000704', NULL, NULL, 'Periplasmic substrate binding protein family 1', NULL, NULL, NULL, NULL, NULL, 4),
(26199, NULL, 'G3DSA:3.10.20.10:FF:000038', NULL, NULL, 'Cell death-inducing DFFA-like effector c', NULL, NULL, NULL, NULL, NULL, 4),
(26200, NULL, 'G3DSA:1.25.40.20:FF:001065', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(26201, NULL, 'G3DSA:3.10.350.10:FF:000044', NULL, NULL, 'Peptidase, M23 family', NULL, NULL, NULL, NULL, NULL, 4),
(26202, NULL, 'G3DSA:1.25.10.10:FF:002544', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26203, NULL, 'G3DSA:1.20.1300.10:FF:000006', NULL, NULL, 'Succinate dehydrogenase cytochrome b560 subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(26204, NULL, 'G3DSA:1.20.1070.10:FF:002140', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(26205, NULL, 'G3DSA:3.30.450.70:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26206, NULL, 'G3DSA:3.10.110.10:FF:000228', NULL, NULL, 'Ubiquitin-conjugating enzyme E2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26207, NULL, 'G3DSA:2.10.25.10:FF:001827', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26208, NULL, 'G3DSA:2.60.60.30:FF:000007', NULL, NULL, 'General stress protein 16U', NULL, NULL, NULL, NULL, NULL, 4),
(26209, NULL, 'G3DSA:3.40.50.150:FF:000591', NULL, NULL, 'Methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(26210, NULL, 'G3DSA:1.10.472.130:FF:000093', NULL, NULL, 'Cytoplasmic dynein heavy chain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(26211, NULL, 'G3DSA:3.30.160.60:FF:002209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26212, NULL, 'G3DSA:3.30.360.50:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26213, NULL, 'G3DSA:3.40.50.2300:FF:001578', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26214, NULL, 'G3DSA:1.20.120.530:FF:000002', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(26215, NULL, 'G3DSA:3.40.640.10:FF:000453', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26216, NULL, 'G3DSA:3.90.1150.10:FF:000049', NULL, NULL, 'Alanine-glyoxylate aminotransferase 1', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(26217, NULL, 'G3DSA:3.20.80.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26218, NULL, 'G3DSA:3.30.360.30:FF:000001', NULL, NULL, 'Homospermidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(26219, NULL, 'G3DSA:1.20.120.350:FF:000156', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26220, NULL, 'G3DSA:1.10.472.10:FF:000632', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26221, NULL, 'G3DSA:3.30.160.60:FF:006470', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26222, NULL, 'G3DSA:1.25.10.10:FF:000453', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26223, NULL, 'G3DSA:3.30.60.20:FF:000088', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(26224, NULL, 'G3DSA:2.120.10.30:FF:000417', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26225, NULL, 'G3DSA:3.90.1100.10:FF:000046', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(26226, NULL, 'G3DSA:3.30.200.20:FF:000453', NULL, NULL, 'Calcium/calmodulin-dependent protein kinase type 1G', NULL, NULL, NULL, NULL, NULL, 4),
(26227, NULL, 'G3DSA:2.60.40.150:FF:000324', NULL, NULL, 'Rab-3-interacting molecule unc-10', NULL, NULL, NULL, NULL, NULL, 4),
(26228, NULL, 'G3DSA:3.40.50.1820:FF:001355', NULL, NULL, 'Esterase/lipase/thioesterase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(26229, NULL, 'G3DSA:3.30.710.10:FF:000039', NULL, NULL, 'Zinc finger and BTB domain containing 20', NULL, NULL, NULL, NULL, NULL, 4),
(26230, NULL, 'G3DSA:3.40.50.300:FF:006414', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26231, NULL, 'G3DSA:1.10.150.20:FF:000141', NULL, NULL, 'Holliday junction ATP-dependent DNA helicase RuvA', NULL, NULL, NULL, NULL, NULL, 4),
(26232, NULL, 'G3DSA:1.10.10.60:FF:000591', NULL, NULL, 'Transcriptional regulator, AraC/XylS family', NULL, NULL, NULL, NULL, NULL, 4),
(26233, NULL, 'G3DSA:3.40.20.10:FF:000003', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(26234, NULL, 'G3DSA:1.25.40.10:FF:002079', NULL, NULL, 'GD12338', NULL, NULL, NULL, NULL, NULL, 4),
(26235, NULL, 'G3DSA:1.10.3210.10:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26236, NULL, 'G3DSA:1.20.120.420:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26237, NULL, 'G3DSA:3.90.79.10:FF:000125', NULL, NULL, 'Probable nudix hydrolase C6G9.05', NULL, NULL, NULL, NULL, NULL, 4),
(26238, NULL, 'G3DSA:3.60.130.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26239, NULL, 'G3DSA:1.10.1410.10:FF:000056', NULL, NULL, 'Speckle targeted PIP5K1A-regulated poly(A) polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(26240, NULL, 'G3DSA:1.10.506.10:FF:000072', NULL, NULL, 'Plexin B3', NULL, NULL, NULL, NULL, NULL, 4),
(26241, NULL, 'G3DSA:3.30.559.10:FF:000029', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(26242, NULL, 'G3DSA:1.10.238.10:FF:000656', NULL, NULL, 'Dynein light chain', NULL, NULL, NULL, NULL, NULL, 4),
(26243, NULL, 'G3DSA:1.25.40.20:FF:000683', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26244, NULL, 'G3DSA:3.20.20.220:FF:000077', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(26245, NULL, 'G3DSA:1.10.533.10:FF:000269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26246, NULL, 'G3DSA:1.10.510.10:FF:000918', NULL, NULL, 'Kinase, Wnk', NULL, NULL, NULL, NULL, NULL, 4),
(26247, NULL, 'G3DSA:2.10.110.10:FF:000266', NULL, NULL, 'Insulin gene enhancer protein ISL-1', NULL, NULL, NULL, NULL, NULL, 4),
(26248, NULL, 'G3DSA:1.25.40.10:FF:000680', NULL, NULL, 'Pre-mRNA-splicing factor SYF1', NULL, NULL, NULL, NULL, NULL, 4),
(26249, NULL, 'G3DSA:1.10.472.10:FF:000290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26250, NULL, 'G3DSA:4.10.60.10:FF:000033', NULL, NULL, 'Glycine-rich RNA-binding protein RZ1C', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(26251, NULL, 'G3DSA:2.60.40.1510:FF:000050', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(26252, NULL, 'G3DSA:2.60.40.150:FF:000088', NULL, NULL, 'multiple C2 and transmembrane domain-containing protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(26253, NULL, 'G3DSA:3.40.50.1480:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26254, NULL, 'G3DSA:2.40.240.20:FF:000002', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4),
(26255, NULL, 'G3DSA:2.30.30.40:FF:000437', NULL, NULL, 'Chromosome 16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(26256, NULL, 'G3DSA:1.10.470.10:FF:000010', NULL, NULL, 'Variant surface glycoprotein (VSG, atypical), putative', NULL, NULL, NULL, NULL, NULL, 4),
(26257, NULL, 'G3DSA:2.130.10.10:FF:002305', NULL, NULL, 'Pwp1p', NULL, NULL, NULL, NULL, NULL, 4),
(26258, NULL, 'G3DSA:3.90.320.10:FF:000041', NULL, NULL, 'Sll1582 protein', NULL, NULL, NULL, NULL, NULL, 4),
(26259, NULL, 'G3DSA:3.30.430.20:FF:000004', NULL, NULL, 'Receptor-like serine-threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(26260, NULL, 'G3DSA:2.120.10.30:FF:000075', NULL, NULL, 'S9 family peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(26261, NULL, 'G3DSA:3.40.50.12780:FF:000123', NULL, NULL, 'Nonribosomal peptide synthetase fmqC', NULL, NULL, NULL, NULL, NULL, 4),
(26262, NULL, 'G3DSA:1.10.287.3700:FF:000006', NULL, NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', NULL, NULL, NULL, NULL, NULL, 4),
(26263, NULL, 'G3DSA:2.40.10.10:FF:000359', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26264, NULL, 'G3DSA:1.10.472.10:FF:000576', NULL, NULL, 'Cyclin D, copy B-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(26265, NULL, 'G3DSA:2.170.140.10:FF:000045', NULL, NULL, 'GD12760', NULL, NULL, NULL, NULL, NULL, 4),
(26266, NULL, 'G3DSA:3.10.129.10:FF:000142', NULL, NULL, 'Acyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(26267, NULL, 'G3DSA:1.25.40.20:FF:001301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26268, NULL, 'G3DSA:1.20.5.580:FF:000001', NULL, NULL, 'Complexin 2', NULL, NULL, NULL, NULL, NULL, 4),
(26269, NULL, 'G3DSA:3.40.50.720:FF:002313', NULL, NULL, 'Putative 2-hydroxyacid dehydrogenase C1773.17c', NULL, NULL, NULL, NULL, NULL, 4),
(26270, NULL, 'G3DSA:3.80.10.10:FF:004222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26271, NULL, 'G3DSA:3.30.1370.170:FF:000005', NULL, NULL, 'Erythronate-4-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(26272, NULL, 'G3DSA:2.40.70.10:FF:000245', NULL, NULL, 'Nuclear receptor interacting protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(26273, NULL, 'G3DSA:3.80.30.20:FF:000005', NULL, NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(26274, NULL, 'G3DSA:3.30.160.60:FF:002827', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(26275, NULL, 'G3DSA:1.10.238.10:FF:000370', NULL, NULL, 'Mitochondrial substrate carrier family protein', NULL, NULL, NULL, NULL, NULL, 4),
(26276, NULL, 'G3DSA:1.25.40.10:FF:004277', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(26277, NULL, 'G3DSA:2.10.25.10:FF:001086', NULL, NULL, 'SCO-spondin', NULL, NULL, NULL, NULL, NULL, 4),
(26278, NULL, 'G3DSA:3.30.750.24:FF:000027', NULL, NULL, 'Solute carrier family 26 member 10', NULL, NULL, NULL, NULL, NULL, 4),
(26279, NULL, 'G3DSA:3.50.50.60:FF:000531', NULL, NULL, 'Flavoprotein monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26280, NULL, 'G3DSA:1.10.8.870:FF:000017', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(26281, NULL, 'G3DSA:3.30.420.40:FF:000099', NULL, NULL, 'Heat shock 70 kDa protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(26282, NULL, 'G3DSA:2.60.40.1930:FF:000001', NULL, NULL, 'CD109 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(26283, NULL, 'G3DSA:3.30.160.60:FF:004626', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(26284, NULL, 'G3DSA:3.40.1280.10:FF:000014', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(26285, NULL, 'G3DSA:3.30.465.10:FF:000143', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(26286, NULL, 'G3DSA:3.10.250.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26287, NULL, 'G3DSA:2.60.40.1940:FF:000004', NULL, NULL, 'Alpha-2-macroglobulin like 1', NULL, NULL, NULL, NULL, NULL, 4),
(26288, NULL, 'G3DSA:2.60.40.10:FF:002378', NULL, NULL, 'Stretchin-Mlck, isoform T', NULL, NULL, NULL, NULL, NULL, 4),
(26289, NULL, 'G3DSA:3.10.490.10:FF:000043', NULL, NULL, 'Gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(26290, NULL, 'G3DSA:1.50.40.10:FF:000447', NULL, NULL, 'Os11g0423800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(26291, NULL, 'G3DSA:3.30.160.890:FF:000001', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(26292, NULL, 'G3DSA:3.30.160.60:FF:006138', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26293, NULL, 'G3DSA:3.10.129.10:FF:000103', NULL, NULL, 'WGS project CABT00000000 data, contig 2.1', NULL, NULL, NULL, NULL, NULL, 4),
(26294, NULL, 'G3DSA:3.15.10.30:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26295, NULL, 'G3DSA:2.30.29.170:FF:000012', NULL, NULL, 'EF-Hand domain-Containing protein 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(26296, NULL, 'G3DSA:3.40.50.300:FF:006291', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26297, NULL, 'G3DSA:1.20.1050.60:FF:000001', NULL, NULL, 'Putative alpha-1,2-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(26298, NULL, 'G3DSA:1.20.1440.180:FF:000004', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26299, NULL, 'G3DSA:2.10.110.10:FF:000322', NULL, NULL, 'Paxillin-B', NULL, NULL, NULL, NULL, NULL, 4),
(26300, NULL, 'G3DSA:1.10.630.10:FF:000686', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26301, NULL, 'G3DSA:3.30.420.580:FF:000013', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(26302, NULL, 'G3DSA:1.20.5.320:FF:000007', NULL, NULL, 'Collagen type XIII alpha 1 chain', NULL, NULL, NULL, NULL, NULL, 4),
(26303, NULL, 'G3DSA:1.10.510.10:FF:000290', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase ERECTA', NULL, NULL, NULL, NULL, NULL, 4),
(26304, NULL, 'G3DSA:1.10.260.30:FF:000011', NULL, NULL, 'SRP54-type protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26305, NULL, 'G3DSA:3.30.160.60:FF:002428', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26306, NULL, 'G3DSA:1.10.260.40:FF:000014', NULL, NULL, 'Cytoskeleton protein RodZ', NULL, NULL, NULL, NULL, NULL, 4),
(26307, NULL, 'G3DSA:1.20.5.190:FF:000154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26308, NULL, 'G3DSA:3.30.200.20:FF:000633', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26309, NULL, 'G3DSA:1.25.40.10:FF:002478', NULL, NULL, 'GM21091', NULL, NULL, NULL, NULL, NULL, 4),
(26310, NULL, 'G3DSA:3.40.640.10:FF:000273', NULL, NULL, 'Aminotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26311, NULL, 'G3DSA:1.10.238.10:FF:000038', NULL, NULL, 'EH domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(26312, NULL, 'G3DSA:3.30.160.60:FF:002485', NULL, NULL, 'Potential zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(26313, NULL, 'G3DSA:3.40.50.2000:FF:000010', NULL, NULL, 'Alpha,alpha-trehalose-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(26314, NULL, 'G3DSA:2.40.37.10:FF:000044', NULL, NULL, 'Ornithine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(26315, NULL, 'G3DSA:1.20.5.170:FF:000035', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(26316, NULL, 'G3DSA:2.60.120.10:FF:000767', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26317, NULL, 'G3DSA:1.20.1070.10:FF:001084', NULL, NULL, 'Octopamine receptor beta-2R', NULL, NULL, NULL, NULL, NULL, 4),
(26318, NULL, 'G3DSA:2.60.410.10:FF:000002', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase dacD', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(26319, NULL, 'G3DSA:2.20.100.10:FF:000100', NULL, NULL, 'Sporozoite surface protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(26320, NULL, 'G3DSA:1.20.58.60:FF:000801', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26321, NULL, 'G3DSA:3.40.50.1000:FF:000659', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26322, NULL, 'G3DSA:2.30.42.10:FF:000107', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 9', NULL, NULL, NULL, NULL, NULL, 4),
(26323, NULL, 'G3DSA:3.60.15.10:FF:000035', NULL, NULL, 'Phosphonate metabolism protein PhnP', NULL, NULL, NULL, NULL, NULL, 4),
(26324, NULL, 'G3DSA:3.30.210.10:FF:000018', NULL, NULL, 'Polymerase (DNA directed), mu', NULL, NULL, NULL, NULL, NULL, 4),
(26325, NULL, 'G3DSA:1.10.1420.10:FF:000175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26326, NULL, 'G3DSA:1.20.1070.10:FF:000122', NULL, NULL, 'Gastrin-releasing peptide receptor', NULL, NULL, NULL, NULL, NULL, 4),
(26327, NULL, 'G3DSA:2.40.370.10:FF:000003', NULL, NULL, 'Kievitone hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(26328, NULL, 'G3DSA:1.20.1440.170:FF:000001', NULL, NULL, 'Translation machinery-associated 16 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(26329, NULL, 'G3DSA:2.70.170.10:FF:000088', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(26330, NULL, 'G3DSA:3.30.710.10:FF:000152', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(26331, NULL, 'G3DSA:2.40.70.10:FF:000520', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26332, NULL, 'G3DSA:2.70.150.10:FF:000199', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(26333, NULL, 'G3DSA:2.60.120.200:FF:000404', NULL, NULL, 'ALK tyrosine kinase receptor homolog scd-2', NULL, NULL, NULL, NULL, NULL, 4),
(26334, NULL, 'G3DSA:1.10.10.10:FF:001110', NULL, NULL, 'DNA-binding transcriptional regulator, MarR family', NULL, NULL, NULL, NULL, NULL, 4),
(26335, NULL, 'G3DSA:1.20.1200.10:FF:000010', NULL, NULL, 'Metabolism of cobalamin associated B', NULL, NULL, NULL, NULL, NULL, 4),
(26336, NULL, 'G3DSA:1.25.40.10:FF:004552', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(26337, NULL, 'G3DSA:3.30.70.330:FF:001949', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26338, NULL, 'G3DSA:2.20.25.420:FF:000008', NULL, NULL, 'Zinc-finger protein zpr1', NULL, NULL, NULL, NULL, NULL, 4),
(26339, NULL, 'G3DSA:3.30.420.40:FF:000953', NULL, NULL, 'AGR099Cp', NULL, NULL, NULL, NULL, NULL, 4),
(26340, NULL, 'G3DSA:1.10.10.10:FF:001054', NULL, NULL, 'GM24041', NULL, NULL, NULL, NULL, NULL, 4),
(26341, NULL, 'G3DSA:3.30.200.20:FF:000015', NULL, NULL, 'Somatic embryogenesis receptor kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(26342, NULL, 'G3DSA:1.20.1070.10:FF:002101', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(26343, NULL, 'G3DSA:3.40.50.300:FF:002249', NULL, NULL, 'ATP-dependent RNA helicase DDX27', NULL, NULL, NULL, NULL, NULL, 4),
(26344, NULL, 'G3DSA:1.25.40.10:FF:000281', NULL, NULL, 'Spermatogenesis associated 16', NULL, NULL, NULL, NULL, NULL, 4),
(26345, NULL, 'G3DSA:3.40.50.1820:FF:000051', NULL, NULL, '(S)-hydroxynitrile lyase', NULL, NULL, NULL, NULL, NULL, 4),
(26346, NULL, 'G3DSA:1.10.10.10:FF:000834', NULL, NULL, 'AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(26347, NULL, 'G3DSA:1.10.287.110:FF:000423', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26348, NULL, 'G3DSA:2.60.320.30:FF:000001', NULL, NULL, 'Tail fiber protein', NULL, NULL, NULL, NULL, NULL, 4),
(26349, NULL, 'G3DSA:2.60.200.20:FF:000248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26350, NULL, 'G3DSA:3.30.70.330:FF:001663', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26351, NULL, 'G3DSA:2.115.10.20:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26352, NULL, 'G3DSA:1.25.40.10:FF:000623', NULL, NULL, 'Tetratricopeptide repeat protein 30 homolog', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(26353, NULL, 'G3DSA:2.60.40.10:FF:002653', NULL, NULL, 'AGAP012059-PA', NULL, NULL, NULL, NULL, NULL, 4),
(26354, NULL, 'G3DSA:3.40.50.300:FF:006178', NULL, NULL, 'Guanine nucleotide-binding protein G(s) subunit alpha isoforms short', NULL, NULL, NULL, NULL, NULL, 4),
(26355, NULL, 'G3DSA:2.170.270.10:FF:000049', NULL, NULL, 'Histone-lysine N-methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26356, NULL, 'G3DSA:3.40.50.1000:FF:000715', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26357, NULL, 'G3DSA:2.60.120.620:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26358, NULL, 'G3DSA:3.10.100.10:FF:000166', NULL, NULL, 'Mannose receptor, C type 1b', NULL, NULL, NULL, NULL, NULL, 4),
(26359, NULL, 'G3DSA:1.20.200.10:FF:000027', NULL, NULL, 'Argininosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(26360, NULL, 'G3DSA:1.10.600.10:FF:000116', NULL, NULL, 'Decaprenyl-diphosphate synthase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(26361, NULL, 'G3DSA:1.20.1090.10:FF:000011', NULL, NULL, 'Putative oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(26362, NULL, 'G3DSA:3.40.50.2300:FF:001398', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26363, NULL, 'G3DSA:1.10.620.20:FF:000008', NULL, NULL, 'Ribonucleoside-diphosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(26364, NULL, 'G3DSA:2.60.40.420:FF:000135', NULL, NULL, 'Laccase', NULL, NULL, NULL, NULL, NULL, 4),
(26365, NULL, 'G3DSA:3.30.230.10:FF:000401', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(26366, NULL, 'G3DSA:2.40.50.140:FF:000075', NULL, NULL, '26S protease regulatory subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(26367, NULL, 'G3DSA:3.30.420.10:FF:000051', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(26368, NULL, 'G3DSA:3.40.50.620:FF:000703', NULL, NULL, 'Electron transfer flavoprotein beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(26369, NULL, 'G3DSA:1.20.1420.30:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26370, NULL, 'G3DSA:1.10.10.580:FF:000018', NULL, NULL, 'AaceriAEL007Wp', NULL, NULL, NULL, NULL, NULL, 4),
(26371, NULL, 'G3DSA:3.40.50.1000:FF:000772', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26372, NULL, 'G3DSA:3.10.100.10:FF:000346', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26373, NULL, 'G3DSA:2.60.120.10:FF:000368', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(26374, NULL, 'G3DSA:1.25.40.20:FF:000284', NULL, NULL, 'Lysophospholipase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26375, NULL, 'G3DSA:3.40.50.150:FF:000478', NULL, NULL, 'YBR271W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(26376, NULL, 'G3DSA:1.20.1070.10:FF:000066', NULL, NULL, 'Dopamine receptor D3', NULL, NULL, NULL, NULL, NULL, 4),
(26377, NULL, 'G3DSA:1.10.1270.20:FF:000002', NULL, NULL, 'tRNA (guanine-N(1)-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(26378, NULL, 'G3DSA:2.130.10.130:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26379, NULL, 'G3DSA:3.90.550.50:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26380, NULL, 'G3DSA:3.10.105.10:FF:000099', NULL, NULL, 'ABC-type transport system, periplasmic component, involved in antimicrobial peptide resistance', NULL, NULL, NULL, NULL, NULL, 4),
(26381, NULL, 'G3DSA:1.10.357.10:FF:000056', NULL, NULL, 'Transcriptional regulator, TetR family', NULL, NULL, NULL, NULL, NULL, 4),
(26382, NULL, 'G3DSA:2.40.160.10:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26383, NULL, 'G3DSA:2.60.40.10:FF:002833', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(26384, NULL, 'G3DSA:2.30.230.10:FF:000001', NULL, NULL, 'Microsomal triglyceride transfer protein large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(26385, NULL, 'G3DSA:3.40.30.10:FF:000684', NULL, NULL, 'Chloride intracellular channel exl-1', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(26386, NULL, 'G3DSA:1.10.10.10:FF:000559', NULL, NULL, 'Transcriptional regulator, IclR family', NULL, NULL, NULL, NULL, NULL, 4),
(26387, NULL, 'G3DSA:2.60.40.10:FF:000798', NULL, NULL, 'Plexin B2', NULL, NULL, NULL, NULL, NULL, 4),
(26388, NULL, 'G3DSA:3.30.70.1010:FF:000002', NULL, NULL, 'Eukaryotic translation elongation factor 1 gamma, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26389, NULL, 'G3DSA:3.60.21.10:FF:000325', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26390, NULL, 'G3DSA:2.60.450.20:FF:000002', NULL, NULL, 'Spindle assembly abnormal 4', NULL, NULL, NULL, NULL, NULL, 4),
(26391, NULL, 'G3DSA:3.20.100.10:FF:000006', NULL, NULL, 'mRNA capping enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26392, NULL, 'G3DSA:1.20.20.10:FF:000014', NULL, NULL, 'ATP synthase subunit 9, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(26393, NULL, 'G3DSA:3.30.70.330:FF:002500', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26394, NULL, 'G3DSA:3.30.1490.100:FF:000028', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(26395, NULL, 'G3DSA:4.10.320.10:FF:000016', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(26396, NULL, 'G3DSA:2.30.29.30:FF:001257', NULL, NULL, 'AGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(26397, NULL, 'G3DSA:2.60.40.10:FF:001074', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(26398, NULL, 'G3DSA:4.10.60.10:FF:000090', NULL, NULL, 'Gag polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(26399, NULL, 'G3DSA:2.130.10.10:FF:002249', NULL, NULL, 'Cleavage and polyadenylation specificity factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(26400, NULL, 'G3DSA:1.10.10.570:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26401, NULL, 'G3DSA:1.25.40.10:FF:000062', NULL, NULL, 'Signal recognition particle subunit SRP72', NULL, NULL, NULL, NULL, NULL, 4),
(26402, NULL, 'G3DSA:3.30.70.870:FF:000054', NULL, NULL, 'Elongation factor Tu GTP-binding domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(26403, NULL, 'G3DSA:2.60.40.10:FF:002092', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(26404, NULL, 'G3DSA:3.30.230.10:FF:000126', NULL, NULL, 'Galactokinase', NULL, NULL, NULL, NULL, NULL, 4),
(26405, NULL, 'G3DSA:3.90.70.10:FF:000712', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(26406, NULL, 'G3DSA:2.60.40.150:FF:000762', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26407, NULL, 'G3DSA:3.40.50.620:FF:000142', NULL, NULL, 'Universal stress protein A-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(26408, NULL, 'G3DSA:1.25.40.20:FF:000626', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26409, NULL, 'G3DSA:2.40.30.10:FF:000068', NULL, NULL, 'Elongation factor Tu', NULL, NULL, NULL, NULL, NULL, 4),
(26410, NULL, 'G3DSA:1.25.10.10:FF:002982', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26411, NULL, 'G3DSA:2.60.40.2610:FF:000003', NULL, NULL, 'Outer membrane usher protein FasD', NULL, NULL, NULL, NULL, NULL, 4),
(26412, NULL, 'G3DSA:3.30.40.10:FF:000651', NULL, NULL, 'Lysine-specific demethylase 5D', NULL, NULL, NULL, NULL, NULL, 4),
(26413, NULL, 'G3DSA:2.40.50.140:FF:000417', NULL, NULL, '30S small subunit ribosomal protein S17', NULL, NULL, NULL, NULL, NULL, 4),
(26414, NULL, 'G3DSA:3.40.50.1980:FF:000138', NULL, NULL, 'ABC-type Fe3+-siderophores transport system, periplasmic component, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26415, NULL, 'G3DSA:3.30.559.10:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26416, NULL, 'G3DSA:3.80.10.10:FF:003547', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26417, NULL, 'G3DSA:1.10.510.10:FF:003324', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26418, NULL, 'G3DSA:2.30.180.10:FF:000171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(26419, NULL, 'G3DSA:1.10.132.60:FF:000021', NULL, NULL, 'DNA polymerase alpha subunit one', NULL, NULL, NULL, NULL, NULL, 4),
(26420, NULL, 'G3DSA:3.90.1750.10:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26421, NULL, 'G3DSA:3.30.1540.20:FF:000006', NULL, NULL, 'PMS1 homolog 2, mismatch repair system component', NULL, NULL, NULL, NULL, NULL, 4),
(26422, NULL, 'G3DSA:1.10.510.10:FF:002088', NULL, NULL, 'Protein_kinase_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(26423, NULL, 'G3DSA:2.130.10.10:FF:002743', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(26424, NULL, 'G3DSA:3.40.630.30:FF:000672', NULL, NULL, 'Acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26425, NULL, 'G3DSA:1.20.58.60:FF:000127', NULL, NULL, 'microtubule-actin cross-linking factor 1 isoform X9', NULL, NULL, NULL, NULL, NULL, 4),
(26426, NULL, 'G3DSA:3.40.50.1000:FF:000373', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(26427, NULL, 'G3DSA:3.40.390.10:FF:000236', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26428, NULL, 'G3DSA:1.10.1200.150:FF:000002', NULL, NULL, 'Transcriptional regulator CtsR', NULL, NULL, NULL, NULL, NULL, 4),
(26429, NULL, 'G3DSA:3.30.1540.10:FF:000003', NULL, NULL, 'CoA-transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(26430, NULL, 'G3DSA:2.30.30.40:FF:000370', NULL, NULL, 'Plenty of SH3s', NULL, NULL, NULL, NULL, NULL, 4),
(26431, NULL, 'G3DSA:3.30.750.24:FF:000140', NULL, NULL, 'Solute carrier family 26 member 6', NULL, NULL, NULL, NULL, NULL, 4),
(26432, NULL, 'G3DSA:3.10.20.90:FF:000641', NULL, NULL, 'Autophagy-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(26433, NULL, 'G3DSA:1.20.1250.20:FF:000111', NULL, NULL, 'Solute carrier family 37 member 4', NULL, NULL, NULL, NULL, NULL, 4),
(26434, NULL, 'G3DSA:1.10.1520.10:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26435, NULL, 'G3DSA:2.60.120.260:FF:000405', NULL, NULL, 'Pesticidal crystal protein Cry5Ba', NULL, NULL, NULL, NULL, NULL, 4),
(26436, NULL, 'G3DSA:3.90.70.10:FF:000358', NULL, NULL, 'Calcium-dependent cysteine protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26437, NULL, 'G3DSA:3.30.500.40:FF:000004', NULL, NULL, 'AGAP004049-PA', NULL, NULL, NULL, NULL, NULL, 4),
(26438, NULL, 'G3DSA:3.40.630.10:FF:000284', NULL, NULL, 'Glutaminyl cyclase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26439, NULL, 'G3DSA:1.20.120.1240:FF:000031', NULL, NULL, 'Dynamin GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26440, NULL, 'G3DSA:2.10.25.10:FF:001316', NULL, NULL, 'AGAP003873-PA', NULL, NULL, NULL, NULL, NULL, 4),
(26441, NULL, 'G3DSA:3.60.21.10:FF:000426', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(26442, NULL, 'G3DSA:3.40.50.300:FF:006268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26443, NULL, 'G3DSA:2.110.10.10:FF:000058', NULL, NULL, 'Matrix metallopeptidase 28', NULL, NULL, NULL, NULL, NULL, 4),
(26444, NULL, 'G3DSA:3.40.30.10:FF:001145', NULL, NULL, 'F18O14.31', NULL, NULL, NULL, NULL, NULL, 4),
(26445, NULL, 'G3DSA:3.40.50.300:FF:007420', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26446, NULL, 'G3DSA:3.40.630.10:FF:000328', NULL, NULL, 'Glutamate carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26447, NULL, 'G3DSA:3.30.70.330:FF:002601', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26448, NULL, 'G3DSA:3.40.50.300:FF:002569', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26449, NULL, 'G3DSA:1.20.1250.20:FF:001589', NULL, NULL, 'Protein NRT1/ PTR FAMILY 5.11', NULL, NULL, NULL, NULL, NULL, 4),
(26450, NULL, 'G3DSA:2.130.10.10:FF:000574', NULL, NULL, 'Transducin beta like 2', NULL, NULL, NULL, NULL, NULL, 4),
(26451, NULL, 'G3DSA:2.130.10.10:FF:004273', NULL, NULL, 'Protein CBR-THOC-3.1', NULL, NULL, NULL, NULL, NULL, 4),
(26452, NULL, 'G3DSA:1.25.40.790:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(26453, NULL, 'G3DSA:3.40.50.720:FF:001633', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(26454, NULL, 'G3DSA:3.40.50.880:FF:000130', NULL, NULL, 'CTP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(26455, NULL, 'G3DSA:2.60.40.10:FF:000607', NULL, NULL, 'Leukemia inhibitory factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(26456, NULL, 'G3DSA:2.60.40.10:FF:001113', NULL, NULL, 'Sallimus, isoform P', NULL, NULL, NULL, NULL, NULL, 4),
(26457, NULL, 'G3DSA:1.20.20.10:FF:000003', NULL, NULL, 'Atp synthase f complex subunit mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(26458, NULL, 'G3DSA:2.60.40.10:FF:004295', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26459, NULL, 'G3DSA:1.20.58.760:FF:000032', NULL, NULL, 'AAA ATPase central domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(26460, NULL, 'G3DSA:3.60.15.10:FF:000013', NULL, NULL, 'Persulfide dioxygenase ETHE1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(26461, NULL, 'G3DSA:1.10.510.10:FF:000609', NULL, NULL, 'Inactive LRR receptor-like serine/threonine-protein kinase BIR2', NULL, NULL, NULL, NULL, NULL, 4),
(26462, NULL, 'G3DSA:2.40.30.10:FF:000478', NULL, NULL, 'Translation initiation factor IF-2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(26463, NULL, 'G3DSA:3.30.230.70:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26464, NULL, 'G3DSA:2.60.40.420:FF:000051', NULL, NULL, 'Coagulation factor VIII', NULL, NULL, NULL, NULL, NULL, 4),
(26465, NULL, 'G3DSA:3.40.50.300:FF:008522', NULL, NULL, 'Type II secretion system protein', NULL, NULL, NULL, NULL, NULL, 4),
(26466, NULL, 'G3DSA:1.25.40.10:FF:002607', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g18970', NULL, NULL, NULL, NULL, NULL, 4),
(26467, NULL, 'G3DSA:3.10.450.50:FF:000024', NULL, NULL, 'CMGC/MAPK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(26468, NULL, 'G3DSA:3.40.50.300:FF:000445', NULL, NULL, 'Phosphate acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(26469, NULL, 'G3DSA:2.60.40.10:FF:004339', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26470, NULL, 'G3DSA:3.90.226.10:FF:000209', NULL, NULL, 'Carboxyl-terminal protease', NULL, NULL, NULL, NULL, NULL, 4),
(26471, NULL, 'G3DSA:3.40.640.10:FF:000256', NULL, NULL, 'NTD biosynthesis operon protein NtdA', NULL, NULL, NULL, NULL, NULL, 4),
(26472, NULL, 'G3DSA:1.25.40.10:FF:004215', NULL, NULL, 'LOC100125120 protein', NULL, NULL, NULL, NULL, NULL, 4),
(26473, NULL, 'G3DSA:1.25.10.10:FF:000335', NULL, NULL, 'cilia- and flagella-associated protein 69 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(26474, NULL, 'G3DSA:3.30.200.20:FF:002353', NULL, NULL, 'Boron transporter 4', NULL, NULL, NULL, NULL, NULL, 4),
(26475, NULL, 'G3DSA:3.10.450.40:FF:000021', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(26476, NULL, 'G3DSA:2.120.10.80:FF:000320', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(26477, NULL, 'G3DSA:1.20.1550.10:FF:000007', NULL, NULL, 'Disulfide bond formation protein B 1', NULL, NULL, NULL, NULL, NULL, 4),
(26478, NULL, 'G3DSA:2.40.10.10:FF:000578', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26479, NULL, 'G3DSA:3.30.565.40:FF:000002', NULL, NULL, 'Immunogenic protein MPT64', NULL, NULL, NULL, NULL, NULL, 4),
(26480, NULL, 'G3DSA:3.40.1090.10:FF:000078', NULL, NULL, 'Patatin', NULL, NULL, NULL, NULL, NULL, 4),
(26481, NULL, 'G3DSA:3.30.1370.10:FF:000192', NULL, NULL, 'KH domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(26482, NULL, 'G3DSA:3.30.420.40:FF:000442', NULL, NULL, 'Pantothenate kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(26483, NULL, 'G3DSA:3.40.50.720:FF:000531', NULL, NULL, 'NAD/FAD dependent dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26484, NULL, 'G3DSA:1.10.472.10:FF:000037', NULL, NULL, 'Cyclin-A2', NULL, NULL, NULL, NULL, NULL, 4),
(26485, NULL, 'G3DSA:1.20.140.150:FF:000044', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(26486, NULL, 'G3DSA:3.50.50.60:FF:001397', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26487, NULL, 'G3DSA:2.40.110.10:FF:000029', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(26488, NULL, 'G3DSA:3.40.50.150:FF:000574', NULL, NULL, 'Eukaryotic initiation factor 3, gamma subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26489, NULL, 'G3DSA:1.25.40.10:FF:004541', NULL, NULL, 'Os02g0833050 protein', NULL, NULL, NULL, NULL, NULL, 4),
(26490, NULL, 'G3DSA:2.60.40.10:FF:000596', NULL, NULL, 'Vascular endothelial growth factor receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(26491, NULL, 'G3DSA:3.80.10.10:FF:000214', NULL, NULL, 'EIN3-binding F-box protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(26492, NULL, 'G3DSA:2.60.40.150:FF:000077', NULL, NULL, 'rab11 family-interacting protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(26493, NULL, 'G3DSA:2.60.40.3090:FF:000001', NULL, NULL, 'PHP domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(26494, NULL, 'G3DSA:3.30.450.40:FF:000270', NULL, NULL, 'PAS sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(26495, NULL, 'G3DSA:3.90.1750.10:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26496, NULL, 'G3DSA:2.10.25.10:FF:000799', NULL, NULL, 'AGAP009716-PA', NULL, NULL, NULL, NULL, NULL, 4),
(26497, NULL, 'G3DSA:3.30.160.60:FF:004744', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26498, NULL, 'G3DSA:3.30.160.60:FF:005250', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26499, NULL, 'G3DSA:2.60.120.650:FF:000106', NULL, NULL, 'Transcription factor jumonji (JmjC) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(26500, NULL, 'G3DSA:3.40.850.10:FF:000502', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26501, NULL, 'G3DSA:2.30.29.30:FF:000251', NULL, NULL, 'Syntrophin beta 2', NULL, NULL, NULL, NULL, NULL, 4),
(26502, NULL, 'G3DSA:1.10.150.20:FF:000146', NULL, NULL, 'DNaJ domain (Prokaryotic heat shock protein)', NULL, NULL, NULL, NULL, NULL, 4),
(26503, NULL, 'G3DSA:3.30.200.20:FF:001847', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26504, NULL, 'G3DSA:1.10.472.80:FF:000277', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26505, NULL, 'G3DSA:1.10.472.10:FF:000363', NULL, NULL, 'Brf1-like TBP-binding domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(26506, NULL, 'G3DSA:1.25.10.10:FF:000970', NULL, NULL, 'ARM REPEAT PROTEIN INTERACTING WITH ABF2', NULL, NULL, NULL, NULL, NULL, 4),
(26507, NULL, 'G3DSA:3.40.50.300:FF:004823', NULL, NULL, 'Helicase', NULL, NULL, NULL, NULL, NULL, 4),
(26508, NULL, 'G3DSA:1.10.1380.10:FF:000013', NULL, NULL, 'neprilysin', NULL, NULL, NULL, NULL, NULL, 4),
(26509, NULL, 'G3DSA:3.30.40.10:FF:002040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26510, NULL, 'G3DSA:1.25.40.10:FF:002933', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(26511, NULL, 'G3DSA:1.25.40.10:FF:000472', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(26512, NULL, 'G3DSA:3.30.160.60:FF:001181', NULL, NULL, 'Zinc finger protein 311', NULL, NULL, NULL, NULL, NULL, 4),
(26513, NULL, 'G3DSA:3.40.50.300:FF:003042', NULL, NULL, 'Hemin import ATP-binding protein HmuV', NULL, NULL, NULL, NULL, NULL, 4),
(26514, NULL, 'G3DSA:1.25.40.10:FF:000842', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(26515, NULL, 'G3DSA:1.25.40.10:FF:002080', NULL, NULL, 'Protein PHOX4', NULL, NULL, NULL, NULL, NULL, 4),
(26516, NULL, 'G3DSA:2.30.180.10:FF:000148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26517, NULL, 'G3DSA:2.40.50.1000:FF:000008', NULL, NULL, '40S ribosomal protein S11', NULL, NULL, NULL, NULL, NULL, 4),
(26518, NULL, 'G3DSA:3.80.10.10:FF:003396', NULL, NULL, 'F-box and leucine rich repeat protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(26519, NULL, 'G3DSA:3.90.1180.10:FF:000012', NULL, NULL, '50S ribosomal protein L13', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(26520, NULL, 'G3DSA:1.10.287.130:FF:000030', NULL, NULL, 'Putative histidine kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(26521, NULL, 'G3DSA:3.90.1150.10:FF:000510', NULL, NULL, 'Cysteine desulfurase', NULL, NULL, NULL, NULL, NULL, 4),
(26522, NULL, 'G3DSA:2.130.10.10:FF:004317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26523, NULL, 'G3DSA:1.25.40.20:FF:000475', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26524, NULL, 'G3DSA:1.10.472.130:FF:000059', NULL, NULL, 'Dynein heavy chain 9', NULL, NULL, NULL, NULL, NULL, 4),
(26525, NULL, 'G3DSA:2.130.10.10:FF:002709', NULL, NULL, 'IP11840p', NULL, NULL, NULL, NULL, NULL, 4),
(26526, NULL, 'G3DSA:2.120.10.30:FF:000092', NULL, NULL, 'GD20529', NULL, NULL, NULL, NULL, NULL, 4),
(26527, NULL, 'G3DSA:3.80.10.10:FF:001479', NULL, NULL, 'Lutropin-choriogonadotropic hormone receptor', NULL, NULL, NULL, NULL, NULL, 4),
(26528, NULL, 'G3DSA:3.10.20.90:FF:000938', NULL, NULL, 'PH domain-containing protein DDB_G0287875', NULL, NULL, NULL, NULL, NULL, 4),
(26529, NULL, 'G3DSA:2.40.50.140:FF:000209', NULL, NULL, 'Replication protein A1, small', NULL, NULL, NULL, NULL, NULL, 4),
(26530, NULL, 'G3DSA:1.25.40.20:FF:000845', NULL, NULL, 'Glycerophosphocholine phosphodiesterase GDE1', NULL, NULL, NULL, NULL, NULL, 4),
(26531, NULL, 'G3DSA:3.30.70.141:FF:000022', NULL, NULL, 'Thioredoxin domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(26532, NULL, 'G3DSA:3.30.40.10:FF:001860', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26533, NULL, 'G3DSA:3.40.50.1000:FF:000581', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26534, NULL, 'G3DSA:1.25.40.10:FF:000163', NULL, NULL, 'Transcriptional corepressor Cyc8', NULL, NULL, NULL, NULL, NULL, 4),
(26535, NULL, 'G3DSA:3.30.40.10:FF:000432', NULL, NULL, 'E3 ubiquitin-protein ligase Hakai', NULL, NULL, NULL, NULL, NULL, 4),
(26536, NULL, 'G3DSA:2.40.30.270:FF:000008', NULL, NULL, 'Unplaced genomic scaffold supercont2.3, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(26537, NULL, 'G3DSA:1.10.10.60:FF:000237', NULL, NULL, 'zinc fingers and homeoboxes protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(26538, NULL, 'G3DSA:1.25.10.10:FF:000661', NULL, NULL, 'Cell differentiation family, Rcd1-like containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(26539, NULL, 'G3DSA:1.25.40.420:FF:000005', NULL, NULL, 'BTB/POZ domain-containing protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(26540, NULL, 'G3DSA:2.70.150.10:FF:000249', NULL, NULL, 'Putative calcium-transporting ATPase 13 plasma membrane-type', NULL, NULL, NULL, NULL, NULL, 4),
(26541, NULL, 'G3DSA:1.10.510.10:FF:002852', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26542, NULL, 'G3DSA:3.90.1150.10:FF:000173', NULL, NULL, 'Glutamate-1-semialdehyde 2,1-aminomutase', NULL, NULL, NULL, NULL, NULL, 4),
(26543, NULL, 'G3DSA:3.20.20.100:FF:000052', NULL, NULL, '2,5-diketo-D-gluconic acid reductase A', NULL, NULL, NULL, NULL, NULL, 4),
(26544, NULL, 'G3DSA:3.40.50.1440:FF:000038', NULL, NULL, 'Tubulin epsilon chain', NULL, NULL, NULL, NULL, NULL, 4),
(26545, NULL, 'G3DSA:3.10.20.90:FF:000629', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26546, NULL, 'G3DSA:2.10.25.10:FF:001642', NULL, NULL, 'Aggrecan b', NULL, NULL, NULL, NULL, NULL, 4),
(26547, NULL, 'G3DSA:3.40.50.300:FF:006594', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26548, NULL, 'G3DSA:1.10.533.10:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26549, NULL, 'G3DSA:4.10.870.10:FF:000001', NULL, NULL, 'Cellulose 1,4-beta-cellobiosidase', NULL, NULL, NULL, NULL, NULL, 4),
(26550, NULL, 'G3DSA:3.10.20.230:FF:000014', NULL, NULL, 'Doublecortin domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(26551, NULL, 'G3DSA:3.30.200.20:FF:000419', NULL, NULL, 'Putative receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(26552, NULL, 'G3DSA:2.60.40.60:FF:000841', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(26553, NULL, 'G3DSA:3.40.50.300:FF:002199', NULL, NULL, 'Putative dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(26554, NULL, 'G3DSA:2.60.40.10:FF:000287', NULL, NULL, 'Prolactin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(26555, NULL, 'G3DSA:1.50.40.10:FF:000554', NULL, NULL, 'Solute carrier family 25 member 17', NULL, NULL, NULL, NULL, NULL, 4),
(26556, NULL, 'G3DSA:3.40.30.10:FF:000791', NULL, NULL, 'Phosphoadenosine phosphosulfate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(26557, NULL, 'G3DSA:2.60.40.150:FF:000723', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26558, NULL, 'G3DSA:1.20.120.330:FF:000026', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(26559, NULL, 'G3DSA:3.30.565.10:FF:000089', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(26560, NULL, 'G3DSA:1.25.40.430:FF:000008', NULL, NULL, 'Unplaced genomic scaffold supercont1.188, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(26561, NULL, 'G3DSA:2.10.90.10:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26562, NULL, 'G3DSA:2.60.120.260:FF:000085', NULL, NULL, 'probable allantoicase', NULL, NULL, NULL, NULL, NULL, 4),
(26563, NULL, 'G3DSA:1.10.340.30:FF:000012', NULL, NULL, 'N-glycosylase/DNA lyase', NULL, NULL, NULL, NULL, NULL, 4),
(26564, NULL, 'G3DSA:2.10.110.10:FF:000070', NULL, NULL, 'Four and a half LIM domains 3', NULL, NULL, NULL, NULL, NULL, 4),
(26565, NULL, 'G3DSA:3.40.50.200:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26566, NULL, 'G3DSA:3.40.190.10:FF:000148', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(26567, NULL, 'G3DSA:1.20.1070.10:FF:001179', NULL, NULL, 'G-protein coupled receptor 126', NULL, NULL, NULL, NULL, NULL, 4),
(26568, NULL, 'G3DSA:1.20.58.1030:FF:000044', NULL, NULL, 'DNA replication complex GINS protein SLD5', NULL, NULL, NULL, NULL, NULL, 4),
(26569, NULL, 'G3DSA:2.120.10.30:FF:000445', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26570, NULL, 'G3DSA:3.60.21.10:FF:000089', NULL, NULL, 'Vacuolar protein sorting-associated protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(26571, NULL, 'G3DSA:3.40.50.670:FF:000022', NULL, NULL, 'DNA gyrase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(26572, NULL, 'G3DSA:3.80.10.10:FF:000799', NULL, NULL, 'Probable disease resistance protein At5g63020', NULL, NULL, NULL, NULL, NULL, 4),
(26573, NULL, 'G3DSA:1.10.2020.20:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26574, NULL, 'G3DSA:3.40.50.300:FF:006605', NULL, NULL, 'Midasin AAA ATPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(26575, NULL, 'G3DSA:2.10.220.10:FF:000089', NULL, NULL, 'Furin 2', NULL, NULL, NULL, NULL, NULL, 4),
(26576, NULL, 'G3DSA:3.40.1210.10:FF:000004', NULL, NULL, '5''-nucleotidase SurE', NULL, NULL, NULL, NULL, NULL, 4),
(26577, NULL, 'G3DSA:1.20.140.40:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26578, NULL, 'G3DSA:3.30.60.10:FF:000006', NULL, NULL, 'Agglutinin isolectin 1', NULL, NULL, NULL, NULL, NULL, 4),
(26579, NULL, 'G3DSA:1.25.40.10:FF:002287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26580, NULL, 'G3DSA:2.130.10.10:FF:000265', NULL, NULL, 'periodic tryptophan protein 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(26581, NULL, 'G3DSA:1.20.1530.20:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26582, NULL, 'G3DSA:2.60.120.10:FF:000576', NULL, NULL, 'CRP-like cAMP-activated global transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(26583, NULL, 'G3DSA:1.20.1250.20:FF:001382', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(26584, NULL, 'G3DSA:3.30.565.10:FF:000252', NULL, NULL, 'Two-component system sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(26585, NULL, 'G3DSA:3.40.390.10:FF:000129', NULL, NULL, 'A disintegrin-like and metallopeptidase (reprolysin type) with thrombospondin type 1 motif, 6', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(26586, NULL, 'G3DSA:3.30.260.10:FF:000072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26587, NULL, 'G3DSA:1.10.730.10:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26588, NULL, 'G3DSA:3.40.50.300:FF:008185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26589, NULL, 'G3DSA:3.20.20.70:FF:000758', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26590, NULL, 'G3DSA:2.20.130.20:FF:000009', NULL, NULL, 'CD109 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(26591, NULL, 'G3DSA:3.30.160.60:FF:006352', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26592, NULL, 'G3DSA:3.30.160.60:FF:004418', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26593, NULL, 'G3DSA:3.30.230.130:FF:000088', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(26594, NULL, 'G3DSA:3.10.110.10:FF:000324', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(26595, NULL, 'G3DSA:1.10.1410.40:FF:000008', NULL, NULL, 'Inositol 1,4,5-trisphosphate receptor-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(26596, NULL, 'G3DSA:2.60.40.10:FF:003030', NULL, NULL, 'Interferon gamma receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(26597, NULL, 'G3DSA:3.30.160.60:FF:003007', NULL, NULL, 'Zgc:174563 protein', NULL, NULL, NULL, NULL, NULL, 4),
(26598, NULL, 'G3DSA:1.10.510.10:FF:000598', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(26599, NULL, 'G3DSA:3.30.1740.10:FF:000001', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(26600, NULL, 'G3DSA:2.30.38.10:FF:000013', NULL, NULL, 'Enniatin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(26601, NULL, 'G3DSA:3.30.60.20:FF:000009', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(26602, NULL, 'G3DSA:1.20.1070.10:FF:001488', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(26603, NULL, 'G3DSA:1.10.10.60:FF:000563', NULL, NULL, 'Putative myb transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(26604, NULL, 'G3DSA:2.60.40.10:FF:002541', NULL, NULL, 'Wrapper/Rega-1/Klingon homolog', NULL, NULL, NULL, NULL, NULL, 4),
(26605, NULL, 'G3DSA:4.10.1000.10:FF:000011', NULL, NULL, 'Zinc finger CCCH domain-containing protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(26606, NULL, 'G3DSA:3.40.50.720:FF:000222', NULL, NULL, 'Glucose-6-phosphate 1-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(26607, NULL, 'G3DSA:1.10.3380.30:FF:000019', NULL, NULL, 'RNA helicase, superfamily II', NULL, NULL, NULL, NULL, NULL, 4),
(26608, NULL, 'G3DSA:3.30.450.80:FF:000006', NULL, NULL, 'Transcriptional regulator, LuxR family', NULL, NULL, NULL, NULL, NULL, 4),
(26609, NULL, 'G3DSA:3.40.50.11660:FF:000017', NULL, NULL, 'Alpha-(1,3)-fucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(26610, NULL, 'G3DSA:1.10.510.10:FF:003032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26611, NULL, 'G3DSA:1.25.40.90:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26612, NULL, 'G3DSA:3.30.1740.20:FF:000004', NULL, NULL, '30S ribosomal protein S26e', NULL, NULL, NULL, NULL, NULL, 4),
(26613, NULL, 'G3DSA:3.40.50.1820:FF:000012', NULL, NULL, 'Lipase', NULL, NULL, NULL, NULL, NULL, 4),
(26614, NULL, 'G3DSA:3.30.160.60:FF:004098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26615, NULL, 'G3DSA:3.50.50.60:FF:000132', NULL, NULL, 'Amine oxidase [flavin-containing] B', NULL, NULL, NULL, NULL, NULL, 4),
(26616, NULL, 'G3DSA:3.90.550.50:FF:000233', NULL, NULL, 'RE01689p', NULL, NULL, NULL, NULL, NULL, 4),
(26617, NULL, 'G3DSA:1.10.10.10:FF:000481', NULL, NULL, 'Transcriptional regulator, GntR family', NULL, NULL, NULL, NULL, NULL, 4),
(26618, NULL, 'G3DSA:3.30.70.1390:FF:000014', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(26619, NULL, 'G3DSA:3.40.50.2300:FF:000072', NULL, NULL, 'Gamma-aminobutyric acid type B receptor subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(26620, NULL, 'G3DSA:1.25.40.10:FF:003698', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g01030, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(26621, NULL, 'G3DSA:2.60.40.10:FF:002850', NULL, NULL, 'Coiled-coil domain-containing protein 141', NULL, NULL, NULL, NULL, NULL, 4),
(26622, NULL, 'G3DSA:3.90.70.10:FF:000684', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26623, NULL, 'G3DSA:3.30.1360.120:FF:000096', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(26624, NULL, 'G3DSA:3.30.497.10:FF:000059', NULL, NULL, 'Putative serpin A13', NULL, NULL, NULL, NULL, NULL, 4),
(26625, NULL, 'G3DSA:2.170.130.10:FF:000016', NULL, NULL, 'Outer membrane receptor for ferrienterochelin and colicins', NULL, NULL, NULL, NULL, NULL, 4),
(26626, NULL, 'G3DSA:3.30.450.70:FF:000003', NULL, NULL, 'Trafficking particle complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(26627, NULL, 'G3DSA:2.40.30.10:FF:000271', NULL, NULL, 'Probable oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(26628, NULL, 'G3DSA:3.40.50.150:FF:001400', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26629, NULL, 'G3DSA:3.30.70.270:FF:000161', NULL, NULL, 'Transposon Tf2-9 polyprotein-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(26630, NULL, 'G3DSA:3.60.10.10:FF:000024', NULL, NULL, 'Tyrosyl-DNA phosphodiesterase 2', NULL, NULL, NULL, NULL, NULL, 4),
(26631, NULL, 'G3DSA:3.40.50.150:FF:000911', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26632, NULL, 'G3DSA:3.40.50.720:FF:001942', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26633, NULL, 'G3DSA:1.10.3380.20:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26634, NULL, 'G3DSA:3.30.310.210:FF:000007', NULL, NULL, 'Ribonuclease Y', NULL, NULL, NULL, NULL, NULL, 4),
(26635, NULL, 'G3DSA:2.40.70.10:FF:000380', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26636, NULL, 'G3DSA:1.10.150.20:FF:000163', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(26637, NULL, 'G3DSA:3.30.160.60:FF:004435', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26638, NULL, 'G3DSA:3.30.160.60:FF:006335', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26639, NULL, 'G3DSA:3.90.740.10:FF:000045', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(26640, NULL, 'G3DSA:3.40.50.1820:FF:001782', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26641, NULL, 'G3DSA:3.30.450.40:FF:000253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26642, NULL, 'G3DSA:3.90.226.10:FF:000182', NULL, NULL, 'Enoyl-CoA hydratase domain-containing protein 3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(26643, NULL, 'G3DSA:1.25.40.10:FF:004524', NULL, NULL, 'Hsp70/Hsp90 organizing protein', NULL, NULL, NULL, NULL, NULL, 4),
(26644, NULL, 'G3DSA:3.60.40.20:FF:000001', NULL, NULL, 'Adenosine monophosphate-protein hydrolase SidD', NULL, NULL, NULL, NULL, NULL, 4),
(26645, NULL, 'G3DSA:3.30.160.60:FF:005233', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26646, NULL, 'G3DSA:2.60.40.150:FF:000386', NULL, NULL, 'Phosphatidylserine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(26647, NULL, 'G3DSA:3.40.640.10:FF:000239', NULL, NULL, 'Cystathionine beta lyase', NULL, NULL, NULL, NULL, NULL, 4),
(26648, NULL, 'G3DSA:2.40.100.10:FF:000074', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(26649, NULL, 'G3DSA:3.30.230.130:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26650, NULL, 'G3DSA:3.90.1150.10:FF:000201', NULL, NULL, 'Glycine dehydrogenase (decarboxylating)', NULL, NULL, NULL, NULL, NULL, 4),
(26651, NULL, 'G3DSA:1.20.120.720:FF:000020', NULL, NULL, 'Myosin XVI', NULL, NULL, NULL, NULL, NULL, 4),
(26652, NULL, 'G3DSA:1.10.1520.10:FF:000002', NULL, NULL, 'Drosha ribonuclease III', NULL, NULL, NULL, NULL, NULL, 4),
(26653, NULL, 'G3DSA:1.10.510.10:FF:000582', NULL, NULL, 'Serine/threonine-protein kinase GRIK1 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(26654, NULL, 'G3DSA:1.10.8.60:FF:000489', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(26655, NULL, 'G3DSA:3.30.420.40:FF:000751', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26656, NULL, 'G3DSA:1.20.1070.10:FF:000999', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26657, NULL, 'G3DSA:3.30.60.20:FF:000026', NULL, NULL, 'Thymidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(26658, NULL, 'G3DSA:3.40.50.300:FF:004486', NULL, NULL, 'Putative ATP-dependent DEAD/H RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(26659, NULL, 'G3DSA:3.40.50.300:FF:001125', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(26660, NULL, 'G3DSA:3.40.50.300:FF:006740', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26661, NULL, 'G3DSA:3.40.50.1000:FF:000564', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26662, NULL, 'G3DSA:1.10.20.10:FF:000083', NULL, NULL, 'nuclear transcription factor Y subunit gamma isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(26663, NULL, 'G3DSA:3.30.60.30:FF:000029', NULL, NULL, 'Serine peptidase inhibitor, Kazal type 5', NULL, NULL, NULL, NULL, NULL, 4),
(26664, NULL, 'G3DSA:3.30.450.70:FF:000020', NULL, NULL, 'TRapp subunit', NULL, NULL, NULL, NULL, NULL, 4),
(26665, NULL, 'G3DSA:1.25.40.10:FF:000825', NULL, NULL, 'Molecular co-chaperone STI1', NULL, NULL, NULL, NULL, NULL, 4),
(26666, NULL, 'G3DSA:3.30.200.20:FF:000762', NULL, NULL, 'Related to calmodulin-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(26667, NULL, 'G3DSA:1.25.40.20:FF:000828', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26668, NULL, 'G3DSA:2.30.42.10:FF:000220', NULL, NULL, 'uncharacterized protein LOC108099354 isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(26669, NULL, 'G3DSA:1.25.40.20:FF:000492', NULL, NULL, 'YTH domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(26670, NULL, 'G3DSA:1.20.1540.10:FF:000052', NULL, NULL, 'Peptidase, S54 family', NULL, NULL, NULL, NULL, NULL, 4),
(26671, NULL, 'G3DSA:1.10.20.10:FF:000318', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26672, NULL, 'G3DSA:1.10.8.720:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26673, NULL, 'G3DSA:3.10.20.90:FF:000955', NULL, NULL, 'FERM, ARH/RhoGEF and pleckstrin domain protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(26674, NULL, 'G3DSA:3.30.230.10:FF:000261', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26675, NULL, 'G3DSA:2.40.30.10:FF:000169', NULL, NULL, '50S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(26676, NULL, 'G3DSA:2.30.42.10:FF:000444', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26677, NULL, 'G3DSA:3.30.160.60:FF:000736', NULL, NULL, 'Zinc finger protein 423', NULL, NULL, NULL, NULL, NULL, 4),
(26678, NULL, 'G3DSA:3.30.70.120:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26679, NULL, 'G3DSA:1.10.3380.30:FF:000036', NULL, NULL, 'ATP-dependent DNA helicase Hel308', NULL, NULL, NULL, NULL, NULL, 4),
(26680, NULL, 'G3DSA:2.120.10.30:FF:000119', NULL, NULL, 'LDL receptor protein 1, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(26681, NULL, 'G3DSA:2.60.200.20:FF:000276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26682, NULL, 'G3DSA:2.40.170.20:FF:000058', NULL, NULL, 'TonB-dependent siderophore receptor', NULL, NULL, NULL, NULL, NULL, 4),
(26683, NULL, 'G3DSA:1.10.287.110:FF:000283', NULL, NULL, 'Chaperone protein DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(26684, NULL, 'G3DSA:2.60.40.2810:FF:000001', NULL, NULL, 'RTX toxins and related Ca2+-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(26685, NULL, 'G3DSA:3.80.10.10:FF:002131', NULL, NULL, '3C420', NULL, NULL, NULL, NULL, NULL, 4),
(26686, NULL, 'G3DSA:1.10.760.10:FF:000111', NULL, NULL, 'Monoheme cytochrome c Shp', NULL, NULL, NULL, NULL, NULL, 4),
(26687, NULL, 'G3DSA:2.70.70.10:FF:000018', NULL, NULL, 'Peptidase, M23 family', NULL, NULL, NULL, NULL, NULL, 4),
(26688, NULL, 'G3DSA:3.30.40.10:FF:000095', NULL, NULL, 'Histone-lysine N-methyltransferase 2C', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(26689, NULL, 'G3DSA:3.40.190.10:FF:000620', NULL, NULL, 'Taurine ABC transporter, periplasmic taurine-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(26690, NULL, 'G3DSA:2.10.25.10:FF:001625', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26691, NULL, 'G3DSA:3.40.140.10:FF:000246', NULL, NULL, 'Protein CBG02246', NULL, NULL, NULL, NULL, NULL, 4),
(26692, NULL, 'G3DSA:1.10.238.10:FF:000465', NULL, NULL, 'Zinc_finger_-_C3HC4_type_(RING_finger)/Ring_finger_domain/zinc-RING_finger_domain/EF-hand_domain_pair/EF-hand_domain/EF_hand/Secreted_protein_acidic_and_rich_in_cys teine_Ca_binding_region_containing_...', NULL, NULL, NULL, NULL, NULL, 4),
(26693, NULL, 'G3DSA:1.10.10.10:FF:000155', NULL, NULL, 'Acetate operon repressor IclR', NULL, NULL, NULL, NULL, NULL, 4),
(26694, NULL, 'G3DSA:2.40.50.90:FF:000003', NULL, NULL, 'Staphylococcal nuclease domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(26695, NULL, 'G3DSA:1.20.120.1750:FF:000105', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(26696, NULL, 'G3DSA:2.30.42.10:FF:000118', NULL, NULL, 'Uncharacterized protein, isoform Z', NULL, NULL, NULL, NULL, NULL, 4),
(26697, NULL, 'G3DSA:2.30.30.10:FF:000001', NULL, NULL, 'POL polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(26698, NULL, 'G3DSA:3.40.50.620:FF:000147', NULL, NULL, 'Cholinephosphate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(26699, NULL, 'G3DSA:2.60.40.10:FF:002748', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26700, NULL, 'G3DSA:2.60.40.60:FF:000824', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26701, NULL, 'G3DSA:3.40.50.720:FF:001616', NULL, NULL, 'Hydroxysteroid 17-beta dehydrogenase 3', NULL, NULL, NULL, NULL, NULL, 4),
(26702, NULL, 'G3DSA:1.10.510.10:FF:003223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26703, NULL, 'G3DSA:2.70.220.10:FF:000002', NULL, NULL, 'Phosphatidylglycerol/phosphatidylinositol transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(26704, NULL, 'G3DSA:3.40.30.10:FF:001162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26705, NULL, 'G3DSA:2.60.40.60:FF:000678', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(26706, NULL, 'G3DSA:1.10.1420.10:FF:000186', NULL, NULL, 'MutS family protein. putative', NULL, NULL, NULL, NULL, NULL, 4),
(26707, NULL, 'G3DSA:3.60.120.10:FF:000010', NULL, NULL, 'Salicylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(26708, NULL, 'G3DSA:3.40.50.150:FF:000927', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26709, NULL, 'G3DSA:2.60.40.10:FF:004648', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26710, NULL, 'G3DSA:3.30.1010.10:FF:000036', NULL, NULL, 'Serine/threonine-protein kinase ATR', NULL, NULL, NULL, NULL, NULL, 4),
(26711, NULL, 'G3DSA:3.30.200.20:FF:002336', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26712, NULL, 'G3DSA:2.30.30.40:FF:000471', NULL, NULL, 'ACR266Wp', NULL, NULL, NULL, NULL, NULL, 4),
(26713, NULL, 'G3DSA:2.30.30.40:FF:000336', NULL, NULL, 'SH3 domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(26714, NULL, 'G3DSA:3.80.10.10:FF:001625', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(26715, NULL, 'G3DSA:3.30.160.60:FF:003333', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26716, NULL, 'G3DSA:3.30.160.60:FF:000692', NULL, NULL, 'Zinc finger and BTB domain containing 24', NULL, NULL, NULL, NULL, NULL, 4),
(26717, NULL, 'G3DSA:2.160.10.10:FF:000005', NULL, NULL, 'UDP-3-O-(3-hydroxymyristoyl)glucosamine N-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(26718, NULL, 'G3DSA:1.25.10.10:FF:001150', NULL, NULL, 'Importin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(26719, NULL, 'G3DSA:3.30.160.60:FF:004761', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26720, NULL, 'G3DSA:1.25.40.10:FF:002624', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26721, NULL, 'G3DSA:1.10.1000.11:FF:000009', NULL, NULL, 'IQ motif and SEC7 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(26722, NULL, 'G3DSA:3.30.200.20:FF:002027', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(26723, NULL, 'G3DSA:3.10.430.100:FF:000005', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(26724, NULL, 'G3DSA:1.10.950.10:FF:000002', NULL, NULL, 'Dematin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(26725, NULL, 'G3DSA:2.60.40.60:FF:001004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26726, NULL, 'G3DSA:3.30.70.330:FF:002910', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26727, NULL, 'G3DSA:1.20.1250.20:FF:000280', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(26728, NULL, 'G3DSA:2.130.10.30:FF:000012', NULL, NULL, 'probable E3 ubiquitin-protein ligase HERC3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(26729, NULL, 'G3DSA:3.40.190.10:FF:000474', NULL, NULL, 'Oligopeptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(26730, NULL, 'G3DSA:1.10.730.10:FF:000154', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(26731, NULL, 'G3DSA:2.60.120.10:FF:000559', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(26732, NULL, 'G3DSA:2.60.40.10:FF:002187', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(26733, NULL, 'G3DSA:2.130.10.10:FF:000248', NULL, NULL, 'Chromatin assembly factor 1 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(26734, NULL, 'G3DSA:1.20.1250.20:FF:001617', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26735, NULL, 'G3DSA:2.170.270.10:FF:000173', NULL, NULL, 'PR domain containing 11', NULL, NULL, NULL, NULL, NULL, 4),
(26736, NULL, 'G3DSA:1.20.1420.30:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26737, NULL, 'G3DSA:2.30.30.100:FF:000044', NULL, NULL, 'Probable U6 snRNA-associated Sm-like protein LSm6', NULL, NULL, NULL, NULL, NULL, 4),
(26738, NULL, 'G3DSA:1.20.120.1750:FF:000122', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(26739, NULL, 'G3DSA:3.40.50.300:FF:008538', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26740, NULL, 'G3DSA:3.30.465.10:FF:000042', NULL, NULL, 'D-arabinono-1,4-lactone oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(26741, NULL, 'G3DSA:3.40.50.720:FF:001487', NULL, NULL, 'UDP-galactopyranose mutase', NULL, NULL, NULL, NULL, NULL, 4),
(26742, NULL, 'G3DSA:2.20.70.10:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26743, NULL, 'G3DSA:1.10.472.10:FF:000716', NULL, NULL, 'Retinoblastoma-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(26744, NULL, 'G3DSA:1.25.10.10:FF:002561', NULL, NULL, 'Calcium-binding protein 39-like', NULL, NULL, NULL, NULL, NULL, 4),
(26745, NULL, 'G3DSA:3.40.50.720:FF:000205', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(26746, NULL, 'G3DSA:3.20.20.300:FF:000005', NULL, NULL, 'Periplasmic beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(26747, NULL, 'G3DSA:2.60.120.200:FF:000174', NULL, NULL, 'MAM domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(26748, NULL, 'G3DSA:1.20.1280.20:FF:000017', NULL, NULL, 'Co-chaperone Hsc20 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(26749, NULL, 'G3DSA:1.10.10.10:FF:000716', NULL, NULL, '40S ribosomal protein S19', NULL, NULL, NULL, NULL, NULL, 4),
(26750, NULL, 'G3DSA:3.90.170.10:FF:000006', NULL, NULL, 'Adenylosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(26751, NULL, 'G3DSA:1.25.40.10:FF:004850', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26752, NULL, 'G3DSA:3.80.10.10:FF:003087', NULL, NULL, 'F-box protein family, AtFBL12, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26753, NULL, 'G3DSA:2.130.10.10:FF:000911', NULL, NULL, 'Putative Rab GTPase-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(26754, NULL, 'G3DSA:1.20.120.620:FF:000006', NULL, NULL, 'Sensor histidine kinase KdpD', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(26755, NULL, 'G3DSA:1.25.40.10:FF:002950', NULL, NULL, 'U4/U6-U5 snRNP complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(26756, NULL, 'G3DSA:1.10.1070.11:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26757, NULL, 'G3DSA:1.10.472.10:FF:000407', NULL, NULL, 'YALI0C10516p', NULL, NULL, NULL, NULL, NULL, 4),
(26758, NULL, 'G3DSA:2.130.10.10:FF:001400', NULL, NULL, 'CCR4-associated factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(26759, NULL, 'G3DSA:1.10.10.2590:FF:000008', NULL, NULL, 'Phospholipase a2 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26760, NULL, 'G3DSA:1.25.40.10:FF:002063', NULL, NULL, 'Hsp70-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(26761, NULL, 'G3DSA:2.120.10.80:FF:000174', NULL, NULL, 'F-box/kelch-repeat protein At5g42360', NULL, NULL, NULL, NULL, NULL, 4),
(26762, NULL, 'G3DSA:2.60.40.10:FF:004665', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26763, NULL, 'G3DSA:1.10.10.710:FF:000001', NULL, NULL, 'DNA damage-inducible protein YebG', NULL, NULL, NULL, NULL, NULL, 4),
(26764, NULL, 'G3DSA:1.20.120.610:FF:000003', NULL, NULL, 'V-type proton ATPase proteolipid subunit', NULL, NULL, NULL, NULL, NULL, 4),
(26765, NULL, 'G3DSA:2.40.50.140:FF:000226', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(26766, NULL, 'G3DSA:3.90.1320.10:FF:000001', NULL, NULL, 'Putative carboxyl-terminal proteinase', NULL, NULL, NULL, NULL, NULL, 4),
(26767, NULL, 'G3DSA:3.30.200.20:FF:000436', NULL, NULL, 'Methylthioribose kinase', NULL, NULL, NULL, NULL, NULL, 4),
(26768, NULL, 'G3DSA:3.90.550.50:FF:000216', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(26769, NULL, 'G3DSA:3.40.50.300:FF:004795', NULL, NULL, 'Rcorf28', NULL, NULL, NULL, NULL, NULL, 4),
(26770, NULL, 'G3DSA:3.40.50.2020:FF:000095', NULL, NULL, 'Ribose-phosphate pyrophosphokinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26771, NULL, 'G3DSA:1.10.10.720:FF:000004', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(26772, NULL, 'G3DSA:3.40.50.1820:FF:001338', NULL, NULL, 'Putative hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(26773, NULL, 'G3DSA:3.40.50.720:FF:000514', NULL, NULL, 'Oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26774, NULL, 'G3DSA:1.20.1270.280:FF:000063', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(26775, NULL, 'G3DSA:2.60.120.740:FF:000015', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(26776, NULL, 'G3DSA:2.30.30.30:FF:000007', NULL, NULL, 'Eukaryotic translation initiation factor 5A', NULL, NULL, NULL, NULL, NULL, 4),
(26777, NULL, 'G3DSA:3.10.110.10:FF:000296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26778, NULL, 'G3DSA:1.25.10.10:FF:002252', NULL, NULL, 'Synembryn-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(26779, NULL, 'G3DSA:3.40.350.10:FF:000037', NULL, NULL, 'Aminopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26780, NULL, 'G3DSA:1.10.3130.10:FF:000012', NULL, NULL, 'Serine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(26781, NULL, 'G3DSA:3.30.70.330:FF:001758', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26782, NULL, 'G3DSA:1.20.58.60:FF:000251', NULL, NULL, 'Spectrin repeat containing nuclear envelope protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(26783, NULL, 'G3DSA:1.10.246.60:FF:000004', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit J', NULL, NULL, NULL, NULL, NULL, 4),
(26784, NULL, 'G3DSA:3.80.10.10:FF:001951', NULL, NULL, 'Receptor kinase-like protein Xa21', NULL, NULL, NULL, NULL, NULL, 4),
(26785, NULL, 'G3DSA:3.40.50.1820:FF:000236', NULL, NULL, 'Alpha/beta hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(26786, NULL, 'G3DSA:2.60.40.150:FF:000740', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26787, NULL, 'G3DSA:3.40.50.1000:FF:000255', NULL, NULL, 'Protein CBG02038', NULL, NULL, NULL, NULL, NULL, 4),
(26788, NULL, 'G3DSA:3.30.40.10:FF:001758', NULL, NULL, 'Inhibitor of growth protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(26789, NULL, 'G3DSA:1.20.1250.20:FF:001926', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26790, NULL, 'G3DSA:3.40.50.2300:FF:000307', NULL, NULL, 'Receptor-like histidine kinase BpdS', NULL, NULL, NULL, NULL, NULL, 4),
(26791, NULL, 'G3DSA:1.20.1070.10:FF:001634', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26792, NULL, 'G3DSA:3.90.1150.10:FF:000408', NULL, NULL, '5-aminolevulinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(26793, NULL, 'G3DSA:3.40.50.1820:FF:001647', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26794, NULL, 'G3DSA:3.40.50.300:FF:005897', NULL, NULL, 'ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26795, NULL, 'G3DSA:3.40.718.10:FF:000021', NULL, NULL, 'Isocitrate dehydrogenase 3 (NAD(+)) alpha', NULL, NULL, NULL, NULL, NULL, 4),
(26796, NULL, 'G3DSA:2.40.50.140:FF:000535', NULL, NULL, 'Asparaginyl-tRNA synthetase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(26797, NULL, 'G3DSA:1.10.238.10:FF:000791', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26798, NULL, 'G3DSA:3.60.160.10:FF:000001', NULL, NULL, 'Altered inheritance of mitochondria protein 24, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(26799, NULL, 'G3DSA:3.30.200.20:FF:000745', NULL, NULL, 'Phytosulfokine receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(26800, NULL, 'G3DSA:1.25.40.20:FF:001290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26801, NULL, 'G3DSA:2.60.40.150:FF:000431', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26802, NULL, 'G3DSA:3.30.40.10:FF:001197', NULL, NULL, 'Ring finger domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(26803, NULL, 'G3DSA:3.40.50.2300:FF:000616', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(26804, NULL, 'G3DSA:1.10.10.60:FF:000900', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26805, NULL, 'G3DSA:1.20.1070.10:FF:000223', NULL, NULL, 'Thyrotropin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(26806, NULL, 'G3DSA:1.10.3260.10:FF:000016', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(26807, NULL, 'G3DSA:2.60.40.2220:FF:000004', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(26808, NULL, 'G3DSA:3.90.480.10:FF:000007', NULL, NULL, 'Nitrite/sulfite reductase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(26809, NULL, 'G3DSA:2.40.70.10:FF:000054', NULL, NULL, 'retrotransposon-derived protein PEG10 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(26810, NULL, 'G3DSA:1.20.1250.20:FF:002106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26811, NULL, 'G3DSA:3.30.70.330:FF:002247', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26812, NULL, 'G3DSA:3.30.230.10:FF:000244', NULL, NULL, 'Galactose kinase', NULL, NULL, NULL, NULL, NULL, 4),
(26813, NULL, 'G3DSA:2.120.10.30:FF:000428', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(26814, NULL, 'G3DSA:1.10.472.80:FF:000001', NULL, NULL, 'TBC1 domain family member 22B', NULL, NULL, NULL, NULL, NULL, 4),
(26815, NULL, 'G3DSA:3.40.50.11260:FF:000004', NULL, NULL, 'Heat shock protein 75 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(26816, NULL, 'G3DSA:1.25.10.10:FF:002459', NULL, NULL, 'Cytoplasm protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26817, NULL, 'G3DSA:6.10.140.2190:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26818, NULL, 'G3DSA:3.40.1770.10:FF:000006', NULL, NULL, 'Urocanate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(26819, NULL, 'G3DSA:2.30.29.30:FF:000060', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(26820, NULL, 'G3DSA:3.30.160.60:FF:000719', NULL, NULL, 'Zinc finger protein 507', NULL, NULL, NULL, NULL, NULL, 4),
(26821, NULL, 'G3DSA:1.20.140.150:FF:000061', NULL, NULL, 'CLaudin-like in Caenorhabditis', NULL, NULL, NULL, NULL, NULL, 4),
(26822, NULL, 'G3DSA:2.40.30.10:FF:000495', NULL, NULL, 'Selenocysteine-specific elongation factor', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(26823, NULL, 'G3DSA:3.90.550.50:FF:000087', NULL, NULL, 'beta-1,3-N-acetylglucosaminyltransferase lunatic fringe', NULL, NULL, NULL, NULL, NULL, 4),
(26824, NULL, 'G3DSA:3.30.160.60:FF:001208', NULL, NULL, 'Zinc finger protein 142', NULL, NULL, NULL, NULL, NULL, 4),
(26825, NULL, 'G3DSA:3.40.50.10890:FF:000011', NULL, NULL, 'Cleavage and polyadenylation specificity factor subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(26826, NULL, 'G3DSA:3.40.50.300:FF:005520', NULL, NULL, 'Protein-tyrosine sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(26827, NULL, 'G3DSA:3.90.79.10:FF:000187', NULL, NULL, 'NUDIX hydrolase, conserved', NULL, NULL, NULL, NULL, NULL, 4),
(26828, NULL, 'G3DSA:3.40.190.10:FF:000603', NULL, NULL, 'Chorismate mutase/prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(26829, NULL, 'G3DSA:1.20.1080.10:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26830, NULL, 'G3DSA:3.30.428.10:FF:000001', NULL, NULL, 'Galactose-1-phosphate uridylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(26831, NULL, 'G3DSA:2.40.70.10:FF:000262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26832, NULL, 'G3DSA:3.40.50.720:FF:001279', NULL, NULL, 'NAD(P) transhydrogenase subunit alpha, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26833, NULL, 'G3DSA:2.60.120.200:FF:000202', NULL, NULL, 'Laminin subunit alpha 5', NULL, NULL, NULL, NULL, NULL, 4),
(26834, NULL, 'G3DSA:3.30.720.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26835, NULL, 'G3DSA:3.30.565.10:FF:000235', NULL, NULL, 'Sensor histidine kinase DesK', NULL, NULL, NULL, NULL, NULL, 4),
(26836, NULL, 'G3DSA:2.160.20.10:FF:000051', NULL, NULL, 'PKHD1, fibrocystin/polyductin', NULL, NULL, NULL, NULL, NULL, 4),
(26837, NULL, 'G3DSA:2.60.40.10:FF:002395', NULL, NULL, 'Down syndrome cell adhesion molecule 1, isoform BY', NULL, NULL, NULL, NULL, NULL, 4),
(26838, NULL, 'G3DSA:2.60.40.10:FF:006094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26839, NULL, 'G3DSA:3.80.10.10:FF:001934', NULL, NULL, 'Receptor-like protein kinase HSL1', NULL, NULL, NULL, NULL, NULL, 4),
(26840, NULL, 'G3DSA:3.40.850.10:FF:000311', NULL, NULL, 'Motor domain of KIF13B', NULL, NULL, NULL, NULL, NULL, 4),
(26841, NULL, 'G3DSA:3.40.50.10810:FF:000044', NULL, NULL, 'Chromatin remodeling factor18', NULL, NULL, NULL, NULL, NULL, 4),
(26842, NULL, 'G3DSA:1.10.238.10:FF:000774', NULL, NULL, 'Related to secretory protein SSP120', NULL, NULL, NULL, NULL, NULL, 4),
(26843, NULL, 'G3DSA:3.30.70.60:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26844, NULL, 'G3DSA:3.10.690.10:FF:000002', NULL, NULL, 'Bifunctional nuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(26845, NULL, 'G3DSA:2.60.40.10:FF:003013', NULL, NULL, '2 (Zwei) IG domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(26846, NULL, 'G3DSA:2.60.40.60:FF:000807', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26847, NULL, 'G3DSA:3.30.70.330:FF:000123', NULL, NULL, 'Pre-mRNA splicing factor (Srp1)', NULL, NULL, NULL, NULL, NULL, 4),
(26848, NULL, 'G3DSA:3.30.40.10:FF:000140', NULL, NULL, 'E3 ubiquitin-protein ligase Hakai isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(26849, NULL, 'G3DSA:2.60.40.640:FF:000027', NULL, NULL, 'VPS26 endosomal protein sorting factor C', NULL, NULL, NULL, NULL, NULL, 4),
(26850, NULL, 'G3DSA:3.30.1330.200:FF:000001', NULL, NULL, 'Probable chemoreceptor glutamine deamidase CheD', NULL, NULL, NULL, NULL, NULL, 4),
(26851, NULL, 'G3DSA:2.30.30.40:FF:000454', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26852, NULL, 'G3DSA:2.40.10.10:FF:000286', NULL, NULL, 'Si:ch211-212d10.1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(26853, NULL, 'G3DSA:1.20.1070.10:FF:000105', NULL, NULL, 'Glucagon like peptide 1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(26854, NULL, 'G3DSA:3.40.50.720:FF:001824', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26855, NULL, 'G3DSA:1.20.1070.10:FF:000206', NULL, NULL, 'Probable G-protein coupled receptor 171', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(26856, NULL, 'G3DSA:2.130.10.10:FF:002518', NULL, NULL, 'Histidine kinase/response regulator hybrid protein', NULL, NULL, NULL, NULL, NULL, 4),
(26857, NULL, 'G3DSA:2.130.10.10:FF:002474', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26858, NULL, 'G3DSA:1.25.40.10:FF:005013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26859, NULL, 'G3DSA:1.25.10.10:FF:001133', NULL, NULL, 'Hectd1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(26860, NULL, 'G3DSA:3.50.50.60:FF:000115', NULL, NULL, 'Salicylate hydroxylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26861, NULL, 'G3DSA:1.10.472.10:FF:000172', NULL, NULL, 'Protein CBG05210', NULL, NULL, NULL, NULL, NULL, 4),
(26862, NULL, 'G3DSA:2.70.170.10:FF:000251', NULL, NULL, 'Soluble acetylcholine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(26863, NULL, 'G3DSA:3.30.450.20:FF:000230', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(26864, NULL, 'G3DSA:1.20.1050.10:FF:000205', NULL, NULL, 'AaceriAFL032Cp', NULL, NULL, NULL, NULL, NULL, 4),
(26865, NULL, 'G3DSA:3.40.47.10:FF:000284', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26866, NULL, 'G3DSA:1.25.40.20:FF:001216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26867, NULL, 'G3DSA:1.10.10.10:FF:000464', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(26868, NULL, 'G3DSA:3.40.50.2300:FF:000055', NULL, NULL, 'Gamma-aminobutyric acid type B receptor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(26869, NULL, 'G3DSA:3.80.10.10:FF:001288', NULL, NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(26870, NULL, 'G3DSA:2.60.40.60:FF:000706', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(26871, NULL, 'G3DSA:3.30.470.20:FF:000130', NULL, NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(26872, NULL, 'G3DSA:2.80.10.50:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26873, NULL, 'G3DSA:3.30.160.60:FF:002299', NULL, NULL, 'Krueppel factor 15', NULL, NULL, NULL, NULL, NULL, 4),
(26874, NULL, 'G3DSA:3.30.2310.10:FF:000003', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(26875, NULL, 'G3DSA:2.10.90.10:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26876, NULL, 'G3DSA:1.20.58.80:FF:000049', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(26877, NULL, 'G3DSA:2.60.120.260:FF:000170', NULL, NULL, 'Glucuronidase beta', NULL, NULL, NULL, NULL, NULL, 4),
(26878, NULL, 'G3DSA:1.10.8.1290:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26879, NULL, 'G3DSA:3.10.20.90:FF:000394', NULL, NULL, 'Ubiquitin-like protein MDY2', NULL, NULL, NULL, NULL, NULL, 4),
(26880, NULL, 'G3DSA:2.60.120.260:FF:000540', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(26881, NULL, 'G3DSA:1.20.120.1750:FF:000077', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(26882, NULL, 'G3DSA:3.10.50.10:FF:000023', NULL, NULL, 'Chitinase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(26883, NULL, 'G3DSA:2.10.25.10:FF:001597', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26884, NULL, 'G3DSA:1.25.40.720:FF:000005', NULL, NULL, 'Telomere length regulation protein TEL2', NULL, NULL, NULL, NULL, NULL, 4),
(26885, NULL, 'G3DSA:1.10.533.10:FF:000196', NULL, NULL, 'Apoptosis-associated speck-like protein containing a CARD', NULL, NULL, NULL, NULL, NULL, 4),
(26886, NULL, 'G3DSA:1.20.142.10:FF:000015', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(26887, NULL, 'G3DSA:3.90.740.10:FF:000062', NULL, NULL, 'Isoleucine--tRNA ligase, cytoplasmic-like', NULL, NULL, NULL, NULL, NULL, 4),
(26888, NULL, 'G3DSA:1.20.58.60:FF:000043', NULL, NULL, 'Spectrin alpha chain, non-erythrocytic 1', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(26889, NULL, 'G3DSA:1.10.8.270:FF:000028', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(26890, NULL, 'G3DSA:3.30.470.30:FF:000032', NULL, NULL, 'Mitochondrial DNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26891, NULL, 'G3DSA:3.40.50.720:FF:002330', NULL, NULL, 'Glyoxylate/hydroxypyruvate reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26892, NULL, 'G3DSA:2.160.10.10:FF:000123', NULL, NULL, 'Serine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(26893, NULL, 'G3DSA:2.60.40.10:FF:004441', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26894, NULL, 'G3DSA:3.30.710.10:FF:000045', NULL, NULL, 'zinc finger and BTB domain-containing protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(26895, NULL, 'G3DSA:1.25.40.10:FF:004395', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26896, NULL, 'G3DSA:1.25.40.430:FF:000025', NULL, NULL, 'BUB1 mitotic checkpoint serine/threonine kinase Bb', NULL, NULL, NULL, NULL, NULL, 4),
(26897, NULL, 'G3DSA:1.10.418.10:FF:000119', NULL, NULL, 'Fimbrin-like protein 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(26898, NULL, 'G3DSA:2.60.120.260:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26899, NULL, 'G3DSA:2.10.25.10:FF:001081', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(26900, NULL, 'G3DSA:1.20.1050.130:FF:000002', NULL, NULL, 'aminoacyl tRNA synthase complex-interacting multifunctional protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(26901, NULL, 'G3DSA:3.40.225.10:FF:000005', NULL, NULL, 'L-fuculose phosphate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(26902, NULL, 'G3DSA:1.20.58.70:FF:000046', NULL, NULL, 'CRE-SYN-16 protein', NULL, NULL, NULL, NULL, NULL, 4),
(26903, NULL, 'G3DSA:3.30.230.10:FF:000053', NULL, NULL, 'DNA repair protein radA isogeny', NULL, NULL, NULL, NULL, NULL, 4),
(26904, NULL, 'G3DSA:1.20.1250.20:FF:001398', NULL, NULL, 'Monocarboxylate transporter-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(26905, NULL, 'G3DSA:3.40.190.290:FF:000117', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(26906, NULL, 'G3DSA:3.40.190.10:FF:000502', NULL, NULL, 'Putative oligopeptide-binding lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(26907, NULL, 'G3DSA:3.40.50.12780:FF:000050', NULL, NULL, 'Acyl-CoA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(26908, NULL, 'G3DSA:3.30.1010.10:FF:000053', NULL, NULL, 'DNA-dependent protein kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(26909, NULL, 'G3DSA:1.20.1070.10:FF:001842', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26910, NULL, 'G3DSA:1.20.120.910:FF:000003', NULL, NULL, 'TraR/DksA family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(26911, NULL, 'G3DSA:3.40.50.1100:FF:000167', NULL, NULL, 'SH3 domain protein (Cyk3), putative (AFU_orthologue AFUA_5G03400)', NULL, NULL, NULL, NULL, NULL, 4),
(26912, NULL, 'G3DSA:1.10.357.10:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26913, NULL, 'G3DSA:3.30.1120.120:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26914, NULL, 'G3DSA:3.30.70.330:FF:000022', NULL, NULL, 'APOBEC1 complementation factor isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(26915, NULL, 'G3DSA:6.10.250.3330:FF:000001', NULL, NULL, 'Secreted effector protein EspF(U)', NULL, NULL, NULL, NULL, NULL, 4),
(26916, NULL, 'G3DSA:3.10.129.10:FF:000125', NULL, NULL, 'Acyl-ACP thioesterase, FatA', NULL, NULL, NULL, NULL, NULL, 4),
(26917, NULL, 'G3DSA:3.40.228.10:FF:000028', NULL, NULL, 'Formylmethanofuran dehydrogenase, subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(26918, NULL, 'G3DSA:1.10.1420.10:FF:000068', NULL, NULL, 'Putative mismatch repair protein MSH8', NULL, NULL, NULL, NULL, NULL, 4),
(26919, NULL, 'G3DSA:3.40.50.1000:FF:000446', NULL, NULL, 'Trehalose-6-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(26920, NULL, 'G3DSA:3.30.70.330:FF:000538', NULL, NULL, 'Nuclear cap-binding protein subunit 2', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(26921, NULL, 'G3DSA:1.20.1560.10:FF:000070', NULL, NULL, 'Multidrug ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(26922, NULL, 'G3DSA:1.10.1130.10:FF:000012', NULL, NULL, 'Octaheme tetrathionate reductase Otr', NULL, NULL, NULL, NULL, NULL, 4),
(26923, NULL, 'G3DSA:1.20.1250.20:FF:001409', NULL, NULL, 'Putative multidrug resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(26924, NULL, 'G3DSA:3.30.160.60:FF:001416', NULL, NULL, 'PR domain zinc finger protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(26925, NULL, 'G3DSA:2.60.40.10:FF:002496', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26926, NULL, 'G3DSA:1.25.10.10:FF:002813', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26927, NULL, 'G3DSA:1.10.510.10:FF:004117', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26928, NULL, 'G3DSA:1.10.8.950:FF:000002', NULL, NULL, 'Polymerase cofactor VP35', NULL, NULL, NULL, NULL, NULL, 4),
(26929, NULL, 'G3DSA:3.30.160.60:FF:000383', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26930, NULL, 'G3DSA:3.30.160.60:FF:002844', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26931, NULL, 'G3DSA:1.25.40.10:FF:000707', NULL, NULL, 'Chitin synthase regulatory factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(26932, NULL, 'G3DSA:1.25.40.10:FF:004406', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(26933, NULL, 'G3DSA:1.25.10.10:FF:000526', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(26934, NULL, 'G3DSA:3.80.10.10:FF:003542', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26935, NULL, 'G3DSA:1.10.287.110:FF:000266', NULL, NULL, 'DnaJ like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26936, NULL, 'G3DSA:3.90.190.20:FF:000044', NULL, NULL, 'Tetrahydrofolate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(26937, NULL, 'G3DSA:3.40.50.1780:FF:000011', NULL, NULL, 'Nuclear prelamin A recognition factor', NULL, NULL, NULL, NULL, NULL, 4),
(26938, NULL, 'G3DSA:2.70.150.10:FF:000250', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(26939, NULL, 'G3DSA:2.60.40.640:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26940, NULL, 'G3DSA:2.40.50.90:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26941, NULL, 'G3DSA:1.20.1080.10:FF:000033', NULL, NULL, 'Probable nitrite transporter', NULL, NULL, NULL, NULL, NULL, 4),
(26942, NULL, 'G3DSA:3.90.550.10:FF:000362', NULL, NULL, 'Cytidylyltransferase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(26943, NULL, 'G3DSA:2.130.10.10:FF:005599', NULL, NULL, 'TBC1 domain family member 31-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(26944, NULL, 'G3DSA:3.40.50.300:FF:000299', NULL, NULL, 'ABC transporter ATP-binding protein/permease', NULL, NULL, NULL, NULL, NULL, 4),
(26945, NULL, 'G3DSA:1.10.510.10:FF:002734', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26946, NULL, 'G3DSA:2.60.40.10:FF:004750', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26947, NULL, 'G3DSA:2.40.30.110:FF:000011', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(26948, NULL, 'G3DSA:2.10.70.10:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26949, NULL, 'G3DSA:3.40.50.150:FF:001046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26950, NULL, 'G3DSA:1.20.272.40:FF:000011', NULL, NULL, 'ATP-dependent RNA helicase SUV3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(26951, NULL, 'G3DSA:1.20.58.1280:FF:000006', NULL, NULL, 'DNA repair protein REV1', NULL, NULL, NULL, NULL, NULL, 4),
(26952, NULL, 'G3DSA:2.40.30.130:FF:000017', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(26953, NULL, 'G3DSA:1.10.510.10:FF:003240', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26954, NULL, 'G3DSA:1.10.1450.10:FF:000160', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(26955, NULL, 'G3DSA:2.20.80.10:FF:000027', NULL, NULL, 'Vitellogenin 3', NULL, NULL, NULL, NULL, NULL, 4),
(26956, NULL, 'G3DSA:3.80.10.10:FF:001597', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(26957, NULL, 'G3DSA:3.10.300.10:FF:000007', NULL, NULL, 'DNA-3-methyladenine glycosylase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(26958, NULL, 'G3DSA:3.40.50.1000:FF:000238', NULL, NULL, 'BnaA03g18060D protein', NULL, NULL, NULL, NULL, NULL, 4),
(26959, NULL, 'G3DSA:3.30.70.330:FF:000331', NULL, NULL, 'RNA binding motif protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(26960, NULL, 'G3DSA:1.20.5.190:FF:000176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26961, NULL, 'G3DSA:3.90.1150.10:FF:000055', NULL, NULL, 'Cysteine desulfurase CsdA', NULL, NULL, NULL, NULL, NULL, 4),
(26962, NULL, 'G3DSA:1.10.645.10:FF:000006', NULL, NULL, 'NADH-quinone oxidoreductase subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(26963, NULL, 'G3DSA:2.40.50.690:FF:000026', NULL, NULL, 'RNB-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(26964, NULL, 'G3DSA:3.90.550.10:FF:000671', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26965, NULL, 'G3DSA:1.20.1070.10:FF:001297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26966, NULL, 'G3DSA:3.40.50.300:FF:005312', NULL, NULL, 'RAS-like, family 12', NULL, NULL, NULL, NULL, NULL, 4),
(26967, NULL, 'G3DSA:2.30.30.40:FF:000662', NULL, NULL, 'Glycoprotein 6-alpha-L-fucosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26968, NULL, 'G3DSA:2.30.30.40:FF:000353', NULL, NULL, 'Neutrophil cytosol factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(26969, NULL, 'G3DSA:3.30.720.210:FF:000010', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(26970, NULL, 'G3DSA:3.80.10.10:FF:003278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26971, NULL, 'G3DSA:1.25.40.10:FF:001798', NULL, NULL, 'At5g02130', NULL, NULL, NULL, NULL, NULL, 4),
(26972, NULL, 'G3DSA:2.60.40.10:FF:000950', NULL, NULL, 'Intercellular adhesion molecule 5', NULL, NULL, NULL, NULL, NULL, 4),
(26973, NULL, 'G3DSA:3.50.70.10:FF:000006', NULL, NULL, 'Chalcone-flavonone isomerase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(26974, NULL, 'G3DSA:1.20.1070.10:FF:001960', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(26975, NULL, 'G3DSA:3.30.1490.40:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26976, NULL, 'G3DSA:1.20.1090.10:FF:000005', NULL, NULL, 'Alcohol dehydrogenase YqhD', NULL, NULL, NULL, NULL, NULL, 4),
(26977, NULL, 'G3DSA:3.30.160.60:FF:004289', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26978, NULL, 'G3DSA:2.70.98.10:FF:000015', NULL, NULL, 'Aldose 1-epimerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(26979, NULL, 'G3DSA:3.30.70.1990:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26980, NULL, 'G3DSA:1.25.40.480:FF:000001', NULL, NULL, 'Bystin (51.6 kD)-like', NULL, NULL, NULL, NULL, NULL, 4),
(26981, NULL, 'G3DSA:2.40.37.10:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26982, NULL, 'G3DSA:3.40.50.300:FF:008494', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26983, NULL, 'G3DSA:2.130.10.10:FF:002726', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26984, NULL, 'G3DSA:1.20.920.30:FF:000015', NULL, NULL, 'Dynein heavy chain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(26985, NULL, 'G3DSA:2.60.40.10:FF:003221', NULL, NULL, 'Si:ch73-296e2.3', NULL, NULL, NULL, NULL, NULL, 4),
(26986, NULL, 'G3DSA:1.10.1240.40:FF:000001', NULL, NULL, 'BRCA2-interacting transcriptional repressor EMSY isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(26987, NULL, 'G3DSA:3.40.1440.10:FF:000004', NULL, NULL, 'UV-repair endonuclease Cho', NULL, NULL, NULL, NULL, NULL, 4),
(26988, NULL, 'G3DSA:1.20.920.20:FF:000012', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(26989, NULL, 'G3DSA:1.20.58.1100:FF:000009', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(26990, NULL, 'G3DSA:3.40.50.11260:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(26991, NULL, 'G3DSA:1.10.8.10:FF:000030', NULL, NULL, 'E3 ubiquitin-protein ligase CBL', NULL, NULL, NULL, NULL, NULL, 4),
(26992, NULL, 'G3DSA:3.40.50.1000:FF:000710', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(26993, NULL, 'G3DSA:3.40.190.290:FF:000016', NULL, NULL, 'Nitrogen assimilation regulatory protein nac', NULL, NULL, NULL, NULL, NULL, 4),
(26994, NULL, 'G3DSA:1.25.40.10:FF:005289', NULL, NULL, 'Pentatricopeptide repeat (PPR) superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(26995, NULL, 'G3DSA:3.30.497.10:FF:000060', NULL, NULL, 'Serpin peptidase inhibitor, clade B (ovalbumin), member 1', NULL, NULL, NULL, NULL, NULL, 4),
(26996, NULL, 'G3DSA:3.30.420.40:FF:000296', NULL, NULL, 'Glucokinase', NULL, NULL, NULL, NULL, NULL, 4),
(26997, NULL, 'G3DSA:1.25.40.10:FF:000354', NULL, NULL, 'UBA domain-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(26998, NULL, 'G3DSA:1.20.1250.20:FF:002123', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(26999, NULL, 'G3DSA:3.30.70.330:FF:000432', NULL, NULL, 'Splicing factor 3B subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(27000, NULL, 'G3DSA:1.25.10.10:FF:001032', NULL, NULL, 'WGS project CABT00000000 data, contig 2.8', NULL, NULL, NULL, NULL, NULL, 4),
(27001, NULL, 'G3DSA:1.20.1070.10:FF:001533', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27002, NULL, 'G3DSA:3.10.490.10:FF:000037', NULL, NULL, 'Gamma-glutamyl cyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(27003, NULL, 'G3DSA:1.10.418.10:FF:000237', NULL, NULL, 'Actinin alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(27004, NULL, 'G3DSA:3.30.40.10:FF:001859', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27005, NULL, 'G3DSA:2.130.10.10:FF:004508', NULL, NULL, 'Pre-rRNA-processing protein crb3/ipi3', NULL, NULL, NULL, NULL, NULL, 4),
(27006, NULL, 'G3DSA:1.25.40.730:FF:000008', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(27007, NULL, 'G3DSA:3.40.350.10:FF:000054', NULL, NULL, 'Aminopeptidase P', NULL, NULL, NULL, NULL, NULL, 4),
(27008, NULL, 'G3DSA:3.40.50.2000:FF:000324', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(27009, NULL, 'G3DSA:3.30.450.40:FF:000236', NULL, NULL, 'Sensor diguanylate cyclase, GAF domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(27010, NULL, 'G3DSA:3.90.79.10:FF:000086', NULL, NULL, 'Cleavage and polyadenylation specificity factor subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(27011, NULL, 'G3DSA:1.10.510.10:FF:004325', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27012, NULL, 'G3DSA:3.60.21.10:FF:000409', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(27013, NULL, 'G3DSA:1.20.940.10:FF:000010', NULL, NULL, 'Protein transport protein SEC31 B', NULL, NULL, NULL, NULL, NULL, 4),
(27014, NULL, 'G3DSA:2.40.10.10:FF:000606', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27015, NULL, 'G3DSA:1.20.58.1590:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27016, NULL, 'G3DSA:3.30.590.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27017, NULL, 'G3DSA:3.30.70.330:FF:000802', NULL, NULL, 'Enhancer binding protein-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27018, NULL, 'G3DSA:4.10.400.10:FF:000298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27019, NULL, 'G3DSA:3.40.50.880:FF:000085', NULL, NULL, 'DJ-1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(27020, NULL, 'G3DSA:2.60.120.10:FF:000694', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27021, NULL, 'G3DSA:3.90.640.10:FF:000205', NULL, NULL, 'Protein CBG03751', NULL, NULL, NULL, NULL, NULL, 4),
(27022, NULL, 'G3DSA:2.20.70.10:FF:000217', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(27023, NULL, 'G3DSA:3.30.1540.20:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27024, NULL, 'G3DSA:1.20.1510.10:FF:000033', NULL, NULL, 'Unplaced genomic scaffold supercont1.9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(27025, NULL, 'G3DSA:2.60.120.260:FF:000276', NULL, NULL, 'Beta-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(27026, NULL, 'G3DSA:3.30.2350.10:FF:000011', NULL, NULL, 'tRNA pseudouridine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(27027, NULL, 'G3DSA:3.90.1100.10:FF:000018', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(27028, NULL, 'G3DSA:1.10.420.10:FF:000035', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(27029, NULL, 'G3DSA:3.40.50.1240:FF:000068', NULL, NULL, 'Putative 2-carboxy-D-arabinitol-1-phosphatase isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(27030, NULL, 'G3DSA:3.30.2350.20:FF:000014', NULL, NULL, 'tRNA pseudouridine synthase D (TruD)', NULL, NULL, NULL, NULL, NULL, 4),
(27031, NULL, 'G3DSA:3.90.550.50:FF:000115', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(27032, NULL, 'G3DSA:3.40.50.2000:FF:000072', NULL, NULL, 'Glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(27033, NULL, 'G3DSA:3.40.1090.10:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27034, NULL, 'G3DSA:1.20.58.670:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27035, NULL, 'G3DSA:3.40.190.10:FF:000266', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(27036, NULL, 'G3DSA:3.60.15.10:FF:000030', NULL, NULL, 'Metallo-beta-lactamase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(27037, NULL, 'G3DSA:1.20.58.760:FF:000015', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH 3', NULL, NULL, NULL, NULL, NULL, 4),
(27038, NULL, 'G3DSA:2.40.50.140:FF:000552', NULL, NULL, 'Cold shock domain containing C2', NULL, NULL, NULL, NULL, NULL, 4),
(27039, NULL, 'G3DSA:1.10.600.10:FF:000133', NULL, NULL, 'Terpenoid synthases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(27040, NULL, 'G3DSA:3.30.70.3040:FF:000004', NULL, NULL, 'Cell division protein FtsX', NULL, NULL, NULL, NULL, NULL, 4),
(27041, NULL, 'G3DSA:2.20.25.80:FF:000004', NULL, NULL, 'WRKY transcription factor 65', NULL, NULL, NULL, NULL, NULL, 4),
(27042, NULL, 'G3DSA:2.20.25.90:FF:000007', NULL, NULL, 'Assimilatory nitrate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(27043, NULL, 'G3DSA:2.40.330.10:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27044, NULL, 'G3DSA:2.10.50.30:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27045, NULL, 'G3DSA:3.80.20.20:FF:000027', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(27046, NULL, 'G3DSA:1.10.533.10:FF:000308', NULL, NULL, 'Retinoic acid-inducible protein Ia', NULL, NULL, NULL, NULL, NULL, 4),
(27047, NULL, 'G3DSA:3.30.70.3030:FF:000001', NULL, NULL, 'Nucleolar protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(27048, NULL, 'G3DSA:3.20.20.70:FF:000449', NULL, NULL, 'N-(5''-phosphoribosyl)anthranilate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(27049, NULL, 'G3DSA:2.40.10.10:FF:000595', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27050, NULL, 'G3DSA:3.40.50.620:FF:000501', NULL, NULL, 'Diphthine--ammonia ligase', NULL, NULL, NULL, NULL, NULL, 4),
(27051, NULL, 'G3DSA:2.120.10.80:FF:000218', NULL, NULL, 'LD20420p', NULL, NULL, NULL, NULL, NULL, 4),
(27052, NULL, 'G3DSA:2.130.10.10:FF:000456', NULL, NULL, 'aladin isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(27053, NULL, 'G3DSA:1.20.144.10:FF:000059', NULL, NULL, 'Phospholipid phosphatase 2b', NULL, NULL, NULL, NULL, NULL, 4),
(27054, NULL, 'G3DSA:1.10.533.10:FF:000297', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(27055, NULL, 'G3DSA:3.30.160.60:FF:003125', NULL, NULL, 'Putative zinc finger protein 66', NULL, NULL, NULL, NULL, NULL, 4),
(27056, NULL, 'G3DSA:2.40.110.10:FF:000046', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(27057, NULL, 'G3DSA:3.80.10.10:FF:000405', NULL, NULL, 'Plant intracellular Ras-group-related LRR protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(27058, NULL, 'G3DSA:1.20.5.4770:FF:000008', NULL, NULL, 'Zinc finger A20 and AN1 domain-containing stress-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(27059, NULL, 'G3DSA:2.60.120.340:FF:000002', NULL, NULL, 'Nucleophosmin/nucleoplasmin 3', NULL, NULL, NULL, NULL, NULL, 4),
(27060, NULL, 'G3DSA:1.25.40.10:FF:002416', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(27061, NULL, 'G3DSA:2.60.120.200:FF:000320', NULL, NULL, 'Collagen alpha-1(IX) chain', NULL, NULL, NULL, NULL, NULL, 4),
(27062, NULL, 'G3DSA:1.10.510.10:FF:004426', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27063, NULL, 'G3DSA:2.10.25.10:FF:001390', NULL, NULL, 'Vasorin', NULL, NULL, NULL, NULL, NULL, 4),
(27064, NULL, 'G3DSA:1.20.58.60:FF:000352', NULL, NULL, 'SMAll', NULL, NULL, NULL, NULL, NULL, 4),
(27065, NULL, 'G3DSA:2.30.30.30:FF:000142', NULL, NULL, 'E3 ubiquitin-protein ligase UHRF2', NULL, NULL, NULL, NULL, NULL, 4),
(27066, NULL, 'G3DSA:3.30.200.20:FF:001864', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27067, NULL, 'G3DSA:3.30.1520.10:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27068, NULL, 'G3DSA:1.10.238.10:FF:000364', NULL, NULL, 'Calmodulin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27069, NULL, 'G3DSA:2.40.10.10:FF:000707', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27070, NULL, 'G3DSA:2.160.20.10:FF:000157', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(27071, NULL, 'G3DSA:2.60.260.20:FF:000061', NULL, NULL, 'Scj1p', NULL, NULL, NULL, NULL, NULL, 4),
(27072, NULL, 'G3DSA:3.40.30.10:FF:000757', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27073, NULL, 'G3DSA:3.40.30.10:FF:001263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27074, NULL, 'G3DSA:1.10.506.10:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27075, NULL, 'G3DSA:3.40.50.10810:FF:000162', NULL, NULL, 'Putative snf2 family dna-dependent atpase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(27076, NULL, 'G3DSA:1.20.1310.10:FF:000052', NULL, NULL, 'Anaphase-promoting complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(27077, NULL, 'G3DSA:3.60.70.12:FF:000002', NULL, NULL, 'Arginine biosynthesis bifunctional protein ArgJ, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(27078, NULL, 'G3DSA:3.40.190.10:FF:000709', NULL, NULL, 'Sugar ABC transporter, periplasmic sugar-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(27079, NULL, 'G3DSA:3.80.10.10:FF:003424', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(27080, NULL, 'G3DSA:1.10.10.10:FF:000346', NULL, NULL, 'PadR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(27081, NULL, 'G3DSA:3.10.450.350:FF:000011', NULL, NULL, 'Cell wall endopeptidase family M23/M37', NULL, NULL, NULL, NULL, NULL, 4),
(27082, NULL, 'G3DSA:2.130.10.10:FF:002827', NULL, NULL, 'Suppressor of mec-8 and unc-52 protein-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(27083, NULL, 'G3DSA:3.80.10.10:FF:001524', NULL, NULL, 'Leucine Rich Repeat family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(27084, NULL, 'G3DSA:3.40.50.150:FF:000883', NULL, NULL, 'Outer capsid protein lambda-2', NULL, NULL, NULL, NULL, NULL, 4),
(27085, NULL, 'G3DSA:3.40.50.2000:FF:000633', NULL, NULL, 'Os10g0332300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(27086, NULL, 'G3DSA:1.10.472.130:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27087, NULL, 'G3DSA:1.20.5.370:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27088, NULL, 'G3DSA:1.25.40.780:FF:000001', NULL, NULL, 'TIR domain-containing adapter molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(27089, NULL, 'G3DSA:3.90.420.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(27090, NULL, 'G3DSA:2.40.70.10:FF:000469', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27091, NULL, 'G3DSA:3.30.70.330:FF:000229', NULL, NULL, 'Squamous cell carcinoma antigen recognized by T-cells 3', NULL, NULL, NULL, NULL, NULL, 4),
(27092, NULL, 'G3DSA:3.30.497.10:FF:000076', NULL, NULL, 'Angiotensinogen', NULL, NULL, NULL, NULL, NULL, 4),
(27093, NULL, 'G3DSA:2.30.30.40:FF:000145', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(27094, NULL, 'G3DSA:3.40.50.300:FF:002654', NULL, NULL, 'Cytoplasmic dynein 2 heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(27095, NULL, 'G3DSA:1.10.510.10:FF:002526', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27096, NULL, 'G3DSA:3.40.50.300:FF:005211', NULL, NULL, 'Adenylate kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27097, NULL, 'G3DSA:1.25.40.10:FF:000146', NULL, NULL, 'Clathrin-coated vesiclec protein (Bud7)', NULL, NULL, NULL, NULL, NULL, 4),
(27098, NULL, 'G3DSA:1.10.10.60:FF:000254', NULL, NULL, 'transcription repressor MYB5-like', NULL, NULL, NULL, NULL, NULL, 4),
(27099, NULL, 'G3DSA:1.10.287.1490:FF:000085', NULL, NULL, 'DNA repair ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(27100, NULL, 'G3DSA:2.40.100.10:FF:000118', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(27101, NULL, 'G3DSA:3.30.505.10:FF:000097', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(27102, NULL, 'G3DSA:3.90.1420.10:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27103, NULL, 'G3DSA:3.90.70.200:FF:000008', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(27104, NULL, 'G3DSA:2.60.120.650:FF:000224', NULL, NULL, 'Bifunctional arginine demethylase and lysyl-hydroxylase psr-1', NULL, NULL, NULL, NULL, NULL, 4),
(27105, NULL, 'G3DSA:3.90.1640.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27106, NULL, 'G3DSA:3.30.160.60:FF:001107', NULL, NULL, 'POZ-, AT hook-, and zinc finger-containing protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(27107, NULL, 'G3DSA:3.30.2170.10:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27108, NULL, 'G3DSA:3.40.570.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27109, NULL, 'G3DSA:3.30.160.60:FF:002962', NULL, NULL, 'Zinc finger domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(27110, NULL, 'G3DSA:3.30.200.20:FF:000228', NULL, NULL, 'Serine/threonine-protein kinase BIK1', NULL, NULL, NULL, NULL, NULL, 4),
(27111, NULL, 'G3DSA:3.40.50.720:FF:001588', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27112, NULL, 'G3DSA:3.10.20.230:FF:000031', NULL, NULL, 'Doublecortin like kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(27113, NULL, 'G3DSA:2.130.10.10:FF:004626', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27114, NULL, 'G3DSA:3.40.50.300:FF:006285', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(27115, NULL, 'G3DSA:1.10.10.60:FF:000355', NULL, NULL, 'Transcription factor MYB124', NULL, NULL, NULL, NULL, NULL, 4),
(27116, NULL, 'G3DSA:3.40.50.1820:FF:001681', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27117, NULL, 'G3DSA:3.40.50.300:FF:007111', NULL, NULL, 'Small GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27118, NULL, 'G3DSA:3.30.70.330:FF:001966', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27119, NULL, 'G3DSA:1.10.10.10:FF:000817', NULL, NULL, 'Transcriptional regulator, GntR family', NULL, NULL, NULL, NULL, NULL, 4),
(27120, NULL, 'G3DSA:2.60.120.1540:FF:000008', NULL, NULL, 'Complement C5', NULL, NULL, NULL, NULL, NULL, 4),
(27121, NULL, 'G3DSA:2.60.40.150:FF:000195', NULL, NULL, 'Synapse defective Rho GTPase homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(27122, NULL, 'G3DSA:1.20.1070.10:FF:000414', NULL, NULL, 'Cholecystokinin A receptor', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(27123, NULL, 'G3DSA:3.90.550.10:FF:000480', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27124, NULL, 'G3DSA:3.40.50.300:FF:001260', NULL, NULL, 'Putative ABC transporter ATP-binding component', NULL, NULL, NULL, NULL, NULL, 4),
(27125, NULL, 'G3DSA:1.20.1250.20:FF:001960', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27126, NULL, 'G3DSA:2.60.120.650:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27127, NULL, 'G3DSA:1.10.10.410:FF:000001', NULL, NULL, 'Aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(27128, NULL, 'G3DSA:3.40.50.300:FF:008393', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27129, NULL, 'G3DSA:2.130.10.10:FF:000927', NULL, NULL, 'Transcription factor (SPT8), putative', NULL, NULL, NULL, NULL, NULL, 4),
(27130, NULL, 'G3DSA:1.20.870.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27131, NULL, 'G3DSA:3.30.200.20:FF:001965', NULL, NULL, 'Mitosis inhibitor protein kinase mik1', NULL, NULL, NULL, NULL, NULL, 4),
(27132, NULL, 'G3DSA:3.40.850.10:FF:000047', NULL, NULL, 'Kinesin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(27133, NULL, 'G3DSA:1.10.3720.10:FF:000052', NULL, NULL, 'Sulfonate ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(27134, NULL, 'G3DSA:3.10.129.10:FF:000007', NULL, NULL, 'Thioesterase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(27135, NULL, 'G3DSA:3.40.50.1980:FF:000144', NULL, NULL, 'Periplasmic binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(27136, NULL, 'G3DSA:4.10.1170.10:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27137, NULL, 'G3DSA:1.20.1250.20:FF:001718', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27138, NULL, 'G3DSA:3.40.50.300:FF:000754', NULL, NULL, 'Guanine nucleotide-binding protein subunit alpha-13', NULL, NULL, NULL, NULL, NULL, 4),
(27139, NULL, 'G3DSA:2.60.120.260:FF:000068', NULL, NULL, 'Adipocyte enhancer-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(27140, NULL, 'G3DSA:3.60.15.10:FF:000131', NULL, NULL, 'Zn-dependent hydrolases, including glyoxylases', NULL, NULL, NULL, NULL, NULL, 4),
(27141, NULL, 'G3DSA:3.40.50.300:FF:003160', NULL, NULL, 'Initiator protein NS1', NULL, NULL, NULL, NULL, NULL, 4),
(27142, NULL, 'G3DSA:3.40.50.970:FF:000022', NULL, NULL, '2-oxoglutarate ferredoxin oxidoreductase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(27143, NULL, 'G3DSA:4.10.60.10:FF:000027', NULL, NULL, 'serine/arginine-rich splicing factor 7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(27144, NULL, 'G3DSA:3.30.1640.10:FF:000084', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(27145, NULL, 'G3DSA:3.30.2410.10:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27146, NULL, 'G3DSA:1.10.472.10:FF:000054', NULL, NULL, 'origin recognition complex subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(27147, NULL, 'G3DSA:2.130.10.10:FF:002165', NULL, NULL, 'Suppressor of organelle fusion 2', NULL, NULL, NULL, NULL, NULL, 4),
(27148, NULL, 'G3DSA:2.10.25.10:FF:001288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27149, NULL, 'G3DSA:3.40.50.80:FF:000048', NULL, NULL, 'Ferric reduction oxidase 5', NULL, NULL, NULL, NULL, NULL, 4),
(27150, NULL, 'G3DSA:3.40.50.2300:FF:000408', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(27151, NULL, 'G3DSA:1.50.40.10:FF:000099', NULL, NULL, 'Mitochondrial carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(27152, NULL, 'G3DSA:2.120.10.80:FF:000319', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27153, NULL, 'G3DSA:3.40.50.300:FF:008084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27154, NULL, 'G3DSA:3.40.50.1240:FF:000170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27155, NULL, 'G3DSA:1.10.8.60:FF:000388', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(27156, NULL, 'G3DSA:1.20.120.20:FF:000035', NULL, NULL, 'Reticulon-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(27157, NULL, 'G3DSA:3.30.70.1290:FF:000001', NULL, NULL, 'REP-associated tyrosine transposase', NULL, NULL, NULL, NULL, NULL, 4),
(27158, NULL, 'G3DSA:1.20.5.190:FF:000058', NULL, NULL, 'IQ motif containing B1', NULL, NULL, NULL, NULL, NULL, 4),
(27159, NULL, 'G3DSA:3.10.20.90:FF:000293', NULL, NULL, 'Tyrosine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(27160, NULL, 'G3DSA:3.10.350.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27161, NULL, 'G3DSA:1.20.120.720:FF:000036', NULL, NULL, 'Unconventional myosin ID', NULL, NULL, NULL, NULL, NULL, 4),
(27162, NULL, 'G3DSA:3.10.100.10:FF:000352', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27163, NULL, 'G3DSA:1.10.10.60:FF:000916', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27164, NULL, 'G3DSA:1.10.220.160:FF:000017', NULL, NULL, 'GH11294p', NULL, NULL, NULL, NULL, NULL, 4),
(27165, NULL, 'G3DSA:3.40.47.10:FF:000183', NULL, NULL, '3-oxoacyl-(Acyl-carrier-protein) synthase III, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27166, NULL, 'G3DSA:3.30.70.330:FF:002231', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27167, NULL, 'G3DSA:3.40.630.10:FF:000430', NULL, NULL, 'Clan MH, family M28, aminopeptidase S-like metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(27168, NULL, 'G3DSA:3.30.40.10:FF:000106', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(27169, NULL, 'G3DSA:3.40.50.300:FF:002906', NULL, NULL, 'Chromosome segregation in meiosis protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(27170, NULL, 'G3DSA:3.30.200.20:FF:000537', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(27171, NULL, 'G3DSA:3.40.50.300:FF:006706', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27172, NULL, 'G3DSA:2.40.50.140:FF:000344', NULL, NULL, 'Replication protein A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(27173, NULL, 'G3DSA:1.10.132.70:FF:000018', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(27174, NULL, 'G3DSA:1.10.167.10:FF:000058', NULL, NULL, 'G protein-coupled receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(27175, NULL, 'G3DSA:2.40.30.10:FF:000506', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27176, NULL, 'G3DSA:3.20.20.80:FF:000502', NULL, NULL, 'Glycoside hydrolase family 17 protein', NULL, NULL, NULL, NULL, NULL, 4),
(27177, NULL, 'G3DSA:3.30.710.10:FF:000500', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27178, NULL, 'G3DSA:3.40.50.300:FF:004694', NULL, NULL, 'Probable mitochondrial Rho GTPase gemA', NULL, NULL, NULL, NULL, NULL, 4),
(27179, NULL, 'G3DSA:3.30.300.130:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27180, NULL, 'G3DSA:1.20.920.10:FF:000110', NULL, NULL, 'RSC complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(27181, NULL, 'G3DSA:3.40.50.170:FF:000012', NULL, NULL, 'Phosphoribosylglycinamide formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(27182, NULL, 'G3DSA:3.40.50.970:FF:000229', NULL, NULL, 'Transketolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27183, NULL, 'G3DSA:1.25.70.10:FF:000092', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27184, NULL, 'G3DSA:3.40.50.300:FF:004806', NULL, NULL, 'GTP-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(27185, NULL, 'G3DSA:3.30.70.1170:FF:000016', NULL, NULL, 'Nop2 (NOP2)/SUN domain family member', NULL, NULL, NULL, NULL, NULL, 4),
(27186, NULL, 'G3DSA:1.10.760.10:FF:000083', NULL, NULL, 'Cytochrome c peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(27187, NULL, 'G3DSA:3.50.50.60:FF:001189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27188, NULL, 'G3DSA:2.60.40.10:FF:004547', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27189, NULL, 'G3DSA:3.30.420.40:FF:000408', NULL, NULL, 'Heat shock protein 70, putative', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(27190, NULL, 'G3DSA:1.25.40.10:FF:001899', NULL, NULL, 'Protein F54C1.5/ TPR repeat family', NULL, NULL, NULL, NULL, NULL, 4),
(27191, NULL, 'G3DSA:2.30.180.10:FF:000165', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27192, NULL, 'G3DSA:3.30.1370.10:FF:000203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27193, NULL, 'G3DSA:2.120.10.80:FF:000112', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(27194, NULL, 'G3DSA:1.10.132.60:FF:000015', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(27195, NULL, 'G3DSA:3.40.50.1100:FF:000285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27196, NULL, 'G3DSA:1.10.220.30:FF:000020', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(27197, NULL, 'G3DSA:3.40.50.1820:FF:001439', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27198, NULL, 'G3DSA:1.20.1050.10:FF:000306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27199, NULL, 'G3DSA:2.130.10.10:FF:004065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27200, NULL, 'G3DSA:2.130.10.10:FF:000720', NULL, NULL, 'Dynein assembly factor with WDR repeat domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(27201, NULL, 'G3DSA:3.90.110.10:FF:000014', NULL, NULL, 'Malate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(27202, NULL, 'G3DSA:2.10.110.10:FF:000305', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(27203, NULL, 'G3DSA:1.25.10.10:FF:002460', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(27204, NULL, 'G3DSA:3.90.79.10:FF:000232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27205, NULL, 'G3DSA:3.30.530.20:FF:000085', NULL, NULL, 'Cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(27206, NULL, 'G3DSA:3.40.50.300:FF:003879', NULL, NULL, 'Tuzin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27207, NULL, 'G3DSA:1.10.260.40:FF:000031', NULL, NULL, 'DNA-binding transcriptional repressor EbgR', NULL, NULL, NULL, NULL, NULL, 4),
(27208, NULL, 'G3DSA:2.60.260.20:FF:000151', NULL, NULL, 'AGAP006578-PA', NULL, NULL, NULL, NULL, NULL, 4),
(27209, NULL, 'G3DSA:3.30.420.40:FF:000650', NULL, NULL, 'Actin-related protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(27210, NULL, 'G3DSA:3.30.200.20:FF:002218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27211, NULL, 'G3DSA:3.30.750.24:FF:000044', NULL, NULL, 'Sulfate permease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(27212, NULL, 'G3DSA:3.30.1360.10:FF:000023', NULL, NULL, 'DNA-directed RNA polymerase II subunit RPB11', NULL, NULL, NULL, NULL, NULL, 4),
(27213, NULL, 'G3DSA:1.10.510.10:FF:002835', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(27214, NULL, 'G3DSA:2.60.40.10:FF:002086', NULL, NULL, 'Tyrosine-protein kinase-like otk', NULL, NULL, NULL, NULL, NULL, 4),
(27215, NULL, 'G3DSA:3.80.10.10:FF:003733', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27216, NULL, 'G3DSA:1.25.40.180:FF:000124', NULL, NULL, 'Protein CBG18870', NULL, NULL, NULL, NULL, NULL, 4),
(27217, NULL, 'G3DSA:1.10.238.10:FF:000673', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27218, NULL, 'G3DSA:2.170.130.10:FF:000033', NULL, NULL, 'Heme transport protein HutA', NULL, NULL, NULL, NULL, NULL, 4),
(27219, NULL, 'G3DSA:3.10.110.10:FF:000178', NULL, NULL, 'Tumor Susceptibility Gene homolog', NULL, NULL, NULL, NULL, NULL, 4),
(27220, NULL, 'G3DSA:1.10.510.10:FF:000935', NULL, NULL, 'Exported serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(27221, NULL, 'G3DSA:3.30.1520.10:FF:000018', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(27222, NULL, 'G3DSA:2.130.10.30:FF:000113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27223, NULL, 'G3DSA:1.10.10.10:FF:000907', NULL, NULL, 'Probable transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(27224, NULL, 'G3DSA:3.30.300.30:FF:000020', NULL, NULL, 'Long-chain fatty acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(27225, NULL, 'G3DSA:2.60.120.260:FF:000422', NULL, NULL, 'Xaa-Pro aminopeptidase P', NULL, NULL, NULL, NULL, NULL, 4),
(27226, NULL, 'G3DSA:2.60.40.1110:FF:000008', NULL, NULL, '1,4-alpha-glucan branching enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(27227, NULL, 'G3DSA:3.30.70.980:FF:000059', NULL, NULL, 'Probable transcriptional regulatory protein C8D2.12c', NULL, NULL, NULL, NULL, NULL, 4),
(27228, NULL, 'G3DSA:3.30.160.60:FF:004862', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27229, NULL, 'G3DSA:3.30.9.10:FF:000298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27230, NULL, 'G3DSA:3.90.1340.10:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27231, NULL, 'G3DSA:3.30.750.160:FF:000001', NULL, NULL, 'Nudix hydrolase 20, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(27232, NULL, 'G3DSA:3.30.1330.30:FF:000089', NULL, NULL, 'Ribosomal protein L7a', NULL, NULL, NULL, NULL, NULL, 4),
(27233, NULL, 'G3DSA:1.10.510.10:FF:000374', NULL, NULL, 'Putative cyclin-dependent kinase E-1', NULL, NULL, NULL, NULL, NULL, 4),
(27234, NULL, 'G3DSA:1.10.510.10:FF:000626', NULL, NULL, 'probable L-type lectin-domain containing receptor kinase S.5', NULL, NULL, NULL, NULL, NULL, 4),
(27235, NULL, 'G3DSA:2.40.50.100:FF:000029', NULL, NULL, 'propionyl-CoA carboxylase alpha chain, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(27236, NULL, 'G3DSA:3.30.70.330:FF:002129', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27237, NULL, 'G3DSA:3.30.890.10:FF:000029', NULL, NULL, 'Methyl-CpG-binding domain-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(27238, NULL, 'G3DSA:3.50.7.10:FF:000030', NULL, NULL, '60 kDa chaperonin GROEL', NULL, NULL, NULL, NULL, NULL, 4),
(27239, NULL, 'G3DSA:1.25.10.10:FF:000318', NULL, NULL, 'Serine/threonine-protein phosphatase 2A regulatory subunit A gamma isoform', NULL, NULL, NULL, NULL, NULL, 4),
(27240, NULL, 'G3DSA:3.10.100.10:FF:000043', NULL, NULL, 'lymphocyte antigen 75 precursor', NULL, NULL, NULL, NULL, NULL, 4),
(27241, NULL, 'G3DSA:3.30.700.10:FF:000011', NULL, NULL, 'Type 4 pili biogenesis protein (Prepilin-like protein)', NULL, NULL, NULL, NULL, NULL, 4),
(27242, NULL, 'G3DSA:2.10.110.10:FF:000053', NULL, NULL, 'Actin-binding LIM protein family, member 2', NULL, NULL, NULL, NULL, NULL, 4),
(27243, NULL, 'G3DSA:2.60.40.10:FF:004856', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27244, NULL, 'G3DSA:3.90.280.10:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27245, NULL, 'G3DSA:3.40.630.10:FF:000076', NULL, NULL, 'Carboxypeptidase B2', NULL, NULL, NULL, NULL, NULL, 4),
(27246, NULL, 'G3DSA:1.20.1070.10:FF:002005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27247, NULL, 'G3DSA:3.80.10.10:FF:001833', NULL, NULL, 'Insulin-like growth factor-binding protein complex acid labile subunit', NULL, NULL, NULL, NULL, NULL, 4),
(27248, NULL, 'G3DSA:1.10.220.150:FF:000014', NULL, NULL, 'ADP-ribosylation factor GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(27249, NULL, 'G3DSA:3.40.50.620:FF:000046', NULL, NULL, 'tRNA-cytidine(32) 2-sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(27250, NULL, 'G3DSA:3.30.200.20:FF:000318', NULL, NULL, 'C-type lectin receptor-like tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(27251, NULL, 'G3DSA:2.60.40.10:FF:001422', NULL, NULL, 'T-cell surface glycoprotein CD3 epsilon chain', NULL, NULL, NULL, NULL, NULL, 4),
(27252, NULL, 'G3DSA:3.40.50.12390:FF:000006', NULL, NULL, 'Putative 5''-3'' exonuclease XRNC', NULL, NULL, NULL, NULL, NULL, 4),
(27253, NULL, 'G3DSA:3.30.430.20:FF:000021', NULL, NULL, 'Protein kinase domain containing protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(27254, NULL, 'G3DSA:3.30.160.60:FF:004553', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27255, NULL, 'G3DSA:3.30.1490.190:FF:000010', NULL, NULL, 'Cation uptake regulator', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(27256, NULL, 'G3DSA:3.30.750.24:FF:000145', NULL, NULL, 'Pendrin', NULL, NULL, NULL, NULL, NULL, 4),
(27257, NULL, 'G3DSA:3.40.390.10:FF:000028', NULL, NULL, 'Zinc metalloproteinase', NULL, NULL, NULL, NULL, NULL, 4),
(27258, NULL, 'G3DSA:3.30.300.180:FF:000024', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(27259, NULL, 'G3DSA:3.90.79.10:FF:000007', NULL, NULL, 'NUDIX hydrolase YfcD', NULL, NULL, NULL, NULL, NULL, 4),
(27260, NULL, 'G3DSA:2.40.160.110:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27261, NULL, 'G3DSA:1.20.1310.10:FF:000158', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27262, NULL, 'G3DSA:2.60.40.1120:FF:000028', NULL, NULL, 'CarboxyPeptidase D family', NULL, NULL, NULL, NULL, NULL, 4),
(27263, NULL, 'G3DSA:1.10.10.60:FF:000664', NULL, NULL, 'Myb-related protein 306', NULL, NULL, NULL, NULL, NULL, 4),
(27264, NULL, 'G3DSA:1.20.1070.10:FF:001387', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27265, NULL, 'G3DSA:3.60.40.10:FF:000060', NULL, NULL, 'Protein phosphatase 2c', NULL, NULL, NULL, NULL, NULL, 4),
(27266, NULL, 'G3DSA:1.25.40.340:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27267, NULL, 'G3DSA:3.30.70.330:FF:001983', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27268, NULL, 'G3DSA:3.30.1060.10:FF:000011', NULL, NULL, 'Peptide methionine sulfoxide reductase MsrA', NULL, NULL, NULL, NULL, NULL, 4),
(27269, NULL, 'G3DSA:3.30.1680.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27270, NULL, 'G3DSA:1.20.272.10:FF:000019', NULL, NULL, 'Protein STICHEL-like 1 isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(27271, NULL, 'G3DSA:1.20.1640.10:FF:000037', NULL, NULL, 'Protein-export membrane protein SecF', NULL, NULL, NULL, NULL, NULL, 4),
(27272, NULL, 'G3DSA:3.90.70.10:FF:000903', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(27273, NULL, 'G3DSA:1.20.1250.20:FF:002207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27274, NULL, 'G3DSA:1.10.10.60:FF:000136', NULL, NULL, 'Transcriptional regulator, AraC family', NULL, NULL, NULL, NULL, NULL, 4),
(27275, NULL, 'G3DSA:3.90.550.50:FF:000132', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(27276, NULL, 'G3DSA:2.40.50.40:FF:000022', NULL, NULL, 'M-phase phosphoprotein 8', NULL, NULL, NULL, NULL, NULL, 4),
(27277, NULL, 'G3DSA:3.40.800.10:FF:000027', NULL, NULL, 'Arginase', NULL, NULL, NULL, NULL, NULL, 4),
(27278, NULL, 'G3DSA:2.60.210.10:FF:000004', NULL, NULL, 'E3 ubiquitin-protein ligase SINAT5-like', NULL, NULL, NULL, NULL, NULL, 4),
(27279, NULL, 'G3DSA:2.40.10.10:FF:000477', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27280, NULL, 'G3DSA:3.80.10.10:FF:004340', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27281, NULL, 'G3DSA:3.90.1100.10:FF:000035', NULL, NULL, 'DNA-directed RNA polymerase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(27282, NULL, 'G3DSA:3.40.395.10:FF:000017', NULL, NULL, 'Protease', NULL, NULL, NULL, NULL, NULL, 4),
(27283, NULL, 'G3DSA:3.30.160.60:FF:000618', NULL, NULL, 'zinc finger protein 341 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(27284, NULL, 'G3DSA:1.25.40.330:FF:000012', NULL, NULL, 'Adenylyl cyclase-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(27285, NULL, 'G3DSA:1.10.510.10:FF:002644', NULL, NULL, 'Probable serine/threonine-protein kinase fhkC', NULL, NULL, NULL, NULL, NULL, 4),
(27286, NULL, 'G3DSA:3.60.15.10:FF:000114', NULL, NULL, 'Protein CBG11581', NULL, NULL, NULL, NULL, NULL, 4),
(27287, NULL, 'G3DSA:3.30.200.20:FF:000644', NULL, NULL, 'Suppressor of npr1-1 constitutive 4', NULL, NULL, NULL, NULL, NULL, 4),
(27288, NULL, 'G3DSA:2.60.40.150:FF:000515', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27289, NULL, 'G3DSA:1.10.287.2620:FF:000002', NULL, NULL, 'Dynein heavy chain 2, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(27290, NULL, 'G3DSA:1.10.472.10:FF:000508', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(27291, NULL, 'G3DSA:3.30.1490.100:FF:000040', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(27292, NULL, 'G3DSA:1.10.238.230:FF:000005', NULL, NULL, 'Serine/threonine-protein phosphatase 2A regulatory subunit B'''' subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(27293, NULL, 'G3DSA:3.40.50.150:FF:000473', NULL, NULL, 'RNA-directed RNA polymerase L', NULL, NULL, NULL, NULL, NULL, 4),
(27294, NULL, 'G3DSA:3.40.47.10:FF:000060', NULL, NULL, 'Acetyl-CoA acyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(27295, NULL, 'G3DSA:1.25.40.10:FF:002506', NULL, NULL, 'DUF3868 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(27296, NULL, 'G3DSA:1.10.1300.10:FF:000036', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(27297, NULL, 'G3DSA:3.80.10.10:FF:001743', NULL, NULL, 'GD14405', NULL, NULL, NULL, NULL, NULL, 4),
(27298, NULL, 'G3DSA:3.30.70.1400:FF:000001', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(27299, NULL, 'G3DSA:1.10.510.10:FF:000508', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(27300, NULL, 'G3DSA:2.60.40.1400:FF:000005', NULL, NULL, 'G protein-activated inward rectifier potassium channel 2', NULL, NULL, NULL, NULL, NULL, 4),
(27301, NULL, 'G3DSA:4.10.520.10:FF:000014', NULL, NULL, 'DNA-binding protein HU', NULL, NULL, NULL, NULL, NULL, 4),
(27302, NULL, 'G3DSA:3.10.110.10:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27303, NULL, 'G3DSA:3.10.110.10:FF:000072', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 W', NULL, NULL, NULL, NULL, NULL, 4),
(27304, NULL, 'G3DSA:1.10.220.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27305, NULL, 'G3DSA:3.40.50.720:FF:000104', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(27306, NULL, 'G3DSA:2.60.40.770:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27307, NULL, 'G3DSA:3.40.525.10:FF:000067', NULL, NULL, 'Putative Rho GTPase-activating protein C1565.02c', NULL, NULL, NULL, NULL, NULL, 4),
(27308, NULL, 'G3DSA:1.10.510.10:FF:000497', NULL, NULL, 'Phosphoinositide 3-kinase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(27309, NULL, 'G3DSA:3.90.226.10:FF:000108', NULL, NULL, 'Acetyl-coenzyme A carboxylase carboxyl transferase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(27310, NULL, 'G3DSA:3.80.20.20:FF:000044', NULL, NULL, 'GPI-anchored cell wall protein Pst1, putative (AFU_orthologue AFUA_6G10290)', NULL, NULL, NULL, NULL, NULL, 4),
(27311, NULL, 'G3DSA:2.130.10.10:FF:003699', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27312, NULL, 'G3DSA:1.10.472.10:FF:000615', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27313, NULL, 'G3DSA:3.30.160.60:FF:006453', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27314, NULL, 'G3DSA:1.10.287.1270:FF:000002', NULL, NULL, 'G protein-coupled receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(27315, NULL, 'G3DSA:3.90.550.10:FF:000586', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(27316, NULL, 'G3DSA:1.20.1530.20:FF:000009', NULL, NULL, 'Arsenite transporter, ACR3 family', NULL, NULL, NULL, NULL, NULL, 4),
(27317, NULL, 'G3DSA:2.70.130.10:FF:000097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27318, NULL, 'G3DSA:1.10.238.10:FF:000583', NULL, NULL, 'Sodium/calcium exchanger NCL', NULL, NULL, NULL, NULL, NULL, 4),
(27319, NULL, 'G3DSA:3.40.50.720:FF:000430', NULL, NULL, '17-beta-hydroxysteroid dehydrogenase 13 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(27320, NULL, 'G3DSA:2.60.40.10:FF:001012', NULL, NULL, 'Embigin', NULL, NULL, NULL, NULL, NULL, 4),
(27321, NULL, 'G3DSA:1.20.1280.290:FF:000101', NULL, NULL, 'YALI0C15345p', NULL, NULL, NULL, NULL, NULL, 4),
(27322, NULL, 'G3DSA:1.20.1250.20:FF:002314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27323, NULL, 'G3DSA:3.10.100.10:FF:000251', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(27324, NULL, 'G3DSA:2.30.18.10:FF:000012', NULL, NULL, 'Septin and tuftelin-interacting protein 1 homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(27325, NULL, 'G3DSA:3.40.630.10:FF:000429', NULL, NULL, 'Carboxypeptidase A6', NULL, NULL, NULL, NULL, NULL, 4),
(27326, NULL, 'G3DSA:1.10.510.10:FF:002751', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27327, NULL, 'G3DSA:3.40.50.1440:FF:000139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27328, NULL, 'G3DSA:2.60.40.60:FF:000942', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27329, NULL, 'G3DSA:2.30.110.10:FF:000099', NULL, NULL, 'Flavin-dependent trigonelline monooxygenase, reductase component', NULL, NULL, NULL, NULL, NULL, 4),
(27330, NULL, 'G3DSA:1.20.1250.20:FF:001174', NULL, NULL, 'Major facilitator superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(27331, NULL, 'G3DSA:1.20.1070.10:FF:002106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27332, NULL, 'G3DSA:3.30.40.10:FF:002129', NULL, NULL, 'General transcription and DNA repair factor IIH', NULL, NULL, NULL, NULL, NULL, 4),
(27333, NULL, 'G3DSA:3.40.50.300:FF:006369', NULL, NULL, 'Ras homolog family member F, filopodia associated', NULL, NULL, NULL, NULL, NULL, 4),
(27334, NULL, 'G3DSA:2.60.34.10:FF:000082', NULL, NULL, 'Heat shock 70 kDa protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(27335, NULL, 'G3DSA:2.130.10.10:FF:002620', NULL, NULL, 'WD repeat-containing protein 92 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(27336, NULL, 'G3DSA:2.130.10.10:FF:002283', NULL, NULL, 'Putative vacuolar assembly protein vps41', NULL, NULL, NULL, NULL, NULL, 4),
(27337, NULL, 'G3DSA:1.10.1670.10:FF:000024', NULL, NULL, 'Endonuclease III homolog', NULL, NULL, NULL, NULL, NULL, 4),
(27338, NULL, 'G3DSA:3.90.70.10:FF:000892', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(27339, NULL, 'G3DSA:2.40.50.140:FF:000120', NULL, NULL, 'Probable DNA helicase MCM9', NULL, NULL, NULL, NULL, NULL, 4),
(27340, NULL, 'G3DSA:3.40.50.200:FF:000179', NULL, NULL, 'PapA protein', NULL, NULL, NULL, NULL, NULL, 4),
(27341, NULL, 'G3DSA:2.60.40.10:FF:002642', NULL, NULL, 'Chaperone CupA5', NULL, NULL, NULL, NULL, NULL, 4),
(27342, NULL, 'G3DSA:3.30.160.60:FF:004199', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27343, NULL, 'G3DSA:3.10.120.10:FF:000044', NULL, NULL, 'AAL078Wp', NULL, NULL, NULL, NULL, NULL, 4),
(27344, NULL, 'G3DSA:1.10.238.10:FF:000920', NULL, NULL, 'EF-hand calcium-binding domain-containing protein 6-like', NULL, NULL, NULL, NULL, NULL, 4),
(27345, NULL, 'G3DSA:1.10.3720.10:FF:000158', NULL, NULL, 'ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(27346, NULL, 'G3DSA:1.25.40.10:FF:001989', NULL, NULL, 'Os06g0493800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(27347, NULL, 'G3DSA:2.30.29.30:FF:000026', NULL, NULL, 'Arf-GAP with coiled-coil, ANK repeat and PH domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(27348, NULL, 'G3DSA:3.40.50.300:FF:002098', NULL, NULL, 'Lsa family ABC-F type ribosomal protection protein', NULL, NULL, NULL, NULL, NULL, 4),
(27349, NULL, 'G3DSA:1.25.40.10:FF:003597', NULL, NULL, 'Conserved WD40 and TPR repeat-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27350, NULL, 'G3DSA:3.30.420.40:FF:000178', NULL, NULL, 'Heat shock 70 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(27351, NULL, 'G3DSA:3.30.40.10:FF:000005', NULL, NULL, 'zinc finger protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(27352, NULL, 'G3DSA:2.60.200.10:FF:000032', NULL, NULL, 'Interferon regulatory factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(27353, NULL, 'G3DSA:3.30.300.30:FF:000121', NULL, NULL, 'L-prolyl-AMP Ligase PltF', NULL, NULL, NULL, NULL, NULL, 4),
(27354, NULL, 'G3DSA:1.10.490.20:FF:000003', NULL, NULL, 'C-phycocyanin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(27355, NULL, 'G3DSA:3.40.50.300:FF:006167', NULL, NULL, 'Heparan sulfate 2-O-sulfotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27356, NULL, 'G3DSA:2.10.25.10:FF:001743', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(27357, NULL, 'G3DSA:3.50.50.60:FF:000194', NULL, NULL, 'Cilia and flagella associated protein 61', NULL, NULL, NULL, NULL, NULL, 4),
(27358, NULL, 'G3DSA:2.130.10.10:FF:000675', NULL, NULL, 'Intraflagellar transport 140', NULL, NULL, NULL, NULL, NULL, 4),
(27359, NULL, 'G3DSA:2.60.40.1170:FF:000094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27360, NULL, 'G3DSA:3.40.50.720:FF:001734', NULL, NULL, 'Homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(27361, NULL, 'G3DSA:2.40.30.10:FF:000063', NULL, NULL, 'Cytochrome b5 reductase 4', NULL, NULL, NULL, NULL, NULL, 4),
(27362, NULL, 'G3DSA:2.60.40.10:FF:000697', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(27363, NULL, 'G3DSA:2.10.25.10:FF:001524', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27364, NULL, 'G3DSA:3.80.10.10:FF:003632', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(27365, NULL, 'G3DSA:3.40.850.10:FF:000401', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(27366, NULL, 'G3DSA:3.30.200.20:FF:000970', NULL, NULL, 'CMGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(27367, NULL, 'G3DSA:3.50.50.60:FF:000087', NULL, NULL, 'oxidative stress-induced growth inhibitor 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(27368, NULL, 'G3DSA:3.30.450.30:FF:000042', NULL, NULL, 'Dynein-associated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27369, NULL, 'G3DSA:3.40.50.2300:FF:000190', NULL, NULL, 'Glutamate receptor, metabotropic', NULL, NULL, NULL, NULL, NULL, 4),
(27370, NULL, 'G3DSA:3.30.43.10:FF:000045', NULL, NULL, 'D-2-hydroxyglutarate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(27371, NULL, 'G3DSA:2.130.10.10:FF:000366', NULL, NULL, 'DDB1-and CUL4-associated factor homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(27372, NULL, 'G3DSA:2.60.40.10:FF:001321', NULL, NULL, 'Cilia and flagella associated protein 221', NULL, NULL, NULL, NULL, NULL, 4),
(27373, NULL, 'G3DSA:1.20.58.70:FF:000029', NULL, NULL, 'Syntaxin, Qa-SNARE family', NULL, NULL, NULL, NULL, NULL, 4),
(27374, NULL, 'G3DSA:3.40.50.920:FF:000029', NULL, NULL, 'Xylulose-5-phosphate/fructose-6-phosphate phosphoketolase', NULL, NULL, NULL, NULL, NULL, 4),
(27375, NULL, 'G3DSA:3.20.110.10:FF:000041', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(27376, NULL, 'G3DSA:1.10.10.10:FF:000610', NULL, NULL, 'LexA repressor', NULL, NULL, NULL, NULL, NULL, 4),
(27377, NULL, 'G3DSA:3.30.760.10:FF:000020', NULL, NULL, 'Eukaryotic translation initiation factor 4E, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27378, NULL, 'G3DSA:1.10.357.10:FF:000067', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(27379, NULL, 'G3DSA:3.40.50.2000:FF:000201', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(27380, NULL, 'G3DSA:3.40.50.1240:FF:000158', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27381, NULL, 'G3DSA:1.25.70.10:FF:000075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27382, NULL, 'G3DSA:3.30.160.60:FF:005025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27383, NULL, 'G3DSA:2.160.20.10:FF:000141', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(27384, NULL, 'G3DSA:3.40.50.300:FF:008314', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(27385, NULL, 'G3DSA:2.130.10.10:FF:002390', NULL, NULL, 'Striatin Pro11', NULL, NULL, NULL, NULL, NULL, 4),
(27386, NULL, 'G3DSA:3.40.50.10860:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27387, NULL, 'G3DSA:3.30.420.40:FF:000543', NULL, NULL, 'Actin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27388, NULL, 'G3DSA:3.30.40.10:FF:001096', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(27389, NULL, 'G3DSA:3.60.15.10:FF:000221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27390, NULL, 'G3DSA:1.20.1420.30:FF:000026', NULL, NULL, 'Vacuolar calcium ion transporter', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(27391, NULL, 'G3DSA:3.40.50.970:FF:000123', NULL, NULL, 'Putative acetolactate synthase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(27392, NULL, 'G3DSA:2.10.25.10:FF:000113', NULL, NULL, 'Cadherin, EGF LAG seven-pass G-type receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(27393, NULL, 'G3DSA:3.80.10.10:FF:004121', NULL, NULL, 'NLR family CARD domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(27394, NULL, 'G3DSA:3.30.720.10:FF:000001', NULL, NULL, 'Signal recognition particle 9 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(27395, NULL, 'G3DSA:1.10.340.30:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27396, NULL, 'G3DSA:3.10.20.90:FF:001017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27397, NULL, 'G3DSA:1.10.510.10:FF:002425', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27398, NULL, 'G3DSA:3.40.50.620:FF:000063', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(27399, NULL, 'G3DSA:2.60.40.10:FF:000388', NULL, NULL, 'TEK receptor tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(27400, NULL, 'G3DSA:3.40.50.150:FF:000782', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27401, NULL, 'G3DSA:3.30.1380.20:FF:000049', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(27402, NULL, 'G3DSA:1.25.40.20:FF:001200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27403, NULL, 'G3DSA:2.60.40.10:FF:000708', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(27404, NULL, 'G3DSA:2.60.40.10:FF:000169', NULL, NULL, '1,4-alpha-glucan branching enzyme GlgB', NULL, NULL, NULL, NULL, NULL, 4),
(27405, NULL, 'G3DSA:3.80.10.10:FF:001850', NULL, NULL, 'Si:dkeyp-5g9.1', NULL, NULL, NULL, NULL, NULL, 4),
(27406, NULL, 'G3DSA:1.10.238.10:FF:000690', NULL, NULL, 'EF-hand calcium-binding domain 6', NULL, NULL, NULL, NULL, NULL, 4),
(27407, NULL, 'G3DSA:3.30.450.40:FF:000045', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(27408, NULL, 'G3DSA:3.30.160.60:FF:000944', NULL, NULL, 'zinc finger protein 232 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(27409, NULL, 'G3DSA:2.30.42.10:FF:000012', NULL, NULL, 'Membrane associated guanylate kinase, WW and PDZ domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(27410, NULL, 'G3DSA:3.40.50.1980:FF:000059', NULL, NULL, 'ABC transporter, periplasmic substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(27411, NULL, 'G3DSA:2.120.10.80:FF:000409', NULL, NULL, 'Kelch repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(27412, NULL, 'G3DSA:1.10.1900.40:FF:000001', NULL, NULL, 'Erythrocyte membrane protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(27413, NULL, 'G3DSA:1.20.1560.10:FF:000160', NULL, NULL, 'ABC transporter B family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(27414, NULL, 'G3DSA:2.20.110.10:FF:000005', NULL, NULL, 'Histone-lysine N-methyltransferase SETD7', NULL, NULL, NULL, NULL, NULL, 4),
(27415, NULL, 'G3DSA:1.10.10.60:FF:000445', NULL, NULL, 'Transcription factor MYB96', NULL, NULL, NULL, NULL, NULL, 4),
(27416, NULL, 'G3DSA:3.30.70.20:FF:000055', NULL, NULL, 'Trichloroethene reductive dehalogenase', NULL, NULL, NULL, NULL, NULL, 4),
(27417, NULL, 'G3DSA:3.40.50.300:FF:004571', NULL, NULL, 'Putative adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(27418, NULL, 'G3DSA:2.30.30.750:FF:000003', NULL, NULL, 'Putative 5''-3'' exonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(27419, NULL, 'G3DSA:1.10.730.10:FF:000019', NULL, NULL, 'Valine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(27420, NULL, 'G3DSA:1.10.8.270:FF:000118', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(27421, NULL, 'G3DSA:1.20.1390.10:FF:000017', NULL, NULL, 'Receptor-like protein kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(27422, NULL, 'G3DSA:3.30.160.290:FF:000001', NULL, NULL, 'V(D)J recombination-activating protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(27423, NULL, 'G3DSA:2.130.10.10:FF:000147', NULL, NULL, 'U4/U6 small nuclear ribonucleoprotein Prp4', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(27424, NULL, 'G3DSA:3.10.20.30:FF:000073', NULL, NULL, 'Fumarate reductase iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4),
(27425, NULL, 'G3DSA:2.30.30.30:FF:000097', NULL, NULL, 'Transcription initiation factor SPT5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27426, NULL, 'G3DSA:3.80.10.10:FF:001378', NULL, NULL, 'Receptor-like protein kinase HAIKU2', NULL, NULL, NULL, NULL, NULL, 4),
(27427, NULL, 'G3DSA:3.30.420.110:FF:000058', NULL, NULL, 'DNA mismatch repair protein MutS 2', NULL, NULL, NULL, NULL, NULL, 4),
(27428, NULL, 'G3DSA:3.40.50.300:FF:000546', NULL, NULL, 'Transcription-repair-coupling factor', NULL, NULL, NULL, NULL, NULL, 4),
(27429, NULL, 'G3DSA:3.40.120.10:FF:000099', NULL, NULL, 'Phosphoglucomutase/phosphomannomutase alpha/beta/alpha domain I', NULL, NULL, NULL, NULL, NULL, 4),
(27430, NULL, 'G3DSA:3.30.160.60:FF:002384', NULL, NULL, 'zinc finger protein 423', NULL, NULL, NULL, NULL, NULL, 4),
(27431, NULL, 'G3DSA:3.90.1030.20:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27432, NULL, 'G3DSA:1.25.40.20:FF:000946', NULL, NULL, 'SRP, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27433, NULL, 'G3DSA:1.10.10.470:FF:000002', NULL, NULL, 'Maltooligosyl trehalose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(27434, NULL, 'G3DSA:1.10.287.110:FF:000182', NULL, NULL, 'dnaJ homolog subfamily C member 28', NULL, NULL, NULL, NULL, NULL, 4),
(27435, NULL, 'G3DSA:3.60.140.10:FF:000011', NULL, NULL, 'Polyphenol oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(27436, NULL, 'G3DSA:1.25.40.10:FF:002725', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27437, NULL, 'G3DSA:3.40.630.10:FF:000183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27438, NULL, 'G3DSA:2.60.40.10:FF:004194', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27439, NULL, 'G3DSA:3.40.50.1820:FF:000130', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(27440, NULL, 'G3DSA:3.30.40.10:FF:000331', NULL, NULL, 'Bifunctional apoptosis regulator', NULL, NULL, NULL, NULL, NULL, 4),
(27441, NULL, 'G3DSA:2.120.10.30:FF:000193', NULL, NULL, 'Lipophorin receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27442, NULL, 'G3DSA:2.160.10.10:FF:000078', NULL, NULL, 'Homolog of p25 of dynactin (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(27443, NULL, 'G3DSA:2.130.10.10:FF:004418', NULL, NULL, 'Autophagy-related protein 18f', NULL, NULL, NULL, NULL, NULL, 4),
(27444, NULL, 'G3DSA:1.10.760.10:FF:000066', NULL, NULL, 'Nicotinate dehydrogenase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(27445, NULL, 'G3DSA:3.40.640.10:FF:000481', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27446, NULL, 'G3DSA:3.40.50.2000:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27447, NULL, 'G3DSA:1.10.150.20:FF:000045', NULL, NULL, 'DNA polymerase V subunit', NULL, NULL, NULL, NULL, NULL, 4),
(27448, NULL, 'G3DSA:3.30.70.330:FF:000241', NULL, NULL, 'Serine/threonine-protein kinase Kist isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(27449, NULL, 'G3DSA:2.130.10.10:FF:000826', NULL, NULL, 'DDB1- and CUL4-associated factor 13', NULL, NULL, NULL, NULL, NULL, 4),
(27450, NULL, 'G3DSA:1.10.510.10:FF:002970', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27451, NULL, 'G3DSA:1.10.10.60:FF:000815', NULL, NULL, 'NK3 homeobox 3', NULL, NULL, NULL, NULL, NULL, 4),
(27452, NULL, 'G3DSA:3.40.50.1240:FF:000186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27453, NULL, 'G3DSA:2.60.40.60:FF:000723', NULL, NULL, 'Cdh-4', NULL, NULL, NULL, NULL, NULL, 4),
(27454, NULL, 'G3DSA:1.10.472.10:FF:000262', NULL, NULL, 'Transcription factor IIIB 70 kDa subunit BRF', NULL, NULL, NULL, NULL, NULL, 4),
(27455, NULL, 'G3DSA:2.40.10.10:FF:000168', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(27456, NULL, 'G3DSA:3.10.10.10:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27457, NULL, 'G3DSA:2.60.40.10:FF:001231', NULL, NULL, 'Immunoglobulin-like and fibronectin type III domain containing 1', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(27458, NULL, 'G3DSA:3.40.120.10:FF:000094', NULL, NULL, 'Phosphoacetylglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(27459, NULL, 'G3DSA:3.40.50.300:FF:007010', NULL, NULL, 'ATP-binding cassette sub-family c putative', NULL, NULL, NULL, NULL, NULL, 4),
(27460, NULL, 'G3DSA:1.10.3720.10:FF:000153', NULL, NULL, 'ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(27461, NULL, 'G3DSA:2.170.270.10:FF:000083', NULL, NULL, 'PR/SET domain 2', NULL, NULL, NULL, NULL, NULL, 4),
(27462, NULL, 'G3DSA:3.20.70.20:FF:000010', NULL, NULL, 'Ribonucleoside-diphosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(27463, NULL, 'G3DSA:3.40.50.720:FF:001739', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27464, NULL, 'G3DSA:3.90.980.20:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27465, NULL, 'G3DSA:1.10.460.10:FF:000026', NULL, NULL, 'DNA topoisomerase 3', NULL, NULL, NULL, NULL, NULL, 4),
(27466, NULL, 'G3DSA:3.90.550.10:FF:000581', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(27467, NULL, 'G3DSA:2.60.40.10:FF:002277', NULL, NULL, 'Plexin A', NULL, NULL, NULL, NULL, NULL, 4),
(27468, NULL, 'G3DSA:3.40.50.1970:FF:000040', NULL, NULL, 'Alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(27469, NULL, 'G3DSA:3.90.400.10:FF:000008', NULL, NULL, 'Oligo-1,6-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(27470, NULL, 'G3DSA:2.40.30.10:FF:000372', NULL, NULL, 'Ferredoxin:NADP oxidoreductase, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(27471, NULL, 'G3DSA:1.25.40.10:FF:000247', NULL, NULL, 'Vacuolar protein sorting-associated protein 41 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(27472, NULL, 'G3DSA:3.40.50.300:FF:006386', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27473, NULL, 'G3DSA:4.10.60.10:FF:000128', NULL, NULL, 'DEAD-box ATP-dependent RNA helicase 3, chloroplastic isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(27474, NULL, 'G3DSA:1.20.1070.10:FF:001617', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27475, NULL, 'G3DSA:1.20.120.1880:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27476, NULL, 'G3DSA:2.60.40.10:FF:002625', NULL, NULL, 'Protein NDNF', NULL, NULL, NULL, NULL, NULL, 4),
(27477, NULL, 'G3DSA:3.10.120.10:FF:000027', NULL, NULL, 'TAX-2', NULL, NULL, NULL, NULL, NULL, 4),
(27478, NULL, 'G3DSA:3.30.160.60:FF:001310', NULL, NULL, 'zinc finger protein 664', NULL, NULL, NULL, NULL, NULL, 4),
(27479, NULL, 'G3DSA:2.10.25.10:FF:001187', NULL, NULL, 'NeuReXin related', NULL, NULL, NULL, NULL, NULL, 4),
(27480, NULL, 'G3DSA:3.80.10.10:FF:003648', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27481, NULL, 'G3DSA:3.30.40.10:FF:000550', NULL, NULL, 'Nitric oxide synthase-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(27482, NULL, 'G3DSA:1.25.40.20:FF:000727', NULL, NULL, 'Related to Lysophospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(27483, NULL, 'G3DSA:3.40.50.11860:FF:000004', NULL, NULL, 'Diphthamide biosynthesis protein 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27484, NULL, 'G3DSA:3.40.50.300:FF:002805', NULL, NULL, 'PEX1p AAA-peroxin', NULL, NULL, NULL, NULL, NULL, 4),
(27485, NULL, 'G3DSA:3.90.70.40:FF:000007', NULL, NULL, 'Josephin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(27486, NULL, 'G3DSA:1.10.8.270:FF:000146', NULL, NULL, 'GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27487, NULL, 'G3DSA:3.40.50.1980:FF:000043', NULL, NULL, 'ABC transporter substrate-binding protein-iron transport', NULL, NULL, NULL, NULL, NULL, 4),
(27488, NULL, 'G3DSA:3.60.21.10:FF:000297', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(27489, NULL, 'G3DSA:2.60.34.10:FF:000109', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(27490, NULL, 'G3DSA:3.30.450.20:FF:000011', NULL, NULL, 'Hybrid signal transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(27491, NULL, 'G3DSA:3.40.50.2300:FF:001499', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(27492, NULL, 'G3DSA:3.90.70.30:FF:000004', NULL, NULL, 'Phytochelatin synthase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(27493, NULL, 'G3DSA:1.25.40.10:FF:000724', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(27494, NULL, 'G3DSA:3.40.50.720:FF:001397', NULL, NULL, 'Os12g0102100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(27495, NULL, 'G3DSA:1.20.1280.290:FF:000062', NULL, NULL, 'L-cystine transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27496, NULL, 'G3DSA:1.10.510.10:FF:002953', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27497, NULL, 'G3DSA:1.10.510.10:FF:002279', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27498, NULL, 'G3DSA:3.40.30.10:FF:000892', NULL, NULL, 'Queuine tRNA-ribosyltransferase accessory subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(27499, NULL, 'G3DSA:3.40.1280.10:FF:000042', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase Nep1', NULL, NULL, NULL, NULL, NULL, 4),
(27500, NULL, 'G3DSA:1.20.5.5270:FF:000001', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(27501, NULL, 'G3DSA:3.90.470.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27502, NULL, 'G3DSA:3.40.30.10:FF:000566', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27503, NULL, 'G3DSA:1.25.10.10:FF:003050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27504, NULL, 'G3DSA:1.10.150.240:FF:000069', NULL, NULL, 'Haloacid dehalogenase-like hydrolase domain-containing protein Sgpp', NULL, NULL, NULL, NULL, NULL, 4),
(27505, NULL, 'G3DSA:3.40.50.1580:FF:000046', NULL, NULL, 'Purine nucleoside phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(27506, NULL, 'G3DSA:3.30.565.10:FF:000218', NULL, NULL, 'C4-dicarboxylate transport sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(27507, NULL, 'G3DSA:3.50.50.60:FF:000901', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27508, NULL, 'G3DSA:3.40.390.10:FF:000045', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(27509, NULL, 'G3DSA:3.30.565.10:FF:000460', NULL, NULL, 'Probable two-component sensor', NULL, NULL, NULL, NULL, NULL, 4),
(27510, NULL, 'G3DSA:2.130.10.10:FF:002934', NULL, NULL, 'Uncharacterized WD repeat-containing protein C126.01c', NULL, NULL, NULL, NULL, NULL, 4),
(27511, NULL, 'G3DSA:2.40.50.140:FF:000760', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27512, NULL, 'G3DSA:2.60.120.260:FF:000630', NULL, NULL, 'Putative sugar hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(27513, NULL, 'G3DSA:3.40.50.620:FF:000602', NULL, NULL, 'Tryptophanyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(27514, NULL, 'G3DSA:1.10.472.10:FF:000481', NULL, NULL, 'Cyclin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27515, NULL, 'G3DSA:2.60.40.10:FF:002951', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(27516, NULL, 'G3DSA:1.20.1250.20:FF:001590', NULL, NULL, 'MFS alpha-glucoside transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27517, NULL, 'G3DSA:3.80.10.10:FF:003851', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(27518, NULL, 'G3DSA:1.10.150.20:FF:000040', NULL, NULL, 'DNA repair endonuclease XPF isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(27519, NULL, 'G3DSA:1.10.533.10:FF:000078', NULL, NULL, 'Probable ATP-dependent RNA helicase DDX58', NULL, NULL, NULL, NULL, NULL, 4),
(27520, NULL, 'G3DSA:1.10.150.20:FF:000264', NULL, NULL, 'ERCC (DNA excision repair protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(27521, NULL, 'G3DSA:3.30.160.60:FF:006458', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27522, NULL, 'G3DSA:1.10.238.10:FF:000903', NULL, NULL, 'Rhomboid-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(27523, NULL, 'G3DSA:3.30.43.10:FF:000028', NULL, NULL, 'FAD binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(27524, NULL, 'G3DSA:3.30.500.10:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(27525, NULL, 'G3DSA:3.40.50.150:FF:000692', NULL, NULL, 'Methyltransferase tpcM', NULL, NULL, NULL, NULL, NULL, 4),
(27526, NULL, 'G3DSA:1.10.510.10:FF:000727', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(27527, NULL, 'G3DSA:1.25.40.20:FF:001110', NULL, NULL, 'Ankyrin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(27528, NULL, 'G3DSA:4.10.1000.10:FF:000112', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(27529, NULL, 'G3DSA:1.25.40.10:FF:004086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27530, NULL, 'G3DSA:3.40.50.2300:FF:000280', NULL, NULL, 'Response regulator receiver domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(27531, NULL, 'G3DSA:1.25.10.10:FF:000419', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(27532, NULL, 'G3DSA:3.30.200.20:FF:000661', NULL, NULL, 'Serine-threonine protein kinase plant-type', NULL, NULL, NULL, NULL, NULL, 4),
(27533, NULL, 'G3DSA:1.20.58.60:FF:000026', NULL, NULL, 'Spectrin alpha chain, non-erythrocytic 1', NULL, NULL, NULL, NULL, NULL, 4),
(27534, NULL, 'G3DSA:3.30.230.10:FF:000160', NULL, NULL, 'Elongation factor G2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(27535, NULL, 'G3DSA:2.40.10.10:FF:000696', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27536, NULL, 'G3DSA:1.25.10.10:FF:002027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27537, NULL, 'G3DSA:1.20.1070.10:FF:001724', NULL, NULL, 'Neuropeptide Y receptor Y8a', NULL, NULL, NULL, NULL, NULL, 4),
(27538, NULL, 'G3DSA:3.50.50.60:FF:000340', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] flavoprotein subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(27539, NULL, 'G3DSA:3.40.50.261:FF:000041', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(27540, NULL, 'G3DSA:1.20.1050.10:FF:000076', NULL, NULL, 'Probable glutathione S-transferase gst-36', NULL, NULL, NULL, NULL, NULL, 4),
(27541, NULL, 'G3DSA:3.30.420.40:FF:000217', NULL, NULL, '2-hydroxyisocaproyl-CoA dehydratase activator', NULL, NULL, NULL, NULL, NULL, 4),
(27542, NULL, 'G3DSA:2.130.10.10:FF:002592', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27543, NULL, 'G3DSA:1.20.58.60:FF:000161', NULL, NULL, 'Short stop, isoform K', NULL, NULL, NULL, NULL, NULL, 4),
(27544, NULL, 'G3DSA:3.30.870.10:FF:000141', NULL, NULL, 'Cardiolipin synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(27545, NULL, 'G3DSA:3.80.10.10:FF:004031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27546, NULL, 'G3DSA:1.20.1050.10:FF:000115', NULL, NULL, 'CaDmium Responsive', NULL, NULL, NULL, NULL, NULL, 4),
(27547, NULL, 'G3DSA:2.60.40.1180:FF:000097', NULL, NULL, 'Alpha-galactosidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(27548, NULL, 'G3DSA:3.40.50.720:FF:002105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27549, NULL, 'G3DSA:1.20.1480.30:FF:000002', NULL, NULL, 'Kinesin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27550, NULL, 'G3DSA:3.40.50.300:FF:006476', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27551, NULL, 'G3DSA:2.40.20.10:FF:000118', NULL, NULL, 'Plasminogen activator, urokinase a', NULL, NULL, NULL, NULL, NULL, 4),
(27552, NULL, 'G3DSA:3.30.1540.20:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27553, NULL, 'G3DSA:2.30.26.10:FF:000002', NULL, NULL, 'Dihydroorotate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(27554, NULL, 'G3DSA:1.20.5.340:FF:000047', NULL, NULL, 'Myosin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(27555, NULL, 'G3DSA:2.60.40.820:FF:000047', NULL, NULL, 'T-box transcription factor Tbx4', NULL, NULL, NULL, NULL, NULL, 4),
(27556, NULL, 'G3DSA:1.10.1300.10:FF:000020', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(27557, NULL, 'G3DSA:2.20.70.10:FF:000116', NULL, NULL, 'Transcription elongation regulator 1', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(27558, NULL, 'G3DSA:3.20.20.70:FF:000859', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27559, NULL, 'G3DSA:2.170.300.10:FF:000041', NULL, NULL, 'Tyrosine protein kinase receptor tie-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27560, NULL, 'G3DSA:1.20.960.20:FF:000003', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(27561, NULL, 'G3DSA:1.20.960.30:FF:000006', NULL, NULL, 'WD repeat protein (AFU_orthologue AFUA_6G12600)', NULL, NULL, NULL, NULL, NULL, 4),
(27562, NULL, 'G3DSA:3.40.1090.10:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27563, NULL, 'G3DSA:3.90.1600.10:FF:000056', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(27564, NULL, 'G3DSA:2.30.30.60:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27565, NULL, 'G3DSA:3.80.10.10:FF:004014', NULL, NULL, 'Ras guanine nucleotide exchange factor V', NULL, NULL, NULL, NULL, NULL, 4),
(27566, NULL, 'G3DSA:3.40.640.10:FF:000464', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27567, NULL, 'G3DSA:1.10.274.10:FF:000003', NULL, NULL, 'PTS-dependent dihydroxyacetone kinase, DhaM subunit', NULL, NULL, NULL, NULL, NULL, 4),
(27568, NULL, 'G3DSA:3.30.70.850:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27569, NULL, 'G3DSA:3.10.20.90:FF:000832', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27570, NULL, 'G3DSA:3.10.129.10:FF:000108', NULL, NULL, 'Acyl dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(27571, NULL, 'G3DSA:2.130.10.10:FF:002625', NULL, NULL, 'DDB1 and CUL4 associated factor 12', NULL, NULL, NULL, NULL, NULL, 4),
(27572, NULL, 'G3DSA:2.40.160.10:FF:000004', NULL, NULL, 'Por1 mitochondrial outer membrane porin', NULL, NULL, NULL, NULL, NULL, 4),
(27573, NULL, 'G3DSA:1.10.510.10:FF:000817', NULL, NULL, 'Serine/threonine-protein kinase ATG1', NULL, NULL, NULL, NULL, NULL, 4),
(27574, NULL, 'G3DSA:1.20.90.10:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27575, NULL, 'G3DSA:4.10.60.10:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27576, NULL, 'G3DSA:3.10.100.10:FF:000161', NULL, NULL, 'Sperm receptor for egg jelly', NULL, NULL, NULL, NULL, NULL, 4),
(27577, NULL, 'G3DSA:3.40.710.10:FF:000110', NULL, NULL, 'Putative D-alanyl-D-alanine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(27578, NULL, 'G3DSA:3.20.20.140:FF:000199', NULL, NULL, 'Xaa-Pro dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(27579, NULL, 'G3DSA:1.20.1310.10:FF:000153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27580, NULL, 'G3DSA:2.60.40.150:FF:000638', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27581, NULL, 'G3DSA:3.30.160.60:FF:003108', NULL, NULL, 'Zinc finger protein 646', NULL, NULL, NULL, NULL, NULL, 4),
(27582, NULL, 'G3DSA:3.90.470.20:FF:000055', NULL, NULL, '4''-phosphopantetheinyl transferase superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(27583, NULL, 'G3DSA:3.40.640.10:FF:000155', NULL, NULL, 'Related to GLY1-L-threonine aldolase, low-specific', NULL, NULL, NULL, NULL, NULL, 4),
(27584, NULL, 'G3DSA:3.30.160.60:FF:001001', NULL, NULL, 'RE1-silencing transcription factor B', NULL, NULL, NULL, NULL, NULL, 4),
(27585, NULL, 'G3DSA:3.30.56.10:FF:000024', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(27586, NULL, 'G3DSA:1.20.1070.10:FF:000313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27587, NULL, 'G3DSA:3.30.70.870:FF:000026', NULL, NULL, 'Elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(27588, NULL, 'G3DSA:3.40.50.970:FF:000128', NULL, NULL, 'Putative 2-oxoglutarate dehydrogenase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(27589, NULL, 'G3DSA:1.20.1250.20:FF:000206', NULL, NULL, 'Major facilitator superfamily domain containing 12', NULL, NULL, NULL, NULL, NULL, 4),
(27590, NULL, 'G3DSA:3.30.160.60:FF:002861', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(27591, NULL, 'G3DSA:3.30.70.580:FF:000063', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(27592, NULL, 'G3DSA:3.30.160.60:FF:002619', NULL, NULL, 'ZFP57 zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(27593, NULL, 'G3DSA:3.90.1300.10:FF:000016', NULL, NULL, 'Vitamin D3 hydroxylase-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(27594, NULL, 'G3DSA:1.20.5.190:FF:000159', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27595, NULL, 'G3DSA:3.30.70.330:FF:002040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27596, NULL, 'G3DSA:3.30.70.1590:FF:000001', NULL, NULL, 'Myosin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(27597, NULL, 'G3DSA:1.10.238.10:FF:000555', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(27598, NULL, 'G3DSA:3.40.30.10:FF:000908', NULL, NULL, 'Thioredoxin superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(27599, NULL, 'G3DSA:2.40.70.10:FF:000363', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27600, NULL, 'G3DSA:3.10.20.90:FF:001012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27601, NULL, 'G3DSA:3.40.50.720:FF:001178', NULL, NULL, 'UDP-glucuronic acid decarboxylase 4', NULL, NULL, NULL, NULL, NULL, 4),
(27602, NULL, 'G3DSA:3.90.79.10:FF:000114', NULL, NULL, 'ADP-ribose pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(27603, NULL, 'G3DSA:3.10.20.90:FF:000484', NULL, NULL, 'E3 ubiquitin-protein ligase parkin', NULL, NULL, NULL, NULL, NULL, 4),
(27604, NULL, 'G3DSA:3.40.50.920:FF:000046', NULL, NULL, 'YALI0D11176p', NULL, NULL, NULL, NULL, NULL, 4),
(27605, NULL, 'G3DSA:2.60.40.10:FF:002316', NULL, NULL, 'AGAP004825-PA', NULL, NULL, NULL, NULL, NULL, 4),
(27606, NULL, 'G3DSA:2.30.30.40:FF:000246', NULL, NULL, 'RIMS-binding protein 3A-like', NULL, NULL, NULL, NULL, NULL, 4),
(27607, NULL, 'G3DSA:3.80.10.10:FF:001715', NULL, NULL, 'Kekkon5, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(27608, NULL, 'G3DSA:1.10.274.30:FF:000009', NULL, NULL, 'Protein CBG13703', NULL, NULL, NULL, NULL, NULL, 4),
(27609, NULL, 'G3DSA:1.25.40.10:FF:000808', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g32430, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(27610, NULL, 'G3DSA:3.40.640.10:FF:000374', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27611, NULL, 'G3DSA:1.10.565.10:FF:000197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27612, NULL, 'G3DSA:3.40.50.300:FF:003603', NULL, NULL, 'Putative Transposon transposition helper protein C', NULL, NULL, NULL, NULL, NULL, 4),
(27613, NULL, 'G3DSA:2.60.200.10:FF:000037', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(27614, NULL, 'G3DSA:3.30.420.40:FF:000397', NULL, NULL, 'Putative fimbrial assembly protein PilM', NULL, NULL, NULL, NULL, NULL, 4),
(27615, NULL, 'G3DSA:2.30.180.10:FF:000047', NULL, NULL, 'Fasciclin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(27616, NULL, 'G3DSA:3.30.420.40:FF:001021', NULL, NULL, 'Glucokinase regulator family protein, putative (AFU_orthologue AFUA_1G17490)', NULL, NULL, NULL, NULL, NULL, 4),
(27617, NULL, 'G3DSA:2.10.110.10:FF:000171', NULL, NULL, 'Actin-binding LIM protein family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(27618, NULL, 'G3DSA:3.40.50.2300:FF:001589', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27619, NULL, 'G3DSA:3.40.50.10810:FF:000268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27620, NULL, 'G3DSA:3.30.70.3490:FF:000009', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(27621, NULL, 'G3DSA:3.30.760.10:FF:000003', NULL, NULL, 'Eukaryotic translation initiation factor 4E', NULL, NULL, NULL, NULL, NULL, 4),
(27622, NULL, 'G3DSA:1.10.620.20:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27623, NULL, 'G3DSA:3.90.1800.10:FF:000021', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(27624, NULL, 'G3DSA:2.130.10.10:FF:002064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(27625, NULL, 'G3DSA:3.40.50.300:FF:002463', NULL, NULL, 'Small nuclear ribonucleoprotein component-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(27626, NULL, 'G3DSA:1.20.1420.30:FF:000009', NULL, NULL, 'sodium/potassium/calcium exchanger 5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(27627, NULL, 'G3DSA:3.90.260.10:FF:000019', NULL, NULL, 'Xeroderma pigmentosum, complementation group C', NULL, NULL, NULL, NULL, NULL, 4),
(27628, NULL, 'G3DSA:2.130.10.10:FF:002373', NULL, NULL, 'Related to UTP7-nucleolar protein, component of the small subunit processome', NULL, NULL, NULL, NULL, NULL, 4),
(27629, NULL, 'G3DSA:3.20.20.210:FF:000012', NULL, NULL, 'Uroporphyrinogen decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(27630, NULL, 'G3DSA:2.10.25.10:FF:001496', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(27631, NULL, 'G3DSA:3.40.50.300:FF:002772', NULL, NULL, 'ATP-dependent DEAD/H RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27632, NULL, 'G3DSA:3.30.40.10:FF:000224', NULL, NULL, 'E3 ubiquitin-protein ligase TRAF7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(27633, NULL, 'G3DSA:1.20.1070.10:FF:001943', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27634, NULL, 'G3DSA:3.30.70.1230:FF:000276', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(27635, NULL, 'G3DSA:3.40.50.300:FF:006695', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(27636, NULL, 'G3DSA:3.30.70.330:FF:000095', NULL, NULL, 'Putative Nucleoporin NUP53', NULL, NULL, NULL, NULL, NULL, 4),
(27637, NULL, 'G3DSA:1.20.120.1440:FF:000001', NULL, NULL, 'Thymine dioxygenase JBP1', NULL, NULL, NULL, NULL, NULL, 4),
(27638, NULL, 'G3DSA:3.40.50.880:FF:000231', NULL, NULL, 'Catalase', NULL, NULL, NULL, NULL, NULL, 4),
(27639, NULL, 'G3DSA:2.60.120.260:FF:000169', NULL, NULL, 'CocE/NonD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(27640, NULL, 'G3DSA:3.30.70.1350:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27641, NULL, 'G3DSA:3.20.20.80:FF:000778', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27642, NULL, 'G3DSA:3.30.70.20:FF:000072', NULL, NULL, '2-oxoglutarate:acceptor oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(27643, NULL, 'G3DSA:3.40.50.2000:FF:000217', NULL, NULL, 'Trehalose-phosphatase, variant 1', NULL, NULL, NULL, NULL, NULL, 4),
(27644, NULL, 'G3DSA:2.30.30.30:FF:000024', NULL, NULL, 'Transcription elongation factor SPT5', NULL, NULL, NULL, NULL, NULL, 4),
(27645, NULL, 'G3DSA:3.40.50.300:FF:008168', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(27646, NULL, 'G3DSA:3.20.20.70:FF:000775', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27647, NULL, 'G3DSA:2.130.10.10:FF:002951', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(27648, NULL, 'G3DSA:2.30.42.10:FF:000135', NULL, NULL, 'LIM domain only 7', NULL, NULL, NULL, NULL, NULL, 4),
(27649, NULL, 'G3DSA:3.30.300.80:FF:000001', NULL, NULL, 'Site-specific recombinase Flp', NULL, NULL, NULL, NULL, NULL, 4),
(27650, NULL, 'G3DSA:2.60.200.20:FF:000170', NULL, NULL, 'Kinesin-like protein KIF13A', NULL, NULL, NULL, NULL, NULL, 4),
(27651, NULL, 'G3DSA:3.30.160.60:FF:000276', NULL, NULL, 'zinc finger protein 385A isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(27652, NULL, 'G3DSA:3.40.50.2300:FF:000206', NULL, NULL, 'Two-component response regulator-like APRR2', NULL, NULL, NULL, NULL, NULL, 4),
(27653, NULL, 'G3DSA:3.40.50.300:FF:001243', NULL, NULL, 'Nucleolar protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(27654, NULL, 'G3DSA:1.25.40.10:FF:002742', NULL, NULL, 'AaceriACR173Wp', NULL, NULL, NULL, NULL, NULL, 4),
(27655, NULL, 'G3DSA:3.80.10.10:FF:002013', NULL, NULL, 'Slit homolog 1b (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(27656, NULL, 'G3DSA:2.120.10.30:FF:000535', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27657, NULL, 'G3DSA:3.90.640.10:FF:000104', NULL, NULL, 'Heat shock protein 70, putative', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(27658, NULL, 'G3DSA:2.60.40.790:FF:000151', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27659, NULL, 'G3DSA:3.80.10.10:FF:001395', NULL, NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', NULL, NULL, NULL, NULL, NULL, 4),
(27660, NULL, 'G3DSA:3.50.50.60:FF:000542', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(27661, NULL, 'G3DSA:3.30.160.60:FF:003024', NULL, NULL, 'Zinc finger protein 699', NULL, NULL, NULL, NULL, NULL, 4),
(27662, NULL, 'G3DSA:3.30.160.60:FF:002945', NULL, NULL, 'LD32088p', NULL, NULL, NULL, NULL, NULL, 4),
(27663, NULL, 'G3DSA:3.10.129.10:FF:000024', NULL, NULL, 'Acyl-CoA hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(27664, NULL, 'G3DSA:2.130.10.10:FF:004497', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27665, NULL, 'G3DSA:3.30.300.90:FF:000004', NULL, NULL, 'SufE-like protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(27666, NULL, 'G3DSA:3.30.1360.10:FF:000028', NULL, NULL, 'DNA-directed RNA polymerase II subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27667, NULL, 'G3DSA:3.90.1410.10:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27668, NULL, 'G3DSA:1.25.40.10:FF:004288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27669, NULL, 'G3DSA:3.30.70.1350:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27670, NULL, 'G3DSA:3.40.50.150:FF:000809', NULL, NULL, 'Probable 18S rRNA (guanine-N(7))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(27671, NULL, 'G3DSA:3.40.50.1820:FF:001237', NULL, NULL, 'Periplasmic siderophore cleavage esterase IroE family', NULL, NULL, NULL, NULL, NULL, 4),
(27672, NULL, 'G3DSA:1.10.150.240:FF:000070', NULL, NULL, 'Phosphorylated carbohydrates phosphatase TM_1254', NULL, NULL, NULL, NULL, NULL, 4),
(27673, NULL, 'G3DSA:3.40.50.300:FF:004368', NULL, NULL, 'Lipoprotein release ATP-binding component', NULL, NULL, NULL, NULL, NULL, 4),
(27674, NULL, 'G3DSA:3.40.190.10:FF:000064', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(27675, NULL, 'G3DSA:3.40.50.10260:FF:000042', NULL, NULL, 'Enhancer of mRNA-decapping protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(27676, NULL, 'G3DSA:3.30.50.10:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27677, NULL, 'G3DSA:3.30.1330.10:FF:000004', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase subunit PurL', NULL, NULL, NULL, NULL, NULL, 4),
(27678, NULL, 'G3DSA:3.40.1810.10:FF:000078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27679, NULL, 'G3DSA:3.40.50.150:FF:001271', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27680, NULL, 'G3DSA:1.10.533.10:FF:000207', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(27681, NULL, 'G3DSA:1.25.40.10:FF:002271', NULL, NULL, 'TPR_repeat/Tetratricopeptide_repeat_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(27682, NULL, 'G3DSA:3.30.497.10:FF:000161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27683, NULL, 'G3DSA:3.40.50.1480:FF:000016', NULL, NULL, 'Adenosylhomocysteinase', NULL, NULL, NULL, NULL, NULL, 4),
(27684, NULL, 'G3DSA:3.20.20.450:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27685, NULL, 'G3DSA:2.60.40.10:FF:000843', NULL, NULL, 'Plexin D1', NULL, NULL, NULL, NULL, NULL, 4),
(27686, NULL, 'G3DSA:2.30.30.40:FF:000561', NULL, NULL, 'Variant SH3 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(27687, NULL, 'G3DSA:1.10.220.150:FF:000031', NULL, NULL, 'ARF GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27688, NULL, 'G3DSA:3.30.420.40:FF:000088', NULL, NULL, 'Glucokinase', NULL, NULL, NULL, NULL, NULL, 4),
(27689, NULL, 'G3DSA:3.40.50.980:FF:000042', NULL, NULL, 'NRPS-like enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27690, NULL, 'G3DSA:1.10.3720.10:FF:000136', NULL, NULL, 'ABC transporter permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(27691, NULL, 'G3DSA:3.40.50.1470:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(27692, NULL, 'G3DSA:2.170.150.10:FF:000006', NULL, NULL, 'Histamine-releasing factor', NULL, NULL, NULL, NULL, NULL, 4),
(27693, NULL, 'G3DSA:3.40.1280.10:FF:000025', NULL, NULL, 'Mitochondrial rRNA methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(27694, NULL, 'G3DSA:2.70.70.10:FF:000002', NULL, NULL, 'Murein DD-endopeptidase MepM', NULL, NULL, NULL, NULL, NULL, 4),
(27695, NULL, 'G3DSA:2.70.170.10:FF:000239', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(27696, NULL, 'G3DSA:3.30.890.10:FF:000024', NULL, NULL, 'Methyl-CpG-binding domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(27697, NULL, 'G3DSA:2.60.40.60:FF:000796', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27698, NULL, 'G3DSA:3.40.50.1820:FF:001765', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27699, NULL, 'G3DSA:2.60.120.200:FF:000303', NULL, NULL, 'Outer capsid protein VP4', NULL, NULL, NULL, NULL, NULL, 4),
(27700, NULL, 'G3DSA:2.170.150.20:FF:000009', NULL, NULL, 'Peptide-methionine (R)-S-oxide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(27701, NULL, 'G3DSA:1.20.1250.20:FF:001516', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27702, NULL, 'G3DSA:1.10.30.10:FF:000038', NULL, NULL, 'High mobility group box 4', NULL, NULL, NULL, NULL, NULL, 4),
(27703, NULL, 'G3DSA:3.40.190.10:FF:000592', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(27704, NULL, 'G3DSA:2.80.10.50:FF:000268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27705, NULL, 'G3DSA:2.60.40.790:FF:000038', NULL, NULL, 'BMA-HSP-25, isoform c', NULL, NULL, NULL, NULL, NULL, 4),
(27706, NULL, 'G3DSA:1.10.10.1330:FF:000002', NULL, NULL, 'RNA polymerase factor sigma-54', NULL, NULL, NULL, NULL, NULL, 4),
(27707, NULL, 'G3DSA:1.20.120.720:FF:000019', NULL, NULL, 'myosin-VIIa isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(27708, NULL, 'G3DSA:3.40.50.1580:FF:000024', NULL, NULL, 'Purine nucleoside phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(27709, NULL, 'G3DSA:1.10.20.10:FF:000291', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27710, NULL, 'G3DSA:3.30.70.1660:FF:000028', NULL, NULL, 'peptide chain release factor 1-like, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(27711, NULL, 'G3DSA:3.30.70.330:FF:001848', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27712, NULL, 'G3DSA:3.30.200.20:FF:000554', NULL, NULL, 'CMGC/CDK/CDK7 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(27713, NULL, 'G3DSA:1.10.10.10:FF:000571', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(27714, NULL, 'G3DSA:2.60.40.3690:FF:000001', NULL, NULL, 'Major fimbrium subunit FimA type-4', NULL, NULL, NULL, NULL, NULL, 4),
(27715, NULL, 'G3DSA:2.10.70.10:FF:000089', NULL, NULL, 'Beta-2-glycoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(27716, NULL, 'G3DSA:3.80.10.10:FF:000304', NULL, NULL, 'Tubulin-specific chaperone cofactor E-like', NULL, NULL, NULL, NULL, NULL, 4),
(27717, NULL, 'G3DSA:2.30.29.30:FF:000161', NULL, NULL, 'Rho GTPase activating protein 42', NULL, NULL, NULL, NULL, NULL, 4),
(27718, NULL, 'G3DSA:1.20.200.10:FF:000016', NULL, NULL, 'Adenylosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(27719, NULL, 'G3DSA:2.130.10.10:FF:002844', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27720, NULL, 'G3DSA:1.10.510.10:FF:003116', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27721, NULL, 'G3DSA:2.40.50.140:FF:000451', NULL, NULL, 'Sugar ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(27722, NULL, 'G3DSA:3.90.70.10:FF:000561', NULL, NULL, 'Calcium-dependent cysteine protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27723, NULL, 'G3DSA:3.40.50.1000:FF:000816', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27724, NULL, 'G3DSA:1.10.510.10:FF:002296', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27725, NULL, 'G3DSA:3.40.50.620:FF:000041', NULL, NULL, 'Electron transfer flavoprotein alpha subunit', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(27726, NULL, 'G3DSA:2.40.10.10:FF:000387', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27727, NULL, 'G3DSA:2.10.25.10:FF:000080', NULL, NULL, 'Neurogenic locus notch 1', NULL, NULL, NULL, NULL, NULL, 4),
(27728, NULL, 'G3DSA:1.20.1070.10:FF:000307', NULL, NULL, 'G-protein coupled bile acid receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(27729, NULL, 'G3DSA:3.10.180.10:FF:000019', NULL, NULL, '4-hydroxyphenylpyruvate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(27730, NULL, 'G3DSA:3.40.30.10:FF:000982', NULL, NULL, 'Protein disulfide isomerase family A, member 3', NULL, NULL, NULL, NULL, NULL, 4),
(27731, NULL, 'G3DSA:1.20.58.610:FF:000004', NULL, NULL, 'Hsp90 co-chaperone Cdc37', NULL, NULL, NULL, NULL, NULL, 4),
(27732, NULL, 'G3DSA:3.55.50.30:FF:000028', NULL, NULL, 'DUF4974 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(27733, NULL, 'G3DSA:2.60.40.10:FF:003120', NULL, NULL, 'AGAP003610-PA', NULL, NULL, NULL, NULL, NULL, 4),
(27734, NULL, 'G3DSA:3.30.40.10:FF:001657', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27735, NULL, 'G3DSA:2.60.34.10:FF:000003', NULL, NULL, 'Molecular chaperone DnaK', NULL, NULL, NULL, NULL, NULL, 4),
(27736, NULL, 'G3DSA:3.30.160.60:FF:002417', NULL, NULL, 'Serendipity locus protein H-1', NULL, NULL, NULL, NULL, NULL, 4),
(27737, NULL, 'G3DSA:1.10.510.10:FF:002189', NULL, NULL, 'Probable inactive serine/threonine-protein kinase DDB_G0280855', NULL, NULL, NULL, NULL, NULL, 4),
(27738, NULL, 'G3DSA:2.130.10.10:FF:004082', NULL, NULL, 'Flagellar associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(27739, NULL, 'G3DSA:3.10.28.10:FF:000062', NULL, NULL, 'Laglidadg endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(27740, NULL, 'G3DSA:1.10.510.10:FF:002509', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27741, NULL, 'G3DSA:3.40.50.1000:FF:000339', NULL, NULL, 'Haloacid dehalogenase-like hydrolase (HAD) superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(27742, NULL, 'G3DSA:3.30.200.20:FF:002443', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27743, NULL, 'G3DSA:3.30.420.40:FF:000633', NULL, NULL, 'Endoplasmic reticulum chaperone BiP', NULL, NULL, NULL, NULL, NULL, 4),
(27744, NULL, 'G3DSA:3.30.413.10:FF:000040', NULL, NULL, 'Sulfite reductase [ferredoxin], chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(27745, NULL, 'G3DSA:3.40.50.300:FF:006622', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27746, NULL, 'G3DSA:3.10.450.50:FF:000108', NULL, NULL, 'Zgc:153681', NULL, NULL, NULL, NULL, NULL, 4),
(27747, NULL, 'G3DSA:1.20.1070.10:FF:001308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27748, NULL, 'G3DSA:1.10.10.10:FF:000262', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC3', NULL, NULL, NULL, NULL, NULL, 4),
(27749, NULL, 'G3DSA:3.40.30.10:FF:000875', NULL, NULL, 'Calsequestrin', NULL, NULL, NULL, NULL, NULL, 4),
(27750, NULL, 'G3DSA:3.50.30.50:FF:000010', NULL, NULL, 'Putative cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(27751, NULL, 'G3DSA:2.60.200.20:FF:000259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27752, NULL, 'G3DSA:1.10.1320.10:FF:000021', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(27753, NULL, 'G3DSA:2.60.40.1110:FF:000003', NULL, NULL, 'Phosphatidylinositol 3,4,5-trisphosphate 3-phosphatase and dual-specificity protein phosphatase PTEN', NULL, NULL, NULL, NULL, NULL, 4),
(27754, NULL, 'G3DSA:2.60.40.60:FF:000381', NULL, NULL, 'Protocadherin 15', NULL, NULL, NULL, NULL, NULL, 4),
(27755, NULL, 'G3DSA:3.30.750.24:FF:000061', NULL, NULL, 'Sigma factor regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(27756, NULL, 'G3DSA:3.30.70.870:FF:000043', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(27757, NULL, 'G3DSA:3.30.1490.100:FF:000039', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(27758, NULL, 'G3DSA:2.60.120.260:FF:000315', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(27759, NULL, 'G3DSA:4.10.49.10:FF:000001', NULL, NULL, 'Cytochrome c oxidase subunit 7C', NULL, NULL, NULL, NULL, NULL, 4),
(27760, NULL, 'G3DSA:1.10.238.200:FF:000019', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(27761, NULL, 'G3DSA:2.60.220.50:FF:000016', NULL, NULL, 'Adhesion G protein-coupled receptor B1', NULL, NULL, NULL, NULL, NULL, 4),
(27762, NULL, 'G3DSA:3.40.30.10:FF:000673', NULL, NULL, 'Adaptive-response sensory-kinase SasA', NULL, NULL, NULL, NULL, NULL, 4),
(27763, NULL, 'G3DSA:3.30.70.330:FF:002455', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27764, NULL, 'G3DSA:3.90.70.10:FF:000448', NULL, NULL, 'Cysteine peptidase, Clan CA, family C2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27765, NULL, 'G3DSA:1.10.238.10:FF:000448', NULL, NULL, 'Serine/threonine-protein phosphatase with EF-hands', NULL, NULL, NULL, NULL, NULL, 4),
(27766, NULL, 'G3DSA:3.30.565.10:FF:000443', NULL, NULL, 'Histidine kinase dimerisation and phosphoacceptor region', NULL, NULL, NULL, NULL, NULL, 4),
(27767, NULL, 'G3DSA:1.20.120.1900:FF:000055', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(27768, NULL, 'G3DSA:3.30.70.1840:FF:000003', NULL, NULL, 'Spike glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(27769, NULL, 'G3DSA:2.30.30.40:FF:000229', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(27770, NULL, 'G3DSA:3.90.1140.10:FF:000009', NULL, NULL, 'RNA 2'',3''-cyclic phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(27771, NULL, 'G3DSA:3.30.200.20:FF:000083', NULL, NULL, 'Putative receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(27772, NULL, 'G3DSA:3.40.50.300:FF:000877', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(27773, NULL, 'G3DSA:1.10.1670.10:FF:000007', NULL, NULL, 'DNA-3-methyladenine glycosylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(27774, NULL, 'G3DSA:3.40.50.300:FF:002570', NULL, NULL, 'ATP-dependent helicase/nuclease subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(27775, NULL, 'G3DSA:2.60.40.10:FF:002732', NULL, NULL, 'Chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(27776, NULL, 'G3DSA:3.30.70.890:FF:000049', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(27777, NULL, 'G3DSA:3.30.1370.10:FF:000220', NULL, NULL, 'LD29992p', NULL, NULL, NULL, NULL, NULL, 4),
(27778, NULL, 'G3DSA:3.10.450.580:FF:000007', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(27779, NULL, 'G3DSA:3.90.1030.20:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27780, NULL, 'G3DSA:1.10.510.10:FF:000952', NULL, NULL, 'cyclin-dependent kinase 20 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(27781, NULL, 'G3DSA:3.80.10.10:FF:001608', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine/tyrosine-protein kinase SOBIR1', NULL, NULL, NULL, NULL, NULL, 4),
(27782, NULL, 'G3DSA:2.60.200.10:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27783, NULL, 'G3DSA:3.90.70.10:FF:000813', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27784, NULL, 'G3DSA:1.10.620.20:FF:000019', NULL, NULL, 'Putative acyl-[acyl-carrier-protein] desaturase DesA2', NULL, NULL, NULL, NULL, NULL, 4),
(27785, NULL, 'G3DSA:3.30.559.30:FF:000069', NULL, NULL, 'N-(5-amino-5-carboxypentanoyl)-L-cysteinyl-D-valine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(27786, NULL, 'G3DSA:3.30.40.10:FF:002023', NULL, NULL, 'CCR4-NOT transcription complex, subunit 4a', NULL, NULL, NULL, NULL, NULL, 4),
(27787, NULL, 'G3DSA:3.40.50.300:FF:002659', NULL, NULL, 'Rad5p', NULL, NULL, NULL, NULL, NULL, 4),
(27788, NULL, 'G3DSA:3.30.2160.10:FF:000047', NULL, NULL, 'E3 ubiquitin-protein ligase HERC2', NULL, NULL, NULL, NULL, NULL, 4),
(27789, NULL, 'G3DSA:3.30.70.330:FF:002146', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27790, NULL, 'G3DSA:3.30.40.10:FF:000241', NULL, NULL, 'E3 SUMO-protein ligase SIZ2', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(27791, NULL, 'G3DSA:1.10.238.10:FF:000139', NULL, NULL, 'Peflin isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(27792, NULL, 'G3DSA:2.60.200.20:FF:000057', NULL, NULL, 'Forkhead box K2', NULL, NULL, NULL, NULL, NULL, 4),
(27793, NULL, 'G3DSA:1.10.510.10:FF:002498', NULL, NULL, 'Serine/threonine-protein kinase stk11 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(27794, NULL, 'G3DSA:1.10.1740.100:FF:000002', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(27795, NULL, 'G3DSA:3.40.50.1000:FF:000671', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27796, NULL, 'G3DSA:3.40.525.10:FF:000051', NULL, NULL, 'Ras GTPase activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(27797, NULL, 'G3DSA:2.130.10.10:FF:002148', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(27798, NULL, 'G3DSA:2.40.70.10:FF:000037', NULL, NULL, 'Renin', NULL, NULL, NULL, NULL, NULL, 4),
(27799, NULL, 'G3DSA:3.30.1120.30:FF:000022', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(27800, NULL, 'G3DSA:3.30.70.2610:FF:000010', NULL, NULL, 'General transcription factor IIH subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(27801, NULL, 'G3DSA:1.20.1260.10:FF:000013', NULL, NULL, '2-nonaprenyl-3-methyl-6-methoxy-1,4-benzoquinol hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(27802, NULL, 'G3DSA:1.20.1070.10:FF:002022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27803, NULL, 'G3DSA:1.10.400.10:FF:000034', NULL, NULL, 'Guanine nucleotide binding protein (G protein), alpha 13b', NULL, NULL, NULL, NULL, NULL, 4),
(27804, NULL, 'G3DSA:3.80.10.10:FF:003317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27805, NULL, 'G3DSA:3.40.50.880:FF:000214', NULL, NULL, 'Uncharacterized protein MG029', NULL, NULL, NULL, NULL, NULL, 4),
(27806, NULL, 'G3DSA:3.30.60.30:FF:000248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27807, NULL, 'G3DSA:3.50.50.60:FF:000323', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(27808, NULL, 'G3DSA:1.10.3810.10:FF:000002', NULL, NULL, 'Penicillin-binding protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(27809, NULL, 'G3DSA:1.25.40.10:FF:004631', NULL, NULL, 'Si:ch73-68b22.2', NULL, NULL, NULL, NULL, NULL, 4),
(27810, NULL, 'G3DSA:2.170.270.10:FF:000190', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(27811, NULL, 'G3DSA:1.25.40.10:FF:004069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27812, NULL, 'G3DSA:2.40.70.10:FF:000508', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27813, NULL, 'G3DSA:3.40.30.10:FF:001061', NULL, NULL, 'AER413Cp', NULL, NULL, NULL, NULL, NULL, 4),
(27814, NULL, 'G3DSA:2.30.42.10:FF:000028', NULL, NULL, 'PDZ domain containing ring finger 4', NULL, NULL, NULL, NULL, NULL, 4),
(27815, NULL, 'G3DSA:3.30.160.60:FF:004328', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27816, NULL, 'G3DSA:3.30.1520.10:FF:000013', NULL, NULL, 'Putative Sorting nexin 3', NULL, NULL, NULL, NULL, NULL, 4),
(27817, NULL, 'G3DSA:3.40.47.10:FF:000076', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 3', NULL, NULL, NULL, NULL, NULL, 4),
(27818, NULL, 'G3DSA:3.30.40.10:FF:001770', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27819, NULL, 'G3DSA:1.10.10.10:FF:000239', NULL, NULL, 'heterochromatin protein 1-binding protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(27820, NULL, 'G3DSA:2.40.50.140:FF:000119', NULL, NULL, 'Protection of telomeres 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(27821, NULL, 'G3DSA:3.30.565.10:FF:000134', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(27822, NULL, 'G3DSA:2.130.10.10:FF:001063', NULL, NULL, 'VPS15 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(27823, NULL, 'G3DSA:2.60.40.10:FF:000478', NULL, NULL, 'Protein tyrosine phosphatase, receptor type Q', NULL, NULL, NULL, NULL, NULL, 4),
(27824, NULL, 'G3DSA:3.40.50.720:FF:002122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(27825, NULL, 'G3DSA:1.20.5.190:FF:000075', NULL, NULL, 'Neuromodulin', NULL, NULL, NULL, NULL, NULL, 4),
(27826, NULL, 'G3DSA:3.30.420.40:FF:000852', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27827, NULL, 'G3DSA:3.30.710.10:FF:000163', NULL, NULL, 'BTB/POZ domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(27828, NULL, 'G3DSA:3.30.160.60:FF:004660', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27829, NULL, 'G3DSA:2.60.40.150:FF:000167', NULL, NULL, 'Multiple C2 domains, transmembrane 2a', NULL, NULL, NULL, NULL, NULL, 4),
(27830, NULL, 'G3DSA:3.40.630.10:FF:000093', NULL, NULL, 'Peptide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(27831, NULL, 'G3DSA:3.30.1120.10:FF:000067', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(27832, NULL, 'G3DSA:1.10.510.10:FF:004443', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27833, NULL, 'G3DSA:3.40.630.30:FF:000099', NULL, NULL, 'probable acetyltransferase NATA1-like', NULL, NULL, NULL, NULL, NULL, 4),
(27834, NULL, 'G3DSA:3.40.630.10:FF:000413', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27835, NULL, 'G3DSA:1.25.40.10:FF:000382', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(27836, NULL, 'G3DSA:1.25.10.10:FF:002662', NULL, NULL, 'Os03g0261950 protein', NULL, NULL, NULL, NULL, NULL, 4),
(27837, NULL, 'G3DSA:1.20.1250.20:FF:000100', NULL, NULL, 'MFS sugar transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27838, NULL, 'G3DSA:3.10.20.90:FF:000068', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 32', NULL, NULL, NULL, NULL, NULL, 4),
(27839, NULL, 'G3DSA:3.10.490.10:FF:000009', NULL, NULL, 'Putative gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(27840, NULL, 'G3DSA:3.50.50.60:FF:000014', NULL, NULL, 'Dihydrolipoyl dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(27841, NULL, 'G3DSA:3.30.470.20:FF:000231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27842, NULL, 'G3DSA:1.25.40.20:FF:000385', NULL, NULL, 'Probable 26S proteasome regulatory subunit p28', NULL, NULL, NULL, NULL, NULL, 4),
(27843, NULL, 'G3DSA:1.10.510.10:FF:000391', NULL, NULL, 'Hormonally up-regulated neu tumor-associated kinase', NULL, NULL, NULL, NULL, NULL, 4),
(27844, NULL, 'G3DSA:1.10.1170.10:FF:000003', NULL, NULL, 'E3 ubiquitin-protein ligase XIAP', NULL, NULL, NULL, NULL, NULL, 4),
(27845, NULL, 'G3DSA:1.10.600.10:FF:000015', NULL, NULL, 'Solanesyl diphosphate synthase 3, chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(27846, NULL, 'G3DSA:3.10.50.40:FF:000139', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(27847, NULL, 'G3DSA:2.60.40.10:FF:004749', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27848, NULL, 'G3DSA:2.60.40.420:FF:000034', NULL, NULL, 'Cupredoxin superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(27849, NULL, 'G3DSA:3.40.50.300:FF:006841', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(27850, NULL, 'G3DSA:2.80.10.50:FF:000049', NULL, NULL, 'Interleukin-1 alpha', NULL, NULL, NULL, NULL, NULL, 4),
(27851, NULL, 'G3DSA:3.10.100.10:FF:000267', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27852, NULL, 'G3DSA:2.60.40.4060:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27853, NULL, 'G3DSA:1.10.10.10:FF:000790', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit K', NULL, NULL, NULL, NULL, NULL, 4),
(27854, NULL, 'G3DSA:2.40.50.1060:FF:000009', NULL, NULL, 'DNA-directed RNA polymerase I subunit', NULL, NULL, NULL, NULL, NULL, 4),
(27855, NULL, 'G3DSA:3.40.50.300:FF:004913', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27856, NULL, 'G3DSA:1.20.58.390:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27857, NULL, 'G3DSA:3.30.530.20:FF:000068', NULL, NULL, 'Pleckstrin homology (PH) and lipid-binding START domains-containing protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(27858, NULL, 'G3DSA:1.25.10.10:FF:002914', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27859, NULL, 'G3DSA:1.20.1070.10:FF:000330', NULL, NULL, 'Alpha 2B adrenergic receptor', NULL, NULL, NULL, NULL, NULL, 4),
(27860, NULL, 'G3DSA:3.40.50.720:FF:002431', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(27861, NULL, 'G3DSA:1.10.3470.10:FF:000032', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(27862, NULL, 'G3DSA:1.10.560.10:FF:000085', NULL, NULL, 'T-complex protein 1 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(27863, NULL, 'G3DSA:3.10.20.90:FF:000719', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(27864, NULL, 'G3DSA:1.20.5.1940:FF:000002', NULL, NULL, 'Signal transducing adapter molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(27865, NULL, 'G3DSA:1.25.70.10:FF:000097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27866, NULL, 'G3DSA:1.25.40.10:FF:002377', NULL, NULL, 'TPR domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(27867, NULL, 'G3DSA:3.40.50.1980:FF:000060', NULL, NULL, 'Iron complex transport system substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(27868, NULL, 'G3DSA:3.30.160.60:FF:002636', NULL, NULL, 'Zinc finger protein 480', NULL, NULL, NULL, NULL, NULL, 4),
(27869, NULL, 'G3DSA:3.80.10.10:FF:002699', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(27870, NULL, 'G3DSA:1.10.10.410:FF:000006', NULL, NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit B, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(27871, NULL, 'G3DSA:3.10.10.10:FF:000021', NULL, NULL, 'Pol93p', NULL, NULL, NULL, NULL, NULL, 4),
(27872, NULL, 'G3DSA:3.40.50.970:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27873, NULL, 'G3DSA:1.20.1250.20:FF:001483', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27874, NULL, 'G3DSA:3.30.565.10:FF:000353', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(27875, NULL, 'G3DSA:2.60.40.1510:FF:000038', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(27876, NULL, 'G3DSA:1.25.10.10:FF:002353', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27877, NULL, 'G3DSA:1.25.40.470:FF:000003', NULL, NULL, 'intraflagellar transport protein 122 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(27878, NULL, 'G3DSA:2.10.25.10:FF:001726', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(27879, NULL, 'G3DSA:3.10.20.90:FF:000377', NULL, NULL, 'FERM domain (Protein4.1-ezrin-radixin-moesin) family', NULL, NULL, NULL, NULL, NULL, 4),
(27880, NULL, 'G3DSA:1.25.40.480:FF:000006', NULL, NULL, 'Bystin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27881, NULL, 'G3DSA:3.30.56.10:FF:000002', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(27882, NULL, 'G3DSA:2.130.10.10:FF:003929', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27883, NULL, 'G3DSA:3.40.50.720:FF:000413', NULL, NULL, 'Trans-acting enoyl reductase', NULL, NULL, NULL, NULL, NULL, 4),
(27884, NULL, 'G3DSA:1.10.238.10:FF:001162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27885, NULL, 'G3DSA:2.60.40.60:FF:000577', NULL, NULL, 'Cadherin 4', NULL, NULL, NULL, NULL, NULL, 4),
(27886, NULL, 'G3DSA:1.20.1250.20:FF:001825', NULL, NULL, 'Slc2A8 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27887, NULL, 'G3DSA:2.130.10.10:FF:004391', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27888, NULL, 'G3DSA:4.10.520.10:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27889, NULL, 'G3DSA:1.10.287.70:FF:000051', NULL, NULL, 'Sodium channel 1', NULL, NULL, NULL, NULL, NULL, 4),
(27890, NULL, 'G3DSA:1.10.1300.10:FF:000019', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(27891, NULL, 'G3DSA:3.40.50.720:FF:000071', NULL, NULL, '2-hydroxy-3-oxopropionate reductase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(27892, NULL, 'G3DSA:3.40.190.10:FF:000373', NULL, NULL, 'Membrane-bound lytic murein transglycosylase F', NULL, NULL, NULL, NULL, NULL, 4),
(27893, NULL, 'G3DSA:3.30.830.10:FF:000228', NULL, NULL, 'Insulin-degrading enzyme-like 1 peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(27894, NULL, 'G3DSA:3.30.230.70:FF:000037', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(27895, NULL, 'G3DSA:2.160.10.10:FF:000084', NULL, NULL, 'Nucleotide-diphospho-sugar transferase', NULL, NULL, NULL, NULL, NULL, 4),
(27896, NULL, 'G3DSA:1.10.10.60:FF:001052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27897, NULL, 'G3DSA:3.30.470.30:FF:000015', NULL, NULL, 'Mrna capping enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(27898, NULL, 'G3DSA:3.90.1310.10:FF:000045', NULL, NULL, 'Penicillin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(27899, NULL, 'G3DSA:2.120.10.30:FF:000226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27900, NULL, 'G3DSA:2.70.98.20:FF:000035', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(27901, NULL, 'G3DSA:3.40.50.300:FF:002878', NULL, NULL, 'RAs-related GTP-binding protein A', NULL, NULL, NULL, NULL, NULL, 4),
(27902, NULL, 'G3DSA:3.40.50.300:FF:006931', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27903, NULL, 'G3DSA:2.130.10.10:FF:000804', NULL, NULL, 'WD repeat and SOCS box-containing 1, isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(27904, NULL, 'G3DSA:3.30.160.60:FF:000585', NULL, NULL, 'zinc finger protein 784', NULL, NULL, NULL, NULL, NULL, 4),
(27905, NULL, 'G3DSA:1.20.1560.10:FF:000053', NULL, NULL, 'Multidrug ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(27906, NULL, 'G3DSA:3.40.50.300:FF:004587', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(27907, NULL, 'G3DSA:1.10.3210.10:FF:000069', NULL, NULL, 'Blr1456 protein', NULL, NULL, NULL, NULL, NULL, 4),
(27908, NULL, 'G3DSA:3.30.200.20:FF:000335', NULL, NULL, 'Serine/threonine-protein kinase MHK', NULL, NULL, NULL, NULL, NULL, 4),
(27909, NULL, 'G3DSA:2.40.160.120:FF:000062', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(27910, NULL, 'G3DSA:3.40.50.1820:FF:001546', NULL, NULL, 'Ndrg family member 3b', NULL, NULL, NULL, NULL, NULL, 4),
(27911, NULL, 'G3DSA:3.30.40.10:FF:000022', NULL, NULL, 'E3 ubiquitin-protein ligase RING1-like', NULL, NULL, NULL, NULL, NULL, 4),
(27912, NULL, 'G3DSA:2.130.10.10:FF:004188', NULL, NULL, 'Secreted chemorepellent semaphorin 3F', NULL, NULL, NULL, NULL, NULL, 4),
(27913, NULL, 'G3DSA:2.60.120.200:FF:000073', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(27914, NULL, 'G3DSA:3.10.20.90:FF:000848', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(27915, NULL, 'G3DSA:2.130.10.10:FF:002479', NULL, NULL, 'Intraflagellar transport protein 140 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(27916, NULL, 'G3DSA:3.90.70.10:FF:000667', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(27917, NULL, 'G3DSA:3.10.110.10:FF:000094', NULL, NULL, 'Probable ubiquitin-conjugating enzyme E2 23', NULL, NULL, NULL, NULL, NULL, 4),
(27918, NULL, 'G3DSA:3.90.1150.10:FF:000190', NULL, NULL, 'Putative serine--glyoxylate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(27919, NULL, 'G3DSA:3.30.450.40:FF:000152', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(27920, NULL, 'G3DSA:2.60.40.1460:FF:000001', NULL, NULL, 'Integrin, alpha V', NULL, NULL, NULL, NULL, NULL, 4),
(27921, NULL, 'G3DSA:2.30.30.100:FF:000151', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm7', NULL, NULL, NULL, NULL, NULL, 4),
(27922, NULL, 'G3DSA:3.30.40.10:FF:001966', NULL, NULL, 'E3 ubiquitin-protein ligase ORTHRUS 2', NULL, NULL, NULL, NULL, NULL, 4),
(27923, NULL, 'G3DSA:3.30.160.60:FF:006436', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27924, NULL, 'G3DSA:3.30.160.60:FF:002726', NULL, NULL, 'Unplaced genomic scaffold supercont1.21, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(27925, NULL, 'G3DSA:1.25.10.10:FF:000644', NULL, NULL, 'Patatin', NULL, NULL, NULL, NULL, NULL, 4),
(27926, NULL, 'G3DSA:1.10.150.380:FF:000004', NULL, NULL, 'Aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(27927, NULL, 'G3DSA:1.10.405.10:FF:000039', NULL, NULL, 'AGAP012773-PA', NULL, NULL, NULL, NULL, NULL, 4),
(27928, NULL, 'G3DSA:2.60.40.1910:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27929, NULL, 'G3DSA:3.90.226.10:FF:000327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27930, NULL, 'G3DSA:2.70.170.10:FF:000133', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(27931, NULL, 'G3DSA:3.40.50.2300:FF:000173', NULL, NULL, 'Two-component transcriptional regulator, winged helix family', NULL, NULL, NULL, NULL, NULL, 4),
(27932, NULL, 'G3DSA:2.160.20.10:FF:000034', NULL, NULL, 'PKHD1, fibrocystin/polyductin', NULL, NULL, NULL, NULL, NULL, 4),
(27933, NULL, 'G3DSA:3.40.50.300:FF:004677', NULL, NULL, 'Nucleic acid helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27934, NULL, 'G3DSA:3.40.50.300:FF:000861', NULL, NULL, 'Fanconi anemia, complementation group M', NULL, NULL, NULL, NULL, NULL, 4),
(27935, NULL, 'G3DSA:3.40.50.720:FF:002212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27936, NULL, 'G3DSA:3.40.395.10:FF:000034', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(27937, NULL, 'G3DSA:3.30.50.10:FF:000051', NULL, NULL, 'Nuclear receptor subfamily 1 group I member 3', NULL, NULL, NULL, NULL, NULL, 4),
(27938, NULL, 'G3DSA:1.25.10.10:FF:000554', NULL, NULL, 'Exportin-7', NULL, NULL, NULL, NULL, NULL, 4),
(27939, NULL, 'G3DSA:1.10.150.370:FF:000001', NULL, NULL, 'Protein her-1', NULL, NULL, NULL, NULL, NULL, 4),
(27940, NULL, 'G3DSA:2.60.420.10:FF:000020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(27941, NULL, 'G3DSA:1.10.1870.10:FF:000011', NULL, NULL, 'Saccharopine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(27942, NULL, 'G3DSA:3.30.200.20:FF:002134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27943, NULL, 'G3DSA:2.70.98.10:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27944, NULL, 'G3DSA:1.20.920.30:FF:000032', NULL, NULL, 'Dynein heavy chain, cytosolic, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27945, NULL, 'G3DSA:3.30.420.40:FF:000324', NULL, NULL, 'Putative actin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(27946, NULL, 'G3DSA:3.50.50.60:FF:000233', NULL, NULL, 'Trypanothione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(27947, NULL, 'G3DSA:3.40.50.1820:FF:001456', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27948, NULL, 'G3DSA:1.20.1050.10:FF:000222', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(27949, NULL, 'G3DSA:2.20.130.20:FF:000010', NULL, NULL, 'Thioester-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(27950, NULL, 'G3DSA:3.30.1370.10:FF:000074', NULL, NULL, 'Small subunit rRNA processing KH domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27951, NULL, 'G3DSA:2.60.40.150:FF:000532', NULL, NULL, 'rab11 family-interacting protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(27952, NULL, 'G3DSA:3.40.50.2300:FF:000515', NULL, NULL, 'glutamate receptor 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(27953, NULL, 'G3DSA:3.30.470.20:FF:000012', NULL, NULL, 'Pyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(27954, NULL, 'G3DSA:1.10.510.10:FF:004078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27955, NULL, 'G3DSA:3.90.226.10:FF:000075', NULL, NULL, 'ATP-dependent Clp protease proteolytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(27956, NULL, 'G3DSA:1.25.10.10:FF:000099', NULL, NULL, 'Deoxyhypusine hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(27957, NULL, 'G3DSA:1.20.120.350:FF:000257', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27958, NULL, 'G3DSA:3.40.225.10:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(27959, NULL, 'G3DSA:3.40.47.10:FF:000166', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase, KASII', NULL, NULL, NULL, NULL, NULL, 4),
(27960, NULL, 'G3DSA:3.40.50.150:FF:000703', NULL, NULL, 'Anamorsin', NULL, NULL, NULL, NULL, NULL, 4),
(27961, NULL, 'G3DSA:2.30.250.10:FF:000007', NULL, NULL, 'Clan MH, family M18, aspartyl aminopeptidase-like metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(27962, NULL, 'G3DSA:3.30.565.10:FF:000549', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27963, NULL, 'G3DSA:3.40.50.150:FF:000557', NULL, NULL, 'Polyamine aminopropyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(27964, NULL, 'G3DSA:3.30.160.60:FF:000927', NULL, NULL, 'Zinc finger and BTB domain-containing protein 49', NULL, NULL, NULL, NULL, NULL, 4),
(27965, NULL, 'G3DSA:1.25.10.10:FF:002443', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(27966, NULL, 'G3DSA:2.130.10.10:FF:004733', NULL, NULL, 'UBP9-binding protein bun107', NULL, NULL, NULL, NULL, NULL, 4),
(27967, NULL, 'G3DSA:1.10.150.390:FF:000007', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(27968, NULL, 'G3DSA:3.90.550.10:FF:000255', NULL, NULL, 'PROBABLE GLYCOSYLTRANSFERASE', NULL, NULL, NULL, NULL, NULL, 4),
(27969, NULL, 'G3DSA:3.100.10.10:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27970, NULL, 'G3DSA:1.20.1250.20:FF:001735', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27971, NULL, 'G3DSA:1.20.1000.10:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27972, NULL, 'G3DSA:2.160.20.70:FF:000046', NULL, NULL, 'Adenylyl cyclase-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(27973, NULL, 'G3DSA:3.30.200.20:FF:001948', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27974, NULL, 'G3DSA:1.20.144.10:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27975, NULL, 'G3DSA:2.60.120.310:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27976, NULL, 'G3DSA:1.25.40.10:FF:000269', NULL, NULL, 'Crooked neck pre-mRNA-splicing factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(27977, NULL, 'G3DSA:1.25.40.10:FF:002832', NULL, NULL, 'Tetratricopeptide repeat protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(27978, NULL, 'G3DSA:2.130.10.10:FF:004643', NULL, NULL, 'F-box and WD domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27979, NULL, 'G3DSA:3.30.160.60:FF:006127', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27980, NULL, 'G3DSA:2.40.10.10:FF:000623', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(27981, NULL, 'G3DSA:3.30.830.10:FF:000138', NULL, NULL, 'Core subunit of the ubiquinol-cytochrome-c reductase complex, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4),
(27982, NULL, 'G3DSA:2.30.29.30:FF:000032', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(27983, NULL, 'G3DSA:3.40.50.300:FF:000529', NULL, NULL, 'helicase SRCAP isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(27984, NULL, 'G3DSA:3.30.160.60:FF:001332', NULL, NULL, 'zinc finger protein 197 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(27985, NULL, 'G3DSA:1.10.10.60:FF:000580', NULL, NULL, 'Reproductive homeobox on X chromosome 11', NULL, NULL, NULL, NULL, NULL, 4),
(27986, NULL, 'G3DSA:2.60.40.60:FF:001105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27987, NULL, 'G3DSA:3.40.50.150:FF:000248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27988, NULL, 'G3DSA:3.90.190.10:FF:000013', NULL, NULL, 'receptor-type tyrosine-protein phosphatase zeta isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(27989, NULL, 'G3DSA:3.10.110.10:FF:000307', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27990, NULL, 'G3DSA:3.50.50.60:FF:000429', NULL, NULL, 'FAD-dependent monooxygenase nscC', NULL, NULL, NULL, NULL, NULL, 4),
(27991, NULL, 'G3DSA:2.60.40.60:FF:000487', NULL, NULL, 'Cadherin 17, LI cadherin (liver-intestine)', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(27992, NULL, 'G3DSA:1.10.10.60:FF:000338', NULL, NULL, 'Homeobox protein Nkx-3.1', NULL, NULL, NULL, NULL, NULL, 4),
(27993, NULL, 'G3DSA:1.10.420.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27994, NULL, 'G3DSA:3.30.740.10:FF:000002', NULL, NULL, 'Dynein light chain', NULL, NULL, NULL, NULL, NULL, 4),
(27995, NULL, 'G3DSA:2.120.10.80:FF:000292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(27996, NULL, 'G3DSA:3.40.190.10:FF:000283', NULL, NULL, 'Blast:Probable glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(27997, NULL, 'G3DSA:3.40.50.300:FF:000771', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(27998, NULL, 'G3DSA:3.90.190.20:FF:000016', NULL, NULL, 'UDP-N-acetylmuramate--L-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(27999, NULL, 'G3DSA:1.10.1070.11:FF:000036', NULL, NULL, 'Phosphatidylinositol-4,5-bisphosphate 3-kinase catalytic subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28000, NULL, 'G3DSA:1.20.120.310:FF:000003', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(28001, NULL, 'G3DSA:3.30.160.60:FF:000837', NULL, NULL, 'E3 SUMO-protein ligase EGR2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(28002, NULL, 'G3DSA:3.30.1640.10:FF:000067', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(28003, NULL, 'G3DSA:1.20.120.330:FF:000009', NULL, NULL, 'Sacsin molecular chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(28004, NULL, 'G3DSA:2.130.10.10:FF:000681', NULL, NULL, 'Cleavage and polyadenylation specificity factor (CPSF) A subunit protein', NULL, NULL, NULL, NULL, NULL, 4),
(28005, NULL, 'G3DSA:3.40.50.720:FF:001740', NULL, NULL, 'Adenosylhomocysteinase', NULL, NULL, NULL, NULL, NULL, 4),
(28006, NULL, 'G3DSA:3.90.550.10:FF:000564', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(28007, NULL, 'G3DSA:1.25.40.10:FF:002490', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g58590', NULL, NULL, NULL, NULL, NULL, 4),
(28008, NULL, 'G3DSA:3.30.160.60:FF:005132', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28009, NULL, 'G3DSA:3.40.50.10810:FF:000246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28010, NULL, 'G3DSA:3.40.50.720:FF:000323', NULL, NULL, 'Estradiol 17-beta-dehydrogenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(28011, NULL, 'G3DSA:1.10.510.10:FF:001205', NULL, NULL, 'SR protein kinase, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(28012, NULL, 'G3DSA:1.20.1080.10:FF:000050', NULL, NULL, 'Formate transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(28013, NULL, 'G3DSA:1.25.10.10:FF:000189', NULL, NULL, 'SCY1-like pseudokinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(28014, NULL, 'G3DSA:3.40.50.2300:FF:000425', NULL, NULL, 'Metabotropic glutamate receptor 7', NULL, NULL, NULL, NULL, NULL, 4),
(28015, NULL, 'G3DSA:2.40.10.10:FF:000281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28016, NULL, 'G3DSA:2.120.10.80:FF:000073', NULL, NULL, 'Kelch domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(28017, NULL, 'G3DSA:3.40.50.720:FF:001717', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(28018, NULL, 'G3DSA:3.50.30.50:FF:000009', NULL, NULL, 'Isatin hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(28019, NULL, 'G3DSA:3.30.200.20:FF:000189', NULL, NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(28020, NULL, 'G3DSA:1.10.287.1490:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28021, NULL, 'G3DSA:2.10.25.10:FF:000889', NULL, NULL, 'Hemolectin', NULL, NULL, NULL, NULL, NULL, 4),
(28022, NULL, 'G3DSA:2.10.25.10:FF:001507', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(28023, NULL, 'G3DSA:1.25.40.10:FF:000578', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(28024, NULL, 'G3DSA:1.10.150.20:FF:000062', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(28025, NULL, 'G3DSA:2.130.10.10:FF:004952', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit trm82', NULL, NULL, NULL, NULL, NULL, 4),
(28026, NULL, 'G3DSA:3.90.70.10:FF:000577', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28027, NULL, 'G3DSA:2.60.210.10:FF:000083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28028, NULL, 'G3DSA:2.60.40.10:FF:000624', NULL, NULL, 'HEPACAM family member 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(28029, NULL, 'G3DSA:3.40.366.10:FF:000051', NULL, NULL, 'Polyketide synthase, putative (JCVI)', NULL, NULL, NULL, NULL, NULL, 4),
(28030, NULL, 'G3DSA:1.10.510.10:FF:004297', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28031, NULL, 'G3DSA:3.20.110.10:FF:000024', NULL, NULL, 'Alpha-mannosidase E', NULL, NULL, NULL, NULL, NULL, 4),
(28032, NULL, 'G3DSA:3.10.450.10:FF:000035', NULL, NULL, 'Cysteine proteinase inhibitor 1', NULL, NULL, NULL, NULL, NULL, 4),
(28033, NULL, 'G3DSA:2.10.25.10:FF:001417', NULL, NULL, 'uncharacterized protein LOC100177824', NULL, NULL, NULL, NULL, NULL, 4),
(28034, NULL, 'G3DSA:3.40.50.720:FF:001408', NULL, NULL, 'UDP-galactose-4-epimerase, isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(28035, NULL, 'G3DSA:3.40.140.10:FF:000128', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit F', NULL, NULL, NULL, NULL, NULL, 4),
(28036, NULL, 'G3DSA:3.90.1150.10:FF:000280', NULL, NULL, 'Class III aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(28037, NULL, 'G3DSA:2.130.10.10:FF:000591', NULL, NULL, 'Echinoderm microtubule-associated protein-like CG42247', NULL, NULL, NULL, NULL, NULL, 4),
(28038, NULL, 'G3DSA:3.90.1180.10:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28039, NULL, 'G3DSA:3.30.60.20:FF:000099', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(28040, NULL, 'G3DSA:1.20.5.370:FF:000005', NULL, NULL, 'Myosin heavy chain, isoform I', NULL, NULL, NULL, NULL, NULL, 4),
(28041, NULL, 'G3DSA:2.130.10.10:FF:000349', NULL, NULL, 'Dynein axonemal intermediate chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(28042, NULL, 'G3DSA:3.80.10.10:FF:002322', NULL, NULL, 'Outer arm dynein light chain 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(28043, NULL, 'G3DSA:3.30.540.10:FF:000037', NULL, NULL, 'Fructose-1,6-bisphosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(28044, NULL, 'G3DSA:1.25.40.430:FF:000020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(28045, NULL, 'G3DSA:1.25.40.10:FF:002181', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(28046, NULL, 'G3DSA:2.70.98.10:FF:000032', NULL, NULL, 'Putative alpha-1,2-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(28047, NULL, 'G3DSA:1.20.1440.120:FF:000003', NULL, NULL, 'DNA repair protein RecO', NULL, NULL, NULL, NULL, NULL, 4),
(28048, NULL, 'G3DSA:3.30.70.330:FF:000106', NULL, NULL, 'Splicing factor 3b, subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(28049, NULL, 'G3DSA:1.20.1440.130:FF:000006', NULL, NULL, 'Vitamin K epoxide reductase family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28050, NULL, 'G3DSA:1.10.418.10:FF:000092', NULL, NULL, 'Fimbrin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28051, NULL, 'G3DSA:2.60.40.10:FF:000933', NULL, NULL, 'Mucosal addressin cell adhesion molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(28052, NULL, 'G3DSA:3.30.200.20:FF:001639', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28053, NULL, 'G3DSA:2.60.40.60:FF:000268', NULL, NULL, 'Cadherin related family member 4', NULL, NULL, NULL, NULL, NULL, 4),
(28054, NULL, 'G3DSA:3.40.50.300:FF:000990', NULL, NULL, 'ras-related protein Rab-15 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(28055, NULL, 'G3DSA:1.25.40.10:FF:002523', NULL, NULL, 'DENN domain-containing protein 4B', NULL, NULL, NULL, NULL, NULL, 4),
(28056, NULL, 'G3DSA:3.40.50.410:FF:000202', NULL, NULL, 'ATP-dependent DNA helicase II subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(28057, NULL, 'G3DSA:3.30.40.10:FF:001876', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(28058, NULL, 'G3DSA:3.30.160.60:FF:001080', NULL, NULL, 'Zinc finger and SCAN domain containing 10', NULL, NULL, NULL, NULL, NULL, 4),
(28059, NULL, 'G3DSA:2.60.40.770:FF:000009', NULL, NULL, 'LP08842p', NULL, NULL, NULL, NULL, NULL, 4),
(28060, NULL, 'G3DSA:3.40.50.2000:FF:000307', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(28061, NULL, 'G3DSA:3.30.160.60:FF:005042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28062, NULL, 'G3DSA:2.10.25.10:FF:001165', NULL, NULL, 'AGAP007850-PA', NULL, NULL, NULL, NULL, NULL, 4),
(28063, NULL, 'G3DSA:3.10.180.10:FF:000042', NULL, NULL, '27 kDa antigen Cfp30B', NULL, NULL, NULL, NULL, NULL, 4),
(28064, NULL, 'G3DSA:1.10.510.10:FF:001115', NULL, NULL, 'Serine/threonine kinase like domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(28065, NULL, 'G3DSA:1.10.10.60:FF:000029', NULL, NULL, 'Homeobox protein Hox-D4', NULL, NULL, NULL, NULL, NULL, 4),
(28066, NULL, 'G3DSA:3.40.50.300:FF:001024', NULL, NULL, 'GTPase Era, mitochondrial isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(28067, NULL, 'G3DSA:3.30.60.290:FF:000002', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(28068, NULL, 'G3DSA:1.10.8.100:FF:000011', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(28069, NULL, 'G3DSA:1.10.287.2250:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28070, NULL, 'G3DSA:3.40.190.290:FF:000090', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(28071, NULL, 'G3DSA:1.25.10.10:FF:000863', NULL, NULL, 'cilia- and flagella-associated protein 69 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(28072, NULL, 'G3DSA:3.30.70.330:FF:001977', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28073, NULL, 'G3DSA:2.130.10.10:FF:002721', NULL, NULL, 'WD repeat domain phosphoinositide-interacting protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(28074, NULL, 'G3DSA:3.90.1100.10:FF:000029', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(28075, NULL, 'G3DSA:2.60.40.10:FF:000489', NULL, NULL, 'collagen alpha-1(XII) chain isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(28076, NULL, 'G3DSA:3.90.470.20:FF:000066', NULL, NULL, '4''-phosphopantetheinyl transferase PfaE', NULL, NULL, NULL, NULL, NULL, 4),
(28077, NULL, 'G3DSA:2.40.30.10:FF:000490', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28078, NULL, 'G3DSA:1.25.40.10:FF:000365', NULL, NULL, 'Pentatricopeptide repeat domain-containing protein 3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(28079, NULL, 'G3DSA:3.30.70.2660:FF:000002', NULL, NULL, 'BH0337 protein', NULL, NULL, NULL, NULL, NULL, 4),
(28080, NULL, 'G3DSA:3.30.559.30:FF:000064', NULL, NULL, 'Linear gramicidin synthase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(28081, NULL, 'G3DSA:3.10.490.10:FF:000026', NULL, NULL, 'Gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(28082, NULL, 'G3DSA:2.60.40.10:FF:004772', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28083, NULL, 'G3DSA:2.130.10.10:FF:005947', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28084, NULL, 'G3DSA:3.30.750.24:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28085, NULL, 'G3DSA:3.90.1640.10:FF:000036', NULL, NULL, 'Mutant prune', NULL, NULL, NULL, NULL, NULL, 4),
(28086, NULL, 'G3DSA:3.30.1020.10:FF:000003', NULL, NULL, 'Peroxiredoxin protein', NULL, NULL, NULL, NULL, NULL, 4),
(28087, NULL, 'G3DSA:3.80.10.10:FF:003289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28088, NULL, 'G3DSA:2.120.10.80:FF:000308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28089, NULL, 'G3DSA:3.30.479.30:FF:000012', NULL, NULL, 'Protein HflK', NULL, NULL, NULL, NULL, NULL, 4),
(28090, NULL, 'G3DSA:2.120.10.80:FF:000213', NULL, NULL, 'TatD related DNase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(28091, NULL, 'G3DSA:3.30.200.20:FF:000217', NULL, NULL, 'probable LRR receptor-like serine/threonine-protein kinase At1g53430', NULL, NULL, NULL, NULL, NULL, 4),
(28092, NULL, 'G3DSA:1.25.40.20:FF:000368', NULL, NULL, 'Palmitoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(28093, NULL, 'G3DSA:3.40.50.620:FF:000271', NULL, NULL, 'Methionine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(28094, NULL, 'G3DSA:1.10.10.10:FF:000711', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(28095, NULL, 'G3DSA:3.40.50.2300:FF:001488', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28096, NULL, 'G3DSA:3.40.640.10:FF:000363', NULL, NULL, 'Pyridoxal phosphate-dependent aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(28097, NULL, 'G3DSA:3.80.10.10:FF:003194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28098, NULL, 'G3DSA:3.30.160.60:FF:002176', NULL, NULL, 'zinc finger protein 236 isoform X7', NULL, NULL, NULL, NULL, NULL, 4),
(28099, NULL, 'G3DSA:1.25.40.10:FF:002394', NULL, NULL, 'Protein CBG11979', NULL, NULL, NULL, NULL, NULL, 4),
(28100, NULL, 'G3DSA:2.40.50.140:FF:000221', NULL, NULL, 'DNA-directed RNA polymerase III subunit', NULL, NULL, NULL, NULL, NULL, 4),
(28101, NULL, 'G3DSA:3.20.20.220:FF:000009', NULL, NULL, 'Methylenetetrahydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(28102, NULL, 'G3DSA:3.90.770.10:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28103, NULL, 'G3DSA:1.10.167.10:FF:000047', NULL, NULL, 'Regulator of G-protein signaling rgs-5', NULL, NULL, NULL, NULL, NULL, 4),
(28104, NULL, 'G3DSA:3.90.1150.10:FF:000066', NULL, NULL, 'Putative cystathionine beta-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(28105, NULL, 'G3DSA:1.25.40.790:FF:000009', NULL, NULL, 'CCR4-NOT transcriptional complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(28106, NULL, 'G3DSA:3.10.20.90:FF:000736', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28107, NULL, 'G3DSA:1.25.40.330:FF:000006', NULL, NULL, 'Adenylyl cyclase-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(28108, NULL, 'G3DSA:1.20.890.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28109, NULL, 'G3DSA:3.30.40.10:FF:002028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28110, NULL, 'G3DSA:2.40.240.20:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28111, NULL, 'G3DSA:1.10.10.60:FF:000670', NULL, NULL, 'Helicase putative', NULL, NULL, NULL, NULL, NULL, 4),
(28112, NULL, 'G3DSA:3.40.50.300:FF:006280', NULL, NULL, 'Replication factor C subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(28113, NULL, 'G3DSA:3.30.2350.10:FF:000090', NULL, NULL, 'TruB pseudouridine (psi) synthase family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(28114, NULL, 'G3DSA:1.10.286.10:FF:000003', NULL, NULL, 'GTP cyclohydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(28115, NULL, 'G3DSA:3.30.70.120:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28116, NULL, 'G3DSA:2.40.50.140:FF:000900', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28117, NULL, 'G3DSA:1.10.510.10:FF:002745', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28118, NULL, 'G3DSA:2.130.10.10:FF:004750', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28119, NULL, 'G3DSA:1.10.3430.10:FF:000035', NULL, NULL, 'Ammonium transporter', NULL, NULL, NULL, NULL, NULL, 4),
(28120, NULL, 'G3DSA:3.20.20.210:FF:000006', NULL, NULL, 'Uroporphyrinogen decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(28121, NULL, 'G3DSA:3.40.50.880:FF:000118', NULL, NULL, 'GMP synthase [glutamine-hydrolyzing] isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(28122, NULL, 'G3DSA:3.40.50.12780:FF:000134', NULL, NULL, 'ATP-dependent acyl-CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(28123, NULL, 'G3DSA:1.25.40.340:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28124, NULL, 'G3DSA:3.40.50.300:FF:007898', NULL, NULL, 'Putative glutamine amidotransferase-like protein MJ0138', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(28125, NULL, 'G3DSA:3.40.140.10:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28126, NULL, 'G3DSA:1.25.40.10:FF:004743', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g15340, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(28127, NULL, 'G3DSA:3.30.830.10:FF:000245', NULL, NULL, 'Ubiquinol-cytochrome c reductase core protein 2a', NULL, NULL, NULL, NULL, NULL, 4),
(28128, NULL, 'G3DSA:3.40.1090.10:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28129, NULL, 'G3DSA:2.60.120.10:FF:000778', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28130, NULL, 'G3DSA:1.10.287.110:FF:000288', NULL, NULL, 'Co-chaperone, HscB-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(28131, NULL, 'G3DSA:2.20.25.90:FF:000002', NULL, NULL, 'NADH-quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(28132, NULL, 'G3DSA:3.90.70.10:FF:000465', NULL, NULL, 'Cathepsin B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28133, NULL, 'G3DSA:3.90.79.10:FF:000108', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(28134, NULL, 'G3DSA:2.10.110.10:FF:000300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28135, NULL, 'G3DSA:3.30.70.3490:FF:000015', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(28136, NULL, 'G3DSA:1.10.510.10:FF:004095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28137, NULL, 'G3DSA:2.60.120.310:FF:000016', NULL, NULL, 'Dopamine beta hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(28138, NULL, 'G3DSA:3.30.430.20:FF:000026', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(28139, NULL, 'G3DSA:1.20.1110.10:FF:000059', NULL, NULL, 'Plasma membrane ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(28140, NULL, 'G3DSA:1.10.20.10:FF:000088', NULL, NULL, 'Histone H3-like centromeric protein CSE4', NULL, NULL, NULL, NULL, NULL, 4),
(28141, NULL, 'G3DSA:3.40.1440.60:FF:000002', NULL, NULL, 'Primosome assembly protein PriA', NULL, NULL, NULL, NULL, NULL, 4),
(28142, NULL, 'G3DSA:2.20.70.10:FF:000083', NULL, NULL, 'pre-mRNA-processing factor 40 homolog A isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(28143, NULL, 'G3DSA:1.10.8.720:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28144, NULL, 'G3DSA:3.40.50.300:FF:008415', NULL, NULL, 'Midasin AAA ATPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(28145, NULL, 'G3DSA:3.40.50.12650:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28146, NULL, 'G3DSA:1.10.1420.10:FF:000107', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(28147, NULL, 'G3DSA:1.10.472.10:FF:000609', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28148, NULL, 'G3DSA:3.30.160.60:FF:000938', NULL, NULL, 'Zinc finger protein 691', NULL, NULL, NULL, NULL, NULL, 4),
(28149, NULL, 'G3DSA:1.25.40.10:FF:003220', NULL, NULL, 'Protein O-mannosyl-transferase TMTC3', NULL, NULL, NULL, NULL, NULL, 4),
(28150, NULL, 'G3DSA:1.25.40.10:FF:000270', NULL, NULL, 'Outer membrane protein assembly factor BamD', NULL, NULL, NULL, NULL, NULL, 4),
(28151, NULL, 'G3DSA:3.80.10.10:FF:002103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28152, NULL, 'G3DSA:3.60.15.10:FF:000120', NULL, NULL, 'Beta lactamase like protein', NULL, NULL, NULL, NULL, NULL, 4),
(28153, NULL, 'G3DSA:3.30.2160.10:FF:000064', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(28154, NULL, 'G3DSA:3.40.350.10:FF:000032', NULL, NULL, 'Xaa-pro aminopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28155, NULL, 'G3DSA:3.40.50.2300:FF:000291', NULL, NULL, 'Two-component response regulator ORR4', NULL, NULL, NULL, NULL, NULL, 4),
(28156, NULL, 'G3DSA:1.20.5.190:FF:000165', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28157, NULL, 'G3DSA:2.60.120.260:FF:000192', NULL, NULL, 'Cell wall-associated protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(28158, NULL, 'G3DSA:3.40.190.10:FF:000513', NULL, NULL, 'Transferrin', NULL, NULL, NULL, NULL, NULL, 4),
(28159, NULL, 'G3DSA:3.90.1150.10:FF:000403', NULL, NULL, 'Sphingosine phosphate lyase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28160, NULL, 'G3DSA:1.10.10.10:FF:000806', NULL, NULL, 'Unplaced genomic scaffold supercont1.172, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(28161, NULL, 'G3DSA:2.130.10.10:FF:002496', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', NULL, NULL, NULL, NULL, NULL, 4),
(28162, NULL, 'G3DSA:1.25.40.180:FF:000040', NULL, NULL, 'Nuclear cap-binding protein subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(28163, NULL, 'G3DSA:2.40.10.10:FF:000376', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28164, NULL, 'G3DSA:2.10.109.10:FF:000004', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(28165, NULL, 'G3DSA:3.40.30.10:FF:000779', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28166, NULL, 'G3DSA:2.60.40.10:FF:004093', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28167, NULL, 'G3DSA:2.60.40.60:FF:000717', NULL, NULL, 'Cadherin-4', NULL, NULL, NULL, NULL, NULL, 4),
(28168, NULL, 'G3DSA:1.10.238.10:FF:000684', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(28169, NULL, 'G3DSA:1.25.40.10:FF:003928', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28170, NULL, 'G3DSA:3.90.1150.170:FF:000006', NULL, NULL, 'Glutamate decarboxylase 1b', NULL, NULL, NULL, NULL, NULL, 4),
(28171, NULL, 'G3DSA:4.10.320.10:FF:000027', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(28172, NULL, 'G3DSA:1.20.1080.10:FF:000044', NULL, NULL, 'Formate/nitrite transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(28173, NULL, 'G3DSA:2.30.29.30:FF:001246', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(28174, NULL, 'G3DSA:2.60.260.20:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28175, NULL, 'G3DSA:3.30.1360.70:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28176, NULL, 'G3DSA:1.10.10.1320:FF:000010', NULL, NULL, 'Glr1765 protein', NULL, NULL, NULL, NULL, NULL, 4),
(28177, NULL, 'G3DSA:1.20.120.920:FF:000001', NULL, NULL, 'CRISPR-associated endonuclease Cas1', NULL, NULL, NULL, NULL, NULL, 4),
(28178, NULL, 'G3DSA:2.60.120.260:FF:000203', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(28179, NULL, 'G3DSA:3.30.160.60:FF:002855', NULL, NULL, 'Zinc finger protein 705A', NULL, NULL, NULL, NULL, NULL, 4),
(28180, NULL, 'G3DSA:1.10.290.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28181, NULL, 'G3DSA:2.70.70.10:FF:000013', NULL, NULL, 'Peptidase family M23', NULL, NULL, NULL, NULL, NULL, 4),
(28182, NULL, 'G3DSA:3.80.10.10:FF:004020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28183, NULL, 'G3DSA:3.50.50.60:FF:000093', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(28184, NULL, 'G3DSA:1.10.10.2740:FF:000003', NULL, NULL, 'Transcription elongation factor SPT6', NULL, NULL, NULL, NULL, NULL, 4),
(28185, NULL, 'G3DSA:2.20.28.10:FF:000058', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(28186, NULL, 'G3DSA:2.10.110.10:FF:000058', NULL, NULL, 'Rho GTPase activator Lrg11', NULL, NULL, NULL, NULL, NULL, 4),
(28187, NULL, 'G3DSA:2.30.29.30:FF:000144', NULL, NULL, 'Ras GTPase-activating protein 2 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(28188, NULL, 'G3DSA:3.40.640.10:FF:000149', NULL, NULL, 'Histidinol-phosphate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(28189, NULL, 'G3DSA:3.80.10.10:FF:001844', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(28190, NULL, 'G3DSA:1.25.40.10:FF:004322', NULL, NULL, 'MAU2 chromatid cohesion factor homolog', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(28191, NULL, 'G3DSA:3.30.160.60:FF:005031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28192, NULL, 'G3DSA:3.30.160.60:FF:004637', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28193, NULL, 'G3DSA:3.30.200.20:FF:000543', NULL, NULL, 'Putative leucine-rich repeat receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(28194, NULL, 'G3DSA:1.10.579.10:FF:000015', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(28195, NULL, 'G3DSA:3.80.10.10:FF:001939', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(28196, NULL, 'G3DSA:2.60.40.690:FF:000008', NULL, NULL, 'Thioester-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(28197, NULL, 'G3DSA:3.40.50.2300:FF:000302', NULL, NULL, 'Si:ch211-203b20.7', NULL, NULL, NULL, NULL, NULL, 4),
(28198, NULL, 'G3DSA:3.30.230.10:FF:000042', NULL, NULL, 'Translation elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(28199, NULL, 'G3DSA:3.30.530.20:FF:000192', NULL, NULL, 'Phosphatidylinositol transfer protein cytoplasmic 1b', NULL, NULL, NULL, NULL, NULL, 4),
(28200, NULL, 'G3DSA:1.10.510.10:FF:000828', NULL, NULL, 'Serine/threonine-protein kinase CBK1', NULL, NULL, NULL, NULL, NULL, 4),
(28201, NULL, 'G3DSA:4.10.60.10:FF:000117', NULL, NULL, 'CCHC-type zinc finger protein CG3800', NULL, NULL, NULL, NULL, NULL, 4),
(28202, NULL, 'G3DSA:3.30.200.20:FF:000431', NULL, NULL, 'serine/threonine-protein kinase 32C isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(28203, NULL, 'G3DSA:4.10.60.10:FF:000229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28204, NULL, 'G3DSA:3.40.190.10:FF:000608', NULL, NULL, 'Phosphate-binding protein PstS 1', NULL, NULL, NULL, NULL, NULL, 4),
(28205, NULL, 'G3DSA:3.40.50.150:FF:000681', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(28206, NULL, 'G3DSA:3.20.110.10:FF:000035', NULL, NULL, 'Lysosomal alpha-mannosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28207, NULL, 'G3DSA:2.130.10.10:FF:000793', NULL, NULL, 'Chromatin assembly factor 1 subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28208, NULL, 'G3DSA:1.10.1040.30:FF:000005', NULL, NULL, 'Adenosinetriphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(28209, NULL, 'G3DSA:3.40.30.10:FF:001038', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(28210, NULL, 'G3DSA:3.40.50.1000:FF:000783', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28211, NULL, 'G3DSA:3.30.60.20:FF:000133', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(28212, NULL, 'G3DSA:2.60.40.60:FF:000690', NULL, NULL, 'Cdh-4', NULL, NULL, NULL, NULL, NULL, 4),
(28213, NULL, 'G3DSA:3.40.390.10:FF:000253', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28214, NULL, 'G3DSA:3.30.2020.30:FF:000009', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(28215, NULL, 'G3DSA:2.60.40.10:FF:002417', NULL, NULL, 'Protein sidekick homolog', NULL, NULL, NULL, NULL, NULL, 4),
(28216, NULL, 'G3DSA:2.60.120.740:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28217, NULL, 'G3DSA:1.10.760.10:FF:000072', NULL, NULL, 'Diheme cytochrome c SoxE', NULL, NULL, NULL, NULL, NULL, 4),
(28218, NULL, 'G3DSA:3.90.226.10:FF:000316', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28219, NULL, 'G3DSA:3.90.1150.160:FF:000003', NULL, NULL, 'Glutamate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(28220, NULL, 'G3DSA:3.40.50.300:FF:001153', NULL, NULL, 'RecBCD enzyme subunit RecC', NULL, NULL, NULL, NULL, NULL, 4),
(28221, NULL, 'G3DSA:2.10.25.10:FF:001518', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28222, NULL, 'G3DSA:1.10.287.110:FF:000176', NULL, NULL, 'Protein CBR-DNJ-11', NULL, NULL, NULL, NULL, NULL, 4),
(28223, NULL, 'G3DSA:3.40.50.300:FF:006375', NULL, NULL, 'GPN-loop GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(28224, NULL, 'G3DSA:1.20.5.340:FF:000036', NULL, NULL, 'Myosin heavy chain', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(28225, NULL, 'G3DSA:2.60.260.20:FF:000050', NULL, NULL, 'Chaperone protein DNAj, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28226, NULL, 'G3DSA:1.25.10.10:FF:002566', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28227, NULL, 'G3DSA:3.30.420.40:FF:000970', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28228, NULL, 'G3DSA:3.30.160.60:FF:006228', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28229, NULL, 'G3DSA:3.30.160.60:FF:004542', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28230, NULL, 'G3DSA:1.20.1070.10:FF:002112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28231, NULL, 'G3DSA:1.20.120.620:FF:000001', NULL, NULL, 'Two-component sensor histidine kinase KdpD', NULL, NULL, NULL, NULL, NULL, 4),
(28232, NULL, 'G3DSA:2.60.40.10:FF:001220', NULL, NULL, 'PKHD1 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(28233, NULL, 'G3DSA:1.10.150.240:FF:000075', NULL, NULL, 'HAD superfamily hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(28234, NULL, 'G3DSA:2.70.98.50:FF:000004', NULL, NULL, 'Glycoside hydrolase family 95', NULL, NULL, NULL, NULL, NULL, 4),
(28235, NULL, 'G3DSA:3.40.50.720:FF:000312', NULL, NULL, '(+)-neomenthol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(28236, NULL, 'G3DSA:3.30.740.10:FF:000007', NULL, NULL, 'Dynein light chain', NULL, NULL, NULL, NULL, NULL, 4),
(28237, NULL, 'G3DSA:3.30.450.40:FF:000258', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(28238, NULL, 'G3DSA:3.30.420.40:FF:000077', NULL, NULL, 'Glucokinase', NULL, NULL, NULL, NULL, NULL, 4),
(28239, NULL, 'G3DSA:3.40.50.150:FF:000467', NULL, NULL, 'RNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(28240, NULL, 'G3DSA:1.20.5.320:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28241, NULL, 'G3DSA:2.30.30.70:FF:000002', NULL, NULL, '60S ribosomal protein L21', NULL, NULL, NULL, NULL, NULL, 4),
(28242, NULL, 'G3DSA:2.10.25.10:FF:000321', NULL, NULL, 'Protein delta homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(28243, NULL, 'G3DSA:3.40.50.1000:FF:000569', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28244, NULL, 'G3DSA:3.40.50.300:FF:000973', NULL, NULL, 'Multidrug resistance-associated protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(28245, NULL, 'G3DSA:1.25.40.10:FF:004529', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g61870, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(28246, NULL, 'G3DSA:1.25.40.10:FF:002068', NULL, NULL, 'AGAP001968-PB', NULL, NULL, NULL, NULL, NULL, 4),
(28247, NULL, 'G3DSA:3.40.1110.10:FF:000289', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28248, NULL, 'G3DSA:1.10.510.10:FF:002419', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28249, NULL, 'G3DSA:2.70.98.60:FF:000007', NULL, NULL, 'Alpha-galactosidase Mel36A', NULL, NULL, NULL, NULL, NULL, 4),
(28250, NULL, 'G3DSA:1.25.40.10:FF:000691', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(28251, NULL, 'G3DSA:3.30.160.60:FF:000826', NULL, NULL, 'Zinc finger protein 570', NULL, NULL, NULL, NULL, NULL, 4),
(28252, NULL, 'G3DSA:1.10.510.10:FF:001222', NULL, NULL, 'Serine/threonine-protein kinase ppk25', NULL, NULL, NULL, NULL, NULL, 4),
(28253, NULL, 'G3DSA:2.30.42.10:FF:000130', NULL, NULL, 'PDZ and LIM domain 2 (mystique)', NULL, NULL, NULL, NULL, NULL, 4),
(28254, NULL, 'G3DSA:2.130.10.10:FF:002384', NULL, NULL, 'WD repeat protein 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28255, NULL, 'G3DSA:3.30.70.330:FF:000454', NULL, NULL, 'RNA-binding protein 15B', NULL, NULL, NULL, NULL, NULL, 4),
(28256, NULL, 'G3DSA:1.25.40.10:FF:001888', NULL, NULL, 'U3 small nucleolar RNA-associated protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(28257, NULL, 'G3DSA:3.30.420.40:FF:000756', NULL, NULL, 'ARP1 actin related protein 1 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(28258, NULL, 'G3DSA:3.40.366.10:FF:000034', NULL, NULL, 'Polyketide synthase module', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(28259, NULL, 'G3DSA:3.40.50.1000:FF:000362', NULL, NULL, 'Acid phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(28260, NULL, 'G3DSA:1.10.10.10:FF:000918', NULL, NULL, 'OmpR subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(28261, NULL, 'G3DSA:2.60.40.10:FF:001006', NULL, NULL, 'Interleukin 20 receptor subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(28262, NULL, 'G3DSA:4.10.60.10:FF:000022', NULL, NULL, 'Serine/arginine-rich splicing factor RS2Z32', NULL, NULL, NULL, NULL, NULL, 4),
(28263, NULL, 'G3DSA:2.40.10.10:FF:000264', NULL, NULL, 'Trypsin precursor', NULL, NULL, NULL, NULL, NULL, 4),
(28264, NULL, 'G3DSA:2.130.10.10:FF:001895', NULL, NULL, 'Cirhin-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(28265, NULL, 'G3DSA:2.60.40.10:FF:000826', NULL, NULL, 'Melanocyte protein PMEL', NULL, NULL, NULL, NULL, NULL, 4),
(28266, NULL, 'G3DSA:2.40.50.140:FF:000428', NULL, NULL, 'Mitochondrial Ribosomal Protein, Large', NULL, NULL, NULL, NULL, NULL, 4),
(28267, NULL, 'G3DSA:3.30.70.330:FF:002236', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28268, NULL, 'G3DSA:3.30.559.10:FF:000153', NULL, NULL, 'Putative peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(28269, NULL, 'G3DSA:1.20.58.1970:FF:000005', NULL, NULL, 'COG4_transport_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(28270, NULL, 'G3DSA:1.20.1250.20:FF:002213', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(28271, NULL, 'G3DSA:3.30.230.10:FF:000137', NULL, NULL, 'Ria1p', NULL, NULL, NULL, NULL, NULL, 4),
(28272, NULL, 'G3DSA:1.25.40.20:FF:000694', NULL, NULL, 'Ankyrin repeat domain 55', NULL, NULL, NULL, NULL, NULL, 4),
(28273, NULL, 'G3DSA:2.70.98.40:FF:000001', NULL, NULL, 'Family 65 glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(28274, NULL, 'G3DSA:3.40.50.300:FF:000759', NULL, NULL, 'probable ATP-dependent RNA helicase DDX52', NULL, NULL, NULL, NULL, NULL, 4),
(28275, NULL, 'G3DSA:2.130.10.10:FF:004845', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28276, NULL, 'G3DSA:1.20.200.10:FF:000011', NULL, NULL, 'Argininosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(28277, NULL, 'G3DSA:1.10.220.10:FF:000048', NULL, NULL, 'Annexin D5', NULL, NULL, NULL, NULL, NULL, 4),
(28278, NULL, 'G3DSA:3.90.780.10:FF:000047', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(28279, NULL, 'G3DSA:3.10.50.10:FF:000012', NULL, NULL, 'Chitinase 17', NULL, NULL, NULL, NULL, NULL, 4),
(28280, NULL, 'G3DSA:3.40.50.300:FF:006728', NULL, NULL, 'Zgc:158828', NULL, NULL, NULL, NULL, NULL, 4),
(28281, NULL, 'G3DSA:2.20.70.10:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28282, NULL, 'G3DSA:1.25.40.10:FF:004760', NULL, NULL, 'Os10g0477200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(28283, NULL, 'G3DSA:2.170.150.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28284, NULL, 'G3DSA:1.20.1510.10:FF:000022', NULL, NULL, 'Cation transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28285, NULL, 'G3DSA:2.170.150.20:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28286, NULL, 'G3DSA:1.10.287.1490:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28287, NULL, 'G3DSA:3.40.50.2000:FF:000105', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(28288, NULL, 'G3DSA:2.30.22.10:FF:000016', NULL, NULL, 'GrpE protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(28289, NULL, 'G3DSA:3.10.110.10:FF:000105', NULL, NULL, 'ubiquitin-conjugating enzyme E2 H isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(28290, NULL, 'G3DSA:2.60.40.10:FF:000377', NULL, NULL, 'Protein tyrosine kinase 7 (inactive)', NULL, NULL, NULL, NULL, NULL, 4),
(28291, NULL, 'G3DSA:3.30.450.70:FF:000008', NULL, NULL, 'Trafficking protein particle complex 2 like', NULL, NULL, NULL, NULL, NULL, 4),
(28292, NULL, 'G3DSA:6.20.250.70:FF:000001', NULL, NULL, 'DNA-directed RNA polymerase I subunit RPA34', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(28293, NULL, 'G3DSA:1.25.40.10:FF:000477', NULL, NULL, 'gamma-soluble NSF attachment protein', NULL, NULL, NULL, NULL, NULL, 4),
(28294, NULL, 'G3DSA:2.60.120.260:FF:000175', NULL, NULL, 'Sad1 / UNC family protein', NULL, NULL, NULL, NULL, NULL, 4),
(28295, NULL, 'G3DSA:3.80.10.10:FF:001277', NULL, NULL, 'Tubulin-specific chaperone, putative (AFU_orthologue AFUA_4G11870)', NULL, NULL, NULL, NULL, NULL, 4),
(28296, NULL, 'G3DSA:3.30.160.60:FF:004093', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28297, NULL, 'G3DSA:3.30.70.3490:FF:000032', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(28298, NULL, 'G3DSA:3.20.20.360:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28299, NULL, 'G3DSA:3.30.200.20:FF:002229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28300, NULL, 'G3DSA:3.40.50.300:FF:007004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28301, NULL, 'G3DSA:3.30.890.10:FF:000007', NULL, NULL, 'Methyl-CpG-binding domain protein 1b', NULL, NULL, NULL, NULL, NULL, 4),
(28302, NULL, 'G3DSA:2.130.10.10:FF:002058', NULL, NULL, 'WD repeat-containing protein 13 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(28303, NULL, 'G3DSA:3.30.200.20:FF:000329', NULL, NULL, 'PAS domain-containing protein tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(28304, NULL, 'G3DSA:1.20.1560.10:FF:000300', NULL, NULL, 'Putative MRP-like ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(28305, NULL, 'G3DSA:1.25.40.10:FF:002282', NULL, NULL, 'Methyltransferase small domain', NULL, NULL, NULL, NULL, NULL, 4),
(28306, NULL, 'G3DSA:2.60.40.10:FF:005031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28307, NULL, 'G3DSA:1.20.140.40:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28308, NULL, 'G3DSA:2.60.40.10:FF:000731', NULL, NULL, 'Lysosomal beta glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(28309, NULL, 'G3DSA:3.30.40.10:FF:001539', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28310, NULL, 'G3DSA:3.90.550.50:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28311, NULL, 'G3DSA:3.30.70.2970:FF:000005', NULL, NULL, 'Interleukin-1 receptor-associated kinase 1-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(28312, NULL, 'G3DSA:1.10.10.60:FF:000782', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28313, NULL, 'G3DSA:1.20.1070.10:FF:001853', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28314, NULL, 'G3DSA:3.40.50.720:FF:001509', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28315, NULL, 'G3DSA:2.130.10.10:FF:003210', NULL, NULL, 'BnaCnng65990D protein', NULL, NULL, NULL, NULL, NULL, 4),
(28316, NULL, 'G3DSA:3.40.640.10:FF:000251', NULL, NULL, 'Soluble hydrogenase, small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(28317, NULL, 'G3DSA:3.40.50.880:FF:000006', NULL, NULL, 'Carbamoyl-phosphate synthase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(28318, NULL, 'G3DSA:1.25.40.180:FF:000023', NULL, NULL, 'regulator of nonsense transcripts 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(28319, NULL, 'G3DSA:1.25.10.10:FF:002780', NULL, NULL, 'STE family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(28320, NULL, 'G3DSA:3.40.50.720:FF:001268', NULL, NULL, '2-hydroxy-3-oxopropionate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(28321, NULL, 'G3DSA:2.60.200.20:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28322, NULL, 'G3DSA:2.60.260.20:FF:000162', NULL, NULL, 'DnaJ protein homolog xdj1', NULL, NULL, NULL, NULL, NULL, 4),
(28323, NULL, 'G3DSA:1.10.150.20:FF:000270', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(28324, NULL, 'G3DSA:1.10.510.10:FF:002633', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28325, NULL, 'G3DSA:1.10.238.10:FF:000807', NULL, NULL, 'AaceriAER419Wp', NULL, NULL, NULL, NULL, NULL, 4),
(28326, NULL, 'G3DSA:1.10.287.1260:FF:000010', NULL, NULL, 'Mechanosensitive ion channel domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(28327, NULL, 'G3DSA:1.25.40.10:FF:002731', NULL, NULL, 'Gamma SNAP', NULL, NULL, NULL, NULL, NULL, 4),
(28328, NULL, 'G3DSA:2.40.50.120:FF:000001', NULL, NULL, 'Netrin 1', NULL, NULL, NULL, NULL, NULL, 4),
(28329, NULL, 'G3DSA:3.40.50.300:FF:004363', NULL, NULL, 'Bacitracin ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(28330, NULL, 'G3DSA:3.30.70.20:FF:000061', NULL, NULL, 'CoB--CoM heterodisulfide reductase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(28331, NULL, 'G3DSA:2.40.50.140:FF:000007', NULL, NULL, '40S ribosomal protein S23', NULL, NULL, NULL, NULL, NULL, 4),
(28332, NULL, 'G3DSA:2.60.40.150:FF:000279', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(28333, NULL, 'G3DSA:1.20.1070.10:FF:000100', NULL, NULL, 'alpha-2B adrenergic receptor', NULL, NULL, NULL, NULL, NULL, 4),
(28334, NULL, 'G3DSA:2.60.40.60:FF:000476', NULL, NULL, 'cadherin-89D', NULL, NULL, NULL, NULL, NULL, 4),
(28335, NULL, 'G3DSA:3.90.640.10:FF:000121', NULL, NULL, 'Actin-like ATPase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(28336, NULL, 'G3DSA:2.60.40.10:FF:004755', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28337, NULL, 'G3DSA:2.170.260.40:FF:000006', NULL, NULL, '5''-3'' exoribonuclease A', NULL, NULL, NULL, NULL, NULL, 4),
(28338, NULL, 'G3DSA:2.40.70.10:FF:000273', NULL, NULL, 'GD19154', NULL, NULL, NULL, NULL, NULL, 4),
(28339, NULL, 'G3DSA:3.30.1360.10:FF:000045', NULL, NULL, 'RNA polymerase I, and III, AC40 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(28340, NULL, 'G3DSA:1.25.40.10:FF:000718', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(28341, NULL, 'G3DSA:3.40.190.290:FF:000095', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(28342, NULL, 'G3DSA:3.10.20.30:FF:000067', NULL, NULL, 'Terephthalate 1,2-dioxygenase, reductase component 2', NULL, NULL, NULL, NULL, NULL, 4),
(28343, NULL, 'G3DSA:1.20.1250.20:FF:002090', NULL, NULL, 'RE57622p', NULL, NULL, NULL, NULL, NULL, 4),
(28344, NULL, 'G3DSA:1.10.472.10:FF:000161', NULL, NULL, 'CTD kinase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(28345, NULL, 'G3DSA:2.40.330.10:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28346, NULL, 'G3DSA:2.70.150.10:FF:000126', NULL, NULL, 'ATPase phospholipid transporting 8A1', NULL, NULL, NULL, NULL, NULL, 4),
(28347, NULL, 'G3DSA:1.10.8.500:FF:000007', NULL, NULL, 'PAS domain-containing sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(28348, NULL, 'G3DSA:1.10.533.10:FF:000174', NULL, NULL, 'Caspase 9', NULL, NULL, NULL, NULL, NULL, 4),
(28349, NULL, 'G3DSA:3.10.100.10:FF:000357', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28350, NULL, 'G3DSA:2.60.40.4310:FF:000002', NULL, NULL, 'Togavirin', NULL, NULL, NULL, NULL, NULL, 4),
(28351, NULL, 'G3DSA:3.90.1600.10:FF:000039', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(28352, NULL, 'G3DSA:1.10.510.10:FF:001110', NULL, NULL, 'AGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(28353, NULL, 'G3DSA:2.40.30.10:FF:000276', NULL, NULL, 'HSP70 subfamily B suppressor 1', NULL, NULL, NULL, NULL, NULL, 4),
(28354, NULL, 'G3DSA:3.30.720.10:FF:000012', NULL, NULL, 'Unplaced genomic scaffold supercont2.12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(28355, NULL, 'G3DSA:2.130.10.10:FF:001310', NULL, NULL, 'kinesin-like protein KIF21A isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(28356, NULL, 'G3DSA:3.40.50.1100:FF:000274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28357, NULL, 'G3DSA:2.60.40.10:FF:002855', NULL, NULL, 'Glycoprotein E', NULL, NULL, NULL, NULL, NULL, 4),
(28358, NULL, 'G3DSA:3.50.50.60:FF:000660', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28359, NULL, 'G3DSA:3.10.129.10:FF:000114', NULL, NULL, 'Acyl-CoA thioester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(28360, NULL, 'G3DSA:3.90.550.10:FF:000682', NULL, NULL, 'Galactosylgalactosylxylosylprotein 3-beta-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(28361, NULL, 'G3DSA:1.10.246.10:FF:000006', NULL, NULL, 'Extracellular matrix protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(28362, NULL, 'G3DSA:2.10.25.10:FF:001277', NULL, NULL, 'Notch 3', NULL, NULL, NULL, NULL, NULL, 4),
(28363, NULL, 'G3DSA:1.10.510.10:FF:000379', NULL, NULL, 'serine/threonine-protein kinase greatwall isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(28364, NULL, 'G3DSA:1.20.1310.10:FF:000136', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28365, NULL, 'G3DSA:3.40.50.1440:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28366, NULL, 'G3DSA:3.30.70.330:FF:001539', NULL, NULL, 'RNA binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28367, NULL, 'G3DSA:3.40.850.10:FF:000300', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(28368, NULL, 'G3DSA:3.30.70.60:FF:000044', NULL, NULL, 'Os12g0563200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(28369, NULL, 'G3DSA:3.40.50.300:FF:000647', NULL, NULL, 'Methylmalonic aciduria type A homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(28370, NULL, 'G3DSA:3.40.630.10:FF:000323', NULL, NULL, 'AGAP008372-PA', NULL, NULL, NULL, NULL, NULL, 4),
(28371, NULL, 'G3DSA:1.10.510.10:FF:002392', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28372, NULL, 'G3DSA:1.10.3430.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28373, NULL, 'G3DSA:1.20.58.70:FF:000035', NULL, NULL, 'Syntaxin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(28374, NULL, 'G3DSA:2.60.40.820:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28375, NULL, 'G3DSA:1.10.150.80:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28376, NULL, 'G3DSA:3.40.47.10:FF:000059', NULL, NULL, 'Beta-ketoacyl-acyl-carrier-protein synthase II', NULL, NULL, NULL, NULL, NULL, 4),
(28377, NULL, 'G3DSA:2.60.40.150:FF:000296', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(28378, NULL, 'G3DSA:3.30.70.580:FF:000057', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(28379, NULL, 'G3DSA:3.40.50.2000:FF:000077', NULL, NULL, 'Sucrose-phosphate synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(28380, NULL, 'G3DSA:1.10.400.10:FF:000051', NULL, NULL, 'ADP ribosylation factor', NULL, NULL, NULL, NULL, NULL, 4),
(28381, NULL, 'G3DSA:1.10.10.60:FF:000456', NULL, NULL, 'ISVch4 transposase, OrfA', NULL, NULL, NULL, NULL, NULL, 4),
(28382, NULL, 'G3DSA:2.60.120.10:FF:000795', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28383, NULL, 'G3DSA:2.40.10.170:FF:000008', NULL, NULL, 'Transcriptional regulator, CarD', NULL, NULL, NULL, NULL, NULL, 4),
(28384, NULL, 'G3DSA:2.30.30.40:FF:000459', NULL, NULL, 'SH3 and SYLF domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(28385, NULL, 'G3DSA:1.10.510.10:FF:004218', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28386, NULL, 'G3DSA:3.60.40.10:FF:000200', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(28387, NULL, 'G3DSA:2.40.50.90:FF:000014', NULL, NULL, 'tudor domain-containing protein 7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(28388, NULL, 'G3DSA:3.10.20.90:FF:000169', NULL, NULL, 'Sequestosome 1', NULL, NULL, NULL, NULL, NULL, 4),
(28389, NULL, 'G3DSA:3.80.10.10:FF:003738', NULL, NULL, 'AGAP000340-PA', NULL, NULL, NULL, NULL, NULL, 4),
(28390, NULL, 'G3DSA:1.10.8.1290:FF:000001', NULL, NULL, 'Glutamine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(28391, NULL, 'G3DSA:3.30.160.60:FF:002625', NULL, NULL, 'zinc finger protein 75A-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(28392, NULL, 'G3DSA:2.130.10.10:FF:004519', NULL, NULL, 'Dmx like 1', NULL, NULL, NULL, NULL, NULL, 4),
(28393, NULL, 'G3DSA:2.60.40.1730:FF:000099', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28394, NULL, 'G3DSA:2.130.10.10:FF:004183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28395, NULL, 'G3DSA:3.30.1540.20:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(28396, NULL, 'G3DSA:1.25.10.10:FF:000649', NULL, NULL, 'CLIP-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(28397, NULL, 'G3DSA:1.20.90.10:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28398, NULL, 'G3DSA:1.25.10.10:FF:002903', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28399, NULL, 'G3DSA:3.30.497.10:FF:000071', NULL, NULL, 'Protein CBG00799', NULL, NULL, NULL, NULL, NULL, 4),
(28400, NULL, 'G3DSA:1.25.40.20:FF:000817', NULL, NULL, 'ankyrin repeat-containing protein ITN1-like', NULL, NULL, NULL, NULL, NULL, 4),
(28401, NULL, 'G3DSA:3.80.10.10:FF:000321', NULL, NULL, 'T-complex-associated testis-expressed protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(28402, NULL, 'G3DSA:3.50.50.60:FF:000334', NULL, NULL, 'Ferredoxin reductase', NULL, NULL, NULL, NULL, NULL, 4),
(28403, NULL, 'G3DSA:1.10.533.10:FF:000191', NULL, NULL, 'V-FLIP', NULL, NULL, NULL, NULL, NULL, 4),
(28404, NULL, 'G3DSA:2.40.30.10:FF:000259', NULL, NULL, 'Protein Translation Initiation Factor 2 (IF-2)', NULL, NULL, NULL, NULL, NULL, 4),
(28405, NULL, 'G3DSA:3.30.40.10:FF:000230', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(28406, NULL, 'G3DSA:1.10.418.10:FF:000226', NULL, NULL, 'p-loop nucleoside triphosphate hydrolase superfamily protein with CH (Calponin Homology) domain', NULL, NULL, NULL, NULL, NULL, 4),
(28407, NULL, 'G3DSA:3.30.70.330:FF:000437', NULL, NULL, 'Polyadenylate-binding protein RBP45C', NULL, NULL, NULL, NULL, NULL, 4),
(28408, NULL, 'G3DSA:3.40.390.10:FF:000141', NULL, NULL, 'Zinc metalloproteinase nas-24', NULL, NULL, NULL, NULL, NULL, 4),
(28409, NULL, 'G3DSA:1.10.472.10:FF:000368', NULL, NULL, 'Cyclin N-terminal domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(28410, NULL, 'G3DSA:3.40.50.2000:FF:000431', NULL, NULL, 'UDP-glycosyltransferase 90A1', NULL, NULL, NULL, NULL, NULL, 4),
(28411, NULL, 'G3DSA:3.30.160.60:FF:002838', NULL, NULL, 'Probable E3 ubiquitin-protein ligase TRIM8', NULL, NULL, NULL, NULL, NULL, 4),
(28412, NULL, 'G3DSA:3.30.230.70:FF:000032', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(28413, NULL, 'G3DSA:2.160.20.10:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28414, NULL, 'G3DSA:2.60.34.10:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28415, NULL, 'G3DSA:1.20.5.190:FF:000182', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28416, NULL, 'G3DSA:1.20.1250.20:FF:001275', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28417, NULL, 'G3DSA:3.40.50.300:FF:004930', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(28418, NULL, 'G3DSA:1.20.1070.10:FF:001286', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(28419, NULL, 'G3DSA:2.60.40.10:FF:002529', NULL, NULL, 'Unc-40 protein', NULL, NULL, NULL, NULL, NULL, 4),
(28420, NULL, 'G3DSA:3.40.630.10:FF:000194', NULL, NULL, 'Probable M18 family aminopeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(28421, NULL, 'G3DSA:3.40.1090.10:FF:000117', NULL, NULL, 'Lysophospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(28422, NULL, 'G3DSA:1.20.58.60:FF:000032', NULL, NULL, 'Kalirin RhoGEF kinase b', NULL, NULL, NULL, NULL, NULL, 4),
(28423, NULL, 'G3DSA:2.130.10.10:FF:004396', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28424, NULL, 'G3DSA:2.60.40.1910:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28425, NULL, 'G3DSA:3.40.50.300:FF:006824', NULL, NULL, 'Elongation factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(28426, NULL, 'G3DSA:2.60.40.2030:FF:000060', NULL, NULL, 'Adhesion G-protein coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(28427, NULL, 'G3DSA:2.70.170.10:FF:000009', NULL, NULL, 'Neuronal acetylcholine receptor subunit alpha-7', NULL, NULL, NULL, NULL, NULL, 4),
(28428, NULL, 'G3DSA:3.90.550.10:FF:000356', NULL, NULL, 'Glycosyl transferase family 2', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(28429, NULL, 'G3DSA:3.30.565.10:FF:000454', NULL, NULL, 'Ethylene receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(28430, NULL, 'G3DSA:3.30.428.10:FF:000080', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(28431, NULL, 'G3DSA:1.10.220.10:FF:000065', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(28432, NULL, 'G3DSA:1.10.10.160:FF:000010', NULL, NULL, 'ATP-dependent DNA helicase Rep', NULL, NULL, NULL, NULL, NULL, 4),
(28433, NULL, 'G3DSA:1.25.40.770:FF:000003', NULL, NULL, 'Transcription initiation factor TFIID complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(28434, NULL, 'G3DSA:1.10.530.10:FF:000049', NULL, NULL, 'At1g16290', NULL, NULL, NULL, NULL, NULL, 4),
(28435, NULL, 'G3DSA:2.130.10.10:FF:000467', NULL, NULL, 'WD repeat domain 18', NULL, NULL, NULL, NULL, NULL, 4),
(28436, NULL, 'G3DSA:3.30.450.30:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28437, NULL, 'G3DSA:2.90.10.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28438, NULL, 'G3DSA:3.40.50.150:FF:000804', NULL, NULL, 'Putative methyltransferase NSUN7', NULL, NULL, NULL, NULL, NULL, 4),
(28439, NULL, 'G3DSA:1.10.10.10:FF:000683', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(28440, NULL, 'G3DSA:3.30.420.40:FF:000532', NULL, NULL, 'Hsp70 protein/TPR repeat/Tetratricopeptide repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28441, NULL, 'G3DSA:2.60.120.200:FF:000213', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(28442, NULL, 'G3DSA:1.10.287.1970:FF:000009', NULL, NULL, 'Alanine aminotransferase5', NULL, NULL, NULL, NULL, NULL, 4),
(28443, NULL, 'G3DSA:3.40.50.720:FF:002324', NULL, NULL, 'NADPH-dependent pterin aldehyde reductase', NULL, NULL, NULL, NULL, NULL, 4),
(28444, NULL, 'G3DSA:1.25.10.10:FF:000442', NULL, NULL, 'Coatomer beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(28445, NULL, 'G3DSA:2.130.10.10:FF:002619', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(28446, NULL, 'G3DSA:2.10.110.10:FF:000075', NULL, NULL, 'Actin-binding lim protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(28447, NULL, 'G3DSA:1.25.40.10:FF:004305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28448, NULL, 'G3DSA:3.30.160.60:FF:003114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28449, NULL, 'G3DSA:3.80.10.10:FF:003177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28450, NULL, 'G3DSA:3.90.550.50:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28451, NULL, 'G3DSA:3.40.50.300:FF:002676', NULL, NULL, 'ATP-dependent DEAH-box RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28452, NULL, 'G3DSA:3.30.60.20:FF:000116', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(28453, NULL, 'G3DSA:3.60.15.10:FF:000232', NULL, NULL, 'Arylsulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(28454, NULL, 'G3DSA:3.50.50.60:FF:000121', NULL, NULL, 'Pyridine nucleotide-disulfide oxidoreductase YkgC', NULL, NULL, NULL, NULL, NULL, 4),
(28455, NULL, 'G3DSA:3.30.900.20:FF:000001', NULL, NULL, 'MAD2L1 binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(28456, NULL, 'G3DSA:1.25.40.10:FF:002405', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(28457, NULL, 'G3DSA:3.90.70.10:FF:000791', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28458, NULL, 'G3DSA:3.60.10.10:FF:000131', NULL, NULL, 'RGD1565316 protein', NULL, NULL, NULL, NULL, NULL, 4),
(28459, NULL, 'G3DSA:1.10.10.10:FF:000470', NULL, NULL, 'Response regulator receiver domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(28460, NULL, 'G3DSA:3.40.1350.80:FF:000001', NULL, NULL, 'Type-2 restriction enzyme AplI', NULL, NULL, NULL, NULL, NULL, 4),
(28461, NULL, 'G3DSA:3.40.50.720:FF:001835', NULL, NULL, 'Methylenetetrahydrofolate dehydrogenase (NADP+-dependent) 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(28462, NULL, 'G3DSA:1.25.40.90:FF:000006', NULL, NULL, 'Clathrin interactor 1', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(28463, NULL, 'G3DSA:1.10.8.270:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28464, NULL, 'G3DSA:2.40.50.690:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28465, NULL, 'G3DSA:3.30.70.100:FF:000178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28466, NULL, 'G3DSA:3.20.20.70:FF:000769', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28467, NULL, 'G3DSA:3.30.200.20:FF:002555', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28468, NULL, 'G3DSA:3.30.200.20:FF:000094', NULL, NULL, 'Serine/threonine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(28469, NULL, 'G3DSA:2.60.40.10:FF:004429', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28470, NULL, 'G3DSA:3.40.50.720:FF:002111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28471, NULL, 'G3DSA:3.40.50.300:FF:008292', NULL, NULL, 'GTP-binding protein-related', NULL, NULL, NULL, NULL, NULL, 4),
(28472, NULL, 'G3DSA:3.30.870.10:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28473, NULL, 'G3DSA:3.90.1420.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28474, NULL, 'G3DSA:3.80.10.10:FF:001389', NULL, NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g63430', NULL, NULL, NULL, NULL, NULL, 4),
(28475, NULL, 'G3DSA:3.40.1280.10:FF:000031', NULL, NULL, 'RNA methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28476, NULL, 'G3DSA:2.60.120.260:FF:000641', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28477, NULL, 'G3DSA:1.20.1250.20:FF:001937', NULL, NULL, 'Solute carrier family 43 member 3a', NULL, NULL, NULL, NULL, NULL, 4),
(28478, NULL, 'G3DSA:3.30.160.60:FF:002951', NULL, NULL, 'Sal-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(28479, NULL, 'G3DSA:3.80.10.10:FF:002007', NULL, NULL, 'Toll-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(28480, NULL, 'G3DSA:3.30.360.10:FF:000046', NULL, NULL, 'Glucose-6-phosphate 1-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(28481, NULL, 'G3DSA:2.130.10.10:FF:005121', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(28482, NULL, 'G3DSA:2.60.40.4060:FF:000005', NULL, NULL, 'GD10853', NULL, NULL, NULL, NULL, NULL, 4),
(28483, NULL, 'G3DSA:3.40.50.300:FF:008174', NULL, NULL, 'HBS1-like translational GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(28484, NULL, 'G3DSA:1.10.1900.10:FF:000009', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(28485, NULL, 'G3DSA:3.40.50.720:FF:000183', NULL, NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(28486, NULL, 'G3DSA:3.40.30.10:FF:000881', NULL, NULL, 'Dolichyl-diphosphooligosaccharide--protein glycosyltransferase subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(28487, NULL, 'G3DSA:3.30.1380.20:FF:000044', NULL, NULL, 'Sigma-54-dependent Fis family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(28488, NULL, 'G3DSA:1.10.238.10:FF:000246', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(28489, NULL, 'G3DSA:2.30.30.30:FF:000018', NULL, NULL, 'Transcription elongation factor SPT5', NULL, NULL, NULL, NULL, NULL, 4),
(28490, NULL, 'G3DSA:3.20.20.150:FF:000044', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(28491, NULL, 'G3DSA:2.10.220.10:FF:000179', NULL, NULL, 'AGAP002915-PA', NULL, NULL, NULL, NULL, NULL, 4),
(28492, NULL, 'G3DSA:1.25.40.990:FF:000069', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(28493, NULL, 'G3DSA:1.25.40.20:FF:000609', NULL, NULL, 'Calmodulin-binding transcription activator 4', NULL, NULL, NULL, NULL, NULL, 4),
(28494, NULL, 'G3DSA:1.10.287.2250:FF:000009', NULL, NULL, 'Cysteine peptidase A (CPA)', NULL, NULL, NULL, NULL, NULL, 4),
(28495, NULL, 'G3DSA:2.130.10.10:FF:000916', NULL, NULL, 'VIP3', NULL, NULL, NULL, NULL, NULL, 4),
(28496, NULL, 'G3DSA:3.30.200.20:FF:002117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(28497, NULL, 'G3DSA:2.60.40.150:FF:000745', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28498, NULL, 'G3DSA:1.20.1250.20:FF:000414', NULL, NULL, 'Folate transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(28499, NULL, 'G3DSA:3.10.180.10:FF:000025', NULL, NULL, '4-hydroxyphenylpyruvate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(28500, NULL, 'G3DSA:3.40.50.2300:FF:000740', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(28501, NULL, 'G3DSA:3.30.160.60:FF:006099', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28502, NULL, 'G3DSA:3.30.50.10:FF:000056', NULL, NULL, 'Peroxisome proliferator-activated receptor gamma', NULL, NULL, NULL, NULL, NULL, 4),
(28503, NULL, 'G3DSA:1.20.1250.20:FF:000313', NULL, NULL, 'MFS quinate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(28504, NULL, 'G3DSA:3.60.21.10:FF:000078', NULL, NULL, 'Vacuolar protein sorting-associated protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(28505, NULL, 'G3DSA:3.40.50.300:FF:004475', NULL, NULL, 'ATP-dependent DNA helicase RRM3', NULL, NULL, NULL, NULL, NULL, 4),
(28506, NULL, 'G3DSA:3.90.110.10:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28507, NULL, 'G3DSA:3.40.50.300:FF:006616', NULL, NULL, 'Polymerase (DNA directed), theta', NULL, NULL, NULL, NULL, NULL, 4),
(28508, NULL, 'G3DSA:3.30.300.30:FF:000031', NULL, NULL, 'Acyl-CoA synthetase family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(28509, NULL, 'G3DSA:3.40.50.1820:FF:001658', NULL, NULL, 'Serine carboxypeptidase-like 19', NULL, NULL, NULL, NULL, NULL, 4),
(28510, NULL, 'G3DSA:2.50.20.10:FF:000016', NULL, NULL, 'Outer-membrane lipoprotein carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(28511, NULL, 'G3DSA:3.50.50.60:FF:000008', NULL, NULL, 'Soluble pyridine nucleotide transhydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(28512, NULL, 'G3DSA:1.20.1070.10:FF:001741', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28513, NULL, 'G3DSA:3.70.10.10:FF:000075', NULL, NULL, 'Cell cycle checkpoint control protein', NULL, NULL, NULL, NULL, NULL, 4),
(28514, NULL, 'G3DSA:1.20.1250.20:FF:001842', NULL, NULL, 'Monocarboxylate transporter 1 homologue', NULL, NULL, NULL, NULL, NULL, 4),
(28515, NULL, 'G3DSA:1.10.1410.10:FF:000039', NULL, NULL, 'RNA polymerase II, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28516, NULL, 'G3DSA:3.30.60.60:FF:000004', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(28517, NULL, 'G3DSA:2.70.50.50:FF:000001', NULL, NULL, 'Chitin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(28518, NULL, 'G3DSA:2.120.10.30:FF:000114', NULL, NULL, 'Low-density lipoprotein receptor-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(28519, NULL, 'G3DSA:3.20.20.300:FF:000016', NULL, NULL, 'Exported beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(28520, NULL, 'G3DSA:3.30.70.1230:FF:000259', NULL, NULL, 'Putative regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(28521, NULL, 'G3DSA:3.20.20.80:FF:000401', NULL, NULL, 'Acidic endochitinase', NULL, NULL, NULL, NULL, NULL, 4),
(28522, NULL, 'G3DSA:3.30.70.330:FF:002253', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28523, NULL, 'G3DSA:3.30.160.60:FF:004654', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28524, NULL, 'G3DSA:1.25.10.10:FF:002336', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28525, NULL, 'G3DSA:3.40.50.300:FF:001136', NULL, NULL, 'Putative ADP-ribosylation factor family protein', NULL, NULL, NULL, NULL, NULL, 4),
(28526, NULL, 'G3DSA:2.60.40.60:FF:000594', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(28527, NULL, 'G3DSA:2.40.30.270:FF:000019', NULL, NULL, 'Putative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(28528, NULL, 'G3DSA:3.90.660.10:FF:000004', NULL, NULL, 'spermine oxidase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(28529, NULL, 'G3DSA:3.30.565.10:FF:000336', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(28530, NULL, 'G3DSA:3.10.10.10:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(28531, NULL, 'G3DSA:1.10.3130.10:FF:000006', NULL, NULL, 'Serine O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(28532, NULL, 'G3DSA:2.60.40.10:FF:000938', NULL, NULL, 'Terribly reduced optic lobes, isoform AH', NULL, NULL, NULL, NULL, NULL, 4),
(28533, NULL, 'G3DSA:1.20.5.190:FF:000069', NULL, NULL, 'Blast:Protein abnormal spindle', NULL, NULL, NULL, NULL, NULL, 4),
(28534, NULL, 'G3DSA:3.40.50.720:FF:000200', NULL, NULL, 'Aspartate-semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(28535, NULL, 'G3DSA:2.60.40.10:FF:002294', NULL, NULL, 'Immunoglobulin-like and fibronectin type III domain-containing 1, tandem duplicate 3', NULL, NULL, NULL, NULL, NULL, 4),
(28536, NULL, 'G3DSA:2.30.30.30:FF:000131', NULL, NULL, '60S ribosomal protein L2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(28537, NULL, 'G3DSA:1.10.10.60:FF:000905', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28538, NULL, 'G3DSA:2.30.42.10:FF:000242', NULL, NULL, 'LIM domain kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(28539, NULL, 'G3DSA:3.90.660.20:FF:000007', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(28540, NULL, 'G3DSA:2.60.120.200:FF:000101', NULL, NULL, 'basement membrane-specific heparan sulfate proteoglycan core protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(28541, NULL, 'G3DSA:1.25.40.10:FF:004193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28542, NULL, 'G3DSA:1.10.510.10:FF:000166', NULL, NULL, 'SNF-related serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(28543, NULL, 'G3DSA:1.20.144.10:FF:000071', NULL, NULL, 'GM22449', NULL, NULL, NULL, NULL, NULL, 4),
(28544, NULL, 'G3DSA:2.60.40.380:FF:000005', NULL, NULL, 'Purple acid phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(28545, NULL, 'G3DSA:2.60.40.1510:FF:000033', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(28546, NULL, 'G3DSA:1.25.40.20:FF:001323', NULL, NULL, 'VMS1 homolog C1827.04', NULL, NULL, NULL, NULL, NULL, 4),
(28547, NULL, 'G3DSA:2.120.10.30:FF:000209', NULL, NULL, 'LDL receptor protein 1, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(28548, NULL, 'G3DSA:3.30.200.20:FF:001499', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28549, NULL, 'G3DSA:1.10.10.60:FF:000810', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28550, NULL, 'G3DSA:3.10.129.10:FF:000018', NULL, NULL, 'ComA operon protein', NULL, NULL, NULL, NULL, NULL, 4),
(28551, NULL, 'G3DSA:3.30.420.40:FF:000526', NULL, NULL, 'Heat shock protein 70, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28552, NULL, 'G3DSA:3.40.50.150:FF:000916', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28553, NULL, 'G3DSA:1.50.10.20:FF:000010', NULL, NULL, 'Complement C4-A', NULL, NULL, NULL, NULL, NULL, 4),
(28554, NULL, 'G3DSA:3.40.30.10:FF:001055', NULL, NULL, 'Thyroxine 5''-deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(28555, NULL, 'G3DSA:2.60.40.4070:FF:000008', NULL, NULL, 'Basal-body rod modification protein FlgD', NULL, NULL, NULL, NULL, NULL, 4),
(28556, NULL, 'G3DSA:2.130.10.10:FF:000821', NULL, NULL, 'Chromatin assembly factor 1 protein WD40 domain,putative', NULL, NULL, NULL, NULL, NULL, 4),
(28557, NULL, 'G3DSA:3.40.50.980:FF:000036', NULL, NULL, 'Nonribosomal peptide synthase, putative (JCVI)', NULL, NULL, NULL, NULL, NULL, 4),
(28558, NULL, 'G3DSA:3.40.50.1820:FF:000135', NULL, NULL, 'Esterase lipC', NULL, NULL, NULL, NULL, NULL, 4),
(28559, NULL, 'G3DSA:3.40.190.10:FF:000058', NULL, NULL, 'Thiosulfate ABC transporter, substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(28560, NULL, 'G3DSA:1.20.58.390:FF:000247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28561, NULL, 'G3DSA:2.60.120.200:FF:000090', NULL, NULL, 'Crumbs cell polarity complex component 1', NULL, NULL, NULL, NULL, NULL, 4),
(28562, NULL, 'G3DSA:3.40.50.300:FF:005998', NULL, NULL, 'uncharacterized protein LOC100176493', NULL, NULL, NULL, NULL, NULL, 4),
(28563, NULL, 'G3DSA:2.60.34.10:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(28564, NULL, 'G3DSA:3.90.1150.10:FF:000307', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28565, NULL, 'G3DSA:3.40.50.970:FF:000033', NULL, NULL, 'Transketolase isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(28566, NULL, 'G3DSA:1.10.472.10:FF:000374', NULL, NULL, 'Cyclin-D5-1', NULL, NULL, NULL, NULL, NULL, 4),
(28567, NULL, 'G3DSA:4.10.400.10:FF:000197', NULL, NULL, 'Sortilin-related receptor', NULL, NULL, NULL, NULL, NULL, 4),
(28568, NULL, 'G3DSA:3.40.50.1820:FF:001563', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28569, NULL, 'G3DSA:3.90.226.10:FF:000204', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(28570, NULL, 'G3DSA:3.30.40.10:FF:001871', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28571, NULL, 'G3DSA:3.40.190.10:FF:000401', NULL, NULL, 'GLutamate Receptor family (AMPA)', NULL, NULL, NULL, NULL, NULL, 4),
(28572, NULL, 'G3DSA:3.10.110.10:FF:000077', NULL, NULL, 'Ubiquitin conjugating enzyme E2', NULL, NULL, NULL, NULL, NULL, 4),
(28573, NULL, 'G3DSA:3.40.50.80:FF:000060', NULL, NULL, 'Cupric reductase', NULL, NULL, NULL, NULL, NULL, 4),
(28574, NULL, 'G3DSA:3.30.40.10:FF:001983', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28575, NULL, 'G3DSA:2.60.40.60:FF:000605', NULL, NULL, 'Fat-like cadherin-related tumor suppressor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(28576, NULL, 'G3DSA:3.90.1150.10:FF:000515', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28577, NULL, 'G3DSA:4.10.1110.10:FF:000008', NULL, NULL, 'YOR052C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(28578, NULL, 'G3DSA:1.10.150.80:FF:000046', NULL, NULL, 'ATP-dependent DNA helicase hus2/rqh1', NULL, NULL, NULL, NULL, NULL, 4),
(28579, NULL, 'G3DSA:3.40.30.10:FF:000549', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28580, NULL, 'G3DSA:1.25.40.20:FF:000823', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(28581, NULL, 'G3DSA:2.60.40.10:FF:001091', NULL, NULL, 'Pre T-cell antigen receptor alpha', NULL, NULL, NULL, NULL, NULL, 4),
(28582, NULL, 'G3DSA:1.10.238.10:FF:000572', NULL, NULL, 'RAB11 family interacting protein 3 (class II)', NULL, NULL, NULL, NULL, NULL, 4),
(28583, NULL, 'G3DSA:3.80.10.10:FF:003744', NULL, NULL, 'ELRR (Extracellular Leucine-Rich Repeat) ONly', NULL, NULL, NULL, NULL, NULL, 4),
(28584, NULL, 'G3DSA:3.40.140.10:FF:000235', NULL, NULL, 'tRNA-specific adenosine deaminase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28585, NULL, 'G3DSA:1.20.5.1500:FF:000011', NULL, NULL, 'TSPY like 1', NULL, NULL, NULL, NULL, NULL, 4),
(28586, NULL, 'G3DSA:2.60.40.420:FF:000040', NULL, NULL, 'Azurin', NULL, NULL, NULL, NULL, NULL, 4),
(28587, NULL, 'G3DSA:3.30.70.870:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28588, NULL, 'G3DSA:3.80.10.10:FF:001732', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(28589, NULL, 'G3DSA:3.80.10.10:FF:002215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28590, NULL, 'G3DSA:3.30.750.24:FF:000055', NULL, NULL, 'Anti-sigma B factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(28591, NULL, 'G3DSA:3.30.420.40:FF:001032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28592, NULL, 'G3DSA:3.10.100.10:FF:000149', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28593, NULL, 'G3DSA:1.20.1070.10:FF:001409', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28594, NULL, 'G3DSA:3.40.50.10810:FF:000252', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(28595, NULL, 'G3DSA:3.30.500.10:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28596, NULL, 'G3DSA:2.130.10.10:FF:002266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28597, NULL, 'G3DSA:3.30.160.60:FF:001220', NULL, NULL, 'ZFP28 zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(28598, NULL, 'G3DSA:3.30.160.60:FF:004749', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(28599, NULL, 'G3DSA:3.40.50.2300:FF:000532', NULL, NULL, 'PTS system fructose-specific IIBC component', NULL, NULL, NULL, NULL, NULL, 4),
(28600, NULL, 'G3DSA:3.10.450.50:FF:000013', NULL, NULL, 'mRNA export factor mex67', NULL, NULL, NULL, NULL, NULL, 4),
(28601, NULL, 'G3DSA:3.40.50.150:FF:000563', NULL, NULL, 'Ribosomal RNA methyltransferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(28602, NULL, 'G3DSA:3.40.50.2300:FF:000420', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(28603, NULL, 'G3DSA:2.30.42.10:FF:000343', NULL, NULL, 'GD20482', NULL, NULL, NULL, NULL, NULL, 4),
(28604, NULL, 'G3DSA:3.40.50.150:FF:001170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28605, NULL, 'G3DSA:3.10.450.40:FF:000010', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(28606, NULL, 'G3DSA:1.10.150.630:FF:000001', NULL, NULL, 'Type III secretion protein', NULL, NULL, NULL, NULL, NULL, 4),
(28607, NULL, 'G3DSA:2.130.10.10:FF:000708', NULL, NULL, 'U3 small nucleolar RNA-associated protein 15 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(28608, NULL, 'G3DSA:3.40.50.1980:FF:000054', NULL, NULL, 'Nitrogenase molybdenum-iron protein beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(28609, NULL, 'G3DSA:3.40.50.300:FF:002446', NULL, NULL, 'Katanin p60 ATPase-containing subunit A1', NULL, NULL, NULL, NULL, NULL, 4),
(28610, NULL, 'G3DSA:3.30.420.40:FF:000195', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(28611, NULL, 'G3DSA:3.80.10.10:FF:002120', NULL, NULL, 'Protein CBG11130', NULL, NULL, NULL, NULL, NULL, 4),
(28612, NULL, 'G3DSA:3.90.1180.10:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28613, NULL, 'G3DSA:2.130.10.10:FF:004284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28614, NULL, 'G3DSA:3.30.160.590:FF:000001', NULL, NULL, 'microprocessor complex subunit DGCR8', NULL, NULL, NULL, NULL, NULL, 4),
(28615, NULL, 'G3DSA:3.30.1490.100:FF:000045', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(28616, NULL, 'G3DSA:1.25.40.10:FF:000820', NULL, NULL, 'Gamma-soluble NSF attachment protein', NULL, NULL, NULL, NULL, NULL, 4),
(28617, NULL, 'G3DSA:1.20.58.60:FF:000144', NULL, NULL, 'Dystonin', NULL, NULL, NULL, NULL, NULL, 4),
(28618, NULL, 'G3DSA:3.90.1150.10:FF:000420', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(28619, NULL, 'G3DSA:3.40.50.300:FF:006936', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(28620, NULL, 'G3DSA:1.10.1420.10:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28621, NULL, 'G3DSA:1.20.1070.10:FF:001398', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28622, NULL, 'G3DSA:3.90.1600.10:FF:000045', NULL, NULL, 'DNA polymerase epsilon catalytic subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(28623, NULL, 'G3DSA:2.120.10.30:FF:000322', NULL, NULL, 'Flagellum-adhesion glycoprotein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28624, NULL, 'G3DSA:2.10.25.10:FF:001182', NULL, NULL, 'Megalin, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(28625, NULL, 'G3DSA:2.40.50.90:FF:000008', NULL, NULL, 'Tudor and KH domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(28626, NULL, 'G3DSA:3.90.226.10:FF:000092', NULL, NULL, 'Malonate decarboxylase, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(28627, NULL, 'G3DSA:3.40.50.1970:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28628, NULL, 'G3DSA:1.10.510.10:FF:003122', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28629, NULL, 'G3DSA:3.40.50.300:FF:001041', NULL, NULL, 'Origin of replication complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(28630, NULL, 'G3DSA:2.120.10.80:FF:000185', NULL, NULL, 'F-box protein family, AtFBX13-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(28631, NULL, 'G3DSA:1.10.10.10:FF:000357', NULL, NULL, 'Caffeic acid 3-O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(28632, NULL, 'G3DSA:3.50.30.40:FF:000001', NULL, NULL, 'Regulator of ribonuclease activity A', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(28633, NULL, 'G3DSA:1.20.120.720:FF:000025', NULL, NULL, 'Myosin-A', NULL, NULL, NULL, NULL, NULL, 4),
(28634, NULL, 'G3DSA:1.20.120.1240:FF:000042', NULL, NULL, 'Dynamin GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28635, NULL, 'G3DSA:2.60.120.650:FF:000090', NULL, NULL, 'Mitochondrial carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(28636, NULL, 'G3DSA:3.30.70.330:FF:000550', NULL, NULL, 'Nuclear localization sequence binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(28637, NULL, 'G3DSA:2.60.40.10:FF:001102', NULL, NULL, 'tyrosine-protein phosphatase Lar isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(28638, NULL, 'G3DSA:3.40.50.720:FF:001498', NULL, NULL, 'Oxidoreductase, short chain dehydrogenase/reductase family', NULL, NULL, NULL, NULL, NULL, 4),
(28639, NULL, 'G3DSA:1.25.10.10:FF:000880', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(28640, NULL, 'G3DSA:2.115.10.20:FF:000005', NULL, NULL, 'Arabinan endo-1,5-alpha-L-arabinosidase', NULL, NULL, NULL, NULL, NULL, 4),
(28641, NULL, 'G3DSA:3.90.550.10:FF:000676', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28642, NULL, 'G3DSA:1.25.10.10:FF:002448', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28643, NULL, 'G3DSA:2.60.200.20:FF:000265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28644, NULL, 'G3DSA:3.50.30.50:FF:000004', NULL, NULL, 'Cyclase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(28645, NULL, 'G3DSA:3.40.630.10:FF:000317', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(28646, NULL, 'G3DSA:2.40.100.10:FF:000085', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(28647, NULL, 'G3DSA:2.170.270.10:FF:000184', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(28648, NULL, 'G3DSA:3.30.160.60:FF:001315', NULL, NULL, 'C2H2 transcription factor Swi5', NULL, NULL, NULL, NULL, NULL, 4),
(28649, NULL, 'G3DSA:3.40.190.10:FF:000390', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(28650, NULL, 'G3DSA:3.30.565.10:FF:000128', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(28651, NULL, 'G3DSA:3.30.160.60:FF:000697', NULL, NULL, 'Recombination activating gene 1', NULL, NULL, NULL, NULL, NULL, 4),
(28652, NULL, 'G3DSA:3.90.550.50:FF:000098', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(28653, NULL, 'G3DSA:3.30.1520.10:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28654, NULL, 'G3DSA:2.60.250.10:FF:000001', NULL, NULL, 'Early 35 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(28655, NULL, 'G3DSA:3.60.15.10:FF:000119', NULL, NULL, 'DNA internalization-related competence protein ComEC/Rec2', NULL, NULL, NULL, NULL, NULL, 4),
(28656, NULL, 'G3DSA:3.40.50.300:FF:008527', NULL, NULL, 'Atp-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(28657, NULL, 'G3DSA:2.40.70.10:FF:000161', NULL, NULL, 'YALI0B06303p', NULL, NULL, NULL, NULL, NULL, 4),
(28658, NULL, 'G3DSA:3.40.50.1820:FF:000034', NULL, NULL, 'NDRG2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(28659, NULL, 'G3DSA:3.30.230.70:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28660, NULL, 'G3DSA:1.25.40.10:FF:000606', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(28661, NULL, 'G3DSA:1.20.120.730:FF:000028', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(28662, NULL, 'G3DSA:2.170.270.10:FF:000066', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(28663, NULL, 'G3DSA:3.30.1890.10:FF:000006', NULL, NULL, 'O-antigen chain length determinant', NULL, NULL, NULL, NULL, NULL, 4),
(28664, NULL, 'G3DSA:1.20.900.10:FF:000120', NULL, NULL, 'Rho guanine nucleotide exchange factor 37', NULL, NULL, NULL, NULL, NULL, 4),
(28665, NULL, 'G3DSA:1.25.40.10:FF:002164', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(28666, NULL, 'G3DSA:3.30.160.400:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28667, NULL, 'G3DSA:2.120.10.80:FF:000090', NULL, NULL, 'Leucine-zipper transcriptional regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(28668, NULL, 'G3DSA:1.10.1070.11:FF:000053', NULL, NULL, 'Serine/threonine-protein kinase ATM', NULL, NULL, NULL, NULL, NULL, 4),
(28669, NULL, 'G3DSA:1.10.8.60:FF:000596', NULL, NULL, 'Cell division control protein', NULL, NULL, NULL, NULL, NULL, 4),
(28670, NULL, 'G3DSA:3.30.160.100:FF:000001', NULL, NULL, 'Ribosome hibernation promoting factor', NULL, NULL, NULL, NULL, NULL, 4),
(28671, NULL, 'G3DSA:2.10.25.10:FF:001389', NULL, NULL, 'Latent transforming growth factor beta binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(28672, NULL, 'G3DSA:1.10.950.10:FF:000007', NULL, NULL, 'Villin like', NULL, NULL, NULL, NULL, NULL, 4),
(28673, NULL, 'G3DSA:1.10.510.10:FF:000946', NULL, NULL, 'Probable serine/threonine-protein kinase DDB_G0284251', NULL, NULL, NULL, NULL, NULL, 4),
(28674, NULL, 'G3DSA:1.20.1070.10:FF:002016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28675, NULL, 'G3DSA:3.90.70.10:FF:000353', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28676, NULL, 'G3DSA:3.30.1370.10:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28677, NULL, 'G3DSA:3.40.1390.30:FF:000011', NULL, NULL, 'Putative GTP cyclohydrolase 1 type 2, NIF3 family', NULL, NULL, NULL, NULL, NULL, 4),
(28678, NULL, 'G3DSA:3.30.470.20:FF:000017', NULL, NULL, 'Phosphoenolpyruvate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(28679, NULL, 'G3DSA:2.120.10.30:FF:000097', NULL, NULL, 'Megalin, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(28680, NULL, 'G3DSA:1.25.40.20:FF:000598', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28681, NULL, 'G3DSA:2.60.200.10:FF:000048', NULL, NULL, 'Dwarfin sma-4', NULL, NULL, NULL, NULL, NULL, 4),
(28682, NULL, 'G3DSA:2.160.20.10:FF:000039', NULL, NULL, 'F-box only protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(28683, NULL, 'G3DSA:3.90.226.10:FF:000187', NULL, NULL, 'Propionyl-CoA carboxylase carboxyltransferase component', NULL, NULL, NULL, NULL, NULL, 4),
(28684, NULL, 'G3DSA:3.40.30.10:FF:000667', NULL, NULL, 'Protein disulfide isomerase PDI1', NULL, NULL, NULL, NULL, NULL, 4),
(28685, NULL, 'G3DSA:3.30.70.330:FF:001747', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28686, NULL, 'G3DSA:3.40.190.10:FF:000721', NULL, NULL, 'Transporter substrate-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(28687, NULL, 'G3DSA:1.20.1530.20:FF:000026', NULL, NULL, 'Sodium/bile acid symporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(28688, NULL, 'G3DSA:3.40.30.10:FF:000987', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28689, NULL, 'G3DSA:3.40.190.290:FF:000106', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(28690, NULL, 'G3DSA:1.20.142.10:FF:000004', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(28691, NULL, 'G3DSA:3.30.40.10:FF:000016', NULL, NULL, 'Inhibitor of growth protein', NULL, NULL, NULL, NULL, NULL, 4),
(28692, NULL, 'G3DSA:2.60.40.10:FF:004660', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28693, NULL, 'G3DSA:3.30.70.1660:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28694, NULL, 'G3DSA:3.30.70.330:FF:001865', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28695, NULL, 'G3DSA:3.40.50.1000:FF:000811', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28696, NULL, 'G3DSA:2.60.40.60:FF:000925', NULL, NULL, 'Cadherin 13', NULL, NULL, NULL, NULL, NULL, 4),
(28697, NULL, 'G3DSA:2.10.25.10:FF:001732', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28698, NULL, 'G3DSA:3.10.100.10:FF:000262', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28699, NULL, 'G3DSA:1.20.920.30:FF:000026', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(28700, NULL, 'G3DSA:3.30.160.60:FF:002288', NULL, NULL, 'Zinc finger protein 700', NULL, NULL, NULL, NULL, NULL, 4),
(28701, NULL, 'G3DSA:3.40.50.11530:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28702, NULL, 'G3DSA:1.20.920.20:FF:000023', NULL, NULL, 'Putative mitotubule-associated protein Gb4', NULL, NULL, NULL, NULL, NULL, 4),
(28703, NULL, 'G3DSA:3.40.640.10:FF:000150', NULL, NULL, 'Cystathionine beta-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(28704, NULL, 'G3DSA:1.10.132.10:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28705, NULL, 'G3DSA:3.40.50.1220:FF:000051', NULL, NULL, 'Pyruvate decarboxylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28706, NULL, 'G3DSA:2.40.70.10:FF:000368', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28707, NULL, 'G3DSA:3.90.730.10:FF:000016', NULL, NULL, 'Ribonuclease T2,-like', NULL, NULL, NULL, NULL, NULL, 4),
(28708, NULL, 'G3DSA:3.10.180.10:FF:000036', NULL, NULL, 'Glyoxalase-like domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(28709, NULL, 'G3DSA:1.10.600.10:FF:000032', NULL, NULL, 'Syn-copalyl diphosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(28710, NULL, 'G3DSA:3.20.20.300:FF:000027', NULL, NULL, 'Glycosyl hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28711, NULL, 'G3DSA:1.10.1410.40:FF:000014', NULL, NULL, 'Cyclic GMP-AMP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(28712, NULL, 'G3DSA:3.40.50.2000:FF:000532', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28713, NULL, 'G3DSA:2.40.50.140:FF:000434', NULL, NULL, 'Methionyl-tRNA synthetase putative', NULL, NULL, NULL, NULL, NULL, 4),
(28714, NULL, 'G3DSA:2.60.40.770:FF:000015', NULL, NULL, 'Putative phosphatidylglycerol/phosphatidylinositol transfer protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(28715, NULL, 'G3DSA:2.30.30.40:FF:000673', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28716, NULL, 'G3DSA:3.40.50.150:FF:000355', NULL, NULL, 'Methyltransferase like 8', NULL, NULL, NULL, NULL, NULL, 4),
(28717, NULL, 'G3DSA:1.10.287.2920:FF:000002', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 15', NULL, NULL, NULL, NULL, NULL, 4),
(28718, NULL, 'G3DSA:2.40.50.140:FF:000333', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC8', NULL, NULL, NULL, NULL, NULL, 4),
(28719, NULL, 'G3DSA:1.10.357.150:FF:000013', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(28720, NULL, 'G3DSA:2.130.10.10:FF:000585', NULL, NULL, 'WD repeat domain 60', NULL, NULL, NULL, NULL, NULL, 4),
(28721, NULL, 'G3DSA:3.40.50.300:FF:003502', NULL, NULL, 'DNA mismatch repair protein mutS, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28722, NULL, 'G3DSA:3.10.20.90:FF:001001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28723, NULL, 'G3DSA:3.30.710.10:FF:000410', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28724, NULL, 'G3DSA:3.30.505.50:FF:000007', NULL, NULL, 'Ribosome hibernation promoting factor', NULL, NULL, NULL, NULL, NULL, 4),
(28725, NULL, 'G3DSA:2.20.70.10:FF:000111', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(28726, NULL, 'G3DSA:3.40.50.11210:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28727, NULL, 'G3DSA:3.10.20.90:FF:000624', NULL, NULL, 'Ubiquitin-40S ribosomal protein S27a', NULL, NULL, NULL, NULL, NULL, 4),
(28728, NULL, 'G3DSA:3.40.630.30:FF:000655', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28729, NULL, 'G3DSA:3.10.110.10:FF:000088', NULL, NULL, 'Ubiquitin-conjugating enzyme E2', NULL, NULL, NULL, NULL, NULL, 4),
(28730, NULL, 'G3DSA:1.10.357.140:FF:000010', NULL, NULL, 'Protoheme IX farnesyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(28731, NULL, 'G3DSA:3.40.50.1240:FF:000057', NULL, NULL, '6-phosphofructo-2-kinase/fructose-2, 6-biphosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28732, NULL, 'G3DSA:3.30.70.330:FF:002141', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(28733, NULL, 'G3DSA:2.60.120.200:FF:000421', NULL, NULL, 'Bb-cadherin', NULL, NULL, NULL, NULL, NULL, 4),
(28734, NULL, 'G3DSA:3.50.7.10:FF:000018', NULL, NULL, 'T-complex protein 1 subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(28735, NULL, 'G3DSA:2.60.40.10:FF:000618', NULL, NULL, 'sushi, nidogen and EGF-like domain-containing protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(28736, NULL, 'G3DSA:3.40.50.300:FF:005301', NULL, NULL, 'Ras-related protein Rap-1b', NULL, NULL, NULL, NULL, NULL, 4),
(28737, NULL, 'G3DSA:3.90.550.10:FF:000238', NULL, NULL, 'Probable N-acetylgalactosaminyltransferase 8', NULL, NULL, NULL, NULL, NULL, 4),
(28738, NULL, 'G3DSA:3.30.160.60:FF:000489', NULL, NULL, 'Zinc finger protein Gfi-1', NULL, NULL, NULL, NULL, NULL, 4),
(28739, NULL, 'G3DSA:3.40.50.2300:FF:000077', NULL, NULL, 'Chemotaxis response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(28740, NULL, 'G3DSA:3.40.50.12240:FF:000012', NULL, NULL, 'ATP synthase subunit beta chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(28741, NULL, 'G3DSA:2.110.10.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28742, NULL, 'G3DSA:3.30.70.330:FF:002242', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28743, NULL, 'G3DSA:3.30.160.60:FF:000259', NULL, NULL, 'Zinc finger and BTB domain containing 7C', NULL, NULL, NULL, NULL, NULL, 4),
(28744, NULL, 'G3DSA:2.60.40.10:FF:000276', NULL, NULL, 'peroxidasin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(28745, NULL, 'G3DSA:3.90.550.10:FF:000468', NULL, NULL, 'Ceramide glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(28746, NULL, 'G3DSA:2.160.20.70:FF:000029', NULL, NULL, 'Tubulin binding cofactor C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28747, NULL, 'G3DSA:1.20.1070.10:FF:001948', NULL, NULL, 'Protein CBR-SRV-22', NULL, NULL, NULL, NULL, NULL, 4),
(28748, NULL, 'G3DSA:1.10.287.110:FF:000384', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28749, NULL, 'G3DSA:2.40.160.110:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28750, NULL, 'G3DSA:3.30.710.10:FF:000511', NULL, NULL, 'Potassium voltage-gated channel subfamily A member 3', NULL, NULL, NULL, NULL, NULL, 4),
(28751, NULL, 'G3DSA:2.60.40.1170:FF:000009', NULL, NULL, 'AP-3 complex subunit mu-1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(28752, NULL, 'G3DSA:1.25.40.10:FF:004417', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28753, NULL, 'G3DSA:1.25.40.10:FF:003799', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28754, NULL, 'G3DSA:3.40.1710.10:FF:000008', NULL, NULL, 'ABC transporter G family member 20', NULL, NULL, NULL, NULL, NULL, 4),
(28755, NULL, 'G3DSA:3.40.50.1000:FF:000457', NULL, NULL, 'Haloacid dehalogenase-like hydrolase domain-containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(28756, NULL, 'G3DSA:3.10.110.10:FF:000190', NULL, NULL, 'Ubiquitin-conjugating enzyme E2-28.4 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(28757, NULL, 'G3DSA:2.40.10.10:FF:000494', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28758, NULL, 'G3DSA:3.30.450.40:FF:000146', NULL, NULL, 'Stage II sporulation protein E', NULL, NULL, NULL, NULL, NULL, 4),
(28759, NULL, 'G3DSA:1.25.10.10:FF:000650', NULL, NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(28760, NULL, 'G3DSA:3.90.190.10:FF:000030', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type', NULL, NULL, NULL, NULL, NULL, 4),
(28761, NULL, 'G3DSA:3.90.1800.10:FF:000026', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(28762, NULL, 'G3DSA:3.30.160.60:FF:004188', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28763, NULL, 'G3DSA:2.40.160.120:FF:000056', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(28764, NULL, 'G3DSA:3.40.630.10:FF:000295', NULL, NULL, 'Putative carboxypeptidase PM20D1', NULL, NULL, NULL, NULL, NULL, 4),
(28765, NULL, 'G3DSA:1.25.40.10:FF:002517', NULL, NULL, 'Protein NCA1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(28766, NULL, 'G3DSA:3.90.190.20:FF:000033', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(28767, NULL, 'G3DSA:1.10.20.10:FF:000184', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28768, NULL, 'G3DSA:2.60.40.10:FF:004328', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28769, NULL, 'G3DSA:2.60.40.1150:FF:000003', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(28770, NULL, 'G3DSA:2.60.260.20:FF:000049', NULL, NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(28771, NULL, 'G3DSA:3.10.450.10:FF:000029', NULL, NULL, 'Fetuin B', NULL, NULL, NULL, NULL, NULL, 4),
(28772, NULL, 'G3DSA:1.20.1250.20:FF:002005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28773, NULL, 'G3DSA:3.90.1410.10:FF:000019', NULL, NULL, 'N-lysine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(28774, NULL, 'G3DSA:3.40.190.10:FF:000047', NULL, NULL, 'Amino acid ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(28775, NULL, 'G3DSA:3.90.1140.10:FF:000026', NULL, NULL, 'U6 snRNA phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(28776, NULL, 'G3DSA:3.30.160.60:FF:002389', NULL, NULL, 'Zinc finger protein 236 variant', NULL, NULL, NULL, NULL, NULL, 4),
(28777, NULL, 'G3DSA:3.30.70.330:FF:000342', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit G', NULL, NULL, NULL, NULL, NULL, 4),
(28778, NULL, 'G3DSA:3.40.50.620:FF:000400', NULL, NULL, 'Isoleucine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(28779, NULL, 'G3DSA:3.40.1480.10:FF:000012', NULL, NULL, 'Glycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(28780, NULL, 'G3DSA:3.40.50.300:FF:002884', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(28781, NULL, 'G3DSA:1.10.238.10:FF:000892', NULL, NULL, 'Dual oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(28782, NULL, 'G3DSA:3.40.50.10810:FF:000263', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(28783, NULL, 'G3DSA:2.130.10.10:FF:004637', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28784, NULL, 'G3DSA:2.130.10.10:FF:000355', NULL, NULL, 'WD repeat-containing protein 81 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(28785, NULL, 'G3DSA:3.40.50.720:FF:000306', NULL, NULL, 'Alpha-aminoadipic semialdehyde synthase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(28786, NULL, 'G3DSA:3.20.20.70:FF:000657', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28787, NULL, 'G3DSA:3.40.1050.10:FF:000008', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(28788, NULL, 'G3DSA:3.30.70.980:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28789, NULL, 'G3DSA:1.10.1420.10:FF:000079', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(28790, NULL, 'G3DSA:2.40.50.140:FF:000092', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(28791, NULL, 'G3DSA:1.10.1670.10:FF:000013', NULL, NULL, '8-oxoguanine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(28792, NULL, 'G3DSA:1.10.8.270:FF:000017', NULL, NULL, 'TBC1 domain family member 16', NULL, NULL, NULL, NULL, NULL, 4),
(28793, NULL, 'G3DSA:1.10.357.10:FF:000073', NULL, NULL, 'Transcriptional regulator tetR/acrR family', NULL, NULL, NULL, NULL, NULL, 4),
(28794, NULL, 'G3DSA:3.90.1010.10:FF:000022', NULL, NULL, 'SUF system NifU family Fe-S cluster assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(28795, NULL, 'G3DSA:1.20.272.10:FF:000008', NULL, NULL, 'DNA polymerase III, delta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(28796, NULL, 'G3DSA:1.10.510.10:FF:001430', NULL, NULL, 'phosphorylase b kinase gamma catalytic chain, skeletal muscle/heart isoform', NULL, NULL, NULL, NULL, NULL, 4),
(28797, NULL, 'G3DSA:3.40.50.300:FF:002564', NULL, NULL, 'Iron ABC transporter ATP-binding protein/permease IrtB', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(28798, NULL, 'G3DSA:3.30.1520.10:FF:000030', NULL, NULL, 'Sorting nexin-3, variant', NULL, NULL, NULL, NULL, NULL, 4),
(28799, NULL, 'G3DSA:2.60.40.10:FF:002176', NULL, NULL, 'Twitchin', NULL, NULL, NULL, NULL, NULL, 4),
(28800, NULL, 'G3DSA:3.30.559.70:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28801, NULL, 'G3DSA:2.160.10.10:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28802, NULL, 'G3DSA:2.60.40.10:FF:004317', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28803, NULL, 'G3DSA:3.40.50.300:FF:001602', NULL, NULL, 'Cell division cycle protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(28804, NULL, 'G3DSA:3.30.40.10:FF:001298', NULL, NULL, 'Major immediate early protein', NULL, NULL, NULL, NULL, NULL, 4),
(28805, NULL, 'G3DSA:3.30.450.20:FF:000140', NULL, NULL, 'Cyclic-di-AMP phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(28806, NULL, 'G3DSA:1.10.10.60:FF:000574', NULL, NULL, 'Homeobox protein CHOX-CAD2', NULL, NULL, NULL, NULL, NULL, 4),
(28807, NULL, 'G3DSA:1.10.30.10:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28808, NULL, 'G3DSA:1.10.10.60:FF:000344', NULL, NULL, 'Transcription factor MYB44', NULL, NULL, NULL, NULL, NULL, 4),
(28809, NULL, 'G3DSA:2.40.100.10:FF:000096', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(28810, NULL, 'G3DSA:3.40.630.10:FF:000418', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(28811, NULL, 'G3DSA:3.30.160.60:FF:004643', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28812, NULL, 'G3DSA:3.90.79.10:FF:000097', NULL, NULL, 'MutT/nudix family protein', NULL, NULL, NULL, NULL, NULL, 4),
(28813, NULL, 'G3DSA:3.40.50.300:FF:004464', NULL, NULL, 'bile salt export pump-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(28814, NULL, 'G3DSA:3.40.50.300:FF:003047', NULL, NULL, 'Septin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28815, NULL, 'G3DSA:2.20.110.10:FF:000022', NULL, NULL, 'MORN repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28816, NULL, 'G3DSA:1.10.730.10:FF:000036', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(28817, NULL, 'G3DSA:3.30.40.10:FF:001753', NULL, NULL, 'Tripartite motif containing 69 protein', NULL, NULL, NULL, NULL, NULL, 4),
(28818, NULL, 'G3DSA:1.10.10.10:FF:000256', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC3', NULL, NULL, NULL, NULL, NULL, 4),
(28819, NULL, 'G3DSA:1.25.10.10:FF:000537', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28820, NULL, 'G3DSA:3.40.640.10:FF:000037', NULL, NULL, 'dTDP-4-amino-4,6-dideoxygalactose transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(28821, NULL, 'G3DSA:3.30.1680.10:FF:000069', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(28822, NULL, 'G3DSA:2.120.10.80:FF:000421', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(28823, NULL, 'G3DSA:2.60.120.10:FF:000683', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28824, NULL, 'G3DSA:2.130.10.10:FF:004407', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28825, NULL, 'G3DSA:2.40.30.10:FF:000164', NULL, NULL, 'Elongation factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(28826, NULL, 'G3DSA:1.25.40.20:FF:001082', NULL, NULL, 'Peroxisomal NADH pyrophosphatase NUDT12', NULL, NULL, NULL, NULL, NULL, 4),
(28827, NULL, 'G3DSA:3.30.70.330:FF:002803', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28828, NULL, 'G3DSA:2.130.10.10:FF:003789', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28829, NULL, 'G3DSA:2.60.40.150:FF:000184', NULL, NULL, 'Translocation protein SEC63', NULL, NULL, NULL, NULL, NULL, 4),
(28830, NULL, 'G3DSA:3.30.160.60:FF:002743', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28831, NULL, 'G3DSA:2.60.120.650:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28832, NULL, 'G3DSA:3.30.497.10:FF:000166', NULL, NULL, 'Serpin peptidase inhibitor 28', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(28833, NULL, 'G3DSA:2.130.10.10:FF:002507', NULL, NULL, 'Syntaxin-binding protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(28834, NULL, 'G3DSA:2.120.10.30:FF:000198', NULL, NULL, 'Sortilin-related receptor, L(DLR class) A repeats containing', NULL, NULL, NULL, NULL, NULL, 4),
(28835, NULL, 'G3DSA:3.40.1800.30:FF:000004', NULL, NULL, 'SAP30 like', NULL, NULL, NULL, NULL, NULL, 4),
(28836, NULL, 'G3DSA:1.10.238.10:FF:000454', NULL, NULL, 'Pef1p', NULL, NULL, NULL, NULL, NULL, 4),
(28837, NULL, 'G3DSA:1.25.40.20:FF:000929', NULL, NULL, 'Putative ankyrin repeat and zinc finger domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(28838, NULL, 'G3DSA:3.10.20.90:FF:000944', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28839, NULL, 'G3DSA:1.20.1440.80:FF:000008', NULL, NULL, 'Gap junction gamma-3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(28840, NULL, 'G3DSA:2.60.40.10:FF:002956', NULL, NULL, 'Sortilin-related receptor, L(DLR class) A repeats containing', NULL, NULL, NULL, NULL, NULL, 4),
(28841, NULL, 'G3DSA:3.10.450.50:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28842, NULL, 'G3DSA:1.20.870.10:FF:000038', NULL, NULL, 'Ras guanine nucleotide exchange factor D', NULL, NULL, NULL, NULL, NULL, 4),
(28843, NULL, 'G3DSA:2.40.30.270:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28844, NULL, 'G3DSA:1.25.40.20:FF:001424', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28845, NULL, 'G3DSA:2.130.10.10:FF:004295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28846, NULL, 'G3DSA:3.30.1370.10:FF:000091', NULL, NULL, 'Putative exosome complex exonuclease Rrp40', NULL, NULL, NULL, NULL, NULL, 4),
(28847, NULL, 'G3DSA:3.80.10.10:FF:001491', NULL, NULL, 'Leucine-rich repeat (LRR) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(28848, NULL, 'G3DSA:3.30.780.10:FF:000004', NULL, NULL, 'density-regulated protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(28849, NULL, 'G3DSA:3.40.50.1580:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28850, NULL, 'G3DSA:1.20.5.190:FF:000070', NULL, NULL, 'Myosin', NULL, NULL, NULL, NULL, NULL, 4),
(28851, NULL, 'G3DSA:1.10.510.10:FF:000716', NULL, NULL, 'Protein kinase byr2-like', NULL, NULL, NULL, NULL, NULL, 4),
(28852, NULL, 'G3DSA:1.10.420.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28853, NULL, 'G3DSA:2.60.40.150:FF:000307', NULL, NULL, 'Copine-E', NULL, NULL, NULL, NULL, NULL, 4),
(28854, NULL, 'G3DSA:3.50.50.60:FF:000216', NULL, NULL, 'Cilia and flagella associated protein 61', NULL, NULL, NULL, NULL, NULL, 4),
(28855, NULL, 'G3DSA:3.40.50.1820:FF:001669', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(28856, NULL, 'G3DSA:3.40.50.150:FF:000793', NULL, NULL, 'FACT complex subunit SPT16', NULL, NULL, NULL, NULL, NULL, 4),
(28857, NULL, 'G3DSA:1.10.510.10:FF:000593', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28858, NULL, 'G3DSA:3.30.230.70:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28859, NULL, 'G3DSA:3.40.225.10:FF:000016', NULL, NULL, 'Possible L-fuculose phosphate aldolase fucA', NULL, NULL, NULL, NULL, NULL, 4),
(28860, NULL, 'G3DSA:3.40.190.10:FF:000160', NULL, NULL, 'GLutamate Receptor family (AMPA)', NULL, NULL, NULL, NULL, NULL, 4),
(28861, NULL, 'G3DSA:2.10.220.10:FF:000078', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(28862, NULL, 'G3DSA:1.20.1250.20:FF:001387', NULL, NULL, 'AGAP012419-PA', NULL, NULL, NULL, NULL, NULL, 4),
(28863, NULL, 'G3DSA:3.40.1090.10:FF:000005', NULL, NULL, 'Patatin', NULL, NULL, NULL, NULL, NULL, 4),
(28864, NULL, 'G3DSA:1.10.3110.10:FF:000011', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(28865, NULL, 'G3DSA:3.60.15.10:FF:000018', NULL, NULL, 'DNA cross-link repair 1C', NULL, NULL, NULL, NULL, NULL, 4),
(28866, NULL, 'G3DSA:2.40.10.10:FF:000617', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(28867, NULL, 'G3DSA:3.30.230.130:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28868, NULL, 'G3DSA:3.30.200.20:FF:002460', NULL, NULL, 'Serine/threonine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(28869, NULL, 'G3DSA:3.90.226.10:FF:000081', NULL, NULL, 'Enoyl-CoA hydratase/isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(28870, NULL, 'G3DSA:3.40.50.1820:FF:001771', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28871, NULL, 'G3DSA:1.20.120.1900:FF:000072', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(28872, NULL, 'G3DSA:2.70.170.10:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28873, NULL, 'G3DSA:2.60.120.260:FF:000080', NULL, NULL, 'Netrin 3', NULL, NULL, NULL, NULL, NULL, 4),
(28874, NULL, 'G3DSA:3.80.10.10:FF:003643', NULL, NULL, 'Os08g0203400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(28875, NULL, 'G3DSA:1.20.1560.10:FF:000879', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28876, NULL, 'G3DSA:3.40.50.1440:FF:000027', NULL, NULL, 'Tubulin gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(28877, NULL, 'G3DSA:2.60.40.60:FF:000364', NULL, NULL, 'Fat-like cadherin-related tumor suppressor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(28878, NULL, 'G3DSA:3.30.60.50:FF:000001', NULL, NULL, '2,3-diketo-L-gulonate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(28879, NULL, 'G3DSA:2.10.50.30:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28880, NULL, 'G3DSA:1.20.1070.10:FF:001168', NULL, NULL, 'Prostaglandin E2 receptor EP3 subtype', NULL, NULL, NULL, NULL, NULL, 4),
(28881, NULL, 'G3DSA:2.20.70.10:FF:000195', NULL, NULL, 'Pasha/DGCR8', NULL, NULL, NULL, NULL, NULL, 4),
(28882, NULL, 'G3DSA:2.60.40.10:FF:003232', NULL, NULL, 'Erythropoietin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(28883, NULL, 'G3DSA:2.120.10.30:FF:000552', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28884, NULL, 'G3DSA:3.30.70.270:FF:000054', NULL, NULL, 'Putative DNA polymerase kappa', NULL, NULL, NULL, NULL, NULL, 4),
(28885, NULL, 'G3DSA:1.10.510.10:FF:003021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28886, NULL, 'G3DSA:2.70.150.10:FF:000238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28887, NULL, 'G3DSA:2.40.70.10:FF:000481', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28888, NULL, 'G3DSA:1.10.150.20:FF:000056', NULL, NULL, 'Meiotic recombination protein DMC1', NULL, NULL, NULL, NULL, NULL, 4),
(28889, NULL, 'G3DSA:1.25.40.990:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28890, NULL, 'G3DSA:1.10.533.10:FF:000286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28891, NULL, 'G3DSA:2.10.25.10:FF:001069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28892, NULL, 'G3DSA:3.40.50.150:FF:001411', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28893, NULL, 'G3DSA:3.80.20.20:FF:000038', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(28894, NULL, 'G3DSA:1.10.472.10:FF:000273', NULL, NULL, 'RE32990p', NULL, NULL, NULL, NULL, NULL, 4),
(28895, NULL, 'G3DSA:1.20.1250.20:FF:000072', NULL, NULL, 'Muropeptide transporter AmpG', NULL, NULL, NULL, NULL, NULL, 4),
(28896, NULL, 'G3DSA:3.40.50.720:FF:001953', NULL, NULL, 'Very-long-chain 3-oxoacyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(28897, NULL, 'G3DSA:1.20.1050.10:FF:000216', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(28898, NULL, 'G3DSA:1.25.40.10:FF:003012', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g46580, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(28899, NULL, 'G3DSA:3.30.420.40:FF:000318', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(28900, NULL, 'G3DSA:3.90.70.10:FF:000673', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(28901, NULL, 'G3DSA:3.10.129.10:FF:000226', NULL, NULL, 'Cytosolic acyl coenzyme A thioester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(28902, NULL, 'G3DSA:3.30.160.100:FF:000012', NULL, NULL, 'Ribosomal subunit interface protein', NULL, NULL, NULL, NULL, NULL, 4),
(28903, NULL, 'G3DSA:2.40.128.330:FF:000014', NULL, NULL, 'Mitochondrial CorA family metal ion transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(28904, NULL, 'G3DSA:2.160.20.10:FF:000270', NULL, NULL, 'Putative beta-1,3 exoglucanase', NULL, NULL, NULL, NULL, NULL, 4),
(28905, NULL, 'G3DSA:1.25.40.10:FF:000926', NULL, NULL, 'Anaphase-promoting complex subunit CDC23', NULL, NULL, NULL, NULL, NULL, 4),
(28906, NULL, 'G3DSA:3.30.200.20:FF:002128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28907, NULL, 'G3DSA:3.40.50.10860:FF:000019', NULL, NULL, 'Quinate pathway repressor protein QutR', NULL, NULL, NULL, NULL, NULL, 4),
(28908, NULL, 'G3DSA:1.10.540.10:FF:000089', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(28909, NULL, 'G3DSA:1.25.10.10:FF:002128', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(28910, NULL, 'G3DSA:3.30.70.3030:FF:000012', NULL, NULL, 'Nucleolar protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(28911, NULL, 'G3DSA:1.20.1260.10:FF:000030', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(28912, NULL, 'G3DSA:3.40.395.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28913, NULL, 'G3DSA:3.90.70.200:FF:000020', NULL, NULL, 'YALI0D01892p', NULL, NULL, NULL, NULL, NULL, 4),
(28914, NULL, 'G3DSA:3.10.110.10:FF:000313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28915, NULL, 'G3DSA:1.20.120.1050:FF:000002', NULL, NULL, 'Nuclear pore complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(28916, NULL, 'G3DSA:1.10.510.10:FF:002184', NULL, NULL, 'Serine/threonine-protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28917, NULL, 'G3DSA:3.90.175.10:FF:000006', NULL, NULL, 'Exotoxin A', NULL, NULL, NULL, NULL, NULL, 4),
(28918, NULL, 'G3DSA:1.10.1450.10:FF:000148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28919, NULL, 'G3DSA:3.90.550.10:FF:000570', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(28920, NULL, 'G3DSA:1.25.40.10:FF:004294', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g31790', NULL, NULL, NULL, NULL, NULL, 4),
(28921, NULL, 'G3DSA:3.40.850.10:FF:000412', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28922, NULL, 'G3DSA:3.20.190.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28923, NULL, 'G3DSA:3.30.160.60:FF:000591', NULL, NULL, 'Zinc finger protein 536', NULL, NULL, NULL, NULL, NULL, 4),
(28924, NULL, 'G3DSA:1.20.120.330:FF:000015', NULL, NULL, 'Lincosamide nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(28925, NULL, 'G3DSA:2.60.40.10:FF:000495', NULL, NULL, 'Periplasmic beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(28926, NULL, 'G3DSA:1.25.40.10:FF:004642', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28927, NULL, 'G3DSA:3.40.50.300:FF:006274', NULL, NULL, 'Mitochondrial Rho GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(28928, NULL, 'G3DSA:3.30.70.330:FF:002023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28929, NULL, 'G3DSA:1.10.10.10:FF:000694', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC3', NULL, NULL, NULL, NULL, NULL, 4),
(28930, NULL, 'G3DSA:2.130.10.10:FF:004851', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28931, NULL, 'G3DSA:3.40.190.10:FF:000833', NULL, NULL, 'Putative nitrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(28932, NULL, 'G3DSA:1.25.10.10:FF:001959', NULL, NULL, 'YALI0D22520p', NULL, NULL, NULL, NULL, NULL, 4),
(28933, NULL, 'G3DSA:3.40.50.300:FF:008398', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28934, NULL, 'G3DSA:2.40.30.10:FF:000484', NULL, NULL, 'NADH-cytochrome b5 reductase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(28935, NULL, 'G3DSA:3.40.50.150:FF:000568', NULL, NULL, 'Leucine carboxyl methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(28936, NULL, 'G3DSA:3.10.20.90:FF:000837', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28937, NULL, 'G3DSA:2.60.120.260:FF:000293', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(28938, NULL, 'G3DSA:1.20.1730.10:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28939, NULL, 'G3DSA:2.120.10.80:FF:000196', NULL, NULL, 'Kelch repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(28940, NULL, 'G3DSA:3.40.640.10:FF:000357', NULL, NULL, 'Pyridoxal phosphate (PLP)-dependent transferases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(28941, NULL, 'G3DSA:3.40.390.10:FF:000040', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(28942, NULL, 'G3DSA:1.10.287.110:FF:000389', NULL, NULL, 'DNAJ heat shock family protein', NULL, NULL, NULL, NULL, NULL, 4),
(28943, NULL, 'G3DSA:1.20.1070.10:FF:002011', NULL, NULL, 'G-protein-linked acetylcholine receptor gar-2A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28944, NULL, 'G3DSA:2.130.10.10:FF:003221', NULL, NULL, 'Flagellar associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(28945, NULL, 'G3DSA:1.10.10.10:FF:000812', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(28946, NULL, 'G3DSA:2.130.10.10:FF:000580', NULL, NULL, 'Guanine nucleotide-binding protein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(28947, NULL, 'G3DSA:3.30.230.10:FF:000143', NULL, NULL, 'Ribonuclease P protein component', NULL, NULL, NULL, NULL, NULL, 4),
(28948, NULL, 'G3DSA:3.40.50.300:FF:007797', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28949, NULL, 'G3DSA:1.10.630.10:FF:000669', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(28950, NULL, 'G3DSA:3.40.850.10:FF:000064', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(28951, NULL, 'G3DSA:1.10.1420.10:FF:000197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28952, NULL, 'G3DSA:3.40.50.1000:FF:000575', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28953, NULL, 'G3DSA:1.20.58.760:FF:000026', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(28954, NULL, 'G3DSA:1.20.5.190:FF:000171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28955, NULL, 'G3DSA:1.10.1420.10:FF:000208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28956, NULL, 'G3DSA:1.25.40.10:FF:002495', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g62720', NULL, NULL, NULL, NULL, NULL, 4),
(28957, NULL, 'G3DSA:3.30.70.1560:FF:000009', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(28958, NULL, 'G3DSA:3.60.10.10:FF:000030', NULL, NULL, 'DNA-(apurinic or apyrimidinic site) lyase', NULL, NULL, NULL, NULL, NULL, 4),
(28959, NULL, 'G3DSA:1.10.510.10:FF:004196', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28960, NULL, 'G3DSA:2.60.120.10:FF:000784', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28961, NULL, 'G3DSA:1.25.40.10:FF:001894', NULL, NULL, 'Peroxisomal biogenesis factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(28962, NULL, 'G3DSA:2.130.10.10:FF:000473', NULL, NULL, 'Phosphoinositide 3-kinase regulatory subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(28963, NULL, 'G3DSA:1.25.10.10:FF:000436', NULL, NULL, 'Cullin binding protein CanA', NULL, NULL, NULL, NULL, NULL, 4),
(28964, NULL, 'G3DSA:3.30.920.20:FF:000002', NULL, NULL, 'dystonin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(28965, NULL, 'G3DSA:2.60.40.10:FF:002737', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase beta', NULL, NULL, NULL, NULL, NULL, 4),
(28966, NULL, 'G3DSA:1.20.1260.60:FF:000011', NULL, NULL, 'Regulator of Vps4 activity in the MVB pathway protein', NULL, NULL, NULL, NULL, NULL, 4),
(28967, NULL, 'G3DSA:3.30.70.3490:FF:000021', NULL, NULL, 'Unplaced genomic scaffold supercont1.13, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(28968, NULL, 'G3DSA:2.60.40.1860:FF:000008', NULL, NULL, 'Peptidylarginine deiminase type III', NULL, NULL, NULL, NULL, NULL, 4),
(28969, NULL, 'G3DSA:3.30.559.30:FF:000058', NULL, NULL, 'Plipastatin synthase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(28970, NULL, 'G3DSA:3.40.50.300:FF:000872', NULL, NULL, 'Twitching motility protein PilT', NULL, NULL, NULL, NULL, NULL, 4),
(28971, NULL, 'G3DSA:2.30.29.30:FF:001347', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(28972, NULL, 'G3DSA:1.10.510.10:FF:000941', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(28973, NULL, 'G3DSA:3.40.50.880:FF:000219', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(28974, NULL, 'G3DSA:1.10.10.1760:FF:000001', NULL, NULL, '60S ribosomal protein L36', NULL, NULL, NULL, NULL, NULL, 4),
(28975, NULL, 'G3DSA:3.90.980.20:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(28976, NULL, 'G3DSA:1.10.100.10:FF:000005', NULL, NULL, 'Insulin, isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(28977, NULL, 'G3DSA:1.10.10.1770:FF:000004', NULL, NULL, 'Ycf53-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(28978, NULL, 'G3DSA:2.130.10.10:FF:004744', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28979, NULL, 'G3DSA:2.60.40.10:FF:001214', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', NULL, NULL, NULL, NULL, NULL, 4),
(28980, NULL, 'G3DSA:3.30.70.270:FF:000060', NULL, NULL, 'Diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(28981, NULL, 'G3DSA:1.10.220.10:FF:000059', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(28982, NULL, 'G3DSA:3.30.750.24:FF:000050', NULL, NULL, 'Anti-sigma F factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(28983, NULL, 'G3DSA:2.60.40.1850:FF:000005', NULL, NULL, 'Sortase B protein-sorting domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(28984, NULL, 'G3DSA:3.10.110.10:FF:000318', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28985, NULL, 'G3DSA:3.40.50.300:FF:006381', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28986, NULL, 'G3DSA:3.30.40.10:FF:002360', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(28987, NULL, 'G3DSA:1.20.58.900:FF:000001', NULL, NULL, 'RUN and FYVE domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(28988, NULL, 'G3DSA:1.10.418.10:FF:000097', NULL, NULL, 'Microtubule-associated protein EB1', NULL, NULL, NULL, NULL, NULL, 4),
(28989, NULL, 'G3DSA:2.60.40.1840:FF:000002', NULL, NULL, 'Aminopeptidase N', NULL, NULL, NULL, NULL, NULL, 4),
(28990, NULL, 'G3DSA:3.30.559.10:FF:000052', NULL, NULL, 'Nonribosomal peptide synthase SidE', NULL, NULL, NULL, NULL, NULL, 4),
(28991, NULL, 'G3DSA:3.90.70.10:FF:000785', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(28992, NULL, 'G3DSA:1.10.1450.10:FF:000143', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(28993, NULL, 'G3DSA:1.10.3430.10:FF:000041', NULL, NULL, 'Rh blood group antigen', NULL, NULL, NULL, NULL, NULL, 4),
(28994, NULL, 'G3DSA:1.10.730.10:FF:000143', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(28995, NULL, 'G3DSA:1.25.40.10:FF:001787', NULL, NULL, 'Os01g0959600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(28996, NULL, 'G3DSA:2.10.110.10:FF:000283', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(28997, NULL, 'G3DSA:3.90.550.50:FF:000227', NULL, NULL, 'Uncharacterized protein F37A4.3', NULL, NULL, NULL, NULL, NULL, 4),
(28998, NULL, 'G3DSA:3.90.1150.10:FF:000072', NULL, NULL, 'Serine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(28999, NULL, 'G3DSA:4.10.60.10:FF:000016', NULL, NULL, 'Cellular nucleic acid-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(29000, NULL, 'G3DSA:1.20.1250.20:FF:002112', NULL, NULL, 'Fucosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29001, NULL, 'G3DSA:3.10.100.10:FF:000037', NULL, NULL, 'C-type lectin domain family 18 member A-like', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(29002, NULL, 'G3DSA:1.10.533.10:FF:000292', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(29003, NULL, 'G3DSA:3.40.50.170:FF:000001', NULL, NULL, 'Formyltetrahydrofolate deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(29004, NULL, 'G3DSA:3.30.70.120:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29005, NULL, 'G3DSA:1.20.890.10:FF:000028', NULL, NULL, 'AGAP008525-PA', NULL, NULL, NULL, NULL, NULL, 4),
(29006, NULL, 'G3DSA:3.30.479.30:FF:000006', NULL, NULL, 'SPFH/Band 7/PHB domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(29007, NULL, 'G3DSA:3.30.200.20:FF:002454', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29008, NULL, 'G3DSA:3.30.60.10:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29009, NULL, 'G3DSA:3.30.160.60:FF:003120', NULL, NULL, 'GM04789p', NULL, NULL, NULL, NULL, NULL, 4),
(29010, NULL, 'G3DSA:1.20.58.1290:FF:000004', NULL, NULL, 'CarD-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(29011, NULL, 'G3DSA:3.80.10.10:FF:001838', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(29012, NULL, 'G3DSA:3.90.470.20:FF:000072', NULL, NULL, 'L-aminoadipate-semialdehyde dehydrogenase-phosphopantetheinyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(29013, NULL, 'G3DSA:2.60.40.10:FF:001107', NULL, NULL, 'Defective proboscis extension response', NULL, NULL, NULL, NULL, NULL, 4),
(29014, NULL, 'G3DSA:3.40.30.10:FF:001044', NULL, NULL, 'Iodothyronine deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(29015, NULL, 'G3DSA:4.10.60.10:FF:000123', NULL, NULL, 'Cellular nucleic acid binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(29016, NULL, 'G3DSA:2.130.10.10:FF:001996', NULL, NULL, 'Connector of kinase to AP-1, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(29017, NULL, 'G3DSA:3.10.100.10:FF:000144', NULL, NULL, 'RE45003p', NULL, NULL, NULL, NULL, NULL, 4),
(29018, NULL, 'G3DSA:1.10.533.10:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29019, NULL, 'G3DSA:2.60.40.150:FF:000397', NULL, NULL, 'C2 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(29020, NULL, 'G3DSA:1.20.58.1280:FF:000001', NULL, NULL, 'DNA repair protein REV1', NULL, NULL, NULL, NULL, NULL, 4),
(29021, NULL, 'G3DSA:3.30.200.20:FF:002347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29022, NULL, 'G3DSA:1.25.10.10:FF:002667', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(29023, NULL, 'G3DSA:1.20.920.60:FF:000001', NULL, NULL, 'Cytoplasmic dynein 1 heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(29024, NULL, 'G3DSA:3.90.1150.10:FF:000291', NULL, NULL, 'Aminotransferase, class V family protein', NULL, NULL, NULL, NULL, NULL, 4),
(29025, NULL, 'G3DSA:2.70.70.10:FF:000007', NULL, NULL, 'Stage IV sporulation protein FA', NULL, NULL, NULL, NULL, NULL, 4),
(29026, NULL, 'G3DSA:3.40.50.1580:FF:000029', NULL, NULL, 'S-methyl-5''-thioadenosine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(29027, NULL, 'G3DSA:1.25.10.10:FF:000543', NULL, NULL, 'Armadillo repeat only 2', NULL, NULL, NULL, NULL, NULL, 4),
(29028, NULL, 'G3DSA:3.40.50.300:FF:007212', NULL, NULL, 'Gluconokinase', NULL, NULL, NULL, NULL, NULL, 4),
(29029, NULL, 'G3DSA:1.10.238.10:FF:000908', NULL, NULL, 'Putative calmodulin-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(29030, NULL, 'G3DSA:1.10.510.10:FF:002846', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29031, NULL, 'G3DSA:1.25.40.10:FF:002169', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(29032, NULL, 'G3DSA:3.90.226.10:FF:000322', NULL, NULL, 'E3 ubiquitin-protein ligase HOS1', NULL, NULL, NULL, NULL, NULL, 4),
(29033, NULL, 'G3DSA:3.30.1360.70:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29034, NULL, 'G3DSA:2.130.10.10:FF:002378', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29035, NULL, 'G3DSA:3.90.70.10:FF:000566', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(29036, NULL, 'G3DSA:3.40.225.10:FF:000022', NULL, NULL, 'Probable bifunctional methylthioribulose-1-phosphate dehydratase/enolase-phosphatase E1', NULL, NULL, NULL, NULL, NULL, 4),
(29037, NULL, 'G3DSA:1.10.472.10:FF:000722', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29038, NULL, 'G3DSA:3.30.200.20:FF:000330', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase At4g03230', NULL, NULL, NULL, NULL, NULL, 4),
(29039, NULL, 'G3DSA:3.10.129.10:FF:000120', NULL, NULL, 'Fox2p', NULL, NULL, NULL, NULL, NULL, 4),
(29040, NULL, 'G3DSA:2.130.10.10:FF:001889', NULL, NULL, 'Small nucleolar ribonucleoprotein complex subunit, putative (AFU_orthologue AFUA_4G07540)', NULL, NULL, NULL, NULL, NULL, 4),
(29041, NULL, 'G3DSA:3.90.70.40:FF:000002', NULL, NULL, 'josephin-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(29042, NULL, 'G3DSA:3.30.530.20:FF:000186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29043, NULL, 'G3DSA:1.10.238.10:FF:000678', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29044, NULL, 'G3DSA:2.60.120.920:FF:000199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29045, NULL, 'G3DSA:3.40.50.2300:FF:000201', NULL, NULL, 'Histidine kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(29046, NULL, 'G3DSA:4.10.1040.10:FF:000002', NULL, NULL, 'Putative transcription factor MAB-23', NULL, NULL, NULL, NULL, NULL, 4),
(29047, NULL, 'G3DSA:2.130.10.10:FF:003002', NULL, NULL, 'YALI0E00506p', NULL, NULL, NULL, NULL, NULL, 4),
(29048, NULL, 'G3DSA:3.30.1360.10:FF:000039', NULL, NULL, 'DNA-directed RNA polymerase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(29049, NULL, 'G3DSA:3.40.50.150:FF:000894', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29050, NULL, 'G3DSA:3.40.50.920:FF:000041', NULL, NULL, 'Transketolase', NULL, NULL, NULL, NULL, NULL, 4),
(29051, NULL, 'G3DSA:3.30.497.10:FF:000065', NULL, NULL, 'Serine (or cysteine) peptidase inhibitor, clade B, member 6e', NULL, NULL, NULL, NULL, NULL, 4),
(29052, NULL, 'G3DSA:3.30.450.20:FF:000134', NULL, NULL, 'Fis family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(29053, NULL, 'G3DSA:1.10.132.50:FF:000001', NULL, NULL, 'V-type proton ATPase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(29054, NULL, 'G3DSA:3.40.50.300:FF:003401', NULL, NULL, 'Protein CBR-CNT-2', NULL, NULL, NULL, NULL, NULL, 4),
(29055, NULL, 'G3DSA:3.30.420.40:FF:000083', NULL, NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(29056, NULL, 'G3DSA:2.40.30.10:FF:000265', NULL, NULL, 'NADH-cytochrome b5 reductase-like', NULL, NULL, NULL, NULL, NULL, 4),
(29057, NULL, 'G3DSA:3.50.7.10:FF:000013', NULL, NULL, 'T-complex protein 1 subunit zeta', NULL, NULL, NULL, NULL, NULL, 4),
(29058, NULL, 'G3DSA:3.10.580.20:FF:000002', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(29059, NULL, 'G3DSA:1.20.5.320:FF:000024', NULL, NULL, 'MBL', NULL, NULL, NULL, NULL, NULL, 4),
(29060, NULL, 'G3DSA:2.30.42.10:FF:000124', NULL, NULL, 'DEP domain-containing mTOR-interacting protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(29061, NULL, 'G3DSA:3.40.50.1000:FF:000356', NULL, NULL, 'Phospholipid-transporting P-type ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29062, NULL, 'G3DSA:3.40.850.10:FF:000171', NULL, NULL, 'Chromosome-associated kinesin KIF4A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29063, NULL, 'G3DSA:3.30.930.10:FF:000298', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(29064, NULL, 'G3DSA:1.25.40.10:FF:004535', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(29065, NULL, 'G3DSA:3.90.260.10:FF:000036', NULL, NULL, 'Transglutaminase 5,-like', NULL, NULL, NULL, NULL, NULL, 4),
(29066, NULL, 'G3DSA:3.40.50.80:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29067, NULL, 'G3DSA:3.30.160.60:FF:000832', NULL, NULL, 'sal-like protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(29068, NULL, 'G3DSA:1.25.40.10:FF:004316', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29069, NULL, 'G3DSA:3.20.20.100:FF:000170', NULL, NULL, 'Oxidoreductase, aldo/keto reductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(29070, NULL, 'G3DSA:3.40.366.10:FF:000040', NULL, NULL, 'Malonyl CoA-acyl carrier protein transacylase', NULL, NULL, NULL, NULL, NULL, 4),
(29071, NULL, 'G3DSA:3.30.740.10:FF:000013', NULL, NULL, 'Dynein light chain', NULL, NULL, NULL, NULL, NULL, 4),
(29072, NULL, 'G3DSA:3.90.190.20:FF:000027', NULL, NULL, 'Folylpolyglutamate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(29073, NULL, 'G3DSA:3.40.50.300:FF:008179', NULL, NULL, 'Os11g0707100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(29074, NULL, 'G3DSA:3.40.1620.70:FF:000002', NULL, NULL, 'Collagen alpha 1 (XV) chain', NULL, NULL, NULL, NULL, NULL, 4),
(29075, NULL, 'G3DSA:1.25.10.10:FF:000762', NULL, NULL, 'HEAT repeat domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(29076, NULL, 'G3DSA:1.20.190.40:FF:000006', NULL, NULL, 'Major DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(29077, NULL, 'G3DSA:3.30.70.580:FF:000046', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(29078, NULL, 'G3DSA:2.130.10.10:FF:004632', NULL, NULL, 'Os12g0129400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(29079, NULL, 'G3DSA:3.90.1380.10:FF:000004', NULL, NULL, 'Threonine synthase like 2', NULL, NULL, NULL, NULL, NULL, 4),
(29080, NULL, 'G3DSA:3.30.40.10:FF:001652', NULL, NULL, 'DNA repair protein RAD5A', NULL, NULL, NULL, NULL, NULL, 4),
(29081, NULL, 'G3DSA:2.60.260.20:FF:000044', NULL, NULL, 'DnaJ protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29082, NULL, 'G3DSA:3.30.40.10:FF:000117', NULL, NULL, 'Probable E3 ubiquitin-protein ligase makorin-1', NULL, NULL, NULL, NULL, NULL, 4),
(29083, NULL, 'G3DSA:2.60.40.10:FF:004873', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29084, NULL, 'G3DSA:3.90.1150.10:FF:000302', NULL, NULL, 'Kynureninase', NULL, NULL, NULL, NULL, NULL, 4),
(29085, NULL, 'G3DSA:1.20.5.3790:FF:000001', NULL, NULL, 'Cellulose synthase operon protein D', NULL, NULL, NULL, NULL, NULL, 4),
(29086, NULL, 'G3DSA:3.40.50.300:FF:006493', NULL, NULL, 'Os11g0490800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(29087, NULL, 'G3DSA:3.40.50.300:FF:008409', NULL, NULL, 'ATP-dependent DEAD/H RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29088, NULL, 'G3DSA:2.20.130.20:FF:000015', NULL, NULL, 'Thiolester containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(29089, NULL, 'G3DSA:3.90.1480.20:FF:000066', NULL, NULL, 'Alpha-2,3-sialyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(29090, NULL, 'G3DSA:1.20.120.1880:FF:000003', NULL, NULL, 'nuclear pore complex protein Nup155', NULL, NULL, NULL, NULL, NULL, 4),
(29091, NULL, 'G3DSA:1.25.40.10:FF:000264', NULL, NULL, 'Tetratricopeptide repeat protein 9A', NULL, NULL, NULL, NULL, NULL, 4),
(29092, NULL, 'G3DSA:1.10.510.10:FF:002291', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29093, NULL, 'G3DSA:2.40.10.10:FF:000382', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29094, NULL, 'G3DSA:3.30.870.10:FF:000129', NULL, NULL, 'Tyrosyl-DNA Phosphodiesterase (Tdp1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(29095, NULL, 'G3DSA:2.40.50.140:FF:000215', NULL, NULL, 'Exosome complex component RRP40, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29096, NULL, 'G3DSA:1.10.510.10:FF:000615', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase', NULL, NULL, NULL, NULL, NULL, 4),
(29097, NULL, 'G3DSA:3.60.120.10:FF:000004', NULL, NULL, 'Aminodeoxychorismate synthase, component I', NULL, NULL, NULL, NULL, NULL, 4),
(29098, NULL, 'G3DSA:1.20.1250.20:FF:002000', NULL, NULL, 'Sucrose transport protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29099, NULL, 'G3DSA:1.10.150.240:FF:000081', NULL, NULL, 'Protein CBG24156', NULL, NULL, NULL, NULL, NULL, 4),
(29100, NULL, 'G3DSA:3.40.190.10:FF:000614', NULL, NULL, 'ATP phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(29101, NULL, 'G3DSA:2.170.140.10:FF:000062', NULL, NULL, 'Chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(29102, NULL, 'G3DSA:3.30.420.40:FF:000638', NULL, NULL, 'Carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(29103, NULL, 'G3DSA:2.130.10.10:FF:002608', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29104, NULL, 'G3DSA:3.30.160.60:FF:002849', NULL, NULL, 'Si:dkey-16b10.2', NULL, NULL, NULL, NULL, NULL, 4),
(29105, NULL, 'G3DSA:3.30.70.3330:FF:000001', NULL, NULL, 'Fatty acid synthase subunit beta dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(29106, NULL, 'G3DSA:1.10.290.10:FF:000007', NULL, NULL, 'DNA topoisomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(29107, NULL, 'G3DSA:2.120.10.80:FF:000314', NULL, NULL, 'Mei4-dependent protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(29108, NULL, 'G3DSA:3.30.70.3340:FF:000004', NULL, NULL, 'Anaerobic sulfite reductase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(29109, NULL, 'G3DSA:2.60.40.630:FF:000013', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(29110, NULL, 'G3DSA:3.30.56.10:FF:000007', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(29111, NULL, 'G3DSA:4.10.60.10:FF:000235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29112, NULL, 'G3DSA:1.10.10.10:FF:000705', NULL, NULL, 'Hypothetical_protein', NULL, NULL, NULL, NULL, NULL, 4),
(29113, NULL, 'G3DSA:3.40.50.12780:FF:000140', NULL, NULL, 'Acetyl-CoA synthetase (Acetate-CoA ligase) amino-end (AcsA-4)', NULL, NULL, NULL, NULL, NULL, 4),
(29114, NULL, 'G3DSA:2.60.40.150:FF:000285', NULL, NULL, 'C2 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(29115, NULL, 'G3DSA:1.20.1000.10:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29116, NULL, 'G3DSA:1.10.10.1320:FF:000004', NULL, NULL, 'Transcriptional activator ChrR', NULL, NULL, NULL, NULL, NULL, 4),
(29117, NULL, 'G3DSA:2.40.70.10:FF:000374', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29118, NULL, 'G3DSA:3.30.830.10:FF:000239', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(29119, NULL, 'G3DSA:3.10.100.10:FF:000363', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29120, NULL, 'G3DSA:2.70.170.10:FF:000234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29121, NULL, 'G3DSA:2.10.110.10:FF:000064', NULL, NULL, 'Four and a half LIM domains protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(29122, NULL, 'G3DSA:1.50.10.20:FF:000015', NULL, NULL, 'Terpene cyclase/mutase family member', NULL, NULL, NULL, NULL, NULL, 4),
(29123, NULL, 'G3DSA:1.25.40.20:FF:000267', NULL, NULL, 'Ankyrin repeat and SOCS box containing 14', NULL, NULL, NULL, NULL, NULL, 4),
(29124, NULL, 'G3DSA:1.20.140.40:FF:000060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29125, NULL, 'G3DSA:2.60.40.10:FF:001799', NULL, NULL, 'Platelet and endothelial cell adhesion molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(29126, NULL, 'G3DSA:3.80.10.10:FF:003188', NULL, NULL, 'Toll-like receptor 9', NULL, NULL, NULL, NULL, NULL, 4),
(29127, NULL, 'G3DSA:3.80.10.10:FF:002002', NULL, NULL, 'Leucine-rich receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(29128, NULL, 'G3DSA:1.20.190.50:FF:000009', NULL, NULL, 'Nuclear pore complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(29129, NULL, 'G3DSA:3.30.60.20:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29130, NULL, 'G3DSA:3.30.40.10:FF:002141', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(29131, NULL, 'G3DSA:1.10.3130.10:FF:000001', NULL, NULL, 'Acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(29132, NULL, 'G3DSA:3.40.50.150:FF:000349', NULL, NULL, 'Methyltransferase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(29133, NULL, 'G3DSA:3.30.70.330:FF:002702', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29134, NULL, 'G3DSA:1.10.20.10:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(29135, NULL, 'G3DSA:2.40.20.10:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29136, NULL, 'G3DSA:2.40.50.40:FF:000134', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(29137, NULL, 'G3DSA:1.10.287.110:FF:000277', NULL, NULL, 'Fe-S protein assembly co-chaperone HscB', NULL, NULL, NULL, NULL, NULL, 4),
(29138, NULL, 'G3DSA:2.170.130.10:FF:000022', NULL, NULL, 'Ligand-gated channel', NULL, NULL, NULL, NULL, NULL, 4),
(29139, NULL, 'G3DSA:1.20.1070.10:FF:001847', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29140, NULL, 'G3DSA:3.90.550.10:FF:000569', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29141, NULL, 'G3DSA:2.60.120.260:FF:000523', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29142, NULL, 'G3DSA:3.40.50.300:FF:008286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29143, NULL, 'G3DSA:1.20.1250.20:FF:002331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29144, NULL, 'G3DSA:2.30.30.360:FF:000004', NULL, NULL, 'Chick atrial myosin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(29145, NULL, 'G3DSA:1.25.10.10:FF:000981', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(29146, NULL, 'G3DSA:3.30.450.70:FF:000014', NULL, NULL, 'Trafficking protein particle complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(29147, NULL, 'G3DSA:3.40.50.1820:FF:001776', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29148, NULL, 'G3DSA:2.170.150.10:FF:000017', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(29149, NULL, 'G3DSA:1.20.1510.10:FF:000016', NULL, NULL, 'Zinc transporter ZitB', NULL, NULL, NULL, NULL, NULL, 4),
(29150, NULL, 'G3DSA:2.120.10.80:FF:000084', NULL, NULL, 'Leucine carboxyl methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(29151, NULL, 'G3DSA:3.30.160.60:FF:004429', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29152, NULL, 'G3DSA:3.10.50.10:FF:000006', NULL, NULL, 'Chitobiase, di-N-acetyl-', NULL, NULL, NULL, NULL, NULL, 4),
(29153, NULL, 'G3DSA:1.25.40.10:FF:004530', NULL, NULL, 'General transcriptional corepressor ssn6', NULL, NULL, NULL, NULL, NULL, 4),
(29154, NULL, 'G3DSA:1.10.1740.100:FF:000007', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(29155, NULL, 'G3DSA:2.20.70.10:FF:000212', NULL, NULL, 'Membrane-associated guanylate kinase, WW and PDZ domain-containing 3b', NULL, NULL, NULL, NULL, NULL, 4),
(29156, NULL, 'G3DSA:3.80.10.10:FF:001619', NULL, NULL, 'SCF E3 ubiquitin ligase complex F-box protein grrA', NULL, NULL, NULL, NULL, NULL, 4),
(29157, NULL, 'G3DSA:3.40.1370.10:FF:000038', NULL, NULL, '50S ribosomal protein L4', NULL, NULL, NULL, NULL, NULL, 4),
(29158, NULL, 'G3DSA:3.40.50.1440:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29159, NULL, 'G3DSA:2.60.120.260:FF:000181', NULL, NULL, 'Neuroendocrine convertase 2', NULL, NULL, NULL, NULL, NULL, 4),
(29160, NULL, 'G3DSA:2.130.10.10:FF:001304', NULL, NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(29161, NULL, 'G3DSA:3.90.780.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29162, NULL, 'G3DSA:1.20.1070.10:FF:002123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29163, NULL, 'G3DSA:2.60.40.10:FF:000383', NULL, NULL, 'CD166 antigen isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(29164, NULL, 'G3DSA:1.10.1070.11:FF:000047', NULL, NULL, 'Serine/threonine-protein kinase ATR', NULL, NULL, NULL, NULL, NULL, 4),
(29165, NULL, 'G3DSA:1.25.40.10:FF:002618', NULL, NULL, 'Hsc70-interacting protein (Hip), putative', NULL, NULL, NULL, NULL, NULL, 4),
(29166, NULL, 'G3DSA:1.20.1110.10:FF:000267', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29167, NULL, 'G3DSA:3.30.160.60:FF:001540', NULL, NULL, 'zinc finger protein 483 isoform X2', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(29168, NULL, 'G3DSA:3.90.660.20:FF:000002', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(29169, NULL, 'G3DSA:1.10.2020.20:FF:000001', NULL, NULL, 'Proteasomal ubiquitin receptor ADRM1', NULL, NULL, NULL, NULL, NULL, 4),
(29170, NULL, 'G3DSA:1.10.3430.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29171, NULL, 'G3DSA:1.10.30.50:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29172, NULL, 'G3DSA:3.30.43.10:FF:000040', NULL, NULL, 'L-gulonolactone oxidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(29173, NULL, 'G3DSA:3.10.28.10:FF:000067', NULL, NULL, 'Cytochrome b mRNA maturase bI3', NULL, NULL, NULL, NULL, NULL, 4),
(29174, NULL, 'G3DSA:2.130.10.10:FF:000692', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(29175, NULL, 'G3DSA:2.30.29.30:FF:000043', NULL, NULL, 'FERM domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(29176, NULL, 'G3DSA:3.30.70.3490:FF:000026', NULL, NULL, 'Oxysterol binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(29177, NULL, 'G3DSA:2.60.40.150:FF:000627', NULL, NULL, 'Synaptotagmin 1e', NULL, NULL, NULL, NULL, NULL, 4),
(29178, NULL, 'G3DSA:2.30.30.40:FF:000572', NULL, NULL, 'Variant SH3 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(29179, NULL, 'G3DSA:1.20.1070.10:FF:001499', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29180, NULL, 'G3DSA:3.40.50.11810:FF:000001', NULL, NULL, 'H(2):CoB-CoM heterodisulfide,ferredoxin reductase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(29181, NULL, 'G3DSA:3.40.1810.10:FF:000067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29182, NULL, 'G3DSA:1.10.238.10:FF:000459', NULL, NULL, 'Probable calcium-binding protein CML16', NULL, NULL, NULL, NULL, NULL, 4),
(29183, NULL, 'G3DSA:4.10.1240.30:FF:000001', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(29184, NULL, 'G3DSA:3.40.50.300:FF:001361', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(29185, NULL, 'G3DSA:1.20.1250.20:FF:001730', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29186, NULL, 'G3DSA:1.10.472.10:FF:000503', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29187, NULL, 'G3DSA:3.80.10.10:FF:003525', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29188, NULL, 'G3DSA:2.60.40.10:FF:004654', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29189, NULL, 'G3DSA:2.60.40.60:FF:000818', NULL, NULL, 'Cad74A isoform A family protein', NULL, NULL, NULL, NULL, NULL, 4),
(29190, NULL, 'G3DSA:2.50.20.10:FF:000011', NULL, NULL, 'Outer-membrane lipoprotein LolB', NULL, NULL, NULL, NULL, NULL, 4),
(29191, NULL, 'G3DSA:3.30.70.80:FF:000056', NULL, NULL, 'Subtilisin-like serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(29192, NULL, 'G3DSA:3.40.50.300:FF:004705', NULL, NULL, 'Cell division protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29193, NULL, 'G3DSA:1.20.1440.90:FF:000006', NULL, NULL, 'Phosphoenolpyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(29194, NULL, 'G3DSA:3.30.200.20:FF:000088', NULL, NULL, 'Casein kinase II subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(29195, NULL, 'G3DSA:4.10.60.10:FF:000230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29196, NULL, 'G3DSA:3.40.50.2000:FF:000206', NULL, NULL, 'Trehalose-6-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(29197, NULL, 'G3DSA:2.60.40.10:FF:004761', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29198, NULL, 'G3DSA:1.10.238.10:FF:000785', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29199, NULL, 'G3DSA:1.10.10.60:FF:000681', NULL, NULL, 'NifA/NtrC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(29200, NULL, 'G3DSA:2.60.260.20:FF:000156', NULL, NULL, 'DnaJ-related protein spj1', NULL, NULL, NULL, NULL, NULL, 4),
(29201, NULL, 'G3DSA:1.10.510.10:FF:002627', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(29202, NULL, 'G3DSA:3.40.50.1000:FF:000570', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29203, NULL, 'G3DSA:3.30.200.20:FF:002561', NULL, NULL, 'AGC protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(29204, NULL, 'G3DSA:3.30.70.330:FF:000662', NULL, NULL, 'Polyadenylated RNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(29205, NULL, 'G3DSA:3.40.350.10:FF:000043', NULL, NULL, 'GM24054', NULL, NULL, NULL, NULL, NULL, 4),
(29206, NULL, 'G3DSA:1.25.10.10:FF:000874', NULL, NULL, 'Kinesin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29207, NULL, 'G3DSA:3.30.540.10:FF:000032', NULL, NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(29208, NULL, 'G3DSA:4.10.1240.50:FF:000007', NULL, NULL, 'Z-linked MIER family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(29209, NULL, 'G3DSA:2.60.40.10:FF:000832', NULL, NULL, 'Platelet-derived growth factor receptor alpha', NULL, NULL, NULL, NULL, NULL, 4),
(29210, NULL, 'G3DSA:3.40.50.300:FF:004357', NULL, NULL, 'Septum site-determining protein MinD', NULL, NULL, NULL, NULL, NULL, 4),
(29211, NULL, 'G3DSA:1.25.40.10:FF:002276', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g26460, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(29212, NULL, 'G3DSA:1.10.10.10:FF:002055', NULL, NULL, 'Two component signal transduction system controlling the osmosenstive K+ channel response regulator KdpE', NULL, NULL, NULL, NULL, NULL, 4),
(29213, NULL, 'G3DSA:2.120.10.80:FF:000426', NULL, NULL, 'Serine/threonine-protein phosphatase BSL1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(29214, NULL, 'G3DSA:2.120.10.80:FF:000191', NULL, NULL, 'Leucine zipper like transcription regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(29215, NULL, 'G3DSA:2.20.25.30:FF:000006', NULL, NULL, 'Ribosomal protein L37', NULL, NULL, NULL, NULL, NULL, 4),
(29216, NULL, 'G3DSA:3.30.1370.10:FF:000102', NULL, NULL, 'Cleavage and polyadenylation specificity factor subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(29217, NULL, 'G3DSA:1.25.40.20:FF:000486', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(29218, NULL, 'G3DSA:1.10.10.10:FF:001779', NULL, NULL, 'Vacuolar-sorting protein SNF8', NULL, NULL, NULL, NULL, NULL, 4),
(29219, NULL, 'G3DSA:3.40.50.410:FF:000101', NULL, NULL, 'General transcription factor IIH subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29220, NULL, 'G3DSA:3.40.50.720:FF:001841', NULL, NULL, 'Putative malate dehydrogenase 1B', NULL, NULL, NULL, NULL, NULL, 4),
(29221, NULL, 'G3DSA:3.40.50.1000:FF:000794', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29222, NULL, 'G3DSA:2.40.70.10:FF:000048', NULL, NULL, 'Napsin A aspartic peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(29223, NULL, 'G3DSA:3.80.10.10:FF:002221', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(29224, NULL, 'G3DSA:2.60.120.200:FF:000207', NULL, NULL, 'Cadherin-related tumor suppressor', NULL, NULL, NULL, NULL, NULL, 4),
(29225, NULL, 'G3DSA:3.80.10.10:FF:001390', NULL, NULL, 'Probable leucine-rich repeat receptor-like protein kinase At1g35710', NULL, NULL, NULL, NULL, NULL, 4),
(29226, NULL, 'G3DSA:3.30.1740.20:FF:000010', NULL, NULL, '40S ribosomal protein S26', NULL, NULL, NULL, NULL, NULL, 4),
(29227, NULL, 'G3DSA:2.60.40.10:FF:000490', NULL, NULL, 'Signal-regulatory protein beta 1', NULL, NULL, NULL, NULL, NULL, 4),
(29228, NULL, 'G3DSA:3.80.10.10:FF:003183', NULL, NULL, 'Toll-like receptor 9', NULL, NULL, NULL, NULL, NULL, 4),
(29229, NULL, 'G3DSA:1.10.510.10:FF:001323', NULL, NULL, 'PK3', NULL, NULL, NULL, NULL, NULL, 4),
(29230, NULL, 'G3DSA:1.10.150.60:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29231, NULL, 'G3DSA:1.10.510.10:FF:000834', NULL, NULL, 'SRSF protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(29232, NULL, 'G3DSA:2.20.70.10:FF:000094', NULL, NULL, 'transcriptional coactivator YAP1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(29233, NULL, 'G3DSA:2.60.40.10:FF:000725', NULL, NULL, 'Platelet-derived growth factor receptor alpha', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(29234, NULL, 'G3DSA:3.40.640.10:FF:000138', NULL, NULL, 'Histidinol-phosphate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(29235, NULL, 'G3DSA:2.60.40.10:FF:003131', NULL, NULL, 'Striated muscle-enriched protein kinase a', NULL, NULL, NULL, NULL, NULL, 4),
(29236, NULL, 'G3DSA:1.25.40.10:FF:000483', NULL, NULL, 'Transcription factor 25', NULL, NULL, NULL, NULL, NULL, 4),
(29237, NULL, 'G3DSA:2.130.10.10:FF:004306', NULL, NULL, 'Defective in DNA methylation-9 protein', NULL, NULL, NULL, NULL, NULL, 4),
(29238, NULL, 'G3DSA:1.20.200.10:FF:000005', NULL, NULL, 'Adenylosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(29239, NULL, 'G3DSA:1.10.238.10:FF:001061', NULL, NULL, 'EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(29240, NULL, 'G3DSA:3.30.830.10:FF:000127', NULL, NULL, 'Clan ME, family M16, insulinase-like metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(29241, NULL, 'G3DSA:3.80.10.10:FF:001945', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(29242, NULL, 'G3DSA:3.30.40.10:FF:002253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29243, NULL, 'G3DSA:3.30.70.330:FF:002028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29244, NULL, 'G3DSA:1.10.20.10:FF:000077', NULL, NULL, 'Histone H3 variant', NULL, NULL, NULL, NULL, NULL, 4),
(29245, NULL, 'G3DSA:1.10.3380.30:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29246, NULL, 'G3DSA:3.40.50.880:FF:000096', NULL, NULL, 'Class I glutamine amidotransferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(29247, NULL, 'G3DSA:2.60.40.10:FF:004980', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29248, NULL, 'G3DSA:1.20.1250.20:FF:000999', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(29249, NULL, 'G3DSA:1.10.1450.10:FF:000036', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(29250, NULL, 'G3DSA:2.40.50.90:FF:000020', NULL, NULL, 'A-kinase anchor protein 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(29251, NULL, 'G3DSA:1.10.3170.10:FF:000003', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(29252, NULL, 'G3DSA:3.40.1770.10:FF:000012', NULL, NULL, 'Urocanate hydratase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29253, NULL, 'G3DSA:3.40.50.2000:FF:000083', NULL, NULL, 'UDP-glycosyltransferase TURAN isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(29254, NULL, 'G3DSA:3.40.50.300:FF:004924', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29255, NULL, 'G3DSA:2.80.10.50:FF:000257', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(29256, NULL, 'G3DSA:1.10.8.270:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29257, NULL, 'G3DSA:3.30.160.60:FF:001214', NULL, NULL, 'Zinc finger with KRAB and SCAN domains 4', NULL, NULL, NULL, NULL, NULL, 4),
(29258, NULL, 'G3DSA:3.30.70.330:FF:000443', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29259, NULL, 'G3DSA:1.10.400.10:FF:000045', NULL, NULL, 'G-protein subunit alpha 7', NULL, NULL, NULL, NULL, NULL, 4),
(29260, NULL, 'G3DSA:3.40.50.2000:FF:000425', NULL, NULL, 'Trehalose-6-phosphate synthase3', NULL, NULL, NULL, NULL, NULL, 4),
(29261, NULL, 'G3DSA:2.60.40.150:FF:000408', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29262, NULL, 'G3DSA:1.25.50.20:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29263, NULL, 'G3DSA:1.20.140.150:FF:000055', NULL, NULL, 'CLaudin-like in Caenorhabditis', NULL, NULL, NULL, NULL, NULL, 4),
(29264, NULL, 'G3DSA:3.30.200.20:FF:002342', NULL, NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 12', NULL, NULL, NULL, NULL, NULL, 4),
(29265, NULL, 'G3DSA:1.20.1250.20:FF:001269', NULL, NULL, 'MFS transporter (Hol1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(29266, NULL, 'G3DSA:3.40.47.10:FF:000065', NULL, NULL, 'Acetyl-CoA acyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(29267, NULL, 'G3DSA:1.10.10.10:FF:000138', NULL, NULL, 'Rrf2 family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(29268, NULL, 'G3DSA:3.40.50.300:FF:005200', NULL, NULL, 'LOC795887 protein', NULL, NULL, NULL, NULL, NULL, 4),
(29269, NULL, 'G3DSA:2.30.30.100:FF:000050', NULL, NULL, 'Small nuclear ribonucleoprotein Sm D1', NULL, NULL, NULL, NULL, NULL, 4),
(29270, NULL, 'G3DSA:3.40.50.1170:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29271, NULL, 'G3DSA:3.40.50.1480:FF:000011', NULL, NULL, 'Adenosylhomocysteinase', NULL, NULL, NULL, NULL, NULL, 4),
(29272, NULL, 'G3DSA:3.40.50.150:FF:000675', NULL, NULL, 'Aklanonic acid methyltransferase DnrC', NULL, NULL, NULL, NULL, NULL, 4),
(29273, NULL, 'G3DSA:3.40.50.300:FF:000653', NULL, NULL, 'Aliphatic sulfonates import ATP-binding protein SsuB', NULL, NULL, NULL, NULL, NULL, 4),
(29274, NULL, 'G3DSA:3.30.450.20:FF:000022', NULL, NULL, 'circadian locomoter output cycles protein kaput', NULL, NULL, NULL, NULL, NULL, 4),
(29275, NULL, 'G3DSA:2.130.10.10:FF:004177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29276, NULL, 'G3DSA:3.90.480.10:FF:000013', NULL, NULL, 'CobG', NULL, NULL, NULL, NULL, NULL, 4),
(29277, NULL, 'G3DSA:3.30.1540.20:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29278, NULL, 'G3DSA:2.160.10.10:FF:000095', NULL, NULL, 'Nucleotidyl transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29279, NULL, 'G3DSA:1.10.510.10:FF:004089', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29280, NULL, 'G3DSA:1.10.510.10:FF:000492', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(29281, NULL, 'G3DSA:2.60.40.10:FF:004435', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29282, NULL, 'G3DSA:3.40.190.10:FF:000507', NULL, NULL, 'Peptide transport periplasmic protein sapA', NULL, NULL, NULL, NULL, NULL, 4),
(29283, NULL, 'G3DSA:3.40.50.1820:FF:001557', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29284, NULL, 'G3DSA:2.60.40.10:FF:004087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29285, NULL, 'G3DSA:1.25.40.90:FF:000012', NULL, NULL, 'Huntingtin interacting protein 1-related', NULL, NULL, NULL, NULL, NULL, 4),
(29286, NULL, 'G3DSA:3.50.50.60:FF:000328', NULL, NULL, 'Probable monoxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(29287, NULL, 'G3DSA:3.40.50.261:FF:000029', NULL, NULL, 'Succinyl-CoA synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(29288, NULL, 'G3DSA:1.20.1250.20:FF:001488', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29289, NULL, 'G3DSA:2.120.10.30:FF:000434', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29290, NULL, 'G3DSA:3.40.50.720:FF:001493', NULL, NULL, 'Ketimine reductase mu-crystallin', NULL, NULL, NULL, NULL, NULL, 4),
(29291, NULL, 'G3DSA:3.40.50.300:FF:004576', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(29292, NULL, 'G3DSA:1.20.1440.80:FF:000003', NULL, NULL, 'Gap junction protein', NULL, NULL, NULL, NULL, NULL, 4),
(29293, NULL, 'G3DSA:1.25.10.10:FF:000655', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(29294, NULL, 'G3DSA:2.30.29.30:FF:000150', NULL, NULL, 'Adaptin ear-binding coat-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(29295, NULL, 'G3DSA:3.90.190.10:FF:000131', NULL, NULL, 'Dual specificity protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29296, NULL, 'G3DSA:2.40.10.10:FF:000505', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29297, NULL, 'G3DSA:1.10.10.60:FF:000462', NULL, NULL, 'ISPsy4, transposase', NULL, NULL, NULL, NULL, NULL, 4),
(29298, NULL, 'G3DSA:2.60.120.260:FF:000304', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(29299, NULL, 'G3DSA:3.90.70.10:FF:000459', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29300, NULL, 'G3DSA:2.60.40.60:FF:000482', NULL, NULL, 'cadherin-89D', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(29301, NULL, 'G3DSA:3.30.479.30:FF:000001', NULL, NULL, 'Prohibitin 2', NULL, NULL, NULL, NULL, NULL, 4),
(29302, NULL, 'G3DSA:3.30.750.24:FF:000162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29303, NULL, 'G3DSA:3.30.70.330:FF:000230', NULL, NULL, 'RNA-binding motif protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(29304, NULL, 'G3DSA:3.30.70.60:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29305, NULL, 'G3DSA:3.30.2160.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29306, NULL, 'G3DSA:3.30.160.60:FF:000377', NULL, NULL, 'zinc finger protein 362 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(29307, NULL, 'G3DSA:3.40.50.300:FF:001142', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(29308, NULL, 'G3DSA:2.40.100.10:FF:000107', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(29309, NULL, 'G3DSA:3.30.565.10:FF:000448', NULL, NULL, 'AGAP006961-PA', NULL, NULL, NULL, NULL, NULL, 4),
(29310, NULL, 'G3DSA:2.10.70.10:FF:000297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29311, NULL, 'G3DSA:2.10.25.10:FF:001283', NULL, NULL, 'AGAP002157-PA', NULL, NULL, NULL, NULL, NULL, 4),
(29312, NULL, 'G3DSA:3.40.190.290:FF:000005', NULL, NULL, 'HTH-type transcriptional activator AllS', NULL, NULL, NULL, NULL, NULL, 4),
(29313, NULL, 'G3DSA:3.10.20.90:FF:000388', NULL, NULL, 'E3 ubiquitin-protein ligase MYLIP-A', NULL, NULL, NULL, NULL, NULL, 4),
(29314, NULL, 'G3DSA:3.30.720.50:FF:000001', NULL, NULL, 'E3 ubiquitin-protein ligase TRIP12 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(29315, NULL, 'G3DSA:1.10.472.10:FF:000155', NULL, NULL, 'TFIIK subunit', NULL, NULL, NULL, NULL, NULL, 4),
(29316, NULL, 'G3DSA:1.10.10.10:FF:001998', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29317, NULL, 'G3DSA:3.40.50.1240:FF:000175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29318, NULL, 'G3DSA:3.30.230.70:FF:000026', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(29319, NULL, 'G3DSA:2.40.70.10:FF:000267', NULL, NULL, 'Aspartic peptidase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(29320, NULL, 'G3DSA:3.30.160.60:FF:004087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29321, NULL, 'G3DSA:3.40.30.10:FF:001049', NULL, NULL, 'Iodothyronine deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(29322, NULL, 'G3DSA:3.30.450.20:FF:000241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29323, NULL, 'G3DSA:3.40.50.2020:FF:000089', NULL, NULL, 'Adenine phosphoribosyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(29324, NULL, 'G3DSA:2.120.10.80:FF:000207', NULL, NULL, 'cDNA FLJ40400 fis, clone TESTI2037103', NULL, NULL, NULL, NULL, NULL, 4),
(29325, NULL, 'G3DSA:3.40.50.150:FF:000456', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(29326, NULL, 'G3DSA:1.10.1320.10:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29327, NULL, 'G3DSA:1.10.20.10:FF:000296', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29328, NULL, 'G3DSA:3.40.190.10:FF:000159', NULL, NULL, 'PBP superfamily domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(29329, NULL, 'G3DSA:3.40.50.300:FF:006830', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29330, NULL, 'G3DSA:1.10.3470.10:FF:000043', NULL, NULL, 'Iron ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(29331, NULL, 'G3DSA:3.30.1050.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29332, NULL, 'G3DSA:1.10.560.10:FF:000096', NULL, NULL, 'McKusick-Kaufman syndrome', NULL, NULL, NULL, NULL, NULL, 4),
(29333, NULL, 'G3DSA:3.30.40.10:FF:002034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29334, NULL, 'G3DSA:3.30.559.70:FF:000042', NULL, NULL, 'AGAP002329-PA', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(29335, NULL, 'G3DSA:1.10.8.500:FF:000013', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(29336, NULL, 'G3DSA:2.30.230.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29337, NULL, 'G3DSA:1.25.40.10:FF:002057', NULL, NULL, 'Transcription factor EMB1444', NULL, NULL, NULL, NULL, NULL, 4),
(29338, NULL, 'G3DSA:3.30.160.60:FF:004980', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29339, NULL, 'G3DSA:1.10.510.10:FF:002408', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29340, NULL, 'G3DSA:2.130.10.10:FF:004525', NULL, NULL, 'Chromosome 12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(29341, NULL, 'G3DSA:3.30.450.40:FF:000247', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(29342, NULL, 'G3DSA:2.60.40.790:FF:000139', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29343, NULL, 'G3DSA:2.130.10.10:FF:005014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29344, NULL, 'G3DSA:2.10.25.10:FF:001631', NULL, NULL, 'FEEL-1', NULL, NULL, NULL, NULL, NULL, 4),
(29345, NULL, 'G3DSA:2.30.18.10:FF:000017', NULL, NULL, 'Transcription initiation factor IIA subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(29346, NULL, 'G3DSA:3.20.20.150:FF:000050', NULL, NULL, 'Hydroxypyruvate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(29347, NULL, 'G3DSA:1.20.1420.30:FF:000021', NULL, NULL, 'Vacuolar calcium ion transporter', NULL, NULL, NULL, NULL, NULL, 4),
(29348, NULL, 'G3DSA:3.90.1420.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29349, NULL, 'G3DSA:3.70.10.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29350, NULL, 'G3DSA:3.30.1360.10:FF:000040', NULL, NULL, 'DNA-directed RNA polymerase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(29351, NULL, 'G3DSA:1.25.10.10:FF:002235', NULL, NULL, 'USO1 vesicle transport factor', NULL, NULL, NULL, NULL, NULL, 4),
(29352, NULL, 'G3DSA:2.10.220.10:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29353, NULL, 'G3DSA:3.40.50.970:FF:000027', NULL, NULL, '2-hydroxyacyl-CoA lyase 1', NULL, NULL, NULL, NULL, NULL, 4),
(29354, NULL, 'G3DSA:3.10.20.90:FF:000495', NULL, NULL, 'Ubiquitin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(29355, NULL, 'G3DSA:3.10.20.580:FF:000001', NULL, NULL, 'Ribonuclease J', NULL, NULL, NULL, NULL, NULL, 4),
(29356, NULL, 'G3DSA:1.20.1070.10:FF:001735', NULL, NULL, 'LOPB11', NULL, NULL, NULL, NULL, NULL, 4),
(29357, NULL, 'G3DSA:2.160.20.10:FF:000045', NULL, NULL, 'Pectin methylesterase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(29358, NULL, 'G3DSA:3.30.1380.20:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29359, NULL, 'G3DSA:3.90.1300.10:FF:000011', NULL, NULL, 'Putative amidase', NULL, NULL, NULL, NULL, NULL, 4),
(29360, NULL, 'G3DSA:1.20.1250.20:FF:001943', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29361, NULL, 'G3DSA:3.90.660.10:FF:000111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29362, NULL, 'G3DSA:3.10.20.590:FF:000004', NULL, NULL, 'Leucine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(29363, NULL, 'G3DSA:1.20.120.360:FF:000001', NULL, NULL, 'Axin interactor, dorsalization-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(29364, NULL, 'G3DSA:3.40.50.10890:FF:000005', NULL, NULL, 'Cleavage and polyadenylation specificity factor subunit 3-II', NULL, NULL, NULL, NULL, NULL, 4),
(29365, NULL, 'G3DSA:2.60.200.20:FF:000158', NULL, NULL, 'Kinesin-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(29366, NULL, 'G3DSA:3.20.20.80:FF:000300', NULL, NULL, 'Glycosyl hydrolase family 25', NULL, NULL, NULL, NULL, NULL, 4),
(29367, NULL, 'G3DSA:3.90.550.10:FF:000463', NULL, NULL, 'Glycosyltransferase involved in cell wall biogenesis', NULL, NULL, NULL, NULL, NULL, 4),
(29368, NULL, 'G3DSA:3.40.50.1820:FF:001664', NULL, NULL, 'Non-ribosomal peptide synthetase OfaC', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(29369, NULL, 'G3DSA:1.10.3720.10:FF:000035', NULL, NULL, 'Nickel ABC transporter permease subunit NikB', NULL, NULL, NULL, NULL, NULL, 4),
(29370, NULL, 'G3DSA:1.25.10.10:FF:000088', NULL, NULL, 'Splicing factor 3b, subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(29371, NULL, 'G3DSA:2.60.40.60:FF:000695', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(29372, NULL, 'G3DSA:3.50.50.60:FF:000109', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(29373, NULL, 'G3DSA:1.10.510.10:FF:003015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29374, NULL, 'G3DSA:3.40.50.10810:FF:000038', NULL, NULL, 'Protein CHROMATIN REMODELING 19 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(29375, NULL, 'G3DSA:3.80.10.10:FF:001507', NULL, NULL, 'F-box domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(29376, NULL, 'G3DSA:3.40.50.2300:FF:000633', NULL, NULL, 'Glutamate receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(29377, NULL, 'G3DSA:1.25.40.10:FF:000713', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(29378, NULL, 'G3DSA:1.20.58.60:FF:000037', NULL, NULL, 'Spectrin alpha chain non-erythrocytic 1', NULL, NULL, NULL, NULL, NULL, 4),
(29379, NULL, 'G3DSA:3.30.160.60:FF:002518', NULL, NULL, 'Zinc finger protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(29380, NULL, 'G3DSA:3.40.50.1820:FF:000141', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(29381, NULL, 'G3DSA:2.30.30.40:FF:000460', NULL, NULL, 'SH3 domain protein, conserved', NULL, NULL, NULL, NULL, NULL, 4),
(29382, NULL, 'G3DSA:3.40.50.10810:FF:000145', NULL, NULL, 'SWI/SNF related, matrix associated, actin dependent regulator of chromatin, subfamily a like 1', NULL, NULL, NULL, NULL, NULL, 4),
(29383, NULL, 'G3DSA:3.30.70.330:FF:000117', NULL, NULL, 'Nuclear and cytoplasmic polyadenylated RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(29384, NULL, 'G3DSA:1.20.1070.10:FF:000212', NULL, NULL, 'Prostaglandin E2 receptor EP2 subtype', NULL, NULL, NULL, NULL, NULL, 4),
(29385, NULL, 'G3DSA:3.30.450.200:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29386, NULL, 'G3DSA:3.40.190.10:FF:000491', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(29387, NULL, 'G3DSA:3.30.160.60:FF:004648', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29388, NULL, 'G3DSA:1.25.40.20:FF:000716', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29389, NULL, 'G3DSA:2.130.10.10:FF:000809', NULL, NULL, 'Autophagy-related protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(29390, NULL, 'G3DSA:1.10.3210.10:FF:000058', NULL, NULL, 'Guanosine-5''-triphosphate,3''-diphosphate pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(29391, NULL, 'G3DSA:3.40.50.300:FF:002339', NULL, NULL, 'Pre-mRNA-splicing helicase BRR2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29392, NULL, 'G3DSA:3.30.70.330:FF:000224', NULL, NULL, 'Nuclear and cytoplasmic polyadenylated RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(29393, NULL, 'G3DSA:3.90.640.10:FF:000003', NULL, NULL, 'Molecular chaperone DnaK', NULL, NULL, NULL, NULL, NULL, 4),
(29394, NULL, 'G3DSA:3.30.160.60:FF:001321', NULL, NULL, 'Zinc finger protein 652', NULL, NULL, NULL, NULL, NULL, 4),
(29395, NULL, 'G3DSA:1.20.120.720:FF:000031', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(29396, NULL, 'G3DSA:1.20.1280.50:FF:000257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29397, NULL, 'G3DSA:2.60.40.10:FF:004542', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29398, NULL, 'G3DSA:3.40.50.300:FF:008067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29399, NULL, 'G3DSA:3.40.50.1240:FF:000169', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29400, NULL, 'G3DSA:3.80.10.10:FF:003637', NULL, NULL, 'Leucine rich repeat and fibronectin type III domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(29401, NULL, 'G3DSA:3.40.50.300:FF:000198', NULL, NULL, 'Activating signal cointegrator 1 complex subunit', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(29402, NULL, 'G3DSA:1.20.144.10:FF:000065', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(29403, NULL, 'G3DSA:3.40.630.10:FF:000205', NULL, NULL, 'Probable TolB protein', NULL, NULL, NULL, NULL, NULL, 4),
(29404, NULL, 'G3DSA:3.40.970.40:FF:000003', NULL, NULL, 'Fibronectin-binding protein-like protein A', NULL, NULL, NULL, NULL, NULL, 4),
(29405, NULL, 'G3DSA:3.40.50.1820:FF:000028', NULL, NULL, 'S9 family peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(29406, NULL, 'G3DSA:1.20.1250.20:FF:001836', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29407, NULL, 'G3DSA:2.120.10.30:FF:000440', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29408, NULL, 'G3DSA:3.40.50.720:FF:001386', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29409, NULL, 'G3DSA:1.10.238.10:FF:000347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29410, NULL, 'G3DSA:2.170.270.10:FF:000072', NULL, NULL, 'SET (Trithorax/polycomb) domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(29411, NULL, 'G3DSA:3.90.1150.10:FF:000414', NULL, NULL, 'Ornithine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(29412, NULL, 'G3DSA:3.40.50.300:FF:002671', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(29413, NULL, 'G3DSA:1.25.40.720:FF:000011', NULL, NULL, 'Telomere length regulation protein clk-2', NULL, NULL, NULL, NULL, NULL, 4),
(29414, NULL, 'G3DSA:2.130.10.10:FF:005020', NULL, NULL, 'Cilia- and flagella-associated protein 251', NULL, NULL, NULL, NULL, NULL, 4),
(29415, NULL, 'G3DSA:3.30.260.10:FF:000100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29416, NULL, 'G3DSA:2.10.25.10:FF:001395', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29417, NULL, 'G3DSA:2.60.40.150:FF:000739', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(29418, NULL, 'G3DSA:3.90.226.10:FF:000193', NULL, NULL, 'Protein CBG12007', NULL, NULL, NULL, NULL, NULL, 4),
(29419, NULL, 'G3DSA:3.10.10.10:FF:000009', NULL, NULL, 'Protein P', NULL, NULL, NULL, NULL, NULL, 4),
(29420, NULL, 'G3DSA:3.30.870.10:FF:000017', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(29421, NULL, 'G3DSA:1.10.10.10:FF:001886', NULL, NULL, 'Methionine aminopeptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(29422, NULL, 'G3DSA:2.60.120.650:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29423, NULL, 'G3DSA:3.30.420.40:FF:000189', NULL, NULL, 'Actin-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(29424, NULL, 'G3DSA:3.30.450.30:FF:000025', NULL, NULL, 'Dynein light chain roadblock', NULL, NULL, NULL, NULL, NULL, 4),
(29425, NULL, 'G3DSA:3.40.47.10:FF:000290', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29426, NULL, 'G3DSA:1.10.506.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29427, NULL, 'G3DSA:3.90.1490.10:FF:000007', NULL, NULL, 'ATP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29428, NULL, 'G3DSA:3.30.160.60:FF:004974', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29429, NULL, 'G3DSA:2.40.100.10:FF:000091', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(29430, NULL, 'G3DSA:3.40.190.10:FF:000165', NULL, NULL, 'Ferric iron ABC transporter, iron-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(29431, NULL, 'G3DSA:1.10.220.150:FF:000019', NULL, NULL, 'ADP-ribosylation factor GTPase-activating protein AGD1', NULL, NULL, NULL, NULL, NULL, 4),
(29432, NULL, 'G3DSA:1.10.230.10:FF:000009', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(29433, NULL, 'G3DSA:3.40.50.970:FF:000140', NULL, NULL, 'Pyruvate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(29434, NULL, 'G3DSA:2.130.10.10:FF:002272', NULL, NULL, 'YALI0B21054p', NULL, NULL, NULL, NULL, NULL, 4),
(29435, NULL, 'G3DSA:1.20.1050.10:FF:000104', NULL, NULL, 'Glutathione S-transferase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(29436, NULL, 'G3DSA:3.40.50.1970:FF:000045', NULL, NULL, 'Aldehyde-alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(29437, NULL, 'G3DSA:1.25.40.730:FF:000014', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(29438, NULL, 'G3DSA:1.10.472.10:FF:000267', NULL, NULL, 'Cyclin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(29439, NULL, 'G3DSA:3.40.630.10:FF:000188', NULL, NULL, 'Nicalin', NULL, NULL, NULL, NULL, NULL, 4),
(29440, NULL, 'G3DSA:2.30.30.40:FF:000347', NULL, NULL, 'SH3 and cysteine rich domain', NULL, NULL, NULL, NULL, NULL, 4),
(29441, NULL, 'G3DSA:1.20.150.20:FF:000003', NULL, NULL, 'ATP synthase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(29442, NULL, 'G3DSA:3.30.200.20:FF:002016', NULL, NULL, 'Tyrosine-protein kinase Src64B-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(29443, NULL, 'G3DSA:3.40.50.300:FF:006942', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29444, NULL, 'G3DSA:1.25.40.20:FF:000699', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(29445, NULL, 'G3DSA:1.20.1540.10:FF:000063', NULL, NULL, 'Rhomboid family intramembrane serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(29446, NULL, 'G3DSA:3.40.50.300:FF:004812', NULL, NULL, 'Translation initiation factor IF-2 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(29447, NULL, 'G3DSA:3.30.700.10:FF:000016', NULL, NULL, 'Fimbrial protein', NULL, NULL, NULL, NULL, NULL, 4),
(29448, NULL, 'G3DSA:3.30.565.10:FF:000229', NULL, NULL, 'Histidine phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(29449, NULL, 'G3DSA:3.30.50.10:FF:000062', NULL, NULL, 'Related to gata transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(29450, NULL, 'G3DSA:3.80.10.10:FF:002114', NULL, NULL, 'F-box and leucine-rich repeat protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(29451, NULL, 'G3DSA:1.20.1050.10:FF:000211', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(29452, NULL, 'G3DSA:3.30.450.40:FF:000028', NULL, NULL, 'PAS domain S-box', NULL, NULL, NULL, NULL, NULL, 4),
(29453, NULL, 'G3DSA:3.90.110.10:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29454, NULL, 'G3DSA:3.40.140.10:FF:000229', NULL, NULL, 'C6.1A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29455, NULL, 'G3DSA:3.30.200.20:FF:002123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29456, NULL, 'G3DSA:2.60.40.60:FF:000369', NULL, NULL, 'putative protocadherin beta-18', NULL, NULL, NULL, NULL, NULL, 4),
(29457, NULL, 'G3DSA:2.40.70.10:FF:000155', NULL, NULL, 'Eukaryotic aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(29458, NULL, 'G3DSA:3.40.50.720:FF:000082', NULL, NULL, 'Erythronate-4-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(29459, NULL, 'G3DSA:4.10.1310.10:FF:000001', NULL, NULL, 'Dinoflagellate luciferase', NULL, NULL, NULL, NULL, NULL, 4),
(29460, NULL, 'G3DSA:2.60.120.970:FF:000079', NULL, NULL, 'Bone morphogenetic protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29461, NULL, 'G3DSA:3.40.50.720:FF:002223', NULL, NULL, '15-hydroxyprostaglandin dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29462, NULL, 'G3DSA:3.40.47.10:FF:000301', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29463, NULL, 'G3DSA:3.30.160.60:FF:004755', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29464, NULL, 'G3DSA:3.10.110.10:FF:000195', NULL, NULL, 'GD23095', NULL, NULL, NULL, NULL, NULL, 4),
(29465, NULL, 'G3DSA:3.30.56.70:FF:000003', NULL, NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(29466, NULL, 'G3DSA:3.40.50.300:FF:001035', NULL, NULL, 'ABC transporter ATP-binding protein YojI', NULL, NULL, NULL, NULL, NULL, 4),
(29467, NULL, 'G3DSA:1.20.140.150:FF:000049', NULL, NULL, 'GH17940', NULL, NULL, NULL, NULL, NULL, 4),
(29468, NULL, 'G3DSA:1.10.472.10:FF:000610', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29469, NULL, 'G3DSA:4.10.1110.10:FF:000014', NULL, NULL, 'Rhomboid family protease', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(29470, NULL, 'G3DSA:3.30.40.10:FF:001865', NULL, NULL, 'E3 SUMO-protein ligase nse2', NULL, NULL, NULL, NULL, NULL, 4),
(29471, NULL, 'G3DSA:2.60.40.2030:FF:000054', NULL, NULL, 'Adhesion G-protein coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(29472, NULL, 'G3DSA:1.10.10.60:FF:000568', NULL, NULL, 'Pathogenesis-related homeodomain protein', NULL, NULL, NULL, NULL, NULL, 4),
(29473, NULL, 'G3DSA:2.60.40.10:FF:002069', NULL, NULL, 'roundabout homolog 1 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(29474, NULL, 'G3DSA:3.60.21.10:FF:000398', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(29475, NULL, 'G3DSA:2.60.120.650:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29476, NULL, 'G3DSA:1.10.472.10:FF:000380', NULL, NULL, 'Cyclin, N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(29477, NULL, 'G3DSA:3.30.160.60:FF:000596', NULL, NULL, 'zinc finger protein 10 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(29478, NULL, 'G3DSA:1.10.950.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29479, NULL, 'G3DSA:3.90.1150.10:FF:000521', NULL, NULL, 'Golgin candidate 2', NULL, NULL, NULL, NULL, NULL, 4),
(29480, NULL, 'G3DSA:3.30.565.10:FF:000561', NULL, NULL, 'Sensory histidine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(29481, NULL, 'G3DSA:1.10.620.20:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29482, NULL, 'G3DSA:2.20.25.30:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29483, NULL, 'G3DSA:1.10.238.10:FF:000566', NULL, NULL, 'Probable calcium-binding protein CML21', NULL, NULL, NULL, NULL, NULL, 4),
(29484, NULL, 'G3DSA:3.50.50.60:FF:000222', NULL, NULL, 'N,N-dimethylglycine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(29485, NULL, 'G3DSA:1.10.640.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29486, NULL, 'G3DSA:3.40.50.2300:FF:000414', NULL, NULL, 'LppC family lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(29487, NULL, 'G3DSA:2.130.10.10:FF:004289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29488, NULL, 'G3DSA:2.120.10.30:FF:000327', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(29489, NULL, 'G3DSA:3.30.470.20:FF:000023', NULL, NULL, 'Biotin carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(29490, NULL, 'G3DSA:3.30.470.30:FF:000026', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(29491, NULL, 'G3DSA:3.30.1010.10:FF:000047', NULL, NULL, 'Phosphatidylinositol-4,5-bisphosphate 3-kinase catalytic subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29492, NULL, 'G3DSA:3.40.190.10:FF:000272', NULL, NULL, 'Transferrin', NULL, NULL, NULL, NULL, NULL, 4),
(29493, NULL, 'G3DSA:3.40.190.10:FF:000384', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(29494, NULL, 'G3DSA:3.30.160.60:FF:001102', NULL, NULL, 'Transcription factor IIIA', NULL, NULL, NULL, NULL, NULL, 4),
(29495, NULL, 'G3DSA:3.30.1370.10:FF:000208', NULL, NULL, 'KRR1 small subunit processome component homolog-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(29496, NULL, 'G3DSA:2.40.30.270:FF:000025', NULL, NULL, 'DNA polymerase alpha-associated DNA helicase A', NULL, NULL, NULL, NULL, NULL, 4),
(29497, NULL, 'G3DSA:3.40.309.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29498, NULL, 'G3DSA:3.30.1640.10:FF:000078', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(29499, NULL, 'G3DSA:3.40.800.10:FF:000022', NULL, NULL, 'Putative agmatinase', NULL, NULL, NULL, NULL, NULL, 4),
(29500, NULL, 'G3DSA:3.90.70.10:FF:000347', NULL, NULL, 'IgG-degrading protease', NULL, NULL, NULL, NULL, NULL, 4),
(29501, NULL, 'G3DSA:3.30.565.10:FF:000342', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(29502, NULL, 'G3DSA:3.80.10.10:FF:001496', NULL, NULL, 'Leucine rich repeats and IQ motif containing 1', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(29503, NULL, 'G3DSA:2.10.25.10:FF:001406', NULL, NULL, 'Uromodulin-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(29504, NULL, 'G3DSA:3.40.50.720:FF:002004', NULL, NULL, 'Inactive hydroxysteroid dehydrogenase-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(29505, NULL, 'G3DSA:3.90.740.10:FF:000056', NULL, NULL, 'Isoleucine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(29506, NULL, 'G3DSA:3.30.160.60:FF:002850', NULL, NULL, 'Zinc finger protein 462', NULL, NULL, NULL, NULL, NULL, 4),
(29507, NULL, 'G3DSA:1.10.287.110:FF:000058', NULL, NULL, 'Chaperone protein dnaJ GFA2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(29508, NULL, 'G3DSA:2.60.200.20:FF:000271', NULL, NULL, 'FHA domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(29509, NULL, 'G3DSA:1.10.420.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29510, NULL, 'G3DSA:3.30.1490.190:FF:000021', NULL, NULL, 'Fur family transcriptional regulator, ferric uptake regulator', NULL, NULL, NULL, NULL, NULL, 4),
(29511, NULL, 'G3DSA:3.90.1600.10:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29512, NULL, 'G3DSA:1.20.1250.20:FF:001724', NULL, NULL, 'AGAP000046-PA', NULL, NULL, NULL, NULL, NULL, 4),
(29513, NULL, 'G3DSA:2.60.40.1510:FF:000027', NULL, NULL, 'Integrin alpha ina-1', NULL, NULL, NULL, NULL, NULL, 4),
(29514, NULL, 'G3DSA:3.30.160.60:FF:001091', NULL, NULL, 'Zinc finger protein 615', NULL, NULL, NULL, NULL, NULL, 4),
(29515, NULL, 'G3DSA:2.130.10.10:FF:004290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29516, NULL, 'G3DSA:3.10.110.10:FF:000206', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 G1', NULL, NULL, NULL, NULL, NULL, 4),
(29517, NULL, 'G3DSA:3.10.450.30:FF:000001', NULL, NULL, 'Ribonuclease mitogillin', NULL, NULL, NULL, NULL, NULL, 4),
(29518, NULL, 'G3DSA:1.20.1070.10:FF:001954', NULL, NULL, 'Probable muscarinic acetylcholine receptor gar-1', NULL, NULL, NULL, NULL, NULL, 4),
(29519, NULL, 'G3DSA:3.60.21.10:FF:000179', NULL, NULL, 'Serine/threonine protein phosphatase type 5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29520, NULL, 'G3DSA:2.40.160.110:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29521, NULL, 'G3DSA:1.10.472.10:FF:000048', NULL, NULL, 'Retinoblastoma-like 2, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(29522, NULL, 'G3DSA:1.10.150.780:FF:000012', NULL, NULL, 'Probable vacuolar protein sorting-associated protein 16 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(29523, NULL, 'G3DSA:3.90.79.10:FF:000092', NULL, NULL, 'Probable conserved membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(29524, NULL, 'G3DSA:3.20.20.300:FF:000022', NULL, NULL, 'Beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(29525, NULL, 'G3DSA:3.40.50.300:FF:006723', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29526, NULL, 'G3DSA:3.30.70.330:FF:002354', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29527, NULL, 'G3DSA:1.10.10.10:FF:000363', NULL, NULL, 'Vacuolar protein sorting-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(29528, NULL, 'G3DSA:3.10.180.10:FF:000031', NULL, NULL, 'Lactoylglutathione lyase', NULL, NULL, NULL, NULL, NULL, 4),
(29529, NULL, 'G3DSA:2.60.40.10:FF:000944', NULL, NULL, 'Ciliary neurotrophic factor receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(29530, NULL, 'G3DSA:3.40.50.300:FF:004469', NULL, NULL, 'Putative RNA helicase SDE3', NULL, NULL, NULL, NULL, NULL, 4),
(29531, NULL, 'G3DSA:3.30.2170.10:FF:000008', NULL, NULL, 'Endonuclease V', NULL, NULL, NULL, NULL, NULL, 4),
(29532, NULL, 'G3DSA:1.10.510.10:FF:001104', NULL, NULL, 'Unplaced genomic scaffold supercont1.234, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(29533, NULL, 'G3DSA:3.40.50.1100:FF:000268', NULL, NULL, 'Cysteine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(29534, NULL, 'G3DSA:3.30.200.20:FF:002235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29535, NULL, 'G3DSA:2.120.10.30:FF:000108', NULL, NULL, 'NHL domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(29536, NULL, 'G3DSA:3.30.540.10:FF:000026', NULL, NULL, 'Myo-inositol-1(Or 4)-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(29537, NULL, 'G3DSA:3.30.160.60:FF:000484', NULL, NULL, 'zinc finger protein 827 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(29538, NULL, 'G3DSA:2.10.25.10:FF:001176', NULL, NULL, 'AGAP003873-PA', NULL, NULL, NULL, NULL, NULL, 4),
(29539, NULL, 'G3DSA:3.50.50.60:FF:000441', NULL, NULL, 'Putative GMC-type oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(29540, NULL, 'G3DSA:3.80.10.10:FF:001726', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29541, NULL, 'G3DSA:3.10.450.50:FF:000007', NULL, NULL, 'Nuclear transport factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(29542, NULL, 'G3DSA:1.25.40.10:FF:004187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29543, NULL, 'G3DSA:2.60.40.60:FF:000588', NULL, NULL, 'Cadherin-related family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(29544, NULL, 'G3DSA:3.30.160.60:FF:004194', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29545, NULL, 'G3DSA:1.25.40.10:FF:002843', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29546, NULL, 'G3DSA:2.110.10.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29547, NULL, 'G3DSA:3.90.1180.10:FF:000017', NULL, NULL, 'Os03g0755700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(29548, NULL, 'G3DSA:1.10.510.10:FF:000267', NULL, NULL, 'probable LRR receptor-like serine/threonine-protein kinase IRK', NULL, NULL, NULL, NULL, NULL, 4),
(29549, NULL, 'G3DSA:2.130.10.10:FF:000922', NULL, NULL, 'Os11g0132700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(29550, NULL, 'G3DSA:3.90.70.10:FF:000908', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(29551, NULL, 'G3DSA:3.40.30.10:FF:001156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29552, NULL, 'G3DSA:3.40.1090.10:FF:000095', NULL, NULL, 'Patatin', NULL, NULL, NULL, NULL, NULL, 4),
(29553, NULL, 'G3DSA:2.60.40.10:FF:002288', NULL, NULL, 'Carcinoembryonic antigen-related cell adhesion molecule 5', NULL, NULL, NULL, NULL, NULL, 4),
(29554, NULL, 'G3DSA:3.10.450.40:FF:000004', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(29555, NULL, 'G3DSA:1.10.10.60:FF:000911', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29556, NULL, 'G3DSA:3.30.420.40:FF:000425', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(29557, NULL, 'G3DSA:3.80.10.10:FF:003750', NULL, NULL, 'Leucine rich repeat containing 8 VRAC subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(29558, NULL, 'G3DSA:3.30.70.330:FF:001859', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29559, NULL, 'G3DSA:1.10.287.1130:FF:000005', NULL, NULL, 'Cytochrome c oxidase assembly protein subunit 17', NULL, NULL, NULL, NULL, NULL, 4),
(29560, NULL, 'G3DSA:1.10.274.20:FF:000001', NULL, NULL, 'Phenylalanine ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(29561, NULL, 'G3DSA:3.30.710.10:FF:000404', NULL, NULL, 'Rho related BTB domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(29562, NULL, 'G3DSA:2.60.40.1180:FF:000119', NULL, NULL, 'Glucosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29563, NULL, 'G3DSA:2.30.42.10:FF:000017', NULL, NULL, 'Amyloid beta A4 protein-binding family A member 1', NULL, NULL, NULL, NULL, NULL, 4),
(29564, NULL, 'G3DSA:1.10.10.460:FF:000004', NULL, NULL, 'Ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(29565, NULL, 'G3DSA:1.20.58.1220:FF:000011', NULL, NULL, 'Exocyst complex component 8', NULL, NULL, NULL, NULL, NULL, 4),
(29566, NULL, 'G3DSA:3.30.710.10:FF:000062', NULL, NULL, 'potassium voltage-gated channel subfamily C member 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(29567, NULL, 'G3DSA:3.40.190.290:FF:000112', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(29568, NULL, 'G3DSA:1.20.920.20:FF:000017', NULL, NULL, 'Cytoplasmic dynein heavy chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(29569, NULL, 'G3DSA:1.20.120.1750:FF:000094', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(29570, NULL, 'G3DSA:3.40.30.10:FF:000993', NULL, NULL, 'Thioredoxin-like protein HCF164 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(29571, NULL, 'G3DSA:3.30.70.330:FF:002135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29572, NULL, 'G3DSA:2.130.10.10:FF:002491', NULL, NULL, 'Intraflagellar Transport Protein 122', NULL, NULL, NULL, NULL, NULL, 4),
(29573, NULL, 'G3DSA:2.130.10.10:FF:000703', NULL, NULL, 'Cilia- and flagella-associated protein 43', NULL, NULL, NULL, NULL, NULL, 4),
(29574, NULL, 'G3DSA:2.60.40.770:FF:000021', NULL, NULL, 'Lymphocyte antigen 86', NULL, NULL, NULL, NULL, NULL, 4),
(29575, NULL, 'G3DSA:1.10.10.10:FF:000924', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(29576, NULL, 'G3DSA:3.40.50.300:FF:002890', NULL, NULL, 'Protein CBG08006', NULL, NULL, NULL, NULL, NULL, 4),
(29577, NULL, 'G3DSA:3.40.50.1000:FF:000463', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29578, NULL, 'G3DSA:3.30.70.980:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29579, NULL, 'G3DSA:2.60.40.10:FF:002524', NULL, NULL, 'Interleukin 1 receptor-like 1 (ST2L)', NULL, NULL, NULL, NULL, NULL, 4),
(29580, NULL, 'G3DSA:3.30.70.330:FF:000336', NULL, NULL, 'Zinc finger protein 638', NULL, NULL, NULL, NULL, NULL, 4),
(29581, NULL, 'G3DSA:2.60.40.150:FF:000291', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(29582, NULL, 'G3DSA:1.10.510.10:FF:002178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29583, NULL, 'G3DSA:2.60.40.150:FF:000633', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29584, NULL, 'G3DSA:2.60.40.630:FF:000007', NULL, NULL, 'Signal transducer and activator of transcription 3', NULL, NULL, NULL, NULL, NULL, 4),
(29585, NULL, 'G3DSA:3.40.525.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29586, NULL, 'G3DSA:1.10.1420.10:FF:000085', NULL, NULL, 'MutS protein homolog 4', NULL, NULL, NULL, NULL, NULL, 4),
(29587, NULL, 'G3DSA:3.60.15.10:FF:000125', NULL, NULL, 'N-acyl-phosphatidylethanolamine-hydrolyzing phospholipase D', NULL, NULL, NULL, NULL, NULL, 4),
(29588, NULL, 'G3DSA:3.80.10.10:FF:003418', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29589, NULL, 'G3DSA:3.40.50.10810:FF:000257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29590, NULL, 'G3DSA:1.20.1250.20:FF:000201', NULL, NULL, 'Shikimate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(29591, NULL, 'G3DSA:3.90.550.50:FF:000008', NULL, NULL, 'Beta-1,3-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(29592, NULL, 'G3DSA:1.20.120.1900:FF:000066', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(29593, NULL, 'G3DSA:3.90.70.200:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29594, NULL, 'G3DSA:3.30.465.10:FF:000053', NULL, NULL, 'D-lactate dehydrogenase (Cytochrome), putative', NULL, NULL, NULL, NULL, NULL, 4),
(29595, NULL, 'G3DSA:2.130.10.10:FF:002833', NULL, NULL, 'Ribosome biogenesis protein WDR12 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(29596, NULL, 'G3DSA:1.10.10.10:FF:001200', NULL, NULL, 'Putative transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(29597, NULL, 'G3DSA:3.80.10.10:FF:000422', NULL, NULL, 'S-phase kinase associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(29598, NULL, 'G3DSA:3.30.420.110:FF:000053', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(29599, NULL, 'G3DSA:3.40.50.300:FF:007105', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(29600, NULL, 'G3DSA:1.20.142.10:FF:000010', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(29601, NULL, 'G3DSA:3.30.160.60:FF:004536', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29602, NULL, 'G3DSA:1.10.1300.10:FF:000031', NULL, NULL, '3'',5''-cyclic nucleotide phosphodiesterase, putative', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(29603, NULL, 'G3DSA:1.20.120.330:FF:000021', NULL, NULL, 'ARF GTPase-activating protein GIT2', NULL, NULL, NULL, NULL, NULL, 4),
(29604, NULL, 'G3DSA:1.25.40.10:FF:004423', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(29605, NULL, 'G3DSA:2.130.10.10:FF:000579', NULL, NULL, 'Os05g0230600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(29606, NULL, 'G3DSA:1.25.10.10:FF:002454', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29607, NULL, 'G3DSA:1.10.1040.10:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29608, NULL, 'G3DSA:3.80.10.10:FF:000080', NULL, NULL, 'F-box/LRR-repeat protein 20 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(29609, NULL, 'G3DSA:1.25.40.330:FF:000001', NULL, NULL, 'Adenylyl cyclase-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(29610, NULL, 'G3DSA:3.40.367.20:FF:000011', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(29611, NULL, 'G3DSA:2.60.120.260:FF:000416', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(29612, NULL, 'G3DSA:1.10.10.10:FF:000469', NULL, NULL, 'RpiR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(29613, NULL, 'G3DSA:1.25.40.990:FF:000064', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 8 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(29614, NULL, 'G3DSA:2.20.70.10:FF:000105', NULL, NULL, 'Pre-mRNA-processing factor 40, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29615, NULL, 'G3DSA:3.40.50.300:FF:006829', NULL, NULL, 'AGL338Wp', NULL, NULL, NULL, NULL, NULL, 4),
(29616, NULL, 'G3DSA:3.10.20.90:FF:000618', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29617, NULL, 'G3DSA:1.10.10.820:FF:000034', NULL, NULL, 'IP10818p', NULL, NULL, NULL, NULL, NULL, 4),
(29618, NULL, 'G3DSA:3.40.50.300:FF:006049', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(29619, NULL, 'G3DSA:2.40.50.140:FF:000327', NULL, NULL, 'Replication protein A1, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(29620, NULL, 'G3DSA:3.40.50.1820:FF:001445', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(29621, NULL, 'G3DSA:3.30.40.10:FF:001646', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29622, NULL, 'G3DSA:1.10.510.10:FF:004319', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29623, NULL, 'G3DSA:1.25.40.340:FF:000004', NULL, NULL, 'Unplaced genomic scaffold supercont1.18, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(29624, NULL, 'G3DSA:3.30.160.100:FF:000006', NULL, NULL, 'Ribosome-binding factor PSRP1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(29625, NULL, 'G3DSA:1.10.287.110:FF:000390', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29626, NULL, 'G3DSA:2.40.50.140:FF:000440', NULL, NULL, '26S protease regulatory subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(29627, NULL, 'G3DSA:1.10.357.150:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29628, NULL, 'G3DSA:3.40.50.12240:FF:000006', NULL, NULL, 'ATP synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(29629, NULL, 'G3DSA:2.170.270.10:FF:000178', NULL, NULL, 'PR/SET domain 8', NULL, NULL, NULL, NULL, NULL, 4),
(29630, NULL, 'G3DSA:3.40.50.300:FF:002777', NULL, NULL, 'YALI0C20265p', NULL, NULL, NULL, NULL, NULL, 4),
(29631, NULL, 'G3DSA:3.30.300.130:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29632, NULL, 'G3DSA:3.10.20.90:FF:000276', NULL, NULL, '40S ribosomal protein S30', NULL, NULL, NULL, NULL, NULL, 4),
(29633, NULL, 'G3DSA:3.40.50.10700:FF:000005', NULL, NULL, 'D-aminoacyl-tRNA deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(29634, NULL, 'G3DSA:3.30.40.10:FF:000123', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM33', NULL, NULL, NULL, NULL, NULL, 4),
(29635, NULL, 'G3DSA:3.30.505.10:FF:000237', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29636, NULL, 'G3DSA:1.10.10.2010:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(29637, NULL, 'G3DSA:2.40.10.10:FF:000269', NULL, NULL, 'IP10114p', NULL, NULL, NULL, NULL, NULL, 4),
(29638, NULL, 'G3DSA:2.10.25.10:FF:000102', NULL, NULL, 'Protein kinase C-binding protein NELL2', NULL, NULL, NULL, NULL, NULL, 4),
(29639, NULL, 'G3DSA:3.40.630.30:FF:000649', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29640, NULL, 'G3DSA:3.40.50.1240:FF:000063', NULL, NULL, '3-phytase B', NULL, NULL, NULL, NULL, NULL, 4),
(29641, NULL, 'G3DSA:1.25.40.20:FF:001430', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29642, NULL, 'G3DSA:3.30.420.40:FF:000644', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(29643, NULL, 'G3DSA:1.25.40.10:FF:000590', NULL, NULL, 'Ubiquitin-protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29644, NULL, 'G3DSA:3.30.70.1660:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29645, NULL, 'G3DSA:1.10.10.10:FF:000582', NULL, NULL, 'ATP-dependent DNA helicase Q-like 4A', NULL, NULL, NULL, NULL, NULL, 4),
(29646, NULL, 'G3DSA:3.90.79.10:FF:000215', NULL, NULL, 'Nudix hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(29647, NULL, 'G3DSA:3.40.50.12230:FF:000003', NULL, NULL, 'methionyl-tRNA formyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(29648, NULL, 'G3DSA:2.60.120.200:FF:000314', NULL, NULL, 'Adhesion G-protein coupled receptor D1', NULL, NULL, NULL, NULL, NULL, 4),
(29649, NULL, 'G3DSA:1.10.3020.20:FF:000001', NULL, NULL, 'Hydrolase, CocE/NonD family', NULL, NULL, NULL, NULL, NULL, 4),
(29650, NULL, 'G3DSA:3.40.50.300:FF:003053', NULL, NULL, 'Ras family protein', NULL, NULL, NULL, NULL, NULL, 4),
(29651, NULL, 'G3DSA:1.10.1410.40:FF:000020', NULL, NULL, 'Zinc finger RNA-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(29652, NULL, 'G3DSA:2.60.40.60:FF:000931', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29653, NULL, 'G3DSA:3.40.50.1000:FF:000805', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29654, NULL, 'G3DSA:2.60.40.10:FF:002962', NULL, NULL, 'Plexin A2', NULL, NULL, NULL, NULL, NULL, 4),
(29655, NULL, 'G3DSA:3.40.50.300:FF:006487', NULL, NULL, 'Heparan sulfate 2-O-sulfotransferase 1b', NULL, NULL, NULL, NULL, NULL, 4),
(29656, NULL, 'G3DSA:3.30.230.70:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29657, NULL, 'G3DSA:2.60.40.790:FF:000027', NULL, NULL, 'integrin beta-1-binding protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(29658, NULL, 'G3DSA:2.60.40.3390:FF:000001', NULL, NULL, 'Dolichyl-monophosphooligosaccharide--protein glycotransferase AglB', NULL, NULL, NULL, NULL, NULL, 4),
(29659, NULL, 'G3DSA:3.40.50.1580:FF:000035', NULL, NULL, '5-methylthioadenosine nucleosidase, S-adenosylhomocysteine nucleosidase', NULL, NULL, NULL, NULL, NULL, 4),
(29660, NULL, 'G3DSA:3.30.160.60:FF:003013', NULL, NULL, 'Zinc finger protein 329', NULL, NULL, NULL, NULL, NULL, 4),
(29661, NULL, 'G3DSA:3.80.10.10:FF:003076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29662, NULL, 'G3DSA:2.130.10.10:FF:004413', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29663, NULL, 'G3DSA:2.60.40.150:FF:000178', NULL, NULL, 'Bitesize, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(29664, NULL, 'G3DSA:1.25.40.10:FF:000039', NULL, NULL, 'Pre-mRNA processing factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(29665, NULL, 'G3DSA:1.20.58.60:FF:000150', NULL, NULL, 'dystrophin, isoforms A/C/F/G/H isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(29666, NULL, 'G3DSA:2.60.120.650:FF:000207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29667, NULL, 'G3DSA:3.40.630.10:FF:000082', NULL, NULL, 'Nicalin', NULL, NULL, NULL, NULL, NULL, 4),
(29668, NULL, 'G3DSA:2.60.40.10:FF:005958', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29669, NULL, 'G3DSA:3.40.630.10:FF:000424', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29670, NULL, 'G3DSA:3.80.10.10:FF:000203', NULL, NULL, 'Relaxin family peptide receptor 1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(29671, NULL, 'G3DSA:1.25.10.10:FF:002673', NULL, NULL, 'AGAP012049-PA', NULL, NULL, NULL, NULL, NULL, 4),
(29672, NULL, 'G3DSA:2.40.50.140:FF:000108', NULL, NULL, '30S ribosomal protein S17', NULL, NULL, NULL, NULL, NULL, 4),
(29673, NULL, 'G3DSA:3.80.10.10:FF:003856', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(29674, NULL, 'G3DSA:2.60.40.10:FF:004199', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29675, NULL, 'G3DSA:1.10.220.150:FF:000020', NULL, NULL, 'ADP ribosylation factor GTPase activating protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(29676, NULL, 'G3DSA:3.40.50.720:FF:001947', NULL, NULL, '3-oxoacyl-[acyl-carrier protein] reductase', NULL, NULL, NULL, NULL, NULL, 4),
(29677, NULL, 'G3DSA:3.30.160.60:FF:002737', NULL, NULL, 'AGAP008430-PA', NULL, NULL, NULL, NULL, NULL, 4),
(29678, NULL, 'G3DSA:3.30.230.10:FF:000036', NULL, NULL, 'DNA mismatch repair endonuclease MutL', NULL, NULL, NULL, NULL, NULL, 4),
(29679, NULL, 'G3DSA:2.60.120.10:FF:000677', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29680, NULL, 'G3DSA:1.25.40.20:FF:000593', NULL, NULL, 'Transient receptor potential cation channel subfamily A member 1b', NULL, NULL, NULL, NULL, NULL, 4),
(29681, NULL, 'G3DSA:3.60.21.10:FF:000292', NULL, NULL, 'Serine/threonine protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29682, NULL, 'G3DSA:3.40.50.12780:FF:000033', NULL, NULL, 'Long-chain fatty acid--CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(29683, NULL, 'G3DSA:3.30.1490.100:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29684, NULL, 'G3DSA:3.10.20.90:FF:000950', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29685, NULL, 'G3DSA:1.20.1070.10:FF:000431', NULL, NULL, 'NeuroPeptide Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(29686, NULL, 'G3DSA:1.25.40.20:FF:001211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29687, NULL, 'G3DSA:3.10.129.10:FF:000232', NULL, NULL, 'Acyl-[acyl-carrier-protein] hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(29688, NULL, 'G3DSA:1.20.5.190:FF:000064', NULL, NULL, 'Myosin 2', NULL, NULL, NULL, NULL, NULL, 4),
(29689, NULL, 'G3DSA:2.40.30.10:FF:000158', NULL, NULL, 'Elongation factor like GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(29690, NULL, 'G3DSA:3.40.50.1820:FF:000360', NULL, NULL, 'Unplaced genomic scaffold supercont1.23, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(29691, NULL, 'G3DSA:3.40.50.1980:FF:000048', NULL, NULL, 'Manganese ABC transporter substrate-binding lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(29692, NULL, 'G3DSA:3.30.160.60:FF:002395', NULL, NULL, 'Enhancer binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(29693, NULL, 'G3DSA:2.30.38.10:FF:000018', NULL, NULL, 'Peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(29694, NULL, 'G3DSA:2.60.34.10:FF:000104', NULL, NULL, 'Heat shock protein', NULL, NULL, NULL, NULL, NULL, 4),
(29695, NULL, 'G3DSA:3.30.497.10:FF:000172', NULL, NULL, 'Serpin peptidase inhibitor 6', NULL, NULL, NULL, NULL, NULL, 4),
(29696, NULL, 'G3DSA:3.30.500.10:FF:000029', NULL, NULL, 'CD1-2 antigen', NULL, NULL, NULL, NULL, NULL, 4),
(29697, NULL, 'G3DSA:3.30.1520.10:FF:000024', NULL, NULL, 'Neutrophil cytosol factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(29698, NULL, 'G3DSA:2.160.10.10:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29699, NULL, 'G3DSA:3.40.50.620:FF:000052', NULL, NULL, 'Sulfate adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(29700, NULL, 'G3DSA:3.30.200.20:FF:000324', NULL, NULL, 'Serine/threonine-protein kinase Kist isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(29701, NULL, 'G3DSA:3.90.70.10:FF:000802', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29702, NULL, 'G3DSA:3.30.40.10:FF:000342', NULL, NULL, 'Histone deacetylase 6', NULL, NULL, NULL, NULL, NULL, 4),
(29703, NULL, 'G3DSA:2.40.30.10:FF:000377', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(29704, NULL, 'G3DSA:3.40.50.300:FF:002558', NULL, NULL, 'ATP-dependent DNA helicase HrpA', NULL, NULL, NULL, NULL, NULL, 4),
(29705, NULL, 'G3DSA:3.30.2080.10:FF:000001', NULL, NULL, 'Alpha-1,2-mannosidase subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(29706, NULL, 'G3DSA:3.30.70.330:FF:001298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29707, NULL, 'G3DSA:1.25.40.20:FF:000935', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29708, NULL, 'G3DSA:1.10.540.10:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29709, NULL, 'G3DSA:3.40.50.150:FF:001063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29710, NULL, 'G3DSA:2.130.10.10:FF:002159', NULL, NULL, 'Intraflagellar transport 122', NULL, NULL, NULL, NULL, NULL, 4),
(29711, NULL, 'G3DSA:2.60.120.260:FF:000074', NULL, NULL, 'Sad1 and UNC84 domain-containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(29712, NULL, 'G3DSA:3.30.70.330:FF:001972', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29713, NULL, 'G3DSA:3.30.420.140:FF:000033', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(29714, NULL, 'G3DSA:1.25.40.10:FF:000932', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(29715, NULL, 'G3DSA:2.160.20.10:FF:000264', NULL, NULL, 'Os11g0659700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(29716, NULL, 'G3DSA:2.120.10.30:FF:000546', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29717, NULL, 'G3DSA:1.10.460.10:FF:000037', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(29718, NULL, 'G3DSA:1.10.238.10:FF:000802', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(29719, NULL, 'G3DSA:2.30.42.10:FF:000236', NULL, NULL, 'uncharacterized protein LOC108093793 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(29720, NULL, 'G3DSA:2.60.40.1120:FF:000017', NULL, NULL, 'Rhamnogalacturonate lyase A', NULL, NULL, NULL, NULL, NULL, 4),
(29721, NULL, 'G3DSA:3.30.300.330:FF:000002', NULL, NULL, 'Alkyldihydroxyacetonephosphate synthase AgpS', NULL, NULL, NULL, NULL, NULL, 4),
(29722, NULL, 'G3DSA:3.40.30.10:FF:001050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29723, NULL, 'G3DSA:1.20.1070.10:FF:001516', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(29724, NULL, 'G3DSA:1.10.3110.10:FF:000005', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(29725, NULL, 'G3DSA:2.60.40.1110:FF:000014', NULL, NULL, 'Phosphatidylinositol 3,4,5-trisphosphate 3-phosphatase and dual-specificity protein phosphatase daf-18', NULL, NULL, NULL, NULL, NULL, 4),
(29726, NULL, 'G3DSA:1.10.150.320:FF:000003', NULL, NULL, 'Photosystem II complex extrinsic proteinprecursor U', NULL, NULL, NULL, NULL, NULL, 4),
(29727, NULL, 'G3DSA:3.40.30.10:FF:000774', NULL, NULL, 'Bacterioferritin comigrating protein', NULL, NULL, NULL, NULL, NULL, 4),
(29728, NULL, 'G3DSA:3.30.530.20:FF:000079', NULL, NULL, 'START domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(29729, NULL, 'G3DSA:1.20.1310.10:FF:000035', NULL, NULL, 'Ubiquitin ligase subunit CulD, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29730, NULL, 'G3DSA:2.30.30.30:FF:000125', NULL, NULL, '50S ribosomal protein L24, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(29731, NULL, 'G3DSA:3.30.60.30:FF:000237', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(29732, NULL, 'G3DSA:1.25.40.10:FF:004081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29733, NULL, 'G3DSA:1.20.1250.20:FF:000420', NULL, NULL, 'Siderophore transporter', NULL, NULL, NULL, NULL, NULL, 4),
(29734, NULL, 'G3DSA:1.10.510.10:FF:002739', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29735, NULL, 'G3DSA:1.10.760.10:FF:000077', NULL, NULL, 'Membrane-bound dehydrogenase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(29736, NULL, 'G3DSA:3.40.50.150:FF:000787', NULL, NULL, 'Generic methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(29737, NULL, 'G3DSA:3.10.310.10:FF:000070', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(29738, NULL, 'G3DSA:1.25.70.10:FF:000086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29739, NULL, 'G3DSA:1.50.10.20:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29740, NULL, 'G3DSA:1.10.510.10:FF:002397', NULL, NULL, 'Serine/threonine protein kinase-35', NULL, NULL, NULL, NULL, NULL, 4),
(29741, NULL, 'G3DSA:2.40.10.10:FF:000488', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29742, NULL, 'G3DSA:1.20.58.670:FF:000005', NULL, NULL, 'RINT-1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(29743, NULL, 'G3DSA:3.40.50.1000:FF:000682', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29744, NULL, 'G3DSA:3.30.780.10:FF:000010', NULL, NULL, 'Protein translation factor SUI1', NULL, NULL, NULL, NULL, NULL, 4),
(29745, NULL, 'G3DSA:3.10.100.10:FF:000256', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29746, NULL, 'G3DSA:3.80.10.10:FF:004132', NULL, NULL, 'Probable serine/threonine-protein kinase roco5', NULL, NULL, NULL, NULL, NULL, 4),
(29747, NULL, 'G3DSA:3.30.230.130:FF:000077', NULL, NULL, 'Cullin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(29748, NULL, 'G3DSA:3.30.160.60:FF:003232', NULL, NULL, 'Zinc finger domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(29749, NULL, 'G3DSA:3.80.10.10:FF:003295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29750, NULL, 'G3DSA:2.60.40.10:FF:002743', NULL, NULL, 'Beta-N-acetylhexosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(29751, NULL, 'G3DSA:3.20.20.60:FF:000087', NULL, NULL, 'Isocitrate lyase AceAa', NULL, NULL, NULL, NULL, NULL, 4),
(29752, NULL, 'G3DSA:3.40.1440.10:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29753, NULL, 'G3DSA:3.30.160.60:FF:002956', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29754, NULL, 'G3DSA:3.10.129.10:FF:000013', NULL, NULL, 'Peroxisomal multifunctional enzyme type 2', NULL, NULL, NULL, NULL, NULL, 4),
(29755, NULL, 'G3DSA:1.10.30.10:FF:000139', NULL, NULL, 'Polybromo-1', NULL, NULL, NULL, NULL, NULL, 4),
(29756, NULL, 'G3DSA:1.10.510.10:FF:000722', NULL, NULL, 'Protein kinase family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(29757, NULL, 'G3DSA:1.25.40.10:FF:000371', NULL, NULL, 'coatomer subunit epsilon isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(29758, NULL, 'G3DSA:2.30.30.40:FF:000128', NULL, NULL, 'Peroxisomal membrane protein (Pex13)', NULL, NULL, NULL, NULL, NULL, 4),
(29759, NULL, 'G3DSA:4.10.110.20:FF:000003', NULL, NULL, 'Variant surface glycoprotein (VSG), putative', NULL, NULL, NULL, NULL, NULL, 4),
(29760, NULL, 'G3DSA:3.30.750.24:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29761, NULL, 'G3DSA:1.25.40.10:FF:004592', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At1g74400', NULL, NULL, NULL, NULL, NULL, 4),
(29762, NULL, 'G3DSA:1.20.5.990:FF:000017', NULL, NULL, 'TNFAIP3 interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(29763, NULL, 'G3DSA:3.30.160.60:FF:006447', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29764, NULL, 'G3DSA:1.20.1180.10:FF:000001', NULL, NULL, 'Acyl-[acyl-carrier-protein]--UDP-N-acetylglucosamine O-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(29765, NULL, 'G3DSA:2.60.120.10:FF:000351', NULL, NULL, 'Putatve signal peptide protein', NULL, NULL, NULL, NULL, NULL, 4),
(29766, NULL, 'G3DSA:1.25.40.1040:FF:000025', NULL, NULL, 'N-acetyltransferase B complex (NatB) non catalytic subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29767, NULL, 'G3DSA:3.40.50.450:FF:000023', NULL, NULL, 'DNA processing protein DprA', NULL, NULL, NULL, NULL, NULL, 4),
(29768, NULL, 'G3DSA:3.80.10.10:FF:003828', NULL, NULL, 'Si:ch211-191d15.2', NULL, NULL, NULL, NULL, NULL, 4),
(29769, NULL, 'G3DSA:1.25.40.10:FF:004120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29770, NULL, 'G3DSA:1.10.442.10:FF:000001', NULL, NULL, 'Cytochrome c oxidase subunit 4 isoform 1', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(29771, NULL, 'G3DSA:3.40.50.10090:FF:000018', NULL, NULL, 'Transcriptional regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29772, NULL, 'G3DSA:3.30.559.10:FF:000097', NULL, NULL, 'Nonribosomal peptide synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29773, NULL, 'G3DSA:3.40.309.10:FF:000060', NULL, NULL, 'Probable aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(29774, NULL, 'G3DSA:3.40.50.10330:FF:000046', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(29775, NULL, 'G3DSA:3.40.800.10:FF:000033', NULL, NULL, 'Agmatinase', NULL, NULL, NULL, NULL, NULL, 4),
(29776, NULL, 'G3DSA:3.40.30.10:FF:000577', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(29777, NULL, 'G3DSA:2.10.70.10:FF:000280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29778, NULL, 'G3DSA:3.30.160.60:FF:003693', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29779, NULL, 'G3DSA:1.10.238.10:FF:001050', NULL, NULL, 'Calcium-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(29780, NULL, 'G3DSA:2.160.20.10:FF:000337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29781, NULL, 'G3DSA:1.20.1250.20:FF:000066', NULL, NULL, 'Uncharacterized MFS-type transporter YcaD', NULL, NULL, NULL, NULL, NULL, 4),
(29782, NULL, 'G3DSA:1.10.630.10:FF:000141', NULL, NULL, 'Pulcherriminic acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(29783, NULL, 'G3DSA:2.40.160.10:FF:000015', NULL, NULL, 'Mitochondrial import receptor subunit tom40', NULL, NULL, NULL, NULL, NULL, 4),
(29784, NULL, 'G3DSA:2.30.29.30:FF:000346', NULL, NULL, 'Pleckstrin homology domain-containing family H member 2', NULL, NULL, NULL, NULL, NULL, 4),
(29785, NULL, 'G3DSA:3.20.20.70:FF:000533', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29786, NULL, 'G3DSA:3.30.160.20:FF:000123', NULL, NULL, 'Glycosyl hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(29787, NULL, 'G3DSA:3.30.200.20:FF:000650', NULL, NULL, 'PTI1-like tyrosine-protein kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(29788, NULL, 'G3DSA:1.25.40.320:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29789, NULL, 'G3DSA:2.130.10.10:FF:003749', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29790, NULL, 'G3DSA:3.20.20.140:FF:000339', NULL, NULL, 'Glr3518 protein', NULL, NULL, NULL, NULL, NULL, 4),
(29791, NULL, 'G3DSA:1.25.10.10:FF:001419', NULL, NULL, 'Hypothetical nuclear condensin complex subunit 3 (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(29792, NULL, 'G3DSA:3.40.50.300:FF:001485', NULL, NULL, 'LPS ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(29793, NULL, 'G3DSA:3.40.50.1820:FF:000916', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(29794, NULL, 'G3DSA:3.40.50.150:FF:000995', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29795, NULL, 'G3DSA:2.30.42.10:FF:000332', NULL, NULL, 'Leucine-rich repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(29796, NULL, 'G3DSA:3.40.50.300:FF:002474', NULL, NULL, 'SWI/SNF chromatin-remodeling complex subunit snf22', NULL, NULL, NULL, NULL, NULL, 4),
(29797, NULL, 'G3DSA:3.30.40.10:FF:001000', NULL, NULL, 'Protein CBG07411', NULL, NULL, NULL, NULL, NULL, 4),
(29798, NULL, 'G3DSA:3.40.50.410:FF:000118', NULL, NULL, 'Collagen type VI alpha 6 chain', NULL, NULL, NULL, NULL, NULL, 4),
(29799, NULL, 'G3DSA:2.60.120.320:FF:000013', NULL, NULL, 'Thiamine pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(29800, NULL, 'G3DSA:3.30.565.10:FF:000038', NULL, NULL, 'Sensor-like histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(29801, NULL, 'G3DSA:2.60.120.340:FF:000019', NULL, NULL, 'Mitotic apparatus protein p62', NULL, NULL, NULL, NULL, NULL, 4),
(29802, NULL, 'G3DSA:1.10.20.10:FF:000195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29803, NULL, 'G3DSA:3.30.70.330:FF:000398', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(29804, NULL, 'G3DSA:1.10.10.10:FF:001739', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(29805, NULL, 'G3DSA:1.10.510.10:FF:000986', NULL, NULL, 'Protein tyrosine kinase 2aa', NULL, NULL, NULL, NULL, NULL, 4),
(29806, NULL, 'G3DSA:3.90.320.10:FF:000018', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(29807, NULL, 'G3DSA:1.50.40.10:FF:000166', NULL, NULL, 'Mitochondrial Carrier (MC) Family', NULL, NULL, NULL, NULL, NULL, 4),
(29808, NULL, 'G3DSA:2.60.40.10:FF:001647', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(29809, NULL, 'G3DSA:2.170.140.10:FF:000056', NULL, NULL, 'Carbohydrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(29810, NULL, 'G3DSA:1.20.1070.10:FF:002056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29811, NULL, 'G3DSA:3.40.50.2300:FF:001010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29812, NULL, 'G3DSA:1.10.10.2210:FF:000007', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(29813, NULL, 'G3DSA:2.130.10.10:FF:000523', NULL, NULL, 'Transcriptional modulator', NULL, NULL, NULL, NULL, NULL, 4),
(29814, NULL, 'G3DSA:1.20.1740.10:FF:000084', NULL, NULL, 'Amino acid permease', NULL, NULL, NULL, NULL, NULL, 4),
(29815, NULL, 'G3DSA:2.40.100.10:FF:000006', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(29816, NULL, 'G3DSA:3.10.580.10:FF:000095', NULL, NULL, 'Formate transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(29817, NULL, 'G3DSA:3.90.400.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29818, NULL, 'G3DSA:1.10.287.550:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29819, NULL, 'G3DSA:1.25.40.120:FF:000073', NULL, NULL, 'Farnesyltransferase, CAAX box, alpha', NULL, NULL, NULL, NULL, NULL, 4),
(29820, NULL, 'G3DSA:3.30.1640.30:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29821, NULL, 'G3DSA:2.102.10.10:FF:000002', NULL, NULL, 'Nitrite reductase [NAD(P)H] small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(29822, NULL, 'G3DSA:2.40.50.250:FF:000001', NULL, NULL, 'GTP-binding protein TypA', NULL, NULL, NULL, NULL, NULL, 4),
(29823, NULL, 'G3DSA:1.20.920.10:FF:000043', NULL, NULL, 'Transcription initiation factor TFIID subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(29824, NULL, 'G3DSA:3.10.20.90:FF:000208', NULL, NULL, 'Small ubiquitin-related modifier', NULL, NULL, NULL, NULL, NULL, 4),
(29825, NULL, 'G3DSA:1.10.530.10:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29826, NULL, 'G3DSA:2.10.25.10:FF:001221', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(29827, NULL, 'G3DSA:2.10.25.10:FF:001693', NULL, NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(29828, NULL, 'G3DSA:1.20.5.110:FF:000192', NULL, NULL, 'SNAP receptor', NULL, NULL, NULL, NULL, NULL, 4),
(29829, NULL, 'G3DSA:3.40.1160.10:FF:000056', NULL, NULL, 'Kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29830, NULL, 'G3DSA:1.25.10.10:FF:001858', NULL, NULL, 'BRCA1-associated ATM activator 1', NULL, NULL, NULL, NULL, NULL, 4),
(29831, NULL, 'G3DSA:1.20.1070.10:FF:001600', NULL, NULL, 'Taste receptor type 2', NULL, NULL, NULL, NULL, NULL, 4),
(29832, NULL, 'G3DSA:3.20.20.110:FF:000004', NULL, NULL, 'Ribulose bisphosphate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(29833, NULL, 'G3DSA:3.40.50.300:FF:006689', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29834, NULL, 'G3DSA:3.40.630.30:FF:000239', NULL, NULL, 'Acetyltransferase, GNAT family protein', NULL, NULL, NULL, NULL, NULL, 4),
(29835, NULL, 'G3DSA:3.40.50.2300:FF:000021', NULL, NULL, 'Two-component system response regulator KdpE', NULL, NULL, NULL, NULL, NULL, 4),
(29836, NULL, 'G3DSA:1.20.1250.20:FF:001022', NULL, NULL, 'Os07g0131250 protein', NULL, NULL, NULL, NULL, NULL, 4),
(29837, NULL, 'G3DSA:3.80.10.10:FF:002839', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29838, NULL, 'G3DSA:3.40.50.300:FF:006217', NULL, NULL, 'Eukaryotic Elongation Factor, SelenoCysteine-tRNA-specific', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(29839, NULL, 'G3DSA:3.30.40.10:FF:001472', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29840, NULL, 'G3DSA:2.70.98.30:FF:000004', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(29841, NULL, 'G3DSA:3.40.720.10:FF:000032', NULL, NULL, 'Choline sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(29842, NULL, 'G3DSA:3.40.50.2300:FF:000493', NULL, NULL, 'PTS system mannitol-specific transporter subunit EIIBC', NULL, NULL, NULL, NULL, NULL, 4),
(29843, NULL, 'G3DSA:1.20.1250.20:FF:001494', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29844, NULL, 'G3DSA:2.10.110.10:FF:000339', NULL, NULL, 'LIM and SH3 domain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(29845, NULL, 'G3DSA:1.20.58.60:FF:000285', NULL, NULL, 'Spectrin repeat containing nuclear envelope protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(29846, NULL, 'G3DSA:2.40.50.140:FF:001249', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29847, NULL, 'G3DSA:3.30.499.10:FF:000007', NULL, NULL, '3-isopropylmalate dehydratase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(29848, NULL, 'G3DSA:2.40.240.10:FF:000016', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(29849, NULL, 'G3DSA:2.60.40.1280:FF:000003', NULL, NULL, 'Sag1p', NULL, NULL, NULL, NULL, NULL, 4),
(29850, NULL, 'G3DSA:3.80.10.10:FF:000602', NULL, NULL, 'F-box domain containing protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(29851, NULL, 'G3DSA:2.10.25.10:FF:000265', NULL, NULL, 'Dumpy, isoform P', NULL, NULL, NULL, NULL, NULL, 4),
(29852, NULL, 'G3DSA:3.40.50.150:FF:001512', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29853, NULL, 'G3DSA:3.30.160.60:FF:005019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29854, NULL, 'G3DSA:1.10.340.30:FF:000080', NULL, NULL, 'DNA-3-methyladenine glycosylase II, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29855, NULL, 'G3DSA:3.40.1800.20:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29856, NULL, 'G3DSA:3.30.160.60:FF:002232', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(29857, NULL, 'G3DSA:1.10.287.370:FF:000085', NULL, NULL, 'Probable prefoldin subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(29858, NULL, 'G3DSA:3.40.50.1010:FF:000207', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29859, NULL, 'G3DSA:3.30.230.70:FF:000060', NULL, NULL, 'Ribosomal RNA processing protein 45', NULL, NULL, NULL, NULL, NULL, 4),
(29860, NULL, 'G3DSA:3.30.70.240:FF:000051', NULL, NULL, 'U5 small nuclear ribonucleoprotein component, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29861, NULL, 'G3DSA:3.30.230.130:FF:000004', NULL, NULL, 'Cullin 5', NULL, NULL, NULL, NULL, NULL, 4),
(29862, NULL, 'G3DSA:2.60.40.10:FF:003625', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29863, NULL, 'G3DSA:3.30.70.260:FF:000057', NULL, NULL, 'Methionine import ATP-binding protein MetN', NULL, NULL, NULL, NULL, NULL, 4),
(29864, NULL, 'G3DSA:3.80.30.20:FF:000022', NULL, NULL, '(Dimethylallyl)adenosine tRNA methylthiotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(29865, NULL, 'G3DSA:1.10.10.60:FF:000984', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29866, NULL, 'G3DSA:3.40.50.10900:FF:000003', NULL, NULL, 'Proteasome assembly chaperone 2', NULL, NULL, NULL, NULL, NULL, 4),
(29867, NULL, 'G3DSA:2.40.30.10:FF:000383', NULL, NULL, 'Translation elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(29868, NULL, 'G3DSA:3.30.160.60:FF:004210', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29869, NULL, 'G3DSA:2.60.40.60:FF:000892', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29870, NULL, 'G3DSA:3.30.300.30:FF:000071', NULL, NULL, 'Anthranilate--CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(29871, NULL, 'G3DSA:3.40.50.10190:FF:000341', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29872, NULL, 'G3DSA:3.40.50.300:FF:002002', NULL, NULL, 'GTP-binding nuclear protein', NULL, NULL, NULL, NULL, NULL, 4),
(29873, NULL, 'G3DSA:3.40.50.620:FF:000535', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(29874, NULL, 'G3DSA:3.90.550.10:FF:000266', NULL, NULL, 'AT31631p', NULL, NULL, NULL, NULL, NULL, 4),
(29875, NULL, 'G3DSA:1.10.510.10:FF:000514', NULL, NULL, 'Putative receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(29876, NULL, 'G3DSA:4.10.520.10:FF:000020', NULL, NULL, 'Probable DNA-binding protein HU', NULL, NULL, NULL, NULL, NULL, 4),
(29877, NULL, 'G3DSA:3.30.70.330:FF:001354', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29878, NULL, 'G3DSA:1.20.5.320:FF:000018', NULL, NULL, '6-phosphogluconate dehydrogenase, decarboxylating', NULL, NULL, NULL, NULL, NULL, 4),
(29879, NULL, 'G3DSA:3.90.190.10:FF:000283', NULL, NULL, 'Protein-tyrosine-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(29880, NULL, 'G3DSA:1.20.930.20:FF:000018', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 8', NULL, NULL, NULL, NULL, NULL, 4),
(29881, NULL, 'G3DSA:2.60.260.20:FF:000038', NULL, NULL, 'DnaJ heat shock protein family (Hsp40) member B4', NULL, NULL, NULL, NULL, NULL, 4),
(29882, NULL, 'G3DSA:2.70.150.10:FF:000154', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(29883, NULL, 'G3DSA:2.130.10.10:FF:000995', NULL, NULL, 'WD repeat domain 27', NULL, NULL, NULL, NULL, NULL, 4),
(29884, NULL, 'G3DSA:3.30.365.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29885, NULL, 'G3DSA:3.20.20.140:FF:000491', NULL, NULL, 'Error-prone DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(29886, NULL, 'G3DSA:1.10.390.40:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29887, NULL, 'G3DSA:1.20.58.80:FF:000032', NULL, NULL, 'Os02g0159900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(29888, NULL, 'G3DSA:1.10.1040.10:FF:000117', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(29889, NULL, 'G3DSA:3.40.50.300:FF:008134', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(29890, NULL, 'G3DSA:3.40.50.300:FF:007206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29891, NULL, 'G3DSA:1.20.1440.90:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29892, NULL, 'G3DSA:1.10.10.60:FF:000512', NULL, NULL, 'Pyruvate carboxylase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(29893, NULL, 'G3DSA:3.40.250.10:FF:000187', NULL, NULL, 'Thiosulfate sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(29894, NULL, 'G3DSA:1.25.40.10:FF:001247', NULL, NULL, 'TPR repeat/Tetratricopeptide repeat', NULL, NULL, NULL, NULL, NULL, 4),
(29895, NULL, 'G3DSA:1.20.1260.140:FF:000002', NULL, NULL, 'Alternative oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(29896, NULL, 'G3DSA:3.30.1330.10:FF:000015', NULL, NULL, 'Hydrogenase expression/formation protein HypE', NULL, NULL, NULL, NULL, NULL, 4),
(29897, NULL, 'G3DSA:2.60.490.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29898, NULL, 'G3DSA:1.25.10.10:FF:002847', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29899, NULL, 'G3DSA:3.30.70.2570:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29900, NULL, 'G3DSA:3.40.50.970:FF:000117', NULL, NULL, 'Transketolase', NULL, NULL, NULL, NULL, NULL, 4),
(29901, NULL, 'G3DSA:3.40.50.1470:FF:000002', NULL, NULL, 'Putative aminoacyl-tRNA hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(29902, NULL, 'G3DSA:2.60.40.10:FF:005542', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29903, NULL, 'G3DSA:3.40.50.300:FF:000057', NULL, NULL, 'GTPase Der', NULL, NULL, NULL, NULL, NULL, 4),
(29904, NULL, 'G3DSA:3.90.550.50:FF:000019', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(29905, NULL, 'G3DSA:3.30.830.10:FF:000026', NULL, NULL, 'Cytochrome b-c1 complex subunit 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(29906, NULL, 'G3DSA:3.30.200.20:FF:001459', NULL, NULL, 'Probable serine/threonine-protein kinase ifkB', NULL, NULL, NULL, NULL, NULL, 4),
(29907, NULL, 'G3DSA:3.30.160.60:FF:001276', NULL, NULL, 'zinc finger protein 425', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(29908, NULL, 'G3DSA:2.60.120.20:FF:000028', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(29909, NULL, 'G3DSA:1.10.720.60:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29910, NULL, 'G3DSA:3.40.50.10480:FF:000012', NULL, NULL, 'U3 small nucleolar ribonucleoprotein protein IMP4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(29911, NULL, 'G3DSA:3.50.50.60:FF:000992', NULL, NULL, 'Neither inactivation nor afterpotential protein G', NULL, NULL, NULL, NULL, NULL, 4),
(29912, NULL, 'G3DSA:2.20.100.10:FF:000229', NULL, NULL, 'Putative semaphorin', NULL, NULL, NULL, NULL, NULL, 4),
(29913, NULL, 'G3DSA:1.20.1070.10:FF:000139', NULL, NULL, 'RPE-retinal G protein-coupled receptor isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(29914, NULL, 'G3DSA:1.10.287.70:FF:000545', NULL, NULL, 'Cytochrome c oxidase subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(29915, NULL, 'G3DSA:3.40.190.10:FF:000569', NULL, NULL, 'Hydroxymethylbilane synthase (Porphobilinogen deaminase)', NULL, NULL, NULL, NULL, NULL, 4),
(29916, NULL, 'G3DSA:3.30.40.10:FF:000483', NULL, NULL, 'E3 ubiquitin-protein ligase SINAT3', NULL, NULL, NULL, NULL, NULL, 4),
(29917, NULL, 'G3DSA:3.10.129.10:FF:000058', NULL, NULL, 'Sterigmatocystin biosynthesis fatty acid synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(29918, NULL, 'G3DSA:2.20.25.10:FF:000124', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(29919, NULL, 'G3DSA:3.40.50.1820:FF:001052', NULL, NULL, 'Retinoid-inducible serine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(29920, NULL, 'G3DSA:1.10.720.30:FF:000007', NULL, NULL, 'X-ray repair cross complementing 6', NULL, NULL, NULL, NULL, NULL, 4),
(29921, NULL, 'G3DSA:3.40.1360.10:FF:000037', NULL, NULL, 'Twinkle homolog protein, chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(29922, NULL, 'G3DSA:3.30.390.30:FF:000048', NULL, NULL, 'Apoptosis-inducing factor 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(29923, NULL, 'G3DSA:1.20.1560.10:FF:000839', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29924, NULL, 'G3DSA:1.25.40.20:FF:000115', NULL, NULL, 'Ankyrin repeat and BTB/POZ domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(29925, NULL, 'G3DSA:1.10.260.100:FF:000035', NULL, NULL, 'Stress-induced phosphoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(29926, NULL, 'G3DSA:1.10.238.10:FF:000914', NULL, NULL, 'EF-hand calcium-binding domain-containing protein 6-like', NULL, NULL, NULL, NULL, NULL, 4),
(29927, NULL, 'G3DSA:1.10.287.130:FF:000125', NULL, NULL, 'Signal transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(29928, NULL, 'G3DSA:1.10.10.10:FF:000430', NULL, NULL, 'Transcription factor E2F4', NULL, NULL, NULL, NULL, NULL, 4),
(29929, NULL, 'G3DSA:1.20.1070.10:FF:001067', NULL, NULL, 'G-protein coupled receptor GRL101-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(29930, NULL, 'G3DSA:1.25.40.180:FF:000304', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29931, NULL, 'G3DSA:3.40.50.720:FF:000739', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(29932, NULL, 'G3DSA:3.10.120.10:FF:000038', NULL, NULL, 'Nitrate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(29933, NULL, 'G3DSA:1.10.510.10:FF:003892', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29934, NULL, 'G3DSA:3.80.10.10:FF:003036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29935, NULL, 'G3DSA:3.40.50.300:FF:003463', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(29936, NULL, 'G3DSA:3.40.50.11840:FF:000015', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(29937, NULL, 'G3DSA:1.25.40.10:FF:000258', NULL, NULL, 'DnaJ domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(29938, NULL, 'G3DSA:1.10.565.10:FF:000101', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(29939, NULL, 'G3DSA:3.40.50.300:FF:007145', NULL, NULL, 'Mitochondrial escape protein 2', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(29940, NULL, 'G3DSA:1.20.120.1080:FF:000056', NULL, NULL, 'probable ATP-dependent RNA helicase DHX34', NULL, NULL, NULL, NULL, NULL, 4),
(29941, NULL, 'G3DSA:1.20.120.1760:FF:000046', NULL, NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(29942, NULL, 'G3DSA:1.25.10.10:FF:003336', NULL, NULL, 'Ecm29p', NULL, NULL, NULL, NULL, NULL, 4),
(29943, NULL, 'G3DSA:3.30.160.60:FF:005458', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29944, NULL, 'G3DSA:2.60.40.60:FF:000420', NULL, NULL, 'Cadherin 74A, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(29945, NULL, 'G3DSA:2.170.300.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29946, NULL, 'G3DSA:3.40.50.510:FF:000002', NULL, NULL, 'PTS-dependent dihydroxyacetone kinase, DhaM subunit', NULL, NULL, NULL, NULL, NULL, 4),
(29947, NULL, 'G3DSA:3.60.130.10:FF:000050', NULL, NULL, 'Butyrobetaine (gamma), 2-oxoglutarate dioxygenase (gamma-butyrobetaine hydroxylase) 1', NULL, NULL, NULL, NULL, NULL, 4),
(29948, NULL, 'G3DSA:1.20.1250.20:FF:000858', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29949, NULL, 'G3DSA:3.10.20.280:FF:000001', NULL, NULL, 'Protein RnfH', NULL, NULL, NULL, NULL, NULL, 4),
(29950, NULL, 'G3DSA:3.30.200.20:FF:001959', NULL, NULL, 'CMGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(29951, NULL, 'G3DSA:1.10.287.110:FF:000406', NULL, NULL, 'DnaJ homolog subfamily C member 11 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(29952, NULL, 'G3DSA:3.40.50.720:FF:002364', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29953, NULL, 'G3DSA:3.30.70.20:FF:000049', NULL, NULL, '4Fe-4S dicluster domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(29954, NULL, 'G3DSA:2.120.10.30:FF:000350', NULL, NULL, 'Peptidylglycine alpha-amidating monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(29955, NULL, 'G3DSA:2.60.40.10:FF:005981', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29956, NULL, 'G3DSA:2.30.29.30:FF:000785', NULL, NULL, 'Syntrophin alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(29957, NULL, 'G3DSA:3.40.50.2000:FF:000993', NULL, NULL, 'Os05g0527600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(29958, NULL, 'G3DSA:3.40.50.720:FF:001728', NULL, NULL, 'Homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(29959, NULL, 'G3DSA:3.30.1050.10:FF:000033', NULL, NULL, 'Os01g0357200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(29960, NULL, 'G3DSA:1.10.287.110:FF:000086', NULL, NULL, 'Chaperone protein dnaJ 10', NULL, NULL, NULL, NULL, NULL, 4),
(29961, NULL, 'G3DSA:2.60.40.10:FF:002636', NULL, NULL, '2 (Zwei) IG domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(29962, NULL, 'G3DSA:1.10.3200.20:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29963, NULL, 'G3DSA:3.30.160.60:FF:000787', NULL, NULL, 'Zinc finger protein 784', NULL, NULL, NULL, NULL, NULL, 4),
(29964, NULL, 'G3DSA:3.40.50.300:FF:001838', NULL, NULL, 'Protein GCN20', NULL, NULL, NULL, NULL, NULL, 4),
(29965, NULL, 'G3DSA:1.20.1070.10:FF:001128', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(29966, NULL, 'G3DSA:1.25.10.10:FF:000610', NULL, NULL, 'Exportin 1', NULL, NULL, NULL, NULL, NULL, 4),
(29967, NULL, 'G3DSA:1.20.58.150:FF:000006', NULL, NULL, 'putative clathrin assembly protein At5g35200', NULL, NULL, NULL, NULL, NULL, 4),
(29968, NULL, 'G3DSA:2.60.120.10:FF:000790', NULL, NULL, 'Cyclic nucleotide-binding domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(29969, NULL, 'G3DSA:2.30.30.40:FF:000420', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(29970, NULL, 'G3DSA:3.30.200.20:FF:002448', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(29971, NULL, 'G3DSA:1.25.40.10:FF:002203', NULL, NULL, 'Uncharacterized protein OSJNBa0026C08.24', NULL, NULL, NULL, NULL, NULL, 4),
(29972, NULL, 'G3DSA:3.40.50.1820:FF:001113', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(29973, NULL, 'G3DSA:3.40.50.920:FF:000035', NULL, NULL, 'Putative 2-ketoglutarate ferredoxin oxidoreductase (Alpha)', NULL, NULL, NULL, NULL, NULL, 4),
(29974, NULL, 'G3DSA:3.30.470.10:FF:000043', NULL, NULL, 'Branched-chain amino-acid transaminase, putative (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(29975, NULL, 'G3DSA:3.40.50.410:FF:000270', NULL, NULL, 'DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(29976, NULL, 'G3DSA:2.130.10.10:FF:003396', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(29977, NULL, 'G3DSA:3.30.930.10:FF:000123', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(29978, NULL, 'G3DSA:3.10.50.40:FF:000015', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(29979, NULL, 'G3DSA:3.40.50.2300:FF:001269', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29980, NULL, 'G3DSA:1.10.510.10:FF:001183', NULL, NULL, 'CAMK/CAMKL protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(29981, NULL, 'G3DSA:3.30.9.10:FF:000039', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(29982, NULL, 'G3DSA:1.10.510.10:FF:001503', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(29983, NULL, 'G3DSA:1.25.40.10:FF:000730', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(29984, NULL, 'G3DSA:2.130.10.10:FF:004205', NULL, NULL, 'Plexin B1b', NULL, NULL, NULL, NULL, NULL, 4),
(29985, NULL, 'G3DSA:1.20.1270.60:FF:000293', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29986, NULL, 'G3DSA:3.30.160.60:FF:003221', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29987, NULL, 'G3DSA:1.20.1070.10:FF:000291', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(29988, NULL, 'G3DSA:3.30.40.10:FF:000544', NULL, NULL, 'FYVE, RhoGEF and PH domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(29989, NULL, 'G3DSA:1.20.1070.10:FF:000611', NULL, NULL, 'NMUR (NeuroMedin U Receptor) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(29990, NULL, 'G3DSA:1.10.10.800:FF:000005', NULL, NULL, 'Alpha/beta superfamily hydrolase, putative (AFU_orthologue AFUA_2G16580)', NULL, NULL, NULL, NULL, NULL, 4),
(29991, NULL, 'G3DSA:3.40.50.11610:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29992, NULL, 'G3DSA:2.40.50.550:FF:000001', NULL, NULL, 'Tetratricopeptide repeat domain 5', NULL, NULL, NULL, NULL, NULL, 4),
(29993, NULL, 'G3DSA:3.40.50.970:FF:000089', NULL, NULL, 'Putative indole-3-pyruvate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(29994, NULL, 'G3DSA:1.20.1560.10:FF:000778', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29995, NULL, 'G3DSA:1.10.132.20:FF:000020', NULL, NULL, 'Putative ribosomal recycling factor, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(29996, NULL, 'G3DSA:1.20.58.60:FF:000638', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(29997, NULL, 'G3DSA:2.60.40.10:FF:003125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(29998, NULL, 'G3DSA:1.20.900.10:FF:000013', NULL, NULL, 'FYVE, RhoGEF and PH domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(29999, NULL, 'G3DSA:1.20.5.1430:FF:000018', NULL, NULL, 'EB1-like C-terminal motif containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(30000, NULL, 'G3DSA:1.10.8.1310:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30001, NULL, 'G3DSA:1.10.287.1490:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30002, NULL, 'G3DSA:3.40.50.300:FF:000557', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(30003, NULL, 'G3DSA:3.60.20.10:FF:000177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30004, NULL, 'G3DSA:3.30.40.10:FF:000983', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30005, NULL, 'G3DSA:1.10.3720.10:FF:000147', NULL, NULL, 'Phosphate ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(30006, NULL, 'G3DSA:1.10.287.3240:FF:000008', NULL, NULL, 'V-type H+-transporting ATPase subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(30007, NULL, 'G3DSA:1.10.533.10:FF:000230', NULL, NULL, 'Putative BOI-related E3 ubiquitin-protein ligase 3', NULL, NULL, NULL, NULL, NULL, 4),
(30008, NULL, 'G3DSA:3.40.50.150:FF:000170', NULL, NULL, 'Probable methyltransferase PMT6', NULL, NULL, NULL, NULL, NULL, 4),
(30009, NULL, 'G3DSA:1.10.10.10:FF:001678', NULL, NULL, 'SirR/DtxR family transcription regulator Idr1', NULL, NULL, NULL, NULL, NULL, 4),
(30010, NULL, 'G3DSA:1.10.510.10:FF:003920', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30011, NULL, 'G3DSA:1.10.238.10:FF:000414', NULL, NULL, 'CAMK/CDPK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(30012, NULL, 'G3DSA:3.30.160.60:FF:005519', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30013, NULL, 'G3DSA:2.60.40.10:FF:000719', NULL, NULL, 'nephrin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(30014, NULL, 'G3DSA:3.60.10.10:FF:000384', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30015, NULL, 'G3DSA:3.20.20.190:FF:000073', NULL, NULL, 'WGS project CABT00000000 data, contig 2.28', NULL, NULL, NULL, NULL, NULL, 4),
(30016, NULL, 'G3DSA:2.40.50.140:FF:001188', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30017, NULL, 'G3DSA:1.10.1420.10:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30018, NULL, 'G3DSA:1.25.10.10:FF:001066', NULL, NULL, 'Exportin-4', NULL, NULL, NULL, NULL, NULL, 4),
(30019, NULL, 'G3DSA:3.40.50.300:FF:000849', NULL, NULL, 'ATP-dependent RNA helicase DBP5', NULL, NULL, NULL, NULL, NULL, 4),
(30020, NULL, 'G3DSA:1.25.40.20:FF:001104', NULL, NULL, 'Ankyrin repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(30021, NULL, 'G3DSA:2.130.10.10:FF:001451', NULL, NULL, 'Autophagy-related protein 18g', NULL, NULL, NULL, NULL, NULL, 4),
(30022, NULL, 'G3DSA:1.25.40.10:FF:002675', NULL, NULL, 'Coatomer subunit epsilon-1', NULL, NULL, NULL, NULL, NULL, 4),
(30023, NULL, 'G3DSA:3.40.1190.20:FF:000066', NULL, NULL, 'PfkB-type carbohydrate kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(30024, NULL, 'G3DSA:1.10.8.270:FF:000096', NULL, NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', NULL, NULL, NULL, NULL, NULL, 4),
(30025, NULL, 'G3DSA:1.10.10.60:FF:000012', NULL, NULL, 'Metastasis-associated 1 family, member 3', NULL, NULL, NULL, NULL, NULL, 4),
(30026, NULL, 'G3DSA:3.20.20.80:FF:000362', NULL, NULL, 'Putative 4-alpha-glucanotransferase / amylo-1,6-glucosidase (Glycogen-debranching enzyme)', NULL, NULL, NULL, NULL, NULL, 4),
(30027, NULL, 'G3DSA:1.25.40.10:FF:005081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30028, NULL, 'G3DSA:2.60.40.10:FF:003564', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30029, NULL, 'G3DSA:1.10.287.70:FF:000045', NULL, NULL, 'Glutamate receptor, ionotropic, delta 2', NULL, NULL, NULL, NULL, NULL, 4),
(30030, NULL, 'G3DSA:3.40.1500.10:FF:000009', NULL, NULL, 'Coproporphyrinogen-III oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(30031, NULL, 'G3DSA:2.60.120.200:FF:000562', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(30032, NULL, 'G3DSA:3.80.10.10:FF:004464', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30033, NULL, 'G3DSA:2.60.120.260:FF:000001', NULL, NULL, 'Ephrin type-A receptor 7', NULL, NULL, NULL, NULL, NULL, 4),
(30034, NULL, 'G3DSA:1.10.472.10:FF:000149', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(30035, NULL, 'G3DSA:3.10.490.20:FF:000006', NULL, NULL, 'Dynein axonemal heavy chain 10', NULL, NULL, NULL, NULL, NULL, 4),
(30036, NULL, 'G3DSA:3.40.50.150:FF:000462', NULL, NULL, 'Methyltransferase-like protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(30037, NULL, 'G3DSA:3.30.565.10:FF:000538', NULL, NULL, 'Two component signal transduction system histidine kinase with CHASE and PAS sensory domains', NULL, NULL, NULL, NULL, NULL, 4),
(30038, NULL, 'G3DSA:2.130.10.10:FF:005666', NULL, NULL, 'Glr0823 protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(30039, NULL, 'G3DSA:2.60.40.10:FF:002136', NULL, NULL, 'Blast:CD109 antigen', NULL, NULL, NULL, NULL, NULL, 4),
(30040, NULL, 'G3DSA:2.130.10.10:FF:002940', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30041, NULL, 'G3DSA:3.40.1000.10:FF:000016', NULL, NULL, 'PsbP domain-containing protein 3, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(30042, NULL, 'G3DSA:3.30.160.60:FF:000287', NULL, NULL, 'PR domain zinc finger protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(30043, NULL, 'G3DSA:1.25.40.20:FF:000087', NULL, NULL, 'Ankyrin repeat domain-containing protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(30044, NULL, 'G3DSA:1.10.510.10:FF:002431', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30045, NULL, 'G3DSA:3.30.465.10:FF:000093', NULL, NULL, 'FAD-linked oxidoreductase afoF', NULL, NULL, NULL, NULL, NULL, 4),
(30046, NULL, 'G3DSA:3.30.200.20:FF:000178', NULL, NULL, 'serine/threonine-protein kinase PBS1-like', NULL, NULL, NULL, NULL, NULL, 4),
(30047, NULL, 'G3DSA:3.80.10.10:FF:000282', NULL, NULL, 'Nucleotide-binding oligomerization domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(30048, NULL, 'G3DSA:3.50.30.30:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30049, NULL, 'G3DSA:1.10.10.10:FF:001239', NULL, NULL, 'Cullin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(30050, NULL, 'G3DSA:3.90.1170.20:FF:000008', NULL, NULL, 'Probable nicotinate-nucleotide pyrophosphorylase [carboxylating]', NULL, NULL, NULL, NULL, NULL, 4),
(30051, NULL, 'G3DSA:3.30.40.10:FF:001500', NULL, NULL, 'Ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(30052, NULL, 'G3DSA:3.40.50.150:FF:000023', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(30053, NULL, 'G3DSA:2.60.120.1040:FF:000004', NULL, NULL, 'Zinc finger protein ZPR1', NULL, NULL, NULL, NULL, NULL, 4),
(30054, NULL, 'G3DSA:3.90.640.10:FF:000065', NULL, NULL, 'Heat shock protein', NULL, NULL, NULL, NULL, NULL, 4),
(30055, NULL, 'G3DSA:3.30.420.40:FF:000700', NULL, NULL, 'Carbohydrate kinase FGGY', NULL, NULL, NULL, NULL, NULL, 4),
(30056, NULL, 'G3DSA:1.20.1310.10:FF:000147', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30057, NULL, 'G3DSA:2.130.10.30:FF:000029', NULL, NULL, 'Secretion-regulating guanine nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(30058, NULL, 'G3DSA:1.25.40.10:FF:001186', NULL, NULL, 'OSJNBa0006B20.8 protein', NULL, NULL, NULL, NULL, NULL, 4),
(30059, NULL, 'G3DSA:3.30.50.10:FF:000129', NULL, NULL, 'Nuclear receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(30060, NULL, 'G3DSA:1.10.520.10:FF:000020', NULL, NULL, 'Peroxisomal ascorbate peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(30061, NULL, 'G3DSA:3.30.540.30:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30062, NULL, 'G3DSA:3.10.110.10:FF:000212', NULL, NULL, 'Ubiquitin E2 (Conjugating enzyme) variant', NULL, NULL, NULL, NULL, NULL, 4),
(30063, NULL, 'G3DSA:3.20.20.70:FF:000180', NULL, NULL, 'Epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(30064, NULL, 'G3DSA:1.10.510.10:FF:000486', NULL, NULL, 'E3 ubiquitin-protein ligase KEG', NULL, NULL, NULL, NULL, NULL, 4),
(30065, NULL, 'G3DSA:3.90.190.10:FF:000311', NULL, NULL, 'Protein CBG15664', NULL, NULL, NULL, NULL, NULL, 4),
(30066, NULL, 'G3DSA:2.50.20.10:FF:000005', NULL, NULL, 'Outer membrane lipoprotein carrier protein LolA', NULL, NULL, NULL, NULL, NULL, 4),
(30067, NULL, 'G3DSA:1.20.1420.10:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30068, NULL, 'G3DSA:1.20.1110.10:FF:000227', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(30069, NULL, 'G3DSA:1.25.40.20:FF:001576', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(30070, NULL, 'G3DSA:3.40.50.1820:FF:000416', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(30071, NULL, 'G3DSA:1.20.1070.10:FF:002117', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(30072, NULL, 'G3DSA:1.10.472.80:FF:000209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30073, NULL, 'G3DSA:3.10.100.10:FF:000155', NULL, NULL, 'Serum lectin isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(30074, NULL, 'G3DSA:3.40.50.170:FF:000029', NULL, NULL, 'Phosphoribosylglycinamide formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(30075, NULL, 'G3DSA:1.10.287.70:FF:000192', NULL, NULL, 'Glutamate receptor, ionotropic kainate', NULL, NULL, NULL, NULL, NULL, 4),
(30076, NULL, 'G3DSA:2.115.10.20:FF:000011', NULL, NULL, 'Glycosyl hydrolases family 32 superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(30077, NULL, 'G3DSA:3.80.10.10:FF:000574', NULL, NULL, 'Jetlag, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(30078, NULL, 'G3DSA:1.10.510.10:FF:001003', NULL, NULL, 'STE/STE20 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(30079, NULL, 'G3DSA:1.10.1040.50:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30080, NULL, 'G3DSA:1.10.150.780:FF:000006', NULL, NULL, 'Probable vacuolar protein sorting-associated protein 16 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(30081, NULL, 'G3DSA:3.30.750.24:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30082, NULL, 'G3DSA:3.40.50.1460:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30083, NULL, 'G3DSA:3.90.1110.10:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30084, NULL, 'G3DSA:2.130.10.10:FF:000170', NULL, NULL, 'lethal(2) giant larvae protein homolog 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(30085, NULL, 'G3DSA:3.20.20.70:FF:000472', NULL, NULL, 'N,N''-diacetyllegionaminic acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(30086, NULL, 'G3DSA:3.30.565.10:FF:000510', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(30087, NULL, 'G3DSA:3.90.190.10:FF:000603', NULL, NULL, 'Protein tyrosine phosphatase 69D, drome, putative', NULL, NULL, NULL, NULL, NULL, 4),
(30088, NULL, 'G3DSA:1.25.40.10:FF:003956', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30089, NULL, 'G3DSA:3.30.70.330:FF:002343', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30090, NULL, 'G3DSA:1.25.10.10:FF:001919', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(30091, NULL, 'G3DSA:3.30.420.110:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30092, NULL, 'G3DSA:2.10.220.10:FF:000201', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(30093, NULL, 'G3DSA:3.40.30.10:FF:000605', NULL, NULL, 'Glutaredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(30094, NULL, 'G3DSA:1.20.120.810:FF:000007', NULL, NULL, 'Vinculin', NULL, NULL, NULL, NULL, NULL, 4),
(30095, NULL, 'G3DSA:1.25.40.420:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30096, NULL, 'G3DSA:3.40.250.10:FF:000007', NULL, NULL, 'Thiosulfate sulfurtransferase GlpE', NULL, NULL, NULL, NULL, NULL, 4),
(30097, NULL, 'G3DSA:1.10.10.60:FF:000804', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30098, NULL, 'G3DSA:3.90.660.10:FF:000095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30099, NULL, 'G3DSA:3.30.559.70:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30100, NULL, 'G3DSA:3.40.640.10:FF:000470', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30101, NULL, 'G3DSA:3.90.70.10:FF:000881', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30102, NULL, 'G3DSA:3.90.700.10:FF:000003', NULL, NULL, 'Fumarate reductase flavoprotein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(30103, NULL, 'G3DSA:3.30.460.50:FF:000003', NULL, NULL, 'RNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(30104, NULL, 'G3DSA:3.30.160.270:FF:000012', NULL, NULL, 'Putative 2-isopropylmalate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(30105, NULL, 'G3DSA:3.90.1580.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(30106, NULL, 'G3DSA:1.10.472.10:FF:000121', NULL, NULL, 'Transcription factor IIIB', NULL, NULL, NULL, NULL, NULL, 4),
(30107, NULL, 'G3DSA:3.40.50.1000:FF:000530', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30108, NULL, 'G3DSA:3.30.40.10:FF:000191', NULL, NULL, 'Chromodomain helicase DNA binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(30109, NULL, 'G3DSA:1.20.1280.50:FF:000049', NULL, NULL, 'F-box protein 41', NULL, NULL, NULL, NULL, NULL, 4),
(30110, NULL, 'G3DSA:2.60.40.10:FF:005250', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30111, NULL, 'G3DSA:1.25.40.10:FF:003164', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(30112, NULL, 'G3DSA:2.80.10.50:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30113, NULL, 'G3DSA:3.40.50.2300:FF:001510', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30114, NULL, 'G3DSA:3.40.5.10:FF:000008', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(30115, NULL, 'G3DSA:3.10.100.10:FF:000447', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30116, NULL, 'G3DSA:3.30.70.3250:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30117, NULL, 'G3DSA:3.40.50.20:FF:000025', NULL, NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(30118, NULL, 'G3DSA:3.30.710.10:FF:000079', NULL, NULL, 'Kelch-like family, member 42', NULL, NULL, NULL, NULL, NULL, 4),
(30119, NULL, 'G3DSA:2.130.10.10:FF:005374', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30120, NULL, 'G3DSA:1.10.510.10:FF:001975', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30121, NULL, 'G3DSA:3.40.50.300:FF:005380', NULL, NULL, 'ATP binding cassette subfamily B member 4', NULL, NULL, NULL, NULL, NULL, 4),
(30122, NULL, 'G3DSA:3.30.70.100:FF:000003', NULL, NULL, 'Protein NipSnap homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(30123, NULL, 'G3DSA:1.20.1250.20:FF:001314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30124, NULL, 'G3DSA:3.30.70.330:FF:001707', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30125, NULL, 'G3DSA:3.40.50.300:FF:004891', NULL, NULL, 'Si:dkey-120c6.5', NULL, NULL, NULL, NULL, NULL, 4),
(30126, NULL, 'G3DSA:2.40.170.20:FF:000081', NULL, NULL, 'SusC/RagA family TonB-linked outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(30127, NULL, 'G3DSA:1.20.5.710:FF:000012', NULL, NULL, 'CG5012', NULL, NULL, NULL, NULL, NULL, 4),
(30128, NULL, 'G3DSA:2.80.10.50:FF:000280', NULL, NULL, 'Cellulase containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(30129, NULL, 'G3DSA:1.10.1410.10:FF:000045', NULL, NULL, 'poly(A) RNA polymerase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(30130, NULL, 'G3DSA:2.10.10.20:FF:000009', NULL, NULL, 'Chitin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(30131, NULL, 'G3DSA:3.30.420.10:FF:000332', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(30132, NULL, 'G3DSA:3.80.10.10:FF:002108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30133, NULL, 'G3DSA:1.20.1260.10:FF:000002', NULL, NULL, 'Ferritin, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(30134, NULL, 'G3DSA:2.60.40.60:FF:000392', NULL, NULL, 'Cadherin 2', NULL, NULL, NULL, NULL, NULL, 4),
(30135, NULL, 'G3DSA:3.40.630.10:FF:000233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30136, NULL, 'G3DSA:2.130.10.10:FF:003688', NULL, NULL, 'F-box/WD repeat-containing protein mec-15', NULL, NULL, NULL, NULL, NULL, 4),
(30137, NULL, 'G3DSA:2.60.40.150:FF:000335', NULL, NULL, 'No pollen', NULL, NULL, NULL, NULL, NULL, 4),
(30138, NULL, 'G3DSA:2.10.25.10:FF:001193', NULL, NULL, 'Laminin subunit gamma 1', NULL, NULL, NULL, NULL, NULL, 4),
(30139, NULL, 'G3DSA:3.60.10.10:FF:000092', NULL, NULL, 'Type I inositol polyphosphate 5-phosphatase 5', NULL, NULL, NULL, NULL, NULL, 4),
(30140, NULL, 'G3DSA:3.40.50.2000:FF:001010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(30141, NULL, 'G3DSA:2.130.10.10:FF:004738', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30142, NULL, 'G3DSA:2.60.40.10:FF:001208', NULL, NULL, 'Hibris, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(30143, NULL, 'G3DSA:3.40.50.1260:FF:000057', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(30144, NULL, 'G3DSA:3.30.505.10:FF:000181', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30145, NULL, 'G3DSA:3.40.120.10:FF:000003', NULL, NULL, 'Phosphoglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(30146, NULL, 'G3DSA:3.40.50.300:FF:004711', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30147, NULL, 'G3DSA:2.130.10.10:FF:001479', NULL, NULL, 'BnaA02g13180D protein', NULL, NULL, NULL, NULL, NULL, 4),
(30148, NULL, 'G3DSA:3.30.40.10:FF:000836', NULL, NULL, 'RING-H2 finger protein ATL40', NULL, NULL, NULL, NULL, NULL, 4),
(30149, NULL, 'G3DSA:1.25.40.180:FF:000276', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30150, NULL, 'G3DSA:3.30.505.10:FF:000029', NULL, NULL, 'Suppressor of cytokine signaling 7', NULL, NULL, NULL, NULL, NULL, 4),
(30151, NULL, 'G3DSA:3.80.10.10:FF:001058', NULL, NULL, 'Protein phosphatase 1 regulatory subunit SDS22', NULL, NULL, NULL, NULL, NULL, 4),
(30152, NULL, 'G3DSA:3.30.160.60:FF:004710', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30153, NULL, 'G3DSA:1.20.5.110:FF:000012', NULL, NULL, 'Mitofusin 2', NULL, NULL, NULL, NULL, NULL, 4),
(30154, NULL, 'G3DSA:3.30.70.120:FF:000009', NULL, NULL, 'ATP phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(30155, NULL, 'G3DSA:3.90.79.10:FF:000018', NULL, NULL, '39S ribosomal protein L46, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(30156, NULL, 'G3DSA:3.40.50.2000:FF:000521', NULL, NULL, 'Scopoletin glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(30157, NULL, 'G3DSA:1.20.80.10:FF:000063', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(30158, NULL, 'G3DSA:2.130.10.10:FF:000815', NULL, NULL, 'Aladin WD repeat nucleoporin', NULL, NULL, NULL, NULL, NULL, 4),
(30159, NULL, 'G3DSA:3.40.50.1820:FF:000596', NULL, NULL, 'Putative lipase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(30160, NULL, 'G3DSA:1.20.1270.60:FF:000321', NULL, NULL, 'Ubp4-interactor sfp47', NULL, NULL, NULL, NULL, NULL, 4),
(30161, NULL, 'G3DSA:2.60.40.10:FF:002928', NULL, NULL, 'Contactin 2', NULL, NULL, NULL, NULL, NULL, 4),
(30162, NULL, 'G3DSA:1.10.418.10:FF:000007', NULL, NULL, 'Microtubule-associated protein, RP/EB family, member 2', NULL, NULL, NULL, NULL, NULL, 4),
(30163, NULL, 'G3DSA:3.50.50.60:FF:001037', NULL, NULL, 'Leucine zipper like transcription regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(30164, NULL, 'G3DSA:3.40.47.10:FF:000200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30165, NULL, 'G3DSA:3.90.70.40:FF:000013', NULL, NULL, 'JOSephin Domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(30166, NULL, 'G3DSA:2.30.30.140:FF:000157', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(30167, NULL, 'G3DSA:1.25.40.280:FF:000008', NULL, NULL, 'Unplaced genomic scaffold supercont1.16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(30168, NULL, 'G3DSA:1.20.1250.20:FF:000566', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30169, NULL, 'G3DSA:3.20.20.70:FF:000033', NULL, NULL, 'Pyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(30170, NULL, 'G3DSA:3.30.70.270:FF:000239', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30171, NULL, 'G3DSA:3.80.10.10:FF:004317', NULL, NULL, 'Toll-like receptor 13', NULL, NULL, NULL, NULL, NULL, 4),
(30172, NULL, 'G3DSA:3.30.1010.10:FF:000087', NULL, NULL, 'Serine/threonine-protein kinase MEC1', NULL, NULL, NULL, NULL, NULL, 4),
(30173, NULL, 'G3DSA:3.40.50.300:FF:002502', NULL, NULL, 'Protein TRIGALACTOSYLDIACYLGLYCEROL 3, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(30174, NULL, 'G3DSA:1.10.10.10:FF:001386', NULL, NULL, 'Forkhead transcription factor required for pathogenic development', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(30175, NULL, 'G3DSA:1.10.238.10:FF:000122', NULL, NULL, 'Centrin 3', NULL, NULL, NULL, NULL, NULL, 4),
(30176, NULL, 'G3DSA:3.40.50.40:FF:000003', NULL, NULL, 'L-asparaginase 2', NULL, NULL, NULL, NULL, NULL, 4),
(30177, NULL, 'G3DSA:1.25.10.10:FF:001358', NULL, NULL, 'Exportin-T', NULL, NULL, NULL, NULL, NULL, 4),
(30178, NULL, 'G3DSA:1.25.10.10:FF:003044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30179, NULL, 'G3DSA:1.10.565.10:FF:000073', NULL, NULL, 'Retinoic acid receptor beta', NULL, NULL, NULL, NULL, NULL, 4),
(30180, NULL, 'G3DSA:3.30.1490.180:FF:000001', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(30181, NULL, 'G3DSA:1.25.40.860:FF:000002', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(30182, NULL, 'G3DSA:3.40.50.300:FF:005228', NULL, NULL, '50S ribosome-binding GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(30183, NULL, 'G3DSA:3.30.160.60:FF:001304', NULL, NULL, 'Zinc finger protein 366', NULL, NULL, NULL, NULL, NULL, 4),
(30184, NULL, 'G3DSA:1.10.3590.10:FF:000001', NULL, NULL, 'acid-sensing ion channel 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(30185, NULL, 'G3DSA:3.10.20.90:FF:000360', NULL, NULL, 'Auxin-responsive protein', NULL, NULL, NULL, NULL, NULL, 4),
(30186, NULL, 'G3DSA:3.40.630.30:FF:000391', NULL, NULL, 'Histone acetyltransferase ESA1', NULL, NULL, NULL, NULL, NULL, 4),
(30187, NULL, 'G3DSA:2.60.40.10:FF:006026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30188, NULL, 'G3DSA:3.40.50.2000:FF:001038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30189, NULL, 'G3DSA:1.10.437.10:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30190, NULL, 'G3DSA:3.40.30.10:FF:000869', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30191, NULL, 'G3DSA:3.40.140.10:FF:000033', NULL, NULL, 'AMSH-like protease sst2', NULL, NULL, NULL, NULL, NULL, 4),
(30192, NULL, 'G3DSA:1.10.287.2250:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30193, NULL, 'G3DSA:3.40.50.720:FF:002425', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30194, NULL, 'G3DSA:3.30.160.60:FF:006155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30195, NULL, 'G3DSA:2.60.40.10:FF:001355', NULL, NULL, 'Down syndrome cell adhesion molecule-like protein Dscam2', NULL, NULL, NULL, NULL, NULL, 4),
(30196, NULL, 'G3DSA:2.60.220.50:FF:000168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30197, NULL, 'G3DSA:3.10.129.10:FF:000030', NULL, NULL, 'Acyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(30198, NULL, 'G3DSA:1.25.10.10:FF:003275', NULL, NULL, 'Elongation factor 3 (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(30199, NULL, 'G3DSA:3.30.60.30:FF:000052', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(30200, NULL, 'G3DSA:1.25.40.10:FF:004884', NULL, NULL, 'Os01g0390600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(30201, NULL, 'G3DSA:1.20.1050.80:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30202, NULL, 'G3DSA:1.20.1420.30:FF:000015', NULL, NULL, 'sodium/potassium/calcium exchanger 5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(30203, NULL, 'G3DSA:3.30.160.60:FF:003513', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30204, NULL, 'G3DSA:1.20.1070.10:FF:000639', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30205, NULL, 'G3DSA:3.40.50.10190:FF:000369', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30206, NULL, 'G3DSA:3.90.1300.10:FF:000005', NULL, NULL, 'Fatty-acid amide hydrolase 2', NULL, NULL, NULL, NULL, NULL, 4),
(30207, NULL, 'G3DSA:2.30.39.10:FF:000133', NULL, NULL, 'Serpin peptidase inhibitor clade I neuroserpin member 1', NULL, NULL, NULL, NULL, NULL, 4),
(30208, NULL, 'G3DSA:2.170.9.10:FF:000001', NULL, NULL, 'Hexon protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(30209, NULL, 'G3DSA:3.60.21.10:FF:000140', NULL, NULL, 'LPXTG cell wall anchor domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(30210, NULL, 'G3DSA:3.40.50.2300:FF:001302', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30211, NULL, 'G3DSA:2.130.10.10:FF:003457', NULL, NULL, 'Neutral sphingomyelinase activation-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(30212, NULL, 'G3DSA:3.30.200.110:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30213, NULL, 'G3DSA:3.30.420.40:FF:000728', NULL, NULL, 'Actin-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(30214, NULL, 'G3DSA:2.70.50.30:FF:000001', NULL, NULL, 'Rho GDP-dissociation inhibitor 1', NULL, NULL, NULL, NULL, NULL, 4),
(30215, NULL, 'G3DSA:3.40.250.10:FF:000215', NULL, NULL, 'TBC domain-containing protein kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(30216, NULL, 'G3DSA:2.170.300.10:FF:000030', NULL, NULL, 'Multiple epidermal growth factor-like domains protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(30217, NULL, 'G3DSA:3.90.132.10:FF:000025', NULL, NULL, 'GP63-like', NULL, NULL, NULL, NULL, NULL, 4),
(30218, NULL, 'G3DSA:3.40.50.2000:FF:000813', NULL, NULL, 'Trehalose-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(30219, NULL, 'G3DSA:2.30.30.30:FF:000030', NULL, NULL, '60S ribosomal protein L14', NULL, NULL, NULL, NULL, NULL, 4),
(30220, NULL, 'G3DSA:3.40.50.150:FF:000231', NULL, NULL, 'mRNA cap guanine-N7 methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(30221, NULL, 'G3DSA:3.40.50.300:FF:007706', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30222, NULL, 'G3DSA:3.90.245.10:FF:000040', NULL, NULL, 'Uridine nucleosidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(30223, NULL, 'G3DSA:2.40.70.10:FF:000357', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30224, NULL, 'G3DSA:3.40.50.10130:FF:000019', NULL, NULL, '(Xeroderma Pigmentosum group F) DNA repair gene homolog', NULL, NULL, NULL, NULL, NULL, 4),
(30225, NULL, 'G3DSA:3.80.10.10:FF:000310', NULL, NULL, 'leucine-rich repeat-containing protein 23', NULL, NULL, NULL, NULL, NULL, 4),
(30226, NULL, 'G3DSA:3.50.50.60:FF:000492', NULL, NULL, 'Aklavinone 12-hydroxylase RdmE', NULL, NULL, NULL, NULL, NULL, 4),
(30227, NULL, 'G3DSA:3.40.980.10:FF:000017', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(30228, NULL, 'G3DSA:2.130.10.10:FF:005166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30229, NULL, 'G3DSA:3.30.720.90:FF:000002', NULL, NULL, '60S ribosomal proteins L38', NULL, NULL, NULL, NULL, NULL, 4),
(30230, NULL, 'G3DSA:2.30.30.30:FF:000119', NULL, NULL, '60S ribosomal protein L14', NULL, NULL, NULL, NULL, NULL, 4),
(30231, NULL, 'G3DSA:3.30.160.60:FF:002996', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30232, NULL, 'G3DSA:3.55.50.30:FF:000034', NULL, NULL, 'Putative anti-sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(30233, NULL, 'G3DSA:1.25.10.10:FF:001566', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30234, NULL, 'G3DSA:1.10.3210.10:FF:000064', NULL, NULL, 'HDIG domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(30235, NULL, 'G3DSA:2.30.29.30:FF:000493', NULL, NULL, 'AGC/AKT protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(30236, NULL, 'G3DSA:3.20.20.105:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30237, NULL, 'G3DSA:1.20.5.170:FF:000131', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(30238, NULL, 'G3DSA:3.40.50.720:FF:001436', NULL, NULL, 'Aspartate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(30239, NULL, 'G3DSA:1.20.1250.20:FF:001786', NULL, NULL, 'Major facilitator superfamily multidrug transporter mdr3', NULL, NULL, NULL, NULL, NULL, 4),
(30240, NULL, 'G3DSA:3.40.50.300:FF:001338', NULL, NULL, 'Type VII secretion protein EccC', NULL, NULL, NULL, NULL, NULL, 4),
(30241, NULL, 'G3DSA:3.30.70.330:FF:001646', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(30242, NULL, 'G3DSA:1.20.1070.10:FF:001628', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30243, NULL, 'G3DSA:3.40.50.300:FF:003963', NULL, NULL, 'Recombination factor protein RarA', NULL, NULL, NULL, NULL, NULL, 4),
(30244, NULL, 'G3DSA:1.20.5.110:FF:000220', NULL, NULL, 'Vesicle-associated membrane protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(30245, NULL, 'G3DSA:1.10.506.10:FF:000055', NULL, NULL, 'Ras GTPase-activating-like protein, IQGAP family member, putative', NULL, NULL, NULL, NULL, NULL, 4),
(30246, NULL, 'G3DSA:2.130.10.10:FF:000231', NULL, NULL, 'Anaphase-promoting complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(30247, NULL, 'G3DSA:3.40.718.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30248, NULL, 'G3DSA:2.30.40.10:FF:000142', NULL, NULL, 'Amidohydrolase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(30249, NULL, 'G3DSA:1.10.150.220:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30250, NULL, 'G3DSA:3.40.50.1820:FF:001613', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30251, NULL, 'G3DSA:3.30.70.330:FF:001062', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(30252, NULL, 'G3DSA:1.20.120.350:FF:000055', NULL, NULL, 'Two pore calcium channel protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(30253, NULL, 'G3DSA:3.30.420.10:FF:000624', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30254, NULL, 'G3DSA:3.30.160.60:FF:001804', NULL, NULL, 'E4F transcription factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(30255, NULL, 'G3DSA:3.40.50.300:FF:008073', NULL, NULL, 'Dynein heavy chain 3', NULL, NULL, NULL, NULL, NULL, 4),
(30256, NULL, 'G3DSA:1.25.40.20:FF:001604', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(30257, NULL, 'G3DSA:3.30.1330.40:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30258, NULL, 'G3DSA:3.50.30.20:FF:000001', NULL, NULL, 'Carbamoyl-phosphate synthase small chain', NULL, NULL, NULL, NULL, NULL, 4),
(30259, NULL, 'G3DSA:3.80.10.10:FF:004525', NULL, NULL, 'Fbxl18 protein', NULL, NULL, NULL, NULL, NULL, 4),
(30260, NULL, 'G3DSA:1.10.510.10:FF:001683', NULL, NULL, 'Protein kinase domain containing protein expressed', NULL, NULL, NULL, NULL, NULL, 4),
(30261, NULL, 'G3DSA:2.170.130.30:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30262, NULL, 'G3DSA:1.25.40.10:FF:000230', NULL, NULL, 'Clustered mitochondria protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(30263, NULL, 'G3DSA:1.25.10.10:FF:001830', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(30264, NULL, 'G3DSA:3.40.1390.20:FF:000014', NULL, NULL, 'Inorganic pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(30265, NULL, 'G3DSA:3.90.550.10:FF:000558', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30266, NULL, 'G3DSA:1.10.8.60:FF:000264', NULL, NULL, '26S protease regulatory subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(30267, NULL, 'G3DSA:3.30.1330.20:FF:000052', NULL, NULL, 'FtsZ', NULL, NULL, NULL, NULL, NULL, 4),
(30268, NULL, 'G3DSA:1.10.150.200:FF:000001', NULL, NULL, 'Malto-oligosyltrehalose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(30269, NULL, 'G3DSA:3.40.50.2300:FF:000785', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30270, NULL, 'G3DSA:3.40.630.30:FF:000211', NULL, NULL, 'Histone acetyltransferase Elp3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(30271, NULL, 'G3DSA:1.20.1250.20:FF:000358', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(30272, NULL, 'G3DSA:3.40.1810.10:FF:000027', NULL, NULL, 'Os01g0213300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(30273, NULL, 'G3DSA:3.30.70.330:FF:000218', NULL, NULL, 'RNA-binding motif protein, X-linked 2', NULL, NULL, NULL, NULL, NULL, 4),
(30274, NULL, 'G3DSA:3.30.470.20:FF:000225', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(30275, NULL, 'G3DSA:1.10.10.10:FF:001711', NULL, NULL, 'Arginine repressor', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(30276, NULL, 'G3DSA:2.40.128.700:FF:000002', NULL, NULL, 'Fatty acid synthase beta subunit aflB', NULL, NULL, NULL, NULL, NULL, 4),
(30277, NULL, 'G3DSA:1.20.1560.10:FF:000547', NULL, NULL, 'ABC transporter atnG', NULL, NULL, NULL, NULL, NULL, 4),
(30278, NULL, 'G3DSA:1.25.10.10:FF:000138', NULL, NULL, 'Putative HEAT repeat-containing protein 5B', NULL, NULL, NULL, NULL, NULL, 4),
(30279, NULL, 'G3DSA:1.10.150.120:FF:000011', NULL, NULL, '(2Fe-2S)-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(30280, NULL, 'G3DSA:1.20.5.370:FF:000011', NULL, NULL, 'DNA repair protein XRCC4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(30281, NULL, 'G3DSA:1.10.600.10:FF:000021', NULL, NULL, 'Farnesyl pyrophosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(30282, NULL, 'G3DSA:2.60.40.10:FF:003917', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30283, NULL, 'G3DSA:1.20.58.1380:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30284, NULL, 'G3DSA:3.50.50.60:FF:000020', NULL, NULL, 'D-amino acid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(30285, NULL, 'G3DSA:3.40.50.1110:FF:000063', NULL, NULL, 'SGNH hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(30286, NULL, 'G3DSA:3.40.50.300:FF:001193', NULL, NULL, 'Rab family, other', NULL, NULL, NULL, NULL, NULL, 4),
(30287, NULL, 'G3DSA:3.30.160.60:FF:002524', NULL, NULL, 'Zinc finger protein 705F', NULL, NULL, NULL, NULL, NULL, 4),
(30288, NULL, 'G3DSA:1.25.40.120:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30289, NULL, 'G3DSA:3.40.720.10:FF:000324', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30290, NULL, 'G3DSA:3.30.40.10:FF:001764', NULL, NULL, 'E3 ubiquitin-protein ligase RNF43', NULL, NULL, NULL, NULL, NULL, 4),
(30291, NULL, 'G3DSA:1.50.10.10:FF:000046', NULL, NULL, 'Cellobionic acid phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(30292, NULL, 'G3DSA:2.90.10.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30293, NULL, 'G3DSA:1.10.510.10:FF:004437', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30294, NULL, 'G3DSA:1.10.510.10:FF:003009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30295, NULL, 'G3DSA:3.90.550.50:FF:000199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30296, NULL, 'G3DSA:3.80.10.10:FF:002491', NULL, NULL, 'Toll-like receptor 13', NULL, NULL, NULL, NULL, NULL, 4),
(30297, NULL, 'G3DSA:1.20.58.60:FF:000577', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30298, NULL, 'G3DSA:1.20.1250.20:FF:002303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30299, NULL, 'G3DSA:1.20.1070.10:FF:000791', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(30300, NULL, 'G3DSA:3.30.70.2610:FF:000004', NULL, NULL, 'General transcription factor IIH subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(30301, NULL, 'G3DSA:2.60.120.200:FF:000354', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(30302, NULL, 'G3DSA:2.30.29.30:FF:001010', NULL, NULL, 'Motor AXon guidance', NULL, NULL, NULL, NULL, NULL, 4),
(30303, NULL, 'G3DSA:1.20.120.1080:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30304, NULL, 'G3DSA:3.40.50.1010:FF:000179', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30305, NULL, 'G3DSA:3.40.50.720:FF:002217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30306, NULL, 'G3DSA:3.30.70.330:FF:002051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30307, NULL, 'G3DSA:1.10.3080.10:FF:000002', NULL, NULL, 'Chloride channel 2c', NULL, NULL, NULL, NULL, NULL, 4),
(30308, NULL, 'G3DSA:1.20.1280.120:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30309, NULL, 'G3DSA:1.20.1740.10:FF:000112', NULL, NULL, 'Large neutral amino acids transporter small subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(30310, NULL, 'G3DSA:1.10.555.10:FF:000044', NULL, NULL, 'Rho-gtpase-activating protein 8', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(30311, NULL, 'G3DSA:2.60.40.10:FF:002075', NULL, NULL, 'Jitterbug, isoform N', NULL, NULL, NULL, NULL, NULL, 4),
(30312, NULL, 'G3DSA:3.90.1200.10:FF:000060', NULL, NULL, 'Hydroxylysine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(30313, NULL, 'G3DSA:1.20.58.1120:FF:000015', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(30314, NULL, 'G3DSA:4.10.140.10:FF:000002', NULL, NULL, 'Coagulation factor II (thrombin)', NULL, NULL, NULL, NULL, NULL, 4),
(30315, NULL, 'G3DSA:3.30.1120.30:FF:000016', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(30316, NULL, 'G3DSA:3.20.20.10:FF:000061', NULL, NULL, 'Pyridoxal phosphate homeostasis protein', NULL, NULL, NULL, NULL, NULL, 4),
(30317, NULL, 'G3DSA:3.30.950.10:FF:000006', NULL, NULL, 'Multifunctional uroporphyrin-III C-methyltransferase/precorrin-2 oxidase/ferrochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(30318, NULL, 'G3DSA:2.60.40.10:FF:004261', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30319, NULL, 'G3DSA:3.30.9.10:FF:000011', NULL, NULL, 'pyruvate dehydrogenase phosphatase regulatory subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(30320, NULL, 'G3DSA:3.40.50.10140:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30321, NULL, 'G3DSA:3.40.50.11180:FF:000003', NULL, NULL, 'Transcription-repair-coupling factor', NULL, NULL, NULL, NULL, NULL, 4),
(30322, NULL, 'G3DSA:3.40.50.150:FF:001479', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30323, NULL, 'G3DSA:2.40.290.10:FF:000019', NULL, NULL, 'ATP-dependent DNA helicase 2 subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(30324, NULL, 'G3DSA:3.30.450.30:FF:000019', NULL, NULL, 'Profilin', NULL, NULL, NULL, NULL, NULL, 4),
(30325, NULL, 'G3DSA:2.60.120.380:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30326, NULL, 'G3DSA:3.30.559.10:FF:000125', NULL, NULL, 'Carnitine palmitoyltransferase 1C', NULL, NULL, NULL, NULL, NULL, 4),
(30327, NULL, 'G3DSA:1.10.1200.10:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30328, NULL, 'G3DSA:3.80.10.10:FF:002339', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(30329, NULL, 'G3DSA:3.30.40.10:FF:002017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30330, NULL, 'G3DSA:2.60.40.10:FF:003333', NULL, NULL, 'Uncharacterized loc548369', NULL, NULL, NULL, NULL, NULL, 4),
(30331, NULL, 'G3DSA:3.40.50.850:FF:000019', NULL, NULL, 'Alpha/beta-hydrolase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(30332, NULL, 'G3DSA:1.20.1270.10:FF:000059', NULL, NULL, 'Chaperone protein DnaK', NULL, NULL, NULL, NULL, NULL, 4),
(30333, NULL, 'G3DSA:2.40.30.180:FF:000004', NULL, NULL, 'Ubiquitin activating enzyme, E1 family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(30334, NULL, 'G3DSA:3.40.50.1820:FF:000888', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(30335, NULL, 'G3DSA:3.40.50.1000:FF:000822', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30336, NULL, 'G3DSA:1.10.565.10:FF:000129', NULL, NULL, 'Nuclear receptor', NULL, NULL, NULL, NULL, NULL, 4),
(30337, NULL, 'G3DSA:1.10.10.200:FF:000005', NULL, NULL, 'POL polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(30338, NULL, 'G3DSA:2.60.40.420:FF:000028', NULL, NULL, 'Ceruloplasmin', NULL, NULL, NULL, NULL, NULL, 4),
(30339, NULL, 'G3DSA:3.40.50.300:FF:002974', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(30340, NULL, 'G3DSA:3.90.1750.10:FF:000033', NULL, NULL, 'E3 ubiquitin-protein ligase hecd-1', NULL, NULL, NULL, NULL, NULL, 4),
(30341, NULL, 'G3DSA:2.60.40.60:FF:000009', NULL, NULL, 'Cadherin 24', NULL, NULL, NULL, NULL, NULL, 4),
(30342, NULL, 'G3DSA:3.30.200.20:FF:000150', NULL, NULL, 'serine/threonine-protein kinase BRI1-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(30343, NULL, 'G3DSA:3.20.20.80:FF:000570', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30344, NULL, 'G3DSA:3.20.20.20:FF:000007', NULL, NULL, 'Methionine synthase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(30345, NULL, 'G3DSA:3.20.20.140:FF:000311', NULL, NULL, 'Guanine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(30346, NULL, 'G3DSA:3.60.40.10:FF:000301', NULL, NULL, 'Alanine aminotransferase 2 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(30347, NULL, 'G3DSA:3.30.70.20:FF:000021', NULL, NULL, 'MauM/NapG family ferredoxin-type protein', NULL, NULL, NULL, NULL, NULL, 4),
(30348, NULL, 'G3DSA:3.30.70.2740:FF:000015', NULL, NULL, 'FAD-dependent oxidoreductase (GlcD/DLD_GlcF/GlpC domain fusion protein)', NULL, NULL, NULL, NULL, NULL, 4),
(30349, NULL, 'G3DSA:1.20.1560.10:FF:000811', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30350, NULL, 'G3DSA:2.70.130.10:FF:000063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30351, NULL, 'G3DSA:1.10.260.60:FF:000003', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', NULL, NULL, NULL, NULL, NULL, 4),
(30352, NULL, 'G3DSA:1.10.238.10:FF:000353', NULL, NULL, 'Probable calcium-binding protein CML31', NULL, NULL, NULL, NULL, NULL, 4),
(30353, NULL, 'G3DSA:3.30.200.20:FF:001931', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30354, NULL, 'G3DSA:2.130.10.10:FF:005402', NULL, NULL, 'Poc1', NULL, NULL, NULL, NULL, NULL, 4),
(30355, NULL, 'G3DSA:3.90.215.10:FF:000004', NULL, NULL, 'microfibril-associated glycoprotein 4', NULL, NULL, NULL, NULL, NULL, 4),
(30356, NULL, 'G3DSA:2.60.40.10:FF:004845', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30357, NULL, 'G3DSA:1.20.58.480:FF:000021', NULL, NULL, 'Tryptophan 2,3-dioxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(30358, NULL, 'G3DSA:2.40.10.340:FF:000008', NULL, NULL, 'Rod shape-determining protein MreC', NULL, NULL, NULL, NULL, NULL, 4),
(30359, NULL, 'G3DSA:3.40.50.300:FF:006717', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30360, NULL, 'G3DSA:2.130.10.10:FF:000023', NULL, NULL, 'Bromodomain and WD repeat domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(30361, NULL, 'G3DSA:2.60.200.20:FF:000001', NULL, NULL, 'Kinesin family member 1B', NULL, NULL, NULL, NULL, NULL, 4),
(30362, NULL, 'G3DSA:3.30.1370.100:FF:000041', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(30363, NULL, 'G3DSA:3.90.550.10:FF:000766', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(30364, NULL, 'G3DSA:1.20.5.190:FF:000081', NULL, NULL, 'Myosin-like protein XIF', NULL, NULL, NULL, NULL, NULL, 4),
(30365, NULL, 'G3DSA:3.40.50.10490:FF:000133', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30366, NULL, 'G3DSA:4.10.60.10:FF:000050', NULL, NULL, 'Unplaced genomic scaffold supercont2.10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(30367, NULL, 'G3DSA:3.30.70.330:FF:003124', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30368, NULL, 'G3DSA:1.25.40.10:FF:001394', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g28660', NULL, NULL, NULL, NULL, NULL, 4),
(30369, NULL, 'G3DSA:3.30.160.60:FF:003249', NULL, NULL, 'Zinc finger protein 407', NULL, NULL, NULL, NULL, NULL, 4),
(30370, NULL, 'G3DSA:1.10.3730.20:FF:000010', NULL, NULL, 'EamA family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(30371, NULL, 'G3DSA:1.10.8.60:FF:000472', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30372, NULL, 'G3DSA:1.25.40.10:FF:003456', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(30373, NULL, 'G3DSA:1.10.510.10:FF:000694', NULL, NULL, 'Kinase non-catalytic C-lobe domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(30374, NULL, 'G3DSA:1.20.1730.10:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30375, NULL, 'G3DSA:3.40.50.720:FF:001700', NULL, NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase NAD-binding', NULL, NULL, NULL, NULL, NULL, 4),
(30376, NULL, 'G3DSA:1.10.472.10:FF:000593', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30377, NULL, 'G3DSA:2.40.30.270:FF:000031', NULL, NULL, 'Protein CBG12210', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(30378, NULL, 'G3DSA:3.40.50.1700:FF:000026', NULL, NULL, 'uncharacterized protein LOC100182860 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(30379, NULL, 'G3DSA:3.40.50.410:FF:000298', NULL, NULL, 'Ubiquitin-conjugating enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(30380, NULL, 'G3DSA:1.10.620.20:FF:000025', NULL, NULL, 'Ribonucleotide reductase small subunit Suc22', NULL, NULL, NULL, NULL, NULL, 4),
(30381, NULL, 'G3DSA:3.40.50.620:FF:000035', NULL, NULL, 'methionine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(30382, NULL, 'G3DSA:3.40.50.1820:FF:000624', NULL, NULL, 'LIPaSe related', NULL, NULL, NULL, NULL, NULL, 4),
(30383, NULL, 'G3DSA:3.40.50.2300:FF:000993', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30384, NULL, 'G3DSA:1.20.1250.20:FF:001994', NULL, NULL, 'Solute carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(30385, NULL, 'G3DSA:1.20.1070.10:FF:001100', NULL, NULL, 'Opsin', NULL, NULL, NULL, NULL, NULL, 4),
(30386, NULL, 'G3DSA:3.40.50.720:FF:000891', NULL, NULL, '(R)-specific carbonyl reductase', NULL, NULL, NULL, NULL, NULL, 4),
(30387, NULL, 'G3DSA:1.25.40.20:FF:001368', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30388, NULL, 'G3DSA:1.20.58.60:FF:000785', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30389, NULL, 'G3DSA:2.60.40.10:FF:004109', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30390, NULL, 'G3DSA:3.40.50.150:FF:000815', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30391, NULL, 'G3DSA:2.130.10.30:FF:000181', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30392, NULL, 'G3DSA:2.40.30.20:FF:000032', NULL, NULL, 'Riboflavin synthase alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(30393, NULL, 'G3DSA:2.120.10.30:FF:000378', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30394, NULL, 'G3DSA:2.60.40.10:FF:005750', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30395, NULL, 'G3DSA:3.10.310.20:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30396, NULL, 'G3DSA:3.40.50.300:FF:000265', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(30397, NULL, 'G3DSA:1.10.1370.10:FF:000018', NULL, NULL, 'Peptidyl-dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(30398, NULL, 'G3DSA:3.60.40.10:FF:000240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30399, NULL, 'G3DSA:1.10.540.10:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30400, NULL, 'G3DSA:2.30.29.30:FF:001274', NULL, NULL, 'Rho-associated protein kinase let-502', NULL, NULL, NULL, NULL, NULL, 4),
(30401, NULL, 'G3DSA:3.30.70.380:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30402, NULL, 'G3DSA:3.30.40.10:FF:000691', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(30403, NULL, 'G3DSA:1.20.120.350:FF:000116', NULL, NULL, 'pH-gated potassium channel KcsA', NULL, NULL, NULL, NULL, NULL, 4),
(30404, NULL, 'G3DSA:3.40.50.2000:FF:000049', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(30405, NULL, 'G3DSA:2.70.98.10:FF:000026', NULL, NULL, 'Beta-galactosidase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(30406, NULL, 'G3DSA:2.130.10.10:FF:004385', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30407, NULL, 'G3DSA:3.80.10.10:FF:004172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30408, NULL, 'G3DSA:1.10.10.500:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30409, NULL, 'G3DSA:1.20.1250.20:FF:002039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30410, NULL, 'G3DSA:3.30.300.30:FF:000099', NULL, NULL, 'Nonribosomal peptide synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(30411, NULL, 'G3DSA:1.25.40.990:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30412, NULL, 'G3DSA:1.10.1410.10:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(30413, NULL, 'G3DSA:1.25.40.10:FF:003664', NULL, NULL, 'Putative DUF947 domain containing family protein', NULL, NULL, NULL, NULL, NULL, 4),
(30414, NULL, 'G3DSA:3.30.1370.10:FF:000080', NULL, NULL, 'RNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(30415, NULL, 'G3DSA:1.10.510.10:FF:001475', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(30416, NULL, 'G3DSA:2.30.180.10:FF:000131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30417, NULL, 'G3DSA:1.20.58.670:FF:000011', NULL, NULL, 'RAD50-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(30418, NULL, 'G3DSA:3.40.50.200:FF:000061', NULL, NULL, 'Secreted subtilisin-like protease', NULL, NULL, NULL, NULL, NULL, 4),
(30419, NULL, 'G3DSA:6.10.140.2220:FF:000005', NULL, NULL, 'Histone-lysine N-methyltransferase SMYD1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(30420, NULL, 'G3DSA:3.40.1350.60:FF:000001', NULL, NULL, 'Sugar fermentation stimulation protein A', NULL, NULL, NULL, NULL, NULL, 4),
(30421, NULL, 'G3DSA:2.60.40.10:FF:000630', NULL, NULL, 'Plexin D1', NULL, NULL, NULL, NULL, NULL, 4),
(30422, NULL, 'G3DSA:3.40.395.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30423, NULL, 'G3DSA:3.40.50.1000:FF:000322', NULL, NULL, 'HAD-superfamily hydrolase, subfamily IA, variant 3', NULL, NULL, NULL, NULL, NULL, 4),
(30424, NULL, 'G3DSA:3.90.260.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30425, NULL, 'G3DSA:1.20.1560.10:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30426, NULL, 'G3DSA:3.30.450.40:FF:000056', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(30427, NULL, 'G3DSA:1.10.10.10:FF:000930', NULL, NULL, 'DNA replication protein DnaD', NULL, NULL, NULL, NULL, NULL, 4),
(30428, NULL, 'G3DSA:3.30.780.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30429, NULL, 'G3DSA:1.25.40.480:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30430, NULL, 'G3DSA:3.40.50.300:FF:001546', NULL, NULL, 'RNase L inhibitor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(30431, NULL, 'G3DSA:3.40.50.300:FF:005700', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(30432, NULL, 'G3DSA:1.10.287.70:FF:000776', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30433, NULL, 'G3DSA:3.40.47.10:FF:000172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30434, NULL, 'G3DSA:3.30.420.10:FF:000124', NULL, NULL, 'Plastid replication-repair enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(30435, NULL, 'G3DSA:3.40.50.2300:FF:000521', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(30436, NULL, 'G3DSA:3.40.1110.10:FF:000053', NULL, NULL, 'Cation-transporting ATPase, E1-E2 family', NULL, NULL, NULL, NULL, NULL, 4),
(30437, NULL, 'G3DSA:2.60.120.260:FF:000618', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(30438, NULL, 'G3DSA:2.40.50.1060:FF:000015', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(30439, NULL, 'G3DSA:1.10.238.10:FF:000706', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30440, NULL, 'G3DSA:3.40.50.300:FF:004683', NULL, NULL, 'Guanine nucleotide binding protein, alpha activating activity polypeptide O', NULL, NULL, NULL, NULL, NULL, 4),
(30441, NULL, 'G3DSA:3.30.1380.20:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30442, NULL, 'G3DSA:2.30.170.20:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30443, NULL, 'G3DSA:3.40.50.1220:FF:000096', NULL, NULL, 'Electron transfer flavoprotein alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(30444, NULL, 'G3DSA:2.40.10.10:FF:000320', NULL, NULL, 'KLKBL4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(30445, NULL, 'G3DSA:2.70.170.10:FF:000037', NULL, NULL, 'zinc-activated ligand-gated ion channel', NULL, NULL, NULL, NULL, NULL, 4),
(30446, NULL, 'G3DSA:3.40.50.11990:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(30447, NULL, 'G3DSA:3.30.390.30:FF:000020', NULL, NULL, 'Lipoamide dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(30448, NULL, 'G3DSA:3.65.10.10:FF:000025', NULL, NULL, 'Putative 3-phosphoshikimate 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(30449, NULL, 'G3DSA:3.90.70.10:FF:000145', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(30450, NULL, 'G3DSA:1.20.91.20:FF:000001', NULL, NULL, 'Complement C3', NULL, NULL, NULL, NULL, NULL, 4),
(30451, NULL, 'G3DSA:3.40.50.12760:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30452, NULL, 'G3DSA:2.60.40.420:FF:000231', NULL, NULL, 'Copper resistance protein A', NULL, NULL, NULL, NULL, NULL, 4),
(30453, NULL, 'G3DSA:1.10.1450.10:FF:000171', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(30454, NULL, 'G3DSA:3.20.20.100:FF:000147', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(30455, NULL, 'G3DSA:2.60.40.10:FF:001708', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(30456, NULL, 'G3DSA:4.10.240.10:FF:000066', NULL, NULL, 'Transcription factor kojR', NULL, NULL, NULL, NULL, NULL, 4),
(30457, NULL, 'G3DSA:1.25.40.60:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30458, NULL, 'G3DSA:3.40.50.300:FF:004211', NULL, NULL, 'Ras-related protein RabV', NULL, NULL, NULL, NULL, NULL, 4),
(30459, NULL, 'G3DSA:3.30.2450.30:FF:000002', NULL, NULL, 'purine-rich element-binding protein gamma isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(30460, NULL, 'G3DSA:3.40.1260.20:FF:000010', NULL, NULL, 'Ribonuclease E', NULL, NULL, NULL, NULL, NULL, 4),
(30461, NULL, 'G3DSA:1.20.1250.40:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30462, NULL, 'G3DSA:3.30.160.60:FF:000315', NULL, NULL, 'Zinc finger and BTB domain-containing protein 20', NULL, NULL, NULL, NULL, NULL, 4),
(30463, NULL, 'G3DSA:3.30.70.1230:FF:000079', NULL, NULL, 'Soluble guanylate cyclase gcy-31', NULL, NULL, NULL, NULL, NULL, 4),
(30464, NULL, 'G3DSA:3.60.15.30:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30465, NULL, 'G3DSA:3.30.160.60:FF:000579', NULL, NULL, 'Zinc finger protein 354B', NULL, NULL, NULL, NULL, NULL, 4),
(30466, NULL, 'G3DSA:3.40.50.1820:FF:000124', NULL, NULL, 'Probable 1-acylglycerol-3-phosphate O-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(30467, NULL, 'G3DSA:3.40.50.300:FF:007645', NULL, NULL, 'DNA repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(30468, NULL, 'G3DSA:3.40.50.1820:FF:000388', NULL, NULL, 'Alpha/beta family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(30469, NULL, 'G3DSA:2.60.40.10:FF:002428', NULL, NULL, 'Immunoglobulin heavy constant delta', NULL, NULL, NULL, NULL, NULL, 4),
(30470, NULL, 'G3DSA:1.25.40.20:FF:001868', NULL, NULL, 'GASZ', NULL, NULL, NULL, NULL, NULL, 4),
(30471, NULL, 'G3DSA:1.20.1110.10:FF:000166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30472, NULL, 'G3DSA:4.10.720.10:FF:000001', NULL, NULL, 'Zinc finger, FYVE domain-containing 9a', NULL, NULL, NULL, NULL, NULL, 4),
(30473, NULL, 'G3DSA:3.40.50.10190:FF:000110', NULL, NULL, 'Regulator of Ty1 transposition', NULL, NULL, NULL, NULL, NULL, 4),
(30474, NULL, 'G3DSA:4.10.800.10:FF:000002', NULL, NULL, 'Insulin-like growth factor-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(30475, NULL, 'G3DSA:2.60.120.970:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30476, NULL, 'G3DSA:1.10.8.10:FF:000210', NULL, NULL, 'Sequestosome-1', NULL, NULL, NULL, NULL, NULL, 4),
(30477, NULL, 'G3DSA:3.30.1490.20:FF:000092', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(30478, NULL, 'G3DSA:1.20.1070.10:FF:000083', NULL, NULL, 'Melanopsin 1', NULL, NULL, NULL, NULL, NULL, 4),
(30479, NULL, 'G3DSA:3.40.50.12650:FF:000039', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(30480, NULL, 'G3DSA:1.20.58.390:FF:000258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(30481, NULL, 'G3DSA:2.40.110.10:FF:000012', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(30482, NULL, 'G3DSA:3.30.200.20:FF:001431', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30483, NULL, 'G3DSA:1.10.357.20:FF:000019', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(30484, NULL, 'G3DSA:3.40.390.10:FF:000309', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30485, NULL, 'G3DSA:3.30.230.70:FF:000088', NULL, NULL, 'Putative exosome complex exonuclease RRP42', NULL, NULL, NULL, NULL, NULL, 4),
(30486, NULL, 'G3DSA:1.20.1270.60:FF:000113', NULL, NULL, 'Atg20p', NULL, NULL, NULL, NULL, NULL, 4),
(30487, NULL, 'G3DSA:3.30.160.20:FF:000062', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(30488, NULL, 'G3DSA:3.40.309.10:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30489, NULL, 'G3DSA:3.30.160.60:FF:005958', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30490, NULL, 'G3DSA:3.60.20.40:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30491, NULL, 'G3DSA:3.30.40.10:FF:000336', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(30492, NULL, 'G3DSA:3.50.50.60:FF:000845', NULL, NULL, 'NAD(P)/FAD-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(30493, NULL, 'G3DSA:3.30.160.60:FF:002001', NULL, NULL, 'Zinc finger protein 445', NULL, NULL, NULL, NULL, NULL, 4),
(30494, NULL, 'G3DSA:1.10.1200.10:FF:000063', NULL, NULL, 'Acyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(30495, NULL, 'G3DSA:3.90.1310.10:FF:000039', NULL, NULL, 'Beta-lactamase', NULL, NULL, NULL, NULL, NULL, 4),
(30496, NULL, 'G3DSA:3.40.50.1170:FF:000002', NULL, NULL, 'L-asparaginase 1', NULL, NULL, NULL, NULL, NULL, 4),
(30497, NULL, 'G3DSA:1.25.10.10:FF:002347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30498, NULL, 'G3DSA:3.30.559.30:FF:000075', NULL, NULL, 'Nonribosomal peptide synthase Pes1 (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(30499, NULL, 'G3DSA:2.40.50.140:FF:000732', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30500, NULL, 'G3DSA:3.40.50.300:FF:004008', NULL, NULL, 'Putative DEAD/DEAH box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(30501, NULL, 'G3DSA:3.40.50.12780:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30502, NULL, 'G3DSA:1.10.510.10:FF:000194', NULL, NULL, 'Casein kinase I isoform delta', NULL, NULL, NULL, NULL, NULL, 4),
(30503, NULL, 'G3DSA:3.40.50.720:FF:001083', NULL, NULL, 'Bile acid 7-dehydroxylase 1/3', NULL, NULL, NULL, NULL, NULL, 4),
(30504, NULL, 'G3DSA:2.10.70.10:FF:000128', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(30505, NULL, 'G3DSA:1.10.510.10:FF:003420', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30506, NULL, 'G3DSA:2.40.40.10:FF:000001', NULL, NULL, 'Expansin', NULL, NULL, NULL, NULL, NULL, 4),
(30507, NULL, 'G3DSA:3.40.50.1000:FF:000058', NULL, NULL, 'Phosphatase yihX', NULL, NULL, NULL, NULL, NULL, 4),
(30508, NULL, 'G3DSA:1.20.1720.10:FF:000049', NULL, NULL, 'Multidrug resistance protein B', NULL, NULL, NULL, NULL, NULL, 4),
(30509, NULL, 'G3DSA:3.20.10.10:FF:000032', NULL, NULL, 'Branched-chain amino acid aminotransferase lateral transfer candidate', NULL, NULL, NULL, NULL, NULL, 4),
(30510, NULL, 'G3DSA:3.30.870.10:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30511, NULL, 'G3DSA:3.40.50.80:FF:000228', NULL, NULL, 'Putative respiratory burst oxidase homolog protein I', NULL, NULL, NULL, NULL, NULL, 4),
(30512, NULL, 'G3DSA:3.40.190.290:FF:000084', NULL, NULL, 'LysR family transcriptional regulator (Chromosome initiation inhibitor)', NULL, NULL, NULL, NULL, NULL, 4),
(30513, NULL, 'G3DSA:2.130.10.10:FF:003721', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(30514, NULL, 'G3DSA:1.25.40.560:FF:000002', NULL, NULL, 'Ubiquitin thioesterase trabid', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(30515, NULL, 'G3DSA:1.10.10.60:FF:000220', NULL, NULL, 'DEK domain-containing chromatin associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(30516, NULL, 'G3DSA:2.60.40.10:FF:001147', NULL, NULL, 'phosphatidylinositol phosphatase PTPRQ isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(30517, NULL, 'G3DSA:1.20.1250.20:FF:002191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30518, NULL, 'G3DSA:3.30.450.200:FF:000001', NULL, NULL, 'DENN domain-containing protein 2A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(30519, NULL, 'G3DSA:1.25.40.10:FF:004384', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30520, NULL, 'G3DSA:1.10.3520.10:FF:000019', NULL, NULL, 'glycolipid transfer protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(30521, NULL, 'G3DSA:3.40.50.12780:FF:000027', NULL, NULL, 'AASDH isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(30522, NULL, 'G3DSA:3.30.420.40:FF:000228', NULL, NULL, 'Probable butyrate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(30523, NULL, 'G3DSA:1.20.1070.10:FF:000903', NULL, NULL, 'Adhesion G protein-coupled receptor E1', NULL, NULL, NULL, NULL, NULL, 4),
(30524, NULL, 'G3DSA:2.60.40.2240:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30525, NULL, 'G3DSA:1.25.40.70:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30526, NULL, 'G3DSA:2.30.30.280:FF:000002', NULL, NULL, 'tRNA (5-methylaminomethyl-2-thiouridylate)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(30527, NULL, 'G3DSA:3.40.50.2000:FF:000313', NULL, NULL, 'Glycosyltransferase family 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(30528, NULL, 'G3DSA:2.170.260.10:FF:000003', NULL, NULL, 'Piwi-like RNA-mediated gene silencing 2', NULL, NULL, NULL, NULL, NULL, 4),
(30529, NULL, 'G3DSA:3.40.50.2300:FF:001038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30530, NULL, 'G3DSA:2.30.29.30:FF:000554', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(30531, NULL, 'G3DSA:3.90.180.10:FF:000046', NULL, NULL, '2-enoyl thioester reductase', NULL, NULL, NULL, NULL, NULL, 4),
(30532, NULL, 'G3DSA:3.60.10.10:FF:000412', NULL, NULL, 'Endonuclease/Exonuclease/phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(30533, NULL, 'G3DSA:3.30.200.20:FF:002095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30534, NULL, 'G3DSA:2.130.10.10:FF:001512', NULL, NULL, 'CPSF_A_subunit_region_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(30535, NULL, 'G3DSA:2.60.40.1670:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30536, NULL, 'G3DSA:4.10.400.10:FF:000073', NULL, NULL, 'Low-density lipoprotein receptor-related protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(30537, NULL, 'G3DSA:2.40.70.10:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30538, NULL, 'G3DSA:2.60.40.10:FF:001855', NULL, NULL, 'Hemicentin 2', NULL, NULL, NULL, NULL, NULL, 4),
(30539, NULL, 'G3DSA:3.30.230.10:FF:000177', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(30540, NULL, 'G3DSA:1.10.10.790:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30541, NULL, 'G3DSA:2.40.50.140:FF:000468', NULL, NULL, 'Ribonuclease R', NULL, NULL, NULL, NULL, NULL, 4),
(30542, NULL, 'G3DSA:3.30.70.260:FF:000118', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(30543, NULL, 'G3DSA:3.40.30.10:FF:000369', NULL, NULL, 'GPX5 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(30544, NULL, 'G3DSA:3.20.20.220:FF:000037', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(30545, NULL, 'G3DSA:2.10.60.10:FF:000043', NULL, NULL, 'GML isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(30546, NULL, 'G3DSA:1.25.40.430:FF:000014', NULL, NULL, 'Protein CBR-SAN-1', NULL, NULL, NULL, NULL, NULL, 4),
(30547, NULL, 'G3DSA:1.10.2000.10:FF:000025', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(30548, NULL, 'G3DSA:3.20.20.190:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(30549, NULL, 'G3DSA:3.40.50.300:FF:008426', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30550, NULL, 'G3DSA:3.30.200.20:FF:001167', NULL, NULL, 'Kinase, CDC7', NULL, NULL, NULL, NULL, NULL, 4),
(30551, NULL, 'G3DSA:3.30.70.270:FF:000178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30552, NULL, 'G3DSA:2.60.40.10:FF:000219', NULL, NULL, 'Down syndrome cell adhesion molecule homolog', NULL, NULL, NULL, NULL, NULL, 4),
(30553, NULL, 'G3DSA:1.25.40.10:FF:002175', NULL, NULL, 'Pentatricopeptide repeat-containing protein DOT4, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(30554, NULL, 'G3DSA:1.10.287.70:FF:000253', NULL, NULL, 'Blast:Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(30555, NULL, 'G3DSA:3.60.20.10:FF:000238', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30556, NULL, 'G3DSA:3.30.70.330:FF:002927', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30557, NULL, 'G3DSA:1.20.1250.20:FF:001522', NULL, NULL, 'Os12g0240875 protein', NULL, NULL, NULL, NULL, NULL, 4),
(30558, NULL, 'G3DSA:1.25.10.10:FF:000902', NULL, NULL, 'HEAT repeat-containing protein 5B', NULL, NULL, NULL, NULL, NULL, 4),
(30559, NULL, 'G3DSA:2.130.10.10:FF:002440', NULL, NULL, 'Subunit of the mRNA cleavage and polyadenylation factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(30560, NULL, 'G3DSA:1.10.30.10:FF:000021', NULL, NULL, 'nucleolar transcription factor 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(30561, NULL, 'G3DSA:2.60.120.200:FF:000707', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30562, NULL, 'G3DSA:2.60.120.560:FF:000001', NULL, NULL, 'galactocerebrosidase precursor', NULL, NULL, NULL, NULL, NULL, 4),
(30563, NULL, 'G3DSA:3.90.180.10:FF:000193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30564, NULL, 'G3DSA:3.20.20.70:FF:000680', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30565, NULL, 'G3DSA:3.30.70.330:FF:000870', NULL, NULL, 'Serine/arginine-rich splicing factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(30566, NULL, 'G3DSA:3.40.20.10:FF:000020', NULL, NULL, 'protein flightless-1 homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(30567, NULL, 'G3DSA:1.10.472.150:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30568, NULL, 'G3DSA:2.30.39.10:FF:000072', NULL, NULL, 'Serpin peptidase inhibitor, clade H (Heat shock protein 47), member 1, (Collagen binding protein 1)', NULL, NULL, NULL, NULL, NULL, 4),
(30569, NULL, 'G3DSA:3.80.10.10:FF:002991', NULL, NULL, 'Si:ch211-180f4.1', NULL, NULL, NULL, NULL, NULL, 4),
(30570, NULL, 'G3DSA:3.30.930.10:FF:000354', NULL, NULL, 'Histidyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(30571, NULL, 'G3DSA:3.40.390.10:FF:000197', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30572, NULL, 'G3DSA:3.10.20.30:FF:000005', NULL, NULL, 'Threonine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(30573, NULL, 'G3DSA:2.170.270.10:FF:000240', NULL, NULL, 'SET and MYND domain-containing protein DDB_G0288495', NULL, NULL, NULL, NULL, NULL, 4),
(30574, NULL, 'G3DSA:3.80.10.10:FF:000074', NULL, NULL, 'Leucine-rich repeat neuronal protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(30575, NULL, 'G3DSA:1.20.1640.10:FF:000048', NULL, NULL, 'protein patched homolog 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(30576, NULL, 'G3DSA:1.25.40.10:FF:004945', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30577, NULL, 'G3DSA:1.10.1580.10:FF:000028', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(30578, NULL, 'G3DSA:2.130.10.10:FF:005874', NULL, NULL, 'Protein CBG14967', NULL, NULL, NULL, NULL, NULL, 4),
(30579, NULL, 'G3DSA:1.10.10.10:FF:001447', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30580, NULL, 'G3DSA:3.30.70.330:FF:000718', NULL, NULL, 'Pre-mRNA-splicing factor CWC2', NULL, NULL, NULL, NULL, NULL, 4),
(30581, NULL, 'G3DSA:3.60.21.10:FF:000229', NULL, NULL, 'Protein CBG06090', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(30582, NULL, 'G3DSA:3.40.50.300:FF:003755', NULL, NULL, 'Im:7158730 protein', NULL, NULL, NULL, NULL, NULL, 4),
(30583, NULL, 'G3DSA:3.90.640.10:FF:000273', NULL, NULL, 'Actin-like protein 3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(30584, NULL, 'G3DSA:1.10.472.10:FF:000649', NULL, NULL, 'Cyclin, N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(30585, NULL, 'G3DSA:3.30.1490.480:FF:000001', NULL, NULL, 'Endolytic murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(30586, NULL, 'G3DSA:3.30.530.20:FF:000051', NULL, NULL, 'Os08g0374000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(30587, NULL, 'G3DSA:1.20.1110.10:FF:000019', NULL, NULL, 'Probable cation-transporting P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(30588, NULL, 'G3DSA:3.40.850.10:FF:000536', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(30589, NULL, 'G3DSA:1.20.120.350:FF:000263', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30590, NULL, 'G3DSA:1.10.287.110:FF:000350', NULL, NULL, 'DnaJ domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(30591, NULL, 'G3DSA:3.80.10.10:FF:000782', NULL, NULL, 'Si:ch211-196h16.4', NULL, NULL, NULL, NULL, NULL, 4),
(30592, NULL, 'G3DSA:2.60.120.330:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30593, NULL, 'G3DSA:3.30.160.60:FF:003193', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30594, NULL, 'G3DSA:1.10.357.70:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30595, NULL, 'G3DSA:3.40.50.1820:FF:001405', NULL, NULL, 'GPI inositol-deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(30596, NULL, 'G3DSA:3.40.50.300:FF:001693', NULL, NULL, 'tRNA dimethylallyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(30597, NULL, 'G3DSA:1.10.860.10:FF:000006', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(30598, NULL, 'G3DSA:2.30.42.10:FF:000596', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30599, NULL, 'G3DSA:1.10.510.10:FF:001211', NULL, NULL, 'AGAP004008-PA', NULL, NULL, NULL, NULL, NULL, 4),
(30600, NULL, 'G3DSA:3.60.15.10:FF:000108', NULL, NULL, 'Cleavage and polyadenylation specificity factor subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(30601, NULL, 'G3DSA:1.25.40.20:FF:000587', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(30602, NULL, 'G3DSA:3.30.40.10:FF:001264', NULL, NULL, 'F2H15.19 protein', NULL, NULL, NULL, NULL, NULL, 4),
(30603, NULL, 'G3DSA:4.10.1000.10:FF:000028', NULL, NULL, 'Zinc finger nuclease 2', NULL, NULL, NULL, NULL, NULL, 4),
(30604, NULL, 'G3DSA:3.40.50.150:FF:001720', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30605, NULL, 'G3DSA:3.20.20.140:FF:000047', NULL, NULL, 'PHP domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(30606, NULL, 'G3DSA:3.90.1410.10:FF:000042', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(30607, NULL, 'G3DSA:3.40.30.10:FF:000105', NULL, NULL, 'protein disulfide-isomerase A5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(30608, NULL, 'G3DSA:3.30.40.10:FF:001972', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30609, NULL, 'G3DSA:1.20.1560.10:FF:000047', NULL, NULL, 'NHLP family bacteriocin export ABC transporter peptidase/permease/ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(30610, NULL, 'G3DSA:2.60.120.10:FF:000407', NULL, NULL, 'ABC-type multidrug transport system, ATPase and permease component', NULL, NULL, NULL, NULL, NULL, 4),
(30611, NULL, 'G3DSA:1.10.10.10:FF:000222', NULL, NULL, 'Transcriptional regulatory protein RcsA', NULL, NULL, NULL, NULL, NULL, 4),
(30612, NULL, 'G3DSA:1.20.1070.10:FF:000875', NULL, NULL, 'Frizzled A', NULL, NULL, NULL, NULL, NULL, 4),
(30613, NULL, 'G3DSA:1.10.510.10:FF:002700', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30614, NULL, 'G3DSA:3.10.490.10:FF:000032', NULL, NULL, 'Gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(30615, NULL, 'G3DSA:3.40.50.1820:FF:000860', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(30616, NULL, 'G3DSA:1.20.1160.20:FF:000003', NULL, NULL, 'Whirlin a', NULL, NULL, NULL, NULL, NULL, 4),
(30617, NULL, 'G3DSA:1.10.10.2670:FF:000010', NULL, NULL, 'WGS project CABT00000000 data, contig 2.6', NULL, NULL, NULL, NULL, NULL, 4),
(30618, NULL, 'G3DSA:3.40.50.1010:FF:000095', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(30619, NULL, 'G3DSA:2.60.40.10:FF:001063', NULL, NULL, 'Programmed cell death ligand 1', NULL, NULL, NULL, NULL, NULL, 4),
(30620, NULL, 'G3DSA:2.10.109.10:FF:000010', NULL, NULL, 'Mitochondrial inner membrane protease subunit', NULL, NULL, NULL, NULL, NULL, 4),
(30621, NULL, 'G3DSA:3.30.590.50:FF:000007', NULL, NULL, 'Glutamate--cysteine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(30622, NULL, 'G3DSA:3.90.470.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30623, NULL, 'G3DSA:3.40.1010.10:FF:000017', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase I', NULL, NULL, NULL, NULL, NULL, 4),
(30624, NULL, 'G3DSA:1.10.580.10:FF:000024', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(30625, NULL, 'G3DSA:3.40.50.1820:FF:000332', NULL, NULL, 'Lysin B', NULL, NULL, NULL, NULL, NULL, 4),
(30626, NULL, 'G3DSA:1.10.1660.10:FF:000001', NULL, NULL, 'Cu(I)-responsive transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(30627, NULL, 'G3DSA:1.10.287.3290:FF:000001', NULL, NULL, 'Dsl1p', NULL, NULL, NULL, NULL, NULL, 4),
(30628, NULL, 'G3DSA:3.40.640.10:FF:000262', NULL, NULL, 'Ornithine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(30629, NULL, 'G3DSA:1.25.40.10:FF:004209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30630, NULL, 'G3DSA:3.90.190.10:FF:000339', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(30631, NULL, 'G3DSA:2.30.29.210:FF:000002', NULL, NULL, 'FACT complex subunit SPT16', NULL, NULL, NULL, NULL, NULL, 4),
(30632, NULL, 'G3DSA:2.130.10.10:FF:001720', NULL, NULL, 'Topless-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(30633, NULL, 'G3DSA:2.60.40.10:FF:005278', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30634, NULL, 'G3DSA:3.40.710.10:FF:000003', NULL, NULL, 'Peptidoglycan D,D-transpeptidase FtsI', NULL, NULL, NULL, NULL, NULL, 4),
(30635, NULL, 'G3DSA:3.30.70.270:FF:000155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30636, NULL, 'G3DSA:1.10.287.70:FF:000753', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30637, NULL, 'G3DSA:3.40.50.1010:FF:000151', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30638, NULL, 'G3DSA:1.10.600.10:FF:000105', NULL, NULL, 'Tsukubadiene synthase', NULL, NULL, NULL, NULL, NULL, 4),
(30639, NULL, 'G3DSA:1.20.5.5160:FF:000007', NULL, NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', NULL, NULL, NULL, NULL, NULL, 4),
(30640, NULL, 'G3DSA:3.10.580.10:FF:000207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30641, NULL, 'G3DSA:2.30.30.230:FF:000004', NULL, NULL, 'Fumarylacetoacetase', NULL, NULL, NULL, NULL, NULL, 4),
(30642, NULL, 'G3DSA:1.10.10.60:FF:000720', NULL, NULL, 'NK1 homeobox 2', NULL, NULL, NULL, NULL, NULL, 4),
(30643, NULL, 'G3DSA:1.25.40.10:FF:001455', NULL, NULL, 'Putative intraflagellar transport protein B2', NULL, NULL, NULL, NULL, NULL, 4),
(30644, NULL, 'G3DSA:3.50.50.60:FF:000289', NULL, NULL, 'Probable lysine-specific histone demethylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(30645, NULL, 'G3DSA:1.20.1070.10:FF:000347', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(30646, NULL, 'G3DSA:1.20.5.510:FF:000008', NULL, NULL, 'Ubiquinol-cytochrome c reductase iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4),
(30647, NULL, 'G3DSA:1.10.8.60:FF:000556', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30648, NULL, 'G3DSA:3.40.50.620:FF:000799', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30649, NULL, 'G3DSA:3.40.50.300:FF:005172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(30650, NULL, 'G3DSA:2.60.120.330:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30651, NULL, 'G3DSA:2.40.10.10:FF:000112', NULL, NULL, 'Mannan-binding lectin serine protease 1', NULL, NULL, NULL, NULL, NULL, 4),
(30652, NULL, 'G3DSA:1.10.10.60:FF:001232', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30653, NULL, 'G3DSA:2.130.10.10:FF:004946', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30654, NULL, 'G3DSA:3.30.710.10:FF:000287', NULL, NULL, 'Zinc finger and BTB domain-containing 21', NULL, NULL, NULL, NULL, NULL, 4),
(30655, NULL, 'G3DSA:3.40.50.720:FF:001200', NULL, NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(30656, NULL, 'G3DSA:2.130.10.10:FF:003660', NULL, NULL, 'WD repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(30657, NULL, 'G3DSA:1.25.40.10:FF:002883', NULL, NULL, 'Os08g0511000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(30658, NULL, 'G3DSA:1.10.510.10:FF:001711', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30659, NULL, 'G3DSA:1.10.8.60:FF:000028', NULL, NULL, 'Replication factor C subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(30660, NULL, 'G3DSA:3.30.70.3030:FF:000006', NULL, NULL, 'Nucleolar protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(30661, NULL, 'G3DSA:1.10.1200.220:FF:000001', NULL, NULL, 'Os06g0322300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(30662, NULL, 'G3DSA:1.10.510.10:FF:002695', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30663, NULL, 'G3DSA:3.30.710.10:FF:000343', NULL, NULL, 'Potassium channel tetramerisation domain-containing 17', NULL, NULL, NULL, NULL, NULL, 4),
(30664, NULL, 'G3DSA:2.40.30.170:FF:000063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30665, NULL, 'G3DSA:1.20.1270.60:FF:000085', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(30666, NULL, 'G3DSA:1.25.40.10:FF:002411', NULL, NULL, 'pentatricopeptide repeat-containing protein At1g71420', NULL, NULL, NULL, NULL, NULL, 4),
(30667, NULL, 'G3DSA:1.10.246.60:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30668, NULL, 'G3DSA:2.30.30.40:FF:000212', NULL, NULL, 'NADPH oxidase activator 1', NULL, NULL, NULL, NULL, NULL, 4),
(30669, NULL, 'G3DSA:1.25.40.10:FF:004737', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(30670, NULL, 'G3DSA:2.10.25.10:FF:000849', NULL, NULL, 'Thrombospondin, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(30671, NULL, 'G3DSA:3.40.50.720:FF:001144', NULL, NULL, 'Uroporphyrinogen-III C-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(30672, NULL, 'G3DSA:3.30.40.10:FF:000275', NULL, NULL, '43 kDa receptor-associated protein of the synapse', NULL, NULL, NULL, NULL, NULL, 4),
(30673, NULL, 'G3DSA:1.10.10.160:FF:000004', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(30674, NULL, 'G3DSA:1.10.287.110:FF:000294', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(30675, NULL, 'G3DSA:2.120.10.30:FF:000142', NULL, NULL, 'NHL repeat containing E3 ubiquitin protein ligase 1', NULL, NULL, NULL, NULL, NULL, 4),
(30676, NULL, 'G3DSA:3.90.1290.10:FF:000037', NULL, NULL, 'VAB-10A protein', NULL, NULL, NULL, NULL, NULL, 4),
(30677, NULL, 'G3DSA:2.60.40.10:FF:005773', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30678, NULL, 'G3DSA:3.90.1750.10:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30679, NULL, 'G3DSA:1.10.150.20:FF:000096', NULL, NULL, 'Putative DNA polymerase kappa', NULL, NULL, NULL, NULL, NULL, 4),
(30680, NULL, 'G3DSA:1.10.520.10:FF:000048', NULL, NULL, 'Peroxidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(30681, NULL, 'G3DSA:2.20.28.10:FF:000013', NULL, NULL, 'DNA replication licensing factor MCM4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(30682, NULL, 'G3DSA:1.10.510.10:FF:001391', NULL, NULL, 'Serine/threonine-protein kinase PknK', NULL, NULL, NULL, NULL, NULL, 4),
(30683, NULL, 'G3DSA:2.130.10.30:FF:000001', NULL, NULL, 'LOW QUALITY PROTEIN: probable E3 ubiquitin-protein ligase HERC1', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(30684, NULL, 'G3DSA:3.40.50.300:FF:000821', NULL, NULL, 'DNA excision repair protein ERCC-6-like 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(30685, NULL, 'G3DSA:1.20.1560.10:FF:000255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30686, NULL, 'G3DSA:3.30.230.80:FF:000006', NULL, NULL, 'endoplasmin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(30687, NULL, 'G3DSA:3.30.160.60:FF:001512', NULL, NULL, 'Zinc finger protein 496', NULL, NULL, NULL, NULL, NULL, 4),
(30688, NULL, 'G3DSA:1.10.287.90:FF:000023', NULL, NULL, 'Ubiquinol oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(30689, NULL, 'G3DSA:1.10.630.10:FF:000725', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30690, NULL, 'G3DSA:1.25.40.10:FF:000522', NULL, NULL, 'Protein adenylyltransferase Fic', NULL, NULL, NULL, NULL, NULL, 4),
(30691, NULL, 'G3DSA:1.10.3460.10:FF:000020', NULL, NULL, 'Photosystem II subunit PsbS1', NULL, NULL, NULL, NULL, NULL, 4),
(30692, NULL, 'G3DSA:1.10.600.10:FF:000049', NULL, NULL, 'Geranylgeranyl pyrophosphate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(30693, NULL, 'G3DSA:3.40.50.410:FF:000062', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(30694, NULL, 'G3DSA:1.10.260.40:FF:000025', NULL, NULL, 'Cro/Cl family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(30695, NULL, 'G3DSA:2.60.40.10:FF:001591', NULL, NULL, 'Mesh, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(30696, NULL, 'G3DSA:3.30.420.40:FF:000964', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30697, NULL, 'G3DSA:2.40.37.10:FF:000033', NULL, NULL, 'Ornithine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(30698, NULL, 'G3DSA:3.80.10.10:FF:003300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30699, NULL, 'G3DSA:3.10.20.90:FF:000888', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30700, NULL, 'G3DSA:1.20.1070.10:FF:000403', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(30701, NULL, 'G3DSA:3.40.50.1390:FF:000012', NULL, NULL, 'Site-specific recombinase', NULL, NULL, NULL, NULL, NULL, 4),
(30702, NULL, 'G3DSA:1.10.238.10:FF:001139', NULL, NULL, 'N-terminal EF-hand calcium-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(30703, NULL, 'G3DSA:3.30.40.10:FF:000752', NULL, NULL, 'Blast:Histone-lysine N-methyltransferase 2C', NULL, NULL, NULL, NULL, NULL, 4),
(30704, NULL, 'G3DSA:3.50.50.60:FF:001245', NULL, NULL, 'Putative ubiquinone biosynthesis monooxygenase COQ6-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(30705, NULL, 'G3DSA:2.40.10.10:FF:000056', NULL, NULL, 'Kallikrein related peptidase 11', NULL, NULL, NULL, NULL, NULL, 4),
(30706, NULL, 'G3DSA:3.40.50.300:FF:005436', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30707, NULL, 'G3DSA:2.60.120.650:FF:000056', NULL, NULL, 'Jumonji domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(30708, NULL, 'G3DSA:3.40.33.10:FF:000027', NULL, NULL, 'Cysteine-rich venom protein kaouthin-1', NULL, NULL, NULL, NULL, NULL, 4),
(30709, NULL, 'G3DSA:2.10.70.10:FF:000072', NULL, NULL, 'CUB and Sushi multiple domains 3', NULL, NULL, NULL, NULL, NULL, 4),
(30710, NULL, 'G3DSA:3.10.290.10:FF:000084', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(30711, NULL, 'G3DSA:3.40.30.10:FF:000785', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(30712, NULL, 'G3DSA:3.10.250.10:FF:000014', NULL, NULL, 'Lysyl oxidase homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(30713, NULL, 'G3DSA:1.10.10.750:FF:000030', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(30714, NULL, 'G3DSA:2.30.30.100:FF:000224', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm2', NULL, NULL, NULL, NULL, NULL, 4),
(30715, NULL, 'G3DSA:1.10.287.1490:FF:000051', NULL, NULL, 'Viral A-type inclusion protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(30716, NULL, 'G3DSA:2.60.40.10:FF:001439', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(30717, NULL, 'G3DSA:3.40.50.2000:FF:000257', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(30718, NULL, 'G3DSA:1.25.40.570:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30719, NULL, 'G3DSA:3.40.50.300:FF:004508', NULL, NULL, 'UBQ, helicase-c and DEAD-like helicase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(30720, NULL, 'G3DSA:3.40.50.1100:FF:000026', NULL, NULL, 'Threonine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(30721, NULL, 'G3DSA:2.30.40.10:FF:000081', NULL, NULL, 'Ethylammeline chlorohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(30722, NULL, 'G3DSA:1.25.10.10:FF:001627', NULL, NULL, 'Beta-catenin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(30723, NULL, 'G3DSA:1.25.40.10:FF:003400', NULL, NULL, 'PPR repeat family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(30724, NULL, 'G3DSA:1.10.287.1050:FF:000003', NULL, NULL, 'DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(30725, NULL, 'G3DSA:1.25.10.10:FF:002263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30726, NULL, 'G3DSA:3.40.630.30:FF:000008', NULL, NULL, 'Acetyltransferase, GNAT family', NULL, NULL, NULL, NULL, NULL, 4),
(30727, NULL, 'G3DSA:2.10.25.10:FF:000496', NULL, NULL, 'Crumbs, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(30728, NULL, 'G3DSA:3.40.50.300:FF:001277', NULL, NULL, 'Elongation factor 1 alpha-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(30729, NULL, 'G3DSA:3.40.50.2300:FF:000605', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(30730, NULL, 'G3DSA:2.130.10.10:FF:004593', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30731, NULL, 'G3DSA:3.80.10.10:FF:000810', NULL, NULL, 'Leucine rich repeat containing 15', NULL, NULL, NULL, NULL, NULL, 4),
(30732, NULL, 'G3DSA:3.80.10.10:FF:001322', NULL, NULL, 'Receptor protein-tyrosine kinase CEPR1', NULL, NULL, NULL, NULL, NULL, 4),
(30733, NULL, 'G3DSA:2.130.10.10:FF:000731', NULL, NULL, 'Echinoderm microtubule-associated 2 isoform x3', NULL, NULL, NULL, NULL, NULL, 4),
(30734, NULL, 'G3DSA:1.25.40.10:FF:000994', NULL, NULL, 'Histone demethylase UTY', NULL, NULL, NULL, NULL, NULL, 4),
(30735, NULL, 'G3DSA:2.40.128.20:FF:000039', NULL, NULL, 'UPF0678 fatty acid-binding protein-like protein At1g79260', NULL, NULL, NULL, NULL, NULL, 4),
(30736, NULL, 'G3DSA:1.10.555.10:FF:000191', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30737, NULL, 'G3DSA:1.25.40.20:FF:001312', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30738, NULL, 'G3DSA:2.60.40.10:FF:002844', NULL, NULL, 'Transcriptional regulator, AraC/XylS family', NULL, NULL, NULL, NULL, NULL, 4),
(30739, NULL, 'G3DSA:2.60.40.2300:FF:000017', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(30740, NULL, 'G3DSA:3.80.10.10:FF:004233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30741, NULL, 'G3DSA:3.30.70.60:FF:000038', NULL, NULL, '30S ribosomal protein S6', NULL, NULL, NULL, NULL, NULL, 4),
(30742, NULL, 'G3DSA:3.40.50.2300:FF:001241', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30743, NULL, 'G3DSA:3.90.70.10:FF:000701', NULL, NULL, 'Ubiquitin specific protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(30744, NULL, 'G3DSA:3.40.50.300:FF:000765', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(30745, NULL, 'G3DSA:2.40.50.140:FF:001160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30746, NULL, 'G3DSA:2.30.29.30:FF:000993', NULL, NULL, 'Subunit of ESCRT-II complex', NULL, NULL, NULL, NULL, NULL, 4),
(30747, NULL, 'G3DSA:3.40.720.10:FF:000263', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(30748, NULL, 'G3DSA:1.10.555.10:FF:000067', NULL, NULL, 'Rho GTPase-activating protein conundrum', NULL, NULL, NULL, NULL, NULL, 4),
(30749, NULL, 'G3DSA:1.20.1250.20:FF:000297', NULL, NULL, 'Solute carrier family 22 member 18', NULL, NULL, NULL, NULL, NULL, 4),
(30750, NULL, 'G3DSA:3.30.160.60:FF:001984', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(30751, NULL, 'G3DSA:1.10.3380.30:FF:000025', NULL, NULL, 'ATP-dependent DNA helicase Hel308', NULL, NULL, NULL, NULL, NULL, 4),
(30752, NULL, 'G3DSA:4.10.410.60:FF:000004', NULL, NULL, 'Related to 50S ribosomal protein L35', NULL, NULL, NULL, NULL, NULL, 4),
(30753, NULL, 'G3DSA:3.30.565.10:FF:000246', NULL, NULL, 'Heat Shock Protein', NULL, NULL, NULL, NULL, NULL, 4),
(30754, NULL, 'G3DSA:3.30.200.20:FF:001370', NULL, NULL, 'Unc-51-like kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(30755, NULL, 'G3DSA:3.40.50.12710:FF:000018', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7', NULL, NULL, NULL, NULL, NULL, 4),
(30756, NULL, 'G3DSA:3.40.50.150:FF:000254', NULL, NULL, 'Ribosomal RNA-processing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(30757, NULL, 'G3DSA:1.20.1050.10:FF:000020', NULL, NULL, 'Glutathione S-transferase P 1', NULL, NULL, NULL, NULL, NULL, 4),
(30758, NULL, 'G3DSA:3.30.1520.10:FF:000086', NULL, NULL, 'Sorting nexin-4', NULL, NULL, NULL, NULL, NULL, 4),
(30759, NULL, 'G3DSA:3.90.170.10:FF:000012', NULL, NULL, 'Adenylosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(30760, NULL, 'G3DSA:1.25.40.20:FF:001840', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30761, NULL, 'G3DSA:2.60.40.150:FF:000190', NULL, NULL, 'ADP-ribosylation factor GTPase-activating protein AGD12', NULL, NULL, NULL, NULL, NULL, 4),
(30762, NULL, 'G3DSA:2.60.40.3210:FF:000009', NULL, NULL, 'CUB and zona pellucida-like domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(30763, NULL, 'G3DSA:2.130.10.10:FF:002968', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(30764, NULL, 'G3DSA:3.50.50.60:FF:001301', NULL, NULL, 'Thioredoxin reductase 2', NULL, NULL, NULL, NULL, NULL, 4),
(30765, NULL, 'G3DSA:3.40.850.10:FF:000452', NULL, NULL, 'Kinesin family member 6', NULL, NULL, NULL, NULL, NULL, 4),
(30766, NULL, 'G3DSA:1.25.40.10:FF:003395', NULL, NULL, 'PPR repeat family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(30767, NULL, 'G3DSA:2.40.50.90:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30768, NULL, 'G3DSA:3.40.430.10:FF:000021', NULL, NULL, 'Riboflavin biosynthesis protein RibD', NULL, NULL, NULL, NULL, NULL, 4),
(30769, NULL, 'G3DSA:1.20.1250.20:FF:000830', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(30770, NULL, 'G3DSA:2.40.10.170:FF:000019', NULL, NULL, 'Transcription-repair-coupling factor', NULL, NULL, NULL, NULL, NULL, 4),
(30771, NULL, 'G3DSA:3.30.450.40:FF:000264', NULL, NULL, 'Chromosome 21, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(30772, NULL, 'G3DSA:2.60.40.60:FF:000684', NULL, NULL, 'Protocadherin fat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(30773, NULL, 'G3DSA:3.30.413.10:FF:000017', NULL, NULL, 'Nitrite reductase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(30774, NULL, 'G3DSA:1.20.5.110:FF:000304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30775, NULL, 'G3DSA:1.10.287.770:FF:000025', NULL, NULL, 'Pickpocket 5, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(30776, NULL, 'G3DSA:3.30.70.330:FF:001562', NULL, NULL, 'Protein CBR-EXC-7', NULL, NULL, NULL, NULL, NULL, 4),
(30777, NULL, 'G3DSA:3.80.10.10:FF:000338', NULL, NULL, 'protein scribble homolog isoform X12', NULL, NULL, NULL, NULL, NULL, 4),
(30778, NULL, 'G3DSA:3.40.190.10:FF:000480', NULL, NULL, 'Putative ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(30779, NULL, 'G3DSA:3.40.605.10:FF:000017', NULL, NULL, 'Bifunctional protein PutA', NULL, NULL, NULL, NULL, NULL, 4),
(30780, NULL, 'G3DSA:3.40.50.300:FF:006897', NULL, NULL, 'Elongator complex protein 6 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(30781, NULL, 'G3DSA:1.10.10.10:FF:001155', NULL, NULL, 'Transcriptional adapter', NULL, NULL, NULL, NULL, NULL, 4),
(30782, NULL, 'G3DSA:3.30.190.20:FF:000007', NULL, NULL, '54S ribosomal protein L1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(30783, NULL, 'G3DSA:3.30.160.60:FF:000079', NULL, NULL, 'Spalt-like transcription factor 3', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(30784, NULL, 'G3DSA:1.10.1200.270:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30785, NULL, 'G3DSA:1.20.58.1610:FF:000010', NULL, NULL, 'NADH-quinone oxidoreductase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(30786, NULL, 'G3DSA:3.60.40.10:FF:000329', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(30787, NULL, 'G3DSA:4.10.280.10:FF:000192', NULL, NULL, 'Transcription factor bHLH109', NULL, NULL, NULL, NULL, NULL, 4),
(30788, NULL, 'G3DSA:2.130.10.10:FF:005458', NULL, NULL, 'Transducin (beta)-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(30789, NULL, 'G3DSA:3.40.50.620:FF:000804', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30790, NULL, 'G3DSA:3.40.50.10260:FF:000002', NULL, NULL, 'NAD(P)H-hydrate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(30791, NULL, 'G3DSA:2.10.25.10:FF:000473', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(30792, NULL, 'G3DSA:3.30.420.10:FF:000096', NULL, NULL, 'Uncharacterized exonuclease domain-containing protein At3g15140', NULL, NULL, NULL, NULL, NULL, 4),
(30793, NULL, 'G3DSA:3.30.40.10:FF:001680', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(30794, NULL, 'G3DSA:2.130.10.10:FF:005082', NULL, NULL, 'Intermediate dynein chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(30795, NULL, 'G3DSA:3.40.50.2300:FF:000285', NULL, NULL, 'Putative sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(30796, NULL, 'G3DSA:1.20.1250.20:FF:001286', NULL, NULL, 'MFS permease', NULL, NULL, NULL, NULL, NULL, 4),
(30797, NULL, 'G3DSA:3.30.200.20:FF:000386', NULL, NULL, 'Fibrillarin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(30798, NULL, 'G3DSA:3.80.10.10:FF:000490', NULL, NULL, 'Leucine rich repeat containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(30799, NULL, 'G3DSA:3.30.70.1230:FF:000023', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(30800, NULL, 'G3DSA:1.20.1250.20:FF:001230', NULL, NULL, 'Solute carrier family 45 member 3', NULL, NULL, NULL, NULL, NULL, 4),
(30801, NULL, 'G3DSA:1.10.1040.30:FF:000011', NULL, NULL, 'Atpase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(30802, NULL, 'G3DSA:3.40.1110.10:FF:000114', NULL, NULL, 'H /K ATPase alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(30803, NULL, 'G3DSA:1.20.910.10:FF:000014', NULL, NULL, 'Heme oxygenase 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(30804, NULL, 'G3DSA:3.30.450.20:FF:000106', NULL, NULL, 'Potassium voltage-gated channel subfamily H member 1', NULL, NULL, NULL, NULL, NULL, 4),
(30805, NULL, 'G3DSA:3.30.1680.10:FF:000007', NULL, NULL, 'semaphorin-6A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(30806, NULL, 'G3DSA:1.10.8.10:FF:000002', NULL, NULL, 'UV excision repair protein RAD23 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(30807, NULL, 'G3DSA:3.30.160.60:FF:002024', NULL, NULL, 'Tripartite motif containing 10', NULL, NULL, NULL, NULL, NULL, 4),
(30808, NULL, 'G3DSA:3.40.1280.30:FF:000014', NULL, NULL, 'tRNA methyltransferase 10B', NULL, NULL, NULL, NULL, NULL, 4),
(30809, NULL, 'G3DSA:3.40.50.300:FF:002210', NULL, NULL, 'Sugar ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(30810, NULL, 'G3DSA:1.10.3730.20:FF:000038', NULL, NULL, 'Integral membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(30811, NULL, 'G3DSA:2.60.40.10:FF:005334', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30812, NULL, 'G3DSA:2.30.29.30:FF:000138', NULL, NULL, 'Ventricular zone-expressed PH domain-containing protein-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(30813, NULL, 'G3DSA:1.10.375.10:FF:000007', NULL, NULL, 'Gag polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(30814, NULL, 'G3DSA:1.10.472.80:FF:000097', NULL, NULL, 'Growth hormone-regulated TBC protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(30815, NULL, 'G3DSA:1.20.1560.10:FF:000250', NULL, NULL, 'ATP binding transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(30816, NULL, 'G3DSA:2.60.120.10:FF:000143', NULL, NULL, 'Cyclic nucleotide-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(30817, NULL, 'G3DSA:1.25.10.10:FF:000638', NULL, NULL, 'Zyg eleven-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(30818, NULL, 'G3DSA:1.10.455.10:FF:000008', NULL, NULL, '40S ribosomal protein S5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(30819, NULL, 'G3DSA:2.130.10.10:FF:000787', NULL, NULL, 'sperm-associated antigen 16 protein', NULL, NULL, NULL, NULL, NULL, 4),
(30820, NULL, 'G3DSA:3.40.50.720:FF:000155', NULL, NULL, 'Adenosylhomocysteinase', NULL, NULL, NULL, NULL, NULL, 4),
(30821, NULL, 'G3DSA:3.90.550.10:FF:000058', NULL, NULL, 'Exostosin-like glycosyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(30822, NULL, 'G3DSA:2.130.10.10:FF:001187', NULL, NULL, 'Chromatin assembly factor-1 p105 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(30823, NULL, 'G3DSA:3.20.20.70:FF:000264', NULL, NULL, 'Pyridoxine 5''-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(30824, NULL, 'G3DSA:3.30.390.50:FF:000003', NULL, NULL, 'Aldehyde oxidase1', NULL, NULL, NULL, NULL, NULL, 4),
(30825, NULL, 'G3DSA:2.40.50.40:FF:000073', NULL, NULL, 'Chemokine (C-C motif) ligand 39, duplicate 2', NULL, NULL, NULL, NULL, NULL, 4),
(30826, NULL, 'G3DSA:3.40.50.300:FF:001810', NULL, NULL, 'Cytoplasmic dynein 2 heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(30827, NULL, 'G3DSA:1.10.10.60:FF:001176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30828, NULL, 'G3DSA:1.10.630.10:FF:000410', NULL, NULL, 'cytochrome P450 2C31', NULL, NULL, NULL, NULL, NULL, 4),
(30829, NULL, 'G3DSA:2.60.120.200:FF:000270', NULL, NULL, 'Legume-like lectin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(30830, NULL, 'G3DSA:1.10.560.10:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30831, NULL, 'G3DSA:3.90.470.10:FF:000001', NULL, NULL, '50S ribosomal protein L22', NULL, NULL, NULL, NULL, NULL, 4),
(30832, NULL, 'G3DSA:1.25.10.10:FF:002639', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30833, NULL, 'G3DSA:2.60.40.1180:FF:000063', NULL, NULL, 'Adenylyl-sulfate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(30834, NULL, 'G3DSA:3.40.50.11030:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30835, NULL, 'G3DSA:2.60.40.10:FF:000899', NULL, NULL, 'Tissue factor', NULL, NULL, NULL, NULL, NULL, 4),
(30836, NULL, 'G3DSA:3.10.20.90:FF:000091', NULL, NULL, 'Splicing factor 3A subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(30837, NULL, 'G3DSA:3.40.50.300:FF:003694', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(30838, NULL, 'G3DSA:2.10.109.10:FF:000066', NULL, NULL, 'LexA repressor', NULL, NULL, NULL, NULL, NULL, 4),
(30839, NULL, 'G3DSA:3.40.50.150:FF:001743', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30840, NULL, 'G3DSA:1.20.1070.10:FF:001331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30841, NULL, 'G3DSA:1.10.533.10:FF:000027', NULL, NULL, 'Interleukin-1 receptor-associated kinase 1 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(30842, NULL, 'G3DSA:3.40.50.300:FF:003019', NULL, NULL, 'Elongation factor 1-alpha, putative', NULL, NULL, NULL, NULL, NULL, 4),
(30843, NULL, 'G3DSA:3.10.50.40:FF:000162', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(30844, NULL, 'G3DSA:2.60.40.10:FF:003856', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30845, NULL, 'G3DSA:3.30.300.30:FF:000155', NULL, NULL, 'Siderophore peptide synthetase fer3', NULL, NULL, NULL, NULL, NULL, 4),
(30846, NULL, 'G3DSA:2.60.120.40:FF:000006', NULL, NULL, 'complement C1q tumor necrosis factor-related protein 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(30847, NULL, 'G3DSA:3.20.20.80:FF:000598', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30848, NULL, 'G3DSA:3.20.20.80:FF:000654', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30849, NULL, 'G3DSA:3.30.420.10:FF:000601', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30850, NULL, 'G3DSA:2.60.11.10:FF:000001', NULL, NULL, 'Cytochrome c oxidase subunit 5B, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(30851, NULL, 'G3DSA:2.40.10.10:FF:000589', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30852, NULL, 'G3DSA:2.130.10.10:FF:004969', NULL, NULL, 'ASTRA-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(30853, NULL, 'G3DSA:3.30.1360.170:FF:000009', NULL, NULL, 'Cation efflux system protein', NULL, NULL, NULL, NULL, NULL, 4),
(30854, NULL, 'G3DSA:3.40.50.1000:FF:000614', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30855, NULL, 'G3DSA:3.40.50.10050:FF:000001', NULL, NULL, 'Translation initiation factor IF-2', NULL, NULL, NULL, NULL, NULL, 4),
(30856, NULL, 'G3DSA:3.30.760.10:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30857, NULL, 'G3DSA:4.10.280.10:FF:000220', NULL, NULL, 'Achaete-scute family bHLH transcription factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(30858, NULL, 'G3DSA:1.25.40.10:FF:002383', NULL, NULL, 'Os02g0226900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(30859, NULL, 'G3DSA:3.30.450.20:FF:000578', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30860, NULL, 'G3DSA:3.30.200.20:FF:001375', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30861, NULL, 'G3DSA:2.40.10.10:FF:000117', NULL, NULL, 'Protein Z, vitamin K-dependent plasma glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(30862, NULL, 'G3DSA:3.20.20.60:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30863, NULL, 'G3DSA:3.40.50.150:FF:001687', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30864, NULL, 'G3DSA:3.40.190.80:FF:000045', NULL, NULL, 'Inositol monophosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(30865, NULL, 'G3DSA:2.60.40.640:FF:000010', NULL, NULL, 'Vacuolar protein sorting-associated protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(30866, NULL, 'G3DSA:3.30.70.330:FF:002904', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30867, NULL, 'G3DSA:3.50.50.80:FF:000003', NULL, NULL, 'Ubiquitin-activating enzyme E1 2', NULL, NULL, NULL, NULL, NULL, 4),
(30868, NULL, 'G3DSA:1.20.5.170:FF:000187', NULL, NULL, 'Transcription factor fos-1', NULL, NULL, NULL, NULL, NULL, 4),
(30869, NULL, 'G3DSA:3.40.50.1820:FF:001260', NULL, NULL, 'Homoserine O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(30870, NULL, 'G3DSA:1.20.1270.130:FF:000001', NULL, NULL, 'Invasion plasmid antigen IpaH', NULL, NULL, NULL, NULL, NULL, 4),
(30871, NULL, 'G3DSA:2.60.120.920:FF:000160', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(30872, NULL, 'G3DSA:1.10.287.380:FF:000026', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(30873, NULL, 'G3DSA:1.20.1250.20:FF:000302', NULL, NULL, 'MFS siderochrome iron transporter MirB', NULL, NULL, NULL, NULL, NULL, 4),
(30874, NULL, 'G3DSA:3.40.50.720:FF:002448', NULL, NULL, 'ADR079Cp', NULL, NULL, NULL, NULL, NULL, 4),
(30875, NULL, 'G3DSA:3.90.1410.10:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30876, NULL, 'G3DSA:3.40.50.300:FF:007729', NULL, NULL, 'Protein KTI12 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(30877, NULL, 'G3DSA:3.40.50.150:FF:001248', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30878, NULL, 'G3DSA:2.60.40.10:FF:000427', NULL, NULL, 'Nectin cell adhesion molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(30879, NULL, 'G3DSA:3.20.14.10:FF:000001', NULL, NULL, 'L-fucose isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(30880, NULL, 'G3DSA:2.60.120.290:FF:000077', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(30881, NULL, 'G3DSA:1.10.1100.10:FF:000004', NULL, NULL, 'Transcription initiation factor TFIID subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(30882, NULL, 'G3DSA:2.30.29.30:FF:000577', NULL, NULL, 'WGS project CABT00000000 data, contig 2.21', NULL, NULL, NULL, NULL, NULL, 4),
(30883, NULL, 'G3DSA:3.30.1120.10:FF:000033', NULL, NULL, 'DUF229 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(30884, NULL, 'G3DSA:3.40.50.720:FF:002156', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(30885, NULL, 'G3DSA:2.10.25.10:FF:001305', NULL, NULL, 'Crumbs-like protein 2b', NULL, NULL, NULL, NULL, NULL, 4),
(30886, NULL, 'G3DSA:3.30.70.330:FF:000926', NULL, NULL, 'Ribonucleoprotein, PTB-binding 1', NULL, NULL, NULL, NULL, NULL, 4),
(30887, NULL, 'G3DSA:3.90.550.10:FF:000002', NULL, NULL, 'UTP--glucose-1-phosphate uridylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(30888, NULL, 'G3DSA:2.40.50.90:FF:000099', NULL, NULL, 'Tudor domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(30889, NULL, 'G3DSA:3.30.160.60:FF:000023', NULL, NULL, 'zinc finger protein 37 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(30890, NULL, 'G3DSA:3.30.50.10:FF:000101', NULL, NULL, 'nuclear receptor isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(30891, NULL, 'G3DSA:2.60.40.60:FF:000212', NULL, NULL, 'Cadherin 17', NULL, NULL, NULL, NULL, NULL, 4),
(30892, NULL, 'G3DSA:3.40.190.10:FF:000300', NULL, NULL, 'C4-dicarboxylate ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(30893, NULL, 'G3DSA:1.20.120.1750:FF:000009', NULL, NULL, 'E3 ubiquitin-protein ligase parkin', NULL, NULL, NULL, NULL, NULL, 4),
(30894, NULL, 'G3DSA:1.10.10.1100:FF:000006', NULL, NULL, '2Fe-2S iron-sulfur cluster-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(30895, NULL, 'G3DSA:2.60.40.60:FF:000504', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30896, NULL, 'G3DSA:2.60.40.60:FF:000156', NULL, NULL, 'cadherin-23 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(30897, NULL, 'G3DSA:2.60.120.10:FF:000582', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(30898, NULL, 'G3DSA:3.30.1120.30:FF:000039', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(30899, NULL, 'G3DSA:3.30.450.20:FF:000634', NULL, NULL, 'Two component system histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(30900, NULL, 'G3DSA:1.20.140.40:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30901, NULL, 'G3DSA:3.10.20.320:FF:000002', NULL, NULL, 'Sucrose-6-phosphate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(30902, NULL, 'G3DSA:3.40.50.300:FF:003547', NULL, NULL, 'Si:ch211-243j20.2', NULL, NULL, NULL, NULL, NULL, 4),
(30903, NULL, 'G3DSA:1.10.287.1260:FF:000004', NULL, NULL, 'Transporter, small conductance mechanosensitive ion channel family', NULL, NULL, NULL, NULL, NULL, 4),
(30904, NULL, 'G3DSA:3.40.50.300:FF:007061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30905, NULL, 'G3DSA:4.10.1240.10:FF:000074', NULL, NULL, 'Calcitonin receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(30906, NULL, 'G3DSA:3.50.50.60:FF:001273', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(30907, NULL, 'G3DSA:3.30.420.40:FF:001072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30908, NULL, 'G3DSA:2.60.120.470:FF:000007', NULL, NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(30909, NULL, 'G3DSA:1.25.40.10:FF:002759', NULL, NULL, 'Tetratricopeptide repeat protein 19, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(30910, NULL, 'G3DSA:1.25.40.20:FF:000351', NULL, NULL, 'E3 ubiquitin-protein ligase KEG', NULL, NULL, NULL, NULL, NULL, 4),
(30911, NULL, 'G3DSA:3.30.70.2850:FF:000025', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(30912, NULL, 'G3DSA:3.20.20.80:FF:000126', NULL, NULL, 'Glucosylceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(30913, NULL, 'G3DSA:2.60.120.380:FF:000008', NULL, NULL, 'Calpain 7', NULL, NULL, NULL, NULL, NULL, 4),
(30914, NULL, 'G3DSA:3.40.50.300:FF:007353', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30915, NULL, 'G3DSA:1.25.40.10:FF:005137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30916, NULL, 'G3DSA:3.30.160.60:FF:001192', NULL, NULL, 'ZXD family zinc finger C', NULL, NULL, NULL, NULL, NULL, 4),
(30917, NULL, 'G3DSA:1.10.510.10:FF:003948', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(30918, NULL, 'G3DSA:1.25.40.20:FF:000379', NULL, NULL, 'Ankyrin repeat-containing protein At5g02620', NULL, NULL, NULL, NULL, NULL, 4),
(30919, NULL, 'G3DSA:3.40.50.11350:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30920, NULL, 'G3DSA:3.30.1360.150:FF:000003', NULL, NULL, 'Alkaline phosphatase PafA', NULL, NULL, NULL, NULL, NULL, 4),
(30921, NULL, 'G3DSA:3.30.160.60:FF:004441', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30922, NULL, 'G3DSA:1.20.1510.10:FF:000067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30923, NULL, 'G3DSA:1.20.58.60:FF:000554', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30924, NULL, 'G3DSA:2.140.10.20:FF:000003', NULL, NULL, 'Cytochrome cd1 nitrite reductase', NULL, NULL, NULL, NULL, NULL, 4),
(30925, NULL, 'G3DSA:1.25.40.10:FF:003872', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30926, NULL, 'G3DSA:2.30.30.100:FF:000168', NULL, NULL, 'Protein CBG22276', NULL, NULL, NULL, NULL, NULL, 4),
(30927, NULL, 'G3DSA:1.20.58.2190:FF:000010', NULL, NULL, 'Glycosyl hydrolase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(30928, NULL, 'G3DSA:1.10.510.10:FF:003656', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30929, NULL, 'G3DSA:2.60.120.860:FF:000001', NULL, NULL, 'Distal tail protein', NULL, NULL, NULL, NULL, NULL, 4),
(30930, NULL, 'G3DSA:2.60.120.10:FF:000435', NULL, NULL, 'Mannose-6-phosphate isomerase, class I', NULL, NULL, NULL, NULL, NULL, 4),
(30931, NULL, 'G3DSA:3.30.360.10:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30932, NULL, 'G3DSA:1.10.8.10:FF:000007', NULL, NULL, 'Ubiquilin 1', NULL, NULL, NULL, NULL, NULL, 4),
(30933, NULL, 'G3DSA:3.40.50.720:FF:000211', NULL, NULL, '3-hydroxybutyrate dehydrogenase type 2', NULL, NULL, NULL, NULL, NULL, 4),
(30934, NULL, 'G3DSA:3.30.2010.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30935, NULL, 'G3DSA:1.10.340.70:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30936, NULL, 'G3DSA:3.40.30.10:FF:000313', NULL, NULL, 'Thioredoxin H9', NULL, NULL, NULL, NULL, NULL, 4),
(30937, NULL, 'G3DSA:1.25.10.10:FF:003191', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(30938, NULL, 'G3DSA:1.20.1280.290:FF:000096', NULL, NULL, 'Bidirectional sugar transporter SWEET', NULL, NULL, NULL, NULL, NULL, 4),
(30939, NULL, 'G3DSA:3.30.260.10:FF:000089', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30940, NULL, 'G3DSA:3.30.160.60:FF:006239', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30941, NULL, 'G3DSA:3.30.930.10:FF:000415', NULL, NULL, 'Lysine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(30942, NULL, 'G3DSA:3.40.30.10:FF:000493', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(30943, NULL, 'G3DSA:3.40.50.1820:FF:001344', NULL, NULL, 'Protein CBR-DPF-7', NULL, NULL, NULL, NULL, NULL, 4),
(30944, NULL, 'G3DSA:2.60.40.10:FF:002900', NULL, NULL, 'Immunoglobulin superfamily, member 3', NULL, NULL, NULL, NULL, NULL, 4),
(30945, NULL, 'G3DSA:1.10.238.200:FF:000025', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(30946, NULL, 'G3DSA:2.30.29.30:FF:001066', NULL, NULL, 'Rho GTPase-activating protein 20b', NULL, NULL, NULL, NULL, NULL, 4),
(30947, NULL, 'G3DSA:3.40.30.10:FF:000841', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30948, NULL, 'G3DSA:3.30.980.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30949, NULL, 'G3DSA:3.40.50.300:FF:002682', NULL, NULL, 'Regulator of nonsense transcripts 1', NULL, NULL, NULL, NULL, NULL, 4),
(30950, NULL, 'G3DSA:1.50.40.10:FF:000082', NULL, NULL, 'Mitochondrial succinate-fumarate transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(30951, NULL, 'G3DSA:1.25.40.10:FF:001450', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(30952, NULL, 'G3DSA:2.60.120.200:FF:000646', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30953, NULL, 'G3DSA:3.20.20.70:FF:000741', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30954, NULL, 'G3DSA:2.60.40.10:FF:003480', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30955, NULL, 'G3DSA:2.120.10.30:FF:000086', NULL, NULL, 'NHL repeat-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(30956, NULL, 'G3DSA:3.40.50.1820:FF:000708', NULL, NULL, 'Protein CBG13010', NULL, NULL, NULL, NULL, NULL, 4),
(30957, NULL, 'G3DSA:2.40.10.10:FF:000084', NULL, NULL, 'Serine protease easter', NULL, NULL, NULL, NULL, NULL, 4),
(30958, NULL, 'G3DSA:3.40.50.300:FF:001754', NULL, NULL, 'DNA replication licensing factor', NULL, NULL, NULL, NULL, NULL, 4),
(30959, NULL, 'G3DSA:3.40.50.2000:FF:000785', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(30960, NULL, 'G3DSA:3.90.1410.10:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30961, NULL, 'G3DSA:2.60.120.620:FF:000036', NULL, NULL, 'Prolyl 3-hydroxylase sudestada1', NULL, NULL, NULL, NULL, NULL, 4),
(30962, NULL, 'G3DSA:3.30.160.60:FF:002496', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(30963, NULL, 'G3DSA:3.40.850.10:FF:000036', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(30964, NULL, 'G3DSA:2.60.40.10:FF:002552', NULL, NULL, 'Myotactin form B', NULL, NULL, NULL, NULL, NULL, 4),
(30965, NULL, 'G3DSA:1.10.10.10:FF:001947', NULL, NULL, 'Histone H1, sperm', NULL, NULL, NULL, NULL, NULL, 4),
(30966, NULL, 'G3DSA:3.90.850.10:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30967, NULL, 'G3DSA:1.10.630.10:FF:000697', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30968, NULL, 'G3DSA:2.30.42.10:FF:000540', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30969, NULL, 'G3DSA:3.20.20.140:FF:000108', NULL, NULL, 'Predicted metal-dependent hydrolase, TIM-barrel fold', NULL, NULL, NULL, NULL, NULL, 4),
(30970, NULL, 'G3DSA:2.10.25.10:FF:000001', NULL, NULL, 'Tenascin C', NULL, NULL, NULL, NULL, NULL, 4),
(30971, NULL, 'G3DSA:1.10.940.10:FF:000035', NULL, NULL, 'Sun protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(30972, NULL, 'G3DSA:1.10.238.20:FF:000035', NULL, NULL, 'GEO02492p1', NULL, NULL, NULL, NULL, NULL, 4),
(30973, NULL, 'G3DSA:4.10.372.10:FF:000001', NULL, NULL, 'Lipoxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(30974, NULL, 'G3DSA:3.30.160.60:FF:001568', NULL, NULL, 'Zinc finger X-linked protein ZXDB', NULL, NULL, NULL, NULL, NULL, 4),
(30975, NULL, 'G3DSA:1.10.3720.10:FF:000063', NULL, NULL, 'Phosphate transport system permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(30976, NULL, 'G3DSA:2.60.40.10:FF:004789', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30977, NULL, 'G3DSA:3.80.10.10:FF:001030', NULL, NULL, 'Acid labile subunit', NULL, NULL, NULL, NULL, NULL, 4),
(30978, NULL, 'G3DSA:1.25.40.10:FF:000466', NULL, NULL, 'Putative TPR repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(30979, NULL, 'G3DSA:2.60.120.650:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30980, NULL, 'G3DSA:3.40.50.300:FF:001569', NULL, NULL, 'ABC multidrug transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(30981, NULL, 'G3DSA:3.30.900.10:FF:000026', NULL, NULL, 'Mitotic spindle checkpoint protein (Mad2), putative', NULL, NULL, NULL, NULL, NULL, 4),
(30982, NULL, 'G3DSA:3.40.50.2300:FF:000313', NULL, NULL, 'Ssu72 CTD phosphatase, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(30983, NULL, 'G3DSA:3.10.28.10:FF:000056', NULL, NULL, 'DNA gyrase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(30984, NULL, 'G3DSA:1.10.287.110:FF:000322', NULL, NULL, 'DnaJ-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(30985, NULL, 'G3DSA:2.40.70.10:FF:000060', NULL, NULL, 'Aspartic-type endopeptidase ctsD', NULL, NULL, NULL, NULL, NULL, 4),
(30986, NULL, 'G3DSA:1.10.630.10:FF:000169', NULL, NULL, 'Epi-isozizaene 5-monooxygenase/(E)-beta-farnesene synthase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(30987, NULL, 'G3DSA:2.60.120.10:FF:000087', NULL, NULL, 'Cyclic nucleotide-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(30988, NULL, 'G3DSA:3.40.930.10:FF:000037', NULL, NULL, 'Anion exchange protein', NULL, NULL, NULL, NULL, NULL, 4),
(30989, NULL, 'G3DSA:3.40.50.300:FF:006425', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30990, NULL, 'G3DSA:2.40.50.140:FF:000940', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(30991, NULL, 'G3DSA:1.10.1000.11:FF:000032', NULL, NULL, 'IQ motif and Sec7 domain 3a', NULL, NULL, NULL, NULL, NULL, 4),
(30992, NULL, 'G3DSA:1.20.58.390:FF:000202', NULL, NULL, 'Transmembrane ion channel', NULL, NULL, NULL, NULL, NULL, 4),
(30993, NULL, 'G3DSA:3.40.50.720:FF:002072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(30994, NULL, 'G3DSA:3.30.70.960:FF:000025', NULL, NULL, 'Suppressor of tumorigenicity 14 protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(30995, NULL, 'G3DSA:1.20.1310.10:FF:000063', NULL, NULL, 'CDC53p Cullin', NULL, NULL, NULL, NULL, NULL, 4),
(30996, NULL, 'G3DSA:3.30.1360.10:FF:000051', NULL, NULL, 'Small RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(30997, NULL, 'G3DSA:3.90.870.40:FF:000001', NULL, NULL, 'Carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(30998, NULL, 'G3DSA:2.30.30.620:FF:000003', NULL, NULL, 'Major vault protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(30999, NULL, 'G3DSA:3.30.160.60:FF:000107', NULL, NULL, 'Zinc finger protein 521', NULL, NULL, NULL, NULL, NULL, 4),
(31000, NULL, 'G3DSA:1.25.40.70:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31001, NULL, 'G3DSA:2.60.40.4370:FF:000003', NULL, NULL, 'General transcription factor 3C polypeptide, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31002, NULL, 'G3DSA:2.160.10.10:FF:000011', NULL, NULL, 'Bifunctional protein GlmU', NULL, NULL, NULL, NULL, NULL, 4),
(31003, NULL, 'G3DSA:3.40.1090.10:FF:000084', NULL, NULL, 'Lysophospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(31004, NULL, 'G3DSA:1.10.510.10:FF:003509', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31005, NULL, 'G3DSA:3.30.460.10:FF:000014', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(31006, NULL, 'G3DSA:2.130.10.10:FF:002676', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31007, NULL, 'G3DSA:3.20.20.80:FF:000093', NULL, NULL, '1,4-alpha-glucan-branching enzyme 3, chloroplastic/amyloplastic', NULL, NULL, NULL, NULL, NULL, 4),
(31008, NULL, 'G3DSA:2.30.30.40:FF:000156', NULL, NULL, 'FYN-binding protein-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(31009, NULL, 'G3DSA:2.70.170.10:FF:000245', NULL, NULL, 'Cholinergic receptor, nicotinic, beta 2', NULL, NULL, NULL, NULL, NULL, 4),
(31010, NULL, 'G3DSA:2.40.50.140:FF:000968', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31011, NULL, 'G3DSA:3.40.50.300:FF:007437', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31012, NULL, 'G3DSA:3.30.420.140:FF:000005', NULL, NULL, 'Putative pre-16S rRNA nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(31013, NULL, 'G3DSA:3.30.9.10:FF:000242', NULL, NULL, 'FAD-dependent oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(31014, NULL, 'G3DSA:3.30.200.20:FF:000442', NULL, NULL, 'Serine/threonine/tyrosine kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(31015, NULL, 'G3DSA:3.30.70.100:FF:000150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31016, NULL, 'G3DSA:3.40.50.620:FF:000327', NULL, NULL, 'Phr1p', NULL, NULL, NULL, NULL, NULL, 4),
(31017, NULL, 'G3DSA:2.30.30.490:FF:000003', NULL, NULL, 'protein polybromo-1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(31018, NULL, 'G3DSA:3.30.40.10:FF:001236', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(31019, NULL, 'G3DSA:2.40.50.140:FF:000232', NULL, NULL, 'Single-stranded DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(31020, NULL, 'G3DSA:3.30.420.40:FF:000436', NULL, NULL, 'Protein CBG07033', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(31021, NULL, 'G3DSA:2.60.120.920:FF:000013', NULL, NULL, 'ATP-dependent RNA helicase DDX1', NULL, NULL, NULL, NULL, NULL, 4),
(31022, NULL, 'G3DSA:2.60.40.10:FF:001916', NULL, NULL, 'Roughest, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(31023, NULL, 'G3DSA:3.30.160.60:FF:004002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31024, NULL, 'G3DSA:1.10.1200.10:FF:000040', NULL, NULL, 'Acyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(31025, NULL, 'G3DSA:3.40.50.1000:FF:000558', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31026, NULL, 'G3DSA:3.30.497.10:FF:000048', NULL, NULL, 'Sodium/hydrogen exchanger 2', NULL, NULL, NULL, NULL, NULL, 4),
(31027, NULL, 'G3DSA:1.10.472.80:FF:000125', NULL, NULL, 'Rab GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31028, NULL, 'G3DSA:2.60.40.10:FF:005626', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31029, NULL, 'G3DSA:1.20.120.620:FF:000012', NULL, NULL, 'Two component signal transduction system controlling the osmosenstive K+ channel histidine kinase KdpD', NULL, NULL, NULL, NULL, NULL, 4),
(31030, NULL, 'G3DSA:2.130.10.10:FF:003513', NULL, NULL, 'WD repeat domain 90', NULL, NULL, NULL, NULL, NULL, 4),
(31031, NULL, 'G3DSA:3.40.1170.20:FF:000003', NULL, NULL, 'tRNA-splicing endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(31032, NULL, 'G3DSA:1.10.287.1130:FF:000016', NULL, NULL, 'Cx9C motif-containing protein 4, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(31033, NULL, 'G3DSA:2.60.120.260:FF:000265', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(31034, NULL, 'G3DSA:1.20.58.60:FF:000369', NULL, NULL, 'Dystrophin-1', NULL, NULL, NULL, NULL, NULL, 4),
(31035, NULL, 'G3DSA:3.90.190.10:FF:000491', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(31036, NULL, 'G3DSA:3.30.450.380:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31037, NULL, 'G3DSA:1.10.8.60:FF:000500', NULL, NULL, '26S proteasome regulatory particle chain RPT6-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(31038, NULL, 'G3DSA:2.30.110.10:FF:000065', NULL, NULL, 'Ferric-chelate reductase (NAD(P)H)', NULL, NULL, NULL, NULL, NULL, 4),
(31039, NULL, 'G3DSA:1.20.5.300:FF:000007', NULL, NULL, 'Phosphoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(31040, NULL, 'G3DSA:3.30.70.330:FF:001146', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(31041, NULL, 'G3DSA:1.25.40.690:FF:000013', NULL, NULL, 'Nuclear pore complex protein nup98, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31042, NULL, 'G3DSA:1.25.10.10:FF:002555', NULL, NULL, 'Proteasome, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31043, NULL, 'G3DSA:2.20.70.10:FF:000167', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(31044, NULL, 'G3DSA:3.30.1490.220:FF:000002', NULL, NULL, 'Inositol-tetrakisphosphate 1-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(31045, NULL, 'G3DSA:1.10.287.470:FF:000053', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(31046, NULL, 'G3DSA:3.30.160.60:FF:003985', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31047, NULL, 'G3DSA:1.10.10.10:FF:000458', NULL, NULL, 'E2F-like (Mammalian transcription factor)', NULL, NULL, NULL, NULL, NULL, 4),
(31048, NULL, 'G3DSA:1.10.1040.10:FF:000033', NULL, NULL, 'PAM1p protein', NULL, NULL, NULL, NULL, NULL, 4),
(31049, NULL, 'G3DSA:1.10.750.20:FF:000006', NULL, NULL, 'neuralized-like protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(31050, NULL, 'G3DSA:3.20.20.100:FF:000086', NULL, NULL, 'Putative sterigmatocystin biosynthesis dehydrogenase stcV', NULL, NULL, NULL, NULL, NULL, 4),
(31051, NULL, 'G3DSA:2.30.29.170:FF:000001', NULL, NULL, 'EF-hand domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(31052, NULL, 'G3DSA:2.10.50.10:FF:000037', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(31053, NULL, 'G3DSA:1.50.40.10:FF:000458', NULL, NULL, 'Ucp4A, isoform C', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(31054, NULL, 'G3DSA:1.20.1080.10:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31055, NULL, 'G3DSA:1.20.5.460:FF:000010', NULL, NULL, 'TIM-barrel enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(31056, NULL, 'G3DSA:1.25.40.10:FF:001163', NULL, NULL, 'Pentatricopeptide repeat protein2263', NULL, NULL, NULL, NULL, NULL, 4),
(31057, NULL, 'G3DSA:3.90.79.10:FF:000193', NULL, NULL, 'ADP ribose hydrolase, putative (MutT/nudix family protein)', NULL, NULL, NULL, NULL, NULL, 4),
(31058, NULL, 'G3DSA:3.60.40.10:FF:000296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31059, NULL, 'G3DSA:1.10.238.10:FF:001286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31060, NULL, 'G3DSA:1.20.1050.130:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31061, NULL, 'G3DSA:3.90.190.10:FF:000047', NULL, NULL, 'Paladin isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(31062, NULL, 'G3DSA:3.40.1690.20:FF:000003', NULL, NULL, 'Mitochondrial inner membrane AAA protease Yta12, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31063, NULL, 'G3DSA:1.10.510.10:FF:003392', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31064, NULL, 'G3DSA:1.10.10.10:FF:000514', NULL, NULL, 'RNA polymerase sigma factor sigE, chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(31065, NULL, 'G3DSA:2.40.50.120:FF:000018', NULL, NULL, 'netrin-3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(31066, NULL, 'G3DSA:3.40.50.620:FF:000619', NULL, NULL, 'Chromosome 16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(31067, NULL, 'G3DSA:3.30.160.60:FF:003457', NULL, NULL, 'Ras-responsive element-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(31068, NULL, 'G3DSA:1.20.1070.10:FF:000111', NULL, NULL, 'Adhesion G protein-coupled receptor A2', NULL, NULL, NULL, NULL, NULL, 4),
(31069, NULL, 'G3DSA:3.80.10.10:FF:003536', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31070, NULL, 'G3DSA:1.10.238.10:FF:000830', NULL, NULL, 'calmodulin-related protein-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(31071, NULL, 'G3DSA:2.160.20.70:FF:000012', NULL, NULL, 'Cyclase-associated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31072, NULL, 'G3DSA:3.10.290.70:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31073, NULL, 'G3DSA:3.40.5.60:FF:000006', NULL, NULL, 'DNA replication complex GINS protein SLD5', NULL, NULL, NULL, NULL, NULL, 4),
(31074, NULL, 'G3DSA:3.60.21.10:FF:000084', NULL, NULL, 'Serine/threonine-protein phosphatase 2', NULL, NULL, NULL, NULL, NULL, 4),
(31075, NULL, 'G3DSA:2.60.40.10:FF:001883', NULL, NULL, 'Cilia- and flagella-associated protein 74', NULL, NULL, NULL, NULL, NULL, 4),
(31076, NULL, 'G3DSA:2.60.40.2170:FF:000017', NULL, NULL, 'Receptor tyrosine kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(31077, NULL, 'G3DSA:1.20.1070.10:FF:000583', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(31078, NULL, 'G3DSA:2.30.30.40:FF:000504', NULL, NULL, 'Dynamin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(31079, NULL, 'G3DSA:3.80.10.10:FF:004048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31080, NULL, 'G3DSA:2.20.200.10:FF:000001', NULL, NULL, 'Multidrug resistance outer membrane protein MdtP', NULL, NULL, NULL, NULL, NULL, 4),
(31081, NULL, 'G3DSA:2.40.50.100:FF:000012', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(31082, NULL, 'G3DSA:3.40.640.10:FF:000498', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(31083, NULL, 'G3DSA:1.20.1070.10:FF:000055', NULL, NULL, 'Taste receptor type 2', NULL, NULL, NULL, NULL, NULL, 4),
(31084, NULL, 'G3DSA:2.40.50.150:FF:000033', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(31085, NULL, 'G3DSA:3.10.200.10:FF:000011', NULL, NULL, 'Protein tyrosine phosphatase receptor type Z1b', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(31086, NULL, 'G3DSA:3.30.420.510:FF:000021', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(31087, NULL, 'G3DSA:3.30.420.10:FF:000129', NULL, NULL, 'Exosome complex exonuclease RRP6', NULL, NULL, NULL, NULL, NULL, 4),
(31088, NULL, 'G3DSA:3.30.2410.10:FF:000050', NULL, NULL, 'E3 ubiquitin-protein ligase etc-1', NULL, NULL, NULL, NULL, NULL, 4),
(31089, NULL, 'G3DSA:3.30.420.40:FF:000200', NULL, NULL, 'L-xylulose/3-keto-L-gulonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(31090, NULL, 'G3DSA:2.60.40.420:FF:000236', NULL, NULL, 'Ceruloplasmin', NULL, NULL, NULL, NULL, NULL, 4),
(31091, NULL, 'G3DSA:2.10.25.10:FF:001018', NULL, NULL, 'Protein cueball-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(31092, NULL, 'G3DSA:3.40.50.300:FF:002238', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(31093, NULL, 'G3DSA:3.40.50.1110:FF:000119', NULL, NULL, 'Phospholipase B1, membrane-associated', NULL, NULL, NULL, NULL, NULL, 4),
(31094, NULL, 'G3DSA:3.30.160.60:FF:001799', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31095, NULL, 'G3DSA:3.10.120.10:FF:000010', NULL, NULL, 'Delta-6 fatty acyl desaturase', NULL, NULL, NULL, NULL, NULL, 4),
(31096, NULL, 'G3DSA:3.40.50.11990:FF:000004', NULL, NULL, 'Potential RNA Pol II elongation accessory factor', NULL, NULL, NULL, NULL, NULL, 4),
(31097, NULL, 'G3DSA:2.30.42.10:FF:000624', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31098, NULL, 'G3DSA:3.90.660.20:FF:000013', NULL, NULL, 'Blr3003 protein', NULL, NULL, NULL, NULL, NULL, 4),
(31099, NULL, 'G3DSA:1.25.40.20:FF:000615', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31100, NULL, 'G3DSA:1.20.58.670:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31101, NULL, 'G3DSA:1.10.10.60:FF:001029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31102, NULL, 'G3DSA:2.120.10.80:FF:000016', NULL, NULL, 'Kelch domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(31103, NULL, 'G3DSA:3.50.30.30:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31104, NULL, 'G3DSA:3.40.50.300:FF:002766', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31105, NULL, 'G3DSA:3.20.20.70:FF:000825', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31106, NULL, 'G3DSA:2.60.40.1090:FF:000036', NULL, NULL, 'Frimbrial protein', NULL, NULL, NULL, NULL, NULL, 4),
(31107, NULL, 'G3DSA:3.40.50.1820:FF:000040', NULL, NULL, 'SPG21, maspardin', NULL, NULL, NULL, NULL, NULL, 4),
(31108, NULL, 'G3DSA:3.40.50.10880:FF:000008', NULL, NULL, 'YMR027W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(31109, NULL, 'G3DSA:3.30.710.10:FF:000051', NULL, NULL, 'myoneurin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(31110, NULL, 'G3DSA:3.10.20.90:FF:000124', NULL, NULL, 'amyloid beta A4 precursor protein-binding family B member 1-interacting protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(31111, NULL, 'G3DSA:2.20.70.10:FF:000223', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(31112, NULL, 'G3DSA:3.30.930.10:FF:000270', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(31113, NULL, 'G3DSA:1.25.40.430:FF:000019', NULL, NULL, 'YALI0B23166p', NULL, NULL, NULL, NULL, NULL, 4),
(31114, NULL, 'G3DSA:3.30.160.60:FF:005222', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31115, NULL, 'G3DSA:1.10.220.10:FF:000031', NULL, NULL, 'AGAP012930-PA', NULL, NULL, NULL, NULL, NULL, 4),
(31116, NULL, 'G3DSA:3.40.50.300:FF:006509', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31117, NULL, 'G3DSA:3.10.290.20:FF:000002', NULL, NULL, 'SUMO-activating enzyme subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(31118, NULL, 'G3DSA:2.60.40.150:FF:000419', NULL, NULL, 'Copine i-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(31119, NULL, 'G3DSA:1.10.1410.10:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31120, NULL, 'G3DSA:3.40.630.10:FF:000469', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(31121, NULL, 'G3DSA:3.30.160.60:FF:005694', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31122, NULL, 'G3DSA:2.60.40.10:FF:003064', NULL, NULL, 'Myotactin form B', NULL, NULL, NULL, NULL, NULL, 4),
(31123, NULL, 'G3DSA:1.10.1520.10:FF:000019', NULL, NULL, 'Ribonuclease III family protein', NULL, NULL, NULL, NULL, NULL, 4),
(31124, NULL, 'G3DSA:3.40.630.30:FF:000155', NULL, NULL, 'GNAT family acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(31125, NULL, 'G3DSA:2.130.10.10:FF:003952', NULL, NULL, 'EMC Endoplasmic Membrane protein Complex (Yeast EMC) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(31126, NULL, 'G3DSA:2.10.220.10:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31127, NULL, 'G3DSA:3.90.190.10:FF:000575', NULL, NULL, 'Tyrosine protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(31128, NULL, 'G3DSA:1.10.220.30:FF:000037', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(31129, NULL, 'G3DSA:2.30.180.10:FF:000159', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31130, NULL, 'G3DSA:2.40.10.10:FF:000404', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31131, NULL, 'G3DSA:3.10.20.90:FF:000596', NULL, NULL, 'Afadin-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(31132, NULL, 'G3DSA:3.30.9.10:FF:000186', NULL, NULL, 'Protein CBG18666', NULL, NULL, NULL, NULL, NULL, 4),
(31133, NULL, 'G3DSA:1.10.510.10:FF:000222', NULL, NULL, 'casein kinase 1-like protein HD16', NULL, NULL, NULL, NULL, NULL, 4),
(31134, NULL, 'G3DSA:3.40.50.1240:FF:000074', NULL, NULL, 'Phosphoglycerate mutase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(31135, NULL, 'G3DSA:3.40.50.300:FF:002390', NULL, NULL, 'ATPase family AAA domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(31136, NULL, 'G3DSA:3.40.50.620:FF:000243', NULL, NULL, 'Cryptochrome-1', NULL, NULL, NULL, NULL, NULL, 4),
(31137, NULL, 'G3DSA:3.30.40.10:FF:000567', NULL, NULL, 'Regulating synaptic membrane exocytosis 1', NULL, NULL, NULL, NULL, NULL, 4),
(31138, NULL, 'G3DSA:2.130.10.10:FF:001804', NULL, NULL, 'Probable cytosolic iron-sulfur protein assembly protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(31139, NULL, 'G3DSA:1.25.40.10:FF:003248', NULL, NULL, 'Uncharacterized protein CaJ7.0066', NULL, NULL, NULL, NULL, NULL, 4),
(31140, NULL, 'G3DSA:3.30.930.10:FF:000359', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31141, NULL, 'G3DSA:3.40.50.12350:FF:000011', NULL, NULL, 'Eyes absent homolog', NULL, NULL, NULL, NULL, NULL, 4),
(31142, NULL, 'G3DSA:1.25.40.10:FF:000814', NULL, NULL, 'Cell division cycle protein 16, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31143, NULL, 'G3DSA:2.30.180.10:FF:000070', NULL, NULL, 'Os02g0308800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(31144, NULL, 'G3DSA:3.30.505.10:FF:000265', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31145, NULL, 'G3DSA:1.25.10.10:FF:001335', NULL, NULL, 'Plakophilin 1', NULL, NULL, NULL, NULL, NULL, 4),
(31146, NULL, 'G3DSA:3.40.50.2000:FF:000021', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(31147, NULL, 'G3DSA:2.80.10.50:FF:000072', NULL, NULL, 'Thisbe, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(31148, NULL, 'G3DSA:3.30.450.60:FF:000034', NULL, NULL, 'AP-3 complex subunit mu', NULL, NULL, NULL, NULL, NULL, 4),
(31149, NULL, 'G3DSA:2.30.30.490:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31150, NULL, 'G3DSA:2.10.110.10:FF:000311', NULL, NULL, 'Chromosome 21, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(31151, NULL, 'G3DSA:3.40.710.10:FF:000150', NULL, NULL, 'Stage V sporulation protein D', NULL, NULL, NULL, NULL, NULL, 4),
(31152, NULL, 'G3DSA:3.90.1440.10:FF:000015', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(31153, NULL, 'G3DSA:4.10.400.10:FF:000101', NULL, NULL, 'Low-density lipoprotein receptor-related protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(31154, NULL, 'G3DSA:3.40.190.10:FF:000805', NULL, NULL, 'Ligand-gated ionic channel, putative', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(31155, NULL, 'G3DSA:1.20.1270.60:FF:000118', NULL, NULL, 'Unplaced genomic scaffold supercont1.83, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(31156, NULL, 'G3DSA:2.40.50.40:FF:000106', NULL, NULL, 'Chromo domain-containing protein cec-3', NULL, NULL, NULL, NULL, NULL, 4),
(31157, NULL, 'G3DSA:2.30.29.30:FF:001358', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31158, NULL, 'G3DSA:3.90.1520.10:FF:000016', NULL, NULL, 'Gcy-37', NULL, NULL, NULL, NULL, NULL, 4),
(31159, NULL, 'G3DSA:3.40.50.10320:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31160, NULL, 'G3DSA:3.30.70.330:FF:002635', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31161, NULL, 'G3DSA:1.10.540.10:FF:000050', NULL, NULL, 'Acyl-CoA dehydrogenase FadE33', NULL, NULL, NULL, NULL, NULL, 4),
(31162, NULL, 'G3DSA:1.20.59.10:FF:000019', NULL, NULL, 'Chorismate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(31163, NULL, 'G3DSA:3.30.500.10:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31164, NULL, 'G3DSA:3.40.140.10:FF:000241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31165, NULL, 'G3DSA:2.60.120.10:FF:000379', NULL, NULL, 'Probable mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(31166, NULL, 'G3DSA:2.160.20.10:FF:000253', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(31167, NULL, 'G3DSA:2.40.50.140:FF:000176', NULL, NULL, 'DNA repair protein RecO', NULL, NULL, NULL, NULL, NULL, 4),
(31168, NULL, 'G3DSA:3.30.70.330:FF:001415', NULL, NULL, 'Organelle RRM domain-containing protein 6, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(31169, NULL, 'G3DSA:1.25.10.10:FF:003483', NULL, NULL, 'U-box domain-containing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(31170, NULL, 'G3DSA:3.40.50.1100:FF:000173', NULL, NULL, 'Pyridoxal-5''-phosphate-dependent enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(31171, NULL, 'G3DSA:3.30.2290.10:FF:000017', NULL, NULL, 'Peptidase U62 modulator of DNA gyrase', NULL, NULL, NULL, NULL, NULL, 4),
(31172, NULL, 'G3DSA:3.40.30.10:FF:000021', NULL, NULL, 'Chloride intracellular channel 4', NULL, NULL, NULL, NULL, NULL, 4),
(31173, NULL, 'G3DSA:1.10.510.10:FF:003712', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31174, NULL, 'G3DSA:3.40.50.620:FF:000771', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31175, NULL, 'G3DSA:3.40.50.720:FF:000503', NULL, NULL, '6-phosphogluconate dehydrogenase, decarboxylating', NULL, NULL, NULL, NULL, NULL, 4),
(31176, NULL, 'G3DSA:1.20.1050.10:FF:000256', NULL, NULL, 'Ganglioside-induced differentiation-associated protein 1, 2 gdap, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31177, NULL, 'G3DSA:1.20.58.60:FF:000846', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(31178, NULL, 'G3DSA:3.40.50.790:FF:000007', NULL, NULL, 'Ribosomal protein L1p/L10e family', NULL, NULL, NULL, NULL, NULL, 4),
(31179, NULL, 'G3DSA:2.130.10.10:FF:002171', NULL, NULL, 'Elongator complex protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(31180, NULL, 'G3DSA:3.40.630.30:FF:000683', NULL, NULL, 'Putative acyl-CoA N-acyltransferase (NAT) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(31181, NULL, 'G3DSA:3.40.50.880:FF:000034', NULL, NULL, 'carbamoyl-phosphate synthase small chain, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(31182, NULL, 'G3DSA:3.40.50.300:FF:007914', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(31183, NULL, 'G3DSA:1.25.40.10:FF:002467', NULL, NULL, 'Starch-binding outer membrane lipoprotein SusD', NULL, NULL, NULL, NULL, NULL, 4),
(31184, NULL, 'G3DSA:2.130.10.10:FF:001748', NULL, NULL, 'Similarity to pre-mRNA splicing factor', NULL, NULL, NULL, NULL, NULL, 4),
(31185, NULL, 'G3DSA:3.30.160.60:FF:005930', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31186, NULL, 'G3DSA:3.40.50.2020:FF:000027', NULL, NULL, 'Xanthine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(31187, NULL, 'G3DSA:3.40.50.10300:FF:000003', NULL, NULL, 'phosphopantothenate--cysteine ligase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(31188, NULL, 'G3DSA:1.10.132.60:FF:000009', NULL, NULL, 'DNA polymerase epsilon, catalytic subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(31189, NULL, 'G3DSA:1.25.40.10:FF:004092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31190, NULL, 'G3DSA:1.25.40.10:FF:000758', NULL, NULL, 'Tetratricopeptide repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(31191, NULL, 'G3DSA:3.10.100.10:FF:000211', NULL, NULL, 'Immune-related, lectin-like receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(31192, NULL, 'G3DSA:1.10.10.250:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31193, NULL, 'G3DSA:3.30.479.30:FF:000046', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(31194, NULL, 'G3DSA:4.10.260.10:FF:000005', NULL, NULL, 'regulator of G-protein signaling 9 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(31195, NULL, 'G3DSA:2.40.70.10:FF:000565', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31196, NULL, 'G3DSA:3.30.1370.140:FF:000002', NULL, NULL, 'Putative hydrogenase expression/formation protein', NULL, NULL, NULL, NULL, NULL, 4),
(31197, NULL, 'G3DSA:3.30.160.60:FF:000551', NULL, NULL, 'zinc finger protein 197 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(31198, NULL, 'G3DSA:2.60.40.10:FF:005481', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31199, NULL, 'G3DSA:2.60.40.10:FF:003772', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31200, NULL, 'G3DSA:3.40.50.2000:FF:000493', NULL, NULL, 'Glycosyl transferase family 1', NULL, NULL, NULL, NULL, NULL, 4),
(31201, NULL, 'G3DSA:3.40.50.720:FF:001228', NULL, NULL, 'Cinnamoyl CoA reductase1', NULL, NULL, NULL, NULL, NULL, 4),
(31202, NULL, 'G3DSA:3.30.200.20:FF:002387', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31203, NULL, 'G3DSA:1.10.533.10:FF:000314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31204, NULL, 'G3DSA:1.25.40.10:FF:003580', NULL, NULL, 'Phox4', NULL, NULL, NULL, NULL, NULL, 4),
(31205, NULL, 'G3DSA:2.10.110.10:FF:000255', NULL, NULL, 'Paxillin', NULL, NULL, NULL, NULL, NULL, 4),
(31206, NULL, 'G3DSA:3.90.1150.10:FF:000476', NULL, NULL, 'Glutamine--scyllo-inositol transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(31207, NULL, 'G3DSA:3.40.50.10330:FF:000107', NULL, NULL, 'Inorganic polyphosphate/ATP-NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(31208, NULL, 'G3DSA:3.30.420.10:FF:000416', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31209, NULL, 'G3DSA:3.40.50.1820:FF:001821', NULL, NULL, 'Triacylglycerol lipase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31210, NULL, 'G3DSA:1.20.920.10:FF:000127', NULL, NULL, 'PolyBRoMo domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(31211, NULL, 'G3DSA:3.80.10.10:FF:000102', NULL, NULL, 'nischarin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(31212, NULL, 'G3DSA:3.40.920.10:FF:000008', NULL, NULL, 'Pyruvate-flavoredoxin oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(31213, NULL, 'G3DSA:3.40.50.300:FF:001985', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(31214, NULL, 'G3DSA:1.20.1070.10:FF:001836', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(31215, NULL, 'G3DSA:2.60.40.150:FF:000043', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', NULL, NULL, NULL, NULL, NULL, 4),
(31216, NULL, 'G3DSA:1.20.58.2010:FF:000001', NULL, NULL, 'Rop guanine nucleotide exchange factor 14', NULL, NULL, NULL, NULL, NULL, 4),
(31217, NULL, 'G3DSA:2.60.120.200:FF:000415', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31218, NULL, 'G3DSA:2.60.40.10:FF:001624', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(31219, NULL, 'G3DSA:2.60.110.10:FF:000030', NULL, NULL, 'Osmotin', NULL, NULL, NULL, NULL, NULL, 4),
(31220, NULL, 'G3DSA:1.20.1730.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31221, NULL, 'G3DSA:6.20.10.30:FF:000008', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(31222, NULL, 'G3DSA:1.25.40.20:FF:000295', NULL, NULL, 'Espin like', NULL, NULL, NULL, NULL, NULL, 4),
(31223, NULL, 'G3DSA:2.30.310.10:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31224, NULL, 'G3DSA:3.30.565.10:FF:000010', NULL, NULL, 'Sensor histidine kinase RcsC', NULL, NULL, NULL, NULL, NULL, 4),
(31225, NULL, 'G3DSA:3.10.20.90:FF:000652', NULL, NULL, 'Autophagy-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(31226, NULL, 'G3DSA:1.20.120.1240:FF:000036', NULL, NULL, 'WGS project CABT00000000 data, contig 2.29', NULL, NULL, NULL, NULL, NULL, 4),
(31227, NULL, 'G3DSA:3.40.1440.10:FF:000010', NULL, NULL, 'Excinuclease ABC subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(31228, NULL, 'G3DSA:3.30.420.10:FF:000040', NULL, NULL, 'Exonuclease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(31229, NULL, 'G3DSA:3.40.50.10860:FF:000002', NULL, NULL, 'Glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(31230, NULL, 'G3DSA:2.130.10.10:FF:002732', NULL, NULL, 'WD repeat-containing protein DWA2', NULL, NULL, NULL, NULL, NULL, 4),
(31231, NULL, 'G3DSA:3.40.50.300:FF:001462', NULL, NULL, 'Small GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31232, NULL, 'G3DSA:3.40.190.170:FF:000014', NULL, NULL, 'TRAP dicarboxylate transporter, DctP subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31233, NULL, 'G3DSA:1.20.58.80:FF:000055', NULL, NULL, 'Regulator of free ubiquitin chains 1', NULL, NULL, NULL, NULL, NULL, 4),
(31234, NULL, 'G3DSA:1.10.287.130:FF:000064', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(31235, NULL, 'G3DSA:1.10.540.10:FF:000139', NULL, NULL, 'Glutaryl-CoA dehydrogenase isoform a', NULL, NULL, NULL, NULL, NULL, 4),
(31236, NULL, 'G3DSA:4.10.410.10:FF:000074', NULL, NULL, 'Serine protease inhibitor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31237, NULL, 'G3DSA:3.10.20.770:FF:000024', NULL, NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(31238, NULL, 'G3DSA:2.20.25.10:FF:000063', NULL, NULL, 'Positive transcription elongation factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31239, NULL, 'G3DSA:3.40.30.10:FF:000077', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(31240, NULL, 'G3DSA:2.20.25.20:FF:000009', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(31241, NULL, 'G3DSA:3.40.50.200:FF:000145', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 6', NULL, NULL, NULL, NULL, NULL, 4),
(31242, NULL, 'G3DSA:2.170.16.10:FF:000006', NULL, NULL, 'UPF0051 protein Mb1496', NULL, NULL, NULL, NULL, NULL, 4),
(31243, NULL, 'G3DSA:1.50.10.20:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31244, NULL, 'G3DSA:3.40.50.300:FF:007881', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31245, NULL, 'G3DSA:1.10.20.10:FF:000015', NULL, NULL, 'Transcription initiation factor TFIID subunit 4B', NULL, NULL, NULL, NULL, NULL, 4),
(31246, NULL, 'G3DSA:1.20.58.60:FF:000138', NULL, NULL, 'Alpha-actinin, sarcomeric', NULL, NULL, NULL, NULL, NULL, 4),
(31247, NULL, 'G3DSA:2.60.40.1230:FF:000005', NULL, NULL, 'AP-1 complex subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(31248, NULL, 'G3DSA:3.40.390.10:FF:000225', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31249, NULL, 'G3DSA:1.50.10.10:FF:000069', NULL, NULL, 'spermatogenesis-associated protein 20', NULL, NULL, NULL, NULL, NULL, 4),
(31250, NULL, 'G3DSA:1.10.405.10:FF:000005', NULL, NULL, 'Amine oxidase [flavin-containing]', NULL, NULL, NULL, NULL, NULL, 4),
(31251, NULL, 'G3DSA:3.30.420.40:FF:000144', NULL, NULL, 'Molecular chaperone HscC', NULL, NULL, NULL, NULL, NULL, 4),
(31252, NULL, 'G3DSA:2.30.30.40:FF:000448', NULL, NULL, 'PACSIN3 isoform 8', NULL, NULL, NULL, NULL, NULL, 4),
(31253, NULL, 'G3DSA:3.40.430.10:FF:000049', NULL, NULL, 'Riboflavin biosynthesis protein RibD', NULL, NULL, NULL, NULL, NULL, 4),
(31254, NULL, 'G3DSA:3.40.50.800:FF:000084', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(31255, NULL, 'G3DSA:3.40.50.300:FF:006133', NULL, NULL, 'SNF2 family DNA-dependent ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(31256, NULL, 'G3DSA:3.30.200.20:FF:000734', NULL, NULL, 'protein kinase DC1', NULL, NULL, NULL, NULL, NULL, 4),
(31257, NULL, 'G3DSA:2.60.40.150:FF:000751', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31258, NULL, 'G3DSA:3.40.50.1980:FF:000003', NULL, NULL, 'Iron ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(31259, NULL, 'G3DSA:4.10.860.120:FF:000012', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(31260, NULL, 'G3DSA:2.40.50.140:FF:001013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31261, NULL, 'G3DSA:2.30.29.30:FF:000846', NULL, NULL, 'RanBP1 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(31262, NULL, 'G3DSA:1.10.510.10:FF:002728', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31263, NULL, 'G3DSA:3.40.50.1440:FF:000162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31264, NULL, 'G3DSA:3.40.720.10:FF:000116', NULL, NULL, 'GPI ethanolamine phosphate transferase 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(31265, NULL, 'G3DSA:1.10.10.60:FF:000776', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31266, NULL, 'G3DSA:2.10.90.10:FF:000163', NULL, NULL, 'Growth differential factor 9', NULL, NULL, NULL, NULL, NULL, 4),
(31267, NULL, 'G3DSA:3.40.50.80:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31268, NULL, 'G3DSA:1.10.238.10:FF:000886', NULL, NULL, 'TBC1 domain family member 9', NULL, NULL, NULL, NULL, NULL, 4),
(31269, NULL, 'G3DSA:1.10.486.10:FF:000035', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(31270, NULL, 'G3DSA:1.10.3210.10:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31271, NULL, 'G3DSA:1.10.10.60:FF:000304', NULL, NULL, 'Visual system homeobox', NULL, NULL, NULL, NULL, NULL, 4),
(31272, NULL, 'G3DSA:3.40.50.80:FF:000144', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(31273, NULL, 'G3DSA:1.20.1560.10:FF:000542', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31274, NULL, 'G3DSA:3.30.342.10:FF:000021', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(31275, NULL, 'G3DSA:3.40.50.300:FF:003986', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(31276, NULL, 'G3DSA:1.20.120.1910:FF:000024', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(31277, NULL, 'G3DSA:3.40.80.10:FF:000024', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(31278, NULL, 'G3DSA:2.60.40.10:FF:000135', NULL, NULL, 'Titin a', NULL, NULL, NULL, NULL, NULL, 4),
(31279, NULL, 'G3DSA:1.50.40.10:FF:000402', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31280, NULL, 'G3DSA:1.10.800.10:FF:000002', NULL, NULL, 'Tyrosine 3-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(31281, NULL, 'G3DSA:1.20.1560.10:FF:000486', NULL, NULL, 'ATP-binding protein syrD-ATP binding protein of ABC-type transporter', NULL, NULL, NULL, NULL, NULL, 4),
(31282, NULL, 'G3DSA:1.10.238.10:FF:000358', NULL, NULL, 'CAMK/CDPK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(31283, NULL, 'G3DSA:2.20.25.90:FF:000013', NULL, NULL, 'Molybdopterin cofactor oxido-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(31284, NULL, 'G3DSA:3.40.50.300:FF:005880', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31285, NULL, 'G3DSA:1.10.287.70:FF:000337', NULL, NULL, 'Ionotropic receptor 31a, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(31286, NULL, 'G3DSA:1.10.10.60:FF:000248', NULL, NULL, 'Gastrulation brain homeobox 2', NULL, NULL, NULL, NULL, NULL, 4),
(31287, NULL, 'G3DSA:3.30.200.20:FF:001083', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31288, NULL, 'G3DSA:1.10.510.10:FF:001239', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(31289, NULL, 'G3DSA:3.40.50.10810:FF:000212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31290, NULL, 'G3DSA:2.30.230.10:FF:000012', NULL, NULL, 'Putative Vitellogenin-1', NULL, NULL, NULL, NULL, NULL, 4),
(31291, NULL, 'G3DSA:2.60.40.2840:FF:000010', NULL, NULL, 'Putative inositol-145-triphosphate 5-phosphatase synaptojanin inp51/inp52/inp53 family', NULL, NULL, NULL, NULL, NULL, 4),
(31292, NULL, 'G3DSA:1.20.1560.10:FF:000339', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(31293, NULL, 'G3DSA:3.30.1640.10:FF:000033', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(31294, NULL, 'G3DSA:3.20.20.190:FF:000129', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31295, NULL, 'G3DSA:1.20.1110.10:FF:000082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31296, NULL, 'G3DSA:2.20.100.10:FF:000145', NULL, NULL, 'SPONdin (Extracellular matrix glycoprotein) family', NULL, NULL, NULL, NULL, NULL, 4),
(31297, NULL, 'G3DSA:2.30.39.10:FF:000009', NULL, NULL, 'Glia-derived nexin isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(31298, NULL, 'G3DSA:3.30.450.20:FF:000342', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(31299, NULL, 'G3DSA:3.30.65.10:FF:000006', NULL, NULL, 'DNA topoisomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(31300, NULL, 'G3DSA:1.10.8.10:FF:000238', NULL, NULL, 'Ubiquitin-like protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(31301, NULL, 'G3DSA:3.90.25.10:FF:000074', NULL, NULL, 'NmrA-like family domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(31302, NULL, 'G3DSA:1.10.287.70:FF:000484', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31303, NULL, 'G3DSA:2.60.120.200:FF:000359', NULL, NULL, 'Hydroxyproline O-galactosyltransferase GALT6', NULL, NULL, NULL, NULL, NULL, 4),
(31304, NULL, 'G3DSA:1.10.510.10:FF:001767', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(31305, NULL, 'G3DSA:1.10.472.10:FF:000060', NULL, NULL, 'D6-type cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(31306, NULL, 'G3DSA:3.40.50.150:FF:001451', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31307, NULL, 'G3DSA:3.40.50.720:FF:001936', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31308, NULL, 'G3DSA:3.30.1110.10:FF:000004', NULL, NULL, 'Adenosine kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(31309, NULL, 'G3DSA:3.40.50.1240:FF:000107', NULL, NULL, 'Phytase', NULL, NULL, NULL, NULL, NULL, 4),
(31310, NULL, 'G3DSA:4.10.60.10:FF:000078', NULL, NULL, 'Unplaced genomic scaffold supercont2.10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(31311, NULL, 'G3DSA:3.90.70.10:FF:000381', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31312, NULL, 'G3DSA:3.60.130.10:FF:000078', NULL, NULL, 'Gamma-butyrobetaine hydroxylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31313, NULL, 'G3DSA:3.90.550.10:FF:000530', NULL, NULL, 'Nucleotidyl transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31314, NULL, 'G3DSA:3.90.1230.10:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31315, NULL, 'G3DSA:1.20.1410.10:FF:000008', NULL, NULL, 'Huntingtin interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(31316, NULL, 'G3DSA:3.90.1150.10:FF:000004', NULL, NULL, '2-amino-3-ketobutyrate coenzyme A ligase', NULL, NULL, NULL, NULL, NULL, 4),
(31317, NULL, 'G3DSA:3.10.110.10:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31318, NULL, 'G3DSA:3.10.20.10:FF:000027', NULL, NULL, '60S ribosomal protein L18a', NULL, NULL, NULL, NULL, NULL, 4),
(31319, NULL, 'G3DSA:3.30.160.60:FF:003277', NULL, NULL, 'Zgc:171551', NULL, NULL, NULL, NULL, NULL, 4),
(31320, NULL, 'G3DSA:2.130.10.10:FF:004677', NULL, NULL, 'Chromosome 12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(31321, NULL, 'G3DSA:4.10.400.10:FF:000157', NULL, NULL, 'LDL receptor related protein 2', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(31322, NULL, 'G3DSA:2.90.10.10:FF:000003', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(31323, NULL, 'G3DSA:2.30.29.30:FF:000285', NULL, NULL, 'regulator of G-protein signaling 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(31324, NULL, 'G3DSA:2.10.25.10:FF:000821', NULL, NULL, 'Neurogenic locus notch-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(31325, NULL, 'G3DSA:3.40.1110.10:FF:000401', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31326, NULL, 'G3DSA:3.80.10.10:FF:002811', NULL, NULL, 'Si:ch73-168d20.1', NULL, NULL, NULL, NULL, NULL, 4),
(31327, NULL, 'G3DSA:2.170.270.10:FF:000004', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(31328, NULL, 'G3DSA:3.40.50.12160:FF:000016', NULL, NULL, 'RNA modification enzyme, MiaB family', NULL, NULL, NULL, NULL, NULL, 4),
(31329, NULL, 'G3DSA:2.60.220.30:FF:000005', NULL, NULL, 'Ankyrin-2 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(31330, NULL, 'G3DSA:2.30.30.90:FF:000002', NULL, NULL, 'Iron-dependent repressor IdeR', NULL, NULL, NULL, NULL, NULL, 4),
(31331, NULL, 'G3DSA:3.40.20.10:FF:000104', NULL, NULL, 'Gelsolin, isoform J', NULL, NULL, NULL, NULL, NULL, 4),
(31332, NULL, 'G3DSA:3.30.70.1230:FF:000107', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(31333, NULL, 'G3DSA:1.20.140.80:FF:000009', NULL, NULL, 'Transcription factor E2F/dimerisation partner (TDP) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(31334, NULL, 'G3DSA:1.20.120.560:FF:000005', NULL, NULL, 'Bro1p', NULL, NULL, NULL, NULL, NULL, 4),
(31335, NULL, 'G3DSA:2.30.39.10:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31336, NULL, 'G3DSA:2.10.50.30:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31337, NULL, 'G3DSA:3.40.190.10:FF:000772', NULL, NULL, 'Os06g0190000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(31338, NULL, 'G3DSA:3.30.300.20:FF:000011', NULL, NULL, 'Single-stranded DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(31339, NULL, 'G3DSA:2.130.10.10:FF:000315', NULL, NULL, 'Vacuolar protein sorting-associated protein 11 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(31340, NULL, 'G3DSA:1.20.1250.20:FF:000774', NULL, NULL, 'Major facilitator superfamily MFS_1', NULL, NULL, NULL, NULL, NULL, 4),
(31341, NULL, 'G3DSA:3.30.70.330:FF:000634', NULL, NULL, 'Related to glycine-rich RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(31342, NULL, 'G3DSA:3.40.140.20:FF:000007', NULL, NULL, 'Bifunctional purine biosynthesis protein PurH', NULL, NULL, NULL, NULL, NULL, 4),
(31343, NULL, 'G3DSA:1.20.5.340:FF:000120', NULL, NULL, 'Rho-associated kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31344, NULL, 'G3DSA:2.130.10.10:FF:000259', NULL, NULL, 'DDB1- and CUL4-associated factor 11 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(31345, NULL, 'G3DSA:2.60.120.10:FF:000290', NULL, NULL, 'Cyclic nucleotide-binding domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31346, NULL, 'G3DSA:2.30.30.380:FF:000061', NULL, NULL, 'TGF-beta activated kinase 1 (MAP3K7) binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(31347, NULL, 'G3DSA:3.50.7.10:FF:000024', NULL, NULL, 'Mitochondrial chaperone TCM62', NULL, NULL, NULL, NULL, NULL, 4),
(31348, NULL, 'G3DSA:3.10.105.10:FF:000054', NULL, NULL, 'Peptide ABC transporter permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(31349, NULL, 'G3DSA:3.30.559.30:FF:000103', NULL, NULL, 'Glycine-AMP ligase', NULL, NULL, NULL, NULL, NULL, 4),
(31350, NULL, 'G3DSA:3.90.79.10:FF:000226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31351, NULL, 'G3DSA:3.80.10.10:FF:000866', NULL, NULL, 'Leucine-rich repeat-containing protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(31352, NULL, 'G3DSA:3.30.310.80:FF:000007', NULL, NULL, 'Serine/threonine-protein kinase Chk1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(31353, NULL, 'G3DSA:2.130.10.10:FF:002204', NULL, NULL, 'Os01g0238900 protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(31354, NULL, 'G3DSA:2.170.220.10:FF:000001', NULL, NULL, 'methionine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(31355, NULL, 'G3DSA:3.40.366.10:FF:000028', NULL, NULL, 'Malonyl CoA-acyl carrier protein transacylase', NULL, NULL, NULL, NULL, NULL, 4),
(31356, NULL, 'G3DSA:3.30.60.90:FF:000024', NULL, NULL, 'Unplaced genomic scaffold supercont2.17, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(31357, NULL, 'G3DSA:3.40.50.10810:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31358, NULL, 'G3DSA:3.30.70.890:FF:000072', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(31359, NULL, 'G3DSA:2.130.10.10:FF:003188', NULL, NULL, 'Flagellar associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(31360, NULL, 'G3DSA:1.25.40.10:FF:002091', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g08210', NULL, NULL, NULL, NULL, NULL, 4),
(31361, NULL, 'G3DSA:3.30.160.60:FF:004238', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31362, NULL, 'G3DSA:3.60.15.10:FF:000024', NULL, NULL, 'Zinc phosphodiesterase ELAC protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(31363, NULL, 'G3DSA:1.20.58.1080:FF:000014', NULL, NULL, 'ATP-dependent RNA helicase SUPV3L1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(31364, NULL, 'G3DSA:3.80.10.10:FF:002608', NULL, NULL, 'Receptor kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(31365, NULL, 'G3DSA:1.10.1040.10:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31366, NULL, 'G3DSA:2.60.120.290:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31367, NULL, 'G3DSA:3.40.50.410:FF:000293', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(31368, NULL, 'G3DSA:2.30.40.10:FF:000114', NULL, NULL, '5-methylthioadenosine/S-adenosylhomocysteine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(31369, NULL, 'G3DSA:3.30.1490.180:FF:000024', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(31370, NULL, 'G3DSA:4.10.375.10:FF:000002', NULL, NULL, 'Lipoxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(31371, NULL, 'G3DSA:2.30.31.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31372, NULL, 'G3DSA:3.40.50.1820:FF:000096', NULL, NULL, 'Carboxypeptidase vitellogenic-like', NULL, NULL, NULL, NULL, NULL, 4),
(31373, NULL, 'G3DSA:2.40.30.110:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31374, NULL, 'G3DSA:3.90.1170.50:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31375, NULL, 'G3DSA:1.10.10.10:FF:002083', NULL, NULL, 'Spo11-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(31376, NULL, 'G3DSA:3.30.70.330:FF:003040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31377, NULL, 'G3DSA:2.60.40.2860:FF:000016', NULL, NULL, 'Transmission-blocking target antigen s230', NULL, NULL, NULL, NULL, NULL, 4),
(31378, NULL, 'G3DSA:3.40.50.300:FF:003839', NULL, NULL, 'Rab GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(31379, NULL, 'G3DSA:3.30.70.330:FF:002579', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31380, NULL, 'G3DSA:3.80.10.10:FF:001119', NULL, NULL, 'mRNA export factor mex67, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31381, NULL, 'G3DSA:3.30.160.60:FF:005727', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31382, NULL, 'G3DSA:2.130.10.10:FF:001951', NULL, NULL, 'WD_domain_-_G-beta_repeat_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(31383, NULL, 'G3DSA:3.40.50.300:FF:008078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31384, NULL, 'G3DSA:3.40.50.720:FF:000447', NULL, NULL, 'NADP dependent oxidoreductase domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(31385, NULL, 'G3DSA:3.40.50.300:FF:000349', NULL, NULL, 'Rho GTPase-activating protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(31386, NULL, 'G3DSA:2.30.29.30:FF:001302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(31387, NULL, 'G3DSA:1.25.40.20:FF:001076', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(31388, NULL, 'G3DSA:2.30.30.830:FF:000004', NULL, NULL, 'Type II secretion system protein C', NULL, NULL, NULL, NULL, NULL, 4),
(31389, NULL, 'G3DSA:3.90.1070.10:FF:000003', NULL, NULL, '5-amino-6-(5-phospho-D-ribitylamino)uracil phosphatase YcsE', NULL, NULL, NULL, NULL, NULL, 4),
(31390, NULL, 'G3DSA:3.30.110.110:FF:000016', NULL, NULL, 'Double-strand break repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(31391, NULL, 'G3DSA:1.10.246.10:FF:000017', NULL, NULL, 'Serum albumin 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(31392, NULL, 'G3DSA:2.130.10.130:FF:000014', NULL, NULL, 'Integrin alpha FG-GAP repeat containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(31393, NULL, 'G3DSA:3.80.10.10:FF:002047', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase PXC1', NULL, NULL, NULL, NULL, NULL, 4),
(31394, NULL, 'G3DSA:1.20.1250.20:FF:000589', NULL, NULL, 'Unplaced genomic scaffold supercont1.136, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(31395, NULL, 'G3DSA:3.40.50.720:FF:000975', NULL, NULL, 'GM20055', NULL, NULL, NULL, NULL, NULL, 4),
(31396, NULL, 'G3DSA:1.25.40.10:FF:001539', NULL, NULL, 'AGAP002648-PA', NULL, NULL, NULL, NULL, NULL, 4),
(31397, NULL, 'G3DSA:3.50.50.60:FF:000576', NULL, NULL, 'Smox protein', NULL, NULL, NULL, NULL, NULL, 4),
(31398, NULL, 'G3DSA:2.30.30.1020:FF:000005', NULL, NULL, 'Regena, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(31399, NULL, 'G3DSA:3.40.50.10190:FF:000138', NULL, NULL, 'AGAP002760-PA', NULL, NULL, NULL, NULL, NULL, 4),
(31400, NULL, 'G3DSA:3.30.200.20:FF:001662', NULL, NULL, 'Serine/threonine-protein kinase Nek4', NULL, NULL, NULL, NULL, NULL, 4),
(31401, NULL, 'G3DSA:2.60.40.10:FF:004025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31402, NULL, 'G3DSA:1.20.1050.10:FF:000312', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(31403, NULL, 'G3DSA:1.10.472.130:FF:000025', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31404, NULL, 'G3DSA:3.40.50.300:FF:005728', NULL, NULL, 'Protein SMAX1-LIKE 2', NULL, NULL, NULL, NULL, NULL, 4),
(31405, NULL, 'G3DSA:2.60.120.970:FF:000034', NULL, NULL, 'inhibin beta B chain', NULL, NULL, NULL, NULL, NULL, 4),
(31406, NULL, 'G3DSA:3.10.450.50:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31407, NULL, 'G3DSA:1.20.120.1630:FF:000030', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(31408, NULL, 'G3DSA:2.70.50.30:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31409, NULL, 'G3DSA:3.30.70.340:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31410, NULL, 'G3DSA:3.30.40.10:FF:002309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31411, NULL, 'G3DSA:3.80.10.10:FF:001827', NULL, NULL, 'F-box and leucine-rich repeat protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(31412, NULL, 'G3DSA:3.50.50.60:FF:000609', NULL, NULL, 'Bacteriochlorophyll synthase', NULL, NULL, NULL, NULL, NULL, 4),
(31413, NULL, 'G3DSA:1.10.220.150:FF:000008', NULL, NULL, 'ADP-ribosylation factor GTPase activating protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(31414, NULL, 'G3DSA:3.30.430.20:FF:000015', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(31415, NULL, 'G3DSA:3.20.20.190:FF:000096', NULL, NULL, 'Phospholipase D LiSicTox-betaID1', NULL, NULL, NULL, NULL, NULL, 4),
(31416, NULL, 'G3DSA:3.60.90.10:FF:000012', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(31417, NULL, 'G3DSA:3.40.1190.10:FF:000029', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(31418, NULL, 'G3DSA:3.40.50.410:FF:000326', NULL, NULL, 'TFIIH P34', NULL, NULL, NULL, NULL, NULL, 4),
(31419, NULL, 'G3DSA:3.90.1100.10:FF:000001', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(31420, NULL, 'G3DSA:3.40.50.720:FF:001431', NULL, NULL, '6-deoxyerythronolide-B synthase EryA2, modules 3 and 4', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(31421, NULL, 'G3DSA:3.30.70.330:FF:002399', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31422, NULL, 'G3DSA:3.60.21.60:FF:000014', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(31423, NULL, 'G3DSA:3.40.50.2300:FF:001533', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31424, NULL, 'G3DSA:1.20.1250.20:FF:002011', NULL, NULL, 'Os04g0691400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(31425, NULL, 'G3DSA:2.130.10.10:FF:001243', NULL, NULL, 'Anaphase-promoting complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(31426, NULL, 'G3DSA:1.25.40.10:FF:001686', NULL, NULL, 'pentatricopeptide repeat-containing protein At4g30700', NULL, NULL, NULL, NULL, NULL, 4),
(31427, NULL, 'G3DSA:1.20.5.110:FF:000248', NULL, NULL, 'Syntaxin 10-1', NULL, NULL, NULL, NULL, NULL, 4),
(31428, NULL, 'G3DSA:3.40.50.200:FF:000089', NULL, NULL, 'Subtilisin-like serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(31429, NULL, 'G3DSA:1.10.3210.10:FF:000092', NULL, NULL, 'Cyclic di-GMP phosphodiesterase PA4108', NULL, NULL, NULL, NULL, NULL, 4),
(31430, NULL, 'G3DSA:3.80.10.10:FF:002755', NULL, NULL, 'Si:ch211-156p11.1', NULL, NULL, NULL, NULL, NULL, 4),
(31431, NULL, 'G3DSA:2.30.29.30:FF:000902', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31432, NULL, 'G3DSA:3.40.140.10:FF:000061', NULL, NULL, 'DRAP deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(31433, NULL, 'G3DSA:3.30.1240.10:FF:000008', NULL, NULL, 'HAD family phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(31434, NULL, 'G3DSA:3.30.200.20:FF:000678', NULL, NULL, 'Tyrosine kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(31435, NULL, 'G3DSA:1.10.150.20:FF:000152', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4),
(31436, NULL, 'G3DSA:2.10.220.10:FF:000140', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(31437, NULL, 'G3DSA:1.25.10.10:FF:001482', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(31438, NULL, 'G3DSA:1.10.287.110:FF:000378', NULL, NULL, 'Dnaj-like protein subfamily B member 1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(31439, NULL, 'G3DSA:3.30.70.20:FF:000105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31440, NULL, 'G3DSA:2.60.40.10:FF:000282', NULL, NULL, 'peroxidasin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(31441, NULL, 'G3DSA:3.40.20.10:FF:000048', NULL, NULL, 'Putative gmf family protein', NULL, NULL, NULL, NULL, NULL, 4),
(31442, NULL, 'G3DSA:1.10.472.10:FF:000621', NULL, NULL, 'Putative cyclin B, copy D', NULL, NULL, NULL, NULL, NULL, 4),
(31443, NULL, 'G3DSA:2.30.29.70:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31444, NULL, 'G3DSA:4.10.650.10:FF:000001', NULL, NULL, 'Copper binding metallothionein', NULL, NULL, NULL, NULL, NULL, 4),
(31445, NULL, 'G3DSA:2.60.40.60:FF:000976', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31446, NULL, 'G3DSA:1.20.920.50:FF:000004', NULL, NULL, 'MCG17492, isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(31447, NULL, 'G3DSA:2.30.30.140:FF:000096', NULL, NULL, 'Tudor domain containing 6', NULL, NULL, NULL, NULL, NULL, 4),
(31448, NULL, 'G3DSA:1.10.1740.10:FF:000002', NULL, NULL, 'RNA polymerase sigma factor FliA', NULL, NULL, NULL, NULL, NULL, 4),
(31449, NULL, 'G3DSA:2.40.30.10:FF:000203', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(31450, NULL, 'G3DSA:3.30.160.60:FF:005166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31451, NULL, 'G3DSA:3.50.50.60:FF:000761', NULL, NULL, 'Alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(31452, NULL, 'G3DSA:3.40.50.300:FF:004391', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(31453, NULL, 'G3DSA:3.40.1110.10:FF:000345', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31454, NULL, 'G3DSA:2.60.40.10:FF:004553', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31455, NULL, 'G3DSA:4.10.780.10:FF:000005', NULL, NULL, 'Pyruvate-ferredoxin oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(31456, NULL, 'G3DSA:1.25.40.180:FF:000220', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31457, NULL, 'G3DSA:3.40.50.2300:FF:000549', NULL, NULL, 'Phosphoglycerate transport system transcriptional regulatory protein PgtA', NULL, NULL, NULL, NULL, NULL, 4),
(31458, NULL, 'G3DSA:3.30.160.60:FF:002440', NULL, NULL, 'ZNF484 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(31459, NULL, 'G3DSA:1.10.510.10:FF:000278', NULL, NULL, 'serine/threonine-protein kinase greatwall isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(31460, NULL, 'G3DSA:3.40.50.1370:FF:000062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31461, NULL, 'G3DSA:3.30.1370.10:FF:000164', NULL, NULL, 'Protein CBG07980', NULL, NULL, NULL, NULL, NULL, 4),
(31462, NULL, 'G3DSA:3.40.50.150:FF:000523', NULL, NULL, 'DNA (cytosine-5)-methyltransferase CMT2', NULL, NULL, NULL, NULL, NULL, 4),
(31463, NULL, 'G3DSA:3.30.1010.10:FF:000148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31464, NULL, 'G3DSA:3.90.190.10:FF:000103', NULL, NULL, 'dual specificity protein phosphatase CDC14A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(31465, NULL, 'G3DSA:3.30.160.60:FF:005874', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31466, NULL, 'G3DSA:3.30.160.20:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31467, NULL, 'G3DSA:1.10.630.10:FF:000641', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(31468, NULL, 'G3DSA:3.40.630.10:FF:000289', NULL, NULL, 'Probable M18 family aminopeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(31469, NULL, 'G3DSA:2.10.25.10:FF:000057', NULL, NULL, 'protocadherin Fat 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(31470, NULL, 'G3DSA:1.20.1640.10:FF:000020', NULL, NULL, 'Transmembrane transport protein MmpL10', NULL, NULL, NULL, NULL, NULL, 4),
(31471, NULL, 'G3DSA:1.25.40.20:FF:001784', NULL, NULL, 'Pho81p', NULL, NULL, NULL, NULL, NULL, 4),
(31472, NULL, 'G3DSA:1.10.510.10:FF:002223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31473, NULL, 'G3DSA:3.30.160.60:FF:000495', NULL, NULL, 'zinc finger protein 668', NULL, NULL, NULL, NULL, NULL, 4),
(31474, NULL, 'G3DSA:1.10.8.60:FF:000180', NULL, NULL, 'Sigma-54 dependent transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(31475, NULL, 'G3DSA:1.20.1720.10:FF:000021', NULL, NULL, 'Drug resistance transporter, EmrB/QacA subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(31476, NULL, 'G3DSA:3.80.10.10:FF:001794', NULL, NULL, 'Rasgrp4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(31477, NULL, 'G3DSA:1.25.40.20:FF:001599', NULL, NULL, 'GH09064p', NULL, NULL, NULL, NULL, NULL, 4),
(31478, NULL, 'G3DSA:2.60.60.20:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31479, NULL, 'G3DSA:2.10.25.10:FF:000765', NULL, NULL, 'neural-cadherin-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(31480, NULL, 'G3DSA:3.30.160.60:FF:006150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31481, NULL, 'G3DSA:3.10.350.10:FF:000055', NULL, NULL, 'Muramidase', NULL, NULL, NULL, NULL, NULL, 4),
(31482, NULL, 'G3DSA:1.20.970.30:FF:000001', NULL, NULL, 'Eukaryotic translation initiation factor subunit eIF-4F, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31483, NULL, 'G3DSA:3.90.550.10:FF:000474', NULL, NULL, 'Protein O-linked-mannose beta-1,2-N-acetylglucosaminyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(31484, NULL, 'G3DSA:1.10.238.110:FF:000003', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(31485, NULL, 'G3DSA:1.20.1720.10:FF:000077', NULL, NULL, 'Drug resistance transporter EmrB/QacA subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(31486, NULL, 'G3DSA:3.40.50.740:FF:000009', NULL, NULL, 'Formate dehydrogenase N subunit alpha, selenocysteine-containing', NULL, NULL, NULL, NULL, NULL, 4),
(31487, NULL, 'G3DSA:2.130.10.10:FF:000046', NULL, NULL, 'WD repeat-containing protein 62 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(31488, NULL, 'G3DSA:2.60.40.10:FF:005918', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31489, NULL, 'G3DSA:3.10.110.10:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(31490, NULL, 'G3DSA:1.20.1250.20:FF:000561', NULL, NULL, 'YJL163C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(31491, NULL, 'G3DSA:1.50.40.10:FF:000222', NULL, NULL, 'Mitochondrial glycine transporter', NULL, NULL, NULL, NULL, NULL, 4),
(31492, NULL, 'G3DSA:2.130.10.10:FF:003805', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31493, NULL, 'G3DSA:3.60.40.10:FF:000116', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(31494, NULL, 'G3DSA:3.40.50.150:FF:000046', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase G', NULL, NULL, NULL, NULL, NULL, 4),
(31495, NULL, 'G3DSA:3.40.50.300:FF:004716', NULL, NULL, 'Methylenetetrahydrofolate dehydrogenase (NADP+-dependent) 1, methenyltetrahydrofolate cyclohydrolase, formyltetrahydrofolate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(31496, NULL, 'G3DSA:3.30.590.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31497, NULL, 'G3DSA:1.10.510.10:FF:000019', NULL, NULL, 'Ephrin type-A receptor 5', NULL, NULL, NULL, NULL, NULL, 4),
(31498, NULL, 'G3DSA:3.40.30.10:FF:000633', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31499, NULL, 'G3DSA:3.40.50.2300:FF:001393', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31500, NULL, 'G3DSA:1.20.5.500:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31501, NULL, 'G3DSA:2.40.30.30:FF:000006', NULL, NULL, 'Riboflavin kinase / FAD synthase family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31502, NULL, 'G3DSA:2.10.25.10:FF:000760', NULL, NULL, 'Delta-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(31503, NULL, 'G3DSA:3.40.50.20:FF:000053', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(31504, NULL, 'G3DSA:2.60.40.740:FF:000001', NULL, NULL, 'Major cell-surface adhesin PAc', NULL, NULL, NULL, NULL, NULL, 4),
(31505, NULL, 'G3DSA:1.25.10.10:FF:002471', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31506, NULL, 'G3DSA:3.40.30.10:FF:001089', NULL, NULL, 'Thioredoxin reductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(31507, NULL, 'G3DSA:3.20.10.10:FF:000060', NULL, NULL, 'Uncharacterized protein HI_1169', NULL, NULL, NULL, NULL, NULL, 4),
(31508, NULL, 'G3DSA:3.30.160.20:FF:000067', NULL, NULL, '40S ribosomal protein S2', NULL, NULL, NULL, NULL, NULL, 4),
(31509, NULL, 'G3DSA:3.40.50.2000:FF:000465', NULL, NULL, 'UDP-glycosyltransferase 73D1', NULL, NULL, NULL, NULL, NULL, 4),
(31510, NULL, 'G3DSA:3.90.70.10:FF:000414', NULL, NULL, 'Clan CA, family C1, cathepsin L-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(31511, NULL, 'G3DSA:2.60.120.260:FF:000349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31512, NULL, 'G3DSA:4.10.400.10:FF:000337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31513, NULL, 'G3DSA:2.40.30.180:FF:000009', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(31514, NULL, 'G3DSA:3.30.160.60:FF:003165', NULL, NULL, 'zinc finger protein 485', NULL, NULL, NULL, NULL, NULL, 4),
(31515, NULL, 'G3DSA:3.90.550.10:FF:000710', NULL, NULL, 'UDP-N-acetylglucosamine pyrophosphorylase 1 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(31516, NULL, 'G3DSA:3.30.1120.30:FF:000011', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(31517, NULL, 'G3DSA:3.20.20.70:FF:000005', NULL, NULL, 'Phospho-2-dehydro-3-deoxyheptonate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(31518, NULL, 'G3DSA:3.30.950.10:FF:000029', NULL, NULL, 'Uroporphyrin-iii C-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(31519, NULL, 'G3DSA:1.25.40.650:FF:000001', NULL, NULL, 'Penicillin-binding protein activator LpoA', NULL, NULL, NULL, NULL, NULL, 4),
(31520, NULL, 'G3DSA:3.60.20.40:FF:000017', NULL, NULL, 'GM13229', NULL, NULL, NULL, NULL, NULL, 4),
(31521, NULL, 'G3DSA:3.90.70.10:FF:000886', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31522, NULL, 'G3DSA:1.25.40.10:FF:000786', NULL, NULL, 'TPR-repeat-containing chaperone protein DNAJ', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(31523, NULL, 'G3DSA:3.50.50.60:FF:000929', NULL, NULL, 'Putative pyridine nucleotide-disulfide oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(31524, NULL, 'G3DSA:1.10.1070.11:FF:000070', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', NULL, NULL, NULL, NULL, NULL, 4),
(31525, NULL, 'G3DSA:3.40.50.720:FF:000003', NULL, NULL, 'S-(hydroxymethyl)glutathione dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(31526, NULL, 'G3DSA:3.90.79.10:FF:000013', NULL, NULL, 'Uncharacterized Nudix hydrolase NudL', NULL, NULL, NULL, NULL, NULL, 4),
(31527, NULL, 'G3DSA:2.60.120.10:FF:000295', NULL, NULL, 'Transcriptional regulator, AraC family', NULL, NULL, NULL, NULL, NULL, 4),
(31528, NULL, 'G3DSA:3.40.50.300:FF:001962', NULL, NULL, 'ATP-dependent protease La', NULL, NULL, NULL, NULL, NULL, 4),
(31529, NULL, 'G3DSA:1.25.10.10:FF:001914', NULL, NULL, 'Disheveled associated activator of morphogenesis, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31530, NULL, 'G3DSA:3.80.10.10:FF:004441', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(31531, NULL, 'G3DSA:3.30.2160.10:FF:000013', NULL, NULL, 'E3 ubiquitin-protein ligase TRIP12 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(31532, NULL, 'G3DSA:1.25.40.20:FF:001520', NULL, NULL, 'Kinase, NEK-frag', NULL, NULL, NULL, NULL, NULL, 4),
(31533, NULL, 'G3DSA:2.70.150.10:FF:000098', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(31534, NULL, 'G3DSA:3.40.50.1380:FF:000003', NULL, NULL, 'Bifunctional purine biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(31535, NULL, 'G3DSA:1.20.1250.20:FF:002308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31536, NULL, 'G3DSA:2.70.130.10:FF:000147', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31537, NULL, 'G3DSA:1.10.472.100:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31538, NULL, 'G3DSA:2.60.40.10:FF:002108', NULL, NULL, '1,4-alpha-glucan branching enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(31539, NULL, 'G3DSA:2.60.40.10:FF:000394', NULL, NULL, 'Down syndrome cell adhesion molecule, isoform J', NULL, NULL, NULL, NULL, NULL, 4),
(31540, NULL, 'G3DSA:3.30.160.60:FF:005514', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31541, NULL, 'G3DSA:1.10.1670.10:FF:000030', NULL, NULL, 'A/G-specific adenine glycosylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31542, NULL, 'G3DSA:1.10.10.60:FF:000035', NULL, NULL, 'paired box protein Pax-3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(31543, NULL, 'G3DSA:2.40.170.20:FF:000053', NULL, NULL, 'Outer membrane cobalamin receptor protein', NULL, NULL, NULL, NULL, NULL, 4),
(31544, NULL, 'G3DSA:1.20.1720.10:FF:000026', NULL, NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(31545, NULL, 'G3DSA:3.80.10.10:FF:000158', NULL, NULL, 'Leucine rich repeat containing 75A', NULL, NULL, NULL, NULL, NULL, 4),
(31546, NULL, 'G3DSA:3.40.50.150:FF:001035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31547, NULL, 'G3DSA:1.10.3380.10:FF:000019', NULL, NULL, 'Protein translocation complex componenet (Npl1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(31548, NULL, 'G3DSA:3.30.70.1230:FF:000231', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(31549, NULL, 'G3DSA:1.25.40.210:FF:000004', NULL, NULL, 'Telomeric repeat-binding factor', NULL, NULL, NULL, NULL, NULL, 4),
(31550, NULL, 'G3DSA:4.10.280.10:FF:000248', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(31551, NULL, 'G3DSA:2.60.40.10:FF:004929', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31552, NULL, 'G3DSA:2.120.10.30:FF:000294', NULL, NULL, 'Low density lipoprotein receptor-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(31553, NULL, 'G3DSA:3.30.200.20:FF:002151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31554, NULL, 'G3DSA:3.40.50.40:FF:000008', NULL, NULL, 'Probable L-asparaginase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(31555, NULL, 'G3DSA:2.40.10.340:FF:000003', NULL, NULL, 'Cell shape-determining protein MreC', NULL, NULL, NULL, NULL, NULL, 4),
(31556, NULL, 'G3DSA:3.40.50.800:FF:000089', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(31557, NULL, 'G3DSA:1.20.1560.10:FF:000042', NULL, NULL, 'Antigen peptide transporter 2', NULL, NULL, NULL, NULL, NULL, 4),
(31558, NULL, 'G3DSA:1.20.1640.10:FF:000043', NULL, NULL, 'Protein CBR-PTC-3', NULL, NULL, NULL, NULL, NULL, 4),
(31559, NULL, 'G3DSA:3.40.50.1000:FF:000474', NULL, NULL, 'Mannosylfructose-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(31560, NULL, 'G3DSA:3.40.50.2000:FF:001033', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(31561, NULL, 'G3DSA:2.40.50.140:FF:000316', NULL, NULL, 'Transcription termination factor Rho', NULL, NULL, NULL, NULL, NULL, 4),
(31562, NULL, 'G3DSA:3.20.20.70:FF:000056', NULL, NULL, 'hydroxyacid oxidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(31563, NULL, 'G3DSA:1.10.287.70:FF:000601', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(31564, NULL, 'G3DSA:3.80.10.10:FF:001586', NULL, NULL, 'RNI-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(31565, NULL, 'G3DSA:3.40.50.300:FF:000501', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(31566, NULL, 'G3DSA:2.10.220.10:FF:000145', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(31567, NULL, 'G3DSA:3.10.580.10:FF:000151', NULL, NULL, 'Metal transporter cnnm-5', NULL, NULL, NULL, NULL, NULL, 4),
(31568, NULL, 'G3DSA:3.30.1460.50:FF:000008', NULL, NULL, 'Autophagy-related 10, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(31569, NULL, 'G3DSA:1.10.8.50:FF:000019', NULL, NULL, 'Unplaced genomic scaffold supercont1.232, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(31570, NULL, 'G3DSA:1.25.40.10:FF:001303', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g46460, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(31571, NULL, 'G3DSA:2.130.10.10:FF:002816', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31572, NULL, 'G3DSA:1.20.1740.10:FF:000140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31573, NULL, 'G3DSA:3.40.630.10:FF:000177', NULL, NULL, 'Aminoacylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(31574, NULL, 'G3DSA:3.40.47.10:FF:000205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31575, NULL, 'G3DSA:2.40.460.10:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31576, NULL, 'G3DSA:3.20.20.80:FF:000738', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31577, NULL, 'G3DSA:1.10.565.10:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31578, NULL, 'G3DSA:3.30.160.60:FF:004946', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31579, NULL, 'G3DSA:3.30.420.10:FF:000276', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(31580, NULL, 'G3DSA:3.40.50.1440:FF:000050', NULL, NULL, 'Zeta tubulin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31581, NULL, 'G3DSA:2.60.40.1180:FF:000147', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(31582, NULL, 'G3DSA:3.30.450.40:FF:000051', NULL, NULL, 'ABC1 family protein C21C3.03', NULL, NULL, NULL, NULL, NULL, 4),
(31583, NULL, 'G3DSA:1.10.287.130:FF:000069', NULL, NULL, 'Probable histidine kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(31584, NULL, 'G3DSA:2.170.300.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31585, NULL, 'G3DSA:3.30.70.1660:FF:000011', NULL, NULL, 'Peptide chain release factor 1-like, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(31586, NULL, 'G3DSA:3.40.50.300:FF:000113', NULL, NULL, 'Preprotein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(31587, NULL, 'G3DSA:3.40.50.360:FF:000024', NULL, NULL, 'NADPH--cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(31588, NULL, 'G3DSA:1.25.40.10:FF:004968', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31589, NULL, 'G3DSA:3.30.160.60:FF:006071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31590, NULL, 'G3DSA:3.40.1280.10:FF:000059', NULL, NULL, 'tRNA/rRNA methyltransferase (SpoU)', NULL, NULL, NULL, NULL, NULL, 4),
(31591, NULL, 'G3DSA:3.30.160.60:FF:003957', NULL, NULL, 'Putative zinc finger protein C09F5.3', NULL, NULL, NULL, NULL, NULL, 4),
(31592, NULL, 'G3DSA:3.30.70.330:FF:002287', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31593, NULL, 'G3DSA:2.130.10.10:FF:002024', NULL, NULL, 'Cilia- and flagella-associated protein 251', NULL, NULL, NULL, NULL, NULL, 4),
(31594, NULL, 'G3DSA:3.30.830.10:FF:000150', NULL, NULL, 'Metalloenzyme, LuxS/M16 peptidase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(31595, NULL, 'G3DSA:1.20.1070.10:FF:001191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31596, NULL, 'G3DSA:3.20.20.80:FF:000334', NULL, NULL, 'Amino acid Transporter GlycoProtein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(31597, NULL, 'G3DSA:3.30.870.10:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31598, NULL, 'G3DSA:1.10.8.60:FF:000287', NULL, NULL, 'ATPase family associated with various cellular activities (AAA), putative', NULL, NULL, NULL, NULL, NULL, 4),
(31599, NULL, 'G3DSA:3.40.710.10:FF:000178', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(31600, NULL, 'G3DSA:1.20.1250.20:FF:002359', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(31601, NULL, 'G3DSA:2.60.40.790:FF:000055', NULL, NULL, 'HSP90 associated co-chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(31602, NULL, 'G3DSA:3.40.50.720:FF:000863', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] reductase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(31603, NULL, 'G3DSA:3.30.1310.10:FF:000008', NULL, NULL, 'ESX-1 secretion-associated protein EspL', NULL, NULL, NULL, NULL, NULL, 4),
(31604, NULL, 'G3DSA:1.10.1200.120:FF:000010', NULL, NULL, 'Large-conductance mechanosensitive channel', NULL, NULL, NULL, NULL, NULL, 4),
(31605, NULL, 'G3DSA:3.40.390.10:FF:000192', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(31606, NULL, 'G3DSA:3.30.160.60:FF:000731', NULL, NULL, 'Zinc finger protein 292', NULL, NULL, NULL, NULL, NULL, 4),
(31607, NULL, 'G3DSA:1.10.390.10:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31608, NULL, 'G3DSA:3.60.10.10:FF:000356', NULL, NULL, 'DNA-(apurinic or apyrimidinic site) lyase', NULL, NULL, NULL, NULL, NULL, 4),
(31609, NULL, 'G3DSA:3.40.50.300:FF:000552', NULL, NULL, 'GPN-loop GTPase 3', NULL, NULL, NULL, NULL, NULL, 4),
(31610, NULL, 'G3DSA:3.40.50.10130:FF:000014', NULL, NULL, 'CCAAT-box DNA binding protein subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(31611, NULL, 'G3DSA:3.80.10.10:FF:002524', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31612, NULL, 'G3DSA:2.60.40.640:FF:000038', NULL, NULL, 'Arrestin-related trafficking adapter 10', NULL, NULL, NULL, NULL, NULL, 4),
(31613, NULL, 'G3DSA:3.80.10.10:FF:001535', NULL, NULL, 'Disease resistance protein RRS1B', NULL, NULL, NULL, NULL, NULL, 4),
(31614, NULL, 'G3DSA:3.40.50.300:FF:007701', NULL, NULL, 'Os04g0582600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(31615, NULL, 'G3DSA:2.130.10.30:FF:000153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31616, NULL, 'G3DSA:1.20.1270.60:FF:000265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31617, NULL, 'G3DSA:1.25.10.10:FF:000054', NULL, NULL, 'General vesicular transport factor p115', NULL, NULL, NULL, NULL, NULL, 4),
(31618, NULL, 'G3DSA:3.40.50.720:FF:001852', NULL, NULL, '6-phosphogluconate dehydrogenase, decarboxylating', NULL, NULL, NULL, NULL, NULL, 4),
(31619, NULL, 'G3DSA:3.30.200.20:FF:001583', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31620, NULL, 'G3DSA:1.10.8.60:FF:000236', NULL, NULL, 'ATPase, AAA family protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(31621, NULL, 'G3DSA:3.60.21.10:FF:000224', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(31622, NULL, 'G3DSA:1.10.8.60:FF:000348', NULL, NULL, 'GM25904', NULL, NULL, NULL, NULL, NULL, 4),
(31623, NULL, 'G3DSA:3.30.420.10:FF:000629', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31624, NULL, 'G3DSA:3.20.20.80:FF:000385', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31625, NULL, 'G3DSA:2.60.40.1940:FF:000010', NULL, NULL, 'Complement 4B (Chido blood group)', NULL, NULL, NULL, NULL, NULL, 4),
(31626, NULL, 'G3DSA:2.10.220.10:FF:000224', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(31627, NULL, 'G3DSA:3.30.300.30:FF:000008', NULL, NULL, '2,3-dihydroxybenzoate-AMP ligase', NULL, NULL, NULL, NULL, NULL, 4),
(31628, NULL, 'G3DSA:3.30.70.150:FF:000001', NULL, NULL, 'Ribulose bisphosphate carboxylase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(31629, NULL, 'G3DSA:3.40.50.720:FF:001352', NULL, NULL, 'OSJNBa0069D17.10 protein', NULL, NULL, NULL, NULL, NULL, 4),
(31630, NULL, 'G3DSA:3.30.70.80:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31631, NULL, 'G3DSA:3.30.450.40:FF:000112', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(31632, NULL, 'G3DSA:2.170.300.10:FF:000086', NULL, NULL, 'Cell death abnormality protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(31633, NULL, 'G3DSA:3.60.110.10:FF:000043', NULL, NULL, 'Glutamine-dependent NAD(+) synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(31634, NULL, 'G3DSA:3.30.160.60:FF:005582', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31635, NULL, 'G3DSA:3.30.710.10:FF:000495', NULL, NULL, 'BTB/POZ domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(31636, NULL, 'G3DSA:2.130.10.10:FF:005790', NULL, NULL, 'Transcription initiation factor TFIID subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(31637, NULL, 'G3DSA:2.60.40.10:FF:002260', NULL, NULL, 'ephrin type-A receptor 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(31638, NULL, 'G3DSA:1.20.5.1200:FF:000011', NULL, NULL, 'GM13560', NULL, NULL, NULL, NULL, NULL, 4),
(31639, NULL, 'G3DSA:2.40.50.1000:FF:000020', NULL, NULL, 'Si:dkey-159f12.2', NULL, NULL, NULL, NULL, NULL, 4),
(31640, NULL, 'G3DSA:1.25.40.10:FF:005053', NULL, NULL, 'Tetratricopeptide repeat domain 21B', NULL, NULL, NULL, NULL, NULL, 4),
(31641, NULL, 'G3DSA:3.10.10.10:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31642, NULL, 'G3DSA:3.30.200.20:FF:000122', NULL, NULL, 'cyclin-dependent kinase 8 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(31643, NULL, 'G3DSA:1.10.287.110:FF:000030', NULL, NULL, 'DnaJ homolog subfamily C GRV2', NULL, NULL, NULL, NULL, NULL, 4),
(31644, NULL, 'G3DSA:3.30.160.60:FF:002760', NULL, NULL, 'Zinc finger protein 785', NULL, NULL, NULL, NULL, NULL, 4),
(31645, NULL, 'G3DSA:2.10.70.10:FF:000105', NULL, NULL, 'Sushi domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(31646, NULL, 'G3DSA:2.60.40.10:FF:001771', NULL, NULL, 'Cytokine receptor common subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(31647, NULL, 'G3DSA:3.40.640.10:FF:000054', NULL, NULL, 'Serine--glyoxylate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(31648, NULL, 'G3DSA:2.60.120.200:FF:000067', NULL, NULL, 'Thrombospondin 2', NULL, NULL, NULL, NULL, NULL, 4),
(31649, NULL, 'G3DSA:3.30.70.260:FF:000034', NULL, NULL, 'Acetolactate synthase small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(31650, NULL, 'G3DSA:2.40.50.140:FF:000737', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31651, NULL, 'G3DSA:1.10.20.10:FF:000200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31652, NULL, 'G3DSA:3.40.50.1000:FF:000878', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31653, NULL, 'G3DSA:2.60.40.150:FF:000779', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31654, NULL, 'G3DSA:1.10.510.10:FF:003004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31655, NULL, 'G3DSA:3.40.50.10420:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(31656, NULL, 'G3DSA:1.50.10.10:FF:000041', NULL, NULL, 'Non-lysosomal glucosylceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(31657, NULL, 'G3DSA:3.40.50.300:FF:000613', NULL, NULL, 'C-1-tetrahydrofolate synthase, cytoplasmic isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(31658, NULL, 'G3DSA:2.10.230.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31659, NULL, 'G3DSA:3.40.50.1000:FF:000053', NULL, NULL, 'TIGR01457 family HAD hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(31660, NULL, 'G3DSA:2.60.40.10:FF:003620', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31661, NULL, 'G3DSA:1.25.40.10:FF:001742', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(31662, NULL, 'G3DSA:2.30.42.10:FF:000276', NULL, NULL, 'General secretion pathway protein C', NULL, NULL, NULL, NULL, NULL, 4),
(31663, NULL, 'G3DSA:1.10.8.1310:FF:000013', NULL, NULL, 'Gyp8p', NULL, NULL, NULL, NULL, NULL, 4),
(31664, NULL, 'G3DSA:1.10.750.20:FF:000001', NULL, NULL, 'Ankyrin repeat and SOCS box containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(31665, NULL, 'G3DSA:3.40.1280.10:FF:000008', NULL, NULL, 'Group 3 RNA methyltransferase TrmH', NULL, NULL, NULL, NULL, NULL, 4),
(31666, NULL, 'G3DSA:1.20.1050.10:FF:000284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31667, NULL, 'G3DSA:1.20.58.240:FF:000005', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(31668, NULL, 'G3DSA:3.80.10.10:FF:004520', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31669, NULL, 'G3DSA:3.40.50.980:FF:000002', NULL, NULL, 'Enterobactin synthetase component F', NULL, NULL, NULL, NULL, NULL, 4),
(31670, NULL, 'G3DSA:2.60.40.10:FF:005986', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31671, NULL, 'G3DSA:3.60.20.10:FF:000233', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31672, NULL, 'G3DSA:2.60.40.10:FF:005806', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31673, NULL, 'G3DSA:2.40.170.20:FF:000114', NULL, NULL, 'SusC homolog', NULL, NULL, NULL, NULL, NULL, 4),
(31674, NULL, 'G3DSA:1.10.3370.10:FF:000013', NULL, NULL, 'Protein translocase subunit SecY', NULL, NULL, NULL, NULL, NULL, 4),
(31675, NULL, 'G3DSA:2.10.70.10:FF:000156', NULL, NULL, 'Interleukin-2 receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(31676, NULL, 'G3DSA:3.40.50.300:FF:006392', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(31677, NULL, 'G3DSA:3.80.10.10:FF:002075', NULL, NULL, 'Leucine-rich repeat-containing 24', NULL, NULL, NULL, NULL, NULL, 4),
(31678, NULL, 'G3DSA:2.130.10.10:FF:003873', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(31679, NULL, 'G3DSA:2.10.50.10:FF:000161', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(31680, NULL, 'G3DSA:1.20.120.720:FF:000008', NULL, NULL, 'Unconventional myosin-VIIa', NULL, NULL, NULL, NULL, NULL, 4),
(31681, NULL, 'G3DSA:1.10.8.100:FF:000028', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(31682, NULL, 'G3DSA:2.130.10.130:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31683, NULL, 'G3DSA:1.10.287.70:FF:000540', NULL, NULL, 'YALI0E03234p', NULL, NULL, NULL, NULL, NULL, 4),
(31684, NULL, 'G3DSA:3.90.190.10:FF:000159', NULL, NULL, 'Dual specificity protein phosphatase lip-1', NULL, NULL, NULL, NULL, NULL, 4),
(31685, NULL, 'G3DSA:3.40.50.880:FF:000186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31686, NULL, 'G3DSA:2.130.10.10:FF:004441', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31687, NULL, 'G3DSA:3.40.109.10:FF:000016', NULL, NULL, 'NAD(P)H nitroreductase', NULL, NULL, NULL, NULL, NULL, 4),
(31688, NULL, 'G3DSA:3.90.960.10:FF:000016', NULL, NULL, 'Prolyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31689, NULL, 'G3DSA:1.10.8.270:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31690, NULL, 'G3DSA:2.40.128.180:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(31691, NULL, 'G3DSA:3.30.40.10:FF:002337', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31692, NULL, 'G3DSA:3.40.50.12780:FF:000022', NULL, NULL, 'Acyl-CoA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(31693, NULL, 'G3DSA:3.30.1130.10:FF:000011', NULL, NULL, 'Dihydroneopterin aldolase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(31694, NULL, 'G3DSA:1.25.40.1010:FF:000005', NULL, NULL, 'N-terminal acetyltransferase A complex subunit NAT1', NULL, NULL, NULL, NULL, NULL, 4),
(31695, NULL, 'G3DSA:1.20.1070.10:FF:000167', NULL, NULL, 'probable G-protein coupled receptor 174', NULL, NULL, NULL, NULL, NULL, 4),
(31696, NULL, 'G3DSA:1.10.10.440:FF:000049', NULL, NULL, 'TransCription Elongation Regulator homolog', NULL, NULL, NULL, NULL, NULL, 4),
(31697, NULL, 'G3DSA:1.25.40.10:FF:004176', NULL, NULL, 'Tetratricopeptide repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31698, NULL, 'G3DSA:1.10.472.10:FF:000677', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31699, NULL, 'G3DSA:1.10.275.20:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31700, NULL, 'G3DSA:2.70.160.11:FF:000021', NULL, NULL, 'Coactivator-associated arginine methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(31701, NULL, 'G3DSA:1.20.58.390:FF:000022', NULL, NULL, 'Nicotinic acetylcholine receptor subunit alpha4', NULL, NULL, NULL, NULL, NULL, 4),
(31702, NULL, 'G3DSA:3.50.50.60:FF:000076', NULL, NULL, 'Sarcosine dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(31703, NULL, 'G3DSA:3.30.420.40:FF:000223', NULL, NULL, 'Type III pantothenate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(31704, NULL, 'G3DSA:2.60.220.50:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31705, NULL, 'G3DSA:3.90.930.12:FF:000011', NULL, NULL, 'Unplaced genomic scaffold supercont1.199, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(31706, NULL, 'G3DSA:1.10.565.10:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31707, NULL, 'G3DSA:2.60.40.1730:FF:000065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31708, NULL, 'G3DSA:3.20.20.70:FF:000117', NULL, NULL, 'molybdenum cofactor biosynthesis protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(31709, NULL, 'G3DSA:3.30.2350.20:FF:000025', NULL, NULL, 'tRNA pseudouridine synthase TruD, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31710, NULL, 'G3DSA:3.30.40.10:FF:000488', NULL, NULL, 'E3 ubiquitin-protein ligase RNF213', NULL, NULL, NULL, NULL, NULL, 4),
(31711, NULL, 'G3DSA:3.40.50.300:FF:008106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31712, NULL, 'G3DSA:1.20.1250.40:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31713, NULL, 'G3DSA:3.30.160.60:FF:000343', NULL, NULL, 'C2H2 transcription factor (AmdX)', NULL, NULL, NULL, NULL, NULL, 4),
(31714, NULL, 'G3DSA:3.30.70.2520:FF:000005', NULL, NULL, 'L-gulonolactone oxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31715, NULL, 'G3DSA:4.10.1000.10:FF:000152', NULL, NULL, 'Zinc finger CCCH-type-containing 10', NULL, NULL, NULL, NULL, NULL, 4),
(31716, NULL, 'G3DSA:2.60.490.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31717, NULL, 'G3DSA:3.30.390.10:FF:000014', NULL, NULL, 'D(-)-tartrate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(31718, NULL, 'G3DSA:1.25.40.20:FF:001632', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(31719, NULL, 'G3DSA:1.20.1460.10:FF:000006', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(31720, NULL, 'G3DSA:2.60.40.1490:FF:000004', NULL, NULL, 'Anti-silencing function 1B histone chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(31721, NULL, 'G3DSA:3.30.160.60:FF:001248', NULL, NULL, 'zinc finger protein 333 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(31722, NULL, 'G3DSA:2.20.25.240:FF:000005', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(31723, NULL, 'G3DSA:1.10.8.270:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31724, NULL, 'G3DSA:1.10.287.110:FF:000142', NULL, NULL, 'DnaJ-like subfamily B member 13', NULL, NULL, NULL, NULL, NULL, 4),
(31725, NULL, 'G3DSA:1.20.1070.10:FF:000908', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31726, NULL, 'G3DSA:3.20.20.100:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31727, NULL, 'G3DSA:1.20.120.1760:FF:000018', NULL, NULL, 'CDP-alcohol phosphatidyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(31728, NULL, 'G3DSA:3.90.190.10:FF:000108', NULL, NULL, 'Tyrosine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(31729, NULL, 'G3DSA:3.30.70.2360:FF:000002', NULL, NULL, 'Endoribonuclease antitoxin GhoS', NULL, NULL, NULL, NULL, NULL, 4),
(31730, NULL, 'G3DSA:3.40.50.300:FF:006341', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31731, NULL, 'G3DSA:3.30.2350.20:FF:000076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31732, NULL, 'G3DSA:1.25.10.10:FF:001414', NULL, NULL, 'Exportin T (TRNA exportin)-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(31733, NULL, 'G3DSA:3.50.50.60:FF:000817', NULL, NULL, 'Prenylcysteine lyase, putative (AFU_orthologue AFUA_3G09330)', NULL, NULL, NULL, NULL, NULL, 4),
(31734, NULL, 'G3DSA:1.20.1250.20:FF:000622', NULL, NULL, 'Mch2p', NULL, NULL, NULL, NULL, NULL, 4),
(31735, NULL, 'G3DSA:3.30.160.60:FF:001299', NULL, NULL, 'CLUMA_CG020620, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(31736, NULL, 'G3DSA:3.30.1010.10:FF:000143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31737, NULL, 'G3DSA:1.10.565.10:FF:000157', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(31738, NULL, 'G3DSA:2.70.70.10:FF:000030', NULL, NULL, 'Possible peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(31739, NULL, 'G3DSA:3.40.50.1820:FF:000068', NULL, NULL, 'Lipid droplet associated hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(31740, NULL, 'G3DSA:3.30.70.330:FF:001382', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(31741, NULL, 'G3DSA:1.25.40.20:FF:001924', NULL, NULL, 'Multiple ankyrin repeats single kh domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31742, NULL, 'G3DSA:1.10.510.10:FF:002083', NULL, NULL, 'Mitogen-activated protein kinase 10', NULL, NULL, NULL, NULL, NULL, 4),
(31743, NULL, 'G3DSA:1.25.10.10:FF:001982', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31744, NULL, 'G3DSA:1.10.3450.40:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31745, NULL, 'G3DSA:3.40.850.10:FF:000272', NULL, NULL, 'kinesin-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(31746, NULL, 'G3DSA:3.40.50.150:FF:001395', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31747, NULL, 'G3DSA:3.40.50.1970:FF:000034', NULL, NULL, 'Phosphoribosylaminoimidazole carboxylase family protein / AIR carboxylase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(31748, NULL, 'G3DSA:3.90.132.10:FF:000020', NULL, NULL, 'Major surface protease gp63, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31749, NULL, 'G3DSA:3.10.129.10:FF:000086', NULL, NULL, 'Acyl-CoA thioester hydrolase, YbgC/YbaW family', NULL, NULL, NULL, NULL, NULL, 4),
(31750, NULL, 'G3DSA:3.90.1480.20:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31751, NULL, 'G3DSA:1.20.1250.20:FF:000010', NULL, NULL, 'Probable glucarate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(31752, NULL, 'G3DSA:2.60.40.640:FF:000089', NULL, NULL, 'Arrestin (Or S-antigen), N-terminal domain protein (AFU_orthologue AFUA_5G12530)', NULL, NULL, NULL, NULL, NULL, 4),
(31753, NULL, 'G3DSA:2.40.100.10:FF:000130', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(31754, NULL, 'G3DSA:3.20.20.140:FF:000024', NULL, NULL, 'Urease', NULL, NULL, NULL, NULL, NULL, 4),
(31755, NULL, 'G3DSA:1.10.418.60:FF:000005', NULL, NULL, 'Kinetochore protein NUF2', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(31756, NULL, 'G3DSA:3.40.50.1100:FF:000178', NULL, NULL, 'Threonine dehydratase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31757, NULL, 'G3DSA:2.130.10.10:FF:001395', NULL, NULL, 'Damaged DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(31758, NULL, 'G3DSA:4.10.60.10:FF:000134', NULL, NULL, 'Cellular nucleic acid-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(31759, NULL, 'G3DSA:3.30.310.10:FF:000026', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(31760, NULL, 'G3DSA:3.90.660.10:FF:000100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31761, NULL, 'G3DSA:3.30.559.10:FF:000041', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(31762, NULL, 'G3DSA:3.20.180.20:FF:000003', NULL, NULL, 'Dynein heavy chain 12, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(31763, NULL, 'G3DSA:3.30.450.20:FF:000286', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(31764, NULL, 'G3DSA:1.20.1440.200:FF:000005', NULL, NULL, 'Vacuolar protein sorting-associated protein 28 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(31765, NULL, 'G3DSA:3.30.70.330:FF:001770', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31766, NULL, 'G3DSA:1.10.10.850:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31767, NULL, 'G3DSA:3.30.40.10:FF:001056', NULL, NULL, 'E3 ubiquitin-protein ligase ATL23', NULL, NULL, NULL, NULL, NULL, 4),
(31768, NULL, 'G3DSA:3.30.930.10:FF:000146', NULL, NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(31769, NULL, 'G3DSA:2.60.40.3500:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31770, NULL, 'G3DSA:1.10.730.10:FF:000210', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(31771, NULL, 'G3DSA:3.30.519.10:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31772, NULL, 'G3DSA:2.30.42.10:FF:000388', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31773, NULL, 'G3DSA:3.40.1190.20:FF:000122', NULL, NULL, 'Adenosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(31774, NULL, 'G3DSA:1.10.510.10:FF:003425', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31775, NULL, 'G3DSA:3.40.50.10490:FF:000138', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31776, NULL, 'G3DSA:2.60.450.10:FF:000016', NULL, NULL, 'Lipopolysaccharide export system protein LptA', NULL, NULL, NULL, NULL, NULL, 4),
(31777, NULL, 'G3DSA:2.70.98.30:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31778, NULL, 'G3DSA:1.20.1050.10:FF:000172', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(31779, NULL, 'G3DSA:3.30.200.20:FF:000526', NULL, NULL, 'Kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(31780, NULL, 'G3DSA:3.30.230.10:FF:000025', NULL, NULL, '30S ribosomal protein S9', NULL, NULL, NULL, NULL, NULL, 4),
(31781, NULL, 'G3DSA:1.20.1070.10:FF:001595', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31782, NULL, 'G3DSA:1.10.10.10:FF:000374', NULL, NULL, 'Two-component transcriptional regulator, winged helix family', NULL, NULL, NULL, NULL, NULL, 4),
(31783, NULL, 'G3DSA:1.20.1310.20:FF:000009', NULL, NULL, 'Antigen 332, DBL-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(31784, NULL, 'G3DSA:3.40.50.360:FF:000092', NULL, NULL, 'S-adenosyl-L-methionine-dependent tRNA 4-demethylwyosine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(31785, NULL, 'G3DSA:3.40.50.300:FF:003778', NULL, NULL, 'Dynein, axonemal, heavy chain 11', NULL, NULL, NULL, NULL, NULL, 4),
(31786, NULL, 'G3DSA:2.60.120.430:FF:000018', NULL, NULL, 'Putative esterase (Lipoprotein)', NULL, NULL, NULL, NULL, NULL, 4),
(31787, NULL, 'G3DSA:1.25.40.120:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31788, NULL, 'G3DSA:3.30.450.60:FF:000039', NULL, NULL, 'Signal recognition particle receptor like protein, putative', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(31789, NULL, 'G3DSA:3.90.180.10:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31790, NULL, 'G3DSA:3.80.10.10:FF:002816', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31791, NULL, 'G3DSA:1.10.287.70:FF:000489', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31792, NULL, 'G3DSA:2.60.200.20:FF:000006', NULL, NULL, 'Afadin, adherens junction formation factor', NULL, NULL, NULL, NULL, NULL, 4),
(31793, NULL, 'G3DSA:3.20.20.140:FF:000075', NULL, NULL, 'Phosphonate metabolism protein PhnM', NULL, NULL, NULL, NULL, NULL, 4),
(31794, NULL, 'G3DSA:1.10.150.50:FF:000020', NULL, NULL, 'Tumor protein 63 (p63)', NULL, NULL, NULL, NULL, NULL, 4),
(31795, NULL, 'G3DSA:1.10.630.10:FF:000517', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31796, NULL, 'G3DSA:3.40.50.300:FF:002007', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(31797, NULL, 'G3DSA:2.30.170.20:FF:000010', NULL, NULL, 'LSU ribosomal protein L24E', NULL, NULL, NULL, NULL, NULL, 4),
(31798, NULL, 'G3DSA:2.60.40.10:FF:000343', NULL, NULL, 'inactive tyrosine-protein kinase 7', NULL, NULL, NULL, NULL, NULL, 4),
(31799, NULL, 'G3DSA:3.90.1410.10:FF:000070', NULL, NULL, 'YALI0F30327p', NULL, NULL, NULL, NULL, NULL, 4),
(31800, NULL, 'G3DSA:3.80.10.10:FF:004380', NULL, NULL, 'Toll-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(31801, NULL, 'G3DSA:1.10.472.10:FF:000065', NULL, NULL, 'G1/S-specific cyclin Cln1', NULL, NULL, NULL, NULL, NULL, 4),
(31802, NULL, 'G3DSA:1.10.10.60:FF:001092', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31803, NULL, 'G3DSA:2.60.40.10:FF:005065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31804, NULL, 'G3DSA:3.40.50.10810:FF:000004', NULL, NULL, 'probable global transcription activator SNF2L2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(31805, NULL, 'G3DSA:1.20.140.40:FF:000020', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(31806, NULL, 'G3DSA:3.10.580.10:FF:000090', NULL, NULL, 'Magnesium transporter MgtE', NULL, NULL, NULL, NULL, NULL, 4),
(31807, NULL, 'G3DSA:3.40.250.10:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31808, NULL, 'G3DSA:1.25.40.20:FF:001020', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(31809, NULL, 'G3DSA:2.60.40.420:FF:000023', NULL, NULL, 'Monocopper oxidase-like protein SKU5', NULL, NULL, NULL, NULL, NULL, 4),
(31810, NULL, 'G3DSA:3.30.70.1230:FF:000282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31811, NULL, 'G3DSA:3.40.50.300:FF:004267', NULL, NULL, 'Os02g0497500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(31812, NULL, 'G3DSA:3.20.20.70:FF:000505', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31813, NULL, 'G3DSA:3.30.70.260:FF:000113', NULL, NULL, '(P)ppGpp synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(31814, NULL, 'G3DSA:3.90.70.130:FF:000004', NULL, NULL, 'Ufm1-specific protease 1', NULL, NULL, NULL, NULL, NULL, 4),
(31815, NULL, 'G3DSA:1.10.490.160:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31816, NULL, 'G3DSA:1.10.150.50:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31817, NULL, 'G3DSA:2.40.33.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31818, NULL, 'G3DSA:3.40.50.300:FF:007089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31819, NULL, 'G3DSA:1.10.530.10:FF:000072', NULL, NULL, 'Endochitinase EP3', NULL, NULL, NULL, NULL, NULL, 4),
(31820, NULL, 'G3DSA:3.40.50.1820:FF:001580', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31821, NULL, 'G3DSA:1.25.40.410:FF:000008', NULL, NULL, 'Tb-292 membrane associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(31822, NULL, 'G3DSA:3.90.550.10:FF:000322', NULL, NULL, 'Alpha-1,6-mannosyl-glycoprotein beta-1,2-N-acetylglucosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(31823, NULL, 'G3DSA:1.10.287.130:FF:000148', NULL, NULL, 'Two-component sensor EnvZ', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(31824, NULL, 'G3DSA:3.80.10.10:FF:000630', NULL, NULL, 'Unplaced genomic scaffold supercont2.23, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(31825, NULL, 'G3DSA:3.30.450.370:FF:000001', NULL, NULL, 'Secretion system protein E', NULL, NULL, NULL, NULL, NULL, 4),
(31826, NULL, 'G3DSA:3.30.870.10:FF:000028', NULL, NULL, 'Tyrosyl-DNA phosphodiesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(31827, NULL, 'G3DSA:4.10.470.20:FF:000001', NULL, NULL, 'N-acetylglucosamine-1-phosphotransferase subunits alpha/beta', NULL, NULL, NULL, NULL, NULL, 4),
(31828, NULL, 'G3DSA:3.80.10.10:FF:002867', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31829, NULL, 'G3DSA:1.20.1250.20:FF:000914', NULL, NULL, 'Myo-inositol/proton symporter (MIT)', NULL, NULL, NULL, NULL, NULL, 4),
(31830, NULL, 'G3DSA:3.30.70.590:FF:000009', NULL, NULL, 'Poly(A) polymerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31831, NULL, 'G3DSA:1.20.1070.10:FF:001544', NULL, NULL, 'Adrenergic receptor alpha 2a', NULL, NULL, NULL, NULL, NULL, 4),
(31832, NULL, 'G3DSA:1.10.3290.10:FF:000012', NULL, NULL, 'Cell filamentation protein Fic', NULL, NULL, NULL, NULL, NULL, 4),
(31833, NULL, 'G3DSA:1.10.30.10:FF:000044', NULL, NULL, 'High mobility group B1', NULL, NULL, NULL, NULL, NULL, 4),
(31834, NULL, 'G3DSA:3.40.30.10:FF:000280', NULL, NULL, 'Grx4 family monothiol glutaredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(31835, NULL, 'G3DSA:1.25.40.10:FF:004917', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31836, NULL, 'G3DSA:2.60.40.2130:FF:000005', NULL, NULL, 'Spondin-1', NULL, NULL, NULL, NULL, NULL, 4),
(31837, NULL, 'G3DSA:2.130.10.10:FF:000107', NULL, NULL, 'Vacuolar protein sorting-associated protein 41 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(31838, NULL, 'G3DSA:1.10.150.910:FF:000006', NULL, NULL, 'UV-damaged DNA binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31839, NULL, 'G3DSA:2.130.10.10:FF:005722', NULL, NULL, 'TBC1 domain family member 31-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(31840, NULL, 'G3DSA:3.10.20.30:FF:000033', NULL, NULL, 'Phenol hydroxylase component', NULL, NULL, NULL, NULL, NULL, 4),
(31841, NULL, 'G3DSA:1.10.510.10:FF:002987', NULL, NULL, 'AGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(31842, NULL, 'G3DSA:1.10.287.2720:FF:000010', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(31843, NULL, 'G3DSA:2.170.270.10:FF:000212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31844, NULL, 'G3DSA:2.30.42.10:FF:000208', NULL, NULL, 'tax1-binding protein 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(31845, NULL, 'G3DSA:1.20.1070.10:FF:002084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31846, NULL, 'G3DSA:3.30.160.60:FF:005014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31847, NULL, 'G3DSA:2.10.220.10:FF:000196', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(31848, NULL, 'G3DSA:3.20.20.70:FF:000556', NULL, NULL, 'Glutamate synthase, iron-sulfur cluster-binding subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31849, NULL, 'G3DSA:3.30.40.10:FF:001848', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31850, NULL, 'G3DSA:2.130.10.10:FF:002412', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31851, NULL, 'G3DSA:1.10.530.10:FF:000021', NULL, NULL, 'Chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(31852, NULL, 'G3DSA:3.90.920.10:FF:000019', NULL, NULL, 'DNA primase small subunit putative', NULL, NULL, NULL, NULL, NULL, 4),
(31853, NULL, 'G3DSA:1.20.58.530:FF:000019', NULL, NULL, 'Myosin-A', NULL, NULL, NULL, NULL, NULL, 4),
(31854, NULL, 'G3DSA:3.40.50.720:FF:002420', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31855, NULL, 'G3DSA:1.10.10.10:FF:001734', NULL, NULL, 'Winged-helix phosphate transcriptional response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(31856, NULL, 'G3DSA:3.20.20.10:FF:000066', NULL, NULL, 'Ornithine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(31857, NULL, 'G3DSA:1.20.1050.80:FF:000001', NULL, NULL, 'GTPase-activating protein and VPS9 domain-containing protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(31858, NULL, 'G3DSA:1.20.58.60:FF:000341', NULL, NULL, 'Trio, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(31859, NULL, 'G3DSA:1.10.1200.10:FF:000068', NULL, NULL, 'Acyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(31860, NULL, 'G3DSA:2.30.42.10:FF:000568', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31861, NULL, 'G3DSA:3.40.50.300:FF:000905', NULL, NULL, 'Heme ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(31862, NULL, 'G3DSA:3.40.50.300:FF:004216', NULL, NULL, 'Dynein heavy chain 6, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(31863, NULL, 'G3DSA:3.30.497.10:FF:000020', NULL, NULL, 'Angiotensinogen preproprotein', NULL, NULL, NULL, NULL, NULL, 4),
(31864, NULL, 'G3DSA:3.50.50.60:FF:000637', NULL, NULL, 'Oxidoreductase, FAD dependent', NULL, NULL, NULL, NULL, NULL, 4),
(31865, NULL, 'G3DSA:1.20.1250.20:FF:002067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31866, NULL, 'G3DSA:2.60.40.10:FF:001703', NULL, NULL, 'Zinc-alpha-2-glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(31867, NULL, 'G3DSA:2.60.40.10:FF:005014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31868, NULL, 'G3DSA:3.90.1310.10:FF:000034', NULL, NULL, 'Cell division protein FtsI [Peptidoglycan synthetase]', NULL, NULL, NULL, NULL, NULL, 4),
(31869, NULL, 'G3DSA:3.40.50.300:FF:004003', NULL, NULL, 'GD15502', NULL, NULL, NULL, NULL, NULL, 4),
(31870, NULL, 'G3DSA:2.60.120.330:FF:000106', NULL, NULL, 'Fe/2-OG dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(31871, NULL, 'G3DSA:2.70.160.11:FF:000072', NULL, NULL, 'Shk1 kinase-binding protein (Skb1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(31872, NULL, 'G3DSA:2.140.10.30:FF:000012', NULL, NULL, 'Dipeptidyl-peptidase 8-like serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(31873, NULL, 'G3DSA:3.30.160.60:FF:002529', NULL, NULL, 'B-cell CLL/lymphoma 6 member B protein', NULL, NULL, NULL, NULL, NULL, 4),
(31874, NULL, 'G3DSA:3.50.50.60:FF:000025', NULL, NULL, 'Dihydrolipoyl dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(31875, NULL, 'G3DSA:3.80.10.10:FF:002603', NULL, NULL, 'Leucine rich repeats and calponin homology domain containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(31876, NULL, 'G3DSA:1.25.10.10:FF:000958', NULL, NULL, 'AP-3 complex subunit delta, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31877, NULL, 'G3DSA:3.40.50.720:FF:001060', NULL, NULL, 'Potassium transporter peripheral membrane component', NULL, NULL, NULL, NULL, NULL, 4),
(31878, NULL, 'G3DSA:1.25.10.10:FF:000133', NULL, NULL, 'DnaJ heat shock protein family (Hsp40) member C13', NULL, NULL, NULL, NULL, NULL, 4),
(31879, NULL, 'G3DSA:3.40.50.300:FF:003727', NULL, NULL, 'ATP-dependent helicase hrpA', NULL, NULL, NULL, NULL, NULL, 4),
(31880, NULL, 'G3DSA:2.40.160.10:FF:000010', NULL, NULL, 'Mitochondrial import receptor subunit TOM40-1', NULL, NULL, NULL, NULL, NULL, 4),
(31881, NULL, 'G3DSA:1.10.510.10:FF:002936', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31882, NULL, 'G3DSA:1.20.58.1080:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31883, NULL, 'G3DSA:3.40.50.300:FF:008218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31884, NULL, 'G3DSA:3.90.1150.10:FF:000263', NULL, NULL, 'PLP-dependent transferase', NULL, NULL, NULL, NULL, NULL, 4),
(31885, NULL, 'G3DSA:3.50.50.100:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31886, NULL, 'G3DSA:2.20.28.200:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31887, NULL, 'G3DSA:2.30.30.100:FF:000084', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm8', NULL, NULL, NULL, NULL, NULL, 4),
(31888, NULL, 'G3DSA:3.40.50.720:FF:002369', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31889, NULL, 'G3DSA:2.40.50.140:FF:000024', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(31890, NULL, 'G3DSA:3.40.50.720:FF:001291', NULL, NULL, 'Short-chain alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(31891, NULL, 'G3DSA:1.25.10.10:FF:003331', NULL, NULL, 'Dynein axonemal assembly factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(31892, NULL, 'G3DSA:1.10.1060.10:FF:000028', NULL, NULL, 'CoB--CoM heterodisulfide reductase 2 iron-sulfur subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(31893, NULL, 'G3DSA:1.10.510.10:FF:000750', NULL, NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', NULL, NULL, NULL, NULL, NULL, 4),
(31894, NULL, 'G3DSA:2.60.40.10:FF:001411', NULL, NULL, 'Protein tyrosine phosphatase, receptor type B', NULL, NULL, NULL, NULL, NULL, 4),
(31895, NULL, 'G3DSA:2.60.40.1390:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31896, NULL, 'G3DSA:3.30.40.10:FF:002225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31897, NULL, 'G3DSA:1.10.375.10:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31898, NULL, 'G3DSA:3.90.226.10:FF:000288', NULL, NULL, 'ATP-dependent Clp protease proteolytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(31899, NULL, 'G3DSA:3.30.2450.30:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31900, NULL, 'G3DSA:2.10.90.10:FF:000039', NULL, NULL, 'growth/differentiation factor 15', NULL, NULL, NULL, NULL, NULL, 4),
(31901, NULL, 'G3DSA:3.40.120.10:FF:000026', NULL, NULL, 'GlcNAc phosphomutase', NULL, NULL, NULL, NULL, NULL, 4),
(31902, NULL, 'G3DSA:3.30.160.60:FF:000282', NULL, NULL, 'Zinc finger, matrin-type 2', NULL, NULL, NULL, NULL, NULL, 4),
(31903, NULL, 'G3DSA:3.90.20.20:FF:000032', NULL, NULL, 'GrpE protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(31904, NULL, 'G3DSA:2.160.10.10:FF:000067', NULL, NULL, 'Transferase hexapeptide repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(31905, NULL, 'G3DSA:2.60.40.10:FF:003541', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31906, NULL, 'G3DSA:2.60.40.150:FF:000330', NULL, NULL, 'uncharacterized protein LOC108095502 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(31907, NULL, 'G3DSA:3.20.20.70:FF:000348', NULL, NULL, 'Possible methyltransferase (Methylase)', NULL, NULL, NULL, NULL, NULL, 4),
(31908, NULL, 'G3DSA:3.40.50.150:FF:000759', NULL, NULL, 'Methylase', NULL, NULL, NULL, NULL, NULL, 4),
(31909, NULL, 'G3DSA:1.10.418.20:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31910, NULL, 'G3DSA:1.25.40.820:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31911, NULL, 'G3DSA:3.40.50.410:FF:000354', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31912, NULL, 'G3DSA:3.30.930.10:FF:000207', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(31913, NULL, 'G3DSA:2.130.10.10:FF:001956', NULL, NULL, 'WD-40 repeat protein family', NULL, NULL, NULL, NULL, NULL, 4),
(31914, NULL, 'G3DSA:3.80.10.10:FF:001878', NULL, NULL, 'Tubulin-specific chaperone, putative (AFU_orthologue AFUA_4G11870)', NULL, NULL, NULL, NULL, NULL, 4),
(31915, NULL, 'G3DSA:2.80.10.50:FF:000217', NULL, NULL, 'Fibroblast growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(31916, NULL, 'G3DSA:3.40.1190.10:FF:000001', NULL, NULL, 'UDP-N-acetylmuramate--L-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(31917, NULL, 'G3DSA:3.90.45.10:FF:000013', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(31918, NULL, 'G3DSA:1.10.555.10:FF:000252', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31919, NULL, 'G3DSA:3.40.50.1000:FF:000502', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31920, NULL, 'G3DSA:6.10.140.2220:FF:000028', NULL, NULL, 'MYND zinc finger (ZnF) domain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(31921, NULL, 'G3DSA:1.25.40.10:FF:003900', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31922, NULL, 'G3DSA:1.20.58.390:FF:000090', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(31923, NULL, 'G3DSA:1.20.58.900:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31924, NULL, 'G3DSA:1.10.510.10:FF:004061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31925, NULL, 'G3DSA:1.20.58.80:FF:000004', NULL, NULL, 'Vacuolar protein sorting-associated protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(31926, NULL, 'G3DSA:3.30.470.20:FF:000169', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(31927, NULL, 'G3DSA:1.20.1070.10:FF:001252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31928, NULL, 'G3DSA:3.90.70.10:FF:000706', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31929, NULL, 'G3DSA:1.20.58.2190:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31930, NULL, 'G3DSA:2.60.40.60:FF:000217', NULL, NULL, 'Cadherin 5', NULL, NULL, NULL, NULL, NULL, 4),
(31931, NULL, 'G3DSA:3.20.20.140:FF:000103', NULL, NULL, 'Histidinol-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(31932, NULL, 'G3DSA:2.40.128.20:FF:000011', NULL, NULL, 'Apolipoprotein M', NULL, NULL, NULL, NULL, NULL, 4),
(31933, NULL, 'G3DSA:3.30.160.60:FF:004497', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31934, NULL, 'G3DSA:3.40.50.1820:FF:000568', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(31935, NULL, 'G3DSA:1.20.1300.20:FF:000003', NULL, NULL, 'Ubiquitin thiolesterase (OtuB1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(31936, NULL, 'G3DSA:3.10.350.10:FF:000050', NULL, NULL, 'Motility protein FimV', NULL, NULL, NULL, NULL, NULL, 4),
(31937, NULL, 'G3DSA:3.30.70.2280:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31938, NULL, 'G3DSA:3.90.640.10:FF:000149', NULL, NULL, 'Actin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31939, NULL, 'G3DSA:2.30.40.10:FF:000086', NULL, NULL, 'Adenosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(31940, NULL, 'G3DSA:3.30.70.580:FF:000012', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(31941, NULL, 'G3DSA:3.40.50.300:FF:003811', NULL, NULL, 'Splicing endonuclease positive effector sen1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31942, NULL, 'G3DSA:1.20.120.1750:FF:000133', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(31943, NULL, 'G3DSA:1.25.40.10:FF:000174', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(31944, NULL, 'G3DSA:1.20.5.4770:FF:000020', NULL, NULL, 'Zinc finger A20 and AN1 domain-containing stress-associated protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(31945, NULL, 'G3DSA:1.20.5.110:FF:000164', NULL, NULL, 'Syntaxin-72, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31946, NULL, 'G3DSA:3.30.420.10:FF:000568', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31947, NULL, 'G3DSA:1.25.40.710:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31948, NULL, 'G3DSA:1.10.472.10:FF:000705', NULL, NULL, 'WNK lysine deficient protein kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(31949, NULL, 'G3DSA:3.30.890.10:FF:000030', NULL, NULL, 'Methyl-CpG-binding domain-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(31950, NULL, 'G3DSA:3.30.70.2820:FF:000005', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(31951, NULL, 'G3DSA:2.60.40.10:FF:000686', NULL, NULL, 'Cytotoxic T-lymphocyte protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(31952, NULL, 'G3DSA:3.40.50.10480:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31953, NULL, 'G3DSA:2.10.70.10:FF:000095', NULL, NULL, 'Zona pellucida sperm-binding protein 3 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(31954, NULL, 'G3DSA:1.25.10.10:FF:001190', NULL, NULL, 'Condensin-2 complex subunit D3', NULL, NULL, NULL, NULL, NULL, 4),
(31955, NULL, 'G3DSA:1.20.1250.20:FF:000802', NULL, NULL, 'Putative permease of the major facilitator superfamily, AmpG-like protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(31956, NULL, 'G3DSA:3.90.180.10:FF:000069', NULL, NULL, 'Putative NADP-dependent alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(31957, NULL, 'G3DSA:2.130.10.10:FF:005610', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(31958, NULL, 'G3DSA:1.25.40.180:FF:000332', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31959, NULL, 'G3DSA:1.20.58.100:FF:000008', NULL, NULL, 'Succinate dehydrogenase flavoprotein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(31960, NULL, 'G3DSA:1.20.120.1150:FF:000009', NULL, NULL, 'Serine/threonine-protein phosphatase 2A activator', NULL, NULL, NULL, NULL, NULL, 4),
(31961, NULL, 'G3DSA:2.60.40.10:FF:000422', NULL, NULL, 'Mast/stem cell growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(31962, NULL, 'G3DSA:1.10.510.10:FF:002779', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31963, NULL, 'G3DSA:3.30.1370.230:FF:000001', NULL, NULL, 'Stn1p', NULL, NULL, NULL, NULL, NULL, 4),
(31964, NULL, 'G3DSA:1.10.1450.10:FF:000047', NULL, NULL, 'Tetraspanin 66A, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(31965, NULL, 'G3DSA:2.60.120.330:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31966, NULL, 'G3DSA:3.40.50.1860:FF:000001', NULL, NULL, 'Glutamate racemase', NULL, NULL, NULL, NULL, NULL, 4),
(31967, NULL, 'G3DSA:3.90.550.10:FF:000614', NULL, NULL, 'Glycosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31968, NULL, 'G3DSA:3.40.50.300:FF:001670', NULL, NULL, 'Dynamin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(31969, NULL, 'G3DSA:3.40.50.1000:FF:000766', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31970, NULL, 'G3DSA:3.40.50.300:FF:008550', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31971, NULL, 'G3DSA:3.30.1330.10:FF:000010', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(31972, NULL, 'G3DSA:1.20.1260.10:FF:000007', NULL, NULL, 'DNA protection during starvation protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(31973, NULL, 'G3DSA:1.10.455.10:FF:000003', NULL, NULL, '40S ribosomal protein S5', NULL, NULL, NULL, NULL, NULL, 4),
(31974, NULL, 'G3DSA:3.30.450.20:FF:000218', NULL, NULL, 'Sensor kinase citA', NULL, NULL, NULL, NULL, NULL, 4),
(31975, NULL, 'G3DSA:1.10.238.10:FF:000881', NULL, NULL, 'Zinc finger, C3HC4 type (RING finger)/EF-hand domain pair, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31976, NULL, 'G3DSA:1.10.555.10:FF:000100', NULL, NULL, 'Inositol polyphosphate 5-phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(31977, NULL, 'G3DSA:3.30.1370.10:FF:000113', NULL, NULL, 'P-element somatic inhibitor, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(31978, NULL, 'G3DSA:3.90.1740.10:FF:000004', NULL, NULL, '2'',3''-cyclic nucleotide 3'' phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(31979, NULL, 'G3DSA:1.20.5.20:FF:000004', NULL, NULL, 'Apolipoprotein A-IV b, tandem duplicate 1', NULL, NULL, NULL, NULL, NULL, 4),
(31980, NULL, 'G3DSA:1.25.40.10:FF:002208', NULL, NULL, 'Putative signal recognition particle protein', NULL, NULL, NULL, NULL, NULL, 4),
(31981, NULL, 'G3DSA:2.130.10.10:FF:005222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31982, NULL, 'G3DSA:2.120.10.30:FF:000586', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31983, NULL, 'G3DSA:3.10.20.230:FF:000003', NULL, NULL, 'Neuronal migration protein doublecortin', NULL, NULL, NULL, NULL, NULL, 4),
(31984, NULL, 'G3DSA:3.30.110.30:FF:000005', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(31985, NULL, 'G3DSA:2.130.10.10:FF:003081', NULL, NULL, 'DNA damage-binding protein CMR1', NULL, NULL, NULL, NULL, NULL, 4),
(31986, NULL, 'G3DSA:1.20.1270.340:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31987, NULL, 'G3DSA:2.170.120.12:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31988, NULL, 'G3DSA:1.20.1420.10:FF:000009', NULL, NULL, 'Talin rod domain containing 1', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(31989, NULL, 'G3DSA:2.60.120.260:FF:000057', NULL, NULL, 'Reelin', NULL, NULL, NULL, NULL, NULL, 4),
(31990, NULL, 'G3DSA:2.60.40.10:FF:004637', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31991, NULL, 'G3DSA:3.40.50.150:FF:001327', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(31992, NULL, 'G3DSA:3.20.20.140:FF:000255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31993, NULL, 'G3DSA:3.20.20.80:FF:000834', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31994, NULL, 'G3DSA:1.25.40.860:FF:000025', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(31995, NULL, 'G3DSA:3.40.50.2000:FF:000757', NULL, NULL, 'PslF', NULL, NULL, NULL, NULL, NULL, 4),
(31996, NULL, 'G3DSA:1.25.40.20:FF:001071', NULL, NULL, 'Si:ch73-193i2.2', NULL, NULL, NULL, NULL, NULL, 4),
(31997, NULL, 'G3DSA:1.20.1060.10:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(31998, NULL, 'G3DSA:1.10.238.10:FF:000145', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(31999, NULL, 'G3DSA:2.60.120.260:FF:000321', NULL, NULL, 'Bgal-1', NULL, NULL, NULL, NULL, NULL, 4),
(32000, NULL, 'G3DSA:2.60.40.10:FF:003209', NULL, NULL, 'MSP_(Major_sperm_protein )_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(32001, NULL, 'G3DSA:3.40.50.300:FF:000001', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(32002, NULL, 'G3DSA:1.10.1370.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32003, NULL, 'G3DSA:3.90.76.10:FF:000040', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(32004, NULL, 'G3DSA:3.40.50.300:FF:006184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32005, NULL, 'G3DSA:2.10.109.10:FF:000038', NULL, NULL, 'Inner Mitochondrial Membrane Protease', NULL, NULL, NULL, NULL, NULL, 4),
(32006, NULL, 'G3DSA:3.40.190.10:FF:000917', NULL, NULL, 'Gll0431 protein', NULL, NULL, NULL, NULL, NULL, 4),
(32007, NULL, 'G3DSA:2.60.40.10:FF:003277', NULL, NULL, 'Limbic system-associated membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(32008, NULL, 'G3DSA:3.40.50.10310:FF:000012', NULL, NULL, '2-amino-5-formylamino-6-ribosylaminopyrimidin-4(3H)-one 5''-monophosphate deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(32009, NULL, 'G3DSA:1.20.1720.10:FF:000105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32010, NULL, 'G3DSA:3.20.20.80:FF:000446', NULL, NULL, 'Beta-galactosidase 5', NULL, NULL, NULL, NULL, NULL, 4),
(32011, NULL, 'G3DSA:2.10.25.10:FF:001698', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32012, NULL, 'G3DSA:3.40.50.300:FF:006420', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32013, NULL, 'G3DSA:1.20.1250.20:FF:002247', NULL, NULL, 'Solute carrier family 43 member 1a', NULL, NULL, NULL, NULL, NULL, 4),
(32014, NULL, 'G3DSA:3.40.50.2300:FF:000965', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32015, NULL, 'G3DSA:2.60.60.20:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32016, NULL, 'G3DSA:1.10.10.10:FF:000666', NULL, NULL, 'MarR family protein', NULL, NULL, NULL, NULL, NULL, 4),
(32017, NULL, 'G3DSA:2.40.37.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32018, NULL, 'G3DSA:3.40.50.1820:FF:001872', NULL, NULL, 'OpdE downstream ORF 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(32019, NULL, 'G3DSA:3.40.50.410:FF:000034', NULL, NULL, 'calcium-activated chloride channel regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(32020, NULL, 'G3DSA:3.50.50.60:FF:001306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32021, NULL, 'G3DSA:1.10.1320.10:FF:000015', NULL, NULL, 'DNA-dependent RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(32022, NULL, 'G3DSA:3.30.70.1180:FF:000013', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(32023, NULL, 'G3DSA:3.30.160.60:FF:001748', NULL, NULL, 'General transcription factor IIIA', NULL, NULL, NULL, NULL, NULL, 4),
(32024, NULL, 'G3DSA:3.30.40.10:FF:001505', NULL, NULL, 'Putative e3 ubiquitin-protein ligase msl2 isoform x3', NULL, NULL, NULL, NULL, NULL, 4),
(32025, NULL, 'G3DSA:3.90.830.10:FF:000012', NULL, NULL, 'Vacuolar protein sorting 33', NULL, NULL, NULL, NULL, NULL, 4),
(32026, NULL, 'G3DSA:1.10.3470.10:FF:000026', NULL, NULL, 'ABC-type Fe3+-siderophore transport system, permease component', NULL, NULL, NULL, NULL, NULL, 4),
(32027, NULL, 'G3DSA:3.30.200.20:FF:001807', NULL, NULL, 'Tyrosine-protein kinase RYK', NULL, NULL, NULL, NULL, NULL, 4),
(32028, NULL, 'G3DSA:1.10.1670.10:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32029, NULL, 'G3DSA:1.10.287.70:FF:000568', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(32030, NULL, 'G3DSA:3.40.50.12780:FF:000230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32031, NULL, 'G3DSA:3.40.50.1910:FF:000027', NULL, NULL, 'Vacuolar protein sorting-associated protein 45,putative', NULL, NULL, NULL, NULL, NULL, 4),
(32032, NULL, 'G3DSA:1.20.58.60:FF:000633', NULL, NULL, 'Spectrin repeat-containing, nuclear envelope 1b', NULL, NULL, NULL, NULL, NULL, 4),
(32033, NULL, 'G3DSA:3.30.559.30:FF:000131', NULL, NULL, 'Nonribosomal peptide synthetase easA', NULL, NULL, NULL, NULL, NULL, 4),
(32034, NULL, 'G3DSA:1.50.10.10:FF:000102', NULL, NULL, 'Mannosyl-oligosaccharide 1,2-alpha-mannosidase MNS2', NULL, NULL, NULL, NULL, NULL, 4),
(32035, NULL, 'G3DSA:1.20.1070.10:FF:001887', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32036, NULL, 'G3DSA:3.40.50.2300:FF:000841', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32037, NULL, 'G3DSA:3.40.30.10:FF:000572', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32038, NULL, 'G3DSA:3.40.720.10:FF:000268', NULL, NULL, 'Extracellular sulfatase SULF-1 homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(32039, NULL, 'G3DSA:1.20.120.1130:FF:000003', NULL, NULL, 'Vacuolar protein sorting-associated protein 28 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(32040, NULL, 'G3DSA:1.10.472.10:FF:000469', NULL, NULL, 'Transcription initiation factor IIB 5', NULL, NULL, NULL, NULL, NULL, 4),
(32041, NULL, 'G3DSA:1.10.287.160:FF:000016', NULL, NULL, 'Protein kinase N1a', NULL, NULL, NULL, NULL, NULL, 4),
(32042, NULL, 'G3DSA:1.10.167.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32043, NULL, 'G3DSA:3.90.550.50:FF:000143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32044, NULL, 'G3DSA:3.90.1170.20:FF:000003', NULL, NULL, 'Nicotinate-nucleotide pyrophosphorylase [carboxylating]', NULL, NULL, NULL, NULL, NULL, 4),
(32045, NULL, 'G3DSA:2.130.10.10:FF:005430', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32046, NULL, 'G3DSA:1.20.1270.60:FF:000169', NULL, NULL, 'Rgd3p', NULL, NULL, NULL, NULL, NULL, 4),
(32047, NULL, 'G3DSA:1.10.1040.10:FF:000084', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)], cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(32048, NULL, 'G3DSA:3.30.830.10:FF:000211', NULL, NULL, 'Metalloprotease, insulinase family', NULL, NULL, NULL, NULL, NULL, 4),
(32049, NULL, 'G3DSA:1.25.40.10:FF:004625', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32050, NULL, 'G3DSA:2.40.160.120:FF:000022', NULL, NULL, 'Oxysterol Binding protein (OSBP) Related', NULL, NULL, NULL, NULL, NULL, 4),
(32051, NULL, 'G3DSA:1.10.287.370:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32052, NULL, 'G3DSA:3.80.10.10:FF:003323', NULL, NULL, 'NLR family CARD domain-containing 8', NULL, NULL, NULL, NULL, NULL, 4),
(32053, NULL, 'G3DSA:3.30.70.330:FF:001590', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32054, NULL, 'G3DSA:1.10.274.30:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(32055, NULL, 'G3DSA:1.10.10.10:FF:001503', NULL, NULL, 'DNR protein', NULL, NULL, NULL, NULL, NULL, 4),
(32056, NULL, 'G3DSA:2.60.120.370:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32057, NULL, 'G3DSA:3.40.50.620:FF:000299', NULL, NULL, 'Sensor histidine kinase KdpD', NULL, NULL, NULL, NULL, NULL, 4),
(32058, NULL, 'G3DSA:3.40.30.10:FF:001010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32059, NULL, 'G3DSA:3.30.70.330:FF:001438', NULL, NULL, 'RNA-binding protein fox-1 homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(32060, NULL, 'G3DSA:2.70.150.10:FF:000070', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(32061, NULL, 'G3DSA:3.40.850.10:FF:000480', NULL, NULL, 'Kinesin motor domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(32062, NULL, 'G3DSA:3.40.50.300:FF:003435', NULL, NULL, 'Dynein heavy chain 6, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(32063, NULL, 'G3DSA:3.30.559.10:FF:000092', NULL, NULL, 'Protein ECERIFERUM 26-like', NULL, NULL, NULL, NULL, NULL, 4),
(32064, NULL, 'G3DSA:2.70.170.10:FF:000301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32065, NULL, 'G3DSA:2.30.180.10:FF:000007', NULL, NULL, 'Transforming growth factor-beta-induced protein ig-h3', NULL, NULL, NULL, NULL, NULL, 4),
(32066, NULL, 'G3DSA:2.30.29.30:FF:001307', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32067, NULL, 'G3DSA:3.30.800.10:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32068, NULL, 'G3DSA:3.40.50.300:FF:003699', NULL, NULL, 'Spastin', NULL, NULL, NULL, NULL, NULL, 4),
(32069, NULL, 'G3DSA:1.25.40.20:FF:001812', NULL, NULL, 'SH3 and multiple ankyrin repeat domains 3', NULL, NULL, NULL, NULL, NULL, 4),
(32070, NULL, 'G3DSA:1.10.510.10:FF:002195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32071, NULL, 'G3DSA:1.10.510.10:FF:003217', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32072, NULL, 'G3DSA:3.50.50.60:FF:000317', NULL, NULL, 'Apoptosis inducing factor, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(32073, NULL, 'G3DSA:3.30.479.20:FF:000037', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(32074, NULL, 'G3DSA:3.30.160.60:FF:001624', NULL, NULL, 'Zinc finger protein 354C', NULL, NULL, NULL, NULL, NULL, 4),
(32075, NULL, 'G3DSA:3.30.530.20:FF:000107', NULL, NULL, 'Coenzyme Q-binding protein, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4),
(32076, NULL, 'G3DSA:3.10.450.120:FF:000004', NULL, NULL, 'RNA-binding protein, containing PUA domain', NULL, NULL, NULL, NULL, NULL, 4),
(32077, NULL, 'G3DSA:1.10.510.10:FF:001531', NULL, NULL, 'Related to CBK1-Serine/threonine protein kinase involved in cell wall biosynthesis', NULL, NULL, NULL, NULL, NULL, 4),
(32078, NULL, 'G3DSA:3.30.450.20:FF:000494', NULL, NULL, 'PAS sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(32079, NULL, 'G3DSA:2.130.10.10:FF:001799', NULL, NULL, 'Eukaryotic translation initiation factor 2A', NULL, NULL, NULL, NULL, NULL, 4),
(32080, NULL, 'G3DSA:1.20.1250.20:FF:000061', NULL, NULL, 'MFS sugar transporter', NULL, NULL, NULL, NULL, NULL, 4),
(32081, NULL, 'G3DSA:4.10.240.10:FF:000122', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(32082, NULL, 'G3DSA:2.10.25.10:FF:000349', NULL, NULL, 'Latent transforming growth factor beta binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(32083, NULL, 'G3DSA:1.10.630.10:FF:000225', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(32084, NULL, 'G3DSA:2.60.40.10:FF:000051', NULL, NULL, 'Uncharacterized protein, isoform J', NULL, NULL, NULL, NULL, NULL, 4),
(32085, NULL, 'G3DSA:3.40.50.2000:FF:000965', NULL, NULL, 'Lipopolysaccharide core biosynthesis mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(32086, NULL, 'G3DSA:1.25.10.10:FF:002875', NULL, NULL, 'HEAT repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(32087, NULL, 'G3DSA:3.30.230.10:FF:000233', NULL, NULL, '40S ribosomal protein S2, putative', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(32088, NULL, 'G3DSA:1.10.20.10:FF:000228', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32089, NULL, 'G3DSA:3.50.50.60:FF:000868', NULL, NULL, 'Monooxygenase, FAD-binding', NULL, NULL, NULL, NULL, NULL, 4),
(32090, NULL, 'G3DSA:2.40.70.10:FF:000413', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32091, NULL, 'G3DSA:3.30.160.60:FF:004233', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32092, NULL, 'G3DSA:1.20.1280.50:FF:000105', NULL, NULL, 'Transport inhibitor response 1-like protein Os05g0150500', NULL, NULL, NULL, NULL, NULL, 4),
(32093, NULL, 'G3DSA:1.10.287.70:FF:000197', NULL, NULL, 'Glutamate receptor, ionotropic, delta 1', NULL, NULL, NULL, NULL, NULL, 4),
(32094, NULL, 'G3DSA:3.30.1360.210:FF:000010', NULL, NULL, 'LSU ribosomal protein L22E', NULL, NULL, NULL, NULL, NULL, 4),
(32095, NULL, 'G3DSA:3.20.20.140:FF:000367', NULL, NULL, 'Alkylphosphonate utilization protein PhnM', NULL, NULL, NULL, NULL, NULL, 4),
(32096, NULL, 'G3DSA:1.20.1250.20:FF:001819', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32097, NULL, 'G3DSA:4.10.280.10:FF:000017', NULL, NULL, 'Transcription factor bHLH66', NULL, NULL, NULL, NULL, NULL, 4),
(32098, NULL, 'G3DSA:1.10.630.10:FF:000017', NULL, NULL, 'cytochrome P450 2U1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(32099, NULL, 'G3DSA:3.30.70.890:FF:000009', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(32100, NULL, 'G3DSA:3.40.50.300:FF:002710', NULL, NULL, 'DNA repair helicase putative', NULL, NULL, NULL, NULL, NULL, 4),
(32101, NULL, 'G3DSA:1.50.40.10:FF:000110', NULL, NULL, 'Solute carrier family 25 member 3', NULL, NULL, NULL, NULL, NULL, 4),
(32102, NULL, 'G3DSA:1.20.1560.10:FF:000834', NULL, NULL, 'ABC transporter multi-drug efflux transporter-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(32103, NULL, 'G3DSA:2.30.30.30:FF:000086', NULL, NULL, 'Transcription elongation factor SPT5', NULL, NULL, NULL, NULL, NULL, 4),
(32104, NULL, 'G3DSA:3.80.10.10:FF:003952', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32105, NULL, 'G3DSA:3.40.50.300:FF:000321', NULL, NULL, 'Thymidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(32106, NULL, 'G3DSA:3.30.365.10:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32107, NULL, 'G3DSA:3.40.1360.10:FF:000009', NULL, NULL, 'Meiotic recombination protein SPO11-2', NULL, NULL, NULL, NULL, NULL, 4),
(32108, NULL, 'G3DSA:3.60.40.10:FF:000184', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(32109, NULL, 'G3DSA:1.10.287.210:FF:000003', NULL, NULL, 'Envelope glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(32110, NULL, 'G3DSA:1.10.260.40:FF:000020', NULL, NULL, 'Trifunctional nicotinamide-nucleotide adenylyltransferase/ribosylnicotinamide kinase/transcriptional regulator NadR', NULL, NULL, NULL, NULL, NULL, 4),
(32111, NULL, 'G3DSA:3.40.50.300:FF:006684', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32112, NULL, 'G3DSA:3.40.1800.20:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32113, NULL, 'G3DSA:3.40.140.10:FF:000089', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit F', NULL, NULL, NULL, NULL, NULL, 4),
(32114, NULL, 'G3DSA:1.10.10.10:FF:000402', NULL, NULL, 'Trehalose operon transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(32115, NULL, 'G3DSA:3.40.50.2000:FF:000577', NULL, NULL, 'GalNAc-alpha-(1->4)-GalNAc-alpha-(1->3)-diNAcBac-PP-undecaprenol alpha-1,4-N-acetyl-D-galactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(32116, NULL, 'G3DSA:2.60.40.10:FF:005694', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32117, NULL, 'G3DSA:1.20.5.320:FF:000013', NULL, NULL, 'Collagen alpha-1(XVII) chain', NULL, NULL, NULL, NULL, NULL, 4),
(32118, NULL, 'G3DSA:3.40.220.10:FF:000011', NULL, NULL, 'Leucine aminopeptidase 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(32119, NULL, 'G3DSA:2.60.120.200:FF:000798', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(32120, NULL, 'G3DSA:3.30.70.3250:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32121, NULL, 'G3DSA:3.30.1490.40:FF:000007', NULL, NULL, 'GYF domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(32122, NULL, 'G3DSA:3.60.21.10:FF:000196', NULL, NULL, 'Acid sphingomyelinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(32123, NULL, 'G3DSA:1.25.40.10:FF:003720', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32124, NULL, 'G3DSA:1.10.150.50:FF:000172', NULL, NULL, 'E74 like ETS transcription factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(32125, NULL, 'G3DSA:3.40.50.1820:FF:001349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32126, NULL, 'G3DSA:1.20.1070.10:FF:000459', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(32127, NULL, 'G3DSA:1.10.260.100:FF:000030', NULL, NULL, 'AGAP009119-PA', NULL, NULL, NULL, NULL, NULL, 4),
(32128, NULL, 'G3DSA:2.60.40.1530:FF:000005', NULL, NULL, 'Integrin, alpha 9', NULL, NULL, NULL, NULL, NULL, 4),
(32129, NULL, 'G3DSA:2.60.40.10:FF:002760', NULL, NULL, 'Glycoprotein UL18', NULL, NULL, NULL, NULL, NULL, 4),
(32130, NULL, 'G3DSA:2.40.40.20:FF:000061', NULL, NULL, 'ATPase, AAA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(32131, NULL, 'G3DSA:3.40.50.300:FF:006925', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32132, NULL, 'G3DSA:2.60.120.330:FF:000078', NULL, NULL, 'Clavaminate synthase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(32133, NULL, 'G3DSA:3.80.10.10:FF:002316', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32134, NULL, 'G3DSA:1.25.40.10:FF:000674', NULL, NULL, 'Protein TONSOKU', NULL, NULL, NULL, NULL, NULL, 4),
(32135, NULL, 'G3DSA:1.20.1640.10:FF:000104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32136, NULL, 'G3DSA:3.40.50.410:FF:000242', NULL, NULL, 'integrator complex subunit 14', NULL, NULL, NULL, NULL, NULL, 4),
(32137, NULL, 'G3DSA:2.20.130.10:FF:000001', NULL, NULL, 'dTDP-3-amino-3,4,6-trideoxy-alpha-D-glucopyranose', NULL, NULL, NULL, NULL, NULL, 4),
(32138, NULL, 'G3DSA:3.40.50.720:FF:001644', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32139, NULL, 'G3DSA:3.30.70.100:FF:000026', NULL, NULL, 'ATPase copper transporting alpha', NULL, NULL, NULL, NULL, NULL, 4),
(32140, NULL, 'G3DSA:2.30.40.10:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32141, NULL, 'G3DSA:1.20.1440.180:FF:000010', NULL, NULL, 'Probable serine/threonine-protein kinase ireA', NULL, NULL, NULL, NULL, NULL, 4),
(32142, NULL, 'G3DSA:3.40.50.1460:FF:000140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32143, NULL, 'G3DSA:2.40.30.10:FF:000416', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32144, NULL, 'G3DSA:1.20.5.110:FF:000040', NULL, NULL, 'SNAP25 homologous protein SNAP33', NULL, NULL, NULL, NULL, NULL, 4),
(32145, NULL, 'G3DSA:1.20.58.390:FF:000314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32146, NULL, 'G3DSA:3.30.50.10:FF:000045', NULL, NULL, 'Transcription factor elt-7', NULL, NULL, NULL, NULL, NULL, 4),
(32147, NULL, 'G3DSA:3.40.50.790:FF:000035', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(32148, NULL, 'G3DSA:3.10.129.110:FF:000017', NULL, NULL, 'Lovastatin diketide synthase LovF', NULL, NULL, NULL, NULL, NULL, 4),
(32149, NULL, 'G3DSA:3.30.70.330:FF:001090', NULL, NULL, 'Si:ch73-190f9.4', NULL, NULL, NULL, NULL, NULL, 4),
(32150, NULL, 'G3DSA:3.40.50.300:FF:005060', NULL, NULL, 'Miro-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(32151, NULL, 'G3DSA:3.40.50.300:FF:007201', NULL, NULL, 'Shikimate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(32152, NULL, 'G3DSA:1.10.8.720:FF:000006', NULL, NULL, 'cytoplasmic dynein 2 heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(32153, NULL, 'G3DSA:3.90.1110.10:FF:000002', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(32154, NULL, 'G3DSA:1.25.10.10:FF:003252', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(32155, NULL, 'G3DSA:2.60.40.10:FF:004901', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32156, NULL, 'G3DSA:3.40.50.300:FF:003935', NULL, NULL, 'Rad17 protein', NULL, NULL, NULL, NULL, NULL, 4),
(32157, NULL, 'G3DSA:3.90.1580.10:FF:000020', NULL, NULL, 'Probable serine/threonine-protein kinase pknB', NULL, NULL, NULL, NULL, NULL, 4),
(32158, NULL, 'G3DSA:1.25.40.10:FF:004889', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32159, NULL, 'G3DSA:1.10.510.10:FF:003717', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32160, NULL, 'G3DSA:1.25.40.180:FF:000068', NULL, NULL, 'Eukaryotic translation initiation factor 4 gamma 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(32161, NULL, 'G3DSA:3.90.660.10:FF:000072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32162, NULL, 'G3DSA:3.40.50.300:FF:001018', NULL, NULL, 'Rab family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(32163, NULL, 'G3DSA:1.20.1070.10:FF:001752', NULL, NULL, 'Olfactory receptor 1507', NULL, NULL, NULL, NULL, NULL, 4),
(32164, NULL, 'G3DSA:3.40.30.10:FF:000072', NULL, NULL, 'Phosducin like', NULL, NULL, NULL, NULL, NULL, 4),
(32165, NULL, 'G3DSA:3.30.70.3170:FF:000003', NULL, NULL, 'Galactokinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(32166, NULL, 'G3DSA:2.10.25.10:FF:000529', NULL, NULL, 'Eyes shut homolog', NULL, NULL, NULL, NULL, NULL, 4),
(32167, NULL, 'G3DSA:1.25.10.10:FF:001122', NULL, NULL, 'Coatomer subunit beta-1', NULL, NULL, NULL, NULL, NULL, 4),
(32168, NULL, 'G3DSA:2.130.10.10:FF:000607', NULL, NULL, 'Autophagy related 16 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(32169, NULL, 'G3DSA:1.25.40.10:FF:005165', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(32170, NULL, 'G3DSA:3.40.630.10:FF:000109', NULL, NULL, 'Putative membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(32171, NULL, 'G3DSA:3.30.70.330:FF:003068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32172, NULL, 'G3DSA:3.90.1100.10:FF:000052', NULL, NULL, 'Os03g0646800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(32173, NULL, 'G3DSA:3.30.9.10:FF:000034', NULL, NULL, 'Fructosyl amino acid oxidasesarcosine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(32174, NULL, 'G3DSA:2.130.10.10:FF:005346', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32175, NULL, 'G3DSA:1.10.720.30:FF:000002', NULL, NULL, 'Myocardin related transcription factor A', NULL, NULL, NULL, NULL, NULL, 4),
(32176, NULL, 'G3DSA:2.170.16.10:FF:000001', NULL, NULL, 'Indian hedgehog', NULL, NULL, NULL, NULL, NULL, 4),
(32177, NULL, 'G3DSA:2.10.25.10:FF:000681', NULL, NULL, 'Multiple epidermal growth factor-like domains 8', NULL, NULL, NULL, NULL, NULL, 4),
(32178, NULL, 'G3DSA:3.30.1490.430:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32179, NULL, 'G3DSA:3.40.50.1820:FF:000444', NULL, NULL, 'Putative serine esterase Rv1835c', NULL, NULL, NULL, NULL, NULL, 4),
(32180, NULL, 'G3DSA:1.20.1250.20:FF:001342', NULL, NULL, 'GD11715', NULL, NULL, NULL, NULL, NULL, 4),
(32181, NULL, 'G3DSA:3.30.70.1820:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32182, NULL, 'G3DSA:3.30.70.260:FF:000085', NULL, NULL, 'ACT domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(32183, NULL, 'G3DSA:2.60.40.10:FF:005418', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32184, NULL, 'G3DSA:3.40.50.1700:FF:000049', NULL, NULL, 'Glycosyl hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(32185, NULL, 'G3DSA:1.25.40.20:FF:000290', NULL, NULL, 'C2H2 finger and ankyrin domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(32186, NULL, 'G3DSA:1.20.1250.20:FF:001078', NULL, NULL, 'Solute carrier family 15 (oligopeptide transporter), member 4', NULL, NULL, NULL, NULL, NULL, 4),
(32187, NULL, 'G3DSA:1.10.10.570:FF:000009', NULL, NULL, 'Vacuolar protein-sorting-associated protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(32188, NULL, 'G3DSA:3.30.160.60:FF:000500', NULL, NULL, 'Tripartite motif-containing 46, isoform CRA_c', NULL, NULL, NULL, NULL, NULL, 4),
(32189, NULL, 'G3DSA:1.10.238.270:FF:000006', NULL, NULL, 'Odorant-binding protein 50b', NULL, NULL, NULL, NULL, NULL, 4),
(32190, NULL, 'G3DSA:3.40.50.150:FF:000607', NULL, NULL, 'Arginine N-methyltransferase, type I', NULL, NULL, NULL, NULL, NULL, 4),
(32191, NULL, 'G3DSA:3.50.50.60:FF:000525', NULL, NULL, 'D-Amino acid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(32192, NULL, 'G3DSA:2.30.30.940:FF:000009', NULL, NULL, 'ATP-dependent RecD-like DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(32193, NULL, 'G3DSA:3.20.20.70:FF:000269', NULL, NULL, 'Putative 2-dehydro-3-deoxy-D-gluconate aldolase YagE', NULL, NULL, NULL, NULL, NULL, 4),
(32194, NULL, 'G3DSA:2.60.120.590:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32195, NULL, 'G3DSA:3.40.50.2300:FF:001185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32196, NULL, 'G3DSA:2.80.10.50:FF:000285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32197, NULL, 'G3DSA:3.30.40.10:FF:001444', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32198, NULL, 'G3DSA:3.40.640.10:FF:000003', NULL, NULL, 'Cysteine desulfurase IscS', NULL, NULL, NULL, NULL, NULL, 4),
(32199, NULL, 'G3DSA:3.40.1110.10:FF:000429', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32200, NULL, 'G3DSA:2.60.120.200:FF:000410', NULL, NULL, 'Thrombospondin 3', NULL, NULL, NULL, NULL, NULL, 4),
(32201, NULL, 'G3DSA:1.25.40.20:FF:000059', NULL, NULL, 'E3 ubiquitin-protein ligase MIB1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(32202, NULL, 'G3DSA:3.40.367.20:FF:000051', NULL, NULL, 'Hexokinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(32203, NULL, 'G3DSA:3.30.1520.10:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32204, NULL, 'G3DSA:4.10.1240.10:FF:000046', NULL, NULL, 'Diuretic hormone receptor precursor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(32205, NULL, 'G3DSA:3.40.720.10:FF:000004', NULL, NULL, 'Arylsulfatase E', NULL, NULL, NULL, NULL, NULL, 4),
(32206, NULL, 'G3DSA:3.40.50.720:FF:000683', NULL, NULL, 'Probable short-chain dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(32207, NULL, 'G3DSA:3.30.470.10:FF:000048', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(32208, NULL, 'G3DSA:1.25.10.10:FF:000846', NULL, NULL, 'Armadillo repeat-containing X-linked protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(32209, NULL, 'G3DSA:3.40.1190.20:FF:000061', NULL, NULL, 'Fructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(32210, NULL, 'G3DSA:3.90.1030.10:FF:000001', NULL, NULL, '50S ribosomal protein L17', NULL, NULL, NULL, NULL, NULL, 4),
(32211, NULL, 'G3DSA:3.20.20.80:FF:000626', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32212, NULL, 'G3DSA:3.30.160.60:FF:006363', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32213, NULL, 'G3DSA:3.90.740.10:FF:000073', NULL, NULL, 'ATP binding / aminoacyl-tRNA ligase/ nucleotide binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(32214, NULL, 'G3DSA:3.30.360.20:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32215, NULL, 'G3DSA:1.10.287.1490:FF:000107', NULL, NULL, 'COP1-interactive protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(32216, NULL, 'G3DSA:2.40.50.140:FF:000288', NULL, NULL, 'Transcription elongation factor SPT6', NULL, NULL, NULL, NULL, NULL, 4),
(32217, NULL, 'G3DSA:1.10.510.10:FF:000227', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(32218, NULL, 'G3DSA:3.90.640.10:FF:000088', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(32219, NULL, 'G3DSA:2.60.200.40:FF:000012', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(32220, NULL, 'G3DSA:2.60.40.10:FF:001203', NULL, NULL, 'Tenascin N', NULL, NULL, NULL, NULL, NULL, 4),
(32221, NULL, 'G3DSA:2.130.10.10:FF:001456', NULL, NULL, 'Pre-rRNA-processing protein IPI3, putative', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(32222, NULL, 'G3DSA:2.60.40.10:FF:000927', NULL, NULL, 'Plexin D1', NULL, NULL, NULL, NULL, NULL, 4),
(32223, NULL, 'G3DSA:3.90.228.10:FF:000006', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(32224, NULL, 'G3DSA:3.90.550.10:FF:000261', NULL, NULL, 'GLYcosylation related', NULL, NULL, NULL, NULL, NULL, 4),
(32225, NULL, 'G3DSA:3.30.70.330:FF:001831', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32226, NULL, 'G3DSA:1.25.40.20:FF:001571', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(32227, NULL, 'G3DSA:1.10.630.10:FF:000293', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32228, NULL, 'G3DSA:2.60.40.1180:FF:000035', NULL, NULL, 'Glucosylceramidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(32229, NULL, 'G3DSA:3.80.10.10:FF:004492', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(32230, NULL, 'G3DSA:1.10.510.10:FF:002436', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32231, NULL, 'G3DSA:1.10.3090.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32232, NULL, 'G3DSA:3.30.160.60:FF:000843', NULL, NULL, 'Potential zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(32233, NULL, 'G3DSA:1.20.1280.50:FF:000173', NULL, NULL, 'F-box protein At2g02240', NULL, NULL, NULL, NULL, NULL, 4),
(32234, NULL, 'G3DSA:3.40.1350.10:FF:000003', NULL, NULL, 'tRNA-splicing endonuclease subunit Sen15 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(32235, NULL, 'G3DSA:2.130.10.120:FF:000005', NULL, NULL, 'Prolyl endopeptidase like', NULL, NULL, NULL, NULL, NULL, 4),
(32236, NULL, 'G3DSA:3.40.50.10490:FF:000077', NULL, NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', NULL, NULL, NULL, NULL, NULL, 4),
(32237, NULL, 'G3DSA:2.60.40.200:FF:000013', NULL, NULL, 'Superoxide dismutase [Cu-Zn]', NULL, NULL, NULL, NULL, NULL, 4),
(32238, NULL, 'G3DSA:2.80.10.50:FF:000009', NULL, NULL, 'Ryanodine receptor 1 (skeletal)', NULL, NULL, NULL, NULL, NULL, 4),
(32239, NULL, 'G3DSA:3.40.50.620:FF:000479', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32240, NULL, 'G3DSA:2.30.30.40:FF:000364', NULL, NULL, 'AMPHiphysin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(32241, NULL, 'G3DSA:3.30.2410.10:FF:000022', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(32242, NULL, 'G3DSA:1.10.472.80:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32243, NULL, 'G3DSA:3.40.50.300:FF:004155', NULL, NULL, 'WHiTe (Drosophila) related ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(32244, NULL, 'G3DSA:3.40.50.10140:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32245, NULL, 'G3DSA:3.40.50.1240:FF:000023', NULL, NULL, 'Periplasmic glucose-1-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(32246, NULL, 'G3DSA:3.30.160.60:FF:004154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32247, NULL, 'G3DSA:3.40.50.10470:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32248, NULL, 'G3DSA:3.30.70.330:FF:002219', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32249, NULL, 'G3DSA:2.30.29.170:FF:000006', NULL, NULL, 'EF-hand domain-containing family member C2', NULL, NULL, NULL, NULL, NULL, 4),
(32250, NULL, 'G3DSA:3.40.50.1260:FF:000029', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(32251, NULL, 'G3DSA:3.30.460.10:FF:000042', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(32252, NULL, 'G3DSA:3.30.1360.40:FF:000003', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(32253, NULL, 'G3DSA:1.20.1440.130:FF:000012', NULL, NULL, 'AGAP000543-PA', NULL, NULL, NULL, NULL, NULL, 4),
(32254, NULL, 'G3DSA:3.30.200.20:FF:001875', NULL, NULL, 'Calcium/calmodulin-dependent protein kinase type II', NULL, NULL, NULL, NULL, NULL, 4),
(32255, NULL, 'G3DSA:3.30.540.10:FF:000043', NULL, NULL, 'Putative inositol monophosphatase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(32256, NULL, 'G3DSA:3.30.450.20:FF:000573', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32257, NULL, 'G3DSA:3.30.565.10:FF:000302', NULL, NULL, 'GAF sensor signal transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(32258, NULL, 'G3DSA:3.40.630.10:FF:000385', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32259, NULL, 'G3DSA:2.40.50.200:FF:000003', NULL, NULL, 'Stress-induced protein YgiW', NULL, NULL, NULL, NULL, NULL, 4),
(32260, NULL, 'G3DSA:3.40.140.10:FF:000010', NULL, NULL, 'AMSH-like protease isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(32261, NULL, 'G3DSA:3.30.70.330:FF:001270', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(32262, NULL, 'G3DSA:1.25.40.10:FF:005345', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32263, NULL, 'G3DSA:1.10.8.270:FF:000040', NULL, NULL, 'GTPase-activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(32264, NULL, 'G3DSA:2.40.10.10:FF:000584', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32265, NULL, 'G3DSA:3.40.630.30:FF:000267', NULL, NULL, 'GNAT family N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(32266, NULL, 'G3DSA:2.60.120.10:FF:000374', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(32267, NULL, 'G3DSA:1.10.10.2170:FF:000001', NULL, NULL, 'Telomeric repeat-binding factor 2-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(32268, NULL, 'G3DSA:2.10.25.10:FF:001777', NULL, NULL, 'Uromodulin', NULL, NULL, NULL, NULL, NULL, 4),
(32269, NULL, 'G3DSA:3.40.630.30:FF:000003', NULL, NULL, 'Elongator complex protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(32270, NULL, 'G3DSA:3.40.50.300:FF:007589', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32271, NULL, 'G3DSA:2.30.29.30:FF:000369', NULL, NULL, 'Oxysterol binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(32272, NULL, 'G3DSA:4.10.400.10:FF:000106', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(32273, NULL, 'G3DSA:3.90.70.80:FF:000025', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(32274, NULL, 'G3DSA:3.30.40.10:FF:000988', NULL, NULL, 'RING/U-box superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(32275, NULL, 'G3DSA:2.170.140.10:FF:000051', NULL, NULL, 'Mucin 68E', NULL, NULL, NULL, NULL, NULL, 4),
(32276, NULL, 'G3DSA:1.25.40.90:FF:000091', NULL, NULL, 'Cids-2', NULL, NULL, NULL, NULL, NULL, 4),
(32277, NULL, 'G3DSA:3.10.20.90:FF:000236', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 7, variant', NULL, NULL, NULL, NULL, NULL, 4),
(32278, NULL, 'G3DSA:3.10.110.10:FF:000004', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 A', NULL, NULL, NULL, NULL, NULL, 4),
(32279, NULL, 'G3DSA:1.20.140.10:FF:000101', NULL, NULL, 'Medium-chain acyl-CoA dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(32280, NULL, 'G3DSA:2.30.30.100:FF:000145', NULL, NULL, 'SnRNP Sm-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(32281, NULL, 'G3DSA:3.40.850.10:FF:000160', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(32282, NULL, 'G3DSA:3.40.190.10:FF:000013', NULL, NULL, 'Lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(32283, NULL, 'G3DSA:1.25.40.1040:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32284, NULL, 'G3DSA:2.60.120.290:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32285, NULL, 'G3DSA:1.25.40.10:FF:000410', NULL, NULL, 'Pre-mRNA-splicing factor prp1', NULL, NULL, NULL, NULL, NULL, 4),
(32286, NULL, 'G3DSA:3.40.50.300:FF:003194', NULL, NULL, 'ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(32287, NULL, 'G3DSA:3.30.310.80:FF:000058', NULL, NULL, '5''-AMP-activated protein kinase catalytic subunit alpha-1', NULL, NULL, NULL, NULL, NULL, 4),
(32288, NULL, 'G3DSA:3.40.250.10:FF:000182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(32289, NULL, 'G3DSA:2.30.30.40:FF:000100', NULL, NULL, 'SH3 domain-containing YSC84-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(32290, NULL, 'G3DSA:1.25.40.10:FF:001511', NULL, NULL, 'OSJNBa0060P14.4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(32291, NULL, 'G3DSA:3.90.1640.10:FF:000019', NULL, NULL, 'Manganese-dependent inorganic pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(32292, NULL, 'G3DSA:3.80.10.10:FF:001182', NULL, NULL, 'Si:dkey-121n8.7', NULL, NULL, NULL, NULL, NULL, 4),
(32293, NULL, 'G3DSA:3.40.720.10:FF:000347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32294, NULL, 'G3DSA:1.50.10.20:FF:000083', NULL, NULL, 'Rab geranylgeranyltransferase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(32295, NULL, 'G3DSA:3.40.50.300:FF:002530', NULL, NULL, 'ABC transporter A family member 5', NULL, NULL, NULL, NULL, NULL, 4),
(32296, NULL, 'G3DSA:3.30.160.60:FF:001692', NULL, NULL, 'Transcriptional activator/repressor GIS1', NULL, NULL, NULL, NULL, NULL, 4),
(32297, NULL, 'G3DSA:1.10.418.10:FF:000131', NULL, NULL, 'Dystrophin-1', NULL, NULL, NULL, NULL, NULL, 4),
(32298, NULL, 'G3DSA:1.10.1200.50:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32299, NULL, 'G3DSA:3.40.50.300:FF:005964', NULL, NULL, 'ATP-dependent DNA helicase, RecQ family', NULL, NULL, NULL, NULL, NULL, 4),
(32300, NULL, 'G3DSA:3.40.30.10:FF:000813', NULL, NULL, 'Pyrimidodiazepine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(32301, NULL, 'G3DSA:2.60.40.10:FF:000186', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(32302, NULL, 'G3DSA:1.50.40.10:FF:000453', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32303, NULL, 'G3DSA:3.30.420.10:FF:000388', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32304, NULL, 'G3DSA:1.20.920.10:FF:000099', NULL, NULL, 'Chromatin remodeling-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(32305, NULL, 'G3DSA:1.25.40.180:FF:000248', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32306, NULL, 'G3DSA:3.30.505.10:FF:000153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32307, NULL, 'G3DSA:3.30.1490.20:FF:000001', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(32308, NULL, 'G3DSA:1.20.1270.10:FF:000115', NULL, NULL, 'ADR128Cp', NULL, NULL, NULL, NULL, NULL, 4),
(32309, NULL, 'G3DSA:1.20.120.980:FF:000007', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(32310, NULL, 'G3DSA:2.60.120.650:FF:000168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32311, NULL, 'G3DSA:1.10.730.10:FF:000002', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(32312, NULL, 'G3DSA:3.40.640.10:FF:000346', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32313, NULL, 'G3DSA:3.30.70.330:FF:003063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32314, NULL, 'G3DSA:3.90.226.10:FF:000120', NULL, NULL, 'Putative acetyl-coenzyme A carboxylase carboxyl transferase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(32315, NULL, 'G3DSA:4.10.240.10:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32316, NULL, 'G3DSA:1.20.1270.60:FF:000034', NULL, NULL, 'DCC-interacting protein 13-alpha isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(32317, NULL, 'G3DSA:4.10.400.10:FF:000281', NULL, NULL, 'complement component C9', NULL, NULL, NULL, NULL, NULL, 4),
(32318, NULL, 'G3DSA:3.40.50.300:FF:007358', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32319, NULL, 'G3DSA:3.90.1150.10:FF:000499', NULL, NULL, 'Aminotransferase, conjectural', NULL, NULL, NULL, NULL, NULL, 4),
(32320, NULL, 'G3DSA:3.40.50.300:FF:007414', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32321, NULL, 'G3DSA:3.10.129.10:FF:000266', NULL, NULL, 'AAL038Wp', NULL, NULL, NULL, NULL, NULL, 4),
(32322, NULL, 'G3DSA:1.10.510.10:FF:003212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32323, NULL, 'G3DSA:1.20.120.1900:FF:000083', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(32324, NULL, 'G3DSA:2.60.20.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32325, NULL, 'G3DSA:1.10.560.10:FF:000017', NULL, NULL, 'T-complex protein 1 subunit eta', NULL, NULL, NULL, NULL, NULL, 4),
(32326, NULL, 'G3DSA:3.40.50.12780:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32327, NULL, 'G3DSA:2.60.40.60:FF:000509', NULL, NULL, 'Protein CBR-CDH-12', NULL, NULL, NULL, NULL, NULL, 4),
(32328, NULL, 'G3DSA:3.80.10.10:FF:002199', NULL, NULL, 'Si:ch211-191a16.2', NULL, NULL, NULL, NULL, NULL, 4),
(32329, NULL, 'G3DSA:2.60.120.680:FF:000008', NULL, NULL, 'PATELLIN 2', NULL, NULL, NULL, NULL, NULL, 4),
(32330, NULL, 'G3DSA:1.25.10.10:FF:002999', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32331, NULL, 'G3DSA:1.10.268.10:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32332, NULL, 'G3DSA:3.30.200.20:FF:001307', NULL, NULL, 'Differentiation inhibitory kinase', NULL, NULL, NULL, NULL, NULL, 4),
(32333, NULL, 'G3DSA:1.10.8.470:FF:000004', NULL, NULL, 'Redox-regulated ATPase YchF', NULL, NULL, NULL, NULL, NULL, 4),
(32334, NULL, 'G3DSA:1.25.40.20:FF:000851', NULL, NULL, 'Protein CBG23394', NULL, NULL, NULL, NULL, NULL, 4),
(32335, NULL, 'G3DSA:3.30.200.20:FF:000739', NULL, NULL, 'Serine/threonine protein kinase VPS15', NULL, NULL, NULL, NULL, NULL, 4),
(32336, NULL, 'G3DSA:3.40.20.10:FF:000127', NULL, NULL, 'YALI0E33693p', NULL, NULL, NULL, NULL, NULL, 4),
(32337, NULL, 'G3DSA:3.30.230.10:FF:000238', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(32338, NULL, 'G3DSA:1.10.287.2610:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32339, NULL, 'G3DSA:3.30.160.60:FF:001068', NULL, NULL, 'Zinc finger and BTB domain-containing 48', NULL, NULL, NULL, NULL, NULL, 4),
(32340, NULL, 'G3DSA:2.60.40.10:FF:004289', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32341, NULL, 'G3DSA:3.30.160.60:FF:004789', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32342, NULL, 'G3DSA:3.40.50.300:FF:003143', NULL, NULL, '6-phosphofructo-2-kinase/fructose-2, 6-biphosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(32343, NULL, 'G3DSA:2.60.40.10:FF:004345', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32344, NULL, 'G3DSA:3.10.100.10:FF:000239', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32345, NULL, 'G3DSA:2.60.40.10:FF:003777', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32346, NULL, 'G3DSA:2.40.70.10:FF:000065', NULL, NULL, 'Eukaryotic aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(32347, NULL, 'G3DSA:3.40.50.10350:FF:000001', NULL, NULL, 'Glycerate kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(32348, NULL, 'G3DSA:2.130.10.10:FF:002232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32349, NULL, 'G3DSA:3.30.420.40:FF:001004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32350, NULL, 'G3DSA:3.40.50.12780:FF:000235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32351, NULL, 'G3DSA:1.20.1110.10:FF:000014', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(32352, NULL, 'G3DSA:3.80.10.10:FF:002255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32353, NULL, 'G3DSA:3.40.50.150:FF:001664', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32354, NULL, 'G3DSA:1.20.810.10:FF:000006', NULL, NULL, 'Cytochrome b', NULL, NULL, NULL, NULL, NULL, 4),
(32355, NULL, 'G3DSA:1.10.510.10:FF:003156', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32356, NULL, 'G3DSA:3.40.50.1000:FF:000210', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(32357, NULL, 'G3DSA:2.60.40.10:FF:000978', NULL, NULL, 'coagulation factor XIII A chain', NULL, NULL, NULL, NULL, NULL, 4),
(32358, NULL, 'G3DSA:2.130.10.10:FF:005902', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(32359, NULL, 'G3DSA:3.30.1560.10:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32360, NULL, 'G3DSA:3.30.559.10:FF:000209', NULL, NULL, 'Carnitine O-octanoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(32361, NULL, 'G3DSA:2.60.40.1120:FF:000040', NULL, NULL, 'Carboxypeptidase Z', NULL, NULL, NULL, NULL, NULL, 4),
(32362, NULL, 'G3DSA:1.20.58.60:FF:000818', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32363, NULL, 'G3DSA:3.60.21.10:FF:000432', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32364, NULL, 'G3DSA:3.40.50.300:FF:000344', NULL, NULL, 'Ras-related protein Rab-14', NULL, NULL, NULL, NULL, NULL, 4),
(32365, NULL, 'G3DSA:1.10.540.10:FF:000111', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(32366, NULL, 'G3DSA:3.40.30.10:FF:001246', NULL, NULL, 'Putative protein disulfide-isomerase C1F5.02', NULL, NULL, NULL, NULL, NULL, 4),
(32367, NULL, 'G3DSA:3.30.1680.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32368, NULL, 'G3DSA:3.40.190.10:FF:000249', NULL, NULL, 'Amino acid ABC transporter, amino acid-binding protein/permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(32369, NULL, 'G3DSA:2.30.30.670:FF:000001', NULL, NULL, 'Fibronectin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(32370, NULL, 'G3DSA:3.40.50.720:FF:002184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32371, NULL, 'G3DSA:3.30.70.330:FF:003012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32372, NULL, 'G3DSA:3.40.50.200:FF:000140', NULL, NULL, 'Probable subtilase-type serine protease DR_A0283', NULL, NULL, NULL, NULL, NULL, 4),
(32373, NULL, 'G3DSA:3.40.630.10:FF:000441', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32374, NULL, 'G3DSA:2.60.40.150:FF:000599', NULL, NULL, 'Neural precursor cell expressed, developmentally down-regulated 4, E3 ubiquitin protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(32375, NULL, 'G3DSA:2.60.40.10:FF:003092', NULL, NULL, 'Protein-tyrosine-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(32376, NULL, 'G3DSA:1.20.1280.20:FF:000006', NULL, NULL, 'DnaJ domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(32377, NULL, 'G3DSA:1.20.5.170:FF:000159', NULL, NULL, 'Serologically defined colon cancer antigen', NULL, NULL, NULL, NULL, NULL, 4),
(32378, NULL, 'G3DSA:3.40.50.300:FF:004559', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(32379, NULL, 'G3DSA:3.30.2130.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32380, NULL, 'G3DSA:1.10.3820.10:FF:000003', NULL, NULL, 'Cytochrome c-type protein', NULL, NULL, NULL, NULL, NULL, 4),
(32381, NULL, 'G3DSA:1.20.58.60:FF:000869', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32382, NULL, 'G3DSA:3.10.20.710:FF:000001', NULL, NULL, 'DNA-binding protein SATB', NULL, NULL, NULL, NULL, NULL, 4),
(32383, NULL, 'G3DSA:1.20.58.60:FF:000133', NULL, NULL, 'nesprin-2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(32384, NULL, 'G3DSA:3.30.1480.10:FF:000003', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(32385, NULL, 'G3DSA:3.40.1350.10:FF:000008', NULL, NULL, 'tRNA-splicing endonuclease subunit Sen34', NULL, NULL, NULL, NULL, NULL, 4),
(32386, NULL, 'G3DSA:2.60.120.380:FF:000076', NULL, NULL, 'Calpain-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(32387, NULL, 'G3DSA:1.10.10.60:FF:000771', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32388, NULL, 'G3DSA:3.40.47.10:FF:000048', NULL, NULL, '3-oxoacyl-Acyl-carrier-protein synthase III', NULL, NULL, NULL, NULL, NULL, 4),
(32389, NULL, 'G3DSA:3.30.500.10:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32390, NULL, 'G3DSA:3.30.9.10:FF:000247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32391, NULL, 'G3DSA:3.40.50.1000:FF:000261', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(32392, NULL, 'G3DSA:3.40.50.150:FF:001619', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32393, NULL, 'G3DSA:3.30.420.10:FF:000045', NULL, NULL, '3''-5'' exonuclease DinG', NULL, NULL, NULL, NULL, NULL, 4),
(32394, NULL, 'G3DSA:3.40.630.30:FF:000503', NULL, NULL, 'Spore associated protein, sapd', NULL, NULL, NULL, NULL, NULL, 4),
(32395, NULL, 'G3DSA:1.10.472.80:FF:000102', NULL, NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', NULL, NULL, NULL, NULL, NULL, 4),
(32396, NULL, 'G3DSA:1.25.40.20:FF:000795', NULL, NULL, 'Lethal (2) 35Be', NULL, NULL, NULL, NULL, NULL, 4),
(32397, NULL, 'G3DSA:3.40.1050.10:FF:000019', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(32398, NULL, 'G3DSA:1.10.260.170:FF:000011', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', NULL, NULL, NULL, NULL, NULL, 4),
(32399, NULL, 'G3DSA:3.20.20.80:FF:000098', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(32400, NULL, 'G3DSA:1.10.3080.10:FF:000030', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(32401, NULL, 'G3DSA:2.130.10.10:FF:002176', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(32402, NULL, 'G3DSA:1.25.40.10:FF:002023', NULL, NULL, 'Os01g0913400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(32403, NULL, 'G3DSA:3.40.50.1220:FF:000040', NULL, NULL, '3D-(3,5/4)-trihydroxycyclohexane-1,2-dione hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(32404, NULL, 'G3DSA:3.40.50.720:FF:002077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32405, NULL, 'G3DSA:1.10.472.10:FF:000413', NULL, NULL, 'Cyclin domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(32406, NULL, 'G3DSA:3.30.70.330:FF:002551', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32407, NULL, 'G3DSA:2.60.40.10:FF:000074', NULL, NULL, 'Recombining binding protein suppressor of hairless, putative', NULL, NULL, NULL, NULL, NULL, 4),
(32408, NULL, 'G3DSA:3.60.10.10:FF:000232', NULL, NULL, 'Inositol 5-phosphatase 4', NULL, NULL, NULL, NULL, NULL, 4),
(32409, NULL, 'G3DSA:1.10.3520.10:FF:000014', NULL, NULL, 'Putative Glycolipid transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(32410, NULL, 'G3DSA:1.10.540.10:FF:000055', NULL, NULL, 'FMNH2-dependent monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(32411, NULL, 'G3DSA:1.25.10.10:FF:000341', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(32412, NULL, 'G3DSA:3.30.540.10:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32413, NULL, 'G3DSA:3.40.605.10:FF:000080', NULL, NULL, 'CoA-acylating methylmalonate-semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(32414, NULL, 'G3DSA:1.10.10.10:FF:000166', NULL, NULL, '40S ribosomal protein S25', NULL, NULL, NULL, NULL, NULL, 4),
(32415, NULL, 'G3DSA:3.40.50.300:FF:006072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32416, NULL, 'G3DSA:1.50.40.10:FF:000374', NULL, NULL, 'Mitochondrial folate carrier protein Flx1', NULL, NULL, NULL, NULL, NULL, 4),
(32417, NULL, 'G3DSA:2.160.20.10:FF:000129', NULL, NULL, 'GD20755', NULL, NULL, NULL, NULL, NULL, 4),
(32418, NULL, 'G3DSA:2.130.10.10:FF:004997', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32419, NULL, 'G3DSA:2.60.120.260:FF:000557', NULL, NULL, 'Putative secreted beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(32420, NULL, 'G3DSA:1.20.1410.10:FF:000003', NULL, NULL, 'Transmembrane protein 98', NULL, NULL, NULL, NULL, NULL, 4),
(32421, NULL, 'G3DSA:2.30.110.10:FF:000060', NULL, NULL, 'PPOX class F420-dependent enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(32422, NULL, 'G3DSA:1.20.120.350:FF:000032', NULL, NULL, 'Sodium leak channel non-selective protein', NULL, NULL, NULL, NULL, NULL, 4),
(32423, NULL, 'G3DSA:3.90.190.10:FF:000570', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32424, NULL, 'G3DSA:3.30.310.130:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(32425, NULL, 'G3DSA:3.30.200.40:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32426, NULL, 'G3DSA:1.25.40.10:FF:004440', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32427, NULL, 'G3DSA:3.40.50.1240:FF:000102', NULL, NULL, 'PE-PGRS family protein PE_PGRS11', NULL, NULL, NULL, NULL, NULL, 4),
(32428, NULL, 'G3DSA:1.10.287.10:FF:000050', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(32429, NULL, 'G3DSA:3.40.50.300:FF:003250', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(32430, NULL, 'G3DSA:1.10.238.10:FF:000206', NULL, NULL, 'Calcium dependent mitochondrial carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(32431, NULL, 'G3DSA:3.10.310.10:FF:000053', NULL, NULL, 'Diaminopimelate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(32432, NULL, 'G3DSA:1.10.10.10:FF:001526', NULL, NULL, 'Cullin 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(32433, NULL, 'G3DSA:3.10.20.230:FF:000008', NULL, NULL, 'retinitis pigmentosa 1-like 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(32434, NULL, 'G3DSA:2.60.120.590:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32435, NULL, 'G3DSA:3.40.50.1220:FF:000091', NULL, NULL, 'Branched-chain alpha-ketoacid decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(32436, NULL, 'G3DSA:1.10.1040.10:FF:000061', NULL, NULL, '3-hydroxyacyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(32437, NULL, 'G3DSA:3.90.70.10:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32438, NULL, 'G3DSA:2.130.10.10:FF:003429', NULL, NULL, 'YALI0E33774p', NULL, NULL, NULL, NULL, NULL, 4),
(32439, NULL, 'G3DSA:1.20.1250.20:FF:000274', NULL, NULL, 'Solute carrier family 43 member 1', NULL, NULL, NULL, NULL, NULL, 4),
(32440, NULL, 'G3DSA:1.10.533.10:FF:000090', NULL, NULL, 'Caspase recruitment domain family member 8', NULL, NULL, NULL, NULL, NULL, 4),
(32441, NULL, 'G3DSA:2.60.120.10:FF:000019', NULL, NULL, 'rap guanine nucleotide exchange factor 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(32442, NULL, 'G3DSA:1.10.1420.10:FF:000051', NULL, NULL, 'Msh4p', NULL, NULL, NULL, NULL, NULL, 4),
(32443, NULL, 'G3DSA:1.10.472.10:FF:000357', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32444, NULL, 'G3DSA:3.40.630.30:FF:000447', NULL, NULL, 'Orf14', NULL, NULL, NULL, NULL, NULL, 4),
(32445, NULL, 'G3DSA:2.30.29.30:FF:000077', NULL, NULL, 'Arf-GAP with GTPase, ANK repeat and PH domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(32446, NULL, 'G3DSA:3.30.470.20:FF:000164', NULL, NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(32447, NULL, 'G3DSA:3.30.160.60:FF:003485', NULL, NULL, 'Zgc:174574', NULL, NULL, NULL, NULL, NULL, 4),
(32448, NULL, 'G3DSA:3.30.40.10:FF:001320', NULL, NULL, 'Zinc finger domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(32449, NULL, 'G3DSA:3.40.1310.20:FF:000003', NULL, NULL, 'Rep protein', NULL, NULL, NULL, NULL, NULL, 4),
(32450, NULL, 'G3DSA:2.40.50.150:FF:000010', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(32451, NULL, 'G3DSA:2.40.128.20:FF:000016', NULL, NULL, 'Metal-binding protein ZinT', NULL, NULL, NULL, NULL, NULL, 4),
(32452, NULL, 'G3DSA:2.30.42.10:FF:000652', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32453, NULL, 'G3DSA:3.20.20.70:FF:000325', NULL, NULL, 'Radical SAM domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(32454, NULL, 'G3DSA:3.40.50.200:FF:000084', NULL, NULL, 'Serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(32455, NULL, 'G3DSA:3.80.10.10:FF:000861', NULL, NULL, 'Disease resistance protein (CC-NBS-LRR class) family', NULL, NULL, NULL, NULL, NULL, 4),
(32456, NULL, 'G3DSA:3.90.150.10:FF:000005', NULL, NULL, 'Variant surface glycoprotein (VSG), putative', NULL, NULL, NULL, NULL, NULL, 4),
(32457, NULL, 'G3DSA:2.120.10.30:FF:000018', NULL, NULL, 'Low-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(32458, NULL, 'G3DSA:3.90.230.10:FF:000006', NULL, NULL, 'Xaa-Pro dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(32459, NULL, 'G3DSA:3.40.630.30:FF:000559', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32460, NULL, 'G3DSA:3.30.70.330:FF:000078', NULL, NULL, 'serine/arginine-rich splicing factor 7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(32461, NULL, 'G3DSA:3.30.160.60:FF:003373', NULL, NULL, 'Zinc finger protein 296', NULL, NULL, NULL, NULL, NULL, 4),
(32462, NULL, 'G3DSA:3.30.70.1350:FF:000025', NULL, NULL, 'Cation-efflux pump FieF protein', NULL, NULL, NULL, NULL, NULL, 4),
(32463, NULL, 'G3DSA:3.30.230.10:FF:000289', NULL, NULL, 'MutL DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(32464, NULL, 'G3DSA:3.10.20.90:FF:000416', NULL, NULL, 'UBX domain protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(32465, NULL, 'G3DSA:1.10.1520.10:FF:000047', NULL, NULL, 'RNase III, putative', NULL, NULL, NULL, NULL, NULL, 4),
(32466, NULL, 'G3DSA:2.60.120.970:FF:000039', NULL, NULL, 'Protein screw', NULL, NULL, NULL, NULL, NULL, 4),
(32467, NULL, 'G3DSA:3.10.20.90:FF:000528', NULL, NULL, 'Auxin-responsive protein', NULL, NULL, NULL, NULL, NULL, 4),
(32468, NULL, 'G3DSA:3.60.10.10:FF:000176', NULL, NULL, 'Protein angel homolog 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(32469, NULL, 'G3DSA:3.90.70.10:FF:000257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32470, NULL, 'G3DSA:3.10.150.10:FF:000006', NULL, NULL, 'Proliferating cell nuclear antigen', NULL, NULL, NULL, NULL, NULL, 4),
(32471, NULL, 'G3DSA:2.60.120.260:FF:000506', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32472, NULL, 'G3DSA:3.30.2020.30:FF:000032', NULL, NULL, 'Trimethyllysine dioxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(32473, NULL, 'G3DSA:3.40.50.2300:FF:000780', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32474, NULL, 'G3DSA:2.60.420.10:FF:000008', NULL, NULL, 'Cellobionic acid phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(32475, NULL, 'G3DSA:2.60.120.10:FF:000082', NULL, NULL, 'Mannose-6-phosphate isomerase, class I', NULL, NULL, NULL, NULL, NULL, 4),
(32476, NULL, 'G3DSA:4.10.280.50:FF:000001', NULL, NULL, 'Glutamate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(32477, NULL, 'G3DSA:1.20.1330.10:FF:000002', NULL, NULL, 'Flagellin', NULL, NULL, NULL, NULL, NULL, 4),
(32478, NULL, 'G3DSA:2.10.25.10:FF:001485', NULL, NULL, 'Cadherin, EGF LAG seven-pass G-type receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(32479, NULL, 'G3DSA:4.10.240.10:FF:000178', NULL, NULL, 'Zcf32p', NULL, NULL, NULL, NULL, NULL, 4),
(32480, NULL, 'G3DSA:2.60.40.3510:FF:000009', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(32481, NULL, 'G3DSA:3.55.40.20:FF:000019', NULL, NULL, 'Superoxide dismutase [Fe]', NULL, NULL, NULL, NULL, NULL, 4),
(32482, NULL, 'G3DSA:2.60.40.10:FF:003833', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32483, NULL, 'G3DSA:2.30.130.10:FF:000004', NULL, NULL, 'tRNA pseudouridine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(32484, NULL, 'G3DSA:1.20.58.60:FF:000077', NULL, NULL, 'dystonin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(32485, NULL, 'G3DSA:3.30.260.10:FF:000066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32486, NULL, 'G3DSA:3.80.10.10:FF:002311', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32487, NULL, 'G3DSA:3.40.50.10580:FF:000008', NULL, NULL, 'V-type ATP synthase subunit F', NULL, NULL, NULL, NULL, NULL, 4),
(32488, NULL, 'G3DSA:2.60.120.290:FF:000049', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(32489, NULL, 'G3DSA:3.90.1150.10:FF:000448', NULL, NULL, 'Kynureninase', NULL, NULL, NULL, NULL, NULL, 4),
(32490, NULL, 'G3DSA:3.90.550.10:FF:000502', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(32491, NULL, 'G3DSA:3.30.160.60:FF:003434', NULL, NULL, 'Zinc finger protein 206', NULL, NULL, NULL, NULL, NULL, 4),
(32492, NULL, 'G3DSA:3.40.50.300:FF:006009', NULL, NULL, 'UVRD/Rep like helicase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(32493, NULL, 'G3DSA:3.30.160.60:FF:000523', NULL, NULL, 'Zinc finger protein WIP2', NULL, NULL, NULL, NULL, NULL, 4),
(32494, NULL, 'G3DSA:2.40.128.80:FF:000006', NULL, NULL, 'Cathepsin C', NULL, NULL, NULL, NULL, NULL, 4),
(32495, NULL, 'G3DSA:2.60.120.590:FF:000021', NULL, NULL, '2OG-Fe(II) oxygenase superfamily, putative', NULL, NULL, NULL, NULL, NULL, 4),
(32496, NULL, 'G3DSA:2.20.25.10:FF:000091', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(32497, NULL, 'G3DSA:3.30.470.20:FF:000113', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(32498, NULL, 'G3DSA:2.40.50.140:FF:000524', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(32499, NULL, 'G3DSA:1.10.20.10:FF:000043', NULL, NULL, 'Histone H2B', NULL, NULL, NULL, NULL, NULL, 4),
(32500, NULL, 'G3DSA:1.20.272.10:FF:000031', NULL, NULL, 'replication factor C subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(32501, NULL, 'G3DSA:1.25.10.10:FF:002139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32502, NULL, 'G3DSA:3.40.630.30:FF:000508', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(32503, NULL, 'G3DSA:1.20.120.140:FF:000031', NULL, NULL, 'Cell division protein FtsY homolog chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(32504, NULL, 'G3DSA:3.40.50.150:FF:000203', NULL, NULL, 'Alkylated DNA repair protein alkB 8', NULL, NULL, NULL, NULL, NULL, 4),
(32505, NULL, 'G3DSA:1.20.120.160:FF:000037', NULL, NULL, 'Histidine-containing phosphotransfer protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(32506, NULL, 'G3DSA:1.10.287.70:FF:000332', NULL, NULL, 'TWiK family of potassium channels protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(32507, NULL, 'G3DSA:3.20.90.10:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32508, NULL, 'G3DSA:3.30.50.10:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32509, NULL, 'G3DSA:1.10.472.10:FF:000301', NULL, NULL, 'Cyclin G-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(32510, NULL, 'G3DSA:2.40.128.20:FF:000067', NULL, NULL, 'Api5 protein', NULL, NULL, NULL, NULL, NULL, 4),
(32511, NULL, 'G3DSA:3.40.190.10:FF:000305', NULL, NULL, 'D-methionine-binding lipoprotein MetQ', NULL, NULL, NULL, NULL, NULL, 4),
(32512, NULL, 'G3DSA:3.40.532.10:FF:000011', NULL, NULL, 'Deubiquinating/deneddylating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(32513, NULL, 'G3DSA:3.40.1230.10:FF:000005', NULL, NULL, 'NADH dehydrogenase [ubiquinone]alpha subcomplex assembly factor', NULL, NULL, NULL, NULL, NULL, 4),
(32514, NULL, 'G3DSA:1.10.150.80:FF:000012', NULL, NULL, 'Exosome complex exonuclease RRP6', NULL, NULL, NULL, NULL, NULL, 4),
(32515, NULL, 'G3DSA:1.10.510.10:FF:000306', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(32516, NULL, 'G3DSA:2.40.30.10:FF:000175', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(32517, NULL, 'G3DSA:1.25.60.10:FF:000001', NULL, NULL, 'Magnesium transporter MgtE', NULL, NULL, NULL, NULL, NULL, 4),
(32518, NULL, 'G3DSA:3.30.160.60:FF:001809', NULL, NULL, 'dnaJ homolog subfamily C member 21 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(32519, NULL, 'G3DSA:3.30.420.10:FF:000068', NULL, NULL, 'Exonuclease domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(32520, NULL, 'G3DSA:2.40.50.90:FF:000104', NULL, NULL, 'Tudor domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(32521, NULL, 'G3DSA:3.60.21.10:FF:000488', NULL, NULL, 'Protein CBG23770', NULL, NULL, NULL, NULL, NULL, 4),
(32522, NULL, 'G3DSA:2.30.29.30:FF:000526', NULL, NULL, 'Rho GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(32523, NULL, 'G3DSA:3.30.70.330:FF:002899', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32524, NULL, 'G3DSA:3.30.230.80:FF:000001', NULL, NULL, 'Heat shock protein 90 alpha', NULL, NULL, NULL, NULL, NULL, 4),
(32525, NULL, 'G3DSA:1.20.120.1630:FF:000035', NULL, NULL, '3-oxo-5-alpha-steroid 4-dehydrogenase family protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(32526, NULL, 'G3DSA:3.30.1370.10:FF:000169', NULL, NULL, 'Protein CBR-NUO-2', NULL, NULL, NULL, NULL, NULL, 4),
(32527, NULL, 'G3DSA:1.10.238.10:FF:001218', NULL, NULL, 'Putative calmodulin', NULL, NULL, NULL, NULL, NULL, 4),
(32528, NULL, 'G3DSA:3.40.50.1000:FF:000266', NULL, NULL, 'PROBABLE PHOSPHATASE', NULL, NULL, NULL, NULL, NULL, 4),
(32529, NULL, 'G3DSA:3.30.260.10:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32530, NULL, 'G3DSA:1.10.8.60:FF:000005', NULL, NULL, '26S protease regulatory subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(32531, NULL, 'G3DSA:2.60.120.10:FF:000531', NULL, NULL, 'MBL fold metallo-hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(32532, NULL, 'G3DSA:3.40.50.10140:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32533, NULL, 'G3DSA:3.40.50.620:FF:000248', NULL, NULL, 'Nicotinate (Nicotinamide) nucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(32534, NULL, 'G3DSA:3.30.200.20:FF:001139', NULL, NULL, 'Protein kinase-like', NULL, NULL, NULL, NULL, NULL, 4),
(32535, NULL, 'G3DSA:3.90.226.10:FF:000176', NULL, NULL, 'Glycine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(32536, NULL, 'G3DSA:3.30.70.330:FF:002955', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32537, NULL, 'G3DSA:1.25.10.10:FF:000689', NULL, NULL, 'HECT ubiquitin protein ligase family protein KAK', NULL, NULL, NULL, NULL, NULL, 4),
(32538, NULL, 'G3DSA:1.20.1250.20:FF:001527', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32539, NULL, 'G3DSA:1.25.40.20:FF:001284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32540, NULL, 'G3DSA:1.10.10.60:FF:001108', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32541, NULL, 'G3DSA:2.30.29.30:FF:000818', NULL, NULL, 'Ankyrin repeat-containing protein kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(32542, NULL, 'G3DSA:3.90.226.10:FF:000232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32543, NULL, 'G3DSA:3.30.160.60:FF:001012', NULL, NULL, 'Zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(32544, NULL, 'G3DSA:3.30.200.20:FF:001870', NULL, NULL, 'Serine/threonine-protein kinase RIO3', NULL, NULL, NULL, NULL, NULL, 4),
(32545, NULL, 'G3DSA:2.20.28.10:FF:000018', NULL, NULL, 'Rubrerythrin', NULL, NULL, NULL, NULL, NULL, 4),
(32546, NULL, 'G3DSA:2.60.40.3960:FF:000003', NULL, NULL, 'VeA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(32547, NULL, 'G3DSA:3.30.200.40:FF:000004', NULL, NULL, 'mRNA decapping hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(32548, NULL, 'G3DSA:3.60.21.60:FF:000019', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(32549, NULL, 'G3DSA:1.25.40.10:FF:003080', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(32550, NULL, 'G3DSA:2.40.10.10:FF:000409', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32551, NULL, 'G3DSA:3.40.50.2020:FF:000004', NULL, NULL, 'Adenine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(32552, NULL, 'G3DSA:4.10.410.10:FF:000006', NULL, NULL, 'Serine peptidase inhibitor, Kunitz type 1', NULL, NULL, NULL, NULL, NULL, 4),
(32553, NULL, 'G3DSA:3.40.50.261:FF:000001', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(32554, NULL, 'G3DSA:2.60.120.10:FF:000823', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32555, NULL, 'G3DSA:3.90.80.10:FF:000027', NULL, NULL, 'Inorganic pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(32556, NULL, 'G3DSA:3.40.50.300:FF:002979', NULL, NULL, 'Chromosome 16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(32557, NULL, 'G3DSA:1.10.630.10:FF:000793', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32558, NULL, 'G3DSA:2.130.10.10:FF:001743', NULL, NULL, 'Protein RIC1 like', NULL, NULL, NULL, NULL, NULL, 4),
(32559, NULL, 'G3DSA:2.130.10.10:FF:005054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(32560, NULL, 'G3DSA:1.25.10.10:FF:001690', NULL, NULL, 'Nucleotide exchange factor SIL1', NULL, NULL, NULL, NULL, NULL, 4),
(32561, NULL, 'G3DSA:3.40.1190.10:FF:000024', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(32562, NULL, 'G3DSA:3.90.70.10:FF:000201', NULL, NULL, 'Unplaced genomic scaffold supercont1.208, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(32563, NULL, 'G3DSA:1.10.150.20:FF:000028', NULL, NULL, 'activating signal cointegrator 1 complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(32564, NULL, 'G3DSA:3.30.70.1730:FF:000055', NULL, NULL, 'mRNA turnover protein 4 mrt4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(32565, NULL, 'G3DSA:1.20.810.10:FF:000001', NULL, NULL, 'Cytochrome b6', NULL, NULL, NULL, NULL, NULL, 4),
(32566, NULL, 'G3DSA:3.90.1750.20:FF:000002', NULL, NULL, 'Putative integrase [Bacteriophage A118]', NULL, NULL, NULL, NULL, NULL, 4),
(32567, NULL, 'G3DSA:3.30.1390.30:FF:000002', NULL, NULL, 'Penicillin-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(32568, NULL, 'G3DSA:3.40.33.10:FF:000106', NULL, NULL, 'GM23776', NULL, NULL, NULL, NULL, NULL, 4),
(32569, NULL, 'G3DSA:1.20.272.10:FF:000087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32570, NULL, 'G3DSA:1.10.10.10:FF:000110', NULL, NULL, 'DNA-binding response regulator RegX3', NULL, NULL, NULL, NULL, NULL, 4),
(32571, NULL, 'G3DSA:1.25.10.10:FF:000397', NULL, NULL, 'sterile alpha and TIR motif-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(32572, NULL, 'G3DSA:3.40.50.300:FF:003255', NULL, NULL, 'Pilus assembly protein CpaE', NULL, NULL, NULL, NULL, NULL, 4),
(32573, NULL, 'G3DSA:3.90.15.10:FF:000017', NULL, NULL, 'Protease Do-like 2 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(32574, NULL, 'G3DSA:2.10.110.10:FF:000159', NULL, NULL, 'Lrg1p', NULL, NULL, NULL, NULL, NULL, 4),
(32575, NULL, 'G3DSA:3.30.110.20:FF:000019', NULL, NULL, 'Ribonuclease P/MRP protein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(32576, NULL, 'G3DSA:1.25.40.10:FF:001478', NULL, NULL, 'Os01g0263600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(32577, NULL, 'G3DSA:1.20.5.110:FF:000225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32578, NULL, 'G3DSA:2.40.30.10:FF:000231', NULL, NULL, '(methionine synthase) reductase', NULL, NULL, NULL, NULL, NULL, 4),
(32579, NULL, 'G3DSA:2.30.29.70:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32580, NULL, 'G3DSA:2.40.10.240:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32581, NULL, 'G3DSA:2.60.40.1180:FF:000012', NULL, NULL, '4F2 cell-surface antigen heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(32582, NULL, 'G3DSA:1.20.1250.20:FF:001634', NULL, NULL, 'Sucrose transport protein SUC4', NULL, NULL, NULL, NULL, NULL, 4),
(32583, NULL, 'G3DSA:2.30.42.10:FF:000096', NULL, NULL, 'PDZ domain-containing protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(32584, NULL, 'G3DSA:3.30.160.60:FF:005290', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32585, NULL, 'G3DSA:3.60.21.10:FF:000437', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32586, NULL, 'G3DSA:1.10.3090.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32587, NULL, 'G3DSA:3.20.20.80:FF:000603', NULL, NULL, 'Heparanase-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(32588, NULL, 'G3DSA:3.30.260.10:FF:000010', NULL, NULL, 'T-complex protein 1 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(32589, NULL, 'G3DSA:3.30.420.40:FF:001009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32590, NULL, 'G3DSA:1.10.238.10:FF:001263', NULL, NULL, 'Phosphatidylserine decarboxylase proenzyme 3', NULL, NULL, NULL, NULL, NULL, 4),
(32591, NULL, 'G3DSA:3.40.630.10:FF:000497', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32592, NULL, 'G3DSA:1.20.1270.60:FF:000057', NULL, NULL, 'Rho guanine nucleotide exchange factor 37', NULL, NULL, NULL, NULL, NULL, 4),
(32593, NULL, 'G3DSA:3.10.450.40:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(32594, NULL, 'G3DSA:2.170.270.10:FF:000032', NULL, NULL, 'PR domain containing 14', NULL, NULL, NULL, NULL, NULL, 4),
(32595, NULL, 'G3DSA:3.40.50.720:FF:000508', NULL, NULL, 'UDP-glucose 4-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(32596, NULL, 'G3DSA:2.10.25.10:FF:001541', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(32597, NULL, 'G3DSA:3.40.50.150:FF:000315', NULL, NULL, 'Methyltransferase protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(32598, NULL, 'G3DSA:3.30.300.180:FF:000007', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(32599, NULL, 'G3DSA:3.30.110.110:FF:000011', NULL, NULL, 'Double-strand break repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(32600, NULL, 'G3DSA:1.25.10.10:FF:000402', NULL, NULL, 'Related to importin beta-2 subunit (Transportin)', NULL, NULL, NULL, NULL, NULL, 4),
(32601, NULL, 'G3DSA:2.60.40.150:FF:000251', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(32602, NULL, 'G3DSA:2.60.40.10:FF:005357', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32603, NULL, 'G3DSA:2.40.10.10:FF:000180', NULL, NULL, 'IP09419p', NULL, NULL, NULL, NULL, NULL, 4),
(32604, NULL, 'G3DSA:3.40.850.10:FF:000328', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(32605, NULL, 'G3DSA:3.15.10.10:FF:000022', NULL, NULL, 'Phospholipid transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(32606, NULL, 'G3DSA:3.40.1110.10:FF:000137', NULL, NULL, 'Heavy metal translocatin', NULL, NULL, NULL, NULL, NULL, 4),
(32607, NULL, 'G3DSA:2.90.10.10:FF:000031', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase LECRK1', NULL, NULL, NULL, NULL, NULL, 4),
(32608, NULL, 'G3DSA:3.20.20.450:FF:000016', NULL, NULL, 'Bifunctional diguanylate cyclase/phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(32609, NULL, 'G3DSA:1.20.272.10:FF:000036', NULL, NULL, 'replication factor C familiy protein', NULL, NULL, NULL, NULL, NULL, 4),
(32610, NULL, 'G3DSA:2.60.120.290:FF:000105', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(32611, NULL, 'G3DSA:1.20.1160.20:FF:000008', NULL, NULL, 'whirlin isoform X8', NULL, NULL, NULL, NULL, NULL, 4),
(32612, NULL, 'G3DSA:3.30.310.80:FF:000035', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(32613, NULL, 'G3DSA:3.40.50.300:FF:005048', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(32614, NULL, 'G3DSA:3.40.50.1820:FF:000629', NULL, NULL, 'WGS project CABT00000000 data, contig 2.92', NULL, NULL, NULL, NULL, NULL, 4),
(32615, NULL, 'G3DSA:2.130.10.10:FF:000782', NULL, NULL, 'Autophagy-related protein 18h', NULL, NULL, NULL, NULL, NULL, 4),
(32616, NULL, 'G3DSA:2.130.10.10:FF:004093', NULL, NULL, 'Protein HIRA', NULL, NULL, NULL, NULL, NULL, 4),
(32617, NULL, 'G3DSA:3.80.10.10:FF:001799', NULL, NULL, 'DNA-damage repair/toleration 100', NULL, NULL, NULL, NULL, NULL, 4),
(32618, NULL, 'G3DSA:1.20.1250.20:FF:001235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32619, NULL, 'G3DSA:2.30.30.140:FF:000073', NULL, NULL, 'ATP-dependent RNA helicase TDRD9', NULL, NULL, NULL, NULL, NULL, 4),
(32620, NULL, 'G3DSA:2.40.50.140:FF:000529', NULL, NULL, 'Cell division control protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(32621, NULL, 'G3DSA:3.30.300.160:FF:000001', NULL, NULL, 'Bacteriophage N4 adsorption protein B', NULL, NULL, NULL, NULL, NULL, 4),
(32622, NULL, 'G3DSA:1.10.418.10:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32623, NULL, 'G3DSA:3.50.50.60:FF:000368', NULL, NULL, 'Probable flavin-containing monoamine oxidase aofH', NULL, NULL, NULL, NULL, NULL, 4),
(32624, NULL, 'G3DSA:3.30.1120.90:FF:000006', NULL, NULL, 'Nucleosome assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(32625, NULL, 'G3DSA:3.30.420.610:FF:000017', NULL, NULL, 'Tudor domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(32626, NULL, 'G3DSA:2.30.29.30:FF:000133', NULL, NULL, 'myosin phosphatase Rho-interacting protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(32627, NULL, 'G3DSA:3.30.160.60:FF:005851', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32628, NULL, 'G3DSA:3.40.50.300:FF:003199', NULL, NULL, 'ATPase family associated with various cellular activities (AAA), putative', NULL, NULL, NULL, NULL, NULL, 4),
(32629, NULL, 'G3DSA:2.10.25.10:FF:000973', NULL, NULL, 'Transmembrane cell adhesion receptor mua-3', NULL, NULL, NULL, NULL, NULL, 4),
(32630, NULL, 'G3DSA:2.60.40.60:FF:001061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32631, NULL, 'G3DSA:1.10.510.10:FF:002200', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(32632, NULL, 'G3DSA:3.40.50.2020:FF:000055', NULL, NULL, 'Ribose-phosphate pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(32633, NULL, 'G3DSA:2.130.10.10:FF:000490', NULL, NULL, 'Kinesin family member 21B', NULL, NULL, NULL, NULL, NULL, 4),
(32634, NULL, 'G3DSA:2.30.29.30:FF:000869', NULL, NULL, 'Bud site selection protein 4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(32635, NULL, 'G3DSA:3.30.1680.10:FF:000002', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(32636, NULL, 'G3DSA:1.50.40.10:FF:000430', NULL, NULL, 'Mitoferrin-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(32637, NULL, 'G3DSA:1.25.40.10:FF:001534', NULL, NULL, 'Os01g0913400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(32638, NULL, 'G3DSA:1.10.10.60:FF:001260', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32639, NULL, 'G3DSA:3.70.10.10:FF:000035', NULL, NULL, 'Cell cycle checkpoint control protein', NULL, NULL, NULL, NULL, NULL, 4),
(32640, NULL, 'G3DSA:2.40.40.20:FF:000066', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(32641, NULL, 'G3DSA:1.20.120.350:FF:000268', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32642, NULL, 'G3DSA:2.130.10.10:FF:005161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32643, NULL, 'G3DSA:2.30.30.40:FF:000600', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32644, NULL, 'G3DSA:3.40.33.10:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32645, NULL, 'G3DSA:3.10.110.10:FF:000009', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 R2', NULL, NULL, NULL, NULL, NULL, 4),
(32646, NULL, 'G3DSA:2.30.29.170:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32647, NULL, 'G3DSA:3.80.10.10:FF:001243', NULL, NULL, 'Si:dkey-286j17.4', NULL, NULL, NULL, NULL, NULL, 4),
(32648, NULL, 'G3DSA:3.30.160.60:FF:003777', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32649, NULL, 'G3DSA:1.25.40.10:FF:005188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32650, NULL, 'G3DSA:3.40.50.300:FF:005560', NULL, NULL, 'Snf2 family helicase', NULL, NULL, NULL, NULL, NULL, 4),
(32651, NULL, 'G3DSA:3.90.230.10:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32652, NULL, 'G3DSA:2.60.120.260:FF:000613', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32653, NULL, 'G3DSA:3.90.640.90:FF:000010', NULL, NULL, 'BTG family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(32654, NULL, 'G3DSA:4.10.400.10:FF:000129', NULL, NULL, 'Complement factor I', NULL, NULL, NULL, NULL, NULL, 4),
(32655, NULL, 'G3DSA:1.25.40.10:FF:002708', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(32656, NULL, 'G3DSA:3.20.20.150:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32657, NULL, 'G3DSA:1.10.510.10:FF:001762', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(32658, NULL, 'G3DSA:3.80.10.10:FF:003216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32659, NULL, 'G3DSA:3.30.1640.10:FF:000005', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(32660, NULL, 'G3DSA:2.10.25.10:FF:000181', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(32661, NULL, 'G3DSA:2.60.120.680:FF:000003', NULL, NULL, 'SEC14-like lipid binding 1', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(32662, NULL, 'G3DSA:3.40.1370.10:FF:000010', NULL, NULL, '50S ribosomal protein L4', NULL, NULL, NULL, NULL, NULL, 4),
(32663, NULL, 'G3DSA:2.60.300.12:FF:000019', NULL, NULL, 'Iron-sulfur assembly protein 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(32664, NULL, 'G3DSA:3.20.20.80:FF:000042', NULL, NULL, 'Klotho', NULL, NULL, NULL, NULL, NULL, 4),
(32665, NULL, 'G3DSA:1.10.10.10:FF:000722', NULL, NULL, 'Topoisomerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(32666, NULL, 'G3DSA:1.10.418.10:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32667, NULL, 'G3DSA:1.10.287.70:FF:000276', NULL, NULL, 'Ion transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(32668, NULL, 'G3DSA:1.20.1560.10:FF:000334', NULL, NULL, 'ABC transporter B family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(32669, NULL, 'G3DSA:1.20.5.750:FF:000001', NULL, NULL, 'Moricin', NULL, NULL, NULL, NULL, NULL, 4),
(32670, NULL, 'G3DSA:2.60.40.2030:FF:000037', NULL, NULL, 'Adhesion G protein-coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(32671, NULL, 'G3DSA:1.10.472.80:FF:000176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32672, NULL, 'G3DSA:2.70.170.10:FF:000032', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(32673, NULL, 'G3DSA:2.30.29.30:FF:000925', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(32674, NULL, 'G3DSA:3.30.450.20:FF:000550', NULL, NULL, 'Nitrogen regulation protein ntrY', NULL, NULL, NULL, NULL, NULL, 4),
(32675, NULL, 'G3DSA:4.10.280.10:FF:000124', NULL, NULL, 'transcription factor AP-4 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(32676, NULL, 'G3DSA:3.40.20.10:FF:000172', NULL, NULL, 'Actin-depolymerizing factor 1, isoforms a/b', NULL, NULL, NULL, NULL, NULL, 4),
(32677, NULL, 'G3DSA:3.30.460.10:FF:000065', NULL, NULL, 'DNA polymerase mu', NULL, NULL, NULL, NULL, NULL, 4),
(32678, NULL, 'G3DSA:1.20.5.120:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32679, NULL, 'G3DSA:2.130.10.10:FF:004885', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32680, NULL, 'G3DSA:3.30.710.10:FF:000264', NULL, NULL, 'BTB domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(32681, NULL, 'G3DSA:3.60.20.30:FF:000008', NULL, NULL, 'N-terminal nucleophile aminohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(32682, NULL, 'G3DSA:3.30.70.360:FF:000025', NULL, NULL, 'Peptidase M20', NULL, NULL, NULL, NULL, NULL, 4),
(32683, NULL, 'G3DSA:1.10.8.60:FF:000056', NULL, NULL, 'Katanin p60 ATPase-containing subunit A-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(32684, NULL, 'G3DSA:2.60.40.10:FF:000130', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(32685, NULL, 'G3DSA:3.30.160.60:FF:004738', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32686, NULL, 'G3DSA:1.25.10.10:FF:001706', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32687, NULL, 'G3DSA:1.25.40.170:FF:000003', NULL, NULL, 'Sterile alpha motif domain-containing 4A', NULL, NULL, NULL, NULL, NULL, 4),
(32688, NULL, 'G3DSA:1.10.10.10:FF:000161', NULL, NULL, 'Cullin 1', NULL, NULL, NULL, NULL, NULL, 4),
(32689, NULL, 'G3DSA:3.30.70.330:FF:002556', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32690, NULL, 'G3DSA:1.25.40.190:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32691, NULL, 'G3DSA:3.90.70.10:FF:000549', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32692, NULL, 'G3DSA:1.10.1740.10:FF:000030', NULL, NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(32693, NULL, 'G3DSA:3.10.130.10:FF:000011', NULL, NULL, 'Ribonuclease A family member k6', NULL, NULL, NULL, NULL, NULL, 4),
(32694, NULL, 'G3DSA:3.30.160.60:FF:001517', NULL, NULL, 'zinc finger protein 333 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(32695, NULL, 'G3DSA:1.20.5.110:FF:000276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(32696, NULL, 'G3DSA:3.40.50.300:FF:001518', NULL, NULL, 'Leucine-rich repeat kinase, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(32697, NULL, 'G3DSA:2.40.50.140:FF:001081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32698, NULL, 'G3DSA:2.60.40.10:FF:004401', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32699, NULL, 'G3DSA:3.40.640.10:FF:000503', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32700, NULL, 'G3DSA:1.10.510.10:FF:002251', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32701, NULL, 'G3DSA:3.30.2230.10:FF:000013', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase cyk-3', NULL, NULL, NULL, NULL, NULL, 4),
(32702, NULL, 'G3DSA:1.25.40.20:FF:001756', NULL, NULL, 'Homeobox protein Wariai', NULL, NULL, NULL, NULL, NULL, 4),
(32703, NULL, 'G3DSA:1.20.5.100:FF:000003', NULL, NULL, 'Cytochrome c1, heme protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(32704, NULL, 'G3DSA:1.10.8.60:FF:000528', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(32705, NULL, 'G3DSA:2.130.10.10:FF:001119', NULL, NULL, 'Polyadenylation factor I', NULL, NULL, NULL, NULL, NULL, 4),
(32706, NULL, 'G3DSA:3.90.1150.10:FF:000504', NULL, NULL, 'Serine--pyruvate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(32707, NULL, 'G3DSA:3.30.70.330:FF:000134', NULL, NULL, 'Nuclear and cytoplasmic polyadenylated rna-binding pub1', NULL, NULL, NULL, NULL, NULL, 4),
(32708, NULL, 'G3DSA:1.10.20.10:FF:000335', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32709, NULL, 'G3DSA:3.30.160.60:FF:002316', NULL, NULL, 'Zinc finger protein 114', NULL, NULL, NULL, NULL, NULL, 4),
(32710, NULL, 'G3DSA:1.10.8.10:FF:000070', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(32711, NULL, 'G3DSA:1.25.10.10:FF:000346', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(32712, NULL, 'G3DSA:3.40.50.2000:FF:000734', NULL, NULL, '7-deoxyloganetic acid glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(32713, NULL, 'G3DSA:2.60.120.290:FF:000156', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(32714, NULL, 'G3DSA:3.40.800.20:FF:000042', NULL, NULL, 'Histone deacetylase-like protein HDO2', NULL, NULL, NULL, NULL, NULL, 4),
(32715, NULL, 'G3DSA:3.40.50.2300:FF:001162', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32716, NULL, 'G3DSA:2.10.25.10:FF:000029', NULL, NULL, 'neurexin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(32717, NULL, 'G3DSA:3.30.160.60:FF:001916', NULL, NULL, 'Zinc finger protein 621', NULL, NULL, NULL, NULL, NULL, 4),
(32718, NULL, 'G3DSA:3.30.200.20:FF:001291', NULL, NULL, 'Spore coat protein CotS', NULL, NULL, NULL, NULL, NULL, 4),
(32719, NULL, 'G3DSA:2.40.30.170:FF:000068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32720, NULL, 'G3DSA:3.30.470.20:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32721, NULL, 'G3DSA:2.130.10.10:FF:005846', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32722, NULL, 'G3DSA:2.120.10.80:FF:000168', NULL, NULL, 'Kelch repeat-containing protein At3g27220', NULL, NULL, NULL, NULL, NULL, 4),
(32723, NULL, 'G3DSA:2.60.120.200:FF:000298', NULL, NULL, 'Sialidase', NULL, NULL, NULL, NULL, NULL, 4),
(32724, NULL, 'G3DSA:4.10.1240.10:FF:000023', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(32725, NULL, 'G3DSA:3.40.366.10:FF:000023', NULL, NULL, 'Sterigmatocystin biosynthesis polyketide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(32726, NULL, 'G3DSA:2.130.10.10:FF:005110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32727, NULL, 'G3DSA:3.30.160.60:FF:005227', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32728, NULL, 'G3DSA:1.10.486.10:FF:000063', NULL, NULL, 'UVRD/Rep like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(32729, NULL, 'G3DSA:3.40.50.2300:FF:000673', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(32730, NULL, 'G3DSA:3.40.1110.10:FF:000406', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32731, NULL, 'G3DSA:3.40.50.720:FF:000571', NULL, NULL, 'Hydroxysteroid 17-beta dehydrogenase 11', NULL, NULL, NULL, NULL, NULL, 4),
(32732, NULL, 'G3DSA:1.20.1250.20:FF:001578', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(32733, NULL, 'G3DSA:3.40.570.10:FF:000003', NULL, NULL, 'Nuclease EXOG, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(32734, NULL, 'G3DSA:1.10.510.10:FF:003504', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32735, NULL, 'G3DSA:2.40.128.270:FF:000002', NULL, NULL, 'Heat shock protein HslJ', NULL, NULL, NULL, NULL, NULL, 4),
(32736, NULL, 'G3DSA:2.10.70.10:FF:000044', NULL, NULL, 'Complement component receptor type 1', NULL, NULL, NULL, NULL, NULL, 4),
(32737, NULL, 'G3DSA:3.10.290.10:FF:000056', NULL, NULL, 'Hemolysin (Tly)', NULL, NULL, NULL, NULL, NULL, 4),
(32738, NULL, 'G3DSA:1.20.58.60:FF:000526', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32739, NULL, 'G3DSA:2.60.120.10:FF:000587', NULL, NULL, 'Transcriptional regulator LdrP', NULL, NULL, NULL, NULL, NULL, 4),
(32740, NULL, 'G3DSA:1.20.1250.20:FF:000797', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(32741, NULL, 'G3DSA:3.30.70.660:FF:000053', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(32742, NULL, 'G3DSA:2.60.120.10:FF:000643', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32743, NULL, 'G3DSA:3.40.30.10:FF:000341', NULL, NULL, 'Glutathione S-transferase T1', NULL, NULL, NULL, NULL, NULL, 4),
(32744, NULL, 'G3DSA:1.20.58.1370:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32745, NULL, 'G3DSA:1.10.510.10:FF:003448', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32746, NULL, 'G3DSA:1.10.10.60:FF:000372', NULL, NULL, 'Homeobox B3', NULL, NULL, NULL, NULL, NULL, 4),
(32747, NULL, 'G3DSA:2.30.30.100:FF:000140', NULL, NULL, 'Probable U6 snRNA-associated Sm-like protein LSm4', NULL, NULL, NULL, NULL, NULL, 4),
(32748, NULL, 'G3DSA:3.40.50.720:FF:000239', NULL, NULL, 'monofunctional C1-tetrahydrofolate synthase, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(32749, NULL, 'G3DSA:1.10.150.240:FF:000114', NULL, NULL, 'Protein containing Haloacid dehalogenase-like hydrolase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(32750, NULL, 'G3DSA:1.20.58.390:FF:000045', NULL, NULL, 'neuronal acetylcholine receptor subunit alpha-10', NULL, NULL, NULL, NULL, NULL, 4),
(32751, NULL, 'G3DSA:1.20.58.90:FF:000001', NULL, NULL, 'ralA-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(32752, NULL, 'G3DSA:3.40.718.10:FF:000004', NULL, NULL, '3-isopropylmalate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(32753, NULL, 'G3DSA:1.25.40.10:FF:002259', NULL, NULL, 'TPR repeat', NULL, NULL, NULL, NULL, NULL, 4),
(32754, NULL, 'G3DSA:3.30.70.330:FF:002787', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32755, NULL, 'G3DSA:1.20.1070.10:FF:001207', NULL, NULL, 'Zgc:85942 protein', NULL, NULL, NULL, NULL, NULL, 4),
(32756, NULL, 'G3DSA:1.20.1270.60:FF:000326', NULL, NULL, 'SH3-domain GRB2-like 3b', NULL, NULL, NULL, NULL, NULL, 4),
(32757, NULL, 'G3DSA:3.30.70.330:FF:002843', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32758, NULL, 'G3DSA:1.10.8.10:FF:000362', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32759, NULL, 'G3DSA:1.20.1250.20:FF:000853', NULL, NULL, 'SLC (SoLute Carrier) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(32760, NULL, 'G3DSA:3.40.50.150:FF:001372', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32761, NULL, 'G3DSA:2.30.39.10:FF:000077', NULL, NULL, 'Serpin 42De, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(32762, NULL, 'G3DSA:3.10.100.10:FF:000003', NULL, NULL, 'Versican core protein', NULL, NULL, NULL, NULL, NULL, 4),
(32763, NULL, 'G3DSA:1.25.40.10:FF:004389', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(32764, NULL, 'G3DSA:2.60.120.920:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32765, NULL, 'G3DSA:1.10.390.10:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32766, NULL, 'G3DSA:3.30.70.330:FF:001207', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(32767, NULL, 'G3DSA:2.130.10.10:FF:002468', NULL, NULL, 'Plexin D1', NULL, NULL, NULL, NULL, NULL, 4),
(32768, NULL, 'G3DSA:3.40.50.410:FF:000303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32769, NULL, 'G3DSA:3.30.60.20:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32770, NULL, 'G3DSA:2.30.140.10:FF:000005', NULL, NULL, 'Spermine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(32771, NULL, 'G3DSA:2.30.30.190:FF:000003', NULL, NULL, 'dynactin subunit 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(32772, NULL, 'G3DSA:1.10.150.50:FF:000195', NULL, NULL, 'GA repeat binding protein alpha homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(32773, NULL, 'G3DSA:3.80.10.10:FF:001350', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32774, NULL, 'G3DSA:1.10.510.10:FF:001363', NULL, NULL, 'Protein CBG06575', NULL, NULL, NULL, NULL, NULL, 4),
(32775, NULL, 'G3DSA:3.90.1860.10:FF:000007', NULL, NULL, 'tRNA-splicing ligase RtcB', NULL, NULL, NULL, NULL, NULL, 4),
(32776, NULL, 'G3DSA:2.10.110.10:FF:000047', NULL, NULL, 'lipoma-preferred partner isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(32777, NULL, 'G3DSA:3.40.190.10:FF:000980', NULL, NULL, 'Chorismate mutase/prephenate dehydratase (P-protein)', NULL, NULL, NULL, NULL, NULL, 4),
(32778, NULL, 'G3DSA:3.90.100.10:FF:000002', NULL, NULL, 'Biodegradative arginine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(32779, NULL, 'G3DSA:3.30.1330.30:FF:000061', NULL, NULL, '40S ribosomal protein S12', NULL, NULL, NULL, NULL, NULL, 4),
(32780, NULL, 'G3DSA:3.30.43.10:FF:000017', NULL, NULL, 'D-arabinono-1,4-lactone oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(32781, NULL, 'G3DSA:3.40.50.2300:FF:000105', NULL, NULL, 'Low molecular weight phosphotyrosine protein', NULL, NULL, NULL, NULL, NULL, 4),
(32782, NULL, 'G3DSA:3.30.160.60:FF:000231', NULL, NULL, 'PLAG1 like zinc finger 2', NULL, NULL, NULL, NULL, NULL, 4),
(32783, NULL, 'G3DSA:2.60.40.640:FF:000033', NULL, NULL, 'Down syndrome critical region protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(32784, NULL, 'G3DSA:2.10.70.10:FF:000100', NULL, NULL, 'SR-CI', NULL, NULL, NULL, NULL, NULL, 4),
(32785, NULL, 'G3DSA:3.40.50.2000:FF:000173', NULL, NULL, 'Processive diacylglycerol beta-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(32786, NULL, 'G3DSA:3.80.10.10:FF:002547', NULL, NULL, 'Transmembrane receptors / ATP binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(32787, NULL, 'G3DSA:1.10.533.10:FF:000106', NULL, NULL, 'Unc-5, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(32788, NULL, 'G3DSA:1.25.50.20:FF:000060', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(32789, NULL, 'G3DSA:3.90.1150.10:FF:000212', NULL, NULL, 'BnaC07g16420D protein', NULL, NULL, NULL, NULL, NULL, 4),
(32790, NULL, 'G3DSA:2.60.40.10:FF:004053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32791, NULL, 'G3DSA:3.20.20.80:FF:000677', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(32792, NULL, 'G3DSA:1.10.730.10:FF:000053', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(32793, NULL, 'G3DSA:2.60.40.60:FF:000280', NULL, NULL, 'AGAP007203-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(32794, NULL, 'G3DSA:2.40.30.10:FF:000411', NULL, NULL, 'Nitric oxide synthase, inducible', NULL, NULL, NULL, NULL, NULL, 4),
(32795, NULL, 'G3DSA:2.60.120.200:FF:000623', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32796, NULL, 'G3DSA:3.40.50.2300:FF:000049', NULL, NULL, 'Fructose repressor FruR', NULL, NULL, NULL, NULL, NULL, 4),
(32797, NULL, 'G3DSA:1.10.275.20:FF:000003', NULL, NULL, 'Carnitine acetyl transferase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(32798, NULL, 'G3DSA:3.30.160.60:FF:004502', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32799, NULL, 'G3DSA:3.30.160.60:FF:002029', NULL, NULL, 'Zinc finger protein 287', NULL, NULL, NULL, NULL, NULL, 4),
(32800, NULL, 'G3DSA:2.60.120.200:FF:000567', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32801, NULL, 'G3DSA:3.90.105.10:FF:000030', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(32802, NULL, 'G3DSA:1.10.167.10:FF:000007', NULL, NULL, 'sorting nexin-13 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(32803, NULL, 'G3DSA:3.40.190.10:FF:000648', NULL, NULL, 'Probable porphobilinogen deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(32804, NULL, 'G3DSA:3.40.50.10240:FF:000024', NULL, NULL, 'Thiamine pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(32805, NULL, 'G3DSA:3.30.710.10:FF:000371', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(32806, NULL, 'G3DSA:3.20.20.140:FF:000098', NULL, NULL, 'Error-prone DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(32807, NULL, 'G3DSA:1.20.1560.10:FF:000603', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32808, NULL, 'G3DSA:2.20.100.10:FF:000224', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs gon-1', NULL, NULL, NULL, NULL, NULL, 4),
(32809, NULL, 'G3DSA:2.30.42.10:FF:000040', NULL, NULL, 'partitioning defective 3 homolog isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(32810, NULL, 'G3DSA:1.25.40.180:FF:000012', NULL, NULL, 'Ccr4-Not transcription complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(32811, NULL, 'G3DSA:2.130.10.10:FF:000383', NULL, NULL, 'Syntaxin-binding protein 5 isoform b', NULL, NULL, NULL, NULL, NULL, 4),
(32812, NULL, 'G3DSA:2.60.40.10:FF:003384', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32813, NULL, 'G3DSA:3.40.525.10:FF:000039', NULL, NULL, 'AT1G30690 protein', NULL, NULL, NULL, NULL, NULL, 4),
(32814, NULL, 'G3DSA:2.20.100.10:FF:000168', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs gon-1', NULL, NULL, NULL, NULL, NULL, 4),
(32815, NULL, 'G3DSA:3.40.50.720:FF:002476', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32816, NULL, 'G3DSA:1.10.10.10:FF:002015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32817, NULL, 'G3DSA:2.160.10.10:FF:000016', NULL, NULL, 'Bifunctional protein GlmU', NULL, NULL, NULL, NULL, NULL, 4),
(32818, NULL, 'G3DSA:1.25.40.10:FF:001747', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(32819, NULL, 'G3DSA:3.40.50.11350:FF:000020', NULL, NULL, 'Protein O-fucosyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(32820, NULL, 'G3DSA:3.10.50.40:FF:000038', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(32821, NULL, 'G3DSA:2.30.30.40:FF:000656', NULL, NULL, 'Discs large MAGUK scaffold protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(32822, NULL, 'G3DSA:4.10.1060.10:FF:000037', NULL, NULL, 'Zn-finger in Ran binding protein and others, putative', NULL, NULL, NULL, NULL, NULL, 4),
(32823, NULL, 'G3DSA:1.25.40.10:FF:002315', NULL, NULL, 'Cell division cycle protein 27 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(32824, NULL, 'G3DSA:1.10.287.600:FF:000025', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(32825, NULL, 'G3DSA:2.130.10.10:FF:002524', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(32826, NULL, 'G3DSA:2.60.40.10:FF:001939', NULL, NULL, 'Jitterbug, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(32827, NULL, 'G3DSA:2.70.160.11:FF:000077', NULL, NULL, 'AGAP010203-PA', NULL, NULL, NULL, NULL, NULL, 4),
(32828, NULL, 'G3DSA:1.10.10.790:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32829, NULL, 'G3DSA:3.40.30.10:FF:000285', NULL, NULL, 'Glutathione S-transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(32830, NULL, 'G3DSA:2.130.10.10:FF:004598', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(32831, NULL, 'G3DSA:2.60.40.420:FF:000079', NULL, NULL, 'Laccase 1', NULL, NULL, NULL, NULL, NULL, 4),
(32832, NULL, 'G3DSA:3.40.50.1820:FF:001136', NULL, NULL, 'Lipoxygenase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(32833, NULL, 'G3DSA:3.40.50.2300:FF:001409', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32834, NULL, 'G3DSA:1.20.5.190:FF:000030', NULL, NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(32835, NULL, 'G3DSA:1.25.10.10:FF:002763', NULL, NULL, 'Intracellular protein transport protein uso1', NULL, NULL, NULL, NULL, NULL, 4),
(32836, NULL, 'G3DSA:3.80.10.10:FF:001294', NULL, NULL, 'PH domain and leucine rich repeat protein phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(32837, NULL, 'G3DSA:3.40.50.12550:FF:000015', NULL, NULL, 'ThiF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(32838, NULL, 'G3DSA:1.10.8.140:FF:000017', NULL, NULL, 'DNA-binding TFAR19-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(32839, NULL, 'G3DSA:2.30.29.30:FF:000638', NULL, NULL, 'Arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(32840, NULL, 'G3DSA:3.90.940.40:FF:000001', NULL, NULL, 'Protein CHLORORESPIRATORY REDUCTION 7 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(32841, NULL, 'G3DSA:3.50.50.60:FF:001149', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(32842, NULL, 'G3DSA:3.40.50.300:FF:005852', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(32843, NULL, 'G3DSA:1.20.5.350:FF:000005', NULL, NULL, 'Troponin I 1', NULL, NULL, NULL, NULL, NULL, 4),
(32844, NULL, 'G3DSA:3.30.70.890:FF:000004', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(32845, NULL, 'G3DSA:3.30.200.20:FF:001015', NULL, NULL, 'Putative serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(32846, NULL, 'G3DSA:3.30.40.10:FF:002068', NULL, NULL, 'Uncharacterized RING finger protein C2A9.04c', NULL, NULL, NULL, NULL, NULL, 4),
(32847, NULL, 'G3DSA:2.130.10.10:FF:001164', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(32848, NULL, 'G3DSA:1.20.5.710:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32849, NULL, 'G3DSA:3.30.830.10:FF:000262', NULL, NULL, 'Ubiquinol-cytochrome c reductase core protein 2a', NULL, NULL, NULL, NULL, NULL, 4),
(32850, NULL, 'G3DSA:1.25.40.10:FF:004676', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(32851, NULL, 'G3DSA:1.25.40.20:FF:001863', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32852, NULL, 'G3DSA:2.40.20.10:FF:000062', NULL, NULL, 'plasminogen-like', NULL, NULL, NULL, NULL, NULL, 4),
(32853, NULL, 'G3DSA:3.30.1240.10:FF:000076', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(32854, NULL, 'G3DSA:3.40.50.300:FF:005672', NULL, NULL, 'Peroxisomal ATPase PEX1', NULL, NULL, NULL, NULL, NULL, 4),
(32855, NULL, 'G3DSA:3.40.190.10:FF:000693', NULL, NULL, 'Sll0064 protein', NULL, NULL, NULL, NULL, NULL, 4),
(32856, NULL, 'G3DSA:3.30.40.10:FF:000831', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(32857, NULL, 'G3DSA:2.130.10.10:FF:005397', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32858, NULL, 'G3DSA:3.30.160.60:FF:003721', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32859, NULL, 'G3DSA:1.50.10.10:FF:000097', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(32860, NULL, 'G3DSA:2.60.40.60:FF:000897', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32861, NULL, 'G3DSA:2.130.10.10:FF:005453', NULL, NULL, 'Heterotrimeric G protein beta subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(32862, NULL, 'G3DSA:3.30.450.20:FF:000281', NULL, NULL, 'Cyclic-di-AMP phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(32863, NULL, 'G3DSA:2.30.29.30:FF:000970', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(32864, NULL, 'G3DSA:1.10.510.10:FF:000519', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', NULL, NULL, NULL, NULL, NULL, 4),
(32865, NULL, 'G3DSA:4.10.75.10:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(32866, NULL, 'G3DSA:3.10.105.10:FF:000031', NULL, NULL, 'Dipeptide ABC transporter, periplasmic dipeptide-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(32867, NULL, 'G3DSA:3.30.565.10:FF:000033', NULL, NULL, 'DNA mismatch repair protein Mlh1', NULL, NULL, NULL, NULL, NULL, 4),
(32868, NULL, 'G3DSA:3.40.50.720:FF:000391', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(32869, NULL, 'G3DSA:3.40.1390.10:FF:000005', NULL, NULL, 'UDP-N-acetylmuramoyl-L-alanyl-D-glutamate--2,6-diaminopimelate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(32870, NULL, 'G3DSA:3.40.50.1010:FF:000090', NULL, NULL, 'Nin one binding protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(32871, NULL, 'G3DSA:3.40.50.2300:FF:000381', NULL, NULL, 'Rgd1566381', NULL, NULL, NULL, NULL, NULL, 4),
(32872, NULL, 'G3DSA:1.10.1220.10:FF:000007', NULL, NULL, 'Addiction module antitoxin, RelB/DinJ family', NULL, NULL, NULL, NULL, NULL, 4),
(32873, NULL, 'G3DSA:2.120.10.80:FF:000224', NULL, NULL, 'kelch domain-containing protein 3 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(32874, NULL, 'G3DSA:1.20.5.1160:FF:000010', NULL, NULL, 'neurofilament heavy polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(32875, NULL, 'G3DSA:1.10.630.10:FF:000809', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32876, NULL, 'G3DSA:1.10.510.10:FF:002144', NULL, NULL, 'MRLK6', NULL, NULL, NULL, NULL, NULL, 4),
(32877, NULL, 'G3DSA:1.10.3370.10:FF:000018', NULL, NULL, 'Os09g0512000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(32878, NULL, 'G3DSA:1.10.20.10:FF:000279', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32879, NULL, 'G3DSA:3.30.160.60:FF:005806', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32880, NULL, 'G3DSA:1.10.1300.10:FF:000008', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(32881, NULL, 'G3DSA:3.40.1500.10:FF:000004', NULL, NULL, 'Coproporphyrinogen III oxidase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(32882, NULL, 'G3DSA:3.40.395.10:FF:000045', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(32883, NULL, 'G3DSA:3.40.50.1820:FF:000337', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(32884, NULL, 'G3DSA:1.10.510.10:FF:001470', NULL, NULL, 'Os04g0517700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(32885, NULL, 'G3DSA:4.10.280.10:FF:000012', NULL, NULL, 'hairy/enhancer-of-split related with YRPW motif protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(32886, NULL, 'G3DSA:3.40.50.300:FF:003486', NULL, NULL, 'Major sperm protein', NULL, NULL, NULL, NULL, NULL, 4),
(32887, NULL, 'G3DSA:3.40.50.10990:FF:000013', NULL, NULL, 'GTP cyclohydrolase II', NULL, NULL, NULL, NULL, NULL, 4),
(32888, NULL, 'G3DSA:2.60.40.10:FF:000635', NULL, NULL, 'Titin b', NULL, NULL, NULL, NULL, NULL, 4),
(32889, NULL, 'G3DSA:2.130.10.10:FF:003249', NULL, NULL, 'WD repeat-containing protein 44 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(32890, NULL, 'G3DSA:3.90.550.10:FF:000154', NULL, NULL, '3-deoxy-manno-octulosonate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(32891, NULL, 'G3DSA:1.20.5.110:FF:000332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32892, NULL, 'G3DSA:4.10.280.10:FF:000068', NULL, NULL, 'factor in the germline alpha', NULL, NULL, NULL, NULL, NULL, 4),
(32893, NULL, 'G3DSA:3.30.160.60:FF:000051', NULL, NULL, 'zinc finger protein 585A', NULL, NULL, NULL, NULL, NULL, 4),
(32894, NULL, 'G3DSA:3.40.80.10:FF:000001', NULL, NULL, 'Peptidoglycan recognition protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(32895, NULL, 'G3DSA:3.40.50.300:FF:000052', NULL, NULL, 'V-type proton ATPase catalytic subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(32896, NULL, 'G3DSA:3.40.50.150:FF:000990', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(32897, NULL, 'G3DSA:3.30.160.60:FF:000175', NULL, NULL, 'Mds1 and evi1 complex locus protein', NULL, NULL, NULL, NULL, NULL, 4),
(32898, NULL, 'G3DSA:3.30.2350.20:FF:000020', NULL, NULL, 'tRNA pseudouridine synthase D', NULL, NULL, NULL, NULL, NULL, 4),
(32899, NULL, 'G3DSA:1.25.40.10:FF:002591', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g15510, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(32900, NULL, 'G3DSA:1.10.555.10:FF:000095', NULL, NULL, 'RhoGAP domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(32901, NULL, 'G3DSA:1.20.140.150:FF:000072', NULL, NULL, 'STarGazin (Mammalian calcium channel) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(32902, NULL, 'G3DSA:3.30.160.60:FF:004446', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32903, NULL, 'G3DSA:1.25.40.10:FF:003951', NULL, NULL, 'rRNA biogenesis protein RRP5', NULL, NULL, NULL, NULL, NULL, 4),
(32904, NULL, 'G3DSA:3.40.50.300:FF:007757', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32905, NULL, 'G3DSA:3.50.50.60:FF:001481', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(32906, NULL, 'G3DSA:2.40.10.10:FF:000292', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32907, NULL, 'G3DSA:3.30.70.1400:FF:000012', NULL, NULL, 'Glycine cleavage T protein', NULL, NULL, NULL, NULL, NULL, 4),
(32908, NULL, 'G3DSA:3.30.70.270:FF:000094', NULL, NULL, 'GGDEF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(32909, NULL, 'G3DSA:3.90.550.10:FF:000030', NULL, NULL, 'Glucose-1-phosphate adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(32910, NULL, 'G3DSA:3.50.50.60:FF:001329', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32911, NULL, 'G3DSA:2.40.30.10:FF:000523', NULL, NULL, 'Translation elongation factor G, putative', NULL, NULL, NULL, NULL, NULL, 4),
(32912, NULL, 'G3DSA:1.25.40.10:FF:001803', NULL, NULL, 'Os12g0289800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(32913, NULL, 'G3DSA:1.10.8.60:FF:000112', NULL, NULL, 'Smallminded, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(32914, NULL, 'G3DSA:3.40.50.10090:FF:000013', NULL, NULL, 'Uroporphyrinogen-III synthase (UroS), putative', NULL, NULL, NULL, NULL, NULL, 4),
(32915, NULL, 'G3DSA:3.40.50.150:FF:000602', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase H', NULL, NULL, NULL, NULL, NULL, 4),
(32916, NULL, 'G3DSA:2.60.40.10:FF:004233', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32917, NULL, 'G3DSA:1.50.40.10:FF:000161', NULL, NULL, 'Calcium-binding mitochondrial carrier protein SCaMC-1', NULL, NULL, NULL, NULL, NULL, 4),
(32918, NULL, 'G3DSA:3.60.10.10:FF:000120', NULL, NULL, 'Inositol-polyphosphate 5-phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(32919, NULL, 'G3DSA:3.40.50.2300:FF:001454', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32920, NULL, 'G3DSA:1.20.1560.10:FF:000278', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(32921, NULL, 'G3DSA:3.40.50.410:FF:000085', NULL, NULL, 'Circumsporozoite-and TRAP-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(32922, NULL, 'G3DSA:1.20.910.10:FF:000042', NULL, NULL, 'AGAP012890-PA', NULL, NULL, NULL, NULL, NULL, 4),
(32923, NULL, 'G3DSA:3.90.550.50:FF:000194', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(32924, NULL, 'G3DSA:3.30.40.10:FF:001556', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32925, NULL, 'G3DSA:2.60.40.10:FF:005306', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32926, NULL, 'G3DSA:1.25.40.10:FF:005114', NULL, NULL, 'Putative helicase with zinc finger domain-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(32927, NULL, 'G3DSA:3.30.70.330:FF:000426', NULL, NULL, 'Serine/arginine-rich splicing factor 2a', NULL, NULL, NULL, NULL, NULL, 4),
(32928, NULL, 'G3DSA:3.40.50.720:FF:000059', NULL, NULL, 'L-threonine 3-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(32929, NULL, 'G3DSA:1.25.40.10:FF:001927', NULL, NULL, 'Pentatricopeptide repeat domain 1', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(32930, NULL, 'G3DSA:2.130.10.10:FF:004941', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32931, NULL, 'G3DSA:1.10.510.10:FF:004229', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32932, NULL, 'G3DSA:3.20.100.30:FF:000001', NULL, NULL, 'Vacuolar transporter chaperone 4', NULL, NULL, NULL, NULL, NULL, 4),
(32933, NULL, 'G3DSA:2.10.110.10:FF:000103', NULL, NULL, 'LIM homeobox transcription factor 1-beta', NULL, NULL, NULL, NULL, NULL, 4),
(32934, NULL, 'G3DSA:3.90.190.10:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32935, NULL, 'G3DSA:1.25.10.10:FF:001127', NULL, NULL, 'Protein CBG03866', NULL, NULL, NULL, NULL, NULL, 4),
(32936, NULL, 'G3DSA:2.70.130.10:FF:000035', NULL, NULL, 'Autophagy protein Atg27, putative', NULL, NULL, NULL, NULL, NULL, 4),
(32937, NULL, 'G3DSA:1.20.1530.20:FF:000043', NULL, NULL, 'Arsenite efflux pump', NULL, NULL, NULL, NULL, NULL, 4),
(32938, NULL, 'G3DSA:3.40.50.300:FF:001069', NULL, NULL, 'ATP-binding cassette, sub-family G (WHITE), member 5', NULL, NULL, NULL, NULL, NULL, 4),
(32939, NULL, 'G3DSA:1.20.140.10:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32940, NULL, 'G3DSA:3.40.470.10:FF:000018', NULL, NULL, 'G/U mismatch-specific DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(32941, NULL, 'G3DSA:1.20.58.70:FF:000063', NULL, NULL, 'Syntaxin', NULL, NULL, NULL, NULL, NULL, 4),
(32942, NULL, 'G3DSA:3.30.70.330:FF:002663', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32943, NULL, 'G3DSA:1.10.246.60:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32944, NULL, 'G3DSA:3.40.630.30:FF:000216', NULL, NULL, 'Alpha-tubulin N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(32945, NULL, 'G3DSA:3.40.50.1000:FF:000030', NULL, NULL, 'HAD-IIA family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(32946, NULL, 'G3DSA:3.40.30.10:FF:000465', NULL, NULL, 'Glutaredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(32947, NULL, 'G3DSA:2.30.30.100:FF:000196', NULL, NULL, 'enhancer of mRNA-decapping protein 3-like', NULL, NULL, NULL, NULL, NULL, 4),
(32948, NULL, 'G3DSA:3.80.10.10:FF:003660', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32949, NULL, 'G3DSA:3.40.30.10:FF:000521', NULL, NULL, 'Thioredoxin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(32950, NULL, 'G3DSA:3.30.70.370:FF:000011', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(32951, NULL, 'G3DSA:2.130.10.10:FF:003581', NULL, NULL, 'Lethal(2) giant larvae protein-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(32952, NULL, 'G3DSA:3.90.550.50:FF:000250', NULL, NULL, 'Os03g0803900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(32953, NULL, 'G3DSA:1.10.30.10:FF:000049', NULL, NULL, 'Related to NHP6B-nonhistone chromosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(32954, NULL, 'G3DSA:3.80.10.10:FF:002367', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(32955, NULL, 'G3DSA:3.40.1340.10:FF:000002', NULL, NULL, 'DNA-directed RNA polymerases I, II, and III subunit RPABC1', NULL, NULL, NULL, NULL, NULL, 4),
(32956, NULL, 'G3DSA:3.40.720.10:FF:000055', NULL, NULL, 'Sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(32957, NULL, 'G3DSA:1.10.30.10:FF:000105', NULL, NULL, 'High mobility group (HMG) DNA binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(32958, NULL, 'G3DSA:3.30.40.10:FF:000196', NULL, NULL, 'PHD finger protein 20 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(32959, NULL, 'G3DSA:3.30.1520.10:FF:000114', NULL, NULL, 'Bud emergence protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(32960, NULL, 'G3DSA:2.30.42.10:FF:000545', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32961, NULL, 'G3DSA:1.20.1740.10:FF:000264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32962, NULL, 'G3DSA:3.30.160.20:FF:000011', NULL, NULL, 'double-stranded RNA-specific editase 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(32963, NULL, 'G3DSA:2.40.30.10:FF:000124', NULL, NULL, 'Elongation factor Tu', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(32964, NULL, 'G3DSA:3.30.1230.20:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32965, NULL, 'G3DSA:3.40.50.1100:FF:000234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32966, NULL, 'G3DSA:2.60.40.10:FF:003272', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32967, NULL, 'G3DSA:3.40.50.300:FF:002362', NULL, NULL, 'ATP-binding cassette transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(32968, NULL, 'G3DSA:1.25.40.10:FF:000966', NULL, NULL, 'Os12g0289800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(32969, NULL, 'G3DSA:1.20.58.390:FF:000207', NULL, NULL, 'Cholinergic receptor nicotinic delta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(32970, NULL, 'G3DSA:1.10.510.10:FF:003268', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32971, NULL, 'G3DSA:3.80.10.10:FF:001530', NULL, NULL, 'Adhesion G protein-coupled receptor A2', NULL, NULL, NULL, NULL, NULL, 4),
(32972, NULL, 'G3DSA:1.20.1600.10:FF:000046', NULL, NULL, 'Outer membrane protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(32973, NULL, 'G3DSA:1.20.1640.10:FF:000099', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32974, NULL, 'G3DSA:1.20.140.10:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32975, NULL, 'G3DSA:2.60.40.10:FF:001759', NULL, NULL, 'Hemicentin 2', NULL, NULL, NULL, NULL, NULL, 4),
(32976, NULL, 'G3DSA:3.40.50.2000:FF:000285', NULL, NULL, 'Digalactosyldiacylglycerol synthase 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(32977, NULL, 'G3DSA:1.25.40.10:FF:003372', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(32978, NULL, 'G3DSA:2.20.70.10:FF:000015', NULL, NULL, 'Transcription elongation regulator 1 (CA150)', NULL, NULL, NULL, NULL, NULL, 4),
(32979, NULL, 'G3DSA:2.60.40.10:FF:001416', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(32980, NULL, 'G3DSA:3.30.70.1230:FF:000051', NULL, NULL, 'Soluble guanylate cyclase 88E', NULL, NULL, NULL, NULL, NULL, 4),
(32981, NULL, 'G3DSA:3.40.50.300:FF:004503', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32982, NULL, 'G3DSA:2.60.40.790:FF:000212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32983, NULL, 'G3DSA:2.60.200.20:FF:000181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32984, NULL, 'G3DSA:1.10.238.20:FF:000030', NULL, NULL, 'IP02370p', NULL, NULL, NULL, NULL, NULL, 4),
(32985, NULL, 'G3DSA:3.60.21.10:FF:000201', NULL, NULL, 'ATPAP14/PAP14', NULL, NULL, NULL, NULL, NULL, 4),
(32986, NULL, 'G3DSA:2.40.70.10:FF:000301', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32987, NULL, 'G3DSA:3.40.390.10:FF:000017', NULL, NULL, 'Disintegrin and metalloproteinase domain-containing protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(32988, NULL, 'G3DSA:2.130.10.10:FF:005958', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase, cyclophilin-type', NULL, NULL, NULL, NULL, NULL, 4),
(32989, NULL, 'G3DSA:3.40.50.150:FF:000259', NULL, NULL, 'Protein-L-isoaspartate O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(32990, NULL, 'G3DSA:2.130.10.10:FF:003828', NULL, NULL, 'Sec13-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(32991, NULL, 'G3DSA:3.40.50.300:FF:006633', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(32992, NULL, 'G3DSA:1.10.12.10:FF:000041', NULL, NULL, 'Enoyl CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(32993, NULL, 'G3DSA:3.30.200.20:FF:000234', NULL, NULL, 'Proto-oncogene tyrosine-protein kinase receptor Ret', NULL, NULL, NULL, NULL, NULL, 4),
(32994, NULL, 'G3DSA:1.20.1560.10:FF:000098', NULL, NULL, 'Probable ATP-binding/permease fusion ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(32995, NULL, 'G3DSA:1.20.1510.10:FF:000095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(32996, NULL, 'G3DSA:1.10.580.10:FF:000001', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(32997, NULL, 'G3DSA:3.20.20.140:FF:000316', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase (NagA)', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(32998, NULL, 'G3DSA:1.25.40.10:FF:001242', NULL, NULL, 'PeRoXisome assembly factor', NULL, NULL, NULL, NULL, NULL, 4),
(32999, NULL, 'G3DSA:2.60.260.20:FF:000010', NULL, NULL, 'Curved DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(33000, NULL, 'G3DSA:3.40.50.720:FF:001296', NULL, NULL, 'Alcohol dehydrogenase, zinc-containing', NULL, NULL, NULL, NULL, NULL, 4),
(33001, NULL, 'G3DSA:3.30.710.10:FF:000219', NULL, NULL, 'BTB domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(33002, NULL, 'G3DSA:2.110.10.10:FF:000041', NULL, NULL, 'Zinc MetalloProtease', NULL, NULL, NULL, NULL, NULL, 4),
(33003, NULL, 'G3DSA:2.30.30.30:FF:000035', NULL, NULL, 'Transcription termination/antitermination protein NusG', NULL, NULL, NULL, NULL, NULL, 4),
(33004, NULL, 'G3DSA:2.60.40.1970:FF:000002', NULL, NULL, 'YEATS domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(33005, NULL, 'G3DSA:3.90.1180.10:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33006, NULL, 'G3DSA:3.10.20.90:FF:000860', NULL, NULL, 'Autophagy-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(33007, NULL, 'G3DSA:2.60.40.150:FF:000543', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(33008, NULL, 'G3DSA:3.30.40.10:FF:001213', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(33009, NULL, 'G3DSA:3.30.1520.10:FF:000058', NULL, NULL, 'VPS9 domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33010, NULL, 'G3DSA:1.25.10.10:FF:000110', NULL, NULL, 'synembryn-B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(33011, NULL, 'G3DSA:1.20.1310.20:FF:000004', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(33012, NULL, 'G3DSA:2.60.40.10:FF:005126', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33013, NULL, 'G3DSA:3.80.10.10:FF:004109', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(33014, NULL, 'G3DSA:4.10.410.10:FF:000051', NULL, NULL, 'CBN-SPON-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(33015, NULL, 'G3DSA:1.10.20.10:FF:000223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33016, NULL, 'G3DSA:2.20.25.10:FF:000040', NULL, NULL, 'Putative DNA-direcetd RNA polymerase II, subunit 9', NULL, NULL, NULL, NULL, NULL, 4),
(33017, NULL, 'G3DSA:2.130.10.10:FF:001687', NULL, NULL, 'WD repeat domain 66', NULL, NULL, NULL, NULL, NULL, 4),
(33018, NULL, 'G3DSA:2.30.30.40:FF:000151', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(33019, NULL, 'G3DSA:2.60.40.4370:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33020, NULL, 'G3DSA:2.30.29.30:FF:001038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33021, NULL, 'G3DSA:3.90.1150.10:FF:000268', NULL, NULL, 'UDP4amino4deoxyLarabinoseoxoglutarate aminotransferase EC 261', NULL, NULL, NULL, NULL, NULL, 4),
(33022, NULL, 'G3DSA:3.40.50.720:FF:001695', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33023, NULL, 'G3DSA:1.10.287.70:FF:000725', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33024, NULL, 'G3DSA:2.60.34.10:FF:000014', NULL, NULL, 'Chaperone protein DnaK HSP70', NULL, NULL, NULL, NULL, NULL, 4),
(33025, NULL, 'G3DSA:3.60.21.10:FF:000145', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(33026, NULL, 'G3DSA:1.20.58.60:FF:000346', NULL, NULL, 'SMAll', NULL, NULL, NULL, NULL, NULL, 4),
(33027, NULL, 'G3DSA:1.10.10.60:FF:001153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33028, NULL, 'G3DSA:1.10.8.10:FF:000182', NULL, NULL, 'Protoporphyrinogen oxidase (HemK)', NULL, NULL, NULL, NULL, NULL, 4),
(33029, NULL, 'G3DSA:2.60.40.10:FF:005649', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33030, NULL, 'G3DSA:3.40.50.300:FF:003704', NULL, NULL, 'Recombinase RecB', NULL, NULL, NULL, NULL, NULL, 4),
(33031, NULL, 'G3DSA:1.25.40.1030:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33032, NULL, 'G3DSA:3.40.50.1820:FF:000736', NULL, NULL, 'Triacylglycerol lipase-like 1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(33033, NULL, 'G3DSA:2.40.50.140:FF:001036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33034, NULL, 'G3DSA:1.10.287.110:FF:000081', NULL, NULL, 'Chaperone DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(33035, NULL, 'G3DSA:2.60.40.10:FF:000579', NULL, NULL, 'Fibronectin 1', NULL, NULL, NULL, NULL, NULL, 4),
(33036, NULL, 'G3DSA:2.130.10.10:FF:003305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33037, NULL, 'G3DSA:1.10.10.10:FF:001178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33038, NULL, 'G3DSA:1.20.58.2220:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33039, NULL, 'G3DSA:1.10.10.10:FF:000778', NULL, NULL, 'Meiotic recombination protein SPO11-1', NULL, NULL, NULL, NULL, NULL, 4),
(33040, NULL, 'G3DSA:3.30.160.60:FF:003665', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33041, NULL, 'G3DSA:1.25.40.10:FF:004732', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33042, NULL, 'G3DSA:3.30.360.10:FF:000006', NULL, NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(33043, NULL, 'G3DSA:2.30.29.30:FF:001190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33044, NULL, 'G3DSA:1.20.920.10:FF:000104', NULL, NULL, 'Bromodomain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(33045, NULL, 'G3DSA:3.40.50.1980:FF:000071', NULL, NULL, 'Iron complex transport system substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(33046, NULL, 'G3DSA:3.30.420.10:FF:000337', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33047, NULL, 'G3DSA:1.10.220.30:FF:000014', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(33048, NULL, 'G3DSA:2.60.120.200:FF:000062', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(33049, NULL, 'G3DSA:2.60.40.1170:FF:000026', NULL, NULL, 'AP-1 complex subunit mu, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33050, NULL, 'G3DSA:3.40.50.620:FF:000827', NULL, NULL, 'Tryptophan--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(33051, NULL, 'G3DSA:3.30.1380.20:FF:000004', NULL, NULL, 'Trafficking protein particle complex subunit 6B', NULL, NULL, NULL, NULL, NULL, 4),
(33052, NULL, 'G3DSA:3.40.50.10190:FF:000217', NULL, NULL, 'Nibrin', NULL, NULL, NULL, NULL, NULL, 4),
(33053, NULL, 'G3DSA:1.25.40.180:FF:000299', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33054, NULL, 'G3DSA:1.20.58.100:FF:000003', NULL, NULL, 'Succinate dehydrogenase flavoprotein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(33055, NULL, 'G3DSA:3.20.20.10:FF:000010', NULL, NULL, 'Antizyme inhibitor 1', NULL, NULL, NULL, NULL, NULL, 4),
(33056, NULL, 'G3DSA:3.80.10.10:FF:003328', NULL, NULL, 'AGAP006408-PA', NULL, NULL, NULL, NULL, NULL, 4),
(33057, NULL, 'G3DSA:3.40.250.10:FF:000131', NULL, NULL, 'Serine/threonine/tyrosine-interacting-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(33058, NULL, 'G3DSA:3.20.20.80:FF:000154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33059, NULL, 'G3DSA:3.30.70.980:FF:000031', NULL, NULL, 'Probable transcriptional regulatory protein ARJ17_01235', NULL, NULL, NULL, NULL, NULL, 4),
(33060, NULL, 'G3DSA:3.40.50.300:FF:007937', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33061, NULL, 'G3DSA:1.25.40.20:FF:000407', NULL, NULL, 'Ankyrin repeat and SOCS box containing 14', NULL, NULL, NULL, NULL, NULL, 4),
(33062, NULL, 'G3DSA:2.40.40.20:FF:000010', NULL, NULL, 'Anaerobic dimethyl sulfoxide reductase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(33063, NULL, 'G3DSA:2.40.50.100:FF:000035', NULL, NULL, 'Auxiliary transport protein, membrane fusion protein family', NULL, NULL, NULL, NULL, NULL, 4),
(33064, NULL, 'G3DSA:3.40.50.300:FF:008213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33065, NULL, 'G3DSA:3.20.20.70:FF:000617', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33066, NULL, 'G3DSA:1.10.10.10:FF:000958', NULL, NULL, 'ATP-dependent DEAD/H DNA helicase recQ, putative', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(33067, NULL, 'G3DSA:2.20.28.230:FF:000004', NULL, NULL, 'Interleukin-2 receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(33068, NULL, 'G3DSA:2.60.120.620:FF:000013', NULL, NULL, 'Prolyl 4-hydroxylase subunit alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(33069, NULL, 'G3DSA:3.40.190.80:FF:000068', NULL, NULL, 'Inositol monophosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(33070, NULL, 'G3DSA:1.10.287.70:FF:000040', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(33071, NULL, 'G3DSA:2.60.40.420:FF:000259', NULL, NULL, 'Early nodulin-55-1', NULL, NULL, NULL, NULL, NULL, 4),
(33072, NULL, 'G3DSA:3.30.559.30:FF:000024', NULL, NULL, 'Nonribosomal peptide synthase sidE', NULL, NULL, NULL, NULL, NULL, 4),
(33073, NULL, 'G3DSA:1.10.1200.10:FF:000012', NULL, NULL, 'Acyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(33074, NULL, 'G3DSA:3.40.50.150:FF:001771', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33075, NULL, 'G3DSA:2.60.40.150:FF:000487', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33076, NULL, 'G3DSA:1.20.920.10:FF:000048', NULL, NULL, 'RSC complex subunit (RSC1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(33077, NULL, 'G3DSA:1.10.510.10:FF:003780', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33078, NULL, 'G3DSA:1.10.510.10:FF:002487', NULL, NULL, 'RE68077p', NULL, NULL, NULL, NULL, NULL, 4),
(33079, NULL, 'G3DSA:3.30.40.10:FF:001612', NULL, NULL, 'DNA repair protein rad8', NULL, NULL, NULL, NULL, NULL, 4),
(33080, NULL, 'G3DSA:1.25.40.20:FF:000227', NULL, NULL, 'Kinase D-interacting substrate 220a', NULL, NULL, NULL, NULL, NULL, 4),
(33081, NULL, 'G3DSA:1.25.40.820:FF:000018', NULL, NULL, 'Putative RNA polymerase II subunit B1 CTD phosphatase RPAP2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(33082, NULL, 'G3DSA:1.10.10.10:FF:001234', NULL, NULL, 'Response regulator SaeR', NULL, NULL, NULL, NULL, NULL, 4),
(33083, NULL, 'G3DSA:2.40.110.10:FF:000063', NULL, NULL, 'Acyl-CoA dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33084, NULL, 'G3DSA:3.30.9.10:FF:000303', NULL, NULL, 'Amino acid deaminase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33085, NULL, 'G3DSA:1.10.1170.10:FF:000014', NULL, NULL, 'IAP-like protein p27', NULL, NULL, NULL, NULL, NULL, 4),
(33086, NULL, 'G3DSA:2.170.150.80:FF:000033', NULL, NULL, 'NAC domain containing protein 65', NULL, NULL, NULL, NULL, NULL, 4),
(33087, NULL, 'G3DSA:3.40.50.1820:FF:000175', NULL, NULL, 'Hydrolase-like protein family', NULL, NULL, NULL, NULL, NULL, 4),
(33088, NULL, 'G3DSA:3.90.550.10:FF:000210', NULL, NULL, 'Mycofactocin biosynthesis glycosyltransferase MftF', NULL, NULL, NULL, NULL, NULL, 4),
(33089, NULL, 'G3DSA:3.30.365.10:FF:000034', NULL, NULL, 'Xanthine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(33090, NULL, 'G3DSA:3.40.140.70:FF:000005', NULL, NULL, 'Autophagy protein apg7, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33091, NULL, 'G3DSA:1.20.990.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33092, NULL, 'G3DSA:3.60.10.10:FF:000064', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(33093, NULL, 'G3DSA:3.40.950.10:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33094, NULL, 'G3DSA:3.30.750.44:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33095, NULL, 'G3DSA:1.20.5.170:FF:000215', NULL, NULL, 'Putative nucleoporin Nup54-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(33096, NULL, 'G3DSA:3.30.70.270:FF:000150', NULL, NULL, 'DNA polymerase eta', NULL, NULL, NULL, NULL, NULL, 4),
(33097, NULL, 'G3DSA:3.40.1190.20:FF:000010', NULL, NULL, 'Ribokinase', NULL, NULL, NULL, NULL, NULL, 4),
(33098, NULL, 'G3DSA:2.20.70.10:FF:000291', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33099, NULL, 'G3DSA:3.30.1460.20:FF:000005', NULL, NULL, 'Arp2/3 complex 34 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(33100, NULL, 'G3DSA:3.90.640.10:FF:000037', NULL, NULL, 'Heat shock 70 kDa protein 13', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(33101, NULL, 'G3DSA:1.20.1250.20:FF:000510', NULL, NULL, 'Siderophore iron transporter mirC', NULL, NULL, NULL, NULL, NULL, 4),
(33102, NULL, 'G3DSA:3.40.50.300:FF:006577', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(33103, NULL, 'G3DSA:3.30.70.330:FF:001882', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33104, NULL, 'G3DSA:1.10.510.10:FF:000014', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(33105, NULL, 'G3DSA:2.40.50.140:FF:000816', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33106, NULL, 'G3DSA:2.40.70.10:FF:000121', NULL, NULL, 'Eukaryotic aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(33107, NULL, 'G3DSA:2.60.40.60:FF:000004', NULL, NULL, 'Protocadherin 1 gamma 2', NULL, NULL, NULL, NULL, NULL, 4),
(33108, NULL, 'G3DSA:3.80.10.10:FF:000170', NULL, NULL, 'amphoterin-induced protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(33109, NULL, 'G3DSA:3.40.50.1460:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33110, NULL, 'G3DSA:1.10.565.10:FF:000045', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(33111, NULL, 'G3DSA:3.90.1480.20:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33112, NULL, 'G3DSA:1.10.10.2330:FF:000009', NULL, NULL, 'Phenylalanyl-tRNA synthetase alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33113, NULL, 'G3DSA:2.40.30.10:FF:000467', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33114, NULL, 'G3DSA:3.30.70.1710:FF:000004', NULL, NULL, 'Ethanolamine utilization microcompartment protein EutL', NULL, NULL, NULL, NULL, NULL, 4),
(33115, NULL, 'G3DSA:1.10.10.10:FF:001919', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33116, NULL, 'G3DSA:1.10.287.3240:FF:000003', NULL, NULL, 'V-type proton ATPase subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(33117, NULL, 'G3DSA:1.20.1070.10:FF:000408', NULL, NULL, 'Olfactory receptor 59', NULL, NULL, NULL, NULL, NULL, 4),
(33118, NULL, 'G3DSA:3.40.50.300:FF:002182', NULL, NULL, 'Bifunctional polynucleotide phosphatase/kinase', NULL, NULL, NULL, NULL, NULL, 4),
(33119, NULL, 'G3DSA:1.20.1260.10:FF:000058', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(33120, NULL, 'G3DSA:1.20.120.230:FF:000013', NULL, NULL, 'Vinculin b', NULL, NULL, NULL, NULL, NULL, 4),
(33121, NULL, 'G3DSA:2.60.120.470:FF:000002', NULL, NULL, 'PITH domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(33122, NULL, 'G3DSA:3.30.40.10:FF:000775', NULL, NULL, 'Tripartite motif-containing protein 40', NULL, NULL, NULL, NULL, NULL, 4),
(33123, NULL, 'G3DSA:3.30.160.60:FF:003541', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33124, NULL, 'G3DSA:3.30.420.40:FF:000279', NULL, NULL, 'Actin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33125, NULL, 'G3DSA:1.25.40.10:FF:004333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33126, NULL, 'G3DSA:3.30.310.10:FF:000003', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(33127, NULL, 'G3DSA:2.60.120.200:FF:000803', NULL, NULL, 'OSJNBa0027H06.10 protein', NULL, NULL, NULL, NULL, NULL, 4),
(33128, NULL, 'G3DSA:3.30.60.30:FF:000080', NULL, NULL, 'Follistatin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(33129, NULL, 'G3DSA:3.40.50.300:FF:003542', NULL, NULL, 'DNA repair protein rhp57', NULL, NULL, NULL, NULL, NULL, 4),
(33130, NULL, 'G3DSA:3.90.110.10:FF:000008', NULL, NULL, '6-phospho-beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(33131, NULL, 'G3DSA:3.40.50.300:FF:006976', NULL, NULL, 'GTP-binding nuclear protein', NULL, NULL, NULL, NULL, NULL, 4),
(33132, NULL, 'G3DSA:1.10.238.10:FF:000482', NULL, NULL, 'CALmodulin related genes', NULL, NULL, NULL, NULL, NULL, 4),
(33133, NULL, 'G3DSA:3.30.1370.100:FF:000018', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(33134, NULL, 'G3DSA:1.20.120.1530:FF:000011', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(33135, NULL, 'G3DSA:3.30.160.60:FF:005879', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33136, NULL, 'G3DSA:1.20.900.10:FF:000081', NULL, NULL, 'Protein ECT2', NULL, NULL, NULL, NULL, NULL, 4),
(33137, NULL, 'G3DSA:2.40.20.10:FF:000034', NULL, NULL, 'Plasminogen', NULL, NULL, NULL, NULL, NULL, 4),
(33138, NULL, 'G3DSA:2.30.30.380:FF:000066', NULL, NULL, 'CaLPain family', NULL, NULL, NULL, NULL, NULL, 4),
(33139, NULL, 'G3DSA:1.20.58.60:FF:000234', NULL, NULL, 'microtubule-actin cross-linking factor 1 isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(33140, NULL, 'G3DSA:2.60.40.10:FF:003193', NULL, NULL, 'Beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(33141, NULL, 'G3DSA:2.20.110.10:FF:000062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33142, NULL, 'G3DSA:3.40.50.1370:FF:000039', NULL, NULL, 'Aspartate carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(33143, NULL, 'G3DSA:3.30.420.10:FF:000383', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33144, NULL, 'G3DSA:1.10.10.60:FF:000080', NULL, NULL, 'Zinc finger homeobox protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(33145, NULL, 'G3DSA:3.40.50.2300:FF:000925', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33146, NULL, 'G3DSA:3.65.10.20:FF:000011', NULL, NULL, '18S rRNA biogenesis protein RCL1', NULL, NULL, NULL, NULL, NULL, 4),
(33147, NULL, 'G3DSA:1.20.120.350:FF:000184', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33148, NULL, 'G3DSA:1.10.439.20:FF:000002', NULL, NULL, 'Phospholipase B-like', NULL, NULL, NULL, NULL, NULL, 4),
(33149, NULL, 'G3DSA:3.10.20.310:FF:000016', NULL, NULL, 'Outer membrane OMP85 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(33150, NULL, 'G3DSA:2.130.10.10:FF:000102', NULL, NULL, 'Actin-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(33151, NULL, 'G3DSA:1.20.920.10:FF:000094', NULL, NULL, 'Unplaced genomic scaffold supercont1.83, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(33152, NULL, 'G3DSA:3.30.160.60:FF:004261', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33153, NULL, 'G3DSA:3.40.20.10:FF:000071', NULL, NULL, 'Unplaced genomic scaffold supercont1.257, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(33154, NULL, 'G3DSA:2.40.30.130:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33155, NULL, 'G3DSA:3.30.1010.10:FF:000019', NULL, NULL, 'Serine/threonine-protein kinase Tel1', NULL, NULL, NULL, NULL, NULL, 4),
(33156, NULL, 'G3DSA:1.10.20.140:FF:000006', NULL, NULL, 'tRNA dimethylallyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(33157, NULL, 'G3DSA:1.10.287.70:FF:000596', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33158, NULL, 'G3DSA:3.20.20.70:FF:000112', NULL, NULL, 'Fructose-bisphosphate aldolase Fba', NULL, NULL, NULL, NULL, NULL, 4),
(33159, NULL, 'G3DSA:3.30.390.150:FF:000005', NULL, NULL, 'Gastrokine-3', NULL, NULL, NULL, NULL, NULL, 4),
(33160, NULL, 'G3DSA:3.80.10.10:FF:001642', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase TDR', NULL, NULL, NULL, NULL, NULL, 4),
(33161, NULL, 'G3DSA:3.40.630.30:FF:000340', NULL, NULL, 'Acyl-CoA N-acyltransferases (NAT) superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(33162, NULL, 'G3DSA:1.10.20.10:FF:000144', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(33163, NULL, 'G3DSA:3.40.50.300:FF:002053', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(33164, NULL, 'G3DSA:1.10.590.10:FF:000002', NULL, NULL, 'Chorismate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(33165, NULL, 'G3DSA:2.60.40.10:FF:002687', NULL, NULL, 'HEMCAM', NULL, NULL, NULL, NULL, NULL, 4),
(33166, NULL, 'G3DSA:3.40.50.150:FF:001563', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33167, NULL, 'G3DSA:2.130.10.10:FF:001563', NULL, NULL, 'Kinesin protein KIF21B', NULL, NULL, NULL, NULL, NULL, 4),
(33168, NULL, 'G3DSA:3.40.30.10:FF:000156', NULL, NULL, 'Glutathione S-transferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(33169, NULL, 'G3DSA:3.40.50.1820:FF:001473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(33170, NULL, 'G3DSA:3.30.160.60:FF:003272', NULL, NULL, 'gastrula zinc finger protein XlCGF67.1-like', NULL, NULL, NULL, NULL, NULL, 4),
(33171, NULL, 'G3DSA:1.10.287.110:FF:000018', NULL, NULL, 'DnaJ (Hsp40) homolog, subfamily C, member 7', NULL, NULL, NULL, NULL, NULL, 4),
(33172, NULL, 'G3DSA:3.40.50.300:FF:000006', NULL, NULL, 'DNA-binding transcriptional regulator NtrC', NULL, NULL, NULL, NULL, NULL, 4),
(33173, NULL, 'G3DSA:1.10.1370.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33174, NULL, 'G3DSA:3.20.20.10:FF:000038', NULL, NULL, 'Pyridoxal phosphate homeostasis protein', NULL, NULL, NULL, NULL, NULL, 4),
(33175, NULL, 'G3DSA:3.40.50.300:FF:005812', NULL, NULL, 'Beethoven', NULL, NULL, NULL, NULL, NULL, 4),
(33176, NULL, 'G3DSA:3.30.160.60:FF:002653', NULL, NULL, 'C2H2 transcription factor protein', NULL, NULL, NULL, NULL, NULL, 4),
(33177, NULL, 'G3DSA:3.40.47.10:FF:000149', NULL, NULL, '3-hydroxy-3-methylglutaryl coenzyme A synthase', NULL, NULL, NULL, NULL, NULL, 4),
(33178, NULL, 'G3DSA:3.40.50.300:FF:001434', NULL, NULL, 'Structural maintenance of chromosomes protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(33179, NULL, 'G3DSA:1.10.630.10:FF:000562', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33180, NULL, 'G3DSA:3.10.180.10:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33181, NULL, 'G3DSA:3.30.200.20:FF:001690', NULL, NULL, 'Putative serine threonine-protein kinase WNK2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(33182, NULL, 'G3DSA:2.130.10.10:FF:004789', NULL, NULL, 'Protein CBR-GAD-1', NULL, NULL, NULL, NULL, NULL, 4),
(33183, NULL, 'G3DSA:1.20.1250.10:FF:000125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33184, NULL, 'G3DSA:2.60.210.10:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33185, NULL, 'G3DSA:3.30.70.330:FF:002394', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33186, NULL, 'G3DSA:2.130.10.10:FF:000091', NULL, NULL, 'mitogen-activated protein kinase-binding protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(33187, NULL, 'G3DSA:3.20.20.140:FF:000440', NULL, NULL, 'Polymerase/histidinol phosphatase-like', NULL, NULL, NULL, NULL, NULL, 4),
(33188, NULL, 'G3DSA:3.10.580.10:FF:000044', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(33189, NULL, 'G3DSA:3.50.50.60:FF:000941', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(33190, NULL, 'G3DSA:3.60.40.10:FF:000161', NULL, NULL, 'Putative Ser/Thr phosphatase 2C', NULL, NULL, NULL, NULL, NULL, 4),
(33191, NULL, 'G3DSA:1.10.510.10:FF:003841', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33192, NULL, 'G3DSA:3.40.390.10:FF:000085', NULL, NULL, 'Zinc metalloproteinase', NULL, NULL, NULL, NULL, NULL, 4),
(33193, NULL, 'G3DSA:1.20.1250.20:FF:002062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33194, NULL, 'G3DSA:3.40.50.300:FF:005279', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(33195, NULL, 'G3DSA:2.60.120.200:FF:000011', NULL, NULL, 'Probable calnexin', NULL, NULL, NULL, NULL, NULL, 4),
(33196, NULL, 'G3DSA:2.60.110.10:FF:000002', NULL, NULL, 'Thaumatin-like protein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(33197, NULL, 'G3DSA:3.30.160.60:FF:003642', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(33198, NULL, 'G3DSA:2.130.10.30:FF:000097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33199, NULL, 'G3DSA:3.40.1080.10:FF:000004', NULL, NULL, 'Acetyl-CoA hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(33200, NULL, 'G3DSA:3.60.15.10:FF:000159', NULL, NULL, 'Rhodanese domain protein / beta-lactamase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(33201, NULL, 'G3DSA:3.30.70.1450:FF:000010', NULL, NULL, 'Trk system potassium transporter TrkA', NULL, NULL, NULL, NULL, NULL, 4),
(33202, NULL, 'G3DSA:3.30.70.1230:FF:000175', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33203, NULL, 'G3DSA:2.60.120.290:FF:000257', NULL, NULL, 'Cubilin-like Protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(33204, NULL, 'G3DSA:1.10.150.50:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33205, NULL, 'G3DSA:3.40.50.11040:FF:000006', NULL, NULL, 'RNA cytidine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(33206, NULL, 'G3DSA:1.20.1070.10:FF:001016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33207, NULL, 'G3DSA:3.30.60.30:FF:000181', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(33208, NULL, 'G3DSA:3.30.160.60:FF:001708', NULL, NULL, 'Zinc finger protein 251', NULL, NULL, NULL, NULL, NULL, 4),
(33209, NULL, 'G3DSA:1.25.40.20:FF:001508', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33210, NULL, 'G3DSA:3.30.1150.10:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33211, NULL, 'G3DSA:1.10.287.70:FF:000124', NULL, NULL, 'Cyclic nucleotide-gated channel 6', NULL, NULL, NULL, NULL, NULL, 4),
(33212, NULL, 'G3DSA:1.20.1540.10:FF:000035', NULL, NULL, 'RHOMBOID-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(33213, NULL, 'G3DSA:1.10.510.10:FF:001071', NULL, NULL, 'NIMA related kinase 11', NULL, NULL, NULL, NULL, NULL, 4),
(33214, NULL, 'G3DSA:2.40.30.20:FF:000009', NULL, NULL, 'V-type proton ATPase catalytic subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(33215, NULL, 'G3DSA:3.40.50.2300:FF:001061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33216, NULL, 'G3DSA:1.20.1070.10:FF:000499', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(33217, NULL, 'G3DSA:1.10.150.40:FF:000006', NULL, NULL, 'Barrier-to-autointegration factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(33218, NULL, 'G3DSA:3.40.50.12780:FF:000078', NULL, NULL, 'Acyl protein synthase/acyl-CoA reductase RfbN', NULL, NULL, NULL, NULL, NULL, 4),
(33219, NULL, 'G3DSA:4.10.400.10:FF:000005', NULL, NULL, 'low-density lipoprotein receptor-related protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(33220, NULL, 'G3DSA:2.130.10.10:FF:005745', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33221, NULL, 'G3DSA:2.60.40.10:FF:002215', NULL, NULL, 'Interleukin 6 signal transducer', NULL, NULL, NULL, NULL, NULL, 4),
(33222, NULL, 'G3DSA:3.40.109.10:FF:000011', NULL, NULL, 'Nitroreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(33223, NULL, 'G3DSA:3.30.450.20:FF:000421', NULL, NULL, 'Sensor histidine kinase, PAS domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(33224, NULL, 'G3DSA:1.20.1720.10:FF:000133', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33225, NULL, 'G3DSA:2.60.40.10:FF:004502', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33226, NULL, 'G3DSA:3.40.50.300:FF:007257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33227, NULL, 'G3DSA:3.40.50.300:FF:001097', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(33228, NULL, 'G3DSA:3.40.50.2000:FF:000942', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33229, NULL, 'G3DSA:1.25.40.10:FF:000207', NULL, NULL, 'Small glutamine-rich tetratricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(33230, NULL, 'G3DSA:2.60.470.10:FF:000023', NULL, NULL, 'Pickpocket 12', NULL, NULL, NULL, NULL, NULL, 4),
(33231, NULL, 'G3DSA:3.30.70.370:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33232, NULL, 'G3DSA:3.30.70.330:FF:001775', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33233, NULL, 'G3DSA:3.30.30.120:FF:000001', NULL, NULL, 'Diapause-specific peptide', NULL, NULL, NULL, NULL, NULL, 4),
(33234, NULL, 'G3DSA:1.10.510.10:FF:003532', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33235, NULL, 'G3DSA:1.10.565.10:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33236, NULL, 'G3DSA:3.30.870.10:FF:000040', NULL, NULL, 'Envelope phospholipase F13', NULL, NULL, NULL, NULL, NULL, 4),
(33237, NULL, 'G3DSA:3.60.20.10:FF:000261', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33238, NULL, 'G3DSA:3.40.630.20:FF:000011', NULL, NULL, 'Pyroglutamyl-peptidase 1-like protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(33239, NULL, 'G3DSA:1.25.10.10:FF:001807', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33240, NULL, 'G3DSA:1.50.10.150:FF:000021', NULL, NULL, 'Os01g0360801 protein', NULL, NULL, NULL, NULL, NULL, 4),
(33241, NULL, 'G3DSA:3.30.505.10:FF:000260', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33242, NULL, 'G3DSA:1.10.510.10:FF:001924', NULL, NULL, 'leucine-rich repeat receptor-like tyrosine-protein kinase PXC3', NULL, NULL, NULL, NULL, NULL, 4),
(33243, NULL, 'G3DSA:2.40.30.10:FF:000332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33244, NULL, 'G3DSA:3.40.630.40:FF:000017', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase CwlD', NULL, NULL, NULL, NULL, NULL, 4),
(33245, NULL, 'G3DSA:3.40.50.720:FF:001779', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(33246, NULL, 'G3DSA:3.30.300.30:FF:000003', NULL, NULL, 'DIP2 disco-interacting protein 2 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(33247, NULL, 'G3DSA:1.20.1070.10:FF:001651', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33248, NULL, 'G3DSA:3.50.50.60:FF:000632', NULL, NULL, 'Glycine/D-amino acid oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(33249, NULL, 'G3DSA:3.40.50.2020:FF:000139', NULL, NULL, 'Ribose-phosphate pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(33250, NULL, 'G3DSA:3.30.420.40:FF:000116', NULL, NULL, 'Pantothenate kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(33251, NULL, 'G3DSA:1.10.10.10:FF:000981', NULL, NULL, 'HTH-type transcriptional regulator Cmr', NULL, NULL, NULL, NULL, NULL, 4),
(33252, NULL, 'G3DSA:3.60.10.10:FF:000333', NULL, NULL, 'Probable secreted protein', NULL, NULL, NULL, NULL, NULL, 4),
(33253, NULL, 'G3DSA:3.20.20.140:FF:000131', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(33254, NULL, 'G3DSA:1.10.287.1060:FF:000012', NULL, NULL, 'Vacuolar sorting protein SNF7', NULL, NULL, NULL, NULL, NULL, 4),
(33255, NULL, 'G3DSA:1.20.58.2180:FF:000001', NULL, NULL, 'Iron(III) ABC transporter, solute-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(33256, NULL, 'G3DSA:1.10.10.10:FF:001470', NULL, NULL, 'Ferric uptake regulator, Fur family', NULL, NULL, NULL, NULL, NULL, 4),
(33257, NULL, 'G3DSA:2.30.40.10:FF:000119', NULL, NULL, 'Bll5494 protein', NULL, NULL, NULL, NULL, NULL, 4),
(33258, NULL, 'G3DSA:1.20.5.110:FF:000141', NULL, NULL, 'CRE-SYN-13 protein', NULL, NULL, NULL, NULL, NULL, 4),
(33259, NULL, 'G3DSA:3.30.160.60:FF:005087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33260, NULL, 'G3DSA:1.25.40.10:FF:001618', NULL, NULL, 'Stress-induced-phosphoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(33261, NULL, 'G3DSA:3.80.10.10:FF:004076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33262, NULL, 'G3DSA:3.30.70.260:FF:000006', NULL, NULL, '(P)ppGpp synthase/hydrolase SpoT', NULL, NULL, NULL, NULL, NULL, 4),
(33263, NULL, 'G3DSA:3.30.390.60:FF:000012', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(33264, NULL, 'G3DSA:1.20.1050.20:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33265, NULL, 'G3DSA:3.30.200.20:FF:002044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33266, NULL, 'G3DSA:1.10.220.150:FF:000059', NULL, NULL, 'Centaurin gamma, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33267, NULL, 'G3DSA:1.25.70.10:FF:000018', NULL, NULL, 'Transcription termination factor MTEF18, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(33268, NULL, 'G3DSA:2.120.10.80:FF:000011', NULL, NULL, 'Kelch like family member 12', NULL, NULL, NULL, NULL, NULL, 4),
(33269, NULL, 'G3DSA:4.10.1000.10:FF:000157', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(33270, NULL, 'G3DSA:1.20.140.100:FF:000023', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(33271, NULL, 'G3DSA:1.20.58.830:FF:000031', NULL, NULL, 'Duffy binding-like merozoite surface protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(33272, NULL, 'G3DSA:3.40.50.1820:FF:001164', NULL, NULL, 'Acyl-CoA thioesterase 16', NULL, NULL, NULL, NULL, NULL, 4),
(33273, NULL, 'G3DSA:3.50.7.10:FF:000075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33274, NULL, 'G3DSA:1.20.1270.60:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33275, NULL, 'G3DSA:2.40.50.140:FF:000491', NULL, NULL, 'S1 RNA-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(33276, NULL, 'G3DSA:1.20.1250.20:FF:000807', NULL, NULL, 'MFS family major facilitator transporter', NULL, NULL, NULL, NULL, NULL, 4),
(33277, NULL, 'G3DSA:2.30.30.140:FF:000236', NULL, NULL, 'Tudor domain-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(33278, NULL, 'G3DSA:1.10.10.1290:FF:000001', NULL, NULL, 'DELLA protein GAI', NULL, NULL, NULL, NULL, NULL, 4),
(33279, NULL, 'G3DSA:2.130.10.10:FF:003980', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33280, NULL, 'G3DSA:3.40.50.2300:FF:001218', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33281, NULL, 'G3DSA:3.40.50.720:FF:001324', NULL, NULL, 'NAD dependent epimerase/dehydratase family', NULL, NULL, NULL, NULL, NULL, 4),
(33282, NULL, 'G3DSA:3.40.190.10:FF:000457', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(33283, NULL, 'G3DSA:4.10.410.10:FF:000107', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(33284, NULL, 'G3DSA:3.30.200.20:FF:002499', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33285, NULL, 'G3DSA:2.40.340.10:FF:000001', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(33286, NULL, 'G3DSA:2.10.90.10:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33287, NULL, 'G3DSA:3.30.160.60:FF:004570', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33288, NULL, 'G3DSA:2.80.10.50:FF:000212', NULL, NULL, 'Interleukin-1 alpha', NULL, NULL, NULL, NULL, NULL, 4),
(33289, NULL, 'G3DSA:1.20.1250.20:FF:001898', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33290, NULL, 'G3DSA:1.25.10.10:FF:001650', NULL, NULL, 'Cilia and flagella associated protein 69', NULL, NULL, NULL, NULL, NULL, 4),
(33291, NULL, 'G3DSA:3.30.40.10:FF:001904', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33292, NULL, 'G3DSA:2.60.40.10:FF:001276', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(33293, NULL, 'G3DSA:2.60.40.10:FF:000450', NULL, NULL, 'Neural cell adhesion molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(33294, NULL, 'G3DSA:2.130.10.10:FF:005306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33295, NULL, 'G3DSA:3.20.80.10:FF:000047', NULL, NULL, 'Heme-binding-like protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(33296, NULL, 'G3DSA:3.40.50.620:FF:000586', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33297, NULL, 'G3DSA:1.20.120.1910:FF:000029', NULL, NULL, 'Cysteinyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(33298, NULL, 'G3DSA:3.40.250.10:FF:000136', NULL, NULL, 'Probable rhodanese domain-containing dual specificity protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(33299, NULL, 'G3DSA:1.25.40.20:FF:000519', NULL, NULL, 'Phosphate metabolism-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(33300, NULL, 'G3DSA:1.25.40.20:FF:001155', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(33301, NULL, 'G3DSA:3.40.50.300:FF:006105', NULL, NULL, 'Dynamin 2', NULL, NULL, NULL, NULL, NULL, 4),
(33302, NULL, 'G3DSA:2.40.50.140:FF:001137', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33303, NULL, 'G3DSA:3.40.33.10:FF:000207', NULL, NULL, 'Protein CBR-SCL-22', NULL, NULL, NULL, NULL, NULL, 4),
(33304, NULL, 'G3DSA:1.25.10.10:FF:000026', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(33305, NULL, 'G3DSA:4.10.1000.10:FF:000096', NULL, NULL, 'Zinc finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(33306, NULL, 'G3DSA:3.40.50.2060:FF:000011', NULL, NULL, 'SLY1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(33307, NULL, 'G3DSA:1.10.10.650:FF:000022', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(33308, NULL, 'G3DSA:3.40.50.720:FF:000368', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(33309, NULL, 'G3DSA:3.10.20.90:FF:000129', NULL, NULL, 'E3 ubiquitin-protein ligase MYLIP isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(33310, NULL, 'G3DSA:1.10.238.10:FF:000965', NULL, NULL, 'Os04g0681500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(33311, NULL, 'G3DSA:3.40.250.10:FF:000075', NULL, NULL, 'Rhodanese-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(33312, NULL, 'G3DSA:3.30.250.20:FF:000001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33313, NULL, 'G3DSA:2.60.40.10:FF:005121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33314, NULL, 'G3DSA:2.40.50.770:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33315, NULL, 'G3DSA:1.10.510.10:FF:002543', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33316, NULL, 'G3DSA:1.10.10.60:FF:000872', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33317, NULL, 'G3DSA:1.20.1250.20:FF:001443', NULL, NULL, 'MFS sugar transporte, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33318, NULL, 'G3DSA:1.20.58.80:FF:000083', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(33319, NULL, 'G3DSA:2.60.220.50:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33320, NULL, 'G3DSA:3.30.230.10:FF:000418', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(33321, NULL, 'G3DSA:3.40.50.1820:FF:000528', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33322, NULL, 'G3DSA:3.30.420.10:FF:000253', NULL, NULL, 'Os01g0566000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(33323, NULL, 'G3DSA:2.130.10.10:FF:000883', NULL, NULL, 'Putative acyl-activating enzyme 19', NULL, NULL, NULL, NULL, NULL, 4),
(33324, NULL, 'G3DSA:1.10.510.10:FF:000082', NULL, NULL, 'Shaggy-related protein kinase kappa', NULL, NULL, NULL, NULL, NULL, 4),
(33325, NULL, 'G3DSA:2.130.10.10:FF:005615', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33326, NULL, 'G3DSA:3.30.160.60:FF:006043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33327, NULL, 'G3DSA:3.30.30.170:FF:000005', NULL, NULL, 'Translation initiation factor 2 beta subunit putative', NULL, NULL, NULL, NULL, NULL, 4),
(33328, NULL, 'G3DSA:3.30.70.270:FF:000335', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33329, NULL, 'G3DSA:3.40.50.1820:FF:000984', NULL, NULL, 'Alpha/beta hydrolase family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33330, NULL, 'G3DSA:3.50.30.30:FF:000173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33331, NULL, 'G3DSA:1.20.1080.10:FF:000016', NULL, NULL, 'Aquaporin', NULL, NULL, NULL, NULL, NULL, 4),
(33332, NULL, 'G3DSA:1.20.1740.10:FF:000016', NULL, NULL, 'Inner membrane transporter YhaO', NULL, NULL, NULL, NULL, NULL, 4),
(33333, NULL, 'G3DSA:3.90.79.10:FF:000069', NULL, NULL, 'Mitochondrial ribosomal protein L46,putative', NULL, NULL, NULL, NULL, NULL, 4),
(33334, NULL, 'G3DSA:3.40.50.2000:FF:001089', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(33335, NULL, 'G3DSA:2.10.70.10:FF:000212', NULL, NULL, 'Complement component receptor 1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(33336, NULL, 'G3DSA:1.20.1420.30:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33337, NULL, 'G3DSA:3.40.50.300:FF:004840', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33338, NULL, 'G3DSA:3.40.1380.10:FF:000016', NULL, NULL, 'ATP synthase gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(33339, NULL, 'G3DSA:1.25.10.10:FF:003095', NULL, NULL, 'Dynein assembly factor 5, axonemal', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(33340, NULL, 'G3DSA:3.40.50.2300:FF:001561', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33341, NULL, 'G3DSA:1.25.10.10:FF:001307', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33342, NULL, 'G3DSA:3.40.30.10:FF:000173', NULL, NULL, 'Mitochondrial 54S ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(33343, NULL, 'G3DSA:1.25.40.10:FF:004232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33344, NULL, 'G3DSA:2.30.29.30:FF:000234', NULL, NULL, 'Pleckstrin homology (PH) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(33345, NULL, 'G3DSA:2.130.10.10:FF:003637', NULL, NULL, 'F-box/WD repeat-containing protein pof11', NULL, NULL, NULL, NULL, NULL, 4),
(33346, NULL, 'G3DSA:3.90.190.10:FF:000215', NULL, NULL, 'Tyrosine/serine protein phosphatase, putative (AFU_orthologue AFUA_6G06650)', NULL, NULL, NULL, NULL, NULL, 4),
(33347, NULL, 'G3DSA:3.40.30.10:FF:000509', NULL, NULL, 'Glutathione S-transferase alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(33348, NULL, 'G3DSA:1.25.40.500:FF:000007', NULL, NULL, 'TAF (TBP-associated transcription factor) family', NULL, NULL, NULL, NULL, NULL, 4),
(33349, NULL, 'G3DSA:2.40.30.320:FF:000001', NULL, NULL, 'Bride of doubletime', NULL, NULL, NULL, NULL, NULL, 4),
(33350, NULL, 'G3DSA:2.30.30.490:FF:000099', NULL, NULL, 'DNA (cytosine-5)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(33351, NULL, 'G3DSA:3.30.1330.30:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33352, NULL, 'G3DSA:1.10.8.270:FF:000045', NULL, NULL, 'GTPase-activating protein GYP5', NULL, NULL, NULL, NULL, NULL, 4),
(33353, NULL, 'G3DSA:3.40.50.10470:FF:000043', NULL, NULL, 'Methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(33354, NULL, 'G3DSA:3.10.110.10:FF:000341', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33355, NULL, 'G3DSA:3.30.70.1430:FF:000015', NULL, NULL, 'Probable Resistance-Nodulation-Cell Division (RND) efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(33356, NULL, 'G3DSA:3.40.50.10860:FF:000070', NULL, NULL, 'Pentafunctional AROM polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(33357, NULL, 'G3DSA:1.20.58.530:FF:000031', NULL, NULL, 'neither inactivation nor afterpotential protein C', NULL, NULL, NULL, NULL, NULL, 4),
(33358, NULL, 'G3DSA:3.40.50.1820:FF:000545', NULL, NULL, 'Protein phosphatase methylesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(33359, NULL, 'G3DSA:3.60.15.10:FF:000176', NULL, NULL, 'Beta-lactamase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(33360, NULL, 'G3DSA:3.30.160.20:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33361, NULL, 'G3DSA:3.40.50.1260:FF:000006', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(33362, NULL, 'G3DSA:3.30.40.10:FF:001112', NULL, NULL, 'CG1909, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(33363, NULL, 'G3DSA:3.20.20.20:FF:000030', NULL, NULL, 'Carbon-monoxide dehydrogenase delta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(33364, NULL, 'G3DSA:2.60.40.10:FF:005458', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33365, NULL, 'G3DSA:3.40.50.300:FF:005149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33366, NULL, 'G3DSA:3.40.50.1010:FF:000275', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33367, NULL, 'G3DSA:3.40.630.30:FF:000470', NULL, NULL, 'N-acetyltransferase, GNAT family', NULL, NULL, NULL, NULL, NULL, 4),
(33368, NULL, 'G3DSA:1.20.1070.10:FF:002168', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(33369, NULL, 'G3DSA:1.10.510.10:FF:000435', NULL, NULL, 'Nik-related protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(33370, NULL, 'G3DSA:1.25.40.10:FF:000781', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(33371, NULL, 'G3DSA:3.30.1180.20:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33372, NULL, 'G3DSA:2.60.40.10:FF:002232', NULL, NULL, 'Intercellular adhesion molecule 3', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(33373, NULL, 'G3DSA:3.40.50.300:FF:005588', NULL, NULL, 'NLR family CARD domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(33374, NULL, 'G3DSA:1.10.530.10:FF:000009', NULL, NULL, 'Lysozyme', NULL, NULL, NULL, NULL, NULL, 4),
(33375, NULL, 'G3DSA:1.25.40.120:FF:000005', NULL, NULL, 'Protein prenyltransferase alpha subunit repeat containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(33376, NULL, 'G3DSA:3.30.1510.10:FF:000001', NULL, NULL, 'Formate--tetrahydrofolate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(33377, NULL, 'G3DSA:3.60.21.10:FF:000117', NULL, NULL, 'Ser/Thr protein phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(33378, NULL, 'G3DSA:3.30.70.2450:FF:000001', NULL, NULL, '3-(3-hydroxy-phenyl)propionate/3-hydroxycinnamic acid hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(33379, NULL, 'G3DSA:1.10.287.70:FF:000096', NULL, NULL, 'polycystic kidney disease 2-like 2 protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(33380, NULL, 'G3DSA:1.10.3720.10:FF:000198', NULL, NULL, 'Riboflavin transport system permease protein RibX', NULL, NULL, NULL, NULL, NULL, 4),
(33381, NULL, 'G3DSA:3.40.50.2300:FF:000942', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33382, NULL, 'G3DSA:2.130.10.10:FF:003480', NULL, NULL, 'Intraflagellar transport protein 172', NULL, NULL, NULL, NULL, NULL, 4),
(33383, NULL, 'G3DSA:2.70.160.11:FF:000009', NULL, NULL, 'protein arginine N-methyltransferase 6', NULL, NULL, NULL, NULL, NULL, 4),
(33384, NULL, 'G3DSA:3.40.50.720:FF:000840', NULL, NULL, 'Zinc-binding dehydrogenase family oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(33385, NULL, 'G3DSA:1.10.238.10:FF:000173', NULL, NULL, 'uncharacterized TPR repeat-containing protein At1g05150-like', NULL, NULL, NULL, NULL, NULL, 4),
(33386, NULL, 'G3DSA:2.40.30.130:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33387, NULL, 'G3DSA:3.30.1490.10:FF:000004', NULL, NULL, 'Mitochondrial ribosomal protein S8', NULL, NULL, NULL, NULL, NULL, 4),
(33388, NULL, 'G3DSA:1.20.120.1080:FF:000140', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(33389, NULL, 'G3DSA:2.40.30.10:FF:000315', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(33390, NULL, 'G3DSA:3.10.50.40:FF:000066', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(33391, NULL, 'G3DSA:1.10.455.10:FF:000031', NULL, NULL, '40S ribosomal protein S5', NULL, NULL, NULL, NULL, NULL, 4),
(33392, NULL, 'G3DSA:2.130.10.10:FF:001580', NULL, NULL, 'Mitotic checkpoint protein bub-3', NULL, NULL, NULL, NULL, NULL, 4),
(33393, NULL, 'G3DSA:1.10.287.370:FF:000017', NULL, NULL, 'Prefoldin, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(33394, NULL, 'G3DSA:1.20.58.830:FF:000014', NULL, NULL, 'Antigen 332, DBL-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(33395, NULL, 'G3DSA:1.10.10.10:FF:001818', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33396, NULL, 'G3DSA:3.40.50.150:FF:000411', NULL, NULL, 'Mrm2p', NULL, NULL, NULL, NULL, NULL, 4),
(33397, NULL, 'G3DSA:3.30.2180.10:FF:000003', NULL, NULL, 'BnaC04g32790D protein', NULL, NULL, NULL, NULL, NULL, 4),
(33398, NULL, 'G3DSA:3.90.360.10:FF:000015', NULL, NULL, 'Chl-1', NULL, NULL, NULL, NULL, NULL, 4),
(33399, NULL, 'G3DSA:2.60.40.10:FF:004132', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33400, NULL, 'G3DSA:3.40.50.150:FF:001580', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33401, NULL, 'G3DSA:1.10.510.10:FF:001615', NULL, NULL, 'Serine/threonine-protein kinase TAO2', NULL, NULL, NULL, NULL, NULL, 4),
(33402, NULL, 'G3DSA:2.30.180.10:FF:000002', NULL, NULL, 'periostin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(33403, NULL, 'G3DSA:3.40.720.10:FF:000111', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(33404, NULL, 'G3DSA:3.10.105.10:FF:000082', NULL, NULL, 'ABC transporter, binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(33405, NULL, 'G3DSA:1.20.1280.50:FF:000178', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(33406, NULL, 'G3DSA:3.40.50.300:FF:002070', NULL, NULL, 'Uridine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(33407, NULL, 'G3DSA:3.40.50.410:FF:000186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33408, NULL, 'G3DSA:3.30.420.10:FF:000692', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33409, NULL, 'G3DSA:1.10.10.60:FF:000063', NULL, NULL, 'SIX homeobox 2', NULL, NULL, NULL, NULL, NULL, 4),
(33410, NULL, 'G3DSA:1.20.140.100:FF:000006', NULL, NULL, 'dynein heavy chain 2, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(33411, NULL, 'G3DSA:3.40.50.300:FF:006768', NULL, NULL, 'DNA repair DEAD helicase RAD3/XP-D subfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(33412, NULL, 'G3DSA:1.50.40.10:FF:000245', NULL, NULL, 'Mitochondrial RNA-splicing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33413, NULL, 'G3DSA:1.25.10.10:FF:001015', NULL, NULL, 'Anaphase-promoting complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(33414, NULL, 'G3DSA:1.10.1520.10:FF:000087', NULL, NULL, 'Endoribonuclease Dicer-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(33415, NULL, 'G3DSA:1.10.287.130:FF:000204', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(33416, NULL, 'G3DSA:3.40.50.720:FF:002285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33417, NULL, 'G3DSA:3.30.190.20:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33418, NULL, 'G3DSA:2.130.10.10:FF:000074', NULL, NULL, 'Angio-associated migratory cell protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(33419, NULL, 'G3DSA:3.40.50.300:FF:007274', NULL, NULL, 'Vasa protein isoform, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33420, NULL, 'G3DSA:3.80.10.10:FF:002159', NULL, NULL, 'F-box/LRR-repeat protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(33421, NULL, 'G3DSA:1.10.510.10:FF:004460', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33422, NULL, 'G3DSA:2.130.10.10:FF:002991', NULL, NULL, 'Dynein intermediate chain 2, ciliary-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(33423, NULL, 'G3DSA:2.60.40.10:FF:001259', NULL, NULL, 'Immunoglobulin heavy variable 13-2', NULL, NULL, NULL, NULL, NULL, 4),
(33424, NULL, 'G3DSA:3.30.200.20:FF:000127', NULL, NULL, 'Putative dual specificity tyrosine-phosphorylation-regulated kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(33425, NULL, 'G3DSA:1.25.40.10:FF:001135', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(33426, NULL, 'G3DSA:3.40.1280.10:FF:000115', NULL, NULL, 'tRNA (guanosine(18)-2''-O)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(33427, NULL, 'G3DSA:4.10.95.10:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33428, NULL, 'G3DSA:1.25.40.180:FF:000225', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33429, NULL, 'G3DSA:3.30.70.20:FF:000100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33430, NULL, 'G3DSA:3.30.710.10:FF:000028', NULL, NULL, 'POZ-, AT hook-, and zinc finger-containing protein 1 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(33431, NULL, 'G3DSA:1.10.565.10:FF:000022', NULL, NULL, 'Nuclear receptor subfamily 2 group E member 3', NULL, NULL, NULL, NULL, NULL, 4),
(33432, NULL, 'G3DSA:1.10.357.30:FF:000005', NULL, NULL, 'Exocyst complex component SEC15', NULL, NULL, NULL, NULL, NULL, 4),
(33433, NULL, 'G3DSA:1.10.472.10:FF:000200', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(33434, NULL, 'G3DSA:3.40.50.300:FF:008022', NULL, NULL, 'Multidrug resistance protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33435, NULL, 'G3DSA:3.30.1460.50:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33436, NULL, 'G3DSA:3.30.70.80:FF:000011', NULL, NULL, 'Vacuolar protease B', NULL, NULL, NULL, NULL, NULL, 4),
(33437, NULL, 'G3DSA:2.130.10.10:FF:005323', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33438, NULL, 'G3DSA:1.20.144.10:FF:000014', NULL, NULL, 'Phospholipid phosphatase-related protein type 3', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(33439, NULL, 'G3DSA:3.40.50.410:FF:000169', NULL, NULL, 'Collagen type VI alpha 3 chain', NULL, NULL, NULL, NULL, NULL, 4),
(33440, NULL, 'G3DSA:2.40.50.100:FF:000147', NULL, NULL, 'Sll0180 protein', NULL, NULL, NULL, NULL, NULL, 4),
(33441, NULL, 'G3DSA:3.10.100.10:FF:000104', NULL, NULL, 'CoLlagen with Endostatin domain', NULL, NULL, NULL, NULL, NULL, 4),
(33442, NULL, 'G3DSA:1.20.58.400:FF:000003', NULL, NULL, 'Vesicle transport through interaction with t-SNAREs homolog 1B', NULL, NULL, NULL, NULL, NULL, 4),
(33443, NULL, 'G3DSA:2.30.30.140:FF:000106', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(33444, NULL, 'G3DSA:2.20.100.10:FF:000117', NULL, NULL, 'Spondin-1', NULL, NULL, NULL, NULL, NULL, 4),
(33445, NULL, 'G3DSA:3.90.70.10:FF:000521', NULL, NULL, 'Flagellar associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(33446, NULL, 'G3DSA:1.10.510.10:FF:001054', NULL, NULL, 'Serine/threonine-protein kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(33447, NULL, 'G3DSA:1.25.40.20:FF:000183', NULL, NULL, 'ankyrin repeat domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(33448, NULL, 'G3DSA:3.90.640.10:FF:000161', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(33449, NULL, 'G3DSA:1.25.40.10:FF:002579', NULL, NULL, 'UTP6 small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4),
(33450, NULL, 'G3DSA:3.40.366.30:FF:000001', NULL, NULL, 'Cupin superfamily protein family', NULL, NULL, NULL, NULL, NULL, 4),
(33451, NULL, 'G3DSA:1.20.930.60:FF:000002', NULL, NULL, 'Protein-glutamate O-methyltransferase C1393.13', NULL, NULL, NULL, NULL, NULL, 4),
(33452, NULL, 'G3DSA:1.20.81.10:FF:000003', NULL, NULL, 'Alpha-2-macroglobulin receptor-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(33453, NULL, 'G3DSA:2.60.40.10:FF:000107', NULL, NULL, 'Myosin, light chain kinase a', NULL, NULL, NULL, NULL, NULL, 4),
(33454, NULL, 'G3DSA:2.40.10.10:FF:000432', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33455, NULL, 'G3DSA:3.60.20.10:FF:000126', NULL, NULL, 'Proteasome subunit alpha type', NULL, NULL, NULL, NULL, NULL, 4),
(33456, NULL, 'G3DSA:3.40.120.10:FF:000054', NULL, NULL, 'Phosphoacetylglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(33457, NULL, 'G3DSA:3.40.50.970:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33458, NULL, 'G3DSA:3.80.10.10:FF:001007', NULL, NULL, 'Si:dkey-32e6.6', NULL, NULL, NULL, NULL, NULL, 4),
(33459, NULL, 'G3DSA:1.10.510.10:FF:002560', NULL, NULL, 'AaceriABR088Cp', NULL, NULL, NULL, NULL, NULL, 4),
(33460, NULL, 'G3DSA:1.10.287.370:FF:000034', NULL, NULL, 'GM15993', NULL, NULL, NULL, NULL, NULL, 4),
(33461, NULL, 'G3DSA:3.40.50.300:FF:003351', NULL, NULL, 'Structural maintenance of chromosomes protein', NULL, NULL, NULL, NULL, NULL, 4),
(33462, NULL, 'G3DSA:3.40.50.10190:FF:000262', NULL, NULL, 'Chromatin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(33463, NULL, 'G3DSA:1.10.8.480:FF:000018', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(33464, NULL, 'G3DSA:3.40.1690.20:FF:000008', NULL, NULL, 'Yta12p', NULL, NULL, NULL, NULL, NULL, 4),
(33465, NULL, 'G3DSA:3.20.20.100:FF:000035', NULL, NULL, 'Aldehyde reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33466, NULL, 'G3DSA:1.20.1070.10:FF:000370', NULL, NULL, 'Neuropeptide receptor 15', NULL, NULL, NULL, NULL, NULL, 4),
(33467, NULL, 'G3DSA:3.40.50.1440:FF:000055', NULL, NULL, 'Protein ACCUMULATION AND REPLICATION OF CHLOROPLASTS 3', NULL, NULL, NULL, NULL, NULL, 4),
(33468, NULL, 'G3DSA:1.20.1560.10:FF:000727', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33469, NULL, 'G3DSA:3.80.10.10:FF:004413', NULL, NULL, 'Receptor like protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(33470, NULL, 'G3DSA:3.40.630.30:FF:000031', NULL, NULL, 'Glucosamine 6-phosphate N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(33471, NULL, 'G3DSA:2.60.120.200:FF:000483', NULL, NULL, 'Neurexin-1', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(33472, NULL, 'G3DSA:1.10.10.440:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33473, NULL, 'G3DSA:1.20.1270.60:FF:000225', NULL, NULL, 'YALI0F19778p', NULL, NULL, NULL, NULL, NULL, 4),
(33474, NULL, 'G3DSA:3.90.660.10:FF:000044', NULL, NULL, 'Peroxisomal n1-acetyl-spermine/spermidine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(33475, NULL, 'G3DSA:1.10.8.10:FF:000098', NULL, NULL, 'ATP-dependent protease ATPase subunit HslU', NULL, NULL, NULL, NULL, NULL, 4),
(33476, NULL, 'G3DSA:3.40.250.10:FF:000058', NULL, NULL, 'MercaptoPyruvate SulfurTransferase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(33477, NULL, 'G3DSA:2.60.40.10:FF:004002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33478, NULL, 'G3DSA:3.90.1200.10:FF:000037', NULL, NULL, 'Choline kinase', NULL, NULL, NULL, NULL, NULL, 4),
(33479, NULL, 'G3DSA:2.60.120.1180:FF:000001', NULL, NULL, 'VP16', NULL, NULL, NULL, NULL, NULL, 4),
(33480, NULL, 'G3DSA:3.40.50.300:FF:001917', NULL, NULL, 'Guanine nucleotide-binding protein alpha-13 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(33481, NULL, 'G3DSA:1.10.287.1040:FF:000017', NULL, NULL, 'Exodeoxyribonuclease 7 small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(33482, NULL, 'G3DSA:3.30.1370.10:FF:000012', NULL, NULL, 'Mex-3 RNA-binding family member D', NULL, NULL, NULL, NULL, NULL, 4),
(33483, NULL, 'G3DSA:1.20.900.10:FF:000064', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(33484, NULL, 'G3DSA:3.40.50.410:FF:000039', NULL, NULL, 'VWFA and cache domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(33485, NULL, 'G3DSA:1.10.110.10:FF:000017', NULL, NULL, '2S seed storage protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(33486, NULL, 'G3DSA:3.30.70.250:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33487, NULL, 'G3DSA:1.10.510.10:FF:003971', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33488, NULL, 'G3DSA:1.10.8.10:FF:000322', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(33489, NULL, 'G3DSA:2.60.40.10:FF:003204', NULL, NULL, 'Babos, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(33490, NULL, 'G3DSA:3.90.70.10:FF:000858', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 30', NULL, NULL, NULL, NULL, NULL, 4),
(33491, NULL, 'G3DSA:3.40.50.300:FF:002715', NULL, NULL, 'Pilus assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(33492, NULL, 'G3DSA:3.40.50.300:FF:002406', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33493, NULL, 'G3DSA:3.40.50.720:FF:001796', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33494, NULL, 'G3DSA:3.30.160.60:FF:004126', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33495, NULL, 'G3DSA:2.60.40.10:FF:003513', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33496, NULL, 'G3DSA:3.90.70.10:FF:000830', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33497, NULL, 'G3DSA:3.30.70.270:FF:000026', NULL, NULL, 'Transposon Ty3-G Gag-Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(33498, NULL, 'G3DSA:1.50.40.10:FF:000115', NULL, NULL, 'Mitochondrial arginine transporter BAC2', NULL, NULL, NULL, NULL, NULL, 4),
(33499, NULL, 'G3DSA:2.80.10.50:FF:000184', NULL, NULL, 'Fascin', NULL, NULL, NULL, NULL, NULL, 4),
(33500, NULL, 'G3DSA:1.20.1560.10:FF:000570', NULL, NULL, 'HAlF transporter (PGP related)', NULL, NULL, NULL, NULL, NULL, 4),
(33501, NULL, 'G3DSA:3.90.1150.10:FF:000156', NULL, NULL, 'Possible aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(33502, NULL, 'G3DSA:3.30.70.1230:FF:000219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33503, NULL, 'G3DSA:1.20.1070.10:FF:001196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33504, NULL, 'G3DSA:2.40.50.140:FF:000844', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33505, NULL, 'G3DSA:3.10.110.10:FF:000032', NULL, NULL, 'probable ubiquitin-conjugating enzyme E2 16', NULL, NULL, NULL, NULL, NULL, 4),
(33506, NULL, 'G3DSA:1.10.8.60:FF:000404', NULL, NULL, 'Spastin', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(33507, NULL, 'G3DSA:3.30.310.50:FF:000015', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(33508, NULL, 'G3DSA:2.30.29.30:FF:001162', NULL, NULL, 'Division mal foutue 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(33509, NULL, 'G3DSA:3.30.70.2150:FF:000001', NULL, NULL, 'GlcNAc-binding protein A', NULL, NULL, NULL, NULL, NULL, 4),
(33510, NULL, 'G3DSA:2.60.120.260:FF:000585', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33511, NULL, 'G3DSA:3.30.360.10:FF:000102', NULL, NULL, 'Similar to Oxidoreductase family', NULL, NULL, NULL, NULL, NULL, 4),
(33512, NULL, 'G3DSA:1.20.58.1070:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33513, NULL, 'G3DSA:2.10.70.60:FF:000002', NULL, NULL, 'Putative phospholipase B-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(33514, NULL, 'G3DSA:2.10.70.80:FF:000008', NULL, NULL, 'VPS10 homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(33515, NULL, 'G3DSA:3.80.10.10:FF:002968', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33516, NULL, 'G3DSA:3.30.450.60:FF:000085', NULL, NULL, 'Signal recognition particle receptor subunit alpha homolog', NULL, NULL, NULL, NULL, NULL, 4),
(33517, NULL, 'G3DSA:1.20.5.490:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33518, NULL, 'G3DSA:3.10.50.10:FF:000068', NULL, NULL, 'Class V chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33519, NULL, 'G3DSA:1.10.555.10:FF:000196', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33520, NULL, 'G3DSA:3.30.70.1070:FF:000020', NULL, NULL, 'Peptidoglycan L,D-transpeptidase lipoprotein, YkuD family, SPOR domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(33521, NULL, 'G3DSA:2.130.10.10:FF:003036', NULL, NULL, 'Coatomer beta'' subunit', NULL, NULL, NULL, NULL, NULL, 4),
(33522, NULL, 'G3DSA:1.10.510.10:FF:004016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33523, NULL, 'G3DSA:2.170.270.10:FF:000009', NULL, NULL, 'SET domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(33524, NULL, 'G3DSA:3.50.30.30:FF:000043', NULL, NULL, 'E3 ubiquitin-protein ligase RNF130', NULL, NULL, NULL, NULL, NULL, 4),
(33525, NULL, 'G3DSA:1.20.1560.10:FF:000126', NULL, NULL, 'Putative ABC transporter B family member 8', NULL, NULL, NULL, NULL, NULL, 4),
(33526, NULL, 'G3DSA:2.60.40.2160:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33527, NULL, 'G3DSA:1.10.287.130:FF:000221', NULL, NULL, 'Two-component system sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(33528, NULL, 'G3DSA:3.30.430.20:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33529, NULL, 'G3DSA:2.60.420.10:FF:000003', NULL, NULL, 'Protein-glucosylgalactosylhydroxylysine glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(33530, NULL, 'G3DSA:1.10.1420.10:FF:000023', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(33531, NULL, 'G3DSA:3.90.190.10:FF:000524', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(33532, NULL, 'G3DSA:1.20.5.440:FF:000004', NULL, NULL, 'Stomatal closure-related actin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(33533, NULL, 'G3DSA:3.30.420.280:FF:000002', NULL, NULL, 'Terminase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(33534, NULL, 'G3DSA:2.30.30.40:FF:000499', NULL, NULL, 'BAR domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(33535, NULL, 'G3DSA:3.30.70.560:FF:000006', NULL, NULL, 'Folic acid synthesis protein fol1', NULL, NULL, NULL, NULL, NULL, 4),
(33536, NULL, 'G3DSA:2.60.40.200:FF:000036', NULL, NULL, 'Superoxide dismutase [cu-zn], putative', NULL, NULL, NULL, NULL, NULL, 4),
(33537, NULL, 'G3DSA:1.20.1090.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33538, NULL, 'G3DSA:3.40.50.1100:FF:000122', NULL, NULL, 'Cysteine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(33539, NULL, 'G3DSA:3.40.50.1000:FF:000390', NULL, NULL, 'Phosphoserine phosphatase (SerB)', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(33540, NULL, 'G3DSA:2.130.10.10:FF:002417', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33541, NULL, 'G3DSA:2.10.25.10:FF:000506', NULL, NULL, 'Adhesion G protein-coupled receptor E1', NULL, NULL, NULL, NULL, NULL, 4),
(33542, NULL, 'G3DSA:1.20.1560.10:FF:000699', NULL, NULL, 'ABC transporter related', NULL, NULL, NULL, NULL, NULL, 4),
(33543, NULL, 'G3DSA:3.30.200.20:FF:001555', NULL, NULL, 'Serine/threonine-protein kinase mos', NULL, NULL, NULL, NULL, NULL, 4),
(33544, NULL, 'G3DSA:3.30.310.10:FF:000054', NULL, NULL, 'TATA-box-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(33545, NULL, 'G3DSA:3.30.1370.10:FF:000057', NULL, NULL, 'High density lipoprotein binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(33546, NULL, 'G3DSA:3.30.70.330:FF:001803', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33547, NULL, 'G3DSA:3.40.50.300:FF:007066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33548, NULL, 'G3DSA:3.40.50.620:FF:000664', NULL, NULL, 'Valyl-tRNA synthetase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(33549, NULL, 'G3DSA:3.20.20.80:FF:000250', NULL, NULL, 'Probable di-N-acetylchitobiase 1', NULL, NULL, NULL, NULL, NULL, 4),
(33550, NULL, 'G3DSA:3.30.40.10:FF:000623', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(33551, NULL, 'G3DSA:2.20.28.230:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33552, NULL, 'G3DSA:1.20.58.1020:FF:000007', NULL, NULL, 'DNA replication complex GINS protein PSF2', NULL, NULL, NULL, NULL, NULL, 4),
(33553, NULL, 'G3DSA:1.10.1060.10:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33554, NULL, 'G3DSA:3.40.850.10:FF:000356', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33555, NULL, 'G3DSA:2.10.25.10:FF:001125', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(33556, NULL, 'G3DSA:3.90.260.10:FF:000070', NULL, NULL, 'Chromosome 15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(33557, NULL, 'G3DSA:2.60.120.260:FF:000113', NULL, NULL, 'Conserved transmembrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(33558, NULL, 'G3DSA:3.90.70.10:FF:000066', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 37', NULL, NULL, NULL, NULL, NULL, 4),
(33559, NULL, 'G3DSA:1.20.1110.10:FF:000087', NULL, NULL, 'Na+\K+ ATPase alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33560, NULL, 'G3DSA:1.20.1070.10:FF:000162', NULL, NULL, 'Muscarinic acetylcholine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(33561, NULL, 'G3DSA:2.60.120.290:FF:000009', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(33562, NULL, 'G3DSA:1.10.1450.10:FF:000103', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(33563, NULL, 'G3DSA:3.40.50.300:FF:004531', NULL, NULL, 'F10O3.15 protein', NULL, NULL, NULL, NULL, NULL, 4),
(33564, NULL, 'G3DSA:1.25.40.10:FF:003743', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33565, NULL, 'G3DSA:3.30.360.10:FF:000001', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(33566, NULL, 'G3DSA:1.10.10.10:FF:000407', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(33567, NULL, 'G3DSA:3.50.50.60:FF:000969', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33568, NULL, 'G3DSA:3.10.330.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33569, NULL, 'G3DSA:1.20.120.1380:FF:000005', NULL, NULL, 'Flagellar biosynthesis regulator FlhF', NULL, NULL, NULL, NULL, NULL, 4),
(33570, NULL, 'G3DSA:3.30.420.80:FF:000004', NULL, NULL, '30S ribosomal protein S11', NULL, NULL, NULL, NULL, NULL, 4),
(33571, NULL, 'G3DSA:1.10.510.10:FF:003869', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33572, NULL, 'G3DSA:3.30.40.10:FF:000724', NULL, NULL, 'RING-H2 finger protein ATL56', NULL, NULL, NULL, NULL, NULL, 4),
(33573, NULL, 'G3DSA:2.130.10.10:FF:001271', NULL, NULL, 'Probable U3 small nucleolar RNA-associated protein 7', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(33574, NULL, 'G3DSA:3.30.830.10:FF:000155', NULL, NULL, 'Metalloenzyme, LuxS/M16 peptidase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(33575, NULL, 'G3DSA:3.80.10.10:FF:000506', NULL, NULL, 'F-box/LRR-repeat protein 16 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(33576, NULL, 'G3DSA:3.30.160.60:FF:004598', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33577, NULL, 'G3DSA:2.10.25.10:FF:000361', NULL, NULL, 'von Willebrand factor C and EGF domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(33578, NULL, 'G3DSA:3.40.1110.10:FF:000457', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33579, NULL, 'G3DSA:3.30.530.20:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33580, NULL, 'G3DSA:3.30.160.60:FF:000899', NULL, NULL, 'zinc finger protein 558 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(33581, NULL, 'G3DSA:1.10.630.10:FF:000270', NULL, NULL, 'Fatty acid alpha hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(33582, NULL, 'G3DSA:3.10.280.10:FF:000027', NULL, NULL, 'Uncharacterized protein At2g39790, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(33583, NULL, 'G3DSA:1.20.120.160:FF:000014', NULL, NULL, 'Chemotaxis protein CheA', NULL, NULL, NULL, NULL, NULL, 4),
(33584, NULL, 'G3DSA:3.40.640.10:FF:000447', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33585, NULL, 'G3DSA:3.40.50.12780:FF:000106', NULL, NULL, 'Putative fatty-acid--CoA ligase fadD11', NULL, NULL, NULL, NULL, NULL, 4),
(33586, NULL, 'G3DSA:1.20.1560.10:FF:000227', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(33587, NULL, 'G3DSA:1.10.1050.10:FF:000011', NULL, NULL, '37S ribosomal protein S4-like, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(33588, NULL, 'G3DSA:3.80.10.10:FF:003115', NULL, NULL, 'Tropomodulin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33589, NULL, 'G3DSA:3.40.50.10860:FF:000053', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(33590, NULL, 'G3DSA:2.10.50.40:FF:000001', NULL, NULL, 'Protein DBF4 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(33591, NULL, 'G3DSA:1.20.1280.50:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33592, NULL, 'G3DSA:3.80.10.10:FF:004205', NULL, NULL, 'Immunoglobulin superfamily, member 10', NULL, NULL, NULL, NULL, NULL, 4),
(33593, NULL, 'G3DSA:3.40.50.300:FF:008230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33594, NULL, 'G3DSA:1.25.10.10:FF:002870', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33595, NULL, 'G3DSA:3.30.457.60:FF:000004', NULL, NULL, 'Mitotic spindle checkpoint protein MAD1', NULL, NULL, NULL, NULL, NULL, 4),
(33596, NULL, 'G3DSA:3.30.160.60:FF:005115', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33597, NULL, 'G3DSA:2.60.40.10:FF:004957', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33598, NULL, 'G3DSA:1.10.10.2120:FF:000003', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(33599, NULL, 'G3DSA:1.10.12.10:FF:000024', NULL, NULL, 'Putative enoyl-CoA hydratase ECHA1', NULL, NULL, NULL, NULL, NULL, 4),
(33600, NULL, 'G3DSA:3.40.47.10:FF:000020', NULL, NULL, 'Putative trifunctional enzyme subunit beta mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(33601, NULL, 'G3DSA:1.10.418.10:FF:000030', NULL, NULL, 'Related to alpha-actinin', NULL, NULL, NULL, NULL, NULL, 4),
(33602, NULL, 'G3DSA:3.40.50.150:FF:000383', NULL, NULL, 'Leucine carboxyl methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(33603, NULL, 'G3DSA:1.10.287.10:FF:000022', NULL, NULL, 'Glycine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(33604, NULL, 'G3DSA:3.70.10.10:FF:000131', NULL, NULL, 'Checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(33605, NULL, 'G3DSA:1.10.10.990:FF:000006', NULL, NULL, 'RecBCD enzyme subunit RecC', NULL, NULL, NULL, NULL, NULL, 4),
(33606, NULL, 'G3DSA:1.10.510.10:FF:000418', NULL, NULL, 'PTEN induced kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(33607, NULL, 'G3DSA:3.40.50.1820:FF:000192', NULL, NULL, 'Caffeoylshikimate esterase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(33608, NULL, 'G3DSA:3.30.70.330:FF:001258', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(33609, NULL, 'G3DSA:3.90.1150.10:FF:000364', NULL, NULL, 'Erythromycin biosynthesis sensory transduction protein eryC1', NULL, NULL, NULL, NULL, NULL, 4),
(33610, NULL, 'G3DSA:3.40.50.10980:FF:000004', NULL, NULL, 'LD44438p', NULL, NULL, NULL, NULL, NULL, 4),
(33611, NULL, 'G3DSA:1.25.10.10:FF:003123', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(33612, NULL, 'G3DSA:3.40.50.720:FF:001015', NULL, NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(33613, NULL, 'G3DSA:3.40.50.740:FF:000037', NULL, NULL, 'NADH-quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(33614, NULL, 'G3DSA:3.40.50.150:FF:000074', NULL, NULL, 'Cyclopropane-fatty-acyl-phospholipid synthase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(33615, NULL, 'G3DSA:3.10.110.10:FF:000133', NULL, NULL, 'Putative ubiquitin-conjugating enzyme E2 38', NULL, NULL, NULL, NULL, NULL, 4),
(33616, NULL, 'G3DSA:4.10.1250.10:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33617, NULL, 'G3DSA:2.60.40.10:FF:005430', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33618, NULL, 'G3DSA:3.90.79.10:FF:000041', NULL, NULL, 'Dihydroneopterin triphosphate pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(33619, NULL, 'G3DSA:3.30.70.330:FF:000847', NULL, NULL, 'Os05g0223300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(33620, NULL, 'G3DSA:3.30.160.60:FF:003833', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33621, NULL, 'G3DSA:3.30.40.10:FF:001343', NULL, NULL, 'PHD finger family', NULL, NULL, NULL, NULL, NULL, 4),
(33622, NULL, 'G3DSA:1.20.1740.10:FF:000224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33623, NULL, 'G3DSA:1.10.238.10:FF:000510', NULL, NULL, 'Protein CBG14543', NULL, NULL, NULL, NULL, NULL, 4),
(33624, NULL, 'G3DSA:3.30.160.60:FF:001164', NULL, NULL, 'C2H2 finger domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33625, NULL, 'G3DSA:1.25.40.10:FF:002107', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(33626, NULL, 'G3DSA:3.80.10.10:FF:003688', NULL, NULL, 'Probable disease resistance protein At5g45510', NULL, NULL, NULL, NULL, NULL, 4),
(33627, NULL, 'G3DSA:3.30.160.60:FF:002136', NULL, NULL, 'Zinc finger protein 721', NULL, NULL, NULL, NULL, NULL, 4),
(33628, NULL, 'G3DSA:3.30.930.10:FF:000011', NULL, NULL, 'Alanine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(33629, NULL, 'G3DSA:3.60.21.10:FF:000460', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33630, NULL, 'G3DSA:3.90.190.10:FF:000199', NULL, NULL, 'Dual specificity protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33631, NULL, 'G3DSA:2.170.270.10:FF:000217', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(33632, NULL, 'G3DSA:3.80.10.10:FF:000153', NULL, NULL, 'centriolin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(33633, NULL, 'G3DSA:2.130.10.10:FF:004817', NULL, NULL, 'WD repeat-containing protein JIP5', NULL, NULL, NULL, NULL, NULL, 4),
(33634, NULL, 'G3DSA:3.30.70.330:FF:002995', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33635, NULL, 'G3DSA:2.60.40.150:FF:000594', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33636, NULL, 'G3DSA:3.40.50.12780:FF:000207', NULL, NULL, 'Probable auxin-responsive-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(33637, NULL, 'G3DSA:3.80.10.10:FF:003379', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33638, NULL, 'G3DSA:3.40.50.2000:FF:000280', NULL, NULL, 'ADP-heptose:LPS heptosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(33639, NULL, 'G3DSA:1.10.580.10:FF:000029', NULL, NULL, 'Citrate synthase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(33640, NULL, 'G3DSA:3.40.850.10:FF:000148', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(33641, NULL, 'G3DSA:3.30.200.20:FF:001347', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(33642, NULL, 'G3DSA:1.10.10.10:FF:001835', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33643, NULL, 'G3DSA:3.40.50.80:FF:000149', NULL, NULL, 'NADPH-dependent diflavin oxidoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(33644, NULL, 'G3DSA:3.40.50.200:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33645, NULL, 'G3DSA:3.40.850.10:FF:000457', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(33646, NULL, 'G3DSA:3.40.605.10:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33647, NULL, 'G3DSA:3.40.50.300:FF:005357', NULL, NULL, 'Preprotein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(33648, NULL, 'G3DSA:3.30.200.20:FF:001190', NULL, NULL, 'Interleukin-1 receptor-associated kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(33649, NULL, 'G3DSA:1.10.1600.10:FF:000020', NULL, NULL, 'Potential Ku DNA binding protein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(33650, NULL, 'G3DSA:3.30.10.10:FF:000003', NULL, NULL, 'Serine protease inhibitor, potato inhibitor I-type family protein', NULL, NULL, NULL, NULL, NULL, 4),
(33651, NULL, 'G3DSA:3.40.50.620:FF:000456', NULL, NULL, 'Probable tRNA sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(33652, NULL, 'G3DSA:1.25.40.180:FF:000080', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(33653, NULL, 'G3DSA:3.40.50.1820:FF:000776', NULL, NULL, 'Endo-1,4-beta-xylanase Z', NULL, NULL, NULL, NULL, NULL, 4),
(33654, NULL, 'G3DSA:1.10.287.130:FF:000013', NULL, NULL, 'Sensor histidine kinase PhoQ', NULL, NULL, NULL, NULL, NULL, 4),
(33655, NULL, 'G3DSA:3.40.50.12780:FF:000095', NULL, NULL, 'Acyl-activating enzyme 15', NULL, NULL, NULL, NULL, NULL, 4),
(33656, NULL, 'G3DSA:1.20.1070.10:FF:000971', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(33657, NULL, 'G3DSA:1.20.1280.290:FF:000028', NULL, NULL, 'Vacuolar membrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33658, NULL, 'G3DSA:2.60.120.200:FF:000466', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33659, NULL, 'G3DSA:3.30.160.60:FF:001063', NULL, NULL, 'zinc finger protein 746 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(33660, NULL, 'G3DSA:3.40.30.10:FF:000234', NULL, NULL, 'Thioredoxin-like 4, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(33661, NULL, 'G3DSA:3.30.70.141:FF:000005', NULL, NULL, 'Nucleoside diphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(33662, NULL, 'G3DSA:3.40.640.10:FF:000402', NULL, NULL, 'Uncharacterized aminotransferase C1771.03c', NULL, NULL, NULL, NULL, NULL, 4),
(33663, NULL, 'G3DSA:2.40.40.20:FF:000015', NULL, NULL, 'spermatogenesis-associated protein 5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(33664, NULL, 'G3DSA:3.40.50.2000:FF:000381', NULL, NULL, 'Alpha,alpha-trehalose-phosphate synthase [UDP-forming], putative', NULL, NULL, NULL, NULL, NULL, 4),
(33665, NULL, 'G3DSA:3.40.50.720:FF:001116', NULL, NULL, '2-hydroxyacid dehydrogenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(33666, NULL, 'G3DSA:3.90.1170.40:FF:000014', NULL, NULL, 'Molybdopterin synthase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(33667, NULL, 'G3DSA:1.25.40.10:FF:001270', NULL, NULL, 'Protein NPG1', NULL, NULL, NULL, NULL, NULL, 4),
(33668, NULL, 'G3DSA:2.60.40.10:FF:005885', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33669, NULL, 'G3DSA:1.10.10.10:FF:001127', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(33670, NULL, 'G3DSA:1.10.238.10:FF:000201', NULL, NULL, 'Spectrin alpha chain, erythrocytic 1', NULL, NULL, NULL, NULL, NULL, 4),
(33671, NULL, 'G3DSA:3.30.260.10:FF:000038', NULL, NULL, 'Thermosome subunit', NULL, NULL, NULL, NULL, NULL, 4),
(33672, NULL, 'G3DSA:2.160.20.10:FF:000096', NULL, NULL, 'Exopolygalacturonase clone GBGE184', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(33673, NULL, 'G3DSA:3.30.160.60:FF:003772', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33674, NULL, 'G3DSA:4.10.400.10:FF:000152', NULL, NULL, 'Transmembrane protease serine 2', NULL, NULL, NULL, NULL, NULL, 4),
(33675, NULL, 'G3DSA:2.130.10.10:FF:005554', NULL, NULL, 'Protein CBG03541', NULL, NULL, NULL, NULL, NULL, 4),
(33676, NULL, 'G3DSA:2.10.25.10:FF:001333', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(33677, NULL, 'G3DSA:2.60.40.10:FF:003176', NULL, NULL, 'Tenascin C', NULL, NULL, NULL, NULL, NULL, 4),
(33678, NULL, 'G3DSA:2.60.120.200:FF:000511', NULL, NULL, 'Bacillopeptidase F', NULL, NULL, NULL, NULL, NULL, 4),
(33679, NULL, 'G3DSA:3.30.110.120:FF:000002', NULL, NULL, 'Acylphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(33680, NULL, 'G3DSA:2.40.50.140:FF:000389', NULL, NULL, 'RIM1p ssDNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(33681, NULL, 'G3DSA:3.90.180.10:FF:000125', NULL, NULL, 'Putative mannitol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(33682, NULL, 'G3DSA:3.80.10.10:FF:003587', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33683, NULL, 'G3DSA:3.40.50.300:FF:006869', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33684, NULL, 'G3DSA:4.10.240.10:FF:000150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33685, NULL, 'G3DSA:3.40.50.1000:FF:000081', NULL, NULL, 'Haloacid dehalogenase like hydrolase domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(33686, NULL, 'G3DSA:2.130.10.10:FF:002209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33687, NULL, 'G3DSA:1.10.565.10:FF:000005', NULL, NULL, 'Nuclear orphan receptor ROR-beta', NULL, NULL, NULL, NULL, NULL, 4),
(33688, NULL, 'G3DSA:1.25.40.10:FF:004041', NULL, NULL, 'Os05g0418500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(33689, NULL, 'G3DSA:2.30.29.30:FF:000689', NULL, NULL, 'RIKEN cDNA 1700003H04 gene', NULL, NULL, NULL, NULL, NULL, 4),
(33690, NULL, 'G3DSA:3.80.10.10:FF:000714', NULL, NULL, 'Si:ch211-149a19.3', NULL, NULL, NULL, NULL, NULL, 4),
(33691, NULL, 'G3DSA:3.30.230.10:FF:000109', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(33692, NULL, 'G3DSA:3.20.20.70:FF:000612', NULL, NULL, 'tRNA-dihydrouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(33693, NULL, 'G3DSA:2.10.70.10:FF:000257', NULL, NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(33694, NULL, 'G3DSA:1.20.5.1190:FF:000013', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(33695, NULL, 'G3DSA:2.120.10.80:FF:000275', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(33696, NULL, 'G3DSA:1.20.58.100:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33697, NULL, 'G3DSA:3.40.50.1000:FF:000401', NULL, NULL, 'HAD-IIB family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(33698, NULL, 'G3DSA:3.30.160.60:FF:001372', NULL, NULL, 'zinc finger protein 333 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(33699, NULL, 'G3DSA:3.30.70.330:FF:000639', NULL, NULL, 'Trivet, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(33700, NULL, 'G3DSA:1.10.510.10:FF:001716', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(33701, NULL, 'G3DSA:3.30.9.10:FF:000135', NULL, NULL, 'Conserved within P. aerophilum', NULL, NULL, NULL, NULL, NULL, 4),
(33702, NULL, 'G3DSA:1.10.510.10:FF:001407', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(33703, NULL, 'G3DSA:3.40.33.10:FF:000050', NULL, NULL, 'Venom allergen-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(33704, NULL, 'G3DSA:1.10.10.350:FF:000022', NULL, NULL, 'Glutamate--tRNA ligase 2', NULL, NULL, NULL, NULL, NULL, 4),
(33705, NULL, 'G3DSA:2.40.50.140:FF:000709', NULL, NULL, 'GD14384', NULL, NULL, NULL, NULL, NULL, 4),
(33706, NULL, 'G3DSA:2.30.42.10:FF:000091', NULL, NULL, 'disks large homolog 1 isoform X8', NULL, NULL, NULL, NULL, NULL, 4),
(33707, NULL, 'G3DSA:3.90.470.20:FF:000010', NULL, NULL, 'L-aminoadipate-semialdehyde dehydrogenase-phosphopantetheinyl transferase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(33708, NULL, 'G3DSA:1.10.238.10:FF:001027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33709, NULL, 'G3DSA:3.30.230.10:FF:000098', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(33710, NULL, 'G3DSA:1.20.1070.10:FF:000515', NULL, NULL, 'CholecystoKinin Receptor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(33711, NULL, 'G3DSA:3.30.70.330:FF:001466', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(33712, NULL, 'G3DSA:3.10.580.10:FF:000174', NULL, NULL, 'Voltage-gated chloride channel', NULL, NULL, NULL, NULL, NULL, 4),
(33713, NULL, 'G3DSA:4.10.280.10:FF:000164', NULL, NULL, 'Putative dna-binding protein inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(33714, NULL, 'G3DSA:6.10.250.3260:FF:000002', NULL, NULL, '60S ribosomal protein L21', NULL, NULL, NULL, NULL, NULL, 4),
(33715, NULL, 'G3DSA:3.80.10.10:FF:000462', NULL, NULL, 'centrosomal protein of 97 kDa isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(33716, NULL, 'G3DSA:3.60.60.10:FF:000027', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(33717, NULL, 'G3DSA:1.10.30.10:FF:000100', NULL, NULL, 'Sex-determining region Y protein', NULL, NULL, NULL, NULL, NULL, 4),
(33718, NULL, 'G3DSA:2.70.150.10:FF:000042', NULL, NULL, 'Plasma membrane ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(33719, NULL, 'G3DSA:3.30.160.60:FF:005981', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33720, NULL, 'G3DSA:3.60.21.10:FF:000252', NULL, NULL, 'Protein phosphatase 2B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33721, NULL, 'G3DSA:1.10.287.110:FF:000327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33722, NULL, 'G3DSA:3.80.10.10:FF:002862', NULL, NULL, 'P-granule-associated novel protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(33723, NULL, 'G3DSA:2.60.40.60:FF:000869', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33724, NULL, 'G3DSA:2.60.210.10:FF:000066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33725, NULL, 'G3DSA:2.60.40.150:FF:000094', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(33726, NULL, 'G3DSA:3.20.20.70:FF:000713', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33727, NULL, 'G3DSA:1.10.287.690:FF:000012', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(33728, NULL, 'G3DSA:3.30.2090.10:FF:000013', NULL, NULL, 'Probable RND efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(33729, NULL, 'G3DSA:1.25.40.10:FF:004816', NULL, NULL, 'Tetratricopeptide repeat domain 21A', NULL, NULL, NULL, NULL, NULL, 4),
(33730, NULL, 'G3DSA:3.40.190.10:FF:000665', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(33731, NULL, 'G3DSA:3.90.1420.10:FF:000003', NULL, NULL, 'Rubisco methyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(33732, NULL, 'G3DSA:2.130.10.30:FF:000158', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33733, NULL, 'G3DSA:2.130.10.10:FF:002108', NULL, NULL, 'F6N15.8 protein', NULL, NULL, NULL, NULL, NULL, 4),
(33734, NULL, 'G3DSA:3.80.10.10:FF:003896', NULL, NULL, 'Os12g0273900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(33735, NULL, 'G3DSA:3.30.160.60:FF:000444', NULL, NULL, 'Zinc finger protein 335', NULL, NULL, NULL, NULL, NULL, 4),
(33736, NULL, 'G3DSA:3.20.110.10:FF:000007', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(33737, NULL, 'G3DSA:3.30.160.60:FF:003625', NULL, NULL, 'AGAP002702-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(33738, NULL, 'G3DSA:3.80.10.10:FF:000962', NULL, NULL, 'RE09158p', NULL, NULL, NULL, NULL, NULL, 4),
(33739, NULL, 'G3DSA:2.40.33.10:FF:000013', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(33740, NULL, 'G3DSA:3.30.200.20:FF:001908', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33741, NULL, 'G3DSA:3.40.50.720:FF:002493', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33742, NULL, 'G3DSA:3.40.50.410:FF:000377', NULL, NULL, 'Calcium voltage-gated channel auxiliary subunit alpha2delta 3', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(33743, NULL, 'G3DSA:1.25.40.10:FF:002916', NULL, NULL, 'Pellicle/biofilm biosynthesis protein PelB', NULL, NULL, NULL, NULL, NULL, 4),
(33744, NULL, 'G3DSA:1.25.10.10:FF:000161', NULL, NULL, 'serine/threonine-protein phosphatase 4 regulatory subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(33745, NULL, 'G3DSA:2.170.300.10:FF:000007', NULL, NULL, 'multiple epidermal growth factor-like domains protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(33746, NULL, 'G3DSA:2.10.25.10:FF:001434', NULL, NULL, 'Multiple epidermal growth factor-like domains protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(33747, NULL, 'G3DSA:3.30.60.30:FF:000164', NULL, NULL, 'Agrin-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(33748, NULL, 'G3DSA:3.40.140.10:FF:000145', NULL, NULL, 'Probable inactive cytidine deaminase 4', NULL, NULL, NULL, NULL, NULL, 4),
(33749, NULL, 'G3DSA:3.30.70.330:FF:001567', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33750, NULL, 'G3DSA:2.60.34.10:FF:000065', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(33751, NULL, 'G3DSA:1.20.1070.10:FF:000471', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(33752, NULL, 'G3DSA:3.60.130.10:FF:000027', NULL, NULL, 'L-lysine 4-hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(33753, NULL, 'G3DSA:3.30.1600.10:FF:000019', NULL, NULL, 'NAD-dependent protein deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(33754, NULL, 'G3DSA:3.30.160.60:FF:001725', NULL, NULL, 'Zinc finger protein 808', NULL, NULL, NULL, NULL, NULL, 4),
(33755, NULL, 'G3DSA:3.30.460.10:FF:000019', NULL, NULL, 'tRNA nucleotidyltransferase cca2', NULL, NULL, NULL, NULL, NULL, 4),
(33756, NULL, 'G3DSA:3.30.470.20:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33757, NULL, 'G3DSA:2.130.10.10:FF:000411', NULL, NULL, 'U4/U6 small nuclear ribonucleoprotein Prp4', NULL, NULL, NULL, NULL, NULL, 4),
(33758, NULL, 'G3DSA:3.40.50.720:FF:001987', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(33759, NULL, 'G3DSA:3.40.50.300:FF:001889', NULL, NULL, 'DNA replication helicase/nuclease 2', NULL, NULL, NULL, NULL, NULL, 4),
(33760, NULL, 'G3DSA:3.40.50.2300:FF:001426', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33761, NULL, 'G3DSA:1.10.10.10:FF:001627', NULL, NULL, 'Transcriptional regulator, marR family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33762, NULL, 'G3DSA:3.80.10.10:FF:000815', NULL, NULL, 'serine/threonine-protein kinase BRI1-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(33763, NULL, 'G3DSA:3.30.70.330:FF:000286', NULL, NULL, 'Putative pre-mRNA branch site protein p14', NULL, NULL, NULL, NULL, NULL, 4),
(33764, NULL, 'G3DSA:2.30.42.10:FF:000309', NULL, NULL, 'Pro-apoptotic serine protease NMA111', NULL, NULL, NULL, NULL, NULL, 4),
(33765, NULL, 'G3DSA:1.10.630.10:FF:000692', NULL, NULL, 'Os06g0204100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(33766, NULL, 'G3DSA:2.130.10.10:FF:002783', NULL, NULL, 'WD repeat domain 44', NULL, NULL, NULL, NULL, NULL, 4),
(33767, NULL, 'G3DSA:3.30.420.210:FF:000009', NULL, NULL, 'Unplaced genomic scaffold supercont2.17, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(33768, NULL, 'G3DSA:3.40.30.10:FF:000026', NULL, NULL, 'Glutaredoxin 2', NULL, NULL, NULL, NULL, NULL, 4),
(33769, NULL, 'G3DSA:3.40.1180.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33770, NULL, 'G3DSA:2.30.29.30:FF:000998', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33771, NULL, 'G3DSA:3.40.50.720:FF:000498', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(33772, NULL, 'G3DSA:2.40.30.30:FF:000001', NULL, NULL, 'Riboflavin biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(33773, NULL, 'G3DSA:3.40.1690.10:FF:000017', NULL, NULL, 'Flagellar biosynthetic protein FlhB', NULL, NULL, NULL, NULL, NULL, 4),
(33774, NULL, 'G3DSA:2.30.29.30:FF:000897', NULL, NULL, 'Dynamin 2', NULL, NULL, NULL, NULL, NULL, 4),
(33775, NULL, 'G3DSA:1.50.10.140:FF:000001', NULL, NULL, 'Cyclic beta-1,2-glucan synthase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(33776, NULL, 'G3DSA:1.10.510.10:FF:001863', NULL, NULL, 'TUBE', NULL, NULL, NULL, NULL, NULL, 4),
(33777, NULL, 'G3DSA:1.25.10.10:FF:001442', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33778, NULL, 'G3DSA:3.40.1670.10:FF:000004', NULL, NULL, 'Ferulic acid decarboxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(33779, NULL, 'G3DSA:1.20.1070.10:FF:001696', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(33780, NULL, 'G3DSA:3.40.630.10:FF:000121', NULL, NULL, 'GPI transamidase component (GAA1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(33781, NULL, 'G3DSA:1.20.1560.10:FF:000935', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33782, NULL, 'G3DSA:2.60.40.10:FF:003985', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33783, NULL, 'G3DSA:2.40.50.150:FF:000038', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(33784, NULL, 'G3DSA:2.30.30.40:FF:000044', NULL, NULL, 'E3 ubiquitin-protein ligase MIB2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33785, NULL, 'G3DSA:4.10.410.10:FF:000079', NULL, NULL, 'Trypsin inhibitor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33786, NULL, 'G3DSA:1.20.58.390:FF:000062', NULL, NULL, 'Neurotransmitter-gated ion-channel transmembrane region', NULL, NULL, NULL, NULL, NULL, 4),
(33787, NULL, 'G3DSA:3.40.33.10:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33788, NULL, 'G3DSA:1.20.120.1770:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33789, NULL, 'G3DSA:3.40.50.150:FF:001355', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33790, NULL, 'G3DSA:3.30.460.10:FF:000166', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(33791, NULL, 'G3DSA:3.30.1370.110:FF:000010', NULL, NULL, 'Unplaced genomic scaffold supercont2.20, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(33792, NULL, 'G3DSA:1.10.565.10:FF:000213', NULL, NULL, 'Protein CBG13679', NULL, NULL, NULL, NULL, NULL, 4),
(33793, NULL, 'G3DSA:3.50.50.60:FF:001121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33794, NULL, 'G3DSA:2.30.29.30:FF:000425', NULL, NULL, 'mRNA-decapping enzyme 1B', NULL, NULL, NULL, NULL, NULL, 4),
(33795, NULL, 'G3DSA:1.25.10.10:FF:002976', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(33796, NULL, 'G3DSA:1.10.260.40:FF:000099', NULL, NULL, 'Predicted transcriptional regulator, XRE family', NULL, NULL, NULL, NULL, NULL, 4),
(33797, NULL, 'G3DSA:3.40.50.2300:FF:000717', NULL, NULL, 'TMAO reductase system periplasmic protein TorT', NULL, NULL, NULL, NULL, NULL, 4),
(33798, NULL, 'G3DSA:3.30.1360.120:FF:000051', NULL, NULL, 'Sarcosine oxidase, gamma subunit', NULL, NULL, NULL, NULL, NULL, 4),
(33799, NULL, 'G3DSA:1.25.70.10:FF:000035', NULL, NULL, 'Protein CBG19300', NULL, NULL, NULL, NULL, NULL, 4),
(33800, NULL, 'G3DSA:3.30.200.20:FF:001246', NULL, NULL, 'Large tumor suppressor kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(33801, NULL, 'G3DSA:1.10.20.10:FF:000127', NULL, NULL, 'Bip2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(33802, NULL, 'G3DSA:4.10.280.10:FF:000063', NULL, NULL, 'transcription factor HES-7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(33803, NULL, 'G3DSA:1.10.510.10:FF:003763', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33804, NULL, 'G3DSA:3.30.160.60:FF:001939', NULL, NULL, 'Zinc finger protein 551', NULL, NULL, NULL, NULL, NULL, 4),
(33805, NULL, 'G3DSA:3.30.1330.30:FF:000044', NULL, NULL, 'Apicoplast RNA methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33806, NULL, 'G3DSA:2.60.120.260:FF:000377', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33807, NULL, 'G3DSA:1.10.10.10:FF:000301', NULL, NULL, 'Homoprotocatechuate degradation operon regulator HpaR', NULL, NULL, NULL, NULL, NULL, 4),
(33808, NULL, 'G3DSA:3.50.50.60:FF:001430', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(33809, NULL, 'G3DSA:2.130.10.10:FF:003536', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(33810, NULL, 'G3DSA:1.10.150.240:FF:000030', NULL, NULL, 'HAD hydrolase, family IA, variant 3', NULL, NULL, NULL, NULL, NULL, 4),
(33811, NULL, 'G3DSA:3.40.1380.20:FF:000053', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(33812, NULL, 'G3DSA:3.40.50.1820:FF:001748', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33813, NULL, 'G3DSA:2.10.50.10:FF:000149', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 10B', NULL, NULL, NULL, NULL, NULL, 4),
(33814, NULL, 'G3DSA:1.20.58.60:FF:000442', NULL, NULL, 'Spectrin repeat containing, nuclear envelope 1a', NULL, NULL, NULL, NULL, NULL, 4),
(33815, NULL, 'G3DSA:3.40.50.11340:FF:000006', NULL, NULL, 'Galactoside 2-alpha-L-fucosyltransferase-like', NULL, NULL, NULL, NULL, NULL, 4),
(33816, NULL, 'G3DSA:2.60.40.10:FF:001068', NULL, NULL, 'interleukin-12 receptor subunit beta-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(33817, NULL, 'G3DSA:2.130.10.10:FF:002311', NULL, NULL, 'GD12443', NULL, NULL, NULL, NULL, NULL, 4),
(33818, NULL, 'G3DSA:3.40.50.300:FF:001417', NULL, NULL, 'DNA replication licensing factor MCM8', NULL, NULL, NULL, NULL, NULL, 4),
(33819, NULL, 'G3DSA:3.30.420.110:FF:000013', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(33820, NULL, 'G3DSA:1.20.1070.10:FF:000723', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33821, NULL, 'G3DSA:3.40.50.360:FF:000148', NULL, NULL, 'Oxygen-independent protoporphyrinogen oxidase HemG', NULL, NULL, NULL, NULL, NULL, 4),
(33822, NULL, 'G3DSA:1.25.10.10:FF:002151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33823, NULL, 'G3DSA:2.130.10.10:FF:003845', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33824, NULL, 'G3DSA:3.30.70.330:FF:002747', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33825, NULL, 'G3DSA:1.10.472.10:FF:000672', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33826, NULL, 'G3DSA:3.90.550.10:FF:000423', NULL, NULL, 'Procollagen-lysine,2-oxoglutarate 5-dioxygenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(33827, NULL, 'G3DSA:1.50.10.160:FF:000012', NULL, NULL, 'Ent-copalyl diphosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(33828, NULL, 'G3DSA:1.20.1250.20:FF:000937', NULL, NULL, 'Putative inorganic phosphate cotransporter-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(33829, NULL, 'G3DSA:2.10.25.10:FF:000714', NULL, NULL, 'Delta/notch like EGF repeat containing', NULL, NULL, NULL, NULL, NULL, 4),
(33830, NULL, 'G3DSA:3.40.1190.20:FF:000223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33831, NULL, 'G3DSA:1.10.3080.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33832, NULL, 'G3DSA:1.10.10.60:FF:000400', NULL, NULL, 'Orthopedia, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(33833, NULL, 'G3DSA:1.20.1250.20:FF:002371', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33834, NULL, 'G3DSA:1.25.10.10:FF:001751', NULL, NULL, 'Transportin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33835, NULL, 'G3DSA:3.30.420.510:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33836, NULL, 'G3DSA:3.90.1260.10:FF:000001', NULL, NULL, 'Argininosuccinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(33837, NULL, 'G3DSA:1.10.268.20:FF:000003', NULL, NULL, 'Dynamin family/50S ribosome-binding GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33838, NULL, 'G3DSA:1.20.120.290:FF:000008', NULL, NULL, 'Calcium ion binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(33839, NULL, 'G3DSA:1.10.287.260:FF:000001', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(33840, NULL, 'G3DSA:1.20.1640.10:FF:000071', NULL, NULL, 'Patched-related protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(33841, NULL, 'G3DSA:3.30.450.20:FF:000393', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(33842, NULL, 'G3DSA:2.60.40.10:FF:001731', NULL, NULL, 'Sperm acrosome associated 6', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(33843, NULL, 'G3DSA:2.60.40.420:FF:000208', NULL, NULL, 'Ceruloplasmin', NULL, NULL, NULL, NULL, NULL, 4),
(33844, NULL, 'G3DSA:1.20.5.420:FF:000009', NULL, NULL, 'protein HOMOLOG OF MAMMALIAN LYST-INTERACTING PROTEIN 5-like', NULL, NULL, NULL, NULL, NULL, 4),
(33845, NULL, 'G3DSA:3.30.70.590:FF:000004', NULL, NULL, 'Poly(A) polymerase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(33846, NULL, 'G3DSA:1.10.30.10:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33847, NULL, 'G3DSA:1.10.8.60:FF:000343', NULL, NULL, 'Peroxisome assembly protein Pex1p', NULL, NULL, NULL, NULL, NULL, 4),
(33848, NULL, 'G3DSA:3.30.40.10:FF:000415', NULL, NULL, 'E3 ubiquitin-protein ligase RNF181', NULL, NULL, NULL, NULL, NULL, 4),
(33849, NULL, 'G3DSA:3.30.760.10:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33850, NULL, 'G3DSA:2.60.40.420:FF:000096', NULL, NULL, 'Multicopper oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(33851, NULL, 'G3DSA:1.20.1250.20:FF:000162', NULL, NULL, 'disrupted in renal carcinoma protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(33852, NULL, 'G3DSA:1.10.238.10:FF:000982', NULL, NULL, 'Calcium-binding mitochondrial carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(33853, NULL, 'G3DSA:2.10.25.10:FF:000405', NULL, NULL, 'Laminin subunit alpha 5', NULL, NULL, NULL, NULL, NULL, 4),
(33854, NULL, 'G3DSA:2.10.110.10:FF:000362', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33855, NULL, 'G3DSA:3.80.10.10:FF:001434', NULL, NULL, 'Toll receptor', NULL, NULL, NULL, NULL, NULL, 4),
(33856, NULL, 'G3DSA:3.30.1490.120:FF:000006', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(33857, NULL, 'G3DSA:3.30.450.30:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33858, NULL, 'G3DSA:1.10.1040.10:FF:000038', NULL, NULL, 'Probable 2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(33859, NULL, 'G3DSA:2.40.128.180:FF:000003', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(33860, NULL, 'G3DSA:1.10.238.10:FF:000274', NULL, NULL, 'Follistatin-like 1b', NULL, NULL, NULL, NULL, NULL, 4),
(33861, NULL, 'G3DSA:3.40.50.300:FF:002131', NULL, NULL, 'Uncharacterized ATP-dependent helicase C05C10.2', NULL, NULL, NULL, NULL, NULL, 4),
(33862, NULL, 'G3DSA:1.20.5.190:FF:000013', NULL, NULL, 'unconventional myosin-IXa isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(33863, NULL, 'G3DSA:2.120.10.30:FF:000619', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33864, NULL, 'G3DSA:4.10.400.10:FF:000253', NULL, NULL, 'Modular serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(33865, NULL, 'G3DSA:1.20.5.400:FF:000003', NULL, NULL, 'Capsid assembly scaffolding protein', NULL, NULL, NULL, NULL, NULL, 4),
(33866, NULL, 'G3DSA:3.40.20.10:FF:000099', NULL, NULL, 'Putative G-actin binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(33867, NULL, 'G3DSA:3.30.70.1730:FF:000032', NULL, NULL, '60S acidic ribosomal protein P0', NULL, NULL, NULL, NULL, NULL, 4),
(33868, NULL, 'G3DSA:1.20.1250.20:FF:001090', NULL, NULL, 'Si:ch211-190o6.3', NULL, NULL, NULL, NULL, NULL, 4),
(33869, NULL, 'G3DSA:1.25.10.10:FF:000470', NULL, NULL, 'Vacuolar protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(33870, NULL, 'G3DSA:3.40.50.11380:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33871, NULL, 'G3DSA:1.25.40.70:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33872, NULL, 'G3DSA:3.20.20.80:FF:000811', NULL, NULL, '1,4-alpha-glucan branching enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33873, NULL, 'G3DSA:3.30.800.10:FF:000018', NULL, NULL, 'Phosphatidylinositol-4-phosphate-5-kinase-likep ro tein', NULL, NULL, NULL, NULL, NULL, 4),
(33874, NULL, 'G3DSA:1.25.10.10:FF:002370', NULL, NULL, 'Cell differentiation, Rcd1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(33875, NULL, 'G3DSA:3.40.50.10380:FF:000021', NULL, NULL, 'GH17657p', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(33876, NULL, 'G3DSA:1.10.3270.10:FF:000005', NULL, NULL, '3-hydroxy-3-methylglutaryl coenzyme A reductase', NULL, NULL, NULL, NULL, NULL, 4),
(33877, NULL, 'G3DSA:3.30.710.10:FF:000455', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33878, NULL, 'G3DSA:3.40.50.300:FF:000136', NULL, NULL, 'Replication factor C subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(33879, NULL, 'G3DSA:3.30.420.40:FF:001077', NULL, NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(33880, NULL, 'G3DSA:1.10.287.1150:FF:000022', NULL, NULL, '2-oxoglutarate dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(33881, NULL, 'G3DSA:3.30.70.1620:FF:000005', NULL, NULL, 'Structural maintenance of chromosomes 2', NULL, NULL, NULL, NULL, NULL, 4),
(33882, NULL, 'G3DSA:3.30.70.330:FF:002186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33883, NULL, 'G3DSA:3.30.70.260:FF:000141', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(33884, NULL, 'G3DSA:1.25.40.10:FF:005221', NULL, NULL, 'Nonsense-mediated mRNA decay protein', NULL, NULL, NULL, NULL, NULL, 4),
(33885, NULL, 'G3DSA:3.70.10.10:FF:000030', NULL, NULL, 'Beta sliding clamp', NULL, NULL, NULL, NULL, NULL, 4),
(33886, NULL, 'G3DSA:2.60.120.620:FF:000064', NULL, NULL, 'Prolyl 4-hydroxylase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(33887, NULL, 'G3DSA:3.30.200.20:FF:002527', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33888, NULL, 'G3DSA:1.25.40.10:FF:003535', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33889, NULL, 'G3DSA:3.30.160.60:FF:002344', NULL, NULL, 'Zinc finger protein 333', NULL, NULL, NULL, NULL, NULL, 4),
(33890, NULL, 'G3DSA:3.30.420.40:FF:000251', NULL, NULL, 'Putative actin-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(33891, NULL, 'G3DSA:3.80.10.10:FF:004093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33892, NULL, 'G3DSA:3.40.50.150:FF:000310', NULL, NULL, 'Arginine N-methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(33893, NULL, 'G3DSA:3.40.50.1980:FF:000099', NULL, NULL, 'Iron ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(33894, NULL, 'G3DSA:3.40.50.1390:FF:000017', NULL, NULL, 'Putative resolvase', NULL, NULL, NULL, NULL, NULL, 4),
(33895, NULL, 'G3DSA:3.40.50.620:FF:000355', NULL, NULL, 'Cysteinyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33896, NULL, 'G3DSA:3.30.200.20:FF:000627', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(33897, NULL, 'G3DSA:1.25.40.20:FF:001172', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(33898, NULL, 'G3DSA:3.30.160.60:FF:002092', NULL, NULL, 'Protein SHOOT GRAVITROPISM 5', NULL, NULL, NULL, NULL, NULL, 4),
(33899, NULL, 'G3DSA:1.25.40.10:FF:001635', NULL, NULL, 'Lethal (2) k14710, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(33900, NULL, 'G3DSA:2.10.25.10:FF:000153', NULL, NULL, 'MUC5B isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(33901, NULL, 'G3DSA:3.90.1750.10:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33902, NULL, 'G3DSA:3.30.420.40:FF:000560', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(33903, NULL, 'G3DSA:2.60.40.1670:FF:000007', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(33904, NULL, 'G3DSA:1.10.510.10:FF:001599', NULL, NULL, 'Kinase, STE STE20', NULL, NULL, NULL, NULL, NULL, 4),
(33905, NULL, 'G3DSA:2.10.70.10:FF:000151', NULL, NULL, 'Complement receptor type 2', NULL, NULL, NULL, NULL, NULL, 4),
(33906, NULL, 'G3DSA:3.10.330.20:FF:000001', NULL, NULL, 'tRNA (adenine(58)-N(1))-methyltransferase TrmI', NULL, NULL, NULL, NULL, NULL, 4),
(33907, NULL, 'G3DSA:3.20.20.140:FF:000232', NULL, NULL, 'AMP deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(33908, NULL, 'G3DSA:1.20.58.390:FF:000281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(33909, NULL, 'G3DSA:3.30.70.330:FF:002894', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33910, NULL, 'G3DSA:3.60.21.50:FF:000005', NULL, NULL, 'DNA polymerase delta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(33911, NULL, 'G3DSA:3.40.710.10:FF:000077', NULL, NULL, 'Peptidoglycan D,D-transpeptidase FtsI', NULL, NULL, NULL, NULL, NULL, 4),
(33912, NULL, 'G3DSA:1.25.40.10:FF:003844', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33913, NULL, 'G3DSA:2.10.25.10:FF:000861', NULL, NULL, 'Nimrod A, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(33914, NULL, 'G3DSA:1.10.150.20:FF:000101', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(33915, NULL, 'G3DSA:3.40.50.620:FF:000911', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33916, NULL, 'G3DSA:3.30.200.20:FF:001802', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(33917, NULL, 'G3DSA:3.60.10.10:FF:000069', NULL, NULL, 'Endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(33918, NULL, 'G3DSA:3.30.70.1230:FF:000074', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(33919, NULL, 'G3DSA:3.80.20.20:FF:000100', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(33920, NULL, 'G3DSA:1.25.40.10:FF:001399', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(33921, NULL, 'G3DSA:3.40.1050.10:FF:000031', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(33922, NULL, 'G3DSA:3.30.40.10:FF:001949', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33923, NULL, 'G3DSA:3.30.70.330:FF:002539', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33924, NULL, 'G3DSA:1.20.5.110:FF:000355', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(33925, NULL, 'G3DSA:3.30.160.60:FF:005295', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33926, NULL, 'G3DSA:1.20.920.10:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33927, NULL, 'G3DSA:3.40.1090.10:FF:000033', NULL, NULL, 'Neuropathy target esterase sws', NULL, NULL, NULL, NULL, NULL, 4),
(33928, NULL, 'G3DSA:1.20.1610.10:FF:000007', NULL, NULL, 'Glycoside hydrolase family 92 protein', NULL, NULL, NULL, NULL, NULL, 4),
(33929, NULL, 'G3DSA:1.10.1280.10:FF:000011', NULL, NULL, 'Tyrosinase', NULL, NULL, NULL, NULL, NULL, 4),
(33930, NULL, 'G3DSA:1.20.58.190:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33931, NULL, 'G3DSA:2.70.170.10:FF:000060', NULL, NULL, 'Nicotinic acetylcholine receptor subunit alpha4', NULL, NULL, NULL, NULL, NULL, 4),
(33932, NULL, 'G3DSA:3.20.20.80:FF:000486', NULL, NULL, 'Maltase A2', NULL, NULL, NULL, NULL, NULL, 4),
(33933, NULL, 'G3DSA:3.30.70.100:FF:000094', NULL, NULL, 'Heavy metal-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(33934, NULL, 'G3DSA:1.25.40.10:FF:000887', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(33935, NULL, 'G3DSA:1.10.8.60:FF:000079', NULL, NULL, 'Cell division cycle protein 48 homologue', NULL, NULL, NULL, NULL, NULL, 4),
(33936, NULL, 'G3DSA:1.25.40.20:FF:001363', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33937, NULL, 'G3DSA:1.10.10.10:FF:001262', NULL, NULL, 'Werner syndrome', NULL, NULL, NULL, NULL, NULL, 4),
(33938, NULL, 'G3DSA:2.20.100.10:FF:000033', NULL, NULL, 'Isthmin 1', NULL, NULL, NULL, NULL, NULL, 4),
(33939, NULL, 'G3DSA:2.60.120.200:FF:000382', NULL, NULL, 'LP03809p', NULL, NULL, NULL, NULL, NULL, 4),
(33940, NULL, 'G3DSA:2.130.10.10:FF:001136', NULL, NULL, 'Unplaced genomic scaffold supercont1.188, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(33941, NULL, 'G3DSA:3.80.10.10:FF:004284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33942, NULL, 'G3DSA:1.10.287.70:FF:000225', NULL, NULL, 'Likely calcium channel', NULL, NULL, NULL, NULL, NULL, 4),
(33943, NULL, 'G3DSA:2.60.40.10:FF:000551', NULL, NULL, 'Protogenin A', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(33944, NULL, 'G3DSA:1.10.472.140:FF:000011', NULL, NULL, 'Retinoblastoma-like protein A', NULL, NULL, NULL, NULL, NULL, 4),
(33945, NULL, 'G3DSA:1.10.510.10:FF:002588', NULL, NULL, 'Serine/threonine-protein kinase VRK1', NULL, NULL, NULL, NULL, NULL, 4),
(33946, NULL, 'G3DSA:1.25.40.10:FF:000415', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(33947, NULL, 'G3DSA:2.40.10.10:FF:000533', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33948, NULL, 'G3DSA:2.40.160.20:FF:000024', NULL, NULL, 'Outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(33949, NULL, 'G3DSA:1.10.287.3240:FF:000031', NULL, NULL, 'V-type proton ATPase subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(33950, NULL, 'G3DSA:2.40.290.10:FF:000047', NULL, NULL, 'KU70 protein', NULL, NULL, NULL, NULL, NULL, 4),
(33951, NULL, 'G3DSA:2.40.10.10:FF:000005', NULL, NULL, 'Serine protease 37', NULL, NULL, NULL, NULL, NULL, 4),
(33952, NULL, 'G3DSA:1.20.120.530:FF:000013', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(33953, NULL, 'G3DSA:3.30.160.60:FF:005790', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33954, NULL, 'G3DSA:3.40.190.10:FF:000356', NULL, NULL, 'Extracellular solute-binding protein family 5', NULL, NULL, NULL, NULL, NULL, 4),
(33955, NULL, 'G3DSA:4.10.280.10:FF:000147', NULL, NULL, 'Transcription factor AP-4 (activating enhancer binding protein 4)', NULL, NULL, NULL, NULL, NULL, 4),
(33956, NULL, 'G3DSA:3.60.20.30:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33957, NULL, 'G3DSA:3.30.450.150:FF:000014', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(33958, NULL, 'G3DSA:2.60.40.10:FF:004238', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33959, NULL, 'G3DSA:3.40.50.1820:FF:001372', NULL, NULL, 'Lysophospholipase-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(33960, NULL, 'G3DSA:1.25.40.10:FF:005305', NULL, NULL, 'Adenylyl cyclase class-3/4/guanylyl cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(33961, NULL, 'G3DSA:1.20.120.550:FF:000019', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(33962, NULL, 'G3DSA:1.20.1280.50:FF:000072', NULL, NULL, 'Os08g0230300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(33963, NULL, 'G3DSA:1.10.3860.10:FF:000005', NULL, NULL, 'Amino acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(33964, NULL, 'G3DSA:3.40.50.1010:FF:000044', NULL, NULL, 'DNA repair endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(33965, NULL, 'G3DSA:2.40.40.20:FF:000038', NULL, NULL, 'Biotin sulfoxide reductas2', NULL, NULL, NULL, NULL, NULL, 4),
(33966, NULL, 'G3DSA:3.40.50.10380:FF:000004', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(33967, NULL, 'G3DSA:2.130.10.30:FF:000052', NULL, NULL, 'RCC1 domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(33968, NULL, 'G3DSA:1.20.930.40:FF:000024', NULL, NULL, 'YALI0A20416p', NULL, NULL, NULL, NULL, NULL, 4),
(33969, NULL, 'G3DSA:4.10.970.10:FF:000003', NULL, NULL, 'ATP-dependent DNA helicase II subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(33970, NULL, 'G3DSA:1.10.3500.10:FF:000007', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(33971, NULL, 'G3DSA:2.40.10.10:FF:000640', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33972, NULL, 'G3DSA:1.10.720.180:FF:000001', NULL, NULL, 'Decaheme cytochrome c MtrF', NULL, NULL, NULL, NULL, NULL, 4),
(33973, NULL, 'G3DSA:3.30.160.60:FF:003856', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33974, NULL, 'G3DSA:2.130.10.10:FF:005514', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33975, NULL, 'G3DSA:3.40.1090.10:FF:000140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33976, NULL, 'G3DSA:3.30.1240.10:FF:000059', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(33977, NULL, 'G3DSA:3.40.50.720:FF:000576', NULL, NULL, 'N-acetyl-gamma-glutamyl-phosphate reductase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(33978, NULL, 'G3DSA:3.50.4.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33979, NULL, 'G3DSA:1.10.10.60:FF:001125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33980, NULL, 'G3DSA:3.40.50.790:FF:000030', NULL, NULL, 'Ribosomal L1 domain-containing protein CG13096-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(33981, NULL, 'G3DSA:1.10.3090.10:FF:000008', NULL, NULL, 'Polynucleotide adenylyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(33982, NULL, 'G3DSA:3.90.640.10:FF:000189', NULL, NULL, 'Molecular chaperone DnaK', NULL, NULL, NULL, NULL, NULL, 4),
(33983, NULL, 'G3DSA:2.60.40.10:FF:001484', NULL, NULL, 'ADAMTS like 3', NULL, NULL, NULL, NULL, NULL, 4),
(33984, NULL, 'G3DSA:1.10.8.10:FF:000114', NULL, NULL, 'Vps9p', NULL, NULL, NULL, NULL, NULL, 4),
(33985, NULL, 'G3DSA:3.30.200.20:FF:001791', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(33986, NULL, 'G3DSA:1.20.1250.10:FF:000024', NULL, NULL, 'Interleukin-23 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(33987, NULL, 'G3DSA:2.60.120.10:FF:000828', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33988, NULL, 'G3DSA:3.30.70.330:FF:002978', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(33989, NULL, 'G3DSA:2.30.30.380:FF:000021', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(33990, NULL, 'G3DSA:3.90.76.10:FF:000017', NULL, NULL, 'Oligopeptide ABC transporter, periplasmic oligopeptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(33991, NULL, 'G3DSA:3.80.10.10:FF:000698', NULL, NULL, 'Mimecan', NULL, NULL, NULL, NULL, NULL, 4),
(33992, NULL, 'G3DSA:3.40.50.300:FF:004076', NULL, NULL, 'AGAP009622-PA', NULL, NULL, NULL, NULL, NULL, 4),
(33993, NULL, 'G3DSA:3.30.160.60:FF:002552', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33994, NULL, 'G3DSA:3.40.50.300:FF:005913', NULL, NULL, 'ABC multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(33995, NULL, 'G3DSA:3.30.420.40:FF:000487', NULL, NULL, 'Actin-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(33996, NULL, 'G3DSA:3.20.20.70:FF:000376', NULL, NULL, 'Fructose-bisphosphate aldolase, class II', NULL, NULL, NULL, NULL, NULL, 4),
(33997, NULL, 'G3DSA:3.30.200.20:FF:000846', NULL, NULL, 'Ribosomal protein S6 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(33998, NULL, 'G3DSA:1.25.40.20:FF:001256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(33999, NULL, 'G3DSA:2.60.40.10:FF:002788', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(34000, NULL, 'G3DSA:3.40.710.10:FF:000054', NULL, NULL, 'Penicillin-binding protein, transpeptidase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(34001, NULL, 'G3DSA:2.130.10.10:FF:001619', NULL, NULL, 'WD repeat-containing protein 74-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(34002, NULL, 'G3DSA:1.20.1560.10:FF:000362', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34003, NULL, 'G3DSA:2.60.40.420:FF:000107', NULL, NULL, 'YDR506C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(34004, NULL, 'G3DSA:3.30.70.270:FF:000099', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(34005, NULL, 'G3DSA:1.10.287.70:FF:000697', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34006, NULL, 'G3DSA:2.30.42.10:FF:000175', NULL, NULL, 'FERM and PDZ domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(34007, NULL, 'G3DSA:2.60.120.200:FF:000275', NULL, NULL, 'Putative unspecified product', NULL, NULL, NULL, NULL, NULL, 4),
(34008, NULL, 'G3DSA:3.80.10.10:FF:004177', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(34009, NULL, 'G3DSA:3.40.50.11610:FF:000008', NULL, NULL, '2-oxoglutarate dehydrogenase, mitochondrial isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(34010, NULL, 'G3DSA:3.10.400.20:FF:000029', NULL, NULL, 'Translation machinery-associated protein 20', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(34011, NULL, 'G3DSA:2.130.10.10:FF:005407', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(34012, NULL, 'G3DSA:2.170.130.10:FF:000078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34013, NULL, 'G3DSA:3.60.40.10:FF:000392', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34014, NULL, 'G3DSA:2.170.270.10:FF:000111', NULL, NULL, 'Probable histone-lysine N-methyltransferase lin-59', NULL, NULL, NULL, NULL, NULL, 4),
(34015, NULL, 'G3DSA:2.30.39.10:FF:000049', NULL, NULL, 'Serpin 100A', NULL, NULL, NULL, NULL, NULL, 4),
(34016, NULL, 'G3DSA:2.60.120.10:FF:000031', NULL, NULL, '1,2-dihydroxy-3-keto-5-methylthiopentene dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(34017, NULL, 'G3DSA:2.10.109.10:FF:000061', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(34018, NULL, 'G3DSA:2.110.10.10:FF:000013', NULL, NULL, 'Hemopexin', NULL, NULL, NULL, NULL, NULL, 4),
(34019, NULL, 'G3DSA:3.20.20.150:FF:000016', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(34020, NULL, 'G3DSA:1.10.1140.10:FF:000001', NULL, NULL, 'ATP synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(34021, NULL, 'G3DSA:3.30.1370.10:FF:000248', NULL, NULL, 'Hdlbp protein', NULL, NULL, NULL, NULL, NULL, 4),
(34022, NULL, 'G3DSA:3.80.10.10:FF:000389', NULL, NULL, 'NLR family pyrin domain containing 6', NULL, NULL, NULL, NULL, NULL, 4),
(34023, NULL, 'G3DSA:1.20.120.350:FF:000083', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(34024, NULL, 'G3DSA:1.10.630.10:FF:000618', NULL, NULL, 'Cyp2c65 protein', NULL, NULL, NULL, NULL, NULL, 4),
(34025, NULL, 'G3DSA:1.20.1250.20:FF:001651', NULL, NULL, 'Major facilitator superfamily domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(34026, NULL, 'G3DSA:1.10.30.10:FF:000173', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(34027, NULL, 'G3DSA:1.10.357.140:FF:000050', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(34028, NULL, 'G3DSA:3.30.300.20:FF:000062', NULL, NULL, 'Ribosome-binding factor A', NULL, NULL, NULL, NULL, NULL, 4),
(34029, NULL, 'G3DSA:3.40.50.300:FF:000237', NULL, NULL, 'replication factor C subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(34030, NULL, 'G3DSA:3.30.230.30:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34031, NULL, 'G3DSA:3.30.360.10:FF:000074', NULL, NULL, 'Dihydrodipicolinate reductase, C-terminus family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(34032, NULL, 'G3DSA:2.60.120.650:FF:000163', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(34033, NULL, 'G3DSA:3.40.50.720:FF:001195', NULL, NULL, 'Carbonyl reductase/20beta-hydroxysteroid dehydrogenase A', NULL, NULL, NULL, NULL, NULL, 4),
(34034, NULL, 'G3DSA:3.90.105.20:FF:000022', NULL, NULL, 'Protein CBG02262', NULL, NULL, NULL, NULL, NULL, 4),
(34035, NULL, 'G3DSA:1.10.150.510:FF:000010', NULL, NULL, 'Receptor activity modifying protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(34036, NULL, 'G3DSA:3.90.79.10:FF:000277', NULL, NULL, 'UDP-glucose pyrophosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34037, NULL, 'G3DSA:1.10.238.10:FF:001246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34038, NULL, 'G3DSA:1.20.140.10:FF:000106', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(34039, NULL, 'G3DSA:1.25.40.20:FF:001739', NULL, NULL, 'Serine/threonine-protein kinase TNNI3K', NULL, NULL, NULL, NULL, NULL, 4),
(34040, NULL, 'G3DSA:1.20.5.100:FF:000026', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(34041, NULL, 'G3DSA:3.40.605.10:FF:000068', NULL, NULL, 'Delta-1-pyrroline-5-carboxylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(34042, NULL, 'G3DSA:3.40.50.2020:FF:000050', NULL, NULL, 'Related to XPT1-xanthine phosphoribosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(34043, NULL, 'G3DSA:3.30.160.60:FF:001933', NULL, NULL, 'Zinc finger protein 870', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(34044, NULL, 'G3DSA:1.10.8.60:FF:000449', NULL, NULL, 'ATP-dependent protease ATPase subunit HslU', NULL, NULL, NULL, NULL, NULL, 4),
(34045, NULL, 'G3DSA:3.40.50.300:FF:006532', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(34046, NULL, 'G3DSA:3.20.20.70:FF:000685', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34047, NULL, 'G3DSA:3.80.10.10:FF:000922', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase PEPR1', NULL, NULL, NULL, NULL, NULL, 4),
(34048, NULL, 'G3DSA:1.10.357.20:FF:000014', NULL, NULL, 'Magnesium transporter MgtE', NULL, NULL, NULL, NULL, NULL, 4),
(34049, NULL, 'G3DSA:1.25.40.10:FF:003760', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34050, NULL, 'G3DSA:2.30.180.10:FF:000103', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34051, NULL, 'G3DSA:3.90.190.10:FF:000446', NULL, NULL, 'Protein tyrosine phosphatase 3', NULL, NULL, NULL, NULL, NULL, 4),
(34052, NULL, 'G3DSA:2.60.120.200:FF:000702', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34053, NULL, 'G3DSA:3.40.630.30:FF:000571', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34054, NULL, 'G3DSA:3.30.70.330:FF:000741', NULL, NULL, '60S ribosomal protein L23A', NULL, NULL, NULL, NULL, NULL, 4),
(34055, NULL, 'G3DSA:2.170.120.20:FF:000007', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(34056, NULL, 'G3DSA:3.40.50.720:FF:002521', NULL, NULL, 'Prephenate dehydrogenase [NADP(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(34057, NULL, 'G3DSA:3.40.50.300:FF:002261', NULL, NULL, 'DNA repair helicase RAD3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34058, NULL, 'G3DSA:3.40.33.10:FF:000078', NULL, NULL, 'Antigen 5/SCP domain-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34059, NULL, 'G3DSA:3.40.50.2300:FF:001117', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34060, NULL, 'G3DSA:1.10.630.10:FF:000461', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34061, NULL, 'G3DSA:3.30.420.580:FF:000002', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(34062, NULL, 'G3DSA:3.50.50.60:FF:000396', NULL, NULL, 'Halogenase', NULL, NULL, NULL, NULL, NULL, 4),
(34063, NULL, 'G3DSA:2.30.40.10:FF:000030', NULL, NULL, 'Putative amidohydrolase ytcJ', NULL, NULL, NULL, NULL, NULL, 4),
(34064, NULL, 'G3DSA:3.40.50.300:FF:001861', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(34065, NULL, 'G3DSA:1.10.760.10:FF:000010', NULL, NULL, 'Predicted thiol oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(34066, NULL, 'G3DSA:1.20.1270.60:FF:000141', NULL, NULL, 'WGS project CABT00000000 data, contig 2.6', NULL, NULL, NULL, NULL, NULL, 4),
(34067, NULL, 'G3DSA:1.10.287.110:FF:000119', NULL, NULL, 'TPR-repeat-containing chaperone protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34068, NULL, 'G3DSA:3.30.70.3540:FF:000002', NULL, NULL, 'ORF1a polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(34069, NULL, 'G3DSA:3.40.50.300:FF:001226', NULL, NULL, 'ATP-dependent DNA helicase PIF1', NULL, NULL, NULL, NULL, NULL, 4),
(34070, NULL, 'G3DSA:3.30.40.10:FF:000168', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM9 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(34071, NULL, 'G3DSA:3.40.50.2300:FF:001645', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34072, NULL, 'G3DSA:1.20.120.1630:FF:000007', NULL, NULL, 'Protein-S-isoprenylcysteine O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(34073, NULL, 'G3DSA:1.10.10.1500:FF:000002', NULL, NULL, 'ribosomal oxygenase 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(34074, NULL, 'G3DSA:2.60.40.10:FF:002479', NULL, NULL, 'Protein tyrosine phosphatase, receptor type C', NULL, NULL, NULL, NULL, NULL, 4),
(34075, NULL, 'G3DSA:1.10.40.30:FF:000005', NULL, NULL, 'Adenylosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(34076, NULL, 'G3DSA:2.60.120.620:FF:000148', NULL, NULL, 'Os03g0166200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(34077, NULL, 'G3DSA:3.30.160.60:FF:005306', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(34078, NULL, 'G3DSA:3.70.10.10:FF:000114', NULL, NULL, 'DNA polymerase sliding clamp', NULL, NULL, NULL, NULL, NULL, 4),
(34079, NULL, 'G3DSA:2.60.40.10:FF:003884', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34080, NULL, 'G3DSA:1.10.238.10:FF:000381', NULL, NULL, 'Dead deah box rna helicase', NULL, NULL, NULL, NULL, NULL, 4),
(34081, NULL, 'G3DSA:3.30.300.130:FF:000009', NULL, NULL, 'Iron-sulfur cluster carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(34082, NULL, 'G3DSA:1.20.1250.20:FF:002270', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(34083, NULL, 'G3DSA:3.40.190.10:FF:000884', NULL, NULL, 'Glutamate receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34084, NULL, 'G3DSA:1.25.10.10:FF:001678', NULL, NULL, 'Armadillo-type protein', NULL, NULL, NULL, NULL, NULL, 4),
(34085, NULL, 'G3DSA:1.20.58.340:FF:000064', NULL, NULL, 'Cation transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34086, NULL, 'G3DSA:3.40.30.10:FF:000364', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(34087, NULL, 'G3DSA:3.30.310.50:FF:000032', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(34088, NULL, 'G3DSA:3.40.50.1220:FF:000028', NULL, NULL, 'Acetolactate synthase, catabolic', NULL, NULL, NULL, NULL, NULL, 4),
(34089, NULL, 'G3DSA:3.30.70.330:FF:002848', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34090, NULL, 'G3DSA:1.25.40.10:FF:002815', NULL, NULL, 'NPGR2', NULL, NULL, NULL, NULL, NULL, 4),
(34091, NULL, 'G3DSA:3.30.1600.10:FF:000036', NULL, NULL, 'NAD-dependent deacetylase sir2E', NULL, NULL, NULL, NULL, NULL, 4),
(34092, NULL, 'G3DSA:1.10.506.10:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34093, NULL, 'G3DSA:1.25.40.10:FF:001034', NULL, NULL, 'Intraflagellar transport 88 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(34094, NULL, 'G3DSA:1.10.150.120:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34095, NULL, 'G3DSA:3.20.10.10:FF:000009', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(34096, NULL, 'G3DSA:2.120.10.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34097, NULL, 'G3DSA:3.40.50.2000:FF:000841', NULL, NULL, 'Glycogen [starch] synthase', NULL, NULL, NULL, NULL, NULL, 4),
(34098, NULL, 'G3DSA:3.30.565.10:FF:000370', NULL, NULL, 'Sensor histidine kinase, HAMP and PAS domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(34099, NULL, 'G3DSA:3.30.1240.10:FF:000053', NULL, NULL, 'HAD family phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(34100, NULL, 'G3DSA:3.90.1750.10:FF:000005', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(34101, NULL, 'G3DSA:1.20.5.420:FF:000026', NULL, NULL, 'Ribonuclease P protein component 4', NULL, NULL, NULL, NULL, NULL, 4),
(34102, NULL, 'G3DSA:1.10.510.10:FF:000334', NULL, NULL, 'Serine/threonine-protein kinase STE11', NULL, NULL, NULL, NULL, NULL, 4),
(34103, NULL, 'G3DSA:3.40.640.10:FF:000211', NULL, NULL, 'Serine hydroxymethyltransferase mitochondrial-like', NULL, NULL, NULL, NULL, NULL, 4),
(34104, NULL, 'G3DSA:3.30.1360.120:FF:000039', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(34105, NULL, 'G3DSA:1.10.630.10:FF:000837', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34106, NULL, 'G3DSA:3.40.50.10810:FF:000105', NULL, NULL, 'DNA repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34107, NULL, 'G3DSA:1.10.510.10:FF:002116', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(34108, NULL, 'G3DSA:3.30.2350.10:FF:000039', NULL, NULL, 'Ribosomal large subunit pseudouridine synthase, RluD subfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(34109, NULL, 'G3DSA:1.20.1250.20:FF:000246', NULL, NULL, 'Cell-surface thiamine transporter 2', NULL, NULL, NULL, NULL, NULL, 4),
(34110, NULL, 'G3DSA:3.80.10.10:FF:001687', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(34111, NULL, 'G3DSA:3.30.2140.20:FF:000015', NULL, NULL, 'Arylamine N-acetyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(34112, NULL, 'G3DSA:1.10.260.40:FF:000076', NULL, NULL, 'Peptidase M23', NULL, NULL, NULL, NULL, NULL, 4),
(34113, NULL, 'G3DSA:3.30.200.20:FF:001010', NULL, NULL, 'eIF-2 alpha kinase', NULL, NULL, NULL, NULL, NULL, 4),
(34114, NULL, 'G3DSA:2.130.10.10:FF:004109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34115, NULL, 'G3DSA:2.60.120.40:FF:000034', NULL, NULL, 'C1qB', NULL, NULL, NULL, NULL, NULL, 4),
(34116, NULL, 'G3DSA:3.30.780.10:FF:000049', NULL, NULL, 'Translation initiation factor SUI1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(34117, NULL, 'G3DSA:3.30.40.10:FF:000640', NULL, NULL, 'DNA repair protein Nse1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34118, NULL, 'G3DSA:3.30.300.110:FF:000003', NULL, NULL, 'tRNA wybutosine-synthesizing protein 2/3/4', NULL, NULL, NULL, NULL, NULL, 4),
(34119, NULL, 'G3DSA:3.30.1490.20:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34120, NULL, 'G3DSA:3.30.930.10:FF:000247', NULL, NULL, 'Phenylalanyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34121, NULL, 'G3DSA:1.25.10.10:FF:001223', NULL, NULL, 'Serine/threonine-protein kinase ATR', NULL, NULL, NULL, NULL, NULL, 4),
(34122, NULL, 'G3DSA:3.90.1110.10:FF:000007', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(34123, NULL, 'G3DSA:1.10.287.70:FF:000702', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34124, NULL, 'G3DSA:1.20.210.10:FF:000028', NULL, NULL, 'Putative COX1/OXI3 intron 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(34125, NULL, 'G3DSA:1.20.5.170:FF:000136', NULL, NULL, 'Proto-oncogene c-Fos', NULL, NULL, NULL, NULL, NULL, 4),
(34126, NULL, 'G3DSA:1.10.1030.10:FF:000009', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(34127, NULL, 'G3DSA:3.40.50.1360:FF:000048', NULL, NULL, 'Glucosamine-6-phosphate isomerase NAGB', NULL, NULL, NULL, NULL, NULL, 4),
(34128, NULL, 'G3DSA:3.40.630.10:FF:000492', NULL, NULL, 'Clan MH, family M18, aspartyl aminopeptidase-like metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(34129, NULL, 'G3DSA:3.30.70.240:FF:000028', NULL, NULL, 'Translation factor GUF1 homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(34130, NULL, 'G3DSA:3.20.20.105:FF:000018', NULL, NULL, 'Queuine tRNA-ribosyltransferase accessory subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(34131, NULL, 'G3DSA:3.50.80.10:FF:000012', NULL, NULL, 'D-tyrosyl-tRNA deacylase 2 (putative)', NULL, NULL, NULL, NULL, NULL, 4),
(34132, NULL, 'G3DSA:1.50.40.10:FF:000346', NULL, NULL, 'Mitochondrial substrate carrier family protein W', NULL, NULL, NULL, NULL, NULL, 4),
(34133, NULL, 'G3DSA:3.30.160.60:FF:003873', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34134, NULL, 'G3DSA:1.25.40.10:FF:005322', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g23020', NULL, NULL, NULL, NULL, NULL, 4),
(34135, NULL, 'G3DSA:3.30.505.10:FF:000052', NULL, NULL, 'Ras and Rab interactor 2', NULL, NULL, NULL, NULL, NULL, 4),
(34136, NULL, 'G3DSA:1.20.1250.20:FF:000729', NULL, NULL, 'MFS multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34137, NULL, 'G3DSA:1.10.510.10:FF:003280', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34138, NULL, 'G3DSA:2.130.10.10:FF:006043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34139, NULL, 'G3DSA:2.60.40.10:FF:001175', NULL, NULL, 'Putative collagen alpha-1vii chain', NULL, NULL, NULL, NULL, NULL, 4),
(34140, NULL, 'G3DSA:1.25.40.10:FF:001826', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(34141, NULL, 'G3DSA:1.25.40.10:FF:001051', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(34142, NULL, 'G3DSA:3.40.50.720:FF:002499', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(34143, NULL, 'G3DSA:3.40.630.150:FF:000008', NULL, NULL, 'malonyl-CoA decarboxylase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(34144, NULL, 'G3DSA:3.90.290.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34145, NULL, 'G3DSA:3.40.50.10490:FF:000037', NULL, NULL, 'Glucose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(34146, NULL, 'G3DSA:3.30.200.210:FF:000005', NULL, NULL, 'NADH-quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(34147, NULL, 'G3DSA:1.10.510.10:FF:003077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34148, NULL, 'G3DSA:3.30.230.10:FF:000317', NULL, NULL, 'XO lethal protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(34149, NULL, 'G3DSA:2.40.160.50:FF:000044', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(34150, NULL, 'G3DSA:3.20.20.80:FF:000710', NULL, NULL, 'Lactase, gene 1', NULL, NULL, NULL, NULL, NULL, 4),
(34151, NULL, 'G3DSA:3.30.420.10:FF:000489', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34152, NULL, 'G3DSA:3.90.550.10:FF:000053', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(34153, NULL, 'G3DSA:3.30.200.20:FF:000818', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34154, NULL, 'G3DSA:1.10.8.60:FF:000444', NULL, NULL, 'ATPase, AAA family', NULL, NULL, NULL, NULL, NULL, 4),
(34155, NULL, 'G3DSA:2.130.10.10:FF:002120', NULL, NULL, 'Serine/threonine kinase IREI', NULL, NULL, NULL, NULL, NULL, 4),
(34156, NULL, 'G3DSA:3.30.70.330:FF:000185', NULL, NULL, 'Probable RNA-binding protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(34157, NULL, 'G3DSA:2.30.30.490:FF:000054', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(34158, NULL, 'G3DSA:3.40.190.80:FF:000096', NULL, NULL, 'Putative inositol monophosphatase 3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(34159, NULL, 'G3DSA:3.40.50.1100:FF:000077', NULL, NULL, 'Cysteine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(34160, NULL, 'G3DSA:3.30.9.10:FF:000219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34161, NULL, 'G3DSA:1.10.760.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34162, NULL, 'G3DSA:1.25.40.20:FF:000435', NULL, NULL, 'YCR051W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(34163, NULL, 'G3DSA:3.30.420.10:FF:000017', NULL, NULL, 'POL polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(34164, NULL, 'G3DSA:1.10.10.10:FF:000773', NULL, NULL, 'Related to RPC82-RNA polymerase III subunit C82', NULL, NULL, NULL, NULL, NULL, 4),
(34165, NULL, 'G3DSA:1.10.472.80:FF:000069', NULL, NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', NULL, NULL, NULL, NULL, NULL, 4),
(34166, NULL, 'G3DSA:4.10.400.10:FF:000360', NULL, NULL, 'Low-density lipoprotein RecePtor related', NULL, NULL, NULL, NULL, NULL, 4),
(34167, NULL, 'G3DSA:3.40.930.10:FF:000060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34168, NULL, 'G3DSA:3.30.420.40:FF:000796', NULL, NULL, 'Actin like 6B', NULL, NULL, NULL, NULL, NULL, 4),
(34169, NULL, 'G3DSA:3.30.930.10:FF:000090', NULL, NULL, 'Lipoyltransferase and lipoate-protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34170, NULL, 'G3DSA:3.40.850.10:FF:000379', NULL, NULL, 'Kinesin motor protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(34171, NULL, 'G3DSA:2.170.120.20:FF:000002', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(34172, NULL, 'G3DSA:3.40.50.1000:FF:000507', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34173, NULL, 'G3DSA:1.20.58.2220:FF:000042', NULL, NULL, 'Formin-I', NULL, NULL, NULL, NULL, NULL, 4),
(34174, NULL, 'G3DSA:3.50.50.60:FF:000716', NULL, NULL, 'Phytoene dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(34175, NULL, 'G3DSA:3.60.10.10:FF:000199', NULL, NULL, 'Os06g0264900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(34176, NULL, 'G3DSA:2.20.100.10:FF:000252', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(34177, NULL, 'G3DSA:3.40.50.150:FF:001794', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(34178, NULL, 'G3DSA:3.40.50.10090:FF:000041', NULL, NULL, 'Uroporphyrinogen-III C-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(34179, NULL, 'G3DSA:1.25.10.10:FF:000262', NULL, NULL, 'HEAT repeat-containing protein 5B', NULL, NULL, NULL, NULL, NULL, 4),
(34180, NULL, 'G3DSA:2.60.120.10:FF:000519', NULL, NULL, 'Tetrameric potassium-selective cyclic nucleotide gated channel', NULL, NULL, NULL, NULL, NULL, 4),
(34181, NULL, 'G3DSA:1.20.5.4770:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34182, NULL, 'G3DSA:1.10.40.60:FF:000003', NULL, NULL, 'Type II secretion system protein K', NULL, NULL, NULL, NULL, NULL, 4),
(34183, NULL, 'G3DSA:3.90.1860.10:FF:000002', NULL, NULL, 'RNA-splicing ligase RtcB', NULL, NULL, NULL, NULL, NULL, 4),
(34184, NULL, 'G3DSA:2.40.50.140:FF:000283', NULL, NULL, 'Hypothetical membrane protein, conserved', NULL, NULL, NULL, NULL, NULL, 4),
(34185, NULL, 'G3DSA:2.60.40.60:FF:000105', NULL, NULL, 'Protocadherin 17', NULL, NULL, NULL, NULL, NULL, 4),
(34186, NULL, 'G3DSA:3.30.565.10:FF:000061', NULL, NULL, 'PAS sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(34187, NULL, 'G3DSA:1.10.10.1890:FF:000001', NULL, NULL, 'Spindle and kinetochore-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(34188, NULL, 'G3DSA:3.30.70.330:FF:001674', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34189, NULL, 'G3DSA:1.10.10.10:FF:001043', NULL, NULL, 'Probable disease resistance protein At4g33300', NULL, NULL, NULL, NULL, NULL, 4),
(34190, NULL, 'G3DSA:1.20.1050.90:FF:000010', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(34191, NULL, 'G3DSA:3.20.20.70:FF:000792', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34192, NULL, 'G3DSA:2.60.40.1120:FF:000045', NULL, NULL, 'Bacillopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(34193, NULL, 'G3DSA:1.25.40.550:FF:000016', NULL, NULL, 'A1 cistron-splicing factor aar2', NULL, NULL, NULL, NULL, NULL, 4),
(34194, NULL, 'G3DSA:3.80.10.10:FF:003795', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34195, NULL, 'G3DSA:3.90.105.10:FF:000002', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(34196, NULL, 'G3DSA:1.10.150.810:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34197, NULL, 'G3DSA:3.40.630.30:FF:000115', NULL, NULL, 'RNA cytidine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(34198, NULL, 'G3DSA:3.40.50.300:FF:008005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34199, NULL, 'G3DSA:3.40.532.10:FF:000016', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(34200, NULL, 'G3DSA:1.10.640.10:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34201, NULL, 'G3DSA:1.10.240.10:FF:000010', NULL, NULL, 'Tryptophan-tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34202, NULL, 'G3DSA:3.30.420.10:FF:000152', NULL, NULL, 'DNA polymerase III polC-type', NULL, NULL, NULL, NULL, NULL, 4),
(34203, NULL, 'G3DSA:3.40.190.10:FF:000912', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34204, NULL, 'G3DSA:1.20.5.700:FF:000003', NULL, NULL, 'Dermcidin', NULL, NULL, NULL, NULL, NULL, 4),
(34205, NULL, 'G3DSA:1.20.58.60:FF:000189', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(34206, NULL, 'G3DSA:3.60.10.10:FF:000108', NULL, NULL, 'AP endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(34207, NULL, 'G3DSA:3.30.160.60:FF:000635', NULL, NULL, 'zinc finger protein 250 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(34208, NULL, 'G3DSA:3.30.1330.20:FF:000024', NULL, NULL, 'Tubulin gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(34209, NULL, 'G3DSA:1.10.540.10:FF:000027', NULL, NULL, 'Putative acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(34210, NULL, 'G3DSA:2.120.10.30:FF:000518', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34211, NULL, 'G3DSA:3.40.50.300:FF:007965', NULL, NULL, 'Si:dkey-11m19.5', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(34212, NULL, 'G3DSA:3.90.1410.10:FF:000154', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(34213, NULL, 'G3DSA:3.10.20.90:FF:000540', NULL, NULL, 'NFATC2-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(34214, NULL, 'G3DSA:2.30.30.210:FF:000021', NULL, NULL, 'Probable ribonuclease P protein subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(34215, NULL, 'G3DSA:1.10.275.10:FF:000011', NULL, NULL, 'Argininosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(34216, NULL, 'G3DSA:3.30.40.10:FF:001152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34217, NULL, 'G3DSA:3.90.1410.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34218, NULL, 'G3DSA:3.90.226.10:FF:000125', NULL, NULL, 'Enoyl-CoA hydratase/isomerase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(34219, NULL, 'G3DSA:3.30.160.60:FF:004345', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34220, NULL, 'G3DSA:1.10.510.10:FF:002335', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34221, NULL, 'G3DSA:3.40.50.720:FF:002504', NULL, NULL, 'ThiF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(34222, NULL, 'G3DSA:2.60.40.150:FF:000678', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(34223, NULL, 'G3DSA:1.10.287.560:FF:000001', NULL, NULL, 'Histidine kinase chemotaxis protein CheA', NULL, NULL, NULL, NULL, NULL, 4),
(34224, NULL, 'G3DSA:2.70.70.10:FF:000058', NULL, NULL, 'PTS system, glucose subfamily, IIA component', NULL, NULL, NULL, NULL, NULL, 4),
(34225, NULL, 'G3DSA:2.120.10.90:FF:000002', NULL, NULL, 'DNA gyrase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(34226, NULL, 'G3DSA:1.25.40.10:FF:000106', NULL, NULL, 'Intraflagellar transport 88 homolog (Chlamydomonas)', NULL, NULL, NULL, NULL, NULL, 4),
(34227, NULL, 'G3DSA:1.10.246.90:FF:000018', NULL, NULL, 'SnoRNA binding domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(34228, NULL, 'G3DSA:1.20.920.10:FF:000172', NULL, NULL, 'YALI0D23287p', NULL, NULL, NULL, NULL, NULL, 4),
(34229, NULL, 'G3DSA:3.40.630.10:FF:000020', NULL, NULL, 'Carboxypeptidase D', NULL, NULL, NULL, NULL, NULL, 4),
(34230, NULL, 'G3DSA:2.60.120.290:FF:000026', NULL, NULL, 'Procollagen C-endopeptidase enhancer 2', NULL, NULL, NULL, NULL, NULL, 4),
(34231, NULL, 'G3DSA:1.20.1250.20:FF:000701', NULL, NULL, 'Phosphate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34232, NULL, 'G3DSA:3.40.50.720:FF:002049', NULL, NULL, 'Anthocyanidin reductase', NULL, NULL, NULL, NULL, NULL, 4),
(34233, NULL, 'G3DSA:1.20.58.60:FF:000318', NULL, NULL, 'Spectrin beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(34234, NULL, 'G3DSA:3.40.720.10:FF:000009', NULL, NULL, 'Phosphoglycerol transferase I', NULL, NULL, NULL, NULL, NULL, 4),
(34235, NULL, 'G3DSA:1.10.287.470:FF:000093', NULL, NULL, 'Putative heavy metal efflux system protein', NULL, NULL, NULL, NULL, NULL, 4),
(34236, NULL, 'G3DSA:3.10.20.90:FF:000337', NULL, NULL, 'Caspar, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(34237, NULL, 'G3DSA:3.40.630.30:FF:000368', NULL, NULL, 'N-acetyltransferase 5', NULL, NULL, NULL, NULL, NULL, 4),
(34238, NULL, 'G3DSA:1.20.120.1320:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34239, NULL, 'G3DSA:3.40.50.1000:FF:000182', NULL, NULL, 'Copper-exporting P-type ATPase B', NULL, NULL, NULL, NULL, NULL, 4),
(34240, NULL, 'G3DSA:2.160.20.10:FF:000197', NULL, NULL, 'Os11g0659700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(34241, NULL, 'G3DSA:2.60.40.640:FF:000061', NULL, NULL, 'Vacuolar protein sorting 26, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34242, NULL, 'G3DSA:2.60.120.380:FF:000059', NULL, NULL, 'Cysteine peptidase, Clan CA, family C2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34243, NULL, 'G3DSA:3.30.559.10:FF:000237', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(34244, NULL, 'G3DSA:3.30.450.20:FF:000449', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(34245, NULL, 'G3DSA:3.30.470.20:FF:000085', NULL, NULL, 'glutathione synthetase isoform X3', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(34246, NULL, 'G3DSA:1.10.220.10:FF:000008', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(34247, NULL, 'G3DSA:1.20.1270.60:FF:000006', NULL, NULL, 'SLIT-ROBO Rho GTPase-activating protein 1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(34248, NULL, 'G3DSA:3.40.50.1240:FF:000214', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34249, NULL, 'G3DSA:2.60.40.10:FF:005227', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34250, NULL, 'G3DSA:1.20.1250.10:FF:000041', NULL, NULL, 'Growth hormone d20', NULL, NULL, NULL, NULL, NULL, 4),
(34251, NULL, 'G3DSA:3.30.160.60:FF:000074', NULL, NULL, 'Tripartite motif containing 66', NULL, NULL, NULL, NULL, NULL, 4),
(34252, NULL, 'G3DSA:3.40.1190.20:FF:000229', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34253, NULL, 'G3DSA:1.10.630.10:FF:000045', NULL, NULL, 'Cytochrome P450 85A1', NULL, NULL, NULL, NULL, NULL, 4),
(34254, NULL, 'G3DSA:3.40.250.10:FF:000030', NULL, NULL, 'Inner membrane protein YgaP', NULL, NULL, NULL, NULL, NULL, 4),
(34255, NULL, 'G3DSA:1.10.287.950:FF:000006', NULL, NULL, 'Methyl-accepting chemotaxis protein signaling domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(34256, NULL, 'G3DSA:1.25.40.10:FF:003288', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(34257, NULL, 'G3DSA:3.60.20.40:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34258, NULL, 'G3DSA:1.20.990.10:FF:000030', NULL, NULL, 'Sulfite reductase [NADPH] flavoprotein alpha-component', NULL, NULL, NULL, NULL, NULL, 4),
(34259, NULL, 'G3DSA:1.50.10.20:FF:000055', NULL, NULL, 'Baccharis oxide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(34260, NULL, 'G3DSA:1.10.167.10:FF:000002', NULL, NULL, 'Regulator of G-protein signaling 6 isoform 9', NULL, NULL, NULL, NULL, NULL, 4),
(34261, NULL, 'G3DSA:2.30.42.10:FF:000192', NULL, NULL, 'Uncharacterized protein, isoform J', NULL, NULL, NULL, NULL, NULL, 4),
(34262, NULL, 'G3DSA:1.25.40.10:FF:002888', NULL, NULL, 'CCR4-NOT transcription complex subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34263, NULL, 'G3DSA:2.60.40.10:FF:002895', NULL, NULL, '5-AMP-activated protein kinase, beta-1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(34264, NULL, 'G3DSA:3.40.50.200:FF:000016', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 9', NULL, NULL, NULL, NULL, NULL, 4),
(34265, NULL, 'G3DSA:1.20.58.60:FF:000009', NULL, NULL, 'dystonin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(34266, NULL, 'G3DSA:1.50.10.10:FF:000209', NULL, NULL, 'AGAP008547-PA', NULL, NULL, NULL, NULL, NULL, 4),
(34267, NULL, 'G3DSA:3.40.50.300:FF:002154', NULL, NULL, 'Putative GTPase Era', NULL, NULL, NULL, NULL, NULL, 4),
(34268, NULL, 'G3DSA:4.10.1000.10:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34269, NULL, 'G3DSA:1.20.1500.20:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34270, NULL, 'G3DSA:4.10.800.20:FF:000016', NULL, NULL, 'Os05g0349200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(34271, NULL, 'G3DSA:3.40.720.10:FF:000375', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34272, NULL, 'G3DSA:2.130.10.10:FF:001355', NULL, NULL, 'Eukaryotic translation initiation factor 2A', NULL, NULL, NULL, NULL, NULL, 4),
(34273, NULL, 'G3DSA:1.10.443.20:FF:000001', NULL, NULL, 'Centromere binding factor CBF3 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(34274, NULL, 'G3DSA:3.40.720.10:FF:000156', NULL, NULL, 'Arylsulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(34275, NULL, 'G3DSA:3.40.50.200:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34276, NULL, 'G3DSA:3.40.50.300:FF:006785', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34277, NULL, 'G3DSA:1.10.560.10:FF:000045', NULL, NULL, 'T-complex protein 1 subunit eta', NULL, NULL, NULL, NULL, NULL, 4),
(34278, NULL, 'G3DSA:3.60.40.10:FF:000245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34279, NULL, 'G3DSA:3.40.30.10:FF:000257', NULL, NULL, '39S ribosomal protein L43', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(34280, NULL, 'G3DSA:2.60.40.60:FF:000740', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(34281, NULL, 'G3DSA:3.40.850.10:FF:000564', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34282, NULL, 'G3DSA:3.30.2350.10:FF:000056', NULL, NULL, 'tRNA pseudouridine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(34283, NULL, 'G3DSA:1.50.40.10:FF:000262', NULL, NULL, 'Mitochondrial substrate carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(34284, NULL, 'G3DSA:2.60.40.10:FF:001967', NULL, NULL, 'Sialic acid binding Ig like lectin 6', NULL, NULL, NULL, NULL, NULL, 4),
(34285, NULL, 'G3DSA:3.30.420.230:FF:000004', NULL, NULL, 'Spliceosomal protein PrP8, U6-snRNA interacting domain', NULL, NULL, NULL, NULL, NULL, 4),
(34286, NULL, 'G3DSA:1.10.630.10:FF:000354', NULL, NULL, 'Cytochrome P450 67', NULL, NULL, NULL, NULL, NULL, 4),
(34287, NULL, 'G3DSA:3.60.21.10:FF:000353', NULL, NULL, 'Purple acid phosphatase 19', NULL, NULL, NULL, NULL, NULL, 4),
(34288, NULL, 'G3DSA:4.10.400.10:FF:000230', NULL, NULL, 'Low-density lipoprotein RecePtor related', NULL, NULL, NULL, NULL, NULL, 4),
(34289, NULL, 'G3DSA:2.40.50.120:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34290, NULL, 'G3DSA:1.25.40.10:FF:000090', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(34291, NULL, 'G3DSA:1.25.10.10:FF:003140', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(34292, NULL, 'G3DSA:3.90.70.80:FF:000053', NULL, NULL, 'Putative bifunctional UDP-N-acetylglucosamine transferase and deubiquitinase ALG13-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(34293, NULL, 'G3DSA:2.170.270.10:FF:000116', NULL, NULL, 'Prdm2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(34294, NULL, 'G3DSA:3.40.50.360:FF:000125', NULL, NULL, 'Neuronal nitric oxide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(34295, NULL, 'G3DSA:3.30.310.130:FF:000034', NULL, NULL, 'SUMO-specific peptidase 6a', NULL, NULL, NULL, NULL, NULL, 4),
(34296, NULL, 'G3DSA:1.20.5.170:FF:000243', NULL, NULL, 'Transcription factor VBP', NULL, NULL, NULL, NULL, NULL, 4),
(34297, NULL, 'G3DSA:3.10.20.740:FF:000004', NULL, NULL, 'NADH-quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(34298, NULL, 'G3DSA:2.130.10.10:FF:000203', NULL, NULL, 'WD repeat domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(34299, NULL, 'G3DSA:1.20.1420.30:FF:000066', NULL, NULL, 'Na/Ca eXchangers', NULL, NULL, NULL, NULL, NULL, 4),
(34300, NULL, 'G3DSA:1.20.1070.10:FF:000398', NULL, NULL, 'FSHR (Mammalian follicle stimulating hormone receptor) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(34301, NULL, 'G3DSA:3.90.79.20:FF:000027', NULL, NULL, 'Hydrolase, NUDIX family protein', NULL, NULL, NULL, NULL, NULL, 4),
(34302, NULL, 'G3DSA:3.30.70.330:FF:000494', NULL, NULL, '28 kDa ribonucleoprotein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(34303, NULL, 'G3DSA:2.130.10.10:FF:003300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34304, NULL, 'G3DSA:2.60.120.260:FF:000478', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34305, NULL, 'G3DSA:3.20.20.80:FF:000469', NULL, NULL, 'Glycoside hydrolase family 35', NULL, NULL, NULL, NULL, NULL, 4),
(34306, NULL, 'G3DSA:1.20.1740.10:FF:000241', NULL, NULL, 'Membrane transporter', NULL, NULL, NULL, NULL, NULL, 4),
(34307, NULL, 'G3DSA:1.50.40.10:FF:000481', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34308, NULL, 'G3DSA:1.10.460.10:FF:000009', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(34309, NULL, 'G3DSA:1.10.10.750:FF:000035', NULL, NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', NULL, NULL, NULL, NULL, NULL, 4),
(34310, NULL, 'G3DSA:3.40.50.10490:FF:000054', NULL, NULL, 'Sugar isomerase, AgaS family', NULL, NULL, NULL, NULL, NULL, 4),
(34311, NULL, 'G3DSA:3.90.290.10:FF:000015', NULL, NULL, 'Latent transforming growth factor beta binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(34312, NULL, 'G3DSA:1.10.533.10:FF:000134', NULL, NULL, 'Netrin receptor unc-5', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(34313, NULL, 'G3DSA:2.40.50.140:FF:000592', NULL, NULL, 'Single-stranded DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(34314, NULL, 'G3DSA:3.40.50.1910:FF:000022', NULL, NULL, 'Protein transport Sec1b', NULL, NULL, NULL, NULL, NULL, 4),
(34315, NULL, 'G3DSA:3.40.50.720:FF:001088', NULL, NULL, 'NAD(P)-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(34316, NULL, 'G3DSA:3.30.160.60:FF:002928', NULL, NULL, 'Related to C2H2-type zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(34317, NULL, 'G3DSA:1.20.140.50:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34318, NULL, 'G3DSA:3.30.160.60:FF:003417', NULL, NULL, 'GD16884', NULL, NULL, NULL, NULL, NULL, 4),
(34319, NULL, 'G3DSA:1.25.10.10:FF:001195', NULL, NULL, 'Transportin 2', NULL, NULL, NULL, NULL, NULL, 4),
(34320, NULL, 'G3DSA:2.60.120.10:FF:000036', NULL, NULL, 'Homogentisate 1,2-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(34321, NULL, 'G3DSA:1.25.40.20:FF:000744', NULL, NULL, 'Si:dkey-9i23.14', NULL, NULL, NULL, NULL, NULL, 4),
(34322, NULL, 'G3DSA:1.20.1560.10:FF:000598', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34323, NULL, 'G3DSA:2.40.70.10:FF:000306', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34324, NULL, 'G3DSA:3.20.20.70:FF:000157', NULL, NULL, 'Orotidine 5''-phosphate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(34325, NULL, 'G3DSA:3.40.50.1820:FF:000759', NULL, NULL, 'GD18190', NULL, NULL, NULL, NULL, NULL, 4),
(34326, NULL, 'G3DSA:3.30.70.1320:FF:000005', NULL, NULL, 'Putative cation efflux system protein CusA', NULL, NULL, NULL, NULL, NULL, 4),
(34327, NULL, 'G3DSA:2.70.98.110:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34328, NULL, 'G3DSA:1.20.1250.20:FF:000353', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(34329, NULL, 'G3DSA:3.30.160.60:FF:003726', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34330, NULL, 'G3DSA:2.130.10.10:FF:006026', NULL, NULL, 'Centriole proteome protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(34331, NULL, 'G3DSA:3.30.70.330:FF:000746', NULL, NULL, 'Glycine-rich RNA-binding protein RZ1A', NULL, NULL, NULL, NULL, NULL, 4),
(34332, NULL, 'G3DSA:3.80.10.10:FF:004104', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(34333, NULL, 'G3DSA:1.20.1070.10:FF:000931', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34334, NULL, 'G3DSA:1.10.10.10:FF:001571', NULL, NULL, 'Uncharacterized HTH-type transcriptional regulator SCO4628', NULL, NULL, NULL, NULL, NULL, 4),
(34335, NULL, 'G3DSA:3.30.70.1730:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34336, NULL, 'G3DSA:1.20.1280.290:FF:000045', NULL, NULL, 'PQ loop repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(34337, NULL, 'G3DSA:1.20.140.150:FF:000004', NULL, NULL, 'Voltage-dependent calcium channel gamma-4 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(34338, NULL, 'G3DSA:2.60.40.10:FF:002007', NULL, NULL, 'Eph receptor A2 a', NULL, NULL, NULL, NULL, NULL, 4),
(34339, NULL, 'G3DSA:3.40.50.300:FF:003912', NULL, NULL, 'ABC_transporter_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(34340, NULL, 'G3DSA:3.90.1720.10:FF:000020', NULL, NULL, 'Inositol-1,4,5-trisphosphate 5-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(34341, NULL, 'G3DSA:1.20.1440.340:FF:000013', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(34342, NULL, 'G3DSA:3.90.180.10:FF:000018', NULL, NULL, 'NAD(P)-dependent alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(34343, NULL, 'G3DSA:1.20.1410.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34344, NULL, 'G3DSA:2.60.40.10:FF:000315', NULL, NULL, 'Down syndrome cell adhesion molecule like 1', NULL, NULL, NULL, NULL, NULL, 4),
(34345, NULL, 'G3DSA:3.60.40.10:FF:000352', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34346, NULL, 'G3DSA:3.90.550.10:FF:000507', NULL, NULL, 'Nucleotide-diphospho-sugar transferase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(34347, NULL, 'G3DSA:1.10.238.10:FF:000302', NULL, NULL, 'Probable calcium-binding protein CML46', NULL, NULL, NULL, NULL, NULL, 4),
(34348, NULL, 'G3DSA:3.15.10.30:FF:000005', NULL, NULL, 'Blast:Protein takeout', NULL, NULL, NULL, NULL, NULL, 4),
(34349, NULL, 'G3DSA:1.10.3210.30:FF:000007', NULL, NULL, 'CRISPR-associated helicase Cas3', NULL, NULL, NULL, NULL, NULL, 4),
(34350, NULL, 'G3DSA:1.25.40.10:FF:000073', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(34351, NULL, 'G3DSA:3.30.70.330:FF:001691', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34352, NULL, 'G3DSA:3.10.20.30:FF:000112', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34353, NULL, 'G3DSA:1.25.40.20:FF:001711', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34354, NULL, 'G3DSA:1.10.10.10:FF:002116', NULL, NULL, 'Selenocysteine-specific elongation factor', NULL, NULL, NULL, NULL, NULL, 4),
(34355, NULL, 'G3DSA:2.60.40.3500:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34356, NULL, 'G3DSA:2.30.30.100:FF:000128', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm3p', NULL, NULL, NULL, NULL, NULL, 4),
(34357, NULL, 'G3DSA:3.30.710.10:FF:000472', NULL, NULL, 'SKP1-like protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(34358, NULL, 'G3DSA:3.40.50.300:FF:000153', NULL, NULL, 'Dynein axonemal heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(34359, NULL, 'G3DSA:3.40.30.10:FF:000925', NULL, NULL, 'Iodothyronine deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(34360, NULL, 'G3DSA:3.40.50.12470:FF:000013', NULL, NULL, '2-oxoglutarate dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(34361, NULL, 'G3DSA:3.30.1370.50:FF:000018', NULL, NULL, 'LD33178p', NULL, NULL, NULL, NULL, NULL, 4),
(34362, NULL, 'G3DSA:3.30.40.10:FF:001713', NULL, NULL, 'E3 ubiquitin-protein ligase WAV3', NULL, NULL, NULL, NULL, NULL, 4),
(34363, NULL, 'G3DSA:2.60.40.10:FF:001299', NULL, NULL, 'Programmed cell death 1', NULL, NULL, NULL, NULL, NULL, 4),
(34364, NULL, 'G3DSA:3.40.50.360:FF:000108', NULL, NULL, 'Possible NAD(P)H dehydrogenase (Quinone)', NULL, NULL, NULL, NULL, NULL, 4),
(34365, NULL, 'G3DSA:1.10.3210.10:FF:000013', NULL, NULL, 'Ribonuclease Y', NULL, NULL, NULL, NULL, NULL, 4),
(34366, NULL, 'G3DSA:1.10.10.10:FF:001026', NULL, NULL, 'Bloom syndrome protein', NULL, NULL, NULL, NULL, NULL, 4),
(34367, NULL, 'G3DSA:2.30.110.10:FF:000014', NULL, NULL, 'Pyridoxine/pyridoxamine 5''-phosphate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(34368, NULL, 'G3DSA:1.10.10.10:FF:001604', NULL, NULL, 'ETS class transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(34369, NULL, 'G3DSA:3.30.160.60:FF:001855', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(34370, NULL, 'G3DSA:1.10.10.60:FF:000956', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34371, NULL, 'G3DSA:2.130.10.10:FF:005661', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(34372, NULL, 'G3DSA:1.20.58.1340:FF:000002', NULL, NULL, 'Envelope glycoprotein H', NULL, NULL, NULL, NULL, NULL, 4),
(34373, NULL, 'G3DSA:3.20.20.100:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34374, NULL, 'G3DSA:3.30.160.60:FF:002889', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34375, NULL, 'G3DSA:3.40.50.2300:FF:000678', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(34376, NULL, 'G3DSA:1.25.40.10:FF:004940', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34377, NULL, 'G3DSA:3.80.10.10:FF:000361', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase ERL1', NULL, NULL, NULL, NULL, NULL, 4),
(34378, NULL, 'G3DSA:2.60.40.10:FF:003968', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34379, NULL, 'G3DSA:2.30.130.10:FF:000027', NULL, NULL, '60S ribosome subunit biogenesis protein NIP7 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(34380, NULL, 'G3DSA:1.20.140.10:FF:000028', NULL, NULL, 'Acyl-CoA dehydrogenase FadE34', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(34381, NULL, 'G3DSA:3.30.1330.30:FF:000049', NULL, NULL, '23S rRNA (guanosine-2''-O-)-methyltransferase RlmB', NULL, NULL, NULL, NULL, NULL, 4),
(34382, NULL, 'G3DSA:2.30.29.30:FF:000650', NULL, NULL, 'Miro family protein', NULL, NULL, NULL, NULL, NULL, 4),
(34383, NULL, 'G3DSA:3.30.160.380:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34384, NULL, 'G3DSA:3.40.50.1000:FF:000873', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34385, NULL, 'G3DSA:2.60.40.150:FF:000695', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(34386, NULL, 'G3DSA:3.20.20.80:FF:000339', NULL, NULL, 'Chondroitin proteoglycan 1', NULL, NULL, NULL, NULL, NULL, 4),
(34387, NULL, 'G3DSA:3.10.20.80:FF:000008', NULL, NULL, 'Translation initiation factor IF-3', NULL, NULL, NULL, NULL, NULL, 4),
(34388, NULL, 'G3DSA:1.10.287.130:FF:000120', NULL, NULL, 'RteA, two-component system histidine kinase, with response regulator receiver domain', NULL, NULL, NULL, NULL, NULL, 4),
(34389, NULL, 'G3DSA:1.10.287.70:FF:000360', NULL, NULL, 'Potassium two pore domain channel subfamily K member 6', NULL, NULL, NULL, NULL, NULL, 4),
(34390, NULL, 'G3DSA:3.40.50.2000:FF:000706', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34391, NULL, 'G3DSA:1.25.40.10:FF:003304', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g53600, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(34392, NULL, 'G3DSA:2.130.10.10:FF:005059', NULL, NULL, 'U3 small nucleolar RNA-associated protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(34393, NULL, 'G3DSA:2.40.50.140:FF:000608', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC8', NULL, NULL, NULL, NULL, NULL, 4),
(34394, NULL, 'G3DSA:1.10.510.10:FF:001262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34395, NULL, 'G3DSA:2.60.40.10:FF:005205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34396, NULL, 'G3DSA:1.10.555.10:FF:000207', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34397, NULL, 'G3DSA:3.40.850.10:FF:000249', NULL, NULL, 'Kif3a protein', NULL, NULL, NULL, NULL, NULL, 4),
(34398, NULL, 'G3DSA:1.10.150.240:FF:000013', NULL, NULL, 'Glycerol-3-phosphate phosphatase (GppA)', NULL, NULL, NULL, NULL, NULL, 4),
(34399, NULL, 'G3DSA:3.40.710.10:FF:000094', NULL, NULL, 'Penicillin-binding protein 2B (PBP-2B)', NULL, NULL, NULL, NULL, NULL, 4),
(34400, NULL, 'G3DSA:3.30.420.10:FF:000236', NULL, NULL, 'Protein piwi', NULL, NULL, NULL, NULL, NULL, 4),
(34401, NULL, 'G3DSA:1.20.1560.10:FF:000704', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(34402, NULL, 'G3DSA:3.40.50.300:FF:006077', NULL, NULL, 'ABC transporter C family member 10', NULL, NULL, NULL, NULL, NULL, 4),
(34403, NULL, 'G3DSA:3.30.40.10:FF:002332', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(34404, NULL, 'G3DSA:3.40.605.10:FF:000040', NULL, NULL, 'Alpha-aminoadipic semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(34405, NULL, 'G3DSA:3.40.50.1240:FF:000130', NULL, NULL, 'Histidine phosphatase superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(34406, NULL, 'G3DSA:3.40.50.11340:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34407, NULL, 'G3DSA:3.30.160.360:FF:000011', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(34408, NULL, 'G3DSA:1.20.58.60:FF:000425', NULL, NULL, 'SMAll', NULL, NULL, NULL, NULL, NULL, 4),
(34409, NULL, 'G3DSA:1.10.510.10:FF:002352', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34410, NULL, 'G3DSA:3.30.1520.10:FF:000182', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(34411, NULL, 'G3DSA:1.10.720.30:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34412, NULL, 'G3DSA:3.20.20.190:FF:000005', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(34413, NULL, 'G3DSA:2.70.170.10:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(34414, NULL, 'G3DSA:3.30.40.10:FF:001820', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34415, NULL, 'G3DSA:1.25.10.10:FF:003224', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(34416, NULL, 'G3DSA:3.40.30.10:FF:000818', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(34417, NULL, 'G3DSA:3.40.1180.10:FF:000023', NULL, NULL, 'Dehydrodolichyl diphosphate synthase 8', NULL, NULL, NULL, NULL, NULL, 4),
(34418, NULL, 'G3DSA:3.30.465.10:FF:000025', NULL, NULL, 'FAD-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(34419, NULL, 'G3DSA:2.60.120.820:FF:000017', NULL, NULL, 'RING zinc finger-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(34420, NULL, 'G3DSA:3.50.30.30:FF:000150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34421, NULL, 'G3DSA:1.25.40.10:FF:004833', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34422, NULL, 'G3DSA:3.20.90.10:FF:000003', NULL, NULL, 'Tubby-like F-box protein', NULL, NULL, NULL, NULL, NULL, 4),
(34423, NULL, 'G3DSA:2.60.120.10:FF:000486', NULL, NULL, 'Lysine-specific demethylase 8', NULL, NULL, NULL, NULL, NULL, 4),
(34424, NULL, 'G3DSA:3.30.1240.10:FF:000031', NULL, NULL, 'Sugar phosphatase YidA', NULL, NULL, NULL, NULL, NULL, 4),
(34425, NULL, 'G3DSA:2.60.200.20:FF:000113', NULL, NULL, 'Checkpoint kinase 2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(34426, NULL, 'G3DSA:3.30.160.60:FF:000219', NULL, NULL, 'Zinc finger protein 276', NULL, NULL, NULL, NULL, NULL, 4),
(34427, NULL, 'G3DSA:3.30.390.10:FF:000019', NULL, NULL, 'Mandelate racemase/muconate lactonizing protein', NULL, NULL, NULL, NULL, NULL, 4),
(34428, NULL, 'G3DSA:3.40.50.1820:FF:000675', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(34429, NULL, 'G3DSA:1.10.630.10:FF:000276', NULL, NULL, 'Cytochrome P450 family 1 subfamily A member 1', NULL, NULL, NULL, NULL, NULL, 4),
(34430, NULL, 'G3DSA:2.60.40.10:FF:005677', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34431, NULL, 'G3DSA:3.10.310.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34432, NULL, 'G3DSA:3.30.470.20:FF:000068', NULL, NULL, 'Tubulin-tyrosine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(34433, NULL, 'G3DSA:1.20.1320.30:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34434, NULL, 'G3DSA:3.20.20.140:FF:000468', NULL, NULL, 'N-substituted formamide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(34435, NULL, 'G3DSA:3.80.10.10:FF:003008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34436, NULL, 'G3DSA:3.40.50.150:FF:000866', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34437, NULL, 'G3DSA:2.40.128.20:FF:000062', NULL, NULL, 'Apolipoprotein D', NULL, NULL, NULL, NULL, NULL, 4),
(34438, NULL, 'G3DSA:2.10.25.10:FF:000945', NULL, NULL, 'Signal peptide, CUB domain, EGF-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(34439, NULL, 'G3DSA:3.30.60.20:FF:000043', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(34440, NULL, 'G3DSA:3.30.200.20:FF:000498', NULL, NULL, 'Serine/threonine-protein kinase KIN28', NULL, NULL, NULL, NULL, NULL, 4),
(34441, NULL, 'G3DSA:3.30.230.10:FF:000334', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(34442, NULL, 'G3DSA:2.60.40.200:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34443, NULL, 'G3DSA:2.130.10.10:FF:004025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34444, NULL, 'G3DSA:3.10.28.10:FF:000005', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g15820, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(34445, NULL, 'G3DSA:3.30.160.60:FF:003081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34446, NULL, 'G3DSA:3.50.50.60:FF:000738', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(34447, NULL, 'G3DSA:1.10.8.60:FF:000427', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(34448, NULL, 'G3DSA:3.30.505.10:FF:000158', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34449, NULL, 'G3DSA:3.80.10.10:FF:001451', NULL, NULL, 'AGAP010218-PA', NULL, NULL, NULL, NULL, NULL, 4),
(34450, NULL, 'G3DSA:3.90.70.10:FF:000757', NULL, NULL, 'Bleomycin hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(34451, NULL, 'G3DSA:2.30.30.180:FF:000006', NULL, NULL, 'Ribosome maturation factor RimP', NULL, NULL, NULL, NULL, NULL, 4),
(34452, NULL, 'G3DSA:3.30.1370.30:FF:000012', NULL, NULL, 'Ribosomal protein S8', NULL, NULL, NULL, NULL, NULL, 4),
(34453, NULL, 'G3DSA:1.20.1070.10:FF:001095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34454, NULL, 'G3DSA:3.20.20.300:FF:000067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34455, NULL, 'G3DSA:2.60.40.10:FF:005194', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34456, NULL, 'G3DSA:2.60.40.150:FF:000223', NULL, NULL, 'Synaptotagmin alpha, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(34457, NULL, 'G3DSA:4.10.1000.10:FF:000073', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(34458, NULL, 'G3DSA:3.40.250.10:FF:000052', NULL, NULL, 'Rhodanese like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34459, NULL, 'G3DSA:2.30.29.30:FF:000318', NULL, NULL, 'insulin receptor substrate 4', NULL, NULL, NULL, NULL, NULL, 4),
(34460, NULL, 'G3DSA:3.40.50.300:FF:004424', NULL, NULL, 'Cell cycle checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(34461, NULL, 'G3DSA:1.20.1070.10:FF:002185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34462, NULL, 'G3DSA:2.60.40.1670:FF:000002', NULL, NULL, 'SEC24 homolog B, COPII coat complex component', NULL, NULL, NULL, NULL, NULL, 4),
(34463, NULL, 'G3DSA:1.20.1260.140:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34464, NULL, 'G3DSA:2.70.170.10:FF:000296', NULL, NULL, 'Protein CBG26995', NULL, NULL, NULL, NULL, NULL, 4),
(34465, NULL, 'G3DSA:3.60.10.10:FF:000417', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34466, NULL, 'G3DSA:1.10.10.10:FF:001498', NULL, NULL, 'Transcriptional adapter', NULL, NULL, NULL, NULL, NULL, 4),
(34467, NULL, 'G3DSA:3.40.50.300:FF:003334', NULL, NULL, 'Ras family gtpase', NULL, NULL, NULL, NULL, NULL, 4),
(34468, NULL, 'G3DSA:1.25.10.10:FF:000245', NULL, NULL, 'Beta-catenin-like protein 1 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(34469, NULL, 'G3DSA:3.40.50.620:FF:000895', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34470, NULL, 'G3DSA:3.30.420.10:FF:000461', NULL, NULL, 'DNA polymerase alpha subunit one', NULL, NULL, NULL, NULL, NULL, 4),
(34471, NULL, 'G3DSA:3.30.70.270:FF:000251', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34472, NULL, 'G3DSA:3.40.50.1820:FF:001400', NULL, NULL, 'Uncharacterized hydrolase C9G1.08c', NULL, NULL, NULL, NULL, NULL, 4),
(34473, NULL, 'G3DSA:1.10.510.10:FF:003768', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34474, NULL, 'G3DSA:3.90.1640.20:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34475, NULL, 'G3DSA:1.20.5.110:FF:000271', NULL, NULL, 'Qb+c-SNARE protein, SNAP25-family', NULL, NULL, NULL, NULL, NULL, 4),
(34476, NULL, 'G3DSA:3.20.20.60:FF:000019', NULL, NULL, 'CoA ester lyase', NULL, NULL, NULL, NULL, NULL, 4),
(34477, NULL, 'G3DSA:4.10.640.30:FF:000001', NULL, NULL, 'DNA damage-binding protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(34478, NULL, 'G3DSA:1.25.10.10:FF:000953', NULL, NULL, 'Protein phosphatase 2A regulatory subunit A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34479, NULL, 'G3DSA:3.90.1750.10:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34480, NULL, 'G3DSA:1.10.1450.10:FF:000098', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(34481, NULL, 'G3DSA:1.25.10.10:FF:001987', NULL, NULL, 'Putative pumilio/PUF RNA binding protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(34482, NULL, 'G3DSA:1.20.1270.220:FF:000005', NULL, NULL, 'Transcription initiation factor TFIID subunit 14', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(34483, NULL, 'G3DSA:1.10.1270.10:FF:000005', NULL, NULL, 'Trp operon repressor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(34484, NULL, 'G3DSA:1.10.287.810:FF:000003', NULL, NULL, 'Mitochondrial import inner membrane translocase subunit TIM8', NULL, NULL, NULL, NULL, NULL, 4),
(34485, NULL, 'G3DSA:1.20.1250.20:FF:001679', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(34486, NULL, 'G3DSA:2.60.120.10:FF:000267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34487, NULL, 'G3DSA:4.10.240.10:FF:000173', NULL, NULL, 'Zcf6p', NULL, NULL, NULL, NULL, NULL, 4),
(34488, NULL, 'G3DSA:3.40.50.1360:FF:000020', NULL, NULL, 'Glucose-6-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(34489, NULL, 'G3DSA:1.10.10.10:FF:000082', NULL, NULL, 'forkhead box protein B2', NULL, NULL, NULL, NULL, NULL, 4),
(34490, NULL, 'G3DSA:1.25.40.20:FF:000328', NULL, NULL, 'BTB/POZ domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(34491, NULL, 'G3DSA:3.10.400.20:FF:000001', NULL, NULL, 'Malignant T-cell-amplified sequence 1', NULL, NULL, NULL, NULL, NULL, 4),
(34492, NULL, 'G3DSA:3.30.1680.10:FF:000030', NULL, NULL, 'Sema domain, immunoglobulin domain (Ig), transmembrane domain (TM) and short cytoplasmic domain, (semaphorin) 4Aa', NULL, NULL, NULL, NULL, NULL, 4),
(34493, NULL, 'G3DSA:3.80.10.10:FF:000737', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(34494, NULL, 'G3DSA:3.30.497.10:FF:000104', NULL, NULL, 'Serpin family E member 3', NULL, NULL, NULL, NULL, NULL, 4),
(34495, NULL, 'G3DSA:1.10.630.10:FF:000585', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34496, NULL, 'G3DSA:2.60.40.60:FF:001049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34497, NULL, 'G3DSA:3.30.1600.10:FF:000014', NULL, NULL, 'NAD-dependent histone deacetylase SIR2', NULL, NULL, NULL, NULL, NULL, 4),
(34498, NULL, 'G3DSA:1.25.40.10:FF:003052', NULL, NULL, 'Activator of C kinase protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(34499, NULL, 'G3DSA:2.130.10.10:FF:002788', NULL, NULL, 'WD-40 repeat protein family', NULL, NULL, NULL, NULL, NULL, 4),
(34500, NULL, 'G3DSA:2.130.10.10:FF:001586', NULL, NULL, 'protein CYPRO4', NULL, NULL, NULL, NULL, NULL, 4),
(34501, NULL, 'G3DSA:3.40.50.10190:FF:000161', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(34502, NULL, 'G3DSA:1.10.287.70:FF:000141', NULL, NULL, 'Polycystin family receptor for egg jelly', NULL, NULL, NULL, NULL, NULL, 4),
(34503, NULL, 'G3DSA:3.90.550.50:FF:000042', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(34504, NULL, 'G3DSA:2.40.270.10:FF:000012', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(34505, NULL, 'G3DSA:2.60.120.260:FF:000006', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(34506, NULL, 'G3DSA:3.40.50.410:FF:000146', NULL, NULL, 'ATP-dependent DNA helicase II subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(34507, NULL, 'G3DSA:1.20.58.1120:FF:000066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34508, NULL, 'G3DSA:1.20.1250.20:FF:001207', NULL, NULL, 'Glucose/mannose transporter GlcP', NULL, NULL, NULL, NULL, NULL, 4),
(34509, NULL, 'G3DSA:3.40.1410.10:FF:000042', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(34510, NULL, 'G3DSA:3.90.810.10:FF:000005', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(34511, NULL, 'G3DSA:1.25.40.10:FF:002995', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34512, NULL, 'G3DSA:2.30.30.40:FF:000072', NULL, NULL, 'Unconventional Myosin IB', NULL, NULL, NULL, NULL, NULL, 4),
(34513, NULL, 'G3DSA:3.10.20.90:FF:000231', NULL, NULL, 'Ubiquitin C-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(34514, NULL, 'G3DSA:1.20.120.230:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34515, NULL, 'G3DSA:2.60.40.10:FF:002024', NULL, NULL, 'Sperm-specific class P protein 19', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(34516, NULL, 'G3DSA:3.90.850.10:FF:000019', NULL, NULL, 'Fumarylacetoacetate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(34517, NULL, 'G3DSA:1.25.10.10:FF:002499', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34518, NULL, 'G3DSA:3.20.20.220:FF:000032', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(34519, NULL, 'G3DSA:1.10.287.110:FF:000434', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34520, NULL, 'G3DSA:1.10.8.610:FF:000001', NULL, NULL, 'Siroheme synthase', NULL, NULL, NULL, NULL, NULL, 4),
(34521, NULL, 'G3DSA:3.60.21.10:FF:000336', NULL, NULL, 'Purple acid phosphatase 3', NULL, NULL, NULL, NULL, NULL, 4),
(34522, NULL, 'G3DSA:3.40.50.300:FF:007297', NULL, NULL, 'Nuclear GTPase, germinal center-associated, tandem duplicate 1', NULL, NULL, NULL, NULL, NULL, 4),
(34523, NULL, 'G3DSA:1.10.510.10:FF:000643', NULL, NULL, 'serine/threonine-protein kinase Nek10 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(34524, NULL, 'G3DSA:3.40.630.30:FF:000262', NULL, NULL, 'Protein N-acetyltransferase, RimJ/RimL family', NULL, NULL, NULL, NULL, NULL, 4),
(34525, NULL, 'G3DSA:1.20.5.340:FF:000064', NULL, NULL, 'Protein CBR-LET-75', NULL, NULL, NULL, NULL, NULL, 4),
(34526, NULL, 'G3DSA:3.60.130.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34527, NULL, 'G3DSA:1.20.1070.10:FF:001460', NULL, NULL, 'RE03009p', NULL, NULL, NULL, NULL, NULL, 4),
(34528, NULL, 'G3DSA:3.30.200.20:FF:000026', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(34529, NULL, 'G3DSA:3.40.50.720:FF:002268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34530, NULL, 'G3DSA:1.20.1250.20:FF:002298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34531, NULL, 'G3DSA:1.20.1250.20:FF:000954', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(34532, NULL, 'G3DSA:2.60.40.60:FF:000324', NULL, NULL, 'FlaMIngo (Cadherin plus 7TM domain) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(34533, NULL, 'G3DSA:3.80.10.10:FF:002176', NULL, NULL, 'F-box/LRR-repeat protein At3g62440', NULL, NULL, NULL, NULL, NULL, 4),
(34534, NULL, 'G3DSA:3.30.365.10:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34535, NULL, 'G3DSA:3.10.20.310:FF:000033', NULL, NULL, 'Hemolysin activator-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(34536, NULL, 'G3DSA:1.10.8.720:FF:000034', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(34537, NULL, 'G3DSA:2.60.40.420:FF:000091', NULL, NULL, 'Copper-containing nitrite reductase', NULL, NULL, NULL, NULL, NULL, 4),
(34538, NULL, 'G3DSA:3.30.40.10:FF:000387', NULL, NULL, 'RING finger protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(34539, NULL, 'G3DSA:3.30.160.60:FF:002237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34540, NULL, 'G3DSA:3.90.1420.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34541, NULL, 'G3DSA:2.40.50.90:FF:000059', NULL, NULL, 'Ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(34542, NULL, 'G3DSA:3.10.129.10:FF:000081', NULL, NULL, 'Acyl-CoA thioester hydrolase, YbgC/YbaW family', NULL, NULL, NULL, NULL, NULL, 4),
(34543, NULL, 'G3DSA:1.10.132.60:FF:000032', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(34544, NULL, 'G3DSA:3.30.450.20:FF:000319', NULL, NULL, 'Hypoxia-inducible factor 1 subunit alpha,-like', NULL, NULL, NULL, NULL, NULL, 4),
(34545, NULL, 'G3DSA:3.10.20.620:FF:000007', NULL, NULL, 'Autophagy protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(34546, NULL, 'G3DSA:1.10.600.10:FF:000072', NULL, NULL, 'Phytoene synthase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(34547, NULL, 'G3DSA:2.20.100.10:FF:000016', NULL, NULL, 'ADAMTS-like 3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(34548, NULL, 'G3DSA:3.40.50.300:FF:007173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34549, NULL, 'G3DSA:1.20.58.400:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(34550, NULL, 'G3DSA:3.30.40.10:FF:001005', NULL, NULL, 'TNF receptor-associated factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(34551, NULL, 'G3DSA:2.130.10.10:FF:003406', NULL, NULL, 'YALI0C15653p', NULL, NULL, NULL, NULL, NULL, 4),
(34552, NULL, 'G3DSA:1.25.10.10:FF:002971', NULL, NULL, 'Exportin 1', NULL, NULL, NULL, NULL, NULL, 4),
(34553, NULL, 'G3DSA:3.30.70.330:FF:000269', NULL, NULL, 'Probable rna-binding protein 23 isoform', NULL, NULL, NULL, NULL, NULL, 4),
(34554, NULL, 'G3DSA:2.60.40.10:FF:000079', NULL, NULL, 'Filamin-B isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(34555, NULL, 'G3DSA:3.30.2410.10:FF:000005', NULL, NULL, 'E3 ubiquitin-protein ligase TRIP12 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(34556, NULL, 'G3DSA:3.40.50.10190:FF:000318', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34557, NULL, 'G3DSA:2.30.180.10:FF:000182', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34558, NULL, 'G3DSA:3.40.50.2300:FF:001297', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34559, NULL, 'G3DSA:3.40.190.10:FF:000120', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(34560, NULL, 'G3DSA:1.20.1070.10:FF:000476', NULL, NULL, 'Protein CBR-GNRR-6', NULL, NULL, NULL, NULL, NULL, 4),
(34561, NULL, 'G3DSA:1.25.40.10:FF:003613', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g23020', NULL, NULL, NULL, NULL, NULL, 4),
(34562, NULL, 'G3DSA:3.30.230.130:FF:000009', NULL, NULL, 'Cullin 9', NULL, NULL, NULL, NULL, NULL, 4),
(34563, NULL, 'G3DSA:2.130.10.10:FF:001372', NULL, NULL, 'U3 snoRNP protein', NULL, NULL, NULL, NULL, NULL, 4),
(34564, NULL, 'G3DSA:2.60.40.60:FF:000072', NULL, NULL, 'Protocadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(34565, NULL, 'G3DSA:3.90.1620.10:FF:000001', NULL, NULL, 'Penton protein', NULL, NULL, NULL, NULL, NULL, 4),
(34566, NULL, 'G3DSA:1.10.506.10:FF:000004', NULL, NULL, 'IQ motif containing GTPase activating protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(34567, NULL, 'G3DSA:3.40.50.300:FF:002822', NULL, NULL, 'ABC transporter C family member 7', NULL, NULL, NULL, NULL, NULL, 4),
(34568, NULL, 'G3DSA:1.50.40.10:FF:000037', NULL, NULL, 'Solute carrier family 25 member 29', NULL, NULL, NULL, NULL, NULL, 4),
(34569, NULL, 'G3DSA:1.10.3080.10:FF:000053', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(34570, NULL, 'G3DSA:1.10.10.10:FF:000879', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(34571, NULL, 'G3DSA:2.60.120.920:FF:000120', NULL, NULL, 'Si:ch211-42i6.2', NULL, NULL, NULL, NULL, NULL, 4),
(34572, NULL, 'G3DSA:2.60.40.10:FF:000787', NULL, NULL, 'ephrin type-B receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(34573, NULL, 'G3DSA:3.50.50.60:FF:001357', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(34574, NULL, 'G3DSA:2.10.25.10:FF:000260', NULL, NULL, 'Notch receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(34575, NULL, 'G3DSA:3.40.50.150:FF:001119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34576, NULL, 'G3DSA:3.30.70.330:FF:000977', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34577, NULL, 'G3DSA:1.10.10.1540:FF:000003', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(34578, NULL, 'G3DSA:2.60.40.60:FF:000633', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34579, NULL, 'G3DSA:3.40.50.150:FF:000158', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(34580, NULL, 'G3DSA:3.80.10.10:FF:000467', NULL, NULL, 'Cyclic nucleotide-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(34581, NULL, 'G3DSA:2.80.10.50:FF:000105', NULL, NULL, 'Actin cross-linking protein, putative (DUF569)', NULL, NULL, NULL, NULL, NULL, 4),
(34582, NULL, 'G3DSA:1.10.510.10:FF:001970', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34583, NULL, 'G3DSA:3.40.50.1110:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34584, NULL, 'G3DSA:3.40.50.300:FF:004059', NULL, NULL, 'Pentafunctional AROM polypeptide', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(34585, NULL, 'G3DSA:3.40.1110.10:FF:000002', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(34586, NULL, 'G3DSA:3.30.40.10:FF:002096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34587, NULL, 'G3DSA:1.10.890.10:FF:000002', NULL, NULL, 'Acid stress chaperone HdeB', NULL, NULL, NULL, NULL, NULL, 4),
(34588, NULL, 'G3DSA:2.40.70.10:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34589, NULL, 'G3DSA:3.90.940.10:FF:000009', NULL, NULL, 'DNA-directed RNA polymerases I', NULL, NULL, NULL, NULL, NULL, 4),
(34590, NULL, 'G3DSA:3.30.1490.20:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34591, NULL, 'G3DSA:3.40.50.300:FF:005352', NULL, NULL, 'Exodeoxyribonuclease V, gamma subunit', NULL, NULL, NULL, NULL, NULL, 4),
(34592, NULL, 'G3DSA:3.30.565.10:FF:000297', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(34593, NULL, 'G3DSA:2.130.10.10:FF:005970', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(34594, NULL, 'G3DSA:1.10.150.50:FF:000127', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(34595, NULL, 'G3DSA:2.60.120.10:FF:000722', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34596, NULL, 'G3DSA:1.20.58.150:FF:000001', NULL, NULL, 'phosphatidylinositol-binding clathrin assembly protein-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(34597, NULL, 'G3DSA:1.25.40.20:FF:001817', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34598, NULL, 'G3DSA:1.10.150.110:FF:000025', NULL, NULL, 'Crossover junction endonuclease MUS81', NULL, NULL, NULL, NULL, NULL, 4),
(34599, NULL, 'G3DSA:3.30.160.20:FF:000202', NULL, NULL, 'Peptide chain release factor PrfB3, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(34600, NULL, 'G3DSA:1.10.1750.10:FF:000008', NULL, NULL, 'Chromosomal replication initiator protein DnaA 1', NULL, NULL, NULL, NULL, NULL, 4),
(34601, NULL, 'G3DSA:3.30.300.30:FF:000104', NULL, NULL, 'Fatty acyl-AMP ligase', NULL, NULL, NULL, NULL, NULL, 4),
(34602, NULL, 'G3DSA:2.20.25.630:FF:000004', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(34603, NULL, 'G3DSA:3.20.20.140:FF:000215', NULL, NULL, 'Putative imidazolonepropionase', NULL, NULL, NULL, NULL, NULL, 4),
(34604, NULL, 'G3DSA:3.90.950.10:FF:000038', NULL, NULL, 'dTTP/UTP pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(34605, NULL, 'G3DSA:3.40.50.1820:FF:001057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34606, NULL, 'G3DSA:2.30.30.140:FF:000314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34607, NULL, 'G3DSA:2.10.220.10:FF:000117', NULL, NULL, 'Proprotein convertase subtilisin/kexin type', NULL, NULL, NULL, NULL, NULL, 4),
(34608, NULL, 'G3DSA:3.40.309.10:FF:000037', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(34609, NULL, 'G3DSA:2.60.120.290:FF:000004', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(34610, NULL, 'G3DSA:3.50.50.60:FF:000177', NULL, NULL, 'Lysine-specific histone demethylase Aof2', NULL, NULL, NULL, NULL, NULL, 4),
(34611, NULL, 'G3DSA:2.60.40.420:FF:000124', NULL, NULL, 'Laccase-10-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(34612, NULL, 'G3DSA:1.50.10.10:FF:000198', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(34613, NULL, 'G3DSA:2.40.10.10:FF:000224', NULL, NULL, 'Protease, serine 51', NULL, NULL, NULL, NULL, NULL, 4),
(34614, NULL, 'G3DSA:3.40.50.2000:FF:000925', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(34615, NULL, 'G3DSA:1.20.1060.10:FF:000009', NULL, NULL, 'DNA-directed DNA polymerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34616, NULL, 'G3DSA:1.20.80.10:FF:000035', NULL, NULL, 'Inactive tyrosine-protein kinase kin-32', NULL, NULL, NULL, NULL, NULL, 4),
(34617, NULL, 'G3DSA:3.40.50.300:FF:007482', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(34618, NULL, 'G3DSA:2.10.25.10:FF:000636', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34619, NULL, 'G3DSA:2.60.120.330:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34620, NULL, 'G3DSA:3.30.750.24:FF:000128', NULL, NULL, 'Sodium-independent sulfate anion transporter', NULL, NULL, NULL, NULL, NULL, 4),
(34621, NULL, 'G3DSA:2.130.10.10:FF:005638', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(34622, NULL, 'G3DSA:1.20.1260.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34623, NULL, 'G3DSA:3.30.70.1070:FF:000003', NULL, NULL, 'Endolytic peptidoglycan transglycosylase RlpA', NULL, NULL, NULL, NULL, NULL, 4),
(34624, NULL, 'G3DSA:3.30.70.330:FF:002764', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34625, NULL, 'G3DSA:1.20.1560.10:FF:000671', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34626, NULL, 'G3DSA:3.20.20.140:FF:000362', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34627, NULL, 'G3DSA:1.10.238.10:FF:000757', NULL, NULL, 'EF-hand calcium-binding domain 6', NULL, NULL, NULL, NULL, NULL, 4),
(34628, NULL, 'G3DSA:3.40.50.300:FF:006313', NULL, NULL, 'CTP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(34629, NULL, 'G3DSA:3.40.50.300:FF:005695', NULL, NULL, 'ATP-dependent DNA helicase Dna2', NULL, NULL, NULL, NULL, NULL, 4),
(34630, NULL, 'G3DSA:1.10.167.10:FF:000075', NULL, NULL, 'Axin-like protein pry-1', NULL, NULL, NULL, NULL, NULL, 4),
(34631, NULL, 'G3DSA:3.40.50.2300:FF:000948', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34632, NULL, 'G3DSA:2.60.40.10:FF:000006', NULL, NULL, 'Uncharacterized protein, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(34633, NULL, 'G3DSA:3.40.50.720:FF:001560', NULL, NULL, 'Estradiol 17-beta-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(34634, NULL, 'G3DSA:1.20.5.110:FF:000124', NULL, NULL, 'SNARE protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34635, NULL, 'G3DSA:3.40.50.720:FF:000470', NULL, NULL, 'NAD-dependent epimerase/dehydratase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(34636, NULL, 'G3DSA:2.130.10.10:FF:001928', NULL, NULL, 'Autophagy-related protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(34637, NULL, 'G3DSA:3.30.460.10:FF:000126', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(34638, NULL, 'G3DSA:1.10.10.1180:FF:000007', NULL, NULL, 'Man1-Src1p-carboxy-terminal domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(34639, NULL, 'G3DSA:1.25.10.10:FF:000498', NULL, NULL, 'testis-expressed sequence 10 protein', NULL, NULL, NULL, NULL, NULL, 4),
(34640, NULL, 'G3DSA:3.40.830.10:FF:000001', NULL, NULL, '2,3-dihydroxyphenylpropionate/2,3-dihydroxicinnamic acid 1,2-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(34641, NULL, 'G3DSA:2.60.15.10:FF:000026', NULL, NULL, 'ATP synthase epsilon chain', NULL, NULL, NULL, NULL, NULL, 4),
(34642, NULL, 'G3DSA:1.20.1270.250:FF:000003', NULL, NULL, 'Inhibitor of nuclear factor kappa B kinase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(34643, NULL, 'G3DSA:3.40.50.300:FF:003587', NULL, NULL, 'ADP-ribosylation factor-like protein 13B', NULL, NULL, NULL, NULL, NULL, 4),
(34644, NULL, 'G3DSA:2.60.40.180:FF:000018', NULL, NULL, '5-hydroxyisourate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(34645, NULL, 'G3DSA:3.40.50.150:FF:000490', NULL, NULL, 'putative methyltransferase NSUN6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(34646, NULL, 'G3DSA:3.30.230.130:FF:000032', NULL, NULL, 'Anaphase-promoting complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(34647, NULL, 'G3DSA:3.10.20.90:FF:000995', NULL, NULL, 'Plant UBX domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(34648, NULL, 'G3DSA:2.30.330.10:FF:000008', NULL, NULL, 'Flagellar motor switch protein FliN', NULL, NULL, NULL, NULL, NULL, 4),
(34649, NULL, 'G3DSA:3.90.190.10:FF:000070', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase kappa', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(34650, NULL, 'G3DSA:1.25.40.10:FF:001719', NULL, NULL, 'Sgt1p', NULL, NULL, NULL, NULL, NULL, 4),
(34651, NULL, 'G3DSA:2.40.10.220:FF:000006', NULL, NULL, 'Cellulose synthase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(34652, NULL, 'G3DSA:1.10.3470.10:FF:000009', NULL, NULL, 'Fe(3+) dicitrate transport system permease fecC', NULL, NULL, NULL, NULL, NULL, 4),
(34653, NULL, 'G3DSA:3.40.50.2300:FF:000572', NULL, NULL, 'Chemotaxis protein CheY', NULL, NULL, NULL, NULL, NULL, 4),
(34654, NULL, 'G3DSA:3.40.50.620:FF:000439', NULL, NULL, 'Glutamine-dependent NAD(+) synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(34655, NULL, 'G3DSA:3.30.40.10:FF:001348', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(34656, NULL, 'G3DSA:3.30.160.60:FF:002108', NULL, NULL, 'Zinc finger and SCAN domain containing 20', NULL, NULL, NULL, NULL, NULL, 4),
(34657, NULL, 'G3DSA:2.20.70.10:FF:000279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34658, NULL, 'G3DSA:3.40.50.2300:FF:001662', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34659, NULL, 'G3DSA:3.90.70.10:FF:000049', NULL, NULL, 'ubiquitin carboxyl-terminal hydrolase 48', NULL, NULL, NULL, NULL, NULL, 4),
(34660, NULL, 'G3DSA:3.20.20.80:FF:000233', NULL, NULL, 'Probable glucan endo-1,3-beta-glucosidase eglC', NULL, NULL, NULL, NULL, NULL, 4),
(34661, NULL, 'G3DSA:3.10.110.10:FF:000240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34662, NULL, 'G3DSA:3.40.50.720:FF:000267', NULL, NULL, 'Hydroxysteroid 17-beta dehydrogenase 4', NULL, NULL, NULL, NULL, NULL, 4),
(34663, NULL, 'G3DSA:2.60.120.200:FF:000691', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(34664, NULL, 'G3DSA:3.40.50.2300:FF:000369', NULL, NULL, 'Vomeronasal 2, receptor 88', NULL, NULL, NULL, NULL, NULL, 4),
(34665, NULL, 'G3DSA:2.60.40.1730:FF:000121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34666, NULL, 'G3DSA:3.40.50.300:FF:007858', NULL, NULL, 'Peroxisome biogenesis factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(34667, NULL, 'G3DSA:2.10.70.10:FF:000021', NULL, NULL, 'fibronectin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(34668, NULL, 'G3DSA:3.40.50.300:FF:005604', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(34669, NULL, 'G3DSA:3.30.420.80:FF:000021', NULL, NULL, '30S ribosomal protein S11, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(34670, NULL, 'G3DSA:2.10.25.10:FF:001350', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(34671, NULL, 'G3DSA:3.90.1150.10:FF:000347', NULL, NULL, 'Cysteine desulfhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(34672, NULL, 'G3DSA:1.20.1560.10:FF:000918', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34673, NULL, 'G3DSA:2.40.37.20:FF:000002', NULL, NULL, 'D-serine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(34674, NULL, 'G3DSA:3.75.10.10:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34675, NULL, 'G3DSA:3.40.50.300:FF:006004', NULL, NULL, 'Katanin p60 ATPase-containing subunit A-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(34676, NULL, 'G3DSA:3.50.50.100:FF:000012', NULL, NULL, 'Type II NADH:ubiquinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(34677, NULL, 'G3DSA:3.60.20.10:FF:000025', NULL, NULL, 'Proteasome subunit alpha type', NULL, NULL, NULL, NULL, NULL, 4),
(34678, NULL, 'G3DSA:3.40.960.10:FF:000005', NULL, NULL, 'Cullin, a subunit of E3 ubiquitin ligase', NULL, NULL, NULL, NULL, NULL, 4),
(34679, NULL, 'G3DSA:3.30.160.60:FF:000528', NULL, NULL, 'zinc finger protein 668', NULL, NULL, NULL, NULL, NULL, 4),
(34680, NULL, 'G3DSA:3.30.70.2750:FF:000001', NULL, NULL, 'V-type ATP synthase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(34681, NULL, 'G3DSA:2.130.10.30:FF:000074', NULL, NULL, 'Regulator of chromosome condensation, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34682, NULL, 'G3DSA:2.60.260.20:FF:000089', NULL, NULL, 'DnaJ homolog subfamily B member 1', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(34683, NULL, 'G3DSA:3.30.428.10:FF:000029', NULL, NULL, 'Unplaced genomic scaffold supercont2.5, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(34684, NULL, 'G3DSA:1.10.1420.10:FF:000130', NULL, NULL, 'Dna mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(34685, NULL, 'G3DSA:1.10.287.130:FF:000193', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(34686, NULL, 'G3DSA:1.10.150.20:FF:000129', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(34687, NULL, 'G3DSA:2.130.10.10:FF:005329', NULL, NULL, 'AGL196Cp', NULL, NULL, NULL, NULL, NULL, 4),
(34688, NULL, 'G3DSA:3.90.80.10:FF:000022', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(34689, NULL, 'G3DSA:3.40.50.300:FF:001333', NULL, NULL, 'FA complementation group M', NULL, NULL, NULL, NULL, NULL, 4),
(34690, NULL, 'G3DSA:2.130.10.10:FF:000967', NULL, NULL, 'Bardet-Biedl syndrome 2 protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(34691, NULL, 'G3DSA:1.10.10.2210:FF:000002', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(34692, NULL, 'G3DSA:2.30.29.30:FF:000009', NULL, NULL, 'Cytohesin 1', NULL, NULL, NULL, NULL, NULL, 4),
(34693, NULL, 'G3DSA:3.40.50.11060:FF:000006', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(34694, NULL, 'G3DSA:3.30.1370.240:FF:000010', NULL, NULL, 'Alpha subunit of phenylalanyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(34695, NULL, 'G3DSA:1.25.40.570:FF:000011', NULL, NULL, 'COP9 signalosome complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(34696, NULL, 'G3DSA:3.40.50.300:FF:000714', NULL, NULL, 'cell cycle checkpoint protein RAD17 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(34697, NULL, 'G3DSA:3.80.10.10:FF:003031', NULL, NULL, 'F-box protein FBW2', NULL, NULL, NULL, NULL, NULL, 4),
(34698, NULL, 'G3DSA:3.80.10.10:FF:002412', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34699, NULL, 'G3DSA:3.30.160.60:FF:000894', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(34700, NULL, 'G3DSA:2.30.30.140:FF:000129', NULL, NULL, 'NuA4 complex subunit EAF3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(34701, NULL, 'G3DSA:2.30.30.140:FF:000005', NULL, NULL, 'Putative lysine-specific demethylase 4a', NULL, NULL, NULL, NULL, NULL, 4),
(34702, NULL, 'G3DSA:1.10.640.10:FF:000091', NULL, NULL, 'Dual oxidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(34703, NULL, 'G3DSA:2.130.10.10:FF:004334', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34704, NULL, 'G3DSA:2.60.40.10:FF:003749', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34705, NULL, 'G3DSA:3.40.1000.10:FF:000011', NULL, NULL, 'Lipoprotein LpqN', NULL, NULL, NULL, NULL, NULL, 4),
(34706, NULL, 'G3DSA:3.40.140.10:FF:000038', NULL, NULL, 'tRNA-specific adenosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(34707, NULL, 'G3DSA:1.20.930.10:FF:000009', NULL, NULL, 'Hepatoma-derived growth factor-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(34708, NULL, 'G3DSA:2.60.120.40:FF:000051', NULL, NULL, 'collagen alpha-1(X) chain-like', NULL, NULL, NULL, NULL, NULL, 4),
(34709, NULL, 'G3DSA:3.30.160.60:FF:005907', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34710, NULL, 'G3DSA:1.10.8.60:FF:000213', NULL, NULL, 'AAA family ATPase, CDC48 subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(34711, NULL, 'G3DSA:3.30.830.10:FF:000071', NULL, NULL, 'Cytochrome b-c1 complex subunit 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(34712, NULL, 'G3DSA:3.30.420.40:FF:000015', NULL, NULL, 'Hexokinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(34713, NULL, 'G3DSA:1.25.40.10:FF:004597', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(34714, NULL, 'G3DSA:3.80.10.10:FF:003340', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34715, NULL, 'G3DSA:1.25.10.10:FF:001206', NULL, NULL, 'Exportin T (TRNA exportin)-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(34716, NULL, 'G3DSA:3.10.580.10:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(34717, NULL, 'G3DSA:1.20.1250.20:FF:001426', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(34718, NULL, 'G3DSA:2.60.120.590:FF:000009', NULL, NULL, 'Alpha-ketoglutarate-dependent dioxygenase alkB homolog 7, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(34719, NULL, 'G3DSA:3.80.10.10:FF:002940', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(34720, NULL, 'G3DSA:2.130.10.10:FF:000658', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(34721, NULL, 'G3DSA:3.40.50.300:FF:001642', NULL, NULL, 'Multidrug ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(34722, NULL, 'G3DSA:2.60.40.10:FF:005913', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34723, NULL, 'G3DSA:1.20.1080.10:FF:000117', NULL, NULL, 'AQuaPorin or aquaglyceroporin related', NULL, NULL, NULL, NULL, NULL, 4),
(34724, NULL, 'G3DSA:3.30.450.50:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34725, NULL, 'G3DSA:3.30.70.360:FF:000053', NULL, NULL, 'Hydrolase, ama/hipO/hyuC family', NULL, NULL, NULL, NULL, NULL, 4),
(34726, NULL, 'G3DSA:1.10.510.10:FF:001947', NULL, NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase At5g58150', NULL, NULL, NULL, NULL, NULL, 4),
(34727, NULL, 'G3DSA:3.40.50.300:FF:004767', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34728, NULL, 'G3DSA:1.10.10.60:FF:000271', NULL, NULL, 'Homeobox protein MSX-2', NULL, NULL, NULL, NULL, NULL, 4),
(34729, NULL, 'G3DSA:3.80.10.10:FF:001086', NULL, NULL, 'P53-induced death domain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(34730, NULL, 'G3DSA:1.10.10.60:FF:000647', NULL, NULL, 'One cut domain family member', NULL, NULL, NULL, NULL, NULL, 4),
(34731, NULL, 'G3DSA:2.60.40.10:FF:000534', NULL, NULL, 'Tenascin N', NULL, NULL, NULL, NULL, NULL, 4),
(34732, NULL, 'G3DSA:2.10.90.10:FF:000034', NULL, NULL, 'Interleukin 17B', NULL, NULL, NULL, NULL, NULL, 4),
(34733, NULL, 'G3DSA:3.30.450.20:FF:000522', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34734, NULL, 'G3DSA:1.10.132.30:FF:000034', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(34735, NULL, 'G3DSA:1.25.40.1030:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34736, NULL, 'G3DSA:1.20.58.1710:FF:000001', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 8', NULL, NULL, NULL, NULL, NULL, 4),
(34737, NULL, 'G3DSA:2.130.10.10:FF:000990', NULL, NULL, 'GG12984', NULL, NULL, NULL, NULL, NULL, 4),
(34738, NULL, 'G3DSA:3.40.47.10:FF:000256', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34739, NULL, 'G3DSA:3.30.160.60:FF:001147', NULL, NULL, 'Sp6 transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(34740, NULL, 'G3DSA:3.40.50.300:FF:000372', NULL, NULL, 'Adenylate kinase isoenzyme 6 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(34741, NULL, 'G3DSA:1.20.120.350:FF:000167', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34742, NULL, 'G3DSA:3.30.200.20:FF:001116', NULL, NULL, 'Mitogen-activated protein kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(34743, NULL, 'G3DSA:1.25.40.10:FF:002124', NULL, NULL, 'Os07g0635800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(34744, NULL, 'G3DSA:2.120.10.30:FF:000030', NULL, NULL, 'Nidogen 1', NULL, NULL, NULL, NULL, NULL, 4),
(34745, NULL, 'G3DSA:3.40.50.300:FF:003098', NULL, NULL, 'ATP-binding protein SCC61A06c', NULL, NULL, NULL, NULL, NULL, 4),
(34746, NULL, 'G3DSA:1.10.220.60:FF:000001', NULL, NULL, 'golgin subfamily A member 4', NULL, NULL, NULL, NULL, NULL, 4),
(34747, NULL, 'G3DSA:1.20.1110.10:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34748, NULL, 'G3DSA:3.80.10.10:FF:002631', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34749, NULL, 'G3DSA:3.80.10.10:FF:002070', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(34750, NULL, 'G3DSA:1.10.1300.10:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34751, NULL, 'G3DSA:1.20.1560.10:FF:000143', NULL, NULL, 'ATP-binding Cassette (ABC) Superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(34752, NULL, 'G3DSA:3.10.129.10:FF:000187', NULL, NULL, 'Probable acyl-coenzyme a thioester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(34753, NULL, 'G3DSA:3.40.50.300:FF:000681', NULL, NULL, 'probable ATP-dependent RNA helicase DDX47', NULL, NULL, NULL, NULL, NULL, 4),
(34754, NULL, 'G3DSA:3.30.300.150:FF:000004', NULL, NULL, 'DNA polymerase III subunit gamma/tau', NULL, NULL, NULL, NULL, NULL, 4),
(34755, NULL, 'G3DSA:1.10.418.10:FF:000035', NULL, NULL, 'girdin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(34756, NULL, 'G3DSA:3.40.50.2020:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34757, NULL, 'G3DSA:3.30.465.10:FF:000098', NULL, NULL, 'Aspergillus niger contig An11c0010, genomic contig', NULL, NULL, NULL, NULL, NULL, 4),
(34758, NULL, 'G3DSA:3.30.450.20:FF:000213', NULL, NULL, 'VWFA and cache domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(34759, NULL, 'G3DSA:3.30.70.330:FF:003017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34760, NULL, 'G3DSA:3.30.540.10:FF:000094', NULL, NULL, 'Erlin-2', NULL, NULL, NULL, NULL, NULL, 4),
(34761, NULL, 'G3DSA:1.10.10.2660:FF:000024', NULL, NULL, 'SUMO-activating enzyme subunit', NULL, NULL, NULL, NULL, NULL, 4),
(34762, NULL, 'G3DSA:3.40.50.300:FF:005043', NULL, NULL, 'Si:dkey-23k10.5', NULL, NULL, NULL, NULL, NULL, 4),
(34763, NULL, 'G3DSA:3.30.160.60:FF:005750', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34764, NULL, 'G3DSA:1.10.2000.10:FF:000076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34765, NULL, 'G3DSA:3.40.50.300:FF:008477', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(34766, NULL, 'G3DSA:1.10.510.10:FF:001823', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34767, NULL, 'G3DSA:3.40.1110.10:FF:000221', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(34768, NULL, 'G3DSA:1.10.340.30:FF:000057', NULL, NULL, '3-methyladenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(34769, NULL, 'G3DSA:1.10.510.10:FF:001638', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34770, NULL, 'G3DSA:1.10.150.670:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34771, NULL, 'G3DSA:3.40.190.290:FF:000033', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(34772, NULL, 'G3DSA:3.40.50.2000:FF:000364', NULL, NULL, 'UDP-glucose:(Heptosyl) LPS alpha 1,3-glucosyltransferase WaaG', NULL, NULL, NULL, NULL, NULL, 4),
(34773, NULL, 'G3DSA:1.25.10.10:FF:001881', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(34774, NULL, 'G3DSA:2.40.100.10:FF:000135', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(34775, NULL, 'G3DSA:2.130.10.10:FF:000282', NULL, NULL, 'Syntaxin binding protein 5 like', NULL, NULL, NULL, NULL, NULL, 4),
(34776, NULL, 'G3DSA:2.30.29.30:FF:000341', NULL, NULL, 'dynamin-3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(34777, NULL, 'G3DSA:3.30.310.80:FF:000030', NULL, NULL, 'Probable serine/threonine-protein kinase MARK-B', NULL, NULL, NULL, NULL, NULL, 4),
(34778, NULL, 'G3DSA:1.25.10.10:FF:001431', NULL, NULL, 'Putative tubulin-specific chaperone d', NULL, NULL, NULL, NULL, NULL, 4),
(34779, NULL, 'G3DSA:3.40.50.300:FF:006324', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34780, NULL, 'G3DSA:1.20.900.10:FF:000087', NULL, NULL, 'FERM, ARH/RhoGEF and pleckstrin domain protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(34781, NULL, 'G3DSA:1.25.40.470:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34782, NULL, 'G3DSA:1.10.510.10:FF:001059', NULL, NULL, 'Male germ cell associated kinase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(34783, NULL, 'G3DSA:1.25.40.1030:FF:000028', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(34784, NULL, 'G3DSA:2.40.10.220:FF:000001', NULL, NULL, 'Cellulose synthase catalytic subunit [UDP-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(34785, NULL, 'G3DSA:2.70.150.10:FF:000047', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(34786, NULL, 'G3DSA:3.30.70.330:FF:001461', NULL, NULL, 'DnaJ homolog subfamily C member 17', NULL, NULL, NULL, NULL, NULL, 4),
(34787, NULL, 'G3DSA:3.40.50.10090:FF:000030', NULL, NULL, 'Uroporphyrinogen-III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(34788, NULL, 'G3DSA:1.10.8.10:FF:000215', NULL, NULL, 'hemK methyltransferase family member 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(34789, NULL, 'G3DSA:2.40.180.10:FF:000022', NULL, NULL, 'CatA, catalase', NULL, NULL, NULL, NULL, NULL, 4),
(34790, NULL, 'G3DSA:3.40.50.300:FF:003570', NULL, NULL, 'Isoniazid inductible gene protein IniA', NULL, NULL, NULL, NULL, NULL, 4),
(34791, NULL, 'G3DSA:4.10.640.10:FF:000023', NULL, NULL, 'Mitochondrial Ribosomal Protein, Small', NULL, NULL, NULL, NULL, NULL, 4),
(34792, NULL, 'G3DSA:1.20.1440.340:FF:000002', NULL, NULL, 'Galactokinase', NULL, NULL, NULL, NULL, NULL, 4),
(34793, NULL, 'G3DSA:2.60.40.10:FF:003199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34794, NULL, 'G3DSA:3.30.40.10:FF:000859', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(34795, NULL, 'G3DSA:3.40.50.12780:FF:000090', NULL, NULL, 'Long-chain-fatty-acid--CoA ligase FadD15', NULL, NULL, NULL, NULL, NULL, 4),
(34796, NULL, 'G3DSA:3.10.20.310:FF:000010', NULL, NULL, 'sorting and assembly machinery component 50 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(34797, NULL, 'G3DSA:1.25.40.180:FF:000091', NULL, NULL, 'Eukaryotic translation initiation factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(34798, NULL, 'G3DSA:1.10.510.10:FF:001610', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34799, NULL, 'G3DSA:3.65.10.20:FF:000017', NULL, NULL, 'RNA cyclase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(34800, NULL, 'G3DSA:3.40.50.2300:FF:001437', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34801, NULL, 'G3DSA:3.30.40.10:FF:001365', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34802, NULL, 'G3DSA:3.40.30.10:FF:000049', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(34803, NULL, 'G3DSA:2.130.10.10:FF:000630', NULL, NULL, 'Ribosome assembly protein SQT1', NULL, NULL, NULL, NULL, NULL, 4),
(34804, NULL, 'G3DSA:3.30.379.10:FF:000004', NULL, NULL, 'Beta-hexosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(34805, NULL, 'G3DSA:3.40.720.10:FF:000364', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34806, NULL, 'G3DSA:3.40.50.300:FF:001541', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(34807, NULL, 'G3DSA:1.10.510.10:FF:001498', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(34808, NULL, 'G3DSA:2.60.40.10:FF:005435', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34809, NULL, 'G3DSA:3.30.160.60:FF:002125', NULL, NULL, 'zinc finger protein 33B-like', NULL, NULL, NULL, NULL, NULL, 4),
(34810, NULL, 'G3DSA:3.30.559.30:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34811, NULL, 'G3DSA:1.25.10.10:FF:002954', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34812, NULL, 'G3DSA:3.40.50.300:FF:000922', NULL, NULL, 'DEAD/DEAH box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(34813, NULL, 'G3DSA:1.20.58.450:FF:000001', NULL, NULL, 'SPI-1 type III secretion system effector inositol phosphate phosphatase SopB', NULL, NULL, NULL, NULL, NULL, 4),
(34814, NULL, 'G3DSA:1.10.472.10:FF:000565', NULL, NULL, 'Cyclin, N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(34815, NULL, 'G3DSA:3.40.1190.20:FF:000089', NULL, NULL, 'ketohexokinase isoform X1', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(34816, NULL, 'G3DSA:1.25.40.10:FF:003057', NULL, NULL, 'RNA polymerase III transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34817, NULL, 'G3DSA:3.40.50.2000:FF:000948', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(34818, NULL, 'G3DSA:3.40.1190.20:FF:000201', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34819, NULL, 'G3DSA:2.130.10.10:FF:001035', NULL, NULL, 'Putative WD repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(34820, NULL, 'G3DSA:3.30.750.24:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34821, NULL, 'G3DSA:2.60.120.200:FF:000489', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(34822, NULL, 'G3DSA:3.90.470.20:FF:000015', NULL, NULL, '4-phosphopantetheinyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(34823, NULL, 'G3DSA:3.40.50.880:FF:000169', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(34824, NULL, 'G3DSA:3.40.50.1260:FF:000001', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(34825, NULL, 'G3DSA:1.10.630.10:FF:000034', NULL, NULL, 'Cholesterol 7-alpha-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(34826, NULL, 'G3DSA:1.10.10.10:FF:001363', NULL, NULL, 'DNA repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34827, NULL, 'G3DSA:2.130.10.10:FF:003856', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34828, NULL, 'G3DSA:3.60.40.10:FF:000167', NULL, NULL, 'Protein phosphatase 2C', NULL, NULL, NULL, NULL, NULL, 4),
(34829, NULL, 'G3DSA:1.10.2000.10:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34830, NULL, 'G3DSA:2.10.70.10:FF:000235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34831, NULL, 'G3DSA:3.90.700.10:FF:000008', NULL, NULL, 'Conserved hypothetical flavoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(34832, NULL, 'G3DSA:3.60.20.10:FF:000154', NULL, NULL, 'Acyl-homoserine lactone acylase QuiP', NULL, NULL, NULL, NULL, NULL, 4),
(34833, NULL, 'G3DSA:3.30.160.60:FF:005986', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34834, NULL, 'G3DSA:3.30.479.20:FF:000060', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(34835, NULL, 'G3DSA:2.10.25.10:FF:000158', NULL, NULL, 'proheparin-binding EGF-like growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(34836, NULL, 'G3DSA:3.50.30.30:FF:000178', NULL, NULL, 'Os01g0795400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(34837, NULL, 'G3DSA:3.10.330.20:FF:000006', NULL, NULL, 'tRNA (adenine(58)-N(1))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(34838, NULL, 'G3DSA:3.20.20.20:FF:000035', NULL, NULL, 'Dihydropteroate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(34839, NULL, 'G3DSA:3.90.320.10:FF:000030', NULL, NULL, 'CRISPR-associated exonuclease Cas4', NULL, NULL, NULL, NULL, NULL, 4),
(34840, NULL, 'G3DSA:3.40.30.10:FF:000150', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(34841, NULL, 'G3DSA:3.80.20.20:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34842, NULL, 'G3DSA:3.40.1190.20:FF:000190', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34843, NULL, 'G3DSA:3.10.110.10:FF:000268', NULL, NULL, 'Ubiquitin protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34844, NULL, 'G3DSA:3.30.390.120:FF:000002', NULL, NULL, 'Rubredoxin-NAD(+) reductase', NULL, NULL, NULL, NULL, NULL, 4),
(34845, NULL, 'G3DSA:1.25.40.10:FF:001612', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(34846, NULL, 'G3DSA:3.30.200.20:FF:000594', NULL, NULL, 'Putative serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(34847, NULL, 'G3DSA:1.10.510.10:FF:002015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34848, NULL, 'G3DSA:1.10.238.10:FF:000049', NULL, NULL, 'Respiratory burst oxidase homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(34849, NULL, 'G3DSA:2.130.10.10:FF:003373', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(34850, NULL, 'G3DSA:3.30.230.10:FF:000093', NULL, NULL, '40S ribosomal protein S16', NULL, NULL, NULL, NULL, NULL, 4),
(34851, NULL, 'G3DSA:1.10.20.10:FF:000251', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34852, NULL, 'G3DSA:3.30.200.20:FF:001111', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34853, NULL, 'G3DSA:3.90.1280.20:FF:000005', NULL, NULL, 'Magnesium and cobalt transporter', NULL, NULL, NULL, NULL, NULL, 4),
(34854, NULL, 'G3DSA:3.40.50.1100:FF:000206', NULL, NULL, 'Cysteine synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34855, NULL, 'G3DSA:3.30.450.20:FF:000314', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(34856, NULL, 'G3DSA:3.50.50.60:FF:001014', NULL, NULL, 'Pyridine nucleotide-disulphide oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(34857, NULL, 'G3DSA:1.25.50.20:FF:000020', NULL, NULL, 'Aminopeptidase-like protein AC3.5', NULL, NULL, NULL, NULL, NULL, 4),
(34858, NULL, 'G3DSA:1.10.287.110:FF:000451', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34859, NULL, 'G3DSA:1.10.472.130:FF:000020', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34860, NULL, 'G3DSA:1.10.533.10:FF:000235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34861, NULL, 'G3DSA:2.20.25.10:FF:000068', NULL, NULL, 'Trm112p family protein', NULL, NULL, NULL, NULL, NULL, 4),
(34862, NULL, 'G3DSA:2.60.40.1760:FF:000012', NULL, NULL, 'Alpha-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(34863, NULL, 'G3DSA:3.30.2130.30:FF:000034', NULL, NULL, 'Putative RNA methylase', NULL, NULL, NULL, NULL, NULL, 4),
(34864, NULL, 'G3DSA:3.30.70.330:FF:002871', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34865, NULL, 'G3DSA:1.20.950.20:FF:000025', NULL, NULL, 'Cytochrome b', NULL, NULL, NULL, NULL, NULL, 4),
(34866, NULL, 'G3DSA:2.70.170.10:FF:000161', NULL, NULL, 'Transmembrane ion channel', NULL, NULL, NULL, NULL, NULL, 4),
(34867, NULL, 'G3DSA:2.10.25.10:FF:000372', NULL, NULL, 'protein crumbs homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(34868, NULL, 'G3DSA:1.20.58.60:FF:000762', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34869, NULL, 'G3DSA:3.30.160.60:FF:000422', NULL, NULL, 'Zinc finger and BTB domain containing 37', NULL, NULL, NULL, NULL, NULL, 4),
(34870, NULL, 'G3DSA:3.40.1110.10:FF:000452', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34871, NULL, 'G3DSA:2.60.40.150:FF:000228', NULL, NULL, 'Blast:Protein kibra', NULL, NULL, NULL, NULL, NULL, 4),
(34872, NULL, 'G3DSA:3.40.50.1220:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34873, NULL, 'G3DSA:1.10.287.1040:FF:000012', NULL, NULL, 'Exodeoxyribonuclease 7 small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(34874, NULL, 'G3DSA:2.60.120.10:FF:000727', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34875, NULL, 'G3DSA:1.20.1070.10:FF:001123', NULL, NULL, 'Neuropeptide receptor 15', NULL, NULL, NULL, NULL, NULL, 4),
(34876, NULL, 'G3DSA:1.20.5.110:FF:000147', NULL, NULL, 'EhSyntaxin H, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34877, NULL, 'G3DSA:1.10.1510.30:FF:000013', NULL, NULL, 'Probable tRNA pseudouridine synthase D 1', NULL, NULL, NULL, NULL, NULL, 4),
(34878, NULL, 'G3DSA:3.40.50.150:FF:001827', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34879, NULL, 'G3DSA:1.20.1250.20:FF:000931', NULL, NULL, 'Sugar transport protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(34880, NULL, 'G3DSA:1.20.5.190:FF:000114', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34881, NULL, 'G3DSA:2.40.10.10:FF:000213', NULL, NULL, 'Si:dkey-33m11.7', NULL, NULL, NULL, NULL, NULL, 4),
(34882, NULL, 'G3DSA:3.40.630.10:FF:000126', NULL, NULL, 'Succinyl-diaminopimelate desuccinylase', NULL, NULL, NULL, NULL, NULL, 4),
(34883, NULL, 'G3DSA:1.10.1200.10:FF:000147', NULL, NULL, 'Polyketide synthase RzxF', NULL, NULL, NULL, NULL, NULL, 4),
(34884, NULL, 'G3DSA:2.60.40.10:FF:004137', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(34885, NULL, 'G3DSA:3.40.50.1820:FF:000652', NULL, NULL, 'CocE/NonD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(34886, NULL, 'G3DSA:3.40.50.300:FF:003339', NULL, NULL, 'Shikimate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(34887, NULL, 'G3DSA:3.30.70.330:FF:001247', NULL, NULL, 'Cleavage stimulation factor subunit 2 tau variant', NULL, NULL, NULL, NULL, NULL, 4),
(34888, NULL, 'G3DSA:2.60.120.330:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34889, NULL, 'G3DSA:2.40.10.10:FF:000325', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34890, NULL, 'G3DSA:1.25.40.10:FF:002782', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34891, NULL, 'G3DSA:3.20.20.80:FF:000694', NULL, NULL, 'Sucrose isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(34892, NULL, 'G3DSA:1.10.287.70:FF:000017', NULL, NULL, 'ryanodine receptor isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(34893, NULL, 'G3DSA:1.20.58.530:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34894, NULL, 'G3DSA:3.40.1110.10:FF:000322', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34895, NULL, 'G3DSA:2.60.120.200:FF:000590', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34896, NULL, 'G3DSA:2.40.30.10:FF:000208', NULL, NULL, 'Putative selenocysteine-specific elongation factor', NULL, NULL, NULL, NULL, NULL, 4),
(34897, NULL, 'G3DSA:3.90.25.10:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34898, NULL, 'G3DSA:3.40.50.2300:FF:000818', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34899, NULL, 'G3DSA:1.25.10.10:FF:001094', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(34900, NULL, 'G3DSA:3.40.140.100:FF:000017', NULL, NULL, 'Ubiquitin-like modifier-activating enzyme ATG7', NULL, NULL, NULL, NULL, NULL, 4),
(34901, NULL, 'G3DSA:3.20.20.140:FF:000007', NULL, NULL, 'Imidazolonepropionase', NULL, NULL, NULL, NULL, NULL, 4),
(34902, NULL, 'G3DSA:1.10.418.10:FF:000052', NULL, NULL, 'Growth arrest specific 2', NULL, NULL, NULL, NULL, NULL, 4),
(34903, NULL, 'G3DSA:3.30.310.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34904, NULL, 'G3DSA:1.20.5.110:FF:000017', NULL, NULL, 'BRICK1, SCAR/WAVE actin-nucleating complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(34905, NULL, 'G3DSA:3.40.50.10810:FF:000072', NULL, NULL, 'Bifunctional helicase and thymine dioxygenase JBP2', NULL, NULL, NULL, NULL, NULL, 4),
(34906, NULL, 'G3DSA:3.90.1720.10:FF:000037', NULL, NULL, 'Lecithin retinol acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(34907, NULL, 'G3DSA:1.20.5.490:FF:000002', NULL, NULL, 'TSC22 domain family, member 1', NULL, NULL, NULL, NULL, NULL, 4),
(34908, NULL, 'G3DSA:1.20.1110.10:FF:000222', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34909, NULL, 'G3DSA:3.50.50.60:FF:000497', NULL, NULL, 'FAD dependent oxidoreductase superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(34910, NULL, 'G3DSA:1.10.510.10:FF:003408', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34911, NULL, 'G3DSA:1.20.5.190:FF:000002', NULL, NULL, 'Major outer membrane lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(34912, NULL, 'G3DSA:2.130.10.10:FF:002333', NULL, NULL, 'THO complex 3 G protein beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(34913, NULL, 'G3DSA:3.50.50.60:FF:000508', NULL, NULL, 'Rab proteins geranylgeranyltransferase component A', NULL, NULL, NULL, NULL, NULL, 4),
(34914, NULL, 'G3DSA:1.25.40.20:FF:000643', NULL, NULL, 'Serine/threonine-protein kinase NEK', NULL, NULL, NULL, NULL, NULL, 4),
(34915, NULL, 'G3DSA:1.20.1250.20:FF:001319', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34916, NULL, 'G3DSA:3.40.50.10190:FF:000285', NULL, NULL, 'DNA ligase 4', NULL, NULL, NULL, NULL, NULL, 4),
(34917, NULL, 'G3DSA:2.60.120.10:FF:000615', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34918, NULL, 'G3DSA:3.30.160.60:FF:005082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(34919, NULL, 'G3DSA:3.40.50.720:FF:000812', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] reductase', NULL, NULL, NULL, NULL, NULL, 4),
(34920, NULL, 'G3DSA:3.40.50.150:FF:001456', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34921, NULL, 'G3DSA:1.10.10.60:FF:001024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34922, NULL, 'G3DSA:2.170.120.40:FF:000013', NULL, NULL, 'YbbR-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(34923, NULL, 'G3DSA:3.90.190.10:FF:000547', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34924, NULL, 'G3DSA:1.20.1300.10:FF:000034', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(34925, NULL, 'G3DSA:1.10.287.1490:FF:000028', NULL, NULL, 'Dynamin associated protein 160, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(34926, NULL, 'G3DSA:1.25.10.10:FF:002050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34927, NULL, 'G3DSA:3.40.50.300:FF:005705', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34928, NULL, 'G3DSA:3.30.200.20:FF:001903', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34929, NULL, 'G3DSA:1.10.287.10:FF:000027', NULL, NULL, 'SSU ribosomal protein, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34930, NULL, 'G3DSA:4.10.240.10:FF:000026', NULL, NULL, 'C6 transcription factor (AmyR)', NULL, NULL, NULL, NULL, NULL, 4),
(34931, NULL, 'G3DSA:3.80.10.10:FF:003935', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34932, NULL, 'G3DSA:3.10.50.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34933, NULL, 'G3DSA:3.30.710.10:FF:000135', NULL, NULL, 'Kelch-like family member 34', NULL, NULL, NULL, NULL, NULL, 4),
(34934, NULL, 'G3DSA:1.10.287.3510:FF:000005', NULL, NULL, 'Hydrogenase 4, membrane subunit', NULL, NULL, NULL, NULL, NULL, 4),
(34935, NULL, 'G3DSA:3.50.50.100:FF:000017', NULL, NULL, 'Sulfide-quinone reductase', NULL, NULL, NULL, NULL, NULL, 4),
(34936, NULL, 'G3DSA:3.30.70.330:FF:001814', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34937, NULL, 'G3DSA:1.25.10.10:FF:003460', NULL, NULL, 'GCN (Yeast General Control Nondrepressible) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(34938, NULL, 'G3DSA:3.40.50.1820:FF:001849', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34939, NULL, 'G3DSA:3.30.160.60:FF:003648', NULL, NULL, 'Zinc finger protein STAR3', NULL, NULL, NULL, NULL, NULL, 4),
(34940, NULL, 'G3DSA:4.10.280.10:FF:000040', NULL, NULL, 'MAX gene-associated protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(34941, NULL, 'G3DSA:3.30.1330.30:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34942, NULL, 'G3DSA:3.80.10.10:FF:001114', NULL, NULL, 'Tollo', NULL, NULL, NULL, NULL, NULL, 4),
(34943, NULL, 'G3DSA:2.60.40.1080:FF:000022', NULL, NULL, 'Surface layer protein', NULL, NULL, NULL, NULL, NULL, 4),
(34944, NULL, 'G3DSA:3.40.50.300:FF:003795', NULL, NULL, 'ATP-dependent DNA helicase CHL1', NULL, NULL, NULL, NULL, NULL, 4),
(34945, NULL, 'G3DSA:3.30.200.20:FF:000947', NULL, NULL, 'GNAT family N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(34946, NULL, 'G3DSA:1.10.510.10:FF:004353', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34947, NULL, 'G3DSA:1.10.510.10:FF:000879', NULL, NULL, 'TKL protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(34948, NULL, 'G3DSA:1.10.10.790:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34949, NULL, 'G3DSA:1.25.40.10:FF:002231', NULL, NULL, 'Separin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34950, NULL, 'G3DSA:2.80.10.50:FF:000077', NULL, NULL, 'Alpha-galactosidase A', NULL, NULL, NULL, NULL, NULL, 4),
(34951, NULL, 'G3DSA:3.20.20.70:FF:000477', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(34952, NULL, 'G3DSA:2.60.40.10:FF:004497', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(34953, NULL, 'G3DSA:3.30.160.60:FF:004137', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34954, NULL, 'G3DSA:1.10.533.10:FF:000123', NULL, NULL, 'Nerve growth factor receptor b', NULL, NULL, NULL, NULL, NULL, 4),
(34955, NULL, 'G3DSA:3.30.40.10:FF:000729', NULL, NULL, 'Mitochondrial ubiquitin ligase activator of nfkb 1-A', NULL, NULL, NULL, NULL, NULL, 4),
(34956, NULL, 'G3DSA:1.10.10.10:FF:001493', NULL, NULL, 'Probable HTH-type transcriptional regulator ArcR', NULL, NULL, NULL, NULL, NULL, 4),
(34957, NULL, 'G3DSA:3.40.50.2300:FF:001084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34958, NULL, 'G3DSA:3.30.420.40:FF:000240', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(34959, NULL, 'G3DSA:3.40.50.300:FF:004284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34960, NULL, 'G3DSA:3.40.630.30:FF:000604', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34961, NULL, 'G3DSA:1.20.1560.10:FF:000463', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(34962, NULL, 'G3DSA:1.10.490.10:FF:000045', NULL, NULL, 'Flavohemoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(34963, NULL, 'G3DSA:1.25.40.10:FF:003428', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(34964, NULL, 'G3DSA:2.70.160.11:FF:000004', NULL, NULL, 'Protein arginine N-methyltransferase 7', NULL, NULL, NULL, NULL, NULL, 4),
(34965, NULL, 'G3DSA:1.25.40.1010:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34966, NULL, 'G3DSA:1.25.40.10:FF:004468', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34967, NULL, 'G3DSA:3.30.160.60:FF:001720', NULL, NULL, 'Si:dkey-7i4.21', NULL, NULL, NULL, NULL, NULL, 4),
(34968, NULL, 'G3DSA:1.10.510.10:FF:003313', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34969, NULL, 'G3DSA:2.20.70.10:FF:000032', NULL, NULL, 'WW domain containing oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(34970, NULL, 'G3DSA:4.10.400.10:FF:000028', NULL, NULL, 'prolow-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(34971, NULL, 'G3DSA:3.50.50.60:FF:001453', NULL, NULL, 'Exocyst complex component EXO84B', NULL, NULL, NULL, NULL, NULL, 4),
(34972, NULL, 'G3DSA:3.20.20.140:FF:000463', NULL, NULL, 'Urease', NULL, NULL, NULL, NULL, NULL, 4),
(34973, NULL, 'G3DSA:3.40.50.150:FF:000630', NULL, NULL, 'RfbT protein', NULL, NULL, NULL, NULL, NULL, 4),
(34974, NULL, 'G3DSA:1.20.140.50:FF:000006', NULL, NULL, 'Putative PalA, pH signal transduction protein', NULL, NULL, NULL, NULL, NULL, 4),
(34975, NULL, 'G3DSA:2.130.10.10:FF:004020', NULL, NULL, 'Uncharacterized WD repeat-containing protein C12G12.01c', NULL, NULL, NULL, NULL, NULL, 4),
(34976, NULL, 'G3DSA:3.40.50.720:FF:002392', NULL, NULL, 'Crystallin, zeta (quinone reductase)', NULL, NULL, NULL, NULL, NULL, 4),
(34977, NULL, 'G3DSA:1.10.472.10:FF:000205', NULL, NULL, 'Cyclin-C', NULL, NULL, NULL, NULL, NULL, 4),
(34978, NULL, 'G3DSA:3.30.565.10:FF:000403', NULL, NULL, 'Phosphate regulon sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(34979, NULL, 'G3DSA:3.40.1380.20:FF:000013', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(34980, NULL, 'G3DSA:1.10.510.10:FF:000087', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 12', NULL, NULL, NULL, NULL, NULL, 4),
(34981, NULL, 'G3DSA:2.70.130.10:FF:000164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34982, NULL, 'G3DSA:3.40.1160.10:FF:000033', NULL, NULL, 'Aspartate kinase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(34983, NULL, 'G3DSA:1.10.730.10:FF:000070', NULL, NULL, 'Arginine-tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34984, NULL, 'G3DSA:2.60.40.10:FF:003069', NULL, NULL, 'Protein sax-3', NULL, NULL, NULL, NULL, NULL, 4),
(34985, NULL, 'G3DSA:2.170.270.10:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34986, NULL, 'G3DSA:2.60.200.20:FF:000102', NULL, NULL, 'Meiosis-specific serine/threonine protein kinase MEK1, putative', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(34987, NULL, 'G3DSA:3.40.50.300:FF:006212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34988, NULL, 'G3DSA:1.25.10.10:FF:001543', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(34989, NULL, 'G3DSA:3.40.1810.10:FF:000022', NULL, NULL, 'MIKC MADS-domain protein PpMADS3', NULL, NULL, NULL, NULL, NULL, 4),
(34990, NULL, 'G3DSA:3.30.70.1730:FF:000010', NULL, NULL, '50S ribosomal protein L10', NULL, NULL, NULL, NULL, NULL, 4),
(34991, NULL, 'G3DSA:1.25.40.180:FF:000309', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(34992, NULL, 'G3DSA:1.25.40.20:FF:001048', NULL, NULL, 'NePHronoPhthisis (Human kidney disease) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(34993, NULL, 'G3DSA:3.30.200.20:FF:000043', NULL, NULL, 'Wall-associated receptor kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(34994, NULL, 'G3DSA:3.90.20.20:FF:000009', NULL, NULL, 'GrpE protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(34995, NULL, 'G3DSA:3.90.70.10:FF:000302', NULL, NULL, 'Cysteine protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(34996, NULL, 'G3DSA:3.90.550.10:FF:000631', NULL, NULL, 'Os02g0664200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(34997, NULL, 'G3DSA:3.30.40.10:FF:000308', NULL, NULL, 'E3 ubiquitin-protein ligase DZIP3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(34998, NULL, 'G3DSA:3.30.800.10:FF:000013', NULL, NULL, 'AGAP005216-PA', NULL, NULL, NULL, NULL, NULL, 4),
(34999, NULL, 'G3DSA:1.10.150.670:FF:000029', NULL, NULL, 'Crossover junction endonuclease eme1', NULL, NULL, NULL, NULL, NULL, 4),
(35000, NULL, 'G3DSA:2.10.25.10:FF:000400', NULL, NULL, 'Crumbs cell polarity complex component 1', NULL, NULL, NULL, NULL, NULL, 4),
(35001, NULL, 'G3DSA:1.10.1370.30:FF:000024', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(35002, NULL, 'G3DSA:2.30.29.30:FF:000762', NULL, NULL, 'Nuclear pore complex protein Nup50', NULL, NULL, NULL, NULL, NULL, 4),
(35003, NULL, 'G3DSA:1.10.150.50:FF:000228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35004, NULL, 'G3DSA:2.60.40.10:FF:001720', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(35005, NULL, 'G3DSA:3.40.50.2000:FF:000818', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35006, NULL, 'G3DSA:1.10.238.10:FF:000066', NULL, NULL, 'Troponin C, slow skeletal and cardiac muscles', NULL, NULL, NULL, NULL, NULL, 4),
(35007, NULL, 'G3DSA:1.20.58.1120:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35008, NULL, 'G3DSA:1.10.8.10:FF:000103', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(35009, NULL, 'G3DSA:3.30.70.330:FF:000050', NULL, NULL, 'heterogeneous nuclear ribonucleoprotein M isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(35010, NULL, 'G3DSA:1.20.1250.20:FF:000482', NULL, NULL, 'Thi73p', NULL, NULL, NULL, NULL, NULL, 4),
(35011, NULL, 'G3DSA:3.40.50.2300:FF:001325', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35012, NULL, 'G3DSA:3.90.640.10:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35013, NULL, 'G3DSA:2.30.30.140:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35014, NULL, 'G3DSA:1.20.5.170:FF:000007', NULL, NULL, 'hepatic leukemia factor isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(35015, NULL, 'G3DSA:2.130.10.10:FF:005189', NULL, NULL, 'WD40 repeat-containing protein smu1', NULL, NULL, NULL, NULL, NULL, 4),
(35016, NULL, 'G3DSA:3.40.50.300:FF:000029', NULL, NULL, 'Elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(35017, NULL, 'G3DSA:1.10.10.60:FF:000405', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(35018, NULL, 'G3DSA:1.10.390.10:FF:000009', NULL, NULL, 'Leukotriene A(4) hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(35019, NULL, 'G3DSA:1.10.287.70:FF:000591', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35020, NULL, 'G3DSA:2.60.40.60:FF:000768', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(35021, NULL, 'G3DSA:1.20.1050.130:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35022, NULL, 'G3DSA:1.25.10.10:FF:001886', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35023, NULL, 'G3DSA:2.130.10.10:FF:005290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35024, NULL, 'G3DSA:2.10.25.10:FF:001569', NULL, NULL, 'Laminin, gamma 2', NULL, NULL, NULL, NULL, NULL, 4),
(35025, NULL, 'G3DSA:3.40.50.1000:FF:000165', NULL, NULL, 'HAD superfamily phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(35026, NULL, 'G3DSA:3.30.160.60:FF:002097', NULL, NULL, 'paternally-expressed gene 3 protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(35027, NULL, 'G3DSA:1.10.12.10:FF:000013', NULL, NULL, 'Enoyl-CoA delta isomerase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(35028, NULL, 'G3DSA:4.10.10.10:FF:000002', NULL, NULL, 'Metallothionein', NULL, NULL, NULL, NULL, NULL, 4),
(35029, NULL, 'G3DSA:2.60.40.1730:FF:000014', NULL, NULL, 'Aminopeptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(35030, NULL, 'G3DSA:3.90.180.10:FF:000041', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(35031, NULL, 'G3DSA:3.40.50.150:FF:000063', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase C', NULL, NULL, NULL, NULL, NULL, 4),
(35032, NULL, 'G3DSA:3.40.1500.10:FF:000021', NULL, NULL, 'Oxygen-dependent coproporphyrinogen-III oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(35033, NULL, 'G3DSA:3.40.30.10:FF:000712', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35034, NULL, 'G3DSA:3.30.70.100:FF:000127', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35035, NULL, 'G3DSA:1.25.40.10:FF:003849', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35036, NULL, 'G3DSA:1.20.1070.10:FF:000616', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(35037, NULL, 'G3DSA:3.40.50.300:FF:002030', NULL, NULL, 'ATP-binding cassette sub-family C member 11 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(35038, NULL, 'G3DSA:3.40.50.300:FF:008241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35039, NULL, 'G3DSA:4.10.400.10:FF:000258', NULL, NULL, 'LDL receptor-like repeat', NULL, NULL, NULL, NULL, NULL, 4),
(35040, NULL, 'G3DSA:3.80.10.10:FF:001226', NULL, NULL, 'Protein Cep78 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(35041, NULL, 'G3DSA:3.30.1330.40:FF:000018', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(35042, NULL, 'G3DSA:3.30.565.10:FF:000162', NULL, NULL, 'Histidine kinase sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(35043, NULL, 'G3DSA:4.10.860.120:FF:000017', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(35044, NULL, 'G3DSA:2.60.120.970:FF:000011', NULL, NULL, 'Growth/differentiation factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(35045, NULL, 'G3DSA:2.60.40.10:FF:000326', NULL, NULL, 'Myosin-binding protein C, cardiac-type', NULL, NULL, NULL, NULL, NULL, 4),
(35046, NULL, 'G3DSA:1.20.58.1880:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35047, NULL, 'G3DSA:3.80.10.10:FF:002171', NULL, NULL, 'U2 small nuclear ribonucleoprotein 40K', NULL, NULL, NULL, NULL, NULL, 4),
(35048, NULL, 'G3DSA:3.30.420.40:FF:000352', NULL, NULL, 'Luminal-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(35049, NULL, 'G3DSA:3.30.460.90:FF:000010', NULL, NULL, 'Cyclic GMP-AMP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(35050, NULL, 'G3DSA:3.60.10.10:FF:000339', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(35051, NULL, 'G3DSA:3.10.170.20:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35052, NULL, 'G3DSA:3.40.1110.10:FF:000081', NULL, NULL, 'Cation transporting P-ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(35053, NULL, 'G3DSA:1.10.760.10:FF:000021', NULL, NULL, 'Cytochrome c6, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(35054, NULL, 'G3DSA:3.10.280.10:FF:000038', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(35055, NULL, 'G3DSA:2.40.50.140:FF:000625', NULL, NULL, 'GM17599', NULL, NULL, NULL, NULL, NULL, 4),
(35056, NULL, 'G3DSA:2.40.50.700:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35057, NULL, 'G3DSA:1.10.10.350:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35058, NULL, 'G3DSA:2.40.240.100:FF:000001', NULL, NULL, 'Glutamate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(35059, NULL, 'G3DSA:3.90.1150.10:FF:000471', NULL, NULL, 'Transcriptional regulator (DegT/DnrJ/Eryc1 family)', NULL, NULL, NULL, NULL, NULL, 4),
(35060, NULL, 'G3DSA:3.30.9.10:FF:000112', NULL, NULL, 'NAD dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(35061, NULL, 'G3DSA:3.30.160.60:FF:001832', NULL, NULL, 'basic leucine zipper 61-like', NULL, NULL, NULL, NULL, NULL, 4),
(35062, NULL, 'G3DSA:1.10.472.10:FF:000548', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35063, NULL, 'G3DSA:3.80.10.10:FF:001895', NULL, NULL, 'Ubiquitin-like_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(35064, NULL, 'G3DSA:3.40.50.300:FF:008578', NULL, NULL, 'Thymidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(35065, NULL, 'G3DSA:3.40.50.1820:FF:000309', NULL, NULL, 'Alpha/beta hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(35066, NULL, 'G3DSA:3.40.50.620:FF:000350', NULL, NULL, 'NH(3)-dependent NAD(+) synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(35067, NULL, 'G3DSA:1.20.1560.10:FF:000351', NULL, NULL, 'Os03g0181675 protein', NULL, NULL, NULL, NULL, NULL, 4),
(35068, NULL, 'G3DSA:1.20.5.1160:FF:000038', NULL, NULL, 'Non-neuronal cytoplasmic intermediate filament protein B', NULL, NULL, NULL, NULL, NULL, 4),
(35069, NULL, 'G3DSA:2.10.70.10:FF:000252', NULL, NULL, 'Extracellular matrix protein FRAS1', NULL, NULL, NULL, NULL, NULL, 4),
(35070, NULL, 'G3DSA:2.60.120.260:FF:000580', NULL, NULL, 'Netrin g1a', NULL, NULL, NULL, NULL, NULL, 4),
(35071, NULL, 'G3DSA:1.25.40.10:FF:000202', NULL, NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(35072, NULL, 'G3DSA:2.60.40.10:FF:001271', NULL, NULL, 'MPL proto-oncogene, thrombopoietin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(35073, NULL, 'G3DSA:3.90.79.10:FF:000030', NULL, NULL, 'Nudix hydrolase 13 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(35074, NULL, 'G3DSA:3.90.550.10:FF:000401', NULL, NULL, '3-deoxy-manno-octulosonate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(35075, NULL, 'G3DSA:3.30.710.10:FF:000247', NULL, NULL, 'Maternal gene required for meiosis, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(35076, NULL, 'G3DSA:1.25.10.10:FF:002162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35077, NULL, 'G3DSA:3.40.50.2000:FF:000156', NULL, NULL, 'GDP-Man:Man(3)GlcNAc(2)-PP-Dol alpha-1,2-mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(35078, NULL, 'G3DSA:2.40.50.730:FF:000010', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(35079, NULL, 'G3DSA:3.20.80.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35080, NULL, 'G3DSA:1.20.58.390:FF:000073', NULL, NULL, 'Neuronal acetylcholine receptor subunit alpha-9-II', NULL, NULL, NULL, NULL, NULL, 4),
(35081, NULL, 'G3DSA:1.25.40.10:FF:004125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35082, NULL, 'G3DSA:3.40.50.2020:FF:000151', NULL, NULL, 'Upp protein', NULL, NULL, NULL, NULL, NULL, 4),
(35083, NULL, 'G3DSA:1.20.1250.20:FF:000038', NULL, NULL, 'Sialic acid transporter NanT', NULL, NULL, NULL, NULL, NULL, 4),
(35084, NULL, 'G3DSA:1.20.1560.10:FF:000912', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35085, NULL, 'G3DSA:3.40.50.1220:FF:000017', NULL, NULL, 'NAD-dependent histone deacetylase SIR2', NULL, NULL, NULL, NULL, NULL, 4),
(35086, NULL, 'G3DSA:4.10.240.10:FF:000043', NULL, NULL, 'Regulatory protein CAT8', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(35087, NULL, 'G3DSA:3.40.850.10:FF:000351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35088, NULL, 'G3DSA:2.130.10.10:FF:000416', NULL, NULL, 'WD repeat-containing protein 13 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(35089, NULL, 'G3DSA:1.25.40.10:FF:004608', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At1g28020', NULL, NULL, NULL, NULL, NULL, 4),
(35090, NULL, 'G3DSA:3.40.980.10:FF:000012', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(35091, NULL, 'G3DSA:1.25.40.550:FF:000005', NULL, NULL, 'Protein AAR2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(35092, NULL, 'G3DSA:3.90.1290.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35093, NULL, 'G3DSA:3.80.10.10:FF:000607', NULL, NULL, 'F-box/LRR-repeat protein 17 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(35094, NULL, 'G3DSA:3.60.130.10:FF:000005', NULL, NULL, 'TfdA family taurine dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(35095, NULL, 'G3DSA:3.40.50.300:FF:000473', NULL, NULL, 'Vacuolar sorting-associated 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(35096, NULL, 'G3DSA:1.25.70.10:FF:000030', NULL, NULL, 'Transcription termination factor MTERF15 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(35097, NULL, 'G3DSA:2.60.40.10:FF:002243', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(35098, NULL, 'G3DSA:1.20.58.60:FF:000678', NULL, NULL, 'Alpha-actinin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(35099, NULL, 'G3DSA:2.10.90.10:FF:000135', NULL, NULL, 'MUC5B', NULL, NULL, NULL, NULL, NULL, 4),
(35100, NULL, 'G3DSA:3.40.190.10:FF:000221', NULL, NULL, 'Amino acid ABC transporter periplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(35101, NULL, 'G3DSA:3.10.580.10:FF:000067', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(35102, NULL, 'G3DSA:3.30.1330.40:FF:000035', NULL, NULL, 'Chorismate mutase AroH', NULL, NULL, NULL, NULL, NULL, 4),
(35103, NULL, 'G3DSA:2.10.25.10:FF:001226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35104, NULL, 'G3DSA:4.10.60.10:FF:000185', NULL, NULL, 'Glycine-rich RNA-binding protein RZ1A', NULL, NULL, NULL, NULL, NULL, 4),
(35105, NULL, 'G3DSA:3.40.50.300:FF:007622', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35106, NULL, 'G3DSA:1.10.1670.10:FF:000081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35107, NULL, 'G3DSA:1.10.287.110:FF:000013', NULL, NULL, 'Curved DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(35108, NULL, 'G3DSA:1.10.287.70:FF:000129', NULL, NULL, 'Two pore calcium channel protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(35109, NULL, 'G3DSA:2.60.120.170:FF:000002', NULL, NULL, 'Outer capsid protein P8', NULL, NULL, NULL, NULL, NULL, 4),
(35110, NULL, 'G3DSA:3.90.320.10:FF:000013', NULL, NULL, 'Exonuclease V chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(35111, NULL, 'G3DSA:3.40.50.300:FF:001878', NULL, NULL, 'Pantothenate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(35112, NULL, 'G3DSA:1.20.1070.10:FF:000959', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35113, NULL, 'G3DSA:3.50.50.60:FF:000385', NULL, NULL, 'FMO1p Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(35114, NULL, 'G3DSA:3.30.160.60:FF:000652', NULL, NULL, 'Zinc finger protein 516', NULL, NULL, NULL, NULL, NULL, 4),
(35115, NULL, 'G3DSA:2.60.120.920:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35116, NULL, 'G3DSA:3.40.30.10:FF:000133', NULL, NULL, 'Endoplasmic reticulum resident protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(35117, NULL, 'G3DSA:3.40.50.2300:FF:000706', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(35118, NULL, 'G3DSA:3.90.1150.210:FF:000007', NULL, NULL, 'F-actin-capping protein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(35119, NULL, 'G3DSA:3.10.100.10:FF:000099', NULL, NULL, 'Putative adhesin', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(35120, NULL, 'G3DSA:3.30.2140.10:FF:000001', NULL, NULL, 'Arylamine N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(35121, NULL, 'G3DSA:1.25.40.20:FF:000531', NULL, NULL, 'ATP-dependent RNA helicase YTHDC2', NULL, NULL, NULL, NULL, NULL, 4),
(35122, NULL, 'G3DSA:3.80.10.10:FF:004071', NULL, NULL, 'Leucine-rich transmembrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(35123, NULL, 'G3DSA:3.80.10.10:FF:003452', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35124, NULL, 'G3DSA:2.30.36.70:FF:000015', NULL, NULL, 'Actin-like ATPase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(35125, NULL, 'G3DSA:3.30.420.60:FF:000021', NULL, NULL, 'Os04g0659900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(35126, NULL, 'G3DSA:2.60.40.60:FF:000425', NULL, NULL, 'Protocadherin-15', NULL, NULL, NULL, NULL, NULL, 4),
(35127, NULL, 'G3DSA:1.25.40.10:FF:004485', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g07590, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(35128, NULL, 'G3DSA:3.30.160.60:FF:005194', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35129, NULL, 'G3DSA:1.20.58.870:FF:000003', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(35130, NULL, 'G3DSA:3.20.20.80:FF:000817', NULL, NULL, 'Alpha-amylase SusG', NULL, NULL, NULL, NULL, NULL, 4),
(35131, NULL, 'G3DSA:3.30.1640.30:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35132, NULL, 'G3DSA:3.40.50.1370:FF:000034', NULL, NULL, 'Ornithine carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(35133, NULL, 'G3DSA:3.10.600.10:FF:000013', NULL, NULL, 'Pyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(35134, NULL, 'G3DSA:1.20.1530.20:FF:000060', NULL, NULL, 'sodium/bile acid cotransporter 7', NULL, NULL, NULL, NULL, NULL, 4),
(35135, NULL, 'G3DSA:2.60.40.60:FF:001044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35136, NULL, 'G3DSA:2.30.42.10:FF:000517', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35137, NULL, 'G3DSA:3.60.15.10:FF:000283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35138, NULL, 'G3DSA:3.40.50.150:FF:001344', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35139, NULL, 'G3DSA:2.170.300.10:FF:000018', NULL, NULL, 'angiopoietin-1 receptor isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(35140, NULL, 'G3DSA:3.40.50.300:FF:000130', NULL, NULL, 'Chromodomain-helicase-DNA-binding protein 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(35141, NULL, 'G3DSA:3.30.300.30:FF:000076', NULL, NULL, 'ATP-dependent serine activating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(35142, NULL, 'G3DSA:3.80.10.10:FF:002963', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35143, NULL, 'G3DSA:1.20.1250.20:FF:001550', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35144, NULL, 'G3DSA:3.40.50.300:FF:002058', NULL, NULL, 'Sulfate adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(35145, NULL, 'G3DSA:2.30.29.30:FF:001381', NULL, NULL, 'Uncharacterized protein R02F2.2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(35146, NULL, 'G3DSA:3.20.20.60:FF:000148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35147, NULL, 'G3DSA:3.30.450.40:FF:000180', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(35148, NULL, 'G3DSA:3.30.70.330:FF:000842', NULL, NULL, 'Pumilio domain-containing protein c', NULL, NULL, NULL, NULL, NULL, 4),
(35149, NULL, 'G3DSA:1.10.238.10:FF:000521', NULL, NULL, 'Calexcitin-2', NULL, NULL, NULL, NULL, NULL, 4),
(35150, NULL, 'G3DSA:2.60.120.230:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35151, NULL, 'G3DSA:1.10.1200.10:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35152, NULL, 'G3DSA:1.10.1060.10:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35153, NULL, 'G3DSA:3.80.10.10:FF:000046', NULL, NULL, 'Toll-like receptor 2', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(35154, NULL, 'G3DSA:3.40.190.10:FF:000564', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(35155, NULL, 'G3DSA:3.30.870.10:FF:000079', NULL, NULL, 'Phospholipase D family protein', NULL, NULL, NULL, NULL, NULL, 4),
(35156, NULL, 'G3DSA:1.20.1250.20:FF:002376', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35157, NULL, 'G3DSA:3.30.559.10:FF:000018', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(35158, NULL, 'G3DSA:3.50.30.30:FF:000066', NULL, NULL, 'Signal peptide peptidase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(35159, NULL, 'G3DSA:1.10.10.10:FF:000065', NULL, NULL, 'Interferon regulatory factor', NULL, NULL, NULL, NULL, NULL, 4),
(35160, NULL, 'G3DSA:3.30.390.60:FF:000017', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(35161, NULL, 'G3DSA:2.60.40.790:FF:000072', NULL, NULL, 'Small heat shock protein HSP16.5', NULL, NULL, NULL, NULL, NULL, 4),
(35162, NULL, 'G3DSA:1.20.1070.10:FF:002180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35163, NULL, 'G3DSA:2.130.10.10:FF:002103', NULL, NULL, 'CPSF A subunit region protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(35164, NULL, 'G3DSA:1.20.140.150:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35165, NULL, 'G3DSA:2.40.270.10:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35166, NULL, 'G3DSA:1.25.40.950:FF:000001', NULL, NULL, 'Arf-GAP with SH3 domain, ANK repeat and PH domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(35167, NULL, 'G3DSA:3.80.10.10:FF:002507', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35168, NULL, 'G3DSA:2.60.120.380:FF:000031', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(35169, NULL, 'G3DSA:3.30.70.330:FF:001359', NULL, NULL, 'Uncharacterized protein B13D15.200', NULL, NULL, NULL, NULL, NULL, 4),
(35170, NULL, 'G3DSA:2.40.50.140:FF:001244', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35171, NULL, 'G3DSA:2.130.10.10:FF:002316', NULL, NULL, 'Serine/threonine-protein kinase PRP4', NULL, NULL, NULL, NULL, NULL, 4),
(35172, NULL, 'G3DSA:2.30.29.30:FF:000892', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35173, NULL, 'G3DSA:3.30.60.90:FF:000047', NULL, NULL, 'ZZ-type zinc finger-containing protein P35G2.11c', NULL, NULL, NULL, NULL, NULL, 4),
(35174, NULL, 'G3DSA:3.30.200.20:FF:001454', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35175, NULL, 'G3DSA:3.10.20.90:FF:000787', NULL, NULL, 'Inhibitor of nuclear factor kappa-B kinase subunit beta-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(35176, NULL, 'G3DSA:2.130.10.10:FF:001827', NULL, NULL, 'UTP4, small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4),
(35177, NULL, 'G3DSA:2.60.470.10:FF:000028', NULL, NULL, 'Amiloride-sensitive sodium channel subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(35178, NULL, 'G3DSA:1.20.1050.10:FF:000149', NULL, NULL, 'Glutathione S-transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(35179, NULL, 'G3DSA:1.10.10.10:FF:000986', NULL, NULL, 'NBS-LRR class disease resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(35180, NULL, 'G3DSA:2.60.15.10:FF:000021', NULL, NULL, 'ATP synthase epsilon chain', NULL, NULL, NULL, NULL, NULL, 4),
(35181, NULL, 'G3DSA:2.60.40.2310:FF:000003', NULL, NULL, 'Subtilisin-like protease SBT4.1', NULL, NULL, NULL, NULL, NULL, 4),
(35182, NULL, 'G3DSA:3.10.100.10:FF:000071', NULL, NULL, 'NKG2-A/NKG2-B type II integral membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(35183, NULL, 'G3DSA:1.10.8.60:FF:000219', NULL, NULL, 'Cell division control protein', NULL, NULL, NULL, NULL, NULL, 4),
(35184, NULL, 'G3DSA:3.50.50.60:FF:000946', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35185, NULL, 'G3DSA:1.20.1070.10:FF:001235', NULL, NULL, 'Frizzled class receptor 8', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(35186, NULL, 'G3DSA:3.30.420.10:FF:000708', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35187, NULL, 'G3DSA:3.30.10.20:FF:000017', NULL, NULL, 'Serine/threonine-protein kinase PrkC', NULL, NULL, NULL, NULL, NULL, 4),
(35188, NULL, 'G3DSA:3.40.50.300:FF:004312', NULL, NULL, 'Elongator complex protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(35189, NULL, 'G3DSA:1.25.10.10:FF:000037', NULL, NULL, 'CCR4-NOT transcription complex subunit 9', NULL, NULL, NULL, NULL, NULL, 4),
(35190, NULL, 'G3DSA:3.40.50.720:FF:000475', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(35191, NULL, 'G3DSA:1.10.238.10:FF:000858', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35192, NULL, 'G3DSA:2.10.110.30:FF:000002', NULL, NULL, 'Putative e3 ubiquitin-protein ligase ubr3', NULL, NULL, NULL, NULL, NULL, 4),
(35193, NULL, 'G3DSA:1.10.630.10:FF:000826', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35194, NULL, 'G3DSA:2.102.10.10:FF:000025', NULL, NULL, 'Vanillate O-demethylase, oxygenase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(35195, NULL, 'G3DSA:3.30.70.330:FF:001331', NULL, NULL, 'RNA-binding protein fox-1 homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(35196, NULL, 'G3DSA:3.30.2010.30:FF:000003', NULL, NULL, 'aminopeptidase O isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(35197, NULL, 'G3DSA:1.20.58.60:FF:000650', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35198, NULL, 'G3DSA:2.130.10.10:FF:003289', NULL, NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', NULL, NULL, NULL, NULL, NULL, 4),
(35199, NULL, 'G3DSA:3.30.70.20:FF:000122', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35200, NULL, 'G3DSA:3.40.50.720:FF:001335', NULL, NULL, 'NAD(P)-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(35201, NULL, 'G3DSA:1.20.120.1750:FF:000032', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(35202, NULL, 'G3DSA:2.20.70.10:FF:000274', NULL, NULL, 'RNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(35203, NULL, 'G3DSA:3.30.160.60:FF:005643', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35204, NULL, 'G3DSA:1.10.510.10:FF:001840', NULL, NULL, 'Cdc2-related protein kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(35205, NULL, 'G3DSA:2.30.30.140:FF:000101', NULL, NULL, 'DNA/RNA-binding protein KIN17', NULL, NULL, NULL, NULL, NULL, 4),
(35206, NULL, 'G3DSA:3.30.465.10:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35207, NULL, 'G3DSA:3.30.710.10:FF:000478', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35208, NULL, 'G3DSA:1.10.287.130:FF:000209', NULL, NULL, 'Integral membrane sensor signal transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(35209, NULL, 'G3DSA:3.40.33.10:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35210, NULL, 'G3DSA:1.20.5.470:FF:000007', NULL, NULL, 'Argininosuccinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(35211, NULL, 'G3DSA:1.20.5.3960:FF:000001', NULL, NULL, 'Anti-sigma-E factor RseA', NULL, NULL, NULL, NULL, NULL, 4),
(35212, NULL, 'G3DSA:3.30.460.10:FF:000143', NULL, NULL, 'Ribosomal silencing factor RsfS', NULL, NULL, NULL, NULL, NULL, 4),
(35213, NULL, 'G3DSA:2.120.10.30:FF:000485', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35214, NULL, 'G3DSA:1.10.472.80:FF:000092', NULL, NULL, 'TBC1 domain family member 15 isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(35215, NULL, 'G3DSA:1.10.287.110:FF:000221', NULL, NULL, 'Protein CBR-DNJ-18', NULL, NULL, NULL, NULL, NULL, 4),
(35216, NULL, 'G3DSA:1.20.58.2130:FF:000003', NULL, NULL, 'DNA replication regulator SLD3', NULL, NULL, NULL, NULL, NULL, 4),
(35217, NULL, 'G3DSA:1.10.10.440:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35218, NULL, 'G3DSA:2.40.50.140:FF:001114', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35219, NULL, 'G3DSA:3.40.50.10810:FF:000100', NULL, NULL, 'SNF2 family protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(35220, NULL, 'G3DSA:3.40.640.10:FF:000071', NULL, NULL, 'Kynurenine/alpha-aminoadipate aminotransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(35221, NULL, 'G3DSA:3.40.50.300:FF:005464', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(35222, NULL, 'G3DSA:2.40.50.140:FF:000496', NULL, NULL, 'Conserved hypothetical alanine,valine and glycine rich protein', NULL, NULL, NULL, NULL, NULL, 4),
(35223, NULL, 'G3DSA:3.30.1330.60:FF:000013', NULL, NULL, 'Flagellar motor protein MotD', NULL, NULL, NULL, NULL, NULL, 4),
(35224, NULL, 'G3DSA:3.40.50.620:FF:000563', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(35225, NULL, 'G3DSA:1.10.3260.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35226, NULL, 'G3DSA:1.20.1250.20:FF:001887', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35227, NULL, 'G3DSA:3.30.70.980:FF:000003', NULL, NULL, 'Probable transcriptional regulatory protein YeeN', NULL, NULL, NULL, NULL, NULL, 4),
(35228, NULL, 'G3DSA:1.20.58.340:FF:000069', NULL, NULL, 'Magnesium transport protein CorA', NULL, NULL, NULL, NULL, NULL, 4),
(35229, NULL, 'G3DSA:3.40.50.300:FF:006993', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35230, NULL, 'G3DSA:2.10.60.10:FF:000066', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(35231, NULL, 'G3DSA:3.80.10.10:FF:000838', NULL, NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g53440', NULL, NULL, NULL, NULL, NULL, 4),
(35232, NULL, 'G3DSA:3.30.40.10:FF:001135', NULL, NULL, 'SNF2 domain-containing protein / helicase domain-containing protein / zinc finger protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(35233, NULL, 'G3DSA:3.80.10.10:FF:004099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35234, NULL, 'G3DSA:3.30.450.20:FF:000073', NULL, NULL, 'Putative Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(35235, NULL, 'G3DSA:1.10.287.70:FF:000461', NULL, NULL, 'Calcium-activated potassium channel subunit alpha-1', NULL, NULL, NULL, NULL, NULL, 4),
(35236, NULL, 'G3DSA:2.60.120.590:FF:000004', NULL, NULL, 'DNA oxidative demethylase ALKBH2', NULL, NULL, NULL, NULL, NULL, 4),
(35237, NULL, 'G3DSA:2.60.40.10:FF:002451', NULL, NULL, 'PLeXin', NULL, NULL, NULL, NULL, NULL, 4),
(35238, NULL, 'G3DSA:2.60.40.10:FF:001832', NULL, NULL, 'Interleukin-12 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(35239, NULL, 'G3DSA:1.20.1110.10:FF:000194', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35240, NULL, 'G3DSA:1.20.5.170:FF:000119', NULL, NULL, 'ATF (cAMP-dependent transcription factor) family', NULL, NULL, NULL, NULL, NULL, 4),
(35241, NULL, 'G3DSA:1.20.5.450:FF:000001', NULL, NULL, 'radixin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(35242, NULL, 'G3DSA:3.40.50.150:FF:001799', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35243, NULL, 'G3DSA:3.30.70.260:FF:000017', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(35244, NULL, 'G3DSA:3.40.1700.10:FF:000002', NULL, NULL, 'Diadenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(35245, NULL, 'G3DSA:3.60.21.10:FF:000128', NULL, NULL, 'Purple acid phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(35246, NULL, 'G3DSA:1.25.10.10:FF:000150', NULL, NULL, 'Nipped-B protein', NULL, NULL, NULL, NULL, NULL, 4),
(35247, NULL, 'G3DSA:2.60.120.200:FF:000146', NULL, NULL, 'Axotactin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(35248, NULL, 'G3DSA:3.30.70.1070:FF:000008', NULL, NULL, 'Sporulation related domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(35249, NULL, 'G3DSA:3.10.250.10:FF:000087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35250, NULL, 'G3DSA:2.10.25.10:FF:000613', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(35251, NULL, 'G3DSA:1.20.1050.10:FF:000155', NULL, NULL, 'Putative glutathione S-transferase C460.02c', NULL, NULL, NULL, NULL, NULL, 4),
(35252, NULL, 'G3DSA:1.25.40.10:FF:003299', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g18485', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(35253, NULL, 'G3DSA:4.10.400.10:FF:000045', NULL, NULL, 'Low-density lipoprotein receptor-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(35254, NULL, 'G3DSA:2.10.10.10:FF:000017', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(35255, NULL, 'G3DSA:3.90.660.10:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35256, NULL, 'G3DSA:1.20.120.1760:FF:000041', NULL, NULL, 'Aminoalcoholphosphotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(35257, NULL, 'G3DSA:3.90.70.10:FF:000173', NULL, NULL, 'Aminopeptidase C', NULL, NULL, NULL, NULL, NULL, 4),
(35258, NULL, 'G3DSA:3.40.50.300:FF:001086', NULL, NULL, 'GTP-binding protein GTR2', NULL, NULL, NULL, NULL, NULL, 4),
(35259, NULL, 'G3DSA:3.40.350.10:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35260, NULL, 'G3DSA:1.10.238.10:FF:001235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35261, NULL, 'G3DSA:3.40.109.10:FF:000033', NULL, NULL, 'NAD(P)H-flavin oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(35262, NULL, 'G3DSA:3.40.50.1820:FF:000995', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35263, NULL, 'G3DSA:1.10.287.1060:FF:000017', NULL, NULL, 'Alpha-(1,6)-fucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(35264, NULL, 'G3DSA:1.10.1820.10:FF:000008', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(35265, NULL, 'G3DSA:2.60.40.830:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35266, NULL, 'G3DSA:1.20.1740.10:FF:000005', NULL, NULL, 'Solute carrier family 12 member 1', NULL, NULL, NULL, NULL, NULL, 4),
(35267, NULL, 'G3DSA:3.60.20.10:FF:000250', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35268, NULL, 'G3DSA:3.30.428.10:FF:000046', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(35269, NULL, 'G3DSA:2.40.50.120:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35270, NULL, 'G3DSA:3.30.300.290:FF:000001', NULL, NULL, 'Probable phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(35271, NULL, 'G3DSA:3.30.70.330:FF:001702', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35272, NULL, 'G3DSA:3.60.150.10:FF:000017', NULL, NULL, 'Chorismate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(35273, NULL, 'G3DSA:3.40.50.300:FF:000260', NULL, NULL, 'Cell division control 10', NULL, NULL, NULL, NULL, NULL, 4),
(35274, NULL, 'G3DSA:3.40.50.300:FF:002401', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(35275, NULL, 'G3DSA:2.10.110.20:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35276, NULL, 'G3DSA:1.10.287.1490:FF:000130', NULL, NULL, 'Viral A-type inclusion protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(35277, NULL, 'G3DSA:3.40.630.30:FF:000475', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35278, NULL, 'G3DSA:1.10.8.60:FF:000320', NULL, NULL, 'ATP-dependent Clp protease subunit, heat shock protein 100 (HSP100), putative', NULL, NULL, NULL, NULL, NULL, 4),
(35279, NULL, 'G3DSA:3.30.200.20:FF:000835', NULL, NULL, 'CMGC/CDK/CRK7 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(35280, NULL, 'G3DSA:3.40.1360.10:FF:000032', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(35281, NULL, 'G3DSA:3.30.40.10:FF:000179', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(35282, NULL, 'G3DSA:2.10.50.10:FF:000138', NULL, NULL, 'Tumor necrosis factor receptor superfamily, member 11b', NULL, NULL, NULL, NULL, NULL, 4),
(35283, NULL, 'G3DSA:3.10.20.90:FF:000444', NULL, NULL, 'Protein CBG19533', NULL, NULL, NULL, NULL, NULL, 4),
(35284, NULL, 'G3DSA:3.30.1330.80:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35285, NULL, 'G3DSA:3.40.50.300:FF:003227', NULL, NULL, 'ATPase component BioM of energizing module of biotin ECF transporter', NULL, NULL, NULL, NULL, NULL, 4),
(35286, NULL, 'G3DSA:1.10.1030.10:FF:000004', NULL, NULL, 'Carbamoyl-phosphate synthase (glutamine-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(35287, NULL, 'G3DSA:2.170.140.10:FF:000028', NULL, NULL, 'mucin-2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(35288, NULL, 'G3DSA:2.40.50.140:FF:000597', NULL, NULL, 'tRNA-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(35289, NULL, 'G3DSA:3.80.10.10:FF:002384', NULL, NULL, 'Insulin like growth factor binding protein acid labile subunit', NULL, NULL, NULL, NULL, NULL, 4),
(35290, NULL, 'G3DSA:2.40.70.10:FF:000205', NULL, NULL, 'Acid protease', NULL, NULL, NULL, NULL, NULL, 4),
(35291, NULL, 'G3DSA:3.30.160.60:FF:004025', NULL, NULL, 'Hindsight transcription factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(35292, NULL, 'G3DSA:3.40.250.10:FF:000159', NULL, NULL, 'Lon-8', NULL, NULL, NULL, NULL, NULL, 4),
(35293, NULL, 'G3DSA:2.40.50.100:FF:000063', NULL, NULL, 'Exosome complex component RRP4', NULL, NULL, NULL, NULL, NULL, 4),
(35294, NULL, 'G3DSA:3.30.342.10:FF:000026', NULL, NULL, 'DNA polymerase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(35295, NULL, 'G3DSA:1.10.274.100:FF:000017', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(35296, NULL, 'G3DSA:3.30.56.130:FF:000001', NULL, NULL, 'Transcriptional regulator CtsR', NULL, NULL, NULL, NULL, NULL, 4),
(35297, NULL, 'G3DSA:3.80.10.10:FF:000254', NULL, NULL, 'nucleotide-binding oligomerization domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(35298, NULL, 'G3DSA:3.50.50.60:FF:001110', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(35299, NULL, 'G3DSA:3.20.20.70:FF:000134', NULL, NULL, '7,8-didemethyl-8-hydroxy-5-deazariboflavin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(35300, NULL, 'G3DSA:1.20.930.10:FF:000026', NULL, NULL, 'Alginate regulatory protein AlgR3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(35301, NULL, 'G3DSA:2.60.120.10:FF:000166', NULL, NULL, 'blood vessel epicardial substance isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(35302, NULL, 'G3DSA:3.60.21.10:FF:000241', NULL, NULL, 'Acid sphingomyelinase-like phosphodiesterase 3b', NULL, NULL, NULL, NULL, NULL, 4),
(35303, NULL, 'G3DSA:1.10.510.10:FF:001508', NULL, NULL, 'STK24 isoform 7', NULL, NULL, NULL, NULL, NULL, 4),
(35304, NULL, 'G3DSA:3.30.160.60:FF:006262', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35305, NULL, 'G3DSA:3.90.190.10:FF:000098', NULL, NULL, 'Protein-tryrosine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(35306, NULL, 'G3DSA:3.30.160.60:FF:003294', NULL, NULL, 'Zinc finger protein 1001', NULL, NULL, NULL, NULL, NULL, 4),
(35307, NULL, 'G3DSA:3.90.740.10:FF:000005', NULL, NULL, 'Valine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(35308, NULL, 'G3DSA:1.10.287.3810:FF:000005', NULL, NULL, 'Tryptophan 2,3-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(35309, NULL, 'G3DSA:2.60.40.10:FF:002237', NULL, NULL, 'Protein tyrosine phosphatase 4E, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(35310, NULL, 'G3DSA:3.40.50.2000:FF:000369', NULL, NULL, 'UDP-GlucuronosylTransferase', NULL, NULL, NULL, NULL, NULL, 4),
(35311, NULL, 'G3DSA:3.10.129.10:FF:000182', NULL, NULL, '4-hydroxybenzoyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(35312, NULL, 'G3DSA:3.60.10.10:FF:000209', NULL, NULL, 'YALI0A17578p', NULL, NULL, NULL, NULL, NULL, 4),
(35313, NULL, 'G3DSA:1.10.287.110:FF:000007', NULL, NULL, 'DnaJ (Hsp40) homolog, subfamily C, member 13', NULL, NULL, NULL, NULL, NULL, 4),
(35314, NULL, 'G3DSA:3.30.70.260:FF:000130', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(35315, NULL, 'G3DSA:1.20.1070.10:FF:000263', NULL, NULL, 'G-protein coupled receptor GRL101-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(35316, NULL, 'G3DSA:3.30.200.20:FF:001774', NULL, NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(35317, NULL, 'G3DSA:1.10.510.10:FF:000430', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(35318, NULL, 'G3DSA:3.30.230.120:FF:000012', NULL, NULL, 'L-fucose kinase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(35319, NULL, 'G3DSA:2.40.50.140:FF:000833', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35320, NULL, 'G3DSA:3.30.70.1230:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35321, NULL, 'G3DSA:3.30.70.100:FF:000110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35322, NULL, 'G3DSA:2.30.30.380:FF:000044', NULL, NULL, 'RanBP-type and C3HC4-type zinc finger containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(35323, NULL, 'G3DSA:1.10.287.810:FF:000009', NULL, NULL, 'Mitochondrial import inner membrane translocase subunit TIM10, putative', NULL, NULL, NULL, NULL, NULL, 4),
(35324, NULL, 'G3DSA:3.10.440.10:FF:000012', NULL, NULL, '50S ribosomal protein L31e', NULL, NULL, NULL, NULL, NULL, 4),
(35325, NULL, 'G3DSA:3.20.20.10:FF:000049', NULL, NULL, 'Ornithine decarboxylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(35326, NULL, 'G3DSA:1.10.565.10:FF:000028', NULL, NULL, 'Nuclear receptor subfamily 0 group B member 2', NULL, NULL, NULL, NULL, NULL, 4),
(35327, NULL, 'G3DSA:2.40.160.60:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35328, NULL, 'G3DSA:4.10.1250.10:FF:000001', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(35329, NULL, 'G3DSA:1.20.1070.10:FF:000847', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(35330, NULL, 'G3DSA:3.40.50.300:FF:006892', NULL, NULL, 'MxD protein', NULL, NULL, NULL, NULL, NULL, 4),
(35331, NULL, 'G3DSA:1.10.10.10:FF:001812', NULL, NULL, 'Nitrogen regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(35332, NULL, 'G3DSA:3.50.50.60:FF:000284', NULL, NULL, 'Chromosome 15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(35333, NULL, 'G3DSA:3.30.40.10:FF:000516', NULL, NULL, 'ESTs AU075348(C11252)', NULL, NULL, NULL, NULL, NULL, 4),
(35334, NULL, 'G3DSA:3.30.160.60:FF:001591', NULL, NULL, 'DAZ interacting zinc finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(35335, NULL, 'G3DSA:3.40.91.60:FF:000002', NULL, NULL, 'RNA-directed RNA polymerase L', NULL, NULL, NULL, NULL, NULL, 4),
(35336, NULL, 'G3DSA:1.10.510.10:FF:001155', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(35337, NULL, 'G3DSA:1.25.40.10:FF:000882', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(35338, NULL, 'G3DSA:1.20.1260.10:FF:000075', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(35339, NULL, 'G3DSA:1.10.20.140:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35340, NULL, 'G3DSA:3.60.20.10:FF:000137', NULL, NULL, 'Proteasome subunit alpha type', NULL, NULL, NULL, NULL, NULL, 4),
(35341, NULL, 'G3DSA:3.30.70.330:FF:001910', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35342, NULL, 'G3DSA:1.10.510.10:FF:003184', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35343, NULL, 'G3DSA:3.40.50.720:FF:001543', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35344, NULL, 'G3DSA:3.40.50.720:FF:000924', NULL, NULL, 'GDP-mannose 4,6 dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(35345, NULL, 'G3DSA:1.25.10.10:FF:002611', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35346, NULL, 'G3DSA:1.20.1310.10:FF:000203', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35347, NULL, 'G3DSA:1.20.120.890:FF:000003', NULL, NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', NULL, NULL, NULL, NULL, NULL, 4),
(35348, NULL, 'G3DSA:3.90.470.10:FF:000029', NULL, NULL, '60S ribosomal protein L17', NULL, NULL, NULL, NULL, NULL, 4),
(35349, NULL, 'G3DSA:1.20.1270.10:FF:000036', NULL, NULL, 'Chaperone protein DnaK', NULL, NULL, NULL, NULL, NULL, 4),
(35350, NULL, 'G3DSA:1.10.287.370:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35351, NULL, 'G3DSA:2.30.30.1160:FF:000002', NULL, NULL, 'YALI0A11869p', NULL, NULL, NULL, NULL, NULL, 4),
(35352, NULL, 'G3DSA:3.30.160.60:FF:002788', NULL, NULL, 'tRNA dimethylallyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(35353, NULL, 'G3DSA:1.10.150.20:FF:000236', NULL, NULL, 'DNA transformation protein tfoX', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(35354, NULL, 'G3DSA:2.130.10.10:FF:000175', NULL, NULL, 'Phospholipase A-2-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(35355, NULL, 'G3DSA:2.130.10.10:FF:003744', NULL, NULL, 'U3 snoRNP-associated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(35356, NULL, 'G3DSA:1.20.120.1910:FF:000007', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(35357, NULL, 'G3DSA:3.40.50.720:FF:000716', NULL, NULL, 'Probable short-chain type dehydrogenase/reductase', NULL, NULL, NULL, NULL, NULL, 4),
(35358, NULL, 'G3DSA:3.30.70.100:FF:000099', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(35359, NULL, 'G3DSA:3.30.10.30:FF:000003', NULL, NULL, 'Dual specificity tyrosine-phosphorylation-regulated kinase mbk-2', NULL, NULL, NULL, NULL, NULL, 4),
(35360, NULL, 'G3DSA:3.30.54.20:FF:000006', NULL, NULL, 'Tryptophan-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(35361, NULL, 'G3DSA:1.10.238.150:FF:000010', NULL, NULL, 'Formin-E', NULL, NULL, NULL, NULL, NULL, 4),
(35362, NULL, 'G3DSA:3.60.20.10:FF:000042', NULL, NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', NULL, NULL, NULL, NULL, NULL, 4),
(35363, NULL, 'G3DSA:2.30.36.90:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35364, NULL, 'G3DSA:3.90.230.10:FF:000034', NULL, NULL, 'Chromatin-specific transcription elongation factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(35365, NULL, 'G3DSA:2.130.10.30:FF:000057', NULL, NULL, 'RCC1-like G exchanging factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(35366, NULL, 'G3DSA:3.30.30.10:FF:000010', NULL, NULL, 'AGAP004632-PA', NULL, NULL, NULL, NULL, NULL, 4),
(35367, NULL, 'G3DSA:1.20.1250.20:FF:000370', NULL, NULL, 'Nicotinic acid permease', NULL, NULL, NULL, NULL, NULL, 4),
(35368, NULL, 'G3DSA:3.30.30.30:FF:000016', NULL, NULL, 'Heat shock protein 110', NULL, NULL, NULL, NULL, NULL, 4),
(35369, NULL, 'G3DSA:2.160.20.10:FF:000202', NULL, NULL, 'Pectin lyase-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(35370, NULL, 'G3DSA:1.10.10.60:FF:001237', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35371, NULL, 'G3DSA:1.25.10.10:FF:001774', NULL, NULL, 'YALI0B18480p', NULL, NULL, NULL, NULL, NULL, 4),
(35372, NULL, 'G3DSA:3.40.50.620:FF:000900', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35373, NULL, 'G3DSA:3.90.550.10:FF:000182', NULL, NULL, 'dTDP-RHA:A-D-GlcNAc-diphosphoryl polyprenolA-3-L-rhamnosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(35374, NULL, 'G3DSA:1.10.3210.10:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35375, NULL, 'G3DSA:1.25.40.20:FF:001492', NULL, NULL, 'S-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(35376, NULL, 'G3DSA:1.25.40.10:FF:001955', NULL, NULL, 'GM14977', NULL, NULL, NULL, NULL, NULL, 4),
(35377, NULL, 'G3DSA:3.90.70.10:FF:000510', NULL, NULL, 'Ubiquitin specific peptidase 40', NULL, NULL, NULL, NULL, NULL, 4),
(35378, NULL, 'G3DSA:2.130.10.130:FF:000019', NULL, NULL, 'Integrin alpha pat-2', NULL, NULL, NULL, NULL, NULL, 4),
(35379, NULL, 'G3DSA:3.40.50.1820:FF:000091', NULL, NULL, 'Gastric triacylglycerol lipase', NULL, NULL, NULL, NULL, NULL, 4),
(35380, NULL, 'G3DSA:1.10.287.950:FF:000023', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(35381, NULL, 'G3DSA:3.30.470.30:FF:000077', NULL, NULL, 'mRNA-capping enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(35382, NULL, 'G3DSA:1.25.40.20:FF:000082', NULL, NULL, 'Inversin', NULL, NULL, NULL, NULL, NULL, 4),
(35383, NULL, 'G3DSA:1.20.120.140:FF:000003', NULL, NULL, 'Signal recognition particle 54 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(35384, NULL, 'G3DSA:3.20.20.80:FF:000238', NULL, NULL, 'Klotho beta', NULL, NULL, NULL, NULL, NULL, 4),
(35385, NULL, 'G3DSA:3.40.50.2300:FF:000257', NULL, NULL, 'glutamate receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(35386, NULL, 'G3DSA:1.25.40.20:FF:001503', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35387, NULL, 'G3DSA:1.10.10.10:FF:001251', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(35388, NULL, 'G3DSA:3.10.129.10:FF:000294', NULL, NULL, 'Polyketide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(35389, NULL, 'G3DSA:1.10.10.60:FF:000164', NULL, NULL, 'Arabinose operon transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(35390, NULL, 'G3DSA:3.80.10.10:FF:004424', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35391, NULL, 'G3DSA:3.30.830.10:FF:000054', NULL, NULL, 'Falcilysin', NULL, NULL, NULL, NULL, NULL, 4),
(35392, NULL, 'G3DSA:1.20.120.1920:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35393, NULL, 'G3DSA:3.30.200.20:FF:001223', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(35394, NULL, 'G3DSA:2.60.120.290:FF:000021', NULL, NULL, 'Low-density lipoprotein receptor-related protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(35395, NULL, 'G3DSA:3.90.190.10:FF:000210', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase delta isoform x2', NULL, NULL, NULL, NULL, NULL, 4),
(35396, NULL, 'G3DSA:3.40.50.10950:FF:000001', NULL, NULL, 'Phosphate acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(35397, NULL, 'G3DSA:3.30.160.60:FF:003406', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35398, NULL, 'G3DSA:2.40.30.330:FF:000015', NULL, NULL, 'mRNA cleavage and polyadenylation factor CLP1', NULL, NULL, NULL, NULL, NULL, 4),
(35399, NULL, 'G3DSA:2.40.33.10:FF:000024', NULL, NULL, 'Plastidial pyruvate kinase 4, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(35400, NULL, 'G3DSA:3.40.50.300:FF:003126', NULL, NULL, 'ATP-dependent helicase', NULL, NULL, NULL, NULL, NULL, 4),
(35401, NULL, 'G3DSA:3.30.1370.100:FF:000013', NULL, NULL, 'DNA mismatch repair protein mutL, putative', NULL, NULL, NULL, NULL, NULL, 4),
(35402, NULL, 'G3DSA:2.150.10.10:FF:000005', NULL, NULL, 'Adhesin', NULL, NULL, NULL, NULL, NULL, 4),
(35403, NULL, 'G3DSA:3.40.50.720:FF:000363', NULL, NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(35404, NULL, 'G3DSA:2.130.10.10:FF:005531', NULL, NULL, 'WD-40 repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(35405, NULL, 'G3DSA:1.25.10.10:FF:002403', NULL, NULL, 'Importin beta-like SAD2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(35406, NULL, 'G3DSA:1.10.510.10:FF:004140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35407, NULL, 'G3DSA:1.10.3720.10:FF:000203', NULL, NULL, 'Glutathione transport system permease protein GsiC', NULL, NULL, NULL, NULL, NULL, 4),
(35408, NULL, 'G3DSA:2.30.30.100:FF:000016', NULL, NULL, 'Small nuclear ribonucleoprotein Sm D1', NULL, NULL, NULL, NULL, NULL, 4),
(35409, NULL, 'G3DSA:2.40.128.130:FF:000005', NULL, NULL, 'Polymorphic outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(35410, NULL, 'G3DSA:1.10.1450.10:FF:000070', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(35411, NULL, 'G3DSA:3.70.10.10:FF:000007', NULL, NULL, 'Gp45 sliding clamp DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(35412, NULL, 'G3DSA:2.130.10.10:FF:005301', NULL, NULL, 'WD40-repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(35413, NULL, 'G3DSA:3.40.250.10:FF:000035', NULL, NULL, 'Thiosulfate sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(35414, NULL, 'G3DSA:3.90.1200.10:FF:000014', NULL, NULL, 'Ethanolamine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(35415, NULL, 'G3DSA:1.10.510.10:FF:003864', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35416, NULL, 'G3DSA:1.25.40.10:FF:002574', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(35417, NULL, 'G3DSA:3.30.420.40:FF:000695', NULL, NULL, 'Glycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(35418, NULL, 'G3DSA:1.25.40.10:FF:001820', NULL, NULL, 'Protein CBG09345', NULL, NULL, NULL, NULL, NULL, 4),
(35419, NULL, 'G3DSA:2.60.40.60:FF:001145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35420, NULL, 'G3DSA:2.40.50.40:FF:000078', NULL, NULL, 'C-C motif chemokine 23-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(35421, NULL, 'G3DSA:1.10.10.10:FF:001150', NULL, NULL, 'Cullin 4B', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(35422, NULL, 'G3DSA:2.10.25.10:FF:000288', NULL, NULL, 'Astrotactin 2', NULL, NULL, NULL, NULL, NULL, 4),
(35423, NULL, 'G3DSA:1.20.1280.170:FF:000003', NULL, NULL, 'Exocyst subunit Exo70 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(35424, NULL, 'G3DSA:2.60.40.10:FF:004946', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35425, NULL, 'G3DSA:3.40.50.200:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35426, NULL, 'G3DSA:3.40.50.2060:FF:000016', NULL, NULL, 'Sec1/munc18-like (SM) proteins superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(35427, NULL, 'G3DSA:1.25.40.660:FF:000021', NULL, NULL, 'Vacuolar protein sorting-associated protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(35428, NULL, 'G3DSA:3.30.70.2190:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35429, NULL, 'G3DSA:1.20.1640.10:FF:000060', NULL, NULL, 'Resistance-Nodulation-cell Division (RND) efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(35430, NULL, 'G3DSA:1.10.630.10:FF:000601', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35431, NULL, 'G3DSA:1.10.287.3240:FF:000020', NULL, NULL, 'V-type H+-transporting ATPase subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(35432, NULL, 'G3DSA:2.130.10.10:FF:003160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35433, NULL, 'G3DSA:2.60.120.1440:FF:000012', NULL, NULL, 'Probable transmembrane sensor', NULL, NULL, NULL, NULL, NULL, 4),
(35434, NULL, 'G3DSA:3.40.50.300:FF:005835', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35435, NULL, 'G3DSA:3.30.1460.50:FF:000025', NULL, NULL, 'Autophagy related 10', NULL, NULL, NULL, NULL, NULL, 4),
(35436, NULL, 'G3DSA:3.40.850.10:FF:000137', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(35437, NULL, 'G3DSA:3.40.50.300:FF:004407', NULL, NULL, 'Small guanosine triphosphatase, Ras-related family', NULL, NULL, NULL, NULL, NULL, 4),
(35438, NULL, 'G3DSA:3.30.160.60:FF:001383', NULL, NULL, 'Zinc finger protein 212', NULL, NULL, NULL, NULL, NULL, 4),
(35439, NULL, 'G3DSA:3.10.180.10:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35440, NULL, 'G3DSA:1.10.630.10:FF:000489', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(35441, NULL, 'G3DSA:2.40.290.10:FF:000042', NULL, NULL, 'DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(35442, NULL, 'G3DSA:3.30.420.10:FF:000259', NULL, NULL, 'Polymerase (DNA directed), theta', NULL, NULL, NULL, NULL, NULL, 4),
(35443, NULL, 'G3DSA:3.60.40.10:FF:000037', NULL, NULL, 'Protein phosphatase, Mg2+/Mn2+-dependent, 1M', NULL, NULL, NULL, NULL, NULL, 4),
(35444, NULL, 'G3DSA:3.40.50.10190:FF:000054', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(35445, NULL, 'G3DSA:3.60.15.10:FF:000075', NULL, NULL, 'Ribonuclease Z', NULL, NULL, NULL, NULL, NULL, 4),
(35446, NULL, 'G3DSA:1.10.10.1590:FF:000006', NULL, NULL, 'Formate dehydrogenase, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(35447, NULL, 'G3DSA:2.60.120.380:FF:000048', NULL, NULL, 'Calpain-9', NULL, NULL, NULL, NULL, NULL, 4),
(35448, NULL, 'G3DSA:1.25.40.20:FF:000188', NULL, NULL, 'NF-kappa-B inhibitor zeta isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(35449, NULL, 'G3DSA:1.25.40.1030:FF:000011', NULL, NULL, 'SEC31 homolog B, COPII coat complex component', NULL, NULL, NULL, NULL, NULL, 4),
(35450, NULL, 'G3DSA:1.50.40.10:FF:000582', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35451, NULL, 'G3DSA:3.40.50.10190:FF:000189', NULL, NULL, 'Cell cycle checkpoint protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(35452, NULL, 'G3DSA:3.40.50.2300:FF:000920', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35453, NULL, 'G3DSA:2.130.10.10:FF:001147', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(35454, NULL, 'G3DSA:1.20.58.1070:FF:000005', NULL, NULL, 'Spliceosome protein-like protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(35455, NULL, 'G3DSA:1.10.287.470:FF:000070', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(35456, NULL, 'G3DSA:2.60.40.1180:FF:000164', NULL, NULL, 'Alpha-L-arabinofuranosidase C', NULL, NULL, NULL, NULL, NULL, 4),
(35457, NULL, 'G3DSA:1.10.443.20:FF:000006', NULL, NULL, 'AEL245Wp', NULL, NULL, NULL, NULL, NULL, 4),
(35458, NULL, 'G3DSA:2.30.40.10:FF:000018', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(35459, NULL, 'G3DSA:3.30.420.110:FF:000002', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(35460, NULL, 'G3DSA:1.25.40.10:FF:001146', NULL, NULL, 'Os03g0795200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(35461, NULL, 'G3DSA:1.20.5.1300:FF:000007', NULL, NULL, 'Histidinol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(35462, NULL, 'G3DSA:1.20.920.20:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35463, NULL, 'G3DSA:3.30.70.270:FF:000234', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35464, NULL, 'G3DSA:2.40.160.20:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35465, NULL, 'G3DSA:3.40.50.10330:FF:000023', NULL, NULL, 'diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(35466, NULL, 'G3DSA:3.40.30.10:FF:000942', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35467, NULL, 'G3DSA:3.30.420.40:FF:000936', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(35468, NULL, 'G3DSA:3.40.50.970:FF:000196', NULL, NULL, 'Probable 2-oxoglutarate dehydrogenase E1 component DHKTD1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(35469, NULL, 'G3DSA:3.30.720.150:FF:000003', NULL, NULL, 'UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(35470, NULL, 'G3DSA:2.60.40.10:FF:003518', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35471, NULL, 'G3DSA:3.10.20.80:FF:000003', NULL, NULL, 'Translation initiation factor IF-3', NULL, NULL, NULL, NULL, NULL, 4),
(35472, NULL, 'G3DSA:3.90.650.10:FF:000015', NULL, NULL, 'Hydrogenase expression/formation protein HypE', NULL, NULL, NULL, NULL, NULL, 4),
(35473, NULL, 'G3DSA:3.30.40.10:FF:002192', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(35474, NULL, 'G3DSA:3.30.470.160:FF:000004', NULL, NULL, 'Inositol polyphosphate multikinase alpha', NULL, NULL, NULL, NULL, NULL, 4),
(35475, NULL, 'G3DSA:2.130.10.10:FF:002884', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit wdr4', NULL, NULL, NULL, NULL, NULL, 4),
(35476, NULL, 'G3DSA:1.20.120.850:FF:000019', NULL, NULL, 'DNA repair and recombination protein RAD54B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(35477, NULL, 'G3DSA:3.90.550.10:FF:000390', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(35478, NULL, 'G3DSA:1.10.10.10:FF:002111', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(35479, NULL, 'G3DSA:2.60.120.260:FF:000366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35480, NULL, 'G3DSA:1.10.287.80:FF:000003', NULL, NULL, 'ATP synthase gamma chain, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(35481, NULL, 'G3DSA:3.30.160.60:FF:003980', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35482, NULL, 'G3DSA:1.20.1250.20:FF:002168', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(35483, NULL, 'G3DSA:1.10.8.10:FF:000345', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(35484, NULL, 'G3DSA:1.10.3210.30:FF:000002', NULL, NULL, 'CRISPR-associated helicase Cas3', NULL, NULL, NULL, NULL, NULL, 4),
(35485, NULL, 'G3DSA:1.10.1620.20:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35486, NULL, 'G3DSA:2.120.10.80:FF:000376', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35487, NULL, 'G3DSA:3.30.390.80:FF:000006', NULL, NULL, 'DNA repair RAD52-like protein 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(35488, NULL, 'G3DSA:3.40.50.300:FF:007830', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(35489, NULL, 'G3DSA:1.10.640.10:FF:000074', NULL, NULL, 'Alpha-dioxygenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(35490, NULL, 'G3DSA:3.30.200.20:FF:001566', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35491, NULL, 'G3DSA:3.40.50.300:FF:002507', NULL, NULL, 'Isoniazid inductible gene protein IniC', NULL, NULL, NULL, NULL, NULL, 4),
(35492, NULL, 'G3DSA:3.90.380.10:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35493, NULL, 'G3DSA:2.120.10.30:FF:000277', NULL, NULL, 'Nhl-3', NULL, NULL, NULL, NULL, NULL, 4),
(35494, NULL, 'G3DSA:3.30.1600.10:FF:000031', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(35495, NULL, 'G3DSA:3.40.525.10:FF:000011', NULL, NULL, 'SEC14 cytosolic factor', NULL, NULL, NULL, NULL, NULL, 4),
(35496, NULL, 'G3DSA:2.60.40.60:FF:000184', NULL, NULL, 'neural-cadherin isoform X12', NULL, NULL, NULL, NULL, NULL, 4),
(35497, NULL, 'G3DSA:1.10.10.10:FF:000874', NULL, NULL, 'EAP30/Vps36 family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(35498, NULL, 'G3DSA:1.10.3080.10:FF:000058', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit E', NULL, NULL, NULL, NULL, NULL, 4),
(35499, NULL, 'G3DSA:2.60.40.10:FF:005222', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35500, NULL, 'G3DSA:1.25.40.510:FF:000004', NULL, NULL, 'Putative RNA export mediator Gle1', NULL, NULL, NULL, NULL, NULL, 4),
(35501, NULL, 'G3DSA:2.130.10.10:FF:003401', NULL, NULL, 'Histidine kinase/response regulator hybrid protein', NULL, NULL, NULL, NULL, NULL, 4),
(35502, NULL, 'G3DSA:3.20.20.120:FF:000018', NULL, NULL, 'D(-)-tartrate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(35503, NULL, 'G3DSA:2.30.42.10:FF:000068', NULL, NULL, 'Na(+)/H(+) exchange regulatory cofactor NHE-RF', NULL, NULL, NULL, NULL, NULL, 4),
(35504, NULL, 'G3DSA:3.30.160.60:FF:005435', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35505, NULL, 'G3DSA:3.30.420.40:FF:000032', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(35506, NULL, 'G3DSA:1.20.1560.10:FF:000593', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35507, NULL, 'G3DSA:3.40.50.2300:FF:000465', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(35508, NULL, 'G3DSA:2.30.29.30:FF:000678', NULL, NULL, 'tensin', NULL, NULL, NULL, NULL, NULL, 4),
(35509, NULL, 'G3DSA:3.30.420.10:FF:000697', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35510, NULL, 'G3DSA:3.90.70.10:FF:000274', NULL, NULL, 'Related to calpain', NULL, NULL, NULL, NULL, NULL, 4),
(35511, NULL, 'G3DSA:3.30.70.660:FF:000025', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(35512, NULL, 'G3DSA:2.30.30.40:FF:000055', NULL, NULL, 'rho GTPase-activating protein 26 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(35513, NULL, 'G3DSA:1.20.120.980:FF:000030', NULL, NULL, 'Lysosomal Pro-X carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(35514, NULL, 'G3DSA:3.40.30.10:FF:000381', NULL, NULL, 'UBX domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(35515, NULL, 'G3DSA:1.20.120.140:FF:000014', NULL, NULL, 'Srp101p', NULL, NULL, NULL, NULL, NULL, 4),
(35516, NULL, 'G3DSA:2.40.50.90:FF:000076', NULL, NULL, 'Nuclease domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(35517, NULL, 'G3DSA:1.25.40.10:FF:000101', NULL, NULL, 'Dual specificity protein kinase TTK', NULL, NULL, NULL, NULL, NULL, 4),
(35518, NULL, 'G3DSA:2.10.25.10:FF:001114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35519, NULL, 'G3DSA:1.20.1270.60:FF:000248', NULL, NULL, 'Chromosome 16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(35520, NULL, 'G3DSA:2.130.10.10:FF:004121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35521, NULL, 'G3DSA:2.60.40.10:FF:002131', NULL, NULL, 'Sallimus, isoform P', NULL, NULL, NULL, NULL, NULL, 4),
(35522, NULL, 'G3DSA:3.30.200.20:FF:000251', NULL, NULL, 'Macrophage stimulating 1 receptor', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(35523, NULL, 'G3DSA:3.90.226.10:FF:000024', NULL, NULL, 'Delta3,5-delta2,4-dienoyl-CoA isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(35524, NULL, 'G3DSA:3.30.160.60:FF:003305', NULL, NULL, 'myeloid zinc finger 1', NULL, NULL, NULL, NULL, NULL, 4),
(35525, NULL, 'G3DSA:3.40.50.300:FF:005256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35526, NULL, 'G3DSA:3.40.50.300:FF:007510', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35527, NULL, 'G3DSA:1.10.1370.40:FF:000010', NULL, NULL, 'Oligopeptidase A family protein', NULL, NULL, NULL, NULL, NULL, 4),
(35528, NULL, 'G3DSA:3.30.70.330:FF:003147', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35529, NULL, 'G3DSA:2.20.100.10:FF:000241', NULL, NULL, 'Thrombospondin type 1 domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(35530, NULL, 'G3DSA:3.30.160.60:FF:005559', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35531, NULL, 'G3DSA:3.10.50.40:FF:000055', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(35532, NULL, 'G3DSA:3.40.50.1820:FF:001153', NULL, NULL, 'ENC6 protein', NULL, NULL, NULL, NULL, NULL, 4),
(35533, NULL, 'G3DSA:1.20.970.10:FF:000023', NULL, NULL, 'Anthranilate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(35534, NULL, 'G3DSA:3.90.190.10:FF:000316', NULL, NULL, 'Dual specificity phosphatase 22b', NULL, NULL, NULL, NULL, NULL, 4),
(35535, NULL, 'G3DSA:1.10.600.10:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35536, NULL, 'G3DSA:3.30.413.10:FF:000012', NULL, NULL, '4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase (flavodoxin)', NULL, NULL, NULL, NULL, NULL, 4),
(35537, NULL, 'G3DSA:1.50.10.10:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35538, NULL, 'G3DSA:3.40.50.1000:FF:000070', NULL, NULL, 'HAD hydrolase, family IA', NULL, NULL, NULL, NULL, NULL, 4),
(35539, NULL, 'G3DSA:2.60.40.10:FF:001512', NULL, NULL, 'Premelanosome protein a', NULL, NULL, NULL, NULL, NULL, 4),
(35540, NULL, 'G3DSA:3.30.40.10:FF:001573', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35541, NULL, 'G3DSA:3.30.590.20:FF:000015', NULL, NULL, 'Putative glutamate--cysteine ligase 2', NULL, NULL, NULL, NULL, NULL, 4),
(35542, NULL, 'G3DSA:3.10.200.10:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35543, NULL, 'G3DSA:3.40.190.10:FF:000676', NULL, NULL, 'Uncharacterized solute-binding protein VNG_1595C', NULL, NULL, NULL, NULL, NULL, 4),
(35544, NULL, 'G3DSA:1.10.10.60:FF:001136', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35545, NULL, 'G3DSA:3.30.760.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35546, NULL, 'G3DSA:3.20.20.60:FF:000036', NULL, NULL, 'ATP/GTP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(35547, NULL, 'G3DSA:1.25.10.10:FF:002746', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(35548, NULL, 'G3DSA:1.20.58.2170:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35549, NULL, 'G3DSA:3.40.720.10:FF:000133', NULL, NULL, 'GPI ethanolamine phosphate transferase 2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(35550, NULL, 'G3DSA:2.10.70.10:FF:000004', NULL, NULL, 'Fibronectin 1', NULL, NULL, NULL, NULL, NULL, 4),
(35551, NULL, 'G3DSA:2.20.110.10:FF:000067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35552, NULL, 'G3DSA:3.40.50.1820:FF:000753', NULL, NULL, 'Alpha/beta fold hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(35553, NULL, 'G3DSA:3.30.70.2450:FF:000006', NULL, NULL, 'Monooxygenase, putative (AFU_orthologue AFUA_7G06960)', NULL, NULL, NULL, NULL, NULL, 4),
(35554, NULL, 'G3DSA:2.30.42.10:FF:000629', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35555, NULL, 'G3DSA:3.30.160.60:FF:004929', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35556, NULL, 'G3DSA:3.40.50.10470:FF:000048', NULL, NULL, 'Translation initiation factor EIF-2B subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(35557, NULL, 'G3DSA:3.40.30.10:FF:000504', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(35558, NULL, 'G3DSA:1.25.40.10:FF:004693', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35559, NULL, 'G3DSA:3.30.70.330:FF:002528', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35560, NULL, 'G3DSA:3.30.565.10:FF:000050', NULL, NULL, 'Histidine kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(35561, NULL, 'G3DSA:1.10.630.10:FF:000146', NULL, NULL, 'Os06g0641800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(35562, NULL, 'G3DSA:2.60.11.10:FF:000006', NULL, NULL, 'Cytochrome c oxidase subunit Vb', NULL, NULL, NULL, NULL, NULL, 4),
(35563, NULL, 'G3DSA:1.20.1070.10:FF:000504', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(35564, NULL, 'G3DSA:1.20.120.420:FF:000008', NULL, NULL, 'Methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(35565, NULL, 'G3DSA:1.20.1250.20:FF:000690', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(35566, NULL, 'G3DSA:3.30.160.60:FF:005778', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35567, NULL, 'G3DSA:3.40.50.740:FF:000026', NULL, NULL, 'NADH-quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(35568, NULL, 'G3DSA:1.10.1410.10:FF:000073', NULL, NULL, 'MUTator', NULL, NULL, NULL, NULL, NULL, 4),
(35569, NULL, 'G3DSA:3.40.50.150:FF:000175', NULL, NULL, 'Chemotaxis methyltransferase CheR', NULL, NULL, NULL, NULL, NULL, 4),
(35570, NULL, 'G3DSA:1.10.10.920:FF:000002', NULL, NULL, 'Coproporphyrinogen-III oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(35571, NULL, 'G3DSA:1.10.10.60:FF:000299', NULL, NULL, 'Empty spiracles homeobox 3', NULL, NULL, NULL, NULL, NULL, 4),
(35572, NULL, 'G3DSA:1.10.287.550:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35573, NULL, 'G3DSA:3.40.50.720:FF:000020', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(35574, NULL, 'G3DSA:1.20.1250.10:FF:000136', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35575, NULL, 'G3DSA:3.30.930.10:FF:000230', NULL, NULL, 'eIF-2-alpha kinase GCN2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(35576, NULL, 'G3DSA:2.60.40.10:FF:005565', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35577, NULL, 'G3DSA:2.60.40.10:FF:001170', NULL, NULL, 'Sema domain, immunoglobulin domain (Ig), short basic domain, secreted, (Semaphorin) 3F', NULL, NULL, NULL, NULL, NULL, 4),
(35578, NULL, 'G3DSA:3.30.9.20:FF:000003', NULL, NULL, 'SibG', NULL, NULL, NULL, NULL, NULL, 4),
(35579, NULL, 'G3DSA:1.20.58.70:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35580, NULL, 'G3DSA:1.25.40.20:FF:000986', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35581, NULL, 'G3DSA:1.20.1610.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35582, NULL, 'G3DSA:1.10.10.10:FF:000531', NULL, NULL, 'Heat shock transcription factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(35583, NULL, 'G3DSA:3.40.50.410:FF:000163', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(35584, NULL, 'G3DSA:2.40.30.10:FF:000107', NULL, NULL, 'Related to translation elongation factor HBS1', NULL, NULL, NULL, NULL, NULL, 4),
(35585, NULL, 'G3DSA:1.10.510.10:FF:003285', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35586, NULL, 'G3DSA:2.60.40.10:FF:000894', NULL, NULL, 'cell adhesion molecule 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(35587, NULL, 'G3DSA:3.40.630.30:FF:000576', NULL, NULL, 'Im:6904045', NULL, NULL, NULL, NULL, NULL, 4),
(35588, NULL, 'G3DSA:3.30.70.920:FF:000013', NULL, NULL, 'AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(35589, NULL, 'G3DSA:3.30.70.940:FF:000019', NULL, NULL, 'Transcription termination/antitermination protein NusG', NULL, NULL, NULL, NULL, NULL, 4),
(35590, NULL, 'G3DSA:3.30.450.20:FF:000426', NULL, NULL, 'Two-component system sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(35591, NULL, 'G3DSA:1.10.10.650:FF:000011', NULL, NULL, 'Transcription elongation factor SPT6', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(35592, NULL, 'G3DSA:3.40.50.2300:FF:000122', NULL, NULL, 'Extracellular calcium-sensing receptor', NULL, NULL, NULL, NULL, NULL, 4),
(35593, NULL, 'G3DSA:3.30.1330.20:FF:000029', NULL, NULL, 'Tubulin gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(35594, NULL, 'G3DSA:1.25.10.10:FF:003229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35595, NULL, 'G3DSA:1.20.120.1900:FF:000015', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(35596, NULL, 'G3DSA:3.90.230.10:FF:000023', NULL, NULL, 'Methionine aminopeptidase 1c, putative', NULL, NULL, NULL, NULL, NULL, 4),
(35597, NULL, 'G3DSA:3.40.1380.10:FF:000027', NULL, NULL, 'ATP synthase gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(35598, NULL, 'G3DSA:3.90.79.10:FF:000142', NULL, NULL, 'Phosphohydrolase (MUTT/NUDIX family protein)', NULL, NULL, NULL, NULL, NULL, 4),
(35599, NULL, 'G3DSA:3.40.1410.10:FF:000025', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(35600, NULL, 'G3DSA:1.10.1520.10:FF:000064', NULL, NULL, '39S ribosomal protein L44, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(35601, NULL, 'G3DSA:3.30.160.60:FF:006054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35602, NULL, 'G3DSA:3.40.50.10930:FF:000006', NULL, NULL, 'Exodeoxyribonuclease V, gamma subunit', NULL, NULL, NULL, NULL, NULL, 4),
(35603, NULL, 'G3DSA:3.10.20.90:FF:000545', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(35604, NULL, 'G3DSA:3.80.10.10:FF:000597', NULL, NULL, 'F-box/LRR-repeat protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(35605, NULL, 'G3DSA:3.80.10.10:FF:002283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35606, NULL, 'G3DSA:3.30.70.1230:FF:000091', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(35607, NULL, 'G3DSA:2.30.180.10:FF:000075', NULL, NULL, 'Stabilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(35608, NULL, 'G3DSA:1.10.510.10:FF:002127', NULL, NULL, 'Probable serine/threonine-protein kinase pats1', NULL, NULL, NULL, NULL, NULL, 4),
(35609, NULL, 'G3DSA:3.40.50.1460:FF:000061', NULL, NULL, 'Caspase 8b', NULL, NULL, NULL, NULL, NULL, 4),
(35610, NULL, 'G3DSA:1.10.3860.10:FF:000022', NULL, NULL, 'Proton/sodium glutamate symporter', NULL, NULL, NULL, NULL, NULL, 4),
(35611, NULL, 'G3DSA:2.40.70.10:FF:000548', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35612, NULL, 'G3DSA:1.20.1070.10:FF:001443', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35613, NULL, 'G3DSA:1.25.40.10:FF:001950', NULL, NULL, 'Pentatricopeptide repeat domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(35614, NULL, 'G3DSA:1.25.40.1030:FF:000034', NULL, NULL, 'Protein transport protein SEC31', NULL, NULL, NULL, NULL, NULL, 4),
(35615, NULL, 'G3DSA:1.10.510.10:FF:004252', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35616, NULL, 'G3DSA:2.70.150.10:FF:000053', NULL, NULL, 'Silver exporting P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(35617, NULL, 'G3DSA:3.30.160.60:FF:003749', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35618, NULL, 'G3DSA:3.50.50.60:FF:001352', NULL, NULL, 'AER292Cp', NULL, NULL, NULL, NULL, NULL, 4),
(35619, NULL, 'G3DSA:1.20.1250.20:FF:002163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35620, NULL, 'G3DSA:3.30.530.20:FF:000028', NULL, NULL, 'Phosphatidylinositol transfer protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(35621, NULL, 'G3DSA:2.30.30.140:FF:000337', NULL, NULL, 'RE66405p', NULL, NULL, NULL, NULL, NULL, 4),
(35622, NULL, 'G3DSA:2.10.25.10:FF:001794', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35623, NULL, 'G3DSA:1.25.40.180:FF:000085', NULL, NULL, 'Eukaryotic translation initiation factor 4G2, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(35624, NULL, 'G3DSA:1.25.40.10:FF:005210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35625, NULL, 'G3DSA:1.20.120.550:FF:000013', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(35626, NULL, 'G3DSA:1.20.1610.10:FF:000001', NULL, NULL, 'Putative alpha-1,2-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(35627, NULL, 'G3DSA:3.30.160.60:FF:000995', NULL, NULL, 'zinc finger protein 668', NULL, NULL, NULL, NULL, NULL, 4),
(35628, NULL, 'G3DSA:1.25.40.10:FF:003063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35629, NULL, 'G3DSA:3.50.50.60:FF:000840', NULL, NULL, 'Putative flavoprotein monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(35630, NULL, 'G3DSA:3.30.710.10:FF:000236', NULL, NULL, 'Transcription regulator protein BACH2', NULL, NULL, NULL, NULL, NULL, 4),
(35631, NULL, 'G3DSA:3.40.50.2300:FF:001538', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35632, NULL, 'G3DSA:1.25.40.20:FF:000323', NULL, NULL, 'Ankyrin repeat domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(35633, NULL, 'G3DSA:3.30.479.20:FF:000054', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(35634, NULL, 'G3DSA:1.50.10.10:FF:000193', NULL, NULL, 'Gll2460 protein', NULL, NULL, NULL, NULL, NULL, 4),
(35635, NULL, 'G3DSA:3.80.10.10:FF:003244', NULL, NULL, 'F-box/LRR-repeat protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(35636, NULL, 'G3DSA:1.20.120.230:FF:000030', NULL, NULL, 'TaLiN', NULL, NULL, NULL, NULL, NULL, 4),
(35637, NULL, 'G3DSA:3.40.50.460:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35638, NULL, 'G3DSA:1.10.8.710:FF:000014', NULL, NULL, 'Si:dkey-11m19.5', NULL, NULL, NULL, NULL, NULL, 4),
(35639, NULL, 'G3DSA:1.20.1270.10:FF:000031', NULL, NULL, 'Cytosolic heat shock protein 70', NULL, NULL, NULL, NULL, NULL, 4),
(35640, NULL, 'G3DSA:4.10.1120.10:FF:000003', NULL, NULL, 'Phosphodiesterase 6G', NULL, NULL, NULL, NULL, NULL, 4),
(35641, NULL, 'G3DSA:1.20.1250.20:FF:001218', NULL, NULL, 'Alpha-ketoglutarate permease (KgtP)', NULL, NULL, NULL, NULL, NULL, 4),
(35642, NULL, 'G3DSA:3.40.50.300:FF:003564', NULL, NULL, 'Branched-chain amino acid ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(35643, NULL, 'G3DSA:3.40.50.10190:FF:000184', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(35644, NULL, 'G3DSA:2.130.10.10:FF:003272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35645, NULL, 'G3DSA:3.40.50.150:FF:000624', NULL, NULL, 'Protein-lysine N-methyltransferase EFM4', NULL, NULL, NULL, NULL, NULL, 4),
(35646, NULL, 'G3DSA:3.80.10.10:FF:003351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35647, NULL, 'G3DSA:3.40.50.300:FF:004183', NULL, NULL, 'Spastin', NULL, NULL, NULL, NULL, NULL, 4),
(35648, NULL, 'G3DSA:1.10.287.70:FF:000708', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35649, NULL, 'G3DSA:3.40.50.150:FF:001136', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35650, NULL, 'G3DSA:3.40.190.10:FF:000777', NULL, NULL, 'Extracellular solute-binding protein family 5', NULL, NULL, NULL, NULL, NULL, 4),
(35651, NULL, 'G3DSA:3.65.10.10:FF:000020', NULL, NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(35652, NULL, 'G3DSA:2.60.15.10:FF:000015', NULL, NULL, 'ATP synthase epsilon chain', NULL, NULL, NULL, NULL, NULL, 4),
(35653, NULL, 'G3DSA:3.40.50.300:FF:003671', NULL, NULL, 'Uncharacterized GTP-binding protein VNG_1111G', NULL, NULL, NULL, NULL, NULL, 4),
(35654, NULL, 'G3DSA:3.30.160.60:FF:004362', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35655, NULL, 'G3DSA:1.25.40.20:FF:000430', NULL, NULL, 'ankyrin repeat and KH domain-containing protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(35656, NULL, 'G3DSA:2.20.100.10:FF:000140', NULL, NULL, 'Zinc metalloproteinase', NULL, NULL, NULL, NULL, NULL, 4),
(35657, NULL, 'G3DSA:3.80.10.10:FF:002732', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(35658, NULL, 'G3DSA:1.10.150.50:FF:000104', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(35659, NULL, 'G3DSA:1.10.10.250:FF:000003', NULL, NULL, 'Mitochondrial ribosomal protein L11', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(35660, NULL, 'G3DSA:3.80.10.10:FF:001215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35661, NULL, 'G3DSA:3.40.50.10190:FF:000077', NULL, NULL, 'Chitin biosynthesis protein CHS5', NULL, NULL, NULL, NULL, NULL, 4),
(35662, NULL, 'G3DSA:1.10.238.20:FF:000058', NULL, NULL, 'AGAP006278-PA', NULL, NULL, NULL, NULL, NULL, 4),
(35663, NULL, 'G3DSA:3.40.140.10:FF:000162', NULL, NULL, 'Apolipoprotein B mRNA editing enzyme catalytic subunit 3B', NULL, NULL, NULL, NULL, NULL, 4),
(35664, NULL, 'G3DSA:2.60.40.150:FF:000127', NULL, NULL, 'copine-9 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(35665, NULL, 'G3DSA:3.90.550.10:FF:000070', NULL, NULL, 'Hyaluronan synthase 3', NULL, NULL, NULL, NULL, NULL, 4),
(35666, NULL, 'G3DSA:3.20.20.80:FF:000593', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35667, NULL, 'G3DSA:1.10.10.10:FF:000649', NULL, NULL, 'Cyclic nucleotide-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(35668, NULL, 'G3DSA:2.60.120.10:FF:000514', NULL, NULL, 'HlyB family protein', NULL, NULL, NULL, NULL, NULL, 4),
(35669, NULL, 'G3DSA:1.25.10.10:FF:003128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35670, NULL, 'G3DSA:1.10.510.10:FF:004145', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35671, NULL, 'G3DSA:1.20.1250.20:FF:000706', NULL, NULL, 'Transporter, major facilitator family protein', NULL, NULL, NULL, NULL, NULL, 4),
(35672, NULL, 'G3DSA:1.20.1070.10:FF:001336', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35673, NULL, 'G3DSA:3.30.160.60:FF:000091', NULL, NULL, 'Putative Krueppel-like factor 12', NULL, NULL, NULL, NULL, NULL, 4),
(35674, NULL, 'G3DSA:2.40.50.140:FF:000159', NULL, NULL, 'rRNA biogenesis protein rrp5', NULL, NULL, NULL, NULL, NULL, 4),
(35675, NULL, 'G3DSA:3.40.50.300:FF:005599', NULL, NULL, 'Dynein axonemal heavy chain 14', NULL, NULL, NULL, NULL, NULL, 4),
(35676, NULL, 'G3DSA:2.40.160.50:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35677, NULL, 'G3DSA:3.80.10.10:FF:003929', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35678, NULL, 'G3DSA:1.10.287.3510:FF:000011', NULL, NULL, 'NADH-ubiquinone oxidoreductase chain 4L', NULL, NULL, NULL, NULL, NULL, 4),
(35679, NULL, 'G3DSA:3.30.1370.210:FF:000023', NULL, NULL, 'Poly (ADP-ribose) polymerase family, member 12', NULL, NULL, NULL, NULL, NULL, 4),
(35680, NULL, 'G3DSA:1.10.533.10:FF:000022', NULL, NULL, 'B-cell lymphoma/leukemia 10', NULL, NULL, NULL, NULL, NULL, 4),
(35681, NULL, 'G3DSA:1.25.40.10:FF:001843', NULL, NULL, 'AfsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(35682, NULL, 'G3DSA:1.20.120.1960:FF:000005', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(35683, NULL, 'G3DSA:3.30.1120.10:FF:000005', NULL, NULL, 'Arylsulfatase A', NULL, NULL, NULL, NULL, NULL, 4),
(35684, NULL, 'G3DSA:2.60.120.920:FF:000036', NULL, NULL, 'Tripartite motif-containing protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(35685, NULL, 'G3DSA:1.20.1740.10:FF:000247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35686, NULL, 'G3DSA:3.40.50.1000:FF:000631', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35687, NULL, 'G3DSA:3.30.559.30:FF:000007', NULL, NULL, 'Trehalose-2-sulfate acyltransferase papA2', NULL, NULL, NULL, NULL, NULL, 4),
(35688, NULL, 'G3DSA:1.20.1730.10:FF:000055', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(35689, NULL, 'G3DSA:3.90.870.10:FF:000009', NULL, NULL, 'Threonylcarbamoyl-AMP synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(35690, NULL, 'G3DSA:2.60.40.10:FF:003412', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35691, NULL, 'G3DSA:3.30.70.330:FF:000499', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(35692, NULL, 'G3DSA:3.30.70.330:FF:001123', NULL, NULL, 'tRNA selenocysteine 1-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(35693, NULL, 'G3DSA:3.10.20.620:FF:000002', NULL, NULL, 'Autophagy protein 5', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(35694, NULL, 'G3DSA:2.60.40.10:FF:003305', NULL, NULL, 'NCAM (Neural cell adhesion molecule) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(35695, NULL, 'G3DSA:2.30.30.570:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35696, NULL, 'G3DSA:3.30.497.10:FF:000121', NULL, NULL, 'Male accessory gland protein', NULL, NULL, NULL, NULL, NULL, 4),
(35697, NULL, 'G3DSA:4.10.280.10:FF:000141', NULL, NULL, 'Basic helix-loop-helix (BHLH) DNA-binding superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(35698, NULL, 'G3DSA:2.40.110.10:FF:000080', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(35699, NULL, 'G3DSA:2.60.120.920:FF:000143', NULL, NULL, 'Protein CBR-SPSB-2', NULL, NULL, NULL, NULL, NULL, 4),
(35700, NULL, 'G3DSA:1.10.238.20:FF:000052', NULL, NULL, 'AGAP002190-PA', NULL, NULL, NULL, NULL, NULL, 4),
(35701, NULL, 'G3DSA:3.40.50.10470:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35702, NULL, 'G3DSA:3.10.310.40:FF:000005', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(35703, NULL, 'G3DSA:1.20.990.10:FF:000036', NULL, NULL, 'NADPH-cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(35704, NULL, 'G3DSA:3.30.750.44:FF:000005', NULL, NULL, 'Retinol-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(35705, NULL, 'G3DSA:1.10.10.10:FF:001594', NULL, NULL, 'O-methyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(35706, NULL, 'G3DSA:1.10.287.40:FF:000020', NULL, NULL, 'Serine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(35707, NULL, 'G3DSA:3.40.630.10:FF:000132', NULL, NULL, 'Carboxypeptidase A1', NULL, NULL, NULL, NULL, NULL, 4),
(35708, NULL, 'G3DSA:1.25.10.10:FF:000711', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(35709, NULL, 'G3DSA:3.10.20.90:FF:000101', NULL, NULL, 'FAS-associated factor 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(35710, NULL, 'G3DSA:1.25.40.90:FF:000068', NULL, NULL, 'At4g31200', NULL, NULL, NULL, NULL, NULL, 4),
(35711, NULL, 'G3DSA:2.130.10.10:FF:003957', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35712, NULL, 'G3DSA:2.60.120.330:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35713, NULL, 'G3DSA:2.60.40.10:FF:005666', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35714, NULL, 'G3DSA:3.40.630.30:FF:000132', NULL, NULL, 'N-acetyltransferase 9-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(35715, NULL, 'G3DSA:1.25.40.70:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35716, NULL, 'G3DSA:3.60.40.10:FF:000268', NULL, NULL, 'Protein phosphatase type 2c', NULL, NULL, NULL, NULL, NULL, 4),
(35717, NULL, 'G3DSA:3.30.70.360:FF:000042', NULL, NULL, 'N-acyl-L-amino acid amidohydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(35718, NULL, 'G3DSA:2.10.25.10:FF:001120', NULL, NULL, 'Laminin alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(35719, NULL, 'G3DSA:3.40.50.300:FF:004868', NULL, NULL, 'RecBCD enzyme subunit RecC', NULL, NULL, NULL, NULL, NULL, 4),
(35720, NULL, 'G3DSA:2.60.40.150:FF:000234', NULL, NULL, 'Translocation protein sec63', NULL, NULL, NULL, NULL, NULL, 4),
(35721, NULL, 'G3DSA:3.40.630.30:FF:000138', NULL, NULL, 'N-acetyltransferase subunit ARD1', NULL, NULL, NULL, NULL, NULL, 4),
(35722, NULL, 'G3DSA:2.40.50.140:FF:000945', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35723, NULL, 'G3DSA:1.20.5.100:FF:000020', NULL, NULL, 'Cytochrome b', NULL, NULL, NULL, NULL, NULL, 4),
(35724, NULL, 'G3DSA:3.80.10.10:FF:004548', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35725, NULL, 'G3DSA:3.90.105.10:FF:000007', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(35726, NULL, 'G3DSA:2.130.10.10:FF:000310', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(35727, NULL, 'G3DSA:3.10.20.90:FF:000107', NULL, NULL, 'protein DDI1 homolog 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(35728, NULL, 'G3DSA:2.30.30.40:FF:000639', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(35729, NULL, 'G3DSA:3.40.50.1820:FF:001265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35730, NULL, 'G3DSA:3.30.160.60:FF:003064', NULL, NULL, 'Zinc finger putative Transcription Factor family', NULL, NULL, NULL, NULL, NULL, 4),
(35731, NULL, 'G3DSA:3.30.160.60:FF:002445', NULL, NULL, 'IKAROS family zinc finger 1', NULL, NULL, NULL, NULL, NULL, 4),
(35732, NULL, 'G3DSA:3.30.60.20:FF:000060', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(35733, NULL, 'G3DSA:3.30.1390.20:FF:000033', NULL, NULL, '50S ribosomal protein L30', NULL, NULL, NULL, NULL, NULL, 4),
(35734, NULL, 'G3DSA:3.40.50.150:FF:001243', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35735, NULL, 'G3DSA:1.10.287.660:FF:000020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(35736, NULL, 'G3DSA:2.30.30.490:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35737, NULL, 'G3DSA:1.10.20.10:FF:000352', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35738, NULL, 'G3DSA:2.40.50.120:FF:000046', NULL, NULL, 'Complement component 4A (Rodgers blood group)', NULL, NULL, NULL, NULL, NULL, 4),
(35739, NULL, 'G3DSA:1.25.40.550:FF:000011', NULL, NULL, 'Protein AAR2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(35740, NULL, 'G3DSA:3.10.20.90:FF:000096', NULL, NULL, 'Ubiquitin thioesterase OTU1', NULL, NULL, NULL, NULL, NULL, 4),
(35741, NULL, 'G3DSA:1.10.510.10:FF:000885', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35742, NULL, 'G3DSA:3.40.630.30:FF:000020', NULL, NULL, 'Alpha-tubulin N-acetyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(35743, NULL, 'G3DSA:3.40.50.300:FF:002266', NULL, NULL, '26S protease regulatory subunit 6B', NULL, NULL, NULL, NULL, NULL, 4),
(35744, NULL, 'G3DSA:2.60.120.560:FF:000006', NULL, NULL, 'LCCL domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(35745, NULL, 'G3DSA:3.30.530.20:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35746, NULL, 'G3DSA:2.130.10.10:FF:004469', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35747, NULL, 'G3DSA:3.30.40.10:FF:002197', NULL, NULL, 'E3 ubiquitin-protein ligase UHRF2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(35748, NULL, 'G3DSA:1.20.5.440:FF:000009', NULL, NULL, '3-mercaptopropionate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(35749, NULL, 'G3DSA:3.40.50.2000:FF:000717', NULL, NULL, 'Zeaxanthin glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(35750, NULL, 'G3DSA:1.25.40.180:FF:000192', NULL, NULL, 'Pre-mRNA-splicing factor CWC22', NULL, NULL, NULL, NULL, NULL, 4),
(35751, NULL, 'G3DSA:3.40.50.300:FF:004290', NULL, NULL, 'ABC transporter G family member 24', NULL, NULL, NULL, NULL, NULL, 4),
(35752, NULL, 'G3DSA:1.20.1080.10:FF:000089', NULL, NULL, 'Aquaporin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(35753, NULL, 'G3DSA:3.40.1110.10:FF:000446', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35754, NULL, 'G3DSA:1.20.1070.10:FF:000824', NULL, NULL, 'G-protein coupled receptor', NULL, NULL, NULL, NULL, NULL, 4),
(35755, NULL, 'G3DSA:3.80.10.10:FF:000366', NULL, NULL, 'leucine-rich repeat-containing protein 23', NULL, NULL, NULL, NULL, NULL, 4),
(35756, NULL, 'G3DSA:2.30.29.30:FF:000661', NULL, NULL, 'PH domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(35757, NULL, 'G3DSA:3.30.70.330:FF:001808', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35758, NULL, 'G3DSA:1.25.40.10:FF:003855', NULL, NULL, 'Tetratricopeptide repeat domain 37', NULL, NULL, NULL, NULL, NULL, 4),
(35759, NULL, 'G3DSA:3.40.50.300:FF:005487', NULL, NULL, 'TFIIH basal transcription factor complex helicase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(35760, NULL, 'G3DSA:3.10.330.20:FF:000012', NULL, NULL, 'tRNA (adenine(58)-N(1))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(35761, NULL, 'G3DSA:2.40.50.90:FF:000183', NULL, NULL, 'Tudor domain-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(35762, NULL, 'G3DSA:2.60.40.1170:FF:000043', NULL, NULL, 'FCH domain only protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(35763, NULL, 'G3DSA:1.20.1560.10:FF:000587', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(35764, NULL, 'G3DSA:1.10.275.10:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35765, NULL, 'G3DSA:3.40.470.10:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35766, NULL, 'G3DSA:3.30.70.330:FF:002972', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35767, NULL, 'G3DSA:1.20.58.60:FF:000661', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35768, NULL, 'G3DSA:1.20.58.390:FF:000174', NULL, NULL, 'Nicotinic acetylcholine receptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(35769, NULL, 'G3DSA:6.20.240.60:FF:000003', NULL, NULL, 'Ion channel', NULL, NULL, NULL, NULL, NULL, 4),
(35770, NULL, 'G3DSA:2.30.42.10:FF:000528', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35771, NULL, 'G3DSA:3.40.720.10:FF:000240', NULL, NULL, 'Arylsulfatase H', NULL, NULL, NULL, NULL, NULL, 4),
(35772, NULL, 'G3DSA:1.20.930.10:FF:000021', NULL, NULL, 'IWS1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(35773, NULL, 'G3DSA:2.30.29.30:FF:001403', NULL, NULL, 'LD45876p', NULL, NULL, NULL, NULL, NULL, 4),
(35774, NULL, 'G3DSA:1.25.40.20:FF:001716', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35775, NULL, 'G3DSA:1.20.1070.10:FF:001224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35776, NULL, 'G3DSA:3.30.40.10:FF:002208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35777, NULL, 'G3DSA:2.60.40.420:FF:000219', NULL, NULL, 'Ac2-120', NULL, NULL, NULL, NULL, NULL, 4),
(35778, NULL, 'G3DSA:1.20.990.10:FF:000013', NULL, NULL, 'NADPH-dependent diflavin oxidoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(35779, NULL, 'G3DSA:2.60.120.620:FF:000053', NULL, NULL, 'Oxidoreductase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(35780, NULL, 'G3DSA:2.60.40.10:FF:003524', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35781, NULL, 'G3DSA:3.40.50.10490:FF:000161', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35782, NULL, 'G3DSA:3.40.50.300:FF:007853', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35783, NULL, 'G3DSA:3.30.760.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35784, NULL, 'G3DSA:2.40.160.210:FF:000021', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(35785, NULL, 'G3DSA:1.10.340.70:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35786, NULL, 'G3DSA:3.30.160.60:FF:000214', NULL, NULL, 'replication initiator 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(35787, NULL, 'G3DSA:1.10.287.130:FF:000092', NULL, NULL, 'Response regulator receiver domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(35788, NULL, 'G3DSA:4.10.1060.10:FF:000060', NULL, NULL, 'Calcium-dependent cysteine protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(35789, NULL, 'G3DSA:3.30.420.10:FF:000591', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35790, NULL, 'G3DSA:3.40.50.300:FF:007049', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(35791, NULL, 'G3DSA:1.10.10.2660:FF:000013', NULL, NULL, 'SUMO-activating enzyme subunit', NULL, NULL, NULL, NULL, NULL, 4),
(35792, NULL, 'G3DSA:3.90.190.10:FF:000075', NULL, NULL, 'Phosphoglucan phosphatase LSF2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(35793, NULL, 'G3DSA:3.30.342.10:FF:000049', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(35794, NULL, 'G3DSA:2.30.30.490:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35795, NULL, 'G3DSA:2.60.120.260:FF:000130', NULL, NULL, 'Discoidin domain-containing receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(35796, NULL, 'G3DSA:1.10.510.10:FF:003740', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35797, NULL, 'G3DSA:3.30.70.890:FF:000077', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(35798, NULL, 'G3DSA:1.10.1300.10:FF:000087', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(35799, NULL, 'G3DSA:3.30.1330.30:FF:000021', NULL, NULL, 'rRNA methyltransferase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(35800, NULL, 'G3DSA:3.10.105.10:FF:000059', NULL, NULL, 'Substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(35801, NULL, 'G3DSA:3.40.50.300:FF:006318', NULL, NULL, 'RecBCD enzyme subunit RecC', NULL, NULL, NULL, NULL, NULL, 4),
(35802, NULL, 'G3DSA:3.40.50.720:FF:000599', NULL, NULL, 'Uncharacterized oxidoreductase C663.06c', NULL, NULL, NULL, NULL, NULL, 4),
(35803, NULL, 'G3DSA:3.30.2070.10:FF:000006', NULL, NULL, 'Molybdopterin-binding iron-sulfur cluster-binding oxidoreductase MopB-3', NULL, NULL, NULL, NULL, NULL, 4),
(35804, NULL, 'G3DSA:3.30.460.20:FF:000034', NULL, NULL, 'Magnesium transport protein CorA', NULL, NULL, NULL, NULL, NULL, 4),
(35805, NULL, 'G3DSA:2.130.10.10:FF:001248', NULL, NULL, 'WD repeat domain 78', NULL, NULL, NULL, NULL, NULL, 4),
(35806, NULL, 'G3DSA:1.10.10.10:FF:000290', NULL, NULL, 'General transcription factor IIF subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(35807, NULL, 'G3DSA:3.40.390.10:FF:000096', NULL, NULL, 'Os10g0558125 protein', NULL, NULL, NULL, NULL, NULL, 4),
(35808, NULL, 'G3DSA:3.30.930.10:FF:000331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35809, NULL, 'G3DSA:3.40.50.720:FF:001223', NULL, NULL, 'SUMO activating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(35810, NULL, 'G3DSA:3.40.50.1820:FF:000197', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(35811, NULL, 'G3DSA:1.25.40.10:FF:001039', NULL, NULL, 'Anaphase-promoting complex subunit CDC23', NULL, NULL, NULL, NULL, NULL, 4),
(35812, NULL, 'G3DSA:2.30.29.240:FF:000022', NULL, NULL, 'Phospholipase C beta-4', NULL, NULL, NULL, NULL, NULL, 4),
(35813, NULL, 'G3DSA:2.130.10.10:FF:005537', NULL, NULL, 'WD repeat-containing protein PCN', NULL, NULL, NULL, NULL, NULL, 4),
(35814, NULL, 'G3DSA:3.30.70.330:FF:002427', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35815, NULL, 'G3DSA:3.20.20.100:FF:000018', NULL, NULL, 'Glycerol dehydrogenase Gcy1', NULL, NULL, NULL, NULL, NULL, 4),
(35816, NULL, 'G3DSA:2.70.130.10:FF:000170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35817, NULL, 'G3DSA:2.40.30.330:FF:000010', NULL, NULL, 'mRNA cleavage and polyadenylation factor CLP1', NULL, NULL, NULL, NULL, NULL, 4),
(35818, NULL, 'G3DSA:1.20.58.100:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35819, NULL, 'G3DSA:3.90.1440.10:FF:000010', NULL, NULL, 'Preprotein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(35820, NULL, 'G3DSA:3.10.350.10:FF:000027', NULL, NULL, 'LysM peptidoglycan-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(35821, NULL, 'G3DSA:3.30.1240.10:FF:000036', NULL, NULL, 'Cof-type HAD-IIB family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(35822, NULL, 'G3DSA:3.40.50.300:FF:001647', NULL, NULL, 'Extra-large guanine nucleotide-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(35823, NULL, 'G3DSA:3.40.50.300:FF:005936', NULL, NULL, 'Putative pre-mRNA-splicing factor ATP-dependent RNA helicase PRP1', NULL, NULL, NULL, NULL, NULL, 4),
(35824, NULL, 'G3DSA:1.10.510.10:FF:000093', NULL, NULL, 'Hepatocyte growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(35825, NULL, 'G3DSA:3.30.160.60:FF:001484', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(35826, NULL, 'G3DSA:3.30.710.10:FF:000348', NULL, NULL, 'BTB (POZ) domain-containing 3a', NULL, NULL, NULL, NULL, NULL, 4),
(35827, NULL, 'G3DSA:2.60.40.10:FF:004362', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35828, NULL, 'G3DSA:3.50.50.60:FF:000952', NULL, NULL, 'Slr0734 protein', NULL, NULL, NULL, NULL, NULL, 4),
(35829, NULL, 'G3DSA:4.10.970.10:FF:000008', NULL, NULL, 'Putative KU70 protein', NULL, NULL, NULL, NULL, NULL, 4),
(35830, NULL, 'G3DSA:2.60.120.920:FF:000148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(35831, NULL, 'G3DSA:3.100.10.10:FF:000015', NULL, NULL, '60S ribosomal protein L27A/L29', NULL, NULL, NULL, NULL, NULL, 4),
(35832, NULL, 'G3DSA:3.30.1160.10:FF:000002', NULL, NULL, 'Cyanate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(35833, NULL, 'G3DSA:1.25.40.10:FF:002332', NULL, NULL, 'general transcription factor 3C polypeptide 3', NULL, NULL, NULL, NULL, NULL, 4),
(35834, NULL, 'G3DSA:3.30.450.20:FF:000185', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(35835, NULL, 'G3DSA:3.40.50.1010:FF:000174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35836, NULL, 'G3DSA:3.30.450.20:FF:000527', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(35837, NULL, 'G3DSA:3.30.70.330:FF:002079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35838, NULL, 'G3DSA:3.30.160.20:FF:000090', NULL, NULL, 'ATP-dependent RNA helicase A isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(35839, NULL, 'G3DSA:2.10.25.10:FF:000389', NULL, NULL, 'slit homolog 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(35840, NULL, 'G3DSA:1.20.1560.10:FF:000238', NULL, NULL, 'Multidrug resistance-associated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(35841, NULL, 'G3DSA:2.60.120.200:FF:000258', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(35842, NULL, 'G3DSA:3.40.710.10:FF:000071', NULL, NULL, 'Probable D-alanyl-D-alanine carboxypeptidase dacB2', NULL, NULL, NULL, NULL, NULL, 4),
(35843, NULL, 'G3DSA:2.130.10.10:FF:002541', NULL, NULL, 'Sensor histidine kinase TodS', NULL, NULL, NULL, NULL, NULL, 4),
(35844, NULL, 'G3DSA:1.25.50.20:FF:000037', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(35845, NULL, 'G3DSA:3.30.200.20:FF:001667', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(35846, NULL, 'G3DSA:1.10.8.60:FF:000551', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35847, NULL, 'G3DSA:2.10.25.10:FF:001013', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(35848, NULL, 'G3DSA:3.40.50.620:FF:000687', NULL, NULL, 'tRNA(Ile)-lysidine synthase MesJ', NULL, NULL, NULL, NULL, NULL, 4),
(35849, NULL, 'G3DSA:2.60.40.1090:FF:000013', NULL, NULL, 'FimI fimbrial protein', NULL, NULL, NULL, NULL, NULL, 4),
(35850, NULL, 'G3DSA:3.90.780.10:FF:000002', NULL, NULL, 'Bifunctional 2'',3''-cyclic-nucleotide 2''-phosphodiesterase/3''-nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(35851, NULL, 'G3DSA:3.80.10.10:FF:002620', NULL, NULL, 'Phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(35852, NULL, 'G3DSA:2.40.270.10:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35853, NULL, 'G3DSA:1.10.3860.10:FF:000028', NULL, NULL, 'Neutral Amino Acid (Glutamate) Transporter', NULL, NULL, NULL, NULL, NULL, 4),
(35854, NULL, 'G3DSA:3.60.40.10:FF:000375', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35855, NULL, 'G3DSA:3.80.10.10:FF:003132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35856, NULL, 'G3DSA:1.25.40.20:FF:000300', NULL, NULL, 'S-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(35857, NULL, 'G3DSA:1.20.58.1040:FF:000002', NULL, NULL, 'Glucan endo-1,3-beta-glucosidase 8', NULL, NULL, NULL, NULL, NULL, 4),
(35858, NULL, 'G3DSA:1.20.120.1240:FF:000008', NULL, NULL, 'dynamin-3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(35859, NULL, 'G3DSA:3.90.1150.10:FF:000139', NULL, NULL, 'Glycine cleavage system P protein', NULL, NULL, NULL, NULL, NULL, 4),
(35860, NULL, 'G3DSA:3.40.50.720:FF:000947', NULL, NULL, 'C-terminal binding protein AN', NULL, NULL, NULL, NULL, NULL, 4),
(35861, NULL, 'G3DSA:3.80.10.10:FF:001327', NULL, NULL, 'Os08g0459100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(35862, NULL, 'G3DSA:1.10.10.350:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35863, NULL, 'G3DSA:4.10.70.10:FF:000005', NULL, NULL, 'Zinc metalloproteinase/disintegrin', NULL, NULL, NULL, NULL, NULL, 4),
(35864, NULL, 'G3DSA:3.30.420.10:FF:000596', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(35865, NULL, 'G3DSA:3.40.50.10380:FF:000027', NULL, NULL, 'NAD-dependent malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(35866, NULL, 'G3DSA:3.40.1690.10:FF:000011', NULL, NULL, 'Flagellar biosynthetic protein FlhB', NULL, NULL, NULL, NULL, NULL, 4),
(35867, NULL, 'G3DSA:1.25.10.10:FF:002504', NULL, NULL, 'USO1 vesicle transport factor', NULL, NULL, NULL, NULL, NULL, 4),
(35868, NULL, 'G3DSA:1.20.120.20:FF:000007', NULL, NULL, 'Apolipoprotein A-IV a', NULL, NULL, NULL, NULL, NULL, 4),
(35869, NULL, 'G3DSA:3.20.20.140:FF:000120', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(35870, NULL, 'G3DSA:3.10.20.600:FF:000007', NULL, NULL, 'NAD-reducing hydrogenase subunit HoxF', NULL, NULL, NULL, NULL, NULL, 4),
(35871, NULL, 'G3DSA:1.20.58.1060:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35872, NULL, 'G3DSA:1.10.238.10:FF:000515', NULL, NULL, 'ITSN (Intersectin) family', NULL, NULL, NULL, NULL, NULL, 4),
(35873, NULL, 'G3DSA:2.130.10.10:FF:004918', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(35874, NULL, 'G3DSA:3.40.50.1360:FF:000025', NULL, NULL, '6-phosphogluconolactonase', NULL, NULL, NULL, NULL, NULL, 4),
(35875, NULL, 'G3DSA:3.90.1170.10:FF:000011', NULL, NULL, 'Mitochondrial ribosomal protein L16, putative', NULL, NULL, NULL, NULL, NULL, 4),
(35876, NULL, 'G3DSA:3.40.50.300:FF:005251', NULL, NULL, 'YALI0C14168p', NULL, NULL, NULL, NULL, NULL, 4),
(35877, NULL, 'G3DSA:1.10.287.110:FF:000226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35878, NULL, 'G3DSA:3.40.50.460:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35879, NULL, 'G3DSA:3.40.50.720:FF:000604', NULL, NULL, 'Oxidoreductase, short-chain dehydrogenase family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(35880, NULL, 'G3DSA:3.30.160.60:FF:005666', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35881, NULL, 'G3DSA:1.10.510.10:FF:003521', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35882, NULL, 'G3DSA:1.10.287.470:FF:000076', NULL, NULL, 'Acriflavin resistance periplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(35883, NULL, 'G3DSA:2.40.20.10:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35884, NULL, 'G3DSA:1.20.1720.10:FF:000122', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35885, NULL, 'G3DSA:3.30.200.20:FF:001324', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(35886, NULL, 'G3DSA:3.30.450.60:FF:000062', NULL, NULL, 'AP-4 complex subunit sigma isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(35887, NULL, 'G3DSA:2.130.10.10:FF:004576', NULL, NULL, 'GATOR complex protein MIOS', NULL, NULL, NULL, NULL, NULL, 4),
(35888, NULL, 'G3DSA:3.20.20.70:FF:000820', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35889, NULL, 'G3DSA:3.40.50.300:FF:004975', NULL, NULL, 'ABC transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(35890, NULL, 'G3DSA:1.10.8.60:FF:000096', NULL, NULL, 'sigma-54-dependent Fis family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(35891, NULL, 'G3DSA:1.25.40.20:FF:001380', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35892, NULL, 'G3DSA:3.60.10.10:FF:000204', NULL, NULL, 'Endonuclease/Exonuclease/phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(35893, NULL, 'G3DSA:3.40.50.10680:FF:000004', NULL, NULL, '2-phospho-L-lactate transferase', NULL, NULL, NULL, NULL, NULL, 4),
(35894, NULL, 'G3DSA:2.60.120.1020:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35895, NULL, 'G3DSA:1.10.510.10:FF:002228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35896, NULL, 'G3DSA:2.60.40.10:FF:000995', NULL, NULL, 'prostaglandin F2 receptor negative regulator', NULL, NULL, NULL, NULL, NULL, 4),
(35897, NULL, 'G3DSA:2.120.10.30:FF:000035', NULL, NULL, 'Low-density lipoprotein receptor-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(35898, NULL, 'G3DSA:2.30.29.30:FF:000094', NULL, NULL, 'Rho guanine nucleotide exchange factor 7', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(35899, NULL, 'G3DSA:1.20.1070.10:FF:000268', NULL, NULL, 'Putative olfactory receptor 2I1', NULL, NULL, NULL, NULL, NULL, 4),
(35900, NULL, 'G3DSA:3.40.30.10:FF:001229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35901, NULL, 'G3DSA:1.10.268.10:FF:000006', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(35902, NULL, 'G3DSA:2.40.30.10:FF:000102', NULL, NULL, 'Translation elongation factor Tu', NULL, NULL, NULL, NULL, NULL, 4),
(35903, NULL, 'G3DSA:3.40.720.10:FF:000139', NULL, NULL, 'Galactosamine (N-acetyl)-6-sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(35904, NULL, 'G3DSA:2.10.25.10:FF:000052', NULL, NULL, 'low-density lipoprotein receptor isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(35905, NULL, 'G3DSA:3.30.160.60:FF:005773', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35906, NULL, 'G3DSA:1.25.40.10:FF:003636', NULL, NULL, 'Tetratricopeptide repeat protein 21B', NULL, NULL, NULL, NULL, NULL, 4),
(35907, NULL, 'G3DSA:1.10.3730.20:FF:000033', NULL, NULL, 'Drug/metabolite transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(35908, NULL, 'G3DSA:3.20.140.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35909, NULL, 'G3DSA:2.10.50.10:FF:000014', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 11B', NULL, NULL, NULL, NULL, NULL, 4),
(35910, NULL, 'G3DSA:2.10.90.10:FF:000011', NULL, NULL, 'Glycoprotein hormones alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(35911, NULL, 'G3DSA:2.10.25.10:FF:000956', NULL, NULL, 'Wall-associated receptor kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(35912, NULL, 'G3DSA:1.20.1560.10:FF:000694', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35913, NULL, 'G3DSA:3.10.110.10:FF:000369', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35914, NULL, 'G3DSA:3.80.10.10:FF:000259', NULL, NULL, 'Leucine-rich repeat-containing protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(35915, NULL, 'G3DSA:3.60.40.10:FF:000032', NULL, NULL, 'Protein phosphatase, Mg2+/Mn2+-dependent, 1F', NULL, NULL, NULL, NULL, NULL, 4),
(35916, NULL, 'G3DSA:1.10.238.10:FF:001134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35917, NULL, 'G3DSA:3.10.150.10:FF:000023', NULL, NULL, 'Beta sliding clamp', NULL, NULL, NULL, NULL, NULL, 4),
(35918, NULL, 'G3DSA:3.80.10.10:FF:003800', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35919, NULL, 'G3DSA:1.25.40.10:FF:003512', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35920, NULL, 'G3DSA:2.60.40.150:FF:000122', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(35921, NULL, 'G3DSA:1.10.630.10:FF:000832', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35922, NULL, 'G3DSA:3.40.430.10:FF:000044', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(35923, NULL, 'G3DSA:3.40.50.150:FF:000731', NULL, NULL, 'Polyamine aminopropyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(35924, NULL, 'G3DSA:1.20.1560.10:FF:000019', NULL, NULL, 'Cystic fibrosis transmembrane conductance regulator', NULL, NULL, NULL, NULL, NULL, 4),
(35925, NULL, 'G3DSA:3.30.420.60:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35926, NULL, 'G3DSA:2.60.40.60:FF:000077', NULL, NULL, 'Protocadherin-11 X-linked', NULL, NULL, NULL, NULL, NULL, 4),
(35927, NULL, 'G3DSA:1.10.630.10:FF:000484', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35928, NULL, 'G3DSA:4.10.60.10:FF:000179', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(35929, NULL, 'G3DSA:3.30.40.10:FF:002085', NULL, NULL, 'Putative RING zinc finger protein; 84572-85321', NULL, NULL, NULL, NULL, NULL, 4),
(35930, NULL, 'G3DSA:3.30.200.20:FF:000493', NULL, NULL, 'Cyclin-dependent kinase 8', NULL, NULL, NULL, NULL, NULL, 4),
(35931, NULL, 'G3DSA:1.20.58.390:FF:000067', NULL, NULL, 'Glycine receptor subunit alpha-2', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(35932, NULL, 'G3DSA:1.10.260.40:FF:000093', NULL, NULL, 'Pou4f2', NULL, NULL, NULL, NULL, NULL, 4),
(35933, NULL, 'G3DSA:3.30.530.20:FF:000023', NULL, NULL, 'Acyl-CoA thioesterase 12', NULL, NULL, NULL, NULL, NULL, 4),
(35934, NULL, 'G3DSA:1.10.510.10:FF:000778', NULL, NULL, 'Kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(35935, NULL, 'G3DSA:3.30.1520.10:FF:000193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35936, NULL, 'G3DSA:1.20.1070.10:FF:001229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35937, NULL, 'G3DSA:2.10.110.10:FF:000120', NULL, NULL, 'Insulin gene enhancer protein ISL-2', NULL, NULL, NULL, NULL, NULL, 4),
(35938, NULL, 'G3DSA:1.10.1070.11:FF:000098', NULL, NULL, 'PIKK family atypical protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(35939, NULL, 'G3DSA:1.25.40.20:FF:001609', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(35940, NULL, 'G3DSA:1.10.472.10:FF:000430', NULL, NULL, 'Cyclin G1', NULL, NULL, NULL, NULL, NULL, 4),
(35941, NULL, 'G3DSA:3.30.160.20:FF:000207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35942, NULL, 'G3DSA:1.10.400.10:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35943, NULL, 'G3DSA:2.10.220.10:FF:000016', NULL, NULL, 'Receptor tyrosine-protein kinase erbB-3', NULL, NULL, NULL, NULL, NULL, 4),
(35944, NULL, 'G3DSA:1.10.510.10:FF:001267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35945, NULL, 'G3DSA:3.40.50.300:FF:001884', NULL, NULL, 'Elongation factor 3 related protein', NULL, NULL, NULL, NULL, NULL, 4),
(35946, NULL, 'G3DSA:3.30.1370.50:FF:000029', NULL, NULL, 'FI18001p1', NULL, NULL, NULL, NULL, NULL, 4),
(35947, NULL, 'G3DSA:3.30.780.10:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35948, NULL, 'G3DSA:1.10.12.70:FF:000008', NULL, NULL, 'Serine/threonine protein kinase MST4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(35949, NULL, 'G3DSA:2.30.30.1190:FF:000005', NULL, NULL, 'Zinc finger CCCH domain-containing protein 37', NULL, NULL, NULL, NULL, NULL, 4),
(35950, NULL, 'G3DSA:3.20.20.140:FF:000238', NULL, NULL, 'Ethylammeline chlorohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(35951, NULL, 'G3DSA:3.30.70.1450:FF:000038', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(35952, NULL, 'G3DSA:3.30.160.60:FF:003069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35953, NULL, 'G3DSA:2.30.30.100:FF:000117', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm5p', NULL, NULL, NULL, NULL, NULL, 4),
(35954, NULL, 'G3DSA:2.10.10.10:FF:000012', NULL, NULL, 'Lymphocyte antigen 75', NULL, NULL, NULL, NULL, NULL, 4),
(35955, NULL, 'G3DSA:2.10.70.10:FF:000027', NULL, NULL, 'Fibronectin 1', NULL, NULL, NULL, NULL, NULL, 4),
(35956, NULL, 'G3DSA:3.30.160.60:FF:002900', NULL, NULL, 'Zinc finger protein 20', NULL, NULL, NULL, NULL, NULL, 4),
(35957, NULL, 'G3DSA:2.10.25.10:FF:000737', NULL, NULL, 'Fat-like cadherin-related tumor suppressor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(35958, NULL, 'G3DSA:1.20.58.190:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35959, NULL, 'G3DSA:3.50.50.60:FF:000733', NULL, NULL, 'FAD-dependent pyridine nucleotide-disulphide oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(35960, NULL, 'G3DSA:1.10.10.10:FF:001599', NULL, NULL, 'Caffeic acid 3-O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(35961, NULL, 'G3DSA:3.10.400.20:FF:000006', NULL, NULL, 'Translation machinery-associated protein 20', NULL, NULL, NULL, NULL, NULL, 4),
(35962, NULL, 'G3DSA:3.30.950.10:FF:000001', NULL, NULL, 'Siroheme synthase', NULL, NULL, NULL, NULL, NULL, 4),
(35963, NULL, 'G3DSA:1.10.555.10:FF:000179', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35964, NULL, 'G3DSA:1.25.10.10:FF:001330', NULL, NULL, 'Coatomer subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(35965, NULL, 'G3DSA:2.30.30.110:FF:000002', NULL, NULL, 'Toxin MazF5', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(35966, NULL, 'G3DSA:2.30.29.30:FF:000217', NULL, NULL, 'Rho GTPase activating protein 20', NULL, NULL, NULL, NULL, NULL, 4),
(35967, NULL, 'G3DSA:1.10.150.50:FF:000099', NULL, NULL, 'EPH receptor B2', NULL, NULL, NULL, NULL, NULL, 4),
(35968, NULL, 'G3DSA:3.50.50.60:FF:000391', NULL, NULL, 'Pyridine nucleotide-disulfide oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(35969, NULL, 'G3DSA:2.130.10.10:FF:003165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35970, NULL, 'G3DSA:3.40.50.720:FF:000262', NULL, NULL, '3 beta-hydroxysteroid dehydrogenase type 7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(35971, NULL, 'G3DSA:2.120.10.80:FF:000140', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(35972, NULL, 'G3DSA:3.20.20.120:FF:000013', NULL, NULL, 'Mandelate racemase/muconate lactonizing enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(35973, NULL, 'G3DSA:1.10.1070.11:FF:000103', NULL, NULL, 'Putative phosphatidylinositol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(35974, NULL, 'G3DSA:1.10.630.10:FF:000702', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35975, NULL, 'G3DSA:2.130.10.10:FF:002889', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35976, NULL, 'G3DSA:3.40.50.2300:FF:000364', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35977, NULL, 'G3DSA:3.50.50.60:FF:001222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35978, NULL, 'G3DSA:1.25.40.90:FF:000063', NULL, NULL, 'Putative clathrin coat assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(35979, NULL, 'G3DSA:2.60.40.60:FF:001038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35980, NULL, 'G3DSA:3.40.50.150:FF:001350', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35981, NULL, 'G3DSA:1.10.287.70:FF:000585', NULL, NULL, 'RE56935p', NULL, NULL, NULL, NULL, NULL, 4),
(35982, NULL, 'G3DSA:3.40.50.1100:FF:000094', NULL, NULL, 'Cysteine synthase protein', NULL, NULL, NULL, NULL, NULL, 4),
(35983, NULL, 'G3DSA:1.20.1250.20:FF:000257', NULL, NULL, 'monocarboxylate transporter 7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(35984, NULL, 'G3DSA:2.130.10.10:FF:001703', NULL, NULL, 'Semaphorin 4e', NULL, NULL, NULL, NULL, NULL, 4),
(35985, NULL, 'G3DSA:3.40.50.2300:FF:001201', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35986, NULL, 'G3DSA:3.40.350.10:FF:000094', NULL, NULL, 'Glr3482 protein', NULL, NULL, NULL, NULL, NULL, 4),
(35987, NULL, 'G3DSA:2.30.40.10:FF:000013', NULL, NULL, 'Isoaspartyl dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(35988, NULL, 'G3DSA:1.10.1670.10:FF:000075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35989, NULL, 'G3DSA:2.60.40.10:FF:003417', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35990, NULL, 'G3DSA:1.20.58.340:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35991, NULL, 'G3DSA:3.90.540.10:FF:000001', NULL, NULL, 'Colicin-E9', NULL, NULL, NULL, NULL, NULL, 4),
(35992, NULL, 'G3DSA:3.10.450.10:FF:000063', NULL, NULL, 'Si:ch211-284e20.8', NULL, NULL, NULL, NULL, NULL, 4),
(35993, NULL, 'G3DSA:3.40.50.300:FF:001209', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(35994, NULL, 'G3DSA:2.60.40.10:FF:004710', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(35995, NULL, 'G3DSA:3.40.50.300:FF:008235', NULL, NULL, 'GTP binding protein 3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(35996, NULL, 'G3DSA:1.10.287.380:FF:000043', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(35997, NULL, 'G3DSA:1.10.640.10:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(35998, NULL, 'G3DSA:1.10.287.40:FF:000025', NULL, NULL, 'Serine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(35999, NULL, 'G3DSA:3.40.50.2300:FF:000577', NULL, NULL, 'GLutamate Receptor family (AMPA)', NULL, NULL, NULL, NULL, NULL, 4),
(36000, NULL, 'G3DSA:3.30.160.60:FF:005323', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(36001, NULL, 'G3DSA:3.30.559.30:FF:000002', NULL, NULL, 'Nonribosomal peptide synthase Pes1', NULL, NULL, NULL, NULL, NULL, 4),
(36002, NULL, 'G3DSA:3.40.50.300:FF:003918', NULL, NULL, 'Adenylate kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(36003, NULL, 'G3DSA:1.20.1070.10:FF:001679', NULL, NULL, 'Si:dkey-42l23.1', NULL, NULL, NULL, NULL, NULL, 4),
(36004, NULL, 'G3DSA:3.70.10.10:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36005, NULL, 'G3DSA:3.40.50.1820:FF:001720', NULL, NULL, 'Serine carboxypeptidase-like 33', NULL, NULL, NULL, NULL, NULL, 4),
(36006, NULL, 'G3DSA:2.60.40.10:FF:003980', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36007, NULL, 'G3DSA:1.10.510.10:FF:004488', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36008, NULL, 'G3DSA:3.10.620.10:FF:000003', NULL, NULL, 'WDYHV motif containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(36009, NULL, 'G3DSA:2.70.150.10:FF:000289', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(36010, NULL, 'G3DSA:3.90.660.10:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36011, NULL, 'G3DSA:2.30.130.10:FF:000021', NULL, NULL, 'Glutamate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(36012, NULL, 'G3DSA:1.10.287.1490:FF:000023', NULL, NULL, 'WD repeat-containing protein 65', NULL, NULL, NULL, NULL, NULL, 4),
(36013, NULL, 'G3DSA:2.160.20.10:FF:000101', NULL, NULL, 'Glycoside hydrolase family 55 protein', NULL, NULL, NULL, NULL, NULL, 4),
(36014, NULL, 'G3DSA:3.90.70.80:FF:000042', NULL, NULL, 'OTU-like cysteine protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(36015, NULL, 'G3DSA:3.10.620.30:FF:000009', NULL, NULL, 'Peptide-N4-(N-acetyl-beta-glucosaminyl)asparagine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(36016, NULL, 'G3DSA:1.10.357.70:FF:000012', NULL, NULL, 'Exocyst complex component 3', NULL, NULL, NULL, NULL, NULL, 4),
(36017, NULL, 'G3DSA:3.40.50.720:FF:001329', NULL, NULL, 'L-2,3-butanediol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(36018, NULL, 'G3DSA:2.60.200.20:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36019, NULL, 'G3DSA:2.20.70.10:FF:000268', NULL, NULL, 'Rho GTPase-activating protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(36020, NULL, 'G3DSA:3.30.70.2850:FF:000020', NULL, NULL, 'DNA-directed RNA polymerase I 190 kDa polypeptide-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(36021, NULL, 'G3DSA:3.30.450.20:FF:000657', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(36022, NULL, 'G3DSA:1.10.510.10:FF:003976', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36023, NULL, 'G3DSA:2.60.120.10:FF:000059', NULL, NULL, 'jmjC domain-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(36024, NULL, 'G3DSA:3.15.10.10:FF:000005', NULL, NULL, 'BPI fold containing family B member 2', NULL, NULL, NULL, NULL, NULL, 4),
(36025, NULL, 'G3DSA:3.40.50.150:FF:000282', NULL, NULL, 'Carnosine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(36026, NULL, 'G3DSA:3.30.460.10:FF:000149', NULL, NULL, 'DNA polymerase sigma-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(36027, NULL, 'G3DSA:2.70.20.10:FF:000010', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(36028, NULL, 'G3DSA:3.40.50.720:FF:000823', NULL, NULL, 'Undecaprenyl-phosphate glucose phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(36029, NULL, 'G3DSA:3.20.20.190:FF:000106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36030, NULL, 'G3DSA:2.130.10.10:FF:004126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36031, NULL, 'G3DSA:4.10.1000.10:FF:000079', NULL, NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', NULL, NULL, NULL, NULL, NULL, 4),
(36032, NULL, 'G3DSA:3.30.1330.90:FF:000016', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(36033, NULL, 'G3DSA:2.130.10.10:FF:000866', NULL, NULL, 'Nucleolar protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(36034, NULL, 'G3DSA:3.30.1360.120:FF:000056', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(36035, NULL, 'G3DSA:1.20.1050.10:FF:000048', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(36036, NULL, 'G3DSA:2.60.40.10:FF:005093', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36037, NULL, 'G3DSA:3.40.630.30:FF:000582', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36038, NULL, 'G3DSA:3.40.50.300:FF:001777', NULL, NULL, 'Os10g0117800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(36039, NULL, 'G3DSA:1.10.510.10:FF:000323', NULL, NULL, 'TP53-regulating kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(36040, NULL, 'G3DSA:2.90.10.10:FF:000008', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(36041, NULL, 'G3DSA:3.30.470.20:FF:000080', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(36042, NULL, 'G3DSA:4.10.860.20:FF:000003', NULL, NULL, 'rabenosyn-5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(36043, NULL, 'G3DSA:1.10.1520.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36044, NULL, 'G3DSA:3.10.20.90:FF:000551', NULL, NULL, 'Auxin-responsive protein', NULL, NULL, NULL, NULL, NULL, 4),
(36045, NULL, 'G3DSA:3.30.160.60:FF:001271', NULL, NULL, 'Zinc finger protein 282', NULL, NULL, NULL, NULL, NULL, 4),
(36046, NULL, 'G3DSA:1.10.150.110:FF:000002', NULL, NULL, 'DNA polymerase beta', NULL, NULL, NULL, NULL, NULL, 4),
(36047, NULL, 'G3DSA:2.130.10.10:FF:001378', NULL, NULL, 'FI05482p', NULL, NULL, NULL, NULL, NULL, 4),
(36048, NULL, 'G3DSA:2.60.40.3510:FF:000032', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(36049, NULL, 'G3DSA:1.10.40.30:FF:000016', NULL, NULL, 'Aspartate ammonium lyase', NULL, NULL, NULL, NULL, NULL, 4),
(36050, NULL, 'G3DSA:1.10.150.130:FF:000008', NULL, NULL, 'Site-specific recombinase IntI4', NULL, NULL, NULL, NULL, NULL, 4),
(36051, NULL, 'G3DSA:1.25.40.10:FF:002787', NULL, NULL, 'Os01g0600400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(36052, NULL, 'G3DSA:1.10.630.10:FF:000377', NULL, NULL, '1,8-cineole 2-endo-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(36053, NULL, 'G3DSA:1.10.10.60:FF:000855', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36054, NULL, 'G3DSA:1.25.40.800:FF:000007', NULL, NULL, 'Cdc39p', NULL, NULL, NULL, NULL, NULL, 4),
(36055, NULL, 'G3DSA:3.10.450.700:FF:000009', NULL, NULL, 'Pur alpha Like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(36056, NULL, 'G3DSA:3.40.50.1010:FF:000286', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36057, NULL, 'G3DSA:3.90.640.10:FF:000060', NULL, NULL, 'Actin-related protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(36058, NULL, 'G3DSA:3.40.1380.20:FF:000036', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(36059, NULL, 'G3DSA:1.10.8.60:FF:000421', NULL, NULL, 'Werner helicase interacting protein, putative (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(36060, NULL, 'G3DSA:3.30.390.30:FF:000025', NULL, NULL, 'Glutathione-disulfide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(36061, NULL, 'G3DSA:2.40.340.10:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36062, NULL, 'G3DSA:1.50.40.10:FF:000470', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36063, NULL, 'G3DSA:3.30.720.150:FF:000008', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36064, NULL, 'G3DSA:2.60.40.10:FF:002344', NULL, NULL, 'KETtiN (Drosophila actin-binding) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(36065, NULL, 'G3DSA:3.30.10.20:FF:000012', NULL, NULL, 'Serine/threonine-protein kinase StkP', NULL, NULL, NULL, NULL, NULL, 4),
(36066, NULL, 'G3DSA:1.10.101.10:FF:000024', NULL, NULL, 'Murein L,D-transpeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(36067, NULL, 'G3DSA:1.20.120.1900:FF:000010', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(36068, NULL, 'G3DSA:1.10.540.10:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36069, NULL, 'G3DSA:3.90.230.10:FF:000028', NULL, NULL, 'Methionine aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(36070, NULL, 'G3DSA:1.20.58.2220:FF:000047', NULL, NULL, 'Formin-like protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(36071, NULL, 'G3DSA:1.10.238.160:FF:000001', NULL, NULL, 'Response regulator inhibitor for tor operon', NULL, NULL, NULL, NULL, NULL, 4),
(36072, NULL, 'G3DSA:3.40.50.2300:FF:001089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36073, NULL, 'G3DSA:1.20.144.10:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36074, NULL, 'G3DSA:3.30.160.60:FF:001956', NULL, NULL, 'ZFP37 zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(36075, NULL, 'G3DSA:3.30.160.60:FF:005542', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36076, NULL, 'G3DSA:2.40.50.90:FF:000071', NULL, NULL, 'tudor domain-containing protein 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(36077, NULL, 'G3DSA:1.20.120.1630:FF:000018', NULL, NULL, 'Protein-S-isoprenylcysteine O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(36078, NULL, 'G3DSA:3.40.50.300:FF:000248', NULL, NULL, 'Mitochondrial Rho GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(36079, NULL, 'G3DSA:3.30.160.60:FF:003412', NULL, NULL, 'LD29879p', NULL, NULL, NULL, NULL, NULL, 4),
(36080, NULL, 'G3DSA:3.40.33.10:FF:000073', NULL, NULL, 'IP19912p', NULL, NULL, NULL, NULL, NULL, 4),
(36081, NULL, 'G3DSA:1.10.10.10:FF:001942', NULL, NULL, 'Transcription factor E', NULL, NULL, NULL, NULL, NULL, 4),
(36082, NULL, 'G3DSA:3.30.70.2190:FF:000013', NULL, NULL, 'FAD-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(36083, NULL, 'G3DSA:3.30.160.60:FF:006048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36084, NULL, 'G3DSA:3.40.50.150:FF:001804', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36085, NULL, 'G3DSA:2.40.10.10:FF:000668', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36086, NULL, 'G3DSA:3.40.50.2000:FF:000594', NULL, NULL, 'GDP-Man:Man(3)GlcNAc(2)-PP-Dol alpha-1,2-mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(36087, NULL, 'G3DSA:3.40.50.300:FF:000580', NULL, NULL, 'uronyl 2-sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(36088, NULL, 'G3DSA:1.25.40.20:FF:001267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36089, NULL, 'G3DSA:3.40.50.1980:FF:000104', NULL, NULL, 'Nitrogenase MoFe cofactor biosynthesis protein NifN', NULL, NULL, NULL, NULL, NULL, 4),
(36090, NULL, 'G3DSA:3.40.50.1820:FF:000989', NULL, NULL, 'AaceriACR149Cp', NULL, NULL, NULL, NULL, NULL, 4),
(36091, NULL, 'G3DSA:2.130.10.10:FF:003614', NULL, NULL, 'Transducin beta-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(36092, NULL, 'G3DSA:2.40.30.10:FF:000091', NULL, NULL, 'NADPH oxidase (NoxA), putative', NULL, NULL, NULL, NULL, NULL, 4),
(36093, NULL, 'G3DSA:2.40.10.350:FF:000017', NULL, NULL, 'Glr4400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(36094, NULL, 'G3DSA:3.20.20.70:FF:000241', NULL, NULL, 'Orotidine 5''-phosphate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(36095, NULL, 'G3DSA:2.40.50.140:FF:001221', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36096, NULL, 'G3DSA:2.130.10.120:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36097, NULL, 'G3DSA:1.25.40.10:FF:001495', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g13880', NULL, NULL, NULL, NULL, NULL, 4),
(36098, NULL, 'G3DSA:1.25.40.10:FF:000657', NULL, NULL, 'U3 small nucleolar RNA-associated protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(36099, NULL, 'G3DSA:3.30.70.240:FF:000023', NULL, NULL, 'Sdo1p', NULL, NULL, NULL, NULL, NULL, 4),
(36100, NULL, 'G3DSA:1.25.40.10:FF:003405', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(36101, NULL, 'G3DSA:1.10.220.150:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36102, NULL, 'G3DSA:3.40.50.800:FF:000061', NULL, NULL, 'Threonyl-tRNA synthetase editing domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(36103, NULL, 'G3DSA:1.10.510.10:FF:001739', NULL, NULL, 'CMGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(36104, NULL, 'G3DSA:1.20.1250.20:FF:001893', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36105, NULL, 'G3DSA:3.30.70.270:FF:000127', NULL, NULL, 'CRISPR-associated protein cas10/csm1, subtype III-a/mtube', NULL, NULL, NULL, NULL, NULL, 4),
(36106, NULL, 'G3DSA:1.10.2010.10:FF:000003', NULL, NULL, 'Protein CBG26136', NULL, NULL, NULL, NULL, NULL, 4),
(36107, NULL, 'G3DSA:3.40.50.360:FF:000120', NULL, NULL, 'NADPH--cytochrome p450 reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(36108, NULL, 'G3DSA:1.20.910.10:FF:000019', NULL, NULL, 'Aminopyrimidine aminohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(36109, NULL, 'G3DSA:3.30.200.20:FF:000942', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(36110, NULL, 'G3DSA:3.10.310.70:FF:000003', NULL, NULL, 'Amidohydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(36111, NULL, 'G3DSA:2.30.30.100:FF:000229', NULL, NULL, 'Small nuclear ribonucleoprotein Sm D2', NULL, NULL, NULL, NULL, NULL, 4),
(36112, NULL, 'G3DSA:3.30.70.1730:FF:000015', NULL, NULL, 'Mrpl11p', NULL, NULL, NULL, NULL, NULL, 4),
(36113, NULL, 'G3DSA:3.80.10.10:FF:004312', NULL, NULL, 'Cyclic GMP-binding protein C', NULL, NULL, NULL, NULL, NULL, 4),
(36114, NULL, 'G3DSA:1.10.10.440:FF:000066', NULL, NULL, 'YALI0C19404p', NULL, NULL, NULL, NULL, NULL, 4),
(36115, NULL, 'G3DSA:3.30.420.10:FF:000141', NULL, NULL, 'Ribonuclease H', NULL, NULL, NULL, NULL, NULL, 4),
(36116, NULL, 'G3DSA:1.10.510.10:FF:001846', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(36117, NULL, 'G3DSA:3.40.50.720:FF:002280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36118, NULL, 'G3DSA:1.25.10.10:FF:001673', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36119, NULL, 'G3DSA:1.20.120.140:FF:000008', NULL, NULL, 'Signal recognition particle receptor FtsY', NULL, NULL, NULL, NULL, NULL, 4),
(36120, NULL, 'G3DSA:3.90.1420.10:FF:000008', NULL, NULL, 'SET domain containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(36121, NULL, 'G3DSA:2.30.29.30:FF:000442', NULL, NULL, 'Target of rapamycin complex 2 subunit AVO1', NULL, NULL, NULL, NULL, NULL, 4),
(36122, NULL, 'G3DSA:4.10.400.10:FF:000365', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36123, NULL, 'G3DSA:1.20.1250.10:FF:000029', NULL, NULL, 'Interleukin-13', NULL, NULL, NULL, NULL, NULL, 4),
(36124, NULL, 'G3DSA:3.60.20.30:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36125, NULL, 'G3DSA:3.30.70.1230:FF:000208', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(36126, NULL, 'G3DSA:1.10.10.1590:FF:000001', NULL, NULL, 'NADH-quinone oxidoreductase subunit E', NULL, NULL, NULL, NULL, NULL, 4),
(36127, NULL, 'G3DSA:3.40.630.10:FF:000368', NULL, NULL, 'Si:ch1073-459j12.1', NULL, NULL, NULL, NULL, NULL, 4),
(36128, NULL, 'G3DSA:2.60.120.10:FF:000391', NULL, NULL, 'Glucose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(36129, NULL, 'G3DSA:3.30.70.100:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36130, NULL, 'G3DSA:3.60.40.10:FF:000144', NULL, NULL, 'Protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(36131, NULL, 'G3DSA:2.110.10.10:FF:000018', NULL, NULL, 'Matrix metallopeptidase 25b', NULL, NULL, NULL, NULL, NULL, 4),
(36132, NULL, 'G3DSA:1.10.520.10:FF:000043', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36133, NULL, 'G3DSA:3.40.50.300:FF:004632', NULL, NULL, 'Toxin secretion ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(36134, NULL, 'G3DSA:1.10.10.60:FF:000748', NULL, NULL, 'Nucleolar protein', NULL, NULL, NULL, NULL, NULL, 4),
(36135, NULL, 'G3DSA:3.40.50.300:FF:005144', NULL, NULL, 'Os02g0107900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(36136, NULL, 'G3DSA:2.60.40.1730:FF:000037', NULL, NULL, 'Aminopeptidase-like protein AC3.5', NULL, NULL, NULL, NULL, NULL, 4),
(36137, NULL, 'G3DSA:1.20.140.150:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(36138, NULL, 'G3DSA:2.130.10.10:FF:004233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36139, NULL, 'G3DSA:3.90.70.10:FF:000280', NULL, NULL, 'Type I secretion system permease/ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(36140, NULL, 'G3DSA:1.25.40.10:FF:001371', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(36141, NULL, 'G3DSA:1.10.287.70:FF:000692', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36142, NULL, 'G3DSA:1.20.1310.10:FF:000198', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36143, NULL, 'G3DSA:2.40.100.10:FF:000034', NULL, NULL, 'Peptidyl-prolyl isomerase CWC27 protein', NULL, NULL, NULL, NULL, NULL, 4),
(36144, NULL, 'G3DSA:2.130.10.10:FF:005981', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36145, NULL, 'G3DSA:3.40.47.10:FF:000121', NULL, NULL, 'Beta-ketoacyl-ACP synthase II', NULL, NULL, NULL, NULL, NULL, 4),
(36146, NULL, 'G3DSA:3.40.1110.10:FF:000210', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(36147, NULL, 'G3DSA:1.10.10.10:FF:000306', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(36148, NULL, 'G3DSA:1.20.1250.20:FF:001095', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(36149, NULL, 'G3DSA:3.40.50.2000:FF:000605', NULL, NULL, 'Granule-bound starch synthase 1 chloroplastic/amyloplastic', NULL, NULL, NULL, NULL, NULL, 4),
(36150, NULL, 'G3DSA:2.60.120.200:FF:000039', NULL, NULL, 'Collagen XV alpha 1 chain', NULL, NULL, NULL, NULL, NULL, 4),
(36151, NULL, 'G3DSA:1.10.510.10:FF:000542', NULL, NULL, 'Tyrosine-protein kinase Abl', NULL, NULL, NULL, NULL, NULL, 4),
(36152, NULL, 'G3DSA:2.60.120.1000:FF:000015', NULL, NULL, 'Fibrillar collagen', NULL, NULL, NULL, NULL, NULL, 4),
(36153, NULL, 'G3DSA:3.80.10.10:FF:004418', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36154, NULL, 'G3DSA:2.40.33.10:FF:000018', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(36155, NULL, 'G3DSA:3.20.20.60:FF:000143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36156, NULL, 'G3DSA:2.10.220.10:FF:000128', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(36157, NULL, 'G3DSA:2.130.10.10:FF:005762', NULL, NULL, 'Glr0823 protein', NULL, NULL, NULL, NULL, NULL, 4),
(36158, NULL, 'G3DSA:2.60.40.840:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36159, NULL, 'G3DSA:3.90.190.10:FF:000204', NULL, NULL, 'Dual specificity protein phosphatase Mpk3', NULL, NULL, NULL, NULL, NULL, 4),
(36160, NULL, 'G3DSA:1.10.10.2230:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36161, NULL, 'G3DSA:1.20.120.980:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36162, NULL, 'G3DSA:1.10.287.940:FF:000014', NULL, NULL, 'P2X purinoceptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(36163, NULL, 'G3DSA:3.30.70.330:FF:000393', NULL, NULL, 'Methenyltetrahydrofolate synthetase domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(36164, NULL, 'G3DSA:2.70.98.10:FF:000077', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(36165, NULL, 'G3DSA:1.20.58.420:FF:000003', NULL, NULL, 'ATLastiN (Endoplasmic reticulum GTPase) related', NULL, NULL, NULL, NULL, NULL, 4),
(36166, NULL, 'G3DSA:2.40.20.10:FF:000039', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(36167, NULL, 'G3DSA:3.40.50.2000:FF:001117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36168, NULL, 'G3DSA:2.60.120.330:FF:000050', NULL, NULL, 'Gibberellin 2-beta-dioxygenase 7', NULL, NULL, NULL, NULL, NULL, 4),
(36169, NULL, 'G3DSA:3.40.50.150:FF:000967', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36170, NULL, 'G3DSA:2.10.25.10:FF:000844', NULL, NULL, 'Neurocan b', NULL, NULL, NULL, NULL, NULL, 4),
(36171, NULL, 'G3DSA:1.25.10.10:FF:000829', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(36172, NULL, 'G3DSA:1.20.1740.10:FF:000011', NULL, NULL, 'Arginine/agmatine antiporter', NULL, NULL, NULL, NULL, NULL, 4),
(36173, NULL, 'G3DSA:2.30.29.30:FF:001061', NULL, NULL, 'Switching B cell complex subunit SWAP70', NULL, NULL, NULL, NULL, NULL, 4),
(36174, NULL, 'G3DSA:2.60.40.10:FF:000214', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(36175, NULL, 'G3DSA:3.90.550.10:FF:000406', NULL, NULL, 'Putative glycosyltransferase EpsE', NULL, NULL, NULL, NULL, NULL, 4),
(36176, NULL, 'G3DSA:1.25.40.180:FF:000208', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36177, NULL, 'G3DSA:2.170.130.10:FF:000073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36178, NULL, 'G3DSA:1.20.120.1910:FF:000001', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(36179, NULL, 'G3DSA:2.60.40.150:FF:000015', NULL, NULL, 'dedicator of cytokinesis protein 9 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(36180, NULL, 'G3DSA:3.60.110.10:FF:000015', NULL, NULL, 'Apolipoprotein N-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(36181, NULL, 'G3DSA:3.30.160.60:FF:005430', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36182, NULL, 'G3DSA:3.30.190.20:FF:000035', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(36183, NULL, 'G3DSA:2.130.10.10:FF:002996', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36184, NULL, 'G3DSA:3.40.50.1220:FF:000124', NULL, NULL, 'Sir2-type regulatory transcription factor silent information regulator protein', NULL, NULL, NULL, NULL, NULL, 4),
(36185, NULL, 'G3DSA:1.10.10.1800:FF:000002', NULL, NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', NULL, NULL, NULL, NULL, NULL, 4),
(36186, NULL, 'G3DSA:3.30.160.60:FF:000427', NULL, NULL, 'Zinc finger with KRAB and SCAN domains 7', NULL, NULL, NULL, NULL, NULL, 4),
(36187, NULL, 'G3DSA:3.40.1190.20:FF:000206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36188, NULL, 'G3DSA:3.40.20.10:FF:000094', NULL, NULL, 'Actin-binding protein, cofilin/tropomyosin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(36189, NULL, 'G3DSA:2.130.10.10:FF:000759', NULL, NULL, 'WD repeat-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(36190, NULL, 'G3DSA:3.40.50.450:FF:000046', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(36191, NULL, 'G3DSA:3.40.50.970:FF:000084', NULL, NULL, 'Probable 2-ketoarginine decarboxylase AruI', NULL, NULL, NULL, NULL, NULL, 4),
(36192, NULL, 'G3DSA:3.40.50.300:FF:001092', NULL, NULL, 'ATP-binding cassette sub-family F member 2', NULL, NULL, NULL, NULL, NULL, 4),
(36193, NULL, 'G3DSA:1.10.238.10:FF:001241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36194, NULL, 'G3DSA:1.20.120.1220:FF:000002', NULL, NULL, 'Leader peptidase (Prepilin peptidase)/N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(36195, NULL, 'G3DSA:3.90.190.10:FF:000423', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36196, NULL, 'G3DSA:3.30.420.510:FF:000009', NULL, NULL, 'PaNtothenate Kinase', NULL, NULL, NULL, NULL, NULL, 4),
(36197, NULL, 'G3DSA:1.10.560.10:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36198, NULL, 'G3DSA:1.20.58.1030:FF:000016', NULL, NULL, 'Partner of sld5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(36199, NULL, 'G3DSA:3.20.20.80:FF:000025', NULL, NULL, 'Alpha-L-arabinofuranosidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(36200, NULL, 'G3DSA:2.40.50.100:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36201, NULL, 'G3DSA:3.80.10.10:FF:002390', NULL, NULL, 'F-box/LRR-repeat protein 20', NULL, NULL, NULL, NULL, NULL, 4),
(36202, NULL, 'G3DSA:2.60.40.10:FF:003648', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36203, NULL, 'G3DSA:1.25.40.20:FF:000879', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(36204, NULL, 'G3DSA:3.40.250.10:FF:000260', NULL, NULL, 'Tyrosine-protein phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(36205, NULL, 'G3DSA:3.40.50.300:FF:008342', NULL, NULL, 'Dynein axonemal heavy chain 10', NULL, NULL, NULL, NULL, NULL, 4),
(36206, NULL, 'G3DSA:3.40.50.300:FF:000361', NULL, NULL, 'Multidrug ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(36207, NULL, 'G3DSA:1.20.1050.90:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36208, NULL, 'G3DSA:3.30.450.20:FF:000533', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36209, NULL, 'G3DSA:1.10.287.70:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36210, NULL, 'G3DSA:1.10.472.80:FF:000193', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36211, NULL, 'G3DSA:3.90.76.10:FF:000012', NULL, NULL, 'Peptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(36212, NULL, 'G3DSA:3.30.70.330:FF:001011', NULL, NULL, 'Serine/arginine-rich SC35-like splicing factor SCL30 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(36213, NULL, 'G3DSA:3.30.200.20:FF:000599', NULL, NULL, 'Cyclin-dependent kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(36214, NULL, 'G3DSA:3.30.457.30:FF:000001', NULL, NULL, 'Fancl, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(36215, NULL, 'G3DSA:3.40.50.300:FF:005829', NULL, NULL, 'ABC transporter D family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(36216, NULL, 'G3DSA:3.30.565.10:FF:000398', NULL, NULL, 'Two component signal transduction system histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(36217, NULL, 'G3DSA:1.10.4160.10:FF:000014', NULL, NULL, 'Putative permease', NULL, NULL, NULL, NULL, NULL, 4),
(36218, NULL, 'G3DSA:3.90.1460.10:FF:000005', NULL, NULL, 'general transcription factor II-I repeat domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(36219, NULL, 'G3DSA:3.30.900.10:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36220, NULL, 'G3DSA:3.90.640.10:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36221, NULL, 'G3DSA:2.60.120.260:FF:000473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36222, NULL, 'G3DSA:3.30.160.60:FF:000208', NULL, NULL, 'zinc finger protein Gfi-1b', NULL, NULL, NULL, NULL, NULL, 4),
(36223, NULL, 'G3DSA:3.90.180.10:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36224, NULL, 'G3DSA:3.40.1280.10:FF:000087', NULL, NULL, 'SPOUT domain-containing methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(36225, NULL, 'G3DSA:3.50.40.10:FF:000010', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36226, NULL, 'G3DSA:1.25.10.10:FF:001779', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36227, NULL, 'G3DSA:2.60.40.3120:FF:000004', NULL, NULL, 'Metallo-peptidase, Clan MC, Family M14', NULL, NULL, NULL, NULL, NULL, 4),
(36228, NULL, 'G3DSA:2.40.70.10:FF:000430', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36229, NULL, 'G3DSA:1.20.1720.10:FF:000009', NULL, NULL, 'MFS multidrug transporter', NULL, NULL, NULL, NULL, NULL, 4),
(36230, NULL, 'G3DSA:2.60.40.820:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36231, NULL, 'G3DSA:1.20.120.1080:FF:000033', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(36232, NULL, 'G3DSA:3.30.460.20:FF:000028', NULL, NULL, 'CorA family metal ion transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(36233, NULL, 'G3DSA:1.25.40.20:FF:000194', NULL, NULL, 'short transient receptor potential channel 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(36234, NULL, 'G3DSA:3.40.50.620:FF:000451', NULL, NULL, 'Cysteine-tRNA ligase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(36235, NULL, 'G3DSA:2.60.120.290:FF:000234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36236, NULL, 'G3DSA:3.40.50.2300:FF:000813', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36237, NULL, 'G3DSA:1.10.630.10:FF:000253', NULL, NULL, 'Cytochrome P450 hydroxylase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(36238, NULL, 'G3DSA:1.25.10.10:FF:002055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36239, NULL, 'G3DSA:2.60.40.10:FF:001962', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(36240, NULL, 'G3DSA:1.25.40.20:FF:000536', NULL, NULL, 'Ankyrin-3 isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(36241, NULL, 'G3DSA:3.40.50.11060:FF:000017', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36242, NULL, 'G3DSA:3.40.50.720:FF:000711', NULL, NULL, 'Unplaced genomic scaffold supercont2.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(36243, NULL, 'G3DSA:1.20.1250.20:FF:001999', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36244, NULL, 'G3DSA:3.40.50.300:FF:002159', NULL, NULL, 'Possible transposase', NULL, NULL, NULL, NULL, NULL, 4),
(36245, NULL, 'G3DSA:3.40.605.10:FF:000063', NULL, NULL, 'Succinate-semialdehyde dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(36246, NULL, 'G3DSA:1.25.40.10:FF:002568', NULL, NULL, 'Putative UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SEC', NULL, NULL, NULL, NULL, NULL, 4),
(36247, NULL, 'G3DSA:1.25.40.10:FF:003187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36248, NULL, 'G3DSA:3.10.180.10:FF:000087', NULL, NULL, '4-hydroxyphenylpyruvate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(36249, NULL, 'G3DSA:3.20.20.300:FF:000078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36250, NULL, 'G3DSA:1.25.10.20:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36251, NULL, 'G3DSA:3.40.50.300:FF:001653', NULL, NULL, 'Transcriptional regulator RtcR', NULL, NULL, NULL, NULL, NULL, 4),
(36252, NULL, 'G3DSA:2.40.50.140:FF:000384', NULL, NULL, 'Aspartate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(36253, NULL, 'G3DSA:3.40.50.1000:FF:000749', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36254, NULL, 'G3DSA:3.40.630.30:FF:000363', NULL, NULL, 'Acetyltransferase, GNAT family', NULL, NULL, NULL, NULL, NULL, 4),
(36255, NULL, 'G3DSA:1.10.150.510:FF:000015', NULL, NULL, 'Receptor (G protein-coupled) activity modifying protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(36256, NULL, 'G3DSA:2.130.10.10:FF:004014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36257, NULL, 'G3DSA:3.40.50.1110:FF:000080', NULL, NULL, 'Slr1119 protein', NULL, NULL, NULL, NULL, NULL, 4),
(36258, NULL, 'G3DSA:1.10.8.10:FF:000339', NULL, NULL, 'Heat shock protein 70 (HSP70)-interacting protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(36259, NULL, 'G3DSA:3.90.470.40:FF:000004', NULL, NULL, 'DNA damage-inducible transcript 4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(36260, NULL, 'G3DSA:2.30.30.40:FF:000280', NULL, NULL, 'Dreadlocks, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(36261, NULL, 'G3DSA:3.30.750.80:FF:000001', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase K/L', NULL, NULL, NULL, NULL, NULL, 4),
(36262, NULL, 'G3DSA:3.40.50.300:FF:004071', NULL, NULL, 'HPr kinase/phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(36263, NULL, 'G3DSA:1.10.357.10:FF:000022', NULL, NULL, 'Transcriptional regulator NfxB', NULL, NULL, NULL, NULL, NULL, 4),
(36264, NULL, 'G3DSA:1.50.10.20:FF:000066', NULL, NULL, 'Geranylgeranyl transferase type-1 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(36265, NULL, 'G3DSA:3.40.630.10:FF:000025', NULL, NULL, 'aspartoacylase', NULL, NULL, NULL, NULL, NULL, 4),
(36266, NULL, 'G3DSA:3.30.2030.20:FF:000001', NULL, NULL, 'Putative lipoprotein LppB', NULL, NULL, NULL, NULL, NULL, 4),
(36267, NULL, 'G3DSA:3.10.100.10:FF:000312', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36268, NULL, 'G3DSA:1.20.58.400:FF:000008', NULL, NULL, 'Vesicle transport v-SNARE 13', NULL, NULL, NULL, NULL, NULL, 4),
(36269, NULL, 'G3DSA:3.40.850.10:FF:000244', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(36270, NULL, 'G3DSA:3.90.1290.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(36271, NULL, 'G3DSA:1.10.1420.10:FF:000028', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(36272, NULL, 'G3DSA:2.40.50.140:FF:000041', NULL, NULL, 'Replication protein A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(36273, NULL, 'G3DSA:1.20.930.60:FF:000007', NULL, NULL, 'GM15669', NULL, NULL, NULL, NULL, NULL, 4),
(36274, NULL, 'G3DSA:4.10.400.10:FF:000022', NULL, NULL, 'LDL receptor related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(36275, NULL, 'G3DSA:1.20.1250.20:FF:001106', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(36276, NULL, 'G3DSA:3.60.21.10:FF:000016', NULL, NULL, 'Putative metallophosphoesterase', NULL, NULL, NULL, NULL, NULL, 4),
(36277, NULL, 'G3DSA:1.20.58.60:FF:000217', NULL, NULL, 'Synaptic nuclear envelope 2', NULL, NULL, NULL, NULL, NULL, 4),
(36278, NULL, 'G3DSA:2.40.160.20:FF:000035', NULL, NULL, 'Major outer membrane protein OMP-1A', NULL, NULL, NULL, NULL, NULL, 4),
(36279, NULL, 'G3DSA:3.30.200.20:FF:002179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36280, NULL, 'G3DSA:3.30.70.330:FF:001915', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36281, NULL, 'G3DSA:1.25.40.10:FF:005328', NULL, NULL, 'Tetratricopeptide repeat protein 37', NULL, NULL, NULL, NULL, NULL, 4),
(36282, NULL, 'G3DSA:2.30.30.380:FF:000049', NULL, NULL, 'AGAP001986-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(36283, NULL, 'G3DSA:3.30.559.10:FF:000232', NULL, NULL, 'Tryptophan N-acetyltransferase ivoA', NULL, NULL, NULL, NULL, NULL, 4),
(36284, NULL, 'G3DSA:1.10.560.10:FF:000040', NULL, NULL, 'Bardet-Biedl syndrome 10 protein', NULL, NULL, NULL, NULL, NULL, 4),
(36285, NULL, 'G3DSA:3.30.70.330:FF:000954', NULL, NULL, 'ESF1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(36286, NULL, 'G3DSA:1.20.1270.60:FF:000017', NULL, NULL, 'endophilin-B2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(36287, NULL, 'G3DSA:2.60.120.200:FF:000371', NULL, NULL, 'Drosophila CRumBs homolog', NULL, NULL, NULL, NULL, NULL, 4),
(36288, NULL, 'G3DSA:2.60.40.60:FF:000532', NULL, NULL, 'Protein CBR-CDH-12', NULL, NULL, NULL, NULL, NULL, 4),
(36289, NULL, 'G3DSA:3.50.50.100:FF:000023', NULL, NULL, 'Apoptosis-inducing factor, mitochondrion-associated, 2', NULL, NULL, NULL, NULL, NULL, 4),
(36290, NULL, 'G3DSA:3.40.50.620:FF:000794', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36291, NULL, 'G3DSA:3.30.1330.40:FF:000030', NULL, NULL, 'Enamine deaminase RidA, house cleaning of reactive enamine intermediates, YjgF/YER057c/UK114 family', NULL, NULL, NULL, NULL, NULL, 4),
(36292, NULL, 'G3DSA:1.10.510.10:FF:002919', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(36293, NULL, 'G3DSA:1.20.1410.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36294, NULL, 'G3DSA:1.10.220.10:FF:000003', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(36295, NULL, 'G3DSA:1.10.10.10:FF:001487', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit K', NULL, NULL, NULL, NULL, NULL, 4),
(36296, NULL, 'G3DSA:3.30.70.330:FF:001230', NULL, NULL, 'CCR4-NOT core complex subunit Not4, putative (AFU_orthologue AFUA_6G08820)', NULL, NULL, NULL, NULL, NULL, 4),
(36297, NULL, 'G3DSA:3.40.50.300:FF:007381', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36298, NULL, 'G3DSA:2.40.128.590:FF:000002', NULL, NULL, 'Phycocyanobilin lyase CpcT', NULL, NULL, NULL, NULL, NULL, 4),
(36299, NULL, 'G3DSA:2.130.10.10:FF:003053', NULL, NULL, 'FI12409p', NULL, NULL, NULL, NULL, NULL, 4),
(36300, NULL, 'G3DSA:3.10.590.10:FF:000005', NULL, NULL, 'Os03g0676100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(36301, NULL, 'G3DSA:1.20.1250.20:FF:000145', NULL, NULL, 'Chromaffin granule amine transporter', NULL, NULL, NULL, NULL, NULL, 4),
(36302, NULL, 'G3DSA:3.50.50.60:FF:001458', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36303, NULL, 'G3DSA:3.30.60.30:FF:000057', NULL, NULL, 'Follistatin, isoform B', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(36304, NULL, 'G3DSA:2.170.16.10:FF:000029', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(36305, NULL, 'G3DSA:3.90.70.10:FF:000622', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36306, NULL, 'G3DSA:3.20.20.70:FF:000365', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(36307, NULL, 'G3DSA:3.40.50.300:FF:002614', NULL, NULL, 'Origin recognition complex subunit Orc5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(36308, NULL, 'G3DSA:3.40.50.1240:FF:000006', NULL, NULL, '6-phosphofructo-2-kinase/fructose-2, 6-bisphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(36309, NULL, 'G3DSA:3.40.50.620:FF:000119', NULL, NULL, 'Putative valine--tRNA ligase-like', NULL, NULL, NULL, NULL, NULL, 4),
(36310, NULL, 'G3DSA:2.60.120.380:FF:000054', NULL, NULL, 'Cysteine peptidase, Clan CA, family C2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(36311, NULL, 'G3DSA:2.130.10.10:FF:001939', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36312, NULL, 'G3DSA:1.50.40.10:FF:000014', NULL, NULL, 'mitochondrial coenzyme A transporter SLC25A42', NULL, NULL, NULL, NULL, NULL, 4),
(36313, NULL, 'G3DSA:1.20.1250.20:FF:002275', NULL, NULL, 'Sugar transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(36314, NULL, 'G3DSA:3.60.10.10:FF:000193', NULL, NULL, 'Endonuclease/exonuclease/phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(36315, NULL, 'G3DSA:1.20.1070.10:FF:000954', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36316, NULL, 'G3DSA:3.30.930.10:FF:000224', NULL, NULL, 'Glycine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(36317, NULL, 'G3DSA:3.40.50.1380:FF:000020', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(36318, NULL, 'G3DSA:3.30.160.60:FF:001377', NULL, NULL, 'Zinc finger protein 585A', NULL, NULL, NULL, NULL, NULL, 4),
(36319, NULL, 'G3DSA:3.30.160.60:FF:003518', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36320, NULL, 'G3DSA:2.130.10.10:FF:005183', NULL, NULL, 'U4/U6-U5 snRNP complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(36321, NULL, 'G3DSA:2.60.40.10:FF:002001', NULL, NULL, 'Unc-89 protein', NULL, NULL, NULL, NULL, NULL, 4),
(36322, NULL, 'G3DSA:1.20.5.2440:FF:000006', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(36323, NULL, 'G3DSA:3.30.40.10:FF:001921', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36324, NULL, 'G3DSA:2.10.50.10:FF:000121', NULL, NULL, 'Tumor necrosis factor receptor superfamily, member 1a', NULL, NULL, NULL, NULL, NULL, 4),
(36325, NULL, 'G3DSA:3.10.580.10:FF:000179', NULL, NULL, 'Os03g0674300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(36326, NULL, 'G3DSA:2.60.40.60:FF:000313', NULL, NULL, 'Tyrosine kinase receptor Cad96Ca', NULL, NULL, NULL, NULL, NULL, 4),
(36327, NULL, 'G3DSA:2.60.40.10:FF:001383', NULL, NULL, 'Bent, isoform I', NULL, NULL, NULL, NULL, NULL, 4),
(36328, NULL, 'G3DSA:2.60.40.3170:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36329, NULL, 'G3DSA:4.10.240.10:FF:000049', NULL, NULL, 'C6 finger domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(36330, NULL, 'G3DSA:1.50.40.10:FF:000138', NULL, NULL, 'Mitochondrial phosphate carrier protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(36331, NULL, 'G3DSA:3.10.170.20:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36332, NULL, 'G3DSA:1.20.1440.300:FF:000001', NULL, NULL, 'RNA-directed RNA polymerase L', NULL, NULL, NULL, NULL, NULL, 4),
(36333, NULL, 'G3DSA:3.30.160.60:FF:004811', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36334, NULL, 'G3DSA:1.25.10.10:FF:003359', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36335, NULL, 'G3DSA:1.25.10.10:FF:003235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36336, NULL, 'G3DSA:3.40.30.10:FF:000717', NULL, NULL, 'Glutathione S-transferase, putative', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(36337, NULL, 'G3DSA:3.60.150.10:FF:000012', NULL, NULL, 'Chorismate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(36338, NULL, 'G3DSA:2.60.220.50:FF:000084', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36339, NULL, 'G3DSA:3.40.50.720:FF:002509', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36340, NULL, 'G3DSA:3.30.450.20:FF:000078', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(36341, NULL, 'G3DSA:2.60.120.620:FF:000160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36342, NULL, 'G3DSA:3.40.50.1000:FF:000406', NULL, NULL, 'HAD superfamily hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(36343, NULL, 'G3DSA:1.20.58.60:FF:000094', NULL, NULL, 'dystonin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(36344, NULL, 'G3DSA:3.40.50.1820:FF:000540', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(36345, NULL, 'G3DSA:2.130.10.10:FF:002092', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(36346, NULL, 'G3DSA:3.30.40.10:FF:001028', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(36347, NULL, 'G3DSA:1.10.455.10:FF:000020', NULL, NULL, '30S ribosomal protein S7', NULL, NULL, NULL, NULL, NULL, 4),
(36348, NULL, 'G3DSA:3.10.250.10:FF:000082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36349, NULL, 'G3DSA:1.10.238.10:FF:000622', NULL, NULL, 'Follistatin-like 5', NULL, NULL, NULL, NULL, NULL, 4),
(36350, NULL, 'G3DSA:1.25.10.10:FF:002959', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36351, NULL, 'G3DSA:1.20.1070.10:FF:000375', NULL, NULL, '5-hydroxytryptamine (serotonin) receptor 1Fa', NULL, NULL, NULL, NULL, NULL, 4),
(36352, NULL, 'G3DSA:1.10.510.10:FF:002796', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(36353, NULL, 'G3DSA:3.30.40.10:FF:000628', NULL, NULL, 'Ubiquitin E3 ligase ICP0', NULL, NULL, NULL, NULL, NULL, 4),
(36354, NULL, 'G3DSA:1.20.1260.10:FF:000081', NULL, NULL, 'Ferritin/ribonucleotide reductase-like family protein', NULL, NULL, NULL, NULL, NULL, 4),
(36355, NULL, 'G3DSA:2.60.40.10:FF:006054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36356, NULL, 'G3DSA:3.40.33.10:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36357, NULL, 'G3DSA:3.30.420.40:FF:000588', NULL, NULL, 'Protein CBR-STC-1', NULL, NULL, NULL, NULL, NULL, 4),
(36358, NULL, 'G3DSA:3.30.420.10:FF:000028', NULL, NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', NULL, NULL, NULL, NULL, NULL, 4),
(36359, NULL, 'G3DSA:3.30.1330.20:FF:000035', NULL, NULL, 'Tubulin-like protein CetZ', NULL, NULL, NULL, NULL, NULL, 4),
(36360, NULL, 'G3DSA:2.30.42.10:FF:000416', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36361, NULL, 'G3DSA:1.10.540.10:FF:000038', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(36362, NULL, 'G3DSA:3.30.9.10:FF:000118', NULL, NULL, 'FAD-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(36363, NULL, 'G3DSA:1.20.1270.60:FF:000130', NULL, NULL, 'Variant sh3 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(36364, NULL, 'G3DSA:3.40.50.150:FF:001586', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36365, NULL, 'G3DSA:1.10.510.10:FF:003072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36366, NULL, 'G3DSA:4.10.800.20:FF:000011', NULL, NULL, 'AMP deaminase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(36367, NULL, 'G3DSA:3.40.50.1010:FF:000067', NULL, NULL, 'DNA repair endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(36368, NULL, 'G3DSA:3.30.70.980:FF:000008', NULL, NULL, 'Translational activator of cytochrome c oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(36369, NULL, 'G3DSA:1.10.510.10:FF:003291', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36370, NULL, 'G3DSA:1.20.920.30:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36371, NULL, 'G3DSA:2.60.40.10:FF:005778', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(36372, NULL, 'G3DSA:1.20.930.80:FF:000002', NULL, NULL, 'DNA primase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(36373, NULL, 'G3DSA:1.10.3370.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36374, NULL, 'G3DSA:3.40.190.80:FF:000091', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(36375, NULL, 'G3DSA:3.30.70.330:FF:002534', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36376, NULL, 'G3DSA:1.25.40.10:FF:004709', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36377, NULL, 'G3DSA:2.30.29.30:FF:001167', NULL, NULL, 'AGAP010456-PA', NULL, NULL, NULL, NULL, NULL, 4),
(36378, NULL, 'G3DSA:3.40.50.1820:FF:000883', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(36379, NULL, 'G3DSA:3.30.420.10:FF:000360', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36380, NULL, 'G3DSA:3.30.160.60:FF:003850', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36381, NULL, 'G3DSA:1.20.920.10:FF:000071', NULL, NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(36382, NULL, 'G3DSA:1.20.1740.10:FF:000117', NULL, NULL, 'General amino-acid permease GAP1', NULL, NULL, NULL, NULL, NULL, 4),
(36383, NULL, 'G3DSA:3.30.160.60:FF:004250', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36384, NULL, 'G3DSA:1.10.30.10:FF:000072', NULL, NULL, 'FACT complex subunit SSRP1', NULL, NULL, NULL, NULL, NULL, 4),
(36385, NULL, 'G3DSA:3.40.50.300:FF:001198', NULL, NULL, 'GTPase HflX', NULL, NULL, NULL, NULL, NULL, 4),
(36386, NULL, 'G3DSA:1.20.140.10:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36387, NULL, 'G3DSA:1.10.287.540:FF:000001', NULL, NULL, 'Type IV pilus assembly protein PilO', NULL, NULL, NULL, NULL, NULL, 4),
(36388, NULL, 'G3DSA:2.20.110.10:FF:000073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36389, NULL, 'G3DSA:2.10.25.10:FF:000501', NULL, NULL, 'Crumbs 2, cell polarity complex component', NULL, NULL, NULL, NULL, NULL, 4),
(36390, NULL, 'G3DSA:1.10.287.110:FF:000114', NULL, NULL, 'SEC63 isoform 5', NULL, NULL, NULL, NULL, NULL, 4),
(36391, NULL, 'G3DSA:3.30.420.10:FF:000484', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36392, NULL, 'G3DSA:3.30.40.10:FF:000960', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36393, NULL, 'G3DSA:3.90.70.10:FF:000061', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(36394, NULL, 'G3DSA:3.40.50.1820:FF:001501', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36395, NULL, 'G3DSA:1.10.510.10:FF:003633', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36396, NULL, 'G3DSA:3.20.20.80:FF:000463', NULL, NULL, 'Spr1p', NULL, NULL, NULL, NULL, NULL, 4),
(36397, NULL, 'G3DSA:3.40.50.740:FF:000032', NULL, NULL, 'NADH-ubiquinone oxidoreductase 75 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(36398, NULL, 'G3DSA:3.40.50.12470:FF:000002', NULL, NULL, '2-oxoglutarate dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(36399, NULL, 'G3DSA:3.30.40.10:FF:001360', NULL, NULL, 'PHD finger protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(36400, NULL, 'G3DSA:3.30.1520.10:FF:000081', NULL, NULL, 'Sorting NeXin', NULL, NULL, NULL, NULL, NULL, 4),
(36401, NULL, 'G3DSA:3.40.50.300:FF:007960', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(36402, NULL, 'G3DSA:1.20.140.10:FF:000005', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(36403, NULL, 'G3DSA:3.80.10.10:FF:000945', NULL, NULL, 'Putative leucine-rich repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(36404, NULL, 'G3DSA:1.10.510.10:FF:004033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36405, NULL, 'G3DSA:2.30.110.10:FF:000037', NULL, NULL, 'F420H(2)-dependent quinone reductase Rv1261c', NULL, NULL, NULL, NULL, NULL, 4),
(36406, NULL, 'G3DSA:1.10.238.10:FF:000061', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(36407, NULL, 'G3DSA:1.25.10.10:FF:002398', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36408, NULL, 'G3DSA:2.40.290.10:FF:000036', NULL, NULL, 'AaceriAFR443Cp', NULL, NULL, NULL, NULL, NULL, 4),
(36409, NULL, 'G3DSA:1.20.1280.50:FF:000077', NULL, NULL, 'EIN3-binding F-box protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(36410, NULL, 'G3DSA:3.30.40.10:FF:000067', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(36411, NULL, 'G3DSA:3.100.10.20:FF:000001', NULL, NULL, 'CRISPR-associated endonuclease Cas1', NULL, NULL, NULL, NULL, NULL, 4),
(36412, NULL, 'G3DSA:3.60.10.10:FF:000316', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36413, NULL, 'G3DSA:3.10.20.90:FF:000332', NULL, NULL, 'Ubiquitin-40S ribosomal protein S27a', NULL, NULL, NULL, NULL, NULL, 4),
(36414, NULL, 'G3DSA:1.25.10.10:FF:003016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36415, NULL, 'G3DSA:3.30.860.10:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36416, NULL, 'G3DSA:1.20.58.60:FF:000892', NULL, NULL, 'Microtubule actin crosslinking factor 1a', NULL, NULL, NULL, NULL, NULL, 4),
(36417, NULL, 'G3DSA:1.25.40.10:FF:004024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36418, NULL, 'G3DSA:3.90.20.20:FF:000004', NULL, NULL, 'GrpE protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(36419, NULL, 'G3DSA:1.20.1090.10:FF:000045', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(36420, NULL, 'G3DSA:3.30.420.270:FF:000016', NULL, NULL, 'Tol-Pal system protein TolR', NULL, NULL, NULL, NULL, NULL, 4),
(36421, NULL, 'G3DSA:3.40.50.1100:FF:000105', NULL, NULL, '1-aminocyclopropane-1-carboxylate deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(36422, NULL, 'G3DSA:2.60.120.10:FF:000278', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(36423, NULL, 'G3DSA:3.10.50.40:FF:000061', NULL, NULL, 'FK506-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(36424, NULL, 'G3DSA:1.25.40.10:FF:003748', NULL, NULL, 'Tetratricopeptide repeat protein 21 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(36425, NULL, 'G3DSA:1.25.40.1040:FF:000020', NULL, NULL, 'Tetratricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(36426, NULL, 'G3DSA:1.25.40.10:FF:000314', NULL, NULL, 'rRNA biogenesis protein RRP5', NULL, NULL, NULL, NULL, NULL, 4),
(36427, NULL, 'G3DSA:3.40.50.1820:FF:000208', NULL, NULL, 'Adenosine deaminase CECR1-A', NULL, NULL, NULL, NULL, NULL, 4),
(36428, NULL, 'G3DSA:1.20.58.830:FF:000019', NULL, NULL, 'Merozoite surface protein duffy binding ligand 2', NULL, NULL, NULL, NULL, NULL, 4),
(36429, NULL, 'G3DSA:1.20.920.10:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36430, NULL, 'G3DSA:1.10.8.720:FF:000023', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(36431, NULL, 'G3DSA:3.30.505.10:FF:000057', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(36432, NULL, 'G3DSA:3.40.50.300:FF:002957', NULL, NULL, 'Mitochondrial RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(36433, NULL, 'G3DSA:1.50.40.10:FF:000357', NULL, NULL, 'Mitochondrial carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(36434, NULL, 'G3DSA:3.20.20.70:FF:000584', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36435, NULL, 'G3DSA:3.40.850.10:FF:000553', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36436, NULL, 'G3DSA:1.10.730.10:FF:000188', NULL, NULL, 'Leucine--tRNA ligase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(36437, NULL, 'G3DSA:2.130.10.10:FF:000040', NULL, NULL, 'echinoderm microtubule-associated protein-like 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(36438, NULL, 'G3DSA:2.60.40.150:FF:000026', NULL, NULL, 'dysferlin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(36439, NULL, 'G3DSA:2.70.170.10:FF:000054', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(36440, NULL, 'G3DSA:3.20.20.80:FF:000492', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36441, NULL, 'G3DSA:2.60.40.10:FF:002153', NULL, NULL, 'Lachesin', NULL, NULL, NULL, NULL, NULL, 4),
(36442, NULL, 'G3DSA:3.30.70.1230:FF:000124', NULL, NULL, 'Adenylate/guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(36443, NULL, 'G3DSA:3.40.50.740:FF:000003', NULL, NULL, 'Biotin sulfoxide reductase 2', NULL, NULL, NULL, NULL, NULL, 4),
(36444, NULL, 'G3DSA:3.40.50.150:FF:000040', NULL, NULL, 'Putative ribosomal RNA methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(36445, NULL, 'G3DSA:2.40.160.180:FF:000006', NULL, NULL, 'Porin', NULL, NULL, NULL, NULL, NULL, 4),
(36446, NULL, 'G3DSA:3.30.559.30:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36447, NULL, 'G3DSA:1.25.40.10:FF:002984', NULL, NULL, 'Os03g0369700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(36448, NULL, 'G3DSA:1.10.8.60:FF:000129', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(36449, NULL, 'G3DSA:1.25.40.20:FF:001885', NULL, NULL, 'Protein 21.1', NULL, NULL, NULL, NULL, NULL, 4),
(36450, NULL, 'G3DSA:2.130.10.30:FF:000046', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(36451, NULL, 'G3DSA:3.40.50.1820:FF:001422', NULL, NULL, 'Putative lipase YDL109C', NULL, NULL, NULL, NULL, NULL, 4),
(36452, NULL, 'G3DSA:3.30.540.30:FF:000009', NULL, NULL, 'Dipeptidyl peptidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(36453, NULL, 'G3DSA:1.10.510.10:FF:000031', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase kinase', NULL, NULL, NULL, NULL, NULL, 4),
(36454, NULL, 'G3DSA:3.60.10.10:FF:000075', NULL, NULL, 'Sphingomyelin phosphodiesterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(36455, NULL, 'G3DSA:2.40.10.10:FF:000011', NULL, NULL, 'Coagulation factor X', NULL, NULL, NULL, NULL, NULL, 4),
(36456, NULL, 'G3DSA:3.90.550.10:FF:000749', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36457, NULL, 'G3DSA:2.60.40.10:FF:003255', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36458, NULL, 'G3DSA:3.30.530.20:FF:000034', NULL, NULL, 'Crossveinless c, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(36459, NULL, 'G3DSA:1.10.520.20:FF:000006', NULL, NULL, 'ATP synthase subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(36460, NULL, 'G3DSA:3.40.1000.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36461, NULL, 'G3DSA:3.40.30.10:FF:000094', NULL, NULL, 'Glutathione S-transferase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(36462, NULL, 'G3DSA:3.40.50.300:FF:003093', NULL, NULL, 'ADP-ribosylation factor-like protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(36463, NULL, 'G3DSA:3.40.50.300:FF:004082', NULL, NULL, 'Peroxisomal biogenesis factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(36464, NULL, 'G3DSA:2.60.120.1440:FF:000017', NULL, NULL, 'Transmembrane sensor', NULL, NULL, NULL, NULL, NULL, 4),
(36465, NULL, 'G3DSA:1.10.630.10:FF:000624', NULL, NULL, 'Os05g0415900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(36466, NULL, 'G3DSA:1.10.287.70:FF:000175', NULL, NULL, 'small conductance calcium-activated potassium channel protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(36467, NULL, 'G3DSA:1.10.520.10:FF:000003', NULL, NULL, 'Cytosolic ascorbate peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(36468, NULL, 'G3DSA:2.130.10.10:FF:001142', NULL, NULL, 'Elongator complex protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(36469, NULL, 'G3DSA:3.40.50.2300:FF:000976', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36470, NULL, 'G3DSA:3.40.190.10:FF:000199', NULL, NULL, 'Sensor histidine kinase/response regulator EvgS', NULL, NULL, NULL, NULL, NULL, 4),
(36471, NULL, 'G3DSA:1.20.1070.10:FF:000448', NULL, NULL, 'G-protein coupled receptor homolog US28', NULL, NULL, NULL, NULL, NULL, 4),
(36472, NULL, 'G3DSA:1.20.1250.20:FF:000549', NULL, NULL, 'Inner membrane protein YbjJ', NULL, NULL, NULL, NULL, NULL, 4),
(36473, NULL, 'G3DSA:2.40.30.160:FF:000009', NULL, NULL, 'Putative transferase CAF17, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(36474, NULL, 'G3DSA:3.80.10.10:FF:002682', NULL, NULL, 'Phytosulfokine receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(36475, NULL, 'G3DSA:1.10.510.10:FF:003257', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36476, NULL, 'G3DSA:3.40.30.10:FF:001196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36477, NULL, 'G3DSA:1.25.10.10:FF:001375', NULL, NULL, 'Armadillo-type protein', NULL, NULL, NULL, NULL, NULL, 4),
(36478, NULL, 'G3DSA:1.20.58.480:FF:000004', NULL, NULL, 'Indoleamine 2,3-dioxygenase subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(36479, NULL, 'G3DSA:3.90.640.10:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36480, NULL, 'G3DSA:3.30.300.160:FF:000018', NULL, NULL, 'PilB/PulE/GspE family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(36481, NULL, 'G3DSA:1.10.238.10:FF:000105', NULL, NULL, 'Actinin, alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(36482, NULL, 'G3DSA:2.10.25.10:FF:000748', NULL, NULL, 'Vitamin K-dependent protein S', NULL, NULL, NULL, NULL, NULL, 4),
(36483, NULL, 'G3DSA:3.40.50.790:FF:000024', NULL, NULL, 'Mitochondrial ribosomal protein L1', NULL, NULL, NULL, NULL, NULL, 4),
(36484, NULL, 'G3DSA:3.30.342.10:FF:000004', NULL, NULL, 'DNA polymerase epsilon catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(36485, NULL, 'G3DSA:3.20.70.20:FF:000027', NULL, NULL, 'Ribonucleoside-diphosphate reductase large subunit-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(36486, NULL, 'G3DSA:1.20.58.60:FF:000655', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36487, NULL, 'G3DSA:1.25.40.10:FF:003973', NULL, NULL, 'Outer membrane protein assembly factor BamD', NULL, NULL, NULL, NULL, NULL, 4),
(36488, NULL, 'G3DSA:2.60.120.260:FF:000456', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36489, NULL, 'G3DSA:1.10.510.10:FF:002801', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36490, NULL, 'G3DSA:3.30.60.270:FF:000013', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(36491, NULL, 'G3DSA:2.30.30.1150:FF:000010', NULL, NULL, 'E3 ubiquitin-protein ligase UHRF1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(36492, NULL, 'G3DSA:2.30.29.30:FF:001291', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(36493, NULL, 'G3DSA:1.10.10.60:FF:001277', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36494, NULL, 'G3DSA:1.10.10.60:FF:001131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36495, NULL, 'G3DSA:1.10.287.1490:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36496, NULL, 'G3DSA:3.30.70.600:FF:000013', NULL, NULL, 'Mitochondrial Ribosomal Protein, Large', NULL, NULL, NULL, NULL, NULL, 4),
(36497, NULL, 'G3DSA:1.25.40.10:FF:003501', NULL, NULL, 'NADPH oxidase activator 1', NULL, NULL, NULL, NULL, NULL, 4),
(36498, NULL, 'G3DSA:1.20.120.350:FF:000133', NULL, NULL, 'cation channel sperm-associated protein 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(36499, NULL, 'G3DSA:1.20.5.650:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36500, NULL, 'G3DSA:2.30.30.380:FF:000015', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(36501, NULL, 'G3DSA:3.40.50.2000:FF:000358', NULL, NULL, 'ADP-heptose--LPS heptosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(36502, NULL, 'G3DSA:3.40.50.300:FF:005863', NULL, NULL, 'Putative RNA helicase armi-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(36503, NULL, 'G3DSA:1.25.40.10:FF:003647', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36504, NULL, 'G3DSA:3.30.160.720:FF:000001', NULL, NULL, 'Nuclease SbcCD subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(36505, NULL, 'G3DSA:3.40.250.10:FF:000024', NULL, NULL, 'Sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(36506, NULL, 'G3DSA:3.30.559.10:FF:000108', NULL, NULL, 'O-acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(36507, NULL, 'G3DSA:3.40.50.1010:FF:000050', NULL, NULL, 'RNA-binding protein NOB1, putative', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(36508, NULL, 'G3DSA:3.40.50.620:FF:000698', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36509, NULL, 'G3DSA:1.20.1050.10:FF:000239', NULL, NULL, 'Rho-class glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(36510, NULL, 'G3DSA:1.10.10.140:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36511, NULL, 'G3DSA:4.10.470.10:FF:000004', NULL, NULL, 'Ribosome-inactivating protein lychnin', NULL, NULL, NULL, NULL, NULL, 4),
(36512, NULL, 'G3DSA:3.40.50.2020:FF:000044', NULL, NULL, 'Pur operon repressor', NULL, NULL, NULL, NULL, NULL, 4),
(36513, NULL, 'G3DSA:2.10.220.10:FF:000038', NULL, NULL, 'Fraser extracellular matrix complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(36514, NULL, 'G3DSA:2.60.40.10:FF:005379', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36515, NULL, 'G3DSA:3.60.21.10:FF:000038', NULL, NULL, 'Probable inactive purple acid phosphatase 29', NULL, NULL, NULL, NULL, NULL, 4),
(36516, NULL, 'G3DSA:3.40.50.10190:FF:000032', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(36517, NULL, 'G3DSA:4.10.470.20:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36518, NULL, 'G3DSA:3.30.160.60:FF:002602', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36519, NULL, 'G3DSA:3.30.1600.10:FF:000042', NULL, NULL, 'Class IV sirtuin', NULL, NULL, NULL, NULL, NULL, 4),
(36520, NULL, 'G3DSA:3.80.10.10:FF:002356', NULL, NULL, 'F-box and leucine-rich repeat protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(36521, NULL, 'G3DSA:3.40.1190.20:FF:000083', NULL, NULL, 'ADP-dependent (S)-NAD(P)H-hydrate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(36522, NULL, 'G3DSA:2.130.10.10:FF:005357', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36523, NULL, 'G3DSA:3.30.200.20:FF:000487', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(36524, NULL, 'G3DSA:3.40.50.1010:FF:000196', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36525, NULL, 'G3DSA:1.10.1200.10:FF:000141', NULL, NULL, 'Fatty acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(36526, NULL, 'G3DSA:2.130.10.10:FF:003266', NULL, NULL, 'Putative WD-repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(36527, NULL, 'G3DSA:2.60.120.200:FF:000545', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36528, NULL, 'G3DSA:3.80.10.10:FF:004447', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase EFR', NULL, NULL, NULL, NULL, NULL, 4),
(36529, NULL, 'G3DSA:2.40.70.10:FF:000020', NULL, NULL, 'Aspartic proteinase-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(36530, NULL, 'G3DSA:3.40.30.10:FF:000740', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36531, NULL, 'G3DSA:1.20.140.10:FF:000112', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(36532, NULL, 'G3DSA:2.60.40.10:FF:005672', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36533, NULL, 'G3DSA:1.20.1250.20:FF:001331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36534, NULL, 'G3DSA:1.20.5.170:FF:000114', NULL, NULL, 'Tropomyosin', NULL, NULL, NULL, NULL, NULL, 4),
(36535, NULL, 'G3DSA:3.80.10.10:FF:000439', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', NULL, NULL, NULL, NULL, NULL, 4),
(36536, NULL, 'G3DSA:1.10.510.10:FF:001812', NULL, NULL, 'cAMP-dependent protein kinase catalytic subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(36537, NULL, 'G3DSA:1.20.1160.11:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36538, NULL, 'G3DSA:3.90.105.10:FF:000013', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(36539, NULL, 'G3DSA:1.10.2000.10:FF:000008', NULL, NULL, 'Frizzled receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(36540, NULL, 'G3DSA:3.30.460.10:FF:000115', NULL, NULL, 'Os01g0702900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(36541, NULL, 'G3DSA:2.10.25.10:FF:000602', NULL, NULL, 'Notch receptor protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(36542, NULL, 'G3DSA:3.30.160.60:FF:005149', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36543, NULL, 'G3DSA:1.10.8.60:FF:000281', NULL, NULL, 'Cell division cycle 48C', NULL, NULL, NULL, NULL, NULL, 4),
(36544, NULL, 'G3DSA:2.60.40.150:FF:000352', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36545, NULL, 'G3DSA:1.25.40.180:FF:000293', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36546, NULL, 'G3DSA:1.10.287.610:FF:000011', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(36547, NULL, 'G3DSA:3.30.160.60:FF:003058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36548, NULL, 'G3DSA:2.40.30.10:FF:000220', NULL, NULL, 'Elongation factor 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(36549, NULL, 'G3DSA:1.10.472.80:FF:000226', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36550, NULL, 'G3DSA:2.10.60.10:FF:000026', NULL, NULL, 'Secreted Ly-6/uPAR domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(36551, NULL, 'G3DSA:2.60.40.10:FF:001810', NULL, NULL, 'T cell receptor delta constant', NULL, NULL, NULL, NULL, NULL, 4),
(36552, NULL, 'G3DSA:2.20.100.10:FF:000185', NULL, NULL, 'AGAP012813-PA', NULL, NULL, NULL, NULL, NULL, 4),
(36553, NULL, 'G3DSA:3.40.50.300:FF:003772', NULL, NULL, 'Structural maintenance of chromosomes protein 6A', NULL, NULL, NULL, NULL, NULL, 4),
(36554, NULL, 'G3DSA:3.30.810.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36555, NULL, 'G3DSA:3.30.930.10:FF:000253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36556, NULL, 'G3DSA:3.10.20.90:FF:000989', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36557, NULL, 'G3DSA:3.30.565.10:FF:000201', NULL, NULL, 'Sensor histidine kinase/response regulator, putative (AFU_orthologue AFUA_4G01020)', NULL, NULL, NULL, NULL, NULL, 4),
(36558, NULL, 'G3DSA:3.90.105.20:FF:000016', NULL, NULL, 'Ribosome assembly factor mrt4', NULL, NULL, NULL, NULL, NULL, 4),
(36559, NULL, 'G3DSA:1.10.287.130:FF:000255', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(36560, NULL, 'G3DSA:3.40.50.620:FF:000226', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(36561, NULL, 'G3DSA:4.10.1060.10:FF:000054', NULL, NULL, 'Zn-finger (Ran-binding)-3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(36562, NULL, 'G3DSA:4.10.1000.10:FF:000045', NULL, NULL, 'Zinc finger, CCCH-type', NULL, NULL, NULL, NULL, NULL, 4),
(36563, NULL, 'G3DSA:3.30.420.270:FF:000033', NULL, NULL, 'Probable biopolymer transport ExbD protein', NULL, NULL, NULL, NULL, NULL, 4),
(36564, NULL, 'G3DSA:2.120.10.30:FF:000041', NULL, NULL, 'adipocyte plasma membrane-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(36565, NULL, 'G3DSA:3.40.50.1820:FF:000579', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(36566, NULL, 'G3DSA:1.20.1270.60:FF:000304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36567, NULL, 'G3DSA:3.30.1520.10:FF:000187', NULL, NULL, 'Nischarin-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(36568, NULL, 'G3DSA:2.30.30.140:FF:000174', NULL, NULL, 'GD18427', NULL, NULL, NULL, NULL, NULL, 4),
(36569, NULL, 'G3DSA:1.20.1310.20:FF:000021', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(36570, NULL, 'G3DSA:2.30.30.40:FF:000111', NULL, NULL, 'Rho guanine nucleotide exchange factor (GEF) 5', NULL, NULL, NULL, NULL, NULL, 4),
(36571, NULL, 'G3DSA:1.25.40.10:FF:001556', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36572, NULL, 'G3DSA:2.60.40.640:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36573, NULL, 'G3DSA:1.10.3380.10:FF:000064', NULL, NULL, 'Os02g0617500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(36574, NULL, 'G3DSA:3.30.450.60:FF:000051', NULL, NULL, 'AP-3 complex subunit mu', NULL, NULL, NULL, NULL, NULL, 4),
(36575, NULL, 'G3DSA:3.30.160.60:FF:005621', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(36576, NULL, 'G3DSA:1.10.565.10:FF:000090', NULL, NULL, 'AGAP000819-PA', NULL, NULL, NULL, NULL, NULL, 4),
(36577, NULL, 'G3DSA:1.10.150.20:FF:000197', NULL, NULL, 'AGAP007361-PA', NULL, NULL, NULL, NULL, NULL, 4),
(36578, NULL, 'G3DSA:3.20.10.10:FF:000015', NULL, NULL, 'Branched-chain amino acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(36579, NULL, 'G3DSA:2.60.40.200:FF:000002', NULL, NULL, 'Superoxide dismutase [Cu-Zn]', NULL, NULL, NULL, NULL, NULL, 4),
(36580, NULL, 'G3DSA:3.30.160.60:FF:004047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36581, NULL, 'G3DSA:3.40.630.30:FF:000109', NULL, NULL, 'Acetyltransferase, GNAT family', NULL, NULL, NULL, NULL, NULL, 4),
(36582, NULL, 'G3DSA:3.40.50.10810:FF:000111', NULL, NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(36583, NULL, 'G3DSA:1.25.40.20:FF:001559', NULL, NULL, 'Espin like', NULL, NULL, NULL, NULL, NULL, 4),
(36584, NULL, 'G3DSA:3.30.310.10:FF:000020', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(36585, NULL, 'G3DSA:1.10.10.10:FF:000121', NULL, NULL, 'ETS translocation variant 5', NULL, NULL, NULL, NULL, NULL, 4),
(36586, NULL, 'G3DSA:1.25.40.420:FF:000056', NULL, NULL, 'Eor-1', NULL, NULL, NULL, NULL, NULL, 4),
(36587, NULL, 'G3DSA:2.30.30.100:FF:000095', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm8', NULL, NULL, NULL, NULL, NULL, 4),
(36588, NULL, 'G3DSA:2.60.40.4330:FF:000002', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(36589, NULL, 'G3DSA:3.40.50.720:FF:000582', NULL, NULL, 'Dehydrogenase/reductase 7B', NULL, NULL, NULL, NULL, NULL, 4),
(36590, NULL, 'G3DSA:3.20.20.370:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36591, NULL, 'G3DSA:1.20.140.10:FF:000051', NULL, NULL, 'Acyl-CoA dehydrogenase FadE34', NULL, NULL, NULL, NULL, NULL, 4),
(36592, NULL, 'G3DSA:1.20.1080.10:FF:000067', NULL, NULL, 'Nitrite transporter NirC', NULL, NULL, NULL, NULL, NULL, 4),
(36593, NULL, 'G3DSA:2.60.40.10:FF:001490', NULL, NULL, 'Interleukin-4 receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(36594, NULL, 'G3DSA:3.40.190.10:FF:000878', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36595, NULL, 'G3DSA:4.10.400.10:FF:000056', NULL, NULL, 'Terribly reduced optic lobes, isoform AM', NULL, NULL, NULL, NULL, NULL, 4),
(36596, NULL, 'G3DSA:1.10.101.10:FF:000002', NULL, NULL, 'Matrix metalloproteinase-14 preproprotein', NULL, NULL, NULL, NULL, NULL, 4),
(36597, NULL, 'G3DSA:3.30.1360.40:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36598, NULL, 'G3DSA:1.10.510.10:FF:003903', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36599, NULL, 'G3DSA:1.10.10.10:FF:001902', NULL, NULL, 'Gll0305 protein', NULL, NULL, NULL, NULL, NULL, 4),
(36600, NULL, 'G3DSA:3.30.450.20:FF:000472', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(36601, NULL, 'G3DSA:3.30.9.10:FF:000202', NULL, NULL, 'sarcosine dehydrogenase, mitochondrial-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(36602, NULL, 'G3DSA:3.30.70.330:FF:002826', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36603, NULL, 'G3DSA:1.10.510.10:FF:003583', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36604, NULL, 'G3DSA:1.10.3060.10:FF:000017', NULL, NULL, 'Protein translocase subunit SecA 1', NULL, NULL, NULL, NULL, NULL, 4),
(36605, NULL, 'G3DSA:3.40.50.2000:FF:000684', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36606, NULL, 'G3DSA:3.40.50.720:FF:000902', NULL, NULL, 'Siroheme synthase component enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(36607, NULL, 'G3DSA:3.30.2410.10:FF:000033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36608, NULL, 'G3DSA:3.50.50.60:FF:001172', NULL, NULL, 'Probable electron transfer flavoprotein-ubiquinone oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(36609, NULL, 'G3DSA:1.20.1540.10:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(36610, NULL, 'G3DSA:3.90.180.10:FF:000029', NULL, NULL, 'Mitochondrial enoyl reductase', NULL, NULL, NULL, NULL, NULL, 4),
(36611, NULL, 'G3DSA:3.20.20.80:FF:000199', NULL, NULL, 'Glycoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(36612, NULL, 'G3DSA:3.30.70.330:FF:001224', NULL, NULL, 'RNA-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(36613, NULL, 'G3DSA:1.10.150.850:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36614, NULL, 'G3DSA:3.30.40.10:FF:000174', NULL, NULL, 'E3 ubiquitin-protein ligase MSL2', NULL, NULL, NULL, NULL, NULL, 4),
(36615, NULL, 'G3DSA:3.30.450.20:FF:000679', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36616, NULL, 'G3DSA:1.25.40.10:FF:002658', NULL, NULL, 'Coatomer subunit epsilon-2', NULL, NULL, NULL, NULL, NULL, 4),
(36617, NULL, 'G3DSA:2.170.260.10:FF:000020', NULL, NULL, 'Endoribonuclease Dicer-like', NULL, NULL, NULL, NULL, NULL, 4),
(36618, NULL, 'G3DSA:3.20.20.220:FF:000054', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(36619, NULL, 'G3DSA:3.90.79.20:FF:000010', NULL, NULL, 'MutT/nudix family protein', NULL, NULL, NULL, NULL, NULL, 4),
(36620, NULL, 'G3DSA:2.60.40.420:FF:000276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36621, NULL, 'G3DSA:2.60.40.10:FF:000236', NULL, NULL, 'Sidekick cell adhesion molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(36622, NULL, 'G3DSA:1.50.40.10:FF:000503', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36623, NULL, 'G3DSA:1.10.10.160:FF:000049', NULL, NULL, 'UvrD/REP helicase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(36624, NULL, 'G3DSA:2.60.40.10:FF:003581', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36625, NULL, 'G3DSA:3.30.60.30:FF:000130', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36626, NULL, 'G3DSA:3.20.20.140:FF:000182', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(36627, NULL, 'G3DSA:2.60.120.290:FF:000206', NULL, NULL, 'AGAP011910-PA', NULL, NULL, NULL, NULL, NULL, 4),
(36628, NULL, 'G3DSA:3.40.50.20:FF:000008', NULL, NULL, 'Synapsin III', NULL, NULL, NULL, NULL, NULL, 4),
(36629, NULL, 'G3DSA:2.60.40.10:FF:004070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36630, NULL, 'G3DSA:3.50.50.60:FF:000683', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36631, NULL, 'G3DSA:3.30.160.60:FF:005828', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36632, NULL, 'G3DSA:1.10.510.10:FF:001958', NULL, NULL, 'Kinase', NULL, NULL, NULL, NULL, NULL, 4),
(36633, NULL, 'G3DSA:3.40.50.300:FF:001529', NULL, NULL, 'Peroxisome biosynthesis protein-like protein (PAS1/Peroxin-1)', NULL, NULL, NULL, NULL, NULL, 4),
(36634, NULL, 'G3DSA:1.25.50.20:FF:000043', NULL, NULL, 'GD16024', NULL, NULL, NULL, NULL, NULL, 4),
(36635, NULL, 'G3DSA:1.10.30.10:FF:000004', NULL, NULL, 'Transcription factor SOX-10', NULL, NULL, NULL, NULL, NULL, 4),
(36636, NULL, 'G3DSA:1.25.40.120:FF:000056', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36637, NULL, 'G3DSA:3.30.420.10:FF:000495', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36638, NULL, 'G3DSA:2.40.50.90:FF:000054', NULL, NULL, 'Nuclease domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(36639, NULL, 'G3DSA:3.30.420.10:FF:000315', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36640, NULL, 'G3DSA:1.20.920.10:FF:000026', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(36641, NULL, 'G3DSA:2.10.25.10:FF:001676', NULL, NULL, 'Fibrillin-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(36642, NULL, 'G3DSA:3.40.1110.10:FF:000480', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36643, NULL, 'G3DSA:2.40.50.140:FF:000923', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36644, NULL, 'G3DSA:1.20.1270.280:FF:000012', NULL, NULL, 'Dynein heavy chain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(36645, NULL, 'G3DSA:2.130.10.10:FF:000214', NULL, NULL, 'WD repeat-containing protein 74', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(36646, NULL, 'G3DSA:3.40.718.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36647, NULL, 'G3DSA:3.40.350.10:FF:000088', NULL, NULL, 'Aminopeptidase P AmpP', NULL, NULL, NULL, NULL, NULL, 4),
(36648, NULL, 'G3DSA:3.90.550.10:FF:000103', NULL, NULL, 'Bacteriophage N4 adsorption protein B', NULL, NULL, NULL, NULL, NULL, 4),
(36649, NULL, 'G3DSA:1.20.5.350:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36650, NULL, 'G3DSA:1.20.120.350:FF:000072', NULL, NULL, 'Voltage-dependent T-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(36651, NULL, 'G3DSA:3.40.390.10:FF:000208', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36652, NULL, 'G3DSA:3.30.160.60:FF:002102', NULL, NULL, 'Zinc finger protein 33A', NULL, NULL, NULL, NULL, NULL, 4),
(36653, NULL, 'G3DSA:1.10.287.160:FF:000005', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(36654, NULL, 'G3DSA:3.30.200.20:FF:001622', NULL, NULL, 'Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(36655, NULL, 'G3DSA:3.80.10.10:FF:002856', NULL, NULL, 'RNI-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(36656, NULL, 'G3DSA:3.30.420.10:FF:000023', NULL, NULL, 'epithelial splicing regulatory protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(36657, NULL, 'G3DSA:1.10.8.10:FF:000047', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(36658, NULL, 'G3DSA:1.10.510.10:FF:001666', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(36659, NULL, 'G3DSA:3.40.190.10:FF:000671', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36660, NULL, 'G3DSA:3.30.70.1180:FF:000002', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(36661, NULL, 'G3DSA:1.20.1250.20:FF:001005', NULL, NULL, 'Uncharacterized MFS-type transporter MT1289', NULL, NULL, NULL, NULL, NULL, 4),
(36662, NULL, 'G3DSA:1.10.20.10:FF:000032', NULL, NULL, 'dr1-associated corepressor isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(36663, NULL, 'G3DSA:3.40.50.1700:FF:000043', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36664, NULL, 'G3DSA:1.10.630.10:FF:000450', NULL, NULL, 'Os10g0171300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(36665, NULL, 'G3DSA:3.90.1720.10:FF:000014', NULL, NULL, 'Peptidoglycan endopeptidase LytF', NULL, NULL, NULL, NULL, NULL, 4),
(36666, NULL, 'G3DSA:1.10.287.370:FF:000068', NULL, NULL, 'Prefoldin subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(36667, NULL, 'G3DSA:3.40.50.1010:FF:000224', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36668, NULL, 'G3DSA:1.20.120.160:FF:000048', NULL, NULL, 'Histidine containing phosphotransfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(36669, NULL, 'G3DSA:1.20.1560.10:FF:000295', NULL, NULL, 'MDR-like ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(36670, NULL, 'G3DSA:3.30.160.20:FF:000253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36671, NULL, 'G3DSA:1.20.1280.50:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36672, NULL, 'G3DSA:1.25.40.10:FF:003473', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g33170', NULL, NULL, NULL, NULL, NULL, 4),
(36673, NULL, 'G3DSA:2.40.50.140:FF:000569', NULL, NULL, 'WGS project CABT00000000 data, contig 2.17', NULL, NULL, NULL, NULL, NULL, 4),
(36674, NULL, 'G3DSA:3.40.30.10:FF:000268', NULL, NULL, 'Thioredoxin domain-containing protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(36675, NULL, 'G3DSA:3.40.50.10190:FF:000239', NULL, NULL, 'Auxin-responsive protein', NULL, NULL, NULL, NULL, NULL, 4),
(36676, NULL, 'G3DSA:3.30.160.60:FF:003384', NULL, NULL, 'Zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(36677, NULL, 'G3DSA:2.10.25.10:FF:000574', NULL, NULL, 'laminin subunit alpha-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(36678, NULL, 'G3DSA:2.40.440.10:FF:000014', NULL, NULL, 'Enhanced entry protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(36679, NULL, 'G3DSA:3.40.50.620:FF:000198', NULL, NULL, 'GMP synthase (Glutamine-hydrolyzing) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(36680, NULL, 'G3DSA:3.40.50.620:FF:000552', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(36681, NULL, 'G3DSA:3.60.10.10:FF:000249', NULL, NULL, 'Endonuclease/Exonuclease/phosphatase family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(36682, NULL, 'G3DSA:3.40.1350.100:FF:000005', NULL, NULL, 'Apicoplast TIC22 protein', NULL, NULL, NULL, NULL, NULL, 4),
(36683, NULL, 'G3DSA:3.40.50.1000:FF:000221', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(36684, NULL, 'G3DSA:3.40.50.200:FF:000162', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36685, NULL, 'G3DSA:1.20.58.60:FF:000594', NULL, NULL, 'Dystrophin', NULL, NULL, NULL, NULL, NULL, 4),
(36686, NULL, 'G3DSA:1.10.10.440:FF:000010', NULL, NULL, 'Transcription elongation regulator 1 (CA150)', NULL, NULL, NULL, NULL, NULL, 4),
(36687, NULL, 'G3DSA:2.60.40.60:FF:000875', NULL, NULL, 'E-cadherin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(36688, NULL, 'G3DSA:3.40.720.10:FF:000341', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36689, NULL, 'G3DSA:3.30.70.330:FF:001724', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36690, NULL, 'G3DSA:2.10.50.10:FF:000054', NULL, NULL, 'UPF0577 protein KIAA1324 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(36691, NULL, 'G3DSA:3.30.720.170:FF:000003', NULL, NULL, 'Perilipin', NULL, NULL, NULL, NULL, NULL, 4),
(36692, NULL, 'G3DSA:2.60.40.10:FF:005851', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36693, NULL, 'G3DSA:2.130.10.10:FF:001349', NULL, NULL, 'AGAP002088-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(36694, NULL, 'G3DSA:2.130.10.10:FF:004868', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36695, NULL, 'G3DSA:2.60.40.10:FF:001338', NULL, NULL, 'MILR1 isoform 7', NULL, NULL, NULL, NULL, NULL, 4),
(36696, NULL, 'G3DSA:1.10.533.10:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36697, NULL, 'G3DSA:2.10.70.10:FF:000263', NULL, NULL, 'Pappalysin 2', NULL, NULL, NULL, NULL, NULL, 4),
(36698, NULL, 'G3DSA:2.30.29.30:FF:000655', NULL, NULL, 'FERM domain (Protein4.1-ezrin-radixin-moesin) family', NULL, NULL, NULL, NULL, NULL, 4),
(36699, NULL, 'G3DSA:3.40.50.300:FF:000220', NULL, NULL, 'ATP-dependent protease ATPase subunit HslU', NULL, NULL, NULL, NULL, NULL, 4),
(36700, NULL, 'G3DSA:3.40.50.720:FF:000256', NULL, NULL, 'Trk system potassium transporter TrkA', NULL, NULL, NULL, NULL, NULL, 4),
(36701, NULL, 'G3DSA:3.40.50.10900:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36702, NULL, 'G3DSA:4.10.1130.20:FF:000001', NULL, NULL, 'Cysteine and histidine-rich domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(36703, NULL, 'G3DSA:2.60.120.10:FF:000042', NULL, NULL, 'Hypoxia-inducible factor 1-alpha inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(36704, NULL, 'G3DSA:1.20.58.770:FF:000001', NULL, NULL, 'Surface layer (S-layer) glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(36705, NULL, 'G3DSA:2.30.39.10:FF:000116', NULL, NULL, 'Serpin family I member 2', NULL, NULL, NULL, NULL, NULL, 4),
(36706, NULL, 'G3DSA:3.40.50.300:FF:008151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36707, NULL, 'G3DSA:2.60.120.10:FF:000660', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36708, NULL, 'G3DSA:3.90.660.10:FF:000078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36709, NULL, 'G3DSA:1.25.10.10:FF:002510', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36710, NULL, 'G3DSA:2.40.170.20:FF:000007', NULL, NULL, 'Ferric aerobactin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(36711, NULL, 'G3DSA:1.20.990.10:FF:000007', NULL, NULL, 'Methionine synthase reductase', NULL, NULL, NULL, NULL, NULL, 4),
(36712, NULL, 'G3DSA:1.10.630.10:FF:000124', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(36713, NULL, 'G3DSA:3.40.50.300:FF:000074', NULL, NULL, 'Multidrug resistance-associated protein 5 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(36714, NULL, 'G3DSA:3.40.50.880:FF:000051', NULL, NULL, 'Glutathione-independent glyoxalase HSP31', NULL, NULL, NULL, NULL, NULL, 4),
(36715, NULL, 'G3DSA:3.30.980.10:FF:000025', NULL, NULL, 'Alanyl-tRNA editing protein AlaX-M', NULL, NULL, NULL, NULL, NULL, 4),
(36716, NULL, 'G3DSA:1.25.40.10:FF:002012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36717, NULL, 'G3DSA:3.40.50.10930:FF:000001', NULL, NULL, 'RecBCD enzyme subunit RecC', NULL, NULL, NULL, NULL, NULL, 4),
(36718, NULL, 'G3DSA:3.30.40.10:FF:001163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36719, NULL, 'G3DSA:2.30.30.490:FF:000048', NULL, NULL, 'DNA methyltransferase Dim-2', NULL, NULL, NULL, NULL, NULL, 4),
(36720, NULL, 'G3DSA:2.30.42.10:FF:000495', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36721, NULL, 'G3DSA:3.30.565.10:FF:000055', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(36722, NULL, 'G3DSA:2.60.120.340:FF:000036', NULL, NULL, 'Nucleophosmin/nucleoplasmin, 3', NULL, NULL, NULL, NULL, NULL, 4),
(36723, NULL, 'G3DSA:1.10.8.720:FF:000028', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(36724, NULL, 'G3DSA:3.90.245.10:FF:000023', NULL, NULL, 'Inosine-uridine nucleoside N-ribohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(36725, NULL, 'G3DSA:2.80.10.50:FF:000150', NULL, NULL, 'Otogelin', NULL, NULL, NULL, NULL, NULL, 4),
(36726, NULL, 'G3DSA:3.20.20.80:FF:000699', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36727, NULL, 'G3DSA:1.50.40.10:FF:000149', NULL, NULL, 'Mitochondrial Carrier (MC) Family', NULL, NULL, NULL, NULL, NULL, 4),
(36728, NULL, 'G3DSA:3.30.450.20:FF:000179', NULL, NULL, 'PAS domain-containing sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(36729, NULL, 'G3DSA:3.40.1160.10:FF:000073', NULL, NULL, 'Delta-1-pyrroline-5-carboxylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(36730, NULL, 'G3DSA:3.40.50.11260:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36731, NULL, 'G3DSA:3.40.50.300:FF:001794', NULL, NULL, 'Eukaryotic translation initiation factor 2 subunit 3, variant', NULL, NULL, NULL, NULL, NULL, 4),
(36732, NULL, 'G3DSA:3.40.630.150:FF:000014', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36733, NULL, 'G3DSA:2.60.40.10:FF:005407', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36734, NULL, 'G3DSA:2.60.120.330:FF:000033', NULL, NULL, 'Clavaminate synthase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(36735, NULL, 'G3DSA:3.40.50.150:FF:001288', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36736, NULL, 'G3DSA:1.20.5.340:FF:000013', NULL, NULL, 'Myosin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(36737, NULL, 'G3DSA:3.30.70.330:FF:000909', NULL, NULL, 'Putative U2 snRNP component IST3', NULL, NULL, NULL, NULL, NULL, 4),
(36738, NULL, 'G3DSA:3.30.710.10:FF:000388', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36739, NULL, 'G3DSA:2.130.10.10:FF:005683', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36740, NULL, 'G3DSA:3.90.1150.10:FF:000459', NULL, NULL, 'Aminotransferase, classes I and II', NULL, NULL, NULL, NULL, NULL, 4),
(36741, NULL, 'G3DSA:3.40.720.10:FF:000015', NULL, NULL, 'GPI ethanolamine phosphate transferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(36742, NULL, 'G3DSA:1.50.10.10:FF:000029', NULL, NULL, 'Family 65 glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(36743, NULL, 'G3DSA:1.20.1250.20:FF:000875', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36744, NULL, 'G3DSA:3.40.50.300:FF:003946', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36745, NULL, 'G3DSA:3.40.30.10:FF:001111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36746, NULL, 'G3DSA:1.10.4020.10:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(36747, NULL, 'G3DSA:1.20.1250.20:FF:001977', NULL, NULL, 'Transmembrane transporter, major facilitator family', NULL, NULL, NULL, NULL, NULL, 4),
(36748, NULL, 'G3DSA:2.40.50.140:FF:000895', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36749, NULL, 'G3DSA:3.40.50.10490:FF:000150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36750, NULL, 'G3DSA:3.40.50.2300:FF:000358', NULL, NULL, 'Two-component system response regulator VanR', NULL, NULL, NULL, NULL, NULL, 4),
(36751, NULL, 'G3DSA:3.30.420.10:FF:000641', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36752, NULL, 'G3DSA:1.10.1520.10:FF:000036', NULL, NULL, 'Ribonuclease 3-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(36753, NULL, 'G3DSA:3.80.10.10:FF:001900', NULL, NULL, 'FI21465p1', NULL, NULL, NULL, NULL, NULL, 4),
(36754, NULL, 'G3DSA:1.20.1730.10:FF:000095', NULL, NULL, 'SGLT-1', NULL, NULL, NULL, NULL, NULL, 4),
(36755, NULL, 'G3DSA:1.10.1790.20:FF:000002', NULL, NULL, 'DNA-directed RNA polymerase subunit beta''''', NULL, NULL, NULL, NULL, NULL, 4),
(36756, NULL, 'G3DSA:2.30.42.10:FF:000169', NULL, NULL, 'FERM and PDZ domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(36757, NULL, 'G3DSA:1.20.120.1320:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36758, NULL, 'G3DSA:1.10.472.80:FF:000052', NULL, NULL, 'Putative TBC domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(36759, NULL, 'G3DSA:1.10.287.130:FF:000081', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(36760, NULL, 'G3DSA:3.40.720.10:FF:000369', NULL, NULL, 'Os03g0852800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(36761, NULL, 'G3DSA:3.40.1110.10:FF:000154', NULL, NULL, 'Putative P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(36762, NULL, 'G3DSA:3.10.20.90:FF:000051', NULL, NULL, 'Unconventional myosin-VIIa', NULL, NULL, NULL, NULL, NULL, 4),
(36763, NULL, 'G3DSA:3.30.70.270:FF:000077', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(36764, NULL, 'G3DSA:3.40.630.30:FF:000082', NULL, NULL, 'Acetyltransferase, GNAT family', NULL, NULL, NULL, NULL, NULL, 4),
(36765, NULL, 'G3DSA:2.30.40.10:FF:000007', NULL, NULL, 'Dihydroorotase', NULL, NULL, NULL, NULL, NULL, 4),
(36766, NULL, 'G3DSA:2.70.130.10:FF:000080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36767, NULL, 'G3DSA:3.20.20.70:FF:000163', NULL, NULL, 'Transaldolase B', NULL, NULL, NULL, NULL, NULL, 4),
(36768, NULL, 'G3DSA:3.30.200.20:FF:000779', NULL, NULL, 'Os09g0251100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(36769, NULL, 'G3DSA:3.40.1800.20:FF:000013', NULL, NULL, 'AGAP011758-PA', NULL, NULL, NULL, NULL, NULL, 4),
(36770, NULL, 'G3DSA:3.10.20.410:FF:000012', NULL, NULL, 'Heat shock protein E', NULL, NULL, NULL, NULL, NULL, 4),
(36771, NULL, 'G3DSA:3.30.230.10:FF:000278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36772, NULL, 'G3DSA:1.10.1040.50:FF:000005', NULL, NULL, 'Probable 3-hydroxyacyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(36773, NULL, 'G3DSA:2.10.25.10:FF:000248', NULL, NULL, 'pikachurin isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(36774, NULL, 'G3DSA:3.30.930.10:FF:000106', NULL, NULL, 'Serine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(36775, NULL, 'G3DSA:1.10.8.60:FF:000455', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36776, NULL, 'G3DSA:3.30.9.10:FF:000056', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(36777, NULL, 'G3DSA:1.10.390.10:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36778, NULL, 'G3DSA:3.30.70.260:FF:000074', NULL, NULL, 'Os10g0523700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(36779, NULL, 'G3DSA:3.30.40.10:FF:002298', NULL, NULL, 'Probable ubiquitin carboxyl-terminal hydrolase 7', NULL, NULL, NULL, NULL, NULL, 4),
(36780, NULL, 'G3DSA:1.20.1440.340:FF:000007', NULL, NULL, 'Ribosomal protein S5 domain 2-type protein', NULL, NULL, NULL, NULL, NULL, 4),
(36781, NULL, 'G3DSA:3.30.470.10:FF:000026', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(36782, NULL, 'G3DSA:3.40.50.1820:FF:000287', NULL, NULL, 'Steryl ester hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(36783, NULL, 'G3DSA:2.10.250.10:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36784, NULL, 'G3DSA:3.40.605.10:FF:000118', NULL, NULL, 'Succinate semialdehyde dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(36785, NULL, 'G3DSA:3.40.50.300:FF:001176', NULL, NULL, 'Adenylate kinase isoenzyme 5', NULL, NULL, NULL, NULL, NULL, 4),
(36786, NULL, 'G3DSA:3.30.1610.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36787, NULL, 'G3DSA:4.10.240.10:FF:000167', NULL, NULL, 'Negative regulator of pleiotropic drug resistance STB5', NULL, NULL, NULL, NULL, NULL, 4),
(36788, NULL, 'G3DSA:2.60.200.30:FF:000021', NULL, NULL, 'NADH kinase, variant 3', NULL, NULL, NULL, NULL, NULL, 4),
(36789, NULL, 'G3DSA:1.10.510.10:FF:004100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36790, NULL, 'G3DSA:3.90.190.10:FF:000620', NULL, NULL, 'Protein-tyrosine-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(36791, NULL, 'G3DSA:1.10.510.10:FF:003611', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36792, NULL, 'G3DSA:2.30.29.30:FF:000829', NULL, NULL, 'TBC1 domain family member 9', NULL, NULL, NULL, NULL, NULL, 4),
(36793, NULL, 'G3DSA:3.20.20.140:FF:000474', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36794, NULL, 'G3DSA:1.10.10.10:FF:001077', NULL, NULL, 'Os01g0753300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(36795, NULL, 'G3DSA:1.50.40.10:FF:000475', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36796, NULL, 'G3DSA:2.130.10.10:FF:003912', NULL, NULL, 'AGAP008550-PA', NULL, NULL, NULL, NULL, NULL, 4),
(36797, NULL, 'G3DSA:3.20.20.140:FF:000210', NULL, NULL, 'Deoxyribonuclease tatD', NULL, NULL, NULL, NULL, NULL, 4),
(36798, NULL, 'G3DSA:3.40.50.300:FF:005537', NULL, NULL, 'At1g03030', NULL, NULL, NULL, NULL, NULL, 4),
(36799, NULL, 'G3DSA:3.30.420.40:FF:000037', NULL, NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(36800, NULL, 'G3DSA:1.25.40.10:FF:004575', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36801, NULL, 'G3DSA:1.10.238.10:FF:000431', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(36802, NULL, 'G3DSA:3.30.1370.210:FF:000001', NULL, NULL, 'Muscleblind-like 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(36803, NULL, 'G3DSA:3.10.580.10:FF:000106', NULL, NULL, 'Putative manganese-dependent inorganic pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(36804, NULL, 'G3DSA:2.130.10.10:FF:001760', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36805, NULL, 'G3DSA:1.25.10.60:FF:000001', NULL, NULL, 'Rad61p', NULL, NULL, NULL, NULL, NULL, 4),
(36806, NULL, 'G3DSA:2.60.40.10:FF:003873', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36807, NULL, 'G3DSA:3.20.20.190:FF:000090', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(36808, NULL, 'G3DSA:3.30.2320.80:FF:000002', NULL, NULL, 'Hydrogenase maturation factor HypA', NULL, NULL, NULL, NULL, NULL, 4),
(36809, NULL, 'G3DSA:1.10.1420.10:FF:000152', NULL, NULL, 'MutS domain III family protein', NULL, NULL, NULL, NULL, NULL, 4),
(36810, NULL, 'G3DSA:3.40.50.410:FF:000135', NULL, NULL, 'Alpha-protein kinase vwkA', NULL, NULL, NULL, NULL, NULL, 4),
(36811, NULL, 'G3DSA:3.40.720.10:FF:000162', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36812, NULL, 'G3DSA:1.25.10.70:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36813, NULL, 'G3DSA:3.40.50.2000:FF:000858', NULL, NULL, 'Glycogen synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(36814, NULL, 'G3DSA:2.60.40.10:FF:001664', NULL, NULL, 'Hemicentin 2', NULL, NULL, NULL, NULL, NULL, 4),
(36815, NULL, 'G3DSA:2.60.40.60:FF:000083', NULL, NULL, 'Desmoglein 1', NULL, NULL, NULL, NULL, NULL, 4),
(36816, NULL, 'G3DSA:1.25.10.10:FF:001049', NULL, NULL, 'HEAT repeat-containing protein 5A', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(36817, NULL, 'G3DSA:1.10.287.70:FF:000528', NULL, NULL, 'Ion transport 2 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(36818, NULL, 'G3DSA:3.30.1780.10:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36819, NULL, 'G3DSA:1.20.1260.100:FF:000001', NULL, NULL, 'translocator protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(36820, NULL, 'G3DSA:1.20.1270.60:FF:000012', NULL, NULL, 'Sorting nexin 2', NULL, NULL, NULL, NULL, NULL, 4),
(36821, NULL, 'G3DSA:2.10.25.10:FF:000395', NULL, NULL, 'Dumpy, isoform P', NULL, NULL, NULL, NULL, NULL, 4),
(36822, NULL, 'G3DSA:2.170.300.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36823, NULL, 'G3DSA:3.80.10.10:FF:003053', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36824, NULL, 'G3DSA:3.10.490.20:FF:000023', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(36825, NULL, 'G3DSA:1.10.510.10:FF:003875', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36826, NULL, 'G3DSA:1.20.1260.110:FF:000004', NULL, NULL, 'DNA integrity scanning protein DisA', NULL, NULL, NULL, NULL, NULL, 4),
(36827, NULL, 'G3DSA:1.20.120.1240:FF:000082', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36828, NULL, 'G3DSA:1.25.40.20:FF:000132', NULL, NULL, 'M-phase phosphoprotein 8 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(36829, NULL, 'G3DSA:2.30.29.30:FF:001111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36830, NULL, 'G3DSA:3.40.50.12160:FF:000033', NULL, NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(36831, NULL, 'G3DSA:1.20.5.490:FF:000007', NULL, NULL, 'Nuclear pore complex protein Nup54', NULL, NULL, NULL, NULL, NULL, 4),
(36832, NULL, 'G3DSA:3.40.630.30:FF:000048', NULL, NULL, 'Glucosamine 6-phosphate N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(36833, NULL, 'G3DSA:2.30.110.10:FF:000020', NULL, NULL, 'PNPO isoform 11', NULL, NULL, NULL, NULL, NULL, 4),
(36834, NULL, 'G3DSA:3.30.160.60:FF:005593', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36835, NULL, 'G3DSA:1.20.58.60:FF:000476', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(36836, NULL, 'G3DSA:3.30.1370.50:FF:000024', NULL, NULL, 'Fgr44p', NULL, NULL, NULL, NULL, NULL, 4),
(36837, NULL, 'G3DSA:3.40.50.1440:FF:000004', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(36838, NULL, 'G3DSA:1.10.10.10:FF:001548', NULL, NULL, 'Apaf-1/CED-4-related caspase activator Dapaf-1S', NULL, NULL, NULL, NULL, NULL, 4),
(36839, NULL, 'G3DSA:1.20.1250.20:FF:000903', NULL, NULL, 'Solute carrier family 22 member 13', NULL, NULL, NULL, NULL, NULL, 4),
(36840, NULL, 'G3DSA:3.40.120.10:FF:000020', NULL, NULL, 'Phosphoglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(36841, NULL, 'G3DSA:1.25.10.10:FF:003319', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(36842, NULL, 'G3DSA:3.30.1330.40:FF:000013', NULL, NULL, 'Chorismate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(36843, NULL, 'G3DSA:2.130.10.10:FF:000332', NULL, NULL, 'glutamate-rich WD repeat-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(36844, NULL, 'G3DSA:3.50.30.30:FF:000105', NULL, NULL, 'Putative N-acetylated-alpha-linked acidic dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(36845, NULL, 'G3DSA:3.10.20.90:FF:000017', NULL, NULL, 'partitioning defective 3 homolog isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(36846, NULL, 'G3DSA:3.30.1740.10:FF:000018', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(36847, NULL, 'G3DSA:3.40.50.1450:FF:000007', NULL, NULL, 'Hydrogenase maturation protease', NULL, NULL, NULL, NULL, NULL, 4),
(36848, NULL, 'G3DSA:3.55.40.10:FF:000005', NULL, NULL, 'Type 4 fimbrial biogenesis protein FimT', NULL, NULL, NULL, NULL, NULL, 4),
(36849, NULL, 'G3DSA:3.30.1330.30:FF:000010', NULL, NULL, 'tRNA/rRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(36850, NULL, 'G3DSA:3.40.720.10:FF:000223', NULL, NULL, 'Probable sulfatase atsG', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(36851, NULL, 'G3DSA:1.25.50.20:FF:000104', NULL, NULL, 'GH14075p', NULL, NULL, NULL, NULL, NULL, 4),
(36852, NULL, 'G3DSA:3.40.50.2000:FF:000712', NULL, NULL, 'Mannosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(36853, NULL, 'G3DSA:3.40.1110.10:FF:000362', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36854, NULL, 'G3DSA:2.60.40.1390:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36855, NULL, 'G3DSA:1.20.1070.10:FF:001145', NULL, NULL, 'growth hormone secretagogue receptor type 1-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(36856, NULL, 'G3DSA:3.30.60.90:FF:000007', NULL, NULL, 'Next to BRCA1 gene 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(36857, NULL, 'G3DSA:3.40.50.1820:FF:001130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36858, NULL, 'G3DSA:1.10.1200.10:FF:000169', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36859, NULL, 'G3DSA:3.50.50.60:FF:001054', NULL, NULL, 'Sulfide quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(36860, NULL, 'G3DSA:2.40.50.100:FF:000113', NULL, NULL, 'Membrane fusion protein (MFP) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(36861, NULL, 'G3DSA:3.40.190.10:FF:000114', NULL, NULL, 'Amino acid ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(36862, NULL, 'G3DSA:3.90.190.10:FF:000474', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36863, NULL, 'G3DSA:3.40.50.410:FF:000253', NULL, NULL, 'ANTXR cell adhesion molecule 1d', NULL, NULL, NULL, NULL, NULL, 4),
(36864, NULL, 'G3DSA:2.130.10.10:FF:005065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36865, NULL, 'G3DSA:3.40.1280.30:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36866, NULL, 'G3DSA:3.30.70.1730:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36867, NULL, 'G3DSA:3.40.50.300:FF:003385', NULL, NULL, 'tRNA dimethylallyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(36868, NULL, 'G3DSA:3.40.50.300:FF:003328', NULL, NULL, 'ISMt2 transposase B', NULL, NULL, NULL, NULL, NULL, 4),
(36869, NULL, 'G3DSA:3.10.50.40:FF:000032', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(36870, NULL, 'G3DSA:1.20.1270.60:FF:000276', NULL, NULL, 'Dip13 beta, putative', NULL, NULL, NULL, NULL, NULL, 4),
(36871, NULL, 'G3DSA:2.60.120.430:FF:000029', NULL, NULL, 'F-box only protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(36872, NULL, 'G3DSA:1.10.10.160:FF:000050', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(36873, NULL, 'G3DSA:1.25.40.20:FF:001705', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36874, NULL, 'G3DSA:1.10.150.50:FF:000239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36875, NULL, 'G3DSA:1.25.40.10:FF:001702', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(36876, NULL, 'G3DSA:3.30.465.10:FF:000076', NULL, NULL, 'FAD linked oxidase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(36877, NULL, 'G3DSA:3.80.10.10:FF:001400', NULL, NULL, 'KEKKON4', NULL, NULL, NULL, NULL, NULL, 4),
(36878, NULL, 'G3DSA:3.40.50.1820:FF:000079', NULL, NULL, 'Abhydrolase domain-containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(36879, NULL, 'G3DSA:3.30.160.60:FF:003558', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36880, NULL, 'G3DSA:3.40.50.300:FF:000102', NULL, NULL, 'RNA helicase, activating signal cointegrator 1', NULL, NULL, NULL, NULL, NULL, 4),
(36881, NULL, 'G3DSA:3.10.350.10:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36882, NULL, 'G3DSA:2.10.90.10:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36883, NULL, 'G3DSA:1.10.287.470:FF:000008', NULL, NULL, 'HlyD family efflux transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(36884, NULL, 'G3DSA:3.10.290.10:FF:000005', NULL, NULL, '40S ribosomal protein S9', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(36885, NULL, 'G3DSA:1.20.1270.60:FF:000219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36886, NULL, 'G3DSA:3.30.365.10:FF:000074', NULL, NULL, 'AGAP006220-PA', NULL, NULL, NULL, NULL, NULL, 4),
(36887, NULL, 'G3DSA:3.30.160.60:FF:001259', NULL, NULL, 'Zinc finger protein 697', NULL, NULL, NULL, NULL, NULL, 4),
(36888, NULL, 'G3DSA:1.10.730.10:FF:000103', NULL, NULL, 'GM25865', NULL, NULL, NULL, NULL, NULL, 4),
(36889, NULL, 'G3DSA:1.10.10.60:FF:000849', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36890, NULL, 'G3DSA:2.130.10.130:FF:000031', NULL, NULL, 'Phosphatidylinositol-glycan-specific phospholipase D', NULL, NULL, NULL, NULL, NULL, 4),
(36891, NULL, 'G3DSA:2.60.40.10:FF:001456', NULL, NULL, 'CD101 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(36892, NULL, 'G3DSA:2.30.30.140:FF:000202', NULL, NULL, 'Tudor, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(36893, NULL, 'G3DSA:3.40.80.10:FF:000007', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase XlyA', NULL, NULL, NULL, NULL, NULL, 4),
(36894, NULL, 'G3DSA:3.20.20.80:FF:000727', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36895, NULL, 'G3DSA:2.60.120.820:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36896, NULL, 'G3DSA:3.20.20.140:FF:000002', NULL, NULL, 'AMP deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(36897, NULL, 'G3DSA:3.10.290.20:FF:000008', NULL, NULL, 'SUMO-activating enzyme subunit', NULL, NULL, NULL, NULL, NULL, 4),
(36898, NULL, 'G3DSA:3.40.50.300:FF:004317', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36899, NULL, 'G3DSA:1.20.58.2220:FF:000053', NULL, NULL, 'FMN2 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(36900, NULL, 'G3DSA:2.40.270.10:FF:000006', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(36901, NULL, 'G3DSA:3.30.240.40:FF:000001', NULL, NULL, 'Protein E6', NULL, NULL, NULL, NULL, NULL, 4),
(36902, NULL, 'G3DSA:3.20.20.70:FF:000724', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36903, NULL, 'G3DSA:3.40.50.1100:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36904, NULL, 'G3DSA:3.20.20.190:FF:000056', NULL, NULL, 'Ankyrin repeat protein nuc-2', NULL, NULL, NULL, NULL, NULL, 4),
(36905, NULL, 'G3DSA:3.80.10.10:FF:000883', NULL, NULL, 'RAN GTPase-activating protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(36906, NULL, 'G3DSA:3.40.190.80:FF:000028', NULL, NULL, 'Fructose-1,6-bisphosphatase class 1', NULL, NULL, NULL, NULL, NULL, 4),
(36907, NULL, 'G3DSA:3.10.20.70:FF:000011', NULL, NULL, 'Glutamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(36908, NULL, 'G3DSA:3.40.605.10:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36909, NULL, 'G3DSA:1.10.287.70:FF:000562', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36910, NULL, 'G3DSA:3.30.160.60:FF:001793', NULL, NULL, 'Blast:Protein drumstick', NULL, NULL, NULL, NULL, NULL, 4),
(36911, NULL, 'G3DSA:3.40.50.150:FF:001434', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36912, NULL, 'G3DSA:3.30.460.10:FF:000087', NULL, NULL, 'Poly(A) RNA polymerase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(36913, NULL, 'G3DSA:3.60.10.10:FF:000367', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36914, NULL, 'G3DSA:2.30.42.10:FF:000523', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36915, NULL, 'G3DSA:2.60.40.1360:FF:000010', NULL, NULL, 'Lysosomal alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(36916, NULL, 'G3DSA:3.40.710.10:FF:000043', NULL, NULL, 'Penicillin-binding protein 2A', NULL, NULL, NULL, NULL, NULL, 4),
(36917, NULL, 'G3DSA:3.20.20.140:FF:000148', NULL, NULL, 'D-hydantoinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(36918, NULL, 'G3DSA:2.60.40.10:FF:005087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36919, NULL, 'G3DSA:2.30.29.30:FF:000268', NULL, NULL, 'Rho guanine nucleotide exchange factor 17', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(36920, NULL, 'G3DSA:3.40.630.10:FF:000042', NULL, NULL, 'Peptide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(36921, NULL, 'G3DSA:3.40.910.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36922, NULL, 'G3DSA:2.60.120.10:FF:000216', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(36923, NULL, 'G3DSA:1.20.1560.10:FF:000856', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36924, NULL, 'G3DSA:3.40.50.360:FF:000070', NULL, NULL, 'Bifunctional sulfite reductase [NADPH] flavoprotein alpha-component/iron-uptake factor', NULL, NULL, NULL, NULL, NULL, 4),
(36925, NULL, 'G3DSA:3.30.1360.120:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36926, NULL, 'G3DSA:3.40.50.360:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36927, NULL, 'G3DSA:3.40.50.2300:FF:001139', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36928, NULL, 'G3DSA:3.10.20.80:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36929, NULL, 'G3DSA:1.25.40.10:FF:004783', NULL, NULL, 'Paf1 complex component', NULL, NULL, NULL, NULL, NULL, 4),
(36930, NULL, 'G3DSA:2.60.40.10:FF:003547', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36931, NULL, 'G3DSA:1.25.40.10:FF:003355', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g13880', NULL, NULL, NULL, NULL, NULL, 4),
(36932, NULL, 'G3DSA:3.40.630.10:FF:000250', NULL, NULL, 'Peptidase M20 domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(36933, NULL, 'G3DSA:3.10.20.90:FF:000225', NULL, NULL, 'Auxin-responsive protein', NULL, NULL, NULL, NULL, NULL, 4),
(36934, NULL, 'G3DSA:3.40.50.720:FF:002055', NULL, NULL, 'Hydroxysteroid (17-beta) dehydrogenase 14', NULL, NULL, NULL, NULL, NULL, 4),
(36935, NULL, 'G3DSA:1.20.5.170:FF:000232', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36936, NULL, 'G3DSA:1.10.3090.10:FF:000019', NULL, NULL, 'YALI0D03267p', NULL, NULL, NULL, NULL, NULL, 4),
(36937, NULL, 'G3DSA:1.10.510.10:FF:001992', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(36938, NULL, 'G3DSA:3.30.160.60:FF:000006', NULL, NULL, 'Zinc finger protein 184 (Kruppel-like)', NULL, NULL, NULL, NULL, NULL, 4),
(36939, NULL, 'G3DSA:2.10.25.10:FF:000782', NULL, NULL, 'Milk fat globule-EGF factor 8 protein', NULL, NULL, NULL, NULL, NULL, 4),
(36940, NULL, 'G3DSA:1.20.120.850:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36941, NULL, 'G3DSA:3.30.160.60:FF:000124', NULL, NULL, 'IKAROS family zinc finger 4', NULL, NULL, NULL, NULL, NULL, 4),
(36942, NULL, 'G3DSA:1.20.58.390:FF:000303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36943, NULL, 'G3DSA:3.30.40.10:FF:002383', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(36944, NULL, 'G3DSA:2.110.10.10:FF:000024', NULL, NULL, 'Matrix metalloproteinase-16-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(36945, NULL, 'G3DSA:2.40.50.100:FF:000170', NULL, NULL, 'Exosome complex component Rrp4', NULL, NULL, NULL, NULL, NULL, 4),
(36946, NULL, 'G3DSA:3.40.50.300:FF:007454', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36947, NULL, 'G3DSA:2.70.98.30:FF:000021', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36948, NULL, 'G3DSA:3.40.630.30:FF:000256', NULL, NULL, 'Putative lysine N-acyltransferase C17G9.06c', NULL, NULL, NULL, NULL, NULL, 4),
(36949, NULL, 'G3DSA:3.30.420.10:FF:000287', NULL, NULL, 'DNA polymerase III subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(36950, NULL, 'G3DSA:1.10.150.20:FF:000079', NULL, NULL, 'Putative DNA repair endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(36951, NULL, 'G3DSA:3.40.50.300:FF:004110', NULL, NULL, 'DNA2/NAM7 helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(36952, NULL, 'G3DSA:3.10.450.40:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36953, NULL, 'G3DSA:3.10.450.50:FF:000058', NULL, NULL, 'Aromatic-ring-hydroxylating dioxygenase subunit beta', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(36954, NULL, 'G3DSA:1.25.40.10:FF:005300', NULL, NULL, 'Outer membrane lipoprotein LppC', NULL, NULL, NULL, NULL, NULL, 4),
(36955, NULL, 'G3DSA:3.60.40.10:FF:000138', NULL, NULL, '5-azacytidine resistance protein azr1', NULL, NULL, NULL, NULL, NULL, 4),
(36956, NULL, 'G3DSA:1.20.58.60:FF:000268', NULL, NULL, 'Microtubule-actin cross-linking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(36957, NULL, 'G3DSA:3.20.20.80:FF:000019', NULL, NULL, 'glycoprotein endo-alpha-1,2-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(36958, NULL, 'G3DSA:3.30.110.10:FF:000005', NULL, NULL, 'Translation initiation factor 3 (IF-3) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(36959, NULL, 'G3DSA:3.40.1170.10:FF:000045', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(36960, NULL, 'G3DSA:2.60.120.920:FF:000114', NULL, NULL, 'Si:ch211-76m11.5', NULL, NULL, NULL, NULL, NULL, 4),
(36961, NULL, 'G3DSA:3.40.50.150:FF:000540', NULL, NULL, 'Protein N-terminal and lysine N-methyltransferase EFM7', NULL, NULL, NULL, NULL, NULL, 4),
(36962, NULL, 'G3DSA:1.10.472.130:FF:000042', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(36963, NULL, 'G3DSA:3.30.200.20:FF:002286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36964, NULL, 'G3DSA:2.20.100.10:FF:000067', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(36965, NULL, 'G3DSA:3.80.10.10:FF:002648', NULL, NULL, 'Leucine rich repeat containing 40, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(36966, NULL, 'G3DSA:1.20.1070.10:FF:000802', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36967, NULL, 'G3DSA:3.20.20.70:FF:000016', NULL, NULL, 'Triosephosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(36968, NULL, 'G3DSA:3.40.50.300:FF:005245', NULL, NULL, 'AGAP005161-PA', NULL, NULL, NULL, NULL, NULL, 4),
(36969, NULL, 'G3DSA:3.40.50.10190:FF:000324', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36970, NULL, 'G3DSA:1.10.238.10:FF:001179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36971, NULL, 'G3DSA:1.20.1640.10:FF:000003', NULL, NULL, 'protein patched homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(36972, NULL, 'G3DSA:3.40.50.300:FF:007336', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36973, NULL, 'G3DSA:1.20.1070.10:FF:000482', NULL, NULL, 'NeuroPeptide Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(36974, NULL, 'G3DSA:1.20.1250.20:FF:000960', NULL, NULL, 'Major facilitator superfamily MFS_1', NULL, NULL, NULL, NULL, NULL, 4),
(36975, NULL, 'G3DSA:1.10.8.60:FF:000163', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(36976, NULL, 'G3DSA:3.40.190.10:FF:000699', NULL, NULL, 'Orphan ABC-type transport system substrate-binding component', NULL, NULL, NULL, NULL, NULL, 4),
(36977, NULL, 'G3DSA:3.20.20.300:FF:000073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36978, NULL, 'G3DSA:2.60.120.650:FF:000039', NULL, NULL, 'JmjC domain-containing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(36979, NULL, 'G3DSA:3.20.20.70:FF:000078', NULL, NULL, 'Fatty acid synthase beta subunit dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(36980, NULL, 'G3DSA:3.30.70.330:FF:001371', NULL, NULL, 'AGAP013051-PA', NULL, NULL, NULL, NULL, NULL, 4),
(36981, NULL, 'G3DSA:1.20.1720.10:FF:000004', NULL, NULL, 'EmrB/QacA family drug resistance transporter', NULL, NULL, NULL, NULL, NULL, 4),
(36982, NULL, 'G3DSA:3.20.20.60:FF:000013', NULL, NULL, 'Citrate lyase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(36983, NULL, 'G3DSA:3.80.10.10:FF:004481', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36984, NULL, 'G3DSA:3.40.50.720:FF:000464', NULL, NULL, 'Lysine-ketoglutarate reductase/saccharopine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(36985, NULL, 'G3DSA:3.30.160.60:FF:006110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36986, NULL, 'G3DSA:2.40.40.20:FF:000049', NULL, NULL, 'Acetylene hydratase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(36987, NULL, 'G3DSA:1.10.10.60:FF:000321', NULL, NULL, 'Small nuclear RNA-activating complex, polypeptide 4', NULL, NULL, NULL, NULL, NULL, 4),
(36988, NULL, 'G3DSA:3.80.10.10:FF:001136', NULL, NULL, 'Probable inactive receptor kinase At3g08680', NULL, NULL, NULL, NULL, NULL, 4),
(36989, NULL, 'G3DSA:1.10.245.10:FF:000009', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(36990, NULL, 'G3DSA:2.40.20.10:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36991, NULL, 'G3DSA:3.60.20.10:FF:000194', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(36992, NULL, 'G3DSA:6.10.250.3450:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36993, NULL, 'G3DSA:1.50.40.10:FF:000183', NULL, NULL, 'Protein CBG09342', NULL, NULL, NULL, NULL, NULL, 4),
(36994, NULL, 'G3DSA:1.25.10.10:FF:002072', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(36995, NULL, 'G3DSA:2.130.10.10:FF:003766', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(36996, NULL, 'G3DSA:3.20.200.10:FF:000003', NULL, NULL, 'alpha-protein kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(36997, NULL, 'G3DSA:3.90.360.10:FF:000009', NULL, NULL, 'Histone AcetylTransferase', NULL, NULL, NULL, NULL, NULL, 4),
(36998, NULL, 'G3DSA:3.60.40.10:FF:000195', NULL, NULL, 'Putative regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(36999, NULL, 'G3DSA:2.60.40.60:FF:000318', NULL, NULL, 'Dachsous cadherin-related 2', NULL, NULL, NULL, NULL, NULL, 4),
(37000, NULL, 'G3DSA:3.90.340.10:FF:000003', NULL, NULL, 'Nitric oxide synthase oxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(37001, NULL, 'G3DSA:2.60.200.40:FF:000057', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(37002, NULL, 'G3DSA:3.40.50.1820:FF:000933', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37003, NULL, 'G3DSA:3.40.1190.10:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37004, NULL, 'G3DSA:3.30.1440.10:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37005, NULL, 'G3DSA:1.10.472.10:FF:000020', NULL, NULL, 'CDK5 and ABL1 enzyme substrate 1', NULL, NULL, NULL, NULL, NULL, 4),
(37006, NULL, 'G3DSA:3.40.50.1820:FF:000315', NULL, NULL, 'Probable carboxylesterase 18', NULL, NULL, NULL, NULL, NULL, 4),
(37007, NULL, 'G3DSA:3.40.50.2300:FF:000684', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37008, NULL, 'G3DSA:2.30.30.180:FF:000012', NULL, NULL, 'Ribosome maturation factor RimP', NULL, NULL, NULL, NULL, NULL, 4),
(37009, NULL, 'G3DSA:1.20.140.150:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37010, NULL, 'G3DSA:3.40.50.410:FF:000309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37011, NULL, 'G3DSA:1.10.510.10:FF:002301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37012, NULL, 'G3DSA:3.90.870.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37013, NULL, 'G3DSA:3.30.505.10:FF:000107', NULL, NULL, 'Transcription elongation factor SPT6', NULL, NULL, NULL, NULL, NULL, 4),
(37014, NULL, 'G3DSA:3.30.160.60:FF:001905', NULL, NULL, 'zinc finger protein 558 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(37015, NULL, 'G3DSA:2.130.10.10:FF:005711', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37016, NULL, 'G3DSA:3.30.920.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37017, NULL, 'G3DSA:1.25.40.10:FF:003147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37018, NULL, 'G3DSA:3.40.1190.20:FF:000049', NULL, NULL, 'Phosphomethylpyrimidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(37019, NULL, 'G3DSA:3.30.1240.10:FF:000025', NULL, NULL, 'Cof family protein', NULL, NULL, NULL, NULL, NULL, 4),
(37020, NULL, 'G3DSA:1.20.1740.10:FF:000067', NULL, NULL, 'Transmembrane domain transporter', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(37021, NULL, 'G3DSA:1.10.287.2620:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37022, NULL, 'G3DSA:1.10.287.110:FF:000041', NULL, NULL, 'Chaperone protein DNAj, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37023, NULL, 'G3DSA:3.30.450.50:FF:000014', NULL, NULL, 'vesicle-associated membrane protein 727', NULL, NULL, NULL, NULL, NULL, 4),
(37024, NULL, 'G3DSA:3.40.50.2000:FF:001139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37025, NULL, 'G3DSA:1.10.10.10:FF:001138', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(37026, NULL, 'G3DSA:1.10.8.50:FF:000008', NULL, NULL, 'Nei-like DNA glycosylase 3', NULL, NULL, NULL, NULL, NULL, 4),
(37027, NULL, 'G3DSA:2.60.40.60:FF:000111', NULL, NULL, 'Cadherin-related family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(37028, NULL, 'G3DSA:1.20.5.110:FF:000175', NULL, NULL, 'Syntaxin-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37029, NULL, 'G3DSA:3.30.160.60:FF:001198', NULL, NULL, 'zinc finger protein 629 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(37030, NULL, 'G3DSA:1.20.5.170:FF:000086', NULL, NULL, 'Transcription factor VIP1', NULL, NULL, NULL, NULL, NULL, 4),
(37031, NULL, 'G3DSA:3.30.1490.20:FF:000046', NULL, NULL, 'Probable alpha-L-glutamate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(37032, NULL, 'G3DSA:3.30.930.10:FF:000045', NULL, NULL, 'lipoyltransferase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(37033, NULL, 'G3DSA:3.50.50.60:FF:001464', NULL, NULL, '3-oxo-5-alpha-steroid 4-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(37034, NULL, 'G3DSA:3.80.10.10:FF:000473', NULL, NULL, 'EIN3-binding F-box protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(37035, NULL, 'G3DSA:1.10.287.130:FF:000047', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(37036, NULL, 'G3DSA:1.20.1250.20:FF:000667', NULL, NULL, 'monocarboxylate transporter 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(37037, NULL, 'G3DSA:2.60.40.10:FF:001809', NULL, NULL, 'Neuromusculin, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(37038, NULL, 'G3DSA:3.20.20.70:FF:000371', NULL, NULL, 'Putative 2-keto-3-deoxy-L-galactonate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(37039, NULL, 'G3DSA:4.10.240.10:FF:000021', NULL, NULL, 'RSC complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(37040, NULL, 'G3DSA:4.10.900.10:FF:000021', NULL, NULL, 'AGAP007216-PA', NULL, NULL, NULL, NULL, NULL, 4),
(37041, NULL, 'G3DSA:3.40.50.300:FF:004109', NULL, NULL, 'Deletions Of G-rich DNA', NULL, NULL, NULL, NULL, NULL, 4),
(37042, NULL, 'G3DSA:3.90.260.10:FF:000002', NULL, NULL, 'Erythrocyte membrane protein band 4.2', NULL, NULL, NULL, NULL, NULL, 4),
(37043, NULL, 'G3DSA:1.10.167.10:FF:000024', NULL, NULL, 'A-kinase anchor protein 10, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(37044, NULL, 'G3DSA:3.30.450.40:FF:000011', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(37045, NULL, 'G3DSA:3.90.190.10:FF:000592', NULL, NULL, 'Protein tyrosine phosphatase, receptor type, A', NULL, NULL, NULL, NULL, NULL, 4),
(37046, NULL, 'G3DSA:1.20.1270.60:FF:000158', NULL, NULL, 'Bridging integrator 2', NULL, NULL, NULL, NULL, NULL, 4),
(37047, NULL, 'G3DSA:1.10.246.230:FF:000001', NULL, NULL, 'Gamma-glutamyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(37048, NULL, 'G3DSA:3.90.1480.20:FF:000009', NULL, NULL, 'alpha-N-acetylgalactosaminide alpha-2,6-sialyltransferase 6 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(37049, NULL, 'G3DSA:3.40.50.1460:FF:000128', NULL, NULL, 'Caspase, apoptotic cysteine protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37050, NULL, 'G3DSA:3.30.160.60:FF:005183', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37051, NULL, 'G3DSA:2.130.10.10:FF:005475', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37052, NULL, 'G3DSA:1.20.58.760:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37053, NULL, 'G3DSA:1.25.40.10:FF:001764', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g16010', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(37054, NULL, 'G3DSA:2.60.40.10:FF:003608', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37055, NULL, 'G3DSA:4.10.1240.10:FF:000001', NULL, NULL, 'Adhesion G protein-coupled receptor L2', NULL, NULL, NULL, NULL, NULL, 4),
(37056, NULL, 'G3DSA:3.20.20.70:FF:000224', NULL, NULL, '3-keto-5-aminohexanoate cleavage enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(37057, NULL, 'G3DSA:3.30.160.60:FF:000978', NULL, NULL, 'Zinc finger protein 770', NULL, NULL, NULL, NULL, NULL, 4),
(37058, NULL, 'G3DSA:1.25.40.20:FF:000542', NULL, NULL, 'Uncharacterized protein, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(37059, NULL, 'G3DSA:3.20.20.80:FF:000227', NULL, NULL, 'Glycogen debranching enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(37060, NULL, 'G3DSA:3.30.40.10:FF:000735', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(37061, NULL, 'G3DSA:3.40.50.1820:FF:000787', NULL, NULL, 'Lysophospholipase-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(37062, NULL, 'G3DSA:3.10.260.10:FF:000003', NULL, NULL, 'Ascospore maturation 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(37063, NULL, 'G3DSA:3.10.25.10:FF:000004', NULL, NULL, 'Methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(37064, NULL, 'G3DSA:1.10.260.40:FF:000065', NULL, NULL, 'Antitoxin HigA', NULL, NULL, NULL, NULL, NULL, 4),
(37065, NULL, 'G3DSA:3.40.50.300:FF:002165', NULL, NULL, 'Manganese/iron ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(37066, NULL, 'G3DSA:3.30.300.30:FF:000054', NULL, NULL, 'Acyl-CoA synthetase (AMP-forming)/AMP-acid ligase II', NULL, NULL, NULL, NULL, NULL, 4),
(37067, NULL, 'G3DSA:1.10.510.10:FF:002037', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(37068, NULL, 'G3DSA:3.30.70.3270:FF:000011', NULL, NULL, 'NADH-quinone oxidoreductase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(37069, NULL, 'G3DSA:1.10.510.10:FF:002240', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37070, NULL, 'G3DSA:1.25.40.20:FF:001767', NULL, NULL, 'Ankyrin repeat, PH and SEC7 domain containing protein secG', NULL, NULL, NULL, NULL, NULL, 4),
(37071, NULL, 'G3DSA:1.25.40.10:FF:003765', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37072, NULL, 'G3DSA:3.30.40.10:FF:000792', NULL, NULL, 'Os01g0766200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(37073, NULL, 'G3DSA:3.40.50.2300:FF:001611', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37074, NULL, 'G3DSA:3.30.360.10:FF:000023', NULL, NULL, 'Inositol 2-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(37075, NULL, 'G3DSA:3.40.50.2300:FF:001140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37076, NULL, 'G3DSA:2.70.150.10:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37077, NULL, 'G3DSA:3.30.450.60:FF:000017', NULL, NULL, 'SNARE-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(37078, NULL, 'G3DSA:1.20.1090.10:FF:000039', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(37079, NULL, 'G3DSA:3.30.70.330:FF:003080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37080, NULL, 'G3DSA:3.40.50.300:FF:000366', NULL, NULL, 'GTPase, IMAP family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(37081, NULL, 'G3DSA:3.20.20.80:FF:000845', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37082, NULL, 'G3DSA:2.10.90.10:FF:000028', NULL, NULL, 'Left-right determination factor', NULL, NULL, NULL, NULL, NULL, 4),
(37083, NULL, 'G3DSA:3.40.50.450:FF:000006', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(37084, NULL, 'G3DSA:3.40.50.620:FF:000844', NULL, NULL, 'ASparagiNe Synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(37085, NULL, 'G3DSA:2.20.50.20:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37086, NULL, 'G3DSA:3.30.750.24:FF:000078', NULL, NULL, 'Glutaminase', NULL, NULL, NULL, NULL, NULL, 4),
(37087, NULL, 'G3DSA:2.120.10.10:FF:000029', NULL, NULL, 'Sialidase NEU1.3; Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(37088, NULL, 'G3DSA:3.10.250.10:FF:000031', NULL, NULL, 'RIKEN cDNA 5830411N06, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(37089, NULL, 'G3DSA:2.30.29.30:FF:001173', NULL, NULL, 'Protein CBR-DYC-1', NULL, NULL, NULL, NULL, NULL, 4),
(37090, NULL, 'G3DSA:3.40.1610.10:FF:000001', NULL, NULL, 'Hydantoinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37091, NULL, 'G3DSA:3.40.50.300:FF:003593', NULL, NULL, 'Os10g0208200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(37092, NULL, 'G3DSA:1.10.510.10:FF:003465', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37093, NULL, 'G3DSA:1.10.1060.10:FF:000017', NULL, NULL, 'Putative succinate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(37094, NULL, 'G3DSA:3.20.20.70:FF:000842', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37095, NULL, 'G3DSA:1.10.10.10:FF:000003', NULL, NULL, 'Paired box protein Pax-6', NULL, NULL, NULL, NULL, NULL, 4),
(37096, NULL, 'G3DSA:1.20.1410.10:FF:000048', NULL, NULL, 'Hip1r protein', NULL, NULL, NULL, NULL, NULL, 4),
(37097, NULL, 'G3DSA:2.60.120.200:FF:000399', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(37098, NULL, 'G3DSA:1.20.140.50:FF:000012', NULL, NULL, 'K7_Rim20p', NULL, NULL, NULL, NULL, NULL, 4),
(37099, NULL, 'G3DSA:1.10.10.10:FF:001195', NULL, NULL, 'ISPsy9, transposase OrfA', NULL, NULL, NULL, NULL, NULL, 4),
(37100, NULL, 'G3DSA:2.30.30.1020:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37101, NULL, 'G3DSA:1.10.510.10:FF:003375', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37102, NULL, 'G3DSA:3.10.620.30:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37103, NULL, 'G3DSA:3.40.630.30:FF:000609', NULL, NULL, 'Os02g0694201 protein', NULL, NULL, NULL, NULL, NULL, 4),
(37104, NULL, 'G3DSA:3.30.70.330:FF:001432', NULL, NULL, 'Os12g0606300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(37105, NULL, 'G3DSA:3.30.70.330:FF:002618', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37106, NULL, 'G3DSA:3.10.580.10:FF:000140', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(37107, NULL, 'G3DSA:1.20.58.60:FF:000829', NULL, NULL, 'Microtubule-actin crosslinking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(37108, NULL, 'G3DSA:3.30.300.20:FF:000051', NULL, NULL, 'GTPase Der', NULL, NULL, NULL, NULL, NULL, 4),
(37109, NULL, 'G3DSA:2.170.130.10:FF:000067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37110, NULL, 'G3DSA:3.40.50.300:FF:005745', NULL, NULL, 'Katanin p60 ATPase-containing subunit A1', NULL, NULL, NULL, NULL, NULL, 4),
(37111, NULL, 'G3DSA:1.10.10.790:FF:000002', NULL, NULL, 'Splicing factor 3A subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(37112, NULL, 'G3DSA:1.10.472.80:FF:000198', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37113, NULL, 'G3DSA:3.30.70.330:FF:002860', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37114, NULL, 'G3DSA:3.20.20.140:FF:000209', NULL, NULL, 'Allantoinase', NULL, NULL, NULL, NULL, NULL, 4),
(37115, NULL, 'G3DSA:3.40.50.2020:FF:000162', NULL, NULL, 'Ribose-phosphat pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(37116, NULL, 'G3DSA:3.40.50.2020:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37117, NULL, 'G3DSA:2.130.10.10:FF:000540', NULL, NULL, 'Dmx like 1', NULL, NULL, NULL, NULL, NULL, 4),
(37118, NULL, 'G3DSA:3.30.559.10:FF:000226', NULL, NULL, 'Putative peptide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(37119, NULL, 'G3DSA:2.60.120.330:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37120, NULL, 'G3DSA:3.90.380.10:FF:000011', NULL, NULL, 'Cholesterol 7-desaturase', NULL, NULL, NULL, NULL, NULL, 4),
(37121, NULL, 'G3DSA:2.60.120.620:FF:000030', NULL, NULL, 'Proline HYdroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(37122, NULL, 'G3DSA:1.10.510.10:FF:000969', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(37123, NULL, 'G3DSA:1.10.390.10:FF:000060', NULL, NULL, 'GD16024', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(37124, NULL, 'G3DSA:1.10.150.110:FF:000019', NULL, NULL, 'Lmo1231 protein', NULL, NULL, NULL, NULL, NULL, 4),
(37125, NULL, 'G3DSA:1.20.1070.10:FF:002039', NULL, NULL, 'Protein CBR-GNRR-8', NULL, NULL, NULL, NULL, NULL, 4),
(37126, NULL, 'G3DSA:1.25.10.10:FF:001257', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(37127, NULL, 'G3DSA:1.10.287.310:FF:000011', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(37128, NULL, 'G3DSA:2.60.40.10:FF:002361', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(37129, NULL, 'G3DSA:3.80.10.10:FF:004273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37130, NULL, 'G3DSA:3.40.50.10630:FF:000001', NULL, NULL, 'PUA domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(37131, NULL, 'G3DSA:3.60.21.60:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37132, NULL, 'G3DSA:1.10.8.60:FF:000573', NULL, NULL, 'Bromodomain protein', NULL, NULL, NULL, NULL, NULL, 4),
(37133, NULL, 'G3DSA:2.10.25.10:FF:000187', NULL, NULL, 'nephronectin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(37134, NULL, 'G3DSA:1.25.40.20:FF:001913', NULL, NULL, 'Ankyrin-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37135, NULL, 'G3DSA:2.130.10.10:FF:005565', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37136, NULL, 'G3DSA:2.40.30.170:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37137, NULL, 'G3DSA:3.30.450.40:FF:000101', NULL, NULL, 'Sigma-54 dependent transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(37138, NULL, 'G3DSA:1.25.40.120:FF:000090', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37139, NULL, 'G3DSA:2.20.25.240:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37140, NULL, 'G3DSA:2.60.40.150:FF:000060', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(37141, NULL, 'G3DSA:3.30.1910.20:FF:000001', NULL, NULL, 'asparagine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(37142, NULL, 'G3DSA:2.30.42.10:FF:000287', NULL, NULL, 'Serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(37143, NULL, 'G3DSA:3.90.660.10:FF:000139', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37144, NULL, 'G3DSA:1.20.120.1080:FF:000073', NULL, NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase PRP16', NULL, NULL, NULL, NULL, NULL, 4),
(37145, NULL, 'G3DSA:3.30.420.10:FF:000523', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37146, NULL, 'G3DSA:1.10.3370.10:FF:000035', NULL, NULL, 'Os12g0625966 protein', NULL, NULL, NULL, NULL, NULL, 4),
(37147, NULL, 'G3DSA:2.60.40.10:FF:003047', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(37148, NULL, 'G3DSA:3.20.20.80:FF:000284', NULL, NULL, 'Glycogen debranching enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(37149, NULL, 'G3DSA:3.50.50.60:FF:001200', NULL, NULL, 'Similar to monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(37150, NULL, 'G3DSA:1.20.1250.20:FF:000757', NULL, NULL, 'YDL199C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(37151, NULL, 'G3DSA:3.30.420.10:FF:000169', NULL, NULL, 'Snipper, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(37152, NULL, 'G3DSA:2.10.50.10:FF:000115', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 6', NULL, NULL, NULL, NULL, NULL, 4),
(37153, NULL, 'G3DSA:3.30.499.10:FF:000024', NULL, NULL, '2-methylisocitrate dehydratase, Fe/S-dependent', NULL, NULL, NULL, NULL, NULL, 4),
(37154, NULL, 'G3DSA:3.30.200.20:FF:001830', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37155, NULL, 'G3DSA:1.50.10.10:FF:000147', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(37156, NULL, 'G3DSA:3.10.170.20:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37157, NULL, 'G3DSA:3.40.50.300:FF:001855', NULL, NULL, 'Dynein axonemal heavy chain 10', NULL, NULL, NULL, NULL, NULL, 4),
(37158, NULL, 'G3DSA:3.30.160.60:FF:002310', NULL, NULL, 'Rna polymerase ii transcription factor', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(37159, NULL, 'G3DSA:3.40.50.200:FF:000128', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37160, NULL, 'G3DSA:2.170.16.10:FF:000046', NULL, NULL, 'Replication factor C small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(37161, NULL, 'G3DSA:3.10.105.10:FF:000014', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(37162, NULL, 'G3DSA:1.10.840.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37163, NULL, 'G3DSA:3.90.1170.40:FF:000003', NULL, NULL, 'Molybdopterin converting factor subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(37164, NULL, 'G3DSA:3.40.50.300:FF:002311', NULL, NULL, 'Intraflagellar transport protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(37165, NULL, 'G3DSA:3.90.1170.50:FF:000006', NULL, NULL, 'Carbon monoxide dehydrogenase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(37166, NULL, 'G3DSA:2.40.50.140:FF:000777', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37167, NULL, 'G3DSA:3.20.20.70:FF:000281', NULL, NULL, 'Probable dihydrodipicolinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(37168, NULL, 'G3DSA:3.40.50.10490:FF:000032', NULL, NULL, 'RpiR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(37169, NULL, 'G3DSA:2.20.25.10:FF:000080', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(37170, NULL, 'G3DSA:3.90.70.10:FF:000100', NULL, NULL, 'Cathepsin W', NULL, NULL, NULL, NULL, NULL, 4),
(37171, NULL, 'G3DSA:3.40.50.460:FF:000009', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(37172, NULL, 'G3DSA:1.25.40.10:FF:001910', NULL, NULL, 'RNA polymerase III transcription factor TFIIIC subunit (Tfc4), putative', NULL, NULL, NULL, NULL, NULL, 4),
(37173, NULL, 'G3DSA:1.10.287.450:FF:000002', NULL, NULL, 'adenomatous polyposis coli protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(37174, NULL, 'G3DSA:2.30.29.30:FF:000863', NULL, NULL, 'Family with sequence similarity 43 member B', NULL, NULL, NULL, NULL, NULL, 4),
(37175, NULL, 'G3DSA:1.10.287.460:FF:000005', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(37176, NULL, 'G3DSA:1.25.10.10:FF:001167', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(37177, NULL, 'G3DSA:1.25.10.10:FF:001521', NULL, NULL, 'AaceriAEL256Cp', NULL, NULL, NULL, NULL, NULL, 4),
(37178, NULL, 'G3DSA:3.90.650.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37179, NULL, 'G3DSA:2.60.40.10:FF:005817', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37180, NULL, 'G3DSA:2.60.200.20:FF:000107', NULL, NULL, 'FHA domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(37181, NULL, 'G3DSA:2.70.160.11:FF:000094', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(37182, NULL, 'G3DSA:3.30.70.330:FF:003023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37183, NULL, 'G3DSA:3.30.160.60:FF:003704', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37184, NULL, 'G3DSA:3.40.50.300:FF:005655', NULL, NULL, 'Protein strawberry notch-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(37185, NULL, 'G3DSA:3.40.1180.10:FF:000017', NULL, NULL, 'Alkyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(37186, NULL, 'G3DSA:3.20.20.140:FF:000356', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37187, NULL, 'G3DSA:3.30.950.30:FF:000001', NULL, NULL, 'Schlafen family member 14', NULL, NULL, NULL, NULL, NULL, 4),
(37188, NULL, 'G3DSA:2.10.50.10:FF:000172', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37189, NULL, 'G3DSA:1.10.238.10:FF:001325', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37190, NULL, 'G3DSA:3.90.70.10:FF:000307', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(37191, NULL, 'G3DSA:3.40.50.1980:FF:000110', NULL, NULL, 'ABC-type transport system periplasmic substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(37192, NULL, 'G3DSA:2.60.40.2700:FF:000002', NULL, NULL, '187-kDa microtubule-associated protein AIR9', NULL, NULL, NULL, NULL, NULL, 4),
(37193, NULL, 'G3DSA:2.40.10.230:FF:000015', NULL, NULL, 'H/ACA ribonucleoprotein complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(37194, NULL, 'G3DSA:1.20.58.70:FF:000012', NULL, NULL, 'diablo homolog, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(37195, NULL, 'G3DSA:2.60.40.10:FF:005907', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37196, NULL, 'G3DSA:1.20.58.90:FF:000018', NULL, NULL, 'Tubulin-specific chaperone A', NULL, NULL, NULL, NULL, NULL, 4),
(37197, NULL, 'G3DSA:2.60.120.10:FF:000626', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37198, NULL, 'G3DSA:3.90.1150.10:FF:000398', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37199, NULL, 'G3DSA:3.40.50.1000:FF:000013', NULL, NULL, 'Carboxy-terminal domain RNA polymerase II polypeptide A small', NULL, NULL, NULL, NULL, NULL, 4),
(37200, NULL, 'G3DSA:3.10.250.10:FF:000121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37201, NULL, 'G3DSA:1.10.150.650:FF:000012', NULL, NULL, 'PHP domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(37202, NULL, 'G3DSA:3.40.50.300:FF:001294', NULL, NULL, 'Caspase recruitment domain family member 14', NULL, NULL, NULL, NULL, NULL, 4),
(37203, NULL, 'G3DSA:3.40.367.20:FF:000039', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(37204, NULL, 'G3DSA:2.20.60.10:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37205, NULL, 'G3DSA:3.40.50.300:FF:007807', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37206, NULL, 'G3DSA:1.25.40.800:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37207, NULL, 'G3DSA:3.40.30.10:FF:000414', NULL, NULL, 'Thioredoxin-like reductase Rv2466c', NULL, NULL, NULL, NULL, NULL, 4),
(37208, NULL, 'G3DSA:3.30.200.20:FF:001476', NULL, NULL, 'DNA-binding SARP family transcriptional activator', NULL, NULL, NULL, NULL, NULL, 4),
(37209, NULL, 'G3DSA:2.130.10.10:FF:002131', NULL, NULL, 'LD10780p', NULL, NULL, NULL, NULL, NULL, 4),
(37210, NULL, 'G3DSA:4.10.240.10:FF:000228', NULL, NULL, 'Uncharacterized transcriptional regulatory protein C320.03', NULL, NULL, NULL, NULL, NULL, 4),
(37211, NULL, 'G3DSA:1.20.58.80:FF:000015', NULL, NULL, 'Calpain 7', NULL, NULL, NULL, NULL, NULL, 4),
(37212, NULL, 'G3DSA:1.10.1420.10:FF:000034', NULL, NULL, 'DNA mismatch repair protein msh2', NULL, NULL, NULL, NULL, NULL, 4),
(37213, NULL, 'G3DSA:3.40.630.30:FF:000402', NULL, NULL, 'O-GlcNAcase like', NULL, NULL, NULL, NULL, NULL, 4),
(37214, NULL, 'G3DSA:2.30.30.140:FF:000320', NULL, NULL, 'Protein lin-61', NULL, NULL, NULL, NULL, NULL, 4),
(37215, NULL, 'G3DSA:3.40.50.1010:FF:000016', NULL, NULL, 'Flap endonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(37216, NULL, 'G3DSA:3.40.720.10:FF:000280', NULL, NULL, 'AGAP003222-PA', NULL, NULL, NULL, NULL, NULL, 4),
(37217, NULL, 'G3DSA:3.30.160.60:FF:005913', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37218, NULL, 'G3DSA:3.40.50.300:FF:003446', NULL, NULL, 'Type I restriction-modification system restriction subunit R', NULL, NULL, NULL, NULL, NULL, 4),
(37219, NULL, 'G3DSA:3.50.50.60:FF:001407', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37220, NULL, 'G3DSA:1.20.1250.20:FF:000196', NULL, NULL, 'MFS toxin efflux pump (AflT)', NULL, NULL, NULL, NULL, NULL, 4),
(37221, NULL, 'G3DSA:3.40.33.10:FF:000128', NULL, NULL, 'Cysteine-rich secretory protein-buccal gland secretion, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37222, NULL, 'G3DSA:3.40.50.1100:FF:000251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37223, NULL, 'G3DSA:3.30.470.20:FF:000063', NULL, NULL, 'beta-citrylglutamate synthase B isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(37224, NULL, 'G3DSA:1.20.1740.10:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37225, NULL, 'G3DSA:2.60.120.10:FF:000008', NULL, NULL, 'Rap guanine nucleotide exchange factor (GEF) 2', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(37226, NULL, 'G3DSA:3.40.1080.10:FF:000010', NULL, NULL, 'Succinate CoA transferase', NULL, NULL, NULL, NULL, NULL, 4),
(37227, NULL, 'G3DSA:3.40.50.2000:FF:000976', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37228, NULL, 'G3DSA:2.40.10.10:FF:000218', NULL, NULL, 'Serine protease nudel', NULL, NULL, NULL, NULL, NULL, 4),
(37229, NULL, 'G3DSA:1.10.8.10:FF:000255', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(37230, NULL, 'G3DSA:3.40.50.300:FF:007600', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37231, NULL, 'G3DSA:3.40.50.2000:FF:000919', NULL, NULL, 'Mannosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37232, NULL, 'G3DSA:1.10.10.10:FF:001756', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37233, NULL, 'G3DSA:3.30.160.60:FF:001759', NULL, NULL, 'Crooked legs, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(37234, NULL, 'G3DSA:1.10.510.10:FF:001784', NULL, NULL, 'Fibroblast growth factor receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(37235, NULL, 'G3DSA:1.10.260.100:FF:000018', NULL, NULL, 'Small glutamine-rich tetratricopeptide repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(37236, NULL, 'G3DSA:1.20.1250.20:FF:001123', NULL, NULL, 'Multidrug resistance protein B', NULL, NULL, NULL, NULL, NULL, 4),
(37237, NULL, 'G3DSA:3.40.1160.10:FF:000011', NULL, NULL, 'N-acetyl-gamma-glutamyl-phosphate reductase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(37238, NULL, 'G3DSA:3.90.25.10:FF:000057', NULL, NULL, 'CipA protein', NULL, NULL, NULL, NULL, NULL, 4),
(37239, NULL, 'G3DSA:3.30.200.160:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37240, NULL, 'G3DSA:1.25.10.10:FF:001728', NULL, NULL, 'Os06g0244700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(37241, NULL, 'G3DSA:3.40.50.720:FF:001245', NULL, NULL, 'Dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37242, NULL, 'G3DSA:3.40.50.300:FF:000720', NULL, NULL, 'Guanine nucleotide-binding protein G(k) subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(37243, NULL, 'G3DSA:1.10.20.10:FF:000150', NULL, NULL, 'DR1 (One) transcription factor family', NULL, NULL, NULL, NULL, NULL, 4),
(37244, NULL, 'G3DSA:3.40.850.10:FF:000227', NULL, NULL, 'Kinesin heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37245, NULL, 'G3DSA:3.40.50.2300:FF:001347', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37246, NULL, 'G3DSA:1.20.1250.20:FF:002348', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37247, NULL, 'G3DSA:3.40.50.720:FF:002139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37248, NULL, 'G3DSA:3.40.50.300:FF:005806', NULL, NULL, 'Zinc finger Ran-binding domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(37249, NULL, 'G3DSA:3.90.550.10:FF:000221', NULL, NULL, 'Glycosyltransferase family protein 47', NULL, NULL, NULL, NULL, NULL, 4),
(37250, NULL, 'G3DSA:1.10.8.60:FF:000073', NULL, NULL, 'ORC1-type DNA replication protein', NULL, NULL, NULL, NULL, NULL, 4),
(37251, NULL, 'G3DSA:2.60.60.20:FF:000033', NULL, NULL, 'Inactive pancreatic lipase-related protein 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(37252, NULL, 'G3DSA:2.40.150.20:FF:000001', NULL, NULL, '50S ribosomal protein L14', NULL, NULL, NULL, NULL, NULL, 4),
(37253, NULL, 'G3DSA:3.30.70.330:FF:000943', NULL, NULL, 'Multiple RNA-binding domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(37254, NULL, 'G3DSA:3.90.1150.10:FF:000021', NULL, NULL, 'Kynurenine--oxoglutarate transaminase 3', NULL, NULL, NULL, NULL, NULL, 4),
(37255, NULL, 'G3DSA:2.102.10.10:FF:000047', NULL, NULL, 'Assimilatory nitrite reductase [NAD(P)H] small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(37256, NULL, 'G3DSA:3.40.20.10:FF:000065', NULL, NULL, 'Quail, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(37257, NULL, 'G3DSA:3.30.160.60:FF:000040', NULL, NULL, 'RB associated KRAB zinc finger', NULL, NULL, NULL, NULL, NULL, 4),
(37258, NULL, 'G3DSA:3.40.1190.20:FF:000139', NULL, NULL, 'Bifunctional protein HldE', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(37259, NULL, 'G3DSA:3.10.105.10:FF:000071', NULL, NULL, 'Peptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(37260, NULL, 'G3DSA:3.30.200.20:FF:001740', NULL, NULL, 'Fructosamine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(37261, NULL, 'G3DSA:3.30.420.40:FF:000919', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(37262, NULL, 'G3DSA:3.30.450.20:FF:000415', NULL, NULL, 'Sensor histidine kinase, HAMP and PAS domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(37263, NULL, 'G3DSA:1.10.560.10:FF:000011', NULL, NULL, '60 kDa heat shock protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(37264, NULL, 'G3DSA:1.10.20.140:FF:000012', NULL, NULL, 'LD10347p', NULL, NULL, NULL, NULL, NULL, 4),
(37265, NULL, 'G3DSA:3.30.70.1130:FF:000009', NULL, NULL, 'Eukaryotic translation initiation factor 2 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(37266, NULL, 'G3DSA:3.30.40.10:FF:000909', NULL, NULL, 'E3 ubiquitin-protein ligase SP1', NULL, NULL, NULL, NULL, NULL, 4),
(37267, NULL, 'G3DSA:1.20.1260.10:FF:000047', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(37268, NULL, 'G3DSA:4.10.240.10:FF:000083', NULL, NULL, 'C6 transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37269, NULL, 'G3DSA:3.40.720.10:FF:000370', NULL, NULL, 'PhosphatidylInositol Glycan anchor biosynthesis class N homolog', NULL, NULL, NULL, NULL, NULL, 4),
(37270, NULL, 'G3DSA:1.20.5.110:FF:000293', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37271, NULL, 'G3DSA:3.50.50.60:FF:001290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37272, NULL, 'G3DSA:3.30.70.330:FF:003107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37273, NULL, 'G3DSA:3.30.1120.30:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37274, NULL, 'G3DSA:2.130.10.10:FF:002659', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37275, NULL, 'G3DSA:1.25.40.180:FF:000203', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37276, NULL, 'G3DSA:1.20.120.1510:FF:000005', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(37277, NULL, 'G3DSA:2.20.100.10:FF:000128', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs adt-2', NULL, NULL, NULL, NULL, NULL, 4),
(37278, NULL, 'G3DSA:1.10.287.70:FF:000646', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37279, NULL, 'G3DSA:2.40.50.140:FF:000687', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37280, NULL, 'G3DSA:3.80.10.10:FF:000703', NULL, NULL, 'Leucine-rich repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(37281, NULL, 'G3DSA:1.10.510.10:FF:001548', NULL, NULL, 'Cyclin-dependent kinase 4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(37282, NULL, 'G3DSA:1.50.10.20:FF:000089', NULL, NULL, 'Terpene cyclase/mutase family member', NULL, NULL, NULL, NULL, NULL, 4),
(37283, NULL, 'G3DSA:1.20.1250.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37284, NULL, 'G3DSA:3.40.50.1010:FF:000106', NULL, NULL, 'Toxin FitB', NULL, NULL, NULL, NULL, NULL, 4),
(37285, NULL, 'G3DSA:3.30.160.60:FF:004255', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37286, NULL, 'G3DSA:3.40.50.300:FF:001384', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(37287, NULL, 'G3DSA:2.80.10.50:FF:000032', NULL, NULL, 'macrophage mannose receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(37288, NULL, 'G3DSA:2.20.20.10:FF:000001', NULL, NULL, 'Crotamine', NULL, NULL, NULL, NULL, NULL, 4),
(37289, NULL, 'G3DSA:1.10.4020.10:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37290, NULL, 'G3DSA:2.60.120.380:FF:000025', NULL, NULL, 'Subtilisin-like serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(37291, NULL, 'G3DSA:1.50.10.10:FF:000086', NULL, NULL, 'Glucanase', NULL, NULL, NULL, NULL, NULL, 4),
(37292, NULL, 'G3DSA:3.50.50.60:FF:000828', NULL, NULL, 'Squalene epoxidase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(37293, NULL, 'G3DSA:1.10.287.70:FF:000118', NULL, NULL, 'Calcium channel subunit Cch1', NULL, NULL, NULL, NULL, NULL, 4),
(37294, NULL, 'G3DSA:2.60.40.10:FF:000500', NULL, NULL, 'limbic system-associated membrane protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(37295, NULL, 'G3DSA:3.40.50.12780:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37296, NULL, 'G3DSA:3.40.50.300:FF:007370', NULL, NULL, 'Protein CBG22156', NULL, NULL, NULL, NULL, NULL, 4),
(37297, NULL, 'G3DSA:3.30.1120.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37298, NULL, 'G3DSA:1.10.150.670:FF:000018', NULL, NULL, 'Crossover junction endonuclease EME1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(37299, NULL, 'G3DSA:2.60.40.10:FF:000444', NULL, NULL, 'Collagen alpha-1(XIV) chain isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(37300, NULL, 'G3DSA:3.50.50.60:FF:000891', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37301, NULL, 'G3DSA:3.40.50.1820:FF:000815', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37302, NULL, 'G3DSA:3.30.160.60:FF:004896', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37303, NULL, 'G3DSA:3.20.20.80:FF:000435', NULL, NULL, 'Chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37304, NULL, 'G3DSA:1.10.8.140:FF:000006', NULL, NULL, 'programmed cell death protein 5-like', NULL, NULL, NULL, NULL, NULL, 4),
(37305, NULL, 'G3DSA:1.20.1070.10:FF:000982', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37306, NULL, 'G3DSA:3.60.60.10:FF:000022', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37307, NULL, 'G3DSA:3.40.50.300:FF:005329', NULL, NULL, 'Unc-53', NULL, NULL, NULL, NULL, NULL, 4),
(37308, NULL, 'G3DSA:1.10.287.1390:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37309, NULL, 'G3DSA:1.10.132.70:FF:000001', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(37310, NULL, 'G3DSA:3.40.1170.60:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37311, NULL, 'G3DSA:3.40.50.80:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37312, NULL, 'G3DSA:1.10.238.10:FF:000959', NULL, NULL, 'Calcineurin B subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37313, NULL, 'G3DSA:1.10.510.10:FF:003791', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37314, NULL, 'G3DSA:3.40.50.10330:FF:000001', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(37315, NULL, 'G3DSA:3.30.450.20:FF:000264', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(37316, NULL, 'G3DSA:2.60.40.10:FF:001602', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(37317, NULL, 'G3DSA:3.40.50.300:FF:005127', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37318, NULL, 'G3DSA:2.40.50.1020:FF:000014', NULL, NULL, 'Accessory gene regulator A', NULL, NULL, NULL, NULL, NULL, 4),
(37319, NULL, 'G3DSA:3.30.420.40:FF:001055', NULL, NULL, 'Putative glycerol kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(37320, NULL, 'G3DSA:1.20.58.1120:FF:000032', NULL, NULL, 'Dynein, axonemal, heavy chain 6', NULL, NULL, NULL, NULL, NULL, 4),
(37321, NULL, 'G3DSA:3.40.50.1820:FF:000697', NULL, NULL, 'Possible secreted protease', NULL, NULL, NULL, NULL, NULL, 4),
(37322, NULL, 'G3DSA:1.20.1250.10:FF:000131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37323, NULL, 'G3DSA:2.60.120.970:FF:000051', NULL, NULL, 'Growth differentiation factor 7', NULL, NULL, NULL, NULL, NULL, 4),
(37324, NULL, 'G3DSA:3.20.80.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37325, NULL, 'G3DSA:3.30.200.20:FF:001061', NULL, NULL, 'Nuclear receptor-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(37326, NULL, 'G3DSA:1.20.120.350:FF:000190', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37327, NULL, 'G3DSA:3.30.200.20:FF:001684', NULL, NULL, 'Kae1-associated serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(37328, NULL, 'G3DSA:3.40.30.10:FF:000004', NULL, NULL, 'Spliceosomal protein DIB1', NULL, NULL, NULL, NULL, NULL, 4),
(37329, NULL, 'G3DSA:3.80.10.10:FF:001013', NULL, NULL, 'Receptor-like protein CLAVATA2', NULL, NULL, NULL, NULL, NULL, 4),
(37330, NULL, 'G3DSA:1.20.5.50:FF:000002', NULL, NULL, 'Fibrinogen beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(37331, NULL, 'G3DSA:3.40.50.2000:FF:000892', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37332, NULL, 'G3DSA:1.25.40.10:FF:002130', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(37333, NULL, 'G3DSA:1.10.510.10:FF:001604', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(37334, NULL, 'G3DSA:1.25.10.10:FF:002948', NULL, NULL, 'Importin beta, nuclear transport factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37335, NULL, 'G3DSA:2.60.220.30:FF:000027', NULL, NULL, 'Unc-5 netrin receptor B', NULL, NULL, NULL, NULL, NULL, 4),
(37336, NULL, 'G3DSA:3.40.50.720:FF:002465', NULL, NULL, 'Alcohol dehydrogenase-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(37337, NULL, 'G3DSA:3.30.1140.60:FF:000015', NULL, NULL, 'F-actin-capping protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(37338, NULL, 'G3DSA:2.130.10.10:FF:001726', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37339, NULL, 'G3DSA:1.10.420.10:FF:000001', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(37340, NULL, 'G3DSA:2.60.40.420:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37341, NULL, 'G3DSA:3.40.50.11060:FF:000012', NULL, NULL, 'GTPase HflX', NULL, NULL, NULL, NULL, NULL, 4),
(37342, NULL, 'G3DSA:3.30.900.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37343, NULL, 'G3DSA:1.10.510.10:FF:001930', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37344, NULL, 'G3DSA:3.10.20.30:FF:000022', NULL, NULL, 'Succinate dehydrogenase iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4),
(37345, NULL, 'G3DSA:2.60.40.3210:FF:000003', NULL, NULL, 'Glycoprotein 2', NULL, NULL, NULL, NULL, NULL, 4),
(37346, NULL, 'G3DSA:3.40.390.10:FF:000298', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37347, NULL, 'G3DSA:3.30.70.330:FF:001253', NULL, NULL, 'Interferon-induced 35 kDa protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(37348, NULL, 'G3DSA:1.10.10.10:FF:001464', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(37349, NULL, 'G3DSA:2.130.10.10:FF:005621', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37350, NULL, 'G3DSA:1.25.40.10:FF:000213', NULL, NULL, 'Tetratricopeptide repeat domain 36', NULL, NULL, NULL, NULL, NULL, 4),
(37351, NULL, 'G3DSA:2.30.29.30:FF:000684', NULL, NULL, 'SH2B adaptor protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(37352, NULL, 'G3DSA:3.80.10.10:FF:002890', NULL, NULL, 'Si:ch211-209n20.3', NULL, NULL, NULL, NULL, NULL, 4),
(37353, NULL, 'G3DSA:3.40.140.10:FF:000111', NULL, NULL, 'Histone H2A deubiquitinase MYSM1', NULL, NULL, NULL, NULL, NULL, 4),
(37354, NULL, 'G3DSA:3.50.30.30:FF:000021', NULL, NULL, 'N-acetylated alpha-linked acidic dipeptidase-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(37355, NULL, 'G3DSA:3.40.50.410:FF:000343', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37356, NULL, 'G3DSA:3.30.420.110:FF:000007', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(37357, NULL, 'G3DSA:1.10.287.10:FF:000056', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37358, NULL, 'G3DSA:3.30.720.50:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37359, NULL, 'G3DSA:3.30.1330.90:FF:000011', NULL, NULL, 'L-serine ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(37360, NULL, 'G3DSA:3.80.10.10:FF:003137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37361, NULL, 'G3DSA:3.30.60.30:FF:000012', NULL, NULL, 'SPARC-related modular calcium binding protein 1', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(37362, NULL, 'G3DSA:3.30.70.960:FF:000008', NULL, NULL, 'Transmembrane protease serine', NULL, NULL, NULL, NULL, NULL, 4),
(37363, NULL, 'G3DSA:1.25.40.20:FF:000216', NULL, NULL, 'Ankyrin repeat and KH domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(37364, NULL, 'G3DSA:2.130.10.10:FF:000422', NULL, NULL, 'BCAS3 microtubule-associated cell migration factor', NULL, NULL, NULL, NULL, NULL, 4),
(37365, NULL, 'G3DSA:2.60.120.200:FF:000814', NULL, NULL, 'Calreticulin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(37366, NULL, 'G3DSA:3.60.21.10:FF:000100', NULL, NULL, 'Vacuolar protein sorting-associated protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(37367, NULL, 'G3DSA:3.30.160.60:FF:000242', NULL, NULL, 'Endolytic murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(37368, NULL, 'G3DSA:1.25.40.10:FF:005356', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(37369, NULL, 'G3DSA:1.20.120.1780:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37370, NULL, 'G3DSA:3.40.50.410:FF:000219', NULL, NULL, 'ABL030Wp', NULL, NULL, NULL, NULL, NULL, 4),
(37371, NULL, 'G3DSA:3.40.50.1460:FF:000044', NULL, NULL, 'Caspase, apoptotic cysteine protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37372, NULL, 'G3DSA:2.170.11.10:FF:000001', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(37373, NULL, 'G3DSA:2.30.29.150:FF:000006', NULL, NULL, 'Transcription factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(37374, NULL, 'G3DSA:2.130.10.10:FF:001350', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(37375, NULL, 'G3DSA:3.60.120.10:FF:000027', NULL, NULL, 'ICS1', NULL, NULL, NULL, NULL, NULL, 4),
(37376, NULL, 'G3DSA:1.25.40.450:FF:000014', NULL, NULL, 'Nuclear pore complex protein nup155, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37377, NULL, 'G3DSA:1.25.50.20:FF:000014', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(37378, NULL, 'G3DSA:2.70.20.60:FF:000002', NULL, NULL, 'Matrix protein', NULL, NULL, NULL, NULL, NULL, 4),
(37379, NULL, 'G3DSA:2.30.30.140:FF:000056', NULL, NULL, 'DNA/RNA-binding protein kin17-like', NULL, NULL, NULL, NULL, NULL, 4),
(37380, NULL, 'G3DSA:1.20.5.110:FF:000118', NULL, NULL, 'Bet1 SNARE 1-2', NULL, NULL, NULL, NULL, NULL, 4),
(37381, NULL, 'G3DSA:1.25.10.10:FF:001318', NULL, NULL, 'Protein CBG13183', NULL, NULL, NULL, NULL, NULL, 4),
(37382, NULL, 'G3DSA:1.10.510.10:FF:000300', NULL, NULL, 'Calmodulin-binding receptor-like cytoplasmic kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(37383, NULL, 'G3DSA:1.10.630.10:FF:000416', NULL, NULL, 'Cytochrome P-450 IIC4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37384, NULL, 'G3DSA:1.10.472.80:FF:000108', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(37385, NULL, 'G3DSA:3.40.50.2000:FF:000566', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(37386, NULL, 'G3DSA:1.10.510.10:FF:004038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37387, NULL, 'G3DSA:2.60.40.10:FF:001748', NULL, NULL, 'Jitterbug, isoform M', NULL, NULL, NULL, NULL, NULL, 4),
(37388, NULL, 'G3DSA:3.40.1110.10:FF:000423', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37389, NULL, 'G3DSA:3.40.50.360:FF:000069', NULL, NULL, 'Flavodoxin', NULL, NULL, NULL, NULL, NULL, 4),
(37390, NULL, 'G3DSA:2.120.10.30:FF:000569', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37391, NULL, 'G3DSA:2.30.110.10:FF:000048', NULL, NULL, 'Flavin reductase domain protein, FMN-binding', NULL, NULL, NULL, NULL, NULL, 4),
(37392, NULL, 'G3DSA:3.30.460.10:FF:000177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37393, NULL, 'G3DSA:3.30.70.940:FF:000002', NULL, NULL, 'Transcription termination/antitermination protein NusG', NULL, NULL, NULL, NULL, NULL, 4),
(37394, NULL, 'G3DSA:1.20.1560.10:FF:000738', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(37395, NULL, 'G3DSA:2.60.40.420:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37396, NULL, 'G3DSA:3.10.180.20:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37397, NULL, 'G3DSA:3.30.70.330:FF:000617', NULL, NULL, 'Puf family protein', NULL, NULL, NULL, NULL, NULL, 4),
(37398, NULL, 'G3DSA:1.25.40.10:FF:002776', NULL, NULL, 'YALI0E17303p', NULL, NULL, NULL, NULL, NULL, 4),
(37399, NULL, 'G3DSA:3.40.250.10:FF:000142', NULL, NULL, 'Putative thiosulfate sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(37400, NULL, 'G3DSA:1.20.1560.10:FF:000087', NULL, NULL, 'p-GlycoProtein related', NULL, NULL, NULL, NULL, NULL, 4),
(37401, NULL, 'G3DSA:3.90.640.10:FF:000138', NULL, NULL, 'AGAP004488-PA', NULL, NULL, NULL, NULL, NULL, 4),
(37402, NULL, 'G3DSA:1.20.58.60:FF:000537', NULL, NULL, 'Nesprin-2', NULL, NULL, NULL, NULL, NULL, 4),
(37403, NULL, 'G3DSA:6.10.140.2220:FF:000051', NULL, NULL, 'GD11242', NULL, NULL, NULL, NULL, NULL, 4),
(37404, NULL, 'G3DSA:1.25.40.10:FF:001085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37405, NULL, 'G3DSA:1.25.10.10:FF:002302', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(37406, NULL, 'G3DSA:1.10.238.10:FF:001269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37407, NULL, 'G3DSA:3.40.30.10:FF:000330', NULL, NULL, 'Heat shock protein DnaJ homologue Pfj2', NULL, NULL, NULL, NULL, NULL, 4),
(37408, NULL, 'G3DSA:1.25.10.10:FF:003084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37409, NULL, 'G3DSA:3.20.20.80:FF:000761', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37410, NULL, 'G3DSA:3.40.50.300:FF:006111', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(37411, NULL, 'G3DSA:3.40.50.2300:FF:001550', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37412, NULL, 'G3DSA:3.30.160.190:FF:000005', NULL, NULL, 'NADH dehydrogenase [ubiquinone] iron-sulfur protein 4, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(37413, NULL, 'G3DSA:1.20.1740.10:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37414, NULL, 'G3DSA:3.30.160.60:FF:006200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37415, NULL, 'G3DSA:2.60.40.10:FF:005643', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37416, NULL, 'G3DSA:2.60.40.10:FF:001372', NULL, NULL, 'Ig heavy chain V region M603', NULL, NULL, NULL, NULL, NULL, 4),
(37417, NULL, 'G3DSA:3.30.2130.30:FF:000028', NULL, NULL, 'Thiamine biosynthesis protein ThiI, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37418, NULL, 'G3DSA:2.60.40.1180:FF:000170', NULL, NULL, 'Glycoside hydrolase family 95', NULL, NULL, NULL, NULL, NULL, 4),
(37419, NULL, 'G3DSA:3.40.50.1000:FF:000305', NULL, NULL, 'D-glycero-alpha-D-manno-heptose-1,7-bisphosphate 7-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(37420, NULL, 'G3DSA:2.60.40.3510:FF:000003', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(37421, NULL, 'G3DSA:2.80.10.50:FF:000234', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(37422, NULL, 'G3DSA:2.30.29.90:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37423, NULL, 'G3DSA:1.20.1050.130:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37424, NULL, 'G3DSA:3.10.580.10:FF:000050', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(37425, NULL, 'G3DSA:2.10.220.10:FF:000100', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(37426, NULL, 'G3DSA:3.20.20.190:FF:000146', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37427, NULL, 'G3DSA:3.30.70.980:FF:000020', NULL, NULL, 'Probable transcriptional regulatory protein CWS35_11355', NULL, NULL, NULL, NULL, NULL, 4),
(37428, NULL, 'G3DSA:1.25.40.10:FF:004867', NULL, NULL, 'Diguanylate cyclase (GGDEF) domain protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(37429, NULL, 'G3DSA:2.60.40.10:FF:000118', NULL, NULL, 'filamin-C isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(37430, NULL, 'G3DSA:1.10.555.10:FF:000230', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37431, NULL, 'G3DSA:3.30.30.30:FF:000038', NULL, NULL, 'Heat shock protein 70 homolog LHS1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37432, NULL, 'G3DSA:2.60.120.10:FF:000452', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(37433, NULL, 'G3DSA:2.60.40.10:FF:003463', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37434, NULL, 'G3DSA:2.40.50.140:FF:000485', NULL, NULL, 'nuclease-sensitive element-binding protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(37435, NULL, 'G3DSA:3.30.1640.10:FF:000050', NULL, NULL, 'Minichromosome maintenance protein MCM', NULL, NULL, NULL, NULL, NULL, 4),
(37436, NULL, 'G3DSA:3.40.250.10:FF:000232', NULL, NULL, 'Sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(37437, NULL, 'G3DSA:2.30.140.10:FF:000022', NULL, NULL, 'Spermidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(37438, NULL, 'G3DSA:3.30.200.20:FF:000695', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37439, NULL, 'G3DSA:3.40.1350.10:FF:000020', NULL, NULL, 'Fanconi-associated nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(37440, NULL, 'G3DSA:1.25.40.20:FF:001677', NULL, NULL, 'Stress-activated protein kinase alpha', NULL, NULL, NULL, NULL, NULL, 4),
(37441, NULL, 'G3DSA:3.30.160.60:FF:003619', NULL, NULL, 'Zinc finger protein 588, isoform CRA_d', NULL, NULL, NULL, NULL, NULL, 4),
(37442, NULL, 'G3DSA:2.130.10.10:FF:005149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37443, NULL, 'G3DSA:2.10.60.10:FF:000083', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(37444, NULL, 'G3DSA:3.40.50.2300:FF:000566', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(37445, NULL, 'G3DSA:4.10.410.10:FF:000113', NULL, NULL, 'Salivary protein KUN-5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37446, NULL, 'G3DSA:3.80.10.10:FF:000647', NULL, NULL, 'Leucine-rich repeat-containing 29', NULL, NULL, NULL, NULL, NULL, 4),
(37447, NULL, 'G3DSA:3.90.1410.10:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37448, NULL, 'G3DSA:3.50.30.30:FF:000077', NULL, NULL, 'Serin endopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(37449, NULL, 'G3DSA:3.40.50.300:FF:007572', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37450, NULL, 'G3DSA:4.10.280.10:FF:000203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37451, NULL, 'G3DSA:1.25.10.10:FF:000211', NULL, NULL, 'Anaphase-promoting complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(37452, NULL, 'G3DSA:2.60.120.330:FF:000241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37453, NULL, 'G3DSA:1.10.8.480:FF:000001', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(37454, NULL, 'G3DSA:3.30.420.10:FF:000107', NULL, NULL, 'Poly(A) ribonuclease POP2', NULL, NULL, NULL, NULL, NULL, 4),
(37455, NULL, 'G3DSA:1.20.1280.50:FF:000009', NULL, NULL, 'F-box only protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(37456, NULL, 'G3DSA:4.10.400.10:FF:000174', NULL, NULL, 'Low-density lipoprotein receptor-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(37457, NULL, 'G3DSA:1.10.630.10:FF:000186', NULL, NULL, 'Cytochrome P450, putative (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(37458, NULL, 'G3DSA:3.30.40.10:FF:001371', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37459, NULL, 'G3DSA:2.120.10.80:FF:000033', NULL, NULL, 'Multiple epidermal growth factor-like domains 8', NULL, NULL, NULL, NULL, NULL, 4),
(37460, NULL, 'G3DSA:1.20.970.10:FF:000006', NULL, NULL, 'Anthranilate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(37461, NULL, 'G3DSA:3.40.50.300:FF:001586', NULL, NULL, 'Small GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(37462, NULL, 'G3DSA:3.30.70.100:FF:000043', NULL, NULL, 'Copper-transporting ATPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(37463, NULL, 'G3DSA:3.30.230.10:FF:000194', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37464, NULL, 'G3DSA:2.130.10.10:FF:003643', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37465, NULL, 'G3DSA:2.130.10.10:FF:005767', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37466, NULL, 'G3DSA:1.25.10.10:FF:001313', NULL, NULL, 'Protein SIEL', NULL, NULL, NULL, NULL, NULL, 4),
(37467, NULL, 'G3DSA:3.40.50.300:FF:006442', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37468, NULL, 'G3DSA:3.40.920.10:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37469, NULL, 'G3DSA:3.30.70.1230:FF:000242', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37470, NULL, 'G3DSA:3.30.70.590:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37471, NULL, 'G3DSA:3.30.40.10:FF:001601', NULL, NULL, 'RING finger protein 151', NULL, NULL, NULL, NULL, NULL, 4),
(37472, NULL, 'G3DSA:3.30.70.141:FF:000039', NULL, NULL, 'Nucleoside diphosphate kinase B', NULL, NULL, NULL, NULL, NULL, 4),
(37473, NULL, 'G3DSA:3.60.21.10:FF:000302', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(37474, NULL, 'G3DSA:3.30.70.330:FF:000999', NULL, NULL, 'Polypyrimidine tract binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37475, NULL, 'G3DSA:1.20.1310.10:FF:000102', NULL, NULL, 'Cullin family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37476, NULL, 'G3DSA:3.30.70.1730:FF:000004', NULL, NULL, 'Ribosome assembly factor mrt4', NULL, NULL, NULL, NULL, NULL, 4),
(37477, NULL, 'G3DSA:3.30.1460.20:FF:000016', NULL, NULL, 'Arp2/3 complex 34 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(37478, NULL, 'G3DSA:2.130.10.10:FF:003148', NULL, NULL, 'Intraflagellar transport protein 122', NULL, NULL, NULL, NULL, NULL, 4),
(37479, NULL, 'G3DSA:3.40.640.10:FF:000189', NULL, NULL, 'Glycine dehydrogenase (decarboxylating)', NULL, NULL, NULL, NULL, NULL, 4),
(37480, NULL, 'G3DSA:3.30.160.60:FF:001967', NULL, NULL, 'Ras-responsive element-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(37481, NULL, 'G3DSA:2.130.10.10:FF:003351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37482, NULL, 'G3DSA:3.30.860.10:FF:000016', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 14-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(37483, NULL, 'G3DSA:3.30.40.10:FF:000258', NULL, NULL, 'Vacuolar protein sorting-associated protein 11 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(37484, NULL, 'G3DSA:3.30.750.44:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37485, NULL, 'G3DSA:1.10.287.700:FF:000004', NULL, NULL, 'Late embryogenesis abundant protein (LEA) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(37486, NULL, 'G3DSA:2.130.10.10:FF:001496', NULL, NULL, 'WD domain, G-beta repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(37487, NULL, 'G3DSA:1.25.40.10:FF:003086', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(37488, NULL, 'G3DSA:1.10.1520.10:FF:000093', NULL, NULL, 'Endoribonuclease Dicer-like', NULL, NULL, NULL, NULL, NULL, 4),
(37489, NULL, 'G3DSA:2.60.40.10:FF:005317', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37490, NULL, 'G3DSA:3.40.50.720:FF:002555', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37491, NULL, 'G3DSA:3.40.50.10190:FF:000116', NULL, NULL, 'Nibrin', NULL, NULL, NULL, NULL, NULL, 4),
(37492, NULL, 'G3DSA:2.20.28.10:FF:000030', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(37493, NULL, 'G3DSA:1.10.510.10:FF:001374', NULL, NULL, 'PH-protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(37494, NULL, 'G3DSA:3.30.70.1720:FF:000001', NULL, NULL, 'Bifunctional hemolysin/adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(37495, NULL, 'G3DSA:2.60.40.1230:FF:000022', NULL, NULL, 'AP-1 complex subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(37496, NULL, 'G3DSA:2.40.37.10:FF:000016', NULL, NULL, 'Carboxynorspermidine/carboxyspermidine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(37497, NULL, 'G3DSA:3.60.10.10:FF:000311', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37498, NULL, 'G3DSA:3.30.60.30:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37499, NULL, 'G3DSA:2.130.10.10:FF:003295', NULL, NULL, 'Serine/threonine-protein kinase/endoribonuclease IRE2', NULL, NULL, NULL, NULL, NULL, 4),
(37500, NULL, 'G3DSA:3.40.630.30:FF:000520', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37501, NULL, 'G3DSA:2.60.120.620:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37502, NULL, 'G3DSA:3.30.1330.30:FF:000072', NULL, NULL, '60S ribosomal protein L7A-2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37503, NULL, 'G3DSA:3.10.280.10:FF:000010', NULL, NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(37504, NULL, 'G3DSA:1.10.840.10:FF:000016', NULL, NULL, 'RASGEF1A isoform 5', NULL, NULL, NULL, NULL, NULL, 4),
(37505, NULL, 'G3DSA:1.10.565.10:FF:000056', NULL, NULL, 'Nuclear hormone receptor family member nhr-49', NULL, NULL, NULL, NULL, NULL, 4),
(37506, NULL, 'G3DSA:1.10.455.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37507, NULL, 'G3DSA:1.10.10.10:FF:002004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37508, NULL, 'G3DSA:1.10.10.60:FF:001159', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37509, NULL, 'G3DSA:2.60.120.970:FF:000112', NULL, NULL, 'Anti-dorsalizing morphogenetic protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37510, NULL, 'G3DSA:3.20.20.190:FF:000174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37511, NULL, 'G3DSA:3.40.50.300:FF:005099', NULL, NULL, 'GTP-binding protein A', NULL, NULL, NULL, NULL, NULL, 4),
(37512, NULL, 'G3DSA:1.10.1200.10:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37513, NULL, 'G3DSA:3.20.20.100:FF:000069', NULL, NULL, 'Protein CBG12061', NULL, NULL, NULL, NULL, NULL, 4),
(37514, NULL, 'G3DSA:1.10.630.10:FF:000096', NULL, NULL, 'Cytochrome P450 3A4', NULL, NULL, NULL, NULL, NULL, 4),
(37515, NULL, 'G3DSA:3.60.20.10:FF:000132', NULL, NULL, 'Asparagine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(37516, NULL, 'G3DSA:4.10.400.10:FF:000264', NULL, NULL, 'LDL receptor-like repeat', NULL, NULL, NULL, NULL, NULL, 4),
(37517, NULL, 'G3DSA:1.20.1070.10:FF:000656', NULL, NULL, 'neuropeptide FF receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(37518, NULL, 'G3DSA:1.50.40.10:FF:000391', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37519, NULL, 'G3DSA:1.25.10.10:FF:001936', NULL, NULL, 'E3 ubiquitin-protein ligase UPL1', NULL, NULL, NULL, NULL, NULL, 4),
(37520, NULL, 'G3DSA:1.20.120.1080:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37521, NULL, 'G3DSA:1.10.10.60:FF:000411', NULL, NULL, 'Transcription factor TRY', NULL, NULL, NULL, NULL, NULL, 4),
(37522, NULL, 'G3DSA:1.20.1070.10:FF:000712', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37523, NULL, 'G3DSA:3.40.30.10:FF:000622', NULL, NULL, 'Protein disulfide isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(37524, NULL, 'G3DSA:1.10.268.10:FF:000017', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(37525, NULL, 'G3DSA:3.40.50.1010:FF:000078', NULL, NULL, 'Ribonuclease VapC', NULL, NULL, NULL, NULL, NULL, 4),
(37526, NULL, 'G3DSA:2.60.40.10:FF:001046', NULL, NULL, 'Immunoglobulin superfamily member 10', NULL, NULL, NULL, NULL, NULL, 4),
(37527, NULL, 'G3DSA:1.10.3720.10:FF:000102', NULL, NULL, 'Oligopeptide ABC transporter permease OppC', NULL, NULL, NULL, NULL, NULL, 4),
(37528, NULL, 'G3DSA:1.10.340.70:FF:000024', NULL, NULL, 'OSJNBa0059D20.8 protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(37529, NULL, 'G3DSA:3.90.1580.10:FF:000008', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37530, NULL, 'G3DSA:2.30.40.10:FF:000064', NULL, NULL, 'Formylmethanofuran dehydrogenase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(37531, NULL, 'G3DSA:1.20.1070.10:FF:000566', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37532, NULL, 'G3DSA:3.40.630.30:FF:000610', NULL, NULL, 'Elongator complex protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(37533, NULL, 'G3DSA:3.20.19.10:FF:000006', NULL, NULL, 'Aconitate hydratase 1', NULL, NULL, NULL, NULL, NULL, 4),
(37534, NULL, 'G3DSA:1.10.510.10:FF:003173', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37535, NULL, 'G3DSA:3.30.160.60:FF:001349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37536, NULL, 'G3DSA:2.60.220.50:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37537, NULL, 'G3DSA:3.40.50.1100:FF:000043', NULL, NULL, 'Cysteine synthase, chloroplastic/chromoplastic', NULL, NULL, NULL, NULL, NULL, 4),
(37538, NULL, 'G3DSA:2.20.110.10:FF:000039', NULL, NULL, 'Protein ACCUMULATION AND REPLICATION OF CHLOROPLASTS 3', NULL, NULL, NULL, NULL, NULL, 4),
(37539, NULL, 'G3DSA:1.10.287.70:FF:000444', NULL, NULL, 'Potassium voltage-gated channel, KQT-like subfamily, member 4', NULL, NULL, NULL, NULL, NULL, 4),
(37540, NULL, 'G3DSA:3.20.20.20:FF:000024', NULL, NULL, 'Tetrahydromethanopterin S-methyltransferase subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(37541, NULL, 'G3DSA:2.60.40.420:FF:000068', NULL, NULL, 'coagulation factor V isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(37542, NULL, 'G3DSA:2.60.40.10:FF:000028', NULL, NULL, 'Neuronal cell adhesion molecule', NULL, NULL, NULL, NULL, NULL, 4),
(37543, NULL, 'G3DSA:2.30.30.40:FF:000521', NULL, NULL, 'phosphatidylinositol 3-kinase regulatory subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(37544, NULL, 'G3DSA:3.40.50.2300:FF:001555', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37545, NULL, 'G3DSA:3.30.2320.20:FF:000001', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(37546, NULL, 'G3DSA:3.30.2320.30:FF:000004', NULL, NULL, 'Putative ATP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(37547, NULL, 'G3DSA:3.40.850.10:FF:000289', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37548, NULL, 'G3DSA:3.20.20.10:FF:000021', NULL, NULL, 'Pyridoxal phosphate homeostasis protein', NULL, NULL, NULL, NULL, NULL, 4),
(37549, NULL, 'G3DSA:3.40.50.10490:FF:000088', NULL, NULL, 'Glucokinase regulator', NULL, NULL, NULL, NULL, NULL, 4),
(37550, NULL, 'G3DSA:3.20.20.30:FF:000027', NULL, NULL, '5,10-methylenetetrahydromethanopterin reductase', NULL, NULL, NULL, NULL, NULL, 4),
(37551, NULL, 'G3DSA:3.40.50.410:FF:000371', NULL, NULL, '60 kDa SS-A/Ro ribonucleoprotein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(37552, NULL, 'G3DSA:1.20.58.60:FF:000684', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37553, NULL, 'G3DSA:1.20.120.1770:FF:000004', NULL, NULL, 'CYB561A3 isoform 10', NULL, NULL, NULL, NULL, NULL, 4),
(37554, NULL, 'G3DSA:1.20.1070.10:FF:000364', NULL, NULL, 'Frizzled receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(37555, NULL, 'G3DSA:3.40.50.2000:FF:000476', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(37556, NULL, 'G3DSA:3.40.50.300:FF:000512', NULL, NULL, 'Rac-like GTP-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(37557, NULL, 'G3DSA:2.30.30.870:FF:000005', NULL, NULL, 'Protein DOM34 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(37558, NULL, 'G3DSA:1.20.900.10:FF:000058', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(37559, NULL, 'G3DSA:3.30.710.10:FF:000450', NULL, NULL, 'SKp1 Related (Ubiquitin ligase complex component)', NULL, NULL, NULL, NULL, NULL, 4),
(37560, NULL, 'G3DSA:2.60.40.10:FF:005464', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37561, NULL, 'G3DSA:3.40.50.1820:FF:001506', NULL, NULL, 'Protein CBG10315', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(37562, NULL, 'G3DSA:3.40.850.10:FF:000435', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37563, NULL, 'G3DSA:3.90.660.10:FF:000050', NULL, NULL, 'Polyamine oxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37564, NULL, 'G3DSA:3.90.1750.10:FF:000050', NULL, NULL, 'E3 ubiquitin-protein ligase hecd-1', NULL, NULL, NULL, NULL, NULL, 4),
(37565, NULL, 'G3DSA:1.20.120.1760:FF:000001', NULL, NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(37566, NULL, 'G3DSA:3.40.50.1370:FF:000017', NULL, NULL, 'Ornithine carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(37567, NULL, 'G3DSA:3.40.50.720:FF:001453', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37568, NULL, 'G3DSA:3.30.70.80:FF:000005', NULL, NULL, 'Proteinase inhibitor I2B', NULL, NULL, NULL, NULL, NULL, 4),
(37569, NULL, 'G3DSA:3.40.50.300:FF:007044', NULL, NULL, 'Small GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37570, NULL, 'G3DSA:3.40.50.10090:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37571, NULL, 'G3DSA:1.25.40.180:FF:000057', NULL, NULL, 'Initiation Factor 4G (eIF4G) family', NULL, NULL, NULL, NULL, NULL, 4),
(37572, NULL, 'G3DSA:1.10.565.10:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37573, NULL, 'G3DSA:3.40.50.10330:FF:000124', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(37574, NULL, 'G3DSA:2.40.50.40:FF:000056', NULL, NULL, 'Heterochromatin protein 1c', NULL, NULL, NULL, NULL, NULL, 4),
(37575, NULL, 'G3DSA:3.30.160.60:FF:002979', NULL, NULL, 'LD21421p', NULL, NULL, NULL, NULL, NULL, 4),
(37576, NULL, 'G3DSA:3.30.190.20:FF:000024', NULL, NULL, '50S ribosomal protein L1', NULL, NULL, NULL, NULL, NULL, 4),
(37577, NULL, 'G3DSA:1.50.10.160:FF:000018', NULL, NULL, 'Os12g0491500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(37578, NULL, 'G3DSA:1.10.720.30:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37579, NULL, 'G3DSA:1.10.565.10:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37580, NULL, 'G3DSA:2.60.40.10:FF:001607', NULL, NULL, 'Leukocyte immune-type receptor TS32.15 L2.5a', NULL, NULL, NULL, NULL, NULL, 4),
(37581, NULL, 'G3DSA:1.20.144.10:FF:000020', NULL, NULL, 'phospholipid phosphatase 6', NULL, NULL, NULL, NULL, NULL, 4),
(37582, NULL, 'G3DSA:3.20.20.140:FF:000417', NULL, NULL, '5-methylthioadenosine/S-adenosylhomocysteine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(37583, NULL, 'G3DSA:1.25.40.20:FF:000042', NULL, NULL, 'caskin-2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(37584, NULL, 'G3DSA:1.10.510.10:FF:002678', NULL, NULL, 'Probable serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(37585, NULL, 'G3DSA:1.10.10.10:FF:001638', NULL, NULL, 'AGAP008638-PA', NULL, NULL, NULL, NULL, NULL, 4),
(37586, NULL, 'G3DSA:3.40.850.10:FF:000345', NULL, NULL, 'Kinesin-like protein KIN-7N', NULL, NULL, NULL, NULL, NULL, 4),
(37587, NULL, 'G3DSA:1.20.1270.60:FF:000192', NULL, NULL, 'YALI0D07524p', NULL, NULL, NULL, NULL, NULL, 4),
(37588, NULL, 'G3DSA:3.30.390.110:FF:000010', NULL, NULL, '60S ribosomal protein L28-2', NULL, NULL, NULL, NULL, NULL, 4),
(37589, NULL, 'G3DSA:3.90.550.20:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37590, NULL, 'G3DSA:1.20.1560.10:FF:000564', NULL, NULL, 'Multidrug resistance protein 1, 2, 3', NULL, NULL, NULL, NULL, NULL, 4),
(37591, NULL, 'G3DSA:2.40.290.10:FF:000013', NULL, NULL, 'ATP-dependent DNA helicase II subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(37592, NULL, 'G3DSA:3.30.70.330:FF:000797', NULL, NULL, 'Nonsense-mediated mRNA decay protein Upf3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37593, NULL, 'G3DSA:1.50.10.150:FF:000015', NULL, NULL, 'Putative malic acid transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(37594, NULL, 'G3DSA:3.40.50.1110:FF:000046', NULL, NULL, 'Protein CBG23371', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(37595, NULL, 'G3DSA:3.90.190.10:FF:000558', NULL, NULL, 'Dual-specificity protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37596, NULL, 'G3DSA:3.10.105.10:FF:000076', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(37597, NULL, 'G3DSA:3.40.50.300:FF:000602', NULL, NULL, 'Serine protein kinase PrkA', NULL, NULL, NULL, NULL, NULL, 4),
(37598, NULL, 'G3DSA:3.80.10.10:FF:000973', NULL, NULL, 'Tubulin-specific chaperone E', NULL, NULL, NULL, NULL, NULL, 4),
(37599, NULL, 'G3DSA:3.30.450.20:FF:000269', NULL, NULL, 'Two-component sensor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(37600, NULL, 'G3DSA:1.20.58.530:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37601, NULL, 'G3DSA:2.40.30.70:FF:000013', NULL, NULL, 'tRNA methyltransferase O', NULL, NULL, NULL, NULL, NULL, 4),
(37602, NULL, 'G3DSA:3.40.50.1400:FF:000009', NULL, NULL, 'Ferrochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(37603, NULL, 'G3DSA:1.25.10.20:FF:000012', NULL, NULL, 'Hemelipoglyco-carrier protein CP3', NULL, NULL, NULL, NULL, NULL, 4),
(37604, NULL, 'G3DSA:1.20.58.60:FF:000740', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37605, NULL, 'G3DSA:3.40.50.300:FF:006116', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(37606, NULL, 'G3DSA:1.10.8.10:FF:000316', NULL, NULL, 'DNA (cytosine-5)-methyltransferase DRM1', NULL, NULL, NULL, NULL, NULL, 4),
(37607, NULL, 'G3DSA:3.40.50.740:FF:000060', NULL, NULL, 'NADH-quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(37608, NULL, 'G3DSA:2.60.120.10:FF:000126', NULL, NULL, 'Cyclic nucleotide-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(37609, NULL, 'G3DSA:3.30.160.60:FF:003912', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37610, NULL, 'G3DSA:3.30.40.10:FF:000584', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(37611, NULL, 'G3DSA:1.20.5.110:FF:000321', NULL, NULL, 'Synaptosomal-associated protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(37612, NULL, 'G3DSA:3.30.160.20:FF:000168', NULL, NULL, 'Ribonuclease III', NULL, NULL, NULL, NULL, NULL, 4),
(37613, NULL, 'G3DSA:3.20.20.70:FF:000432', NULL, NULL, 'tRNA-dihydrouridine(20) synthase [NAD(P)+]-like', NULL, NULL, NULL, NULL, NULL, 4),
(37614, NULL, 'G3DSA:3.40.1280.10:FF:000082', NULL, NULL, 'TrmH family tRNA/rRNA methyltransferase YacO', NULL, NULL, NULL, NULL, NULL, 4),
(37615, NULL, 'G3DSA:1.20.1270.220:FF:000011', NULL, NULL, 'SWR1 complex bromodomain subunit bdf1', NULL, NULL, NULL, NULL, NULL, 4),
(37616, NULL, 'G3DSA:3.40.50.1820:FF:000641', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(37617, NULL, 'G3DSA:3.30.160.60:FF:004401', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37618, NULL, 'G3DSA:2.60.40.10:FF:003171', NULL, NULL, 'LOC100005699 protein', NULL, NULL, NULL, NULL, NULL, 4),
(37619, NULL, 'G3DSA:2.60.40.10:FF:001574', NULL, NULL, 'Blast:Putative epidermal cell surface receptor', NULL, NULL, NULL, NULL, NULL, 4),
(37620, NULL, 'G3DSA:1.25.10.10:FF:003258', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37621, NULL, 'G3DSA:1.10.3810.10:FF:000019', NULL, NULL, 'Penicillin-binding protein 1C', NULL, NULL, NULL, NULL, NULL, 4),
(37622, NULL, 'G3DSA:3.10.290.60:FF:000003', NULL, NULL, 'Ubiquitin-like modifier activating enzyme 6', NULL, NULL, NULL, NULL, NULL, 4),
(37623, NULL, 'G3DSA:3.30.160.60:FF:003822', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37624, NULL, 'G3DSA:3.10.290.70:FF:000006', NULL, NULL, '40S ribosomal protein S8', NULL, NULL, NULL, NULL, NULL, 4),
(37625, NULL, 'G3DSA:3.40.30.10:FF:000532', NULL, NULL, 'Uncharacterized protein T09A5.5', NULL, NULL, NULL, NULL, NULL, 4),
(37626, NULL, 'G3DSA:4.10.280.110:FF:000006', NULL, NULL, 'U4/U6 small nuclear ribonucleoprotein Prp4', NULL, NULL, NULL, NULL, NULL, 4),
(37627, NULL, 'G3DSA:1.20.1070.10:FF:001022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37628, NULL, 'G3DSA:2.10.50.10:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(37629, NULL, 'G3DSA:4.10.400.10:FF:000320', NULL, NULL, 'uncharacterized protein LOC100180965 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(37630, NULL, 'G3DSA:1.10.630.10:FF:000388', NULL, NULL, 'Os04g0480600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(37631, NULL, 'G3DSA:3.30.160.60:FF:006172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37632, NULL, 'G3DSA:2.60.120.260:FF:000664', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37633, NULL, 'G3DSA:3.40.50.620:FF:000636', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(37634, NULL, 'G3DSA:1.10.10.60:FF:001069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37635, NULL, 'G3DSA:2.20.25.530:FF:000013', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(37636, NULL, 'G3DSA:3.90.470.20:FF:000021', NULL, NULL, 'L-aminoadipate-semialdehyde dehydrogenase-phosphopantetheinyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(37637, NULL, 'G3DSA:1.20.58.60:FF:000863', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37638, NULL, 'G3DSA:3.40.50.150:FF:001557', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37639, NULL, 'G3DSA:2.60.120.10:FF:000396', NULL, NULL, 'cAMP-binding protein-catabolite gene activator and regulatory subunit of cAMP-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(37640, NULL, 'G3DSA:3.30.479.20:FF:000026', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(37641, NULL, 'G3DSA:2.60.120.260:FF:000574', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37642, NULL, 'G3DSA:2.40.128.20:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37643, NULL, 'G3DSA:3.20.20.70:FF:000342', NULL, NULL, 'tRNA-dihydrouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(37644, NULL, 'G3DSA:3.40.50.1100:FF:000133', NULL, NULL, 'Serine racemase', NULL, NULL, NULL, NULL, NULL, 4),
(37645, NULL, 'G3DSA:3.30.160.60:FF:001877', NULL, NULL, 'Zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(37646, NULL, 'G3DSA:3.90.190.10:FF:000182', NULL, NULL, 'Protein-tyrosine-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(37647, NULL, 'G3DSA:3.50.50.60:FF:000598', NULL, NULL, 'FAD-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(37648, NULL, 'G3DSA:1.20.1070.10:FF:000038', NULL, NULL, 'Muscarinic acetylcholine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(37649, NULL, 'G3DSA:3.40.190.80:FF:000062', NULL, NULL, 'Inositol polyphosphate 1-phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37650, NULL, 'G3DSA:2.60.40.10:FF:005587', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37651, NULL, 'G3DSA:3.30.470.20:FF:000181', NULL, NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(37652, NULL, 'G3DSA:1.10.510.10:FF:000441', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(37653, NULL, 'G3DSA:3.30.230.10:FF:000368', NULL, NULL, 'Lon protease homolog 1 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(37654, NULL, 'G3DSA:3.80.10.10:FF:004065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37655, NULL, 'G3DSA:3.30.479.30:FF:000029', NULL, NULL, 'Band 7 protein', NULL, NULL, NULL, NULL, NULL, 4),
(37656, NULL, 'G3DSA:1.10.1200.10:FF:000107', NULL, NULL, 'Ferricrocin synthetase (Nonribosomal peptide siderophore synthase ) (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(37657, NULL, 'G3DSA:2.30.42.10:FF:000607', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37658, NULL, 'G3DSA:1.10.287.4070:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37659, NULL, 'G3DSA:2.20.100.10:FF:000123', NULL, NULL, 'SCO-spondin', NULL, NULL, NULL, NULL, NULL, 4),
(37660, NULL, 'G3DSA:3.30.160.60:FF:004311', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37661, NULL, 'G3DSA:1.25.40.10:FF:003563', NULL, NULL, 'Reduced mechanoreceptor potential A', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(37662, NULL, 'G3DSA:3.40.50.1010:FF:000134', NULL, NULL, 'Phosphate starvation protein PhoH', NULL, NULL, NULL, NULL, NULL, 4),
(37663, NULL, 'G3DSA:3.30.390.80:FF:000001', NULL, NULL, 'DNA repair protein RAD52 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(37664, NULL, 'G3DSA:2.60.40.1930:FF:000024', NULL, NULL, 'Alpha-2-macroglobulin-like', NULL, NULL, NULL, NULL, NULL, 4),
(37665, NULL, 'G3DSA:2.130.10.10:FF:002985', NULL, NULL, 'YALI0B17798p', NULL, NULL, NULL, NULL, NULL, 4),
(37666, NULL, 'G3DSA:1.25.40.10:FF:001141', NULL, NULL, 'Tetratricopeptide repeat protein 30A', NULL, NULL, NULL, NULL, NULL, 4),
(37667, NULL, 'G3DSA:2.60.120.200:FF:000337', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(37668, NULL, 'G3DSA:3.60.10.10:FF:000159', NULL, NULL, 'Putative neutral sphingomyelinase', NULL, NULL, NULL, NULL, NULL, 4),
(37669, NULL, 'G3DSA:3.40.50.1000:FF:000131', NULL, NULL, 'HAD superfamily hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37670, NULL, 'G3DSA:2.30.110.10:FF:000104', NULL, NULL, 'Cellular repressor of E1A stimulated genes 1', NULL, NULL, NULL, NULL, NULL, 4),
(37671, NULL, 'G3DSA:2.10.110.10:FF:000238', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37672, NULL, 'G3DSA:3.20.20.80:FF:000345', NULL, NULL, 'Secreted alpha-amylase', NULL, NULL, NULL, NULL, NULL, 4),
(37673, NULL, 'G3DSA:3.40.50.1110:FF:000136', NULL, NULL, 'Similar to acyl-CoA thioesterase I', NULL, NULL, NULL, NULL, NULL, 4),
(37674, NULL, 'G3DSA:1.10.510.10:FF:003818', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37675, NULL, 'G3DSA:3.40.50.300:FF:007746', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37676, NULL, 'G3DSA:1.20.1070.10:FF:000892', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37677, NULL, 'G3DSA:1.10.1040.10:FF:000016', NULL, NULL, 'Glyoxylate/succinic semialdehyde reductase 2', NULL, NULL, NULL, NULL, NULL, 4),
(37678, NULL, 'G3DSA:2.40.50.140:FF:000659', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37679, NULL, 'G3DSA:1.10.10.540:FF:000006', NULL, NULL, 'Unplaced genomic scaffold supercont2.19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(37680, NULL, 'G3DSA:3.90.70.10:FF:000072', NULL, NULL, 'Cysteine proteinase', NULL, NULL, NULL, NULL, NULL, 4),
(37681, NULL, 'G3DSA:3.90.640.10:FF:000048', NULL, NULL, 'Heat shock protein 110', NULL, NULL, NULL, NULL, NULL, 4),
(37682, NULL, 'G3DSA:2.30.29.30:FF:000594', NULL, NULL, 'YLR072Wp protein', NULL, NULL, NULL, NULL, NULL, 4),
(37683, NULL, 'G3DSA:2.40.50.90:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37684, NULL, 'G3DSA:2.60.120.200:FF:000668', NULL, NULL, 'Clade XVII lectin receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(37685, NULL, 'G3DSA:3.30.160.60:FF:002895', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37686, NULL, 'G3DSA:3.80.10.10:FF:002974', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37687, NULL, 'G3DSA:3.40.50.300:FF:003862', NULL, NULL, 'U3 small nucleolar RNA-associated protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(37688, NULL, 'G3DSA:3.30.160.60:FF:004603', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37689, NULL, 'G3DSA:1.10.510.10:FF:004010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37690, NULL, 'G3DSA:3.80.10.10:FF:002502', NULL, NULL, 'Leucine-rich repeat kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(37691, NULL, 'G3DSA:2.130.10.110:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37692, NULL, 'G3DSA:3.40.50.720:FF:002381', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37693, NULL, 'G3DSA:3.40.50.300:FF:006026', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(37694, NULL, 'G3DSA:3.30.310.10:FF:000048', NULL, NULL, 'AP-1 complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(37695, NULL, 'G3DSA:1.20.1110.10:FF:000244', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(37696, NULL, 'G3DSA:1.25.10.10:FF:001083', NULL, NULL, 'Dynein assembly factor 5, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(37697, NULL, 'G3DSA:2.10.25.10:FF:000456', NULL, NULL, 'Neurogenic locus notch homolog protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(37698, NULL, 'G3DSA:1.20.1070.10:FF:001201', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37699, NULL, 'G3DSA:3.40.50.300:FF:007662', NULL, NULL, 'SMC domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(37700, NULL, 'G3DSA:3.80.10.10:FF:002446', NULL, NULL, 'Receptor like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(37701, NULL, 'G3DSA:3.20.20.80:FF:000289', NULL, NULL, 'Beta-mannosidase Man2', NULL, NULL, NULL, NULL, NULL, 4),
(37702, NULL, 'G3DSA:1.10.472.10:FF:000222', NULL, NULL, 'Retinoblastoma family protein', NULL, NULL, NULL, NULL, NULL, 4),
(37703, NULL, 'G3DSA:1.10.287.130:FF:000171', NULL, NULL, 'Integral membrane sensor signal transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(37704, NULL, 'G3DSA:1.25.40.570:FF:000045', NULL, NULL, 'YALI0D25102p', NULL, NULL, NULL, NULL, NULL, 4),
(37705, NULL, 'G3DSA:3.20.20.70:FF:000286', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(37706, NULL, 'G3DSA:2.60.40.10:FF:001933', NULL, NULL, 'Blast:Contactin', NULL, NULL, NULL, NULL, NULL, 4),
(37707, NULL, 'G3DSA:3.40.50.300:FF:001676', NULL, NULL, 'DExH-box ATP-dependent RNA helicase DExH7 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(37708, NULL, 'G3DSA:3.40.50.150:FF:001378', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37709, NULL, 'G3DSA:3.30.160.60:FF:000332', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM37 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(37710, NULL, 'G3DSA:3.30.450.20:FF:000180', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(37711, NULL, 'G3DSA:3.30.70.330:FF:001163', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(37712, NULL, 'G3DSA:3.30.420.10:FF:000725', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37713, NULL, 'G3DSA:3.30.70.2850:FF:000008', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(37714, NULL, 'G3DSA:1.20.1560.10:FF:000233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37715, NULL, 'G3DSA:3.30.70.330:FF:002742', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37716, NULL, 'G3DSA:1.20.1250.20:FF:000752', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37717, NULL, 'G3DSA:3.30.70.2840:FF:000005', NULL, NULL, 'NS5 protein', NULL, NULL, NULL, NULL, NULL, 4),
(37718, NULL, 'G3DSA:1.10.10.350:FF:000016', NULL, NULL, 'Glutamate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(37719, NULL, 'G3DSA:3.40.50.620:FF:000726', NULL, NULL, 'Electron transfer flavoprotein, beta subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37720, NULL, 'G3DSA:1.20.120.790:FF:000001', NULL, NULL, 'Heat shock protein 90 alpha', NULL, NULL, NULL, NULL, NULL, 4),
(37721, NULL, 'G3DSA:3.40.50.150:FF:001849', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37722, NULL, 'G3DSA:3.40.50.300:FF:007128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37723, NULL, 'G3DSA:3.40.50.720:FF:000666', NULL, NULL, 'Probable oxidoreductase EphD', NULL, NULL, NULL, NULL, NULL, 4),
(37724, NULL, 'G3DSA:3.20.20.80:FF:000671', NULL, NULL, 'Glucosylceramidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37725, NULL, 'G3DSA:1.25.10.10:FF:003174', NULL, NULL, 'PIKK family atypical protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(37726, NULL, 'G3DSA:1.10.510.10:FF:003403', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37727, NULL, 'G3DSA:1.20.1280.290:FF:000079', NULL, NULL, 'Os09g0258700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(37728, NULL, 'G3DSA:3.40.190.10:FF:000968', NULL, NULL, 'Extracellular solute-binding protein, family 5', NULL, NULL, NULL, NULL, NULL, 4),
(37729, NULL, 'G3DSA:3.30.40.10:FF:000730', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(37730, NULL, 'G3DSA:3.40.50.300:FF:005571', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37731, NULL, 'G3DSA:3.70.10.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37732, NULL, 'G3DSA:1.10.1200.10:FF:000080', NULL, NULL, 'Peptidyl carrier protein PltL', NULL, NULL, NULL, NULL, NULL, 4),
(37733, NULL, 'G3DSA:3.30.70.330:FF:002888', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37734, NULL, 'G3DSA:1.10.3370.10:FF:000030', NULL, NULL, 'Protein translocase subunit SecY', NULL, NULL, NULL, NULL, NULL, 4),
(37735, NULL, 'G3DSA:3.30.300.30:FF:000138', NULL, NULL, 'Nonribosomal peptide synthetase 8', NULL, NULL, NULL, NULL, NULL, 4),
(37736, NULL, 'G3DSA:3.40.50.300:FF:007605', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37737, NULL, 'G3DSA:3.40.50.1820:FF:000725', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(37738, NULL, 'G3DSA:3.20.20.140:FF:000092', NULL, NULL, 'Formylmethanofuran dehydrogenase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(37739, NULL, 'G3DSA:2.60.40.10:FF:004154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37740, NULL, 'G3DSA:1.10.510.10:FF:003549', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37741, NULL, 'G3DSA:1.10.287.370:FF:000006', NULL, NULL, 'prefoldin subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(37742, NULL, 'G3DSA:2.130.10.10:FF:004986', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37743, NULL, 'G3DSA:4.10.400.10:FF:000090', NULL, NULL, 'neuropilin and tolloid-like protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(37744, NULL, 'G3DSA:2.60.120.200:FF:000253', NULL, NULL, 'FlaMIngo (Cadherin plus 7TM domain) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(37745, NULL, 'G3DSA:2.10.70.10:FF:000145', NULL, NULL, 'Pappalysin 2', NULL, NULL, NULL, NULL, NULL, 4),
(37746, NULL, 'G3DSA:3.80.10.10:FF:004155', NULL, NULL, 'Protein phosphatase 2C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37747, NULL, 'G3DSA:1.25.40.10:FF:000977', NULL, NULL, 'MAU2 chromatid cohesion factor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(37748, NULL, 'G3DSA:1.20.1560.10:FF:000177', NULL, NULL, 'Iron ABC transporter ATP-binding protein/permease IrtA', NULL, NULL, NULL, NULL, NULL, 4),
(37749, NULL, 'G3DSA:3.30.40.10:FF:000617', NULL, NULL, 'Peroxin 10', NULL, NULL, NULL, NULL, NULL, 4),
(37750, NULL, 'G3DSA:1.10.630.10:FF:000803', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37751, NULL, 'G3DSA:1.20.140.90:FF:000001', NULL, NULL, 'Malonyl-CoA decarboxylase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(37752, NULL, 'G3DSA:1.10.510.10:FF:001458', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(37753, NULL, 'G3DSA:3.30.760.10:FF:000037', NULL, NULL, 'Translation initiation factor eIF-4e-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(37754, NULL, 'G3DSA:1.10.1520.10:FF:000126', NULL, NULL, 'RNase3 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(37755, NULL, 'G3DSA:3.30.200.20:FF:001392', NULL, NULL, 'Kinase, PEK', NULL, NULL, NULL, NULL, NULL, 4),
(37756, NULL, 'G3DSA:3.30.300.10:FF:000019', NULL, NULL, 'S-adenosylmethionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(37757, NULL, 'G3DSA:2.120.10.30:FF:000479', NULL, NULL, 'Diisopropyl-fluorophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(37758, NULL, 'G3DSA:1.20.1250.20:FF:000465', NULL, NULL, 'Carboxylic acid transporter protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(37759, NULL, 'G3DSA:1.25.40.20:FF:000660', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37760, NULL, 'G3DSA:3.30.450.20:FF:000595', NULL, NULL, 'Sensor histidine kinase, PAS and PAS domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(37761, NULL, 'G3DSA:3.30.70.330:FF:001308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37762, NULL, 'G3DSA:1.10.533.10:FF:000100', NULL, NULL, 'NLR family pyrin domain containing 11', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(37763, NULL, 'G3DSA:2.30.30.190:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37764, NULL, 'G3DSA:2.40.10.10:FF:000134', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(37765, NULL, 'G3DSA:3.30.40.10:FF:000674', NULL, NULL, 'HRD1p Ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(37766, NULL, 'G3DSA:1.20.1740.10:FF:000275', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37767, NULL, 'G3DSA:1.10.287.380:FF:000009', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(37768, NULL, 'G3DSA:1.10.510.10:FF:003347', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37769, NULL, 'G3DSA:3.40.50.300:FF:002283', NULL, NULL, 'p-GlycoProtein related', NULL, NULL, NULL, NULL, NULL, 4),
(37770, NULL, 'G3DSA:3.30.450.20:FF:000556', NULL, NULL, 'Putative histidine kinase (PhoR1)', NULL, NULL, NULL, NULL, NULL, 4),
(37771, NULL, 'G3DSA:3.30.200.20:FF:001353', NULL, NULL, 'AGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(37772, NULL, 'G3DSA:3.30.1520.10:FF:000069', NULL, NULL, 'YPT35p Endosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(37773, NULL, 'G3DSA:1.10.1410.10:FF:000090', NULL, NULL, 'MUTator', NULL, NULL, NULL, NULL, NULL, 4),
(37774, NULL, 'G3DSA:1.10.150.910:FF:000017', NULL, NULL, 'UV-damaged DNA binding complex subunit 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(37775, NULL, 'G3DSA:1.20.1740.10:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37776, NULL, 'G3DSA:3.30.420.380:FF:000004', NULL, NULL, 'Type II secretion system protein L', NULL, NULL, NULL, NULL, NULL, 4),
(37777, NULL, 'G3DSA:3.10.20.90:FF:000343', NULL, NULL, 'Zinc metalloproteinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37778, NULL, 'G3DSA:3.40.1020.10:FF:000006', NULL, NULL, 'Threonine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(37779, NULL, 'G3DSA:3.30.70.270:FF:000195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37780, NULL, 'G3DSA:3.30.160.60:FF:005385', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37781, NULL, 'G3DSA:1.20.920.10:FF:000060', NULL, NULL, 'PH-interacting protein isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(37782, NULL, 'G3DSA:3.80.10.10:FF:000029', NULL, NULL, 'Transport inhibitor response 1', NULL, NULL, NULL, NULL, NULL, 4),
(37783, NULL, 'G3DSA:2.40.70.10:FF:000110', NULL, NULL, 'Yps7p', NULL, NULL, NULL, NULL, NULL, 4),
(37784, NULL, 'G3DSA:1.10.8.1160:FF:000001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37785, NULL, 'G3DSA:1.20.920.20:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37786, NULL, 'G3DSA:3.40.1500.20:FF:000001', NULL, NULL, 'Red chlorophyll catabolite reductase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(37787, NULL, 'G3DSA:1.25.40.10:FF:003029', NULL, NULL, 'Pentatricopeptide repeat protein PPR868-14 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(37788, NULL, 'G3DSA:1.25.10.10:FF:001459', NULL, NULL, 'Protein kinase family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(37789, NULL, 'G3DSA:3.90.550.10:FF:000311', NULL, NULL, 'Cellulose synthase-like protein H2', NULL, NULL, NULL, NULL, NULL, 4),
(37790, NULL, 'G3DSA:3.40.50.300:FF:002081', NULL, NULL, 'Small GTPase EhRabX6, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37791, NULL, 'G3DSA:3.40.50.1820:FF:001512', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37792, NULL, 'G3DSA:3.30.420.370:FF:000001', NULL, NULL, 'Type II secretion system protein L', NULL, NULL, NULL, NULL, NULL, 4),
(37793, NULL, 'G3DSA:3.30.70.1230:FF:000096', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(37794, NULL, 'G3DSA:3.40.850.10:FF:000519', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37795, NULL, 'G3DSA:1.25.40.1040:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37796, NULL, 'G3DSA:2.60.40.10:FF:005790', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(37797, NULL, 'G3DSA:1.10.530.10:FF:000004', NULL, NULL, 'Membrane-bound lytic murein transglycosylase D', NULL, NULL, NULL, NULL, NULL, 4),
(37798, NULL, 'G3DSA:1.20.1600.10:FF:000001', NULL, NULL, 'TolC outer membrane channel', NULL, NULL, NULL, NULL, NULL, 4),
(37799, NULL, 'G3DSA:3.40.50.10490:FF:000094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37800, NULL, 'G3DSA:4.10.280.10:FF:000113', NULL, NULL, 'Transcription factor ILI1', NULL, NULL, NULL, NULL, NULL, 4),
(37801, NULL, 'G3DSA:1.10.8.10:FF:000081', NULL, NULL, 'GTPase activating protein for Arf', NULL, NULL, NULL, NULL, NULL, 4),
(37802, NULL, 'G3DSA:3.30.40.10:FF:001281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37803, NULL, 'G3DSA:3.30.70.330:FF:001106', NULL, NULL, 'Nuclear acid binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37804, NULL, 'G3DSA:3.30.40.10:FF:000819', NULL, NULL, 'RING finger protein nhl-1', NULL, NULL, NULL, NULL, NULL, 4),
(37805, NULL, 'G3DSA:3.40.50.300:FF:001619', NULL, NULL, 'ATP-dependent DNA helicase PIF1', NULL, NULL, NULL, NULL, NULL, 4),
(37806, NULL, 'G3DSA:2.60.120.330:FF:000151', NULL, NULL, 'Os08g0249900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(37807, NULL, 'G3DSA:1.10.1200.10:FF:000023', NULL, NULL, 'Acyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(37808, NULL, 'G3DSA:2.60.40.10:FF:001990', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(37809, NULL, 'G3DSA:3.30.70.100:FF:000133', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37810, NULL, 'G3DSA:3.30.1490.20:FF:000018', NULL, NULL, 'Biotin carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(37811, NULL, 'G3DSA:3.80.10.10:FF:002917', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37812, NULL, 'G3DSA:2.60.98.10:FF:000004', NULL, NULL, 'Structural polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(37813, NULL, 'G3DSA:1.25.10.10:FF:000301', NULL, NULL, 'Heat shock transcription factor 2 binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(37814, NULL, 'G3DSA:2.40.50.140:FF:000715', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37815, NULL, 'G3DSA:3.20.20.70:FF:000606', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37816, NULL, 'G3DSA:1.10.510.10:FF:000115', NULL, NULL, 'Dual specificity mitogen-activated protein kinase kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(37817, NULL, 'G3DSA:2.30.39.10:FF:000032', NULL, NULL, 'Uteroferrin-associated basic protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(37818, NULL, 'G3DSA:3.40.50.2000:FF:001055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37819, NULL, 'G3DSA:1.50.10.10:FF:000232', NULL, NULL, 'N-acylglucosamine 2-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(37820, NULL, 'G3DSA:1.10.630.10:FF:000747', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37821, NULL, 'G3DSA:3.90.190.10:FF:000266', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37822, NULL, 'G3DSA:3.40.630.30:FF:000317', NULL, NULL, 'AGAP000132-PA', NULL, NULL, NULL, NULL, NULL, 4),
(37823, NULL, 'G3DSA:1.10.437.10:FF:000034', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37824, NULL, 'G3DSA:3.20.20.80:FF:000609', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37825, NULL, 'G3DSA:3.30.160.60:FF:003766', NULL, NULL, 'Histone-lysine N-methyltransferase PRDM9', NULL, NULL, NULL, NULL, NULL, 4),
(37826, NULL, 'G3DSA:3.40.1350.150:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37827, NULL, 'G3DSA:3.80.10.10:FF:000557', NULL, NULL, 'Toll-6', NULL, NULL, NULL, NULL, NULL, 4),
(37828, NULL, 'G3DSA:3.40.630.30:FF:000374', NULL, NULL, 'N-terminal acetyltransferase complex subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37829, NULL, 'G3DSA:3.40.50.1000:FF:000075', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(37830, NULL, 'G3DSA:3.10.250.10:FF:000093', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37831, NULL, 'G3DSA:3.10.580.10:FF:000078', NULL, NULL, 'HlyC/CorC family transporter', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(37832, NULL, 'G3DSA:1.10.10.10:FF:001279', NULL, NULL, 'Protein CBR-ELK-2', NULL, NULL, NULL, NULL, NULL, 4),
(37833, NULL, 'G3DSA:3.30.160.60:FF:003620', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37834, NULL, 'G3DSA:2.30.30.100:FF:000185', NULL, NULL, 'Sm protein', NULL, NULL, NULL, NULL, NULL, 4),
(37835, NULL, 'G3DSA:2.60.40.1180:FF:000080', NULL, NULL, '1,4-alpha-glucan-branching enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(37836, NULL, 'G3DSA:2.60.120.10:FF:000542', NULL, NULL, 'Cyclic nucleotide-binding protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(37837, NULL, 'G3DSA:3.40.50.150:FF:001760', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37838, NULL, 'G3DSA:3.30.930.10:FF:000432', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37839, NULL, 'G3DSA:3.40.50.300:FF:005947', NULL, NULL, 'Putative ATP-dependent RNA helicase DHX40', NULL, NULL, NULL, NULL, NULL, 4),
(37840, NULL, 'G3DSA:2.10.70.10:FF:000201', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37841, NULL, 'G3DSA:3.80.10.10:FF:004357', NULL, NULL, 'Leucine rich repeats and calponin homology domain containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(37842, NULL, 'G3DSA:2.40.40.20:FF:000021', NULL, NULL, 'Cell division cycle protein 48 homologue', NULL, NULL, NULL, NULL, NULL, 4),
(37843, NULL, 'G3DSA:2.60.120.200:FF:000781', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(37844, NULL, 'G3DSA:3.90.360.10:FF:000010', NULL, NULL, 'Histone acetyltransferase, type b catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(37845, NULL, 'G3DSA:3.90.226.10:FF:000041', NULL, NULL, 'Propionyl-CoA carboxylase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(37846, NULL, 'G3DSA:1.10.357.120:FF:000004', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(37847, NULL, 'G3DSA:3.30.160.60:FF:003676', NULL, NULL, 'Protein suppressor of hairy wing', NULL, NULL, NULL, NULL, NULL, 4),
(37848, NULL, 'G3DSA:3.40.30.10:FF:000240', NULL, NULL, 'TPR repeat-containing thioredoxin TDX', NULL, NULL, NULL, NULL, NULL, 4),
(37849, NULL, 'G3DSA:1.20.920.10:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37850, NULL, 'G3DSA:1.20.120.350:FF:000223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37851, NULL, 'G3DSA:3.90.70.10:FF:000015', NULL, NULL, 'Ubiquitin specific peptidase 10', NULL, NULL, NULL, NULL, NULL, 4),
(37852, NULL, 'G3DSA:1.10.150.50:FF:000150', NULL, NULL, 'SAM_domain_(Sterile_alpha_motif)_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(37853, NULL, 'G3DSA:3.90.228.10:FF:000023', NULL, NULL, 'mRNA, clone: RTFL01-11-B23', NULL, NULL, NULL, NULL, NULL, 4),
(37854, NULL, 'G3DSA:2.60.98.20:FF:000007', NULL, NULL, 'Flagellar hook protein FlgE', NULL, NULL, NULL, NULL, NULL, 4),
(37855, NULL, 'G3DSA:3.20.20.70:FF:000516', NULL, NULL, 'Triosephosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(37856, NULL, 'G3DSA:1.10.357.110:FF:000001', NULL, NULL, 'vacuolar protein sorting-associated protein 53 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(37857, NULL, 'G3DSA:1.10.10.10:FF:001133', NULL, NULL, 'Fork-head transcriptional regulator FHL1', NULL, NULL, NULL, NULL, NULL, 4),
(37858, NULL, 'G3DSA:2.60.40.10:FF:005733', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37859, NULL, 'G3DSA:2.60.120.200:FF:000629', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37860, NULL, 'G3DSA:2.30.29.30:FF:000537', NULL, NULL, 'Inorganic pyrophosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37861, NULL, 'G3DSA:3.40.1120.10:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37862, NULL, 'G3DSA:3.40.850.10:FF:000199', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(37863, NULL, 'G3DSA:3.90.190.10:FF:000356', NULL, NULL, 'Tyrosine-protein phosphatase 3', NULL, NULL, NULL, NULL, NULL, 4),
(37864, NULL, 'G3DSA:1.25.40.10:FF:001433', NULL, NULL, 'Os10g0501200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(37865, NULL, 'G3DSA:3.20.20.330:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(37866, NULL, 'G3DSA:3.30.70.330:FF:002944', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37867, NULL, 'G3DSA:1.25.40.660:FF:000015', NULL, NULL, 'Vacuolar protein sorting-associated protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(37868, NULL, 'G3DSA:1.10.238.10:FF:000015', NULL, NULL, 'Calcium-dependent protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(37869, NULL, 'G3DSA:1.10.3500.10:FF:000030', NULL, NULL, 'Glycine rich protein', NULL, NULL, NULL, NULL, NULL, 4),
(37870, NULL, 'G3DSA:3.20.20.80:FF:000519', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37871, NULL, 'G3DSA:3.60.40.10:FF:000077', NULL, NULL, 'Protein phosphatase 1A', NULL, NULL, NULL, NULL, NULL, 4),
(37872, NULL, 'G3DSA:1.10.10.10:FF:001841', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(37873, NULL, 'G3DSA:3.30.420.10:FF:000438', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37874, NULL, 'G3DSA:3.10.250.10:FF:000036', NULL, NULL, 'CD163 molecule like 1', NULL, NULL, NULL, NULL, NULL, 4),
(37875, NULL, 'G3DSA:3.30.160.60:FF:001585', NULL, NULL, 'Zinc finger protein 329', NULL, NULL, NULL, NULL, NULL, 4),
(37876, NULL, 'G3DSA:1.20.1560.10:FF:000648', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37877, NULL, 'G3DSA:2.130.10.10:FF:005391', NULL, NULL, 'WD repeat-containing protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(37878, NULL, 'G3DSA:3.40.30.10:FF:000386', NULL, NULL, '54S ribosomal protein L51', NULL, NULL, NULL, NULL, NULL, 4),
(37879, NULL, 'G3DSA:3.40.50.150:FF:000068', NULL, NULL, 'Ribosomal RNA-processing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(37880, NULL, 'G3DSA:2.60.260.20:FF:000111', NULL, NULL, 'Cobalamin ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(37881, NULL, 'G3DSA:1.10.238.20:FF:000018', NULL, NULL, 'General odorant-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(37882, NULL, 'G3DSA:1.10.246.140:FF:000002', NULL, NULL, 'Enhancer of yellow 2 transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(37883, NULL, 'G3DSA:1.10.287.2900:FF:000013', NULL, NULL, 'Coiled-coil-helix-coiled-coil-helix domain-containing 4b', NULL, NULL, NULL, NULL, NULL, 4),
(37884, NULL, 'G3DSA:1.20.1250.20:FF:001769', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37885, NULL, 'G3DSA:3.30.70.270:FF:000285', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37886, NULL, 'G3DSA:3.30.160.60:FF:005475', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37887, NULL, 'G3DSA:1.50.40.10:FF:000060', NULL, NULL, 'Mitochondrial carnitine carrier', NULL, NULL, NULL, NULL, NULL, 4),
(37888, NULL, 'G3DSA:1.25.10.10:FF:001605', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37889, NULL, 'G3DSA:3.40.1550.10:FF:000001', NULL, NULL, 'Flagellar motor switch protein FliM', NULL, NULL, NULL, NULL, NULL, 4),
(37890, NULL, 'G3DSA:3.30.160.60:FF:000096', NULL, NULL, 'Zinc finger and BTB domain-containing protein 18 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(37891, NULL, 'G3DSA:3.30.1680.30:FF:000002', NULL, NULL, 'Variant surface glycoprotein (VSG, atypical), putative', NULL, NULL, NULL, NULL, NULL, 4),
(37892, NULL, 'G3DSA:3.60.21.10:FF:000246', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(37893, NULL, 'G3DSA:1.25.10.10:FF:001791', NULL, NULL, 'AP-3 complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(37894, NULL, 'G3DSA:1.10.287.950:FF:000028', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(37895, NULL, 'G3DSA:3.40.1550.20:FF:000004', NULL, NULL, 'Transcriptional regulator MraZ', NULL, NULL, NULL, NULL, NULL, 4),
(37896, NULL, 'G3DSA:3.30.505.10:FF:000102', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(37897, NULL, 'G3DSA:1.20.58.340:FF:000013', NULL, NULL, 'Magnesium transporter MRS2-11, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(37898, NULL, 'G3DSA:3.20.20.120:FF:000024', NULL, NULL, '2-oxoglutarate decarboxylase/ hydro-lyase/ magnesium ion binding protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(37899, NULL, 'G3DSA:1.10.8.60:FF:000247', NULL, NULL, 'Flagellar regulatory protein C', NULL, NULL, NULL, NULL, NULL, 4),
(37900, NULL, 'G3DSA:3.40.50.720:FF:001161', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(37901, NULL, 'G3DSA:2.60.40.10:FF:005172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37902, NULL, 'G3DSA:1.10.472.80:FF:000260', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37903, NULL, 'G3DSA:3.40.50.1820:FF:000495', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(37904, NULL, 'G3DSA:3.40.33.10:FF:000044', NULL, NULL, 'SCP-Like extracellular protein', NULL, NULL, NULL, NULL, NULL, 4),
(37905, NULL, 'G3DSA:3.30.160.60:FF:001675', NULL, NULL, 'Zinc finger protein 329', NULL, NULL, NULL, NULL, NULL, 4),
(37906, NULL, 'G3DSA:1.10.1070.11:FF:000002', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', NULL, NULL, NULL, NULL, NULL, 4),
(37907, NULL, 'G3DSA:3.10.450.700:FF:000004', NULL, NULL, 'Transcriptional activator protein Pur-alpha', NULL, NULL, NULL, NULL, NULL, 4),
(37908, NULL, 'G3DSA:1.10.472.80:FF:000018', NULL, NULL, 'TBC1 domain family member 2B', NULL, NULL, NULL, NULL, NULL, 4),
(37909, NULL, 'G3DSA:4.10.280.10:FF:000170', NULL, NULL, 'Putative myc-like protein MYCLP1', NULL, NULL, NULL, NULL, NULL, 4),
(37910, NULL, 'G3DSA:1.20.58.1020:FF:000002', NULL, NULL, 'DNA replication complex GINS protein', NULL, NULL, NULL, NULL, NULL, 4),
(37911, NULL, 'G3DSA:1.25.10.10:FF:000155', NULL, NULL, 'Protein MOR1', NULL, NULL, NULL, NULL, NULL, 4),
(37912, NULL, 'G3DSA:3.90.190.10:FF:000412', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37913, NULL, 'G3DSA:2.130.10.10:FF:005239', NULL, NULL, 'Chromatin modification-related protein rik1', NULL, NULL, NULL, NULL, NULL, 4),
(37914, NULL, 'G3DSA:1.20.1160.20:FF:000020', NULL, NULL, 'Regulator of telomere elongation helicase 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(37915, NULL, 'G3DSA:3.30.710.10:FF:000449', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37916, NULL, 'G3DSA:3.30.200.20:FF:001914', NULL, NULL, 'Dual specificity protein kinase zak2', NULL, NULL, NULL, NULL, NULL, 4),
(37917, NULL, 'G3DSA:1.25.70.10:FF:000041', NULL, NULL, 'Transcription termination factor family protein', NULL, NULL, NULL, NULL, NULL, 4),
(37918, NULL, 'G3DSA:3.40.50.2300:FF:000914', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37919, NULL, 'G3DSA:3.80.10.10:FF:002266', NULL, NULL, 'Promastigote surface antigen protein PSA', NULL, NULL, NULL, NULL, NULL, 4),
(37920, NULL, 'G3DSA:2.130.10.30:FF:000164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37921, NULL, 'G3DSA:3.40.50.150:FF:001850', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37922, NULL, 'G3DSA:1.10.287.1490:FF:000034', NULL, NULL, 'Synaptonemal complex protein ZIP1', NULL, NULL, NULL, NULL, NULL, 4),
(37923, NULL, 'G3DSA:3.40.1410.10:FF:000019', NULL, NULL, 'Transcriptional regulator, GntR family', NULL, NULL, NULL, NULL, NULL, 4),
(37924, NULL, 'G3DSA:3.60.40.10:FF:000133', NULL, NULL, 'Protein serine/threonine phosphatase 2C', NULL, NULL, NULL, NULL, NULL, 4),
(37925, NULL, 'G3DSA:1.10.10.10:FF:000205', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(37926, NULL, 'G3DSA:3.20.20.140:FF:000272', NULL, NULL, 'Adenosine deaminase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37927, NULL, 'G3DSA:1.25.40.850:FF:000005', NULL, NULL, 'Vacuolar protein sorting 33B', NULL, NULL, NULL, NULL, NULL, 4),
(37928, NULL, 'G3DSA:3.40.50.720:FF:001122', NULL, NULL, 'Adenylyltransferase and sulfurtransferase uba4', NULL, NULL, NULL, NULL, NULL, 4),
(37929, NULL, 'G3DSA:1.50.40.10:FF:000003', NULL, NULL, 'Putative calcium-binding mitochondrial carrier protein scamc-2', NULL, NULL, NULL, NULL, NULL, 4),
(37930, NULL, 'G3DSA:2.60.40.10:FF:003991', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37931, NULL, 'G3DSA:3.30.70.240:FF:000034', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(37932, NULL, 'G3DSA:1.25.40.1030:FF:000005', NULL, NULL, 'Protein transport protein sec16', NULL, NULL, NULL, NULL, NULL, 4),
(37933, NULL, 'G3DSA:1.20.1560.10:FF:000941', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37934, NULL, 'G3DSA:3.40.50.720:FF:000846', NULL, NULL, 'Quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(37935, NULL, 'G3DSA:1.10.150.50:FF:000037', NULL, NULL, 'sphingomyelin synthase-related protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(37936, NULL, 'G3DSA:3.30.2230.10:FF:000019', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(37937, NULL, 'G3DSA:3.40.33.10:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37938, NULL, 'G3DSA:3.20.20.60:FF:000042', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(37939, NULL, 'G3DSA:3.40.50.2300:FF:001263', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37940, NULL, 'G3DSA:3.30.40.100:FF:000003', NULL, NULL, 'MORC family CW-type zinc finger 3', NULL, NULL, NULL, NULL, NULL, 4),
(37941, NULL, 'G3DSA:4.10.95.10:FF:000001', NULL, NULL, 'Cytochrome c oxidase subunit 6A, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(37942, NULL, 'G3DSA:1.25.10.10:FF:001644', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(37943, NULL, 'G3DSA:1.25.40.1040:FF:000008', NULL, NULL, 'Cleavage stimulation factor subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(37944, NULL, 'G3DSA:1.25.40.840:FF:000002', NULL, NULL, 'Ccr4-Not transcription complex subunit (NOT1)', NULL, NULL, NULL, NULL, NULL, 4),
(37945, NULL, 'G3DSA:2.130.10.10:FF:001552', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37946, NULL, 'G3DSA:3.40.50.2300:FF:001224', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37947, NULL, 'G3DSA:2.30.30.140:FF:000258', NULL, NULL, 'SAGA-associated factor 29', NULL, NULL, NULL, NULL, NULL, 4),
(37948, NULL, 'G3DSA:3.40.50.10140:FF:000039', NULL, NULL, 'Putative serine/threonine-protein kinase pats1', NULL, NULL, NULL, NULL, NULL, 4),
(37949, NULL, 'G3DSA:1.10.287.70:FF:000736', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37950, NULL, 'G3DSA:2.30.34.10:FF:000004', NULL, NULL, 'GP63, leishmanolysin', NULL, NULL, NULL, NULL, NULL, 4),
(37951, NULL, 'G3DSA:1.10.472.80:FF:000170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37952, NULL, 'G3DSA:3.50.50.60:FF:001323', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37953, NULL, 'G3DSA:2.60.40.10:FF:003373', NULL, NULL, 'Lymphocyte activating 3', NULL, NULL, NULL, NULL, NULL, 4),
(37954, NULL, 'G3DSA:3.50.50.60:FF:001138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37955, NULL, 'G3DSA:3.40.50.10140:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37956, NULL, 'G3DSA:3.40.50.10130:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37957, NULL, 'G3DSA:2.60.120.620:FF:000058', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37958, NULL, 'G3DSA:1.10.287.70:FF:000085', NULL, NULL, 'Transient receptor potential cation channel subfamily V member 3', NULL, NULL, NULL, NULL, NULL, 4),
(37959, NULL, 'G3DSA:2.130.10.10:FF:003682', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37960, NULL, 'G3DSA:3.50.50.60:FF:001380', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37961, NULL, 'G3DSA:3.30.160.60:FF:005531', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37962, NULL, 'G3DSA:3.40.309.10:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37963, NULL, 'G3DSA:1.10.2000.10:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37964, NULL, 'G3DSA:3.90.340.10:FF:000008', NULL, NULL, 'Nitric oxide synthase, inducible', NULL, NULL, NULL, NULL, NULL, 4),
(37965, NULL, 'G3DSA:1.25.40.10:FF:002866', NULL, NULL, 'Sll0837 protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(37966, NULL, 'G3DSA:1.25.40.10:FF:005272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37967, NULL, 'G3DSA:2.60.40.60:FF:000234', NULL, NULL, 'Si:dkey-22o22.2', NULL, NULL, NULL, NULL, NULL, 4),
(37968, NULL, 'G3DSA:1.10.10.880:FF:000001', NULL, NULL, 'Anti-sigma-E factor RseA', NULL, NULL, NULL, NULL, NULL, 4),
(37969, NULL, 'G3DSA:3.30.70.260:FF:000192', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37970, NULL, 'G3DSA:1.25.40.70:FF:000006', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit gamma isoform', NULL, NULL, NULL, NULL, NULL, 4),
(37971, NULL, 'G3DSA:2.40.160.110:FF:000002', NULL, NULL, 'lysosome-associated membrane glycoprotein 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(37972, NULL, 'G3DSA:2.40.160.120:FF:000005', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(37973, NULL, 'G3DSA:3.40.50.150:FF:000124', NULL, NULL, 'HEN methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(37974, NULL, 'G3DSA:3.40.50.1220:FF:000079', NULL, NULL, 'Probable electron transfer flavoprotein alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(37975, NULL, 'G3DSA:1.20.1070.10:FF:001999', NULL, NULL, 'Si:ch211-132e22.4', NULL, NULL, NULL, NULL, NULL, 4),
(37976, NULL, 'G3DSA:1.20.5.110:FF:000091', NULL, NULL, 'Syntaxin, Qa-SNARE family', NULL, NULL, NULL, NULL, NULL, 4),
(37977, NULL, 'G3DSA:1.25.40.60:FF:000003', NULL, NULL, 'Vacuolar protein sorting-associated protein 45', NULL, NULL, NULL, NULL, NULL, 4),
(37978, NULL, 'G3DSA:3.30.1360.180:FF:000001', NULL, NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase family member 6', NULL, NULL, NULL, NULL, NULL, 4),
(37979, NULL, 'G3DSA:2.130.10.10:FF:000006', NULL, NULL, 'Plexin A2', NULL, NULL, NULL, NULL, NULL, 4),
(37980, NULL, 'G3DSA:3.30.70.3400:FF:000005', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(37981, NULL, 'G3DSA:1.25.40.80:FF:000009', NULL, NULL, 'Deoxyribodipyrimidine photo-lyase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37982, NULL, 'G3DSA:1.20.5.2950:FF:000007', NULL, NULL, 'Vacuolar ATP synthase subunit G', NULL, NULL, NULL, NULL, NULL, 4),
(37983, NULL, 'G3DSA:3.30.160.60:FF:005565', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37984, NULL, 'G3DSA:3.40.50.11740:FF:000002', NULL, NULL, 'Hydrogenase maturation factor', NULL, NULL, NULL, NULL, NULL, 4),
(37985, NULL, 'G3DSA:3.40.50.720:FF:001009', NULL, NULL, 'HPGD isoform 12', NULL, NULL, NULL, NULL, NULL, 4),
(37986, NULL, 'G3DSA:1.25.40.10:FF:005182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(37987, NULL, 'G3DSA:3.30.200.20:FF:000369', NULL, NULL, 'G2-specific protein kinase NimA', NULL, NULL, NULL, NULL, NULL, 4),
(37988, NULL, 'G3DSA:3.30.160.60:FF:001821', NULL, NULL, 'GH16297', NULL, NULL, NULL, NULL, NULL, 4),
(37989, NULL, 'G3DSA:1.10.8.60:FF:000337', NULL, NULL, 'ORC1-type DNA replication protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(37990, NULL, 'G3DSA:3.90.190.10:FF:000502', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(37991, NULL, 'G3DSA:3.50.50.60:FF:000918', NULL, NULL, 'Oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37992, NULL, 'G3DSA:3.80.20.20:FF:000010', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(37993, NULL, 'G3DSA:3.30.1490.120:FF:000012', NULL, NULL, 'DNA-directed RNA polymerase II subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(37994, NULL, 'G3DSA:3.40.50.150:FF:000304', NULL, NULL, 'Methyltransferase/nucleic acid binding', NULL, NULL, NULL, NULL, NULL, 4),
(37995, NULL, 'G3DSA:2.40.50.140:FF:001266', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(37996, NULL, 'G3DSA:3.30.70.1230:FF:000040', NULL, NULL, 'Ca(2+)/calmodulin-responsive adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(37997, NULL, 'G3DSA:3.40.50.12660:FF:000003', NULL, NULL, 'Metacaspase MCA2', NULL, NULL, NULL, NULL, NULL, 4),
(37998, NULL, 'G3DSA:4.10.280.10:FF:000057', NULL, NULL, 'transcription factor-like 5 protein-like', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(37999, NULL, 'G3DSA:1.10.640.10:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38000, NULL, 'G3DSA:3.40.50.2300:FF:000768', NULL, NULL, 'GLutamate Receptor family (AMPA)', NULL, NULL, NULL, NULL, NULL, 4),
(38001, NULL, 'G3DSA:1.25.40.10:FF:001848', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(38002, NULL, 'G3DSA:3.30.1330.80:FF:000002', NULL, NULL, 'AT-hook motif nuclear-localized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38003, NULL, 'G3DSA:2.10.25.10:FF:000366', NULL, NULL, 'EGF-containing fibulin-like extracellular matrix protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(38004, NULL, 'G3DSA:3.40.50.1450:FF:000002', NULL, NULL, 'Hydrogenase 1 maturation protease', NULL, NULL, NULL, NULL, NULL, 4),
(38005, NULL, 'G3DSA:3.30.160.60:FF:002041', NULL, NULL, 'Zinc finger protein 526', NULL, NULL, NULL, NULL, NULL, 4),
(38006, NULL, 'G3DSA:3.30.200.20:FF:000897', NULL, NULL, 'Uncharacterized protein, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(38007, NULL, 'G3DSA:2.120.10.80:FF:000359', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38008, NULL, 'G3DSA:3.40.33.10:FF:000005', NULL, NULL, 'Cysteine-rich secretory protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(38009, NULL, 'G3DSA:2.60.40.10:FF:003934', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38010, NULL, 'G3DSA:2.30.29.30:FF:000740', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38011, NULL, 'G3DSA:3.90.550.10:FF:000075', NULL, NULL, 'Probable UDP-N-acetylglucosamine pyrophosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(38012, NULL, 'G3DSA:1.20.120.1380:FF:000011', NULL, NULL, 'Flagellar polar localization control system flagellar assembly determinant GTPase FlhF', NULL, NULL, NULL, NULL, NULL, 4),
(38013, NULL, 'G3DSA:1.25.40.860:FF:000008', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(38014, NULL, 'G3DSA:2.60.40.2100:FF:000002', NULL, NULL, 'Major fimbrium anchoring subunit FimB', NULL, NULL, NULL, NULL, NULL, 4),
(38015, NULL, 'G3DSA:2.30.30.140:FF:000348', NULL, NULL, 'Chromatin modification-related protein EAF3', NULL, NULL, NULL, NULL, NULL, 4),
(38016, NULL, 'G3DSA:3.30.160.60:FF:005418', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38017, NULL, 'G3DSA:3.10.20.870:FF:000009', NULL, NULL, 'phospholipase A-2-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(38018, NULL, 'G3DSA:3.10.129.10:FF:000277', NULL, NULL, 'Acyl-CoA thioesterase 11b', NULL, NULL, NULL, NULL, NULL, 4),
(38019, NULL, 'G3DSA:2.130.10.10:FF:005913', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38020, NULL, 'G3DSA:3.40.50.720:FF:000138', NULL, NULL, 'Short-chain dehydrogenase/reductase family 42E member 1', NULL, NULL, NULL, NULL, NULL, 4),
(38021, NULL, 'G3DSA:2.60.20.10:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38022, NULL, 'G3DSA:3.40.50.300:FF:005419', NULL, NULL, 'RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38023, NULL, 'G3DSA:3.40.50.300:FF:004025', NULL, NULL, 'RAB30 isoform 9', NULL, NULL, NULL, NULL, NULL, 4),
(38024, NULL, 'G3DSA:3.40.1810.10:FF:000044', NULL, NULL, 'AGAMOUS-like 101', NULL, NULL, NULL, NULL, NULL, 4),
(38025, NULL, 'G3DSA:3.30.1330.90:FF:000005', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(38026, NULL, 'G3DSA:1.10.630.10:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38027, NULL, 'G3DSA:1.25.10.10:FF:002010', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(38028, NULL, 'G3DSA:3.50.50.60:FF:000975', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38029, NULL, 'G3DSA:1.20.120.1110:FF:000014', NULL, NULL, 'TAF4B RNA polymerase II, TATA box-binding protein (TBP)-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(38030, NULL, 'G3DSA:3.60.40.10:FF:000223', NULL, NULL, 'Protein phosphatase 2C, putative', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(38031, NULL, 'G3DSA:3.40.50.300:FF:000282', NULL, NULL, 'Strawberry notch homolog 1 (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(38032, NULL, 'G3DSA:3.15.20.10:FF:000005', NULL, NULL, 'BPI fold containing family C', NULL, NULL, NULL, NULL, NULL, 4),
(38033, NULL, 'G3DSA:1.10.10.750:FF:000013', NULL, NULL, 'Similar to TBC domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(38034, NULL, 'G3DSA:1.20.1560.10:FF:000851', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38035, NULL, 'G3DSA:1.10.555.10:FF:000027', NULL, NULL, 'RalA-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(38036, NULL, 'G3DSA:2.10.70.10:FF:000055', NULL, NULL, 'Complement decay-accelerating factor, GPI-anchored', NULL, NULL, NULL, NULL, NULL, 4),
(38037, NULL, 'G3DSA:3.90.76.10:FF:000023', NULL, NULL, 'Oligopeptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(38038, NULL, 'G3DSA:1.25.10.10:FF:002100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38039, NULL, 'G3DSA:1.20.1280.50:FF:000212', NULL, NULL, 'SCF E3 ubiquitin ligase complex F-box protein grrA', NULL, NULL, NULL, NULL, NULL, 4),
(38040, NULL, 'G3DSA:2.130.10.10:FF:001642', NULL, NULL, 'WD domain, G-beta repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(38041, NULL, 'G3DSA:2.160.20.20:FF:000003', NULL, NULL, 'Possible enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(38042, NULL, 'G3DSA:3.30.160.60:FF:000129', NULL, NULL, 'Zinc finger protein 503', NULL, NULL, NULL, NULL, NULL, 4),
(38043, NULL, 'G3DSA:3.30.160.60:FF:006402', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38044, NULL, 'G3DSA:3.30.200.20:FF:000987', NULL, NULL, 'Os03g0335900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(38045, NULL, 'G3DSA:3.40.50.11500:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38046, NULL, 'G3DSA:3.40.50.1820:FF:001799', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38047, NULL, 'G3DSA:1.25.40.20:FF:001475', NULL, NULL, 'Ankyrin repeat-containing protein C6C3.08', NULL, NULL, NULL, NULL, NULL, 4),
(38048, NULL, 'G3DSA:3.50.50.60:FF:000267', NULL, NULL, 'YOR356W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(38049, NULL, 'G3DSA:3.40.1110.10:FF:000036', NULL, NULL, 'Copper-exporting P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(38050, NULL, 'G3DSA:1.25.40.10:FF:001472', NULL, NULL, 'Paf1 complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(38051, NULL, 'G3DSA:1.10.555.10:FF:000084', NULL, NULL, 'WW domain-containing protein tag-325', NULL, NULL, NULL, NULL, NULL, 4),
(38052, NULL, 'G3DSA:2.40.50.1020:FF:000008', NULL, NULL, 'LytR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(38053, NULL, 'G3DSA:1.10.630.10:FF:000332', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38054, NULL, 'G3DSA:2.60.120.330:FF:000095', NULL, NULL, '1-aminocyclopropane-1-carboxylate oxidase 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38055, NULL, 'G3DSA:3.40.50.410:FF:000017', NULL, NULL, 'Anthrax toxin receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(38056, NULL, 'G3DSA:2.60.120.1000:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38057, NULL, 'G3DSA:3.40.50.300:FF:001732', NULL, NULL, 'tRNA threonylcarbamoyladenosine biosynthesis protein TsaE', NULL, NULL, NULL, NULL, NULL, 4),
(38058, NULL, 'G3DSA:3.30.830.10:FF:000104', NULL, NULL, 'Metalloenzyme, LuxS/M16 peptidase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(38059, NULL, 'G3DSA:1.25.40.10:FF:001287', NULL, NULL, 'Pre-mRNA-processing factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(38060, NULL, 'G3DSA:1.20.1270.10:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38061, NULL, 'G3DSA:3.40.50.720:FF:000756', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(38062, NULL, 'G3DSA:3.10.580.10:FF:000224', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(38063, NULL, 'G3DSA:3.40.250.10:FF:000086', NULL, NULL, 'Thiosulfate sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(38064, NULL, 'G3DSA:3.40.50.150:FF:000214', NULL, NULL, 'Probable tRNA methyltransferase 9B', NULL, NULL, NULL, NULL, NULL, 4),
(38065, NULL, 'G3DSA:3.40.50.2300:FF:000858', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38066, NULL, 'G3DSA:3.30.160.60:FF:002131', NULL, NULL, 'Zinc finger protein 112', NULL, NULL, NULL, NULL, NULL, 4),
(38067, NULL, 'G3DSA:1.20.1270.10:FF:000019', NULL, NULL, 'Heat shock 70 kDa protein 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(38068, NULL, 'G3DSA:3.30.70.330:FF:002798', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38069, NULL, 'G3DSA:1.20.5.990:FF:000011', NULL, NULL, 'AGAP005933-PA', NULL, NULL, NULL, NULL, NULL, 4),
(38070, NULL, 'G3DSA:3.30.70.330:FF:003113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38071, NULL, 'G3DSA:1.20.1070.10:FF:000925', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38072, NULL, 'G3DSA:2.10.25.10:FF:000804', NULL, NULL, 'Fibrillin-1', NULL, NULL, NULL, NULL, NULL, 4),
(38073, NULL, 'G3DSA:2.40.170.20:FF:000002', NULL, NULL, 'Colicin I TonB-dependent receptor', NULL, NULL, NULL, NULL, NULL, 4),
(38074, NULL, 'G3DSA:4.10.240.10:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38075, NULL, 'G3DSA:1.20.1560.10:FF:000946', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38076, NULL, 'G3DSA:3.40.50.300:FF:007364', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38077, NULL, 'G3DSA:3.90.1200.10:FF:000082', NULL, NULL, 'Uncharacterized protein DR_0394', NULL, NULL, NULL, NULL, NULL, 4),
(38078, NULL, 'G3DSA:2.60.20.10:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38079, NULL, 'G3DSA:2.130.10.10:FF:003761', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38080, NULL, 'G3DSA:3.20.200.10:FF:000008', NULL, NULL, 'Elongation factor 2 kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38081, NULL, 'G3DSA:1.25.40.10:FF:002017', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(38082, NULL, 'G3DSA:1.10.540.10:FF:000010', NULL, NULL, 'Medium-chain specific acyl-CoA dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(38083, NULL, 'G3DSA:3.10.450.240:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38084, NULL, 'G3DSA:3.40.850.10:FF:000497', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38085, NULL, 'G3DSA:1.10.287.70:FF:000652', NULL, NULL, 'Potassium channel, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38086, NULL, 'G3DSA:3.30.200.20:FF:000689', NULL, NULL, 'SCY1 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(38087, NULL, 'G3DSA:3.60.110.10:FF:000094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38088, NULL, 'G3DSA:1.10.10.10:FF:001751', NULL, NULL, 'Spo11 protein', NULL, NULL, NULL, NULL, NULL, 4),
(38089, NULL, 'G3DSA:3.30.70.260:FF:000164', NULL, NULL, 'Amino acid-binding ACT domain regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(38090, NULL, 'G3DSA:1.10.3080.10:FF:000024', NULL, NULL, 'Voltage-gated chloride channel, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38091, NULL, 'G3DSA:1.10.10.10:FF:001846', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38092, NULL, 'G3DSA:1.10.437.10:FF:000006', NULL, NULL, 'Apoptosis regulator Bcl-2', NULL, NULL, NULL, NULL, NULL, 4),
(38093, NULL, 'G3DSA:1.10.1370.30:FF:000041', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(38094, NULL, 'G3DSA:3.30.450.20:FF:000409', NULL, NULL, 'Sensor histidine kinase, PAS, PAS and PAS domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(38095, NULL, 'G3DSA:3.40.1110.10:FF:000064', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(38096, NULL, 'G3DSA:3.30.9.10:FF:000146', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(38097, NULL, 'G3DSA:1.25.40.10:FF:003119', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(38098, NULL, 'G3DSA:3.40.309.10:FF:000099', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(38099, NULL, 'G3DSA:3.30.980.10:FF:000020', NULL, NULL, 'Uridine cytidine kinase I, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38100, NULL, 'G3DSA:1.10.3080.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38101, NULL, 'G3DSA:3.30.230.10:FF:000188', NULL, NULL, 'DNA topoisomerase (ATP-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4),
(38102, NULL, 'G3DSA:3.30.500.10:FF:000001', NULL, NULL, 'H-2 class I histocompatibility antigen, alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(38103, NULL, 'G3DSA:3.10.400.20:FF:000035', NULL, NULL, 'Ligatin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38104, NULL, 'G3DSA:3.40.50.1820:FF:000282', NULL, NULL, 'Putative beta-ketoadipate enol-lactone hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(38105, NULL, 'G3DSA:3.30.1490.180:FF:000007', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(38106, NULL, 'G3DSA:3.30.160.20:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38107, NULL, 'G3DSA:1.20.58.60:FF:000178', NULL, NULL, 'Envoplakin a', NULL, NULL, NULL, NULL, NULL, 4),
(38108, NULL, 'G3DSA:3.90.1150.10:FF:000454', NULL, NULL, 'Aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(38109, NULL, 'G3DSA:2.40.50.140:FF:001261', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38110, NULL, 'G3DSA:1.25.40.20:FF:000901', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38111, NULL, 'G3DSA:1.20.1280.50:FF:000122', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(38112, NULL, 'G3DSA:1.20.1070.10:FF:000297', NULL, NULL, 'G-protein coupled receptor Mth', NULL, NULL, NULL, NULL, NULL, 4),
(38113, NULL, 'G3DSA:3.40.20.10:FF:000026', NULL, NULL, 'Glia maturation factor', NULL, NULL, NULL, NULL, NULL, 4),
(38114, NULL, 'G3DSA:3.30.1370.100:FF:000030', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(38115, NULL, 'G3DSA:2.130.10.10:FF:001670', NULL, NULL, 'WD domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(38116, NULL, 'G3DSA:3.40.50.2300:FF:000448', NULL, NULL, 'Two-component response regulator ORR29', NULL, NULL, NULL, NULL, NULL, 4),
(38117, NULL, 'G3DSA:3.40.50.1820:FF:000961', NULL, NULL, 'AB-hydrolase YheT, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38118, NULL, 'G3DSA:3.30.40.10:FF:000376', NULL, NULL, 'Putative E3 ubiquitin-protein ligase RHB1A', NULL, NULL, NULL, NULL, NULL, 4),
(38119, NULL, 'G3DSA:3.80.10.10:FF:002154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38120, NULL, 'G3DSA:3.30.70.330:FF:000937', NULL, NULL, 'NOP4p Nucleolar protein', NULL, NULL, NULL, NULL, NULL, 4),
(38121, NULL, 'G3DSA:2.60.200.40:FF:000029', NULL, NULL, 'ceramide kinase', NULL, NULL, NULL, NULL, NULL, 4),
(38122, NULL, 'G3DSA:1.10.510.10:FF:003785', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38123, NULL, 'G3DSA:3.60.130.10:FF:000056', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38124, NULL, 'G3DSA:1.50.40.10:FF:000273', NULL, NULL, 'Mitochondrial carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(38125, NULL, 'G3DSA:2.130.10.10:FF:004896', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38126, NULL, 'G3DSA:1.10.10.10:FF:000323', NULL, NULL, 'HTH-type transcriptional regulator rpiR', NULL, NULL, NULL, NULL, NULL, 4),
(38127, NULL, 'G3DSA:2.130.10.10:FF:003710', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38128, NULL, 'G3DSA:1.10.400.20:FF:000003', NULL, NULL, 'Tagatose-6-phosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(38129, NULL, 'G3DSA:1.20.1070.10:FF:000976', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38130, NULL, 'G3DSA:3.30.160.60:FF:003906', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38131, NULL, 'G3DSA:3.80.10.10:FF:001052', NULL, NULL, 'Putative leucine-rich repeat protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(38132, NULL, 'G3DSA:1.20.1260.30:FF:000002', NULL, NULL, 'Possible type I restriction/modification system DNA methylase HsdM (M protein) (DNA methyltransferase)', NULL, NULL, NULL, NULL, NULL, 4),
(38133, NULL, 'G3DSA:1.20.120.1910:FF:000041', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(38134, NULL, 'G3DSA:3.30.160.60:FF:006020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38135, NULL, 'G3DSA:1.20.1250.10:FF:000018', NULL, NULL, 'leukemia inhibitory factor', NULL, NULL, NULL, NULL, NULL, 4),
(38136, NULL, 'G3DSA:3.90.740.10:FF:000022', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(38137, NULL, 'G3DSA:3.40.50.300:FF:007459', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38138, NULL, 'G3DSA:3.30.40.10:FF:001039', NULL, NULL, 'Lysine-specific demethylase 5B', NULL, NULL, NULL, NULL, NULL, 4),
(38139, NULL, 'G3DSA:2.60.40.10:FF:005823', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38140, NULL, 'G3DSA:2.30.29.30:FF:001021', NULL, NULL, 'Arf guanine nucleotide exchange factor sec74', NULL, NULL, NULL, NULL, NULL, 4),
(38141, NULL, 'G3DSA:3.90.190.10:FF:000176', NULL, NULL, 'Dual specificity protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38142, NULL, 'G3DSA:3.30.70.2330:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38143, NULL, 'G3DSA:2.60.120.10:FF:000244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38144, NULL, 'G3DSA:3.40.50.300:FF:000490', NULL, NULL, 'Katanin p60 ATPase-containing subunit A-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(38145, NULL, 'G3DSA:3.30.2140.20:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38146, NULL, 'G3DSA:3.30.160.60:FF:003586', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38147, NULL, 'G3DSA:1.20.1250.20:FF:002264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38148, NULL, 'G3DSA:2.40.50.140:FF:001210', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38149, NULL, 'G3DSA:3.40.50.2300:FF:000774', NULL, NULL, 'Protein tyrosine phosphatase putative', NULL, NULL, NULL, NULL, NULL, 4),
(38150, NULL, 'G3DSA:2.40.100.10:FF:000051', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(38151, NULL, 'G3DSA:1.20.1070.10:FF:000246', NULL, NULL, 'Atypical chemokine receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(38152, NULL, 'G3DSA:1.50.10.10:FF:000092', NULL, NULL, 'N-acyl-D-glucosamine 2-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(38153, NULL, 'G3DSA:2.60.120.1000:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38154, NULL, 'G3DSA:1.25.10.20:FF:000006', NULL, NULL, 'Putative Vitellogenin-1', NULL, NULL, NULL, NULL, NULL, 4),
(38155, NULL, 'G3DSA:1.20.1280.50:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38156, NULL, 'G3DSA:3.40.50.620:FF:000428', NULL, NULL, 'Deoxyribodipyrimidine photolyase', NULL, NULL, NULL, NULL, NULL, 4),
(38157, NULL, 'G3DSA:3.40.50.1000:FF:000311', NULL, NULL, 'Trehalose 6-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(38158, NULL, 'G3DSA:3.40.50.12780:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38159, NULL, 'G3DSA:3.30.160.60:FF:001462', NULL, NULL, 'Zinc finger protein 502, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(38160, NULL, 'G3DSA:1.10.246.90:FF:000007', NULL, NULL, 'Pre mRNA splicing protein', NULL, NULL, NULL, NULL, NULL, 4),
(38161, NULL, 'G3DSA:3.90.190.10:FF:000390', NULL, NULL, 'Kinase, Uni1', NULL, NULL, NULL, NULL, NULL, 4),
(38162, NULL, 'G3DSA:1.25.10.10:FF:000003', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 56 kDa regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(38163, NULL, 'G3DSA:1.10.510.10:FF:003055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38164, NULL, 'G3DSA:1.10.238.10:FF:001089', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38165, NULL, 'G3DSA:3.40.50.2300:FF:001342', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(38166, NULL, 'G3DSA:1.25.10.30:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38167, NULL, 'G3DSA:3.30.460.10:FF:000059', NULL, NULL, 'Non-canonical poly(A) RNA polymerase PAPD5', NULL, NULL, NULL, NULL, NULL, 4),
(38168, NULL, 'G3DSA:3.40.50.1460:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38169, NULL, 'G3DSA:3.30.505.10:FF:000023', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(38170, NULL, 'G3DSA:1.10.1280.10:FF:000005', NULL, NULL, 'Tyrosinase related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(38171, NULL, 'G3DSA:1.20.80.10:FF:000018', NULL, NULL, 'Kinesin-like calmodulin binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(38172, NULL, 'G3DSA:2.40.50.140:FF:000693', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38173, NULL, 'G3DSA:1.25.10.10:FF:001577', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38174, NULL, 'G3DSA:1.10.287.410:FF:000013', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(38175, NULL, 'G3DSA:2.60.40.10:FF:003732', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38176, NULL, 'G3DSA:3.40.50.300:FF:008027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38177, NULL, 'G3DSA:3.40.50.720:FF:000907', NULL, NULL, 'Probable myo-inositol 1-phosphate synthase (MIPS)', NULL, NULL, NULL, NULL, NULL, 4),
(38178, NULL, 'G3DSA:2.60.120.1160:FF:000001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38179, NULL, 'G3DSA:3.30.40.10:FF:001899', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38180, NULL, 'G3DSA:1.20.1070.10:FF:002163', NULL, NULL, 'Rhodopsin', NULL, NULL, NULL, NULL, NULL, 4),
(38181, NULL, 'G3DSA:2.60.120.200:FF:000808', NULL, NULL, 'Lectin receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(38182, NULL, 'G3DSA:3.30.160.60:FF:005677', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38183, NULL, 'G3DSA:3.40.50.1220:FF:000085', NULL, NULL, 'Probable 2-hydroxyacyl-CoA lyase 1', NULL, NULL, NULL, NULL, NULL, 4),
(38184, NULL, 'G3DSA:3.30.450.20:FF:000623', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38185, NULL, 'G3DSA:1.25.40.120:FF:000028', NULL, NULL, 'AGAP002731-PA', NULL, NULL, NULL, NULL, NULL, 4),
(38186, NULL, 'G3DSA:3.30.300.20:FF:000056', NULL, NULL, 'Ribosomal protein S3', NULL, NULL, NULL, NULL, NULL, 4),
(38187, NULL, 'G3DSA:3.30.2300.10:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38188, NULL, 'G3DSA:3.40.50.150:FF:000416', NULL, NULL, 'Protein-L-isoaspartate O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(38189, NULL, 'G3DSA:2.130.10.10:FF:005155', NULL, NULL, 'Cilia- and flagella-associated protein 43', NULL, NULL, NULL, NULL, NULL, 4),
(38190, NULL, 'G3DSA:3.30.710.10:FF:000444', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38191, NULL, 'G3DSA:3.40.50.1110:FF:000052', NULL, NULL, 'Exported lipase/acylhydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(38192, NULL, 'G3DSA:3.80.10.10:FF:002480', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38193, NULL, 'G3DSA:3.40.50.300:FF:001799', NULL, NULL, 'Rac2 family GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38194, NULL, 'G3DSA:1.25.40.20:FF:001683', NULL, NULL, 'Serine/threonine-protein kinase TNNI3K', NULL, NULL, NULL, NULL, NULL, 4),
(38195, NULL, 'G3DSA:2.130.10.10:FF:001344', NULL, NULL, 'WD repeat-containing protein 91', NULL, NULL, NULL, NULL, NULL, 4),
(38196, NULL, 'G3DSA:3.50.30.30:FF:000083', NULL, NULL, 'Subtilisin-like protease SBT2.4', NULL, NULL, NULL, NULL, NULL, 4),
(38197, NULL, 'G3DSA:3.30.420.10:FF:000225', NULL, NULL, 'Os07g0112400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(38198, NULL, 'G3DSA:3.50.50.60:FF:001144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38199, NULL, 'G3DSA:3.30.830.10:FF:000020', NULL, NULL, 'Mitochondrial presequence protease', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(38200, NULL, 'G3DSA:3.40.190.80:FF:000023', NULL, NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(38201, NULL, 'G3DSA:2.30.42.10:FF:000490', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38202, NULL, 'G3DSA:3.40.50.150:FF:001765', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38203, NULL, 'G3DSA:1.10.287.110:FF:000125', NULL, NULL, 'HSP40/DnaJ peptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(38204, NULL, 'G3DSA:3.30.300.30:FF:000059', NULL, NULL, 'YOR093C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(38205, NULL, 'G3DSA:1.20.120.740:FF:000003', NULL, NULL, 'UPF0149 protein PLES_56191', NULL, NULL, NULL, NULL, NULL, 4),
(38206, NULL, 'G3DSA:2.130.10.10:FF:005801', NULL, NULL, 'Plexin C1', NULL, NULL, NULL, NULL, NULL, 4),
(38207, NULL, 'G3DSA:3.50.50.60:FF:001082', NULL, NULL, 'N-methylproline demethylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38208, NULL, 'G3DSA:3.20.20.190:FF:000028', NULL, NULL, 'Glycerophosphodiester phosphodiesterase domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(38209, NULL, 'G3DSA:3.30.200.20:FF:001532', NULL, NULL, 'Putative lectin-like receptor protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(38210, NULL, 'G3DSA:1.20.1250.20:FF:000398', NULL, NULL, 'Monocarboxylate transporter 14', NULL, NULL, NULL, NULL, NULL, 4),
(38211, NULL, 'G3DSA:3.30.1490.70:FF:000005', NULL, NULL, 'RNA-editing ligase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(38212, NULL, 'G3DSA:3.30.160.60:FF:001815', NULL, NULL, 'Zinc finger protein 425', NULL, NULL, NULL, NULL, NULL, 4),
(38213, NULL, 'G3DSA:1.10.10.10:FF:000857', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(38214, NULL, 'G3DSA:2.60.40.10:FF:005177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38215, NULL, 'G3DSA:2.60.40.10:FF:003457', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38216, NULL, 'G3DSA:1.10.510.10:FF:001868', NULL, NULL, 'NACHT and Ankyrin domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(38217, NULL, 'G3DSA:3.40.50.150:FF:001518', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38218, NULL, 'G3DSA:2.40.70.10:FF:000222', NULL, NULL, 'Aspartic proteinase NANA, chloroplast', NULL, NULL, NULL, NULL, NULL, 4),
(38219, NULL, 'G3DSA:3.30.160.60:FF:004042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38220, NULL, 'G3DSA:3.30.200.20:FF:001471', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(38221, NULL, 'G3DSA:2.30.140.10:FF:000016', NULL, NULL, 'Spermidine synthase isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(38222, NULL, 'G3DSA:1.20.120.160:FF:000043', NULL, NULL, 'Two-component phosphorelay mediator', NULL, NULL, NULL, NULL, NULL, 4),
(38223, NULL, 'G3DSA:2.60.40.10:FF:000877', NULL, NULL, 'CLUMA_CG002357, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(38224, NULL, 'G3DSA:3.30.505.10:FF:000074', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(38225, NULL, 'G3DSA:3.40.50.300:FF:007690', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38226, NULL, 'G3DSA:1.10.287.70:FF:000326', NULL, NULL, 'GG19677', NULL, NULL, NULL, NULL, NULL, 4),
(38227, NULL, 'G3DSA:3.40.50.720:FF:001301', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(38228, NULL, 'G3DSA:1.10.20.10:FF:000037', NULL, NULL, 'Transcription initiation factor TFIID subunit 12', NULL, NULL, NULL, NULL, NULL, 4),
(38229, NULL, 'G3DSA:1.20.1110.10:FF:000160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38230, NULL, 'G3DSA:1.25.40.10:FF:001028', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(38231, NULL, 'G3DSA:1.10.1410.20:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38232, NULL, 'G3DSA:1.10.3520.10:FF:000008', NULL, NULL, 'Glycolipid transfer protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(38233, NULL, 'G3DSA:1.25.10.10:FF:002420', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(38234, NULL, 'G3DSA:3.30.160.60:FF:004688', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38235, NULL, 'G3DSA:1.20.1070.10:FF:000572', NULL, NULL, 'DOPamine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(38236, NULL, 'G3DSA:2.60.120.10:FF:000306', NULL, NULL, 'Homogentisate 1,2-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(38237, NULL, 'G3DSA:1.10.357.140:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38238, NULL, 'G3DSA:2.130.10.10:FF:005060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38239, NULL, 'G3DSA:3.70.10.10:FF:000136', NULL, NULL, 'Cell cycle checkpoint control protein', NULL, NULL, NULL, NULL, NULL, 4),
(38240, NULL, 'G3DSA:1.25.10.10:FF:001526', NULL, NULL, 'Probable serine/threonine-protein kinase tsuA', NULL, NULL, NULL, NULL, NULL, 4),
(38241, NULL, 'G3DSA:2.60.200.30:FF:000026', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(38242, NULL, 'G3DSA:1.10.287.110:FF:000400', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38243, NULL, 'G3DSA:3.40.50.150:FF:001670', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38244, NULL, 'G3DSA:1.10.10.60:FF:000939', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38245, NULL, 'G3DSA:6.10.140.2220:FF:000045', NULL, NULL, 'AT24727p', NULL, NULL, NULL, NULL, NULL, 4),
(38246, NULL, 'G3DSA:1.10.510.10:FF:001368', NULL, NULL, 'serine/threonine-protein kinase 38 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(38247, NULL, 'G3DSA:1.20.1740.10:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38248, NULL, 'G3DSA:3.40.50.1000:FF:000423', NULL, NULL, 'Trehalose-6-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(38249, NULL, 'G3DSA:3.40.50.720:FF:000958', NULL, NULL, '6-hydroxycyclohex-1-ene-1-carbonyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(38250, NULL, 'G3DSA:2.160.10.30:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38251, NULL, 'G3DSA:1.10.3210.10:FF:000024', NULL, NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(38252, NULL, 'G3DSA:1.25.40.10:FF:003271', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g74900, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(38253, NULL, 'G3DSA:1.25.10.10:FF:003090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38254, NULL, 'G3DSA:1.20.1740.10:FF:000039', NULL, NULL, 'Neutral amino acid transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(38255, NULL, 'G3DSA:1.10.8.140:FF:000012', NULL, NULL, 'DNA-binding protein MSBR3_2977', NULL, NULL, NULL, NULL, NULL, 4),
(38256, NULL, 'G3DSA:2.60.40.10:FF:001866', NULL, NULL, 'T cell receptor gamma variable 3', NULL, NULL, NULL, NULL, NULL, 4),
(38257, NULL, 'G3DSA:3.40.50.300:FF:005335', NULL, NULL, 'Ras-related protein RABD1', NULL, NULL, NULL, NULL, NULL, 4),
(38258, NULL, 'G3DSA:3.40.50.360:FF:000075', NULL, NULL, 'NADPH--cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(38259, NULL, 'G3DSA:2.40.50.140:FF:000367', NULL, NULL, 'rRNA biogenesis protein RRP5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38260, NULL, 'G3DSA:2.60.200.20:FF:000023', NULL, NULL, 'Solute carrier family 4 member 1 adaptor protein', NULL, NULL, NULL, NULL, NULL, 4),
(38261, NULL, 'G3DSA:3.90.190.10:FF:000238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38262, NULL, 'G3DSA:1.10.8.60:FF:000511', NULL, NULL, 'AAA ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38263, NULL, 'G3DSA:3.30.930.10:FF:000084', NULL, NULL, 'Phenylalanine-tRNA ligase, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(38264, NULL, 'G3DSA:3.40.1190.10:FF:000018', NULL, NULL, 'Rma1p', NULL, NULL, NULL, NULL, NULL, 4),
(38265, NULL, 'G3DSA:1.20.1560.10:FF:000093', NULL, NULL, 'Type I secretion system permease/ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(38266, NULL, 'G3DSA:3.60.10.10:FF:000305', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(38267, NULL, 'G3DSA:2.60.120.970:FF:000045', NULL, NULL, 'CET-1', NULL, NULL, NULL, NULL, NULL, 4),
(38268, NULL, 'G3DSA:3.30.160.60:FF:005177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38269, NULL, 'G3DSA:1.20.58.60:FF:000824', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38270, NULL, 'G3DSA:2.40.50.100:FF:000203', NULL, NULL, 'Exosome complex component csl4', NULL, NULL, NULL, NULL, NULL, 4),
(38271, NULL, 'G3DSA:3.40.50.2300:FF:000499', NULL, NULL, 'Orn/Arg/Lys decarboxylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38272, NULL, 'G3DSA:2.60.40.10:FF:005082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38273, NULL, 'G3DSA:1.20.1110.10:FF:000008', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(38274, NULL, 'G3DSA:2.130.10.10:FF:003435', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38275, NULL, 'G3DSA:3.80.10.10:FF:002884', NULL, NULL, 'NLR family CARD domain-containing 9', NULL, NULL, NULL, NULL, NULL, 4),
(38276, NULL, 'G3DSA:3.20.20.70:FF:000168', NULL, NULL, '3-hydroxy-5-phosphonooxypentane-2,4-dione thiolase', NULL, NULL, NULL, NULL, NULL, 4),
(38277, NULL, 'G3DSA:3.40.50.1820:FF:000809', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38278, NULL, 'G3DSA:3.10.280.10:FF:000004', NULL, NULL, 'Mitochondrial acidic protein MAM33, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38279, NULL, 'G3DSA:1.10.287.1150:FF:000011', NULL, NULL, '2-oxoglutarate dehydrogenase E1 component DHKTD1', NULL, NULL, NULL, NULL, NULL, 4),
(38280, NULL, 'G3DSA:1.20.1070.10:FF:001061', NULL, NULL, 'putative gonadotropin-releasing hormone II receptor', NULL, NULL, NULL, NULL, NULL, 4),
(38281, NULL, 'G3DSA:1.10.630.10:FF:000129', NULL, NULL, 'Benzoate 4-monooxygenase cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(38282, NULL, 'G3DSA:3.30.40.10:FF:001314', NULL, NULL, 'Putative E3 ubiquitin-protein ligase XERICO', NULL, NULL, NULL, NULL, NULL, 4),
(38283, NULL, 'G3DSA:1.10.510.10:FF:004044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38284, NULL, 'G3DSA:1.20.5.110:FF:000231', NULL, NULL, 'Vesicle transport v-SNARE protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38285, NULL, 'G3DSA:1.10.101.10:FF:000007', NULL, NULL, 'Carboxyl-terminal protease', NULL, NULL, NULL, NULL, NULL, 4),
(38286, NULL, 'G3DSA:1.20.1020.10:FF:000001', NULL, NULL, 'E1A binding protein p300', NULL, NULL, NULL, NULL, NULL, 4),
(38287, NULL, 'G3DSA:3.40.470.10:FF:000012', NULL, NULL, 'Type-5 uracil-DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(38288, NULL, 'G3DSA:1.20.1250.20:FF:000965', NULL, NULL, 'Multidrug efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(38289, NULL, 'G3DSA:3.10.20.90:FF:000141', NULL, NULL, 'Neutrophil cytosol factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(38290, NULL, 'G3DSA:1.10.510.10:FF:003908', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38291, NULL, 'G3DSA:3.30.70.330:FF:002949', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38292, NULL, 'G3DSA:1.20.120.1160:FF:000001', NULL, NULL, 'Minor nucleoprotein VP30', NULL, NULL, NULL, NULL, NULL, 4),
(38293, NULL, 'G3DSA:1.10.10.2320:FF:000001', NULL, NULL, 'phenylalanine--tRNA ligase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(38294, NULL, 'G3DSA:2.10.25.10:FF:000872', NULL, NULL, 'Versican b', NULL, NULL, NULL, NULL, NULL, 4),
(38295, NULL, 'G3DSA:1.10.10.2330:FF:000004', NULL, NULL, 'Phenylalanine--tRNA ligase alpha subunit, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(38296, NULL, 'G3DSA:2.30.29.30:FF:000532', NULL, NULL, 'Sterol 3-beta-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(38297, NULL, 'G3DSA:1.25.10.10:FF:003443', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38298, NULL, 'G3DSA:2.30.30.870:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38299, NULL, 'G3DSA:3.20.20.105:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38300, NULL, 'G3DSA:3.30.710.10:FF:000118', NULL, NULL, 'Abrupt, isoform B', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(38301, NULL, 'G3DSA:3.30.420.10:FF:000551', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38302, NULL, 'G3DSA:3.40.50.150:FF:001198', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38303, NULL, 'G3DSA:3.30.750.44:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38304, NULL, 'G3DSA:3.30.70.270:FF:000279', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38305, NULL, 'G3DSA:1.10.1200.10:FF:000113', NULL, NULL, 'Peptide synthetase NRPS type II-PCP', NULL, NULL, NULL, NULL, NULL, 4),
(38306, NULL, 'G3DSA:3.80.10.10:FF:000529', NULL, NULL, 'PH domain leucine-rich repeat-containing protein phosphatase 2', NULL, NULL, NULL, NULL, NULL, 4),
(38307, NULL, 'G3DSA:1.10.800.10:FF:000008', NULL, NULL, 'Phenylalanine-4-hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(38308, NULL, 'G3DSA:2.130.10.10:FF:005773', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38309, NULL, 'G3DSA:3.20.20.20:FF:000018', NULL, NULL, 'Corrinoid/iron-sulfur protein small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(38310, NULL, 'G3DSA:2.60.40.420:FF:000074', NULL, NULL, 'Blue copper binding protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(38311, NULL, 'G3DSA:3.40.50.2020:FF:000049', NULL, NULL, 'Putative uracil phosphoribosyltransferase urg2', NULL, NULL, NULL, NULL, NULL, 4),
(38312, NULL, 'G3DSA:3.30.70.330:FF:001101', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(38313, NULL, 'G3DSA:3.40.50.80:FF:000094', NULL, NULL, 'Bifunctional cytochrome P450/NADPH--P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(38314, NULL, 'G3DSA:3.40.366.10:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38315, NULL, 'G3DSA:3.30.1330.30:FF:000066', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(38316, NULL, 'G3DSA:3.30.230.10:FF:000076', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(38317, NULL, 'G3DSA:3.30.1490.120:FF:000017', NULL, NULL, 'RNA polymerase subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38318, NULL, 'G3DSA:3.40.50.720:FF:001801', NULL, NULL, 'Protein CLP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(38319, NULL, 'G3DSA:2.80.10.50:FF:000094', NULL, NULL, 'Cellulase containing protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(38320, NULL, 'G3DSA:3.30.200.20:FF:000577', NULL, NULL, 'Tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(38321, NULL, 'G3DSA:2.40.50.100:FF:000080', NULL, NULL, 'Spermidine/putrescine ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(38322, NULL, 'G3DSA:2.30.29.30:FF:000178', NULL, NULL, 'DCC-interacting protein 13-alpha isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(38323, NULL, 'G3DSA:3.30.1330.40:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38324, NULL, 'G3DSA:1.25.40.10:FF:001528', NULL, NULL, 'pentatricopeptide repeat-containing protein At1g11290, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(38325, NULL, 'G3DSA:3.90.1600.10:FF:000011', NULL, NULL, 'DNA-directed DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(38326, NULL, 'G3DSA:2.130.10.10:FF:001844', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(38327, NULL, 'G3DSA:2.20.25.10:FF:000085', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(38328, NULL, 'G3DSA:3.60.40.10:FF:000279', NULL, NULL, 'Sll1771 protein', NULL, NULL, NULL, NULL, NULL, 4),
(38329, NULL, 'G3DSA:3.40.50.300:FF:001850', NULL, NULL, 'ATP-dependent helicase/nuclease subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(38330, NULL, 'G3DSA:3.30.1440.10:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38331, NULL, 'G3DSA:3.20.20.10:FF:000015', NULL, NULL, 'Diaminopimelate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(38332, NULL, 'G3DSA:1.20.1250.20:FF:001241', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(38333, NULL, 'G3DSA:3.30.930.10:FF:000376', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38334, NULL, 'G3DSA:1.20.140.150:FF:000021', NULL, NULL, 'Transmembrane protein 114', NULL, NULL, NULL, NULL, NULL, 4),
(38335, NULL, 'G3DSA:1.10.510.10:FF:001189', NULL, NULL, 'calcium/calmodulin-dependent protein kinase type IV isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(38336, NULL, 'G3DSA:3.40.1110.10:FF:000238', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38337, NULL, 'G3DSA:2.60.98.60:FF:000002', NULL, NULL, 'Protein CBR-EFF-1, isoform a', NULL, NULL, NULL, NULL, NULL, 4),
(38338, NULL, 'G3DSA:2.60.120.10:FF:000183', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(38339, NULL, 'G3DSA:1.50.40.10:FF:000205', NULL, NULL, 'Uncharacterized mitochondrial carrier SCY_1795', NULL, NULL, NULL, NULL, NULL, 4),
(38340, NULL, 'G3DSA:3.30.70.330:FF:000825', NULL, NULL, 'Pre-rRNA-processing protein ESF2', NULL, NULL, NULL, NULL, NULL, 4),
(38341, NULL, 'G3DSA:3.40.50.720:FF:000458', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(38342, NULL, 'G3DSA:3.40.50.300:FF:005773', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38343, NULL, 'G3DSA:3.40.50.1100:FF:000127', NULL, NULL, 'L-threonine ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(38344, NULL, 'G3DSA:3.40.50.300:FF:000164', NULL, NULL, 'regulator of nonsense transcripts 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(38345, NULL, 'G3DSA:1.10.1080.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38346, NULL, 'G3DSA:1.10.1740.10:FF:000024', NULL, NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(38347, NULL, 'G3DSA:3.40.50.620:FF:000642', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38348, NULL, 'G3DSA:1.20.1720.10:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38349, NULL, 'G3DSA:3.30.300.10:FF:000020', NULL, NULL, 'S-adenosylmethionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(38350, NULL, 'G3DSA:3.30.450.20:FF:000674', NULL, NULL, 'Nuclear receptor coactivator', NULL, NULL, NULL, NULL, NULL, 4),
(38351, NULL, 'G3DSA:3.30.70.330:FF:000876', NULL, NULL, 'RNA splicing factor (Pad-1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(38352, NULL, 'G3DSA:1.10.300.10:FF:000015', NULL, NULL, 'Adenylosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(38353, NULL, 'G3DSA:3.30.70.1730:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38354, NULL, 'G3DSA:1.20.120.720:FF:000059', NULL, NULL, 'Myosin-M heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(38355, NULL, 'G3DSA:2.60.120.10:FF:000418', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38356, NULL, 'G3DSA:1.10.238.10:FF:001117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38357, NULL, 'G3DSA:1.10.1410.10:FF:000005', NULL, NULL, 'Nucleolar protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(38358, NULL, 'G3DSA:2.30.29.30:FF:000919', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38359, NULL, 'G3DSA:3.30.160.60:FF:005918', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38360, NULL, 'G3DSA:3.30.40.10:FF:000876', NULL, NULL, 'Anaphase promoting complex subunit 11', NULL, NULL, NULL, NULL, NULL, 4),
(38361, NULL, 'G3DSA:3.40.50.300:FF:005447', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(38362, NULL, 'G3DSA:3.30.360.10:FF:000107', NULL, NULL, 'Acetylglutamate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(38363, NULL, 'G3DSA:2.40.50.690:FF:000003', NULL, NULL, 'DIS3-like exonuclease 2', NULL, NULL, NULL, NULL, NULL, 4),
(38364, NULL, 'G3DSA:1.20.120.1810:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38365, NULL, 'G3DSA:3.40.50.410:FF:000079', NULL, NULL, 'Mg-protoporphyrin IX chelatase', NULL, NULL, NULL, NULL, NULL, 4),
(38366, NULL, 'G3DSA:3.40.50.300:FF:006875', NULL, NULL, 'Sulfate transport ATP-binding protein cysA', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(38367, NULL, 'G3DSA:1.25.40.20:FF:000401', NULL, NULL, 'Glycerophosphocholine phosphodiesterase Gde1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38368, NULL, 'G3DSA:3.40.1380.20:FF:000064', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(38369, NULL, 'G3DSA:2.40.50.140:FF:000479', NULL, NULL, '28S ribosomal protein S17, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(38370, NULL, 'G3DSA:1.10.1200.10:FF:000017', NULL, NULL, 'Acyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(38371, NULL, 'G3DSA:3.40.50.300:FF:001524', NULL, NULL, 'Si:dkey-126g1.7', NULL, NULL, NULL, NULL, NULL, 4),
(38372, NULL, 'G3DSA:3.60.15.10:FF:000266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38373, NULL, 'G3DSA:3.30.40.10:FF:002388', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38374, NULL, 'G3DSA:3.40.50.11350:FF:000037', NULL, NULL, 'Protein O-fucosyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(38375, NULL, 'G3DSA:1.25.40.10:FF:001680', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g42310, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(38376, NULL, 'G3DSA:3.30.160.60:FF:003148', NULL, NULL, 'Zinc finger 30C', NULL, NULL, NULL, NULL, NULL, 4),
(38377, NULL, 'G3DSA:3.30.559.30:FF:000125', NULL, NULL, 'Non-ribosomal peptide synthetase OfaA', NULL, NULL, NULL, NULL, NULL, 4),
(38378, NULL, 'G3DSA:2.40.30.190:FF:000001', NULL, NULL, 'Secreted protein ORF2', NULL, NULL, NULL, NULL, NULL, 4),
(38379, NULL, 'G3DSA:3.90.1750.10:FF:000011', NULL, NULL, 'E3 ubiquitin-protein ligase UBR5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(38380, NULL, 'G3DSA:2.20.28.10:FF:000024', NULL, NULL, 'rRNA maturation endonuclease Nob1', NULL, NULL, NULL, NULL, NULL, 4),
(38381, NULL, 'G3DSA:2.60.40.10:FF:001580', NULL, NULL, 'Echinoid, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(38382, NULL, 'G3DSA:3.40.630.30:FF:000172', NULL, NULL, 'GNAT family acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(38383, NULL, 'G3DSA:3.90.360.10:FF:000004', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(38384, NULL, 'G3DSA:1.10.510.10:FF:001138', NULL, NULL, 'Fmp48p', NULL, NULL, NULL, NULL, NULL, 4),
(38385, NULL, 'G3DSA:3.90.190.10:FF:000564', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38386, NULL, 'G3DSA:1.20.1250.20:FF:000639', NULL, NULL, 'Unplaced genomic scaffold supercont1.38, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(38387, NULL, 'G3DSA:3.60.40.10:FF:000228', NULL, NULL, 'PH domain leucine-rich repeat protein phosphatase, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(38388, NULL, 'G3DSA:3.30.450.20:FF:000382', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(38389, NULL, 'G3DSA:2.60.40.10:FF:003906', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38390, NULL, 'G3DSA:3.40.1110.10:FF:000390', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38391, NULL, 'G3DSA:1.10.3660.10:FF:000018', NULL, NULL, 'Prephenate dehydrogenase [NADP(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(38392, NULL, 'G3DSA:3.10.20.260:FF:000001', NULL, NULL, 'Putative NEDD8-activating enzyme E1 catalytic subunit-like', NULL, NULL, NULL, NULL, NULL, 4),
(38393, NULL, 'G3DSA:3.90.280.10:FF:000003', NULL, NULL, 'phosphatidylethanolamine-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(38394, NULL, 'G3DSA:3.30.70.330:FF:000584', NULL, NULL, 'Splicing factor CC1-like', NULL, NULL, NULL, NULL, NULL, 4),
(38395, NULL, 'G3DSA:1.10.3200.20:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38396, NULL, 'G3DSA:2.10.50.10:FF:000110', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38397, NULL, 'G3DSA:2.40.420.20:FF:000050', NULL, NULL, 'Acriflavin resistance periplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(38398, NULL, 'G3DSA:2.30.30.40:FF:000201', NULL, NULL, 'Myosin XVA', NULL, NULL, NULL, NULL, NULL, 4),
(38399, NULL, 'G3DSA:1.10.630.10:FF:000394', NULL, NULL, 'Cytochrome P450 71D8', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(38400, NULL, 'G3DSA:3.40.50.12760:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38401, NULL, 'G3DSA:3.40.630.190:FF:000003', NULL, NULL, 'Polyisoprenyl-teichoic acid--peptidoglycan teichoic acid transferase TagU', NULL, NULL, NULL, NULL, NULL, 4),
(38402, NULL, 'G3DSA:3.30.70.1230:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38403, NULL, 'G3DSA:3.40.50.1360:FF:000008', NULL, NULL, 'Transcriptional regulator, DeoR family', NULL, NULL, NULL, NULL, NULL, 4),
(38404, NULL, 'G3DSA:3.10.50.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38405, NULL, 'G3DSA:1.10.220.10:FF:000014', NULL, NULL, 'annexin D4', NULL, NULL, NULL, NULL, NULL, 4),
(38406, NULL, 'G3DSA:2.160.20.20:FF:000008', NULL, NULL, 'Adhesin/invasin TibA autotransporter', NULL, NULL, NULL, NULL, NULL, 4),
(38407, NULL, 'G3DSA:1.10.10.440:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38408, NULL, 'G3DSA:2.30.110.10:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38409, NULL, 'G3DSA:3.10.20.310:FF:000044', NULL, NULL, 'Hemolysin transporter protein ShlB', NULL, NULL, NULL, NULL, NULL, 4),
(38410, NULL, 'G3DSA:1.25.40.10:FF:001079', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g17210', NULL, NULL, NULL, NULL, NULL, 4),
(38411, NULL, 'G3DSA:1.10.220.20:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38412, NULL, 'G3DSA:3.40.190.10:FF:000873', NULL, NULL, 'Glutamate receptor 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(38413, NULL, 'G3DSA:3.40.50.300:FF:007038', NULL, NULL, 'Si:ch211-139n6.3', NULL, NULL, NULL, NULL, NULL, 4),
(38414, NULL, 'G3DSA:1.25.40.10:FF:005070', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38415, NULL, 'G3DSA:3.30.160.60:FF:001703', NULL, NULL, 'Zinc finger protein, FOG family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(38416, NULL, 'G3DSA:2.60.40.10:FF:003165', NULL, NULL, 'Phosphoglucan, water dikinase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(38417, NULL, 'G3DSA:1.25.40.10:FF:001972', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(38418, NULL, 'G3DSA:1.10.10.540:FF:000012', NULL, NULL, 'UV excision repair protein RAD23-like protein B', NULL, NULL, NULL, NULL, NULL, 4),
(38419, NULL, 'G3DSA:3.30.40.10:FF:001511', NULL, NULL, 'Putative ring finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(38420, NULL, 'G3DSA:2.130.10.10:FF:003261', NULL, NULL, 'Syntaxin-binding protein 5 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(38421, NULL, 'G3DSA:3.30.200.20:FF:001420', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38422, NULL, 'G3DSA:3.30.190.20:FF:000018', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(38423, NULL, 'G3DSA:1.10.10.350:FF:000011', NULL, NULL, 'Glutamate--tRNA ligase 2', NULL, NULL, NULL, NULL, NULL, 4),
(38424, NULL, 'G3DSA:3.80.10.10:FF:002654', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RCH1', NULL, NULL, NULL, NULL, NULL, 4),
(38425, NULL, 'G3DSA:1.25.10.10:FF:001285', NULL, NULL, 'HEAT repeat containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(38426, NULL, 'G3DSA:2.130.10.10:FF:002979', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38427, NULL, 'G3DSA:3.60.10.10:FF:000165', NULL, NULL, 'DNase I-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(38428, NULL, 'G3DSA:4.10.280.10:FF:000169', NULL, NULL, 'FI24210p1', NULL, NULL, NULL, NULL, NULL, 4),
(38429, NULL, 'G3DSA:1.20.1250.20:FF:000347', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(38430, NULL, 'G3DSA:3.40.1180.10:FF:000012', NULL, NULL, 'Alkyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(38431, NULL, 'G3DSA:1.25.40.20:FF:000222', NULL, NULL, 'Short transient receptor potential channel 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(38432, NULL, 'G3DSA:1.10.510.10:FF:002245', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(38433, NULL, 'G3DSA:2.60.120.380:FF:000082', NULL, NULL, 'Calpain-like protease palB', NULL, NULL, NULL, NULL, NULL, 4),
(38434, NULL, 'G3DSA:2.60.40.10:FF:001754', NULL, NULL, 'Protein tyrosine phosphatase, receptor type B', NULL, NULL, NULL, NULL, NULL, 4),
(38435, NULL, 'G3DSA:3.80.10.10:FF:003143', NULL, NULL, 'Protein CBG07183', NULL, NULL, NULL, NULL, NULL, 4),
(38436, NULL, 'G3DSA:1.20.120.1770:FF:000010', NULL, NULL, 'DOMON domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(38437, NULL, 'G3DSA:1.20.1560.10:FF:000379', NULL, NULL, 'Transporter associated with antigen presentation 2', NULL, NULL, NULL, NULL, NULL, 4),
(38438, NULL, 'G3DSA:3.40.50.300:FF:007982', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(38439, NULL, 'G3DSA:1.10.510.10:FF:002032', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38440, NULL, 'G3DSA:3.40.50.720:FF:002471', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(38441, NULL, 'G3DSA:3.40.50.1010:FF:000140', NULL, NULL, 'Protein CBG02516', NULL, NULL, NULL, NULL, NULL, 4),
(38442, NULL, 'G3DSA:3.40.50.300:FF:007752', NULL, NULL, 'Heparan-sulfate 6-O-sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(38443, NULL, 'G3DSA:3.40.440.10:FF:000005', NULL, NULL, 'Adenylosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(38444, NULL, 'G3DSA:3.90.320.10:FF:000064', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38445, NULL, 'G3DSA:3.40.30.10:FF:000184', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(38446, NULL, 'G3DSA:3.90.25.10:FF:000029', NULL, NULL, 'GalE family epimerase/dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(38447, NULL, 'G3DSA:3.20.20.70:FF:000718', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38448, NULL, 'G3DSA:3.80.10.10:FF:000916', NULL, NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g53440', NULL, NULL, NULL, NULL, NULL, 4),
(38449, NULL, 'G3DSA:3.40.710.10:FF:000099', NULL, NULL, 'Membrane peptidoglycan carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(38450, NULL, 'G3DSA:3.90.640.90:FF:000004', NULL, NULL, 'FOG-3', NULL, NULL, NULL, NULL, NULL, 4),
(38451, NULL, 'G3DSA:1.25.40.10:FF:003557', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38452, NULL, 'G3DSA:3.30.1490.480:FF:000007', NULL, NULL, 'Endolytic murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(38453, NULL, 'G3DSA:1.10.510.10:FF:001756', NULL, NULL, 'Serine/threonine-protein kinase STE7 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(38454, NULL, 'G3DSA:3.30.200.20:FF:001706', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38455, NULL, 'G3DSA:3.10.129.10:FF:000165', NULL, NULL, 'Thioesterase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(38456, NULL, 'G3DSA:3.90.1420.10:FF:000025', NULL, NULL, 'N-lysine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(38457, NULL, 'G3DSA:2.130.10.10:FF:005447', NULL, NULL, 'Transducin beta-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(38458, NULL, 'G3DSA:1.10.268.10:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38459, NULL, 'G3DSA:1.10.287.70:FF:000438', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38460, NULL, 'G3DSA:1.10.285.10:FF:000012', NULL, NULL, 'NADP-specific glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(38461, NULL, 'G3DSA:3.30.420.10:FF:000293', NULL, NULL, 'Protein CBG00653', NULL, NULL, NULL, NULL, NULL, 4),
(38462, NULL, 'G3DSA:3.40.1280.10:FF:000076', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase NEP1', NULL, NULL, NULL, NULL, NULL, 4),
(38463, NULL, 'G3DSA:1.25.40.20:FF:001762', NULL, NULL, 'Poly [ADP-ribose] polymerase tankyrase', NULL, NULL, NULL, NULL, NULL, 4),
(38464, NULL, 'G3DSA:3.30.160.60:FF:005626', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38465, NULL, 'G3DSA:4.10.280.10:FF:000118', NULL, NULL, 'Transcription factor bHLH10', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(38466, NULL, 'G3DSA:3.30.70.330:FF:001640', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38467, NULL, 'G3DSA:3.80.10.10:FF:004503', NULL, NULL, 'Os03g0717000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(38468, NULL, 'G3DSA:1.20.1070.10:FF:000746', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38469, NULL, 'G3DSA:1.10.1530.10:FF:000003', NULL, NULL, 'Malate/L-lactate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(38470, NULL, 'G3DSA:1.10.1390.10:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38471, NULL, 'G3DSA:2.30.29.30:FF:000739', NULL, NULL, 'mRNA DeCAPping enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(38472, NULL, 'G3DSA:1.25.10.10:FF:001852', NULL, NULL, 'AGAP009004-PA', NULL, NULL, NULL, NULL, NULL, 4),
(38473, NULL, 'G3DSA:1.10.533.10:FF:000044', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 1A', NULL, NULL, NULL, NULL, NULL, 4),
(38474, NULL, 'G3DSA:2.130.10.10:FF:002007', NULL, NULL, 'Protein SLOW WALKER 1', NULL, NULL, NULL, NULL, NULL, 4),
(38475, NULL, 'G3DSA:1.10.287.470:FF:000036', NULL, NULL, 'RND family efflux transporter, MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(38476, NULL, 'G3DSA:3.40.50.1820:FF:000731', NULL, NULL, 'NDRG family member 4', NULL, NULL, NULL, NULL, NULL, 4),
(38477, NULL, 'G3DSA:1.20.1740.10:FF:000269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38478, NULL, 'G3DSA:3.30.465.10:FF:000109', NULL, NULL, 'Lactate dehydrogenase D', NULL, NULL, NULL, NULL, NULL, 4),
(38479, NULL, 'G3DSA:1.10.220.110:FF:000002', NULL, NULL, 'GDNF family receptor alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(38480, NULL, 'G3DSA:3.30.300.70:FF:000009', NULL, NULL, 'Ribosome maturation factor RimP', NULL, NULL, NULL, NULL, NULL, 4),
(38481, NULL, 'G3DSA:3.30.40.10:FF:000590', NULL, NULL, 'Putative RING zinc finger domain superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(38482, NULL, 'G3DSA:3.10.20.90:FF:000702', NULL, NULL, 'Autophagy protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(38483, NULL, 'G3DSA:2.40.10.10:FF:000342', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38484, NULL, 'G3DSA:1.10.3430.10:FF:000001', NULL, NULL, 'Ammonium transporter Rh type C', NULL, NULL, NULL, NULL, NULL, 4),
(38485, NULL, 'G3DSA:2.60.40.10:FF:003783', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38486, NULL, 'G3DSA:2.40.50.120:FF:000035', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(38487, NULL, 'G3DSA:3.40.50.720:FF:000784', NULL, NULL, 'GDP-L-fucose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(38488, NULL, 'G3DSA:3.40.390.10:FF:000175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38489, NULL, 'G3DSA:1.10.340.70:FF:000018', NULL, NULL, 'Usp-48', NULL, NULL, NULL, NULL, NULL, 4),
(38490, NULL, 'G3DSA:2.60.120.10:FF:000132', NULL, NULL, 'mannose-6-phosphate isomerase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(38491, NULL, 'G3DSA:1.25.10.10:FF:003168', NULL, NULL, 'Ubiquitin-protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38492, NULL, 'G3DSA:3.40.710.10:FF:000048', NULL, NULL, 'Probable peptidoglycan D,D-transpeptidase PenA', NULL, NULL, NULL, NULL, NULL, 4),
(38493, NULL, 'G3DSA:2.130.10.10:FF:003822', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1', NULL, NULL, NULL, NULL, NULL, 4),
(38494, NULL, 'G3DSA:1.25.40.10:FF:001354', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(38495, NULL, 'G3DSA:3.40.50.2300:FF:000886', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38496, NULL, 'G3DSA:3.90.70.10:FF:000431', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(38497, NULL, 'G3DSA:3.40.50.10190:FF:000329', NULL, NULL, 'DNA-directed DNA/RNA polymerase mu', NULL, NULL, NULL, NULL, NULL, 4),
(38498, NULL, 'G3DSA:3.30.450.20:FF:000056', NULL, NULL, 'aryl hydrocarbon receptor repressor', NULL, NULL, NULL, NULL, NULL, 4),
(38499, NULL, 'G3DSA:2.40.30.70:FF:000007', NULL, NULL, 'Methyltransferase, YaeB/AF_0241 family protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(38500, NULL, 'G3DSA:3.40.50.1010:FF:000191', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38501, NULL, 'G3DSA:3.40.630.30:FF:000430', NULL, NULL, 'Probable N-acetylglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(38502, NULL, 'G3DSA:3.90.640.10:FF:000251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38503, NULL, 'G3DSA:1.20.1560.10:FF:000328', NULL, NULL, 'Lipid A export ATP-binding/permease protein MsbA', NULL, NULL, NULL, NULL, NULL, 4),
(38504, NULL, 'G3DSA:1.20.58.1120:FF:000026', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(38505, NULL, 'G3DSA:1.10.510.10:FF:003167', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38506, NULL, 'G3DSA:2.40.30.10:FF:000225', NULL, NULL, 'Probable translation initiation factor IF-2', NULL, NULL, NULL, NULL, NULL, 4),
(38507, NULL, 'G3DSA:3.40.50.300:FF:007931', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38508, NULL, 'G3DSA:3.30.200.20:FF:001145', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38509, NULL, 'G3DSA:3.40.1280.30:FF:000003', NULL, NULL, 'tRNA methyltransferase 10C, mitochondrial RNase P subunit', NULL, NULL, NULL, NULL, NULL, 4),
(38510, NULL, 'G3DSA:3.90.650.10:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38511, NULL, 'G3DSA:1.10.287.310:FF:000016', NULL, NULL, 'Ribosomal L29 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(38512, NULL, 'G3DSA:3.80.10.10:FF:000967', NULL, NULL, 'F-box/LRR-repeat protein 3 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(38513, NULL, 'G3DSA:3.80.10.10:FF:004278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38514, NULL, 'G3DSA:1.25.40.10:FF:000865', NULL, NULL, 'Target for rapamycin', NULL, NULL, NULL, NULL, NULL, 4),
(38515, NULL, 'G3DSA:3.40.1170.60:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38516, NULL, 'G3DSA:1.10.8.10:FF:000283', NULL, NULL, 'AT5g12120/MXC9_8', NULL, NULL, NULL, NULL, NULL, 4),
(38517, NULL, 'G3DSA:3.40.50.2300:FF:001016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38518, NULL, 'G3DSA:3.40.50.1820:FF:000635', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(38519, NULL, 'G3DSA:1.10.10.10:FF:002010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38520, NULL, 'G3DSA:1.20.1270.60:FF:000282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38521, NULL, 'G3DSA:3.40.850.10:FF:000558', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(38522, NULL, 'G3DSA:1.10.150.50:FF:000071', NULL, NULL, 'Caskin, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(38523, NULL, 'G3DSA:1.25.40.20:FF:001357', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38524, NULL, 'G3DSA:2.130.10.10:FF:001518', NULL, NULL, 'GD13102', NULL, NULL, NULL, NULL, NULL, 4),
(38525, NULL, 'G3DSA:1.50.10.10:FF:000119', NULL, NULL, 'Glycogen debranching enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38526, NULL, 'G3DSA:1.20.5.190:FF:000131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38527, NULL, 'G3DSA:3.80.10.10:FF:003789', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38528, NULL, 'G3DSA:1.20.5.170:FF:000058', NULL, NULL, 'Intermediate filament protein B', NULL, NULL, NULL, NULL, NULL, 4),
(38529, NULL, 'G3DSA:2.40.30.230:FF:000002', NULL, NULL, 'regulator of nonsense transcripts 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(38530, NULL, 'G3DSA:2.70.50.30:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38531, NULL, 'G3DSA:2.60.120.10:FF:000744', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38532, NULL, 'G3DSA:1.10.12.10:FF:000047', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(38533, NULL, 'G3DSA:2.60.40.10:FF:003378', NULL, NULL, 'Ig-like and fibronectin type-III domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(38534, NULL, 'G3DSA:2.60.40.1730:FF:000048', NULL, NULL, 'YALI0C13904p', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(38535, NULL, 'G3DSA:1.20.1250.10:FF:000069', NULL, NULL, 'Interleukin-6', NULL, NULL, NULL, NULL, NULL, 4),
(38536, NULL, 'G3DSA:3.30.2160.10:FF:000030', NULL, NULL, 'Ubiquitin ligase (E3)', NULL, NULL, NULL, NULL, NULL, 4),
(38537, NULL, 'G3DSA:3.30.9.90:FF:000001', NULL, NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(38538, NULL, 'G3DSA:2.60.40.10:FF:002889', NULL, NULL, 'Leptin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(38539, NULL, 'G3DSA:2.40.240.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38540, NULL, 'G3DSA:3.80.10.10:FF:000349', NULL, NULL, 'Dynein assembly factor 1, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(38541, NULL, 'G3DSA:1.10.506.10:FF:000010', NULL, NULL, 'Plexin B1', NULL, NULL, NULL, NULL, NULL, 4),
(38542, NULL, 'G3DSA:1.25.40.70:FF:000034', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit gamma, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38543, NULL, 'G3DSA:1.20.1440.100:FF:000014', NULL, NULL, 'Putative phosphatase involved in 2-Alkyl-4-hydroxymethylfuran-3-carboxylic acid biosynthesis, MmfP', NULL, NULL, NULL, NULL, NULL, 4),
(38544, NULL, 'G3DSA:1.20.1250.20:FF:000847', NULL, NULL, 'MFS gliotoxin efflux transporter GliA', NULL, NULL, NULL, NULL, NULL, 4),
(38545, NULL, 'G3DSA:3.40.720.10:FF:000167', NULL, NULL, 'Arylsulfatase family member H', NULL, NULL, NULL, NULL, NULL, 4),
(38546, NULL, 'G3DSA:1.20.1250.20:FF:000791', NULL, NULL, 'Uncharacterized transporter slc-17.2', NULL, NULL, NULL, NULL, NULL, 4),
(38547, NULL, 'G3DSA:2.60.40.1930:FF:000018', NULL, NULL, 'Thioester-containing protein 4, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(38548, NULL, 'G3DSA:3.80.10.10:FF:000355', NULL, NULL, 'Toll-like receptor Tollo', NULL, NULL, NULL, NULL, NULL, 4),
(38549, NULL, 'G3DSA:3.30.428.30:FF:000001', NULL, NULL, 'CDP-diacylglycerol pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(38550, NULL, 'G3DSA:2.30.39.10:FF:000083', NULL, NULL, 'Serpin-2 precursor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38551, NULL, 'G3DSA:3.40.630.30:FF:000104', NULL, NULL, 'Aerobactin siderophore biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(38552, NULL, 'G3DSA:1.20.58.60:FF:000532', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38553, NULL, 'G3DSA:1.10.510.10:FF:000800', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(38554, NULL, 'G3DSA:3.30.200.20:FF:002494', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38555, NULL, 'G3DSA:3.30.160.60:FF:005705', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38556, NULL, 'G3DSA:1.20.1560.10:FF:000654', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38557, NULL, 'G3DSA:3.40.605.10:FF:000034', NULL, NULL, 'Aldehyde dehydrogenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(38558, NULL, 'G3DSA:3.30.780.10:FF:000038', NULL, NULL, 'Protein translation factor SUI1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(38559, NULL, 'G3DSA:2.40.50.140:FF:000985', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38560, NULL, 'G3DSA:3.30.420.270:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38561, NULL, 'G3DSA:2.30.30.40:FF:000021', NULL, NULL, 'Putative sam and sh3 domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(38562, NULL, 'G3DSA:3.40.50.300:FF:004430', NULL, NULL, 'ABC transporter ATP-binding protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(38563, NULL, 'G3DSA:2.70.50.80:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38564, NULL, 'G3DSA:3.60.40.10:FF:000346', NULL, NULL, 'Os04g0449400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(38565, NULL, 'G3DSA:2.180.10.10:FF:000010', NULL, NULL, 'Cell wall-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(38566, NULL, 'G3DSA:3.40.50.12710:FF:000041', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7', NULL, NULL, NULL, NULL, NULL, 4),
(38567, NULL, 'G3DSA:3.40.50.10190:FF:000363', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(38568, NULL, 'G3DSA:3.30.160.60:FF:005059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38569, NULL, 'G3DSA:2.60.40.420:FF:000186', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38570, NULL, 'G3DSA:1.10.3730.20:FF:000055', NULL, NULL, 'Membrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38571, NULL, 'G3DSA:1.20.1540.10:FF:000119', NULL, NULL, 'Probable glpG protein', NULL, NULL, NULL, NULL, NULL, 4),
(38572, NULL, 'G3DSA:2.60.40.1910:FF:000012', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(38573, NULL, 'G3DSA:1.10.390.10:FF:000032', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(38574, NULL, 'G3DSA:2.60.40.10:FF:004103', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38575, NULL, 'G3DSA:2.60.120.920:FF:000171', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38576, NULL, 'G3DSA:2.130.10.10:FF:004992', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38577, NULL, 'G3DSA:3.30.70.330:FF:001314', NULL, NULL, 'Ribosomal protein L23, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38578, NULL, 'G3DSA:2.60.120.200:FF:000247', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(38579, NULL, 'G3DSA:3.40.50.300:FF:007656', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38580, NULL, 'G3DSA:2.30.180.10:FF:000108', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38581, NULL, 'G3DSA:3.50.30.30:FF:000144', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38582, NULL, 'G3DSA:3.30.497.10:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38583, NULL, 'G3DSA:3.40.50.300:FF:005565', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38584, NULL, 'G3DSA:4.10.320.30:FF:000005', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(38585, NULL, 'G3DSA:3.20.20.140:FF:000480', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38586, NULL, 'G3DSA:3.30.1360.70:FF:000001', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(38587, NULL, 'G3DSA:1.25.10.10:FF:001818', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38588, NULL, 'G3DSA:3.60.40.10:FF:000307', NULL, NULL, 'Protein phosphatase 2C-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(38589, NULL, 'G3DSA:2.30.29.30:FF:000745', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(38590, NULL, 'G3DSA:2.60.120.200:FF:000573', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38591, NULL, 'G3DSA:2.10.50.10:FF:000082', NULL, NULL, 'Zinc finger domain LSD1 subclass family protein', NULL, NULL, NULL, NULL, NULL, 4),
(38592, NULL, 'G3DSA:1.25.10.10:FF:003376', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38593, NULL, 'G3DSA:1.20.120.1080:FF:000016', NULL, NULL, 'ATP-dependent RNA helicase A', NULL, NULL, NULL, NULL, NULL, 4),
(38594, NULL, 'G3DSA:1.10.10.10:FF:002009', NULL, NULL, 'Vacuolar membrane-associated protein IML1', NULL, NULL, NULL, NULL, NULL, 4),
(38595, NULL, 'G3DSA:2.60.40.10:FF:005531', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38596, NULL, 'G3DSA:3.30.70.330:FF:002736', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38597, NULL, 'G3DSA:1.10.510.10:FF:003493', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38598, NULL, 'G3DSA:3.50.50.60:FF:000593', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38599, NULL, 'G3DSA:3.30.420.40:FF:000043', NULL, NULL, 'glycerol kinase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(38600, NULL, 'G3DSA:2.80.10.50:FF:000122', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38601, NULL, 'G3DSA:2.60.120.10:FF:000750', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38602, NULL, 'G3DSA:3.40.30.10:FF:000392', NULL, NULL, 'Glutathione S-transferase pi 1', NULL, NULL, NULL, NULL, NULL, 4),
(38603, NULL, 'G3DSA:3.40.50.720:FF:000672', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(38604, NULL, 'G3DSA:3.40.50.1820:FF:000523', NULL, NULL, 'Pimeloyl-[acyl-carrier protein] methyl ester esterase', NULL, NULL, NULL, NULL, NULL, 4),
(38605, NULL, 'G3DSA:1.10.510.10:FF:001256', NULL, NULL, 'Cell division protein kinase 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(38606, NULL, 'G3DSA:2.40.50.140:FF:000928', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38607, NULL, 'G3DSA:3.40.1110.10:FF:000305', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38608, NULL, 'G3DSA:1.10.486.10:FF:000018', NULL, NULL, 'Helicase in mitochondria', NULL, NULL, NULL, NULL, NULL, 4),
(38609, NULL, 'G3DSA:3.30.160.60:FF:005744', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38610, NULL, 'G3DSA:1.20.1150.12:FF:000002', NULL, NULL, 'Disulfide isomerase TigA', NULL, NULL, NULL, NULL, NULL, 4),
(38611, NULL, 'G3DSA:3.50.50.60:FF:001256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38612, NULL, 'G3DSA:1.25.50.20:FF:000048', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(38613, NULL, 'G3DSA:3.40.50.410:FF:000197', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(38614, NULL, 'G3DSA:3.30.420.10:FF:000731', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38615, NULL, 'G3DSA:3.90.320.10:FF:000058', NULL, NULL, 'UvrD/REP helicase domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38616, NULL, 'G3DSA:3.50.50.60:FF:000688', NULL, NULL, 'NADH-dependent phenylglyoxylate dehydrogenase subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(38617, NULL, 'G3DSA:3.80.10.10:FF:000681', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', NULL, NULL, NULL, NULL, NULL, 4),
(38618, NULL, 'G3DSA:3.40.50.2300:FF:001050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38619, NULL, 'G3DSA:3.30.70.330:FF:002793', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38620, NULL, 'G3DSA:2.60.40.10:FF:002030', NULL, NULL, 'B-cell receptor CD22', NULL, NULL, NULL, NULL, NULL, 4),
(38621, NULL, 'G3DSA:2.60.120.920:FF:000058', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM69', NULL, NULL, NULL, NULL, NULL, 4),
(38622, NULL, 'G3DSA:1.20.120.1070:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38623, NULL, 'G3DSA:2.60.40.650:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38624, NULL, 'G3DSA:3.80.10.10:FF:001344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38625, NULL, 'G3DSA:2.130.10.10:FF:001911', NULL, NULL, 'RaBConnectin related', NULL, NULL, NULL, NULL, NULL, 4),
(38626, NULL, 'G3DSA:1.25.40.10:FF:001854', NULL, NULL, 'GD16292', NULL, NULL, NULL, NULL, NULL, 4),
(38627, NULL, 'G3DSA:1.25.40.20:FF:001857', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38628, NULL, 'G3DSA:1.10.10.10:FF:000031', NULL, NULL, 'Paired box protein Pax-7', NULL, NULL, NULL, NULL, NULL, 4),
(38629, NULL, 'G3DSA:3.30.200.20:FF:001712', NULL, NULL, 'Ste20-like serine threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(38630, NULL, 'G3DSA:1.20.1070.10:FF:000538', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(38631, NULL, 'G3DSA:3.30.160.60:FF:003614', NULL, NULL, 'Serendipity beta, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(38632, NULL, 'G3DSA:3.90.550.10:FF:000081', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(38633, NULL, 'G3DSA:3.40.50.300:FF:000046', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(38634, NULL, 'G3DSA:2.60.120.10:FF:000536', NULL, NULL, '2-hydroxyethylphosphonate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(38635, NULL, 'G3DSA:3.40.30.10:FF:000178', NULL, NULL, 'glutaredoxin domain-containing cysteine-rich protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(38636, NULL, 'G3DSA:1.10.555.10:FF:000089', NULL, NULL, 'Rho GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38637, NULL, 'G3DSA:1.10.10.10:FF:001228', NULL, NULL, 'Topoisomerase, putative', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(38638, NULL, 'G3DSA:3.30.160.60:FF:005391', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38639, NULL, 'G3DSA:3.30.1120.10:FF:000016', NULL, NULL, 'Arylsulfatase A', NULL, NULL, NULL, NULL, NULL, 4),
(38640, NULL, 'G3DSA:1.10.10.10:FF:001346', NULL, NULL, 'Vacuolar proteinsorting--associated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38641, NULL, 'G3DSA:3.40.50.720:FF:000397', NULL, NULL, 'UDP-galactopyranose mutase', NULL, NULL, NULL, NULL, NULL, 4),
(38642, NULL, 'G3DSA:1.25.10.10:FF:001465', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(38643, NULL, 'G3DSA:3.30.710.10:FF:000326', NULL, NULL, 'SKN-1 Dependent Zygotic transcript', NULL, NULL, NULL, NULL, NULL, 4),
(38644, NULL, 'G3DSA:1.10.8.10:FF:000075', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 24', NULL, NULL, NULL, NULL, NULL, 4),
(38645, NULL, 'G3DSA:1.25.40.180:FF:000169', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38646, NULL, 'G3DSA:3.40.50.1360:FF:000014', NULL, NULL, 'Ribose 5-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(38647, NULL, 'G3DSA:3.30.420.10:FF:000343', NULL, NULL, 'Poly(A)-specific ribonuclease PARN', NULL, NULL, NULL, NULL, NULL, 4),
(38648, NULL, 'G3DSA:3.30.40.10:FF:000943', NULL, NULL, 'V(D)J recombination-activating protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(38649, NULL, 'G3DSA:2.10.220.10:FF:000033', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(38650, NULL, 'G3DSA:1.20.920.20:FF:000057', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38651, NULL, 'G3DSA:3.30.70.330:FF:001601', NULL, NULL, 'DAZ protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(38652, NULL, 'G3DSA:1.20.5.340:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38653, NULL, 'G3DSA:3.40.50.150:FF:000130', NULL, NULL, 'Alkylated DNA repair protein alkB homolog 8', NULL, NULL, NULL, NULL, NULL, 4),
(38654, NULL, 'G3DSA:3.80.10.10:FF:002704', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(38655, NULL, 'G3DSA:3.40.50.10190:FF:000088', NULL, NULL, 'Chitin biosynthesis protein (Chs5), putative', NULL, NULL, NULL, NULL, NULL, 4),
(38656, NULL, 'G3DSA:3.30.450.20:FF:000505', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(38657, NULL, 'G3DSA:3.60.20.10:FF:000019', NULL, NULL, 'Proteasome subunit alpha type', NULL, NULL, NULL, NULL, NULL, 4),
(38658, NULL, 'G3DSA:3.10.390.10:FF:000007', NULL, NULL, 'Deformed epidermal autoregulatory factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(38659, NULL, 'G3DSA:2.130.10.10:FF:005267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38660, NULL, 'G3DSA:2.60.40.60:FF:000959', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38661, NULL, 'G3DSA:1.25.40.10:FF:005244', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(38662, NULL, 'G3DSA:1.20.920.10:FF:000054', NULL, NULL, 'Zinc finger MYND-type containing 11', NULL, NULL, NULL, NULL, NULL, 4),
(38663, NULL, 'G3DSA:1.10.600.10:FF:000066', NULL, NULL, 'Presilphiperfolan-8-beta-ol synthase', NULL, NULL, NULL, NULL, NULL, 4),
(38664, NULL, 'G3DSA:3.40.50.2300:FF:001403', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38665, NULL, 'G3DSA:2.60.40.10:FF:004160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38666, NULL, 'G3DSA:3.30.70.330:FF:002950', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38667, NULL, 'G3DSA:1.10.287.1240:FF:000004', NULL, NULL, 'Exodeoxyribonuclease I', NULL, NULL, NULL, NULL, NULL, 4),
(38668, NULL, 'G3DSA:2.60.40.150:FF:000700', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38669, NULL, 'G3DSA:3.40.50.10190:FF:000155', NULL, NULL, 'Os05g0486600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(38670, NULL, 'G3DSA:1.25.40.20:FF:000334', NULL, NULL, 'S-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(38671, NULL, 'G3DSA:2.10.25.10:FF:000254', NULL, NULL, 'Pro-epidermal growth factor', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(38672, NULL, 'G3DSA:2.30.31.10:FF:000003', NULL, NULL, 'SUB1p Transcriptional coactivator', NULL, NULL, NULL, NULL, NULL, 4),
(38673, NULL, 'G3DSA:3.20.20.80:FF:000547', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38674, NULL, 'G3DSA:3.40.1190.20:FF:000167', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38675, NULL, 'G3DSA:1.10.8.10:FF:000311', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38676, NULL, 'G3DSA:1.25.40.10:FF:000331', NULL, NULL, 'dynein assembly factor 4, axonemal isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(38677, NULL, 'G3DSA:1.20.58.830:FF:000036', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(38678, NULL, 'G3DSA:3.30.420.610:FF:000011', NULL, NULL, 'tudor domain-containing protein 5 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(38679, NULL, 'G3DSA:2.102.10.10:FF:000042', NULL, NULL, 'Terephthalate 1,2-dioxygenase oxygenase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(38680, NULL, 'G3DSA:3.40.50.10090:FF:000064', NULL, NULL, 'Uroporphyrin-III C-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(38681, NULL, 'G3DSA:1.25.40.1040:FF:000003', NULL, NULL, 'N-terminal acetyltransferase A, auxiliary subunit', NULL, NULL, NULL, NULL, NULL, 4),
(38682, NULL, 'G3DSA:1.20.120.350:FF:000105', NULL, NULL, 'CRE-KVS-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(38683, NULL, 'G3DSA:3.40.50.720:FF:002583', NULL, NULL, 'Lysine-ketoglutarate reductase/saccharopine dehydrogenase bifunctional enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(38684, NULL, 'G3DSA:3.10.20.710:FF:000006', NULL, NULL, 'DNA-binding protein SATB', NULL, NULL, NULL, NULL, NULL, 4),
(38685, NULL, 'G3DSA:3.40.50.10330:FF:000068', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(38686, NULL, 'G3DSA:3.90.1200.10:FF:000048', NULL, NULL, 'Spore coat protein CotS', NULL, NULL, NULL, NULL, NULL, 4),
(38687, NULL, 'G3DSA:3.40.50.2300:FF:001460', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38688, NULL, 'G3DSA:2.40.20.10:FF:000011', NULL, NULL, 'Plasminogen', NULL, NULL, NULL, NULL, NULL, 4),
(38689, NULL, 'G3DSA:3.40.50.10090:FF:000007', NULL, NULL, 'Uroporphyrinogen-III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(38690, NULL, 'G3DSA:1.10.510.10:FF:003555', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38691, NULL, 'G3DSA:1.20.1160.20:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38692, NULL, 'G3DSA:1.20.1070.10:FF:000690', NULL, NULL, 'Putative allatostatin B receptor', NULL, NULL, NULL, NULL, NULL, 4),
(38693, NULL, 'G3DSA:1.10.10.60:FF:001215', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38694, NULL, 'G3DSA:2.60.40.10:FF:001248', NULL, NULL, 'Matrix remodeling associated 5', NULL, NULL, NULL, NULL, NULL, 4),
(38695, NULL, 'G3DSA:3.30.40.10:FF:000882', NULL, NULL, 'E3 ubiquitin-protein ligase RMA3', NULL, NULL, NULL, NULL, NULL, 4),
(38696, NULL, 'G3DSA:3.30.540.30:FF:000004', NULL, NULL, 'Dipeptidyl peptidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(38697, NULL, 'G3DSA:1.20.120.350:FF:000217', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38698, NULL, 'G3DSA:2.130.10.10:FF:004784', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38699, NULL, 'G3DSA:1.20.58.60:FF:000419', NULL, NULL, 'Myosin light chain kinase, smooth muscle', NULL, NULL, NULL, NULL, NULL, 4),
(38700, NULL, 'G3DSA:3.60.21.10:FF:000033', NULL, NULL, 'Tartrate-resistant acid phosphatase type 5', NULL, NULL, NULL, NULL, NULL, 4),
(38701, NULL, 'G3DSA:2.60.220.50:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38702, NULL, 'G3DSA:3.30.200.20:FF:001066', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(38703, NULL, 'G3DSA:1.50.40.10:FF:000155', NULL, NULL, 'Solute carrier family 25 member 4', NULL, NULL, NULL, NULL, NULL, 4),
(38704, NULL, 'G3DSA:1.10.510.10:FF:003673', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38705, NULL, 'G3DSA:2.40.50.1070:FF:000012', NULL, NULL, 'RNA m5u methyltransferase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(38706, NULL, 'G3DSA:3.30.160.60:FF:005952', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38707, NULL, 'G3DSA:1.20.5.110:FF:000326', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38708, NULL, 'G3DSA:1.10.287.920:FF:000008', NULL, NULL, 'Pheromone P-factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(38709, NULL, 'G3DSA:2.10.25.10:FF:001243', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(38710, NULL, 'G3DSA:3.40.50.10070:FF:000001', NULL, NULL, 'Tol-Pal system protein TolB', NULL, NULL, NULL, NULL, NULL, 4),
(38711, NULL, 'G3DSA:3.40.50.300:FF:005953', NULL, NULL, 'DNA mismatch repair protein MSH3', NULL, NULL, NULL, NULL, NULL, 4),
(38712, NULL, 'G3DSA:1.10.10.10:FF:000211', NULL, NULL, 'Regulatory factor X, 6', NULL, NULL, NULL, NULL, NULL, 4),
(38713, NULL, 'G3DSA:1.25.40.10:FF:002989', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g42630', NULL, NULL, NULL, NULL, NULL, 4),
(38714, NULL, 'G3DSA:3.30.930.10:FF:000308', NULL, NULL, 'Seryl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38715, NULL, 'G3DSA:1.20.5.350:FF:000011', NULL, NULL, 'Troponin I body wall-embryo/larva muscle isoform', NULL, NULL, NULL, NULL, NULL, 4),
(38716, NULL, 'G3DSA:2.30.30.490:FF:000043', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38717, NULL, 'G3DSA:3.40.50.300:FF:005801', NULL, NULL, 'DNA helicase RepD', NULL, NULL, NULL, NULL, NULL, 4),
(38718, NULL, 'G3DSA:3.30.40.10:FF:000668', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(38719, NULL, 'G3DSA:1.20.1070.10:FF:000358', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(38720, NULL, 'G3DSA:1.20.1250.20:FF:000459', NULL, NULL, 'Major facilitator superfamily domain containing 4A', NULL, NULL, NULL, NULL, NULL, 4),
(38721, NULL, 'G3DSA:1.10.287.70:FF:000731', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38722, NULL, 'G3DSA:3.30.70.330:FF:001039', NULL, NULL, 'Putative RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(38723, NULL, 'G3DSA:3.40.630.30:FF:000380', NULL, NULL, 'GNAT family N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(38724, NULL, 'G3DSA:3.40.30.10:FF:000116', NULL, NULL, 'Thiol:disulfide interchange protein DsbD', NULL, NULL, NULL, NULL, NULL, 4),
(38725, NULL, 'G3DSA:3.90.850.10:FF:000025', NULL, NULL, '5-oxo-1,2,5-tricarboxilic-3-penten aciddecarboxilase/isomer', NULL, NULL, NULL, NULL, NULL, 4),
(38726, NULL, 'G3DSA:3.40.50.12780:FF:000073', NULL, NULL, 'Putative long-chain-fatty-acid--CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(38727, NULL, 'G3DSA:1.25.40.20:FF:000452', NULL, NULL, 'ankyrin repeat domain-containing protein 17 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(38728, NULL, 'G3DSA:1.10.510.10:FF:000121', NULL, NULL, 'Serine/threonine-protein kinase nrc-2', NULL, NULL, NULL, NULL, NULL, 4),
(38729, NULL, 'G3DSA:1.10.437.10:FF:000040', NULL, NULL, 'Apoptosis regulator R11', NULL, NULL, NULL, NULL, NULL, 4),
(38730, NULL, 'G3DSA:1.20.1280.50:FF:000094', NULL, NULL, 'F-box and leucine-rich repeat protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(38731, NULL, 'G3DSA:2.60.40.10:FF:001984', NULL, NULL, 'Hemicentin 2', NULL, NULL, NULL, NULL, NULL, 4),
(38732, NULL, 'G3DSA:2.60.40.10:FF:005295', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38733, NULL, 'G3DSA:1.25.40.20:FF:001649', NULL, NULL, 'NAD-dependent deacetylase sir2B', NULL, NULL, NULL, NULL, NULL, 4),
(38734, NULL, 'G3DSA:1.10.510.10:FF:001464', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38735, NULL, 'G3DSA:2.30.39.10:FF:000026', NULL, NULL, 'Serpin 38F, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(38736, NULL, 'G3DSA:1.25.10.10:FF:001931', NULL, NULL, 'ELMO domain-containing protein A', NULL, NULL, NULL, NULL, NULL, 4),
(38737, NULL, 'G3DSA:3.30.1520.10:FF:000064', NULL, NULL, 'Blast:Sorting nexin-16', NULL, NULL, NULL, NULL, NULL, 4),
(38738, NULL, 'G3DSA:1.25.40.180:FF:000170', NULL, NULL, 'YALI0A13101p', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(38739, NULL, 'G3DSA:2.20.100.10:FF:000095', NULL, NULL, 'Circumsporozoite protein', NULL, NULL, NULL, NULL, NULL, 4),
(38740, NULL, 'G3DSA:3.90.176.10:FF:000008', NULL, NULL, 'Lethal factor', NULL, NULL, NULL, NULL, NULL, 4),
(38741, NULL, 'G3DSA:2.30.30.140:FF:000146', NULL, NULL, 'Ubiquitin like with PHD and ring finger domains 2', NULL, NULL, NULL, NULL, NULL, 4),
(38742, NULL, 'G3DSA:3.30.40.10:FF:000825', NULL, NULL, 'Protein CBG07640', NULL, NULL, NULL, NULL, NULL, 4),
(38743, NULL, 'G3DSA:1.25.10.10:FF:001408', NULL, NULL, 'Integrator complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(38744, NULL, 'G3DSA:2.130.10.10:FF:001226', NULL, NULL, 'WD repeat-containing protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(38745, NULL, 'G3DSA:3.40.190.10:FF:000547', NULL, NULL, 'ABC transporter permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(38746, NULL, 'G3DSA:2.20.25.10:FF:000102', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(38747, NULL, 'G3DSA:3.40.50.300:FF:002075', NULL, NULL, 'Probable RSR1-GTP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(38748, NULL, 'G3DSA:2.60.40.790:FF:000100', NULL, NULL, 'ATP binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(38749, NULL, 'G3DSA:1.20.1270.60:FF:000332', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38750, NULL, 'G3DSA:3.40.50.1820:FF:001074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38751, NULL, 'G3DSA:3.80.10.10:FF:002980', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38752, NULL, 'G3DSA:1.25.40.10:FF:001646', NULL, NULL, 'Transcription factor tau subunit sfc4', NULL, NULL, NULL, NULL, NULL, 4),
(38753, NULL, 'G3DSA:3.40.50.150:FF:000208', NULL, NULL, '2-methoxy-6-polyprenyl-1,4-benzoquinol methylase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(38754, NULL, 'G3DSA:2.60.40.10:FF:005520', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38755, NULL, 'G3DSA:2.130.10.10:FF:000208', NULL, NULL, 'dmX-like protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(38756, NULL, 'G3DSA:3.40.50.300:FF:007246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38757, NULL, 'G3DSA:2.130.10.10:FF:001018', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(38758, NULL, 'G3DSA:1.20.5.1190:FF:000002', NULL, NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily A member', NULL, NULL, NULL, NULL, NULL, 4),
(38759, NULL, 'G3DSA:1.10.510.10:FF:003616', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38760, NULL, 'G3DSA:1.10.2000.10:FF:000036', NULL, NULL, 'Frizzled-3', NULL, NULL, NULL, NULL, NULL, 4),
(38761, NULL, 'G3DSA:2.60.40.10:FF:002029', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38762, NULL, 'G3DSA:3.30.200.20:FF:001920', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(38763, NULL, 'G3DSA:3.30.410.40:FF:000003', NULL, NULL, '(R)-mandelonitrile lyase 2', NULL, NULL, NULL, NULL, NULL, 4),
(38764, NULL, 'G3DSA:3.30.160.60:FF:005469', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38765, NULL, 'G3DSA:3.40.50.720:FF:002549', NULL, NULL, 'Siroheme biosynthesis protein met8', NULL, NULL, NULL, NULL, NULL, 4),
(38766, NULL, 'G3DSA:1.25.40.20:FF:000014', NULL, NULL, 'ankyrin repeat domain-containing protein 17 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(38767, NULL, 'G3DSA:1.20.1290.10:FF:000015', NULL, NULL, 'Uncharacterized protein C17D11.03c', NULL, NULL, NULL, NULL, NULL, 4),
(38768, NULL, 'G3DSA:2.40.30.10:FF:000130', NULL, NULL, 'Bifunctional cytochrome P450/NADPH--P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(38769, NULL, 'G3DSA:3.30.2320.80:FF:000007', NULL, NULL, 'Hydrogenase maturation factor HypA', NULL, NULL, NULL, NULL, NULL, 4),
(38770, NULL, 'G3DSA:1.20.1270.60:FF:000214', NULL, NULL, 'GRAF', NULL, NULL, NULL, NULL, NULL, 4),
(38771, NULL, 'G3DSA:2.60.40.1730:FF:000115', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(38772, NULL, 'G3DSA:2.60.120.620:FF:000120', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38773, NULL, 'G3DSA:3.30.930.10:FF:000101', NULL, NULL, 'Lipoate-protein ligase A subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(38774, NULL, 'G3DSA:3.30.1370.210:FF:000006', NULL, NULL, 'Zinc finger CCCH domain-containing protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(38775, NULL, 'G3DSA:1.25.40.10:FF:001293', NULL, NULL, 'Tetratricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(38776, NULL, 'G3DSA:3.30.70.240:FF:000040', NULL, NULL, 'Elongation factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(38777, NULL, 'G3DSA:1.20.870.10:FF:000004', NULL, NULL, 'Ras-specific guanine nucleotide-releasing factor 1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(38778, NULL, 'G3DSA:3.30.1470.10:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38779, NULL, 'G3DSA:2.60.40.10:FF:003665', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38780, NULL, 'G3DSA:3.40.50.300:FF:007544', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38781, NULL, 'G3DSA:2.30.29.30:FF:000824', NULL, NULL, 'Ran-specific GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(38782, NULL, 'G3DSA:2.30.30.380:FF:000010', NULL, NULL, 'MDM4 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(38783, NULL, 'G3DSA:3.40.50.720:FF:002263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38784, NULL, 'G3DSA:3.30.300.150:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38785, NULL, 'G3DSA:1.10.10.1210:FF:000005', NULL, NULL, 'MAGE', NULL, NULL, NULL, NULL, NULL, 4),
(38786, NULL, 'G3DSA:1.25.40.10:FF:001236', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g28660', NULL, NULL, NULL, NULL, NULL, 4),
(38787, NULL, 'G3DSA:1.25.40.20:FF:001239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38788, NULL, 'G3DSA:3.40.1170.10:FF:000017', NULL, NULL, 'Mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(38789, NULL, 'G3DSA:1.25.40.10:FF:000011', NULL, NULL, 'lysine-specific demethylase 6A isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(38790, NULL, 'G3DSA:1.20.950.20:FF:000008', NULL, NULL, 'Cytochrome B561', NULL, NULL, NULL, NULL, NULL, 4),
(38791, NULL, 'G3DSA:1.10.555.10:FF:000090', NULL, NULL, 'T-cell activation Rho GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38792, NULL, 'G3DSA:1.10.520.10:FF:000065', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(38793, NULL, 'G3DSA:3.30.40.10:FF:002293', NULL, NULL, 'Translation elongation factor EF1A/initiation factor IF2gamma family protein', NULL, NULL, NULL, NULL, NULL, 4),
(38794, NULL, 'G3DSA:3.30.420.40:FF:000161', NULL, NULL, 'L-fuculokinase', NULL, NULL, NULL, NULL, NULL, 4),
(38795, NULL, 'G3DSA:2.100.10.50:FF:000008', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38796, NULL, 'G3DSA:2.60.40.10:FF:001366', NULL, NULL, 'Nectin cell adhesion molecule 1a', NULL, NULL, NULL, NULL, NULL, 4),
(38797, NULL, 'G3DSA:3.30.1300.30:FF:000008', NULL, NULL, 'General secretion pathway protein I', NULL, NULL, NULL, NULL, NULL, 4),
(38798, NULL, 'G3DSA:3.40.50.300:FF:006021', NULL, NULL, 'Ras-like GTP-binding protein RhoL', NULL, NULL, NULL, NULL, NULL, 4),
(38799, NULL, 'G3DSA:2.130.10.10:FF:003974', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38800, NULL, 'G3DSA:1.20.1070.10:FF:000858', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38801, NULL, 'G3DSA:1.10.238.20:FF:000024', NULL, NULL, 'Odorant-binding protein 56b', NULL, NULL, NULL, NULL, NULL, 4),
(38802, NULL, 'G3DSA:1.10.10.1200:FF:000002', NULL, NULL, 'MAGE family member A11', NULL, NULL, NULL, NULL, NULL, 4),
(38803, NULL, 'G3DSA:1.20.1740.10:FF:000157', NULL, NULL, 'YALI0B20064p', NULL, NULL, NULL, NULL, NULL, 4),
(38804, NULL, 'G3DSA:3.40.50.1820:FF:000843', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38805, NULL, 'G3DSA:2.60.40.10:FF:005795', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(38806, NULL, 'G3DSA:2.130.10.10:FF:004250', NULL, NULL, 'Histone transcription regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38807, NULL, 'G3DSA:2.30.300.10:FF:000001', NULL, NULL, 'Mu phage baseplate assembly protein GpP', NULL, NULL, NULL, NULL, NULL, 4),
(38808, NULL, 'G3DSA:3.15.20.10:FF:000011', NULL, NULL, 'BPI fold containing family C, like', NULL, NULL, NULL, NULL, NULL, 4),
(38809, NULL, 'G3DSA:3.20.20.140:FF:000266', NULL, NULL, 'Uncharacterized protein MJ0699', NULL, NULL, NULL, NULL, NULL, 4),
(38810, NULL, 'G3DSA:3.30.40.10:FF:000589', NULL, NULL, 'RING/U-box superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(38811, NULL, 'G3DSA:3.75.10.10:FF:000019', NULL, NULL, 'Related to l-arginine:lysine amidinotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(38812, NULL, 'G3DSA:2.10.25.30:FF:000001', NULL, NULL, 'Tryptophan aminotransferase-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(38813, NULL, 'G3DSA:3.10.105.10:FF:000104', NULL, NULL, 'Peptide ABC transporter, peptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(38814, NULL, 'G3DSA:2.100.10.30:FF:000002', NULL, NULL, 'Zymogen granule membrane protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(38815, NULL, 'G3DSA:3.60.20.10:FF:000076', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(38816, NULL, 'G3DSA:1.10.510.10:FF:001817', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38817, NULL, 'G3DSA:2.60.40.10:FF:006071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38818, NULL, 'G3DSA:3.30.70.2850:FF:000003', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(38819, NULL, 'G3DSA:1.25.40.470:FF:000054', NULL, NULL, 'Protein CBR-IFTA-1', NULL, NULL, NULL, NULL, NULL, 4),
(38820, NULL, 'G3DSA:4.10.1000.10:FF:000051', NULL, NULL, 'Cleavage and polyadenylation specificity factor 30 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(38821, NULL, 'G3DSA:1.10.10.10:FF:001285', NULL, NULL, 'Bacterial regulatory, arsR family protein', NULL, NULL, NULL, NULL, NULL, 4),
(38822, NULL, 'G3DSA:1.10.238.10:FF:000021', NULL, NULL, 'Mitochondrial Rho GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(38823, NULL, 'G3DSA:2.10.25.10:FF:001035', NULL, NULL, 'Crumbs', NULL, NULL, NULL, NULL, NULL, 4),
(38824, NULL, 'G3DSA:1.10.506.10:FF:000009', NULL, NULL, 'GTPase-activating protein and VPS9 domain-containing protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(38825, NULL, 'G3DSA:3.40.33.10:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38826, NULL, 'G3DSA:1.10.287.70:FF:000377', NULL, NULL, 'Potassium intermediate/small conductance calcium-activated channel, subfamily N, member 4', NULL, NULL, NULL, NULL, NULL, 4),
(38827, NULL, 'G3DSA:3.80.10.10:FF:000563', NULL, NULL, 'Capricious, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(38828, NULL, 'G3DSA:1.10.510.10:FF:002150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38829, NULL, 'G3DSA:1.25.40.20:FF:001469', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38830, NULL, 'G3DSA:3.30.70.980:FF:000025', NULL, NULL, 'Probable transcriptional regulatory protein VCRC385_02559', NULL, NULL, NULL, NULL, NULL, 4),
(38831, NULL, 'G3DSA:2.60.120.290:FF:000055', NULL, NULL, 'Dorsal-ventral patterning protein tolloid', NULL, NULL, NULL, NULL, NULL, 4),
(38832, NULL, 'G3DSA:2.40.50.140:FF:001143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38833, NULL, 'G3DSA:3.30.1340.30:FF:000005', NULL, NULL, 'Putative signal peptide protein', NULL, NULL, NULL, NULL, NULL, 4),
(38834, NULL, 'G3DSA:1.10.3450.20:FF:000005', NULL, NULL, 'Nuclear pore complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(38835, NULL, 'G3DSA:1.10.3210.10:FF:000018', NULL, NULL, 'Two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(38836, NULL, 'G3DSA:2.40.50.140:FF:000867', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38837, NULL, 'G3DSA:3.80.10.10:FF:002772', NULL, NULL, 'Si:ch211-278p9.1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(38838, NULL, 'G3DSA:2.40.50.140:FF:001182', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38839, NULL, 'G3DSA:3.80.10.10:FF:002715', NULL, NULL, 'Putative leucine-rich repeat receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(38840, NULL, 'G3DSA:2.80.10.50:FF:000111', NULL, NULL, 'Ryanodine receptor 2b (cardiac)', NULL, NULL, NULL, NULL, NULL, 4),
(38841, NULL, 'G3DSA:3.90.640.10:FF:000043', NULL, NULL, 'AGAP008687-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(38842, NULL, 'G3DSA:3.30.160.60:FF:003671', NULL, NULL, 'Zinc finger protein 527', NULL, NULL, NULL, NULL, NULL, 4),
(38843, NULL, 'G3DSA:1.10.10.60:FF:001007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38844, NULL, 'G3DSA:1.10.238.10:FF:000100', NULL, NULL, 'Calmodulin 1', NULL, NULL, NULL, NULL, NULL, 4),
(38845, NULL, 'G3DSA:3.40.190.10:FF:000755', NULL, NULL, 'Glutamate receptor 2.6', NULL, NULL, NULL, NULL, NULL, 4),
(38846, NULL, 'G3DSA:2.60.220.30:FF:000022', NULL, NULL, 'Ankyrin-3', NULL, NULL, NULL, NULL, NULL, 4),
(38847, NULL, 'G3DSA:1.10.240.10:FF:000015', NULL, NULL, 'Tryptophan--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(38848, NULL, 'G3DSA:3.30.1380.20:FF:000010', NULL, NULL, 'Trafficking protein particle complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(38849, NULL, 'G3DSA:1.25.10.10:FF:001695', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(38850, NULL, 'G3DSA:1.20.58.60:FF:000796', NULL, NULL, 'Spectrin beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(38851, NULL, 'G3DSA:3.40.50.1820:FF:000169', NULL, NULL, 'Yersiniabactin biosynthesis thioesterase YbtT', NULL, NULL, NULL, NULL, NULL, 4),
(38852, NULL, 'G3DSA:3.50.30.30:FF:000133', NULL, NULL, 'Uncharacterized RING finger protein C57A7.09', NULL, NULL, NULL, NULL, NULL, 4),
(38853, NULL, 'G3DSA:1.20.58.390:FF:000191', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38854, NULL, 'G3DSA:3.40.50.450:FF:000063', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit beta 2', NULL, NULL, NULL, NULL, NULL, 4),
(38855, NULL, 'G3DSA:3.30.559.30:FF:000030', NULL, NULL, 'Hydroxamate-type ferrichrome siderophore peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(38856, NULL, 'G3DSA:3.40.50.970:FF:000067', NULL, NULL, '2-hydroxyacyl-CoA lyase 1', NULL, NULL, NULL, NULL, NULL, 4),
(38857, NULL, 'G3DSA:1.20.1730.10:FF:000033', NULL, NULL, 'Urea transporter or sodium transporter', NULL, NULL, NULL, NULL, NULL, 4),
(38858, NULL, 'G3DSA:2.40.30.10:FF:000017', NULL, NULL, 'Eukaryotic peptide chain release factor GTP-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(38859, NULL, 'G3DSA:3.30.70.3400:FF:000011', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(38860, NULL, 'G3DSA:1.10.1520.10:FF:000098', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38861, NULL, 'G3DSA:1.10.630.10:FF:000455', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38862, NULL, 'G3DSA:3.30.1430.10:FF:000006', NULL, NULL, 'LSU ribosomal protein L3P', NULL, NULL, NULL, NULL, NULL, 4),
(38863, NULL, 'G3DSA:3.30.160.60:FF:002254', NULL, NULL, 'Zinc finger protein 540', NULL, NULL, NULL, NULL, NULL, 4),
(38864, NULL, 'G3DSA:3.60.10.10:FF:000277', NULL, NULL, 'Protein translocase subunit SECA1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(38865, NULL, 'G3DSA:1.10.3880.10:FF:000001', NULL, NULL, 'Probable Fe(2+)-trafficking protein', NULL, NULL, NULL, NULL, NULL, 4),
(38866, NULL, 'G3DSA:2.30.30.140:FF:000135', NULL, NULL, 'Metal-response element-binding transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(38867, NULL, 'G3DSA:3.80.10.10:FF:000849', NULL, NULL, 'F-box and leucine-rich repeat protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(38868, NULL, 'G3DSA:2.60.40.10:FF:000231', NULL, NULL, 'Sidekick cell adhesion molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(38869, NULL, 'G3DSA:1.20.1070.10:FF:001353', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(38870, NULL, 'G3DSA:1.10.510.10:FF:001874', NULL, NULL, 'Differentiation inhibitory kinase', NULL, NULL, NULL, NULL, NULL, 4),
(38871, NULL, 'G3DSA:3.40.50.300:FF:007864', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38872, NULL, 'G3DSA:1.20.1250.20:FF:000229', NULL, NULL, 'Major facilitator superfamily domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(38873, NULL, 'G3DSA:2.130.10.10:FF:003356', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38874, NULL, 'G3DSA:3.30.60.30:FF:000074', NULL, NULL, 'Serine protease inhibitor Kazal-type 5-like', NULL, NULL, NULL, NULL, NULL, 4),
(38875, NULL, 'G3DSA:2.130.10.10:FF:001636', NULL, NULL, 'Putative small nucleolar ribonucleoprotein complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(38876, NULL, 'G3DSA:3.40.50.620:FF:000193', NULL, NULL, 'Cryptochrome 1', NULL, NULL, NULL, NULL, NULL, 4),
(38877, NULL, 'G3DSA:1.10.287.70:FF:000091', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(38878, NULL, 'G3DSA:3.40.50.1110:FF:000164', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(38879, NULL, 'G3DSA:3.30.230.10:FF:000396', NULL, NULL, 'AFR031Cp', NULL, NULL, NULL, NULL, NULL, 4),
(38880, NULL, 'G3DSA:3.30.200.20:FF:001302', NULL, NULL, 'interleukin-1 receptor-associated kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(38881, NULL, 'G3DSA:2.20.100.10:FF:000218', NULL, NULL, 'kielin/chordin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(38882, NULL, 'G3DSA:1.10.533.10:FF:000252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38883, NULL, 'G3DSA:1.20.1110.10:FF:000121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38884, NULL, 'G3DSA:1.25.40.10:FF:003445', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At1g13800', NULL, NULL, NULL, NULL, NULL, 4),
(38885, NULL, 'G3DSA:1.20.1560.10:FF:000446', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(38886, NULL, 'G3DSA:1.10.490.10:FF:000028', NULL, NULL, 'Adenylate cyclase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(38887, NULL, 'G3DSA:2.10.25.10:FF:000243', NULL, NULL, 'Adhesion G protein-coupled receptor E1', NULL, NULL, NULL, NULL, NULL, 4),
(38888, NULL, 'G3DSA:3.40.50.300:FF:003536', NULL, NULL, 'Rab_A63 protein', NULL, NULL, NULL, NULL, NULL, 4),
(38889, NULL, 'G3DSA:3.40.50.800:FF:000044', NULL, NULL, 'Threonine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(38890, NULL, 'G3DSA:3.30.160.60:FF:003878', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38891, NULL, 'G3DSA:3.30.160.60:FF:003592', NULL, NULL, 'LD46263p', NULL, NULL, NULL, NULL, NULL, 4),
(38892, NULL, 'G3DSA:3.50.50.60:FF:001374', NULL, NULL, 'LD25803p', NULL, NULL, NULL, NULL, NULL, 4),
(38893, NULL, 'G3DSA:3.40.50.360:FF:000103', NULL, NULL, 'Glutathione-regulated potassium-efflux system ancillary protein KefG', NULL, NULL, NULL, NULL, NULL, 4),
(38894, NULL, 'G3DSA:2.60.98.10:FF:000009', NULL, NULL, 'Structural polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(38895, NULL, 'G3DSA:3.30.1460.20:FF:000011', NULL, NULL, 'Arp2/3 complex 34 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(38896, NULL, 'G3DSA:3.40.50.10330:FF:000057', NULL, NULL, 'Inorganic polyphosphate/ATP-NAD kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38897, NULL, 'G3DSA:1.10.10.60:FF:001283', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38898, NULL, 'G3DSA:1.20.5.690:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38899, NULL, 'G3DSA:1.10.287.370:FF:000012', NULL, NULL, 'Probable prefoldin subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(38900, NULL, 'G3DSA:2.60.120.10:FF:000250', NULL, NULL, 'cGMP-dependent protein kinase, isozyme 2 forms cD4/T1/T3A/T3B-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(38901, NULL, 'G3DSA:2.60.120.200:FF:000455', NULL, NULL, 'Laminin, alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(38902, NULL, 'G3DSA:1.20.58.60:FF:000739', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(38903, NULL, 'G3DSA:3.40.50.1820:FF:001006', NULL, NULL, 'Serine peptidase, putative serine peptidase, Clan SC, Family S9D', NULL, NULL, NULL, NULL, NULL, 4),
(38904, NULL, 'G3DSA:3.40.50.1100:FF:000009', NULL, NULL, 'Cysteine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(38905, NULL, 'G3DSA:2.130.10.10:FF:005508', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38906, NULL, 'G3DSA:2.60.40.10:FF:001546', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(38907, NULL, 'G3DSA:3.60.60.10:FF:000016', NULL, NULL, 'Dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(38908, NULL, 'G3DSA:3.30.1300.10:FF:000002', NULL, NULL, 'Pantoate--beta-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(38909, NULL, 'G3DSA:3.40.50.620:FF:000754', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38910, NULL, 'G3DSA:1.10.510.10:FF:003993', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38911, NULL, 'G3DSA:2.10.220.10:FF:000044', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(38912, NULL, 'G3DSA:3.40.50.150:FF:001844', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38913, NULL, 'G3DSA:3.30.40.10:FF:001606', NULL, NULL, 'Putative tumor necrosis factor receptor-associated factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(38914, NULL, 'G3DSA:3.80.10.10:FF:000288', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase EFR', NULL, NULL, NULL, NULL, NULL, 4),
(38915, NULL, 'G3DSA:3.40.50.1000:FF:000103', NULL, NULL, 'Trehalose 6-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(38916, NULL, 'G3DSA:2.20.25.10:FF:000113', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(38917, NULL, 'G3DSA:3.90.190.20:FF:000067', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38918, NULL, 'G3DSA:3.60.10.10:FF:000070', NULL, NULL, 'Type IV inositol polyphosphate 5-phosphatase 7', NULL, NULL, NULL, NULL, NULL, 4),
(38919, NULL, 'G3DSA:2.30.29.230:FF:000019', NULL, NULL, 'TBC1 domain family member 16-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(38920, NULL, 'G3DSA:2.60.220.50:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38921, NULL, 'G3DSA:3.40.50.1820:FF:001063', NULL, NULL, 'Esterase-6-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(38922, NULL, 'G3DSA:3.80.10.10:FF:002592', NULL, NULL, 'Transmembrane receptors / ATP binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(38923, NULL, 'G3DSA:2.130.10.10:FF:001294', NULL, NULL, 'Polyadenylation factor I', NULL, NULL, NULL, NULL, NULL, 4),
(38924, NULL, 'G3DSA:3.40.50.150:FF:001226', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38925, NULL, 'G3DSA:1.20.990.10:FF:000002', NULL, NULL, 'Nitric oxide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(38926, NULL, 'G3DSA:3.30.450.20:FF:000174', NULL, NULL, 'BHLH-PAS factor', NULL, NULL, NULL, NULL, NULL, 4),
(38927, NULL, 'G3DSA:1.10.287.950:FF:000034', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(38928, NULL, 'G3DSA:1.20.1740.10:FF:000270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38929, NULL, 'G3DSA:1.10.238.10:FF:000307', NULL, NULL, 'Follistatin like 4', NULL, NULL, NULL, NULL, NULL, 4),
(38930, NULL, 'G3DSA:3.90.190.10:FF:000064', NULL, NULL, 'RNA/RNP complex-1-interacting phosphatase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(38931, NULL, 'G3DSA:1.25.10.10:FF:001077', NULL, NULL, 'WD domain, G-beta repeat/PFU (PLAA family ubiquitin binding), putative', NULL, NULL, NULL, NULL, NULL, 4),
(38932, NULL, 'G3DSA:2.60.40.150:FF:000150', NULL, NULL, 'RAS protein activator like 1', NULL, NULL, NULL, NULL, NULL, 4),
(38933, NULL, 'G3DSA:2.40.160.120:FF:000011', NULL, NULL, 'Oxysterol-binding protein-related protein 4C', NULL, NULL, NULL, NULL, NULL, 4),
(38934, NULL, 'G3DSA:1.10.720.30:FF:000047', NULL, NULL, 'SAP domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(38935, NULL, 'G3DSA:1.25.10.10:FF:000503', NULL, NULL, 'AP-1 complex subunit gamma', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(38936, NULL, 'G3DSA:3.30.1360.220:FF:000002', NULL, NULL, 'Zinc finger FYVE domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(38937, NULL, 'G3DSA:1.20.1250.60:FF:000005', NULL, NULL, 'Interferon lambda3', NULL, NULL, NULL, NULL, NULL, 4),
(38938, NULL, 'G3DSA:2.60.40.10:FF:003940', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38939, NULL, 'G3DSA:2.60.40.10:FF:005256', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38940, NULL, 'G3DSA:3.90.1290.10:FF:000082', NULL, NULL, 'Dystonin', NULL, NULL, NULL, NULL, NULL, 4),
(38941, NULL, 'G3DSA:3.30.70.330:FF:000376', NULL, NULL, 'Putative RNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(38942, NULL, 'G3DSA:3.40.1110.10:FF:000182', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(38943, NULL, 'G3DSA:3.30.390.30:FF:000008', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(38944, NULL, 'G3DSA:1.20.5.170:FF:000266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38945, NULL, 'G3DSA:2.10.25.10:FF:000754', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38946, NULL, 'G3DSA:3.60.21.10:FF:000370', NULL, NULL, 'Serine/threonine-protein phosphatase BSL3', NULL, NULL, NULL, NULL, NULL, 4),
(38947, NULL, 'G3DSA:3.30.160.60:FF:005413', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38948, NULL, 'G3DSA:3.40.47.10:FF:000099', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 3', NULL, NULL, NULL, NULL, NULL, 4),
(38949, NULL, 'G3DSA:2.30.30.380:FF:000072', NULL, NULL, 'At2g27460', NULL, NULL, NULL, NULL, NULL, 4),
(38950, NULL, 'G3DSA:3.10.580.10:FF:000145', NULL, NULL, 'Homoserine O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(38951, NULL, 'G3DSA:3.30.160.60:FF:005357', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38952, NULL, 'G3DSA:3.20.20.60:FF:000047', NULL, NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(38953, NULL, 'G3DSA:2.130.10.10:FF:005891', NULL, NULL, 'Probable serine/threonine-protein kinase pats1', NULL, NULL, NULL, NULL, NULL, 4),
(38954, NULL, 'G3DSA:1.50.40.10:FF:000216', NULL, NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(38955, NULL, 'G3DSA:2.60.40.150:FF:000032', NULL, NULL, 'Double c2-like domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(38956, NULL, 'G3DSA:2.30.29.30:FF:000296', NULL, NULL, 'Regulator of G protein signaling 12', NULL, NULL, NULL, NULL, NULL, 4),
(38957, NULL, 'G3DSA:2.10.25.10:FF:000810', NULL, NULL, 'Delta-like 1 isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(38958, NULL, 'G3DSA:3.40.50.2000:FF:001027', NULL, NULL, 'UDP-N-acetylglucosamine transferase subunit ALG14 homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(38959, NULL, 'G3DSA:3.30.1370.100:FF:000024', NULL, NULL, 'DNA mismatch repair protein domain', NULL, NULL, NULL, NULL, NULL, 4),
(38960, NULL, 'G3DSA:3.30.1370.110:FF:000027', NULL, NULL, 'Nucleolar protein', NULL, NULL, NULL, NULL, NULL, 4),
(38961, NULL, 'G3DSA:1.25.40.10:FF:002990', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(38962, NULL, 'G3DSA:1.10.10.580:FF:000001', NULL, NULL, 'double-strand-break repair protein rad21 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(38963, NULL, 'G3DSA:3.20.20.70:FF:000106', NULL, NULL, 'Deoxyribose-phosphate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(38964, NULL, 'G3DSA:3.80.10.10:FF:003778', NULL, NULL, 'Leucine-rich repeat neuronal protein 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(38965, NULL, 'G3DSA:3.30.70.1230:FF:000118', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38966, NULL, 'G3DSA:3.90.79.20:FF:000004', NULL, NULL, 'NADH pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(38967, NULL, 'G3DSA:1.10.10.1890:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38968, NULL, 'G3DSA:1.10.1070.11:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(38969, NULL, 'G3DSA:3.40.50.800:FF:000095', NULL, NULL, 'Polymerase (DNA directed), gamma 2, accessory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(38970, NULL, 'G3DSA:2.30.42.10:FF:000377', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38971, NULL, 'G3DSA:3.40.50.300:FF:002524', NULL, NULL, 'Dicer-2', NULL, NULL, NULL, NULL, NULL, 4),
(38972, NULL, 'G3DSA:2.60.40.10:FF:003726', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38973, NULL, 'G3DSA:2.40.70.10:FF:000014', NULL, NULL, 'Aspartyl protease family protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(38974, NULL, 'G3DSA:3.20.20.80:FF:000109', NULL, NULL, 'Glucosylceramidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(38975, NULL, 'G3DSA:3.30.160.60:FF:003266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38976, NULL, 'G3DSA:1.10.540.10:FF:000004', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(38977, NULL, 'G3DSA:2.40.30.10:FF:000012', NULL, NULL, '60S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(38978, NULL, 'G3DSA:3.40.1010.10:FF:000011', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase I', NULL, NULL, NULL, NULL, NULL, 4),
(38979, NULL, 'G3DSA:3.40.50.300:FF:002631', NULL, NULL, 'Hypothetical alanine rich protein', NULL, NULL, NULL, NULL, NULL, 4),
(38980, NULL, 'G3DSA:1.20.1250.20:FF:002258', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(38981, NULL, 'G3DSA:2.130.10.10:FF:002125', NULL, NULL, 'Protein CBG01041', NULL, NULL, NULL, NULL, NULL, 4),
(38982, NULL, 'G3DSA:2.40.30.20:FF:000015', NULL, NULL, 'Riboflavin synthase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(38983, NULL, 'G3DSA:3.30.70.1430:FF:000004', NULL, NULL, 'Multidrug resistance protein MdtC', NULL, NULL, NULL, NULL, NULL, 4),
(38984, NULL, 'G3DSA:3.20.10.10:FF:000054', NULL, NULL, 'Putative aminodeoxychorismate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(38985, NULL, 'G3DSA:3.90.70.10:FF:000420', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38986, NULL, 'G3DSA:3.80.10.10:FF:004391', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(38987, NULL, 'G3DSA:3.30.70.100:FF:000138', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38988, NULL, 'G3DSA:3.40.30.10:FF:000627', NULL, NULL, 'Thiol:disulfide interchange protein DsbD', NULL, NULL, NULL, NULL, NULL, 4),
(38989, NULL, 'G3DSA:3.30.70.270:FF:000217', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(38990, NULL, 'G3DSA:3.40.50.1980:FF:000020', NULL, NULL, 'Iron-uptake system-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(38991, NULL, 'G3DSA:3.30.70.330:FF:001606', NULL, NULL, 'Transformer-2 sex-determining protein', NULL, NULL, NULL, NULL, NULL, 4),
(38992, NULL, 'G3DSA:3.60.40.10:FF:000015', NULL, NULL, 'probable protein phosphatase 2C 60', NULL, NULL, NULL, NULL, NULL, 4),
(38993, NULL, 'G3DSA:3.90.550.10:FF:000316', NULL, NULL, 'UDP-N-acetylglucosamine pyrophosphorylase putative', NULL, NULL, NULL, NULL, NULL, 4),
(38994, NULL, 'G3DSA:3.90.70.10:FF:000313', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(38995, NULL, 'G3DSA:3.30.559.10:FF:000198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38996, NULL, 'G3DSA:3.30.1440.10:FF:000001', NULL, NULL, '50S ribosomal protein L5', NULL, NULL, NULL, NULL, NULL, 4),
(38997, NULL, 'G3DSA:1.25.40.20:FF:001470', NULL, NULL, 'Ankyrin repeat domain 6', NULL, NULL, NULL, NULL, NULL, 4),
(38998, NULL, 'G3DSA:1.50.40.10:FF:000267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(38999, NULL, 'G3DSA:2.130.10.10:FF:003704', NULL, NULL, 'Cannonball', NULL, NULL, NULL, NULL, NULL, 4),
(39000, NULL, 'G3DSA:1.50.40.10:FF:000323', NULL, NULL, 'GH22139p', NULL, NULL, NULL, NULL, NULL, 4),
(39001, NULL, 'G3DSA:2.60.120.10:FF:000194', NULL, NULL, 'Rap guanine nucleotide exchange factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(39002, NULL, 'G3DSA:2.60.40.60:FF:001128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(39003, NULL, 'G3DSA:3.40.50.150:FF:001726', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39004, NULL, 'G3DSA:3.90.1290.10:FF:000031', NULL, NULL, 'AGAP011396-PA', NULL, NULL, NULL, NULL, NULL, 4),
(39005, NULL, 'G3DSA:3.30.70.1440:FF:000007', NULL, NULL, 'Probable RND efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(39006, NULL, 'G3DSA:1.25.40.420:FF:000062', NULL, NULL, 'TD and POZ domain-containing protein 3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(39007, NULL, 'G3DSA:1.20.1230.10:FF:000017', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(39008, NULL, 'G3DSA:3.30.40.10:FF:001045', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(39009, NULL, 'G3DSA:3.40.50.620:FF:000378', NULL, NULL, 'Deoxyribodipyrimidine photo-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(39010, NULL, 'G3DSA:3.30.70.260:FF:000107', NULL, NULL, 'Glycine cleavage system transcriptional antiactivator GcvR', NULL, NULL, NULL, NULL, NULL, 4),
(39011, NULL, 'G3DSA:1.20.5.1430:FF:000001', NULL, NULL, 'microtubule-associated protein RP/EB family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(39012, NULL, 'G3DSA:3.20.20.220:FF:000060', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(39013, NULL, 'G3DSA:2.60.40.1730:FF:000110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39014, NULL, 'G3DSA:3.40.50.1460:FF:000095', NULL, NULL, 'Caspase 16, apoptosis-related cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(39015, NULL, 'G3DSA:3.30.70.1220:FF:000008', NULL, NULL, 'Transcription factor IIH, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39016, NULL, 'G3DSA:1.10.640.10:FF:000063', NULL, NULL, 'Cyclooxygenase-1', NULL, NULL, NULL, NULL, NULL, 4),
(39017, NULL, 'G3DSA:3.30.110.60:FF:000003', NULL, NULL, 'CRM-domain containing factor CFM3B, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(39018, NULL, 'G3DSA:3.30.200.20:FF:002201', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(39019, NULL, 'G3DSA:3.30.40.10:FF:000382', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(39020, NULL, 'G3DSA:1.10.8.60:FF:000242', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(39021, NULL, 'G3DSA:1.10.560.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39022, NULL, 'G3DSA:3.20.20.60:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39023, NULL, 'G3DSA:3.40.50.620:FF:000485', NULL, NULL, 'Leucyl-tRNA synthetase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(39024, NULL, 'G3DSA:2.60.40.10:FF:005290', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39025, NULL, 'G3DSA:3.30.160.60:FF:004160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39026, NULL, 'G3DSA:1.20.58.340:FF:000041', NULL, NULL, 'Related to MNR2-Manganese resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(39027, NULL, 'G3DSA:3.60.110.10:FF:000088', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39028, NULL, 'G3DSA:3.40.50.12360:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39029, NULL, 'G3DSA:1.25.40.660:FF:000010', NULL, NULL, 'Vacuolar protein sorting 35, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39030, NULL, 'G3DSA:3.40.50.720:FF:000964', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(39031, NULL, 'G3DSA:2.60.120.290:FF:000094', NULL, NULL, 'GM21018', NULL, NULL, NULL, NULL, NULL, 4),
(39032, NULL, 'G3DSA:3.40.50.150:FF:000422', NULL, NULL, 'tRNA (adenine(58)-N(1))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(39033, NULL, 'G3DSA:3.30.300.150:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39034, NULL, 'G3DSA:3.90.70.80:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39035, NULL, 'G3DSA:3.40.1110.10:FF:000070', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(39036, NULL, 'G3DSA:3.40.250.10:FF:000237', NULL, NULL, 'Zgc:162544 protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(39037, NULL, 'G3DSA:2.30.30.140:FF:000180', NULL, NULL, 'G-patch domain and KOW motifs-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(39038, NULL, 'G3DSA:3.30.460.10:FF:000121', NULL, NULL, 'DNA-directed DNA/RNA polymerase mu', NULL, NULL, NULL, NULL, NULL, 4),
(39039, NULL, 'G3DSA:1.10.287.110:FF:000243', NULL, NULL, 'AGAP009787-PA', NULL, NULL, NULL, NULL, NULL, 4),
(39040, NULL, 'G3DSA:2.130.10.10:FF:002018', NULL, NULL, 'WD-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39041, NULL, 'G3DSA:1.25.10.10:FF:001583', NULL, NULL, 'Probable importin-7 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(39042, NULL, 'G3DSA:3.30.310.130:FF:000011', NULL, NULL, 'Ubiquitin-like protease 4', NULL, NULL, NULL, NULL, NULL, 4),
(39043, NULL, 'G3DSA:3.30.870.10:FF:000202', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(39044, NULL, 'G3DSA:3.40.50.1820:FF:001630', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(39045, NULL, 'G3DSA:1.10.1240.100:FF:000001', NULL, NULL, 'Polyketide synthase/nonribosomal peptide synthetase hybrid RzxA', NULL, NULL, NULL, NULL, NULL, 4),
(39046, NULL, 'G3DSA:1.10.287.110:FF:000131', NULL, NULL, 'Ring-infected erythrocyte surface antigen', NULL, NULL, NULL, NULL, NULL, 4),
(39047, NULL, 'G3DSA:3.30.800.10:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39048, NULL, 'G3DSA:3.40.50.150:FF:000192', NULL, NULL, 'NOP2p rRNA m5C methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(39049, NULL, 'G3DSA:3.30.390.30:FF:000003', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(39050, NULL, 'G3DSA:1.10.10.750:FF:000018', NULL, NULL, 'TBC domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(39051, NULL, 'G3DSA:3.30.420.10:FF:000231', NULL, NULL, 'DNA polymerase epsilon catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(39052, NULL, 'G3DSA:1.10.10.160:FF:000055', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(39053, NULL, 'G3DSA:1.25.40.180:FF:000349', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39054, NULL, 'G3DSA:1.10.220.10:FF:000020', NULL, NULL, 'Annexin A10', NULL, NULL, NULL, NULL, NULL, 4),
(39055, NULL, 'G3DSA:1.10.245.10:FF:000004', NULL, NULL, 'Upstream activation factor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(39056, NULL, 'G3DSA:1.20.5.170:FF:000108', NULL, NULL, 'SYNM isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(39057, NULL, 'G3DSA:1.10.287.130:FF:000249', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(39058, NULL, 'G3DSA:3.40.50.300:FF:003828', NULL, NULL, 'Gtr1/RagA G protein Gtr1', NULL, NULL, NULL, NULL, NULL, 4),
(39059, NULL, 'G3DSA:3.10.20.90:FF:000461', NULL, NULL, 'Phosphatidylinositol 3-kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39060, NULL, 'G3DSA:3.30.70.330:FF:001191', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(39061, NULL, 'G3DSA:1.25.10.10:FF:001813', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(39062, NULL, 'G3DSA:2.30.29.30:FF:000189', NULL, NULL, 'Actin filament associated protein 1-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(39063, NULL, 'G3DSA:3.30.200.20:FF:001414', NULL, NULL, 'GD18431', NULL, NULL, NULL, NULL, NULL, 4),
(39064, NULL, 'G3DSA:2.60.120.290:FF:000212', NULL, NULL, 'C-type LECtin', NULL, NULL, NULL, NULL, NULL, 4),
(39065, NULL, 'G3DSA:1.10.357.70:FF:000034', NULL, NULL, 'Exocyst complex component 3-like 2b', NULL, NULL, NULL, NULL, NULL, 4),
(39066, NULL, 'G3DSA:1.20.1270.60:FF:000271', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39067, NULL, 'G3DSA:1.10.472.80:FF:000046', NULL, NULL, 'TBC domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(39068, NULL, 'G3DSA:2.40.50.140:FF:001204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39069, NULL, 'G3DSA:3.40.50.300:FF:002305', NULL, NULL, 'Elongator subunit', NULL, NULL, NULL, NULL, NULL, 4),
(39070, NULL, 'G3DSA:1.25.40.10:FF:003265', NULL, NULL, 'Pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(39071, NULL, 'G3DSA:1.10.287.10:FF:000005', NULL, NULL, 'ataxin-3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(39072, NULL, 'G3DSA:3.40.50.2000:FF:000678', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(39073, NULL, 'G3DSA:1.20.120.1900:FF:000032', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(39074, NULL, 'G3DSA:1.20.58.1610:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39075, NULL, 'G3DSA:3.30.70.330:FF:002388', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39076, NULL, 'G3DSA:1.10.287.70:FF:000383', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39077, NULL, 'G3DSA:2.10.220.10:FF:000151', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(39078, NULL, 'G3DSA:3.20.20.100:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39079, NULL, 'G3DSA:3.40.1360.10:FF:000060', NULL, NULL, 'Meiotic recombination protein SPO11, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39080, NULL, 'G3DSA:1.20.140.10:FF:000045', NULL, NULL, 'Putative acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(39081, NULL, 'G3DSA:3.40.30.10:FF:000734', NULL, NULL, '39S ribosomal protein L43, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(39082, NULL, 'G3DSA:3.30.360.10:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39083, NULL, 'G3DSA:1.20.120.1910:FF:000035', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(39084, NULL, 'G3DSA:3.40.50.450:FF:000068', NULL, NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(39085, NULL, 'G3DSA:3.30.420.10:FF:000282', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(39086, NULL, 'G3DSA:3.60.21.10:FF:000151', NULL, NULL, 'Acid sphingomyelinase family phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(39087, NULL, 'G3DSA:3.10.580.10:FF:000196', NULL, NULL, 'Cystathionine beta synthase domain protein1', NULL, NULL, NULL, NULL, NULL, 4),
(39088, NULL, 'G3DSA:1.10.357.140:FF:000038', NULL, NULL, 'Protoheme IX farnesyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(39089, NULL, 'G3DSA:3.40.250.10:FF:000018', NULL, NULL, 'TBC domain-containing protein kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(39090, NULL, 'G3DSA:3.10.20.90:FF:000410', NULL, NULL, 'Esc2p', NULL, NULL, NULL, NULL, NULL, 4),
(39091, NULL, 'G3DSA:1.10.287.410:FF:000007', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(39092, NULL, 'G3DSA:3.40.50.300:FF:008033', NULL, NULL, 'Dicer-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(39093, NULL, 'G3DSA:2.30.29.30:FF:001083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39094, NULL, 'G3DSA:2.30.30.100:FF:000089', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm7, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39095, NULL, 'G3DSA:3.80.10.10:FF:002148', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase FEI 2', NULL, NULL, NULL, NULL, NULL, 4),
(39096, NULL, 'G3DSA:3.30.40.10:FF:001157', NULL, NULL, 'Putative RING zinc finger domain superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(39097, NULL, 'G3DSA:1.10.1200.270:FF:000021', NULL, NULL, 'Os11g0260600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(39098, NULL, 'G3DSA:1.10.3080.10:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39099, NULL, 'G3DSA:3.40.50.2300:FF:001055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39100, NULL, 'G3DSA:1.20.1250.20:FF:000460', NULL, NULL, 'MFS multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39101, NULL, 'G3DSA:3.40.50.620:FF:000434', NULL, NULL, 'Cytidylyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39102, NULL, 'G3DSA:3.30.40.10:FF:001101', NULL, NULL, 'Structure-specific endonuclease subunit slx1', NULL, NULL, NULL, NULL, NULL, 4),
(39103, NULL, 'G3DSA:3.30.1360.170:FF:000003', NULL, NULL, 'Flavin-dependent thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(39104, NULL, 'G3DSA:3.40.50.300:FF:000400', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(39105, NULL, 'G3DSA:3.30.1360.180:FF:000006', NULL, NULL, 'Nucleotide phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(39106, NULL, 'G3DSA:3.90.190.10:FF:000384', NULL, NULL, 'Si:ch1073-391i24.1', NULL, NULL, NULL, NULL, NULL, 4),
(39107, NULL, 'G3DSA:3.40.710.10:FF:000009', NULL, NULL, 'Glutaminase', NULL, NULL, NULL, NULL, NULL, 4),
(39108, NULL, 'G3DSA:3.30.70.260:FF:000158', NULL, NULL, 'Prephenate dehydratase-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(39109, NULL, 'G3DSA:3.40.630.30:FF:000441', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39110, NULL, 'G3DSA:1.10.3380.10:FF:000070', NULL, NULL, 'Activating signal cointegrator 1 complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(39111, NULL, 'G3DSA:2.130.10.10:FF:003648', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39112, NULL, 'G3DSA:3.40.50.300:FF:005178', NULL, NULL, 'ATP-dependent dethiobiotin synthetase BioD', NULL, NULL, NULL, NULL, NULL, 4),
(39113, NULL, 'G3DSA:3.40.390.10:FF:000186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39114, NULL, 'G3DSA:3.30.450.260:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39115, NULL, 'G3DSA:2.130.10.10:FF:001557', NULL, NULL, 'Protein HIR', NULL, NULL, NULL, NULL, NULL, 4),
(39116, NULL, 'G3DSA:3.40.850.10:FF:000547', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39117, NULL, 'G3DSA:3.40.50.300:FF:003087', NULL, NULL, 'GTP-binding protein, Ras family protein', NULL, NULL, NULL, NULL, NULL, 4),
(39118, NULL, 'G3DSA:2.60.120.200:FF:000753', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39119, NULL, 'G3DSA:3.30.2460.20:FF:000011', NULL, NULL, 'Protein Wnt', NULL, NULL, NULL, NULL, NULL, 4),
(39120, NULL, 'G3DSA:4.10.1000.10:FF:000039', NULL, NULL, 'Putative RNA helicase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(39121, NULL, 'G3DSA:1.10.510.10:FF:004510', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39122, NULL, 'G3DSA:1.20.5.110:FF:000169', NULL, NULL, 'Snare-like domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(39123, NULL, 'G3DSA:1.10.472.80:FF:000232', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39124, NULL, 'G3DSA:3.80.10.10:FF:004239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39125, NULL, 'G3DSA:2.130.10.10:FF:000001', NULL, NULL, 'transducin-like enhancer protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(39126, NULL, 'G3DSA:1.25.40.10:FF:004895', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g11690', NULL, NULL, NULL, NULL, NULL, 4),
(39127, NULL, 'G3DSA:3.30.70.330:FF:001932', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39128, NULL, 'G3DSA:1.10.287.160:FF:000011', NULL, NULL, 'catenin alpha-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(39129, NULL, 'G3DSA:3.30.70.1230:FF:000006', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(39130, NULL, 'G3DSA:2.10.25.10:FF:000580', NULL, NULL, 'Wing blister, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(39131, NULL, 'G3DSA:3.40.720.10:FF:000049', NULL, NULL, 'Alkaline phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(39132, NULL, 'G3DSA:2.10.70.10:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39133, NULL, 'G3DSA:2.10.25.10:FF:000922', NULL, NULL, 'neurogenic locus notch homolog protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(39134, NULL, 'G3DSA:2.40.170.20:FF:000120', NULL, NULL, 'SusC homolog', NULL, NULL, NULL, NULL, NULL, 4),
(39135, NULL, 'G3DSA:3.30.70.1220:FF:000003', NULL, NULL, 'General transcription and DNA repair factor IIH subunit TFB5', NULL, NULL, NULL, NULL, NULL, 4),
(39136, NULL, 'G3DSA:3.30.70.330:FF:000819', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(39137, NULL, 'G3DSA:3.40.366.10:FF:000074', NULL, NULL, 'Polyketide synthase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(39138, NULL, 'G3DSA:2.10.25.10:FF:000866', NULL, NULL, 'Cubilin', NULL, NULL, NULL, NULL, NULL, 4),
(39139, NULL, 'G3DSA:3.40.1110.10:FF:000244', NULL, NULL, 'Na/K ATPase alpha 1 subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39140, NULL, 'G3DSA:2.60.40.150:FF:000200', NULL, NULL, 'Ras GTPase-activating protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(39141, NULL, 'G3DSA:1.10.287.70:FF:000770', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39142, NULL, 'G3DSA:2.130.10.10:FF:000220', NULL, NULL, 'Actin-related protein 2/3 complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(39143, NULL, 'G3DSA:1.20.1270.280:FF:000006', NULL, NULL, 'Dynein cytoplasmic 2 heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(39144, NULL, 'G3DSA:2.30.29.30:FF:000184', NULL, NULL, 'Rho guanine nucleotide exchange factor (GEF) 25', NULL, NULL, NULL, NULL, NULL, 4),
(39145, NULL, 'G3DSA:1.10.630.10:FF:000742', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39146, NULL, 'G3DSA:1.10.532.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39147, NULL, 'G3DSA:3.40.50.1220:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39148, NULL, 'G3DSA:2.60.40.10:FF:005812', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39149, NULL, 'G3DSA:3.40.720.10:FF:000105', NULL, NULL, 'Phosphatidylinositol glycan anchor biosynthesis, class G', NULL, NULL, NULL, NULL, NULL, 4),
(39150, NULL, 'G3DSA:2.60.120.920:FF:000053', NULL, NULL, 'E3 ubiquitin-protein ligase RKP', NULL, NULL, NULL, NULL, NULL, 4),
(39151, NULL, 'G3DSA:1.25.10.10:FF:003089', NULL, NULL, 'Condensin complex subunit 3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(39152, NULL, 'G3DSA:3.30.160.60:FF:003378', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39153, NULL, 'G3DSA:1.20.58.390:FF:000213', NULL, NULL, 'Acr-19', NULL, NULL, NULL, NULL, NULL, 4),
(39154, NULL, 'G3DSA:2.30.42.10:FF:000489', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39155, NULL, 'G3DSA:3.40.430.10:FF:000004', NULL, NULL, 'Dihydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(39156, NULL, 'G3DSA:1.20.1730.10:FF:000038', NULL, NULL, 'Similar to sodium-glucose cotransporter-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(39157, NULL, 'G3DSA:1.20.930.10:FF:000004', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(39158, NULL, 'G3DSA:3.30.70.1430:FF:000009', NULL, NULL, 'Probable RND efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(39159, NULL, 'G3DSA:3.30.70.330:FF:001376', NULL, NULL, 'RNA-binding protein (RRM domain)', NULL, NULL, NULL, NULL, NULL, 4),
(39160, NULL, 'G3DSA:2.30.30.140:FF:000028', NULL, NULL, 'polycomb protein SCMH1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(39161, NULL, 'G3DSA:1.25.40.20:FF:001918', NULL, NULL, 'Ankyrin-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39162, NULL, 'G3DSA:3.30.980.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39163, NULL, 'G3DSA:3.40.50.1820:FF:001304', NULL, NULL, 'Os03g0393066 protein', NULL, NULL, NULL, NULL, NULL, 4),
(39164, NULL, 'G3DSA:1.20.1440.200:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(39165, NULL, 'G3DSA:1.10.150.50:FF:000065', NULL, NULL, 'mitogen-activated protein kinase kinase kinase 20 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(39166, NULL, 'G3DSA:3.40.50.11500:FF:000009', NULL, NULL, 'Pinstripe, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(39167, NULL, 'G3DSA:1.20.1110.10:FF:000126', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39168, NULL, 'G3DSA:3.40.50.410:FF:000141', NULL, NULL, 'Matrilin-4', NULL, NULL, NULL, NULL, NULL, 4),
(39169, NULL, 'G3DSA:2.130.10.10:FF:002013', NULL, NULL, 'rRNA-processing protein', NULL, NULL, NULL, NULL, NULL, 4),
(39170, NULL, 'G3DSA:3.30.530.20:FF:000101', NULL, NULL, 'Polyadenylate-binding protein RBP45C', NULL, NULL, NULL, NULL, NULL, 4),
(39171, NULL, 'G3DSA:3.40.50.1360:FF:000065', NULL, NULL, '6phosphogluconolactonase, putative', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(39172, NULL, 'G3DSA:3.10.20.90:FF:000135', NULL, NULL, 'UBX domain-containing protein 2B', NULL, NULL, NULL, NULL, NULL, 4),
(39173, NULL, 'G3DSA:3.40.630.30:FF:000166', NULL, NULL, 'Alpha-tubulin N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(39174, NULL, 'G3DSA:1.20.1060.20:FF:000012', NULL, NULL, 'Structural maintenance of chromosomes protein', NULL, NULL, NULL, NULL, NULL, 4),
(39175, NULL, 'G3DSA:3.30.2290.10:FF:000028', NULL, NULL, 'Zinc-dependent protease, TldD/PmbA family', NULL, NULL, NULL, NULL, NULL, 4),
(39176, NULL, 'G3DSA:2.60.220.50:FF:000062', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(39177, NULL, 'G3DSA:3.40.50.300:FF:005453', NULL, NULL, 'ABC multidrug transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(39178, NULL, 'G3DSA:3.40.50.300:FF:000214', NULL, NULL, 'Mitofusin 2', NULL, NULL, NULL, NULL, NULL, 4),
(39179, NULL, 'G3DSA:1.25.10.10:FF:000796', NULL, NULL, 'Arm repeat containing protein homolog-like', NULL, NULL, NULL, NULL, NULL, 4),
(39180, NULL, 'G3DSA:3.50.50.60:FF:000823', NULL, NULL, 'Fructose dehydrogenase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(39181, NULL, 'G3DSA:3.30.565.10:FF:000488', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(39182, NULL, 'G3DSA:2.60.40.10:FF:005705', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39183, NULL, 'G3DSA:3.30.160.60:FF:000337', NULL, NULL, 'Zinc finger and BTB domain containing 41', NULL, NULL, NULL, NULL, NULL, 4),
(39184, NULL, 'G3DSA:3.40.50.10110:FF:000002', NULL, NULL, 'DNA polymerase III, chi subunit', NULL, NULL, NULL, NULL, NULL, 4),
(39185, NULL, 'G3DSA:3.40.50.2000:FF:000971', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39186, NULL, 'G3DSA:4.10.400.10:FF:000062', NULL, NULL, 'Terribly reduced optic lobes, isoform AI', NULL, NULL, NULL, NULL, NULL, 4),
(39187, NULL, 'G3DSA:3.60.40.10:FF:000285', NULL, NULL, 'AGAP008536-PA', NULL, NULL, NULL, NULL, NULL, 4),
(39188, NULL, 'G3DSA:1.25.40.10:FF:003821', NULL, NULL, 'Nuclear autoantigenic sperm protein-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(39189, NULL, 'G3DSA:2.30.29.30:FF:001201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39190, NULL, 'G3DSA:3.30.450.20:FF:000680', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(39191, NULL, 'G3DSA:2.30.30.100:FF:000207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39192, NULL, 'G3DSA:3.30.200.20:FF:000925', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 15', NULL, NULL, NULL, NULL, NULL, 4),
(39193, NULL, 'G3DSA:2.80.10.50:FF:000004', NULL, NULL, 'Fibroblast growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(39194, NULL, 'G3DSA:1.10.1040.50:FF:000011', NULL, NULL, 'Enoyl-CoA hydratase/Enoyl-CoA isomerase/3-hydroxyacyl-CoA dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39195, NULL, 'G3DSA:3.70.10.10:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39196, NULL, 'G3DSA:3.40.710.10:FF:000161', NULL, NULL, 'Penicillin-binding protein 1B McrB, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39197, NULL, 'G3DSA:3.40.50.720:FF:000790', NULL, NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(39198, NULL, 'G3DSA:1.25.40.10:FF:004569', NULL, NULL, 'Leucine-rich PPR motif-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(39199, NULL, 'G3DSA:1.10.1080.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39200, NULL, 'G3DSA:1.20.1280.50:FF:000004', NULL, NULL, 'F-box/WD repeat-containing protein 7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(39201, NULL, 'G3DSA:1.10.10.10:FF:001341', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit K', NULL, NULL, NULL, NULL, NULL, 4),
(39202, NULL, 'G3DSA:1.25.40.10:FF:003327', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(39203, NULL, 'G3DSA:1.20.850.10:FF:000003', NULL, NULL, 'Hydroxylamine oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(39204, NULL, 'G3DSA:1.20.1070.10:FF:001994', NULL, NULL, 'Olfactory receptor family 10 subfamily D member 3 (putative)', NULL, NULL, NULL, NULL, NULL, 4),
(39205, NULL, 'G3DSA:2.60.200.20:FF:000231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39206, NULL, 'G3DSA:3.50.30.30:FF:000026', NULL, NULL, 'E3 ubiquitin-protein ligase RNF13', NULL, NULL, NULL, NULL, NULL, 4),
(39207, NULL, 'G3DSA:2.130.10.10:FF:001850', NULL, NULL, 'Trp-asp repeats containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(39208, NULL, 'G3DSA:3.40.50.10130:FF:000008', NULL, NULL, 'DNA repair endonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39209, NULL, 'G3DSA:3.30.450.40:FF:000106', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(39210, NULL, 'G3DSA:3.50.50.60:FF:000767', NULL, NULL, 'Glycine/D-amino acid oxidase (Deaminating)', NULL, NULL, NULL, NULL, NULL, 4),
(39211, NULL, 'G3DSA:1.10.510.10:FF:001576', NULL, NULL, 'Protein kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(39212, NULL, 'G3DSA:3.40.250.10:FF:000081', NULL, NULL, 'Arr2p', NULL, NULL, NULL, NULL, NULL, 4),
(39213, NULL, 'G3DSA:3.90.190.10:FF:000507', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39214, NULL, 'G3DSA:1.10.10.10:FF:001964', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39215, NULL, 'G3DSA:3.30.160.20:FF:000247', NULL, NULL, 'A-to-I RNA editing regulator adr-1', NULL, NULL, NULL, NULL, NULL, 4),
(39216, NULL, 'G3DSA:1.10.8.1120:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39217, NULL, 'G3DSA:3.40.50.300:FF:001737', NULL, NULL, 'ATP-dependent RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39218, NULL, 'G3DSA:1.20.1250.20:FF:001128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39219, NULL, 'G3DSA:3.30.160.60:FF:004053', NULL, NULL, 'Zinc finger protein 462', NULL, NULL, NULL, NULL, NULL, 4),
(39220, NULL, 'G3DSA:1.25.10.10:FF:000060', NULL, NULL, 'Serine/threonine-protein kinase mTOR', NULL, NULL, NULL, NULL, NULL, 4),
(39221, NULL, 'G3DSA:3.30.530.20:FF:000152', NULL, NULL, 'Phosphatidylinositol transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(39222, NULL, 'G3DSA:1.20.1270.10:FF:000014', NULL, NULL, 'Heat shock protein 70', NULL, NULL, NULL, NULL, NULL, 4),
(39223, NULL, 'G3DSA:3.30.1400.10:FF:000004', NULL, NULL, 'Cell division protein ZipA', NULL, NULL, NULL, NULL, NULL, 4),
(39224, NULL, 'G3DSA:3.30.160.60:FF:001580', NULL, NULL, 'zinc finger protein 483', NULL, NULL, NULL, NULL, NULL, 4),
(39225, NULL, 'G3DSA:1.10.287.660:FF:000003', NULL, NULL, 'vacuolar protein sorting-associated protein 37B', NULL, NULL, NULL, NULL, NULL, 4),
(39226, NULL, 'G3DSA:2.40.50.120:FF:000029', NULL, NULL, 'Complement C4', NULL, NULL, NULL, NULL, NULL, 4),
(39227, NULL, 'G3DSA:1.20.1280.40:FF:000001', NULL, NULL, 'Hemolysin expression modulator Hha', NULL, NULL, NULL, NULL, NULL, 4),
(39228, NULL, 'G3DSA:3.40.50.300:FF:003654', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39229, NULL, 'G3DSA:3.30.40.10:FF:001106', NULL, NULL, 'Bifunctional apoptosis regulator', NULL, NULL, NULL, NULL, NULL, 4),
(39230, NULL, 'G3DSA:3.10.110.20:FF:000001', NULL, NULL, 'E3 ubiquitin-protein ligase FANCL', NULL, NULL, NULL, NULL, NULL, 4),
(39231, NULL, 'G3DSA:3.40.50.2300:FF:000892', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39232, NULL, 'G3DSA:2.60.120.330:FF:000090', NULL, NULL, 'Gibberellin 20 oxidase 5', NULL, NULL, NULL, NULL, NULL, 4),
(39233, NULL, 'G3DSA:1.10.220.60:FF:000006', NULL, NULL, 'GRIP and coiled-coil domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(39234, NULL, 'G3DSA:1.20.58.60:FF:000296', NULL, NULL, 'centrosomal protein of 68 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(39235, NULL, 'G3DSA:1.10.150.910:FF:000012', NULL, NULL, 'DNA damage-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(39236, NULL, 'G3DSA:1.20.1250.20:FF:002197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(39237, NULL, 'G3DSA:1.20.1250.20:FF:000959', NULL, NULL, 'Similar to MFS multidrug transporter', NULL, NULL, NULL, NULL, NULL, 4),
(39238, NULL, 'G3DSA:4.10.60.10:FF:000269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39239, NULL, 'G3DSA:1.10.630.10:FF:000337', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(39240, NULL, 'G3DSA:3.50.50.60:FF:000475', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(39241, NULL, 'G3DSA:1.25.10.10:FF:003437', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39242, NULL, 'G3DSA:3.30.1320.10:FF:000003', NULL, NULL, '30S ribosomal protein S16, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(39243, NULL, 'G3DSA:1.10.287.370:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39244, NULL, 'G3DSA:1.20.1250.20:FF:002253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39245, NULL, 'G3DSA:3.40.1160.10:FF:000067', NULL, NULL, 'Glutamate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(39246, NULL, 'G3DSA:3.30.1360.20:FF:000003', NULL, NULL, 'Transcriptional coactivator/pterin dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(39247, NULL, 'G3DSA:3.10.20.310:FF:000038', NULL, NULL, 'Hemolysin activator protein', NULL, NULL, NULL, NULL, NULL, 4),
(39248, NULL, 'G3DSA:2.60.200.30:FF:000015', NULL, NULL, 'NAD(H) kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(39249, NULL, 'G3DSA:1.20.1320.30:FF:000002', NULL, NULL, 'Probable ATP-dependent RNA helicase DDX58', NULL, NULL, NULL, NULL, NULL, 4),
(39250, NULL, 'G3DSA:2.60.200.40:FF:000018', NULL, NULL, 'Diacylglycerol kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39251, NULL, 'G3DSA:3.80.10.10:FF:002822', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(39252, NULL, 'G3DSA:3.40.50.11340:FF:000028', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(39253, NULL, 'G3DSA:1.25.10.10:FF:001291', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39254, NULL, 'G3DSA:1.25.40.10:FF:004788', NULL, NULL, 'Tetratricopeptide repeat domain 21B', NULL, NULL, NULL, NULL, NULL, 4),
(39255, NULL, 'G3DSA:2.30.170.20:FF:000004', NULL, NULL, '60S ribosomal protein l24', NULL, NULL, NULL, NULL, NULL, 4),
(39256, NULL, 'G3DSA:3.30.1450.10:FF:000007', NULL, NULL, 'Outer membrane protein assembly factor BamE', NULL, NULL, NULL, NULL, NULL, 4),
(39257, NULL, 'G3DSA:3.30.450.40:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39258, NULL, 'G3DSA:3.40.50.2000:FF:000920', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39259, NULL, 'G3DSA:3.90.1420.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39260, NULL, 'G3DSA:3.30.450.50:FF:000042', NULL, NULL, 'Vesicle transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(39261, NULL, 'G3DSA:1.20.1070.10:FF:002157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39262, NULL, 'G3DSA:2.60.40.790:FF:000105', NULL, NULL, 'NudC domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(39263, NULL, 'G3DSA:3.40.50.300:FF:002013', NULL, NULL, 'GTP-binding protein HflX', NULL, NULL, NULL, NULL, NULL, 4),
(39264, NULL, 'G3DSA:4.10.280.10:FF:000175', NULL, NULL, 'Inhibitor of DNA binding 1', NULL, NULL, NULL, NULL, NULL, 4),
(39265, NULL, 'G3DSA:3.40.50.2000:FF:000864', NULL, NULL, 'Os06g0192100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(39266, NULL, 'G3DSA:3.40.50.300:FF:000107', NULL, NULL, 'Replication factor C subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(39267, NULL, 'G3DSA:1.20.5.4820:FF:000001', NULL, NULL, 'Myosin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(39268, NULL, 'G3DSA:2.180.10.10:FF:000015', NULL, NULL, 'Cell wall-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(39269, NULL, 'G3DSA:3.30.1360.40:FF:000009', NULL, NULL, 'DNA topoisomerase medium subunit', NULL, NULL, NULL, NULL, NULL, 4),
(39270, NULL, 'G3DSA:3.40.50.720:FF:001127', NULL, NULL, 'NAD binding Rossmann fold oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(39271, NULL, 'G3DSA:3.10.100.10:FF:000110', NULL, NULL, 'GM24217', NULL, NULL, NULL, NULL, NULL, 4),
(39272, NULL, 'G3DSA:3.40.50.850:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39273, NULL, 'G3DSA:3.30.450.20:FF:000617', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39274, NULL, 'G3DSA:1.10.8.10:FF:000137', NULL, NULL, 'Doublesex, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(39275, NULL, 'G3DSA:3.30.1360.30:FF:000006', NULL, NULL, 'Aspartyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(39276, NULL, 'G3DSA:1.20.120.1080:FF:000011', NULL, NULL, 'DExH-box ATP-dependent RNA helicase DExH6', NULL, NULL, NULL, NULL, NULL, 4),
(39277, NULL, 'G3DSA:3.30.450.60:FF:000045', NULL, NULL, 'Vesicle coat complex COPI, zeta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(39278, NULL, 'G3DSA:1.10.287.70:FF:000618', NULL, NULL, 'Potassium two pore domain channel subfamily K member 9', NULL, NULL, NULL, NULL, NULL, 4),
(39279, NULL, 'G3DSA:2.40.10.480:FF:000011', NULL, NULL, 'Beta-alanine-activating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(39280, NULL, 'G3DSA:1.20.1730.10:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39281, NULL, 'G3DSA:1.10.287.70:FF:000495', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(39282, NULL, 'G3DSA:3.80.10.10:FF:002474', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(39283, NULL, 'G3DSA:3.40.50.300:FF:003598', NULL, NULL, 'Small GTPase EhRabX1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39284, NULL, 'G3DSA:2.60.40.60:FF:000116', NULL, NULL, 'Dachsous cadherin-related 2', NULL, NULL, NULL, NULL, NULL, 4),
(39285, NULL, 'G3DSA:2.60.40.1730:FF:000054', NULL, NULL, 'Protein CBG09901', NULL, NULL, NULL, NULL, NULL, 4),
(39286, NULL, 'G3DSA:3.90.810.10:FF:000028', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(39287, NULL, 'G3DSA:1.10.3380.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39288, NULL, 'G3DSA:2.130.10.10:FF:003199', NULL, NULL, 'Protein HIRA homolog', NULL, NULL, NULL, NULL, NULL, 4),
(39289, NULL, 'G3DSA:2.40.270.10:FF:000001', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(39290, NULL, 'G3DSA:2.10.25.10:FF:000428', NULL, NULL, 'Laminin subunit alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(39291, NULL, 'G3DSA:1.10.3730.20:FF:000050', NULL, NULL, 'Multidrug resistance protein, SMR family', NULL, NULL, NULL, NULL, NULL, 4),
(39292, NULL, 'G3DSA:1.10.287.130:FF:000075', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(39293, NULL, 'G3DSA:3.30.160.60:FF:005683', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39294, NULL, 'G3DSA:3.40.50.620:FF:000872', NULL, NULL, 'ATP sulfurylase 1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(39295, NULL, 'G3DSA:3.20.80.10:FF:000002', NULL, NULL, 'Heme-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(39296, NULL, 'G3DSA:1.25.40.10:FF:000859', NULL, NULL, 'Drug transmembrane transporters', NULL, NULL, NULL, NULL, NULL, 4),
(39297, NULL, 'G3DSA:1.20.120.430:FF:000011', NULL, NULL, 'RE57978p', NULL, NULL, NULL, NULL, NULL, 4),
(39298, NULL, 'G3DSA:3.30.300.20:FF:000017', NULL, NULL, 'GTP-binding protein ERG', NULL, NULL, NULL, NULL, NULL, 4),
(39299, NULL, 'G3DSA:1.10.630.10:FF:000118', NULL, NULL, 'Cytochrome P450 family 3 subfamily A member 43', NULL, NULL, NULL, NULL, NULL, 4),
(39300, NULL, 'G3DSA:3.40.50.300:FF:005627', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(39301, NULL, 'G3DSA:2.60.490.10:FF:000007', NULL, NULL, 'P2X purinoceptor', NULL, NULL, NULL, NULL, NULL, 4),
(39302, NULL, 'G3DSA:1.25.40.10:FF:001348', NULL, NULL, 'DNA-directed RNA polymerase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(39303, NULL, 'G3DSA:3.40.1380.20:FF:000058', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(39304, NULL, 'G3DSA:1.10.520.10:FF:000060', NULL, NULL, 'Peroxidase 12', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(39305, NULL, 'G3DSA:3.30.300.10:FF:000014', NULL, NULL, 'Burgundy, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(39306, NULL, 'G3DSA:2.40.420.20:FF:000044', NULL, NULL, 'Efflux protein', NULL, NULL, NULL, NULL, NULL, 4),
(39307, NULL, 'G3DSA:3.20.20.140:FF:000204', NULL, NULL, 'Adenine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(39308, NULL, 'G3DSA:3.60.40.10:FF:000341', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39309, NULL, 'G3DSA:3.30.160.60:FF:002810', NULL, NULL, 'Zinc finger protein 386 (Kruppel-like)', NULL, NULL, NULL, NULL, NULL, 4),
(39310, NULL, 'G3DSA:2.10.50.10:FF:000048', NULL, NULL, 'Cysteine repeat modular protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(39311, NULL, 'G3DSA:1.50.40.10:FF:000211', NULL, NULL, 'Mitochondrial carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39312, NULL, 'G3DSA:3.40.50.410:FF:000192', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(39313, NULL, 'G3DSA:3.40.605.10:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39314, NULL, 'G3DSA:2.120.10.30:FF:000400', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39315, NULL, 'G3DSA:3.40.50.2300:FF:001229', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39316, NULL, 'G3DSA:1.10.238.10:FF:001095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39317, NULL, 'G3DSA:2.60.40.10:FF:005413', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39318, NULL, 'G3DSA:3.90.1200.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39319, NULL, 'G3DSA:3.40.50.720:FF:000638', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit alpha, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(39320, NULL, 'G3DSA:1.10.287.470:FF:000042', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(39321, NULL, 'G3DSA:3.10.20.30:FF:000027', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] iron-sulfur subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(39322, NULL, 'G3DSA:3.10.129.10:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39323, NULL, 'G3DSA:2.20.80.10:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39324, NULL, 'G3DSA:2.30.33.40:FF:000005', NULL, NULL, '20 kDa chaperonin, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(39325, NULL, 'G3DSA:1.20.1250.20:FF:000908', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39326, NULL, 'G3DSA:1.20.1560.10:FF:000733', NULL, NULL, 'p-glycoprotein-2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39327, NULL, 'G3DSA:1.10.1580.10:FF:000006', NULL, NULL, 'Nuclear GTP-binding protein NUG1', NULL, NULL, NULL, NULL, NULL, 4),
(39328, NULL, 'G3DSA:3.30.70.3000:FF:000003', NULL, NULL, 'tRNA(His) guanylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(39329, NULL, 'G3DSA:1.10.390.10:FF:000026', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(39330, NULL, 'G3DSA:3.40.30.60:FF:000002', NULL, NULL, 'EscV/YscV/HrcV family type III secretion system export apparatus protein', NULL, NULL, NULL, NULL, NULL, 4),
(39331, NULL, 'G3DSA:3.30.200.20:FF:000869', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(39332, NULL, 'G3DSA:1.10.238.10:FF:000083', NULL, NULL, 'guanylyl cyclase-activating protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(39333, NULL, 'G3DSA:1.10.555.10:FF:000151', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39334, NULL, 'G3DSA:3.30.200.20:FF:001358', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39335, NULL, 'G3DSA:1.20.1560.10:FF:000385', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(39336, NULL, 'G3DSA:2.60.120.560:FF:000023', NULL, NULL, 'Beta-fructofuranosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39337, NULL, 'G3DSA:3.40.50.12710:FF:000035', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7', NULL, NULL, NULL, NULL, NULL, 4),
(39338, NULL, 'G3DSA:1.10.3730.30:FF:000002', NULL, NULL, 'Toxin B', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(39339, NULL, 'G3DSA:3.40.640.10:FF:000104', NULL, NULL, 'Alanine aminotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39340, NULL, 'G3DSA:2.40.50.140:FF:001148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39341, NULL, 'G3DSA:2.60.200.20:FF:000012', NULL, NULL, 'Nuclear inhibitor of protein phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(39342, NULL, 'G3DSA:1.10.287.110:FF:000136', NULL, NULL, 'DnaJ domain-containing protein Psi', NULL, NULL, NULL, NULL, NULL, 4),
(39343, NULL, 'G3DSA:3.40.50.2000:FF:001134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39344, NULL, 'G3DSA:1.25.40.10:FF:005064', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g04860', NULL, NULL, NULL, NULL, NULL, 4),
(39345, NULL, 'G3DSA:1.10.8.60:FF:000461', NULL, NULL, 'Peroxisomal ATPase pex1', NULL, NULL, NULL, NULL, NULL, 4),
(39346, NULL, 'G3DSA:3.40.50.300:FF:000158', NULL, NULL, 'Site-determining protein', NULL, NULL, NULL, NULL, NULL, 4),
(39347, NULL, 'G3DSA:2.130.10.10:FF:003474', NULL, NULL, 'Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(39348, NULL, 'G3DSA:2.40.50.90:FF:000048', NULL, NULL, 'Nuclease domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(39349, NULL, 'G3DSA:3.10.20.90:FF:000023', NULL, NULL, 'NEDD8 protein', NULL, NULL, NULL, NULL, NULL, 4),
(39350, NULL, 'G3DSA:1.10.510.10:FF:002886', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39351, NULL, 'G3DSA:1.10.1450.10:FF:000002', NULL, NULL, 'Retinal outer segment membrane protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(39352, NULL, 'G3DSA:2.60.40.10:FF:005582', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39353, NULL, 'G3DSA:3.40.720.10:FF:000217', NULL, NULL, 'Arylsulfatase A', NULL, NULL, NULL, NULL, NULL, 4),
(39354, NULL, 'G3DSA:1.25.40.860:FF:000019', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(39355, NULL, 'G3DSA:1.25.50.20:FF:000110', NULL, NULL, 'Npepps protein', NULL, NULL, NULL, NULL, NULL, 4),
(39356, NULL, 'G3DSA:3.40.50.12710:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39357, NULL, 'G3DSA:2.30.30.100:FF:000090', NULL, NULL, 'SnRNP Sm-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(39358, NULL, 'G3DSA:3.40.50.1820:FF:000574', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(39359, NULL, 'G3DSA:2.60.40.420:FF:000192', NULL, NULL, 'Blue (Type 1) copper domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(39360, NULL, 'G3DSA:2.60.40.60:FF:000223', NULL, NULL, 'neural-cadherin isoform X10', NULL, NULL, NULL, NULL, NULL, 4),
(39361, NULL, 'G3DSA:4.10.410.10:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39362, NULL, 'G3DSA:1.25.40.70:FF:000040', NULL, NULL, 'Putative phosphatidylinositol 4-kinase alpha', NULL, NULL, NULL, NULL, NULL, 4),
(39363, NULL, 'G3DSA:3.30.60.90:FF:000013', NULL, NULL, 'Transcriptional adapter', NULL, NULL, NULL, NULL, NULL, 4),
(39364, NULL, 'G3DSA:1.20.58.390:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39365, NULL, 'G3DSA:1.10.238.10:FF:000190', NULL, NULL, 'calcium-binding mitochondrial carrier protein SCaMC-3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(39366, NULL, 'G3DSA:2.130.10.10:FF:001905', NULL, NULL, 'Protein phosphatase 2C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39367, NULL, 'G3DSA:3.40.50.300:FF:004958', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39368, NULL, 'G3DSA:3.90.25.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39369, NULL, 'G3DSA:3.50.50.60:FF:001205', NULL, NULL, 'Geranylgeranyl reductase', NULL, NULL, NULL, NULL, NULL, 4),
(39370, NULL, 'G3DSA:2.60.40.10:FF:003491', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39371, NULL, 'G3DSA:3.30.160.60:FF:002361', NULL, NULL, 'Zinc finger protein 559', NULL, NULL, NULL, NULL, NULL, 4),
(39372, NULL, 'G3DSA:3.40.50.1400:FF:000043', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(39373, NULL, 'G3DSA:3.30.1330.20:FF:000001', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(39374, NULL, 'G3DSA:3.30.1330.30:FF:000004', NULL, NULL, 'selenocysteine insertion sequence-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(39375, NULL, 'G3DSA:3.30.200.20:FF:002488', NULL, NULL, 'Spermatocyte protein spe-8', NULL, NULL, NULL, NULL, NULL, 4),
(39376, NULL, 'G3DSA:3.50.50.80:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39377, NULL, 'G3DSA:3.40.50.1110:FF:000018', NULL, NULL, 'Lipase 1', NULL, NULL, NULL, NULL, NULL, 4),
(39378, NULL, 'G3DSA:3.20.20.80:FF:000840', NULL, NULL, 'Class V chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39379, NULL, 'G3DSA:2.20.28.200:FF:000006', NULL, NULL, 'NAD-dependent protein deacetylase sirtuin-6 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(39380, NULL, 'G3DSA:3.30.1330.40:FF:000007', NULL, NULL, 'Reactive intermediate/imine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(39381, NULL, 'G3DSA:1.10.555.10:FF:000145', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39382, NULL, 'G3DSA:3.40.630.30:FF:000054', NULL, NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', NULL, NULL, NULL, NULL, NULL, 4),
(39383, NULL, 'G3DSA:3.30.930.10:FF:000314', NULL, NULL, 'Phenylalanyl-tRNA synthetase, beta subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(39384, NULL, 'G3DSA:1.25.40.840:FF:000013', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(39385, NULL, 'G3DSA:2.60.40.10:FF:001254', NULL, NULL, 'Cartilage intermediate layer protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(39386, NULL, 'G3DSA:3.40.50.620:FF:000086', NULL, NULL, 'Electron transfer flavoprotein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(39387, NULL, 'G3DSA:3.40.50.1400:FF:000004', NULL, NULL, 'Ferrochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(39388, NULL, 'G3DSA:1.25.40.90:FF:000046', NULL, NULL, 'LSB5p protein', NULL, NULL, NULL, NULL, NULL, 4),
(39389, NULL, 'G3DSA:1.20.5.110:FF:000113', NULL, NULL, 't-SNARE domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(39390, NULL, 'G3DSA:3.40.50.720:FF:000346', NULL, NULL, 'C-3 sterol dehydrogenase/C-4 decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(39391, NULL, 'G3DSA:3.80.10.10:FF:001985', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(39392, NULL, 'G3DSA:3.40.50.1100:FF:000015', NULL, NULL, 'Cysteine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(39393, NULL, 'G3DSA:3.30.160.60:FF:003884', NULL, NULL, 'GD10687', NULL, NULL, NULL, NULL, NULL, 4),
(39394, NULL, 'G3DSA:3.40.1160.10:FF:000016', NULL, NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(39395, NULL, 'G3DSA:3.30.70.660:FF:000008', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(39396, NULL, 'G3DSA:4.10.420.10:FF:000001', NULL, NULL, 'Salt-mediated killer protoxin 1', NULL, NULL, NULL, NULL, NULL, 4),
(39397, NULL, 'G3DSA:1.10.225.10:FF:000008', NULL, NULL, 'Pulmonary surfactant-associated protein B', NULL, NULL, NULL, NULL, NULL, 4),
(39398, NULL, 'G3DSA:1.20.58.900:FF:000029', NULL, NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', NULL, NULL, NULL, NULL, NULL, 4),
(39399, NULL, 'G3DSA:1.10.1040.10:FF:000078', NULL, NULL, 'YALI0D20438p', NULL, NULL, NULL, NULL, NULL, 4),
(39400, NULL, 'G3DSA:1.25.40.10:FF:005351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39401, NULL, 'G3DSA:1.10.287.1150:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39402, NULL, 'G3DSA:2.60.40.10:FF:005525', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39403, NULL, 'G3DSA:3.90.180.10:FF:000119', NULL, NULL, 'Protein CBG06201', NULL, NULL, NULL, NULL, NULL, 4),
(39404, NULL, 'G3DSA:1.20.5.1930:FF:000005', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(39405, NULL, 'G3DSA:3.40.720.10:FF:000274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39406, NULL, 'G3DSA:3.40.50.720:FF:001240', NULL, NULL, '4-carboxy-2-hydroxymuconate-6-semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(39407, NULL, 'G3DSA:3.30.1240.10:FF:000019', NULL, NULL, 'Cof family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(39408, NULL, 'G3DSA:1.20.970.10:FF:000001', NULL, NULL, 'Thymidine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(39409, NULL, 'G3DSA:2.10.90.10:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39410, NULL, 'G3DSA:1.10.287.470:FF:000098', NULL, NULL, 'Sll0180 protein', NULL, NULL, NULL, NULL, NULL, 4),
(39411, NULL, 'G3DSA:3.90.20.20:FF:000038', NULL, NULL, 'GrpE protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(39412, NULL, 'G3DSA:3.40.50.410:FF:000247', NULL, NULL, 'General transcription and DNA repair factor IIH subunit TFB4', NULL, NULL, NULL, NULL, NULL, 4),
(39413, NULL, 'G3DSA:3.40.930.10:FF:000031', NULL, NULL, 'Anion exchange protein', NULL, NULL, NULL, NULL, NULL, 4),
(39414, NULL, 'G3DSA:3.30.780.10:FF:000044', NULL, NULL, '39S ribosomal protein L49, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(39415, NULL, 'G3DSA:1.20.58.830:FF:000042', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(39416, NULL, 'G3DSA:3.40.1170.60:FF:000009', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(39417, NULL, 'G3DSA:3.30.40.10:FF:002175', NULL, NULL, 'Vacuolar segregation protein pep7', NULL, NULL, NULL, NULL, NULL, 4),
(39418, NULL, 'G3DSA:2.60.120.330:FF:000207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39419, NULL, 'G3DSA:1.20.5.1190:FF:000007', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(39420, NULL, 'G3DSA:2.20.25.10:FF:000107', NULL, NULL, 'Plant-specific TFIIB-related protein PTF2', NULL, NULL, NULL, NULL, NULL, 4),
(39421, NULL, 'G3DSA:1.10.400.10:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39422, NULL, 'G3DSA:1.20.5.110:FF:000057', NULL, NULL, 'SNARE complex subunit (Bet1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(39423, NULL, 'G3DSA:3.30.160.60:FF:001754', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39424, NULL, 'G3DSA:3.40.50.1110:FF:000170', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(39425, NULL, 'G3DSA:3.30.160.60:FF:005065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39426, NULL, 'G3DSA:2.70.170.10:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39427, NULL, 'G3DSA:3.30.40.10:FF:000994', NULL, NULL, 'SR-related CTD associated factor 11', NULL, NULL, NULL, NULL, NULL, 4),
(39428, NULL, 'G3DSA:1.20.58.80:FF:000010', NULL, NULL, 'serine/threonine-protein kinase ULK3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(39429, NULL, 'G3DSA:3.60.90.10:FF:000018', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(39430, NULL, 'G3DSA:1.25.40.180:FF:000175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39431, NULL, 'G3DSA:1.20.1070.10:FF:000684', NULL, NULL, 'G protein coupled receptor', NULL, NULL, NULL, NULL, NULL, 4),
(39432, NULL, 'G3DSA:1.20.1300.10:FF:000051', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(39433, NULL, 'G3DSA:1.10.8.430:FF:000003', NULL, NULL, 'Probable disease resistance protein At5g66910', NULL, NULL, NULL, NULL, NULL, 4),
(39434, NULL, 'G3DSA:1.20.1560.10:FF:000497', NULL, NULL, 'ATP-binding cassette transporter, subfamily B, member 11, group MDR/PGP protein PpABCB11', NULL, NULL, NULL, NULL, NULL, 4),
(39435, NULL, 'G3DSA:3.40.50.300:FF:004104', NULL, NULL, 'Zinc finger NFX1-type containing homolog', NULL, NULL, NULL, NULL, NULL, 4),
(39436, NULL, 'G3DSA:2.130.10.10:FF:005560', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39437, NULL, 'G3DSA:2.130.10.10:FF:005503', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(39438, NULL, 'G3DSA:3.30.830.10:FF:000312', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(39439, NULL, 'G3DSA:2.60.60.20:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39440, NULL, 'G3DSA:1.20.900.10:FF:000053', NULL, NULL, 'Rho guanyl nucleotide exchange factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39441, NULL, 'G3DSA:3.30.930.10:FF:000371', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39442, NULL, 'G3DSA:1.20.120.850:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39443, NULL, 'G3DSA:3.20.20.70:FF:000511', NULL, NULL, 'N-acetylneuraminate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(39444, NULL, 'G3DSA:3.90.76.10:FF:000034', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(39445, NULL, 'G3DSA:3.30.160.60:FF:000118', NULL, NULL, 'Ataxin-7-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(39446, NULL, 'G3DSA:3.90.180.10:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39447, NULL, 'G3DSA:3.80.10.10:FF:002710', NULL, NULL, 'Putative leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(39448, NULL, 'G3DSA:2.60.120.1040:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39449, NULL, 'G3DSA:3.30.160.60:FF:005795', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39450, NULL, 'G3DSA:1.20.120.1110:FF:000003', NULL, NULL, 'Transcription initiation factor TFIID subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(39451, NULL, 'G3DSA:2.130.10.10:FF:005273', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(39452, NULL, 'G3DSA:3.40.50.2000:FF:000914', NULL, NULL, 'Mannosyltransferase B', NULL, NULL, NULL, NULL, NULL, 4),
(39453, NULL, 'G3DSA:3.30.160.60:FF:003827', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39454, NULL, 'G3DSA:3.30.2130.30:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39455, NULL, 'G3DSA:3.80.10.10:FF:000675', NULL, NULL, 'F-box domain protein (AFU_orthologue AFUA_2G02860)', NULL, NULL, NULL, NULL, NULL, 4),
(39456, NULL, 'G3DSA:1.10.510.10:FF:004162', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39457, NULL, 'G3DSA:1.10.630.10:FF:000629', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39458, NULL, 'G3DSA:1.20.80.40:FF:000004', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(39459, NULL, 'G3DSA:3.80.10.10:FF:002766', NULL, NULL, 'Dynein light chain 1, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(39460, NULL, 'G3DSA:3.90.640.10:FF:000256', NULL, NULL, 'Actin-like protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(39461, NULL, 'G3DSA:3.40.1190.20:FF:000173', NULL, NULL, 'Adenosine kinase 2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(39462, NULL, 'G3DSA:2.60.120.380:FF:000020', NULL, NULL, 'Protein CBR-TRA-3', NULL, NULL, NULL, NULL, NULL, 4),
(39463, NULL, 'G3DSA:3.90.176.10:FF:000014', NULL, NULL, 'NAD(P)(+)--arginine ADP-ribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(39464, NULL, 'G3DSA:3.90.870.10:FF:000026', NULL, NULL, 'Sll1866 protein', NULL, NULL, NULL, NULL, NULL, 4),
(39465, NULL, 'G3DSA:2.40.250.10:FF:000005', NULL, NULL, 'Core binding factor beta subunit isoform 10', NULL, NULL, NULL, NULL, NULL, 4),
(39466, NULL, 'G3DSA:1.25.40.10:FF:003153', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g10910, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(39467, NULL, 'G3DSA:1.10.555.10:FF:000106', NULL, NULL, 'Ecm25p', NULL, NULL, NULL, NULL, NULL, 4),
(39468, NULL, 'G3DSA:3.40.50.300:FF:003648', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(39469, NULL, 'G3DSA:2.10.25.10:FF:000136', NULL, NULL, 'Neurogenic locus notch 1', NULL, NULL, NULL, NULL, NULL, 4),
(39470, NULL, 'G3DSA:1.10.3550.10:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39471, NULL, 'G3DSA:3.40.50.300:FF:001468', NULL, NULL, 'Probable RNA helicase SDE3', NULL, NULL, NULL, NULL, NULL, 4),
(39472, NULL, 'G3DSA:2.60.120.330:FF:000027', NULL, NULL, 'Gibberellin 2-beta-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(39473, NULL, 'G3DSA:2.40.160.20:FF:000001', NULL, NULL, 'Outer membrane protein W', NULL, NULL, NULL, NULL, NULL, 4),
(39474, NULL, 'G3DSA:4.10.280.10:FF:000231', NULL, NULL, 'Uncharacterized bHLH domain-containing protein C3F10.12c', NULL, NULL, NULL, NULL, NULL, 4),
(39475, NULL, 'G3DSA:2.130.10.10:FF:003087', NULL, NULL, 'Pre-rRNA-processing protein IPI3', NULL, NULL, NULL, NULL, NULL, 4),
(39476, NULL, 'G3DSA:2.60.40.10:FF:004688', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39477, NULL, 'G3DSA:1.10.150.50:FF:000026', NULL, NULL, 'ETS homologous factor isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(39478, NULL, 'G3DSA:2.60.120.920:FF:000002', NULL, NULL, 'ryanodine receptor isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(39479, NULL, 'G3DSA:2.60.120.230:FF:000003', NULL, NULL, 'Probable peptidyl-glycine alpha-amidating monooxygenase pamn-1', NULL, NULL, NULL, NULL, NULL, 4),
(39480, NULL, 'G3DSA:3.30.559.10:FF:000086', NULL, NULL, 'Diacylglycerol O-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(39481, NULL, 'G3DSA:1.10.472.10:FF:000014', NULL, NULL, 'cyclin-L1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(39482, NULL, 'G3DSA:3.30.9.10:FF:000141', NULL, NULL, 'FAD-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(39483, NULL, 'G3DSA:3.40.20.10:FF:000060', NULL, NULL, 'Cofilin', NULL, NULL, NULL, NULL, NULL, 4),
(39484, NULL, 'G3DSA:3.50.50.60:FF:001262', NULL, NULL, 'FAD-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(39485, NULL, 'G3DSA:1.20.5.500:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39486, NULL, 'G3DSA:1.20.5.110:FF:000170', NULL, NULL, 'Synaptosomal-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(39487, NULL, 'G3DSA:2.40.10.10:FF:000016', NULL, NULL, 'Tryptase beta-2', NULL, NULL, NULL, NULL, NULL, 4),
(39488, NULL, 'G3DSA:1.20.1560.10:FF:000441', NULL, NULL, 'ABC transporter B family member 9', NULL, NULL, NULL, NULL, NULL, 4),
(39489, NULL, 'G3DSA:1.10.510.10:FF:001582', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39490, NULL, 'G3DSA:3.40.30.10:FF:000122', NULL, NULL, 'Peroxiredoxin Q chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(39491, NULL, 'G3DSA:3.80.10.10:FF:001018', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase EFR', NULL, NULL, NULL, NULL, NULL, 4),
(39492, NULL, 'G3DSA:1.20.58.60:FF:000689', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(39493, NULL, 'G3DSA:2.30.29.30:FF:001313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39494, NULL, 'G3DSA:3.20.20.70:FF:000730', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39495, NULL, 'G3DSA:2.130.10.10:FF:004778', NULL, NULL, 'WD40 repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(39496, NULL, 'G3DSA:1.10.630.10:FF:000068', NULL, NULL, 'Probable cytochrome P450 508A2', NULL, NULL, NULL, NULL, NULL, 4),
(39497, NULL, 'G3DSA:3.30.1140.60:FF:000010', NULL, NULL, 'F-actin capping protein', NULL, NULL, NULL, NULL, NULL, 4),
(39498, NULL, 'G3DSA:1.10.10.60:FF:000203', NULL, NULL, 'Nanog homeobox transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(39499, NULL, 'G3DSA:2.40.150.20:FF:000006', NULL, NULL, '50S ribosomal protein HLP, mitochondrial-like', NULL, NULL, NULL, NULL, NULL, 4),
(39500, NULL, 'G3DSA:1.20.1250.20:FF:002146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39501, NULL, 'G3DSA:3.30.70.100:FF:000071', NULL, NULL, 'Heavy metal P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(39502, NULL, 'G3DSA:3.30.160.60:FF:001467', NULL, NULL, 'Zinc finger protein 397', NULL, NULL, NULL, NULL, NULL, 4),
(39503, NULL, 'G3DSA:3.30.70.640:FF:000002', NULL, NULL, 'Molybdenum cofactor biosynthesis protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(39504, NULL, 'G3DSA:3.30.70.590:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39505, NULL, 'G3DSA:1.10.10.10:FF:001397', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(39506, NULL, 'G3DSA:3.20.20.140:FF:000154', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(39507, NULL, 'G3DSA:3.20.20.80:FF:000733', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39508, NULL, 'G3DSA:1.25.40.990:FF:000030', NULL, NULL, 'Putative leucine permease transcriptional regulator protein', NULL, NULL, NULL, NULL, NULL, 4),
(39509, NULL, 'G3DSA:1.20.1070.10:FF:000920', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39510, NULL, 'G3DSA:2.130.10.10:FF:001962', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(39511, NULL, 'G3DSA:3.40.50.10190:FF:000094', NULL, NULL, 'Regulatory subunit for Cdc7p protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(39512, NULL, 'G3DSA:1.10.150.50:FF:000245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39513, NULL, 'G3DSA:1.20.5.790:FF:000002', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 8', NULL, NULL, NULL, NULL, NULL, 4),
(39514, NULL, 'G3DSA:2.60.300.12:FF:000002', NULL, NULL, 'Iron-sulfur cluster insertion protein ErpA', NULL, NULL, NULL, NULL, NULL, 4),
(39515, NULL, 'G3DSA:1.10.287.1890:FF:000002', NULL, NULL, 'SAM-dependent methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(39516, NULL, 'G3DSA:2.80.10.50:FF:000116', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(39517, NULL, 'G3DSA:3.40.1110.10:FF:000356', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39518, NULL, 'G3DSA:3.40.50.300:FF:004323', NULL, NULL, 'Ras family gtpase', NULL, NULL, NULL, NULL, NULL, 4),
(39519, NULL, 'G3DSA:3.30.200.20:FF:001184', NULL, NULL, 'Methylthioribose kinase', NULL, NULL, NULL, NULL, NULL, 4),
(39520, NULL, 'G3DSA:3.30.70.1180:FF:000007', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(39521, NULL, 'G3DSA:2.30.29.30:FF:000419', NULL, NULL, 'mRNA-decapping enzyme subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(39522, NULL, 'G3DSA:1.25.40.10:FF:005238', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(39523, NULL, 'G3DSA:1.10.1200.10:FF:000175', NULL, NULL, 'Acyl-CoA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(39524, NULL, 'G3DSA:2.40.50.140:FF:000979', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39525, NULL, 'G3DSA:2.60.40.10:FF:003339', NULL, NULL, 'NPHS1 adhesion molecule, nephrin', NULL, NULL, NULL, NULL, NULL, 4),
(39526, NULL, 'G3DSA:1.20.1250.20:FF:000673', NULL, NULL, 'SLC (SoLute Carrier) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(39527, NULL, 'G3DSA:2.60.40.60:FF:000442', NULL, NULL, 'Cadherin 4, retinal', NULL, NULL, NULL, NULL, NULL, 4),
(39528, NULL, 'G3DSA:1.20.120.1810:FF:000005', NULL, NULL, 'RNA polymerase sigma factor SigB', NULL, NULL, NULL, NULL, NULL, 4),
(39529, NULL, 'G3DSA:3.30.450.20:FF:000348', NULL, NULL, 'Two component system histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(39530, NULL, 'G3DSA:3.40.120.10:FF:000071', NULL, NULL, 'Phosphoacetylglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(39531, NULL, 'G3DSA:3.40.630.30:FF:000110', NULL, NULL, 'Ribosomal-protein-serine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(39532, NULL, 'G3DSA:2.60.120.10:FF:000424', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39533, NULL, 'G3DSA:3.40.50.10190:FF:000037', NULL, NULL, 'Mediator of DNA damage checkpoint protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(39534, NULL, 'G3DSA:2.10.25.10:FF:001030', NULL, NULL, 'Laminin-like protein epi-1', NULL, NULL, NULL, NULL, NULL, 4),
(39535, NULL, 'G3DSA:3.30.710.10:FF:000096', NULL, NULL, 'Trithorax-like, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(39536, NULL, 'G3DSA:2.60.40.10:FF:002035', NULL, NULL, 'Mesocentin', NULL, NULL, NULL, NULL, NULL, 4),
(39537, NULL, 'G3DSA:3.40.50.300:FF:003980', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39538, NULL, 'G3DSA:3.40.50.300:FF:007196', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39539, NULL, 'G3DSA:1.10.720.30:FF:000053', NULL, NULL, 'AGAP005031-PA', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(39540, NULL, 'G3DSA:2.60.40.150:FF:000144', NULL, NULL, 'RAS p21 protein activator 3', NULL, NULL, NULL, NULL, NULL, 4),
(39541, NULL, 'G3DSA:3.90.70.10:FF:000190', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 8', NULL, NULL, NULL, NULL, NULL, 4),
(39542, NULL, 'G3DSA:1.25.40.10:FF:000005', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(39543, NULL, 'G3DSA:2.30.29.30:FF:000476', NULL, NULL, 'Oxysterol-binding protein-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(39544, NULL, 'G3DSA:1.25.40.20:FF:000008', NULL, NULL, 'Apoptosis-stimulating of p53 protein 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(39545, NULL, 'G3DSA:1.20.1560.10:FF:000772', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39546, NULL, 'G3DSA:1.20.5.170:FF:000092', NULL, NULL, 'Basic-leucine zipper transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(39547, NULL, 'G3DSA:3.40.50.720:FF:002257', NULL, NULL, 'C-terminal-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(39548, NULL, 'G3DSA:3.40.50.12610:FF:000005', NULL, NULL, 'Dolichyl-monophosphooligosaccharide--protein glycotransferase AglB', NULL, NULL, NULL, NULL, NULL, 4),
(39549, NULL, 'G3DSA:3.40.1110.10:FF:000300', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39550, NULL, 'G3DSA:3.80.10.10:FF:004508', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39551, NULL, 'G3DSA:3.20.20.70:FF:000218', NULL, NULL, 'Ribulose-phosphate 3-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(39552, NULL, 'G3DSA:3.30.470.10:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39553, NULL, 'G3DSA:3.30.70.330:FF:001045', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(39554, NULL, 'G3DSA:3.30.70.600:FF:000018', NULL, NULL, 'Ribosomal protein S10p/S20e', NULL, NULL, NULL, NULL, NULL, 4),
(39555, NULL, 'G3DSA:3.40.50.300:FF:007252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39556, NULL, 'G3DSA:2.30.40.10:FF:000159', NULL, NULL, 'Imidazolonepropionase', NULL, NULL, NULL, NULL, NULL, 4),
(39557, NULL, 'G3DSA:3.30.160.60:FF:000450', NULL, NULL, 'PR domain zinc finger protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(39558, NULL, 'G3DSA:3.40.600.10:FF:000001', NULL, NULL, 'DNA mismatch repair protein MutH', NULL, NULL, NULL, NULL, NULL, 4),
(39559, NULL, 'G3DSA:2.30.39.10:FF:000021', NULL, NULL, 'Serpin family B member 9', NULL, NULL, NULL, NULL, NULL, 4),
(39560, NULL, 'G3DSA:1.20.1070.10:FF:000807', NULL, NULL, 'Visual pigment-like receptor peropsin', NULL, NULL, NULL, NULL, NULL, 4),
(39561, NULL, 'G3DSA:1.10.8.50:FF:000014', NULL, NULL, 'Type 2 DNA topoisomerase 6 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(39562, NULL, 'G3DSA:3.80.10.10:FF:002709', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(39563, NULL, 'G3DSA:3.60.21.50:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39564, NULL, 'G3DSA:3.40.50.11000:FF:000005', NULL, NULL, 'Fe-S cluster assembly protein DRE2', NULL, NULL, NULL, NULL, NULL, 4),
(39565, NULL, 'G3DSA:3.30.1490.20:FF:000052', NULL, NULL, 'Formate-dependent phosphoribosylglycinamide formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(39566, NULL, 'G3DSA:2.60.40.10:FF:003614', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39567, NULL, 'G3DSA:2.60.40.10:FF:006020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39568, NULL, 'G3DSA:3.60.21.60:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39569, NULL, 'G3DSA:1.10.565.10:FF:000207', NULL, NULL, 'Coup transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39570, NULL, 'G3DSA:1.25.40.470:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39571, NULL, 'G3DSA:1.10.10.60:FF:001097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39572, NULL, 'G3DSA:3.40.50.150:FF:001552', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39573, NULL, 'G3DSA:1.20.120.1320:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(39574, NULL, 'G3DSA:2.60.40.2160:FF:000003', NULL, NULL, 'Interleukin 17 receptor A', NULL, NULL, NULL, NULL, NULL, 4),
(39575, NULL, 'G3DSA:3.30.342.10:FF:000009', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(39576, NULL, 'G3DSA:1.20.1270.60:FF:000164', NULL, NULL, 'Putative Sip3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(39577, NULL, 'G3DSA:3.80.10.10:FF:000237', NULL, NULL, 'F-box only protein 39', NULL, NULL, NULL, NULL, NULL, 4),
(39578, NULL, 'G3DSA:3.30.470.20:FF:000057', NULL, NULL, 'Carbamoyl-phosphate synthetase 2, aspartate transcarbamylase, and dihydroorotase', NULL, NULL, NULL, NULL, NULL, 4),
(39579, NULL, 'G3DSA:3.90.190.10:FF:000058', NULL, NULL, 'myotubularin-related protein 14 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(39580, NULL, 'G3DSA:3.40.50.2020:FF:000111', NULL, NULL, 'Ribose-phosphate pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(39581, NULL, 'G3DSA:1.25.10.10:FF:003106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39582, NULL, 'G3DSA:3.90.70.80:FF:000019', NULL, NULL, 'Cysteine proteinases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(39583, NULL, 'G3DSA:3.30.1550.10:FF:000009', NULL, NULL, 'RPL12 isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(39584, NULL, 'G3DSA:1.25.40.10:FF:003771', NULL, NULL, 'Sel1 repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(39585, NULL, 'G3DSA:2.10.25.10:FF:000535', NULL, NULL, 'Si:dkey-237h12.3', NULL, NULL, NULL, NULL, NULL, 4),
(39586, NULL, 'G3DSA:3.20.70.20:FF:000055', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(39587, NULL, 'G3DSA:4.10.400.10:FF:000112', NULL, NULL, 'Low-density lipoprotein receptor-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(39588, NULL, 'G3DSA:3.40.50.300:FF:005739', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39589, NULL, 'G3DSA:2.60.120.200:FF:000747', NULL, NULL, 'MAM domain-containing glycosylphosphatidylinositol anchor 2a', NULL, NULL, NULL, NULL, NULL, 4),
(39590, NULL, 'G3DSA:3.40.1360.10:FF:000054', NULL, NULL, 'Topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(39591, NULL, 'G3DSA:3.30.460.10:FF:000172', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(39592, NULL, 'G3DSA:3.20.20.70:FF:000550', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39593, NULL, 'G3DSA:3.40.50.450:FF:000012', NULL, NULL, 'LOG family protein YvdD', NULL, NULL, NULL, NULL, NULL, 4),
(39594, NULL, 'G3DSA:1.25.40.10:FF:001641', NULL, NULL, 'Os12g0114400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(39595, NULL, 'G3DSA:2.60.40.10:FF:003671', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39596, NULL, 'G3DSA:1.10.3450.40:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39597, NULL, 'G3DSA:3.40.50.460:FF:000015', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(39598, NULL, 'G3DSA:2.160.20.80:FF:000004', NULL, NULL, 'RNA-binding motif protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(39599, NULL, 'G3DSA:3.10.25.10:FF:000010', NULL, NULL, '10-formyltetrahydrofolate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(39600, NULL, 'G3DSA:2.60.40.1670:FF:000013', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(39601, NULL, 'G3DSA:1.20.1740.10:FF:000207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39602, NULL, 'G3DSA:3.30.70.330:FF:001084', NULL, NULL, '50S ribosomal protein L23', NULL, NULL, NULL, NULL, NULL, 4),
(39603, NULL, 'G3DSA:1.20.1270.60:FF:000220', NULL, NULL, 'SH3 and F-BAR domain-containing protein DDB_G0274695', NULL, NULL, NULL, NULL, NULL, 4),
(39604, NULL, 'G3DSA:2.60.40.1660:FF:000010', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit beta-2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(39605, NULL, 'G3DSA:3.40.630.30:FF:000492', NULL, NULL, 'Acyl-CoA N-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(39606, NULL, 'G3DSA:1.25.40.20:FF:000340', NULL, NULL, 'serine/threonine-protein kinase TNNI3K', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(39607, NULL, 'G3DSA:1.10.10.10:FF:001633', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39608, NULL, 'G3DSA:1.20.1070.10:FF:001027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39609, NULL, 'G3DSA:2.60.40.10:FF:001872', NULL, NULL, 'lachesin', NULL, NULL, NULL, NULL, NULL, 4),
(39610, NULL, 'G3DSA:2.40.50.1070:FF:000006', NULL, NULL, '23S rRNA (uracil(1939)-C(5))-methyltransferase RlmD', NULL, NULL, NULL, NULL, NULL, 4),
(39611, NULL, 'G3DSA:3.80.10.10:FF:000855', NULL, NULL, 'Blast:Leucine-rich repeat-containing protein 4B', NULL, NULL, NULL, NULL, NULL, 4),
(39612, NULL, 'G3DSA:3.30.160.60:FF:004103', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39613, NULL, 'G3DSA:3.30.930.10:FF:000039', NULL, NULL, 'Threonyl-tRNA synthetase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(39614, NULL, 'G3DSA:1.10.10.10:FF:001672', NULL, NULL, 'Winged helix-turn-helix transcriptional regulator, Rrf2 family', NULL, NULL, NULL, NULL, NULL, 4),
(39615, NULL, 'G3DSA:3.40.50.12780:FF:000067', NULL, NULL, 'Probable chain-fatty-acid-CoA ligase fadD13', NULL, NULL, NULL, NULL, NULL, 4),
(39616, NULL, 'G3DSA:1.20.1280.50:FF:000043', NULL, NULL, 'F-box only protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(39617, NULL, 'G3DSA:3.40.50.1820:FF:001012', NULL, NULL, 'Cutinase', NULL, NULL, NULL, NULL, NULL, 4),
(39618, NULL, 'G3DSA:1.50.10.10:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39619, NULL, 'G3DSA:1.20.5.730:FF:000012', NULL, NULL, 'Rho-associated protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(39620, NULL, 'G3DSA:2.160.20.70:FF:000001', NULL, NULL, 'Adenylyl cyclase-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(39621, NULL, 'G3DSA:1.10.840.10:FF:000044', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(39622, NULL, 'G3DSA:1.20.5.1230:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39623, NULL, 'G3DSA:1.25.40.10:FF:003714', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39624, NULL, 'G3DSA:1.10.260.40:FF:000071', NULL, NULL, 'One cut domain family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(39625, NULL, 'G3DSA:2.60.120.200:FF:000129', NULL, NULL, 'Vitamin K-dependent protein S', NULL, NULL, NULL, NULL, NULL, 4),
(39626, NULL, 'G3DSA:3.40.50.300:FF:005397', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39627, NULL, 'G3DSA:1.10.510.10:FF:000233', NULL, NULL, 'receptor tyrosine-protein kinase erbB-3', NULL, NULL, NULL, NULL, NULL, 4),
(39628, NULL, 'G3DSA:3.40.50.300:FF:007538', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39629, NULL, 'G3DSA:2.60.40.10:FF:001815', NULL, NULL, 'pregnancy zone protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(39630, NULL, 'G3DSA:3.20.20.80:FF:000553', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39631, NULL, 'G3DSA:3.30.70.330:FF:000769', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39632, NULL, 'G3DSA:3.30.40.10:FF:000937', NULL, NULL, 'E3 ubiquitin-protein ligase RZFP34', NULL, NULL, NULL, NULL, NULL, 4),
(39633, NULL, 'G3DSA:1.10.510.10:FF:003667', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39634, NULL, 'G3DSA:3.40.980.10:FF:000034', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(39635, NULL, 'G3DSA:3.80.10.10:FF:003261', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39636, NULL, 'G3DSA:3.40.50.1820:FF:000793', NULL, NULL, 'GPI inositol-deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(39637, NULL, 'G3DSA:3.40.50.10330:FF:000006', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(39638, NULL, 'G3DSA:2.40.400.10:FF:000001', NULL, NULL, 'FAD binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(39639, NULL, 'G3DSA:2.160.20.10:FF:000079', NULL, NULL, 'Probable GLUCAN ENDO-1, 3-BETA-GLUCOSIDASE BGN13.1', NULL, NULL, NULL, NULL, NULL, 4),
(39640, NULL, 'G3DSA:2.60.120.260:FF:000669', NULL, NULL, 'AFR597Wp', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(39641, NULL, 'G3DSA:3.40.50.300:FF:005958', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(39642, NULL, 'G3DSA:3.90.1750.10:FF:000016', NULL, NULL, 'E3 ubiquitin-protein ligase UBR5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(39643, NULL, 'G3DSA:3.30.420.10:FF:000175', NULL, NULL, 'RNA exonuclease 5', NULL, NULL, NULL, NULL, NULL, 4),
(39644, NULL, 'G3DSA:3.30.30.30:FF:000033', NULL, NULL, 'HSP70-family chaperone protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39645, NULL, 'G3DSA:1.10.510.10:FF:003942', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39646, NULL, 'G3DSA:3.30.505.10:FF:000080', NULL, NULL, 'Pi3K21B, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(39647, NULL, 'G3DSA:1.20.920.10:FF:000228', NULL, NULL, 'PHD Zn finger-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(39648, NULL, 'G3DSA:1.20.120.1760:FF:000063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39649, NULL, 'G3DSA:3.30.930.10:FF:000191', NULL, NULL, 'Bifunctional protein BirA: biotin operon repressor + biotin--[acetyl-CoA-carboxylase] synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(39650, NULL, 'G3DSA:1.10.8.10:FF:000249', NULL, NULL, 'Subunit of ESCRT-II complex', NULL, NULL, NULL, NULL, NULL, 4),
(39651, NULL, 'G3DSA:1.25.40.20:FF:000160', NULL, NULL, 'KN motif and ankyrin repeat domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(39652, NULL, 'G3DSA:2.130.10.10:FF:002867', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One component system)', NULL, NULL, NULL, NULL, NULL, 4),
(39653, NULL, 'G3DSA:3.40.50.360:FF:000154', NULL, NULL, 'FMN-dependent NADH-azoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(39654, NULL, 'G3DSA:3.40.50.300:FF:006234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39655, NULL, 'G3DSA:3.80.10.10:FF:001131', NULL, NULL, 'Os04g0132500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(39656, NULL, 'G3DSA:3.30.1120.10:FF:000022', NULL, NULL, 'Arylsulfatase A', NULL, NULL, NULL, NULL, NULL, 4),
(39657, NULL, 'G3DSA:1.20.120.1080:FF:000067', NULL, NULL, 'Dosage compensation regulator-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(39658, NULL, 'G3DSA:2.130.10.10:FF:001288', NULL, NULL, 'TOMosyn synaptic protein', NULL, NULL, NULL, NULL, NULL, 4),
(39659, NULL, 'G3DSA:1.10.590.10:FF:000007', NULL, NULL, 'Chorismate mutase1', NULL, NULL, NULL, NULL, NULL, 4),
(39660, NULL, 'G3DSA:3.40.640.10:FF:000397', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39661, NULL, 'G3DSA:1.25.40.10:FF:003439', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g62720', NULL, NULL, NULL, NULL, NULL, 4),
(39662, NULL, 'G3DSA:1.20.1170.10:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39663, NULL, 'G3DSA:3.40.50.300:FF:007813', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39664, NULL, 'G3DSA:2.60.120.10:FF:000188', NULL, NULL, 'Transcriptional activator putative', NULL, NULL, NULL, NULL, NULL, 4),
(39665, NULL, 'G3DSA:3.40.50.1010:FF:000252', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39666, NULL, 'G3DSA:3.20.20.80:FF:000278', NULL, NULL, 'Glucan 1,6-alpha-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(39667, NULL, 'G3DSA:3.30.9.10:FF:000180', NULL, NULL, 'FAD-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(39668, NULL, 'G3DSA:3.60.10.10:FF:000283', NULL, NULL, 'Putative inositol polyphosphate phosphatase (Synaptogenin-like) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(39669, NULL, 'G3DSA:1.20.120.350:FF:000212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39670, NULL, 'G3DSA:3.30.499.10:FF:000030', NULL, NULL, 'Aconitate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(39671, NULL, 'G3DSA:3.20.20.70:FF:000494', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39672, NULL, 'G3DSA:3.40.30.10:FF:000408', NULL, NULL, 'Possible thioredoxin protein', NULL, NULL, NULL, NULL, NULL, 4),
(39673, NULL, 'G3DSA:3.80.10.10:FF:000911', NULL, NULL, 'Protein lap4-like Protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(39674, NULL, 'G3DSA:3.30.420.40:FF:000897', NULL, NULL, 'Heat shock cognate 70 kDa protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(39675, NULL, 'G3DSA:3.40.50.80:FF:000099', NULL, NULL, 'NADPH-cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(39676, NULL, 'G3DSA:3.40.50.10320:FF:000003', NULL, NULL, '1D-myo-inositol 2-acetamido-2-deoxy-alpha-D-glucopyranoside deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(39677, NULL, 'G3DSA:1.10.240.10:FF:000021', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(39678, NULL, 'G3DSA:1.10.238.10:FF:000313', NULL, NULL, 'Probable calcium-binding protein CML16', NULL, NULL, NULL, NULL, NULL, 4),
(39679, NULL, 'G3DSA:1.20.58.60:FF:000745', NULL, NULL, 'Si:ch211-207i1.2', NULL, NULL, NULL, NULL, NULL, 4),
(39680, NULL, 'G3DSA:3.30.420.10:FF:000517', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39681, NULL, 'G3DSA:3.40.50.10190:FF:000150', NULL, NULL, 'DNA-directed DNA/RNA polymerase mu', NULL, NULL, NULL, NULL, NULL, 4),
(39682, NULL, 'G3DSA:2.130.10.10:FF:005559', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39683, NULL, 'G3DSA:1.10.510.10:FF:003723', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39684, NULL, 'G3DSA:2.30.40.10:FF:000092', NULL, NULL, 'Cytosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(39685, NULL, 'G3DSA:3.20.20.80:FF:000497', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39686, NULL, 'G3DSA:1.10.510.10:FF:003049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39687, NULL, 'G3DSA:3.30.70.330:FF:001483', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39688, NULL, 'G3DSA:3.40.50.620:FF:000760', NULL, NULL, 'AGAP009543-PA', NULL, NULL, NULL, NULL, NULL, 4),
(39689, NULL, 'G3DSA:1.10.3720.10:FF:000220', NULL, NULL, 'Proline/glycine betaine ABC superfamily ATP binding cassette transporter, membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(39690, NULL, 'G3DSA:1.10.10.830:FF:000003', NULL, NULL, 'Isoleucine--tRNA ligase, chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(39691, NULL, 'G3DSA:1.20.120.1770:FF:000009', NULL, NULL, 'Related to CYTOCHROME B561', NULL, NULL, NULL, NULL, NULL, 4),
(39692, NULL, 'G3DSA:3.40.50.1260:FF:000035', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(39693, NULL, 'G3DSA:3.10.250.10:FF:000115', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39694, NULL, 'G3DSA:1.20.1070.10:FF:001140', NULL, NULL, 'Tachykinin-like peptides receptor 99D', NULL, NULL, NULL, NULL, NULL, 4),
(39695, NULL, 'G3DSA:1.10.3450.20:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39696, NULL, 'G3DSA:2.60.40.10:FF:001198', NULL, NULL, 'Beta-glucuronidase UidA', NULL, NULL, NULL, NULL, NULL, 4),
(39697, NULL, 'G3DSA:3.40.50.300:FF:001288', NULL, NULL, 'Conjugal transfer protein TraB', NULL, NULL, NULL, NULL, NULL, 4),
(39698, NULL, 'G3DSA:3.40.367.20:FF:000045', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(39699, NULL, 'G3DSA:2.160.20.10:FF:000298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39700, NULL, 'G3DSA:3.20.20.80:FF:000839', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39701, NULL, 'G3DSA:1.20.58.80:FF:000009', NULL, NULL, 'spartin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(39702, NULL, 'G3DSA:3.30.70.1430:FF:000010', NULL, NULL, 'RND multidrug efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(39703, NULL, 'G3DSA:3.30.420.10:FF:000736', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39704, NULL, 'G3DSA:3.40.1380.20:FF:000002', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(39705, NULL, 'G3DSA:1.10.510.10:FF:003381', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39706, NULL, 'G3DSA:3.40.50.10330:FF:000063', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(39707, NULL, 'G3DSA:3.40.630.150:FF:000019', NULL, NULL, 'Malonyl-CoA decarboxylase, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(39708, NULL, 'G3DSA:3.60.130.10:FF:000090', NULL, NULL, 'Clavaminate synthase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(39709, NULL, 'G3DSA:4.10.640.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39710, NULL, 'G3DSA:1.10.135.10:FF:000001', NULL, NULL, 'Creatine kinase M-type', NULL, NULL, NULL, NULL, NULL, 4),
(39711, NULL, 'G3DSA:2.60.40.10:FF:001692', NULL, NULL, 'Immunoglobulin superfamily containing leucine-rich repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(39712, NULL, 'G3DSA:3.40.50.300:FF:007870', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39713, NULL, 'G3DSA:1.10.540.10:FF:000061', NULL, NULL, 'Acyl-CoA dehydrogenase fadE3', NULL, NULL, NULL, NULL, NULL, 4),
(39714, NULL, 'G3DSA:3.40.50.10470:FF:000020', NULL, NULL, 'Eukaryotic translation initiation factor 2b, subunit 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39715, NULL, 'G3DSA:3.40.50.300:FF:003941', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39716, NULL, 'G3DSA:1.20.1070.10:FF:000864', NULL, NULL, 'Protein CBG03354', NULL, NULL, NULL, NULL, NULL, 4),
(39717, NULL, 'G3DSA:3.30.160.60:FF:003940', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39718, NULL, 'G3DSA:3.30.420.40:FF:000678', NULL, NULL, 'Glycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(39719, NULL, 'G3DSA:2.60.120.200:FF:000461', NULL, NULL, 'Deleted in malignant brain tumors 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(39720, NULL, 'G3DSA:2.130.10.10:FF:001849', NULL, NULL, 'Telomerase protein component 1', NULL, NULL, NULL, NULL, NULL, 4),
(39721, NULL, 'G3DSA:3.40.50.200:FF:000134', NULL, NULL, 'Glr3087 protein', NULL, NULL, NULL, NULL, NULL, 4),
(39722, NULL, 'G3DSA:3.20.20.70:FF:000275', NULL, NULL, 'tRNA-dihydrouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(39723, NULL, 'G3DSA:3.40.50.10490:FF:000026', NULL, NULL, '28S ribosomal protein S2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(39724, NULL, 'G3DSA:3.40.50.800:FF:000038', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(39725, NULL, 'G3DSA:3.40.630.30:FF:000615', NULL, NULL, 'N-alpha-acetyltransferase 40', NULL, NULL, NULL, NULL, NULL, 4),
(39726, NULL, 'G3DSA:2.30.42.10:FF:000383', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39727, NULL, 'G3DSA:3.40.50.150:FF:001496', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39728, NULL, 'G3DSA:2.30.180.10:FF:000114', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39729, NULL, 'G3DSA:3.40.50.1820:FF:000517', NULL, NULL, 'Lipase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(39730, NULL, 'G3DSA:3.40.390.10:FF:000293', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39731, NULL, 'G3DSA:3.30.40.10:FF:001051', NULL, NULL, 'SNF2 family helicase/ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(39732, NULL, 'G3DSA:2.60.40.10:FF:005469', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39733, NULL, 'G3DSA:3.30.9.10:FF:000028', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(39734, NULL, 'G3DSA:1.10.418.70:FF:000002', NULL, NULL, 'Intraflagellar Transport Protein 81', NULL, NULL, NULL, NULL, NULL, 4),
(39735, NULL, 'G3DSA:3.30.450.20:FF:000387', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(39736, NULL, 'G3DSA:1.10.418.80:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39737, NULL, 'G3DSA:3.30.70.330:FF:000589', NULL, NULL, 'RNA-binding protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(39738, NULL, 'G3DSA:1.10.246.90:FF:000013', NULL, NULL, 'Archaeal nucleolar protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(39739, NULL, 'G3DSA:3.30.930.10:FF:000258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39740, NULL, 'G3DSA:1.10.10.140:FF:000004', NULL, NULL, 'Cytochrome c oxidase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(39741, NULL, 'G3DSA:1.20.1310.10:FF:000220', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39742, NULL, 'G3DSA:1.10.506.10:FF:000015', NULL, NULL, 'Neurofibromin isoform 1', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(39743, NULL, 'G3DSA:4.10.110.10:FF:000011', NULL, NULL, 'Epi-1', NULL, NULL, NULL, NULL, NULL, 4),
(39744, NULL, 'G3DSA:2.130.10.10:FF:003143', NULL, NULL, 'Intraflagellar transport particle protein IFT140', NULL, NULL, NULL, NULL, NULL, 4),
(39745, NULL, 'G3DSA:3.30.2140.20:FF:000026', NULL, NULL, 'arylamine N-acetyltransferase, pineal gland isozyme NAT-3', NULL, NULL, NULL, NULL, NULL, 4),
(39746, NULL, 'G3DSA:1.25.10.10:FF:003382', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39747, NULL, 'G3DSA:3.40.50.150:FF:001439', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39748, NULL, 'G3DSA:1.20.1070.10:FF:001701', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39749, NULL, 'G3DSA:3.40.50.10490:FF:000083', NULL, NULL, 'Glucose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(39750, NULL, 'G3DSA:3.90.1750.20:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39751, NULL, 'G3DSA:4.10.240.10:FF:000015', NULL, NULL, 'Nitrogen assimilation transcription factor nirA', NULL, NULL, NULL, NULL, NULL, 4),
(39752, NULL, 'G3DSA:1.20.58.60:FF:000184', NULL, NULL, 'Coiled-coil domain containing 141', NULL, NULL, NULL, NULL, NULL, 4),
(39753, NULL, 'G3DSA:3.40.30.10:FF:000066', NULL, NULL, 'FAS-associated factor 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(39754, NULL, 'G3DSA:3.30.70.330:FF:002101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39755, NULL, 'G3DSA:1.25.10.10:FF:003325', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(39756, NULL, 'G3DSA:1.10.1060.10:FF:000023', NULL, NULL, 'FAD-linked oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(39757, NULL, 'G3DSA:2.30.30.40:FF:000313', NULL, NULL, 'SH3 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(39758, NULL, 'G3DSA:3.40.30.10:FF:000009', NULL, NULL, 'Tumor suppressor candidate 3', NULL, NULL, NULL, NULL, NULL, 4),
(39759, NULL, 'G3DSA:3.10.270.10:FF:000004', NULL, NULL, '2-oxo-4-hydroxy-4-carboxy--5-ureidoimidazoline (OHCU) decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(39760, NULL, 'G3DSA:1.25.40.10:FF:005160', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(39761, NULL, 'G3DSA:1.10.238.20:FF:000013', NULL, NULL, 'Odorant-binding protein 56i, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(39762, NULL, 'G3DSA:4.10.400.10:FF:000331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39763, NULL, 'G3DSA:2.70.150.10:FF:000103', NULL, NULL, 'Calcium-translocating P-type ATPase, SERCA-type', NULL, NULL, NULL, NULL, NULL, 4),
(39764, NULL, 'G3DSA:1.10.8.10:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39765, NULL, 'G3DSA:1.10.10.60:FF:001182', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39766, NULL, 'G3DSA:3.40.50.2300:FF:000881', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39767, NULL, 'G3DSA:1.20.1070.10:FF:000353', NULL, NULL, 'G-protein coupled receptor GRL101-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(39768, NULL, 'G3DSA:3.30.40.10:FF:000915', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(39769, NULL, 'G3DSA:1.10.10.10:FF:001318', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39770, NULL, 'G3DSA:3.30.420.10:FF:000427', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39771, NULL, 'G3DSA:2.60.60.20:FF:000027', NULL, NULL, 'Protein CBR-LOV-1', NULL, NULL, NULL, NULL, NULL, 4),
(39772, NULL, 'G3DSA:1.10.530.10:FF:000026', NULL, NULL, 'Lysozyme g', NULL, NULL, NULL, NULL, NULL, 4),
(39773, NULL, 'G3DSA:1.20.1600.10:FF:000023', NULL, NULL, 'Outer membrane protein TolC', NULL, NULL, NULL, NULL, NULL, 4),
(39774, NULL, 'G3DSA:1.10.10.10:FF:000216', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(39775, NULL, 'G3DSA:1.20.1070.10:FF:000869', NULL, NULL, 'CholecystoKinin Receptor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(39776, NULL, 'G3DSA:3.90.550.10:FF:000215', NULL, NULL, 'D-alpha-D-mannose-1-phosphate guanylyltransferase ManB', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(39777, NULL, 'G3DSA:1.10.510.10:FF:001554', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(39778, NULL, 'G3DSA:1.10.510.10:FF:003678', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39779, NULL, 'G3DSA:3.40.50.300:FF:007903', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(39780, NULL, 'G3DSA:1.10.600.10:FF:000055', NULL, NULL, 'Squalene synthase HpnC', NULL, NULL, NULL, NULL, NULL, 4),
(39781, NULL, 'G3DSA:2.30.29.30:FF:000408', NULL, NULL, 'Pleckstrin (PH) domain containing family protein', NULL, NULL, NULL, NULL, NULL, 4),
(39782, NULL, 'G3DSA:3.20.20.220:FF:000003', NULL, NULL, 'Methylenetetrahydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(39783, NULL, 'G3DSA:1.25.40.10:FF:003552', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g04810, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(39784, NULL, 'G3DSA:3.30.160.60:FF:005407', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39785, NULL, 'G3DSA:2.102.10.10:FF:000053', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(39786, NULL, 'G3DSA:2.60.40.10:FF:005284', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39787, NULL, 'G3DSA:3.90.850.10:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39788, NULL, 'G3DSA:1.20.1280.50:FF:000015', NULL, NULL, 'F-box/WD repeat-containing protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(39789, NULL, 'G3DSA:1.50.10.10:FF:000243', NULL, NULL, 'Mannosyl-oligosaccharide glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(39790, NULL, 'G3DSA:2.60.40.10:FF:003676', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39791, NULL, 'G3DSA:1.10.510.10:FF:002060', NULL, NULL, 'SH3 domain-binding kinase family, member 3', NULL, NULL, NULL, NULL, NULL, 4),
(39792, NULL, 'G3DSA:3.80.10.10:FF:000653', NULL, NULL, 'F-box/LRR-repeat protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(39793, NULL, 'G3DSA:3.30.479.10:FF:000012', NULL, NULL, '6-carboxy-5,6,7,8-tetrahydropterin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(39794, NULL, 'G3DSA:3.60.20.10:FF:000098', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(39795, NULL, 'G3DSA:3.40.33.10:FF:000033', NULL, NULL, 'Protein lon-1', NULL, NULL, NULL, NULL, NULL, 4),
(39796, NULL, 'G3DSA:3.30.160.60:FF:001664', NULL, NULL, 'Zinc finger protein 133', NULL, NULL, NULL, NULL, NULL, 4),
(39797, NULL, 'G3DSA:2.60.40.60:FF:000032', NULL, NULL, 'FAT atypical cadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(39798, NULL, 'G3DSA:1.10.238.220:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39799, NULL, 'G3DSA:1.20.1560.10:FF:000418', NULL, NULL, 'ABC transporter HlyB/MsbA family', NULL, NULL, NULL, NULL, NULL, 4),
(39800, NULL, 'G3DSA:3.20.20.140:FF:000277', NULL, NULL, 'Slr0619 protein', NULL, NULL, NULL, NULL, NULL, 4),
(39801, NULL, 'G3DSA:3.40.50.720:FF:000970', NULL, NULL, 'Similar to surfactin synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(39802, NULL, 'G3DSA:3.40.50.10190:FF:000127', NULL, NULL, 'Mutagen-sensitive 101', NULL, NULL, NULL, NULL, NULL, 4),
(39803, NULL, 'G3DSA:2.170.150.80:FF:000010', NULL, NULL, 'NAC domain-containing protein 67-like', NULL, NULL, NULL, NULL, NULL, 4),
(39804, NULL, 'G3DSA:1.10.1240.10:FF:000003', NULL, NULL, '5-methyltetrahydrofolate--homocysteine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(39805, NULL, 'G3DSA:3.30.479.20:FF:000015', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(39806, NULL, 'G3DSA:3.50.50.60:FF:000778', NULL, NULL, 'Fumarate reductase/succinate dehydrogenase flavoprotein domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(39807, NULL, 'G3DSA:1.25.40.180:FF:000046', NULL, NULL, 'Eukaryotic translation initiation factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(39808, NULL, 'G3DSA:2.30.29.30:FF:000397', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(39809, NULL, 'G3DSA:3.30.559.10:FF:000159', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(39810, NULL, 'G3DSA:3.30.190.20:FF:000013', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(39811, NULL, 'G3DSA:2.10.25.10:FF:000653', NULL, NULL, 'Putative Fibrillin-1', NULL, NULL, NULL, NULL, NULL, 4),
(39812, NULL, 'G3DSA:2.40.50.1020:FF:000020', NULL, NULL, 'Putative two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(39813, NULL, 'G3DSA:1.25.40.470:FF:000026', NULL, NULL, 'Intraflagellar transport protein 172 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(39814, NULL, 'G3DSA:3.40.50.720:FF:001150', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(39815, NULL, 'G3DSA:3.30.70.330:FF:000786', NULL, NULL, 'Yme2p', NULL, NULL, NULL, NULL, NULL, 4),
(39816, NULL, 'G3DSA:2.130.10.10:FF:005262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39817, NULL, 'G3DSA:3.30.70.100:FF:000037', NULL, NULL, 'NIPSNAP family protein', NULL, NULL, NULL, NULL, NULL, 4),
(39818, NULL, 'G3DSA:3.40.50.150:FF:000091', NULL, NULL, 'tRNA 5-carboxymethoxyuridine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(39819, NULL, 'G3DSA:3.80.10.10:FF:003879', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39820, NULL, 'G3DSA:1.25.40.20:FF:001790', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(39821, NULL, 'G3DSA:3.20.20.190:FF:000152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39822, NULL, 'G3DSA:1.50.40.10:FF:000071', NULL, NULL, 'probable ADP,ATP carrier protein At5g56450', NULL, NULL, NULL, NULL, NULL, 4),
(39823, NULL, 'G3DSA:2.60.220.50:FF:000039', NULL, NULL, 'Adhesion G protein-coupled receptor G4b', NULL, NULL, NULL, NULL, NULL, 4),
(39824, NULL, 'G3DSA:1.25.40.450:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39825, NULL, 'G3DSA:3.40.30.10:FF:000526', NULL, NULL, 'AGAP012823-PA', NULL, NULL, NULL, NULL, NULL, 4),
(39826, NULL, 'G3DSA:3.40.50.1360:FF:000003', NULL, NULL, 'Glucosamine-6-phosphate deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(39827, NULL, 'G3DSA:3.40.50.300:FF:005649', NULL, NULL, 'Guanylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(39828, NULL, 'G3DSA:2.20.100.10:FF:000090', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 12', NULL, NULL, NULL, NULL, NULL, 4),
(39829, NULL, 'G3DSA:2.130.10.10:FF:001193', NULL, NULL, 'DYnein Chain, light Intermediate', NULL, NULL, NULL, NULL, NULL, 4),
(39830, NULL, 'G3DSA:2.130.10.10:FF:003654', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(39831, NULL, 'G3DSA:1.10.510.10:FF:000126', NULL, NULL, 'Protein kinase C epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(39832, NULL, 'G3DSA:3.40.50.10090:FF:000069', NULL, NULL, 'Putative uroporphyrinogen III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(39833, NULL, 'G3DSA:3.30.710.10:FF:000293', NULL, NULL, 'Zinc finger and BTB domain-containing 7a', NULL, NULL, NULL, NULL, NULL, 4),
(39834, NULL, 'G3DSA:3.90.320.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39835, NULL, 'G3DSA:3.40.190.100:FF:000004', NULL, NULL, 'Probable glycine betaine-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(39836, NULL, 'G3DSA:1.10.10.41:FF:000002', NULL, NULL, 'Topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(39837, NULL, 'G3DSA:3.30.200.20:FF:001364', NULL, NULL, 'CMGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(39838, NULL, 'G3DSA:1.10.238.210:FF:000011', NULL, NULL, 'Glutaminase kidney isoform, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(39839, NULL, 'G3DSA:3.40.50.1820:FF:001001', NULL, NULL, 'Alpha/beta hydrolase family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39840, NULL, 'G3DSA:1.10.860.10:FF:000012', NULL, NULL, 'Replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(39841, NULL, 'G3DSA:3.40.50.2000:FF:000572', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(39842, NULL, 'G3DSA:3.40.930.10:FF:000020', NULL, NULL, 'Anion exchange protein', NULL, NULL, NULL, NULL, NULL, 4),
(39843, NULL, 'G3DSA:1.10.10.10:FF:001644', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(39844, NULL, 'G3DSA:3.40.50.300:FF:003188', NULL, NULL, 'ESX conserved componant EccC2', NULL, NULL, NULL, NULL, NULL, 4),
(39845, NULL, 'G3DSA:1.25.10.10:FF:003078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39846, NULL, 'G3DSA:3.30.50.10:FF:000197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39847, NULL, 'G3DSA:3.40.50.10490:FF:000099', NULL, NULL, 'Transcriptional regulator RpiR family', NULL, NULL, NULL, NULL, NULL, 4),
(39848, NULL, 'G3DSA:1.20.1250.20:FF:000454', NULL, NULL, 'Karmoisin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(39849, NULL, 'G3DSA:1.25.10.10:FF:002898', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39850, NULL, 'G3DSA:2.60.40.10:FF:005930', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39851, NULL, 'G3DSA:3.30.505.10:FF:000130', NULL, NULL, 'Spermatocyte protein spe-8', NULL, NULL, NULL, NULL, NULL, 4),
(39852, NULL, 'G3DSA:3.40.50.970:FF:000168', NULL, NULL, 'Transketolase chloroplast putative', NULL, NULL, NULL, NULL, NULL, 4),
(39853, NULL, 'G3DSA:3.40.50.150:FF:000102', NULL, NULL, 'tRNA (guanine(37)-N1)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(39854, NULL, 'G3DSA:1.10.238.10:FF:000010', NULL, NULL, 'Myosin regulatory light chain 2, atrial isoform', NULL, NULL, NULL, NULL, NULL, 4),
(39855, NULL, 'G3DSA:3.60.110.10:FF:000049', NULL, NULL, 'Glutamine-dependent NAD(+) synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(39856, NULL, 'G3DSA:1.20.1260.10:FF:000053', NULL, NULL, 'Rho family-interacting cell polarization regulator 2', NULL, NULL, NULL, NULL, NULL, 4),
(39857, NULL, 'G3DSA:2.30.40.10:FF:000075', NULL, NULL, 'Allantoinase', NULL, NULL, NULL, NULL, NULL, 4),
(39858, NULL, 'G3DSA:2.30.29.30:FF:000734', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(39859, NULL, 'G3DSA:1.20.5.170:FF:000209', NULL, NULL, 'cyclic nucleotide-gated channel rod photoreceptor subunit alpha-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(39860, NULL, 'G3DSA:3.30.720.50:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39861, NULL, 'G3DSA:1.25.40.10:FF:003922', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(39862, NULL, 'G3DSA:1.20.1250.20:FF:000763', NULL, NULL, 'Organic cation/carnitine transporter 4', NULL, NULL, NULL, NULL, NULL, 4),
(39863, NULL, 'G3DSA:3.30.160.60:FF:000236', NULL, NULL, 'zinc finger protein 143 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(39864, NULL, 'G3DSA:3.40.50.300:FF:003834', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(39865, NULL, 'G3DSA:1.10.630.10:FF:000399', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(39866, NULL, 'G3DSA:1.20.1560.10:FF:000744', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39867, NULL, 'G3DSA:3.10.250.10:FF:000008', NULL, NULL, 'Lysyl oxidase homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(39868, NULL, 'G3DSA:3.90.650.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39869, NULL, 'G3DSA:3.40.720.10:FF:000083', NULL, NULL, 'Hydrolase of alkaline phosphatase superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(39870, NULL, 'G3DSA:3.90.660.10:FF:000027', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(39871, NULL, 'G3DSA:3.30.450.20:FF:000567', NULL, NULL, 'Putative methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(39872, NULL, 'G3DSA:2.60.40.10:FF:006110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39873, NULL, 'G3DSA:3.40.850.10:FF:000295', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(39874, NULL, 'G3DSA:2.10.70.10:FF:000066', NULL, NULL, 'CUB and sushi domain-containing protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(39875, NULL, 'G3DSA:3.30.420.10:FF:000753', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39876, NULL, 'G3DSA:3.90.640.10:FF:000144', NULL, NULL, 'Actin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(39877, NULL, 'G3DSA:1.10.10.2420:FF:000003', NULL, NULL, 'Glutamine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(39878, NULL, 'G3DSA:1.10.390.10:FF:000037', NULL, NULL, 'TAF2 RNA polymerase II, TATA box binding (TBP)-associated factor, 150 kDa (TAF2), mRNA protein', NULL, NULL, NULL, NULL, NULL, 4),
(39879, NULL, 'G3DSA:3.40.50.300:FF:007566', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(39880, NULL, 'G3DSA:2.60.40.1180:FF:000203', NULL, NULL, 'Alpha-L-fucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(39881, NULL, 'G3DSA:3.30.2460.20:FF:000005', NULL, NULL, 'Protein Wnt', NULL, NULL, NULL, NULL, NULL, 4),
(39882, NULL, 'G3DSA:3.40.1110.10:FF:000266', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(39883, NULL, 'G3DSA:2.40.420.20:FF:000005', NULL, NULL, 'Efflux transporter, RND family, MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(39884, NULL, 'G3DSA:3.40.50.720:FF:002459', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(39885, NULL, 'G3DSA:3.30.40.10:FF:000595', NULL, NULL, 'MAG2p Cytoplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(39886, NULL, 'G3DSA:2.60.40.10:FF:001905', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(39887, NULL, 'G3DSA:3.40.50.11500:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39888, NULL, 'G3DSA:3.30.450.20:FF:000258', NULL, NULL, 'SIM bHLH transcription factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(39889, NULL, 'G3DSA:3.90.1210.10:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39890, NULL, 'G3DSA:2.60.40.1730:FF:000060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39891, NULL, 'G3DSA:1.10.189.10:FF:000002', NULL, NULL, 'Pyruvate, phosphate dikinase', NULL, NULL, NULL, NULL, NULL, 4),
(39892, NULL, 'G3DSA:3.40.50.300:FF:002423', NULL, NULL, 'Cobalt ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(39893, NULL, 'G3DSA:3.40.1350.10:FF:000014', NULL, NULL, 'tRNA intron endonuclease putative', NULL, NULL, NULL, NULL, NULL, 4),
(39894, NULL, 'G3DSA:1.10.630.10:FF:000192', NULL, NULL, 'Cytochrome P450 monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39895, NULL, 'G3DSA:3.40.50.2000:FF:000779', NULL, NULL, 'Glycosyltransferase-like domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(39896, NULL, 'G3DSA:3.40.449.10:FF:000002', NULL, NULL, 'Phosphoenolpyruvate carboxykinase [ATP]', NULL, NULL, NULL, NULL, NULL, 4),
(39897, NULL, 'G3DSA:1.10.287.470:FF:000031', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(39898, NULL, 'G3DSA:3.30.230.80:FF:000012', NULL, NULL, 'Cation-transporting ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39899, NULL, 'G3DSA:3.90.228.10:FF:000051', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(39900, NULL, 'G3DSA:1.10.3720.10:FF:000113', NULL, NULL, 'ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(39901, NULL, 'G3DSA:3.30.160.60:FF:005733', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39902, NULL, 'G3DSA:3.30.9.10:FF:000253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39903, NULL, 'G3DSA:4.10.1080.10:FF:000016', NULL, NULL, 'AAA ATPase containing von Willebrand factor type A (VWA) domain', NULL, NULL, NULL, NULL, NULL, 4),
(39904, NULL, 'G3DSA:3.40.50.450:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39905, NULL, 'G3DSA:2.30.29.30:FF:001240', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(39906, NULL, 'G3DSA:2.60.120.780:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39907, NULL, 'G3DSA:2.60.40.1730:FF:000104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39908, NULL, 'G3DSA:3.40.50.360:FF:000047', NULL, NULL, 'NADPH-cytochrome p450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(39909, NULL, 'G3DSA:1.20.5.110:FF:000080', NULL, NULL, 'Synaptosomal-associated protein 47', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(39910, NULL, 'G3DSA:1.25.10.10:FF:001280', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(39911, NULL, 'G3DSA:2.130.10.10:FF:002974', NULL, NULL, 'Dynein axonemal intermediate chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(39912, NULL, 'G3DSA:1.20.5.170:FF:000165', NULL, NULL, 'Pachytene arrest protein SAE3', NULL, NULL, NULL, NULL, NULL, 4),
(39913, NULL, 'G3DSA:2.60.120.200:FF:000657', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39914, NULL, 'G3DSA:3.30.1380.20:FF:000021', NULL, NULL, 'TRansport Protein Particle', NULL, NULL, NULL, NULL, NULL, 4),
(39915, NULL, 'G3DSA:3.30.30.30:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39916, NULL, 'G3DSA:1.20.1420.40:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39917, NULL, 'G3DSA:1.10.10.10:FF:001009', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(39918, NULL, 'G3DSA:3.30.70.270:FF:000318', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39919, NULL, 'G3DSA:1.10.8.1220:FF:000014', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39920, NULL, 'G3DSA:2.30.30.40:FF:000206', NULL, NULL, 'GRB2-related adapter protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(39921, NULL, 'G3DSA:3.40.50.300:FF:003525', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(39922, NULL, 'G3DSA:2.60.220.30:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39923, NULL, 'G3DSA:3.80.10.10:FF:000344', NULL, NULL, 'Dynein assembly factor 1, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(39924, NULL, 'G3DSA:2.170.220.10:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39925, NULL, 'G3DSA:2.30.39.10:FF:000004', NULL, NULL, 'Serpin peptidase inhibitor, clade H, member 1', NULL, NULL, NULL, NULL, NULL, 4),
(39926, NULL, 'G3DSA:1.25.40.10:FF:001298', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(39927, NULL, 'G3DSA:1.10.720.30:FF:000058', NULL, NULL, 'DSB repair complex subunit Ku70, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39928, NULL, 'G3DSA:1.20.1270.60:FF:000079', NULL, NULL, 'Transcription factor SipA3', NULL, NULL, NULL, NULL, NULL, 4),
(39929, NULL, 'G3DSA:3.60.40.10:FF:000291', NULL, NULL, 'Protein phosphatase 2C 50', NULL, NULL, NULL, NULL, NULL, 4),
(39930, NULL, 'G3DSA:3.30.160.60:FF:001990', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39931, NULL, 'G3DSA:2.10.25.10:FF:000327', NULL, NULL, 'neurogenic locus notch homolog protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(39932, NULL, 'G3DSA:1.25.40.10:FF:001461', NULL, NULL, 'Crooked neck protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(39933, NULL, 'G3DSA:3.40.50.700:FF:000003', NULL, NULL, 'Ni/Fe hydrogenase, small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(39934, NULL, 'G3DSA:1.20.1110.10:FF:000132', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39935, NULL, 'G3DSA:3.40.50.620:FF:000277', NULL, NULL, 'Tyrosyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39936, NULL, 'G3DSA:2.10.80.10:FF:000005', NULL, NULL, 'Colipase', NULL, NULL, NULL, NULL, NULL, 4),
(39937, NULL, 'G3DSA:1.10.1870.10:FF:000017', NULL, NULL, 'Lysine-ketoglutarate reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39938, NULL, 'G3DSA:1.25.40.570:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39939, NULL, 'G3DSA:3.30.160.60:FF:002170', NULL, NULL, 'Zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(39940, NULL, 'G3DSA:3.30.310.10:FF:000071', NULL, NULL, 'Adaptor-related protein complex 2 subunit alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(39941, NULL, 'G3DSA:2.60.120.470:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39942, NULL, 'G3DSA:2.60.40.10:FF:002996', NULL, NULL, 'Bacterial Ig-like domain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(39943, NULL, 'G3DSA:3.80.10.10:FF:004385', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(39944, NULL, 'G3DSA:4.10.1220.10:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39945, NULL, 'G3DSA:3.40.710.10:FF:000155', NULL, NULL, 'Penicillin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(39946, NULL, 'G3DSA:3.30.2020.30:FF:000003', NULL, NULL, 'trimethyllysine dioxygenase, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(39947, NULL, 'G3DSA:3.30.200.20:FF:001038', NULL, NULL, 'PH-protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(39948, NULL, 'G3DSA:3.40.190.80:FF:000051', NULL, NULL, 'Inositol monophosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(39949, NULL, 'G3DSA:3.60.20.10:FF:000109', NULL, NULL, 'Asparagine synthetase B', NULL, NULL, NULL, NULL, NULL, 4),
(39950, NULL, 'G3DSA:3.40.50.1820:FF:000158', NULL, NULL, 'Thymus-specific serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(39951, NULL, 'G3DSA:1.20.1310.10:FF:000113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39952, NULL, 'G3DSA:3.40.50.620:FF:000647', NULL, NULL, 'Cysteine--tRNA ligase 1 cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(39953, NULL, 'G3DSA:3.30.200.20:FF:000919', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39954, NULL, 'G3DSA:1.25.40.20:FF:001464', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39955, NULL, 'G3DSA:1.25.40.10:FF:003243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39956, NULL, 'G3DSA:2.30.30.1020:FF:000016', NULL, NULL, 'NOT-Like (Yeast CCR4/NOT complex component)', NULL, NULL, NULL, NULL, NULL, 4),
(39957, NULL, 'G3DSA:3.30.200.20:FF:001408', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39958, NULL, 'G3DSA:3.40.1190.20:FF:000145', NULL, NULL, 'Fructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(39959, NULL, 'G3DSA:3.10.580.10:FF:000027', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(39960, NULL, 'G3DSA:1.20.58.60:FF:000408', NULL, NULL, 'Spectrin beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(39961, NULL, 'G3DSA:3.40.190.10:FF:000957', NULL, NULL, 'Ionotropic receptor 7e', NULL, NULL, NULL, NULL, NULL, 4),
(39962, NULL, 'G3DSA:3.90.1010.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39963, NULL, 'G3DSA:3.20.20.80:FF:000424', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39964, NULL, 'G3DSA:3.20.20.330:FF:000036', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(39965, NULL, 'G3DSA:2.40.50.1020:FF:000003', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(39966, NULL, 'G3DSA:3.30.70.1230:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39967, NULL, 'G3DSA:2.60.40.60:FF:000341', NULL, NULL, 'FlaMIngo (Cadherin plus 7TM domain) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(39968, NULL, 'G3DSA:3.30.300.30:FF:000149', NULL, NULL, 'Phenylacetate-CoA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39969, NULL, 'G3DSA:2.130.10.10:FF:005245', NULL, NULL, 'CPSF A subunit region family protein', NULL, NULL, NULL, NULL, NULL, 4),
(39970, NULL, 'G3DSA:3.90.1290.10:FF:000020', NULL, NULL, 'Short stop, isoform AA', NULL, NULL, NULL, NULL, NULL, 4),
(39971, NULL, 'G3DSA:3.40.50.800:FF:000033', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(39972, NULL, 'G3DSA:1.25.10.10:FF:002589', NULL, NULL, 'Integrator complex subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(39973, NULL, 'G3DSA:3.90.70.80:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39974, NULL, 'G3DSA:1.25.10.10:FF:003387', NULL, NULL, 'AER049Wp', NULL, NULL, NULL, NULL, NULL, 4),
(39975, NULL, 'G3DSA:3.60.90.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39976, NULL, 'G3DSA:1.10.520.10:FF:000071', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(39977, NULL, 'G3DSA:2.60.220.50:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(39978, NULL, 'G3DSA:2.10.25.10:FF:000344', NULL, NULL, 'FAT atypical cadherin 4', NULL, NULL, NULL, NULL, NULL, 4),
(39979, NULL, 'G3DSA:3.40.50.1820:FF:001310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39980, NULL, 'G3DSA:3.20.20.70:FF:000421', NULL, NULL, 'Xenobiotic reductase B', NULL, NULL, NULL, NULL, NULL, 4),
(39981, NULL, 'G3DSA:1.20.1270.10:FF:000008', NULL, NULL, '78 kDa glucose-regulated protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(39982, NULL, 'G3DSA:3.30.70.330:FF:000477', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein D', NULL, NULL, NULL, NULL, NULL, 4),
(39983, NULL, 'G3DSA:3.40.50.1110:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39984, NULL, 'G3DSA:1.25.40.10:FF:001770', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(39985, NULL, 'G3DSA:1.25.40.20:FF:001773', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39986, NULL, 'G3DSA:3.40.50.1460:FF:000033', NULL, NULL, 'CASP8 and FADD like apoptosis regulator', NULL, NULL, NULL, NULL, NULL, 4),
(39987, NULL, 'G3DSA:1.25.40.450:FF:000003', NULL, NULL, 'Nuclear pore complex protein NUP155', NULL, NULL, NULL, NULL, NULL, 4),
(39988, NULL, 'G3DSA:2.30.33.40:FF:000022', NULL, NULL, 'Chloroplast protein Cpn21 in A-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(39989, NULL, 'G3DSA:3.30.70.330:FF:002377', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(39990, NULL, 'G3DSA:3.40.630.30:FF:000514', NULL, NULL, 'Pre-mRNA-splicing factor cwf24', NULL, NULL, NULL, NULL, NULL, 4),
(39991, NULL, 'G3DSA:3.40.50.300:FF:001608', NULL, NULL, 'Cytidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(39992, NULL, 'G3DSA:3.50.50.60:FF:000469', NULL, NULL, 'FAD/NAD(P)-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(39993, NULL, 'G3DSA:3.40.930.10:FF:000003', NULL, NULL, 'PTS IIA-like nitrogen regulatory protein PtsN', NULL, NULL, NULL, NULL, NULL, 4),
(39994, NULL, 'G3DSA:3.40.50.10730:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39995, NULL, 'G3DSA:2.60.40.1230:FF:000016', NULL, NULL, 'ADP-ribosylation factor-binding protein GGA2', NULL, NULL, NULL, NULL, NULL, 4),
(39996, NULL, 'G3DSA:1.20.990.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(39997, NULL, 'G3DSA:3.50.50.60:FF:001267', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(39998, NULL, 'G3DSA:1.20.1250.20:FF:000437', NULL, NULL, 'Blast:Monocarboxylate transporter 4', NULL, NULL, NULL, NULL, NULL, 4),
(39999, NULL, 'G3DSA:3.40.50.720:FF:000661', NULL, NULL, 'dTDP-4-dehydrorhamnose reductase', NULL, NULL, NULL, NULL, NULL, 4),
(40000, NULL, 'G3DSA:3.30.40.10:FF:001404', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(40001, NULL, 'G3DSA:1.20.890.10:FF:000011', NULL, NULL, 'tubulin polyglutamylase complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(40002, NULL, 'G3DSA:2.60.90.20:FF:000001', NULL, NULL, 'Outer capsid protein sigma-1', NULL, NULL, NULL, NULL, NULL, 4),
(40003, NULL, 'G3DSA:3.90.190.10:FF:000362', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40004, NULL, 'G3DSA:3.20.20.80:FF:000648', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40005, NULL, 'G3DSA:1.10.10.10:FF:001970', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40006, NULL, 'G3DSA:1.25.10.10:FF:001487', NULL, NULL, 'Wings apart-like', NULL, NULL, NULL, NULL, NULL, 4),
(40007, NULL, 'G3DSA:3.80.10.10:FF:002570', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40008, NULL, 'G3DSA:3.20.20.100:FF:000209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40009, NULL, 'G3DSA:2.130.10.10:FF:003345', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40010, NULL, 'G3DSA:3.30.70.330:FF:001275', NULL, NULL, 'U2 snRNP auxiliary factor large subunit, putative', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(40011, NULL, 'G3DSA:3.40.50.10710:FF:000002', NULL, NULL, 'Ribonuclease J 2', NULL, NULL, NULL, NULL, NULL, 4),
(40012, NULL, 'G3DSA:3.40.50.150:FF:001737', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40013, NULL, 'G3DSA:1.25.40.470:FF:000009', NULL, NULL, 'WD repeat-containing protein 19 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(40014, NULL, 'G3DSA:1.20.1260.10:FF:000036', NULL, NULL, 'Catalase, Mn-containing', NULL, NULL, NULL, NULL, NULL, 4),
(40015, NULL, 'G3DSA:4.10.400.10:FF:000314', NULL, NULL, 'LDL receptor protein 1, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(40016, NULL, 'G3DSA:3.30.930.10:FF:000202', NULL, NULL, 'Asparaginyl-tRNA synthetase 2', NULL, NULL, NULL, NULL, NULL, 4),
(40017, NULL, 'G3DSA:3.60.40.10:FF:000335', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40018, NULL, 'G3DSA:2.30.40.10:FF:000058', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(40019, NULL, 'G3DSA:1.20.1070.10:FF:000662', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(40020, NULL, 'G3DSA:3.30.1960.10:FF:000012', NULL, NULL, 'Methyltransferase TYW3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40021, NULL, 'G3DSA:3.30.420.10:FF:000074', NULL, NULL, 'exonuclease mut-7 homolog isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(40022, NULL, 'G3DSA:3.30.160.60:FF:003816', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40023, NULL, 'G3DSA:1.10.10.10:FF:001335', NULL, NULL, '40S ribosomal protein S10', NULL, NULL, NULL, NULL, NULL, 4),
(40024, NULL, 'G3DSA:1.20.1070.10:FF:001988', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40025, NULL, 'G3DSA:3.30.70.330:FF:000932', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(40026, NULL, 'G3DSA:3.30.1360.210:FF:000004', NULL, NULL, '60S ribosomal protein L22', NULL, NULL, NULL, NULL, NULL, 4),
(40027, NULL, 'G3DSA:2.60.120.290:FF:000083', NULL, NULL, 'Suppressor of lurcher protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(40028, NULL, 'G3DSA:3.30.450.20:FF:000584', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40029, NULL, 'G3DSA:3.30.1360.70:FF:000012', NULL, NULL, 'Arginine-tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40030, NULL, 'G3DSA:3.40.50.2000:FF:000881', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40031, NULL, 'G3DSA:3.40.1110.10:FF:000283', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40032, NULL, 'G3DSA:3.40.50.1010:FF:000128', NULL, NULL, 'Nucleic acid binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40033, NULL, 'G3DSA:3.30.1360.220:FF:000007', NULL, NULL, 'Zinc finger, FYVE domain-containing 9b', NULL, NULL, NULL, NULL, NULL, 4),
(40034, NULL, 'G3DSA:1.10.472.80:FF:000131', NULL, NULL, 'Rab GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40035, NULL, 'G3DSA:4.10.240.10:FF:000116', NULL, NULL, 'C2H2 transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40036, NULL, 'G3DSA:3.30.470.20:FF:000158', NULL, NULL, 'Glutathione synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40037, NULL, 'G3DSA:2.40.160.120:FF:000016', NULL, NULL, 'Oxysterol binding protein (Orp8), putative', NULL, NULL, NULL, NULL, NULL, 4),
(40038, NULL, 'G3DSA:3.30.200.20:FF:001381', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40039, NULL, 'G3DSA:1.20.1270.60:FF:000063', NULL, NULL, 'Rho GTPase activator', NULL, NULL, NULL, NULL, NULL, 4),
(40040, NULL, 'G3DSA:3.40.640.10:FF:000110', NULL, NULL, 'Aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(40041, NULL, 'G3DSA:3.30.2130.30:FF:000006', NULL, NULL, 'Probable tRNA sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(40042, NULL, 'G3DSA:3.30.365.10:FF:000006', NULL, NULL, 'xanthine dehydrogenase/oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(40043, NULL, 'G3DSA:1.10.168.20:FF:000001', NULL, NULL, '40S ribosomal protein S8', NULL, NULL, NULL, NULL, NULL, 4),
(40044, NULL, 'G3DSA:3.40.50.10490:FF:000127', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(40045, NULL, 'G3DSA:1.10.555.10:FF:000224', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40046, NULL, 'G3DSA:2.60.40.10:FF:001922', NULL, NULL, 'KETtiN (Drosophila actin-binding) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(40047, NULL, 'G3DSA:3.40.30.10:FF:000217', NULL, NULL, 'Glutaredoxin-C5 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(40048, NULL, 'G3DSA:2.60.40.10:FF:003693', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40049, NULL, 'G3DSA:3.40.33.10:FF:000016', NULL, NULL, 'Golgi-associated plant pathogenesis-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(40050, NULL, 'G3DSA:4.10.80.70:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40051, NULL, 'G3DSA:3.30.1490.180:FF:000035', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(40052, NULL, 'G3DSA:3.30.160.60:FF:003255', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40053, NULL, 'G3DSA:3.30.40.10:FF:000887', NULL, NULL, 'Unplaced genomic scaffold supercont2.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(40054, NULL, 'G3DSA:3.30.40.10:FF:000606', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(40055, NULL, 'G3DSA:3.30.40.10:FF:000578', NULL, NULL, 'E3 ubiquitin-protein ligase CHFR', NULL, NULL, NULL, NULL, NULL, 4),
(40056, NULL, 'G3DSA:1.20.1560.10:FF:000109', NULL, NULL, 'Alkaline protease secretion ATP-binding protein aprD', NULL, NULL, NULL, NULL, NULL, 4),
(40057, NULL, 'G3DSA:3.30.160.60:FF:001647', NULL, NULL, 'Zinc finger protein 596', NULL, NULL, NULL, NULL, NULL, 4),
(40058, NULL, 'G3DSA:3.30.160.60:FF:001338', NULL, NULL, 'Zinc finger and BTB domain-containing protein 49', NULL, NULL, NULL, NULL, NULL, 4),
(40059, NULL, 'G3DSA:2.60.40.150:FF:000301', NULL, NULL, 'Tcb3p', NULL, NULL, NULL, NULL, NULL, 4),
(40060, NULL, 'G3DSA:3.30.479.20:FF:000032', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(40061, NULL, 'G3DSA:3.20.20.70:FF:000319', NULL, NULL, 'Dihydroorotate dehydrogenase (quinone)', NULL, NULL, NULL, NULL, NULL, 4),
(40062, NULL, 'G3DSA:3.40.50.450:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40063, NULL, 'G3DSA:3.30.160.60:FF:005716', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40064, NULL, 'G3DSA:3.40.390.10:FF:000259', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40065, NULL, 'G3DSA:3.40.50.2300:FF:001235', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40066, NULL, 'G3DSA:2.10.25.10:FF:001142', NULL, NULL, 'Dumpy, isoform V', NULL, NULL, NULL, NULL, NULL, 4),
(40067, NULL, 'G3DSA:3.80.10.10:FF:000670', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM1', NULL, NULL, NULL, NULL, NULL, 4),
(40068, NULL, 'G3DSA:3.40.50.720:FF:001133', NULL, NULL, 'NADP-dependent alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(40069, NULL, 'G3DSA:1.50.40.10:FF:000424', NULL, NULL, 'Putative envelope ADPATP carrier protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(40070, NULL, 'G3DSA:1.20.120.1080:FF:000005', NULL, NULL, 'ATP-dependent helicase HrpA', NULL, NULL, NULL, NULL, NULL, 4),
(40071, NULL, 'G3DSA:2.60.40.790:FF:000111', NULL, NULL, 'Cysteine and histidine-rich domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(40072, NULL, 'G3DSA:1.25.40.20:FF:000036', NULL, NULL, 'protein TANC2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(40073, NULL, 'G3DSA:1.25.10.10:FF:001633', NULL, NULL, 'YALI0B03014p', NULL, NULL, NULL, NULL, NULL, 4),
(40074, NULL, 'G3DSA:1.10.8.1220:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40075, NULL, 'G3DSA:2.30.30.140:FF:000253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40076, NULL, 'G3DSA:2.10.25.10:FF:000670', NULL, NULL, 'Stabilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(40077, NULL, 'G3DSA:2.40.170.20:FF:000030', NULL, NULL, 'Outer membrane cobalamin receptor protein', NULL, NULL, NULL, NULL, NULL, 4),
(40078, NULL, 'G3DSA:1.10.510.10:FF:003824', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(40079, NULL, 'G3DSA:3.90.180.10:FF:000108', NULL, NULL, 'Zinc-binding oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40080, NULL, 'G3DSA:3.90.70.10:FF:000212', NULL, NULL, 'Cathepsin L-like protease', NULL, NULL, NULL, NULL, NULL, 4),
(40081, NULL, 'G3DSA:2.60.40.10:FF:003822', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40082, NULL, 'G3DSA:1.20.5.110:FF:000315', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40083, NULL, 'G3DSA:2.60.120.10:FF:000429', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(40084, NULL, 'G3DSA:2.60.120.10:FF:000093', NULL, NULL, '3-hydroxyanthranilate 3,4-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(40085, NULL, 'G3DSA:3.30.70.100:FF:000054', NULL, NULL, 'Acylphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(40086, NULL, 'G3DSA:3.20.20.60:FF:000081', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(40087, NULL, 'G3DSA:1.10.720.30:FF:000075', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(40088, NULL, 'G3DSA:3.20.20.70:FF:000084', NULL, NULL, 'Ferredoxin-dependent glutamate synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(40089, NULL, 'G3DSA:3.50.50.60:FF:001312', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40090, NULL, 'G3DSA:1.20.120.1070:FF:000002', NULL, NULL, 'Translation initiation factor eIF-2B subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(40091, NULL, 'G3DSA:1.10.8.720:FF:000051', NULL, NULL, 'Dynein-1-beta heavy chain, flagellar inner arm I1 complex', NULL, NULL, NULL, NULL, NULL, 4),
(40092, NULL, 'G3DSA:1.20.120.1910:FF:000046', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(40093, NULL, 'G3DSA:3.20.20.80:FF:000750', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40094, NULL, 'G3DSA:1.10.1420.10:FF:000101', NULL, NULL, 'DNA mismatch repair mutS protein', NULL, NULL, NULL, NULL, NULL, 4),
(40095, NULL, 'G3DSA:1.10.10.10:FF:001661', NULL, NULL, 'Flocculation suppression protein (AFU_orthologue AFUA_4G04502)', NULL, NULL, NULL, NULL, NULL, 4),
(40096, NULL, 'G3DSA:1.25.40.10:FF:005058', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(40097, NULL, 'G3DSA:3.30.70.340:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40098, NULL, 'G3DSA:3.40.50.2000:FF:000555', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(40099, NULL, 'G3DSA:3.30.310.230:FF:000002', NULL, NULL, 'Sigma factor-binding protein Crl', NULL, NULL, NULL, NULL, NULL, 4),
(40100, NULL, 'G3DSA:1.10.555.10:FF:000241', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40101, NULL, 'G3DSA:2.40.50.140:FF:001154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40102, NULL, 'G3DSA:3.30.160.60:FF:001355', NULL, NULL, 'zinc finger protein 334', NULL, NULL, NULL, NULL, NULL, 4),
(40103, NULL, 'G3DSA:1.25.40.10:FF:001444', NULL, NULL, 'Pentatricopeptide repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(40104, NULL, 'G3DSA:3.30.160.60:FF:002153', NULL, NULL, 'Zinc finger protein 30', NULL, NULL, NULL, NULL, NULL, 4),
(40105, NULL, 'G3DSA:3.30.60.30:FF:000001', NULL, NULL, 'Serine peptidase inhibitor, Kazal type 5', NULL, NULL, NULL, NULL, NULL, 4),
(40106, NULL, 'G3DSA:3.40.50.150:FF:001872', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40107, NULL, 'G3DSA:3.30.457.60:FF:000021', NULL, NULL, 'Spindle assembly checkpoint component mad1', NULL, NULL, NULL, NULL, NULL, 4),
(40108, NULL, 'G3DSA:3.30.200.20:FF:001055', NULL, NULL, 'Serine/threonine-protein kinase MRCK beta', NULL, NULL, NULL, NULL, NULL, 4),
(40109, NULL, 'G3DSA:2.180.10.10:FF:000021', NULL, NULL, 'Teneurin transmembrane protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(40110, NULL, 'G3DSA:3.80.10.10:FF:004368', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40111, NULL, 'G3DSA:3.60.40.10:FF:000318', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(40112, NULL, 'G3DSA:4.10.280.10:FF:000181', NULL, NULL, 'Hairy enhancer of split', NULL, NULL, NULL, NULL, NULL, 4),
(40113, NULL, 'G3DSA:3.30.70.360:FF:000019', NULL, NULL, 'Allantoate deiminase', NULL, NULL, NULL, NULL, NULL, 4),
(40114, NULL, 'G3DSA:2.60.40.10:FF:005593', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40115, NULL, 'G3DSA:1.10.150.50:FF:000161', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase', NULL, NULL, NULL, NULL, NULL, 4),
(40116, NULL, 'G3DSA:1.25.40.20:FF:001447', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40117, NULL, 'G3DSA:3.40.50.620:FF:000294', NULL, NULL, 'Phosphopantetheine adenylyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40118, NULL, 'G3DSA:1.10.3810.10:FF:000025', NULL, NULL, 'Penicillin-binding protein 1C (PBP-1c)', NULL, NULL, NULL, NULL, NULL, 4),
(40119, NULL, 'G3DSA:3.20.20.140:FF:000423', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40120, NULL, 'G3DSA:3.20.20.80:FF:000441', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40121, NULL, 'G3DSA:3.40.50.740:FF:000054', NULL, NULL, 'Bll5478 protein', NULL, NULL, NULL, NULL, NULL, 4),
(40122, NULL, 'G3DSA:3.40.1190.20:FF:000162', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(40123, NULL, 'G3DSA:2.60.40.10:FF:001568', NULL, NULL, 'Ribonuclease E/G-like protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(40124, NULL, 'G3DSA:2.60.40.350:FF:000002', NULL, NULL, 'Structural polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(40125, NULL, 'G3DSA:1.25.40.10:FF:003905', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40126, NULL, 'G3DSA:3.30.160.60:FF:000253', NULL, NULL, 'Crooked legs, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(40127, NULL, 'G3DSA:3.30.40.10:FF:000932', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40128, NULL, 'G3DSA:3.40.720.10:FF:000318', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40129, NULL, 'G3DSA:3.30.40.10:FF:001730', NULL, NULL, 'E3 ubiquitin-protein ligase PRT1', NULL, NULL, NULL, NULL, NULL, 4),
(40130, NULL, 'G3DSA:1.10.3500.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40131, NULL, 'G3DSA:2.160.20.80:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40132, NULL, 'G3DSA:2.20.110.10:FF:000045', NULL, NULL, 'MORN repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40133, NULL, 'G3DSA:3.90.550.10:FF:000232', NULL, NULL, 'Glycosyl transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(40134, NULL, 'G3DSA:1.20.1250.20:FF:001460', NULL, NULL, 'Myo-inositol/proton symporter (MIT)', NULL, NULL, NULL, NULL, NULL, 4),
(40135, NULL, 'G3DSA:3.30.300.30:FF:000166', NULL, NULL, 'Putative non-ribosomal peptide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(40136, NULL, 'G3DSA:3.40.50.20:FF:000076', NULL, NULL, 'D-alanine--D-alanine ligase A', NULL, NULL, NULL, NULL, NULL, 4),
(40137, NULL, 'G3DSA:3.30.1120.10:FF:000027', NULL, NULL, 'Arylsulfatase A', NULL, NULL, NULL, NULL, NULL, 4),
(40138, NULL, 'G3DSA:3.40.720.10:FF:000066', NULL, NULL, 'Non-specific phospholipase C6', NULL, NULL, NULL, NULL, NULL, 4),
(40139, NULL, 'G3DSA:1.25.40.20:FF:000345', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(40140, NULL, 'G3DSA:1.25.10.10:FF:001942', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(40141, NULL, 'G3DSA:1.20.120.350:FF:000021', NULL, NULL, 'Potassium voltage-gated channel subfamily A member 3', NULL, NULL, NULL, NULL, NULL, 4),
(40142, NULL, 'G3DSA:2.40.10.480:FF:000005', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(40143, NULL, 'G3DSA:2.130.10.10:FF:003019', NULL, NULL, 'ATG16/SAP18/CVT11/APG16, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40144, NULL, 'G3DSA:1.10.860.10:FF:000028', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(40145, NULL, 'G3DSA:2.60.40.10:FF:004795', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(40146, NULL, 'G3DSA:3.40.50.300:FF:000506', NULL, NULL, 'transcriptional regulator ATRX isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(40147, NULL, 'G3DSA:3.60.40.10:FF:000009', NULL, NULL, 'Blast:Protein phosphatase PTC7 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(40148, NULL, 'G3DSA:1.20.58.60:FF:000717', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40149, NULL, 'G3DSA:3.40.50.1820:FF:001181', NULL, NULL, 'Clan SC, family S28, unassigned serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(40150, NULL, 'G3DSA:1.10.246.140:FF:000013', NULL, NULL, 'Transcription and mRNA export factor sus1', NULL, NULL, NULL, NULL, NULL, 4),
(40151, NULL, 'G3DSA:2.130.10.10:FF:003328', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40152, NULL, 'G3DSA:3.10.450.540:FF:000001', NULL, NULL, 'ORF13-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(40153, NULL, 'G3DSA:3.80.10.10:FF:001979', NULL, NULL, 'Matrix remodeling associated 5', NULL, NULL, NULL, NULL, NULL, 4),
(40154, NULL, 'G3DSA:3.30.40.10:FF:001421', NULL, NULL, 'General transcription factor IIE subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(40155, NULL, 'G3DSA:3.10.105.10:FF:000109', NULL, NULL, 'Amino acid ABC transporter, periplasmic amino acid-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(40156, NULL, 'G3DSA:3.40.1350.10:FF:000031', NULL, NULL, 'tRNA-splicing endonuclease subunit Sen2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40157, NULL, 'G3DSA:3.80.10.10:FF:002777', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40158, NULL, 'G3DSA:3.30.160.20:FF:000174', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(40159, NULL, 'G3DSA:3.90.228.10:FF:000034', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(40160, NULL, 'G3DSA:3.80.10.10:FF:002468', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40161, NULL, 'G3DSA:1.10.287.70:FF:000624', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(40162, NULL, 'G3DSA:1.20.1250.10:FF:000108', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40163, NULL, 'G3DSA:1.10.246.130:FF:000010', NULL, NULL, 'Gamma-glutamyltranspeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(40164, NULL, 'G3DSA:3.30.70.330:FF:001292', NULL, NULL, 'Nuclear transport factor 2 (NTF2) family protein with RNA binding (RRM-RBD-RNP motifs) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(40165, NULL, 'G3DSA:3.30.40.100:FF:000008', NULL, NULL, 'Methyl-CpG-binding domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(40166, NULL, 'G3DSA:3.40.718.10:FF:000049', NULL, NULL, 'Isocitrate dehydrogenase 3 (NAD+) alpha', NULL, NULL, NULL, NULL, NULL, 4),
(40167, NULL, 'G3DSA:3.90.850.10:FF:000036', NULL, NULL, '2-hydroxyhexa-2,4-dienoate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(40168, NULL, 'G3DSA:3.30.160.60:FF:005380', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40169, NULL, 'G3DSA:2.30.30.100:FF:000174', NULL, NULL, 'U2 small nuclear ribonucleoprotein 16.5K', NULL, NULL, NULL, NULL, NULL, 4),
(40170, NULL, 'G3DSA:1.25.40.180:FF:000063', NULL, NULL, 'Unplaced genomic scaffold supercont1.20, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(40171, NULL, 'G3DSA:2.40.50.120:FF:000024', NULL, NULL, 'Putative metalloproteinase inhibitor tag-225', NULL, NULL, NULL, NULL, NULL, 4),
(40172, NULL, 'G3DSA:2.60.120.10:FF:000121', NULL, NULL, 'HTH-type transcriptional regulator ArcR', NULL, NULL, NULL, NULL, NULL, 4),
(40173, NULL, 'G3DSA:1.10.510.10:FF:003454', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40174, NULL, 'G3DSA:1.25.40.10:FF:004878', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g62590', NULL, NULL, NULL, NULL, NULL, 4),
(40175, NULL, 'G3DSA:3.80.10.10:FF:000299', NULL, NULL, 'Piriformospora indica-insensitive protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(40176, NULL, 'G3DSA:2.160.20.70:FF:000006', NULL, NULL, 'Adenylyl cyclase-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(40177, NULL, 'G3DSA:2.160.20.80:FF:000009', NULL, NULL, 'NifU-like N-terminal domain protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(40178, NULL, 'G3DSA:2.30.29.30:FF:000588', NULL, NULL, 'SHC-transforming protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(40179, NULL, 'G3DSA:3.20.19.10:FF:000001', NULL, NULL, 'Aconitate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(40180, NULL, 'G3DSA:3.30.300.20:FF:000028', NULL, NULL, 'GTPase Der', NULL, NULL, NULL, NULL, NULL, 4),
(40181, NULL, 'G3DSA:3.30.420.10:FF:000091', NULL, NULL, 'Protein argonaute 3', NULL, NULL, NULL, NULL, NULL, 4),
(40182, NULL, 'G3DSA:1.20.5.110:FF:000063', NULL, NULL, 'Synaptobrevin 1', NULL, NULL, NULL, NULL, NULL, 4),
(40183, NULL, 'G3DSA:3.30.830.10:FF:000110', NULL, NULL, 'Peptidase, insulinase family', NULL, NULL, NULL, NULL, NULL, 4),
(40184, NULL, 'G3DSA:3.30.30.30:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40185, NULL, 'G3DSA:2.10.25.10:FF:000462', NULL, NULL, 'Adhesion G protein-coupled receptor E1', NULL, NULL, NULL, NULL, NULL, 4),
(40186, NULL, 'G3DSA:2.10.70.10:FF:000050', NULL, NULL, 'sushi domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(40187, NULL, 'G3DSA:3.40.50.10420:FF:000005', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(40188, NULL, 'G3DSA:1.20.5.110:FF:000107', NULL, NULL, 'Vesicle-associated membrane protein 7B', NULL, NULL, NULL, NULL, NULL, 4),
(40189, NULL, 'G3DSA:3.40.50.720:FF:000189', NULL, NULL, 'Bifunctional protein FolD', NULL, NULL, NULL, NULL, NULL, 4),
(40190, NULL, 'G3DSA:3.30.300.10:FF:000025', NULL, NULL, 'S-adenosylmethionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(40191, NULL, 'G3DSA:2.10.110.10:FF:000098', NULL, NULL, 'Uncoordinated 115a, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(40192, NULL, 'G3DSA:2.60.40.10:FF:001361', NULL, NULL, 'T-cell surface glycoprotein CD3 delta chain', NULL, NULL, NULL, NULL, NULL, 4),
(40193, NULL, 'G3DSA:3.60.21.60:FF:000042', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(40194, NULL, 'G3DSA:3.30.200.20:FF:001510', NULL, NULL, 'Cell adhesion-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(40195, NULL, 'G3DSA:2.60.120.290:FF:000066', NULL, NULL, 'AGAP006059-PA', NULL, NULL, NULL, NULL, NULL, 4),
(40196, NULL, 'G3DSA:1.10.533.10:FF:000151', NULL, NULL, 'Viral CASP8 and FADD-like apoptosis regulator', NULL, NULL, NULL, NULL, NULL, 4),
(40197, NULL, 'G3DSA:3.30.200.20:FF:000892', NULL, NULL, 'Blast:Mitogen-activated protein kinase kinase kinase 7', NULL, NULL, NULL, NULL, NULL, 4),
(40198, NULL, 'G3DSA:3.40.30.10:FF:000335', NULL, NULL, 'Glutaredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(40199, NULL, 'G3DSA:3.40.50.300:FF:001726', NULL, NULL, 'Multidrug resistance-associated protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(40200, NULL, 'G3DSA:3.10.250.10:FF:000042', NULL, NULL, 'Lysyl oxidase-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(40201, NULL, 'G3DSA:3.40.50.300:FF:003379', NULL, NULL, 'Regulator of nonsense transcripts putative', NULL, NULL, NULL, NULL, NULL, 4),
(40202, NULL, 'G3DSA:1.25.10.10:FF:001178', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(40203, NULL, 'G3DSA:3.10.50.40:FF:000083', NULL, NULL, 'Rhodanese-like/PpiC domain-containing protein 12, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(40204, NULL, 'G3DSA:3.40.710.10:FF:000138', NULL, NULL, 'Putative penicillin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(40205, NULL, 'G3DSA:3.40.630.30:FF:000632', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40206, NULL, 'G3DSA:3.10.120.10:FF:000004', NULL, NULL, 'Acyl-CoA desaturase', NULL, NULL, NULL, NULL, NULL, 4),
(40207, NULL, 'G3DSA:1.20.1460.10:FF:000017', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(40208, NULL, 'G3DSA:3.40.50.1820:FF:000719', NULL, NULL, 'Serine carboxypeptidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(40209, NULL, 'G3DSA:3.90.190.10:FF:000053', NULL, NULL, 'Phosphatidylinositol 3,4,5-trisphosphate 3-phosphatase TPTE2', NULL, NULL, NULL, NULL, NULL, 4),
(40210, NULL, 'G3DSA:2.130.10.10:FF:001855', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(40211, NULL, 'G3DSA:3.90.228.10:FF:000017', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(40212, NULL, 'G3DSA:3.40.50.2020:FF:000173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40213, NULL, 'G3DSA:2.60.40.10:FF:002979', NULL, NULL, 'Bacterial group 1 Ig-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(40214, NULL, 'G3DSA:2.10.80.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40215, NULL, 'G3DSA:1.25.40.10:FF:003260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40216, NULL, 'G3DSA:3.40.50.200:FF:000050', NULL, NULL, 'Surface layer-associated STABLE protease, conjectural', NULL, NULL, NULL, NULL, NULL, 4),
(40217, NULL, 'G3DSA:1.10.1900.10:FF:000003', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(40218, NULL, 'G3DSA:1.10.630.10:FF:000427', NULL, NULL, 'Putative cytochrome P450 superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(40219, NULL, 'G3DSA:3.10.20.90:FF:000601', NULL, NULL, 'Nuclear protein localization protein 4, variant', NULL, NULL, NULL, NULL, NULL, 4),
(40220, NULL, 'G3DSA:2.30.29.30:FF:001206', NULL, NULL, 'Collagen, type IV, alpha 3 (Goodpasture antigen)-binding protein b', NULL, NULL, NULL, NULL, NULL, 4),
(40221, NULL, 'G3DSA:1.10.840.10:FF:000027', NULL, NULL, 'Ras family guanine nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(40222, NULL, 'G3DSA:2.30.30.1020:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40223, NULL, 'G3DSA:3.40.390.10:FF:000276', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40224, NULL, 'G3DSA:1.10.1900.20:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40225, NULL, 'G3DSA:3.30.160.60:FF:005587', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40226, NULL, 'G3DSA:2.60.120.200:FF:000674', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(40227, NULL, 'G3DSA:2.130.10.10:FF:001428', NULL, NULL, 'Autophagy-related protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(40228, NULL, 'G3DSA:3.40.30.10:FF:000291', NULL, NULL, 'DnaJ protein ERDJ3A', NULL, NULL, NULL, NULL, NULL, 4),
(40229, NULL, 'G3DSA:2.40.50.400:FF:000001', NULL, NULL, 'SSB protein', NULL, NULL, NULL, NULL, NULL, 4),
(40230, NULL, 'G3DSA:3.30.70.1230:FF:000253', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(40231, NULL, 'G3DSA:1.25.40.10:FF:004979', NULL, NULL, 'Pentatricopeptide repeat-containing protein103', NULL, NULL, NULL, NULL, NULL, 4),
(40232, NULL, 'G3DSA:3.90.640.10:FF:000099', NULL, NULL, 'Heat shock protein 70 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(40233, NULL, 'G3DSA:1.10.405.10:FF:000011', NULL, NULL, 'Rab GDP dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(40234, NULL, 'G3DSA:3.40.50.720:FF:000868', NULL, NULL, 'Cell-cell signaling protein C-factor', NULL, NULL, NULL, NULL, NULL, 4),
(40235, NULL, 'G3DSA:3.30.160.60:FF:003934', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40236, NULL, 'G3DSA:3.30.160.60:FF:005172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40237, NULL, 'G3DSA:3.90.70.10:FF:000021', NULL, NULL, 'Bleomycin hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(40238, NULL, 'G3DSA:1.10.287.110:FF:000052', NULL, NULL, 'Chaperone protein DNAj, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40239, NULL, 'G3DSA:2.130.10.10:FF:005806', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40240, NULL, 'G3DSA:1.25.40.10:FF:001118', NULL, NULL, 'Type IV pilus biogenesis/stability protein PilW', NULL, NULL, NULL, NULL, NULL, 4),
(40241, NULL, 'G3DSA:1.10.287.130:FF:000058', NULL, NULL, 'Histidine phosphotransferase ChpT', NULL, NULL, NULL, NULL, NULL, 4),
(40242, NULL, 'G3DSA:1.10.800.10:FF:000019', NULL, NULL, 'Tyrosine/tryptophan monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40243, NULL, 'G3DSA:2.30.29.30:FF:001105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40244, NULL, 'G3DSA:1.20.1250.20:FF:000746', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(40245, NULL, 'G3DSA:3.20.20.70:FF:000404', NULL, NULL, 'Proline 2-methylase for pyrrolysine biosynthesis', NULL, NULL, NULL, NULL, NULL, 4),
(40246, NULL, 'G3DSA:2.60.40.10:FF:005475', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40247, NULL, 'G3DSA:3.10.20.90:FF:000500', NULL, NULL, 'bolA-like protein DDB_G0274169', NULL, NULL, NULL, NULL, NULL, 4),
(40248, NULL, 'G3DSA:2.20.28.10:FF:000035', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(40249, NULL, 'G3DSA:3.90.1470.20:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40250, NULL, 'G3DSA:1.20.1280.50:FF:000150', NULL, NULL, 'F-box/kelch-repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(40251, NULL, 'G3DSA:3.40.470.10:FF:000001', NULL, NULL, 'Uracil-DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(40252, NULL, 'G3DSA:1.10.1200.10:FF:000074', NULL, NULL, 'Aspergillus niger contig An11c0010, genomic contig', NULL, NULL, NULL, NULL, NULL, 4),
(40253, NULL, 'G3DSA:3.30.160.60:FF:005688', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40254, NULL, 'G3DSA:3.50.50.80:FF:000008', NULL, NULL, 'Ubiquitin-activating enzyme e1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40255, NULL, 'G3DSA:2.30.180.10:FF:000120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40256, NULL, 'G3DSA:3.30.70.330:FF:002938', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40257, NULL, 'G3DSA:3.30.1490.20:FF:000024', NULL, NULL, 'Ribosomal protein S6 modification enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(40258, NULL, 'G3DSA:1.10.150.50:FF:000144', NULL, NULL, 'GD15078', NULL, NULL, NULL, NULL, NULL, 4),
(40259, NULL, 'G3DSA:3.40.50.300:FF:008600', NULL, NULL, 'AGAP003241-PA', NULL, NULL, NULL, NULL, NULL, 4),
(40260, NULL, 'G3DSA:3.40.50.300:FF:002440', NULL, NULL, 'Drug efflux ABC transporter, ATP-binding/permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(40261, NULL, 'G3DSA:2.40.50.140:FF:001171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40262, NULL, 'G3DSA:3.40.630.30:FF:000531', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40263, NULL, 'G3DSA:3.30.450.20:FF:000275', NULL, NULL, 'C4-dicarboxylate transport sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(40264, NULL, 'G3DSA:2.130.10.10:FF:001754', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(40265, NULL, 'G3DSA:3.40.50.1100:FF:000021', NULL, NULL, 'D-serine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(40266, NULL, 'G3DSA:1.20.1270.60:FF:000181', NULL, NULL, 'Vacuolar protein sorting-associated protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(40267, NULL, 'G3DSA:3.90.1480.20:FF:000032', NULL, NULL, 'ST3 beta-galactoside alpha-2,3-sialyltransferase 6', NULL, NULL, NULL, NULL, NULL, 4),
(40268, NULL, 'G3DSA:3.40.50.2000:FF:001061', NULL, NULL, 'Os07g0243000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(40269, NULL, 'G3DSA:1.10.630.10:FF:000753', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40270, NULL, 'G3DSA:2.40.30.10:FF:000141', NULL, NULL, 'Sporozoite surface antigen MB2', NULL, NULL, NULL, NULL, NULL, 4),
(40271, NULL, 'G3DSA:2.30.30.140:FF:000045', NULL, NULL, 'tudor domain-containing protein 7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(40272, NULL, 'G3DSA:3.40.1620.10:FF:000007', NULL, NULL, 'Antitoxin', NULL, NULL, NULL, NULL, NULL, 4),
(40273, NULL, 'G3DSA:2.60.40.10:FF:001776', NULL, NULL, 'Protein-tyrosine-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(40274, NULL, 'G3DSA:1.25.40.570:FF:000039', NULL, NULL, '26S proteasome regulatory complex component', NULL, NULL, NULL, NULL, NULL, 4),
(40275, NULL, 'G3DSA:3.80.10.10:FF:001024', NULL, NULL, 'Si:ch211-11p18.6', NULL, NULL, NULL, NULL, NULL, 4),
(40276, NULL, 'G3DSA:3.90.550.10:FF:000024', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(40277, NULL, 'G3DSA:3.90.550.20:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40278, NULL, 'G3DSA:3.40.50.150:FF:001754', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(40279, NULL, 'G3DSA:1.10.510.10:FF:001099', NULL, NULL, 'PEK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(40280, NULL, 'G3DSA:3.30.160.60:FF:006205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40281, NULL, 'G3DSA:1.10.238.10:FF:001292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40282, NULL, 'G3DSA:2.40.10.10:FF:000241', NULL, NULL, 'Haptoglobin', NULL, NULL, NULL, NULL, NULL, 4),
(40283, NULL, 'G3DSA:3.30.70.330:FF:002686', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40284, NULL, 'G3DSA:3.40.50.11890:FF:000002', NULL, NULL, '(R)-2-hydroxyisocaproyl-CoA dehydratase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(40285, NULL, 'G3DSA:1.10.510.10:FF:003706', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40286, NULL, 'G3DSA:3.60.110.10:FF:000066', NULL, NULL, 'Amidase', NULL, NULL, NULL, NULL, NULL, 4),
(40287, NULL, 'G3DSA:3.30.70.330:FF:003091', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40288, NULL, 'G3DSA:1.25.40.1040:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40289, NULL, 'G3DSA:1.10.3500.10:FF:000024', NULL, NULL, 'Transcription elongation factor Spt6', NULL, NULL, NULL, NULL, NULL, 4),
(40290, NULL, 'G3DSA:1.25.40.470:FF:000043', NULL, NULL, 'Intraflagellar transport protein 172, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40291, NULL, 'G3DSA:2.20.110.10:FF:000028', NULL, NULL, 'Phosphatidylinositol 4-phosphate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(40292, NULL, 'G3DSA:3.40.50.20:FF:000093', NULL, NULL, 'Protein CBR-SNN-1', NULL, NULL, NULL, NULL, NULL, 4),
(40293, NULL, 'G3DSA:1.10.150.650:FF:000001', NULL, NULL, 'PHP domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(40294, NULL, 'G3DSA:3.40.50.300:FF:005666', NULL, NULL, 'Peroxisome biogenesis factor 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40295, NULL, 'G3DSA:4.10.280.10:FF:000107', NULL, NULL, 'Basic helix-loop-helix transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(40296, NULL, 'G3DSA:1.10.150.670:FF:000007', NULL, NULL, 'Crossover junction endonuclease EME1B', NULL, NULL, NULL, NULL, NULL, 4),
(40297, NULL, 'G3DSA:3.40.800.20:FF:000002', NULL, NULL, 'Histone deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(40298, NULL, 'G3DSA:1.10.287.70:FF:000079', NULL, NULL, 'Inositol 1,4,5-trisphosphate receptor type 3', NULL, NULL, NULL, NULL, NULL, 4),
(40299, NULL, 'G3DSA:2.30.29.30:FF:000852', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40300, NULL, 'G3DSA:3.40.1080.10:FF:000021', NULL, NULL, '4-hydroxybutyrate CoA transferase', NULL, NULL, NULL, NULL, NULL, 4),
(40301, NULL, 'G3DSA:3.40.50.300:FF:001934', NULL, NULL, 'tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(40302, NULL, 'G3DSA:2.60.40.10:FF:005828', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40303, NULL, 'G3DSA:1.25.40.1030:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40304, NULL, 'G3DSA:1.50.40.10:FF:000200', NULL, NULL, 'Mitochondrial carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(40305, NULL, 'G3DSA:3.40.50.720:FF:000559', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(40306, NULL, 'G3DSA:1.20.1270.60:FF:000080', NULL, NULL, 'ADP-ribosylation factor GTPase-activating protein AGD3', NULL, NULL, NULL, NULL, NULL, 4),
(40307, NULL, 'G3DSA:3.30.70.270:FF:000189', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40308, NULL, 'G3DSA:3.40.30.10:FF:000543', NULL, NULL, 'Hematopoietic prostaglandin D synthase', NULL, NULL, NULL, NULL, NULL, 4),
(40309, NULL, 'G3DSA:4.10.280.10:FF:000225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40310, NULL, 'G3DSA:2.60.40.1130:FF:000003', NULL, NULL, 'Protein CBG15026', NULL, NULL, NULL, NULL, NULL, 4),
(40311, NULL, 'G3DSA:1.20.900.10:FF:000047', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(40312, NULL, 'G3DSA:3.60.10.10:FF:000171', NULL, NULL, 'Endonuclease/exonuclease/phosphatase family protein-like', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(40313, NULL, 'G3DSA:3.40.50.1820:FF:000467', NULL, NULL, 'Lipase LipV', NULL, NULL, NULL, NULL, NULL, 4),
(40314, NULL, 'G3DSA:2.30.42.10:FF:000366', NULL, NULL, 'SAM domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(40315, NULL, 'G3DSA:1.10.1300.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40316, NULL, 'G3DSA:3.30.1490.180:FF:000018', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(40317, NULL, 'G3DSA:2.20.25.10:FF:000012', NULL, NULL, 'Putative transcription factor IIIB 90 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(40318, NULL, 'G3DSA:3.40.50.200:FF:000139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40319, NULL, 'G3DSA:2.60.40.10:FF:002602', NULL, NULL, 'Chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(40320, NULL, 'G3DSA:3.30.70.260:FF:000186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40321, NULL, 'G3DSA:1.20.1250.20:FF:001252', NULL, NULL, 'Major facilitator superfamily MFS_1', NULL, NULL, NULL, NULL, NULL, 4),
(40322, NULL, 'G3DSA:1.20.58.60:FF:000852', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40323, NULL, 'G3DSA:3.30.450.40:FF:000022', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(40324, NULL, 'G3DSA:2.30.30.100:FF:000191', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm5', NULL, NULL, NULL, NULL, NULL, 4),
(40325, NULL, 'G3DSA:2.40.40.20:FF:000072', NULL, NULL, 'AAA family ATPase, possible cell division control protein cdc48', NULL, NULL, NULL, NULL, NULL, 4),
(40326, NULL, 'G3DSA:2.80.10.50:FF:000021', NULL, NULL, 'Ryanodine receptor, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(40327, NULL, 'G3DSA:3.40.390.10:FF:000068', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(40328, NULL, 'G3DSA:2.60.120.10:FF:000800', NULL, NULL, 'Cyclic nucleotide-binding', NULL, NULL, NULL, NULL, NULL, 4),
(40329, NULL, 'G3DSA:2.20.25.20:FF:000015', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(40330, NULL, 'G3DSA:3.40.50.300:FF:007875', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40331, NULL, 'G3DSA:3.30.930.10:FF:000056', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(40332, NULL, 'G3DSA:3.30.565.10:FF:000004', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(40333, NULL, 'G3DSA:2.40.150.20:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40334, NULL, 'G3DSA:3.30.450.60:FF:000028', NULL, NULL, 'Adaptor related protein complex 1 subunit sigma 3', NULL, NULL, NULL, NULL, NULL, 4),
(40335, NULL, 'G3DSA:1.10.510.10:FF:003807', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40336, NULL, 'G3DSA:3.30.420.10:FF:000192', NULL, NULL, 'AGO2, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(40337, NULL, 'G3DSA:1.10.357.120:FF:000010', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(40338, NULL, 'G3DSA:2.60.120.200:FF:000775', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(40339, NULL, 'G3DSA:1.10.405.20:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40340, NULL, 'G3DSA:3.40.190.10:FF:000974', NULL, NULL, 'ABC-type peptide uptake system substrate-binding component SapA', NULL, NULL, NULL, NULL, NULL, 4),
(40341, NULL, 'G3DSA:1.20.920.10:FF:000155', NULL, NULL, 'Transcription initiation factor TFIID subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(40342, NULL, 'G3DSA:3.30.70.330:FF:003102', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40343, NULL, 'G3DSA:1.20.1070.10:FF:000914', NULL, NULL, '5-hydroxytryptamine (serotonin) receptor 7c', NULL, NULL, NULL, NULL, NULL, 4),
(40344, NULL, 'G3DSA:3.30.450.50:FF:000025', NULL, NULL, 'Vesicle-associated membrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40345, NULL, 'G3DSA:2.40.170.20:FF:000013', NULL, NULL, 'SusC/RagA family TonB-linked outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(40346, NULL, 'G3DSA:3.30.160.60:FF:003890', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40347, NULL, 'G3DSA:3.80.10.10:FF:002553', NULL, NULL, 'Guanylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(40348, NULL, 'G3DSA:3.80.10.10:FF:002805', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40349, NULL, 'G3DSA:3.30.70.1230:FF:000045', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(40350, NULL, 'G3DSA:1.50.40.10:FF:000407', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40351, NULL, 'G3DSA:1.10.287.70:FF:000641', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40352, NULL, 'G3DSA:1.25.10.10:FF:003432', NULL, NULL, 'Splicing factor subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40353, NULL, 'G3DSA:1.10.246.20:FF:000003', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 15a', NULL, NULL, NULL, NULL, NULL, 4),
(40354, NULL, 'G3DSA:2.40.50.140:FF:000766', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40355, NULL, 'G3DSA:3.40.630.30:FF:000323', NULL, NULL, 'Acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(40356, NULL, 'G3DSA:1.25.10.20:FF:000001', NULL, NULL, 'microsomal triglyceride transfer protein large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(40357, NULL, 'G3DSA:1.20.1560.10:FF:000435', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40358, NULL, 'G3DSA:3.40.50.12350:FF:000005', NULL, NULL, 'Eyes absent homolog', NULL, NULL, NULL, NULL, NULL, 4),
(40359, NULL, 'G3DSA:1.20.1250.20:FF:001134', NULL, NULL, 'Multidrug resistance protein B', NULL, NULL, NULL, NULL, NULL, 4),
(40360, NULL, 'G3DSA:2.40.10.10:FF:000140', NULL, NULL, 'CLIP-domain serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(40361, NULL, 'G3DSA:1.10.220.10:FF:000025', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(40362, NULL, 'G3DSA:1.10.8.10:FF:000176', NULL, NULL, 'Ancient ubiquitous protein 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(40363, NULL, 'G3DSA:3.30.200.20:FF:001717', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40364, NULL, 'G3DSA:3.40.50.300:FF:002232', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(40365, NULL, 'G3DSA:3.40.50.10330:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40366, NULL, 'G3DSA:2.60.120.330:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40367, NULL, 'G3DSA:3.40.50.150:FF:001546', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40368, NULL, 'G3DSA:2.60.40.10:FF:005267', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40369, NULL, 'G3DSA:3.20.20.70:FF:000292', NULL, NULL, 'Unplaced genomic scaffold supercont2.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(40370, NULL, 'G3DSA:3.40.50.300:FF:001625', NULL, NULL, 'tRNA dimethylallyltransferase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(40371, NULL, 'G3DSA:2.60.40.10:FF:005519', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40372, NULL, 'G3DSA:3.30.1490.80:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40373, NULL, 'G3DSA:1.10.20.10:FF:000161', NULL, NULL, 'Histone H3', NULL, NULL, NULL, NULL, NULL, 4),
(40374, NULL, 'G3DSA:1.50.10.10:FF:000226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40375, NULL, 'G3DSA:3.40.50.2000:FF:000908', NULL, NULL, 'Probable heptosyl III transferase', NULL, NULL, NULL, NULL, NULL, 4),
(40376, NULL, 'G3DSA:3.30.70.330:FF:001157', NULL, NULL, 'Sra (SRA) stem-Loop interacting Rna (RNA) binding Protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(40377, NULL, 'G3DSA:3.30.40.10:FF:002169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40378, NULL, 'G3DSA:3.30.559.30:FF:000041', NULL, NULL, 'Nonribosomal peptide synthetase 13', NULL, NULL, NULL, NULL, NULL, 4),
(40379, NULL, 'G3DSA:3.40.50.300:FF:007920', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(40380, NULL, 'G3DSA:3.90.190.10:FF:000569', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40381, NULL, 'G3DSA:3.20.20.80:FF:000295', NULL, NULL, 'Alpha-glucosidase B', NULL, NULL, NULL, NULL, NULL, 4),
(40382, NULL, 'G3DSA:1.20.58.340:FF:000007', NULL, NULL, 'Magnesium transporter MRS2 homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(40383, NULL, 'G3DSA:3.40.50.12660:FF:000008', NULL, NULL, 'Type I metacaspase', NULL, NULL, NULL, NULL, NULL, 4),
(40384, NULL, 'G3DSA:2.60.40.10:FF:003794', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40385, NULL, 'G3DSA:1.20.1110.10:FF:000250', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40386, NULL, 'G3DSA:6.10.140.2220:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40387, NULL, 'G3DSA:2.60.40.10:FF:003485', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40388, NULL, 'G3DSA:3.40.50.150:FF:001855', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40389, NULL, 'G3DSA:3.40.50.2300:FF:001027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40390, NULL, 'G3DSA:3.30.160.60:FF:001681', NULL, NULL, 'C2H2 transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40391, NULL, 'G3DSA:2.60.120.10:FF:000328', NULL, NULL, 'Transcriptional regulator AraC/XylS family', NULL, NULL, NULL, NULL, NULL, 4),
(40392, NULL, 'G3DSA:3.30.160.60:FF:005924', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40393, NULL, 'G3DSA:3.30.160.60:FF:003463', NULL, NULL, 'Hypermethylated in cancer 2', NULL, NULL, NULL, NULL, NULL, 4),
(40394, NULL, 'G3DSA:1.20.5.50:FF:000007', NULL, NULL, 'Cell division protein ZapA', NULL, NULL, NULL, NULL, NULL, 4),
(40395, NULL, 'G3DSA:3.80.10.10:FF:002923', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(40396, NULL, 'G3DSA:3.40.80.10:FF:000030', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(40397, NULL, 'G3DSA:2.10.90.10:FF:000051', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(40398, NULL, 'G3DSA:3.40.50.12650:FF:000005', NULL, NULL, 'DNA repair metallo-beta-lactamase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(40399, NULL, 'G3DSA:1.10.238.10:FF:001084', NULL, NULL, 'Protein phosphatase 2 regulatory subunit B'''', alpha', NULL, NULL, NULL, NULL, NULL, 4),
(40400, NULL, 'G3DSA:1.20.1050.10:FF:000099', NULL, NULL, 'Glutathione S-transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(40401, NULL, 'G3DSA:3.30.160.20:FF:000039', NULL, NULL, '30S ribosomal protein S5', NULL, NULL, NULL, NULL, NULL, 4),
(40402, NULL, 'G3DSA:2.60.120.590:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40403, NULL, 'G3DSA:3.20.20.70:FF:000303', NULL, NULL, 'Glutamate synthase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(40404, NULL, 'G3DSA:2.60.40.10:FF:001467', NULL, NULL, 'Osteoclast-associated immunoglobulin-like receptor', NULL, NULL, NULL, NULL, NULL, 4),
(40405, NULL, 'G3DSA:2.60.40.1730:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40406, NULL, 'G3DSA:3.40.50.1000:FF:000024', NULL, NULL, 'Phosphoglycolate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(40407, NULL, 'G3DSA:3.40.50.1010:FF:000027', NULL, NULL, '5''-3'' exonuclease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(40408, NULL, 'G3DSA:2.10.90.10:FF:000157', NULL, NULL, 'Otogelin', NULL, NULL, NULL, NULL, NULL, 4),
(40409, NULL, 'G3DSA:1.10.132.30:FF:000017', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(40410, NULL, 'G3DSA:1.50.40.10:FF:000054', NULL, NULL, 'Mitochondrial carrier', NULL, NULL, NULL, NULL, NULL, 4),
(40411, NULL, 'G3DSA:2.60.40.10:FF:000141', NULL, NULL, 'Down syndrome cell adhesion molecule a', NULL, NULL, NULL, NULL, NULL, 4),
(40412, NULL, 'G3DSA:3.40.50.2000:FF:000780', NULL, NULL, 'Solanidine glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(40413, NULL, 'G3DSA:3.30.160.60:FF:003581', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40414, NULL, 'G3DSA:3.40.980.10:FF:000040', NULL, NULL, 'FAD synthase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(40415, NULL, 'G3DSA:1.20.1070.10:FF:001033', NULL, NULL, 'Atypical chemokine receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(40416, NULL, 'G3DSA:1.20.1250.10:FF:000007', NULL, NULL, 'Interferon gamma', NULL, NULL, NULL, NULL, NULL, 4),
(40417, NULL, 'G3DSA:2.60.40.10:FF:003367', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40418, NULL, 'G3DSA:3.30.160.60:FF:005481', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40419, NULL, 'G3DSA:3.40.1370.10:FF:000032', NULL, NULL, '50S ribosomal protein L4', NULL, NULL, NULL, NULL, NULL, 4),
(40420, NULL, 'G3DSA:1.10.10.10:FF:001436', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(40421, NULL, 'G3DSA:1.25.40.10:FF:002141', NULL, NULL, 'Pre-mRNA-splicing factor CLF1', NULL, NULL, NULL, NULL, NULL, 4),
(40422, NULL, 'G3DSA:3.40.50.300:FF:007774', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(40423, NULL, 'G3DSA:3.60.20.10:FF:000227', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40424, NULL, 'G3DSA:3.80.10.10:FF:002659', NULL, NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At3g47570', NULL, NULL, NULL, NULL, NULL, 4),
(40425, NULL, 'G3DSA:2.60.40.10:FF:005166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40426, NULL, 'G3DSA:3.40.720.10:FF:000302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40427, NULL, 'G3DSA:3.40.50.10130:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40428, NULL, 'G3DSA:3.40.50.10140:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40429, NULL, 'G3DSA:3.40.50.300:FF:003317', NULL, NULL, 'Phage GTP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(40430, NULL, 'G3DSA:3.10.50.40:FF:000021', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(40431, NULL, 'G3DSA:3.40.50.150:FF:000220', NULL, NULL, 'CAMK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(40432, NULL, 'G3DSA:3.30.420.10:FF:000298', NULL, NULL, 'Argonaute protein wago-1', NULL, NULL, NULL, NULL, NULL, 4),
(40433, NULL, 'G3DSA:1.25.10.10:FF:001841', NULL, NULL, 'Condensin-2 complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(40434, NULL, 'G3DSA:1.10.132.20:FF:000014', NULL, NULL, 'Ribosome-recycling factor, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(40435, NULL, 'G3DSA:4.10.365.10:FF:000001', NULL, NULL, 'Cyclin-dependent kinase inhibitor 1B', NULL, NULL, NULL, NULL, NULL, 4),
(40436, NULL, 'G3DSA:1.10.287.70:FF:000287', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(40437, NULL, 'G3DSA:1.25.10.10:FF:003196', NULL, NULL, 'Formin-F', NULL, NULL, NULL, NULL, NULL, 4),
(40438, NULL, 'G3DSA:1.10.3080.10:FF:000013', NULL, NULL, 'Voltage-gated chloride channel (ClcA)', NULL, NULL, NULL, NULL, NULL, 4),
(40439, NULL, 'G3DSA:1.10.532.10:FF:000008', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(40440, NULL, 'G3DSA:3.30.70.890:FF:000021', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(40441, NULL, 'G3DSA:1.10.555.10:FF:000033', NULL, NULL, 'Rho GTPase activator (Lrg11)', NULL, NULL, NULL, NULL, NULL, 4),
(40442, NULL, 'G3DSA:1.20.58.60:FF:000509', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(40443, NULL, 'G3DSA:2.140.10.30:FF:000017', NULL, NULL, 'Putative dipeptidyl aminopeptidase C14C4.15c', NULL, NULL, NULL, NULL, NULL, 4),
(40444, NULL, 'G3DSA:3.40.20.10:FF:000054', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(40445, NULL, 'G3DSA:2.60.40.10:FF:000242', NULL, NULL, 'Inactive tyrosine-protein kinase transmembrane receptor ROR1', NULL, NULL, NULL, NULL, NULL, 4),
(40446, NULL, 'G3DSA:3.20.20.140:FF:000070', NULL, NULL, 'Guanine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(40447, NULL, 'G3DSA:3.30.420.10:FF:000444', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(40448, NULL, 'G3DSA:3.80.10.10:FF:003997', NULL, NULL, 'Protein phosphatase 2C, putative', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(40449, NULL, 'G3DSA:2.130.10.10:FF:001900', NULL, NULL, 'DDB1- and CUL4-associated factor 13', NULL, NULL, NULL, NULL, NULL, 4),
(40450, NULL, 'G3DSA:2.130.10.10:FF:003800', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40451, NULL, 'G3DSA:3.40.50.2300:FF:000864', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40452, NULL, 'G3DSA:2.10.25.10:FF:000771', NULL, NULL, 'Fat-like cadherin-related tumor suppressor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(40453, NULL, 'G3DSA:3.40.50.10190:FF:000099', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(40454, NULL, 'G3DSA:3.30.160.60:FF:001872', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(40455, NULL, 'G3DSA:2.60.60.20:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40456, NULL, 'G3DSA:3.40.50.360:FF:000081', NULL, NULL, 'Glutathione-regulated potassium-efflux system ancillary protein KefG', NULL, NULL, NULL, NULL, NULL, 4),
(40457, NULL, 'G3DSA:2.60.120.10:FF:000430', NULL, NULL, 'Cyclic nucleotide-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(40458, NULL, 'G3DSA:3.10.100.10:FF:000397', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40459, NULL, 'G3DSA:2.10.70.10:FF:000049', NULL, NULL, 'Complement C1s subcomponent', NULL, NULL, NULL, NULL, NULL, 4),
(40460, NULL, 'G3DSA:1.10.510.10:FF:001907', NULL, NULL, 'Si:ch73-40a2.1', NULL, NULL, NULL, NULL, NULL, 4),
(40461, NULL, 'G3DSA:2.60.40.10:FF:003721', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40462, NULL, 'G3DSA:1.20.1720.10:FF:000072', NULL, NULL, 'Azole resistance protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40463, NULL, 'G3DSA:2.60.40.1930:FF:000029', NULL, NULL, 'Complement 4B (Chido blood group)', NULL, NULL, NULL, NULL, NULL, 4),
(40464, NULL, 'G3DSA:2.60.40.1400:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40465, NULL, 'G3DSA:3.30.930.10:FF:000174', NULL, NULL, 'ATP phosphoribosyltransferase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(40466, NULL, 'G3DSA:1.20.1270.60:FF:000287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40467, NULL, 'G3DSA:1.20.120.640:FF:000001', NULL, NULL, 'L-cysteine:1D-myo-inositol 2-amino-2-deoxy-alpha-D-glucopyranoside ligase', NULL, NULL, NULL, NULL, NULL, 4),
(40468, NULL, 'G3DSA:3.40.1280.30:FF:000008', NULL, NULL, 'tRNA m(1)G methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40469, NULL, 'G3DSA:3.10.580.10:FF:000218', NULL, NULL, 'Chloride channel', NULL, NULL, NULL, NULL, NULL, 4),
(40470, NULL, 'G3DSA:3.60.130.10:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40471, NULL, 'G3DSA:1.20.1640.10:FF:000014', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(40472, NULL, 'G3DSA:2.60.40.10:FF:005621', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40473, NULL, 'G3DSA:3.30.160.60:FF:001782', NULL, NULL, 'Ras-responsive element-binding protein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(40474, NULL, 'G3DSA:1.10.3660.10:FF:000007', NULL, NULL, 'Prephenate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(40475, NULL, 'G3DSA:2.170.190.11:FF:000004', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(40476, NULL, 'G3DSA:1.10.287.130:FF:000176', NULL, NULL, 'Development and carotenogenesis control-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(40477, NULL, 'G3DSA:1.10.510.10:FF:001245', NULL, NULL, 'AGC/PDK1 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(40478, NULL, 'G3DSA:3.80.10.10:FF:000905', NULL, NULL, 'Receptor-like protein kinase 7', NULL, NULL, NULL, NULL, NULL, 4),
(40479, NULL, 'G3DSA:3.30.160.60:FF:003479', NULL, NULL, 'Zinc finger protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(40480, NULL, 'G3DSA:2.60.120.920:FF:000182', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(40481, NULL, 'G3DSA:3.30.60.30:FF:000107', NULL, NULL, 'Protein CBG17314', NULL, NULL, NULL, NULL, NULL, 4),
(40482, NULL, 'G3DSA:2.30.30.490:FF:000009', NULL, NULL, 'DNA (cytosine-5)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(40483, NULL, 'G3DSA:2.10.25.10:FF:000198', NULL, NULL, 'latent-transforming growth factor beta-binding protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(40484, NULL, 'G3DSA:2.30.29.30:FF:000279', NULL, NULL, 'FYVE, RhoGEF and PH domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(40485, NULL, 'G3DSA:3.40.190.80:FF:000017', NULL, NULL, 'Putative PAP-specific phosphatase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(40486, NULL, 'G3DSA:3.40.50.2300:FF:001370', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40487, NULL, 'G3DSA:1.25.40.20:FF:000244', NULL, NULL, 'Ankyrin repeat-containing protein ITN1', NULL, NULL, NULL, NULL, NULL, 4),
(40488, NULL, 'G3DSA:1.20.1560.10:FF:000536', NULL, NULL, 'ABC transporter, multidrug resistance associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(40489, NULL, 'G3DSA:1.10.10.440:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40490, NULL, 'G3DSA:2.60.220.50:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40491, NULL, 'G3DSA:2.60.40.10:FF:002041', NULL, NULL, 'AGAP005471-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(40492, NULL, 'G3DSA:3.90.70.10:FF:000330', NULL, NULL, 'Papain family cysteine protease', NULL, NULL, NULL, NULL, NULL, 4),
(40493, NULL, 'G3DSA:3.30.160.60:FF:000045', NULL, NULL, 'ZFP69 zinc finger protein B', NULL, NULL, NULL, NULL, NULL, 4),
(40494, NULL, 'G3DSA:3.40.50.410:FF:000332', NULL, NULL, 'Sec24-related gene family, member C (S. cerevisiae)', NULL, NULL, NULL, NULL, NULL, 4),
(40495, NULL, 'G3DSA:3.40.50.1760:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40496, NULL, 'G3DSA:1.20.5.1130:FF:000001', NULL, NULL, 'Gap junction alpha-1', NULL, NULL, NULL, NULL, NULL, 4),
(40497, NULL, 'G3DSA:3.30.70.100:FF:000155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40498, NULL, 'G3DSA:3.30.1340.10:FF:000010', NULL, NULL, 'Phosphotransferase system fructose-specific transporter subunit EI/HPr/EIIA', NULL, NULL, NULL, NULL, NULL, 4),
(40499, NULL, 'G3DSA:3.40.605.10:FF:000023', NULL, NULL, 'Succinate-semialdehyde dehydrogenase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(40500, NULL, 'G3DSA:3.10.20.870:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40501, NULL, 'G3DSA:2.40.20.10:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40502, NULL, 'G3DSA:3.50.50.60:FF:000924', NULL, NULL, 'Rab proteins geranylgeranyltransferase component A', NULL, NULL, NULL, NULL, NULL, 4),
(40503, NULL, 'G3DSA:3.90.1300.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40504, NULL, 'G3DSA:3.40.50.300:FF:006240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40505, NULL, 'G3DSA:1.50.40.10:FF:000306', NULL, NULL, 'RE67391p', NULL, NULL, NULL, NULL, NULL, 4),
(40506, NULL, 'G3DSA:3.40.50.720:FF:000453', NULL, NULL, '3-oxoacyl-[acyl-carrier protein] reductase', NULL, NULL, NULL, NULL, NULL, 4),
(40507, NULL, 'G3DSA:1.25.10.10:FF:002313', NULL, NULL, 'AGAP000271-PA', NULL, NULL, NULL, NULL, NULL, 4),
(40508, NULL, 'G3DSA:2.60.200.20:FF:000130', NULL, NULL, 'Plm2p', NULL, NULL, NULL, NULL, NULL, 4),
(40509, NULL, 'G3DSA:1.10.1760.20:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40510, NULL, 'G3DSA:3.40.50.720:FF:000969', NULL, NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(40511, NULL, 'G3DSA:1.20.1070.10:FF:000561', NULL, NULL, 'Protein CBG19271', NULL, NULL, NULL, NULL, NULL, 4),
(40512, NULL, 'G3DSA:3.90.1750.10:FF:000022', NULL, NULL, 'probable E3 ubiquitin-protein ligase HECTD4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(40513, NULL, 'G3DSA:3.40.50.300:FF:004340', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(40514, NULL, 'G3DSA:3.30.70.330:FF:002585', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40515, NULL, 'G3DSA:3.40.1810.10:FF:000050', NULL, NULL, 'AGAMOUS-like 15', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(40516, NULL, 'G3DSA:4.10.1060.10:FF:000015', NULL, NULL, 'Nuclear pore complex protein Nup153', NULL, NULL, NULL, NULL, NULL, 4),
(40517, NULL, 'G3DSA:1.10.10.10:FF:002032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40518, NULL, 'G3DSA:3.30.70.330:FF:001303', NULL, NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(40519, NULL, 'G3DSA:1.25.40.10:FF:001017', NULL, NULL, 'Os12g0181900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(40520, NULL, 'G3DSA:2.130.10.10:FF:005907', NULL, NULL, 'PRP4 pre-mRNA-processing factor 4 homolog (yeast)', NULL, NULL, NULL, NULL, NULL, 4),
(40521, NULL, 'G3DSA:1.25.10.10:FF:000104', NULL, NULL, 'HOPM interactor 7', NULL, NULL, NULL, NULL, NULL, 4),
(40522, NULL, 'G3DSA:2.40.10.190:FF:000008', NULL, NULL, '60S ribosomal protein L35a-2', NULL, NULL, NULL, NULL, NULL, 4),
(40523, NULL, 'G3DSA:3.30.460.10:FF:000109', NULL, NULL, 'Topoisomerase I-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(40524, NULL, 'G3DSA:1.10.540.10:FF:000100', NULL, NULL, 'L-prolyl-[peptidyl-carrier protein] dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(40525, NULL, 'G3DSA:1.20.58.90:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40526, NULL, 'G3DSA:3.90.530.10:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40527, NULL, 'G3DSA:1.10.8.1120:FF:000001', NULL, NULL, 'Histone RNA hairpin-binding protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(40528, NULL, 'G3DSA:3.90.190.10:FF:000154', NULL, NULL, 'Protein CBG00285', NULL, NULL, NULL, NULL, NULL, 4),
(40529, NULL, 'G3DSA:3.40.1110.10:FF:000249', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40530, NULL, 'G3DSA:2.60.40.1530:FF:000016', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(40531, NULL, 'G3DSA:3.40.1170.60:FF:000015', NULL, NULL, 'Polymerase (DNA directed) kappa', NULL, NULL, NULL, NULL, NULL, 4),
(40532, NULL, 'G3DSA:3.30.559.10:FF:000193', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(40533, NULL, 'G3DSA:3.40.50.150:FF:001193', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(40534, NULL, 'G3DSA:3.40.50.720:FF:000762', NULL, NULL, 'PROBABLE SHORT-CHAIN TYPE DEHYDROGENASE', NULL, NULL, NULL, NULL, NULL, 4),
(40535, NULL, 'G3DSA:1.10.287.70:FF:000433', NULL, NULL, 'Cytochrome c oxidase subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(40536, NULL, 'G3DSA:3.40.250.10:FF:000092', NULL, NULL, 'MBL fold metallo-hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(40537, NULL, 'G3DSA:2.40.50.140:FF:001272', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40538, NULL, 'G3DSA:3.20.80.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40539, NULL, 'G3DSA:1.20.1070.10:FF:000870', NULL, NULL, 'Cholecystokinin-like receptor at 17D1', NULL, NULL, NULL, NULL, NULL, 4),
(40540, NULL, 'G3DSA:3.40.50.2300:FF:000555', NULL, NULL, 'Phosphodiesterase 8, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(40541, NULL, 'G3DSA:3.90.1200.10:FF:000071', NULL, NULL, 'RE24176p', NULL, NULL, NULL, NULL, NULL, 4),
(40542, NULL, 'G3DSA:3.30.50.10:FF:000079', NULL, NULL, 'Protein CBR-UNC-55, isoform a', NULL, NULL, NULL, NULL, NULL, 4),
(40543, NULL, 'G3DSA:1.10.287.70:FF:000742', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40544, NULL, 'G3DSA:1.25.40.10:FF:003226', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(40545, NULL, 'G3DSA:1.10.506.10:FF:000021', NULL, NULL, 'Plexin C1', NULL, NULL, NULL, NULL, NULL, 4),
(40546, NULL, 'G3DSA:3.30.70.330:FF:000994', NULL, NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(40547, NULL, 'G3DSA:2.130.10.10:FF:003137', NULL, NULL, 'BEACH domain-containing protein lvsD', NULL, NULL, NULL, NULL, NULL, 4),
(40548, NULL, 'G3DSA:1.20.1740.10:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40549, NULL, 'G3DSA:2.60.470.10:FF:000006', NULL, NULL, 'Acid-sensing ion channel 5', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(40550, NULL, 'G3DSA:3.30.160.60:FF:005379', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40551, NULL, 'G3DSA:3.90.260.10:FF:000013', NULL, NULL, 'DNA repair protein RAD34', NULL, NULL, NULL, NULL, NULL, 4),
(40552, NULL, 'G3DSA:3.30.160.60:FF:000135', NULL, NULL, 'Zinc finger protein 358', NULL, NULL, NULL, NULL, NULL, 4),
(40553, NULL, 'G3DSA:3.80.10.10:FF:000198', NULL, NULL, 'Blast:Protein toll', NULL, NULL, NULL, NULL, NULL, 4),
(40554, NULL, 'G3DSA:3.40.630.30:FF:000177', NULL, NULL, 'Putative acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(40555, NULL, 'G3DSA:1.20.120.1080:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40556, NULL, 'G3DSA:1.25.40.770:FF:000009', NULL, NULL, 'Transcription initiation factor tfiid, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40557, NULL, 'G3DSA:1.10.565.10:FF:000051', NULL, NULL, 'Blast:Protein tailless', NULL, NULL, NULL, NULL, NULL, 4),
(40558, NULL, 'G3DSA:1.20.1250.20:FF:000780', NULL, NULL, 'Proton myo-inositol cotransporter', NULL, NULL, NULL, NULL, NULL, 4),
(40559, NULL, 'G3DSA:3.40.140.10:FF:000100', NULL, NULL, 'DNA repair protein RadC', NULL, NULL, NULL, NULL, NULL, 4),
(40560, NULL, 'G3DSA:1.25.10.10:FF:003286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40561, NULL, 'G3DSA:2.70.170.10:FF:000003', NULL, NULL, 'Putative gamma-aminobutyric acid receptor subunit gamma-2', NULL, NULL, NULL, NULL, NULL, 4),
(40562, NULL, 'G3DSA:3.30.70.330:FF:001612', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40563, NULL, 'G3DSA:3.30.200.20:FF:000993', NULL, NULL, 'Probable choline kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(40564, NULL, 'G3DSA:1.20.1600.10:FF:000006', NULL, NULL, 'Type I secretion protein TolC', NULL, NULL, NULL, NULL, NULL, 4),
(40565, NULL, 'G3DSA:1.10.225.10:FF:000014', NULL, NULL, 'Proactivator polypeptide-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(40566, NULL, 'G3DSA:2.60.40.60:FF:000240', NULL, NULL, 'Cadherin 16', NULL, NULL, NULL, NULL, NULL, 4),
(40567, NULL, 'G3DSA:3.10.20.90:FF:000146', NULL, NULL, 'deubiquitinating protein VCIP135 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(40568, NULL, 'G3DSA:1.10.510.10:FF:000160', NULL, NULL, 'Casein kinase I 1', NULL, NULL, NULL, NULL, NULL, 4),
(40569, NULL, 'G3DSA:1.25.40.610:FF:000012', NULL, NULL, 'Adhesion G protein-coupled receptor L3', NULL, NULL, NULL, NULL, NULL, 4),
(40570, NULL, 'G3DSA:2.60.40.1180:FF:000220', NULL, NULL, 'Oligosaccharide 4-alpha-D-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(40571, NULL, 'G3DSA:1.10.8.50:FF:000031', NULL, NULL, 'Mitochondrial ribosomal protein S13', NULL, NULL, NULL, NULL, NULL, 4),
(40572, NULL, 'G3DSA:3.30.70.850:FF:000026', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5a', NULL, NULL, NULL, NULL, NULL, 4),
(40573, NULL, 'G3DSA:2.130.10.10:FF:003446', NULL, NULL, 'Endonuclease/exonuclease/phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(40574, NULL, 'G3DSA:2.130.10.10:FF:005700', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(40575, NULL, 'G3DSA:1.20.58.60:FF:000397', NULL, NULL, 'AGAP007562-PA', NULL, NULL, NULL, NULL, NULL, 4),
(40576, NULL, 'G3DSA:2.60.40.60:FF:000150', NULL, NULL, 'Dachsous cadherin-related 1', NULL, NULL, NULL, NULL, NULL, 4),
(40577, NULL, 'G3DSA:3.90.190.10:FF:000463', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40578, NULL, 'G3DSA:1.10.555.10:FF:000123', NULL, NULL, 'Rho GTPase activating protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(40579, NULL, 'G3DSA:3.40.50.10190:FF:000144', NULL, NULL, 'Protein CBR-HSR-9', NULL, NULL, NULL, NULL, NULL, 4),
(40580, NULL, 'G3DSA:1.10.150.50:FF:000043', NULL, NULL, 'Sterile alpha and TIR motif-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(40581, NULL, 'G3DSA:2.60.120.380:FF:000003', NULL, NULL, 'Calpain 5', NULL, NULL, NULL, NULL, NULL, 4),
(40582, NULL, 'G3DSA:3.30.170.10:FF:000008', NULL, NULL, 'Cyclin-dependent kinases regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(40583, NULL, 'G3DSA:2.40.30.10:FF:000040', NULL, NULL, 'Peptide chain release factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(40584, NULL, 'G3DSA:3.50.30.30:FF:000088', NULL, NULL, 'Peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(40585, NULL, 'G3DSA:2.130.10.10:FF:001546', NULL, NULL, 'Cilia and flagella associated protein 52', NULL, NULL, NULL, NULL, NULL, 4),
(40586, NULL, 'G3DSA:1.25.50.20:FF:000082', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(40587, NULL, 'G3DSA:3.30.200.20:FF:000684', NULL, NULL, 'Serine/threonine-protein kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(40588, NULL, 'G3DSA:1.25.10.10:FF:002004', NULL, NULL, 'HEAT domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(40589, NULL, 'G3DSA:3.40.50.300:FF:004031', NULL, NULL, 'Thiamine ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(40590, NULL, 'G3DSA:3.30.160.60:FF:002035', NULL, NULL, 'HKR1, GLI-Kruppel zinc finger family member', NULL, NULL, NULL, NULL, NULL, 4),
(40591, NULL, 'G3DSA:1.10.8.60:FF:000034', NULL, NULL, 'Two-component system response regulator GlrR', NULL, NULL, NULL, NULL, NULL, 4),
(40592, NULL, 'G3DSA:3.80.10.10:FF:002098', NULL, NULL, 'Calmodulin-binding protein CmbB', NULL, NULL, NULL, NULL, NULL, 4),
(40593, NULL, 'G3DSA:1.20.58.390:FF:000224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40594, NULL, 'G3DSA:1.10.630.10:FF:000545', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40595, NULL, 'G3DSA:1.25.40.10:FF:001326', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(40596, NULL, 'G3DSA:3.40.50.300:FF:007465', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40597, NULL, 'G3DSA:4.10.410.10:FF:000124', NULL, NULL, 'Amyloid beta (A4) precursor protein a', NULL, NULL, NULL, NULL, NULL, 4),
(40598, NULL, 'G3DSA:3.20.20.80:FF:000542', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(40599, NULL, 'G3DSA:2.10.70.10:FF:000274', NULL, NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(40600, NULL, 'G3DSA:2.170.190.11:FF:000021', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(40601, NULL, 'G3DSA:3.30.70.330:FF:002495', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40602, NULL, 'G3DSA:3.90.370.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40603, NULL, 'G3DSA:3.40.190.10:FF:000839', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40604, NULL, 'G3DSA:1.50.40.10:FF:000172', NULL, NULL, 'MC family mitochondrial carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(40605, NULL, 'G3DSA:2.70.130.10:FF:000102', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40606, NULL, 'G3DSA:1.25.40.20:FF:001891', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40607, NULL, 'G3DSA:2.10.230.10:FF:000016', NULL, NULL, 'Os12g0619100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(40608, NULL, 'G3DSA:1.10.1220.10:FF:000002', NULL, NULL, 'Negative modulator of initiation of replication', NULL, NULL, NULL, NULL, NULL, 4),
(40609, NULL, 'G3DSA:3.30.70.330:FF:000887', NULL, NULL, 'HnRNP A1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(40610, NULL, 'G3DSA:2.60.120.260:FF:000299', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(40611, NULL, 'G3DSA:3.40.50.300:FF:001479', NULL, NULL, 'ABC transporter G family member 10', NULL, NULL, NULL, NULL, NULL, 4),
(40612, NULL, 'G3DSA:1.10.287.70:FF:000169', NULL, NULL, 'Glutamate receptor ionotropic, delta-2', NULL, NULL, NULL, NULL, NULL, 4),
(40613, NULL, 'G3DSA:1.10.8.60:FF:000135', NULL, NULL, 'Replication factor C subunit 5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40614, NULL, 'G3DSA:1.20.1250.20:FF:000555', NULL, NULL, 'MFS transporter, putative (AFU_orthologue AFUA_8G05090)', NULL, NULL, NULL, NULL, NULL, 4),
(40615, NULL, 'G3DSA:3.30.300.160:FF:000024', NULL, NULL, 'Similar to type IV pilus assembly protein TapB', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(40616, NULL, 'G3DSA:2.60.120.330:FF:000022', NULL, NULL, 'Probable 2-oxoglutarate-dependent dioxygenase AOP1.2', NULL, NULL, NULL, NULL, NULL, 4),
(40617, NULL, 'G3DSA:2.60.40.10:FF:000023', NULL, NULL, 'receptor-type tyrosine-protein phosphatase delta isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(40618, NULL, 'G3DSA:3.40.30.10:FF:000111', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(40619, NULL, 'G3DSA:3.30.230.70:FF:000110', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(40620, NULL, 'G3DSA:2.40.30.70:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40621, NULL, 'G3DSA:1.10.10.830:FF:000014', NULL, NULL, 'Isoleucine-trna synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(40622, NULL, 'G3DSA:1.10.630.10:FF:000663', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40623, NULL, 'G3DSA:1.25.40.180:FF:000147', NULL, NULL, 'Suppressor of glycerol defect protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40624, NULL, 'G3DSA:3.30.70.330:FF:001511', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40625, NULL, 'G3DSA:1.10.287.950:FF:000051', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(40626, NULL, 'G3DSA:3.30.200.20:FF:001263', NULL, NULL, 'Serine-threonine kinase Stk1', NULL, NULL, NULL, NULL, NULL, 4),
(40627, NULL, 'G3DSA:2.40.10.10:FF:000050', NULL, NULL, 'mannan-binding lectin serine protease 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(40628, NULL, 'G3DSA:2.60.120.620:FF:000002', NULL, NULL, 'Prolyl 4-hydroxylase 4', NULL, NULL, NULL, NULL, NULL, 4),
(40629, NULL, 'G3DSA:3.40.1110.10:FF:000165', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(40630, NULL, 'G3DSA:1.10.150.50:FF:000060', NULL, NULL, 'Ankyrin repeat, SAM and basic leucine zipper domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(40631, NULL, 'G3DSA:3.40.50.300:FF:004132', NULL, NULL, 'Mitochondrial GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40632, NULL, 'G3DSA:3.40.50.10190:FF:000228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40633, NULL, 'G3DSA:3.40.50.1820:FF:000383', NULL, NULL, 'endothelial lipase', NULL, NULL, NULL, NULL, NULL, 4),
(40634, NULL, 'G3DSA:3.30.160.60:FF:001563', NULL, NULL, 'GDNF inducible zinc finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(40635, NULL, 'G3DSA:2.10.110.10:FF:000289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40636, NULL, 'G3DSA:3.30.9.10:FF:000152', NULL, NULL, 'YALI0E20735p', NULL, NULL, NULL, NULL, NULL, 4),
(40637, NULL, 'G3DSA:3.90.640.10:FF:000245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40638, NULL, 'G3DSA:1.20.1270.10:FF:000082', NULL, NULL, 'Endoplasmic reticulum heat shock protein 70, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40639, NULL, 'G3DSA:3.30.450.20:FF:000466', NULL, NULL, 'Hypoxia-inducible factor 1-alpha', NULL, NULL, NULL, NULL, NULL, 4),
(40640, NULL, 'G3DSA:2.160.20.10:FF:000287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40641, NULL, 'G3DSA:1.20.58.60:FF:000279', NULL, NULL, 'Calponin domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(40642, NULL, 'G3DSA:1.10.510.10:FF:001655', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(40643, NULL, 'G3DSA:2.60.120.10:FF:000345', NULL, NULL, 'Acireductone dioxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40644, NULL, 'G3DSA:1.25.40.20:FF:000261', NULL, NULL, 'Ankyrin repeat, SAM and basic leucine zipper domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(40645, NULL, 'G3DSA:1.20.1560.10:FF:000519', NULL, NULL, 'ATP-binding cassette transporter, subfamily C, member 6, group MRP protein PpABCC6', NULL, NULL, NULL, NULL, NULL, 4),
(40646, NULL, 'G3DSA:3.30.930.10:FF:000410', NULL, NULL, 'GlycyltRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40647, NULL, 'G3DSA:1.20.120.850:FF:000047', NULL, NULL, 'AGL212Wp', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(40648, NULL, 'G3DSA:3.30.70.600:FF:000007', NULL, NULL, 'Ribosomal protein S10', NULL, NULL, NULL, NULL, NULL, 4),
(40649, NULL, 'G3DSA:3.40.367.20:FF:000034', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(40650, NULL, 'G3DSA:1.20.120.1240:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40651, NULL, 'G3DSA:3.40.50.300:FF:003733', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40652, NULL, 'G3DSA:2.10.25.10:FF:000905', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(40653, NULL, 'G3DSA:3.30.420.10:FF:000528', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40654, NULL, 'G3DSA:3.30.420.10:FF:000326', NULL, NULL, 'Mitochondrial resolvase Ydc2', NULL, NULL, NULL, NULL, NULL, 4),
(40655, NULL, 'G3DSA:1.10.10.10:FF:001419', NULL, NULL, 'Putative transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(40656, NULL, 'G3DSA:2.70.170.10:FF:000211', NULL, NULL, 'Glutamate-gated chloride channel, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40657, NULL, 'G3DSA:2.70.150.10:FF:000204', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(40658, NULL, 'G3DSA:1.10.8.10:FF:000058', NULL, NULL, 'Ubiquitin conjugating enzyme E2 K', NULL, NULL, NULL, NULL, NULL, 4),
(40659, NULL, 'G3DSA:3.30.160.60:FF:005834', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40660, NULL, 'G3DSA:1.10.10.10:FF:001099', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(40661, NULL, 'G3DSA:3.30.930.10:FF:000292', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(40662, NULL, 'G3DSA:3.40.1370.10:FF:000015', NULL, NULL, '50S ribosomal protein L4', NULL, NULL, NULL, NULL, NULL, 4),
(40663, NULL, 'G3DSA:3.60.40.10:FF:000217', NULL, NULL, 'Probable protein phosphatase 2C F42G9.1', NULL, NULL, NULL, NULL, NULL, 4),
(40664, NULL, 'G3DSA:1.20.920.10:FF:000037', NULL, NULL, 'ATPase family AAA domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(40665, NULL, 'G3DSA:3.40.50.850:FF:000014', NULL, NULL, 'Maleamate amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(40666, NULL, 'G3DSA:3.40.50.300:FF:007791', NULL, NULL, 'Ras-related protein Rab-6A', NULL, NULL, NULL, NULL, NULL, 4),
(40667, NULL, 'G3DSA:1.20.1560.10:FF:000845', NULL, NULL, 'ATP-binding cassette transporter, subfamily B, member 2, group MDR/PGP protein PpABCB2', NULL, NULL, NULL, NULL, NULL, 4),
(40668, NULL, 'G3DSA:3.30.70.3310:FF:000001', NULL, NULL, 'Neurogenic locus notch protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(40669, NULL, 'G3DSA:2.60.40.10:FF:001804', NULL, NULL, 'Titin, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(40670, NULL, 'G3DSA:2.30.42.10:FF:000484', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40671, NULL, 'G3DSA:2.70.160.11:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40672, NULL, 'G3DSA:3.90.190.10:FF:000137', NULL, NULL, 'Protein tyrosine phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40673, NULL, 'G3DSA:1.50.10.10:FF:000142', NULL, NULL, 'Non-lysosomal glucosylceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(40674, NULL, 'G3DSA:3.40.50.620:FF:000748', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40675, NULL, 'G3DSA:3.40.33.10:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40676, NULL, 'G3DSA:1.25.40.20:FF:001565', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(40677, NULL, 'G3DSA:1.10.3060.10:FF:000023', NULL, NULL, 'Protein translocase subunit SECA1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(40678, NULL, 'G3DSA:1.50.10.20:FF:000038', NULL, NULL, 'Complement C4', NULL, NULL, NULL, NULL, NULL, 4),
(40679, NULL, 'G3DSA:3.80.10.10:FF:004486', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40680, NULL, 'G3DSA:3.60.20.10:FF:000008', NULL, NULL, 'Proteasome subunit beta type-4', NULL, NULL, NULL, NULL, NULL, 4),
(40681, NULL, 'G3DSA:3.30.980.10:FF:000014', NULL, NULL, 'Alanyl-tRNA editing protein AlaX-M', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(40682, NULL, 'G3DSA:3.30.160.60:FF:000461', NULL, NULL, 'Zinc finger X-chromosomal protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(40683, NULL, 'G3DSA:2.130.10.10:FF:005037', NULL, NULL, 'Protein HIRA', NULL, NULL, NULL, NULL, NULL, 4),
(40684, NULL, 'G3DSA:2.20.25.10:FF:000118', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(40685, NULL, 'G3DSA:3.40.1170.10:FF:000034', NULL, NULL, 'MutS homolog 1B', NULL, NULL, NULL, NULL, NULL, 4),
(40686, NULL, 'G3DSA:2.60.120.340:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40687, NULL, 'G3DSA:2.60.40.10:FF:004879', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40688, NULL, 'G3DSA:1.50.10.20:FF:000145', NULL, NULL, 'Terpene cyclase/mutase family member', NULL, NULL, NULL, NULL, NULL, 4),
(40689, NULL, 'G3DSA:2.30.30.40:FF:000105', NULL, NULL, 'MAGUK p55 subfamily member 5', NULL, NULL, NULL, NULL, NULL, 4),
(40690, NULL, 'G3DSA:1.25.40.10:FF:003451', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40691, NULL, 'G3DSA:3.40.850.10:FF:000396', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(40692, NULL, 'G3DSA:1.20.1250.20:FF:000881', NULL, NULL, 'SoLute Carrier Family', NULL, NULL, NULL, NULL, NULL, 4),
(40693, NULL, 'G3DSA:3.40.50.620:FF:000855', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40694, NULL, 'G3DSA:3.10.290.20:FF:000019', NULL, NULL, 'SUMO-activating enzyme subunit', NULL, NULL, NULL, NULL, NULL, 4),
(40695, NULL, 'G3DSA:2.60.120.430:FF:000024', NULL, NULL, 'Receptor protein kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(40696, NULL, 'G3DSA:1.10.510.10:FF:003370', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40697, NULL, 'G3DSA:3.30.2440.10:FF:000001', NULL, NULL, 'SPI-2 type III secretion system effector SseI', NULL, NULL, NULL, NULL, NULL, 4),
(40698, NULL, 'G3DSA:1.20.1560.10:FF:000626', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40699, NULL, 'G3DSA:3.10.290.10:FF:000016', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(40700, NULL, 'G3DSA:1.10.1040.10:FF:000123', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(40701, NULL, 'G3DSA:3.40.1180.10:FF:000006', NULL, NULL, 'Alkyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(40702, NULL, 'G3DSA:3.40.50.1260:FF:000046', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(40703, NULL, 'G3DSA:1.50.10.10:FF:000035', NULL, NULL, 'LanC-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(40704, NULL, 'G3DSA:3.10.270.10:FF:000009', NULL, NULL, 'Uricase', NULL, NULL, NULL, NULL, NULL, 4),
(40705, NULL, 'G3DSA:3.30.360.20:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40706, NULL, 'G3DSA:3.30.40.10:FF:000707', NULL, NULL, 'RING finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(40707, NULL, 'G3DSA:1.10.287.70:FF:000539', NULL, NULL, 'Potassium channel, calcium-activated intermediate/small conductance subfamily N alpha, member 2', NULL, NULL, NULL, NULL, NULL, 4),
(40708, NULL, 'G3DSA:3.10.20.410:FF:000006', NULL, NULL, 'Outer membrane usher protein PefC', NULL, NULL, NULL, NULL, NULL, 4),
(40709, NULL, 'G3DSA:3.90.190.10:FF:000614', NULL, NULL, 'DnaJ heat shock protein family (Hsp40) member C6', NULL, NULL, NULL, NULL, NULL, 4),
(40710, NULL, 'G3DSA:2.30.29.30:FF:001122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40711, NULL, 'G3DSA:1.10.8.60:FF:000505', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(40712, NULL, 'G3DSA:3.90.70.80:FF:000008', NULL, NULL, 'OTU domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(40713, NULL, 'G3DSA:2.40.440.10:FF:000003', NULL, NULL, 'L,D-transpeptidase YciB', NULL, NULL, NULL, NULL, NULL, 4),
(40714, NULL, 'G3DSA:3.90.25.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40715, NULL, 'G3DSA:3.30.160.60:FF:005615', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(40716, NULL, 'G3DSA:3.40.250.10:FF:000193', NULL, NULL, 'Adenylyltransferase and sulfurtransferase MOCS3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(40717, NULL, 'G3DSA:1.20.58.930:FF:000004', NULL, NULL, 'Biosynthetic arginine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(40718, NULL, 'G3DSA:2.60.40.10:FF:005059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40719, NULL, 'G3DSA:2.60.40.10:FF:003575', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40720, NULL, 'G3DSA:3.30.450.20:FF:000157', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(40721, NULL, 'G3DSA:3.30.40.10:FF:000696', NULL, NULL, 'RING zinc finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40722, NULL, 'G3DSA:2.60.40.1670:FF:000024', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(40723, NULL, 'G3DSA:3.40.50.620:FF:000529', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(40724, NULL, 'G3DSA:3.30.40.10:FF:002259', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(40725, NULL, 'G3DSA:3.40.50.2300:FF:000656', NULL, NULL, 'Response regulator SaeR', NULL, NULL, NULL, NULL, NULL, 4),
(40726, NULL, 'G3DSA:3.30.1360.40:FF:000026', NULL, NULL, 'Allophanate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(40727, NULL, 'G3DSA:1.10.630.10:FF:000770', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40728, NULL, 'G3DSA:3.40.1800.20:FF:000024', NULL, NULL, 'GG15664', NULL, NULL, NULL, NULL, NULL, 4),
(40729, NULL, 'G3DSA:2.130.10.10:FF:001771', NULL, NULL, 'Coatomer alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(40730, NULL, 'G3DSA:3.30.40.10:FF:000477', NULL, NULL, 'General transcription and DNA repair factor IIH', NULL, NULL, NULL, NULL, NULL, 4),
(40731, NULL, 'G3DSA:2.130.10.10:FF:004042', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(40732, NULL, 'G3DSA:2.60.40.10:FF:001793', NULL, NULL, 'Immunoglobulin alpha Fc receptor', NULL, NULL, NULL, NULL, NULL, 4),
(40733, NULL, 'G3DSA:3.40.50.300:FF:001816', NULL, NULL, '3''-5'' exonuclease DinG', NULL, NULL, NULL, NULL, NULL, 4),
(40734, NULL, 'G3DSA:1.10.287.70:FF:000388', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40735, NULL, 'G3DSA:3.20.20.70:FF:000213', NULL, NULL, '1-(5-phosphoribosyl)-5-[(5-phosphoribosylamino)methylideneamino] imidazole-4-carboxamide isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(40736, NULL, 'G3DSA:2.170.150.40:FF:000004', NULL, NULL, 'Related to decapping enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(40737, NULL, 'G3DSA:1.25.50.20:FF:000065', NULL, NULL, 'Peptidase family m1 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40738, NULL, 'G3DSA:1.10.3200.20:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40739, NULL, 'G3DSA:3.90.1780.10:FF:000001', NULL, NULL, 'Adhesin', NULL, NULL, NULL, NULL, NULL, 4),
(40740, NULL, 'G3DSA:3.40.1380.20:FF:000070', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(40741, NULL, 'G3DSA:1.10.510.10:FF:001806', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40742, NULL, 'G3DSA:3.30.70.260:FF:000063', NULL, NULL, 'ACT domain repeat 6', NULL, NULL, NULL, NULL, NULL, 4),
(40743, NULL, 'G3DSA:3.40.50.300:FF:004441', NULL, NULL, 'Shikimate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(40744, NULL, 'G3DSA:1.25.40.70:FF:000012', NULL, NULL, 'phosphatidylinositol 3-kinase, root isoform', NULL, NULL, NULL, NULL, NULL, 4),
(40745, NULL, 'G3DSA:3.30.2410.10:FF:000027', NULL, NULL, 'E3 ubiquitin-protein ligase HUWE1', NULL, NULL, NULL, NULL, NULL, 4),
(40746, NULL, 'G3DSA:1.20.1250.20:FF:000336', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(40747, NULL, 'G3DSA:1.20.58.60:FF:000498', NULL, NULL, 'Guanine nucleotide exchange factor UNC-73B', NULL, NULL, NULL, NULL, NULL, 4),
(40748, NULL, 'G3DSA:2.130.10.10:FF:003553', NULL, NULL, 'Protein will die slowly-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(40749, NULL, 'G3DSA:3.80.10.10:FF:003502', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(40750, NULL, 'G3DSA:1.10.1080.10:FF:000013', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(40751, NULL, 'G3DSA:3.80.10.10:FF:002362', NULL, NULL, 'P-granule-associated novel protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(40752, NULL, 'G3DSA:3.30.1490.20:FF:000041', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(40753, NULL, 'G3DSA:3.10.250.10:FF:000126', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40754, NULL, 'G3DSA:3.30.450.20:FF:000685', NULL, NULL, 'Regulatory-associated protein of TOR 1', NULL, NULL, NULL, NULL, NULL, 4),
(40755, NULL, 'G3DSA:2.170.150.30:FF:000001', NULL, NULL, 'Probable ATP-dependent RNA helicase DDX58', NULL, NULL, NULL, NULL, NULL, 4),
(40756, NULL, 'G3DSA:3.20.20.80:FF:000216', NULL, NULL, 'Beta-N-acetylhexosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(40757, NULL, 'G3DSA:3.40.50.300:FF:007802', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(40758, NULL, 'G3DSA:3.40.50.300:FF:003952', NULL, NULL, 'Carbohydrate sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(40759, NULL, 'G3DSA:2.60.200.30:FF:000032', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(40760, NULL, 'G3DSA:1.20.91.20:FF:000007', NULL, NULL, 'Complement 4B (Chido blood group)', NULL, NULL, NULL, NULL, NULL, 4),
(40761, NULL, 'G3DSA:3.40.50.300:FF:000080', NULL, NULL, 'Ras-like GTPase Ras1', NULL, NULL, NULL, NULL, NULL, 4),
(40762, NULL, 'G3DSA:3.20.20.380:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40763, NULL, 'G3DSA:2.30.39.10:FF:000122', NULL, NULL, 'Serpin-2 precursor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40764, NULL, 'G3DSA:3.30.160.270:FF:000001', NULL, NULL, '2-isopropylmalate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(40765, NULL, 'G3DSA:1.10.8.280:FF:000003', NULL, NULL, 'UvrABC system protein A', NULL, NULL, NULL, NULL, NULL, 4),
(40766, NULL, 'G3DSA:3.30.710.10:FF:000399', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40767, NULL, 'G3DSA:2.60.200.40:FF:000035', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(40768, NULL, 'G3DSA:1.10.1450.10:FF:000013', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(40769, NULL, 'G3DSA:3.40.50.11840:FF:000009', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(40770, NULL, 'G3DSA:2.60.120.200:FF:000539', NULL, NULL, 'sex hormone-binding globulin-like', NULL, NULL, NULL, NULL, NULL, 4),
(40771, NULL, 'G3DSA:3.40.50.10180:FF:000006', NULL, NULL, 'Glycerate 2-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(40772, NULL, 'G3DSA:4.10.1060.10:FF:000032', NULL, NULL, 'Endonuclease/Exonuclease/phosphatase family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(40773, NULL, 'G3DSA:1.25.40.20:FF:000800', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40774, NULL, 'G3DSA:3.30.505.10:FF:000231', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40775, NULL, 'G3DSA:1.10.10.10:FF:000115', NULL, NULL, 'HTH-type transcriptional regulator MalT', NULL, NULL, NULL, NULL, NULL, 4),
(40776, NULL, 'G3DSA:1.25.10.10:FF:003314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40777, NULL, 'G3DSA:3.30.70.330:FF:000668', NULL, NULL, 'RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(40778, NULL, 'G3DSA:3.40.50.10190:FF:000009', NULL, NULL, 'DNA repair protein REV1', NULL, NULL, NULL, NULL, NULL, 4),
(40779, NULL, 'G3DSA:2.30.29.30:FF:000633', NULL, NULL, 'PH-protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(40780, NULL, 'G3DSA:1.20.1070.10:FF:000454', NULL, NULL, 'TYRAmine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(40781, NULL, 'G3DSA:3.40.50.1820:FF:000276', NULL, NULL, 'Acyl-protein thioesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(40782, NULL, 'G3DSA:3.40.50.300:FF:005857', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40783, NULL, 'G3DSA:3.40.605.10:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(40784, NULL, 'G3DSA:3.30.200.20:FF:001156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40785, NULL, 'G3DSA:3.40.50.1700:FF:000004', NULL, NULL, 'Periplasmic beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(40786, NULL, 'G3DSA:3.30.160.60:FF:004204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40787, NULL, 'G3DSA:1.10.287.600:FF:000002', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(40788, NULL, 'G3DSA:1.10.3380.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40789, NULL, 'G3DSA:2.70.50.30:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40790, NULL, 'G3DSA:3.40.50.1240:FF:000040', NULL, NULL, 'Phosphoglycerate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(40791, NULL, 'G3DSA:1.10.510.10:FF:001346', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40792, NULL, 'G3DSA:3.30.559.10:FF:000277', NULL, NULL, 'Choline oacetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40793, NULL, 'G3DSA:3.30.160.60:FF:001439', NULL, NULL, 'Trithorax-like, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(40794, NULL, 'G3DSA:3.40.50.11350:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40795, NULL, 'G3DSA:1.25.10.10:FF:001369', NULL, NULL, 'Rho family-interacting cell polarization regulator 2', NULL, NULL, NULL, NULL, NULL, 4),
(40796, NULL, 'G3DSA:1.20.1560.10:FF:000317', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(40797, NULL, 'G3DSA:1.10.287.370:FF:000079', NULL, NULL, 'Prefoldin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(40798, NULL, 'G3DSA:1.20.1730.10:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40799, NULL, 'G3DSA:2.40.240.10:FF:000022', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(40800, NULL, 'G3DSA:3.60.10.10:FF:000362', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40801, NULL, 'G3DSA:3.30.60.270:FF:000007', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(40802, NULL, 'G3DSA:2.30.29.30:FF:000942', NULL, NULL, 'G-protein subunit alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(40803, NULL, 'G3DSA:3.40.50.80:FF:000178', NULL, NULL, 'Ferric-chelate reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40804, NULL, 'G3DSA:1.10.510.10:FF:000025', NULL, NULL, 'Casein kinase I isoform gamma-1', NULL, NULL, NULL, NULL, NULL, 4),
(40805, NULL, 'G3DSA:3.40.50.1820:FF:000585', NULL, NULL, 'CBN-PCP-5 protein', NULL, NULL, NULL, NULL, NULL, 4),
(40806, NULL, 'G3DSA:1.10.287.610:FF:000005', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(40807, NULL, 'G3DSA:1.10.575.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40808, NULL, 'G3DSA:2.70.50.40:FF:000015', NULL, NULL, 'Phosphodiesterase 6D, cGMP-specific, rod, delta', NULL, NULL, NULL, NULL, NULL, 4),
(40809, NULL, 'G3DSA:3.40.720.10:FF:000212', NULL, NULL, 'Choline sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(40810, NULL, 'G3DSA:3.40.50.410:FF:000124', NULL, NULL, 'ATP-dependent DNA helicase II subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(40811, NULL, 'G3DSA:3.40.50.300:FF:005548', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(40812, NULL, 'G3DSA:4.10.400.10:FF:000213', NULL, NULL, 'Complement component C9', NULL, NULL, NULL, NULL, NULL, 4),
(40813, NULL, 'G3DSA:3.30.60.160:FF:000002', NULL, NULL, 'Polyhomeotic-like protein 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(40814, NULL, 'G3DSA:2.60.120.200:FF:000556', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40815, NULL, 'G3DSA:1.25.10.10:FF:003207', NULL, NULL, 'Protein CELLULOSE SYNTHASE INTERACTIVE 3', NULL, NULL, NULL, NULL, NULL, 4),
(40816, NULL, 'G3DSA:3.40.30.10:FF:000751', NULL, NULL, 'Peroxiredoxin-2', NULL, NULL, NULL, NULL, NULL, 4),
(40817, NULL, 'G3DSA:1.10.510.10:FF:003572', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40818, NULL, 'G3DSA:1.20.1250.20:FF:002337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(40819, NULL, 'G3DSA:1.20.58.60:FF:000588', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(40820, NULL, 'G3DSA:3.80.10.10:FF:004470', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40821, NULL, 'G3DSA:1.20.1270.60:FF:000208', NULL, NULL, 'YALI0C03245p', NULL, NULL, NULL, NULL, NULL, 4),
(40822, NULL, 'G3DSA:2.60.40.10:FF:003570', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40823, NULL, 'G3DSA:3.40.50.300:FF:003750', NULL, NULL, 'Dynamin 1 like', NULL, NULL, NULL, NULL, NULL, 4),
(40824, NULL, 'G3DSA:1.20.1250.20:FF:000971', NULL, NULL, 'WGS project CABT00000000 data, contig 2.10', NULL, NULL, NULL, NULL, NULL, 4),
(40825, NULL, 'G3DSA:3.40.50.80:FF:000088', NULL, NULL, 'Ferric-chelate reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40826, NULL, 'G3DSA:3.10.50.40:FF:000009', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(40827, NULL, 'G3DSA:2.60.40.60:FF:001089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40828, NULL, 'G3DSA:3.40.50.1820:FF:000692', NULL, NULL, 'Probable thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(40829, NULL, 'G3DSA:2.40.50.140:FF:000575', NULL, NULL, 'sn-glycerol-3-phosphate import ATP-binding protein UgpC', NULL, NULL, NULL, NULL, NULL, 4),
(40830, NULL, 'G3DSA:2.30.29.30:FF:001324', NULL, NULL, 'Histonearginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(40831, NULL, 'G3DSA:2.60.40.10:FF:003912', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40832, NULL, 'G3DSA:3.40.850.10:FF:000087', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(40833, NULL, 'G3DSA:3.40.140.10:FF:000201', NULL, NULL, 'Deoxycytidylate deaminase, putative (AFU_orthologue AFUA_2G06240)', NULL, NULL, NULL, NULL, NULL, 4),
(40834, NULL, 'G3DSA:3.30.420.10:FF:000545', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40835, NULL, 'G3DSA:1.10.287.4300:FF:000001', NULL, NULL, 'Stage III sporulation protein AH', NULL, NULL, NULL, NULL, NULL, 4),
(40836, NULL, 'G3DSA:2.70.160.11:FF:000066', NULL, NULL, 'Ribosomal protein L11 methyltransferase (PrmA)', NULL, NULL, NULL, NULL, NULL, 4),
(40837, NULL, 'G3DSA:3.20.20.70:FF:000174', NULL, NULL, 'Transaldolase type', NULL, NULL, NULL, NULL, NULL, 4),
(40838, NULL, 'G3DSA:2.70.98.30:FF:000026', NULL, NULL, 'Alpha-mannosidase F', NULL, NULL, NULL, NULL, NULL, 4),
(40839, NULL, 'G3DSA:4.10.240.10:FF:000206', NULL, NULL, 'Probable transcriptional repressor C1348.12', NULL, NULL, NULL, NULL, NULL, 4),
(40840, NULL, 'G3DSA:1.50.10.10:FF:000125', NULL, NULL, 'Meiotically up-regulated gene 157 protein', NULL, NULL, NULL, NULL, NULL, 4),
(40841, NULL, 'G3DSA:3.30.70.330:FF:000578', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(40842, NULL, 'G3DSA:1.10.640.10:FF:000046', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(40843, NULL, 'G3DSA:1.10.3370.10:FF:000007', NULL, NULL, 'Sec61 translocon alpha 2 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(40844, NULL, 'G3DSA:3.40.50.1820:FF:001107', NULL, NULL, 'Lipase family member K', NULL, NULL, NULL, NULL, NULL, 4),
(40845, NULL, 'G3DSA:3.40.50.300:FF:001496', NULL, NULL, 'Translation factor GUF1 homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(40846, NULL, 'G3DSA:3.30.60.90:FF:000002', NULL, NULL, 'Dystrobrevin alpha', NULL, NULL, NULL, NULL, NULL, 4),
(40847, NULL, 'G3DSA:3.30.420.10:FF:000309', NULL, NULL, 'Target of EGR1, exonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(40848, NULL, 'G3DSA:3.20.20.80:FF:000177', NULL, NULL, 'MANEAL isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(40849, NULL, 'G3DSA:3.30.1740.10:FF:000029', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(40850, NULL, 'G3DSA:3.30.70.330:FF:001202', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(40851, NULL, 'G3DSA:1.20.1070.10:FF:000763', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40852, NULL, 'G3DSA:1.10.287.70:FF:000534', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(40853, NULL, 'G3DSA:3.10.20.410:FF:000001', NULL, NULL, 'Fimbrial outer membrane usher protein', NULL, NULL, NULL, NULL, NULL, 4),
(40854, NULL, 'G3DSA:3.90.245.10:FF:000017', NULL, NULL, 'Related to nucleoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(40855, NULL, 'G3DSA:1.10.510.10:FF:000042', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(40856, NULL, 'G3DSA:1.10.540.10:FF:000072', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(40857, NULL, 'G3DSA:2.130.10.10:FF:005716', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(40858, NULL, 'G3DSA:1.10.30.10:FF:000010', NULL, NULL, 'Capicua transcriptional repressor b', NULL, NULL, NULL, NULL, NULL, 4),
(40859, NULL, 'G3DSA:1.10.630.10:FF:000298', NULL, NULL, 'Cytochrome P450, family 2, subfamily C, polypeptide 8, gene 2', NULL, NULL, NULL, NULL, NULL, 4),
(40860, NULL, 'G3DSA:2.130.10.10:FF:001299', NULL, NULL, 'Probable cytosolic iron-sulfur protein assembly protein CIAO1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(40861, NULL, 'G3DSA:3.60.40.10:FF:000083', NULL, NULL, 'Stage II sporulation protein E', NULL, NULL, NULL, NULL, NULL, 4),
(40862, NULL, 'G3DSA:1.20.5.170:FF:000283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40863, NULL, 'G3DSA:3.40.50.720:FF:002358', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40864, NULL, 'G3DSA:1.25.10.10:FF:002212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40865, NULL, 'G3DSA:3.20.20.60:FF:000064', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(40866, NULL, 'G3DSA:2.20.25.240:FF:000011', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(40867, NULL, 'G3DSA:3.20.20.70:FF:000522', NULL, NULL, 'Dihydroorotate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(40868, NULL, 'G3DSA:3.40.630.30:FF:000059', NULL, NULL, 'Putative acetyltransferase NSI', NULL, NULL, NULL, NULL, NULL, 4),
(40869, NULL, 'G3DSA:1.10.1410.20:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40870, NULL, 'G3DSA:2.40.50.140:FF:000682', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40871, NULL, 'G3DSA:2.40.240.10:FF:000038', NULL, NULL, 'Putative glutaminyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(40872, NULL, 'G3DSA:1.25.10.10:FF:001588', NULL, NULL, 'Adaptin N terminal region family protein', NULL, NULL, NULL, NULL, NULL, 4),
(40873, NULL, 'G3DSA:1.20.1740.10:FF:000073', NULL, NULL, 'Y+L amino acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(40874, NULL, 'G3DSA:3.40.50.1010:FF:000218', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40875, NULL, 'G3DSA:3.20.20.70:FF:000067', NULL, NULL, 'tRNA-dihydrouridine(47) synthase [NAD(P)(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(40876, NULL, 'G3DSA:1.10.3720.10:FF:000012', NULL, NULL, 'Histidine ABC transporter permease HisM', NULL, NULL, NULL, NULL, NULL, 4),
(40877, NULL, 'G3DSA:3.30.70.330:FF:002000', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40878, NULL, 'G3DSA:2.10.50.10:FF:000060', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 3', NULL, NULL, NULL, NULL, NULL, 4),
(40879, NULL, 'G3DSA:3.40.50.300:FF:000170', NULL, NULL, 'Mitochondrial Rho GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(40880, NULL, 'G3DSA:3.30.160.60:FF:005278', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40881, NULL, 'G3DSA:3.10.20.90:FF:000028', NULL, NULL, 'Talin 2', NULL, NULL, NULL, NULL, NULL, 4),
(40882, NULL, 'G3DSA:2.60.40.640:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40883, NULL, 'G3DSA:3.40.50.300:FF:003643', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(40884, NULL, 'G3DSA:3.40.50.1000:FF:000215', NULL, NULL, 'Trehalose 6-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(40885, NULL, 'G3DSA:3.40.50.150:FF:000017', NULL, NULL, 'probable 18S rRNA (Guanine-N(7))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(40886, NULL, 'G3DSA:2.60.40.10:FF:001658', NULL, NULL, 'Glycoside hydrolase family 2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(40887, NULL, 'G3DSA:1.10.1410.10:FF:000011', NULL, NULL, 'Poly(A) polymerase alpha', NULL, NULL, NULL, NULL, NULL, 4),
(40888, NULL, 'G3DSA:3.20.20.80:FF:000525', NULL, NULL, 'Malto-oligosyltrehalose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(40889, NULL, 'G3DSA:3.40.1110.10:FF:000148', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(40890, NULL, 'G3DSA:3.30.420.40:FF:000402', NULL, NULL, 'Actin-related protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(40891, NULL, 'G3DSA:3.40.50.150:FF:001647', NULL, NULL, 'tRNA (adenine(58)-N(1))-methyltransferase TrmI', NULL, NULL, NULL, NULL, NULL, 4),
(40892, NULL, 'G3DSA:3.40.50.10190:FF:000245', NULL, NULL, 'Nucleomorphin', NULL, NULL, NULL, NULL, NULL, 4),
(40893, NULL, 'G3DSA:2.10.60.10:FF:000032', NULL, NULL, 'TGF-beta receptor type-2', NULL, NULL, NULL, NULL, NULL, 4),
(40894, NULL, 'G3DSA:3.90.190.10:FF:000272', NULL, NULL, 'Tyrosine-protein phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(40895, NULL, 'G3DSA:1.25.40.10:FF:003035', NULL, NULL, 'Pentatricopeptide repeat-containing protein DOT4, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(40896, NULL, 'G3DSA:3.20.20.140:FF:000159', NULL, NULL, 'Putative adenosine monophosphate deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(40897, NULL, 'G3DSA:3.40.50.300:FF:001844', NULL, NULL, 'Dynein heavy chain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(40898, NULL, 'G3DSA:1.25.40.10:FF:001427', NULL, NULL, 'Small glutamine-rich tetratricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(40899, NULL, 'G3DSA:1.20.190.10:FF:000003', NULL, NULL, 'Cry21a', NULL, NULL, NULL, NULL, NULL, 4),
(40900, NULL, 'G3DSA:2.130.10.10:FF:005368', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40901, NULL, 'G3DSA:2.40.50.100:FF:000102', NULL, NULL, 'KGD2p Dihydrolipoyl transsuccinylase', NULL, NULL, NULL, NULL, NULL, 4),
(40902, NULL, 'G3DSA:3.40.50.1820:FF:000366', NULL, NULL, 'Phenyloxazoline synthase MbtB', NULL, NULL, NULL, NULL, NULL, 4),
(40903, NULL, 'G3DSA:1.10.8.10:FF:000367', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40904, NULL, 'G3DSA:1.10.630.10:FF:000444', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40905, NULL, 'G3DSA:3.40.50.410:FF:000129', NULL, NULL, 'Probable E3 ubiquitin-protein ligase EDA40', NULL, NULL, NULL, NULL, NULL, 4),
(40906, NULL, 'G3DSA:3.60.10.10:FF:000378', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40907, NULL, 'G3DSA:3.80.10.10:FF:000428', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(40908, NULL, 'G3DSA:2.40.50.140:FF:000917', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40909, NULL, 'G3DSA:3.90.640.10:FF:000228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40910, NULL, 'G3DSA:2.30.30.1020:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40911, NULL, 'G3DSA:3.40.50.200:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40912, NULL, 'G3DSA:3.30.420.10:FF:000219', NULL, NULL, 'Putative retroelement', NULL, NULL, NULL, NULL, NULL, 4),
(40913, NULL, 'G3DSA:1.10.560.10:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40914, NULL, 'G3DSA:2.30.42.10:FF:000591', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40915, NULL, 'G3DSA:2.130.10.10:FF:001445', NULL, NULL, 'Protein TRANSPARENT TESTA GLABRA, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40916, NULL, 'G3DSA:1.25.40.120:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40917, NULL, 'G3DSA:2.60.40.10:FF:005368', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40918, NULL, 'G3DSA:3.30.9.10:FF:000062', NULL, NULL, 'Os07g0155100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(40919, NULL, 'G3DSA:3.40.50.300:FF:001698', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(40920, NULL, 'G3DSA:1.10.10.60:FF:001288', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40921, NULL, 'G3DSA:1.25.40.20:FF:001672', NULL, NULL, 'Guard cell S-type anion channel SLAC1', NULL, NULL, NULL, NULL, NULL, 4),
(40922, NULL, 'G3DSA:1.20.58.390:FF:000016', NULL, NULL, 'Putative acetylcholine receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(40923, NULL, 'G3DSA:1.10.4020.10:FF:000004', NULL, NULL, 'Zinc finger and SCAN domain containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(40924, NULL, 'G3DSA:3.40.50.1000:FF:000108', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(40925, NULL, 'G3DSA:1.20.1310.10:FF:000012', NULL, NULL, 'Cullin 2', NULL, NULL, NULL, NULL, NULL, 4),
(40926, NULL, 'G3DSA:3.30.420.10:FF:000635', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40927, NULL, 'G3DSA:3.30.70.330:FF:001421', NULL, NULL, 'RNA-binding protein LARK', NULL, NULL, NULL, NULL, NULL, 4),
(40928, NULL, 'G3DSA:1.10.437.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40929, NULL, 'G3DSA:1.20.1310.20:FF:000015', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(40930, NULL, 'G3DSA:3.20.70.20:FF:000050', NULL, NULL, 'Glr3745 protein', NULL, NULL, NULL, NULL, NULL, 4),
(40931, NULL, 'G3DSA:3.30.70.1970:FF:000003', NULL, NULL, 'RNA editing 3'' terminal uridylyl transferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(40932, NULL, 'G3DSA:3.60.21.10:FF:000044', NULL, NULL, 'acid sphingomyelinase-like phosphodiesterase 3a', NULL, NULL, NULL, NULL, NULL, 4),
(40933, NULL, 'G3DSA:3.20.20.80:FF:000396', NULL, NULL, 'Oligo-1,6-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(40934, NULL, 'G3DSA:1.25.40.10:FF:003344', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(40935, NULL, 'G3DSA:3.30.420.40:FF:000060', NULL, NULL, 'Bifunctional UDP-N-acetylglucosamine 2-epimerase/N-acetylmannosamine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(40936, NULL, 'G3DSA:3.40.50.300:FF:004222', NULL, NULL, 'Os02g0288700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(40937, NULL, 'G3DSA:1.20.1070.10:FF:000437', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(40938, NULL, 'G3DSA:3.40.605.10:FF:000124', NULL, NULL, 'Gamma-glutamyl phosphate reductase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(40939, NULL, 'G3DSA:3.30.559.10:FF:000075', NULL, NULL, 'Spermidine hydroxycinnamoyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(40940, NULL, 'G3DSA:1.10.510.10:FF:000351', NULL, NULL, 'PAS domain-containing serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(40941, NULL, 'G3DSA:3.40.50.410:FF:000096', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(40942, NULL, 'G3DSA:3.80.10.10:FF:000754', NULL, NULL, 'CCR4-NOT transcriptional complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(40943, NULL, 'G3DSA:3.30.160.60:FF:000130', NULL, NULL, 'Spalt-like transcription factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(40944, NULL, 'G3DSA:3.10.20.310:FF:000050', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(40945, NULL, 'G3DSA:1.10.246.190:FF:000005', NULL, NULL, 'Autophagy protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(40946, NULL, 'G3DSA:2.120.10.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40947, NULL, 'G3DSA:3.40.50.300:FF:001389', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(40948, NULL, 'G3DSA:2.60.120.920:FF:000064', NULL, NULL, 'AGAP009295-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(40949, NULL, 'G3DSA:1.20.1070.10:FF:000089', NULL, NULL, '5-hydroxytryptamine receptor 5A', NULL, NULL, NULL, NULL, NULL, 4),
(40950, NULL, 'G3DSA:1.10.287.70:FF:000315', NULL, NULL, 'GM16780', NULL, NULL, NULL, NULL, NULL, 4),
(40951, NULL, 'G3DSA:4.10.240.10:FF:000190', NULL, NULL, 'Hal9p', NULL, NULL, NULL, NULL, NULL, 4),
(40952, NULL, 'G3DSA:3.20.20.70:FF:000393', NULL, NULL, 'WGS project CABT00000000 data, contig 2.5', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(40953, NULL, 'G3DSA:3.20.20.140:FF:000069', NULL, NULL, 'Adenosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(40954, NULL, 'G3DSA:3.40.950.10:FF:000021', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', NULL, NULL, NULL, NULL, NULL, 4),
(40955, NULL, 'G3DSA:1.10.1520.10:FF:000042', NULL, NULL, 'Ribonuclease 3', NULL, NULL, NULL, NULL, NULL, 4),
(40956, NULL, 'G3DSA:1.20.58.390:FF:000106', NULL, NULL, 'ACHA7', NULL, NULL, NULL, NULL, NULL, 4),
(40957, NULL, 'G3DSA:3.30.160.270:FF:000006', NULL, NULL, '2-isopropylmalate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(40958, NULL, 'G3DSA:3.20.20.10:FF:000072', NULL, NULL, 'Antizyme inhibitor 1a', NULL, NULL, NULL, NULL, NULL, 4),
(40959, NULL, 'G3DSA:3.40.50.10190:FF:000335', NULL, NULL, 'Meiotically up-regulated gene 176 protein', NULL, NULL, NULL, NULL, NULL, 4),
(40960, NULL, 'G3DSA:3.40.630.30:FF:000424', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40961, NULL, 'G3DSA:1.20.1560.10:FF:000199', NULL, NULL, 'ABC transporter transmembrane region', NULL, NULL, NULL, NULL, NULL, 4),
(40962, NULL, 'G3DSA:1.10.357.140:FF:000033', NULL, NULL, 'Protoheme IX farnesyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(40963, NULL, 'G3DSA:2.30.30.40:FF:000122', NULL, NULL, 'intersectin-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(40964, NULL, 'G3DSA:2.60.120.330:FF:000112', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(40965, NULL, 'G3DSA:3.30.710.10:FF:000394', NULL, NULL, 'AGAP008959-PA', NULL, NULL, NULL, NULL, NULL, 4),
(40966, NULL, 'G3DSA:3.40.50.450:FF:000001', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(40967, NULL, 'G3DSA:2.30.30.190:FF:000026', NULL, NULL, 'CYLinDromatosis (Human disease gene) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(40968, NULL, 'G3DSA:3.80.10.10:FF:000445', NULL, NULL, 'Oligodendrocyte myelin glycoprotein b', NULL, NULL, NULL, NULL, NULL, 4),
(40969, NULL, 'G3DSA:1.20.1270.60:FF:000315', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40970, NULL, 'G3DSA:3.10.250.10:FF:000143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40971, NULL, 'G3DSA:3.60.110.10:FF:000083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40972, NULL, 'G3DSA:1.10.510.10:FF:003605', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40973, NULL, 'G3DSA:3.30.1670.10:FF:000001', NULL, NULL, '3-mercaptopyruvate sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(40974, NULL, 'G3DSA:3.30.160.60:FF:003480', NULL, NULL, 'zinc finger protein isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(40975, NULL, 'G3DSA:1.10.510.10:FF:001801', NULL, NULL, 'Tyrosine kinase receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40976, NULL, 'G3DSA:3.30.980.10:FF:000019', NULL, NULL, 'tRNA synthetases class II (A)/Threonyl and Alanyl tRNA synthetase second additional domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(40977, NULL, 'G3DSA:3.30.710.10:FF:000085', NULL, NULL, 'Kelch-like family member 14', NULL, NULL, NULL, NULL, NULL, 4),
(40978, NULL, 'G3DSA:3.30.460.10:FF:000104', NULL, NULL, 'Ribosomal silencing factor RsfS', NULL, NULL, NULL, NULL, NULL, 4),
(40979, NULL, 'G3DSA:3.90.1290.10:FF:000003', NULL, NULL, 'microtubule-actin cross-linking factor 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(40980, NULL, 'G3DSA:1.20.58.90:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40981, NULL, 'G3DSA:1.10.10.160:FF:000038', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(40982, NULL, 'G3DSA:3.40.50.300:FF:007095', NULL, NULL, 'ADP-ribosylation factor family protein', NULL, NULL, NULL, NULL, NULL, 4),
(40983, NULL, 'G3DSA:3.30.70.330:FF:001730', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40984, NULL, 'G3DSA:3.40.390.10:FF:000169', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40985, NULL, 'G3DSA:1.10.510.10:FF:004403', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40986, NULL, 'G3DSA:1.20.1250.20:FF:000662', NULL, NULL, 'Thymidylate kinase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(40987, NULL, 'G3DSA:3.40.30.10:FF:000190', NULL, NULL, 'Peroxiredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(40988, NULL, 'G3DSA:3.40.1110.10:FF:000058', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(40989, NULL, 'G3DSA:1.10.510.10:FF:003263', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40990, NULL, 'G3DSA:3.30.930.10:FF:000382', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40991, NULL, 'G3DSA:2.80.10.50:FF:000127', NULL, NULL, 'Fibroblast growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(40992, NULL, 'G3DSA:2.60.40.1970:FF:000007', NULL, NULL, 'Protein AF-9 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(40993, NULL, 'G3DSA:3.30.450.20:FF:000359', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(40994, NULL, 'G3DSA:3.40.50.10190:FF:000026', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(40995, NULL, 'G3DSA:3.40.1110.10:FF:000367', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(40996, NULL, 'G3DSA:1.10.10.10:FF:001880', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(40997, NULL, 'G3DSA:2.130.10.10:FF:001664', NULL, NULL, 'suppressor of mec-8 and unc-52 protein homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(40998, NULL, 'G3DSA:3.60.10.10:FF:000255', NULL, NULL, 'Endonuclease/exonuclease/phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(40999, NULL, 'G3DSA:1.10.10.10:FF:000008', NULL, NULL, 'E2F transcription factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(41000, NULL, 'G3DSA:1.20.1560.10:FF:000289', NULL, NULL, 'ABC transporter B family member 11 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(41001, NULL, 'G3DSA:3.50.50.60:FF:001183', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(41002, NULL, 'G3DSA:1.10.10.440:FF:000004', NULL, NULL, 'Transcription elongation regulator 1 like', NULL, NULL, NULL, NULL, NULL, 4),
(41003, NULL, 'G3DSA:2.60.120.970:FF:000056', NULL, NULL, 'Myoglianin', NULL, NULL, NULL, NULL, NULL, 4),
(41004, NULL, 'G3DSA:1.10.510.10:FF:003914', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41005, NULL, 'G3DSA:1.25.40.10:FF:002978', NULL, NULL, 'Pre-mRNA-splicing factor CLF1', NULL, NULL, NULL, NULL, NULL, 4),
(41006, NULL, 'G3DSA:2.60.40.10:FF:001877', NULL, NULL, 'LOC100170443 protein', NULL, NULL, NULL, NULL, NULL, 4),
(41007, NULL, 'G3DSA:1.10.300.10:FF:000009', NULL, NULL, 'Adenylosuccinate synthetase 2', NULL, NULL, NULL, NULL, NULL, 4),
(41008, NULL, 'G3DSA:2.130.10.10:FF:001973', NULL, NULL, 'Ribosome biogenesis protein YTM1', NULL, NULL, NULL, NULL, NULL, 4),
(41009, NULL, 'G3DSA:2.40.50.1070:FF:000001', NULL, NULL, 'tRNA/tmRNA (uracil-C(5))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(41010, NULL, 'G3DSA:3.30.2410.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41011, NULL, 'G3DSA:3.20.200.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41012, NULL, 'G3DSA:2.130.10.10:FF:003570', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41013, NULL, 'G3DSA:2.30.29.30:FF:001015', NULL, NULL, 'IQ motif and Sec7 domain 3a', NULL, NULL, NULL, NULL, NULL, 4),
(41014, NULL, 'G3DSA:4.10.60.10:FF:000100', NULL, NULL, 'Arginine/serine-rich splicing factor RSZ23 transcript III', NULL, NULL, NULL, NULL, NULL, 4),
(41015, NULL, 'G3DSA:2.10.110.10:FF:000199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41016, NULL, 'G3DSA:3.30.930.10:FF:000073', NULL, NULL, 'Biotin--protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(41017, NULL, 'G3DSA:3.40.50.410:FF:000348', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(41018, NULL, 'G3DSA:3.10.290.10:FF:000011', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(41019, NULL, 'G3DSA:3.30.70.260:FF:000080', NULL, NULL, 'Ribose 5-phosphate isomerase A', NULL, NULL, NULL, NULL, NULL, 4),
(41020, NULL, 'G3DSA:1.10.10.430:FF:000001', NULL, NULL, 'protein phosphatase 1B isoform X1', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(41021, NULL, 'G3DSA:1.25.40.10:FF:000123', NULL, NULL, '43 kDa receptor-associated protein of the synapse', NULL, NULL, NULL, NULL, NULL, 4),
(41022, NULL, 'G3DSA:3.30.365.10:FF:000023', NULL, NULL, 'Aldehyde oxidase4', NULL, NULL, NULL, NULL, NULL, 4),
(41023, NULL, 'G3DSA:3.30.160.60:FF:001911', NULL, NULL, 'zinc finger protein 624 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(41024, NULL, 'G3DSA:1.50.40.10:FF:000508', NULL, NULL, 'ADP,ATP carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(41025, NULL, 'G3DSA:3.80.10.10:FF:000900', NULL, NULL, 'Leucine-rich repeat transmembrane protein kinase, putative, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(41026, NULL, 'G3DSA:3.20.20.140:FF:000053', NULL, NULL, 'Ribonuclease P complex subunit Pop2', NULL, NULL, NULL, NULL, NULL, 4),
(41027, NULL, 'G3DSA:1.25.40.20:FF:000126', NULL, NULL, 'Kinase D-interacting substrate of 220 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(41028, NULL, 'G3DSA:2.40.50.140:FF:000991', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41029, NULL, 'G3DSA:1.20.1070.10:FF:001151', NULL, NULL, 'Olfactory receptor 4A16', NULL, NULL, NULL, NULL, NULL, 4),
(41030, NULL, 'G3DSA:1.20.120.350:FF:000004', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(41031, NULL, 'G3DSA:2.30.30.770:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41032, NULL, 'G3DSA:3.30.60.30:FF:000102', NULL, NULL, 'GEO10195p1', NULL, NULL, NULL, NULL, NULL, 4),
(41033, NULL, 'G3DSA:1.25.10.10:FF:003281', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(41034, NULL, 'G3DSA:3.40.250.10:FF:000209', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(41035, NULL, 'G3DSA:3.30.460.10:FF:000093', NULL, NULL, 'Interleukin enhancer-binding factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(41036, NULL, 'G3DSA:2.130.10.10:FF:003463', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41037, NULL, 'G3DSA:3.20.20.100:FF:000092', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(41038, NULL, 'G3DSA:2.170.300.10:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41039, NULL, 'G3DSA:3.30.930.10:FF:000157', NULL, NULL, 'Seryl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41040, NULL, 'G3DSA:2.60.40.10:FF:002501', NULL, NULL, 'Colony stimulating factor 1 receptor, a', NULL, NULL, NULL, NULL, NULL, 4),
(41041, NULL, 'G3DSA:4.10.1000.10:FF:000034', NULL, NULL, 'pre-mRNA-splicing factor RBM22', NULL, NULL, NULL, NULL, NULL, 4),
(41042, NULL, 'G3DSA:3.30.230.10:FF:000391', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41043, NULL, 'G3DSA:3.40.50.150:FF:001428', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41044, NULL, 'G3DSA:1.20.58.1610:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41045, NULL, 'G3DSA:3.40.50.1820:FF:001080', NULL, NULL, 'AaceriAFR601Cp', NULL, NULL, NULL, NULL, NULL, 4),
(41046, NULL, 'G3DSA:3.60.10.10:FF:000272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41047, NULL, 'G3DSA:1.20.120.610:FF:000026', NULL, NULL, 'ATPase, F0/V0 complex, subunit C protein', NULL, NULL, NULL, NULL, NULL, 4),
(41048, NULL, 'G3DSA:1.20.120.910:FF:000009', NULL, NULL, 'Uncharacterized protein HI_1497', NULL, NULL, NULL, NULL, NULL, 4),
(41049, NULL, 'G3DSA:1.25.40.10:FF:001652', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(41050, NULL, 'G3DSA:1.10.8.60:FF:000270', NULL, NULL, 'AAA family ATPase putative', NULL, NULL, NULL, NULL, NULL, 4),
(41051, NULL, 'G3DSA:3.80.10.10:FF:000776', NULL, NULL, 'Transforming growth factor beta activator LRRC33', NULL, NULL, NULL, NULL, NULL, 4),
(41052, NULL, 'G3DSA:3.40.50.1820:FF:000618', NULL, NULL, 'Lipase', NULL, NULL, NULL, NULL, NULL, 4),
(41053, NULL, 'G3DSA:1.20.1420.10:FF:000015', NULL, NULL, 'Talin 2b', NULL, NULL, NULL, NULL, NULL, 4),
(41054, NULL, 'G3DSA:2.70.50.80:FF:000004', NULL, NULL, 'TEA domain transcription factor 1', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(41055, NULL, 'G3DSA:1.10.730.20:FF:000011', NULL, NULL, 'Isoleucyl-tRNA synthetase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(41056, NULL, 'G3DSA:1.25.40.20:FF:001655', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41057, NULL, 'G3DSA:1.10.510.10:FF:003931', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41058, NULL, 'G3DSA:1.10.10.10:FF:001554', NULL, NULL, 'DDE-recombinase A', NULL, NULL, NULL, NULL, NULL, 4),
(41059, NULL, 'G3DSA:3.40.30.10:FF:000442', NULL, NULL, 'Dolichyl-diphosphooligosaccharide--protein glycosyltransferase subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(41060, NULL, 'G3DSA:3.90.1720.10:FF:000003', NULL, NULL, 'FAM84B isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(41061, NULL, 'G3DSA:1.10.510.10:FF:001790', NULL, NULL, 'Protein CBG20999', NULL, NULL, NULL, NULL, NULL, 4),
(41062, NULL, 'G3DSA:1.10.1580.10:FF:000034', NULL, NULL, 'Nucleolar GTP-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(41063, NULL, 'G3DSA:2.30.42.10:FF:000574', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41064, NULL, 'G3DSA:3.20.20.190:FF:000062', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(41065, NULL, 'G3DSA:1.20.120.340:FF:000001', NULL, NULL, 'Flagellar secretion chaperone FliS', NULL, NULL, NULL, NULL, NULL, 4),
(41066, NULL, 'G3DSA:2.60.40.10:FF:003603', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41067, NULL, 'G3DSA:3.40.50.300:FF:003278', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(41068, NULL, 'G3DSA:2.30.110.10:FF:000071', NULL, NULL, 'Pyridoxamine 5''-phosphate oxidase-related FMN-binding', NULL, NULL, NULL, NULL, NULL, 4),
(41069, NULL, 'G3DSA:1.10.150.20:FF:000186', NULL, NULL, 'YALI0B22242p', NULL, NULL, NULL, NULL, NULL, 4),
(41070, NULL, 'G3DSA:1.20.1560.10:FF:000761', NULL, NULL, 'Multidrug resistance-associated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41071, NULL, 'G3DSA:3.30.420.110:FF:000030', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(41072, NULL, 'G3DSA:1.20.1250.20:FF:002354', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41073, NULL, 'G3DSA:1.20.5.170:FF:000081', NULL, NULL, 'Nestin', NULL, NULL, NULL, NULL, NULL, 4),
(41074, NULL, 'G3DSA:3.90.1720.30:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41075, NULL, 'G3DSA:3.40.50.11540:FF:000004', NULL, NULL, 'Ion-translocating oxidoreductase complex subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(41076, NULL, 'G3DSA:1.20.5.110:FF:000214', NULL, NULL, 'Yeast SEC homolog', NULL, NULL, NULL, NULL, NULL, 4),
(41077, NULL, 'G3DSA:1.10.10.160:FF:000044', NULL, NULL, 'AaceriAFR093Wp', NULL, NULL, NULL, NULL, NULL, 4),
(41078, NULL, 'G3DSA:1.25.40.120:FF:000045', NULL, NULL, 'YALI0E13662p', NULL, NULL, NULL, NULL, NULL, 4),
(41079, NULL, 'G3DSA:3.30.160.60:FF:003564', NULL, NULL, 'Zinc finger protein 440', NULL, NULL, NULL, NULL, NULL, 4),
(41080, NULL, 'G3DSA:3.30.160.60:FF:006312', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41081, NULL, 'G3DSA:1.20.58.60:FF:000627', NULL, NULL, 'Spectrin repeat-containing, nuclear envelope 1b', NULL, NULL, NULL, NULL, NULL, 4),
(41082, NULL, 'G3DSA:3.40.570.10:FF:000048', NULL, NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase 3', NULL, NULL, NULL, NULL, NULL, 4),
(41083, NULL, 'G3DSA:1.10.8.60:FF:000466', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41084, NULL, 'G3DSA:2.60.120.200:FF:000197', NULL, NULL, 'Blast:Protein eyes shut', NULL, NULL, NULL, NULL, NULL, 4),
(41085, NULL, 'G3DSA:1.20.1310.20:FF:000032', NULL, NULL, 'Erythrocyte membrane protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(41086, NULL, 'G3DSA:3.40.50.11660:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41087, NULL, 'G3DSA:3.30.1330.30:FF:000105', NULL, NULL, 'Uncharacterized protein P883.19', NULL, NULL, NULL, NULL, NULL, 4),
(41088, NULL, 'G3DSA:1.20.120.350:FF:000111', NULL, NULL, 'Cation channel sperm-associated protein 3', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(41089, NULL, 'G3DSA:2.30.30.140:FF:000152', NULL, NULL, 'GM14014p', NULL, NULL, NULL, NULL, NULL, 4),
(41090, NULL, 'G3DSA:3.40.50.11530:FF:000001', NULL, NULL, 'interleukin-17 receptor C isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(41091, NULL, 'G3DSA:1.10.3730.20:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41092, NULL, 'G3DSA:3.40.50.300:FF:007549', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41093, NULL, 'G3DSA:2.60.40.10:FF:004210', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41094, NULL, 'G3DSA:2.30.30.490:FF:000037', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(41095, NULL, 'G3DSA:2.40.128.20:FF:000005', NULL, NULL, 'Retinol binding protein 4, like', NULL, NULL, NULL, NULL, NULL, 4),
(41096, NULL, 'G3DSA:3.20.20.80:FF:000087', NULL, NULL, 'Oligo-1,6-glucosidase IMA1', NULL, NULL, NULL, NULL, NULL, 4),
(41097, NULL, 'G3DSA:1.10.246.190:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41098, NULL, 'G3DSA:1.25.40.10:FF:004890', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41099, NULL, 'G3DSA:3.40.50.1010:FF:000022', NULL, NULL, 'DNA repair protein complementing XP-G cells homolog', NULL, NULL, NULL, NULL, NULL, 4),
(41100, NULL, 'G3DSA:3.30.160.60:FF:004171', NULL, NULL, 'LD39664p', NULL, NULL, NULL, NULL, NULL, 4),
(41101, NULL, 'G3DSA:3.90.190.10:FF:000468', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41102, NULL, 'G3DSA:3.30.420.40:FF:000779', NULL, NULL, 'YALI0B10934p', NULL, NULL, NULL, NULL, NULL, 4),
(41103, NULL, 'G3DSA:3.30.1360.40:FF:000043', NULL, NULL, 'DNA topoisomerase IV, ATP/GTP binding site', NULL, NULL, NULL, NULL, NULL, 4),
(41104, NULL, 'G3DSA:1.25.40.10:FF:001904', NULL, NULL, 'Exomer complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(41105, NULL, 'G3DSA:3.10.350.10:FF:000089', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(41106, NULL, 'G3DSA:3.40.50.2300:FF:000639', NULL, NULL, 'GLutamate Receptor family (AMPA)', NULL, NULL, NULL, NULL, NULL, 4),
(41107, NULL, 'G3DSA:3.30.420.140:FF:000039', NULL, NULL, 'SH2 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(41108, NULL, 'G3DSA:3.40.50.300:FF:007460', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41109, NULL, 'G3DSA:3.30.1150.10:FF:000001', NULL, NULL, 'Cell envelope integrity protein TolA', NULL, NULL, NULL, NULL, NULL, 4),
(41110, NULL, 'G3DSA:1.10.472.80:FF:000237', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41111, NULL, 'G3DSA:4.10.240.10:FF:000223', NULL, NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(41112, NULL, 'G3DSA:3.60.40.10:FF:000189', NULL, NULL, 'Probable protein phosphatase 2C 61', NULL, NULL, NULL, NULL, NULL, 4),
(41113, NULL, 'G3DSA:3.30.572.10:FF:000010', NULL, NULL, 'Thymidylate synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(41114, NULL, 'G3DSA:3.30.930.10:FF:000409', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(41115, NULL, 'G3DSA:3.40.250.10:FF:000013', NULL, NULL, 'Dual specificity phosphatase 10 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(41116, NULL, 'G3DSA:2.60.40.10:FF:001349', NULL, NULL, 'Jitterbug, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(41117, NULL, 'G3DSA:3.40.80.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41118, NULL, 'G3DSA:2.60.320.10:FF:000001', NULL, NULL, 'Transcription termination/antitermination protein NusG', NULL, NULL, NULL, NULL, NULL, 4),
(41119, NULL, 'G3DSA:1.10.533.10:FF:000050', NULL, NULL, 'E3 ubiquitin-protein ligase XIAP', NULL, NULL, NULL, NULL, NULL, 4),
(41120, NULL, 'G3DSA:2.70.130.10:FF:000012', NULL, NULL, 'Insulin-like growth factor 2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(41121, NULL, 'G3DSA:3.40.50.2300:FF:000971', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41122, NULL, 'G3DSA:1.20.58.2220:FF:000002', NULL, NULL, 'Dishevelled associated activator of morphogenesis 1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(41123, NULL, 'G3DSA:1.20.1250.20:FF:000645', NULL, NULL, 'Autophagy-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(41124, NULL, 'G3DSA:1.20.272.40:FF:000017', NULL, NULL, 'AGAP012862-PA', NULL, NULL, NULL, NULL, NULL, 4),
(41125, NULL, 'G3DSA:3.40.50.10330:FF:000074', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(41126, NULL, 'G3DSA:1.20.1070.10:FF:000785', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41127, NULL, 'G3DSA:3.90.550.10:FF:000131', NULL, NULL, 'Glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(41128, NULL, 'G3DSA:3.40.1190.20:FF:000055', NULL, NULL, 'Hydroxyethylthiazole kinase', NULL, NULL, NULL, NULL, NULL, 4),
(41129, NULL, 'G3DSA:1.10.630.10:FF:000219', NULL, NULL, 'Putative inactive cytochrome P450 2G1', NULL, NULL, NULL, NULL, NULL, 4),
(41130, NULL, 'G3DSA:3.90.1200.10:FF:000054', NULL, NULL, 'Spore coat, CotS family protein', NULL, NULL, NULL, NULL, NULL, 4),
(41131, NULL, 'G3DSA:3.40.20.10:FF:000161', NULL, NULL, 'Protovillin', NULL, NULL, NULL, NULL, NULL, 4),
(41132, NULL, 'G3DSA:3.40.50.800:FF:000117', NULL, NULL, 'Ornithine carbamoyltransferase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(41133, NULL, 'G3DSA:1.20.58.60:FF:000734', NULL, NULL, 'Protein CBG15811', NULL, NULL, NULL, NULL, NULL, 4),
(41134, NULL, 'G3DSA:1.25.40.20:FF:001907', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41135, NULL, 'G3DSA:3.30.505.10:FF:000012', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type', NULL, NULL, NULL, NULL, NULL, 4),
(41136, NULL, 'G3DSA:2.10.250.10:FF:000001', NULL, NULL, 'Calnexin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(41137, NULL, 'G3DSA:3.40.1190.10:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41138, NULL, 'G3DSA:2.60.40.10:FF:001097', NULL, NULL, 'Immunoglobulin-like and fibronectin type III domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(41139, NULL, 'G3DSA:1.25.40.770:FF:000026', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(41140, NULL, 'G3DSA:2.40.30.10:FF:000023', NULL, NULL, 'tRNA-specific 2-thiouridylase MnmA', NULL, NULL, NULL, NULL, NULL, 4),
(41141, NULL, 'G3DSA:1.25.10.10:FF:001279', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(41142, NULL, 'G3DSA:3.30.160.60:FF:002260', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41143, NULL, 'G3DSA:3.40.710.10:FF:000037', NULL, NULL, 'Penicillin-binding protein, 1A family', NULL, NULL, NULL, NULL, NULL, 4),
(41144, NULL, 'G3DSA:2.130.10.10:FF:003244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41145, NULL, 'G3DSA:3.40.50.620:FF:000187', NULL, NULL, 'Probable FAD synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(41146, NULL, 'G3DSA:2.40.30.20:FF:000026', NULL, NULL, 'ATP synthase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(41147, NULL, 'G3DSA:3.40.50.12780:FF:000168', NULL, NULL, 'Benzoate-coenzyme A ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41148, NULL, 'G3DSA:1.20.1270.280:FF:000017', NULL, NULL, 'Axonemal dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(41149, NULL, 'G3DSA:1.10.10.60:FF:001198', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41150, NULL, 'G3DSA:3.30.230.10:FF:000284', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(41151, NULL, 'G3DSA:1.20.58.1120:FF:000009', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41152, NULL, 'G3DSA:3.80.10.10:FF:001142', NULL, NULL, 'Leucine-rich repeats and IQ motif containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(41153, NULL, 'G3DSA:3.40.630.30:FF:000205', NULL, NULL, 'Acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(41154, NULL, 'G3DSA:1.10.472.80:FF:000041', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(41155, NULL, 'G3DSA:3.40.50.1820:FF:000927', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(41156, NULL, 'G3DSA:1.10.630.10:FF:000528', NULL, NULL, 'Protein DesVIII', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(41157, NULL, 'G3DSA:1.10.8.60:FF:000051', NULL, NULL, 'CbxX/CfqX family protein', NULL, NULL, NULL, NULL, NULL, 4),
(41158, NULL, 'G3DSA:3.30.160.60:FF:003709', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41159, NULL, 'G3DSA:1.10.472.10:FF:000599', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41160, NULL, 'G3DSA:2.40.50.140:FF:000884', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41161, NULL, 'G3DSA:1.20.1730.10:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41162, NULL, 'G3DSA:3.40.309.10:FF:000094', NULL, NULL, 'Aldehyde dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41163, NULL, 'G3DSA:2.60.40.10:FF:001462', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase C', NULL, NULL, NULL, NULL, NULL, 4),
(41164, NULL, 'G3DSA:1.10.600.10:FF:000139', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(41165, NULL, 'G3DSA:1.25.40.20:FF:000019', NULL, NULL, 'Glutaminase liver isoform, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(41166, NULL, 'G3DSA:1.25.40.10:FF:004777', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41167, NULL, 'G3DSA:2.40.240.10:FF:000044', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(41168, NULL, 'G3DSA:2.130.10.10:FF:003772', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41169, NULL, 'G3DSA:1.25.40.10:FF:005143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41170, NULL, 'G3DSA:3.90.1580.10:FF:000014', NULL, NULL, 'Gliding motility protein GldJ', NULL, NULL, NULL, NULL, NULL, 4),
(41171, NULL, 'G3DSA:3.40.1350.60:FF:000006', NULL, NULL, 'Sugar fermentation stimulation protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(41172, NULL, 'G3DSA:1.25.40.420:FF:000028', NULL, NULL, 'kelch-like protein 8 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(41173, NULL, 'G3DSA:3.40.50.360:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41174, NULL, 'G3DSA:3.30.1370.100:FF:000035', NULL, NULL, 'Mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(41175, NULL, 'G3DSA:3.30.160.880:FF:000004', NULL, NULL, 'Cell division protein ZapA', NULL, NULL, NULL, NULL, NULL, 4),
(41176, NULL, 'G3DSA:1.20.58.1100:FF:000003', NULL, NULL, 'Phorbol ester/diacylglycerol-binding protein unc-13', NULL, NULL, NULL, NULL, NULL, 4),
(41177, NULL, 'G3DSA:1.25.40.10:FF:000016', NULL, NULL, 'probable serine/threonine-protein kinase At4g35230', NULL, NULL, NULL, NULL, NULL, 4),
(41178, NULL, 'G3DSA:3.90.1750.10:FF:000027', NULL, NULL, 'HECT and RLD domain containing E3 ubiquitin protein ligase 5', NULL, NULL, NULL, NULL, NULL, 4),
(41179, NULL, 'G3DSA:3.30.420.40:FF:000998', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41180, NULL, 'G3DSA:1.25.40.10:FF:003361', NULL, NULL, 'Pre-mRNA-splicing factor CLF1', NULL, NULL, NULL, NULL, NULL, 4),
(41181, NULL, 'G3DSA:4.10.410.10:FF:000017', NULL, NULL, 'papilin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(41182, NULL, 'G3DSA:1.10.10.440:FF:000021', NULL, NULL, 'pre-mRNA-processing protein 40C isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(41183, NULL, 'G3DSA:2.130.10.10:FF:001529', NULL, NULL, 'WD repeat-containing protein SAZD, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41184, NULL, 'G3DSA:1.10.287.70:FF:000208', NULL, NULL, 'Blast:Probable glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(41185, NULL, 'G3DSA:3.60.20.10:FF:000188', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41186, NULL, 'G3DSA:3.40.1160.10:FF:000078', NULL, NULL, 'Aspartate/glutamate/uridylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(41187, NULL, 'G3DSA:3.40.50.1820:FF:000837', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(41188, NULL, 'G3DSA:1.10.8.970:FF:000002', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(41189, NULL, 'G3DSA:3.30.1360.120:FF:000011', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(41190, NULL, 'G3DSA:3.50.50.60:FF:001048', NULL, NULL, 'FAD dependent oxidoreductase domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(41191, NULL, 'G3DSA:3.30.450.20:FF:000376', NULL, NULL, 'Regulatory components of sensory transductionsystem', NULL, NULL, NULL, NULL, NULL, 4),
(41192, NULL, 'G3DSA:3.80.10.10:FF:004267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41193, NULL, 'G3DSA:2.60.120.620:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41194, NULL, 'G3DSA:2.40.50.140:FF:001070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41195, NULL, 'G3DSA:1.10.510.10:FF:001677', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(41196, NULL, 'G3DSA:1.10.640.10:FF:000029', NULL, NULL, 'Protein CBG06977', NULL, NULL, NULL, NULL, NULL, 4),
(41197, NULL, 'G3DSA:1.10.10.140:FF:000015', NULL, NULL, 'Cytochrome c oxidase subunit VIb polypeptide 1 (ubiquitous)', NULL, NULL, NULL, NULL, NULL, 4),
(41198, NULL, 'G3DSA:3.80.10.10:FF:003160', NULL, NULL, 'Protein CBG00082', NULL, NULL, NULL, NULL, NULL, 4),
(41199, NULL, 'G3DSA:1.10.287.70:FF:000517', NULL, NULL, 'Phosphomevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(41200, NULL, 'G3DSA:2.60.40.10:FF:002878', NULL, NULL, 'GD14480', NULL, NULL, NULL, NULL, NULL, 4),
(41201, NULL, 'G3DSA:1.20.1280.50:FF:000251', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(41202, NULL, 'G3DSA:3.30.40.10:FF:000786', NULL, NULL, 'Putative E3 ubiquitin-protein ligase RHA4A isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(41203, NULL, 'G3DSA:2.60.40.60:FF:000015', NULL, NULL, 'FAT atypical cadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(41204, NULL, 'G3DSA:2.60.40.10:FF:005149', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41205, NULL, 'G3DSA:2.60.120.290:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41206, NULL, 'G3DSA:3.40.50.300:FF:002114', NULL, NULL, 'ATP-dependent RNA helicase DEAH12 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(41207, NULL, 'G3DSA:2.60.40.10:FF:003805', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41208, NULL, 'G3DSA:1.20.120.1080:FF:000078', NULL, NULL, 'Pre-mRNA splicing factor ATP-dependent RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41209, NULL, 'G3DSA:2.40.37.10:FF:000067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41210, NULL, 'G3DSA:3.40.50.720:FF:002577', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41211, NULL, 'G3DSA:1.20.1740.10:FF:000163', NULL, NULL, 'Amino acid transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(41212, NULL, 'G3DSA:2.130.10.30:FF:000035', NULL, NULL, 'Putative regulator of chromosome condensation', NULL, NULL, NULL, NULL, NULL, 4),
(41213, NULL, 'G3DSA:1.20.140.10:FF:000073', NULL, NULL, 'Putative acyl-CoA dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(41214, NULL, 'G3DSA:3.40.720.10:FF:000173', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(41215, NULL, 'G3DSA:3.10.100.10:FF:000121', NULL, NULL, 'Mannose receptor, C type 1b', NULL, NULL, NULL, NULL, NULL, 4),
(41216, NULL, 'G3DSA:3.40.50.2000:FF:000869', NULL, NULL, 'UDP glucuronosyltransferase 2 family, polypeptide A1, complex locus', NULL, NULL, NULL, NULL, NULL, 4),
(41217, NULL, 'G3DSA:3.40.50.300:FF:000315', NULL, NULL, 'Adenylate kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(41218, NULL, 'G3DSA:1.20.5.110:FF:000181', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(41219, NULL, 'G3DSA:2.60.40.1180:FF:000113', NULL, NULL, 'Glucosylceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(41220, NULL, 'G3DSA:1.20.58.1220:FF:000017', NULL, NULL, 'Exocyst complex component exo84', NULL, NULL, NULL, NULL, NULL, 4),
(41221, NULL, 'G3DSA:2.130.10.10:FF:005481', NULL, NULL, 'WD domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(41222, NULL, 'G3DSA:2.30.30.370:FF:000001', NULL, NULL, 'Possible 2-hydroxyhepta-2,4-diene-1,7-dioate isomerase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(41223, NULL, 'G3DSA:3.20.20.100:FF:000198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41224, NULL, 'G3DSA:2.30.30.380:FF:000004', NULL, NULL, 'SEC24 homolog B, COPII coat complex component', NULL, NULL, NULL, NULL, NULL, 4),
(41225, NULL, 'G3DSA:1.25.40.10:FF:004996', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41226, NULL, 'G3DSA:2.60.40.10:FF:005514', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41227, NULL, 'G3DSA:3.40.50.720:FF:000885', NULL, NULL, 'Phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(41228, NULL, 'G3DSA:4.10.900.10:FF:000015', NULL, NULL, 'Cadherin 24, type 2b', NULL, NULL, NULL, NULL, NULL, 4),
(41229, NULL, 'G3DSA:2.60.40.10:FF:004896', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41230, NULL, 'G3DSA:3.30.160.60:FF:000152', NULL, NULL, 'DNA-binding protein creA', NULL, NULL, NULL, NULL, NULL, 4),
(41231, NULL, 'G3DSA:6.10.140.2150:FF:000001', NULL, NULL, 'Sphingosine-1-phosphate lyase 1', NULL, NULL, NULL, NULL, NULL, 4),
(41232, NULL, 'G3DSA:1.10.287.110:FF:000035', NULL, NULL, 'DnaJ homolog subfamily C member 9', NULL, NULL, NULL, NULL, NULL, 4),
(41233, NULL, 'G3DSA:2.60.200.40:FF:000052', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(41234, NULL, 'G3DSA:1.25.40.10:FF:003670', NULL, NULL, 'Pentatricopeptide repeat protein PPR986-12', NULL, NULL, NULL, NULL, NULL, 4),
(41235, NULL, 'G3DSA:3.40.1110.10:FF:000474', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41236, NULL, 'G3DSA:3.30.160.60:FF:005817', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41237, NULL, 'G3DSA:1.10.3380.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41238, NULL, 'G3DSA:1.20.120.730:FF:000011', NULL, NULL, 'Sfb3p', NULL, NULL, NULL, NULL, NULL, 4),
(41239, NULL, 'G3DSA:1.10.287.1150:FF:000005', NULL, NULL, 'probable 2-oxoglutarate dehydrogenase E1 component DHKTD1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(41240, NULL, 'G3DSA:1.10.1450.10:FF:000120', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(41241, NULL, 'G3DSA:3.30.430.20:FF:000049', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 36', NULL, NULL, NULL, NULL, NULL, 4),
(41242, NULL, 'G3DSA:1.20.960.50:FF:000001', NULL, NULL, 'Cleavage stimulation factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(41243, NULL, 'G3DSA:1.25.40.10:FF:003142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41244, NULL, 'G3DSA:1.10.260.40:FF:000059', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(41245, NULL, 'G3DSA:3.40.50.300:FF:005296', NULL, NULL, 'ABC transporter E family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(41246, NULL, 'G3DSA:1.10.510.10:FF:002043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41247, NULL, 'G3DSA:1.10.630.10:FF:000309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41248, NULL, 'G3DSA:1.10.555.10:FF:000140', NULL, NULL, 'GTPase-activating protein rrc-1', NULL, NULL, NULL, NULL, NULL, 4),
(41249, NULL, 'G3DSA:1.25.40.10:FF:001343', NULL, NULL, 'Pentatricopeptide (PPR) repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(41250, NULL, 'G3DSA:3.40.910.10:FF:000002', NULL, NULL, 'Deoxyhypusine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(41251, NULL, 'G3DSA:3.40.50.200:FF:000055', NULL, NULL, 'Tk-subtilisin', NULL, NULL, NULL, NULL, NULL, 4),
(41252, NULL, 'G3DSA:1.25.40.20:FF:001346', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41253, NULL, 'G3DSA:1.10.510.10:FF:003369', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41254, NULL, 'G3DSA:3.40.50.2300:FF:000987', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41255, NULL, 'G3DSA:1.10.260.100:FF:000024', NULL, NULL, 'Putative TPR repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(41256, NULL, 'G3DSA:3.30.70.1820:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41257, NULL, 'G3DSA:3.40.50.300:FF:003497', NULL, NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase PRP16', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(41258, NULL, 'G3DSA:1.20.1110.10:FF:000025', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(41259, NULL, 'G3DSA:3.30.1520.10:FF:000159', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(41260, NULL, 'G3DSA:1.25.40.10:FF:001871', NULL, NULL, 'Protein_of_uncharacterized_function_(DUF3808)/Tet ratricopeptide_repeat', NULL, NULL, NULL, NULL, NULL, 4),
(41261, NULL, 'G3DSA:2.60.120.590:FF:000066', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(41262, NULL, 'G3DSA:3.40.50.620:FF:000838', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41263, NULL, 'G3DSA:2.60.120.920:FF:000210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41264, NULL, 'G3DSA:2.130.10.10:FF:003098', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41265, NULL, 'G3DSA:3.20.20.80:FF:000851', NULL, NULL, 'Chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41266, NULL, 'G3DSA:2.30.29.30:FF:000717', NULL, NULL, 'Ran-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(41267, NULL, 'G3DSA:1.20.58.1210:FF:000014', NULL, NULL, 'Exocyst complex component exo84', NULL, NULL, NULL, NULL, NULL, 4),
(41268, NULL, 'G3DSA:2.60.120.330:FF:000128', NULL, NULL, 'Leucoanthocyanidin dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(41269, NULL, 'G3DSA:3.60.40.10:FF:000190', NULL, NULL, 'Protein serine/threonine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(41270, NULL, 'G3DSA:2.60.40.420:FF:000181', NULL, NULL, 'Copper-containing nitrite reductase', NULL, NULL, NULL, NULL, NULL, 4),
(41271, NULL, 'G3DSA:3.30.870.10:FF:000101', NULL, NULL, 'Phosphatidylcholine-hydrolyzing phospholipase D (PLD) protein', NULL, NULL, NULL, NULL, NULL, 4),
(41272, NULL, 'G3DSA:3.30.70.260:FF:000079', NULL, NULL, 'UPF0250 protein NCTC10783_06313', NULL, NULL, NULL, NULL, NULL, 4),
(41273, NULL, 'G3DSA:1.20.1250.20:FF:000864', NULL, NULL, 'solute carrier family 15 member 2-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(41274, NULL, 'G3DSA:4.10.1240.50:FF:000001', NULL, NULL, 'Metastasis-associated 1 family, member 3', NULL, NULL, NULL, NULL, NULL, 4),
(41275, NULL, 'G3DSA:1.25.10.10:FF:001734', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41276, NULL, 'G3DSA:3.40.30.10:FF:000420', NULL, NULL, 'Protein disulfide-isomerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41277, NULL, 'G3DSA:3.40.850.10:FF:000542', NULL, NULL, 'Kinesin family member 1C', NULL, NULL, NULL, NULL, NULL, 4),
(41278, NULL, 'G3DSA:3.90.550.10:FF:000440', NULL, NULL, 'Gll3051 protein', NULL, NULL, NULL, NULL, NULL, 4),
(41279, NULL, 'G3DSA:1.10.10.60:FF:001209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41280, NULL, 'G3DSA:1.25.40.20:FF:001874', NULL, NULL, 'Intracelllar PhosphoLipase A family', NULL, NULL, NULL, NULL, NULL, 4),
(41281, NULL, 'G3DSA:3.10.105.10:FF:000110', NULL, NULL, 'ABC-type transport system periplasmic substrate-binding protein (Probable substrate dipeptide/oligopeptide)', NULL, NULL, NULL, NULL, NULL, 4),
(41282, NULL, 'G3DSA:1.10.510.10:FF:000244', NULL, NULL, 'Dual serine/threonine and tyrosine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(41283, NULL, 'G3DSA:2.30.29.30:FF:000627', NULL, NULL, 'Bud site selection protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(41284, NULL, 'G3DSA:1.20.1270.10:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41285, NULL, 'G3DSA:1.20.58.80:FF:000021', NULL, NULL, 'MIT domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(41286, NULL, 'G3DSA:1.25.40.180:FF:000164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41287, NULL, 'G3DSA:1.20.870.10:FF:000010', NULL, NULL, 'ras guanyl-releasing protein 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(41288, NULL, 'G3DSA:2.30.30.140:FF:000062', NULL, NULL, 'trinucleotide repeat-containing gene 18 protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(41289, NULL, 'G3DSA:2.40.50.140:FF:001047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(41290, NULL, 'G3DSA:2.40.30.30:FF:000029', NULL, NULL, 'Riboflavin kinase', NULL, NULL, NULL, NULL, NULL, 4),
(41291, NULL, 'G3DSA:2.40.50.90:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41292, NULL, 'G3DSA:2.20.100.10:FF:000089', NULL, NULL, 'Complement component C9', NULL, NULL, NULL, NULL, NULL, 4),
(41293, NULL, 'G3DSA:1.20.58.90:FF:000024', NULL, NULL, 'IcmR', NULL, NULL, NULL, NULL, NULL, 4),
(41294, NULL, 'G3DSA:1.20.5.110:FF:000068', NULL, NULL, 'Syntaxin 1A', NULL, NULL, NULL, NULL, NULL, 4),
(41295, NULL, 'G3DSA:2.102.10.10:FF:000070', NULL, NULL, 'Protochlorophyllide-dependent translocon component 52 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(41296, NULL, 'G3DSA:1.10.418.10:FF:000001', NULL, NULL, 'Actinin alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(41297, NULL, 'G3DSA:1.10.10.10:FF:001189', NULL, NULL, 'Fork head domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(41298, NULL, 'G3DSA:3.40.50.300:FF:001951', NULL, NULL, 'ATP-dependent RNA helicase DBP5', NULL, NULL, NULL, NULL, NULL, 4),
(41299, NULL, 'G3DSA:3.30.70.660:FF:000076', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(41300, NULL, 'G3DSA:3.40.50.300:FF:001709', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(41301, NULL, 'G3DSA:3.40.50.300:FF:004115', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(41302, NULL, 'G3DSA:1.10.8.60:FF:000360', NULL, NULL, 'ATPase WRNIP1', NULL, NULL, NULL, NULL, NULL, 4),
(41303, NULL, 'G3DSA:1.10.418.20:FF:000004', NULL, NULL, 'sentrin-specific protease 7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(41304, NULL, 'G3DSA:1.20.1280.50:FF:000032', NULL, NULL, 'F-box/WD repeat-containing protein 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(41305, NULL, 'G3DSA:3.40.50.620:FF:000496', NULL, NULL, 'Valyl tRNA Synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41306, NULL, 'G3DSA:3.30.200.20:FF:000768', NULL, NULL, 'Dual specificity protein kinase lkH1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41307, NULL, 'G3DSA:3.40.50.1460:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41308, NULL, 'G3DSA:3.40.1030.10:FF:000001', NULL, NULL, 'Thymidine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(41309, NULL, 'G3DSA:2.10.25.10:FF:000237', NULL, NULL, 'Signal peptide, CUB domain and EGF like domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(41310, NULL, 'G3DSA:3.50.50.60:FF:000795', NULL, NULL, 'Kynurenine 3-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(41311, NULL, 'G3DSA:3.40.50.11840:FF:000010', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(41312, NULL, 'G3DSA:3.40.50.10420:FF:000022', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41313, NULL, 'G3DSA:2.130.10.10:FF:005823', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41314, NULL, 'G3DSA:1.20.900.10:FF:000019', NULL, NULL, 'Pleckstrin homology domain-containing family G member 1', NULL, NULL, NULL, NULL, NULL, 4),
(41315, NULL, 'G3DSA:1.20.1250.20:FF:001050', NULL, NULL, 'Related to nitrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(41316, NULL, 'G3DSA:2.60.120.200:FF:000449', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(41317, NULL, 'G3DSA:1.10.418.30:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41318, NULL, 'G3DSA:3.90.180.10:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41319, NULL, 'G3DSA:2.60.120.290:FF:000190', NULL, NULL, 'AGAP005526-PA', NULL, NULL, NULL, NULL, NULL, 4),
(41320, NULL, 'G3DSA:1.25.40.420:FF:000051', NULL, NULL, 'Kelch-like protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(41321, NULL, 'G3DSA:3.40.50.300:FF:000063', NULL, NULL, 'dynein heavy chain 6, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(41322, NULL, 'G3DSA:2.60.40.10:FF:005604', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41323, NULL, 'G3DSA:1.25.10.10:FF:000897', NULL, NULL, 'Ataxin-10', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(41324, NULL, 'G3DSA:1.10.3520.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41325, NULL, 'G3DSA:2.60.120.200:FF:000758', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(41326, NULL, 'G3DSA:1.10.8.60:FF:000157', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(41327, NULL, 'G3DSA:2.60.120.10:FF:000323', NULL, NULL, '5-deoxy-glucuronate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(41328, NULL, 'G3DSA:1.10.510.10:FF:001880', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41329, NULL, 'G3DSA:3.30.460.10:FF:000183', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(41330, NULL, 'G3DSA:1.25.10.10:FF:001515', NULL, NULL, 'Formin-D', NULL, NULL, NULL, NULL, NULL, 4),
(41331, NULL, 'G3DSA:3.40.50.300:FF:005442', NULL, NULL, 'Rad50, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(41332, NULL, 'G3DSA:3.10.490.20:FF:000001', NULL, NULL, 'dynein heavy chain 7, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(41333, NULL, 'G3DSA:3.20.20.80:FF:000632', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41334, NULL, 'G3DSA:3.40.250.10:FF:000119', NULL, NULL, 'Putative thiosulfate sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(41335, NULL, 'G3DSA:3.40.50.300:FF:000405', NULL, NULL, 'Fe-S cluster assembly ATPase SufC', NULL, NULL, NULL, NULL, NULL, 4),
(41336, NULL, 'G3DSA:3.20.20.140:FF:000305', NULL, NULL, 'Putative adenosine monophosphate deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(41337, NULL, 'G3DSA:2.10.25.10:FF:000546', NULL, NULL, 'Vacuolar-sorting receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(41338, NULL, 'G3DSA:3.40.50.720:FF:001251', NULL, NULL, 'Adenosylhomocysteinase', NULL, NULL, NULL, NULL, NULL, 4),
(41339, NULL, 'G3DSA:3.30.930.10:FF:000303', NULL, NULL, 'Class II aaRS and biotin synthetases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(41340, NULL, 'G3DSA:3.30.160.60:FF:006003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41341, NULL, 'G3DSA:2.30.230.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41342, NULL, 'G3DSA:3.40.50.1700:FF:000021', NULL, NULL, 'Probable beta-glucosidase D', NULL, NULL, NULL, NULL, NULL, 4),
(41343, NULL, 'G3DSA:1.20.1720.10:FF:000055', NULL, NULL, 'Synaptic vesicular amine transporter', NULL, NULL, NULL, NULL, NULL, 4),
(41344, NULL, 'G3DSA:3.20.10.10:FF:000026', NULL, NULL, 'Branched-chain amino acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(41345, NULL, 'G3DSA:2.130.10.10:FF:005571', NULL, NULL, 'Chromosome 16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(41346, NULL, 'G3DSA:1.25.10.10:FF:001173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41347, NULL, 'G3DSA:3.40.190.10:FF:000749', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(41348, NULL, 'G3DSA:3.30.200.20:FF:001173', NULL, NULL, 'Kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(41349, NULL, 'G3DSA:1.20.1250.10:FF:000097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41350, NULL, 'G3DSA:3.40.1160.10:FF:000005', NULL, NULL, 'Amino-acid acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(41351, NULL, 'G3DSA:3.30.160.60:FF:001765', NULL, NULL, 'zinc finger protein 324A', NULL, NULL, NULL, NULL, NULL, 4),
(41352, NULL, 'G3DSA:1.20.1270.280:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41353, NULL, 'G3DSA:2.60.40.10:FF:003592', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41354, NULL, 'G3DSA:1.10.472.80:FF:000147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41355, NULL, 'G3DSA:1.10.510.10:FF:001329', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41356, NULL, 'G3DSA:2.20.100.10:FF:000179', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs gon-1', NULL, NULL, NULL, NULL, NULL, 4),
(41357, NULL, 'G3DSA:1.25.40.10:FF:005159', NULL, NULL, 'Programmed cell death 11', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(41358, NULL, 'G3DSA:1.25.40.10:FF:001562', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(41359, NULL, 'G3DSA:3.40.50.2300:FF:001353', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41360, NULL, 'G3DSA:3.40.50.10810:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41361, NULL, 'G3DSA:3.30.200.20:FF:001482', NULL, NULL, 'Serine/threonine-protein kinase 38', NULL, NULL, NULL, NULL, NULL, 4),
(41362, NULL, 'G3DSA:3.90.870.10:FF:000037', NULL, NULL, 'Threonylcarbamoyl-AMP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(41363, NULL, 'G3DSA:1.25.40.180:FF:000254', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41364, NULL, 'G3DSA:4.10.280.10:FF:000080', NULL, NULL, 'Taiman isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(41365, NULL, 'G3DSA:2.60.40.10:FF:003569', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41366, NULL, 'G3DSA:3.90.180.10:FF:000097', NULL, NULL, 'Alcohol dehydrogenase GroES domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(41367, NULL, 'G3DSA:3.40.50.300:FF:003749', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41368, NULL, 'G3DSA:2.60.40.200:FF:000007', NULL, NULL, 'Cell surface Cu-only superoxide dismutase 5', NULL, NULL, NULL, NULL, NULL, 4),
(41369, NULL, 'G3DSA:3.30.70.100:FF:000172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41370, NULL, 'G3DSA:2.70.150.10:FF:000210', NULL, NULL, 'Copper-transporting ATPase RAN1', NULL, NULL, NULL, NULL, NULL, 4),
(41371, NULL, 'G3DSA:3.30.160.20:FF:000056', NULL, NULL, 'Adenosine deaminase domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(41372, NULL, 'G3DSA:3.20.20.70:FF:000320', NULL, NULL, 'Quinate pathway repressor protein QutR', NULL, NULL, NULL, NULL, NULL, 4),
(41373, NULL, 'G3DSA:3.40.50.2300:FF:001044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41374, NULL, 'G3DSA:2.60.120.10:FF:000014', NULL, NULL, 'Potassium voltage-gated channel, subfamily H (Eag-related), member 4', NULL, NULL, NULL, NULL, NULL, 4),
(41375, NULL, 'G3DSA:3.10.580.10:FF:000134', NULL, NULL, 'CBS domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(41376, NULL, 'G3DSA:1.10.575.10:FF:000006', NULL, NULL, 'p1 nuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41377, NULL, 'G3DSA:1.10.8.10:FF:000261', NULL, NULL, 'baculoviral IAP repeat-containing protein 7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(41378, NULL, 'G3DSA:1.25.40.10:FF:001197', NULL, NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(41379, NULL, 'G3DSA:2.10.50.10:FF:000166', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(41380, NULL, 'G3DSA:3.40.220.10:FF:000039', NULL, NULL, 'Phosphatase, putative (AFU_orthologue AFUA_1G16556)', NULL, NULL, NULL, NULL, NULL, 4),
(41381, NULL, 'G3DSA:3.30.160.60:FF:001456', NULL, NULL, 'flt3-interacting zinc finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(41382, NULL, 'G3DSA:3.40.50.2000:FF:000982', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41383, NULL, 'G3DSA:3.50.50.60:FF:001413', NULL, NULL, 'Dihydropyrimidine dehydrogenase [NADP(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(41384, NULL, 'G3DSA:3.40.20.10:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41385, NULL, 'G3DSA:3.30.450.20:FF:000612', NULL, NULL, 'Protein TWIN LOV 1', NULL, NULL, NULL, NULL, NULL, 4),
(41386, NULL, 'G3DSA:3.30.160.60:FF:005256', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41387, NULL, 'G3DSA:3.30.160.60:FF:005508', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41388, NULL, 'G3DSA:3.30.300.20:FF:000045', NULL, NULL, 'Ribosome-binding factor A', NULL, NULL, NULL, NULL, NULL, 4),
(41389, NULL, 'G3DSA:2.130.10.10:FF:005352', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41390, NULL, 'G3DSA:1.10.2000.10:FF:000019', NULL, NULL, 'Corin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(41391, NULL, 'G3DSA:3.30.300.30:FF:000048', NULL, NULL, 'Coronamic acid synthetase CmaA', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(41392, NULL, 'G3DSA:3.50.50.60:FF:001503', NULL, NULL, 'Leucine zipper like transcription regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(41393, NULL, 'G3DSA:1.10.530.10:FF:000043', NULL, NULL, 'Tail associated lysin', NULL, NULL, NULL, NULL, NULL, 4),
(41394, NULL, 'G3DSA:2.70.150.10:FF:000120', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(41395, NULL, 'G3DSA:2.10.220.10:FF:000050', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(41396, NULL, 'G3DSA:3.30.70.330:FF:003074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41397, NULL, 'G3DSA:3.50.50.60:FF:000885', NULL, NULL, 'FAD-dependent oxidoreductase (Homolog to geranylgeranyl reductase)', NULL, NULL, NULL, NULL, NULL, 4),
(41398, NULL, 'G3DSA:1.20.5.780:FF:000010', NULL, NULL, 'DUF1778 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(41399, NULL, 'G3DSA:3.10.290.10:FF:000033', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(41400, NULL, 'G3DSA:3.40.50.2000:FF:000763', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(41401, NULL, 'G3DSA:1.10.10.2770:FF:000001', NULL, NULL, 'Selenocysteine-specific translation elongation factor', NULL, NULL, NULL, NULL, NULL, 4),
(41402, NULL, 'G3DSA:1.10.510.10:FF:001571', NULL, NULL, 'cyclin-dependent kinase 19', NULL, NULL, NULL, NULL, NULL, 4),
(41403, NULL, 'G3DSA:3.30.300.10:FF:000042', NULL, NULL, 'S-adenosylmethionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(41404, NULL, 'G3DSA:2.10.25.10:FF:001041', NULL, NULL, 'GD22027', NULL, NULL, NULL, NULL, NULL, 4),
(41405, NULL, 'G3DSA:3.40.50.2000:FF:000673', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41406, NULL, 'G3DSA:3.90.550.10:FF:000108', NULL, NULL, 'hyaluronan synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(41407, NULL, 'G3DSA:1.10.238.10:FF:001319', NULL, NULL, 'Mitochondrial Rho GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(41408, NULL, 'G3DSA:1.10.390.10:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41409, NULL, 'G3DSA:3.50.50.60:FF:001161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41410, NULL, 'G3DSA:3.40.50.720:FF:001032', NULL, NULL, 'ADP-L-glycero-D-manno-heptose-6-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(41411, NULL, 'G3DSA:3.30.70.260:FF:000169', NULL, NULL, 'Aspartokinase 1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(41412, NULL, 'G3DSA:3.30.200.20:FF:001515', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41413, NULL, 'G3DSA:3.30.200.20:FF:002100', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(41414, NULL, 'G3DSA:3.10.450.240:FF:000001', NULL, NULL, 'Mitochondrial import inner membrane translocase subunit TIM44', NULL, NULL, NULL, NULL, NULL, 4),
(41415, NULL, 'G3DSA:3.30.160.60:FF:001546', NULL, NULL, 'Zinc finger protein 296', NULL, NULL, NULL, NULL, NULL, 4),
(41416, NULL, 'G3DSA:3.40.50.2300:FF:001134', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41417, NULL, 'G3DSA:1.20.140.100:FF:000040', NULL, NULL, 'Dynein-1-beta heavy chain, flagellar inner arm I1 complex', NULL, NULL, NULL, NULL, NULL, 4),
(41418, NULL, 'G3DSA:1.25.40.10:FF:005249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41419, NULL, 'G3DSA:4.10.400.10:FF:000067', NULL, NULL, 'Serine peptidase inhibitor, Kunitz type 1', NULL, NULL, NULL, NULL, NULL, 4),
(41420, NULL, 'G3DSA:1.20.1250.20:FF:001027', NULL, NULL, 'Riboflavin transporter RibJ', NULL, NULL, NULL, NULL, NULL, 4),
(41421, NULL, 'G3DSA:3.40.50.300:FF:005751', NULL, NULL, 'Slr1959 protein', NULL, NULL, NULL, NULL, NULL, 4),
(41422, NULL, 'G3DSA:1.10.10.60:FF:000214', NULL, NULL, 'Homeobox expressed in ES cells 1', NULL, NULL, NULL, NULL, NULL, 4),
(41423, NULL, 'G3DSA:3.30.200.20:FF:001824', NULL, NULL, 'Serine/threonine-protein kinase NEK', NULL, NULL, NULL, NULL, NULL, 4),
(41424, NULL, 'G3DSA:3.10.105.10:FF:000020', NULL, NULL, 'Monoacyl phosphatidylinositol tetramannoside-binding protein LpqW', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(41425, NULL, 'G3DSA:3.30.70.1230:FF:000130', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(41426, NULL, 'G3DSA:1.25.10.10:FF:001824', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41427, NULL, 'G3DSA:3.30.450.40:FF:000005', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(41428, NULL, 'G3DSA:3.30.450.50:FF:000008', NULL, NULL, 'Vesicle-associated membrane protein 711', NULL, NULL, NULL, NULL, NULL, 4),
(41429, NULL, 'G3DSA:1.25.40.710:FF:000014', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(41430, NULL, 'G3DSA:3.30.40.10:FF:002276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41431, NULL, 'G3DSA:3.50.30.30:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41432, NULL, 'G3DSA:2.130.10.10:FF:000225', NULL, NULL, 'Endoplasmic reticulum to nucleus-signaling 1', NULL, NULL, NULL, NULL, NULL, 4),
(41433, NULL, 'G3DSA:3.30.160.60:FF:000034', NULL, NULL, 'zinc finger protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(41434, NULL, 'G3DSA:3.30.710.10:FF:000186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41435, NULL, 'G3DSA:3.40.50.300:FF:005756', NULL, NULL, 'AGAP010790-PA', NULL, NULL, NULL, NULL, NULL, 4),
(41436, NULL, 'G3DSA:2.60.120.200:FF:000438', NULL, NULL, 'Transport protein ExbB2', NULL, NULL, NULL, NULL, NULL, 4),
(41437, NULL, 'G3DSA:1.10.510.10:FF:004302', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41438, NULL, 'G3DSA:3.10.20.90:FF:000253', NULL, NULL, 'unc-112-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(41439, NULL, 'G3DSA:3.40.50.720:FF:000537', NULL, NULL, 'NADH-ubiquinone oxidoreductase 39 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(41440, NULL, 'G3DSA:2.60.40.1180:FF:000001', NULL, NULL, 'Maltase-glucoamylase, intestinal', NULL, NULL, NULL, NULL, NULL, 4),
(41441, NULL, 'G3DSA:1.20.58.390:FF:000331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41442, NULL, 'G3DSA:2.60.40.10:FF:000601', NULL, NULL, 'striated muscle preferentially expressed protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(41443, NULL, 'G3DSA:3.40.367.20:FF:000028', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(41444, NULL, 'G3DSA:1.20.5.2650:FF:000002', NULL, NULL, '40S ribosomal protein S6', NULL, NULL, NULL, NULL, NULL, 4),
(41445, NULL, 'G3DSA:1.10.510.10:FF:003690', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41446, NULL, 'G3DSA:2.130.10.10:FF:001086', NULL, NULL, 'GATOR complex protein MIOS', NULL, NULL, NULL, NULL, NULL, 4),
(41447, NULL, 'G3DSA:3.30.540.30:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41448, NULL, 'G3DSA:3.50.50.60:FF:000790', NULL, NULL, '2-polyprenyl-6-methoxyphenol hydroxylase and related FAD-dependent oxidoreductases', NULL, NULL, NULL, NULL, NULL, 4),
(41449, NULL, 'G3DSA:3.40.630.30:FF:000284', NULL, NULL, 'Putative N-acetyltransferase HLS1', NULL, NULL, NULL, NULL, NULL, 4),
(41450, NULL, 'G3DSA:3.30.1140.60:FF:000021', NULL, NULL, 'F-actin-capping protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(41451, NULL, 'G3DSA:1.10.575.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41452, NULL, 'G3DSA:3.30.160.60:FF:005935', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41453, NULL, 'G3DSA:3.10.105.10:FF:000121', NULL, NULL, 'Periplasmic oligopeptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(41454, NULL, 'G3DSA:4.10.280.10:FF:000091', NULL, NULL, 'HLH DNA binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(41455, NULL, 'G3DSA:2.60.40.1190:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41456, NULL, 'G3DSA:3.20.20.10:FF:000083', NULL, NULL, 'Orn/DAP/Arg decarboxylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(41457, NULL, 'G3DSA:1.20.920.10:FF:000150', NULL, NULL, 'PolyBRoMo domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(41458, NULL, 'G3DSA:2.70.170.10:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(41459, NULL, 'G3DSA:3.30.9.10:FF:000051', NULL, NULL, 'Digeranylgeranylglycerophospholipid reductase', NULL, NULL, NULL, NULL, NULL, 4),
(41460, NULL, 'G3DSA:1.20.1070.10:FF:000881', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(41461, NULL, 'G3DSA:3.50.50.60:FF:001402', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41462, NULL, 'G3DSA:1.20.120.350:FF:000240', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41463, NULL, 'G3DSA:2.30.30.140:FF:000281', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(41464, NULL, 'G3DSA:1.10.630.10:FF:000085', NULL, NULL, 'Cytochrome P450 family 2 subfamily C member 8', NULL, NULL, NULL, NULL, NULL, 4),
(41465, NULL, 'G3DSA:3.30.70.330:FF:000893', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit G', NULL, NULL, NULL, NULL, NULL, 4),
(41466, NULL, 'G3DSA:1.25.40.10:FF:005148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41467, NULL, 'G3DSA:1.25.40.10:FF:001449', NULL, NULL, 'Tetratricopeptide repeat domain 7B', NULL, NULL, NULL, NULL, NULL, 4),
(41468, NULL, 'G3DSA:2.20.25.10:FF:000017', NULL, NULL, 'protein preY, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(41469, NULL, 'G3DSA:3.30.160.60:FF:003811', NULL, NULL, 'LD13921p', NULL, NULL, NULL, NULL, NULL, 4),
(41470, NULL, 'G3DSA:3.30.200.20:FF:001162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41471, NULL, 'G3DSA:2.20.100.10:FF:000078', NULL, NULL, 'ADAMTS like 2', NULL, NULL, NULL, NULL, NULL, 4),
(41472, NULL, 'G3DSA:3.40.50.2000:FF:000886', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41473, NULL, 'G3DSA:3.30.40.10:FF:000797', NULL, NULL, 'BnaA02g29780D protein', NULL, NULL, NULL, NULL, NULL, 4),
(41474, NULL, 'G3DSA:1.10.287.70:FF:000747', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41475, NULL, 'G3DSA:2.40.50.140:FF:000788', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41476, NULL, 'G3DSA:2.40.30.70:FF:000024', NULL, NULL, 'TA01342p', NULL, NULL, NULL, NULL, NULL, 4),
(41477, NULL, 'G3DSA:1.50.10.20:FF:000139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41478, NULL, 'G3DSA:1.10.555.10:FF:000022', NULL, NULL, 'rho GTPase-activating protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(41479, NULL, 'G3DSA:1.10.150.50:FF:000054', NULL, NULL, 'Sterile alpha motif domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(41480, NULL, 'G3DSA:2.60.40.10:FF:004300', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41481, NULL, 'G3DSA:3.40.50.620:FF:000849', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(41482, NULL, 'G3DSA:2.60.120.330:FF:000123', NULL, NULL, 'Putative 2-oxoglutarate-dependent dioxygenase AOP1.2', NULL, NULL, NULL, NULL, NULL, 4),
(41483, NULL, 'G3DSA:3.40.50.150:FF:001086', NULL, NULL, 'tRNA (Uracil-5-)-methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41484, NULL, 'G3DSA:3.30.200.20:FF:001841', NULL, NULL, 'Cell division control protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41485, NULL, 'G3DSA:1.50.10.10:FF:000136', NULL, NULL, 'N-acylglucosamine 2-epimerase-like', NULL, NULL, NULL, NULL, NULL, 4),
(41486, NULL, 'G3DSA:3.40.50.10330:FF:000102', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(41487, NULL, 'G3DSA:3.30.450.20:FF:000365', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(41488, NULL, 'G3DSA:1.10.287.70:FF:000068', NULL, NULL, 'Voltage-dependent N-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(41489, NULL, 'G3DSA:3.40.50.720:FF:001043', NULL, NULL, 'Aspergillus niger contig An11c0010, genomic contig', NULL, NULL, NULL, NULL, NULL, 4),
(41490, NULL, 'G3DSA:3.20.20.140:FF:000384', NULL, NULL, 'PHP domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(41491, NULL, 'G3DSA:3.20.20.70:FF:000640', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41492, NULL, 'G3DSA:1.20.1250.20:FF:000656', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(41493, NULL, 'G3DSA:3.40.50.300:FF:005661', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(41494, NULL, 'G3DSA:3.40.50.300:FF:004233', NULL, NULL, 'ATP-dependent helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41495, NULL, 'G3DSA:1.10.720.30:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41496, NULL, 'G3DSA:4.10.400.10:FF:000180', NULL, NULL, 'Low-density lipoprotein receptor-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(41497, NULL, 'G3DSA:1.10.10.60:FF:001075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41498, NULL, 'G3DSA:1.10.510.10:FF:001661', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41499, NULL, 'G3DSA:3.40.80.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41500, NULL, 'G3DSA:1.20.900.10:FF:000036', NULL, NULL, 'EG:23E12.2, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(41501, NULL, 'G3DSA:2.130.10.10:FF:005464', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41502, NULL, 'G3DSA:2.70.130.10:FF:000001', NULL, NULL, 'Endoplasmic reticulum lectin 1', NULL, NULL, NULL, NULL, NULL, 4),
(41503, NULL, 'G3DSA:3.40.50.10330:FF:000091', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(41504, NULL, 'G3DSA:1.20.5.4820:FF:000012', NULL, NULL, 'Class II myosin', NULL, NULL, NULL, NULL, NULL, 4),
(41505, NULL, 'G3DSA:2.60.40.10:FF:003148', NULL, NULL, 'Tie-like receptor tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(41506, NULL, 'G3DSA:1.20.58.60:FF:000599', NULL, NULL, 'spectrin beta chain, non-erythrocytic 2', NULL, NULL, NULL, NULL, NULL, 4),
(41507, NULL, 'G3DSA:3.30.170.10:FF:000003', NULL, NULL, 'Cyclin-dependent kinases regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(41508, NULL, 'G3DSA:4.10.40.20:FF:000012', NULL, NULL, 'Insulin like growth factor binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(41509, NULL, 'G3DSA:1.20.5.110:FF:000310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41510, NULL, 'G3DSA:3.30.70.890:FF:000032', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(41511, NULL, 'G3DSA:3.30.160.60:FF:004412', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41512, NULL, 'G3DSA:1.10.1760.10:FF:000003', NULL, NULL, 'Actin-related protein 2/3 complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(41513, NULL, 'G3DSA:2.20.25.100:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41514, NULL, 'G3DSA:3.80.10.10:FF:000546', NULL, NULL, 'Partner of Paired', NULL, NULL, NULL, NULL, NULL, 4),
(41515, NULL, 'G3DSA:1.20.1560.10:FF:000525', NULL, NULL, 'Multidrug resistance-associated ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(41516, NULL, 'G3DSA:3.20.20.80:FF:000429', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41517, NULL, 'G3DSA:1.25.10.10:FF:001268', NULL, NULL, 'HEAT-like_repeat_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(41518, NULL, 'G3DSA:3.40.50.10190:FF:000234', NULL, NULL, 'ECT2 (Mammalian Rho GEF) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(41519, NULL, 'G3DSA:2.60.40.420:FF:000057', NULL, NULL, 'Ephrin A4', NULL, NULL, NULL, NULL, NULL, 4),
(41520, NULL, 'G3DSA:1.25.40.10:FF:003703', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41521, NULL, 'G3DSA:1.10.555.10:FF:000117', NULL, NULL, 'LIM and Rho-GAP domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(41522, NULL, 'G3DSA:1.10.225.10:FF:000036', NULL, NULL, 'LD25144p', NULL, NULL, NULL, NULL, NULL, 4),
(41523, NULL, 'G3DSA:2.80.10.50:FF:000026', NULL, NULL, 'Blast:Protein O-mannosyl-transferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(41524, NULL, 'G3DSA:3.20.20.70:FF:000426', NULL, NULL, 'tRNA-dihydrouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(41525, NULL, 'G3DSA:2.60.40.340:FF:000004', NULL, NULL, 'Nuclear factor NF-kappa-B p105 subunit isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(41526, NULL, 'G3DSA:2.60.120.330:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(41527, NULL, 'G3DSA:3.40.50.1820:FF:000377', NULL, NULL, 'LIPaSe related', NULL, NULL, NULL, NULL, NULL, 4),
(41528, NULL, 'G3DSA:3.30.1330.30:FF:000083', NULL, NULL, '40S ribosomal protein S12', NULL, NULL, NULL, NULL, NULL, 4),
(41529, NULL, 'G3DSA:2.60.40.10:FF:006003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41530, NULL, 'G3DSA:4.10.280.10:FF:000102', NULL, NULL, 'Nescient helix-loop-helix 1', NULL, NULL, NULL, NULL, NULL, 4),
(41531, NULL, 'G3DSA:2.60.40.10:FF:003362', NULL, NULL, 'Immununoglobulin light chain', NULL, NULL, NULL, NULL, NULL, 4),
(41532, NULL, 'G3DSA:1.20.58.390:FF:000005', NULL, NULL, 'Putative gamma-aminobutyric acid receptor subunit rho-2-like', NULL, NULL, NULL, NULL, NULL, 4),
(41533, NULL, 'G3DSA:2.30.29.30:FF:000841', NULL, NULL, 'Pleckstrin homology-like domain, family B, member 2a', NULL, NULL, NULL, NULL, NULL, 4),
(41534, NULL, 'G3DSA:3.40.1110.10:FF:000159', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(41535, NULL, 'G3DSA:3.30.70.330:FF:001073', NULL, NULL, 'U1snRNP-specific protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41536, NULL, 'G3DSA:3.30.1490.20:FF:000035', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(41537, NULL, 'G3DSA:3.50.30.20:FF:000012', NULL, NULL, 'Aspartate carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(41538, NULL, 'G3DSA:3.50.50.60:FF:001391', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41539, NULL, 'G3DSA:3.40.910.10:FF:000013', NULL, NULL, 'Deoxyhypusine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(41540, NULL, 'G3DSA:1.10.8.10:FF:000171', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(41541, NULL, 'G3DSA:2.30.40.10:FF:000182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41542, NULL, 'G3DSA:3.30.450.90:FF:000003', NULL, NULL, 'Type II secretion system protein E', NULL, NULL, NULL, NULL, NULL, 4),
(41543, NULL, 'G3DSA:2.60.40.10:FF:001445', NULL, NULL, 'Tyrosine-protein phosphatase 10D', NULL, NULL, NULL, NULL, NULL, 4),
(41544, NULL, 'G3DSA:3.50.30.30:FF:000015', NULL, NULL, 'Putative e3 ubiquitin-protein ligase rnf43', NULL, NULL, NULL, NULL, NULL, 4),
(41545, NULL, 'G3DSA:1.20.120.1080:FF:000112', NULL, NULL, 'DEAH-box RNA helicase (Dhr1), putative (AFU_orthologue AFUA_6G04330)', NULL, NULL, NULL, NULL, NULL, 4),
(41546, NULL, 'G3DSA:1.10.1760.20:FF:000006', NULL, NULL, 'Biotin transporter', NULL, NULL, NULL, NULL, NULL, 4),
(41547, NULL, 'G3DSA:3.40.50.300:FF:001378', NULL, NULL, 'Zinc ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(41548, NULL, 'G3DSA:1.10.246.30:FF:000001', NULL, NULL, 'Portal protein', NULL, NULL, NULL, NULL, NULL, 4),
(41549, NULL, 'G3DSA:3.30.160.60:FF:003895', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41550, NULL, 'G3DSA:4.10.900.10:FF:000010', NULL, NULL, 'Cadherin 24', NULL, NULL, NULL, NULL, NULL, 4),
(41551, NULL, 'G3DSA:2.130.10.10:FF:001765', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41552, NULL, 'G3DSA:3.40.50.1260:FF:000052', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(41553, NULL, 'G3DSA:3.40.120.10:FF:000110', NULL, NULL, 'Phosphoglucomutase/phosphomannomutase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(41554, NULL, 'G3DSA:1.25.40.10:FF:005362', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41555, NULL, 'G3DSA:1.10.1410.10:FF:000022', NULL, NULL, 'U3 small nucleolar RNA-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(41556, NULL, 'G3DSA:3.10.250.10:FF:000132', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41557, NULL, 'G3DSA:1.10.510.10:FF:003364', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41558, NULL, 'G3DSA:1.10.287.470:FF:000019', NULL, NULL, 'Efflux transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(41559, NULL, 'G3DSA:3.40.50.1820:FF:000714', NULL, NULL, 'Triacylglycerol lipase, putative', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(41560, NULL, 'G3DSA:2.20.25.530:FF:000002', NULL, NULL, 'Ribonuclease H2 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(41561, NULL, 'G3DSA:2.10.90.10:FF:000073', NULL, NULL, 'Beadex/dlmo protein', NULL, NULL, NULL, NULL, NULL, 4),
(41562, NULL, 'G3DSA:3.40.220.10:FF:000045', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(41563, NULL, 'G3DSA:3.30.160.60:FF:005609', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41564, NULL, 'G3DSA:3.60.40.10:FF:000330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41565, NULL, 'G3DSA:1.10.238.10:FF:000324', NULL, NULL, 'EF hand', NULL, NULL, NULL, NULL, NULL, 4),
(41566, NULL, 'G3DSA:2.30.29.30:FF:001116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41567, NULL, 'G3DSA:3.30.160.60:FF:004997', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41568, NULL, 'G3DSA:2.10.50.10:FF:000059', NULL, NULL, 'TNF receptor superfamily member 8', NULL, NULL, NULL, NULL, NULL, 4),
(41569, NULL, 'G3DSA:3.20.20.330:FF:000008', NULL, NULL, 'S-methylmethionine--homocysteine S-methyltransferase BHMT2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(41570, NULL, 'G3DSA:3.40.50.1400:FF:000032', NULL, NULL, 'Sirohydrochlorin cobaltochelatase CbiKC', NULL, NULL, NULL, NULL, NULL, 4),
(41571, NULL, 'G3DSA:1.25.10.10:FF:003185', NULL, NULL, 'PIKK family atypical protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(41572, NULL, 'G3DSA:1.25.10.10:FF:003297', NULL, NULL, 'Protein ARABIDILLO 2', NULL, NULL, NULL, NULL, NULL, 4),
(41573, NULL, 'G3DSA:3.80.10.10:FF:003986', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41574, NULL, 'G3DSA:3.90.1410.10:FF:000002', NULL, NULL, 'SET domain-containing protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(41575, NULL, 'G3DSA:3.40.1280.30:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41576, NULL, 'G3DSA:3.40.190.10:FF:000030', NULL, NULL, 'Molybdate ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(41577, NULL, 'G3DSA:4.10.410.10:FF:000040', NULL, NULL, 'Serine protease inhibitor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41578, NULL, 'G3DSA:4.10.1060.10:FF:000009', NULL, NULL, 'YY1 associated factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(41579, NULL, 'G3DSA:1.10.1200.10:FF:000085', NULL, NULL, 'Nonribosomal peptide synthetase 9', NULL, NULL, NULL, NULL, NULL, 4),
(41580, NULL, 'G3DSA:2.30.42.10:FF:000585', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41581, NULL, 'G3DSA:3.10.50.40:FF:000105', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase FKBP20-2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(41582, NULL, 'G3DSA:2.30.30.190:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41583, NULL, 'G3DSA:1.10.506.10:FF:000026', NULL, NULL, 'Plexin D1', NULL, NULL, NULL, NULL, NULL, 4),
(41584, NULL, 'G3DSA:3.40.30.10:FF:000419', NULL, NULL, 'Protein disulfide-isomerase MPD1', NULL, NULL, NULL, NULL, NULL, 4),
(41585, NULL, 'G3DSA:3.40.50.1820:FF:001203', NULL, NULL, 'Phosphatidylcholine-sterol acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(41586, NULL, 'G3DSA:2.60.220.50:FF:000163', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(41587, NULL, 'G3DSA:1.50.40.10:FF:000059', NULL, NULL, 'Mitochondrial ornithine transporter 2', NULL, NULL, NULL, NULL, NULL, 4),
(41588, NULL, 'G3DSA:3.40.50.300:FF:001592', NULL, NULL, 'ATP-binding cassette protein subfamily A, member 6', NULL, NULL, NULL, NULL, NULL, 4),
(41589, NULL, 'G3DSA:2.60.40.10:FF:005486', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41590, NULL, 'G3DSA:3.30.60.30:FF:000006', NULL, NULL, 'Follistatin a', NULL, NULL, NULL, NULL, NULL, 4),
(41591, NULL, 'G3DSA:2.30.180.10:FF:000030', NULL, NULL, 'Stabilin 1', NULL, NULL, NULL, NULL, NULL, 4),
(41592, NULL, 'G3DSA:3.40.1370.10:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41593, NULL, 'G3DSA:2.70.50.40:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(41594, NULL, 'G3DSA:3.30.160.60:FF:001771', NULL, NULL, 'Zinc finger protein 200', NULL, NULL, NULL, NULL, NULL, 4),
(41595, NULL, 'G3DSA:3.40.50.1000:FF:000002', NULL, NULL, 'Potassium-transporting ATPase ATP-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(41596, NULL, 'G3DSA:3.40.50.1010:FF:000005', NULL, NULL, 'ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(41597, NULL, 'G3DSA:2.70.160.11:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41598, NULL, 'G3DSA:2.80.10.50:FF:000240', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(41599, NULL, 'G3DSA:1.20.120.350:FF:000009', NULL, NULL, 'Voltage-dependent T-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(41600, NULL, 'G3DSA:1.20.1070.10:FF:000667', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41601, NULL, 'G3DSA:2.70.50.30:FF:000006', NULL, NULL, 'Rho GDP exchange inhibitor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41602, NULL, 'G3DSA:2.30.30.100:FF:000067', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm5', NULL, NULL, NULL, NULL, NULL, 4),
(41603, NULL, 'G3DSA:3.20.20.80:FF:000643', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(41604, NULL, 'G3DSA:1.25.10.10:FF:003308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41605, NULL, 'G3DSA:3.90.70.10:FF:000105', NULL, NULL, 'Ubiquitin C-terminal hydrolase Ubp3', NULL, NULL, NULL, NULL, NULL, 4),
(41606, NULL, 'G3DSA:3.90.1420.10:FF:000042', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(41607, NULL, 'G3DSA:3.30.70.330:FF:001410', NULL, NULL, 'La protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(41608, NULL, 'G3DSA:1.25.40.10:FF:000140', NULL, NULL, 'Coatomer subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(41609, NULL, 'G3DSA:1.20.5.2210:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41610, NULL, 'G3DSA:1.20.1250.20:FF:000982', NULL, NULL, 'CLN3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(41611, NULL, 'G3DSA:3.30.930.10:FF:000404', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41612, NULL, 'G3DSA:3.30.420.10:FF:000534', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41613, NULL, 'G3DSA:3.40.30.10:FF:000212', NULL, NULL, 'Endoplasmic reticulum resident protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(41614, NULL, 'G3DSA:2.60.40.10:FF:002046', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(41615, NULL, 'G3DSA:3.40.1170.10:FF:000040', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(41616, NULL, 'G3DSA:1.10.730.20:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41617, NULL, 'G3DSA:3.10.20.230:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41618, NULL, 'G3DSA:3.30.70.330:FF:002596', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41619, NULL, 'G3DSA:1.25.10.10:FF:001156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41620, NULL, 'G3DSA:1.25.50.20:FF:000071', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(41621, NULL, 'G3DSA:1.10.8.10:FF:000266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41622, NULL, 'G3DSA:1.50.40.10:FF:000531', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41623, NULL, 'G3DSA:2.130.10.10:FF:001439', NULL, NULL, 'Possible glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(41624, NULL, 'G3DSA:1.10.150.50:FF:000149', NULL, NULL, 'uncharacterized protein LOC100179383 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(41625, NULL, 'G3DSA:1.25.40.20:FF:000143', NULL, NULL, 'transient receptor potential cation channel subfamily V member 5', NULL, NULL, NULL, NULL, NULL, 4),
(41626, NULL, 'G3DSA:3.50.50.60:FF:000559', NULL, NULL, 'tRNA 5-methylaminomethyl-2-thiouridine biosynthesis bifunctional protein MnmC', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(41627, NULL, 'G3DSA:1.10.630.10:FF:000438', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(41628, NULL, 'G3DSA:3.80.10.10:FF:002575', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41629, NULL, 'G3DSA:3.30.160.60:FF:001557', NULL, NULL, 'Transcription factor E4F1', NULL, NULL, NULL, NULL, NULL, 4),
(41630, NULL, 'G3DSA:1.10.555.10:FF:000229', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41631, NULL, 'G3DSA:3.20.20.140:FF:000058', NULL, NULL, 'Phosphotriesterase-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(41632, NULL, 'G3DSA:3.40.1800.20:FF:000018', NULL, NULL, 'AGAP008515-PA', NULL, NULL, NULL, NULL, NULL, 4),
(41633, NULL, 'G3DSA:3.40.50.2300:FF:000869', NULL, NULL, 'Vomeronasal 2, receptor 56', NULL, NULL, NULL, NULL, NULL, 4),
(41634, NULL, 'G3DSA:3.40.50.10190:FF:000346', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41635, NULL, 'G3DSA:3.90.190.10:FF:000608', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41636, NULL, 'G3DSA:3.40.50.1110:FF:000147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41637, NULL, 'G3DSA:3.40.50.410:FF:000337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41638, NULL, 'G3DSA:2.30.180.10:FF:000125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41639, NULL, 'G3DSA:3.40.710.10:FF:000127', NULL, NULL, 'Penicillin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(41640, NULL, 'G3DSA:4.10.1240.10:FF:000012', NULL, NULL, 'Calcitonin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(41641, NULL, 'G3DSA:3.90.25.10:FF:000046', NULL, NULL, 'NmrA family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(41642, NULL, 'G3DSA:1.10.860.10:FF:000017', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(41643, NULL, 'G3DSA:3.30.160.60:FF:000360', NULL, NULL, 'zinc finger protein 572', NULL, NULL, NULL, NULL, NULL, 4),
(41644, NULL, 'G3DSA:2.60.40.10:FF:005391', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41645, NULL, 'G3DSA:3.40.50.1820:FF:000489', NULL, NULL, 'Hydrolase, CocE/NonD family', NULL, NULL, NULL, NULL, NULL, 4),
(41646, NULL, 'G3DSA:2.60.40.790:FF:000004', NULL, NULL, 'ubiquitin carboxyl-terminal hydrolase 19 isoform X9', NULL, NULL, NULL, NULL, NULL, 4),
(41647, NULL, 'G3DSA:1.10.510.10:FF:003459', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41648, NULL, 'G3DSA:1.10.510.10:FF:001773', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41649, NULL, 'G3DSA:1.10.1580.10:FF:000017', NULL, NULL, 'Short integuments 2 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(41650, NULL, 'G3DSA:2.130.10.10:FF:005576', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41651, NULL, 'G3DSA:3.40.50.1100:FF:000144', NULL, NULL, 'Threonine dehydratase catabolic putative', NULL, NULL, NULL, NULL, NULL, 4),
(41652, NULL, 'G3DSA:3.40.50.720:FF:000649', NULL, NULL, 'dTDP-glucose 4,6-dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(41653, NULL, 'G3DSA:3.90.180.10:FF:000092', NULL, NULL, 'Protein CBG23238', NULL, NULL, NULL, NULL, NULL, 4),
(41654, NULL, 'G3DSA:3.80.10.10:FF:002912', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41655, NULL, 'G3DSA:3.30.70.360:FF:000008', NULL, NULL, 'Cytosolic non-specific dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(41656, NULL, 'G3DSA:1.10.10.10:FF:000340', NULL, NULL, 'ETS translocation variant 2', NULL, NULL, NULL, NULL, NULL, 4),
(41657, NULL, 'G3DSA:3.30.70.330:FF:002719', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41658, NULL, 'G3DSA:3.30.710.10:FF:000298', NULL, NULL, 'Rho-related BTB domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(41659, NULL, 'G3DSA:2.60.40.790:FF:000021', NULL, NULL, 'nudC domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(41660, NULL, 'G3DSA:3.30.70.330:FF:001617', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41661, NULL, 'G3DSA:1.25.10.10:FF:001835', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(41662, NULL, 'G3DSA:2.30.29.30:FF:001330', NULL, NULL, 'ArfGAP with SH3 domain, ankyrin repeat and PH domain 3', NULL, NULL, NULL, NULL, NULL, 4),
(41663, NULL, 'G3DSA:3.30.565.10:FF:000111', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(41664, NULL, 'G3DSA:1.20.58.900:FF:000018', NULL, NULL, 'RUN and FYVE domain-containing protein 2 isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(41665, NULL, 'G3DSA:3.50.50.60:FF:001514', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41666, NULL, 'G3DSA:1.25.40.10:FF:001337', NULL, NULL, 'Suppressor with Morphological effect on Genitalia', NULL, NULL, NULL, NULL, NULL, 4),
(41667, NULL, 'G3DSA:1.10.4200.10:FF:000001', NULL, NULL, 'Triphosphoribosyl-dephospho-CoA synthase CitG', NULL, NULL, NULL, NULL, NULL, 4),
(41668, NULL, 'G3DSA:4.10.400.10:FF:000207', NULL, NULL, 'Thioester-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(41669, NULL, 'G3DSA:3.30.60.30:FF:000220', NULL, NULL, 'Protein CBR-AGR-1', NULL, NULL, NULL, NULL, NULL, 4),
(41670, NULL, 'G3DSA:2.60.40.60:FF:001095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41671, NULL, 'G3DSA:1.25.10.10:FF:002111', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(41672, NULL, 'G3DSA:1.10.555.10:FF:000134', NULL, NULL, 'SLIT-ROBO Rho GTPase-activating protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(41673, NULL, 'G3DSA:3.40.50.2300:FF:000757', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41674, NULL, 'G3DSA:3.30.160.60:FF:002046', NULL, NULL, 'zinc finger protein 275', NULL, NULL, NULL, NULL, NULL, 4),
(41675, NULL, 'G3DSA:1.10.225.10:FF:000019', NULL, NULL, 'Saposin-related', NULL, NULL, NULL, NULL, NULL, 4),
(41676, NULL, 'G3DSA:3.20.20.80:FF:000076', NULL, NULL, 'Mannan endo-1,4-beta-mannosidase A', NULL, NULL, NULL, NULL, NULL, 4),
(41677, NULL, 'G3DSA:1.20.5.4880:FF:000002', NULL, NULL, 'rab-3A-interacting protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(41678, NULL, 'G3DSA:3.80.10.10:FF:002558', NULL, NULL, 'geranylgeranyl transferase type-2 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(41679, NULL, 'G3DSA:1.10.840.10:FF:000022', NULL, NULL, 'Ral GDS-Like', NULL, NULL, NULL, NULL, NULL, 4),
(41680, NULL, 'G3DSA:1.10.10.10:FF:001863', NULL, NULL, 'Vacuolar protein-sorting-associated protein 36', NULL, NULL, NULL, NULL, NULL, 4),
(41681, NULL, 'G3DSA:3.40.50.2000:FF:001050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41682, NULL, 'G3DSA:3.30.200.20:FF:000998', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41683, NULL, 'G3DSA:1.20.1280.50:FF:000234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41684, NULL, 'G3DSA:1.10.510.10:FF:003038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41685, NULL, 'G3DSA:1.25.10.10:FF:000312', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(41686, NULL, 'G3DSA:3.30.200.20:FF:001274', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(41687, NULL, 'G3DSA:1.20.1250.20:FF:000089', NULL, NULL, 'L-fucose:H+ symporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(41688, NULL, 'G3DSA:3.40.50.300:FF:007443', NULL, NULL, 'Uncharacterized ABC transporter ATP-binding protein C323.04', NULL, NULL, NULL, NULL, NULL, 4),
(41689, NULL, 'G3DSA:1.10.472.80:FF:000254', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41690, NULL, 'G3DSA:2.60.120.970:FF:000062', NULL, NULL, 'Bone morphogenetic protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(41691, NULL, 'G3DSA:3.40.1170.60:FF:000026', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(41692, NULL, 'G3DSA:3.40.50.2300:FF:001033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41693, NULL, 'G3DSA:3.20.20.70:FF:000409', NULL, NULL, 'FMN-dependent alpha-hydroxy acid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(41694, NULL, 'G3DSA:2.60.40.650:FF:000007', NULL, NULL, 'Molybdopterin-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(41695, NULL, 'G3DSA:3.20.20.70:FF:000073', NULL, NULL, '12-oxophytodienoate reductase 3', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(41696, NULL, 'G3DSA:2.60.120.330:FF:000235', NULL, NULL, '2-oxoglutarate (2OG) and Fe(II)-dependent oxygenase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(41697, NULL, 'G3DSA:3.40.1550.20:FF:000010', NULL, NULL, 'Transcriptional regulator MraZ', NULL, NULL, NULL, NULL, NULL, 4),
(41698, NULL, 'G3DSA:3.40.850.10:FF:000429', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41699, NULL, 'G3DSA:1.20.1250.10:FF:000086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41700, NULL, 'G3DSA:2.30.42.10:FF:000259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41701, NULL, 'G3DSA:1.10.3500.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41702, NULL, 'G3DSA:3.50.50.60:FF:000997', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(41703, NULL, 'G3DSA:1.10.630.10:FF:000208', NULL, NULL, 'Cytochrome P450, family 2, subfamily k, polypeptide 20', NULL, NULL, NULL, NULL, NULL, 4),
(41704, NULL, 'G3DSA:2.60.40.10:FF:005609', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41705, NULL, 'G3DSA:2.30.110.10:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41706, NULL, 'G3DSA:3.40.50.2000:FF:000774', NULL, NULL, 'GDP-Man:Man(3)GlcNAc(2)-PP-Dol alpha-1,2-mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(41707, NULL, 'G3DSA:3.40.50.300:FF:003744', NULL, NULL, 'ATPase, AAA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(41708, NULL, 'G3DSA:3.30.420.10:FF:000197', NULL, NULL, 'CCR4-NOT transcription complex subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(41709, NULL, 'G3DSA:2.40.50.140:FF:000676', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41710, NULL, 'G3DSA:3.40.50.720:FF:000554', NULL, NULL, 'Homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(41711, NULL, 'G3DSA:1.10.10.10:FF:001442', NULL, NULL, 'Nodulation protein D 2', NULL, NULL, NULL, NULL, NULL, 4),
(41712, NULL, 'G3DSA:3.20.20.60:FF:000070', NULL, NULL, 'Phosphotransferase system fructose-specific transporter subunit EI/HPr/EIIA', NULL, NULL, NULL, NULL, NULL, 4),
(41713, NULL, 'G3DSA:1.50.40.10:FF:000301', NULL, NULL, 'Uncoupling protein 4B, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(41714, NULL, 'G3DSA:3.20.19.10:FF:000012', NULL, NULL, 'Aconitate hydratase A', NULL, NULL, NULL, NULL, NULL, 4),
(41715, NULL, 'G3DSA:3.10.20.90:FF:000270', NULL, NULL, 'Ubiquitin regulatory protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41716, NULL, 'G3DSA:1.20.1070.10:FF:001510', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41717, NULL, 'G3DSA:1.25.40.10:FF:004659', NULL, NULL, 'Superkiller protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(41718, NULL, 'G3DSA:2.10.25.10:FF:000451', NULL, NULL, 'alpha-tectorin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(41719, NULL, 'G3DSA:1.25.40.10:FF:001096', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(41720, NULL, 'G3DSA:4.10.280.110:FF:000012', NULL, NULL, 'Yeast PRP (Splicing factor) related', NULL, NULL, NULL, NULL, NULL, 4),
(41721, NULL, 'G3DSA:1.25.10.10:FF:001594', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41722, NULL, 'G3DSA:1.20.1270.60:FF:000309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41723, NULL, 'G3DSA:1.10.150.310:FF:000006', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(41724, NULL, 'G3DSA:3.40.1160.10:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41725, NULL, 'G3DSA:3.30.1360.120:FF:000101', NULL, NULL, 'Glr1472 protein', NULL, NULL, NULL, NULL, NULL, 4),
(41726, NULL, 'G3DSA:3.10.450.240:FF:000006', NULL, NULL, 'Mitochondrial inner membrane translocase complex, subunit Tim44-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(41727, NULL, 'G3DSA:1.25.40.20:FF:001099', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(41728, NULL, 'G3DSA:2.10.220.10:FF:000162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(41729, NULL, 'G3DSA:3.30.160.60:FF:005368', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41730, NULL, 'G3DSA:1.20.5.2950:FF:000002', NULL, NULL, 'V-type proton ATPase subunit G, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41731, NULL, 'G3DSA:3.40.250.10:FF:000226', NULL, NULL, 'Cdc25b protein', NULL, NULL, NULL, NULL, NULL, 4),
(41732, NULL, 'G3DSA:1.20.920.10:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41733, NULL, 'G3DSA:2.10.90.10:FF:000056', NULL, NULL, 'Protein spaetzle', NULL, NULL, NULL, NULL, NULL, 4),
(41734, NULL, 'G3DSA:3.30.420.40:FF:000886', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41735, NULL, 'G3DSA:3.40.190.80:FF:000039', NULL, NULL, 'Inositol-1-monophosphatase protein', NULL, NULL, NULL, NULL, NULL, 4),
(41736, NULL, 'G3DSA:2.60.40.640:FF:000004', NULL, NULL, 'Vacuolar protein sorting-associated protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(41737, NULL, 'G3DSA:3.60.110.10:FF:000077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41738, NULL, 'G3DSA:3.30.9.100:FF:000001', NULL, NULL, 'Possible oxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(41739, NULL, 'G3DSA:3.40.50.300:FF:003295', NULL, NULL, 'GD25727', NULL, NULL, NULL, NULL, NULL, 4),
(41740, NULL, 'G3DSA:3.10.100.10:FF:000020', NULL, NULL, 'Mannose receptor C type 2', NULL, NULL, NULL, NULL, NULL, 4),
(41741, NULL, 'G3DSA:3.40.50.720:FF:002454', NULL, NULL, 'Autophagy protein', NULL, NULL, NULL, NULL, NULL, 4),
(41742, NULL, 'G3DSA:1.10.8.1220:FF:000019', NULL, NULL, 'MKIAA1697 protein', NULL, NULL, NULL, NULL, NULL, 4),
(41743, NULL, 'G3DSA:3.40.50.300:FF:007908', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41744, NULL, 'G3DSA:2.60.120.200:FF:000652', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41745, NULL, 'G3DSA:3.40.50.10810:FF:000021', NULL, NULL, 'DNA repair and recombination protein RAD54', NULL, NULL, NULL, NULL, NULL, 4),
(41746, NULL, 'G3DSA:2.130.10.10:FF:004975', NULL, NULL, 'Intraflagellar transport protein 80', NULL, NULL, NULL, NULL, NULL, 4),
(41747, NULL, 'G3DSA:1.10.3060.10:FF:000012', NULL, NULL, 'Protein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(41748, NULL, 'G3DSA:3.40.630.30:FF:000407', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(41749, NULL, 'G3DSA:3.30.505.10:FF:000091', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(41750, NULL, 'G3DSA:3.30.420.10:FF:000422', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41751, NULL, 'G3DSA:3.40.50.300:FF:007673', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41752, NULL, 'G3DSA:1.10.150.300:FF:000003', NULL, NULL, 'Obg-like ATPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(41753, NULL, 'G3DSA:3.40.20.10:FF:000043', NULL, NULL, 'macrophage-capping protein-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(41754, NULL, 'G3DSA:2.60.120.260:FF:000658', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41755, NULL, 'G3DSA:3.40.720.10:FF:000285', NULL, NULL, 'Protein CBG09284', NULL, NULL, NULL, NULL, NULL, 4),
(41756, NULL, 'G3DSA:3.30.40.10:FF:001202', NULL, NULL, 'GM14467p', NULL, NULL, NULL, NULL, NULL, 4),
(41757, NULL, 'G3DSA:4.10.1060.10:FF:000026', NULL, NULL, 'Zn-finger in Ran binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(41758, NULL, 'G3DSA:3.80.10.10:FF:000097', NULL, NULL, 'leucine-rich repeat protein SHOC-2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(41759, NULL, 'G3DSA:3.30.450.20:FF:000691', NULL, NULL, 'PAS sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(41760, NULL, 'G3DSA:1.20.1270.60:FF:000186', NULL, NULL, 'Transcription modulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41761, NULL, 'G3DSA:2.60.120.10:FF:000441', NULL, NULL, 'cGMP-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(41762, NULL, 'G3DSA:3.40.50.300:FF:005318', NULL, NULL, 'GM13376', NULL, NULL, NULL, NULL, NULL, 4),
(41763, NULL, 'G3DSA:1.25.40.10:FF:003350', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g11690', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(41764, NULL, 'G3DSA:1.20.58.60:FF:000392', NULL, NULL, 'Dystonin', NULL, NULL, NULL, NULL, NULL, 4),
(41765, NULL, 'G3DSA:3.40.50.300:FF:000181', NULL, NULL, 'Guanine nucleotide-binding protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(41766, NULL, 'G3DSA:1.10.405.10:FF:000022', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(41767, NULL, 'G3DSA:1.10.1080.10:FF:000007', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(41768, NULL, 'G3DSA:3.60.21.10:FF:000050', NULL, NULL, 'Calcineurin-like metallo-phosphoesterase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(41769, NULL, 'G3DSA:3.90.550.20:FF:000016', NULL, NULL, 'Glycosyltransferase family 32 protein', NULL, NULL, NULL, NULL, NULL, 4),
(41770, NULL, 'G3DSA:3.30.559.10:FF:000069', NULL, NULL, 'Protein CBG23894', NULL, NULL, NULL, NULL, NULL, 4),
(41771, NULL, 'G3DSA:3.10.250.10:FF:000020', NULL, NULL, 'serine protease hepsin', NULL, NULL, NULL, NULL, NULL, 4),
(41772, NULL, 'G3DSA:1.10.357.140:FF:000027', NULL, NULL, 'Fumagillin beta-trans-bergamotene synthase af520', NULL, NULL, NULL, NULL, NULL, 4),
(41773, NULL, 'G3DSA:2.60.40.10:FF:005374', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41774, NULL, 'G3DSA:3.30.479.10:FF:000017', NULL, NULL, '6-carboxy-5,6,7,8-tetrahydropterin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(41775, NULL, 'G3DSA:3.40.50.410:FF:000225', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(41776, NULL, 'G3DSA:3.40.50.2020:FF:000100', NULL, NULL, 'Ribose-phosphate pyrophosphokinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41777, NULL, 'G3DSA:1.20.1740.10:FF:000056', NULL, NULL, 'Y+L amino acid transporter 2', NULL, NULL, NULL, NULL, NULL, 4),
(41778, NULL, 'G3DSA:3.30.70.1130:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41779, NULL, 'G3DSA:3.10.50.40:FF:000122', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(41780, NULL, 'G3DSA:2.130.10.30:FF:000136', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41781, NULL, 'G3DSA:2.60.220.50:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41782, NULL, 'G3DSA:3.90.550.10:FF:000013', NULL, NULL, 'mannose-1-phosphate guanyltransferase beta', NULL, NULL, NULL, NULL, NULL, 4),
(41783, NULL, 'G3DSA:3.40.50.300:FF:003418', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(41784, NULL, 'G3DSA:3.30.930.10:FF:000067', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(41785, NULL, 'G3DSA:3.90.190.10:FF:000255', NULL, NULL, 'putative tyrosine-protein phosphatase auxilin', NULL, NULL, NULL, NULL, NULL, 4),
(41786, NULL, 'G3DSA:3.40.50.1400:FF:000015', NULL, NULL, 'Ferrochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(41787, NULL, 'G3DSA:1.25.40.10:FF:001663', NULL, NULL, 'GM20009', NULL, NULL, NULL, NULL, NULL, 4),
(41788, NULL, 'G3DSA:2.130.10.10:FF:003238', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41789, NULL, 'G3DSA:3.40.50.850:FF:000008', NULL, NULL, 'Blast:Pyrazinamidase/nicotinamidase', NULL, NULL, NULL, NULL, NULL, 4),
(41790, NULL, 'G3DSA:1.10.3200.20:FF:000004', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(41791, NULL, 'G3DSA:3.30.160.60:FF:000601', NULL, NULL, 'Histone-lysine N-methyltransferase PRDM9', NULL, NULL, NULL, NULL, NULL, 4),
(41792, NULL, 'G3DSA:1.25.40.20:FF:001666', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(41793, NULL, 'G3DSA:3.30.70.330:FF:001056', NULL, NULL, 'HnRNP A1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(41794, NULL, 'G3DSA:1.10.510.10:FF:001447', NULL, NULL, 'Os07g0227300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(41795, NULL, 'G3DSA:3.90.190.10:FF:000485', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41796, NULL, 'G3DSA:1.25.40.370:FF:000007', NULL, NULL, 'Putative apoptotic protease-activating factor', NULL, NULL, NULL, NULL, NULL, 4),
(41797, NULL, 'G3DSA:3.80.10.10:FF:000760', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RCH1', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(41798, NULL, 'G3DSA:3.40.1110.10:FF:000373', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41799, NULL, 'G3DSA:1.10.510.10:FF:003476', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41800, NULL, 'G3DSA:3.40.50.300:FF:002316', NULL, NULL, 'Multidrug ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(41801, NULL, 'G3DSA:3.30.70.1230:FF:000129', NULL, NULL, 'Adenylate/guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(41802, NULL, 'G3DSA:1.10.10.10:FF:000014', NULL, NULL, 'Cullin 1', NULL, NULL, NULL, NULL, NULL, 4),
(41803, NULL, 'G3DSA:3.30.160.60:FF:001883', NULL, NULL, 'zinc finger protein 683', NULL, NULL, NULL, NULL, NULL, 4),
(41804, NULL, 'G3DSA:2.130.10.10:FF:000130', NULL, NULL, 'DNA excision repair protein ERCC-8', NULL, NULL, NULL, NULL, NULL, 4),
(41805, NULL, 'G3DSA:2.60.40.10:FF:000034', NULL, NULL, 'Titin isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(41806, NULL, 'G3DSA:2.10.70.10:FF:000173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41807, NULL, 'G3DSA:1.10.510.10:FF:000036', NULL, NULL, 'RAF proto-oncogene serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(41808, NULL, 'G3DSA:2.70.130.10:FF:000113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41809, NULL, 'G3DSA:2.60.40.2690:FF:000004', NULL, NULL, 'Splicing factor 3A subunit 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41810, NULL, 'G3DSA:3.60.20.10:FF:000216', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41811, NULL, 'G3DSA:3.10.350.10:FF:000084', NULL, NULL, 'Lipoprotein NlpD', NULL, NULL, NULL, NULL, NULL, 4),
(41812, NULL, 'G3DSA:3.30.710.10:FF:000427', NULL, NULL, 'Protein CBG06295', NULL, NULL, NULL, NULL, NULL, 4),
(41813, NULL, 'G3DSA:3.40.1010.20:FF:000003', NULL, NULL, '4-hydroxy-3-methylbut-2-enyl diphosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(41814, NULL, 'G3DSA:3.40.50.300:FF:007347', NULL, NULL, 'Superfamily I DNA and RNA helicase and helicase subunits-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(41815, NULL, 'G3DSA:2.30.29.30:FF:000487', NULL, NULL, 'Stress-activated map kinase-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(41816, NULL, 'G3DSA:3.40.50.150:FF:001069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41817, NULL, 'G3DSA:2.60.40.10:FF:005935', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41818, NULL, 'G3DSA:4.10.240.10:FF:000094', NULL, NULL, 'Zcf29p', NULL, NULL, NULL, NULL, NULL, 4),
(41819, NULL, 'G3DSA:1.20.120.850:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41820, NULL, 'G3DSA:3.80.10.10:FF:000658', NULL, NULL, 'Serine/threonine-protein kinase 11-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(41821, NULL, 'G3DSA:3.30.160.60:FF:003474', NULL, NULL, 'Related to ZAP1-metalloregulatory protein involved in zinc-responsive transcriptional regulation', NULL, NULL, NULL, NULL, NULL, 4),
(41822, NULL, 'G3DSA:1.20.1560.10:FF:000637', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41823, NULL, 'G3DSA:1.10.1670.40:FF:000005', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(41824, NULL, 'G3DSA:1.20.1730.10:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41825, NULL, 'G3DSA:3.90.660.10:FF:000134', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41826, NULL, 'G3DSA:3.40.50.720:FF:000880', NULL, NULL, 'NADH dehydrogenase (Ubiquinone) 1 alpha subcomplex 9', NULL, NULL, NULL, NULL, NULL, 4),
(41827, NULL, 'G3DSA:1.10.132.30:FF:000012', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(41828, NULL, 'G3DSA:2.130.10.10:FF:005138', NULL, NULL, 'WD repeat-containing protein 19-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(41829, NULL, 'G3DSA:3.40.50.10140:FF:000034', NULL, NULL, 'Tehao', NULL, NULL, NULL, NULL, NULL, 4),
(41830, NULL, 'G3DSA:3.80.10.10:FF:003401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41831, NULL, 'G3DSA:3.40.50.2300:FF:001600', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(41832, NULL, 'G3DSA:3.60.21.60:FF:000036', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(41833, NULL, 'G3DSA:3.20.20.190:FF:000157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41834, NULL, 'G3DSA:1.20.58.340:FF:000018', NULL, NULL, 'Magnesium transport protein CorA', NULL, NULL, NULL, NULL, NULL, 4),
(41835, NULL, 'G3DSA:2.60.40.10:FF:003474', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41836, NULL, 'G3DSA:3.40.50.300:FF:005189', NULL, NULL, 'ATP-dependent dethiobiotin synthetase BioD', NULL, NULL, NULL, NULL, NULL, 4),
(41837, NULL, 'G3DSA:3.30.499.10:FF:000002', NULL, NULL, 'Aconitate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(41838, NULL, 'G3DSA:1.10.472.10:FF:000031', NULL, NULL, 'cyclin-L1-1-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(41839, NULL, 'G3DSA:3.40.50.1820:FF:001220', NULL, NULL, 'Gastric triacylglycerol lipase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41840, NULL, 'G3DSA:1.20.120.900:FF:000006', NULL, NULL, 'Peroxin 19', NULL, NULL, NULL, NULL, NULL, 4),
(41841, NULL, 'G3DSA:2.70.98.30:FF:000009', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(41842, NULL, 'G3DSA:3.40.50.10130:FF:000031', NULL, NULL, 'Probable crossover junction endonuclease EME2', NULL, NULL, NULL, NULL, NULL, 4),
(41843, NULL, 'G3DSA:3.30.470.20:FF:000248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41844, NULL, 'G3DSA:1.10.8.60:FF:000365', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(41845, NULL, 'G3DSA:3.30.420.40:FF:001049', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(41846, NULL, 'G3DSA:4.10.280.10:FF:000214', NULL, NULL, 'MLX-interacting protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(41847, NULL, 'G3DSA:3.40.50.1820:FF:000944', NULL, NULL, 'Protein phosphatase methylesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(41848, NULL, 'G3DSA:1.20.1110.10:FF:000143', NULL, NULL, 'Calcium-translocating P-type ATPase, PMCA-type', NULL, NULL, NULL, NULL, NULL, 4),
(41849, NULL, 'G3DSA:1.50.40.10:FF:000076', NULL, NULL, 'Mitochondrial phosphate carrier protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(41850, NULL, 'G3DSA:1.10.1200.270:FF:000010', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(41851, NULL, 'G3DSA:1.10.10.10:FF:001425', NULL, NULL, 'Putative transcriptional regulator, LuxR family', NULL, NULL, NULL, NULL, NULL, 4),
(41852, NULL, 'G3DSA:1.25.10.10:FF:001717', NULL, NULL, 'UTP20 small subunit (SSU) processome component', NULL, NULL, NULL, NULL, NULL, 4),
(41853, NULL, 'G3DSA:1.10.565.10:FF:000180', NULL, NULL, 'Hepatic nuclear factor 4, beta', NULL, NULL, NULL, NULL, NULL, 4),
(41854, NULL, 'G3DSA:3.90.70.10:FF:000122', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 2', NULL, NULL, NULL, NULL, NULL, 4),
(41855, NULL, 'G3DSA:2.170.300.10:FF:000069', NULL, NULL, 'Laminin subunit alpha-1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(41856, NULL, 'G3DSA:2.30.30.1020:FF:000027', NULL, NULL, 'Protein CBR-TAG-153', NULL, NULL, NULL, NULL, NULL, 4),
(41857, NULL, 'G3DSA:3.40.50.620:FF:000625', NULL, NULL, 'FAD synthase', NULL, NULL, NULL, NULL, NULL, 4),
(41858, NULL, 'G3DSA:3.40.50.10880:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41859, NULL, 'G3DSA:3.30.70.80:FF:000033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(41860, NULL, 'G3DSA:3.30.505.10:FF:000220', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41861, NULL, 'G3DSA:3.30.930.10:FF:000163', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(41862, NULL, 'G3DSA:3.40.50.300:FF:006032', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(41863, NULL, 'G3DSA:3.10.290.70:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41864, NULL, 'G3DSA:2.40.420.20:FF:000027', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(41865, NULL, 'G3DSA:1.10.8.530:FF:000005', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(41866, NULL, 'G3DSA:3.30.40.10:FF:000573', NULL, NULL, 'CDK-activating kinase assembly factor', NULL, NULL, NULL, NULL, NULL, 4),
(41867, NULL, 'G3DSA:3.30.505.10:FF:000214', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41868, NULL, 'G3DSA:3.40.50.2300:FF:001246', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41869, NULL, 'G3DSA:2.40.50.140:FF:001064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41870, NULL, 'G3DSA:3.40.710.10:FF:000144', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(41871, NULL, 'G3DSA:3.40.50.360:FF:000058', NULL, NULL, 'Sulfite reductase (NADPH) hemoprotein, beta-component', NULL, NULL, NULL, NULL, NULL, 4),
(41872, NULL, 'G3DSA:1.10.260.100:FF:000007', NULL, NULL, 'hsc70-interacting protein-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(41873, NULL, 'G3DSA:3.40.50.200:FF:000038', NULL, NULL, 'Clan SB, family S8, subtilisin-like serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(41874, NULL, 'G3DSA:1.50.40.10:FF:000514', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41875, NULL, 'G3DSA:1.20.120.1010:FF:000001', NULL, NULL, 'Sumoylation ligase MMS21', NULL, NULL, NULL, NULL, NULL, 4),
(41876, NULL, 'G3DSA:2.160.20.80:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41877, NULL, 'G3DSA:3.30.40.10:FF:001174', NULL, NULL, 'Ring finger protein 138', NULL, NULL, NULL, NULL, NULL, 4),
(41878, NULL, 'G3DSA:1.25.40.10:FF:001225', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(41879, NULL, 'G3DSA:2.10.60.10:FF:000015', NULL, NULL, 'Urokinase plasminogen activator surface receptor', NULL, NULL, NULL, NULL, NULL, 4),
(41880, NULL, 'G3DSA:3.40.50.2300:FF:001151', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41881, NULL, 'G3DSA:4.10.1000.10:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41882, NULL, 'G3DSA:3.80.10.10:FF:004149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41883, NULL, 'G3DSA:3.40.50.2020:FF:000072', NULL, NULL, 'Uncharacterized protein, isoform I', NULL, NULL, NULL, NULL, NULL, 4),
(41884, NULL, 'G3DSA:3.40.50.300:FF:001827', NULL, NULL, 'Septin', NULL, NULL, NULL, NULL, NULL, 4),
(41885, NULL, 'G3DSA:3.40.50.11990:FF:000010', NULL, NULL, 'Uncharacterized protein Ca49C10.12c', NULL, NULL, NULL, NULL, NULL, 4),
(41886, NULL, 'G3DSA:3.80.10.10:FF:001501', NULL, NULL, 'Insulin-like growth factor-binding protein complex acid labile subunit', NULL, NULL, NULL, NULL, NULL, 4),
(41887, NULL, 'G3DSA:1.10.3380.10:FF:000053', NULL, NULL, 'AGAP009060-PA', NULL, NULL, NULL, NULL, NULL, 4),
(41888, NULL, 'G3DSA:3.30.460.10:FF:000188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41889, NULL, 'G3DSA:3.40.50.300:FF:000630', NULL, NULL, 'ATP-binding cassette (ABC) transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41890, NULL, 'G3DSA:1.10.510.10:FF:002402', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41891, NULL, 'G3DSA:2.130.10.10:FF:003564', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41892, NULL, 'G3DSA:3.30.230.10:FF:000385', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(41893, NULL, 'G3DSA:3.30.1360.40:FF:000037', NULL, NULL, 'Ribosome-recycling factor, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(41894, NULL, 'G3DSA:1.10.472.80:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41895, NULL, 'G3DSA:3.40.1350.60:FF:000012', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(41896, NULL, 'G3DSA:3.40.50.300:FF:007555', NULL, NULL, 'Adenylate kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(41897, NULL, 'G3DSA:3.40.50.300:FF:003856', NULL, NULL, 'Recombinase RecA', NULL, NULL, NULL, NULL, NULL, 4),
(41898, NULL, 'G3DSA:3.90.190.10:FF:000581', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41899, NULL, 'G3DSA:3.30.40.10:FF:001073', NULL, NULL, 'Ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(41900, NULL, 'G3DSA:2.10.25.10:FF:000990', NULL, NULL, 'Transmembrane matrix receptor MUP-4', NULL, NULL, NULL, NULL, NULL, 4),
(41901, NULL, 'G3DSA:1.20.58.940:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41902, NULL, 'G3DSA:3.30.70.330:FF:000808', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein Q isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(41903, NULL, 'G3DSA:2.30.30.100:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41904, NULL, 'G3DSA:3.40.50.300:FF:007235', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(41905, NULL, 'G3DSA:1.20.1110.10:FF:000137', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41906, NULL, 'G3DSA:3.30.450.20:FF:000606', NULL, NULL, 'Calcium voltage-gated channel auxiliary subunit alpha2delta 4', NULL, NULL, NULL, NULL, NULL, 4),
(41907, NULL, 'G3DSA:1.10.287.70:FF:000523', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41908, NULL, 'G3DSA:1.10.630.10:FF:000326', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41909, NULL, 'G3DSA:2.130.10.10:FF:002041', NULL, NULL, 'AaceriADL184Wp', NULL, NULL, NULL, NULL, NULL, 4),
(41910, NULL, 'G3DSA:3.40.720.10:FF:000072', NULL, NULL, 'GPI ethanolamine phosphate transferase 3,putative', NULL, NULL, NULL, NULL, NULL, 4),
(41911, NULL, 'G3DSA:2.60.40.10:FF:000152', NULL, NULL, 'receptor-type tyrosine-protein phosphatase T isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(41912, NULL, 'G3DSA:1.25.40.120:FF:000051', NULL, NULL, 'RAB geranylgeranyl transferase alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41913, NULL, 'G3DSA:3.40.50.1440:FF:000111', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(41914, NULL, 'G3DSA:2.130.10.10:FF:001327', NULL, NULL, 'Ribosome biogenesis protein BOP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(41915, NULL, 'G3DSA:1.10.10.10:FF:001655', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41916, NULL, 'G3DSA:1.10.287.70:FF:000298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41917, NULL, 'G3DSA:3.20.20.330:FF:000025', NULL, NULL, 'S-methylmethionine--homocysteine S-methyltransferase BHMT2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(41918, NULL, 'G3DSA:3.10.50.10:FF:000029', NULL, NULL, 'Glycoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(41919, NULL, 'G3DSA:3.30.1360.120:FF:000005', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(41920, NULL, 'G3DSA:3.20.20.70:FF:000191', NULL, NULL, 'ribulose-phosphate 3-epimerase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(41921, NULL, 'G3DSA:2.60.40.10:FF:005048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41922, NULL, 'G3DSA:2.40.50.140:FF:000558', NULL, NULL, 'Primosomal replication protein N', NULL, NULL, NULL, NULL, NULL, 4),
(41923, NULL, 'G3DSA:4.10.410.10:FF:000023', NULL, NULL, 'Axotactin, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(41924, NULL, 'G3DSA:1.25.40.10:FF:001545', NULL, NULL, 'tetratricopeptide repeat protein 28', NULL, NULL, NULL, NULL, NULL, 4),
(41925, NULL, 'G3DSA:1.20.58.1250:FF:000003', NULL, NULL, 'Tubulin-folding cofactor C', NULL, NULL, NULL, NULL, NULL, 4),
(41926, NULL, 'G3DSA:2.60.40.10:FF:003586', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41927, NULL, 'G3DSA:1.20.1110.10:FF:000042', NULL, NULL, 'Potassium/sodium P-type ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41928, NULL, 'G3DSA:3.30.200.20:FF:001403', NULL, NULL, 'Cyclin-dependent protein kinase-activating kinase', NULL, NULL, NULL, NULL, NULL, 4),
(41929, NULL, 'G3DSA:2.60.120.10:FF:000109', NULL, NULL, 'Acyl-CoA thioesterase II', NULL, NULL, NULL, NULL, NULL, 4),
(41930, NULL, 'G3DSA:3.20.20.80:FF:000194', NULL, NULL, 'Conserved exported protein of uncharacterized function', NULL, NULL, NULL, NULL, NULL, 4),
(41931, NULL, 'G3DSA:3.40.50.1010:FF:000235', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41932, NULL, 'G3DSA:3.40.50.11260:FF:000027', NULL, NULL, 'Os09g0474300 protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(41933, NULL, 'G3DSA:2.40.50.100:FF:000006', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(41934, NULL, 'G3DSA:3.30.300.20:FF:000040', NULL, NULL, 'Ribosome-binding factor A', NULL, NULL, NULL, NULL, NULL, 4),
(41935, NULL, 'G3DSA:2.60.40.10:FF:005727', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41936, NULL, 'G3DSA:2.60.40.1730:FF:000082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41937, NULL, 'G3DSA:3.80.10.10:FF:000990', NULL, NULL, '187-kDa microtubule-associated protein AIR9', NULL, NULL, NULL, NULL, NULL, 4),
(41938, NULL, 'G3DSA:3.30.365.10:FF:000017', NULL, NULL, 'Xanthine dehydrogenase yagR molybdenum-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(41939, NULL, 'G3DSA:1.10.510.10:FF:001885', NULL, NULL, 'Ribosomal protein S6 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(41940, NULL, 'G3DSA:1.10.287.130:FF:000165', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(41941, NULL, 'G3DSA:1.10.287.70:FF:000309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41942, NULL, 'G3DSA:1.10.10.60:FF:000799', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41943, NULL, 'G3DSA:1.10.1740.10:FF:000007', NULL, NULL, 'RNA polymerase sigma factor SigE', NULL, NULL, NULL, NULL, NULL, 4),
(41944, NULL, 'G3DSA:3.30.160.60:FF:005273', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41945, NULL, 'G3DSA:3.60.130.10:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41946, NULL, 'G3DSA:3.40.50.1820:FF:000832', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(41947, NULL, 'G3DSA:3.40.50.1000:FF:000114', NULL, NULL, 'Phosphoserine phosphatase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(41948, NULL, 'G3DSA:1.20.58.60:FF:000728', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41949, NULL, 'G3DSA:2.40.50.690:FF:000020', NULL, NULL, 'Exosome complex exonuclease RRP44', NULL, NULL, NULL, NULL, NULL, 4),
(41950, NULL, 'G3DSA:3.20.70.20:FF:000038', NULL, NULL, 'Ribonucleoside-diphosphate reductase nrdEB subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(41951, NULL, 'G3DSA:3.10.580.10:FF:000117', NULL, NULL, 'CBS-domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(41952, NULL, 'G3DSA:1.10.8.60:FF:000045', NULL, NULL, 'Anaerobic nitric oxide reductase transcription regulator NorR', NULL, NULL, NULL, NULL, NULL, 4),
(41953, NULL, 'G3DSA:3.80.10.10:FF:004262', NULL, NULL, 'EIN3-binding F-box protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(41954, NULL, 'G3DSA:2.130.10.10:FF:003901', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(41955, NULL, 'G3DSA:3.40.50.450:FF:000107', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(41956, NULL, 'G3DSA:2.60.40.10:FF:001675', NULL, NULL, 'Endothelial cell-selective adhesion molecule', NULL, NULL, NULL, NULL, NULL, 4),
(41957, NULL, 'G3DSA:3.40.33.10:FF:000022', NULL, NULL, 'peptidase inhibitor 15', NULL, NULL, NULL, NULL, NULL, 4),
(41958, NULL, 'G3DSA:2.60.40.60:FF:000021', NULL, NULL, 'FAT atypical cadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(41959, NULL, 'G3DSA:3.40.50.200:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41960, NULL, 'G3DSA:3.40.50.1000:FF:000232', NULL, NULL, 'Trehalose-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(41961, NULL, 'G3DSA:1.10.510.10:FF:003246', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41962, NULL, 'G3DSA:2.130.10.10:FF:001535', NULL, NULL, 'Intraflagellar transport protein 172 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(41963, NULL, 'G3DSA:3.40.50.720:FF:000981', NULL, NULL, '3-hydroxybutyrate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(41964, NULL, 'G3DSA:3.40.50.1460:FF:000117', NULL, NULL, 'Caspase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(41965, NULL, 'G3DSA:3.30.1120.30:FF:000045', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(41966, NULL, 'G3DSA:3.30.160.20:FF:000163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41967, NULL, 'G3DSA:1.10.10.440:FF:000015', NULL, NULL, 'pre-mRNA-processing factor 40 homolog B isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(41968, NULL, 'G3DSA:2.130.10.10:FF:001647', NULL, NULL, 'Unplaced genomic scaffold supercont1.83, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(41969, NULL, 'G3DSA:1.10.8.10:FF:000154', NULL, NULL, 'NSFL1 cofactor p47', NULL, NULL, NULL, NULL, NULL, 4),
(41970, NULL, 'G3DSA:3.30.200.20:FF:000785', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(41971, NULL, 'G3DSA:3.40.33.10:FF:000117', NULL, NULL, 'Golgi-associated plant pathogenesis-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(41972, NULL, 'G3DSA:2.30.42.10:FF:000467', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41973, NULL, 'G3DSA:3.20.20.100:FF:000193', NULL, NULL, 'Alcohol dehydrogenase [NADP(+)] A-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(41974, NULL, 'G3DSA:3.40.50.1010:FF:000117', NULL, NULL, 'Posttranscriptional regulation nuclease (Mkt1), putative (AFU_orthologue AFUA_5G12250)', NULL, NULL, NULL, NULL, NULL, 4),
(41975, NULL, 'G3DSA:3.90.70.80:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41976, NULL, 'G3DSA:3.10.580.10:FF:000022', NULL, NULL, 'Cystathionine beta-synthase Cbs', NULL, NULL, NULL, NULL, NULL, 4),
(41977, NULL, 'G3DSA:4.10.240.10:FF:000217', NULL, NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(41978, NULL, 'G3DSA:3.40.50.300:FF:000310', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(41979, NULL, 'G3DSA:3.40.50.150:FF:000012', NULL, NULL, 'tRNA/tmRNA (uracil-C(5))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(41980, NULL, 'G3DSA:1.10.3520.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41981, NULL, 'G3DSA:3.40.50.300:FF:000422', NULL, NULL, 'Guanylate-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(41982, NULL, 'G3DSA:3.30.1490.180:FF:000041', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(41983, NULL, 'G3DSA:1.10.260.40:FF:000054', NULL, NULL, 'POU domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(41984, NULL, 'G3DSA:3.40.30.10:FF:000083', NULL, NULL, 'Thiol:disulfide interchange protein', NULL, NULL, NULL, NULL, NULL, 4),
(41985, NULL, 'G3DSA:1.20.1310.20:FF:000026', NULL, NULL, 'Erythrocyte binding ligand-1', NULL, NULL, NULL, NULL, NULL, 4),
(41986, NULL, 'G3DSA:3.30.260.10:FF:000095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41987, NULL, 'G3DSA:2.60.120.290:FF:000173', NULL, NULL, 'Fibropellin-1', NULL, NULL, NULL, NULL, NULL, 4),
(41988, NULL, 'G3DSA:2.40.170.20:FF:000131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41989, NULL, 'G3DSA:3.60.21.10:FF:000403', NULL, NULL, 'Serine/threonine protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(41990, NULL, 'G3DSA:2.60.40.10:FF:000360', NULL, NULL, 'Sidekick cell adhesion molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(41991, NULL, 'G3DSA:1.25.40.10:FF:000022', NULL, NULL, 'lysine-specific demethylase 6A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(41992, NULL, 'G3DSA:3.40.50.150:FF:000107', NULL, NULL, 'tRNA 5-methylaminomethyl-2-thiouridine biosynthesis bifunctional protein MnmC', NULL, NULL, NULL, NULL, NULL, 4),
(41993, NULL, 'G3DSA:3.40.190.10:FF:000856', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(41994, NULL, 'G3DSA:2.40.50.140:FF:000890', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(41995, NULL, 'G3DSA:3.30.900.10:FF:000009', NULL, NULL, 'Meiosis-specific protein ASY2', NULL, NULL, NULL, NULL, NULL, 4),
(41996, NULL, 'G3DSA:3.30.450.40:FF:000230', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(41997, NULL, 'G3DSA:3.40.1110.10:FF:000261', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(41998, NULL, 'G3DSA:1.20.5.170:FF:000075', NULL, NULL, 'BZIP transcription factor (MetR)', NULL, NULL, NULL, NULL, NULL, 4),
(41999, NULL, 'G3DSA:1.10.510.10:FF:003925', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42000, NULL, 'G3DSA:2.10.25.10:FF:000563', NULL, NULL, 'Wall-associated receptor kinase-like 8', NULL, NULL, NULL, NULL, NULL, 4),
(42001, NULL, 'G3DSA:1.25.40.20:FF:000025', NULL, NULL, 'GA-binding protein subunit beta-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(42002, NULL, 'G3DSA:1.25.10.10:FF:001622', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42003, NULL, 'G3DSA:2.40.50.140:FF:001159', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42004, NULL, 'G3DSA:3.40.50.360:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42005, NULL, 'G3DSA:3.60.10.10:FF:000148', NULL, NULL, 'DNA-(Apurinic or apyrimidinic site) lyase,putative', NULL, NULL, NULL, NULL, NULL, 4),
(42006, NULL, 'G3DSA:3.80.10.10:FF:002671', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(42007, NULL, 'G3DSA:3.30.160.60:FF:004300', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42008, NULL, 'G3DSA:3.80.10.10:FF:004363', NULL, NULL, 'NLR family, pyrin domain-containing 12', NULL, NULL, NULL, NULL, NULL, 4),
(42009, NULL, 'G3DSA:2.30.30.140:FF:000264', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(42010, NULL, 'G3DSA:3.10.20.110:FF:000001', NULL, NULL, 'Protective antigen', NULL, NULL, NULL, NULL, NULL, 4),
(42011, NULL, 'G3DSA:1.20.1270.280:FF:000023', NULL, NULL, 'Dynein-1-beta heavy chain, flagellar inner arm I1 complex', NULL, NULL, NULL, NULL, NULL, 4),
(42012, NULL, 'G3DSA:1.10.630.10:FF:000534', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42013, NULL, 'G3DSA:3.40.50.2000:FF:000656', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(42014, NULL, 'G3DSA:3.30.200.20:FF:001280', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(42015, NULL, 'G3DSA:3.40.250.10:FF:000114', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(42016, NULL, 'G3DSA:3.30.9.10:FF:000163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42017, NULL, 'G3DSA:3.30.70.330:FF:001409', NULL, NULL, 'la-related protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(42018, NULL, 'G3DSA:3.30.70.340:FF:000002', NULL, NULL, 'Carboxypeptidase A', NULL, NULL, NULL, NULL, NULL, 4),
(42019, NULL, 'G3DSA:1.25.40.10:FF:003574', NULL, NULL, 'Protein TONSOKU', NULL, NULL, NULL, NULL, NULL, 4),
(42020, NULL, 'G3DSA:1.10.1520.10:FF:000025', NULL, NULL, 'Unplaced genomic scaffold supercont1.15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(42021, NULL, 'G3DSA:2.60.40.10:FF:003709', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42022, NULL, 'G3DSA:2.10.25.10:FF:000658', NULL, NULL, 'cubilin', NULL, NULL, NULL, NULL, NULL, 4),
(42023, NULL, 'G3DSA:1.20.5.110:FF:000208', NULL, NULL, 'Protein CBR-SYX-4', NULL, NULL, NULL, NULL, NULL, 4),
(42024, NULL, 'G3DSA:3.30.40.10:FF:001410', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42025, NULL, 'G3DSA:2.130.10.10:FF:002142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42026, NULL, 'G3DSA:1.20.120.350:FF:000010', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(42027, NULL, 'G3DSA:3.40.50.300:FF:005644', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42028, NULL, 'G3DSA:1.25.40.10:FF:004991', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42029, NULL, 'G3DSA:2.60.40.10:FF:001557', NULL, NULL, 'Echinoid, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(42030, NULL, 'G3DSA:3.40.20.10:FF:000155', NULL, NULL, 'Cofilin-5', NULL, NULL, NULL, NULL, NULL, 4),
(42031, NULL, 'G3DSA:3.40.50.800:FF:000123', NULL, NULL, 'Histidyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(42032, NULL, 'G3DSA:3.30.40.10:FF:000359', NULL, NULL, 'E3 ubiquitin-protein ligase At3g02290-like', NULL, NULL, NULL, NULL, NULL, 4),
(42033, NULL, 'G3DSA:3.30.750.24:FF:000179', NULL, NULL, 'Solute carrier family 26 member 9', NULL, NULL, NULL, NULL, NULL, 4),
(42034, NULL, 'G3DSA:3.30.450.270:FF:000005', NULL, NULL, 'Bacteriophytochrome (Light-regulated signal transduction histidine kinase), PhyB2', NULL, NULL, NULL, NULL, NULL, 4),
(42035, NULL, 'G3DSA:1.10.10.160:FF:000027', NULL, NULL, 'RecBCD enzyme subunit RecC', NULL, NULL, NULL, NULL, NULL, 4),
(42036, NULL, 'G3DSA:2.60.200.40:FF:000046', NULL, NULL, 'Ceramide kinase-like isoform 14', NULL, NULL, NULL, NULL, NULL, 4),
(42037, NULL, 'G3DSA:3.30.70.3310:FF:000006', NULL, NULL, 'Protein glp-1', NULL, NULL, NULL, NULL, NULL, 4),
(42038, NULL, 'G3DSA:3.40.50.11830:FF:000001', NULL, NULL, 'Transcriptional activator CadC', NULL, NULL, NULL, NULL, NULL, 4),
(42039, NULL, 'G3DSA:3.40.50.300:FF:005874', NULL, NULL, 'ATP-dependent DNA helicase CHL1', NULL, NULL, NULL, NULL, NULL, 4),
(42040, NULL, 'G3DSA:3.30.572.10:FF:000015', NULL, NULL, 'Thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(42041, NULL, 'G3DSA:3.30.450.260:FF:000002', NULL, NULL, 'guanylate cyclase soluble subunit alpha-2', NULL, NULL, NULL, NULL, NULL, 4),
(42042, NULL, 'G3DSA:4.10.240.10:FF:000195', NULL, NULL, 'Putative transcription factor with C2H2 and Zn(2)-Cys(6) DNA binding domain (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(42043, NULL, 'G3DSA:2.60.200.30:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42044, NULL, 'G3DSA:3.40.50.300:FF:008050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42045, NULL, 'G3DSA:3.50.50.60:FF:001520', NULL, NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', NULL, NULL, NULL, NULL, NULL, 4),
(42046, NULL, 'G3DSA:1.25.40.420:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42047, NULL, 'G3DSA:1.10.565.10:FF:000062', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(42048, NULL, 'G3DSA:1.10.1040.10:FF:000095', NULL, NULL, 'Probable 2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(42049, NULL, 'G3DSA:3.30.70.330:FF:001281', NULL, NULL, 'Cold-shock DEAD-box protein A', NULL, NULL, NULL, NULL, NULL, 4),
(42050, NULL, 'G3DSA:1.25.40.10:FF:005036', NULL, NULL, 'AGAP000136-PA', NULL, NULL, NULL, NULL, NULL, 4),
(42051, NULL, 'G3DSA:3.40.50.11850:FF:000007', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(42052, NULL, 'G3DSA:1.20.5.650:FF:000005', NULL, NULL, 'Transcription factor TFIIIB complex subunit Brf1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(42053, NULL, 'G3DSA:2.60.120.290:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42054, NULL, 'G3DSA:3.40.710.10:FF:000032', NULL, NULL, 'Penicillin-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(42055, NULL, 'G3DSA:3.30.160.60:FF:005823', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42056, NULL, 'G3DSA:1.20.1070.10:FF:000229', NULL, NULL, 'Gastric inhibitory polypeptide receptor', NULL, NULL, NULL, NULL, NULL, 4),
(42057, NULL, 'G3DSA:3.80.10.10:FF:001035', NULL, NULL, 'GH20134p', NULL, NULL, NULL, NULL, NULL, 4),
(42058, NULL, 'G3DSA:2.60.120.10:FF:000227', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(42059, NULL, 'G3DSA:3.30.160.60:FF:003923', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42060, NULL, 'G3DSA:3.40.50.1820:FF:000259', NULL, NULL, 'Lysophospholipase L2', NULL, NULL, NULL, NULL, NULL, 4),
(42061, NULL, 'G3DSA:3.40.605.10:FF:000113', NULL, NULL, 'Delta-1-pyrroline-5-carboxylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(42062, NULL, 'G3DSA:1.20.1250.20:FF:001044', NULL, NULL, 'Solute carrier family 49 member 4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(42063, NULL, 'G3DSA:1.20.5.5160:FF:000002', NULL, NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(42064, NULL, 'G3DSA:3.30.160.60:FF:003569', NULL, NULL, 'zinc finger protein 287 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(42065, NULL, 'G3DSA:1.20.58.60:FF:000841', NULL, NULL, 'Spectrin repeat containing nuclear envelope protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(42066, NULL, 'G3DSA:1.25.40.10:FF:005266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42067, NULL, 'G3DSA:2.10.25.10:FF:000097', NULL, NULL, 'Fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(42068, NULL, 'G3DSA:3.30.930.10:FF:000275', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(42069, NULL, 'G3DSA:3.30.9.10:FF:000264', NULL, NULL, 'FAD-dependent catabolic D-arginine dehydrogenase DauA', NULL, NULL, NULL, NULL, NULL, 4),
(42070, NULL, 'G3DSA:3.20.20.380:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42071, NULL, 'G3DSA:3.40.850.10:FF:000194', NULL, NULL, 'AaceriADR145Cp', NULL, NULL, NULL, NULL, NULL, 4),
(42072, NULL, 'G3DSA:3.30.565.10:FF:000212', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(42073, NULL, 'G3DSA:3.40.720.10:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42074, NULL, 'G3DSA:2.10.70.10:FF:000061', NULL, NULL, 'Pappalysin 1', NULL, NULL, NULL, NULL, NULL, 4),
(42075, NULL, 'G3DSA:3.40.50.11840:FF:000004', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(42076, NULL, 'G3DSA:2.30.30.40:FF:000330', NULL, NULL, 'Purine-binding chemotaxis protein CheW', NULL, NULL, NULL, NULL, NULL, 4),
(42077, NULL, 'G3DSA:3.40.50.300:FF:006150', NULL, NULL, 'Zgc:113442', NULL, NULL, NULL, NULL, NULL, 4),
(42078, NULL, 'G3DSA:3.40.50.80:FF:000195', NULL, NULL, 'YALI0F01386p', NULL, NULL, NULL, NULL, NULL, 4),
(42079, NULL, 'G3DSA:3.10.105.10:FF:000003', NULL, NULL, 'Glutathione ABC transporter substrate-binding protein GsiB', NULL, NULL, NULL, NULL, NULL, 4),
(42080, NULL, 'G3DSA:1.20.1250.20:FF:000768', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(42081, NULL, 'G3DSA:3.40.50.300:FF:004121', NULL, NULL, 'tRNA modification GTPase MnmE', NULL, NULL, NULL, NULL, NULL, 4),
(42082, NULL, 'G3DSA:3.30.160.20:FF:000152', NULL, NULL, 'Dicer-like 4', NULL, NULL, NULL, NULL, NULL, 4),
(42083, NULL, 'G3DSA:1.25.40.10:FF:002040', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(42084, NULL, 'G3DSA:3.40.710.10:FF:000133', NULL, NULL, 'Peptidase M15', NULL, NULL, NULL, NULL, NULL, 4),
(42085, NULL, 'G3DSA:3.90.1200.10:FF:000059', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(42086, NULL, 'G3DSA:2.60.40.10:FF:003811', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42087, NULL, 'G3DSA:3.40.50.300:FF:002108', NULL, NULL, 'ATP-binding cassette sub-family F member 1', NULL, NULL, NULL, NULL, NULL, 4),
(42088, NULL, 'G3DSA:1.25.40.10:FF:002973', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(42089, NULL, 'G3DSA:3.30.160.60:FF:003682', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42090, NULL, 'G3DSA:3.30.70.330:FF:001522', NULL, NULL, 'RNA-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(42091, NULL, 'G3DSA:1.20.120.1080:FF:000084', NULL, NULL, 'Let-355 protein', NULL, NULL, NULL, NULL, NULL, 4),
(42092, NULL, 'G3DSA:3.20.20.140:FF:000412', NULL, NULL, 'TatD related DNase', NULL, NULL, NULL, NULL, NULL, 4),
(42093, NULL, 'G3DSA:3.20.20.80:FF:000755', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42094, NULL, 'G3DSA:3.40.50.1820:FF:000591', NULL, NULL, 'Serine carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(42095, NULL, 'G3DSA:2.10.270.10:FF:000013', NULL, NULL, 'Dextransucrase', NULL, NULL, NULL, NULL, NULL, 4),
(42096, NULL, 'G3DSA:3.30.460.10:FF:000076', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(42097, NULL, 'G3DSA:3.40.50.720:FF:001610', NULL, NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(42098, NULL, 'G3DSA:1.20.1250.20:FF:000870', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(42099, NULL, 'G3DSA:2.60.120.330:FF:000005', NULL, NULL, '1-aminocyclopropane-1-carboxylate oxidase homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(42100, NULL, 'G3DSA:2.60.120.920:FF:000204', NULL, NULL, 'Si:dkey-56m15.9', NULL, NULL, NULL, NULL, NULL, 4),
(42101, NULL, 'G3DSA:3.30.160.60:FF:002400', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42102, NULL, 'G3DSA:3.80.10.10:FF:002463', NULL, NULL, 'Si:ch211-214b16.3', NULL, NULL, NULL, NULL, NULL, 4),
(42103, NULL, 'G3DSA:1.10.3520.10:FF:000042', NULL, NULL, 'pleckstrin homology domain-containing family A member 8 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(42104, NULL, 'G3DSA:3.40.50.720:FF:000992', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(42105, NULL, 'G3DSA:3.30.160.60:FF:001669', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(42106, NULL, 'G3DSA:3.20.10.10:FF:000043', NULL, NULL, 'Branched-chain amino acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(42107, NULL, 'G3DSA:2.60.120.10:FF:000340', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(42108, NULL, 'G3DSA:3.40.50.2000:FF:000448', NULL, NULL, 'UDP-glucoronosyl and UDP-glucosyl transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(42109, NULL, 'G3DSA:1.50.10.10:FF:000018', NULL, NULL, 'Glucoamylase', NULL, NULL, NULL, NULL, NULL, 4),
(42110, NULL, 'G3DSA:2.60.120.320:FF:000002', NULL, NULL, 'Thiamine pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(42111, NULL, 'G3DSA:1.20.1110.10:FF:000031', NULL, NULL, 'Calcium-transporting ATPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(42112, NULL, 'G3DSA:3.40.50.1100:FF:000032', NULL, NULL, 'Cysteine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(42113, NULL, 'G3DSA:1.25.40.180:FF:000271', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42114, NULL, 'G3DSA:2.20.100.10:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42115, NULL, 'G3DSA:1.10.287.70:FF:000629', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42116, NULL, 'G3DSA:3.40.605.10:FF:000012', NULL, NULL, 'NAD-dependent succinate-semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(42117, NULL, 'G3DSA:3.30.559.10:FF:000283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42118, NULL, 'G3DSA:2.130.10.10:FF:005930', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42119, NULL, 'G3DSA:3.40.50.1110:FF:000035', NULL, NULL, 'Acyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(42120, NULL, 'G3DSA:3.30.230.10:FF:000267', NULL, NULL, 'Diphosphomevalonate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(42121, NULL, 'G3DSA:1.25.10.10:FF:000071', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(42122, NULL, 'G3DSA:2.60.40.420:FF:000175', NULL, NULL, 'Aspergillus niger contig An12c0160, genomic contig', NULL, NULL, NULL, NULL, NULL, 4),
(42123, NULL, 'G3DSA:2.30.29.30:FF:000599', NULL, NULL, 'AGAP011491-PA', NULL, NULL, NULL, NULL, NULL, 4),
(42124, NULL, 'G3DSA:1.10.10.10:FF:001537', NULL, NULL, 'C-type lectin', NULL, NULL, NULL, NULL, NULL, 4),
(42125, NULL, 'G3DSA:3.80.10.10:FF:000759', NULL, NULL, 'Leucine-rich repeat receptor protein kinase EMS1', NULL, NULL, NULL, NULL, NULL, 4),
(42126, NULL, 'G3DSA:3.40.30.10:FF:000324', NULL, NULL, 'Iodothyronine deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(42127, NULL, 'G3DSA:3.60.10.10:FF:000047', NULL, NULL, 'Deoxyribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(42128, NULL, 'G3DSA:1.10.472.80:FF:000024', NULL, NULL, 'TBC1 domain family member 20', NULL, NULL, NULL, NULL, NULL, 4),
(42129, NULL, 'G3DSA:1.10.8.60:FF:000253', NULL, NULL, 'GM14642', NULL, NULL, NULL, NULL, NULL, 4),
(42130, NULL, 'G3DSA:2.10.270.10:FF:000002', NULL, NULL, 'NLP/P60 protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(42131, NULL, 'G3DSA:3.20.20.190:FF:000045', NULL, NULL, 'Glycerophosphodiester phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(42132, NULL, 'G3DSA:1.10.510.10:FF:001565', NULL, NULL, 'WNK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(42133, NULL, 'G3DSA:1.20.5.640:FF:000002', NULL, NULL, 'Transcriptional regulator, IclR family', NULL, NULL, NULL, NULL, NULL, 4),
(42134, NULL, 'G3DSA:3.30.70.2630:FF:000004', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(42135, NULL, 'G3DSA:2.60.40.10:FF:001911', NULL, NULL, 'Titin', NULL, NULL, NULL, NULL, NULL, 4),
(42136, NULL, 'G3DSA:1.10.238.10:FF:000330', NULL, NULL, 'Putative calcium-binding protein CML41', NULL, NULL, NULL, NULL, NULL, 4),
(42137, NULL, 'G3DSA:3.90.70.10:FF:000010', NULL, NULL, 'Calpain 15', NULL, NULL, NULL, NULL, NULL, 4),
(42138, NULL, 'G3DSA:2.10.25.10:FF:000552', NULL, NULL, 'Basement membrane proteoglycan', NULL, NULL, NULL, NULL, NULL, 4),
(42139, NULL, 'G3DSA:2.30.29.30:FF:000392', NULL, NULL, 'Signal transducing adaptor family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(42140, NULL, 'G3DSA:1.20.1270.60:FF:000068', NULL, NULL, 'Islet cell autoantigen', NULL, NULL, NULL, NULL, NULL, 4),
(42141, NULL, 'G3DSA:3.30.70.1230:FF:000034', NULL, NULL, 'Adenylyl cyclase beta', NULL, NULL, NULL, NULL, NULL, 4),
(42142, NULL, 'G3DSA:2.130.10.10:FF:000012', NULL, NULL, 'Putative pleiotropic regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(42143, NULL, 'G3DSA:1.20.1740.10:FF:000168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42144, NULL, 'G3DSA:2.40.240.10:FF:000027', NULL, NULL, 'Glutamine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(42145, NULL, 'G3DSA:1.10.10.10:FF:000132', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(42146, NULL, 'G3DSA:1.25.10.10:FF:003067', NULL, NULL, 'Exportin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(42147, NULL, 'G3DSA:1.20.5.170:FF:000176', NULL, NULL, 'Aureochrome 1', NULL, NULL, NULL, NULL, NULL, 4),
(42148, NULL, 'G3DSA:2.60.40.10:FF:005840', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42149, NULL, 'G3DSA:1.10.3210.10:FF:000041', NULL, NULL, 'GTP pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(42150, NULL, 'G3DSA:3.30.1330.30:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42151, NULL, 'G3DSA:2.60.120.200:FF:000764', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42152, NULL, 'G3DSA:3.60.21.10:FF:000162', NULL, NULL, 'Sphingomyelin phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(42153, NULL, 'G3DSA:1.20.120.790:FF:000006', NULL, NULL, 'Chaperone protein HtpG', NULL, NULL, NULL, NULL, NULL, 4),
(42154, NULL, 'G3DSA:1.20.1250.20:FF:002129', NULL, NULL, 'Uncharacterized MFS-type transporter C947.06c', NULL, NULL, NULL, NULL, NULL, 4),
(42155, NULL, 'G3DSA:3.40.50.300:FF:005094', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(42156, NULL, 'G3DSA:1.25.10.10:FF:001509', NULL, NULL, 'Protein phosphatase 4 regulatory subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(42157, NULL, 'G3DSA:3.30.200.20:FF:001509', NULL, NULL, 'Mitogen-activated protein kinase 13', NULL, NULL, NULL, NULL, NULL, 4),
(42158, NULL, 'G3DSA:6.10.140.2220:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42159, NULL, 'G3DSA:2.40.150.20:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(42160, NULL, 'G3DSA:3.90.245.10:FF:000012', NULL, NULL, 'Hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(42161, NULL, 'G3DSA:1.10.10.60:FF:000698', NULL, NULL, 'Anthocyanin regulatory C1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(42162, NULL, 'G3DSA:3.30.230.80:FF:000023', NULL, NULL, 'Heat shock protein 75 kDa, mitochondrial-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(42163, NULL, 'G3DSA:3.50.50.60:FF:001065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42164, NULL, 'G3DSA:3.40.720.10:FF:000313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(42165, NULL, 'G3DSA:3.30.70.330:FF:000685', NULL, NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(42166, NULL, 'G3DSA:1.20.5.110:FF:000085', NULL, NULL, '25.3 kDa vesicle transport protein-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(42167, NULL, 'G3DSA:3.10.50.40:FF:000010', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase Pin1', NULL, NULL, NULL, NULL, NULL, 4),
(42168, NULL, 'G3DSA:3.30.505.10:FF:000006', NULL, NULL, 'Phosphatidylinositol 3-kinase regulatory subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(42169, NULL, 'G3DSA:1.20.58.380:FF:000002', NULL, NULL, 'Flagellar protein FliT', NULL, NULL, NULL, NULL, NULL, 4),
(42170, NULL, 'G3DSA:1.25.40.20:FF:001548', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42171, NULL, 'G3DSA:3.40.50.1820:FF:001315', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42172, NULL, 'G3DSA:3.40.50.720:FF:000099', NULL, NULL, 'Aspartate-semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(42173, NULL, 'G3DSA:1.20.1280.50:FF:000026', NULL, NULL, 'F-box only protein 21 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(42174, NULL, 'G3DSA:3.80.10.10:FF:004469', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42175, NULL, 'G3DSA:3.80.10.10:FF:000872', NULL, NULL, 'Protein NUD1', NULL, NULL, NULL, NULL, NULL, 4),
(42176, NULL, 'G3DSA:2.60.40.10:FF:003356', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42177, NULL, 'G3DSA:1.10.20.10:FF:000060', NULL, NULL, 'BTB domain containing 11', NULL, NULL, NULL, NULL, NULL, 4),
(42178, NULL, 'G3DSA:4.10.830.40:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42179, NULL, 'G3DSA:1.25.40.20:FF:001778', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42180, NULL, 'G3DSA:3.40.630.30:FF:000312', NULL, NULL, 'AANAT (Arylalkylamine N-AcetylTransferase) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(42181, NULL, 'G3DSA:3.30.70.330:FF:001168', NULL, NULL, 'Nuclear RNA export factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(42182, NULL, 'G3DSA:3.90.190.10:FF:000373', NULL, NULL, 'Protein-tyrosine-phosphatase PTP1', NULL, NULL, NULL, NULL, NULL, 4),
(42183, NULL, 'G3DSA:4.10.410.10:FF:000034', NULL, NULL, 'CBN-MEC-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(42184, NULL, 'G3DSA:1.25.10.10:FF:001386', NULL, NULL, 'Polyubiquitin binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(42185, NULL, 'G3DSA:3.50.50.60:FF:000789', NULL, NULL, 'YALI0B23430p', NULL, NULL, NULL, NULL, NULL, 4),
(42186, NULL, 'G3DSA:2.130.10.10:FF:003665', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42187, NULL, 'G3DSA:3.40.1110.10:FF:000272', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42188, NULL, 'G3DSA:2.40.50.140:FF:000996', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42189, NULL, 'G3DSA:3.30.300.20:FF:000039', NULL, NULL, 'Probable transcription termination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(42190, NULL, 'G3DSA:2.30.30.40:FF:000010', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(42191, NULL, 'G3DSA:2.10.230.10:FF:000005', NULL, NULL, 'DnaJ homolog subfamily A member 1', NULL, NULL, NULL, NULL, NULL, 4),
(42192, NULL, 'G3DSA:3.30.810.10:FF:000002', NULL, NULL, 'Phosphatidylinositol 4-phosphate 5-kinase type-1 gamma', NULL, NULL, NULL, NULL, NULL, 4),
(42193, NULL, 'G3DSA:3.20.20.330:FF:000014', NULL, NULL, 'Os01g0772900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(42194, NULL, 'G3DSA:3.90.550.10:FF:000114', NULL, NULL, 'UTP--glucose-1-phosphate uridylyltransferase 3 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(42195, NULL, 'G3DSA:1.20.140.10:FF:000056', NULL, NULL, 'Acyl-CoA dehydrogenase family member 9', NULL, NULL, NULL, NULL, NULL, 4),
(42196, NULL, 'G3DSA:1.20.1250.20:FF:001033', NULL, NULL, 'Oligopeptide transporter, kidney isoform', NULL, NULL, NULL, NULL, NULL, 4),
(42197, NULL, 'G3DSA:3.40.930.10:FF:000014', NULL, NULL, 'PTS system fructose-specific IIA component', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(42198, NULL, 'G3DSA:1.20.1070.10:FF:001044', NULL, NULL, 'AGAP002679-PA', NULL, NULL, NULL, NULL, NULL, 4),
(42199, NULL, 'G3DSA:2.30.39.10:FF:000105', NULL, NULL, 'Serpin family B member 8', NULL, NULL, NULL, NULL, NULL, 4),
(42200, NULL, 'G3DSA:1.10.510.10:FF:000250', NULL, NULL, 'Death-associated protein kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(42201, NULL, 'G3DSA:2.40.50.140:FF:001053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42202, NULL, 'G3DSA:1.10.10.60:FF:001193', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42203, NULL, 'G3DSA:3.10.580.10:FF:000128', NULL, NULL, 'CBS domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(42204, NULL, 'G3DSA:1.10.10.750:FF:000007', NULL, NULL, 'TBC1 domain family member', NULL, NULL, NULL, NULL, NULL, 4),
(42205, NULL, 'G3DSA:1.25.40.20:FF:001880', NULL, NULL, 'C2 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(42206, NULL, 'G3DSA:2.40.420.20:FF:000016', NULL, NULL, 'Efflux transporter, RND family, MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(42207, NULL, 'G3DSA:3.30.40.10:FF:000814', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(42208, NULL, 'G3DSA:3.40.50.300:FF:003845', NULL, NULL, 'GTP-binding protein Rheb homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(42209, NULL, 'G3DSA:1.20.1560.10:FF:000755', NULL, NULL, 'p-glycoprotein 5 putative', NULL, NULL, NULL, NULL, NULL, 4),
(42210, NULL, 'G3DSA:3.30.200.20:FF:001611', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42211, NULL, 'G3DSA:1.20.58.60:FF:000487', NULL, NULL, 'AGAP004440-PC', NULL, NULL, NULL, NULL, NULL, 4),
(42212, NULL, 'G3DSA:1.10.287.110:FF:000260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42213, NULL, 'G3DSA:3.20.20.80:FF:000317', NULL, NULL, 'Arabinogalactan endo-beta-1,4-galactanase', NULL, NULL, NULL, NULL, NULL, 4),
(42214, NULL, 'G3DSA:3.10.250.10:FF:000019', NULL, NULL, 'Neurotrypsin', NULL, NULL, NULL, NULL, NULL, 4),
(42215, NULL, 'G3DSA:2.30.29.30:FF:000953', NULL, NULL, 'Putative wiskott-aldrich syndrome-like a', NULL, NULL, NULL, NULL, NULL, 4),
(42216, NULL, 'G3DSA:3.40.1190.20:FF:000038', NULL, NULL, 'Hydroxymethylpyrimidine/phosphomethylpyrimidine kinase THI20', NULL, NULL, NULL, NULL, NULL, 4),
(42217, NULL, 'G3DSA:3.40.80.10:FF:000041', NULL, NULL, 'Glr3318 protein', NULL, NULL, NULL, NULL, NULL, 4),
(42218, NULL, 'G3DSA:1.10.10.740:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42219, NULL, 'G3DSA:3.40.20.10:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42220, NULL, 'G3DSA:3.40.50.800:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42221, NULL, 'G3DSA:1.20.1070.10:FF:000768', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42222, NULL, 'G3DSA:1.10.196.10:FF:000007', NULL, NULL, 'regulator of G-protein signaling 21', NULL, NULL, NULL, NULL, NULL, 4),
(42223, NULL, 'G3DSA:1.20.1250.20:FF:000538', NULL, NULL, 'Major facilitator transporter', NULL, NULL, NULL, NULL, NULL, 4),
(42224, NULL, 'G3DSA:3.40.1190.10:FF:000035', NULL, NULL, 'Dihydrofolate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(42225, NULL, 'G3DSA:3.40.190.80:FF:000040', NULL, NULL, '3''(2''),5''-bisphosphate nucleotidase CysQ', NULL, NULL, NULL, NULL, NULL, 4),
(42226, NULL, 'G3DSA:1.10.10.730:FF:000001', NULL, NULL, 'Transcriptional repressor protein KorB', NULL, NULL, NULL, NULL, NULL, 4),
(42227, NULL, 'G3DSA:3.40.50.150:FF:000001', NULL, NULL, 'Fibrillarin like 1', NULL, NULL, NULL, NULL, NULL, 4),
(42228, NULL, 'G3DSA:3.50.30.80:FF:000002', NULL, NULL, 'Dehydratase, YjhG/YagF family', NULL, NULL, NULL, NULL, NULL, 4),
(42229, NULL, 'G3DSA:1.10.238.200:FF:000002', NULL, NULL, 'DCN1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(42230, NULL, 'G3DSA:3.30.1490.180:FF:000030', NULL, NULL, 'RNA polymerase Rpb1, domain 2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(42231, NULL, 'G3DSA:1.10.10.60:FF:000001', NULL, NULL, 'MYB-related transcription factor', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(42232, NULL, 'G3DSA:1.25.40.10:FF:003136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42233, NULL, 'G3DSA:1.20.120.610:FF:000009', NULL, NULL, 'V-type proton ATPase 16 kDa proteolipid subunit', NULL, NULL, NULL, NULL, NULL, 4),
(42234, NULL, 'G3DSA:1.25.40.570:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42235, NULL, 'G3DSA:3.40.50.300:FF:002221', NULL, NULL, 'RuvB-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(42236, NULL, 'G3DSA:3.40.50.1700:FF:000015', NULL, NULL, 'Exported beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(42237, NULL, 'G3DSA:3.30.420.10:FF:000079', NULL, NULL, 'Polynucleotidyl transferase ribonuclease H fold protein with HRDC domain', NULL, NULL, NULL, NULL, NULL, 4),
(42238, NULL, 'G3DSA:3.30.40.10:FF:000679', NULL, NULL, 'SH3 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(42239, NULL, 'G3DSA:3.20.20.70:FF:000314', NULL, NULL, 'Uncharacterized protein, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(42240, NULL, 'G3DSA:1.10.287.130:FF:000266', NULL, NULL, 'Putative two-component system sensor kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(42241, NULL, 'G3DSA:3.40.50.150:FF:001535', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42242, NULL, 'G3DSA:6.10.250.3310:FF:000001', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(42243, NULL, 'G3DSA:3.40.50.300:FF:001945', NULL, NULL, 'Nuclease SbcCD subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(42244, NULL, 'G3DSA:1.20.1420.10:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42245, NULL, 'G3DSA:2.30.140.10:FF:000033', NULL, NULL, 'Spermidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(42246, NULL, 'G3DSA:1.10.238.210:FF:000005', NULL, NULL, 'Putative Glutaminase kidney', NULL, NULL, NULL, NULL, NULL, 4),
(42247, NULL, 'G3DSA:2.130.10.10:FF:005256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42248, NULL, 'G3DSA:3.30.450.20:FF:000483', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(42249, NULL, 'G3DSA:2.60.40.10:FF:001237', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(42250, NULL, 'G3DSA:1.10.238.220:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42251, NULL, 'G3DSA:3.30.540.30:FF:000015', NULL, NULL, 'Dipeptidyl peptidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(42252, NULL, 'G3DSA:1.25.10.10:FF:001381', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42253, NULL, 'G3DSA:3.30.160.60:FF:003805', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42254, NULL, 'G3DSA:1.10.510.10:FF:003684', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42255, NULL, 'G3DSA:2.60.120.200:FF:000444', NULL, NULL, 'Calreticulin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(42256, NULL, 'G3DSA:3.30.450.20:FF:000371', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(42257, NULL, 'G3DSA:3.30.960.10:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42258, NULL, 'G3DSA:1.25.40.10:FF:005154', NULL, NULL, 'Flagellar associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(42259, NULL, 'G3DSA:3.90.1580.10:FF:000003', NULL, NULL, 'Sulfatase modifying factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(42260, NULL, 'G3DSA:1.20.920.10:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42261, NULL, 'G3DSA:3.30.1960.10:FF:000001', NULL, NULL, 'tRNA wybutosine-synthesizing protein 3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(42262, NULL, 'G3DSA:1.10.246.140:FF:000007', NULL, NULL, 'Transcription and mRNA export factor ENY2', NULL, NULL, NULL, NULL, NULL, 4),
(42263, NULL, 'G3DSA:3.40.395.10:FF:000011', NULL, NULL, 'Ulp2p', NULL, NULL, NULL, NULL, NULL, 4),
(42264, NULL, 'G3DSA:1.10.238.10:FF:000004', NULL, NULL, 'Actinin alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(42265, NULL, 'G3DSA:3.90.850.10:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(42266, NULL, 'G3DSA:3.40.50.300:FF:003626', NULL, NULL, 'AGAP006235-PA', NULL, NULL, NULL, NULL, NULL, 4),
(42267, NULL, 'G3DSA:1.10.238.20:FF:000007', NULL, NULL, 'Odorant-binding protein 57b', NULL, NULL, NULL, NULL, NULL, 4),
(42268, NULL, 'G3DSA:3.90.180.10:FF:000198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42269, NULL, 'G3DSA:3.40.50.300:FF:005762', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(42270, NULL, 'G3DSA:3.40.50.300:FF:002103', NULL, NULL, 'DEAD box helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(42271, NULL, 'G3DSA:1.10.246.130:FF:000004', NULL, NULL, 'Gamma-glutamyltranspeptidase (Ggt)', NULL, NULL, NULL, NULL, NULL, 4),
(42272, NULL, 'G3DSA:3.40.630.30:FF:000290', NULL, NULL, 'Protein CBG23731', NULL, NULL, NULL, NULL, NULL, 4),
(42273, NULL, 'G3DSA:3.50.50.60:FF:000784', NULL, NULL, 'Cinnamate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(42274, NULL, 'G3DSA:1.20.1280.50:FF:000021', NULL, NULL, 'Adagio protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(42275, NULL, 'G3DSA:3.10.450.10:FF:000012', NULL, NULL, 'Retinoic acid receptor responder (tazarotene-induced) 1', NULL, NULL, NULL, NULL, NULL, 4),
(42276, NULL, 'G3DSA:2.130.10.10:FF:005363', NULL, NULL, 'Cirhin-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(42277, NULL, 'G3DSA:3.30.420.10:FF:000433', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42278, NULL, 'G3DSA:3.20.20.140:FF:000283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42279, NULL, 'G3DSA:2.20.25.20:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42280, NULL, 'G3DSA:3.30.9.10:FF:000045', NULL, NULL, 'D-amino acid oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(42281, NULL, 'G3DSA:1.10.1760.20:FF:000012', NULL, NULL, 'Thiamine transporter ThiT', NULL, NULL, NULL, NULL, NULL, 4),
(42282, NULL, 'G3DSA:2.60.120.330:FF:000117', NULL, NULL, '2OG-Fe(II) oxygenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(42283, NULL, 'G3DSA:3.80.10.10:FF:000552', NULL, NULL, 'RNI-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(42284, NULL, 'G3DSA:3.40.50.2000:FF:000987', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42285, NULL, 'G3DSA:4.10.40.20:FF:000006', NULL, NULL, 'insulin-like growth factor-binding protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(42286, NULL, 'G3DSA:3.40.50.300:FF:001491', NULL, NULL, 'Dynein heavy chain domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(42287, NULL, 'G3DSA:3.40.50.10490:FF:000116', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42288, NULL, 'G3DSA:1.50.10.10:FF:000237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42289, NULL, 'G3DSA:2.20.25.10:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(42290, NULL, 'G3DSA:2.40.37.10:FF:000084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42291, NULL, 'G3DSA:4.10.1240.10:FF:000006', NULL, NULL, 'corticotropin-releasing factor receptor 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(42292, NULL, 'G3DSA:1.10.287.370:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42293, NULL, 'G3DSA:1.10.8.10:FF:000165', NULL, NULL, 'Baculoviral IAP repeat-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(42294, NULL, 'G3DSA:1.10.630.10:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42295, NULL, 'G3DSA:3.30.160.60:FF:000028', NULL, NULL, 'zinc finger protein 90 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(42296, NULL, 'G3DSA:2.60.40.10:FF:003249', NULL, NULL, '1,4-alpha-glucan branching enzyme GlgB', NULL, NULL, NULL, NULL, NULL, 4),
(42297, NULL, 'G3DSA:2.60.40.10:FF:005385', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42298, NULL, 'G3DSA:1.10.1780.10:FF:000004', NULL, NULL, 'ATP-dependent Clp protease ATP-binding subunit ClpC', NULL, NULL, NULL, NULL, NULL, 4),
(42299, NULL, 'G3DSA:3.40.1160.10:FF:000106', NULL, NULL, 'Glutamate 5-kinase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(42300, NULL, 'G3DSA:2.30.29.30:FF:000509', NULL, NULL, 'Phosphatidylinositol 3-kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(42301, NULL, 'G3DSA:1.25.40.10:FF:003018', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g11310, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(42302, NULL, 'G3DSA:2.70.150.10:FF:000002', NULL, NULL, 'Copper-transporting ATPase 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(42303, NULL, 'G3DSA:3.30.160.60:FF:005941', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42304, NULL, 'G3DSA:3.10.105.10:FF:000115', NULL, NULL, 'Glr3204 protein', NULL, NULL, NULL, NULL, NULL, 4),
(42305, NULL, 'G3DSA:4.10.280.10:FF:000085', NULL, NULL, 'Transcription factor bHLH126', NULL, NULL, NULL, NULL, NULL, 4),
(42306, NULL, 'G3DSA:3.30.1610.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42307, NULL, 'G3DSA:2.60.40.790:FF:000010', NULL, NULL, '17.3 kDa class II heat shock protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(42308, NULL, 'G3DSA:1.25.40.10:FF:005261', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(42309, NULL, 'G3DSA:3.40.1190.20:FF:000044', NULL, NULL, 'Carbohydrate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(42310, NULL, 'G3DSA:1.20.5.350:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42311, NULL, 'G3DSA:3.30.70.890:FF:000026', NULL, NULL, 'Diphosphomevalonate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(42312, NULL, 'G3DSA:3.30.70.330:FF:001404', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42313, NULL, 'G3DSA:2.70.98.30:FF:000010', NULL, NULL, 'Cytosolic alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(42314, NULL, 'G3DSA:3.20.20.140:FF:000390', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42315, NULL, 'G3DSA:1.25.10.10:FF:001274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42316, NULL, 'G3DSA:3.80.10.10:FF:002783', NULL, NULL, 'F-box family protein', NULL, NULL, NULL, NULL, NULL, 4),
(42317, NULL, 'G3DSA:1.20.90.10:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42318, NULL, 'G3DSA:3.30.470.10:FF:000037', NULL, NULL, 'Branched-chain amino acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(42319, NULL, 'G3DSA:1.20.58.390:FF:000230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42320, NULL, 'G3DSA:2.40.40.20:FF:000083', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(42321, NULL, 'G3DSA:1.10.287.70:FF:000074', NULL, NULL, 'Transient receptor potential cation channel subfamily V member 1', NULL, NULL, NULL, NULL, NULL, 4),
(42322, NULL, 'G3DSA:2.60.40.10:FF:002052', NULL, NULL, 'Ig heavy chain V region MOO', NULL, NULL, NULL, NULL, NULL, 4),
(42323, NULL, 'G3DSA:3.40.30.10:FF:000206', NULL, NULL, 'Probable glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(42324, NULL, 'G3DSA:3.40.50.720:FF:002572', NULL, NULL, 'NmrA-like family domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(42325, NULL, 'G3DSA:2.10.25.10:FF:000119', NULL, NULL, 'vitamin K-dependent protein S', NULL, NULL, NULL, NULL, NULL, 4),
(42326, NULL, 'G3DSA:1.10.510.10:FF:002161', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(42327, NULL, 'G3DSA:1.25.40.10:FF:000949', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(42328, NULL, 'G3DSA:1.10.20.10:FF:000301', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42329, NULL, 'G3DSA:3.80.10.10:FF:002676', NULL, NULL, 'Leucine-rich repeat transmembrane protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(42330, NULL, 'G3DSA:3.80.10.10:FF:002569', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42331, NULL, 'G3DSA:1.10.150.50:FF:000155', NULL, NULL, 'STE11', NULL, NULL, NULL, NULL, NULL, 4),
(42332, NULL, 'G3DSA:3.40.50.1820:FF:001321', NULL, NULL, '3-oxoadipate enol-lactone hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(42333, NULL, 'G3DSA:2.130.10.10:FF:003227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(42334, NULL, 'G3DSA:3.40.1190.10:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42335, NULL, 'G3DSA:3.40.50.720:FF:001037', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(42336, NULL, 'G3DSA:3.40.630.30:FF:000183', NULL, NULL, 'Acetyltransferase YpeA', NULL, NULL, NULL, NULL, NULL, 4),
(42337, NULL, 'G3DSA:1.20.58.60:FF:000616', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(42338, NULL, 'G3DSA:3.40.50.300:FF:003519', NULL, NULL, 'GD23310', NULL, NULL, NULL, NULL, NULL, 4),
(42339, NULL, 'G3DSA:2.130.10.10:FF:003906', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42340, NULL, 'G3DSA:1.10.10.10:FF:001217', NULL, NULL, 'Transcriptional regulatory protein TcrA', NULL, NULL, NULL, NULL, NULL, 4),
(42341, NULL, 'G3DSA:1.10.10.490:FF:000002', NULL, NULL, 'protein LZIC isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(42342, NULL, 'G3DSA:1.10.1200.10:FF:000102', NULL, NULL, 'Nonribosomal peptide synthetase fmqC', NULL, NULL, NULL, NULL, NULL, 4),
(42343, NULL, 'G3DSA:3.30.40.10:FF:001522', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42344, NULL, 'G3DSA:3.10.20.90:FF:000152', NULL, NULL, 'regulator of G-protein signaling 12', NULL, NULL, NULL, NULL, NULL, 4),
(42345, NULL, 'G3DSA:1.20.1070.10:FF:000780', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(42346, NULL, 'G3DSA:1.10.150.50:FF:000048', NULL, NULL, 'kazrin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(42347, NULL, 'G3DSA:2.30.29.30:FF:000728', NULL, NULL, 'Myotubularin-related protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(42348, NULL, 'G3DSA:1.10.1060.10:FF:000006', NULL, NULL, 'Glutamate synthase (NADPH/NADH)', NULL, NULL, NULL, NULL, NULL, 4),
(42349, NULL, 'G3DSA:1.25.10.10:FF:003409', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42350, NULL, 'G3DSA:1.20.58.80:FF:000026', NULL, NULL, 'serine/threonine-protein kinase ULK3', NULL, NULL, NULL, NULL, NULL, 4),
(42351, NULL, 'G3DSA:1.10.287.470:FF:000025', NULL, NULL, 'HlyD family secretion protein', NULL, NULL, NULL, NULL, NULL, 4),
(42352, NULL, 'G3DSA:1.20.58.90:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42353, NULL, 'G3DSA:3.30.70.330:FF:002697', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42354, NULL, 'G3DSA:1.20.58.60:FF:000386', NULL, NULL, 'Spectrin repeat containing, nuclear envelope 1a', NULL, NULL, NULL, NULL, NULL, 4),
(42355, NULL, 'G3DSA:3.40.570.10:FF:000037', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(42356, NULL, 'G3DSA:3.40.720.10:FF:000077', NULL, NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase 3', NULL, NULL, NULL, NULL, NULL, 4),
(42357, NULL, 'G3DSA:2.20.100.10:FF:000191', NULL, NULL, 'Netrin receptor unc-5', NULL, NULL, NULL, NULL, NULL, 4),
(42358, NULL, 'G3DSA:2.10.50.10:FF:000065', NULL, NULL, 'TNF receptor superfamily member 14', NULL, NULL, NULL, NULL, NULL, 4),
(42359, NULL, 'G3DSA:3.20.20.80:FF:000856', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42360, NULL, 'G3DSA:3.60.40.10:FF:000324', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42361, NULL, 'G3DSA:3.40.120.10:FF:000104', NULL, NULL, 'Phosphoglucomutase/phosphomannomutase alpha/beta/alpha domain I', NULL, NULL, NULL, NULL, NULL, 4),
(42362, NULL, 'G3DSA:1.10.10.10:FF:000020', NULL, NULL, 'SWI/SNF complex subunit SMARCC2 isoform c', NULL, NULL, NULL, NULL, NULL, 4),
(42363, NULL, 'G3DSA:1.20.1070.10:FF:000549', NULL, NULL, 'Olfactory receptor 10T2', NULL, NULL, NULL, NULL, NULL, 4),
(42364, NULL, 'G3DSA:3.40.718.10:FF:000038', NULL, NULL, '1,2-dihydroxy-3,5-cyclohexadiene-1,4-dicarboxylate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(42365, NULL, 'G3DSA:1.10.506.10:FF:000032', NULL, NULL, 'RAS protein activator like-3', NULL, NULL, NULL, NULL, NULL, 4),
(42366, NULL, 'G3DSA:3.90.1480.20:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42367, NULL, 'G3DSA:3.20.20.190:FF:000051', NULL, NULL, 'DNA-(Apurinic or apyrimidinic site) lyase 2', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(42368, NULL, 'G3DSA:2.30.29.30:FF:000498', NULL, NULL, 'Switch-associated protein 70', NULL, NULL, NULL, NULL, NULL, 4),
(42369, NULL, 'G3DSA:1.20.1560.10:FF:000750', NULL, NULL, 'Os06g0184766 protein', NULL, NULL, NULL, NULL, NULL, 4),
(42370, NULL, 'G3DSA:3.40.1620.60:FF:000005', NULL, NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 9', NULL, NULL, NULL, NULL, NULL, 4),
(42371, NULL, 'G3DSA:2.60.40.60:FF:000133', NULL, NULL, 'protocadherin-18 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(42372, NULL, 'G3DSA:3.40.50.10470:FF:000003', NULL, NULL, 'Methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(42373, NULL, 'G3DSA:2.20.25.10:FF:000130', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(42374, NULL, 'G3DSA:2.60.40.420:FF:000282', NULL, NULL, 'Cytochrome c oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(42375, NULL, 'G3DSA:3.40.140.20:FF:000002', NULL, NULL, 'Bifunctional purine biosynthesis protein PurH', NULL, NULL, NULL, NULL, NULL, 4),
(42376, NULL, 'G3DSA:3.40.50.150:FF:001294', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42377, NULL, 'G3DSA:1.10.8.10:FF:000272', NULL, NULL, 'Tyrosyl-DNA phosphodiesterase 2', NULL, NULL, NULL, NULL, NULL, 4),
(42378, NULL, 'G3DSA:3.40.30.10:FF:000195', NULL, NULL, 'thioredoxin-like fold domain-containing protein MRL7, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(42379, NULL, 'G3DSA:1.10.390.10:FF:000043', NULL, NULL, 'Putative aminopeptidase-2', NULL, NULL, NULL, NULL, NULL, 4),
(42380, NULL, 'G3DSA:2.60.40.1820:FF:000002', NULL, NULL, 'Late embryogenesis abundant protein Lea14-A', NULL, NULL, NULL, NULL, NULL, 4),
(42381, NULL, 'G3DSA:2.40.50.140:FF:000889', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42382, NULL, 'G3DSA:3.30.70.330:FF:001067', NULL, NULL, 'Serine/arginine-rich splicing factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(42383, NULL, 'G3DSA:2.30.42.10:FF:000579', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42384, NULL, 'G3DSA:3.10.105.10:FF:000008', NULL, NULL, 'Peptide/nickel ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(42385, NULL, 'G3DSA:3.90.550.10:FF:000007', NULL, NULL, 'probable xyloglucan glycosyltransferase 5', NULL, NULL, NULL, NULL, NULL, 4),
(42386, NULL, 'G3DSA:3.20.20.140:FF:000176', NULL, NULL, 'Deoxyribonuclease tatD', NULL, NULL, NULL, NULL, NULL, 4),
(42387, NULL, 'G3DSA:2.60.40.340:FF:000010', NULL, NULL, 'Nuclear factor of activated T cells 3', NULL, NULL, NULL, NULL, NULL, 4),
(42388, NULL, 'G3DSA:3.50.50.60:FF:000677', NULL, NULL, 'Spermine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(42389, NULL, 'G3DSA:3.40.50.1100:FF:000150', NULL, NULL, 'Tryptophan synthase beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(42390, NULL, 'G3DSA:3.40.720.10:FF:000307', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42391, NULL, 'G3DSA:3.20.20.140:FF:000064', NULL, NULL, 'Adenosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(42392, NULL, 'G3DSA:1.10.510.10:FF:003577', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42393, NULL, 'G3DSA:3.30.420.10:FF:000540', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42394, NULL, 'G3DSA:3.40.50.10480:FF:000006', NULL, NULL, 'RNA processing factor 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(42395, NULL, 'G3DSA:3.40.50.300:FF:005981', NULL, NULL, '26S protease regulatory subunit s10b putative', NULL, NULL, NULL, NULL, NULL, 4),
(42396, NULL, 'G3DSA:3.40.50.1820:FF:000490', NULL, NULL, 'Peptidase S10 serine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(42397, NULL, 'G3DSA:1.10.10.10:FF:001650', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(42398, NULL, 'G3DSA:3.40.50.300:FF:006959', NULL, NULL, 'RAD51-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(42399, NULL, 'G3DSA:3.40.80.10:FF:000029', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(42400, NULL, 'G3DSA:1.25.40.10:FF:003804', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(42401, NULL, 'G3DSA:3.40.50.10490:FF:000009', NULL, NULL, 'DNA-binding transcriptional regulator HexR', NULL, NULL, NULL, NULL, NULL, 4),
(42402, NULL, 'G3DSA:1.20.960.40:FF:000003', NULL, NULL, 'Putative trans-2-enoyl-CoA reductase, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(42403, NULL, 'G3DSA:3.40.50.1110:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42404, NULL, 'G3DSA:3.10.20.860:FF:000001', NULL, NULL, 'Antitoxin MqsA', NULL, NULL, NULL, NULL, NULL, 4),
(42405, NULL, 'G3DSA:2.60.40.1930:FF:000035', NULL, NULL, 'Complement component C3-4', NULL, NULL, NULL, NULL, NULL, 4),
(42406, NULL, 'G3DSA:3.30.360.20:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42407, NULL, 'G3DSA:1.20.1250.20:FF:001600', NULL, NULL, 'YALI0E27225p', NULL, NULL, NULL, NULL, NULL, 4),
(42408, NULL, 'G3DSA:3.10.20.90:FF:000040', NULL, NULL, 'FERM, RhoGEF and pleckstrin domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(42409, NULL, 'G3DSA:3.30.450.20:FF:000590', NULL, NULL, 'C4-dicarboxylate transport sensor protein dctB', NULL, NULL, NULL, NULL, NULL, 4),
(42410, NULL, 'G3DSA:1.10.730.20:FF:000016', NULL, NULL, 'Putative isoleucine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(42411, NULL, 'G3DSA:1.25.40.20:FF:001902', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42412, NULL, 'G3DSA:3.30.70.330:FF:000792', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(42413, NULL, 'G3DSA:1.20.1270.190:FF:000002', NULL, NULL, 'ExsD', NULL, NULL, NULL, NULL, NULL, 4),
(42414, NULL, 'G3DSA:1.10.238.10:FF:000111', NULL, NULL, 'Calcium-dependent protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(42415, NULL, 'G3DSA:2.60.40.10:FF:005615', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42416, NULL, 'G3DSA:3.40.50.300:FF:007667', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42417, NULL, 'G3DSA:1.10.30.10:FF:000122', NULL, NULL, 'PMS1 homolog 1, mismatch repair system component', NULL, NULL, NULL, NULL, NULL, 4),
(42418, NULL, 'G3DSA:3.30.420.10:FF:000652', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42419, NULL, 'G3DSA:4.10.900.10:FF:000004', NULL, NULL, 'lymphoid enhancer-binding factor 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(42420, NULL, 'G3DSA:1.50.40.10:FF:000065', NULL, NULL, 'ADP,ATP carrier protein ER-ANT1', NULL, NULL, NULL, NULL, NULL, 4),
(42421, NULL, 'G3DSA:3.50.30.30:FF:000116', NULL, NULL, 'Ring finger protein 167', NULL, NULL, NULL, NULL, NULL, 4),
(42422, NULL, 'G3DSA:3.20.70.20:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42423, NULL, 'G3DSA:3.60.21.10:FF:000061', NULL, NULL, 'Metallophosphoesterase', NULL, NULL, NULL, NULL, NULL, 4),
(42424, NULL, 'G3DSA:3.30.160.60:FF:003794', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42425, NULL, 'G3DSA:1.10.238.10:FF:001297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42426, NULL, 'G3DSA:3.80.10.10:FF:000771', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase GSO1', NULL, NULL, NULL, NULL, NULL, 4),
(42427, NULL, 'G3DSA:3.90.70.10:FF:000111', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 11', NULL, NULL, NULL, NULL, NULL, 4),
(42428, NULL, 'G3DSA:3.30.1780.10:FF:000015', NULL, NULL, 'Ornithine cyclodeaminase', NULL, NULL, NULL, NULL, NULL, 4),
(42429, NULL, 'G3DSA:3.20.20.150:FF:000067', NULL, NULL, 'Putative hydroxypyruvate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(42430, NULL, 'G3DSA:1.10.510.10:FF:004201', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42431, NULL, 'G3DSA:2.30.40.10:FF:000176', NULL, NULL, 'Isoaspartyl dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(42432, NULL, 'G3DSA:3.80.10.10:FF:001260', NULL, NULL, 'Toll-like receptor 6', NULL, NULL, NULL, NULL, NULL, 4),
(42433, NULL, 'G3DSA:2.170.300.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42434, NULL, 'G3DSA:1.10.287.310:FF:000005', NULL, NULL, '50S ribosomal protein L29', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(42435, NULL, 'G3DSA:3.20.20.80:FF:000637', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42436, NULL, 'G3DSA:1.10.287.70:FF:000293', NULL, NULL, 'Osm-9 and Capsaicin receptor-Related', NULL, NULL, NULL, NULL, NULL, 4),
(42437, NULL, 'G3DSA:3.30.499.10:FF:000013', NULL, NULL, 'Homoaconitase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(42438, NULL, 'G3DSA:3.30.479.20:FF:000009', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(42439, NULL, 'G3DSA:3.40.970.10:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42440, NULL, 'G3DSA:3.90.1430.10:FF:000003', NULL, NULL, 'Elongation factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(42441, NULL, 'G3DSA:3.40.50.300:FF:003396', NULL, NULL, 'DNA replication ATP-dependent helicase/nuclease DNA2', NULL, NULL, NULL, NULL, NULL, 4),
(42442, NULL, 'G3DSA:3.80.10.10:FF:002457', NULL, NULL, 'Receptor-like protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(42443, NULL, 'G3DSA:3.40.50.1400:FF:000026', NULL, NULL, 'Ferrochelatase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(42444, NULL, 'G3DSA:3.30.479.10:FF:000006', NULL, NULL, '6-carboxy-5,6,7,8-tetrahydropterin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(42445, NULL, 'G3DSA:3.20.20.70:FF:000634', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42446, NULL, 'G3DSA:2.60.40.10:FF:006104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42447, NULL, 'G3DSA:3.10.50.40:FF:000111', NULL, NULL, 'PPIC-type PPIASE domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(42448, NULL, 'G3DSA:1.10.530.10:FF:000032', NULL, NULL, 'Putative autolysin, N-acetylmuramidase', NULL, NULL, NULL, NULL, NULL, 4),
(42449, NULL, 'G3DSA:3.40.30.10:FF:000425', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(42450, NULL, 'G3DSA:1.25.10.10:FF:003179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42451, NULL, 'G3DSA:1.20.120.1710:FF:000003', NULL, NULL, 'NAD-dependent histone deacetylase SIR2', NULL, NULL, NULL, NULL, NULL, 4),
(42452, NULL, 'G3DSA:1.10.8.590:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42453, NULL, 'G3DSA:1.10.555.10:FF:000016', NULL, NULL, 'Rho GTPase activating protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(42454, NULL, 'G3DSA:2.10.25.10:FF:000445', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(42455, NULL, 'G3DSA:3.40.630.30:FF:000071', NULL, NULL, 'Acetyltransf_1', NULL, NULL, NULL, NULL, NULL, 4),
(42456, NULL, 'G3DSA:3.40.50.11500:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42457, NULL, 'G3DSA:3.40.50.10190:FF:000133', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(42458, NULL, 'G3DSA:2.30.30.190:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42459, NULL, 'G3DSA:3.30.460.10:FF:000082', NULL, NULL, 'Poly(A) polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(42460, NULL, 'G3DSA:3.40.950.10:FF:000004', NULL, NULL, 'NADP-reducing hydrogenase subunit HndD', NULL, NULL, NULL, NULL, NULL, 4),
(42461, NULL, 'G3DSA:2.60.120.920:FF:000081', NULL, NULL, 'Vacuolar import and degradation protein', NULL, NULL, NULL, NULL, NULL, 4),
(42462, NULL, 'G3DSA:3.40.50.620:FF:000743', NULL, NULL, 'Uncharacterized protein C167.05', NULL, NULL, NULL, NULL, NULL, 4),
(42463, NULL, 'G3DSA:3.90.650.10:FF:000066', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(42464, NULL, 'G3DSA:1.10.10.10:FF:001094', NULL, NULL, 'DNA-binding transcriptional regulator, MarR family', NULL, NULL, NULL, NULL, NULL, 4),
(42465, NULL, 'G3DSA:1.10.225.10:FF:000025', NULL, NULL, 'Saposin-related', NULL, NULL, NULL, NULL, NULL, 4),
(42466, NULL, 'G3DSA:1.25.40.720:FF:000028', NULL, NULL, 'Liquid facets-Related, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(42467, NULL, 'G3DSA:3.30.56.30:FF:000002', NULL, NULL, 'Signal recognition particle 19kDa', NULL, NULL, NULL, NULL, NULL, 4),
(42468, NULL, 'G3DSA:1.10.510.10:FF:001672', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(42469, NULL, 'G3DSA:3.90.1290.10:FF:000014', NULL, NULL, 'microtubule-actin cross-linking factor 1 isoform X21', NULL, NULL, NULL, NULL, NULL, 4),
(42470, NULL, 'G3DSA:3.40.1350.10:FF:000025', NULL, NULL, 'AGAP009485-PA', NULL, NULL, NULL, NULL, NULL, 4),
(42471, NULL, 'G3DSA:2.20.100.10:FF:000207', NULL, NULL, 'Thrombospondin type I repeat-containing single pass transmembrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(42472, NULL, 'G3DSA:3.30.470.20:FF:000254', NULL, NULL, '3-methylornithine--L-lysine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(42473, NULL, 'G3DSA:3.40.50.300:FF:004020', NULL, NULL, 'Putative ATP-dependent RNA helicase DDX56', NULL, NULL, NULL, NULL, NULL, 4),
(42474, NULL, 'G3DSA:3.40.50.300:FF:005650', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42475, NULL, 'G3DSA:1.25.10.10:FF:001829', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42476, NULL, 'G3DSA:3.40.50.720:FF:000655', NULL, NULL, 'D-erythrose-4-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(42477, NULL, 'G3DSA:1.20.5.3310:FF:000003', NULL, NULL, 'Sec-independent protein translocase protein TATB, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(42478, NULL, 'G3DSA:1.25.40.180:FF:000259', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42479, NULL, 'G3DSA:3.20.20.140:FF:000171', NULL, NULL, 'AMP deaminase 3', NULL, NULL, NULL, NULL, NULL, 4),
(42480, NULL, 'G3DSA:3.30.70.330:FF:001623', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42481, NULL, 'G3DSA:1.25.40.10:FF:003237', NULL, NULL, 'Pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(42482, NULL, 'G3DSA:1.10.601.10:FF:000006', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(42483, NULL, 'G3DSA:1.10.1580.10:FF:000023', NULL, NULL, 'Ferrous iron transporter B', NULL, NULL, NULL, NULL, NULL, 4),
(42484, NULL, 'G3DSA:2.60.40.10:FF:001670', NULL, NULL, 'Down syndrome cell adhesion molecule-like protein Dscam2', NULL, NULL, NULL, NULL, NULL, 4),
(42485, NULL, 'G3DSA:3.90.228.10:FF:000028', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(42486, NULL, 'G3DSA:1.10.238.10:FF:000116', NULL, NULL, 'calretinin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(42487, NULL, 'G3DSA:3.40.630.30:FF:000413', NULL, NULL, 'ActC', NULL, NULL, NULL, NULL, NULL, 4),
(42488, NULL, 'G3DSA:1.10.3060.10:FF:000006', NULL, NULL, 'Protein translocase subunit SecA 2', NULL, NULL, NULL, NULL, NULL, 4),
(42489, NULL, 'G3DSA:3.40.720.10:FF:000291', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42490, NULL, 'G3DSA:3.30.1490.80:FF:000019', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(42491, NULL, 'G3DSA:3.50.50.60:FF:001166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42492, NULL, 'G3DSA:3.60.90.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42493, NULL, 'G3DSA:3.30.160.60:FF:005722', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42494, NULL, 'G3DSA:3.30.160.60:FF:005048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42495, NULL, 'G3DSA:3.30.1490.70:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42496, NULL, 'G3DSA:1.20.5.350:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42497, NULL, 'G3DSA:2.30.30.140:FF:000163', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(42498, NULL, 'G3DSA:3.40.50.2300:FF:000763', NULL, NULL, 'Odorant receptor VR5.3', NULL, NULL, NULL, NULL, NULL, 4),
(42499, NULL, 'G3DSA:3.80.10.10:FF:002906', NULL, NULL, 'Protein CBG18939', NULL, NULL, NULL, NULL, NULL, 4),
(42500, NULL, 'G3DSA:1.10.8.10:FF:000053', NULL, NULL, 'Ubiquitin-associated and SH3 domain-containing, A', NULL, NULL, NULL, NULL, NULL, 4),
(42501, NULL, 'G3DSA:3.30.160.60:FF:005374', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42502, NULL, 'G3DSA:1.20.120.340:FF:000012', NULL, NULL, 'Perilipin', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(42503, NULL, 'G3DSA:1.20.120.350:FF:000015', NULL, NULL, 'Voltage-dependent N-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(42504, NULL, 'G3DSA:2.10.250.10:FF:000006', NULL, NULL, 'Calreticulin', NULL, NULL, NULL, NULL, NULL, 4),
(42505, NULL, 'G3DSA:3.70.10.10:FF:000052', NULL, NULL, 'DNA repair protein Rad1', NULL, NULL, NULL, NULL, NULL, 4),
(42506, NULL, 'G3DSA:2.130.10.10:FF:005144', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(42507, NULL, 'G3DSA:3.40.50.300:FF:005543', NULL, NULL, 'ADP-ribosylation factor A1F', NULL, NULL, NULL, NULL, NULL, 4),
(42508, NULL, 'G3DSA:2.60.40.1130:FF:000008', NULL, NULL, 'Rab geranylgeranyltransferase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(42509, NULL, 'G3DSA:1.20.1560.10:FF:000643', NULL, NULL, 'Multidrug resistance protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(42510, NULL, 'G3DSA:3.40.50.720:FF:000548', NULL, NULL, 'Ast1p', NULL, NULL, NULL, NULL, NULL, 4),
(42511, NULL, 'G3DSA:3.40.50.2000:FF:001044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42512, NULL, 'G3DSA:3.10.129.10:FF:000249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42513, NULL, 'G3DSA:3.40.50.150:FF:001299', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42514, NULL, 'G3DSA:2.60.120.200:FF:000663', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42515, NULL, 'G3DSA:1.10.1900.20:FF:000001', NULL, NULL, '50S ribosomal protein L20', NULL, NULL, NULL, NULL, NULL, 4),
(42516, NULL, 'G3DSA:2.30.30.770:FF:000003', NULL, NULL, '60S ribosomal protein L27', NULL, NULL, NULL, NULL, NULL, 4),
(42517, NULL, 'G3DSA:2.60.40.2690:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42518, NULL, 'G3DSA:1.10.630.10:FF:000646', NULL, NULL, 'Os04g0174100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(42519, NULL, 'G3DSA:3.80.10.10:FF:002238', NULL, NULL, 'Os08g0203100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(42520, NULL, 'G3DSA:3.40.50.150:FF:001636', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42521, NULL, 'G3DSA:2.60.40.10:FF:005941', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42522, NULL, 'G3DSA:4.10.280.10:FF:000208', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(42523, NULL, 'G3DSA:3.40.50.150:FF:000113', NULL, NULL, 'Glycine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(42524, NULL, 'G3DSA:3.30.200.20:FF:001268', NULL, NULL, 'Cdc2-related kinase 8', NULL, NULL, NULL, NULL, NULL, 4),
(42525, NULL, 'G3DSA:1.10.3500.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42526, NULL, 'G3DSA:3.30.70.1230:FF:000135', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(42527, NULL, 'G3DSA:3.40.50.1820:FF:001214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42528, NULL, 'G3DSA:1.10.10.60:FF:000113', NULL, NULL, 'homeobox protein Hox-B1', NULL, NULL, NULL, NULL, NULL, 4),
(42529, NULL, 'G3DSA:1.10.10.60:FF:000006', NULL, NULL, 'DNA-binding protein Fis', NULL, NULL, NULL, NULL, NULL, 4),
(42530, NULL, 'G3DSA:3.30.70.330:FF:000100', NULL, NULL, 'Putative ribonucleoprotein PTB-binding 1', NULL, NULL, NULL, NULL, NULL, 4),
(42531, NULL, 'G3DSA:3.30.200.20:FF:001616', NULL, NULL, 'Serine/threonine-protein kinase 38-like', NULL, NULL, NULL, NULL, NULL, 4),
(42532, NULL, 'G3DSA:3.50.50.60:FF:001508', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(42533, NULL, 'G3DSA:3.40.50.2000:FF:000768', NULL, NULL, 'Glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(42534, NULL, 'G3DSA:3.60.140.10:FF:000017', NULL, NULL, 'Polyphenol oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(42535, NULL, 'G3DSA:1.20.1740.10:FF:000062', NULL, NULL, 'Vesicular inhibitory amino acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(42536, NULL, 'G3DSA:1.10.555.10:FF:000235', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42537, NULL, 'G3DSA:1.20.1250.10:FF:000092', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(42538, NULL, 'G3DSA:1.20.58.390:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42539, NULL, 'G3DSA:3.10.50.40:FF:000116', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(42540, NULL, 'G3DSA:3.30.160.60:FF:003468', NULL, NULL, 'Zinc finger protein 233', NULL, NULL, NULL, NULL, NULL, 4),
(42541, NULL, 'G3DSA:3.40.50.300:FF:002322', NULL, NULL, 'Shikimate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(42542, NULL, 'G3DSA:3.40.50.10190:FF:000352', NULL, NULL, 'BRCT-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(42543, NULL, 'G3DSA:3.30.200.20:FF:001723', NULL, NULL, 'Serine/threonine-protein kinase haspin', NULL, NULL, NULL, NULL, NULL, 4),
(42544, NULL, 'G3DSA:2.10.70.10:FF:000302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42545, NULL, 'G3DSA:3.20.20.80:FF:000418', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42546, NULL, 'G3DSA:1.25.40.10:FF:001438', NULL, NULL, 'Sel1 repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(42547, NULL, 'G3DSA:2.130.10.10:FF:000017', NULL, NULL, 'SEC13 homolog (S. cerevisiae)', NULL, NULL, NULL, NULL, NULL, 4),
(42548, NULL, 'G3DSA:1.10.8.1220:FF:000008', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(42549, NULL, 'G3DSA:3.10.350.10:FF:000078', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(42550, NULL, 'G3DSA:1.25.10.10:FF:002105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42551, NULL, 'G3DSA:1.10.555.10:FF:000128', NULL, NULL, 'Rho GTPase-activating protein 39', NULL, NULL, NULL, NULL, NULL, 4),
(42552, NULL, 'G3DSA:3.40.50.1400:FF:000021', NULL, NULL, 'Sirohydrochlorin ferrochelatase B', NULL, NULL, NULL, NULL, NULL, 4),
(42553, NULL, 'G3DSA:3.90.660.10:FF:000128', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42554, NULL, 'G3DSA:3.20.20.70:FF:000415', NULL, NULL, 'Anaerobic ribonucleoside-triphosphate reductase activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(42555, NULL, 'G3DSA:4.10.240.10:FF:000088', NULL, NULL, 'Zinc cluster transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(42556, NULL, 'G3DSA:4.10.1000.40:FF:000003', NULL, NULL, 'Nuclear polyadenylated RNA-binding protein NAB2', NULL, NULL, NULL, NULL, NULL, 4),
(42557, NULL, 'G3DSA:1.20.1250.20:FF:000095', NULL, NULL, 'Alpha-ketoglutarate permease', NULL, NULL, NULL, NULL, NULL, 4),
(42558, NULL, 'G3DSA:3.40.50.620:FF:000069', NULL, NULL, 'diphthine--ammonia ligase', NULL, NULL, NULL, NULL, NULL, 4),
(42559, NULL, 'G3DSA:3.40.50.150:FF:000006', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(42560, NULL, 'G3DSA:3.40.630.30:FF:000076', NULL, NULL, 'Blast:N-acetyltransferase 6', NULL, NULL, NULL, NULL, NULL, 4),
(42561, NULL, 'G3DSA:3.30.70.100:FF:000048', NULL, NULL, 'Antibiotic biosynthesis monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(42562, NULL, 'G3DSA:1.20.120.1910:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42563, NULL, 'G3DSA:2.60.40.10:FF:005722', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42564, NULL, 'G3DSA:2.30.29.30:FF:000616', NULL, NULL, 'Oxysterol-binding protein-like 7', NULL, NULL, NULL, NULL, NULL, 4),
(42565, NULL, 'G3DSA:3.30.70.1820:FF:000003', NULL, NULL, 'Protein unc-13 homolog C', NULL, NULL, NULL, NULL, NULL, 4),
(42566, NULL, 'G3DSA:3.30.200.20:FF:001049', NULL, NULL, 'Elongation factor 2 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(42567, NULL, 'G3DSA:4.10.40.20:FF:000001', NULL, NULL, 'Insulin-like growth factor binding protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(42568, NULL, 'G3DSA:1.20.5.390:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42569, NULL, 'G3DSA:4.10.400.10:FF:000191', NULL, NULL, 'Blast:Prolow-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(42570, NULL, 'G3DSA:1.10.287.770:FF:000008', NULL, NULL, 'pickpocket protein 28', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(42571, NULL, 'G3DSA:1.20.120.1240:FF:000059', NULL, NULL, 'Dynamin-related GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(42572, NULL, 'G3DSA:2.40.50.90:FF:000138', NULL, NULL, 'LD30829p', NULL, NULL, NULL, NULL, NULL, 4),
(42573, NULL, 'G3DSA:3.40.1110.10:FF:000160', NULL, NULL, 'Cation transport ATPase, E1-E2 family', NULL, NULL, NULL, NULL, NULL, 4),
(42574, NULL, 'G3DSA:3.10.20.90:FF:000045', NULL, NULL, 'TFG isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(42575, NULL, 'G3DSA:1.10.1200.270:FF:000004', NULL, NULL, 'Salicylate/benzoate carboxyl methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(42576, NULL, 'G3DSA:1.20.5.110:FF:000309', NULL, NULL, 'Condensin complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(42577, NULL, 'G3DSA:1.20.1250.20:FF:001151', NULL, NULL, 'Drug resistance transporter EmrB/QacA subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(42578, NULL, 'G3DSA:3.20.20.190:FF:000163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42579, NULL, 'G3DSA:1.25.40.10:FF:001657', NULL, NULL, 'EMB2750', NULL, NULL, NULL, NULL, NULL, 4),
(42580, NULL, 'G3DSA:1.10.1200.10:FF:000091', NULL, NULL, 'Nonribosomal peptide synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(42581, NULL, 'G3DSA:3.40.50.300:FF:003289', NULL, NULL, 'Small GTP-binding rab protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(42582, NULL, 'G3DSA:2.60.40.10:FF:003816', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42583, NULL, 'G3DSA:1.10.220.160:FF:000011', NULL, NULL, 'protein msta', NULL, NULL, NULL, NULL, NULL, 4),
(42584, NULL, 'G3DSA:2.60.40.10:FF:005380', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42585, NULL, 'G3DSA:1.20.5.170:FF:000294', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(42586, NULL, 'G3DSA:2.60.40.10:FF:004311', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42587, NULL, 'G3DSA:1.20.58.1210:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42588, NULL, 'G3DSA:3.50.30.20:FF:000006', NULL, NULL, 'Putative carbamoyl-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(42589, NULL, 'G3DSA:3.40.50.2300:FF:001471', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42590, NULL, 'G3DSA:1.10.8.10:FF:000160', NULL, NULL, 'UBA/TS-N domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(42591, NULL, 'G3DSA:3.50.30.30:FF:000009', NULL, NULL, 'Carboxypeptidase Q', NULL, NULL, NULL, NULL, NULL, 4),
(42592, NULL, 'G3DSA:1.10.565.10:FF:000067', NULL, NULL, 'Putative retinoic acid receptor alpha', NULL, NULL, NULL, NULL, NULL, 4),
(42593, NULL, 'G3DSA:2.30.30.790:FF:000009', NULL, NULL, '50S ribosomal protein L19', NULL, NULL, NULL, NULL, NULL, 4),
(42594, NULL, 'G3DSA:3.30.70.1130:FF:000004', NULL, NULL, 'Translation initiation factor 2 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(42595, NULL, 'G3DSA:3.40.50.1820:FF:000938', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42596, NULL, 'G3DSA:2.70.98.20:FF:000012', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(42597, NULL, 'G3DSA:1.20.58.340:FF:000024', NULL, NULL, 'Magnesium transporter MRS2-5', NULL, NULL, NULL, NULL, NULL, 4),
(42598, NULL, 'G3DSA:3.40.50.720:FF:000874', NULL, NULL, 'Oxidoreductase, short-chain dehydrogenase/reductase family', NULL, NULL, NULL, NULL, NULL, 4),
(42599, NULL, 'G3DSA:3.40.1160.10:FF:000090', NULL, NULL, 'Aspartokinase 1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(42600, NULL, 'G3DSA:3.40.910.10:FF:000007', NULL, NULL, 'Probable deoxyhypusine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(42601, NULL, 'G3DSA:3.40.50.300:FF:005195', NULL, NULL, 'Molybdopterin guanine dinucleotide synthesis protein B', NULL, NULL, NULL, NULL, NULL, 4),
(42602, NULL, 'G3DSA:2.60.40.10:FF:003468', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42603, NULL, 'G3DSA:1.20.5.110:FF:000186', NULL, NULL, 'WGS project CABT00000000 data, contig 2.13', NULL, NULL, NULL, NULL, NULL, 4),
(42604, NULL, 'G3DSA:3.30.1490.310:FF:000001', NULL, NULL, 'Serine/threonine-protein kinase BRI1-like 1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(42605, NULL, 'G3DSA:1.10.357.120:FF:000015', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(42606, NULL, 'G3DSA:3.30.1960.10:FF:000006', NULL, NULL, 'tRNA-yW synthesizing protein 3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(42607, NULL, 'G3DSA:3.90.280.10:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42608, NULL, 'G3DSA:3.60.20.10:FF:000087', NULL, NULL, 'Asparagine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(42609, NULL, 'G3DSA:3.30.505.10:FF:000001', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(42610, NULL, 'G3DSA:2.70.98.30:FF:000015', NULL, NULL, 'Glycoside hydrolase family 81 protein', NULL, NULL, NULL, NULL, NULL, 4),
(42611, NULL, 'G3DSA:1.10.287.2210:FF:000003', NULL, NULL, 'YALI0D22520p', NULL, NULL, NULL, NULL, NULL, 4),
(42612, NULL, 'G3DSA:1.10.132.30:FF:000006', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(42613, NULL, 'G3DSA:2.60.120.10:FF:000222', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(42614, NULL, 'G3DSA:2.10.90.10:FF:000062', NULL, NULL, 'GK21666', NULL, NULL, NULL, NULL, NULL, 4),
(42615, NULL, 'G3DSA:2.40.440.10:FF:000020', NULL, NULL, 'Murein L,D-transpeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(42616, NULL, 'G3DSA:1.25.40.10:FF:003911', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42617, NULL, 'G3DSA:3.30.70.270:FF:000296', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42618, NULL, 'G3DSA:2.60.40.10:FF:000040', NULL, NULL, 'Nuclear factor of activated T-cells, cytoplasmic, calcineurin-dependent 2', NULL, NULL, NULL, NULL, NULL, 4),
(42619, NULL, 'G3DSA:2.130.10.10:FF:005470', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42620, NULL, 'G3DSA:3.30.365.10:FF:000012', NULL, NULL, 'Selenate reductase, molybdenum-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(42621, NULL, 'G3DSA:3.40.50.800:FF:000016', NULL, NULL, 'Proline--tRNA ligase, chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(42622, NULL, 'G3DSA:3.40.50.1220:FF:000074', NULL, NULL, 'Electron transfer flavoprotein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(42623, NULL, 'G3DSA:1.10.287.70:FF:000186', NULL, NULL, 'Cation channel sperm-associated protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(42624, NULL, 'G3DSA:2.30.29.30:FF:000835', NULL, NULL, 'FI17948p1', NULL, NULL, NULL, NULL, NULL, 4),
(42625, NULL, 'G3DSA:3.40.1190.20:FF:000156', NULL, NULL, 'PfkB family kinase', NULL, NULL, NULL, NULL, NULL, 4),
(42626, NULL, 'G3DSA:1.10.287.2900:FF:000002', NULL, NULL, 'Mitochondrial intermembrane space import and assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(42627, NULL, 'G3DSA:2.30.39.10:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42628, NULL, 'G3DSA:1.10.132.20:FF:000003', NULL, NULL, 'ribosome-recycling factor, mitochondrial isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(42629, NULL, 'G3DSA:3.40.50.2300:FF:000982', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42630, NULL, 'G3DSA:3.30.160.60:FF:001670', NULL, NULL, 'Zinc finger protein 524', NULL, NULL, NULL, NULL, NULL, 4),
(42631, NULL, 'G3DSA:1.10.8.60:FF:000152', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(42632, NULL, 'G3DSA:3.30.1490.180:FF:000029', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(42633, NULL, 'G3DSA:2.60.120.430:FF:000041', NULL, NULL, 'Endoglucanase', NULL, NULL, NULL, NULL, NULL, 4),
(42634, NULL, 'G3DSA:1.20.190.60:FF:000001', NULL, NULL, 'SMG-7', NULL, NULL, NULL, NULL, NULL, 4),
(42635, NULL, 'G3DSA:2.60.40.60:FF:000026', NULL, NULL, 'FAT atypical cadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(42636, NULL, 'G3DSA:2.40.10.10:FF:000033', NULL, NULL, 'Replicase polyprotein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(42637, NULL, 'G3DSA:2.10.25.10:FF:000338', NULL, NULL, 'hepatocyte growth factor activator', NULL, NULL, NULL, NULL, NULL, 4),
(42638, NULL, 'G3DSA:1.10.472.80:FF:000029', NULL, NULL, 'Growth hormone-regulated TBC protein 1', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(42639, NULL, 'G3DSA:3.40.50.620:FF:000288', NULL, NULL, 'Glutamate--tRNA ligase 1', NULL, NULL, NULL, NULL, NULL, 4),
(42640, NULL, 'G3DSA:3.30.160.60:FF:002501', NULL, NULL, 'Zinc finger protein 526', NULL, NULL, NULL, NULL, NULL, 4),
(42641, NULL, 'G3DSA:1.10.510.10:FF:001453', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(42642, NULL, 'G3DSA:1.20.1280.50:FF:000240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42643, NULL, 'G3DSA:2.20.100.10:FF:000084', NULL, NULL, 'WNT1-inducible-signaling pathway protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(42644, NULL, 'G3DSA:3.80.10.10:FF:002564', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42645, NULL, 'G3DSA:3.40.1800.20:FF:000007', NULL, NULL, 'Hangover, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(42646, NULL, 'G3DSA:3.40.50.2000:FF:000549', NULL, NULL, 'Sucrose synthase 3', NULL, NULL, NULL, NULL, NULL, 4),
(42647, NULL, 'G3DSA:3.40.50.1010:FF:000230', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42648, NULL, 'G3DSA:3.40.50.720:FF:000329', NULL, NULL, 'Corticosteroid 11-beta-dehydrogenase isozyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(42649, NULL, 'G3DSA:2.60.40.1180:FF:000102', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(42650, NULL, 'G3DSA:3.30.160.60:FF:003687', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42651, NULL, 'G3DSA:1.20.120.350:FF:000234', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42652, NULL, 'G3DSA:2.60.120.320:FF:000007', NULL, NULL, 'Thiamine pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(42653, NULL, 'G3DSA:3.40.190.10:FF:000963', NULL, NULL, 'ABC transporter, periplasmic substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(42654, NULL, 'G3DSA:3.30.460.10:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42655, NULL, 'G3DSA:1.10.150.20:FF:000287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42656, NULL, 'G3DSA:3.40.50.360:FF:000064', NULL, NULL, 'Flavin reductase', NULL, NULL, NULL, NULL, NULL, 4),
(42657, NULL, 'G3DSA:3.30.160.60:FF:006211', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42658, NULL, 'G3DSA:3.40.1380.20:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42659, NULL, 'G3DSA:3.10.20.30:FF:000050', NULL, NULL, 'Threonine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(42660, NULL, 'G3DSA:2.130.10.10:FF:005705', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(42661, NULL, 'G3DSA:2.40.50.140:FF:001058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42662, NULL, 'G3DSA:1.25.10.10:FF:001723', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42663, NULL, 'G3DSA:1.25.40.10:FF:001219', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(42664, NULL, 'G3DSA:3.30.300.10:FF:000031', NULL, NULL, 'S-adenosylmethionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(42665, NULL, 'G3DSA:3.90.190.10:FF:000480', NULL, NULL, 'Dual-specificity protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(42666, NULL, 'G3DSA:1.10.287.130:FF:000159', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(42667, NULL, 'G3DSA:1.10.565.10:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42668, NULL, 'G3DSA:3.40.50.10130:FF:000025', NULL, NULL, 'GD10756', NULL, NULL, NULL, NULL, NULL, 4),
(42669, NULL, 'G3DSA:3.40.50.150:FF:001861', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42670, NULL, 'G3DSA:1.10.8.530:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42671, NULL, 'G3DSA:3.40.50.10420:FF:000011', NULL, NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(42672, NULL, 'G3DSA:3.40.50.720:FF:000767', NULL, NULL, 'YMR090W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(42673, NULL, 'G3DSA:2.60.120.10:FF:000115', NULL, NULL, 'Cyclic nucleotide-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(42674, NULL, 'G3DSA:3.30.300.20:FF:000034', NULL, NULL, 'GTPase Era', NULL, NULL, NULL, NULL, NULL, 4),
(42675, NULL, 'G3DSA:3.40.250.10:FF:000097', NULL, NULL, 'Putative thiosulfate sulfurtransferase mpst-1', NULL, NULL, NULL, NULL, NULL, 4),
(42676, NULL, 'G3DSA:3.20.20.80:FF:000188', NULL, NULL, 'Beta-N-acetylhexosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(42677, NULL, 'G3DSA:3.40.50.2300:FF:001252', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42678, NULL, 'G3DSA:3.30.40.10:FF:001180', NULL, NULL, 'GG22947', NULL, NULL, NULL, NULL, NULL, 4),
(42679, NULL, 'G3DSA:1.20.1560.10:FF:000076', NULL, NULL, 'Peptidase domain-containing ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(42680, NULL, 'G3DSA:3.30.40.100:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42681, NULL, 'G3DSA:2.130.10.10:FF:003558', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(42682, NULL, 'G3DSA:2.60.40.10:FF:001782', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(42683, NULL, 'G3DSA:3.90.1150.190:FF:000001', NULL, NULL, 'Polycomb protein scmh1 isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(42684, NULL, 'G3DSA:3.10.290.60:FF:000008', NULL, NULL, 'Putative ubiquitin-activating enzyme e1', NULL, NULL, NULL, NULL, NULL, 4),
(42685, NULL, 'G3DSA:3.30.160.60:FF:004070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42686, NULL, 'G3DSA:1.25.40.10:FF:003349', NULL, NULL, 'Os03g0701400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(42687, NULL, 'G3DSA:2.60.120.290:FF:000072', NULL, NULL, 'Zinc metalloproteinase', NULL, NULL, NULL, NULL, NULL, 4),
(42688, NULL, 'G3DSA:2.60.120.590:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42689, NULL, 'G3DSA:3.30.1740.10:FF:000024', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(42690, NULL, 'G3DSA:1.10.8.60:FF:000371', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42691, NULL, 'G3DSA:3.40.50.1450:FF:000013', NULL, NULL, 'Hydrogenase maturation protease', NULL, NULL, NULL, NULL, NULL, 4),
(42692, NULL, 'G3DSA:3.40.50.2300:FF:001145', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42693, NULL, 'G3DSA:2.20.28.10:FF:000041', NULL, NULL, 'Probable rubredoxin HupI', NULL, NULL, NULL, NULL, NULL, 4),
(42694, NULL, 'G3DSA:3.40.640.10:FF:000020', NULL, NULL, 'sphingosine-1-phosphate lyase 1', NULL, NULL, NULL, NULL, NULL, 4),
(42695, NULL, 'G3DSA:2.40.10.190:FF:000003', NULL, NULL, '60S ribosomal protein L35a', NULL, NULL, NULL, NULL, NULL, 4),
(42696, NULL, 'G3DSA:3.20.20.70:FF:000185', NULL, NULL, 'Thiamine phosphate pyrophosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(42697, NULL, 'G3DSA:3.30.420.10:FF:000085', NULL, NULL, 'IS1239 transposase', NULL, NULL, NULL, NULL, NULL, 4),
(42698, NULL, 'G3DSA:2.60.120.200:FF:000096', NULL, NULL, 'L-type lectin-domain containing receptor kinase V.9', NULL, NULL, NULL, NULL, NULL, 4),
(42699, NULL, 'G3DSA:3.40.250.10:FF:000108', NULL, NULL, 'Thiosulfate sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(42700, NULL, 'G3DSA:3.40.50.1440:FF:000010', NULL, NULL, 'Tubulin gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(42701, NULL, 'G3DSA:3.40.50.150:FF:000332', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase J', NULL, NULL, NULL, NULL, NULL, 4),
(42702, NULL, 'G3DSA:3.40.190.80:FF:000034', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(42703, NULL, 'G3DSA:3.30.200.20:FF:000886', NULL, NULL, 'At3g57720', NULL, NULL, NULL, NULL, NULL, 4),
(42704, NULL, 'G3DSA:3.40.630.30:FF:000525', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42705, NULL, 'G3DSA:1.50.40.10:FF:000413', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42706, NULL, 'G3DSA:2.30.30.140:FF:000051', NULL, NULL, 'Tudor domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(42707, NULL, 'G3DSA:1.10.510.10:FF:001902', NULL, NULL, 'Leucine-rich repeat receptor protein kinase MSP1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(42708, NULL, 'G3DSA:3.40.50.300:FF:007229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42709, NULL, 'G3DSA:3.90.70.10:FF:000223', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(42710, NULL, 'G3DSA:3.20.20.330:FF:000019', NULL, NULL, '5-methyltetrahydrofolate S-homocysteine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(42711, NULL, 'G3DSA:1.10.10.2030:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42712, NULL, 'G3DSA:1.10.238.10:FF:001185', NULL, NULL, 'EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(42713, NULL, 'G3DSA:3.10.580.10:FF:000016', NULL, NULL, 'Transcriptional repressor CcpN', NULL, NULL, NULL, NULL, NULL, 4),
(42714, NULL, 'G3DSA:2.170.150.30:FF:000006', NULL, NULL, 'DEXH (Asp-Glu-X-His) box polypeptide 58', NULL, NULL, NULL, NULL, NULL, 4),
(42715, NULL, 'G3DSA:1.10.10.2020:FF:000001', NULL, NULL, 'Host-nuclease inhibitor protein gam', NULL, NULL, NULL, NULL, NULL, 4),
(42716, NULL, 'G3DSA:2.60.120.430:FF:000035', NULL, NULL, 'Endoglucanase H', NULL, NULL, NULL, NULL, NULL, 4),
(42717, NULL, 'G3DSA:3.20.20.100:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42718, NULL, 'G3DSA:3.40.50.1220:FF:000068', NULL, NULL, 'Electron transfer flavoprotein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(42719, NULL, 'G3DSA:1.25.40.10:FF:004985', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(42720, NULL, 'G3DSA:3.30.830.10:FF:000003', NULL, NULL, 'Insulin-degrading enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(42721, NULL, 'G3DSA:1.25.40.20:FF:001554', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42722, NULL, 'G3DSA:3.40.50.300:FF:003957', NULL, NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', NULL, NULL, NULL, NULL, NULL, 4),
(42723, NULL, 'G3DSA:3.80.10.10:FF:004475', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42724, NULL, 'G3DSA:1.25.40.20:FF:000031', NULL, NULL, 'Ankyrin repeat, family A (RFXANK-like), 2', NULL, NULL, NULL, NULL, NULL, 4),
(42725, NULL, 'G3DSA:1.20.1560.10:FF:000749', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(42726, NULL, 'G3DSA:1.20.120.1460:FF:000001', NULL, NULL, 'tRNA-dihydrouridine(20/20a) synthase', NULL, NULL, NULL, NULL, NULL, 4),
(42727, NULL, 'G3DSA:1.10.510.10:FF:003919', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42728, NULL, 'G3DSA:2.130.10.10:FF:005812', NULL, NULL, 'Cleavage stimulation factor, 3'' pre-RNA, subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(42729, NULL, 'G3DSA:3.40.50.1460:FF:000016', NULL, NULL, 'GPI-anchor transamidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(42730, NULL, 'G3DSA:2.130.10.10:FF:001434', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42731, NULL, 'G3DSA:3.40.50.10140:FF:000028', NULL, NULL, 'Protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(42732, NULL, 'G3DSA:1.10.260.100:FF:000013', NULL, NULL, 'NEDD8-activating enzyme E1 catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(42733, NULL, 'G3DSA:1.10.287.130:FF:000272', NULL, NULL, 'BfiS', NULL, NULL, NULL, NULL, NULL, 4),
(42734, NULL, 'G3DSA:1.10.630.10:FF:000433', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42735, NULL, 'G3DSA:3.80.10.10:FF:002345', NULL, NULL, 'Leucine-rich repeat (LRR) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(42736, NULL, 'G3DSA:1.10.630.10:FF:000540', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42737, NULL, 'G3DSA:1.10.287.70:FF:000416', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42738, NULL, 'G3DSA:3.90.190.10:FF:000148', NULL, NULL, 'Dual specificity protein phosphatase PHS1', NULL, NULL, NULL, NULL, NULL, 4),
(42739, NULL, 'G3DSA:3.40.50.200:FF:000044', NULL, NULL, 'Serine protease/ABC transporter B family protein tagC', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(42740, NULL, 'G3DSA:3.40.50.300:FF:001833', NULL, NULL, 'Stage III sporulation protein AA', NULL, NULL, NULL, NULL, NULL, 4),
(42741, NULL, 'G3DSA:3.40.50.1460:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42742, NULL, 'G3DSA:3.40.33.10:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42743, NULL, 'G3DSA:2.10.25.10:FF:000557', NULL, NULL, 'fibulin-5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(42744, NULL, 'G3DSA:3.50.50.60:FF:001060', NULL, NULL, 'Os01g0269100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(42745, NULL, 'G3DSA:3.40.366.10:FF:000057', NULL, NULL, 'Malonyl-CoA:acyl-carrier-protein transacylase', NULL, NULL, NULL, NULL, NULL, 4),
(42746, NULL, 'G3DSA:1.20.1270.60:FF:000074', NULL, NULL, 'Rho GTPase-activating protein 42', NULL, NULL, NULL, NULL, NULL, 4),
(42747, NULL, 'G3DSA:3.40.50.140:FF:000003', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(42748, NULL, 'G3DSA:2.60.40.10:FF:002400', NULL, NULL, 'Stranded at second, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(42749, NULL, 'G3DSA:2.10.60.10:FF:000021', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(42750, NULL, 'G3DSA:3.30.460.10:FF:000194', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(42751, NULL, 'G3DSA:1.10.3380.10:FF:000047', NULL, NULL, 'DEAD/DEAH box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(42752, NULL, 'G3DSA:2.130.10.10:FF:001541', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(42753, NULL, 'G3DSA:1.25.10.10:FF:001616', NULL, NULL, 'Protein phosphatase 2A regulatory subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(42754, NULL, 'G3DSA:3.40.20.10:FF:000037', NULL, NULL, 'macrophage-capping protein-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(42755, NULL, 'G3DSA:3.30.160.570:FF:000001', NULL, NULL, 'SPC24, NDC80 kinetochore complex component', NULL, NULL, NULL, NULL, NULL, 4),
(42756, NULL, 'G3DSA:1.20.1560.10:FF:000862', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42757, NULL, 'G3DSA:2.60.40.10:FF:001669', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(42758, NULL, 'G3DSA:3.40.50.300:FF:001940', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(42759, NULL, 'G3DSA:3.40.50.300:FF:007448', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(42760, NULL, 'G3DSA:2.130.10.10:FF:000124', NULL, NULL, 'WD repeat-containing protein 62 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(42761, NULL, 'G3DSA:2.60.40.10:FF:005834', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42762, NULL, 'G3DSA:3.40.20.10:FF:000149', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(42763, NULL, 'G3DSA:1.10.1740.10:FF:000013', NULL, NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase, apicoplastic', NULL, NULL, NULL, NULL, NULL, 4),
(42764, NULL, 'G3DSA:3.60.20.10:FF:000093', NULL, NULL, 'Proteasome endopeptidase complex', NULL, NULL, NULL, NULL, NULL, 4),
(42765, NULL, 'G3DSA:1.10.8.50:FF:000036', NULL, NULL, 'Nei like DNA glycosylase 3', NULL, NULL, NULL, NULL, NULL, 4),
(42766, NULL, 'G3DSA:3.30.70.330:FF:003085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42767, NULL, 'G3DSA:1.25.40.10:FF:003462', NULL, NULL, 'Os09g0423300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(42768, NULL, 'G3DSA:1.10.238.10:FF:001078', NULL, NULL, 'Putative calcium-binding protein CML41', NULL, NULL, NULL, NULL, NULL, 4),
(42769, NULL, 'G3DSA:2.30.29.30:FF:001004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42770, NULL, 'G3DSA:3.40.50.1000:FF:000120', NULL, NULL, 'Magnesium-dependent phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(42771, NULL, 'G3DSA:3.30.160.20:FF:000157', NULL, NULL, 'Plastid ribosomal protein S5', NULL, NULL, NULL, NULL, NULL, 4),
(42772, NULL, 'G3DSA:3.40.50.20:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42773, NULL, 'G3DSA:1.20.1110.10:FF:000036', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(42774, NULL, 'G3DSA:2.30.29.30:FF:000386', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(42775, NULL, 'G3DSA:2.60.40.10:FF:001563', NULL, NULL, 'Interferon receptor 1 isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(42776, NULL, 'G3DSA:2.10.25.10:FF:000664', NULL, NULL, 'Blast:Protein spitz', NULL, NULL, NULL, NULL, NULL, 4),
(42777, NULL, 'G3DSA:2.130.10.10:FF:003671', NULL, NULL, 'Semaphorin 6B', NULL, NULL, NULL, NULL, NULL, 4),
(42778, NULL, 'G3DSA:3.30.40.10:FF:002377', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(42779, NULL, 'G3DSA:3.10.580.10:FF:000123', NULL, NULL, 'Metal transporter cnnm-2', NULL, NULL, NULL, NULL, NULL, 4),
(42780, NULL, 'G3DSA:1.10.8.60:FF:000039', NULL, NULL, 'peroxisome biogenesis factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(42781, NULL, 'G3DSA:3.40.50.300:FF:000523', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(42782, NULL, 'G3DSA:1.10.8.60:FF:000590', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42783, NULL, 'G3DSA:3.80.10.10:FF:000984', NULL, NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(42784, NULL, 'G3DSA:3.40.50.300:FF:003177', NULL, NULL, 'Replication factor C small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(42785, NULL, 'G3DSA:3.40.50.300:FF:005088', NULL, NULL, 'Bsl1937 protein', NULL, NULL, NULL, NULL, NULL, 4),
(42786, NULL, 'G3DSA:3.30.70.260:FF:000068', NULL, NULL, 'Glycine cleavage system transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(42787, NULL, 'G3DSA:3.30.160.20:FF:000045', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(42788, NULL, 'G3DSA:3.90.190.10:FF:000261', NULL, NULL, 'MAP kinase phosphatase-1', NULL, NULL, NULL, NULL, NULL, 4),
(42789, NULL, 'G3DSA:1.10.510.10:FF:001559', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(42790, NULL, 'G3DSA:3.90.199.10:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42791, NULL, 'G3DSA:3.30.70.2630:FF:000010', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(42792, NULL, 'G3DSA:3.30.505.10:FF:000113', NULL, NULL, 'Holliday-junction_resolvase-like_of_SPT6 /SH2_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(42793, NULL, 'G3DSA:1.20.5.170:FF:000288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42794, NULL, 'G3DSA:2.60.40.10:FF:003923', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42795, NULL, 'G3DSA:1.25.40.10:FF:001551', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(42796, NULL, 'G3DSA:3.30.160.60:FF:005267', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42797, NULL, 'G3DSA:2.40.50.140:FF:001165', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42798, NULL, 'G3DSA:2.30.30.140:FF:000270', NULL, NULL, 'Chromatin binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(42799, NULL, 'G3DSA:3.30.70.330:FF:002478', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42800, NULL, 'G3DSA:2.130.10.10:FF:003890', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42801, NULL, 'G3DSA:3.10.490.20:FF:000012', NULL, NULL, 'Putative dynein beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(42802, NULL, 'G3DSA:1.25.10.10:FF:000998', NULL, NULL, 'GM16513', NULL, NULL, NULL, NULL, NULL, 4),
(42803, NULL, 'G3DSA:1.10.8.60:FF:000258', NULL, NULL, 'Spermatogenesis-associated protein 5-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(42804, NULL, 'G3DSA:3.20.20.140:FF:000406', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42805, NULL, 'G3DSA:3.100.10.10:FF:000066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42806, NULL, 'G3DSA:3.40.50.300:FF:000304', NULL, NULL, 'Iron-sulfur cluster carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(42807, NULL, 'G3DSA:3.30.70.1230:FF:000141', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(42808, NULL, 'G3DSA:1.25.40.10:FF:002967', NULL, NULL, 'RNA polymerase-associated protein CTR9', NULL, NULL, NULL, NULL, NULL, 4),
(42809, NULL, 'G3DSA:3.30.160.60:FF:005486', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42810, NULL, 'G3DSA:2.170.190.11:FF:000010', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(42811, NULL, 'G3DSA:2.30.29.30:FF:000167', NULL, NULL, 'Pleckstrin homology domain-containing family F member 2', NULL, NULL, NULL, NULL, NULL, 4),
(42812, NULL, 'G3DSA:3.30.930.10:FF:000062', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(42813, NULL, 'G3DSA:3.30.160.60:FF:006104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42814, NULL, 'G3DSA:1.10.287.70:FF:000635', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42815, NULL, 'G3DSA:1.10.510.10:FF:001891', NULL, NULL, 'Dual specificity mitogen-activated protein kinase kinase mek-1', NULL, NULL, NULL, NULL, NULL, 4),
(42816, NULL, 'G3DSA:1.20.1270.10:FF:000087', NULL, NULL, 'hypoxia up-regulated protein 1-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(42817, NULL, 'G3DSA:1.20.5.170:FF:000069', NULL, NULL, 'cGMP-gated cation channel alpha-1', NULL, NULL, NULL, NULL, NULL, 4),
(42818, NULL, 'G3DSA:2.130.10.10:FF:005924', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42819, NULL, 'G3DSA:3.30.450.50:FF:000019', NULL, NULL, 'arf-GAP domain and FG repeat-containing protein 1 isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(42820, NULL, 'G3DSA:3.40.50.150:FF:000225', NULL, NULL, 'tRNA (guanine(37)-N1)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(42821, NULL, 'G3DSA:3.30.420.40:FF:000301', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(42822, NULL, 'G3DSA:1.10.630.10:FF:000652', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42823, NULL, 'G3DSA:1.10.260.40:FF:000048', NULL, NULL, 'DNA-binding helix-turn-helix protein', NULL, NULL, NULL, NULL, NULL, 4),
(42824, NULL, 'G3DSA:3.30.230.10:FF:000379', NULL, NULL, '30S ribosomal protein S9', NULL, NULL, NULL, NULL, NULL, 4),
(42825, NULL, 'G3DSA:1.10.472.80:FF:000136', NULL, NULL, 'TBC1 domain family member', NULL, NULL, NULL, NULL, NULL, 4),
(42826, NULL, 'G3DSA:3.40.1170.10:FF:000039', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(42827, NULL, 'G3DSA:3.20.10.10:FF:000037', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(42828, NULL, 'G3DSA:3.40.50.1010:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42829, NULL, 'G3DSA:3.10.450.240:FF:000012', NULL, NULL, 'TIMM44 isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(42830, NULL, 'G3DSA:2.130.10.10:FF:003339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42831, NULL, 'G3DSA:3.40.1110.10:FF:000047', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(42832, NULL, 'G3DSA:1.10.10.1050:FF:000013', NULL, NULL, 'Hydrolase, NUDIX family protein', NULL, NULL, NULL, NULL, NULL, 4),
(42833, NULL, 'G3DSA:1.10.225.10:FF:000031', NULL, NULL, 'Granulysin', NULL, NULL, NULL, NULL, NULL, 4),
(42834, NULL, 'G3DSA:3.40.50.150:FF:001642', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42835, NULL, 'G3DSA:1.10.10.10:FF:001649', NULL, NULL, 'Transcriptional regulator, MarR family', NULL, NULL, NULL, NULL, NULL, 4),
(42836, NULL, 'G3DSA:3.30.200.20:FF:001504', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(42837, NULL, 'G3DSA:4.10.1000.10:FF:000135', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(42838, NULL, 'G3DSA:1.10.10.41:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42839, NULL, 'G3DSA:2.130.10.10:FF:001653', NULL, NULL, 'WD domain, G-beta repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(42840, NULL, 'G3DSA:3.50.50.60:FF:000907', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(42841, NULL, 'G3DSA:4.10.280.110:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(42842, NULL, 'G3DSA:3.40.1170.60:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42843, NULL, 'G3DSA:1.20.58.630:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42844, NULL, 'G3DSA:1.25.40.420:FF:000039', NULL, NULL, 'BTB/POZ domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(42845, NULL, 'G3DSA:1.10.630.10:FF:000197', NULL, NULL, 'Cytochrome P450 pisatin demethylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(42846, NULL, 'G3DSA:1.20.940.10:FF:000027', NULL, NULL, 'Splicing factor Prp18 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(42847, NULL, 'G3DSA:1.20.1070.10:FF:000993', NULL, NULL, '5-hydroxytryptamine (serotonin) receptor 5A, genome duplicate a', NULL, NULL, NULL, NULL, NULL, 4),
(42848, NULL, 'G3DSA:3.10.10.20:FF:000001', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(42849, NULL, 'G3DSA:3.90.1030.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42850, NULL, 'G3DSA:3.30.160.60:FF:003917', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42851, NULL, 'G3DSA:1.10.630.10:FF:000539', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42852, NULL, 'G3DSA:3.90.70.10:FF:000004', NULL, NULL, 'Putative ubiquitin carboxyl-terminal hydrolase 25', NULL, NULL, NULL, NULL, NULL, 4),
(42853, NULL, 'G3DSA:2.130.10.10:FF:001198', NULL, NULL, 'DNA damage-binding protein CMR1', NULL, NULL, NULL, NULL, NULL, 4),
(42854, NULL, 'G3DSA:3.20.20.380:FF:000006', NULL, NULL, 'CutC family protein', NULL, NULL, NULL, NULL, NULL, 4),
(42855, NULL, 'G3DSA:3.30.890.10:FF:000001', NULL, NULL, 'methyl-CpG-binding domain protein 1 isoform X7', NULL, NULL, NULL, NULL, NULL, 4),
(42856, NULL, 'G3DSA:3.80.10.10:FF:001041', NULL, NULL, 'Preferentially-expressed antigen in melanoma-like', NULL, NULL, NULL, NULL, NULL, 4),
(42857, NULL, 'G3DSA:2.10.220.10:FF:000061', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 6 isoform PACE4-AI preproprotein', NULL, NULL, NULL, NULL, NULL, 4),
(42858, NULL, 'G3DSA:3.40.50.300:FF:002215', NULL, NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(42859, NULL, 'G3DSA:3.40.50.620:FF:000737', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42860, NULL, 'G3DSA:3.30.572.10:FF:000021', NULL, NULL, 'Thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(42861, NULL, 'G3DSA:3.50.50.60:FF:000896', NULL, NULL, 'Flavin-containing amine oxidasedehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(42862, NULL, 'G3DSA:3.40.50.300:FF:001597', NULL, NULL, 'Origin recognition complex subunit Orc4', NULL, NULL, NULL, NULL, NULL, 4),
(42863, NULL, 'G3DSA:3.90.180.10:FF:000086', NULL, NULL, 'NADP-dependent alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(42864, NULL, 'G3DSA:1.10.510.10:FF:000143', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 7', NULL, NULL, NULL, NULL, NULL, 4),
(42865, NULL, 'G3DSA:3.40.50.300:FF:003738', NULL, NULL, 'ATPase family AAA domain-containing 5b', NULL, NULL, NULL, NULL, NULL, 4),
(42866, NULL, 'G3DSA:2.60.120.290:FF:000178', NULL, NULL, 'Zgc:154142', NULL, NULL, NULL, NULL, NULL, 4),
(42867, NULL, 'G3DSA:2.60.120.380:FF:000093', NULL, NULL, 'Putative calpain-like cysteine protease A', NULL, NULL, NULL, NULL, NULL, 4),
(42868, NULL, 'G3DSA:3.30.40.10:FF:000685', NULL, NULL, 'E3 ubiquitin-protein ligase RNF114', NULL, NULL, NULL, NULL, NULL, 4),
(42869, NULL, 'G3DSA:1.25.10.10:FF:001493', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(42870, NULL, 'G3DSA:1.50.40.10:FF:000290', NULL, NULL, 'GM26277', NULL, NULL, NULL, NULL, NULL, 4),
(42871, NULL, 'G3DSA:3.30.450.50:FF:000020', NULL, NULL, 'Synaptobrevin homolog YKT6', NULL, NULL, NULL, NULL, NULL, 4),
(42872, NULL, 'G3DSA:1.20.1280.50:FF:000133', NULL, NULL, 'F-box and WD repeat domain-containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(42873, NULL, 'G3DSA:3.40.50.300:FF:004014', NULL, NULL, 'DEAD-box ATP-dependent RNA helicase 38', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(42874, NULL, 'G3DSA:3.30.160.60:FF:001776', NULL, NULL, 'zinc finger protein 75D isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(42875, NULL, 'G3DSA:1.10.437.10:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(42876, NULL, 'G3DSA:3.90.1290.10:FF:000008', NULL, NULL, 'microtubule-actin cross-linking factor 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(42877, NULL, 'G3DSA:3.80.10.10:FF:000765', NULL, NULL, 'Receptor-like protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(42878, NULL, 'G3DSA:3.40.50.300:FF:001939', NULL, NULL, 'Nucleotide binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(42879, NULL, 'G3DSA:3.40.50.620:FF:000395', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(42880, NULL, 'G3DSA:3.30.450.20:FF:000477', NULL, NULL, 'Probable serine/threonine-protein kinase DDB_G0280133', NULL, NULL, NULL, NULL, NULL, 4),
(42881, NULL, 'G3DSA:3.40.50.12650:FF:000011', NULL, NULL, 'Unplaced genomic scaffold supercont1.142, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(42882, NULL, 'G3DSA:1.10.287.2620:FF:000025', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(42883, NULL, 'G3DSA:3.30.70.100:FF:000161', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42884, NULL, 'G3DSA:2.40.10.120:FF:000010', NULL, NULL, 'NS3 protease', NULL, NULL, NULL, NULL, NULL, 4),
(42885, NULL, 'G3DSA:3.40.710.10:FF:000026', NULL, NULL, 'Penicillin-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(42886, NULL, 'G3DSA:1.50.10.10:FF:000024', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(42887, NULL, 'G3DSA:1.25.40.20:FF:000250', NULL, NULL, 'Serine/threonine-protein phosphatase 6 regulatory ankyrin repeat subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(42888, NULL, 'G3DSA:1.10.860.10:FF:000023', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(42889, NULL, 'G3DSA:1.25.40.570:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42890, NULL, 'G3DSA:3.40.950.10:FF:000010', NULL, NULL, 'Nar1p', NULL, NULL, NULL, NULL, NULL, 4),
(42891, NULL, 'G3DSA:3.40.50.12660:FF:000014', NULL, NULL, 'Metacaspase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(42892, NULL, 'G3DSA:1.25.40.180:FF:000265', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42893, NULL, 'G3DSA:2.40.50.110:FF:000004', NULL, NULL, 'Toxic shock syndrome toxin-1', NULL, NULL, NULL, NULL, NULL, 4),
(42894, NULL, 'G3DSA:3.40.50.1820:FF:000607', NULL, NULL, 'Lipase, member Ia', NULL, NULL, NULL, NULL, NULL, 4),
(42895, NULL, 'G3DSA:3.30.160.60:FF:002052', NULL, NULL, 'Krueppel factor 7', NULL, NULL, NULL, NULL, NULL, 4),
(42896, NULL, 'G3DSA:2.60.200.30:FF:000037', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(42897, NULL, 'G3DSA:2.60.40.10:FF:005273', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42898, NULL, 'G3DSA:1.25.40.10:FF:004766', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(42899, NULL, 'G3DSA:1.10.10.10:FF:001088', NULL, NULL, 'DEP domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(42900, NULL, 'G3DSA:3.30.9.10:FF:000157', NULL, NULL, 'Putative bifunctional amine oxidase DDB_G0291301', NULL, NULL, NULL, NULL, NULL, 4),
(42901, NULL, 'G3DSA:1.20.1250.20:FF:000544', NULL, NULL, 'Alpha-ketoglutarate permease', NULL, NULL, NULL, NULL, NULL, 4),
(42902, NULL, 'G3DSA:1.20.5.650:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42903, NULL, 'G3DSA:3.30.70.270:FF:000184', NULL, NULL, 'Diguanylate cyclase/phosphodiesterase (GGDEF & EAL domains) with PAS/PAC sensor(S)', NULL, NULL, NULL, NULL, NULL, 4),
(42904, NULL, 'G3DSA:3.30.420.10:FF:000646', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42905, NULL, 'G3DSA:1.25.40.20:FF:000137', NULL, NULL, 'Ankyrin repeat domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(42906, NULL, 'G3DSA:2.30.29.30:FF:000947', NULL, NULL, 'rho GTPase-activating protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(42907, NULL, 'G3DSA:1.20.1720.10:FF:000066', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(42908, NULL, 'G3DSA:1.10.3520.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42909, NULL, 'G3DSA:1.25.40.70:FF:000017', NULL, NULL, 'Phosphatidylinositol-4-phosphate 3-kinase catalytic subunit type 2 beta', NULL, NULL, NULL, NULL, NULL, 4),
(42910, NULL, 'G3DSA:1.25.10.10:FF:003292', NULL, NULL, 'ATR serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(42911, NULL, 'G3DSA:1.20.120.1080:FF:000090', NULL, NULL, 'DEAH-box helicase 40', NULL, NULL, NULL, NULL, NULL, 4),
(42912, NULL, 'G3DSA:2.60.120.10:FF:000334', NULL, NULL, 'Protein Kinase, cGMP-dependent', NULL, NULL, NULL, NULL, NULL, 4),
(42913, NULL, 'G3DSA:2.130.10.10:FF:005582', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42914, NULL, 'G3DSA:2.60.40.10:FF:004997', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42915, NULL, 'G3DSA:1.10.510.10:FF:003813', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42916, NULL, 'G3DSA:1.25.40.60:FF:000014', NULL, NULL, 'SEC1 family transport protein SLY1', NULL, NULL, NULL, NULL, NULL, 4),
(42917, NULL, 'G3DSA:1.10.238.10:FF:000223', NULL, NULL, 'Related to alpha-actinin', NULL, NULL, NULL, NULL, NULL, 4),
(42918, NULL, 'G3DSA:2.60.60.20:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42919, NULL, 'G3DSA:2.30.140.10:FF:000027', NULL, NULL, 'Spermidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(42920, NULL, 'G3DSA:3.40.970.10:FF:000005', NULL, NULL, 'RNase H domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(42921, NULL, 'G3DSA:3.30.70.260:FF:000181', NULL, NULL, 'Arogenate dehydratase/prephenate dehydratase 2 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(42922, NULL, 'G3DSA:4.10.830.40:FF:000007', NULL, NULL, 'E3 ubiquitin/ISG15 ligase TRIM25', NULL, NULL, NULL, NULL, NULL, 4),
(42923, NULL, 'G3DSA:3.40.50.450:FF:000102', NULL, NULL, 'Phosphofructokinase, platelet a', NULL, NULL, NULL, NULL, NULL, 4),
(42924, NULL, 'G3DSA:2.40.420.20:FF:000022', NULL, NULL, 'Resistance-Nodulation-Cell Division (RND) efflux membrane fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(42925, NULL, 'G3DSA:1.20.1560.10:FF:000188', NULL, NULL, 'ABC multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(42926, NULL, 'G3DSA:1.10.510.10:FF:003471', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42927, NULL, 'G3DSA:3.30.420.10:FF:000208', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(42928, NULL, 'G3DSA:3.30.70.1570:FF:000001', NULL, NULL, 'Isocitrate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(42929, NULL, 'G3DSA:2.40.30.20:FF:000037', NULL, NULL, 'ATP synthase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(42930, NULL, 'G3DSA:3.40.50.300:FF:007780', NULL, NULL, 'Dephospho-CoA kinase', NULL, NULL, NULL, NULL, NULL, 4),
(42931, NULL, 'G3DSA:2.40.70.10:FF:000031', NULL, NULL, 'Aspartyl protease AED1', NULL, NULL, NULL, NULL, NULL, 4),
(42932, NULL, 'G3DSA:3.30.470.20:FF:000147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42933, NULL, 'G3DSA:2.60.40.2240:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42934, NULL, 'G3DSA:3.40.20.10:FF:000150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42935, NULL, 'G3DSA:3.40.50.800:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42936, NULL, 'G3DSA:3.20.20.70:FF:000308', NULL, NULL, 'Protein CBG12371', NULL, NULL, NULL, NULL, NULL, 4),
(42937, NULL, 'G3DSA:2.130.10.10:FF:001872', NULL, NULL, 'WD repeat-containing protein 90', NULL, NULL, NULL, NULL, NULL, 4),
(42938, NULL, 'G3DSA:3.30.1780.10:FF:000021', NULL, NULL, 'Ornithine cyclodeaminase', NULL, NULL, NULL, NULL, NULL, 4),
(42939, NULL, 'G3DSA:3.60.10.10:FF:000154', NULL, NULL, 'DNA-(apurinic or apyrimidinic site) lyase', NULL, NULL, NULL, NULL, NULL, 4),
(42940, NULL, 'G3DSA:3.30.160.60:FF:003575', NULL, NULL, 'IKAROS family zinc finger 4', NULL, NULL, NULL, NULL, NULL, 4),
(42941, NULL, 'G3DSA:1.20.120.350:FF:000122', NULL, NULL, 'Ion transport protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(42942, NULL, 'G3DSA:2.30.29.30:FF:001223', NULL, NULL, 'AGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(42943, NULL, 'G3DSA:2.40.50.990:FF:000003', NULL, NULL, 'Elongation factor 3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(42944, NULL, 'G3DSA:3.30.930.10:FF:000281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42945, NULL, 'G3DSA:3.30.559.10:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42946, NULL, 'G3DSA:1.10.10.160:FF:000033', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(42947, NULL, 'G3DSA:2.60.120.10:FF:000553', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42948, NULL, 'G3DSA:2.60.40.650:FF:000002', NULL, NULL, 'sulfite oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(42949, NULL, 'G3DSA:1.20.140.10:FF:000062', NULL, NULL, 'Acyl-CoA oxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(42950, NULL, 'G3DSA:3.90.530.10:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42951, NULL, 'G3DSA:1.20.5.110:FF:000203', NULL, NULL, 'Synaptobrevin (V-SNARE), putative', NULL, NULL, NULL, NULL, NULL, 4),
(42952, NULL, 'G3DSA:2.30.39.10:FF:000111', NULL, NULL, 'Serpin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(42953, NULL, 'G3DSA:1.25.10.10:FF:003415', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42954, NULL, 'G3DSA:2.30.40.10:FF:000069', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(42955, NULL, 'G3DSA:3.30.60.270:FF:000018', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(42956, NULL, 'G3DSA:2.60.40.10:FF:003704', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42957, NULL, 'G3DSA:1.20.1740.10:FF:000174', NULL, NULL, 'Bumetanide-sensitive sodium-(Potassium)-chloride cotransporter-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(42958, NULL, 'G3DSA:3.40.630.30:FF:000306', NULL, NULL, 'Acetyltransferase, GNAT family protein', NULL, NULL, NULL, NULL, NULL, 4),
(42959, NULL, 'G3DSA:1.20.120.790:FF:000012', NULL, NULL, 'Cation-transporting ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(42960, NULL, 'G3DSA:1.20.58.390:FF:000011', NULL, NULL, 'neuronal acetylcholine receptor subunit alpha-7', NULL, NULL, NULL, NULL, NULL, 4),
(42961, NULL, 'G3DSA:2.60.40.10:FF:005492', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42962, NULL, 'G3DSA:3.40.930.10:FF:000008', NULL, NULL, 'Anion exchange protein', NULL, NULL, NULL, NULL, NULL, 4),
(42963, NULL, 'G3DSA:2.40.50.140:FF:000783', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42964, NULL, 'G3DSA:1.10.30.10:FF:000015', NULL, NULL, 'high mobility group protein B1', NULL, NULL, NULL, NULL, NULL, 4),
(42965, NULL, 'G3DSA:3.60.130.10:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42966, NULL, 'G3DSA:3.40.50.1820:FF:000484', NULL, NULL, 'Dipeptidyl peptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(42967, NULL, 'G3DSA:4.10.960.10:FF:000002', NULL, NULL, '60S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(42968, NULL, 'G3DSA:2.30.180.10:FF:000024', NULL, NULL, 'fasciclin-like arabinogalactan protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(42969, NULL, 'G3DSA:2.30.30.490:FF:000026', NULL, NULL, 'Polybromo-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(42970, NULL, 'G3DSA:2.60.120.330:FF:000230', NULL, NULL, 'Probable flavonol synthase 6', NULL, NULL, NULL, NULL, NULL, 4),
(42971, NULL, 'G3DSA:2.40.240.10:FF:000033', NULL, NULL, 'Glutamate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(42972, NULL, 'G3DSA:3.90.190.10:FF:000367', NULL, NULL, 'receptor-type tyrosine-protein phosphatase alpha-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(42973, NULL, 'G3DSA:1.25.10.10:FF:003073', NULL, NULL, 'tRNA exportin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(42974, NULL, 'G3DSA:1.20.5.170:FF:000182', NULL, NULL, 'C-type lectin domain family 4 member F', NULL, NULL, NULL, NULL, NULL, 4),
(42975, NULL, 'G3DSA:1.10.510.10:FF:003358', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42976, NULL, 'G3DSA:3.40.50.1820:FF:001102', NULL, NULL, 'Putative serine esterase family protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(42977, NULL, 'G3DSA:3.40.50.720:FF:002347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42978, NULL, 'G3DSA:3.30.60.20:FF:000110', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(42979, NULL, 'G3DSA:1.10.10.10:FF:001762', NULL, NULL, 'Replication protein', NULL, NULL, NULL, NULL, NULL, 4),
(42980, NULL, 'G3DSA:3.30.930.10:FF:000168', NULL, NULL, 'Glycine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(42981, NULL, 'G3DSA:3.40.50.12780:FF:000157', NULL, NULL, 'Natural product biosynthesis luciferase-like monooxygenase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(42982, NULL, 'G3DSA:3.40.50.150:FF:001748', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42983, NULL, 'G3DSA:3.40.50.150:FF:001529', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42984, NULL, 'G3DSA:1.20.1420.10:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(42985, NULL, 'G3DSA:3.30.1520.10:FF:000148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42986, NULL, 'G3DSA:3.40.50.1700:FF:000009', NULL, NULL, 'Periplasmic beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(42987, NULL, 'G3DSA:6.10.140.2220:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42988, NULL, 'G3DSA:1.10.10.10:FF:001543', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(42989, NULL, 'G3DSA:2.40.50.100:FF:000220', NULL, NULL, 'Sugar ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(42990, NULL, 'G3DSA:3.30.70.330:FF:000679', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein A1', NULL, NULL, NULL, NULL, NULL, 4),
(42991, NULL, 'G3DSA:3.30.70.1230:FF:000028', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(42992, NULL, 'G3DSA:3.40.50.1820:FF:000826', NULL, NULL, 'Alpha/Beta hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(42993, NULL, 'G3DSA:4.10.240.10:FF:000105', NULL, NULL, 'Transcription factor PDR1', NULL, NULL, NULL, NULL, NULL, 4),
(42994, NULL, 'G3DSA:3.40.605.10:FF:000006', NULL, NULL, '1-pyrroline-5-carboxylate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(42995, NULL, 'G3DSA:1.20.1600.10:FF:000012', NULL, NULL, 'Outer membrane protein TolC', NULL, NULL, NULL, NULL, NULL, 4),
(42996, NULL, 'G3DSA:3.30.70.330:FF:000898', NULL, NULL, 'GTPase activating protein (SH3 domain) binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(42997, NULL, 'G3DSA:3.50.50.60:FF:001059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42998, NULL, 'G3DSA:3.80.10.10:FF:004256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(42999, NULL, 'G3DSA:2.90.20.10:FF:000003', NULL, NULL, 'cartilage acidic protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(43000, NULL, 'G3DSA:3.30.60.30:FF:000113', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(43001, NULL, 'G3DSA:2.60.120.200:FF:000770', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43002, NULL, 'G3DSA:3.40.50.1010:FF:000229', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43003, NULL, 'G3DSA:1.20.1070.10:FF:000555', NULL, NULL, 'NeuroPeptide Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(43004, NULL, 'G3DSA:3.40.50.620:FF:000518', NULL, NULL, 'Riboflavin biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(43005, NULL, 'G3DSA:3.40.50.300:FF:002092', NULL, NULL, 'Dynein-related AAA-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(43006, NULL, 'G3DSA:3.30.40.10:FF:000808', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(43007, NULL, 'G3DSA:3.40.50.1110:FF:000041', NULL, NULL, 'Lipase/acylhydrolase, GDSL family', NULL, NULL, NULL, NULL, NULL, 4),
(43008, NULL, 'G3DSA:3.60.20.10:FF:000199', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43009, NULL, 'G3DSA:1.20.1070.10:FF:000774', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43010, NULL, 'G3DSA:3.40.30.10:FF:000650', NULL, NULL, 'Putative ovule protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(43011, NULL, 'G3DSA:3.40.50.300:FF:003851', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43012, NULL, 'G3DSA:4.10.400.10:FF:000202', NULL, NULL, 'LDL receptor protein 1, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(43013, NULL, 'G3DSA:3.90.1200.10:FF:000065', NULL, NULL, 'Ethanolamine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(43014, NULL, 'G3DSA:3.40.50.11980:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43015, NULL, 'G3DSA:3.10.450.70:FF:000002', NULL, NULL, 'Thiol:disulfide interchange protein', NULL, NULL, NULL, NULL, NULL, 4),
(43016, NULL, 'G3DSA:3.40.50.620:FF:000850', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(43017, NULL, 'G3DSA:3.40.50.10190:FF:000240', NULL, NULL, 'Tumor suppressor p53-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(43018, NULL, 'G3DSA:2.130.10.10:FF:003452', NULL, NULL, 'Exosome complex exonuclease RRP46-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(43019, NULL, 'G3DSA:2.30.30.30:FF:000001', NULL, NULL, '50S ribosomal protein L2', NULL, NULL, NULL, NULL, NULL, 4),
(43020, NULL, 'G3DSA:3.40.50.80:FF:000189', NULL, NULL, 'Sulfite reductase (Nadph), alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(43021, NULL, 'G3DSA:3.90.640.10:FF:000127', NULL, NULL, 'Actin', NULL, NULL, NULL, NULL, NULL, 4),
(43022, NULL, 'G3DSA:2.70.98.90:FF:000005', NULL, NULL, 'Membrane protein insertase YidC', NULL, NULL, NULL, NULL, NULL, 4),
(43023, NULL, 'G3DSA:3.30.200.20:FF:000200', NULL, NULL, 'Serine/threonine-protein kinase RIO3', NULL, NULL, NULL, NULL, NULL, 4),
(43024, NULL, 'G3DSA:3.40.50.150:FF:001187', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43025, NULL, 'G3DSA:3.40.720.10:FF:000184', NULL, NULL, 'Multifunctional alkaline phosphatase superfamily protein PehA', NULL, NULL, NULL, NULL, NULL, 4),
(43026, NULL, 'G3DSA:1.20.1070.10:FF:001050', NULL, NULL, 'Rhodopsin, GQ-coupled', NULL, NULL, NULL, NULL, NULL, 4),
(43027, NULL, 'G3DSA:1.10.10.60:FF:001187', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43028, NULL, 'G3DSA:3.30.1490.20:FF:000029', NULL, NULL, 'synapsin', NULL, NULL, NULL, NULL, NULL, 4),
(43029, NULL, 'G3DSA:1.25.10.10:FF:000200', NULL, NULL, 'Centrosomal protein of 104 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(43030, NULL, 'G3DSA:1.25.40.10:FF:003681', NULL, NULL, 'PPR superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(43031, NULL, 'G3DSA:2.30.30.40:FF:000004', NULL, NULL, 'Sorbin and SH3 domain-containing protein 1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(43032, NULL, 'G3DSA:2.10.230.10:FF:000011', NULL, NULL, 'Chaperone protein dnaJ 3', NULL, NULL, NULL, NULL, NULL, 4),
(43033, NULL, 'G3DSA:2.70.220.10:FF:000008', NULL, NULL, 'Putative phosphatidylglycerol/phosphatidylinositol transfer protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(43034, NULL, 'G3DSA:3.30.70.330:FF:001174', NULL, NULL, 'RNA methyltransferase TrmH family protein', NULL, NULL, NULL, NULL, NULL, 4),
(43035, NULL, 'G3DSA:1.20.58.60:FF:000493', NULL, NULL, 'AGAP009554-PA', NULL, NULL, NULL, NULL, NULL, 4),
(43036, NULL, 'G3DSA:2.40.50.100:FF:000001', NULL, NULL, '50S ribosomal protein L27', NULL, NULL, NULL, NULL, NULL, 4),
(43037, NULL, 'G3DSA:3.10.50.30:FF:000001', NULL, NULL, 'Transcription elongation factor GreA', NULL, NULL, NULL, NULL, NULL, 4),
(43038, NULL, 'G3DSA:3.40.50.1000:FF:000007', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(43039, NULL, 'G3DSA:2.10.80.10:FF:000016', NULL, NULL, 'Prokineticin 2', NULL, NULL, NULL, NULL, NULL, 4),
(43040, NULL, 'G3DSA:3.10.250.10:FF:000025', NULL, NULL, 'Transmembrane protease, serine 3 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(43041, NULL, 'G3DSA:2.60.40.420:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43042, NULL, 'G3DSA:2.40.37.10:FF:000078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43043, NULL, 'G3DSA:3.60.10.10:FF:000373', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43044, NULL, 'G3DSA:3.40.30.10:FF:000318', NULL, NULL, 'Ribosomal protein L43, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(43045, NULL, 'G3DSA:3.20.20.70:FF:000527', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43046, NULL, 'G3DSA:3.20.20.330:FF:000020', NULL, NULL, 'Selenocysteine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(43047, NULL, 'G3DSA:3.30.70.330:FF:002933', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43048, NULL, 'G3DSA:1.10.3080.10:FF:000007', NULL, NULL, 'Putative ion-transport protein YfeO', NULL, NULL, NULL, NULL, NULL, 4),
(43049, NULL, 'G3DSA:1.20.810.10:FF:000023', NULL, NULL, 'Cytochrome b6', NULL, NULL, NULL, NULL, NULL, 4),
(43050, NULL, 'G3DSA:3.30.40.10:FF:000466', NULL, NULL, 'E3 ubiquitin-protein ligase RNF168', NULL, NULL, NULL, NULL, NULL, 4),
(43051, NULL, 'G3DSA:3.10.50.40:FF:000004', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(43052, NULL, 'G3DSA:2.60.120.620:FF:000103', NULL, NULL, '2OG-Fe(II) oxygenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(43053, NULL, 'G3DSA:3.40.50.300:FF:007561', NULL, NULL, 'AGAP011893-PA', NULL, NULL, NULL, NULL, NULL, 4),
(43054, NULL, 'G3DSA:3.30.40.10:FF:001303', NULL, NULL, 'Im:7158173 protein', NULL, NULL, NULL, NULL, NULL, 4),
(43055, NULL, 'G3DSA:3.40.850.10:FF:000188', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(43056, NULL, 'G3DSA:3.60.40.10:FF:000088', NULL, NULL, 'Protein phosphatase PPM4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(43057, NULL, 'G3DSA:3.40.50.720:FF:002566', NULL, NULL, 'NmrA-like family domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(43058, NULL, 'G3DSA:3.30.160.60:FF:003356', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43059, NULL, 'G3DSA:1.10.10.1350:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43060, NULL, 'G3DSA:3.30.40.150:FF:000001', NULL, NULL, 'F-box only protein 30', NULL, NULL, NULL, NULL, NULL, 4),
(43061, NULL, 'G3DSA:2.60.40.1530:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43062, NULL, 'G3DSA:1.10.510.10:FF:003139', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43063, NULL, 'G3DSA:1.25.10.10:FF:002797', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43064, NULL, 'G3DSA:3.30.9.10:FF:000270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43065, NULL, 'G3DSA:3.30.70.330:FF:001516', NULL, NULL, 'RNA recognition motif-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(43066, NULL, 'G3DSA:1.20.58.60:FF:000835', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43067, NULL, 'G3DSA:2.10.25.10:FF:000900', NULL, NULL, 'Netrin 4', NULL, NULL, NULL, NULL, NULL, 4),
(43068, NULL, 'G3DSA:3.30.420.40:FF:000987', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(43069, NULL, 'G3DSA:3.40.250.10:FF:000221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43070, NULL, 'G3DSA:4.10.410.10:FF:000028', NULL, NULL, 'CBN-MEC-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(43071, NULL, 'G3DSA:1.10.167.10:FF:000030', NULL, NULL, 'Regulator of G-protein signaling egl-10', NULL, NULL, NULL, NULL, NULL, 4),
(43072, NULL, 'G3DSA:1.20.920.10:FF:000138', NULL, NULL, 'Transcription initiation factor TFIID subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(43073, NULL, 'G3DSA:3.20.20.370:FF:000003', NULL, NULL, 'CLUMA_CG003232, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(43074, NULL, 'G3DSA:3.40.30.10:FF:001207', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43075, NULL, 'G3DSA:1.20.120.550:FF:000025', NULL, NULL, 'Microsomal glutathione S-transferase 3', NULL, NULL, NULL, NULL, NULL, 4),
(43076, NULL, 'G3DSA:2.40.30.10:FF:000496', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43077, NULL, 'G3DSA:3.30.160.60:FF:004323', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43078, NULL, 'G3DSA:3.30.200.20:FF:001752', NULL, NULL, 'Raf-1 proto-oncogene, serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(43079, NULL, 'G3DSA:3.10.105.10:FF:000083', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(43080, NULL, 'G3DSA:1.10.10.2660:FF:000025', NULL, NULL, 'ThiF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(43081, NULL, 'G3DSA:1.10.510.10:FF:001616', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(43082, NULL, 'G3DSA:1.20.1610.10:FF:000013', NULL, NULL, 'Alpha-1,2-mannosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(43083, NULL, 'G3DSA:2.40.30.10:FF:000024', NULL, NULL, 'Eukaryotic peptide chain release factor GTP-binding subunit ERF3A', NULL, NULL, NULL, NULL, NULL, 4),
(43084, NULL, 'G3DSA:3.40.50.720:FF:001049', NULL, NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(43085, NULL, 'G3DSA:3.40.50.12650:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43086, NULL, 'G3DSA:3.40.1190.20:FF:000207', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43087, NULL, 'G3DSA:1.25.40.180:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43088, NULL, 'G3DSA:1.25.40.10:FF:005222', NULL, NULL, 'AGAP003595-PA', NULL, NULL, NULL, NULL, NULL, 4),
(43089, NULL, 'G3DSA:1.20.1250.20:FF:001135', NULL, NULL, 'Ascorbate transporter chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(43090, NULL, 'G3DSA:2.30.30.40:FF:000180', NULL, NULL, 'epidermal growth factor receptor kinase substrate 8-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(43091, NULL, 'G3DSA:1.10.287.70:FF:000658', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43092, NULL, 'G3DSA:3.30.70.1230:FF:000080', NULL, NULL, 'LuxR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(43093, NULL, 'G3DSA:3.30.1120.10:FF:000062', NULL, NULL, 'Arylsulphatase A', NULL, NULL, NULL, NULL, NULL, 4),
(43094, NULL, 'G3DSA:3.90.70.200:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43095, NULL, 'G3DSA:3.90.870.10:FF:000015', NULL, NULL, 'Probable riboflavin biosynthesis protein RibA1 (GTP cyclohydrolase II)', NULL, NULL, NULL, NULL, NULL, 4),
(43096, NULL, 'G3DSA:2.130.10.10:FF:001625', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(43097, NULL, 'G3DSA:2.30.29.30:FF:000898', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(43098, NULL, 'G3DSA:4.10.280.10:FF:000097', NULL, NULL, 'Neuronal PAS domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(43099, NULL, 'G3DSA:2.60.15.10:FF:000027', NULL, NULL, 'ATP synthase subunit delta, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(43100, NULL, 'G3DSA:3.90.1750.10:FF:000085', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43101, NULL, 'G3DSA:3.40.1170.60:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43102, NULL, 'G3DSA:2.60.120.380:FF:000037', NULL, NULL, 'Serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(43103, NULL, 'G3DSA:2.60.40.1120:FF:000001', NULL, NULL, 'Nodal modulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(43104, NULL, 'G3DSA:1.10.10.10:FF:000190', NULL, NULL, 'COP9 signalosome complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(43105, NULL, 'G3DSA:3.30.1960.10:FF:000013', NULL, NULL, 'tRNA wybutosine-synthesizing protein 3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(43106, NULL, 'G3DSA:4.10.240.10:FF:000151', NULL, NULL, 'Uga32p', NULL, NULL, NULL, NULL, NULL, 4),
(43107, NULL, 'G3DSA:2.30.30.550:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43108, NULL, 'G3DSA:3.30.70.330:FF:001028', NULL, NULL, 'RNA binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(43109, NULL, 'G3DSA:3.40.50.10320:FF:000010', NULL, NULL, 'Glucosamine-6-phosphate isomerase / GlcNAc-PI de-N-acetylase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(43110, NULL, 'G3DSA:2.40.160.120:FF:000051', NULL, NULL, 'Oxysterol binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(43111, NULL, 'G3DSA:3.40.20.10:FF:000133', NULL, NULL, 'YALI0E34687p', NULL, NULL, NULL, NULL, NULL, 4),
(43112, NULL, 'G3DSA:3.40.50.300:FF:003104', NULL, NULL, 'Suppressor of Stomatin mutant Uncoordination', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(43113, NULL, 'G3DSA:3.40.50.150:FF:000636', NULL, NULL, 'Class I SAM-dependent methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(43114, NULL, 'G3DSA:1.10.3520.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43115, NULL, 'G3DSA:2.70.98.10:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43116, NULL, 'G3DSA:3.30.260.10:FF:000090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43117, NULL, 'G3DSA:3.40.50.1360:FF:000054', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43118, NULL, 'G3DSA:3.40.50.150:FF:001625', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43119, NULL, 'G3DSA:1.10.8.60:FF:000085', NULL, NULL, 'DNA polymerase III subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(43120, NULL, 'G3DSA:3.30.2130.10:FF:000001', NULL, NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(43121, NULL, 'G3DSA:1.25.40.20:FF:000380', NULL, NULL, 'Os01g0892800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(43122, NULL, 'G3DSA:2.60.40.10:FF:003738', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43123, NULL, 'G3DSA:1.10.510.10:FF:000627', NULL, NULL, 'Os02g0694800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(43124, NULL, 'G3DSA:3.30.70.330:FF:001467', NULL, NULL, 'UBP1-associated protein 2C', NULL, NULL, NULL, NULL, NULL, 4),
(43125, NULL, 'G3DSA:3.40.30.10:FF:000218', NULL, NULL, 'spermatogenesis-associated protein 20', NULL, NULL, NULL, NULL, NULL, 4),
(43126, NULL, 'G3DSA:3.30.160.60:FF:003334', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43127, NULL, 'G3DSA:3.80.10.10:FF:001704', NULL, NULL, 'Os02g0216000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(43128, NULL, 'G3DSA:3.40.50.300:FF:002115', NULL, NULL, 'disks large homolog 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(43129, NULL, 'G3DSA:3.40.50.10810:FF:000241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43130, NULL, 'G3DSA:3.10.310.10:FF:000014', NULL, NULL, 'Diaminopimelate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(43131, NULL, 'G3DSA:3.30.70.1430:FF:000016', NULL, NULL, 'Probable Resistance-Nodulation-Cell Division (RND) efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(43132, NULL, 'G3DSA:1.10.510.10:FF:002605', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43133, NULL, 'G3DSA:4.10.400.10:FF:000186', NULL, NULL, 'MAM and LDL-receptor class A domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(43134, NULL, 'G3DSA:2.40.290.10:FF:000020', NULL, NULL, 'Related to ATP-dependent DNA helicase II, 80 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(43135, NULL, 'G3DSA:3.30.1680.10:FF:000031', NULL, NULL, 'Similar to semaphorin-I', NULL, NULL, NULL, NULL, NULL, 4),
(43136, NULL, 'G3DSA:2.70.98.40:FF:000007', NULL, NULL, 'Cyclic beta-1,2-glucan synthase', NULL, NULL, NULL, NULL, NULL, 4),
(43137, NULL, 'G3DSA:1.10.418.10:FF:000272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43138, NULL, 'G3DSA:3.30.230.70:FF:000173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43139, NULL, 'G3DSA:1.10.30.10:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43140, NULL, 'G3DSA:3.30.230.80:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43141, NULL, 'G3DSA:3.20.20.70:FF:000646', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43142, NULL, 'G3DSA:2.60.40.1170:FF:000055', NULL, NULL, 'Coatomer subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(43143, NULL, 'G3DSA:3.20.20.80:FF:000503', NULL, NULL, 'Glycoside hydrolase family 17 protein', NULL, NULL, NULL, NULL, NULL, 4),
(43144, NULL, 'G3DSA:3.40.50.2300:FF:001562', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43145, NULL, 'G3DSA:2.60.120.620:FF:000065', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43146, NULL, 'G3DSA:2.60.200.40:FF:000041', NULL, NULL, 'Sphingosine kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(43147, NULL, 'G3DSA:3.40.525.10:FF:000040', NULL, NULL, 'Cell surface biosynthesis and architecture modulator, putative', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(43148, NULL, 'G3DSA:1.10.10.60:FF:000625', NULL, NULL, 'Transcriptional regulator, AraC/XylS family', NULL, NULL, NULL, NULL, NULL, 4),
(43149, NULL, 'G3DSA:2.60.40.10:FF:000512', NULL, NULL, 'neurofascin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(43150, NULL, 'G3DSA:2.40.50.100:FF:000209', NULL, NULL, 'Glr3987 protein', NULL, NULL, NULL, NULL, NULL, 4),
(43151, NULL, 'G3DSA:1.20.1110.10:FF:000020', NULL, NULL, 'Sodium ion P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(43152, NULL, 'G3DSA:2.60.40.10:FF:002749', NULL, NULL, 'T cell receptor delta variable 3', NULL, NULL, NULL, NULL, NULL, 4),
(43153, NULL, 'G3DSA:3.90.180.10:FF:000159', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43154, NULL, 'G3DSA:3.40.50.300:FF:007758', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43155, NULL, 'G3DSA:1.25.10.10:FF:003096', NULL, NULL, 'MMS19 nucleotide excision repair protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(43156, NULL, 'G3DSA:3.30.420.40:FF:000021', NULL, NULL, 'heat shock 70 kDa protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(43157, NULL, 'G3DSA:3.90.1410.10:FF:000008', NULL, NULL, 'SET domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(43158, NULL, 'G3DSA:3.30.70.100:FF:000055', NULL, NULL, 'Antibiotic biosynthesis monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(43159, NULL, 'G3DSA:2.60.120.740:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43160, NULL, 'G3DSA:2.60.40.60:FF:000533', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43161, NULL, 'G3DSA:1.10.10.1250:FF:000001', NULL, NULL, 'Probable DNA-directed RNA polymerase subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(43162, NULL, 'G3DSA:2.130.10.10:FF:000636', NULL, NULL, 'Telomerase protein component 1', NULL, NULL, NULL, NULL, NULL, 4),
(43163, NULL, 'G3DSA:2.60.40.150:FF:000095', NULL, NULL, 'myoferlin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(43164, NULL, 'G3DSA:1.20.1740.10:FF:000197', NULL, NULL, 'AGAP011499-PA', NULL, NULL, NULL, NULL, NULL, 4),
(43165, NULL, 'G3DSA:3.30.760.10:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43166, NULL, 'G3DSA:3.30.40.10:FF:001113', NULL, NULL, '3'',5''-cyclic nucleotide phosphodiesterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(43167, NULL, 'G3DSA:1.10.540.10:FF:000016', NULL, NULL, 'acyl-CoA dehydrogenase family member 11', NULL, NULL, NULL, NULL, NULL, 4),
(43168, NULL, 'G3DSA:2.170.270.10:FF:000061', NULL, NULL, 'Down and out, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(43169, NULL, 'G3DSA:3.30.500.10:FF:000007', NULL, NULL, 'Major histocompatibility complex class I LDA', NULL, NULL, NULL, NULL, NULL, 4),
(43170, NULL, 'G3DSA:3.40.50.300:FF:003576', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(43171, NULL, 'G3DSA:3.90.730.10:FF:000005', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(43172, NULL, 'G3DSA:3.90.810.10:FF:000006', NULL, NULL, 'Neural Wiskott-Aldrich syndrome protein', NULL, NULL, NULL, NULL, NULL, 4),
(43173, NULL, 'G3DSA:2.30.42.10:FF:000445', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43174, NULL, 'G3DSA:2.10.25.10:FF:001334', NULL, NULL, 'Si:dkey-1m11.6', NULL, NULL, NULL, NULL, NULL, 4),
(43175, NULL, 'G3DSA:3.40.228.10:FF:000029', NULL, NULL, 'DMSO reductase chain A', NULL, NULL, NULL, NULL, NULL, 4),
(43176, NULL, 'G3DSA:1.10.357.20:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43177, NULL, 'G3DSA:1.20.5.4770:FF:000009', NULL, NULL, 'Tumor necrosis factor, alpha-induced protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(43178, NULL, 'G3DSA:2.60.40.10:FF:001940', NULL, NULL, 'Twitchin', NULL, NULL, NULL, NULL, NULL, 4),
(43179, NULL, 'G3DSA:3.30.450.40:FF:000169', NULL, NULL, 'PAS sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(43180, NULL, 'G3DSA:1.25.40.10:FF:002788', NULL, NULL, 'Chitin synthase regulatory factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(43181, NULL, 'G3DSA:2.40.50.140:FF:000553', NULL, NULL, 'Cytochrome c-type biogenesis protein CcmE homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(43182, NULL, 'G3DSA:3.20.20.70:FF:000293', NULL, NULL, 'Triosephosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(43183, NULL, 'G3DSA:3.30.40.10:FF:001585', NULL, NULL, 'Zinc finger, C3HC4 type (RING finger), putative', NULL, NULL, NULL, NULL, NULL, 4),
(43184, NULL, 'G3DSA:1.20.1070.10:FF:002169', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43185, NULL, 'G3DSA:3.40.120.10:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43186, NULL, 'G3DSA:3.90.79.10:FF:000250', NULL, NULL, 'Nudix hydrolase 16 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(43187, NULL, 'G3DSA:2.20.70.10:FF:000252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43188, NULL, 'G3DSA:3.40.50.2000:FF:000634', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(43189, NULL, 'G3DSA:3.40.720.10:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43190, NULL, 'G3DSA:3.30.2350.10:FF:000012', NULL, NULL, 'tRNA pseudouridine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(43191, NULL, 'G3DSA:1.10.238.10:FF:000174', NULL, NULL, 'Calcium-dependent protein kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(43192, NULL, 'G3DSA:1.20.1070.10:FF:001713', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43193, NULL, 'G3DSA:3.40.1110.10:FF:000458', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43194, NULL, 'G3DSA:2.130.10.10:FF:004970', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43195, NULL, 'G3DSA:3.40.50.300:FF:006010', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(43196, NULL, 'G3DSA:3.30.160.60:FF:000428', NULL, NULL, 'PR domain zinc finger protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(43197, NULL, 'G3DSA:1.10.630.10:FF:000254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43198, NULL, 'G3DSA:1.20.1250.20:FF:000179', NULL, NULL, 'Solute carrier family 16 member 2', NULL, NULL, NULL, NULL, NULL, 4),
(43199, NULL, 'G3DSA:3.90.70.10:FF:000230', NULL, NULL, 'Peptidase domain-containing ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(43200, NULL, 'G3DSA:3.90.640.10:FF:000206', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43201, NULL, 'G3DSA:3.40.1110.10:FF:000019', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(43202, NULL, 'G3DSA:2.40.50.140:FF:001042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43203, NULL, 'G3DSA:1.25.10.10:FF:001651', NULL, NULL, 'Transport and golgi organization 6 homolog (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(43204, NULL, 'G3DSA:1.10.10.10:FF:001499', NULL, NULL, 'Iron/manganese-dependent transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(43205, NULL, 'G3DSA:3.80.10.10:FF:000395', NULL, NULL, 'Reticulon 4 receptor like 2', NULL, NULL, NULL, NULL, NULL, 4),
(43206, NULL, 'G3DSA:1.20.58.390:FF:000079', NULL, NULL, 'Cholinergic receptor, nicotinic, epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(43207, NULL, 'G3DSA:2.10.25.10:FF:000378', NULL, NULL, 'neurogenic locus notch homolog protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(43208, NULL, 'G3DSA:3.30.310.130:FF:000023', NULL, NULL, 'Si:dkey-100n23.3', NULL, NULL, NULL, NULL, NULL, 4),
(43209, NULL, 'G3DSA:1.20.120.910:FF:000004', NULL, NULL, 'Conjugal transfer protein TraR', NULL, NULL, NULL, NULL, NULL, 4),
(43210, NULL, 'G3DSA:3.30.160.60:FF:001417', NULL, NULL, 'zinc finger protein 423', NULL, NULL, NULL, NULL, NULL, 4),
(43211, NULL, 'G3DSA:3.10.20.90:FF:000473', NULL, NULL, 'Auxin-responsive protein', NULL, NULL, NULL, NULL, NULL, 4),
(43212, NULL, 'G3DSA:2.90.10.10:FF:000060', NULL, NULL, 'Putative S-locus receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(43213, NULL, 'G3DSA:2.60.120.260:FF:000586', NULL, NULL, 'Si:ch73-40a2.1', NULL, NULL, NULL, NULL, NULL, 4),
(43214, NULL, 'G3DSA:1.10.238.10:FF:000235', NULL, NULL, 'Probable calcium-binding protein CML15', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(43215, NULL, 'G3DSA:1.50.40.10:FF:000279', NULL, NULL, 'Mitochondrial carrier protein (Rim2), putative', NULL, NULL, NULL, NULL, NULL, 4),
(43216, NULL, 'G3DSA:3.40.50.10140:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43217, NULL, 'G3DSA:3.40.33.10:FF:000051', NULL, NULL, 'Protein CBG01191', NULL, NULL, NULL, NULL, NULL, 4),
(43218, NULL, 'G3DSA:1.10.400.10:FF:000006', NULL, NULL, 'Guanine nucleotide-binding protein G(Z) subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(43219, NULL, 'G3DSA:1.10.520.10:FF:000072', NULL, NULL, 'Peroxidase 12', NULL, NULL, NULL, NULL, NULL, 4),
(43220, NULL, 'G3DSA:2.40.420.20:FF:000056', NULL, NULL, 'RND superfamily efflux pump MFP component', NULL, NULL, NULL, NULL, NULL, 4),
(43221, NULL, 'G3DSA:3.20.20.140:FF:000132', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(43222, NULL, 'G3DSA:2.60.40.1760:FF:000018', NULL, NULL, 'Oligosaccharide 4-alpha-D-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(43223, NULL, 'G3DSA:1.25.10.10:FF:002168', NULL, NULL, 'Coatomer subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(43224, NULL, 'G3DSA:2.20.25.80:FF:000005', NULL, NULL, 'probable WRKY transcription factor 14', NULL, NULL, NULL, NULL, NULL, 4),
(43225, NULL, 'G3DSA:3.30.160.810:FF:000006', NULL, NULL, '50S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(43226, NULL, 'G3DSA:3.30.420.40:FF:000460', NULL, NULL, 'Heat shock protein 70, putative', NULL, NULL, NULL, NULL, NULL, 4),
(43227, NULL, 'G3DSA:1.10.8.140:FF:000018', NULL, NULL, 'AaceriAGL074Wp', NULL, NULL, NULL, NULL, NULL, 4),
(43228, NULL, 'G3DSA:3.30.70.330:FF:002456', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43229, NULL, 'G3DSA:3.30.479.20:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43230, NULL, 'G3DSA:3.80.10.10:FF:000715', NULL, NULL, 'F-box and leucine-rich repeat protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(43231, NULL, 'G3DSA:1.10.510.10:FF:003533', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43232, NULL, 'G3DSA:1.10.287.470:FF:000082', NULL, NULL, 'RND family efflux transporter MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(43233, NULL, 'G3DSA:2.170.130.10:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43234, NULL, 'G3DSA:3.10.250.10:FF:000043', NULL, NULL, 'Lysyl oxidase homolog 3B', NULL, NULL, NULL, NULL, NULL, 4),
(43235, NULL, 'G3DSA:2.60.450.20:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43236, NULL, 'G3DSA:2.10.110.10:FF:000132', NULL, NULL, 'Pxl1p', NULL, NULL, NULL, NULL, NULL, 4),
(43237, NULL, 'G3DSA:3.30.160.60:FF:000580', NULL, NULL, 'Zinc finger protein 512', NULL, NULL, NULL, NULL, NULL, 4),
(43238, NULL, 'G3DSA:1.25.40.10:FF:004233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43239, NULL, 'G3DSA:3.30.160.60:FF:000900', NULL, NULL, 'Zinc finger and BTB domain containing 47', NULL, NULL, NULL, NULL, NULL, 4),
(43240, NULL, 'G3DSA:1.25.40.420:FF:000006', NULL, NULL, 'RCC1 and BTB domain-containing protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(43241, NULL, 'G3DSA:3.90.230.10:FF:000012', NULL, NULL, 'ERBB-3 BINDING PROTEIN 1', NULL, NULL, NULL, NULL, NULL, 4),
(43242, NULL, 'G3DSA:3.30.1740.10:FF:000002', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(43243, NULL, 'G3DSA:3.30.200.20:FF:000763', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(43244, NULL, 'G3DSA:3.40.50.1980:FF:000032', NULL, NULL, 'Ferrichrome ABC transporter substrate-bindingprotein', NULL, NULL, NULL, NULL, NULL, 4),
(43245, NULL, 'G3DSA:1.20.58.1030:FF:000045', NULL, NULL, 'DNA replication complex GINS protein SLD5', NULL, NULL, NULL, NULL, NULL, 4),
(43246, NULL, 'G3DSA:2.60.40.3510:FF:000010', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(43247, NULL, 'G3DSA:3.30.230.10:FF:000262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43248, NULL, 'G3DSA:2.130.10.10:FF:005807', NULL, NULL, 'WD repeat domain 19', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(43249, NULL, 'G3DSA:3.30.70.3290:FF:000001', NULL, NULL, 'Probable polyketide synthase Pks8', NULL, NULL, NULL, NULL, NULL, 4),
(43250, NULL, 'G3DSA:1.25.10.10:FF:002640', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43251, NULL, 'G3DSA:2.40.10.170:FF:000020', NULL, NULL, 'ATP synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(43252, NULL, 'G3DSA:1.50.10.10:FF:000098', NULL, NULL, 'Glucanase', NULL, NULL, NULL, NULL, NULL, 4),
(43253, NULL, 'G3DSA:1.10.10.10:FF:001532', NULL, NULL, 'Two-component response regulator, SAPR family, consists of REC, wHTH and BTAD domains', NULL, NULL, NULL, NULL, NULL, 4),
(43254, NULL, 'G3DSA:3.40.50.980:FF:000059', NULL, NULL, 'Acyl-CoA ligase easD', NULL, NULL, NULL, NULL, NULL, 4),
(43255, NULL, 'G3DSA:3.40.800.20:FF:000003', NULL, NULL, 'Histone deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(43256, NULL, 'G3DSA:3.40.50.300:FF:006510', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43257, NULL, 'G3DSA:3.30.30.30:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43258, NULL, 'G3DSA:1.10.8.10:FF:000031', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(43259, NULL, 'G3DSA:1.20.920.10:FF:000156', NULL, NULL, 'ATPase family AAA domain-containing protein 2B', NULL, NULL, NULL, NULL, NULL, 4),
(43260, NULL, 'G3DSA:2.60.40.10:FF:001440', NULL, NULL, 'CD101 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(43261, NULL, 'G3DSA:3.40.50.10260:FF:000031', NULL, NULL, 'enhancer of mRNA-decapping protein 3-like', NULL, NULL, NULL, NULL, NULL, 4),
(43262, NULL, 'G3DSA:3.30.530.20:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43263, NULL, 'G3DSA:1.20.1410.10:FF:000032', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43264, NULL, 'G3DSA:3.40.50.150:FF:001272', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43265, NULL, 'G3DSA:3.40.50.1000:FF:000643', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43266, NULL, 'G3DSA:1.25.40.10:FF:000051', NULL, NULL, 'Cell division cycle protein 27 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(43267, NULL, 'G3DSA:3.40.630.10:FF:000346', NULL, NULL, 'Carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(43268, NULL, 'G3DSA:2.30.180.10:FF:000036', NULL, NULL, 'Stabilin 1', NULL, NULL, NULL, NULL, NULL, 4),
(43269, NULL, 'G3DSA:3.40.50.2300:FF:000634', NULL, NULL, 'Vomeronasal 2, receptor 120', NULL, NULL, NULL, NULL, NULL, 4),
(43270, NULL, 'G3DSA:3.40.50.1100:FF:000055', NULL, NULL, 'Threonine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(43271, NULL, 'G3DSA:3.40.50.11260:FF:000022', NULL, NULL, 'Endoplasmin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(43272, NULL, 'G3DSA:1.25.40.720:FF:000006', NULL, NULL, 'Telomere binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(43273, NULL, 'G3DSA:3.10.450.10:FF:000024', NULL, NULL, 'Cystatin F', NULL, NULL, NULL, NULL, NULL, 4),
(43274, NULL, 'G3DSA:1.25.40.10:FF:002288', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g27460', NULL, NULL, NULL, NULL, NULL, 4),
(43275, NULL, 'G3DSA:3.40.50.2300:FF:001123', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43276, NULL, 'G3DSA:3.30.420.10:FF:000445', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43277, NULL, 'G3DSA:1.20.1250.20:FF:002124', NULL, NULL, 'Solute carrier family 22 member 21', NULL, NULL, NULL, NULL, NULL, 4),
(43278, NULL, 'G3DSA:2.130.10.10:FF:005487', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43279, NULL, 'G3DSA:1.10.720.30:FF:000059', NULL, NULL, 'Ubiquitin-conjugating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(43280, NULL, 'G3DSA:1.10.510.10:FF:002252', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43281, NULL, 'G3DSA:2.130.10.10:FF:005015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43282, NULL, 'G3DSA:1.25.40.10:FF:001832', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g16610', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(43283, NULL, 'G3DSA:1.20.5.100:FF:000004', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(43284, NULL, 'G3DSA:3.30.1360.120:FF:000012', NULL, NULL, 'sarcosine dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(43285, NULL, 'G3DSA:3.30.10.10:FF:000004', NULL, NULL, 'Serine proteinase inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(43286, NULL, 'G3DSA:2.130.10.10:FF:005307', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43287, NULL, 'G3DSA:2.130.10.10:FF:002553', NULL, NULL, 'Dynein assembly factor with WDR repeat domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(43288, NULL, 'G3DSA:1.10.20.10:FF:000336', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43289, NULL, 'G3DSA:2.40.70.10:FF:000442', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43290, NULL, 'G3DSA:2.10.25.10:FF:000878', NULL, NULL, 'Otogelin-like', NULL, NULL, NULL, NULL, NULL, 4),
(43291, NULL, 'G3DSA:3.80.10.10:FF:002340', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43292, NULL, 'G3DSA:3.90.190.10:FF:000424', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43293, NULL, 'G3DSA:3.40.1190.10:FF:000030', NULL, NULL, 'UDP-N-acetylmuramoyl-L-alanyl-D-glutamate--2,6-diaminopimelate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(43294, NULL, 'G3DSA:1.25.10.10:FF:000223', NULL, NULL, 'Serine/threonine-protein kinase TIO', NULL, NULL, NULL, NULL, NULL, 4),
(43295, NULL, 'G3DSA:1.20.58.1480:FF:000011', NULL, NULL, 'Lon protease homolog 2, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(43296, NULL, 'G3DSA:2.40.70.10:FF:000150', NULL, NULL, 'Gag-Pro polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(43297, NULL, 'G3DSA:1.25.40.450:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43298, NULL, 'G3DSA:3.30.450.50:FF:000026', NULL, NULL, 'SNARE protein', NULL, NULL, NULL, NULL, NULL, 4),
(43299, NULL, 'G3DSA:1.25.40.10:FF:001540', NULL, NULL, 'Os07g0598500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(43300, NULL, 'G3DSA:3.10.100.10:FF:000268', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43301, NULL, 'G3DSA:3.40.1390.10:FF:000006', NULL, NULL, 'UDP-N-acetylmuramoyl-L-alanyl-D-glutamate--2,6-diaminopimelate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(43302, NULL, 'G3DSA:1.10.150.20:FF:000001', NULL, NULL, 'DNA-directed RNA polymerase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(43303, NULL, 'G3DSA:3.40.33.10:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43304, NULL, 'G3DSA:4.10.910.10:FF:000005', NULL, NULL, '30S ribosomal protein S13, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(43305, NULL, 'G3DSA:2.60.40.10:FF:004666', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43306, NULL, 'G3DSA:3.40.50.11620:FF:000001', NULL, NULL, 'Phosphotransferase RcsD', NULL, NULL, NULL, NULL, NULL, 4),
(43307, NULL, 'G3DSA:1.20.58.80:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43308, NULL, 'G3DSA:3.60.10.10:FF:000025', NULL, NULL, 'Angel homolog 1 (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(43309, NULL, 'G3DSA:1.25.40.20:FF:001189', NULL, NULL, 'Ankyrin repeat and SOCS box containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(43310, NULL, 'G3DSA:2.160.20.70:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43311, NULL, 'G3DSA:1.10.510.10:FF:002105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43312, NULL, 'G3DSA:1.20.272.40:FF:000012', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(43313, NULL, 'G3DSA:3.30.160.60:FF:005251', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43314, NULL, 'G3DSA:3.40.50.300:FF:007258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43315, NULL, 'G3DSA:2.60.40.150:FF:000156', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(43316, NULL, 'G3DSA:2.30.29.30:FF:000959', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(43317, NULL, 'G3DSA:1.10.533.10:FF:000051', NULL, NULL, 'Baculoviral IAP repeat containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(43318, NULL, 'G3DSA:3.30.160.60:FF:001097', NULL, NULL, 'IKAROS family zinc finger 5', NULL, NULL, NULL, NULL, NULL, 4),
(43319, NULL, 'G3DSA:3.80.10.10:FF:003621', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43320, NULL, 'G3DSA:1.10.630.10:FF:000754', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43321, NULL, 'G3DSA:1.10.150.20:FF:000181', NULL, NULL, 'Exonuclease I, putative', NULL, NULL, NULL, NULL, NULL, 4),
(43322, NULL, 'G3DSA:1.10.510.10:FF:002544', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 40', NULL, NULL, NULL, NULL, NULL, 4),
(43323, NULL, 'G3DSA:3.90.226.10:FF:000053', NULL, NULL, 'Tricorn protease homolog', NULL, NULL, NULL, NULL, NULL, 4),
(43324, NULL, 'G3DSA:3.30.70.330:FF:001528', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43325, NULL, 'G3DSA:3.40.50.1240:FF:000131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43326, NULL, 'G3DSA:2.60.120.200:FF:000175', NULL, NULL, 'Laminin subunit alpha 5', NULL, NULL, NULL, NULL, NULL, 4),
(43327, NULL, 'G3DSA:1.20.58.60:FF:000459', NULL, NULL, 'AGAP009554-PA', NULL, NULL, NULL, NULL, NULL, 4),
(43328, NULL, 'G3DSA:2.60.120.260:FF:000086', NULL, NULL, 'Non-specific cytotoxic cell receptor protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(43329, NULL, 'G3DSA:3.40.30.10:FF:000370', NULL, NULL, 'Peroxiredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(43330, NULL, 'G3DSA:3.80.10.10:FF:001643', NULL, NULL, 'Toll-like receptor 13', NULL, NULL, NULL, NULL, NULL, 4),
(43331, NULL, 'G3DSA:3.30.250.20:FF:000002', NULL, NULL, 'LINE1 type transposase domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(43332, NULL, 'G3DSA:1.25.40.20:FF:000700', NULL, NULL, 'Mann-cup, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(43333, NULL, 'G3DSA:1.10.600.10:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43334, NULL, 'G3DSA:3.30.200.20:FF:001691', NULL, NULL, 'Leucine-rich repeat receptor kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(43335, NULL, 'G3DSA:3.30.700.40:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43336, NULL, 'G3DSA:3.20.20.80:FF:000475', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43337, NULL, 'G3DSA:1.25.40.20:FF:000880', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43338, NULL, 'G3DSA:3.10.20.90:FF:000973', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43339, NULL, 'G3DSA:1.20.120.610:FF:000004', NULL, NULL, 'V-type ATP synthase subunit K', NULL, NULL, NULL, NULL, NULL, 4),
(43340, NULL, 'G3DSA:1.10.10.10:FF:000251', NULL, NULL, 'Transcriptional regulator, GntR family', NULL, NULL, NULL, NULL, NULL, 4),
(43341, NULL, 'G3DSA:3.30.60.20:FF:000044', NULL, NULL, 'SH3 and cysteine-rich domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(43342, NULL, 'G3DSA:3.10.50.40:FF:000067', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(43343, NULL, 'G3DSA:3.30.160.60:FF:002406', NULL, NULL, 'Zinc finger and BTB domain containing 11', NULL, NULL, NULL, NULL, NULL, 4),
(43344, NULL, 'G3DSA:1.20.120.350:FF:000229', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43345, NULL, 'G3DSA:3.40.50.1820:FF:001165', NULL, NULL, 'Methyl esterase 10', NULL, NULL, NULL, NULL, NULL, 4),
(43346, NULL, 'G3DSA:1.20.1280.290:FF:000001', NULL, NULL, 'Bidirectional sugar transporter SWEET', NULL, NULL, NULL, NULL, NULL, 4),
(43347, NULL, 'G3DSA:4.10.80.30:FF:000001', NULL, NULL, 'Putative autolysin, N-acetylmuramidase', NULL, NULL, NULL, NULL, NULL, 4),
(43348, NULL, 'G3DSA:1.10.238.10:FF:000999', NULL, NULL, 'Repetin', NULL, NULL, NULL, NULL, NULL, 4),
(43349, NULL, 'G3DSA:1.25.10.10:FF:000370', NULL, NULL, 'phosphoinositide 3-kinase regulatory subunit 4-like', NULL, NULL, NULL, NULL, NULL, 4),
(43350, NULL, 'G3DSA:2.60.40.10:FF:003238', NULL, NULL, 'Ig delta chain C region membrane-bound form', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(43351, NULL, 'G3DSA:2.40.37.10:FF:000062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43352, NULL, 'G3DSA:4.10.240.10:FF:000212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43353, NULL, 'G3DSA:1.50.10.10:FF:000131', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(43354, NULL, 'G3DSA:1.25.40.10:FF:001299', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g39980, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(43355, NULL, 'G3DSA:2.40.50.140:FF:000053', NULL, NULL, 'Elongation factor P-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(43356, NULL, 'G3DSA:2.120.10.80:FF:000045', NULL, NULL, 'leucine-zipper-like transcriptional regulator 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(43357, NULL, 'G3DSA:3.40.50.300:FF:001659', NULL, NULL, 'Peptide ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(43358, NULL, 'G3DSA:1.10.630.10:FF:000607', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43359, NULL, 'G3DSA:1.10.1070.11:FF:000008', NULL, NULL, 'serine/threonine-protein kinase SMG1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(43360, NULL, 'G3DSA:1.10.555.10:FF:000096', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(43361, NULL, 'G3DSA:1.25.40.20:FF:001217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43362, NULL, 'G3DSA:1.20.58.90:FF:000002', NULL, NULL, 'syntaxin-6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(43363, NULL, 'G3DSA:3.40.50.150:FF:000283', NULL, NULL, 'Class I SAM-dependent methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(43364, NULL, 'G3DSA:2.60.120.620:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43365, NULL, 'G3DSA:3.40.50.1440:FF:000039', NULL, NULL, 'Tubulin gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(43366, NULL, 'G3DSA:1.20.1740.10:FF:000225', NULL, NULL, 'Amino-acid permease 1', NULL, NULL, NULL, NULL, NULL, 4),
(43367, NULL, 'G3DSA:3.40.50.2300:FF:000134', NULL, NULL, 'Autolysin response regulator LytR', NULL, NULL, NULL, NULL, NULL, 4),
(43368, NULL, 'G3DSA:2.70.70.10:FF:000019', NULL, NULL, 'M23 family peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(43369, NULL, 'G3DSA:3.40.605.10:FF:000041', NULL, NULL, 'Aldehyde dehydrogenase 1 family member A3', NULL, NULL, NULL, NULL, NULL, 4),
(43370, NULL, 'G3DSA:3.30.1320.10:FF:000010', NULL, NULL, '30S ribosomal protein S16', NULL, NULL, NULL, NULL, NULL, 4),
(43371, NULL, 'G3DSA:3.20.20.80:FF:000183', NULL, NULL, 'Glycosyl hydrolase family 25', NULL, NULL, NULL, NULL, NULL, 4),
(43372, NULL, 'G3DSA:1.25.10.10:FF:001712', NULL, NULL, 'Sister chromatid cohesion protein', NULL, NULL, NULL, NULL, NULL, 4),
(43373, NULL, 'G3DSA:3.40.50.360:FF:000109', NULL, NULL, 'Multimeric flavodoxin WrbA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(43374, NULL, 'G3DSA:3.40.120.10:FF:000055', NULL, NULL, 'Phosphomannomutase PmmB', NULL, NULL, NULL, NULL, NULL, 4),
(43375, NULL, 'G3DSA:3.30.70.330:FF:001500', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43376, NULL, 'G3DSA:3.40.50.620:FF:000709', NULL, NULL, '7-cyano-7-deazaguanine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(43377, NULL, 'G3DSA:1.10.730.20:FF:000028', NULL, NULL, 'Isoleucyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(43378, NULL, 'G3DSA:1.10.472.170:FF:000010', NULL, NULL, 'Transcription initiation factor IIB', NULL, NULL, NULL, NULL, NULL, 4),
(43379, NULL, 'G3DSA:2.60.120.920:FF:000065', NULL, NULL, 'Ear1p', NULL, NULL, NULL, NULL, NULL, 4),
(43380, NULL, 'G3DSA:3.30.310.50:FF:000016', NULL, NULL, 'Phosphomannomutase', NULL, NULL, NULL, NULL, NULL, 4),
(43381, NULL, 'G3DSA:2.40.50.100:FF:000148', NULL, NULL, 'Vacuolar ATP synthase catalytic subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(43382, NULL, 'G3DSA:2.40.10.10:FF:000433', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43383, NULL, 'G3DSA:3.40.640.10:FF:000291', NULL, NULL, 'Aromatic amino acid aminotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(43384, NULL, 'G3DSA:3.40.50.300:FF:005813', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(43385, NULL, 'G3DSA:1.10.10.10:FF:001971', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(43386, NULL, 'G3DSA:4.10.410.10:FF:000012', NULL, NULL, 'Tissue factor pathway inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(43387, NULL, 'G3DSA:1.10.10.10:FF:000543', NULL, NULL, 'Transcriptional regulator, GntR family', NULL, NULL, NULL, NULL, NULL, 4),
(43388, NULL, 'G3DSA:1.20.1270.10:FF:000060', NULL, NULL, 'Heat shock protein 70-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(43389, NULL, 'G3DSA:1.10.287.1040:FF:000018', NULL, NULL, 'Exodeoxyribonuclease 7 small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(43390, NULL, 'G3DSA:2.60.40.60:FF:000033', NULL, NULL, 'FAT atypical cadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(43391, NULL, 'G3DSA:3.30.460.10:FF:000071', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43392, NULL, 'G3DSA:2.40.50.140:FF:000845', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43393, NULL, 'G3DSA:2.30.29.30:FF:000398', NULL, NULL, 'FACT complex subunit POB3', NULL, NULL, NULL, NULL, NULL, 4),
(43394, NULL, 'G3DSA:1.10.472.80:FF:000002', NULL, NULL, 'Ecotropic viral integration site 5', NULL, NULL, NULL, NULL, NULL, 4),
(43395, NULL, 'G3DSA:3.40.50.300:FF:003604', NULL, NULL, 'Small Rab GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(43396, NULL, 'G3DSA:1.10.472.80:FF:000182', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43397, NULL, 'G3DSA:3.100.10.10:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43398, NULL, 'G3DSA:3.30.559.10:FF:000210', NULL, NULL, 'Siderophore peptide synthetase fer3', NULL, NULL, NULL, NULL, NULL, 4),
(43399, NULL, 'G3DSA:1.25.40.10:FF:005194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43400, NULL, 'G3DSA:3.90.1150.10:FF:000409', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(43401, NULL, 'G3DSA:3.30.930.10:FF:000383', NULL, NULL, 'Lipoate protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(43402, NULL, 'G3DSA:3.30.40.10:FF:001293', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43403, NULL, 'G3DSA:3.40.1350.10:FF:000032', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43404, NULL, 'G3DSA:3.30.70.330:FF:002809', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43405, NULL, 'G3DSA:3.30.565.10:FF:000331', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(43406, NULL, 'G3DSA:1.20.5.170:FF:000244', NULL, NULL, 'X-box-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(43407, NULL, 'G3DSA:3.40.50.300:FF:004532', NULL, NULL, 'GL13229', NULL, NULL, NULL, NULL, NULL, 4),
(43408, NULL, 'G3DSA:3.30.110.150:FF:000001', NULL, NULL, 'Cell division protein SepF', NULL, NULL, NULL, NULL, NULL, 4),
(43409, NULL, 'G3DSA:3.10.20.90:FF:000181', NULL, NULL, 'transmembrane and ubiquitin-like domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(43410, NULL, 'G3DSA:3.30.450.20:FF:000455', NULL, NULL, 'Response receiver sensor histidine kinase, PAS domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(43411, NULL, 'G3DSA:3.10.620.30:FF:000010', NULL, NULL, 'Peptide-N(4)-(N-acetyl-beta-glucosaminyl)asparagine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(43412, NULL, 'G3DSA:3.80.10.10:FF:004138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43413, NULL, 'G3DSA:4.10.960.10:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43414, NULL, 'G3DSA:1.25.40.10:FF:002316', NULL, NULL, 'UTP6 small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4),
(43415, NULL, 'G3DSA:1.25.10.10:FF:001179', NULL, NULL, 'HEAT repeat domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(43416, NULL, 'G3DSA:2.60.120.290:FF:000162', NULL, NULL, 'Adhesion G protein-coupled receptor L3', NULL, NULL, NULL, NULL, NULL, 4),
(43417, NULL, 'G3DSA:3.30.70.330:FF:000039', NULL, NULL, 'U1 small nuclear ribonucleoprotein A', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(43418, NULL, 'G3DSA:3.30.56.30:FF:000003', NULL, NULL, 'Signal recognition particle SEC65 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(43419, NULL, 'G3DSA:3.30.1360.40:FF:000032', NULL, NULL, 'Ribosomal recycling factor, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4),
(43420, NULL, 'G3DSA:1.10.1740.10:FF:000031', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(43421, NULL, 'G3DSA:3.10.110.10:FF:000033', NULL, NULL, 'NEDD8-conjugating enzyme UBE2F', NULL, NULL, NULL, NULL, NULL, 4),
(43422, NULL, 'G3DSA:3.30.1120.70:FF:000001', NULL, NULL, 'Lambda phage portal protein B', NULL, NULL, NULL, NULL, NULL, 4),
(43423, NULL, 'G3DSA:3.40.395.10:FF:000006', NULL, NULL, 'sentrin-specific protease 5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(43424, NULL, 'G3DSA:3.40.1410.10:FF:000003', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(43425, NULL, 'G3DSA:2.10.25.160:FF:000001', NULL, NULL, 'Granulin precursor', NULL, NULL, NULL, NULL, NULL, 4),
(43426, NULL, 'G3DSA:3.40.50.2000:FF:000342', NULL, NULL, 'Related to alpha,alpha-trehalose-phosphate synthase, 115 KD subunit', NULL, NULL, NULL, NULL, NULL, 4),
(43427, NULL, 'G3DSA:1.10.246.130:FF:000011', NULL, NULL, 'Probable bifunctional acylase ggtA: cephalosporin acylase + gamma-glutamyltranspeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(43428, NULL, 'G3DSA:3.30.70.660:FF:000054', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(43429, NULL, 'G3DSA:3.40.50.1820:FF:000237', NULL, NULL, 'Acetyl xylan esterase', NULL, NULL, NULL, NULL, NULL, 4),
(43430, NULL, 'G3DSA:1.20.1070.10:FF:001421', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(43431, NULL, 'G3DSA:3.90.190.10:FF:000396', NULL, NULL, 'Slr1617 protein', NULL, NULL, NULL, NULL, NULL, 4),
(43432, NULL, 'G3DSA:3.30.40.10:FF:000657', NULL, NULL, 'E3 ubiquitin-protein ligase RGLG1', NULL, NULL, NULL, NULL, NULL, 4),
(43433, NULL, 'G3DSA:1.10.8.60:FF:000405', NULL, NULL, 'AAA-type ATPase family protein isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(43434, NULL, 'G3DSA:3.30.160.20:FF:000175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43435, NULL, 'G3DSA:2.70.150.10:FF:000267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43436, NULL, 'G3DSA:3.30.70.250:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43437, NULL, 'G3DSA:3.40.47.10:FF:000021', NULL, NULL, 'Fatty acid synthase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(43438, NULL, 'G3DSA:1.10.455.10:FF:000032', NULL, NULL, '30S ribosomal protein S7', NULL, NULL, NULL, NULL, NULL, 4),
(43439, NULL, 'G3DSA:3.40.50.300:FF:005021', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43440, NULL, 'G3DSA:1.20.1560.10:FF:000599', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43441, NULL, 'G3DSA:3.60.21.60:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43442, NULL, 'G3DSA:1.25.40.10:FF:003777', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43443, NULL, 'G3DSA:3.40.50.2300:FF:000926', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43444, NULL, 'G3DSA:1.20.120.1900:FF:000044', NULL, NULL, 'gamma-tubulin complex component 6 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(43445, NULL, 'G3DSA:1.10.560.10:FF:000046', NULL, NULL, '60 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(43446, NULL, 'G3DSA:2.10.220.10:FF:000022', NULL, NULL, 'proprotein convertase subtilisin/kexin type 5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(43447, NULL, 'G3DSA:3.30.360.10:FF:000035', NULL, NULL, 'Galactose 1-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(43448, NULL, 'G3DSA:3.40.390.10:FF:000310', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43449, NULL, 'G3DSA:1.10.8.10:FF:000323', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43450, NULL, 'G3DSA:2.30.30.190:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(43451, NULL, 'G3DSA:1.20.58.60:FF:000870', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43452, NULL, 'G3DSA:3.30.1490.20:FF:000030', NULL, NULL, 'Acetyl coenzyme A synthetase (ADP forming), alpha domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(43453, NULL, 'G3DSA:3.40.640.10:FF:000111', NULL, NULL, 'Cystathionine gamma-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(43454, NULL, 'G3DSA:1.10.10.60:FF:001261', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43455, NULL, 'G3DSA:2.130.10.10:FF:001272', NULL, NULL, 'WD domain, G-beta repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(43456, NULL, 'G3DSA:3.30.160.60:FF:001389', NULL, NULL, 'Zinc finger and AT-hook domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(43457, NULL, 'G3DSA:3.40.50.150:FF:001564', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43458, NULL, 'G3DSA:3.30.930.10:FF:000236', NULL, NULL, 'Proline--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(43459, NULL, 'G3DSA:1.10.8.60:FF:000585', NULL, NULL, 'Katanin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(43460, NULL, 'G3DSA:1.10.287.950:FF:000012', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(43461, NULL, 'G3DSA:3.30.540.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43462, NULL, 'G3DSA:3.30.1300.10:FF:000008', NULL, NULL, 'Pantothenate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(43463, NULL, 'G3DSA:2.30.29.30:FF:000931', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43464, NULL, 'G3DSA:3.40.630.30:FF:000032', NULL, NULL, 'Aminoalkylphosphonic acid N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(43465, NULL, 'G3DSA:3.40.50.300:FF:005993', NULL, NULL, 'Orc1-type DNA replication protein', NULL, NULL, NULL, NULL, NULL, 4),
(43466, NULL, 'G3DSA:1.20.58.400:FF:000037', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43467, NULL, 'G3DSA:3.90.950.10:FF:000016', NULL, NULL, 'dTTP/UTP pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(43468, NULL, 'G3DSA:2.10.25.10:FF:000086', NULL, NULL, 'Fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(43469, NULL, 'G3DSA:3.40.50.300:FF:000350', NULL, NULL, 'RNA polymerase-associated protein RapA', NULL, NULL, NULL, NULL, NULL, 4),
(43470, NULL, 'G3DSA:3.40.50.720:FF:002538', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(43471, NULL, 'G3DSA:3.30.559.10:FF:000238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43472, NULL, 'G3DSA:2.60.40.10:FF:003385', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43473, NULL, 'G3DSA:1.10.287.130:FF:000238', NULL, NULL, 'Circadian input kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(43474, NULL, 'G3DSA:2.180.10.10:FF:000022', NULL, NULL, 'Protein CBR-TEN-1', NULL, NULL, NULL, NULL, NULL, 4),
(43475, NULL, 'G3DSA:3.30.70.890:FF:000038', NULL, NULL, 'Diphosphomevalonate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(43476, NULL, 'G3DSA:3.30.1490.20:FF:000058', NULL, NULL, 'UvrABC system protein A', NULL, NULL, NULL, NULL, NULL, 4),
(43477, NULL, 'G3DSA:2.30.30.1020:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43478, NULL, 'G3DSA:3.40.50.300:FF:002587', NULL, NULL, 'Multidrug ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(43479, NULL, 'G3DSA:3.10.20.90:FF:000001', NULL, NULL, 'Probable polyubiquitin', NULL, NULL, NULL, NULL, NULL, 4),
(43480, NULL, 'G3DSA:1.20.1250.20:FF:000207', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(43481, NULL, 'G3DSA:3.10.180.10:FF:000099', NULL, NULL, 'Glyoxalase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(43482, NULL, 'G3DSA:3.30.1370.10:FF:000193', NULL, NULL, 'High density lipoprotein-binding protein a', NULL, NULL, NULL, NULL, NULL, 4),
(43483, NULL, 'G3DSA:1.10.287.80:FF:000015', NULL, NULL, 'ATP synthase gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(43484, NULL, 'G3DSA:4.10.280.10:FF:000125', NULL, NULL, 'Transcription factor EGL1', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(43485, NULL, 'G3DSA:1.10.274.10:FF:000004', NULL, NULL, 'Phosphotransferase system fructose-specific transporter subunit EI/HPr/EIIA', NULL, NULL, NULL, NULL, NULL, 4),
(43486, NULL, 'G3DSA:1.20.58.340:FF:000025', NULL, NULL, 'CorA Metal Ion Transporter (MIT) Family', NULL, NULL, NULL, NULL, NULL, 4),
(43487, NULL, 'G3DSA:3.30.160.60:FF:001917', NULL, NULL, 'Zinc finger and SCAN domain containing 10', NULL, NULL, NULL, NULL, NULL, 4),
(43488, NULL, 'G3DSA:3.40.50.300:FF:003868', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43489, NULL, 'G3DSA:1.25.40.20:FF:001717', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43490, NULL, 'G3DSA:1.20.1070.10:FF:001213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43491, NULL, 'G3DSA:1.10.565.10:FF:000186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43492, NULL, 'G3DSA:1.20.5.170:FF:000036', NULL, NULL, 'ABSCISIC ACID-INSENSITIVE 5-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(43493, NULL, 'G3DSA:1.25.10.10:FF:001151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43494, NULL, 'G3DSA:3.40.449.10:FF:000003', NULL, NULL, 'Phosphoenolpyruvate carboxykinase, cytosolic [GTP]', NULL, NULL, NULL, NULL, NULL, 4),
(43495, NULL, 'G3DSA:2.170.16.10:FF:000030', NULL, NULL, 'Transcriptional regulator, XRE family', NULL, NULL, NULL, NULL, NULL, 4),
(43496, NULL, 'G3DSA:3.30.160.60:FF:001861', NULL, NULL, 'Protein tramtrack, beta isoform', NULL, NULL, NULL, NULL, NULL, 4),
(43497, NULL, 'G3DSA:3.10.20.30:FF:000062', NULL, NULL, 'Sulfur carrier protein ThiS', NULL, NULL, NULL, NULL, NULL, 4),
(43498, NULL, 'G3DSA:1.25.40.10:FF:000079', NULL, NULL, 'WD and tetratricopeptide repeats protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(43499, NULL, 'G3DSA:1.20.120.1750:FF:000038', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(43500, NULL, 'G3DSA:3.30.70.330:FF:001175', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein A3', NULL, NULL, NULL, NULL, NULL, 4),
(43501, NULL, 'G3DSA:1.25.40.20:FF:001661', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43502, NULL, 'G3DSA:1.20.58.390:FF:000107', NULL, NULL, 'AcetylCholine Receptor', NULL, NULL, NULL, NULL, NULL, 4),
(43503, NULL, 'G3DSA:2.30.130.10:FF:000033', NULL, NULL, 'Ribosome biogenesis protein NIP7, putative', NULL, NULL, NULL, NULL, NULL, 4),
(43504, NULL, 'G3DSA:3.10.50.40:FF:000100', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(43505, NULL, 'G3DSA:1.20.140.10:FF:000034', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(43506, NULL, 'G3DSA:1.20.1250.20:FF:001427', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(43507, NULL, 'G3DSA:4.10.60.10:FF:000163', NULL, NULL, 'Vasa', NULL, NULL, NULL, NULL, NULL, 4),
(43508, NULL, 'G3DSA:3.30.450.20:FF:000663', NULL, NULL, 'PAS sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(43509, NULL, 'G3DSA:1.20.58.390:FF:000051', NULL, NULL, 'Cholinergic receptor, nicotinic, alpha 6', NULL, NULL, NULL, NULL, NULL, 4),
(43510, NULL, 'G3DSA:3.40.228.10:FF:000001', NULL, NULL, 'Periplasmic nitrate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(43511, NULL, 'G3DSA:2.70.20.10:FF:000016', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(43512, NULL, 'G3DSA:1.10.472.10:FF:000234', NULL, NULL, 'Cyclin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(43513, NULL, 'G3DSA:3.80.10.10:FF:003560', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43514, NULL, 'G3DSA:2.70.50.40:FF:000004', NULL, NULL, 'protein unc-119 homolog A isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(43515, NULL, 'G3DSA:2.60.120.260:FF:000647', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43516, NULL, 'G3DSA:3.30.200.20:FF:001460', NULL, NULL, 'TUBE', NULL, NULL, NULL, NULL, NULL, 4),
(43517, NULL, 'G3DSA:1.10.340.30:FF:000013', NULL, NULL, 'DNA-3-methyladenine glycosylase II', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(43518, NULL, 'G3DSA:1.20.1510.10:FF:000096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43519, NULL, 'G3DSA:1.10.10.440:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43520, NULL, 'G3DSA:1.20.120.790:FF:000013', NULL, NULL, 'Heat shock protein 90, putative', NULL, NULL, NULL, NULL, NULL, 4),
(43521, NULL, 'G3DSA:3.30.420.10:FF:000153', NULL, NULL, 'Bifunctional RNase H/acid phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(43522, NULL, 'G3DSA:1.20.5.110:FF:000125', NULL, NULL, 'Vesicule-associated membrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(43523, NULL, 'G3DSA:2.10.25.10:FF:001042', NULL, NULL, 'HL01444p', NULL, NULL, NULL, NULL, NULL, 4),
(43524, NULL, 'G3DSA:3.90.1480.20:FF:000050', NULL, NULL, 'ST3 beta-galactoside alpha-2,3-sialyltransferase 3a', NULL, NULL, NULL, NULL, NULL, 4),
(43525, NULL, 'G3DSA:3.40.50.12470:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43526, NULL, 'G3DSA:1.20.140.80:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43527, NULL, 'G3DSA:1.10.510.10:FF:004461', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43528, NULL, 'G3DSA:2.60.40.1180:FF:000204', NULL, NULL, 'Alpha-L-fucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(43529, NULL, 'G3DSA:3.90.1770.10:FF:000001', NULL, NULL, 'acetyl-CoA carboxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(43530, NULL, 'G3DSA:3.40.50.1000:FF:000351', NULL, NULL, 'Trehalose-6-phosphatase synthase S4', NULL, NULL, NULL, NULL, NULL, 4),
(43531, NULL, 'G3DSA:3.40.605.10:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43532, NULL, 'G3DSA:1.20.140.100:FF:000007', NULL, NULL, 'Dynein axonemal heavy chain 9', NULL, NULL, NULL, NULL, NULL, 4),
(43533, NULL, 'G3DSA:2.70.220.10:FF:000003', NULL, NULL, 'NPC2p protein', NULL, NULL, NULL, NULL, NULL, 4),
(43534, NULL, 'G3DSA:1.10.1060.10:FF:000001', NULL, NULL, 'Succinate dehydrogenase iron-sulfur subunit SdhB', NULL, NULL, NULL, NULL, NULL, 4),
(43535, NULL, 'G3DSA:2.40.128.20:FF:000068', NULL, NULL, 'Heart-type fatty acid-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(43536, NULL, 'G3DSA:3.40.50.720:FF:001196', NULL, NULL, 'Fluoren-9-ol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(43537, NULL, 'G3DSA:3.20.20.70:FF:000793', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43538, NULL, 'G3DSA:3.40.50.300:FF:001098', NULL, NULL, 'Cytochrome c biogenesis ATP-binding export protein CcmA', NULL, NULL, NULL, NULL, NULL, 4),
(43539, NULL, 'G3DSA:3.40.1110.10:FF:000430', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43540, NULL, 'G3DSA:1.10.510.10:FF:001324', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(43541, NULL, 'G3DSA:1.10.260.30:FF:000012', NULL, NULL, 'Signal recognition particle 54 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(43542, NULL, 'G3DSA:2.40.50.90:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43543, NULL, 'G3DSA:3.90.226.10:FF:000261', NULL, NULL, 'Bifunctional fatty acid oxidation enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(43544, NULL, 'G3DSA:1.20.1440.170:FF:000002', NULL, NULL, 'TMA16p protein', NULL, NULL, NULL, NULL, NULL, 4),
(43545, NULL, 'G3DSA:3.80.10.10:FF:000895', NULL, NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(43546, NULL, 'G3DSA:1.25.10.10:FF:001679', NULL, NULL, 'AGAP010793-PA', NULL, NULL, NULL, NULL, NULL, 4),
(43547, NULL, 'G3DSA:3.30.70.1390:FF:000015', NULL, NULL, 'Roco10, ROCO family protein', NULL, NULL, NULL, NULL, NULL, 4),
(43548, NULL, 'G3DSA:1.10.287.370:FF:000018', NULL, NULL, 'Prefoldin, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(43549, NULL, 'G3DSA:2.30.30.40:FF:000033', NULL, NULL, 'FCH and double SH3 domains protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(43550, NULL, 'G3DSA:1.25.40.120:FF:000006', NULL, NULL, 'Geranylgeranyl transferase type-2 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(43551, NULL, 'G3DSA:1.20.1250.20:FF:001899', NULL, NULL, 'Slc2A8 protein, putative', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(43552, NULL, 'G3DSA:2.160.10.10:FF:000040', NULL, NULL, 'UDP-2-acetamido-3-amino-2,3-dideoxy-glucuronate N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(43553, NULL, 'G3DSA:1.25.40.10:FF:002849', NULL, NULL, 'Putative TPR repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(43554, NULL, 'G3DSA:2.130.10.10:FF:001772', NULL, NULL, 'WD-repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(43555, NULL, 'G3DSA:3.20.20.80:FF:000211', NULL, NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(43556, NULL, 'G3DSA:3.10.129.10:FF:000143', NULL, NULL, 'Putative esterase MT1895', NULL, NULL, NULL, NULL, NULL, 4),
(43557, NULL, 'G3DSA:3.40.50.150:FF:001772', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43558, NULL, 'G3DSA:2.40.10.10:FF:000202', NULL, NULL, 'Granzyme H', NULL, NULL, NULL, NULL, NULL, 4),
(43559, NULL, 'G3DSA:3.40.850.10:FF:000418', NULL, NULL, 'ATP binding microtubule motor family protein', NULL, NULL, NULL, NULL, NULL, 4),
(43560, NULL, 'G3DSA:1.25.10.10:FF:002140', NULL, NULL, 'AP-3 complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(43561, NULL, 'G3DSA:3.30.470.30:FF:000050', NULL, NULL, 'mRNA-capping enzyme subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(43562, NULL, 'G3DSA:3.50.30.30:FF:000004', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(43563, NULL, 'G3DSA:1.20.1560.10:FF:000571', NULL, NULL, 'Phosphatidylcholine translocator ABCB4', NULL, NULL, NULL, NULL, NULL, 4),
(43564, NULL, 'G3DSA:1.20.1050.20:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43565, NULL, 'G3DSA:3.40.50.11530:FF:000007', NULL, NULL, 'adapter protein CIKS isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(43566, NULL, 'G3DSA:2.30.39.10:FF:000038', NULL, NULL, 'Os01g0267300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(43567, NULL, 'G3DSA:3.40.140.10:FF:000090', NULL, NULL, 'Cytidine deoxycytidylate deaminase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(43568, NULL, 'G3DSA:3.30.160.60:FF:003042', NULL, NULL, 'Transcription factor che-1', NULL, NULL, NULL, NULL, NULL, 4),
(43569, NULL, 'G3DSA:3.40.1390.30:FF:000017', NULL, NULL, 'Nif3-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(43570, NULL, 'G3DSA:1.10.10.60:FF:001053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43571, NULL, 'G3DSA:3.50.50.60:FF:000133', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(43572, NULL, 'G3DSA:3.30.160.60:FF:004470', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43573, NULL, 'G3DSA:2.60.40.790:FF:000112', NULL, NULL, '17.4 kDa class III heat shock protein', NULL, NULL, NULL, NULL, NULL, 4),
(43574, NULL, 'G3DSA:3.30.1240.10:FF:000037', NULL, NULL, 'Haloacid dehalogenase-like hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(43575, NULL, 'G3DSA:2.60.40.10:FF:005155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43576, NULL, 'G3DSA:1.10.510.10:FF:000599', NULL, NULL, 'Serine/threonine-protein kinase Aurora-1', NULL, NULL, NULL, NULL, NULL, 4),
(43577, NULL, 'G3DSA:2.30.30.140:FF:000006', NULL, NULL, 'DNA (Cytosine-5)-methyltransferase 3B isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(43578, NULL, 'G3DSA:3.80.10.10:FF:003649', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43579, NULL, 'G3DSA:1.10.555.10:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43580, NULL, 'G3DSA:2.30.29.30:FF:001123', NULL, NULL, 'mRNA-decapping enzyme subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(43581, NULL, 'G3DSA:1.20.58.1220:FF:000012', NULL, NULL, 'Exocyst complex component EXO84', NULL, NULL, NULL, NULL, NULL, 4),
(43582, NULL, 'G3DSA:3.40.50.150:FF:000344', NULL, NULL, 'Blast:Calmodulin-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(43583, NULL, 'G3DSA:1.10.2080.10:FF:000002', NULL, NULL, 'GD24980', NULL, NULL, NULL, NULL, NULL, 4),
(43584, NULL, 'G3DSA:3.40.50.12090:FF:000001', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(43585, NULL, 'G3DSA:2.130.10.10:FF:005987', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(43586, NULL, 'G3DSA:1.10.8.60:FF:000377', NULL, NULL, 'ATP-dependent 26S proteasome regulatory subunit Posttranslational modification protein', NULL, NULL, NULL, NULL, NULL, 4),
(43587, NULL, 'G3DSA:1.10.10.1550:FF:000001', NULL, NULL, 'MucR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(43588, NULL, 'G3DSA:3.30.230.130:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43589, NULL, 'G3DSA:1.20.1270.60:FF:000142', NULL, NULL, 'Rho GTPase-activating protein 92B', NULL, NULL, NULL, NULL, NULL, 4),
(43590, NULL, 'G3DSA:3.80.10.10:FF:000215', NULL, NULL, 'Receptor-like protein kinase HSL1', NULL, NULL, NULL, NULL, NULL, 4),
(43591, NULL, 'G3DSA:3.40.50.11020:FF:000001', NULL, NULL, 'Orf1a polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(43592, NULL, 'G3DSA:3.40.50.720:FF:001460', NULL, NULL, 'Putative UDP-glucose 6-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(43593, NULL, 'G3DSA:2.130.10.10:FF:000344', NULL, NULL, 'Protein NEDD1', NULL, NULL, NULL, NULL, NULL, 4),
(43594, NULL, 'G3DSA:3.40.50.300:FF:003284', NULL, NULL, 'Rab family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(43595, NULL, 'G3DSA:3.80.10.10:FF:002132', NULL, NULL, 'Receptor-like protein 55', NULL, NULL, NULL, NULL, NULL, 4),
(43596, NULL, 'G3DSA:3.40.1380.20:FF:000042', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(43597, NULL, 'G3DSA:1.20.120.310:FF:000004', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(43598, NULL, 'G3DSA:2.60.40.10:FF:000220', NULL, NULL, 'X-linked interleukin-1 receptor accessory protein-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(43599, NULL, 'G3DSA:3.90.70.10:FF:000522', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(43600, NULL, 'G3DSA:3.40.1280.10:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43601, NULL, 'G3DSA:2.130.10.10:FF:005279', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43602, NULL, 'G3DSA:3.40.1500.10:FF:000010', NULL, NULL, 'Oxygen-dependent coproporphyrinogen-III oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(43603, NULL, 'G3DSA:1.10.10.60:FF:000333', NULL, NULL, 'Fis family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(43604, NULL, 'G3DSA:1.10.287.70:FF:000366', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43605, NULL, 'G3DSA:3.30.160.60:FF:005812', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43606, NULL, 'G3DSA:3.40.830.10:FF:000002', NULL, NULL, 'MEMO1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(43607, NULL, 'G3DSA:3.60.40.10:FF:000206', NULL, NULL, 'Stage II sporulation E family protein', NULL, NULL, NULL, NULL, NULL, 4),
(43608, NULL, 'G3DSA:1.10.10.520:FF:000012', NULL, NULL, 'SUMO-activating enzyme subunit', NULL, NULL, NULL, NULL, NULL, 4),
(43609, NULL, 'G3DSA:1.25.10.10:FF:000431', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(43610, NULL, 'G3DSA:3.30.300.160:FF:000002', NULL, NULL, 'Type II secretion system protein E', NULL, NULL, NULL, NULL, NULL, 4),
(43611, NULL, 'G3DSA:2.30.180.10:FF:000183', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43612, NULL, 'G3DSA:1.20.1250.20:FF:000651', NULL, NULL, 'Glutathione uptake transporter', NULL, NULL, NULL, NULL, NULL, 4),
(43613, NULL, 'G3DSA:1.10.132.60:FF:000033', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(43614, NULL, 'G3DSA:3.90.550.10:FF:000087', NULL, NULL, 'Glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(43615, NULL, 'G3DSA:1.20.870.10:FF:000011', NULL, NULL, 'RAS guanyl-releasing protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(43616, NULL, 'G3DSA:3.30.2130.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43617, NULL, 'G3DSA:2.40.30.10:FF:000524', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43618, NULL, 'G3DSA:3.30.710.10:FF:000164', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(43619, NULL, 'G3DSA:3.80.10.10:FF:002840', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43620, NULL, 'G3DSA:3.30.70.330:FF:000983', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43621, NULL, 'G3DSA:3.40.50.150:FF:000136', NULL, NULL, 'tRNA (Adenine(22)-N(1))-methyltransferase TrmK', NULL, NULL, NULL, NULL, NULL, 4),
(43622, NULL, 'G3DSA:2.10.25.10:FF:000850', NULL, NULL, 'Pro-epidermal growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(43623, NULL, 'G3DSA:3.30.40.10:FF:000949', NULL, NULL, 'Zinc finger, C3HC4 type (RING finger) domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(43624, NULL, 'G3DSA:3.40.50.1820:FF:001518', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43625, NULL, 'G3DSA:2.130.10.10:FF:001064', NULL, NULL, 'Tricorn protease homolog', NULL, NULL, NULL, NULL, NULL, 4),
(43626, NULL, 'G3DSA:4.10.240.10:FF:000179', NULL, NULL, 'Putative transcription factor with C2H2 and Zn(2)-Cys(6) DNA binding domain (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(43627, NULL, 'G3DSA:2.60.40.10:FF:004874', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43628, NULL, 'G3DSA:3.30.420.40:FF:001038', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43629, NULL, 'G3DSA:3.20.20.60:FF:000025', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(43630, NULL, 'G3DSA:1.20.5.110:FF:000333', NULL, NULL, 'Syntaxin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(43631, NULL, 'G3DSA:1.10.8.60:FF:000113', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(43632, NULL, 'G3DSA:3.40.20.10:FF:000072', NULL, NULL, 'Villin-1', NULL, NULL, NULL, NULL, NULL, 4),
(43633, NULL, 'G3DSA:3.80.10.10:FF:001204', NULL, NULL, 'F-box/leucine rich repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(43634, NULL, 'G3DSA:1.25.40.10:FF:004997', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(43635, NULL, 'G3DSA:1.25.40.20:FF:001397', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43636, NULL, 'G3DSA:1.20.810.10:FF:000035', NULL, NULL, 'Cytochrome b', NULL, NULL, NULL, NULL, NULL, 4),
(43637, NULL, 'G3DSA:3.40.50.1820:FF:000529', NULL, NULL, 'S10 family peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(43638, NULL, 'G3DSA:3.40.50.10190:FF:000223', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(43639, NULL, 'G3DSA:2.60.120.1440:FF:000001', NULL, NULL, 'Putative anti-sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(43640, NULL, 'G3DSA:1.25.40.20:FF:001509', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43641, NULL, 'G3DSA:4.10.400.10:FF:000214', NULL, NULL, 'low-density lipoprotein receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(43642, NULL, 'G3DSA:1.10.510.10:FF:004230', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43643, NULL, 'G3DSA:3.40.50.880:FF:000063', NULL, NULL, 'Protein DJ-1 homolog D', NULL, NULL, NULL, NULL, NULL, 4),
(43644, NULL, 'G3DSA:2.120.10.30:FF:000171', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43645, NULL, 'G3DSA:1.25.40.10:FF:002024', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g05670, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(43646, NULL, 'G3DSA:3.20.20.210:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43647, NULL, 'G3DSA:3.10.450.30:FF:000002', NULL, NULL, 'Guanyl-specific ribonuclease T1', NULL, NULL, NULL, NULL, NULL, 4),
(43648, NULL, 'G3DSA:3.40.50.2300:FF:000898', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43649, NULL, 'G3DSA:1.20.1070.10:FF:000696', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(43650, NULL, 'G3DSA:3.40.50.300:FF:002615', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(43651, NULL, 'G3DSA:1.10.3080.10:FF:000031', NULL, NULL, 'Putative chloride channel-like protein CLC-g', NULL, NULL, NULL, NULL, NULL, 4),
(43652, NULL, 'G3DSA:1.20.58.1780:FF:000011', NULL, NULL, 'Nuclear Pore complex Protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(43653, NULL, 'G3DSA:3.30.160.60:FF:004262', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43654, NULL, 'G3DSA:3.90.1410.10:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43655, NULL, 'G3DSA:3.40.50.300:FF:002879', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(43656, NULL, 'G3DSA:3.90.360.10:FF:000016', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(43657, NULL, 'G3DSA:3.90.1430.10:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43658, NULL, 'G3DSA:2.40.30.30:FF:000035', NULL, NULL, 'Riboflavin kinase/fmn adenylyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(43659, NULL, 'G3DSA:2.60.120.200:FF:000383', NULL, NULL, 'GM25102', NULL, NULL, NULL, NULL, NULL, 4),
(43660, NULL, 'G3DSA:1.25.70.10:FF:000019', NULL, NULL, 'mTERF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(43661, NULL, 'G3DSA:1.10.630.10:FF:000815', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43662, NULL, 'G3DSA:3.80.10.10:FF:003913', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', NULL, NULL, NULL, NULL, NULL, 4),
(43663, NULL, 'G3DSA:3.40.50.1380:FF:000032', NULL, NULL, 'Bifunctional purine biosynthesis protein PURH', NULL, NULL, NULL, NULL, NULL, 4),
(43664, NULL, 'G3DSA:1.10.510.10:FF:000335', NULL, NULL, 'receptor-like cytosolic serine/threonine-protein kinase RBK2', NULL, NULL, NULL, NULL, NULL, 4),
(43665, NULL, 'G3DSA:2.60.40.10:FF:006111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43666, NULL, 'G3DSA:3.40.50.200:FF:000174', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43667, NULL, 'G3DSA:3.60.40.10:FF:000145', NULL, NULL, 'PPM1A isoform 7', NULL, NULL, NULL, NULL, NULL, 4),
(43668, NULL, 'G3DSA:3.40.50.10190:FF:000162', NULL, NULL, 'Pescadillo homolog', NULL, NULL, NULL, NULL, NULL, 4),
(43669, NULL, 'G3DSA:1.25.40.20:FF:001009', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43670, NULL, 'G3DSA:1.25.40.10:FF:001771', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g26782, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(43671, NULL, 'G3DSA:3.40.33.10:FF:000079', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43672, NULL, 'G3DSA:3.40.720.10:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43673, NULL, 'G3DSA:3.40.50.2000:FF:001123', NULL, NULL, 'Glycogen [starch] synthase', NULL, NULL, NULL, NULL, NULL, 4),
(43674, NULL, 'G3DSA:1.10.8.10:FF:000059', NULL, NULL, 'Lingerer, isoform I', NULL, NULL, NULL, NULL, NULL, 4),
(43675, NULL, 'G3DSA:2.60.40.10:FF:004166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43676, NULL, 'G3DSA:3.20.70.20:FF:000011', NULL, NULL, 'Formate acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(43677, NULL, 'G3DSA:3.40.640.10:FF:000083', NULL, NULL, 'Selenocysteine lyase', NULL, NULL, NULL, NULL, NULL, 4),
(43678, NULL, 'G3DSA:3.10.150.10:FF:000007', NULL, NULL, 'Beta sliding clamp', NULL, NULL, NULL, NULL, NULL, 4),
(43679, NULL, 'G3DSA:2.60.40.2440:FF:000003', NULL, NULL, 'protein phosphatase 1 regulatory subunit 3F isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(43680, NULL, 'G3DSA:1.20.1740.10:FF:000017', NULL, NULL, 'Amino acid permease', NULL, NULL, NULL, NULL, NULL, 4),
(43681, NULL, 'G3DSA:2.120.10.10:FF:000013', NULL, NULL, 'Sialidase', NULL, NULL, NULL, NULL, NULL, 4),
(43682, NULL, 'G3DSA:3.40.50.720:FF:000532', NULL, NULL, 'SLOwpoke potassium channel family', NULL, NULL, NULL, NULL, NULL, 4),
(43683, NULL, 'G3DSA:3.30.160.60:FF:004823', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43684, NULL, 'G3DSA:3.30.160.60:FF:002053', NULL, NULL, 'C2H2 finger domain protein (Gli3)', NULL, NULL, NULL, NULL, NULL, 4),
(43685, NULL, 'G3DSA:2.120.10.30:FF:000019', NULL, NULL, 'Low-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(43686, NULL, 'G3DSA:3.40.1090.10:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(43687, NULL, 'G3DSA:1.25.40.10:FF:003805', NULL, NULL, 'DAP3-binding cell death enhancer 1', NULL, NULL, NULL, NULL, NULL, 4),
(43688, NULL, 'G3DSA:3.20.20.100:FF:000199', NULL, NULL, 'Aldo-keto reductase family 1, member C19', NULL, NULL, NULL, NULL, NULL, 4),
(43689, NULL, 'G3DSA:2.130.10.10:FF:001564', NULL, NULL, 'Vacuolar protein sorting/targeting protein PEP1', NULL, NULL, NULL, NULL, NULL, 4),
(43690, NULL, 'G3DSA:3.30.497.10:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43691, NULL, 'G3DSA:1.10.510.10:FF:001588', NULL, NULL, 'Protein CBG04908', NULL, NULL, NULL, NULL, NULL, 4),
(43692, NULL, 'G3DSA:1.20.1250.20:FF:001635', NULL, NULL, 'Glucose transporter GLUT4', NULL, NULL, NULL, NULL, NULL, 4),
(43693, NULL, 'G3DSA:3.90.79.10:FF:000103', NULL, NULL, 'MutT/nudix family protein', NULL, NULL, NULL, NULL, NULL, 4),
(43694, NULL, 'G3DSA:2.130.10.10:FF:004998', NULL, NULL, 'Notchless-like protein isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(43695, NULL, 'G3DSA:2.60.40.3210:FF:000010', NULL, NULL, 'Transforming growth factor beta receptor type 3', NULL, NULL, NULL, NULL, NULL, 4),
(43696, NULL, 'G3DSA:3.30.420.40:FF:000521', NULL, NULL, 'Actin-related protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(43697, NULL, 'G3DSA:2.60.200.30:FF:000004', NULL, NULL, 'NAD kinase 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(43698, NULL, 'G3DSA:3.40.50.1820:FF:000681', NULL, NULL, 'Siderophore esterase IroE-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(43699, NULL, 'G3DSA:3.80.10.10:FF:001143', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM2', NULL, NULL, NULL, NULL, NULL, 4),
(43700, NULL, 'G3DSA:3.50.50.60:FF:000958', NULL, NULL, 'Sarcosine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(43701, NULL, 'G3DSA:2.170.270.10:FF:000089', NULL, NULL, 'N-lysine methyltransferase SMYD2', NULL, NULL, NULL, NULL, NULL, 4),
(43702, NULL, 'G3DSA:3.60.21.10:FF:000022', NULL, NULL, 'Putative metallophosphoesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(43703, NULL, 'G3DSA:1.25.10.10:FF:003157', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(43704, NULL, 'G3DSA:3.90.180.10:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43705, NULL, 'G3DSA:3.40.50.410:FF:000203', NULL, NULL, 'KU80 protein', NULL, NULL, NULL, NULL, NULL, 4),
(43706, NULL, 'G3DSA:3.80.10.10:FF:002632', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43707, NULL, 'G3DSA:3.40.50.300:FF:004324', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43708, NULL, 'G3DSA:3.30.70.1730:FF:000016', NULL, NULL, 'Related to ribosomal protein YmL11, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(43709, NULL, 'G3DSA:3.40.50.1110:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43710, NULL, 'G3DSA:3.30.40.10:FF:001613', NULL, NULL, 'Pre-mRNA-splicing factor CWC24', NULL, NULL, NULL, NULL, NULL, 4),
(43711, NULL, 'G3DSA:2.40.110.10:FF:000064', NULL, NULL, 'Acyl-CoA dehydrogenase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(43712, NULL, 'G3DSA:1.10.405.20:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43713, NULL, 'G3DSA:2.10.25.10:FF:000586', NULL, NULL, 'EGF, latrophilin seven transmembrane domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(43714, NULL, 'G3DSA:1.10.630.10:FF:000462', NULL, NULL, 'Cytochrome P-450 IIC4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(43715, NULL, 'G3DSA:2.130.10.10:FF:005779', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43716, NULL, 'G3DSA:1.20.1070.10:FF:002141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43717, NULL, 'G3DSA:2.70.130.10:FF:000176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43718, NULL, 'G3DSA:1.10.30.10:FF:000073', NULL, NULL, 'High mobility group protein 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(43719, NULL, 'G3DSA:1.20.120.1150:FF:000010', NULL, NULL, 'Serine/threonine-protein phosphatase 2A activator', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(43720, NULL, 'G3DSA:3.90.550.10:FF:000351', NULL, NULL, 'Glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(43721, NULL, 'G3DSA:3.60.110.10:FF:000100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43722, NULL, 'G3DSA:1.10.10.10:FF:000835', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(43723, NULL, 'G3DSA:3.40.50.10810:FF:000180', NULL, NULL, 'Snf2 family helicase', NULL, NULL, NULL, NULL, NULL, 4),
(43724, NULL, 'G3DSA:2.60.120.650:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43725, NULL, 'G3DSA:3.40.30.40:FF:000002', NULL, NULL, 'Thiol-activated cytolysin', NULL, NULL, NULL, NULL, NULL, 4),
(43726, NULL, 'G3DSA:3.30.40.10:FF:000449', NULL, NULL, 'General transcription factor IIH subunit', NULL, NULL, NULL, NULL, NULL, 4),
(43727, NULL, 'G3DSA:3.30.160.60:FF:002114', NULL, NULL, 'zinc finger protein 133 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(43728, NULL, 'G3DSA:1.10.285.10:FF:000001', NULL, NULL, 'Glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(43729, NULL, 'G3DSA:1.10.150.50:FF:000077', NULL, NULL, 'DDHD domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(43730, NULL, 'G3DSA:1.20.1070.10:FF:001921', NULL, NULL, 'Serpentine Receptor, class SX', NULL, NULL, NULL, NULL, NULL, 4),
(43731, NULL, 'G3DSA:1.20.58.2220:FF:000003', NULL, NULL, 'protein diaphanous homolog 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(43732, NULL, 'G3DSA:3.90.550.10:FF:000407', NULL, NULL, 'Glycosyl transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(43733, NULL, 'G3DSA:3.40.50.12780:FF:000079', NULL, NULL, 'Capsule biosynthesis protein CapK', NULL, NULL, NULL, NULL, NULL, 4),
(43734, NULL, 'G3DSA:1.10.630.10:FF:000315', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43735, NULL, 'G3DSA:3.40.50.1820:FF:000029', NULL, NULL, 'Acetylcholinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(43736, NULL, 'G3DSA:1.10.10.10:FF:002016', NULL, NULL, 'Putative marR-family regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(43737, NULL, 'G3DSA:3.40.50.10190:FF:000015', NULL, NULL, 'protein ECT2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(43738, NULL, 'G3DSA:1.10.10.60:FF:000272', NULL, NULL, 'zinc fingers and homeoboxes protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(43739, NULL, 'G3DSA:1.10.510.10:FF:000099', NULL, NULL, 'Serine/threonine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(43740, NULL, 'G3DSA:3.30.70.330:FF:000247', NULL, NULL, 'Multiple RNA-binding domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(43741, NULL, 'G3DSA:2.40.50.1070:FF:000018', NULL, NULL, 'RNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(43742, NULL, 'G3DSA:3.40.50.300:FF:005549', NULL, NULL, 'DNA repair helicase Rad3', NULL, NULL, NULL, NULL, NULL, 4),
(43743, NULL, 'G3DSA:2.60.200.20:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43744, NULL, 'G3DSA:4.10.280.110:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43745, NULL, 'G3DSA:1.10.20.10:FF:000044', NULL, NULL, 'Histone H3.3', NULL, NULL, NULL, NULL, NULL, 4),
(43746, NULL, 'G3DSA:3.40.50.410:FF:000091', NULL, NULL, 'General transcription factor IIH subunit', NULL, NULL, NULL, NULL, NULL, 4),
(43747, NULL, 'G3DSA:2.130.10.10:FF:004026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43748, NULL, 'G3DSA:1.25.40.10:FF:000843', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(43749, NULL, 'G3DSA:3.30.160.60:FF:003542', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43750, NULL, 'G3DSA:1.20.58.60:FF:000370', NULL, NULL, 'AcTiniN', NULL, NULL, NULL, NULL, NULL, 4),
(43751, NULL, 'G3DSA:3.90.70.80:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43752, NULL, 'G3DSA:2.130.10.10:FF:003834', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43753, NULL, 'G3DSA:3.40.50.720:FF:001813', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(43754, NULL, 'G3DSA:3.30.60.30:FF:000081', NULL, NULL, 'AGRin (Synaptic protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(43755, NULL, 'G3DSA:1.10.1450.10:FF:000076', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(43756, NULL, 'G3DSA:3.90.70.10:FF:000258', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 32', NULL, NULL, NULL, NULL, NULL, 4),
(43757, NULL, 'G3DSA:3.30.750.24:FF:000180', NULL, NULL, 'Solute carrier family 26 member 9', NULL, NULL, NULL, NULL, NULL, 4),
(43758, NULL, 'G3DSA:3.10.20.90:FF:000681', NULL, NULL, 'ISG15 ubiquitin-like modifier', NULL, NULL, NULL, NULL, NULL, 4),
(43759, NULL, 'G3DSA:2.130.10.10:FF:004498', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43760, NULL, 'G3DSA:1.10.1200.10:FF:000176', NULL, NULL, 'Polyketide synthase/nonribosomal peptide synthetase hybrid RzxA', NULL, NULL, NULL, NULL, NULL, 4),
(43761, NULL, 'G3DSA:2.80.10.50:FF:000246', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(43762, NULL, 'G3DSA:1.20.900.10:FF:000126', NULL, NULL, 'Kalirin RhoGEF kinase a', NULL, NULL, NULL, NULL, NULL, 4),
(43763, NULL, 'G3DSA:1.20.1070.10:FF:000432', NULL, NULL, 'Mas-related G protein-coupled receptor D', NULL, NULL, NULL, NULL, NULL, 4),
(43764, NULL, 'G3DSA:1.25.40.10:FF:003305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43765, NULL, 'G3DSA:2.40.50.180:FF:000014', NULL, NULL, 'Probable chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(43766, NULL, 'G3DSA:3.40.50.170:FF:000030', NULL, NULL, 'Phosphoribosylglycinamide formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(43767, NULL, 'G3DSA:1.25.40.10:FF:003569', NULL, NULL, 'Adenylate/guanylate cyclase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(43768, NULL, 'G3DSA:3.40.50.620:FF:000648', NULL, NULL, 'Os02g0814900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(43769, NULL, 'G3DSA:3.30.830.10:FF:000291', NULL, NULL, 'Clan ME, family M16, insulinase-like metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(43770, NULL, 'G3DSA:3.40.30.10:FF:000718', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(43771, NULL, 'G3DSA:1.25.40.320:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43772, NULL, 'G3DSA:3.60.10.10:FF:000317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43773, NULL, 'G3DSA:3.10.280.10:FF:000016', NULL, NULL, 'Putative p22 protein', NULL, NULL, NULL, NULL, NULL, 4),
(43774, NULL, 'G3DSA:1.20.1560.10:FF:000099', NULL, NULL, 'ABC transporter ATP-binding protein/permease', NULL, NULL, NULL, NULL, NULL, 4),
(43775, NULL, 'G3DSA:2.30.29.30:FF:001387', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(43776, NULL, 'G3DSA:1.20.58.190:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43777, NULL, 'G3DSA:3.30.40.10:FF:000596', NULL, NULL, 'FYVE zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(43778, NULL, 'G3DSA:2.130.10.10:FF:003981', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43779, NULL, 'G3DSA:2.160.20.10:FF:000130', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(43780, NULL, 'G3DSA:3.40.50.150:FF:001064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43781, NULL, 'G3DSA:1.10.1520.10:FF:000048', NULL, NULL, 'Ribonuclease 3', NULL, NULL, NULL, NULL, NULL, 4),
(43782, NULL, 'G3DSA:3.90.1180.10:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43783, NULL, 'G3DSA:3.30.710.10:FF:000372', NULL, NULL, 'Kruppel-like zinc-finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(43784, NULL, 'G3DSA:3.60.40.10:FF:000353', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43785, NULL, 'G3DSA:3.40.1550.10:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43786, NULL, 'G3DSA:3.40.50.2300:FF:000426', NULL, NULL, 'Eg243628', NULL, NULL, NULL, NULL, NULL, 4),
(43787, NULL, 'G3DSA:3.30.70.100:FF:000116', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(43788, NULL, 'G3DSA:3.10.20.90:FF:000529', NULL, NULL, 'UBX domain-containing protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(43789, NULL, 'G3DSA:2.60.34.10:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43790, NULL, 'G3DSA:1.20.58.1880:FF:000007', NULL, NULL, 'Homeodomain-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(43791, NULL, 'G3DSA:2.130.10.30:FF:000030', NULL, NULL, 'Secretion-regulating guanine nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(43792, NULL, 'G3DSA:3.40.630.30:FF:000240', NULL, NULL, 'GCN5 family acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(43793, NULL, 'G3DSA:1.20.120.350:FF:000168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43794, NULL, 'G3DSA:3.30.43.10:FF:000046', NULL, NULL, 'FAD-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(43795, NULL, 'G3DSA:3.30.200.20:FF:002500', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43796, NULL, 'G3DSA:1.50.40.10:FF:000487', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43797, NULL, 'G3DSA:2.60.40.10:FF:004374', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43798, NULL, 'G3DSA:2.60.40.10:FF:005094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43799, NULL, 'G3DSA:3.80.10.10:FF:004077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43800, NULL, 'G3DSA:3.40.50.720:FF:001549', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43801, NULL, 'G3DSA:3.90.640.10:FF:000178', NULL, NULL, 'Actin4-1', NULL, NULL, NULL, NULL, NULL, 4),
(43802, NULL, 'G3DSA:3.80.10.10:FF:001351', NULL, NULL, 'Leucine-rich repeat receptor protein kinase MSL1', NULL, NULL, NULL, NULL, NULL, 4),
(43803, NULL, 'G3DSA:3.20.20.190:FF:000006', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(43804, NULL, 'G3DSA:3.90.1290.10:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43805, NULL, 'G3DSA:3.30.70.980:FF:000032', NULL, NULL, 'AGAP001629-PA', NULL, NULL, NULL, NULL, NULL, 4),
(43806, NULL, 'G3DSA:1.20.5.340:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43807, NULL, 'G3DSA:3.40.1110.10:FF:000166', NULL, NULL, 'Calcium-transporting P-type ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(43808, NULL, 'G3DSA:3.40.50.300:FF:005493', NULL, NULL, 'ATP-dependent RecD-like DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(43809, NULL, 'G3DSA:3.90.780.10:FF:000008', NULL, NULL, 'Ser/Thr protein phosphatase family', NULL, NULL, NULL, NULL, NULL, 4),
(43810, NULL, 'G3DSA:1.25.40.10:FF:000579', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g39710', NULL, NULL, NULL, NULL, NULL, 4),
(43811, NULL, 'G3DSA:3.10.129.130:FF:000001', NULL, NULL, 'Endoribonuclease ToxN', NULL, NULL, NULL, NULL, NULL, 4),
(43812, NULL, 'G3DSA:3.20.20.70:FF:000585', NULL, NULL, 'Tryptophan synthase', NULL, NULL, NULL, NULL, NULL, 4),
(43813, NULL, 'G3DSA:3.40.50.2000:FF:000926', NULL, NULL, 'ADP-heptose--lipopolysaccharide heptosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(43814, NULL, 'G3DSA:1.10.3860.10:FF:000006', NULL, NULL, 'Dicarboxylate/amino acid:cation symporter', NULL, NULL, NULL, NULL, NULL, 4),
(43815, NULL, 'G3DSA:3.40.190.10:FF:000593', NULL, NULL, 'Glutamate ionotropic receptor NMDA type subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(43816, NULL, 'G3DSA:3.30.70.330:FF:000511', NULL, NULL, 'RNA binding motif protein 34', NULL, NULL, NULL, NULL, NULL, 4),
(43817, NULL, 'G3DSA:1.10.3730.20:FF:000062', NULL, NULL, '10 TMS drug/metabolite efflux pump (DME) family', NULL, NULL, NULL, NULL, NULL, 4),
(43818, NULL, 'G3DSA:1.10.510.10:FF:001824', NULL, NULL, 'Kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(43819, NULL, 'G3DSA:3.40.850.10:FF:000065', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(43820, NULL, 'G3DSA:3.90.1720.30:FF:000004', NULL, NULL, 'PPPDE putative peptidase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(43821, NULL, 'G3DSA:3.30.40.10:FF:001877', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43822, NULL, 'G3DSA:1.10.287.110:FF:000199', NULL, NULL, 'Molecular chaperones (DnaJ family)', NULL, NULL, NULL, NULL, NULL, 4),
(43823, NULL, 'G3DSA:3.30.70.360:FF:000054', NULL, NULL, 'N-carbamoyl-L-amino acid hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(43824, NULL, 'G3DSA:3.30.160.60:FF:001709', NULL, NULL, 'Zelda, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(43825, NULL, 'G3DSA:1.10.510.10:FF:002044', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(43826, NULL, 'G3DSA:2.30.31.10:FF:000009', NULL, NULL, 'activated RNA polymerase II transcriptional coactivator p15-like', NULL, NULL, NULL, NULL, NULL, 4),
(43827, NULL, 'G3DSA:1.20.120.230:FF:000014', NULL, NULL, 'Catenin alpha like 1', NULL, NULL, NULL, NULL, NULL, 4),
(43828, NULL, 'G3DSA:1.20.1560.10:FF:000924', NULL, NULL, 'ABC transporter B family member 29 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(43829, NULL, 'G3DSA:1.20.1250.20:FF:000707', NULL, NULL, 'Sugar transporter', NULL, NULL, NULL, NULL, NULL, 4),
(43830, NULL, 'G3DSA:3.40.50.300:FF:001598', NULL, NULL, 'ABC transporter ced-7', NULL, NULL, NULL, NULL, NULL, 4),
(43831, NULL, 'G3DSA:2.130.10.10:FF:005515', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43832, NULL, 'G3DSA:2.60.40.10:FF:000720', NULL, NULL, 'Platelet-derived growth factor receptor alpha', NULL, NULL, NULL, NULL, NULL, 4),
(43833, NULL, 'G3DSA:3.30.160.60:FF:001597', NULL, NULL, 'Zinc finger protein 222', NULL, NULL, NULL, NULL, NULL, 4),
(43834, NULL, 'G3DSA:1.10.472.10:FF:000442', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43835, NULL, 'G3DSA:3.40.350.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43836, NULL, 'G3DSA:3.80.10.10:FF:000687', NULL, NULL, 'Leucine Rich Repeat family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(43837, NULL, 'G3DSA:2.130.10.10:FF:000283', NULL, NULL, 'WD repeat domain 34', NULL, NULL, NULL, NULL, NULL, 4),
(43838, NULL, 'G3DSA:1.10.2000.10:FF:000082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43839, NULL, 'G3DSA:3.30.160.60:FF:005751', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43840, NULL, 'G3DSA:2.60.40.60:FF:000797', NULL, NULL, 'Cadherin-1', NULL, NULL, NULL, NULL, NULL, 4),
(43841, NULL, 'G3DSA:3.70.10.10:FF:000064', NULL, NULL, 'DNA polymerase sliding clamp 2', NULL, NULL, NULL, NULL, NULL, 4),
(43842, NULL, 'G3DSA:2.60.40.1730:FF:000122', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43843, NULL, 'G3DSA:3.90.550.50:FF:000104', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(43844, NULL, 'G3DSA:2.40.30.10:FF:000288', NULL, NULL, 'NADH-cytochrome b5 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(43845, NULL, 'G3DSA:1.10.238.10:FF:001163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43846, NULL, 'G3DSA:3.30.9.10:FF:000271', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43847, NULL, 'G3DSA:2.30.29.30:FF:000870', NULL, NULL, 'extensin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(43848, NULL, 'G3DSA:1.20.140.40:FF:000077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43849, NULL, 'G3DSA:2.60.120.10:FF:000464', NULL, NULL, 'cGMP-dependent protein kinase 15-1', NULL, NULL, NULL, NULL, NULL, 4),
(43850, NULL, 'G3DSA:3.40.1180.10:FF:000024', NULL, NULL, 'Alkyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(43851, NULL, 'G3DSA:1.10.510.10:FF:001116', NULL, NULL, 'Scy1p', NULL, NULL, NULL, NULL, NULL, 4),
(43852, NULL, 'G3DSA:3.40.50.1820:FF:000737', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(43853, NULL, 'G3DSA:3.30.870.10:FF:000057', NULL, NULL, 'DEAD/DEAH box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(43854, NULL, 'G3DSA:3.40.50.720:FF:000268', NULL, NULL, 'Malate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(43855, NULL, 'G3DSA:2.60.40.10:FF:005655', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(43856, NULL, 'G3DSA:2.60.40.10:FF:003969', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43857, NULL, 'G3DSA:3.40.1050.10:FF:000020', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(43858, NULL, 'G3DSA:2.40.50.690:FF:000015', NULL, NULL, 'RNB domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(43859, NULL, 'G3DSA:1.20.58.120:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43860, NULL, 'G3DSA:3.30.1150.10:FF:000002', NULL, NULL, 'Energy transducer TonB', NULL, NULL, NULL, NULL, NULL, 4),
(43861, NULL, 'G3DSA:3.30.70.270:FF:000268', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43862, NULL, 'G3DSA:3.30.160.60:FF:006268', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43863, NULL, 'G3DSA:3.40.50.80:FF:000021', NULL, NULL, 'Cytochrome b5 reductase 4', NULL, NULL, NULL, NULL, NULL, 4),
(43864, NULL, 'G3DSA:2.60.120.340:FF:000020', NULL, NULL, 'Nucleophosmin 1a', NULL, NULL, NULL, NULL, NULL, 4),
(43865, NULL, 'G3DSA:3.40.50.2300:FF:001354', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43866, NULL, 'G3DSA:2.30.29.30:FF:000459', NULL, NULL, 'Arf-GAP with GTPase, ANK repeat and PH domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(43867, NULL, 'G3DSA:1.10.418.70:FF:000003', NULL, NULL, 'AGAP002293-PA', NULL, NULL, NULL, NULL, NULL, 4),
(43868, NULL, 'G3DSA:3.40.50.10810:FF:000033', NULL, NULL, 'E1A-binding protein p400 isoform X9', NULL, NULL, NULL, NULL, NULL, 4),
(43869, NULL, 'G3DSA:2.30.250.10:FF:000008', NULL, NULL, 'aspartyl aminopeptidase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(43870, NULL, 'G3DSA:1.10.3370.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43871, NULL, 'G3DSA:2.60.40.10:FF:000012', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(43872, NULL, 'G3DSA:2.30.30.40:FF:000533', NULL, NULL, 'AaceriABR082Wp', NULL, NULL, NULL, NULL, NULL, 4),
(43873, NULL, 'G3DSA:2.60.40.1180:FF:000092', NULL, NULL, 'Glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(43874, NULL, 'G3DSA:3.90.550.50:FF:000251', NULL, NULL, 'Mitotic spindle checkpoint protein MAD1', NULL, NULL, NULL, NULL, NULL, 4),
(43875, NULL, 'G3DSA:2.60.120.260:FF:000294', NULL, NULL, 'CocE/NonD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(43876, NULL, 'G3DSA:3.30.900.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43877, NULL, 'G3DSA:1.20.1270.20:FF:000001', NULL, NULL, 'Hydroxylamine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(43878, NULL, 'G3DSA:1.20.1250.20:FF:002096', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(43879, NULL, 'G3DSA:3.30.420.10:FF:000737', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43880, NULL, 'G3DSA:3.40.50.720:FF:002477', NULL, NULL, 'Ubiquitin-activating enzyme E1 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(43881, NULL, 'G3DSA:1.10.575.10:FF:000012', NULL, NULL, 'Endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(43882, NULL, 'G3DSA:2.30.42.10:FF:000237', NULL, NULL, 'AFaDin (Actin filament binding protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(43883, NULL, 'G3DSA:1.10.10.60:FF:000833', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43884, NULL, 'G3DSA:1.25.40.20:FF:000228', NULL, NULL, 'Ankyrin repeat and SOCS box containing 10', NULL, NULL, NULL, NULL, NULL, 4),
(43885, NULL, 'G3DSA:2.60.40.10:FF:003446', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43886, NULL, 'G3DSA:3.80.10.10:FF:003149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43887, NULL, 'G3DSA:1.25.40.10:FF:000282', NULL, NULL, 'Transcriptional corepressor Cyc8', NULL, NULL, NULL, NULL, NULL, 4),
(43888, NULL, 'G3DSA:1.20.1070.10:FF:001360', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43889, NULL, 'G3DSA:1.10.3680.20:FF:000001', NULL, NULL, 'Actin cross-linking toxin VgrG1', NULL, NULL, NULL, NULL, NULL, 4),
(43890, NULL, 'G3DSA:1.10.533.10:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(43891, NULL, 'G3DSA:2.40.50.140:FF:000261', NULL, NULL, 'Putative 30S Ribosomal protein S17', NULL, NULL, NULL, NULL, NULL, 4),
(43892, NULL, 'G3DSA:1.10.150.240:FF:000014', NULL, NULL, 'HAD hydrolase, family IA, variant 1', NULL, NULL, NULL, NULL, NULL, 4),
(43893, NULL, 'G3DSA:3.80.10.10:FF:000423', NULL, NULL, 'Leucine rich repeat containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(43894, NULL, 'G3DSA:3.40.30.10:FF:000870', NULL, NULL, 'Glutaredoxin 3', NULL, NULL, NULL, NULL, NULL, 4),
(43895, NULL, 'G3DSA:3.30.9.10:FF:000124', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(43896, NULL, 'G3DSA:2.60.120.10:FF:000200', NULL, NULL, 'YGR125W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(43897, NULL, 'G3DSA:3.30.160.60:FF:005604', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43898, NULL, 'G3DSA:2.130.10.10:FF:000844', NULL, NULL, 'Elongator acetyltransferase complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(43899, NULL, 'G3DSA:3.20.20.80:FF:000683', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43900, NULL, 'G3DSA:2.130.10.10:FF:000136', NULL, NULL, 'Probable cytosolic iron-sulfur protein assembly protein CIAO1', NULL, NULL, NULL, NULL, NULL, 4),
(43901, NULL, 'G3DSA:3.20.20.70:FF:000438', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43902, NULL, 'G3DSA:1.10.10.10:FF:001763', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC3', NULL, NULL, NULL, NULL, NULL, 4),
(43903, NULL, 'G3DSA:3.40.50.970:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43904, NULL, 'G3DSA:1.10.287.70:FF:000158', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(43905, NULL, 'G3DSA:3.90.25.10:FF:000007', NULL, NULL, 'dTDP-4-dehydrorhamnose reductase', NULL, NULL, NULL, NULL, NULL, 4),
(43906, NULL, 'G3DSA:1.10.10.60:FF:000125', NULL, NULL, 'diencephalon/mesencephalon homeobox protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(43907, NULL, 'G3DSA:1.10.510.10:FF:004258', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43908, NULL, 'G3DSA:1.10.530.40:FF:000002', NULL, NULL, 'Endolysin', NULL, NULL, NULL, NULL, NULL, 4),
(43909, NULL, 'G3DSA:2.60.40.1400:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43910, NULL, 'G3DSA:3.30.1070.10:FF:000001', NULL, NULL, 'Cell division topological specificity factor', NULL, NULL, NULL, NULL, NULL, 4),
(43911, NULL, 'G3DSA:1.20.1070.10:FF:001449', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43912, NULL, 'G3DSA:1.25.10.10:FF:001387', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(43913, NULL, 'G3DSA:3.40.50.200:FF:000197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43914, NULL, 'G3DSA:2.20.70.10:FF:000044', NULL, NULL, 'E3 ubiquitin-protein ligase SMURF2', NULL, NULL, NULL, NULL, NULL, 4),
(43915, NULL, 'G3DSA:2.60.40.10:FF:002660', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(43916, NULL, 'G3DSA:3.10.490.20:FF:000035', NULL, NULL, 'Dynein heavy chain 6, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(43917, NULL, 'G3DSA:2.70.150.10:FF:000059', NULL, NULL, 'ATPase 2 plasma membrane-type', NULL, NULL, NULL, NULL, NULL, 4),
(43918, NULL, 'G3DSA:1.10.510.10:FF:004314', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43919, NULL, 'G3DSA:1.25.40.10:FF:002996', NULL, NULL, 'Intraflagellar transport protein IFT88', NULL, NULL, NULL, NULL, NULL, 4),
(43920, NULL, 'G3DSA:3.50.50.60:FF:001358', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(43921, NULL, 'G3DSA:1.20.58.390:FF:000287', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43922, NULL, 'G3DSA:3.20.20.140:FF:000401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43923, NULL, 'G3DSA:3.40.1190.20:FF:000095', NULL, NULL, 'Fructoselysine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(43924, NULL, 'G3DSA:1.10.1420.10:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(43925, NULL, 'G3DSA:2.40.170.20:FF:000014', NULL, NULL, 'TonB-dependent haem/haemoglobin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(43926, NULL, 'G3DSA:1.10.8.270:FF:000181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43927, NULL, 'G3DSA:3.50.50.60:FF:000902', NULL, NULL, 'Sll0321 protein', NULL, NULL, NULL, NULL, NULL, 4),
(43928, NULL, 'G3DSA:3.60.20.10:FF:000059', NULL, NULL, 'Proteasome subunit alpha type', NULL, NULL, NULL, NULL, NULL, 4),
(43929, NULL, 'G3DSA:2.170.180.11:FF:000004', NULL, NULL, 'GM14282', NULL, NULL, NULL, NULL, NULL, 4),
(43930, NULL, 'G3DSA:3.40.50.10680:FF:000005', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(43931, NULL, 'G3DSA:1.25.10.10:FF:001443', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(43932, NULL, 'G3DSA:3.40.50.150:FF:000491', NULL, NULL, 'Putative siderophore biosysnthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(43933, NULL, 'G3DSA:3.30.499.10:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43934, NULL, 'G3DSA:1.25.10.10:FF:000931', NULL, NULL, 'Pumilio family RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(43935, NULL, 'G3DSA:1.10.10.580:FF:000007', NULL, NULL, 'Sister chromatid cohesion 1 protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(43936, NULL, 'G3DSA:1.20.1070.10:FF:001505', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43937, NULL, 'G3DSA:1.10.268.20:FF:000004', NULL, NULL, 'Sarcoplasmic reticulum glycoprotein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(43938, NULL, 'G3DSA:1.20.120.350:FF:000201', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43939, NULL, 'G3DSA:2.60.210.10:FF:000022', NULL, NULL, 'TRAF-like family protein', NULL, NULL, NULL, NULL, NULL, 4),
(43940, NULL, 'G3DSA:3.40.630.30:FF:000301', NULL, NULL, 'Ribosomal-protein-alanine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(43941, NULL, 'G3DSA:3.40.390.10:FF:000102', NULL, NULL, 'Matrix metalloproteinase 16', NULL, NULL, NULL, NULL, NULL, 4),
(43942, NULL, 'G3DSA:2.60.40.10:FF:002221', NULL, NULL, 'Major histocompatibility complex class I ZKA', NULL, NULL, NULL, NULL, NULL, 4),
(43943, NULL, 'G3DSA:3.20.20.70:FF:000062', NULL, NULL, 'Cytochrome b2, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4),
(43944, NULL, 'G3DSA:3.40.50.300:FF:006241', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43945, NULL, 'G3DSA:1.10.150.370:FF:000002', NULL, NULL, 'Protein her-1', NULL, NULL, NULL, NULL, NULL, 4),
(43946, NULL, 'G3DSA:3.40.50.12690:FF:000001', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43947, NULL, 'G3DSA:3.40.630.30:FF:000296', NULL, NULL, 'N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(43948, NULL, 'G3DSA:1.20.120.290:FF:000009', NULL, NULL, 'Oxygen evolving enhancer protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(43949, NULL, 'G3DSA:3.40.350.10:FF:000100', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43950, NULL, 'G3DSA:3.20.20.60:FF:000109', NULL, NULL, 'HpcH/HpaI aldolase/citrate lyase family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(43951, NULL, 'G3DSA:3.10.20.90:FF:000265', NULL, NULL, 'Ras-associating and dilute domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(43952, NULL, 'G3DSA:1.10.150.60:FF:000018', NULL, NULL, 'AT-rich interactive domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(43953, NULL, 'G3DSA:1.20.58.1280:FF:000007', NULL, NULL, 'DNA repair protein REV1', NULL, NULL, NULL, NULL, NULL, 4),
(43954, NULL, 'G3DSA:3.40.190.10:FF:000418', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(43955, NULL, 'G3DSA:3.40.50.10190:FF:000246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43956, NULL, 'G3DSA:2.30.330.10:FF:000009', NULL, NULL, 'Flagellar motor switch protein FliM', NULL, NULL, NULL, NULL, NULL, 4),
(43957, NULL, 'G3DSA:3.30.160.60:FF:006471', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43958, NULL, 'G3DSA:3.40.50.1820:FF:001434', NULL, NULL, 'Lipase, putative', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(43959, NULL, 'G3DSA:1.10.472.10:FF:000526', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43960, NULL, 'G3DSA:3.80.10.10:FF:003413', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43961, NULL, 'G3DSA:4.10.970.10:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43962, NULL, 'G3DSA:1.10.510.10:FF:003325', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43963, NULL, 'G3DSA:1.10.10.10:FF:000279', NULL, NULL, 'Transcriptional regulator, ArsR family', NULL, NULL, NULL, NULL, NULL, 4),
(43964, NULL, 'G3DSA:3.20.20.220:FF:000066', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(43965, NULL, 'G3DSA:3.30.160.60:FF:000636', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(43966, NULL, 'G3DSA:2.130.10.10:FF:003334', NULL, NULL, 'Pre-mRNA processing factor 4 (PRP4) like/WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(43967, NULL, 'G3DSA:1.20.1280.50:FF:000078', NULL, NULL, 'F-box family protein', NULL, NULL, NULL, NULL, NULL, 4),
(43968, NULL, 'G3DSA:2.40.128.330:FF:000015', NULL, NULL, 'Mitochondrial inner membrane magnesium transporter MRS2', NULL, NULL, NULL, NULL, NULL, 4),
(43969, NULL, 'G3DSA:3.90.70.10:FF:000319', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(43970, NULL, 'G3DSA:2.130.10.10:FF:001480', NULL, NULL, 'WD domain, G-beta repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(43971, NULL, 'G3DSA:3.30.420.40:FF:000252', NULL, NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(43972, NULL, 'G3DSA:1.10.3080.10:FF:000087', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(43973, NULL, 'G3DSA:2.60.40.820:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43974, NULL, 'G3DSA:3.40.50.300:FF:006185', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(43975, NULL, 'G3DSA:3.30.160.20:FF:000091', NULL, NULL, 'Peptide chain release factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(43976, NULL, 'G3DSA:1.25.40.10:FF:004025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43977, NULL, 'G3DSA:3.30.930.10:FF:000028', NULL, NULL, 'Phenylalanyl-tRNA synthetase alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(43978, NULL, 'G3DSA:1.10.20.10:FF:000105', NULL, NULL, 'Inner kinetochore subunit cnp20', NULL, NULL, NULL, NULL, NULL, 4),
(43979, NULL, 'G3DSA:2.10.70.10:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43980, NULL, 'G3DSA:3.80.10.10:FF:001120', NULL, NULL, 'MDIS1-interacting receptor like kinase 2 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(43981, NULL, 'G3DSA:3.90.70.30:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43982, NULL, 'G3DSA:1.20.1270.10:FF:000088', NULL, NULL, 'ER-located HSP110/SSE-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(43983, NULL, 'G3DSA:3.40.390.10:FF:000046', NULL, NULL, 'Serralysin', NULL, NULL, NULL, NULL, NULL, 4),
(43984, NULL, 'G3DSA:2.60.120.290:FF:000218', NULL, NULL, 'C-type LECtin', NULL, NULL, NULL, NULL, NULL, 4),
(43985, NULL, 'G3DSA:3.10.50.30:FF:000007', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(43986, NULL, 'G3DSA:3.30.1590.10:FF:000001', NULL, NULL, 'Malto-oligosyltrehalose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(43987, NULL, 'G3DSA:3.30.40.10:FF:001821', NULL, NULL, 'Uncharacterized ATP-dependent helicase C144.05', NULL, NULL, NULL, NULL, NULL, 4),
(43988, NULL, 'G3DSA:1.20.1560.10:FF:000863', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43989, NULL, 'G3DSA:3.40.50.300:FF:000878', NULL, NULL, 'Mitochondrial Rho GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(43990, NULL, 'G3DSA:3.30.160.60:FF:004907', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(43991, NULL, 'G3DSA:3.40.50.300:FF:007527', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(43992, NULL, 'G3DSA:3.10.580.10:FF:000005', NULL, NULL, 'HlyC/CorC family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(43993, NULL, 'G3DSA:1.25.40.20:FF:000436', NULL, NULL, 'Swh1p', NULL, NULL, NULL, NULL, NULL, 4),
(43994, NULL, 'G3DSA:3.80.10.10:FF:003357', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(43995, NULL, 'G3DSA:1.20.1250.20:FF:002332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43996, NULL, 'G3DSA:2.130.10.10:FF:005695', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43997, NULL, 'G3DSA:3.40.50.1100:FF:000263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(43998, NULL, 'G3DSA:3.30.565.10:FF:000062', NULL, NULL, 'Type 2 DNA topoisomerase 6 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(43999, NULL, 'G3DSA:3.20.20.100:FF:000176', NULL, NULL, 'Oxidoreductase, aldo/keto reductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(44000, NULL, 'G3DSA:1.25.40.10:FF:001271', NULL, NULL, 'HemY protein', NULL, NULL, NULL, NULL, NULL, 4),
(44001, NULL, 'G3DSA:3.40.50.150:FF:000052', NULL, NULL, 'Probable histone-arginine methyltransferase CARM1', NULL, NULL, NULL, NULL, NULL, 4),
(44002, NULL, 'G3DSA:3.40.50.300:FF:004296', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(44003, NULL, 'G3DSA:1.10.510.10:FF:003802', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44004, NULL, 'G3DSA:3.30.1670.10:FF:000002', NULL, NULL, 'Mercaptopyruvate sulfurtransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(44005, NULL, 'G3DSA:2.30.30.30:FF:000120', NULL, NULL, 'Ribosomal protein L26, putative', NULL, NULL, NULL, NULL, NULL, 4),
(44006, NULL, 'G3DSA:1.10.472.10:FF:000150', NULL, NULL, 'Cyclin-T1-3 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(44007, NULL, 'G3DSA:1.10.287.4070:FF:000011', NULL, NULL, 'Nucleolar protein NOP5/ snoRNA binding domain', NULL, NULL, NULL, NULL, NULL, 4),
(44008, NULL, 'G3DSA:3.40.50.2300:FF:000842', NULL, NULL, 'Vomeronasal 2, receptor 73', NULL, NULL, NULL, NULL, NULL, 4),
(44009, NULL, 'G3DSA:1.10.720.140:FF:000001', NULL, NULL, 'E3 ubiquitin-protein ligase RNF34 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(44010, NULL, 'G3DSA:1.25.40.10:FF:004502', NULL, NULL, 'TPR repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(44011, NULL, 'G3DSA:1.10.510.10:FF:000571', NULL, NULL, 'Maternal embryonic leucine zipper kinase', NULL, NULL, NULL, NULL, NULL, 4),
(44012, NULL, 'G3DSA:2.10.25.10:FF:001126', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(44013, NULL, 'G3DSA:1.25.40.530:FF:000011', NULL, NULL, 'Myosin 10A, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(44014, NULL, 'G3DSA:1.20.5.700:FF:000004', NULL, NULL, 'Cytochrome b6-f complex iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4),
(44015, NULL, 'G3DSA:2.40.50.100:FF:000120', NULL, NULL, 'Molybdenum import ATP-binding protein ModC', NULL, NULL, NULL, NULL, NULL, 4),
(44016, NULL, 'G3DSA:3.90.1150.10:FF:000297', NULL, NULL, 'Transcriptional regulator, GntR family', NULL, NULL, NULL, NULL, NULL, 4),
(44017, NULL, 'G3DSA:2.10.50.10:FF:000127', NULL, NULL, 'C-type LECtin', NULL, NULL, NULL, NULL, NULL, 4),
(44018, NULL, 'G3DSA:3.30.420.10:FF:000237', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(44019, NULL, 'G3DSA:3.40.50.1110:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44020, NULL, 'G3DSA:2.60.40.3960:FF:000004', NULL, NULL, 'Spore development regulator vosA', NULL, NULL, NULL, NULL, NULL, 4),
(44021, NULL, 'G3DSA:3.40.50.300:FF:003312', NULL, NULL, 'Small GTPase EhRabX14, putative', NULL, NULL, NULL, NULL, NULL, 4),
(44022, NULL, 'G3DSA:2.40.70.10:FF:000234', NULL, NULL, 'Endopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(44023, NULL, 'G3DSA:3.30.930.10:FF:000091', NULL, NULL, 'Glycine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(44024, NULL, 'G3DSA:2.10.25.10:FF:000614', NULL, NULL, 'Neurogenic locus notch protein 1', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(44025, NULL, 'G3DSA:3.40.50.1000:FF:000851', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44026, NULL, 'G3DSA:3.30.450.30:FF:000048', NULL, NULL, 'Late endosomal/lysosomal adaptor, Mapk (MAPK) and mToR (MTOR) activator homolog', NULL, NULL, NULL, NULL, NULL, 4),
(44027, NULL, 'G3DSA:3.30.70.20:FF:000050', NULL, NULL, 'Periplasmic [Fe] hydrogenase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(44028, NULL, 'G3DSA:1.20.144.10:FF:000094', NULL, NULL, 'Phospholipid phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(44029, NULL, 'G3DSA:2.60.120.920:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44030, NULL, 'G3DSA:1.10.630.10:FF:000838', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44031, NULL, 'G3DSA:3.10.100.10:FF:000004', NULL, NULL, 'CD44 antigen isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(44032, NULL, 'G3DSA:1.20.1530.20:FF:000072', NULL, NULL, 'Cation/H(+) antiporter 15', NULL, NULL, NULL, NULL, NULL, 4),
(44033, NULL, 'G3DSA:3.30.1330.90:FF:000017', NULL, NULL, 'L-serine ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(44034, NULL, 'G3DSA:1.10.510.10:FF:002460', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44035, NULL, 'G3DSA:1.10.730.10:FF:000054', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(44036, NULL, 'G3DSA:1.10.730.10:FF:000110', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(44037, NULL, 'G3DSA:3.40.30.10:FF:000926', NULL, NULL, 'Probable thiol:disulfide interchange protein', NULL, NULL, NULL, NULL, NULL, 4),
(44038, NULL, 'G3DSA:3.40.50.1580:FF:000064', NULL, NULL, 'Purine nucleoside phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(44039, NULL, 'G3DSA:2.130.10.10:FF:001417', NULL, NULL, 'WD repeat domain 90', NULL, NULL, NULL, NULL, NULL, 4),
(44040, NULL, 'G3DSA:1.10.3380.10:FF:000076', NULL, NULL, 'DEAD/DEAH box helicase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(44041, NULL, 'G3DSA:2.60.40.290:FF:000001', NULL, NULL, 'Glucanase', NULL, NULL, NULL, NULL, NULL, 4),
(44042, NULL, 'G3DSA:3.40.50.300:FF:000081', NULL, NULL, 'Preprotein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(44043, NULL, 'G3DSA:1.20.1310.20:FF:000033', NULL, NULL, 'PfEMP1 variant 1 of strain MC', NULL, NULL, NULL, NULL, NULL, 4),
(44044, NULL, 'G3DSA:4.10.800.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44045, NULL, 'G3DSA:1.20.1050.10:FF:000077', NULL, NULL, 'Protein CBG23268', NULL, NULL, NULL, NULL, NULL, 4),
(44046, NULL, 'G3DSA:1.10.510.10:FF:002021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44047, NULL, 'G3DSA:1.10.10.1800:FF:000003', NULL, NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', NULL, NULL, NULL, NULL, NULL, 4),
(44048, NULL, 'G3DSA:3.40.1260.10:FF:000002', NULL, NULL, 'Sulfurtransferase TusB', NULL, NULL, NULL, NULL, NULL, 4),
(44049, NULL, 'G3DSA:3.15.20.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44050, NULL, 'G3DSA:3.40.50.2300:FF:001298', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44051, NULL, 'G3DSA:3.30.160.60:FF:003126', NULL, NULL, 'Zinc finger imprinted 2', NULL, NULL, NULL, NULL, NULL, 4),
(44052, NULL, 'G3DSA:2.40.10.10:FF:000697', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44053, NULL, 'G3DSA:3.30.465.10:FF:000003', NULL, NULL, 'Magnesium and cobalt efflux protein corC', NULL, NULL, NULL, NULL, NULL, 4),
(44054, NULL, 'G3DSA:2.130.10.10:FF:005223', NULL, NULL, 'Ribosome biogenesis protein WDR12 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(44055, NULL, 'G3DSA:2.20.100.10:FF:000197', NULL, NULL, 'Thrombospondin type 1 domain containing 7A', NULL, NULL, NULL, NULL, NULL, 4),
(44056, NULL, 'G3DSA:2.40.100.10:FF:000063', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(44057, NULL, 'G3DSA:3.40.190.10:FF:000946', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44058, NULL, 'G3DSA:3.40.50.300:FF:003840', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(44059, NULL, 'G3DSA:3.40.50.150:FF:001833', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44060, NULL, 'G3DSA:4.10.1060.10:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44061, NULL, 'G3DSA:3.30.830.10:FF:000083', NULL, NULL, 'Putative insulinase', NULL, NULL, NULL, NULL, NULL, 4),
(44062, NULL, 'G3DSA:2.60.40.1930:FF:000007', NULL, NULL, 'Complement C4-A', NULL, NULL, NULL, NULL, NULL, 4),
(44063, NULL, 'G3DSA:3.10.330.20:FF:000018', NULL, NULL, 'tRNA (Adenine(58)-N(1))-methyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(44064, NULL, 'G3DSA:1.50.40.10:FF:000015', NULL, NULL, 'Solute carrier family 25 member 36', NULL, NULL, NULL, NULL, NULL, 4),
(44065, NULL, 'G3DSA:3.20.20.140:FF:000396', NULL, NULL, 'Ribonuclease P protein subunit p30, putative', NULL, NULL, NULL, NULL, NULL, 4),
(44066, NULL, 'G3DSA:2.60.40.2160:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44067, NULL, 'G3DSA:3.80.10.10:FF:002901', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44068, NULL, 'G3DSA:3.50.50.60:FF:000897', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(44069, NULL, 'G3DSA:3.40.50.150:FF:000844', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44070, NULL, 'G3DSA:2.160.20.60:FF:000004', NULL, NULL, 'NAD(P)H-dependent glutamate synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(44071, NULL, 'G3DSA:3.30.450.20:FF:000686', NULL, NULL, 'Blr6052 protein', NULL, NULL, NULL, NULL, NULL, 4),
(44072, NULL, 'G3DSA:1.20.1280.50:FF:000134', NULL, NULL, 'F-box domain containing protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(44073, NULL, 'G3DSA:3.30.160.60:FF:002614', NULL, NULL, 'Pita, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(44074, NULL, 'G3DSA:2.30.30.140:FF:000242', NULL, NULL, 'Protein CBR-ARID-1', NULL, NULL, NULL, NULL, NULL, 4),
(44075, NULL, 'G3DSA:3.40.1340.10:FF:000003', NULL, NULL, 'DNA-directed RNA polymerase II, putative', NULL, NULL, NULL, NULL, NULL, 4),
(44076, NULL, 'G3DSA:3.20.70.20:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44077, NULL, 'G3DSA:3.20.20.80:FF:000267', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(44078, NULL, 'G3DSA:1.20.1070.10:FF:000640', NULL, NULL, 'Frizzled-2', NULL, NULL, NULL, NULL, NULL, 4),
(44079, NULL, 'G3DSA:3.40.50.300:FF:008039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44080, NULL, 'G3DSA:3.40.50.11040:FF:000012', NULL, NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', NULL, NULL, NULL, NULL, NULL, 4),
(44081, NULL, 'G3DSA:3.40.50.720:FF:001757', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44082, NULL, 'G3DSA:3.90.580.10:FF:000004', NULL, NULL, 'DNA primase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(44083, NULL, 'G3DSA:3.80.10.10:FF:002429', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44084, NULL, 'G3DSA:3.40.50.2020:FF:000117', NULL, NULL, 'Phosphoribosyl pyrophosphate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(44085, NULL, 'G3DSA:2.130.10.10:FF:003278', NULL, NULL, 'DmX-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(44086, NULL, 'G3DSA:3.40.50.10090:FF:000042', NULL, NULL, 'Uroporphyrinogen III synthase/methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(44087, NULL, 'G3DSA:3.40.50.300:FF:003368', NULL, NULL, 'Putative DEAD/DEAH box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(44088, NULL, 'G3DSA:1.10.390.10:FF:000015', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(44089, NULL, 'G3DSA:1.25.40.180:FF:000209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44090, NULL, 'G3DSA:2.60.40.150:FF:000420', NULL, NULL, 'Protein SRC2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(44091, NULL, 'G3DSA:1.10.10.1500:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44092, NULL, 'G3DSA:3.10.25.10:FF:000016', NULL, NULL, 'Methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(44093, NULL, 'G3DSA:3.80.10.10:FF:002368', NULL, NULL, 'At1g80630', NULL, NULL, NULL, NULL, NULL, 4),
(44094, NULL, 'G3DSA:3.90.1100.10:FF:000053', NULL, NULL, 'RNA polymerase I subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(44095, NULL, 'G3DSA:1.10.10.10:FF:000335', NULL, NULL, 'Spi-C transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(44096, NULL, 'G3DSA:1.25.40.70:FF:000018', NULL, NULL, 'Phosphatidylinositol 4-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(44097, NULL, 'G3DSA:3.10.100.10:FF:000032', NULL, NULL, 'Secretory phospholipase A2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(44098, NULL, 'G3DSA:2.60.40.10:FF:000243', NULL, NULL, 'MAM domain-containing glycosylphosphatidylinositol anchor protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(44099, NULL, 'G3DSA:1.25.40.550:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44100, NULL, 'G3DSA:3.40.50.10130:FF:000020', NULL, NULL, 'Crossover junction endonuclease MUS81', NULL, NULL, NULL, NULL, NULL, 4),
(44101, NULL, 'G3DSA:3.30.450.40:FF:000080', NULL, NULL, 'Two component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(44102, NULL, 'G3DSA:1.10.565.10:FF:000130', NULL, NULL, 'AGAP012921-PA', NULL, NULL, NULL, NULL, NULL, 4),
(44103, NULL, 'G3DSA:1.10.287.70:FF:000389', NULL, NULL, 'CPD photolyase class II', NULL, NULL, NULL, NULL, NULL, 4),
(44104, NULL, 'G3DSA:3.90.1300.10:FF:000034', NULL, NULL, 'Fatty acid amide hydrolase, gene 3', NULL, NULL, NULL, NULL, NULL, 4),
(44105, NULL, 'G3DSA:3.30.300.20:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44106, NULL, 'G3DSA:3.30.465.10:FF:000059', NULL, NULL, 'D-lactate dehydrogenase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(44107, NULL, 'G3DSA:1.50.40.10:FF:000190', NULL, NULL, 'Unplaced genomic scaffold supercont2.19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(44108, NULL, 'G3DSA:1.20.1270.280:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44109, NULL, 'G3DSA:1.20.58.1070:FF:000006', NULL, NULL, 'Gem-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(44110, NULL, 'G3DSA:2.60.260.20:FF:000067', NULL, NULL, 'GD13648', NULL, NULL, NULL, NULL, NULL, 4),
(44111, NULL, 'G3DSA:1.25.10.10:FF:000515', NULL, NULL, 'Importin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(44112, NULL, 'G3DSA:2.60.120.780:FF:000005', NULL, NULL, 'Chromatin protein', NULL, NULL, NULL, NULL, NULL, 4),
(44113, NULL, 'G3DSA:3.30.505.10:FF:000114', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(44114, NULL, 'G3DSA:3.30.160.60:FF:005487', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44115, NULL, 'G3DSA:1.20.5.1190:FF:000014', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(44116, NULL, 'G3DSA:2.60.260.20:FF:000123', NULL, NULL, 'DnaJ-like protein subfamily A member 2', NULL, NULL, NULL, NULL, NULL, 4),
(44117, NULL, 'G3DSA:3.30.160.60:FF:005543', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44118, NULL, 'G3DSA:1.20.1540.10:FF:000013', NULL, NULL, 'Rhomboid protease aarA', NULL, NULL, NULL, NULL, NULL, 4),
(44119, NULL, 'G3DSA:3.90.660.10:FF:000005', NULL, NULL, 'Polyamine oxidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(44120, NULL, 'G3DSA:2.60.110.10:FF:000019', NULL, NULL, 'Thaumatin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(44121, NULL, 'G3DSA:1.10.287.930:FF:000001', NULL, NULL, 'Potassium voltage-gated channel, subfamily G, member 1', NULL, NULL, NULL, NULL, NULL, 4),
(44122, NULL, 'G3DSA:1.20.1250.20:FF:000387', NULL, NULL, 'H(+) MyoInositol coTransporter', NULL, NULL, NULL, NULL, NULL, 4),
(44123, NULL, 'G3DSA:1.20.930.40:FF:000025', NULL, NULL, 'Putative zinc metalloprotease', NULL, NULL, NULL, NULL, NULL, 4),
(44124, NULL, 'G3DSA:3.90.79.10:FF:000042', NULL, NULL, 'Probable NADH pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(44125, NULL, 'G3DSA:2.60.34.10:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44126, NULL, 'G3DSA:1.20.1270.60:FF:000226', NULL, NULL, 'Brain-specific angiogenesis inhibitor 1-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(44127, NULL, 'G3DSA:3.30.457.60:FF:000005', NULL, NULL, 'Spindle assembly checkpoint component', NULL, NULL, NULL, NULL, NULL, 4),
(44128, NULL, 'G3DSA:1.10.287.1080:FF:000007', NULL, NULL, 'Nucleotide pyrophosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(44129, NULL, 'G3DSA:1.10.150.670:FF:000002', NULL, NULL, 'Crossover junction endonuclease EME1', NULL, NULL, NULL, NULL, NULL, 4),
(44130, NULL, 'G3DSA:1.20.990.10:FF:000019', NULL, NULL, 'Methionine synthase reductase', NULL, NULL, NULL, NULL, NULL, 4),
(44131, NULL, 'G3DSA:1.20.1530.20:FF:000044', NULL, NULL, 'Glutathione-gated K(+)-efflux system KefB', NULL, NULL, NULL, NULL, NULL, 4),
(44132, NULL, 'G3DSA:1.10.167.10:FF:000036', NULL, NULL, 'Regulator of G-protein signaling rgs-3', NULL, NULL, NULL, NULL, NULL, 4),
(44133, NULL, 'G3DSA:3.40.50.1820:FF:001018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44134, NULL, 'G3DSA:3.90.740.10:FF:000006', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(44135, NULL, 'G3DSA:6.10.250.3290:FF:000001', NULL, NULL, 'Resistin-like beta', NULL, NULL, NULL, NULL, NULL, 4),
(44136, NULL, 'G3DSA:1.20.1250.20:FF:000882', NULL, NULL, 'Enterobactin transporter', NULL, NULL, NULL, NULL, NULL, 4),
(44137, NULL, 'G3DSA:3.20.20.70:FF:000085', NULL, NULL, '7-carboxy-7-deazaguanine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(44138, NULL, 'G3DSA:3.80.10.10:FF:000479', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(44139, NULL, 'G3DSA:3.40.605.10:FF:000125', NULL, NULL, 'Long-chain acyl-protein thioester reductase', NULL, NULL, NULL, NULL, NULL, 4),
(44140, NULL, 'G3DSA:2.130.10.10:FF:000075', NULL, NULL, 'Protein HIRA', NULL, NULL, NULL, NULL, NULL, 4),
(44141, NULL, 'G3DSA:3.30.160.60:FF:006476', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44142, NULL, 'G3DSA:3.30.1610.10:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44143, NULL, 'G3DSA:3.30.70.1560:FF:000004', NULL, NULL, 'Ribosomal large subunit pseudouridine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(44144, NULL, 'G3DSA:3.90.1420.10:FF:000009', NULL, NULL, 'Histone-lysine N-methyltransferase setd3', NULL, NULL, NULL, NULL, NULL, 4),
(44145, NULL, 'G3DSA:3.30.572.10:FF:000027', NULL, NULL, 'Putative thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(44146, NULL, 'G3DSA:2.10.80.10:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44147, NULL, 'G3DSA:3.90.1150.10:FF:000292', NULL, NULL, 'Threonine aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(44148, NULL, 'G3DSA:2.60.120.310:FF:000005', NULL, NULL, 'Peptidylglycine alpha-hydroxylating monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(44149, NULL, 'G3DSA:2.60.120.10:FF:000672', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44150, NULL, 'G3DSA:3.40.50.1820:FF:000945', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44151, NULL, 'G3DSA:3.40.50.20:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44152, NULL, 'G3DSA:3.40.50.620:FF:000564', NULL, NULL, 'Probable nicotinate-nucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(44153, NULL, 'G3DSA:3.30.40.10:FF:000888', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(44154, NULL, 'G3DSA:3.30.70.330:FF:002248', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44155, NULL, 'G3DSA:3.40.50.720:FF:000032', NULL, NULL, 'UDP-glucose 6-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(44156, NULL, 'G3DSA:3.30.360.10:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44157, NULL, 'G3DSA:2.160.10.10:FF:000101', NULL, NULL, 'Probable maltose O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(44158, NULL, 'G3DSA:2.20.25.20:FF:000010', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(44159, NULL, 'G3DSA:3.30.40.10:FF:002310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(44160, NULL, 'G3DSA:3.90.550.20:FF:000005', NULL, NULL, 'Unplaced genomic scaffold supercont1.17, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(44161, NULL, 'G3DSA:3.50.50.100:FF:000029', NULL, NULL, 'Type-II NADH dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(44162, NULL, 'G3DSA:1.10.1060.10:FF:000029', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] iron-sulfur subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(44163, NULL, 'G3DSA:2.30.29.30:FF:000667', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(44164, NULL, 'G3DSA:3.40.710.10:FF:000139', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(44165, NULL, 'G3DSA:3.90.226.10:FF:000345', NULL, NULL, 'Enoyl-CoA hydratase, short chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(44166, NULL, 'G3DSA:3.80.10.10:FF:004341', NULL, NULL, 'Protein CLP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(44167, NULL, 'G3DSA:3.40.50.360:FF:000053', NULL, NULL, 'Protein NrdI', NULL, NULL, NULL, NULL, NULL, 4),
(44168, NULL, 'G3DSA:1.10.238.10:FF:000319', NULL, NULL, 'Allograft inflammatory factor 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(44169, NULL, 'G3DSA:3.30.160.60:FF:004054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44170, NULL, 'G3DSA:3.80.10.10:FF:004369', NULL, NULL, 'Ras guanine nucleotide exchange factor L', NULL, NULL, NULL, NULL, NULL, 4),
(44171, NULL, 'G3DSA:3.30.70.330:FF:001236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44172, NULL, 'G3DSA:2.60.120.200:FF:000467', NULL, NULL, 'Basement membrane proteoglycan', NULL, NULL, NULL, NULL, NULL, 4),
(44173, NULL, 'G3DSA:2.60.40.10:FF:005863', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44174, NULL, 'G3DSA:1.20.1250.20:FF:000590', NULL, NULL, 'Vba1p', NULL, NULL, NULL, NULL, NULL, 4),
(44175, NULL, 'G3DSA:1.10.8.60:FF:000321', NULL, NULL, 'Lon protease', NULL, NULL, NULL, NULL, NULL, 4),
(44176, NULL, 'G3DSA:3.30.1370.10:FF:000013', NULL, NULL, 'Mex-3 RNA-binding family member B', NULL, NULL, NULL, NULL, NULL, 4),
(44177, NULL, 'G3DSA:1.20.1460.10:FF:000012', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(44178, NULL, 'G3DSA:1.10.238.10:FF:000027', NULL, NULL, 'Calmodulin (CaM)', NULL, NULL, NULL, NULL, NULL, 4),
(44179, NULL, 'G3DSA:3.30.710.10:FF:000517', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44180, NULL, 'G3DSA:1.25.40.20:FF:001892', NULL, NULL, 'Transient receptor potential cation channel subfamily A member 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(44181, NULL, 'G3DSA:2.130.10.10:FF:003750', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44182, NULL, 'G3DSA:3.90.175.10:FF:000001', NULL, NULL, 'Grass carp reovirus (GCRV)-induced gene 2e', NULL, NULL, NULL, NULL, NULL, 4),
(44183, NULL, 'G3DSA:3.30.200.20:FF:001983', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44184, NULL, 'G3DSA:2.130.10.30:FF:000119', NULL, NULL, 'Serine/threonine-protein kinase Nek8-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(44185, NULL, 'G3DSA:3.20.20.140:FF:000340', NULL, NULL, 'Adenosine/AMP deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(44186, NULL, 'G3DSA:3.40.47.10:FF:000105', NULL, NULL, 'Polyketide biosynthesis 3-hydroxy-3-methylglutaryl-ACP synthase PksG', NULL, NULL, NULL, NULL, NULL, 4),
(44187, NULL, 'G3DSA:2.20.110.10:FF:000079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44188, NULL, 'G3DSA:3.30.200.20:FF:000971', NULL, NULL, 'Putative serine/threonine-protein kinase Nek3', NULL, NULL, NULL, NULL, NULL, 4),
(44189, NULL, 'G3DSA:2.60.40.60:FF:000302', NULL, NULL, 'CaDHerin family', NULL, NULL, NULL, NULL, NULL, 4),
(44190, NULL, 'G3DSA:2.40.50.140:FF:001250', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44191, NULL, 'G3DSA:4.10.1110.10:FF:000003', NULL, NULL, 'AN1-type zinc finger protein 2B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(44192, NULL, 'G3DSA:1.10.10.1200:FF:000008', NULL, NULL, 'Melanoma-associated antigen G1-like protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(44193, NULL, 'G3DSA:2.60.40.1720:FF:000001', NULL, NULL, 'Calcium-dependent cell adhesion molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(44194, NULL, 'G3DSA:3.40.50.1000:FF:000435', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44195, NULL, 'G3DSA:3.60.10.10:FF:000289', NULL, NULL, 'DNA-(apurinic or apyrimidinic site) lyase', NULL, NULL, NULL, NULL, NULL, 4),
(44196, NULL, 'G3DSA:2.40.50.140:FF:001278', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44197, NULL, 'G3DSA:3.30.499.10:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44198, NULL, 'G3DSA:3.40.50.300:FF:004801', NULL, NULL, 'Nitrogen assimilation regulatory protein ntrX', NULL, NULL, NULL, NULL, NULL, 4),
(44199, NULL, 'G3DSA:1.20.1280.50:FF:000139', NULL, NULL, 'AGAP011930-PA', NULL, NULL, NULL, NULL, NULL, 4),
(44200, NULL, 'G3DSA:3.40.50.1440:FF:000011', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(44201, NULL, 'G3DSA:1.10.533.10:FF:000135', NULL, NULL, 'SBP (S-ribonuclease binding protein) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(44202, NULL, 'G3DSA:3.40.50.720:FF:000768', NULL, NULL, 'Prodigiosin synthesizing transferase PigC', NULL, NULL, NULL, NULL, NULL, 4),
(44203, NULL, 'G3DSA:3.40.605.10:FF:000069', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(44204, NULL, 'G3DSA:3.40.50.740:FF:000038', NULL, NULL, 'NADH-quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(44205, NULL, 'G3DSA:1.10.10.10:FF:001768', NULL, NULL, 'ORC1-type DNA replication protein', NULL, NULL, NULL, NULL, NULL, 4),
(44206, NULL, 'G3DSA:3.90.320.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44207, NULL, 'G3DSA:1.10.287.130:FF:000154', NULL, NULL, 'Adaptive-response sensory kinase', NULL, NULL, NULL, NULL, NULL, 4),
(44208, NULL, 'G3DSA:4.10.1240.10:FF:000007', NULL, NULL, 'Corticotropin-releasing factor receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(44209, NULL, 'G3DSA:1.10.10.10:FF:001263', NULL, NULL, 'Cullin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(44210, NULL, 'G3DSA:2.60.40.10:FF:001968', NULL, NULL, 'KETtiN (Drosophila actin-binding) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(44211, NULL, 'G3DSA:3.40.50.300:FF:004616', NULL, NULL, 'Small nuclear ribonucleoprotein U5 subunit 200', NULL, NULL, NULL, NULL, NULL, 4),
(44212, NULL, 'G3DSA:3.40.1190.20:FF:000090', NULL, NULL, 'Putative Pyridoxal kinase', NULL, NULL, NULL, NULL, NULL, 4),
(44213, NULL, 'G3DSA:3.40.50.2300:FF:001331', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44214, NULL, 'G3DSA:1.10.730.10:FF:000082', NULL, NULL, 'Methionyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(44215, NULL, 'G3DSA:3.80.10.10:FF:000631', NULL, NULL, 'Leucine-rich repeat extensin-like protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(44216, NULL, 'G3DSA:1.10.150.50:FF:000105', NULL, NULL, 'Blast:Protein aveugle', NULL, NULL, NULL, NULL, NULL, 4),
(44217, NULL, 'G3DSA:3.40.50.620:FF:000912', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44218, NULL, 'G3DSA:3.40.525.10:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44219, NULL, 'G3DSA:3.30.70.330:FF:000303', NULL, NULL, 'RNA-binding motif protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(44220, NULL, 'G3DSA:2.120.10.80:FF:000337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44221, NULL, 'G3DSA:2.20.100.10:FF:000253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44222, NULL, 'G3DSA:3.40.630.10:FF:000138', NULL, NULL, 'Protein CBG11596', NULL, NULL, NULL, NULL, NULL, 4),
(44223, NULL, 'G3DSA:1.25.40.10:FF:005014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44224, NULL, 'G3DSA:2.60.40.10:FF:004402', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44225, NULL, 'G3DSA:3.30.1120.130:FF:000001', NULL, NULL, 'serine/threonine-protein kinase PLK4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(44226, NULL, 'G3DSA:3.40.50.300:FF:003784', NULL, NULL, 'Iron-sulfur cluster carrier protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(44227, NULL, 'G3DSA:1.10.287.40:FF:000026', NULL, NULL, 'Serine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(44228, NULL, 'G3DSA:1.10.287.70:FF:000630', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44229, NULL, 'G3DSA:1.10.10.60:FF:000064', NULL, NULL, 'Zinc finger homeobox protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(44230, NULL, 'G3DSA:3.30.60.210:FF:000001', NULL, NULL, 'Meiotic chromosome segregation protein P8B7.28c', NULL, NULL, NULL, NULL, NULL, 4),
(44231, NULL, 'G3DSA:3.40.50.300:FF:000906', NULL, NULL, 'Probable ATP-dependent RNA helicase DDX52', NULL, NULL, NULL, NULL, NULL, 4),
(44232, NULL, 'G3DSA:1.25.40.1010:FF:000006', NULL, NULL, 'Unplaced genomic scaffold supercont1.13, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(44233, NULL, 'G3DSA:3.30.60.30:FF:000142', NULL, NULL, 'SPARC-related modular calcium-binding 1', NULL, NULL, NULL, NULL, NULL, 4),
(44234, NULL, 'G3DSA:2.60.40.10:FF:003946', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44235, NULL, 'G3DSA:3.40.50.720:FF:001752', NULL, NULL, 'S-(Hydroxymethyl)glutathione dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(44236, NULL, 'G3DSA:1.20.1250.20:FF:001219', NULL, NULL, 'Glucitol/sorbitol-specific transport protein GutA', NULL, NULL, NULL, NULL, NULL, 4),
(44237, NULL, 'G3DSA:3.30.1360.200:FF:000002', NULL, NULL, 'Preprotein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(44238, NULL, 'G3DSA:3.80.10.10:FF:002424', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44239, NULL, 'G3DSA:3.30.160.60:FF:004531', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44240, NULL, 'G3DSA:3.60.21.10:FF:000230', NULL, NULL, 'Protein phosphotase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(44241, NULL, 'G3DSA:3.30.1360.220:FF:000008', NULL, NULL, 'FYVE zinc finger domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(44242, NULL, 'G3DSA:2.60.40.10:FF:004930', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44243, NULL, 'G3DSA:1.25.40.20:FF:001925', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44244, NULL, 'G3DSA:3.30.505.10:FF:000086', NULL, NULL, 'SH2 domain protein B', NULL, NULL, NULL, NULL, NULL, 4),
(44245, NULL, 'G3DSA:2.60.120.10:FF:000700', NULL, NULL, 'Chromosome 23, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(44246, NULL, 'G3DSA:2.40.160.110:FF:000014', NULL, NULL, 'Lysosome-associated membrane glycoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(44247, NULL, 'G3DSA:2.40.50.100:FF:000064', NULL, NULL, 'Exosome complex component RRP4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(44248, NULL, 'G3DSA:3.30.200.20:FF:001308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44249, NULL, 'G3DSA:3.90.1260.10:FF:000007', NULL, NULL, 'Argininosuccinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(44250, NULL, 'G3DSA:1.25.40.10:FF:000343', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g58590', NULL, NULL, NULL, NULL, NULL, 4),
(44251, NULL, 'G3DSA:3.20.200.10:FF:000015', NULL, NULL, 'Alpha-kinase 3b', NULL, NULL, NULL, NULL, NULL, 4),
(44252, NULL, 'G3DSA:1.10.287.70:FF:000097', NULL, NULL, 'Potassium voltage-gated channel subfamily G member 3', NULL, NULL, NULL, NULL, NULL, 4),
(44253, NULL, 'G3DSA:1.20.140.150:FF:000005', NULL, NULL, 'Germ cell-specific gene 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(44254, NULL, 'G3DSA:3.90.550.10:FF:000615', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44255, NULL, 'G3DSA:3.40.50.300:FF:008455', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44256, NULL, 'G3DSA:3.40.50.720:FF:000824', NULL, NULL, 'Possible oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(44257, NULL, 'G3DSA:3.30.160.60:FF:001125', NULL, NULL, 'Zinc finger and BTB domain-containing protein 24', NULL, NULL, NULL, NULL, NULL, 4),
(44258, NULL, 'G3DSA:3.30.40.140:FF:000004', NULL, NULL, 'Checkpoint with forkhead and ring finger domains, E3 ubiquitin protein ligase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(44259, NULL, 'G3DSA:1.10.1520.10:FF:000109', NULL, NULL, 'Dicer-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(44260, NULL, 'G3DSA:2.10.25.10:FF:000906', NULL, NULL, 'Versican a', NULL, NULL, NULL, NULL, NULL, 4),
(44261, NULL, 'G3DSA:1.10.510.10:FF:000419', NULL, NULL, 'STE20-related kinase adapter protein beta', NULL, NULL, NULL, NULL, NULL, 4),
(44262, NULL, 'G3DSA:2.102.10.10:FF:000031', NULL, NULL, 'Nitrite reductase [NAD(P)H]', NULL, NULL, NULL, NULL, NULL, 4),
(44263, NULL, 'G3DSA:1.10.10.10:FF:001824', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44264, NULL, 'G3DSA:2.40.440.10:FF:000021', NULL, NULL, 'Putative lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(44265, NULL, 'G3DSA:3.40.50.620:FF:000856', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44266, NULL, 'G3DSA:1.10.246.90:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44267, NULL, 'G3DSA:1.25.40.10:FF:004974', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44268, NULL, 'G3DSA:1.25.10.10:FF:003388', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44269, NULL, 'G3DSA:1.10.287.70:FF:000102', NULL, NULL, 'Two-pore potassium channel 3', NULL, NULL, NULL, NULL, NULL, 4),
(44270, NULL, 'G3DSA:3.40.50.1000:FF:000379', NULL, NULL, 'HAD-IB family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(44271, NULL, 'G3DSA:2.10.70.10:FF:000157', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(44272, NULL, 'G3DSA:3.40.50.10860:FF:000054', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(44273, NULL, 'G3DSA:2.40.50.510:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44274, NULL, 'G3DSA:3.30.60.190:FF:000006', NULL, NULL, 'Hit1p', NULL, NULL, NULL, NULL, NULL, 4),
(44275, NULL, 'G3DSA:3.90.550.10:FF:000290', NULL, NULL, 'Protein CDI', NULL, NULL, NULL, NULL, NULL, 4),
(44276, NULL, 'G3DSA:1.10.287.540:FF:000007', NULL, NULL, 'ATP synthase epsilon chain', NULL, NULL, NULL, NULL, NULL, 4),
(44277, NULL, 'G3DSA:1.10.10.1760:FF:000007', NULL, NULL, '60S ribosomal protein L36', NULL, NULL, NULL, NULL, NULL, 4),
(44278, NULL, 'G3DSA:3.80.10.10:FF:004285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44279, NULL, 'G3DSA:1.25.40.1030:FF:000017', NULL, NULL, 'Protein transport protein SEC31 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(44280, NULL, 'G3DSA:3.40.1380.10:FF:000005', NULL, NULL, 'ATP synthase subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(44281, NULL, 'G3DSA:3.40.50.150:FF:000900', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44282, NULL, 'G3DSA:2.70.50.30:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44283, NULL, 'G3DSA:3.90.228.10:FF:000035', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(44284, NULL, 'G3DSA:3.90.640.90:FF:000011', NULL, NULL, 'Anti-proliferation factor BTG1/TOB, putative', NULL, NULL, NULL, NULL, NULL, 4),
(44285, NULL, 'G3DSA:1.10.287.3240:FF:000032', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(44286, NULL, 'G3DSA:2.60.40.640:FF:000062', NULL, NULL, 'pH-response regulator protein palF', NULL, NULL, NULL, NULL, NULL, 4),
(44287, NULL, 'G3DSA:1.25.40.20:FF:000964', NULL, NULL, 'Calmodulin-binding transcription activator 1 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(44288, NULL, 'G3DSA:1.20.1250.20:FF:001404', NULL, NULL, 'Drug resistence protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(44289, NULL, 'G3DSA:2.60.120.200:FF:000091', NULL, NULL, 'Beta-1,3-galactosyltransferase GALT1', NULL, NULL, NULL, NULL, NULL, 4),
(44290, NULL, 'G3DSA:3.40.710.10:FF:000055', NULL, NULL, 'Probable penicillin-binding protein dacB1', NULL, NULL, NULL, NULL, NULL, 4),
(44291, NULL, 'G3DSA:1.10.10.2010:FF:000004', NULL, NULL, 'Protein CBR-MAC-1', NULL, NULL, NULL, NULL, NULL, 4),
(44292, NULL, 'G3DSA:2.60.120.330:FF:000163', NULL, NULL, 'Isopenicillin N synthase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(44293, NULL, 'G3DSA:3.40.50.1240:FF:000215', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44294, NULL, 'G3DSA:3.30.110.40:FF:000003', NULL, NULL, 'Response regulator SirA', NULL, NULL, NULL, NULL, NULL, 4),
(44295, NULL, 'G3DSA:3.20.20.370:FF:000032', NULL, NULL, 'YdjC chitooligosaccharide deacetylase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(44296, NULL, 'G3DSA:3.40.50.300:FF:007966', NULL, NULL, 'ATP-dependent DEAH-box RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(44297, NULL, 'G3DSA:2.40.30.130:FF:000035', NULL, NULL, 'Alanine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(44298, NULL, 'G3DSA:3.30.310.10:FF:000032', NULL, NULL, 'Ribonuclease HIII', NULL, NULL, NULL, NULL, NULL, 4),
(44299, NULL, 'G3DSA:1.20.58.830:FF:000048', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(44300, NULL, 'G3DSA:2.70.130.10:FF:000120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44301, NULL, 'G3DSA:1.10.510.10:FF:000043', NULL, NULL, 'probable serine/threonine-protein kinase At1g54610', NULL, NULL, NULL, NULL, NULL, 4),
(44302, NULL, 'G3DSA:2.10.25.10:FF:001542', NULL, NULL, 'Si:dkey-88l16.4', NULL, NULL, NULL, NULL, NULL, 4),
(44303, NULL, 'G3DSA:3.10.20.740:FF:000005', NULL, NULL, 'NADH:ubiquinone oxidoreductase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(44304, NULL, 'G3DSA:1.25.40.10:FF:003069', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(44305, NULL, 'G3DSA:3.30.40.10:FF:000096', NULL, NULL, 'E3 ubiquitin-protein ligase MARCH6', NULL, NULL, NULL, NULL, NULL, 4),
(44306, NULL, 'G3DSA:1.20.120.350:FF:000145', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44307, NULL, 'G3DSA:2.70.150.10:FF:000003', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(44308, NULL, 'G3DSA:2.60.40.60:FF:000741', NULL, NULL, 'Cdh-4', NULL, NULL, NULL, NULL, NULL, 4),
(44309, NULL, 'G3DSA:3.90.45.10:FF:000014', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(44310, NULL, 'G3DSA:2.40.70.10:FF:000178', NULL, NULL, 'Protein CBG08575', NULL, NULL, NULL, NULL, NULL, 4),
(44311, NULL, 'G3DSA:1.20.142.10:FF:000016', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(44312, NULL, 'G3DSA:1.20.1530.20:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44313, NULL, 'G3DSA:2.10.90.10:FF:000012', NULL, NULL, 'Growth/differentiation factor 9 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(44314, NULL, 'G3DSA:3.30.160.60:FF:003598', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44315, NULL, 'G3DSA:2.60.40.10:FF:006083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44316, NULL, 'G3DSA:3.30.160.60:FF:000872', NULL, NULL, 'zinc finger X-linked protein ZXDB', NULL, NULL, NULL, NULL, NULL, 4),
(44317, NULL, 'G3DSA:1.10.238.10:FF:000090', NULL, NULL, 'calumenin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(44318, NULL, 'G3DSA:1.10.150.110:FF:000003', NULL, NULL, 'DNA polymerase mu', NULL, NULL, NULL, NULL, NULL, 4),
(44319, NULL, 'G3DSA:2.160.10.10:FF:000096', NULL, NULL, 'UTP--glucose-1-phosphate uridylyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(44320, NULL, 'G3DSA:3.90.180.10:FF:000075', NULL, NULL, 'Glucose 1-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(44321, NULL, 'G3DSA:3.10.450.580:FF:000019', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(44322, NULL, 'G3DSA:2.40.30.10:FF:000260', NULL, NULL, '50S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(44323, NULL, 'G3DSA:2.30.110.10:FF:000026', NULL, NULL, 'PPOX class F420-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(44324, NULL, 'G3DSA:3.40.630.10:FF:000054', NULL, NULL, 'Peptide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(44325, NULL, 'G3DSA:3.10.20.90:FF:000029', NULL, NULL, 'SH3 and multiple ankyrin repeat domains protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(44326, NULL, 'G3DSA:3.40.50.1820:FF:001726', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(44327, NULL, 'G3DSA:3.50.50.60:FF:000610', NULL, NULL, 'Halogenase PltM', NULL, NULL, NULL, NULL, NULL, 4),
(44328, NULL, 'G3DSA:2.130.10.10:FF:003481', NULL, NULL, 'Mauve', NULL, NULL, NULL, NULL, NULL, 4),
(44329, NULL, 'G3DSA:1.10.510.10:FF:001908', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44330, NULL, 'G3DSA:3.50.50.60:FF:001122', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(44331, NULL, 'G3DSA:3.30.70.80:FF:000045', NULL, NULL, 'AGR386Cp', NULL, NULL, NULL, NULL, NULL, 4),
(44332, NULL, 'G3DSA:1.25.40.10:FF:002760', NULL, NULL, 'Pentatricopeptide repeat domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(44333, NULL, 'G3DSA:3.30.160.60:FF:004615', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44334, NULL, 'G3DSA:3.10.250.10:FF:000104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44335, NULL, 'G3DSA:3.30.930.10:FF:000175', NULL, NULL, 'ATP phosphoribosyltransferase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(44336, NULL, 'G3DSA:1.10.510.10:FF:004022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44337, NULL, 'G3DSA:3.50.50.60:FF:001066', NULL, NULL, 'Prenylcysteine oxidase 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(44338, NULL, 'G3DSA:3.10.20.70:FF:000023', NULL, NULL, 'Probable glutamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(44339, NULL, 'G3DSA:3.40.50.2020:FF:000084', NULL, NULL, 'Adenine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(44340, NULL, 'G3DSA:2.60.120.970:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44341, NULL, 'G3DSA:4.10.320.10:FF:000005', NULL, NULL, 'Acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(44342, NULL, 'G3DSA:3.10.20.90:FF:000557', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 7', NULL, NULL, NULL, NULL, NULL, 4),
(44343, NULL, 'G3DSA:2.60.120.650:FF:000197', NULL, NULL, 'Lysine demethylase 4C', NULL, NULL, NULL, NULL, NULL, 4),
(44344, NULL, 'G3DSA:3.40.50.11660:FF:000018', NULL, NULL, 'Fucosyltransferase 7 (alpha (1,3) fucosyltransferase)', NULL, NULL, NULL, NULL, NULL, 4),
(44345, NULL, 'G3DSA:3.30.70.2110:FF:000001', NULL, NULL, 'Penicillin-binding protein 1 (Peptidoglycan synthetase)', NULL, NULL, NULL, NULL, NULL, 4),
(44346, NULL, 'G3DSA:3.80.10.10:FF:001412', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44347, NULL, 'G3DSA:3.30.1520.10:FF:000194', NULL, NULL, 'Neutrophil cytosolic factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(44348, NULL, 'G3DSA:3.90.190.10:FF:000008', NULL, NULL, 'putative tyrosine-protein phosphatase auxilin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(44349, NULL, 'G3DSA:2.60.40.10:FF:005099', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44350, NULL, 'G3DSA:1.25.40.860:FF:000031', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(44351, NULL, 'G3DSA:1.10.10.60:FF:000917', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44352, NULL, 'G3DSA:2.60.40.10:FF:000804', NULL, NULL, 'V-set and transmembrane domain containing 2B', NULL, NULL, NULL, NULL, NULL, 4),
(44353, NULL, 'G3DSA:3.40.50.720:FF:002393', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44354, NULL, 'G3DSA:3.40.50.300:FF:002295', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(44355, NULL, 'G3DSA:3.40.50.620:FF:000148', NULL, NULL, 'Cytoplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(44356, NULL, 'G3DSA:3.40.50.300:FF:000586', NULL, NULL, 'Rab family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(44357, NULL, 'G3DSA:3.30.70.330:FF:002692', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44358, NULL, 'G3DSA:2.10.110.10:FF:000216', NULL, NULL, 'Four and a half LIM domains 5', NULL, NULL, NULL, NULL, NULL, 4),
(44359, NULL, 'G3DSA:1.20.1070.10:FF:001652', NULL, NULL, 'Rhodopsin', NULL, NULL, NULL, NULL, NULL, 4),
(44360, NULL, 'G3DSA:2.160.10.10:FF:000129', NULL, NULL, 'UTP--glucose-1-phosphate uridylyltransferase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(44361, NULL, 'G3DSA:3.30.160.60:FF:000400', NULL, NULL, 'Zinc finger protein 276', NULL, NULL, NULL, NULL, NULL, 4),
(44362, NULL, 'G3DSA:3.10.28.10:FF:000017', NULL, NULL, 'V-type proton ATPase catalytic subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(44363, NULL, 'G3DSA:3.10.430.100:FF:000006', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(44364, NULL, 'G3DSA:2.60.120.200:FF:000736', NULL, NULL, 'BAM-2', NULL, NULL, NULL, NULL, NULL, 4),
(44365, NULL, 'G3DSA:3.40.50.1820:FF:001249', NULL, NULL, 'Protein phosphatase methylesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(44366, NULL, 'G3DSA:3.30.420.40:FF:000049', NULL, NULL, 'N-acetyl-D-glucosamine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(44367, NULL, 'G3DSA:1.20.120.20:FF:000036', NULL, NULL, 'Apolipoprotein Ea', NULL, NULL, NULL, NULL, NULL, 4),
(44368, NULL, 'G3DSA:3.40.50.980:FF:000003', NULL, NULL, 'Vibriobactin-specific 2,3-dihydroxybenzoate-AMP ligase', NULL, NULL, NULL, NULL, NULL, 4),
(44369, NULL, 'G3DSA:1.25.40.10:FF:004789', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(44370, NULL, 'G3DSA:2.60.40.10:FF:002513', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44371, NULL, 'G3DSA:3.40.50.300:FF:006038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44372, NULL, 'G3DSA:1.50.10.20:FF:000016', NULL, NULL, 'Cobalamin binding intrinsic factor', NULL, NULL, NULL, NULL, NULL, 4),
(44373, NULL, 'G3DSA:1.10.287.1770:FF:000006', NULL, NULL, 'Ferrous iron transport protein B', NULL, NULL, NULL, NULL, NULL, 4),
(44374, NULL, 'G3DSA:3.40.50.300:FF:007674', NULL, NULL, 'Protein-tyrosine sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(44375, NULL, 'G3DSA:1.25.40.10:FF:002232', NULL, NULL, 'ALBINO3-like protein 2 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(44376, NULL, 'G3DSA:3.90.70.10:FF:000027', NULL, NULL, 'Calpain 5', NULL, NULL, NULL, NULL, NULL, 4),
(44377, NULL, 'G3DSA:3.30.2310.20:FF:000012', NULL, NULL, 'Toxin ParE', NULL, NULL, NULL, NULL, NULL, 4),
(44378, NULL, 'G3DSA:3.30.70.330:FF:002164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44379, NULL, 'G3DSA:1.10.10.650:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44380, NULL, 'G3DSA:1.10.8.870:FF:000006', NULL, NULL, 'Aerobic glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(44381, NULL, 'G3DSA:3.40.970.10:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44382, NULL, 'G3DSA:1.20.1070.10:FF:000488', NULL, NULL, 'Adrenoceptor alpha 2B', NULL, NULL, NULL, NULL, NULL, 4),
(44383, NULL, 'G3DSA:1.10.510.10:FF:002313', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44384, NULL, 'G3DSA:3.30.470.20:FF:000193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44385, NULL, 'G3DSA:1.20.58.60:FF:000375', NULL, NULL, 'Spectrin, beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(44386, NULL, 'G3DSA:1.10.1200.10:FF:000092', NULL, NULL, 'Nonribosomal peptide synthetase 8', NULL, NULL, NULL, NULL, NULL, 4),
(44387, NULL, 'G3DSA:2.130.10.10:FF:000928', NULL, NULL, 'DDB1-and CUL4-associated factor 13', NULL, NULL, NULL, NULL, NULL, 4),
(44388, NULL, 'G3DSA:3.40.50.300:FF:002351', NULL, NULL, 'ATP-dependent helicase/nuclease subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(44389, NULL, 'G3DSA:3.10.450.350:FF:000012', NULL, NULL, 'M23 family peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(44390, NULL, 'G3DSA:3.20.20.70:FF:000354', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(44391, NULL, 'G3DSA:3.40.1310.20:FF:000004', NULL, NULL, 'Initiator protein NS1', NULL, NULL, NULL, NULL, NULL, 4),
(44392, NULL, 'G3DSA:3.30.30.30:FF:000022', NULL, NULL, 'Lumenal Hsp70 protein', NULL, NULL, NULL, NULL, NULL, 4),
(44393, NULL, 'G3DSA:1.10.3720.10:FF:000204', NULL, NULL, 'Amino ABC transporter, permease protein, 3-TM region, His/Glu/Gln/Arg/opine family domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(44394, NULL, 'G3DSA:2.60.40.790:FF:000056', NULL, NULL, '15.7 kDa heat shock protein, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(44395, NULL, 'G3DSA:1.10.238.10:FF:000735', NULL, NULL, 'Dual oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(44396, NULL, 'G3DSA:3.40.30.10:FF:000398', NULL, NULL, 'Thioredoxin domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(44397, NULL, 'G3DSA:2.60.120.10:FF:000756', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44398, NULL, 'G3DSA:3.40.50.2300:FF:000550', NULL, NULL, 'Sigma-54 dependent response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(44399, NULL, 'G3DSA:2.30.42.10:FF:000153', NULL, NULL, 'Scribbled, isoform T', NULL, NULL, NULL, NULL, NULL, 4),
(44400, NULL, 'G3DSA:3.20.20.190:FF:000130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44401, NULL, 'G3DSA:3.40.50.300:FF:000114', NULL, NULL, 'ATP-dependent RNA helicase DDX6', NULL, NULL, NULL, NULL, NULL, 4),
(44402, NULL, 'G3DSA:1.25.40.20:FF:000144', NULL, NULL, 'inversin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(44403, NULL, 'G3DSA:3.40.50.300:FF:007819', NULL, NULL, 'Putative RNA helicase armi-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(44404, NULL, 'G3DSA:3.30.200.20:FF:000263', NULL, NULL, 'Choline kinase alpha', NULL, NULL, NULL, NULL, NULL, 4),
(44405, NULL, 'G3DSA:2.60.40.10:FF:002457', NULL, NULL, 'Uncharacterized protein, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(44406, NULL, 'G3DSA:3.40.980.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44407, NULL, 'G3DSA:1.10.1520.10:FF:000076', NULL, NULL, 'Endoribonuclease Dicer 2b', NULL, NULL, NULL, NULL, NULL, 4),
(44408, NULL, 'G3DSA:3.80.10.10:FF:003065', NULL, NULL, 'Leucine-rich repeat-containing protein 51-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(44409, NULL, 'G3DSA:3.30.70.330:FF:002956', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44410, NULL, 'G3DSA:3.40.630.30:FF:000588', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44411, NULL, 'G3DSA:1.25.10.10:FF:002404', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44412, NULL, 'G3DSA:3.90.550.10:FF:000323', NULL, NULL, 'Processive diacylglycerol beta-glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(44413, NULL, 'G3DSA:1.20.1270.20:FF:000006', NULL, NULL, 'Hydroxylamine reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(44414, NULL, 'G3DSA:3.30.450.60:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44415, NULL, 'G3DSA:3.30.160.60:FF:000344', NULL, NULL, 'zinc finger protein 90 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(44416, NULL, 'G3DSA:1.10.287.110:FF:000227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44417, NULL, 'G3DSA:3.40.50.1820:FF:000473', NULL, NULL, 'YNL320W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(44418, NULL, 'G3DSA:3.30.70.1230:FF:000164', NULL, NULL, 'Adenylyl cyclase class-3/4/guanylyl cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(44419, NULL, 'G3DSA:1.10.510.10:FF:003617', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44420, NULL, 'G3DSA:3.40.50.1820:FF:001581', NULL, NULL, 'Alpha/beta-Hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(44421, NULL, 'G3DSA:3.30.2320.60:FF:000002', NULL, NULL, 'DUF2662 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(44422, NULL, 'G3DSA:2.160.20.10:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44423, NULL, 'G3DSA:1.25.40.10:FF:001068', NULL, NULL, 'Pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(44424, NULL, 'G3DSA:2.130.10.10:FF:005190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44425, NULL, 'G3DSA:3.40.50.1100:FF:000078', NULL, NULL, 'Threonine synthase-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(44426, NULL, 'G3DSA:1.10.510.10:FF:003297', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44427, NULL, 'G3DSA:1.20.120.720:FF:000037', NULL, NULL, 'Heavy chain, Unconventional Myosin', NULL, NULL, NULL, NULL, NULL, 4),
(44428, NULL, 'G3DSA:3.40.50.300:FF:007730', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(44429, NULL, 'G3DSA:3.40.50.720:FF:000740', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(44430, NULL, 'G3DSA:2.10.70.10:FF:000213', NULL, NULL, 'CUB and sushi domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(44431, NULL, 'G3DSA:3.90.1600.10:FF:000074', NULL, NULL, 'DNA polymerase alpha subunit one', NULL, NULL, NULL, NULL, NULL, 4),
(44432, NULL, 'G3DSA:3.40.50.261:FF:000002', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(44433, NULL, 'G3DSA:1.10.510.10:FF:001532', NULL, NULL, 'Ribosomal protein S6 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(44434, NULL, 'G3DSA:3.20.20.140:FF:000429', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44435, NULL, 'G3DSA:3.80.10.10:FF:002716', NULL, NULL, 'Putative inactive leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(44436, NULL, 'G3DSA:3.90.190.10:FF:000340', NULL, NULL, 'Dual specificity protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(44437, NULL, 'G3DSA:3.40.50.300:FF:004240', NULL, NULL, 'Probable chromosome partitioning ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(44438, NULL, 'G3DSA:1.10.8.700:FF:000001', NULL, NULL, 'DNA polymerase clamp loader subunit', NULL, NULL, NULL, NULL, NULL, 4),
(44439, NULL, 'G3DSA:3.40.1190.20:FF:000179', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44440, NULL, 'G3DSA:3.40.1190.20:FF:000123', NULL, NULL, 'Nucleoside kinase', NULL, NULL, NULL, NULL, NULL, 4),
(44441, NULL, 'G3DSA:2.130.10.10:FF:002637', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44442, NULL, 'G3DSA:2.120.10.80:FF:000253', NULL, NULL, 'Galactose oxidase, central domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(44443, NULL, 'G3DSA:3.40.50.300:FF:008511', NULL, NULL, 'AAA family cell division control-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(44444, NULL, 'G3DSA:3.30.70.270:FF:000263', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44445, NULL, 'G3DSA:3.90.70.10:FF:000286', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(44446, NULL, 'G3DSA:3.20.20.10:FF:000090', NULL, NULL, 'Arginine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(44447, NULL, 'G3DSA:1.25.40.10:FF:000287', NULL, NULL, 'uncharacterized TPR repeat-containing protein At1g05150-like', NULL, NULL, NULL, NULL, NULL, 4),
(44448, NULL, 'G3DSA:2.40.50.1070:FF:000013', NULL, NULL, 'tRNA/tmRNA (uracil-C(5))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(44449, NULL, 'G3DSA:1.10.510.10:FF:000127', NULL, NULL, 'Putative cyclin-dependent kinase-like 5', NULL, NULL, NULL, NULL, NULL, 4),
(44450, NULL, 'G3DSA:1.25.10.10:FF:002876', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44451, NULL, 'G3DSA:1.25.40.210:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44452, NULL, 'G3DSA:1.20.210.10:FF:000006', NULL, NULL, 'Cytochrome c oxidase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(44453, NULL, 'G3DSA:3.10.580.10:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44454, NULL, 'G3DSA:2.60.40.150:FF:000656', NULL, NULL, 'Copine 5', NULL, NULL, NULL, NULL, NULL, 4),
(44455, NULL, 'G3DSA:3.30.160.60:FF:000080', NULL, NULL, 'IKAROS family zinc finger 4', NULL, NULL, NULL, NULL, NULL, 4),
(44456, NULL, 'G3DSA:1.50.10.10:FF:000070', NULL, NULL, 'Putative bile acid beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(44457, NULL, 'G3DSA:3.40.50.300:FF:004329', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(44458, NULL, 'G3DSA:1.20.1310.10:FF:000171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44459, NULL, 'G3DSA:2.30.30.40:FF:000264', NULL, NULL, 'HECT E3 ubiquitin ligase', NULL, NULL, NULL, NULL, NULL, 4),
(44460, NULL, 'G3DSA:1.10.1040.10:FF:000090', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(44461, NULL, 'G3DSA:2.170.130.10:FF:000079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44462, NULL, 'G3DSA:1.50.10.10:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44463, NULL, 'G3DSA:3.30.2180.10:FF:000004', NULL, NULL, 'ATP12-like chaperone protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(44464, NULL, 'G3DSA:3.40.50.10490:FF:000162', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44465, NULL, 'G3DSA:1.20.940.10:FF:000016', NULL, NULL, 'Transport protein Sec31A', NULL, NULL, NULL, NULL, NULL, 4),
(44466, NULL, 'G3DSA:3.40.640.10:FF:000403', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(44467, NULL, 'G3DSA:2.130.10.10:FF:004262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44468, NULL, 'G3DSA:1.10.8.720:FF:000012', NULL, NULL, 'Dynein heavy chain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(44469, NULL, 'G3DSA:3.40.30.10:FF:000454', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(44470, NULL, 'G3DSA:1.25.40.10:FF:003485', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(44471, NULL, 'G3DSA:2.60.40.10:FF:003677', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44472, NULL, 'G3DSA:3.30.910.20:FF:000002', NULL, NULL, 'Outer membrane chaperone Skp (OmpH)', NULL, NULL, NULL, NULL, NULL, 4),
(44473, NULL, 'G3DSA:4.10.400.10:FF:000006', NULL, NULL, 'Putative low-density lipoprotein receptor', NULL, NULL, NULL, NULL, NULL, 4),
(44474, NULL, 'G3DSA:1.25.40.20:FF:000672', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44475, NULL, 'G3DSA:3.90.380.10:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44476, NULL, 'G3DSA:3.40.50.300:FF:005313', NULL, NULL, 'Shikimate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(44477, NULL, 'G3DSA:3.40.50.1380:FF:000004', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(44478, NULL, 'G3DSA:1.10.260.40:FF:000077', NULL, NULL, 'Replication factor C small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(44479, NULL, 'G3DSA:3.20.20.20:FF:000036', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(44480, NULL, 'G3DSA:3.30.70.330:FF:003092', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44481, NULL, 'G3DSA:3.60.140.10:FF:000012', NULL, NULL, 'Polyphenol oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(44482, NULL, 'G3DSA:3.40.140.10:FF:000146', NULL, NULL, 'ER membrane protein complex subunit 8/9 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(44483, NULL, 'G3DSA:1.20.1250.10:FF:000058', NULL, NULL, 'Leptin A1', NULL, NULL, NULL, NULL, NULL, 4),
(44484, NULL, 'G3DSA:3.30.420.10:FF:000506', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44485, NULL, 'G3DSA:1.20.120.1080:FF:000146', NULL, NULL, 'Tudor domain containing 9', NULL, NULL, NULL, NULL, NULL, 4),
(44486, NULL, 'G3DSA:1.10.238.10:FF:001247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44487, NULL, 'G3DSA:2.70.98.10:FF:000050', NULL, NULL, 'Aldose 1-epimerase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(44488, NULL, 'G3DSA:3.40.50.2300:FF:001062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44489, NULL, 'G3DSA:2.30.42.10:FF:000529', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44490, NULL, 'G3DSA:3.40.50.450:FF:000075', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(44491, NULL, 'G3DSA:2.60.40.1510:FF:000056', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(44492, NULL, 'G3DSA:3.30.160.60:FF:005835', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44493, NULL, 'G3DSA:1.10.10.60:FF:000541', NULL, NULL, 'mRNA, clone: RTFL01-36-L09', NULL, NULL, NULL, NULL, NULL, 4),
(44494, NULL, 'G3DSA:2.130.10.10:FF:000552', NULL, NULL, 'Cytoplasmic dynein 1 intermediate chain', NULL, NULL, NULL, NULL, NULL, 4),
(44495, NULL, 'G3DSA:1.10.3720.10:FF:000171', NULL, NULL, 'Molybdenum transport system permease', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(44496, NULL, 'G3DSA:3.40.50.300:FF:000642', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(44497, NULL, 'G3DSA:1.10.20.10:FF:000072', NULL, NULL, 'Transcriptional activator spt7', NULL, NULL, NULL, NULL, NULL, 4),
(44498, NULL, 'G3DSA:3.60.20.10:FF:000262', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44499, NULL, 'G3DSA:3.30.200.20:FF:001191', NULL, NULL, 'Discoidin domain-containing receptor A', NULL, NULL, NULL, NULL, NULL, 4),
(44500, NULL, 'G3DSA:1.10.10.160:FF:000056', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(44501, NULL, 'G3DSA:3.30.70.1180:FF:000014', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(44502, NULL, 'G3DSA:1.10.287.70:FF:000574', NULL, NULL, 'ATP-sensitive inward rectifier potassium channel 12-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(44503, NULL, 'G3DSA:3.90.1170.40:FF:000015', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(44504, NULL, 'G3DSA:1.10.1300.10:FF:000037', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(44505, NULL, 'G3DSA:2.10.25.10:FF:001311', NULL, NULL, 'Multiple EGF like domains 8', NULL, NULL, NULL, NULL, NULL, 4),
(44506, NULL, 'G3DSA:2.40.10.10:FF:000641', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44507, NULL, 'G3DSA:2.10.50.10:FF:000094', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(44508, NULL, 'G3DSA:1.20.120.980:FF:000008', NULL, NULL, 'Serine protease 16', NULL, NULL, NULL, NULL, NULL, 4),
(44509, NULL, 'G3DSA:1.10.287.160:FF:000017', NULL, NULL, 'Target of rapamycin complex 2 subunit ste20', NULL, NULL, NULL, NULL, NULL, 4),
(44510, NULL, 'G3DSA:3.30.70.330:FF:000539', NULL, NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(44511, NULL, 'G3DSA:3.30.200.20:FF:002152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44512, NULL, 'G3DSA:3.40.50.2300:FF:001623', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44513, NULL, 'G3DSA:3.30.450.30:FF:000020', NULL, NULL, 'Profilin', NULL, NULL, NULL, NULL, NULL, 4),
(44514, NULL, 'G3DSA:3.30.420.40:FF:000813', NULL, NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(44515, NULL, 'G3DSA:3.30.60.30:FF:000226', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(44516, NULL, 'G3DSA:3.30.559.30:FF:000008', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(44517, NULL, 'G3DSA:1.20.245.10:FF:000002', NULL, NULL, 'Lipoxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(44518, NULL, 'G3DSA:2.10.25.10:FF:000294', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(44519, NULL, 'G3DSA:3.60.21.10:FF:000314', NULL, NULL, 'Serine/threonine protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(44520, NULL, 'G3DSA:1.25.10.10:FF:000459', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(44521, NULL, 'G3DSA:2.60.40.10:FF:001529', NULL, NULL, 'Cell adhesion molecule', NULL, NULL, NULL, NULL, NULL, 4),
(44522, NULL, 'G3DSA:1.20.1640.10:FF:000072', NULL, NULL, 'Hopanoid biosynthesis associated RND transporter like protein HpnN', NULL, NULL, NULL, NULL, NULL, 4),
(44523, NULL, 'G3DSA:1.20.120.960:FF:000002', NULL, NULL, 'Sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(44524, NULL, 'G3DSA:2.60.40.10:FF:001732', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(44525, NULL, 'G3DSA:3.40.50.300:FF:007022', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(44526, NULL, 'G3DSA:3.90.550.50:FF:000020', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(44527, NULL, 'G3DSA:2.60.120.10:FF:000195', NULL, NULL, 'Putative quercetin 2,3-dioxygenase Rv0181c', NULL, NULL, NULL, NULL, NULL, 4),
(44528, NULL, 'G3DSA:1.20.120.1760:FF:000070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44529, NULL, 'G3DSA:1.10.1600.10:FF:000021', NULL, NULL, 'Putative dna-binding subunit of a dna-dependent protein kinase ku70 autoantigen', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(44530, NULL, 'G3DSA:3.30.450.20:FF:000247', NULL, NULL, 'Aryl hydrocarbon receptor protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(44531, NULL, 'G3DSA:1.25.10.10:FF:000987', NULL, NULL, 'Putative splicing factor 3B subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(44532, NULL, 'G3DSA:3.30.420.40:FF:000757', NULL, NULL, 'Actin-like 6B', NULL, NULL, NULL, NULL, NULL, 4),
(44533, NULL, 'G3DSA:3.80.10.10:FF:000007', NULL, NULL, 'Leucine-rich repeat and calponin homology domain-containing protein 1 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(44534, NULL, 'G3DSA:3.50.30.30:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44535, NULL, 'G3DSA:3.60.21.10:FF:000461', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44536, NULL, 'G3DSA:3.40.50.720:FF:001465', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(44537, NULL, 'G3DSA:1.25.40.10:FF:002052', NULL, NULL, 'Protein CLMP1', NULL, NULL, NULL, NULL, NULL, 4),
(44538, NULL, 'G3DSA:1.20.5.340:FF:000025', NULL, NULL, 'Myosin heavy chain, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(44539, NULL, 'G3DSA:1.20.1110.10:FF:000043', NULL, NULL, 'Metal ABC transporter ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(44540, NULL, 'G3DSA:3.50.50.60:FF:000138', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(44541, NULL, 'G3DSA:1.20.58.1970:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44542, NULL, 'G3DSA:3.30.200.20:FF:002005', NULL, NULL, 'Kinase', NULL, NULL, NULL, NULL, NULL, 4),
(44543, NULL, 'G3DSA:3.90.199.10:FF:000005', NULL, NULL, 'DNA topoisomerase (ATP-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4),
(44544, NULL, 'G3DSA:2.30.30.380:FF:000022', NULL, NULL, 'calpain-D isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(44545, NULL, 'G3DSA:3.40.50.300:FF:006746', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44546, NULL, 'G3DSA:2.40.50.730:FF:000016', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(44547, NULL, 'G3DSA:3.30.160.60:FF:006240', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44548, NULL, 'G3DSA:1.10.8.10:FF:000295', NULL, NULL, 'UBX domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(44549, NULL, 'G3DSA:2.60.40.2140:FF:000003', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(44550, NULL, 'G3DSA:3.30.40.10:FF:001905', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44551, NULL, 'G3DSA:2.60.120.10:FF:000048', NULL, NULL, 'Protein phosphatase 2C and cyclic nucleotide-binding/kinase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(44552, NULL, 'G3DSA:1.20.920.10:FF:000217', NULL, NULL, 'WD-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(44553, NULL, 'G3DSA:3.50.50.60:FF:000666', NULL, NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme GidA', NULL, NULL, NULL, NULL, NULL, 4),
(44554, NULL, 'G3DSA:1.20.1070.10:FF:000724', NULL, NULL, 'Putative G-protein coupled receptor 101', NULL, NULL, NULL, NULL, NULL, 4),
(44555, NULL, 'G3DSA:1.20.1560.10:FF:000071', NULL, NULL, 'ATP binding cassette subfamily B member 5', NULL, NULL, NULL, NULL, NULL, 4),
(44556, NULL, 'G3DSA:3.30.40.10:FF:000040', NULL, NULL, 'E3 ubiquitin protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(44557, NULL, 'G3DSA:3.40.50.1700:FF:000055', NULL, NULL, 'Probable beta-glucosidase O', NULL, NULL, NULL, NULL, NULL, 4),
(44558, NULL, 'G3DSA:1.20.1250.20:FF:000679', NULL, NULL, 'Putative hexose transporter', NULL, NULL, NULL, NULL, NULL, 4),
(44559, NULL, 'G3DSA:3.40.50.1010:FF:000236', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44560, NULL, 'G3DSA:3.30.160.60:FF:005779', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44561, NULL, 'G3DSA:1.25.10.10:FF:002371', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44562, NULL, 'G3DSA:2.60.200.10:FF:000049', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(44563, NULL, 'G3DSA:1.20.1020.10:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(44564, NULL, 'G3DSA:1.20.1420.30:FF:000044', NULL, NULL, 'sodium/potassium/calcium exchanger 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(44565, NULL, 'G3DSA:3.30.479.30:FF:000007', NULL, NULL, 'Protein HflK', NULL, NULL, NULL, NULL, NULL, 4),
(44566, NULL, 'G3DSA:3.90.226.10:FF:000289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44567, NULL, 'G3DSA:3.40.50.10900:FF:000032', NULL, NULL, 'Proteasome assembly chaperone 2', NULL, NULL, NULL, NULL, NULL, 4),
(44568, NULL, 'G3DSA:4.10.640.10:FF:000024', NULL, NULL, 'GM16961', NULL, NULL, NULL, NULL, NULL, 4),
(44569, NULL, 'G3DSA:3.40.50.80:FF:000049', NULL, NULL, 'Nitrate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(44570, NULL, 'G3DSA:1.20.1280.50:FF:000050', NULL, NULL, 'F-box and leucine-rich repeat protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(44571, NULL, 'G3DSA:1.10.510.10:FF:003241', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44572, NULL, 'G3DSA:3.40.50.80:FF:000105', NULL, NULL, 'Ferric-chelate reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(44573, NULL, 'G3DSA:3.40.630.30:FF:000532', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(44574, NULL, 'G3DSA:2.40.128.20:FF:000040', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(44575, NULL, 'G3DSA:3.10.660.10:FF:000006', NULL, NULL, 'Diphthamide biosynthesis protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(44576, NULL, 'G3DSA:1.10.3430.10:FF:000013', NULL, NULL, 'Rh-like protein/ammonium transporter', NULL, NULL, NULL, NULL, NULL, 4),
(44577, NULL, 'G3DSA:3.30.160.60:FF:006184', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44578, NULL, 'G3DSA:2.60.40.10:FF:005571', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44579, NULL, 'G3DSA:3.30.9.10:FF:000040', NULL, NULL, 'D-aspartate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(44580, NULL, 'G3DSA:2.60.40.10:FF:005947', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44581, NULL, 'G3DSA:2.30.29.30:FF:000375', NULL, NULL, 'Related to Neural Wiskott-Aldrich syndrome protein', NULL, NULL, NULL, NULL, NULL, 4),
(44582, NULL, 'G3DSA:2.60.120.10:FF:000380', NULL, NULL, 'cAMP/cGMP-dependent 3'',5''-cAMP/cGMP phosphodiesterase B', NULL, NULL, NULL, NULL, NULL, 4),
(44583, NULL, 'G3DSA:3.40.50.1000:FF:000290', NULL, NULL, 'glycerol-3-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(44584, NULL, 'G3DSA:2.30.140.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44585, NULL, 'G3DSA:3.30.160.60:FF:003834', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44586, NULL, 'G3DSA:3.40.50.620:FF:000620', NULL, NULL, 'CPD photolyase type II', NULL, NULL, NULL, NULL, NULL, 4),
(44587, NULL, 'G3DSA:1.10.1520.10:FF:000020', NULL, NULL, 'Protein NUCLEAR FUSION DEFECTIVE 2', NULL, NULL, NULL, NULL, NULL, 4),
(44588, NULL, 'G3DSA:1.25.40.10:FF:003013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44589, NULL, 'G3DSA:1.20.920.30:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44590, NULL, 'G3DSA:3.10.20.90:FF:000501', NULL, NULL, 'WGS project CABT00000000 data, contig 2.11', NULL, NULL, NULL, NULL, NULL, 4),
(44591, NULL, 'G3DSA:3.40.50.1000:FF:000143', NULL, NULL, 'Phosphoserine phosphatase serb', NULL, NULL, NULL, NULL, NULL, 4),
(44592, NULL, 'G3DSA:1.10.287.1150:FF:000023', NULL, NULL, 'Putative 2-oxoglutarate dehydrogenase E1 component DHKTD1 homolog, mitochondrial-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(44593, NULL, 'G3DSA:1.10.1280.10:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44594, NULL, 'G3DSA:3.30.200.20:FF:001044', NULL, NULL, 'Serine/threonine-protein kinase MRCK beta', NULL, NULL, NULL, NULL, NULL, 4),
(44595, NULL, 'G3DSA:1.10.10.60:FF:000209', NULL, NULL, 'Psp operon transcriptional activator', NULL, NULL, NULL, NULL, NULL, 4),
(44596, NULL, 'G3DSA:1.20.58.60:FF:000662', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44597, NULL, 'G3DSA:1.10.340.70:FF:000002', NULL, NULL, 'Zinc finger and BTB domain-containing protein 11', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(44598, NULL, 'G3DSA:3.40.50.150:FF:001356', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44599, NULL, 'G3DSA:3.40.50.300:FF:005785', NULL, NULL, 'DNA repair and recombination protein, putative helicase', NULL, NULL, NULL, NULL, NULL, 4),
(44600, NULL, 'G3DSA:3.30.479.10:FF:000001', NULL, NULL, '6-carboxy-5,6,7,8-tetrahydropterin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(44601, NULL, 'G3DSA:3.40.720.10:FF:000353', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44602, NULL, 'G3DSA:3.40.720.10:FF:000168', NULL, NULL, 'Iduronate-2-sulfatase and sulfatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(44603, NULL, 'G3DSA:3.40.50.720:FF:001521', NULL, NULL, 'Hydroxysteroid (17-beta) dehydrogenase 14', NULL, NULL, NULL, NULL, NULL, 4),
(44604, NULL, 'G3DSA:3.40.50.10470:FF:000004', NULL, NULL, 'Translation initiation factor eIF-2B subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(44605, NULL, 'G3DSA:3.30.420.10:FF:000653', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44606, NULL, 'G3DSA:2.70.170.10:FF:000061', NULL, NULL, 'Ligand-gated ion channel 4', NULL, NULL, NULL, NULL, NULL, 4),
(44607, NULL, 'G3DSA:2.10.10.20:FF:000010', NULL, NULL, 'Chitin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(44608, NULL, 'G3DSA:2.60.40.10:FF:004082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44609, NULL, 'G3DSA:2.30.40.10:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44610, NULL, 'G3DSA:1.20.1310.10:FF:000204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44611, NULL, 'G3DSA:1.20.120.140:FF:000015', NULL, NULL, 'Signal peptide binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(44612, NULL, 'G3DSA:2.60.40.3210:FF:000015', NULL, NULL, 'Si:ch211-14a17.6', NULL, NULL, NULL, NULL, NULL, 4),
(44613, NULL, 'G3DSA:3.40.50.2000:FF:000398', NULL, NULL, 'AGAP009137-PA', NULL, NULL, NULL, NULL, NULL, 4),
(44614, NULL, 'G3DSA:3.30.559.10:FF:000002', NULL, NULL, 'carnitine O-palmitoyltransferase 1, liver isoform', NULL, NULL, NULL, NULL, NULL, 4),
(44615, NULL, 'G3DSA:3.40.1280.10:FF:000060', NULL, NULL, 'rRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(44616, NULL, 'G3DSA:3.10.610.10:FF:000003', NULL, NULL, 'General secretion pathway protein J', NULL, NULL, NULL, NULL, NULL, 4),
(44617, NULL, 'G3DSA:1.25.40.180:FF:000125', NULL, NULL, 'Putative eukaryotic translation initiation factor 4 gamma', NULL, NULL, NULL, NULL, NULL, 4),
(44618, NULL, 'G3DSA:2.130.10.10:FF:002261', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44619, NULL, 'G3DSA:2.60.40.10:FF:001676', NULL, NULL, 'CD96 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(44620, NULL, 'G3DSA:3.30.420.40:FF:001033', NULL, NULL, 'Heat shock protein 70 family', NULL, NULL, NULL, NULL, NULL, 4),
(44621, NULL, 'G3DSA:3.40.50.300:FF:001367', NULL, NULL, 'Elongation factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(44622, NULL, 'G3DSA:3.30.160.60:FF:001889', NULL, NULL, 'Paternally-expressed gene 3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(44623, NULL, 'G3DSA:1.25.40.10:FF:001776', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(44624, NULL, 'G3DSA:1.20.1420.30:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44625, NULL, 'G3DSA:2.40.30.10:FF:000440', NULL, NULL, 'Elongation factor Tu', NULL, NULL, NULL, NULL, NULL, 4),
(44626, NULL, 'G3DSA:2.60.120.260:FF:000114', NULL, NULL, 'Glycoside hydrolase family 3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(44627, NULL, 'G3DSA:3.60.40.10:FF:000061', NULL, NULL, 'Probable protein phosphatase 2C 67', NULL, NULL, NULL, NULL, NULL, 4),
(44628, NULL, 'G3DSA:3.40.1360.10:FF:000061', NULL, NULL, 'Spo11-like type II topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(44629, NULL, 'G3DSA:3.40.50.300:FF:001570', NULL, NULL, 'Adenylate isopentenyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(44630, NULL, 'G3DSA:3.30.1490.190:FF:000027', NULL, NULL, 'Ferric uptake regulation protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(44631, NULL, 'G3DSA:1.10.630.10:FF:000170', NULL, NULL, 'Cytochrome P450 137', NULL, NULL, NULL, NULL, NULL, 4),
(44632, NULL, 'G3DSA:3.40.850.10:FF:000357', NULL, NULL, 'Myosin, heavy chain 11a, smooth muscle', NULL, NULL, NULL, NULL, NULL, 4),
(44633, NULL, 'G3DSA:3.30.70.330:FF:001091', NULL, NULL, 'Protein CBR-RNP-8.1', NULL, NULL, NULL, NULL, NULL, 4),
(44634, NULL, 'G3DSA:2.120.10.30:FF:000463', NULL, NULL, 'RING finger-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(44635, NULL, 'G3DSA:1.20.1560.10:FF:000632', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44636, NULL, 'G3DSA:3.30.160.60:FF:001945', NULL, NULL, 'Zinc finger protein 559', NULL, NULL, NULL, NULL, NULL, 4),
(44637, NULL, 'G3DSA:2.60.40.420:FF:000052', NULL, NULL, 'Iron uptake system component EfeO', NULL, NULL, NULL, NULL, NULL, 4),
(44638, NULL, 'G3DSA:4.10.1000.40:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44639, NULL, 'G3DSA:3.30.40.10:FF:000601', NULL, NULL, 'Nitric oxide synthase-interacting protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(44640, NULL, 'G3DSA:3.30.950.10:FF:000030', NULL, NULL, 'Uroporphyrin-III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(44641, NULL, 'G3DSA:3.90.550.10:FF:000379', NULL, NULL, 'Alpha-D-GlcNAc-pyrophosphate polyprenol, alpha-3-L-rhamnosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(44642, NULL, 'G3DSA:1.20.1260.10:FF:000031', NULL, NULL, 'Neutrophil activating protein A (NapA)', NULL, NULL, NULL, NULL, NULL, 4),
(44643, NULL, 'G3DSA:3.40.850.10:FF:000413', NULL, NULL, 'Kinesin heavy chain isoform 5C', NULL, NULL, NULL, NULL, NULL, 4),
(44644, NULL, 'G3DSA:3.10.110.10:FF:000089', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 I', NULL, NULL, NULL, NULL, NULL, 4),
(44645, NULL, 'G3DSA:2.10.220.10:FF:000045', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 4', NULL, NULL, NULL, NULL, NULL, 4),
(44646, NULL, 'G3DSA:2.40.30.10:FF:000108', NULL, NULL, 'Vanillate O-demethylase oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(44647, NULL, 'G3DSA:2.60.40.10:FF:005386', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44648, NULL, 'G3DSA:3.30.160.60:FF:002345', NULL, NULL, 'YPR013C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(44649, NULL, 'G3DSA:2.60.40.10:FF:004458', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44650, NULL, 'G3DSA:2.40.30.230:FF:000008', NULL, NULL, 'ATP-dependent helicase upf1', NULL, NULL, NULL, NULL, NULL, 4),
(44651, NULL, 'G3DSA:1.10.565.10:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44652, NULL, 'G3DSA:1.20.120.1750:FF:000010', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(44653, NULL, 'G3DSA:3.40.1170.60:FF:000021', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(44654, NULL, 'G3DSA:1.10.760.10:FF:000027', NULL, NULL, 'Nitrite reductase', NULL, NULL, NULL, NULL, NULL, 4),
(44655, NULL, 'G3DSA:3.30.505.10:FF:000030', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(44656, NULL, 'G3DSA:1.10.3060.10:FF:000001', NULL, NULL, 'Preprotein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(44657, NULL, 'G3DSA:2.60.120.290:FF:000185', NULL, NULL, 'Soluble neuropilin 2a2', NULL, NULL, NULL, NULL, NULL, 4),
(44658, NULL, 'G3DSA:3.30.2320.80:FF:000008', NULL, NULL, 'Hydrogenase maturation factor HypA 2', NULL, NULL, NULL, NULL, NULL, 4),
(44659, NULL, 'G3DSA:3.30.160.20:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44660, NULL, 'G3DSA:1.10.10.10:FF:001004', NULL, NULL, 'Heat shock transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(44661, NULL, 'G3DSA:3.10.20.230:FF:000032', NULL, NULL, 'Doublecortin', NULL, NULL, NULL, NULL, NULL, 4),
(44662, NULL, 'G3DSA:1.10.10.970:FF:000001', NULL, NULL, 'RNA 2''-phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(44663, NULL, 'G3DSA:2.130.10.10:FF:002109', NULL, NULL, 'WD repeat protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(44664, NULL, 'G3DSA:1.10.510.10:FF:001296', NULL, NULL, 'Dual serine/threonine and tyrosine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(44665, NULL, 'G3DSA:3.40.640.10:FF:000167', NULL, NULL, 'Putative serine palmitoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(44666, NULL, 'G3DSA:2.160.20.10:FF:000214', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(44667, NULL, 'G3DSA:2.130.10.10:FF:005751', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44668, NULL, 'G3DSA:3.40.50.150:FF:000428', NULL, NULL, 'Alkylated DNA repair protein alkB homolog 8', NULL, NULL, NULL, NULL, NULL, 4),
(44669, NULL, 'G3DSA:3.30.70.1620:FF:000011', NULL, NULL, 'Structural maintenance of chromosomes protein', NULL, NULL, NULL, NULL, NULL, 4),
(44670, NULL, 'G3DSA:3.40.50.2000:FF:000578', NULL, NULL, 'Glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(44671, NULL, 'G3DSA:1.10.472.30:FF:000009', NULL, NULL, 'Transcription factor BYE1', NULL, NULL, NULL, NULL, NULL, 4),
(44672, NULL, 'G3DSA:3.40.50.1820:FF:000001', NULL, NULL, 'Neuroligin 3 isoform', NULL, NULL, NULL, NULL, NULL, 4),
(44673, NULL, 'G3DSA:1.10.287.600:FF:000014', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(44674, NULL, 'G3DSA:3.90.1010.10:FF:000023', NULL, NULL, 'Iron-sulfur cluster assembly scaffold protein', NULL, NULL, NULL, NULL, NULL, 4),
(44675, NULL, 'G3DSA:1.25.40.20:FF:001689', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(44676, NULL, 'G3DSA:3.60.21.50:FF:000006', NULL, NULL, 'DNA polymerase delta subunit 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(44677, NULL, 'G3DSA:1.25.50.20:FF:000026', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(44678, NULL, 'G3DSA:3.30.40.10:FF:002366', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(44679, NULL, 'G3DSA:3.40.30.10:FF:000634', NULL, NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(44680, NULL, 'G3DSA:3.60.10.10:FF:000233', NULL, NULL, 'Endonuclease/Exonuclease/phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(44681, NULL, 'G3DSA:1.20.1070.10:FF:000016', NULL, NULL, 'Adhesion G protein-coupled receptor B2', NULL, NULL, NULL, NULL, NULL, 4),
(44682, NULL, 'G3DSA:2.130.10.10:FF:001709', NULL, NULL, 'Elongator complex protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(44683, NULL, 'G3DSA:2.60.40.10:FF:000187', NULL, NULL, 'neogenin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(44684, NULL, 'G3DSA:1.20.1560.10:FF:000576', NULL, NULL, 'Protein CBR-PGP-9', NULL, NULL, NULL, NULL, NULL, 4),
(44685, NULL, 'G3DSA:2.10.25.10:FF:001598', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44686, NULL, 'G3DSA:2.30.40.10:FF:000019', NULL, NULL, 'Urease subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(44687, NULL, 'G3DSA:1.10.630.10:FF:000546', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44688, NULL, 'G3DSA:1.10.10.440:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44689, NULL, 'G3DSA:3.30.450.20:FF:000394', NULL, NULL, 'Membrane-anchored chemotaxis sensory transducer', NULL, NULL, NULL, NULL, NULL, 4),
(44690, NULL, 'G3DSA:3.40.50.300:FF:005257', NULL, NULL, 'Probable thymidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(44691, NULL, 'G3DSA:2.130.10.10:FF:006004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44692, NULL, 'G3DSA:3.40.50.300:FF:002531', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(44693, NULL, 'G3DSA:3.20.19.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44694, NULL, 'G3DSA:1.25.40.10:FF:003541', NULL, NULL, 'LD41803p', NULL, NULL, NULL, NULL, NULL, 4),
(44695, NULL, 'G3DSA:3.30.1370.210:FF:000007', NULL, NULL, 'Zinc finger CCCH domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(44696, NULL, 'G3DSA:1.10.10.10:FF:000043', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(44697, NULL, 'G3DSA:2.60.120.10:FF:000228', NULL, NULL, 'Acetyltransferase Pat', NULL, NULL, NULL, NULL, NULL, 4),
(44698, NULL, 'G3DSA:2.80.10.50:FF:000162', NULL, NULL, 'Putative fibroblast growth factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(44699, NULL, 'G3DSA:2.10.90.10:FF:000068', NULL, NULL, 'AGAP000342-PA', NULL, NULL, NULL, NULL, NULL, 4),
(44700, NULL, 'G3DSA:3.40.1110.10:FF:000435', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44701, NULL, 'G3DSA:2.130.10.10:FF:001856', NULL, NULL, 'Bromodomain and WD repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(44702, NULL, 'G3DSA:1.20.920.60:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44703, NULL, 'G3DSA:1.10.10.60:FF:001137', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44704, NULL, 'G3DSA:1.10.12.10:FF:000025', NULL, NULL, 'Enoyl-CoA hydratase EchA19', NULL, NULL, NULL, NULL, NULL, 4),
(44705, NULL, 'G3DSA:2.30.30.140:FF:000186', NULL, NULL, 'Acylphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(44706, NULL, 'G3DSA:3.20.20.70:FF:000410', NULL, NULL, 'Radical SAM domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(44707, NULL, 'G3DSA:1.20.120.850:FF:000025', NULL, NULL, 'Protein CBR-SSL-1', NULL, NULL, NULL, NULL, NULL, 4),
(44708, NULL, 'G3DSA:3.30.160.60:FF:002906', NULL, NULL, 'Protein CBR-LSY-2', NULL, NULL, NULL, NULL, NULL, 4),
(44709, NULL, 'G3DSA:2.60.40.150:FF:000712', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(44710, NULL, 'G3DSA:1.25.10.10:FF:002224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44711, NULL, 'G3DSA:1.25.40.20:FF:000200', NULL, NULL, 'ankyrin repeat domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(44712, NULL, 'G3DSA:3.30.1120.30:FF:000040', NULL, NULL, 'Probable serine/threonine-protein kinase CCRP1', NULL, NULL, NULL, NULL, NULL, 4),
(44713, NULL, 'G3DSA:3.80.10.10:FF:003121', NULL, NULL, 'Leucine-rich, glioma inactivated 1b', NULL, NULL, NULL, NULL, NULL, 4),
(44714, NULL, 'G3DSA:1.25.10.10:FF:001948', NULL, NULL, 'HECT-domain (Ubiquitin-transferase), putative', NULL, NULL, NULL, NULL, NULL, 4),
(44715, NULL, 'G3DSA:1.20.1540.10:FF:000069', NULL, NULL, 'Rhombosortase', NULL, NULL, NULL, NULL, NULL, 4),
(44716, NULL, 'G3DSA:2.60.40.10:FF:005419', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44717, NULL, 'G3DSA:1.10.225.10:FF:000020', NULL, NULL, 'Saposin-related', NULL, NULL, NULL, NULL, NULL, 4),
(44718, NULL, 'G3DSA:2.20.110.10:FF:000023', NULL, NULL, 'GD23870', NULL, NULL, NULL, NULL, NULL, 4),
(44719, NULL, 'G3DSA:2.60.40.10:FF:001024', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(44720, NULL, 'G3DSA:2.130.10.120:FF:000006', NULL, NULL, 'Prolyl oligopeptidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(44721, NULL, 'G3DSA:2.60.120.260:FF:000642', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44722, NULL, 'G3DSA:3.30.70.590:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44723, NULL, 'G3DSA:3.30.420.40:FF:000105', NULL, NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(44724, NULL, 'G3DSA:3.30.720.10:FF:000018', NULL, NULL, 'Signal recognition particle 14kD protein', NULL, NULL, NULL, NULL, NULL, 4),
(44725, NULL, 'G3DSA:1.20.5.190:FF:000014', NULL, NULL, 'IQ motif containing F5', NULL, NULL, NULL, NULL, NULL, 4),
(44726, NULL, 'G3DSA:3.30.230.120:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44727, NULL, 'G3DSA:2.60.40.840:FF:000003', NULL, NULL, 'Kurtz arrestin', NULL, NULL, NULL, NULL, NULL, 4),
(44728, NULL, 'G3DSA:3.20.80.10:FF:000008', NULL, NULL, 'SOUL heme-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(44729, NULL, 'G3DSA:3.40.50.300:FF:006802', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44730, NULL, 'G3DSA:1.10.840.10:FF:000028', NULL, NULL, 'Cell division control protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(44731, NULL, 'G3DSA:3.30.800.10:FF:000019', NULL, NULL, 'Unplaced genomic scaffold supercont1.157, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(44732, NULL, 'G3DSA:1.20.120.1770:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44733, NULL, 'G3DSA:2.170.120.20:FF:000019', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(44734, NULL, 'G3DSA:4.10.1130.20:FF:000007', NULL, NULL, 'CHORD, putative', NULL, NULL, NULL, NULL, NULL, 4),
(44735, NULL, 'G3DSA:1.50.40.10:FF:000307', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44736, NULL, 'G3DSA:4.10.410.10:FF:000035', NULL, NULL, 'Protein CBR-MLT-11', NULL, NULL, NULL, NULL, NULL, 4),
(44737, NULL, 'G3DSA:2.60.40.10:FF:000748', NULL, NULL, 'Uncharacterized protein, isoform J', NULL, NULL, NULL, NULL, NULL, 4),
(44738, NULL, 'G3DSA:2.30.29.30:FF:001207', NULL, NULL, 'Goodpasture antigen-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(44739, NULL, 'G3DSA:1.10.10.10:FF:000751', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(44740, NULL, 'G3DSA:1.20.58.870:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44741, NULL, 'G3DSA:1.25.10.10:FF:002932', NULL, NULL, 'AP-3 complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(44742, NULL, 'G3DSA:1.10.560.10:FF:000023', NULL, NULL, 'T-complex protein 1, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(44743, NULL, 'G3DSA:2.60.40.10:FF:000035', NULL, NULL, 'Contactin 1', NULL, NULL, NULL, NULL, NULL, 4),
(44744, NULL, 'G3DSA:3.40.5.120:FF:000004', NULL, NULL, 'Chromodomain-helicase-DNA-binding protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(44745, NULL, 'G3DSA:1.20.1280.290:FF:000006', NULL, NULL, 'mannose-P-dolichol utilization defect 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(44746, NULL, 'G3DSA:1.10.10.570:FF:000010', NULL, NULL, 'ESCRT-II complex subunit-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(44747, NULL, 'G3DSA:1.10.8.60:FF:000580', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44748, NULL, 'G3DSA:1.20.1250.90:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44749, NULL, 'G3DSA:2.102.10.10:FF:000059', NULL, NULL, 'Cytochrome b6/f complex iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4),
(44750, NULL, 'G3DSA:1.10.640.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44751, NULL, 'G3DSA:2.60.120.650:FF:000017', NULL, NULL, 'lysine-specific demethylase hairless isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(44752, NULL, 'G3DSA:3.40.20.10:FF:000077', NULL, NULL, 'Gelsolin, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(44753, NULL, 'G3DSA:3.90.1110.10:FF:000019', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(44754, NULL, 'G3DSA:1.20.5.170:FF:000272', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(44755, NULL, 'G3DSA:1.20.1250.20:FF:001079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44756, NULL, 'G3DSA:2.40.30.170:FF:000024', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(44757, NULL, 'G3DSA:3.40.50.300:FF:005818', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44758, NULL, 'G3DSA:1.10.150.50:FF:000021', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(44759, NULL, 'G3DSA:3.40.390.30:FF:000001', NULL, NULL, 'Endoribonuclease YbeY', NULL, NULL, NULL, NULL, NULL, 4),
(44760, NULL, 'G3DSA:3.30.200.20:FF:002264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44761, NULL, 'G3DSA:3.40.50.720:FF:000976', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(44762, NULL, 'G3DSA:3.40.1110.10:FF:000082', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(44763, NULL, 'G3DSA:3.30.70.100:FF:000111', NULL, NULL, 'Heavy metal translocating P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(44764, NULL, 'G3DSA:1.20.120.1240:FF:000037', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(44765, NULL, 'G3DSA:1.20.810.10:FF:000030', NULL, NULL, 'Cytochrome b mRNA maturase bI2', NULL, NULL, NULL, NULL, NULL, 4),
(44766, NULL, 'G3DSA:3.40.50.1000:FF:000166', NULL, NULL, 'Cytosolic 5-nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(44767, NULL, 'G3DSA:3.30.160.60:FF:001092', NULL, NULL, 'Wilms tumor protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(44768, NULL, 'G3DSA:1.25.40.10:FF:001416', NULL, NULL, 'Tetratricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(44769, NULL, 'G3DSA:3.40.50.300:FF:007382', NULL, NULL, 'Guanylate-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(44770, NULL, 'G3DSA:1.10.10.41:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44771, NULL, 'G3DSA:2.30.36.90:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44772, NULL, 'G3DSA:3.40.50.300:FF:008371', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44773, NULL, 'G3DSA:3.20.20.60:FF:000020', NULL, NULL, 'Malyl-CoA lyase', NULL, NULL, NULL, NULL, NULL, 4),
(44774, NULL, 'G3DSA:3.40.630.30:FF:000408', NULL, NULL, 'O-GlcNAc selective N-Acetyl-beta-D-glucosaminidase (O-GlcNAcase)', NULL, NULL, NULL, NULL, NULL, 4),
(44775, NULL, 'G3DSA:3.80.10.10:FF:002216', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(44776, NULL, 'G3DSA:2.60.40.10:FF:001496', NULL, NULL, 'Plexin A, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(44777, NULL, 'G3DSA:1.20.59.10:FF:000020', NULL, NULL, 'Chorismate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(44778, NULL, 'G3DSA:3.30.70.330:FF:000955', NULL, NULL, 'RNA binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(44779, NULL, 'G3DSA:3.30.1490.20:FF:000002', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(44780, NULL, 'G3DSA:3.40.50.1240:FF:000007', NULL, NULL, 'Phosphoglycerate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(44781, NULL, 'G3DSA:3.40.50.1440:FF:000163', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(44782, NULL, 'G3DSA:3.40.50.300:FF:000294', NULL, NULL, 'ADP-ribosylation factor-like protein 5A', NULL, NULL, NULL, NULL, NULL, 4),
(44783, NULL, 'G3DSA:3.40.630.10:FF:000402', NULL, NULL, 'Peptidase M20', NULL, NULL, NULL, NULL, NULL, 4),
(44784, NULL, 'G3DSA:2.40.70.10:FF:000026', NULL, NULL, 'Endothiapepsin', NULL, NULL, NULL, NULL, NULL, 4),
(44785, NULL, 'G3DSA:3.30.1640.10:FF:000062', NULL, NULL, 'DNA replication licensing factor mcm6', NULL, NULL, NULL, NULL, NULL, 4),
(44786, NULL, 'G3DSA:2.20.80.10:FF:000022', NULL, NULL, 'Hemelipoglyco-carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(44787, NULL, 'G3DSA:3.40.50.150:FF:000108', NULL, NULL, 'DNA (cytosine-5)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(44788, NULL, 'G3DSA:3.90.79.20:FF:000016', NULL, NULL, 'NADH pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(44789, NULL, 'G3DSA:3.100.10.10:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44790, NULL, 'G3DSA:2.40.10.10:FF:000489', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44791, NULL, 'G3DSA:2.30.42.10:FF:000501', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44792, NULL, 'G3DSA:1.10.472.80:FF:000007', NULL, NULL, 'Rab GTPase-activating protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(44793, NULL, 'G3DSA:3.30.1240.10:FF:000065', NULL, NULL, 'Hydrolase, haloacid dehalogenase-like hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(44794, NULL, 'G3DSA:1.10.630.10:FF:000731', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(44795, NULL, 'G3DSA:1.25.40.10:FF:000427', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(44796, NULL, 'G3DSA:1.10.1070.11:FF:000132', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(44797, NULL, 'G3DSA:2.30.42.10:FF:000389', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44798, NULL, 'G3DSA:1.20.58.340:FF:000002', NULL, NULL, 'Zinc transport protein ZntB', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(44799, NULL, 'G3DSA:3.90.1030.10:FF:000018', NULL, NULL, '50S ribosomal protein L17', NULL, NULL, NULL, NULL, NULL, 4),
(44800, NULL, 'G3DSA:2.60.40.1590:FF:000001', NULL, NULL, 'Peptidase M23', NULL, NULL, NULL, NULL, NULL, 4),
(44801, NULL, 'G3DSA:1.10.10.10:FF:000127', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(44802, NULL, 'G3DSA:2.40.270.10:FF:000013', NULL, NULL, 'DNA-directed RNA polymerase II subunit RPB2', NULL, NULL, NULL, NULL, NULL, 4),
(44803, NULL, 'G3DSA:3.30.160.60:FF:002822', NULL, NULL, 'Unplaced genomic scaffold supercont1.138, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(44804, NULL, 'G3DSA:1.10.510.10:FF:002549', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(44805, NULL, 'G3DSA:2.10.25.10:FF:000081', NULL, NULL, 'Netrin 1', NULL, NULL, NULL, NULL, NULL, 4),
(44806, NULL, 'G3DSA:3.40.50.300:FF:002643', NULL, NULL, 'YDR061W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(44807, NULL, 'G3DSA:3.90.480.20:FF:000005', NULL, NULL, 'Nitrite/sulfite reductase, 4Fe-4S iron-sulfur cluster-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(44808, NULL, 'G3DSA:1.20.58.80:FF:000089', NULL, NULL, 'Sorting nexin 15', NULL, NULL, NULL, NULL, NULL, 4),
(44809, NULL, 'G3DSA:2.60.40.60:FF:001078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44810, NULL, 'G3DSA:3.90.226.10:FF:000025', NULL, NULL, 'Peroxisomal fatty acid beta-oxidation multifunctional protein', NULL, NULL, NULL, NULL, NULL, 4),
(44811, NULL, 'G3DSA:3.30.450.20:FF:000478', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44812, NULL, 'G3DSA:1.25.10.10:FF:002112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44813, NULL, 'G3DSA:3.40.50.10810:FF:000185', NULL, NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily A-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(44814, NULL, 'G3DSA:3.30.9.10:FF:000208', NULL, NULL, 'Dao1p', NULL, NULL, NULL, NULL, NULL, 4),
(44815, NULL, 'G3DSA:2.130.10.10:FF:004442', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44816, NULL, 'G3DSA:1.25.40.10:FF:003721', NULL, NULL, 'Tetratricopeptide repeat domain 36', NULL, NULL, NULL, NULL, NULL, 4),
(44817, NULL, 'G3DSA:3.80.10.10:FF:001699', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44818, NULL, 'G3DSA:3.30.200.20:FF:001275', NULL, NULL, 'Serine/threonine/tyrosine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(44819, NULL, 'G3DSA:1.10.630.10:FF:000198', NULL, NULL, 'Cytochrome P450, family 7, subfamily B, polypeptide 1', NULL, NULL, NULL, NULL, NULL, 4),
(44820, NULL, 'G3DSA:2.30.38.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44821, NULL, 'G3DSA:3.30.450.50:FF:000003', NULL, NULL, '25.3 kDa vesicle transport protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(44822, NULL, 'G3DSA:3.30.70.330:FF:001944', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44823, NULL, 'G3DSA:2.10.25.10:FF:000873', NULL, NULL, 'FAT atypical cadherin 2', NULL, NULL, NULL, NULL, NULL, 4),
(44824, NULL, 'G3DSA:3.40.190.290:FF:000045', NULL, NULL, 'Helix-turn-helix transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(44825, NULL, 'G3DSA:3.30.60.270:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44826, NULL, 'G3DSA:2.130.10.10:FF:001569', NULL, NULL, 'WD repeat-containing protein 74-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(44827, NULL, 'G3DSA:3.40.50.1220:FF:000001', NULL, NULL, 'Electron transfer flavoprotein, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(44828, NULL, 'G3DSA:2.70.98.10:FF:000055', NULL, NULL, 'Aldose 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(44829, NULL, 'G3DSA:1.10.8.10:FF:000328', NULL, NULL, 'UBA/TS-N domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(44830, NULL, 'G3DSA:3.20.20.80:FF:000059', NULL, NULL, 'Alpha-L-iduronidase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(44831, NULL, 'G3DSA:3.40.50.300:FF:003099', NULL, NULL, 'PhiRv1 phage protein', NULL, NULL, NULL, NULL, NULL, 4),
(44832, NULL, 'G3DSA:3.30.160.60:FF:002030', NULL, NULL, 'zinc finger protein 445 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(44833, NULL, 'G3DSA:2.130.10.10:FF:002137', NULL, NULL, 'U4/U6 small nuclear ribonucleoprotein PRP4-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(44834, NULL, 'G3DSA:3.30.160.60:FF:005695', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44835, NULL, 'G3DSA:4.10.240.10:FF:000095', NULL, NULL, 'C6 transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(44836, NULL, 'G3DSA:1.10.840.10:FF:000005', NULL, NULL, 'Ral guanine nucleotide dissociation stimulator isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(44837, NULL, 'G3DSA:3.40.50.150:FF:001569', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44838, NULL, 'G3DSA:3.40.1380.20:FF:000014', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(44839, NULL, 'G3DSA:3.40.50.150:FF:000159', NULL, NULL, 'Malonyl-[acyl-carrier protein] O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(44840, NULL, 'G3DSA:3.30.70.330:FF:002512', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44841, NULL, 'G3DSA:1.10.510.10:FF:003909', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44842, NULL, 'G3DSA:3.30.1370.10:FF:000198', NULL, NULL, 'Synaptic functional regulator FMR1', NULL, NULL, NULL, NULL, NULL, 4),
(44843, NULL, 'G3DSA:3.80.10.10:FF:000659', NULL, NULL, 'Leucine-rich repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(44844, NULL, 'G3DSA:1.20.58.870:FF:000004', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(44845, NULL, 'G3DSA:3.40.50.300:FF:005077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44846, NULL, 'G3DSA:3.60.21.10:FF:000337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44847, NULL, 'G3DSA:2.60.40.10:FF:004790', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44848, NULL, 'G3DSA:3.30.590.20:FF:000016', NULL, NULL, 'Glutamate--cysteine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(44849, NULL, 'G3DSA:1.10.240.10:FF:000027', NULL, NULL, 'Tryptophanyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(44850, NULL, 'G3DSA:3.40.190.80:FF:000074', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(44851, NULL, 'G3DSA:1.25.40.20:FF:000756', NULL, NULL, 'Mechanosensory transduction channel NOMPC', NULL, NULL, NULL, NULL, NULL, 4),
(44852, NULL, 'G3DSA:3.40.50.200:FF:000090', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(44853, NULL, 'G3DSA:3.40.50.1000:FF:000115', NULL, NULL, 'Copper-exporting P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(44854, NULL, 'G3DSA:1.10.640.10:FF:000024', NULL, NULL, 'AGAP013282-PA', NULL, NULL, NULL, NULL, NULL, 4),
(44855, NULL, 'G3DSA:3.30.300.10:FF:000003', NULL, NULL, 'S-adenosylmethionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(44856, NULL, 'G3DSA:1.25.40.20:FF:001745', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(44857, NULL, 'G3DSA:2.130.10.10:FF:003565', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(44858, NULL, 'G3DSA:3.60.21.60:FF:000020', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(44859, NULL, 'G3DSA:2.130.10.10:FF:002997', NULL, NULL, 'WD40-repeat-containing domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(44860, NULL, 'G3DSA:3.30.1360.120:FF:000040', NULL, NULL, 'Folate-dependent protein for Fe/S cluster synthesis/repair in oxidative stress', NULL, NULL, NULL, NULL, NULL, 4),
(44861, NULL, 'G3DSA:1.25.40.10:FF:002844', NULL, NULL, 'Clustered mitochondria protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(44862, NULL, 'G3DSA:3.40.50.1820:FF:001642', NULL, NULL, 'Serine carboxypeptidase S10 family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(44863, NULL, 'G3DSA:3.30.450.50:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44864, NULL, 'G3DSA:1.20.140.10:FF:000118', NULL, NULL, 'Putative acyl CoA oxidase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(44865, NULL, 'G3DSA:3.30.565.10:FF:000275', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(44866, NULL, 'G3DSA:1.20.1070.10:FF:001657', NULL, NULL, 'MAS related GPR family member F', NULL, NULL, NULL, NULL, NULL, 4),
(44867, NULL, 'G3DSA:3.30.450.40:FF:000113', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(44868, NULL, 'G3DSA:3.30.70.2880:FF:000001', NULL, NULL, 'PelD', NULL, NULL, NULL, NULL, NULL, 4),
(44869, NULL, 'G3DSA:2.30.29.30:FF:001090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44870, NULL, 'G3DSA:2.60.40.10:FF:002452', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(44871, NULL, 'G3DSA:1.25.10.10:FF:001595', NULL, NULL, 'Rotatin-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(44872, NULL, 'G3DSA:3.30.300.30:FF:000009', NULL, NULL, 'Bifunctional protein Aas', NULL, NULL, NULL, NULL, NULL, 4),
(44873, NULL, 'G3DSA:1.10.238.10:FF:000230', NULL, NULL, 'Protein S100-A3', NULL, NULL, NULL, NULL, NULL, 4),
(44874, NULL, 'G3DSA:2.60.40.1180:FF:000209', NULL, NULL, 'Alpha-N-arabinofuranosidase', NULL, NULL, NULL, NULL, NULL, 4),
(44875, NULL, 'G3DSA:2.30.30.40:FF:000117', NULL, NULL, 'SH3 domain-binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(44876, NULL, 'G3DSA:3.30.1360.10:FF:000012', NULL, NULL, 'DNA-directed RNA polymerases I and III subunit RPAC2', NULL, NULL, NULL, NULL, NULL, 4),
(44877, NULL, 'G3DSA:3.90.70.10:FF:000174', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(44878, NULL, 'G3DSA:3.40.50.10140:FF:000017', NULL, NULL, 'B cell scaffold protein with ankyrin repeats 1', NULL, NULL, NULL, NULL, NULL, 4),
(44879, NULL, 'G3DSA:3.40.50.300:FF:001654', NULL, NULL, 'Replication factor C subunit 5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(44880, NULL, 'G3DSA:1.25.40.20:FF:000705', NULL, NULL, 'Glycerophosphocholine phosphodiesterase Gde1', NULL, NULL, NULL, NULL, NULL, 4),
(44881, NULL, 'G3DSA:3.40.640.10:FF:000116', NULL, NULL, 'Pyridoxal phosphate (PLP)-dependent transferases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(44882, NULL, 'G3DSA:3.30.160.60:FF:006263', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44883, NULL, 'G3DSA:1.20.58.60:FF:000875', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(44884, NULL, 'G3DSA:2.40.50.140:FF:000429', NULL, NULL, 'Transcription elongation factor SPT6', NULL, NULL, NULL, NULL, NULL, 4),
(44885, NULL, 'G3DSA:3.30.360.10:FF:000030', NULL, NULL, 'NAD binding Rossmann fold oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(44886, NULL, 'G3DSA:3.40.50.2060:FF:000017', NULL, NULL, 'Vacuolar protein sorting-associated protein 33B', NULL, NULL, NULL, NULL, NULL, 4),
(44887, NULL, 'G3DSA:1.20.58.2220:FF:000031', NULL, NULL, 'Formin 2', NULL, NULL, NULL, NULL, NULL, 4),
(44888, NULL, 'G3DSA:1.10.220.10:FF:000032', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(44889, NULL, 'G3DSA:2.60.40.1670:FF:000019', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(44890, NULL, 'G3DSA:1.10.510.10:FF:000312', NULL, NULL, 'Serine/threonine-protein kinase OXI1', NULL, NULL, NULL, NULL, NULL, 4),
(44891, NULL, 'G3DSA:1.20.1370.60:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44892, NULL, 'G3DSA:3.20.20.70:FF:000270', NULL, NULL, 'Triosephosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(44893, NULL, 'G3DSA:2.50.20.20:FF:000003', NULL, NULL, 'Lipoprotein LprA', NULL, NULL, NULL, NULL, NULL, 4),
(44894, NULL, 'G3DSA:1.10.472.10:FF:000206', NULL, NULL, 'Cyclin domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(44895, NULL, 'G3DSA:2.30.29.30:FF:001151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44896, NULL, 'G3DSA:3.30.505.10:FF:000266', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44897, NULL, 'G3DSA:1.25.10.10:FF:001656', NULL, NULL, 'Transport and Golgi organization 6', NULL, NULL, NULL, NULL, NULL, 4),
(44898, NULL, 'G3DSA:3.30.450.70:FF:000009', NULL, NULL, 'Trafficking protein particle complex 4', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(44899, NULL, 'G3DSA:1.25.40.60:FF:000009', NULL, NULL, 'Sly1p', NULL, NULL, NULL, NULL, NULL, 4),
(44900, NULL, 'G3DSA:1.25.40.510:FF:000005', NULL, NULL, 'Unplaced genomic scaffold supercont2.9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(44901, NULL, 'G3DSA:1.10.287.470:FF:000054', NULL, NULL, 'RND efflux system membrane fusion protein CmeA', NULL, NULL, NULL, NULL, NULL, 4),
(44902, NULL, 'G3DSA:1.10.10.10:FF:000919', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(44903, NULL, 'G3DSA:2.60.40.4100:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44904, NULL, 'G3DSA:3.80.10.10:FF:003565', NULL, NULL, 'leucine-rich repeat transmembrane neuronal protein 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(44905, NULL, 'G3DSA:1.10.3720.10:FF:000024', NULL, NULL, 'Glutathione ABC transporter permease GsiC', NULL, NULL, NULL, NULL, NULL, 4),
(44906, NULL, 'G3DSA:3.40.50.1820:FF:000653', NULL, NULL, 'Protein CBG25340', NULL, NULL, NULL, NULL, NULL, 4),
(44907, NULL, 'G3DSA:3.90.1290.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44908, NULL, 'G3DSA:3.90.530.10:FF:000001', NULL, NULL, 'DNA repair protein complementing XP-A cells', NULL, NULL, NULL, NULL, NULL, 4),
(44909, NULL, 'G3DSA:1.10.420.10:FF:000013', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(44910, NULL, 'G3DSA:3.30.1440.10:FF:000013', NULL, NULL, '60S ribosomal protein L11-1', NULL, NULL, NULL, NULL, NULL, 4),
(44911, NULL, 'G3DSA:1.10.220.160:FF:000006', NULL, NULL, 'Blast:Chromosome-associated kinesin KIF4A', NULL, NULL, NULL, NULL, NULL, 4),
(44912, NULL, 'G3DSA:1.25.40.660:FF:000022', NULL, NULL, 'Vacuolar protein sorting-associated protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(44913, NULL, 'G3DSA:1.25.10.10:FF:000246', NULL, NULL, 'Transportin MOS14', NULL, NULL, NULL, NULL, NULL, 4),
(44914, NULL, 'G3DSA:2.70.20.10:FF:000011', NULL, NULL, 'DNA topoisomerase 1A', NULL, NULL, NULL, NULL, NULL, 4),
(44915, NULL, 'G3DSA:1.25.40.20:FF:000644', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(44916, NULL, 'G3DSA:3.30.70.1050:FF:000003', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(44917, NULL, 'G3DSA:3.40.50.720:FF:000588', NULL, NULL, 'Putative ubiquitin activating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(44918, NULL, 'G3DSA:1.20.1070.10:FF:000308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44919, NULL, 'G3DSA:3.40.50.1820:FF:001693', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(44920, NULL, 'G3DSA:3.30.70.1070:FF:000009', NULL, NULL, 'DedD protein', NULL, NULL, NULL, NULL, NULL, 4),
(44921, NULL, 'G3DSA:2.60.40.2830:FF:000002', NULL, NULL, 'Autophagy-related protein 34', NULL, NULL, NULL, NULL, NULL, 4),
(44922, NULL, 'G3DSA:1.20.1070.10:FF:000668', NULL, NULL, 'Olfactory receptor 587, pseudogene 1', NULL, NULL, NULL, NULL, NULL, 4),
(44923, NULL, 'G3DSA:2.60.40.10:FF:005711', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44924, NULL, 'G3DSA:3.30.1390.20:FF:000017', NULL, NULL, '60S ribosomal protein L7, putative', NULL, NULL, NULL, NULL, NULL, 4),
(44925, NULL, 'G3DSA:3.40.50.720:FF:000184', NULL, NULL, 'Probable GDP-L-fucose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(44926, NULL, 'G3DSA:1.50.10.100:FF:000006', NULL, NULL, 'Xanthan lyase', NULL, NULL, NULL, NULL, NULL, 4),
(44927, NULL, 'G3DSA:3.40.449.10:FF:000008', NULL, NULL, 'D111/G-patch domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(44928, NULL, 'G3DSA:4.10.400.10:FF:000242', NULL, NULL, 'CBN-MIG-13 protein', NULL, NULL, NULL, NULL, NULL, 4),
(44929, NULL, 'G3DSA:2.40.240.100:FF:000002', NULL, NULL, 'Glutamate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(44930, NULL, 'G3DSA:3.30.200.20:FF:002213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44931, NULL, 'G3DSA:3.30.1330.50:FF:000005', NULL, NULL, 'Bifunctional enzyme IspD/IspF', NULL, NULL, NULL, NULL, NULL, 4),
(44932, NULL, 'G3DSA:2.160.20.10:FF:000074', NULL, NULL, 'Poly(Beta-D-mannuronate) C5 epimerase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(44933, NULL, 'G3DSA:3.60.40.10:FF:000297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44934, NULL, 'G3DSA:1.25.40.10:FF:003833', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44935, NULL, 'G3DSA:3.40.50.620:FF:000772', NULL, NULL, '7-cyano-7-deazaguanine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(44936, NULL, 'G3DSA:3.40.50.1010:FF:000056', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(44937, NULL, 'G3DSA:3.40.50.12710:FF:000024', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7', NULL, NULL, NULL, NULL, NULL, 4),
(44938, NULL, 'G3DSA:1.10.10.60:FF:000569', NULL, NULL, 'telomere repeats-binding bouquet formation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(44939, NULL, 'G3DSA:3.40.50.12350:FF:000012', NULL, NULL, 'Eyes absent homolog', NULL, NULL, NULL, NULL, NULL, 4),
(44940, NULL, 'G3DSA:3.90.76.10:FF:000041', NULL, NULL, 'Oligopeptide transport system binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(44941, NULL, 'G3DSA:1.10.260.30:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44942, NULL, 'G3DSA:2.160.20.70:FF:000013', NULL, NULL, 'Probable septum site-determining protein MinC', NULL, NULL, NULL, NULL, NULL, 4),
(44943, NULL, 'G3DSA:3.30.70.330:FF:002400', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44944, NULL, 'G3DSA:3.40.50.1000:FF:000519', NULL, NULL, 'Cation-transporting ATPase (P-type)', NULL, NULL, NULL, NULL, NULL, 4),
(44945, NULL, 'G3DSA:2.130.10.10:FF:002025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44946, NULL, 'G3DSA:3.40.50.720:FF:001544', NULL, NULL, 'Putative short-chain dehydrogenase/reductase, SDR family', NULL, NULL, NULL, NULL, NULL, 4),
(44947, NULL, 'G3DSA:3.30.70.520:FF:000001', NULL, NULL, 'Formylmethanofuran--tetrahydromethanopterin formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(44948, NULL, 'G3DSA:3.10.20.90:FF:000445', NULL, NULL, 'Ubiquitin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(44949, NULL, 'G3DSA:3.40.390.10:FF:000254', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44950, NULL, 'G3DSA:1.10.340.30:FF:000018', NULL, NULL, 'Os07g0657600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(44951, NULL, 'G3DSA:2.10.25.10:FF:000822', NULL, NULL, 'Transmembrane matrix receptor MUP-4', NULL, NULL, NULL, NULL, NULL, 4),
(44952, NULL, 'G3DSA:3.40.50.150:FF:000260', NULL, NULL, 'RNA methylase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(44953, NULL, 'G3DSA:2.60.40.1730:FF:000066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44954, NULL, 'G3DSA:3.10.580.10:FF:000213', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(44955, NULL, 'G3DSA:3.40.630.30:FF:000476', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44956, NULL, 'G3DSA:3.30.160.60:FF:002081', NULL, NULL, 'Zinc finger protein 1060', NULL, NULL, NULL, NULL, NULL, 4),
(44957, NULL, 'G3DSA:1.20.1560.10:FF:000104', NULL, NULL, 'ABC transporter ATP-binding protein/permease', NULL, NULL, NULL, NULL, NULL, 4),
(44958, NULL, 'G3DSA:3.30.160.60:FF:003278', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44959, NULL, 'G3DSA:3.90.550.10:FF:000435', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44960, NULL, 'G3DSA:1.25.10.10:FF:003101', NULL, NULL, 'AGAP002100-PA', NULL, NULL, NULL, NULL, NULL, 4),
(44961, NULL, 'G3DSA:1.10.238.10:FF:000730', NULL, NULL, 'Centrin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(44962, NULL, 'G3DSA:1.20.1310.10:FF:000024', NULL, NULL, 'Cullin-4 like', NULL, NULL, NULL, NULL, NULL, 4),
(44963, NULL, 'G3DSA:2.130.10.10:FF:003986', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44964, NULL, 'G3DSA:3.90.190.10:FF:000452', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44965, NULL, 'G3DSA:3.20.20.70:FF:000118', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(44966, NULL, 'G3DSA:1.10.510.10:FF:000363', NULL, NULL, 'Striated muscle preferentially expressed protein kinase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(44967, NULL, 'G3DSA:1.20.1640.10:FF:000105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44968, NULL, 'G3DSA:1.20.58.1120:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44969, NULL, 'G3DSA:3.40.850.10:FF:000385', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(44970, NULL, 'G3DSA:3.40.190.10:FF:000385', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(44971, NULL, 'G3DSA:1.20.1250.20:FF:000735', NULL, NULL, 'Putative sugar transporter', NULL, NULL, NULL, NULL, NULL, 4),
(44972, NULL, 'G3DSA:2.60.40.60:FF:000589', NULL, NULL, 'Protocadherin 1 gamma 1', NULL, NULL, NULL, NULL, NULL, 4),
(44973, NULL, 'G3DSA:3.20.20.300:FF:000051', NULL, NULL, 'Glycoside hydrolase family 3 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(44974, NULL, 'G3DSA:3.40.50.11320:FF:000006', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(44975, NULL, 'G3DSA:6.10.140.2150:FF:000013', NULL, NULL, 'Sphingosine Phosphate Lyase', NULL, NULL, NULL, NULL, NULL, 4),
(44976, NULL, 'G3DSA:1.10.555.10:FF:000101', NULL, NULL, 'Oligophrenin 1', NULL, NULL, NULL, NULL, NULL, 4),
(44977, NULL, 'G3DSA:2.130.10.10:FF:005982', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44978, NULL, 'G3DSA:2.60.40.1530:FF:000011', NULL, NULL, 'Integrin subunit alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(44979, NULL, 'G3DSA:2.40.10.10:FF:000085', NULL, NULL, 'Prothrombin', NULL, NULL, NULL, NULL, NULL, 4),
(44980, NULL, 'G3DSA:3.90.1210.10:FF:000004', NULL, NULL, 'Flagella basal body P-ring formation protein FlgA', NULL, NULL, NULL, NULL, NULL, 4),
(44981, NULL, 'G3DSA:3.90.1280.20:FF:000006', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(44982, NULL, 'G3DSA:1.10.510.10:FF:002780', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44983, NULL, 'G3DSA:4.10.240.10:FF:000027', NULL, NULL, 'Specific RNA polymerase II transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(44984, NULL, 'G3DSA:1.25.40.10:FF:000023', NULL, NULL, 'Pre-mRNA-splicing factor SYF1', NULL, NULL, NULL, NULL, NULL, 4),
(44985, NULL, 'G3DSA:3.40.980.10:FF:000046', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(44986, NULL, 'G3DSA:1.20.1250.20:FF:001551', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44987, NULL, 'G3DSA:3.40.50.300:FF:007494', NULL, NULL, 'ATP-dependent RNA helicase RhlE', NULL, NULL, NULL, NULL, NULL, 4),
(44988, NULL, 'G3DSA:1.10.238.10:FF:001168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(44989, NULL, 'G3DSA:1.10.10.10:FF:000066', NULL, NULL, 'ETS-related transcription factor Elf-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(44990, NULL, 'G3DSA:3.40.1110.10:FF:000194', NULL, NULL, 'Ca ion P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(44991, NULL, 'G3DSA:3.40.190.10:FF:000205', NULL, NULL, 'Membrane-bound lytic murein transglycosylase F', NULL, NULL, NULL, NULL, NULL, 4),
(44992, NULL, 'G3DSA:3.30.70.330:FF:002580', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44993, NULL, 'G3DSA:3.40.50.2000:FF:000639', NULL, NULL, 'Os02g0242900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(44994, NULL, 'G3DSA:1.20.1050.60:FF:000007', NULL, NULL, 'Glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(44995, NULL, 'G3DSA:1.10.2000.10:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(44996, NULL, 'G3DSA:1.20.120.520:FF:000005', NULL, NULL, 'Iron-sulfur cluster repair protein DnrN', NULL, NULL, NULL, NULL, NULL, 4),
(44997, NULL, 'G3DSA:1.25.40.10:FF:001304', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g15300', NULL, NULL, NULL, NULL, NULL, 4),
(44998, NULL, 'G3DSA:1.20.5.170:FF:000160', NULL, NULL, 'C/EBP (CCAAT/enhancer-binding protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(44999, NULL, 'G3DSA:3.40.630.10:FF:000470', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45000, NULL, 'G3DSA:2.60.40.10:FF:001092', NULL, NULL, 'Sodium channel subunit beta-2', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(45001, NULL, 'G3DSA:3.10.250.10:FF:000071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45002, NULL, 'G3DSA:2.60.120.10:FF:000487', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45003, NULL, 'G3DSA:3.30.200.20:FF:000639', NULL, NULL, 'Serine/threonine-protein kinase BUD32', NULL, NULL, NULL, NULL, NULL, 4),
(45004, NULL, 'G3DSA:3.40.50.2300:FF:000578', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45005, NULL, 'G3DSA:3.30.160.810:FF:000001', NULL, NULL, '50S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(45006, NULL, 'G3DSA:3.30.230.10:FF:000138', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(45007, NULL, 'G3DSA:2.60.40.60:FF:000409', NULL, NULL, 'DE-cadherin', NULL, NULL, NULL, NULL, NULL, 4),
(45008, NULL, 'G3DSA:1.10.418.10:FF:000148', NULL, NULL, 'Alpha-parvin', NULL, NULL, NULL, NULL, NULL, 4),
(45009, NULL, 'G3DSA:3.30.470.20:FF:000018', NULL, NULL, 'Trifunctional purine biosynthetic protein adenosine-3', NULL, NULL, NULL, NULL, NULL, 4),
(45010, NULL, 'G3DSA:3.30.50.10:FF:000006', NULL, NULL, 'Nuclear receptor subfamily 5 group A member', NULL, NULL, NULL, NULL, NULL, 4),
(45011, NULL, 'G3DSA:3.60.130.10:FF:000039', NULL, NULL, 'Os01g0190000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(45012, NULL, 'G3DSA:4.10.860.20:FF:000004', NULL, NULL, 'PKHD-type hydroxylase RPA3479', NULL, NULL, NULL, NULL, NULL, 4),
(45013, NULL, 'G3DSA:2.30.30.140:FF:000326', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45014, NULL, 'G3DSA:3.30.710.10:FF:000169', NULL, NULL, 'BTB/POZ domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(45015, NULL, 'G3DSA:1.20.90.10:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45016, NULL, 'G3DSA:3.30.70.330:FF:001152', NULL, NULL, 'Glycine-rich rna-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(45017, NULL, 'G3DSA:3.20.20.150:FF:000045', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45018, NULL, 'G3DSA:1.25.40.10:FF:003333', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(45019, NULL, 'G3DSA:1.10.760.10:FF:000022', NULL, NULL, 'Cytochrome c4', NULL, NULL, NULL, NULL, NULL, 4),
(45020, NULL, 'G3DSA:2.130.10.10:FF:001648', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(45021, NULL, 'G3DSA:3.40.190.80:FF:000006', NULL, NULL, 'Bisphosphate nucleotidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(45022, NULL, 'G3DSA:3.30.160.60:FF:000113', NULL, NULL, 'zinc finger protein 699 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(45023, NULL, 'G3DSA:2.130.10.10:FF:004054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45024, NULL, 'G3DSA:2.60.120.10:FF:000436', NULL, NULL, 'Cyclic nucleotide-gated channel 12', NULL, NULL, NULL, NULL, NULL, 4),
(45025, NULL, 'G3DSA:2.40.40.20:FF:000027', NULL, NULL, 'Sec18p', NULL, NULL, NULL, NULL, NULL, 4),
(45026, NULL, 'G3DSA:3.80.10.10:FF:001148', NULL, NULL, 'Si:dkey-286j17.4', NULL, NULL, NULL, NULL, NULL, 4),
(45027, NULL, 'G3DSA:2.20.28.10:FF:000042', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(45028, NULL, 'G3DSA:3.40.50.300:FF:005465', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(45029, NULL, 'G3DSA:3.90.1150.10:FF:000112', NULL, NULL, 'Cystathionine gamma-lyase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(45030, NULL, 'G3DSA:3.30.470.20:FF:000069', NULL, NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(45031, NULL, 'G3DSA:3.40.50.200:FF:000022', NULL, NULL, 'Extracellular protease', NULL, NULL, NULL, NULL, NULL, 4),
(45032, NULL, 'G3DSA:3.30.200.20:FF:001196', NULL, NULL, 'Alpha-protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(45033, NULL, 'G3DSA:2.20.25.10:FF:000001', NULL, NULL, 'Probable Transcription elongation factor S-II', NULL, NULL, NULL, NULL, NULL, 4),
(45034, NULL, 'G3DSA:1.10.418.70:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(45035, NULL, 'G3DSA:3.30.2410.10:FF:000039', NULL, NULL, 'E3 ubiquitin-protein ligase HACE1', NULL, NULL, NULL, NULL, NULL, 4),
(45036, NULL, 'G3DSA:3.40.50.300:FF:007314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45037, NULL, 'G3DSA:2.60.40.150:FF:000212', NULL, NULL, 'Synaptotagmin like 1', NULL, NULL, NULL, NULL, NULL, 4),
(45038, NULL, 'G3DSA:2.60.40.150:FF:000504', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45039, NULL, 'G3DSA:3.30.160.60:FF:006212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45040, NULL, 'G3DSA:1.25.40.570:FF:000028', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit E', NULL, NULL, NULL, NULL, NULL, 4),
(45041, NULL, 'G3DSA:2.60.40.3510:FF:000015', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(45042, NULL, 'G3DSA:3.40.640.10:FF:000408', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45043, NULL, 'G3DSA:1.25.40.770:FF:000004', NULL, NULL, 'transcription initiation factor TFIID subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(45044, NULL, 'G3DSA:2.40.50.140:FF:000497', NULL, NULL, 'Aspartyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(45045, NULL, 'G3DSA:1.25.40.10:FF:001484', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(45046, NULL, 'G3DSA:1.20.120.1130:FF:000004', NULL, NULL, 'Vacuolar protein sorting-associated protein 28', NULL, NULL, NULL, NULL, NULL, 4),
(45047, NULL, 'G3DSA:3.40.50.12780:FF:000135', NULL, NULL, 'Nonribosomal peptide synthetase, discrete adenylation domain', NULL, NULL, NULL, NULL, NULL, 4),
(45048, NULL, 'G3DSA:3.90.70.10:FF:000106', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 35', NULL, NULL, NULL, NULL, NULL, 4),
(45049, NULL, 'G3DSA:3.40.225.10:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45050, NULL, 'G3DSA:3.40.630.30:FF:000560', NULL, NULL, 'Putative acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(45051, NULL, 'G3DSA:3.30.1140.60:FF:000022', NULL, NULL, 'F-actin-capping protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(45052, NULL, 'G3DSA:2.30.30.140:FF:000034', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(45053, NULL, 'G3DSA:3.30.160.20:FF:000208', NULL, NULL, 'A-to-I RNA editing regulator adr-1', NULL, NULL, NULL, NULL, NULL, 4),
(45054, NULL, 'G3DSA:3.30.160.60:FF:002901', NULL, NULL, 'Zinc finger protein 564', NULL, NULL, NULL, NULL, NULL, 4),
(45055, NULL, 'G3DSA:1.25.40.10:FF:000074', NULL, NULL, 'ER membrane protein complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(45056, NULL, 'G3DSA:3.40.50.2300:FF:001146', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45057, NULL, 'G3DSA:3.40.50.300:FF:008219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45058, NULL, 'G3DSA:2.60.120.10:FF:000728', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45059, NULL, 'G3DSA:1.20.1070.10:FF:001365', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45060, NULL, 'G3DSA:1.10.1450.10:FF:000132', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(45061, NULL, 'G3DSA:3.40.50.720:FF:001044', NULL, NULL, 'Ketose-bisphosphate aldolase class-II family protein', NULL, NULL, NULL, NULL, NULL, 4),
(45062, NULL, 'G3DSA:1.10.357.110:FF:000013', NULL, NULL, 'Vacuolar protein sorting-associated protein 53', NULL, NULL, NULL, NULL, NULL, 4),
(45063, NULL, 'G3DSA:2.130.10.10:FF:002929', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45064, NULL, 'G3DSA:3.30.160.60:FF:001833', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45065, NULL, 'G3DSA:3.80.20.20:FF:000022', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(45066, NULL, 'G3DSA:1.20.1300.20:FF:000004', NULL, NULL, 'RNA-binding protein 8A', NULL, NULL, NULL, NULL, NULL, 4),
(45067, NULL, 'G3DSA:3.40.50.1820:FF:001350', NULL, NULL, 'AER322Cp', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(45068, NULL, 'G3DSA:2.60.9.10:FF:000003', NULL, NULL, 'Putative vasopressin-like neuropeptide preprohormone', NULL, NULL, NULL, NULL, NULL, 4),
(45069, NULL, 'G3DSA:1.25.40.10:FF:005250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45070, NULL, 'G3DSA:3.90.1640.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45071, NULL, 'G3DSA:3.30.9.10:FF:000147', NULL, NULL, 'FAD-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(45072, NULL, 'G3DSA:3.40.50.300:FF:003548', NULL, NULL, 'Iron-sulfur cluster carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(45073, NULL, 'G3DSA:2.10.25.10:FF:000434', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45074, NULL, 'G3DSA:2.40.70.10:FF:000526', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45075, NULL, 'G3DSA:3.40.50.11530:FF:000002', NULL, NULL, 'Interleukin 17 receptor A', NULL, NULL, NULL, NULL, NULL, 4),
(45076, NULL, 'G3DSA:2.60.40.10:FF:001884', NULL, NULL, 'Fc receptor like 4', NULL, NULL, NULL, NULL, NULL, 4),
(45077, NULL, 'G3DSA:2.60.40.1080:FF:000005', NULL, NULL, 'Intimin', NULL, NULL, NULL, NULL, NULL, 4),
(45078, NULL, 'G3DSA:3.30.1370.50:FF:000002', NULL, NULL, 'Immunoglobulin mu DNA-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(45079, NULL, 'G3DSA:3.40.1810.10:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45080, NULL, 'G3DSA:1.10.287.70:FF:000282', NULL, NULL, 'Calcium channel subunit Cch1', NULL, NULL, NULL, NULL, NULL, 4),
(45081, NULL, 'G3DSA:3.20.20.80:FF:000508', NULL, NULL, 'Linamarase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(45082, NULL, 'G3DSA:3.30.70.1730:FF:000044', NULL, NULL, '50S ribosomal protein L10', NULL, NULL, NULL, NULL, NULL, 4),
(45083, NULL, 'G3DSA:1.10.630.10:FF:000310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45084, NULL, 'G3DSA:2.30.42.10:FF:000001', NULL, NULL, 'Disks large homolog 1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(45085, NULL, 'G3DSA:2.160.20.10:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45086, NULL, 'G3DSA:2.40.50.140:FF:000137', NULL, NULL, '28S ribosomal protein S17, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(45087, NULL, 'G3DSA:4.10.280.10:FF:000092', NULL, NULL, 'transcription factor bHLH68 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(45088, NULL, 'G3DSA:1.20.58.60:FF:000807', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45089, NULL, 'G3DSA:1.20.120.1750:FF:000033', NULL, NULL, 'Ring finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(45090, NULL, 'G3DSA:1.10.10.10:FF:001476', NULL, NULL, 'Putative helicase mug81', NULL, NULL, NULL, NULL, NULL, 4),
(45091, NULL, 'G3DSA:1.10.1420.10:FF:000012', NULL, NULL, 'DNA mismatch repair protein MSH4', NULL, NULL, NULL, NULL, NULL, 4),
(45092, NULL, 'G3DSA:2.130.10.10:FF:004003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45093, NULL, 'G3DSA:3.40.50.720:FF:000476', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(45094, NULL, 'G3DSA:3.30.160.60:FF:002322', NULL, NULL, 'Homeotic protein spalt-major', NULL, NULL, NULL, NULL, NULL, 4),
(45095, NULL, 'G3DSA:1.25.10.10:FF:002163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45096, NULL, 'G3DSA:1.10.287.1490:FF:000012', NULL, NULL, 'intraflagellar transport protein 74 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(45097, NULL, 'G3DSA:1.20.1250.20:FF:000174', NULL, NULL, 'Sucrose transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(45098, NULL, 'G3DSA:2.60.120.620:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45099, NULL, 'G3DSA:3.40.30.10:FF:000746', NULL, NULL, 'Iodothyronine deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(45100, NULL, 'G3DSA:3.30.1120.10:FF:000034', NULL, NULL, 'Arylsulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(45101, NULL, 'G3DSA:1.10.472.10:FF:000318', NULL, NULL, 'Cyclin domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(45102, NULL, 'G3DSA:3.20.20.190:FF:000158', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45103, NULL, 'G3DSA:3.30.40.10:FF:001057', NULL, NULL, 'Protein CBG07029', NULL, NULL, NULL, NULL, NULL, 4),
(45104, NULL, 'G3DSA:2.20.25.30:FF:000007', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(45105, NULL, 'G3DSA:3.40.50.300:FF:005757', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(45106, NULL, 'G3DSA:3.30.1370.70:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45107, NULL, 'G3DSA:3.40.50.2300:FF:001067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45108, NULL, 'G3DSA:1.25.10.10:FF:002988', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45109, NULL, 'G3DSA:1.10.238.10:FF:000651', NULL, NULL, 'Centrin-related-protein,putative', NULL, NULL, NULL, NULL, NULL, 4),
(45110, NULL, 'G3DSA:1.10.10.830:FF:000009', NULL, NULL, 'Isoleucyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(45111, NULL, 'G3DSA:2.60.120.380:FF:000032', NULL, NULL, 'Zgc:162184', NULL, NULL, NULL, NULL, NULL, 4),
(45112, NULL, 'G3DSA:3.30.160.60:FF:005756', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45113, NULL, 'G3DSA:2.60.40.10:FF:003733', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45114, NULL, 'G3DSA:3.40.50.1700:FF:000050', NULL, NULL, 'Glycoside hydrolase family 3 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(45115, NULL, 'G3DSA:3.30.160.60:FF:004346', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45116, NULL, 'G3DSA:1.10.10.10:FF:000015', NULL, NULL, 'Leucine-responsive transcriptional regulator Lrp', NULL, NULL, NULL, NULL, NULL, 4),
(45117, NULL, 'G3DSA:2.30.29.30:FF:000583', NULL, NULL, 'Protein CBG09025', NULL, NULL, NULL, NULL, NULL, 4),
(45118, NULL, 'G3DSA:3.20.20.80:FF:000559', NULL, NULL, 'GH13872p', NULL, NULL, NULL, NULL, NULL, 4),
(45119, NULL, 'G3DSA:3.30.160.60:FF:001884', NULL, NULL, 'Zinc finger protein 836', NULL, NULL, NULL, NULL, NULL, 4),
(45120, NULL, 'G3DSA:3.30.200.20:FF:002505', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45121, NULL, 'G3DSA:1.50.40.10:FF:000335', NULL, NULL, 'Mitochondrial carrier domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(45122, NULL, 'G3DSA:1.10.238.20:FF:000036', NULL, NULL, 'GD25639', NULL, NULL, NULL, NULL, NULL, 4),
(45123, NULL, 'G3DSA:2.60.34.20:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45124, NULL, 'G3DSA:3.30.428.10:FF:000030', NULL, NULL, 'Hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(45125, NULL, 'G3DSA:3.40.109.10:FF:000017', NULL, NULL, 'Putative NAD(P)H nitroreductase', NULL, NULL, NULL, NULL, NULL, 4),
(45126, NULL, 'G3DSA:1.25.40.20:FF:000352', NULL, NULL, 'YIL001W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(45127, NULL, 'G3DSA:3.40.50.300:FF:006033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45128, NULL, 'G3DSA:2.60.120.590:FF:000038', NULL, NULL, 'ALKBH3 isoform 7', NULL, NULL, NULL, NULL, NULL, 4),
(45129, NULL, 'G3DSA:1.10.510.10:FF:000751', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(45130, NULL, 'G3DSA:2.80.10.50:FF:000010', NULL, NULL, 'Fascin', NULL, NULL, NULL, NULL, NULL, 4),
(45131, NULL, 'G3DSA:1.10.555.10:FF:000005', NULL, NULL, 'Chimaerin', NULL, NULL, NULL, NULL, NULL, 4),
(45132, NULL, 'G3DSA:1.10.10.10:FF:000627', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(45133, NULL, 'G3DSA:1.10.510.10:FF:000655', NULL, NULL, 'serine/threonine-protein kinase 35', NULL, NULL, NULL, NULL, NULL, 4),
(45134, NULL, 'G3DSA:3.80.10.10:FF:003273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45135, NULL, 'G3DSA:1.10.10.2660:FF:000002', NULL, NULL, 'Ubiquitin-activating enzyme E1 2', NULL, NULL, NULL, NULL, NULL, 4),
(45136, NULL, 'G3DSA:3.80.20.20:FF:000073', NULL, NULL, 'Erb-b2 receptor tyrosine kinase 3b', NULL, NULL, NULL, NULL, NULL, 4),
(45137, NULL, 'G3DSA:1.10.510.10:FF:003117', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(45138, NULL, 'G3DSA:2.60.120.230:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45139, NULL, 'G3DSA:2.60.40.10:FF:002373', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(45140, NULL, 'G3DSA:2.40.240.20:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45141, NULL, 'G3DSA:1.20.58.100:FF:000009', NULL, NULL, 'L-aspartate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(45142, NULL, 'G3DSA:3.40.50.300:FF:001575', NULL, NULL, 'Protein translocase subunit SecA 2', NULL, NULL, NULL, NULL, NULL, 4),
(45143, NULL, 'G3DSA:1.20.120.310:FF:000009', NULL, NULL, 'FAD-linked sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(45144, NULL, 'G3DSA:3.40.140.10:FF:000202', NULL, NULL, 'COP9 signalosome complex subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(45145, NULL, 'G3DSA:2.60.34.10:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45146, NULL, 'G3DSA:2.40.160.20:FF:000013', NULL, NULL, 'Outer membrane protein OprG', NULL, NULL, NULL, NULL, NULL, 4),
(45147, NULL, 'G3DSA:1.10.287.110:FF:000143', NULL, NULL, 'Unplaced genomic scaffold supercont2.13, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(45148, NULL, 'G3DSA:3.40.930.10:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45149, NULL, 'G3DSA:3.40.1380.20:FF:000065', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(45150, NULL, 'G3DSA:3.30.70.980:FF:000037', NULL, NULL, 'GD20114', NULL, NULL, NULL, NULL, NULL, 4),
(45151, NULL, 'G3DSA:3.40.50.620:FF:000384', NULL, NULL, '7-cyano-7-deazaguanine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(45152, NULL, 'G3DSA:1.10.630.10:FF:000698', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45153, NULL, 'G3DSA:1.10.472.130:FF:000054', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45154, NULL, 'G3DSA:2.60.120.970:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45155, NULL, 'G3DSA:3.30.160.60:FF:002373', NULL, NULL, 'Protein krueppel', NULL, NULL, NULL, NULL, NULL, 4),
(45156, NULL, 'G3DSA:3.30.40.100:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45157, NULL, 'G3DSA:3.40.50.300:FF:001362', NULL, NULL, 'DNA repair protein recA 1 like', NULL, NULL, NULL, NULL, NULL, 4),
(45158, NULL, 'G3DSA:3.40.50.410:FF:000259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45159, NULL, 'G3DSA:3.30.160.60:FF:005195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45160, NULL, 'G3DSA:1.50.10.10:FF:000215', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45161, NULL, 'G3DSA:2.30.30.40:FF:000505', NULL, NULL, 'BAR domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(45162, NULL, 'G3DSA:2.120.10.30:FF:000547', NULL, NULL, 'Putative oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(45163, NULL, 'G3DSA:3.30.830.10:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45164, NULL, 'G3DSA:3.30.70.660:FF:000059', NULL, NULL, 'Pseudouridylate synthase 3 (AFU_orthologue AFUA_3G13350)', NULL, NULL, NULL, NULL, NULL, 4),
(45165, NULL, 'G3DSA:3.40.30.10:FF:000403', NULL, NULL, 'Protein disulfide-isomerase A4', NULL, NULL, NULL, NULL, NULL, 4),
(45166, NULL, 'G3DSA:3.30.200.20:FF:001988', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45167, NULL, 'G3DSA:3.40.850.10:FF:000273', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(45168, NULL, 'G3DSA:4.10.1060.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45169, NULL, 'G3DSA:3.90.1330.10:FF:000002', NULL, NULL, 'Extracellular xylan exo-alpha-(1->2)-glucuronosidase', NULL, NULL, NULL, NULL, NULL, 4),
(45170, NULL, 'G3DSA:3.30.1330.40:FF:000019', NULL, NULL, 'YLR143W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(45171, NULL, 'G3DSA:1.25.40.10:FF:003272', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g10910, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(45172, NULL, 'G3DSA:1.20.5.110:FF:000069', NULL, NULL, 'Related to syntaxin 18', NULL, NULL, NULL, NULL, NULL, 4),
(45173, NULL, 'G3DSA:2.60.120.260:FF:000119', NULL, NULL, 'Probable beta-glucosidase I', NULL, NULL, NULL, NULL, NULL, 4),
(45174, NULL, 'G3DSA:2.40.70.10:FF:000318', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45175, NULL, 'G3DSA:3.40.50.300:FF:005526', NULL, NULL, 'RAB40C, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(45176, NULL, 'G3DSA:2.60.40.1090:FF:000042', NULL, NULL, 'Long polar fimbrial protein LpfE', NULL, NULL, NULL, NULL, NULL, 4),
(45177, NULL, 'G3DSA:3.80.10.10:FF:002508', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45178, NULL, 'G3DSA:2.60.40.10:FF:000327', NULL, NULL, 'Cell adhesion associated, oncogene regulated', NULL, NULL, NULL, NULL, NULL, 4),
(45179, NULL, 'G3DSA:3.55.40.20:FF:000020', NULL, NULL, 'Superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(45180, NULL, 'G3DSA:3.30.450.20:FF:000135', NULL, NULL, 'Ptaureo1a lov2 domain', NULL, NULL, NULL, NULL, NULL, 4),
(45181, NULL, 'G3DSA:1.25.40.10:FF:000135', NULL, NULL, 'intraflagellar transport protein 88 homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(45182, NULL, 'G3DSA:3.30.40.10:FF:000629', NULL, NULL, 'RING finger domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(45183, NULL, 'G3DSA:3.40.630.10:FF:000110', NULL, NULL, 'Acetylornithine deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(45184, NULL, 'G3DSA:1.20.58.90:FF:000007', NULL, NULL, 'E3 ubiquitin-protein ligase ipaH9.8', NULL, NULL, NULL, NULL, NULL, 4),
(45185, NULL, 'G3DSA:1.20.1260.100:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45186, NULL, 'G3DSA:1.20.1250.20:FF:000915', NULL, NULL, 'Similar to MFS multidrug transporter', NULL, NULL, NULL, NULL, NULL, 4),
(45187, NULL, 'G3DSA:2.10.50.10:FF:000043', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 5', NULL, NULL, NULL, NULL, NULL, 4),
(45188, NULL, 'G3DSA:3.40.50.1000:FF:000407', NULL, NULL, 'Os02g0790500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(45189, NULL, 'G3DSA:1.10.555.10:FF:000213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45190, NULL, 'G3DSA:3.30.70.330:FF:001231', NULL, NULL, 'RNA-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(45191, NULL, 'G3DSA:1.25.40.70:FF:000046', NULL, NULL, 'Phosphatidylinositol 4-kinase (STT4), putative', NULL, NULL, NULL, NULL, NULL, 4),
(45192, NULL, 'G3DSA:3.40.50.1100:FF:000027', NULL, NULL, 'Threonine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(45193, NULL, 'G3DSA:2.30.40.10:FF:000047', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(45194, NULL, 'G3DSA:3.40.50.1820:FF:001142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45195, NULL, 'G3DSA:3.30.1370.10:FF:000018', NULL, NULL, 'vigilin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(45196, NULL, 'G3DSA:3.40.630.30:FF:000116', NULL, NULL, 'Putative N-acetyltransferase HLS1', NULL, NULL, NULL, NULL, NULL, 4),
(45197, NULL, 'G3DSA:3.30.420.10:FF:000681', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45198, NULL, 'G3DSA:1.10.10.350:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45199, NULL, 'G3DSA:3.40.50.300:FF:001311', NULL, NULL, 'Dynamin-like protein-related', NULL, NULL, NULL, NULL, NULL, 4),
(45200, NULL, 'G3DSA:1.10.533.10:FF:000056', NULL, NULL, 'NACHT, LRR and PYD domains-containing protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(45201, NULL, 'G3DSA:2.40.50.730:FF:000011', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(45202, NULL, 'G3DSA:3.80.10.10:FF:000367', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(45203, NULL, 'G3DSA:3.10.50.40:FF:000044', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(45204, NULL, 'G3DSA:2.130.10.10:FF:000400', NULL, NULL, 'Elongator acetyltransferase complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(45205, NULL, 'G3DSA:3.30.2410.10:FF:000011', NULL, NULL, 'Putative Ubiquitin-protein ligase E3C', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(45206, NULL, 'G3DSA:2.60.40.1230:FF:000011', NULL, NULL, 'ADP-ribosylation factor-binding protein GGA2', NULL, NULL, NULL, NULL, NULL, 4),
(45207, NULL, 'G3DSA:2.60.40.10:FF:001316', NULL, NULL, 'PKHD1 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(45208, NULL, 'G3DSA:3.40.720.10:FF:000229', NULL, NULL, 'Iduronate 2-sulfatase (Hunter syndrome), isoform CRA_e', NULL, NULL, NULL, NULL, NULL, 4),
(45209, NULL, 'G3DSA:3.30.40.10:FF:001580', NULL, NULL, 'Putative RING-H2 finger protein ATL62', NULL, NULL, NULL, NULL, NULL, 4),
(45210, NULL, 'G3DSA:1.20.1300.10:FF:000018', NULL, NULL, 'Fumarate reductase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(45211, NULL, 'G3DSA:3.30.40.10:FF:000152', NULL, NULL, 'E3 ubiquitin-protein ligase Praja-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(45212, NULL, 'G3DSA:1.20.1250.20:FF:001371', NULL, NULL, 'Major facilitator superfamily domain-containing protein 12-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(45213, NULL, 'G3DSA:3.10.590.10:FF:000006', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(45214, NULL, 'G3DSA:1.20.1110.10:FF:000256', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45215, NULL, 'G3DSA:2.10.50.30:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45216, NULL, 'G3DSA:2.30.29.30:FF:000662', NULL, NULL, 'GD19751', NULL, NULL, NULL, NULL, NULL, 4),
(45217, NULL, 'G3DSA:3.90.79.10:FF:000255', NULL, NULL, 'Diphosphoinositol polyphosphate phosphohydrolase aps1', NULL, NULL, NULL, NULL, NULL, 4),
(45218, NULL, 'G3DSA:3.40.50.300:FF:002300', NULL, NULL, 'ABC transporter G family protein', NULL, NULL, NULL, NULL, NULL, 4),
(45219, NULL, 'G3DSA:1.10.418.10:FF:000036', NULL, NULL, 'Actinin alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(45220, NULL, 'G3DSA:3.20.110.10:FF:000036', NULL, NULL, 'Alpha-mannosidase E', NULL, NULL, NULL, NULL, NULL, 4),
(45221, NULL, 'G3DSA:1.10.510.10:FF:000863', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(45222, NULL, 'G3DSA:1.50.40.10:FF:000043', NULL, NULL, 'mitochondrial dicarboxylate carrier isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(45223, NULL, 'G3DSA:3.90.1720.10:FF:000021', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(45224, NULL, 'G3DSA:1.10.287.80:FF:000010', NULL, NULL, 'ATP synthase gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(45225, NULL, 'G3DSA:3.20.20.140:FF:000216', NULL, NULL, 'AMP deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(45226, NULL, 'G3DSA:1.25.40.10:FF:003749', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g18110, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(45227, NULL, 'G3DSA:3.60.21.10:FF:000045', NULL, NULL, 'Sphingomyelin phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(45228, NULL, 'G3DSA:3.30.160.60:FF:004138', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45229, NULL, 'G3DSA:3.30.70.2580:FF:000001', NULL, NULL, 'tRNA (guanine(37)-N1)-methyltransferase Trm5b', NULL, NULL, NULL, NULL, NULL, 4),
(45230, NULL, 'G3DSA:3.30.70.3290:FF:000006', NULL, NULL, 'GD23207', NULL, NULL, NULL, NULL, NULL, 4),
(45231, NULL, 'G3DSA:3.40.710.10:FF:000111', NULL, NULL, 'Penicillin-binding protein 1C', NULL, NULL, NULL, NULL, NULL, 4),
(45232, NULL, 'G3DSA:1.25.10.10:FF:002084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45233, NULL, 'G3DSA:1.20.930.40:FF:000002', NULL, NULL, 'Transferrin receptor protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(45234, NULL, 'G3DSA:4.10.1080.10:FF:000005', NULL, NULL, 'Thrombospondin type 3 repeat', NULL, NULL, NULL, NULL, NULL, 4),
(45235, NULL, 'G3DSA:1.20.1070.10:FF:000752', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45236, NULL, 'G3DSA:1.25.40.470:FF:000004', NULL, NULL, 'WD repeat-containing protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(45237, NULL, 'G3DSA:1.10.238.10:FF:000679', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(45238, NULL, 'G3DSA:2.60.220.50:FF:000129', NULL, NULL, 'G-protein coupled receptor 126-like Protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(45239, NULL, 'G3DSA:2.40.100.10:FF:000147', NULL, NULL, 'AAR045Cp', NULL, NULL, NULL, NULL, NULL, 4),
(45240, NULL, 'G3DSA:2.170.150.10:FF:000018', NULL, NULL, 'Guanine nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(45241, NULL, 'G3DSA:3.40.120.10:FF:000083', NULL, NULL, 'Phosphohexomutase (Phosphoglucomutase / phosphomannomutase)', NULL, NULL, NULL, NULL, NULL, 4),
(45242, NULL, 'G3DSA:1.20.1250.20:FF:002040', NULL, NULL, 'Solute carrier family 43 member 1', NULL, NULL, NULL, NULL, NULL, 4),
(45243, NULL, 'G3DSA:1.25.10.10:FF:003444', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45244, NULL, 'G3DSA:1.20.5.340:FF:000020', NULL, NULL, 'polycystin-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(45245, NULL, 'G3DSA:3.50.7.10:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45246, NULL, 'G3DSA:1.20.930.60:FF:000008', NULL, NULL, 'GD25149', NULL, NULL, NULL, NULL, NULL, 4),
(45247, NULL, 'G3DSA:3.30.70.1470:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45248, NULL, 'G3DSA:2.60.120.200:FF:000591', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45249, NULL, 'G3DSA:3.30.70.1020:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45250, NULL, 'G3DSA:1.10.150.530:FF:000005', NULL, NULL, 'Radical SAM superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(45251, NULL, 'G3DSA:3.40.50.300:FF:006533', NULL, NULL, 'Si:dkey-79f11.7', NULL, NULL, NULL, NULL, NULL, 4),
(45252, NULL, 'G3DSA:1.20.1530.20:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45253, NULL, 'G3DSA:3.20.19.10:FF:000013', NULL, NULL, 'Aconitate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(45254, NULL, 'G3DSA:3.40.50.620:FF:000204', NULL, NULL, 'Probable electron transfer flavoprotein beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(45255, NULL, 'G3DSA:3.40.50.2000:FF:000718', NULL, NULL, 'Glycosyl transferase family 9', NULL, NULL, NULL, NULL, NULL, 4),
(45256, NULL, 'G3DSA:1.10.1580.10:FF:000001', NULL, NULL, 'Nucleolar GTP-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(45257, NULL, 'G3DSA:1.20.920.20:FF:000018', NULL, NULL, 'Dynein heavy chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(45258, NULL, 'G3DSA:3.30.1330.20:FF:000013', NULL, NULL, 'Tubulin gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(45259, NULL, 'G3DSA:2.60.200.30:FF:000027', NULL, NULL, 'NAD kinase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(45260, NULL, 'G3DSA:6.20.50.160:FF:000008', NULL, NULL, 'Complement component C5', NULL, NULL, NULL, NULL, NULL, 4),
(45261, NULL, 'G3DSA:3.30.70.330:FF:002220', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45262, NULL, 'G3DSA:1.50.10.10:FF:000007', NULL, NULL, 'Phosphorylase b kinase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(45263, NULL, 'G3DSA:2.70.150.10:FF:000211', NULL, NULL, 'Copper-transporting ATPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(45264, NULL, 'G3DSA:2.30.30.490:FF:000055', NULL, NULL, 'Polybromo 1', NULL, NULL, NULL, NULL, NULL, 4),
(45265, NULL, 'G3DSA:3.30.200.20:FF:000999', NULL, NULL, 'Protein phosphatase 2C and cyclic nucleotide-binding/kinase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(45266, NULL, 'G3DSA:3.30.200.60:FF:000011', NULL, NULL, 'OTU deubiquitinase, ubiquitin aldehyde-binding 1a', NULL, NULL, NULL, NULL, NULL, 4),
(45267, NULL, 'G3DSA:1.10.8.10:FF:000036', NULL, NULL, 'Toll-interacting protein-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(45268, NULL, 'G3DSA:3.40.850.10:FF:000121', NULL, NULL, 'Myosin B', NULL, NULL, NULL, NULL, NULL, 4),
(45269, NULL, 'G3DSA:3.30.160.60:FF:003839', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45270, NULL, 'G3DSA:1.10.510.10:FF:004174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45271, NULL, 'G3DSA:2.130.10.10:FF:005335', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45272, NULL, 'G3DSA:2.10.25.10:FF:000322', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(45273, NULL, 'G3DSA:3.40.50.12650:FF:000012', NULL, NULL, 'DNA repair metallo-beta-lactamase, putative', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(45274, NULL, 'G3DSA:3.30.190.20:FF:000036', NULL, NULL, '39S ribosomal protein L1, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(45275, NULL, 'G3DSA:3.80.10.10:FF:003352', NULL, NULL, 'Si:zfos-323e3.4', NULL, NULL, NULL, NULL, NULL, 4),
(45276, NULL, 'G3DSA:3.30.200.20:FF:001724', NULL, NULL, 'Receptor protein kinase TMK1', NULL, NULL, NULL, NULL, NULL, 4),
(45277, NULL, 'G3DSA:3.30.200.20:FF:001836', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(45278, NULL, 'G3DSA:3.30.70.330:FF:003029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45279, NULL, 'G3DSA:2.30.30.940:FF:000010', NULL, NULL, 'ATP-dependent RecD-like DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(45280, NULL, 'G3DSA:4.10.520.10:FF:000009', NULL, NULL, 'Nucleoid DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(45281, NULL, 'G3DSA:1.25.40.10:FF:005306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45282, NULL, 'G3DSA:3.20.20.300:FF:000079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45283, NULL, 'G3DSA:3.30.450.40:FF:000293', NULL, NULL, 'PAS sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(45284, NULL, 'G3DSA:3.40.50.620:FF:000833', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45285, NULL, 'G3DSA:1.10.10.160:FF:000005', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(45286, NULL, 'G3DSA:3.30.160.60:FF:001653', NULL, NULL, 'Zinc finger and BTB domain containing 7C', NULL, NULL, NULL, NULL, NULL, 4),
(45287, NULL, 'G3DSA:2.60.40.150:FF:000443', NULL, NULL, 'Protein-transporting protein', NULL, NULL, NULL, NULL, NULL, 4),
(45288, NULL, 'G3DSA:3.40.50.300:FF:007943', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(45289, NULL, 'G3DSA:1.20.1250.20:FF:000123', NULL, NULL, 'Tricarballylate/proton symporter TcuC', NULL, NULL, NULL, NULL, NULL, 4),
(45290, NULL, 'G3DSA:3.30.40.10:FF:001349', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(45291, NULL, 'G3DSA:1.10.1370.30:FF:000025', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(45292, NULL, 'G3DSA:3.30.450.20:FF:000399', NULL, NULL, 'Aryl hydrocarbon receptor type 1', NULL, NULL, NULL, NULL, NULL, 4),
(45293, NULL, 'G3DSA:3.40.50.10490:FF:000038', NULL, NULL, 'Fructoselysine 6-phosphate deglycase', NULL, NULL, NULL, NULL, NULL, 4),
(45294, NULL, 'G3DSA:3.40.50.1000:FF:000615', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45295, NULL, 'G3DSA:3.40.50.1010:FF:000152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45296, NULL, 'G3DSA:3.40.50.300:FF:004116', NULL, NULL, 'AAA_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(45297, NULL, 'G3DSA:3.40.50.300:FF:003492', NULL, NULL, 'AGAP012735-PA', NULL, NULL, NULL, NULL, NULL, 4),
(45298, NULL, 'G3DSA:3.30.160.60:FF:001541', NULL, NULL, 'zinc finger protein OZF', NULL, NULL, NULL, NULL, NULL, 4),
(45299, NULL, 'G3DSA:2.60.40.1170:FF:000050', NULL, NULL, 'AP-3 complex subunit mu', NULL, NULL, NULL, NULL, NULL, 4),
(45300, NULL, 'G3DSA:2.130.10.10:FF:005459', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45301, NULL, 'G3DSA:2.60.200.10:FF:000021', NULL, NULL, 'Interferon regulatory factor 9', NULL, NULL, NULL, NULL, NULL, 4),
(45302, NULL, 'G3DSA:3.30.70.330:FF:001383', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(45303, NULL, 'G3DSA:1.10.287.890:FF:000005', NULL, NULL, 'Adenylate isopentenyltransferase 4', NULL, NULL, NULL, NULL, NULL, 4),
(45304, NULL, 'G3DSA:3.30.70.3030:FF:000007', NULL, NULL, 'Nucleolar protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(45305, NULL, 'G3DSA:3.30.70.330:FF:001495', NULL, NULL, 'Protein CBR-UNC-75', NULL, NULL, NULL, NULL, NULL, 4),
(45306, NULL, 'G3DSA:1.10.238.10:FF:000943', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45307, NULL, 'G3DSA:1.20.1560.10:FF:000284', NULL, NULL, 'ABC multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(45308, NULL, 'G3DSA:1.10.8.60:FF:000080', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(45309, NULL, 'G3DSA:3.30.2130.30:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45310, NULL, 'G3DSA:3.40.50.10470:FF:000032', NULL, NULL, 'Translation initiation factor eIF-2B subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(45311, NULL, 'G3DSA:3.30.1460.50:FF:000009', NULL, NULL, 'Autophagy-related protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(45312, NULL, 'G3DSA:2.70.170.10:FF:000206', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45313, NULL, 'G3DSA:3.90.1170.30:FF:000006', NULL, NULL, 'Pyrimidine-nucleoside phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(45314, NULL, 'G3DSA:1.20.58.80:FF:000061', NULL, NULL, 'YALI0C00165p', NULL, NULL, NULL, NULL, NULL, 4),
(45315, NULL, 'G3DSA:2.60.40.10:FF:001592', NULL, NULL, 'Tenascin-X', NULL, NULL, NULL, NULL, NULL, 4),
(45316, NULL, 'G3DSA:1.20.120.350:FF:000224', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45317, NULL, 'G3DSA:1.10.275.40:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45318, NULL, 'G3DSA:3.30.559.10:FF:000154', NULL, NULL, 'Si:ch211-256m1.8', NULL, NULL, NULL, NULL, NULL, 4),
(45319, NULL, 'G3DSA:3.30.530.20:FF:000012', NULL, NULL, 'Acyl-coenzyme A thioesterase 11', NULL, NULL, NULL, NULL, NULL, 4),
(45320, NULL, 'G3DSA:3.40.50.1360:FF:000026', NULL, NULL, 'DeoR/GlpR transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(45321, NULL, 'G3DSA:2.40.10.10:FF:000146', NULL, NULL, 'Serine protease 53', NULL, NULL, NULL, NULL, NULL, 4),
(45322, NULL, 'G3DSA:3.90.340.10:FF:000009', NULL, NULL, 'Nitric oxide synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(45323, NULL, 'G3DSA:1.50.40.10:FF:000223', NULL, NULL, 'SLC (SoLute Carrier) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(45324, NULL, 'G3DSA:1.25.40.10:FF:000523', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(45325, NULL, 'G3DSA:3.40.190.10:FF:000834', NULL, NULL, 'Opine/polyamine ABC transporter, periplasmic substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(45326, NULL, 'G3DSA:1.10.10.10:FF:001408', NULL, NULL, 'Iron-dependent transcriptional repressor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(45327, NULL, 'G3DSA:3.30.1460.30:FF:000003', NULL, NULL, 'DNA transformation protein TfoX', NULL, NULL, NULL, NULL, NULL, 4),
(45328, NULL, 'G3DSA:1.10.730.10:FF:000115', NULL, NULL, 'Methionyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(45329, NULL, 'G3DSA:1.10.10.10:FF:001184', NULL, NULL, 'Transcriptional regulator YetL MarR family', NULL, NULL, NULL, NULL, NULL, 4),
(45330, NULL, 'G3DSA:3.40.640.10:FF:000459', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45331, NULL, 'G3DSA:3.40.50.300:FF:007882', NULL, NULL, 'Spindle E', NULL, NULL, NULL, NULL, NULL, 4),
(45332, NULL, 'G3DSA:3.40.50.2000:FF:000870', NULL, NULL, 'Chromosome 23, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(45333, NULL, 'G3DSA:3.40.50.720:FF:001605', NULL, NULL, '2,4-diaminopentanoate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(45334, NULL, 'G3DSA:3.40.50.150:FF:001120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45335, NULL, 'G3DSA:2.60.120.200:FF:000259', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(45336, NULL, 'G3DSA:3.30.560.10:FF:000011', NULL, NULL, 'Dehydrogenase xptC', NULL, NULL, NULL, NULL, NULL, 4),
(45337, NULL, 'G3DSA:1.10.135.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45338, NULL, 'G3DSA:3.90.1600.10:FF:000023', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(45339, NULL, 'G3DSA:3.20.20.140:FF:000160', NULL, NULL, 'Sodium/hydrogen exchanger 2', NULL, NULL, NULL, NULL, NULL, 4),
(45340, NULL, 'G3DSA:3.30.160.60:FF:004290', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45341, NULL, 'G3DSA:1.10.4200.10:FF:000002', NULL, NULL, 'Probable 2-(5''''-triphosphoribosyl)-3''-dephosphocoenzyme-A synthase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(45342, NULL, 'G3DSA:2.60.120.330:FF:000219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45343, NULL, 'G3DSA:2.30.30.140:FF:000214', NULL, NULL, 'Os04g0101300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(45344, NULL, 'G3DSA:3.50.50.60:FF:000661', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45345, NULL, 'G3DSA:2.10.25.10:FF:001339', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45346, NULL, 'G3DSA:3.20.20.140:FF:000008', NULL, NULL, 'Probable phosphatase YcdX', NULL, NULL, NULL, NULL, NULL, 4),
(45347, NULL, 'G3DSA:3.50.50.60:FF:001335', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45348, NULL, 'G3DSA:1.20.1310.30:FF:000002', NULL, NULL, 'Exocyst complex protein EXO70', NULL, NULL, NULL, NULL, NULL, 4),
(45349, NULL, 'G3DSA:3.90.226.10:FF:000137', NULL, NULL, 'Possible protease IV sppA (Endopeptidase IV)', NULL, NULL, NULL, NULL, NULL, 4),
(45350, NULL, 'G3DSA:3.20.20.80:FF:000739', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45351, NULL, 'G3DSA:3.30.70.1230:FF:000113', NULL, NULL, 'Adenylate cyclase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(45352, NULL, 'G3DSA:3.90.1410.10:FF:000003', NULL, NULL, 'Rubisco methyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(45353, NULL, 'G3DSA:1.25.50.20:FF:000021', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(45354, NULL, 'G3DSA:2.60.40.60:FF:000510', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45355, NULL, 'G3DSA:3.40.30.10:FF:001202', NULL, NULL, 'Calsequestrin', NULL, NULL, NULL, NULL, NULL, 4),
(45356, NULL, 'G3DSA:1.10.10.10:FF:000307', NULL, NULL, 'Crossover junction endonuclease MUS81', NULL, NULL, NULL, NULL, NULL, 4),
(45357, NULL, 'G3DSA:2.60.40.1120:FF:000057', NULL, NULL, 'Carboxypeptidase D, a', NULL, NULL, NULL, NULL, NULL, 4),
(45358, NULL, 'G3DSA:3.40.50.300:FF:008399', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(45359, NULL, 'G3DSA:2.30.30.40:FF:000213', NULL, NULL, 'High osmolarity signaling protein SHO1', NULL, NULL, NULL, NULL, NULL, 4),
(45360, NULL, 'G3DSA:2.60.120.260:FF:000350', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45361, NULL, 'G3DSA:2.60.220.50:FF:000017', NULL, NULL, 'Adhesion G protein-coupled receptor F3', NULL, NULL, NULL, NULL, NULL, 4),
(45362, NULL, 'G3DSA:2.40.100.10:FF:000035', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(45363, NULL, 'G3DSA:1.10.730.20:FF:000023', NULL, NULL, 'Isoleucyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(45364, NULL, 'G3DSA:3.10.110.10:FF:000302', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45365, NULL, 'G3DSA:1.10.287.110:FF:000435', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45366, NULL, 'G3DSA:3.40.140.10:FF:000270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45367, NULL, 'G3DSA:3.40.605.10:FF:000046', NULL, NULL, 'Aldehyde dehydrogenase family 7 member A1', NULL, NULL, NULL, NULL, NULL, 4),
(45368, NULL, 'G3DSA:3.90.550.50:FF:000048', NULL, NULL, 'beta-1,3-N-acetylglucosaminyltransferase radical fringe', NULL, NULL, NULL, NULL, NULL, 4),
(45369, NULL, 'G3DSA:2.30.240.10:FF:000002', NULL, NULL, 'Uncharacterized protein At3g07460', NULL, NULL, NULL, NULL, NULL, 4),
(45370, NULL, 'G3DSA:3.20.20.120:FF:000002', NULL, NULL, 'Enolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(45371, NULL, 'G3DSA:1.20.1310.10:FF:000120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45372, NULL, 'G3DSA:3.40.50.300:FF:002082', NULL, NULL, 'Ras GTPAse, putative', NULL, NULL, NULL, NULL, NULL, 4),
(45373, NULL, 'G3DSA:1.25.40.20:FF:001133', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(45374, NULL, 'G3DSA:3.30.530.20:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45375, NULL, 'G3DSA:2.60.40.1180:FF:000148', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(45376, NULL, 'G3DSA:2.60.120.620:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45377, NULL, 'G3DSA:3.30.1010.10:FF:000048', NULL, NULL, 'Phosphatidylinositol 4-kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(45378, NULL, 'G3DSA:3.40.1110.10:FF:000143', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(45379, NULL, 'G3DSA:3.30.160.60:FF:006324', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45380, NULL, 'G3DSA:1.25.10.10:FF:000307', NULL, NULL, '26S proteasome regulatory subunit RPN1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(45381, NULL, 'G3DSA:3.80.10.10:FF:000743', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45382, NULL, 'G3DSA:3.20.20.70:FF:000641', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45383, NULL, 'G3DSA:3.40.50.300:FF:006325', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45384, NULL, 'G3DSA:1.20.1070.10:FF:001157', NULL, NULL, 'Hydroxycarboxylic acid receptor 1-4', NULL, NULL, NULL, NULL, NULL, 4),
(45385, NULL, 'G3DSA:1.25.10.10:FF:001095', NULL, NULL, 'Coatomer protein complex, subunit gamma 2', NULL, NULL, NULL, NULL, NULL, 4),
(45386, NULL, 'G3DSA:4.10.400.10:FF:000181', NULL, NULL, 'Low-density lipoprotein RecePtor related', NULL, NULL, NULL, NULL, NULL, 4),
(45387, NULL, 'G3DSA:1.10.1200.10:FF:000029', NULL, NULL, 'Acyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(45388, NULL, 'G3DSA:2.60.40.10:FF:002665', NULL, NULL, 'Immunoglobulin superfamily, member 8', NULL, NULL, NULL, NULL, NULL, 4),
(45389, NULL, 'G3DSA:1.10.8.270:FF:000001', NULL, NULL, 'TBC1 domain family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(45390, NULL, 'G3DSA:2.60.220.30:FF:000011', NULL, NULL, 'P53-induced death domain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(45391, NULL, 'G3DSA:1.10.1450.10:FF:000020', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(45392, NULL, 'G3DSA:1.10.630.10:FF:000282', NULL, NULL, 'Lanosterol 14-alpha demethylase', NULL, NULL, NULL, NULL, NULL, 4),
(45393, NULL, 'G3DSA:1.20.1250.20:FF:000527', NULL, NULL, 'Probable triacylglyceride transporter Mb1445c', NULL, NULL, NULL, NULL, NULL, 4),
(45394, NULL, 'G3DSA:1.20.1640.10:FF:000009', NULL, NULL, 'Dispatched homolog 1 (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(45395, NULL, 'G3DSA:3.40.1110.10:FF:000486', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45396, NULL, 'G3DSA:1.10.460.10:FF:000038', NULL, NULL, 'DNA topoisomerase type IA core', NULL, NULL, NULL, NULL, NULL, 4),
(45397, NULL, 'G3DSA:2.60.120.920:FF:000121', NULL, NULL, 'Ryanodine receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(45398, NULL, 'G3DSA:3.40.50.300:FF:001862', NULL, NULL, 'Disease resistance protein RPS4', NULL, NULL, NULL, NULL, NULL, 4),
(45399, NULL, 'G3DSA:3.30.505.10:FF:000058', NULL, NULL, 'SH2 domain-containing adapter protein D', NULL, NULL, NULL, NULL, NULL, 4),
(45400, NULL, 'G3DSA:2.60.40.1290:FF:000001', NULL, NULL, 'Clumping factor A', NULL, NULL, NULL, NULL, NULL, 4),
(45401, NULL, 'G3DSA:2.130.10.10:FF:004211', NULL, NULL, 'Uncharacterized WD repeat-containing protein C32H8.09', NULL, NULL, NULL, NULL, NULL, 4),
(45402, NULL, 'G3DSA:2.30.29.30:FF:001100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45403, NULL, 'G3DSA:2.10.25.10:FF:000642', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(45404, NULL, 'G3DSA:3.30.160.60:FF:002261', NULL, NULL, 'zinc finger protein 236 isoform X7', NULL, NULL, NULL, NULL, NULL, 4),
(45405, NULL, 'G3DSA:3.30.420.10:FF:000029', NULL, NULL, 'ERI1 exoribonuclease 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(45406, NULL, 'G3DSA:1.25.10.10:FF:000807', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(45407, NULL, 'G3DSA:2.10.70.10:FF:000218', NULL, NULL, 'Protein lev-9', NULL, NULL, NULL, NULL, NULL, 4),
(45408, NULL, 'G3DSA:3.30.70.330:FF:000775', NULL, NULL, 'GL16640', NULL, NULL, NULL, NULL, NULL, 4),
(45409, NULL, 'G3DSA:1.20.58.390:FF:000231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(45410, NULL, 'G3DSA:3.40.470.10:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45411, NULL, 'G3DSA:3.90.190.10:FF:000368', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45412, NULL, 'G3DSA:3.90.260.10:FF:000008', NULL, NULL, 'DNA repair protein RAD4', NULL, NULL, NULL, NULL, NULL, 4),
(45413, NULL, 'G3DSA:1.20.210.10:FF:000001', NULL, NULL, 'Cytochrome c oxidase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(45414, NULL, 'G3DSA:3.40.50.720:FF:002033', NULL, NULL, 'Short-chain alcohol dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(45415, NULL, 'G3DSA:3.30.70.1230:FF:000248', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45416, NULL, 'G3DSA:1.10.287.70:FF:000490', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45417, NULL, 'G3DSA:3.60.110.10:FF:000044', NULL, NULL, 'Carbon-nitrogen hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(45418, NULL, 'G3DSA:2.60.120.650:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45419, NULL, 'G3DSA:3.40.33.10:FF:000056', NULL, NULL, 'AGAP002703-PA', NULL, NULL, NULL, NULL, NULL, 4),
(45420, NULL, 'G3DSA:3.10.110.10:FF:000061', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 8', NULL, NULL, NULL, NULL, NULL, 4),
(45421, NULL, 'G3DSA:3.30.460.80:FF:000007', NULL, NULL, 'Formate hydrogenase HycE', NULL, NULL, NULL, NULL, NULL, 4),
(45422, NULL, 'G3DSA:3.90.920.10:FF:000020', NULL, NULL, 'Multifunctional non-homologous end joining protein LigD', NULL, NULL, NULL, NULL, NULL, 4),
(45423, NULL, 'G3DSA:3.40.50.1110:FF:000148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45424, NULL, 'G3DSA:1.10.150.50:FF:000133', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45425, NULL, 'G3DSA:1.25.10.10:FF:001027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45426, NULL, 'G3DSA:3.40.50.2300:FF:000050', NULL, NULL, 'Response regulator receiver', NULL, NULL, NULL, NULL, NULL, 4),
(45427, NULL, 'G3DSA:1.20.144.10:FF:000122', NULL, NULL, 'Lipid A 4''-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(45428, NULL, 'G3DSA:1.20.1310.20:FF:000010', NULL, NULL, 'Erythrocyte binding antigen-181', NULL, NULL, NULL, NULL, NULL, 4),
(45429, NULL, 'G3DSA:1.25.40.10:FF:000315', NULL, NULL, 'Transcriptional activator CadC', NULL, NULL, NULL, NULL, NULL, 4),
(45430, NULL, 'G3DSA:3.30.160.60:FF:000405', NULL, NULL, 'pogo transposable element with ZNF domain isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(45431, NULL, 'G3DSA:3.40.720.10:FF:000117', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45432, NULL, 'G3DSA:1.10.150.110:FF:000031', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(45433, NULL, 'G3DSA:3.30.160.60:FF:003339', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45434, NULL, 'G3DSA:2.10.60.10:FF:000004', NULL, NULL, 'Ly6/PLAUR domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(45435, NULL, 'G3DSA:2.60.120.200:FF:000759', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(45436, NULL, 'G3DSA:3.30.160.60:FF:000748', NULL, NULL, 'PR domain zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(45437, NULL, 'G3DSA:2.60.40.10:FF:001384', NULL, NULL, 'Beta-D-xylosidase 4', NULL, NULL, NULL, NULL, NULL, 4),
(45438, NULL, 'G3DSA:3.20.20.10:FF:000027', NULL, NULL, 'Pyridoxal-dependent decarboxylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(45439, NULL, 'G3DSA:3.40.630.30:FF:000184', NULL, NULL, 'GCN5-related N-acetyl-transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(45440, NULL, 'G3DSA:1.10.10.10:FF:001684', NULL, NULL, 'Interferon regulatory factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(45441, NULL, 'G3DSA:4.10.960.10:FF:000003', NULL, NULL, '50S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(45442, NULL, 'G3DSA:3.30.420.40:FF:000465', NULL, NULL, 'Heat shock cognate 70 kDa protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(45443, NULL, 'G3DSA:2.60.40.10:FF:002401', NULL, NULL, 'Cytokine receptor like factor 2', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(45444, NULL, 'G3DSA:2.40.290.30:FF:000003', NULL, NULL, 'Prostate tumor-overexpressed gene 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(45445, NULL, 'G3DSA:3.10.20.90:FF:000153', NULL, NULL, 'Ral guanine nucleotide dissociation stimulator like 2', NULL, NULL, NULL, NULL, NULL, 4),
(45446, NULL, 'G3DSA:2.70.98.40:FF:000002', NULL, NULL, 'Putative maltose phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(45447, NULL, 'G3DSA:4.10.880.10:FF:000002', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(45448, NULL, 'G3DSA:3.40.50.720:FF:000796', NULL, NULL, 'Enoyl-CoA Hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(45449, NULL, 'G3DSA:3.60.40.10:FF:000089', NULL, NULL, 'Protein phosphatase 2C 71', NULL, NULL, NULL, NULL, NULL, 4),
(45450, NULL, 'G3DSA:1.25.40.10:FF:003625', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g09040, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(45451, NULL, 'G3DSA:1.20.1250.20:FF:002208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45452, NULL, 'G3DSA:6.10.140.2220:FF:000057', NULL, NULL, 'LD37257p', NULL, NULL, NULL, NULL, NULL, 4),
(45453, NULL, 'G3DSA:3.40.50.300:FF:005173', NULL, NULL, 'Type II/IV secretion system ATPase TadZ/CpaE, associated with Flp pilus assembly', NULL, NULL, NULL, NULL, NULL, 4),
(45454, NULL, 'G3DSA:3.40.50.620:FF:000592', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45455, NULL, 'G3DSA:3.30.60.20:FF:000100', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(45456, NULL, 'G3DSA:3.30.930.10:FF:000388', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(45457, NULL, 'G3DSA:2.60.120.10:FF:000144', NULL, NULL, 'sodium/hydrogen exchanger 11 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(45458, NULL, 'G3DSA:3.40.30.10:FF:001090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45459, NULL, 'G3DSA:2.60.40.10:FF:005599', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45460, NULL, 'G3DSA:2.40.160.50:FF:000005', NULL, NULL, 'Outer membrane OMP85 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(45461, NULL, 'G3DSA:1.20.1050.10:FF:000133', NULL, NULL, 'Tau class glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(45462, NULL, 'G3DSA:3.40.366.10:FF:000029', NULL, NULL, 'Malonyl CoA-acyl carrier protein transacylase', NULL, NULL, NULL, NULL, NULL, 4),
(45463, NULL, 'G3DSA:3.40.50.300:FF:002823', NULL, NULL, 'ATP-binding cassette (ABC) transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(45464, NULL, 'G3DSA:3.40.50.620:FF:000272', NULL, NULL, 'Universal stress protein family', NULL, NULL, NULL, NULL, NULL, 4),
(45465, NULL, 'G3DSA:3.40.395.10:FF:000001', NULL, NULL, 'Sentrin-specific protease 1', NULL, NULL, NULL, NULL, NULL, 4),
(45466, NULL, 'G3DSA:3.20.20.140:FF:000284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45467, NULL, 'G3DSA:3.30.870.10:FF:000113', NULL, NULL, 'Cardiolipin synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(45468, NULL, 'G3DSA:3.40.1280.30:FF:000015', NULL, NULL, 'tRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(45469, NULL, 'G3DSA:1.10.510.10:FF:000543', NULL, NULL, 'Serine/threonine-protein kinase CDL1-like', NULL, NULL, NULL, NULL, NULL, 4),
(45470, NULL, 'G3DSA:2.40.50.100:FF:000041', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(45471, NULL, 'G3DSA:1.20.1730.10:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45472, NULL, 'G3DSA:3.30.160.60:FF:004790', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45473, NULL, 'G3DSA:1.25.40.10:FF:004289', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(45474, NULL, 'G3DSA:1.20.1270.60:FF:000170', NULL, NULL, 'Rgd3p', NULL, NULL, NULL, NULL, NULL, 4),
(45475, NULL, 'G3DSA:1.10.3730.10:FF:000002', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(45476, NULL, 'G3DSA:2.30.30.40:FF:000005', NULL, NULL, 'SLIT-ROBO Rho GTPase-activating protein 1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(45477, NULL, 'G3DSA:3.30.160.60:FF:003098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45478, NULL, 'G3DSA:2.120.10.80:FF:000017', NULL, NULL, 'kelch-like protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(45479, NULL, 'G3DSA:2.30.30.1020:FF:000011', NULL, NULL, 'CCR4-NOT transcriptional complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(45480, NULL, 'G3DSA:3.30.1740.10:FF:000007', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(45481, NULL, 'G3DSA:1.20.920.10:FF:000072', NULL, NULL, 'Bromodomain-containing factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(45482, NULL, 'G3DSA:1.10.510.10:FF:000020', NULL, NULL, 'serine/threonine-protein kinase D6PK-like', NULL, NULL, NULL, NULL, NULL, 4),
(45483, NULL, 'G3DSA:3.40.50.150:FF:000788', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45484, NULL, 'G3DSA:1.10.3810.10:FF:000003', NULL, NULL, 'Penicillin-binding protein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(45485, NULL, 'G3DSA:3.40.800.20:FF:000008', NULL, NULL, 'Histone deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(45486, NULL, 'G3DSA:3.40.50.410:FF:000147', NULL, NULL, 'Copine family protein', NULL, NULL, NULL, NULL, NULL, 4),
(45487, NULL, 'G3DSA:3.40.50.300:FF:003992', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45488, NULL, 'G3DSA:3.40.50.10380:FF:000005', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(45489, NULL, 'G3DSA:1.10.3210.10:FF:000093', NULL, NULL, 'HD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(45490, NULL, 'G3DSA:2.60.40.60:FF:000010', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(45491, NULL, 'G3DSA:2.130.10.10:FF:003273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45492, NULL, 'G3DSA:3.30.110.20:FF:000020', NULL, NULL, 'Rpp20 subunit of nuclear RNase MRP and P-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(45493, NULL, 'G3DSA:3.40.720.10:FF:000061', NULL, NULL, 'Sulfatase atsG', NULL, NULL, NULL, NULL, NULL, 4),
(45494, NULL, 'G3DSA:2.40.50.120:FF:000047', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(45495, NULL, 'G3DSA:2.60.40.3800:FF:000001', NULL, NULL, 'Gingipain R2', NULL, NULL, NULL, NULL, NULL, 4),
(45496, NULL, 'G3DSA:3.30.50.10:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45497, NULL, 'G3DSA:1.10.287.660:FF:000021', NULL, NULL, 'Pre-mRNA-splicing factor ISY1', NULL, NULL, NULL, NULL, NULL, 4),
(45498, NULL, 'G3DSA:1.20.1270.280:FF:000075', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45499, NULL, 'G3DSA:1.10.510.10:FF:001768', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45500, NULL, 'G3DSA:3.80.10.10:FF:002896', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45501, NULL, 'G3DSA:1.20.58.340:FF:000053', NULL, NULL, 'Magnesium and cobalt transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(45502, NULL, 'G3DSA:3.30.565.10:FF:000207', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(45503, NULL, 'G3DSA:1.10.510.10:FF:002100', NULL, NULL, 'Cell division control protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(45504, NULL, 'G3DSA:3.30.450.40:FF:000225', NULL, NULL, 'PAS sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(45505, NULL, 'G3DSA:1.20.1320.30:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45506, NULL, 'G3DSA:1.10.510.10:FF:001644', NULL, NULL, 'Serine/threonine-protein kinase US3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(45507, NULL, 'G3DSA:1.25.10.20:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45508, NULL, 'G3DSA:1.20.140.10:FF:000006', NULL, NULL, 'Glutaryl-CoA dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(45509, NULL, 'G3DSA:1.10.287.110:FF:000255', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(45510, NULL, 'G3DSA:3.90.470.40:FF:000005', NULL, NULL, 'DNA damage-inducible transcript 4-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(45511, NULL, 'G3DSA:1.10.472.80:FF:000058', NULL, NULL, 'Ubiquitin specific peptidase 6', NULL, NULL, NULL, NULL, NULL, 4),
(45512, NULL, 'G3DSA:1.10.1660.10:FF:000002', NULL, NULL, 'Redox-sensitive transcriptional activator SoxR', NULL, NULL, NULL, NULL, NULL, 4),
(45513, NULL, 'G3DSA:2.70.150.10:FF:000031', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(45514, NULL, 'G3DSA:3.90.1420.10:FF:000037', NULL, NULL, 'Lysine N-methylase', NULL, NULL, NULL, NULL, NULL, 4),
(45515, NULL, 'G3DSA:3.30.160.60:FF:004059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45516, NULL, 'G3DSA:3.90.228.20:FF:000009', NULL, NULL, 'Os04g0592500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(45517, NULL, 'G3DSA:3.30.70.20:FF:000106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45518, NULL, 'G3DSA:1.10.287.540:FF:000002', NULL, NULL, 'Fimbrial assembly membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(45519, NULL, 'G3DSA:3.30.40.10:FF:000781', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45520, NULL, 'G3DSA:3.30.830.10:FF:000324', NULL, NULL, 'Presequence protease', NULL, NULL, NULL, NULL, NULL, 4),
(45521, NULL, 'G3DSA:2.60.40.10:FF:000535', NULL, NULL, 'neural cell adhesion molecule L1-like protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(45522, NULL, 'G3DSA:3.30.420.10:FF:000361', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45523, NULL, 'G3DSA:3.40.1780.10:FF:000002', NULL, NULL, 'S-adenosylmethionine:tRNA ribosyltransferase-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(45524, NULL, 'G3DSA:1.10.510.10:FF:003977', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45525, NULL, 'G3DSA:3.30.40.10:FF:001169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45526, NULL, 'G3DSA:3.30.1780.10:FF:000004', NULL, NULL, '2,3-diaminopropionate biosynthesis protein SbnB', NULL, NULL, NULL, NULL, NULL, 4),
(45527, NULL, 'G3DSA:1.10.10.10:FF:000515', NULL, NULL, 'DNA-directed RNA polymerase III subunit rpc3', NULL, NULL, NULL, NULL, NULL, 4),
(45528, NULL, 'G3DSA:2.70.170.10:FF:000274', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45529, NULL, 'G3DSA:3.30.70.80:FF:000040', NULL, NULL, 'Tk-subtilisin', NULL, NULL, NULL, NULL, NULL, 4),
(45530, NULL, 'G3DSA:3.90.550.10:FF:000727', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45531, NULL, 'G3DSA:2.60.120.330:FF:000039', NULL, NULL, 'Unplaced genomic scaffold supercont1.13, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(45532, NULL, 'G3DSA:1.25.40.20:FF:000195', NULL, NULL, 'Kinase D-interacting substrate of 220 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(45533, NULL, 'G3DSA:1.10.630.10:FF:000759', NULL, NULL, 'Fatty acid hydroxylase, cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(45534, NULL, 'G3DSA:1.25.40.190:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45535, NULL, 'G3DSA:1.20.5.100:FF:000009', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(45536, NULL, 'G3DSA:1.25.10.10:FF:001999', NULL, NULL, 'ADR334Wp', NULL, NULL, NULL, NULL, NULL, 4),
(45537, NULL, 'G3DSA:1.10.167.10:FF:000031', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(45538, NULL, 'G3DSA:3.40.50.300:FF:005869', NULL, NULL, 'ATP-dependent DNA helicase recQ', NULL, NULL, NULL, NULL, NULL, 4),
(45539, NULL, 'G3DSA:1.10.510.10:FF:004253', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45540, NULL, 'G3DSA:1.10.10.2360:FF:000002', NULL, NULL, 'Unplaced genomic scaffold supercont1.219, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(45541, NULL, 'G3DSA:3.40.50.300:FF:002435', NULL, NULL, 'Probable SNF2-component of SWI/SNF global transcription activator complex', NULL, NULL, NULL, NULL, NULL, 4),
(45542, NULL, 'G3DSA:1.10.238.110:FF:000004', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(45543, NULL, 'G3DSA:4.10.1000.10:FF:000118', NULL, NULL, 'Pharynx and intestine in excess protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(45544, NULL, 'G3DSA:2.130.10.10:FF:003194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45545, NULL, 'G3DSA:3.80.10.10:FF:001087', NULL, NULL, 'Leucine-rich_repeat_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(45546, NULL, 'G3DSA:3.30.420.10:FF:000181', NULL, NULL, 'RNase H', NULL, NULL, NULL, NULL, NULL, 4),
(45547, NULL, 'G3DSA:3.30.70.100:FF:000083', NULL, NULL, 'Heavy-metal transporting CPx-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(45548, NULL, 'G3DSA:2.60.120.10:FF:000279', NULL, NULL, 'Unplaced genomic scaffold supercont2.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(45549, NULL, 'G3DSA:1.20.1270.60:FF:000018', NULL, NULL, 'Rho GTPase activating protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(45550, NULL, 'G3DSA:1.20.1070.10:FF:000376', NULL, NULL, 'probable G-protein coupled receptor 141', NULL, NULL, NULL, NULL, NULL, 4),
(45551, NULL, 'G3DSA:3.90.228.10:FF:000063', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(45552, NULL, 'G3DSA:3.30.70.270:FF:000004', NULL, NULL, 'Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(45553, NULL, 'G3DSA:3.30.70.330:FF:002012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45554, NULL, 'G3DSA:2.60.40.10:FF:006055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45555, NULL, 'G3DSA:2.40.10.10:FF:000410', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45556, NULL, 'G3DSA:2.60.40.790:FF:000168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45557, NULL, 'G3DSA:2.130.10.10:FF:004554', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45558, NULL, 'G3DSA:1.10.3500.10:FF:000013', NULL, NULL, 'Holliday-junction_resolvase-like_of_SPT6 /SH2_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(45559, NULL, 'G3DSA:3.40.532.10:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45560, NULL, 'G3DSA:3.30.200.20:FF:001483', NULL, NULL, 'Inactive leucine-rich repeat receptor-like protein kinase isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(45561, NULL, 'G3DSA:3.80.10.10:FF:004133', NULL, NULL, 'Probable serine/threonine-protein kinase pats1', NULL, NULL, NULL, NULL, NULL, 4),
(45562, NULL, 'G3DSA:2.60.210.10:FF:000027', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(45563, NULL, 'G3DSA:3.10.50.30:FF:000002', NULL, NULL, 'Regulator of nucleoside diphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(45564, NULL, 'G3DSA:2.10.90.10:FF:000040', NULL, NULL, 'Persephin', NULL, NULL, NULL, NULL, NULL, 4),
(45565, NULL, 'G3DSA:2.10.25.10:FF:001603', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45566, NULL, 'G3DSA:3.30.70.330:FF:001736', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45567, NULL, 'G3DSA:2.60.40.420:FF:000265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45568, NULL, 'G3DSA:3.30.710.10:FF:000405', NULL, NULL, 'Rho-related BTB domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(45569, NULL, 'G3DSA:2.10.50.10:FF:000122', NULL, NULL, 'Ephrin receptor like protein', NULL, NULL, NULL, NULL, NULL, 4),
(45570, NULL, 'G3DSA:1.20.58.530:FF:000020', NULL, NULL, 'Myosin C', NULL, NULL, NULL, NULL, NULL, 4),
(45571, NULL, 'G3DSA:3.80.10.10:FF:003857', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45572, NULL, 'G3DSA:3.40.50.10890:FF:000006', NULL, NULL, 'Cleavage and polyadenylation specificity factor subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(45573, NULL, 'G3DSA:3.30.1320.10:FF:000015', NULL, NULL, '30S ribosomal protein S16', NULL, NULL, NULL, NULL, NULL, 4),
(45574, NULL, 'G3DSA:3.40.50.300:FF:000226', NULL, NULL, 'Ras-related GTP-binding protein D', NULL, NULL, NULL, NULL, NULL, 4),
(45575, NULL, 'G3DSA:2.130.10.10:FF:001120', NULL, NULL, 'Blast:DmX-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(45576, NULL, 'G3DSA:1.25.10.10:FF:001920', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(45577, NULL, 'G3DSA:2.30.120.10:FF:000004', NULL, NULL, 'Penicillin acylase II', NULL, NULL, NULL, NULL, NULL, 4),
(45578, NULL, 'G3DSA:1.10.287.2620:FF:000008', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(45579, NULL, 'G3DSA:2.60.40.150:FF:000100', NULL, NULL, 'Extended synaptotagmin-2', NULL, NULL, NULL, NULL, NULL, 4),
(45580, NULL, 'G3DSA:3.40.50.1820:FF:001721', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45581, NULL, 'G3DSA:1.10.275.30:FF:000001', NULL, NULL, 'DNA repair helicase RAD3', NULL, NULL, NULL, NULL, NULL, 4),
(45582, NULL, 'G3DSA:1.20.120.360:FF:000002', NULL, NULL, 'Axin interactor, dorsalization associated', NULL, NULL, NULL, NULL, NULL, 4),
(45583, NULL, 'G3DSA:1.25.10.10:FF:002320', NULL, NULL, 'Armadillo-like helical domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(45584, NULL, 'G3DSA:2.60.40.10:FF:001945', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(45585, NULL, 'G3DSA:3.40.630.30:FF:000060', NULL, NULL, 'Alpha-tubulin N-acetyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(45586, NULL, 'G3DSA:3.40.50.1010:FF:000287', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45587, NULL, 'G3DSA:1.20.58.400:FF:000009', NULL, NULL, 'Unplaced genomic scaffold supercont1.201, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(45588, NULL, 'G3DSA:3.30.420.140:FF:000034', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(45589, NULL, 'G3DSA:3.30.160.60:FF:003918', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45590, NULL, 'G3DSA:1.20.5.1700:FF:000004', NULL, NULL, 'Homer homolog 2 (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(45591, NULL, 'G3DSA:3.40.50.1820:FF:000361', NULL, NULL, 'Thioesterase TesA', NULL, NULL, NULL, NULL, NULL, 4),
(45592, NULL, 'G3DSA:1.20.5.2440:FF:000007', NULL, NULL, 'Rab-11 Family Interacting-Protein', NULL, NULL, NULL, NULL, NULL, 4),
(45593, NULL, 'G3DSA:1.25.40.20:FF:000413', NULL, NULL, 'Ankyrin repeat domain 23', NULL, NULL, NULL, NULL, NULL, 4),
(45594, NULL, 'G3DSA:3.40.50.720:FF:001252', NULL, NULL, 'Nadp-dependent leukotriene b4', NULL, NULL, NULL, NULL, NULL, 4),
(45595, NULL, 'G3DSA:3.80.10.10:FF:001648', NULL, NULL, 'Nuclear RNA export factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(45596, NULL, 'G3DSA:1.10.540.10:FF:000039', NULL, NULL, 'Acyl-CoA dehydrogenase FadE28', NULL, NULL, NULL, NULL, NULL, 4),
(45597, NULL, 'G3DSA:3.40.50.2300:FF:000954', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45598, NULL, 'G3DSA:3.40.630.10:FF:000026', NULL, NULL, 'Carboxypeptidase D', NULL, NULL, NULL, NULL, NULL, 4),
(45599, NULL, 'G3DSA:3.40.50.261:FF:000007', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(45600, NULL, 'G3DSA:3.40.50.1000:FF:000227', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45601, NULL, 'G3DSA:2.120.10.30:FF:000311', NULL, NULL, 'Gluconolactonase', NULL, NULL, NULL, NULL, NULL, 4),
(45602, NULL, 'G3DSA:3.30.70.330:FF:000371', NULL, NULL, 'RNA-binding protein 28 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(45603, NULL, 'G3DSA:1.25.40.20:FF:000913', NULL, NULL, 'Zgc:112001', NULL, NULL, NULL, NULL, NULL, 4),
(45604, NULL, 'G3DSA:1.10.287.1260:FF:000005', NULL, NULL, 'Mechanosensitive ion channel family protein', NULL, NULL, NULL, NULL, NULL, 4),
(45605, NULL, 'G3DSA:3.30.160.60:FF:002665', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45606, NULL, 'G3DSA:2.30.30.210:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45607, NULL, 'G3DSA:2.40.50.140:FF:000761', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45608, NULL, 'G3DSA:3.40.50.1820:FF:000922', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45609, NULL, 'G3DSA:1.10.357.120:FF:000005', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(45610, NULL, 'G3DSA:3.80.10.10:FF:004346', NULL, NULL, 'Probable serine/threonine-protein kinase roco5', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(45611, NULL, 'G3DSA:1.10.565.10:FF:000006', NULL, NULL, 'Thyroid hormone receptor beta 2', NULL, NULL, NULL, NULL, NULL, 4),
(45612, NULL, 'G3DSA:3.40.1480.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45613, NULL, 'G3DSA:3.90.550.10:FF:000227', NULL, NULL, 'Glycosyltransferases', NULL, NULL, NULL, NULL, NULL, 4),
(45614, NULL, 'G3DSA:1.25.40.20:FF:001425', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45615, NULL, 'G3DSA:1.10.1280.10:FF:000017', NULL, NULL, 'Amino acid transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(45616, NULL, 'G3DSA:1.20.1070.10:FF:000937', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45617, NULL, 'G3DSA:2.30.29.30:FF:000370', NULL, NULL, 'Dynamin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(45618, NULL, 'G3DSA:1.10.20.140:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45619, NULL, 'G3DSA:2.60.40.10:FF:002165', NULL, NULL, 'Disorganized muscle protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(45620, NULL, 'G3DSA:2.130.10.10:FF:003773', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45621, NULL, 'G3DSA:3.30.70.1230:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45622, NULL, 'G3DSA:2.120.10.30:FF:000255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45623, NULL, 'G3DSA:3.40.50.740:FF:000015', NULL, NULL, 'Anaerobic dimethyl sulfoxide reductase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(45624, NULL, 'G3DSA:1.10.8.480:FF:000007', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(45625, NULL, 'G3DSA:1.10.510.10:FF:000520', NULL, NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', NULL, NULL, NULL, NULL, NULL, 4),
(45626, NULL, 'G3DSA:2.130.10.10:FF:000052', NULL, NULL, 'semaphorin-3F isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(45627, NULL, 'G3DSA:2.60.40.10:FF:005886', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45628, NULL, 'G3DSA:1.10.510.10:FF:001032', NULL, NULL, 'KP78b, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(45629, NULL, 'G3DSA:1.10.630.10:FF:000574', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45630, NULL, 'G3DSA:2.40.50.140:FF:001273', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45631, NULL, 'G3DSA:2.30.30.40:FF:000269', NULL, NULL, 'SH3 adapter protein SPIN90', NULL, NULL, NULL, NULL, NULL, 4),
(45632, NULL, 'G3DSA:3.60.40.10:FF:000066', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(45633, NULL, 'G3DSA:1.20.120.530:FF:000019', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(45634, NULL, 'G3DSA:2.40.50.690:FF:000010', NULL, NULL, 'Rrp44p homologue, putative', NULL, NULL, NULL, NULL, NULL, 4),
(45635, NULL, 'G3DSA:1.10.238.10:FF:000494', NULL, NULL, 'Ubiquitin interaction motif-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(45636, NULL, 'G3DSA:3.40.50.300:FF:000406', NULL, NULL, 'tRNA (N6-adenosine(37)-N6)-threonylcarbamoyltransferase complex ATPase TsaE', NULL, NULL, NULL, NULL, NULL, 4),
(45637, NULL, 'G3DSA:4.10.280.10:FF:000209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45638, NULL, 'G3DSA:2.60.40.10:FF:001608', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45639, NULL, 'G3DSA:3.40.50.300:FF:004740', NULL, NULL, 'Septin 7b', NULL, NULL, NULL, NULL, NULL, 4),
(45640, NULL, 'G3DSA:3.80.10.10:FF:003801', NULL, NULL, 'Leucine-rich repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(45641, NULL, 'G3DSA:1.20.1720.10:FF:000050', NULL, NULL, 'Major facilitator superfamily transporter', NULL, NULL, NULL, NULL, NULL, 4),
(45642, NULL, 'G3DSA:3.30.1370.100:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45643, NULL, 'G3DSA:1.20.1310.10:FF:000176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45644, NULL, 'G3DSA:3.40.50.2300:FF:000398', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(45645, NULL, 'G3DSA:1.25.40.20:FF:001369', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45646, NULL, 'G3DSA:2.120.10.30:FF:000199', NULL, NULL, 'Serine peptidase family S9', NULL, NULL, NULL, NULL, NULL, 4),
(45647, NULL, 'G3DSA:1.20.1740.10:FF:000045', NULL, NULL, 'Inner membrane transporter YhjV', NULL, NULL, NULL, NULL, NULL, 4),
(45648, NULL, 'G3DSA:2.130.10.30:FF:000114', NULL, NULL, 'NimA-like kinase', NULL, NULL, NULL, NULL, NULL, 4),
(45649, NULL, 'G3DSA:3.90.190.10:FF:000188', NULL, NULL, 'Protein tyrosine phosphatase type IVA 3', NULL, NULL, NULL, NULL, NULL, 4),
(45650, NULL, 'G3DSA:3.30.40.10:FF:000337', NULL, NULL, 'Zinc finger family protein', NULL, NULL, NULL, NULL, NULL, 4),
(45651, NULL, 'G3DSA:3.80.10.10:FF:000075', NULL, NULL, 'F-box/LRR-repeat protein 14 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(45652, NULL, 'G3DSA:2.130.10.10:FF:003722', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45653, NULL, 'G3DSA:2.160.20.10:FF:000310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45654, NULL, 'G3DSA:1.10.238.10:FF:000443', NULL, NULL, 'Ubiquitin specific peptidase 32', NULL, NULL, NULL, NULL, NULL, 4),
(45655, NULL, 'G3DSA:1.25.40.10:FF:003564', NULL, NULL, 'Plastid transcriptionally active 3', NULL, NULL, NULL, NULL, NULL, 4),
(45656, NULL, 'G3DSA:3.10.110.10:FF:000241', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 2', NULL, NULL, NULL, NULL, NULL, 4),
(45657, NULL, 'G3DSA:3.90.1140.10:FF:000004', NULL, NULL, 'A-kinase anchoring protein 7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(45658, NULL, 'G3DSA:3.40.50.1010:FF:000213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45659, NULL, 'G3DSA:2.40.37.20:FF:000003', NULL, NULL, 'D-serine deaminase, pyridoxal phosphate-dependent', NULL, NULL, NULL, NULL, NULL, 4),
(45660, NULL, 'G3DSA:1.10.3720.10:FF:000232', NULL, NULL, 'Sugar ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(45661, NULL, 'G3DSA:2.60.120.200:FF:000023', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(45662, NULL, 'G3DSA:1.10.10.60:FF:000041', NULL, NULL, 'insulin gene enhancer protein ISL-1', NULL, NULL, NULL, NULL, NULL, 4),
(45663, NULL, 'G3DSA:3.40.1090.10:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45664, NULL, 'G3DSA:3.40.30.10:FF:000538', NULL, NULL, 'Glutathione s-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(45665, NULL, 'G3DSA:3.40.50.2300:FF:001410', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45666, NULL, 'G3DSA:1.10.238.10:FF:000387', NULL, NULL, 'Myosin light chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(45667, NULL, 'G3DSA:3.40.630.30:FF:000684', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45668, NULL, 'G3DSA:1.20.58.60:FF:000139', NULL, NULL, 'nesprin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(45669, NULL, 'G3DSA:2.40.10.10:FF:000646', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45670, NULL, 'G3DSA:3.30.1460.20:FF:000017', NULL, NULL, 'Arp2/3 complex 34 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(45671, NULL, 'G3DSA:3.80.10.10:FF:004397', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45672, NULL, 'G3DSA:1.25.10.10:FF:002376', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45673, NULL, 'G3DSA:3.40.50.1820:FF:001485', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45674, NULL, 'G3DSA:3.30.230.130:FF:000061', NULL, NULL, 'YALI0A02200p', NULL, NULL, NULL, NULL, NULL, 4),
(45675, NULL, 'G3DSA:3.90.280.10:FF:000010', NULL, NULL, 'Phosphatidylethanolamine binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(45676, NULL, 'G3DSA:1.10.150.20:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45677, NULL, 'G3DSA:1.25.10.10:FF:002432', NULL, NULL, 'Wings apart family (Drosophila), putative', NULL, NULL, NULL, NULL, NULL, 4),
(45678, NULL, 'G3DSA:3.40.440.10:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(45679, NULL, 'G3DSA:3.40.50.1370:FF:000063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45680, NULL, 'G3DSA:3.80.10.10:FF:000979', NULL, NULL, 'NBS-LRR class disease resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(45681, NULL, 'G3DSA:1.25.40.20:FF:001476', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45682, NULL, 'G3DSA:3.30.160.60:FF:005464', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45683, NULL, 'G3DSA:2.10.220.10:FF:000106', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5a', NULL, NULL, NULL, NULL, NULL, 4),
(45684, NULL, 'G3DSA:3.10.20.90:FF:000653', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45685, NULL, 'G3DSA:3.90.550.50:FF:000043', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(45686, NULL, 'G3DSA:2.30.30.40:FF:000325', NULL, NULL, 'Hof1p', NULL, NULL, NULL, NULL, NULL, 4),
(45687, NULL, 'G3DSA:2.130.10.30:FF:000058', NULL, NULL, 'Regulator of chromosome condensation', NULL, NULL, NULL, NULL, NULL, 4),
(45688, NULL, 'G3DSA:3.40.50.300:FF:002379', NULL, NULL, 'Hydrogenobyrinate a,c-diamide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(45689, NULL, 'G3DSA:1.20.1310.10:FF:000232', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45690, NULL, 'G3DSA:3.90.1140.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45691, NULL, 'G3DSA:3.40.50.1010:FF:000264', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45692, NULL, 'G3DSA:2.40.100.10:FF:000012', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(45693, NULL, 'G3DSA:2.60.40.60:FF:000853', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45694, NULL, 'G3DSA:3.40.50.2000:FF:000426', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(45695, NULL, 'G3DSA:1.10.1620.20:FF:000002', NULL, NULL, 'ATP synthase subunit epsilon, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(45696, NULL, 'G3DSA:2.60.120.10:FF:000312', NULL, NULL, 'cGMP-dependent 3'',5''-cGMP phosphodiesterase A', NULL, NULL, NULL, NULL, NULL, 4),
(45697, NULL, 'G3DSA:1.10.3720.10:FF:000176', NULL, NULL, 'ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(45698, NULL, 'G3DSA:1.10.20.120:FF:000012', NULL, NULL, 'Ribonuclease H2 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(45699, NULL, 'G3DSA:3.40.50.2020:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45700, NULL, 'G3DSA:3.60.21.10:FF:000106', NULL, NULL, 'Sphingomyelin phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(45701, NULL, 'G3DSA:3.30.70.1950:FF:000003', NULL, NULL, 'Adapter protein MecA', NULL, NULL, NULL, NULL, NULL, 4),
(45702, NULL, 'G3DSA:1.20.1110.10:FF:000251', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45703, NULL, 'G3DSA:3.80.10.10:FF:002492', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45704, NULL, 'G3DSA:1.10.10.440:FF:000050', NULL, NULL, 'U1 snRNP protein', NULL, NULL, NULL, NULL, NULL, 4),
(45705, NULL, 'G3DSA:3.30.200.20:FF:001600', NULL, NULL, 'Protein CBR-FLR-4', NULL, NULL, NULL, NULL, NULL, 4),
(45706, NULL, 'G3DSA:2.60.200.20:FF:000086', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(45707, NULL, 'G3DSA:1.10.472.80:FF:000238', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45708, NULL, 'G3DSA:1.10.510.10:FF:002336', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45709, NULL, 'G3DSA:3.30.450.20:FF:000635', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(45710, NULL, 'G3DSA:3.30.200.20:FF:002000', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45711, NULL, 'G3DSA:3.30.460.10:FF:000127', NULL, NULL, '2''-5''-oligoadenylate synthetase-like protein isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(45712, NULL, 'G3DSA:1.10.510.10:FF:001936', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(45713, NULL, 'G3DSA:2.60.120.10:FF:000205', NULL, NULL, 'Lysophospholipase NTE1', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(45714, NULL, 'G3DSA:3.90.180.10:FF:000070', NULL, NULL, 'Mitochondrial enoyl reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(45715, NULL, 'G3DSA:3.30.160.60:FF:000248', NULL, NULL, 'zinc finger protein 62 homolog isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(45716, NULL, 'G3DSA:1.25.40.120:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45717, NULL, 'G3DSA:3.40.50.300:FF:006538', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45718, NULL, 'G3DSA:1.10.150.20:FF:000265', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45719, NULL, 'G3DSA:1.25.40.10:FF:002260', NULL, NULL, 'AGAP001809-PA', NULL, NULL, NULL, NULL, NULL, 4),
(45720, NULL, 'G3DSA:1.20.1110.10:FF:000195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45721, NULL, 'G3DSA:3.30.160.60:FF:004115', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45722, NULL, 'G3DSA:1.20.5.30:FF:000002', NULL, NULL, 'matrilin-4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(45723, NULL, 'G3DSA:3.10.10.10:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45724, NULL, 'G3DSA:2.170.150.20:FF:000004', NULL, NULL, 'Peptide-methionine (R)-S-oxide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(45725, NULL, 'G3DSA:3.40.50.720:FF:001257', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(45726, NULL, 'G3DSA:1.10.287.70:FF:000338', NULL, NULL, 'Ion transport protein/Polycystin cation channel, putative', NULL, NULL, NULL, NULL, NULL, 4),
(45727, NULL, 'G3DSA:3.30.450.60:FF:000063', NULL, NULL, 'AP complex subunit sigma', NULL, NULL, NULL, NULL, NULL, 4),
(45728, NULL, 'G3DSA:1.25.40.20:FF:000172', NULL, NULL, 'Ankyrin repeat domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(45729, NULL, 'G3DSA:1.20.1250.20:FF:001871', NULL, NULL, 'Os02g0832100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(45730, NULL, 'G3DSA:1.10.8.60:FF:000293', NULL, NULL, 'WGS project CABT00000000 data, contig 2.3', NULL, NULL, NULL, NULL, NULL, 4),
(45731, NULL, 'G3DSA:1.25.10.10:FF:000982', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(45732, NULL, 'G3DSA:3.80.10.10:FF:000182', NULL, NULL, 'volume-regulated anion channel subunit LRRC8C isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(45733, NULL, 'G3DSA:3.90.79.10:FF:000070', NULL, NULL, 'Nucleoside diphosphate hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(45734, NULL, 'G3DSA:1.20.5.50:FF:000008', NULL, NULL, 'Cell division protein ZapA', NULL, NULL, NULL, NULL, NULL, 4),
(45735, NULL, 'G3DSA:3.90.660.10:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45736, NULL, 'G3DSA:1.20.940.10:FF:000011', NULL, NULL, 'Pre-mRNA-splicing factor 18', NULL, NULL, NULL, NULL, NULL, 4),
(45737, NULL, 'G3DSA:3.30.200.20:FF:000027', NULL, NULL, 'Putative Cyclin-dependent kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(45738, NULL, 'G3DSA:3.40.50.11350:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45739, NULL, 'G3DSA:3.60.10.10:FF:000238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45740, NULL, 'G3DSA:1.20.1070.10:FF:000196', NULL, NULL, 'Glucagon like peptide 2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(45741, NULL, 'G3DSA:1.20.120.1760:FF:000075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45742, NULL, 'G3DSA:1.10.1370.30:FF:000002', NULL, NULL, 'M3 family oligoendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(45743, NULL, 'G3DSA:1.20.1050.10:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45744, NULL, 'G3DSA:3.50.30.30:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45745, NULL, 'G3DSA:2.130.10.10:FF:001412', NULL, NULL, 'AGAP010693-PA', NULL, NULL, NULL, NULL, NULL, 4),
(45746, NULL, 'G3DSA:3.90.740.10:FF:000034', NULL, NULL, 'Leucine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(45747, NULL, 'G3DSA:3.50.50.60:FF:001150', NULL, NULL, 'Os10g0554300 protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(45748, NULL, 'G3DSA:1.10.287.130:FF:000093', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(45749, NULL, 'G3DSA:1.25.40.10:FF:000635', NULL, NULL, 'Serine/threonine-protein kinase ATR', NULL, NULL, NULL, NULL, NULL, 4),
(45750, NULL, 'G3DSA:3.30.830.10:FF:000055', NULL, NULL, 'Falcilysin', NULL, NULL, NULL, NULL, NULL, 4),
(45751, NULL, 'G3DSA:3.40.50.300:FF:008163', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45752, NULL, 'G3DSA:1.10.10.350:FF:000023', NULL, NULL, 'Glutamate-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(45753, NULL, 'G3DSA:3.40.50.200:FF:000146', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45754, NULL, 'G3DSA:1.20.1250.20:FF:000466', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45755, NULL, 'G3DSA:3.20.20.80:FF:000391', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(45756, NULL, 'G3DSA:1.20.1070.10:FF:001096', NULL, NULL, 'Alpha-1A adrenergic receptor', NULL, NULL, NULL, NULL, NULL, 4),
(45757, NULL, 'G3DSA:3.40.1360.10:FF:000066', NULL, NULL, 'ADR025Wp', NULL, NULL, NULL, NULL, NULL, 4),
(45758, NULL, 'G3DSA:2.60.40.150:FF:000780', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45759, NULL, 'G3DSA:2.130.10.10:FF:000900', NULL, NULL, 'Periodic tryptophan protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(45760, NULL, 'G3DSA:3.30.930.10:FF:000152', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(45761, NULL, 'G3DSA:3.40.50.150:FF:001856', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45762, NULL, 'G3DSA:3.40.50.1820:FF:001081', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(45763, NULL, 'G3DSA:3.20.20.70:FF:000854', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45764, NULL, 'G3DSA:1.20.58.70:FF:000024', NULL, NULL, 'Syntaxin, Qa-SNARE family', NULL, NULL, NULL, NULL, NULL, 4),
(45765, NULL, 'G3DSA:2.60.40.10:FF:000304', NULL, NULL, 'Nectin cell adhesion molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(45766, NULL, 'G3DSA:2.130.10.10:FF:004234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45767, NULL, 'G3DSA:2.40.33.10:FF:000002', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(45768, NULL, 'G3DSA:4.10.1000.10:FF:000113', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45769, NULL, 'G3DSA:1.25.40.10:FF:003457', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g20090', NULL, NULL, NULL, NULL, NULL, 4),
(45770, NULL, 'G3DSA:1.20.1070.10:FF:000084', NULL, NULL, 'Probable G-protein coupled receptor 22', NULL, NULL, NULL, NULL, NULL, 4),
(45771, NULL, 'G3DSA:1.10.510.10:FF:003797', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45772, NULL, 'G3DSA:2.60.40.1660:FF:000022', NULL, NULL, 'ATPase Na+/K+-transporting subunit beta 2a', NULL, NULL, NULL, NULL, NULL, 4),
(45773, NULL, 'G3DSA:2.40.10.10:FF:000702', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45774, NULL, 'G3DSA:2.10.25.10:FF:000665', NULL, NULL, 'Merozoite surface protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(45775, NULL, 'G3DSA:3.40.50.300:FF:000581', NULL, NULL, 'Cystic fibrosis transmembrane conductance regulator', NULL, NULL, NULL, NULL, NULL, 4),
(45776, NULL, 'G3DSA:3.40.630.10:FF:000133', NULL, NULL, 'VPS70p protein', NULL, NULL, NULL, NULL, NULL, 4),
(45777, NULL, 'G3DSA:3.80.10.10:FF:000867', NULL, NULL, 'Blast:Protein halfway', NULL, NULL, NULL, NULL, NULL, 4),
(45778, NULL, 'G3DSA:1.10.287.1770:FF:000001', NULL, NULL, 'Ferrous iron transport protein B', NULL, NULL, NULL, NULL, NULL, 4),
(45779, NULL, 'G3DSA:1.10.555.10:FF:000236', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45780, NULL, 'G3DSA:3.30.40.10:FF:000388', NULL, NULL, 'Putative RING zinc finger domain superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(45781, NULL, 'G3DSA:1.10.506.10:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45782, NULL, 'G3DSA:2.10.50.10:FF:000066', NULL, NULL, 'Cysteine repeat modular protein 3', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(45783, NULL, 'G3DSA:3.20.20.100:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45784, NULL, 'G3DSA:2.60.40.10:FF:001653', NULL, NULL, 'Tyrosine-protein kinase receptor TYRO3', NULL, NULL, NULL, NULL, NULL, 4),
(45785, NULL, 'G3DSA:1.10.630.10:FF:000467', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(45786, NULL, 'G3DSA:3.30.710.10:FF:000512', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45787, NULL, 'G3DSA:3.40.50.880:FF:000035', NULL, NULL, 'ES1 protein homolog, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(45788, NULL, 'G3DSA:3.90.70.10:FF:000382', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45789, NULL, 'G3DSA:3.40.50.300:FF:001070', NULL, NULL, 'Translocase of chloroplast', NULL, NULL, NULL, NULL, NULL, 4),
(45790, NULL, 'G3DSA:1.25.40.20:FF:000121', NULL, NULL, 'SMC5-SMC6 complex localization factor protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(45791, NULL, 'G3DSA:1.20.1250.20:FF:001820', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45792, NULL, 'G3DSA:3.80.10.10:FF:000928', NULL, NULL, 'Peroxidasin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(45793, NULL, 'G3DSA:3.80.10.10:FF:000131', NULL, NULL, 'acidic leucine-rich nuclear phosphoprotein 32-related protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(45794, NULL, 'G3DSA:3.40.50.720:FF:000745', NULL, NULL, 'Ktr system potassium uptake protein A', NULL, NULL, NULL, NULL, NULL, 4),
(45795, NULL, 'G3DSA:1.10.10.200:FF:000006', NULL, NULL, 'Putative transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(45796, NULL, 'G3DSA:1.20.960.30:FF:000001', NULL, NULL, 'F-box-like/WD repeat-containing protein TBL1XR1', NULL, NULL, NULL, NULL, NULL, 4),
(45797, NULL, 'G3DSA:3.30.70.940:FF:000008', NULL, NULL, 'Transcription termination/antitermination protein NusG', NULL, NULL, NULL, NULL, NULL, 4),
(45798, NULL, 'G3DSA:3.30.200.20:FF:000976', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(45799, NULL, 'G3DSA:3.40.50.300:FF:001867', NULL, NULL, 'Dynein heavy chain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(45800, NULL, 'G3DSA:3.30.1330.30:FF:000078', NULL, NULL, 'Ribose methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(45801, NULL, 'G3DSA:1.20.1110.10:FF:000200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45802, NULL, 'G3DSA:3.40.50.300:FF:002267', NULL, NULL, 'ATP-dependent RNA helicase prh1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(45803, NULL, 'G3DSA:3.10.280.10:FF:000011', NULL, NULL, 'Uncharacterized protein AT4g32610', NULL, NULL, NULL, NULL, NULL, 4),
(45804, NULL, 'G3DSA:2.30.39.10:FF:000033', NULL, NULL, 'LP08647p', NULL, NULL, NULL, NULL, NULL, 4),
(45805, NULL, 'G3DSA:3.40.50.12430:FF:000002', NULL, NULL, 'FoLliCuliN', NULL, NULL, NULL, NULL, NULL, 4),
(45806, NULL, 'G3DSA:3.10.660.10:FF:000001', NULL, NULL, 'Diphthamide biosynthesis 3', NULL, NULL, NULL, NULL, NULL, 4),
(45807, NULL, 'G3DSA:1.25.10.10:FF:001319', NULL, NULL, 'HEAT repeat family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(45808, NULL, 'G3DSA:1.20.1070.10:FF:000191', NULL, NULL, 'Probable G-protein coupled receptor 83', NULL, NULL, NULL, NULL, NULL, 4),
(45809, NULL, 'G3DSA:1.10.8.270:FF:000057', NULL, NULL, 'Rab GTPase activator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(45810, NULL, 'G3DSA:3.30.230.90:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45811, NULL, 'G3DSA:1.10.472.10:FF:000594', NULL, NULL, 'Cyclin A1', NULL, NULL, NULL, NULL, NULL, 4),
(45812, NULL, 'G3DSA:3.60.20.10:FF:000183', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45813, NULL, 'G3DSA:4.10.60.10:FF:000051', NULL, NULL, 'Zinc finger protein containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(45814, NULL, 'G3DSA:2.120.10.30:FF:000143', NULL, NULL, 'Protein roller-3', NULL, NULL, NULL, NULL, NULL, 4),
(45815, NULL, 'G3DSA:2.60.40.60:FF:000297', NULL, NULL, 'Cadherin 12', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(45816, NULL, 'G3DSA:3.30.160.60:FF:002553', NULL, NULL, 'Zinc finger protein 343', NULL, NULL, NULL, NULL, NULL, 4),
(45817, NULL, 'G3DSA:2.60.40.60:FF:000353', NULL, NULL, 'Dachsous, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(45818, NULL, 'G3DSA:1.20.1560.10:FF:000784', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45819, NULL, 'G3DSA:3.80.10.10:FF:000187', NULL, NULL, 'F-box and leucine rich repeat protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(45820, NULL, 'G3DSA:3.40.1190.20:FF:000027', NULL, NULL, 'Hydroxyethylthiazole kinase', NULL, NULL, NULL, NULL, NULL, 4),
(45821, NULL, 'G3DSA:1.50.40.10:FF:000066', NULL, NULL, 'Mitochondrial ornithine transporter 2', NULL, NULL, NULL, NULL, NULL, 4),
(45822, NULL, 'G3DSA:1.10.220.150:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45823, NULL, 'G3DSA:3.40.30.10:FF:000477', NULL, NULL, 'Eps1p', NULL, NULL, NULL, NULL, NULL, 4),
(45824, NULL, 'G3DSA:1.10.506.10:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45825, NULL, 'G3DSA:1.20.58.70:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45826, NULL, 'G3DSA:3.10.450.350:FF:000017', NULL, NULL, 'Peptidoglycan-specific endopeptidase, M23 family', NULL, NULL, NULL, NULL, NULL, 4),
(45827, NULL, 'G3DSA:3.30.70.850:FF:000021', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45828, NULL, 'G3DSA:3.40.50.300:FF:002374', NULL, NULL, 'E3 ubiquitin-protein ligase arc-1', NULL, NULL, NULL, NULL, NULL, 4),
(45829, NULL, 'G3DSA:3.40.50.300:FF:004796', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(45830, NULL, 'G3DSA:2.60.40.10:FF:006032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45831, NULL, 'G3DSA:3.40.190.10:FF:000093', NULL, NULL, 'HTH-type transcriptional regulator YidZ', NULL, NULL, NULL, NULL, NULL, 4),
(45832, NULL, 'G3DSA:1.20.58.120:FF:000010', NULL, NULL, 'BAG family molecular chaperone regulator 6', NULL, NULL, NULL, NULL, NULL, 4),
(45833, NULL, 'G3DSA:2.10.25.10:FF:001098', NULL, NULL, 'Epidermal growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(45834, NULL, 'G3DSA:3.30.460.50:FF:000004', NULL, NULL, 'Poly(A) polymerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(45835, NULL, 'G3DSA:1.25.40.10:FF:004002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45836, NULL, 'G3DSA:1.20.58.1000:FF:000002', NULL, NULL, 'Transcriptional repressor FrmR', NULL, NULL, NULL, NULL, NULL, 4),
(45837, NULL, 'G3DSA:1.10.472.10:FF:000650', NULL, NULL, 'Retinoblastoma-like 1 (p107)', NULL, NULL, NULL, NULL, NULL, 4),
(45838, NULL, 'G3DSA:3.90.280.10:FF:000015', NULL, NULL, 'PEBP-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(45839, NULL, 'G3DSA:1.10.490.10:FF:000023', NULL, NULL, 'GLoBin related', NULL, NULL, NULL, NULL, NULL, 4),
(45840, NULL, 'G3DSA:3.30.420.40:FF:000173', NULL, NULL, 'Xylulose kinase', NULL, NULL, NULL, NULL, NULL, 4),
(45841, NULL, 'G3DSA:2.10.25.10:FF:001154', NULL, NULL, 'Laminin subunit alpha 5', NULL, NULL, NULL, NULL, NULL, 4),
(45842, NULL, 'G3DSA:1.10.238.10:FF:000382', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45843, NULL, 'G3DSA:3.30.40.10:FF:002361', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(45844, NULL, 'G3DSA:3.90.1100.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45845, NULL, 'G3DSA:3.30.160.60:FF:004975', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45846, NULL, 'G3DSA:3.40.50.970:FF:000062', NULL, NULL, 'Acetolactate synthase, catabolic', NULL, NULL, NULL, NULL, NULL, 4),
(45847, NULL, 'G3DSA:3.50.50.60:FF:001043', NULL, NULL, 'Protoporphyrinogen IX oxidase2', NULL, NULL, NULL, NULL, NULL, 4),
(45848, NULL, 'G3DSA:3.90.70.10:FF:000786', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45849, NULL, 'G3DSA:3.30.160.60:FF:001209', NULL, NULL, 'Zinc finger and BTB domain-containing protein 38', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(45850, NULL, 'G3DSA:1.10.10.410:FF:000007', NULL, NULL, 'Aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(45851, NULL, 'G3DSA:3.40.50.300:FF:004852', NULL, NULL, 'Putative ribosome-releasing factor 2 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(45852, NULL, 'G3DSA:1.10.132.60:FF:000038', NULL, NULL, 'DNA polymerase B region', NULL, NULL, NULL, NULL, NULL, 4),
(45853, NULL, 'G3DSA:1.25.40.10:FF:001192', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(45854, NULL, 'G3DSA:3.40.50.10330:FF:000075', NULL, NULL, 'ATP-NADH kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(45855, NULL, 'G3DSA:3.40.50.720:FF:002325', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45856, NULL, 'G3DSA:3.10.110.10:FF:000246', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45857, NULL, 'G3DSA:3.90.190.10:FF:000076', NULL, NULL, 'Paladin isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(45858, NULL, 'G3DSA:2.130.10.10:FF:002317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45859, NULL, 'G3DSA:1.10.8.50:FF:000020', NULL, NULL, 'Fibronectin-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(45860, NULL, 'G3DSA:3.30.420.40:FF:000280', NULL, NULL, 'Actin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(45861, NULL, 'G3DSA:3.40.50.300:FF:006589', NULL, NULL, 'Torsin family 2, member A', NULL, NULL, NULL, NULL, NULL, 4),
(45862, NULL, 'G3DSA:3.20.20.80:FF:000239', NULL, NULL, 'Pullulanase 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(45863, NULL, 'G3DSA:1.20.920.60:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45864, NULL, 'G3DSA:1.20.1540.10:FF:000064', NULL, NULL, 'Rhomboid protease AarA', NULL, NULL, NULL, NULL, NULL, 4),
(45865, NULL, 'G3DSA:3.30.450.190:FF:000004', NULL, NULL, 'Small monomeric GTPase (Gtr2)', NULL, NULL, NULL, NULL, NULL, 4),
(45866, NULL, 'G3DSA:3.40.30.10:FF:000426', NULL, NULL, 'Putative Disulfide-isomerase A4', NULL, NULL, NULL, NULL, NULL, 4),
(45867, NULL, 'G3DSA:1.10.510.10:FF:001829', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45868, NULL, 'G3DSA:1.20.1070.10:FF:001101', NULL, NULL, 'G protein-coupled receptor 78a', NULL, NULL, NULL, NULL, NULL, 4),
(45869, NULL, 'G3DSA:1.20.1420.10:FF:000010', NULL, NULL, 'Rhea, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(45870, NULL, 'G3DSA:2.30.180.10:FF:000188', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45871, NULL, 'G3DSA:1.10.8.270:FF:000006', NULL, NULL, 'Small G protein signaling modulator 2', NULL, NULL, NULL, NULL, NULL, 4),
(45872, NULL, 'G3DSA:2.60.60.20:FF:000016', NULL, NULL, 'Polycystin family receptor for egg jelly', NULL, NULL, NULL, NULL, NULL, 4),
(45873, NULL, 'G3DSA:3.80.10.10:FF:000923', NULL, NULL, 'Flyers-cup, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(45874, NULL, 'G3DSA:1.10.10.2150:FF:000001', NULL, NULL, 'Ribosomal RNA-processing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(45875, NULL, 'G3DSA:3.30.1150.10:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45876, NULL, 'G3DSA:1.20.120.530:FF:000014', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(45877, NULL, 'G3DSA:1.10.510.10:FF:003393', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45878, NULL, 'G3DSA:2.10.25.10:FF:001103', NULL, NULL, 'Transmembrane cell adhesion receptor mua-3', NULL, NULL, NULL, NULL, NULL, 4),
(45879, NULL, 'G3DSA:1.10.12.10:FF:000053', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(45880, NULL, 'G3DSA:2.60.40.10:FF:000248', NULL, NULL, 'peroxidasin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(45881, NULL, 'G3DSA:1.20.1070.10:FF:000140', NULL, NULL, 'Mas-related G-protein coupled receptor member X2', NULL, NULL, NULL, NULL, NULL, 4),
(45882, NULL, 'G3DSA:3.40.50.1820:FF:000861', NULL, NULL, 'Palmitoyl-protein thioesterase 1 (ceroid-lipofuscinosis, neuronal 1, infantile)', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(45883, NULL, 'G3DSA:3.30.110.90:FF:000001', NULL, NULL, 'Imidazolonepropionase-like amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(45884, NULL, 'G3DSA:3.20.20.190:FF:000034', NULL, NULL, 'Glycerophosphodiester phosphodiesterase GDPD2', NULL, NULL, NULL, NULL, NULL, 4),
(45885, NULL, 'G3DSA:3.90.190.10:FF:000183', NULL, NULL, 'Tyrosine-protein phosphatase 4', NULL, NULL, NULL, NULL, NULL, 4),
(45886, NULL, 'G3DSA:1.25.40.70:FF:000069', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(45887, NULL, 'G3DSA:3.40.30.10:FF:000078', NULL, NULL, '39S ribosomal protein L43, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(45888, NULL, 'G3DSA:3.40.50.10860:FF:000003', NULL, NULL, 'Glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(45889, NULL, 'G3DSA:1.10.246.120:FF:000002', NULL, NULL, 'rab5 GDP/GTP exchange factor isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(45890, NULL, 'G3DSA:3.40.50.300:FF:007606', NULL, NULL, 'ATP-dependent helicase (DinG family)', NULL, NULL, NULL, NULL, NULL, 4),
(45891, NULL, 'G3DSA:3.40.50.300:FF:002031', NULL, NULL, 'RNA cytidine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(45892, NULL, 'G3DSA:2.10.110.10:FF:000340', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45893, NULL, 'G3DSA:1.20.1070.10:FF:001152', NULL, NULL, 'C-X-C chemokine receptor type 1', NULL, NULL, NULL, NULL, NULL, 4),
(45894, NULL, 'G3DSA:2.70.150.10:FF:000054', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(45895, NULL, 'G3DSA:1.25.10.10:FF:001364', NULL, NULL, 'WGS project CABT00000000 data, contig 2.52', NULL, NULL, NULL, NULL, NULL, 4),
(45896, NULL, 'G3DSA:1.10.510.10:FF:001088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45897, NULL, 'G3DSA:1.10.10.820:FF:000012', NULL, NULL, 'Chitin synthase ChsE', NULL, NULL, NULL, NULL, NULL, 4),
(45898, NULL, 'G3DSA:1.50.40.10:FF:000515', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45899, NULL, 'G3DSA:3.40.50.12390:FF:000001', NULL, NULL, '5''-3'' exoribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(45900, NULL, 'G3DSA:3.10.260.10:FF:000009', NULL, NULL, 'Enhanced filamentous growth protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(45901, NULL, 'G3DSA:1.20.1070.10:FF:001500', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45902, NULL, 'G3DSA:3.30.70.330:FF:001731', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45903, NULL, 'G3DSA:2.60.120.200:FF:000815', NULL, NULL, 'Calreticulin-2', NULL, NULL, NULL, NULL, NULL, 4),
(45904, NULL, 'G3DSA:3.40.250.10:FF:000148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45905, NULL, 'G3DSA:1.20.58.1020:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45906, NULL, 'G3DSA:1.10.579.10:FF:000004', NULL, NULL, 'Cryptochrome-1', NULL, NULL, NULL, NULL, NULL, 4),
(45907, NULL, 'G3DSA:3.60.15.10:FF:000053', NULL, NULL, 'protein artemis isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(45908, NULL, 'G3DSA:2.60.40.10:FF:003469', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45909, NULL, 'G3DSA:3.40.50.720:FF:002269', NULL, NULL, 'Phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(45910, NULL, 'G3DSA:1.10.10.670:FF:000001', NULL, NULL, 'Photosystem II CP43 reaction center protein', NULL, NULL, NULL, NULL, NULL, 4),
(45911, NULL, 'G3DSA:3.10.450.220:FF:000001', NULL, NULL, '60S ribosome subunit biogenesis protein NIP7 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(45912, NULL, 'G3DSA:3.40.50.10190:FF:000167', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45913, NULL, 'G3DSA:1.25.10.10:FF:001943', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45914, NULL, 'G3DSA:1.25.40.20:FF:001537', NULL, NULL, 'Espin like', NULL, NULL, NULL, NULL, NULL, 4),
(45915, NULL, 'G3DSA:3.40.50.300:FF:006302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45916, NULL, 'G3DSA:1.20.58.760:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(45917, NULL, 'G3DSA:1.10.10.10:FF:001740', NULL, NULL, 'ATP-dependent DNA helicase, RecQ family', NULL, NULL, NULL, NULL, NULL, 4),
(45918, NULL, 'G3DSA:3.30.470.10:FF:000009', NULL, NULL, 'D-alanine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(45919, NULL, 'G3DSA:3.30.870.10:FF:000052', NULL, NULL, 'Polyphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(45920, NULL, 'G3DSA:3.10.250.10:FF:000127', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45921, NULL, 'G3DSA:1.25.40.10:FF:002496', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45922, NULL, 'G3DSA:3.10.490.20:FF:000007', NULL, NULL, 'Dynein cytoplasmic 2 heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(45923, NULL, 'G3DSA:2.40.170.20:FF:000082', NULL, NULL, 'Transporter, outer membrane receptor (OMR) family', NULL, NULL, NULL, NULL, NULL, 4),
(45924, NULL, 'G3DSA:3.10.110.10:FF:000297', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 6, putative', NULL, NULL, NULL, NULL, NULL, 4),
(45925, NULL, 'G3DSA:1.20.1070.10:FF:000876', NULL, NULL, 'Adhesion G protein-coupled receptor L4', NULL, NULL, NULL, NULL, NULL, 4),
(45926, NULL, 'G3DSA:1.10.287.2620:FF:000003', NULL, NULL, 'Dynein, axonemal, heavy chain 5', NULL, NULL, NULL, NULL, NULL, 4),
(45927, NULL, 'G3DSA:3.30.200.20:FF:001488', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45928, NULL, 'G3DSA:3.30.1380.20:FF:000016', NULL, NULL, 'Transport protein particle (TRAPP) subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(45929, NULL, 'G3DSA:3.40.50.150:FF:000895', NULL, NULL, 'Cyclopropane fatty acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(45930, NULL, 'G3DSA:2.130.10.10:FF:001356', NULL, NULL, 'Excision repair cross-complementation group 8', NULL, NULL, NULL, NULL, NULL, 4),
(45931, NULL, 'G3DSA:3.30.420.40:FF:000128', NULL, NULL, 'actin-related protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(45932, NULL, 'G3DSA:2.130.10.10:FF:003778', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(45933, NULL, 'G3DSA:3.80.10.10:FF:002660', NULL, NULL, 'Leucine-rich receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(45934, NULL, 'G3DSA:2.60.40.10:FF:004582', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45935, NULL, 'G3DSA:3.50.50.60:FF:001442', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45936, NULL, 'G3DSA:3.30.40.10:FF:001405', NULL, NULL, 'TNF Receptor Associated Factor (TRAF) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(45937, NULL, 'G3DSA:1.25.40.10:FF:002552', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45938, NULL, 'G3DSA:2.130.10.10:FF:006027', NULL, NULL, 'Probable elongator complex protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(45939, NULL, 'G3DSA:2.60.200.20:FF:000142', NULL, NULL, 'AGAP005926-PA', NULL, NULL, NULL, NULL, NULL, 4),
(45940, NULL, 'G3DSA:3.40.50.10610:FF:000001', NULL, NULL, 'Curli production assembly/transport component CsgG', NULL, NULL, NULL, NULL, NULL, 4),
(45941, NULL, 'G3DSA:3.30.420.40:FF:000965', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45942, NULL, 'G3DSA:2.40.37.20:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45943, NULL, 'G3DSA:3.30.300.20:FF:000068', NULL, NULL, 'GTPase Era, mitochondrial-like', NULL, NULL, NULL, NULL, NULL, 4),
(45944, NULL, 'G3DSA:1.10.1420.10:FF:000136', NULL, NULL, 'Endonuclease MutS2', NULL, NULL, NULL, NULL, NULL, 4),
(45945, NULL, 'G3DSA:4.10.320.60:FF:000003', NULL, NULL, 'Mitochondrial FAD-linked sulfhydryl oxidase erv1', NULL, NULL, NULL, NULL, NULL, 4),
(45946, NULL, 'G3DSA:3.40.50.2300:FF:001415', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45947, NULL, 'G3DSA:1.20.900.10:FF:000065', NULL, NULL, 'T-cell activation Rho GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(45948, NULL, 'G3DSA:3.40.50.720:FF:001313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45949, NULL, 'G3DSA:3.30.420.10:FF:000529', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(45950, NULL, 'G3DSA:3.10.100.10:FF:000420', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45951, NULL, 'G3DSA:3.40.50.1000:FF:000727', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45952, NULL, 'G3DSA:3.80.10.10:FF:002784', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45953, NULL, 'G3DSA:3.30.710.10:FF:000220', NULL, NULL, 'BTB/POZ and TAZ domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(45954, NULL, 'G3DSA:2.130.10.10:FF:005627', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45955, NULL, 'G3DSA:3.40.50.740:FF:000010', NULL, NULL, 'Thiosulfate reductase PhsA', NULL, NULL, NULL, NULL, NULL, 4),
(45956, NULL, 'G3DSA:3.90.290.10:FF:000016', NULL, NULL, 'latent-transforming growth factor beta-binding protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(45957, NULL, 'G3DSA:1.10.510.10:FF:003792', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45958, NULL, 'G3DSA:3.30.70.890:FF:000010', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(45959, NULL, 'G3DSA:1.20.1070.10:FF:000932', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45960, NULL, 'G3DSA:2.130.10.10:FF:001305', NULL, NULL, 'Unplaced genomic scaffold supercont2.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(45961, NULL, 'G3DSA:2.30.130.40:FF:000008', NULL, NULL, 'Lon protease homolog 2, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(45962, NULL, 'G3DSA:1.25.40.690:FF:000014', NULL, NULL, 'Nuclear pore complex protein Nup98-Nup96', NULL, NULL, NULL, NULL, NULL, 4),
(45963, NULL, 'G3DSA:1.10.630.10:FF:000523', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45964, NULL, 'G3DSA:2.30.29.30:FF:001382', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45965, NULL, 'G3DSA:1.50.40.10:FF:000459', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45966, NULL, 'G3DSA:1.25.10.10:FF:001887', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45967, NULL, 'G3DSA:3.40.50.1460:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45968, NULL, 'G3DSA:1.20.120.1080:FF:000141', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(45969, NULL, 'G3DSA:3.10.450.240:FF:000007', NULL, NULL, '39S ribosomal protein L45, mitochondrial isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(45970, NULL, 'G3DSA:2.170.270.10:FF:000117', NULL, NULL, 'PR domain zinc finger protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(45971, NULL, 'G3DSA:2.10.25.10:FF:001047', NULL, NULL, 'GM21210', NULL, NULL, NULL, NULL, NULL, 4),
(45972, NULL, 'G3DSA:3.90.460.10:FF:000001', NULL, NULL, 'Ferredoxin-thioredoxin reductase, catalytic chain', NULL, NULL, NULL, NULL, NULL, 4),
(45973, NULL, 'G3DSA:3.40.50.300:FF:002323', NULL, NULL, 'ADP-ribosylation factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(45974, NULL, 'G3DSA:1.10.10.60:FF:001289', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45975, NULL, 'G3DSA:3.30.200.20:FF:001544', NULL, NULL, 'Probable protein kinase DDB_G0291133', NULL, NULL, NULL, NULL, NULL, 4),
(45976, NULL, 'G3DSA:2.20.100.10:FF:000174', NULL, NULL, 'GD10852', NULL, NULL, NULL, NULL, NULL, 4),
(45977, NULL, 'G3DSA:1.20.1090.10:FF:000023', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(45978, NULL, 'G3DSA:3.30.70.330:FF:001675', NULL, NULL, 'Ribonucleoprotein, putative (AFU_orthologue AFUA_7G05810)', NULL, NULL, NULL, NULL, NULL, 4),
(45979, NULL, 'G3DSA:3.40.50.800:FF:000106', NULL, NULL, 'Histidine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(45980, NULL, 'G3DSA:3.90.980.20:FF:000021', NULL, NULL, 'GD21826', NULL, NULL, NULL, NULL, NULL, 4),
(45981, NULL, 'G3DSA:3.20.20.140:FF:000391', NULL, NULL, 'Uncharacterized protein MJ1587', NULL, NULL, NULL, NULL, NULL, 4),
(45982, NULL, 'G3DSA:3.40.50.300:FF:001923', NULL, NULL, 'DEAD/DEAH box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(45983, NULL, 'G3DSA:2.60.40.10:FF:002721', NULL, NULL, 'Anosmin 1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(45984, NULL, 'G3DSA:3.40.50.300:FF:006246', NULL, NULL, 'DNA excision repair protein ERCC-6-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(45985, NULL, 'G3DSA:2.60.120.10:FF:000256', NULL, NULL, 'Cyclic nucleotide-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(45986, NULL, 'G3DSA:3.40.50.300:FF:005285', NULL, NULL, 'Ras family protein', NULL, NULL, NULL, NULL, NULL, 4),
(45987, NULL, 'G3DSA:3.10.105.10:FF:000116', NULL, NULL, 'Putative solute-binding lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(45988, NULL, 'G3DSA:3.50.30.30:FF:000156', NULL, NULL, 'Peptide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(45989, NULL, 'G3DSA:3.30.160.60:FF:006032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(45990, NULL, 'G3DSA:2.30.30.380:FF:000027', NULL, NULL, 'Sfb3p', NULL, NULL, NULL, NULL, NULL, 4),
(45991, NULL, 'G3DSA:3.30.505.10:FF:000035', NULL, NULL, 'phosphatidylinositol 3,4,5-trisphosphate 5-phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(45992, NULL, 'G3DSA:2.130.10.10:FF:005228', NULL, NULL, 'WD repeat-containing protein 91 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(45993, NULL, 'G3DSA:3.20.20.70:FF:000562', NULL, NULL, 'Isopentenyl-diphosphate delta-isomerase (Type II)', NULL, NULL, NULL, NULL, NULL, 4),
(45994, NULL, 'G3DSA:3.40.50.300:FF:002935', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(45995, NULL, 'G3DSA:1.25.40.10:FF:003513', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(45996, NULL, 'G3DSA:2.130.10.10:FF:001980', NULL, NULL, 'WD-repeat membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(45997, NULL, 'G3DSA:3.30.870.10:FF:000001', NULL, NULL, 'Polyphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(45998, NULL, 'G3DSA:4.10.1000.10:FF:000057', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(45999, NULL, 'G3DSA:1.10.10.60:FF:000889', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46000, NULL, 'G3DSA:3.30.40.10:FF:000444', NULL, NULL, 'Nitric oxide synthase-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(46001, NULL, 'G3DSA:1.10.30.10:FF:000050', NULL, NULL, 'Nuclear autoantigen Sp-100', NULL, NULL, NULL, NULL, NULL, 4),
(46002, NULL, 'G3DSA:1.20.870.10:FF:000016', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(46003, NULL, 'G3DSA:3.40.830.10:FF:000007', NULL, NULL, 'Extradiol ring-cleavage dioxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46004, NULL, 'G3DSA:3.30.160.20:FF:000028', NULL, NULL, 'ATP-dependent RNA helicase A', NULL, NULL, NULL, NULL, NULL, 4),
(46005, NULL, 'G3DSA:3.40.50.1460:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46006, NULL, 'G3DSA:1.20.120.1910:FF:000053', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(46007, NULL, 'G3DSA:1.20.900.10:FF:000014', NULL, NULL, 'active breakpoint cluster region-related protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(46008, NULL, 'G3DSA:2.30.29.30:FF:001331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46009, NULL, 'G3DSA:3.40.30.10:FF:000134', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(46010, NULL, 'G3DSA:3.10.180.10:FF:000071', NULL, NULL, 'Lactoylglutathione lyase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(46011, NULL, 'G3DSA:2.60.40.10:FF:005942', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46012, NULL, 'G3DSA:2.30.26.10:FF:000003', NULL, NULL, 'Dihydroorotate dehydrogenase (fumarate)', NULL, NULL, NULL, NULL, NULL, 4),
(46013, NULL, 'G3DSA:4.10.410.20:FF:000009', NULL, NULL, 'Proteoglycan 4', NULL, NULL, NULL, NULL, NULL, 4),
(46014, NULL, 'G3DSA:1.20.920.30:FF:000055', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(46015, NULL, 'G3DSA:3.40.910.10:FF:000008', NULL, NULL, 'Deoxyhypusine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(46016, NULL, 'G3DSA:1.20.1280.50:FF:000055', NULL, NULL, 'F-box/SPRY domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(46017, NULL, 'G3DSA:3.50.50.60:FF:001094', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(46018, NULL, 'G3DSA:2.130.10.10:FF:005690', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46019, NULL, 'G3DSA:3.40.50.150:FF:000552', NULL, NULL, 'Probable RNA methyltransferase CG11342', NULL, NULL, NULL, NULL, NULL, 4),
(46020, NULL, 'G3DSA:3.90.190.10:FF:000132', NULL, NULL, 'Dual specificity protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46021, NULL, 'G3DSA:2.60.40.10:FF:001760', NULL, NULL, 'Murinoglobulin-1', NULL, NULL, NULL, NULL, NULL, 4),
(46022, NULL, 'G3DSA:2.60.40.10:FF:005594', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46023, NULL, 'G3DSA:1.10.510.10:FF:001268', NULL, NULL, 'Protein lipid droplet kinase (LDK)', NULL, NULL, NULL, NULL, NULL, 4),
(46024, NULL, 'G3DSA:3.10.290.50:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46025, NULL, 'G3DSA:6.10.140.2220:FF:000034', NULL, NULL, 'Putative MYND finger domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(46026, NULL, 'G3DSA:3.80.10.10:FF:003060', NULL, NULL, 'Protein CBG16793', NULL, NULL, NULL, NULL, NULL, 4),
(46027, NULL, 'G3DSA:3.30.70.1230:FF:000187', NULL, NULL, 'Adenylate/guanylate cyclase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(46028, NULL, 'G3DSA:3.40.1110.10:FF:000374', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46029, NULL, 'G3DSA:2.60.40.10:FF:002160', NULL, NULL, 'Paired immunoglobulin-like receptor B', NULL, NULL, NULL, NULL, NULL, 4),
(46030, NULL, 'G3DSA:3.40.50.200:FF:000202', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 4', NULL, NULL, NULL, NULL, NULL, 4),
(46031, NULL, 'G3DSA:3.40.47.10:FF:000285', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46032, NULL, 'G3DSA:3.30.1360.70:FF:000007', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(46033, NULL, 'G3DSA:3.30.200.20:FF:002556', NULL, NULL, 'Putative serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(46034, NULL, 'G3DSA:1.10.510.10:FF:000812', NULL, NULL, 'CMGC/DYRK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(46035, NULL, 'G3DSA:3.40.718.10:FF:000016', NULL, NULL, 'Isocitrate dehydrogenase [NADP]', NULL, NULL, NULL, NULL, NULL, 4),
(46036, NULL, 'G3DSA:3.30.1330.30:FF:000022', NULL, NULL, '60S ribosomal protein L7a', NULL, NULL, NULL, NULL, NULL, 4),
(46037, NULL, 'G3DSA:2.60.40.60:FF:000185', NULL, NULL, 'Protocadherin 2 alpha c', NULL, NULL, NULL, NULL, NULL, 4),
(46038, NULL, 'G3DSA:2.40.30.10:FF:000316', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(46039, NULL, 'G3DSA:2.40.50.140:FF:000997', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46040, NULL, 'G3DSA:3.40.120.10:FF:000032', NULL, NULL, 'Udp-glucose-pyrophosphorylase phosphoglucomutase', NULL, NULL, NULL, NULL, NULL, 4),
(46041, NULL, 'G3DSA:2.60.40.1910:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46042, NULL, 'G3DSA:2.30.30.490:FF:000004', NULL, NULL, 'DNA (cytosine-5)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(46043, NULL, 'G3DSA:3.60.9.10:FF:000001', NULL, NULL, 'Aldehyde:ferredoxin oxidoreductase, tungsten-containing', NULL, NULL, NULL, NULL, NULL, 4),
(46044, NULL, 'G3DSA:1.10.10.60:FF:001002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46045, NULL, 'G3DSA:1.20.1070.10:FF:000645', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46046, NULL, 'G3DSA:2.60.40.420:FF:000260', NULL, NULL, 'Cupredoxin superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(46047, NULL, 'G3DSA:3.30.70.330:FF:000663', NULL, NULL, 'CUGBP Elav-like family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(46048, NULL, 'G3DSA:2.80.10.50:FF:000185', NULL, NULL, 'Inositol 1,4,5-trisphosphate receptor type 3', NULL, NULL, NULL, NULL, NULL, 4),
(46049, NULL, 'G3DSA:1.10.10.60:FF:000384', NULL, NULL, 'Transcriptional regulatory protein TOD6', NULL, NULL, NULL, NULL, NULL, 4),
(46050, NULL, 'G3DSA:2.80.10.50:FF:000241', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(46051, NULL, 'G3DSA:3.30.300.250:FF:000001', NULL, NULL, 'Lipoprotein YghG', NULL, NULL, NULL, NULL, NULL, 4),
(46052, NULL, 'G3DSA:4.10.800.10:FF:000003', NULL, NULL, 'SPARC-related modular calcium-binding protein 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(46053, NULL, 'G3DSA:1.10.10.10:FF:001471', NULL, NULL, 'Protein CBG05575', NULL, NULL, NULL, NULL, NULL, 4),
(46054, NULL, 'G3DSA:2.40.10.10:FF:000197', NULL, NULL, 'chymotrypsin-1', NULL, NULL, NULL, NULL, NULL, 4),
(46055, NULL, 'G3DSA:1.10.390.10:FF:000038', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(46056, NULL, 'G3DSA:2.30.140.10:FF:000011', NULL, NULL, 'Polyamine aminopropyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(46057, NULL, 'G3DSA:2.40.10.10:FF:000253', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46058, NULL, 'G3DSA:1.25.40.10:FF:003856', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46059, NULL, 'G3DSA:3.30.390.60:FF:000001', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(46060, NULL, 'G3DSA:3.30.70.60:FF:000039', NULL, NULL, '30S ribosomal protein S6, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(46061, NULL, 'G3DSA:3.40.50.10860:FF:000059', NULL, NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(46062, NULL, 'G3DSA:2.60.40.10:FF:004014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46063, NULL, 'G3DSA:1.10.10.920:FF:000003', NULL, NULL, 'Coproporphyrinogen-III oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(46064, NULL, 'G3DSA:2.60.40.150:FF:000336', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46065, NULL, 'G3DSA:1.10.533.10:FF:000163', NULL, NULL, 'Putative BOI-related E3 ubiquitin-protein ligase 3', NULL, NULL, NULL, NULL, NULL, 4),
(46066, NULL, 'G3DSA:1.20.1390.10:FF:000012', NULL, NULL, 'RNA-binding motif protein 25a', NULL, NULL, NULL, NULL, NULL, 4),
(46067, NULL, 'G3DSA:2.130.10.10:FF:002429', NULL, NULL, 'Periodic tryptophan protein 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(46068, NULL, 'G3DSA:3.30.60.20:FF:000105', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(46069, NULL, 'G3DSA:3.40.50.2000:FF:000134', NULL, NULL, 'UDP-glucuronosyltransferase 2A2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(46070, NULL, 'G3DSA:3.30.70.330:FF:002804', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46071, NULL, 'G3DSA:2.130.10.10:FF:000288', NULL, NULL, 'RAB6A-GEF complex partner protein 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(46072, NULL, 'G3DSA:2.30.30.100:FF:000045', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm1', NULL, NULL, NULL, NULL, NULL, 4),
(46073, NULL, 'G3DSA:3.10.290.10:FF:000017', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(46074, NULL, 'G3DSA:3.40.950.10:FF:000005', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', NULL, NULL, NULL, NULL, NULL, 4),
(46075, NULL, 'G3DSA:1.25.10.10:FF:002668', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46076, NULL, 'G3DSA:2.60.40.10:FF:005650', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46077, NULL, 'G3DSA:3.30.390.80:FF:000007', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(46078, NULL, 'G3DSA:3.40.50.300:FF:002828', NULL, NULL, 'PEX6p AAA-peroxin', NULL, NULL, NULL, NULL, NULL, 4),
(46079, NULL, 'G3DSA:1.10.287.1080:FF:000002', NULL, NULL, 'Histidine biosynthesis bifunctional protein HisIE', NULL, NULL, NULL, NULL, NULL, 4),
(46080, NULL, 'G3DSA:1.25.40.990:FF:000042', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(46081, NULL, 'G3DSA:2.60.120.40:FF:000035', NULL, NULL, 'Elastin microfibril interfacer 2a', NULL, NULL, NULL, NULL, NULL, 4),
(46082, NULL, 'G3DSA:2.130.10.10:FF:001917', NULL, NULL, 'Transducin (beta)-like 1 X-linked receptor 1a', NULL, NULL, NULL, NULL, NULL, 4),
(46083, NULL, 'G3DSA:1.20.920.10:FF:000009', NULL, NULL, 'Protein polybromo-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(46084, NULL, 'G3DSA:1.10.10.60:FF:000277', NULL, NULL, 'Pre-B-cell leukemia transcription factor 1', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(46085, NULL, 'G3DSA:1.20.5.400:FF:000004', NULL, NULL, 'CD209 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(46086, NULL, 'G3DSA:1.20.58.1210:FF:000003', NULL, NULL, 'Exocyst complex component EXO84', NULL, NULL, NULL, NULL, NULL, 4),
(46087, NULL, 'G3DSA:1.10.3430.10:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46088, NULL, 'G3DSA:3.30.830.10:FF:000167', NULL, NULL, 'Mitochondrial-processing peptidase subunit alpha-1', NULL, NULL, NULL, NULL, NULL, 4),
(46089, NULL, 'G3DSA:1.25.40.20:FF:001768', NULL, NULL, 'Autophagy-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(46090, NULL, 'G3DSA:1.20.1440.260:FF:000001', NULL, NULL, 'Protein HIT1', NULL, NULL, NULL, NULL, NULL, 4),
(46091, NULL, 'G3DSA:3.30.1330.40:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46092, NULL, 'G3DSA:1.10.238.10:FF:000095', NULL, NULL, 'dual oxidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(46093, NULL, 'G3DSA:1.20.990.10:FF:000014', NULL, NULL, 'NADPH-cytochrome p450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(46094, NULL, 'G3DSA:2.60.40.10:FF:005543', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46095, NULL, 'G3DSA:3.40.50.80:FF:000173', NULL, NULL, 'NADPH--cytochrome P450 reductase 2', NULL, NULL, NULL, NULL, NULL, 4),
(46096, NULL, 'G3DSA:3.40.50.720:FF:000296', NULL, NULL, 'peroxisomal bifunctional enzyme isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(46097, NULL, 'G3DSA:1.10.510.10:FF:003561', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46098, NULL, 'G3DSA:3.40.50.2000:FF:000078', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(46099, NULL, 'G3DSA:1.25.10.10:FF:000690', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(46100, NULL, 'G3DSA:3.40.220.10:FF:000028', NULL, NULL, 'Possible lipoprotein lppD', NULL, NULL, NULL, NULL, NULL, 4),
(46101, NULL, 'G3DSA:1.25.40.20:FF:000464', NULL, NULL, 'Ankyrin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(46102, NULL, 'G3DSA:3.60.15.10:FF:000160', NULL, NULL, 'Rhodanese domain protein / beta-lactamase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(46103, NULL, 'G3DSA:1.10.10.10:FF:001139', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(46104, NULL, 'G3DSA:2.60.40.10:FF:002901', NULL, NULL, 'Cilia and flagella associated protein 65', NULL, NULL, NULL, NULL, NULL, 4),
(46105, NULL, 'G3DSA:3.40.50.410:FF:000208', NULL, NULL, 'Voltage-dependent calcium channel subunit alpha-2/delta-1', NULL, NULL, NULL, NULL, NULL, 4),
(46106, NULL, 'G3DSA:3.30.420.240:FF:000002', NULL, NULL, 'Mu phage large terminase subunit GpE', NULL, NULL, NULL, NULL, NULL, 4),
(46107, NULL, 'G3DSA:3.30.565.10:FF:000090', NULL, NULL, 'Heme sensor histidine kinase HssS', NULL, NULL, NULL, NULL, NULL, 4),
(46108, NULL, 'G3DSA:3.40.50.10190:FF:000274', NULL, NULL, 'Putative dna topoisomerase 2-binding protein 1 isoform x1', NULL, NULL, NULL, NULL, NULL, 4),
(46109, NULL, 'G3DSA:3.30.60.30:FF:000221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46110, NULL, 'G3DSA:1.25.40.10:FF:005019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46111, NULL, 'G3DSA:3.40.30.10:FF:000246', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(46112, NULL, 'G3DSA:2.60.120.10:FF:000604', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(46113, NULL, 'G3DSA:3.40.190.10:FF:000598', NULL, NULL, 'Dipeptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(46114, NULL, 'G3DSA:3.20.20.110:FF:000005', NULL, NULL, 'Ribulose bisphosphate carboxylase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(46115, NULL, 'G3DSA:4.10.365.10:FF:000002', NULL, NULL, 'cyclin-dependent kinase inhibitor 1C', NULL, NULL, NULL, NULL, NULL, 4),
(46116, NULL, 'G3DSA:3.40.50.150:FF:001277', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46117, NULL, 'G3DSA:3.90.45.10:FF:000019', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(46118, NULL, 'G3DSA:1.25.10.10:FF:002724', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(46119, NULL, 'G3DSA:1.10.8.10:FF:000267', NULL, NULL, 'HBS1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(46120, NULL, 'G3DSA:1.25.40.10:FF:001708', NULL, NULL, 'Pre-mRNA-processing factor 6-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(46121, NULL, 'G3DSA:3.10.170.20:FF:000011', NULL, NULL, 'Cell surface protease gp63 putative', NULL, NULL, NULL, NULL, NULL, 4),
(46122, NULL, 'G3DSA:2.170.260.10:FF:000004', NULL, NULL, 'Dicer-like 104', NULL, NULL, NULL, NULL, NULL, 4),
(46123, NULL, 'G3DSA:3.30.40.10:FF:000101', NULL, NULL, 'Integrator complex subunit 12', NULL, NULL, NULL, NULL, NULL, 4),
(46124, NULL, 'G3DSA:3.40.50.11210:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46125, NULL, 'G3DSA:1.10.150.240:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46126, NULL, 'G3DSA:2.30.30.40:FF:000617', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46127, NULL, 'G3DSA:3.40.50.1820:FF:001193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46128, NULL, 'G3DSA:3.30.460.20:FF:000012', NULL, NULL, 'Magnesium and cobalt transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(46129, NULL, 'G3DSA:3.50.50.100:FF:000001', NULL, NULL, 'NADH dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(46130, NULL, 'G3DSA:3.30.450.20:FF:000186', NULL, NULL, 'Unplaced genomic scaffold supercont2.18, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(46131, NULL, 'G3DSA:1.10.150.240:FF:000019', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(46132, NULL, 'G3DSA:2.60.220.30:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46133, NULL, 'G3DSA:2.60.40.60:FF:000241', NULL, NULL, 'Cadherin 16', NULL, NULL, NULL, NULL, NULL, 4),
(46134, NULL, 'G3DSA:3.40.50.300:FF:007090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46135, NULL, 'G3DSA:3.10.50.40:FF:000095', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(46136, NULL, 'G3DSA:3.40.720.10:FF:000292', NULL, NULL, 'WASH complex subunit 7-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(46137, NULL, 'G3DSA:2.30.30.100:FF:000101', NULL, NULL, 'AGAP007326-PB', NULL, NULL, NULL, NULL, NULL, 4),
(46138, NULL, 'G3DSA:2.70.160.11:FF:000038', NULL, NULL, 'Arginine N-methyltransferase, type II, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46139, NULL, 'G3DSA:2.20.25.10:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46140, NULL, 'G3DSA:3.30.70.3490:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46141, NULL, 'G3DSA:3.10.100.10:FF:000240', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46142, NULL, 'G3DSA:3.50.50.60:FF:000874', NULL, NULL, 'Monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(46143, NULL, 'G3DSA:4.10.640.10:FF:000001', NULL, NULL, '30S ribosomal protein S18', NULL, NULL, NULL, NULL, NULL, 4),
(46144, NULL, 'G3DSA:3.40.50.12660:FF:000009', NULL, NULL, 'Metacaspase-2', NULL, NULL, NULL, NULL, NULL, 4),
(46145, NULL, 'G3DSA:3.50.50.60:FF:001274', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(46146, NULL, 'G3DSA:2.150.10.10:FF:000006', NULL, NULL, 'RTX-I toxin determinant A from serotypes 5/10', NULL, NULL, NULL, NULL, NULL, 4),
(46147, NULL, 'G3DSA:3.40.50.720:FF:001021', NULL, NULL, 'NAD-dependent dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(46148, NULL, 'G3DSA:1.25.40.10:FF:001984', NULL, NULL, 'Embryo specific2', NULL, NULL, NULL, NULL, NULL, 4),
(46149, NULL, 'G3DSA:2.130.10.10:FF:002761', NULL, NULL, 'General transcription factor IIIC, polypeptide 2, beta', NULL, NULL, NULL, NULL, NULL, 4),
(46150, NULL, 'G3DSA:1.20.1250.20:FF:002091', NULL, NULL, 'RE25916p', NULL, NULL, NULL, NULL, NULL, 4),
(46151, NULL, 'G3DSA:1.25.10.10:FF:001471', NULL, NULL, 'Dynein axonemal assembly factor 5', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(46152, NULL, 'G3DSA:1.20.120.850:FF:000048', NULL, NULL, 'Meiotic recombination protein rdh54', NULL, NULL, NULL, NULL, NULL, 4),
(46153, NULL, 'G3DSA:2.30.30.140:FF:000265', NULL, NULL, 'Histone acetyltransferase ESA1', NULL, NULL, NULL, NULL, NULL, 4),
(46154, NULL, 'G3DSA:4.10.1120.10:FF:000004', NULL, NULL, 'Rod phosphodiesterase gamma subunit', NULL, NULL, NULL, NULL, NULL, 4),
(46155, NULL, 'G3DSA:1.20.1280.50:FF:000111', NULL, NULL, 'F-box and WD domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(46156, NULL, 'G3DSA:3.90.1150.10:FF:000117', NULL, NULL, 'Cystathionine gamma-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(46157, NULL, 'G3DSA:1.10.1200.80:FF:000005', NULL, NULL, 'tRNA-dihydrouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(46158, NULL, 'G3DSA:3.40.630.30:FF:000291', NULL, NULL, 'GNAT family acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(46159, NULL, 'G3DSA:2.40.30.70:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46160, NULL, 'G3DSA:3.40.50.2300:FF:000847', NULL, NULL, 'ETR4 ethylene receptor protein', NULL, NULL, NULL, NULL, NULL, 4),
(46161, NULL, 'G3DSA:3.50.50.60:FF:001386', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(46162, NULL, 'G3DSA:2.60.200.20:FF:000030', NULL, NULL, 'FHA domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(46163, NULL, 'G3DSA:3.50.50.60:FF:001330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46164, NULL, 'G3DSA:3.30.200.20:FF:001252', NULL, NULL, 'Nerve growth factor receptor TRKA, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46165, NULL, 'G3DSA:3.40.50.10090:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46166, NULL, 'G3DSA:1.10.4050.10:FF:000001', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(46167, NULL, 'G3DSA:3.10.330.20:FF:000013', NULL, NULL, 'tRNA (adenine(58)-N(1))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(46168, NULL, 'G3DSA:1.20.1560.10:FF:000508', NULL, NULL, 'Protein CBR-MRP-6', NULL, NULL, NULL, NULL, NULL, 4),
(46169, NULL, 'G3DSA:3.40.50.2300:FF:001359', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46170, NULL, 'G3DSA:2.60.40.10:FF:004290', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46171, NULL, 'G3DSA:1.10.510.10:FF:003741', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46172, NULL, 'G3DSA:3.30.160.60:FF:005863', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46173, NULL, 'G3DSA:2.130.10.10:FF:000395', NULL, NULL, 'lipopolysaccharide-responsive and beige-like anchor protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(46174, NULL, 'G3DSA:3.40.1160.10:FF:000085', NULL, NULL, 'Acetylglutamate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(46175, NULL, 'G3DSA:1.10.472.10:FF:000026', NULL, NULL, 'Cyclin-T1-5 like', NULL, NULL, NULL, NULL, NULL, 4),
(46176, NULL, 'G3DSA:3.90.810.10:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46177, NULL, 'G3DSA:1.10.1450.10:FF:000071', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(46178, NULL, 'G3DSA:1.10.880.10:FF:000002', NULL, NULL, 'transcription regulator protein BACH2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(46179, NULL, 'G3DSA:3.30.160.60:FF:005987', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46180, NULL, 'G3DSA:1.10.8.10:FF:000087', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(46181, NULL, 'G3DSA:1.20.900.10:FF:000121', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF b', NULL, NULL, NULL, NULL, NULL, 4),
(46182, NULL, 'G3DSA:3.40.50.300:FF:000794', NULL, NULL, 'ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(46183, NULL, 'G3DSA:3.40.50.150:FF:000496', NULL, NULL, 'Chromosome 21, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(46184, NULL, 'G3DSA:1.20.920.20:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46185, NULL, 'G3DSA:2.60.120.920:FF:000126', NULL, NULL, 'Ryanodine receptor 3', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(46186, NULL, 'G3DSA:2.10.110.10:FF:000008', NULL, NULL, 'Paxillin isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(46187, NULL, 'G3DSA:3.40.605.10:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46188, NULL, 'G3DSA:3.30.200.20:FF:002449', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46189, NULL, 'G3DSA:1.10.10.1760:FF:000002', NULL, NULL, '60S ribosomal protein L36', NULL, NULL, NULL, NULL, NULL, 4),
(46190, NULL, 'G3DSA:3.10.100.10:FF:000184', NULL, NULL, 'Mannose receptor, C type 1b', NULL, NULL, NULL, NULL, NULL, 4),
(46191, NULL, 'G3DSA:1.20.1070.10:FF:001444', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46192, NULL, 'G3DSA:2.130.10.10:FF:004846', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46193, NULL, 'G3DSA:3.30.710.10:FF:000113', NULL, NULL, 'BTB/POZ domain-containing protein KCTD5', NULL, NULL, NULL, NULL, NULL, 4),
(46194, NULL, 'G3DSA:3.30.70.330:FF:000770', NULL, NULL, 'Polyadenylate-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46195, NULL, 'G3DSA:2.170.270.10:FF:000229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46196, NULL, 'G3DSA:1.10.3080.10:FF:000059', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(46197, NULL, 'G3DSA:3.80.10.10:FF:001199', NULL, NULL, 'Expressed sequence C87414', NULL, NULL, NULL, NULL, NULL, 4),
(46198, NULL, 'G3DSA:3.30.300.130:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46199, NULL, 'G3DSA:3.30.60.30:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46200, NULL, 'G3DSA:2.40.50.90:FF:000009', NULL, NULL, 'tudor domain-containing protein 7 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(46201, NULL, 'G3DSA:1.10.510.10:FF:003409', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46202, NULL, 'G3DSA:3.60.20.10:FF:000138', NULL, NULL, 'Proteasome subunit alpha type', NULL, NULL, NULL, NULL, NULL, 4),
(46203, NULL, 'G3DSA:3.30.70.330:FF:001444', NULL, NULL, 'RNA-binding_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(46204, NULL, 'G3DSA:1.10.1650.10:FF:000001', NULL, NULL, 'Ribosomal protein L19', NULL, NULL, NULL, NULL, NULL, 4),
(46205, NULL, 'G3DSA:3.40.50.150:FF:001620', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46206, NULL, 'G3DSA:2.40.170.20:FF:000019', NULL, NULL, 'TonB-dependent siderophore receptor', NULL, NULL, NULL, NULL, NULL, 4),
(46207, NULL, 'G3DSA:3.40.50.300:FF:005577', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46208, NULL, 'G3DSA:2.130.10.10:FF:001069', NULL, NULL, 'Related to GLE2-required for nuclear pore complex structure and function', NULL, NULL, NULL, NULL, NULL, 4),
(46209, NULL, 'G3DSA:2.60.40.10:FF:005363', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46210, NULL, 'G3DSA:3.30.200.20:FF:001775', NULL, NULL, 'Serine/threonine protein kinase-43', NULL, NULL, NULL, NULL, NULL, 4),
(46211, NULL, 'G3DSA:3.40.1180.10:FF:000029', NULL, NULL, 'Alkyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(46212, NULL, 'G3DSA:3.30.160.60:FF:001592', NULL, NULL, 'Abrupt, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(46213, NULL, 'G3DSA:1.25.40.10:FF:003221', NULL, NULL, 'Protein O-mannosyl-transferase TMTC4', NULL, NULL, NULL, NULL, NULL, 4),
(46214, NULL, 'G3DSA:3.90.70.10:FF:000730', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46215, NULL, 'G3DSA:3.40.50.2300:FF:001646', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46216, NULL, 'G3DSA:1.10.510.10:FF:001375', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46217, NULL, 'G3DSA:2.30.29.30:FF:001275', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(46218, NULL, 'G3DSA:2.10.110.10:FF:000284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46219, NULL, 'G3DSA:3.40.50.720:FF:002218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46220, NULL, 'G3DSA:3.40.800.20:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(46221, NULL, 'G3DSA:3.20.20.80:FF:000003', NULL, NULL, '1,4-alpha-glucan branching enzyme GlgB', NULL, NULL, NULL, NULL, NULL, 4),
(46222, NULL, 'G3DSA:2.30.29.30:FF:000875', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46223, NULL, 'G3DSA:1.25.40.20:FF:000520', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46224, NULL, 'G3DSA:2.60.120.10:FF:000548', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46225, NULL, 'G3DSA:3.30.70.2740:FF:000021', NULL, NULL, 'Putative oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(46226, NULL, 'G3DSA:3.30.470.160:FF:000005', NULL, NULL, 'Inositol polyphosphate multikinase', NULL, NULL, NULL, NULL, NULL, 4),
(46227, NULL, 'G3DSA:1.10.287.370:FF:000086', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(46228, NULL, 'G3DSA:3.10.20.90:FF:000260', NULL, NULL, 'Phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(46229, NULL, 'G3DSA:4.10.720.10:FF:000002', NULL, NULL, 'Putative smad anchor for receptor activation', NULL, NULL, NULL, NULL, NULL, 4),
(46230, NULL, 'G3DSA:3.30.160.60:FF:003626', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(46231, NULL, 'G3DSA:1.10.287.3510:FF:000012', NULL, NULL, 'NADH-ubiquinone oxidoreductase chain 4L', NULL, NULL, NULL, NULL, NULL, 4),
(46232, NULL, 'G3DSA:2.120.10.80:FF:000129', NULL, NULL, 'Kelch domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(46233, NULL, 'G3DSA:1.10.510.10:FF:002049', NULL, NULL, 'Protein CBG09052', NULL, NULL, NULL, NULL, NULL, 4),
(46234, NULL, 'G3DSA:2.60.120.520:FF:000001', NULL, NULL, '4-deoxy-L-threo-5-hexosulose-uronate ketol-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(46235, NULL, 'G3DSA:3.40.50.300:FF:002143', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(46236, NULL, 'G3DSA:2.40.30.10:FF:000029', NULL, NULL, '116 kDa U5 small nuclear ribonucleoprotein component', NULL, NULL, NULL, NULL, NULL, 4),
(46237, NULL, 'G3DSA:3.30.160.60:FF:002266', NULL, NULL, 'zinc finger protein 526', NULL, NULL, NULL, NULL, NULL, 4),
(46238, NULL, 'G3DSA:1.25.10.10:FF:002612', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46239, NULL, 'G3DSA:1.10.1780.10:FF:000005', NULL, NULL, 'protein SUPPRESSOR OF MAX2 1', NULL, NULL, NULL, NULL, NULL, 4),
(46240, NULL, 'G3DSA:1.10.3730.20:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46241, NULL, 'G3DSA:2.130.10.10:FF:001013', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(46242, NULL, 'G3DSA:3.30.450.150:FF:000015', NULL, NULL, 'UPF0303 protein P4H10.12', NULL, NULL, NULL, NULL, NULL, 4),
(46243, NULL, 'G3DSA:1.20.1270.10:FF:000065', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(46244, NULL, 'G3DSA:3.40.190.10:FF:000885', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46245, NULL, 'G3DSA:1.20.120.1080:FF:000085', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(46246, NULL, 'G3DSA:3.90.1170.20:FF:000009', NULL, NULL, 'Nicotinate-nucleotide pyrophosphorylase [carboxylating]', NULL, NULL, NULL, NULL, NULL, 4),
(46247, NULL, 'G3DSA:1.20.1560.10:FF:000840', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46248, NULL, 'G3DSA:3.80.10.10:FF:002891', NULL, NULL, 'Involucrin', NULL, NULL, NULL, NULL, NULL, 4),
(46249, NULL, 'G3DSA:4.10.1040.10:FF:000003', NULL, NULL, 'doublesex- and mab-3-related transcription factor 3a-like', NULL, NULL, NULL, NULL, NULL, 4),
(46250, NULL, 'G3DSA:2.40.270.10:FF:000018', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(46251, NULL, 'G3DSA:1.10.3810.10:FF:000008', NULL, NULL, 'Monofunctional biosynthetic peptidoglycan transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(46252, NULL, 'G3DSA:2.70.130.10:FF:000092', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46253, NULL, 'G3DSA:3.30.420.10:FF:000630', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(46254, NULL, 'G3DSA:3.60.40.10:FF:000358', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(46255, NULL, 'G3DSA:3.30.40.10:FF:000736', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(46256, NULL, 'G3DSA:3.30.200.60:FF:000016', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(46257, NULL, 'G3DSA:1.10.287.70:FF:000782', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46258, NULL, 'G3DSA:2.40.50.140:FF:000873', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46259, NULL, 'G3DSA:2.60.40.10:FF:003918', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46260, NULL, 'G3DSA:2.40.70.10:FF:000206', NULL, NULL, 'Os08g0207800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(46261, NULL, 'G3DSA:2.40.10.10:FF:000141', NULL, NULL, 'Enterokinase light chain', NULL, NULL, NULL, NULL, NULL, 4),
(46262, NULL, 'G3DSA:3.90.550.10:FF:000059', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(46263, NULL, 'G3DSA:1.10.630.10:FF:000810', NULL, NULL, 'Ent-kaurenoic acid oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(46264, NULL, 'G3DSA:3.40.50.1780:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46265, NULL, 'G3DSA:1.10.10.60:FF:001058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46266, NULL, 'G3DSA:3.30.40.10:FF:001793', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(46267, NULL, 'G3DSA:2.130.10.10:FF:004503', NULL, NULL, 'LD47540p', NULL, NULL, NULL, NULL, NULL, 4),
(46268, NULL, 'G3DSA:3.40.140.10:FF:000207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46269, NULL, 'G3DSA:3.40.1380.10:FF:000028', NULL, NULL, 'ATP synthase subunit gamma, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(46270, NULL, 'G3DSA:3.30.70.270:FF:000055', NULL, NULL, 'Sensor domain-containing diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(46271, NULL, 'G3DSA:3.90.550.10:FF:000115', NULL, NULL, 'Dolichyl-phosphate beta-glucosyltransferase isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(46272, NULL, 'G3DSA:3.40.1170.10:FF:000023', NULL, NULL, 'DNA mismatch repair protein Msh2', NULL, NULL, NULL, NULL, NULL, 4),
(46273, NULL, 'G3DSA:1.10.20.10:FF:000280', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46274, NULL, 'G3DSA:3.40.50.300:FF:004560', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(46275, NULL, 'G3DSA:3.30.1660.10:FF:000001', NULL, NULL, 'Multiple stress resistance protein BhsA', NULL, NULL, NULL, NULL, NULL, 4),
(46276, NULL, 'G3DSA:1.20.1270.280:FF:000024', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(46277, NULL, 'G3DSA:1.10.1410.10:FF:000074', NULL, NULL, 'Terminal uridylyl transferase 4', NULL, NULL, NULL, NULL, NULL, 4),
(46278, NULL, 'G3DSA:3.20.70.20:FF:000016', NULL, NULL, 'Vitamin B12-dependent ribonucleotide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(46279, NULL, 'G3DSA:2.60.40.60:FF:000061', NULL, NULL, 'FAT atypical cadherin 3', NULL, NULL, NULL, NULL, NULL, 4),
(46280, NULL, 'G3DSA:1.20.1060.20:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46281, NULL, 'G3DSA:3.40.50.1100:FF:000139', NULL, NULL, 'Cysteine synthase CysK', NULL, NULL, NULL, NULL, NULL, 4),
(46282, NULL, 'G3DSA:1.25.10.10:FF:003449', NULL, NULL, 'HEAT repeat-containing 5B', NULL, NULL, NULL, NULL, NULL, 4),
(46283, NULL, 'G3DSA:1.20.1520.10:FF:000006', NULL, NULL, 'The ARF-like 2 binding protein BART, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46284, NULL, 'G3DSA:2.30.30.40:FF:000056', NULL, NULL, 'rho GTPase-activating protein 12 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(46285, NULL, 'G3DSA:3.40.50.880:FF:000203', NULL, NULL, 'Putative glutamine amidotransferase-like protein MJ0138', NULL, NULL, NULL, NULL, NULL, 4),
(46286, NULL, 'G3DSA:3.40.50.2300:FF:000286', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(46287, NULL, 'G3DSA:2.40.50.510:FF:000001', NULL, NULL, 'RecQ-mediated genome instability protein 1', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(46288, NULL, 'G3DSA:1.20.272.10:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46289, NULL, 'G3DSA:3.10.110.10:FF:000353', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46290, NULL, 'G3DSA:3.80.30.20:FF:000023', NULL, NULL, 'RNA modification enzyme, MiaB family', NULL, NULL, NULL, NULL, NULL, 4),
(46291, NULL, 'G3DSA:1.20.140.150:FF:000033', NULL, NULL, 'Natural killer cell granule protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(46292, NULL, 'G3DSA:2.60.40.150:FF:000448', NULL, NULL, 'Calcium-dependent lipid-binding (CaLB domain) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(46293, NULL, 'G3DSA:2.60.40.10:FF:004138', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46294, NULL, 'G3DSA:1.10.10.60:FF:000620', NULL, NULL, 'Mechanosensory protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(46295, NULL, 'G3DSA:1.10.10.10:FF:001291', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46296, NULL, 'G3DSA:3.90.70.10:FF:000550', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46297, NULL, 'G3DSA:3.40.20.10:FF:000021', NULL, NULL, 'protein flightless-1 homolog isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(46298, NULL, 'G3DSA:1.20.1740.10:FF:000169', NULL, NULL, 'Amino acid transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(46299, NULL, 'G3DSA:3.10.110.10:FF:000010', NULL, NULL, 'Ubiquitin-conjugating enzyme E2-16 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(46300, NULL, 'G3DSA:3.90.1720.10:FF:000026', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(46301, NULL, 'G3DSA:2.40.340.10:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46302, NULL, 'G3DSA:3.30.420.80:FF:000005', NULL, NULL, '39S ribosomal protein L18, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(46303, NULL, 'G3DSA:2.60.40.4100:FF:000029', NULL, NULL, 'SD02173p', NULL, NULL, NULL, NULL, NULL, 4),
(46304, NULL, 'G3DSA:1.25.40.10:FF:004238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46305, NULL, 'G3DSA:2.40.50.100:FF:000092', NULL, NULL, 'EXOSome (Multiexonuclease complex) component', NULL, NULL, NULL, NULL, NULL, 4),
(46306, NULL, 'G3DSA:3.40.1390.30:FF:000012', NULL, NULL, 'YbgI/family dinuclear metal center protein', NULL, NULL, NULL, NULL, NULL, 4),
(46307, NULL, 'G3DSA:3.40.50.300:FF:000518', NULL, NULL, 'Dephospho-CoA kinase', NULL, NULL, NULL, NULL, NULL, 4),
(46308, NULL, 'G3DSA:3.30.450.200:FF:000002', NULL, NULL, 'MAP kinase-activating death domain protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(46309, NULL, 'G3DSA:3.30.160.60:FF:003446', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46310, NULL, 'G3DSA:3.40.50.300:FF:001811', NULL, NULL, 'Rab family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(46311, NULL, 'G3DSA:2.60.40.1670:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46312, NULL, 'G3DSA:3.20.20.220:FF:000038', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(46313, NULL, 'G3DSA:3.30.300.10:FF:000026', NULL, NULL, 'Arl-6', NULL, NULL, NULL, NULL, NULL, 4),
(46314, NULL, 'G3DSA:3.40.50.300:FF:008450', NULL, NULL, 'DNA repair helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46315, NULL, 'G3DSA:3.30.70.330:FF:002568', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46316, NULL, 'G3DSA:1.20.58.2130:FF:000004', NULL, NULL, 'YALI0C09614p', NULL, NULL, NULL, NULL, NULL, 4),
(46317, NULL, 'G3DSA:3.90.260.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46318, NULL, 'G3DSA:2.60.40.60:FF:001022', NULL, NULL, 'FAT atypical cadherin 2', NULL, NULL, NULL, NULL, NULL, 4),
(46319, NULL, 'G3DSA:3.40.850.10:FF:000278', NULL, NULL, 'Si:ch211-63b16.4', NULL, NULL, NULL, NULL, NULL, 4),
(46320, NULL, 'G3DSA:1.25.40.10:FF:000927', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(46321, NULL, 'G3DSA:3.40.50.12760:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46322, NULL, 'G3DSA:2.40.50.1060:FF:000021', NULL, NULL, 'DNA-directed RNA polymerase I subunit rpa43', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(46323, NULL, 'G3DSA:3.40.50.880:FF:000147', NULL, NULL, 'Imidazole glycerol phosphate synthase subunit HisH', NULL, NULL, NULL, NULL, NULL, 4),
(46324, NULL, 'G3DSA:1.10.600.10:FF:000078', NULL, NULL, 'Terpene synthase', NULL, NULL, NULL, NULL, NULL, 4),
(46325, NULL, 'G3DSA:3.40.50.620:FF:000884', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46326, NULL, 'G3DSA:4.10.400.10:FF:000130', NULL, NULL, 'Low-density lipoprotein receptor-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(46327, NULL, 'G3DSA:3.40.50.300:FF:005521', NULL, NULL, 'DEAH (Asp-Glu-Ala-His) box polypeptide 35', NULL, NULL, NULL, NULL, NULL, 4),
(46328, NULL, 'G3DSA:3.90.550.50:FF:000099', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(46329, NULL, 'G3DSA:2.130.10.10:FF:003486', NULL, NULL, 'F-box and WD domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(46330, NULL, 'G3DSA:3.30.9.90:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46331, NULL, 'G3DSA:3.90.470.10:FF:000058', NULL, NULL, 'Ac2-210', NULL, NULL, NULL, NULL, NULL, 4),
(46332, NULL, 'G3DSA:3.40.190.10:FF:000542', NULL, NULL, 'GD15119', NULL, NULL, NULL, NULL, NULL, 4),
(46333, NULL, 'G3DSA:3.10.20.90:FF:000821', NULL, NULL, 'Autophagy-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(46334, NULL, 'G3DSA:2.110.10.10:FF:000002', NULL, NULL, 'Matrix metallopeptidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(46335, NULL, 'G3DSA:2.10.70.10:FF:000281', NULL, NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(46336, NULL, 'G3DSA:3.40.50.12780:FF:000028', NULL, NULL, 'Long-chain-fatty-acid--CoA ligase 1', NULL, NULL, NULL, NULL, NULL, 4),
(46337, NULL, 'G3DSA:2.60.40.10:FF:003177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46338, NULL, 'G3DSA:3.90.70.10:FF:000494', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46339, NULL, 'G3DSA:1.25.40.10:FF:002108', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g61360', NULL, NULL, NULL, NULL, NULL, 4),
(46340, NULL, 'G3DSA:2.30.170.20:FF:000016', NULL, NULL, '60S ribosomal protein L24', NULL, NULL, NULL, NULL, NULL, 4),
(46341, NULL, 'G3DSA:3.30.1520.10:FF:000019', NULL, NULL, 'Putative sorting nexin-19', NULL, NULL, NULL, NULL, NULL, 4),
(46342, NULL, 'G3DSA:3.90.1260.10:FF:000002', NULL, NULL, 'Argininosuccinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(46343, NULL, 'G3DSA:3.30.70.3540:FF:000003', NULL, NULL, 'Replicase polyprotein 1ab', NULL, NULL, NULL, NULL, NULL, 4),
(46344, NULL, 'G3DSA:1.25.40.10:FF:003277', NULL, NULL, 'Uncharacterized protein CaJ7.0066', NULL, NULL, NULL, NULL, NULL, 4),
(46345, NULL, 'G3DSA:1.20.1310.20:FF:000061', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(46346, NULL, 'G3DSA:1.10.510.10:FF:003685', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46347, NULL, 'G3DSA:2.30.29.170:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46348, NULL, 'G3DSA:1.10.510.10:FF:000251', NULL, NULL, 'eukaryotic translation initiation factor 2-alpha kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(46349, NULL, 'G3DSA:1.25.40.1040:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46350, NULL, 'G3DSA:2.60.40.60:FF:000746', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(46351, NULL, 'G3DSA:3.30.160.60:FF:004683', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46352, NULL, 'G3DSA:3.30.930.10:FF:000096', NULL, NULL, 'ATP phosphoribosyltransferase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(46353, NULL, 'G3DSA:2.10.25.10:FF:000934', NULL, NULL, 'Drosophila CRumBs homolog', NULL, NULL, NULL, NULL, NULL, 4),
(46354, NULL, 'G3DSA:1.25.40.1030:FF:000012', NULL, NULL, 'Secretory 31, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(46355, NULL, 'G3DSA:1.20.140.10:FF:000057', NULL, NULL, 'Medium-chain acyl-CoA dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(46356, NULL, 'G3DSA:1.50.10.10:FF:000238', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(46357, NULL, 'G3DSA:2.180.10.10:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46358, NULL, 'G3DSA:1.20.1250.20:FF:000415', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46359, NULL, 'G3DSA:2.30.29.30:FF:001095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46360, NULL, 'G3DSA:3.90.1180.10:FF:000001', NULL, NULL, '50S ribosomal protein L13', NULL, NULL, NULL, NULL, NULL, 4),
(46361, NULL, 'G3DSA:3.40.50.300:FF:004408', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46362, NULL, 'G3DSA:1.25.40.10:FF:002440', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g62914, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(46363, NULL, 'G3DSA:2.60.120.200:FF:000528', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46364, NULL, 'G3DSA:3.30.160.60:FF:004407', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46365, NULL, 'G3DSA:2.10.25.10:FF:000030', NULL, NULL, 'Signal peptide, CUB domain and EGF-like domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(46366, NULL, 'G3DSA:1.10.3210.10:FF:000109', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(46367, NULL, 'G3DSA:2.60.40.790:FF:000117', NULL, NULL, 'Heat shock protein Hsp20', NULL, NULL, NULL, NULL, NULL, 4),
(46368, NULL, 'G3DSA:3.40.50.300:FF:000850', NULL, NULL, 'Malignant fibrous histiocytoma-amplified sequence 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(46369, NULL, 'G3DSA:1.10.3930.10:FF:000006', NULL, NULL, 'Arginine deiminase', NULL, NULL, NULL, NULL, NULL, 4),
(46370, NULL, 'G3DSA:1.10.20.10:FF:000128', NULL, NULL, 'Chromatin accessibility complex 14kD protein', NULL, NULL, NULL, NULL, NULL, 4),
(46371, NULL, 'G3DSA:2.170.190.11:FF:000005', NULL, NULL, 'Molybdopterin biosynthesis MoeA protein', NULL, NULL, NULL, NULL, NULL, 4),
(46372, NULL, 'G3DSA:1.10.510.10:FF:004466', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46373, NULL, 'G3DSA:2.60.40.10:FF:001996', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(46374, NULL, 'G3DSA:2.20.100.10:FF:000129', NULL, NULL, 'Zinc metalloproteinase dpy-31', NULL, NULL, NULL, NULL, NULL, 4),
(46375, NULL, 'G3DSA:3.30.160.60:FF:000136', NULL, NULL, 'GLI family zinc finger 4', NULL, NULL, NULL, NULL, NULL, 4),
(46376, NULL, 'G3DSA:2.60.120.200:FF:000708', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46377, NULL, 'G3DSA:3.90.640.10:FF:000094', NULL, NULL, 'Actin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46378, NULL, 'G3DSA:3.80.10.10:FF:000474', NULL, NULL, 'Si:ch211-214c20.1', NULL, NULL, NULL, NULL, NULL, 4),
(46379, NULL, 'G3DSA:3.40.50.300:FF:002087', NULL, NULL, 'Cobalt ABC transporter ATP-binding protien', NULL, NULL, NULL, NULL, NULL, 4),
(46380, NULL, 'G3DSA:1.10.510.10:FF:004522', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46381, NULL, 'G3DSA:3.40.50.720:FF:001201', NULL, NULL, 'NADPH-dependent reductase BacG', NULL, NULL, NULL, NULL, NULL, 4),
(46382, NULL, 'G3DSA:2.130.10.10:FF:000631', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(46383, NULL, 'G3DSA:2.20.70.10:FF:000196', NULL, NULL, 'Rho GTPase-activating protein 27,-like', NULL, NULL, NULL, NULL, NULL, 4),
(46384, NULL, 'G3DSA:1.10.150.20:FF:000321', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(46385, NULL, 'G3DSA:1.10.287.70:FF:000506', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46386, NULL, 'G3DSA:3.40.50.2300:FF:001303', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46387, NULL, 'G3DSA:1.50.10.100:FF:000001', NULL, NULL, 'dermatan-sulfate epimerase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(46388, NULL, 'G3DSA:1.20.1600.10:FF:000007', NULL, NULL, 'Outer membrane efflux protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(46389, NULL, 'G3DSA:2.102.10.10:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46390, NULL, 'G3DSA:2.60.40.60:FF:000802', NULL, NULL, 'Protein CBR-CDH-12', NULL, NULL, NULL, NULL, NULL, 4),
(46391, NULL, 'G3DSA:3.40.50.11320:FF:000001', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(46392, NULL, 'G3DSA:1.10.510.10:FF:000195', NULL, NULL, 'pto-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(46393, NULL, 'G3DSA:3.40.390.10:FF:000198', NULL, NULL, 'Zinc metalloproteinase', NULL, NULL, NULL, NULL, NULL, 4),
(46394, NULL, 'G3DSA:3.40.50.300:FF:007651', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46395, NULL, 'G3DSA:1.25.10.10:FF:000015', NULL, NULL, 'Catenin beta-1', NULL, NULL, NULL, NULL, NULL, 4),
(46396, NULL, 'G3DSA:2.60.40.10:FF:003233', NULL, NULL, 'Interferon gamma receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(46397, NULL, 'G3DSA:3.90.1800.10:FF:000027', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(46398, NULL, 'G3DSA:2.40.490.10:FF:000001', NULL, NULL, 'Fusion glycoprotein F0', NULL, NULL, NULL, NULL, NULL, 4),
(46399, NULL, 'G3DSA:3.20.140.10:FF:000021', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(46400, NULL, 'G3DSA:3.30.559.10:FF:000266', NULL, NULL, 'Acylsugar acyltransferase 3', NULL, NULL, NULL, NULL, NULL, 4),
(46401, NULL, 'G3DSA:1.20.91.20:FF:000002', NULL, NULL, 'Complement C4-A', NULL, NULL, NULL, NULL, NULL, 4),
(46402, NULL, 'G3DSA:1.25.40.10:FF:001147', NULL, NULL, 'LD33695p', NULL, NULL, NULL, NULL, NULL, 4),
(46403, NULL, 'G3DSA:3.40.190.10:FF:000941', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46404, NULL, 'G3DSA:2.60.40.1760:FF:000013', NULL, NULL, 'Alpha glucosidase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(46405, NULL, 'G3DSA:3.30.70.330:FF:001787', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46406, NULL, 'G3DSA:1.20.58.390:FF:000282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46407, NULL, 'G3DSA:3.30.200.20:FF:000139', NULL, NULL, 'inactive tyrosine-protein kinase transmembrane receptor ROR1', NULL, NULL, NULL, NULL, NULL, 4),
(46408, NULL, 'G3DSA:1.10.150.280:FF:000003', NULL, NULL, 'Kinesin-like protein KIN-10C', NULL, NULL, NULL, NULL, NULL, 4),
(46409, NULL, 'G3DSA:3.20.190.10:FF:000024', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(46410, NULL, 'G3DSA:3.40.50.300:FF:007994', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46411, NULL, 'G3DSA:1.10.275.40:FF:000010', NULL, NULL, 'XPD (Xeroderma Pigmentosum complementation group D) related', NULL, NULL, NULL, NULL, NULL, 4),
(46412, NULL, 'G3DSA:3.30.1510.10:FF:000013', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(46413, NULL, 'G3DSA:3.40.50.11950:FF:000009', NULL, NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(46414, NULL, 'G3DSA:3.30.1430.10:FF:000012', NULL, NULL, 'Ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(46415, NULL, 'G3DSA:1.20.1070.10:FF:001949', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46416, NULL, 'G3DSA:3.30.710.10:FF:000456', NULL, NULL, 'AGAP008506-PA', NULL, NULL, NULL, NULL, NULL, 4),
(46417, NULL, 'G3DSA:3.30.200.20:FF:001432', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46418, NULL, 'G3DSA:1.20.1250.20:FF:000359', NULL, NULL, 'equilibrative nucleoside transporter 2', NULL, NULL, NULL, NULL, NULL, 4),
(46419, NULL, 'G3DSA:2.40.20.10:FF:000023', NULL, NULL, 'Cysteine repeat modular protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(46420, NULL, 'G3DSA:3.90.228.10:FF:000012', NULL, NULL, 'Poly(ADP-ribose) polymerase family member 6', NULL, NULL, NULL, NULL, NULL, 4),
(46421, NULL, 'G3DSA:3.30.70.1730:FF:000067', NULL, NULL, 'Ribosome assembly factor mrt4', NULL, NULL, NULL, NULL, NULL, 4),
(46422, NULL, 'G3DSA:1.10.238.10:FF:000151', NULL, NULL, 'Calpain 9', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(46423, NULL, 'G3DSA:3.10.129.10:FF:000227', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(46424, NULL, 'G3DSA:2.60.40.640:FF:000090', NULL, NULL, 'YALI0A18359p', NULL, NULL, NULL, NULL, NULL, 4),
(46425, NULL, 'G3DSA:3.40.50.1820:FF:001373', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46426, NULL, 'G3DSA:2.10.25.10:FF:000373', NULL, NULL, 'sushi, nidogen and EGF-like domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(46427, NULL, 'G3DSA:1.20.120.1750:FF:000089', NULL, NULL, 'Protein CBG27680', NULL, NULL, NULL, NULL, NULL, 4),
(46428, NULL, 'G3DSA:3.40.50.300:FF:007319', NULL, NULL, 'Si:ch73-170d6.2', NULL, NULL, NULL, NULL, NULL, 4),
(46429, NULL, 'G3DSA:3.30.70.330:FF:001388', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(46430, NULL, 'G3DSA:1.20.1250.20:FF:000758', NULL, NULL, 'Mch1p', NULL, NULL, NULL, NULL, NULL, 4),
(46431, NULL, 'G3DSA:2.60.120.480:FF:000005', NULL, NULL, 'Allantoicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46432, NULL, 'G3DSA:3.40.1810.10:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46433, NULL, 'G3DSA:1.10.287.40:FF:000003', NULL, NULL, 'Serine--tRNA ligase cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(46434, NULL, 'G3DSA:3.40.50.720:FF:000240', NULL, NULL, 'SDR family oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(46435, NULL, 'G3DSA:3.20.20.70:FF:000798', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46436, NULL, 'G3DSA:3.40.50.300:FF:003609', NULL, NULL, 'Polyphosphate kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(46437, NULL, 'G3DSA:1.10.10.10:FF:001976', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46438, NULL, 'G3DSA:3.90.70.10:FF:000151', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(46439, NULL, 'G3DSA:3.30.200.20:FF:001831', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46440, NULL, 'G3DSA:3.80.10.10:FF:001435', NULL, NULL, 'Toll-like receptor 15', NULL, NULL, NULL, NULL, NULL, 4),
(46441, NULL, 'G3DSA:1.20.58.60:FF:000583', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(46442, NULL, 'G3DSA:4.10.400.10:FF:000074', NULL, NULL, 'low-density lipoprotein receptor-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(46443, NULL, 'G3DSA:3.40.50.2300:FF:000342', NULL, NULL, 'Related to serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(46444, NULL, 'G3DSA:1.10.287.110:FF:000204', NULL, NULL, 'Co-chaperone-curved DNA binding protein A', NULL, NULL, NULL, NULL, NULL, 4),
(46445, NULL, 'G3DSA:3.40.50.1820:FF:000973', NULL, NULL, 'Os02g0463500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(46446, NULL, 'G3DSA:3.10.20.90:FF:000765', NULL, NULL, 'ubiquitin carboxyl-terminal hydrolase 32', NULL, NULL, NULL, NULL, NULL, 4),
(46447, NULL, 'G3DSA:1.20.1250.10:FF:000137', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46448, NULL, 'G3DSA:1.10.560.10:FF:000074', NULL, NULL, 'T-complex protein 1 subunit delta, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46449, NULL, 'G3DSA:2.130.10.10:FF:003542', NULL, NULL, 'QUInine non-avoider', NULL, NULL, NULL, NULL, NULL, 4),
(46450, NULL, 'G3DSA:2.60.40.10:FF:002957', NULL, NULL, 'Hemicentin-2', NULL, NULL, NULL, NULL, NULL, 4),
(46451, NULL, 'G3DSA:3.30.60.20:FF:000049', NULL, NULL, 'serine/threonine-protein kinase MRCK gamma isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(46452, NULL, 'G3DSA:3.80.10.10:FF:000636', NULL, NULL, 'Leucine rich repeat containing 15', NULL, NULL, NULL, NULL, NULL, 4),
(46453, NULL, 'G3DSA:3.40.50.300:FF:003048', NULL, NULL, 'Ras-related protein RabN2', NULL, NULL, NULL, NULL, NULL, 4),
(46454, NULL, 'G3DSA:3.40.250.10:FF:000036', NULL, NULL, 'M-phase inducer phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(46455, NULL, 'G3DSA:3.30.70.100:FF:000032', NULL, NULL, 'Copper-exporting P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(46456, NULL, 'G3DSA:1.20.120.350:FF:000117', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(46457, NULL, 'G3DSA:3.40.50.10420:FF:000006', NULL, NULL, 'Lactate utilization protein C', NULL, NULL, NULL, NULL, NULL, 4),
(46458, NULL, 'G3DSA:1.10.510.10:FF:000071', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 3 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(46459, NULL, 'G3DSA:3.30.40.10:FF:001118', NULL, NULL, 'Nhl repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(46460, NULL, 'G3DSA:3.30.70.330:FF:002748', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46461, NULL, 'G3DSA:1.20.1070.10:FF:000988', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46462, NULL, 'G3DSA:2.10.70.10:FF:000005', NULL, NULL, 'Chordin-like 1, isoform CRA_c', NULL, NULL, NULL, NULL, NULL, 4),
(46463, NULL, 'G3DSA:3.30.200.20:FF:000471', NULL, NULL, 'muscle M-line assembly protein unc-89 isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(46464, NULL, 'G3DSA:3.30.830.10:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46465, NULL, 'G3DSA:3.40.710.10:FF:000116', NULL, NULL, 'Penicillin-binding proteins 1A and 1B', NULL, NULL, NULL, NULL, NULL, 4),
(46466, NULL, 'G3DSA:3.30.70.120:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46467, NULL, 'G3DSA:3.30.70.330:FF:003024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46468, NULL, 'G3DSA:2.60.300.12:FF:000020', NULL, NULL, 'HesB domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(46469, NULL, 'G3DSA:1.10.274.30:FF:000038', NULL, NULL, 'MRG family protein', NULL, NULL, NULL, NULL, NULL, 4),
(46470, NULL, 'G3DSA:3.30.565.10:FF:000270', NULL, NULL, 'DNA topoisomerase II beta', NULL, NULL, NULL, NULL, NULL, 4),
(46471, NULL, 'G3DSA:4.10.240.10:FF:000072', NULL, NULL, 'Unplaced genomic scaffold supercont1.201, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(46472, NULL, 'G3DSA:2.130.10.10:FF:005419', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(46473, NULL, 'G3DSA:3.40.1090.10:FF:000045', NULL, NULL, 'NTE family protein', NULL, NULL, NULL, NULL, NULL, 4),
(46474, NULL, 'G3DSA:2.60.40.720:FF:000001', NULL, NULL, 'Runt-related transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(46475, NULL, 'G3DSA:1.50.40.10:FF:000228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46476, NULL, 'G3DSA:3.40.30.10:FF:000639', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46477, NULL, 'G3DSA:3.40.50.720:FF:002089', NULL, NULL, 'HIV-1 Tat interactive protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(46478, NULL, 'G3DSA:3.30.160.60:FF:003755', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46479, NULL, 'G3DSA:1.10.580.10:FF:000030', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(46480, NULL, 'G3DSA:3.30.230.10:FF:000211', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(46481, NULL, 'G3DSA:2.60.20.10:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46482, NULL, 'G3DSA:3.80.10.10:FF:002744', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46483, NULL, 'G3DSA:3.90.550.50:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46484, NULL, 'G3DSA:3.30.200.20:FF:002320', NULL, NULL, 'Os08g0374600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(46485, NULL, 'G3DSA:1.20.1250.20:FF:002175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46486, NULL, 'G3DSA:2.30.30.140:FF:000349', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(46487, NULL, 'G3DSA:1.50.10.10:FF:000210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46488, NULL, 'G3DSA:3.30.200.20:FF:000712', NULL, NULL, 'WAK-like kinase', NULL, NULL, NULL, NULL, NULL, 4),
(46489, NULL, 'G3DSA:1.25.10.10:FF:000291', NULL, NULL, 'Cytokinesis protein sepA', NULL, NULL, NULL, NULL, NULL, 4),
(46490, NULL, 'G3DSA:1.25.40.1030:FF:000040', NULL, NULL, 'COPII coat assembly protein sec16', NULL, NULL, NULL, NULL, NULL, 4),
(46491, NULL, 'G3DSA:1.20.58.480:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(46492, NULL, 'G3DSA:3.50.50.60:FF:000262', NULL, NULL, 'Cholesterol oxidase ChoD', NULL, NULL, NULL, NULL, NULL, 4),
(46493, NULL, 'G3DSA:3.40.50.720:FF:001600', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(46494, NULL, 'G3DSA:1.20.1270.60:FF:000046', NULL, NULL, 'Vacuolar protein sorting-associated protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(46495, NULL, 'G3DSA:1.10.8.710:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46496, NULL, 'G3DSA:1.10.472.130:FF:000026', NULL, NULL, 'Glutathione S-transferase class-mu 26 kDa isozyme', NULL, NULL, NULL, NULL, NULL, 4),
(46497, NULL, 'G3DSA:2.60.120.10:FF:000413', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46498, NULL, 'G3DSA:3.90.1150.220:FF:000005', NULL, NULL, 'DNA repair-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46499, NULL, 'G3DSA:1.10.150.20:FF:000113', NULL, NULL, 'DNA polymerase theta, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46500, NULL, 'G3DSA:3.40.309.10:FF:000122', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(46501, NULL, 'G3DSA:2.60.120.1040:FF:000005', NULL, NULL, 'Zinc finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46502, NULL, 'G3DSA:1.10.30.10:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46503, NULL, 'G3DSA:3.40.50.300:FF:002536', NULL, NULL, 'Rs1', NULL, NULL, NULL, NULL, NULL, 4),
(46504, NULL, 'G3DSA:2.60.40.10:FF:003317', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46505, NULL, 'G3DSA:3.40.50.2000:FF:001039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46506, NULL, 'G3DSA:3.90.70.10:FF:000281', NULL, NULL, 'ABC transporter ATP-binding/membrane-spanning-hemolysin secretion protein', NULL, NULL, NULL, NULL, NULL, 4),
(46507, NULL, 'G3DSA:4.10.640.10:FF:000029', NULL, NULL, '30S ribosomal protein S18', NULL, NULL, NULL, NULL, NULL, 4),
(46508, NULL, 'G3DSA:3.40.50.300:FF:006870', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46509, NULL, 'G3DSA:3.30.1120.10:FF:000011', NULL, NULL, 'Arylsulfatase AtsB', NULL, NULL, NULL, NULL, NULL, 4),
(46510, NULL, 'G3DSA:1.10.2000.10:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46511, NULL, 'G3DSA:2.10.25.10:FF:000766', NULL, NULL, 'Complement component C9', NULL, NULL, NULL, NULL, NULL, 4),
(46512, NULL, 'G3DSA:3.40.50.20:FF:000059', NULL, NULL, 'UDP-N-acetylbacillosamine N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(46513, NULL, 'G3DSA:3.90.1110.10:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46514, NULL, 'G3DSA:3.40.50.1000:FF:000059', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(46515, NULL, 'G3DSA:1.20.920.10:FF:000105', NULL, NULL, 'Zinc finger, MYND-type-containing 11', NULL, NULL, NULL, NULL, NULL, 4),
(46516, NULL, 'G3DSA:4.10.280.10:FF:000046', NULL, NULL, 'Transcription factor bHLH83', NULL, NULL, NULL, NULL, NULL, 4),
(46517, NULL, 'G3DSA:1.20.1740.10:FF:000146', NULL, NULL, 'Os01g0945100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(46518, NULL, 'G3DSA:1.20.1070.10:FF:000836', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46519, NULL, 'G3DSA:1.10.10.60:FF:000204', NULL, NULL, 'transcription factor MYB80', NULL, NULL, NULL, NULL, NULL, 4),
(46520, NULL, 'G3DSA:3.90.76.10:FF:000029', NULL, NULL, 'Diguanylate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(46521, NULL, 'G3DSA:1.25.10.10:FF:003045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46522, NULL, 'G3DSA:1.10.287.70:FF:000237', NULL, NULL, 'Voltage-gated Ion Channel (VIC) Superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(46523, NULL, 'G3DSA:3.40.50.10490:FF:000066', NULL, NULL, 'RpiR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(46524, NULL, 'G3DSA:2.60.40.150:FF:000044', NULL, NULL, 'dedicator of cytokinesis protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(46525, NULL, 'G3DSA:3.10.20.90:FF:000905', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(46526, NULL, 'G3DSA:3.30.497.10:FF:000026', NULL, NULL, 'Serine protease inhibitor (serpin) 19', NULL, NULL, NULL, NULL, NULL, 4),
(46527, NULL, 'G3DSA:1.10.1410.10:FF:000079', NULL, NULL, 'Os06g0558766 protein', NULL, NULL, NULL, NULL, NULL, 4),
(46528, NULL, 'G3DSA:2.120.10.30:FF:000412', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46529, NULL, 'G3DSA:3.40.30.10:FF:001258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46530, NULL, 'G3DSA:3.30.160.60:FF:004374', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46531, NULL, 'G3DSA:1.25.10.10:FF:002056', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(46532, NULL, 'G3DSA:3.20.20.140:FF:000244', NULL, NULL, 'N-ethylammeline chlorohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(46533, NULL, 'G3DSA:1.25.10.10:FF:000302', NULL, NULL, 'Anaphase-promoting complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(46534, NULL, 'G3DSA:3.10.450.10:FF:000075', NULL, NULL, 'Kininogen 2', NULL, NULL, NULL, NULL, NULL, 4),
(46535, NULL, 'G3DSA:2.60.40.10:FF:005251', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46536, NULL, 'G3DSA:3.30.450.20:FF:000534', NULL, NULL, 'Two-component sensor PprA', NULL, NULL, NULL, NULL, NULL, 4),
(46537, NULL, 'G3DSA:3.30.160.40:FF:000001', NULL, NULL, 'Porphobilinogen deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(46538, NULL, 'G3DSA:1.25.40.10:FF:003665', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(46539, NULL, 'G3DSA:3.30.200.20:FF:001331', NULL, NULL, 'Cysteine-rich RLK (RECEPTOR-like protein kinase) 13', NULL, NULL, NULL, NULL, NULL, 4),
(46540, NULL, 'G3DSA:1.10.510.10:FF:003645', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46541, NULL, 'G3DSA:3.50.50.60:FF:000745', NULL, NULL, 'Flavin-binding monooxygenase-like, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46542, NULL, 'G3DSA:3.40.630.10:FF:000397', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46543, NULL, 'G3DSA:1.10.8.60:FF:000473', NULL, NULL, 'Valosin-containing protein homolog, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46544, NULL, 'G3DSA:3.40.50.150:FF:001676', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46545, NULL, 'G3DSA:3.40.640.10:FF:000223', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(46546, NULL, 'G3DSA:3.30.50.10:FF:000001', NULL, NULL, 'GATA transcription factor (GATAd)', NULL, NULL, NULL, NULL, NULL, 4),
(46547, NULL, 'G3DSA:3.30.2140.20:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46548, NULL, 'G3DSA:3.30.420.10:FF:000496', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46549, NULL, 'G3DSA:1.10.560.10:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46550, NULL, 'G3DSA:1.20.120.430:FF:000023', NULL, NULL, 'tRNA modification GTPase MnmE', NULL, NULL, NULL, NULL, NULL, 4),
(46551, NULL, 'G3DSA:4.10.950.10:FF:000002', NULL, NULL, '60S ribosomal protein L2', NULL, NULL, NULL, NULL, NULL, 4),
(46552, NULL, 'G3DSA:3.30.200.20:FF:001701', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46553, NULL, 'G3DSA:2.30.30.490:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46554, NULL, 'G3DSA:1.20.1070.10:FF:001781', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46555, NULL, 'G3DSA:1.10.940.10:FF:000013', NULL, NULL, 'Transcription antitermination protein NusB', NULL, NULL, NULL, NULL, NULL, 4),
(46556, NULL, 'G3DSA:3.30.160.60:FF:004711', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46557, NULL, 'G3DSA:3.30.1120.30:FF:000017', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(46558, NULL, 'G3DSA:1.20.120.1630:FF:000019', NULL, NULL, 'Possible conserved transmembrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(46559, NULL, 'G3DSA:3.60.10.10:FF:000093', NULL, NULL, 'Exodeoxyribonuclease III, putative', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(46560, NULL, 'G3DSA:3.40.630.30:FF:000453', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46561, NULL, 'G3DSA:3.40.50.300:FF:002166', NULL, NULL, 'BnaAnng32580D protein', NULL, NULL, NULL, NULL, NULL, 4),
(46562, NULL, 'G3DSA:3.40.50.1000:FF:000222', NULL, NULL, 'NLI interacting factor-like phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(46563, NULL, 'G3DSA:3.40.630.30:FF:000144', NULL, NULL, 'Putatative acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(46564, NULL, 'G3DSA:1.10.150.50:FF:000009', NULL, NULL, 'Stromal interaction molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(46565, NULL, 'G3DSA:1.20.120.1250:FF:000001', NULL, NULL, 'GM23464', NULL, NULL, NULL, NULL, NULL, 4),
(46566, NULL, 'G3DSA:3.40.50.460:FF:000044', NULL, NULL, 'Phosphofructokinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46567, NULL, 'G3DSA:3.30.530.20:FF:000052', NULL, NULL, 'Coenzyme Q', NULL, NULL, NULL, NULL, NULL, 4),
(46568, NULL, 'G3DSA:3.20.20.120:FF:000025', NULL, NULL, 'ENO3 isoform 7', NULL, NULL, NULL, NULL, NULL, 4),
(46569, NULL, 'G3DSA:3.10.20.90:FF:000422', NULL, NULL, 'Ubiquitin-specific protease', NULL, NULL, NULL, NULL, NULL, 4),
(46570, NULL, 'G3DSA:2.60.40.10:FF:003789', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46571, NULL, 'G3DSA:2.40.160.20:FF:000036', NULL, NULL, 'Outer membrane protein MopB', NULL, NULL, NULL, NULL, NULL, 4),
(46572, NULL, 'G3DSA:3.90.850.10:FF:000020', NULL, NULL, 'Putative 4-hydroxyphenylacetate degradation bifunctional isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(46573, NULL, 'G3DSA:3.30.565.10:FF:000382', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46574, NULL, 'G3DSA:3.90.1150.10:FF:000140', NULL, NULL, 'alanine aminotransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(46575, NULL, 'G3DSA:3.30.70.330:FF:002405', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46576, NULL, 'G3DSA:1.20.930.10:FF:000033', NULL, NULL, 'Transcription elongation factor S-II', NULL, NULL, NULL, NULL, NULL, 4),
(46577, NULL, 'G3DSA:4.10.1000.10:FF:000080', NULL, NULL, 'Zinc finger CCCH domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(46578, NULL, 'G3DSA:2.40.50.90:FF:000088', NULL, NULL, 'Staphylococcal nuclease-like, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46579, NULL, 'G3DSA:3.30.1340.10:FF:000005', NULL, NULL, 'Fructose-specific PTS system IIA component', NULL, NULL, NULL, NULL, NULL, 4),
(46580, NULL, 'G3DSA:1.20.1460.20:FF:000004', NULL, NULL, 'V-type ATP synthase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(46581, NULL, 'G3DSA:1.10.238.10:FF:000286', NULL, NULL, 'Myosin alkali light chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(46582, NULL, 'G3DSA:3.30.342.10:FF:000055', NULL, NULL, 'DNA polymerase zeta catalytic subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46583, NULL, 'G3DSA:1.10.472.80:FF:000070', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(46584, NULL, 'G3DSA:1.20.1070.10:FF:001129', NULL, NULL, 'Neuropeptide FF receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(46585, NULL, 'G3DSA:3.40.50.11370:FF:000004', NULL, NULL, 'Inositol-tetrakisphosphate 1-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(46586, NULL, 'G3DSA:2.40.50.140:FF:000957', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46587, NULL, 'G3DSA:3.40.30.10:FF:000269', NULL, NULL, 'Selenoprotein H', NULL, NULL, NULL, NULL, NULL, 4),
(46588, NULL, 'G3DSA:1.25.40.540:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46589, NULL, 'G3DSA:3.20.20.70:FF:000697', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46590, NULL, 'G3DSA:3.10.20.90:FF:000113', NULL, NULL, 'ras association domain-containing protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(46591, NULL, 'G3DSA:2.60.120.200:FF:000596', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(46592, NULL, 'G3DSA:2.60.120.560:FF:000018', NULL, NULL, 'Beta-fructofuranosidase suc1-Aspergillus niger', NULL, NULL, NULL, NULL, NULL, 4),
(46593, NULL, 'G3DSA:2.60.120.260:FF:000035', NULL, NULL, 'probable carboxypeptidase X1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(46594, NULL, 'G3DSA:1.25.40.10:FF:001748', NULL, NULL, 'Vesicle-associated protein 1-1', NULL, NULL, NULL, NULL, NULL, 4),
(46595, NULL, 'G3DSA:2.130.10.10:FF:003621', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46596, NULL, 'G3DSA:1.10.260.60:FF:000004', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', NULL, NULL, NULL, NULL, NULL, 4),
(46597, NULL, 'G3DSA:3.40.50.2000:FF:000746', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46598, NULL, 'G3DSA:3.40.50.300:FF:000249', NULL, NULL, 'tRNA modification GTPase MnmE', NULL, NULL, NULL, NULL, NULL, 4),
(46599, NULL, 'G3DSA:1.25.10.10:FF:000611', NULL, NULL, 'Condensin-2 complex subunit D3', NULL, NULL, NULL, NULL, NULL, 4),
(46600, NULL, 'G3DSA:1.10.472.80:FF:000114', NULL, NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', NULL, NULL, NULL, NULL, NULL, 4),
(46601, NULL, 'G3DSA:3.30.200.110:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46602, NULL, 'G3DSA:2.20.200.10:FF:000002', NULL, NULL, 'Probable outer membrane efflux protein', NULL, NULL, NULL, NULL, NULL, 4),
(46603, NULL, 'G3DSA:2.30.29.30:FF:000690', NULL, NULL, 'Tectonin beta-propeller repeat-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(46604, NULL, 'G3DSA:1.10.510.10:FF:001184', NULL, NULL, 'GM17114', NULL, NULL, NULL, NULL, NULL, 4),
(46605, NULL, 'G3DSA:3.30.1330.80:FF:000008', NULL, NULL, 'AT-hook motif nuclear-localized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46606, NULL, 'G3DSA:3.10.28.10:FF:000012', NULL, NULL, 'Replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(46607, NULL, 'G3DSA:2.120.10.90:FF:000014', NULL, NULL, 'DNA topoisomerase (ATP-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4),
(46608, NULL, 'G3DSA:1.10.472.10:FF:000330', NULL, NULL, 'Cyclin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(46609, NULL, 'G3DSA:3.40.50.300:FF:006561', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46610, NULL, 'G3DSA:3.40.50.980:FF:000008', NULL, NULL, 'Long-chain-fatty-acid--[acyl-carrier-protein] ligase AEE15, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(46611, NULL, 'G3DSA:1.25.40.10:FF:002237', NULL, NULL, 'DnaJ-like chaperone, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46612, NULL, 'G3DSA:1.20.140.40:FF:000009', NULL, NULL, 'Invertase/pectin methylesterase inhibitor family protein', NULL, NULL, NULL, NULL, NULL, 4),
(46613, NULL, 'G3DSA:3.40.532.10:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46614, NULL, 'G3DSA:1.10.510.10:FF:000239', NULL, NULL, 'Proline-rich receptor-like protein kinase PERK1', NULL, NULL, NULL, NULL, NULL, 4),
(46615, NULL, 'G3DSA:1.10.750.20:FF:000007', NULL, NULL, 'Suppressor of cytokine signaling', NULL, NULL, NULL, NULL, NULL, 4),
(46616, NULL, 'G3DSA:3.40.50.720:FF:002409', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(46617, NULL, 'G3DSA:3.90.1410.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46618, NULL, 'G3DSA:2.130.10.10:FF:000215', NULL, NULL, 'Regulatory associated protein of MTOR, complex 1', NULL, NULL, NULL, NULL, NULL, 4),
(46619, NULL, 'G3DSA:3.80.10.10:FF:000283', NULL, NULL, 'Si:cabz01069012.2', NULL, NULL, NULL, NULL, NULL, 4),
(46620, NULL, 'G3DSA:3.30.160.60:FF:002457', NULL, NULL, 'Zinc finger and SCAN domain-containing 4B', NULL, NULL, NULL, NULL, NULL, 4),
(46621, NULL, 'G3DSA:1.10.8.1310:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46622, NULL, 'G3DSA:3.40.50.410:FF:000299', NULL, NULL, 'Sec24d protein', NULL, NULL, NULL, NULL, NULL, 4),
(46623, NULL, 'G3DSA:3.30.40.10:FF:000545', NULL, NULL, 'E3 ubiquitin-protein ligase RNF135', NULL, NULL, NULL, NULL, NULL, 4),
(46624, NULL, 'G3DSA:2.10.10.10:FF:000024', NULL, NULL, 'Insulin-like growth factor 2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(46625, NULL, 'G3DSA:3.30.1330.20:FF:000053', NULL, NULL, 'Tubulin gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(46626, NULL, 'G3DSA:1.10.287.70:FF:000607', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(46627, NULL, 'G3DSA:3.30.70.330:FF:002877', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46628, NULL, 'G3DSA:3.30.1490.50:FF:000005', NULL, NULL, 'Eukaryotic glutathione synthase', NULL, NULL, NULL, NULL, NULL, 4),
(46629, NULL, 'G3DSA:3.90.230.10:FF:000063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46630, NULL, 'G3DSA:1.25.40.10:FF:001309', NULL, NULL, 'Putative intraflagellar transport protein IFT88', NULL, NULL, NULL, NULL, NULL, 4),
(46631, NULL, 'G3DSA:3.10.250.10:FF:000094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46632, NULL, 'G3DSA:2.60.40.10:FF:000900', NULL, NULL, 'Titin a', NULL, NULL, NULL, NULL, NULL, 4),
(46633, NULL, 'G3DSA:2.60.40.10:FF:001991', NULL, NULL, 'Uncharacterized protein YeeJ', NULL, NULL, NULL, NULL, NULL, 4),
(46634, NULL, 'G3DSA:3.30.70.330:FF:000270', NULL, NULL, 'RNA binding motif protein 20', NULL, NULL, NULL, NULL, NULL, 4),
(46635, NULL, 'G3DSA:3.40.1650.10:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46636, NULL, 'G3DSA:3.30.70.990:FF:000001', NULL, NULL, 'UPF0234 protein YajQ', NULL, NULL, NULL, NULL, NULL, 4),
(46637, NULL, 'G3DSA:1.10.10.60:FF:000193', NULL, NULL, 'Ultrabithorax, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(46638, NULL, 'G3DSA:2.60.40.10:FF:000080', NULL, NULL, 'Myosin light chain kinase, smooth muscle', NULL, NULL, NULL, NULL, NULL, 4),
(46639, NULL, 'G3DSA:2.30.29.170:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46640, NULL, 'G3DSA:3.20.20.70:FF:000242', NULL, NULL, 'Dihydroorotate reductase PyrE', NULL, NULL, NULL, NULL, NULL, 4),
(46641, NULL, 'G3DSA:3.30.40.10:FF:001164', NULL, NULL, 'E3 ubiquitin-protein ligase RNF4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(46642, NULL, 'G3DSA:2.60.120.200:FF:000287', NULL, NULL, 'tectonin beta-propeller repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(46643, NULL, 'G3DSA:1.20.1560.10:FF:000683', NULL, NULL, 'Serine protease/ABC transporter B family protein tagB', NULL, NULL, NULL, NULL, NULL, 4),
(46644, NULL, 'G3DSA:3.40.50.2300:FF:001674', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46645, NULL, 'G3DSA:3.30.160.60:FF:001940', NULL, NULL, 'RB-associated KRAB zinc finger protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(46646, NULL, 'G3DSA:2.60.40.2030:FF:000049', NULL, NULL, 'Adhesion G protein-coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(46647, NULL, 'G3DSA:2.130.10.10:FF:004610', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(46648, NULL, 'G3DSA:1.20.1110.10:FF:000228', NULL, NULL, 'Calcium-transporting ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46649, NULL, 'G3DSA:3.90.105.10:FF:000014', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(46650, NULL, 'G3DSA:1.20.990.10:FF:000042', NULL, NULL, 'Sulfite reductase [NADPH] flavoprotein alpha-component', NULL, NULL, NULL, NULL, NULL, 4),
(46651, NULL, 'G3DSA:3.40.50.300:FF:003155', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(46652, NULL, 'G3DSA:2.40.50.140:FF:000502', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(46653, NULL, 'G3DSA:3.30.160.60:FF:001838', NULL, NULL, 'Zinc finger protein 646', NULL, NULL, NULL, NULL, NULL, 4),
(46654, NULL, 'G3DSA:1.10.20.10:FF:000257', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46655, NULL, 'G3DSA:6.20.50.160:FF:000003', NULL, NULL, 'Complement C3', NULL, NULL, NULL, NULL, NULL, 4),
(46656, NULL, 'G3DSA:2.60.120.290:FF:000050', NULL, NULL, 'Cubilin', NULL, NULL, NULL, NULL, NULL, 4),
(46657, NULL, 'G3DSA:2.170.270.10:FF:000010', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(46658, NULL, 'G3DSA:3.30.420.510:FF:000010', NULL, NULL, 'Pantothenate kinase 2, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46659, NULL, 'G3DSA:3.30.460.10:FF:000150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46660, NULL, 'G3DSA:3.30.160.60:FF:005672', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(46661, NULL, 'G3DSA:1.10.10.60:FF:000513', NULL, NULL, 'Chromatin-remodeling complex ATPase chain', NULL, NULL, NULL, NULL, NULL, 4),
(46662, NULL, 'G3DSA:2.110.10.10:FF:000025', NULL, NULL, 'Vitronectin', NULL, NULL, NULL, NULL, NULL, 4),
(46663, NULL, 'G3DSA:3.90.70.10:FF:000634', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46664, NULL, 'G3DSA:3.40.1260.20:FF:000011', NULL, NULL, 'Cytoplasmic axial filament protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46665, NULL, 'G3DSA:1.20.120.730:FF:000006', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(46666, NULL, 'G3DSA:3.80.10.10:FF:003700', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46667, NULL, 'G3DSA:3.30.200.20:FF:000403', NULL, NULL, 'Serine/threonine-protein kinase RIO1', NULL, NULL, NULL, NULL, NULL, 4),
(46668, NULL, 'G3DSA:2.60.120.200:FF:000607', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46669, NULL, 'G3DSA:1.10.800.10:FF:000003', NULL, NULL, 'Phenylalanine-4-hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(46670, NULL, 'G3DSA:2.60.40.10:FF:002480', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(46671, NULL, 'G3DSA:1.25.40.570:FF:000023', NULL, NULL, '26S proteasome regulatory subunit RPN7,putative', NULL, NULL, NULL, NULL, NULL, 4),
(46672, NULL, 'G3DSA:2.60.40.3180:FF:000006', NULL, NULL, 'transcription factor COE1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(46673, NULL, 'G3DSA:2.30.42.10:FF:000557', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46674, NULL, 'G3DSA:2.60.40.10:FF:004262', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46675, NULL, 'G3DSA:2.60.200.20:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46676, NULL, 'G3DSA:3.30.420.210:FF:000010', NULL, NULL, 'NSFL1 cofactor p47, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46677, NULL, 'G3DSA:1.25.10.20:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46678, NULL, 'G3DSA:1.20.1070.10:FF:000483', NULL, NULL, 'G protein-coupled receptor 31', NULL, NULL, NULL, NULL, NULL, 4),
(46679, NULL, 'G3DSA:3.40.1380.20:FF:000019', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(46680, NULL, 'G3DSA:2.40.10.10:FF:000545', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46681, NULL, 'G3DSA:3.40.50.300:FF:005925', NULL, NULL, 'Multidrug resistance-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(46682, NULL, 'G3DSA:1.10.287.110:FF:000250', NULL, NULL, 'Chaperone protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46683, NULL, 'G3DSA:3.80.10.10:FF:003380', NULL, NULL, 'Tehao', NULL, NULL, NULL, NULL, NULL, 4),
(46684, NULL, 'G3DSA:2.170.120.20:FF:000014', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(46685, NULL, 'G3DSA:3.30.70.330:FF:001579', NULL, NULL, 'SR Protein (Splicing factor)', NULL, NULL, NULL, NULL, NULL, 4),
(46686, NULL, 'G3DSA:2.40.30.10:FF:000428', NULL, NULL, 'Translation elongation factor-1-alpha', NULL, NULL, NULL, NULL, NULL, 4),
(46687, NULL, 'G3DSA:3.80.10.10:FF:001772', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46688, NULL, 'G3DSA:1.10.3380.30:FF:000003', NULL, NULL, 'ATP dependent RNA helicase (Dob1)', NULL, NULL, NULL, NULL, NULL, 4),
(46689, NULL, 'G3DSA:1.25.10.10:FF:002409', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46690, NULL, 'G3DSA:1.20.5.170:FF:000148', NULL, NULL, 'Nuclear pore complex protein Nup54', NULL, NULL, NULL, NULL, NULL, 4),
(46691, NULL, 'G3DSA:3.40.50.300:FF:003464', NULL, NULL, 'Cell division control protein', NULL, NULL, NULL, NULL, NULL, 4),
(46692, NULL, 'G3DSA:3.40.190.10:FF:000441', NULL, NULL, 'Tungstate ABC transporter, periplasmic tungstate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(46693, NULL, 'G3DSA:3.40.50.1000:FF:000531', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46694, NULL, 'G3DSA:2.60.40.10:FF:005234', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(46695, NULL, 'G3DSA:1.20.58.130:FF:000001', NULL, NULL, 'Intracellular protein transport protein (UsoA), putative', NULL, NULL, NULL, NULL, NULL, 4),
(46696, NULL, 'G3DSA:3.30.450.20:FF:000551', NULL, NULL, 'Signal-transducing histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(46697, NULL, 'G3DSA:3.10.310.70:FF:000004', NULL, NULL, 'N-substituted formamide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(46698, NULL, 'G3DSA:1.25.40.10:FF:005334', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g23020', NULL, NULL, NULL, NULL, NULL, 4),
(46699, NULL, 'G3DSA:1.10.510.10:FF:001976', NULL, NULL, 'Protein CBG16237', NULL, NULL, NULL, NULL, NULL, 4),
(46700, NULL, 'G3DSA:2.60.40.60:FF:000645', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46701, NULL, 'G3DSA:3.40.50.1820:FF:001614', NULL, NULL, 'Thymusspecific serine protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46702, NULL, 'G3DSA:3.20.20.70:FF:000725', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46703, NULL, 'G3DSA:1.10.720.60:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46704, NULL, 'G3DSA:3.40.140.120:FF:000001', NULL, NULL, 'Lambda phage portal protein B', NULL, NULL, NULL, NULL, NULL, 4),
(46705, NULL, 'G3DSA:2.60.40.10:FF:000872', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', NULL, NULL, NULL, NULL, NULL, 4),
(46706, NULL, 'G3DSA:2.30.180.10:FF:000087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46707, NULL, 'G3DSA:2.60.40.10:FF:003334', NULL, NULL, 'Fibronectin 1b', NULL, NULL, NULL, NULL, NULL, 4),
(46708, NULL, 'G3DSA:3.40.50.150:FF:001693', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46709, NULL, 'G3DSA:1.10.8.60:FF:000456', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46710, NULL, 'G3DSA:3.40.50.300:FF:005942', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46711, NULL, 'G3DSA:3.30.300.30:FF:000116', NULL, NULL, 'Nonribosomal peptide synthase inpB', NULL, NULL, NULL, NULL, NULL, 4),
(46712, NULL, 'G3DSA:3.30.300.130:FF:000010', NULL, NULL, 'Protein AE7-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(46713, NULL, 'G3DSA:3.30.1490.20:FF:000007', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(46714, NULL, 'G3DSA:3.40.50.10190:FF:000066', NULL, NULL, 'BRCT domain protein (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(46715, NULL, 'G3DSA:3.40.250.10:FF:000188', NULL, NULL, 'MBL fold metallo-hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(46716, NULL, 'G3DSA:3.40.50.1100:FF:000004', NULL, NULL, 'Tryptophan synthase beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(46717, NULL, 'G3DSA:4.10.280.10:FF:000176', NULL, NULL, 'Carbohydrate metabolism regulator TYE7', NULL, NULL, NULL, NULL, NULL, 4),
(46718, NULL, 'G3DSA:3.30.1240.10:FF:000060', NULL, NULL, 'Cof-type HAD-IIB family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(46719, NULL, 'G3DSA:3.80.10.10:FF:000827', NULL, NULL, 'Leucine Rich Repeat family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(46720, NULL, 'G3DSA:3.30.1370.10:FF:000142', NULL, NULL, 'AGAP004145-PA', NULL, NULL, NULL, NULL, NULL, 4),
(46721, NULL, 'G3DSA:3.30.160.60:FF:000220', NULL, NULL, 'Zinc finger and BTB domain-containing protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(46722, NULL, 'G3DSA:3.40.50.1010:FF:000051', NULL, NULL, 'Rad2-like endonuclease, putative (AFU_orthologue AFUA_3G13260)', NULL, NULL, NULL, NULL, NULL, 4),
(46723, NULL, 'G3DSA:1.10.10.60:FF:000985', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46724, NULL, 'G3DSA:3.90.228.20:FF:000004', NULL, NULL, 'Phosphoenolpyruvate carboxykinase [GTP], mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(46725, NULL, 'G3DSA:1.20.5.320:FF:000019', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(46726, NULL, 'G3DSA:3.90.850.10:FF:000003', NULL, NULL, 'Fumarylacetoacetate hydrolase domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(46727, NULL, 'G3DSA:3.30.70.240:FF:000052', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(46728, NULL, 'G3DSA:3.30.230.70:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46729, NULL, 'G3DSA:1.25.10.10:FF:001128', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(46730, NULL, 'G3DSA:2.130.10.10:FF:000996', NULL, NULL, 'WD repeat-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(46731, NULL, 'G3DSA:3.40.50.2300:FF:001202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46732, NULL, 'G3DSA:2.40.10.10:FF:000562', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46733, NULL, 'G3DSA:1.20.1740.10:FF:000276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46734, NULL, 'G3DSA:1.20.140.10:FF:000113', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(46735, NULL, 'G3DSA:3.10.20.620:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46736, NULL, 'G3DSA:3.30.450.40:FF:000118', NULL, NULL, 'Diguanylate cyclase-related enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(46737, NULL, 'G3DSA:2.60.40.10:FF:000580', NULL, NULL, 'Myosin light chain kinase, smooth muscle', NULL, NULL, NULL, NULL, NULL, 4),
(46738, NULL, 'G3DSA:3.30.450.30:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46739, NULL, 'G3DSA:2.40.50.140:FF:000974', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46740, NULL, 'G3DSA:2.30.29.30:FF:000347', NULL, NULL, 'Docking protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(46741, NULL, 'G3DSA:3.30.1490.180:FF:000002', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(46742, NULL, 'G3DSA:1.25.40.840:FF:000008', NULL, NULL, 'Subunit of the CCR4-NOT transcriptional complex, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46743, NULL, 'G3DSA:2.130.10.10:FF:001704', NULL, NULL, 'echinoderm microtubule-associated protein-like 5 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(46744, NULL, 'G3DSA:3.40.33.10:FF:000163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46745, NULL, 'G3DSA:1.10.238.10:FF:001275', NULL, NULL, 'Calbindin 2a', NULL, NULL, NULL, NULL, NULL, 4),
(46746, NULL, 'G3DSA:2.10.25.10:FF:000827', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46747, NULL, 'G3DSA:1.20.58.340:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46748, NULL, 'G3DSA:2.40.240.130:FF:000005', NULL, NULL, 'Segment polarity protein dishevelled DVL-1', NULL, NULL, NULL, NULL, NULL, 4),
(46749, NULL, 'G3DSA:1.50.40.10:FF:000167', NULL, NULL, 'Uncharacterized mitochondrial carrier C29A3.11c', NULL, NULL, NULL, NULL, NULL, 4),
(46750, NULL, 'G3DSA:2.60.40.10:FF:004615', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46751, NULL, 'G3DSA:3.30.420.40:FF:000572', NULL, NULL, 'Protein CBG18255', NULL, NULL, NULL, NULL, NULL, 4),
(46752, NULL, 'G3DSA:2.60.40.150:FF:000105', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(46753, NULL, 'G3DSA:1.20.1070.10:FF:001472', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46754, NULL, 'G3DSA:1.20.1250.20:FF:000258', NULL, NULL, 'Melibiose carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(46755, NULL, 'G3DSA:3.30.470.20:FF:000125', NULL, NULL, 'D-alanyl-alanine synthetase A', NULL, NULL, NULL, NULL, NULL, 4),
(46756, NULL, 'G3DSA:3.40.50.10380:FF:000033', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(46757, NULL, 'G3DSA:3.30.160.60:FF:005200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46758, NULL, 'G3DSA:1.25.10.10:FF:000274', NULL, NULL, 'Non-SMC condensin I complex subunit G', NULL, NULL, NULL, NULL, NULL, 4),
(46759, NULL, 'G3DSA:2.60.40.10:FF:001491', NULL, NULL, 'Sidekick, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(46760, NULL, 'G3DSA:1.25.40.20:FF:000312', NULL, NULL, 'serine/threonine-protein kinase STY8', NULL, NULL, NULL, NULL, NULL, 4),
(46761, NULL, 'G3DSA:1.10.630.10:FF:000703', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(46762, NULL, 'G3DSA:2.60.120.10:FF:000060', NULL, NULL, 'Putative mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(46763, NULL, 'G3DSA:2.30.110.10:FF:000021', NULL, NULL, 'Pyridoxine 5''-phosphate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(46764, NULL, 'G3DSA:3.80.10.10:FF:002391', NULL, NULL, 'Leucine-rich repeat-containing protein 40', NULL, NULL, NULL, NULL, NULL, 4),
(46765, NULL, 'G3DSA:1.10.510.10:FF:001537', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(46766, NULL, 'G3DSA:1.10.510.10:FF:004281', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46767, NULL, 'G3DSA:3.40.50.1010:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46768, NULL, 'G3DSA:3.40.50.720:FF:000953', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(46769, NULL, 'G3DSA:2.60.300.12:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46770, NULL, 'G3DSA:3.30.450.40:FF:000220', NULL, NULL, 'Phytochrome-like protein cph1', NULL, NULL, NULL, NULL, NULL, 4),
(46771, NULL, 'G3DSA:1.10.287.810:FF:000015', NULL, NULL, 'Mitochondrial import inner membrane translocase subunit Tim9', NULL, NULL, NULL, NULL, NULL, 4),
(46772, NULL, 'G3DSA:1.20.58.150:FF:000007', NULL, NULL, 'Putative clathrin assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(46773, NULL, 'G3DSA:3.10.150.10:FF:000030', NULL, NULL, 'Proliferating cell nuclear antigen', NULL, NULL, NULL, NULL, NULL, 4),
(46774, NULL, 'G3DSA:2.170.140.10:FF:000057', NULL, NULL, 'Obstructor-G', NULL, NULL, NULL, NULL, NULL, 4),
(46775, NULL, 'G3DSA:1.10.3090.10:FF:000037', NULL, NULL, 'tRNA nucleotidyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46776, NULL, 'G3DSA:3.40.50.300:FF:007207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46777, NULL, 'G3DSA:1.20.1080.10:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46778, NULL, 'G3DSA:3.30.160.60:FF:004402', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46779, NULL, 'G3DSA:1.20.58.730:FF:000001', NULL, NULL, 'Protein zwilch homolog', NULL, NULL, NULL, NULL, NULL, 4),
(46780, NULL, 'G3DSA:2.30.29.30:FF:000908', NULL, NULL, 'FACT complex subunit SSRP1', NULL, NULL, NULL, NULL, NULL, 4),
(46781, NULL, 'G3DSA:1.20.1740.10:FF:000129', NULL, NULL, 'Lysine/arginine permease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46782, NULL, 'G3DSA:1.25.40.10:FF:001591', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(46783, NULL, 'G3DSA:3.20.20.80:FF:000571', NULL, NULL, 'Oligosaccharide 4-alpha-D-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(46784, NULL, 'G3DSA:3.90.76.10:FF:000046', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(46785, NULL, 'G3DSA:3.80.10.10:FF:003037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46786, NULL, 'G3DSA:3.30.70.330:FF:000399', NULL, NULL, 'Nuclear cap-binding protein subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(46787, NULL, 'G3DSA:1.10.287.550:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46788, NULL, 'G3DSA:2.60.40.150:FF:000027', NULL, NULL, 'Synaptotagmin 7', NULL, NULL, NULL, NULL, NULL, 4),
(46789, NULL, 'G3DSA:2.120.10.30:FF:000042', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(46790, NULL, 'G3DSA:2.30.30.380:FF:000050', NULL, NULL, 'AGAP000829-PA', NULL, NULL, NULL, NULL, NULL, 4),
(46791, NULL, 'G3DSA:1.25.10.10:FF:003028', NULL, NULL, 'Cellular apoptosis susceptibility protein', NULL, NULL, NULL, NULL, NULL, 4),
(46792, NULL, 'G3DSA:3.30.2230.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46793, NULL, 'G3DSA:3.40.140.10:FF:000067', NULL, NULL, 'COP9 signalosome, subunit CSN5', NULL, NULL, NULL, NULL, NULL, 4),
(46794, NULL, 'G3DSA:1.10.238.10:FF:000106', NULL, NULL, 'Allograft inflammatory factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(46795, NULL, 'G3DSA:3.30.420.610:FF:000023', NULL, NULL, 'Tudor domain-containing protein 7A', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(46796, NULL, 'G3DSA:1.10.40.30:FF:000017', NULL, NULL, 'Argininosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(46797, NULL, 'G3DSA:1.20.1690.10:FF:000001', NULL, NULL, 'V-type proton ATPase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(46798, NULL, 'G3DSA:3.30.360.10:FF:000086', NULL, NULL, 'Glyceraldehyde 3-phosphate dehydrogenase isoform', NULL, NULL, NULL, NULL, NULL, 4),
(46799, NULL, 'G3DSA:3.40.850.10:FF:000469', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46800, NULL, 'G3DSA:4.10.400.10:FF:000135', NULL, NULL, 'LDL receptor protein 1, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(46801, NULL, 'G3DSA:3.30.559.30:FF:000036', NULL, NULL, 'Nonribosomal peptide synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46802, NULL, 'G3DSA:1.20.120.160:FF:000049', NULL, NULL, 'Chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(46803, NULL, 'G3DSA:3.20.20.140:FF:000261', NULL, NULL, 'Amidohydrolase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(46804, NULL, 'G3DSA:3.30.70.3000:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46805, NULL, 'G3DSA:1.10.630.10:FF:000175', NULL, NULL, 'Cytochrome P450 family 81 subfamily D polypeptide 8', NULL, NULL, NULL, NULL, NULL, 4),
(46806, NULL, 'G3DSA:2.20.20.110:FF:000003', NULL, NULL, 'Putative DNA repair protein Rad4', NULL, NULL, NULL, NULL, NULL, 4),
(46807, NULL, 'G3DSA:1.25.40.10:FF:002900', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46808, NULL, 'G3DSA:3.30.420.10:FF:000057', NULL, NULL, 'IS150, transposase orfB', NULL, NULL, NULL, NULL, NULL, 4),
(46809, NULL, 'G3DSA:1.10.510.10:FF:002156', NULL, NULL, 'Kinase, NEK-like', NULL, NULL, NULL, NULL, NULL, 4),
(46810, NULL, 'G3DSA:1.10.510.10:FF:003662', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46811, NULL, 'G3DSA:1.10.1070.11:FF:000104', NULL, NULL, 'Serine/threonine-protein kinase tel1', NULL, NULL, NULL, NULL, NULL, 4),
(46812, NULL, 'G3DSA:1.10.1170.10:FF:000043', NULL, NULL, 'Protein bir1', NULL, NULL, NULL, NULL, NULL, 4),
(46813, NULL, 'G3DSA:2.60.40.10:FF:001209', NULL, NULL, 'Colony stimulating factor 3 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(46814, NULL, 'G3DSA:3.30.200.20:FF:000050', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(46815, NULL, 'G3DSA:1.25.40.20:FF:000649', NULL, NULL, 'WGS project CABT00000000 data, contig 2.8', NULL, NULL, NULL, NULL, NULL, 4),
(46816, NULL, 'G3DSA:3.30.200.20:FF:001668', NULL, NULL, 'Tribbles pseudokinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(46817, NULL, 'G3DSA:3.30.160.20:FF:000124', NULL, NULL, 'Adenosine deaminase acting on RNA (Adar)-1', NULL, NULL, NULL, NULL, NULL, 4),
(46818, NULL, 'G3DSA:2.130.10.10:FF:001176', NULL, NULL, 'Os02g0290300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(46819, NULL, 'G3DSA:3.30.160.60:FF:001485', NULL, NULL, 'Krueppel-related zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(46820, NULL, 'G3DSA:2.60.120.10:FF:000043', NULL, NULL, 'cGMP-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(46821, NULL, 'G3DSA:2.40.50.140:FF:001121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46822, NULL, 'G3DSA:4.10.400.10:FF:000265', NULL, NULL, 'AGAP003656-PA', NULL, NULL, NULL, NULL, NULL, 4),
(46823, NULL, 'G3DSA:2.120.10.80:FF:000141', NULL, NULL, 'Attractin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(46824, NULL, 'G3DSA:3.90.79.10:FF:000171', NULL, NULL, 'Flavin-dependent trigonelline monooxygenase, reductase component', NULL, NULL, NULL, NULL, NULL, 4),
(46825, NULL, 'G3DSA:3.10.20.90:FF:000361', NULL, NULL, 'Membrane-anchored ubiquitin-fold protein', NULL, NULL, NULL, NULL, NULL, 4),
(46826, NULL, 'G3DSA:1.10.10.10:FF:002100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46827, NULL, 'G3DSA:1.20.120.140:FF:000043', NULL, NULL, 'Signal recognition particle receptor', NULL, NULL, NULL, NULL, NULL, 4),
(46828, NULL, 'G3DSA:1.25.40.10:FF:000130', NULL, NULL, 'Transmembrane and tetratricopeptide repeat containing 2', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(46829, NULL, 'G3DSA:3.90.390.10:FF:000001', NULL, NULL, 'Methyl-coenzyme M reductase I subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(46830, NULL, 'G3DSA:1.50.10.10:FF:000182', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(46831, NULL, 'G3DSA:3.90.1530.10:FF:000006', NULL, NULL, 'Siderophore biosynthesis protein SbnI', NULL, NULL, NULL, NULL, NULL, 4),
(46832, NULL, 'G3DSA:1.25.40.860:FF:000003', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(46833, NULL, 'G3DSA:1.25.40.1040:FF:000026', NULL, NULL, 'Putative nucleotide kinase', NULL, NULL, NULL, NULL, NULL, 4),
(46834, NULL, 'G3DSA:1.25.10.10:FF:001763', NULL, NULL, 'Exportin-T', NULL, NULL, NULL, NULL, NULL, 4),
(46835, NULL, 'G3DSA:3.10.290.10:FF:000101', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(46836, NULL, 'G3DSA:3.40.630.30:FF:000392', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46837, NULL, 'G3DSA:1.10.10.10:FF:001611', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(46838, NULL, 'G3DSA:2.10.50.10:FF:000150', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(46839, NULL, 'G3DSA:3.30.160.60:FF:006156', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46840, NULL, 'G3DSA:3.40.50.720:FF:001100', NULL, NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase catalytic region', NULL, NULL, NULL, NULL, NULL, 4),
(46841, NULL, 'G3DSA:2.60.40.10:FF:001389', NULL, NULL, 'Immunoglobulin-like and fibronectin type III domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(46842, NULL, 'G3DSA:3.30.1370.210:FF:000035', NULL, NULL, 'Zinc finger cx8-c-x5-c-x3-h type (and similar) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(46843, NULL, 'G3DSA:3.90.70.10:FF:000651', NULL, NULL, 'Ubiquitin-specific peptidase 28', NULL, NULL, NULL, NULL, NULL, 4),
(46844, NULL, 'G3DSA:3.30.1360.120:FF:000063', NULL, NULL, 'Folate-binding protein YgfZ', NULL, NULL, NULL, NULL, NULL, 4),
(46845, NULL, 'G3DSA:2.60.120.1000:FF:000004', NULL, NULL, 'collagen alpha-2(XI) chain isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(46846, NULL, 'G3DSA:1.10.3210.10:FF:000098', NULL, NULL, 'YALI0B16566p', NULL, NULL, NULL, NULL, NULL, 4),
(46847, NULL, 'G3DSA:1.20.920.10:FF:000077', NULL, NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(46848, NULL, 'G3DSA:3.30.420.10:FF:000366', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46849, NULL, 'G3DSA:1.20.59.10:FF:000008', NULL, NULL, 'Chorismate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(46850, NULL, 'G3DSA:1.10.10.60:FF:001165', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46851, NULL, 'G3DSA:1.10.418.10:FF:000160', NULL, NULL, 'Fimbrin', NULL, NULL, NULL, NULL, NULL, 4),
(46852, NULL, 'G3DSA:3.40.50.10900:FF:000004', NULL, NULL, 'Proteasome assembly chaperone 2', NULL, NULL, NULL, NULL, NULL, 4),
(46853, NULL, 'G3DSA:3.40.50.1100:FF:000134', NULL, NULL, 'L-serine dehydratase/L-threonine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(46854, NULL, 'G3DSA:2.40.30.10:FF:000445', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46855, NULL, 'G3DSA:2.60.120.260:FF:000518', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(46856, NULL, 'G3DSA:3.40.50.12780:FF:000219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46857, NULL, 'G3DSA:3.40.50.300:FF:003947', NULL, NULL, 'Bifunctional adenosylcobalamin biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(46858, NULL, 'G3DSA:1.10.150.20:FF:000130', NULL, NULL, '5''-3'' exonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(46859, NULL, 'G3DSA:3.40.605.10:FF:000092', NULL, NULL, 'Aldehyde dehydrogenase 4 family member A1', NULL, NULL, NULL, NULL, NULL, 4),
(46860, NULL, 'G3DSA:3.30.930.10:FF:000332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46861, NULL, 'G3DSA:3.40.50.2000:FF:000393', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(46862, NULL, 'G3DSA:3.40.50.720:FF:001128', NULL, NULL, 'Homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(46863, NULL, 'G3DSA:2.10.70.10:FF:000033', NULL, NULL, 'Complement receptor type 1', NULL, NULL, NULL, NULL, NULL, 4),
(46864, NULL, 'G3DSA:2.40.40.20:FF:000067', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(46865, NULL, 'G3DSA:3.30.342.10:FF:000038', NULL, NULL, 'DNA polymerase epsilon catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(46866, NULL, 'G3DSA:1.10.540.10:FF:000067', NULL, NULL, 'Acyl-CoA dehydrogenase FadE22', NULL, NULL, NULL, NULL, NULL, 4),
(46867, NULL, 'G3DSA:3.30.70.100:FF:000004', NULL, NULL, 'NIPSNAP family protein', NULL, NULL, NULL, NULL, NULL, 4),
(46868, NULL, 'G3DSA:1.20.140.10:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46869, NULL, 'G3DSA:3.30.70.330:FF:002905', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46870, NULL, 'G3DSA:1.10.510.10:FF:004410', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46871, NULL, 'G3DSA:2.60.40.10:FF:003289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46872, NULL, 'G3DSA:3.90.190.10:FF:000345', NULL, NULL, 'Protein tyrosine phosphatase type IVA 1', NULL, NULL, NULL, NULL, NULL, 4),
(46873, NULL, 'G3DSA:3.80.10.10:FF:000266', NULL, NULL, 'F-box and leucine rich repeat protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(46874, NULL, 'G3DSA:1.25.40.20:FF:001268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46875, NULL, 'G3DSA:3.40.50.10190:FF:000083', NULL, NULL, 'DNA damage repair protein (Rad9)', NULL, NULL, NULL, NULL, NULL, 4),
(46876, NULL, 'G3DSA:3.80.10.10:FF:004189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46877, NULL, 'G3DSA:1.10.10.2210:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46878, NULL, 'G3DSA:1.10.3230.20:FF:000001', NULL, NULL, 'DNA stabilization, phage-associated', NULL, NULL, NULL, NULL, NULL, 4),
(46879, NULL, 'G3DSA:1.20.5.190:FF:000042', NULL, NULL, 'IQ motif containing F6', NULL, NULL, NULL, NULL, NULL, 4),
(46880, NULL, 'G3DSA:3.10.20.90:FF:000922', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(46881, NULL, 'G3DSA:1.20.1560.10:FF:000239', NULL, NULL, 'ABC type transmembrane transporter', NULL, NULL, NULL, NULL, NULL, 4),
(46882, NULL, 'G3DSA:2.40.30.10:FF:000136', NULL, NULL, 'NADPH-cytochrome p450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(46883, NULL, 'G3DSA:3.40.50.300:FF:007842', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(46884, NULL, 'G3DSA:3.40.50.300:FF:005381', NULL, NULL, 'ATP-binding cassette, sub-family B (MDR/TAP), member 11b', NULL, NULL, NULL, NULL, NULL, 4),
(46885, NULL, 'G3DSA:1.10.10.10:FF:000200', NULL, NULL, 'GA-binding protein alpha chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46886, NULL, 'G3DSA:3.40.50.200:FF:000106', NULL, NULL, 'YALI0C15532p', NULL, NULL, NULL, NULL, NULL, 4),
(46887, NULL, 'G3DSA:3.30.70.330:FF:001708', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46888, NULL, 'G3DSA:1.25.40.10:FF:003417', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(46889, NULL, 'G3DSA:3.80.10.10:FF:001463', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46890, NULL, 'G3DSA:3.30.720.150:FF:000009', NULL, NULL, 'UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(46891, NULL, 'G3DSA:3.30.2090.10:FF:000025', NULL, NULL, 'Probable Resistance-Nodulation-Cell Division (RND) efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(46892, NULL, 'G3DSA:4.10.280.10:FF:000029', NULL, NULL, 'Achaete-scute family bHLH transcription factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(46893, NULL, 'G3DSA:2.10.25.10:FF:001446', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46894, NULL, 'G3DSA:2.60.40.10:FF:000563', NULL, NULL, 'interleukin-6 receptor subunit beta', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(46895, NULL, 'G3DSA:3.40.50.720:FF:001437', NULL, NULL, 'Myo-inositol-1-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(46896, NULL, 'G3DSA:3.40.1190.10:FF:000007', NULL, NULL, 'UDP-N-acetylmuramoyl-tripeptide--D-alanyl-D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(46897, NULL, 'G3DSA:2.60.40.1670:FF:000014', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(46898, NULL, 'G3DSA:3.40.50.410:FF:000271', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(46899, NULL, 'G3DSA:2.130.10.10:FF:005083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46900, NULL, 'G3DSA:1.10.506.10:FF:000016', NULL, NULL, 'Neurofibromin 1', NULL, NULL, NULL, NULL, NULL, 4),
(46901, NULL, 'G3DSA:3.40.50.10810:FF:000112', NULL, NULL, 'SuUR', NULL, NULL, NULL, NULL, NULL, 4),
(46902, NULL, 'G3DSA:1.10.1450.10:FF:000008', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(46903, NULL, 'G3DSA:1.25.10.10:FF:000583', NULL, NULL, 'MAP3K epsilon protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(46904, NULL, 'G3DSA:3.40.50.300:FF:004436', NULL, NULL, 'Fe(2+) transporter FeoB', NULL, NULL, NULL, NULL, NULL, 4),
(46905, NULL, 'G3DSA:2.10.25.10:FF:000518', NULL, NULL, 'latent-transforming growth factor beta-binding protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(46906, NULL, 'G3DSA:3.90.1150.10:FF:000269', NULL, NULL, 'DegT/DnrJ/EryC1/StrS aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(46907, NULL, 'G3DSA:3.30.160.650:FF:000003', NULL, NULL, 'Alkylglycerone-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(46908, NULL, 'G3DSA:1.10.357.10:FF:000051', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(46909, NULL, 'G3DSA:3.40.190.80:FF:000001', NULL, NULL, 'Fructose-1,6-bisphosphatase class 1', NULL, NULL, NULL, NULL, NULL, 4),
(46910, NULL, 'G3DSA:3.15.10.10:FF:000011', NULL, NULL, 'Latherin', NULL, NULL, NULL, NULL, NULL, 4),
(46911, NULL, 'G3DSA:3.40.50.12760:FF:000005', NULL, NULL, 'Methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46912, NULL, 'G3DSA:3.15.10.30:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46913, NULL, 'G3DSA:2.40.70.10:FF:000330', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46914, NULL, 'G3DSA:3.90.550.10:FF:000519', NULL, NULL, 'Glycoside transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(46915, NULL, 'G3DSA:1.10.510.10:FF:002948', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46916, NULL, 'G3DSA:2.160.20.10:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46917, NULL, 'G3DSA:3.30.70.2850:FF:000026', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(46918, NULL, 'G3DSA:3.30.420.40:FF:000701', NULL, NULL, 'L-fuculose kinase', NULL, NULL, NULL, NULL, NULL, 4),
(46919, NULL, 'G3DSA:1.10.375.10:FF:000008', NULL, NULL, 'Gag polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(46920, NULL, 'G3DSA:3.40.50.620:FF:000569', NULL, NULL, 'Sll1606 protein', NULL, NULL, NULL, NULL, NULL, 4),
(46921, NULL, 'G3DSA:2.60.40.1210:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46922, NULL, 'G3DSA:1.10.150.110:FF:000008', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(46923, NULL, 'G3DSA:4.10.400.10:FF:000057', NULL, NULL, 'Very low density lipoprotein receptor', NULL, NULL, NULL, NULL, NULL, 4),
(46924, NULL, 'G3DSA:1.10.510.10:FF:002364', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46925, NULL, 'G3DSA:1.25.40.10:FF:004362', NULL, NULL, 'Cell cycle control protein cwf4', NULL, NULL, NULL, NULL, NULL, 4),
(46926, NULL, 'G3DSA:3.30.450.20:FF:000079', NULL, NULL, 'NADPH-dependent FMN reductase', NULL, NULL, NULL, NULL, NULL, 4),
(46927, NULL, 'G3DSA:1.20.1250.20:FF:000275', NULL, NULL, 'Major facilitator superfamily domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(46928, NULL, 'G3DSA:2.130.10.10:FF:002002', NULL, NULL, 'U3 small nucleolar RNA-associated protein 15 homolog', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(46929, NULL, 'G3DSA:2.60.120.290:FF:000033', NULL, NULL, 'Transmembrane protease serine 7', NULL, NULL, NULL, NULL, NULL, 4),
(46930, NULL, 'G3DSA:2.60.40.10:FF:001417', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase eta', NULL, NULL, NULL, NULL, NULL, 4),
(46931, NULL, 'G3DSA:3.90.550.10:FF:000430', NULL, NULL, 'Bifunctional glycosyltransferase pgtA', NULL, NULL, NULL, NULL, NULL, 4),
(46932, NULL, 'G3DSA:1.25.40.20:FF:001077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46933, NULL, 'G3DSA:2.130.10.10:FF:001384', NULL, NULL, 'Putative polyadenylation factor i complex subunit pfs2', NULL, NULL, NULL, NULL, NULL, 4),
(46934, NULL, 'G3DSA:3.30.70.330:FF:002799', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46935, NULL, 'G3DSA:2.140.10.30:FF:000001', NULL, NULL, 'Dipeptidyl peptidase 4', NULL, NULL, NULL, NULL, NULL, 4),
(46936, NULL, 'G3DSA:3.40.50.2000:FF:000185', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(46937, NULL, 'G3DSA:3.40.50.300:FF:001210', NULL, NULL, 'D-glycerate 3-kinase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(46938, NULL, 'G3DSA:1.25.40.90:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46939, NULL, 'G3DSA:1.10.287.1490:FF:000035', NULL, NULL, 'Protein NETWORKED 1A', NULL, NULL, NULL, NULL, NULL, 4),
(46940, NULL, 'G3DSA:2.60.40.10:FF:001844', NULL, NULL, 'Titin, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(46941, NULL, 'G3DSA:3.40.50.1820:FF:000097', NULL, NULL, 'Alpha/beta hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(46942, NULL, 'G3DSA:1.10.30.10:FF:000005', NULL, NULL, 'TOX high mobility group box family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(46943, NULL, 'G3DSA:2.40.160.210:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46944, NULL, 'G3DSA:2.40.50.140:FF:001019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46945, NULL, 'G3DSA:3.40.570.10:FF:000015', NULL, NULL, 'GM25382', NULL, NULL, NULL, NULL, NULL, 4),
(46946, NULL, 'G3DSA:2.120.10.30:FF:000603', NULL, NULL, 'Serine peptidase family S9', NULL, NULL, NULL, NULL, NULL, 4),
(46947, NULL, 'G3DSA:3.30.505.10:FF:000081', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(46948, NULL, 'G3DSA:3.40.50.300:FF:007179', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(46949, NULL, 'G3DSA:3.40.50.150:FF:000732', NULL, NULL, 'THUMP domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(46950, NULL, 'G3DSA:3.30.160.60:FF:005228', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46951, NULL, 'G3DSA:3.30.930.10:FF:000124', NULL, NULL, 'Putative aspartyl-tRNA synthetase Dps1', NULL, NULL, NULL, NULL, NULL, 4),
(46952, NULL, 'G3DSA:3.30.1330.30:FF:000073', NULL, NULL, 'tRNA/rRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(46953, NULL, 'G3DSA:3.10.350.10:FF:000056', NULL, NULL, 'Peptidase, M23 family', NULL, NULL, NULL, NULL, NULL, 4),
(46954, NULL, 'G3DSA:3.30.70.1210:FF:000001', NULL, NULL, 'CRISPR system Cascade subunit CasE', NULL, NULL, NULL, NULL, NULL, 4),
(46955, NULL, 'G3DSA:2.130.10.10:FF:001968', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46956, NULL, 'G3DSA:2.60.120.260:FF:000018', NULL, NULL, 'Laminin subunit gamma 1', NULL, NULL, NULL, NULL, NULL, 4),
(46957, NULL, 'G3DSA:1.10.510.10:FF:001959', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46958, NULL, 'G3DSA:2.40.10.10:FF:000354', NULL, NULL, 'Complement component 1, r subcomponent', NULL, NULL, NULL, NULL, NULL, 4),
(46959, NULL, 'G3DSA:3.10.20.90:FF:000130', NULL, NULL, 'SHANK-associated RH domain interactor', NULL, NULL, NULL, NULL, NULL, 4),
(46960, NULL, 'G3DSA:3.60.130.10:FF:000034', NULL, NULL, 'Alpha-ketoglutarate-dependent xanthine dioxygenase xanA', NULL, NULL, NULL, NULL, NULL, 4),
(46961, NULL, 'G3DSA:3.30.360.20:FF:000004', NULL, NULL, '18S rRNA biogenesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(46962, NULL, 'G3DSA:3.40.50.2300:FF:000494', NULL, NULL, 'PTS system fructose-specific transporter subunit IIBC', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(46963, NULL, 'G3DSA:1.10.101.10:FF:000036', NULL, NULL, 'Membrane-bound lytic transglycosylase MltB_2 family', NULL, NULL, NULL, NULL, NULL, 4),
(46964, NULL, 'G3DSA:1.10.238.10:FF:000415', NULL, NULL, 'Mitochondrial carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46965, NULL, 'G3DSA:1.20.58.860:FF:000012', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(46966, NULL, 'G3DSA:1.10.418.20:FF:000033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(46967, NULL, 'G3DSA:1.25.40.180:FF:000338', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46968, NULL, 'G3DSA:3.80.10.10:FF:004009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46969, NULL, 'G3DSA:3.30.559.10:FF:000261', NULL, NULL, 'Acyltransferase easC', NULL, NULL, NULL, NULL, NULL, 4),
(46970, NULL, 'G3DSA:3.90.1150.10:FF:000168', NULL, NULL, 'HTH-type transcriptional regulator NorG', NULL, NULL, NULL, NULL, NULL, 4),
(46971, NULL, 'G3DSA:3.40.140.100:FF:000006', NULL, NULL, 'Autophagy protein apg7, putative', NULL, NULL, NULL, NULL, NULL, 4),
(46972, NULL, 'G3DSA:4.10.410.10:FF:000080', NULL, NULL, 'Putative salivary kunitz domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(46973, NULL, 'G3DSA:3.40.50.300:FF:006089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46974, NULL, 'G3DSA:3.90.940.10:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46975, NULL, 'G3DSA:1.20.1110.10:FF:000099', NULL, NULL, 'Transport ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(46976, NULL, 'G3DSA:2.130.10.10:FF:003430', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46977, NULL, 'G3DSA:2.60.40.1730:FF:000043', NULL, NULL, 'TAF2 RNA polymerase II, TATA box binding (TBP)-associated factor, 150 kDa (TAF2), mRNA protein', NULL, NULL, NULL, NULL, NULL, 4),
(46978, NULL, 'G3DSA:3.30.160.60:FF:001277', NULL, NULL, 'zinc finger and BTB domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(46979, NULL, 'G3DSA:3.30.70.330:FF:001916', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46980, NULL, 'G3DSA:3.30.565.10:FF:000410', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(46981, NULL, 'G3DSA:3.10.100.10:FF:000009', NULL, NULL, 'Aggrecan core protein', NULL, NULL, NULL, NULL, NULL, 4),
(46982, NULL, 'G3DSA:1.25.40.90:FF:000097', NULL, NULL, 'Regulation of nuclear pre-mRNA domain containing 2b', NULL, NULL, NULL, NULL, NULL, 4),
(46983, NULL, 'G3DSA:1.10.10.10:FF:000330', NULL, NULL, 'Ferric uptake regulation protein', NULL, NULL, NULL, NULL, NULL, 4),
(46984, NULL, 'G3DSA:1.20.1070.10:FF:000983', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46985, NULL, 'G3DSA:2.40.50.740:FF:000002', NULL, NULL, '30S ribosomal protein S4e', NULL, NULL, NULL, NULL, NULL, 4),
(46986, NULL, 'G3DSA:3.40.50.300:FF:008034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46987, NULL, 'G3DSA:1.20.80.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46988, NULL, 'G3DSA:2.60.210.10:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46989, NULL, 'G3DSA:1.20.272.10:FF:000065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(46990, NULL, 'G3DSA:1.10.630.10:FF:000383', NULL, NULL, 'Os02g0503100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(46991, NULL, 'G3DSA:3.40.20.10:FF:000004', NULL, NULL, 'Gelsolin', NULL, NULL, NULL, NULL, NULL, 4),
(46992, NULL, 'G3DSA:1.10.220.160:FF:000001', NULL, NULL, 'N-lysine methyltransferase SMYD2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(46993, NULL, 'G3DSA:2.70.170.10:FF:000307', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46994, NULL, 'G3DSA:1.10.8.60:FF:000534', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(46995, NULL, 'G3DSA:3.40.50.300:FF:000693', NULL, NULL, 'Nephrocystin-3', NULL, NULL, NULL, NULL, NULL, 4),
(46996, NULL, 'G3DSA:1.10.287.130:FF:000126', NULL, NULL, 'Related to SLN1-histidine kinase osmosensor that regulates a MAP kinase cascade', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(46997, NULL, 'G3DSA:1.20.58.2220:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(46998, NULL, 'G3DSA:3.40.50.720:FF:001780', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(46999, NULL, 'G3DSA:4.10.860.10:FF:000012', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4),
(47000, NULL, 'G3DSA:1.20.58.2010:FF:000007', NULL, NULL, 'Pollen-specific kinase partner protein', NULL, NULL, NULL, NULL, NULL, 4),
(47001, NULL, 'G3DSA:3.30.40.10:FF:000528', NULL, NULL, 'E3 ubiquitin-protein ligase XBAT33', NULL, NULL, NULL, NULL, NULL, 4),
(47002, NULL, 'G3DSA:1.10.287.110:FF:000120', NULL, NULL, 'Hlj1p', NULL, NULL, NULL, NULL, NULL, 4),
(47003, NULL, 'G3DSA:1.25.10.10:FF:002617', NULL, NULL, 'Putative ARM repeat-containing protein containing family protein', NULL, NULL, NULL, NULL, NULL, 4),
(47004, NULL, 'G3DSA:3.30.460.10:FF:000048', NULL, NULL, 'PolyA polymerase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(47005, NULL, 'G3DSA:3.30.450.40:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47006, NULL, 'G3DSA:3.30.30.10:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47007, NULL, 'G3DSA:3.40.50.150:FF:001384', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47008, NULL, 'G3DSA:2.10.25.10:FF:001238', NULL, NULL, 'Protein C (inactivator of coagulation factors Va and VIIIa), a', NULL, NULL, NULL, NULL, NULL, 4),
(47009, NULL, 'G3DSA:3.40.50.300:FF:003672', NULL, NULL, '26S proteasome regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(47010, NULL, 'G3DSA:2.60.120.970:FF:000040', NULL, NULL, 'Nodal homolog 5', NULL, NULL, NULL, NULL, NULL, 4),
(47011, NULL, 'G3DSA:2.30.29.30:FF:001319', NULL, NULL, 'PH and Rap-GAP domain-containing protein DDB_G0271806', NULL, NULL, NULL, NULL, NULL, 4),
(47012, NULL, 'G3DSA:1.10.560.10:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47013, NULL, 'G3DSA:3.30.1490.20:FF:000081', NULL, NULL, 'Blr0101 protein', NULL, NULL, NULL, NULL, NULL, 4),
(47014, NULL, 'G3DSA:3.30.2290.10:FF:000023', NULL, NULL, 'Peptidase U62 modulator of DNA gyrase', NULL, NULL, NULL, NULL, NULL, 4),
(47015, NULL, 'G3DSA:1.20.120.1220:FF:000003', NULL, NULL, 'Type 4 prepilin-like proteins leader peptide-processing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(47016, NULL, 'G3DSA:3.30.70.270:FF:000139', NULL, NULL, 'Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(47017, NULL, 'G3DSA:3.30.70.330:FF:002113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47018, NULL, 'G3DSA:2.40.37.10:FF:000011', NULL, NULL, 'Diaminopimelate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(47019, NULL, 'G3DSA:1.10.287.3550:FF:000001', NULL, NULL, 'Stromal interaction molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(47020, NULL, 'G3DSA:3.40.50.300:FF:003716', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(47021, NULL, 'G3DSA:2.60.40.10:FF:002800', NULL, NULL, 'CD4-1 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(47022, NULL, 'G3DSA:1.25.40.10:FF:003648', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47023, NULL, 'G3DSA:1.20.1070.10:FF:000275', NULL, NULL, 'Gonadotropin-releasing hormone II receptor', NULL, NULL, NULL, NULL, NULL, 4),
(47024, NULL, 'G3DSA:2.10.25.10:FF:000266', NULL, NULL, 'Urokinase-type plasminogen activator', NULL, NULL, NULL, NULL, NULL, 4),
(47025, NULL, 'G3DSA:3.30.160.60:FF:003677', NULL, NULL, 'Zinc finger and BTB domain-containing protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(47026, NULL, 'G3DSA:3.40.50.620:FF:000777', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47027, NULL, 'G3DSA:1.25.40.10:FF:005082', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(47028, NULL, 'G3DSA:3.20.20.70:FF:000517', NULL, NULL, 'Putative dihydropyrimidine dehydrogenase [NADP+]', NULL, NULL, NULL, NULL, NULL, 4),
(47029, NULL, 'G3DSA:3.20.20.80:FF:000054', NULL, NULL, 'Glycogen debranching enzyme', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(47030, NULL, 'G3DSA:3.30.200.20:FF:001140', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(47031, NULL, 'G3DSA:1.25.40.10:FF:003064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47032, NULL, 'G3DSA:3.30.70.330:FF:001607', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47033, NULL, 'G3DSA:3.40.50.300:FF:008343', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47034, NULL, 'G3DSA:1.20.890.10:FF:000006', NULL, NULL, 'Sperm surface protein Sp17', NULL, NULL, NULL, NULL, NULL, 4),
(47035, NULL, 'G3DSA:1.20.5.1240:FF:000001', NULL, NULL, 'Tail spike protein', NULL, NULL, NULL, NULL, NULL, 4),
(47036, NULL, 'G3DSA:3.90.550.50:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47037, NULL, 'G3DSA:1.20.1250.20:FF:000067', NULL, NULL, 'sialin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(47038, NULL, 'G3DSA:3.40.50.720:FF:000509', NULL, NULL, 'Short chain dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(47039, NULL, 'G3DSA:2.10.70.10:FF:000264', NULL, NULL, 'Complement factor H-related 1', NULL, NULL, NULL, NULL, NULL, 4),
(47040, NULL, 'G3DSA:3.40.50.1820:FF:000349', NULL, NULL, 'Monoglyceride lipase', NULL, NULL, NULL, NULL, NULL, 4),
(47041, NULL, 'G3DSA:1.10.530.10:FF:000010', NULL, NULL, 'chitinase-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(47042, NULL, 'G3DSA:3.30.40.10:FF:001034', NULL, NULL, 'E3 ubiquitin-protein ligase SHPRH', NULL, NULL, NULL, NULL, NULL, 4),
(47043, NULL, 'G3DSA:2.60.40.150:FF:000499', NULL, NULL, 'Uncharacterized protein PYUK71.03c', NULL, NULL, NULL, NULL, NULL, 4),
(47044, NULL, 'G3DSA:3.30.160.60:FF:001529', NULL, NULL, 'zinc finger X-linked protein ZXDB', NULL, NULL, NULL, NULL, NULL, 4),
(47045, NULL, 'G3DSA:3.40.30.10:FF:000741', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(47046, NULL, 'G3DSA:1.20.1070.10:FF:001601', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47047, NULL, 'G3DSA:3.40.630.30:FF:000161', NULL, NULL, 'Acetyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(47048, NULL, 'G3DSA:3.40.350.10:FF:000004', NULL, NULL, 'xaa-Pro aminopeptidase 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(47049, NULL, 'G3DSA:3.80.10.10:FF:000619', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(47050, NULL, 'G3DSA:3.40.50.620:FF:000468', NULL, NULL, 'Cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(47051, NULL, 'G3DSA:1.25.40.20:FF:001285', NULL, NULL, 'Ankyrin repeat and zinc finger domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(47052, NULL, 'G3DSA:3.10.400.20:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47053, NULL, 'G3DSA:1.10.1300.10:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47054, NULL, 'G3DSA:3.30.70.330:FF:003041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47055, NULL, 'G3DSA:3.30.300.30:FF:000088', NULL, NULL, 'Dihydroaeruginoic acid synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(47056, NULL, 'G3DSA:3.40.50.300:FF:005734', NULL, NULL, 'Endoribonuclease Dicer-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(47057, NULL, 'G3DSA:2.60.120.200:FF:000416', NULL, NULL, 'Pappalysin 1', NULL, NULL, NULL, NULL, NULL, 4),
(47058, NULL, 'G3DSA:2.60.40.2030:FF:000021', NULL, NULL, 'Adhesion G protein-coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(47059, NULL, 'G3DSA:4.10.240.10:FF:000055', NULL, NULL, 'C6 transcription factor (Ctf1B)', NULL, NULL, NULL, NULL, NULL, 4),
(47060, NULL, 'G3DSA:3.90.1150.10:FF:000477', NULL, NULL, '8-amino-3,8-dideoxy-alpha-D-manno-octulosonate transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(47061, NULL, 'G3DSA:1.10.520.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47062, NULL, 'G3DSA:3.10.580.10:FF:000079', NULL, NULL, 'DUF21 domain-containing protein At1g47330', NULL, NULL, NULL, NULL, NULL, 4),
(47063, NULL, 'G3DSA:1.20.58.60:FF:000802', NULL, NULL, 'AGAP009554-PA', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(47064, NULL, 'G3DSA:3.40.920.10:FF:000014', NULL, NULL, 'Pyruvic-ferredoxin oxidoreductase, gamma subunit', NULL, NULL, NULL, NULL, NULL, 4),
(47065, NULL, 'G3DSA:1.20.58.60:FF:000690', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(47066, NULL, 'G3DSA:1.10.287.70:FF:000737', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(47067, NULL, 'G3DSA:2.40.70.10:FF:000021', NULL, NULL, 'Aspartyl protease AED1', NULL, NULL, NULL, NULL, NULL, 4),
(47068, NULL, 'G3DSA:3.40.50.150:FF:000996', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47069, NULL, 'G3DSA:3.40.50.300:FF:004291', NULL, NULL, 'Guanylate-binding family protein', NULL, NULL, NULL, NULL, NULL, 4),
(47070, NULL, 'G3DSA:3.20.20.80:FF:000363', NULL, NULL, 'Chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47071, NULL, 'G3DSA:3.20.20.80:FF:000615', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(47072, NULL, 'G3DSA:3.40.50.720:FF:001881', NULL, NULL, 'dTDP-4-dehydrorhamnose 3,5-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(47073, NULL, 'G3DSA:2.130.10.10:FF:003958', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(47074, NULL, 'G3DSA:1.25.40.10:FF:002445', NULL, NULL, 'Os03g0701400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(47075, NULL, 'G3DSA:3.40.50.1110:FF:000125', NULL, NULL, 'Similar to c-type cytochrome', NULL, NULL, NULL, NULL, NULL, 4),
(47076, NULL, 'G3DSA:3.40.50.300:FF:006353', NULL, NULL, 'LD28840p', NULL, NULL, NULL, NULL, NULL, 4),
(47077, NULL, 'G3DSA:2.130.10.10:FF:002210', NULL, NULL, 'WD repeat-containing protein 82', NULL, NULL, NULL, NULL, NULL, 4),
(47078, NULL, 'G3DSA:2.60.40.60:FF:000662', NULL, NULL, 'Cadherin 17', NULL, NULL, NULL, NULL, NULL, 4),
(47079, NULL, 'G3DSA:3.30.420.40:FF:000364', NULL, NULL, 'Heat shock protein 70 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(47080, NULL, 'G3DSA:1.10.3210.10:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47081, NULL, 'G3DSA:3.70.10.10:FF:000143', NULL, NULL, 'DNA repair exonuclease REC1', NULL, NULL, NULL, NULL, NULL, 4),
(47082, NULL, 'G3DSA:1.20.1730.10:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47083, NULL, 'G3DSA:3.20.20.140:FF:000492', NULL, NULL, 'Error-prone DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(47084, NULL, 'G3DSA:1.10.510.10:FF:001745', NULL, NULL, 'Non-specific protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(47085, NULL, 'G3DSA:3.90.80.10:FF:000005', NULL, NULL, 'Pyrophosphatase (inorganic) 2', NULL, NULL, NULL, NULL, NULL, 4),
(47086, NULL, 'G3DSA:3.40.720.10:FF:000241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47087, NULL, 'G3DSA:3.40.50.300:FF:001991', NULL, NULL, 'DNA polymerase III, delta prime subunit', NULL, NULL, NULL, NULL, NULL, 4),
(47088, NULL, 'G3DSA:3.40.50.300:FF:008135', NULL, NULL, 'ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(47089, NULL, 'G3DSA:2.30.42.10:FF:000102', NULL, NULL, 'Putative pro-interleukin-16', NULL, NULL, NULL, NULL, NULL, 4),
(47090, NULL, 'G3DSA:3.40.50.300:FF:006898', NULL, NULL, 'Anion-transporting ATPase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(47091, NULL, 'G3DSA:3.40.50.720:FF:001572', NULL, NULL, 'Short-chain dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47092, NULL, 'G3DSA:1.10.10.60:FF:000968', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47093, NULL, 'G3DSA:1.10.8.10:FF:000244', NULL, NULL, 'NSFL1 cofactor p47', NULL, NULL, NULL, NULL, NULL, 4),
(47094, NULL, 'G3DSA:1.10.274.100:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47095, NULL, 'G3DSA:3.30.70.240:FF:000035', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(47096, NULL, 'G3DSA:1.50.10.10:FF:000108', NULL, NULL, 'Glucan 1,4-alpha-glucosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47097, NULL, 'G3DSA:2.30.30.40:FF:000292', NULL, NULL, 'Calcium Channel, Beta subunit', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(47098, NULL, 'G3DSA:2.130.10.10:FF:000524', NULL, NULL, 'Autophagy-related protein 18, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47099, NULL, 'G3DSA:1.25.40.180:FF:000237', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47100, NULL, 'G3DSA:2.60.40.150:FF:000235', NULL, NULL, 'Activating signal cointegrator 1 complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(47101, NULL, 'G3DSA:2.60.120.920:FF:000177', NULL, NULL, 'Si:dkeyp-4f2.1', NULL, NULL, NULL, NULL, NULL, 4),
(47102, NULL, 'G3DSA:3.40.50.300:FF:001682', NULL, NULL, 'Putative pre-mRNA splicing factor ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(47103, NULL, 'G3DSA:2.130.10.10:FF:000979', NULL, NULL, 'WD repeat domain 60', NULL, NULL, NULL, NULL, NULL, 4),
(47104, NULL, 'G3DSA:1.10.1030.10:FF:000016', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(47105, NULL, 'G3DSA:4.10.400.10:FF:000366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47106, NULL, 'G3DSA:2.60.40.150:FF:000605', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47107, NULL, 'G3DSA:3.30.160.20:FF:000096', NULL, NULL, 'Os01g0887400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(47108, NULL, 'G3DSA:1.20.1310.10:FF:000209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47109, NULL, 'G3DSA:1.10.3720.10:FF:000209', NULL, NULL, 'Arginine transport system permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(47110, NULL, 'G3DSA:2.130.10.10:FF:003649', NULL, NULL, 'Elongator acetyltransferase complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(47111, NULL, 'G3DSA:1.20.1560.10:FF:000492', NULL, NULL, 'ABC transporter, putative (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(47112, NULL, 'G3DSA:2.40.30.10:FF:000092', NULL, NULL, 'Elongation factor Tu', NULL, NULL, NULL, NULL, NULL, 4),
(47113, NULL, 'G3DSA:2.30.29.30:FF:001044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47114, NULL, 'G3DSA:3.30.1010.10:FF:000104', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(47115, NULL, 'G3DSA:3.30.160.60:FF:001985', NULL, NULL, 'SEM-4 long form', NULL, NULL, NULL, NULL, NULL, 4),
(47116, NULL, 'G3DSA:1.10.150.190:FF:000004', NULL, NULL, 'Eukaryotic translation initiation factor 2 subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(47117, NULL, 'G3DSA:3.20.20.80:FF:000716', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47118, NULL, 'G3DSA:3.10.20.90:FF:000097', NULL, NULL, 'UBX domain-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(47119, NULL, 'G3DSA:1.20.1250.20:FF:001247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47120, NULL, 'G3DSA:2.70.160.11:FF:000033', NULL, NULL, 'Protein arginine N-methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47121, NULL, 'G3DSA:1.25.10.10:FF:001555', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47122, NULL, 'G3DSA:1.20.58.390:FF:000219', NULL, NULL, 'Gamma-aminobutyric acid (GABA) A receptor, alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(47123, NULL, 'G3DSA:1.20.1420.30:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47124, NULL, 'G3DSA:1.10.510.10:FF:003292', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47125, NULL, 'G3DSA:1.10.510.10:FF:001392', NULL, NULL, 'Px serine/threonine kinase (Pxk)', NULL, NULL, NULL, NULL, NULL, 4),
(47126, NULL, 'G3DSA:1.20.58.390:FF:000175', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(47127, NULL, 'G3DSA:2.130.10.10:FF:006055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47128, NULL, 'G3DSA:1.10.565.10:FF:000118', NULL, NULL, 'Steroid hormone receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(47129, NULL, 'G3DSA:1.10.1420.10:FF:000052', NULL, NULL, 'Msh4p', NULL, NULL, NULL, NULL, NULL, 4),
(47130, NULL, 'G3DSA:3.30.160.60:FF:004391', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47131, NULL, 'G3DSA:2.60.40.10:FF:005998', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(47132, NULL, 'G3DSA:2.60.120.380:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47133, NULL, 'G3DSA:1.20.120.1910:FF:000030', NULL, NULL, 'YALI0D15268p', NULL, NULL, NULL, NULL, NULL, 4),
(47134, NULL, 'G3DSA:3.50.50.60:FF:001234', NULL, NULL, 'Glr0393 protein', NULL, NULL, NULL, NULL, NULL, 4),
(47135, NULL, 'G3DSA:1.20.1310.10:FF:000108', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47136, NULL, 'G3DSA:1.20.1560.10:FF:000020', NULL, NULL, 'ABC metal ion transporter', NULL, NULL, NULL, NULL, NULL, 4),
(47137, NULL, 'G3DSA:1.10.260.40:FF:000026', NULL, NULL, 'Predicted DNA-binding transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(47138, NULL, 'G3DSA:2.30.30.40:FF:000404', NULL, NULL, 'Rho GTPase-activating protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(47139, NULL, 'G3DSA:3.30.160.60:FF:006291', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47140, NULL, 'G3DSA:3.30.70.1510:FF:000001', NULL, NULL, 'Probable tRNA sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(47141, NULL, 'G3DSA:2.40.170.20:FF:000126', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47142, NULL, 'G3DSA:1.20.1070.10:FF:001337', NULL, NULL, 'Si:dkey-94e7.1', NULL, NULL, NULL, NULL, NULL, 4),
(47143, NULL, 'G3DSA:3.40.50.150:FF:001805', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47144, NULL, 'G3DSA:3.30.230.80:FF:000007', NULL, NULL, 'Heat shock protein 90', NULL, NULL, NULL, NULL, NULL, 4),
(47145, NULL, 'G3DSA:2.40.50.90:FF:000116', NULL, NULL, 'Spindle E', NULL, NULL, NULL, NULL, NULL, 4),
(47146, NULL, 'G3DSA:3.30.160.60:FF:002249', NULL, NULL, 'Zinc finger protein 560', NULL, NULL, NULL, NULL, NULL, 4),
(47147, NULL, 'G3DSA:3.40.50.10470:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47148, NULL, 'G3DSA:2.60.120.200:FF:000624', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47149, NULL, 'G3DSA:2.102.10.10:FF:000003', NULL, NULL, 'apoptosis-inducing factor 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(47150, NULL, 'G3DSA:2.160.20.10:FF:000001', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(47151, NULL, 'G3DSA:3.50.4.10:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47152, NULL, 'G3DSA:3.30.160.60:FF:003885', NULL, NULL, 'RE23320p', NULL, NULL, NULL, NULL, NULL, 4),
(47153, NULL, 'G3DSA:3.90.1480.20:FF:000027', NULL, NULL, 'ST3 beta-galactoside alpha-2,3-sialyltransferase 3a', NULL, NULL, NULL, NULL, NULL, 4),
(47154, NULL, 'G3DSA:2.130.10.10:FF:001693', NULL, NULL, 'WD repeats protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(47155, NULL, 'G3DSA:3.40.50.720:FF:002398', NULL, NULL, 'Glutathione-gated K(+)-efflux system KefB', NULL, NULL, NULL, NULL, NULL, 4),
(47156, NULL, 'G3DSA:1.10.238.160:FF:000002', NULL, NULL, 'Predicted transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(47157, NULL, 'G3DSA:2.30.30.830:FF:000005', NULL, NULL, 'Pilus assembly protein PilZ', NULL, NULL, NULL, NULL, NULL, 4),
(47158, NULL, 'G3DSA:3.20.20.190:FF:000135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47159, NULL, 'G3DSA:3.90.1440.10:FF:000016', NULL, NULL, 'AGAP011982-PA', NULL, NULL, NULL, NULL, NULL, 4),
(47160, NULL, 'G3DSA:3.40.50.150:FF:000524', NULL, NULL, 'PHD finger-like domain-containing protein 5A', NULL, NULL, NULL, NULL, NULL, 4),
(47161, NULL, 'G3DSA:1.50.40.10:FF:000358', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47162, NULL, 'G3DSA:1.10.10.800:FF:000006', NULL, NULL, 'YALI0A17281p', NULL, NULL, NULL, NULL, NULL, 4),
(47163, NULL, 'G3DSA:3.40.50.1820:FF:000760', NULL, NULL, 'Alpha/beta hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(47164, NULL, 'G3DSA:3.40.50.880:FF:000198', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(47165, NULL, 'G3DSA:3.30.540.10:FF:000004', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(47166, NULL, 'G3DSA:3.40.1190.20:FF:000128', NULL, NULL, 'GD14306', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(47167, NULL, 'G3DSA:3.30.1330.30:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47168, NULL, 'G3DSA:3.30.230.60:FF:000001', NULL, NULL, '5,6,7,8-tetrahydromethanopterin hydro-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(47169, NULL, 'G3DSA:3.50.50.60:FF:001381', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47170, NULL, 'G3DSA:2.20.25.10:FF:000108', NULL, NULL, 'Transcription elongation factor s-II, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47171, NULL, 'G3DSA:2.60.40.1510:FF:000005', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(47172, NULL, 'G3DSA:1.20.1050.80:FF:000013', NULL, NULL, 'Ankyrin repeat domain 27 (VPS9 domain)', NULL, NULL, NULL, NULL, NULL, 4),
(47173, NULL, 'G3DSA:3.90.1750.10:FF:000017', NULL, NULL, 'Ubiquitin-protein ligase E3B', NULL, NULL, NULL, NULL, NULL, 4),
(47174, NULL, 'G3DSA:1.25.40.20:FF:000560', NULL, NULL, 'Os07g0193200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(47175, NULL, 'G3DSA:3.30.160.60:FF:000760', NULL, NULL, 'Zinc finger protein 423', NULL, NULL, NULL, NULL, NULL, 4),
(47176, NULL, 'G3DSA:3.30.160.60:FF:003738', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47177, NULL, 'G3DSA:3.80.10.10:FF:002761', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(47178, NULL, 'G3DSA:3.40.1110.10:FF:000351', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47179, NULL, 'G3DSA:3.80.10.10:FF:003481', NULL, NULL, 'Fgr51p', NULL, NULL, NULL, NULL, NULL, 4),
(47180, NULL, 'G3DSA:3.40.50.150:FF:001704', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47181, NULL, 'G3DSA:2.130.10.10:FF:005436', NULL, NULL, 'Uncharacterized WD repeat-containing protein C1306.02', NULL, NULL, NULL, NULL, NULL, 4),
(47182, NULL, 'G3DSA:3.40.1090.10:FF:000062', NULL, NULL, 'Uncharacterized NTE family protein M110.7', NULL, NULL, NULL, NULL, NULL, 4),
(47183, NULL, 'G3DSA:1.50.10.150:FF:000004', NULL, NULL, 'Malic acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(47184, NULL, 'G3DSA:1.10.3720.10:FF:000108', NULL, NULL, 'Oligopeptide ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(47185, NULL, 'G3DSA:1.20.1560.10:FF:000739', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47186, NULL, 'G3DSA:1.20.1540.10:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47187, NULL, 'G3DSA:3.90.190.10:FF:000553', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47188, NULL, 'G3DSA:1.25.10.10:FF:002308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47189, NULL, 'G3DSA:1.20.58.480:FF:000005', NULL, NULL, 'Indoleamine 2,3-dioxygenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(47190, NULL, 'G3DSA:2.130.10.10:FF:004110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47191, NULL, 'G3DSA:2.60.40.10:FF:003525', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47192, NULL, 'G3DSA:3.90.70.10:FF:000842', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47193, NULL, 'G3DSA:3.40.50.300:FF:004083', NULL, NULL, 'Serine_hydrolase_(FSH1)/50S_ribosome-binding_GTPase/GTPase_of_uncharacterized_function_C-terminal_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(47194, NULL, 'G3DSA:2.60.120.330:FF:000051', NULL, NULL, 'Clavaminate synthase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(47195, NULL, 'G3DSA:2.60.120.560:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47196, NULL, 'G3DSA:1.25.40.20:FF:001740', NULL, NULL, 'C2 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(47197, NULL, 'G3DSA:3.90.1070.10:FF:000004', NULL, NULL, 'Sucrose-phosphate synthase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(47198, NULL, 'G3DSA:3.80.10.10:FF:002975', NULL, NULL, 'CLL4B clavata1-like receptor S/T protein kinase protein', NULL, NULL, NULL, NULL, NULL, 4),
(47199, NULL, 'G3DSA:3.30.1010.10:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(47200, NULL, 'G3DSA:3.90.1170.10:FF:000023', NULL, NULL, 'Ribosomal protein L16', NULL, NULL, NULL, NULL, NULL, 4),
(47201, NULL, 'G3DSA:3.40.50.300:FF:002183', NULL, NULL, 'Nucleotide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(47202, NULL, 'G3DSA:3.60.21.10:FF:000365', NULL, NULL, 'Sphingomyelin phosphodiesterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47203, NULL, 'G3DSA:1.25.40.10:FF:004929', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(47204, NULL, 'G3DSA:1.10.630.10:FF:000597', NULL, NULL, 'Cytochrome P450 superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(47205, NULL, 'G3DSA:1.25.10.10:FF:002983', NULL, NULL, 'Condensin complex subunit 3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(47206, NULL, 'G3DSA:1.20.1250.20:FF:000628', NULL, NULL, 'Unplaced genomic scaffold supercont1.223, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(47207, NULL, 'G3DSA:1.20.58.1040:FF:000014', NULL, NULL, '1,3-beta-glucanosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(47208, NULL, 'G3DSA:3.30.40.210:FF:000008', NULL, NULL, 'Transcription elongation factor SPT4', NULL, NULL, NULL, NULL, NULL, 4),
(47209, NULL, 'G3DSA:2.60.40.420:FF:000001', NULL, NULL, 'Cytochrome c oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(47210, NULL, 'G3DSA:3.40.50.300:FF:003363', NULL, NULL, 'ATPase family, AAA domain containing 5a', NULL, NULL, NULL, NULL, NULL, 4),
(47211, NULL, 'G3DSA:2.60.40.1180:FF:000171', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(47212, NULL, 'G3DSA:2.60.40.60:FF:000454', NULL, NULL, 'Si:dkey-30k22.7', NULL, NULL, NULL, NULL, NULL, 4),
(47213, NULL, 'G3DSA:3.40.50.11350:FF:000009', NULL, NULL, 'Galactoside 2-alpha-L-fucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(47214, NULL, 'G3DSA:3.30.470.20:FF:000097', NULL, NULL, 'Phosphoribosylamine--glycine ligase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(47215, NULL, 'G3DSA:1.20.120.1200:FF:000008', NULL, NULL, 'NADH-ubiquinone oxidoreductase chain 6', NULL, NULL, NULL, NULL, NULL, 4),
(47216, NULL, 'G3DSA:1.10.10.10:FF:001583', NULL, NULL, 'RNA polymerase sigma-38 factor, stationary phase', NULL, NULL, NULL, NULL, NULL, 4),
(47217, NULL, 'G3DSA:3.30.160.60:FF:005880', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47218, NULL, 'G3DSA:2.60.120.10:FF:000543', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47219, NULL, 'G3DSA:1.10.220.30:FF:000015', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(47220, NULL, 'G3DSA:1.20.58.1120:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47221, NULL, 'G3DSA:3.90.1410.10:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47222, NULL, 'G3DSA:3.90.320.10:FF:000019', NULL, NULL, 'DNA replication ATP-dependent helicase Dna2', NULL, NULL, NULL, NULL, NULL, 4),
(47223, NULL, 'G3DSA:3.40.30.10:FF:000139', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(47224, NULL, 'G3DSA:3.40.50.1820:FF:000658', NULL, NULL, 'Alpha/beta hydrolase, putative (AFU_orthologue AFUA_7G06650)', NULL, NULL, NULL, NULL, NULL, 4),
(47225, NULL, 'G3DSA:2.10.70.100:FF:000001', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(47226, NULL, 'G3DSA:2.30.29.30:FF:001191', NULL, NULL, 'YL1 nuclear protein Cterminal domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(47227, NULL, 'G3DSA:3.40.50.2000:FF:000494', NULL, NULL, 'Related to SPT14-N-acetylglucosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(47228, NULL, 'G3DSA:3.40.50.720:FF:001229', NULL, NULL, 'Oxidoreductase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(47229, NULL, 'G3DSA:1.20.1330.10:FF:000008', NULL, NULL, 'Flagellin', NULL, NULL, NULL, NULL, NULL, 4),
(47230, NULL, 'G3DSA:3.90.1860.10:FF:000008', NULL, NULL, 'RNA-splicing ligase RtcB', NULL, NULL, NULL, NULL, NULL, 4),
(47231, NULL, 'G3DSA:3.10.20.30:FF:000039', NULL, NULL, 'Putative threonyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(47232, NULL, 'G3DSA:1.10.510.10:FF:002673', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47233, NULL, 'G3DSA:2.60.120.590:FF:000033', NULL, NULL, 'Hydroxyproline-rich glycoprotein family protein', NULL, NULL, NULL, NULL, NULL, 4),
(47234, NULL, 'G3DSA:3.30.160.20:FF:000023', NULL, NULL, 'DGCR8, microprocessor complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(47235, NULL, 'G3DSA:3.30.1330.40:FF:000047', NULL, NULL, 'diphthine--ammonia ligase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(47236, NULL, 'G3DSA:3.40.190.10:FF:000250', NULL, NULL, 'RGD-containing lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(47237, NULL, 'G3DSA:3.40.50.2300:FF:001011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47238, NULL, 'G3DSA:2.60.40.790:FF:000180', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47239, NULL, 'G3DSA:3.90.550.50:FF:000071', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(47240, NULL, 'G3DSA:3.40.50.300:FF:002744', NULL, NULL, 'Oligopeptide ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(47241, NULL, 'G3DSA:3.30.450.20:FF:000343', NULL, NULL, 'Sensor histidine kinase, Cache_1, HAMP and PAS domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(47242, NULL, 'G3DSA:2.60.40.60:FF:001073', NULL, NULL, 'Protein CBR-CDH-3', NULL, NULL, NULL, NULL, NULL, 4),
(47243, NULL, 'G3DSA:1.25.40.10:FF:005126', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(47244, NULL, 'G3DSA:3.50.50.60:FF:000762', NULL, NULL, 'FAD-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(47245, NULL, 'G3DSA:3.40.50.300:FF:004644', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(47246, NULL, 'G3DSA:3.90.105.10:FF:000031', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(47247, NULL, 'G3DSA:3.40.30.10:FF:000847', NULL, NULL, 'Protein disulfide isomerase1-2', NULL, NULL, NULL, NULL, NULL, 4),
(47248, NULL, 'G3DSA:3.30.160.60:FF:000451', NULL, NULL, 'Zinc finger protein 710', NULL, NULL, NULL, NULL, NULL, 4),
(47249, NULL, 'G3DSA:3.30.1640.10:FF:000034', NULL, NULL, 'Os06g0723400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(47250, NULL, 'G3DSA:1.50.10.20:FF:000067', NULL, NULL, 'Protein CBG20759', NULL, NULL, NULL, NULL, NULL, 4),
(47251, NULL, 'G3DSA:3.40.50.10190:FF:000291', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(47252, NULL, 'G3DSA:1.25.40.10:FF:004154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47253, NULL, 'G3DSA:3.30.9.10:FF:000091', NULL, NULL, 'D-amino acid oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(47254, NULL, 'G3DSA:3.40.50.1100:FF:000235', NULL, NULL, 'Serine racemase', NULL, NULL, NULL, NULL, NULL, 4),
(47255, NULL, 'G3DSA:3.50.50.60:FF:000054', NULL, NULL, 'Flavoprotein disulfide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(47256, NULL, 'G3DSA:3.10.350.10:FF:000011', NULL, NULL, 'Peptidoglycan endopeptidase LytF', NULL, NULL, NULL, NULL, NULL, 4),
(47257, NULL, 'G3DSA:3.60.40.10:FF:000274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47258, NULL, 'G3DSA:1.10.167.10:FF:000008', NULL, NULL, 'rho guanine nucleotide exchange factor 12', NULL, NULL, NULL, NULL, NULL, 4),
(47259, NULL, 'G3DSA:3.90.1200.10:FF:000021', NULL, NULL, 'Choline kinase', NULL, NULL, NULL, NULL, NULL, 4),
(47260, NULL, 'G3DSA:1.10.10.830:FF:000004', NULL, NULL, 'Isoleucyl-tRNA synthetase, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47261, NULL, 'G3DSA:3.40.1110.10:FF:000087', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(47262, NULL, 'G3DSA:1.10.510.10:FF:003853', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47263, NULL, 'G3DSA:3.40.50.1000:FF:000194', NULL, NULL, 'Mitochondrial import inner membrane translocase subunit TIM50', NULL, NULL, NULL, NULL, NULL, 4),
(47264, NULL, 'G3DSA:2.110.10.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47265, NULL, 'G3DSA:3.30.530.20:FF:000035', NULL, NULL, 'ENHANCED DISEASE RESISTANCE 2', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(47266, NULL, 'G3DSA:3.40.250.10:FF:000087', NULL, NULL, 'Sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(47267, NULL, 'G3DSA:3.40.50.150:FF:000215', NULL, NULL, 'Hua enhancer1', NULL, NULL, NULL, NULL, NULL, 4),
(47268, NULL, 'G3DSA:3.30.230.10:FF:000003', NULL, NULL, 'Elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(47269, NULL, 'G3DSA:3.40.50.720:FF:000291', NULL, NULL, 'Phosphoglycerate dehydrogenase, putative; 33424-31403', NULL, NULL, NULL, NULL, NULL, 4),
(47270, NULL, 'G3DSA:3.30.1370.10:FF:000041', NULL, NULL, 'vigilin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(47271, NULL, 'G3DSA:2.60.40.10:FF:002906', NULL, NULL, 'Cheerio, isoform I', NULL, NULL, NULL, NULL, NULL, 4),
(47272, NULL, 'G3DSA:3.30.160.60:FF:005571', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47273, NULL, 'G3DSA:1.20.5.340:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47274, NULL, 'G3DSA:2.40.50.140:FF:001222', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47275, NULL, 'G3DSA:2.30.180.10:FF:000115', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47276, NULL, 'G3DSA:2.10.90.10:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47277, NULL, 'G3DSA:3.10.620.10:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47278, NULL, 'G3DSA:3.40.47.10:FF:000133', NULL, NULL, '3-hydroxy-3-methylglutaryl coenzyme A synthase', NULL, NULL, NULL, NULL, NULL, 4),
(47279, NULL, 'G3DSA:3.30.70.1450:FF:000022', NULL, NULL, 'Sodium/sulfate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47280, NULL, 'G3DSA:3.40.50.620:FF:000671', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47281, NULL, 'G3DSA:1.10.10.10:FF:000094', NULL, NULL, 'Phosphatidylinositol-3,4,5-trisphosphate dependent Rac exchange factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(47282, NULL, 'G3DSA:3.40.50.2300:FF:000393', NULL, NULL, 'Sucrose operon repressor ScrR LacI family', NULL, NULL, NULL, NULL, NULL, 4),
(47283, NULL, 'G3DSA:3.40.30.10:FF:000286', NULL, NULL, 'Protein disulfide-isomerase domain', NULL, NULL, NULL, NULL, NULL, 4),
(47284, NULL, 'G3DSA:3.40.50.410:FF:000170', NULL, NULL, 'Collagen, type VI, alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(47285, NULL, 'G3DSA:1.20.1070.10:FF:000628', NULL, NULL, 'Adenosine receptor A3', NULL, NULL, NULL, NULL, NULL, 4),
(47286, NULL, 'G3DSA:1.25.40.540:FF:000025', NULL, NULL, 'TAP42-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(47287, NULL, 'G3DSA:3.90.70.10:FF:000179', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47288, NULL, 'G3DSA:3.30.70.330:FF:001360', NULL, NULL, 'Putative RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(47289, NULL, 'G3DSA:3.30.565.10:FF:000174', NULL, NULL, 'Serine phosphatase RsbU, regulator of sigma subunit', NULL, NULL, NULL, NULL, NULL, 4),
(47290, NULL, 'G3DSA:1.20.5.110:FF:000254', NULL, NULL, 'Syx-3', NULL, NULL, NULL, NULL, NULL, 4),
(47291, NULL, 'G3DSA:3.90.550.10:FF:000328', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(47292, NULL, 'G3DSA:3.30.9.10:FF:000248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47293, NULL, 'G3DSA:1.20.58.60:FF:000347', NULL, NULL, 'Muscle-specific protein 300 kDa, isoform L', NULL, NULL, NULL, NULL, NULL, 4),
(47294, NULL, 'G3DSA:3.30.420.40:FF:000600', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(47295, NULL, 'G3DSA:1.20.120.180:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47296, NULL, 'G3DSA:2.60.40.10:FF:000136', NULL, NULL, 'Ciliary neurotrophic factor receptor alpha', NULL, NULL, NULL, NULL, NULL, 4),
(47297, NULL, 'G3DSA:1.20.1250.20:FF:001556', NULL, NULL, 'Solute carrier family 22 member 16', NULL, NULL, NULL, NULL, NULL, 4),
(47298, NULL, 'G3DSA:3.30.160.60:FF:002558', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47299, NULL, 'G3DSA:1.20.120.1750:FF:000061', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(47300, NULL, 'G3DSA:2.60.40.10:FF:002036', NULL, NULL, 'Contactin', NULL, NULL, NULL, NULL, NULL, 4),
(47301, NULL, 'G3DSA:3.40.50.1820:FF:001277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47302, NULL, 'G3DSA:1.25.40.60:FF:000004', NULL, NULL, 'syntaxin-binding protein 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(47303, NULL, 'G3DSA:3.90.1310.10:FF:000012', NULL, NULL, 'Penicillin-binding protein 1 (Peptidoglycan synthetase)', NULL, NULL, NULL, NULL, NULL, 4),
(47304, NULL, 'G3DSA:3.40.1190.20:FF:000230', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(47305, NULL, 'G3DSA:3.60.90.10:FF:000013', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(47306, NULL, 'G3DSA:1.10.238.10:FF:000887', NULL, NULL, 'Rab-GTPase-TBC domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(47307, NULL, 'G3DSA:3.40.50.12160:FF:000022', NULL, NULL, 'tRNA (N(6)-L-threonylcarbamoyladenosine(37)-C(2))-methylthiotransferase MtaB', NULL, NULL, NULL, NULL, NULL, 4),
(47308, NULL, 'G3DSA:1.10.240.10:FF:000022', NULL, NULL, 'Tryptophanyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(47309, NULL, 'G3DSA:3.40.50.720:FF:000852', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(P)+]', NULL, NULL, NULL, NULL, NULL, 4),
(47310, NULL, 'G3DSA:3.40.350.10:FF:000105', NULL, NULL, 'Xaa-Pro aminopeptidase 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(47311, NULL, 'G3DSA:2.60.40.10:FF:002345', NULL, NULL, 'FMS related tyrosine kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(47312, NULL, 'G3DSA:3.30.1370.100:FF:000002', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(47313, NULL, 'G3DSA:1.25.40.10:FF:001383', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(47314, NULL, 'G3DSA:1.10.238.10:FF:000623', NULL, NULL, 'Putative calmodulin-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(47315, NULL, 'G3DSA:1.20.1250.20:FF:000730', NULL, NULL, 'Protein CBG05932', NULL, NULL, NULL, NULL, NULL, 4),
(47316, NULL, 'G3DSA:3.30.70.980:FF:000009', NULL, NULL, 'Putative transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(47317, NULL, 'G3DSA:1.10.510.10:FF:001083', NULL, NULL, 'Probable peptidoglycan biosynthesis protein MviN', NULL, NULL, NULL, NULL, NULL, 4),
(47318, NULL, 'G3DSA:2.60.40.10:FF:004031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47319, NULL, 'G3DSA:1.10.555.10:FF:000180', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47320, NULL, 'G3DSA:3.40.50.300:FF:007415', NULL, NULL, 'ATP binding cassette subfamily B member 1', NULL, NULL, NULL, NULL, NULL, 4),
(47321, NULL, 'G3DSA:1.25.40.20:FF:001638', NULL, NULL, 'Protein 21.1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47322, NULL, 'G3DSA:3.30.160.60:FF:000349', NULL, NULL, 'metal regulatory transcription factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(47323, NULL, 'G3DSA:1.10.1520.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47324, NULL, 'G3DSA:1.10.238.10:FF:000314', NULL, NULL, 'Reticulocalbin 1', NULL, NULL, NULL, NULL, NULL, 4),
(47325, NULL, 'G3DSA:2.130.10.10:FF:004155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47326, NULL, 'G3DSA:3.30.160.60:FF:004503', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47327, NULL, 'G3DSA:3.30.1330.20:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47328, NULL, 'G3DSA:1.25.10.10:FF:003236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47329, NULL, 'G3DSA:3.40.50.300:FF:002036', NULL, NULL, 'ATP-dependent rRNA helicase SPB4', NULL, NULL, NULL, NULL, NULL, 4),
(47330, NULL, 'G3DSA:3.30.70.960:FF:000003', NULL, NULL, 'MUC16 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(47331, NULL, 'G3DSA:3.30.1370.120:FF:000008', NULL, NULL, 'Type III secretion outer membrane pore YscC', NULL, NULL, NULL, NULL, NULL, 4),
(47332, NULL, 'G3DSA:2.10.25.10:FF:000619', NULL, NULL, 'Brevican core protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(47333, NULL, 'G3DSA:3.10.20.90:FF:000552', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47334, NULL, 'G3DSA:3.40.630.30:FF:000583', NULL, NULL, 'MGC78821 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47335, NULL, 'G3DSA:1.25.10.10:FF:000510', NULL, NULL, 'V-type proton ATPase subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(47336, NULL, 'G3DSA:3.50.30.30:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47337, NULL, 'G3DSA:1.10.10.60:FF:000092', NULL, NULL, 'Trihelix transcription factor GT-2', NULL, NULL, NULL, NULL, NULL, 4),
(47338, NULL, 'G3DSA:1.25.40.10:FF:001956', NULL, NULL, 'GD21390', NULL, NULL, NULL, NULL, NULL, 4),
(47339, NULL, 'G3DSA:1.10.3470.10:FF:000010', NULL, NULL, 'Branched-chain amino acid ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(47340, NULL, 'G3DSA:3.50.50.60:FF:000846', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47341, NULL, 'G3DSA:1.20.58.60:FF:000246', NULL, NULL, 'Dystrophin', NULL, NULL, NULL, NULL, NULL, 4),
(47342, NULL, 'G3DSA:3.90.1170.50:FF:000001', NULL, NULL, 'Aldehyde oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(47343, NULL, 'G3DSA:2.10.25.10:FF:000182', NULL, NULL, 'Protransforming growth factor alpha', NULL, NULL, NULL, NULL, NULL, 4),
(47344, NULL, 'G3DSA:3.30.70.330:FF:003069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47345, NULL, 'G3DSA:3.20.20.140:FF:000345', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47346, NULL, 'G3DSA:1.10.3450.30:FF:000003', NULL, NULL, 'UPF0536 protein', NULL, NULL, NULL, NULL, NULL, 4),
(47347, NULL, 'G3DSA:3.40.140.10:FF:000275', NULL, NULL, 'Cytidine/deoxycytidylate deaminase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(47348, NULL, 'G3DSA:1.25.10.10:FF:000403', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(47349, NULL, 'G3DSA:3.90.550.10:FF:000183', NULL, NULL, 'isoprenoid synthase domain-containing protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(47350, NULL, 'G3DSA:3.40.30.10:FF:000055', NULL, NULL, 'Glutathione S-transferase YfcF', NULL, NULL, NULL, NULL, NULL, 4),
(47351, NULL, 'G3DSA:2.40.10.240:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47352, NULL, 'G3DSA:2.70.130.10:FF:000064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47353, NULL, 'G3DSA:1.20.58.60:FF:000774', NULL, NULL, 'Spectrin, beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(47354, NULL, 'G3DSA:1.20.140.150:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47355, NULL, 'G3DSA:3.40.50.410:FF:000068', NULL, NULL, 'ATP-dependent DNA helicase 2 subunit KU70', NULL, NULL, NULL, NULL, NULL, 4),
(47356, NULL, 'G3DSA:3.20.80.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47357, NULL, 'G3DSA:3.60.20.40:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47358, NULL, 'G3DSA:2.40.180.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47359, NULL, 'G3DSA:3.40.50.300:FF:007281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47360, NULL, 'G3DSA:1.25.40.10:FF:001517', NULL, NULL, 'Tonsoku-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(47361, NULL, 'G3DSA:3.40.1080.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47362, NULL, 'G3DSA:1.10.20.10:FF:000156', NULL, NULL, 'Centromere protein S', NULL, NULL, NULL, NULL, NULL, 4),
(47363, NULL, 'G3DSA:2.20.110.10:FF:000074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47364, NULL, 'G3DSA:3.40.50.300:FF:000513', NULL, NULL, 'ras-related protein Rab-28 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(47365, NULL, 'G3DSA:2.60.40.10:FF:004407', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47366, NULL, 'G3DSA:1.25.40.10:FF:002029', NULL, NULL, 'Pentatricopeptide repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(47367, NULL, 'G3DSA:2.40.50.140:FF:000749', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(47368, NULL, 'G3DSA:3.10.580.10:FF:000056', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(47369, NULL, 'G3DSA:1.20.120.980:FF:000031', NULL, NULL, 'Dipeptidyl peptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(47370, NULL, 'G3DSA:1.10.10.880:FF:000002', NULL, NULL, 'Sigma factor AlgU regulatory protein MucA', NULL, NULL, NULL, NULL, NULL, 4),
(47371, NULL, 'G3DSA:3.40.50.720:FF:001701', NULL, NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase family', NULL, NULL, NULL, NULL, NULL, 4),
(47372, NULL, 'G3DSA:3.30.230.130:FF:000010', NULL, NULL, 'Anaphase-promoting complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(47373, NULL, 'G3DSA:3.10.20.600:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47374, NULL, 'G3DSA:1.20.900.10:FF:000093', NULL, NULL, 'ECT2 (Mammalian Rho GEF) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(47375, NULL, 'G3DSA:1.10.510.10:FF:003746', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47376, NULL, 'G3DSA:2.40.20.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47377, NULL, 'G3DSA:1.20.120.150:FF:000001', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(47378, NULL, 'G3DSA:1.20.120.350:FF:000089', NULL, NULL, 'Four domain-type voltage-gated ion channel alpha-1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(47379, NULL, 'G3DSA:3.40.50.10330:FF:000052', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(47380, NULL, 'G3DSA:1.10.510.10:FF:003218', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47381, NULL, 'G3DSA:1.20.1070.10:FF:000409', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47382, NULL, 'G3DSA:2.60.40.10:FF:003098', NULL, NULL, 'Hemicentin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47383, NULL, 'G3DSA:3.30.200.20:FF:002421', NULL, NULL, 'Protein ver-2', NULL, NULL, NULL, NULL, NULL, 4),
(47384, NULL, 'G3DSA:1.50.40.10:FF:000127', NULL, NULL, 'MC family mitochondrial carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(47385, NULL, 'G3DSA:3.40.50.300:FF:000018', NULL, NULL, 'Cell division control 48', NULL, NULL, NULL, NULL, NULL, 4),
(47386, NULL, 'G3DSA:3.30.160.60:FF:003654', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47387, NULL, 'G3DSA:3.40.50.10190:FF:000302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47388, NULL, 'G3DSA:1.10.472.10:FF:000577', NULL, NULL, 'Cyclin, N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(47389, NULL, 'G3DSA:1.10.8.270:FF:000074', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(47390, NULL, 'G3DSA:3.40.309.10:FF:000021', NULL, NULL, 'Aldehyde dehydrogenase family 8 member A1', NULL, NULL, NULL, NULL, NULL, 4),
(47391, NULL, 'G3DSA:3.40.50.1460:FF:000062', NULL, NULL, 'GPI-anchor transamidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47392, NULL, 'G3DSA:1.20.58.830:FF:000043', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(47393, NULL, 'G3DSA:1.10.10.10:FF:001712', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(47394, NULL, 'G3DSA:3.90.260.10:FF:000003', NULL, NULL, 'XPC complex subunit, DNA damage recognition and repair factor', NULL, NULL, NULL, NULL, NULL, 4),
(47395, NULL, 'G3DSA:1.20.1270.280:FF:000001', NULL, NULL, 'dynein heavy chain 7, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(47396, NULL, 'G3DSA:1.20.58.70:FF:000092', NULL, NULL, 'Putative snare protein syntaxin 1', NULL, NULL, NULL, NULL, NULL, 4),
(47397, NULL, 'G3DSA:2.40.70.10:FF:000127', NULL, NULL, 'Os04g0334700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(47398, NULL, 'G3DSA:3.40.50.720:FF:000392', NULL, NULL, '3-oxoacyl-[acyl-carrier protein] reductase', NULL, NULL, NULL, NULL, NULL, 4),
(47399, NULL, 'G3DSA:1.10.287.370:FF:000046', NULL, NULL, 'Prefoldin subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(47400, NULL, 'G3DSA:3.30.40.230:FF:000003', NULL, NULL, 'Glycine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(47401, NULL, 'G3DSA:3.40.30.10:FF:000494', NULL, NULL, 'Thiol-dependent reductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(47402, NULL, 'G3DSA:3.30.70.330:FF:000854', NULL, NULL, 'Putative RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(47403, NULL, 'G3DSA:3.30.2160.10:FF:000025', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(47404, NULL, 'G3DSA:2.60.40.10:FF:000664', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(47405, NULL, 'G3DSA:3.40.50.300:FF:004189', NULL, NULL, 'AGAP012081-PA', NULL, NULL, NULL, NULL, NULL, 4),
(47406, NULL, 'G3DSA:3.80.10.10:FF:002317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47407, NULL, 'G3DSA:1.25.40.10:FF:000231', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(47408, NULL, 'G3DSA:3.40.1160.10:FF:000062', NULL, NULL, 'Delta-1-pyrroline-5-carboxylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(47409, NULL, 'G3DSA:2.60.40.3710:FF:000002', NULL, NULL, 'Putative lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(47410, NULL, 'G3DSA:3.50.50.60:FF:001465', NULL, NULL, 'Probable lysine-specific histone demethylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(47411, NULL, 'G3DSA:3.40.50.150:FF:001249', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47412, NULL, 'G3DSA:3.40.50.2000:FF:001090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47413, NULL, 'G3DSA:1.25.40.990:FF:000014', NULL, NULL, '26S proteasome regulatory subunit RPN12, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47414, NULL, 'G3DSA:1.10.150.460:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47415, NULL, 'G3DSA:3.90.1200.10:FF:000049', NULL, NULL, 'GD20644', NULL, NULL, NULL, NULL, NULL, 4),
(47416, NULL, 'G3DSA:1.20.58.70:FF:000103', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(47417, NULL, 'G3DSA:1.20.5.190:FF:000126', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47418, NULL, 'G3DSA:3.40.50.300:FF:003256', NULL, NULL, 'Replication factor C, subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(47419, NULL, 'G3DSA:2.130.10.10:FF:000440', NULL, NULL, 'Bromodomain and WD repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(47420, NULL, 'G3DSA:3.40.50.1820:FF:001378', NULL, NULL, 'Feruloyl esterase C', NULL, NULL, NULL, NULL, NULL, 4),
(47421, NULL, 'G3DSA:1.20.120.1080:FF:000062', NULL, NULL, 'ATP-dependent helicase HrpB', NULL, NULL, NULL, NULL, NULL, 4),
(47422, NULL, 'G3DSA:4.10.410.20:FF:000004', NULL, NULL, 'ectonucleotide pyrophosphatase/phosphodiesterase family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(47423, NULL, 'G3DSA:2.30.29.30:FF:000791', NULL, NULL, 'Src kinase-associated phosphoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(47424, NULL, 'G3DSA:3.90.70.10:FF:000426', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47425, NULL, 'G3DSA:1.10.238.10:FF:001011', NULL, NULL, 'UBA domain-containing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(47426, NULL, 'G3DSA:1.20.1110.10:FF:000127', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47427, NULL, 'G3DSA:2.60.40.10:FF:000355', NULL, NULL, 'Leucine-rich repeat neuronal protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(47428, NULL, 'G3DSA:2.130.10.130:FF:000020', NULL, NULL, 'Glycosylphosphatidylinositol specific phospholipase D1', NULL, NULL, NULL, NULL, NULL, 4),
(47429, NULL, 'G3DSA:1.10.357.30:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47430, NULL, 'G3DSA:2.40.30.10:FF:000344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47431, NULL, 'G3DSA:3.90.190.10:FF:000576', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47432, NULL, 'G3DSA:3.20.20.70:FF:000803', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47433, NULL, 'G3DSA:3.30.230.40:FF:000006', NULL, NULL, 'Imidazoleglycerol-phosphate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(47434, NULL, 'G3DSA:3.40.710.10:FF:000184', NULL, NULL, 'Penicillin-sensitive carboxypeptidase A', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(47435, NULL, 'G3DSA:3.30.70.2190:FF:000002', NULL, NULL, 'FAD-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(47436, NULL, 'G3DSA:2.10.90.10:FF:000017', NULL, NULL, 'Platelet derived growth factor subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(47437, NULL, 'G3DSA:3.30.160.60:FF:004475', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47438, NULL, 'G3DSA:2.10.220.10:FF:000157', NULL, NULL, 'High cysteine membrane protein Group 5', NULL, NULL, NULL, NULL, NULL, 4),
(47439, NULL, 'G3DSA:3.30.160.60:FF:003963', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47440, NULL, 'G3DSA:1.20.920.10:FF:000004', NULL, NULL, 'probable global transcription activator SNF2L2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(47441, NULL, 'G3DSA:3.30.70.260:FF:000018', NULL, NULL, 'Ribose-5-phosphate isomerase A', NULL, NULL, NULL, NULL, NULL, 4),
(47442, NULL, 'G3DSA:1.20.5.110:FF:000029', NULL, NULL, 'Syntaxin-binding protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(47443, NULL, 'G3DSA:3.90.1150.10:FF:000241', NULL, NULL, 'Transcriptional regulator, GntR family', NULL, NULL, NULL, NULL, NULL, 4),
(47444, NULL, 'G3DSA:1.20.1560.10:FF:000812', NULL, NULL, 'Sulfonylurea receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47445, NULL, 'G3DSA:2.60.40.10:FF:005026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47446, NULL, 'G3DSA:1.25.10.10:FF:001819', NULL, NULL, 'MMS19 nucleotide excision repair protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(47447, NULL, 'G3DSA:2.60.40.10:FF:004514', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47448, NULL, 'G3DSA:4.10.410.10:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47449, NULL, 'G3DSA:3.80.10.10:FF:002952', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47450, NULL, 'G3DSA:1.10.20.10:FF:000049', NULL, NULL, 'Nuclear transcription factor Y subunit B-6', NULL, NULL, NULL, NULL, NULL, 4),
(47451, NULL, 'G3DSA:3.10.120.10:FF:000011', NULL, NULL, 'Fatty acid 2-hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(47452, NULL, 'G3DSA:3.30.420.10:FF:000602', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47453, NULL, 'G3DSA:2.60.120.10:FF:000644', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(47454, NULL, 'G3DSA:2.10.25.10:FF:001710', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47455, NULL, 'G3DSA:3.40.50.300:FF:006662', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47456, NULL, 'G3DSA:1.25.40.10:FF:002136', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(47457, NULL, 'G3DSA:1.20.140.100:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47458, NULL, 'G3DSA:3.20.20.100:FF:000120', NULL, NULL, 'Glutamate--cysteine ligase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(47459, NULL, 'G3DSA:2.60.120.820:FF:000001', NULL, NULL, 'BTB/POZ domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(47460, NULL, 'G3DSA:3.50.20.20:FF:000001', NULL, NULL, '14 kDa phosphohistidine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(47461, NULL, 'G3DSA:2.130.10.10:FF:000788', NULL, NULL, 'mRNA cleavage and polyadenylation factor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(47462, NULL, 'G3DSA:3.40.50.2020:FF:000168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47463, NULL, 'G3DSA:1.10.10.60:FF:000777', NULL, NULL, 'Homeobox protein dsc-1', NULL, NULL, NULL, NULL, NULL, 4),
(47464, NULL, 'G3DSA:3.30.2300.10:FF:000014', NULL, NULL, 'THUMP domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(47465, NULL, 'G3DSA:3.30.1330.30:FF:000027', NULL, NULL, 'H/ACA ribonucleoprotein complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(47466, NULL, 'G3DSA:1.10.287.130:FF:000098', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(47467, NULL, 'G3DSA:3.40.50.2000:FF:000847', NULL, NULL, 'Zeaxanthin glucosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(47468, NULL, 'G3DSA:3.30.200.20:FF:002056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(47469, NULL, 'G3DSA:3.50.50.60:FF:000161', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(47470, NULL, 'G3DSA:3.90.70.10:FF:000050', NULL, NULL, 'Cathepsin F', NULL, NULL, NULL, NULL, NULL, 4),
(47471, NULL, 'G3DSA:2.10.90.10:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47472, NULL, 'G3DSA:2.10.50.10:FF:000015', NULL, NULL, 'TNF receptor superfamily member 11a', NULL, NULL, NULL, NULL, NULL, 4),
(47473, NULL, 'G3DSA:2.30.29.30:FF:000139', NULL, NULL, 'ADP-ribosylation factor GTPase-activating protein AGD3', NULL, NULL, NULL, NULL, NULL, 4),
(47474, NULL, 'G3DSA:3.30.420.10:FF:000597', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47475, NULL, 'G3DSA:1.20.1250.20:FF:002276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47476, NULL, 'G3DSA:3.40.630.30:FF:000509', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47477, NULL, 'G3DSA:3.30.420.40:FF:000145', NULL, NULL, 'Xylulose kinase', NULL, NULL, NULL, NULL, NULL, 4),
(47478, NULL, 'G3DSA:1.10.3730.20:FF:000039', NULL, NULL, 'Purine permease-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(47479, NULL, 'G3DSA:1.25.40.590:FF:000001', NULL, NULL, 'DotU family type IV/VI secretion system protein', NULL, NULL, NULL, NULL, NULL, 4),
(47480, NULL, 'G3DSA:3.40.50.300:FF:006134', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(47481, NULL, 'G3DSA:3.30.60.30:FF:000193', NULL, NULL, 'Vasotab', NULL, NULL, NULL, NULL, NULL, 4),
(47482, NULL, 'G3DSA:3.30.390.30:FF:000026', NULL, NULL, 'Irc15p', NULL, NULL, NULL, NULL, NULL, 4),
(47483, NULL, 'G3DSA:2.100.10.30:FF:000014', NULL, NULL, 'Putative zinc metalloproteinase C607.06c', NULL, NULL, NULL, NULL, NULL, 4),
(47484, NULL, 'G3DSA:3.60.40.10:FF:000173', NULL, NULL, 'Phosphatase 2C family protein', NULL, NULL, NULL, NULL, NULL, 4),
(47485, NULL, 'G3DSA:3.40.50.800:FF:000062', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(47486, NULL, 'G3DSA:1.10.510.10:FF:003437', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47487, NULL, 'G3DSA:2.170.270.10:FF:000038', NULL, NULL, 'Histone-lysine N-methyltransferase ATXR5', NULL, NULL, NULL, NULL, NULL, 4),
(47488, NULL, 'G3DSA:3.60.20.10:FF:000166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47489, NULL, 'G3DSA:3.30.460.10:FF:000178', NULL, NULL, 'PAP associated domain containing 5 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(47490, NULL, 'G3DSA:3.40.50.1000:FF:000430', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47491, NULL, 'G3DSA:3.50.50.60:FF:000537', NULL, NULL, 'WGS project CABT00000000 data, contig 2.2', NULL, NULL, NULL, NULL, NULL, 4),
(47492, NULL, 'G3DSA:3.40.50.300:FF:002391', NULL, NULL, 'Ras family protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(47493, NULL, 'G3DSA:1.20.1720.10:FF:000038', NULL, NULL, 'Major facilitator superfamily MFS_1', NULL, NULL, NULL, NULL, NULL, 4),
(47494, NULL, 'G3DSA:3.20.20.140:FF:000036', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(47495, NULL, 'G3DSA:3.60.21.10:FF:000129', NULL, NULL, 'DNA double-strand break repair protein Mre11', NULL, NULL, NULL, NULL, NULL, 4),
(47496, NULL, 'G3DSA:3.20.20.70:FF:000826', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47497, NULL, 'G3DSA:3.40.50.720:FF:001206', NULL, NULL, 'Molybdopterin biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(47498, NULL, 'G3DSA:3.30.160.60:FF:004166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47499, NULL, 'G3DSA:2.40.50.100:FF:000171', NULL, NULL, 'Sugar ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(47500, NULL, 'G3DSA:2.130.10.10:FF:005644', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47501, NULL, 'G3DSA:2.60.40.10:FF:002114', NULL, NULL, 'Twitchin', NULL, NULL, NULL, NULL, NULL, 4),
(47502, NULL, 'G3DSA:4.10.1230.10:FF:000001', NULL, NULL, 'Ecotin', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(47503, NULL, 'G3DSA:3.90.70.10:FF:000207', NULL, NULL, 'Putative cysteine proteinase', NULL, NULL, NULL, NULL, NULL, 4),
(47504, NULL, 'G3DSA:3.30.70.330:FF:002304', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47505, NULL, 'G3DSA:3.40.50.1100:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47506, NULL, 'G3DSA:1.10.287.700:FF:000005', NULL, NULL, 'Plant Late Embryo Abundant (LEA) related', NULL, NULL, NULL, NULL, NULL, 4),
(47507, NULL, 'G3DSA:3.40.630.10:FF:000503', NULL, NULL, 'Peptidase M28', NULL, NULL, NULL, NULL, NULL, 4),
(47508, NULL, 'G3DSA:3.30.420.10:FF:000288', NULL, NULL, 'Putative DNA polymerase III, epsilon subunit', NULL, NULL, NULL, NULL, NULL, 4),
(47509, NULL, 'G3DSA:3.40.50.920:FF:000013', NULL, NULL, 'Ferredoxin oxidoreductase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(47510, NULL, 'G3DSA:2.70.170.10:FF:000173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47511, NULL, 'G3DSA:1.20.1270.10:FF:000037', NULL, NULL, 'Heat shock protein 110, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47512, NULL, 'G3DSA:3.30.70.850:FF:000009', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(47513, NULL, 'G3DSA:1.10.150.50:FF:000217', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(47514, NULL, 'G3DSA:3.40.50.720:FF:000717', NULL, NULL, 'Probable short-chain dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(47515, NULL, 'G3DSA:2.60.40.10:FF:001283', NULL, NULL, 'Carcinoembryonic antigen related cell adhesion molecule 16', NULL, NULL, NULL, NULL, NULL, 4),
(47516, NULL, 'G3DSA:3.90.660.10:FF:000084', NULL, NULL, 'lysine-specific histone demethylase 1B', NULL, NULL, NULL, NULL, NULL, 4),
(47517, NULL, 'G3DSA:1.10.287.660:FF:000026', NULL, NULL, 'Aquaporin SIP1-1', NULL, NULL, NULL, NULL, NULL, 4),
(47518, NULL, 'G3DSA:3.50.50.100:FF:000024', NULL, NULL, 'Apoptosis-inducing factor', NULL, NULL, NULL, NULL, NULL, 4),
(47519, NULL, 'G3DSA:3.40.390.10:FF:000097', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(47520, NULL, 'G3DSA:3.50.50.60:FF:001026', NULL, NULL, 'Peroxisomal N(1)-acetyl-spermine/spermidine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(47521, NULL, 'G3DSA:3.90.1750.20:FF:000008', NULL, NULL, 'DNA invertase', NULL, NULL, NULL, NULL, NULL, 4),
(47522, NULL, 'G3DSA:3.40.630.30:FF:000352', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(47523, NULL, 'G3DSA:3.30.160.60:FF:006420', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47524, NULL, 'G3DSA:3.30.390.10:FF:000020', NULL, NULL, '2-oxoglutarate decarboxylase/hydro-lyase/magnesium ion-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(47525, NULL, 'G3DSA:3.30.40.10:FF:002198', NULL, NULL, 'E3 ubiquitin-protein ligase WAVH1', NULL, NULL, NULL, NULL, NULL, 4),
(47526, NULL, 'G3DSA:3.30.470.20:FF:000209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47527, NULL, 'G3DSA:3.40.50.10240:FF:000025', NULL, NULL, 'Thiamine pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(47528, NULL, 'G3DSA:3.10.20.90:FF:000321', NULL, NULL, 'Ral GDS-Like', NULL, NULL, NULL, NULL, NULL, 4),
(47529, NULL, 'G3DSA:3.90.1460.10:FF:000006', NULL, NULL, 'General transcription factor II-I repeat domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(47530, NULL, 'G3DSA:3.10.180.10:FF:000003', NULL, NULL, 'Methylmalonyl-CoA epimerase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(47531, NULL, 'G3DSA:1.20.1060.10:FF:000010', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(47532, NULL, 'G3DSA:2.30.130.40:FF:000020', NULL, NULL, 'Lon protease', NULL, NULL, NULL, NULL, NULL, 4),
(47533, NULL, 'G3DSA:1.10.1380.10:FF:000008', NULL, NULL, 'Probable zinc metalloprotease', NULL, NULL, NULL, NULL, NULL, 4),
(47534, NULL, 'G3DSA:1.10.274.100:FF:000001', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(47535, NULL, 'G3DSA:2.40.320.10:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(47536, NULL, 'G3DSA:2.130.10.10:FF:002238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47537, NULL, 'G3DSA:3.80.10.10:FF:000974', NULL, NULL, 'NACHT, LRR and PYD domains-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(47538, NULL, 'G3DSA:2.30.29.30:FF:000010', NULL, NULL, 'dynamin-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(47539, NULL, 'G3DSA:2.10.220.10:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47540, NULL, 'G3DSA:1.20.5.1430:FF:000024', NULL, NULL, 'MIP05284p', NULL, NULL, NULL, NULL, NULL, 4),
(47541, NULL, 'G3DSA:2.80.10.50:FF:000117', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(47542, NULL, 'G3DSA:3.40.30.10:FF:000185', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(47543, NULL, 'G3DSA:1.10.287.370:FF:000041', NULL, NULL, 'Prefoldin, alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47544, NULL, 'G3DSA:1.20.1250.20:FF:001011', NULL, NULL, 'SLC (SoLute Carrier) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(47545, NULL, 'G3DSA:1.25.40.20:FF:001829', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(47546, NULL, 'G3DSA:3.40.50.300:FF:000822', NULL, NULL, 'Shikimate kinase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(47547, NULL, 'G3DSA:1.25.40.20:FF:001493', NULL, NULL, 'Ankyrin repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(47548, NULL, 'G3DSA:2.40.33.10:FF:000025', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(47549, NULL, 'G3DSA:2.170.120.30:FF:000005', NULL, NULL, 'CdaA regulatory protein CdaR', NULL, NULL, NULL, NULL, NULL, 4),
(47550, NULL, 'G3DSA:1.10.287.110:FF:000103', NULL, NULL, 'DnaJ subfamily B member', NULL, NULL, NULL, NULL, NULL, 4),
(47551, NULL, 'G3DSA:1.10.510.10:FF:004146', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47552, NULL, 'G3DSA:1.10.287.110:FF:000339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47553, NULL, 'G3DSA:1.20.58.530:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47554, NULL, 'G3DSA:3.30.200.20:FF:001932', NULL, NULL, 'Os07g0534100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(47555, NULL, 'G3DSA:3.40.50.1820:FF:000996', NULL, NULL, 'Sn1-specific diacylglycerol lipase beta', NULL, NULL, NULL, NULL, NULL, 4),
(47556, NULL, 'G3DSA:3.90.70.10:FF:000735', NULL, NULL, 'Ubiquitin-specific peptidase 19', NULL, NULL, NULL, NULL, NULL, 4),
(47557, NULL, 'G3DSA:3.40.50.300:FF:008112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47558, NULL, 'G3DSA:3.50.50.60:FF:001482', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47559, NULL, 'G3DSA:2.60.40.10:FF:002244', NULL, NULL, 'CBN-TWK-30 protein', NULL, NULL, NULL, NULL, NULL, 4),
(47560, NULL, 'G3DSA:1.20.58.60:FF:000791', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47561, NULL, 'G3DSA:1.10.287.130:FF:000109', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(47562, NULL, 'G3DSA:1.20.80.10:FF:000047', NULL, NULL, 'Tyrosine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(47563, NULL, 'G3DSA:1.25.40.10:FF:000214', NULL, NULL, 'MAU2 chromatid cohesion factor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(47564, NULL, 'G3DSA:3.40.47.10:FF:000234', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47565, NULL, 'G3DSA:3.40.50.300:FF:000474', NULL, NULL, 'Putative ABC transporter ATP-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(47566, NULL, 'G3DSA:3.30.200.20:FF:001437', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47567, NULL, 'G3DSA:1.10.510.10:FF:003876', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47568, NULL, 'G3DSA:2.60.120.200:FF:000523', NULL, NULL, 'Novel protein similar to vertebrate pentaxin-related', NULL, NULL, NULL, NULL, NULL, 4),
(47569, NULL, 'G3DSA:3.30.70.920:FF:000025', NULL, NULL, 'Transcriptional regulator AsnC family', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(47570, NULL, 'G3DSA:2.130.10.10:FF:000423', NULL, NULL, 'YncE family protein', NULL, NULL, NULL, NULL, NULL, 4),
(47571, NULL, 'G3DSA:1.10.10.10:FF:001392', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(47572, NULL, 'G3DSA:1.10.150.50:FF:000234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47573, NULL, 'G3DSA:1.25.10.10:FF:000038', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(47574, NULL, 'G3DSA:1.20.58.60:FF:000555', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(47575, NULL, 'G3DSA:1.10.10.10:FF:001639', NULL, NULL, 'Ferric uptake regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47576, NULL, 'G3DSA:1.10.287.10:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47577, NULL, 'G3DSA:2.130.10.30:FF:000182', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47578, NULL, 'G3DSA:3.40.50.300:FF:004745', NULL, NULL, 'Smarca5 protein', NULL, NULL, NULL, NULL, NULL, 4),
(47579, NULL, 'G3DSA:1.25.40.10:FF:001647', NULL, NULL, 'Os03g0369700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(47580, NULL, 'G3DSA:1.25.40.10:FF:003434', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(47581, NULL, 'G3DSA:3.40.50.200:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47582, NULL, 'G3DSA:2.40.240.10:FF:000005', NULL, NULL, 'Bifunctional glutamate/proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(47583, NULL, 'G3DSA:2.40.50.140:FF:001149', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47584, NULL, 'G3DSA:2.70.170.10:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47585, NULL, 'G3DSA:3.50.20.20:FF:000006', NULL, NULL, 'Putative secreted protein', NULL, NULL, NULL, NULL, NULL, 4),
(47586, NULL, 'G3DSA:3.40.50.300:FF:005364', NULL, NULL, 'Structural maintenance of chromosomes protein', NULL, NULL, NULL, NULL, NULL, 4),
(47587, NULL, 'G3DSA:3.40.220.10:FF:000023', NULL, NULL, 'ADP-ribose 1''''-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(47588, NULL, 'G3DSA:1.25.40.10:FF:004053', NULL, NULL, 'Extra spindle pole bodies like 1, separase', NULL, NULL, NULL, NULL, NULL, 4),
(47589, NULL, 'G3DSA:1.10.1200.10:FF:000069', NULL, NULL, 'Yersiniabactin polyketide/non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(47590, NULL, 'G3DSA:1.10.620.20:FF:000003', NULL, NULL, 'Ribonucleoside-diphosphate reductase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(47591, NULL, 'G3DSA:1.10.3720.10:FF:000120', NULL, NULL, 'Iron(III) ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(47592, NULL, 'G3DSA:3.10.20.310:FF:000045', NULL, NULL, 'Outer membrane protein Omp85 family', NULL, NULL, NULL, NULL, NULL, 4),
(47593, NULL, 'G3DSA:2.170.300.10:FF:000019', NULL, NULL, 'Platelet endothelial aggregation receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(47594, NULL, 'G3DSA:3.50.30.30:FF:000072', NULL, NULL, 'RING finger protein 150', NULL, NULL, NULL, NULL, NULL, 4),
(47595, NULL, 'G3DSA:3.40.50.10950:FF:000002', NULL, NULL, 'NADP-dependent malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(47596, NULL, 'G3DSA:3.40.50.800:FF:000090', NULL, NULL, 'Proline--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(47597, NULL, 'G3DSA:1.20.1250.40:FF:000022', NULL, NULL, 'DNA-directed RNA polymerase III subunit rpc9', NULL, NULL, NULL, NULL, NULL, 4),
(47598, NULL, 'G3DSA:2.40.50.90:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47599, NULL, 'G3DSA:1.10.287.70:FF:000501', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47600, NULL, 'G3DSA:3.40.50.1820:FF:000889', NULL, NULL, 'Triacylglycerol lipase', NULL, NULL, NULL, NULL, NULL, 4),
(47601, NULL, 'G3DSA:3.30.565.10:FF:000308', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(47602, NULL, 'G3DSA:2.60.120.10:FF:000088', NULL, NULL, 'Guanine nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(47603, NULL, 'G3DSA:3.30.70.270:FF:000156', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47604, NULL, 'G3DSA:1.20.1250.20:FF:001348', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47605, NULL, 'G3DSA:1.20.5.110:FF:000046', NULL, NULL, 'syntaxin-17 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(47606, NULL, 'G3DSA:2.30.30.140:FF:000130', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(47607, NULL, 'G3DSA:3.90.1530.30:FF:000001', NULL, NULL, 'Chromosome partitioning protein ParB', NULL, NULL, NULL, NULL, NULL, 4),
(47608, NULL, 'G3DSA:2.130.10.10:FF:004346', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47609, NULL, 'G3DSA:2.60.260.20:FF:000016', NULL, NULL, 'DnaJ (Hsp40) homolog, subfamily A, member 2', NULL, NULL, NULL, NULL, NULL, 4),
(47610, NULL, 'G3DSA:2.10.25.10:FF:000165', NULL, NULL, 'FAT atypical cadherin 3', NULL, NULL, NULL, NULL, NULL, 4),
(47611, NULL, 'G3DSA:2.160.10.10:FF:000045', NULL, NULL, 'Translation initiation factor eIF-2B subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(47612, NULL, 'G3DSA:1.10.150.850:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47613, NULL, 'G3DSA:2.130.10.10:FF:003166', NULL, NULL, 'Periodic tryptophan protein 2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(47614, NULL, 'G3DSA:1.20.58.1610:FF:000011', NULL, NULL, 'NADH-quinone oxidoreductase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(47615, NULL, 'G3DSA:1.10.287.70:FF:000153', NULL, NULL, 'High-affinity cell membrane calcium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(47616, NULL, 'G3DSA:3.30.230.40:FF:000001', NULL, NULL, 'Imidazoleglycerol-phosphate dehydratase HisB', NULL, NULL, NULL, NULL, NULL, 4),
(47617, NULL, 'G3DSA:4.10.400.10:FF:000282', NULL, NULL, 'Low-density lipoprotein RecePtor related', NULL, NULL, NULL, NULL, NULL, 4),
(47618, NULL, 'G3DSA:1.10.10.2670:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47619, NULL, 'G3DSA:1.25.10.10:FF:002511', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47620, NULL, 'G3DSA:2.20.25.10:FF:000097', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(47621, NULL, 'G3DSA:1.10.10.250:FF:000004', NULL, NULL, '39S ribosomal protein L11, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(47622, NULL, 'G3DSA:3.40.50.1820:FF:001069', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(47623, NULL, 'G3DSA:3.40.109.10:FF:000040', NULL, NULL, 'Albonoursin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(47624, NULL, 'G3DSA:3.30.70.240:FF:000012', NULL, NULL, 'Elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(47625, NULL, 'G3DSA:3.30.160.60:FF:005919', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47626, NULL, 'G3DSA:3.20.20.10:FF:000067', NULL, NULL, 'D-threo-3-hydroxyaspartate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(47627, NULL, 'G3DSA:1.10.287.1490:FF:000052', NULL, NULL, 'Phosphatidylinositol 3-kinase regulatory subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(47628, NULL, 'G3DSA:3.60.15.10:FF:000188', NULL, NULL, 'Prostate cancer susceptibility protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(47629, NULL, 'G3DSA:2.30.130.40:FF:000025', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(47630, NULL, 'G3DSA:3.10.110.10:FF:000162', NULL, NULL, 'Calmodulin-binding transcription activator 2', NULL, NULL, NULL, NULL, NULL, 4),
(47631, NULL, 'G3DSA:1.25.40.10:FF:000686', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(47632, NULL, 'G3DSA:3.90.470.20:FF:000022', NULL, NULL, 'L-aminoadipate-semialdehyde dehydrogenase-phosphopantetheinyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(47633, NULL, 'G3DSA:1.20.1270.60:FF:000277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47634, NULL, 'G3DSA:3.40.50.1260:FF:000030', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(47635, NULL, 'G3DSA:1.10.486.10:FF:000047', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(47636, NULL, 'G3DSA:1.10.340.30:FF:000041', NULL, NULL, 'N-glycosylase/DNA lyase', NULL, NULL, NULL, NULL, NULL, 4),
(47637, NULL, 'G3DSA:2.30.30.40:FF:000393', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(47638, NULL, 'G3DSA:1.10.287.70:FF:000462', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47639, NULL, 'G3DSA:3.30.590.10:FF:000024', NULL, NULL, 'Glutamine synthetase catalytic region', NULL, NULL, NULL, NULL, NULL, 4),
(47640, NULL, 'G3DSA:1.10.238.10:FF:000522', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47641, NULL, 'G3DSA:3.30.40.10:FF:001017', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(47642, NULL, 'G3DSA:1.10.1040.10:FF:000067', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(47643, NULL, 'G3DSA:1.20.1250.20:FF:000819', NULL, NULL, 'General substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(47644, NULL, 'G3DSA:3.30.420.100:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47645, NULL, 'G3DSA:1.10.1200.10:FF:000041', NULL, NULL, 'Acyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(47646, NULL, 'G3DSA:3.10.50.40:FF:000090', NULL, NULL, 'MIP25048p', NULL, NULL, NULL, NULL, NULL, 4),
(47647, NULL, 'G3DSA:3.80.10.10:FF:004318', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47648, NULL, 'G3DSA:1.20.1250.20:FF:000483', NULL, NULL, 'Related to allantoate permease', NULL, NULL, NULL, NULL, NULL, 4),
(47649, NULL, 'G3DSA:6.10.300.40:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47650, NULL, 'G3DSA:2.130.10.10:FF:003727', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47651, NULL, 'G3DSA:3.40.50.300:FF:004184', NULL, NULL, 'ATP-binding cassette, sub-family B (MDR/TAP), member 10', NULL, NULL, NULL, NULL, NULL, 4),
(47652, NULL, 'G3DSA:2.60.40.2020:FF:000001', NULL, NULL, 'Inhibitor of cysteine proteases', NULL, NULL, NULL, NULL, NULL, 4),
(47653, NULL, 'G3DSA:2.60.40.1090:FF:000014', NULL, NULL, 'Fimbrial family protein', NULL, NULL, NULL, NULL, NULL, 4),
(47654, NULL, 'G3DSA:3.30.540.10:FF:000105', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(47655, NULL, 'G3DSA:2.30.110.10:FF:000066', NULL, NULL, 'Flavin oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(47656, NULL, 'G3DSA:3.30.70.940:FF:000020', NULL, NULL, 'Transcription termination/antitermination protein NusG', NULL, NULL, NULL, NULL, NULL, 4),
(47657, NULL, 'G3DSA:3.75.10.10:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47658, NULL, 'G3DSA:2.80.10.50:FF:000089', NULL, NULL, 'Dolichyl-phosphate-mannose-protein mannosyltransferase 7', NULL, NULL, NULL, NULL, NULL, 4),
(47659, NULL, 'G3DSA:3.30.60.30:FF:000086', NULL, NULL, 'Enhancer of split m1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(47660, NULL, 'G3DSA:3.40.250.10:FF:000160', NULL, NULL, 'AaceriAFR296Cp', NULL, NULL, NULL, NULL, NULL, 4),
(47661, NULL, 'G3DSA:3.40.630.20:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47662, NULL, 'G3DSA:3.40.50.300:FF:004060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47663, NULL, 'G3DSA:3.30.160.60:FF:003547', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47664, NULL, 'G3DSA:3.30.420.80:FF:000033', NULL, NULL, '30S ribosomal protein S11', NULL, NULL, NULL, NULL, NULL, 4),
(47665, NULL, 'G3DSA:2.30.42.10:FF:000658', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47666, NULL, 'G3DSA:3.40.50.10190:FF:000297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47667, NULL, 'G3DSA:2.60.40.10:FF:003109', NULL, NULL, 'receptor-type tyrosine-protein phosphatase beta isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(47668, NULL, 'G3DSA:1.25.40.10:FF:004738', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(47669, NULL, 'G3DSA:3.30.365.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47670, NULL, 'G3DSA:1.10.510.10:FF:000094', NULL, NULL, 'MAP kinase-activated protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(47671, NULL, 'G3DSA:3.30.1600.10:FF:000020', NULL, NULL, 'Related to NAD-dependent histone deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(47672, NULL, 'G3DSA:3.40.50.1010:FF:000096', NULL, NULL, 'Exonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(47673, NULL, 'G3DSA:1.10.287.130:FF:000025', NULL, NULL, 'Histidine kinase 1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(47674, NULL, 'G3DSA:2.70.130.10:FF:000171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47675, NULL, 'G3DSA:3.40.50.150:FF:000316', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47676, NULL, 'G3DSA:3.40.50.300:FF:001002', NULL, NULL, 'Disease resistance protein (TIR-NBS-LRR class)', NULL, NULL, NULL, NULL, NULL, 4),
(47677, NULL, 'G3DSA:1.10.8.60:FF:000225', NULL, NULL, 'Os09g0560200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(47678, NULL, 'G3DSA:2.170.120.12:FF:000013', NULL, NULL, 'DNA-directed RNA polymerase II subunit RPB3', NULL, NULL, NULL, NULL, NULL, 4),
(47679, NULL, 'G3DSA:1.10.10.60:FF:000412', NULL, NULL, 'Anomalous homeobox', NULL, NULL, NULL, NULL, NULL, 4),
(47680, NULL, 'G3DSA:2.130.10.10:FF:004711', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(47681, NULL, 'G3DSA:3.30.70.330:FF:002776', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47682, NULL, 'G3DSA:1.10.533.10:FF:000264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47683, NULL, 'G3DSA:3.30.1410.10:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47684, NULL, 'G3DSA:3.40.50.300:FF:003239', NULL, NULL, 'Autoinducer 2 import ATP-binding protein LsrA', NULL, NULL, NULL, NULL, NULL, 4),
(47685, NULL, 'G3DSA:3.40.50.150:FF:000501', NULL, NULL, 'Ubiquinone biosynthesis O-methyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(47686, NULL, 'G3DSA:3.40.50.1820:FF:001041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47687, NULL, 'G3DSA:2.30.30.30:FF:000064', NULL, NULL, 'SPT5 homolog, DSIF elongation factor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(47688, NULL, 'G3DSA:2.60.40.10:FF:004037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47689, NULL, 'G3DSA:2.60.40.10:FF:003418', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47690, NULL, 'G3DSA:3.60.10.10:FF:000345', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47691, NULL, 'G3DSA:3.40.50.300:FF:004217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47692, NULL, 'G3DSA:1.20.1250.20:FF:001803', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47693, NULL, 'G3DSA:1.10.510.10:FF:004365', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47694, NULL, 'G3DSA:1.10.472.80:FF:000215', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47695, NULL, 'G3DSA:3.40.50.620:FF:000480', NULL, NULL, 'Asparagine synthase (Glutamine-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4),
(47696, NULL, 'G3DSA:3.90.105.20:FF:000005', NULL, NULL, 'Putative ribosome biogenesis protein MRT4', NULL, NULL, NULL, NULL, NULL, 4),
(47697, NULL, 'G3DSA:3.10.20.90:FF:000214', NULL, NULL, 'Serine/threonine-protein kinase STE11', NULL, NULL, NULL, NULL, NULL, 4),
(47698, NULL, 'G3DSA:2.120.10.80:FF:000360', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(47699, NULL, 'G3DSA:1.10.10.10:FF:001948', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47700, NULL, 'G3DSA:1.10.287.70:FF:000681', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47701, NULL, 'G3DSA:3.90.20.20:FF:000033', NULL, NULL, 'GrpE protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(47702, NULL, 'G3DSA:3.40.50.1000:FF:000778', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(47703, NULL, 'G3DSA:3.30.160.60:FF:004582', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47704, NULL, 'G3DSA:1.10.287.110:FF:000356', NULL, NULL, 'HSP40/DnaJ peptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(47705, NULL, 'G3DSA:3.50.50.60:FF:000953', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(47706, NULL, 'G3DSA:2.130.10.10:FF:005330', NULL, NULL, 'POC1 centriolar protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(47707, NULL, 'G3DSA:2.60.260.20:FF:000090', NULL, NULL, 'DnaJ heat shock protein family (Hsp40) member A3', NULL, NULL, NULL, NULL, NULL, 4),
(47708, NULL, 'G3DSA:3.30.160.60:FF:004958', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47709, NULL, 'G3DSA:3.40.30.10:FF:000038', NULL, NULL, 'Predicted glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(47710, NULL, 'G3DSA:3.30.750.24:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47711, NULL, 'G3DSA:1.10.287.1490:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47712, NULL, 'G3DSA:3.90.76.10:FF:000001', NULL, NULL, 'Oligopeptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(47713, NULL, 'G3DSA:1.10.472.10:FF:000105', NULL, NULL, 'cyclin-L2 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(47714, NULL, 'G3DSA:3.40.50.150:FF:001468', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47715, NULL, 'G3DSA:3.90.780.10:FF:000003', NULL, NULL, 'Protein UshA', NULL, NULL, NULL, NULL, NULL, 4),
(47716, NULL, 'G3DSA:3.40.1350.10:FF:000009', NULL, NULL, 'Fanconi-associated nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(47717, NULL, 'G3DSA:3.40.50.740:FF:000061', NULL, NULL, 'Thiosulfate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(47718, NULL, 'G3DSA:3.40.50.300:FF:008242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47719, NULL, 'G3DSA:2.130.10.10:FF:003385', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47720, NULL, 'G3DSA:3.40.50.10330:FF:000035', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(47721, NULL, 'G3DSA:3.10.450.50:FF:000053', NULL, NULL, 'Nuclear RNA export factor 7', NULL, NULL, NULL, NULL, NULL, 4),
(47722, NULL, 'G3DSA:1.10.287.690:FF:000024', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(47723, NULL, 'G3DSA:3.40.50.300:FF:000165', NULL, NULL, 'ADP-ribosylation factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(47724, NULL, 'G3DSA:3.90.70.10:FF:000090', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(47725, NULL, 'G3DSA:3.90.640.10:FF:000066', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(47726, NULL, 'G3DSA:2.10.25.10:FF:000957', NULL, NULL, 'Os10g0151100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(47727, NULL, 'G3DSA:3.40.630.30:FF:000245', NULL, NULL, 'Acetyltransferase, GNAT family', NULL, NULL, NULL, NULL, NULL, 4),
(47728, NULL, 'G3DSA:2.60.120.200:FF:000490', NULL, NULL, 'Tetanus toxin', NULL, NULL, NULL, NULL, NULL, 4),
(47729, NULL, 'G3DSA:3.10.400.20:FF:000013', NULL, NULL, 'Translation machinery-associated protein 20', NULL, NULL, NULL, NULL, NULL, 4),
(47730, NULL, 'G3DSA:2.130.10.10:FF:002896', NULL, NULL, 'U4/U6 small nuclear ribonucleoprotein Prp4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47731, NULL, 'G3DSA:2.130.10.10:FF:002441', NULL, NULL, 'Subunit of the mRNA cleavage and polyadenylation factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47732, NULL, 'G3DSA:3.40.50.300:FF:007078', NULL, NULL, 'Small GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47733, NULL, 'G3DSA:3.30.160.60:FF:005127', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47734, NULL, 'G3DSA:3.10.620.10:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47735, NULL, 'G3DSA:3.40.33.10:FF:000186', NULL, NULL, 'Os07g0127700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(47736, NULL, 'G3DSA:1.25.40.10:FF:001720', NULL, NULL, 'SGT1 homolog, MIS12 kinetochore complex assembly cochaperone', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(47737, NULL, 'G3DSA:2.60.40.1390:FF:000025', NULL, NULL, 'Transcriptional regulator PacG/VIB-1', NULL, NULL, NULL, NULL, NULL, 4),
(47738, NULL, 'G3DSA:2.30.29.150:FF:000007', NULL, NULL, 'Histone_chaperone_Rttp106-like_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(47739, NULL, 'G3DSA:1.20.58.60:FF:000010', NULL, NULL, 'plectin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(47740, NULL, 'G3DSA:2.30.30.140:FF:000113', NULL, NULL, 'SAGA-associated factor 29 protein', NULL, NULL, NULL, NULL, NULL, 4),
(47741, NULL, 'G3DSA:3.30.200.20:FF:000948', NULL, NULL, 'ATMKK3 MITOGEN-ACTIVATED kinase', NULL, NULL, NULL, NULL, NULL, 4),
(47742, NULL, 'G3DSA:3.30.565.10:FF:000191', NULL, NULL, 'Histidine kinase response regulator hybrid protein', NULL, NULL, NULL, NULL, NULL, 4),
(47743, NULL, 'G3DSA:3.30.40.10:FF:001725', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47744, NULL, 'G3DSA:1.10.357.70:FF:000018', NULL, NULL, 'Exocyst complex component 3 like 4', NULL, NULL, NULL, NULL, NULL, 4),
(47745, NULL, 'G3DSA:3.30.930.10:FF:000231', NULL, NULL, 'Serine/threonine-protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47746, NULL, 'G3DSA:1.25.40.820:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47747, NULL, 'G3DSA:4.10.400.10:FF:000051', NULL, NULL, 'Very low density lipoprotein receptor', NULL, NULL, NULL, NULL, NULL, 4),
(47748, NULL, 'G3DSA:2.10.25.10:FF:000530', NULL, NULL, 'Crumbs 2, cell polarity complex component', NULL, NULL, NULL, NULL, NULL, 4),
(47749, NULL, 'G3DSA:3.90.190.10:FF:000536', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47750, NULL, 'G3DSA:1.20.1250.20:FF:000859', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47751, NULL, 'G3DSA:3.30.160.60:FF:005655', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47752, NULL, 'G3DSA:2.60.40.420:FF:000248', NULL, NULL, 'Cytochrome c oxidase,ba3-type, subunit I, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47753, NULL, 'G3DSA:3.30.70.920:FF:000042', NULL, NULL, 'Transcriptional regulator, AsnC family', NULL, NULL, NULL, NULL, NULL, 4),
(47754, NULL, 'G3DSA:3.40.50.2020:FF:000140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47755, NULL, 'G3DSA:3.30.710.10:FF:000484', NULL, NULL, 'Potassium voltage-gated channel, Shab-related subfamily, member 2', NULL, NULL, NULL, NULL, NULL, 4),
(47756, NULL, 'G3DSA:3.20.20.80:FF:000846', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47757, NULL, 'G3DSA:2.30.42.10:FF:000097', NULL, NULL, 'PDZ domain-containing protein GIPC1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(47758, NULL, 'G3DSA:1.25.10.10:FF:002191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47759, NULL, 'G3DSA:1.25.40.20:FF:000088', NULL, NULL, 'short transient receptor potential channel 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(47760, NULL, 'G3DSA:3.80.10.10:FF:002992', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47761, NULL, 'G3DSA:3.30.710.10:FF:000012', NULL, NULL, 'Potassium voltage-gated channel subfamily A member 10', NULL, NULL, NULL, NULL, NULL, 4),
(47762, NULL, 'G3DSA:2.60.40.60:FF:000229', NULL, NULL, 'Cadherin 15', NULL, NULL, NULL, NULL, NULL, 4),
(47763, NULL, 'G3DSA:3.30.70.370:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47764, NULL, 'G3DSA:3.30.420.270:FF:000005', NULL, NULL, 'TonB system transport protein ExbD', NULL, NULL, NULL, NULL, NULL, 4),
(47765, NULL, 'G3DSA:1.25.40.560:FF:000003', NULL, NULL, 'Putative nf-kappa b regulator ap20/cezanne', NULL, NULL, NULL, NULL, NULL, 4),
(47766, NULL, 'G3DSA:1.10.357.50:FF:000012', NULL, NULL, 'Unc-13 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(47767, NULL, 'G3DSA:2.60.11.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47768, NULL, 'G3DSA:1.20.58.80:FF:000016', NULL, NULL, 'Calpain 7', NULL, NULL, NULL, NULL, NULL, 4),
(47769, NULL, 'G3DSA:3.40.50.11350:FF:000026', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(47770, NULL, 'G3DSA:3.30.420.40:FF:001089', NULL, NULL, 'Glycerol kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47771, NULL, 'G3DSA:3.30.1370.10:FF:000069', NULL, NULL, 'Zinc finger CCCH domain-containing protein 52', NULL, NULL, NULL, NULL, NULL, 4),
(47772, NULL, 'G3DSA:3.20.20.100:FF:000047', NULL, NULL, 'Putative aldo/keto reductase', NULL, NULL, NULL, NULL, NULL, 4),
(47773, NULL, 'G3DSA:2.30.29.30:FF:001174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47774, NULL, 'G3DSA:2.130.10.10:FF:001277', NULL, NULL, 'Pre-mRNA-splicing factor RSE1', NULL, NULL, NULL, NULL, NULL, 4),
(47775, NULL, 'G3DSA:1.25.40.20:FF:001184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47776, NULL, 'G3DSA:2.30.39.10:FF:000050', NULL, NULL, 'Heterochromatin-associated protein MENT', NULL, NULL, NULL, NULL, NULL, 4),
(47777, NULL, 'G3DSA:1.10.287.90:FF:000001', NULL, NULL, 'Cytochrome c oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(47778, NULL, 'G3DSA:2.130.10.10:FF:005566', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(47779, NULL, 'G3DSA:3.30.160.60:FF:002002', NULL, NULL, 'Zinc finger protein 786', NULL, NULL, NULL, NULL, NULL, 4),
(47780, NULL, 'G3DSA:3.30.1330.60:FF:000025', NULL, NULL, 'Outer membrane protein/peptidoglycan-associated lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(47781, NULL, 'G3DSA:3.40.525.10:FF:000012', NULL, NULL, 'bcl-2/adenovirus E1B 19 kDa-interacting protein 2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(47782, NULL, 'G3DSA:3.90.1420.10:FF:000032', NULL, NULL, 'Ribosomal lysine N-methyltransferase 4', NULL, NULL, NULL, NULL, NULL, 4),
(47783, NULL, 'G3DSA:3.40.190.10:FF:000025', NULL, NULL, 'glutamate receptor ionotropic, NMDA 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(47784, NULL, 'G3DSA:3.50.30.30:FF:000055', NULL, NULL, 'Minor extracellular protease VpR', NULL, NULL, NULL, NULL, NULL, 4),
(47785, NULL, 'G3DSA:1.25.40.20:FF:000565', NULL, NULL, '6-phosphofructo-2-kinase/fructose-2, 6-biphosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47786, NULL, 'G3DSA:3.40.50.300:FF:005965', NULL, NULL, 'ATP-dependent DNA helicase, RecQ family', NULL, NULL, NULL, NULL, NULL, 4),
(47787, NULL, 'G3DSA:3.30.40.10:FF:001242', NULL, NULL, 'Ubiquitin fusion degradation protein 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47788, NULL, 'G3DSA:3.30.160.60:FF:004508', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47789, NULL, 'G3DSA:2.60.40.60:FF:000084', NULL, NULL, 'FAT atypical cadherin 3', NULL, NULL, NULL, NULL, NULL, 4),
(47790, NULL, 'G3DSA:1.25.10.10:FF:001100', NULL, NULL, 'WGS project CABT00000000 data, contig 2.18', NULL, NULL, NULL, NULL, NULL, 4),
(47791, NULL, 'G3DSA:3.60.40.10:FF:000257', NULL, NULL, 'Protein phosphatase 2C 3', NULL, NULL, NULL, NULL, NULL, 4),
(47792, NULL, 'G3DSA:3.30.70.330:FF:001596', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47793, NULL, 'G3DSA:3.40.50.300:FF:002727', NULL, NULL, 'RNA polymerase II Elongator complex associated protein Kti12, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47794, NULL, 'G3DSA:1.10.760.10:FF:000050', NULL, NULL, 'Bll0021 protein', NULL, NULL, NULL, NULL, NULL, 4),
(47795, NULL, 'G3DSA:3.30.200.20:FF:001567', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47796, NULL, 'G3DSA:1.25.40.10:FF:000995', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(47797, NULL, 'G3DSA:2.60.120.470:FF:000008', NULL, NULL, 'DUF1000-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(47798, NULL, 'G3DSA:1.20.1250.20:FF:001320', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47799, NULL, 'G3DSA:1.20.1070.10:FF:001106', NULL, NULL, 'Substance-P receptor', NULL, NULL, NULL, NULL, NULL, 4),
(47800, NULL, 'G3DSA:2.130.10.10:FF:000187', NULL, NULL, 'WD repeat-containing protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(47801, NULL, 'G3DSA:2.130.10.10:FF:004150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(47802, NULL, 'G3DSA:3.40.50.300:FF:003817', NULL, NULL, 'ABC a-pheromone efflux pump AtrD', NULL, NULL, NULL, NULL, NULL, 4),
(47803, NULL, 'G3DSA:3.40.50.1820:FF:001833', NULL, NULL, 'Putative phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(47804, NULL, 'G3DSA:1.25.40.10:FF:005357', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g39620', NULL, NULL, NULL, NULL, NULL, 4),
(47805, NULL, 'G3DSA:2.10.110.10:FF:000020', NULL, NULL, 'PDZ and LIM domain protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(47806, NULL, 'G3DSA:1.10.8.270:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47807, NULL, 'G3DSA:1.10.10.10:FF:000419', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(47808, NULL, 'G3DSA:2.60.40.10:FF:002261', NULL, NULL, 'Transglutaminase 2, like', NULL, NULL, NULL, NULL, NULL, 4),
(47809, NULL, 'G3DSA:3.90.79.10:FF:000154', NULL, NULL, 'Nudix hydrolase DR_0079', NULL, NULL, NULL, NULL, NULL, 4),
(47810, NULL, 'G3DSA:1.25.40.170:FF:000009', NULL, NULL, 'Protein Smaug homolog 2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(47811, NULL, 'G3DSA:1.10.10.10:FF:001509', NULL, NULL, 'Vacuolar protein-sorting-associated protein 36', NULL, NULL, NULL, NULL, NULL, 4),
(47812, NULL, 'G3DSA:1.20.1080.10:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47813, NULL, 'G3DSA:4.10.60.10:FF:000056', NULL, NULL, 'Splicing factor, arginine/serine-rich 7', NULL, NULL, NULL, NULL, NULL, 4),
(47814, NULL, 'G3DSA:2.30.30.190:FF:000009', NULL, NULL, 'Kinesin family member 13B', NULL, NULL, NULL, NULL, NULL, 4),
(47815, NULL, 'G3DSA:2.30.30.40:FF:000084', NULL, NULL, 'dynamin-binding protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(47816, NULL, 'G3DSA:1.25.40.10:FF:003209', NULL, NULL, 'TPR repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47817, NULL, 'G3DSA:1.50.40.10:FF:000583', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47818, NULL, 'G3DSA:2.30.29.130:FF:000001', NULL, NULL, 'Glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(47819, NULL, 'G3DSA:1.10.287.70:FF:000046', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(47820, NULL, 'G3DSA:1.10.510.10:FF:001167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47821, NULL, 'G3DSA:1.20.1250.20:FF:000966', NULL, NULL, 'YMR155W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(47822, NULL, 'G3DSA:1.20.120.1760:FF:000047', NULL, NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(47823, NULL, 'G3DSA:2.60.40.60:FF:000561', NULL, NULL, 'Cadherin 5', NULL, NULL, NULL, NULL, NULL, 4),
(47824, NULL, 'G3DSA:3.80.10.10:FF:000844', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(47825, NULL, 'G3DSA:3.40.50.1240:FF:000035', NULL, NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(47826, NULL, 'G3DSA:1.10.510.10:FF:002257', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47827, NULL, 'G3DSA:1.20.5.780:FF:000005', NULL, NULL, 'FXYD domain-containing ion transport regulator', NULL, NULL, NULL, NULL, NULL, 4),
(47828, NULL, 'G3DSA:1.20.1110.10:FF:000205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47829, NULL, 'G3DSA:3.30.1520.10:FF:000087', NULL, NULL, 'GD16870', NULL, NULL, NULL, NULL, NULL, 4),
(47830, NULL, 'G3DSA:3.30.160.60:FF:002474', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM16', NULL, NULL, NULL, NULL, NULL, 4),
(47831, NULL, 'G3DSA:3.30.160.60:FF:001384', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(47832, NULL, 'G3DSA:1.20.120.1110:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47833, NULL, 'G3DSA:3.30.1360.40:FF:000004', NULL, NULL, 'Arginine repressor', NULL, NULL, NULL, NULL, NULL, 4),
(47834, NULL, 'G3DSA:3.30.1360.120:FF:000080', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(47835, NULL, 'G3DSA:3.30.40.10:FF:001618', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(47836, NULL, 'G3DSA:3.40.50.150:FF:000631', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47837, NULL, 'G3DSA:1.10.565.10:FF:000034', NULL, NULL, 'Hormone receptor 4, isoform J', NULL, NULL, NULL, NULL, NULL, 4),
(47838, NULL, 'G3DSA:1.10.238.10:FF:000050', NULL, NULL, 'Calcium-dependent protein kinase 7', NULL, NULL, NULL, NULL, NULL, 4),
(47839, NULL, 'G3DSA:3.30.2290.10:FF:000029', NULL, NULL, 'Peptidase U62 modulator of DNA gyrase', NULL, NULL, NULL, NULL, NULL, 4),
(47840, NULL, 'G3DSA:3.30.40.10:FF:001473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47841, NULL, 'G3DSA:1.25.40.20:FF:001869', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(47842, NULL, 'G3DSA:3.30.200.20:FF:002404', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(47843, NULL, 'G3DSA:1.25.10.10:FF:003129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47844, NULL, 'G3DSA:3.30.1010.10:FF:000020', NULL, NULL, 'Serine/threonine-protein kinase ATR', NULL, NULL, NULL, NULL, NULL, 4),
(47845, NULL, 'G3DSA:3.30.1490.430:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47846, NULL, 'G3DSA:1.10.10.60:FF:001266', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47847, NULL, 'G3DSA:2.10.25.10:FF:000726', NULL, NULL, 'Laminin-like protein epi-1', NULL, NULL, NULL, NULL, NULL, 4),
(47848, NULL, 'G3DSA:3.40.1190.20:FF:000235', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47849, NULL, 'G3DSA:3.30.420.10:FF:000473', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(47850, NULL, 'G3DSA:3.40.50.300:FF:005280', NULL, NULL, 'Adenosylcobinamide kinase/adenosylcobinamidephosphate guanylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(47851, NULL, 'G3DSA:3.30.230.10:FF:000239', NULL, NULL, 'Probable DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(47852, NULL, 'G3DSA:2.130.10.10:FF:004239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47853, NULL, 'G3DSA:1.20.920.10:FF:000184', NULL, NULL, 'Bromodomain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(47854, NULL, 'G3DSA:3.40.50.1820:FF:001294', NULL, NULL, 'Protein phosphatase methylesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(47855, NULL, 'G3DSA:2.60.120.290:FF:000241', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(47856, NULL, 'G3DSA:1.25.40.10:FF:003518', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47857, NULL, 'G3DSA:3.40.50.150:FF:001485', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47858, NULL, 'G3DSA:3.30.9.10:FF:000017', NULL, NULL, 'Sarcosine oxidase, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(47859, NULL, 'G3DSA:1.20.5.190:FF:000143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47860, NULL, 'G3DSA:2.60.40.60:FF:000870', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47861, NULL, 'G3DSA:3.30.565.10:FF:000511', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(47862, NULL, 'G3DSA:3.40.50.720:FF:000936', NULL, NULL, 'Oxidoreductase, short-chain dehydrogenase/reductase family', NULL, NULL, NULL, NULL, NULL, 4),
(47863, NULL, 'G3DSA:2.40.160.120:FF:000023', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(47864, NULL, 'G3DSA:3.40.50.1440:FF:000067', NULL, NULL, 'Tubulin delta chain', NULL, NULL, NULL, NULL, NULL, 4),
(47865, NULL, 'G3DSA:1.10.238.10:FF:000994', NULL, NULL, 'CALUmenin (Calcium-binding protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(47866, NULL, 'G3DSA:1.10.510.10:FF:000003', NULL, NULL, 'TRAF2 and NCK-interacting protein kinase isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(47867, NULL, 'G3DSA:1.10.10.500:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47868, NULL, 'G3DSA:1.20.120.350:FF:000061', NULL, NULL, 'Potassium voltage-gated channel subfamily C member 2', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(47869, NULL, 'G3DSA:1.20.1170.10:FF:000001', NULL, NULL, 'Hemolytic enterotoxin HBL', NULL, NULL, NULL, NULL, NULL, 4),
(47870, NULL, 'G3DSA:3.40.50.10260:FF:000003', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(47871, NULL, 'G3DSA:2.40.50.140:FF:001227', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47872, NULL, 'G3DSA:2.130.10.10:FF:004947', NULL, NULL, 'Sperm associated antigen 16', NULL, NULL, NULL, NULL, NULL, 4),
(47873, NULL, 'G3DSA:3.30.1360.210:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47874, NULL, 'G3DSA:3.10.110.10:FF:000145', NULL, NULL, 'Probable ubiquitin-conjugating enzyme E2 21', NULL, NULL, NULL, NULL, NULL, 4),
(47875, NULL, 'G3DSA:3.20.180.20:FF:000032', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(47876, NULL, 'G3DSA:2.60.40.10:FF:004823', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47877, NULL, 'G3DSA:2.10.310.10:FF:000001', NULL, NULL, 'Serpin family A member 1', NULL, NULL, NULL, NULL, NULL, 4),
(47878, NULL, 'G3DSA:1.20.1730.10:FF:000084', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(47879, NULL, 'G3DSA:1.10.472.10:FF:000021', NULL, NULL, 'Cyclin-K (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(47880, NULL, 'G3DSA:3.40.50.1820:FF:000905', NULL, NULL, 'Ves G 1 allergen precursor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47881, NULL, 'G3DSA:1.10.510.10:FF:003185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47882, NULL, 'G3DSA:3.40.50.1820:FF:001305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47883, NULL, 'G3DSA:3.40.1360.10:FF:000038', NULL, NULL, 'Mitochondrial helicase twinkle', NULL, NULL, NULL, NULL, NULL, 4),
(47884, NULL, 'G3DSA:3.20.20.70:FF:000478', NULL, NULL, 'tRNA-dihydrouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(47885, NULL, 'G3DSA:1.20.1560.10:FF:000503', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47886, NULL, 'G3DSA:3.40.50.620:FF:000676', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47887, NULL, 'G3DSA:3.40.50.720:FF:000408', NULL, NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(47888, NULL, 'G3DSA:1.20.58.390:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47889, NULL, 'G3DSA:1.10.238.10:FF:000207', NULL, NULL, 'Putative 45 kDa calcium-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(47890, NULL, 'G3DSA:3.40.850.10:FF:000486', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47891, NULL, 'G3DSA:3.40.630.10:FF:000161', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(47892, NULL, 'G3DSA:2.40.30.20:FF:000010', NULL, NULL, 'ATP synthase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(47893, NULL, 'G3DSA:3.30.160.60:FF:002710', NULL, NULL, 'Zinc finger protein 880', NULL, NULL, NULL, NULL, NULL, 4),
(47894, NULL, 'G3DSA:1.10.287.100:FF:000005', NULL, NULL, 'Transcription initiation factor IIA subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(47895, NULL, 'G3DSA:3.40.50.300:FF:007387', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47896, NULL, 'G3DSA:2.60.40.10:FF:003553', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47897, NULL, 'G3DSA:1.10.3380.10:FF:000020', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(47898, NULL, 'G3DSA:3.40.50.300:FF:004661', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(47899, NULL, 'G3DSA:3.10.20.230:FF:000009', NULL, NULL, 'Echinoderm microtubule-associated protein-like CG42247', NULL, NULL, NULL, NULL, NULL, 4),
(47900, NULL, 'G3DSA:3.30.565.10:FF:000202', NULL, NULL, 'Sensor histidine kinase TodS', NULL, NULL, NULL, NULL, NULL, 4),
(47901, NULL, 'G3DSA:3.10.105.10:FF:000088', NULL, NULL, 'Peptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(47902, NULL, 'G3DSA:1.25.40.10:FF:001411', NULL, NULL, 'Outer membrane protein assembly factor BamD', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(47903, NULL, 'G3DSA:1.20.144.10:FF:000127', NULL, NULL, 'Phospholipid phosphatase 4', NULL, NULL, NULL, NULL, NULL, 4),
(47904, NULL, 'G3DSA:3.40.190.10:FF:000334', NULL, NULL, 'Peptide ABC transporter, periplasmic peptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(47905, NULL, 'G3DSA:3.40.50.300:FF:000058', NULL, NULL, 'Translation elongation factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(47906, NULL, 'G3DSA:1.25.40.10:FF:004137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47907, NULL, 'G3DSA:1.25.10.10:FF:000858', NULL, NULL, 'Vimar', NULL, NULL, NULL, NULL, NULL, 4),
(47908, NULL, 'G3DSA:1.25.10.10:FF:000482', NULL, NULL, 'TOG array regulator of axonemal microtubules 1', NULL, NULL, NULL, NULL, NULL, 4),
(47909, NULL, 'G3DSA:2.40.50.100:FF:000193', NULL, NULL, 'Putative heavy metal efflux system protein', NULL, NULL, NULL, NULL, NULL, 4),
(47910, NULL, 'G3DSA:3.30.160.20:FF:000107', NULL, NULL, 'Peptide chain release factor 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47911, NULL, 'G3DSA:3.40.630.30:FF:000167', NULL, NULL, 'GNAT family acetyltransferase Nat4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47912, NULL, 'G3DSA:3.80.10.10:FF:001356', NULL, NULL, 'Receptor-like protein kinase HSL1', NULL, NULL, NULL, NULL, NULL, 4),
(47913, NULL, 'G3DSA:1.20.1330.10:FF:000003', NULL, NULL, 'Flagellin', NULL, NULL, NULL, NULL, NULL, 4),
(47914, NULL, 'G3DSA:3.90.550.10:FF:000744', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47915, NULL, 'G3DSA:1.10.287.10:FF:000034', NULL, NULL, 'Histidyl-tRNA synthetase, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(47916, NULL, 'G3DSA:3.30.497.10:FF:000009', NULL, NULL, 'serpin B5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(47917, NULL, 'G3DSA:1.10.510.10:FF:003893', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47918, NULL, 'G3DSA:3.90.830.10:FF:000018', NULL, NULL, 'Syntaxin binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47919, NULL, 'G3DSA:3.60.10.10:FF:000429', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47920, NULL, 'G3DSA:3.40.47.10:FF:000150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47921, NULL, 'G3DSA:3.90.640.10:FF:000173', NULL, NULL, 'Actin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(47922, NULL, 'G3DSA:1.10.510.10:FF:000548', NULL, NULL, 'Serine/threonine-protein kinase ATG1', NULL, NULL, NULL, NULL, NULL, 4),
(47923, NULL, 'G3DSA:3.30.200.20:FF:000151', NULL, NULL, 'G2-specific protein kinase nimA', NULL, NULL, NULL, NULL, NULL, 4),
(47924, NULL, 'G3DSA:1.25.40.10:FF:004845', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(47925, NULL, 'G3DSA:3.30.160.60:FF:000765', NULL, NULL, 'Zinc finger 45-like', NULL, NULL, NULL, NULL, NULL, 4),
(47926, NULL, 'G3DSA:3.40.50.2300:FF:000022', NULL, NULL, 'Fructose repressor (Catabolite repressor/activator)', NULL, NULL, NULL, NULL, NULL, 4),
(47927, NULL, 'G3DSA:3.30.160.60:FF:000456', NULL, NULL, 'Zinc finger and BTB domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(47928, NULL, 'G3DSA:2.30.40.10:FF:000148', NULL, NULL, 'Probable N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(47929, NULL, 'G3DSA:1.20.1510.10:FF:000101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47930, NULL, 'G3DSA:2.170.120.40:FF:000014', NULL, NULL, 'YbbR family protein', NULL, NULL, NULL, NULL, NULL, 4),
(47931, NULL, 'G3DSA:2.40.290.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47932, NULL, 'G3DSA:1.20.1070.10:FF:000853', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47933, NULL, 'G3DSA:3.40.50.12780:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47934, NULL, 'G3DSA:3.30.160.60:FF:003093', NULL, NULL, 'Zinc finger protein 662', NULL, NULL, NULL, NULL, NULL, 4),
(47935, NULL, 'G3DSA:1.20.5.110:FF:000176', NULL, NULL, 'Qa-SNARE protein, putative', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(47936, NULL, 'G3DSA:3.30.40.10:FF:002237', NULL, NULL, 'Qin', NULL, NULL, NULL, NULL, NULL, 4),
(47937, NULL, 'G3DSA:3.10.20.90:FF:000136', NULL, NULL, 'Arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(47938, NULL, 'G3DSA:2.60.60.20:FF:000011', NULL, NULL, 'Lipoxygenase homology domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(47939, NULL, 'G3DSA:1.20.5.430:FF:000007', NULL, NULL, 'Heat shock factor-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(47940, NULL, 'G3DSA:1.10.630.10:FF:000602', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47941, NULL, 'G3DSA:2.170.300.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47942, NULL, 'G3DSA:3.30.710.10:FF:000377', NULL, NULL, 'SCF ubiquitin ligase complex protein SKP1b', NULL, NULL, NULL, NULL, NULL, 4),
(47943, NULL, 'G3DSA:2.60.40.60:FF:000538', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47944, NULL, 'G3DSA:1.10.1410.10:FF:000006', NULL, NULL, 'Nucleolar protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(47945, NULL, 'G3DSA:1.10.3580.10:FF:000001', NULL, NULL, 'ATP synthase mitochondrial F1 complex assembly factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(47946, NULL, 'G3DSA:2.30.29.30:FF:000246', NULL, NULL, 'Docking protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(47947, NULL, 'G3DSA:3.10.450.10:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47948, NULL, 'G3DSA:3.30.2350.10:FF:000040', NULL, NULL, 'Os04g0576300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(47949, NULL, 'G3DSA:2.40.50.100:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47950, NULL, 'G3DSA:3.30.70.330:FF:001343', NULL, NULL, 'Single-stranded DNA binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(47951, NULL, 'G3DSA:3.40.20.10:FF:000009', NULL, NULL, 'gelsolin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(47952, NULL, 'G3DSA:3.20.170.50:FF:000001', NULL, NULL, 'Dot/Icm secretion system protein IcmQ', NULL, NULL, NULL, NULL, NULL, 4),
(47953, NULL, 'G3DSA:3.30.450.40:FF:000309', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(47954, NULL, 'G3DSA:3.40.190.10:FF:000677', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(47955, NULL, 'G3DSA:2.60.120.260:FF:000243', NULL, NULL, 'Alpha-1,3/4-fucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(47956, NULL, 'G3DSA:3.40.50.150:FF:001699', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47957, NULL, 'G3DSA:3.30.10.20:FF:000001', NULL, NULL, 'Stage V sporulation protein D', NULL, NULL, NULL, NULL, NULL, 4),
(47958, NULL, 'G3DSA:1.10.275.10:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47959, NULL, 'G3DSA:3.20.20.80:FF:000138', NULL, NULL, 'Putative alpha-glucosidase AgdA', NULL, NULL, NULL, NULL, NULL, 4),
(47960, NULL, 'G3DSA:3.40.50.800:FF:000101', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(47961, NULL, 'G3DSA:3.30.160.60:FF:006055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47962, NULL, 'G3DSA:1.20.970.10:FF:000024', NULL, NULL, 'Anthranilate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(47963, NULL, 'G3DSA:2.60.210.10:FF:000078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47964, NULL, 'G3DSA:2.130.10.10:FF:001513', NULL, NULL, 'Cilia and flagella associated protein 52', NULL, NULL, NULL, NULL, NULL, 4),
(47965, NULL, 'G3DSA:2.130.10.130:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47966, NULL, 'G3DSA:3.40.50.2300:FF:001567', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47967, NULL, 'G3DSA:1.10.8.60:FF:000450', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47968, NULL, 'G3DSA:3.40.50.1980:FF:000111', NULL, NULL, 'Hemin-binding periplasmic protein hmuT', NULL, NULL, NULL, NULL, NULL, 4),
(47969, NULL, 'G3DSA:3.30.2010.10:FF:000003', NULL, NULL, 'CAAX prenyl protease', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(47970, NULL, 'G3DSA:1.10.510.10:FF:001728', NULL, NULL, 'Protein CBG02852', NULL, NULL, NULL, NULL, NULL, 4),
(47971, NULL, 'G3DSA:1.10.560.10:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47972, NULL, 'G3DSA:3.40.50.720:FF:000375', NULL, NULL, 'Uncharacterized protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(47973, NULL, 'G3DSA:3.40.50.300:FF:000619', NULL, NULL, 'Phosphoribulokinase', NULL, NULL, NULL, NULL, NULL, 4),
(47974, NULL, 'G3DSA:1.20.1050.10:FF:000184', NULL, NULL, 'Hypothetical glutathione S-transferase like protein', NULL, NULL, NULL, NULL, NULL, 4),
(47975, NULL, 'G3DSA:1.20.272.10:FF:000060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47976, NULL, 'G3DSA:3.40.50.300:FF:006218', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(47977, NULL, 'G3DSA:3.30.30.10:FF:000011', NULL, NULL, 'Plant defensin 1.5', NULL, NULL, NULL, NULL, NULL, 4),
(47978, NULL, 'G3DSA:3.40.50.2300:FF:000477', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(47979, NULL, 'G3DSA:1.10.540.10:FF:000140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47980, NULL, 'G3DSA:2.130.10.10:FF:000895', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(47981, NULL, 'G3DSA:3.30.260.10:FF:000067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47982, NULL, 'G3DSA:2.70.170.10:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47983, NULL, 'G3DSA:3.20.20.60:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47984, NULL, 'G3DSA:3.30.559.70:FF:000014', NULL, NULL, 'Carnitine palmitoyltransferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(47985, NULL, 'G3DSA:1.25.10.10:FF:003461', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47986, NULL, 'G3DSA:2.20.28.290:FF:000005', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(47987, NULL, 'G3DSA:3.30.70.330:FF:001490', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47988, NULL, 'G3DSA:1.20.58.2220:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47989, NULL, 'G3DSA:2.60.40.1730:FF:000026', NULL, NULL, 'TAF2', NULL, NULL, NULL, NULL, NULL, 4),
(47990, NULL, 'G3DSA:2.60.220.50:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(47991, NULL, 'G3DSA:3.10.290.10:FF:000085', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(47992, NULL, 'G3DSA:3.90.215.10:FF:000005', NULL, NULL, 'angiopoietin-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(47993, NULL, 'G3DSA:3.80.10.10:FF:002284', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(47994, NULL, 'G3DSA:1.10.10.10:FF:001403', NULL, NULL, 'PeRoXisome assembly factor', NULL, NULL, NULL, NULL, NULL, 4),
(47995, NULL, 'G3DSA:2.40.30.330:FF:000016', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(47996, NULL, 'G3DSA:2.10.25.160:FF:000006', NULL, NULL, 'Granulin a', NULL, NULL, NULL, NULL, NULL, 4),
(47997, NULL, 'G3DSA:3.40.50.620:FF:000221', NULL, NULL, 'Nicotinamide/nicotinic acid mononucleotide adenylyltransferase 3', NULL, NULL, NULL, NULL, NULL, 4),
(47998, NULL, 'G3DSA:3.30.160.60:FF:005436', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(47999, NULL, 'G3DSA:2.70.150.10:FF:000082', NULL, NULL, 'Cation-transporter ATPase I CtpI', NULL, NULL, NULL, NULL, NULL, 4),
(48000, NULL, 'G3DSA:3.30.70.330:FF:002669', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48001, NULL, 'G3DSA:2.60.200.40:FF:000013', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(48002, NULL, 'G3DSA:2.30.29.30:FF:000774', NULL, NULL, 'Dynamin 2b', NULL, NULL, NULL, NULL, NULL, 4),
(48003, NULL, 'G3DSA:2.60.120.430:FF:000007', NULL, NULL, 'FERONIA receptor-like kinase', NULL, NULL, NULL, NULL, NULL, 4),
(48004, NULL, 'G3DSA:2.40.70.10:FF:000105', NULL, NULL, 'aspartic proteinase PCS1', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(48005, NULL, 'G3DSA:3.40.50.2000:FF:000977', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48006, NULL, 'G3DSA:2.170.8.10:FF:000011', NULL, NULL, 'Phosphoenolpyruvate carboxykinase [GTP]', NULL, NULL, NULL, NULL, NULL, 4),
(48007, NULL, 'G3DSA:2.40.110.10:FF:000013', NULL, NULL, 'Acyl-coenzyme A oxidase 4 peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(48008, NULL, 'G3DSA:1.20.1070.10:FF:000292', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(48009, NULL, 'G3DSA:3.40.50.150:FF:000760', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48010, NULL, 'G3DSA:3.30.160.60:FF:005094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48011, NULL, 'G3DSA:2.60.120.920:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48012, NULL, 'G3DSA:2.10.25.10:FF:001255', NULL, NULL, 'C-type lectin domain-containing 14A', NULL, NULL, NULL, NULL, NULL, 4),
(48013, NULL, 'G3DSA:1.10.10.750:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48014, NULL, 'G3DSA:2.60.40.10:FF:004481', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48015, NULL, 'G3DSA:3.80.10.10:FF:004425', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48016, NULL, 'G3DSA:1.10.10.790:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48017, NULL, 'G3DSA:2.90.10.10:FF:000037', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(48018, NULL, 'G3DSA:1.10.10.440:FF:000073', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48019, NULL, 'G3DSA:3.30.450.20:FF:000450', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48020, NULL, 'G3DSA:3.10.100.10:FF:000083', NULL, NULL, 'C-type lectin domain family 1 member B', NULL, NULL, NULL, NULL, NULL, 4),
(48021, NULL, 'G3DSA:1.20.810.10:FF:000007', NULL, NULL, 'Ubiquinol-cytochrome C reductase B subunit', NULL, NULL, NULL, NULL, NULL, 4),
(48022, NULL, 'G3DSA:3.30.450.20:FF:000118', NULL, NULL, 'Potassium voltage-gated channel subfamily H member 8', NULL, NULL, NULL, NULL, NULL, 4),
(48023, NULL, 'G3DSA:3.40.50.2300:FF:001438', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48024, NULL, 'G3DSA:1.10.510.10:FF:001875', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(48025, NULL, 'G3DSA:1.10.8.60:FF:000118', NULL, NULL, 'Propionate catabolism operon regulatory protein PrpR', NULL, NULL, NULL, NULL, NULL, 4),
(48026, NULL, 'G3DSA:3.40.50.720:FF:001336', NULL, NULL, 'SDR family NAD(P)-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(48027, NULL, 'G3DSA:1.10.630.10:FF:000366', NULL, NULL, 'Ent-kaurene oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(48028, NULL, 'G3DSA:3.40.50.970:FF:000197', NULL, NULL, 'Pyruvate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(48029, NULL, 'G3DSA:3.40.50.300:FF:005841', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48030, NULL, 'G3DSA:1.10.10.60:FF:000884', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48031, NULL, 'G3DSA:3.40.50.720:FF:002426', NULL, NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(48032, NULL, 'G3DSA:2.60.40.10:FF:000771', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', NULL, NULL, NULL, NULL, NULL, 4),
(48033, NULL, 'G3DSA:1.20.140.40:FF:000026', NULL, NULL, 'Os08g0541800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(48034, NULL, 'G3DSA:2.60.40.10:FF:001861', NULL, NULL, 'Cell adhesion molecule', NULL, NULL, NULL, NULL, NULL, 4),
(48035, NULL, 'G3DSA:1.10.20.60:FF:000002', NULL, NULL, 'Amidase', NULL, NULL, NULL, NULL, NULL, 4),
(48036, NULL, 'G3DSA:2.60.120.260:FF:000619', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48037, NULL, 'G3DSA:3.40.50.300:FF:003711', NULL, NULL, 'Eukaryotic initiation factor 4A-III', NULL, NULL, NULL, NULL, NULL, 4),
(48038, NULL, 'G3DSA:3.40.50.10810:FF:000117', NULL, NULL, 'Defense against restriction protein B', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(48039, NULL, 'G3DSA:2.10.90.10:FF:000124', NULL, NULL, 'Bone morphogenetic protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(48040, NULL, 'G3DSA:1.25.40.10:FF:005087', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g49170, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(48041, NULL, 'G3DSA:2.40.30.10:FF:000237', NULL, NULL, 'tRNA-specific 2-thiouridylase MnmA', NULL, NULL, NULL, NULL, NULL, 4),
(48042, NULL, 'G3DSA:1.20.120.550:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48043, NULL, 'G3DSA:2.60.40.420:FF:000029', NULL, NULL, 'L-ascorbate oxidase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(48044, NULL, 'G3DSA:1.10.10.10:FF:000223', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(48045, NULL, 'G3DSA:3.30.950.10:FF:000007', NULL, NULL, 'Diphthine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(48046, NULL, 'G3DSA:2.30.30.140:FF:000219', NULL, NULL, 'AT14886p', NULL, NULL, NULL, NULL, NULL, 4),
(48047, NULL, 'G3DSA:1.10.287.450:FF:000003', NULL, NULL, 'Non-homologous end-joining factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(48048, NULL, 'G3DSA:3.10.100.10:FF:000425', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48049, NULL, 'G3DSA:6.10.140.2220:FF:000006', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 15', NULL, NULL, NULL, NULL, NULL, 4),
(48050, NULL, 'G3DSA:3.30.479.20:FF:000061', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(48051, NULL, 'G3DSA:3.40.640.10:FF:000532', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48052, NULL, 'G3DSA:3.60.40.10:FF:000038', NULL, NULL, 'Probable protein phosphatase 2C 34', NULL, NULL, NULL, NULL, NULL, 4),
(48053, NULL, 'G3DSA:1.10.486.10:FF:000069', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(48054, NULL, 'G3DSA:1.10.10.60:FF:000176', NULL, NULL, 'pancreas/duodenum homeobox protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(48055, NULL, 'G3DSA:3.80.10.10:FF:003464', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48056, NULL, 'G3DSA:2.30.30.40:FF:000320', NULL, NULL, 'E3 ubiquitin-protein ligase hecd-1', NULL, NULL, NULL, NULL, NULL, 4),
(48057, NULL, 'G3DSA:2.60.40.10:FF:005442', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48058, NULL, 'G3DSA:1.25.40.20:FF:000543', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48059, NULL, 'G3DSA:3.80.10.10:FF:002536', NULL, NULL, 'TOLl (Drosophila) family', NULL, NULL, NULL, NULL, NULL, 4),
(48060, NULL, 'G3DSA:3.10.100.10:FF:000116', NULL, NULL, 'Complement component C1q receptor', NULL, NULL, NULL, NULL, NULL, 4),
(48061, NULL, 'G3DSA:3.20.20.80:FF:000470', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48062, NULL, 'G3DSA:2.60.40.1180:FF:000041', NULL, NULL, 'Alpha-xylosidase A', NULL, NULL, NULL, NULL, NULL, 4),
(48063, NULL, 'G3DSA:3.30.70.330:FF:000163', NULL, NULL, 'Eukaryotic translation initiation factor 4B', NULL, NULL, NULL, NULL, NULL, 4),
(48064, NULL, 'G3DSA:3.30.420.40:FF:000381', NULL, NULL, 'Glucosamine kinase GpsK', NULL, NULL, NULL, NULL, NULL, 4),
(48065, NULL, 'G3DSA:3.90.700.10:FF:000009', NULL, NULL, 'Adenylylsulfate reductase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(48066, NULL, 'G3DSA:3.20.80.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48067, NULL, 'G3DSA:3.40.50.10810:FF:000084', NULL, NULL, 'Protein CHROMATIN REMODELING 19', NULL, NULL, NULL, NULL, NULL, 4),
(48068, NULL, 'G3DSA:1.10.460.10:FF:000010', NULL, NULL, 'DNA topoisomerase 1A', NULL, NULL, NULL, NULL, NULL, 4),
(48069, NULL, 'G3DSA:1.50.40.10:FF:000274', NULL, NULL, 'Carnitine/acyl carnitine carrier, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48070, NULL, 'G3DSA:1.10.287.370:FF:000063', NULL, NULL, 'Uri-1', NULL, NULL, NULL, NULL, NULL, 4),
(48071, NULL, 'G3DSA:2.60.40.150:FF:000128', NULL, NULL, 'C2 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(48072, NULL, 'G3DSA:3.20.20.140:FF:000267', NULL, NULL, 'Uncharacterized protein MJ0699', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(48073, NULL, 'G3DSA:3.40.50.2300:FF:001191', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48074, NULL, 'G3DSA:1.10.730.10:FF:000222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48075, NULL, 'G3DSA:3.40.50.300:FF:001766', NULL, NULL, 'Elongator complex protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(48076, NULL, 'G3DSA:3.30.70.141:FF:000017', NULL, NULL, 'Nucleoside diphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(48077, NULL, 'G3DSA:2.40.10.10:FF:000461', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48078, NULL, 'G3DSA:3.40.50.150:FF:001013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48079, NULL, 'G3DSA:1.20.120.30:FF:000005', NULL, NULL, 'Methyl-accepting chemotaxis citrate transducer', NULL, NULL, NULL, NULL, NULL, 4),
(48080, NULL, 'G3DSA:1.25.40.180:FF:000092', NULL, NULL, 'SD07232p', NULL, NULL, NULL, NULL, NULL, 4),
(48081, NULL, 'G3DSA:1.10.268.10:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48082, NULL, 'G3DSA:2.30.40.10:FF:000042', NULL, NULL, 'N-acetylglucosamine 6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(48083, NULL, 'G3DSA:1.25.10.10:FF:001786', NULL, NULL, 'Adaptor protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48084, NULL, 'G3DSA:3.30.519.10:FF:000005', NULL, NULL, 'Rab GDP dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(48085, NULL, 'G3DSA:1.20.1560.10:FF:000048', NULL, NULL, 'ATP-binding cassette sub-family B member 10, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(48086, NULL, 'G3DSA:3.30.70.330:FF:000871', NULL, NULL, 'Sex lethal', NULL, NULL, NULL, NULL, NULL, 4),
(48087, NULL, 'G3DSA:3.40.50.300:FF:001238', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(48088, NULL, 'G3DSA:3.40.50.2000:FF:000269', NULL, NULL, '3-deoxy-D-manno-octulosonic acid transferase', NULL, NULL, NULL, NULL, NULL, 4),
(48089, NULL, 'G3DSA:3.40.50.2000:FF:001016', NULL, NULL, 'Glycosyl transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48090, NULL, 'G3DSA:4.10.1240.10:FF:000052', NULL, NULL, 'Secretin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(48091, NULL, 'G3DSA:2.60.40.150:FF:000151', NULL, NULL, 'Rab11 family-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(48092, NULL, 'G3DSA:3.40.50.10930:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48093, NULL, 'G3DSA:3.30.160.60:FF:002221', NULL, NULL, 'Zinc finger protein 559', NULL, NULL, NULL, NULL, NULL, 4),
(48094, NULL, 'G3DSA:2.60.120.290:FF:000038', NULL, NULL, 'enteropeptidase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(48095, NULL, 'G3DSA:1.10.8.10:FF:000019', NULL, NULL, 'Putative e3 ubiquitin-protein ligase huwe1 isoform x2', NULL, NULL, NULL, NULL, NULL, 4),
(48096, NULL, 'G3DSA:1.10.730.10:FF:000003', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(48097, NULL, 'G3DSA:2.60.200.20:FF:000018', NULL, NULL, 'Centrosomal protein of 170 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(48098, NULL, 'G3DSA:1.10.472.10:FF:000094', NULL, NULL, 'G1/S-specific cyclin-D3 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(48099, NULL, 'G3DSA:3.80.10.10:FF:003806', NULL, NULL, 'Septation initiation network scaffold protein cdc11', NULL, NULL, NULL, NULL, NULL, 4),
(48100, NULL, 'G3DSA:3.30.70.1230:FF:000220', NULL, NULL, 'Atrial natriuretic peptide receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48101, NULL, 'G3DSA:3.30.470.20:FF:000226', NULL, NULL, 'Pyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(48102, NULL, 'G3DSA:2.10.70.10:FF:000269', NULL, NULL, 'Complement component 1, s subcomponent', NULL, NULL, NULL, NULL, NULL, 4),
(48103, NULL, 'G3DSA:3.40.50.150:FF:001721', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48104, NULL, 'G3DSA:1.20.120.1900:FF:000016', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(48105, NULL, 'G3DSA:3.40.50.300:FF:005509', NULL, NULL, 'RAD51-like 3 (S. cerevisiae), isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(48106, NULL, 'G3DSA:3.30.500.10:FF:000002', NULL, NULL, 'Antigen-presenting glycoprotein CD1d1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(48107, NULL, 'G3DSA:2.40.170.20:FF:000087', NULL, NULL, 'TonB dependent receptor', NULL, NULL, NULL, NULL, NULL, 4),
(48108, NULL, 'G3DSA:2.70.20.20:FF:000002', NULL, NULL, 'Matrix protein VP40', NULL, NULL, NULL, NULL, NULL, 4),
(48109, NULL, 'G3DSA:2.40.10.10:FF:000438', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48110, NULL, 'G3DSA:3.40.50.10240:FF:000008', NULL, NULL, 'Thiamine pyrophosphokinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48111, NULL, 'G3DSA:3.30.70.870:FF:000004', NULL, NULL, 'Translation factor GUF1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(48112, NULL, 'G3DSA:3.30.70.330:FF:001124', NULL, NULL, 'Nucleic acid binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(48113, NULL, 'G3DSA:3.40.50.10910:FF:000001', NULL, NULL, 'Imidazolonepropionase-like amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(48114, NULL, 'G3DSA:2.60.40.150:FF:000460', NULL, NULL, 'Bud/polarization protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48115, NULL, 'G3DSA:3.80.10.10:FF:002845', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48116, NULL, 'G3DSA:3.30.9.10:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48117, NULL, 'G3DSA:3.50.50.60:FF:001251', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(48118, NULL, 'G3DSA:3.30.300.160:FF:000007', NULL, NULL, 'Type II secretion system protein GspE', NULL, NULL, NULL, NULL, NULL, 4),
(48119, NULL, 'G3DSA:2.30.29.30:FF:000555', NULL, NULL, 'dynamin-1-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(48120, NULL, 'G3DSA:1.25.40.90:FF:000092', NULL, NULL, 'Putative clathrin assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(48121, NULL, 'G3DSA:3.20.20.140:FF:000452', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(48122, NULL, 'G3DSA:3.30.379.10:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48123, NULL, 'G3DSA:1.20.80.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48124, NULL, 'G3DSA:2.130.10.10:FF:002132', NULL, NULL, 'WD domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(48125, NULL, 'G3DSA:3.40.50.410:FF:000198', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(48126, NULL, 'G3DSA:3.30.450.60:FF:000068', NULL, NULL, 'AP-1 complex subunit mu-2', NULL, NULL, NULL, NULL, NULL, 4),
(48127, NULL, 'G3DSA:3.40.850.10:FF:000014', NULL, NULL, 'Kinesin-like protein KIN-7G', NULL, NULL, NULL, NULL, NULL, 4),
(48128, NULL, 'G3DSA:1.10.1420.10:FF:000035', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(48129, NULL, 'G3DSA:3.40.30.10:FF:000510', NULL, NULL, 'Iodothyronine deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(48130, NULL, 'G3DSA:3.40.50.10220:FF:000002', NULL, NULL, 'DNA polymerase III subunit psi', NULL, NULL, NULL, NULL, NULL, 4),
(48131, NULL, 'G3DSA:1.20.1070.10:FF:001000', NULL, NULL, 'opsin', NULL, NULL, NULL, NULL, NULL, 4),
(48132, NULL, 'G3DSA:3.30.559.30:FF:000031', NULL, NULL, 'Nonribosomal peptide synthase GliP2', NULL, NULL, NULL, NULL, NULL, 4),
(48133, NULL, 'G3DSA:1.20.1250.20:FF:002192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48134, NULL, 'G3DSA:1.25.10.10:FF:001572', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48135, NULL, 'G3DSA:1.20.1560.10:FF:000267', NULL, NULL, 'p-GlycoProtein related', NULL, NULL, NULL, NULL, NULL, 4),
(48136, NULL, 'G3DSA:3.10.310.20:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48137, NULL, 'G3DSA:3.30.470.10:FF:000004', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(48138, NULL, 'G3DSA:2.170.270.10:FF:000241', NULL, NULL, 'SET and MYND domain containing 1a', NULL, NULL, NULL, NULL, NULL, 4),
(48139, NULL, 'G3DSA:3.30.1380.20:FF:000011', NULL, NULL, 'Trafficking protein particle complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(48140, NULL, 'G3DSA:3.40.50.150:FF:000395', NULL, NULL, 'N-terminal Xaa-Pro-Lys N-methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(48141, NULL, 'G3DSA:3.30.70.330:FF:001832', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48142, NULL, 'G3DSA:2.60.120.10:FF:000627', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48143, NULL, 'G3DSA:3.10.580.10:FF:000096', NULL, NULL, 'Magnesium and cobalt efflux protein CorC', NULL, NULL, NULL, NULL, NULL, 4),
(48144, NULL, 'G3DSA:2.130.10.10:FF:005875', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48145, NULL, 'G3DSA:2.60.40.10:FF:004059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48146, NULL, 'G3DSA:3.50.4.10:FF:000035', NULL, NULL, 'Hepatocyte growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(48147, NULL, 'G3DSA:3.40.50.300:FF:001547', NULL, NULL, 'Dynein heavy chain, cytosolic, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48148, NULL, 'G3DSA:2.40.10.10:FF:000129', NULL, NULL, 'Tequila, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(48149, NULL, 'G3DSA:3.10.170.20:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48150, NULL, 'G3DSA:3.65.10.10:FF:000026', NULL, NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(48151, NULL, 'G3DSA:1.10.472.10:FF:000127', NULL, NULL, 'Cyclin I family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(48152, NULL, 'G3DSA:1.10.630.10:FF:000147', NULL, NULL, '(S)-stylopine synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(48153, NULL, 'G3DSA:3.40.850.10:FF:000380', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48154, NULL, 'G3DSA:2.60.40.10:FF:005818', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48155, NULL, 'G3DSA:2.60.40.150:FF:000004', NULL, NULL, 'RNA helicase, activating signal cointegrator 1', NULL, NULL, NULL, NULL, NULL, 4),
(48156, NULL, 'G3DSA:2.30.29.30:FF:000807', NULL, NULL, 'Protein CBG15618', NULL, NULL, NULL, NULL, NULL, 4),
(48157, NULL, 'G3DSA:1.10.8.10:FF:000351', NULL, NULL, 'UBA domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(48158, NULL, 'G3DSA:1.20.1560.10:FF:000609', NULL, NULL, 'ABC transporter, multidrug resistance associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(48159, NULL, 'G3DSA:1.20.120.160:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48160, NULL, 'G3DSA:3.40.980.10:FF:000018', NULL, NULL, 'CinA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(48161, NULL, 'G3DSA:3.30.200.20:FF:001696', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48162, NULL, 'G3DSA:3.80.10.10:FF:003245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48163, NULL, 'G3DSA:2.130.10.10:FF:001148', NULL, NULL, 'WD repeat-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(48164, NULL, 'G3DSA:1.20.5.450:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48165, NULL, 'G3DSA:3.40.50.1000:FF:000323', NULL, NULL, 'Phosphoglycolate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(48166, NULL, 'G3DSA:3.40.1000.50:FF:000006', NULL, NULL, 'Repressor of RNA polymerase III transcription MAF1', NULL, NULL, NULL, NULL, NULL, 4),
(48167, NULL, 'G3DSA:3.40.190.10:FF:000789', NULL, NULL, 'Peptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(48168, NULL, 'G3DSA:2.40.10.230:FF:000004', NULL, NULL, 'H/ACA ribonucleoprotein complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(48169, NULL, 'G3DSA:1.10.472.30:FF:000004', NULL, NULL, 'SPOC domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(48170, NULL, 'G3DSA:3.30.450.20:FF:000427', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(48171, NULL, 'G3DSA:2.30.30.140:FF:000343', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(48172, NULL, 'G3DSA:3.10.100.10:FF:000212', NULL, NULL, 'GM21154', NULL, NULL, NULL, NULL, NULL, 4),
(48173, NULL, 'G3DSA:3.20.20.80:FF:000498', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48174, NULL, 'G3DSA:3.40.50.720:FF:001105', NULL, NULL, 'WGS project CABT00000000 data, contig 2.10', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(48175, NULL, 'G3DSA:3.40.50.300:FF:004200', NULL, NULL, 'DNA2/NAM7 helicase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(48176, NULL, 'G3DSA:3.90.1150.10:FF:000033', NULL, NULL, 'Cystathionine gamma-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(48177, NULL, 'G3DSA:2.60.40.10:FF:001075', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(48178, NULL, 'G3DSA:2.130.10.10:FF:000108', NULL, NULL, 'cytoplasmic dynein 1 intermediate chain 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(48179, NULL, 'G3DSA:3.80.10.10:FF:003256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48180, NULL, 'G3DSA:2.60.40.700:FF:000001', NULL, NULL, 'Diphtheria toxin', NULL, NULL, NULL, NULL, NULL, 4),
(48181, NULL, 'G3DSA:1.20.1250.20:FF:001663', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48182, NULL, 'G3DSA:1.25.40.20:FF:000335', NULL, NULL, 'Palmitoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(48183, NULL, 'G3DSA:1.20.120.850:FF:000020', NULL, NULL, 'DNA repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48184, NULL, 'G3DSA:2.40.40.20:FF:000044', NULL, NULL, 'Transitional endoplasmic reticulum ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(48185, NULL, 'G3DSA:3.30.160.60:FF:004267', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48186, NULL, 'G3DSA:3.20.20.10:FF:000050', NULL, NULL, 'L-glutamyl-[BtrI acyl-carrier protein] decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(48187, NULL, 'G3DSA:3.40.50.2300:FF:001455', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48188, NULL, 'G3DSA:1.10.287.70:FF:000714', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48189, NULL, 'G3DSA:2.60.260.40:FF:000005', NULL, NULL, 'NADH dehydrogenase [ubiquinone] iron-sulfur protein 6, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(48190, NULL, 'G3DSA:3.40.50.10190:FF:000089', NULL, NULL, 'DDK kinase regulatory subunit DBF4', NULL, NULL, NULL, NULL, NULL, 4),
(48191, NULL, 'G3DSA:4.10.280.10:FF:000153', NULL, NULL, 'Transcription factor bHLH167', NULL, NULL, NULL, NULL, NULL, 4),
(48192, NULL, 'G3DSA:1.10.287.810:FF:000010', NULL, NULL, 'Mitochondrial import inner membrane translocase subunit TIM9, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48193, NULL, 'G3DSA:2.60.120.10:FF:000419', NULL, NULL, 'Regulatory subunit of protein kinase a-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(48194, NULL, 'G3DSA:3.40.50.150:FF:001148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48195, NULL, 'G3DSA:1.20.920.10:FF:000212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48196, NULL, 'G3DSA:3.90.850.10:FF:000008', NULL, NULL, 'FAA hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(48197, NULL, 'G3DSA:1.10.730.10:FF:000211', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48198, NULL, 'G3DSA:3.30.70.330:FF:002984', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48199, NULL, 'G3DSA:2.40.160.20:FF:000030', NULL, NULL, 'p44-18ES, P44 outer membrane protein expression locus with P44-18', NULL, NULL, NULL, NULL, NULL, 4),
(48200, NULL, 'G3DSA:1.25.10.10:FF:002533', NULL, NULL, 'Exportin 1 (CRM1 homolog, yeast) b', NULL, NULL, NULL, NULL, NULL, 4),
(48201, NULL, 'G3DSA:2.60.40.150:FF:000572', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48202, NULL, 'G3DSA:3.90.550.10:FF:000082', NULL, NULL, 'Dolichol-phosphate mannosyltransferase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(48203, NULL, 'G3DSA:1.20.120.230:FF:000042', NULL, NULL, 'TaLiN', NULL, NULL, NULL, NULL, NULL, 4),
(48204, NULL, 'G3DSA:1.10.110.30:FF:000001', NULL, NULL, 'CCA-adding enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(48205, NULL, 'G3DSA:1.10.510.10:FF:002128', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48206, NULL, 'G3DSA:2.60.40.60:FF:000898', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48207, NULL, 'G3DSA:3.40.1810.10:FF:000005', NULL, NULL, 'MADS-box transcription factor 21', NULL, NULL, NULL, NULL, NULL, 4),
(48208, NULL, 'G3DSA:3.30.420.10:FF:000389', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(48209, NULL, 'G3DSA:3.40.50.300:FF:006342', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48210, NULL, 'G3DSA:3.40.50.1820:FF:000344', NULL, NULL, 'Acylamino-acid-releasing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(48211, NULL, 'G3DSA:3.30.710.10:FF:000248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48212, NULL, 'G3DSA:3.30.200.20:FF:001224', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48213, NULL, 'G3DSA:2.102.10.10:FF:000008', NULL, NULL, 'Ubiquinol-cytochrome c reductase iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4),
(48214, NULL, 'G3DSA:2.130.10.10:FF:005431', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48215, NULL, 'G3DSA:3.30.420.10:FF:000501', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48216, NULL, 'G3DSA:1.25.40.10:FF:005115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48217, NULL, 'G3DSA:3.40.50.300:FF:003683', NULL, NULL, 'Peroxisome biosynthesis protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(48218, NULL, 'G3DSA:3.40.50.620:FF:000816', NULL, NULL, 'Probable ethanolamine-phosphate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(48219, NULL, 'G3DSA:1.20.1070.10:FF:001348', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48220, NULL, 'G3DSA:1.20.58.390:FF:000186', NULL, NULL, 'Gamma-aminobutyric acid (GABA) A receptor, alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(48221, NULL, 'G3DSA:1.10.10.10:FF:001167', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(48222, NULL, 'G3DSA:1.10.1200.10:FF:000052', NULL, NULL, 'Nonribosomal peptide synthase GliP', NULL, NULL, NULL, NULL, NULL, 4),
(48223, NULL, 'G3DSA:3.30.930.10:FF:000360', NULL, NULL, 'Alanyl-tRNA synthetase 2, mitochondrial (putative)', NULL, NULL, NULL, NULL, NULL, 4),
(48224, NULL, 'G3DSA:1.10.238.10:FF:000067', NULL, NULL, 'serine/threonine protein phosphatase 2A regulatory subunit B''''beta-like', NULL, NULL, NULL, NULL, NULL, 4),
(48225, NULL, 'G3DSA:3.80.10.10:FF:002637', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase GSO2', NULL, NULL, NULL, NULL, NULL, 4),
(48226, NULL, 'G3DSA:3.40.50.2300:FF:000027', NULL, NULL, 'HTH-type transcriptional regulator GalR', NULL, NULL, NULL, NULL, NULL, 4),
(48227, NULL, 'G3DSA:3.40.50.720:FF:002533', NULL, NULL, 'L-lactate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(48228, NULL, 'G3DSA:1.25.10.10:FF:003152', NULL, NULL, 'Target of rapamycin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(48229, NULL, 'G3DSA:1.20.1280.290:FF:000057', NULL, NULL, 'Bidirectional sugar transporter SWEET', NULL, NULL, NULL, NULL, NULL, 4),
(48230, NULL, 'G3DSA:1.10.10.250:FF:000015', NULL, NULL, '60S ribosomal protein L12, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48231, NULL, 'G3DSA:3.40.190.10:FF:000694', NULL, NULL, 'ABC transporter, solute-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(48232, NULL, 'G3DSA:3.10.330.10:FF:000021', NULL, NULL, 'Vesicle-fusing ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48233, NULL, 'G3DSA:3.40.50.1820:FF:000765', NULL, NULL, 'Kynurenine formamidase', NULL, NULL, NULL, NULL, NULL, 4),
(48234, NULL, 'G3DSA:3.80.10.10:FF:001227', NULL, NULL, 'F-box/LRR-repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(48235, NULL, 'G3DSA:1.25.40.10:FF:000006', NULL, NULL, 'Prolyl 4-hydroxylase subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(48236, NULL, 'G3DSA:2.60.40.10:FF:002805', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48237, NULL, 'G3DSA:3.30.420.10:FF:000490', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48238, NULL, 'G3DSA:3.90.1640.20:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48239, NULL, 'G3DSA:3.40.50.150:FF:000529', NULL, NULL, 'tRNA (1-methyladenosine) methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(48240, NULL, 'G3DSA:2.10.25.10:FF:001811', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48241, NULL, 'G3DSA:1.25.40.10:FF:000899', NULL, NULL, 'Si:ch211-114c17.1', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(48242, NULL, 'G3DSA:1.10.8.1080:FF:000006', NULL, NULL, 'Glucokinase regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(48243, NULL, 'G3DSA:1.10.288.10:FF:000002', NULL, NULL, 'Methionine synthase (B12-dependent)', NULL, NULL, NULL, NULL, NULL, 4),
(48244, NULL, 'G3DSA:3.40.50.300:FF:003469', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48245, NULL, 'G3DSA:1.10.260.70:FF:000001', NULL, NULL, 'DNA-binding protein SATB', NULL, NULL, NULL, NULL, NULL, 4),
(48246, NULL, 'G3DSA:2.40.160.120:FF:000006', NULL, NULL, 'oxysterol-binding protein-related protein 1D isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(48247, NULL, 'G3DSA:3.40.430.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48248, NULL, 'G3DSA:2.40.10.10:FF:000017', NULL, NULL, 'Chymotrypsin-like elastase family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(48249, NULL, 'G3DSA:3.90.830.10:FF:000013', NULL, NULL, 'BnaCnng68440D protein', NULL, NULL, NULL, NULL, NULL, 4),
(48250, NULL, 'G3DSA:3.90.470.10:FF:000030', NULL, NULL, 'RL17, ribosomal protein 17-like 60S large ribosomal subunit', NULL, NULL, NULL, NULL, NULL, 4),
(48251, NULL, 'G3DSA:2.130.10.10:FF:003874', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48252, NULL, 'G3DSA:2.20.20.160:FF:000001', NULL, NULL, 'Blast:Protein giant-lens', NULL, NULL, NULL, NULL, NULL, 4),
(48253, NULL, 'G3DSA:3.40.50.300:FF:007865', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48254, NULL, 'G3DSA:3.40.50.1820:FF:001058', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48255, NULL, 'G3DSA:1.10.10.60:FF:000518', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(48256, NULL, 'G3DSA:2.130.10.10:FF:000529', NULL, NULL, 'WD repeat domain phosphoinositide-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(48257, NULL, 'G3DSA:1.10.3370.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48258, NULL, 'G3DSA:3.20.20.80:FF:000610', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48259, NULL, 'G3DSA:3.40.50.300:FF:002059', NULL, NULL, 'ADP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(48260, NULL, 'G3DSA:2.30.30.40:FF:000073', NULL, NULL, 'SH3 and cysteine-rich domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(48261, NULL, 'G3DSA:1.20.1250.20:FF:001242', NULL, NULL, 'Sialin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48262, NULL, 'G3DSA:1.50.10.10:FF:000103', NULL, NULL, 'Mannosyl-oligosaccharide 1,2-alpha-mannosidase IB', NULL, NULL, NULL, NULL, NULL, 4),
(48263, NULL, 'G3DSA:1.10.418.10:FF:000165', NULL, NULL, 'Rac guanine nucleotide exchange factor B', NULL, NULL, NULL, NULL, NULL, 4),
(48264, NULL, 'G3DSA:1.25.40.10:FF:004598', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48265, NULL, 'G3DSA:2.130.10.10:FF:003177', NULL, NULL, 'WD repeat domain 27', NULL, NULL, NULL, NULL, NULL, 4),
(48266, NULL, 'G3DSA:3.40.1190.10:FF:000002', NULL, NULL, 'UDP-N-acetylmuramoylalanine--D-glutamate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(48267, NULL, 'G3DSA:2.130.10.10:FF:001957', NULL, NULL, 'U5 snRNP-specific 40 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(48268, NULL, 'G3DSA:1.20.1070.10:FF:000729', NULL, NULL, 'Frizzled 3, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(48269, NULL, 'G3DSA:2.60.40.60:FF:000201', NULL, NULL, 'Dachsous cadherin-related 1', NULL, NULL, NULL, NULL, NULL, 4),
(48270, NULL, 'G3DSA:1.25.40.20:FF:001633', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(48271, NULL, 'G3DSA:3.30.70.60:FF:000011', NULL, NULL, '30S ribosomal protein S6', NULL, NULL, NULL, NULL, NULL, 4),
(48272, NULL, 'G3DSA:1.25.40.10:FF:003412', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g53600, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(48273, NULL, 'G3DSA:2.10.25.10:FF:000390', NULL, NULL, 'Laminin subunit alpha 3', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(48274, NULL, 'G3DSA:2.60.40.10:FF:005678', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48275, NULL, 'G3DSA:3.40.50.300:FF:002290', NULL, NULL, 'Elongation factor Tu', NULL, NULL, NULL, NULL, NULL, 4),
(48276, NULL, 'G3DSA:1.20.1070.10:FF:000617', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48277, NULL, 'G3DSA:2.60.40.790:FF:000185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48278, NULL, 'G3DSA:3.30.250.20:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48279, NULL, 'G3DSA:3.40.50.300:FF:005386', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48280, NULL, 'G3DSA:3.40.30.10:FF:000393', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(48281, NULL, 'G3DSA:1.10.565.10:FF:000158', NULL, NULL, 'Retinoid X receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48282, NULL, 'G3DSA:1.20.58.390:FF:000091', NULL, NULL, 'Glycine receptor, beta a', NULL, NULL, NULL, NULL, NULL, 4),
(48283, NULL, 'G3DSA:3.40.50.300:FF:000243', NULL, NULL, 'Bifunctional 3''-phosphoadenosine 5''-phosphosulfate synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(48284, NULL, 'G3DSA:3.30.497.10:FF:000133', NULL, NULL, 'Serine protease inhibitor 2.1', NULL, NULL, NULL, NULL, NULL, 4),
(48285, NULL, 'G3DSA:2.30.29.30:FF:001308', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(48286, NULL, 'G3DSA:3.30.70.330:FF:001135', NULL, NULL, 'Poly(A) binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(48287, NULL, 'G3DSA:3.30.70.80:FF:000017', NULL, NULL, 'Subtilisin-like protease SBT2.5', NULL, NULL, NULL, NULL, NULL, 4),
(48288, NULL, 'G3DSA:1.20.58.60:FF:000454', NULL, NULL, 'Dystonin', NULL, NULL, NULL, NULL, NULL, 4),
(48289, NULL, 'G3DSA:1.10.10.10:FF:001959', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48290, NULL, 'G3DSA:1.20.58.60:FF:000566', NULL, NULL, 'Dystrophin', NULL, NULL, NULL, NULL, NULL, 4),
(48291, NULL, 'G3DSA:3.30.1520.10:FF:000098', NULL, NULL, 'Rho GTPase-activating protein 33', NULL, NULL, NULL, NULL, NULL, 4),
(48292, NULL, 'G3DSA:1.10.510.10:FF:000672', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(48293, NULL, 'G3DSA:2.10.25.10:FF:001002', NULL, NULL, 'Protein eyes shut homolog', NULL, NULL, NULL, NULL, NULL, 4),
(48294, NULL, 'G3DSA:3.40.30.10:FF:000263', NULL, NULL, 'Redoxin', NULL, NULL, NULL, NULL, NULL, 4),
(48295, NULL, 'G3DSA:3.30.1330.30:FF:000050', NULL, NULL, 'Putative selenocysteine insertion sequence-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(48296, NULL, 'G3DSA:3.40.50.720:FF:001914', NULL, NULL, 'UDP-galactopyranose mutase', NULL, NULL, NULL, NULL, NULL, 4),
(48297, NULL, 'G3DSA:1.50.10.130:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48298, NULL, 'G3DSA:3.40.80.10:FF:000002', NULL, NULL, '1,6-anhydro-N-acetylmuramyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(48299, NULL, 'G3DSA:1.20.1280.170:FF:000004', NULL, NULL, 'Exocyst complex component 7', NULL, NULL, NULL, NULL, NULL, 4),
(48300, NULL, 'G3DSA:3.40.50.12470:FF:000014', NULL, NULL, 'Dehydrogenase E1 and transketolase domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(48301, NULL, 'G3DSA:1.20.1740.10:FF:000253', NULL, NULL, 'Solute carrier family 12 member 3', NULL, NULL, NULL, NULL, NULL, 4),
(48302, NULL, 'G3DSA:2.60.120.200:FF:000731', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48303, NULL, 'G3DSA:2.30.30.40:FF:000426', NULL, NULL, 'Peroxisomal membrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48304, NULL, 'G3DSA:3.30.750.44:FF:000011', NULL, NULL, 'Tricorn protease homolog', NULL, NULL, NULL, NULL, NULL, 4),
(48305, NULL, 'G3DSA:2.40.128.20:FF:000045', NULL, NULL, 'CRE-LPR-2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(48306, NULL, 'G3DSA:1.10.150.530:FF:000022', NULL, NULL, 'Probable dual-specificity RNA methyltransferase RlmN', NULL, NULL, NULL, NULL, NULL, 4),
(48307, NULL, 'G3DSA:3.20.20.70:FF:000169', NULL, NULL, 'Fatty acid synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(48308, NULL, 'G3DSA:2.170.16.10:FF:000035', NULL, NULL, 'DNA topoisomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(48309, NULL, 'G3DSA:3.30.160.60:FF:003862', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48310, NULL, 'G3DSA:1.25.40.10:FF:003884', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48311, NULL, 'G3DSA:2.40.170.20:FF:000115', NULL, NULL, 'Putative outer membrane protein, probably involved in nutrient binding', NULL, NULL, NULL, NULL, NULL, 4),
(48312, NULL, 'G3DSA:1.10.510.10:FF:001509', NULL, NULL, 'Double-stranded RNA activated protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(48313, NULL, 'G3DSA:3.30.930.10:FF:000129', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(48314, NULL, 'G3DSA:3.40.50.300:FF:000614', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(48315, NULL, 'G3DSA:2.130.10.10:FF:006050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48316, NULL, 'G3DSA:2.60.40.10:FF:005239', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48317, NULL, 'G3DSA:2.30.29.30:FF:000566', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(48318, NULL, 'G3DSA:3.30.1330.80:FF:000020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48319, NULL, 'G3DSA:3.40.50.410:FF:000276', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(48320, NULL, 'G3DSA:2.60.40.10:FF:005127', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48321, NULL, 'G3DSA:3.40.50.300:FF:004425', NULL, NULL, 'Small GTPase Rab7, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48322, NULL, 'G3DSA:1.25.40.10:FF:003772', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48323, NULL, 'G3DSA:2.60.40.1090:FF:000025', NULL, NULL, 'Fimbrial protein', NULL, NULL, NULL, NULL, NULL, 4),
(48324, NULL, 'G3DSA:1.25.10.10:FF:000616', NULL, NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48325, NULL, 'G3DSA:1.10.390.10:FF:000111', NULL, NULL, 'GH14075p', NULL, NULL, NULL, NULL, NULL, 4),
(48326, NULL, 'G3DSA:3.30.70.330:FF:002080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48327, NULL, 'G3DSA:3.80.10.10:FF:002525', NULL, NULL, 'Leucine-rich repeats and immunoglobulin-like domains protein sma-10', NULL, NULL, NULL, NULL, NULL, 4),
(48328, NULL, 'G3DSA:3.30.70.330:FF:000646', NULL, NULL, 'U1 small nuclear ribonucleoprotein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48329, NULL, 'G3DSA:1.10.287.70:FF:000361', NULL, NULL, 'TWiK family of potassium channels', NULL, NULL, NULL, NULL, NULL, 4),
(48330, NULL, 'G3DSA:3.20.20.70:FF:000702', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48331, NULL, 'G3DSA:2.60.40.10:FF:001867', NULL, NULL, 'Titin', NULL, NULL, NULL, NULL, NULL, 4),
(48332, NULL, 'G3DSA:2.70.170.10:FF:000302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48333, NULL, 'G3DSA:2.30.180.10:FF:000008', NULL, NULL, 'Fasciclin-like arabinogalactan protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(48334, NULL, 'G3DSA:3.10.20.620:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48335, NULL, 'G3DSA:2.60.40.10:FF:000456', NULL, NULL, 'protogenin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(48336, NULL, 'G3DSA:2.10.25.10:FF:000513', NULL, NULL, 'Coagulation factor VII', NULL, NULL, NULL, NULL, NULL, 4),
(48337, NULL, 'G3DSA:1.20.970.10:FF:000035', NULL, NULL, 'Uncharacterized protein aq_209', NULL, NULL, NULL, NULL, NULL, 4),
(48338, NULL, 'G3DSA:3.30.40.10:FF:001720', NULL, NULL, 'WD40 repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(48339, NULL, 'G3DSA:1.10.10.10:FF:000083', NULL, NULL, 'AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(48340, NULL, 'G3DSA:1.10.3090.10:FF:000014', NULL, NULL, 'tRNA nucleotidyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48341, NULL, 'G3DSA:3.40.50.11350:FF:000021', NULL, NULL, 'Alpha(1,6)-fucosyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(48342, NULL, 'G3DSA:3.10.20.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48343, NULL, 'G3DSA:2.10.50.30:FF:000021', NULL, NULL, 'Vomeronasal 2, receptor 28', NULL, NULL, NULL, NULL, NULL, 4),
(48344, NULL, 'G3DSA:3.30.160.60:FF:000001', NULL, NULL, 'Zinc finger protein 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(48345, NULL, 'G3DSA:3.30.160.60:FF:002238', NULL, NULL, 'zinc finger protein 606 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(48346, NULL, 'G3DSA:3.30.40.10:FF:000764', NULL, NULL, 'RING-H2 zinc finger protein RHA4a', NULL, NULL, NULL, NULL, NULL, 4),
(48347, NULL, 'G3DSA:3.30.830.10:FF:000307', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48348, NULL, 'G3DSA:2.60.120.650:FF:000068', NULL, NULL, 'UTX (Ubiquitously transcribed TPR on X) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(48349, NULL, 'G3DSA:2.10.25.10:FF:001699', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48350, NULL, 'G3DSA:3.30.390.50:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48351, NULL, 'G3DSA:1.10.472.80:FF:000075', NULL, NULL, 'Growth hormone-regulated TBC protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(48352, NULL, 'G3DSA:1.10.555.10:FF:000073', NULL, NULL, 'SLIT-ROBO Rho GTPase-activating protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(48353, NULL, 'G3DSA:2.60.120.40:FF:000063', NULL, NULL, 'Collagen X alpha I', NULL, NULL, NULL, NULL, NULL, 4),
(48354, NULL, 'G3DSA:1.20.58.2010:FF:000002', NULL, NULL, 'Rop guanine nucleotide exchange factor 9', NULL, NULL, NULL, NULL, NULL, 4),
(48355, NULL, 'G3DSA:3.40.50.300:FF:007735', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48356, NULL, 'G3DSA:3.30.160.60:FF:001041', NULL, NULL, 'Zinc finger protein 142', NULL, NULL, NULL, NULL, NULL, 4),
(48357, NULL, 'G3DSA:2.120.10.30:FF:000047', NULL, NULL, 'Acylamino-acid-releasing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(48358, NULL, 'G3DSA:3.70.10.10:FF:000019', NULL, NULL, 'Checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(48359, NULL, 'G3DSA:1.10.1370.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48360, NULL, 'G3DSA:1.25.40.10:FF:001063', NULL, NULL, 'Pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(48361, NULL, 'G3DSA:3.30.1120.10:FF:000017', NULL, NULL, 'Sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(48362, NULL, 'G3DSA:1.20.1250.20:FF:000623', NULL, NULL, 'Mch2p', NULL, NULL, NULL, NULL, NULL, 4),
(48363, NULL, 'G3DSA:3.40.140.10:FF:000174', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(48364, NULL, 'G3DSA:2.20.100.10:FF:000045', NULL, NULL, 'ADAMTS-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(48365, NULL, 'G3DSA:2.60.120.10:FF:000520', NULL, NULL, 'cGMP binding protein with small GTPase-serine/threonine kinase-dep-rasgef-gram-and two cGMP binding domains', NULL, NULL, NULL, NULL, NULL, 4),
(48366, NULL, 'G3DSA:3.30.420.40:FF:000706', NULL, NULL, 'Mitochondrion protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48367, NULL, 'G3DSA:1.25.10.10:FF:000830', NULL, NULL, 'Importin subunit alpha, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48368, NULL, 'G3DSA:1.20.1070.10:FF:001253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48369, NULL, 'G3DSA:2.130.10.10:FF:003065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48370, NULL, 'G3DSA:3.40.50.10190:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48371, NULL, 'G3DSA:3.40.50.620:FF:000463', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(48372, NULL, 'G3DSA:3.60.21.10:FF:000258', NULL, NULL, 'Phosphoprotein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(48373, NULL, 'G3DSA:3.10.100.10:FF:000324', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48374, NULL, 'G3DSA:3.30.200.20:FF:001584', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(48375, NULL, 'G3DSA:2.60.120.260:FF:000479', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48376, NULL, 'G3DSA:3.40.50.300:FF:002952', NULL, NULL, 'CBN-MAC-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(48377, NULL, 'G3DSA:3.10.180.10:FF:000104', NULL, NULL, 'Gll3193 protein', NULL, NULL, NULL, NULL, NULL, 4),
(48378, NULL, 'G3DSA:1.20.1300.10:FF:000035', NULL, NULL, 'Succinate dehydrogenase, hydrophobic membrane anchor protein', NULL, NULL, NULL, NULL, NULL, 4),
(48379, NULL, 'G3DSA:2.40.70.10:FF:000094', NULL, NULL, 'Eukaryotic aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(48380, NULL, 'G3DSA:3.40.50.2300:FF:000819', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48381, NULL, 'G3DSA:3.40.50.620:FF:000693', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48382, NULL, 'G3DSA:3.30.780.10:FF:000073', NULL, NULL, 'Exocyst complex component SEC5A', NULL, NULL, NULL, NULL, NULL, 4),
(48383, NULL, 'G3DSA:3.30.930.10:FF:000343', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48384, NULL, 'G3DSA:2.60.40.10:FF:003862', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48385, NULL, 'G3DSA:1.10.630.10:FF:000259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48386, NULL, 'G3DSA:3.30.2290.10:FF:000001', NULL, NULL, 'Metalloprotease TldD homolog', NULL, NULL, NULL, NULL, NULL, 4),
(48387, NULL, 'G3DSA:1.50.40.10:FF:000352', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48388, NULL, 'G3DSA:3.30.9.10:FF:000225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48389, NULL, 'G3DSA:3.80.10.10:FF:003144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48390, NULL, 'G3DSA:3.80.10.10:FF:001244', NULL, NULL, 'Carboxypeptidase N subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(48391, NULL, 'G3DSA:3.30.70.330:FF:001927', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48392, NULL, 'G3DSA:1.20.1560.10:FF:000604', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48393, NULL, 'G3DSA:3.30.70.330:FF:001591', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48394, NULL, 'G3DSA:1.10.3860.10:FF:000034', NULL, NULL, 'Excitatory amino acid transporter 4', NULL, NULL, NULL, NULL, NULL, 4),
(48395, NULL, 'G3DSA:3.40.190.290:FF:000062', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(48396, NULL, 'G3DSA:2.60.40.60:FF:000117', NULL, NULL, 'protocadherin-8 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(48397, NULL, 'G3DSA:3.90.230.10:FF:000035', NULL, NULL, 'T0096427 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(48398, NULL, 'G3DSA:3.30.160.60:FF:002013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48399, NULL, 'G3DSA:1.20.144.10:FF:000021', NULL, NULL, 'Glucose-6-phosphatase 2', NULL, NULL, NULL, NULL, NULL, 4),
(48400, NULL, 'G3DSA:3.40.720.10:FF:000252', NULL, NULL, 'Arylsulfatase A', NULL, NULL, NULL, NULL, NULL, 4),
(48401, NULL, 'G3DSA:1.10.10.10:FF:001504', NULL, NULL, 'Transcriptional regulator, Crp/Fnr family', NULL, NULL, NULL, NULL, NULL, 4),
(48402, NULL, 'G3DSA:3.30.160.60:FF:005678', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48403, NULL, 'G3DSA:2.40.50.140:FF:001014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48404, NULL, 'G3DSA:3.30.70.330:FF:002872', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48405, NULL, 'G3DSA:2.40.160.210:FF:000033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48406, NULL, 'G3DSA:2.130.10.10:FF:005543', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48407, NULL, 'G3DSA:1.10.640.10:FF:000007', NULL, NULL, 'Peroxidase mlt-7', NULL, NULL, NULL, NULL, NULL, 4),
(48408, NULL, 'G3DSA:1.20.1720.10:FF:000027', NULL, NULL, 'MFS multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48409, NULL, 'G3DSA:3.30.450.20:FF:000539', NULL, NULL, 'C4-dicarboxylate transport sensor protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(48410, NULL, 'G3DSA:3.90.180.10:FF:000154', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48411, NULL, 'G3DSA:3.40.1110.10:FF:000014', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(48412, NULL, 'G3DSA:1.20.1070.10:FF:001236', NULL, NULL, 'frizzled-10-B-like', NULL, NULL, NULL, NULL, NULL, 4),
(48413, NULL, 'G3DSA:3.90.550.10:FF:000194', NULL, NULL, 'Cellulose synthase-like protein G2 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(48414, NULL, 'G3DSA:2.80.10.50:FF:000218', NULL, NULL, 'Dolichyl-phosphate-mannose--protein mannosyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(48415, NULL, 'G3DSA:2.30.39.10:FF:000078', NULL, NULL, 'GM20478', NULL, NULL, NULL, NULL, NULL, 4),
(48416, NULL, 'G3DSA:1.10.10.60:FF:001249', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48417, NULL, 'G3DSA:3.30.1330.40:FF:000036', NULL, NULL, '2-iminobutanoate/2-iminopropanoate deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(48418, NULL, 'G3DSA:2.130.10.10:FF:003514', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48419, NULL, 'G3DSA:2.40.30.230:FF:000003', NULL, NULL, 'Regulator of nonsense transcripts 1', NULL, NULL, NULL, NULL, NULL, 4),
(48420, NULL, 'G3DSA:2.130.10.10:FF:001620', NULL, NULL, 'Flagellar inner dynein arm I1 intermediate chain IC140', NULL, NULL, NULL, NULL, NULL, 4),
(48421, NULL, 'G3DSA:1.10.510.10:FF:004045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48422, NULL, 'G3DSA:3.50.50.60:FF:000301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48423, NULL, 'G3DSA:1.10.510.10:FF:001291', NULL, NULL, 'Serine/threonine protein kinase PAK, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48424, NULL, 'G3DSA:1.25.50.20:FF:000049', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(48425, NULL, 'G3DSA:1.20.1050.10:FF:000285', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48426, NULL, 'G3DSA:2.60.40.150:FF:000600', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48427, NULL, 'G3DSA:2.60.40.10:FF:003441', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48428, NULL, 'G3DSA:1.10.10.1460:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48429, NULL, 'G3DSA:1.20.1560.10:FF:000155', NULL, NULL, 'ATP-binding cassette transporter, subfamily B, member 2, group MDR/PGP protein PpABCB2', NULL, NULL, NULL, NULL, NULL, 4),
(48430, NULL, 'G3DSA:3.10.129.10:FF:000199', NULL, NULL, 'HotDog domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(48431, NULL, 'G3DSA:2.60.40.10:FF:000344', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(48432, NULL, 'G3DSA:2.40.50.140:FF:000160', NULL, NULL, 'single-stranded DNA-binding protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(48433, NULL, 'G3DSA:1.10.357.70:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48434, NULL, 'G3DSA:1.20.1250.20:FF:001680', NULL, NULL, 'Sugar transporter ERD6-like 6', NULL, NULL, NULL, NULL, NULL, 4),
(48435, NULL, 'G3DSA:1.10.10.10:FF:000195', NULL, NULL, 'LsrR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(48436, NULL, 'G3DSA:2.60.120.260:FF:000142', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(48437, NULL, 'G3DSA:3.30.160.60:FF:003778', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48438, NULL, 'G3DSA:1.10.4160.10:FF:000026', NULL, NULL, 'Permease for cytosine/purines uracil thiamine allantoin', NULL, NULL, NULL, NULL, NULL, 4),
(48439, NULL, 'G3DSA:3.40.50.410:FF:000304', NULL, NULL, 'Serine/threonine protein kinase PpkA', NULL, NULL, NULL, NULL, NULL, 4),
(48440, NULL, 'G3DSA:4.10.280.10:FF:000041', NULL, NULL, 'aryl hydrocarbon receptor repressor', NULL, NULL, NULL, NULL, NULL, 4),
(48441, NULL, 'G3DSA:1.10.238.10:FF:001039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48442, NULL, 'G3DSA:3.40.50.1000:FF:000087', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(48443, NULL, 'G3DSA:2.40.50.140:FF:000188', NULL, NULL, 'mRNA capping enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(48444, NULL, 'G3DSA:3.90.640.10:FF:000285', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48445, NULL, 'G3DSA:3.90.70.10:FF:000415', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(48446, NULL, 'G3DSA:3.40.50.1000:FF:000183', NULL, NULL, 'Pyrimidine nucleotidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48447, NULL, 'G3DSA:4.10.1300.10:FF:000001', NULL, NULL, 'Dinoflagellate luciferase', NULL, NULL, NULL, NULL, NULL, 4),
(48448, NULL, 'G3DSA:3.30.200.20:FF:000398', NULL, NULL, 'serine/threonine-protein kinase Nek9 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(48449, NULL, 'G3DSA:1.10.8.60:FF:000349', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(48450, NULL, 'G3DSA:1.25.40.20:FF:000205', NULL, NULL, 'Fem-1 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(48451, NULL, 'G3DSA:1.10.340.30:FF:000069', NULL, NULL, 'Endonuclease III homolog', NULL, NULL, NULL, NULL, NULL, 4),
(48452, NULL, 'G3DSA:2.20.80.10:FF:000005', NULL, NULL, 'Vit-6', NULL, NULL, NULL, NULL, NULL, 4),
(48453, NULL, 'G3DSA:3.90.79.20:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48454, NULL, 'G3DSA:1.10.10.10:FF:000650', NULL, NULL, 'Transcriptional regulator, RpiR family', NULL, NULL, NULL, NULL, NULL, 4),
(48455, NULL, 'G3DSA:1.25.10.10:FF:000167', NULL, NULL, 'RNA binding protein Jsn1', NULL, NULL, NULL, NULL, NULL, 4),
(48456, NULL, 'G3DSA:3.60.40.10:FF:000381', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48457, NULL, 'G3DSA:1.25.40.540:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48458, NULL, 'G3DSA:2.60.40.10:FF:004267', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48459, NULL, 'G3DSA:1.10.533.10:FF:000039', NULL, NULL, 'Mucosa-associated lymphoid tissue lymphoma translocation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(48460, NULL, 'G3DSA:3.30.2160.10:FF:000014', NULL, NULL, 'Putative E3 ubiquitin-protein ligase HECTD3', NULL, NULL, NULL, NULL, NULL, 4),
(48461, NULL, 'G3DSA:2.20.100.10:FF:000157', NULL, NULL, 'papilin isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(48462, NULL, 'G3DSA:3.30.710.10:FF:000265', NULL, NULL, 'GM12221', NULL, NULL, NULL, NULL, NULL, 4),
(48463, NULL, 'G3DSA:2.60.40.10:FF:005919', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48464, NULL, 'G3DSA:1.25.10.10:FF:002180', NULL, NULL, 'Beta-catenin-like protein 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(48465, NULL, 'G3DSA:3.30.413.10:FF:000029', NULL, NULL, 'Sulfite reductase hemoprotein beta component (CysI)', NULL, NULL, NULL, NULL, NULL, 4),
(48466, NULL, 'G3DSA:2.130.10.10:FF:002446', NULL, NULL, 'Notchless', NULL, NULL, NULL, NULL, NULL, 4),
(48467, NULL, 'G3DSA:1.20.120.1220:FF:000014', NULL, NULL, 'ComC processing protease Leader peptidase / N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(48468, NULL, 'G3DSA:1.25.40.180:FF:000232', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48469, NULL, 'G3DSA:3.30.1640.10:FF:000045', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(48470, NULL, 'G3DSA:3.30.70.150:FF:000002', NULL, NULL, '2,3-diketo-5-methylthiopentyl-1-phosphate enolase', NULL, NULL, NULL, NULL, NULL, 4),
(48471, NULL, 'G3DSA:3.30.830.10:FF:000184', NULL, NULL, 'Peptidase, mitochondrial processing alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(48472, NULL, 'G3DSA:3.30.70.360:FF:000059', NULL, NULL, 'Dipeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48473, NULL, 'G3DSA:3.60.20.10:FF:000267', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48474, NULL, 'G3DSA:2.40.110.10:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48475, NULL, 'G3DSA:3.40.50.720:FF:000167', NULL, NULL, 'Ketol-acid reductoisomerase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(48476, NULL, 'G3DSA:1.25.10.10:FF:001235', NULL, NULL, 'CLIP-associating protein', NULL, NULL, NULL, NULL, NULL, 4),
(48477, NULL, 'G3DSA:2.130.10.10:FF:004363', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48478, NULL, 'G3DSA:3.30.420.110:FF:000019', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(48479, NULL, 'G3DSA:2.130.10.10:FF:004133', NULL, NULL, 'Uncharacterized protein C4G3.03', NULL, NULL, NULL, NULL, NULL, 4),
(48480, NULL, 'G3DSA:3.30.70.330:FF:001023', NULL, NULL, 'Pre-mRNA branch site protein p14, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48481, NULL, 'G3DSA:3.20.20.140:FF:000025', NULL, NULL, 'Dihydroorotase', NULL, NULL, NULL, NULL, NULL, 4),
(48482, NULL, 'G3DSA:3.40.50.1820:FF:000782', NULL, NULL, 'Esterase', NULL, NULL, NULL, NULL, NULL, 4),
(48483, NULL, 'G3DSA:3.30.70.2740:FF:000004', NULL, NULL, 'Glycolate oxidase, subunit GlcD', NULL, NULL, NULL, NULL, NULL, 4),
(48484, NULL, 'G3DSA:3.30.497.10:FF:000021', NULL, NULL, 'Proteinase inhibitor I4 serpin', NULL, NULL, NULL, NULL, NULL, 4),
(48485, NULL, 'G3DSA:3.90.1600.10:FF:000006', NULL, NULL, 'DNA polymerase epsilon catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(48486, NULL, 'G3DSA:3.30.160.60:FF:000905', NULL, NULL, 'PR domain containing 14', NULL, NULL, NULL, NULL, NULL, 4),
(48487, NULL, 'G3DSA:1.10.20.10:FF:000252', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48488, NULL, 'G3DSA:3.40.50.800:FF:000073', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(48489, NULL, 'G3DSA:2.60.120.180:FF:000005', NULL, NULL, 'Endo-1,4-beta-xylanase', NULL, NULL, NULL, NULL, NULL, 4),
(48490, NULL, 'G3DSA:1.25.10.10:FF:000263', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(48491, NULL, 'G3DSA:2.60.40.10:FF:002013', NULL, NULL, 'KETtiN (Drosophila actin-binding) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(48492, NULL, 'G3DSA:2.20.28.10:FF:000025', NULL, NULL, 'DNA replication licensing factor MCM3', NULL, NULL, NULL, NULL, NULL, 4),
(48493, NULL, 'G3DSA:1.20.82.10:FF:000001', NULL, NULL, 'ADP-ribosyl cyclase/cyclic ADP-ribose hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(48494, NULL, 'G3DSA:1.10.10.10:FF:000987', NULL, NULL, 'Cullin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(48495, NULL, 'G3DSA:3.10.290.10:FF:000096', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(48496, NULL, 'G3DSA:3.60.150.10:FF:000018', NULL, NULL, 'Chorismate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(48497, NULL, 'G3DSA:1.20.1270.10:FF:000048', NULL, NULL, 'Heat shock cognate protein 70', NULL, NULL, NULL, NULL, NULL, 4),
(48498, NULL, 'G3DSA:3.50.50.60:FF:000638', NULL, NULL, 'Flavin-binding monooxygenase-like, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48499, NULL, 'G3DSA:3.10.20.30:FF:000034', NULL, NULL, 'Vanillate monooxygenase, oxidoreductase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(48500, NULL, 'G3DSA:2.60.40.10:FF:003784', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48501, NULL, 'G3DSA:3.30.160.40:FF:000006', NULL, NULL, 'Porphobilinogen deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(48502, NULL, 'G3DSA:1.20.5.110:FF:000277', NULL, NULL, 'syntaxin-binding protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(48503, NULL, 'G3DSA:3.40.50.300:FF:002160', NULL, NULL, 'Elongator complex protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(48504, NULL, 'G3DSA:3.30.2140.20:FF:000004', NULL, NULL, 'Putative N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(48505, NULL, 'G3DSA:3.30.160.60:FF:003199', NULL, NULL, 'Hunchback-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(48506, NULL, 'G3DSA:2.60.40.10:FF:001524', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(48507, NULL, 'G3DSA:2.60.40.1730:FF:000049', NULL, NULL, 'TATA binding protein-associated factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48508, NULL, 'G3DSA:2.40.100.10:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48509, NULL, 'G3DSA:3.40.50.300:FF:000726', NULL, NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(48510, NULL, 'G3DSA:3.50.50.60:FF:001127', NULL, NULL, 'LOC100158500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(48511, NULL, 'G3DSA:3.90.1480.20:FF:000004', NULL, NULL, 'alpha-2,8-sialyltransferase 8E isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(48512, NULL, 'G3DSA:3.30.70.1320:FF:000011', NULL, NULL, 'Transporter, AcrB/D/F family', NULL, NULL, NULL, NULL, NULL, 4),
(48513, NULL, 'G3DSA:2.60.40.2030:FF:000010', NULL, NULL, 'Fraser extracellular matrix complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(48514, NULL, 'G3DSA:2.60.34.10:FF:000043', NULL, NULL, 'Heat shock protein 70, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48515, NULL, 'G3DSA:3.30.1490.110:FF:000009', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(48516, NULL, 'G3DSA:1.20.1310.10:FF:000103', NULL, NULL, 'SCF ubiquitin ligase complex subunit CulA, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48517, NULL, 'G3DSA:3.60.21.10:FF:000354', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48518, NULL, 'G3DSA:2.130.10.10:FF:003857', NULL, NULL, 'Histone-binding protein RBBP7', NULL, NULL, NULL, NULL, NULL, 4),
(48519, NULL, 'G3DSA:3.30.1330.20:FF:000030', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(48520, NULL, 'G3DSA:1.25.10.10:FF:000959', NULL, NULL, 'Protein phosphatase PP2A regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(48521, NULL, 'G3DSA:2.130.10.10:FF:003418', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(48522, NULL, 'G3DSA:1.20.1250.20:FF:002068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48523, NULL, 'G3DSA:1.10.510.10:FF:000442', NULL, NULL, 'Testis-specific serine/threonine-protein kinase 6', NULL, NULL, NULL, NULL, NULL, 4),
(48524, NULL, 'G3DSA:1.10.287.2070:FF:000001', NULL, NULL, 'StAR-related lipid transfer domain-containing 13', NULL, NULL, NULL, NULL, NULL, 4),
(48525, NULL, 'G3DSA:1.25.40.10:FF:001967', NULL, NULL, 'Pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(48526, NULL, 'G3DSA:1.10.510.10:FF:003426', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48527, NULL, 'G3DSA:1.10.3290.10:FF:000013', NULL, NULL, 'Phosphocholine transferase AnkX', NULL, NULL, NULL, NULL, NULL, 4),
(48528, NULL, 'G3DSA:1.25.40.20:FF:001616', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48529, NULL, 'G3DSA:3.40.50.2000:FF:000741', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(48530, NULL, 'G3DSA:1.10.10.1100:FF:000012', NULL, NULL, 'Bacterioferritin-associated ferredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(48531, NULL, 'G3DSA:3.30.200.20:FF:001707', NULL, NULL, 'Serine/threonine-protein kinase RIO1', NULL, NULL, NULL, NULL, NULL, 4),
(48532, NULL, 'G3DSA:3.80.10.10:FF:004537', NULL, NULL, 'F-box protein At5g03100', NULL, NULL, NULL, NULL, NULL, 4),
(48533, NULL, 'G3DSA:1.20.58.390:FF:000074', NULL, NULL, 'Gamma-aminobutyric acid type A receptor gamma2 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(48534, NULL, 'G3DSA:1.10.10.2100:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48535, NULL, 'G3DSA:3.90.1410.10:FF:000071', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48536, NULL, 'G3DSA:2.10.220.10:FF:000146', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(48537, NULL, 'G3DSA:3.40.50.10490:FF:000061', NULL, NULL, '40S ribosomal protein S2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48538, NULL, 'G3DSA:3.40.50.1000:FF:000750', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48539, NULL, 'G3DSA:2.20.28.120:FF:000005', NULL, NULL, '39S ribosomal protein L33, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(48540, NULL, 'G3DSA:3.40.50.10810:FF:000005', NULL, NULL, 'Photoperiod-independent early flowering 1', NULL, NULL, NULL, NULL, NULL, 4),
(48541, NULL, 'G3DSA:1.20.1250.20:FF:000606', NULL, NULL, 'Unplaced genomic scaffold supercont2.17, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(48542, NULL, 'G3DSA:2.60.20.10:FF:000005', NULL, NULL, 'Crystallin, beta B1', NULL, NULL, NULL, NULL, NULL, 4),
(48543, NULL, 'G3DSA:1.20.1280.50:FF:000218', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48544, NULL, 'G3DSA:2.10.25.10:FF:000743', NULL, NULL, 'Si:dkey-220k22.1', NULL, NULL, NULL, NULL, NULL, 4),
(48545, NULL, 'G3DSA:3.90.650.10:FF:000027', NULL, NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(48546, NULL, 'G3DSA:1.20.890.10:FF:000001', NULL, NULL, 'cAMP-dependent protein kinase type I-alpha regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(48547, NULL, 'G3DSA:3.30.428.10:FF:000058', NULL, NULL, 'APTX isoform 28', NULL, NULL, NULL, NULL, NULL, 4),
(48548, NULL, 'G3DSA:2.40.33.10:FF:000042', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(48549, NULL, 'G3DSA:1.25.10.10:FF:001578', NULL, NULL, 'Exportin-6-B-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(48550, NULL, 'G3DSA:1.10.30.10:FF:000078', NULL, NULL, 'ARS-binding factor', NULL, NULL, NULL, NULL, NULL, 4),
(48551, NULL, 'G3DSA:3.30.70.260:FF:000147', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(48552, NULL, 'G3DSA:3.30.160.60:FF:001524', NULL, NULL, 'Zinc finger protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(48553, NULL, 'G3DSA:1.10.8.60:FF:000006', NULL, NULL, '26S protease regulatory subunit 8', NULL, NULL, NULL, NULL, NULL, 4),
(48554, NULL, 'G3DSA:2.40.70.10:FF:000577', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48555, NULL, 'G3DSA:3.40.50.300:FF:003571', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(48556, NULL, 'G3DSA:3.30.70.330:FF:003052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48557, NULL, 'G3DSA:3.40.50.300:FF:001671', NULL, NULL, 'Type IV secretion system protein VirD4', NULL, NULL, NULL, NULL, NULL, 4),
(48558, NULL, 'G3DSA:3.30.420.40:FF:000044', NULL, NULL, 'Actin-like 6a isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(48559, NULL, 'G3DSA:1.25.40.10:FF:005227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48560, NULL, 'G3DSA:3.50.50.60:FF:001257', NULL, NULL, 'Salicylate monooxygenase-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(48561, NULL, 'G3DSA:1.50.40.10:FF:000482', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48562, NULL, 'G3DSA:4.10.240.10:FF:000044', NULL, NULL, 'Pyrimidine pathway regulatory protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(48563, NULL, 'G3DSA:3.30.760.10:FF:000088', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48564, NULL, 'G3DSA:2.10.110.10:FF:000025', NULL, NULL, 'Cysteine-rich protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(48565, NULL, 'G3DSA:2.30.30.40:FF:000409', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48566, NULL, 'G3DSA:3.40.50.1950:FF:000012', NULL, NULL, 'Flavin prenyltransferase UbiX', NULL, NULL, NULL, NULL, NULL, 4),
(48567, NULL, 'G3DSA:1.10.630.10:FF:000389', NULL, NULL, 'Cytochrome P450, putative (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(48568, NULL, 'G3DSA:1.10.150.240:FF:000042', NULL, NULL, 'Haloacid dehalogenase-like hydrolase domain-containing protein At4g39970', NULL, NULL, NULL, NULL, NULL, 4),
(48569, NULL, 'G3DSA:1.20.930.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48570, NULL, 'G3DSA:3.80.10.10:FF:000608', NULL, NULL, 'Leucine-rich repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(48571, NULL, 'G3DSA:1.20.1640.10:FF:000077', NULL, NULL, 'Transmembrane transport protein MmpL3', NULL, NULL, NULL, NULL, NULL, 4),
(48572, NULL, 'G3DSA:1.10.220.110:FF:000003', NULL, NULL, 'GDNF family receptor alpha 4', NULL, NULL, NULL, NULL, NULL, 4),
(48573, NULL, 'G3DSA:1.10.220.10:FF:000015', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(48574, NULL, 'G3DSA:3.30.160.360:FF:000012', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(48575, NULL, 'G3DSA:2.60.120.620:FF:000042', NULL, NULL, 'Phytanoyl-CoA dioxygenase (PhyH)', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(48576, NULL, 'G3DSA:1.20.1560.10:FF:000947', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48577, NULL, 'G3DSA:3.60.10.10:FF:000109', NULL, NULL, 'Endonuclease/exonuclease/phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(48578, NULL, 'G3DSA:2.60.120.560:FF:000030', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(48579, NULL, 'G3DSA:2.40.30.170:FF:000075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48580, NULL, 'G3DSA:1.10.3720.10:FF:000103', NULL, NULL, 'ABC transporter permease, nitrate/sulfonate/bicarbonate transport', NULL, NULL, NULL, NULL, NULL, 4),
(48581, NULL, 'G3DSA:3.40.190.10:FF:000817', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48582, NULL, 'G3DSA:3.40.50.300:FF:004088', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(48583, NULL, 'G3DSA:1.25.40.10:FF:004710', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48584, NULL, 'G3DSA:1.20.140.40:FF:000021', NULL, NULL, 'Probable pectinesterase/pectinesterase inhibitor 51', NULL, NULL, NULL, NULL, NULL, 4),
(48585, NULL, 'G3DSA:3.40.50.300:FF:003599', NULL, NULL, 'Shikimate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(48586, NULL, 'G3DSA:3.30.160.60:FF:004930', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48587, NULL, 'G3DSA:1.10.510.10:FF:002600', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48588, NULL, 'G3DSA:1.10.472.10:FF:000678', NULL, NULL, 'Putative cyclin-Y-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(48589, NULL, 'G3DSA:3.30.460.10:FF:000155', NULL, NULL, 'Os06g0319600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(48590, NULL, 'G3DSA:1.20.1560.10:FF:000716', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48591, NULL, 'G3DSA:3.60.10.10:FF:000340', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48592, NULL, 'G3DSA:1.20.1410.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48593, NULL, 'G3DSA:3.60.21.10:FF:000146', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(48594, NULL, 'G3DSA:3.30.70.1350:FF:000003', NULL, NULL, 'Cation diffusion facilitator 1', NULL, NULL, NULL, NULL, NULL, 4),
(48595, NULL, 'G3DSA:2.60.120.10:FF:000065', NULL, NULL, 'HTH-type transcriptional regulator ChbR', NULL, NULL, NULL, NULL, NULL, 4),
(48596, NULL, 'G3DSA:1.10.3210.10:FF:000025', NULL, NULL, 'Exopolyphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(48597, NULL, 'G3DSA:3.30.160.60:FF:006167', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48598, NULL, 'G3DSA:1.10.510.10:FF:001852', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48599, NULL, 'G3DSA:3.30.70.330:FF:002321', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48600, NULL, 'G3DSA:3.20.20.70:FF:000253', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(48601, NULL, 'G3DSA:3.40.50.1000:FF:000879', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48602, NULL, 'G3DSA:2.60.40.10:FF:003992', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48603, NULL, 'G3DSA:3.40.50.720:FF:000829', NULL, NULL, 'Glyoxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(48604, NULL, 'G3DSA:1.25.10.10:FF:000055', NULL, NULL, 'AP-3 complex subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(48605, NULL, 'G3DSA:2.30.29.170:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48606, NULL, 'G3DSA:2.60.120.430:FF:000002', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(48607, NULL, 'G3DSA:2.90.10.10:FF:000032', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase SD3-1', NULL, NULL, NULL, NULL, NULL, 4),
(48608, NULL, 'G3DSA:3.40.50.150:FF:000288', NULL, NULL, 'Spermine/spermidine synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48609, NULL, 'G3DSA:3.30.870.10:FF:000080', NULL, NULL, 'Probable tyrosyl-DNA phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(48610, NULL, 'G3DSA:2.60.40.10:FF:000799', NULL, NULL, 'Semaphorin 4G', NULL, NULL, NULL, NULL, NULL, 4),
(48611, NULL, 'G3DSA:3.40.50.300:FF:003924', NULL, NULL, 'Protein peanut', NULL, NULL, NULL, NULL, NULL, 4),
(48612, NULL, 'G3DSA:3.90.70.10:FF:000078', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 23', NULL, NULL, NULL, NULL, NULL, 4),
(48613, NULL, 'G3DSA:3.40.50.720:FF:001353', NULL, NULL, 'Retinol dehydrogenase 7', NULL, NULL, NULL, NULL, NULL, 4),
(48614, NULL, 'G3DSA:3.30.470.20:FF:000086', NULL, NULL, 'inositol-tetrakisphosphate 1-kinase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(48615, NULL, 'G3DSA:3.10.280.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48616, NULL, 'G3DSA:2.60.40.10:FF:004610', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48617, NULL, 'G3DSA:1.20.140.90:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48618, NULL, 'G3DSA:1.10.10.10:FF:001616', NULL, NULL, 'DEP domain-containing protein DDB_G0279099', NULL, NULL, NULL, NULL, NULL, 4),
(48619, NULL, 'G3DSA:3.40.50.2300:FF:001207', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48620, NULL, 'G3DSA:3.30.420.40:FF:000156', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(48621, NULL, 'G3DSA:2.60.40.10:FF:000905', NULL, NULL, 'Ankyrin repeat and fibronectin type III domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(48622, NULL, 'G3DSA:3.40.250.10:FF:000064', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(48623, NULL, 'G3DSA:3.80.10.10:FF:002396', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48624, NULL, 'G3DSA:2.10.25.10:FF:001570', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48625, NULL, 'G3DSA:2.10.25.10:FF:000951', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(48626, NULL, 'G3DSA:2.60.40.790:FF:000213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48627, NULL, 'G3DSA:3.70.10.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48628, NULL, 'G3DSA:3.40.50.150:FF:000400', NULL, NULL, 'Glutathione S-transferase C-terminal domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(48629, NULL, 'G3DSA:2.10.60.10:FF:000072', NULL, NULL, 'Lymphocyte antigen 6 family member E', NULL, NULL, NULL, NULL, NULL, 4),
(48630, NULL, 'G3DSA:3.40.390.10:FF:000237', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48631, NULL, 'G3DSA:1.10.220.20:FF:000001', NULL, NULL, 'IQ motif and SEC7 domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(48632, NULL, 'G3DSA:3.40.720.10:FF:000140', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48633, NULL, 'G3DSA:1.10.10.440:FF:000090', NULL, NULL, 'ADR159Cp', NULL, NULL, NULL, NULL, NULL, 4),
(48634, NULL, 'G3DSA:2.60.120.290:FF:000134', NULL, NULL, 'GD12774', NULL, NULL, NULL, NULL, NULL, 4),
(48635, NULL, 'G3DSA:1.10.20.10:FF:000021', NULL, NULL, 'Histone H2A', NULL, NULL, NULL, NULL, NULL, 4),
(48636, NULL, 'G3DSA:3.30.360.10:FF:000007', NULL, NULL, 'D-erythrose-4-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(48637, NULL, 'G3DSA:3.10.620.30:FF:000015', NULL, NULL, 'Protein-glutamine gamma-glutamyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(48638, NULL, 'G3DSA:2.130.10.10:FF:003626', NULL, NULL, 'Dynein, axonemal, intermediate chain 1, paralog 1', NULL, NULL, NULL, NULL, NULL, 4),
(48639, NULL, 'G3DSA:3.20.20.70:FF:000247', NULL, NULL, 'Pyridoxine 5''-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(48640, NULL, 'G3DSA:1.25.40.10:FF:000091', NULL, NULL, 'Pre-mRNA-processing factor 39', NULL, NULL, NULL, NULL, NULL, 4),
(48641, NULL, 'G3DSA:3.30.10.20:FF:000018', NULL, NULL, 'Serine/threonine-protein kinase PrkC', NULL, NULL, NULL, NULL, NULL, 4),
(48642, NULL, 'G3DSA:1.10.510.10:FF:000234', NULL, NULL, 'Citron rho-interacting serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(48643, NULL, 'G3DSA:2.30.29.30:FF:001067', NULL, NULL, 'DAB adaptor protein 2', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(48644, NULL, 'G3DSA:3.10.250.10:FF:000099', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48645, NULL, 'G3DSA:3.30.50.10:FF:000023', NULL, NULL, 'Vitamin D3 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(48646, NULL, 'G3DSA:3.30.160.60:FF:005548', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48647, NULL, 'G3DSA:3.20.90.10:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48648, NULL, 'G3DSA:3.30.40.10:FF:002338', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48649, NULL, 'G3DSA:1.10.510.10:FF:001953', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48650, NULL, 'G3DSA:3.20.20.80:FF:000155', NULL, NULL, '1,3-beta-glucanosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(48651, NULL, 'G3DSA:3.10.110.10:FF:000038', NULL, NULL, 'SUMO-conjugating enzyme SCE1', NULL, NULL, NULL, NULL, NULL, 4),
(48652, NULL, 'G3DSA:1.20.140.10:FF:000135', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48653, NULL, 'G3DSA:3.40.50.300:FF:005369', NULL, NULL, 'Primosomal protein N''', NULL, NULL, NULL, NULL, NULL, 4),
(48654, NULL, 'G3DSA:4.10.400.10:FF:000158', NULL, NULL, 'LDL receptor related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(48655, NULL, 'G3DSA:1.10.30.10:FF:000106', NULL, NULL, 'Zgc:165618 protein', NULL, NULL, NULL, NULL, NULL, 4),
(48656, NULL, 'G3DSA:3.40.50.10810:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48657, NULL, 'G3DSA:3.50.50.60:FF:000397', NULL, NULL, 'Probable monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(48658, NULL, 'G3DSA:3.40.50.300:FF:001783', NULL, NULL, 'DNA repair protein RecN', NULL, NULL, NULL, NULL, NULL, 4),
(48659, NULL, 'G3DSA:3.40.190.10:FF:000126', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(48660, NULL, 'G3DSA:1.10.10.1800:FF:000008', NULL, NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', NULL, NULL, NULL, NULL, NULL, 4),
(48661, NULL, 'G3DSA:3.30.160.60:FF:003418', NULL, NULL, 'Zinc finger protein 407', NULL, NULL, NULL, NULL, NULL, 4),
(48662, NULL, 'G3DSA:1.20.5.420:FF:000010', NULL, NULL, 'Truncated muramidase-released protein', NULL, NULL, NULL, NULL, NULL, 4),
(48663, NULL, 'G3DSA:2.20.70.10:FF:000179', NULL, NULL, 'YALI0C19404p', NULL, NULL, NULL, NULL, NULL, 4),
(48664, NULL, 'G3DSA:3.30.70.260:FF:000035', NULL, NULL, 'Modulator protein MzrA', NULL, NULL, NULL, NULL, NULL, 4),
(48665, NULL, 'G3DSA:2.60.420.10:FF:000009', NULL, NULL, 'Alpha-L-rhamnosidase B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48666, NULL, 'G3DSA:1.10.533.10:FF:000011', NULL, NULL, 'Myeloid cell nuclear differentiation antigen', NULL, NULL, NULL, NULL, NULL, 4),
(48667, NULL, 'G3DSA:2.60.40.10:FF:001737', NULL, NULL, 'CD226 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(48668, NULL, 'G3DSA:3.40.220.30:FF:000001', NULL, NULL, 'Orf1a polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(48669, NULL, 'G3DSA:3.40.50.2300:FF:000269', NULL, NULL, 'Sugar ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(48670, NULL, 'G3DSA:1.25.40.10:FF:001175', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g19720', NULL, NULL, NULL, NULL, NULL, 4),
(48671, NULL, 'G3DSA:3.90.190.10:FF:000429', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48672, NULL, 'G3DSA:1.10.287.70:FF:000259', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(48673, NULL, 'G3DSA:2.60.40.1120:FF:000080', NULL, NULL, 'Carboxypeptidase M', NULL, NULL, NULL, NULL, NULL, 4),
(48674, NULL, 'G3DSA:3.40.50.300:FF:007623', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48675, NULL, 'G3DSA:3.30.160.60:FF:006280', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48676, NULL, 'G3DSA:3.30.40.10:FF:000197', NULL, NULL, 'E3 ubiquitin-protein ligase RNF152', NULL, NULL, NULL, NULL, NULL, 4),
(48677, NULL, 'G3DSA:1.10.400.10:FF:000001', NULL, NULL, 'Guanine nucleotide-binding protein G(I) subunit alpha', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(48678, NULL, 'G3DSA:1.20.1070.10:FF:000168', NULL, NULL, 'Cholecystokinin receptor type A', NULL, NULL, NULL, NULL, NULL, 4),
(48679, NULL, 'G3DSA:1.20.120.730:FF:000001', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(48680, NULL, 'G3DSA:3.20.190.10:FF:000007', NULL, NULL, 'DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(48681, NULL, 'G3DSA:3.30.160.60:FF:004722', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48682, NULL, 'G3DSA:3.30.420.10:FF:000052', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(48683, NULL, 'G3DSA:3.30.70.2020:FF:000002', NULL, NULL, 'Phosphoserine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(48684, NULL, 'G3DSA:3.30.420.150:FF:000003', NULL, NULL, 'ectonucleoside triphosphate diphosphohydrolase 7', NULL, NULL, NULL, NULL, NULL, 4),
(48685, NULL, 'G3DSA:3.80.10.10:FF:000951', NULL, NULL, 'SCF E3 ubiquitin ligase complex F-box protein GRR1', NULL, NULL, NULL, NULL, NULL, 4),
(48686, NULL, 'G3DSA:3.20.20.60:FF:000149', NULL, NULL, 'Citrate lyase beta-like', NULL, NULL, NULL, NULL, NULL, 4),
(48687, NULL, 'G3DSA:2.60.40.10:FF:000113', NULL, NULL, 'Opioid-binding protein/cell adhesion molecule', NULL, NULL, NULL, NULL, NULL, 4),
(48688, NULL, 'G3DSA:1.20.1250.20:FF:002309', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(48689, NULL, 'G3DSA:3.30.160.60:FF:002581', NULL, NULL, 'Zinc finger protein 407', NULL, NULL, NULL, NULL, NULL, 4),
(48690, NULL, 'G3DSA:3.40.50.790:FF:000013', NULL, NULL, '50S ribosomal protein L1', NULL, NULL, NULL, NULL, NULL, 4),
(48691, NULL, 'G3DSA:3.10.20.90:FF:000349', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(48692, NULL, 'G3DSA:1.10.10.60:FF:001154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48693, NULL, 'G3DSA:3.40.50.300:FF:002514', NULL, NULL, 'GTP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(48694, NULL, 'G3DSA:2.60.40.10:FF:003654', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48695, NULL, 'G3DSA:2.10.25.10:FF:001250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48696, NULL, 'G3DSA:2.40.50.40:FF:000118', NULL, NULL, 'CHD gene family protein containing chromodomain, helicase domain, and DNA-binding domain', NULL, NULL, NULL, NULL, NULL, 4),
(48697, NULL, 'G3DSA:2.60.120.330:FF:000062', NULL, NULL, '2-oxoglutarate-dependent dioxygenase AOP3', NULL, NULL, NULL, NULL, NULL, 4),
(48698, NULL, 'G3DSA:3.80.10.10:FF:000159', NULL, NULL, 'Ras suppressor protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(48699, NULL, 'G3DSA:1.10.510.10:FF:002572', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48700, NULL, 'G3DSA:2.10.25.10:FF:001362', NULL, NULL, 'Notch receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(48701, NULL, 'G3DSA:1.25.10.10:FF:001347', NULL, NULL, 'HEAT repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(48702, NULL, 'G3DSA:3.20.20.80:FF:000582', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48703, NULL, 'G3DSA:3.90.226.10:FF:000160', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(48704, NULL, 'G3DSA:3.30.2350.10:FF:000068', NULL, NULL, 'Trans-splicing factor Raa2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(48705, NULL, 'G3DSA:1.20.120.350:FF:000191', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48706, NULL, 'G3DSA:3.40.50.620:FF:000249', NULL, NULL, 'Ethanolamine-phosphate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(48707, NULL, 'G3DSA:1.10.268.10:FF:000018', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(48708, NULL, 'G3DSA:3.40.50.1000:FF:000306', NULL, NULL, 'HAD family phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(48709, NULL, 'G3DSA:1.20.1740.10:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48710, NULL, 'G3DSA:1.20.140.150:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(48711, NULL, 'G3DSA:2.130.10.30:FF:000086', NULL, NULL, 'BTB/POZ domain/Regulator of chromosome condensation (RCC1) repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48712, NULL, 'G3DSA:1.20.58.70:FF:000120', NULL, NULL, 'Syntaxin-132', NULL, NULL, NULL, NULL, NULL, 4),
(48713, NULL, 'G3DSA:3.60.21.10:FF:000466', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(48714, NULL, 'G3DSA:1.20.910.10:FF:000043', NULL, NULL, 'Bsl7393 protein', NULL, NULL, NULL, NULL, NULL, 4),
(48715, NULL, 'G3DSA:3.40.430.10:FF:000050', NULL, NULL, 'Riboflavin biosynthesis protein RibD', NULL, NULL, NULL, NULL, NULL, 4),
(48716, NULL, 'G3DSA:1.20.1070.10:FF:001005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48717, NULL, 'G3DSA:2.60.120.970:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48718, NULL, 'G3DSA:3.30.160.60:FF:003750', NULL, NULL, 'Zgc:174234 protein', NULL, NULL, NULL, NULL, NULL, 4),
(48719, NULL, 'G3DSA:4.10.280.10:FF:000069', NULL, NULL, 'Transcription factor PIF7', NULL, NULL, NULL, NULL, NULL, 4),
(48720, NULL, 'G3DSA:3.30.200.20:FF:001128', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(48721, NULL, 'G3DSA:1.20.120.140:FF:000032', NULL, NULL, 'Cell division protein FtsY homolog chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(48722, NULL, 'G3DSA:2.60.40.150:FF:000021', NULL, NULL, 'dysferlin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(48723, NULL, 'G3DSA:1.10.472.130:FF:000037', NULL, NULL, 'Flagellar inner arm dynein 1 heavy chain alpha', NULL, NULL, NULL, NULL, NULL, 4),
(48724, NULL, 'G3DSA:1.20.120.450:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48725, NULL, 'G3DSA:1.20.5.170:FF:000137', NULL, NULL, 'Unplaced genomic scaffold supercont2.16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(48726, NULL, 'G3DSA:3.80.20.20:FF:000101', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48727, NULL, 'G3DSA:2.40.30.30:FF:000007', NULL, NULL, 'Riboflavin kinase', NULL, NULL, NULL, NULL, NULL, 4),
(48728, NULL, 'G3DSA:3.30.70.20:FF:000027', NULL, NULL, 'Electron transport protein hydN', NULL, NULL, NULL, NULL, NULL, 4),
(48729, NULL, 'G3DSA:2.60.40.10:FF:005335', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48730, NULL, 'G3DSA:1.20.58.2220:FF:000059', NULL, NULL, 'Si:ch1073-209e23.1', NULL, NULL, NULL, NULL, NULL, 4),
(48731, NULL, 'G3DSA:2.40.50.140:FF:000738', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48732, NULL, 'G3DSA:1.10.150.120:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48733, NULL, 'G3DSA:1.10.720.30:FF:000036', NULL, NULL, 'Plastid transcriptionally active 3', NULL, NULL, NULL, NULL, NULL, 4),
(48734, NULL, 'G3DSA:1.20.1250.20:FF:001112', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(48735, NULL, 'G3DSA:1.10.510.10:FF:002145', NULL, NULL, 'Receptor tyrosine kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(48736, NULL, 'G3DSA:3.90.1110.10:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48737, NULL, 'G3DSA:1.10.40.90:FF:000001', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(48738, NULL, 'G3DSA:1.10.1450.10:FF:000109', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(48739, NULL, 'G3DSA:2.40.30.10:FF:000001', NULL, NULL, 'Elongation factor Tu', NULL, NULL, NULL, NULL, NULL, 4),
(48740, NULL, 'G3DSA:3.30.160.60:FF:001069', NULL, NULL, 'zinc finger protein 217', NULL, NULL, NULL, NULL, NULL, 4),
(48741, NULL, 'G3DSA:3.40.50.720:FF:001448', NULL, NULL, 'GDP-mannose 4,6 dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(48742, NULL, 'G3DSA:3.30.160.60:FF:006072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48743, NULL, 'G3DSA:1.10.287.110:FF:000126', NULL, NULL, 'Cell division related protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(48744, NULL, 'G3DSA:3.30.40.10:FF:000860', NULL, NULL, 'Plus-3 domain/Zinc finger', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(48745, NULL, 'G3DSA:2.130.10.10:FF:001592', NULL, NULL, 'Anaphase-promoting complex component Cut20/Apc4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48746, NULL, 'G3DSA:3.30.70.100:FF:000015', NULL, NULL, 'Potassium efflux system KefA', NULL, NULL, NULL, NULL, NULL, 4),
(48747, NULL, 'G3DSA:3.10.129.10:FF:000087', NULL, NULL, 'Thioesterase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(48748, NULL, 'G3DSA:3.80.10.10:FF:002767', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48749, NULL, 'G3DSA:1.10.630.10:FF:000591', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48750, NULL, 'G3DSA:2.60.40.10:FF:002356', NULL, NULL, 'Protein roller-3', NULL, NULL, NULL, NULL, NULL, 4),
(48751, NULL, 'G3DSA:1.10.150.50:FF:000004', NULL, NULL, 'PTPRF interacting protein alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(48752, NULL, 'G3DSA:3.30.70.100:FF:000139', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48753, NULL, 'G3DSA:3.30.70.330:FF:001815', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48754, NULL, 'G3DSA:2.30.30.380:FF:000073', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(48755, NULL, 'G3DSA:2.160.20.10:FF:000231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48756, NULL, 'G3DSA:1.10.10.10:FF:001717', NULL, NULL, 'Response regulator receiver and SARP domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(48757, NULL, 'G3DSA:3.50.50.60:FF:000189', NULL, NULL, 'Monomeric sarcosine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(48758, NULL, 'G3DSA:2.60.40.10:FF:001625', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(48759, NULL, 'G3DSA:3.40.50.1000:FF:000295', NULL, NULL, 'Phosphatidyl synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48760, NULL, 'G3DSA:3.30.160.60:FF:001496', NULL, NULL, 'zinc finger protein 581', NULL, NULL, NULL, NULL, NULL, 4),
(48761, NULL, 'G3DSA:1.10.10.10:FF:000644', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(48762, NULL, 'G3DSA:3.40.20.10:FF:000105', NULL, NULL, 'Protein flightless-1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(48763, NULL, 'G3DSA:3.40.1080.20:FF:000002', NULL, NULL, 'Acetyl-CoA hydrolase/transferase', NULL, NULL, NULL, NULL, NULL, 4),
(48764, NULL, 'G3DSA:1.20.120.1910:FF:000036', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(48765, NULL, 'G3DSA:3.80.10.10:FF:003014', NULL, NULL, 'LRR F-box protein MAX2a', NULL, NULL, NULL, NULL, NULL, 4),
(48766, NULL, 'G3DSA:1.20.120.1750:FF:000050', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(48767, NULL, 'G3DSA:3.30.1370.110:FF:000016', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(48768, NULL, 'G3DSA:3.30.200.20:FF:000055', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(48769, NULL, 'G3DSA:3.40.50.2000:FF:000286', NULL, NULL, 'UDP-glucuronosyltransferase 3A2', NULL, NULL, NULL, NULL, NULL, 4),
(48770, NULL, 'G3DSA:3.30.40.10:FF:001933', NULL, NULL, 'Ligand of numb-protein X 2b', NULL, NULL, NULL, NULL, NULL, 4),
(48771, NULL, 'G3DSA:3.20.20.105:FF:000025', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48772, NULL, 'G3DSA:1.25.40.20:FF:001841', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48773, NULL, 'G3DSA:3.40.30.10:FF:000617', NULL, NULL, 'Protein disulfide isomerase family A member 3', NULL, NULL, NULL, NULL, NULL, 4),
(48774, NULL, 'G3DSA:3.30.160.60:FF:000552', NULL, NULL, 'Zinc finger protein 131', NULL, NULL, NULL, NULL, NULL, 4),
(48775, NULL, 'G3DSA:1.25.10.10:FF:002516', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48776, NULL, 'G3DSA:1.25.40.10:FF:000787', NULL, NULL, 'CHIP', NULL, NULL, NULL, NULL, NULL, 4),
(48777, NULL, 'G3DSA:3.40.50.1240:FF:000136', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48778, NULL, 'G3DSA:3.30.420.10:FF:000260', NULL, NULL, 'DNA polymerase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(48779, NULL, 'G3DSA:2.120.10.80:FF:000040', NULL, NULL, 'Kelch-like family member 22', NULL, NULL, NULL, NULL, NULL, 4),
(48780, NULL, 'G3DSA:3.30.160.20:FF:000231', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48781, NULL, 'G3DSA:1.10.1600.10:FF:000026', NULL, NULL, 'Ku70-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(48782, NULL, 'G3DSA:1.10.510.10:FF:003089', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48783, NULL, 'G3DSA:3.90.550.10:FF:000531', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48784, NULL, 'G3DSA:2.60.120.650:FF:000040', NULL, NULL, 'lysine-specific demethylase JMJ25 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(48785, NULL, 'G3DSA:3.40.50.300:FF:008011', NULL, NULL, 'Molybdopterin-guanine dinucleotide biosynthesis protein B/molybdopterin converting factor, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(48786, NULL, 'G3DSA:3.30.160.60:FF:001962', NULL, NULL, 'Zinc finger and SCAN domain-containing protein 32', NULL, NULL, NULL, NULL, NULL, 4),
(48787, NULL, 'G3DSA:1.10.1070.11:FF:000003', NULL, NULL, 'Phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(48788, NULL, 'G3DSA:1.10.238.10:FF:000634', NULL, NULL, 'Calpain 8', NULL, NULL, NULL, NULL, NULL, 4),
(48789, NULL, 'G3DSA:3.40.50.1240:FF:000030', NULL, NULL, 'Lysophosphatidic acid phosphatase type 6', NULL, NULL, NULL, NULL, NULL, 4),
(48790, NULL, 'G3DSA:1.10.287.70:FF:000602', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48791, NULL, 'G3DSA:2.60.40.420:FF:000136', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48792, NULL, 'G3DSA:2.60.40.1180:FF:000069', NULL, NULL, 'Glucosidase II', NULL, NULL, NULL, NULL, NULL, 4),
(48793, NULL, 'G3DSA:3.40.50.1260:FF:000018', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(48794, NULL, 'G3DSA:3.40.50.80:FF:000156', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48795, NULL, 'G3DSA:2.130.10.10:FF:002789', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48796, NULL, 'G3DSA:3.90.550.10:FF:000295', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(48797, NULL, 'G3DSA:3.10.28.10:FF:000034', NULL, NULL, 'Probable intron-encoded DNA endonuclease aI1', NULL, NULL, NULL, NULL, NULL, 4),
(48798, NULL, 'G3DSA:3.30.40.10:FF:000995', NULL, NULL, 'Zinc finger domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(48799, NULL, 'G3DSA:1.20.1560.10:FF:000498', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(48800, NULL, 'G3DSA:2.40.50.140:FF:000637', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(48801, NULL, 'G3DSA:3.20.20.70:FF:000141', NULL, NULL, 'D-tagatose-1,6-bisphosphate aldolase subunit GatZ', NULL, NULL, NULL, NULL, NULL, 4),
(48802, NULL, 'G3DSA:3.40.1160.10:FF:000045', NULL, NULL, 'Glutamate 5-kinase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(48803, NULL, 'G3DSA:1.25.40.90:FF:000075', NULL, NULL, 'VHS domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48804, NULL, 'G3DSA:2.170.270.10:FF:000145', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(48805, NULL, 'G3DSA:3.80.10.10:FF:001339', NULL, NULL, 'Leucine-rich repeat protein SHOC-2', NULL, NULL, NULL, NULL, NULL, 4),
(48806, NULL, 'G3DSA:1.50.10.10:FF:000075', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(48807, NULL, 'G3DSA:1.10.3380.10:FF:000003', NULL, NULL, 'SEC63 homolog, protein translocation regulator', NULL, NULL, NULL, NULL, NULL, 4),
(48808, NULL, 'G3DSA:3.30.470.20:FF:000198', NULL, NULL, 'Tubulin glycylase 3F', NULL, NULL, NULL, NULL, NULL, 4),
(48809, NULL, 'G3DSA:1.20.120.150:FF:000006', NULL, NULL, 'Phosphatidylinositol 3-kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(48810, NULL, 'G3DSA:2.120.10.80:FF:000146', NULL, NULL, 'tRNA wybutosine-synthesizing protein 2/3/4', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(48811, NULL, 'G3DSA:1.10.455.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48812, NULL, 'G3DSA:2.130.10.10:FF:001165', NULL, NULL, 'WD repeat-containing protein 63 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(48813, NULL, 'G3DSA:1.25.40.10:FF:003980', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48814, NULL, 'G3DSA:3.90.76.10:FF:000024', NULL, NULL, 'Peptide ABC transporter permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(48815, NULL, 'G3DSA:3.30.160.60:FF:006403', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48816, NULL, 'G3DSA:1.10.8.10:FF:000115', NULL, NULL, 'DNA damage-inducible protein', NULL, NULL, NULL, NULL, NULL, 4),
(48817, NULL, 'G3DSA:3.90.640.10:FF:000190', NULL, NULL, 'Actin-related protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(48818, NULL, 'G3DSA:3.40.50.1820:FF:001850', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48819, NULL, 'G3DSA:1.10.1070.11:FF:000109', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48820, NULL, 'G3DSA:1.25.40.10:FF:002344', NULL, NULL, 'GD21537', NULL, NULL, NULL, NULL, NULL, 4),
(48821, NULL, 'G3DSA:3.30.200.20:FF:001679', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48822, NULL, 'G3DSA:1.10.10.60:FF:000069', NULL, NULL, 'MYB transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(48823, NULL, 'G3DSA:3.40.50.300:FF:006454', NULL, NULL, 'Structural maintenance of chromosomes protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(48824, NULL, 'G3DSA:1.20.140.100:FF:000030', NULL, NULL, 'GM10109', NULL, NULL, NULL, NULL, NULL, 4),
(48825, NULL, 'G3DSA:3.30.420.10:FF:000613', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48826, NULL, 'G3DSA:3.30.300.110:FF:000004', NULL, NULL, 'tRNA (guanine(37)-N1)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(48827, NULL, 'G3DSA:3.80.10.10:FF:000390', NULL, NULL, 'fibromodulin', NULL, NULL, NULL, NULL, NULL, 4),
(48828, NULL, 'G3DSA:3.10.105.10:FF:000060', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(48829, NULL, 'G3DSA:2.10.25.10:FF:000058', NULL, NULL, 'Fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(48830, NULL, 'G3DSA:1.20.120.1200:FF:000020', NULL, NULL, 'NADH-quinone oxidoreductase subunit J', NULL, NULL, NULL, NULL, NULL, 4),
(48831, NULL, 'G3DSA:3.30.200.20:FF:001336', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(48832, NULL, 'G3DSA:3.20.20.70:FF:000618', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48833, NULL, 'G3DSA:3.30.40.10:FF:000652', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(48834, NULL, 'G3DSA:3.40.50.1980:FF:000004', NULL, NULL, 'Histidinol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(48835, NULL, 'G3DSA:4.10.400.10:FF:000034', NULL, NULL, 'Low-density lipoprotein receptor-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(48836, NULL, 'G3DSA:3.10.20.90:FF:000006', NULL, NULL, 'Polyubiquitin 10', NULL, NULL, NULL, NULL, NULL, 4),
(48837, NULL, 'G3DSA:1.10.640.10:FF:000092', NULL, NULL, 'NADPH thyroid oxidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(48838, NULL, 'G3DSA:2.30.39.10:FF:000162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48839, NULL, 'G3DSA:3.30.230.130:FF:000033', NULL, NULL, 'Cullin family-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(48840, NULL, 'G3DSA:3.30.505.10:FF:000187', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48841, NULL, 'G3DSA:3.40.50.360:FF:000137', NULL, NULL, 'NADPH-dependent FMN reductase', NULL, NULL, NULL, NULL, NULL, 4),
(48842, NULL, 'G3DSA:3.80.10.10:FF:001671', NULL, NULL, 'Leucine rich repeat neuronal 3', NULL, NULL, NULL, NULL, NULL, 4),
(48843, NULL, 'G3DSA:1.10.472.80:FF:000081', NULL, NULL, 'CRE-TAG-236 protein', NULL, NULL, NULL, NULL, NULL, 4),
(48844, NULL, 'G3DSA:3.80.10.10:FF:000058', NULL, NULL, 'immunoglobulin superfamily containing leucine-rich repeat protein 2', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(48845, NULL, 'G3DSA:3.30.420.10:FF:000158', NULL, NULL, 'Ribonuclease H', NULL, NULL, NULL, NULL, NULL, 4),
(48846, NULL, 'G3DSA:3.40.630.30:FF:000616', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48847, NULL, 'G3DSA:3.30.160.380:FF:000001', NULL, NULL, 'Endoribonuclease dicer-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(48848, NULL, 'G3DSA:3.30.310.50:FF:000044', NULL, NULL, 'Phosphomannomutase', NULL, NULL, NULL, NULL, NULL, 4),
(48849, NULL, 'G3DSA:1.10.443.10:FF:000021', NULL, NULL, 'Site-specific recombinase, phage integrase family', NULL, NULL, NULL, NULL, NULL, 4),
(48850, NULL, 'G3DSA:3.40.309.10:FF:000049', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(48851, NULL, 'G3DSA:3.30.420.270:FF:000022', NULL, NULL, 'Putative biopolymer transmembrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(48852, NULL, 'G3DSA:4.10.240.10:FF:000156', NULL, NULL, 'Dal81p', NULL, NULL, NULL, NULL, NULL, 4),
(48853, NULL, 'G3DSA:2.30.30.100:FF:000129', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm4', NULL, NULL, NULL, NULL, NULL, 4),
(48854, NULL, 'G3DSA:3.90.1150.10:FF:000488', NULL, NULL, '3,4-dihydroxyphenylacetaldehyde synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(48855, NULL, 'G3DSA:1.25.40.10:FF:001164', NULL, NULL, 'mRNA splicing factor (Prp1/Zer1), putative (AFU_orthologue AFUA_2G06070)', NULL, NULL, NULL, NULL, NULL, 4),
(48856, NULL, 'G3DSA:3.70.10.10:FF:000120', NULL, NULL, 'Zgc:56197', NULL, NULL, NULL, NULL, NULL, 4),
(48857, NULL, 'G3DSA:3.40.50.300:FF:005948', NULL, NULL, 'DExH-box helicase 34', NULL, NULL, NULL, NULL, NULL, 4),
(48858, NULL, 'G3DSA:3.40.50.300:FF:007634', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48859, NULL, 'G3DSA:1.10.10.10:FF:001398', NULL, NULL, 'Cadmium resistance transcriptional regulatory protein CadC', NULL, NULL, NULL, NULL, NULL, 4),
(48860, NULL, 'G3DSA:1.25.40.10:FF:000444', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(48861, NULL, 'G3DSA:2.130.10.10:FF:000316', NULL, NULL, 'Plexin C1', NULL, NULL, NULL, NULL, NULL, 4),
(48862, NULL, 'G3DSA:3.10.400.20:FF:000018', NULL, NULL, 'Malignant T-cell-amplified sequence 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(48863, NULL, 'G3DSA:3.40.50.300:FF:008354', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48864, NULL, 'G3DSA:3.40.50.300:FF:000373', NULL, NULL, 'Cytoplasmic dynein heavy chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(48865, NULL, 'G3DSA:1.10.630.10:FF:000714', NULL, NULL, 'Cytochrome P450 1B', NULL, NULL, NULL, NULL, NULL, 4),
(48866, NULL, 'G3DSA:1.10.1750.10:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48867, NULL, 'G3DSA:3.40.140.10:FF:000062', NULL, NULL, 'tRNA-specific adenosine deaminase-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(48868, NULL, 'G3DSA:2.60.120.200:FF:000282', NULL, NULL, 'BEACH-DOMAIN HOMOLOG A1', NULL, NULL, NULL, NULL, NULL, 4),
(48869, NULL, 'G3DSA:3.30.200.20:FF:000156', NULL, NULL, 'MAP kinase-activated protein kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(48870, NULL, 'G3DSA:1.20.1250.10:FF:000053', NULL, NULL, 'Growth hormone 2', NULL, NULL, NULL, NULL, NULL, 4),
(48871, NULL, 'G3DSA:3.90.105.10:FF:000019', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(48872, NULL, 'G3DSA:2.130.10.10:FF:002688', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48873, NULL, 'G3DSA:2.40.20.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48874, NULL, 'G3DSA:2.130.10.10:FF:005094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48875, NULL, 'G3DSA:3.30.1330.60:FF:000042', NULL, NULL, 'Peptidoglycan associated lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(48876, NULL, 'G3DSA:3.40.630.30:FF:000037', NULL, NULL, 'N-alpha-acetyltransferase daf-31-like', NULL, NULL, NULL, NULL, NULL, 4),
(48877, NULL, 'G3DSA:1.20.58.400:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(48878, NULL, 'G3DSA:1.25.70.10:FF:000042', NULL, NULL, 'Mitochondrial transcription termination factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(48879, NULL, 'G3DSA:3.30.930.10:FF:000259', NULL, NULL, 'Threonine--tRNA ligase, chloroplastic/mitochondrial 2 isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(48880, NULL, 'G3DSA:3.10.25.10:FF:000011', NULL, NULL, 'Methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(48881, NULL, 'G3DSA:2.40.70.10:FF:000122', NULL, NULL, 'Plasmepsin VII', NULL, NULL, NULL, NULL, NULL, 4),
(48882, NULL, 'G3DSA:1.20.5.2050:FF:000002', NULL, NULL, 'Transcription factor with AP2 domain(S)', NULL, NULL, NULL, NULL, NULL, 4),
(48883, NULL, 'G3DSA:3.40.30.10:FF:001123', NULL, NULL, 'Chloride intracellular channel 4', NULL, NULL, NULL, NULL, NULL, 4),
(48884, NULL, 'G3DSA:1.50.40.10:FF:000144', NULL, NULL, 'Mitochondrial glycine transporter', NULL, NULL, NULL, NULL, NULL, 4),
(48885, NULL, 'G3DSA:1.20.1250.20:FF:000595', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48886, NULL, 'G3DSA:2.40.10.10:FF:000225', NULL, NULL, 'GD19101', NULL, NULL, NULL, NULL, NULL, 4),
(48887, NULL, 'G3DSA:3.40.50.2300:FF:001663', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48888, NULL, 'G3DSA:1.25.10.10:FF:000375', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48889, NULL, 'G3DSA:2.130.10.10:FF:003969', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48890, NULL, 'G3DSA:3.30.200.20:FF:001792', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48891, NULL, 'G3DSA:1.10.540.10:FF:000062', NULL, NULL, 'Flavin-dependent monooxygenase, oxygenase subunit HsaA', NULL, NULL, NULL, NULL, NULL, 4),
(48892, NULL, 'G3DSA:3.80.10.10:FF:004442', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48893, NULL, 'G3DSA:1.10.20.10:FF:000364', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48894, NULL, 'G3DSA:2.30.42.10:FF:000546', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48895, NULL, 'G3DSA:1.10.10.10:FF:000436', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(48896, NULL, 'G3DSA:2.40.50.100:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48897, NULL, 'G3DSA:1.25.40.840:FF:000003', NULL, NULL, 'Transcription regulator', NULL, NULL, NULL, NULL, NULL, 4),
(48898, NULL, 'G3DSA:3.20.20.140:FF:000137', NULL, NULL, 'Protein CBG19874', NULL, NULL, NULL, NULL, NULL, 4),
(48899, NULL, 'G3DSA:3.30.40.10:FF:002097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48900, NULL, 'G3DSA:2.40.10.10:FF:000101', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(48901, NULL, 'G3DSA:1.25.40.20:FF:000104', NULL, NULL, 'Ankyrin 2, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(48902, NULL, 'G3DSA:2.10.110.10:FF:000267', NULL, NULL, 'LIM homeobox 2a', NULL, NULL, NULL, NULL, NULL, 4),
(48903, NULL, 'G3DSA:3.40.50.1010:FF:000073', NULL, NULL, 'Ribonuclease VapC', NULL, NULL, NULL, NULL, NULL, 4),
(48904, NULL, 'G3DSA:3.40.50.12710:FF:000007', NULL, NULL, 'SAM-dependent methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(48905, NULL, 'G3DSA:3.60.20.10:FF:000155', NULL, NULL, 'Asparagine synthetase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(48906, NULL, 'G3DSA:2.60.40.150:FF:000364', NULL, NULL, 'Sperm vesicle fusion protein fer-1', NULL, NULL, NULL, NULL, NULL, 4),
(48907, NULL, 'G3DSA:3.40.50.300:FF:006797', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48908, NULL, 'G3DSA:1.25.40.10:FF:002001', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g79490, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(48909, NULL, 'G3DSA:4.10.860.120:FF:000029', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(48910, NULL, 'G3DSA:2.60.40.1930:FF:000002', NULL, NULL, 'PZP, alpha-2-macroglobulin like', NULL, NULL, NULL, NULL, NULL, 4),
(48911, NULL, 'G3DSA:3.40.50.2020:FF:000033', NULL, NULL, 'Xanthine phosphoribosyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(48912, NULL, 'G3DSA:3.80.10.10:FF:002188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48913, NULL, 'G3DSA:2.60.40.10:FF:001636', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(48914, NULL, 'G3DSA:1.20.1000.10:FF:000001', NULL, NULL, 'Guanylate binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(48915, NULL, 'G3DSA:1.10.10.60:FF:000524', NULL, NULL, 'cDNA FLJ16624 fis, clone TESTI4015442, moderately similar to Mus musculus zinc finger homeodomain 4 (Zfh4-pending)', NULL, NULL, NULL, NULL, NULL, 4),
(48916, NULL, 'G3DSA:1.20.1270.60:FF:000041', NULL, NULL, 'F-BAR and double SH3 domains protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(48917, NULL, 'G3DSA:3.40.50.300:FF:003020', NULL, NULL, 'SNF2-related domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(48918, NULL, 'G3DSA:3.30.565.10:FF:000516', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48919, NULL, 'G3DSA:1.25.40.10:FF:001725', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(48920, NULL, 'G3DSA:3.40.50.1100:FF:000111', NULL, NULL, 'Threonine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(48921, NULL, 'G3DSA:1.10.510.10:FF:003668', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48922, NULL, 'G3DSA:2.60.120.1000:FF:000027', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48923, NULL, 'G3DSA:1.10.1520.10:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48924, NULL, 'G3DSA:2.130.10.10:FF:003306', NULL, NULL, 'Chromosome 12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(48925, NULL, 'G3DSA:3.90.79.10:FF:000047', NULL, NULL, 'Transient receptor potential cation channel subfamily M member 2', NULL, NULL, NULL, NULL, NULL, 4),
(48926, NULL, 'G3DSA:3.20.20.70:FF:000039', NULL, NULL, 'N-acetylneuraminate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(48927, NULL, 'G3DSA:1.20.5.100:FF:000032', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(48928, NULL, 'G3DSA:3.40.50.1820:FF:001619', NULL, NULL, 'Os04g0381400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(48929, NULL, 'G3DSA:3.40.50.150:FF:000743', NULL, NULL, 'Protein with similarity to HEN1 (Arabidopsis thaliana)', NULL, NULL, NULL, NULL, NULL, 4),
(48930, NULL, 'G3DSA:3.90.190.10:FF:000323', NULL, NULL, 'Chromosome 16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(48931, NULL, 'G3DSA:3.40.50.720:FF:002078', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(48932, NULL, 'G3DSA:3.40.1110.10:FF:000222', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(48933, NULL, 'G3DSA:3.30.230.10:FF:000346', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48934, NULL, 'G3DSA:3.40.50.300:FF:007073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48935, NULL, 'G3DSA:1.10.10.10:FF:000206', NULL, NULL, '1-phosphatidylinositol 3-phosphate 5-kinase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(48936, NULL, 'G3DSA:2.60.40.60:FF:000089', NULL, NULL, 'FAT atypical cadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(48937, NULL, 'G3DSA:1.10.472.80:FF:000103', NULL, NULL, 'TBC Kinase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(48938, NULL, 'G3DSA:1.20.1560.10:FF:000363', NULL, NULL, 'Multidrug resistance-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(48939, NULL, 'G3DSA:1.25.10.10:FF:001336', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48940, NULL, 'G3DSA:1.10.150.20:FF:000006', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(48941, NULL, 'G3DSA:1.20.5.710:FF:000018', NULL, NULL, '50S ribosomal protein L7/L12', NULL, NULL, NULL, NULL, NULL, 4),
(48942, NULL, 'G3DSA:3.40.50.620:FF:000704', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(48943, NULL, 'G3DSA:2.30.110.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(48944, NULL, 'G3DSA:3.40.720.10:FF:000038', NULL, NULL, 'Arylsulfatase AtsA', NULL, NULL, NULL, NULL, NULL, 4),
(48945, NULL, 'G3DSA:1.10.238.10:FF:000179', NULL, NULL, 'EF-hand calcium-binding domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(48946, NULL, 'G3DSA:2.10.25.10:FF:001019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48947, NULL, 'G3DSA:2.30.30.190:FF:000004', NULL, NULL, 'Putative ubiquitin carboxyl-terminal hydrolase CYLD', NULL, NULL, NULL, NULL, NULL, 4),
(48948, NULL, 'G3DSA:1.20.120.1080:FF:000068', NULL, NULL, 'ATP-dependent RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48949, NULL, 'G3DSA:2.40.50.90:FF:000083', NULL, NULL, 'Staphylococcal nuclease domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(48950, NULL, 'G3DSA:3.90.182.10:FF:000001', NULL, NULL, 'Protective antigen', NULL, NULL, NULL, NULL, NULL, 4),
(48951, NULL, 'G3DSA:3.50.50.60:FF:001015', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(48952, NULL, 'G3DSA:2.60.120.260:FF:000030', NULL, NULL, 'Reelin', NULL, NULL, NULL, NULL, NULL, 4),
(48953, NULL, 'G3DSA:1.10.8.60:FF:000433', NULL, NULL, 'ORC1-type DNA replication protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(48954, NULL, 'G3DSA:3.40.50.720:FF:001561', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48955, NULL, 'G3DSA:3.30.70.120:FF:000010', NULL, NULL, 'Divalent cation tolerance protein, CutA1 family', NULL, NULL, NULL, NULL, NULL, 4),
(48956, NULL, 'G3DSA:3.40.50.20:FF:000054', NULL, NULL, 'SyNapsiN', NULL, NULL, NULL, NULL, NULL, 4),
(48957, NULL, 'G3DSA:1.20.58.1880:FF:000030', NULL, NULL, 'Myb domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(48958, NULL, 'G3DSA:3.40.50.1000:FF:000536', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48959, NULL, 'G3DSA:1.20.1070.10:FF:000960', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48960, NULL, 'G3DSA:1.10.10.10:FF:000779', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(48961, NULL, 'G3DSA:3.30.40.10:FF:001478', NULL, NULL, 'MIZ/SP-RING zinc finger, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48962, NULL, 'G3DSA:3.30.67.10:FF:000005', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(48963, NULL, 'G3DSA:3.90.70.10:FF:000314', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(48964, NULL, 'G3DSA:3.30.200.20:FF:000499', NULL, NULL, 'Cdc2-related protein kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(48965, NULL, 'G3DSA:2.30.29.30:FF:000903', NULL, NULL, 'FERM, RhoGEF (ARHGEF) and pleckstrin domain protein 1 (chondrocyte-derived)', NULL, NULL, NULL, NULL, NULL, 4),
(48966, NULL, 'G3DSA:3.10.110.10:FF:000370', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(48967, NULL, 'G3DSA:3.40.50.1440:FF:000084', NULL, NULL, 'Tubulin/FtsZ family, C-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(48968, NULL, 'G3DSA:2.130.10.10:FF:002345', NULL, NULL, 'Protein phosphatase PP2A regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(48969, NULL, 'G3DSA:3.30.70.2850:FF:000037', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(48970, NULL, 'G3DSA:2.40.50.120:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48971, NULL, 'G3DSA:1.25.40.10:FF:003193', NULL, NULL, 'Pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(48972, NULL, 'G3DSA:4.10.1000.10:FF:000085', NULL, NULL, 'FI03239p', NULL, NULL, NULL, NULL, NULL, 4),
(48973, NULL, 'G3DSA:1.10.8.60:FF:000557', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48974, NULL, 'G3DSA:2.60.530.10:FF:000001', NULL, NULL, 'Surface protein adhesin', NULL, NULL, NULL, NULL, NULL, 4),
(48975, NULL, 'G3DSA:1.20.1070.10:FF:000067', NULL, NULL, 'G-protein coupled receptor 12', NULL, NULL, NULL, NULL, NULL, 4),
(48976, NULL, 'G3DSA:1.10.1270.20:FF:000003', NULL, NULL, 'tRNA (guanine-N(1)-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(48977, NULL, 'G3DSA:1.10.10.10:FF:001055', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(48978, NULL, 'G3DSA:2.60.120.920:FF:000042', NULL, NULL, 'neuralized-like protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(48979, NULL, 'G3DSA:1.20.1730.10:FF:000067', NULL, NULL, 'High affinity choline transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(48980, NULL, 'G3DSA:3.40.50.300:FF:005605', NULL, NULL, 'Dynein heavy chain 14, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(48981, NULL, 'G3DSA:3.40.50.150:FF:001592', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48982, NULL, 'G3DSA:3.40.50.150:FF:000182', NULL, NULL, 'Nicotianamine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(48983, NULL, 'G3DSA:3.90.320.10:FF:000042', NULL, NULL, 'DNA helicase II', NULL, NULL, NULL, NULL, NULL, 4),
(48984, NULL, 'G3DSA:3.40.30.10:FF:000162', NULL, NULL, 'Glutathione S-transferase Gst3', NULL, NULL, NULL, NULL, NULL, 4),
(48985, NULL, 'G3DSA:2.60.40.10:FF:001069', NULL, NULL, 'Fibronectin 1', NULL, NULL, NULL, NULL, NULL, 4),
(48986, NULL, 'G3DSA:3.40.50.620:FF:000917', NULL, NULL, 'Electron transfer flavoprotein subunit alpha mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(48987, NULL, 'G3DSA:3.30.200.20:FF:001808', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(48988, NULL, 'G3DSA:2.60.120.200:FF:000388', NULL, NULL, 'Anti-tumor lectin', NULL, NULL, NULL, NULL, NULL, 4),
(48989, NULL, 'G3DSA:1.20.1440.340:FF:000014', NULL, NULL, 'AGAP012567-PA', NULL, NULL, NULL, NULL, NULL, 4),
(48990, NULL, 'G3DSA:1.10.8.720:FF:000035', NULL, NULL, 'Putative dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(48991, NULL, 'G3DSA:3.80.20.20:FF:000106', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48992, NULL, 'G3DSA:3.40.50.300:FF:000934', NULL, NULL, 'ADP-ribosylation factor-like 15 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(48993, NULL, 'G3DSA:1.10.418.10:FF:000171', NULL, NULL, 'dixin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(48994, NULL, 'G3DSA:2.40.37.10:FF:000039', NULL, NULL, 'Probable diaminopimelate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(48995, NULL, 'G3DSA:2.60.260.20:FF:000011', NULL, NULL, 'DnaJ homolog subfamily A member 1', NULL, NULL, NULL, NULL, NULL, 4),
(48996, NULL, 'G3DSA:3.40.720.10:FF:000376', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(48997, NULL, 'G3DSA:3.20.20.80:FF:000604', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(48998, NULL, 'G3DSA:3.40.50.300:FF:001446', NULL, NULL, 'DsDNA exonuclease SbcC', NULL, NULL, NULL, NULL, NULL, 4),
(48999, NULL, 'G3DSA:1.20.1250.40:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49000, NULL, 'G3DSA:1.10.3410.10:FF:000001', NULL, NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(49001, NULL, 'G3DSA:2.40.150.20:FF:000007', NULL, NULL, '50S ribosomal protein L14', NULL, NULL, NULL, NULL, NULL, 4),
(49002, NULL, 'G3DSA:1.10.10.10:FF:001268', NULL, NULL, 'Ferric uptake regulator, Fur family', NULL, NULL, NULL, NULL, NULL, 4),
(49003, NULL, 'G3DSA:3.40.50.2000:FF:000954', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49004, NULL, 'G3DSA:2.70.150.10:FF:000071', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(49005, NULL, 'G3DSA:3.30.70.3400:FF:000006', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(49006, NULL, 'G3DSA:1.20.120.1200:FF:000025', NULL, NULL, 'NADH-quinone oxidoreductase subunit J', NULL, NULL, NULL, NULL, NULL, 4),
(49007, NULL, 'G3DSA:1.10.8.10:FF:000227', NULL, NULL, 'Ubiquitin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(49008, NULL, 'G3DSA:1.10.3090.10:FF:000020', NULL, NULL, 'Bifunctional uridylyltransferase/uridylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(49009, NULL, 'G3DSA:3.10.20.620:FF:000008', NULL, NULL, 'Autophagy protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(49010, NULL, 'G3DSA:2.130.10.10:FF:000535', NULL, NULL, 'Eukaryotic translation initiation factor 2 alpha kinase 3', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(49011, NULL, 'G3DSA:2.30.29.30:FF:000797', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49012, NULL, 'G3DSA:3.30.160.60:FF:002137', NULL, NULL, 'Specific RNA polymerase II transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(49013, NULL, 'G3DSA:3.40.50.10490:FF:000167', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49014, NULL, 'G3DSA:3.65.10.20:FF:000023', NULL, NULL, 'RNA terminal phosphate cyclase-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(49015, NULL, 'G3DSA:1.20.120.350:FF:000196', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49016, NULL, 'G3DSA:1.25.10.10:FF:003472', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49017, NULL, 'G3DSA:3.30.40.210:FF:000003', NULL, NULL, 'Transcription elongation factor SPT4', NULL, NULL, NULL, NULL, NULL, 4),
(49018, NULL, 'G3DSA:3.40.640.10:FF:000324', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49019, NULL, 'G3DSA:4.10.240.10:FF:000050', NULL, NULL, 'C6 transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(49020, NULL, 'G3DSA:3.20.20.70:FF:000489', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49021, NULL, 'G3DSA:1.20.58.60:FF:000667', NULL, NULL, 'Microtubule-actin cross-linking factor 1, isoforms 1/2/3/5', NULL, NULL, NULL, NULL, NULL, 4),
(49022, NULL, 'G3DSA:2.70.170.10:FF:000066', NULL, NULL, 'Glutamate-gated ChLoride channel', NULL, NULL, NULL, NULL, NULL, 4),
(49023, NULL, 'G3DSA:3.80.10.10:FF:000614', NULL, NULL, 'polycystin-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(49024, NULL, 'G3DSA:1.10.1200.10:FF:000046', NULL, NULL, 'Nonribosomal peptide synthetase easA', NULL, NULL, NULL, NULL, NULL, 4),
(49025, NULL, 'G3DSA:1.10.486.10:FF:000064', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(49026, NULL, 'G3DSA:3.40.50.300:FF:007859', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49027, NULL, 'G3DSA:2.60.40.10:FF:005447', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49028, NULL, 'G3DSA:3.30.160.60:FF:002244', NULL, NULL, 'Zinc finger protein 625', NULL, NULL, NULL, NULL, NULL, 4),
(49029, NULL, 'G3DSA:1.25.40.1040:FF:000037', NULL, NULL, 'N-terminal acetyltransferase A complex subunit NAT1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(49030, NULL, 'G3DSA:3.40.1060.10:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49031, NULL, 'G3DSA:3.30.40.10:FF:001377', NULL, NULL, 'NHL repeat containing E3 ubiquitin protein ligase 1', NULL, NULL, NULL, NULL, NULL, 4),
(49032, NULL, 'G3DSA:2.60.40.150:FF:000471', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49033, NULL, 'G3DSA:1.20.1270.260:FF:000001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49034, NULL, 'G3DSA:3.10.20.310:FF:000022', NULL, NULL, 'Outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(49035, NULL, 'G3DSA:1.20.1070.10:FF:001028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49036, NULL, 'G3DSA:3.30.40.10:FF:000865', NULL, NULL, 'CHD3-type chromatin-remodeling factor PICKLE', NULL, NULL, NULL, NULL, NULL, 4),
(49037, NULL, 'G3DSA:1.20.1560.10:FF:000368', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49038, NULL, 'G3DSA:3.30.160.60:FF:001625', NULL, NULL, 'Zinc finger protein 569', NULL, NULL, NULL, NULL, NULL, 4),
(49039, NULL, 'G3DSA:2.130.10.10:FF:003290', NULL, NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', NULL, NULL, NULL, NULL, NULL, 4),
(49040, NULL, 'G3DSA:3.30.160.60:FF:001732', NULL, NULL, 'Zgc:162936', NULL, NULL, NULL, NULL, NULL, 4),
(49041, NULL, 'G3DSA:3.40.50.150:FF:001480', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49042, NULL, 'G3DSA:3.30.1330.30:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49043, NULL, 'G3DSA:1.10.1100.10:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49044, NULL, 'G3DSA:3.30.40.10:FF:000972', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(49045, NULL, 'G3DSA:2.40.30.170:FF:000069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49046, NULL, 'G3DSA:1.20.1070.10:FF:000516', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49047, NULL, 'G3DSA:2.20.100.10:FF:000146', NULL, NULL, 'CBN-PPN-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(49048, NULL, 'G3DSA:2.20.28.120:FF:000011', NULL, NULL, 'Mrpl39p', NULL, NULL, NULL, NULL, NULL, 4),
(49049, NULL, 'G3DSA:2.60.120.200:FF:000495', NULL, NULL, 'Laminin subunit alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(49050, NULL, 'G3DSA:3.30.9.10:FF:000012', NULL, NULL, 'Dimethylglycine dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(49051, NULL, 'G3DSA:1.20.1560.10:FF:000475', NULL, NULL, 'ABC-type multidrug/protein/lipid transport system, ATPase component', NULL, NULL, NULL, NULL, NULL, 4),
(49052, NULL, 'G3DSA:1.25.40.10:FF:003081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49053, NULL, 'G3DSA:1.25.40.20:FF:001846', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(49054, NULL, 'G3DSA:1.10.510.10:FF:001515', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(49055, NULL, 'G3DSA:3.20.20.80:FF:000599', NULL, NULL, 'Glycoside hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(49056, NULL, 'G3DSA:3.30.300.110:FF:000009', NULL, NULL, 'tRNA (Guanine(37)-N1)-methyltransferase Trm5b', NULL, NULL, NULL, NULL, NULL, 4),
(49057, NULL, 'G3DSA:3.30.160.60:FF:006408', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49058, NULL, 'G3DSA:3.40.1110.10:FF:000227', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49059, NULL, 'G3DSA:1.25.40.10:FF:003985', NULL, NULL, 'N-ethylmaleimide-sensitive factor attachment protein, beta a', NULL, NULL, NULL, NULL, NULL, 4),
(49060, NULL, 'G3DSA:2.30.30.1150:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49061, NULL, 'G3DSA:4.10.1240.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49062, NULL, 'G3DSA:1.10.287.3160:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49063, NULL, 'G3DSA:3.40.50.1820:FF:000445', NULL, NULL, 'Lecithin-cholesterol acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(49064, NULL, 'G3DSA:1.10.630.10:FF:000046', NULL, NULL, 'Cytochrome P450 90A1', NULL, NULL, NULL, NULL, NULL, 4),
(49065, NULL, 'G3DSA:2.60.40.10:FF:004161', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49066, NULL, 'G3DSA:3.40.50.10260:FF:000008', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(49067, NULL, 'G3DSA:1.20.140.160:FF:000002', NULL, NULL, 'RNA polymerase sigma factor RpoH', NULL, NULL, NULL, NULL, NULL, 4),
(49068, NULL, 'G3DSA:3.30.200.20:FF:000611', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(49069, NULL, 'G3DSA:2.10.70.10:FF:000241', NULL, NULL, 'Complement factor B', NULL, NULL, NULL, NULL, NULL, 4),
(49070, NULL, 'G3DSA:1.20.1270.280:FF:000007', NULL, NULL, 'dynein heavy chain 2, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(49071, NULL, 'G3DSA:2.30.29.30:FF:000802', NULL, NULL, 'Wiskott-Aldrich syndrome, like', NULL, NULL, NULL, NULL, NULL, 4),
(49072, NULL, 'G3DSA:3.30.2350.20:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49073, NULL, 'G3DSA:3.30.230.10:FF:000110', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(49074, NULL, 'G3DSA:1.10.10.60:FF:000305', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(49075, NULL, 'G3DSA:1.20.970.10:FF:000029', NULL, NULL, 'Anthranilate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(49076, NULL, 'G3DSA:2.30.40.10:FF:000143', NULL, NULL, 'Alpha-D-ribose 1-methylphosphonate 5-triphosphate diphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(49077, NULL, 'G3DSA:1.25.40.20:FF:000329', NULL, NULL, 'No mechanoreceptor potential C, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(49078, NULL, 'G3DSA:1.10.287.3240:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(49079, NULL, 'G3DSA:3.40.50.10470:FF:000072', NULL, NULL, 'Translation initiation factor eif-2b alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(49080, NULL, 'G3DSA:3.40.50.1820:FF:000338', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49081, NULL, 'G3DSA:3.80.10.10:FF:000496', NULL, NULL, 'Thyrotropin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(49082, NULL, 'G3DSA:3.40.50.10330:FF:000058', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(49083, NULL, 'G3DSA:3.40.50.300:FF:001339', NULL, NULL, 'Mitochondrial ribosome-associated GTPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(49084, NULL, 'G3DSA:3.40.1020.10:FF:000001', NULL, NULL, 'L-threonine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(49085, NULL, 'G3DSA:1.10.287.810:FF:000004', NULL, NULL, 'Mitochondrial import inner membrane translocase subunit Tim9', NULL, NULL, NULL, NULL, NULL, 4),
(49086, NULL, 'G3DSA:3.30.160.210:FF:000001', NULL, NULL, 'Nuclease SbcCD subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(49087, NULL, 'G3DSA:3.30.200.20:FF:001915', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49088, NULL, 'G3DSA:1.25.40.470:FF:000083', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49089, NULL, 'G3DSA:2.60.120.330:FF:000079', NULL, NULL, 'Protein SRG1', NULL, NULL, NULL, NULL, NULL, 4),
(49090, NULL, 'G3DSA:1.10.720.30:FF:000031', NULL, NULL, 'Apoptotic chromatin condensation inducer 1', NULL, NULL, NULL, NULL, NULL, 4),
(49091, NULL, 'G3DSA:3.40.50.300:FF:005717', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(49092, NULL, 'G3DSA:1.10.510.10:FF:004270', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49093, NULL, 'G3DSA:3.20.20.105:FF:000002', NULL, NULL, 'Queuine tRNA-ribosyltransferase accessory subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(49094, NULL, 'G3DSA:1.20.1070.10:FF:001461', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49095, NULL, 'G3DSA:1.50.10.10:FF:000199', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(49096, NULL, 'G3DSA:1.10.390.10:FF:000010', NULL, NULL, 'Leucyl-cystinyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(49097, NULL, 'G3DSA:1.20.5.110:FF:000153', NULL, NULL, 'Target SNARE, putative', NULL, NULL, NULL, NULL, NULL, 4),
(49098, NULL, 'G3DSA:3.40.190.10:FF:000121', NULL, NULL, 'HTH-type transcriptional regulator cbl', NULL, NULL, NULL, NULL, NULL, 4),
(49099, NULL, 'G3DSA:1.10.1200.10:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49100, NULL, 'G3DSA:3.80.10.10:FF:001912', NULL, NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(49101, NULL, 'G3DSA:3.30.70.330:FF:001259', NULL, NULL, 'Putative rna recognition domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(49102, NULL, 'G3DSA:2.60.120.330:FF:000186', NULL, NULL, '2-oxoglutarate (2OG) and Fe(II)-dependent oxygenase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(49103, NULL, 'G3DSA:3.40.30.10:FF:001011', NULL, NULL, 'Tumor suppressor candidate 3', NULL, NULL, NULL, NULL, NULL, 4),
(49104, NULL, 'G3DSA:3.90.980.10:FF:000001', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(49105, NULL, 'G3DSA:3.30.750.24:FF:000005', NULL, NULL, 'Anti-sigma F factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(49106, NULL, 'G3DSA:3.40.50.720:FF:002297', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(49107, NULL, 'G3DSA:1.10.510.10:FF:003432', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49108, NULL, 'G3DSA:1.10.510.10:FF:001408', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(49109, NULL, 'G3DSA:2.60.40.640:FF:000067', NULL, NULL, 'Vacuolar sorting-associated protein-like,putative', NULL, NULL, NULL, NULL, NULL, 4),
(49110, NULL, 'G3DSA:3.30.310.10:FF:000055', NULL, NULL, 'TATA-box-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(49111, NULL, 'G3DSA:3.40.50.300:FF:007174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(49112, NULL, 'G3DSA:3.40.50.410:FF:000175', NULL, NULL, 'Complement factor B', NULL, NULL, NULL, NULL, NULL, 4),
(49113, NULL, 'G3DSA:2.60.40.790:FF:000191', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49114, NULL, 'G3DSA:3.80.10.10:FF:001019', NULL, NULL, 'Si:ch211-213a13.5', NULL, NULL, NULL, NULL, NULL, 4),
(49115, NULL, 'G3DSA:1.10.555.10:FF:000197', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49116, NULL, 'G3DSA:1.10.150.440:FF:000001', NULL, NULL, 'Antimicrobial peptide microplusin', NULL, NULL, NULL, NULL, NULL, 4),
(49117, NULL, 'G3DSA:1.20.5.730:FF:000007', NULL, NULL, 'V-type proton ATPase subunit G', NULL, NULL, NULL, NULL, NULL, 4),
(49118, NULL, 'G3DSA:2.60.40.60:FF:000325', NULL, NULL, 'Fat-like cadherin-related tumor suppressor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(49119, NULL, 'G3DSA:3.90.1480.20:FF:000010', NULL, NULL, 'ST6 beta-galactoside alpha-2,6-sialyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(49120, NULL, 'G3DSA:3.30.413.10:FF:000018', NULL, NULL, 'Nitrite/sulfite reductase, 4Fe-4S iron-sulfur cluster-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(49121, NULL, 'G3DSA:3.80.10.10:FF:001452', NULL, NULL, 'Leucine-rich repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(49122, NULL, 'G3DSA:2.30.39.10:FF:000061', NULL, NULL, 'Serpin 2', NULL, NULL, NULL, NULL, NULL, 4),
(49123, NULL, 'G3DSA:3.30.200.20:FF:001016', NULL, NULL, 'Probable cyclin-dependent kinase 10', NULL, NULL, NULL, NULL, NULL, 4),
(49124, NULL, 'G3DSA:2.60.110.10:FF:000014', NULL, NULL, 'Thaumatin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(49125, NULL, 'G3DSA:3.80.10.10:FF:000507', NULL, NULL, 'negative regulator of reactive oxygen species isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(49126, NULL, 'G3DSA:2.70.150.10:FF:000290', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(49127, NULL, 'G3DSA:2.10.25.10:FF:000974', NULL, NULL, 'Laminin subunit gamma-1', NULL, NULL, NULL, NULL, NULL, 4),
(49128, NULL, 'G3DSA:3.30.160.380:FF:000006', NULL, NULL, 'Dicer-2', NULL, NULL, NULL, NULL, NULL, 4),
(49129, NULL, 'G3DSA:1.10.533.10:FF:000028', NULL, NULL, 'Interleukin 1 receptor-associated kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(49130, NULL, 'G3DSA:3.30.420.270:FF:000028', NULL, NULL, 'Biopolymer transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(49131, NULL, 'G3DSA:3.90.70.10:FF:000073', NULL, NULL, 'Calpain 10', NULL, NULL, NULL, NULL, NULL, 4),
(49132, NULL, 'G3DSA:3.30.1490.20:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49133, NULL, 'G3DSA:1.10.287.90:FF:000029', NULL, NULL, 'Cytochrome c oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(49134, NULL, 'G3DSA:3.30.70.330:FF:002664', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49135, NULL, 'G3DSA:2.60.220.50:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49136, NULL, 'G3DSA:2.130.10.10:FF:005088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49137, NULL, 'G3DSA:3.40.50.2000:FF:000050', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(49138, NULL, 'G3DSA:3.30.40.10:FF:000758', NULL, NULL, 'WGS project CABT00000000 data, contig 2.1', NULL, NULL, NULL, NULL, NULL, 4),
(49139, NULL, 'G3DSA:1.25.40.10:FF:001624', NULL, NULL, 'PsbB mRNA maturation factor Mbb1', NULL, NULL, NULL, NULL, NULL, 4),
(49140, NULL, 'G3DSA:3.40.50.2020:FF:000056', NULL, NULL, 'Ribose-phosphate pyrophosphokinase II', NULL, NULL, NULL, NULL, NULL, 4),
(49141, NULL, 'G3DSA:3.40.630.10:FF:000498', NULL, NULL, 'Aspartyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(49142, NULL, 'G3DSA:3.30.70.1630:FF:000003', NULL, NULL, 'tRNA-modifying protein YgfZ', NULL, NULL, NULL, NULL, NULL, 4),
(49143, NULL, 'G3DSA:1.20.140.90:FF:000002', NULL, NULL, 'Malonyl-CoA decarboxylase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(49144, NULL, 'G3DSA:2.20.25.10:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(49145, NULL, 'G3DSA:3.90.20.20:FF:000016', NULL, NULL, 'Protein GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(49146, NULL, 'G3DSA:2.60.40.1180:FF:000176', NULL, NULL, 'Epididymis-specific alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(49147, NULL, 'G3DSA:2.10.70.10:FF:000022', NULL, NULL, 'fibronectin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(49148, NULL, 'G3DSA:2.10.70.10:FF:000134', NULL, NULL, 'Complement inhibitory factor H', NULL, NULL, NULL, NULL, NULL, 4),
(49149, NULL, 'G3DSA:1.10.238.10:FF:000073', NULL, NULL, 'calcineurin B-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(49150, NULL, 'G3DSA:3.30.70.330:FF:001129', NULL, NULL, 'RNA-binding protein 39', NULL, NULL, NULL, NULL, NULL, 4),
(49151, NULL, 'G3DSA:2.10.109.10:FF:000067', NULL, NULL, 'Transcriptional repressor LexA, putative', NULL, NULL, NULL, NULL, NULL, 4),
(49152, NULL, 'G3DSA:1.10.287.70:FF:000029', NULL, NULL, 'Voltage-dependent T-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(49153, NULL, 'G3DSA:3.90.940.40:FF:000002', NULL, NULL, 'Gsl0285 protein', NULL, NULL, NULL, NULL, NULL, 4),
(49154, NULL, 'G3DSA:3.40.1110.10:FF:000334', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49155, NULL, 'G3DSA:1.10.510.10:FF:001397', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(49156, NULL, 'G3DSA:1.25.10.10:FF:003253', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49157, NULL, 'G3DSA:1.25.10.10:FF:003365', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49158, NULL, 'G3DSA:3.40.50.620:FF:000013', NULL, NULL, 'Pantothenate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(49159, NULL, 'G3DSA:1.20.1250.20:FF:001236', NULL, NULL, 'Putative anion transporter 3 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(49160, NULL, 'G3DSA:3.30.420.100:FF:000005', NULL, NULL, '50S ribosomal protein L18', NULL, NULL, NULL, NULL, NULL, 4),
(49161, NULL, 'G3DSA:3.40.1810.10:FF:000011', NULL, NULL, 'MADS-box transcription factor 7', NULL, NULL, NULL, NULL, NULL, 4),
(49162, NULL, 'G3DSA:3.10.20.80:FF:000015', NULL, NULL, 'Probable mitochondrial translation initiation factor', NULL, NULL, NULL, NULL, NULL, 4),
(49163, NULL, 'G3DSA:3.50.30.30:FF:000078', NULL, NULL, 'Zinc and ring finger 3', NULL, NULL, NULL, NULL, NULL, 4),
(49164, NULL, 'G3DSA:3.40.50.300:FF:006229', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49165, NULL, 'G3DSA:1.25.40.10:FF:004497', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49166, NULL, 'G3DSA:2.30.42.10:FF:000653', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49167, NULL, 'G3DSA:1.10.3210.10:FF:000002', NULL, NULL, 'Nucleotidase YfbR', NULL, NULL, NULL, NULL, NULL, 4),
(49168, NULL, 'G3DSA:3.40.50.300:FF:002851', NULL, NULL, 'ADP-ribosylation factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(49169, NULL, 'G3DSA:3.30.450.20:FF:000326', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(49170, NULL, 'G3DSA:1.10.1140.10:FF:000007', NULL, NULL, 'V-type ATP synthase alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(49171, NULL, 'G3DSA:3.90.640.10:FF:000077', NULL, NULL, 'Actin-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(49172, NULL, 'G3DSA:3.40.50.1100:FF:000212', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49173, NULL, 'G3DSA:2.102.10.10:FF:000014', NULL, NULL, 'Oxidoreductase, FAD dependent', NULL, NULL, NULL, NULL, NULL, 4),
(49174, NULL, 'G3DSA:2.30.30.140:FF:000118', NULL, NULL, 'E3 ubiquitin-protein ligase UHRF2', NULL, NULL, NULL, NULL, NULL, 4),
(49175, NULL, 'G3DSA:1.10.1040.10:FF:000062', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(49176, NULL, 'G3DSA:3.30.60.30:FF:000069', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(49177, NULL, 'G3DSA:3.40.50.1820:FF:000557', NULL, NULL, 'Probable lipase', NULL, NULL, NULL, NULL, NULL, 4),
(49178, NULL, 'G3DSA:3.40.50.720:FF:001330', NULL, NULL, 'Peroxisomal 2,4-dienoyl-CoA reductase, putative', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(49179, NULL, 'G3DSA:3.30.160.60:FF:003986', NULL, NULL, 'C2H2 zinc finger protein EGL-46', NULL, NULL, NULL, NULL, NULL, 4),
(49180, NULL, 'G3DSA:2.130.10.10:FF:002452', NULL, NULL, 'Bifunctional endoribonuclease/protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(49181, NULL, 'G3DSA:1.10.10.60:FF:000417', NULL, NULL, 'Even-skipped homeobox 1', NULL, NULL, NULL, NULL, NULL, 4),
(49182, NULL, 'G3DSA:3.40.50.300:FF:000827', NULL, NULL, 'KTI12 chromatin-associated homolog', NULL, NULL, NULL, NULL, NULL, 4),
(49183, NULL, 'G3DSA:2.30.29.30:FF:001179', NULL, NULL, 'cAMP-dependent protein kinase catalytic subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(49184, NULL, 'G3DSA:3.40.640.10:FF:000431', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49185, NULL, 'G3DSA:1.20.1250.20:FF:000836', NULL, NULL, 'Solute carrier family 2, (Facilitated glucose transporter) member 8, isoform CRA_c', NULL, NULL, NULL, NULL, NULL, 4),
(49186, NULL, 'G3DSA:3.40.50.300:FF:004301', NULL, NULL, 'Os03g0627300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(49187, NULL, 'G3DSA:3.40.720.10:FF:000269', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49188, NULL, 'G3DSA:3.30.160.60:FF:004610', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49189, NULL, 'G3DSA:2.40.40.20:FF:000050', NULL, NULL, 'Thiosulfate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(49190, NULL, 'G3DSA:3.30.1330.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49191, NULL, 'G3DSA:1.10.533.10:FF:000247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49192, NULL, 'G3DSA:1.20.58.1370:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49193, NULL, 'G3DSA:1.20.5.340:FF:000104', NULL, NULL, 'Forkhead box protein P1', NULL, NULL, NULL, NULL, NULL, 4),
(49194, NULL, 'G3DSA:1.10.510.10:FF:002920', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49195, NULL, 'G3DSA:1.10.287.110:FF:000463', NULL, NULL, 'Radial spoke protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(49196, NULL, 'G3DSA:2.130.10.10:FF:000428', NULL, NULL, 'F-box and WD repeat domain containing 8', NULL, NULL, NULL, NULL, NULL, 4),
(49197, NULL, 'G3DSA:1.10.10.10:FF:001375', NULL, NULL, 'Transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(49198, NULL, 'G3DSA:1.10.3210.30:FF:000008', NULL, NULL, 'CRISPR-associated helicase Cas3', NULL, NULL, NULL, NULL, NULL, 4),
(49199, NULL, 'G3DSA:1.25.40.180:FF:000333', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49200, NULL, 'G3DSA:3.20.20.80:FF:000711', NULL, NULL, 'Lactase, gene 2', NULL, NULL, NULL, NULL, NULL, 4),
(49201, NULL, 'G3DSA:1.10.10.10:FF:000886', NULL, NULL, 'U5 small nuclear ribonucleoprotein helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(49202, NULL, 'G3DSA:1.10.10.10:FF:002117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49203, NULL, 'G3DSA:1.20.1070.10:FF:001680', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49204, NULL, 'G3DSA:3.10.20.600:FF:000002', NULL, NULL, 'NADH-quinone oxidoreductase subunit F', NULL, NULL, NULL, NULL, NULL, 4),
(49205, NULL, 'G3DSA:1.10.510.10:FF:004382', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49206, NULL, 'G3DSA:2.40.20.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49207, NULL, 'G3DSA:1.20.5.340:FF:000093', NULL, NULL, 'Rho-associated protein kinase 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(49208, NULL, 'G3DSA:2.40.10.10:FF:000118', NULL, NULL, 'Chymotrypsinogen A', NULL, NULL, NULL, NULL, NULL, 4),
(49209, NULL, 'G3DSA:3.20.14.10:FF:000002', NULL, NULL, 'L-fucose isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(49210, NULL, 'G3DSA:1.20.1270.60:FF:000147', NULL, NULL, 'Protein CBG09025', NULL, NULL, NULL, NULL, NULL, 4),
(49211, NULL, 'G3DSA:1.25.70.10:FF:000047', NULL, NULL, 'Cleavage and polyadenylation factor 6-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(49212, NULL, 'G3DSA:3.40.50.790:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(49213, NULL, 'G3DSA:2.40.50.140:FF:000396', NULL, NULL, 'rRNA biogenesis protein RRP5', NULL, NULL, NULL, NULL, NULL, 4),
(49214, NULL, 'G3DSA:1.10.10.2670:FF:000016', NULL, NULL, 'E3 ubiquitin-protein ligase UBR2', NULL, NULL, NULL, NULL, NULL, 4),
(49215, NULL, 'G3DSA:3.40.50.300:FF:000030', NULL, NULL, '26S protease regulatory subunit 8', NULL, NULL, NULL, NULL, NULL, 4),
(49216, NULL, 'G3DSA:1.25.40.20:FF:000548', NULL, NULL, 'Protein 21.1', NULL, NULL, NULL, NULL, NULL, 4),
(49217, NULL, 'G3DSA:1.20.1250.20:FF:001450', NULL, NULL, 'Solute carrier family 2, facilitated glucose transporter member 2', NULL, NULL, NULL, NULL, NULL, 4),
(49218, NULL, 'G3DSA:2.40.340.10:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49219, NULL, 'G3DSA:3.30.710.10:FF:000473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49220, NULL, 'G3DSA:2.10.90.10:FF:000147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49221, NULL, 'G3DSA:3.30.40.10:FF:000753', NULL, NULL, 'DNA repair protein RAD16', NULL, NULL, NULL, NULL, NULL, 4),
(49222, NULL, 'G3DSA:1.20.120.160:FF:000021', NULL, NULL, 'Chemotaxis protein CheA', NULL, NULL, NULL, NULL, NULL, 4),
(49223, NULL, 'G3DSA:2.60.120.200:FF:000040', NULL, NULL, 'neural-cadherin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(49224, NULL, 'G3DSA:3.40.50.300:FF:000035', NULL, NULL, 'Ribosome-binding ATPase YchF', NULL, NULL, NULL, NULL, NULL, 4),
(49225, NULL, 'G3DSA:3.10.310.20:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49226, NULL, 'G3DSA:3.80.10.10:FF:002868', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49227, NULL, 'G3DSA:1.25.40.10:FF:002928', NULL, NULL, 'Pellicle/biofilm biosynthesis protein PelB', NULL, NULL, NULL, NULL, NULL, 4),
(49228, NULL, 'G3DSA:3.30.9.10:FF:000231', NULL, NULL, 'Amino acid oxidase fmpA', NULL, NULL, NULL, NULL, NULL, 4),
(49229, NULL, 'G3DSA:1.25.40.10:FF:003204', NULL, NULL, 'Pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(49230, NULL, 'G3DSA:3.40.50.620:FF:000805', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49231, NULL, 'G3DSA:3.30.565.10:FF:000067', NULL, NULL, 'Two-component system sensor histidine kinase CreC', NULL, NULL, NULL, NULL, NULL, 4),
(49232, NULL, 'G3DSA:3.30.30.170:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49233, NULL, 'G3DSA:1.25.10.10:FF:002067', NULL, NULL, 'DNA-dependent protein kinase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(49234, NULL, 'G3DSA:3.40.50.300:FF:005594', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49235, NULL, 'G3DSA:1.20.120.1080:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49236, NULL, 'G3DSA:1.25.40.990:FF:000019', NULL, NULL, 'SAC3/GANP/Nin1/mts3/eIF-3 p25 family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(49237, NULL, 'G3DSA:3.40.50.10540:FF:000008', NULL, NULL, 'Probable CoA-transferase Rv1866', NULL, NULL, NULL, NULL, NULL, 4),
(49238, NULL, 'G3DSA:1.20.990.10:FF:000031', NULL, NULL, 'Probable oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(49239, NULL, 'G3DSA:2.40.50.140:FF:000401', NULL, NULL, 'Exosome complex exonuclease RRP40', NULL, NULL, NULL, NULL, NULL, 4),
(49240, NULL, 'G3DSA:1.20.1070.10:FF:002085', NULL, NULL, 'Growth hormone releasing hormone receptor', NULL, NULL, NULL, NULL, NULL, 4),
(49241, NULL, 'G3DSA:3.20.20.70:FF:000377', NULL, NULL, 'Radical SAM domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(49242, NULL, 'G3DSA:3.30.565.10:FF:000415', NULL, NULL, 'ATP-binding region ATPase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(49243, NULL, 'G3DSA:3.30.830.10:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49244, NULL, 'G3DSA:2.60.120.820:FF:000006', NULL, NULL, 'Blast:BTB/POZ domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(49245, NULL, 'G3DSA:3.40.50.10810:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(49246, NULL, 'G3DSA:1.10.10.10:FF:001156', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(49247, NULL, 'G3DSA:3.40.850.10:FF:000149', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(49248, NULL, 'G3DSA:1.10.238.10:FF:000078', NULL, NULL, 'Hippocalcin-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(49249, NULL, 'G3DSA:2.60.120.260:FF:000485', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49250, NULL, 'G3DSA:2.130.10.10:FF:002901', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49251, NULL, 'G3DSA:1.10.472.10:FF:000122', NULL, NULL, 'Cyclin-related protein FAM58A', NULL, NULL, NULL, NULL, NULL, 4),
(49252, NULL, 'G3DSA:3.20.20.140:FF:000475', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49253, NULL, 'G3DSA:2.70.150.10:FF:000183', NULL, NULL, 'Phospholipid-transporting ATPase IIB, putative', NULL, NULL, NULL, NULL, NULL, 4),
(49254, NULL, 'G3DSA:2.130.10.10:FF:005195', NULL, NULL, 'WD-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(49255, NULL, 'G3DSA:3.30.1640.10:FF:000039', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(49256, NULL, 'G3DSA:2.60.120.290:FF:000246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49257, NULL, 'G3DSA:3.40.50.300:FF:001558', NULL, NULL, 'Ribosome biogenesis GTPase Lsg1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(49258, NULL, 'G3DSA:3.10.580.10:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49259, NULL, 'G3DSA:2.60.40.10:FF:003093', NULL, NULL, 'Si:ch211-141e20.2', NULL, NULL, NULL, NULL, NULL, 4),
(49260, NULL, 'G3DSA:1.25.10.10:FF:003360', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49261, NULL, 'G3DSA:4.10.95.10:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49262, NULL, 'G3DSA:1.25.40.180:FF:000226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49263, NULL, 'G3DSA:1.10.510.10:FF:000211', NULL, NULL, 'Cyclin-dependent kinase G-2', NULL, NULL, NULL, NULL, NULL, 4),
(49264, NULL, 'G3DSA:3.90.780.10:FF:000020', NULL, NULL, '5`-nucleotidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(49265, NULL, 'G3DSA:3.90.1750.10:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49266, NULL, 'G3DSA:3.40.525.10:FF:000017', NULL, NULL, 'Phosphatidylinositol transfer protein sfh5', NULL, NULL, NULL, NULL, NULL, 4),
(49267, NULL, 'G3DSA:3.40.50.2300:FF:001090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49268, NULL, 'G3DSA:3.80.10.10:FF:000491', NULL, NULL, 'Blast:Protein toll', NULL, NULL, NULL, NULL, NULL, 4),
(49269, NULL, 'G3DSA:2.60.120.290:FF:000139', NULL, NULL, 'Cubilin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(49270, NULL, 'G3DSA:3.50.50.60:FF:000970', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(49271, NULL, 'G3DSA:3.40.50.150:FF:000423', NULL, NULL, 'tRNA (guanine(37)-N1)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(49272, NULL, 'G3DSA:3.30.70.330:FF:000062', NULL, NULL, 'serine/arginine-rich splicing factor SR34A-like', NULL, NULL, NULL, NULL, NULL, 4),
(49273, NULL, 'G3DSA:2.30.30.40:FF:000634', NULL, NULL, 'Glutamate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(49274, NULL, 'G3DSA:1.20.1560.10:FF:000256', NULL, NULL, 'Similar to ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(49275, NULL, 'G3DSA:1.10.510.10:FF:003769', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49276, NULL, 'G3DSA:1.20.58.830:FF:000020', NULL, NULL, 'Erythrocyte binding ligand-1', NULL, NULL, NULL, NULL, NULL, 4),
(49277, NULL, 'G3DSA:2.60.40.10:FF:004958', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49278, NULL, 'G3DSA:1.20.1000.10:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49279, NULL, 'G3DSA:2.60.120.970:FF:000023', NULL, NULL, 'Anti-dorsalizing morphogenetic protein 1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(49280, NULL, 'G3DSA:1.20.1280.170:FF:000015', NULL, NULL, 'Protein REDUCED WALL ACETYLATION 3', NULL, NULL, NULL, NULL, NULL, 4),
(49281, NULL, 'G3DSA:3.80.10.10:FF:002531', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49282, NULL, 'G3DSA:3.30.160.60:FF:001737', NULL, NULL, 'Zinc finger protein 100', NULL, NULL, NULL, NULL, NULL, 4),
(49283, NULL, 'G3DSA:1.10.287.90:FF:000024', NULL, NULL, 'Cytochrome c oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(49284, NULL, 'G3DSA:2.60.200.20:FF:000007', NULL, NULL, 'microspherule protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(49285, NULL, 'G3DSA:3.40.30.10:FF:000050', NULL, NULL, 'protein disulfide-isomerase A6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(49286, NULL, 'G3DSA:3.30.40.10:FF:001372', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49287, NULL, 'G3DSA:3.60.21.10:FF:000123', NULL, NULL, 'SA0881 protein', NULL, NULL, NULL, NULL, NULL, 4),
(49288, NULL, 'G3DSA:3.60.20.10:FF:000054', NULL, NULL, 'Proteasome subunit alpha type', NULL, NULL, NULL, NULL, NULL, 4),
(49289, NULL, 'G3DSA:3.30.1050.10:FF:000011', NULL, NULL, 'Peroxisomal multifunctional enzyme type 2', NULL, NULL, NULL, NULL, NULL, 4),
(49290, NULL, 'G3DSA:2.30.110.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49291, NULL, 'G3DSA:3.90.550.10:FF:000188', NULL, NULL, 'Polysaccharide biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(49292, NULL, 'G3DSA:3.30.70.330:FF:000410', NULL, NULL, 'ASF/SF2-like pre-mRNA splicing factor SRP31', NULL, NULL, NULL, NULL, NULL, 4),
(49293, NULL, 'G3DSA:3.40.50.410:FF:000282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49294, NULL, 'G3DSA:3.20.20.140:FF:000368', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49295, NULL, 'G3DSA:3.40.50.1820:FF:001513', NULL, NULL, 'Os01g0934600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(49296, NULL, 'G3DSA:1.20.1250.20:FF:000494', NULL, NULL, 'Transporter, MFS superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(49297, NULL, 'G3DSA:2.70.130.10:FF:000069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49298, NULL, 'G3DSA:3.40.50.2000:FF:000735', NULL, NULL, 'UDP-glycosyltransferase 82A1', NULL, NULL, NULL, NULL, NULL, 4),
(49299, NULL, 'G3DSA:1.10.357.10:FF:000034', NULL, NULL, 'Transcriptional regulator, TetR family', NULL, NULL, NULL, NULL, NULL, 4),
(49300, NULL, 'G3DSA:2.130.10.10:FF:001940', NULL, NULL, 'Pre-rRNA-processing protein IPI3', NULL, NULL, NULL, NULL, NULL, 4),
(49301, NULL, 'G3DSA:3.30.420.40:FF:000712', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49302, NULL, 'G3DSA:1.10.10.580:FF:000002', NULL, NULL, 'Sister chromatid cohesion 1 protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(49303, NULL, 'G3DSA:1.10.287.10:FF:000039', NULL, NULL, '40S ribosomal protein S13', NULL, NULL, NULL, NULL, NULL, 4),
(49304, NULL, 'G3DSA:3.20.20.80:FF:000823', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49305, NULL, 'G3DSA:3.40.50.2000:FF:001011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49306, NULL, 'G3DSA:3.30.420.10:FF:000714', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49307, NULL, 'G3DSA:3.20.20.70:FF:000034', NULL, NULL, 'Deoxyribose-phosphate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(49308, NULL, 'G3DSA:1.10.8.10:FF:000008', NULL, NULL, 'Holliday junction ATP-dependent DNA helicase RuvA', NULL, NULL, NULL, NULL, NULL, 4),
(49309, NULL, 'G3DSA:3.30.1370.100:FF:000025', NULL, NULL, 'DNA mismatch repair protein pms1', NULL, NULL, NULL, NULL, NULL, 4),
(49310, NULL, 'G3DSA:3.30.160.60:FF:000557', NULL, NULL, 'zinc finger and SCAN domain-containing protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(49311, NULL, 'G3DSA:2.60.40.10:FF:002137', NULL, NULL, 'Putative adhesin', NULL, NULL, NULL, NULL, NULL, 4),
(49312, NULL, 'G3DSA:1.20.1250.20:FF:000831', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(49313, NULL, 'G3DSA:3.40.50.450:FF:000052', NULL, NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(49314, NULL, 'G3DSA:3.90.550.10:FF:000536', NULL, NULL, 'Mannosylglycerate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(49315, NULL, 'G3DSA:2.40.160.10:FF:000044', NULL, NULL, 'AGAP002595-PA', NULL, NULL, NULL, NULL, NULL, 4),
(49316, NULL, 'G3DSA:3.10.580.10:FF:000073', NULL, NULL, 'CBS domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(49317, NULL, 'G3DSA:1.20.120.1750:FF:000162', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49318, NULL, 'G3DSA:1.20.5.190:FF:000019', NULL, NULL, 'Calmodulin-binding transcription activator 1', NULL, NULL, NULL, NULL, NULL, 4),
(49319, NULL, 'G3DSA:2.60.40.10:FF:004054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49320, NULL, 'G3DSA:3.30.40.10:FF:001714', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(49321, NULL, 'G3DSA:3.40.630.30:FF:000375', NULL, NULL, 'Acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(49322, NULL, 'G3DSA:2.40.10.10:FF:000337', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(49323, NULL, 'G3DSA:2.60.120.1000:FF:000021', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49324, NULL, 'G3DSA:3.40.50.300:FF:006903', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49325, NULL, 'G3DSA:3.40.50.300:FF:006117', NULL, NULL, 'DNA helicase related protein', NULL, NULL, NULL, NULL, NULL, 4),
(49326, NULL, 'G3DSA:3.10.20.90:FF:000344', NULL, NULL, 'Nuclear protein localization protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(49327, NULL, 'G3DSA:3.40.50.1820:FF:000552', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(49328, NULL, 'G3DSA:3.30.930.10:FF:000023', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(49329, NULL, 'G3DSA:2.40.30.10:FF:000232', NULL, NULL, 'Metalloreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(49330, NULL, 'G3DSA:1.20.930.80:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49331, NULL, 'G3DSA:1.20.1250.20:FF:001455', NULL, NULL, 'Major facilitator superfamily domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(49332, NULL, 'G3DSA:1.20.120.980:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49333, NULL, 'G3DSA:3.30.70.330:FF:000747', NULL, NULL, 'Serine and arginine rich splicing factor 12', NULL, NULL, NULL, NULL, NULL, 4),
(49334, NULL, 'G3DSA:2.60.40.10:FF:003778', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49335, NULL, 'G3DSA:3.30.1490.120:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49336, NULL, 'G3DSA:1.10.510.10:FF:003084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49337, NULL, 'G3DSA:2.130.10.10:FF:002233', NULL, NULL, 'GM24813', NULL, NULL, NULL, NULL, NULL, 4),
(49338, NULL, 'G3DSA:1.25.40.70:FF:000086', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', NULL, NULL, NULL, NULL, NULL, 4),
(49339, NULL, 'G3DSA:3.40.630.10:FF:000150', NULL, NULL, 'Nicastrin', NULL, NULL, NULL, NULL, NULL, 4),
(49340, NULL, 'G3DSA:2.130.10.10:FF:001833', NULL, NULL, 'Polyadenylation factor subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(49341, NULL, 'G3DSA:3.30.420.40:FF:000605', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49342, NULL, 'G3DSA:2.60.120.10:FF:000621', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49343, NULL, 'G3DSA:3.40.50.150:FF:000979', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49344, NULL, 'G3DSA:3.40.190.10:FF:000469', NULL, NULL, 'Dipeptide ABC transporter, substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(49345, NULL, 'G3DSA:3.40.1000.10:FF:000017', NULL, NULL, 'Tagatose-6-phosphate ketose/aldose isomerase, putative (Mog1/PsbP/DUF1795-like photosystem II reaction center PsbP family protein)', NULL, NULL, NULL, NULL, NULL, 4),
(49346, NULL, 'G3DSA:1.10.287.370:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49347, NULL, 'G3DSA:1.20.1070.10:FF:000623', NULL, NULL, 'Gonadotropin-releasing hormone receptor', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(49348, NULL, 'G3DSA:3.30.60.90:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49349, NULL, 'G3DSA:3.30.160.60:FF:005447', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49350, NULL, 'G3DSA:2.30.33.40:FF:000006', NULL, NULL, 'Head assembly cochaperone with GroEL', NULL, NULL, NULL, NULL, NULL, 4),
(49351, NULL, 'G3DSA:3.80.10.10:FF:002076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49352, NULL, 'G3DSA:2.130.10.10:FF:001485', NULL, NULL, 'WD domain, G-beta repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(49353, NULL, 'G3DSA:3.40.50.720:FF:001673', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49354, NULL, 'G3DSA:3.30.420.40:FF:000257', NULL, NULL, 'Actin-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(49355, NULL, 'G3DSA:1.25.10.10:FF:002741', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49356, NULL, 'G3DSA:3.80.10.10:FF:002289', NULL, NULL, 'F-box/LRR-repeat protein 20-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(49357, NULL, 'G3DSA:2.20.28.10:FF:000019', NULL, NULL, 'Dna replication licensing factor mcm9 mini-chromosome maintenance deficient 9 hmcm9 mini-chromosome maintenance deficient domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(49358, NULL, 'G3DSA:3.40.50.1460:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49359, NULL, 'G3DSA:2.60.40.150:FF:000252', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(49360, NULL, 'G3DSA:3.20.20.60:FF:000155', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(49361, NULL, 'G3DSA:3.30.160.60:FF:001518', NULL, NULL, 'Zinc finger with KRAB and SCAN domains 4', NULL, NULL, NULL, NULL, NULL, 4),
(49362, NULL, 'G3DSA:2.60.40.1180:FF:000064', NULL, NULL, 'Type I pullulanase', NULL, NULL, NULL, NULL, NULL, 4),
(49363, NULL, 'G3DSA:3.30.70.580:FF:000013', NULL, NULL, 'Ribosomal large subunit pseudouridine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(49364, NULL, 'G3DSA:3.50.50.100:FF:000041', NULL, NULL, 'Slr1591 protein', NULL, NULL, NULL, NULL, NULL, 4),
(49365, NULL, 'G3DSA:1.20.5.490:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49366, NULL, 'G3DSA:1.10.1140.10:FF:000002', NULL, NULL, 'V-type proton ATPase catalytic subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(49367, NULL, 'G3DSA:3.30.870.10:FF:000181', NULL, NULL, 'Phospholipase D-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(49368, NULL, 'G3DSA:3.30.200.20:FF:000959', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 17', NULL, NULL, NULL, NULL, NULL, 4),
(49369, NULL, 'G3DSA:3.40.50.1260:FF:000013', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(49370, NULL, 'G3DSA:1.25.40.10:FF:000107', NULL, NULL, 'CCR4-NOT transcription complex subunit 10 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(49371, NULL, 'G3DSA:3.30.200.20:FF:001359', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(49372, NULL, 'G3DSA:1.25.40.170:FF:000004', NULL, NULL, 'Protein Smaug', NULL, NULL, NULL, NULL, NULL, 4),
(49373, NULL, 'G3DSA:1.25.10.10:FF:001448', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(49374, NULL, 'G3DSA:3.40.50.1980:FF:000116', NULL, NULL, 'Ferrichrome ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(49375, NULL, 'G3DSA:2.10.110.10:FF:000031', NULL, NULL, 'LIM homeobox 6, isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(49376, NULL, 'G3DSA:3.30.450.20:FF:000219', NULL, NULL, 'Nitrogen regulation protein', NULL, NULL, NULL, NULL, NULL, 4),
(49377, NULL, 'G3DSA:3.30.160.60:FF:002682', NULL, NULL, 'Zinc finger protein 646', NULL, NULL, NULL, NULL, NULL, 4),
(49378, NULL, 'G3DSA:3.40.850.10:FF:000256', NULL, NULL, 'KIF20A isoform 5', NULL, NULL, NULL, NULL, NULL, 4),
(49379, NULL, 'G3DSA:3.40.50.150:FF:001816', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(49380, NULL, 'G3DSA:1.10.510.10:FF:002465', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(49381, NULL, 'G3DSA:2.60.40.10:FF:003997', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49382, NULL, 'G3DSA:3.30.70.330:FF:003046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49383, NULL, 'G3DSA:1.10.472.10:FF:000341', NULL, NULL, 'Mitotic cyclin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(49384, NULL, 'G3DSA:1.20.58.70:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49385, NULL, 'G3DSA:1.10.565.10:FF:000023', NULL, NULL, 'Steroid hormone receptor ERR1', NULL, NULL, NULL, NULL, NULL, 4),
(49386, NULL, 'G3DSA:2.120.10.30:FF:000272', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(49387, NULL, 'G3DSA:3.10.100.10:FF:000111', NULL, NULL, 'Adhesion G protein-coupled receptor L3', NULL, NULL, NULL, NULL, NULL, 4),
(49388, NULL, 'G3DSA:3.30.10.20:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49389, NULL, 'G3DSA:2.60.40.10:FF:004273', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49390, NULL, 'G3DSA:3.40.50.300:FF:000378', NULL, NULL, 'ATP-dependent Clp protease ATP-binding subunit clpX-like, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(49391, NULL, 'G3DSA:1.10.510.10:FF:002813', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49392, NULL, 'G3DSA:3.40.50.720:FF:000728', NULL, NULL, 'D-lactate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(49393, NULL, 'G3DSA:3.40.50.620:FF:000120', NULL, NULL, 'Valine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(49394, NULL, 'G3DSA:1.20.1300.10:FF:000046', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(49395, NULL, 'G3DSA:1.20.1250.20:FF:001798', NULL, NULL, 'Solute carrier family 22 member 12', NULL, NULL, NULL, NULL, NULL, 4),
(49396, NULL, 'G3DSA:3.30.1330.40:FF:000042', NULL, NULL, 'Chorismate mutase AroH', NULL, NULL, NULL, NULL, NULL, 4),
(49397, NULL, 'G3DSA:2.60.40.10:FF:001176', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(49398, NULL, 'G3DSA:3.30.160.60:FF:002007', NULL, NULL, 'Zinc finger protein 80', NULL, NULL, NULL, NULL, NULL, 4),
(49399, NULL, 'G3DSA:2.120.10.80:FF:000388', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49400, NULL, 'G3DSA:1.25.40.10:FF:003873', NULL, NULL, 'Os01g0164700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(49401, NULL, 'G3DSA:3.30.70.330:FF:001366', NULL, NULL, 'RNA-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(49402, NULL, 'G3DSA:3.90.190.10:FF:000559', NULL, NULL, 'Cell division cycle 14B', NULL, NULL, NULL, NULL, NULL, 4),
(49403, NULL, 'G3DSA:1.10.418.10:FF:000064', NULL, NULL, 'Parvin, gamma', NULL, NULL, NULL, NULL, NULL, 4),
(49404, NULL, 'G3DSA:3.90.1150.10:FF:000376', NULL, NULL, 'Methionine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(49405, NULL, 'G3DSA:3.60.21.10:FF:000360', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49406, NULL, 'G3DSA:3.40.50.720:FF:002292', NULL, NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase NAD-binding', NULL, NULL, NULL, NULL, NULL, 4),
(49407, NULL, 'G3DSA:3.40.50.360:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49408, NULL, 'G3DSA:3.30.160.60:FF:006392', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49409, NULL, 'G3DSA:3.40.1160.10:FF:000068', NULL, NULL, 'Glutamate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(49410, NULL, 'G3DSA:3.30.1360.20:FF:000004', NULL, NULL, 'Transcriptional coactivator/pterin dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(49411, NULL, 'G3DSA:2.60.120.10:FF:000751', NULL, NULL, 'Metal transporter CNNM4', NULL, NULL, NULL, NULL, NULL, 4),
(49412, NULL, 'G3DSA:3.30.200.100:FF:000001', NULL, NULL, 'Sigma-E factor regulatory protein RseB', NULL, NULL, NULL, NULL, NULL, 4),
(49413, NULL, 'G3DSA:3.30.160.60:FF:005099', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(49414, NULL, 'G3DSA:2.120.10.30:FF:000620', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49415, NULL, 'G3DSA:2.40.128.180:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49416, NULL, 'G3DSA:2.60.40.420:FF:000237', NULL, NULL, 'Iron transport multicopper oxidase fio1', NULL, NULL, NULL, NULL, NULL, 4),
(49417, NULL, 'G3DSA:3.30.70.20:FF:000134', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49418, NULL, 'G3DSA:3.30.160.60:FF:001176', NULL, NULL, 'C2H2 finger domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(49419, NULL, 'G3DSA:3.30.450.40:FF:000085', NULL, NULL, 'PAS/PAC sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(49420, NULL, 'G3DSA:3.30.870.10:FF:000074', NULL, NULL, 'Phospholipase D family protein', NULL, NULL, NULL, NULL, NULL, 4),
(49421, NULL, 'G3DSA:3.20.20.80:FF:000262', NULL, NULL, 'Glycogen debranching enzyme GlgX', NULL, NULL, NULL, NULL, NULL, 4),
(49422, NULL, 'G3DSA:2.60.200.20:FF:000226', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49423, NULL, 'G3DSA:2.70.40.10:FF:000023', NULL, NULL, '2''-deoxycytidine 5''-triphosphate deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(49424, NULL, 'G3DSA:2.60.40.150:FF:000813', NULL, NULL, 'Extended synaptotagmin-like protein 2b', NULL, NULL, NULL, NULL, NULL, 4),
(49425, NULL, 'G3DSA:3.30.465.10:FF:000138', NULL, NULL, 'Glycolate oxidase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(49426, NULL, 'G3DSA:3.30.470.20:FF:000092', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(49427, NULL, 'G3DSA:1.10.472.80:FF:000210', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49428, NULL, 'G3DSA:3.60.10.10:FF:000334', NULL, NULL, 'Phosphatidylinositol phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(49429, NULL, 'G3DSA:2.130.10.10:FF:003519', NULL, NULL, 'Small nucleolar ribonucleoprotein complex subunit, putative (AFU_orthologue AFUA_4G07540)', NULL, NULL, NULL, NULL, NULL, 4),
(49430, NULL, 'G3DSA:3.20.20.100:FF:000148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49431, NULL, 'G3DSA:3.30.1360.120:FF:000068', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49432, NULL, 'G3DSA:2.170.270.10:FF:000033', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(49433, NULL, 'G3DSA:2.60.40.1660:FF:000005', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(49434, NULL, 'G3DSA:3.30.40.10:FF:001141', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(49435, NULL, 'G3DSA:1.10.472.80:FF:000098', NULL, NULL, 'Tbc domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(49436, NULL, 'G3DSA:2.130.10.10:FF:005667', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49437, NULL, 'G3DSA:1.25.10.10:FF:002303', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49438, NULL, 'G3DSA:3.30.390.30:FF:000037', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(49439, NULL, 'G3DSA:3.30.50.10:FF:000130', NULL, NULL, 'Mineralocorticoid receptor', NULL, NULL, NULL, NULL, NULL, 4),
(49440, NULL, 'G3DSA:1.25.40.10:FF:004946', NULL, NULL, 'Os05g0305300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(49441, NULL, 'G3DSA:3.30.505.10:FF:000182', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49442, NULL, 'G3DSA:2.30.29.150:FF:000001', NULL, NULL, 'Fact complex subunit ssrp1', NULL, NULL, NULL, NULL, NULL, 4),
(49443, NULL, 'G3DSA:1.25.40.10:FF:001169', NULL, NULL, 'Os07g0588100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(49444, NULL, 'G3DSA:3.30.2380.10:FF:000002', NULL, NULL, 'EKC/KEOPS complex subunit CGI121', NULL, NULL, NULL, NULL, NULL, 4),
(49445, NULL, 'G3DSA:3.30.2360.10:FF:000001', NULL, NULL, 'Inositol-3-phosphate synthase isozyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(49446, NULL, 'G3DSA:2.130.10.10:FF:002008', NULL, NULL, 'Polyadenylation factor subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(49447, NULL, 'G3DSA:3.40.30.10:FF:000842', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(49448, NULL, 'G3DSA:3.30.70.250:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49449, NULL, 'G3DSA:1.20.1250.20:FF:001904', NULL, NULL, 'Os01g0556700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(49450, NULL, 'G3DSA:2.40.50.140:FF:001126', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49451, NULL, 'G3DSA:2.40.50.100:FF:000069', NULL, NULL, 'Putative maltose ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(49452, NULL, 'G3DSA:3.40.50.1820:FF:000102', NULL, NULL, 'Putative serine esterase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(49453, NULL, 'G3DSA:3.10.280.10:FF:000033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49454, NULL, 'G3DSA:3.30.565.10:FF:000303', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(49455, NULL, 'G3DSA:3.90.70.80:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49456, NULL, 'G3DSA:3.30.360.10:FF:000114', NULL, NULL, 'Myo-inositol 2-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(49457, NULL, 'G3DSA:2.130.10.10:FF:004138', NULL, NULL, 'ADL248Cp', NULL, NULL, NULL, NULL, NULL, 4),
(49458, NULL, 'G3DSA:2.160.20.10:FF:000006', NULL, NULL, 'F-box only protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(49459, NULL, 'G3DSA:3.80.10.10:FF:003020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49460, NULL, 'G3DSA:3.30.310.80:FF:000036', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(49461, NULL, 'G3DSA:3.40.50.300:FF:005049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49462, NULL, 'G3DSA:1.25.40.150:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49463, NULL, 'G3DSA:3.30.160.60:FF:004031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49464, NULL, 'G3DSA:3.30.342.10:FF:000050', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(49465, NULL, 'G3DSA:3.30.70.560:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49466, NULL, 'G3DSA:1.20.120.80:FF:000003', NULL, NULL, 'Cytochrome c oxidase subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(49467, NULL, 'G3DSA:2.10.25.10:FF:001463', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49468, NULL, 'G3DSA:3.40.250.10:FF:000165', NULL, NULL, 'Hydrolase glyoxylase', NULL, NULL, NULL, NULL, NULL, 4),
(49469, NULL, 'G3DSA:2.70.98.110:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49470, NULL, 'G3DSA:3.30.1010.10:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49471, NULL, 'G3DSA:1.20.1250.20:FF:001000', NULL, NULL, 'Multidrug efflux MFS transporter putative', NULL, NULL, NULL, NULL, NULL, 4),
(49472, NULL, 'G3DSA:1.10.565.10:FF:000135', NULL, NULL, 'RAR related orphan receptor C', NULL, NULL, NULL, NULL, NULL, 4),
(49473, NULL, 'G3DSA:3.30.160.60:FF:001968', NULL, NULL, 'chorion transcription factor Cf2 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(49474, NULL, 'G3DSA:2.60.40.2320:FF:000001', NULL, NULL, 'Type I pullulanase', NULL, NULL, NULL, NULL, NULL, 4),
(49475, NULL, 'G3DSA:1.20.1560.10:FF:000817', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49476, NULL, 'G3DSA:1.25.40.10:FF:004261', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(49477, NULL, 'G3DSA:2.60.40.10:FF:003885', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49478, NULL, 'G3DSA:3.20.20.105:FF:000019', NULL, NULL, 'Queuine tRNA-ribosyltransferase accessory subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(49479, NULL, 'G3DSA:2.130.10.10:FF:002340', NULL, NULL, 'Protein HIRA', NULL, NULL, NULL, NULL, NULL, 4),
(49480, NULL, 'G3DSA:2.130.10.130:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49481, NULL, 'G3DSA:3.60.110.10:FF:000027', NULL, NULL, 'AGAP012662-PA', NULL, NULL, NULL, NULL, NULL, 4),
(49482, NULL, 'G3DSA:1.20.58.60:FF:000111', NULL, NULL, 'dystonin isoform X1', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(49483, NULL, 'G3DSA:3.30.70.850:FF:000004', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 6', NULL, NULL, NULL, NULL, NULL, 4),
(49484, NULL, 'G3DSA:1.10.287.130:FF:000233', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(49485, NULL, 'G3DSA:1.10.1410.10:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49486, NULL, 'G3DSA:3.40.50.300:FF:002407', NULL, NULL, 'ABC transporter ATP-binding protein-amino acid transport', NULL, NULL, NULL, NULL, NULL, 4),
(49487, NULL, 'G3DSA:1.10.287.70:FF:000473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49488, NULL, 'G3DSA:1.20.120.1910:FF:000013', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(49489, NULL, 'G3DSA:3.90.215.10:FF:000016', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(49490, NULL, 'G3DSA:3.40.50.300:FF:000266', NULL, NULL, 'DNA replication protein DnaC', NULL, NULL, NULL, NULL, NULL, 4),
(49491, NULL, 'G3DSA:3.80.10.10:FF:003705', NULL, NULL, 'P-granule-associated novel protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(49492, NULL, 'G3DSA:2.30.30.40:FF:000421', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49493, NULL, 'G3DSA:3.60.21.60:FF:000003', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(49494, NULL, 'G3DSA:2.20.28.10:FF:000002', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(49495, NULL, 'G3DSA:3.10.20.30:FF:000011', NULL, NULL, '2Fe-2S ferredoxin YfaE', NULL, NULL, NULL, NULL, NULL, 4),
(49496, NULL, 'G3DSA:3.90.920.10:FF:000003', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(49497, NULL, 'G3DSA:1.20.120.1630:FF:000036', NULL, NULL, 'Phosphatidylethanolamine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(49498, NULL, 'G3DSA:3.90.190.10:FF:000109', NULL, NULL, 'Dual specificity phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(49499, NULL, 'G3DSA:3.30.1490.100:FF:000012', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(49500, NULL, 'G3DSA:1.25.40.20:FF:001498', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49501, NULL, 'G3DSA:1.10.3380.10:FF:000008', NULL, NULL, 'DExH-box ATP-dependent RNA helicase DExH17', NULL, NULL, NULL, NULL, NULL, 4),
(49502, NULL, 'G3DSA:1.25.10.10:FF:001780', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49503, NULL, 'G3DSA:3.30.160.60:FF:000664', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49504, NULL, 'G3DSA:2.60.40.820:FF:000020', NULL, NULL, 'T-box transcription factor 18', NULL, NULL, NULL, NULL, NULL, 4),
(49505, NULL, 'G3DSA:3.30.200.20:FF:002073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49506, NULL, 'G3DSA:3.40.50.150:FF:000187', NULL, NULL, 'Ribosomal RNA methyltransferase putative', NULL, NULL, NULL, NULL, NULL, 4),
(49507, NULL, 'G3DSA:2.30.42.10:FF:000310', NULL, NULL, 'Pro-apoptotic serine protease NMA111', NULL, NULL, NULL, NULL, NULL, 4),
(49508, NULL, 'G3DSA:1.10.472.10:FF:000335', NULL, NULL, 'Cyclin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(49509, NULL, 'G3DSA:3.60.20.10:FF:000161', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49510, NULL, 'G3DSA:3.40.50.1220:FF:000029', NULL, NULL, 'NAD-dependent protein deacetylase sirtuin-6 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(49511, NULL, 'G3DSA:3.30.450.190:FF:000021', NULL, NULL, 'Gtr1/RagA G protein conserved region-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(49512, NULL, 'G3DSA:2.130.10.10:FF:004470', NULL, NULL, 'Uncharacterized WD repeat-containing protein C227.12', NULL, NULL, NULL, NULL, NULL, 4),
(49513, NULL, 'G3DSA:3.30.70.100:FF:000009', NULL, NULL, 'ATPase copper transporting beta', NULL, NULL, NULL, NULL, NULL, 4),
(49514, NULL, 'G3DSA:3.40.50.10140:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49515, NULL, 'G3DSA:3.30.200.20:FF:002180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(49516, NULL, 'G3DSA:3.50.50.60:FF:001021', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(49517, NULL, 'G3DSA:1.10.630.10:FF:000490', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49518, NULL, 'G3DSA:3.90.1750.20:FF:000003', NULL, NULL, 'Serine recombinase', NULL, NULL, NULL, NULL, NULL, 4),
(49519, NULL, 'G3DSA:3.40.50.1000:FF:000300', NULL, NULL, 'Putative cytosolic 5''-nucleotidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(49520, NULL, 'G3DSA:3.40.33.10:FF:000180', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49521, NULL, 'G3DSA:3.40.50.300:FF:005156', NULL, NULL, 'Adenylyl-sulfate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(49522, NULL, 'G3DSA:3.30.70.330:FF:000859', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(49523, NULL, 'G3DSA:2.60.40.10:FF:000119', NULL, NULL, 'Sallimus, isoform P', NULL, NULL, NULL, NULL, NULL, 4),
(49524, NULL, 'G3DSA:3.80.20.20:FF:000090', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49525, NULL, 'G3DSA:3.30.160.60:FF:002805', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(49526, NULL, 'G3DSA:3.40.50.300:FF:001890', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(49527, NULL, 'G3DSA:1.25.40.10:FF:004042', NULL, NULL, 'CCR4-NOT transcription complex subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(49528, NULL, 'G3DSA:1.10.540.10:FF:000056', NULL, NULL, 'Acyl-CoA dehydrogenase FadE6', NULL, NULL, NULL, NULL, NULL, 4),
(49529, NULL, 'G3DSA:3.30.70.330:FF:003153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49530, NULL, 'G3DSA:1.10.3080.10:FF:000082', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(49531, NULL, 'G3DSA:1.20.58.390:FF:000315', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49532, NULL, 'G3DSA:3.30.2160.10:FF:000020', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(49533, NULL, 'G3DSA:1.25.40.10:FF:003642', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49534, NULL, 'G3DSA:3.40.850.10:FF:000481', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(49535, NULL, 'G3DSA:3.30.950.10:FF:000018', NULL, NULL, 'Uroporphyrin-III C-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(49536, NULL, 'G3DSA:3.40.50.1460:FF:000073', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49537, NULL, 'G3DSA:3.40.50.410:FF:000063', NULL, NULL, 'von Willebrand factor', NULL, NULL, NULL, NULL, NULL, 4),
(49538, NULL, 'G3DSA:1.10.10.10:FF:001847', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49539, NULL, 'G3DSA:1.20.120.430:FF:000006', NULL, NULL, 'tRNA modification GTPase MnmE', NULL, NULL, NULL, NULL, NULL, 4),
(49540, NULL, 'G3DSA:3.20.20.220:FF:000061', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(49541, NULL, 'G3DSA:3.40.50.150:FF:001709', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49542, NULL, 'G3DSA:3.30.160.60:FF:005335', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49543, NULL, 'G3DSA:3.30.230.130:FF:000038', NULL, NULL, 'AGAP005048-PA', NULL, NULL, NULL, NULL, NULL, 4),
(49544, NULL, 'G3DSA:3.80.10.10:FF:001564', NULL, NULL, 'Malignant fibrous histiocytoma-amplified sequence 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(49545, NULL, 'G3DSA:2.130.10.10:FF:001721', NULL, NULL, 'Spliceosomal protein sap, putative', NULL, NULL, NULL, NULL, NULL, 4),
(49546, NULL, 'G3DSA:3.40.50.1000:FF:000082', NULL, NULL, 'N-acylneuraminate cytidylyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(49547, NULL, 'G3DSA:1.20.1720.10:FF:000134', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49548, NULL, 'G3DSA:3.20.20.70:FF:000146', NULL, NULL, 'Indole-3-glycerol phosphate synthase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(49549, NULL, 'G3DSA:1.10.268.10:FF:000012', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(49550, NULL, 'G3DSA:3.40.720.10:FF:000033', NULL, NULL, 'Alkaline-phosphatase-like family protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(49551, NULL, 'G3DSA:3.30.1370.100:FF:000019', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(49552, NULL, 'G3DSA:3.30.200.20:FF:001229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49553, NULL, 'G3DSA:3.40.50.300:FF:001103', NULL, NULL, 'DNA repair protein RAD51 homolog 3', NULL, NULL, NULL, NULL, NULL, 4),
(49554, NULL, 'G3DSA:2.130.10.10:FF:005774', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49555, NULL, 'G3DSA:2.130.10.10:FF:005886', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49556, NULL, 'G3DSA:1.10.10.1410:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49557, NULL, 'G3DSA:3.40.50.1980:FF:000009', NULL, NULL, 'Iron-enterobactin transporter periplasmic binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(49558, NULL, 'G3DSA:3.40.50.720:FF:002185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49559, NULL, 'G3DSA:2.30.30.380:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49560, NULL, 'G3DSA:3.90.190.10:FF:000216', NULL, NULL, 'Protein-tyrosine phosphatase delta-b', NULL, NULL, NULL, NULL, NULL, 4),
(49561, NULL, 'G3DSA:2.170.270.10:FF:000140', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(49562, NULL, 'G3DSA:3.40.47.10:FF:000026', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(49563, NULL, 'G3DSA:3.90.190.10:FF:000328', NULL, NULL, 'Tyrosine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(49564, NULL, 'G3DSA:2.60.40.10:FF:001631', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(49565, NULL, 'G3DSA:1.10.10.10:FF:001723', NULL, NULL, 'Putative iron-dependent transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(49566, NULL, 'G3DSA:2.30.29.30:FF:000454', NULL, NULL, 'Ran-specific GTPase-activating protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(49567, NULL, 'G3DSA:3.80.10.10:FF:001800', NULL, NULL, 'Putative leucine-rich repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(49568, NULL, 'G3DSA:1.20.1070.10:FF:000859', NULL, NULL, 'G-protein coupled receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(49569, NULL, 'G3DSA:3.40.30.10:FF:000611', NULL, NULL, 'Putative elongation factor 1-gamma', NULL, NULL, NULL, NULL, NULL, 4),
(49570, NULL, 'G3DSA:3.40.50.300:FF:004537', NULL, NULL, 'ATP-dependent (ABC) transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(49571, NULL, 'G3DSA:2.40.50.140:FF:000744', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49572, NULL, 'G3DSA:2.60.120.10:FF:000172', NULL, NULL, 'Transcriptional regulator, Crp/Fnr family', NULL, NULL, NULL, NULL, NULL, 4),
(49573, NULL, 'G3DSA:3.40.1110.10:FF:000115', NULL, NULL, 'Plasma membrane ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(49574, NULL, 'G3DSA:3.80.10.10:FF:004217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49575, NULL, 'G3DSA:3.30.420.40:FF:000948', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49576, NULL, 'G3DSA:3.30.420.10:FF:000046', NULL, NULL, 'Three prime repair exonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(49577, NULL, 'G3DSA:1.50.40.10:FF:000251', NULL, NULL, 'Solute carrier family 25 member 51', NULL, NULL, NULL, NULL, NULL, 4),
(49578, NULL, 'G3DSA:3.40.50.360:FF:000025', NULL, NULL, 'methionine synthase reductase', NULL, NULL, NULL, NULL, NULL, 4),
(49579, NULL, 'G3DSA:1.20.5.170:FF:000143', NULL, NULL, 'Structural maintenance of chromosomes', NULL, NULL, NULL, NULL, NULL, 4),
(49580, NULL, 'G3DSA:3.20.80.10:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49581, NULL, 'G3DSA:3.40.50.2300:FF:001432', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49582, NULL, 'G3DSA:3.30.365.10:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49583, NULL, 'G3DSA:3.30.70.330:FF:000298', NULL, NULL, 'U1 small nuclear ribonucleoprotein 70 kDa', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(49584, NULL, 'G3DSA:3.80.10.10:FF:002183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49585, NULL, 'G3DSA:3.60.21.10:FF:000253', NULL, NULL, 'Ser/Thr protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(49586, NULL, 'G3DSA:1.20.1170.10:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49587, NULL, 'G3DSA:1.10.630.10:FF:000158', NULL, NULL, 'Cytochrome P450, putative (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(49588, NULL, 'G3DSA:2.60.200.20:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49589, NULL, 'G3DSA:3.40.50.300:FF:002519', NULL, NULL, 'Hydrolase, P-loop-like family protein', NULL, NULL, NULL, NULL, NULL, 4),
(49590, NULL, 'G3DSA:3.30.70.330:FF:000404', NULL, NULL, 'RNA-binding protein with multiple splicing', NULL, NULL, NULL, NULL, NULL, 4),
(49591, NULL, 'G3DSA:1.10.150.120:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49592, NULL, 'G3DSA:1.10.390.40:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49593, NULL, 'G3DSA:3.40.50.720:FF:000959', NULL, NULL, 'Unplaced genomic scaffold supercont1.208, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(49594, NULL, 'G3DSA:3.60.40.10:FF:000049', NULL, NULL, 'Protein phosphatase 2C 57', NULL, NULL, NULL, NULL, NULL, 4),
(49595, NULL, 'G3DSA:3.40.980.10:FF:000029', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(49596, NULL, 'G3DSA:1.20.82.10:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49597, NULL, 'G3DSA:3.20.20.60:FF:000048', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(49598, NULL, 'G3DSA:1.20.1110.10:FF:000104', NULL, NULL, 'E1-E2 ATPase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(49599, NULL, 'G3DSA:1.50.40.10:FF:000375', NULL, NULL, 'Mitochondrial carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(49600, NULL, 'G3DSA:3.40.50.1010:FF:000180', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49601, NULL, 'G3DSA:1.25.40.10:FF:001276', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(49602, NULL, 'G3DSA:3.40.50.2000:FF:000499', NULL, NULL, 'DNA beta-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(49603, NULL, 'G3DSA:3.30.1680.10:FF:000036', NULL, NULL, 'AGAP005742-PA', NULL, NULL, NULL, NULL, NULL, 4),
(49604, NULL, 'G3DSA:1.10.8.60:FF:000326', NULL, NULL, 'Transitional endoplasmic reticulum ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(49605, NULL, 'G3DSA:3.90.1200.10:FF:000026', NULL, NULL, 'Putative aminoglycoside phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(49606, NULL, 'G3DSA:3.90.70.10:FF:000421', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49607, NULL, 'G3DSA:3.40.50.150:FF:000075', NULL, NULL, 'NOP2/Sun RNA methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(49608, NULL, 'G3DSA:3.40.50.300:FF:000485', NULL, NULL, 'Dephospho-CoA kinase CAB5', NULL, NULL, NULL, NULL, NULL, 4),
(49609, NULL, 'G3DSA:1.20.1250.20:FF:000488', NULL, NULL, 'MonoCarboxylate Transporter family', NULL, NULL, NULL, NULL, NULL, 4),
(49610, NULL, 'G3DSA:3.10.100.10:FF:000217', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49611, NULL, 'G3DSA:1.25.10.10:FF:002292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49612, NULL, 'G3DSA:3.65.10.10:FF:000037', NULL, NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(49613, NULL, 'G3DSA:3.20.20.190:FF:000118', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49614, NULL, 'G3DSA:3.40.430.10:FF:000056', NULL, NULL, 'Dihydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(49615, NULL, 'G3DSA:1.20.5.440:FF:000010', NULL, NULL, 'pH-gated potassium channel KcsA', NULL, NULL, NULL, NULL, NULL, 4),
(49616, NULL, 'G3DSA:2.60.120.10:FF:000296', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(49617, NULL, 'G3DSA:3.40.50.300:FF:007522', NULL, NULL, 'AGR108Cp', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(49618, NULL, 'G3DSA:1.10.10.10:FF:000431', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC6', NULL, NULL, NULL, NULL, NULL, 4),
(49619, NULL, 'G3DSA:3.30.200.20:FF:001561', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49620, NULL, 'G3DSA:2.10.25.10:FF:000406', NULL, NULL, 'CD248 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(49621, NULL, 'G3DSA:3.10.350.10:FF:000039', NULL, NULL, 'Putative membrane bound murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(49622, NULL, 'G3DSA:3.40.50.620:FF:000699', NULL, NULL, 'Asparagine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(49623, NULL, 'G3DSA:2.130.10.10:FF:003413', NULL, NULL, 'WD repeat and HMG-box DNA binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(49624, NULL, 'G3DSA:3.30.40.10:FF:000989', NULL, NULL, 'E3 ubiquitin-protein ligase AIP2', NULL, NULL, NULL, NULL, NULL, 4),
(49625, NULL, 'G3DSA:3.40.50.2000:FF:000842', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49626, NULL, 'G3DSA:3.30.420.10:FF:000265', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(49627, NULL, 'G3DSA:2.60.120.200:FF:000276', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(49628, NULL, 'G3DSA:3.30.160.60:FF:004155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49629, NULL, 'G3DSA:3.30.460.10:FF:000043', NULL, NULL, 'Putative nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(49630, NULL, 'G3DSA:1.20.120.450:FF:000001', NULL, NULL, 'Damage-inducible protein DinB', NULL, NULL, NULL, NULL, NULL, 4),
(49631, NULL, 'G3DSA:3.30.420.10:FF:000607', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49632, NULL, 'G3DSA:3.40.640.10:FF:000212', NULL, NULL, 'Gamma-aminobutyrate transaminase POP2 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(49633, NULL, 'G3DSA:1.10.510.10:FF:001740', NULL, NULL, 'AEL173Wp', NULL, NULL, NULL, NULL, NULL, 4),
(49634, NULL, 'G3DSA:2.30.30.40:FF:000640', NULL, NULL, 'Mindbomb E3 ubiquitin protein ligase 2', NULL, NULL, NULL, NULL, NULL, 4),
(49635, NULL, 'G3DSA:2.130.10.30:FF:000081', NULL, NULL, 'Regulator of chromosome condensation (RCC1) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(49636, NULL, 'G3DSA:3.40.50.300:FF:003812', NULL, NULL, 'MCM / cell division control protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(49637, NULL, 'G3DSA:1.10.3120.10:FF:000012', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(49638, NULL, 'G3DSA:3.70.10.10:FF:000013', NULL, NULL, 'Beta sliding clamp', NULL, NULL, NULL, NULL, NULL, 4),
(49639, NULL, 'G3DSA:2.60.40.10:FF:004722', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49640, NULL, 'G3DSA:1.20.140.100:FF:000024', NULL, NULL, 'Cytoplasmic dynein 1b heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(49641, NULL, 'G3DSA:1.10.1520.10:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49642, NULL, 'G3DSA:1.50.40.10:FF:000594', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49643, NULL, 'G3DSA:2.60.40.10:FF:003429', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49644, NULL, 'G3DSA:1.20.120.350:FF:000084', NULL, NULL, 'Cation channel sperm associated 2', NULL, NULL, NULL, NULL, NULL, 4),
(49645, NULL, 'G3DSA:1.20.58.60:FF:000797', NULL, NULL, 'Muscle-specific protein 300 kDa, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(49646, NULL, 'G3DSA:3.40.50.11340:FF:000012', NULL, NULL, 'Fucosyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(49647, NULL, 'G3DSA:1.10.510.10:FF:000447', NULL, NULL, 'Polo-like kinase 4 (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(49648, NULL, 'G3DSA:3.40.50.720:FF:000616', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase 2 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(49649, NULL, 'G3DSA:1.10.510.10:FF:000104', NULL, NULL, 'serine/threonine-protein kinase MAK isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(49650, NULL, 'G3DSA:3.40.30.10:FF:000954', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49651, NULL, 'G3DSA:3.60.10.10:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(49652, NULL, 'G3DSA:1.25.10.10:FF:001903', NULL, NULL, 'Armadillo repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(49653, NULL, 'G3DSA:1.10.287.1490:FF:000147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49654, NULL, 'G3DSA:1.25.40.20:FF:000099', NULL, NULL, 'ankyrin repeat and sterile alpha motif domain-containing protein 1B isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(49655, NULL, 'G3DSA:3.30.420.110:FF:000014', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(49656, NULL, 'G3DSA:1.10.220.20:FF:000006', NULL, NULL, 'F-box only protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(49657, NULL, 'G3DSA:3.30.40.10:FF:001265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49658, NULL, 'G3DSA:3.40.30.10:FF:001230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49659, NULL, 'G3DSA:2.60.120.260:FF:000378', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49660, NULL, 'G3DSA:3.30.70.940:FF:000025', NULL, NULL, 'Transcription termination/antitermination protein NusG', NULL, NULL, NULL, NULL, NULL, 4),
(49661, NULL, 'G3DSA:3.90.870.10:FF:000010', NULL, NULL, 'Si:ch211-153b23.4', NULL, NULL, NULL, NULL, NULL, 4),
(49662, NULL, 'G3DSA:1.50.10.160:FF:000013', NULL, NULL, 'Putative geranyllinalool synthase', NULL, NULL, NULL, NULL, NULL, 4),
(49663, NULL, 'G3DSA:3.30.540.10:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49664, NULL, 'G3DSA:3.40.1810.10:FF:000028', NULL, NULL, 'Agamous-like MADS-box protein AGL66 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(49665, NULL, 'G3DSA:1.20.5.170:FF:000249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49666, NULL, 'G3DSA:1.10.8.60:FF:000220', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(49667, NULL, 'G3DSA:2.10.25.10:FF:001025', NULL, NULL, 'Protein CBG11506', NULL, NULL, NULL, NULL, NULL, 4),
(49668, NULL, 'G3DSA:2.30.29.30:FF:000111', NULL, NULL, 'anillin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(49669, NULL, 'G3DSA:2.60.40.10:FF:003761', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49670, NULL, 'G3DSA:1.20.1070.10:FF:001230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49671, NULL, 'G3DSA:4.10.60.10:FF:000180', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49672, NULL, 'G3DSA:2.60.40.10:FF:001288', NULL, NULL, 'Embigin', NULL, NULL, NULL, NULL, NULL, 4),
(49673, NULL, 'G3DSA:3.40.710.10:FF:000083', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(49674, NULL, 'G3DSA:1.10.287.70:FF:000597', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49675, NULL, 'G3DSA:3.40.50.300:FF:000721', NULL, NULL, 'DNA replication ATP-dependent helicase/nuclease DNA2', NULL, NULL, NULL, NULL, NULL, 4),
(49676, NULL, 'G3DSA:3.40.50.10090:FF:000047', NULL, NULL, 'Uroporphyrinogen decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(49677, NULL, 'G3DSA:1.10.20.10:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49678, NULL, 'G3DSA:3.40.190.10:FF:000918', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49679, NULL, 'G3DSA:3.30.1370.110:FF:000011', NULL, NULL, 'Endonuclease MutS2', NULL, NULL, NULL, NULL, NULL, 4),
(49680, NULL, 'G3DSA:1.50.10.20:FF:000084', NULL, NULL, 'Terpene cyclase/mutase family member', NULL, NULL, NULL, NULL, NULL, 4),
(49681, NULL, 'G3DSA:3.40.50.300:FF:004431', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49682, NULL, 'G3DSA:1.25.40.10:FF:000551', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(49683, NULL, 'G3DSA:2.130.10.10:FF:000760', NULL, NULL, 'Splicing factor 3B subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(49684, NULL, 'G3DSA:3.40.50.2300:FF:000718', NULL, NULL, 'Natriuretic peptide receptor 3', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(49685, NULL, 'G3DSA:1.10.510.10:FF:002701', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49686, NULL, 'G3DSA:3.40.50.300:FF:008247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49687, NULL, 'G3DSA:3.30.70.330:FF:002771', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49688, NULL, 'G3DSA:3.30.160.60:FF:003194', NULL, NULL, 'Zinc finger protein 429', NULL, NULL, NULL, NULL, NULL, 4),
(49689, NULL, 'G3DSA:2.60.40.10:FF:002581', NULL, NULL, 'Muscle M-line assembly protein unc-89-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(49690, NULL, 'G3DSA:3.40.1080.10:FF:000011', NULL, NULL, 'CoA-transferase (Alpha subunit)', NULL, NULL, NULL, NULL, NULL, 4),
(49691, NULL, 'G3DSA:2.60.40.2300:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49692, NULL, 'G3DSA:2.60.40.10:FF:000451', NULL, NULL, 'aggrecan core protein', NULL, NULL, NULL, NULL, NULL, 4),
(49693, NULL, 'G3DSA:3.40.630.30:FF:000268', NULL, NULL, 'GNAT family acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(49694, NULL, 'G3DSA:3.90.550.10:FF:000643', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49695, NULL, 'G3DSA:1.10.287.110:FF:000351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49696, NULL, 'G3DSA:3.40.50.1910:FF:000028', NULL, NULL, 'Vacuolar protein-sorting-associated protein 33 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(49697, NULL, 'G3DSA:1.10.510.10:FF:003870', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49698, NULL, 'G3DSA:3.30.559.10:FF:000137', NULL, NULL, 'Protein ECERIFERUM 2', NULL, NULL, NULL, NULL, NULL, 4),
(49699, NULL, 'G3DSA:1.10.1070.11:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49700, NULL, 'G3DSA:3.40.50.300:FF:000142', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(49701, NULL, 'G3DSA:1.20.120.1760:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49702, NULL, 'G3DSA:3.20.20.80:FF:000368', NULL, NULL, 'Os01g0942300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(49703, NULL, 'G3DSA:1.20.1070.10:FF:002192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49704, NULL, 'G3DSA:2.10.25.10:FF:000749', NULL, NULL, 'SP2353, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(49705, NULL, 'G3DSA:3.40.50.1240:FF:000024', NULL, NULL, 'Periplasmic glucose-1-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(49706, NULL, 'G3DSA:3.30.60.20:FF:000072', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(49707, NULL, 'G3DSA:2.120.10.80:FF:000152', NULL, NULL, 'Gpb1p', NULL, NULL, NULL, NULL, NULL, 4),
(49708, NULL, 'G3DSA:3.40.50.200:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49709, NULL, 'G3DSA:1.20.1270.60:FF:000035', NULL, NULL, 'Sorting nexin 4', NULL, NULL, NULL, NULL, NULL, 4),
(49710, NULL, 'G3DSA:2.60.40.790:FF:000084', NULL, NULL, 'Calcyclin binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(49711, NULL, 'G3DSA:3.30.70.20:FF:000022', NULL, NULL, 'Pyruvate:ferredoxin (Flavodoxin) oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(49712, NULL, 'G3DSA:3.90.226.10:FF:000154', NULL, NULL, 'Glutaconyl-CoA decarboxylase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(49713, NULL, 'G3DSA:3.40.50.1820:FF:000788', NULL, NULL, 'Linear gramicidin dehydrogenase LgrE', NULL, NULL, NULL, NULL, NULL, 4),
(49714, NULL, 'G3DSA:2.60.40.60:FF:000437', NULL, NULL, 'Dachsous, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(49715, NULL, 'G3DSA:2.60.40.10:FF:003542', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49716, NULL, 'G3DSA:1.10.287.110:FF:000019', NULL, NULL, 'dnaJ homolog subfamily C member 27', NULL, NULL, NULL, NULL, NULL, 4),
(49717, NULL, 'G3DSA:3.90.1530.30:FF:000006', NULL, NULL, 'ParB-like partition protein', NULL, NULL, NULL, NULL, NULL, 4),
(49718, NULL, 'G3DSA:1.25.40.10:FF:000894', NULL, NULL, 'Tetratricopeptide repeat domain 21B', NULL, NULL, NULL, NULL, NULL, 4),
(49719, NULL, 'G3DSA:3.30.1300.10:FF:000003', NULL, NULL, 'PAN6 Pantoate-beta-alanine ligase, putative', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(49720, NULL, 'G3DSA:3.30.70.260:FF:000142', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(49721, NULL, 'G3DSA:1.20.58.2190:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49722, NULL, 'G3DSA:3.40.50.1820:FF:001064', NULL, NULL, 'Glutathione S-transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(49723, NULL, 'G3DSA:3.10.129.10:FF:000194', NULL, NULL, 'Acyl-CoA hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(49724, NULL, 'G3DSA:1.25.40.10:FF:001512', NULL, NULL, 'Os06g0143500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(49725, NULL, 'G3DSA:3.40.1360.10:FF:000049', NULL, NULL, 'Type IIB DNA topoisomerase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(49726, NULL, 'G3DSA:3.30.230.70:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49727, NULL, 'G3DSA:3.10.20.90:FF:000237', NULL, NULL, 'BAG family molecular chaperone regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(49728, NULL, 'G3DSA:3.40.50.1110:FF:000108', NULL, NULL, 'GDSL esterase/lipase At3g05180', NULL, NULL, NULL, NULL, NULL, 4),
(49729, NULL, 'G3DSA:1.10.287.950:FF:000035', NULL, NULL, 'Methyl-accepting chemotaxis sensory transducer, class 40+24H', NULL, NULL, NULL, NULL, NULL, 4),
(49730, NULL, 'G3DSA:1.20.1250.20:FF:001343', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(49731, NULL, 'G3DSA:3.40.50.300:FF:007286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49732, NULL, 'G3DSA:1.25.10.10:FF:000723', NULL, NULL, 'Receptor mediated endocytosis 8, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(49733, NULL, 'G3DSA:3.40.630.10:FF:000262', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(49734, NULL, 'G3DSA:3.40.50.1370:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49735, NULL, 'G3DSA:1.10.1450.10:FF:000104', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(49736, NULL, 'G3DSA:1.25.40.10:FF:001170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49737, NULL, 'G3DSA:2.60.40.1120:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49738, NULL, 'G3DSA:3.40.50.1820:FF:001406', NULL, NULL, 'GPI inositol-deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(49739, NULL, 'G3DSA:3.30.200.20:FF:000162', NULL, NULL, 'Adenine nucleotide alpha hydrolase-like domain kinase', NULL, NULL, NULL, NULL, NULL, 4),
(49740, NULL, 'G3DSA:3.40.50.880:FF:000170', NULL, NULL, 'Putative glutathione-independent glyoxalase hsp3105', NULL, NULL, NULL, NULL, NULL, 4),
(49741, NULL, 'G3DSA:3.60.20.40:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49742, NULL, 'G3DSA:3.40.50.300:FF:007628', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49743, NULL, 'G3DSA:3.30.200.20:FF:000504', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(49744, NULL, 'G3DSA:3.40.1000.50:FF:000001', NULL, NULL, 'Repressor of RNA polymerase III transcription MAF1', NULL, NULL, NULL, NULL, NULL, 4),
(49745, NULL, 'G3DSA:1.20.1560.10:FF:000711', NULL, NULL, 'ABC transporter ATP-binding protein RamA', NULL, NULL, NULL, NULL, NULL, 4),
(49746, NULL, 'G3DSA:2.60.120.650:FF:000169', NULL, NULL, 'Lysine-specific demethylase REF6', NULL, NULL, NULL, NULL, NULL, 4),
(49747, NULL, 'G3DSA:1.25.40.10:FF:000219', NULL, NULL, 'Tetratricopeptide repeat domain 21B', NULL, NULL, NULL, NULL, NULL, 4),
(49748, NULL, 'G3DSA:3.40.50.11380:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49749, NULL, 'G3DSA:3.30.200.20:FF:000847', NULL, NULL, 'Protein kinase family protein with leucine-rich repeat domain', NULL, NULL, NULL, NULL, NULL, 4),
(49750, NULL, 'G3DSA:3.40.190.10:FF:000233', NULL, NULL, 'Membrane-bound lytic murein transglycosylase F', NULL, NULL, NULL, NULL, NULL, 4),
(49751, NULL, 'G3DSA:3.40.30.10:FF:000499', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(49752, NULL, 'G3DSA:1.25.40.20:FF:001392', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49753, NULL, 'G3DSA:1.25.40.20:FF:000773', NULL, NULL, 'Ankyrin repeat domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(49754, NULL, 'G3DSA:1.20.144.10:FF:000026', NULL, NULL, 'Lipid phosphate phosphatase epsilon 2 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(49755, NULL, 'G3DSA:3.40.50.300:FF:002396', NULL, NULL, 'Cell division inhibitor SulA', NULL, NULL, NULL, NULL, NULL, 4),
(49756, NULL, 'G3DSA:1.10.510.10:FF:003538', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49757, NULL, 'G3DSA:3.90.180.10:FF:000047', NULL, NULL, '(R)-specific carbonyl reductase', NULL, NULL, NULL, NULL, NULL, 4),
(49758, NULL, 'G3DSA:3.90.1660.10:FF:000004', NULL, NULL, 'Coenzyme F420:L-glutamate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(49759, NULL, 'G3DSA:2.60.40.10:FF:004503', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49760, NULL, 'G3DSA:1.25.40.10:FF:001855', NULL, NULL, 'AGAP002782-PA', NULL, NULL, NULL, NULL, NULL, 4),
(49761, NULL, 'G3DSA:1.20.1250.20:FF:000382', NULL, NULL, 'Nitrate transporter CrnA', NULL, NULL, NULL, NULL, NULL, 4),
(49762, NULL, 'G3DSA:2.40.70.10:FF:000335', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49763, NULL, 'G3DSA:3.30.40.10:FF:001826', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49764, NULL, 'G3DSA:2.60.40.60:FF:000218', NULL, NULL, 'Protocadherin-20', NULL, NULL, NULL, NULL, NULL, 4),
(49765, NULL, 'G3DSA:1.25.10.10:FF:000162', NULL, NULL, 'GCN1, eIF2 alpha kinase activator homolog', NULL, NULL, NULL, NULL, NULL, 4),
(49766, NULL, 'G3DSA:3.40.366.10:FF:000001', NULL, NULL, 'Malonyl CoA-acyl carrier protein transacylase', NULL, NULL, NULL, NULL, NULL, 4),
(49767, NULL, 'G3DSA:1.10.510.10:FF:004157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49768, NULL, 'G3DSA:3.40.50.300:FF:007067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49769, NULL, 'G3DSA:3.30.40.10:FF:002102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49770, NULL, 'G3DSA:3.30.40.10:FF:001484', NULL, NULL, 'Protein CBG04193', NULL, NULL, NULL, NULL, NULL, 4),
(49771, NULL, 'G3DSA:1.10.238.10:FF:000527', NULL, NULL, 'Calmodulin-3', NULL, NULL, NULL, NULL, NULL, 4),
(49772, NULL, 'G3DSA:3.40.50.1820:FF:001625', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(49773, NULL, 'G3DSA:3.40.50.620:FF:000356', NULL, NULL, 'Os02g0722001 protein', NULL, NULL, NULL, NULL, NULL, 4),
(49774, NULL, 'G3DSA:2.60.40.1390:FF:000014', NULL, NULL, 'Rep1p', NULL, NULL, NULL, NULL, NULL, 4),
(49775, NULL, 'G3DSA:3.30.2290.10:FF:000006', NULL, NULL, 'Modulator of DNA gyrase', NULL, NULL, NULL, NULL, NULL, 4),
(49776, NULL, 'G3DSA:1.10.260.40:FF:000009', NULL, NULL, 'Hepatocyte nuclear factor 1-beta', NULL, NULL, NULL, NULL, NULL, 4),
(49777, NULL, 'G3DSA:3.90.470.20:FF:000027', NULL, NULL, 'Enterobactin synthase component D', NULL, NULL, NULL, NULL, NULL, 4),
(49778, NULL, 'G3DSA:3.40.190.10:FF:000014', NULL, NULL, 'Arginine ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(49779, NULL, 'G3DSA:3.30.200.20:FF:001123', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49780, NULL, 'G3DSA:3.30.160.60:FF:004716', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49781, NULL, 'G3DSA:1.25.40.10:FF:002131', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At5g09950', NULL, NULL, NULL, NULL, NULL, 4),
(49782, NULL, 'G3DSA:1.10.472.170:FF:000015', NULL, NULL, 'Transcription initiation factor IIB', NULL, NULL, NULL, NULL, NULL, 4),
(49783, NULL, 'G3DSA:1.25.40.10:FF:001731', NULL, NULL, 'AGAP000136-PA', NULL, NULL, NULL, NULL, NULL, 4),
(49784, NULL, 'G3DSA:3.90.70.10:FF:000527', NULL, NULL, 'Putative ubiquitin hydrolase putative cysteine peptidase Clan CA family C19', NULL, NULL, NULL, NULL, NULL, 4),
(49785, NULL, 'G3DSA:3.30.565.10:FF:000522', NULL, NULL, 'Two component signal transduction system histidine kinase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(49786, NULL, 'G3DSA:2.10.50.10:FF:000026', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 4', NULL, NULL, NULL, NULL, NULL, 4),
(49787, NULL, 'G3DSA:3.40.50.2020:FF:000163', NULL, NULL, 'Ribose phosphate pyrophosphokinase NadR', NULL, NULL, NULL, NULL, NULL, 4),
(49788, NULL, 'G3DSA:1.10.3720.10:FF:000092', NULL, NULL, 'Iron ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(49789, NULL, 'G3DSA:1.20.1270.60:FF:000254', NULL, NULL, 'Inositol-pentakisphosphate 2-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(49790, NULL, 'G3DSA:2.40.50.140:FF:000289', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(49791, NULL, 'G3DSA:3.80.10.10:FF:001221', NULL, NULL, 'Leucine_rich_repeat/Leucine_Rich_Repeat_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(49792, NULL, 'G3DSA:1.10.510.10:FF:000228', NULL, NULL, 'cyclin-G-associated kinase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(49793, NULL, 'G3DSA:3.90.660.10:FF:000073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49794, NULL, 'G3DSA:3.40.50.2300:FF:000033', NULL, NULL, 'Amino acid ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(49795, NULL, 'G3DSA:3.30.160.60:FF:000321', NULL, NULL, 'myeloid zinc finger 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(49796, NULL, 'G3DSA:3.30.70.3170:FF:000004', NULL, NULL, 'Galactokinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(49797, NULL, 'G3DSA:3.30.2320.10:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49798, NULL, 'G3DSA:1.20.1310.10:FF:000092', NULL, NULL, 'Cullin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(49799, NULL, 'G3DSA:3.90.550.10:FF:000300', NULL, NULL, 'UDP-sugar pyrophosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(49800, NULL, 'G3DSA:3.40.50.10190:FF:000307', NULL, NULL, 'DNA repair and telomere maintenance protein nbs1', NULL, NULL, NULL, NULL, NULL, 4),
(49801, NULL, 'G3DSA:3.30.420.510:FF:000027', NULL, NULL, 'Type II pantothenate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(49802, NULL, 'G3DSA:3.20.20.10:FF:000044', NULL, NULL, 'Alanine racemase', NULL, NULL, NULL, NULL, NULL, 4),
(49803, NULL, 'G3DSA:2.60.40.10:FF:002249', NULL, NULL, 'Uncharacterized protein, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(49804, NULL, 'G3DSA:1.20.1250.20:FF:000943', NULL, NULL, 'Amino acid/peptide transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(49805, NULL, 'G3DSA:2.60.120.1040:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49806, NULL, 'G3DSA:1.20.1070.10:FF:001573', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49807, NULL, 'G3DSA:3.40.109.10:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49808, NULL, 'G3DSA:3.50.50.60:FF:000402', NULL, NULL, 'Flavoprotein monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(49809, NULL, 'G3DSA:1.20.5.110:FF:000041', NULL, NULL, 'Synaptosomal-associated protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(49810, NULL, 'G3DSA:1.10.287.70:FF:000254', NULL, NULL, 'CRE-TWK-16 protein', NULL, NULL, NULL, NULL, NULL, 4),
(49811, NULL, 'G3DSA:2.130.10.10:FF:003851', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49812, NULL, 'G3DSA:2.30.30.40:FF:000185', NULL, NULL, 'brain-specific angiogenesis inhibitor 1-associated protein 2-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(49813, NULL, 'G3DSA:2.30.29.170:FF:000007', NULL, NULL, 'EF-Hand domain-Containing protein 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(49814, NULL, 'G3DSA:1.20.120.850:FF:000008', NULL, NULL, 'DsDNA-dependent ATPase (Rad54b), putative', NULL, NULL, NULL, NULL, NULL, 4),
(49815, NULL, 'G3DSA:1.25.10.10:FF:002005', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(49816, NULL, 'G3DSA:1.10.10.60:FF:000142', NULL, NULL, 'homeobox protein OTX2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(49817, NULL, 'G3DSA:3.40.50.300:FF:007921', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(49818, NULL, 'G3DSA:1.25.40.470:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49819, NULL, 'G3DSA:3.20.20.220:FF:000021', NULL, NULL, 'Aldehyde dehydrogenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(49820, NULL, 'G3DSA:3.80.10.10:FF:003312', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49821, NULL, 'G3DSA:3.30.160.60:FF:002715', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49822, NULL, 'G3DSA:1.25.40.10:FF:003614', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g12300, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(49823, NULL, 'G3DSA:3.40.50.1820:FF:000872', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49824, NULL, 'G3DSA:2.10.220.10:FF:000005', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(49825, NULL, 'G3DSA:2.60.40.10:FF:003694', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49826, NULL, 'G3DSA:3.90.226.10:FF:000070', NULL, NULL, 'Enoyl-CoA hydratase/isomerase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(49827, NULL, 'G3DSA:3.30.590.50:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49828, NULL, 'G3DSA:1.10.238.10:FF:000544', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(49829, NULL, 'G3DSA:3.40.390.30:FF:000007', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49830, NULL, 'G3DSA:1.20.5.500:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49831, NULL, 'G3DSA:3.40.50.300:FF:001968', NULL, NULL, 'ATP-dependent DNA helicase CHL1', NULL, NULL, NULL, NULL, NULL, 4),
(49832, NULL, 'G3DSA:3.40.50.620:FF:000339', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(49833, NULL, 'G3DSA:1.20.1070.10:FF:000887', NULL, NULL, 'Olfactory receptor 1487', NULL, NULL, NULL, NULL, NULL, 4),
(49834, NULL, 'G3DSA:3.30.70.330:FF:003075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49835, NULL, 'G3DSA:3.30.160.60:FF:003817', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49836, NULL, 'G3DSA:3.30.530.20:FF:000001', NULL, NULL, 'Phosphatidylinositol transfer protein membrane associated 2', NULL, NULL, NULL, NULL, NULL, 4),
(49837, NULL, 'G3DSA:1.10.510.10:FF:003696', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49838, NULL, 'G3DSA:1.10.510.10:FF:000470', NULL, NULL, 'Ephrin type-B receptor 6', NULL, NULL, NULL, NULL, NULL, 4),
(49839, NULL, 'G3DSA:1.10.510.10:FF:002122', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49840, NULL, 'G3DSA:1.10.8.60:FF:000568', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49841, NULL, 'G3DSA:1.10.3470.10:FF:000004', NULL, NULL, 'Iron compound ABC transporter, permease', NULL, NULL, NULL, NULL, NULL, 4),
(49842, NULL, 'G3DSA:1.20.120.350:FF:000246', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49843, NULL, 'G3DSA:2.30.30.140:FF:000287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49844, NULL, 'G3DSA:3.10.105.10:FF:000127', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49845, NULL, 'G3DSA:3.40.50.1000:FF:000160', NULL, NULL, 'HAD hydrolase, family IA', NULL, NULL, NULL, NULL, NULL, 4),
(49846, NULL, 'G3DSA:3.40.50.150:FF:001581', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49847, NULL, 'G3DSA:1.10.10.60:FF:001244', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49848, NULL, 'G3DSA:3.40.50.10190:FF:000145', NULL, NULL, 'Microcephalin, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(49849, NULL, 'G3DSA:1.10.10.10:FF:000234', NULL, NULL, 'Vacuolar-sorting protein SNF8', NULL, NULL, NULL, NULL, NULL, 4),
(49850, NULL, 'G3DSA:4.10.280.10:FF:000108', NULL, NULL, 'Basic helix-loop-helix transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(49851, NULL, 'G3DSA:3.40.50.300:FF:000507', NULL, NULL, 'Pre-mRNA-splicing factor', NULL, NULL, NULL, NULL, NULL, 4),
(49852, NULL, 'G3DSA:3.30.110.120:FF:000003', NULL, NULL, 'Carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(49853, NULL, 'G3DSA:3.10.580.10:FF:000219', NULL, NULL, 'Chloride channel protein EriC', NULL, NULL, NULL, NULL, NULL, 4),
(49854, NULL, 'G3DSA:1.20.1740.10:FF:000208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49855, NULL, 'G3DSA:1.10.20.10:FF:000206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49856, NULL, 'G3DSA:3.40.50.300:FF:005830', NULL, NULL, 'ABC transporter B family member 7', NULL, NULL, NULL, NULL, NULL, 4),
(49857, NULL, 'G3DSA:3.30.230.10:FF:000099', NULL, NULL, 'Elongation factor Tu, putative', NULL, NULL, NULL, NULL, NULL, 4),
(49858, NULL, 'G3DSA:1.25.40.180:FF:000108', NULL, NULL, 'MIF4G domain-containing protein A', NULL, NULL, NULL, NULL, NULL, 4),
(49859, NULL, 'G3DSA:2.130.10.10:FF:002244', NULL, NULL, 'Protein transport protein sec13, putative', NULL, NULL, NULL, NULL, NULL, 4),
(49860, NULL, 'G3DSA:3.40.50.1010:FF:000163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49861, NULL, 'G3DSA:2.60.120.620:FF:000109', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49862, NULL, 'G3DSA:3.40.1000.30:FF:000006', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(49863, NULL, 'G3DSA:1.20.58.60:FF:000768', NULL, NULL, 'Protein CBG15811', NULL, NULL, NULL, NULL, NULL, 4),
(49864, NULL, 'G3DSA:3.30.420.40:FF:000504', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(49865, NULL, 'G3DSA:3.50.50.60:FF:000796', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(49866, NULL, 'G3DSA:2.60.40.10:FF:006009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49867, NULL, 'G3DSA:3.30.40.10:FF:000287', NULL, NULL, 'RING finger membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(49868, NULL, 'G3DSA:3.30.70.330:FF:000848', NULL, NULL, 'Sgn1p', NULL, NULL, NULL, NULL, NULL, 4),
(49869, NULL, 'G3DSA:3.30.590.20:FF:000010', NULL, NULL, 'Glutamate--cysteine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(49870, NULL, 'G3DSA:1.20.1280.50:FF:000033', NULL, NULL, 'F-box only protein 31', NULL, NULL, NULL, NULL, NULL, 4),
(49871, NULL, 'G3DSA:1.20.1270.10:FF:000043', NULL, NULL, 'Heat shock 70 kDa protein 15-like', NULL, NULL, NULL, NULL, NULL, 4),
(49872, NULL, 'G3DSA:1.20.5.690:FF:000001', NULL, NULL, 'Importin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(49873, NULL, 'G3DSA:2.60.40.10:FF:002120', NULL, NULL, 'obscurin-like isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(49874, NULL, 'G3DSA:3.20.20.140:FF:000295', NULL, NULL, 'AaceriAER218Cp', NULL, NULL, NULL, NULL, NULL, 4),
(49875, NULL, 'G3DSA:2.130.10.10:FF:001581', NULL, NULL, 'Polycomb protein mes-6', NULL, NULL, NULL, NULL, NULL, 4),
(49876, NULL, 'G3DSA:3.40.1190.20:FF:000196', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49877, NULL, 'G3DSA:4.10.220.40:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49878, NULL, 'G3DSA:3.30.450.40:FF:000006', NULL, NULL, 'Phytochrome', NULL, NULL, NULL, NULL, NULL, 4),
(49879, NULL, 'G3DSA:3.30.40.10:FF:000966', NULL, NULL, 'E3 ubiquitin-protein ligase CCNB1IP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(49880, NULL, 'G3DSA:1.20.58.60:FF:000089', NULL, NULL, 'microtubule-actin cross-linking factor 1 isoform X9', NULL, NULL, NULL, NULL, NULL, 4),
(49881, NULL, 'G3DSA:2.40.50.140:FF:001172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49882, NULL, 'G3DSA:2.40.70.10:FF:000133', NULL, NULL, 'Cathepsin E-like protease', NULL, NULL, NULL, NULL, NULL, 4),
(49883, NULL, 'G3DSA:3.30.450.50:FF:000009', NULL, NULL, 'Vesicle-associated membrane protein 724', NULL, NULL, NULL, NULL, NULL, 4),
(49884, NULL, 'G3DSA:2.130.10.10:FF:002570', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49885, NULL, 'G3DSA:1.20.5.170:FF:000227', NULL, NULL, 'BZIP transcription factor bZIP44', NULL, NULL, NULL, NULL, NULL, 4),
(49886, NULL, 'G3DSA:1.20.1060.10:FF:000004', NULL, NULL, 'Plastid replication-repair enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(49887, NULL, 'G3DSA:1.25.10.10:FF:001342', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(49888, NULL, 'G3DSA:2.60.40.10:FF:004211', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49889, NULL, 'G3DSA:3.40.50.11000:FF:000006', NULL, NULL, 'Fe-S cluster assembly protein DRE2', NULL, NULL, NULL, NULL, NULL, 4),
(49890, NULL, 'G3DSA:1.25.10.10:FF:003466', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49891, NULL, 'G3DSA:2.130.10.10:FF:003672', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49892, NULL, 'G3DSA:2.60.40.10:FF:000142', NULL, NULL, 'V-set domain-containing T-cell activation inhibitor 1', NULL, NULL, NULL, NULL, NULL, 4),
(49893, NULL, 'G3DSA:1.20.5.110:FF:000316', NULL, NULL, 'Vesicle transport through interaction with t-SNAREs 1b, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(49894, NULL, 'G3DSA:1.20.1560.10:FF:000469', NULL, NULL, 'Antibiotic ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(49895, NULL, 'G3DSA:3.30.160.60:FF:001726', NULL, NULL, 'Zinc finger protein 275', NULL, NULL, NULL, NULL, NULL, 4),
(49896, NULL, 'G3DSA:3.30.930.10:FF:000366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49897, NULL, 'G3DSA:1.10.287.660:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49898, NULL, 'G3DSA:3.90.190.10:FF:000407', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49899, NULL, 'G3DSA:1.10.287.3700:FF:000001', NULL, NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', NULL, NULL, NULL, NULL, NULL, 4),
(49900, NULL, 'G3DSA:2.40.50.40:FF:000085', NULL, NULL, 'Chromo domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(49901, NULL, 'G3DSA:1.20.1250.20:FF:000988', NULL, NULL, 'MFS multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(49902, NULL, 'G3DSA:3.40.50.1820:FF:001535', NULL, NULL, 'Ndrg family member 3a', NULL, NULL, NULL, NULL, NULL, 4),
(49903, NULL, 'G3DSA:3.50.50.60:FF:001313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49904, NULL, 'G3DSA:2.40.10.10:FF:000124', NULL, NULL, 'Cationic trypsin', NULL, NULL, NULL, NULL, NULL, 4),
(49905, NULL, 'G3DSA:1.10.238.110:FF:000015', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(49906, NULL, 'G3DSA:1.10.10.10:FF:001662', NULL, NULL, 'Winged helix-turn-helix transcriptional regulator, MarR family', NULL, NULL, NULL, NULL, NULL, 4),
(49907, NULL, 'G3DSA:1.20.1060.20:FF:000007', NULL, NULL, 'Structural maintenance of chromosomes protein', NULL, NULL, NULL, NULL, NULL, 4),
(49908, NULL, 'G3DSA:1.25.40.10:FF:005059', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g62670, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(49909, NULL, 'G3DSA:1.10.1740.10:FF:000014', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(49910, NULL, 'G3DSA:3.40.395.10:FF:000023', NULL, NULL, 'Ulp1 protease family c-terminal catalytic domain co', NULL, NULL, NULL, NULL, NULL, 4),
(49911, NULL, 'G3DSA:2.30.40.10:FF:000093', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(49912, NULL, 'G3DSA:3.90.190.10:FF:000087', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type 20', NULL, NULL, NULL, NULL, NULL, 4),
(49913, NULL, 'G3DSA:3.30.420.110:FF:000031', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(49914, NULL, 'G3DSA:3.40.50.12780:FF:000096', NULL, NULL, 'Peptide synthetase Nrp', NULL, NULL, NULL, NULL, NULL, 4),
(49915, NULL, 'G3DSA:2.30.30.100:FF:000236', NULL, NULL, 'Bifunctional ligase/repressor BirA', NULL, NULL, NULL, NULL, NULL, 4),
(49916, NULL, 'G3DSA:1.10.287.70:FF:000288', NULL, NULL, 'Two pore potassium channel protein sup-9', NULL, NULL, NULL, NULL, NULL, 4),
(49917, NULL, 'G3DSA:1.10.510.10:FF:000144', NULL, NULL, 'Cyclin-dependent kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(49918, NULL, 'G3DSA:3.40.50.300:FF:007275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49919, NULL, 'G3DSA:2.10.25.10:FF:001704', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(49920, NULL, 'G3DSA:1.20.1070.10:FF:001404', NULL, NULL, 'Olfactory receptor family 2 subfamily T member 11 (gene/pseudogene)', NULL, NULL, NULL, NULL, NULL, 4),
(49921, NULL, 'G3DSA:1.20.810.10:FF:000018', NULL, NULL, 'Cytochrome b mRNA maturase bI3', NULL, NULL, NULL, NULL, NULL, 4),
(49922, NULL, 'G3DSA:1.10.1450.10:FF:000093', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(49923, NULL, 'G3DSA:3.10.20.90:FF:000810', NULL, NULL, 'Ubiquitin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(49924, NULL, 'G3DSA:1.10.510.10:FF:004213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49925, NULL, 'G3DSA:2.40.33.10:FF:000047', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(49926, NULL, 'G3DSA:3.40.50.300:FF:001289', NULL, NULL, 'RAB7a, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(49927, NULL, 'G3DSA:1.25.10.10:FF:001488', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(49928, NULL, 'G3DSA:3.30.160.60:FF:006077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49929, NULL, 'G3DSA:1.10.287.110:FF:000362', NULL, NULL, 'Co-chaperone Hsc20 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(49930, NULL, 'G3DSA:3.60.21.60:FF:000026', NULL, NULL, 'DNA polymerase epsilon subunit b, putative', NULL, NULL, NULL, NULL, NULL, 4),
(49931, NULL, 'G3DSA:3.30.360.10:FF:000018', NULL, NULL, 'Glucose-6-phosphate 1-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(49932, NULL, 'G3DSA:3.40.50.360:FF:000098', NULL, NULL, 'Flavodoxin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(49933, NULL, 'G3DSA:3.30.300.10:FF:000009', NULL, NULL, 'GMP synthase [glutamine-hydrolyzing]', NULL, NULL, NULL, NULL, NULL, 4),
(49934, NULL, 'G3DSA:3.30.200.20:FF:001382', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49935, NULL, 'G3DSA:1.20.1250.20:FF:001505', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49936, NULL, 'G3DSA:2.40.50.120:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49937, NULL, 'G3DSA:3.40.50.2300:FF:001253', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49938, NULL, 'G3DSA:1.10.8.10:FF:000340', NULL, NULL, 'Toll interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(49939, NULL, 'G3DSA:1.10.506.10:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49940, NULL, 'G3DSA:2.30.39.10:FF:000055', NULL, NULL, 'GM21844', NULL, NULL, NULL, NULL, NULL, 4),
(49941, NULL, 'G3DSA:3.30.470.20:FF:000176', NULL, NULL, 'Inositol-tetrakisphosphate 1-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(49942, NULL, 'G3DSA:1.10.1410.10:FF:000028', NULL, NULL, 'U3 small nucleolar RNA-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(49943, NULL, 'G3DSA:3.60.21.50:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(49944, NULL, 'G3DSA:3.30.70.660:FF:000037', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(49945, NULL, 'G3DSA:3.40.1110.10:FF:000328', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49946, NULL, 'G3DSA:3.70.10.10:FF:000047', NULL, NULL, 'Cell cycle checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(49947, NULL, 'G3DSA:1.25.40.10:FF:003294', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(49948, NULL, 'G3DSA:3.40.630.30:FF:000515', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49949, NULL, 'G3DSA:3.30.160.60:FF:003497', NULL, NULL, 'Zinc finger protein 142', NULL, NULL, NULL, NULL, NULL, 4),
(49950, NULL, 'G3DSA:1.50.40.10:FF:000442', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49951, NULL, 'G3DSA:2.30.30.40:FF:000550', NULL, NULL, 'Calcium voltage-gated channel auxiliary subunit beta 3', NULL, NULL, NULL, NULL, NULL, 4),
(49952, NULL, 'G3DSA:3.40.910.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49953, NULL, 'G3DSA:3.90.980.20:FF:000010', NULL, NULL, 'Set1/Ash2 histone methyltransferase complex subunit ash-2', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(49954, NULL, 'G3DSA:2.130.10.30:FF:000159', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49955, NULL, 'G3DSA:3.30.70.330:FF:002765', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49956, NULL, 'G3DSA:2.120.10.80:FF:000062', NULL, NULL, 'Putative LOV domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(49957, NULL, 'G3DSA:1.20.120.1760:FF:000030', NULL, NULL, 'Cardiolipin synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(49958, NULL, 'G3DSA:3.40.50.300:FF:005976', NULL, NULL, 'Type VI secretion system ATPase TssH', NULL, NULL, NULL, NULL, NULL, 4),
(49959, NULL, 'G3DSA:2.60.40.10:FF:003368', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49960, NULL, 'G3DSA:3.30.710.10:FF:000355', NULL, NULL, 'Protein abrupt', NULL, NULL, NULL, NULL, NULL, 4),
(49961, NULL, 'G3DSA:2.30.30.1020:FF:000017', NULL, NULL, 'CCR4-NOT transcription complex, subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(49962, NULL, 'G3DSA:3.40.720.10:FF:000275', NULL, NULL, 'Sulfatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(49963, NULL, 'G3DSA:3.40.30.10:FF:000853', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(49964, NULL, 'G3DSA:2.60.40.10:FF:002266', NULL, NULL, '1,4-alpha-glucan-branching enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(49965, NULL, 'G3DSA:3.40.50.720:FF:000869', NULL, NULL, 'Pteridine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(49966, NULL, 'G3DSA:3.30.40.10:FF:001276', NULL, NULL, 'RNA binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(49967, NULL, 'G3DSA:2.130.10.10:FF:005650', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49968, NULL, 'G3DSA:3.60.40.10:FF:000336', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49969, NULL, 'G3DSA:3.40.50.150:FF:000327', NULL, NULL, 'Unplaced genomic scaffold supercont2.6, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(49970, NULL, 'G3DSA:1.10.1070.11:FF:000025', NULL, NULL, 'Serine/threonine-protein kinase Tel1', NULL, NULL, NULL, NULL, NULL, 4),
(49971, NULL, 'G3DSA:2.130.10.10:FF:000153', NULL, NULL, 'WD and tetratricopeptide repeats protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(49972, NULL, 'G3DSA:3.30.70.330:FF:001837', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49973, NULL, 'G3DSA:3.40.50.720:FF:001212', NULL, NULL, 'Short chain dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(49974, NULL, 'G3DSA:3.40.109.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(49975, NULL, 'G3DSA:3.40.120.10:FF:000072', NULL, NULL, 'Phosphoacetylglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(49976, NULL, 'G3DSA:1.20.120.1370:FF:000003', NULL, NULL, 'Regulator of sigma D', NULL, NULL, NULL, NULL, NULL, 4),
(49977, NULL, 'G3DSA:3.40.50.300:FF:000833', NULL, NULL, 'F-box DNA helicase 1', NULL, NULL, NULL, NULL, NULL, 4),
(49978, NULL, 'G3DSA:3.40.605.10:FF:000024', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(49979, NULL, 'G3DSA:3.30.390.30:FF:000032', NULL, NULL, 'Pyridine nucleotide-disulfide oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(49980, NULL, 'G3DSA:3.30.43.10:FF:000001', NULL, NULL, 'Xanthine dehydrogenase/oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(49981, NULL, 'G3DSA:2.60.120.200:FF:000658', NULL, NULL, 'EGF family domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(49982, NULL, 'G3DSA:2.40.50.590:FF:000002', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(49983, NULL, 'G3DSA:1.10.10.10:FF:001369', NULL, NULL, 'Transcriptional regulator, IclR family', NULL, NULL, NULL, NULL, NULL, 4),
(49984, NULL, 'G3DSA:3.40.710.10:FF:000190', NULL, NULL, 'D-alanyl-D-alanine endopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(49985, NULL, 'G3DSA:2.80.10.50:FF:000263', NULL, NULL, 'Beta-porphyranase A', NULL, NULL, NULL, NULL, NULL, 4),
(49986, NULL, 'G3DSA:2.60.40.10:FF:001277', NULL, NULL, 'sialoadhesin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(49987, NULL, 'G3DSA:3.80.10.10:FF:002795', NULL, NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase At3g28040', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(49988, NULL, 'G3DSA:2.60.40.60:FF:000050', NULL, NULL, 'protocadherin-15 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(49989, NULL, 'G3DSA:1.20.58.340:FF:000008', NULL, NULL, 'CorA family metal ion transporter', NULL, NULL, NULL, NULL, NULL, 4),
(49990, NULL, 'G3DSA:1.20.58.390:FF:000242', NULL, NULL, 'AGAP009493-PA', NULL, NULL, NULL, NULL, NULL, 4),
(49991, NULL, 'G3DSA:1.10.472.80:FF:000165', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49992, NULL, 'G3DSA:3.40.50.720:FF:001358', NULL, NULL, 'At1g19690', NULL, NULL, NULL, NULL, NULL, 4),
(49993, NULL, 'G3DSA:3.30.160.60:FF:005088', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49994, NULL, 'G3DSA:1.25.10.10:FF:000240', NULL, NULL, 'TELO2-interacting protein 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(49995, NULL, 'G3DSA:3.30.160.60:FF:002362', NULL, NULL, 'Zinc finger protein 620', NULL, NULL, NULL, NULL, NULL, 4),
(49996, NULL, 'G3DSA:3.30.1390.30:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(49997, NULL, 'G3DSA:3.60.21.10:FF:000005', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(49998, NULL, 'G3DSA:1.10.1440.10:FF:000002', NULL, NULL, 'Apolipoprotein C-II', NULL, NULL, NULL, NULL, NULL, 4),
(49999, NULL, 'G3DSA:3.40.50.410:FF:000248', NULL, NULL, 'Methanol oxidation protein', NULL, NULL, NULL, NULL, NULL, 4),
(50000, NULL, 'G3DSA:3.30.1390.20:FF:000011', NULL, NULL, '50S ribosomal protein L30', NULL, NULL, NULL, NULL, NULL, 4),
(50001, NULL, 'G3DSA:3.30.200.20:FF:001443', NULL, NULL, 'Cyclin-dependent kinase 19', NULL, NULL, NULL, NULL, NULL, 4),
(50002, NULL, 'G3DSA:1.10.287.110:FF:000036', NULL, NULL, 'dnaJ homolog subfamily C member 25', NULL, NULL, NULL, NULL, NULL, 4),
(50003, NULL, 'G3DSA:1.10.287.2250:FF:000004', NULL, NULL, 'Si:dkey-267n13.1', NULL, NULL, NULL, NULL, NULL, 4),
(50004, NULL, 'G3DSA:1.10.30.10:FF:000090', NULL, NULL, 'High mobility group protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(50005, NULL, 'G3DSA:1.25.40.10:FF:004603', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(50006, NULL, 'G3DSA:2.70.170.10:FF:000021', NULL, NULL, 'Gamma-aminobutyric acid receptor isoform 3b', NULL, NULL, NULL, NULL, NULL, 4),
(50007, NULL, 'G3DSA:3.30.420.40:FF:000830', NULL, NULL, 'Actin-like protein arp5', NULL, NULL, NULL, NULL, NULL, 4),
(50008, NULL, 'G3DSA:1.10.246.20:FF:000004', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 15', NULL, NULL, NULL, NULL, NULL, 4),
(50009, NULL, 'G3DSA:3.30.200.20:FF:001589', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50010, NULL, 'G3DSA:3.10.20.90:FF:000164', NULL, NULL, 'UBX domain-containing protein 2A', NULL, NULL, NULL, NULL, NULL, 4),
(50011, NULL, 'G3DSA:2.130.10.10:FF:005796', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50012, NULL, 'G3DSA:2.60.120.330:FF:000085', NULL, NULL, '1-aminocyclopropane-1-carboxylate oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(50013, NULL, 'G3DSA:3.30.420.10:FF:000136', NULL, NULL, 'Poly(A)-specific ribonuclease PARN', NULL, NULL, NULL, NULL, NULL, 4),
(50014, NULL, 'G3DSA:2.102.10.10:FF:000071', NULL, NULL, 'Aromatic 1,2-dioxygenase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(50015, NULL, 'G3DSA:1.10.246.10:FF:000001', NULL, NULL, 'Serum albumin', NULL, NULL, NULL, NULL, NULL, 4),
(50016, NULL, 'G3DSA:3.30.70.330:FF:001630', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50017, NULL, 'G3DSA:1.10.510.10:FF:001279', NULL, NULL, 'Ser/Thr protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50018, NULL, 'G3DSA:3.40.50.1000:FF:000334', NULL, NULL, '2-deoxyglucose-6-phosphate phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50019, NULL, 'G3DSA:3.30.420.10:FF:000754', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50020, NULL, 'G3DSA:3.40.630.30:FF:000195', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(50021, NULL, 'G3DSA:2.130.10.10:FF:001255', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(50022, NULL, 'G3DSA:2.30.30.40:FF:000050', NULL, NULL, 'RAS p21 protein activator 1', NULL, NULL, NULL, NULL, NULL, 4),
(50023, NULL, 'G3DSA:3.30.160.60:FF:000271', NULL, NULL, 'Zinc finger protein 662', NULL, NULL, NULL, NULL, NULL, 4),
(50024, NULL, 'G3DSA:3.40.50.300:FF:006140', NULL, NULL, 'DNA helicase related protein', NULL, NULL, NULL, NULL, NULL, 4),
(50025, NULL, 'G3DSA:1.10.10.1180:FF:000002', NULL, NULL, 'LEM domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(50026, NULL, 'G3DSA:3.30.70.1230:FF:000237', NULL, NULL, 'Adenylate cyclase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50027, NULL, 'G3DSA:3.30.2160.10:FF:000019', NULL, NULL, 'E3 ubiquitin-protein ligase UPL5 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(50028, NULL, 'G3DSA:2.60.40.150:FF:000139', NULL, NULL, 'extended synaptotagmin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(50029, NULL, 'G3DSA:3.30.160.20:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50030, NULL, 'G3DSA:2.60.120.10:FF:000481', NULL, NULL, 'Cyclic nucleotide-binding domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50031, NULL, 'G3DSA:1.10.8.60:FF:000422', NULL, NULL, 'Replication factor C small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(50032, NULL, 'G3DSA:1.20.120.20:FF:000019', NULL, NULL, 'Apolipoprotein A-I', NULL, NULL, NULL, NULL, NULL, 4),
(50033, NULL, 'G3DSA:1.25.10.10:FF:002331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50034, NULL, 'G3DSA:1.10.405.10:FF:000012', NULL, NULL, 'Probable flavin-containing monoamine oxidase aofH', NULL, NULL, NULL, NULL, NULL, 4),
(50035, NULL, 'G3DSA:2.130.10.10:FF:001934', NULL, NULL, '66 kDa stress protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(50036, NULL, 'G3DSA:3.40.50.1820:FF:001209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50037, NULL, 'G3DSA:1.10.533.10:FF:000034', NULL, NULL, 'tumor necrosis factor receptor superfamily member 16', NULL, NULL, NULL, NULL, NULL, 4),
(50038, NULL, 'G3DSA:2.60.120.10:FF:000801', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(50039, NULL, 'G3DSA:1.20.1250.20:FF:002287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50040, NULL, 'G3DSA:1.10.287.3990:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50041, NULL, 'G3DSA:3.40.50.300:FF:005358', NULL, NULL, 'Dynamin 2', NULL, NULL, NULL, NULL, NULL, 4),
(50042, NULL, 'G3DSA:1.10.1200.10:FF:000075', NULL, NULL, 'Nonribosomal peptide synthetase 13', NULL, NULL, NULL, NULL, NULL, 4),
(50043, NULL, 'G3DSA:3.40.50.720:FF:000369', NULL, NULL, 'flavin reductase (NADPH)', NULL, NULL, NULL, NULL, NULL, 4),
(50044, NULL, 'G3DSA:4.10.400.10:FF:000169', NULL, NULL, 'Low-density lipoprotein receptor-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(50045, NULL, 'G3DSA:1.10.287.380:FF:000038', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(50046, NULL, 'G3DSA:3.10.310.10:FF:000031', NULL, NULL, 'Proline racemase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50047, NULL, 'G3DSA:1.10.30.10:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50048, NULL, 'G3DSA:3.40.50.10810:FF:000224', NULL, NULL, 'SNF2 histone linker PHD RING helicase', NULL, NULL, NULL, NULL, NULL, 4),
(50049, NULL, 'G3DSA:1.20.120.1080:FF:000039', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(50050, NULL, 'G3DSA:1.20.120.1900:FF:000027', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(50051, NULL, 'G3DSA:1.10.10.60:FF:000316', NULL, NULL, 'Transcription factor MYB15', NULL, NULL, NULL, NULL, NULL, 4),
(50052, NULL, 'G3DSA:1.50.40.10:FF:000296', NULL, NULL, 'SLC (SoLute Carrier) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(50053, NULL, 'G3DSA:3.40.710.10:FF:000038', NULL, NULL, 'Penicillin-binding protein, transpeptidase domain protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(50054, NULL, 'G3DSA:3.30.450.260:FF:000008', NULL, NULL, 'Soluble guanylate cyclase gcy-37', NULL, NULL, NULL, NULL, NULL, 4),
(50055, NULL, 'G3DSA:1.10.287.370:FF:000035', NULL, NULL, 'Probable prefoldin subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(50056, NULL, 'G3DSA:2.130.10.10:FF:001755', NULL, NULL, 'GD12195', NULL, NULL, NULL, NULL, NULL, 4),
(50057, NULL, 'G3DSA:3.90.1470.20:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50058, NULL, 'G3DSA:2.60.120.620:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50059, NULL, 'G3DSA:2.130.10.10:FF:003407', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(50060, NULL, 'G3DSA:3.30.830.10:FF:000010', NULL, NULL, 'Mitochondrial-processing peptidase alpha subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(50061, NULL, 'G3DSA:1.20.1280.170:FF:000009', NULL, NULL, 'Exocyst complex protein EXO70', NULL, NULL, NULL, NULL, NULL, 4),
(50062, NULL, 'G3DSA:1.20.5.390:FF:000001', NULL, NULL, 'rho guanine nucleotide exchange factor 7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(50063, NULL, 'G3DSA:3.40.30.10:FF:000527', NULL, NULL, 'Glutaredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(50064, NULL, 'G3DSA:2.30.29.30:FF:001106', NULL, NULL, 'Uncharacterized protein C1610.01', NULL, NULL, NULL, NULL, NULL, 4),
(50065, NULL, 'G3DSA:3.30.160.60:FF:003643', NULL, NULL, 'Putative tiptop', NULL, NULL, NULL, NULL, NULL, 4),
(50066, NULL, 'G3DSA:1.20.58.70:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50067, NULL, 'G3DSA:1.20.5.4820:FF:000002', NULL, NULL, 'Myosin heavy chain 10', NULL, NULL, NULL, NULL, NULL, 4),
(50068, NULL, 'G3DSA:1.10.510.10:FF:000205', NULL, NULL, 'Cyclin-dependent kinase 6', NULL, NULL, NULL, NULL, NULL, 4),
(50069, NULL, 'G3DSA:3.30.160.60:FF:006105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50070, NULL, 'G3DSA:3.90.1470.10:FF:000001', NULL, NULL, 'Phosphoserine phosphatase ThrH', NULL, NULL, NULL, NULL, NULL, 4),
(50071, NULL, 'G3DSA:1.20.120.160:FF:000015', NULL, NULL, 'Hybrid sensor kinase RscS', NULL, NULL, NULL, NULL, NULL, 4),
(50072, NULL, 'G3DSA:3.30.70.100:FF:000038', NULL, NULL, 'Superoxide dismutase 1 copper chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(50073, NULL, 'G3DSA:1.25.40.570:FF:000074', NULL, NULL, 'COP9 signalosome complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(50074, NULL, 'G3DSA:1.10.287.70:FF:000349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50075, NULL, 'G3DSA:1.10.530.10:FF:000061', NULL, NULL, 'Morphogenesis protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(50076, NULL, 'G3DSA:2.130.10.10:FF:002070', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50077, NULL, 'G3DSA:1.10.10.10:FF:001869', NULL, NULL, 'Probable intron-encoded endonuclease bI1', NULL, NULL, NULL, NULL, NULL, 4),
(50078, NULL, 'G3DSA:1.10.437.10:FF:000029', NULL, NULL, 'Bcl2-associated X protein b', NULL, NULL, NULL, NULL, NULL, 4),
(50079, NULL, 'G3DSA:2.60.40.10:FF:004183', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50080, NULL, 'G3DSA:2.130.10.10:FF:000653', NULL, NULL, 'Telomerase protein component 1', NULL, NULL, NULL, NULL, NULL, 4),
(50081, NULL, 'G3DSA:1.20.920.10:FF:000173', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(50082, NULL, 'G3DSA:3.60.21.10:FF:000270', NULL, NULL, 'Purple acid phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(50083, NULL, 'G3DSA:3.40.50.720:FF:001712', NULL, NULL, 'Bifunctional dTDP-4-dehydrorhamnose 3,5-epimerase/dTDP-4-dehydrorhamnose reductase', NULL, NULL, NULL, NULL, NULL, 4),
(50084, NULL, 'G3DSA:1.10.10.250:FF:000010', NULL, NULL, 'Putative ribosomal protein L11', NULL, NULL, NULL, NULL, NULL, 4),
(50085, NULL, 'G3DSA:2.70.98.60:FF:000002', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(50086, NULL, 'G3DSA:3.40.50.300:FF:000333', NULL, NULL, 'Dynein cytoplasmic 1 light intermediate chain 2', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(50087, NULL, 'G3DSA:1.20.5.2440:FF:000001', NULL, NULL, 'RAB11 family interacting protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(50088, NULL, 'G3DSA:3.40.50.300:FF:008410', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50089, NULL, 'G3DSA:2.70.130.10:FF:000075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50090, NULL, 'G3DSA:3.40.50.300:FF:003559', NULL, NULL, 'Guanine nucleotide-binding protein G(i) subunit alpha-1', NULL, NULL, NULL, NULL, NULL, 4),
(50091, NULL, 'G3DSA:3.30.200.20:FF:001089', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(50092, NULL, 'G3DSA:2.60.120.330:FF:000146', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(50093, NULL, 'G3DSA:1.10.510.10:FF:001925', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50094, NULL, 'G3DSA:3.40.449.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50095, NULL, 'G3DSA:3.30.420.10:FF:000462', NULL, NULL, 'AGAP007533-PA', NULL, NULL, NULL, NULL, NULL, 4),
(50096, NULL, 'G3DSA:3.10.450.10:FF:000007', NULL, NULL, 'latexin', NULL, NULL, NULL, NULL, NULL, 4),
(50097, NULL, 'G3DSA:1.50.40.10:FF:000116', NULL, NULL, 'Mitochondrial substrate carrier', NULL, NULL, NULL, NULL, NULL, 4),
(50098, NULL, 'G3DSA:2.60.40.10:FF:000203', NULL, NULL, 'Plexin B2', NULL, NULL, NULL, NULL, NULL, 4),
(50099, NULL, 'G3DSA:2.30.29.30:FF:000004', NULL, NULL, 'IQ motif and SEC7 domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(50100, NULL, 'G3DSA:3.40.640.10:FF:000009', NULL, NULL, 'Cystathionine gamma-synthase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(50101, NULL, 'G3DSA:3.30.1640.10:FF:000101', NULL, NULL, 'MCM / cell division control protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(50102, NULL, 'G3DSA:3.40.140.10:FF:000016', NULL, NULL, 'Cytosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(50103, NULL, 'G3DSA:3.30.40.10:FF:001422', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50104, NULL, 'G3DSA:3.30.565.10:FF:000022', NULL, NULL, 'Anti-sigma F factor', NULL, NULL, NULL, NULL, NULL, 4),
(50105, NULL, 'G3DSA:2.60.200.10:FF:000010', NULL, NULL, 'Interferon regulatory factor 8', NULL, NULL, NULL, NULL, NULL, 4),
(50106, NULL, 'G3DSA:3.30.70.330:FF:003136', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50107, NULL, 'G3DSA:1.10.540.10:FF:000033', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(50108, NULL, 'G3DSA:2.170.270.10:FF:000044', NULL, NULL, 'Zinc finger protein 408', NULL, NULL, NULL, NULL, NULL, 4),
(50109, NULL, 'G3DSA:2.60.200.20:FF:000013', NULL, NULL, 'FHA domain-containing protein FhaA', NULL, NULL, NULL, NULL, NULL, 4),
(50110, NULL, 'G3DSA:1.20.1730.10:FF:000062', NULL, NULL, 'High affinity choline transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(50111, NULL, 'G3DSA:1.20.120.1070:FF:000003', NULL, NULL, 'Translation initiation factor eIF-2B subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(50112, NULL, 'G3DSA:3.30.160.60:FF:004306', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50113, NULL, 'G3DSA:1.20.5.170:FF:000199', NULL, NULL, 'Glial fibrillary acidic protein', NULL, NULL, NULL, NULL, NULL, 4),
(50114, NULL, 'G3DSA:2.60.120.200:FF:000719', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50115, NULL, 'G3DSA:3.40.190.10:FF:000784', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50116, NULL, 'G3DSA:1.20.5.110:FF:000142', NULL, NULL, 'Syntaxin-binding protein 6 (amisyn),-like', NULL, NULL, NULL, NULL, NULL, 4),
(50117, NULL, 'G3DSA:3.30.565.10:FF:000314', NULL, NULL, 'Two component system histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(50118, NULL, 'G3DSA:3.80.10.10:FF:002469', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50119, NULL, 'G3DSA:2.60.60.20:FF:000062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50120, NULL, 'G3DSA:3.90.70.10:FF:000600', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(50121, NULL, 'G3DSA:3.30.70.240:FF:000001', NULL, NULL, 'Elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(50122, NULL, 'G3DSA:1.10.10.60:FF:000081', NULL, NULL, 'Empty spiracles homeobox 2', NULL, NULL, NULL, NULL, NULL, 4),
(50123, NULL, 'G3DSA:1.10.10.440:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50124, NULL, 'G3DSA:2.30.30.140:FF:000080', NULL, NULL, 'Fragile X mental retardation protein 1 B', NULL, NULL, NULL, NULL, NULL, 4),
(50125, NULL, 'G3DSA:3.40.250.10:FF:000137', NULL, NULL, 'Rhodanese domain protein / beta-lactamase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(50126, NULL, 'G3DSA:1.10.287.70:FF:000675', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50127, NULL, 'G3DSA:2.40.160.110:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50128, NULL, 'G3DSA:2.130.10.10:FF:001608', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(50129, NULL, 'G3DSA:3.90.70.10:FF:000213', NULL, NULL, 'Cysteine protease 11', NULL, NULL, NULL, NULL, NULL, 4),
(50130, NULL, 'G3DSA:3.30.300.30:FF:000167', NULL, NULL, 'Tryptophan N-acetyltransferase ivoA', NULL, NULL, NULL, NULL, NULL, 4),
(50131, NULL, 'G3DSA:3.10.20.90:FF:000490', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50132, NULL, 'G3DSA:2.60.40.60:FF:000988', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50133, NULL, 'G3DSA:3.50.30.60:FF:000002', NULL, NULL, 'Microcin immunity protein MccF', NULL, NULL, NULL, NULL, NULL, 4),
(50134, NULL, 'G3DSA:2.60.40.10:FF:000821', NULL, NULL, 'Myomesin 3', NULL, NULL, NULL, NULL, NULL, 4),
(50135, NULL, 'G3DSA:1.10.20.120:FF:000001', NULL, NULL, 'Ribonuclease H2 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(50136, NULL, 'G3DSA:2.10.50.10:FF:000021', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 6', NULL, NULL, NULL, NULL, NULL, 4),
(50137, NULL, 'G3DSA:2.10.25.10:FF:000980', NULL, NULL, 'Fibrillin-1', NULL, NULL, NULL, NULL, NULL, 4),
(50138, NULL, 'G3DSA:2.40.40.20:FF:000016', NULL, NULL, 'peroxisome biogenesis factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(50139, NULL, 'G3DSA:2.40.10.480:FF:000006', NULL, NULL, 'Os06g0111600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(50140, NULL, 'G3DSA:3.20.20.70:FF:000337', NULL, NULL, 'NADPH dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(50141, NULL, 'G3DSA:2.10.25.10:FF:001789', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50142, NULL, 'G3DSA:4.10.240.10:FF:000134', NULL, NULL, 'Fluconazole resistance protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(50143, NULL, 'G3DSA:2.40.160.120:FF:000034', NULL, NULL, 'Oxysterol-binding protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(50144, NULL, 'G3DSA:3.10.20.360:FF:000003', NULL, NULL, 'Patronin (microtubule-binding protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(50145, NULL, 'G3DSA:1.10.20.130:FF:000004', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(50146, NULL, 'G3DSA:3.30.160.60:FF:005588', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50147, NULL, 'G3DSA:2.60.120.260:FF:000569', NULL, NULL, 'Si:dkey-202e22.2', NULL, NULL, NULL, NULL, NULL, 4),
(50148, NULL, 'G3DSA:2.40.40.10:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50149, NULL, 'G3DSA:3.30.70.250:FF:000004', NULL, NULL, 'Malonyl CoA-acyl carrier transacylase', NULL, NULL, NULL, NULL, NULL, 4),
(50150, NULL, 'G3DSA:3.90.550.10:FF:000216', NULL, NULL, 'Cellulose synthase-like protein G2', NULL, NULL, NULL, NULL, NULL, 4),
(50151, NULL, 'G3DSA:3.80.10.10:FF:001721', NULL, NULL, 'Leucine rich repeat containing 8 VRAC subunit E', NULL, NULL, NULL, NULL, NULL, 4),
(50152, NULL, 'G3DSA:3.40.50.10490:FF:000145', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50153, NULL, 'G3DSA:2.20.25.530:FF:000008', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(50154, NULL, 'G3DSA:1.25.40.990:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(50155, NULL, 'G3DSA:1.20.1070.10:FF:000915', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50156, NULL, 'G3DSA:3.40.50.300:FF:004402', NULL, NULL, 'DNA replication protein DnaC', NULL, NULL, NULL, NULL, NULL, 4),
(50157, NULL, 'G3DSA:3.30.70.1660:FF:000017', NULL, NULL, 'Peptide chain release factor 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(50158, NULL, 'G3DSA:3.40.33.10:FF:000034', NULL, NULL, 'Protein CBG17161', NULL, NULL, NULL, NULL, NULL, 4),
(50159, NULL, 'G3DSA:1.25.10.10:FF:003079', NULL, NULL, 'Phosphoprotein p93', NULL, NULL, NULL, NULL, NULL, 4),
(50160, NULL, 'G3DSA:3.20.20.70:FF:000629', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50161, NULL, 'G3DSA:2.130.10.10:FF:003733', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50162, NULL, 'G3DSA:2.40.150.20:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50163, NULL, 'G3DSA:3.30.2020.30:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50164, NULL, 'G3DSA:3.40.50.1820:FF:000546', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50165, NULL, 'G3DSA:3.10.50.40:FF:000084', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(50166, NULL, 'G3DSA:1.10.510.10:FF:003078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50167, NULL, 'G3DSA:2.60.120.200:FF:000484', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50168, NULL, 'G3DSA:3.40.50.300:FF:007893', NULL, NULL, 'Si:dkeyp-86b9.1', NULL, NULL, NULL, NULL, NULL, 4),
(50169, NULL, 'G3DSA:3.40.50.2300:FF:000797', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(50170, NULL, 'G3DSA:3.40.50.200:FF:000157', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(50171, NULL, 'G3DSA:2.60.40.10:FF:005846', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50172, NULL, 'G3DSA:3.40.50.740:FF:000055', NULL, NULL, 'NADH dehydrogenase I chain G', NULL, NULL, NULL, NULL, NULL, 4),
(50173, NULL, 'G3DSA:1.10.10.1940:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50174, NULL, 'G3DSA:3.40.50.1820:FF:001182', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(50175, NULL, 'G3DSA:1.10.10.60:FF:000642', NULL, NULL, 'MYB transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(50176, NULL, 'G3DSA:3.80.10.10:FF:003930', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50177, NULL, 'G3DSA:3.30.160.60:FF:000563', NULL, NULL, 'Krueppel-like factor 8', NULL, NULL, NULL, NULL, NULL, 4),
(50178, NULL, 'G3DSA:3.30.450.20:FF:000585', NULL, NULL, 'Sensory box protein', NULL, NULL, NULL, NULL, NULL, 4),
(50179, NULL, 'G3DSA:3.40.50.720:FF:000695', NULL, NULL, 'UDP-glucose 4-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(50180, NULL, 'G3DSA:2.60.40.1770:FF:000010', NULL, NULL, 'Ephrin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(50181, NULL, 'G3DSA:2.60.40.60:FF:000903', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50182, NULL, 'G3DSA:1.10.3210.10:FF:000047', NULL, NULL, 'HD domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(50183, NULL, 'G3DSA:3.10.400.20:FF:000007', NULL, NULL, 'Putative translation initiation factor SUI1', NULL, NULL, NULL, NULL, NULL, 4),
(50184, NULL, 'G3DSA:1.10.10.10:FF:000560', NULL, NULL, 'Iron-dependent transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(50185, NULL, 'G3DSA:3.40.50.2300:FF:000151', NULL, NULL, 'Penicillin-binding protein activator LpoA', NULL, NULL, NULL, NULL, NULL, 4),
(50186, NULL, 'G3DSA:2.40.50.140:FF:000070', NULL, NULL, 'Maltose/maltodextrin import ATP-binding protein MalK', NULL, NULL, NULL, NULL, NULL, 4),
(50187, NULL, 'G3DSA:3.40.50.1100:FF:000038', NULL, NULL, 'Threonine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(50188, NULL, 'G3DSA:3.40.50.10260:FF:000014', NULL, NULL, 'NAD(P)H-hydrate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(50189, NULL, 'G3DSA:3.30.30.30:FF:000062', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(50190, NULL, 'G3DSA:3.90.79.10:FF:000120', NULL, NULL, 'MutT/nudix family protein', NULL, NULL, NULL, NULL, NULL, 4),
(50191, NULL, 'G3DSA:3.30.70.330:FF:002939', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50192, NULL, 'G3DSA:3.30.160.60:FF:001698', NULL, NULL, 'Zinc finger protein 90 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(50193, NULL, 'G3DSA:2.130.10.10:FF:003379', NULL, NULL, 'Probable serine/threonine-protein kinase vps15', NULL, NULL, NULL, NULL, NULL, 4),
(50194, NULL, 'G3DSA:2.30.180.10:FF:000053', NULL, NULL, 'Transforming growth factor-beta-induced protein', NULL, NULL, NULL, NULL, NULL, 4),
(50195, NULL, 'G3DSA:3.40.50.450:FF:000092', NULL, NULL, 'Putative cytokinin riboside 5''-monophosphate phosphoribohydrolase LOG9', NULL, NULL, NULL, NULL, NULL, 4),
(50196, NULL, 'G3DSA:3.40.1160.10:FF:000040', NULL, NULL, 'Glutamate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(50197, NULL, 'G3DSA:2.130.10.10:FF:000327', NULL, NULL, 'F-box/WD repeat-containing protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(50198, NULL, 'G3DSA:2.30.110.50:FF:000004', NULL, NULL, 'Putative VGR-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(50199, NULL, 'G3DSA:3.30.200.20:FF:000280', NULL, NULL, 'membrane-associated tyrosine- and threonine-specific cdc2-inhibitory kinase', NULL, NULL, NULL, NULL, NULL, 4),
(50200, NULL, 'G3DSA:1.10.600.10:FF:000089', NULL, NULL, 'Geranylgeranyl pyrophosphate synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(50201, NULL, 'G3DSA:3.30.500.10:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50202, NULL, 'G3DSA:3.40.50.300:FF:003913', NULL, NULL, 'Dephospho-CoA_kinase_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(50203, NULL, 'G3DSA:3.40.50.150:FF:001255', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50204, NULL, 'G3DSA:2.30.42.10:FF:000428', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50205, NULL, 'G3DSA:3.40.50.300:FF:005684', NULL, NULL, 'ABC multidrug transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(50206, NULL, 'G3DSA:3.40.50.1000:FF:000660', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50207, NULL, 'G3DSA:1.25.40.10:FF:003468', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(50208, NULL, 'G3DSA:2.10.70.10:FF:000084', NULL, NULL, 'Mannan-binding lectin serine protease 2', NULL, NULL, NULL, NULL, NULL, 4),
(50209, NULL, 'G3DSA:3.50.50.60:FF:000211', NULL, NULL, 'Amine oxidase, flavin-containing superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(50210, NULL, 'G3DSA:3.10.400.10:FF:000004', NULL, NULL, 'PAPS synthetase, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(50211, NULL, 'G3DSA:3.40.50.10330:FF:000029', NULL, NULL, 'NAD+ kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50212, NULL, 'G3DSA:3.80.10.10:FF:001160', NULL, NULL, 'Receptor-like protein kinase HSL1 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(50213, NULL, 'G3DSA:2.60.40.1090:FF:000020', NULL, NULL, 'Fimbrial protein YehD', NULL, NULL, NULL, NULL, NULL, 4),
(50214, NULL, 'G3DSA:3.30.200.20:FF:002106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50215, NULL, 'G3DSA:1.10.357.20:FF:000003', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(50216, NULL, 'G3DSA:3.40.50.1260:FF:000007', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(50217, NULL, 'G3DSA:3.40.50.300:FF:001761', NULL, NULL, 'Replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(50218, NULL, 'G3DSA:1.10.720.30:FF:000076', NULL, NULL, 'Ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(50219, NULL, 'G3DSA:1.20.1250.20:FF:001152', NULL, NULL, 'Sugar transporter ERD6-like 6', NULL, NULL, NULL, NULL, NULL, 4),
(50220, NULL, 'G3DSA:2.60.40.10:FF:005285', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50221, NULL, 'G3DSA:2.60.120.10:FF:000094', NULL, NULL, 'cGMP-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(50222, NULL, 'G3DSA:1.10.220.60:FF:000007', NULL, NULL, 'GM15554', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(50223, NULL, 'G3DSA:2.130.10.10:FF:003172', NULL, NULL, 'WD repeat-containing protein 16-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(50224, NULL, 'G3DSA:2.60.120.970:FF:000102', NULL, NULL, 'Transforming growth factor beta', NULL, NULL, NULL, NULL, NULL, 4),
(50225, NULL, 'G3DSA:3.30.505.10:FF:000131', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(50226, NULL, 'G3DSA:1.20.1110.10:FF:000150', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(50227, NULL, 'G3DSA:1.25.10.10:FF:000532', NULL, NULL, 'Serine/threonine-protein kinase mTOR', NULL, NULL, NULL, NULL, NULL, 4),
(50228, NULL, 'G3DSA:3.40.50.300:FF:004223', NULL, NULL, 'MRP-like ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(50229, NULL, 'G3DSA:3.40.50.12650:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50230, NULL, 'G3DSA:3.20.20.10:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50231, NULL, 'G3DSA:3.20.20.60:FF:000008', NULL, NULL, 'Citrate (Pro-3S)-lyase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(50232, NULL, 'G3DSA:1.10.472.10:FF:000251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50233, NULL, 'G3DSA:2.30.29.30:FF:000089', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(50234, NULL, 'G3DSA:1.10.357.30:FF:000006', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(50235, NULL, 'G3DSA:1.10.10.390:FF:000001', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(50236, NULL, 'G3DSA:3.40.50.2020:FF:000011', NULL, NULL, 'Putative ribose-phosphate pyrophosphokinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(50237, NULL, 'G3DSA:2.60.40.10:FF:001923', NULL, NULL, 'KETtiN (Drosophila actin-binding) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(50238, NULL, 'G3DSA:1.20.1070.10:FF:001730', NULL, NULL, 'Zg02', NULL, NULL, NULL, NULL, NULL, 4),
(50239, NULL, 'G3DSA:1.20.58.60:FF:000589', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(50240, NULL, 'G3DSA:3.40.50.150:FF:000153', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(50241, NULL, 'G3DSA:3.80.10.10:FF:002823', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(50242, NULL, 'G3DSA:3.30.70.1230:FF:000063', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(50243, NULL, 'G3DSA:3.40.470.10:FF:000002', NULL, NULL, 'G/T mismatch-specific thymine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(50244, NULL, 'G3DSA:3.90.550.10:FF:000542', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(50245, NULL, 'G3DSA:3.40.50.1820:FF:001035', NULL, NULL, 'Putative isoprenylcysteine alpha-carbonyl methylesterase ICMEL2', NULL, NULL, NULL, NULL, NULL, 4),
(50246, NULL, 'G3DSA:1.20.58.60:FF:000561', NULL, NULL, 'Vab-10', NULL, NULL, NULL, NULL, NULL, 4),
(50247, NULL, 'G3DSA:1.10.8.10:FF:000194', NULL, NULL, 'Plant UBX domain-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(50248, NULL, 'G3DSA:1.20.81.10:FF:000004', NULL, NULL, 'GG17180', NULL, NULL, NULL, NULL, NULL, 4),
(50249, NULL, 'G3DSA:3.30.160.60:FF:006431', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50250, NULL, 'G3DSA:2.170.150.80:FF:000011', NULL, NULL, 'NAC domain-containing protein 41', NULL, NULL, NULL, NULL, NULL, 4),
(50251, NULL, 'G3DSA:2.130.10.10:FF:005942', NULL, NULL, 'F-box/WD repeat-containing protein A-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(50252, NULL, 'G3DSA:2.60.120.10:FF:000655', NULL, NULL, 'Dimethlysulfonioproprionate lyase DddW', NULL, NULL, NULL, NULL, NULL, 4),
(50253, NULL, 'G3DSA:1.20.1270.60:FF:000097', NULL, NULL, 'Vacuolar protein sorting-associated protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(50254, NULL, 'G3DSA:3.40.390.10:FF:000001', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(50255, NULL, 'G3DSA:2.60.40.2690:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(50256, NULL, 'G3DSA:2.60.40.10:FF:003076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50257, NULL, 'G3DSA:3.10.20.90:FF:000310', NULL, NULL, 'BolA-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(50258, NULL, 'G3DSA:2.30.110.10:FF:000072', NULL, NULL, 'Pyridoxamine 5''-phosphate oxidase-related FMN-binding', NULL, NULL, NULL, NULL, NULL, 4),
(50259, NULL, 'G3DSA:3.40.630.30:FF:000341', NULL, NULL, 'Hypothetical acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(50260, NULL, 'G3DSA:1.10.630.10:FF:000737', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50261, NULL, 'G3DSA:2.30.30.140:FF:000107', NULL, NULL, 'Six-banded, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(50262, NULL, 'G3DSA:3.80.10.10:FF:000878', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(50263, NULL, 'G3DSA:3.40.50.1240:FF:000001', NULL, NULL, '6-phosphofructo-2-kinase/fructose-2, 6-bisphosphatase 3 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(50264, NULL, 'G3DSA:1.25.10.10:FF:002185', NULL, NULL, 'Os03g0701000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(50265, NULL, 'G3DSA:1.10.730.10:FF:000008', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(50266, NULL, 'G3DSA:2.130.10.10:FF:001873', NULL, NULL, 'Small nucleolar ribonucleoprotein complex subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50267, NULL, 'G3DSA:3.90.1410.10:FF:000110', NULL, NULL, 'Histone-lysine N-methyltransferase setd3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(50268, NULL, 'G3DSA:3.40.30.10:FF:000353', NULL, NULL, 'Methionyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(50269, NULL, 'G3DSA:1.10.287.310:FF:000006', NULL, NULL, '50S ribosomal protein L29', NULL, NULL, NULL, NULL, NULL, 4),
(50270, NULL, 'G3DSA:3.40.30.10:FF:000409', NULL, NULL, 'Fmp46p', NULL, NULL, NULL, NULL, NULL, 4),
(50271, NULL, 'G3DSA:3.20.20.70:FF:000837', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50272, NULL, 'G3DSA:3.40.710.10:FF:000156', NULL, NULL, 'Cell division protein ftsI', NULL, NULL, NULL, NULL, NULL, 4),
(50273, NULL, 'G3DSA:3.30.200.20:FF:000954', NULL, NULL, 'Cell division control protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50274, NULL, 'G3DSA:1.20.1270.420:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50275, NULL, 'G3DSA:3.20.20.140:FF:000115', NULL, NULL, 'Dihydropyrimidinase', NULL, NULL, NULL, NULL, NULL, 4),
(50276, NULL, 'G3DSA:1.10.10.790:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50277, NULL, 'G3DSA:3.80.10.10:FF:003604', NULL, NULL, 'Dynein assembly factor 1, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(50278, NULL, 'G3DSA:3.30.160.360:FF:000017', NULL, NULL, 'Lysine (K)-specific methyltransferase 2D', NULL, NULL, NULL, NULL, NULL, 4),
(50279, NULL, 'G3DSA:3.30.160.60:FF:005649', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50280, NULL, 'G3DSA:1.25.40.20:FF:000571', NULL, NULL, 'Rab GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50281, NULL, 'G3DSA:2.30.42.10:FF:000636', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50282, NULL, 'G3DSA:3.30.300.10:FF:000043', NULL, NULL, 'S-adenosylmethionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(50283, NULL, 'G3DSA:2.60.40.10:FF:000321', NULL, NULL, 'protein turtle homolog B isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(50284, NULL, 'G3DSA:2.40.420.20:FF:000039', NULL, NULL, 'RND family efflux transporter, MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(50285, NULL, 'G3DSA:3.20.20.80:FF:000784', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(50286, NULL, 'G3DSA:3.40.1690.10:FF:000006', NULL, NULL, 'Flagellar biosynthetic protein flhB', NULL, NULL, NULL, NULL, NULL, 4),
(50287, NULL, 'G3DSA:1.20.58.70:FF:000007', NULL, NULL, 'ER-golgi SNARE complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(50288, NULL, 'G3DSA:2.10.25.10:FF:000480', NULL, NULL, 'Protein Z, vitamin K-dependent plasma glycoprotein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(50289, NULL, 'G3DSA:3.30.160.60:FF:002423', NULL, NULL, 'Blast:Protein glass', NULL, NULL, NULL, NULL, NULL, 4),
(50290, NULL, 'G3DSA:1.20.1110.10:FF:000211', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50291, NULL, 'G3DSA:1.10.8.10:FF:000368', NULL, NULL, 'AGAP000733-PA', NULL, NULL, NULL, NULL, NULL, 4),
(50292, NULL, 'G3DSA:1.10.287.470:FF:000065', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(50293, NULL, 'G3DSA:2.60.40.10:FF:002412', NULL, NULL, 'Synaptogenesis protein syg-1', NULL, NULL, NULL, NULL, NULL, 4),
(50294, NULL, 'G3DSA:2.40.128.20:FF:000023', NULL, NULL, 'Epididymal-specific lipocalin-12', NULL, NULL, NULL, NULL, NULL, 4),
(50295, NULL, 'G3DSA:1.10.10.60:FF:000434', NULL, NULL, 'Transcription termination factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(50296, NULL, 'G3DSA:3.40.50.2300:FF:000589', NULL, NULL, 'LacI family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(50297, NULL, 'G3DSA:1.20.58.60:FF:000004', NULL, NULL, 'Actinin alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(50298, NULL, 'G3DSA:3.40.1690.20:FF:000009', NULL, NULL, 'Unplaced genomic scaffold supercont1.113, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(50299, NULL, 'G3DSA:1.10.3710.10:FF:000012', NULL, NULL, 'Recombinase RarA', NULL, NULL, NULL, NULL, NULL, 4),
(50300, NULL, 'G3DSA:3.30.800.10:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50301, NULL, 'G3DSA:3.30.310.10:FF:000015', NULL, NULL, 'Transcription initiation factor TFiid', NULL, NULL, NULL, NULL, NULL, 4),
(50302, NULL, 'G3DSA:1.50.40.10:FF:000381', NULL, NULL, 'Mitochondrial carrier protein MTM1', NULL, NULL, NULL, NULL, NULL, 4),
(50303, NULL, 'G3DSA:1.25.40.10:FF:004896', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50304, NULL, 'G3DSA:1.10.533.10:FF:000213', NULL, NULL, 'Tumor necrosis factor receptor superfamily, member 1a', NULL, NULL, NULL, NULL, NULL, 4),
(50305, NULL, 'G3DSA:1.20.5.1030:FF:000005', NULL, NULL, 'preprotein translocase subunit SECE1', NULL, NULL, NULL, NULL, NULL, 4),
(50306, NULL, 'G3DSA:3.30.420.10:FF:000636', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50307, NULL, 'G3DSA:1.10.840.10:FF:000045', NULL, NULL, 'Cyclic GMP-binding protein D', NULL, NULL, NULL, NULL, NULL, 4),
(50308, NULL, 'G3DSA:3.10.250.10:FF:000060', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(50309, NULL, 'G3DSA:1.25.40.20:FF:000037', NULL, NULL, 'short transient receptor potential channel 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(50310, NULL, 'G3DSA:2.20.28.10:FF:000053', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(50311, NULL, 'G3DSA:2.60.120.200:FF:000692', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50312, NULL, 'G3DSA:1.25.40.10:FF:000034', NULL, NULL, 'Peroxisomal biogenesis factor 5 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(50313, NULL, 'G3DSA:3.40.50.360:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50314, NULL, 'G3DSA:3.30.60.30:FF:000209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50315, NULL, 'G3DSA:2.130.10.10:FF:005616', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(50316, NULL, 'G3DSA:3.40.50.720:FF:002286', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(50317, NULL, 'G3DSA:2.30.29.30:FF:001224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50318, NULL, 'G3DSA:3.10.120.10:FF:000022', NULL, NULL, 'Cytochrome b5-like Heme/Steroid binding domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50319, NULL, 'G3DSA:3.30.200.20:FF:001617', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50320, NULL, 'G3DSA:1.20.5.110:FF:000024', NULL, NULL, 'Vesicle transport through interaction with t-SNAREs homolog 1A', NULL, NULL, NULL, NULL, NULL, 4),
(50321, NULL, 'G3DSA:1.20.58.340:FF:000042', NULL, NULL, 'Magnesium transport protein CorA', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(50322, NULL, 'G3DSA:3.40.50.10420:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50323, NULL, 'G3DSA:1.10.1900.10:FF:000021', NULL, NULL, 'E3 ubiquitin-protein ligase UBR5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(50324, NULL, 'G3DSA:3.30.300.20:FF:000046', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(50325, NULL, 'G3DSA:2.60.120.470:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50326, NULL, 'G3DSA:3.30.70.330:FF:001276', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50327, NULL, 'G3DSA:1.20.58.390:FF:000208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50328, NULL, 'G3DSA:3.90.260.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50329, NULL, 'G3DSA:1.20.1070.10:FF:001112', NULL, NULL, 'Beta-2 adrenergic receptor', NULL, NULL, NULL, NULL, NULL, 4),
(50330, NULL, 'G3DSA:1.20.58.930:FF:000005', NULL, NULL, 'Biosynthetic arginine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(50331, NULL, 'G3DSA:3.40.50.2300:FF:001640', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50332, NULL, 'G3DSA:3.30.1330.30:FF:000123', NULL, NULL, '60S ribosomal protein L7a', NULL, NULL, NULL, NULL, NULL, 4),
(50333, NULL, 'G3DSA:1.25.40.20:FF:001818', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(50334, NULL, 'G3DSA:1.10.565.10:FF:000085', NULL, NULL, 'Vitamin D3 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(50335, NULL, 'G3DSA:3.40.630.10:FF:000155', NULL, NULL, 'Zn-dependent exopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(50336, NULL, 'G3DSA:1.20.140.10:FF:000079', NULL, NULL, 'Isovaleryl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(50337, NULL, 'G3DSA:3.90.550.10:FF:000042', NULL, NULL, 'Glucoside xylosyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(50338, NULL, 'G3DSA:1.20.58.920:FF:000002', NULL, NULL, 'Putative phosphoglycerate transport regulatory protein PgtB', NULL, NULL, NULL, NULL, NULL, 4),
(50339, NULL, 'G3DSA:3.30.565.10:FF:000140', NULL, NULL, 'Cation-transporting ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50340, NULL, 'G3DSA:1.20.1070.10:FF:001258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50341, NULL, 'G3DSA:3.30.200.20:FF:001943', NULL, NULL, 'Protein kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(50342, NULL, 'G3DSA:1.20.1300.10:FF:000012', NULL, NULL, 'Succinate dehydrogenase hydrophobic membrane anchor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(50343, NULL, 'G3DSA:2.10.25.10:FF:000895', NULL, NULL, 'Teneurin-1', NULL, NULL, NULL, NULL, NULL, 4),
(50344, NULL, 'G3DSA:3.30.310.10:FF:000072', NULL, NULL, 'TATA-box-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(50345, NULL, 'G3DSA:1.25.10.10:FF:000740', NULL, NULL, 'Nucleolar protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(50346, NULL, 'G3DSA:3.90.550.50:FF:000003', NULL, NULL, 'Beta-1,3-N-acetylglucosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(50347, NULL, 'G3DSA:3.30.1380.20:FF:000005', NULL, NULL, 'Trafficking protein particle complex subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(50348, NULL, 'G3DSA:2.60.120.620:FF:000143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50349, NULL, 'G3DSA:3.10.50.40:FF:000145', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(50350, NULL, 'G3DSA:1.10.40.70:FF:000001', NULL, NULL, 'Type II secretion system protein GspE', NULL, NULL, NULL, NULL, NULL, 4),
(50351, NULL, 'G3DSA:3.40.1110.10:FF:000475', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50352, NULL, 'G3DSA:3.30.1380.10:FF:000002', NULL, NULL, 'Penicillin-insensitive murein endopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(50353, NULL, 'G3DSA:2.60.40.10:FF:005493', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50354, NULL, 'G3DSA:1.10.510.10:FF:004505', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50355, NULL, 'G3DSA:2.60.40.10:FF:004065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(50356, NULL, 'G3DSA:1.20.1300.20:FF:000015', NULL, NULL, 'Ubiquitin thioesterase otubain-like', NULL, NULL, NULL, NULL, NULL, 4),
(50357, NULL, 'G3DSA:3.40.720.10:FF:000128', NULL, NULL, 'Iduronate-sulfatase or arylsulfatase A', NULL, NULL, NULL, NULL, NULL, 4),
(50358, NULL, 'G3DSA:3.40.50.2000:FF:000825', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50359, NULL, 'G3DSA:3.40.50.970:FF:000101', NULL, NULL, 'Putative phosphonopyruvate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(50360, NULL, 'G3DSA:1.20.1250.20:FF:001270', NULL, NULL, 'Major facilitator superfamily domain containing 2B', NULL, NULL, NULL, NULL, NULL, 4),
(50361, NULL, 'G3DSA:3.40.50.1440:FF:000117', NULL, NULL, 'Tubulin gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(50362, NULL, 'G3DSA:3.30.160.20:FF:000219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50363, NULL, 'G3DSA:3.40.190.10:FF:000019', NULL, NULL, 'Sulfate ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(50364, NULL, 'G3DSA:3.30.70.1230:FF:000271', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(50365, NULL, 'G3DSA:1.10.1450.10:FF:000121', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(50366, NULL, 'G3DSA:3.80.10.10:FF:001042', NULL, NULL, 'Si:dkey-264f17.1', NULL, NULL, NULL, NULL, NULL, 4),
(50367, NULL, 'G3DSA:1.25.50.10:FF:000006', NULL, NULL, 'Peptidase M1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(50368, NULL, 'G3DSA:2.130.10.10:FF:000092', NULL, NULL, 'notchless protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(50369, NULL, 'G3DSA:1.25.10.10:FF:001634', NULL, NULL, 'Proteasome activator complex subunit 4-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(50370, NULL, 'G3DSA:3.40.50.720:FF:001151', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(50371, NULL, 'G3DSA:3.40.50.1700:FF:000038', NULL, NULL, 'Lysosomal beta glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(50372, NULL, 'G3DSA:2.60.40.1180:FF:000193', NULL, NULL, 'Glucan 1\3-alpha-glucosidase ROT2', NULL, NULL, NULL, NULL, NULL, 4),
(50373, NULL, 'G3DSA:3.10.310.40:FF:000012', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(50374, NULL, 'G3DSA:2.30.29.30:FF:000976', NULL, NULL, 'Tyrosine-protein phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(50375, NULL, 'G3DSA:3.40.50.1220:FF:000136', NULL, NULL, 'Pyruvate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(50376, NULL, 'G3DSA:3.40.50.1820:FF:001243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50377, NULL, 'G3DSA:1.25.50.20:FF:000009', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(50378, NULL, 'G3DSA:2.10.220.10:FF:000152', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(50379, NULL, 'G3DSA:3.20.20.100:FF:000098', NULL, NULL, 'Os10g0113375 protein', NULL, NULL, NULL, NULL, NULL, 4),
(50380, NULL, 'G3DSA:3.30.160.60:FF:006223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50381, NULL, 'G3DSA:3.30.70.330:FF:001219', NULL, NULL, 'Putative G3BP-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(50382, NULL, 'G3DSA:3.40.50.300:FF:004015', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(50383, NULL, 'G3DSA:3.90.190.10:FF:000379', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50384, NULL, 'G3DSA:3.30.70.330:FF:001130', NULL, NULL, 'CUGBP Elav-like family member 4', NULL, NULL, NULL, NULL, NULL, 4),
(50385, NULL, 'G3DSA:1.25.40.10:FF:001815', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At1g56570', NULL, NULL, NULL, NULL, NULL, 4),
(50386, NULL, 'G3DSA:1.20.1070.10:FF:000595', NULL, NULL, 'Substance-P receptor', NULL, NULL, NULL, NULL, NULL, 4),
(50387, NULL, 'G3DSA:1.10.630.10:FF:000771', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50388, NULL, 'G3DSA:1.20.1250.20:FF:000696', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(50389, NULL, 'G3DSA:2.60.40.150:FF:000173', NULL, NULL, 'Calpain 5b', NULL, NULL, NULL, NULL, NULL, 4),
(50390, NULL, 'G3DSA:3.40.50.11980:FF:000013', NULL, NULL, 'mitochondrial ribonuclease P catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(50391, NULL, 'G3DSA:2.60.40.10:FF:006010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50392, NULL, 'G3DSA:3.30.40.10:FF:000787', NULL, NULL, 'Os02g0130300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(50393, NULL, 'G3DSA:3.40.50.1820:FF:000838', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50394, NULL, 'G3DSA:3.80.10.10:FF:004386', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(50395, NULL, 'G3DSA:2.60.120.10:FF:000273', NULL, NULL, 'Cysteine dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(50396, NULL, 'G3DSA:3.40.1030.10:FF:000002', NULL, NULL, 'Anthranilate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(50397, NULL, 'G3DSA:3.80.10.10:FF:004268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50398, NULL, 'G3DSA:1.10.238.20:FF:000047', NULL, NULL, 'AGAP012319-PA', NULL, NULL, NULL, NULL, NULL, 4),
(50399, NULL, 'G3DSA:3.40.50.300:FF:000007', NULL, NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(50400, NULL, 'G3DSA:2.40.10.10:FF:000511', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50401, NULL, 'G3DSA:1.25.40.10:FF:004688', NULL, NULL, 'Pre-mRNA-splicing factor CLF1', NULL, NULL, NULL, NULL, NULL, 4),
(50402, NULL, 'G3DSA:2.40.50.140:FF:001233', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50403, NULL, 'G3DSA:3.20.20.190:FF:000169', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50404, NULL, 'G3DSA:1.20.5.1430:FF:000002', NULL, NULL, 'microtubule-associated protein RP/EB family member 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(50405, NULL, 'G3DSA:3.40.50.1000:FF:000126', NULL, NULL, 'Cytosolic purine 5-nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(50406, NULL, 'G3DSA:1.10.238.10:FF:000044', NULL, NULL, 'Protein S100', NULL, NULL, NULL, NULL, NULL, 4),
(50407, NULL, 'G3DSA:2.102.10.10:FF:000037', NULL, NULL, 'Benzoate 1,2-dioxygenase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(50408, NULL, 'G3DSA:1.50.40.10:FF:000088', NULL, NULL, 'Mitochondrial carrier protein RIM2', NULL, NULL, NULL, NULL, NULL, 4),
(50409, NULL, 'G3DSA:3.30.70.330:FF:002001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50410, NULL, 'G3DSA:3.40.50.300:FF:003498', NULL, NULL, 'Si:dkey-73p2.2', NULL, NULL, NULL, NULL, NULL, 4),
(50411, NULL, 'G3DSA:2.130.10.10:FF:006021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50412, NULL, 'G3DSA:3.90.470.20:FF:000044', NULL, NULL, 'Holo-[acyl-carrier-protein] synthase', NULL, NULL, NULL, NULL, NULL, 4),
(50413, NULL, 'G3DSA:3.60.20.10:FF:000099', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(50414, NULL, 'G3DSA:1.20.120.1900:FF:000061', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(50415, NULL, 'G3DSA:1.10.510.10:FF:003842', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50416, NULL, 'G3DSA:3.40.720.10:FF:000336', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50417, NULL, 'G3DSA:3.30.160.60:FF:002215', NULL, NULL, 'Zinc finger protein 544', NULL, NULL, NULL, NULL, NULL, 4),
(50418, NULL, 'G3DSA:3.90.1750.10:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50419, NULL, 'G3DSA:3.80.10.10:FF:002177', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(50420, NULL, 'G3DSA:3.65.10.20:FF:000012', NULL, NULL, 'RNA 3''-terminal phosphate cyclase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50421, NULL, 'G3DSA:3.30.70.100:FF:000072', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(50422, NULL, 'G3DSA:3.40.250.10:FF:000019', NULL, NULL, 'Sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(50423, NULL, 'G3DSA:4.10.280.10:FF:000142', NULL, NULL, 'Spermatogenesis and oogenesis specific basic helix-loop-helix 1', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(50424, NULL, 'G3DSA:1.10.510.10:FF:000026', NULL, NULL, 'Calcium/calmodulin-dependent protein kinase type 1', NULL, NULL, NULL, NULL, NULL, 4),
(50425, NULL, 'G3DSA:2.10.250.10:FF:000007', NULL, NULL, 'calreticulin-like', NULL, NULL, NULL, NULL, NULL, 4),
(50426, NULL, 'G3DSA:3.40.50.1010:FF:000129', NULL, NULL, '6-hydroxy-3-succinoylpyridine hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(50427, NULL, 'G3DSA:3.30.200.20:FF:000100', NULL, NULL, 'Dual specificity mitogen-activated protein kinase kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(50428, NULL, 'G3DSA:2.10.270.10:FF:000008', NULL, NULL, 'Lysin', NULL, NULL, NULL, NULL, NULL, 4),
(50429, NULL, 'G3DSA:3.40.50.300:FF:005858', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50430, NULL, 'G3DSA:3.30.70.890:FF:000055', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(50431, NULL, 'G3DSA:1.20.900.10:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50432, NULL, 'G3DSA:1.10.287.70:FF:000760', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50433, NULL, 'G3DSA:1.10.510.10:FF:000705', NULL, NULL, 'SRSF protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(50434, NULL, 'G3DSA:6.10.140.2150:FF:000002', NULL, NULL, 'Sphinganine-1-phosphate aldolase Bst1', NULL, NULL, NULL, NULL, NULL, 4),
(50435, NULL, 'G3DSA:2.60.40.10:FF:000057', NULL, NULL, 'neural cell adhesion molecule L1', NULL, NULL, NULL, NULL, NULL, 4),
(50436, NULL, 'G3DSA:1.50.40.10:FF:000324', NULL, NULL, 'Low-CO2-inducible chloroplast envelope protein', NULL, NULL, NULL, NULL, NULL, 4),
(50437, NULL, 'G3DSA:3.30.1520.10:FF:000093', NULL, NULL, 'Vacuolar protein sorting-associated protein vps17', NULL, NULL, NULL, NULL, NULL, 4),
(50438, NULL, 'G3DSA:1.25.40.10:FF:001462', NULL, NULL, 'OJ991214_12.4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(50439, NULL, 'G3DSA:2.10.25.10:FF:000687', NULL, NULL, 'Neurogenic locus notch homolog protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(50440, NULL, 'G3DSA:1.20.5.100:FF:000021', NULL, NULL, 'UDP-glucose/GDP-mannose dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50441, NULL, 'G3DSA:1.20.120.980:FF:000053', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(50442, NULL, 'G3DSA:3.40.718.10:FF:000067', NULL, NULL, 'Isocitrate dehydrogenase [NADP]', NULL, NULL, NULL, NULL, NULL, 4),
(50443, NULL, 'G3DSA:2.60.40.60:FF:000016', NULL, NULL, 'Protocadherin 9', NULL, NULL, NULL, NULL, NULL, 4),
(50444, NULL, 'G3DSA:1.10.510.10:FF:001897', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50445, NULL, 'G3DSA:1.10.150.300:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50446, NULL, 'G3DSA:3.80.10.10:FF:002677', NULL, NULL, 'leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3', NULL, NULL, NULL, NULL, NULL, 4),
(50447, NULL, 'G3DSA:3.30.160.60:FF:004514', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50448, NULL, 'G3DSA:3.40.1110.10:FF:000267', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50449, NULL, 'G3DSA:3.10.20.90:FF:000282', NULL, NULL, 'Blast:Ral guanine nucleotide dissociation stimulator-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(50450, NULL, 'G3DSA:3.40.50.410:FF:000366', NULL, NULL, 'General transcription and DNA repair factor IIH subunit tfb4', NULL, NULL, NULL, NULL, NULL, 4),
(50451, NULL, 'G3DSA:2.30.30.40:FF:000078', NULL, NULL, 'Putative e3 ubiquitin-protein ligase mib2', NULL, NULL, NULL, NULL, NULL, 4),
(50452, NULL, 'G3DSA:3.40.50.300:FF:006201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50453, NULL, 'G3DSA:3.30.70.1230:FF:000119', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(50454, NULL, 'G3DSA:3.90.1290.10:FF:000021', NULL, NULL, 'microtubule-actin cross-linking factor 1 isoform X25', NULL, NULL, NULL, NULL, NULL, 4),
(50455, NULL, 'G3DSA:3.30.420.40:FF:000212', NULL, NULL, 'L-xylulose/3-keto-L-gulonate kinase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(50456, NULL, 'G3DSA:1.10.238.260:FF:000009', NULL, NULL, 'Putative 2-isopropylmalate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(50457, NULL, 'G3DSA:1.10.287.570:FF:000005', NULL, NULL, 'Anion transporter ABTS-2', NULL, NULL, NULL, NULL, NULL, 4),
(50458, NULL, 'G3DSA:2.130.10.10:FF:001816', NULL, NULL, 'WD-repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(50459, NULL, 'G3DSA:2.60.260.20:FF:000140', NULL, NULL, 'DnaJ-related molecular chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(50460, NULL, 'G3DSA:1.20.5.340:FF:000008', NULL, NULL, 'Myosin heavy chain 11', NULL, NULL, NULL, NULL, NULL, 4),
(50461, NULL, 'G3DSA:1.10.3420.10:FF:000001', NULL, NULL, 'Cof family protein', NULL, NULL, NULL, NULL, NULL, 4),
(50462, NULL, 'G3DSA:1.10.760.10:FF:000044', NULL, NULL, 'Cytochrome c2', NULL, NULL, NULL, NULL, NULL, 4),
(50463, NULL, 'G3DSA:3.30.160.60:FF:002480', NULL, NULL, 'Zinc finger protein 1050', NULL, NULL, NULL, NULL, NULL, 4),
(50464, NULL, 'G3DSA:3.40.50.720:FF:000987', NULL, NULL, 'Enoyl-[acyl-carrier-protein] reductase [NADH]', NULL, NULL, NULL, NULL, NULL, 4),
(50465, NULL, 'G3DSA:2.70.130.10:FF:000103', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50466, NULL, 'G3DSA:3.10.110.10:FF:000050', NULL, NULL, 'eIF-2-alpha kinase GCN2', NULL, NULL, NULL, NULL, NULL, 4),
(50467, NULL, 'G3DSA:3.80.10.10:FF:000586', NULL, NULL, 'Blast:Protein toll', NULL, NULL, NULL, NULL, NULL, 4),
(50468, NULL, 'G3DSA:3.40.50.150:FF:000445', NULL, NULL, 'Protein-L-isoaspartate O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(50469, NULL, 'G3DSA:1.20.120.1110:FF:000004', NULL, NULL, 'TBP-associated factor 4, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(50470, NULL, 'G3DSA:1.20.1600.10:FF:000024', NULL, NULL, 'Multidrug efflux transporter outer membrane subunit OpmD', NULL, NULL, NULL, NULL, NULL, 4),
(50471, NULL, 'G3DSA:3.40.50.300:FF:000272', NULL, NULL, 'UvrABC system protein A', NULL, NULL, NULL, NULL, NULL, 4),
(50472, NULL, 'G3DSA:2.10.70.10:FF:000112', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(50473, NULL, 'G3DSA:1.10.555.10:FF:000258', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50474, NULL, 'G3DSA:1.20.120.1100:FF:000001', NULL, NULL, 'Fatty-acid and retinol-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(50475, NULL, 'G3DSA:1.10.167.10:FF:000019', NULL, NULL, 'A-kinase anchor protein 10, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(50476, NULL, 'G3DSA:2.60.120.970:FF:000017', NULL, NULL, 'Bone morphogenetic protein 8a', NULL, NULL, NULL, NULL, NULL, 4),
(50477, NULL, 'G3DSA:1.10.230.10:FF:000015', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(50478, NULL, 'G3DSA:2.60.40.150:FF:000111', NULL, NULL, 'synaptotagmin-5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(50479, NULL, 'G3DSA:2.40.50.100:FF:000018', NULL, NULL, 'p-hydroxybenzoic acid efflux pump subunit AaeA', NULL, NULL, NULL, NULL, NULL, 4),
(50480, NULL, 'G3DSA:3.90.420.10:FF:000004', NULL, NULL, 'Sulfite oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(50481, NULL, 'G3DSA:3.90.1720.10:FF:000009', NULL, NULL, 'Peptidoglycan endopeptidase LytF', NULL, NULL, NULL, NULL, NULL, 4),
(50482, NULL, 'G3DSA:2.40.160.20:FF:000002', NULL, NULL, 'Lipid A palmitoyltransferase PagP', NULL, NULL, NULL, NULL, NULL, 4),
(50483, NULL, 'G3DSA:3.40.50.300:FF:002306', NULL, NULL, 'Grc3p', NULL, NULL, NULL, NULL, NULL, 4),
(50484, NULL, 'G3DSA:1.10.630.10:FF:000563', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50485, NULL, 'G3DSA:3.40.1000.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50486, NULL, 'G3DSA:1.20.1070.10:FF:000707', NULL, NULL, 'Angiotensin II receptor, type 2', NULL, NULL, NULL, NULL, NULL, 4),
(50487, NULL, 'G3DSA:3.80.10.10:FF:001513', NULL, NULL, 'PH domain and leucine rich repeat protein phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(50488, NULL, 'G3DSA:3.40.50.300:FF:000215', NULL, NULL, 'ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(50489, NULL, 'G3DSA:1.20.1070.10:FF:000387', NULL, NULL, 'DOPamine receptor', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(50490, NULL, 'G3DSA:3.90.228.10:FF:000052', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(50491, NULL, 'G3DSA:3.40.50.620:FF:000839', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50492, NULL, 'G3DSA:1.20.1250.20:FF:000808', NULL, NULL, 'Sucrose transport protein SUC5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50493, NULL, 'G3DSA:2.60.260.20:FF:000022', NULL, NULL, 'HSP40, subfamily A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50494, NULL, 'G3DSA:3.60.10.10:FF:000216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50495, NULL, 'G3DSA:1.10.472.80:FF:000047', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(50496, NULL, 'G3DSA:3.90.550.10:FF:000250', NULL, NULL, 'Glycosyl transferase, group 2 family', NULL, NULL, NULL, NULL, NULL, 4),
(50497, NULL, 'G3DSA:2.130.10.10:FF:003879', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50498, NULL, 'G3DSA:1.20.970.10:FF:000030', NULL, NULL, 'Anthranilate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(50499, NULL, 'G3DSA:1.10.8.270:FF:000107', NULL, NULL, 'TBC1 domain family member 28', NULL, NULL, NULL, NULL, NULL, 4),
(50500, NULL, 'G3DSA:2.40.290.10:FF:000003', NULL, NULL, 'RNA-binding motif protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(50501, NULL, 'G3DSA:3.40.50.2300:FF:000825', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50502, NULL, 'G3DSA:3.40.50.10140:FF:000063', NULL, NULL, 'Interleukin 1 receptor accessory protein', NULL, NULL, NULL, NULL, NULL, 4),
(50503, NULL, 'G3DSA:3.40.1810.10:FF:000034', NULL, NULL, 'Os09g0116000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(50504, NULL, 'G3DSA:1.10.10.10:FF:000060', NULL, NULL, 'DNA-binding transcriptional regulator HexR', NULL, NULL, NULL, NULL, NULL, 4),
(50505, NULL, 'G3DSA:1.20.1070.10:FF:001051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50506, NULL, 'G3DSA:2.30.29.30:FF:000768', NULL, NULL, 'Protein CBG15745', NULL, NULL, NULL, NULL, NULL, 4),
(50507, NULL, 'G3DSA:3.40.50.150:FF:001463', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50508, NULL, 'G3DSA:1.10.10.10:FF:000116', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC6', NULL, NULL, NULL, NULL, NULL, 4),
(50509, NULL, 'G3DSA:2.10.25.10:FF:001204', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(50510, NULL, 'G3DSA:2.30.30.140:FF:000169', NULL, NULL, 'DNA (cytosine-5-)-methyltransferase 3 beta, duplicate b.2', NULL, NULL, NULL, NULL, NULL, 4),
(50511, NULL, 'G3DSA:3.60.20.10:FF:000245', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50512, NULL, 'G3DSA:3.10.590.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50513, NULL, 'G3DSA:1.10.132.30:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50514, NULL, 'G3DSA:2.130.10.10:FF:001463', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(50515, NULL, 'G3DSA:2.10.90.10:FF:000175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50516, NULL, 'G3DSA:3.30.9.10:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50517, NULL, 'G3DSA:2.60.120.10:FF:000773', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50518, NULL, 'G3DSA:3.40.50.1820:FF:000990', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50519, NULL, 'G3DSA:3.80.10.10:FF:004532', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50520, NULL, 'G3DSA:3.40.50.300:FF:002424', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(50521, NULL, 'G3DSA:2.10.220.10:FF:000123', NULL, NULL, 'Fibronectin domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(50522, NULL, 'G3DSA:2.60.40.10:FF:002474', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(50523, NULL, 'G3DSA:2.10.70.10:FF:000230', NULL, NULL, 'Mannose-binding lectin associated serine protease', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(50524, NULL, 'G3DSA:2.60.40.1730:FF:000077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50525, NULL, 'G3DSA:1.20.1250.10:FF:000098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50526, NULL, 'G3DSA:1.20.5.3600:FF:000001', NULL, NULL, 'inner centromere protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(50527, NULL, 'G3DSA:1.10.10.1050:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50528, NULL, 'G3DSA:2.40.150.20:FF:000030', NULL, NULL, '60S ribosomal protein L23', NULL, NULL, NULL, NULL, NULL, 4),
(50529, NULL, 'G3DSA:1.10.287.130:FF:000194', NULL, NULL, 'Sensor histidine kinase, PAS, PAS and PAS domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(50530, NULL, 'G3DSA:1.10.287.110:FF:000244', NULL, NULL, 'Chaperone protein dnaJ 3', NULL, NULL, NULL, NULL, NULL, 4),
(50531, NULL, 'G3DSA:3.10.580.10:FF:000045', NULL, NULL, 'Magnesium and cobalt transporter', NULL, NULL, NULL, NULL, NULL, 4),
(50532, NULL, 'G3DSA:3.30.160.60:FF:000119', NULL, NULL, 'Zinc finger and BTB domain containing 37', NULL, NULL, NULL, NULL, NULL, 4),
(50533, NULL, 'G3DSA:3.30.70.330:FF:002973', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50534, NULL, 'G3DSA:2.40.50.140:FF:001087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50535, NULL, 'G3DSA:3.40.50.300:FF:000625', NULL, NULL, 'Ras-like protein family member 10B', NULL, NULL, NULL, NULL, NULL, 4),
(50536, NULL, 'G3DSA:3.30.760.10:FF:000066', NULL, NULL, 'Eukaryotic translation initiation factor 4E family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(50537, NULL, 'G3DSA:2.60.220.30:FF:000017', NULL, NULL, 'ZO-1 (Zonula Occludens tight junctional protein) Ortholog', NULL, NULL, NULL, NULL, NULL, 4),
(50538, NULL, 'G3DSA:3.30.160.60:FF:004632', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50539, NULL, 'G3DSA:3.30.420.40:FF:000330', NULL, NULL, 'Transcriptional regulator MT0503', NULL, NULL, NULL, NULL, NULL, 4),
(50540, NULL, 'G3DSA:1.10.555.10:FF:000051', NULL, NULL, 'Synapse defective Rho GTPase homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(50541, NULL, 'G3DSA:3.40.50.1100:FF:000246', NULL, NULL, 'Putative truncated L-serine dehydratase YIL168W', NULL, NULL, NULL, NULL, NULL, 4),
(50542, NULL, 'G3DSA:3.40.1360.10:FF:000021', NULL, NULL, 'Type 2 DNA topoisomerase 6 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(50543, NULL, 'G3DSA:3.40.50.10130:FF:000060', NULL, NULL, 'Crossover junction endonuclease eme1', NULL, NULL, NULL, NULL, NULL, 4),
(50544, NULL, 'G3DSA:3.30.70.330:FF:001337', NULL, NULL, 'SART-3/p110 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(50545, NULL, 'G3DSA:3.40.50.300:FF:004987', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50546, NULL, 'G3DSA:3.30.160.60:FF:004161', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50547, NULL, 'G3DSA:2.40.70.10:FF:000341', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50548, NULL, 'G3DSA:3.40.50.300:FF:007393', NULL, NULL, 'SWI/SNF related, matrix associated, actin dependent regulator of chromatin, subfamily a, member 1', NULL, NULL, NULL, NULL, NULL, 4),
(50549, NULL, 'G3DSA:3.40.930.10:FF:000021', NULL, NULL, 'PTS sugar transporter subunit IIA', NULL, NULL, NULL, NULL, NULL, 4),
(50550, NULL, 'G3DSA:3.40.50.720:FF:000723', NULL, NULL, 'Glyoxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(50551, NULL, 'G3DSA:3.40.50.300:FF:004610', NULL, NULL, 'ATP-dependent DNA helicase Dna2', NULL, NULL, NULL, NULL, NULL, 4),
(50552, NULL, 'G3DSA:2.40.70.10:FF:000251', NULL, NULL, 'Probable aspartic-type endopeptidase AFUA_3G01220', NULL, NULL, NULL, NULL, NULL, 4),
(50553, NULL, 'G3DSA:2.30.29.30:FF:000297', NULL, NULL, 'Sorting nexin 31', NULL, NULL, NULL, NULL, NULL, 4),
(50554, NULL, 'G3DSA:3.40.50.800:FF:000096', NULL, NULL, 'Ornithine carbamoyltransferase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(50555, NULL, 'G3DSA:2.60.40.1910:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50556, NULL, 'G3DSA:3.30.200.120:FF:000001', NULL, NULL, 'Serine/threonine-protein kinase CtkA', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(50557, NULL, 'G3DSA:1.20.5.110:FF:000288', NULL, NULL, 'Vesicle transport v-SNARE protein', NULL, NULL, NULL, NULL, NULL, 4),
(50558, NULL, 'G3DSA:3.30.160.60:FF:005296', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50559, NULL, 'G3DSA:3.30.930.10:FF:000192', NULL, NULL, 'Phenylalanyl-tRNA synthetase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(50560, NULL, 'G3DSA:1.10.510.10:FF:001779', NULL, NULL, 'Probable myosin light chain kinase DDB_G0292624', NULL, NULL, NULL, NULL, NULL, 4),
(50561, NULL, 'G3DSA:1.25.40.10:FF:005205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50562, NULL, 'G3DSA:2.60.40.60:FF:000224', NULL, NULL, 'Si:dkey-22o22.2', NULL, NULL, NULL, NULL, NULL, 4),
(50563, NULL, 'G3DSA:2.60.40.640:FF:000106', NULL, NULL, 'Arrestin domain-containing protein C31A2.12', NULL, NULL, NULL, NULL, NULL, 4),
(50564, NULL, 'G3DSA:2.70.150.10:FF:000076', NULL, NULL, 'P-type ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50565, NULL, 'G3DSA:3.30.1330.20:FF:000002', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(50566, NULL, 'G3DSA:3.10.100.10:FF:000223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50567, NULL, 'G3DSA:3.30.70.80:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50568, NULL, 'G3DSA:3.30.190.20:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50569, NULL, 'G3DSA:4.10.320.10:FF:000022', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(50570, NULL, 'G3DSA:1.20.1070.10:FF:001522', NULL, NULL, 'Adenylate cyclase-activating polypeptide 1a (pituitary) receptor type I', NULL, NULL, NULL, NULL, NULL, 4),
(50571, NULL, 'G3DSA:3.80.10.10:FF:000378', NULL, NULL, 'Leucine-rich repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(50572, NULL, 'G3DSA:1.10.238.10:FF:000191', NULL, NULL, 'Calmodulin like 4', NULL, NULL, NULL, NULL, NULL, 4),
(50573, NULL, 'G3DSA:3.20.20.70:FF:000276', NULL, NULL, 'Thiamine-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(50574, NULL, 'G3DSA:1.20.190.50:FF:000015', NULL, NULL, 'Nuclear pore complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(50575, NULL, 'G3DSA:3.90.79.10:FF:000002', NULL, NULL, 'diphosphoinositol polyphosphate phosphohydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(50576, NULL, 'G3DSA:1.25.10.10:FF:000032', NULL, NULL, 'Vac14 homolog (S. cerevisiae)', NULL, NULL, NULL, NULL, NULL, 4),
(50577, NULL, 'G3DSA:3.30.505.10:FF:000013', NULL, NULL, 'SH2 domain-containing protein 3C isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(50578, NULL, 'G3DSA:3.40.1280.30:FF:000026', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(50579, NULL, 'G3DSA:1.10.8.60:FF:000214', NULL, NULL, 'CbbX protein', NULL, NULL, NULL, NULL, NULL, 4),
(50580, NULL, 'G3DSA:1.10.510.10:FF:003724', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50581, NULL, 'G3DSA:1.25.40.10:FF:001669', NULL, NULL, 'Tetratricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(50582, NULL, 'G3DSA:3.40.50.10330:FF:000030', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(50583, NULL, 'G3DSA:2.60.40.10:FF:002002', NULL, NULL, 'FiLamiN (Actin binding protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(50584, NULL, 'G3DSA:2.170.190.11:FF:000022', NULL, NULL, 'Molybdopterin biosynthesis protein (MoeA-2)', NULL, NULL, NULL, NULL, NULL, 4),
(50585, NULL, 'G3DSA:3.30.160.60:FF:005442', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50586, NULL, 'G3DSA:2.10.50.10:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50587, NULL, 'G3DSA:3.90.230.10:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50588, NULL, 'G3DSA:3.40.50.150:FF:000653', NULL, NULL, 'Protein-L-isoaspartate O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(50589, NULL, 'G3DSA:1.10.8.60:FF:000068', NULL, NULL, 'spermatogenesis-associated protein 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(50590, NULL, 'G3DSA:3.30.870.10:FF:000102', NULL, NULL, 'Cardiolipin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(50591, NULL, 'G3DSA:3.30.160.60:FF:000063', NULL, NULL, 'Wilms tumor 1-KTS isoform', NULL, NULL, NULL, NULL, NULL, 4),
(50592, NULL, 'G3DSA:3.30.160.60:FF:004014', NULL, NULL, 'GM23838', NULL, NULL, NULL, NULL, NULL, 4),
(50593, NULL, 'G3DSA:3.10.290.10:FF:000034', NULL, NULL, 'RNA-binding protein S4', NULL, NULL, NULL, NULL, NULL, 4),
(50594, NULL, 'G3DSA:2.60.220.50:FF:000175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50595, NULL, 'G3DSA:1.10.510.10:FF:003578', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50596, NULL, 'G3DSA:2.30.30.140:FF:000315', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50597, NULL, 'G3DSA:3.40.50.300:FF:007449', NULL, NULL, 'ATP-dependent helicase (DinG family)', NULL, NULL, NULL, NULL, NULL, 4),
(50598, NULL, 'G3DSA:3.30.1330.30:FF:000005', NULL, NULL, '40S ribosomal protein S12', NULL, NULL, NULL, NULL, NULL, 4),
(50599, NULL, 'G3DSA:2.130.10.10:FF:002126', NULL, NULL, 'WD40 repeat-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(50600, NULL, 'G3DSA:2.60.40.1090:FF:000019', NULL, NULL, 'Type 1 fimbrial protein subunit FimI', NULL, NULL, NULL, NULL, NULL, 4),
(50601, NULL, 'G3DSA:3.30.40.10:FF:000848', NULL, NULL, 'AGAP001386-PA', NULL, NULL, NULL, NULL, NULL, 4),
(50602, NULL, 'G3DSA:1.20.5.4130:FF:000008', NULL, NULL, 'Disease resistance protein RGA5', NULL, NULL, NULL, NULL, NULL, 4),
(50603, NULL, 'G3DSA:3.30.2350.20:FF:000003', NULL, NULL, 'Pseudouridylate synthase 7 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(50604, NULL, 'G3DSA:1.10.10.140:FF:000005', NULL, NULL, 'Cytochrome c oxidase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(50605, NULL, 'G3DSA:1.10.10.60:FF:001098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50606, NULL, 'G3DSA:3.30.160.60:FF:003609', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50607, NULL, 'G3DSA:2.10.220.10:FF:000213', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(50608, NULL, 'G3DSA:3.60.40.10:FF:000044', NULL, NULL, 'probable protein phosphatase 2C 25', NULL, NULL, NULL, NULL, NULL, 4),
(50609, NULL, 'G3DSA:4.10.400.10:FF:000023', NULL, NULL, 'Low density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(50610, NULL, 'G3DSA:1.25.40.10:FF:003878', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50611, NULL, 'G3DSA:3.30.1460.10:FF:000003', NULL, NULL, 'Type III export apparatus protein', NULL, NULL, NULL, NULL, NULL, 4),
(50612, NULL, 'G3DSA:1.10.730.10:FF:000216', NULL, NULL, 'Valyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(50613, NULL, 'G3DSA:1.10.3430.10:FF:000030', NULL, NULL, 'Rh family, C glycoprotein b', NULL, NULL, NULL, NULL, NULL, 4),
(50614, NULL, 'G3DSA:3.80.10.10:FF:000996', NULL, NULL, 'Os04g0503500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(50615, NULL, 'G3DSA:3.40.30.10:FF:000561', NULL, NULL, 'Periplasmic [Fe] hydrogenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(50616, NULL, 'G3DSA:2.60.40.10:FF:005964', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50617, NULL, 'G3DSA:3.40.50.1820:FF:000428', NULL, NULL, 'YJR098C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(50618, NULL, 'G3DSA:3.40.50.1000:FF:000008', NULL, NULL, 'Plasma membrane ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(50619, NULL, 'G3DSA:3.10.250.10:FF:000026', NULL, NULL, 'Tequila, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(50620, NULL, 'G3DSA:2.70.98.110:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50621, NULL, 'G3DSA:3.40.1800.20:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50622, NULL, 'G3DSA:2.60.40.10:FF:002620', NULL, NULL, 'Down syndrome cell adhesion molecule 3, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(50623, NULL, 'G3DSA:1.10.3720.10:FF:000131', NULL, NULL, 'Molybdenum transport system permease', NULL, NULL, NULL, NULL, NULL, 4),
(50624, NULL, 'G3DSA:3.30.160.60:FF:003851', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(50625, NULL, 'G3DSA:3.20.20.70:FF:000219', NULL, NULL, 'Thiamine phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(50626, NULL, 'G3DSA:1.10.135.10:FF:000002', NULL, NULL, 'creatine kinase S-type, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(50627, NULL, 'G3DSA:3.40.50.1980:FF:000015', NULL, NULL, 'Fe(3+)-hydroxamate ABC transporter substrate-binding protein FhuD', NULL, NULL, NULL, NULL, NULL, 4),
(50628, NULL, 'G3DSA:1.20.1250.20:FF:001213', NULL, NULL, 'MFS transporter, putative (AFU_orthologue AFUA_2G08230)', NULL, NULL, NULL, NULL, NULL, 4),
(50629, NULL, 'G3DSA:3.40.50.300:FF:008264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50630, NULL, 'G3DSA:1.20.1280.170:FF:000010', NULL, NULL, 'Exocyst complex component 7', NULL, NULL, NULL, NULL, NULL, 4),
(50631, NULL, 'G3DSA:1.25.40.10:FF:000888', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(50632, NULL, 'G3DSA:2.60.120.10:FF:000155', NULL, NULL, 'Mannose-6-phosphate isomerase, class I', NULL, NULL, NULL, NULL, NULL, 4),
(50633, NULL, 'G3DSA:3.40.50.150:FF:000092', NULL, NULL, 'Leucine carboxyl methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(50634, NULL, 'G3DSA:1.25.40.20:FF:000071', NULL, NULL, 'E3 ubiquitin-protein ligase MIB2 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(50635, NULL, 'G3DSA:3.90.79.20:FF:000005', NULL, NULL, 'NADH pyrophosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50636, NULL, 'G3DSA:3.30.200.20:FF:001117', NULL, NULL, 'Putative kinase-like protein TMKL1', NULL, NULL, NULL, NULL, NULL, 4),
(50637, NULL, 'G3DSA:4.10.900.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50638, NULL, 'G3DSA:2.130.10.10:FF:005824', NULL, NULL, 'Protein FAN', NULL, NULL, NULL, NULL, NULL, 4),
(50639, NULL, 'G3DSA:2.60.40.10:FF:003194', NULL, NULL, 'Neuron-derived neurotrophic factor', NULL, NULL, NULL, NULL, NULL, 4),
(50640, NULL, 'G3DSA:3.40.50.720:FF:001504', NULL, NULL, 'Putative CDP tyvulose epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(50641, NULL, 'G3DSA:3.80.10.10:FF:001249', NULL, NULL, 'Leucine rich repeats (6 copies)/Leucine Rich repeat', NULL, NULL, NULL, NULL, NULL, 4),
(50642, NULL, 'G3DSA:2.130.10.10:FF:002036', NULL, NULL, 'Unplaced genomic scaffold supercont1.18, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(50643, NULL, 'G3DSA:1.10.472.10:FF:000133', NULL, NULL, 'Putative cyclin-F1-2', NULL, NULL, NULL, NULL, NULL, 4),
(50644, NULL, 'G3DSA:1.10.1220.10:FF:000019', NULL, NULL, 'Antitoxin FitA', NULL, NULL, NULL, NULL, NULL, 4),
(50645, NULL, 'G3DSA:3.30.420.10:FF:000428', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50646, NULL, 'G3DSA:3.40.50.720:FF:000577', NULL, NULL, 'Proline utilization protein PrnX, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50647, NULL, 'G3DSA:3.40.50.1970:FF:000012', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(50648, NULL, 'G3DSA:1.20.920.10:FF:000139', NULL, NULL, 'AT24439p', NULL, NULL, NULL, NULL, NULL, 4),
(50649, NULL, 'G3DSA:3.40.50.150:FF:000035', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(50650, NULL, 'G3DSA:3.60.15.10:FF:000210', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(50651, NULL, 'G3DSA:3.10.450.580:FF:000013', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(50652, NULL, 'G3DSA:2.30.29.30:FF:001078', NULL, NULL, 'Ran-specific GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(50653, NULL, 'G3DSA:3.10.129.10:FF:000188', NULL, NULL, 'Probable acyl-coenzyme a thioester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(50654, NULL, 'G3DSA:3.40.50.300:FF:006055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50655, NULL, 'G3DSA:3.30.70.3270:FF:000006', NULL, NULL, 'NAD(P)H-quinone oxidoreductase subunit I, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(50656, NULL, 'G3DSA:1.25.40.10:FF:005093', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g35130, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(50657, NULL, 'G3DSA:3.10.450.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50658, NULL, 'G3DSA:1.20.1070.10:FF:002186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50659, NULL, 'G3DSA:3.40.190.10:FF:000020', NULL, NULL, 'Histidine ABC transporter substrate-binding periplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(50660, NULL, 'G3DSA:1.20.58.1390:FF:000001', NULL, NULL, 'Methyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(50661, NULL, 'G3DSA:2.60.120.920:FF:000166', NULL, NULL, 'HNRNPUL2-BSCL2 readthrough (NMD candidate)', NULL, NULL, NULL, NULL, NULL, 4),
(50662, NULL, 'G3DSA:3.30.70.330:FF:000202', NULL, NULL, 'HIV Tat-specific factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(50663, NULL, 'G3DSA:3.30.450.30:FF:000003', NULL, NULL, 'ragulator complex protein LAMTOR3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(50664, NULL, 'G3DSA:3.40.50.2300:FF:001606', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50665, NULL, 'G3DSA:3.30.40.10:FF:001304', NULL, NULL, 'Putative oxidoreductase, chloroplastic isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(50666, NULL, 'G3DSA:1.10.10.250:FF:000009', NULL, NULL, '60S ribosomal protein L12', NULL, NULL, NULL, NULL, NULL, 4),
(50667, NULL, 'G3DSA:3.30.60.30:FF:000243', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(50668, NULL, 'G3DSA:4.10.1290.10:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50669, NULL, 'G3DSA:3.30.200.20:FF:001735', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50670, NULL, 'G3DSA:3.60.21.10:FF:000331', NULL, NULL, 'Acid sphingomyelinase-like phosphodiesterase 3a', NULL, NULL, NULL, NULL, NULL, 4),
(50671, NULL, 'G3DSA:3.40.50.2000:FF:000617', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50672, NULL, 'G3DSA:3.90.20.10:FF:000002', NULL, NULL, 'Hemagglutinin', NULL, NULL, NULL, NULL, NULL, 4),
(50673, NULL, 'G3DSA:1.10.390.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50674, NULL, 'G3DSA:3.40.50.1360:FF:000037', NULL, NULL, '6-phosphogluconolactonase', NULL, NULL, NULL, NULL, NULL, 4),
(50675, NULL, 'G3DSA:1.10.220.10:FF:000043', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(50676, NULL, 'G3DSA:3.50.50.60:FF:001105', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(50677, NULL, 'G3DSA:3.40.800.20:FF:000020', NULL, NULL, 'Histone deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(50678, NULL, 'G3DSA:1.10.10.10:FF:001454', NULL, NULL, 'Meiotic recombination protein SPO11-4', NULL, NULL, NULL, NULL, NULL, 4),
(50679, NULL, 'G3DSA:2.130.10.10:FF:000445', NULL, NULL, 'Regulatory-associated protein of TOR 1', NULL, NULL, NULL, NULL, NULL, 4),
(50680, NULL, 'G3DSA:2.30.29.30:FF:000561', NULL, NULL, 'FERM domain (Protein4.1-ezrin-radixin-moesin) family', NULL, NULL, NULL, NULL, NULL, 4),
(50681, NULL, 'G3DSA:3.90.640.10:FF:000280', NULL, NULL, 'Actin-like protein arp5', NULL, NULL, NULL, NULL, NULL, 4),
(50682, NULL, 'G3DSA:3.30.200.20:FF:002399', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50683, NULL, 'G3DSA:3.30.450.350:FF:000002', NULL, NULL, 'Adenylate cyclase, germination specific', NULL, NULL, NULL, NULL, NULL, 4),
(50684, NULL, 'G3DSA:3.30.559.70:FF:000020', NULL, NULL, 'Putative carnitine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(50685, NULL, 'G3DSA:1.10.10.580:FF:000024', NULL, NULL, 'Cohesin subunit rad21', NULL, NULL, NULL, NULL, NULL, 4),
(50686, NULL, 'G3DSA:3.20.20.70:FF:000129', NULL, NULL, 'Probable galactinol--sucrose galactosyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(50687, NULL, 'G3DSA:1.20.1310.10:FF:000131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50688, NULL, 'G3DSA:2.30.30.40:FF:000224', NULL, NULL, 'Src like adaptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(50689, NULL, 'G3DSA:1.10.287.70:FF:000467', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(50690, NULL, 'G3DSA:3.40.50.300:FF:008000', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50691, NULL, 'G3DSA:1.25.40.10:FF:001198', NULL, NULL, 'Transcriptional regulator, LuxR family', NULL, NULL, NULL, NULL, NULL, 4),
(50692, NULL, 'G3DSA:3.30.420.40:FF:000066', NULL, NULL, 'Actin-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(50693, NULL, 'G3DSA:3.40.50.2300:FF:001045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50694, NULL, 'G3DSA:1.20.1070.10:FF:001612', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50695, NULL, 'G3DSA:2.60.120.920:FF:000109', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein U-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(50696, NULL, 'G3DSA:1.10.1410.10:FF:000113', NULL, NULL, 'Nucleolar protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(50697, NULL, 'G3DSA:3.30.420.10:FF:000580', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50698, NULL, 'G3DSA:3.30.1480.10:FF:000009', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(50699, NULL, 'G3DSA:2.60.40.10:FF:003755', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50700, NULL, 'G3DSA:3.80.10.10:FF:002941', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50701, NULL, 'G3DSA:1.20.58.390:FF:000096', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(50702, NULL, 'G3DSA:3.40.50.720:FF:002168', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(50703, NULL, 'G3DSA:4.10.1060.10:FF:000049', NULL, NULL, 'Zn-finger in Ran binding protein and others, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50704, NULL, 'G3DSA:3.30.70.330:FF:001484', NULL, NULL, 'DAZ-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(50705, NULL, 'G3DSA:1.20.1560.10:FF:000762', NULL, NULL, 'Multidrug resistance-associated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50706, NULL, 'G3DSA:3.20.20.60:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50707, NULL, 'G3DSA:3.30.310.130:FF:000006', NULL, NULL, 'Probable ubiquitin-like-specific protease 2B', NULL, NULL, NULL, NULL, NULL, 4),
(50708, NULL, 'G3DSA:2.130.10.10:FF:005206', NULL, NULL, 'WD40-repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(50709, NULL, 'G3DSA:3.90.190.10:FF:000587', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(50710, NULL, 'G3DSA:1.10.10.350:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50711, NULL, 'G3DSA:2.90.10.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50712, NULL, 'G3DSA:1.10.510.10:FF:000998', NULL, NULL, 'Anchored-membrane serine/threonine-protein kinase pknF', NULL, NULL, NULL, NULL, NULL, 4),
(50713, NULL, 'G3DSA:3.40.50.2300:FF:001461', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50714, NULL, 'G3DSA:4.10.110.10:FF:000012', NULL, NULL, 'Epi-1', NULL, NULL, NULL, NULL, NULL, 4),
(50715, NULL, 'G3DSA:3.30.450.20:FF:000377', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(50716, NULL, 'G3DSA:2.130.10.10:FF:003817', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50717, NULL, 'G3DSA:3.60.40.10:FF:000128', NULL, NULL, 'Serine/threonine phosphatase containing a PAS domain', NULL, NULL, NULL, NULL, NULL, 4),
(50718, NULL, 'G3DSA:1.10.260.40:FF:000094', NULL, NULL, 'Transcriptional regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50719, NULL, 'G3DSA:1.20.1250.20:FF:002169', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50720, NULL, 'G3DSA:1.10.510.10:FF:002706', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50721, NULL, 'G3DSA:4.10.400.10:FF:000287', NULL, NULL, 'Low-density lipoprotein receptor-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(50722, NULL, 'G3DSA:3.40.50.300:FF:005768', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(50723, NULL, 'G3DSA:2.60.120.10:FF:000363', NULL, NULL, 'Regulatory subunit of protein kinase a-like protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(50724, NULL, 'G3DSA:1.20.1250.20:FF:000573', NULL, NULL, 'Unplaced genomic scaffold supercont1.138, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(50725, NULL, 'G3DSA:1.50.40.10:FF:000234', NULL, NULL, 'Peroxisomal membrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50726, NULL, 'G3DSA:1.20.1160.20:FF:000009', NULL, NULL, 'Regulator of telomere elongation helicase 1', NULL, NULL, NULL, NULL, NULL, 4),
(50727, NULL, 'G3DSA:1.20.1720.10:FF:000089', NULL, NULL, 'Bcr/CflA family efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(50728, NULL, 'G3DSA:3.30.40.10:FF:002001', NULL, NULL, 'RING-H2 finger protein ATL1I', NULL, NULL, NULL, NULL, NULL, 4),
(50729, NULL, 'G3DSA:3.40.50.720:FF:000487', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(50730, NULL, 'G3DSA:3.40.50.460:FF:000038', NULL, NULL, 'ATP-dependent 6-phosphofructokinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(50731, NULL, 'G3DSA:1.10.630.10:FF:000153', NULL, NULL, 'Os05g0424300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(50732, NULL, 'G3DSA:1.10.8.10:FF:000076', NULL, NULL, 'Ubiquitin associated and SH3 domain containing A', NULL, NULL, NULL, NULL, NULL, 4),
(50733, NULL, 'G3DSA:2.60.40.10:FF:001659', NULL, NULL, 'Terribly reduced optic lobes, isoform AY', NULL, NULL, NULL, NULL, NULL, 4),
(50734, NULL, 'G3DSA:1.10.1760.20:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50735, NULL, 'G3DSA:1.25.10.10:FF:001926', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50736, NULL, 'G3DSA:3.40.50.150:FF:000535', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', NULL, NULL, NULL, NULL, NULL, 4),
(50737, NULL, 'G3DSA:2.10.70.10:FF:000292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50738, NULL, 'G3DSA:3.40.50.450:FF:000035', NULL, NULL, 'Phosphofructokinase, muscle b', NULL, NULL, NULL, NULL, NULL, 4),
(50739, NULL, 'G3DSA:3.40.630.10:FF:000301', NULL, NULL, 'Carboxypeptidase B2 (plasma)', NULL, NULL, NULL, NULL, NULL, 4),
(50740, NULL, 'G3DSA:3.40.50.10380:FF:000022', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(50741, NULL, 'G3DSA:3.30.9.10:FF:000107', NULL, NULL, 'FAD dependent oxidoreductase superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(50742, NULL, 'G3DSA:2.10.25.10:FF:000277', NULL, NULL, 'Thrombospondin 4', NULL, NULL, NULL, NULL, NULL, 4),
(50743, NULL, 'G3DSA:3.20.20.140:FF:000407', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(50744, NULL, 'G3DSA:3.40.50.300:FF:001553', NULL, NULL, 'Snf2-related CBP activator', NULL, NULL, NULL, NULL, NULL, 4),
(50745, NULL, 'G3DSA:3.30.200.20:FF:002314', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50746, NULL, 'G3DSA:3.30.160.60:FF:005852', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50747, NULL, 'G3DSA:2.60.120.620:FF:000020', NULL, NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(50748, NULL, 'G3DSA:1.10.510.10:FF:003639', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50749, NULL, 'G3DSA:1.10.3860.10:FF:000023', NULL, NULL, 'Dicarboxylate/amino acid:cation symporter', NULL, NULL, NULL, NULL, NULL, 4),
(50750, NULL, 'G3DSA:1.20.1070.10:FF:002068', NULL, NULL, 'Olfactory receptor family 10 subfamily D member 3 (putative)', NULL, NULL, NULL, NULL, NULL, 4),
(50751, NULL, 'G3DSA:3.40.1110.10:FF:000183', NULL, NULL, 'Cation-transporter ATPase I CtpI', NULL, NULL, NULL, NULL, NULL, 4),
(50752, NULL, 'G3DSA:3.30.559.30:FF:000025', NULL, NULL, 'Vibriobactin synthetase, amide synthase subunit VibH', NULL, NULL, NULL, NULL, NULL, 4),
(50753, NULL, 'G3DSA:2.60.40.10:FF:002058', NULL, NULL, 'Sidekick, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(50754, NULL, 'G3DSA:3.30.70.1230:FF:000029', NULL, NULL, 'Adenylate cyclase type 2', NULL, NULL, NULL, NULL, NULL, 4),
(50755, NULL, 'G3DSA:3.20.20.70:FF:000394', NULL, NULL, 'Polyketide biosynthesis protein PksE', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(50756, NULL, 'G3DSA:1.10.645.10:FF:000001', NULL, NULL, 'NADH-quinone oxidoreductase subunit C/D', NULL, NULL, NULL, NULL, NULL, 4),
(50757, NULL, 'G3DSA:2.60.40.10:FF:001985', NULL, NULL, 'Hemicentin 2', NULL, NULL, NULL, NULL, NULL, 4),
(50758, NULL, 'G3DSA:1.20.5.340:FF:000042', NULL, NULL, 'NHS like 2', NULL, NULL, NULL, NULL, NULL, 4),
(50759, NULL, 'G3DSA:2.60.40.10:FF:003839', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50760, NULL, 'G3DSA:3.30.497.10:FF:000032', NULL, NULL, 'Putative non-inhibitory serpin-Z11', NULL, NULL, NULL, NULL, NULL, 4),
(50761, NULL, 'G3DSA:2.120.10.80:FF:000270', NULL, NULL, 'Negative regulator of sporulation MDS3', NULL, NULL, NULL, NULL, NULL, 4),
(50762, NULL, 'G3DSA:1.20.920.10:FF:000055', NULL, NULL, 'AAA family ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50763, NULL, 'G3DSA:3.30.420.10:FF:000344', NULL, NULL, 'CAF1 family ribonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50764, NULL, 'G3DSA:2.60.40.10:FF:001715', NULL, NULL, 'Sidekick, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(50765, NULL, 'G3DSA:3.30.420.10:FF:000546', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50766, NULL, 'G3DSA:1.25.40.10:FF:003671', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50767, NULL, 'G3DSA:1.20.1270.50:FF:000004', NULL, NULL, 'alpha-mannosidase 2C1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(50768, NULL, 'G3DSA:1.20.120.140:FF:000037', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(50769, NULL, 'G3DSA:2.130.10.10:FF:005532', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50770, NULL, 'G3DSA:3.40.50.150:FF:000209', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(50771, NULL, 'G3DSA:3.20.20.80:FF:000397', NULL, NULL, 'Amino acid Transporter GlycoProtein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(50772, NULL, 'G3DSA:2.70.150.10:FF:000222', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(50773, NULL, 'G3DSA:1.10.167.10:FF:000053', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(50774, NULL, 'G3DSA:2.130.10.10:FF:005908', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50775, NULL, 'G3DSA:1.20.210.10:FF:000023', NULL, NULL, 'Cox-type terminal oxidase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(50776, NULL, 'G3DSA:1.10.8.10:FF:000278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50777, NULL, 'G3DSA:2.20.25.10:FF:000136', NULL, NULL, 'Peptide-N(4)-(N-acetyl-beta-glucosaminyl)asparagine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(50778, NULL, 'G3DSA:3.40.630.30:FF:000307', NULL, NULL, 'Probable serine/threonine-protein kinase DDB_G0279719', NULL, NULL, NULL, NULL, NULL, 4),
(50779, NULL, 'G3DSA:3.30.470.10:FF:000055', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(50780, NULL, 'G3DSA:2.60.120.200:FF:000776', NULL, NULL, 'Beta-porphyranase B', NULL, NULL, NULL, NULL, NULL, 4),
(50781, NULL, 'G3DSA:2.10.25.10:FF:000923', NULL, NULL, 'GM14656', NULL, NULL, NULL, NULL, NULL, 4),
(50782, NULL, 'G3DSA:2.60.40.10:FF:005880', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50783, NULL, 'G3DSA:1.50.10.10:FF:000053', NULL, NULL, 'Putative glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(50784, NULL, 'G3DSA:1.20.120.1920:FF:000005', NULL, NULL, 'Ubiquitin associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(50785, NULL, 'G3DSA:2.40.170.20:FF:000121', NULL, NULL, 'SusC homolog', NULL, NULL, NULL, NULL, NULL, 4),
(50786, NULL, 'G3DSA:1.10.472.10:FF:000043', NULL, NULL, 'Transcription initiation factor IIB', NULL, NULL, NULL, NULL, NULL, 4),
(50787, NULL, 'G3DSA:1.10.287.110:FF:000305', NULL, NULL, 'Putative chaperone protein DNAj', NULL, NULL, NULL, NULL, NULL, 4),
(50788, NULL, 'G3DSA:3.40.50.620:FF:000873', NULL, NULL, 'Valine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(50789, NULL, 'G3DSA:2.30.30.40:FF:000432', NULL, NULL, 'BAR domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(50790, NULL, 'G3DSA:2.40.10.120:FF:000011', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(50791, NULL, 'G3DSA:3.40.50.1000:FF:000542', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50792, NULL, 'G3DSA:3.80.10.10:FF:002587', NULL, NULL, 'leucine-rich repeat neuronal protein 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(50793, NULL, 'G3DSA:4.10.280.10:FF:000198', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(50794, NULL, 'G3DSA:1.10.630.10:FF:000529', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50795, NULL, 'G3DSA:1.10.287.1240:FF:000005', NULL, NULL, 'Exodeoxyribonuclease I', NULL, NULL, NULL, NULL, NULL, 4),
(50796, NULL, 'G3DSA:1.20.120.1910:FF:000002', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(50797, NULL, 'G3DSA:1.20.58.150:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50798, NULL, 'G3DSA:1.25.10.10:FF:002859', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50799, NULL, 'G3DSA:3.40.710.10:FF:000072', NULL, NULL, 'Alanine rich lipoprotein LppW', NULL, NULL, NULL, NULL, NULL, 4),
(50800, NULL, 'G3DSA:3.40.50.10810:FF:000140', NULL, NULL, 'DNA repair and recombination protein Rhp26p', NULL, NULL, NULL, NULL, NULL, 4),
(50801, NULL, 'G3DSA:6.10.250.3260:FF:000003', NULL, NULL, '60S ribosomal protein L21', NULL, NULL, NULL, NULL, NULL, 4),
(50802, NULL, 'G3DSA:2.60.40.10:FF:005554', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50803, NULL, 'G3DSA:3.90.228.10:FF:000018', NULL, NULL, 'Putative zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(50804, NULL, 'G3DSA:1.10.10.10:FF:000026', NULL, NULL, 'HTH-type transcriptional regulator IscR', NULL, NULL, NULL, NULL, NULL, 4),
(50805, NULL, 'G3DSA:1.25.40.20:FF:001583', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(50806, NULL, 'G3DSA:3.30.160.60:FF:001783', NULL, NULL, 'Zinc finger protein 142', NULL, NULL, NULL, NULL, NULL, 4),
(50807, NULL, 'G3DSA:3.40.50.10190:FF:000353', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50808, NULL, 'G3DSA:3.40.50.1980:FF:000133', NULL, NULL, 'ABC-type transport system periplasmic substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(50809, NULL, 'G3DSA:3.30.160.60:FF:002923', NULL, NULL, 'Asparagine-rich zinc-finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(50810, NULL, 'G3DSA:2.10.90.10:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50811, NULL, 'G3DSA:2.130.10.10:FF:001963', NULL, NULL, 'WD repeat domain phosphoinositide-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(50812, NULL, 'G3DSA:1.25.40.10:FF:001580', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(50813, NULL, 'G3DSA:2.80.10.50:FF:000145', NULL, NULL, 'Lymphocyte antigen 75', NULL, NULL, NULL, NULL, NULL, 4),
(50814, NULL, 'G3DSA:3.50.50.60:FF:000588', NULL, NULL, 'Pyridine nucleotide-disulphide oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50815, NULL, 'G3DSA:3.60.21.10:FF:000062', NULL, NULL, 'Tartrate-resistant acid phosphatase type 5', NULL, NULL, NULL, NULL, NULL, 4),
(50816, NULL, 'G3DSA:1.10.510.10:FF:002330', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50817, NULL, 'G3DSA:3.40.50.720:FF:001920', NULL, NULL, 'Short-chain dehydrogenase/reductase SDR', NULL, NULL, NULL, NULL, NULL, 4),
(50818, NULL, 'G3DSA:1.10.12.10:FF:000008', NULL, NULL, 'Chromodomain Y like 2', NULL, NULL, NULL, NULL, NULL, 4),
(50819, NULL, 'G3DSA:1.20.140.40:FF:000032', NULL, NULL, 'Pectinesterase inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(50820, NULL, 'G3DSA:4.10.1000.10:FF:000074', NULL, NULL, 'GM22131', NULL, NULL, NULL, NULL, NULL, 4),
(50821, NULL, 'G3DSA:2.60.40.340:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50822, NULL, 'G3DSA:3.40.50.300:FF:002216', NULL, NULL, 'ATP-dependent Clp protease', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(50823, NULL, 'G3DSA:1.10.10.10:FF:001605', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50824, NULL, 'G3DSA:3.30.70.330:FF:001719', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50825, NULL, 'G3DSA:1.25.40.10:FF:003406', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(50826, NULL, 'G3DSA:1.20.120.350:FF:000038', NULL, NULL, 'Sodium leak channel non-selective protein', NULL, NULL, NULL, NULL, NULL, 4),
(50827, NULL, 'G3DSA:3.80.10.10:FF:003048', NULL, NULL, 'AGAP009086-PA', NULL, NULL, NULL, NULL, NULL, 4),
(50828, NULL, 'G3DSA:3.40.33.10:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50829, NULL, 'G3DSA:2.30.30.140:FF:000079', NULL, NULL, 'Enhancer of polycomb-like transcription factor protein', NULL, NULL, NULL, NULL, NULL, 4),
(50830, NULL, 'G3DSA:2.60.40.150:FF:000201', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(50831, NULL, 'G3DSA:3.80.10.10:FF:003104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50832, NULL, 'G3DSA:1.10.150.510:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50833, NULL, 'G3DSA:3.30.40.10:FF:001219', NULL, NULL, 'Structure-specific endonuclease subunit SLX1', NULL, NULL, NULL, NULL, NULL, 4),
(50834, NULL, 'G3DSA:3.40.50.300:FF:008202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50835, NULL, 'G3DSA:3.30.420.40:FF:000122', NULL, NULL, 'ARP5 actin-related protein 5 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(50836, NULL, 'G3DSA:3.40.640.10:FF:000217', NULL, NULL, 'Cysteine desulfurase', NULL, NULL, NULL, NULL, NULL, 4),
(50837, NULL, 'G3DSA:1.20.5.190:FF:000031', NULL, NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(50838, NULL, 'G3DSA:1.25.40.10:FF:003176', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(50839, NULL, 'G3DSA:1.20.930.10:FF:000027', NULL, NULL, 'Transcription elongation factor TFIIS', NULL, NULL, NULL, NULL, NULL, 4),
(50840, NULL, 'G3DSA:2.40.50.140:FF:001115', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50841, NULL, 'G3DSA:3.90.1750.10:FF:000040', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(50842, NULL, 'G3DSA:2.60.40.60:FF:000139', NULL, NULL, 'Cadherin-2 preproprotein', NULL, NULL, NULL, NULL, NULL, 4),
(50843, NULL, 'G3DSA:3.40.720.10:FF:000218', NULL, NULL, 'N-acetylgalactosamine 6-sulfatase (GALNS)', NULL, NULL, NULL, NULL, NULL, 4),
(50844, NULL, 'G3DSA:1.10.533.10:FF:000152', NULL, NULL, 'Caspase-8', NULL, NULL, NULL, NULL, NULL, 4),
(50845, NULL, 'G3DSA:4.10.410.10:FF:000052', NULL, NULL, 'CBN-PPN-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(50846, NULL, 'G3DSA:1.20.1270.60:FF:000333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50847, NULL, 'G3DSA:3.40.50.300:FF:007713', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(50848, NULL, 'G3DSA:3.80.10.10:FF:003043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50849, NULL, 'G3DSA:3.40.630.70:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50850, NULL, 'G3DSA:3.20.20.140:FF:000087', NULL, NULL, 'TatD-like deoxyribonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50851, NULL, 'G3DSA:2.130.10.10:FF:004604', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50852, NULL, 'G3DSA:2.130.10.10:FF:001373', NULL, NULL, 'F-box protein MET30', NULL, NULL, NULL, NULL, NULL, 4),
(50853, NULL, 'G3DSA:1.20.58.60:FF:000297', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(50854, NULL, 'G3DSA:3.90.1410.10:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50855, NULL, 'G3DSA:3.30.930.10:FF:000158', NULL, NULL, 'Glycyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(50856, NULL, 'G3DSA:1.20.5.170:FF:000019', NULL, NULL, 'BZIP family transcription factor', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(50857, NULL, 'G3DSA:1.20.58.390:FF:000124', NULL, NULL, 'Protein CBG26995', NULL, NULL, NULL, NULL, NULL, 4),
(50858, NULL, 'G3DSA:2.40.10.10:FF:000242', NULL, NULL, 'chymotrypsinogen A-like', NULL, NULL, NULL, NULL, NULL, 4),
(50859, NULL, 'G3DSA:1.25.40.10:FF:005267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50860, NULL, 'G3DSA:3.40.1110.10:FF:000357', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50861, NULL, 'G3DSA:3.30.505.10:FF:000193', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50862, NULL, 'G3DSA:3.40.430.10:FF:000027', NULL, NULL, 'Riboflavin biosynthesis protein RibD', NULL, NULL, NULL, NULL, NULL, 4),
(50863, NULL, 'G3DSA:3.40.1110.10:FF:000385', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50864, NULL, 'G3DSA:1.10.510.10:FF:001987', NULL, NULL, 'MAP kinase-interacting serine/threonine-protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(50865, NULL, 'G3DSA:2.10.220.10:FF:000062', NULL, NULL, 'Extracellular matrix protein FRAS1', NULL, NULL, NULL, NULL, NULL, 4),
(50866, NULL, 'G3DSA:2.40.30.10:FF:000125', NULL, NULL, 'Ferric reduction oxidase 7', NULL, NULL, NULL, NULL, NULL, 4),
(50867, NULL, 'G3DSA:1.10.630.10:FF:000681', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50868, NULL, 'G3DSA:1.25.40.10:FF:002687', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50869, NULL, 'G3DSA:1.10.540.10:FF:000117', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(50870, NULL, 'G3DSA:3.40.50.300:FF:003677', NULL, NULL, 'Cell death protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(50871, NULL, 'G3DSA:3.30.60.90:FF:000036', NULL, NULL, 'Putative N6-adenosine-methyltransferase with ZZ-type zinc-binding domains', NULL, NULL, NULL, NULL, NULL, 4),
(50872, NULL, 'G3DSA:3.50.50.60:FF:001521', NULL, NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', NULL, NULL, NULL, NULL, NULL, 4),
(50873, NULL, 'G3DSA:3.30.63.20:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50874, NULL, 'G3DSA:3.40.50.1820:FF:001327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50875, NULL, 'G3DSA:3.30.160.60:FF:005526', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50876, NULL, 'G3DSA:1.10.510.10:FF:001841', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50877, NULL, 'G3DSA:3.30.9.10:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50878, NULL, 'G3DSA:2.60.40.150:FF:000257', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(50879, NULL, 'G3DSA:1.10.150.50:FF:000178', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 15', NULL, NULL, NULL, NULL, NULL, 4),
(50880, NULL, 'G3DSA:3.30.63.10:FF:000002', NULL, NULL, 'Guanylate kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(50881, NULL, 'G3DSA:1.20.120.1080:FF:000124', NULL, NULL, 'DEAH-box helicase 16', NULL, NULL, NULL, NULL, NULL, 4),
(50882, NULL, 'G3DSA:3.40.50.1000:FF:000216', NULL, NULL, 'Phosphomannomutase', NULL, NULL, NULL, NULL, NULL, 4),
(50883, NULL, 'G3DSA:2.30.29.30:FF:001314', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(50884, NULL, 'G3DSA:3.40.50.1010:FF:000219', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50885, NULL, 'G3DSA:2.60.120.970:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50886, NULL, 'G3DSA:3.80.10.10:FF:002059', NULL, NULL, 'Leucine-rich repeat receptor protein kinase MSP1', NULL, NULL, NULL, NULL, NULL, 4),
(50887, NULL, 'G3DSA:2.60.300.12:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50888, NULL, 'G3DSA:1.20.1110.10:FF:000065', NULL, NULL, 'Sarcoplasmic/endoplasmic reticulum calcium ATPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(50889, NULL, 'G3DSA:3.10.105.10:FF:000009', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(50890, NULL, 'G3DSA:2.30.30.90:FF:000014', NULL, NULL, 'Diphtheria toxin repressor', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(50891, NULL, 'G3DSA:3.80.10.10:FF:002738', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(50892, NULL, 'G3DSA:3.40.605.10:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50893, NULL, 'G3DSA:2.40.50.150:FF:000011', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(50894, NULL, 'G3DSA:1.25.40.180:FF:000198', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50895, NULL, 'G3DSA:3.40.50.300:FF:001497', NULL, NULL, 'SNF2 family DNA-dependent ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(50896, NULL, 'G3DSA:1.10.510.10:FF:003932', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50897, NULL, 'G3DSA:4.10.400.10:FF:000085', NULL, NULL, 'low-density lipoprotein receptor-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(50898, NULL, 'G3DSA:2.60.120.260:FF:000041', NULL, NULL, 'Reelin', NULL, NULL, NULL, NULL, NULL, 4),
(50899, NULL, 'G3DSA:3.30.160.60:FF:005796', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50900, NULL, 'G3DSA:1.10.510.10:FF:004421', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50901, NULL, 'G3DSA:1.10.1000.11:FF:000015', NULL, NULL, 'GTP exchange factor for ARFs 1', NULL, NULL, NULL, NULL, NULL, 4),
(50902, NULL, 'G3DSA:3.30.70.330:FF:001629', NULL, NULL, 'Nucleolar protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(50903, NULL, 'G3DSA:1.10.287.70:FF:000552', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50904, NULL, 'G3DSA:3.40.50.10190:FF:000263', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(50905, NULL, 'G3DSA:1.10.287.70:FF:000496', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(50906, NULL, 'G3DSA:1.20.1560.10:FF:000554', NULL, NULL, 'Haemolysin secretion ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(50907, NULL, 'G3DSA:1.10.540.10:FF:000090', NULL, NULL, 'GM20419', NULL, NULL, NULL, NULL, NULL, 4),
(50908, NULL, 'G3DSA:2.130.10.130:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50909, NULL, 'G3DSA:3.40.250.10:FF:000194', NULL, NULL, 'Adenylyltransferase and sulfurtransferase MOCS3', NULL, NULL, NULL, NULL, NULL, 4),
(50910, NULL, 'G3DSA:1.10.510.10:FF:000352', NULL, NULL, 'SCY1-like pseudokinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(50911, NULL, 'G3DSA:3.40.1380.20:FF:000025', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(50912, NULL, 'G3DSA:1.10.8.10:FF:000306', NULL, NULL, 'Release factor glutamine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(50913, NULL, 'G3DSA:3.80.10.10:FF:001250', NULL, NULL, 'RE09158p', NULL, NULL, NULL, NULL, NULL, 4),
(50914, NULL, 'G3DSA:3.40.50.620:FF:000457', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(50915, NULL, 'G3DSA:3.30.30.30:FF:000005', NULL, NULL, 'Heat shock protein ssb1', NULL, NULL, NULL, NULL, NULL, 4),
(50916, NULL, 'G3DSA:3.40.50.300:FF:008056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50917, NULL, 'G3DSA:2.30.30.40:FF:000342', NULL, NULL, 'Bzz1p', NULL, NULL, NULL, NULL, NULL, 4),
(50918, NULL, 'G3DSA:3.40.1380.10:FF:000022', NULL, NULL, 'ATP synthase gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(50919, NULL, 'G3DSA:3.30.160.60:FF:003289', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50920, NULL, 'G3DSA:3.30.200.20:FF:001590', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50921, NULL, 'G3DSA:2.130.10.10:FF:004689', NULL, NULL, 'Gll0893 protein', NULL, NULL, NULL, NULL, NULL, 4),
(50922, NULL, 'G3DSA:2.60.120.200:FF:000574', NULL, NULL, 'ALK tyrosine kinase receptor homolog scd-2', NULL, NULL, NULL, NULL, NULL, 4),
(50923, NULL, 'G3DSA:3.60.10.10:FF:000396', NULL, NULL, 'Type I inositol polyphosphate 5-phosphatase 2', NULL, NULL, NULL, NULL, NULL, 4),
(50924, NULL, 'G3DSA:2.10.220.10:FF:000067', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(50925, NULL, 'G3DSA:3.40.50.300:FF:007983', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(50926, NULL, 'G3DSA:3.30.160.60:FF:000506', NULL, NULL, 'Zinc finger protein 23', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(50927, NULL, 'G3DSA:2.20.25.10:FF:000046', NULL, NULL, 'UPF0434 protein Rv1684', NULL, NULL, NULL, NULL, NULL, 4),
(50928, NULL, 'G3DSA:3.90.25.10:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50929, NULL, 'G3DSA:3.10.20.90:FF:000574', NULL, NULL, 'Autophagy-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(50930, NULL, 'G3DSA:2.60.40.10:FF:004003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50931, NULL, 'G3DSA:1.20.120.1220:FF:000008', NULL, NULL, 'Type IV peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(50932, NULL, 'G3DSA:1.25.40.10:FF:002102', NULL, NULL, 'Pentatricopeptide repeat-containing protein103', NULL, NULL, NULL, NULL, NULL, 4),
(50933, NULL, 'G3DSA:3.40.50.300:FF:007836', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(50934, NULL, 'G3DSA:1.20.120.350:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50935, NULL, 'G3DSA:1.10.510.10:FF:000060', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(50936, NULL, 'G3DSA:2.130.10.10:FF:005678', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50937, NULL, 'G3DSA:2.80.10.50:FF:000055', NULL, NULL, 'Fascin', NULL, NULL, NULL, NULL, NULL, 4),
(50938, NULL, 'G3DSA:3.40.980.10:FF:000001', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(50939, NULL, 'G3DSA:3.10.110.10:FF:000111', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(50940, NULL, 'G3DSA:1.10.510.10:FF:001982', NULL, NULL, 'Cyclin-dependent protein kinase-activating kinase', NULL, NULL, NULL, NULL, NULL, 4),
(50941, NULL, 'G3DSA:1.20.1070.10:FF:001814', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50942, NULL, 'G3DSA:3.80.10.10:FF:001103', NULL, NULL, 'Putative internalin', NULL, NULL, NULL, NULL, NULL, 4),
(50943, NULL, 'G3DSA:3.40.630.30:FF:000077', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(50944, NULL, 'G3DSA:3.60.15.10:FF:000002', NULL, NULL, 'Ribonuclease Z', NULL, NULL, NULL, NULL, NULL, 4),
(50945, NULL, 'G3DSA:2.10.25.10:FF:000507', NULL, NULL, 'Crumbs, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(50946, NULL, 'G3DSA:1.10.472.140:FF:000012', NULL, NULL, 'Retinoblastoma-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(50947, NULL, 'G3DSA:3.40.50.1110:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50948, NULL, 'G3DSA:1.20.58.390:FF:000326', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50949, NULL, 'G3DSA:3.10.20.90:FF:000046', NULL, NULL, 'Homocysteine-responsive endoplasmic reticulum-resident ubiquitin-like domain member 2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(50950, NULL, 'G3DSA:2.130.10.10:FF:005588', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50951, NULL, 'G3DSA:2.60.40.1970:FF:000008', NULL, NULL, 'Transcription initiation factor TFIID subunit 14', NULL, NULL, NULL, NULL, NULL, 4),
(50952, NULL, 'G3DSA:1.20.58.390:FF:000034', NULL, NULL, 'Cholinergic receptor nicotinic beta 4 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(50953, NULL, 'G3DSA:3.30.460.10:FF:000144', NULL, NULL, 'Ribosomal silencing factor RsfS', NULL, NULL, NULL, NULL, NULL, 4),
(50954, NULL, 'G3DSA:3.30.40.10:FF:001512', NULL, NULL, 'At1g74990', NULL, NULL, NULL, NULL, NULL, 4),
(50955, NULL, 'G3DSA:1.10.630.10:FF:000653', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50956, NULL, 'G3DSA:3.10.490.10:FF:000015', NULL, NULL, 'Gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(50957, NULL, 'G3DSA:3.40.50.11380:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50958, NULL, 'G3DSA:1.20.58.60:FF:000499', NULL, NULL, 'Protein CBR-SMA-1', NULL, NULL, NULL, NULL, NULL, 4),
(50959, NULL, 'G3DSA:3.30.1950.10:FF:000001', NULL, NULL, 'Sugar ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(50960, NULL, 'G3DSA:3.80.10.10:FF:002733', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(50961, NULL, 'G3DSA:1.10.510.10:FF:004331', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50962, NULL, 'G3DSA:3.30.9.10:FF:000080', NULL, NULL, 'FAD-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(50963, NULL, 'G3DSA:2.60.40.10:FF:002148', NULL, NULL, 'DS cell adhesion molecule', NULL, NULL, NULL, NULL, NULL, 4),
(50964, NULL, 'G3DSA:2.40.240.10:FF:000056', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(50965, NULL, 'G3DSA:3.40.50.10330:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50966, NULL, 'G3DSA:2.70.170.10:FF:000083', NULL, NULL, 'AcetylCholine Receptor', NULL, NULL, NULL, NULL, NULL, 4),
(50967, NULL, 'G3DSA:3.10.20.70:FF:000040', NULL, NULL, 'Glutamine synthetase catalytic region', NULL, NULL, NULL, NULL, NULL, 4),
(50968, NULL, 'G3DSA:3.40.50.1820:FF:001125', NULL, NULL, 'Oligopeptidase B protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50969, NULL, 'G3DSA:2.30.39.10:FF:000084', NULL, NULL, 'Serine protease inhibitor (serpin) 14', NULL, NULL, NULL, NULL, NULL, 4),
(50970, NULL, 'G3DSA:1.20.1270.170:FF:000002', NULL, NULL, 'Stress response kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(50971, NULL, 'G3DSA:2.10.25.10:FF:000777', NULL, NULL, 'neurogenic locus notch homolog protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(50972, NULL, 'G3DSA:3.40.50.1010:FF:000281', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50973, NULL, 'G3DSA:3.40.50.1100:FF:000100', NULL, NULL, '1-aminocyclopropane-1-carboxylate deaminase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(50974, NULL, 'G3DSA:3.10.450.50:FF:000002', NULL, NULL, 'Ras GTPase-activating protein-binding protein 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(50975, NULL, 'G3DSA:1.10.357.90:FF:000007', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(50976, NULL, 'G3DSA:3.40.50.300:FF:004133', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(50977, NULL, 'G3DSA:3.10.490.20:FF:000018', NULL, NULL, 'Dynein heavy chain 5, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(50978, NULL, 'G3DSA:3.40.630.10:FF:000071', NULL, NULL, 'Peptidase M20 domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(50979, NULL, 'G3DSA:1.10.285.10:FF:000007', NULL, NULL, 'NADP-specific glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(50980, NULL, 'G3DSA:1.10.150.340:FF:000004', NULL, NULL, 'Endoplasmin like', NULL, NULL, NULL, NULL, NULL, 4),
(50981, NULL, 'G3DSA:3.40.50.720:FF:002376', NULL, NULL, 'Zinc-type alcohol dehydrogenase-like protein C16A3.02c', NULL, NULL, NULL, NULL, NULL, 4),
(50982, NULL, 'G3DSA:2.40.50.150:FF:000016', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(50983, NULL, 'G3DSA:3.30.420.510:FF:000004', NULL, NULL, 'Fbl, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(50984, NULL, 'G3DSA:3.40.50.720:FF:000807', NULL, NULL, '3-keto-dihydrosphingosine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(50985, NULL, 'G3DSA:1.25.40.20:FF:000127', NULL, NULL, 'Nuclear factor NF-kappa-B p100 subunit isoform b', NULL, NULL, NULL, NULL, NULL, 4),
(50986, NULL, 'G3DSA:2.170.260.10:FF:000015', NULL, NULL, 'Dicer-like 4', NULL, NULL, NULL, NULL, NULL, 4),
(50987, NULL, 'G3DSA:2.130.10.10:FF:005706', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(50988, NULL, 'G3DSA:2.40.100.10:FF:000080', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(50989, NULL, 'G3DSA:3.40.720.10:FF:000246', NULL, NULL, 'Sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(50990, NULL, 'G3DSA:3.40.630.30:FF:000279', NULL, NULL, 'PHD zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(50991, NULL, 'G3DSA:3.30.160.20:FF:000158', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(50992, NULL, 'G3DSA:2.40.40.20:FF:000073', NULL, NULL, 'cDNA FLJ54381, highly similar to Vesicle-fusing ATPase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(50993, NULL, 'G3DSA:2.30.180.10:FF:000137', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(50994, NULL, 'G3DSA:1.25.40.10:FF:000124', NULL, NULL, 'Prolyl 3-hydroxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(50995, NULL, 'G3DSA:3.10.50.40:FF:000027', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(50996, NULL, 'G3DSA:1.20.58.1100:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(50997, NULL, 'G3DSA:1.10.472.10:FF:000015', NULL, NULL, 'Putative cyclin-c', NULL, NULL, NULL, NULL, NULL, 4),
(50998, NULL, 'G3DSA:1.20.1640.10:FF:000032', NULL, NULL, 'MMPL family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(50999, NULL, 'G3DSA:3.30.200.20:FF:001527', NULL, NULL, 'Leucine Rich Repeat family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(51000, NULL, 'G3DSA:3.40.1370.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51001, NULL, 'G3DSA:3.40.50.720:FF:000459', NULL, NULL, 'Dehydrogenase/reductase SDR family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(51002, NULL, 'G3DSA:1.10.506.10:FF:000038', NULL, NULL, 'Bud2p', NULL, NULL, NULL, NULL, NULL, 4),
(51003, NULL, 'G3DSA:1.25.10.10:FF:003348', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51004, NULL, 'G3DSA:3.90.740.10:FF:000051', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(51005, NULL, 'G3DSA:3.40.50.1820:FF:001417', NULL, NULL, 'Protein CBG10455', NULL, NULL, NULL, NULL, NULL, 4),
(51006, NULL, 'G3DSA:3.10.20.90:FF:000248', NULL, NULL, 'Plexin A, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(51007, NULL, 'G3DSA:1.10.357.70:FF:000001', NULL, NULL, 'Exocyst complex component 3', NULL, NULL, NULL, NULL, NULL, 4),
(51008, NULL, 'G3DSA:1.10.238.10:FF:000426', NULL, NULL, 'Centrin-4', NULL, NULL, NULL, NULL, NULL, 4),
(51009, NULL, 'G3DSA:3.40.30.10:FF:000089', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(51010, NULL, 'G3DSA:3.40.50.300:FF:000423', NULL, NULL, 'ABC transporter ATP-binding protein YbbA', NULL, NULL, NULL, NULL, NULL, 4),
(51011, NULL, 'G3DSA:1.25.10.10:FF:000622', NULL, NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(51012, NULL, 'G3DSA:2.30.29.30:FF:001196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51013, NULL, 'G3DSA:1.10.238.10:FF:000336', NULL, NULL, 'HLH domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(51014, NULL, 'G3DSA:3.20.20.190:FF:000113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51015, NULL, 'G3DSA:3.80.10.10:FF:000940', NULL, NULL, 'Disease resistance RPP8-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(51016, NULL, 'G3DSA:1.25.40.10:FF:001754', NULL, NULL, 'Toll-Interleukin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(51017, NULL, 'G3DSA:3.20.20.140:FF:000379', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51018, NULL, 'G3DSA:3.30.450.200:FF:000013', NULL, NULL, 'DENN domain-containing protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(51019, NULL, 'G3DSA:3.40.50.620:FF:000547', NULL, NULL, 'Electron transfer flavoprotein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(51020, NULL, 'G3DSA:3.30.70.3000:FF:000004', NULL, NULL, 'tRNA(His) guanylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(51021, NULL, 'G3DSA:1.20.120.1080:FF:000129', NULL, NULL, 'Kurz protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51022, NULL, 'G3DSA:3.30.160.60:FF:001491', NULL, NULL, 'Cross-pathway control protein A', NULL, NULL, NULL, NULL, NULL, 4),
(51023, NULL, 'G3DSA:1.10.155.10:FF:000003', NULL, NULL, 'Chemotaxis protein methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(51024, NULL, 'G3DSA:3.30.70.330:FF:001545', NULL, NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(51025, NULL, 'G3DSA:1.10.720.30:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51026, NULL, 'G3DSA:3.90.70.10:FF:000336', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(51027, NULL, 'G3DSA:3.30.160.60:FF:003379', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51028, NULL, 'G3DSA:3.40.1010.10:FF:000001', NULL, NULL, 'Siroheme synthase', NULL, NULL, NULL, NULL, NULL, 4),
(51029, NULL, 'G3DSA:1.10.510.10:FF:000262', NULL, NULL, 'Serine/threonine-protein kinase Nek8', NULL, NULL, NULL, NULL, NULL, 4),
(51030, NULL, 'G3DSA:1.10.20.10:FF:000122', NULL, NULL, 'CCAAT-HAP5 transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(51031, NULL, 'G3DSA:2.60.40.10:FF:001569', NULL, NULL, 'Sallimus, isoform P', NULL, NULL, NULL, NULL, NULL, 4),
(51032, NULL, 'G3DSA:3.20.20.20:FF:000019', NULL, NULL, '5-methyltetrahydrofolate:corrinoid/iron-sulfur protein co-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(51033, NULL, 'G3DSA:2.10.25.10:FF:000272', NULL, NULL, 'neurogenic locus notch homolog protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(51034, NULL, 'G3DSA:3.40.140.10:FF:000073', NULL, NULL, 'COP9 signalosome complex subunit 6a', NULL, NULL, NULL, NULL, NULL, 4),
(51035, NULL, 'G3DSA:3.40.50.300:FF:003970', NULL, NULL, 'Glycosyl transferase family 1', NULL, NULL, NULL, NULL, NULL, 4),
(51036, NULL, 'G3DSA:1.20.58.1250:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51037, NULL, 'G3DSA:3.30.300.30:FF:000083', NULL, NULL, 'acyl-CoA synthetase family member 3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(51038, NULL, 'G3DSA:4.10.410.10:FF:000057', NULL, NULL, 'CRE-MEC-9 protein', NULL, NULL, NULL, NULL, NULL, 4),
(51039, NULL, 'G3DSA:1.10.1420.10:FF:000057', NULL, NULL, 'Mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(51040, NULL, 'G3DSA:2.130.10.10:FF:003880', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51041, NULL, 'G3DSA:3.40.605.10:FF:000086', NULL, NULL, 'Succinate semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(51042, NULL, 'G3DSA:2.40.100.10:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51043, NULL, 'G3DSA:3.30.300.20:FF:000080', NULL, NULL, 'GTPase Era', NULL, NULL, NULL, NULL, NULL, 4),
(51044, NULL, 'G3DSA:1.20.58.2010:FF:000013', NULL, NULL, 'Rop guanine nucleotide exchange factor 7', NULL, NULL, NULL, NULL, NULL, 4),
(51045, NULL, 'G3DSA:1.10.3260.10:FF:000022', NULL, NULL, 'Protein CBR-LIG-4', NULL, NULL, NULL, NULL, NULL, 4),
(51046, NULL, 'G3DSA:3.30.160.60:FF:004840', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51047, NULL, 'G3DSA:3.10.250.10:FF:000144', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51048, NULL, 'G3DSA:2.60.40.10:FF:003637', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51049, NULL, 'G3DSA:2.60.40.1960:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51050, NULL, 'G3DSA:4.10.400.10:FF:000141', NULL, NULL, 'Transmembrane serine protease 4', NULL, NULL, NULL, NULL, NULL, 4),
(51051, NULL, 'G3DSA:3.40.50.800:FF:000067', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(51052, NULL, 'G3DSA:3.10.450.60:FF:000005', NULL, NULL, 'Lipoxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(51053, NULL, 'G3DSA:3.30.9.90:FF:000002', NULL, NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(51054, NULL, 'G3DSA:3.40.50.10330:FF:000086', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(51055, NULL, 'G3DSA:3.30.40.10:FF:000495', NULL, NULL, 'E3 ubiquitin-protein ligase ORTHRUS 2', NULL, NULL, NULL, NULL, NULL, 4),
(51056, NULL, 'G3DSA:2.120.10.90:FF:000003', NULL, NULL, 'DNA topoisomerase 4 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(51057, NULL, 'G3DSA:2.60.40.10:FF:000260', NULL, NULL, 'Muscle, skeletal receptor tyrosine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(51058, NULL, 'G3DSA:1.20.5.110:FF:000232', NULL, NULL, 'Syntaxin-17', NULL, NULL, NULL, NULL, NULL, 4),
(51059, NULL, 'G3DSA:3.40.50.1100:FF:000280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51060, NULL, 'G3DSA:1.10.1450.10:FF:000003', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(51061, NULL, 'G3DSA:3.40.50.620:FF:000783', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51062, NULL, 'G3DSA:3.30.160.60:FF:004222', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51063, NULL, 'G3DSA:2.40.10.10:FF:000040', NULL, NULL, 'Serine protease 23', NULL, NULL, NULL, NULL, NULL, 4),
(51064, NULL, 'G3DSA:3.30.1490.180:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51065, NULL, 'G3DSA:1.25.40.450:FF:000004', NULL, NULL, 'Nuclear pore complex protein Nup155', NULL, NULL, NULL, NULL, NULL, 4),
(51066, NULL, 'G3DSA:1.10.510.10:FF:004275', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51067, NULL, 'G3DSA:1.10.510.10:FF:004005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51068, NULL, 'G3DSA:2.10.25.10:FF:001143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51069, NULL, 'G3DSA:2.70.98.30:FF:000016', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(51070, NULL, 'G3DSA:2.60.40.10:FF:004621', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51071, NULL, 'G3DSA:3.40.1190.20:FF:000106', NULL, NULL, 'Bifunctional NAD(P)H-hydrate repair enzyme Nnr', NULL, NULL, NULL, NULL, NULL, 4),
(51072, NULL, 'G3DSA:3.30.450.40:FF:000040', NULL, NULL, 'Formate hydrogenlyase transcriptional activator', NULL, NULL, NULL, NULL, NULL, 4),
(51073, NULL, 'G3DSA:1.10.8.720:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51074, NULL, 'G3DSA:3.50.30.20:FF:000007', NULL, NULL, 'Carbamoyl-phosphate synthase small chain', NULL, NULL, NULL, NULL, NULL, 4),
(51075, NULL, 'G3DSA:3.30.1330.30:FF:000067', NULL, NULL, 'H/ACA ribonucleoprotein complex subunit 2 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(51076, NULL, 'G3DSA:3.30.750.24:FF:000022', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(51077, NULL, 'G3DSA:3.40.50.10490:FF:000055', NULL, NULL, 'Mitochondrial ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(51078, NULL, 'G3DSA:2.10.25.10:FF:000833', NULL, NULL, 'Drosophila CRumBs homolog', NULL, NULL, NULL, NULL, NULL, 4),
(51079, NULL, 'G3DSA:3.30.450.50:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51080, NULL, 'G3DSA:1.10.1200.10:FF:000018', NULL, NULL, 'Nonribosomal siderophore peptide synthase SidC', NULL, NULL, NULL, NULL, NULL, 4),
(51081, NULL, 'G3DSA:2.70.98.10:FF:000010', NULL, NULL, 'Alpha-1,2-mannosidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(51082, NULL, 'G3DSA:2.60.40.2300:FF:000001', NULL, NULL, 'N-acylsphingosine amidohydrolase 2', NULL, NULL, NULL, NULL, NULL, 4),
(51083, NULL, 'G3DSA:3.30.1370.210:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51084, NULL, 'G3DSA:2.130.10.10:FF:003790', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51085, NULL, 'G3DSA:2.30.39.10:FF:000140', NULL, NULL, 'Serpin peptidase inhibitor 7', NULL, NULL, NULL, NULL, NULL, 4),
(51086, NULL, 'G3DSA:3.80.10.10:FF:001805', NULL, NULL, 'GM16316', NULL, NULL, NULL, NULL, NULL, 4),
(51087, NULL, 'G3DSA:2.60.40.10:FF:000911', NULL, NULL, 'tyrosine-protein kinase receptor Tie-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(51088, NULL, 'G3DSA:1.25.40.10:FF:005323', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51089, NULL, 'G3DSA:3.90.1750.10:FF:000045', NULL, NULL, 'Ubiquitin ligase e3', NULL, NULL, NULL, NULL, NULL, 4),
(51090, NULL, 'G3DSA:3.30.420.310:FF:000001', NULL, NULL, '2-oxo-3-deoxygalactonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(51091, NULL, 'G3DSA:3.40.50.1820:FF:001743', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(51092, NULL, 'G3DSA:1.25.40.440:FF:000001', NULL, NULL, 'Nuclear pore complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(51093, NULL, 'G3DSA:1.20.1250.20:FF:001062', NULL, NULL, 'Uncharacterized transporter YwbF', NULL, NULL, NULL, NULL, NULL, 4),
(51094, NULL, 'G3DSA:3.90.180.10:FF:000199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(51095, NULL, 'G3DSA:3.90.640.10:FF:000279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51096, NULL, 'G3DSA:2.40.170.20:FF:000031', NULL, NULL, 'TonB-dependent heme receptor HasR', NULL, NULL, NULL, NULL, NULL, 4),
(51097, NULL, 'G3DSA:2.60.40.60:FF:000342', NULL, NULL, 'Fat-like cadherin-related tumor suppressor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(51098, NULL, 'G3DSA:2.160.20.80:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51099, NULL, 'G3DSA:3.40.50.1240:FF:000029', NULL, NULL, 'Phosphoglycerate mutase-like protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(51100, NULL, 'G3DSA:3.30.750.44:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51101, NULL, 'G3DSA:3.20.20.10:FF:000016', NULL, NULL, 'D-serine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(51102, NULL, 'G3DSA:3.30.450.60:FF:000046', NULL, NULL, 'Coatomer subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(51103, NULL, 'G3DSA:4.10.91.20:FF:000001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51104, NULL, 'G3DSA:1.50.10.10:FF:000176', NULL, NULL, 'LanC-like protein 3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(51105, NULL, 'G3DSA:2.60.40.10:FF:000350', NULL, NULL, 'Immunoglobulin kappa chain variable 18-36', NULL, NULL, NULL, NULL, NULL, 4),
(51106, NULL, 'G3DSA:4.10.400.10:FF:000231', NULL, NULL, 'LDL receptor repeat-containing protein egg-1', NULL, NULL, NULL, NULL, NULL, 4),
(51107, NULL, 'G3DSA:3.40.50.200:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51108, NULL, 'G3DSA:1.25.40.10:FF:001607', NULL, NULL, 'Os02g0152100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(51109, NULL, 'G3DSA:1.25.10.10:FF:001550', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51110, NULL, 'G3DSA:2.60.130.10:FF:000004', NULL, NULL, 'Protocatechuate 3,4-dioxygenase (PcxB)', NULL, NULL, NULL, NULL, NULL, 4),
(51111, NULL, 'G3DSA:3.40.20.10:FF:000173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51112, NULL, 'G3DSA:3.40.50.1820:FF:001092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51113, NULL, 'G3DSA:1.20.990.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51114, NULL, 'G3DSA:3.30.160.60:FF:005942', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51115, NULL, 'G3DSA:1.20.1250.20:FF:001713', NULL, NULL, 'Os09g0556400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(51116, NULL, 'G3DSA:2.60.200.60:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51117, NULL, 'G3DSA:1.25.40.10:FF:003378', NULL, NULL, 'Intraflagellar transport protein 139', NULL, NULL, NULL, NULL, NULL, 4),
(51118, NULL, 'G3DSA:2.70.98.20:FF:000013', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(51119, NULL, 'G3DSA:1.20.120.1080:FF:000096', NULL, NULL, 'ATP-dependent RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51120, NULL, 'G3DSA:3.40.1110.10:FF:000413', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51121, NULL, 'G3DSA:3.40.50.300:FF:008146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51122, NULL, 'G3DSA:2.160.20.70:FF:000024', NULL, NULL, 'Tubulin binding cofactor C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51123, NULL, 'G3DSA:3.30.810.10:FF:000008', NULL, NULL, 'MSS4p Phosphatidylinositol-4-phosphate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(51124, NULL, 'G3DSA:3.30.780.10:FF:000067', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51125, NULL, 'G3DSA:3.40.50.300:FF:007657', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51126, NULL, 'G3DSA:3.30.420.220:FF:000002', NULL, NULL, 'Pre-mRNA processing ribonucleoprotein, binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(51127, NULL, 'G3DSA:3.50.30.10:FF:000004', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(51128, NULL, 'G3DSA:1.10.238.10:FF:000252', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(51129, NULL, 'G3DSA:1.25.40.10:FF:001670', NULL, NULL, 'WGS project CABT00000000 data, contig 2.13', NULL, NULL, NULL, NULL, NULL, 4),
(51130, NULL, 'G3DSA:3.30.160.60:FF:003525', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(51131, NULL, 'G3DSA:2.70.50.30:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51132, NULL, 'G3DSA:2.80.10.50:FF:000229', NULL, NULL, 'Putative polypeptide N-acetylgalactosaminyltransferase 12', NULL, NULL, NULL, NULL, NULL, 4),
(51133, NULL, 'G3DSA:2.170.210.10:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51134, NULL, 'G3DSA:2.60.120.200:FF:000158', NULL, NULL, 'Chondroitin sulfate proteoglycan 4', NULL, NULL, NULL, NULL, NULL, 4),
(51135, NULL, 'G3DSA:2.60.40.10:FF:005638', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51136, NULL, 'G3DSA:3.30.160.60:FF:003997', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51137, NULL, 'G3DSA:1.25.40.10:FF:003794', NULL, NULL, 'Cytochrome c-type biogenesis protein CycH', NULL, NULL, NULL, NULL, NULL, 4),
(51138, NULL, 'G3DSA:2.60.220.50:FF:000091', NULL, NULL, 'Adhesion G protein-coupled receptor L3', NULL, NULL, NULL, NULL, NULL, 4),
(51139, NULL, 'G3DSA:1.10.3730.20:FF:000022', NULL, NULL, 'Magnesium transporter NIPA2', NULL, NULL, NULL, NULL, NULL, 4),
(51140, NULL, 'G3DSA:1.20.1440.90:FF:000001', NULL, NULL, 'Phosphoenolpyruvate carboxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(51141, NULL, 'G3DSA:1.25.40.10:FF:003850', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51142, NULL, 'G3DSA:2.40.10.190:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51143, NULL, 'G3DSA:3.30.40.10:FF:000579', NULL, NULL, 'Tripartite motif-containing protein 67', NULL, NULL, NULL, NULL, NULL, 4),
(51144, NULL, 'G3DSA:2.10.50.10:FF:000049', NULL, NULL, 'Cysteine repeat modular protein 2 PbCRM2', NULL, NULL, NULL, NULL, NULL, 4),
(51145, NULL, 'G3DSA:2.10.50.10:FF:000105', NULL, NULL, 'TvbS1', NULL, NULL, NULL, NULL, NULL, 4),
(51146, NULL, 'G3DSA:3.40.50.10810:FF:000050', NULL, NULL, 'Snf2-related CBP activator', NULL, NULL, NULL, NULL, NULL, 4),
(51147, NULL, 'G3DSA:2.10.25.10:FF:001620', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51148, NULL, 'G3DSA:3.30.360.10:FF:000052', NULL, NULL, 'Unplaced genomic scaffold supercont1.170, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(51149, NULL, 'G3DSA:3.50.50.100:FF:000046', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51150, NULL, 'G3DSA:3.80.10.10:FF:000794', NULL, NULL, 'Similar to preferentially-expressed antigen in melanoma-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(51151, NULL, 'G3DSA:2.40.10.170:FF:000003', NULL, NULL, 'ATP synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(51152, NULL, 'G3DSA:3.40.50.670:FF:000011', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(51153, NULL, 'G3DSA:1.10.8.960:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51154, NULL, 'G3DSA:3.40.50.300:FF:007567', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51155, NULL, 'G3DSA:3.90.230.10:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51156, NULL, 'G3DSA:3.30.1330.20:FF:000058', NULL, NULL, 'Tubulin gamma chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51157, NULL, 'G3DSA:3.30.1490.20:FF:000075', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(51158, NULL, 'G3DSA:3.60.40.10:FF:000370', NULL, NULL, 'Protein phosphatase 2C 29', NULL, NULL, NULL, NULL, NULL, 4),
(51159, NULL, 'G3DSA:3.30.70.330:FF:002849', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51160, NULL, 'G3DSA:3.30.40.10:FF:000202', NULL, NULL, 'PHD finger protein 10 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(51161, NULL, 'G3DSA:1.20.120.640:FF:000002', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(51162, NULL, 'G3DSA:1.10.340.40:FF:000004', NULL, NULL, 'Zinc finger CCCH domain-containing protein 14', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(51163, NULL, 'G3DSA:3.40.50.12710:FF:000002', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7', NULL, NULL, NULL, NULL, NULL, 4),
(51164, NULL, 'G3DSA:2.120.10.30:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51165, NULL, 'G3DSA:3.30.530.20:FF:000181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51166, NULL, 'G3DSA:1.20.1110.10:FF:000149', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(51167, NULL, 'G3DSA:3.40.250.10:FF:000227', NULL, NULL, 'Thiosulfate/3-mercaptopyruvate sulfurtransferase 1 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(51168, NULL, 'G3DSA:3.30.365.10:FF:000041', NULL, NULL, 'Glyceraldehyde dehydrogenase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(51169, NULL, 'G3DSA:1.10.10.1050:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51170, NULL, 'G3DSA:1.25.40.180:FF:000288', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51171, NULL, 'G3DSA:3.40.140.70:FF:000012', NULL, NULL, 'Ubiquitin-like modifier-activating enzyme ATG7, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51172, NULL, 'G3DSA:3.40.50.2300:FF:001314', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51173, NULL, 'G3DSA:3.40.50.1000:FF:000452', NULL, NULL, 'Haloacid dehalogenase-like hydrolase domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(51174, NULL, 'G3DSA:3.40.50.300:FF:002188', NULL, NULL, 'ATP-dependent helicase STH1/SNF2', NULL, NULL, NULL, NULL, NULL, 4),
(51175, NULL, 'G3DSA:3.30.60.30:FF:000120', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51176, NULL, 'G3DSA:1.25.10.10:FF:000061', NULL, NULL, 'armadillo repeat-containing protein 8 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(51177, NULL, 'G3DSA:1.20.1270.280:FF:000035', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51178, NULL, 'G3DSA:1.20.1270.60:FF:000187', NULL, NULL, 'YALI0E05489p', NULL, NULL, NULL, NULL, NULL, 4),
(51179, NULL, 'G3DSA:3.40.50.300:FF:005476', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51180, NULL, 'G3DSA:3.30.420.10:FF:000198', NULL, NULL, 'Protein RRP6-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(51181, NULL, 'G3DSA:3.50.30.20:FF:000013', NULL, NULL, 'CAD protein', NULL, NULL, NULL, NULL, NULL, 4),
(51182, NULL, 'G3DSA:1.10.472.80:FF:000255', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51183, NULL, 'G3DSA:1.10.510.10:FF:000913', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(51184, NULL, 'G3DSA:2.60.120.920:FF:000082', NULL, NULL, 'Compass component', NULL, NULL, NULL, NULL, NULL, 4),
(51185, NULL, 'G3DSA:3.30.420.10:FF:000254', NULL, NULL, 'Integrase/recombinase core subunit', NULL, NULL, NULL, NULL, NULL, 4),
(51186, NULL, 'G3DSA:2.30.29.30:FF:000499', NULL, NULL, 'Pleckstrin y domain-containing family H member 2', NULL, NULL, NULL, NULL, NULL, 4),
(51187, NULL, 'G3DSA:1.10.1200.260:FF:000002', NULL, NULL, 'Potassium voltage-gated channel subfamily H member 8', NULL, NULL, NULL, NULL, NULL, 4),
(51188, NULL, 'G3DSA:2.60.40.10:FF:005695', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51189, NULL, 'G3DSA:2.60.40.1230:FF:000017', NULL, NULL, 'ADP-ribosylation factor-binding protein GGA1', NULL, NULL, NULL, NULL, NULL, 4),
(51190, NULL, 'G3DSA:3.90.1750.10:FF:000039', NULL, NULL, 'Ubiquitin-protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51191, NULL, 'G3DSA:3.20.20.190:FF:000080', NULL, NULL, 'Glycerophosphoryl diester phosphodiesterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51192, NULL, 'G3DSA:2.40.440.10:FF:000004', NULL, NULL, 'L,D-transpeptidase catalytic domain', NULL, NULL, NULL, NULL, NULL, 4),
(51193, NULL, 'G3DSA:3.50.30.10:FF:000010', NULL, NULL, 'Phosphotransferase system fructose-specific transporter subunit EI/HPr/EIIA', NULL, NULL, NULL, NULL, NULL, 4),
(51194, NULL, 'G3DSA:2.40.50.140:FF:001082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(51195, NULL, 'G3DSA:2.40.50.140:FF:000952', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51196, NULL, 'G3DSA:6.10.140.2220:FF:000079', NULL, NULL, 'SET and MYND domain-containing protein DDB_G0288495', NULL, NULL, NULL, NULL, NULL, 4),
(51197, NULL, 'G3DSA:3.30.830.10:FF:000009', NULL, NULL, 'Presequence protease, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(51198, NULL, 'G3DSA:1.10.287.110:FF:000070', NULL, NULL, 'Endoplasmic reticulum protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51199, NULL, 'G3DSA:2.170.130.20:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51200, NULL, 'G3DSA:3.30.450.40:FF:000242', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(51201, NULL, 'G3DSA:3.40.1350.10:FF:000015', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(51202, NULL, 'G3DSA:3.30.70.20:FF:000033', NULL, NULL, 'Anaerobic sulfite reductase subunit AsrC', NULL, NULL, NULL, NULL, NULL, 4),
(51203, NULL, 'G3DSA:1.20.1280.50:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51204, NULL, 'G3DSA:3.80.10.10:FF:002879', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(51205, NULL, 'G3DSA:2.40.50.100:FF:000081', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(51206, NULL, 'G3DSA:3.40.30.10:FF:001016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51207, NULL, 'G3DSA:1.10.1200.270:FF:000005', NULL, NULL, 'Paraxanthine methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(51208, NULL, 'G3DSA:3.30.160.60:FF:004132', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51209, NULL, 'G3DSA:3.40.1180.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51210, NULL, 'G3DSA:1.10.150.50:FF:000094', NULL, NULL, 'Actin cytoskeleton-regulatory complex protein SLA1', NULL, NULL, NULL, NULL, NULL, 4),
(51211, NULL, 'G3DSA:2.60.40.10:FF:001367', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(51212, NULL, 'G3DSA:3.90.79.10:FF:000204', NULL, NULL, 'Mitochondrial RNA binding complex 1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(51213, NULL, 'G3DSA:3.70.10.10:FF:000081', NULL, NULL, 'DNA polymerase sliding clamp 1', NULL, NULL, NULL, NULL, NULL, 4),
(51214, NULL, 'G3DSA:3.30.70.330:FF:002647', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51215, NULL, 'G3DSA:3.30.457.60:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51216, NULL, 'G3DSA:3.30.60.20:FF:000004', NULL, NULL, 'B-Raf proto-oncogene serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(51217, NULL, 'G3DSA:1.10.10.10:FF:001459', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC6', NULL, NULL, NULL, NULL, NULL, 4),
(51218, NULL, 'G3DSA:2.170.16.10:FF:000018', NULL, NULL, 'DNA-directed RNA polymerase III subunit rpc2', NULL, NULL, NULL, NULL, NULL, 4),
(51219, NULL, 'G3DSA:2.60.200.20:FF:000131', NULL, NULL, 'Adenylate cyclase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(51220, NULL, 'G3DSA:1.25.10.10:FF:000206', NULL, NULL, 'Transportin-1', NULL, NULL, NULL, NULL, NULL, 4),
(51221, NULL, 'G3DSA:2.60.40.60:FF:000611', NULL, NULL, 'Protocadherin gamma B6', NULL, NULL, NULL, NULL, NULL, 4),
(51222, NULL, 'G3DSA:3.30.60.30:FF:000007', NULL, NULL, 'follistatin-related protein 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(51223, NULL, 'G3DSA:3.40.50.1100:FF:000128', NULL, NULL, 'Putative serine-threonine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(51224, NULL, 'G3DSA:1.20.1310.20:FF:000050', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(51225, NULL, 'G3DSA:3.10.20.90:FF:000607', NULL, NULL, 'SF3A1 splicing factor 3a, subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(51226, NULL, 'G3DSA:3.30.160.60:FF:000237', NULL, NULL, 'Krueppel-like factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(51227, NULL, 'G3DSA:1.50.40.10:FF:000526', NULL, NULL, 'Mitochondrial carrier protein-like protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(51228, NULL, 'G3DSA:2.130.10.10:FF:004043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51229, NULL, 'G3DSA:2.60.120.10:FF:000447', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51230, NULL, 'G3DSA:1.20.58.60:FF:000858', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51231, NULL, 'G3DSA:1.10.10.10:FF:001370', NULL, NULL, 'WNK lysine deficient protein kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(51232, NULL, 'G3DSA:3.40.50.10860:FF:000014', NULL, NULL, 'Shikimate 5-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(51233, NULL, 'G3DSA:1.10.8.60:FF:000484', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51234, NULL, 'G3DSA:3.60.21.10:FF:000152', NULL, NULL, 'Nuclease SbcCD subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(51235, NULL, 'G3DSA:3.30.9.10:FF:000254', NULL, NULL, 'L-2-hydroxyglutarate dehydrogenase, mitochondrial-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(51236, NULL, 'G3DSA:1.10.287.130:FF:000076', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(51237, NULL, 'G3DSA:3.40.50.720:FF:001830', NULL, NULL, 'NADP(+) coupled glycerol dehydrogenase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(51238, NULL, 'G3DSA:3.40.630.30:FF:000638', NULL, NULL, 'Uncharacterized N-acetyltransferase C56E4.07', NULL, NULL, NULL, NULL, NULL, 4),
(51239, NULL, 'G3DSA:3.40.50.20:FF:000037', NULL, NULL, 'Ribosomal modification protein rimK like family member A', NULL, NULL, NULL, NULL, NULL, 4),
(51240, NULL, 'G3DSA:3.40.1090.10:FF:000011', NULL, NULL, 'Phospholipase, patatin family', NULL, NULL, NULL, NULL, NULL, 4),
(51241, NULL, 'G3DSA:3.30.1480.10:FF:000004', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(51242, NULL, 'G3DSA:1.25.40.10:FF:004160', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(51243, NULL, 'G3DSA:3.40.50.2300:FF:001371', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51244, NULL, 'G3DSA:2.40.20.10:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51245, NULL, 'G3DSA:3.40.50.1100:FF:000241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51246, NULL, 'G3DSA:1.10.560.10:FF:000063', NULL, NULL, 'T-complex protein 1 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(51247, NULL, 'G3DSA:3.20.20.80:FF:000576', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(51248, NULL, 'G3DSA:1.10.10.60:FF:000232', NULL, NULL, 'homeobox-leucine zipper protein ATHB-13-like', NULL, NULL, NULL, NULL, NULL, 4),
(51249, NULL, 'G3DSA:1.10.30.10:FF:000151', NULL, NULL, 'Kinetoplast-associated protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(51250, NULL, 'G3DSA:1.20.1070.10:FF:000269', NULL, NULL, 'C3a anaphylatoxin chemotactic receptor', NULL, NULL, NULL, NULL, NULL, 4),
(51251, NULL, 'G3DSA:2.40.50.100:FF:000226', NULL, NULL, 'Cytochrome f, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(51252, NULL, 'G3DSA:3.20.10.10:FF:000044', NULL, NULL, 'Slr0887 protein', NULL, NULL, NULL, NULL, NULL, 4),
(51253, NULL, 'G3DSA:1.20.1560.10:FF:000470', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(51254, NULL, 'G3DSA:2.40.20.10:FF:000012', NULL, NULL, 'Phosphoinositide-3-kinase-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(51255, NULL, 'G3DSA:3.30.457.10:FF:000001', NULL, NULL, 'Primary amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(51256, NULL, 'G3DSA:3.20.20.140:FF:000323', NULL, NULL, 'Allantoinase', NULL, NULL, NULL, NULL, NULL, 4),
(51257, NULL, 'G3DSA:3.40.50.2300:FF:000909', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51258, NULL, 'G3DSA:3.30.900.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51259, NULL, 'G3DSA:1.10.533.10:FF:000005', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 21', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(51260, NULL, 'G3DSA:2.60.40.10:FF:003840', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51261, NULL, 'G3DSA:3.30.60.10:FF:000001', NULL, NULL, 'Basic endochitinase', NULL, NULL, NULL, NULL, NULL, 4),
(51262, NULL, 'G3DSA:3.10.20.310:FF:000011', NULL, NULL, 'Protein TOC75-3 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(51263, NULL, 'G3DSA:1.10.287.210:FF:000004', NULL, NULL, 'LPS O-antigen length regulator', NULL, NULL, NULL, NULL, NULL, 4),
(51264, NULL, 'G3DSA:2.30.30.40:FF:000140', NULL, NULL, 'vinexin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(51265, NULL, 'G3DSA:3.40.50.300:FF:000390', NULL, NULL, 'tRNA dimethylallyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(51266, NULL, 'G3DSA:3.30.70.100:FF:000190', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51267, NULL, 'G3DSA:3.30.160.20:FF:000074', NULL, NULL, 'RNA polymerase II C-terminal domain phosphatase-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(51268, NULL, 'G3DSA:1.10.287.110:FF:000272', NULL, NULL, 'Chaperone protein DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(51269, NULL, 'G3DSA:3.30.160.60:FF:000035', NULL, NULL, 'Zinc finger protein ZIC 1', NULL, NULL, NULL, NULL, NULL, 4),
(51270, NULL, 'G3DSA:4.10.400.10:FF:000315', NULL, NULL, 'neurotrypsin-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(51271, NULL, 'G3DSA:3.30.160.60:FF:006021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51272, NULL, 'G3DSA:1.25.10.10:FF:000004', NULL, NULL, 'Pumilio homolog 1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(51273, NULL, 'G3DSA:1.10.150.80:FF:000013', NULL, NULL, 'Bloom syndrome protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(51274, NULL, 'G3DSA:1.10.510.10:FF:002999', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51275, NULL, 'G3DSA:1.10.8.10:FF:000222', NULL, NULL, 'ubiquitin-associated protein 2-like isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(51276, NULL, 'G3DSA:2.60.120.920:FF:000025', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM41 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(51277, NULL, 'G3DSA:3.40.30.10:FF:000145', NULL, NULL, 'thioredoxin-like protein HCF164, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(51278, NULL, 'G3DSA:1.20.5.540:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51279, NULL, 'G3DSA:1.10.8.60:FF:000540', NULL, NULL, 'DNA damage checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(51280, NULL, 'G3DSA:3.10.20.90:FF:000720', NULL, NULL, 'FERM domain-containing protein A', NULL, NULL, NULL, NULL, NULL, 4),
(51281, NULL, 'G3DSA:2.130.10.10:FF:003907', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51282, NULL, 'G3DSA:2.130.10.10:FF:003256', NULL, NULL, 'Polyadenylation factor subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(51283, NULL, 'G3DSA:2.40.50.1010:FF:000001', NULL, NULL, 'tRNA(Ile2) 2-agmatinylcytidine synthetase TiaS', NULL, NULL, NULL, NULL, NULL, 4),
(51284, NULL, 'G3DSA:3.90.320.10:FF:000025', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(51285, NULL, 'G3DSA:1.20.1440.240:FF:000001', NULL, NULL, 'L-amino acid oxidase LaoA', NULL, NULL, NULL, NULL, NULL, 4),
(51286, NULL, 'G3DSA:2.40.10.500:FF:000001', NULL, NULL, 'tripartite motif-containing protein 3-like', NULL, NULL, NULL, NULL, NULL, 4),
(51287, NULL, 'G3DSA:3.40.50.880:FF:000102', NULL, NULL, 'Probable amidotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(51288, NULL, 'G3DSA:3.40.50.300:FF:003767', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(51289, NULL, 'G3DSA:3.40.50.2000:FF:000943', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51290, NULL, 'G3DSA:3.40.50.300:FF:006347', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51291, NULL, 'G3DSA:3.30.160.60:FF:001816', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51292, NULL, 'G3DSA:2.120.10.30:FF:000300', NULL, NULL, 'adipocyte plasma membrane-associated protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(51293, NULL, 'G3DSA:3.40.50.300:FF:000951', NULL, NULL, 'Putative pre-mRNA-splicing factor ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(51294, NULL, 'G3DSA:2.20.70.10:FF:000061', NULL, NULL, 'Rho GTPase activating protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(51295, NULL, 'G3DSA:2.60.40.10:FF:003929', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51296, NULL, 'G3DSA:3.50.50.60:FF:001431', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51297, NULL, 'G3DSA:1.25.10.20:FF:000007', NULL, NULL, 'Crossveinless d', NULL, NULL, NULL, NULL, NULL, 4),
(51298, NULL, 'G3DSA:1.25.40.10:FF:005177', NULL, NULL, 'Tetratricopeptide repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(51299, NULL, 'G3DSA:1.25.40.1030:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51300, NULL, 'G3DSA:2.60.40.60:FF:000140', NULL, NULL, 'Dachsous cadherin-related 1', NULL, NULL, NULL, NULL, NULL, 4),
(51301, NULL, 'G3DSA:4.10.80.10:FF:000001', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(51302, NULL, 'G3DSA:3.30.1610.10:FF:000004', NULL, NULL, 'Nuclear pore complex protein Nup98-Nup96', NULL, NULL, NULL, NULL, NULL, 4),
(51303, NULL, 'G3DSA:3.30.70.330:FF:001068', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(51304, NULL, 'G3DSA:1.10.580.10:FF:000007', NULL, NULL, 'Citrate synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(51305, NULL, 'G3DSA:2.60.120.380:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51306, NULL, 'G3DSA:3.80.10.10:FF:002407', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51307, NULL, 'G3DSA:3.40.1810.10:FF:000039', NULL, NULL, 'Agamous-like MADS-box protein AGL62', NULL, NULL, NULL, NULL, NULL, 4),
(51308, NULL, 'G3DSA:2.110.10.10:FF:000047', NULL, NULL, 'Matrix metallopeptidase 9', NULL, NULL, NULL, NULL, NULL, 4),
(51309, NULL, 'G3DSA:3.30.70.260:FF:000187', NULL, NULL, 'Homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(51310, NULL, 'G3DSA:1.25.40.250:FF:000011', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit K', NULL, NULL, NULL, NULL, NULL, 4),
(51311, NULL, 'G3DSA:3.30.160.60:FF:004076', NULL, NULL, 'LD35343p', NULL, NULL, NULL, NULL, NULL, 4),
(51312, NULL, 'G3DSA:1.20.140.100:FF:000001', NULL, NULL, 'dynein heavy chain 17, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(51313, NULL, 'G3DSA:3.30.70.580:FF:000018', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(51314, NULL, 'G3DSA:2.40.70.10:FF:000015', NULL, NULL, 'Aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(51315, NULL, 'G3DSA:3.40.50.300:FF:007365', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51316, NULL, 'G3DSA:3.30.1120.10:FF:000045', NULL, NULL, 'N-acetyl-galactosamine-6-sulfatase (GALNS)', NULL, NULL, NULL, NULL, NULL, 4),
(51317, NULL, 'G3DSA:1.10.2000.10:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51318, NULL, 'G3DSA:4.10.240.10:FF:000218', NULL, NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(51319, NULL, 'G3DSA:1.25.40.10:FF:000360', NULL, NULL, 'Lysine (K)-specific demethylase 6A, like', NULL, NULL, NULL, NULL, NULL, 4),
(51320, NULL, 'G3DSA:3.40.50.300:FF:005712', NULL, NULL, 'DsRNA-specific nuclease dicer and related ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(51321, NULL, 'G3DSA:1.25.10.10:FF:001842', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51322, NULL, 'G3DSA:2.130.10.10:FF:000243', NULL, NULL, 'Transcription initiation factor TFIID subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(51323, NULL, 'G3DSA:1.20.1070.10:FF:000977', NULL, NULL, 'Protein CBG08799', NULL, NULL, NULL, NULL, NULL, 4),
(51324, NULL, 'G3DSA:3.40.50.720:FF:001302', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(51325, NULL, 'G3DSA:1.25.40.20:FF:000363', NULL, NULL, 'Ankyrin repeat domain 31', NULL, NULL, NULL, NULL, NULL, 4),
(51326, NULL, 'G3DSA:1.25.40.20:FF:000306', NULL, NULL, 'L-asparaginase', NULL, NULL, NULL, NULL, NULL, 4),
(51327, NULL, 'G3DSA:1.20.140.150:FF:000022', NULL, NULL, 'Germ cell-specific 1 protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(51328, NULL, 'G3DSA:4.10.280.10:FF:000018', NULL, NULL, 'Aryl hydrocarbon receptor nuclear translocator-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(51329, NULL, 'G3DSA:3.40.50.1820:FF:000962', NULL, NULL, 'protein NDRG1 isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(51330, NULL, 'G3DSA:2.40.128.490:FF:000001', NULL, NULL, 'TonB family protein', NULL, NULL, NULL, NULL, NULL, 4),
(51331, NULL, 'G3DSA:3.30.2410.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51332, NULL, 'G3DSA:3.90.70.80:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51333, NULL, 'G3DSA:1.20.1270.60:FF:000243', NULL, NULL, 'Islet cell autoantigen, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51334, NULL, 'G3DSA:3.30.230.10:FF:000329', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51335, NULL, 'G3DSA:2.60.120.330:FF:000056', NULL, NULL, 'Flavonol synthase', NULL, NULL, NULL, NULL, NULL, 4),
(51336, NULL, 'G3DSA:3.30.40.10:FF:001186', NULL, NULL, 'Putative Zn-finger domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(51337, NULL, 'G3DSA:2.60.40.10:FF:001895', NULL, NULL, 'PeroXidasiN (Drosophila peroxidase) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(51338, NULL, 'G3DSA:2.60.40.10:FF:001838', NULL, NULL, 'Protein kinase, AMP-activated, beta 1 non-catalytic subunit, b', NULL, NULL, NULL, NULL, NULL, 4),
(51339, NULL, 'G3DSA:3.30.40.10:FF:001506', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51340, NULL, 'G3DSA:3.80.10.10:FF:003430', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51341, NULL, 'G3DSA:1.10.10.730:FF:000002', NULL, NULL, 'Chromosome-partitioning protein ParB', NULL, NULL, NULL, NULL, NULL, 4),
(51342, NULL, 'G3DSA:3.20.20.140:FF:000177', NULL, NULL, 'Similar to carbohydrate esterase family 9 protein', NULL, NULL, NULL, NULL, NULL, 4),
(51343, NULL, 'G3DSA:1.25.10.10:FF:001549', NULL, NULL, 'Exportin-T', NULL, NULL, NULL, NULL, NULL, 4),
(51344, NULL, 'G3DSA:3.40.30.10:FF:000235', NULL, NULL, 'nucleoredoxin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(51345, NULL, 'G3DSA:3.40.50.300:FF:002660', NULL, NULL, 'Nucleotide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(51346, NULL, 'G3DSA:3.40.50.12100:FF:000004', NULL, NULL, 'Putative transmembrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(51347, NULL, 'G3DSA:3.20.20.70:FF:000663', NULL, NULL, 'Deoxyribose-phosphate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(51348, NULL, 'G3DSA:2.30.30.490:FF:000072', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(51349, NULL, 'G3DSA:2.30.29.30:FF:001050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51350, NULL, 'G3DSA:3.90.1490.10:FF:000002', NULL, NULL, 'Diphthine--ammonia ligase', NULL, NULL, NULL, NULL, NULL, 4),
(51351, NULL, 'G3DSA:2.60.40.1170:FF:000072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51352, NULL, 'G3DSA:1.10.3370.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51353, NULL, 'G3DSA:3.20.20.140:FF:000233', NULL, NULL, 'Putative AMP deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(51354, NULL, 'G3DSA:3.40.50.150:FF:001755', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51355, NULL, 'G3DSA:3.40.50.150:FF:001811', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51356, NULL, 'G3DSA:3.40.1160.10:FF:000039', NULL, NULL, 'Glutamate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(51357, NULL, 'G3DSA:2.60.40.1180:FF:000075', NULL, NULL, 'Alpha-xylosidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(51358, NULL, 'G3DSA:3.30.1370.210:FF:000030', NULL, NULL, 'Zinc finger matrin-type protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(51359, NULL, 'G3DSA:1.20.1560.10:FF:000846', NULL, NULL, 'ATP-binding cassette transporter, subfamily B, member 11, group MDR/PGP protein PpABCB11', NULL, NULL, NULL, NULL, NULL, 4),
(51360, NULL, 'G3DSA:2.60.40.10:FF:002822', NULL, NULL, 'Tenascin C', NULL, NULL, NULL, NULL, NULL, 4),
(51361, NULL, 'G3DSA:3.40.50.1460:FF:000039', NULL, NULL, 'Caspase b', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(51362, NULL, 'G3DSA:2.60.40.1180:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51363, NULL, 'G3DSA:2.60.40.10:FF:003278', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(51364, NULL, 'G3DSA:1.25.40.90:FF:000069', NULL, NULL, 'Huntingtin interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(51365, NULL, 'G3DSA:1.10.8.60:FF:000394', NULL, NULL, 'AGAP012537-PA', NULL, NULL, NULL, NULL, NULL, 4),
(51366, NULL, 'G3DSA:1.25.10.10:FF:001752', NULL, NULL, 'Protein VAC14-like', NULL, NULL, NULL, NULL, NULL, 4),
(51367, NULL, 'G3DSA:3.40.50.150:FF:000361', NULL, NULL, 'Ferredoxin-fold anticodon-binding domain-containing protein 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(51368, NULL, 'G3DSA:1.10.510.10:FF:003926', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51369, NULL, 'G3DSA:2.60.40.150:FF:000403', NULL, NULL, 'Unc-13-like protein A', NULL, NULL, NULL, NULL, NULL, 4),
(51370, NULL, 'G3DSA:1.25.40.10:FF:000450', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(51371, NULL, 'G3DSA:2.60.120.590:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51372, NULL, 'G3DSA:3.30.70.260:FF:000097', NULL, NULL, 'Bifunctional (P)ppGpp synthase/hydrolase SpoT', NULL, NULL, NULL, NULL, NULL, 4),
(51373, NULL, 'G3DSA:3.90.730.10:FF:000022', NULL, NULL, 'Rnt2', NULL, NULL, NULL, NULL, NULL, 4),
(51374, NULL, 'G3DSA:2.60.120.10:FF:000537', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51375, NULL, 'G3DSA:1.10.10.10:FF:000352', NULL, NULL, 'Forkhead box Q2', NULL, NULL, NULL, NULL, NULL, 4),
(51376, NULL, 'G3DSA:2.130.10.10:FF:003587', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(51377, NULL, 'G3DSA:3.30.2170.10:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51378, NULL, 'G3DSA:3.80.10.10:FF:003374', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51379, NULL, 'G3DSA:1.25.10.10:FF:001078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51380, NULL, 'G3DSA:3.20.20.80:FF:000666', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51381, NULL, 'G3DSA:3.50.50.60:FF:001228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51382, NULL, 'G3DSA:3.40.50.1440:FF:000033', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(51383, NULL, 'G3DSA:3.20.20.70:FF:000192', NULL, NULL, 'Multifunctional tryptophan biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(51384, NULL, 'G3DSA:1.10.10.10:FF:001931', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51385, NULL, 'G3DSA:4.10.1240.10:FF:000086', NULL, NULL, 'Pituitary adenylate cyclase-activating polypeptide type I receptor', NULL, NULL, NULL, NULL, NULL, 4),
(51386, NULL, 'G3DSA:3.30.930.10:FF:000337', NULL, NULL, 'Alanyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51387, NULL, 'G3DSA:1.25.40.20:FF:000453', NULL, NULL, 'Ankyrin repeat domain 1a (cardiac muscle)', NULL, NULL, NULL, NULL, NULL, 4),
(51388, NULL, 'G3DSA:1.10.10.10:FF:001746', NULL, NULL, 'Transcriptional regulator, MarR family', NULL, NULL, NULL, NULL, NULL, 4),
(51389, NULL, 'G3DSA:3.50.50.60:FF:001285', NULL, NULL, 'Apoptosis-inducing factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(51390, NULL, 'G3DSA:1.10.101.10:FF:000031', NULL, NULL, 'Lytic murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(51391, NULL, 'G3DSA:3.30.40.10:FF:001130', NULL, NULL, 'Ring finger domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51392, NULL, 'G3DSA:3.10.28.10:FF:000040', NULL, NULL, 'Ribonucleoside-diphosphate reductase nrdEB subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(51393, NULL, 'G3DSA:3.90.1410.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51394, NULL, 'G3DSA:3.40.50.1440:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(51395, NULL, 'G3DSA:1.10.510.10:FF:002151', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51396, NULL, 'G3DSA:2.10.10.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51397, NULL, 'G3DSA:1.20.5.110:FF:000086', NULL, NULL, 'Vesicle transport v-SNARE protein VTI1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51398, NULL, 'G3DSA:2.130.10.10:FF:005296', NULL, NULL, 'WD repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51399, NULL, 'G3DSA:2.10.10.100:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51400, NULL, 'G3DSA:2.130.10.10:FF:005386', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51401, NULL, 'G3DSA:1.10.510.10:FF:002061', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(51402, NULL, 'G3DSA:2.70.160.11:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51403, NULL, 'G3DSA:2.40.30.10:FF:000041', NULL, NULL, 'NADPH--cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(51404, NULL, 'G3DSA:3.90.1420.10:FF:000054', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51405, NULL, 'G3DSA:3.30.200.20:FF:001819', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(51406, NULL, 'G3DSA:1.25.40.10:FF:004103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51407, NULL, 'G3DSA:3.40.50.720:FF:001066', NULL, NULL, 'Short-chain dehydrogenase/reductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(51408, NULL, 'G3DSA:3.30.40.10:FF:001220', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(51409, NULL, 'G3DSA:3.40.50.150:FF:000119', NULL, NULL, 'probable pectin methyltransferase QUA2', NULL, NULL, NULL, NULL, NULL, 4),
(51410, NULL, 'G3DSA:2.60.40.10:FF:005077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51411, NULL, 'G3DSA:1.25.40.540:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51412, NULL, 'G3DSA:1.10.1420.10:FF:000001', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(51413, NULL, 'G3DSA:2.70.20.10:FF:000033', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(51414, NULL, 'G3DSA:3.30.499.10:FF:000014', NULL, NULL, 'Aconitate hydratase 1', NULL, NULL, NULL, NULL, NULL, 4),
(51415, NULL, 'G3DSA:3.10.50.10:FF:000069', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51416, NULL, 'G3DSA:1.20.1560.10:FF:000885', NULL, NULL, 'ABC protein, subfamily ABCC', NULL, NULL, NULL, NULL, NULL, 4),
(51417, NULL, 'G3DSA:1.10.287.2900:FF:000008', NULL, NULL, 'AGAP002940-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(51418, NULL, 'G3DSA:2.60.40.10:FF:002204', NULL, NULL, '1,4-alpha-glucan branching enzyme GlgB', NULL, NULL, NULL, NULL, NULL, 4),
(51419, NULL, 'G3DSA:2.60.40.1180:FF:000018', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(51420, NULL, 'G3DSA:3.30.70.330:FF:001158', NULL, NULL, 'RNA-binding protein, mRNA-processing factor 2b', NULL, NULL, NULL, NULL, NULL, 4),
(51421, NULL, 'G3DSA:2.150.10.10:FF:000017', NULL, NULL, 'Putative Mannuronan C-5-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(51422, NULL, 'G3DSA:1.20.58.340:FF:000070', NULL, NULL, 'Cobalt/magnesium transport protein CorA', NULL, NULL, NULL, NULL, NULL, 4),
(51423, NULL, 'G3DSA:1.25.40.70:FF:000063', NULL, NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(51424, NULL, 'G3DSA:3.40.630.30:FF:000133', NULL, NULL, 'Acetyltransferase, GNAT family', NULL, NULL, NULL, NULL, NULL, 4),
(51425, NULL, 'G3DSA:1.10.555.10:FF:000174', NULL, NULL, 'YALI0E07601p', NULL, NULL, NULL, NULL, NULL, 4),
(51426, NULL, 'G3DSA:1.25.40.120:FF:000080', NULL, NULL, 'Rab geranylgeranyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(51427, NULL, 'G3DSA:2.130.10.30:FF:000069', NULL, NULL, 'Serine/threonine-protein kinase-like protein CR4', NULL, NULL, NULL, NULL, NULL, 4),
(51428, NULL, 'G3DSA:1.10.510.10:FF:002004', NULL, NULL, 'NimA-related protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(51429, NULL, 'G3DSA:2.60.120.10:FF:000650', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51430, NULL, 'G3DSA:2.60.40.1180:FF:000221', NULL, NULL, 'Oligosaccharide 4-alpha-D-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(51431, NULL, 'G3DSA:3.40.50.300:FF:000277', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(51432, NULL, 'G3DSA:3.90.1410.10:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51433, NULL, 'G3DSA:1.10.730.10:FF:000132', NULL, NULL, 'Leucyl-tRNA synthetase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(51434, NULL, 'G3DSA:2.40.50.90:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51435, NULL, 'G3DSA:3.10.20.90:FF:000102', NULL, NULL, 'Plexin B2', NULL, NULL, NULL, NULL, NULL, 4),
(51436, NULL, 'G3DSA:4.10.1000.10:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51437, NULL, 'G3DSA:3.40.50.12500:FF:000001', NULL, NULL, 'Putative hydantoin racemase', NULL, NULL, NULL, NULL, NULL, 4),
(51438, NULL, 'G3DSA:3.40.30.10:FF:000292', NULL, NULL, 'Molecular chaperone DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(51439, NULL, 'G3DSA:1.10.3380.10:FF:000054', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51440, NULL, 'G3DSA:3.20.20.70:FF:000753', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51441, NULL, 'G3DSA:2.30.29.30:FF:000645', NULL, NULL, 'FACT complex subunit SSRP1', NULL, NULL, NULL, NULL, NULL, 4),
(51442, NULL, 'G3DSA:3.50.4.10:FF:000001', NULL, NULL, 'Coagulation factor XI', NULL, NULL, NULL, NULL, NULL, 4),
(51443, NULL, 'G3DSA:3.40.50.150:FF:001665', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51444, NULL, 'G3DSA:2.60.40.10:FF:000349', NULL, NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein', NULL, NULL, NULL, NULL, NULL, 4),
(51445, NULL, 'G3DSA:1.10.510.10:FF:003308', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51446, NULL, 'G3DSA:2.40.270.10:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51447, NULL, 'G3DSA:3.30.230.130:FF:000050', NULL, NULL, 'Cullin-4A', NULL, NULL, NULL, NULL, NULL, 4),
(51448, NULL, 'G3DSA:1.25.10.10:FF:001639', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51449, NULL, 'G3DSA:3.40.30.10:FF:000325', NULL, NULL, 'Glutathione S-transferase kappa', NULL, NULL, NULL, NULL, NULL, 4),
(51450, NULL, 'G3DSA:3.40.50.300:FF:000187', NULL, NULL, 'Vesicular-fusion ATPase SEC18', NULL, NULL, NULL, NULL, NULL, 4),
(51451, NULL, 'G3DSA:3.40.50.300:FF:002750', NULL, NULL, 'Cdc3p', NULL, NULL, NULL, NULL, NULL, 4),
(51452, NULL, 'G3DSA:3.80.10.10:FF:003520', NULL, NULL, 'Leucine-rich repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(51453, NULL, 'G3DSA:1.10.3080.10:FF:000014', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(51454, NULL, 'G3DSA:3.30.930.10:FF:000427', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(51455, NULL, 'G3DSA:3.40.50.300:FF:005566', NULL, NULL, 'Dynein heavy chain domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(51456, NULL, 'G3DSA:3.30.160.60:FF:006307', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51457, NULL, 'G3DSA:1.10.510.10:FF:002622', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51458, NULL, 'G3DSA:2.30.29.30:FF:001140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51459, NULL, 'G3DSA:3.20.20.80:FF:000756', NULL, NULL, 'Glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(51460, NULL, 'G3DSA:3.40.50.300:FF:002222', NULL, NULL, 'AFG1-family ATPase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(51461, NULL, 'G3DSA:1.20.1280.50:FF:000117', NULL, NULL, 'F-box/WD repeat-containing protein lin-23', NULL, NULL, NULL, NULL, NULL, 4),
(51462, NULL, 'G3DSA:3.40.33.10:FF:000096', NULL, NULL, 'MIP08535p', NULL, NULL, NULL, NULL, NULL, 4),
(51463, NULL, 'G3DSA:1.25.40.10:FF:001377', NULL, NULL, 'Fleer', NULL, NULL, NULL, NULL, NULL, 4),
(51464, NULL, 'G3DSA:1.10.630.10:FF:000237', NULL, NULL, 'Cytochrome P450 3A9-like', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(51465, NULL, 'G3DSA:3.40.50.300:FF:002042', NULL, NULL, 'ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(51466, NULL, 'G3DSA:2.40.10.10:FF:000039', NULL, NULL, 'Brain-specific serine protease 4', NULL, NULL, NULL, NULL, NULL, 4),
(51467, NULL, 'G3DSA:1.20.120.1080:FF:000040', NULL, NULL, 'ATP-dependent RNA helicase DHX36', NULL, NULL, NULL, NULL, NULL, 4),
(51468, NULL, 'G3DSA:3.30.200.20:FF:001297', NULL, NULL, 'Fibroblast growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(51469, NULL, 'G3DSA:3.30.160.60:FF:002036', NULL, NULL, 'Ras-responsive element-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(51470, NULL, 'G3DSA:3.10.580.10:FF:000129', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51471, NULL, 'G3DSA:3.40.50.2300:FF:001168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51472, NULL, 'G3DSA:3.40.630.30:FF:000223', NULL, NULL, 'GNAT family acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51473, NULL, 'G3DSA:3.20.20.80:FF:000812', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51474, NULL, 'G3DSA:1.10.630.10:FF:000708', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51475, NULL, 'G3DSA:2.130.10.10:FF:001547', NULL, NULL, 'Nuclear distribution protein PAC1', NULL, NULL, NULL, NULL, NULL, 4),
(51476, NULL, 'G3DSA:3.90.780.10:FF:000025', NULL, NULL, 'UDP-sugar hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(51477, NULL, 'G3DSA:2.60.40.10:FF:004391', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51478, NULL, 'G3DSA:2.60.40.10:FF:005728', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51479, NULL, 'G3DSA:1.20.1740.10:FF:000091', NULL, NULL, 'Amino acid permease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(51480, NULL, 'G3DSA:3.40.50.410:FF:000164', NULL, NULL, 'LOC553407 protein', NULL, NULL, NULL, NULL, NULL, 4),
(51481, NULL, 'G3DSA:2.30.29.30:FF:000589', NULL, NULL, 'disabled homolog 1 isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(51482, NULL, 'G3DSA:3.30.160.60:FF:002507', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51483, NULL, 'G3DSA:3.40.50.2000:FF:000797', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51484, NULL, 'G3DSA:4.10.1240.10:FF:000029', NULL, NULL, 'PDF receptor isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(51485, NULL, 'G3DSA:3.30.450.20:FF:000646', NULL, NULL, 'PAS sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(51486, NULL, 'G3DSA:2.60.120.1540:FF:000014', NULL, NULL, 'MHC-linked complement C4', NULL, NULL, NULL, NULL, NULL, 4),
(51487, NULL, 'G3DSA:1.10.510.10:FF:001695', NULL, NULL, 'Ribosomal protein S6 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(51488, NULL, 'G3DSA:1.10.520.10:FF:000032', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(51489, NULL, 'G3DSA:3.40.50.2000:FF:000887', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(51490, NULL, 'G3DSA:3.30.70.2430:FF:000001', NULL, NULL, 'Fatty acid synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(51491, NULL, 'G3DSA:2.10.25.10:FF:000979', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(51492, NULL, 'G3DSA:3.50.50.60:FF:001375', NULL, NULL, 'Probable alkylhalidase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(51493, NULL, 'G3DSA:3.30.310.10:FF:000010', NULL, NULL, 'TATA-box-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(51494, NULL, 'G3DSA:3.40.50.300:FF:006403', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51495, NULL, 'G3DSA:3.30.420.40:FF:000414', NULL, NULL, 'Glycerol kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51496, NULL, 'G3DSA:3.90.190.10:FF:000317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51497, NULL, 'G3DSA:2.40.50.90:FF:000077', NULL, NULL, 'Nuclease domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(51498, NULL, 'G3DSA:3.40.50.1460:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51499, NULL, 'G3DSA:3.90.1480.20:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(51500, NULL, 'G3DSA:1.20.1510.10:FF:000079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51501, NULL, 'G3DSA:3.40.33.10:FF:000039', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51502, NULL, 'G3DSA:3.30.70.330:FF:001214', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase E, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51503, NULL, 'G3DSA:3.40.50.2000:FF:001106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51504, NULL, 'G3DSA:3.90.1200.10:FF:000015', NULL, NULL, 'Choline kinase', NULL, NULL, NULL, NULL, NULL, 4),
(51505, NULL, 'G3DSA:1.20.58.2220:FF:000020', NULL, NULL, 'Formin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(51506, NULL, 'G3DSA:1.20.1740.10:FF:000124', NULL, NULL, 'Y+L amino acid transporter 2', NULL, NULL, NULL, NULL, NULL, 4),
(51507, NULL, 'G3DSA:1.10.10.10:FF:000442', NULL, NULL, 'Transcriptional activator CadC', NULL, NULL, NULL, NULL, NULL, 4),
(51508, NULL, 'G3DSA:3.20.20.370:FF:000010', NULL, NULL, 'Carbohydrate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(51509, NULL, 'G3DSA:3.30.1130.10:FF:000017', NULL, NULL, '7,8-dihydroneopterin aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(51510, NULL, 'G3DSA:1.10.510.10:FF:003640', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51511, NULL, 'G3DSA:1.50.40.10:FF:000240', NULL, NULL, 'WGS project CABT00000000 data, contig 2.3', NULL, NULL, NULL, NULL, NULL, 4),
(51512, NULL, 'G3DSA:3.40.1160.10:FF:000096', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51513, NULL, 'G3DSA:3.30.1360.40:FF:000038', NULL, NULL, 'Ribosome-recycling factor, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(51514, NULL, 'G3DSA:3.40.720.10:FF:000191', NULL, NULL, 'Protein CBG24051', NULL, NULL, NULL, NULL, NULL, 4),
(51515, NULL, 'G3DSA:3.30.450.20:FF:000085', NULL, NULL, 'PAS domain-containing protein tyrosine kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(51516, NULL, 'G3DSA:3.30.70.330:FF:000938', NULL, NULL, 'Ribosome biogenesis (Nop4), putative', NULL, NULL, NULL, NULL, NULL, 4),
(51517, NULL, 'G3DSA:1.25.10.10:FF:001696', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51518, NULL, 'G3DSA:3.40.1110.10:FF:000093', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(51519, NULL, 'G3DSA:2.40.50.140:FF:000300', NULL, NULL, 'Replication protein A1, small', NULL, NULL, NULL, NULL, NULL, 4),
(51520, NULL, 'G3DSA:3.30.70.2450:FF:000007', NULL, NULL, 'Oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51521, NULL, 'G3DSA:1.10.287.370:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51522, NULL, 'G3DSA:3.90.1200.10:FF:000072', NULL, NULL, 'Uncharacterized protein, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(51523, NULL, 'G3DSA:3.40.50.300:FF:002132', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor CFD1', NULL, NULL, NULL, NULL, NULL, 4),
(51524, NULL, 'G3DSA:1.25.40.10:FF:003940', NULL, NULL, 'Clustered mitochondria protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(51525, NULL, 'G3DSA:1.20.1110.10:FF:000239', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51526, NULL, 'G3DSA:2.130.10.10:FF:000097', NULL, NULL, 'WD repeat domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(51527, NULL, 'G3DSA:3.40.50.720:FF:001156', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(51528, NULL, 'G3DSA:1.10.3080.10:FF:000042', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(51529, NULL, 'G3DSA:1.10.1280.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51530, NULL, 'G3DSA:1.25.40.10:FF:003558', NULL, NULL, 'Putative TPR repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(51531, NULL, 'G3DSA:1.10.287.70:FF:000670', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51532, NULL, 'G3DSA:1.10.510.10:FF:003168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51533, NULL, 'G3DSA:3.40.1090.10:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(51534, NULL, 'G3DSA:2.40.50.690:FF:000004', NULL, NULL, 'DIS3-like exonuclease 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(51535, NULL, 'G3DSA:3.10.129.10:FF:000278', NULL, NULL, 'Acyl-CoA thioesterase 7', NULL, NULL, NULL, NULL, NULL, 4),
(51536, NULL, 'G3DSA:2.60.40.10:FF:003750', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51537, NULL, 'G3DSA:3.90.1140.10:FF:000010', NULL, NULL, 'RNA 2'',3''-cyclic phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(51538, NULL, 'G3DSA:4.10.240.10:FF:000139', NULL, NULL, 'C6 transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51539, NULL, 'G3DSA:2.130.10.10:FF:003823', NULL, NULL, 'Uncharacterized WD repeat-containing protein C4F10.18', NULL, NULL, NULL, NULL, NULL, 4),
(51540, NULL, 'G3DSA:4.10.860.120:FF:000001', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(51541, NULL, 'G3DSA:1.10.10.10:FF:001813', NULL, NULL, 'Gll3293 protein', NULL, NULL, NULL, NULL, NULL, 4),
(51542, NULL, 'G3DSA:2.70.150.10:FF:000109', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(51543, NULL, 'G3DSA:3.30.70.330:FF:003131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51544, NULL, 'G3DSA:1.10.10.60:FF:001188', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51545, NULL, 'G3DSA:3.40.50.450:FF:000029', NULL, NULL, 'Diphosphate-fructose-6-phosphate 1-phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(51546, NULL, 'G3DSA:3.10.20.90:FF:000315', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(51547, NULL, 'G3DSA:1.20.1070.10:FF:000943', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51548, NULL, 'G3DSA:3.40.630.30:FF:000346', NULL, NULL, 'N(alpha)-acetyltransferase 40, NatD catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(51549, NULL, 'G3DSA:3.90.190.10:FF:000289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51550, NULL, 'G3DSA:3.30.160.60:FF:000473', NULL, NULL, 'zinc finger protein 14 homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(51551, NULL, 'G3DSA:1.25.40.10:FF:002035', NULL, NULL, 'Tetratricopeptide repeat domain 21B', NULL, NULL, NULL, NULL, NULL, 4),
(51552, NULL, 'G3DSA:1.25.40.10:FF:001467', NULL, NULL, 'Serine/threonine protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51553, NULL, 'G3DSA:2.60.40.1730:FF:000015', NULL, NULL, 'Transcription initiation factor TFIID subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(51554, NULL, 'G3DSA:1.20.1250.10:FF:000036', NULL, NULL, 'Growth hormone d15', NULL, NULL, NULL, NULL, NULL, 4),
(51555, NULL, 'G3DSA:1.20.1160.20:FF:000015', NULL, NULL, 'Regulator of telomere elongation helicase 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(51556, NULL, 'G3DSA:1.10.4030.10:FF:000005', NULL, NULL, 'Chaperone SurA', NULL, NULL, NULL, NULL, NULL, 4),
(51557, NULL, 'G3DSA:1.20.1720.10:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51558, NULL, 'G3DSA:4.10.1170.10:FF:000001', NULL, NULL, 'MAP kinase-activated protein kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(51559, NULL, 'G3DSA:1.25.40.950:FF:000002', NULL, NULL, 'Arf-GAP with SH3 domain, ANK repeat and PH domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(51560, NULL, 'G3DSA:2.60.40.10:FF:005936', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51561, NULL, 'G3DSA:1.10.260.40:FF:000088', NULL, NULL, 'Mu phage transposase OrfB TnpB_MuSo2', NULL, NULL, NULL, NULL, NULL, 4),
(51562, NULL, 'G3DSA:2.40.10.10:FF:000601', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51563, NULL, 'G3DSA:3.30.505.10:FF:000041', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(51564, NULL, 'G3DSA:1.10.1370.40:FF:000011', NULL, NULL, 'Putative cytosolic oligopeptidase A-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(51565, NULL, 'G3DSA:1.10.540.10:FF:000123', NULL, NULL, 'Acryloyl-CoA reductase (NADH)', NULL, NULL, NULL, NULL, NULL, 4),
(51566, NULL, 'G3DSA:3.30.460.10:FF:000026', NULL, NULL, 'Protein Iojap, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(51567, NULL, 'G3DSA:1.10.565.10:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51568, NULL, 'G3DSA:1.25.40.120:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51569, NULL, 'G3DSA:1.10.10.10:FF:001864', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51570, NULL, 'G3DSA:1.25.40.10:FF:002895', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51571, NULL, 'G3DSA:2.60.40.10:FF:003845', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51572, NULL, 'G3DSA:1.10.510.10:FF:004415', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51573, NULL, 'G3DSA:1.20.5.390:FF:000006', NULL, NULL, 'Early endosome antigen 1', NULL, NULL, NULL, NULL, NULL, 4),
(51574, NULL, 'G3DSA:3.10.20.90:FF:000366', NULL, NULL, 'Raf homolog serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(51575, NULL, 'G3DSA:3.40.50.2300:FF:000792', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51576, NULL, 'G3DSA:3.50.50.60:FF:001515', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51577, NULL, 'G3DSA:3.30.160.60:FF:001996', NULL, NULL, 'Zinc finger protein 398', NULL, NULL, NULL, NULL, NULL, 4),
(51578, NULL, 'G3DSA:2.60.120.970:FF:000012', NULL, NULL, 'inhibin beta B chain', NULL, NULL, NULL, NULL, NULL, 4),
(51579, NULL, 'G3DSA:1.20.1440.230:FF:000003', NULL, NULL, 'NADH-quinone oxidoreductase subunit F', NULL, NULL, NULL, NULL, NULL, 4),
(51580, NULL, 'G3DSA:1.20.1250.20:FF:001028', NULL, NULL, 'Solute carrier family 16 member 14', NULL, NULL, NULL, NULL, NULL, 4),
(51581, NULL, 'G3DSA:3.30.565.10:FF:000112', NULL, NULL, 'Two-component system sensor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(51582, NULL, 'G3DSA:2.130.10.10:FF:002300', NULL, NULL, 'WD40 repeat-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(51583, NULL, 'G3DSA:3.90.228.10:FF:000057', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51584, NULL, 'G3DSA:3.30.420.40:FF:000302', NULL, NULL, 'Actin-like protein ARP9', NULL, NULL, NULL, NULL, NULL, 4),
(51585, NULL, 'G3DSA:1.20.920.30:FF:000010', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(51586, NULL, 'G3DSA:1.25.10.10:FF:000184', NULL, NULL, 'HEAT repeat-containing protein 5B', NULL, NULL, NULL, NULL, NULL, 4),
(51587, NULL, 'G3DSA:3.40.50.300:FF:007477', NULL, NULL, 'Brefeldin A resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(51588, NULL, 'G3DSA:3.40.50.720:FF:001482', NULL, NULL, 'YALI0E19657p', NULL, NULL, NULL, NULL, NULL, 4),
(51589, NULL, 'G3DSA:3.30.160.60:FF:005318', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51590, NULL, 'G3DSA:1.10.8.50:FF:000037', NULL, NULL, 'Uncharacterized protein YloA', NULL, NULL, NULL, NULL, NULL, 4),
(51591, NULL, 'G3DSA:2.130.10.10:FF:001199', NULL, NULL, 'Probable cytosolic iron-sulfur protein assembly protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(51592, NULL, 'G3DSA:2.40.30.10:FF:000131', NULL, NULL, 'NADPH-dependent ferric siderophore reductase', NULL, NULL, NULL, NULL, NULL, 4),
(51593, NULL, 'G3DSA:3.80.10.10:FF:003161', NULL, NULL, 'F-box and leucine-rich repeat protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(51594, NULL, 'G3DSA:3.40.850.10:FF:000464', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(51595, NULL, 'G3DSA:3.30.200.20:FF:001645', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51596, NULL, 'G3DSA:2.130.10.10:FF:005852', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51597, NULL, 'G3DSA:1.10.3860.10:FF:000017', NULL, NULL, 'Amino acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(51598, NULL, 'G3DSA:3.90.132.10:FF:000003', NULL, NULL, 'GP63-like', NULL, NULL, NULL, NULL, NULL, 4),
(51599, NULL, 'G3DSA:3.80.10.10:FF:001070', NULL, NULL, 'Leucine-rich repeat transmembrane protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(51600, NULL, 'G3DSA:3.40.50.300:FF:002429', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(51601, NULL, 'G3DSA:2.170.150.20:FF:000010', NULL, NULL, 'Protein yippee-like', NULL, NULL, NULL, NULL, NULL, 4),
(51602, NULL, 'G3DSA:3.30.40.10:FF:001006', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(51603, NULL, 'G3DSA:1.20.120.350:FF:000044', NULL, NULL, 'Potassium voltage-gated channel subfamily V member 1', NULL, NULL, NULL, NULL, NULL, 4),
(51604, NULL, 'G3DSA:1.10.238.10:FF:000600', NULL, NULL, 'Probable calcium-binding protein CML12', NULL, NULL, NULL, NULL, NULL, 4),
(51605, NULL, 'G3DSA:1.50.40.10:FF:000291', NULL, NULL, 'Flavin adenine dinucleotide transporter', NULL, NULL, NULL, NULL, NULL, 4),
(51606, NULL, 'G3DSA:3.20.20.60:FF:000071', NULL, NULL, 'Citryl-CoA lyase', NULL, NULL, NULL, NULL, NULL, 4),
(51607, NULL, 'G3DSA:1.10.630.10:FF:000568', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51608, NULL, 'G3DSA:1.20.120.1160:FF:000002', NULL, NULL, 'Minor nucleoprotein VP30', NULL, NULL, NULL, NULL, NULL, 4),
(51609, NULL, 'G3DSA:1.10.287.1490:FF:000063', NULL, NULL, 'Viral A-type inclusion protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51610, NULL, 'G3DSA:3.40.50.720:FF:000925', NULL, NULL, 'Putative NAD dependent epimerase/dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(51611, NULL, 'G3DSA:2.60.40.10:FF:002322', NULL, NULL, 'macrophage colony-stimulating factor 1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(51612, NULL, 'G3DSA:1.10.510.10:FF:002712', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51613, NULL, 'G3DSA:1.20.910.10:FF:000026', NULL, NULL, 'Transcriptional activator (TenA-2)', NULL, NULL, NULL, NULL, NULL, 4),
(51614, NULL, 'G3DSA:2.20.110.10:FF:000068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51615, NULL, 'G3DSA:1.25.40.10:FF:002361', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(51616, NULL, 'G3DSA:4.10.400.10:FF:000293', NULL, NULL, 'LDL receptor-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(51617, NULL, 'G3DSA:2.120.10.30:FF:000305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51618, NULL, 'G3DSA:3.80.10.10:FF:002267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51619, NULL, 'G3DSA:3.40.50.300:FF:004346', NULL, NULL, 'ATPases involved in chromosome partitioning', NULL, NULL, NULL, NULL, NULL, 4),
(51620, NULL, 'G3DSA:3.40.20.10:FF:000139', NULL, NULL, 'YALI0E34687p', NULL, NULL, NULL, NULL, NULL, 4),
(51621, NULL, 'G3DSA:3.30.70.100:FF:000162', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51622, NULL, 'G3DSA:2.60.40.10:FF:004413', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51623, NULL, 'G3DSA:3.40.30.10:FF:000651', NULL, NULL, 'Thio-Specific Antioxidant (TSA) Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(51624, NULL, 'G3DSA:1.20.1560.10:FF:000913', NULL, NULL, 'ATP binding cassette subfamily B member 8', NULL, NULL, NULL, NULL, NULL, 4),
(51625, NULL, 'G3DSA:3.80.10.10:FF:002946', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51626, NULL, 'G3DSA:3.40.630.20:FF:000017', NULL, NULL, 'Pyroglutamyl-peptidase I (PGP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(51627, NULL, 'G3DSA:1.25.10.10:FF:002207', NULL, NULL, '26S proteasome regulatory subunit rpn1', NULL, NULL, NULL, NULL, NULL, 4),
(51628, NULL, 'G3DSA:3.40.50.10810:FF:000022', NULL, NULL, 'Blast:Putative DNA helicase Ino80', NULL, NULL, NULL, NULL, NULL, 4),
(51629, NULL, 'G3DSA:3.30.60.30:FF:000092', NULL, NULL, 'AGRin (Synaptic protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(51630, NULL, 'G3DSA:3.80.10.10:FF:003514', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51631, NULL, 'G3DSA:3.40.50.200:FF:000101', NULL, NULL, 'Peptidase S8 and S53 subtilisin kexin sedolisin', NULL, NULL, NULL, NULL, NULL, 4),
(51632, NULL, 'G3DSA:3.40.50.10190:FF:000347', NULL, NULL, 'ADL145Cp', NULL, NULL, NULL, NULL, NULL, 4),
(51633, NULL, 'G3DSA:2.30.30.140:FF:000085', NULL, NULL, 'Tudor domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(51634, NULL, 'G3DSA:3.50.50.60:FF:000998', NULL, NULL, 'Putative bifunctional amine oxidase DDB_G0291301', NULL, NULL, NULL, NULL, NULL, 4),
(51635, NULL, 'G3DSA:3.90.190.10:FF:000582', NULL, NULL, 'Protein tyrosine phosphatase, receptor type, A', NULL, NULL, NULL, NULL, NULL, 4),
(51636, NULL, 'G3DSA:3.80.10.10:FF:003110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51637, NULL, 'G3DSA:4.10.400.10:FF:000079', NULL, NULL, 'Low-density lipoprotein receptor-related protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(51638, NULL, 'G3DSA:2.60.40.10:FF:000405', NULL, NULL, 'nephrin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(51639, NULL, 'G3DSA:1.25.40.700:FF:000006', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51640, NULL, 'G3DSA:1.20.1280.50:FF:000235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51641, NULL, 'G3DSA:3.20.20.140:FF:000093', NULL, NULL, 'Adenosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(51642, NULL, 'G3DSA:3.90.70.10:FF:000044', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 13', NULL, NULL, NULL, NULL, NULL, 4),
(51643, NULL, 'G3DSA:1.20.1250.20:FF:000365', NULL, NULL, 'chromaffin granule amine transporter isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(51644, NULL, 'G3DSA:3.30.360.10:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51645, NULL, 'G3DSA:3.30.9.10:FF:000259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51646, NULL, 'G3DSA:3.40.710.10:FF:000066', NULL, NULL, 'Penicillin-binding membrane protein PbpB', NULL, NULL, NULL, NULL, NULL, 4),
(51647, NULL, 'G3DSA:2.80.10.50:FF:000139', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(51648, NULL, 'G3DSA:3.30.70.240:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51649, NULL, 'G3DSA:2.30.130.10:FF:000011', NULL, NULL, 'Glutamate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(51650, NULL, 'G3DSA:3.30.830.10:FF:000212', NULL, NULL, 'Peptidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(51651, NULL, 'G3DSA:2.60.120.970:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51652, NULL, 'G3DSA:2.60.40.10:FF:003896', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51653, NULL, 'G3DSA:2.60.40.10:FF:005548', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51654, NULL, 'G3DSA:2.60.40.150:FF:000263', NULL, NULL, 'Regulator of G-protein signaling 3', NULL, NULL, NULL, NULL, NULL, 4),
(51655, NULL, 'G3DSA:1.20.1640.10:FF:000094', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(51656, NULL, 'G3DSA:1.10.8.60:FF:000192', NULL, NULL, 'Fis family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(51657, NULL, 'G3DSA:2.60.40.10:FF:002390', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(51658, NULL, 'G3DSA:2.60.120.290:FF:000168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51659, NULL, 'G3DSA:1.10.10.10:FF:001538', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51660, NULL, 'G3DSA:3.40.50.300:FF:000305', NULL, NULL, 'CTP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(51661, NULL, 'G3DSA:3.40.50.2300:FF:001129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51662, NULL, 'G3DSA:1.10.860.10:FF:000018', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(51663, NULL, 'G3DSA:1.10.630.10:FF:000473', NULL, NULL, 'Probable cytochrome P450 522A1', NULL, NULL, NULL, NULL, NULL, 4),
(51664, NULL, 'G3DSA:4.10.1000.10:FF:000068', NULL, NULL, 'Zinc finger C-x8-C-x5-C-x3-H type (And similar), putative', NULL, NULL, NULL, NULL, NULL, 4),
(51665, NULL, 'G3DSA:3.40.640.10:FF:000004', NULL, NULL, 'Acetylornithine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(51666, NULL, 'G3DSA:1.20.1440.240:FF:000006', NULL, NULL, 'Putative L-amino-acid oxidase YobN', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(51667, NULL, 'G3DSA:2.60.40.3210:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51668, NULL, 'G3DSA:1.10.287.110:FF:000160', NULL, NULL, 'Chaperone protein DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(51669, NULL, 'G3DSA:2.40.10.120:FF:000005', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(51670, NULL, 'G3DSA:1.20.1080.10:FF:000011', NULL, NULL, 'Formate family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(51671, NULL, 'G3DSA:3.30.70.240:FF:000006', NULL, NULL, 'Elongation factor like GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(51672, NULL, 'G3DSA:1.25.10.10:FF:001718', NULL, NULL, 'YALI0D16841p', NULL, NULL, NULL, NULL, NULL, 4),
(51673, NULL, 'G3DSA:3.90.550.10:FF:000340', NULL, NULL, 'CMP-sialic acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(51674, NULL, 'G3DSA:3.10.280.10:FF:000005', NULL, NULL, 'Glycoprotein gC1qBP, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51675, NULL, 'G3DSA:2.60.40.200:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51676, NULL, 'G3DSA:1.10.10.200:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51677, NULL, 'G3DSA:3.40.250.10:FF:000261', NULL, NULL, 'Tyrosine protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(51678, NULL, 'G3DSA:3.40.50.10810:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51679, NULL, 'G3DSA:1.10.60.10:FF:000001', NULL, NULL, 'Iron dependent repressor', NULL, NULL, NULL, NULL, NULL, 4),
(51680, NULL, 'G3DSA:3.30.160.60:FF:006133', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51681, NULL, 'G3DSA:1.25.10.10:FF:000116', NULL, NULL, 'importin-11 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(51682, NULL, 'G3DSA:3.80.20.20:FF:000005', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(51683, NULL, 'G3DSA:3.30.160.60:FF:005644', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51684, NULL, 'G3DSA:3.30.310.50:FF:000010', NULL, NULL, 'Phosphoglucomutase', NULL, NULL, NULL, NULL, NULL, 4),
(51685, NULL, 'G3DSA:1.10.510.10:FF:001774', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51686, NULL, 'G3DSA:3.80.10.10:FF:000934', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(51687, NULL, 'G3DSA:3.90.640.90:FF:000022', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51688, NULL, 'G3DSA:3.40.140.70:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51689, NULL, 'G3DSA:3.40.630.70:FF:000004', NULL, NULL, 'Leucyl/phenylalanyl-tRNA--protein transferase', NULL, NULL, NULL, NULL, NULL, 4),
(51690, NULL, 'G3DSA:1.20.5.1040:FF:000003', NULL, NULL, 'Sensor protein QseC', NULL, NULL, NULL, NULL, NULL, 4),
(51691, NULL, 'G3DSA:2.10.25.10:FF:000659', NULL, NULL, 'Crumbs cell polarity complex component 2b', NULL, NULL, NULL, NULL, NULL, 4),
(51692, NULL, 'G3DSA:2.10.90.10:FF:000118', NULL, NULL, 'Vascular endothelial growth factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(51693, NULL, 'G3DSA:3.60.21.10:FF:000275', NULL, NULL, 'Sphingomyelin phosphodiesterase A', NULL, NULL, NULL, NULL, NULL, 4),
(51694, NULL, 'G3DSA:3.30.870.10:FF:000107', NULL, NULL, 'Phospholipase D endonuclease superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(51695, NULL, 'G3DSA:3.40.50.200:FF:000152', NULL, NULL, 'Collagenolytic serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(51696, NULL, 'G3DSA:3.40.50.410:FF:000338', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51697, NULL, 'G3DSA:1.10.510.10:FF:001723', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(51698, NULL, 'G3DSA:3.30.9.10:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51699, NULL, 'G3DSA:3.55.50.30:FF:000012', NULL, NULL, 'Probable transmembrane sensor', NULL, NULL, NULL, NULL, NULL, 4),
(51700, NULL, 'G3DSA:1.20.58.390:FF:000118', NULL, NULL, 'GABA-gated ion channel', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(51701, NULL, 'G3DSA:2.20.25.530:FF:000003', NULL, NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(51702, NULL, 'G3DSA:2.40.50.120:FF:000053', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51703, NULL, 'G3DSA:3.30.70.1660:FF:000012', NULL, NULL, 'Peptide chain release factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(51704, NULL, 'G3DSA:3.30.1370.30:FF:000007', NULL, NULL, 'Related to MRPS8-mitochondrial ribosomal protein, small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(51705, NULL, 'G3DSA:4.10.1250.10:FF:000002', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(51706, NULL, 'G3DSA:1.25.40.10:FF:003463', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(51707, NULL, 'G3DSA:2.40.50.140:FF:001048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51708, NULL, 'G3DSA:1.20.1250.20:FF:000932', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51709, NULL, 'G3DSA:1.20.120.350:FF:000095', NULL, NULL, 'Voltage-gated Ca2+ channel, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(51710, NULL, 'G3DSA:3.30.200.20:FF:001533', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51711, NULL, 'G3DSA:2.40.30.10:FF:000243', NULL, NULL, 'Methionine synthase reductase', NULL, NULL, NULL, NULL, NULL, 4),
(51712, NULL, 'G3DSA:2.40.50.230:FF:000001', NULL, NULL, 'Type VI secretion protein VgrG', NULL, NULL, NULL, NULL, NULL, 4),
(51713, NULL, 'G3DSA:3.40.50.150:FF:000097', NULL, NULL, 'tRNA (adenine(58)-N(1))-methyltransferase catalytic subunit TRMT61A', NULL, NULL, NULL, NULL, NULL, 4),
(51714, NULL, 'G3DSA:3.10.20.30:FF:000051', NULL, NULL, 'Possible oxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(51715, NULL, 'G3DSA:3.40.50.300:FF:008320', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51716, NULL, 'G3DSA:3.30.70.250:FF:000009', NULL, NULL, 'Malonyl-CoA:ACP transferase', NULL, NULL, NULL, NULL, NULL, 4),
(51717, NULL, 'G3DSA:2.40.50.140:FF:001109', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51718, NULL, 'G3DSA:2.60.40.10:FF:001507', NULL, NULL, 'tyrosine-protein phosphatase 10D isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(51719, NULL, 'G3DSA:1.25.10.10:FF:001870', NULL, NULL, 'Integrator complex subunit 4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(51720, NULL, 'G3DSA:3.30.200.20:FF:001319', NULL, NULL, 'Interleukin-1 receptor-associated kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(51721, NULL, 'G3DSA:1.50.40.10:FF:000414', NULL, NULL, 'MIP14680p', NULL, NULL, NULL, NULL, NULL, 4),
(51722, NULL, 'G3DSA:3.40.50.1440:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51723, NULL, 'G3DSA:3.40.50.2000:FF:001084', NULL, NULL, 'Sulfoquinovosyl transferase SQD2', NULL, NULL, NULL, NULL, NULL, 4),
(51724, NULL, 'G3DSA:3.30.230.70:FF:000015', NULL, NULL, 'Exosome complex component RRP41-like', NULL, NULL, NULL, NULL, NULL, 4),
(51725, NULL, 'G3DSA:3.40.50.2000:FF:000595', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(51726, NULL, 'G3DSA:1.25.40.10:FF:001372', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g21300', NULL, NULL, NULL, NULL, NULL, 4),
(51727, NULL, 'G3DSA:3.20.20.190:FF:000079', NULL, NULL, 'POGO family transposase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51728, NULL, 'G3DSA:3.30.310.80:FF:000019', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(51729, NULL, 'G3DSA:2.10.70.10:FF:000286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51730, NULL, 'G3DSA:3.90.190.10:FF:000082', NULL, NULL, 'Serine/threonine/tyrosine-interacting-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(51731, NULL, 'G3DSA:3.90.79.10:FF:000064', NULL, NULL, 'GDP-mannose mannosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(51732, NULL, 'G3DSA:3.40.30.10:FF:000763', NULL, NULL, 'Glutathione S-transferase kappa', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(51733, NULL, 'G3DSA:1.10.10.1050:FF:000020', NULL, NULL, 'Decapping enzyme complex catalytic component', NULL, NULL, NULL, NULL, NULL, 4),
(51734, NULL, 'G3DSA:2.60.120.10:FF:000150', NULL, NULL, 'Spherulin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51735, NULL, 'G3DSA:3.30.230.80:FF:000018', NULL, NULL, 'Heat Shock Protein', NULL, NULL, NULL, NULL, NULL, 4),
(51736, NULL, 'G3DSA:2.130.10.10:FF:005526', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51737, NULL, 'G3DSA:3.30.700.20:FF:000003', NULL, NULL, 'Uncharacterized protein, PH0010 family/AmmeMemoRadiSam system protein A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51738, NULL, 'G3DSA:3.40.50.150:FF:001457', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51739, NULL, 'G3DSA:3.40.1280.30:FF:000021', NULL, NULL, 'tRNA (guanineN(1)-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(51740, NULL, 'G3DSA:3.40.50.2300:FF:001404', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51741, NULL, 'G3DSA:3.80.10.10:FF:004296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51742, NULL, 'G3DSA:3.40.630.60:FF:000001', NULL, NULL, 'Ornithine decarboxylase antizyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(51743, NULL, 'G3DSA:3.30.60.30:FF:000041', NULL, NULL, 'agrin isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(51744, NULL, 'G3DSA:2.60.120.290:FF:000117', NULL, NULL, 'Complement factor D, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51745, NULL, 'G3DSA:1.20.1250.20:FF:001354', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51746, NULL, 'G3DSA:1.25.40.20:FF:001375', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51747, NULL, 'G3DSA:3.40.1340.10:FF:000014', NULL, NULL, 'Putative DNA-directed RNA polymerase II', NULL, NULL, NULL, NULL, NULL, 4),
(51748, NULL, 'G3DSA:2.60.40.10:FF:000147', NULL, NULL, 'Myosin light chain kinase', NULL, NULL, NULL, NULL, NULL, 4),
(51749, NULL, 'G3DSA:2.30.39.10:FF:000027', NULL, NULL, 'Serpin peptidase inhibitor 29', NULL, NULL, NULL, NULL, NULL, 4),
(51750, NULL, 'G3DSA:1.10.510.10:FF:000700', NULL, NULL, 'CMGC/RCK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(51751, NULL, 'G3DSA:2.80.10.50:FF:000061', NULL, NULL, 'Protein FRG1', NULL, NULL, NULL, NULL, NULL, 4),
(51752, NULL, 'G3DSA:2.10.90.10:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51753, NULL, 'G3DSA:1.10.420.10:FF:000030', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(51754, NULL, 'G3DSA:3.40.50.410:FF:000097', NULL, NULL, 'Protein transport protein Sec24-like CEF', NULL, NULL, NULL, NULL, NULL, 4),
(51755, NULL, 'G3DSA:1.20.1560.10:FF:000790', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51756, NULL, 'G3DSA:1.10.1200.10:FF:000131', NULL, NULL, 'Nonribosomal peptide synthase inpB', NULL, NULL, NULL, NULL, NULL, 4),
(51757, NULL, 'G3DSA:3.40.50.1010:FF:000039', NULL, NULL, 'rRNA-processing protein FCF1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(51758, NULL, 'G3DSA:1.25.40.10:FF:003384', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g37230', NULL, NULL, NULL, NULL, NULL, 4),
(51759, NULL, 'G3DSA:2.60.40.2860:FF:000028', NULL, NULL, 'Sporozoite surface protein P36p', NULL, NULL, NULL, NULL, NULL, 4),
(51760, NULL, 'G3DSA:3.40.1350.60:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51761, NULL, 'G3DSA:2.10.25.10:FF:000890', NULL, NULL, 'Notch, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(51762, NULL, 'G3DSA:3.10.20.90:FF:000580', NULL, NULL, 'Ubiquitin-2_like_Rad60_SUMO-like_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(51763, NULL, 'G3DSA:3.90.190.10:FF:000177', NULL, NULL, 'Protein tyrosine phosphatase TpbA', NULL, NULL, NULL, NULL, NULL, 4),
(51764, NULL, 'G3DSA:2.60.40.60:FF:000701', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51765, NULL, 'G3DSA:1.10.472.130:FF:000003', NULL, NULL, 'Dynein, axonemal, heavy chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(51766, NULL, 'G3DSA:2.10.25.10:FF:001502', NULL, NULL, 'Reelin', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(51767, NULL, 'G3DSA:1.20.1310.10:FF:000007', NULL, NULL, 'Cullin 1', NULL, NULL, NULL, NULL, NULL, 4),
(51768, NULL, 'G3DSA:3.40.910.10:FF:000014', NULL, NULL, 'Deoxyhypusine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(51769, NULL, 'G3DSA:2.60.120.470:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51770, NULL, 'G3DSA:3.40.50.1000:FF:000036', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(51771, NULL, 'G3DSA:2.60.40.10:FF:005762', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51772, NULL, 'G3DSA:3.40.50.200:FF:000073', NULL, NULL, 'Peptidase S8 and S53 subtilisin kexin sedolisin', NULL, NULL, NULL, NULL, NULL, 4),
(51773, NULL, 'G3DSA:2.60.120.200:FF:000809', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51774, NULL, 'G3DSA:2.120.10.100:FF:000002', NULL, NULL, 'Apyrase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51775, NULL, 'G3DSA:3.40.50.300:FF:000182', NULL, NULL, 'ras-related protein Rap-1b', NULL, NULL, NULL, NULL, NULL, 4),
(51776, NULL, 'G3DSA:1.10.1070.11:FF:000020', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(51777, NULL, 'G3DSA:2.20.100.10:FF:000028', NULL, NULL, 'R-spondin 2', NULL, NULL, NULL, NULL, NULL, 4),
(51778, NULL, 'G3DSA:1.10.472.140:FF:000006', NULL, NULL, 'Cell cycle regulator p107, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51779, NULL, 'G3DSA:2.40.50.700:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51780, NULL, 'G3DSA:2.10.25.10:FF:001053', NULL, NULL, 'Slit homolog 1b (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(51781, NULL, 'G3DSA:1.10.510.10:FF:001835', NULL, NULL, 'Casein kinase 1 isoform 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51782, NULL, 'G3DSA:2.30.110.10:FF:000009', NULL, NULL, 'PPOX class F420-dependent enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(51783, NULL, 'G3DSA:2.10.25.10:FF:000485', NULL, NULL, 'Epidermal growth factor-like protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(51784, NULL, 'G3DSA:1.25.10.10:FF:001218', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51785, NULL, 'G3DSA:1.10.510.10:FF:004011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51786, NULL, 'G3DSA:3.10.105.10:FF:000122', NULL, NULL, '4-phytase', NULL, NULL, NULL, NULL, NULL, 4),
(51787, NULL, 'G3DSA:1.20.1070.10:FF:001202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51788, NULL, 'G3DSA:2.40.10.10:FF:000034', NULL, NULL, 'Eupolytin', NULL, NULL, NULL, NULL, NULL, 4),
(51789, NULL, 'G3DSA:3.30.505.10:FF:000215', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51790, NULL, 'G3DSA:1.20.58.390:FF:000332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51791, NULL, 'G3DSA:3.40.50.150:FF:000322', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(51792, NULL, 'G3DSA:2.60.40.10:FF:001833', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(51793, NULL, 'G3DSA:1.10.150.250:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51794, NULL, 'G3DSA:3.90.550.10:FF:000014', NULL, NULL, 'Glucose-1-phosphate adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(51795, NULL, 'G3DSA:3.30.497.10:FF:000150', NULL, NULL, 'Serpin family C member 1', NULL, NULL, NULL, NULL, NULL, 4),
(51796, NULL, 'G3DSA:3.30.1490.20:FF:000070', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(51797, NULL, 'G3DSA:1.10.630.10:FF:000647', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51798, NULL, 'G3DSA:3.40.50.300:FF:006988', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51799, NULL, 'G3DSA:2.10.25.10:FF:000159', NULL, NULL, 'Fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(51800, NULL, 'G3DSA:3.40.1000.50:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51801, NULL, 'G3DSA:2.10.60.10:FF:000049', NULL, NULL, 'Serine/threonine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(51802, NULL, 'G3DSA:2.70.170.10:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51803, NULL, 'G3DSA:3.60.21.50:FF:000028', NULL, NULL, 'DNA polymerase delta small subunit-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(51804, NULL, 'G3DSA:1.10.575.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51805, NULL, 'G3DSA:3.30.420.40:FF:000274', NULL, NULL, 'Glucose kinase', NULL, NULL, NULL, NULL, NULL, 4),
(51806, NULL, 'G3DSA:3.30.200.20:FF:000010', NULL, NULL, 'Serine/threonine-protein kinase WNK1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(51807, NULL, 'G3DSA:1.25.40.470:FF:000072', NULL, NULL, 'Cotamer alpha, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51808, NULL, 'G3DSA:3.90.70.80:FF:000037', NULL, NULL, 'OTU domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(51809, NULL, 'G3DSA:3.40.50.300:FF:005706', NULL, NULL, 'SNF2 DNA repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51810, NULL, 'G3DSA:1.20.1070.10:FF:001820', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51811, NULL, 'G3DSA:1.20.140.150:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51812, NULL, 'G3DSA:3.30.1360.70:FF:000002', NULL, NULL, 'arginine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(51813, NULL, 'G3DSA:3.80.10.10:FF:000581', NULL, NULL, 'Leucine Rich Repeat family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(51814, NULL, 'G3DSA:2.130.10.10:FF:005414', NULL, NULL, 'Serine/threonine-protein kinase ppk4', NULL, NULL, NULL, NULL, NULL, 4),
(51815, NULL, 'G3DSA:2.10.70.10:FF:000174', NULL, NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(51816, NULL, 'G3DSA:3.30.530.20:FF:000006', NULL, NULL, 'StAR-related lipid transfer protein 7, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(51817, NULL, 'G3DSA:2.130.10.130:FF:000060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51818, NULL, 'G3DSA:3.30.40.10:FF:001074', NULL, NULL, 'RING finger protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(51819, NULL, 'G3DSA:2.160.20.10:FF:000023', NULL, NULL, 'Exo-beta-1,3-glucanase Exg0', NULL, NULL, NULL, NULL, NULL, 4),
(51820, NULL, 'G3DSA:3.60.40.10:FF:000246', NULL, NULL, 'TipA', NULL, NULL, NULL, NULL, NULL, 4),
(51821, NULL, 'G3DSA:1.10.418.20:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51822, NULL, 'G3DSA:2.60.120.620:FF:000019', NULL, NULL, '2-oxoglutarate and iron-dependent oxygenase domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(51823, NULL, 'G3DSA:1.20.120.350:FF:000218', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51824, NULL, 'G3DSA:3.40.50.150:FF:001783', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51825, NULL, 'G3DSA:2.60.470.10:FF:000029', NULL, NULL, 'Pickpocket 30, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(51826, NULL, 'G3DSA:3.60.20.10:FF:000037', NULL, NULL, 'Asparagine synthetase B', NULL, NULL, NULL, NULL, NULL, 4),
(51827, NULL, 'G3DSA:1.20.1050.80:FF:000002', NULL, NULL, 'Ras and Rab interactor 2', NULL, NULL, NULL, NULL, NULL, 4),
(51828, NULL, 'G3DSA:2.60.200.20:FF:000136', NULL, NULL, 'Serine/threonine-protein kinase Chk2', NULL, NULL, NULL, NULL, NULL, 4),
(51829, NULL, 'G3DSA:3.80.10.10:FF:003402', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51830, NULL, 'G3DSA:1.25.10.10:FF:002033', NULL, NULL, 'Microtubule associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(51831, NULL, 'G3DSA:1.10.510.10:FF:004062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51832, NULL, 'G3DSA:2.60.40.10:FF:005318', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51833, NULL, 'G3DSA:3.30.450.350:FF:000007', NULL, NULL, 'Sensor histidine kinase, CHASE domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(51834, NULL, 'G3DSA:3.30.40.10:FF:000843', NULL, NULL, 'E3 ubiquitin-protein ligase PEP5', NULL, NULL, NULL, NULL, NULL, 4),
(51835, NULL, 'G3DSA:3.30.1480.10:FF:000010', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(51836, NULL, 'G3DSA:1.10.3060.10:FF:000007', NULL, NULL, 'Protein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(51837, NULL, 'G3DSA:3.20.20.190:FF:000107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51838, NULL, 'G3DSA:1.20.1560.10:FF:000638', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51839, NULL, 'G3DSA:3.20.20.140:FF:000385', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51840, NULL, 'G3DSA:2.60.40.10:FF:000473', NULL, NULL, 'WAP, Kazal, immunoglobulin, Kunitz and NTR domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(51841, NULL, 'G3DSA:2.40.20.10:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51842, NULL, 'G3DSA:3.30.300.20:FF:000074', NULL, NULL, 'Ribosome-binding factor A', NULL, NULL, NULL, NULL, NULL, 4),
(51843, NULL, 'G3DSA:1.50.40.10:FF:000386', NULL, NULL, 'Calcium-binding mitochondrial carrier protein SCaMC-2', NULL, NULL, NULL, NULL, NULL, 4),
(51844, NULL, 'G3DSA:2.60.40.1670:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51845, NULL, 'G3DSA:3.30.230.10:FF:000189', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(51846, NULL, 'G3DSA:2.60.40.1260:FF:000003', NULL, NULL, 'Intermediate filament protein A', NULL, NULL, NULL, NULL, NULL, 4),
(51847, NULL, 'G3DSA:3.80.10.10:FF:002790', NULL, NULL, 'Os02g0277700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(51848, NULL, 'G3DSA:3.40.50.2300:FF:001601', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51849, NULL, 'G3DSA:1.10.287.130:FF:000199', NULL, NULL, 'Two component signal transduction system histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(51850, NULL, 'G3DSA:1.10.3210.10:FF:000103', NULL, NULL, 'Hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(51851, NULL, 'G3DSA:3.40.50.1110:FF:000070', NULL, NULL, 'Si:ch211-214p16.3', NULL, NULL, NULL, NULL, NULL, 4),
(51852, NULL, 'G3DSA:3.30.450.200:FF:000007', NULL, NULL, 'MAP kinase-activating death domain protein isoform X10', NULL, NULL, NULL, NULL, NULL, 4),
(51853, NULL, 'G3DSA:1.10.1610.10:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51854, NULL, 'G3DSA:3.40.50.300:FF:000131', NULL, NULL, 'GTP-binding nuclear protein Ran', NULL, NULL, NULL, NULL, NULL, 4),
(51855, NULL, 'G3DSA:1.20.1250.20:FF:002377', NULL, NULL, 'Facilitated trehalose transporter Tret1-2 homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(51856, NULL, 'G3DSA:2.170.260.10:FF:000009', NULL, NULL, 'Dicer-2', NULL, NULL, NULL, NULL, NULL, 4),
(51857, NULL, 'G3DSA:3.40.50.12780:FF:000186', NULL, NULL, 'MIP16841p', NULL, NULL, NULL, NULL, NULL, 4),
(51858, NULL, 'G3DSA:3.30.930.10:FF:000197', NULL, NULL, 'Lysine--tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51859, NULL, 'G3DSA:3.40.50.11350:FF:000004', NULL, NULL, 'GDP-fucose protein O-fucosyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(51860, NULL, 'G3DSA:3.30.450.20:FF:000641', NULL, NULL, 'Cytokinin receptor AtCKI2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(51861, NULL, 'G3DSA:1.20.1280.50:FF:000061', NULL, NULL, 'F-box only protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(51862, NULL, 'G3DSA:3.30.160.60:FF:005936', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51863, NULL, 'G3DSA:2.70.98.10:FF:000004', NULL, NULL, 'Glucans biosynthesis protein D', NULL, NULL, NULL, NULL, NULL, 4),
(51864, NULL, 'G3DSA:3.40.50.1820:FF:000198', NULL, NULL, 'Putative esterase', NULL, NULL, NULL, NULL, NULL, 4),
(51865, NULL, 'G3DSA:2.40.160.10:FF:000061', NULL, NULL, 'Bll5078 protein', NULL, NULL, NULL, NULL, NULL, 4),
(51866, NULL, 'G3DSA:3.40.50.10130:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51867, NULL, 'G3DSA:2.40.240.10:FF:000062', NULL, NULL, 'Glutamine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(51868, NULL, 'G3DSA:1.25.40.10:FF:001046', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g14330', NULL, NULL, NULL, NULL, NULL, 4),
(51869, NULL, 'G3DSA:1.10.555.10:FF:000056', NULL, NULL, 'AGAP001687-PB', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(51870, NULL, 'G3DSA:3.40.50.300:FF:000417', NULL, NULL, 'Cell division inhibitor SulA', NULL, NULL, NULL, NULL, NULL, 4),
(51871, NULL, 'G3DSA:2.70.98.20:FF:000007', NULL, NULL, 'Primary amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(51872, NULL, 'G3DSA:3.30.300.30:FF:000077', NULL, NULL, 'Benzoate-CoA ligase family', NULL, NULL, NULL, NULL, NULL, 4),
(51873, NULL, 'G3DSA:4.10.240.10:FF:000078', NULL, NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(51874, NULL, 'G3DSA:1.10.10.10:FF:001246', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(51875, NULL, 'G3DSA:3.40.50.10140:FF:000068', NULL, NULL, 'Toll-like receptor 9', NULL, NULL, NULL, NULL, NULL, 4),
(51876, NULL, 'G3DSA:3.90.1100.10:FF:000013', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(51877, NULL, 'G3DSA:3.30.40.10:FF:001950', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51878, NULL, 'G3DSA:1.10.8.60:FF:000366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51879, NULL, 'G3DSA:3.60.10.10:FF:000418', NULL, NULL, 'Imidazole glycerol phosphate synthase hisHF chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(51880, NULL, 'G3DSA:3.90.550.10:FF:000452', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51881, NULL, 'G3DSA:3.40.50.10490:FF:000089', NULL, NULL, 'Glucosamine--fructose-6-phosphate aminotransferase, isomerizing', NULL, NULL, NULL, NULL, NULL, 4),
(51882, NULL, 'G3DSA:1.25.10.10:FF:001544', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51883, NULL, 'G3DSA:3.40.50.10190:FF:000173', NULL, NULL, 'Protein CBR-MUS-101', NULL, NULL, NULL, NULL, NULL, 4),
(51884, NULL, 'G3DSA:3.50.50.60:FF:001436', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51885, NULL, 'G3DSA:1.20.1050.90:FF:000005', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(51886, NULL, 'G3DSA:3.40.50.1820:FF:001530', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51887, NULL, 'G3DSA:1.10.630.10:FF:000361', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51888, NULL, 'G3DSA:3.50.50.60:FF:000947', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51889, NULL, 'G3DSA:3.90.190.10:FF:000531', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51890, NULL, 'G3DSA:3.30.160.60:FF:003727', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51891, NULL, 'G3DSA:1.20.58.1120:FF:000027', NULL, NULL, 'dynein heavy chain 12, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(51892, NULL, 'G3DSA:2.30.29.90:FF:000005', NULL, NULL, 'Exocyst complex component 1', NULL, NULL, NULL, NULL, NULL, 4),
(51893, NULL, 'G3DSA:2.40.290.10:FF:000008', NULL, NULL, 'ATP-dependent DNA helicase II subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(51894, NULL, 'G3DSA:3.40.1190.20:FF:000073', NULL, NULL, 'Fructokinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51895, NULL, 'G3DSA:3.30.60.30:FF:000215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51896, NULL, 'G3DSA:3.90.280.10:FF:000004', NULL, NULL, 'Mitochondrial large ribosomal subunit YmL35', NULL, NULL, NULL, NULL, NULL, 4),
(51897, NULL, 'G3DSA:3.30.470.30:FF:000010', NULL, NULL, 'Snurportin-1', NULL, NULL, NULL, NULL, NULL, 4),
(51898, NULL, 'G3DSA:3.60.21.10:FF:000207', NULL, NULL, 'Putative serine/threonine protein phosphatase 2B catalytic subunit A2', NULL, NULL, NULL, NULL, NULL, 4),
(51899, NULL, 'G3DSA:2.130.10.10:FF:003548', NULL, NULL, 'Dmx-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(51900, NULL, 'G3DSA:3.80.10.10:FF:002997', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(51901, NULL, 'G3DSA:3.80.10.10:FF:001811', NULL, NULL, 'DNA-damage repair/toleration 100', NULL, NULL, NULL, NULL, NULL, 4),
(51902, NULL, 'G3DSA:3.30.460.10:FF:000138', NULL, NULL, 'Protein CBG22981', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(51903, NULL, 'G3DSA:1.20.58.390:FF:000040', NULL, NULL, 'Gamma-aminobutyric acid receptor subunit beta-like', NULL, NULL, NULL, NULL, NULL, 4),
(51904, NULL, 'G3DSA:1.20.870.10:FF:000022', NULL, NULL, 'Rho GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(51905, NULL, 'G3DSA:3.30.40.10:FF:001332', NULL, NULL, 'Predicted zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(51906, NULL, 'G3DSA:3.40.50.980:FF:000020', NULL, NULL, 'Luciferin 4-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(51907, NULL, 'G3DSA:3.50.30.30:FF:000162', NULL, NULL, 'Glutamate carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51908, NULL, 'G3DSA:3.40.140.10:FF:000106', NULL, NULL, 'Cytidine/deoxycytidylate deaminase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(51909, NULL, 'G3DSA:1.10.472.80:FF:000249', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51910, NULL, 'G3DSA:3.30.1640.30:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51911, NULL, 'G3DSA:3.40.50.410:FF:000046', NULL, NULL, 'von Willebrand factor A domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(51912, NULL, 'G3DSA:3.30.1490.270:FF:000001', NULL, NULL, 'Hypothetical alanine and leucine rich protein', NULL, NULL, NULL, NULL, NULL, 4),
(51913, NULL, 'G3DSA:3.30.450.40:FF:000130', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(51914, NULL, 'G3DSA:2.60.40.10:FF:005195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51915, NULL, 'G3DSA:1.25.40.10:FF:004401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51916, NULL, 'G3DSA:3.90.980.20:FF:000015', NULL, NULL, 'Histidine kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(51917, NULL, 'G3DSA:3.30.710.10:FF:000299', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51918, NULL, 'G3DSA:3.30.160.60:FF:002160', NULL, NULL, 'Transcriptional regulator NRG1', NULL, NULL, NULL, NULL, NULL, 4),
(51919, NULL, 'G3DSA:3.30.1520.10:FF:000177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51920, NULL, 'G3DSA:3.30.530.20:FF:000057', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(51921, NULL, 'G3DSA:3.40.50.2000:FF:000769', NULL, NULL, 'Glycosyltransferase family 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(51922, NULL, 'G3DSA:1.20.120.850:FF:000003', NULL, NULL, 'DNA repair and recombination protein RAD54', NULL, NULL, NULL, NULL, NULL, 4),
(51923, NULL, 'G3DSA:3.40.1690.20:FF:000015', NULL, NULL, 'ATP-dependent zinc metalloprotease FTSH 8', NULL, NULL, NULL, NULL, NULL, 4),
(51924, NULL, 'G3DSA:3.80.10.10:FF:002379', NULL, NULL, 'AGAP012425-PA', NULL, NULL, NULL, NULL, NULL, 4),
(51925, NULL, 'G3DSA:3.90.1580.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51926, NULL, 'G3DSA:2.20.25.10:FF:000052', NULL, NULL, 'Transcription elongation factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(51927, NULL, 'G3DSA:1.10.10.750:FF:000042', NULL, NULL, 'RabGAP/TBC domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(51928, NULL, 'G3DSA:1.20.1070.10:FF:000590', NULL, NULL, 'Adhesion G-protein coupled receptor D1', NULL, NULL, NULL, NULL, NULL, 4),
(51929, NULL, 'G3DSA:2.60.120.260:FF:000400', NULL, NULL, 'Endo-1,4-beta-xylanase Y', NULL, NULL, NULL, NULL, NULL, 4),
(51930, NULL, 'G3DSA:3.40.50.11340:FF:000001', NULL, NULL, 'GDP-fucose protein O-fucosyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(51931, NULL, 'G3DSA:3.40.50.360:FF:000093', NULL, NULL, 'Flavin reductase', NULL, NULL, NULL, NULL, NULL, 4),
(51932, NULL, 'G3DSA:3.30.1640.10:FF:000011', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(51933, NULL, 'G3DSA:3.40.50.12760:FF:000028', NULL, NULL, 'FtsJ methyltransferase domaincontaining protein 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51934, NULL, 'G3DSA:2.30.40.10:FF:000098', NULL, NULL, 'Bll3830 protein', NULL, NULL, NULL, NULL, NULL, 4),
(51935, NULL, 'G3DSA:2.60.40.10:FF:001479', NULL, NULL, 'Immunoglobulin lambda variable 7-43', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(51936, NULL, 'G3DSA:3.30.1150.10:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51937, NULL, 'G3DSA:1.10.510.10:FF:003786', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51938, NULL, 'G3DSA:1.10.1420.10:FF:000063', NULL, NULL, 'MutS family protein', NULL, NULL, NULL, NULL, NULL, 4),
(51939, NULL, 'G3DSA:3.40.1690.10:FF:000012', NULL, NULL, 'Flagellar biosynthesis protein FlhB', NULL, NULL, NULL, NULL, NULL, 4),
(51940, NULL, 'G3DSA:2.30.30.140:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51941, NULL, 'G3DSA:1.10.3720.10:FF:000007', NULL, NULL, 'Dipeptide ABC transporter permease DppC', NULL, NULL, NULL, NULL, NULL, 4),
(51942, NULL, 'G3DSA:2.40.30.10:FF:000310', NULL, NULL, '5-methyltetrahydrofolate-homocysteine methyltransferase reductase', NULL, NULL, NULL, NULL, NULL, 4),
(51943, NULL, 'G3DSA:3.30.930.10:FF:000225', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(51944, NULL, 'G3DSA:1.25.50.20:FF:000066', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(51945, NULL, 'G3DSA:1.20.1250.20:FF:001421', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51946, NULL, 'G3DSA:1.20.120.330:FF:000004', NULL, NULL, 'Mannitol operon repressor', NULL, NULL, NULL, NULL, NULL, 4),
(51947, NULL, 'G3DSA:2.30.39.10:FF:000139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51948, NULL, 'G3DSA:3.40.30.10:FF:000297', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(51949, NULL, 'G3DSA:3.30.70.2130:FF:000001', NULL, NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase-like', NULL, NULL, NULL, NULL, NULL, 4),
(51950, NULL, 'G3DSA:1.20.120.340:FF:000007', NULL, NULL, 'Perilipin 4', NULL, NULL, NULL, NULL, NULL, 4),
(51951, NULL, 'G3DSA:3.30.160.60:FF:003519', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51952, NULL, 'G3DSA:3.40.50.1820:FF:001204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51953, NULL, 'G3DSA:1.10.238.10:FF:001298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51954, NULL, 'G3DSA:3.60.40.10:FF:000364', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51955, NULL, 'G3DSA:1.10.1040.10:FF:000045', NULL, NULL, 'Ketose-bisphosphate aldolase class-II family protein', NULL, NULL, NULL, NULL, NULL, 4),
(51956, NULL, 'G3DSA:2.30.180.10:FF:000025', NULL, NULL, 'Midline fasciclin, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(51957, NULL, 'G3DSA:3.10.290.10:FF:000062', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(51958, NULL, 'G3DSA:3.50.30.30:FF:000049', NULL, NULL, 'VPS70p protein', NULL, NULL, NULL, NULL, NULL, 4),
(51959, NULL, 'G3DSA:3.40.50.300:FF:005971', NULL, NULL, 'ATP-binding cassette alpha-factor transporter', NULL, NULL, NULL, NULL, NULL, 4),
(51960, NULL, 'G3DSA:2.10.70.10:FF:000056', NULL, NULL, 'CUB and Sushi multiple domains 3', NULL, NULL, NULL, NULL, NULL, 4),
(51961, NULL, 'G3DSA:1.10.510.10:FF:001274', NULL, NULL, 'Putative serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(51962, NULL, 'G3DSA:1.10.10.790:FF:000025', NULL, NULL, 'Mrna splicing factor', NULL, NULL, NULL, NULL, NULL, 4),
(51963, NULL, 'G3DSA:2.30.140.10:FF:000017', NULL, NULL, 'Polyamine aminopropyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(51964, NULL, 'G3DSA:2.60.40.640:FF:000101', NULL, NULL, 'Arrestin domain-containing protein C31A2.12', NULL, NULL, NULL, NULL, NULL, 4),
(51965, NULL, 'G3DSA:3.40.1650.10:FF:000004', NULL, NULL, 'D-ribose pyranase', NULL, NULL, NULL, NULL, NULL, 4),
(51966, NULL, 'G3DSA:2.120.10.30:FF:000013', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM71', NULL, NULL, NULL, NULL, NULL, 4),
(51967, NULL, 'G3DSA:1.10.533.10:FF:000157', NULL, NULL, 'NALP2', NULL, NULL, NULL, NULL, NULL, 4),
(51968, NULL, 'G3DSA:2.170.260.10:FF:000010', NULL, NULL, 'Argonaute (Plant)-Like protein', NULL, NULL, NULL, NULL, NULL, 4),
(51969, NULL, 'G3DSA:3.40.50.150:FF:001339', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(51970, NULL, 'G3DSA:2.60.40.10:FF:005644', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51971, NULL, 'G3DSA:2.170.210.10:FF:000006', NULL, NULL, 'DNA repair protein xrcc4', NULL, NULL, NULL, NULL, NULL, 4),
(51972, NULL, 'G3DSA:3.40.1110.10:FF:000418', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51973, NULL, 'G3DSA:3.10.50.40:FF:000106', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(51974, NULL, 'G3DSA:2.80.10.50:FF:000235', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51975, NULL, 'G3DSA:3.10.150.10:FF:000001', NULL, NULL, 'Beta sliding clamp', NULL, NULL, NULL, NULL, NULL, 4),
(51976, NULL, 'G3DSA:3.30.160.60:FF:002367', NULL, NULL, 'zinc finger protein 226 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(51977, NULL, 'G3DSA:3.40.50.1820:FF:000636', NULL, NULL, 'Serine peptidase, family S28, putative', NULL, NULL, NULL, NULL, NULL, 4),
(51978, NULL, 'G3DSA:1.25.40.10:FF:003912', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51979, NULL, 'G3DSA:1.10.510.10:FF:003398', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(51980, NULL, 'G3DSA:3.30.160.60:FF:001378', NULL, NULL, 'Zinc finger protein 652', NULL, NULL, NULL, NULL, NULL, 4),
(51981, NULL, 'G3DSA:3.90.520.10:FF:000006', NULL, NULL, 'Mothers against decapentaplegic homolog', NULL, NULL, NULL, NULL, NULL, 4),
(51982, NULL, 'G3DSA:3.30.160.60:FF:000243', NULL, NULL, 'Probable transcription factor steA', NULL, NULL, NULL, NULL, NULL, 4),
(51983, NULL, 'G3DSA:3.10.50.40:FF:000089', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(51984, NULL, 'G3DSA:2.60.220.50:FF:000085', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(51985, NULL, 'G3DSA:2.70.160.11:FF:000089', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(51986, NULL, 'G3DSA:3.40.50.1820:FF:001187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51987, NULL, 'G3DSA:3.40.50.10860:FF:000008', NULL, NULL, 'Glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(51988, NULL, 'G3DSA:3.80.10.10:FF:002497', NULL, NULL, 'Probable serine/threonine-protein kinase pats1', NULL, NULL, NULL, NULL, NULL, 4),
(51989, NULL, 'G3DSA:1.10.10.10:FF:001572', NULL, NULL, 'Putative GntR-family regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(51990, NULL, 'G3DSA:1.25.70.10:FF:000064', NULL, NULL, 'Transcription termination factor MTERF15, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(51991, NULL, 'G3DSA:1.10.3730.20:FF:000073', NULL, NULL, 'LOC568275 protein', NULL, NULL, NULL, NULL, NULL, 4),
(51992, NULL, 'G3DSA:3.20.20.70:FF:000309', NULL, NULL, 'Triosephosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(51993, NULL, 'G3DSA:3.40.50.300:FF:001199', NULL, NULL, 'Probable RNA helicase SDE3', NULL, NULL, NULL, NULL, NULL, 4),
(51994, NULL, 'G3DSA:1.20.5.190:FF:000036', NULL, NULL, 'IQ motif containing N', NULL, NULL, NULL, NULL, NULL, 4),
(51995, NULL, 'G3DSA:1.10.10.10:FF:002027', NULL, NULL, 'Protein CBG25628', NULL, NULL, NULL, NULL, NULL, 4),
(51996, NULL, 'G3DSA:2.60.120.10:FF:000649', NULL, NULL, 'Cysteine dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(51997, NULL, 'G3DSA:3.50.50.100:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(51998, NULL, 'G3DSA:3.30.160.60:FF:000181', NULL, NULL, 'C2H2 type zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(51999, NULL, 'G3DSA:1.25.40.10:FF:001759', NULL, NULL, 'Rhomboid family intramembrane serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(52000, NULL, 'G3DSA:1.20.1560.10:FF:000672', NULL, NULL, 'Multidrug resistance-associated protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(52001, NULL, 'G3DSA:1.20.1080.10:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52002, NULL, 'G3DSA:3.90.1480.20:FF:000038', NULL, NULL, 'ST8 alpha-N-acetyl-neuraminide alpha-2,8-sialyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(52003, NULL, 'G3DSA:1.10.287.10:FF:000028', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(52004, NULL, 'G3DSA:3.10.170.20:FF:000005', NULL, NULL, 'MSP-A1 surface protease homolog', NULL, NULL, NULL, NULL, NULL, 4),
(52005, NULL, 'G3DSA:3.40.50.2020:FF:000134', NULL, NULL, 'Adenine phosphoribosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52006, NULL, 'G3DSA:1.10.3730.20:FF:000016', NULL, NULL, 'NIPA1 (NonImprinted gene in Prader-Willi/Angelman syndrome region 1) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(52007, NULL, 'G3DSA:3.30.310.170:FF:000001', NULL, NULL, 'Outer membrane protein assembly factor BamC', NULL, NULL, NULL, NULL, NULL, 4),
(52008, NULL, 'G3DSA:2.60.40.60:FF:000134', NULL, NULL, 'protocadherin Fat 4', NULL, NULL, NULL, NULL, NULL, 4),
(52009, NULL, 'G3DSA:2.20.100.10:FF:000236', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs adt-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(52010, NULL, 'G3DSA:3.40.30.10:FF:001022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52011, NULL, 'G3DSA:3.10.20.90:FF:000074', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(52012, NULL, 'G3DSA:2.30.110.10:FF:000077', NULL, NULL, 'Putative 4-nitrophenol hydroxylase component B', NULL, NULL, NULL, NULL, NULL, 4),
(52013, NULL, 'G3DSA:3.40.1110.10:FF:000323', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52014, NULL, 'G3DSA:3.40.50.300:FF:006145', NULL, NULL, 'Rothmund-thomson syndrome DNA helicase recq4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52015, NULL, 'G3DSA:3.30.565.10:FF:000084', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(52016, NULL, 'G3DSA:3.30.450.90:FF:000004', NULL, NULL, 'Type IV pili twitching motility protein PilT', NULL, NULL, NULL, NULL, NULL, 4),
(52017, NULL, 'G3DSA:1.20.58.390:FF:000152', NULL, NULL, 'GABA/Glycine Receptor family (See gbr)', NULL, NULL, NULL, NULL, NULL, 4),
(52018, NULL, 'G3DSA:3.30.70.940:FF:000003', NULL, NULL, 'Transcription elongation factor SPT5', NULL, NULL, NULL, NULL, NULL, 4),
(52019, NULL, 'G3DSA:3.30.310.180:FF:000004', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 20', NULL, NULL, NULL, NULL, NULL, 4),
(52020, NULL, 'G3DSA:3.80.10.10:FF:002885', NULL, NULL, 'Si:ch211-213a13.2', NULL, NULL, NULL, NULL, NULL, 4),
(52021, NULL, 'G3DSA:3.50.50.60:FF:001223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52022, NULL, 'G3DSA:2.40.50.140:FF:000946', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52023, NULL, 'G3DSA:3.50.50.60:FF:001487', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52024, NULL, 'G3DSA:1.10.238.10:FF:000213', NULL, NULL, 'Reticulocalbin 1', NULL, NULL, NULL, NULL, NULL, 4),
(52025, NULL, 'G3DSA:3.30.160.60:FF:002272', NULL, NULL, 'Zinc finger protein 445', NULL, NULL, NULL, NULL, NULL, 4),
(52026, NULL, 'G3DSA:1.20.120.1080:FF:000034', NULL, NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase PRP16', NULL, NULL, NULL, NULL, NULL, 4),
(52027, NULL, 'G3DSA:3.30.450.80:FF:000001', NULL, NULL, 'Transcriptional activator protein TraR', NULL, NULL, NULL, NULL, NULL, 4),
(52028, NULL, 'G3DSA:2.80.10.50:FF:000140', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(52029, NULL, 'G3DSA:2.60.120.380:FF:000083', NULL, NULL, 'Calpain 9', NULL, NULL, NULL, NULL, NULL, 4),
(52030, NULL, 'G3DSA:2.60.40.3110:FF:000002', NULL, NULL, 'Fimbrial biogenesis outer membrane usher protein', NULL, NULL, NULL, NULL, NULL, 4),
(52031, NULL, 'G3DSA:1.10.510.10:FF:001369', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52032, NULL, 'G3DSA:1.25.10.10:FF:001836', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52033, NULL, 'G3DSA:1.10.150.50:FF:000212', NULL, NULL, 'DDHD domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(52034, NULL, 'G3DSA:3.90.640.10:FF:000167', NULL, NULL, 'Actin-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(52035, NULL, 'G3DSA:2.60.40.10:FF:004121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(52036, NULL, 'G3DSA:2.60.40.10:FF:004008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52037, NULL, 'G3DSA:3.40.50.2300:FF:001584', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52038, NULL, 'G3DSA:2.130.10.10:FF:000237', NULL, NULL, 'Flowering time control protein FY', NULL, NULL, NULL, NULL, NULL, 4),
(52039, NULL, 'G3DSA:2.60.120.920:FF:000076', NULL, NULL, 'ATP-dependent RNA helicase DDX1', NULL, NULL, NULL, NULL, NULL, 4),
(52040, NULL, 'G3DSA:2.120.10.30:FF:000070', NULL, NULL, 'Low-density lipoprotein receptor-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(52041, NULL, 'G3DSA:3.30.160.60:FF:005762', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52042, NULL, 'G3DSA:1.20.58.60:FF:000645', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52043, NULL, 'G3DSA:3.40.720.10:FF:000185', NULL, NULL, 'Iduronate-sulfatase (Partial) and sulfatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(52044, NULL, 'G3DSA:3.40.50.300:FF:007769', NULL, NULL, 'Ras, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52045, NULL, 'G3DSA:4.10.280.10:FF:000024', NULL, NULL, 'Aryl hydrocarbon receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(52046, NULL, 'G3DSA:2.60.120.620:FF:000087', NULL, NULL, 'Ectoine dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(52047, NULL, 'G3DSA:2.130.10.10:FF:000501', NULL, NULL, 'WD repeat domain 70', NULL, NULL, NULL, NULL, NULL, 4),
(52048, NULL, 'G3DSA:3.90.290.10:FF:000010', NULL, NULL, 'Fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(52049, NULL, 'G3DSA:1.20.140.100:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52050, NULL, 'G3DSA:3.40.1550.20:FF:000005', NULL, NULL, 'Transcriptional regulator MraZ', NULL, NULL, NULL, NULL, NULL, 4),
(52051, NULL, 'G3DSA:3.40.50.410:FF:000158', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52052, NULL, 'G3DSA:3.80.30.30:FF:000003', NULL, NULL, 'PA0069 family radical SAM protein', NULL, NULL, NULL, NULL, NULL, 4),
(52053, NULL, 'G3DSA:3.40.50.720:FF:000690', NULL, NULL, 'Glucose-6-phosphate 1-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(52054, NULL, 'G3DSA:3.40.605.10:FF:000108', NULL, NULL, '10-formyltetrahydrofolate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(52055, NULL, 'G3DSA:3.40.50.300:FF:004054', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(52056, NULL, 'G3DSA:1.25.40.20:FF:000514', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52057, NULL, 'G3DSA:3.80.10.10:FF:001362', NULL, NULL, 'Lrr receptor-like serinethreonine-protein kinase gso2', NULL, NULL, NULL, NULL, NULL, 4),
(52058, NULL, 'G3DSA:3.40.50.300:FF:002194', NULL, NULL, '3''-phosphoadenosine 5''-phosphosulfate synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(52059, NULL, 'G3DSA:3.40.50.300:FF:000064', NULL, NULL, 'Septin 4', NULL, NULL, NULL, NULL, NULL, 4),
(52060, NULL, 'G3DSA:3.80.10.10:FF:001305', NULL, NULL, 'EIN3-binding F-box domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(52061, NULL, 'G3DSA:3.40.50.300:FF:002137', NULL, NULL, 'Elongation factor 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52062, NULL, 'G3DSA:2.60.40.3120:FF:000005', NULL, NULL, 'Putative zinc carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(52063, NULL, 'G3DSA:2.70.50.30:FF:000007', NULL, NULL, 'Rho GDI/ GDP dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(52064, NULL, 'G3DSA:1.20.1050.10:FF:000268', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52065, NULL, 'G3DSA:3.40.1160.10:FF:000034', NULL, NULL, 'Acetylglutamate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(52066, NULL, 'G3DSA:3.40.50.300:FF:000743', NULL, NULL, 'Torsin', NULL, NULL, NULL, NULL, NULL, 4),
(52067, NULL, 'G3DSA:1.10.287.70:FF:000636', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52068, NULL, 'G3DSA:3.20.10.10:FF:000038', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(52069, NULL, 'G3DSA:1.20.1560.10:FF:000464', NULL, NULL, 'ATP-binding cassette sub-family B member 6, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(52070, NULL, 'G3DSA:2.60.40.780:FF:000002', NULL, NULL, 'von Hippel-Lindau disease tumor suppressor', NULL, NULL, NULL, NULL, NULL, 4),
(52071, NULL, 'G3DSA:3.40.30.10:FF:000033', NULL, NULL, 'Calsequestrin', NULL, NULL, NULL, NULL, NULL, 4),
(52072, NULL, 'G3DSA:2.60.60.20:FF:000067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52073, NULL, 'G3DSA:1.10.10.60:FF:000114', NULL, NULL, 'cyclin-D-binding Myb-like transcription factor 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(52074, NULL, 'G3DSA:1.25.40.10:FF:001872', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52075, NULL, 'G3DSA:1.10.10.60:FF:000226', NULL, NULL, 'Paired box gene 4', NULL, NULL, NULL, NULL, NULL, 4),
(52076, NULL, 'G3DSA:3.40.50.300:FF:003554', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52077, NULL, 'G3DSA:3.90.190.10:FF:000290', NULL, NULL, 'Protein tyrosine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(52078, NULL, 'G3DSA:2.60.120.330:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52079, NULL, 'G3DSA:2.150.10.10:FF:000012', NULL, NULL, 'Putative Mannuronan C-5-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(52080, NULL, 'G3DSA:3.40.50.300:FF:005678', NULL, NULL, 'DnaJ-like protein subfamily C member 27', NULL, NULL, NULL, NULL, NULL, 4),
(52081, NULL, 'G3DSA:3.80.10.10:FF:002828', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52082, NULL, 'G3DSA:1.25.40.10:FF:001990', NULL, NULL, 'Os05g0439300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(52083, NULL, 'G3DSA:2.60.40.790:FF:000005', NULL, NULL, 'Small heat shock protein IbpB', NULL, NULL, NULL, NULL, NULL, 4),
(52084, NULL, 'G3DSA:3.10.450.10:FF:000002', NULL, NULL, 'Kininogen 1', NULL, NULL, NULL, NULL, NULL, 4),
(52085, NULL, 'G3DSA:3.30.420.10:FF:000467', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52086, NULL, 'G3DSA:3.40.50.150:FF:001671', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52087, NULL, 'G3DSA:2.40.20.10:FF:000074', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52088, NULL, 'G3DSA:1.20.1070.10:FF:001371', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52089, NULL, 'G3DSA:1.10.533.10:FF:000270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52090, NULL, 'G3DSA:3.30.450.20:FF:000287', NULL, NULL, 'Transcriptional regulator TyrR', NULL, NULL, NULL, NULL, NULL, 4),
(52091, NULL, 'G3DSA:2.80.10.50:FF:000027', NULL, NULL, 'Interleukin-1 beta', NULL, NULL, NULL, NULL, NULL, 4),
(52092, NULL, 'G3DSA:3.10.490.10:FF:000010', NULL, NULL, 'Urea amidolyase', NULL, NULL, NULL, NULL, NULL, 4),
(52093, NULL, 'G3DSA:3.30.160.60:FF:005857', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52094, NULL, 'G3DSA:1.25.40.20:FF:001875', NULL, NULL, 'Leucine-rich repeat serine/threonine-protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(52095, NULL, 'G3DSA:2.40.110.10:FF:000018', NULL, NULL, 'Acyl-CoA dehydrogenase fadE29', NULL, NULL, NULL, NULL, NULL, 4),
(52096, NULL, 'G3DSA:1.10.8.10:FF:000216', NULL, NULL, 'ER organization and biogenesis-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52097, NULL, 'G3DSA:2.60.40.10:FF:005436', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52098, NULL, 'G3DSA:3.30.160.60:FF:003795', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52099, NULL, 'G3DSA:1.25.40.180:FF:000075', NULL, NULL, 'SGD1p nuclear protein', NULL, NULL, NULL, NULL, NULL, 4),
(52100, NULL, 'G3DSA:2.70.150.10:FF:000110', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(52101, NULL, 'G3DSA:3.40.1550.10:FF:000002', NULL, NULL, 'Chemotaxis protein CheX', NULL, NULL, NULL, NULL, NULL, 4),
(52102, NULL, 'G3DSA:3.20.80.10:FF:000025', NULL, NULL, 'Heme-binding-like protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(52103, NULL, 'G3DSA:2.110.10.10:FF:000053', NULL, NULL, 'Hemopexin', NULL, NULL, NULL, NULL, NULL, 4),
(52104, NULL, 'G3DSA:3.80.10.10:FF:000468', NULL, NULL, 'nischarin isoform X2', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(52105, NULL, 'G3DSA:1.20.1070.10:FF:001899', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52106, NULL, 'G3DSA:1.20.120.350:FF:000162', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52107, NULL, 'G3DSA:3.40.630.30:FF:000285', NULL, NULL, 'GNAT family N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(52108, NULL, 'G3DSA:1.10.530.10:FF:000033', NULL, NULL, 'Transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(52109, NULL, 'G3DSA:2.60.120.290:FF:000235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52110, NULL, 'G3DSA:2.60.120.620:FF:000025', NULL, NULL, 'MGC115642 protein', NULL, NULL, NULL, NULL, NULL, 4),
(52111, NULL, 'G3DSA:3.10.105.10:FF:000037', NULL, NULL, 'Nickel ABC transporter periplasmic nickel-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(52112, NULL, 'G3DSA:1.10.1740.10:FF:000042', NULL, NULL, 'ECF RNA polymerase sigma factor SigJ', NULL, NULL, NULL, NULL, NULL, 4),
(52113, NULL, 'G3DSA:3.10.20.90:FF:000254', NULL, NULL, 'UV excision repair protein Rad23', NULL, NULL, NULL, NULL, NULL, 4),
(52114, NULL, 'G3DSA:1.10.268.10:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52115, NULL, 'G3DSA:1.10.8.60:FF:000478', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52116, NULL, 'G3DSA:3.60.10.10:FF:000183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52117, NULL, 'G3DSA:3.30.930.10:FF:000282', NULL, NULL, 'Phenylalanine--tRNA ligase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(52118, NULL, 'G3DSA:3.30.70.330:FF:001506', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52119, NULL, 'G3DSA:3.30.70.580:FF:000024', NULL, NULL, 'RNA pseudouridylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(52120, NULL, 'G3DSA:1.10.510.10:FF:002206', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(52121, NULL, 'G3DSA:1.10.287.3240:FF:000015', NULL, NULL, 'Vacuolar ATP synthase subunit d, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52122, NULL, 'G3DSA:3.10.490.20:FF:000013', NULL, NULL, 'Dynein, axonemal, heavy chain 11', NULL, NULL, NULL, NULL, NULL, 4),
(52123, NULL, 'G3DSA:1.10.510.10:FF:002263', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52124, NULL, 'G3DSA:1.20.920.10:FF:000178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52125, NULL, 'G3DSA:2.60.40.10:FF:004301', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52126, NULL, 'G3DSA:3.30.479.20:FF:000044', NULL, NULL, 'Elongation factor Ts, mitochondrial 2', NULL, NULL, NULL, NULL, NULL, 4),
(52127, NULL, 'G3DSA:1.25.40.10:FF:005149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52128, NULL, 'G3DSA:1.20.810.10:FF:000013', NULL, NULL, 'Cytochrome bc1 complex cytochrome b subunit', NULL, NULL, NULL, NULL, NULL, 4),
(52129, NULL, 'G3DSA:3.10.100.10:FF:000341', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52130, NULL, 'G3DSA:1.20.1070.10:FF:001314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52131, NULL, 'G3DSA:3.30.40.10:FF:001624', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52132, NULL, 'G3DSA:3.30.420.110:FF:000036', NULL, NULL, 'DNA mismatch repair protein MSH3', NULL, NULL, NULL, NULL, NULL, 4),
(52133, NULL, 'G3DSA:3.30.160.60:FF:000922', NULL, NULL, 'PR domain zinc finger protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(52134, NULL, 'G3DSA:3.30.1140.60:FF:000016', NULL, NULL, 'F-actin-capping protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(52135, NULL, 'G3DSA:3.10.105.10:FF:000094', NULL, NULL, 'Similar to periplasmic dipeptide transport protein (Dipeptide-binding protein) (DBP)-putative secreted, membrane associated or paryphoplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(52136, NULL, 'G3DSA:2.20.25.10:FF:000131', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(52137, NULL, 'G3DSA:2.60.40.10:FF:005369', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(52138, NULL, 'G3DSA:3.90.550.50:FF:000205', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(52139, NULL, 'G3DSA:1.10.275.10:FF:000006', NULL, NULL, 'Adenylosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(52140, NULL, 'G3DSA:2.40.50.990:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52141, NULL, 'G3DSA:1.20.120.550:FF:000014', NULL, NULL, 'Probable microsomal glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(52142, NULL, 'G3DSA:1.20.1270.60:FF:000119', NULL, NULL, 'Unplaced genomic scaffold supercont1.126, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(52143, NULL, 'G3DSA:3.90.550.10:FF:000222', NULL, NULL, '3-deoxy-manno-octulosonate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(52144, NULL, 'G3DSA:3.30.160.40:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52145, NULL, 'G3DSA:2.130.10.10:FF:003374', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52146, NULL, 'G3DSA:1.25.40.20:FF:000239', NULL, NULL, 'BTB/POZ domain and ankyrin repeat-containing protein NPR1', NULL, NULL, NULL, NULL, NULL, 4),
(52147, NULL, 'G3DSA:2.130.10.10:FF:000125', NULL, NULL, 'Outer membrane protein assembly factor BamB', NULL, NULL, NULL, NULL, NULL, 4),
(52148, NULL, 'G3DSA:1.10.275.20:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52149, NULL, 'G3DSA:1.10.287.950:FF:000052', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52150, NULL, 'G3DSA:3.40.50.2300:FF:001308', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52151, NULL, 'G3DSA:3.10.20.90:FF:000815', NULL, NULL, 'F15I1.6 protein', NULL, NULL, NULL, NULL, NULL, 4),
(52152, NULL, 'G3DSA:3.30.200.20:FF:001095', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase CES101 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(52153, NULL, 'G3DSA:3.30.70.890:FF:000027', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(52154, NULL, 'G3DSA:3.30.70.330:FF:002855', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52155, NULL, 'G3DSA:1.20.1600.10:FF:000052', NULL, NULL, 'Efflux pump, RND family, outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(52156, NULL, 'G3DSA:1.20.58.150:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52157, NULL, 'G3DSA:3.30.210.10:FF:000013', NULL, NULL, 'Putative DNA polymerase X', NULL, NULL, NULL, NULL, NULL, 4),
(52158, NULL, 'G3DSA:2.60.40.10:FF:002210', NULL, NULL, 'Hibris, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(52159, NULL, 'G3DSA:2.130.10.10:FF:001749', NULL, NULL, 'Nucleoporin SEH1', NULL, NULL, NULL, NULL, NULL, 4),
(52160, NULL, 'G3DSA:3.50.50.60:FF:000498', NULL, NULL, 'FAD-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(52161, NULL, 'G3DSA:1.25.40.10:FF:000236', NULL, NULL, 'pre-mRNA-processing factor 39 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(52162, NULL, 'G3DSA:1.20.1560.10:FF:000559', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52163, NULL, 'G3DSA:1.20.5.170:FF:000289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52164, NULL, 'G3DSA:1.20.1250.20:FF:000865', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52165, NULL, 'G3DSA:3.40.50.720:FF:002488', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52166, NULL, 'G3DSA:2.120.10.80:FF:000410', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52167, NULL, 'G3DSA:3.30.160.60:FF:000029', NULL, NULL, 'GLI family zinc finger 4', NULL, NULL, NULL, NULL, NULL, 4),
(52168, NULL, 'G3DSA:3.10.20.310:FF:000005', NULL, NULL, 'Outer membrane protein assembly factor BamA', NULL, NULL, NULL, NULL, NULL, 4),
(52169, NULL, 'G3DSA:3.40.50.10190:FF:000229', NULL, NULL, 'CTD phosphatase-related (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(52170, NULL, 'G3DSA:3.30.1370.210:FF:000024', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(52171, NULL, 'G3DSA:3.40.50.300:FF:004554', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52172, NULL, 'G3DSA:1.20.1250.20:FF:001303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52173, NULL, 'G3DSA:3.40.50.2300:FF:001573', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52174, NULL, 'G3DSA:3.20.20.220:FF:000083', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(52175, NULL, 'G3DSA:1.10.8.870:FF:000023', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(52176, NULL, 'G3DSA:3.40.50.360:FF:000008', NULL, NULL, 'Glutathione-regulated potassium-efflux system ancillary protein KefF', NULL, NULL, NULL, NULL, NULL, 4),
(52177, NULL, 'G3DSA:1.25.40.10:FF:000978', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(52178, NULL, 'G3DSA:3.60.20.10:FF:000189', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52179, NULL, 'G3DSA:2.60.40.60:FF:000055', NULL, NULL, 'protocadherin-15 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(52180, NULL, 'G3DSA:1.25.40.450:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52181, NULL, 'G3DSA:2.30.33.40:FF:000028', NULL, NULL, 'Os06g0197550 protein', NULL, NULL, NULL, NULL, NULL, 4),
(52182, NULL, 'G3DSA:3.80.10.10:FF:004178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52183, NULL, 'G3DSA:3.30.70.870:FF:000021', NULL, NULL, 'Putative Mitochondrial elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(52184, NULL, 'G3DSA:1.10.275.10:FF:000017', NULL, NULL, 'Argininosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(52185, NULL, 'G3DSA:3.30.160.60:FF:005970', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52186, NULL, 'G3DSA:1.20.1500.20:FF:000002', NULL, NULL, 'DEAD/DEAH box helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52187, NULL, 'G3DSA:1.10.10.10:FF:001925', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52188, NULL, 'G3DSA:3.40.50.1820:FF:000748', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52189, NULL, 'G3DSA:3.40.50.150:FF:001749', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52190, NULL, 'G3DSA:1.25.40.20:FF:000801', NULL, NULL, 'Protein 21.1', NULL, NULL, NULL, NULL, NULL, 4),
(52191, NULL, 'G3DSA:3.80.10.10:FF:003722', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52192, NULL, 'G3DSA:2.130.10.10:FF:003935', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52193, NULL, 'G3DSA:3.80.10.10:FF:004476', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52194, NULL, 'G3DSA:1.10.1000.11:FF:000021', NULL, NULL, 'Golgi-specific brefeldin A-resistance factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(52195, NULL, 'G3DSA:1.10.20.10:FF:000330', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52196, NULL, 'G3DSA:3.40.30.10:FF:000471', NULL, NULL, 'Glutathione S-transferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(52197, NULL, 'G3DSA:1.20.1740.10:FF:000175', NULL, NULL, 'Transport protein (Probable substrate cationic amino acids)', NULL, NULL, NULL, NULL, NULL, 4),
(52198, NULL, 'G3DSA:2.30.40.10:FF:000126', NULL, NULL, '5-methylthioadenosine-S-adenosylhomocysteine deaminase protein', NULL, NULL, NULL, NULL, NULL, 4),
(52199, NULL, 'G3DSA:1.20.120.1460:FF:000002', NULL, NULL, 'tRNA-dihydrouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(52200, NULL, 'G3DSA:1.20.1070.10:FF:000831', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52201, NULL, 'G3DSA:3.90.70.10:FF:000544', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52202, NULL, 'G3DSA:1.10.287.500:FF:000001', NULL, NULL, 'Protein phosphatase CheZ', NULL, NULL, NULL, NULL, NULL, 4),
(52203, NULL, 'G3DSA:3.30.160.60:FF:000361', NULL, NULL, 'Zinc finger protein 658', NULL, NULL, NULL, NULL, NULL, 4),
(52204, NULL, 'G3DSA:4.10.410.10:FF:000018', NULL, NULL, 'Tissue factor pathway inhibitor', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(52205, NULL, 'G3DSA:3.40.80.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52206, NULL, 'G3DSA:1.20.1250.20:FF:000983', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52207, NULL, 'G3DSA:3.30.420.40:FF:001084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52208, NULL, 'G3DSA:2.10.25.10:FF:001148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52209, NULL, 'G3DSA:3.30.1130.10:FF:000023', NULL, NULL, 'Dihydropteroate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(52210, NULL, 'G3DSA:1.10.510.10:FF:003634', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52211, NULL, 'G3DSA:1.10.1410.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52212, NULL, 'G3DSA:2.40.50.100:FF:000142', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(52213, NULL, 'G3DSA:1.25.40.10:FF:001254', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(52214, NULL, 'G3DSA:3.40.50.300:FF:007505', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52215, NULL, 'G3DSA:3.30.200.20:FF:001825', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(52216, NULL, 'G3DSA:1.20.1630.10:FF:000003', NULL, NULL, 'Oxidoreductase, membrane subunit', NULL, NULL, NULL, NULL, NULL, 4),
(52217, NULL, 'G3DSA:1.10.150.560:FF:000003', NULL, NULL, 'Major DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(52218, NULL, 'G3DSA:3.40.50.20:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52219, NULL, 'G3DSA:2.30.34.10:FF:000005', NULL, NULL, 'GP63-like protein, leishmanolysin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(52220, NULL, 'G3DSA:3.30.70.330:FF:001394', NULL, NULL, 'RBD (RNA binding domain) protein', NULL, NULL, NULL, NULL, NULL, 4),
(52221, NULL, 'G3DSA:1.10.10.10:FF:001982', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52222, NULL, 'G3DSA:1.25.40.10:FF:005183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52223, NULL, 'G3DSA:3.30.160.60:FF:001928', NULL, NULL, 'Zinc finger protein 131', NULL, NULL, NULL, NULL, NULL, 4),
(52224, NULL, 'G3DSA:2.40.30.20:FF:000038', NULL, NULL, 'H(+)-transporting ATP synthase, subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(52225, NULL, 'G3DSA:3.30.200.20:FF:002101', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52226, NULL, 'G3DSA:3.30.930.10:FF:000214', NULL, NULL, 'Aspartate--tRNA(Asp/Asn) ligase', NULL, NULL, NULL, NULL, NULL, 4),
(52227, NULL, 'G3DSA:1.10.565.10:FF:000175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52228, NULL, 'G3DSA:1.10.472.80:FF:000137', NULL, NULL, 'Rab GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52229, NULL, 'G3DSA:3.50.30.30:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52230, NULL, 'G3DSA:1.20.1250.20:FF:001360', NULL, NULL, 'Major facilitator superfamily domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(52231, NULL, 'G3DSA:2.40.30.10:FF:000035', NULL, NULL, 'HBS1-like translational GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(52232, NULL, 'G3DSA:1.10.287.520:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52233, NULL, 'G3DSA:2.10.80.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52234, NULL, 'G3DSA:2.60.40.150:FF:000055', NULL, NULL, 'Toll-interacting protein-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(52235, NULL, 'G3DSA:3.50.50.60:FF:001049', NULL, NULL, 'D-amino acid dehydrogenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(52236, NULL, 'G3DSA:1.25.10.10:FF:000408', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52237, NULL, 'G3DSA:3.40.120.10:FF:000105', NULL, NULL, 'Phosphoglucomutase/phosphomannomutase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(52238, NULL, 'G3DSA:2.130.10.10:FF:003992', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(52239, NULL, 'G3DSA:1.10.1520.10:FF:000059', NULL, NULL, 'Endoribonuclease Dicer-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(52240, NULL, 'G3DSA:2.30.30.190:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52241, NULL, 'G3DSA:3.10.100.10:FF:000133', NULL, NULL, 'C-type LECtin', NULL, NULL, NULL, NULL, NULL, 4),
(52242, NULL, 'G3DSA:2.10.60.10:FF:000050', NULL, NULL, 'TGF-beta receptor type-2', NULL, NULL, NULL, NULL, NULL, 4),
(52243, NULL, 'G3DSA:3.80.10.10:FF:004419', NULL, NULL, 'Receptor-like protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(52244, NULL, 'G3DSA:1.20.1250.20:FF:001921', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52245, NULL, 'G3DSA:2.20.25.10:FF:000018', NULL, NULL, 'Multifunctional methyltransferase subunit TRM112-like B', NULL, NULL, NULL, NULL, NULL, 4),
(52246, NULL, 'G3DSA:2.60.120.920:FF:000019', NULL, NULL, 'Ryanodine receptor 1 (skeletal)', NULL, NULL, NULL, NULL, NULL, 4),
(52247, NULL, 'G3DSA:2.30.29.30:FF:000937', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52248, NULL, 'G3DSA:3.30.160.20:FF:000197', NULL, NULL, 'Class I peptide chain release factor', NULL, NULL, NULL, NULL, NULL, 4),
(52249, NULL, 'G3DSA:2.170.240.10:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52250, NULL, 'G3DSA:2.130.10.10:FF:005791', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52251, NULL, 'G3DSA:4.10.400.10:FF:000080', NULL, NULL, 'Low-density lipoprotein receptor-related protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(52252, NULL, 'G3DSA:2.130.10.10:FF:005734', NULL, NULL, 'Vacuolar protein sorting/targeting protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(52253, NULL, 'G3DSA:3.30.40.10:FF:001124', NULL, NULL, 'YALI0F20834p', NULL, NULL, NULL, NULL, NULL, 4),
(52254, NULL, 'G3DSA:1.10.101.10:FF:000025', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(52255, NULL, 'G3DSA:2.170.300.10:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52256, NULL, 'G3DSA:2.170.270.10:FF:000100', NULL, NULL, 'PR domain-containing 2, with ZNF domain b', NULL, NULL, NULL, NULL, NULL, 4),
(52257, NULL, 'G3DSA:3.30.1390.30:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52258, NULL, 'G3DSA:3.40.50.2300:FF:001516', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52259, NULL, 'G3DSA:3.40.50.720:FF:001414', NULL, NULL, 'NAD binding domain of 6-phosphogluconate dehydrogenase/NAD-binding of NADP-dependent 3-hydroxyisobutyrate dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52260, NULL, 'G3DSA:3.30.342.10:FF:000033', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(52261, NULL, 'G3DSA:2.60.40.10:FF:003284', NULL, NULL, 'Mcam protein', NULL, NULL, NULL, NULL, NULL, 4),
(52262, NULL, 'G3DSA:1.25.40.180:FF:000086', NULL, NULL, 'Eukaryotic initiation factor 4a, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52263, NULL, 'G3DSA:1.10.510.10:FF:003898', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52264, NULL, 'G3DSA:3.30.200.20:FF:001207', NULL, NULL, 'CDPK-related kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(52265, NULL, 'G3DSA:2.60.40.10:FF:003924', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52266, NULL, 'G3DSA:1.20.120.80:FF:000020', NULL, NULL, 'Cytochrome c oxidase polypeptide I', NULL, NULL, NULL, NULL, NULL, 4),
(52267, NULL, 'G3DSA:1.10.510.10:FF:001482', NULL, NULL, 'Serine/threonine-protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(52268, NULL, 'G3DSA:2.130.10.10:FF:003615', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52269, NULL, 'G3DSA:3.40.30.10:FF:000319', NULL, NULL, 'Thioredoxin domain-containing protein PLP3B', NULL, NULL, NULL, NULL, NULL, 4),
(52270, NULL, 'G3DSA:3.20.20.70:FF:000461', NULL, NULL, 'Magnesium-dependent deoxyribonuclease, TatD family, and radical SAM domain iron-sulfur oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(52271, NULL, 'G3DSA:3.20.20.70:FF:000747', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(52272, NULL, 'G3DSA:3.20.20.80:FF:000464', NULL, NULL, 'Beta-glucosidase 40', NULL, NULL, NULL, NULL, NULL, 4),
(52273, NULL, 'G3DSA:1.10.238.10:FF:000224', NULL, NULL, 'CMD1p Calmodulin', NULL, NULL, NULL, NULL, NULL, 4),
(52274, NULL, 'G3DSA:2.130.10.10:FF:005173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52275, NULL, 'G3DSA:2.40.330.10:FF:000001', NULL, NULL, 'Auxin response factor', NULL, NULL, NULL, NULL, NULL, 4),
(52276, NULL, 'G3DSA:1.25.40.10:FF:002310', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g77170, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(52277, NULL, 'G3DSA:3.30.980.10:FF:000048', NULL, NULL, 'Threonine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(52278, NULL, 'G3DSA:1.10.510.10:FF:002274', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52279, NULL, 'G3DSA:2.60.120.680:FF:000015', NULL, NULL, 'Oxysterol-binding protein related protein', NULL, NULL, NULL, NULL, NULL, 4),
(52280, NULL, 'G3DSA:3.40.50.620:FF:000659', NULL, NULL, 'DALR anticodon binding domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(52281, NULL, 'G3DSA:2.130.10.10:FF:004897', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52282, NULL, 'G3DSA:1.10.3080.10:FF:000008', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(52283, NULL, 'G3DSA:1.20.1740.10:FF:000118', NULL, NULL, 'Amino acid permease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52284, NULL, 'G3DSA:2.60.120.620:FF:000104', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52285, NULL, 'G3DSA:3.30.160.60:FF:006313', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52286, NULL, 'G3DSA:3.30.200.20:FF:001084', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(52287, NULL, 'G3DSA:1.25.10.10:FF:000201', NULL, NULL, 'Importin beta-3 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(52288, NULL, 'G3DSA:2.60.120.10:FF:000099', NULL, NULL, '1,2-dihydroxy-3-keto-5-methylthiopentene dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(52289, NULL, 'G3DSA:1.10.287.130:FF:000216', NULL, NULL, 'Two-component system sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(52290, NULL, 'G3DSA:3.30.70.890:FF:000016', NULL, NULL, 'Homoserine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(52291, NULL, 'G3DSA:1.10.10.10:FF:001364', NULL, NULL, 'Protein CBR-DSH-2', NULL, NULL, NULL, NULL, NULL, 4),
(52292, NULL, 'G3DSA:1.20.5.340:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52293, NULL, 'G3DSA:1.10.510.10:FF:003691', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52294, NULL, 'G3DSA:3.30.160.60:FF:005818', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52295, NULL, 'G3DSA:1.10.8.60:FF:000248', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(52296, NULL, 'G3DSA:3.60.10.10:FF:000194', NULL, NULL, 'Endonuclease/exonuclease/phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(52297, NULL, 'G3DSA:3.30.160.60:FF:001367', NULL, NULL, 'replication initiator 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(52298, NULL, 'G3DSA:1.25.10.10:FF:000066', NULL, NULL, 'Splicing factor 3B subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(52299, NULL, 'G3DSA:1.10.1040.50:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52300, NULL, 'G3DSA:3.40.50.2300:FF:000679', NULL, NULL, 'Peroxide stress-activated histidine kinase mak2', NULL, NULL, NULL, NULL, NULL, 4),
(52301, NULL, 'G3DSA:1.10.510.10:FF:000200', NULL, NULL, 'inactive tyrosine-protein kinase 7', NULL, NULL, NULL, NULL, NULL, 4),
(52302, NULL, 'G3DSA:1.10.20.10:FF:000055', NULL, NULL, 'Transcription initiation factor TFIID subunit 11', NULL, NULL, NULL, NULL, NULL, 4),
(52303, NULL, 'G3DSA:3.90.1200.10:FF:000066', NULL, NULL, 'Aminoglycoside phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(52304, NULL, 'G3DSA:3.30.160.60:FF:000681', NULL, NULL, 'zinc finger protein 205 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(52305, NULL, 'G3DSA:3.90.1200.10:FF:000009', NULL, NULL, 'Acyl-CoA dehydrogenase family member 11', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(52306, NULL, 'G3DSA:1.20.120.550:FF:000003', NULL, NULL, 'Leukotriene C4 synthase', NULL, NULL, NULL, NULL, NULL, 4),
(52307, NULL, 'G3DSA:3.40.140.10:FF:000191', NULL, NULL, 'Cytidine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(52308, NULL, 'G3DSA:1.10.520.10:FF:000026', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(52309, NULL, 'G3DSA:3.30.70.1230:FF:000181', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52310, NULL, 'G3DSA:1.20.5.110:FF:000344', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52311, NULL, 'G3DSA:1.10.287.70:FF:000557', NULL, NULL, 'Voltage-dependent calcium channel type A subunit alpha-1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(52312, NULL, 'G3DSA:1.20.120.350:FF:000123', NULL, NULL, 'Potassium channel subunit', NULL, NULL, NULL, NULL, NULL, 4),
(52313, NULL, 'G3DSA:1.10.600.10:FF:000084', NULL, NULL, 'Phytoene/squalene synthase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(52314, NULL, 'G3DSA:3.40.50.10190:FF:000061', NULL, NULL, 'Transcription coactivator', NULL, NULL, NULL, NULL, NULL, 4),
(52315, NULL, 'G3DSA:1.20.1050.20:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52316, NULL, 'G3DSA:1.10.287.110:FF:000210', NULL, NULL, 'DnaJ domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52317, NULL, 'G3DSA:2.30.31.10:FF:000021', NULL, NULL, 'SsDNA-binding transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(52318, NULL, 'G3DSA:3.30.70.870:FF:000010', NULL, NULL, 'GTP-binding translation elongation factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52319, NULL, 'G3DSA:3.80.10.10:FF:000822', NULL, NULL, 'Patatin', NULL, NULL, NULL, NULL, NULL, 4),
(52320, NULL, 'G3DSA:2.60.40.10:FF:000411', NULL, NULL, 'Vascular endothelial growth factor receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(52321, NULL, 'G3DSA:2.30.30.140:FF:000259', NULL, NULL, 'SGF29 tudor-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(52322, NULL, 'G3DSA:3.30.40.10:FF:000961', NULL, NULL, 'TNF-receptor-associated factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(52323, NULL, 'G3DSA:3.30.465.10:FF:000099', NULL, NULL, 'Xanthine dehydrogenase/oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(52324, NULL, 'G3DSA:3.30.420.40:FF:000510', NULL, NULL, 'Kanosamine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(52325, NULL, 'G3DSA:3.20.20.140:FF:000446', NULL, NULL, 'Polymerase/histidinol phosphatase-like', NULL, NULL, NULL, NULL, NULL, 4),
(52326, NULL, 'G3DSA:3.30.1330.80:FF:000003', NULL, NULL, 'AT-hook motif nuclear-localized protein 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(52327, NULL, 'G3DSA:2.10.25.10:FF:001261', NULL, NULL, 'Bb-cadherin', NULL, NULL, NULL, NULL, NULL, 4),
(52328, NULL, 'G3DSA:1.25.10.10:FF:001426', NULL, NULL, 'Spindle pole body protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52329, NULL, 'G3DSA:3.50.50.60:FF:000829', NULL, NULL, 'YALI0D21076p', NULL, NULL, NULL, NULL, NULL, 4),
(52330, NULL, 'G3DSA:1.10.1420.10:FF:000181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52331, NULL, 'G3DSA:1.20.1250.20:FF:001180', NULL, NULL, 'Pantothenate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(52332, NULL, 'G3DSA:3.30.1360.120:FF:000085', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(52333, NULL, 'G3DSA:3.90.70.10:FF:000005', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 7', NULL, NULL, NULL, NULL, NULL, 4),
(52334, NULL, 'G3DSA:1.10.20.120:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52335, NULL, 'G3DSA:1.20.58.60:FF:000437', NULL, NULL, 'Dystonin', NULL, NULL, NULL, NULL, NULL, 4),
(52336, NULL, 'G3DSA:3.20.20.70:FF:000186', NULL, NULL, 'Lipoyl synthase', NULL, NULL, NULL, NULL, NULL, 4),
(52337, NULL, 'G3DSA:2.60.120.1540:FF:000020', NULL, NULL, 'Complement component 4A (Rodgers blood group)', NULL, NULL, NULL, NULL, NULL, 4),
(52338, NULL, 'G3DSA:3.20.20.80:FF:000189', NULL, NULL, 'Endoglucanase', NULL, NULL, NULL, NULL, NULL, 4),
(52339, NULL, 'G3DSA:1.10.3520.10:FF:000026', NULL, NULL, 'ceramide-1-phosphate transfer protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(52340, NULL, 'G3DSA:3.30.160.330:FF:000003', NULL, NULL, 'Protein E7', NULL, NULL, NULL, NULL, NULL, 4),
(52341, NULL, 'G3DSA:3.40.50.2020:FF:000067', NULL, NULL, 'Ribose-phosphate diphosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(52342, NULL, 'G3DSA:2.70.98.30:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52343, NULL, 'G3DSA:2.10.25.10:FF:000367', NULL, NULL, 'EGF-containing fibulin-like extracellular matrix protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(52344, NULL, 'G3DSA:3.40.50.1110:FF:000069', NULL, NULL, 'GDSL esterase/lipase 6', NULL, NULL, NULL, NULL, NULL, 4),
(52345, NULL, 'G3DSA:3.30.160.60:FF:002159', NULL, NULL, 'Zinc finger protein 841', NULL, NULL, NULL, NULL, NULL, 4),
(52346, NULL, 'G3DSA:1.20.1110.10:FF:000026', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(52347, NULL, 'G3DSA:3.30.1120.90:FF:000001', NULL, NULL, 'Nucleosome assembly protein 1-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(52348, NULL, 'G3DSA:3.90.1410.10:FF:000109', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52349, NULL, 'G3DSA:2.10.25.10:FF:000985', NULL, NULL, 'NIDogen (Basement membrane protein)', NULL, NULL, NULL, NULL, NULL, 4),
(52350, NULL, 'G3DSA:2.60.120.200:FF:000714', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52351, NULL, 'G3DSA:3.40.50.300:FF:005914', NULL, NULL, 'ATP-binding cassette transporter (ABC transporter) family C member 11', NULL, NULL, NULL, NULL, NULL, 4),
(52352, NULL, 'G3DSA:3.40.50.300:FF:001120', NULL, NULL, 'ADP-ribosylation factor family', NULL, NULL, NULL, NULL, NULL, 4),
(52353, NULL, 'G3DSA:3.40.50.11040:FF:000001', NULL, NULL, 'RNA cytidine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(52354, NULL, 'G3DSA:3.40.50.10190:FF:000268', NULL, NULL, 'Putative dna topoisomerase 2-binding protein 1 isoform x1', NULL, NULL, NULL, NULL, NULL, 4),
(52355, NULL, 'G3DSA:3.40.1370.10:FF:000016', NULL, NULL, '60S ribosomal protein L4, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(52356, NULL, 'G3DSA:3.40.47.10:FF:000043', NULL, NULL, '3-hydroxy-3-methylglutaryl CoA synthase', NULL, NULL, NULL, NULL, NULL, 4),
(52357, NULL, 'G3DSA:2.130.10.10:FF:005914', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52358, NULL, 'G3DSA:3.30.450.20:FF:000298', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(52359, NULL, 'G3DSA:1.20.5.4820:FF:000007', NULL, NULL, 'Myosin-A', NULL, NULL, NULL, NULL, NULL, 4),
(52360, NULL, 'G3DSA:3.90.780.10:FF:000031', NULL, NULL, 'Putative nucleotidase YunD', NULL, NULL, NULL, NULL, NULL, 4),
(52361, NULL, 'G3DSA:3.30.479.20:FF:000055', NULL, NULL, 'Elongation factor Ts 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(52362, NULL, 'G3DSA:2.40.50.100:FF:000221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52363, NULL, 'G3DSA:2.20.28.230:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52364, NULL, 'G3DSA:1.50.40.10:FF:000178', NULL, NULL, 'Mitochondrial Carrier (MC) Family', NULL, NULL, NULL, NULL, NULL, 4),
(52365, NULL, 'G3DSA:3.40.50.1820:FF:000866', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52366, NULL, 'G3DSA:3.40.50.300:FF:001974', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(52367, NULL, 'G3DSA:3.30.160.60:FF:002721', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52368, NULL, 'G3DSA:3.30.1540.20:FF:000012', NULL, NULL, 'MutL homolog 3 (E. coli)', NULL, NULL, NULL, NULL, NULL, 4),
(52369, NULL, 'G3DSA:3.90.380.10:FF:000006', NULL, NULL, 'Chlorophyllide a oxygenase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(52370, NULL, 'G3DSA:1.10.10.60:FF:001238', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52371, NULL, 'G3DSA:3.40.50.300:FF:002542', NULL, NULL, 'ATP-dependent RNA helicase cgh-1', NULL, NULL, NULL, NULL, NULL, 4),
(52372, NULL, 'G3DSA:3.40.50.720:FF:000982', NULL, NULL, 'NmrA-like family protein (AFU_orthologue AFUA_8G01860)', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(52373, NULL, 'G3DSA:1.10.10.10:FF:000228', NULL, NULL, 'heterochromatin protein 1-binding protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(52374, NULL, 'G3DSA:1.10.150.80:FF:000018', NULL, NULL, 'Putative ribonuclease D', NULL, NULL, NULL, NULL, NULL, 4),
(52375, NULL, 'G3DSA:2.30.330.10:FF:000003', NULL, NULL, 'Flagellar motor switch protein FliM', NULL, NULL, NULL, NULL, NULL, 4),
(52376, NULL, 'G3DSA:3.40.30.10:FF:000645', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(52377, NULL, 'G3DSA:3.30.160.60:FF:003177', NULL, NULL, 'Zinc finger protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(52378, NULL, 'G3DSA:2.60.40.10:FF:003688', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52379, NULL, 'G3DSA:3.90.1100.10:FF:000002', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(52380, NULL, 'G3DSA:1.20.1740.10:FF:000096', NULL, NULL, 'Amino Acid Transporter', NULL, NULL, NULL, NULL, NULL, 4),
(52381, NULL, 'G3DSA:1.10.640.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52382, NULL, 'G3DSA:2.60.40.10:FF:000029', NULL, NULL, 'Myomesin 1', NULL, NULL, NULL, NULL, NULL, 4),
(52383, NULL, 'G3DSA:1.10.238.10:FF:000550', NULL, NULL, 'EF-hand calcium-binding domain 6', NULL, NULL, NULL, NULL, NULL, 4),
(52384, NULL, 'G3DSA:3.90.1170.30:FF:000001', NULL, NULL, 'Thymidine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(52385, NULL, 'G3DSA:3.40.50.200:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52386, NULL, 'G3DSA:3.40.50.300:FF:000395', NULL, NULL, 'Replication factor C subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(52387, NULL, 'G3DSA:3.40.50.300:FF:000451', NULL, NULL, 'Neuron navigator 2', NULL, NULL, NULL, NULL, NULL, 4),
(52388, NULL, 'G3DSA:3.10.580.10:FF:000163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52389, NULL, 'G3DSA:3.20.20.60:FF:000065', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(52390, NULL, 'G3DSA:3.90.550.10:FF:000660', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52391, NULL, 'G3DSA:2.30.42.10:FF:000288', NULL, NULL, 'MAGI family member, X-linked a', NULL, NULL, NULL, NULL, NULL, 4),
(52392, NULL, 'G3DSA:3.30.70.100:FF:000156', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52393, NULL, 'G3DSA:2.30.30.40:FF:000218', NULL, NULL, 'Myosin light chain kinase, smooth muscle', NULL, NULL, NULL, NULL, NULL, 4),
(52394, NULL, 'G3DSA:3.30.200.20:FF:000072', NULL, NULL, 'Rho-associated protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(52395, NULL, 'G3DSA:1.10.510.10:FF:003808', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52396, NULL, 'G3DSA:1.10.287.2900:FF:000003', NULL, NULL, 'mitochondrial intermembrane space import and assembly protein 40', NULL, NULL, NULL, NULL, NULL, 4),
(52397, NULL, 'G3DSA:2.130.10.10:FF:000007', NULL, NULL, 'Guanine nucleotide-binding protein G(I)/G(S)/G(T) subunit beta-1', NULL, NULL, NULL, NULL, NULL, 4),
(52398, NULL, 'G3DSA:1.25.40.660:FF:000016', NULL, NULL, 'Vacuolar protein sorting-associated protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(52399, NULL, 'G3DSA:3.40.50.2000:FF:001101', NULL, NULL, 'Protein CBG00513', NULL, NULL, NULL, NULL, NULL, 4),
(52400, NULL, 'G3DSA:1.10.10.1740:FF:000007', NULL, NULL, 'Transmembrane proteins 14C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52401, NULL, 'G3DSA:1.10.560.10:FF:000068', NULL, NULL, 'GD22056', NULL, NULL, NULL, NULL, NULL, 4),
(52402, NULL, 'G3DSA:1.10.1740.10:FF:000008', NULL, NULL, 'RNA polymerase sigma factor PvdS', NULL, NULL, NULL, NULL, NULL, 4),
(52403, NULL, 'G3DSA:2.60.40.10:FF:001597', NULL, NULL, 'V-type immunoglobulin domain-containing suppressor of T-cell activation', NULL, NULL, NULL, NULL, NULL, 4),
(52404, NULL, 'G3DSA:3.30.160.20:FF:000079', NULL, NULL, 'Disco interacting protein isoform TO67', NULL, NULL, NULL, NULL, NULL, 4),
(52405, NULL, 'G3DSA:3.20.10.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(52406, NULL, 'G3DSA:3.40.50.2000:FF:000477', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52407, NULL, 'G3DSA:3.90.70.10:FF:000331', NULL, NULL, 'Clan CA, family C1, cathepsin L-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(52408, NULL, 'G3DSA:2.40.240.10:FF:000028', NULL, NULL, 'Probable glutamine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(52409, NULL, 'G3DSA:2.10.270.10:FF:000003', NULL, NULL, 'Toxin B', NULL, NULL, NULL, NULL, NULL, 4),
(52410, NULL, 'G3DSA:1.10.510.10:FF:001717', NULL, NULL, 'Ribosomal protein S6 kinase A1', NULL, NULL, NULL, NULL, NULL, 4),
(52411, NULL, 'G3DSA:3.30.70.260:FF:000125', NULL, NULL, 'Homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(52412, NULL, 'G3DSA:3.30.200.20:FF:001651', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(52413, NULL, 'G3DSA:3.30.70.330:FF:003018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52414, NULL, 'G3DSA:1.10.238.110:FF:000009', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(52415, NULL, 'G3DSA:2.10.25.10:FF:000709', NULL, NULL, 'Protocadherin Fat 4', NULL, NULL, NULL, NULL, NULL, 4),
(52416, NULL, 'G3DSA:4.10.280.50:FF:000007', NULL, NULL, 'Glutamate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(52417, NULL, 'G3DSA:4.10.400.10:FF:000236', NULL, NULL, 'AGAP003656-PC', NULL, NULL, NULL, NULL, NULL, 4),
(52418, NULL, 'G3DSA:1.10.472.80:FF:000283', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52419, NULL, 'G3DSA:1.10.10.430:FF:000002', NULL, NULL, 'Protein phosphatase, Mg2+/Mn2+ dependent 1A', NULL, NULL, NULL, NULL, NULL, 4),
(52420, NULL, 'G3DSA:1.10.565.10:FF:000057', NULL, NULL, 'Retinoid x receptor', NULL, NULL, NULL, NULL, NULL, 4),
(52421, NULL, 'G3DSA:1.10.10.440:FF:000005', NULL, NULL, 'Transcription elongation regulator 1 (CA150)', NULL, NULL, NULL, NULL, NULL, 4),
(52422, NULL, 'G3DSA:2.40.50.40:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52423, NULL, 'G3DSA:3.20.80.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52424, NULL, 'G3DSA:3.30.160.60:FF:003284', NULL, NULL, 'KRAB zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(52425, NULL, 'G3DSA:3.40.50.150:FF:000440', NULL, NULL, 'Os09g0479300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(52426, NULL, 'G3DSA:3.30.200.20:FF:001595', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(52427, NULL, 'G3DSA:3.40.50.1820:FF:001541', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52428, NULL, 'G3DSA:2.30.42.10:FF:000395', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52429, NULL, 'G3DSA:2.60.40.2840:FF:000011', NULL, NULL, 'calcium-binding and coiled-coil domain-containing protein 2 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(52430, NULL, 'G3DSA:2.60.40.1730:FF:000021', NULL, NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(52431, NULL, 'G3DSA:3.40.50.300:FF:005919', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(52432, NULL, 'G3DSA:3.90.550.10:FF:000334', NULL, NULL, 'CMP-N-acetlyneuraminic acid synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(52433, NULL, 'G3DSA:3.30.70.3310:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52434, NULL, 'G3DSA:3.20.20.70:FF:000124', NULL, NULL, 'Heme chaperone HemW', NULL, NULL, NULL, NULL, NULL, 4),
(52435, NULL, 'G3DSA:3.30.565.10:FF:000432', NULL, NULL, 'Histidine kinase response regulator hybrid protein', NULL, NULL, NULL, NULL, NULL, 4),
(52436, NULL, 'G3DSA:3.80.10.10:FF:001603', NULL, NULL, 'Protein kinase family protein with leucine-rich repeat domain', NULL, NULL, NULL, NULL, NULL, 4),
(52437, NULL, 'G3DSA:2.130.10.10:FF:002250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52438, NULL, 'G3DSA:3.30.200.20:FF:001325', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(52439, NULL, 'G3DSA:3.30.70.330:FF:001624', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52440, NULL, 'G3DSA:1.20.1640.10:FF:000111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52441, NULL, 'G3DSA:3.10.20.90:FF:000372', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(52442, NULL, 'G3DSA:2.10.25.10:FF:000721', NULL, NULL, 'Odd Oz/ten-m (Odz2), mRNA protein', NULL, NULL, NULL, NULL, NULL, 4),
(52443, NULL, 'G3DSA:3.20.20.60:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52444, NULL, 'G3DSA:3.30.1600.10:FF:000003', NULL, NULL, 'NAD-dependent histone deacetylase sirtuin-1', NULL, NULL, NULL, NULL, NULL, 4),
(52445, NULL, 'G3DSA:3.40.50.300:FF:003739', NULL, NULL, 'Peroxisomal biogenesis factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(52446, NULL, 'G3DSA:3.30.450.20:FF:000528', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(52447, NULL, 'G3DSA:1.20.1310.10:FF:000125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52448, NULL, 'G3DSA:1.20.58.100:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52449, NULL, 'G3DSA:2.60.40.10:FF:002272', NULL, NULL, 'Paired immunoglobulin-like receptor B', NULL, NULL, NULL, NULL, NULL, 4),
(52450, NULL, 'G3DSA:3.40.30.10:FF:000971', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52451, NULL, 'G3DSA:3.30.70.100:FF:000105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52452, NULL, 'G3DSA:3.40.50.880:FF:000080', NULL, NULL, 'Para-aminobenzoate synthase, glutamine amidotransferase, component II', NULL, NULL, NULL, NULL, NULL, 4),
(52453, NULL, 'G3DSA:3.40.50.10420:FF:000051', NULL, NULL, 'Probable 5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(52454, NULL, 'G3DSA:3.20.20.60:FF:000014', NULL, NULL, 'Citrate lyase subunit beta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(52455, NULL, 'G3DSA:3.20.20.70:FF:000017', NULL, NULL, 'Glutamate synthase [NADH], amyloplastic', NULL, NULL, NULL, NULL, NULL, 4),
(52456, NULL, 'G3DSA:3.40.250.10:FF:000255', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52457, NULL, 'G3DSA:3.40.30.10:FF:000701', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(52458, NULL, 'G3DSA:1.20.1640.10:FF:000004', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(52459, NULL, 'G3DSA:1.10.510.10:FF:000464', NULL, NULL, 'Protein O-mannose kinase', NULL, NULL, NULL, NULL, NULL, 4),
(52460, NULL, 'G3DSA:2.130.10.10:FF:001249', NULL, NULL, 'WD repeat domain 54', NULL, NULL, NULL, NULL, NULL, 4),
(52461, NULL, 'G3DSA:3.40.50.300:FF:001648', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(52462, NULL, 'G3DSA:1.10.10.10:FF:001807', NULL, NULL, 'Transcriptional adapter', NULL, NULL, NULL, NULL, NULL, 4),
(52463, NULL, 'G3DSA:1.20.144.10:FF:000043', NULL, NULL, 'GD12067', NULL, NULL, NULL, NULL, NULL, 4),
(52464, NULL, 'G3DSA:1.10.275.60:FF:000004', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52465, NULL, 'G3DSA:4.10.400.10:FF:000343', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52466, NULL, 'G3DSA:2.70.130.10:FF:000108', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52467, NULL, 'G3DSA:1.25.40.10:FF:002041', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g09900', NULL, NULL, NULL, NULL, NULL, 4),
(52468, NULL, 'G3DSA:2.130.10.30:FF:000165', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52469, NULL, 'G3DSA:3.30.470.30:FF:000004', NULL, NULL, 'mRNA-capping enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(52470, NULL, 'G3DSA:1.25.40.20:FF:000806', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52471, NULL, 'G3DSA:1.10.287.110:FF:000042', NULL, NULL, 'Iron-sulfur cluster co-chaperone protein HscB, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(52472, NULL, 'G3DSA:1.20.58.2220:FF:000025', NULL, NULL, 'Formin-E', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(52473, NULL, 'G3DSA:3.40.50.1010:FF:000157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52474, NULL, 'G3DSA:3.40.50.1820:FF:000928', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(52475, NULL, 'G3DSA:3.40.50.2300:FF:001292', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52476, NULL, 'G3DSA:1.20.120.290:FF:000003', NULL, NULL, 'Photosynthetic NDH subunit of lumenal location 3, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(52477, NULL, 'G3DSA:3.80.10.10:FF:002907', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52478, NULL, 'G3DSA:3.40.640.10:FF:000010', NULL, NULL, 'Phosphoserine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(52479, NULL, 'G3DSA:3.40.50.720:FF:000875', NULL, NULL, 'tRNA threonylcarbamoyladenosine dehydratase 1', NULL, NULL, NULL, NULL, NULL, 4),
(52480, NULL, 'G3DSA:3.30.200.20:FF:000021', NULL, NULL, 'probable serine/threonine-protein kinase At1g54610', NULL, NULL, NULL, NULL, NULL, 4),
(52481, NULL, 'G3DSA:3.30.360.10:FF:000136', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52482, NULL, 'G3DSA:3.30.160.60:FF:004071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52483, NULL, 'G3DSA:2.40.440.10:FF:000009', NULL, NULL, 'L,D-transpeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(52484, NULL, 'G3DSA:2.60.40.200:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52485, NULL, 'G3DSA:1.25.10.10:FF:002325', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52486, NULL, 'G3DSA:3.40.630.30:FF:000633', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52487, NULL, 'G3DSA:2.130.10.10:FF:003559', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52488, NULL, 'G3DSA:1.20.1310.10:FF:000018', NULL, NULL, 'Cullin 2', NULL, NULL, NULL, NULL, NULL, 4),
(52489, NULL, 'G3DSA:1.10.10.650:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52490, NULL, 'G3DSA:3.30.70.330:FF:002299', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52491, NULL, 'G3DSA:2.60.120.10:FF:000149', NULL, NULL, '1,2-dihydroxy-3-keto-5-methylthiopentene dioxygenase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(52492, NULL, 'G3DSA:2.60.40.10:FF:000181', NULL, NULL, 'receptor-type tyrosine-protein phosphatase delta isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(52493, NULL, 'G3DSA:3.80.10.10:FF:000816', NULL, NULL, 'Nuclear RNA export factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(52494, NULL, 'G3DSA:3.30.40.10:FF:001063', NULL, NULL, 'Putative ring finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(52495, NULL, 'G3DSA:1.25.10.10:FF:002213', NULL, NULL, 'Nipped-B protein', NULL, NULL, NULL, NULL, NULL, 4),
(52496, NULL, 'G3DSA:3.40.50.12160:FF:000005', NULL, NULL, 'threonylcarbamoyladenosine tRNA methylthiotransferase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(52497, NULL, 'G3DSA:1.10.287.1490:FF:000057', NULL, NULL, 'At5g52280', NULL, NULL, NULL, NULL, NULL, 4),
(52498, NULL, 'G3DSA:1.10.287.1490:FF:000001', NULL, NULL, 'Putative phosphatidylinositol 3-kinase regulatory subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(52499, NULL, 'G3DSA:3.40.50.2300:FF:001247', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52500, NULL, 'G3DSA:1.10.8.60:FF:000304', NULL, NULL, 'AAA-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(52501, NULL, 'G3DSA:1.10.437.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52502, NULL, 'G3DSA:1.10.8.60:FF:000416', NULL, NULL, 'Replication factor C subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(52503, NULL, 'G3DSA:2.120.10.90:FF:000008', NULL, NULL, 'DNA gyrase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(52504, NULL, 'G3DSA:3.30.70.1230:FF:000243', NULL, NULL, 'Adenylyl cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(52505, NULL, 'G3DSA:1.20.5.3310:FF:000004', NULL, NULL, 'Sec-independent protein translocase protein TatA', NULL, NULL, NULL, NULL, NULL, 4),
(52506, NULL, 'G3DSA:3.30.420.210:FF:000004', NULL, NULL, 'UBX domain-containing protein 2A', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(52507, NULL, 'G3DSA:2.180.10.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52508, NULL, 'G3DSA:1.10.510.10:FF:000357', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(52509, NULL, 'G3DSA:3.90.640.10:FF:000049', NULL, NULL, 'Putative actin-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(52510, NULL, 'G3DSA:3.30.160.60:FF:000304', NULL, NULL, 'Zinc finger and BTB domain-containing protein 20', NULL, NULL, NULL, NULL, NULL, 4),
(52511, NULL, 'G3DSA:1.20.58.1240:FF:000001', NULL, NULL, 'Conserved oligomeric Golgi complex component', NULL, NULL, NULL, NULL, NULL, 4),
(52512, NULL, 'G3DSA:3.40.250.10:FF:000199', NULL, NULL, 'Dual specificity protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(52513, NULL, 'G3DSA:3.40.50.10130:FF:000026', NULL, NULL, 'FA core complex-associated protein 24', NULL, NULL, NULL, NULL, NULL, 4),
(52514, NULL, 'G3DSA:1.20.1300.20:FF:000010', NULL, NULL, 'cDNA clone:J023014N14, full insert sequence', NULL, NULL, NULL, NULL, NULL, 4),
(52515, NULL, 'G3DSA:2.60.40.1730:FF:000072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52516, NULL, 'G3DSA:3.40.50.720:FF:000931', NULL, NULL, 'Short chain dehydrogenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(52517, NULL, 'G3DSA:3.40.50.300:FF:000125', NULL, NULL, 'Guanine nucleotide-binding protein G(Q) subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(52518, NULL, 'G3DSA:2.40.10.340:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52519, NULL, 'G3DSA:3.40.1380.20:FF:000020', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(52520, NULL, 'G3DSA:2.40.50.100:FF:000108', NULL, NULL, 'DNA-directed RNA polymerase subunit beta''', NULL, NULL, NULL, NULL, NULL, 4),
(52521, NULL, 'G3DSA:1.20.58.1250:FF:000004', NULL, NULL, 'Unplaced genomic scaffold supercont2.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(52522, NULL, 'G3DSA:3.60.10.10:FF:000368', NULL, NULL, 'Type I inositol polyphosphate 5-phosphatase 10', NULL, NULL, NULL, NULL, NULL, 4),
(52523, NULL, 'G3DSA:3.90.550.10:FF:000008', NULL, NULL, 'UTP--glucose-1-phosphate uridylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(52524, NULL, 'G3DSA:2.130.10.10:FF:003492', NULL, NULL, 'GPI inositol-deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(52525, NULL, 'G3DSA:3.30.1370.30:FF:000013', NULL, NULL, 'Ribosomal Protein, Small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(52526, NULL, 'G3DSA:3.30.565.10:FF:000106', NULL, NULL, 'Two-component system sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(52527, NULL, 'G3DSA:3.60.21.10:FF:000157', NULL, NULL, 'Metallophosphoesterase', NULL, NULL, NULL, NULL, NULL, 4),
(52528, NULL, 'G3DSA:3.40.850.10:FF:000458', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52529, NULL, 'G3DSA:3.10.20.30:FF:000045', NULL, NULL, 'Obg-like ATPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(52530, NULL, 'G3DSA:1.10.472.80:FF:000171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52531, NULL, 'G3DSA:1.10.10.10:FF:001870', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52532, NULL, 'G3DSA:3.10.250.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52533, NULL, 'G3DSA:1.20.1070.10:FF:001090', NULL, NULL, 'Visual pigment-like receptor peropsin', NULL, NULL, NULL, NULL, NULL, 4),
(52534, NULL, 'G3DSA:1.20.1560.10:FF:000907', NULL, NULL, 'Novel protein similar to human transporter 2, ATP-binding cassette, sub-family B (MDR/TAP2)', NULL, NULL, NULL, NULL, NULL, 4),
(52535, NULL, 'G3DSA:1.10.560.10:FF:000124', NULL, NULL, 'Chaperonin-containing TCP1, subunit 2 (beta)', NULL, NULL, NULL, NULL, NULL, 4),
(52536, NULL, 'G3DSA:3.30.70.260:FF:000069', NULL, NULL, 'Ribose-5-phosphate isomerase A', NULL, NULL, NULL, NULL, NULL, 4),
(52537, NULL, 'G3DSA:1.20.1250.20:FF:000926', NULL, NULL, 'Major facilitator superfamily (MFS) transporter', NULL, NULL, NULL, NULL, NULL, 4),
(52538, NULL, 'G3DSA:3.40.50.300:FF:003891', NULL, NULL, 'Heme ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(52539, NULL, 'G3DSA:3.30.40.10:FF:001012', NULL, NULL, 'Alcohol sensitive Ring/PHD finger', NULL, NULL, NULL, NULL, NULL, 4),
(52540, NULL, 'G3DSA:1.25.40.20:FF:001588', NULL, NULL, 'Ankyrin repeat domain-containing protein 27-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(52541, NULL, 'G3DSA:2.60.490.10:FF:000025', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52542, NULL, 'G3DSA:3.30.160.60:FF:000804', NULL, NULL, 'PR domain zinc finger protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(52543, NULL, 'G3DSA:1.10.1070.11:FF:000031', NULL, NULL, 'Phosphatidyl inositol 3-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(52544, NULL, 'G3DSA:1.25.10.10:FF:000122', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 1 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(52545, NULL, 'G3DSA:3.30.710.10:FF:000349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52546, NULL, 'G3DSA:1.10.3720.10:FF:000018', NULL, NULL, 'Molybdenum transport system permease', NULL, NULL, NULL, NULL, NULL, 4),
(52547, NULL, 'G3DSA:2.130.10.10:FF:002362', NULL, NULL, 'Guanine nucleotide-binding protein subunit beta-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(52548, NULL, 'G3DSA:3.40.50.1820:FF:000187', NULL, NULL, 'Phosphatidylcholine-sterol acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(52549, NULL, 'G3DSA:1.10.506.10:FF:000033', NULL, NULL, 'PLeXin', NULL, NULL, NULL, NULL, NULL, 4),
(52550, NULL, 'G3DSA:2.60.120.560:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52551, NULL, 'G3DSA:3.40.50.300:FF:007269', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52552, NULL, 'G3DSA:3.90.190.10:FF:000295', NULL, NULL, 'LOC100036671 protein', NULL, NULL, NULL, NULL, NULL, 4),
(52553, NULL, 'G3DSA:1.20.1560.10:FF:000677', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(52554, NULL, 'G3DSA:3.30.160.60:FF:001934', NULL, NULL, 'Zinc finger protein 430', NULL, NULL, NULL, NULL, NULL, 4),
(52555, NULL, 'G3DSA:1.10.510.10:FF:003960', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52556, NULL, 'G3DSA:3.40.30.10:FF:000920', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52557, NULL, 'G3DSA:2.170.270.10:FF:000162', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52558, NULL, 'G3DSA:3.40.1690.10:FF:000001', NULL, NULL, 'Flagellar biosynthetic protein FlhB', NULL, NULL, NULL, NULL, NULL, 4),
(52559, NULL, 'G3DSA:1.10.287.470:FF:000060', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(52560, NULL, 'G3DSA:3.40.50.300:FF:007483', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52561, NULL, 'G3DSA:3.40.50.150:FF:000114', NULL, NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(52562, NULL, 'G3DSA:2.60.40.150:FF:000050', NULL, NULL, 'Multiple C2 and transmembrane domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(52563, NULL, 'G3DSA:2.130.10.10:FF:004048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52564, NULL, 'G3DSA:3.40.720.10:FF:000123', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52565, NULL, 'G3DSA:3.10.20.90:FF:000602', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(52566, NULL, 'G3DSA:3.40.1350.60:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52567, NULL, 'G3DSA:2.10.60.10:FF:000055', NULL, NULL, 'RIKEN cDNA 2210407C18', NULL, NULL, NULL, NULL, NULL, 4),
(52568, NULL, 'G3DSA:3.30.565.10:FF:000320', NULL, NULL, 'Sensor histidine kinase TodS', NULL, NULL, NULL, NULL, NULL, 4),
(52569, NULL, 'G3DSA:3.40.250.10:FF:000143', NULL, NULL, 'Thiosulfate sulfurtransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52570, NULL, 'G3DSA:3.30.160.60:FF:005650', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52571, NULL, 'G3DSA:3.30.360.20:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(52572, NULL, 'G3DSA:1.50.40.10:FF:000560', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52573, NULL, 'G3DSA:3.40.50.10810:FF:000016', NULL, NULL, 'Chromatin structure-remodeling complex protein SYD', NULL, NULL, NULL, NULL, NULL, 4),
(52574, NULL, 'G3DSA:3.30.200.20:FF:001376', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52575, NULL, 'G3DSA:1.10.287.110:FF:000154', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(52576, NULL, 'G3DSA:1.25.40.120:FF:000085', NULL, NULL, 'Prenyltransferase alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52577, NULL, 'G3DSA:1.20.120.1760:FF:000024', NULL, NULL, 'Probable phosphatidylinositol synthase pgsA1', NULL, NULL, NULL, NULL, NULL, 4),
(52578, NULL, 'G3DSA:2.40.50.140:FF:001166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52579, NULL, 'G3DSA:3.30.40.10:FF:001282', NULL, NULL, 'Remodeling and spacing factor 1b, tandem duplicate 1', NULL, NULL, NULL, NULL, NULL, 4),
(52580, NULL, 'G3DSA:3.30.70.330:FF:001843', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52581, NULL, 'G3DSA:2.170.16.10:FF:000013', NULL, NULL, 'Replication factor C small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(52582, NULL, 'G3DSA:1.25.40.10:FF:003620', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(52583, NULL, 'G3DSA:3.40.640.10:FF:000122', NULL, NULL, 'Bifunctional dethiobiotin synthetase/adenosylmethionine-8-amino-7-oxononanoate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(52584, NULL, 'G3DSA:3.30.360.10:FF:000024', NULL, NULL, 'Inositol-3-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(52585, NULL, 'G3DSA:2.130.10.10:FF:001468', NULL, NULL, 'WD repeat domain 55', NULL, NULL, NULL, NULL, NULL, 4),
(52586, NULL, 'G3DSA:3.40.50.10800:FF:000013', NULL, NULL, 'Quinolinate synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(52587, NULL, 'G3DSA:6.10.140.2150:FF:000007', NULL, NULL, 'Putative sphingosine 1-phosphate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(52588, NULL, 'G3DSA:2.10.110.30:FF:000003', NULL, NULL, 'E3 ubiquitin-protein ligase UBR3 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(52589, NULL, 'G3DSA:3.30.1610.10:FF:000009', NULL, NULL, 'Nucleoporin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52590, NULL, 'G3DSA:3.40.50.300:FF:002430', NULL, NULL, 'Zinc finger protein family member', NULL, NULL, NULL, NULL, NULL, 4),
(52591, NULL, 'G3DSA:1.20.1070.10:FF:000477', NULL, NULL, 'Chemokine (C-X-C motif) receptor 3, tandem duplicate 2', NULL, NULL, NULL, NULL, NULL, 4),
(52592, NULL, 'G3DSA:2.60.40.10:FF:005756', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52593, NULL, 'G3DSA:3.30.930.10:FF:000107', NULL, NULL, 'Putative lipoate-protein ligase A', NULL, NULL, NULL, NULL, NULL, 4),
(52594, NULL, 'G3DSA:3.30.420.150:FF:000020', NULL, NULL, 'Ppx/GppA phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(52595, NULL, 'G3DSA:3.30.830.10:FF:000004', NULL, NULL, 'Putative insulin-degrading enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(52596, NULL, 'G3DSA:1.10.405.10:FF:000006', NULL, NULL, 'Rab GDP dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(52597, NULL, 'G3DSA:1.10.1450.10:FF:000126', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(52598, NULL, 'G3DSA:2.60.40.2840:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52599, NULL, 'G3DSA:3.60.40.10:FF:000196', NULL, NULL, 'Protein phosphatase 2C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52600, NULL, 'G3DSA:1.25.10.10:FF:003399', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52601, NULL, 'G3DSA:1.10.287.370:FF:000029', NULL, NULL, 'Prefoldin subunit 2 putative', NULL, NULL, NULL, NULL, NULL, 4),
(52602, NULL, 'G3DSA:1.10.630.10:FF:000029', NULL, NULL, 'Cytochrome P450 734A1', NULL, NULL, NULL, NULL, NULL, 4),
(52603, NULL, 'G3DSA:1.10.405.20:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52604, NULL, 'G3DSA:1.50.40.10:FF:000408', NULL, NULL, 'Solute carrier family 25 member 18', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(52605, NULL, 'G3DSA:2.10.70.10:FF:000168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52606, NULL, 'G3DSA:1.50.40.10:FF:000122', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(52607, NULL, 'G3DSA:1.10.510.10:FF:002830', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52608, NULL, 'G3DSA:3.40.50.1000:FF:000328', NULL, NULL, 'BnaAnng05460D protein', NULL, NULL, NULL, NULL, NULL, 4),
(52609, NULL, 'G3DSA:3.30.40.10:FF:001068', NULL, NULL, 'RING finger protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(52610, NULL, 'G3DSA:1.10.150.250:FF:000005', NULL, NULL, 'Succinate dehydrogenase assembly factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(52611, NULL, 'G3DSA:2.30.40.10:FF:000177', NULL, NULL, 'N-substituted formamide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(52612, NULL, 'G3DSA:3.40.50.2000:FF:000589', NULL, NULL, 'Putative teichuronic acid biosynthesis glycosyl transferase TuaC', NULL, NULL, NULL, NULL, NULL, 4),
(52613, NULL, 'G3DSA:1.10.418.60:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52614, NULL, 'G3DSA:2.60.40.10:FF:001485', NULL, NULL, 'Tripartite motif containing 45', NULL, NULL, NULL, NULL, NULL, 4),
(52615, NULL, 'G3DSA:3.40.50.720:FF:001706', NULL, NULL, 'Erythronate-4-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(52616, NULL, 'G3DSA:3.40.720.10:FF:000067', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52617, NULL, 'G3DSA:3.40.50.300:FF:006701', NULL, NULL, 'Protein CBG27014', NULL, NULL, NULL, NULL, NULL, 4),
(52618, NULL, 'G3DSA:3.30.420.10:FF:000748', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52619, NULL, 'G3DSA:1.25.40.10:FF:001585', NULL, NULL, 'TPR repeat', NULL, NULL, NULL, NULL, NULL, 4),
(52620, NULL, 'G3DSA:1.10.8.60:FF:000309', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(52621, NULL, 'G3DSA:3.40.1110.10:FF:000188', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(52622, NULL, 'G3DSA:3.40.30.10:FF:000533', NULL, NULL, 'ThioRedoXin [see also xtr]', NULL, NULL, NULL, NULL, NULL, 4),
(52623, NULL, 'G3DSA:1.20.1070.10:FF:000825', NULL, NULL, 'Adrenoceptor alpha 2B', NULL, NULL, NULL, NULL, NULL, 4),
(52624, NULL, 'G3DSA:2.30.30.40:FF:000106', NULL, NULL, 'disks large homolog 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(52625, NULL, 'G3DSA:3.60.40.10:FF:000252', NULL, NULL, 'Stage II sporulation protein E', NULL, NULL, NULL, NULL, NULL, 4),
(52626, NULL, 'G3DSA:3.40.50.1580:FF:000013', NULL, NULL, 'Purine nucleoside phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(52627, NULL, 'G3DSA:3.80.10.10:FF:002385', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(52628, NULL, 'G3DSA:1.20.1110.10:FF:000144', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(52629, NULL, 'G3DSA:2.130.10.10:FF:002031', NULL, NULL, 'WD repeat domain 48b', NULL, NULL, NULL, NULL, NULL, 4),
(52630, NULL, 'G3DSA:3.80.10.10:FF:001480', NULL, NULL, 'Leucine-rich repeat transmembrane protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(52631, NULL, 'G3DSA:1.10.238.20:FF:000042', NULL, NULL, 'Odorant binding protein C15', NULL, NULL, NULL, NULL, NULL, 4),
(52632, NULL, 'G3DSA:1.25.10.70:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52633, NULL, 'G3DSA:3.20.20.190:FF:000085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52634, NULL, 'G3DSA:1.20.58.70:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52635, NULL, 'G3DSA:3.40.630.30:FF:000228', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(52636, NULL, 'G3DSA:2.60.120.200:FF:000697', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52637, NULL, 'G3DSA:2.30.30.30:FF:000103', NULL, NULL, 'Elongation factor P 1', NULL, NULL, NULL, NULL, NULL, 4),
(52638, NULL, 'G3DSA:2.60.40.10:FF:003963', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(52639, NULL, 'G3DSA:2.40.50.140:FF:000828', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52640, NULL, 'G3DSA:3.30.160.60:FF:002502', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52641, NULL, 'G3DSA:2.130.10.130:FF:000003', NULL, NULL, 'Integrin alpha V', NULL, NULL, NULL, NULL, NULL, 4),
(52642, NULL, 'G3DSA:1.10.510.10:FF:002381', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52643, NULL, 'G3DSA:3.30.450.40:FF:000124', NULL, NULL, 'Sigma-54 dependent transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(52644, NULL, 'G3DSA:1.10.287.370:FF:000092', NULL, NULL, 'Putative prefoldin subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(52645, NULL, 'G3DSA:1.10.4080.10:FF:000008', NULL, NULL, 'ADP-ribosylglycohydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52646, NULL, 'G3DSA:3.90.190.10:FF:000525', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52647, NULL, 'G3DSA:3.40.50.1100:FF:000302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52648, NULL, 'G3DSA:3.90.550.10:FF:000160', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(52649, NULL, 'G3DSA:1.25.40.10:FF:001933', NULL, NULL, 'Os06g0235800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(52650, NULL, 'G3DSA:2.30.29.30:FF:001145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52651, NULL, 'G3DSA:1.10.287.1490:FF:000006', NULL, NULL, 'Centromere protein E', NULL, NULL, NULL, NULL, NULL, 4),
(52652, NULL, 'G3DSA:3.30.479.10:FF:000007', NULL, NULL, '6-pyruvoyltetrahydropterin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(52653, NULL, 'G3DSA:2.130.10.10:FF:001794', NULL, NULL, 'Angio-associated migratory cell protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52654, NULL, 'G3DSA:2.70.130.10:FF:000041', NULL, NULL, 'Protein OS-9 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(52655, NULL, 'G3DSA:2.10.25.10:FF:000479', NULL, NULL, 'Notch homolog 4, [Drosophila]', NULL, NULL, NULL, NULL, NULL, 4),
(52656, NULL, 'G3DSA:3.40.640.10:FF:000341', NULL, NULL, 'Glutamine--scyllo-inositol transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(52657, NULL, 'G3DSA:3.60.21.10:FF:000213', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(52658, NULL, 'G3DSA:1.20.140.10:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52659, NULL, 'G3DSA:3.30.60.30:FF:000035', NULL, NULL, 'Serine protease inhibitor dipetalogastin', NULL, NULL, NULL, NULL, NULL, 4),
(52660, NULL, 'G3DSA:3.30.160.60:FF:001878', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(52661, NULL, 'G3DSA:3.30.365.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52662, NULL, 'G3DSA:3.30.70.330:FF:001006', NULL, NULL, 'Nucleolin 2', NULL, NULL, NULL, NULL, NULL, 4),
(52663, NULL, 'G3DSA:3.30.420.40:FF:000622', NULL, NULL, 'N-methylhydantoinase A related protein (HuyA-like)', NULL, NULL, NULL, NULL, NULL, 4),
(52664, NULL, 'G3DSA:2.170.270.10:FF:000050', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(52665, NULL, 'G3DSA:3.40.50.980:FF:000014', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(52666, NULL, 'G3DSA:3.30.1120.10:FF:000040', NULL, NULL, 'Putative secreted sulfatase ydeN', NULL, NULL, NULL, NULL, NULL, 4),
(52667, NULL, 'G3DSA:1.10.630.10:FF:000355', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52668, NULL, 'G3DSA:3.30.530.20:FF:000063', NULL, NULL, 'SRPBCC family protein', NULL, NULL, NULL, NULL, NULL, 4),
(52669, NULL, 'G3DSA:3.70.10.10:FF:000053', NULL, NULL, 'DNA polymerase processivity factor', NULL, NULL, NULL, NULL, NULL, 4),
(52670, NULL, 'G3DSA:3.80.10.10:FF:001081', NULL, NULL, 'Ribonuclease inhibitor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(52671, NULL, 'G3DSA:1.20.120.340:FF:000002', NULL, NULL, 'Flagellar secretion chaperone FliS', NULL, NULL, NULL, NULL, NULL, 4),
(52672, NULL, 'G3DSA:1.10.510.10:FF:001487', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(52673, NULL, 'G3DSA:3.40.980.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52674, NULL, 'G3DSA:3.40.50.300:FF:007488', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52675, NULL, 'G3DSA:3.40.50.2300:FF:001466', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52676, NULL, 'G3DSA:3.30.160.60:FF:001608', NULL, NULL, 'Zinc finger protein 605', NULL, NULL, NULL, NULL, NULL, 4),
(52677, NULL, 'G3DSA:1.10.30.10:FF:000123', NULL, NULL, 'FACT complex subunit SSRP1', NULL, NULL, NULL, NULL, NULL, 4),
(52678, NULL, 'G3DSA:3.40.50.720:FF:001364', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52679, NULL, 'G3DSA:3.30.160.60:FF:002154', NULL, NULL, 'Zinc finger protein 337', NULL, NULL, NULL, NULL, NULL, 4),
(52680, NULL, 'G3DSA:3.40.50.300:FF:001755', NULL, NULL, 'Methionine import ATP-binding protein MetN', NULL, NULL, NULL, NULL, NULL, 4),
(52681, NULL, 'G3DSA:3.65.10.10:FF:000003', NULL, NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(52682, NULL, 'G3DSA:3.65.10.20:FF:000006', NULL, NULL, 'RNA terminal phosphate cyclase like 1', NULL, NULL, NULL, NULL, NULL, 4),
(52683, NULL, 'G3DSA:1.20.1250.20:FF:001146', NULL, NULL, 'Sodium/phosphate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52684, NULL, 'G3DSA:3.40.50.300:FF:008500', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52685, NULL, 'G3DSA:3.60.10.10:FF:000424', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52686, NULL, 'G3DSA:3.40.50.150:FF:000333', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', NULL, NULL, NULL, NULL, NULL, 4),
(52687, NULL, 'G3DSA:3.30.200.20:FF:000302', NULL, NULL, 'striated muscle preferentially expressed protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(52688, NULL, 'G3DSA:2.10.70.10:FF:000117', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(52689, NULL, 'G3DSA:1.10.20.10:FF:000173', NULL, NULL, 'Histone H2A', NULL, NULL, NULL, NULL, NULL, 4),
(52690, NULL, 'G3DSA:3.30.2410.10:FF:000028', NULL, NULL, 'Ubiquitin protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52691, NULL, 'G3DSA:3.30.70.890:FF:000061', NULL, NULL, 'Putative mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(52692, NULL, 'G3DSA:1.25.40.10:FF:003732', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52693, NULL, 'G3DSA:3.20.20.80:FF:000346', NULL, NULL, 'Alpha-xylosidase BoGH31A', NULL, NULL, NULL, NULL, NULL, 4),
(52694, NULL, 'G3DSA:3.40.50.300:FF:000069', NULL, NULL, 'Ras GTP-binding protein YPT1', NULL, NULL, NULL, NULL, NULL, 4),
(52695, NULL, 'G3DSA:1.10.510.10:FF:002504', NULL, NULL, 'CK1 family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(52696, NULL, 'G3DSA:2.60.40.10:FF:001890', NULL, NULL, 'Cell adhesion molecule L1-like a', NULL, NULL, NULL, NULL, NULL, 4),
(52697, NULL, 'G3DSA:3.30.450.20:FF:000579', NULL, NULL, 'PAS domain-containing serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(52698, NULL, 'G3DSA:1.10.3720.10:FF:000013', NULL, NULL, 'Spermidine/putrescine ABC transporter permease PotC', NULL, NULL, NULL, NULL, NULL, 4),
(52699, NULL, 'G3DSA:3.50.50.60:FF:001280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52700, NULL, 'G3DSA:1.10.8.720:FF:000001', NULL, NULL, 'dynein heavy chain 7, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(52701, NULL, 'G3DSA:2.60.40.1770:FF:000004', NULL, NULL, 'ephrin type-B receptor 6', NULL, NULL, NULL, NULL, NULL, 4),
(52702, NULL, 'G3DSA:3.40.50.720:FF:000689', NULL, NULL, 'D-galactose 1-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(52703, NULL, 'G3DSA:3.30.160.60:FF:006083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52704, NULL, 'G3DSA:2.60.120.10:FF:000037', NULL, NULL, 'cGMP-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(52705, NULL, 'G3DSA:3.30.70.980:FF:000043', NULL, NULL, 'Probable transcriptional regulatory protein RB5500', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(52706, NULL, 'G3DSA:2.60.40.10:FF:002502', NULL, NULL, 'CBN-UNC-40 protein', NULL, NULL, NULL, NULL, NULL, 4),
(52707, NULL, 'G3DSA:3.40.1170.60:FF:000027', NULL, NULL, 'DNA polymerase Y family protein', NULL, NULL, NULL, NULL, NULL, 4),
(52708, NULL, 'G3DSA:3.30.160.60:FF:006425', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52709, NULL, 'G3DSA:3.30.160.60:FF:002103', NULL, NULL, 'Zinc finger protein 766', NULL, NULL, NULL, NULL, NULL, 4),
(52710, NULL, 'G3DSA:1.25.10.10:FF:001757', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52711, NULL, 'G3DSA:1.10.4160.10:FF:000009', NULL, NULL, 'NCS1 family nucleobase:cation symporter-1', NULL, NULL, NULL, NULL, NULL, 4),
(52712, NULL, 'G3DSA:1.10.10.750:FF:000036', NULL, NULL, 'Rab-like GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52713, NULL, 'G3DSA:2.130.10.10:FF:005291', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52714, NULL, 'G3DSA:1.20.920.30:FF:000004', NULL, NULL, 'Dynein axonemal heavy chain 5', NULL, NULL, NULL, NULL, NULL, 4),
(52715, NULL, 'G3DSA:2.60.40.1180:FF:000103', NULL, NULL, 'Antimony resistance marker of 58 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(52716, NULL, 'G3DSA:3.10.310.40:FF:000006', NULL, NULL, 'Alanine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(52717, NULL, 'G3DSA:1.20.5.3960:FF:000002', NULL, NULL, 'DNA polymerase gamma, catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(52718, NULL, 'G3DSA:1.25.40.180:FF:000316', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52719, NULL, 'G3DSA:2.60.40.1170:FF:000100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52720, NULL, 'G3DSA:1.10.630.10:FF:000299', NULL, NULL, 'Cytochrome P450 2C9', NULL, NULL, NULL, NULL, NULL, 4),
(52721, NULL, 'G3DSA:3.30.420.40:FF:000010', NULL, NULL, 'Actin-related protein 3 (ARP3)', NULL, NULL, NULL, NULL, NULL, 4),
(52722, NULL, 'G3DSA:3.40.50.300:FF:005471', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52723, NULL, 'G3DSA:3.10.310.30:FF:000003', NULL, NULL, 'Cyclic-di-AMP phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(52724, NULL, 'G3DSA:1.10.8.60:FF:000186', NULL, NULL, 'Cell division control protein', NULL, NULL, NULL, NULL, NULL, 4),
(52725, NULL, 'G3DSA:2.30.30.760:FF:000001', NULL, NULL, 'Flagella basal body P-ring formation protein FlgA', NULL, NULL, NULL, NULL, NULL, 4),
(52726, NULL, 'G3DSA:3.40.50.970:FF:000011', NULL, NULL, 'Pyruvate dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(52727, NULL, 'G3DSA:3.30.160.60:FF:005594', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52728, NULL, 'G3DSA:1.25.40.10:FF:001259', NULL, NULL, 'Glutenin, low molecular weight subunit protein', NULL, NULL, NULL, NULL, NULL, 4),
(52729, NULL, 'G3DSA:1.10.150.300:FF:000004', NULL, NULL, 'Ribosome-binding ATPase YchF', NULL, NULL, NULL, NULL, NULL, 4),
(52730, NULL, 'G3DSA:1.10.565.10:FF:000113', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(52731, NULL, 'G3DSA:2.60.40.2690:FF:000005', NULL, NULL, 'Pre-mRNA-splicing factor PRP11', NULL, NULL, NULL, NULL, NULL, 4),
(52732, NULL, 'G3DSA:3.40.50.300:FF:001699', NULL, NULL, 'ATP-binding cassette sub-family A member', NULL, NULL, NULL, NULL, NULL, 4),
(52733, NULL, 'G3DSA:3.90.76.10:FF:000052', NULL, NULL, 'Oligopeptide ABC transporter, periplasmic oligopeptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(52734, NULL, 'G3DSA:2.70.170.10:FF:000105', NULL, NULL, 'Nicotinic acetylcholine receptor a9 subunit splice variant', NULL, NULL, NULL, NULL, NULL, 4),
(52735, NULL, 'G3DSA:1.20.1280.50:FF:000241', NULL, NULL, 'F-box/WD repeat-containing protein mec-15', NULL, NULL, NULL, NULL, NULL, 4),
(52736, NULL, 'G3DSA:3.20.20.70:FF:000343', NULL, NULL, 'tRNA-dihydrouridine(47) synthase [NAD(P)(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(52737, NULL, 'G3DSA:2.60.120.230:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52738, NULL, 'G3DSA:3.40.50.10090:FF:000025', NULL, NULL, 'uroporphyrinogen-III synthase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(52739, NULL, 'G3DSA:1.25.40.10:FF:003171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52740, NULL, 'G3DSA:1.50.40.10:FF:000173', NULL, NULL, 'Mitochondrial glycine transporter', NULL, NULL, NULL, NULL, NULL, 4),
(52741, NULL, 'G3DSA:3.30.70.330:FF:000320', NULL, NULL, 'RNA-binding protein Musashi 2', NULL, NULL, NULL, NULL, NULL, 4),
(52742, NULL, 'G3DSA:3.20.20.140:FF:000328', NULL, NULL, '2-amino-3-carboxymuconate-6-semialdehyde decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(52743, NULL, 'G3DSA:2.60.120.920:FF:000020', NULL, NULL, 'Putative E3 ubiquitin-protein ligase NEURL1B', NULL, NULL, NULL, NULL, NULL, 4),
(52744, NULL, 'G3DSA:3.40.50.300:FF:006027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52745, NULL, 'G3DSA:3.40.50.720:FF:001038', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(52746, NULL, 'G3DSA:3.30.9.10:FF:000102', NULL, NULL, 'FAD-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(52747, NULL, 'G3DSA:2.40.50.100:FF:000103', NULL, NULL, 'Cation efflux system protein', NULL, NULL, NULL, NULL, NULL, 4),
(52748, NULL, 'G3DSA:3.50.50.60:FF:001493', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52749, NULL, 'G3DSA:2.30.110.10:FF:000015', NULL, NULL, 'Glutamyl-tRNA reductase-binding protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(52750, NULL, 'G3DSA:1.20.1610.10:FF:000002', NULL, NULL, 'Alpha-1,2-mannosidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(52751, NULL, 'G3DSA:3.90.190.10:FF:000469', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52752, NULL, 'G3DSA:3.30.505.10:FF:000221', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52753, NULL, 'G3DSA:3.30.1680.10:FF:000053', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(52754, NULL, 'G3DSA:3.40.50.450:FF:000086', NULL, NULL, 'Phosphofructokinase, platelet b', NULL, NULL, NULL, NULL, NULL, 4),
(52755, NULL, 'G3DSA:2.10.240.10:FF:000001', NULL, NULL, 'Dihydroorotate dehydrogenase B (NAD(+)), electron transfer subunit', NULL, NULL, NULL, NULL, NULL, 4),
(52756, NULL, 'G3DSA:3.10.100.10:FF:000021', NULL, NULL, 'Mannose receptor C type 2', NULL, NULL, NULL, NULL, NULL, 4),
(52757, NULL, 'G3DSA:3.40.50.300:FF:001429', NULL, NULL, 'Torsin family protein C9orf167-like', NULL, NULL, NULL, NULL, NULL, 4),
(52758, NULL, 'G3DSA:3.40.720.10:FF:000016', NULL, NULL, 'Phosphoethanolamine transferase CptA', NULL, NULL, NULL, NULL, NULL, 4),
(52759, NULL, 'G3DSA:1.20.1310.10:FF:000013', NULL, NULL, 'Cullin-1 like', NULL, NULL, NULL, NULL, NULL, 4),
(52760, NULL, 'G3DSA:2.40.430.10:FF:000003', NULL, NULL, 'Binding-protein-dependent transport systems inner membrane component', NULL, NULL, NULL, NULL, NULL, 4),
(52761, NULL, 'G3DSA:2.30.30.770:FF:000004', NULL, NULL, '60S ribosomal protein L27', NULL, NULL, NULL, NULL, NULL, 4),
(52762, NULL, 'G3DSA:3.40.50.1700:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52763, NULL, 'G3DSA:3.40.50.1010:FF:000045', NULL, NULL, 'Transcriptional protein swt1', NULL, NULL, NULL, NULL, NULL, 4),
(52764, NULL, 'G3DSA:3.40.640.10:FF:000015', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(52765, NULL, 'G3DSA:1.10.1420.10:FF:000006', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(52766, NULL, 'G3DSA:3.30.200.20:FF:001269', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52767, NULL, 'G3DSA:4.10.280.10:FF:000086', NULL, NULL, 'protein extra-macrochaetae', NULL, NULL, NULL, NULL, NULL, 4),
(52768, NULL, 'G3DSA:1.20.1720.10:FF:000117', NULL, NULL, 'Bcr/CflA family efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(52769, NULL, 'G3DSA:1.25.40.10:FF:002153', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(52770, NULL, 'G3DSA:3.40.50.300:FF:005690', NULL, NULL, 'Pentafunctional AROM polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(52771, NULL, 'G3DSA:3.40.50.2000:FF:001045', NULL, NULL, 'Protein CBG08872', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(52772, NULL, 'G3DSA:3.40.50.1000:FF:000042', NULL, NULL, 'HAD hydrolase, family IF', NULL, NULL, NULL, NULL, NULL, 4),
(52773, NULL, 'G3DSA:3.30.70.330:FF:001950', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52774, NULL, 'G3DSA:3.20.20.70:FF:000068', NULL, NULL, 'Fructose-bisphosphate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(52775, NULL, 'G3DSA:3.30.360.10:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52776, NULL, 'G3DSA:2.130.10.10:FF:001575', NULL, NULL, 'WGS project CABT00000000 data, contig 2.15', NULL, NULL, NULL, NULL, NULL, 4),
(52777, NULL, 'G3DSA:3.40.50.2020:FF:000185', NULL, NULL, 'Ribose-phosphate pyrophosphokinase 2 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(52778, NULL, 'G3DSA:1.10.10.1940:FF:000005', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(52779, NULL, 'G3DSA:1.20.1310.20:FF:000016', NULL, NULL, 'Erythrocyte membrane protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(52780, NULL, 'G3DSA:2.60.120.10:FF:000442', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52781, NULL, 'G3DSA:3.40.50.2300:FF:001073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52782, NULL, 'G3DSA:3.40.33.10:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52783, NULL, 'G3DSA:3.30.160.60:FF:003733', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52784, NULL, 'G3DSA:1.25.40.10:FF:001877', NULL, NULL, 'Os06g0681900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(52785, NULL, 'G3DSA:1.20.1530.20:FF:000004', NULL, NULL, 'Kef family K(+) transporter', NULL, NULL, NULL, NULL, NULL, 4),
(52786, NULL, 'G3DSA:1.10.390.10:FF:000083', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52787, NULL, 'G3DSA:3.40.190.10:FF:000778', NULL, NULL, 'ABC-type dipeptide transport system, solute-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(52788, NULL, 'G3DSA:3.90.1100.10:FF:000007', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(52789, NULL, 'G3DSA:2.30.29.30:FF:000437', NULL, NULL, 'Focal adhesion kinase, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(52790, NULL, 'G3DSA:3.30.70.1660:FF:000023', NULL, NULL, 'Peptide chain release factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(52791, NULL, 'G3DSA:1.20.1530.10:FF:000001', NULL, NULL, 'Na(+)/H(+) antiporter NhaA', NULL, NULL, NULL, NULL, NULL, 4),
(52792, NULL, 'G3DSA:1.25.40.10:FF:002889', NULL, NULL, 'PsbB mRNA maturation factor Mbb1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(52793, NULL, 'G3DSA:2.30.29.30:FF:001218', NULL, NULL, 'Rho guanine nucleotide exchange factor (GEF) 26', NULL, NULL, NULL, NULL, NULL, 4),
(52794, NULL, 'G3DSA:3.30.1490.220:FF:000008', NULL, NULL, 'Inositol-tetrakisphosphate 1-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(52795, NULL, 'G3DSA:1.10.287.470:FF:000059', NULL, NULL, 'Efflux transporter, RND family, MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(52796, NULL, 'G3DSA:3.20.20.140:FF:000109', NULL, NULL, '4-oxalomesaconate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(52797, NULL, 'G3DSA:1.25.40.10:FF:000129', NULL, NULL, 'protein sel-1 homolog 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(52798, NULL, 'G3DSA:3.20.20.140:FF:000059', NULL, NULL, 'Histidinol-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(52799, NULL, 'G3DSA:1.10.1040.10:FF:000039', NULL, NULL, 'Blast:Putative oxidoreductase GLYR1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(52800, NULL, 'G3DSA:3.30.70.330:FF:001225', NULL, NULL, 'Transformer-2 sex-determining protein-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(52801, NULL, 'G3DSA:3.90.1410.10:FF:000104', NULL, NULL, 'AFL100Wp', NULL, NULL, NULL, NULL, NULL, 4),
(52802, NULL, 'G3DSA:3.40.50.1100:FF:000033', NULL, NULL, 'Diaminopropionate ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(52803, NULL, 'G3DSA:2.40.10.10:FF:000303', NULL, NULL, 'GM18242', NULL, NULL, NULL, NULL, NULL, 4),
(52804, NULL, 'G3DSA:1.20.1070.10:FF:000589', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(52805, NULL, 'G3DSA:1.25.70.10:FF:000070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52806, NULL, 'G3DSA:1.20.5.110:FF:000075', NULL, NULL, 'Related to SEC9-protein transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(52807, NULL, 'G3DSA:3.30.60.90:FF:000031', NULL, NULL, 'Transcriptional adaptor ADA2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52808, NULL, 'G3DSA:2.10.90.10:FF:000057', NULL, NULL, 'Interleukin 17E', NULL, NULL, NULL, NULL, NULL, 4),
(52809, NULL, 'G3DSA:2.130.10.10:FF:001867', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(52810, NULL, 'G3DSA:1.10.510.10:FF:003516', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52811, NULL, 'G3DSA:2.30.29.30:FF:000656', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52812, NULL, 'G3DSA:2.170.240.10:FF:000003', NULL, NULL, 'Collagen, type IV, alpha 4', NULL, NULL, NULL, NULL, NULL, 4),
(52813, NULL, 'G3DSA:3.30.930.10:FF:000219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52814, NULL, 'G3DSA:4.10.1060.10:FF:000055', NULL, NULL, 'E3 SUMO-protein ligase RanBP2', NULL, NULL, NULL, NULL, NULL, 4),
(52815, NULL, 'G3DSA:3.20.20.80:FF:000790', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52816, NULL, 'G3DSA:1.25.50.20:FF:000072', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(52817, NULL, 'G3DSA:3.20.19.10:FF:000007', NULL, NULL, 'Isopropylmalate/citramalate isomerase small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(52818, NULL, 'G3DSA:3.30.420.40:FF:000061', NULL, NULL, 'Heat shock protein family A (Hsp70) member 12A', NULL, NULL, NULL, NULL, NULL, 4),
(52819, NULL, 'G3DSA:1.10.730.10:FF:000014', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(52820, NULL, 'G3DSA:3.40.50.300:FF:007718', NULL, NULL, 'Glycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(52821, NULL, 'G3DSA:2.60.120.10:FF:000711', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52822, NULL, 'G3DSA:2.60.120.10:FF:000661', NULL, NULL, 'Bll6461 protein', NULL, NULL, NULL, NULL, NULL, 4),
(52823, NULL, 'G3DSA:3.40.50.11980:FF:000007', NULL, NULL, 'ORF13', NULL, NULL, NULL, NULL, NULL, 4),
(52824, NULL, 'G3DSA:3.40.630.30:FF:000015', NULL, NULL, 'N-alpha-acetyltransferase 20 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(52825, NULL, 'G3DSA:1.25.10.10:FF:003287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52826, NULL, 'G3DSA:1.20.1250.20:FF:000814', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52827, NULL, 'G3DSA:2.60.40.10:FF:004071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52828, NULL, 'G3DSA:3.40.50.300:FF:002250', NULL, NULL, 'ATP-dependent RNA helicase DDX51', NULL, NULL, NULL, NULL, NULL, 4),
(52829, NULL, 'G3DSA:3.10.100.10:FF:000015', NULL, NULL, 'C-type lectin Cal', NULL, NULL, NULL, NULL, NULL, 4),
(52830, NULL, 'G3DSA:3.30.420.10:FF:000574', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52831, NULL, 'G3DSA:2.60.40.1180:FF:000142', NULL, NULL, 'Maltase A8', NULL, NULL, NULL, NULL, NULL, 4),
(52832, NULL, 'G3DSA:1.10.357.30:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52833, NULL, 'G3DSA:3.40.50.300:FF:004009', NULL, NULL, 'Uncharacterized protein YpbR', NULL, NULL, NULL, NULL, NULL, 4),
(52834, NULL, 'G3DSA:2.40.10.10:FF:000247', NULL, NULL, 'GG11533', NULL, NULL, NULL, NULL, NULL, 4),
(52835, NULL, 'G3DSA:3.30.160.60:FF:004520', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52836, NULL, 'G3DSA:2.130.10.10:FF:003048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52837, NULL, 'G3DSA:2.30.39.10:FF:000089', NULL, NULL, 'Serpin peptidase inhibitor 22', NULL, NULL, NULL, NULL, NULL, 4),
(52838, NULL, 'G3DSA:3.40.50.300:FF:003447', NULL, NULL, 'Type I restriction-modification system restriction subunit R', NULL, NULL, NULL, NULL, NULL, 4),
(52839, NULL, 'G3DSA:1.25.10.10:FF:002090', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(52840, NULL, 'G3DSA:3.10.50.40:FF:000151', NULL, NULL, 'Inactive peptidyl-prolyl cis-trans isomerase shutdown', NULL, NULL, NULL, NULL, NULL, 4),
(52841, NULL, 'G3DSA:3.90.25.10:FF:000081', NULL, NULL, 'UDP-glucose 4-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(52842, NULL, 'G3DSA:3.40.50.1100:FF:000072', NULL, NULL, 'Related to cysteine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(52843, NULL, 'G3DSA:4.10.60.10:FF:000213', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52844, NULL, 'G3DSA:2.30.180.10:FF:000019', NULL, NULL, 'Cell surface lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(52845, NULL, 'G3DSA:3.40.630.20:FF:000012', NULL, NULL, 'Pyroglutamyl-peptidase I-like', NULL, NULL, NULL, NULL, NULL, 4),
(52846, NULL, 'G3DSA:3.30.200.20:FF:001937', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52847, NULL, 'G3DSA:3.80.10.10:FF:002615', NULL, NULL, 'Putative phopshatase', NULL, NULL, NULL, NULL, NULL, 4),
(52848, NULL, 'G3DSA:3.40.50.410:FF:000372', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52849, NULL, 'G3DSA:2.40.30.10:FF:000361', NULL, NULL, 'Putative nadp-dependent flavoprotein reductase', NULL, NULL, NULL, NULL, NULL, 4),
(52850, NULL, 'G3DSA:1.10.275.10:FF:000012', NULL, NULL, 'Adenylosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(52851, NULL, 'G3DSA:3.30.160.60:FF:006318', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52852, NULL, 'G3DSA:3.90.180.10:FF:000137', NULL, NULL, 'Lovastatin diketide synthase LovF', NULL, NULL, NULL, NULL, NULL, 4),
(52853, NULL, 'G3DSA:3.40.50.300:FF:006139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52854, NULL, 'G3DSA:3.30.70.330:FF:001332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52855, NULL, 'G3DSA:1.20.5.110:FF:000018', NULL, NULL, 'Synaptosomal-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(52856, NULL, 'G3DSA:1.20.58.390:FF:000006', NULL, NULL, 'Putative gamma-aminobutyric acid receptor subunit gamma-2', NULL, NULL, NULL, NULL, NULL, 4),
(52857, NULL, 'G3DSA:2.130.10.10:FF:003380', NULL, NULL, 'Intraflagellar transport 172', NULL, NULL, NULL, NULL, NULL, 4),
(52858, NULL, 'G3DSA:3.30.70.360:FF:000037', NULL, NULL, 'Carboxypeptidase G2', NULL, NULL, NULL, NULL, NULL, 4),
(52859, NULL, 'G3DSA:3.20.20.70:FF:000742', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52860, NULL, 'G3DSA:3.40.50.300:FF:005920', NULL, NULL, 'Cadmium ion transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52861, NULL, 'G3DSA:3.50.50.60:FF:001167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52862, NULL, 'G3DSA:3.40.1370.10:FF:000022', NULL, NULL, '50S ribosomal protein L4', NULL, NULL, NULL, NULL, NULL, 4),
(52863, NULL, 'G3DSA:1.25.70.10:FF:000013', NULL, NULL, 'uncharacterized protein LOC106769908', NULL, NULL, NULL, NULL, NULL, 4),
(52864, NULL, 'G3DSA:3.80.10.10:FF:002559', NULL, NULL, 'RAB geranylgeranyl transferase alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52865, NULL, 'G3DSA:1.25.10.10:FF:001196', NULL, NULL, 'Cyclosome subunit-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(52866, NULL, 'G3DSA:1.10.287.160:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52867, NULL, 'G3DSA:2.60.40.420:FF:000097', NULL, NULL, 'Basic blue copper protein', NULL, NULL, NULL, NULL, NULL, 4),
(52868, NULL, 'G3DSA:3.80.10.10:FF:001255', NULL, NULL, 'Leucine rich repeats (6 copies)/Leucine Rich repeat', NULL, NULL, NULL, NULL, NULL, 4),
(52869, NULL, 'G3DSA:1.25.40.180:FF:000193', NULL, NULL, 'Pre-mRNA-splicing factor CWC22', NULL, NULL, NULL, NULL, NULL, 4),
(52870, NULL, 'G3DSA:2.130.10.10:FF:000451', NULL, NULL, 'Plexin A4, B', NULL, NULL, NULL, NULL, NULL, 4),
(52871, NULL, 'G3DSA:1.10.730.10:FF:000121', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(52872, NULL, 'G3DSA:2.10.90.10:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52873, NULL, 'G3DSA:1.20.58.830:FF:000003', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(52874, NULL, 'G3DSA:3.10.120.10:FF:000016', NULL, NULL, 'Nitrate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(52875, NULL, 'G3DSA:1.10.225.10:FF:000026', NULL, NULL, 'Saposin-related', NULL, NULL, NULL, NULL, NULL, 4),
(52876, NULL, 'G3DSA:2.10.90.10:FF:000170', NULL, NULL, 'Bone morphogenetic protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(52877, NULL, 'G3DSA:1.20.58.530:FF:000014', NULL, NULL, 'unconventional myosin-XVIIIa isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(52878, NULL, 'G3DSA:1.10.730.20:FF:000017', NULL, NULL, 'Isoleucyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(52879, NULL, 'G3DSA:1.10.10.60:FF:000440', NULL, NULL, 'NK7.1, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(52880, NULL, 'G3DSA:1.10.10.10:FF:002033', NULL, NULL, 'Cell division control protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(52881, NULL, 'G3DSA:3.40.140.10:FF:000140', NULL, NULL, 'Putative 26S proteasome non-ATPase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(52882, NULL, 'G3DSA:3.30.200.20:FF:001090', NULL, NULL, 'Probable serine/threonine-protein kinase YabT', NULL, NULL, NULL, NULL, NULL, 4),
(52883, NULL, 'G3DSA:1.25.40.20:FF:000301', NULL, NULL, 'Palmitoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(52884, NULL, 'G3DSA:1.10.1040.10:FF:000096', NULL, NULL, 'Glyoxylate reductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(52885, NULL, 'G3DSA:1.25.40.10:FF:003906', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52886, NULL, 'G3DSA:3.80.10.10:FF:003222', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52887, NULL, 'G3DSA:3.40.720.10:FF:000342', NULL, NULL, 'Alkaline phosphatase, biomineralization-associated', NULL, NULL, NULL, NULL, NULL, 4),
(52888, NULL, 'G3DSA:3.40.50.720:FF:001190', NULL, NULL, 'Short-chain dehydrogenase/reductase SDR', NULL, NULL, NULL, NULL, NULL, 4),
(52889, NULL, 'G3DSA:1.10.510.10:FF:004067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52890, NULL, 'G3DSA:3.20.20.80:FF:000745', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52891, NULL, 'G3DSA:3.90.1580.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52892, NULL, 'G3DSA:3.40.140.10:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52893, NULL, 'G3DSA:1.20.5.100:FF:000015', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(52894, NULL, 'G3DSA:2.30.39.10:FF:000145', NULL, NULL, 'Serpin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52895, NULL, 'G3DSA:1.20.1000.10:FF:000023', NULL, NULL, 'Guanylate-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(52896, NULL, 'G3DSA:2.60.120.290:FF:000229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52897, NULL, 'G3DSA:2.60.120.330:FF:000225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52898, NULL, 'G3DSA:3.10.200.10:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52899, NULL, 'G3DSA:3.10.105.10:FF:000043', NULL, NULL, 'Oligopeptide ABC transporter, oligopeptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(52900, NULL, 'G3DSA:3.40.50.2000:FF:000876', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52901, NULL, 'G3DSA:1.25.40.10:FF:002602', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(52902, NULL, 'G3DSA:3.20.20.70:FF:000635', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52903, NULL, 'G3DSA:3.30.450.20:FF:000293', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(52904, NULL, 'G3DSA:2.60.40.10:FF:001159', NULL, NULL, 'Fms related tyrosine kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(52905, NULL, 'G3DSA:2.40.110.10:FF:000024', NULL, NULL, 'Acyl-CoA dehydrogenase FadE23', NULL, NULL, NULL, NULL, NULL, 4),
(52906, NULL, 'G3DSA:3.20.20.80:FF:000458', NULL, NULL, 'Cyanogenic beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(52907, NULL, 'G3DSA:1.20.1560.10:FF:000346', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(52908, NULL, 'G3DSA:3.30.160.60:FF:001659', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52909, NULL, 'G3DSA:2.60.120.10:FF:000329', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(52910, NULL, 'G3DSA:3.30.429.10:FF:000004', NULL, NULL, 'Tautomerase/MIF superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(52911, NULL, 'G3DSA:3.40.50.300:FF:004228', NULL, NULL, 'Elongation factor 1-alpha, putative (TuF-2)', NULL, NULL, NULL, NULL, NULL, 4),
(52912, NULL, 'G3DSA:3.30.160.60:FF:004301', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52913, NULL, 'G3DSA:3.40.50.300:FF:006252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52914, NULL, 'G3DSA:3.20.20.80:FF:000638', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52915, NULL, 'G3DSA:2.60.40.150:FF:000611', NULL, NULL, 'Extended synaptotagmin-2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52916, NULL, 'G3DSA:3.40.50.720:FF:001145', NULL, NULL, 'GDP-L-fucose synthase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(52917, NULL, 'G3DSA:1.10.510.10:FF:002212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52918, NULL, 'G3DSA:3.40.50.300:FF:007831', NULL, NULL, 'DNA helicase II', NULL, NULL, NULL, NULL, NULL, 4),
(52919, NULL, 'G3DSA:3.40.50.10330:FF:000024', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(52920, NULL, 'G3DSA:3.40.50.720:FF:000583', NULL, NULL, 'Glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(52921, NULL, 'G3DSA:2.40.50.140:FF:000311', NULL, NULL, '30S ribosomal protein S17', NULL, NULL, NULL, NULL, NULL, 4),
(52922, NULL, 'G3DSA:2.60.40.4230:FF:000001', NULL, NULL, 'Resistin-like beta', NULL, NULL, NULL, NULL, NULL, 4),
(52923, NULL, 'G3DSA:1.10.418.10:FF:000081', NULL, NULL, 'Leucine-rich-repeats and calponin homology domain protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(52924, NULL, 'G3DSA:1.10.167.10:FF:000025', NULL, NULL, 'Axin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(52925, NULL, 'G3DSA:3.30.420.40:FF:000004', NULL, NULL, 'Molecular chaperone DnaK', NULL, NULL, NULL, NULL, NULL, 4),
(52926, NULL, 'G3DSA:2.60.40.10:FF:000703', NULL, NULL, 'Neural cell adhesion molecule L1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(52927, NULL, 'G3DSA:2.30.29.30:FF:000763', NULL, NULL, 'FE65-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(52928, NULL, 'G3DSA:1.25.40.10:FF:000242', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(52929, NULL, 'G3DSA:1.20.58.60:FF:000763', NULL, NULL, 'Nesprin-1', NULL, NULL, NULL, NULL, NULL, 4),
(52930, NULL, 'G3DSA:1.25.40.20:FF:000245', NULL, NULL, 'Ankyrin repeat-containing protein ITN1', NULL, NULL, NULL, NULL, NULL, 4),
(52931, NULL, 'G3DSA:3.40.1000.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52932, NULL, 'G3DSA:3.40.50.300:FF:005864', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52933, NULL, 'G3DSA:1.20.5.350:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52934, NULL, 'G3DSA:3.80.10.10:FF:003166', NULL, NULL, 'F-box and leucine-rich repeat protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(52935, NULL, 'G3DSA:3.20.20.140:FF:000441', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52936, NULL, 'G3DSA:2.60.40.10:FF:002614', NULL, NULL, 'Filamin 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(52937, NULL, 'G3DSA:3.30.110.170:FF:000001', NULL, NULL, 'Oxidative stress defense protein', NULL, NULL, NULL, NULL, NULL, 4),
(52938, NULL, 'G3DSA:1.10.8.60:FF:000074', NULL, NULL, 'Chromosome transmission fidelity protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(52939, NULL, 'G3DSA:1.20.1070.10:FF:000882', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52940, NULL, 'G3DSA:3.40.50.720:FF:002494', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52941, NULL, 'G3DSA:2.130.10.10:FF:005465', NULL, NULL, 'Heterotrimeric G protein beta subunit 1', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(52942, NULL, 'G3DSA:3.20.20.70:FF:000455', NULL, NULL, 'Coenzyme PQQ synthesis protein E', NULL, NULL, NULL, NULL, NULL, 4),
(52943, NULL, 'G3DSA:3.30.70.330:FF:001282', NULL, NULL, 'SD09402p', NULL, NULL, NULL, NULL, NULL, 4),
(52944, NULL, 'G3DSA:1.20.5.340:FF:000014', NULL, NULL, 'Cell division protein ZapB', NULL, NULL, NULL, NULL, NULL, 4),
(52945, NULL, 'G3DSA:1.20.5.340:FF:000126', NULL, NULL, 'Myhz2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(52946, NULL, 'G3DSA:3.30.160.60:FF:002210', NULL, NULL, 'Zinc finger and BTB domain containing 17', NULL, NULL, NULL, NULL, NULL, 4),
(52947, NULL, 'G3DSA:3.90.400.10:FF:000003', NULL, NULL, 'Probable alpha-glucosidase (Maltase)', NULL, NULL, NULL, NULL, NULL, 4),
(52948, NULL, 'G3DSA:1.10.10.60:FF:000108', NULL, NULL, 'NK2 homeobox 1', NULL, NULL, NULL, NULL, NULL, 4),
(52949, NULL, 'G3DSA:1.20.58.480:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52950, NULL, 'G3DSA:2.40.160.120:FF:000028', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(52951, NULL, 'G3DSA:1.25.40.10:FF:003619', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(52952, NULL, 'G3DSA:3.40.1110.10:FF:000149', NULL, NULL, 'Probable copper-transporting ATPase HMA5', NULL, NULL, NULL, NULL, NULL, 4),
(52953, NULL, 'G3DSA:1.25.40.10:FF:005295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52954, NULL, 'G3DSA:3.30.830.10:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52955, NULL, 'G3DSA:1.20.1260.10:FF:000076', NULL, NULL, 'Ferritin 2 light chain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(52956, NULL, 'G3DSA:2.120.10.30:FF:000598', NULL, NULL, 'Gll1703 protein', NULL, NULL, NULL, NULL, NULL, 4),
(52957, NULL, 'G3DSA:3.30.930.10:FF:000276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52958, NULL, 'G3DSA:2.40.10.10:FF:000360', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52959, NULL, 'G3DSA:2.60.40.10:FF:005487', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52960, NULL, 'G3DSA:2.130.10.10:FF:005408', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52961, NULL, 'G3DSA:2.130.10.10:FF:000119', NULL, NULL, 'peptidylprolyl isomerase domain and WD repeat-containing protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(52962, NULL, 'G3DSA:1.20.1250.20:FF:001472', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52963, NULL, 'G3DSA:3.40.1190.20:FF:000078', NULL, NULL, 'Ribokinase', NULL, NULL, NULL, NULL, NULL, 4),
(52964, NULL, 'G3DSA:1.10.275.20:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52965, NULL, 'G3DSA:3.90.1150.10:FF:000050', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(52966, NULL, 'G3DSA:3.40.50.2300:FF:001522', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52967, NULL, 'G3DSA:3.30.70.340:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52968, NULL, 'G3DSA:1.20.120.550:FF:000008', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(52969, NULL, 'G3DSA:1.20.1680.10:FF:000001', NULL, NULL, 'Putative deoxyuridine triphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(52970, NULL, 'G3DSA:3.40.30.10:FF:000084', NULL, NULL, 'Protein disulfide-isomerase A4', NULL, NULL, NULL, NULL, NULL, 4),
(52971, NULL, 'G3DSA:1.20.5.110:FF:000294', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52972, NULL, 'G3DSA:2.30.31.10:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52973, NULL, 'G3DSA:1.25.50.10:FF:000012', NULL, NULL, 'Peptidase M1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(52974, NULL, 'G3DSA:1.10.510.10:FF:004303', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52975, NULL, 'G3DSA:3.30.230.10:FF:000020', NULL, NULL, 'Homoserine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(52976, NULL, 'G3DSA:3.30.560.10:FF:000005', NULL, NULL, 'Glucose-methanol-choline (Gmc) oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(52977, NULL, 'G3DSA:3.30.40.10:FF:001630', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52978, NULL, 'G3DSA:1.20.1070.10:FF:001320', NULL, NULL, 'DOPamine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(52979, NULL, 'G3DSA:4.10.280.10:FF:000193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52980, NULL, 'G3DSA:1.25.50.20:FF:000015', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(52981, NULL, 'G3DSA:3.30.1460.50:FF:000003', NULL, NULL, 'Autophagy-related protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(52982, NULL, 'G3DSA:2.130.10.10:FF:005178', NULL, NULL, 'Pre-mRNA-splicing factor RSE1', NULL, NULL, NULL, NULL, NULL, 4),
(52983, NULL, 'G3DSA:3.90.550.50:FF:000211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52984, NULL, 'G3DSA:1.20.1530.20:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52985, NULL, 'G3DSA:4.10.280.10:FF:000136', NULL, NULL, 'CBN-MXL-2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(52986, NULL, 'G3DSA:6.10.250.3440:FF:000001', NULL, NULL, 'Mitochondrial ribosomal protein L40', NULL, NULL, NULL, NULL, NULL, 4),
(52987, NULL, 'G3DSA:2.60.40.150:FF:000381', NULL, NULL, 'Phosphatidylserine decarboxylase proenzyme 2', NULL, NULL, NULL, NULL, NULL, 4),
(52988, NULL, 'G3DSA:2.60.40.10:FF:003396', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52989, NULL, 'G3DSA:2.30.33.40:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52990, NULL, 'G3DSA:6.10.250.3450:FF:000004', NULL, NULL, 'Ribosomal protein L35', NULL, NULL, NULL, NULL, NULL, 4),
(52991, NULL, 'G3DSA:2.60.40.10:FF:002053', NULL, NULL, 'Triggering receptor expressed on myeloid cells 1', NULL, NULL, NULL, NULL, NULL, 4),
(52992, NULL, 'G3DSA:1.10.418.20:FF:000027', NULL, NULL, 'Ulp1 protease family protein (AFU_orthologue AFUA_5G03200)', NULL, NULL, NULL, NULL, NULL, 4),
(52993, NULL, 'G3DSA:3.40.1110.10:FF:000481', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(52994, NULL, 'G3DSA:1.25.10.10:FF:003343', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52995, NULL, 'G3DSA:3.40.30.10:FF:000027', NULL, NULL, 'protein disulfide-isomerase A2', NULL, NULL, NULL, NULL, NULL, 4),
(52996, NULL, 'G3DSA:1.20.1300.20:FF:000009', NULL, NULL, 'Ubiquitin thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(52997, NULL, 'G3DSA:3.40.50.2000:FF:000819', NULL, NULL, 'Pseudaminic acid cytidylyltransferase and UDP-2,4-diacetamido-2,4,6-trideoxy-beta-L-altropyranose hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(52998, NULL, 'G3DSA:3.40.50.720:FF:001999', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(52999, NULL, 'G3DSA:2.40.40.20:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53000, NULL, 'G3DSA:3.30.310.10:FF:000021', NULL, NULL, 'Ribonuclease HIII', NULL, NULL, NULL, NULL, NULL, 4),
(53001, NULL, 'G3DSA:2.60.40.790:FF:000011', NULL, NULL, 'Alpha-crystallin B chain', NULL, NULL, NULL, NULL, NULL, 4),
(53002, NULL, 'G3DSA:3.30.9.10:FF:000046', NULL, NULL, 'Sarcosine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(53003, NULL, 'G3DSA:2.30.180.10:FF:000132', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53004, NULL, 'G3DSA:1.25.40.10:FF:003058', NULL, NULL, 'WGS project CABT00000000 data, contig 2.19', NULL, NULL, NULL, NULL, NULL, 4),
(53005, NULL, 'G3DSA:3.40.50.300:FF:006471', NULL, NULL, 'Os06g0158200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(53006, NULL, 'G3DSA:3.80.10.10:FF:004184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53007, NULL, 'G3DSA:1.10.400.10:FF:000023', NULL, NULL, 'Guanine nucleotide-binding protein alpha-6 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(53008, NULL, 'G3DSA:2.60.40.10:FF:003632', NULL, NULL, 'Platelet-derived growth factor receptor, beta polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(53009, NULL, 'G3DSA:3.40.1360.10:FF:000015', NULL, NULL, 'Topoisomerase, putative', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(53010, NULL, 'G3DSA:1.25.40.10:FF:003676', NULL, NULL, 'At5g02130', NULL, NULL, NULL, NULL, NULL, 4),
(53011, NULL, 'G3DSA:3.40.50.1820:FF:000754', NULL, NULL, 'Protein of uncharacterized function (DUF2424)', NULL, NULL, NULL, NULL, NULL, 4),
(53012, NULL, 'G3DSA:2.30.18.10:FF:000001', NULL, NULL, 'Transcription initiation factor IIA subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(53013, NULL, 'G3DSA:1.20.5.110:FF:000237', NULL, NULL, 'Syntaxin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(53014, NULL, 'G3DSA:2.60.40.60:FF:000403', NULL, NULL, 'Protocadherin 15', NULL, NULL, NULL, NULL, NULL, 4),
(53015, NULL, 'G3DSA:3.40.50.410:FF:000153', NULL, NULL, 'RfeF', NULL, NULL, NULL, NULL, NULL, 4),
(53016, NULL, 'G3DSA:3.40.33.10:FF:000118', NULL, NULL, 'Vap-1', NULL, NULL, NULL, NULL, NULL, 4),
(53017, NULL, 'G3DSA:1.25.40.740:FF:000001', NULL, NULL, 'Sel1 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(53018, NULL, 'G3DSA:3.30.342.10:FF:000027', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(53019, NULL, 'G3DSA:2.130.10.10:FF:004161', NULL, NULL, 'MGC69094 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(53020, NULL, 'G3DSA:3.40.1190.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53021, NULL, 'G3DSA:1.20.1070.10:FF:001045', NULL, NULL, 'Beta-1 adrenergic receptor', NULL, NULL, NULL, NULL, NULL, 4),
(53022, NULL, 'G3DSA:2.130.10.10:FF:001811', NULL, NULL, 'Unplaced genomic scaffold supercont1.15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(53023, NULL, 'G3DSA:2.60.40.1530:FF:000017', NULL, NULL, 'Integrin alpha5tr subunit', NULL, NULL, NULL, NULL, NULL, 4),
(53024, NULL, 'G3DSA:3.40.50.1820:FF:000698', NULL, NULL, 'Lysosomal thioesterase PPT2', NULL, NULL, NULL, NULL, NULL, 4),
(53025, NULL, 'G3DSA:3.80.10.10:FF:004526', NULL, NULL, 'F-box/leucine rich repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(53026, NULL, 'G3DSA:3.30.810.10:FF:000003', NULL, NULL, 'Phosphatidylinositol 5-phosphate 4-kinase type-2 beta', NULL, NULL, NULL, NULL, NULL, 4),
(53027, NULL, 'G3DSA:2.60.40.60:FF:000347', NULL, NULL, 'Cadherin 2', NULL, NULL, NULL, NULL, NULL, 4),
(53028, NULL, 'G3DSA:2.130.10.10:FF:003885', NULL, NULL, 'Protein CBG05170', NULL, NULL, NULL, NULL, NULL, 4),
(53029, NULL, 'G3DSA:1.20.1070.10:FF:000769', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(53030, NULL, 'G3DSA:3.30.230.80:FF:000013', NULL, NULL, 'Heat shock protein Hsp90', NULL, NULL, NULL, NULL, NULL, 4),
(53031, NULL, 'G3DSA:3.40.140.100:FF:000001', NULL, NULL, 'Ubiquitin-like modifier-activating enzyme ATG7', NULL, NULL, NULL, NULL, NULL, 4),
(53032, NULL, 'G3DSA:3.40.190.10:FF:000143', NULL, NULL, 'Glutamate receptor ionotropic, NMDA 2B', NULL, NULL, NULL, NULL, NULL, 4),
(53033, NULL, 'G3DSA:3.30.160.60:FF:001991', NULL, NULL, 'Zinc finger and SCAN domain containing 26', NULL, NULL, NULL, NULL, NULL, 4),
(53034, NULL, 'G3DSA:1.20.1250.20:FF:000691', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(53035, NULL, 'G3DSA:2.10.70.10:FF:000224', NULL, NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(53036, NULL, 'G3DSA:3.30.1330.30:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53037, NULL, 'G3DSA:2.60.40.10:FF:003576', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53038, NULL, 'G3DSA:3.40.50.300:FF:004902', NULL, NULL, 'ADR093Wp', NULL, NULL, NULL, NULL, NULL, 4),
(53039, NULL, 'G3DSA:3.40.50.10330:FF:000081', NULL, NULL, 'Sphingoid long-chain bases kinase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(53040, NULL, 'G3DSA:3.40.1580.20:FF:000001', NULL, NULL, 'Protein Syd', NULL, NULL, NULL, NULL, NULL, 4),
(53041, NULL, 'G3DSA:1.25.40.10:FF:001546', NULL, NULL, 'Translation regulator (Cya5), putative', NULL, NULL, NULL, NULL, NULL, 4),
(53042, NULL, 'G3DSA:3.40.50.1820:FF:001030', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(53043, NULL, 'G3DSA:1.10.10.10:FF:000122', NULL, NULL, 'Forkhead box protein N1', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(53044, NULL, 'G3DSA:2.130.10.10:FF:005740', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53045, NULL, 'G3DSA:1.10.510.10:FF:003286', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53046, NULL, 'G3DSA:2.10.25.10:FF:001210', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(53047, NULL, 'G3DSA:1.25.40.10:FF:001602', NULL, NULL, 'WGS project CABT00000000 data, contig 2.59', NULL, NULL, NULL, NULL, NULL, 4),
(53048, NULL, 'G3DSA:1.10.287.110:FF:000480', NULL, NULL, 'DnaJ-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(53049, NULL, 'G3DSA:1.20.1270.60:FF:000125', NULL, NULL, 'Putative phosphoinositide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(53050, NULL, 'G3DSA:3.30.160.60:FF:000355', NULL, NULL, 'zinc finger and SCAN domain-containing protein 20 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(53051, NULL, 'G3DSA:2.60.40.10:FF:001777', NULL, NULL, 'myopalladin isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(53052, NULL, 'G3DSA:3.30.160.60:FF:004008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53053, NULL, 'G3DSA:3.40.50.720:FF:001420', NULL, NULL, 'Zgc:158138 protein', NULL, NULL, NULL, NULL, NULL, 4),
(53054, NULL, 'G3DSA:1.20.1330.10:FF:000014', NULL, NULL, 'Flagellar hook-associated protein FlgL', NULL, NULL, NULL, NULL, NULL, 4),
(53055, NULL, 'G3DSA:1.10.10.1050:FF:000008', NULL, NULL, 'M7GpppN-mRNA hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(53056, NULL, 'G3DSA:2.10.50.10:FF:000173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53057, NULL, 'G3DSA:2.130.10.10:FF:003941', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53058, NULL, 'G3DSA:1.10.3210.10:FF:000042', NULL, NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(53059, NULL, 'G3DSA:1.10.238.10:FF:000331', NULL, NULL, 'Ca2+-binding EF-hand protein', NULL, NULL, NULL, NULL, NULL, 4),
(53060, NULL, 'G3DSA:1.10.10.390:FF:000006', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(53061, NULL, 'G3DSA:1.10.287.950:FF:000001', NULL, NULL, 'Methyl-accepting chemotaxis sensory transducer', NULL, NULL, NULL, NULL, NULL, 4),
(53062, NULL, 'G3DSA:1.10.720.30:FF:000014', NULL, NULL, 'E3 SUMO-protein ligase SIZ1', NULL, NULL, NULL, NULL, NULL, 4),
(53063, NULL, 'G3DSA:1.10.10.10:FF:001577', NULL, NULL, 'Zinc uptake regulation protein ZUR', NULL, NULL, NULL, NULL, NULL, 4),
(53064, NULL, 'G3DSA:3.90.226.10:FF:000300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53065, NULL, 'G3DSA:1.10.287.1060:FF:000007', NULL, NULL, 'Charged multivesicular body protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(53066, NULL, 'G3DSA:3.30.1360.120:FF:000091', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(53067, NULL, 'G3DSA:3.40.1110.10:FF:000205', NULL, NULL, 'Ca2+-transporting ATPase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(53068, NULL, 'G3DSA:2.30.130.10:FF:000016', NULL, NULL, 'tRNA pseudouridine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(53069, NULL, 'G3DSA:3.40.50.300:FF:003885', NULL, NULL, 'ATP binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(53070, NULL, 'G3DSA:3.90.530.10:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53071, NULL, 'G3DSA:3.50.30.30:FF:000044', NULL, NULL, 'N-acetylated alpha-linked acidic dipeptidase like 1', NULL, NULL, NULL, NULL, NULL, 4),
(53072, NULL, 'G3DSA:1.10.287.110:FF:000148', NULL, NULL, 'DnaJ protein', NULL, NULL, NULL, NULL, NULL, 4),
(53073, NULL, 'G3DSA:3.40.30.10:FF:001140', NULL, NULL, 'Uncharacterized protein DpGSTM3', NULL, NULL, NULL, NULL, NULL, 4),
(53074, NULL, 'G3DSA:2.60.40.150:FF:000049', NULL, NULL, 'Protein kinase C delta type', NULL, NULL, NULL, NULL, NULL, 4),
(53075, NULL, 'G3DSA:3.80.10.10:FF:000873', NULL, NULL, 'Leucine-rich repeat-containing protein 8C', NULL, NULL, NULL, NULL, NULL, 4),
(53076, NULL, 'G3DSA:1.10.3730.20:FF:000011', NULL, NULL, 'EamA family transporter', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(53077, NULL, 'G3DSA:3.40.50.261:FF:000013', NULL, NULL, 'Acetyltransferase, GNAT family', NULL, NULL, NULL, NULL, NULL, 4),
(53078, NULL, 'G3DSA:1.20.1250.20:FF:000578', NULL, NULL, 'Mch4p', NULL, NULL, NULL, NULL, NULL, 4),
(53079, NULL, 'G3DSA:3.30.1320.10:FF:000021', NULL, NULL, 'Putative 28S ribosomal protein S16, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(53080, NULL, 'G3DSA:3.30.1010.10:FF:000099', NULL, NULL, 'Phosphatidylinositol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(53081, NULL, 'G3DSA:3.40.50.2020:FF:000073', NULL, NULL, 'Uncharacterized protein, isoform L', NULL, NULL, NULL, NULL, NULL, 4),
(53082, NULL, 'G3DSA:3.10.20.770:FF:000008', NULL, NULL, 'Si:rp71-17i16.5', NULL, NULL, NULL, NULL, NULL, 4),
(53083, NULL, 'G3DSA:3.30.70.330:FF:002006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53084, NULL, 'G3DSA:2.130.10.10:FF:004104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53085, NULL, 'G3DSA:3.40.50.300:FF:007157', NULL, NULL, 'Rab family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(53086, NULL, 'G3DSA:1.50.10.10:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53087, NULL, 'G3DSA:1.20.1050.80:FF:000007', NULL, NULL, 'Vacuolar protein sorting-associated protein 9A', NULL, NULL, NULL, NULL, NULL, 4),
(53088, NULL, 'G3DSA:3.40.50.360:FF:000059', NULL, NULL, '5-methyltetrahydrofolate-homocysteine methyltransferase reductase', NULL, NULL, NULL, NULL, NULL, 4),
(53089, NULL, 'G3DSA:3.90.70.10:FF:000095', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(53090, NULL, 'G3DSA:2.60.40.10:FF:003519', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53091, NULL, 'G3DSA:3.30.160.60:FF:004284', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53092, NULL, 'G3DSA:1.10.530.10:FF:000027', NULL, NULL, 'Cell wall hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(53093, NULL, 'G3DSA:3.40.50.1100:FF:000252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53094, NULL, 'G3DSA:1.10.287.1040:FF:000001', NULL, NULL, 'Exodeoxyribonuclease 7 small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(53095, NULL, 'G3DSA:3.40.50.150:FF:000041', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase G', NULL, NULL, NULL, NULL, NULL, 4),
(53096, NULL, 'G3DSA:3.10.580.10:FF:000051', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(53097, NULL, 'G3DSA:3.30.70.330:FF:002967', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53098, NULL, 'G3DSA:2.10.230.10:FF:000006', NULL, NULL, 'Chaperone protein dnaJ A6 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(53099, NULL, 'G3DSA:3.40.50.300:FF:007595', NULL, NULL, 'Glr1151 protein', NULL, NULL, NULL, NULL, NULL, 4),
(53100, NULL, 'G3DSA:3.40.350.10:FF:000021', NULL, NULL, 'xaa-Pro aminopeptidase 1 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(53101, NULL, 'G3DSA:3.30.160.60:FF:000411', NULL, NULL, 'PR domain zinc finger protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(53102, NULL, 'G3DSA:3.40.430.10:FF:000022', NULL, NULL, 'Riboflavin biosynthesis protein RibD', NULL, NULL, NULL, NULL, NULL, 4),
(53103, NULL, 'G3DSA:3.90.640.10:FF:000274', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(53104, NULL, 'G3DSA:3.30.830.10:FF:000330', NULL, NULL, 'Presequence protease', NULL, NULL, NULL, NULL, NULL, 4),
(53105, NULL, 'G3DSA:2.70.150.10:FF:000104', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(53106, NULL, 'G3DSA:2.60.40.1510:FF:000011', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(53107, NULL, 'G3DSA:3.40.50.2020:FF:000016', NULL, NULL, 'Ribose-phosphate pyrophosphokinase II', NULL, NULL, NULL, NULL, NULL, 4),
(53108, NULL, 'G3DSA:3.30.1370.70:FF:000002', NULL, NULL, 'NFU1 iron-sulfur cluster scaffold homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(53109, NULL, 'G3DSA:3.40.50.300:FF:003846', NULL, NULL, 'Spliceosome RNA helicase DDX39B', NULL, NULL, NULL, NULL, NULL, 4),
(53110, NULL, 'G3DSA:3.30.40.10:FF:001394', NULL, NULL, 'CRE-MADD-2 protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(53111, NULL, 'G3DSA:1.10.10.10:FF:001690', NULL, NULL, 'DEP domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(53112, NULL, 'G3DSA:1.10.418.10:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53113, NULL, 'G3DSA:2.170.210.10:FF:000001', NULL, NULL, 'Non-homologous end-joining factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(53114, NULL, 'G3DSA:2.170.210.20:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53115, NULL, 'G3DSA:2.40.50.140:FF:001093', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53116, NULL, 'G3DSA:3.20.20.10:FF:000078', NULL, NULL, 'Proline synthase co-transcribed bacterial homolog protein', NULL, NULL, NULL, NULL, NULL, 4),
(53117, NULL, 'G3DSA:1.10.8.270:FF:000113', NULL, NULL, 'TBC1 domain family, member 17', NULL, NULL, NULL, NULL, NULL, 4),
(53118, NULL, 'G3DSA:3.30.230.70:FF:000010', NULL, NULL, 'Exosome complex component RRP41', NULL, NULL, NULL, NULL, NULL, 4),
(53119, NULL, 'G3DSA:3.40.50.300:FF:004161', NULL, NULL, 'YALI0A17171p', NULL, NULL, NULL, NULL, NULL, 4),
(53120, NULL, 'G3DSA:4.10.400.10:FF:000017', NULL, NULL, 'LDL receptor related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(53121, NULL, 'G3DSA:3.40.50.620:FF:000665', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53122, NULL, 'G3DSA:1.20.1270.50:FF:000009', NULL, NULL, 'Alpha-mannosidase F', NULL, NULL, NULL, NULL, NULL, 4),
(53123, NULL, 'G3DSA:1.10.3720.10:FF:000125', NULL, NULL, 'ABC amino acid transporter, permease component', NULL, NULL, NULL, NULL, NULL, 4),
(53124, NULL, 'G3DSA:3.30.160.60:FF:003789', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53125, NULL, 'G3DSA:1.10.238.10:FF:000218', NULL, NULL, 'Phosphatase 2A regulatory subunit-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(53126, NULL, 'G3DSA:3.30.40.10:FF:000899', NULL, NULL, 'PHD finger and BAH domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(53127, NULL, 'G3DSA:1.10.132.70:FF:000024', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(53128, NULL, 'G3DSA:3.30.160.60:FF:003845', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53129, NULL, 'G3DSA:1.10.287.70:FF:000344', NULL, NULL, 'KCNN (Potassium K ChaNNel, calcium activated)-Like', NULL, NULL, NULL, NULL, NULL, 4),
(53130, NULL, 'G3DSA:3.40.50.200:FF:000039', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(53131, NULL, 'G3DSA:3.40.1190.20:FF:000191', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53132, NULL, 'G3DSA:3.30.479.20:FF:000049', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(53133, NULL, 'G3DSA:3.30.1360.120:FF:000034', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(53134, NULL, 'G3DSA:1.20.1410.10:FF:000015', NULL, NULL, 'WGS project CABT00000000 data, contig 2.10', NULL, NULL, NULL, NULL, NULL, 4),
(53135, NULL, 'G3DSA:2.30.30.140:FF:000321', NULL, NULL, 'Transcription elongation factor S-II, putative', NULL, NULL, NULL, NULL, NULL, 4),
(53136, NULL, 'G3DSA:2.60.120.200:FF:000366', NULL, NULL, 'Laminin subunit alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(53137, NULL, 'G3DSA:3.40.50.300:FF:007775', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(53138, NULL, 'G3DSA:3.30.40.10:FF:001517', NULL, NULL, 'Zinc finger, C3HC4 type (RING finger), putative', NULL, NULL, NULL, NULL, NULL, 4),
(53139, NULL, 'G3DSA:1.10.8.720:FF:000057', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(53140, NULL, 'G3DSA:1.10.472.80:FF:000244', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53141, NULL, 'G3DSA:3.40.50.450:FF:000030', NULL, NULL, 'Diphosphate-fructose-6-phosphate 1-phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(53142, NULL, 'G3DSA:1.10.287.1490:FF:000113', NULL, NULL, 'Spindle pole body protein pcp1', NULL, NULL, NULL, NULL, NULL, 4),
(53143, NULL, 'G3DSA:3.30.460.10:FF:000077', NULL, NULL, 'Poly(A) polymerase, putative', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(53144, NULL, 'G3DSA:1.10.437.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53145, NULL, 'G3DSA:3.40.50.300:FF:008051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53146, NULL, 'G3DSA:3.90.470.20:FF:000050', NULL, NULL, 'Holo-[acyl-carrier-protein] synthase', NULL, NULL, NULL, NULL, NULL, 4),
(53147, NULL, 'G3DSA:3.30.310.220:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53148, NULL, 'G3DSA:3.70.10.10:FF:000103', NULL, NULL, 'Cell cycle checkpoint control protein', NULL, NULL, NULL, NULL, NULL, 4),
(53149, NULL, 'G3DSA:3.40.630.30:FF:000397', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(53150, NULL, 'G3DSA:3.40.50.12350:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53151, NULL, 'G3DSA:3.30.470.110:FF:000001', NULL, NULL, 'ATP-citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(53152, NULL, 'G3DSA:3.30.572.10:FF:000016', NULL, NULL, 'Thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(53153, NULL, 'G3DSA:1.10.1520.10:FF:000065', NULL, NULL, 'YALI0D18150p', NULL, NULL, NULL, NULL, NULL, 4),
(53154, NULL, 'G3DSA:2.130.10.10:FF:003267', NULL, NULL, 'Pre-mRNA-splicing factor RSE1', NULL, NULL, NULL, NULL, NULL, 4),
(53155, NULL, 'G3DSA:3.40.50.300:FF:008270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53156, NULL, 'G3DSA:3.40.50.1240:FF:000153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53157, NULL, 'G3DSA:3.40.50.1820:FF:000479', NULL, NULL, 'Phosphoribosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(53158, NULL, 'G3DSA:3.40.50.300:FF:000013', NULL, NULL, 'PhoH family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(53159, NULL, 'G3DSA:3.30.310.210:FF:000002', NULL, NULL, 'KH domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(53160, NULL, 'G3DSA:3.30.160.60:FF:004065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53161, NULL, 'G3DSA:1.20.1070.10:FF:001606', NULL, NULL, '5-hydroxytryptamine receptor 1E', NULL, NULL, NULL, NULL, NULL, 4),
(53162, NULL, 'G3DSA:1.10.510.10:FF:004180', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53163, NULL, 'G3DSA:1.10.510.10:FF:000138', NULL, NULL, 'PX domain-containing protein kinase-like protein isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(53164, NULL, 'G3DSA:1.10.220.10:FF:000037', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(53165, NULL, 'G3DSA:3.80.10.10:FF:001311', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', NULL, NULL, NULL, NULL, NULL, 4),
(53166, NULL, 'G3DSA:3.10.20.90:FF:000080', NULL, NULL, 'protein-tyrosine kinase 2-beta isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(53167, NULL, 'G3DSA:1.25.40.20:FF:001824', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53168, NULL, 'G3DSA:1.10.510.10:FF:004123', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53169, NULL, 'G3DSA:3.30.40.10:FF:001450', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53170, NULL, 'G3DSA:1.20.1070.10:FF:001264', NULL, NULL, 'Adhesion G protein-coupled receptor B3', NULL, NULL, NULL, NULL, NULL, 4),
(53171, NULL, 'G3DSA:3.30.160.60:FF:004340', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53172, NULL, 'G3DSA:1.20.1250.20:FF:001034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53173, NULL, 'G3DSA:1.25.10.10:FF:000414', NULL, NULL, 'Kinase family with ARM repeat domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(53174, NULL, 'G3DSA:1.10.565.10:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53175, NULL, 'G3DSA:1.10.1200.10:FF:000136', NULL, NULL, 'Nonribosomal peptide synthase, putative (JCVI)', NULL, NULL, NULL, NULL, NULL, 4),
(53176, NULL, 'G3DSA:2.60.40.790:FF:000050', NULL, NULL, 'Probable inactive shikimate kinase like 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(53177, NULL, 'G3DSA:2.30.30.280:FF:000003', NULL, NULL, 'tRNA (5-methylaminomethyl-2-thiouridylate)-methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(53178, NULL, 'G3DSA:3.40.50.1110:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53179, NULL, 'G3DSA:1.25.40.10:FF:001821', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(53180, NULL, 'G3DSA:3.10.20.30:FF:000101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53181, NULL, 'G3DSA:2.10.50.10:FF:000116', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(53182, NULL, 'G3DSA:3.30.450.40:FF:000012', NULL, NULL, 'Phosphoenolpyruvate-protein phosphotransferase PtsP', NULL, NULL, NULL, NULL, NULL, 4),
(53183, NULL, 'G3DSA:2.40.50.140:FF:000598', NULL, NULL, 'Single-stranded DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(53184, NULL, 'G3DSA:3.30.70.80:FF:000034', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 9', NULL, NULL, NULL, NULL, NULL, 4),
(53185, NULL, 'G3DSA:1.25.40.20:FF:000065', NULL, NULL, 'Ankyrin repeat domain-containing protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(53186, NULL, 'G3DSA:3.40.50.300:FF:004341', NULL, NULL, 'RAD51 paralog D', NULL, NULL, NULL, NULL, NULL, 4),
(53187, NULL, 'G3DSA:1.50.10.10:FF:000058', NULL, NULL, 'YMR196W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(53188, NULL, 'G3DSA:1.20.5.110:FF:000350', NULL, NULL, 'Qc-SNARE protein, Tlg1/Syntaxin 6-family', NULL, NULL, NULL, NULL, NULL, 4),
(53189, NULL, 'G3DSA:3.30.70.1020:FF:000005', NULL, NULL, 'Trehalose 6-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(53190, NULL, 'G3DSA:1.10.510.10:FF:003847', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53191, NULL, 'G3DSA:3.60.10.10:FF:000188', NULL, NULL, 'YALI0C08657p', NULL, NULL, NULL, NULL, NULL, 4),
(53192, NULL, 'G3DSA:2.20.25.240:FF:000017', NULL, NULL, 'AGAP004541-PA', NULL, NULL, NULL, NULL, NULL, 4),
(53193, NULL, 'G3DSA:2.40.150.20:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53194, NULL, 'G3DSA:4.10.240.10:FF:000196', NULL, NULL, 'Putative transcription factor with C2H2 and Zn(2)-Cys(6) DNA binding domain (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(53195, NULL, 'G3DSA:2.130.10.10:FF:000232', NULL, NULL, 'enhancer of mRNA-decapping protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(53196, NULL, 'G3DSA:1.10.238.110:FF:000010', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(53197, NULL, 'G3DSA:3.30.70.1170:FF:000022', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(53198, NULL, 'G3DSA:3.10.300.10:FF:000002', NULL, NULL, 'DNA-3-methyladenine glycosylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(53199, NULL, 'G3DSA:2.10.25.10:FF:000772', NULL, NULL, 'Multiple epidermal growth factor-like domains 6', NULL, NULL, NULL, NULL, NULL, 4),
(53200, NULL, 'G3DSA:1.10.20.10:FF:000004', NULL, NULL, 'Histone H2A', NULL, NULL, NULL, NULL, NULL, 4),
(53201, NULL, 'G3DSA:3.30.420.40:FF:001078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53202, NULL, 'G3DSA:1.10.510.10:FF:000413', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(53203, NULL, 'G3DSA:1.20.1270.60:FF:000069', NULL, NULL, 'Nostrin, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(53204, NULL, 'G3DSA:3.80.10.10:FF:001036', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(53205, NULL, 'G3DSA:2.40.128.20:FF:000028', NULL, NULL, 'Violaxanthin de-epoxidase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(53206, NULL, 'G3DSA:3.40.50.10190:FF:000055', NULL, NULL, 'Microcephalin', NULL, NULL, NULL, NULL, NULL, 4),
(53207, NULL, 'G3DSA:3.90.520.10:FF:000001', NULL, NULL, 'Mothers against decapentaplegic homolog', NULL, NULL, NULL, NULL, NULL, 4),
(53208, NULL, 'G3DSA:1.10.150.50:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53209, NULL, 'G3DSA:2.60.40.2000:FF:000001', NULL, NULL, 'Spore protein YabP', NULL, NULL, NULL, NULL, NULL, 4),
(53210, NULL, 'G3DSA:3.40.50.300:FF:000631', NULL, NULL, 'Ras small monomeric GTPase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(53211, NULL, 'G3DSA:3.40.50.300:FF:008612', NULL, NULL, 'Pre-initiation complex, subunit CDC6', NULL, NULL, NULL, NULL, NULL, 4),
(53212, NULL, 'G3DSA:3.40.1670.10:FF:000005', NULL, NULL, 'UbiD family decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(53213, NULL, 'G3DSA:1.10.20.10:FF:000061', NULL, NULL, 'TFIID subunit', NULL, NULL, NULL, NULL, NULL, 4),
(53214, NULL, 'G3DSA:1.10.10.60:FF:000221', NULL, NULL, 'MYB transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(53215, NULL, 'G3DSA:2.60.40.60:FF:000460', NULL, NULL, 'Dachsous, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(53216, NULL, 'G3DSA:3.30.160.60:FF:000630', NULL, NULL, 'Zinc finger protein 180', NULL, NULL, NULL, NULL, NULL, 4),
(53217, NULL, 'G3DSA:2.10.25.10:FF:000715', NULL, NULL, 'Hemicentin 2', NULL, NULL, NULL, NULL, NULL, 4),
(53218, NULL, 'G3DSA:2.130.10.10:FF:003609', NULL, NULL, 'SEC31 homolog B, COPII coat complex component', NULL, NULL, NULL, NULL, NULL, 4),
(53219, NULL, 'G3DSA:3.30.9.10:FF:000085', NULL, NULL, 'Putative secreted oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(53220, NULL, 'G3DSA:3.90.70.10:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53221, NULL, 'G3DSA:2.60.120.380:FF:000088', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(53222, NULL, 'G3DSA:3.30.70.260:FF:000119', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(53223, NULL, 'G3DSA:2.130.10.10:FF:003666', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53224, NULL, 'G3DSA:3.20.20.70:FF:000399', NULL, NULL, 'Homocitrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(53225, NULL, 'G3DSA:3.10.20.90:FF:000259', NULL, NULL, 'Raf serine/threonine-protein kinase phl', NULL, NULL, NULL, NULL, NULL, 4),
(53226, NULL, 'G3DSA:2.10.25.10:FF:001272', NULL, NULL, 'Laminin subunit alpha-1', NULL, NULL, NULL, NULL, NULL, 4),
(53227, NULL, 'G3DSA:1.20.1250.20:FF:000567', NULL, NULL, 'MonoCarboxylate Transporter family', NULL, NULL, NULL, NULL, NULL, 4),
(53228, NULL, 'G3DSA:2.60.40.1170:FF:000004', NULL, NULL, 'SH3-containing GRB2-like protein 3-interacting protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(53229, NULL, 'G3DSA:3.40.50.300:FF:003638', NULL, NULL, 'DNA repair protein RecN', NULL, NULL, NULL, NULL, NULL, 4),
(53230, NULL, 'G3DSA:3.20.10.10:FF:000066', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(53231, NULL, 'G3DSA:3.40.50.2300:FF:001511', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53232, NULL, 'G3DSA:3.30.540.10:FF:000021', NULL, NULL, 'Inositol monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(53233, NULL, 'G3DSA:3.20.20.70:FF:000551', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53234, NULL, 'G3DSA:3.40.50.1820:FF:001440', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53235, NULL, 'G3DSA:3.40.1010.10:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53236, NULL, 'G3DSA:2.60.120.330:FF:000034', NULL, NULL, '2-oxoglutarate (2OG) and Fe(II)-dependent oxygenase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(53237, NULL, 'G3DSA:3.30.70.330:FF:000899', NULL, NULL, 'RNA-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(53238, NULL, 'G3DSA:1.10.1200.10:FF:000007', NULL, NULL, 'Probable polyketide synthase pks17', NULL, NULL, NULL, NULL, NULL, 4),
(53239, NULL, 'G3DSA:1.25.40.610:FF:000007', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(53240, NULL, 'G3DSA:3.30.9.10:FF:000057', NULL, NULL, 'Protein CBG22093', NULL, NULL, NULL, NULL, NULL, 4),
(53241, NULL, 'G3DSA:2.60.120.620:FF:000014', NULL, NULL, 'Prolyl 3,4-dihydroxylase TPA1', NULL, NULL, NULL, NULL, NULL, 4),
(53242, NULL, 'G3DSA:3.60.21.10:FF:000382', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53243, NULL, 'G3DSA:3.10.490.20:FF:000041', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(53244, NULL, 'G3DSA:1.10.8.10:FF:000082', NULL, NULL, 'Ubiquilin 3', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(53245, NULL, 'G3DSA:3.40.50.300:FF:000412', NULL, NULL, 'ADP-ribosylation factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(53246, NULL, 'G3DSA:1.10.10.10:FF:001757', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC3', NULL, NULL, NULL, NULL, NULL, 4),
(53247, NULL, 'G3DSA:2.60.40.10:FF:004306', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53248, NULL, 'G3DSA:1.50.40.10:FF:000184', NULL, NULL, 'Mitochondrial carrier protein, putative (AFU_orthologue AFUA_6G12900)', NULL, NULL, NULL, NULL, NULL, 4),
(53249, NULL, 'G3DSA:1.10.150.80:FF:000024', NULL, NULL, 'Unplaced genomic scaffold supercont1.37, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(53250, NULL, 'G3DSA:3.50.50.60:FF:001408', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53251, NULL, 'G3DSA:2.60.40.60:FF:000471', NULL, NULL, 'E-cadherin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(53252, NULL, 'G3DSA:1.20.120.350:FF:000151', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53253, NULL, 'G3DSA:1.10.520.10:FF:000021', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(53254, NULL, 'G3DSA:2.70.170.10:FF:000116', NULL, NULL, 'CHRNA7 (exons 5-10) and FAM7A (exons A-E) fusion', NULL, NULL, NULL, NULL, NULL, 4),
(53255, NULL, 'G3DSA:3.10.450.240:FF:000029', NULL, NULL, 'Uncharacterized protein C13G7.11', NULL, NULL, NULL, NULL, NULL, 4),
(53256, NULL, 'G3DSA:3.30.70.1230:FF:000142', NULL, NULL, 'Blr5637 protein', NULL, NULL, NULL, NULL, NULL, 4),
(53257, NULL, 'G3DSA:1.10.8.60:FF:000147', NULL, NULL, 'Putative ATP-dependent zinc metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(53258, NULL, 'G3DSA:2.60.40.10:FF:001709', NULL, NULL, 'filamin-A isoform X9', NULL, NULL, NULL, NULL, NULL, 4),
(53259, NULL, 'G3DSA:1.10.555.10:FF:000028', NULL, NULL, 'rho GTPase-activating protein 18 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(53260, NULL, 'G3DSA:4.10.1240.10:FF:000018', NULL, NULL, 'Secretin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(53261, NULL, 'G3DSA:2.30.29.30:FF:000847', NULL, NULL, 'RanBP1 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(53262, NULL, 'G3DSA:3.90.640.10:FF:000257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53263, NULL, 'G3DSA:1.20.120.1080:FF:000118', NULL, NULL, 'Putative mrna splicing factor atp-dependent rna helicase', NULL, NULL, NULL, NULL, NULL, 4),
(53264, NULL, 'G3DSA:1.25.10.10:FF:001393', NULL, NULL, 'VAC (Yeast VACuole morphology)-Like', NULL, NULL, NULL, NULL, NULL, 4),
(53265, NULL, 'G3DSA:2.10.230.10:FF:000028', NULL, NULL, 'AGAP005908-PA', NULL, NULL, NULL, NULL, NULL, 4),
(53266, NULL, 'G3DSA:3.10.580.10:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53267, NULL, 'G3DSA:2.60.40.1180:FF:000007', NULL, NULL, 'Sucrose isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(53268, NULL, 'G3DSA:3.40.50.300:FF:004144', NULL, NULL, 'ADP-ribosylation factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(53269, NULL, 'G3DSA:3.20.20.80:FF:000554', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53270, NULL, 'G3DSA:3.40.140.10:FF:000230', NULL, NULL, 'CMP/dCMP deaminase, zinc-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(53271, NULL, 'G3DSA:2.30.310.10:FF:000002', NULL, NULL, 'nuclear export mediator factor Nemf', NULL, NULL, NULL, NULL, NULL, 4),
(53272, NULL, 'G3DSA:1.20.5.240:FF:000001', NULL, NULL, 'Cholera enterotoxin subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(53273, NULL, 'G3DSA:1.20.1560.10:FF:000857', NULL, NULL, 'Bll6336 protein', NULL, NULL, NULL, NULL, NULL, 4),
(53274, NULL, 'G3DSA:1.10.418.10:FF:000221', NULL, NULL, 'PH domain-containing protein DDB_G0287875', NULL, NULL, NULL, NULL, NULL, 4),
(53275, NULL, 'G3DSA:1.10.510.10:FF:004308', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53276, NULL, 'G3DSA:2.10.220.10:FF:000056', NULL, NULL, 'Fraser extracellular matrix complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(53277, NULL, 'G3DSA:1.10.510.10:FF:003275', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(53278, NULL, 'G3DSA:3.10.105.10:FF:000032', NULL, NULL, 'Probable periplasmic oligopeptide-binding lipoprotein oppA', NULL, NULL, NULL, NULL, NULL, 4),
(53279, NULL, 'G3DSA:2.40.250.10:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53280, NULL, 'G3DSA:1.25.40.10:FF:004171', NULL, NULL, 'SYF pre-mRNA splicing factor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(53281, NULL, 'G3DSA:3.40.50.1820:FF:000967', NULL, NULL, 'AGAP001825-PA', NULL, NULL, NULL, NULL, NULL, 4),
(53282, NULL, 'G3DSA:1.10.238.10:FF:000123', NULL, NULL, 'probable calcium-binding protein CML18', NULL, NULL, NULL, NULL, NULL, 4),
(53283, NULL, 'G3DSA:3.80.10.10:FF:003407', NULL, NULL, 'Uncharacterized leucine-rich repeat-containing protein C926.06c', NULL, NULL, NULL, NULL, NULL, 4),
(53284, NULL, 'G3DSA:2.60.40.10:FF:005397', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53285, NULL, 'G3DSA:2.30.29.30:FF:001027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53286, NULL, 'G3DSA:3.20.80.10:FF:000014', NULL, NULL, 'Heme-binding-like protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(53287, NULL, 'G3DSA:3.80.10.10:FF:000457', NULL, NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g34110', NULL, NULL, NULL, NULL, NULL, 4),
(53288, NULL, 'G3DSA:2.170.130.30:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53289, NULL, 'G3DSA:3.40.50.10330:FF:000097', NULL, NULL, 'Diacylglycerol kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(53290, NULL, 'G3DSA:2.60.40.10:FF:001698', NULL, NULL, 'contactin', NULL, NULL, NULL, NULL, NULL, 4),
(53291, NULL, 'G3DSA:3.30.200.20:FF:001168', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(53292, NULL, 'G3DSA:4.10.1130.20:FF:000002', NULL, NULL, 'cysteine and histidine-rich domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(53293, NULL, 'G3DSA:2.30.22.10:FF:000011', NULL, NULL, 'Putative co-chaperone, GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(53294, NULL, 'G3DSA:1.10.10.60:FF:001295', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53295, NULL, 'G3DSA:3.20.70.20:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53296, NULL, 'G3DSA:2.170.130.20:FF:000003', NULL, NULL, 'Multidomain scavenger receptor', NULL, NULL, NULL, NULL, NULL, 4),
(53297, NULL, 'G3DSA:1.25.40.20:FF:000166', NULL, NULL, 'rabankyrin-5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(53298, NULL, 'G3DSA:3.30.499.10:FF:000025', NULL, NULL, 'Aconitate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(53299, NULL, 'G3DSA:1.20.1280.50:FF:000128', NULL, NULL, 'Leucine rich repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(53300, NULL, 'G3DSA:2.20.70.10:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53301, NULL, 'G3DSA:3.80.10.10:FF:000766', NULL, NULL, 'Os05g0263100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(53302, NULL, 'G3DSA:2.130.10.10:FF:001676', NULL, NULL, 'WD domain, G-beta repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(53303, NULL, 'G3DSA:3.40.50.1820:FF:000288', NULL, NULL, 'Pancreatic triacylglycerol lipase', NULL, NULL, NULL, NULL, NULL, 4),
(53304, NULL, 'G3DSA:2.60.40.60:FF:000145', NULL, NULL, 'protocadherin-20', NULL, NULL, NULL, NULL, NULL, 4),
(53305, NULL, 'G3DSA:3.40.50.10330:FF:000108', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(53306, NULL, 'G3DSA:1.10.630.10:FF:000675', NULL, NULL, 'Os01g0388000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(53307, NULL, 'G3DSA:1.25.40.10:FF:001911', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53308, NULL, 'G3DSA:2.130.10.10:FF:005375', NULL, NULL, 'WD repeat domain 27', NULL, NULL, NULL, NULL, NULL, 4),
(53309, NULL, 'G3DSA:3.40.1840.10:FF:000002', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(53310, NULL, 'G3DSA:3.30.160.60:FF:002620', NULL, NULL, 'Zinc finger protein 516', NULL, NULL, NULL, NULL, NULL, 4),
(53311, NULL, 'G3DSA:1.10.1420.10:FF:000214', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(53312, NULL, 'G3DSA:3.40.50.300:FF:000119', NULL, NULL, 'Sulfate adenylyltransferase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(53313, NULL, 'G3DSA:1.20.1270.280:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53314, NULL, 'G3DSA:2.40.440.10:FF:000015', NULL, NULL, 'ErfK/YbiS/YcfS/YnhG family protein', NULL, NULL, NULL, NULL, NULL, 4),
(53315, NULL, 'G3DSA:3.40.33.10:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53316, NULL, 'G3DSA:3.40.190.80:FF:000029', NULL, NULL, 'Inositol monophosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(53317, NULL, 'G3DSA:1.10.10.440:FF:000044', NULL, NULL, 'Transcription elongation regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(53318, NULL, 'G3DSA:1.25.50.20:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53319, NULL, 'G3DSA:2.40.50.100:FF:000114', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(53320, NULL, 'G3DSA:3.30.930.10:FF:000315', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(53321, NULL, 'G3DSA:1.10.1450.10:FF:000042', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(53322, NULL, 'G3DSA:2.30.42.10:FF:000496', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53323, NULL, 'G3DSA:2.30.110.10:FF:000004', NULL, NULL, 'Cellular repressor of E1A-stimulated genes 1', NULL, NULL, NULL, NULL, NULL, 4),
(53324, NULL, 'G3DSA:4.10.400.10:FF:000091', NULL, NULL, 'Low-density lipoprotein receptor (Ldl)', NULL, NULL, NULL, NULL, NULL, 4),
(53325, NULL, 'G3DSA:1.25.40.60:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53326, NULL, 'G3DSA:3.10.50.40:FF:000016', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(53327, NULL, 'G3DSA:3.40.50.720:FF:001263', NULL, NULL, 'Siroheme synthase', NULL, NULL, NULL, NULL, NULL, 4),
(53328, NULL, 'G3DSA:1.20.1250.20:FF:000893', NULL, NULL, 'Similar to transporter', NULL, NULL, NULL, NULL, NULL, 4),
(53329, NULL, 'G3DSA:2.60.40.10:FF:005734', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53330, NULL, 'G3DSA:3.30.200.20:FF:001494', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53331, NULL, 'G3DSA:3.80.10.10:FF:002374', NULL, NULL, 'Insulin-like growth factor-binding protein complex acid labile subunit', NULL, NULL, NULL, NULL, NULL, 4),
(53332, NULL, 'G3DSA:2.60.40.10:FF:003952', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53333, NULL, 'G3DSA:1.10.630.10:FF:000349', NULL, NULL, 'Ent-kaurene oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(53334, NULL, 'G3DSA:3.30.450.90:FF:000009', NULL, NULL, 'Twitching motility protein PilT', NULL, NULL, NULL, NULL, NULL, 4),
(53335, NULL, 'G3DSA:3.40.50.2300:FF:000685', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53336, NULL, 'G3DSA:3.10.250.10:FF:000138', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53337, NULL, 'G3DSA:3.40.50.300:FF:003964', NULL, NULL, 'Endoribonuclease Dcr-1', NULL, NULL, NULL, NULL, NULL, 4),
(53338, NULL, 'G3DSA:3.40.50.300:FF:004470', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(53339, NULL, 'G3DSA:2.60.40.150:FF:000414', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(53340, NULL, 'G3DSA:1.50.10.10:FF:000047', NULL, NULL, 'Mannosyl-oligosaccharide alpha-1,2-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(53341, NULL, 'G3DSA:2.60.220.50:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53342, NULL, 'G3DSA:1.10.287.110:FF:000311', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53343, NULL, 'G3DSA:2.130.10.10:FF:003930', NULL, NULL, 'Prolactin regulatory element binding', NULL, NULL, NULL, NULL, NULL, 4),
(53344, NULL, 'G3DSA:3.40.605.10:FF:000136', NULL, NULL, '4-trimethylaminobutyraldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(53345, NULL, 'G3DSA:1.10.8.60:FF:000517', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(53346, NULL, 'G3DSA:3.40.50.2300:FF:001174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53347, NULL, 'G3DSA:3.30.160.60:FF:004109', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53348, NULL, 'G3DSA:2.40.50.150:FF:000005', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(53349, NULL, 'G3DSA:1.10.510.10:FF:003954', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53350, NULL, 'G3DSA:1.25.40.70:FF:000024', NULL, NULL, 'Phosphatidylinositol 3-kinase age-1', NULL, NULL, NULL, NULL, NULL, 4),
(53351, NULL, 'G3DSA:3.30.1490.220:FF:000003', NULL, NULL, 'inositol 1,3,4-trisphosphate 5/6-kinase 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(53352, NULL, 'G3DSA:1.25.40.10:FF:005273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53353, NULL, 'G3DSA:2.170.260.10:FF:000021', NULL, NULL, 'Endoribonuclease Dicer-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(53354, NULL, 'G3DSA:1.10.1520.10:FF:000054', NULL, NULL, 'Endoribonuclease Dicer-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(53355, NULL, 'G3DSA:3.40.50.2300:FF:000994', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53356, NULL, 'G3DSA:3.10.50.30:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53357, NULL, 'G3DSA:1.20.1110.10:FF:000071', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(53358, NULL, 'G3DSA:3.40.50.1820:FF:001114', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(53359, NULL, 'G3DSA:3.30.160.60:FF:000366', NULL, NULL, 'Putative Krueppel-like factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(53360, NULL, 'G3DSA:2.80.10.50:FF:000151', NULL, NULL, 'Otogelin-like', NULL, NULL, NULL, NULL, NULL, 4),
(53361, NULL, 'G3DSA:3.40.50.2000:FF:000685', NULL, NULL, 'Glycosyltransferase, group 1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(53362, NULL, 'G3DSA:2.40.50.140:FF:000002', NULL, NULL, 'Translation initiation factor IF-1', NULL, NULL, NULL, NULL, NULL, 4),
(53363, NULL, 'G3DSA:1.10.1040.50:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53364, NULL, 'G3DSA:1.10.720.30:FF:000008', NULL, NULL, 'Myocardin', NULL, NULL, NULL, NULL, NULL, 4),
(53365, NULL, 'G3DSA:3.30.70.330:FF:001416', NULL, NULL, 'Peroxisome proliferator-activated receptor gamma, coactivator-related 1', NULL, NULL, NULL, NULL, NULL, 4),
(53366, NULL, 'G3DSA:1.25.40.10:FF:003709', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53367, NULL, 'G3DSA:3.30.2410.10:FF:000034', NULL, NULL, 'WWP1 isoform 12', NULL, NULL, NULL, NULL, NULL, 4),
(53368, NULL, 'G3DSA:3.90.190.10:FF:000519', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53369, NULL, 'G3DSA:1.10.510.10:FF:002173', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(53370, NULL, 'G3DSA:3.40.30.10:FF:000432', NULL, NULL, 'Tryparedoxin peroxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(53371, NULL, 'G3DSA:3.40.950.10:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53372, NULL, 'G3DSA:3.30.1360.120:FF:000107', NULL, NULL, 'Dimethylglycine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(53373, NULL, 'G3DSA:3.30.160.60:FF:001468', NULL, NULL, 'Zinc finger protein 672', NULL, NULL, NULL, NULL, NULL, 4),
(53374, NULL, 'G3DSA:3.30.40.10:FF:001534', NULL, NULL, 'Vacuolar protein sorting-associated protein 11 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(53375, NULL, 'G3DSA:2.70.130.10:FF:000007', NULL, NULL, 'Insulin-like growth factor 2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(53376, NULL, 'G3DSA:1.20.1070.10:FF:000792', NULL, NULL, 'galanin receptor type 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(53377, NULL, 'G3DSA:3.30.65.10:FF:000012', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(53378, NULL, 'G3DSA:3.90.1200.10:FF:000004', NULL, NULL, 'Thiamine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(53379, NULL, 'G3DSA:1.20.58.70:FF:000030', NULL, NULL, 'TLG2p Syntaxin-like t-SNARE', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(53380, NULL, 'G3DSA:1.20.58.390:FF:000028', NULL, NULL, 'Cholinergic receptor nicotinic beta 2 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(53381, NULL, 'G3DSA:3.90.1750.10:FF:000034', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(53382, NULL, 'G3DSA:1.20.120.1760:FF:000081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53383, NULL, 'G3DSA:3.40.1370.10:FF:000027', NULL, NULL, '50S ribosomal protein L4', NULL, NULL, NULL, NULL, NULL, 4),
(53384, NULL, 'G3DSA:2.40.10.340:FF:000009', NULL, NULL, 'Cell shape-determining protein MreC', NULL, NULL, NULL, NULL, NULL, 4),
(53385, NULL, 'G3DSA:3.50.30.10:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53386, NULL, 'G3DSA:3.40.50.720:FF:000774', NULL, NULL, 'Glyoxylate reductase/hydroxypyruvate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(53387, NULL, 'G3DSA:1.25.40.10:FF:001248', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g09450, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(53388, NULL, 'G3DSA:3.90.640.20:FF:000001', NULL, NULL, 'Immunogenic protein Mpt64', NULL, NULL, NULL, NULL, NULL, 4),
(53389, NULL, 'G3DSA:2.60.40.10:FF:002171', NULL, NULL, 'Twitchin', NULL, NULL, NULL, NULL, NULL, 4),
(53390, NULL, 'G3DSA:3.40.50.150:FF:000232', NULL, NULL, 'Sterol 24-C-methyltransferase erg6', NULL, NULL, NULL, NULL, NULL, 4),
(53391, NULL, 'G3DSA:3.40.30.10:FF:000802', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53392, NULL, 'G3DSA:3.40.50.300:FF:007707', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53393, NULL, 'G3DSA:1.10.260.100:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53394, NULL, 'G3DSA:4.10.410.10:FF:000046', NULL, NULL, 'AGAP011765-PA', NULL, NULL, NULL, NULL, NULL, 4),
(53395, NULL, 'G3DSA:3.40.50.300:FF:007696', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53396, NULL, 'G3DSA:1.20.1270.10:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53397, NULL, 'G3DSA:3.30.70.330:FF:001096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53398, NULL, 'G3DSA:1.20.58.80:FF:000033', NULL, NULL, 'Alpha-1,4-glucan:maltose-1-phosphate maltosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(53399, NULL, 'G3DSA:1.10.510.10:FF:000402', NULL, NULL, 'MAPK/MAK/MRK overlapping kinase', NULL, NULL, NULL, NULL, NULL, 4),
(53400, NULL, 'G3DSA:3.40.120.10:FF:000021', NULL, NULL, 'Phosphomannomutase/phosphoglucomutase', NULL, NULL, NULL, NULL, NULL, 4),
(53401, NULL, 'G3DSA:1.10.20.10:FF:000111', NULL, NULL, 'Histone H3', NULL, NULL, NULL, NULL, NULL, 4),
(53402, NULL, 'G3DSA:1.25.10.10:FF:001746', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53403, NULL, 'G3DSA:1.20.1250.20:FF:001073', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(53404, NULL, 'G3DSA:1.10.720.10:FF:000002', NULL, NULL, 'Transcription termination factor Rho', NULL, NULL, NULL, NULL, NULL, 4),
(53405, NULL, 'G3DSA:3.40.50.300:FF:005555', NULL, NULL, 'Protein SMAX1-LIKE 6', NULL, NULL, NULL, NULL, NULL, 4),
(53406, NULL, 'G3DSA:3.30.160.60:FF:001777', NULL, NULL, 'zinc finger protein 770', NULL, NULL, NULL, NULL, NULL, 4),
(53407, NULL, 'G3DSA:3.20.20.10:FF:000005', NULL, NULL, 'Ornithine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(53408, NULL, 'G3DSA:3.30.40.10:FF:001225', NULL, NULL, 'Protein CBG01632', NULL, NULL, NULL, NULL, NULL, 4),
(53409, NULL, 'G3DSA:2.60.40.640:FF:000112', NULL, NULL, 'RE30730p', NULL, NULL, NULL, NULL, NULL, 4),
(53410, NULL, 'G3DSA:1.20.58.90:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53411, NULL, 'G3DSA:1.20.120.980:FF:000002', NULL, NULL, 'lysosomal Pro-X carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(53412, NULL, 'G3DSA:2.10.220.10:FF:000073', NULL, NULL, 'CXXC-rich, putative', NULL, NULL, NULL, NULL, NULL, 4),
(53413, NULL, 'G3DSA:3.50.50.60:FF:001190', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(53414, NULL, 'G3DSA:1.10.3590.10:FF:000002', NULL, NULL, 'acid-sensing ion channel 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(53415, NULL, 'G3DSA:1.25.40.10:FF:003726', NULL, NULL, 'Glr1376 protein', NULL, NULL, NULL, NULL, NULL, 4),
(53416, NULL, 'G3DSA:1.20.5.1190:FF:000008', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(53417, NULL, 'G3DSA:1.20.1050.20:FF:000001', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(53418, NULL, 'G3DSA:1.10.287.2170:FF:000003', NULL, NULL, 'Predicted site-specific integrase-resolvase', NULL, NULL, NULL, NULL, NULL, 4),
(53419, NULL, 'G3DSA:3.90.226.10:FF:000002', NULL, NULL, 'ATP-dependent Clp protease proteolytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(53420, NULL, 'G3DSA:3.30.200.20:FF:001640', NULL, NULL, 'Putative serine/threonine-protein kinase pknB', NULL, NULL, NULL, NULL, NULL, 4),
(53421, NULL, 'G3DSA:1.20.5.1180:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53422, NULL, 'G3DSA:3.90.70.10:FF:000016', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 36', NULL, NULL, NULL, NULL, NULL, 4),
(53423, NULL, 'G3DSA:3.30.160.60:FF:003929', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53424, NULL, 'G3DSA:1.10.510.10:FF:001684', NULL, NULL, 'Cyclin-G-associated kinase', NULL, NULL, NULL, NULL, NULL, 4),
(53425, NULL, 'G3DSA:3.30.930.10:FF:000287', NULL, NULL, 'eIF-2-alpha kinase GCN2', NULL, NULL, NULL, NULL, NULL, 4),
(53426, NULL, 'G3DSA:3.30.70.1180:FF:000020', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(53427, NULL, 'G3DSA:3.40.50.10190:FF:000257', NULL, NULL, 'PIS (Pax-2, IA-1/6, Smad-2 interacting protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(53428, NULL, 'G3DSA:3.40.50.11840:FF:000016', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(53429, NULL, 'G3DSA:3.40.950.10:FF:000016', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', NULL, NULL, NULL, NULL, NULL, 4),
(53430, NULL, 'G3DSA:3.30.920.90:FF:000001', NULL, NULL, '5-methylcytosine-specific restriction enzyme B (EcoKMcrBC)', NULL, NULL, NULL, NULL, NULL, 4),
(53431, NULL, 'G3DSA:1.25.10.10:FF:002117', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(53432, NULL, 'G3DSA:3.30.505.10:FF:000108', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(53433, NULL, 'G3DSA:1.10.540.10:FF:000084', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(53434, NULL, 'G3DSA:3.30.40.10:FF:001551', NULL, NULL, 'Si:dkey-111e8.1', NULL, NULL, NULL, NULL, NULL, 4),
(53435, NULL, 'G3DSA:1.10.555.10:FF:000045', NULL, NULL, 'RhoGAP domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(53436, NULL, 'G3DSA:1.20.1560.10:FF:000548', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(53437, NULL, 'G3DSA:3.40.50.300:FF:002227', NULL, NULL, 'DNA polymerase III subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(53438, NULL, 'G3DSA:3.40.50.2300:FF:000100', NULL, NULL, 'Taste receptor type 1 member 2', NULL, NULL, NULL, NULL, NULL, 4),
(53439, NULL, 'G3DSA:2.60.120.290:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53440, NULL, 'G3DSA:3.40.1370.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53441, NULL, 'G3DSA:1.20.120.730:FF:000023', NULL, NULL, 'Uncharacterized protein C4.03c', NULL, NULL, NULL, NULL, NULL, 4),
(53442, NULL, 'G3DSA:3.30.160.60:FF:000512', NULL, NULL, 'zinc finger protein 197 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(53443, NULL, 'G3DSA:2.70.150.10:FF:000233', NULL, NULL, 'Calcium-transporting ATPase 9 plasma membrane-type', NULL, NULL, NULL, NULL, NULL, 4),
(53444, NULL, 'G3DSA:1.20.1270.280:FF:000030', NULL, NULL, 'Dynein heavy chain 7', NULL, NULL, NULL, NULL, NULL, 4),
(53445, NULL, 'G3DSA:3.30.160.60:FF:005829', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53446, NULL, 'G3DSA:1.25.40.420:FF:000057', NULL, NULL, 'Goa-1', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(53447, NULL, 'G3DSA:2.10.50.10:FF:000072', NULL, NULL, 'TNF receptor superfamily member 8', NULL, NULL, NULL, NULL, NULL, 4),
(53448, NULL, 'G3DSA:3.30.1360.170:FF:000015', NULL, NULL, 'Flavin-dependent thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(53449, NULL, 'G3DSA:3.30.980.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53450, NULL, 'G3DSA:2.40.30.130:FF:000001', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(53451, NULL, 'G3DSA:3.30.70.330:FF:000005', NULL, NULL, 'ELAV-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(53452, NULL, 'G3DSA:1.10.510.10:FF:003819', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53453, NULL, 'G3DSA:1.20.1280.50:FF:000145', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(53454, NULL, 'G3DSA:1.20.1250.20:FF:001056', NULL, NULL, 'Major facilitator superfamily MFS_1', NULL, NULL, NULL, NULL, NULL, 4),
(53455, NULL, 'G3DSA:2.40.50.140:FF:000587', NULL, NULL, 'Replication protein A 32 kDa subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(53456, NULL, 'G3DSA:1.10.10.60:FF:000030', NULL, NULL, 'DNA-binding transcriptional regulator SoxS', NULL, NULL, NULL, NULL, NULL, 4),
(53457, NULL, 'G3DSA:2.60.40.60:FF:000162', NULL, NULL, 'Protocadherin-20', NULL, NULL, NULL, NULL, NULL, 4),
(53458, NULL, 'G3DSA:3.40.50.10330:FF:000125', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(53459, NULL, 'G3DSA:3.30.70.660:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53460, NULL, 'G3DSA:3.30.160.60:FF:001794', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53461, NULL, 'G3DSA:1.20.1050.40:FF:000007', NULL, NULL, 'YALI0F07667p', NULL, NULL, NULL, NULL, NULL, 4),
(53462, NULL, 'G3DSA:1.10.10.2750:FF:000001', NULL, NULL, 'TBC1 domain family member 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(53463, NULL, 'G3DSA:3.30.70.340:FF:000008', NULL, NULL, 'Putative carboxypeptidase suro-1', NULL, NULL, NULL, NULL, NULL, 4),
(53464, NULL, 'G3DSA:1.20.5.110:FF:000193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53465, NULL, 'G3DSA:3.40.50.300:FF:003655', NULL, NULL, 'Uncharacterized protein B13D15.290', NULL, NULL, NULL, NULL, NULL, 4),
(53466, NULL, 'G3DSA:2.60.40.10:FF:003817', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53467, NULL, 'G3DSA:1.10.1200.10:FF:000024', NULL, NULL, 'Nonribosomal peptide synthase Pes1', NULL, NULL, NULL, NULL, NULL, 4),
(53468, NULL, 'G3DSA:3.40.50.1390:FF:000001', NULL, NULL, 'DNA recombinase', NULL, NULL, NULL, NULL, NULL, 4),
(53469, NULL, 'G3DSA:4.10.400.10:FF:000118', NULL, NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein', NULL, NULL, NULL, NULL, NULL, 4),
(53470, NULL, 'G3DSA:3.40.50.300:FF:004453', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53471, NULL, 'G3DSA:1.20.1250.20:FF:002158', NULL, NULL, 'Potassium channel, putative', NULL, NULL, NULL, NULL, NULL, 4),
(53472, NULL, 'G3DSA:3.40.1110.10:FF:000407', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53473, NULL, 'G3DSA:3.30.60.30:FF:000131', NULL, NULL, 'Protein CBG17314', NULL, NULL, NULL, NULL, NULL, 4),
(53474, NULL, 'G3DSA:1.25.40.10:FF:003491', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(53475, NULL, 'G3DSA:2.40.170.20:FF:000025', NULL, NULL, 'Fe(III)-pyochelin outer membrane receptor', NULL, NULL, NULL, NULL, NULL, 4),
(53476, NULL, 'G3DSA:3.20.10.10:FF:000049', NULL, NULL, 'Branched chain amino acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(53477, NULL, 'G3DSA:2.130.10.10:FF:003604', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(53478, NULL, 'G3DSA:3.10.490.20:FF:000024', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(53479, NULL, 'G3DSA:1.25.40.20:FF:001886', NULL, NULL, 'Protein 21.1', NULL, NULL, NULL, NULL, NULL, 4),
(53480, NULL, 'G3DSA:1.20.120.1320:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(53481, NULL, 'G3DSA:3.40.50.10090:FF:000019', NULL, NULL, 'Uroporphyrinogen-III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(53482, NULL, 'G3DSA:3.10.450.240:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53483, NULL, 'G3DSA:3.40.50.300:FF:002553', NULL, NULL, 'Adenylyl-sulfate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(53484, NULL, 'G3DSA:3.40.50.300:FF:000092', NULL, NULL, 'DNA repair protein Rad51 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(53485, NULL, 'G3DSA:3.10.20.90:FF:000052', NULL, NULL, 'Ubiquitin-like protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(53486, NULL, 'G3DSA:3.30.420.40:FF:000100', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(53487, NULL, 'G3DSA:3.80.10.10:FF:004291', NULL, NULL, 'Protein CBR-PXN-2', NULL, NULL, NULL, NULL, NULL, 4),
(53488, NULL, 'G3DSA:2.40.50.140:FF:001104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53489, NULL, 'G3DSA:2.30.39.10:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53490, NULL, 'G3DSA:1.20.5.170:FF:000295', NULL, NULL, 'Activating transcription factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(53491, NULL, 'G3DSA:1.20.1420.10:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53492, NULL, 'G3DSA:3.40.50.2300:FF:000668', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(53493, NULL, 'G3DSA:2.170.16.10:FF:000007', NULL, NULL, 'Protein RecA', NULL, NULL, NULL, NULL, NULL, 4),
(53494, NULL, 'G3DSA:3.40.50.1820:FF:000597', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53495, NULL, 'G3DSA:1.10.167.10:FF:000042', NULL, NULL, 'G protein-coupled receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(53496, NULL, 'G3DSA:1.10.8.10:FF:000065', NULL, NULL, 'E3 ubiquitin-protein ligase XIAP isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(53497, NULL, 'G3DSA:3.20.20.140:FF:000418', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53498, NULL, 'G3DSA:1.10.1060.10:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53499, NULL, 'G3DSA:2.130.10.10:FF:005066', NULL, NULL, 'UBP9-binding protein bun107', NULL, NULL, NULL, NULL, NULL, 4),
(53500, NULL, 'G3DSA:1.25.40.10:FF:001883', NULL, NULL, 'DnaJ_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(53501, NULL, 'G3DSA:3.40.630.30:FF:000318', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53502, NULL, 'G3DSA:1.20.58.60:FF:000847', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53503, NULL, 'G3DSA:3.40.605.10:FF:000119', NULL, NULL, 'Putative aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(53504, NULL, 'G3DSA:3.40.630.30:FF:000083', NULL, NULL, 'Acyl-CoA N-acyltransferases (NAT) superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(53505, NULL, 'G3DSA:3.30.530.20:FF:000113', NULL, NULL, 'Phosphatidylinositol transfer protein cytoplasmic 1', NULL, NULL, NULL, NULL, NULL, 4),
(53506, NULL, 'G3DSA:3.30.200.20:FF:001538', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(53507, NULL, 'G3DSA:3.40.50.620:FF:000862', NULL, NULL, 'Tyrosyl-tRNA synthetase 2', NULL, NULL, NULL, NULL, NULL, 4),
(53508, NULL, 'G3DSA:3.40.50.720:FF:002589', NULL, NULL, 'L-lactate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(53509, NULL, 'G3DSA:1.10.533.10:FF:000281', NULL, NULL, 'Putative inhibitor of apoptosis', NULL, NULL, NULL, NULL, NULL, 4),
(53510, NULL, 'G3DSA:1.25.40.70:FF:000041', NULL, NULL, 'Phosphatidylinositol 3-kinase class, putative', NULL, NULL, NULL, NULL, NULL, 4),
(53511, NULL, 'G3DSA:1.20.1560.10:FF:000874', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(53512, NULL, 'G3DSA:3.30.40.10:FF:002299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53513, NULL, 'G3DSA:1.25.40.10:FF:005290', NULL, NULL, 'HL04910p', NULL, NULL, NULL, NULL, NULL, 4),
(53514, NULL, 'G3DSA:1.20.58.390:FF:000130', NULL, NULL, 'Si:ch211-256e16.7', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(53515, NULL, 'G3DSA:3.40.1160.10:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53516, NULL, 'G3DSA:3.90.245.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53517, NULL, 'G3DSA:2.130.10.10:FF:005919', NULL, NULL, 'Bromodomain and WD repeat-containing DDB_G0285837', NULL, NULL, NULL, NULL, NULL, 4),
(53518, NULL, 'G3DSA:2.130.10.10:FF:003458', NULL, NULL, 'Alkaline phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(53519, NULL, 'G3DSA:3.40.720.10:FF:000196', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(53520, NULL, 'G3DSA:2.30.30.40:FF:000112', NULL, NULL, 'SH3 domain-containing kinase-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(53521, NULL, 'G3DSA:1.20.1070.10:FF:000819', NULL, NULL, 'Frizzled', NULL, NULL, NULL, NULL, NULL, 4),
(53522, NULL, 'G3DSA:1.20.1180.10:FF:000002', NULL, NULL, 'Probable acyl-[acyl-carrier-protein]--UDP-N-acetylglucosamine O-acyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(53523, NULL, 'G3DSA:3.90.190.10:FF:000475', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53524, NULL, 'G3DSA:3.40.50.1260:FF:000058', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(53525, NULL, 'G3DSA:3.40.50.2300:FF:000977', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53526, NULL, 'G3DSA:3.90.245.10:FF:000024', NULL, NULL, 'Purine nucleosidase, putative (IunH-1)', NULL, NULL, NULL, NULL, NULL, 4),
(53527, NULL, 'G3DSA:3.30.160.60:FF:003385', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53528, NULL, 'G3DSA:3.40.50.720:FF:001307', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(53529, NULL, 'G3DSA:1.25.40.20:FF:001577', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53530, NULL, 'G3DSA:6.10.140.2220:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53531, NULL, 'G3DSA:2.10.10.10:FF:000007', NULL, NULL, 'hepatocyte growth factor activator', NULL, NULL, NULL, NULL, NULL, 4),
(53532, NULL, 'G3DSA:3.80.10.10:FF:004498', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(53533, NULL, 'G3DSA:3.30.2410.10:FF:000051', NULL, NULL, 'Probable E3 ubiquitin protein ligase C167.07c', NULL, NULL, NULL, NULL, NULL, 4),
(53534, NULL, 'G3DSA:3.40.120.10:FF:000004', NULL, NULL, 'Phosphoglucomutase 5', NULL, NULL, NULL, NULL, NULL, 4),
(53535, NULL, 'G3DSA:3.30.200.20:FF:001314', NULL, NULL, 'Serine/threonine-protein kinase STE11', NULL, NULL, NULL, NULL, NULL, 4),
(53536, NULL, 'G3DSA:1.10.510.10:FF:002510', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53537, NULL, 'G3DSA:3.30.70.330:FF:001551', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53538, NULL, 'G3DSA:3.40.50.1240:FF:000052', NULL, NULL, '6-phosphofructo-2-kinase/fructose-2,6-biphosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(53539, NULL, 'G3DSA:3.40.20.10:FF:000167', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(53540, NULL, 'G3DSA:3.40.30.10:FF:000095', NULL, NULL, 'Glutaredoxin 2', NULL, NULL, NULL, NULL, NULL, 4),
(53541, NULL, 'G3DSA:3.40.50.300:FF:000075', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(53542, NULL, 'G3DSA:2.70.130.10:FF:000024', NULL, NULL, 'Putative vacuolar sorting receptor', NULL, NULL, NULL, NULL, NULL, 4),
(53543, NULL, 'G3DSA:2.30.39.10:FF:000117', NULL, NULL, 'Serpin A3-8', NULL, NULL, NULL, NULL, NULL, 4),
(53544, NULL, 'G3DSA:2.130.10.10:FF:003149', NULL, NULL, 'Intraflagellar transport protein 122', NULL, NULL, NULL, NULL, NULL, 4),
(53545, NULL, 'G3DSA:3.80.10.10:FF:002598', NULL, NULL, 'F-box/LRR-repeat protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(53546, NULL, 'G3DSA:1.50.40.10:FF:000521', NULL, NULL, 'Mitochondrial carrier protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(53547, NULL, 'G3DSA:2.130.10.10:FF:005049', NULL, NULL, 'WD-40 repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(53548, NULL, 'G3DSA:3.60.10.10:FF:000076', NULL, NULL, 'Type I inositol polyphosphate 5-phosphatase 8', NULL, NULL, NULL, NULL, NULL, 4),
(53549, NULL, 'G3DSA:1.20.1730.10:FF:000039', NULL, NULL, 'Na+/glucose cotransporter', NULL, NULL, NULL, NULL, NULL, 4),
(53550, NULL, 'G3DSA:1.20.1250.40:FF:000005', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC9 isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(53551, NULL, 'G3DSA:3.90.190.10:FF:000166', NULL, NULL, 'Leucine rich repeat and phosphatase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(53552, NULL, 'G3DSA:3.50.50.60:FF:001088', NULL, NULL, 'Os03g0193400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(53553, NULL, 'G3DSA:1.20.58.80:FF:000050', NULL, NULL, 'Bride of doubletime', NULL, NULL, NULL, NULL, NULL, 4),
(53554, NULL, 'G3DSA:2.30.29.30:FF:000982', NULL, NULL, 'AER092Wp', NULL, NULL, NULL, NULL, NULL, 4),
(53555, NULL, 'G3DSA:3.90.70.10:FF:000342', NULL, NULL, 'Ananain, putative, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(53556, NULL, 'G3DSA:3.90.1750.10:FF:000051', NULL, NULL, 'Ubiquitin protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(53557, NULL, 'G3DSA:4.10.410.10:FF:000063', NULL, NULL, 'Putative salivary kunitz domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(53558, NULL, 'G3DSA:1.25.40.10:FF:001574', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(53559, NULL, 'G3DSA:1.10.510.10:FF:001358', NULL, NULL, 'Serine-threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(53560, NULL, 'G3DSA:1.10.437.10:FF:000052', NULL, NULL, 'MCL1 apoptosis regulator, BCL2 family member b', NULL, NULL, NULL, NULL, NULL, 4),
(53561, NULL, 'G3DSA:3.90.1450.10:FF:000005', NULL, NULL, 'Guanylate cyclase activator 2A', NULL, NULL, NULL, NULL, NULL, 4),
(53562, NULL, 'G3DSA:2.130.10.10:FF:002502', NULL, NULL, 'Histidine kinase/response regulator hybrid protein', NULL, NULL, NULL, NULL, NULL, 4),
(53563, NULL, 'G3DSA:3.40.50.280:FF:000012', NULL, NULL, 'Methylmalonyl-CoA mutase', NULL, NULL, NULL, NULL, NULL, 4),
(53564, NULL, 'G3DSA:2.130.10.10:FF:005358', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53565, NULL, 'G3DSA:1.20.1260.100:FF:000002', NULL, NULL, 'TspO and MBR related proteins', NULL, NULL, NULL, NULL, NULL, 4),
(53566, NULL, 'G3DSA:3.30.160.60:FF:002283', NULL, NULL, 'Zinc finger protein 646', NULL, NULL, NULL, NULL, NULL, 4),
(53567, NULL, 'G3DSA:2.60.120.10:FF:000352', NULL, NULL, 'Cyclic nucleotide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(53568, NULL, 'G3DSA:3.10.490.10:FF:000021', NULL, NULL, 'Gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(53569, NULL, 'G3DSA:2.130.10.10:FF:000041', NULL, NULL, 'Splicing factor 3b subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(53570, NULL, 'G3DSA:1.20.1250.20:FF:001410', NULL, NULL, 'MFS transporter, putative (AFU_orthologue AFUA_3G07120)', NULL, NULL, NULL, NULL, NULL, 4),
(53571, NULL, 'G3DSA:3.20.20.10:FF:000022', NULL, NULL, 'S-adenosylmethionine decarboxylase-ornithine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(53572, NULL, 'G3DSA:1.10.510.10:FF:001667', NULL, NULL, 'Serine/threonine-protein kinase/endoribonuclease IRE1', NULL, NULL, NULL, NULL, NULL, 4),
(53573, NULL, 'G3DSA:1.10.510.10:FF:002201', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(53574, NULL, 'G3DSA:1.10.520.10:FF:000004', NULL, NULL, 'Catalase-peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(53575, NULL, 'G3DSA:2.80.10.50:FF:000134', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase 17', NULL, NULL, NULL, NULL, NULL, 4),
(53576, NULL, 'G3DSA:1.10.10.10:FF:001920', NULL, NULL, 'Forkhead domain protein Q2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(53577, NULL, 'G3DSA:3.30.160.60:FF:006026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53578, NULL, 'G3DSA:3.20.20.70:FF:000416', NULL, NULL, '4-hydroxy-2-oxoglutarate aldolase/2-dehydro-3-deoxyphosphogluconate aldolase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(53579, NULL, 'G3DSA:3.40.30.10:FF:000656', NULL, NULL, 'Oligosaccharyltransferase complex subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(53580, NULL, 'G3DSA:2.130.10.10:FF:003784', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53581, NULL, 'G3DSA:2.60.120.920:FF:000014', NULL, NULL, 'neuralized-like protein 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(53582, NULL, 'G3DSA:3.30.200.70:FF:000002', NULL, NULL, 'Stress response kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(53583, NULL, 'G3DSA:1.20.1250.20:FF:000876', NULL, NULL, 'Protein CBG07685', NULL, NULL, NULL, NULL, NULL, 4),
(53584, NULL, 'G3DSA:3.40.190.290:FF:000101', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(53585, NULL, 'G3DSA:3.40.630.30:FF:000644', NULL, NULL, 'AGAP009686-PA', NULL, NULL, NULL, NULL, NULL, 4),
(53586, NULL, 'G3DSA:1.25.40.10:FF:003165', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(53587, NULL, 'G3DSA:3.30.160.270:FF:000013', NULL, NULL, 'ADL015Cp', NULL, NULL, NULL, NULL, NULL, 4),
(53588, NULL, 'G3DSA:1.10.8.270:FF:000012', NULL, NULL, 'TBC domain-containing protein kinase-like protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(53589, NULL, 'G3DSA:3.10.50.40:FF:000033', NULL, NULL, 'Foldase protein PrsA', NULL, NULL, NULL, NULL, NULL, 4),
(53590, NULL, 'G3DSA:3.90.226.10:FF:000311', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(53591, NULL, 'G3DSA:3.40.50.720:FF:001280', NULL, NULL, 'Molybdopterin biosynthesis protein MoeY', NULL, NULL, NULL, NULL, NULL, 4),
(53592, NULL, 'G3DSA:3.40.50.720:FF:000791', NULL, NULL, 'Polyketide synthetase mbtD', NULL, NULL, NULL, NULL, NULL, 4),
(53593, NULL, 'G3DSA:2.60.40.10:FF:000254', NULL, NULL, 'Antigen-presenting glycoprotein CD1d1', NULL, NULL, NULL, NULL, NULL, 4),
(53594, NULL, 'G3DSA:3.40.50.1440:FF:000005', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(53595, NULL, 'G3DSA:3.40.50.12500:FF:000006', NULL, NULL, 'Peptide/nickel transport system ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(53596, NULL, 'G3DSA:3.30.980.10:FF:000026', NULL, NULL, 'Threonyl/alanyl tRNA synthetase SAD', NULL, NULL, NULL, NULL, NULL, 4),
(53597, NULL, 'G3DSA:1.20.1440.100:FF:000004', NULL, NULL, 'Glycerol-3-phosphate 2-O-acyltransferase 6-like', NULL, NULL, NULL, NULL, NULL, 4),
(53598, NULL, 'G3DSA:2.60.120.310:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(53599, NULL, 'G3DSA:1.25.40.420:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53600, NULL, 'G3DSA:1.20.1110.10:FF:000054', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(53601, NULL, 'G3DSA:3.30.70.2850:FF:000009', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(53602, NULL, 'G3DSA:3.40.50.1820:FF:000951', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(53603, NULL, 'G3DSA:2.40.50.150:FF:000022', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(53604, NULL, 'G3DSA:3.40.50.1010:FF:000258', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53605, NULL, 'G3DSA:2.70.150.10:FF:000216', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(53606, NULL, 'G3DSA:1.10.510.10:FF:000256', NULL, NULL, 'Serine/threonine-protein kinase TOUSLED', NULL, NULL, NULL, NULL, NULL, 4),
(53607, NULL, 'G3DSA:2.30.42.10:FF:000479', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53608, NULL, 'G3DSA:3.30.160.60:FF:005846', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53609, NULL, 'G3DSA:2.120.10.80:FF:000303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53610, NULL, 'G3DSA:2.40.20.10:FF:000001', NULL, NULL, 'Urokinase-type plasminogen activator', NULL, NULL, NULL, NULL, NULL, 4),
(53611, NULL, 'G3DSA:3.40.50.1450:FF:000008', NULL, NULL, 'Periplasmically oriented, membrane-bound [NiFe]-hydrogenase maturation protease', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(53612, NULL, 'G3DSA:3.40.50.300:FF:004127', NULL, NULL, 'ATP-dependent nuclease subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(53613, NULL, 'G3DSA:1.10.510.10:FF:004101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53614, NULL, 'G3DSA:3.30.160.60:FF:003694', NULL, NULL, 'Draculin-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(53615, NULL, 'G3DSA:2.60.120.330:FF:000017', NULL, NULL, '2-oxoglutarate-dependent dioxygenase DAO', NULL, NULL, NULL, NULL, NULL, 4),
(53616, NULL, 'G3DSA:3.40.50.1820:FF:001131', NULL, NULL, '2310038E17Rik protein', NULL, NULL, NULL, NULL, NULL, 4),
(53617, NULL, 'G3DSA:3.30.1610.10:FF:000015', NULL, NULL, 'YALI0D17886p', NULL, NULL, NULL, NULL, NULL, 4),
(53618, NULL, 'G3DSA:1.10.1040.50:FF:000006', NULL, NULL, 'Peroxisomal bifunctional enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(53619, NULL, 'G3DSA:1.20.120.1080:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53620, NULL, 'G3DSA:3.40.50.740:FF:000004', NULL, NULL, 'Formate dehydrogenase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(53621, NULL, 'G3DSA:3.30.230.70:FF:000122', NULL, NULL, 'RE29317p', NULL, NULL, NULL, NULL, NULL, 4),
(53622, NULL, 'G3DSA:2.130.10.10:FF:000602', NULL, NULL, 'Periodic tryptophan protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(53623, NULL, 'G3DSA:3.30.450.40:FF:000135', NULL, NULL, 'Bacteriophytochrome', NULL, NULL, NULL, NULL, NULL, 4),
(53624, NULL, 'G3DSA:2.10.220.10:FF:000191', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5a', NULL, NULL, NULL, NULL, NULL, 4),
(53625, NULL, 'G3DSA:1.20.1250.20:FF:001365', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53626, NULL, 'G3DSA:3.30.70.80:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53627, NULL, 'G3DSA:3.60.21.10:FF:000090', NULL, NULL, 'Sphingomyelin phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(53628, NULL, 'G3DSA:1.20.1280.50:FF:000263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53629, NULL, 'G3DSA:3.40.140.70:FF:000006', NULL, NULL, 'ThiF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(53630, NULL, 'G3DSA:3.40.50.300:FF:006044', NULL, NULL, 'Senataxin', NULL, NULL, NULL, NULL, NULL, 4),
(53631, NULL, 'G3DSA:1.25.10.10:FF:000111', NULL, NULL, 'Protein zer-1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(53632, NULL, 'G3DSA:3.40.50.10860:FF:000020', NULL, NULL, 'Probable bifunctional methylenetetrahydrofolate dehydrogenase/cyclohydrolase 2', NULL, NULL, NULL, NULL, NULL, 4),
(53633, NULL, 'G3DSA:3.40.50.150:FF:001867', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53634, NULL, 'G3DSA:3.30.60.30:FF:000114', NULL, NULL, 'GG13119', NULL, NULL, NULL, NULL, NULL, 4),
(53635, NULL, 'G3DSA:3.60.10.10:FF:000284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53636, NULL, 'G3DSA:2.30.30.100:FF:000096', NULL, NULL, 'Small nuclear ribonucleoprotein G', NULL, NULL, NULL, NULL, NULL, 4),
(53637, NULL, 'G3DSA:3.40.1110.10:FF:000380', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53638, NULL, 'G3DSA:2.160.20.70:FF:000018', NULL, NULL, 'Tubulin folding cofactor C', NULL, NULL, NULL, NULL, NULL, 4),
(53639, NULL, 'G3DSA:1.10.287.110:FF:000165', NULL, NULL, 'Fe-S protein assembly co-chaperone HscB', NULL, NULL, NULL, NULL, NULL, 4),
(53640, NULL, 'G3DSA:2.30.30.90:FF:000003', NULL, NULL, 'Iron-dependent repressor IdeR', NULL, NULL, NULL, NULL, NULL, 4),
(53641, NULL, 'G3DSA:2.10.90.10:FF:000063', NULL, NULL, 'Glycoprotein hormone beta 5', NULL, NULL, NULL, NULL, NULL, 4),
(53642, NULL, 'G3DSA:3.50.50.60:FF:001072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53643, NULL, 'G3DSA:1.25.10.10:FF:003337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53644, NULL, 'G3DSA:3.40.50.1820:FF:001086', NULL, NULL, '1H-3-hydroxy-4-oxoquinaldine 2,4-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(53645, NULL, 'G3DSA:3.90.70.10:FF:000134', NULL, NULL, 'Ubiquitin-specific protease', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(53646, NULL, 'G3DSA:2.60.40.10:FF:001889', NULL, NULL, 'fasciclin-2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(53647, NULL, 'G3DSA:1.10.510.10:FF:000273', NULL, NULL, 'Cyclin-dependent kinase C-2', NULL, NULL, NULL, NULL, NULL, 4),
(53648, NULL, 'G3DSA:3.10.20.90:FF:000613', NULL, NULL, 'AGAP010770-PA', NULL, NULL, NULL, NULL, NULL, 4),
(53649, NULL, 'G3DSA:3.40.50.300:FF:000120', NULL, NULL, 'ATP-dependent chaperone ClpB', NULL, NULL, NULL, NULL, NULL, 4),
(53650, NULL, 'G3DSA:4.10.410.10:FF:000029', NULL, NULL, 'CRE-MEC-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(53651, NULL, 'G3DSA:1.10.10.10:FF:001465', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(53652, NULL, 'G3DSA:1.20.1250.20:FF:000921', NULL, NULL, 'Putative efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(53653, NULL, 'G3DSA:2.60.120.970:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53654, NULL, 'G3DSA:1.20.1270.60:FF:000338', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53655, NULL, 'G3DSA:2.40.50.140:FF:001076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53656, NULL, 'G3DSA:3.40.50.620:FF:000098', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(53657, NULL, 'G3DSA:3.40.50.10130:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53658, NULL, 'G3DSA:1.10.8.60:FF:000282', NULL, NULL, 'Sigma-54-dependent Fis family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(53659, NULL, 'G3DSA:1.20.1270.60:FF:000294', NULL, NULL, 'Asap2a protein', NULL, NULL, NULL, NULL, NULL, 4),
(53660, NULL, 'G3DSA:1.20.140.40:FF:000043', NULL, NULL, '21 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(53661, NULL, 'G3DSA:4.10.1000.40:FF:000004', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(53662, NULL, 'G3DSA:2.60.40.4330:FF:000003', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(53663, NULL, 'G3DSA:2.60.40.10:FF:002406', NULL, NULL, 'Wrapper/Rega-1/Klingon homolog', NULL, NULL, NULL, NULL, NULL, 4),
(53664, NULL, 'G3DSA:3.20.20.70:FF:000197', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(53665, NULL, 'G3DSA:2.10.60.10:FF:000027', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(53666, NULL, 'G3DSA:3.30.200.20:FF:000420', NULL, NULL, 'Putative receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(53667, NULL, 'G3DSA:1.20.970.10:FF:000007', NULL, NULL, 'Anthranilate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(53668, NULL, 'G3DSA:3.90.190.20:FF:000011', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(53669, NULL, 'G3DSA:4.10.1000.30:FF:000001', NULL, NULL, 'Zinc finger CCCH domain-containing protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(53670, NULL, 'G3DSA:2.40.30.10:FF:000254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53671, NULL, 'G3DSA:3.10.20.540:FF:000001', NULL, NULL, 'Replicase polyprotein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(53672, NULL, 'G3DSA:1.10.238.10:FF:001197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53673, NULL, 'G3DSA:3.80.10.10:FF:002609', NULL, NULL, 'Nuclear export factor-a isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(53674, NULL, 'G3DSA:1.10.510.10:FF:003499', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53675, NULL, 'G3DSA:3.30.60.90:FF:000025', NULL, NULL, 'Unplaced genomic scaffold supercont1.18, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(53676, NULL, 'G3DSA:1.10.10.10:FF:000037', NULL, NULL, 'Heat stress transcription factor B-4', NULL, NULL, NULL, NULL, NULL, 4),
(53677, NULL, 'G3DSA:3.50.50.60:FF:001173', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(53678, NULL, 'G3DSA:2.10.90.10:FF:000107', NULL, NULL, 'Protein CBR-DAF-7', NULL, NULL, NULL, NULL, NULL, 4),
(53679, NULL, 'G3DSA:2.60.40.1730:FF:000088', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(53680, NULL, 'G3DSA:3.40.630.10:FF:000003', NULL, NULL, 'Probable aspartyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(53681, NULL, 'G3DSA:3.30.870.10:FF:000023', NULL, NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(53682, NULL, 'G3DSA:2.60.40.340:FF:000011', NULL, NULL, 'Nuclear factor of activated T cells 3', NULL, NULL, NULL, NULL, NULL, 4),
(53683, NULL, 'G3DSA:2.60.40.10:FF:003935', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53684, NULL, 'G3DSA:1.20.120.680:FF:000002', NULL, NULL, 'Formimidoyltransferase-cyclodeaminase', NULL, NULL, NULL, NULL, NULL, 4),
(53685, NULL, 'G3DSA:2.30.30.140:FF:000158', NULL, NULL, 'maternal protein tudor', NULL, NULL, NULL, NULL, NULL, 4),
(53686, NULL, 'G3DSA:2.10.25.10:FF:000575', NULL, NULL, 'Crumbs, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(53687, NULL, 'G3DSA:3.40.30.10:FF:000448', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(53688, NULL, 'G3DSA:3.30.160.60:FF:004082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53689, NULL, 'G3DSA:3.40.50.300:FF:007680', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53690, NULL, 'G3DSA:3.40.630.20:FF:000006', NULL, NULL, 'Peptidase C15, pyroglutamyl peptidase I-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(53691, NULL, 'G3DSA:3.30.160.60:FF:003368', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53692, NULL, 'G3DSA:3.30.200.20:FF:000797', NULL, NULL, 'PTI1-like tyrosine-protein kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(53693, NULL, 'G3DSA:3.90.228.10:FF:000029', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(53694, NULL, 'G3DSA:1.20.1270.280:FF:000029', NULL, NULL, 'Dynein heavy chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(53695, NULL, 'G3DSA:1.25.10.10:FF:000010', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 56 kDa regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(53696, NULL, 'G3DSA:1.50.40.10:FF:000419', NULL, NULL, 'Mitochondrial substrate carrier family protein I', NULL, NULL, NULL, NULL, NULL, 4),
(53697, NULL, 'G3DSA:2.40.50.100:FF:000131', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(53698, NULL, 'G3DSA:2.10.50.10:FF:000088', NULL, NULL, 'Si:ch211-261n11.7', NULL, NULL, NULL, NULL, NULL, 4),
(53699, NULL, 'G3DSA:1.25.40.10:FF:003373', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At3g16890, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(53700, NULL, 'G3DSA:3.40.50.800:FF:000028', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(53701, NULL, 'G3DSA:2.60.120.10:FF:000234', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(53702, NULL, 'G3DSA:2.10.220.10:FF:000202', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(53703, NULL, 'G3DSA:3.40.630.30:FF:000009', NULL, NULL, 'Amino-acid acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(53704, NULL, 'G3DSA:1.10.8.870:FF:000012', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(53705, NULL, 'G3DSA:3.40.430.10:FF:000005', NULL, NULL, 'Riboflavin biosynthesis protein ribD', NULL, NULL, NULL, NULL, NULL, 4),
(53706, NULL, 'G3DSA:3.40.50.300:FF:003981', NULL, NULL, 'Phosphatidylcholine translocator ABCB4', NULL, NULL, NULL, NULL, NULL, 4),
(53707, NULL, 'G3DSA:3.20.20.380:FF:000007', NULL, NULL, 'Copper homeostasis protein CutC', NULL, NULL, NULL, NULL, NULL, 4),
(53708, NULL, 'G3DSA:3.40.190.80:FF:000046', NULL, NULL, 'Ammonium transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(53709, NULL, 'G3DSA:3.20.20.190:FF:000074', NULL, NULL, 'Phosphatidylinositol-specific phospholipase c, putative', NULL, NULL, NULL, NULL, NULL, 4),
(53710, NULL, 'G3DSA:3.10.290.10:FF:000023', NULL, NULL, '40S ribosomal protein S9', NULL, NULL, NULL, NULL, NULL, 4),
(53711, NULL, 'G3DSA:2.60.220.50:FF:000186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53712, NULL, 'G3DSA:1.20.990.10:FF:000008', NULL, NULL, 'NADPH-dependent diflavin oxidoreductase 1', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(53713, NULL, 'G3DSA:2.70.98.20:FF:000018', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(53714, NULL, 'G3DSA:3.10.20.90:FF:000714', NULL, NULL, 'Nuclear protein localization protein 4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(53715, NULL, 'G3DSA:3.40.50.300:FF:002244', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(53716, NULL, 'G3DSA:3.40.50.10190:FF:000049', NULL, NULL, 'RNA Polymerase II CTD phosphatase Fcp1', NULL, NULL, NULL, NULL, NULL, 4),
(53717, NULL, 'G3DSA:2.60.40.10:FF:002507', NULL, NULL, 'Fc receptor like 4', NULL, NULL, NULL, NULL, NULL, 4),
(53718, NULL, 'G3DSA:1.10.20.10:FF:000066', NULL, NULL, 'H2B histone family member W testis-specific', NULL, NULL, NULL, NULL, NULL, 4),
(53719, NULL, 'G3DSA:3.40.50.300:FF:000636', NULL, NULL, 'ATP-binding cassette sub-family D member 3', NULL, NULL, NULL, NULL, NULL, 4),
(53720, NULL, 'G3DSA:3.30.300.350:FF:000003', NULL, NULL, 'Probable GTP-binding protein OBGC1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(53721, NULL, 'G3DSA:2.130.10.10:FF:003913', NULL, NULL, 'Semaphorin 4d', NULL, NULL, NULL, NULL, NULL, 4),
(53722, NULL, 'G3DSA:1.20.1250.20:FF:001039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53723, NULL, 'G3DSA:3.60.21.10:FF:000202', NULL, NULL, 'Acid sphingomyelinase-like phosphodiesterase 3b', NULL, NULL, NULL, NULL, NULL, 4),
(53724, NULL, 'G3DSA:2.60.120.290:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53725, NULL, 'G3DSA:3.30.70.1180:FF:000019', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(53726, NULL, 'G3DSA:3.30.70.340:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53727, NULL, 'G3DSA:3.60.10.10:FF:000385', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53728, NULL, 'G3DSA:1.25.40.20:FF:000251', NULL, NULL, 'Protein LHCP TRANSLOCATION DEFECT', NULL, NULL, NULL, NULL, NULL, 4),
(53729, NULL, 'G3DSA:2.60.120.200:FF:000787', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53730, NULL, 'G3DSA:3.30.830.10:FF:000223', NULL, NULL, 'Putative mitochondrial-processing peptidase subunit beta mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(53731, NULL, 'G3DSA:2.10.25.10:FF:000148', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(53732, NULL, 'G3DSA:3.80.10.10:FF:003172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53733, NULL, 'G3DSA:1.20.58.60:FF:000538', NULL, NULL, 'Nesprin-2', NULL, NULL, NULL, NULL, NULL, 4),
(53734, NULL, 'G3DSA:1.10.8.960:FF:000005', NULL, NULL, 'Putative gamma-glutamylcysteine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(53735, NULL, 'G3DSA:3.40.710.10:FF:000061', NULL, NULL, 'Penicillin-binding protein A', NULL, NULL, NULL, NULL, NULL, 4),
(53736, NULL, 'G3DSA:3.30.60.20:FF:000111', NULL, NULL, 'CBN-KSR-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(53737, NULL, 'G3DSA:2.40.110.10:FF:000030', NULL, NULL, 'Acyl-CoA dehydrogenase FadE4', NULL, NULL, NULL, NULL, NULL, 4),
(53738, NULL, 'G3DSA:2.170.11.10:FF:000002', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(53739, NULL, 'G3DSA:1.25.40.20:FF:000621', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53740, NULL, 'G3DSA:3.30.420.10:FF:000349', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(53741, NULL, 'G3DSA:3.40.50.800:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53742, NULL, 'G3DSA:2.60.40.10:FF:003834', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53743, NULL, 'G3DSA:3.30.9.10:FF:000203', NULL, NULL, 'D-aspartate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(53744, NULL, 'G3DSA:1.10.8.720:FF:000063', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(53745, NULL, 'G3DSA:2.160.20.110:FF:000004', NULL, NULL, 'CXC-rich protein', NULL, NULL, NULL, NULL, NULL, 4),
(53746, NULL, 'G3DSA:2.40.50.140:FF:000795', NULL, NULL, 'Eukaryotic translation initiation factor 2 subunit 1', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(53747, NULL, 'G3DSA:2.40.50.100:FF:000232', NULL, NULL, 'Fe(3+) ions import ATP-binding protein FbpC 1', NULL, NULL, NULL, NULL, NULL, 4),
(53748, NULL, 'G3DSA:1.10.510.10:FF:000610', NULL, NULL, 'Calcium and calcium/calmodulin-dependent serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(53749, NULL, 'G3DSA:2.20.70.10:FF:000010', NULL, NULL, 'Transcription elongation regulator 1 (CA150)', NULL, NULL, NULL, NULL, NULL, 4),
(53750, NULL, 'G3DSA:2.130.10.10:FF:004301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53751, NULL, 'G3DSA:3.30.1150.10:FF:000013', NULL, NULL, 'Protein TonB', NULL, NULL, NULL, NULL, NULL, 4),
(53752, NULL, 'G3DSA:3.30.1110.10:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53753, NULL, 'G3DSA:3.40.640.10:FF:000240', NULL, NULL, 'Molybdenum cofactor sulfurase', NULL, NULL, NULL, NULL, NULL, 4),
(53754, NULL, 'G3DSA:1.25.40.1040:FF:000009', NULL, NULL, 'N-acetyltransferase subunit Nat1', NULL, NULL, NULL, NULL, NULL, 4),
(53755, NULL, 'G3DSA:2.40.10.10:FF:000045', NULL, NULL, 'Replicase polyprotein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(53756, NULL, 'G3DSA:1.10.3500.10:FF:000036', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(53757, NULL, 'G3DSA:3.40.630.10:FF:000312', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(53758, NULL, 'G3DSA:2.40.155.10:FF:000009', NULL, NULL, 'Hemicentin 2', NULL, NULL, NULL, NULL, NULL, 4),
(53759, NULL, 'G3DSA:3.40.190.10:FF:000879', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(53760, NULL, 'G3DSA:1.25.40.1030:FF:000006', NULL, NULL, 'SEC31 homolog B, COPII coat complex component', NULL, NULL, NULL, NULL, NULL, 4),
(53761, NULL, 'G3DSA:3.90.850.10:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53762, NULL, 'G3DSA:3.40.50.150:FF:000024', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(53763, NULL, 'G3DSA:2.60.40.10:FF:001474', NULL, NULL, 'Protein tyrosine phosphatase, receptor type Q', NULL, NULL, NULL, NULL, NULL, 4),
(53764, NULL, 'G3DSA:3.40.50.2000:FF:000994', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53765, NULL, 'G3DSA:3.30.70.260:FF:000092', NULL, NULL, 'Homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(53766, NULL, 'G3DSA:3.20.20.140:FF:000435', NULL, NULL, 'Carbamoyl-phosphate synthetase 2, aspartate transcarbamylase, and dihydroorotase', NULL, NULL, NULL, NULL, NULL, 4),
(53767, NULL, 'G3DSA:3.40.50.300:FF:000900', NULL, NULL, 'Eukaryotic elongation factor, selenocysteine-tRNA-specific', NULL, NULL, NULL, NULL, NULL, 4),
(53768, NULL, 'G3DSA:3.40.50.1000:FF:000031', NULL, NULL, 'Probable copper-transporting ATPase HMA5', NULL, NULL, NULL, NULL, NULL, 4),
(53769, NULL, 'G3DSA:3.30.200.20:FF:000212', NULL, NULL, 'Proline-rich receptor-like protein kinase PERK8', NULL, NULL, NULL, NULL, NULL, 4),
(53770, NULL, 'G3DSA:1.25.40.490:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53771, NULL, 'G3DSA:2.170.190.11:FF:000011', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(53772, NULL, 'G3DSA:2.40.40.20:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53773, NULL, 'G3DSA:2.40.100.10:FF:000102', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(53774, NULL, 'G3DSA:3.40.50.2300:FF:001056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53775, NULL, 'G3DSA:3.30.420.40:FF:000307', NULL, NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(53776, NULL, 'G3DSA:1.20.58.1590:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53777, NULL, 'G3DSA:2.10.25.10:FF:000912', NULL, NULL, 'low-density lipoprotein receptor-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(53778, NULL, 'G3DSA:3.30.980.10:FF:000009', NULL, NULL, 'Uridine kinase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(53779, NULL, 'G3DSA:3.40.50.450:FF:000024', NULL, NULL, 'Probable cytokinin riboside 5''-monophosphate phosphoribohydrolase LOG4', NULL, NULL, NULL, NULL, NULL, 4),
(53780, NULL, 'G3DSA:3.30.200.20:FF:001185', NULL, NULL, 'Spore coat protein, CotS family', NULL, NULL, NULL, NULL, NULL, 4),
(53781, NULL, 'G3DSA:3.40.50.300:FF:007887', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53782, NULL, 'G3DSA:3.40.50.460:FF:000027', NULL, NULL, '6-phosphofructokinase, pyrophosphate-dependent', NULL, NULL, NULL, NULL, NULL, 4),
(53783, NULL, 'G3DSA:1.25.40.20:FF:000357', NULL, NULL, 'ankyrin repeat domain-containing protein 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(53784, NULL, 'G3DSA:1.10.246.130:FF:000005', NULL, NULL, 'Gamma-glutamyltranspeptidase 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(53785, NULL, 'G3DSA:2.40.40.20:FF:000022', NULL, NULL, 'Thiosulfate reductase PhsA', NULL, NULL, NULL, NULL, NULL, 4),
(53786, NULL, 'G3DSA:1.10.246.140:FF:000008', NULL, NULL, 'Transcription and mRNA export factor SUS1', NULL, NULL, NULL, NULL, NULL, 4),
(53787, NULL, 'G3DSA:1.25.40.10:FF:001439', NULL, NULL, 'Protein F54C1.5/ TPR repeat family', NULL, NULL, NULL, NULL, NULL, 4),
(53788, NULL, 'G3DSA:2.130.10.10:FF:001659', NULL, NULL, 'Cleavage and polyadenylation specific factor 1, 160kDa (Predicted), isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(53789, NULL, 'G3DSA:3.30.930.10:FF:000433', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53790, NULL, 'G3DSA:3.20.20.70:FF:000208', NULL, NULL, 'Fructose-bisphosphate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(53791, NULL, 'G3DSA:3.30.499.10:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53792, NULL, 'G3DSA:1.10.132.20:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53793, NULL, 'G3DSA:1.20.1560.10:FF:000891', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(53794, NULL, 'G3DSA:1.10.10.10:FF:001892', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(53795, NULL, 'G3DSA:2.130.10.10:FF:002047', NULL, NULL, 'WD domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(53796, NULL, 'G3DSA:3.40.50.300:FF:007825', NULL, NULL, 'RAD50 DNA repair-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(53797, NULL, 'G3DSA:3.40.50.2300:FF:001483', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53798, NULL, 'G3DSA:3.30.160.60:FF:001586', NULL, NULL, 'Zinc finger protein 354B', NULL, NULL, NULL, NULL, NULL, 4),
(53799, NULL, 'G3DSA:3.90.770.10:FF:000002', NULL, NULL, '3-hydroxy-3-methylglutaryl coenzyme A reductase', NULL, NULL, NULL, NULL, NULL, 4),
(53800, NULL, 'G3DSA:1.10.3480.20:FF:000002', NULL, NULL, 'AGAP012757-PA', NULL, NULL, NULL, NULL, NULL, 4),
(53801, NULL, 'G3DSA:1.10.8.480:FF:000002', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(53802, NULL, 'G3DSA:1.10.132.30:FF:000024', NULL, NULL, 'DNA-directed RNA polymerase I subunit rpa1', NULL, NULL, NULL, NULL, NULL, 4),
(53803, NULL, 'G3DSA:4.10.110.10:FF:000001', NULL, NULL, 'Trefoil factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(53804, NULL, 'G3DSA:1.20.900.10:FF:000059', NULL, NULL, 'Protein CBG22463', NULL, NULL, NULL, NULL, NULL, 4),
(53805, NULL, 'G3DSA:1.10.630.10:FF:000658', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53806, NULL, 'G3DSA:1.10.580.10:FF:000013', NULL, NULL, 'Citrate synthase-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(53807, NULL, 'G3DSA:1.10.510.10:FF:004073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53808, NULL, 'G3DSA:1.10.260.40:FF:000083', NULL, NULL, 'Transcriptional repressor LexA, putative', NULL, NULL, NULL, NULL, NULL, 4),
(53809, NULL, 'G3DSA:3.90.245.10:FF:000007', NULL, NULL, 'Nucleoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(53810, NULL, 'G3DSA:2.10.220.10:FF:000090', NULL, NULL, 'Fraser extracellular matrix complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(53811, NULL, 'G3DSA:3.30.1120.10:FF:000039', NULL, NULL, 'N-acetylgalactosamine 6-sulfate sulfatase (GALNS)', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(53812, NULL, 'G3DSA:2.60.120.10:FF:000026', NULL, NULL, 'Homogentisate 1,2-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(53813, NULL, 'G3DSA:3.30.60.30:FF:000013', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(53814, NULL, 'G3DSA:3.30.2310.20:FF:000006', NULL, NULL, 'Possible toxin pare2', NULL, NULL, NULL, NULL, NULL, 4),
(53815, NULL, 'G3DSA:3.30.9.10:FF:000192', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(53816, NULL, 'G3DSA:3.40.50.300:FF:003773', NULL, NULL, 'Protein CBR-PGP-10', NULL, NULL, NULL, NULL, NULL, 4),
(53817, NULL, 'G3DSA:2.40.30.10:FF:000153', NULL, NULL, 'GTP-binding protein TypA/BipA', NULL, NULL, NULL, NULL, NULL, 4),
(53818, NULL, 'G3DSA:3.30.70.1560:FF:000010', NULL, NULL, 'Uncharacterized RNA pseudouridine synthase jhp_1352', NULL, NULL, NULL, NULL, NULL, 4),
(53819, NULL, 'G3DSA:1.10.150.50:FF:000156', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(53820, NULL, 'G3DSA:3.90.25.10:FF:000075', NULL, NULL, 'UDP-glucose-4-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(53821, NULL, 'G3DSA:3.60.21.10:FF:000101', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(53822, NULL, 'G3DSA:2.10.70.10:FF:000207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53823, NULL, 'G3DSA:3.80.10.10:FF:003071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53824, NULL, 'G3DSA:3.40.50.300:FF:001839', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(53825, NULL, 'G3DSA:3.30.60.20:FF:000010', NULL, NULL, 'Putative kinase suppressor of Ras 1', NULL, NULL, NULL, NULL, NULL, 4),
(53826, NULL, 'G3DSA:1.10.3060.10:FF:000018', NULL, NULL, 'Protein translocase subunit SecA 1', NULL, NULL, NULL, NULL, NULL, 4),
(53827, NULL, 'G3DSA:1.10.472.80:FF:000261', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53828, NULL, 'G3DSA:1.10.150.80:FF:000041', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(53829, NULL, 'G3DSA:3.30.70.330:FF:002698', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53830, NULL, 'G3DSA:3.50.50.60:FF:001425', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(53831, NULL, 'G3DSA:1.10.8.10:FF:000273', NULL, NULL, 'ATP-dependent protease ATPase subunit HslU', NULL, NULL, NULL, NULL, NULL, 4),
(53832, NULL, 'G3DSA:1.10.10.10:FF:001774', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(53833, NULL, 'G3DSA:3.40.50.2020:FF:000078', NULL, NULL, 'ribose-phosphate pyrophosphokinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(53834, NULL, 'G3DSA:3.30.160.60:FF:003840', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53835, NULL, 'G3DSA:3.60.21.10:FF:000410', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(53836, NULL, 'G3DSA:1.25.40.180:FF:000294', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53837, NULL, 'G3DSA:3.40.50.300:FF:008505', NULL, NULL, 'UvrD/REP helicase domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(53838, NULL, 'G3DSA:2.60.120.290:FF:000078', NULL, NULL, 'CUB and zona pellucida-like domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(53839, NULL, 'G3DSA:3.40.50.1010:FF:000034', NULL, NULL, 'Ribonuclease H', NULL, NULL, NULL, NULL, NULL, 4),
(53840, NULL, 'G3DSA:1.25.40.10:FF:002046', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g18940, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(53841, NULL, 'G3DSA:1.10.10.10:FF:000801', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(53842, NULL, 'G3DSA:3.40.50.720:FF:001515', NULL, NULL, 'Chromosome 12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(53843, NULL, 'G3DSA:1.50.10.10:FF:000165', NULL, NULL, 'Family 48 cellulase', NULL, NULL, NULL, NULL, NULL, 4),
(53844, NULL, 'G3DSA:2.60.120.220:FF:000001', NULL, NULL, 'Capsid protein', NULL, NULL, NULL, NULL, NULL, 4),
(53845, NULL, 'G3DSA:3.40.50.2000:FF:001056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(53846, NULL, 'G3DSA:2.60.40.1180:FF:000024', NULL, NULL, 'Cytoplasmic alpha-amylase', NULL, NULL, NULL, NULL, NULL, 4),
(53847, NULL, 'G3DSA:3.90.190.10:FF:000267', NULL, NULL, 'Putative tyrosine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(53848, NULL, 'G3DSA:2.60.120.10:FF:000335', NULL, NULL, 'Cysteine dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(53849, NULL, 'G3DSA:3.40.50.2300:FF:001365', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53850, NULL, 'G3DSA:1.25.40.20:FF:000150', NULL, NULL, 'calmodulin-binding transcription activator 5', NULL, NULL, NULL, NULL, NULL, 4),
(53851, NULL, 'G3DSA:1.20.1250.20:FF:002366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53852, NULL, 'G3DSA:1.10.287.70:FF:000428', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(53853, NULL, 'G3DSA:2.30.30.380:FF:000016', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(53854, NULL, 'G3DSA:2.60.120.10:FF:000705', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(53855, NULL, 'G3DSA:1.20.1280.50:FF:000162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53856, NULL, 'G3DSA:4.10.400.10:FF:000309', NULL, NULL, 'GPR insulin like receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(53857, NULL, 'G3DSA:3.40.140.10:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53858, NULL, 'G3DSA:1.10.220.10:FF:000054', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(53859, NULL, 'G3DSA:1.10.3520.10:FF:000037', NULL, NULL, 'Os04g0438600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(53860, NULL, 'G3DSA:2.60.40.1170:FF:000021', NULL, NULL, 'AP-4 complex subunit mu-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(53861, NULL, 'G3DSA:3.60.130.10:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53862, NULL, 'G3DSA:3.40.50.1820:FF:001322', NULL, NULL, 'Lipase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(53863, NULL, 'G3DSA:2.130.10.10:FF:003593', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53864, NULL, 'G3DSA:3.60.21.10:FF:000308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53865, NULL, 'G3DSA:3.80.10.10:FF:002918', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53866, NULL, 'G3DSA:1.25.40.10:FF:001782', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(53867, NULL, 'G3DSA:1.25.40.20:FF:001785', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53868, NULL, 'G3DSA:1.20.1250.20:FF:000685', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(53869, NULL, 'G3DSA:2.60.120.330:FF:000152', NULL, NULL, 'Oxidoreductase, 2OG-Fe(II) oxygenase family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(53870, NULL, 'G3DSA:2.60.40.790:FF:000033', NULL, NULL, 'Ubiquitin specific peptidase 19', NULL, NULL, NULL, NULL, NULL, 4),
(53871, NULL, 'G3DSA:3.90.260.10:FF:000020', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(53872, NULL, 'G3DSA:3.90.1290.10:FF:000032', NULL, NULL, 'AGAP011396-PA', NULL, NULL, NULL, NULL, NULL, 4),
(53873, NULL, 'G3DSA:3.40.30.10:FF:000241', NULL, NULL, 'Glutathione S-transferase F9', NULL, NULL, NULL, NULL, NULL, 4),
(53874, NULL, 'G3DSA:3.30.70.330:FF:001107', NULL, NULL, 'GM14902', NULL, NULL, NULL, NULL, NULL, 4),
(53875, NULL, 'G3DSA:1.10.630.10:FF:000804', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53876, NULL, 'G3DSA:1.25.40.10:FF:004300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53877, NULL, 'G3DSA:2.60.40.10:FF:005526', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53878, NULL, 'G3DSA:1.25.40.10:FF:003682', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(53879, NULL, 'G3DSA:1.10.287.1890:FF:000003', NULL, NULL, 'tRNA (Adenine(22)-N(1))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(53880, NULL, 'G3DSA:2.130.10.10:FF:005493', NULL, NULL, 'Cleavage and polyadenylation specificity factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(53881, NULL, 'G3DSA:3.90.950.20:FF:000002', NULL, NULL, 'CinA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(53882, NULL, 'G3DSA:2.60.40.10:FF:001682', NULL, NULL, 'filamin-A isoform X8', NULL, NULL, NULL, NULL, NULL, 4),
(53883, NULL, 'G3DSA:1.25.40.20:FF:000503', NULL, NULL, 'Ankyrin repeat domain 2 (stretch responsive muscle)', NULL, NULL, NULL, NULL, NULL, 4),
(53884, NULL, 'G3DSA:2.30.29.30:FF:000538', NULL, NULL, 'Pleckstrin-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(53885, NULL, 'G3DSA:3.40.50.10470:FF:000010', NULL, NULL, 'Methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(53886, NULL, 'G3DSA:1.10.287.1130:FF:000011', NULL, NULL, 'Cx9C motif-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(53887, NULL, 'G3DSA:2.170.270.10:FF:000201', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(53888, NULL, 'G3DSA:3.40.50.1010:FF:000242', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53889, NULL, 'G3DSA:1.20.1070.10:FF:001281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53890, NULL, 'G3DSA:2.10.25.10:FF:000928', NULL, NULL, 'Protein eyes shut homolog', NULL, NULL, NULL, NULL, NULL, 4),
(53891, NULL, 'G3DSA:1.25.40.120:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53892, NULL, 'G3DSA:1.20.1310.20:FF:000055', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(53893, NULL, 'G3DSA:1.10.8.10:FF:000289', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(53894, NULL, 'G3DSA:3.30.2160.10:FF:000042', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(53895, NULL, 'G3DSA:1.20.1070.10:FF:000775', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(53896, NULL, 'G3DSA:1.10.287.70:FF:000546', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53897, NULL, 'G3DSA:2.60.40.10:FF:002300', NULL, NULL, 'Ephrin receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(53898, NULL, 'G3DSA:1.10.3370.10:FF:000019', NULL, NULL, 'Retrotransposon protein, putative, Ty3-gypsy subclass', NULL, NULL, NULL, NULL, NULL, 4),
(53899, NULL, 'G3DSA:3.30.200.20:FF:000111', NULL, NULL, 'Tyrosine-protein kinase receptor TYRO3', NULL, NULL, NULL, NULL, NULL, 4),
(53900, NULL, 'G3DSA:1.20.120.350:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53901, NULL, 'G3DSA:1.10.3380.10:FF:000048', NULL, NULL, 'Activating signal cointegrator 1 complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(53902, NULL, 'G3DSA:1.10.287.2900:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53903, NULL, 'G3DSA:1.25.40.790:FF:000004', NULL, NULL, 'Not1, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(53904, NULL, 'G3DSA:2.60.40.10:FF:000400', NULL, NULL, 'Hepatocyte growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(53905, NULL, 'G3DSA:1.25.40.180:FF:000176', NULL, NULL, 'nuclear cap-binding protein subunit 1-A-like', NULL, NULL, NULL, NULL, NULL, 4),
(53906, NULL, 'G3DSA:1.10.287.1150:FF:000017', NULL, NULL, '2-oxoglutarate dehydrogenase subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(53907, NULL, 'G3DSA:1.10.287.660:FF:000009', NULL, NULL, 'Golgi to ER traffic protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(53908, NULL, 'G3DSA:1.10.10.430:FF:000007', NULL, NULL, 'Protein phosphatase 1A', NULL, NULL, NULL, NULL, NULL, 4),
(53909, NULL, 'G3DSA:1.10.150.910:FF:000018', NULL, NULL, 'Putative CPSF-domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(53910, NULL, 'G3DSA:1.10.1780.10:FF:000011', NULL, NULL, 'Heat shock protein 101', NULL, NULL, NULL, NULL, NULL, 4),
(53911, NULL, 'G3DSA:3.40.50.300:FF:007679', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53912, NULL, 'G3DSA:3.30.499.10:FF:000008', NULL, NULL, 'Aconitate hydratase B', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(53913, NULL, 'G3DSA:3.10.450.580:FF:000002', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(53914, NULL, 'G3DSA:3.40.50.1440:FF:000140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53915, NULL, 'G3DSA:2.130.10.10:FF:005392', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53916, NULL, 'G3DSA:1.10.840.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53917, NULL, 'G3DSA:3.40.50.10190:FF:000358', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53918, NULL, 'G3DSA:1.25.40.20:FF:000149', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 10 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(53919, NULL, 'G3DSA:3.30.160.60:FF:002491', NULL, NULL, 'Zinc finger protein 217', NULL, NULL, NULL, NULL, NULL, 4),
(53920, NULL, 'G3DSA:2.60.40.10:FF:003626', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53921, NULL, 'G3DSA:3.90.550.10:FF:000121', NULL, NULL, 'Probable molybdenum cofactor guanylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(53922, NULL, 'G3DSA:3.30.70.330:FF:003007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53923, NULL, 'G3DSA:3.30.310.10:FF:000004', NULL, NULL, 'AP-2 complex subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(53924, NULL, 'G3DSA:1.25.40.10:FF:000500', NULL, NULL, 'Tetratricopeptide repeat domain 21A', NULL, NULL, NULL, NULL, NULL, 4),
(53925, NULL, 'G3DSA:3.30.450.50:FF:000032', NULL, NULL, 'AGAP000700-PA', NULL, NULL, NULL, NULL, NULL, 4),
(53926, NULL, 'G3DSA:1.25.10.10:FF:002218', NULL, NULL, 'Protein purity of essence-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(53927, NULL, 'G3DSA:1.10.510.10:FF:002055', NULL, NULL, 'Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(53928, NULL, 'G3DSA:3.90.70.10:FF:000443', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53929, NULL, 'G3DSA:2.130.10.10:FF:001805', NULL, NULL, 'Putative dynein', NULL, NULL, NULL, NULL, NULL, 4),
(53930, NULL, 'G3DSA:3.20.20.140:FF:000183', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(53931, NULL, 'G3DSA:2.70.160.11:FF:000078', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(53932, NULL, 'G3DSA:3.40.50.1000:FF:000340', NULL, NULL, 'RNA polymerase II ctd phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(53933, NULL, 'G3DSA:2.10.25.10:FF:000457', NULL, NULL, 'Sushi, nidogen and EGF like domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(53934, NULL, 'G3DSA:1.10.1200.270:FF:000033', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(53935, NULL, 'G3DSA:2.40.20.10:FF:000017', NULL, NULL, 'Prothrombin', NULL, NULL, NULL, NULL, NULL, 4),
(53936, NULL, 'G3DSA:3.30.1360.70:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53937, NULL, 'G3DSA:3.30.505.10:FF:000243', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53938, NULL, 'G3DSA:3.40.50.2000:FF:000893', NULL, NULL, 'Putative transferase', NULL, NULL, NULL, NULL, NULL, 4),
(53939, NULL, 'G3DSA:2.60.40.10:FF:005425', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53940, NULL, 'G3DSA:3.30.40.10:FF:001742', NULL, NULL, 'Lipase', NULL, NULL, NULL, NULL, NULL, 4),
(53941, NULL, 'G3DSA:1.20.1560.10:FF:000649', NULL, NULL, 'Protein CBG14016', NULL, NULL, NULL, NULL, NULL, 4),
(53942, NULL, 'G3DSA:2.60.490.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53943, NULL, 'G3DSA:1.20.1070.10:FF:001180', NULL, NULL, 'Melatonin receptor type 1B', NULL, NULL, NULL, NULL, NULL, 4),
(53944, NULL, 'G3DSA:3.30.70.330:FF:001208', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(53945, NULL, 'G3DSA:1.25.10.10:FF:000420', NULL, NULL, 'Sister chromatid cohesion protein PDS5 isogeny B', NULL, NULL, NULL, NULL, NULL, 4),
(53946, NULL, 'G3DSA:1.25.50.20:FF:000077', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(53947, NULL, 'G3DSA:2.130.10.10:FF:002710', NULL, NULL, 'WD40-repeat-containing domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(53948, NULL, 'G3DSA:3.40.710.10:FF:000167', NULL, NULL, 'Peptidoglycan glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(53949, NULL, 'G3DSA:3.40.50.1000:FF:000137', NULL, NULL, 'Hydrolase family protein / HAD-superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(53950, NULL, 'G3DSA:1.10.10.790:FF:000020', NULL, NULL, 'RNA splicing factor', NULL, NULL, NULL, NULL, NULL, 4),
(53951, NULL, 'G3DSA:3.30.160.60:FF:005638', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53952, NULL, 'G3DSA:1.20.5.2950:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53953, NULL, 'G3DSA:3.40.50.2020:FF:000123', NULL, NULL, 'Adenine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(53954, NULL, 'G3DSA:1.10.1740.170:FF:000001', NULL, NULL, 'Erythrocyte binding antigen', NULL, NULL, NULL, NULL, NULL, 4),
(53955, NULL, 'G3DSA:3.20.20.70:FF:000860', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53956, NULL, 'G3DSA:1.20.5.110:FF:000092', NULL, NULL, 'Transport protein SEC22', NULL, NULL, NULL, NULL, NULL, 4),
(53957, NULL, 'G3DSA:1.20.1640.10:FF:000021', NULL, NULL, 'Cation efflux system protein CusA', NULL, NULL, NULL, NULL, NULL, 4),
(53958, NULL, 'G3DSA:3.40.50.720:FF:001072', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(53959, NULL, 'G3DSA:1.10.10.10:FF:000700', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(53960, NULL, 'G3DSA:3.30.160.60:FF:006234', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53961, NULL, 'G3DSA:1.20.80.30:FF:000002', NULL, NULL, 'Pyruvate, phosphate dikinase', NULL, NULL, NULL, NULL, NULL, 4),
(53962, NULL, 'G3DSA:2.60.40.10:FF:000046', NULL, NULL, 'Nuclear factor NF-kappa-B p105 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(53963, NULL, 'G3DSA:1.50.40.10:FF:000313', NULL, NULL, 'Mitochondrial carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(53964, NULL, 'G3DSA:3.30.559.10:FF:000098', NULL, NULL, 'Nonribosomal peptide synthase SidC', NULL, NULL, NULL, NULL, NULL, 4),
(53965, NULL, 'G3DSA:1.20.120.1080:FF:000091', NULL, NULL, 'RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(53966, NULL, 'G3DSA:1.20.120.350:FF:000033', NULL, NULL, 'potassium voltage-gated channel subfamily A member 10', NULL, NULL, NULL, NULL, NULL, 4),
(53967, NULL, 'G3DSA:4.10.1240.10:FF:000035', NULL, NULL, 'Glucagon receptor a', NULL, NULL, NULL, NULL, NULL, 4),
(53968, NULL, 'G3DSA:3.60.20.40:FF:000006', NULL, NULL, 'Protein CBG05566', NULL, NULL, NULL, NULL, NULL, 4),
(53969, NULL, 'G3DSA:3.40.720.10:FF:000207', NULL, NULL, 'Putative glycosylphosphatidylinositol anchor synthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(53970, NULL, 'G3DSA:3.40.50.980:FF:000025', NULL, NULL, 'Amino acid adenylation', NULL, NULL, NULL, NULL, NULL, 4),
(53971, NULL, 'G3DSA:1.25.10.10:FF:001954', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53972, NULL, 'G3DSA:1.20.5.340:FF:000031', NULL, NULL, 'CDC42 binding protein kinase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(53973, NULL, 'G3DSA:1.20.1250.20:FF:001601', NULL, NULL, 'Battenin', NULL, NULL, NULL, NULL, NULL, 4),
(53974, NULL, 'G3DSA:3.90.640.90:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53975, NULL, 'G3DSA:3.40.50.300:FF:004026', NULL, NULL, 'DEAD box helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(53976, NULL, 'G3DSA:1.10.10.350:FF:000017', NULL, NULL, 'Glutamyl-tRNA synthetase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(53977, NULL, 'G3DSA:2.60.40.790:FF:000123', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53978, NULL, 'G3DSA:2.60.40.1180:FF:000125', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(53979, NULL, 'G3DSA:3.30.160.60:FF:000703', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53980, NULL, 'G3DSA:3.60.20.30:FF:000003', NULL, NULL, 'N(4)-(Beta-N-acetylglucosaminyl)-L-asparaginase isoform X1', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(53981, NULL, 'G3DSA:2.60.40.10:FF:001783', NULL, NULL, 'Anosmin 1', NULL, NULL, NULL, NULL, NULL, 4),
(53982, NULL, 'G3DSA:2.130.10.10:FF:006010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53983, NULL, 'G3DSA:2.120.10.80:FF:000202', NULL, NULL, 'Protein UNUSUAL FLORAL ORGANS', NULL, NULL, NULL, NULL, NULL, 4),
(53984, NULL, 'G3DSA:3.40.50.1460:FF:000045', NULL, NULL, 'AGAP010829-PA', NULL, NULL, NULL, NULL, NULL, 4),
(53985, NULL, 'G3DSA:1.20.1410.10:FF:000009', NULL, NULL, 'Sla2p', NULL, NULL, NULL, NULL, NULL, 4),
(53986, NULL, 'G3DSA:1.25.40.10:FF:002400', NULL, NULL, 'Pentatricopeptide repeat (PPR) superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(53987, NULL, 'G3DSA:3.30.70.1230:FF:000260', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(53988, NULL, 'G3DSA:3.10.50.40:FF:000134', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(53989, NULL, 'G3DSA:3.30.420.10:FF:000557', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(53990, NULL, 'G3DSA:3.60.21.10:FF:000056', NULL, NULL, 'Serine/threonine-protein phosphatase with EF-hands', NULL, NULL, NULL, NULL, NULL, 4),
(53991, NULL, 'G3DSA:3.30.450.20:FF:000697', NULL, NULL, 'Energy taxis modulating methyl accepting sensory transducer', NULL, NULL, NULL, NULL, NULL, 4),
(53992, NULL, 'G3DSA:3.30.70.1230:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53993, NULL, 'G3DSA:1.25.40.20:FF:001695', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(53994, NULL, 'G3DSA:1.10.560.10:FF:000113', NULL, NULL, 'Chaperonin-containing TCP1 subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(53995, NULL, 'G3DSA:3.30.70.3490:FF:000010', NULL, NULL, 'Oxysterol binding protein (Osh1)', NULL, NULL, NULL, NULL, NULL, 4),
(53996, NULL, 'G3DSA:1.20.120.1750:FF:000004', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(53997, NULL, 'G3DSA:3.90.550.10:FF:000019', NULL, NULL, 'Undecaprenyl-phosphate 4-deoxy-4-formamido-L-arabinose transferase', NULL, NULL, NULL, NULL, NULL, 4),
(53998, NULL, 'G3DSA:3.30.40.10:FF:001181', NULL, NULL, 'RING/FYVE/PHD zinc finger superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(53999, NULL, 'G3DSA:3.40.50.300:FF:007781', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54000, NULL, 'G3DSA:2.60.40.10:FF:004340', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54001, NULL, 'G3DSA:2.40.50.1070:FF:000007', NULL, NULL, '23S rRNA (Uracil-5-)-methyltransferase RumA', NULL, NULL, NULL, NULL, NULL, 4),
(54002, NULL, 'G3DSA:3.40.1110.10:FF:000396', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54003, NULL, 'G3DSA:3.40.50.150:FF:001659', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54004, NULL, 'G3DSA:1.20.272.10:FF:000020', NULL, NULL, 'Putative replication factor C3', NULL, NULL, NULL, NULL, NULL, 4),
(54005, NULL, 'G3DSA:1.25.10.10:FF:001645', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54006, NULL, 'G3DSA:2.120.10.30:FF:000103', NULL, NULL, 'Sortilin-related receptor', NULL, NULL, NULL, NULL, NULL, 4),
(54007, NULL, 'G3DSA:2.70.130.10:FF:000142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54008, NULL, 'G3DSA:2.40.50.1060:FF:000004', NULL, NULL, 'TWIST neighbor', NULL, NULL, NULL, NULL, NULL, 4),
(54009, NULL, 'G3DSA:3.40.50.300:FF:000193', NULL, NULL, 'Probable Elongation factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(54010, NULL, 'G3DSA:1.25.40.10:FF:001692', NULL, NULL, 'Os07g0203900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(54011, NULL, 'G3DSA:3.10.20.90:FF:000405', NULL, NULL, 'PB1_domain_containing_protein', NULL, NULL, NULL, NULL, NULL, 4),
(54012, NULL, 'G3DSA:3.40.50.2000:FF:000584', NULL, NULL, 'ADP-heptose--LPS heptosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(54013, NULL, 'G3DSA:1.10.8.60:FF:000490', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54014, NULL, 'G3DSA:3.40.50.300:FF:005881', NULL, NULL, 'ATP-dependent DNA helicase DDX11 isoform X1', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(54015, NULL, 'G3DSA:3.30.572.10:FF:000022', NULL, NULL, 'Putative phage-related deoxyuridylate hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(54016, NULL, 'G3DSA:3.40.50.200:FF:000045', NULL, NULL, 'Serine protease AprX', NULL, NULL, NULL, NULL, NULL, 4),
(54017, NULL, 'G3DSA:3.40.50.720:FF:000919', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(54018, NULL, 'G3DSA:3.40.250.10:FF:000249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54019, NULL, 'G3DSA:1.10.287.10:FF:000017', NULL, NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(54020, NULL, 'G3DSA:3.80.10.10:FF:001272', NULL, NULL, 'TIR-NBS-LRR class disease resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(54021, NULL, 'G3DSA:3.30.160.60:FF:000142', NULL, NULL, 'Putative zinc finger protein 143', NULL, NULL, NULL, NULL, NULL, 4),
(54022, NULL, 'G3DSA:3.20.20.70:FF:000096', NULL, NULL, 'Thiamine-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(54023, NULL, 'G3DSA:1.25.10.10:FF:000009', NULL, NULL, 'Importin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(54024, NULL, 'G3DSA:2.60.120.200:FF:000681', NULL, NULL, 'Papp-a2', NULL, NULL, NULL, NULL, NULL, 4),
(54025, NULL, 'G3DSA:3.40.630.30:FF:000436', NULL, NULL, 'Acyl-CoA N-acyltransferase (NAT) superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(54026, NULL, 'G3DSA:1.20.120.1760:FF:000007', NULL, NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(54027, NULL, 'G3DSA:3.20.20.370:FF:000004', NULL, NULL, 'Related to Chitin deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(54028, NULL, 'G3DSA:1.10.510.10:FF:000065', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(54029, NULL, 'G3DSA:1.10.510.10:FF:001459', NULL, NULL, 'Ribosomal protein S6 kinase beta-2', NULL, NULL, NULL, NULL, NULL, 4),
(54030, NULL, 'G3DSA:1.10.1000.11:FF:000010', NULL, NULL, 'ARF guanine-nucleotide exchange factor GNOM-like', NULL, NULL, NULL, NULL, NULL, 4),
(54031, NULL, 'G3DSA:3.40.20.10:FF:000049', NULL, NULL, 'Vesicle coat component', NULL, NULL, NULL, NULL, NULL, 4),
(54032, NULL, 'G3DSA:1.20.58.390:FF:000129', NULL, NULL, 'AcetylCholine Receptor', NULL, NULL, NULL, NULL, NULL, 4),
(54033, NULL, 'G3DSA:3.30.1370.30:FF:000002', NULL, NULL, '30S ribosomal protein S8', NULL, NULL, NULL, NULL, NULL, 4),
(54034, NULL, 'G3DSA:1.10.8.60:FF:000181', NULL, NULL, 'DnaA regulatory inactivator Hda', NULL, NULL, NULL, NULL, NULL, 4),
(54035, NULL, 'G3DSA:3.20.20.360:FF:000001', NULL, NULL, 'Malate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(54036, NULL, 'G3DSA:1.20.1070.10:FF:000466', NULL, NULL, 'Urotensin 2 receptor 5', NULL, NULL, NULL, NULL, NULL, 4),
(54037, NULL, 'G3DSA:3.20.20.60:FF:000093', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(54038, NULL, 'G3DSA:3.40.50.300:FF:005572', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54039, NULL, 'G3DSA:3.30.40.10:FF:000719', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(54040, NULL, 'G3DSA:3.30.450.20:FF:000388', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(54041, NULL, 'G3DSA:1.25.40.20:FF:000812', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54042, NULL, 'G3DSA:1.10.238.10:FF:000005', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(54043, NULL, 'G3DSA:3.40.50.620:FF:000878', NULL, NULL, 'Isoleucyl-tRNA synthetase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(54044, NULL, 'G3DSA:1.10.150.510:FF:000005', NULL, NULL, 'Receptor (G protein-coupled) activity-modifying protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(54045, NULL, 'G3DSA:3.30.160.60:FF:003576', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(54046, NULL, 'G3DSA:3.40.50.300:FF:005779', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(54047, NULL, 'G3DSA:2.30.29.30:FF:001353', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(54048, NULL, 'G3DSA:2.60.40.200:FF:000020', NULL, NULL, 'Copper chaperone for superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(54049, NULL, 'G3DSA:3.80.10.10:FF:004509', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54050, NULL, 'G3DSA:2.60.120.200:FF:000579', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54051, NULL, 'G3DSA:2.60.120.290:FF:000224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54052, NULL, 'G3DSA:3.40.50.1820:FF:001013', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(54053, NULL, 'G3DSA:3.20.20.80:FF:000099', NULL, NULL, 'Lactase-phlorizin hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(54054, NULL, 'G3DSA:3.30.160.60:FF:005728', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54055, NULL, 'G3DSA:1.20.5.540:FF:000001', NULL, NULL, 'focal adhesion kinase 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(54056, NULL, 'G3DSA:2.30.30.140:FF:000192', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(54057, NULL, 'G3DSA:2.60.40.3210:FF:000021', NULL, NULL, 'Novel protein with a zona pellucida-like domain', NULL, NULL, NULL, NULL, NULL, 4),
(54058, NULL, 'G3DSA:1.20.5.190:FF:000160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54059, NULL, 'G3DSA:3.40.50.300:FF:002345', NULL, NULL, 'YNR029C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(54060, NULL, 'G3DSA:3.30.40.10:FF:001079', NULL, NULL, 'Transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(54061, NULL, 'G3DSA:3.40.720.10:FF:000095', NULL, NULL, 'GPI ethanolamine phosphate transferase 3', NULL, NULL, NULL, NULL, NULL, 4),
(54062, NULL, 'G3DSA:3.50.50.60:FF:001279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54063, NULL, 'G3DSA:3.40.50.300:FF:007472', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54064, NULL, 'G3DSA:1.20.1740.10:FF:000085', NULL, NULL, 'large neutral amino acids transporter small subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(54065, NULL, 'G3DSA:3.30.200.20:FF:002011', NULL, NULL, 'Probable serine/threonine-protein kinase DDB_G0283065', NULL, NULL, NULL, NULL, NULL, 4),
(54066, NULL, 'G3DSA:3.40.50.1400:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54067, NULL, 'G3DSA:3.30.930.10:FF:000169', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(54068, NULL, 'G3DSA:3.50.30.30:FF:000038', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(54069, NULL, 'G3DSA:3.30.565.10:FF:000117', NULL, NULL, 'Two-component system sensor histidine kinase DcuS', NULL, NULL, NULL, NULL, NULL, 4),
(54070, NULL, 'G3DSA:3.30.160.60:FF:005419', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54071, NULL, 'G3DSA:3.40.850.10:FF:000099', NULL, NULL, 'Myosin E, putative', NULL, NULL, NULL, NULL, NULL, 4),
(54072, NULL, 'G3DSA:3.30.420.40:FF:000201', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(54073, NULL, 'G3DSA:1.10.565.10:FF:000208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54074, NULL, 'G3DSA:3.90.1600.10:FF:000040', NULL, NULL, 'DNA-directed DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(54075, NULL, 'G3DSA:3.30.559.30:FF:000070', NULL, NULL, 'Nonribosomal peptide synthase nlsA', NULL, NULL, NULL, NULL, NULL, 4),
(54076, NULL, 'G3DSA:1.10.287.70:FF:000664', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(54077, NULL, 'G3DSA:3.80.10.10:FF:004408', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54078, NULL, 'G3DSA:1.25.40.10:FF:003608', NULL, NULL, 'Transcriptional activator domain', NULL, NULL, NULL, NULL, NULL, 4),
(54079, NULL, 'G3DSA:2.30.30.140:FF:000293', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54080, NULL, 'G3DSA:3.40.50.2300:FF:000893', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(54081, NULL, 'G3DSA:1.10.510.10:FF:001566', NULL, NULL, 'Protein_kinase_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(54082, NULL, 'G3DSA:3.30.40.10:FF:000927', NULL, NULL, 'E3 ubiquitin-protein ligase RING1-like isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(54083, NULL, 'G3DSA:3.30.70.330:FF:001517', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54084, NULL, 'G3DSA:1.20.810.10:FF:000024', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(54085, NULL, 'G3DSA:3.20.20.140:FF:000289', NULL, NULL, 'Putative lactonase', NULL, NULL, NULL, NULL, NULL, 4),
(54086, NULL, 'G3DSA:2.60.60.20:FF:000039', NULL, NULL, 'Lipoxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(54087, NULL, 'G3DSA:1.20.5.110:FF:000299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54088, NULL, 'G3DSA:3.40.50.12240:FF:000001', NULL, NULL, 'V-type proton ATPase subunit B, brain', NULL, NULL, NULL, NULL, NULL, 4),
(54089, NULL, 'G3DSA:3.30.70.330:FF:003125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54090, NULL, 'G3DSA:2.20.70.10:FF:000100', NULL, NULL, 'Pre-mRNA-processing protein 40A isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(54091, NULL, 'G3DSA:3.10.450.10:FF:000018', NULL, NULL, 'Secreted phosphoprotein 2', NULL, NULL, NULL, NULL, NULL, 4),
(54092, NULL, 'G3DSA:3.40.50.12650:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54093, NULL, 'G3DSA:2.30.30.40:FF:000230', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(54094, NULL, 'G3DSA:1.20.1280.50:FF:000027', NULL, NULL, 'F-box only protein 39', NULL, NULL, NULL, NULL, NULL, 4),
(54095, NULL, 'G3DSA:3.90.1580.10:FF:000009', NULL, NULL, 'Gliding motility lipoprotein GldJ', NULL, NULL, NULL, NULL, NULL, 4),
(54096, NULL, 'G3DSA:1.20.1260.10:FF:000065', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(54097, NULL, 'G3DSA:3.40.1190.20:FF:000157', NULL, NULL, 'Ketohexokinase', NULL, NULL, NULL, NULL, NULL, 4),
(54098, NULL, 'G3DSA:3.30.420.10:FF:000451', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54099, NULL, 'G3DSA:1.20.920.10:FF:000162', NULL, NULL, 'Histone-lysine N-methyltransferase ash1', NULL, NULL, NULL, NULL, NULL, 4),
(54100, NULL, 'G3DSA:1.25.10.10:FF:001971', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(54101, NULL, 'G3DSA:1.20.1070.10:FF:000893', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(54102, NULL, 'G3DSA:3.40.50.300:FF:008421', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54103, NULL, 'G3DSA:3.30.160.60:FF:002182', NULL, NULL, 'Zinc finger protein 319', NULL, NULL, NULL, NULL, NULL, 4),
(54104, NULL, 'G3DSA:3.40.50.1000:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54105, NULL, 'G3DSA:1.20.1600.10:FF:000035', NULL, NULL, 'Efflux pump, RND family, outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(54106, NULL, 'G3DSA:1.10.10.10:FF:000240', NULL, NULL, 'Global nitrogen regulator NtcA', NULL, NULL, NULL, NULL, NULL, 4),
(54107, NULL, 'G3DSA:2.30.29.30:FF:000948', NULL, NULL, 'BEACH domain-containing protein lvsA', NULL, NULL, NULL, NULL, NULL, 4),
(54108, NULL, 'G3DSA:1.10.8.10:FF:000183', NULL, NULL, 'Probable peptidyl-tRNA hydrolase 2', NULL, NULL, NULL, NULL, NULL, 4),
(54109, NULL, 'G3DSA:2.60.40.10:FF:005835', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54110, NULL, 'G3DSA:1.20.58.1150:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54111, NULL, 'G3DSA:2.170.150.80:FF:000022', NULL, NULL, 'ANAC084', NULL, NULL, NULL, NULL, NULL, 4),
(54112, NULL, 'G3DSA:3.40.630.30:FF:000189', NULL, NULL, 'Probable ribosomal-protein-alanine acetyltransferase rimI', NULL, NULL, NULL, NULL, NULL, 4),
(54113, NULL, 'G3DSA:3.40.50.261:FF:000024', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(54114, NULL, 'G3DSA:3.60.21.10:FF:000281', NULL, NULL, 'Acid phosphatase 5a, tartrate-resistant', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(54115, NULL, 'G3DSA:1.10.530.10:FF:000038', NULL, NULL, 'Soluble lytic murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(54116, NULL, 'G3DSA:3.40.50.140:FF:000004', NULL, NULL, 'DNA topoisomerase 3', NULL, NULL, NULL, NULL, NULL, 4),
(54117, NULL, 'G3DSA:1.25.10.10:FF:001864', NULL, NULL, 'AGAP000374-PA', NULL, NULL, NULL, NULL, NULL, 4),
(54118, NULL, 'G3DSA:3.80.10.10:FF:001064', NULL, NULL, 'Protein singed wings 2', NULL, NULL, NULL, NULL, NULL, 4),
(54119, NULL, 'G3DSA:3.30.160.60:FF:002075', NULL, NULL, 'zinc finger protein 646', NULL, NULL, NULL, NULL, NULL, 4),
(54120, NULL, 'G3DSA:1.10.3080.10:FF:000036', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(54121, NULL, 'G3DSA:3.80.10.10:FF:000991', NULL, NULL, 'DnaJ family protein', NULL, NULL, NULL, NULL, NULL, 4),
(54122, NULL, 'G3DSA:2.60.40.10:FF:005296', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54123, NULL, 'G3DSA:2.102.10.10:FF:000065', NULL, NULL, 'Rieske (2Fe-2S) domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(54124, NULL, 'G3DSA:2.60.40.150:FF:000622', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54125, NULL, 'G3DSA:1.20.58.60:FF:000729', NULL, NULL, 'Alpha-actinin A', NULL, NULL, NULL, NULL, NULL, 4),
(54126, NULL, 'G3DSA:1.20.5.390:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54127, NULL, 'G3DSA:2.10.25.10:FF:001171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54128, NULL, 'G3DSA:3.90.480.20:FF:000011', NULL, NULL, 'Ferredoxin-nitrite reductase', NULL, NULL, NULL, NULL, NULL, 4),
(54129, NULL, 'G3DSA:1.20.5.1430:FF:000007', NULL, NULL, 'Protein BIM1', NULL, NULL, NULL, NULL, NULL, 4),
(54130, NULL, 'G3DSA:1.25.40.10:FF:005065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54131, NULL, 'G3DSA:1.10.620.20:FF:000020', NULL, NULL, 'Ribonucleoside-diphosphate reductase small chain', NULL, NULL, NULL, NULL, NULL, 4),
(54132, NULL, 'G3DSA:2.60.40.790:FF:000016', NULL, NULL, 'Very-long-chain (3R)-3-hydroxyacyl-CoA dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(54133, NULL, 'G3DSA:2.80.10.50:FF:000050', NULL, NULL, 'Fascin', NULL, NULL, NULL, NULL, NULL, 4),
(54134, NULL, 'G3DSA:3.30.230.80:FF:000024', NULL, NULL, 'Heat shock protein HSP 90-alpha', NULL, NULL, NULL, NULL, NULL, 4),
(54135, NULL, 'G3DSA:2.70.150.10:FF:000008', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(54136, NULL, 'G3DSA:3.40.1500.20:FF:000002', NULL, NULL, 'Phytochromobilin:ferredoxin oxidoreductase, chloroplast / phytochromobilin synthase (HY2)', NULL, NULL, NULL, NULL, NULL, 4),
(54137, NULL, 'G3DSA:3.30.70.330:FF:000798', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein A0', NULL, NULL, NULL, NULL, NULL, 4),
(54138, NULL, 'G3DSA:3.80.10.10:FF:002789', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(54139, NULL, 'G3DSA:2.60.40.1180:FF:000108', NULL, NULL, 'Alpha-galactosidase AgaA', NULL, NULL, NULL, NULL, NULL, 4),
(54140, NULL, 'G3DSA:3.20.20.70:FF:000450', NULL, NULL, '3-dehydroquinate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(54141, NULL, 'G3DSA:2.60.200.30:FF:000038', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(54142, NULL, 'G3DSA:3.40.33.10:FF:000045', NULL, NULL, 'GLIPR1-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(54143, NULL, 'G3DSA:3.40.50.720:FF:001162', NULL, NULL, 'Polyketide synthase RzxD', NULL, NULL, NULL, NULL, NULL, 4),
(54144, NULL, 'G3DSA:3.40.50.300:FF:004043', NULL, NULL, 'Probable non-intrinsic ABC protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(54145, NULL, 'G3DSA:2.40.20.10:FF:000091', NULL, NULL, 'Hepatocyte growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(54146, NULL, 'G3DSA:3.40.50.720:FF:002483', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54147, NULL, 'G3DSA:3.30.230.70:FF:000021', NULL, NULL, 'Exosome complex exonuclease RRP46 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(54148, NULL, 'G3DSA:3.30.160.60:FF:001676', NULL, NULL, 'Zinc finger protein 668', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(54149, NULL, 'G3DSA:3.30.1440.10:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54150, NULL, 'G3DSA:1.10.287.70:FF:000771', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54151, NULL, 'G3DSA:1.20.58.390:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54152, NULL, 'G3DSA:2.60.40.1170:FF:000105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54153, NULL, 'G3DSA:3.30.40.10:FF:001326', NULL, NULL, 'Related to postreplication repair protein uvsH/nuvA', NULL, NULL, NULL, NULL, NULL, 4),
(54154, NULL, 'G3DSA:3.20.20.80:FF:000453', NULL, NULL, 'YALI0F13299p', NULL, NULL, NULL, NULL, NULL, 4),
(54155, NULL, 'G3DSA:3.30.70.1720:FF:000002', NULL, NULL, 'Calmodulin-sensitive adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(54156, NULL, 'G3DSA:2.40.20.10:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54157, NULL, 'G3DSA:2.60.40.1510:FF:000022', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(54158, NULL, 'G3DSA:3.30.160.60:FF:005947', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54159, NULL, 'G3DSA:3.40.50.300:FF:002109', NULL, NULL, 'ABC transporter B family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(54160, NULL, 'G3DSA:1.10.287.110:FF:000412', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(54161, NULL, 'G3DSA:1.10.20.10:FF:000212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54162, NULL, 'G3DSA:2.70.150.10:FF:000115', NULL, NULL, 'Phospholipid-transporting ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(54163, NULL, 'G3DSA:3.40.50.2020:FF:000005', NULL, NULL, 'Ribose-phosphate pyrophosphokinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(54164, NULL, 'G3DSA:3.40.1170.60:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54165, NULL, 'G3DSA:2.40.160.120:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54166, NULL, 'G3DSA:3.40.50.2030:FF:000008', NULL, NULL, 'Hybrid cluster protein lateral transfer candidate', NULL, NULL, NULL, NULL, NULL, 4),
(54167, NULL, 'G3DSA:3.40.50.300:FF:005347', NULL, NULL, 'endoribonuclease Dicer', NULL, NULL, NULL, NULL, NULL, 4),
(54168, NULL, 'G3DSA:1.20.1070.10:FF:000691', NULL, NULL, 'Predicted vertebrate-like dopamine D1-like G-protein coupled receptor', NULL, NULL, NULL, NULL, NULL, 4),
(54169, NULL, 'G3DSA:2.60.200.20:FF:000035', NULL, NULL, 'Protein phosphatase 2C 70', NULL, NULL, NULL, NULL, NULL, 4),
(54170, NULL, 'G3DSA:1.10.8.140:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54171, NULL, 'G3DSA:1.25.40.20:FF:000711', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(54172, NULL, 'G3DSA:3.30.450.50:FF:000048', NULL, NULL, 'Vesicle-trafficking protein SEC22b', NULL, NULL, NULL, NULL, NULL, 4),
(54173, NULL, 'G3DSA:3.40.50.300:FF:004352', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(54174, NULL, 'G3DSA:3.30.830.10:FF:000032', NULL, NULL, 'Mitochondrial processing peptidase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(54175, NULL, 'G3DSA:1.25.10.10:FF:001185', NULL, NULL, 'HEAT repeat-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(54176, NULL, 'G3DSA:3.30.505.10:FF:000142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54177, NULL, 'G3DSA:3.40.50.1110:FF:000064', NULL, NULL, 'Acetylxylan esterase', NULL, NULL, NULL, NULL, NULL, 4),
(54178, NULL, 'G3DSA:3.40.1810.10:FF:000062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54179, NULL, 'G3DSA:3.30.160.60:FF:001895', NULL, NULL, 'Zinc finger protein 559', NULL, NULL, NULL, NULL, NULL, 4),
(54180, NULL, 'G3DSA:3.40.50.300:FF:002800', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(54181, NULL, 'G3DSA:1.20.1250.20:FF:001281', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(54182, NULL, 'G3DSA:2.90.10.10:FF:000054', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase LECRK3', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(54183, NULL, 'G3DSA:1.10.3210.10:FF:000053', NULL, NULL, 'Exopolyphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(54184, NULL, 'G3DSA:2.30.130.10:FF:000005', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase I', NULL, NULL, NULL, NULL, NULL, 4),
(54185, NULL, 'G3DSA:2.130.10.10:FF:002401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54186, NULL, 'G3DSA:1.10.510.10:FF:001892', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(54187, NULL, 'G3DSA:3.30.70.330:FF:000213', NULL, NULL, 'Uncharacterized protein, isoform R', NULL, NULL, NULL, NULL, NULL, 4),
(54188, NULL, 'G3DSA:3.30.200.20:FF:002112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54189, NULL, 'G3DSA:3.40.50.1100:FF:000061', NULL, NULL, 'Cysteine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(54190, NULL, 'G3DSA:1.25.40.10:FF:001810', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(54191, NULL, 'G3DSA:2.60.40.3500:FF:000001', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(54192, NULL, 'G3DSA:2.30.29.30:FF:001252', NULL, NULL, 'Vacuolar protein-sorting-associated protein 36', NULL, NULL, NULL, NULL, NULL, 4),
(54193, NULL, 'G3DSA:3.50.30.30:FF:000139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54194, NULL, 'G3DSA:3.40.1110.10:FF:000290', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54195, NULL, 'G3DSA:3.20.20.190:FF:000057', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(54196, NULL, 'G3DSA:1.10.510.10:FF:000150', NULL, NULL, 'Protein kinase C, theta', NULL, NULL, NULL, NULL, NULL, 4),
(54197, NULL, 'G3DSA:1.10.510.10:FF:004000', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54198, NULL, 'G3DSA:3.40.50.300:FF:002328', NULL, NULL, 'Helicase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(54199, NULL, 'G3DSA:1.10.287.600:FF:000008', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(54200, NULL, 'G3DSA:1.10.10.480:FF:000005', NULL, NULL, 'Probable ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(54201, NULL, 'G3DSA:3.30.160.60:FF:005745', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54202, NULL, 'G3DSA:2.30.30.770:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54203, NULL, 'G3DSA:1.10.238.10:FF:000701', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(54204, NULL, 'G3DSA:3.40.1360.10:FF:000010', NULL, NULL, 'DNA primase DnaG', NULL, NULL, NULL, NULL, NULL, 4),
(54205, NULL, 'G3DSA:3.30.160.20:FF:000186', NULL, NULL, '39S ribosomal protein L44, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(54206, NULL, 'G3DSA:3.30.40.10:FF:001107', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(54207, NULL, 'G3DSA:3.40.50.1400:FF:000027', NULL, NULL, 'Ferrochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(54208, NULL, 'G3DSA:3.10.50.40:FF:000117', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(54209, NULL, 'G3DSA:2.60.40.4380:FF:000001', NULL, NULL, 'Translational regulator CsrA', NULL, NULL, NULL, NULL, NULL, 4),
(54210, NULL, 'G3DSA:1.50.40.10:FF:000436', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54211, NULL, 'G3DSA:3.40.50.720:FF:001381', NULL, NULL, 'Epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(54212, NULL, 'G3DSA:1.25.40.20:FF:000060', NULL, NULL, 'E3 ubiquitin-protein ligase MIB1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(54213, NULL, 'G3DSA:2.40.30.10:FF:000400', NULL, NULL, 'NADPH--cytochrome p450 reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(54214, NULL, 'G3DSA:1.10.390.10:FF:000066', NULL, NULL, 'cDNA FLJ56120, highly similar to Aminopeptidase N', NULL, NULL, NULL, NULL, NULL, 4),
(54215, NULL, 'G3DSA:2.60.40.1180:FF:000215', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(54216, NULL, 'G3DSA:3.90.1410.10:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(54217, NULL, 'G3DSA:3.40.50.2300:FF:000786', NULL, NULL, 'Ribose ABC transporter, periplasmic ribose-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(54218, NULL, 'G3DSA:3.20.20.80:FF:000762', NULL, NULL, 'Klotho beta', NULL, NULL, NULL, NULL, NULL, 4),
(54219, NULL, 'G3DSA:2.130.10.10:FF:004172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54220, NULL, 'G3DSA:3.40.1190.10:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54221, NULL, 'G3DSA:1.25.40.10:FF:003827', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54222, NULL, 'G3DSA:3.40.50.1000:FF:000800', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54223, NULL, 'G3DSA:3.10.20.90:FF:000158', NULL, NULL, 'Polyubiquitin 5', NULL, NULL, NULL, NULL, NULL, 4),
(54224, NULL, 'G3DSA:2.130.10.10:FF:001912', NULL, NULL, 'Putative_intraflagellar_transport_protein_D4', NULL, NULL, NULL, NULL, NULL, 4),
(54225, NULL, 'G3DSA:2.30.29.30:FF:000639', NULL, NULL, 'SH2B adaptor protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(54226, NULL, 'G3DSA:2.20.25.10:FF:000041', NULL, NULL, 'DNA-directed RNA polymerase 2 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(54227, NULL, 'G3DSA:1.25.10.10:FF:001494', NULL, NULL, 'Vacuolar protein 14 C-terminal Fig4p binding-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(54228, NULL, 'G3DSA:3.90.1410.10:FF:000031', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(54229, NULL, 'G3DSA:3.40.930.10:FF:000032', NULL, NULL, 'Phosphotransferase system fructose-specific transporter subunit EI/HPr/EIIA', NULL, NULL, NULL, NULL, NULL, 4),
(54230, NULL, 'G3DSA:2.120.10.30:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54231, NULL, 'G3DSA:2.130.10.10:FF:005274', NULL, NULL, 'WD repeat-containing protein 16-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(54232, NULL, 'G3DSA:1.10.533.10:FF:000101', NULL, NULL, 'Receptor-interacting serine/threonine kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(54233, NULL, 'G3DSA:1.10.1420.10:FF:000113', NULL, NULL, 'DNA mismatch repair protein MutS 1', NULL, NULL, NULL, NULL, NULL, 4),
(54234, NULL, 'G3DSA:2.60.470.10:FF:000018', NULL, NULL, 'Pickpocket 21, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(54235, NULL, 'G3DSA:1.10.238.10:FF:000229', NULL, NULL, 'Calcineurin B subunit isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(54236, NULL, 'G3DSA:3.40.50.300:FF:005673', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54237, NULL, 'G3DSA:3.10.10.20:FF:000002', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(54238, NULL, 'G3DSA:2.30.29.30:FF:000729', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54239, NULL, 'G3DSA:2.10.70.10:FF:000073', NULL, NULL, 'Sushi repeat-containing protein SRPX2', NULL, NULL, NULL, NULL, NULL, 4),
(54240, NULL, 'G3DSA:1.10.30.10:FF:000128', NULL, NULL, 'High mobility group protein', NULL, NULL, NULL, NULL, NULL, 4),
(54241, NULL, 'G3DSA:2.130.10.10:FF:005953', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54242, NULL, 'G3DSA:2.60.40.10:FF:002423', NULL, NULL, 'Protein-tyrosine-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(54243, NULL, 'G3DSA:1.10.8.60:FF:000265', NULL, NULL, '26S protease regulatory subunit 6B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(54244, NULL, 'G3DSA:3.10.20.90:FF:000630', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54245, NULL, 'G3DSA:3.40.30.10:FF:000550', NULL, NULL, 'Glutathione S-transferase theta-2-like', NULL, NULL, NULL, NULL, NULL, 4),
(54246, NULL, 'G3DSA:2.60.40.1730:FF:000009', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(54247, NULL, 'G3DSA:3.30.160.60:FF:006111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54248, NULL, 'G3DSA:2.130.10.10:FF:001098', NULL, NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(54249, NULL, 'G3DSA:1.10.10.10:FF:001656', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(54250, NULL, 'G3DSA:3.20.20.80:FF:000672', NULL, NULL, 'Mannan endo-1,4-beta-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(54251, NULL, 'G3DSA:1.25.10.10:FF:000083', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(54252, NULL, 'G3DSA:2.60.40.1820:FF:000008', NULL, NULL, 'Late embryogenesis abundant (LEA) hydroxyproline-rich glycoprotein family', NULL, NULL, NULL, NULL, NULL, 4),
(54253, NULL, 'G3DSA:1.10.238.200:FF:000020', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(54254, NULL, 'G3DSA:2.60.40.10:FF:001934', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54255, NULL, 'G3DSA:3.10.260.10:FF:000004', NULL, NULL, 'Transcription factor MBP1', NULL, NULL, NULL, NULL, NULL, 4),
(54256, NULL, 'G3DSA:3.30.200.20:FF:001746', NULL, NULL, 'Serine/threonine-protein kinase greatwall', NULL, NULL, NULL, NULL, NULL, 4),
(54257, NULL, 'G3DSA:2.130.10.10:FF:005583', NULL, NULL, 'WD repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(54258, NULL, 'G3DSA:3.40.50.300:FF:005982', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54259, NULL, 'G3DSA:3.40.50.620:FF:000654', NULL, NULL, 'Protein CBR-WARS-1', NULL, NULL, NULL, NULL, NULL, 4),
(54260, NULL, 'G3DSA:1.10.10.60:FF:001087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54261, NULL, 'G3DSA:1.25.40.10:FF:004070', NULL, NULL, 'Putative Gamma-soluble NSF attachment protein (SNAP-gamma) (N-ethylmaleimide-sensitive factor attachment protein, gamma)', NULL, NULL, NULL, NULL, NULL, 4),
(54262, NULL, 'G3DSA:2.60.40.10:FF:004205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54263, NULL, 'G3DSA:2.40.50.140:FF:001205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54264, NULL, 'G3DSA:1.10.287.130:FF:000188', NULL, NULL, 'Sensor protein atoS', NULL, NULL, NULL, NULL, NULL, 4),
(54265, NULL, 'G3DSA:3.40.720.10:FF:000308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54266, NULL, 'G3DSA:1.10.630.10:FF:000097', NULL, NULL, 'Cytochrome P-450 19', NULL, NULL, NULL, NULL, NULL, 4),
(54267, NULL, 'G3DSA:1.10.1200.10:FF:000125', NULL, NULL, 'Nonribosomal peptide synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(54268, NULL, 'G3DSA:1.25.50.20:FF:000004', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(54269, NULL, 'G3DSA:3.40.50.1100:FF:000151', NULL, NULL, 'Cysteine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(54270, NULL, 'G3DSA:3.30.60.30:FF:000232', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(54271, NULL, 'G3DSA:1.10.472.80:FF:000036', NULL, NULL, 'TBC1 domain family member 17', NULL, NULL, NULL, NULL, NULL, 4),
(54272, NULL, 'G3DSA:1.25.10.10:FF:001499', NULL, NULL, 'AP-2 complex subunit beta-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(54273, NULL, 'G3DSA:3.30.70.330:FF:000489', NULL, NULL, 'RNA-binding protein 12B', NULL, NULL, NULL, NULL, NULL, 4),
(54274, NULL, 'G3DSA:1.25.40.10:FF:005048', NULL, NULL, 'Os11g0680200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(54275, NULL, 'G3DSA:1.20.5.100:FF:000010', NULL, NULL, 'Cytochrome c1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(54276, NULL, 'G3DSA:1.10.565.10:FF:000074', NULL, NULL, 'Nuclear hormone receptor family member nhr-25', NULL, NULL, NULL, NULL, NULL, 4),
(54277, NULL, 'G3DSA:1.10.287.110:FF:000047', NULL, NULL, 'Heat shock 40 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(54278, NULL, 'G3DSA:3.40.630.30:FF:000661', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54279, NULL, 'G3DSA:3.40.50.300:FF:000530', NULL, NULL, 'ABC transporter G family member 6', NULL, NULL, NULL, NULL, NULL, 4),
(54280, NULL, 'G3DSA:1.20.58.340:FF:000031', NULL, NULL, 'Chromosome 12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(54281, NULL, 'G3DSA:1.10.418.10:FF:000103', NULL, NULL, 'Fimbrin', NULL, NULL, NULL, NULL, NULL, 4),
(54282, NULL, 'G3DSA:2.40.70.10:FF:000144', NULL, NULL, 'Aspartic protease', NULL, NULL, NULL, NULL, NULL, 4),
(54283, NULL, 'G3DSA:3.30.70.330:FF:001287', NULL, NULL, 'WGS project CABT00000000 data, contig 2.24', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(54284, NULL, 'G3DSA:3.30.40.10:FF:001309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54285, NULL, 'G3DSA:3.40.1340.10:FF:000008', NULL, NULL, 'RNA polymerase I subunit 1RPB5', NULL, NULL, NULL, NULL, NULL, 4),
(54286, NULL, 'G3DSA:3.40.720.10:FF:000297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54287, NULL, 'G3DSA:3.30.450.40:FF:000017', NULL, NULL, 'HTH-type transcriptional repressor AllR', NULL, NULL, NULL, NULL, NULL, 4),
(54288, NULL, 'G3DSA:3.40.250.10:FF:000250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54289, NULL, 'G3DSA:3.80.10.10:FF:000682', NULL, NULL, 'Protein kinase family protein with leucine-rich repeat domain', NULL, NULL, NULL, NULL, NULL, 4),
(54290, NULL, 'G3DSA:3.30.1330.30:FF:000090', NULL, NULL, 'Peptide chain release factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(54291, NULL, 'G3DSA:2.10.25.10:FF:000704', NULL, NULL, 'Os12g0614800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(54292, NULL, 'G3DSA:3.40.190.80:FF:000063', NULL, NULL, 'Sulfite Synthesis/biphosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(54293, NULL, 'G3DSA:2.40.50.140:FF:000103', NULL, NULL, 'protein RRP5 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(54294, NULL, 'G3DSA:3.40.390.10:FF:000299', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54295, NULL, 'G3DSA:2.60.120.590:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54296, NULL, 'G3DSA:3.40.50.10420:FF:000034', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(54297, NULL, 'G3DSA:1.20.1110.10:FF:000037', NULL, NULL, 'Calcium-transporting ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(54298, NULL, 'G3DSA:2.10.70.10:FF:000180', NULL, NULL, 'Furrowed, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(54299, NULL, 'G3DSA:4.10.900.10:FF:000027', NULL, NULL, 'Novel protein similar to vertebrate cadherin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(54300, NULL, 'G3DSA:3.40.1170.60:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54301, NULL, 'G3DSA:2.70.150.10:FF:000132', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(54302, NULL, 'G3DSA:3.30.450.30:FF:000014', NULL, NULL, 'Profilin', NULL, NULL, NULL, NULL, NULL, 4),
(54303, NULL, 'G3DSA:2.60.40.150:FF:000206', NULL, NULL, 'C2 calcium-dependent domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(54304, NULL, 'G3DSA:1.20.144.10:FF:000060', NULL, NULL, 'Phospholipid phosphatase 4', NULL, NULL, NULL, NULL, NULL, 4),
(54305, NULL, 'G3DSA:3.30.200.20:FF:000004', NULL, NULL, 'Calcium-dependent protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(54306, NULL, 'G3DSA:1.10.10.10:FF:000021', NULL, NULL, 'HTH-type transcriptional regulator CysB', NULL, NULL, NULL, NULL, NULL, 4),
(54307, NULL, 'G3DSA:3.40.1110.10:FF:000295', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54308, NULL, 'G3DSA:1.20.1070.10:FF:000674', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54309, NULL, 'G3DSA:3.30.1360.120:FF:000006', NULL, NULL, 'Pyruvate dehydrogenase phosphatase regulatory subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(54310, NULL, 'G3DSA:3.60.21.10:FF:000320', NULL, NULL, 'Vacuolar protein sorting-associated protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(54311, NULL, 'G3DSA:3.40.50.1820:FF:000849', NULL, NULL, 'Serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(54312, NULL, 'G3DSA:3.40.50.360:FF:000087', NULL, NULL, 'Sulfite reductase [NADPH] flavoprotein alpha-component', NULL, NULL, NULL, NULL, NULL, 4),
(54313, NULL, 'G3DSA:1.10.8.10:FF:000188', NULL, NULL, 'AGAP003615-PA', NULL, NULL, NULL, NULL, NULL, 4),
(54314, NULL, 'G3DSA:2.60.120.620:FF:000132', NULL, NULL, '1-deoxypentalenic acid 11-beta-hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(54315, NULL, 'G3DSA:2.30.30.140:FF:000074', NULL, NULL, 'E3 ubiquitin-protein ligase UHRF2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(54316, NULL, 'G3DSA:3.30.450.20:FF:000596', NULL, NULL, 'Sensor histidine kinase, PAS domain-containing', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(54317, NULL, 'G3DSA:3.30.70.1230:FF:000057', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(54318, NULL, 'G3DSA:1.10.510.10:FF:001583', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54319, NULL, 'G3DSA:2.60.40.10:FF:004531', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54320, NULL, 'G3DSA:1.10.10.10:FF:000245', NULL, NULL, 'forkhead box protein M1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(54321, NULL, 'G3DSA:2.130.10.10:FF:004402', NULL, NULL, 'Actin-interacting protein 1-2', NULL, NULL, NULL, NULL, NULL, 4),
(54322, NULL, 'G3DSA:3.30.70.330:FF:003086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54323, NULL, 'G3DSA:3.30.559.30:FF:000053', NULL, NULL, 'Nonribosomal peptide synthetase 13', NULL, NULL, NULL, NULL, NULL, 4),
(54324, NULL, 'G3DSA:3.30.360.10:FF:000029', NULL, NULL, 'NAD-dependent dihydrogenase, Gfo/Idh/MocA family', NULL, NULL, NULL, NULL, NULL, 4),
(54325, NULL, 'G3DSA:3.40.50.300:FF:007932', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54326, NULL, 'G3DSA:3.40.140.10:FF:000022', NULL, NULL, 'Single-stranded DNA cytosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(54327, NULL, 'G3DSA:1.10.560.10:FF:000012', NULL, NULL, 'RuBisCO large subunit-binding protein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(54328, NULL, 'G3DSA:3.30.40.10:FF:001416', NULL, NULL, 'RING finger protein 113 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(54329, NULL, 'G3DSA:3.40.449.10:FF:000014', NULL, NULL, 'Phosphoenolpyruvate carboxykinase (ATP)', NULL, NULL, NULL, NULL, NULL, 4),
(54330, NULL, 'G3DSA:1.10.510.10:FF:004191', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54331, NULL, 'G3DSA:1.10.8.60:FF:000591', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54332, NULL, 'G3DSA:1.10.700.10:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54333, NULL, 'G3DSA:1.10.10.790:FF:000008', NULL, NULL, 'SURP and G-patch domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(54334, NULL, 'G3DSA:2.10.25.10:FF:001401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54335, NULL, 'G3DSA:3.90.1580.10:FF:000026', NULL, NULL, 'Sulfatase-modifying factor 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(54336, NULL, 'G3DSA:3.40.140.10:FF:000112', NULL, NULL, 'Mov34/MPN/PAD-1 metallopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(54337, NULL, 'G3DSA:1.20.1070.10:FF:000584', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(54338, NULL, 'G3DSA:3.40.50.1820:FF:001215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54339, NULL, 'G3DSA:2.60.40.10:FF:003391', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54340, NULL, 'G3DSA:3.30.420.610:FF:000006', NULL, NULL, 'tudor domain-containing protein 7 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(54341, NULL, 'G3DSA:1.10.510.10:FF:001931', NULL, NULL, 'Kinase, NEK-frag', NULL, NULL, NULL, NULL, NULL, 4),
(54342, NULL, 'G3DSA:3.90.70.10:FF:000117', NULL, NULL, 'Probable papain cysteine protease', NULL, NULL, NULL, NULL, NULL, 4),
(54343, NULL, 'G3DSA:3.40.50.150:FF:000810', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54344, NULL, 'G3DSA:3.40.50.12550:FF:000004', NULL, NULL, 'Ubiquitin-activating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(54345, NULL, 'G3DSA:3.40.50.12650:FF:000017', NULL, NULL, 'DNA cross-link repair 1C', NULL, NULL, NULL, NULL, NULL, 4),
(54346, NULL, 'G3DSA:2.40.160.20:FF:000007', NULL, NULL, 'Outer membrane protein OmpA', NULL, NULL, NULL, NULL, NULL, 4),
(54347, NULL, 'G3DSA:1.25.40.20:FF:000930', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54348, NULL, 'G3DSA:1.20.810.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54349, NULL, 'G3DSA:2.130.10.10:FF:000131', NULL, NULL, 'Kinesin family member 21A', NULL, NULL, NULL, NULL, NULL, 4),
(54350, NULL, 'G3DSA:2.60.40.3510:FF:000004', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(54351, NULL, 'G3DSA:3.40.50.300:FF:008404', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54352, NULL, 'G3DSA:1.20.1560.10:FF:000902', NULL, NULL, 'ABC transporter B family member 26 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(54353, NULL, 'G3DSA:1.20.1600.10:FF:000018', NULL, NULL, 'Outer membrane efflux protein', NULL, NULL, NULL, NULL, NULL, 4),
(54354, NULL, 'G3DSA:3.40.395.10:FF:000012', NULL, NULL, 'Deubiquitinase and deneddylase Dub2', NULL, NULL, NULL, NULL, NULL, 4),
(54355, NULL, 'G3DSA:3.30.1120.10:FF:000051', NULL, NULL, 'Arylsulfatase A', NULL, NULL, NULL, NULL, NULL, 4),
(54356, NULL, 'G3DSA:2.60.120.380:FF:000026', NULL, NULL, 'Calpain a', NULL, NULL, NULL, NULL, NULL, 4),
(54357, NULL, 'G3DSA:2.170.150.80:FF:000005', NULL, NULL, 'NAC transcription factor 56', NULL, NULL, NULL, NULL, NULL, 4),
(54358, NULL, 'G3DSA:3.90.660.10:FF:000039', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(54359, NULL, 'G3DSA:2.60.40.1120:FF:000012', NULL, NULL, 'probable carboxypeptidase X1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(54360, NULL, 'G3DSA:1.20.120.790:FF:000018', NULL, NULL, 'Molecular chaperone/ Grp94/Hsp90', NULL, NULL, NULL, NULL, NULL, 4),
(54361, NULL, 'G3DSA:3.40.50.300:FF:005763', NULL, NULL, 'Exodeoxyribonuclease V subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(54362, NULL, 'G3DSA:3.40.50.880:FF:000012', NULL, NULL, 'CTP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(54363, NULL, 'G3DSA:2.60.40.200:FF:000019', NULL, NULL, 'Superoxide dismutase [Cu-Zn]', NULL, NULL, NULL, NULL, NULL, 4),
(54364, NULL, 'G3DSA:3.40.50.150:FF:001558', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54365, NULL, 'G3DSA:3.40.50.300:FF:005987', NULL, NULL, 'YALI0C00671p', NULL, NULL, NULL, NULL, NULL, 4),
(54366, NULL, 'G3DSA:1.10.10.10:FF:001875', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54367, NULL, 'G3DSA:3.30.200.20:FF:001730', NULL, NULL, 'Wee1 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(54368, NULL, 'G3DSA:1.20.1250.20:FF:000792', NULL, NULL, 'Synaptic vesicle amine transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(54369, NULL, 'G3DSA:2.60.40.10:FF:005279', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54370, NULL, 'G3DSA:3.90.70.10:FF:000252', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(54371, NULL, 'G3DSA:2.130.10.10:FF:000024', NULL, NULL, 'Putative echinoderm microtubule-associated protein-like 6', NULL, NULL, NULL, NULL, NULL, 4),
(54372, NULL, 'G3DSA:1.10.530.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54373, NULL, 'G3DSA:3.40.50.300:FF:000327', NULL, NULL, 'ATP-binding cassette sub-family A member 3', NULL, NULL, NULL, NULL, NULL, 4),
(54374, NULL, 'G3DSA:3.40.50.10190:FF:000156', NULL, NULL, 'Protein BREAST CANCER SUSCEPTIBILITY 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(54375, NULL, 'G3DSA:3.30.160.60:FF:002058', NULL, NULL, 'YML081W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(54376, NULL, 'G3DSA:2.10.250.10:FF:000013', NULL, NULL, 'Calreticulin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(54377, NULL, 'G3DSA:1.10.472.80:FF:000159', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54378, NULL, 'G3DSA:3.40.50.200:FF:000163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54379, NULL, 'G3DSA:1.10.510.10:FF:004224', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54380, NULL, 'G3DSA:2.10.25.10:FF:000558', NULL, NULL, 'Neurogenic locus notch homolog protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(54381, NULL, 'G3DSA:3.40.1190.20:FF:000067', NULL, NULL, 'Ribokinase', NULL, NULL, NULL, NULL, NULL, 4),
(54382, NULL, 'G3DSA:3.30.1390.30:FF:000003', NULL, NULL, 'Peptidoglycan D,D-transpeptidase MrdA', NULL, NULL, NULL, NULL, NULL, 4),
(54383, NULL, 'G3DSA:3.10.20.90:FF:000175', NULL, NULL, 'UV excision repair protein Rad23', NULL, NULL, NULL, NULL, NULL, 4),
(54384, NULL, 'G3DSA:3.10.180.10:FF:000020', NULL, NULL, '4-hydroxyphenylpyruvate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(54385, NULL, 'G3DSA:1.10.287.70:FF:000754', NULL, NULL, 'Voltage-dependent T-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(54386, NULL, 'G3DSA:3.30.40.10:FF:000837', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(54387, NULL, 'G3DSA:3.30.160.60:FF:004183', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54388, NULL, 'G3DSA:2.20.25.530:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54389, NULL, 'G3DSA:1.10.472.130:FF:000060', NULL, NULL, 'Dynein heavy chain 1, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(54390, NULL, 'G3DSA:3.30.460.10:FF:000195', NULL, NULL, 'Ribosomal silencing factor RsfS', NULL, NULL, NULL, NULL, NULL, 4),
(54391, NULL, 'G3DSA:2.60.40.60:FF:000027', NULL, NULL, 'Cadherin 2', NULL, NULL, NULL, NULL, NULL, 4),
(54392, NULL, 'G3DSA:3.60.21.10:FF:000174', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(54393, NULL, 'G3DSA:2.60.40.10:FF:005498', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54394, NULL, 'G3DSA:3.80.10.10:FF:000884', NULL, NULL, 'NACHT, LRR and PYD domains-containing protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(54395, NULL, 'G3DSA:2.40.40.10:FF:000007', NULL, NULL, 'Papaya barwin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(54396, NULL, 'G3DSA:1.10.132.20:FF:000004', NULL, NULL, 'Ribosome-recycling factor', NULL, NULL, NULL, NULL, NULL, 4),
(54397, NULL, 'G3DSA:1.10.418.20:FF:000016', NULL, NULL, 'Ubiquitin-like protease 4', NULL, NULL, NULL, NULL, NULL, 4),
(54398, NULL, 'G3DSA:1.10.10.10:FF:001791', NULL, NULL, 'Transcription factor Dp-1', NULL, NULL, NULL, NULL, NULL, 4),
(54399, NULL, 'G3DSA:3.30.70.330:FF:002962', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54400, NULL, 'G3DSA:3.30.70.330:FF:001197', NULL, NULL, 'AGAP013051-PA', NULL, NULL, NULL, NULL, NULL, 4),
(54401, NULL, 'G3DSA:1.10.287.3240:FF:000009', NULL, NULL, 'ATPase H+ transporting V1 subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(54402, NULL, 'G3DSA:3.40.50.410:FF:000361', NULL, NULL, 'Collagen, type VI, alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(54403, NULL, 'G3DSA:1.20.1070.10:FF:001073', NULL, NULL, 'Trace amine-associated receptor 7h', NULL, NULL, NULL, NULL, NULL, 4),
(54404, NULL, 'G3DSA:2.10.70.10:FF:000090', NULL, NULL, 'Complement component 4 binding protein beta', NULL, NULL, NULL, NULL, NULL, 4),
(54405, NULL, 'G3DSA:1.10.275.10:FF:000001', NULL, NULL, 'Fumarate hydratase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(54406, NULL, 'G3DSA:1.10.10.10:FF:002038', NULL, NULL, 'Possible transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(54407, NULL, 'G3DSA:3.30.160.60:FF:004003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54408, NULL, 'G3DSA:3.40.605.10:FF:000035', NULL, NULL, 'Succinate-semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(54409, NULL, 'G3DSA:1.20.140.10:FF:000068', NULL, NULL, 'Acyl-CoA dehydrogenase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(54410, NULL, 'G3DSA:1.10.132.10:FF:000001', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(54411, NULL, 'G3DSA:1.20.58.390:FF:000253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54412, NULL, 'G3DSA:3.90.230.10:FF:000001', NULL, NULL, 'Methionine aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(54413, NULL, 'G3DSA:1.20.120.350:FF:000235', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54414, NULL, 'G3DSA:1.10.555.10:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54415, NULL, 'G3DSA:3.90.640.10:FF:000156', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(54416, NULL, 'G3DSA:3.80.10.10:FF:001373', NULL, NULL, 'GH20134p', NULL, NULL, NULL, NULL, NULL, 4),
(54417, NULL, 'G3DSA:3.40.630.30:FF:000335', NULL, NULL, 'FI06426p', NULL, NULL, NULL, NULL, NULL, 4),
(54418, NULL, 'G3DSA:1.10.150.50:FF:000049', NULL, NULL, 'phosphatidylinositol 3,4,5-trisphosphate 5-phosphatase 2', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(54419, NULL, 'G3DSA:3.30.70.100:FF:000184', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54420, NULL, 'G3DSA:3.10.20.90:FF:000523', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(54421, NULL, 'G3DSA:2.60.40.10:FF:005189', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54422, NULL, 'G3DSA:3.80.10.10:FF:000575', NULL, NULL, 'Leucine rich repeat containing 41', NULL, NULL, NULL, NULL, NULL, 4),
(54423, NULL, 'G3DSA:1.20.120.790:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54424, NULL, 'G3DSA:1.20.58.60:FF:000864', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54425, NULL, 'G3DSA:4.10.280.10:FF:000131', NULL, NULL, 'Basic helix-loop-helix protein', NULL, NULL, NULL, NULL, NULL, 4),
(54426, NULL, 'G3DSA:3.30.1380.20:FF:000033', NULL, NULL, 'Trafficking protein particle complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(54427, NULL, 'G3DSA:4.10.110.10:FF:000017', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(54428, NULL, 'G3DSA:3.10.20.90:FF:000304', NULL, NULL, 'Rho GTPase activating protein at 15B, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(54429, NULL, 'G3DSA:2.60.120.920:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54430, NULL, 'G3DSA:1.10.287.70:FF:000445', NULL, NULL, 'Inositol 1,4,5-trisphosphate receptor type 3', NULL, NULL, NULL, NULL, NULL, 4),
(54431, NULL, 'G3DSA:2.60.40.10:FF:004222', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54432, NULL, 'G3DSA:3.30.160.60:FF:004312', NULL, NULL, 'IP15679p', NULL, NULL, NULL, NULL, NULL, 4),
(54433, NULL, 'G3DSA:1.20.1070.10:FF:001382', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54434, NULL, 'G3DSA:1.10.418.10:FF:000013', NULL, NULL, 'IQ motif containing GTPase activating protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(54435, NULL, 'G3DSA:2.30.30.1020:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54436, NULL, 'G3DSA:3.30.40.10:FF:001635', NULL, NULL, 'Structure-specific endonuclease subunit SLX1', NULL, NULL, NULL, NULL, NULL, 4),
(54437, NULL, 'G3DSA:3.40.1160.10:FF:000017', NULL, NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(54438, NULL, 'G3DSA:1.25.40.10:FF:001703', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(54439, NULL, 'G3DSA:1.50.40.10:FF:000329', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54440, NULL, 'G3DSA:2.130.10.10:FF:003694', NULL, NULL, 'F-box/WD repeat-containing protein pof10', NULL, NULL, NULL, NULL, NULL, 4),
(54441, NULL, 'G3DSA:3.10.450.10:FF:000013', NULL, NULL, 'Cysteine proteinase inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(54442, NULL, 'G3DSA:1.10.1200.10:FF:000108', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(54443, NULL, 'G3DSA:3.30.70.330:FF:002130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54444, NULL, 'G3DSA:3.40.50.1110:FF:000047', NULL, NULL, 'GDSL family lipase', NULL, NULL, NULL, NULL, NULL, 4),
(54445, NULL, 'G3DSA:1.10.510.10:FF:003729', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54446, NULL, 'G3DSA:1.10.8.60:FF:000411', NULL, NULL, 'DNA polymerase epsilon subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(54447, NULL, 'G3DSA:3.20.20.190:FF:000164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54448, NULL, 'G3DSA:2.10.25.10:FF:000249', NULL, NULL, 'Integrin subunit beta like 1', NULL, NULL, NULL, NULL, NULL, 4),
(54449, NULL, 'G3DSA:1.10.3210.10:FF:000070', NULL, NULL, 'HDIG domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(54450, NULL, 'G3DSA:4.10.365.10:FF:000007', NULL, NULL, 'Cyclin-dependent kinase inhibitor 2', NULL, NULL, NULL, NULL, NULL, 4),
(54451, NULL, 'G3DSA:3.30.40.10:FF:001080', NULL, NULL, 'Anaphase-promoting_complex_subunit_11_RING-H2_finger/Zinc_finger', NULL, NULL, NULL, NULL, NULL, 4),
(54452, NULL, 'G3DSA:3.30.30.30:FF:000056', NULL, NULL, 'Heat shock protein 70 putative', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(54453, NULL, 'G3DSA:3.40.50.300:FF:007590', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54454, NULL, 'G3DSA:3.40.50.1100:FF:000044', NULL, NULL, 'Phenylserine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(54455, NULL, 'G3DSA:3.30.160.60:FF:000602', NULL, NULL, 'Teashirt zinc finger homeobox 2', NULL, NULL, NULL, NULL, NULL, 4),
(54456, NULL, 'G3DSA:3.80.10.10:FF:000665', NULL, NULL, 'Geranylgeranyl transferase type-2 subunit alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(54457, NULL, 'G3DSA:4.10.400.10:FF:000192', NULL, NULL, 'Low density lipoprotein receptor-related protein 1Bb', NULL, NULL, NULL, NULL, NULL, 4),
(54458, NULL, 'G3DSA:3.30.160.60:FF:003946', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54459, NULL, 'G3DSA:1.20.920.10:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54460, NULL, 'G3DSA:3.30.420.10:FF:000456', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(54461, NULL, 'G3DSA:1.10.3280.10:FF:000001', NULL, NULL, 'Bifunctional dehydrogenase/ferrochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(54462, NULL, 'G3DSA:3.40.50.150:FF:000007', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(54463, NULL, 'G3DSA:3.30.160.20:FF:000181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54464, NULL, 'G3DSA:2.40.10.480:FF:000012', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(54465, NULL, 'G3DSA:3.40.630.30:FF:000554', NULL, NULL, 'Acetyltransferase, GNAT family protein', NULL, NULL, NULL, NULL, NULL, 4),
(54466, NULL, 'G3DSA:2.60.40.60:FF:000246', NULL, NULL, 'Cadherin 86C, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(54467, NULL, 'G3DSA:1.25.40.10:FF:002501', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(54468, NULL, 'G3DSA:1.10.10.10:FF:001549', NULL, NULL, 'GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(54469, NULL, 'G3DSA:2.130.10.10:FF:000350', NULL, NULL, 'C-Jun-amino-terminal kinase-interacting protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(54470, NULL, 'G3DSA:2.60.40.10:FF:003727', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54471, NULL, 'G3DSA:1.10.720.30:FF:000082', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(54472, NULL, 'G3DSA:2.40.50.140:FF:001059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54473, NULL, 'G3DSA:3.30.559.10:FF:000199', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(54474, NULL, 'G3DSA:1.10.8.60:FF:000063', NULL, NULL, 'Nuclear valosin-containing protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(54475, NULL, 'G3DSA:2.40.160.120:FF:000040', NULL, NULL, 'Oxysterol-binding protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(54476, NULL, 'G3DSA:2.40.10.120:FF:000016', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(54477, NULL, 'G3DSA:3.80.10.10:FF:001154', NULL, NULL, 'Dma-1', NULL, NULL, NULL, NULL, NULL, 4),
(54478, NULL, 'G3DSA:3.40.50.620:FF:000199', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(54479, NULL, 'G3DSA:1.20.1270.60:FF:000193', NULL, NULL, 'YALI0F13673p', NULL, NULL, NULL, NULL, NULL, 4),
(54480, NULL, 'G3DSA:3.40.50.300:FF:000204', NULL, NULL, 'Translation elongation factor Tu', NULL, NULL, NULL, NULL, NULL, 4),
(54481, NULL, 'G3DSA:3.30.70.100:FF:000061', NULL, NULL, 'Photoactivated adenylate cyclase subunit beta-like protein 1224-5/1F', NULL, NULL, NULL, NULL, NULL, 4),
(54482, NULL, 'G3DSA:3.30.160.60:FF:000260', NULL, NULL, 'Spalt-like transcription factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(54483, NULL, 'G3DSA:3.10.670.10:FF:000001', NULL, NULL, 'Dermonecrotic toxin', NULL, NULL, NULL, NULL, NULL, 4),
(54484, NULL, 'G3DSA:1.10.8.60:FF:000372', NULL, NULL, 'AaceriAER065Cp', NULL, NULL, NULL, NULL, NULL, 4),
(54485, NULL, 'G3DSA:3.30.1960.10:FF:000007', NULL, NULL, 'tRNA-yW synthesizing protein 3 homolog', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(54486, NULL, 'G3DSA:3.30.160.60:FF:001923', NULL, NULL, 'Zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(54487, NULL, 'G3DSA:3.90.70.10:FF:000033', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(54488, NULL, 'G3DSA:3.40.30.10:FF:000347', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(54489, NULL, 'G3DSA:3.40.190.10:FF:000042', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(54490, NULL, 'G3DSA:3.20.20.220:FF:000015', NULL, NULL, 'Methylenetetrahydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(54491, NULL, 'G3DSA:3.40.50.300:FF:003880', NULL, NULL, 'RAS like family 12', NULL, NULL, NULL, NULL, NULL, 4),
(54492, NULL, 'G3DSA:1.25.50.10:FF:000001', NULL, NULL, 'Aminopeptidase N', NULL, NULL, NULL, NULL, NULL, 4),
(54493, NULL, 'G3DSA:1.25.10.10:FF:000190', NULL, NULL, 'Ecm29 proteasome adaptor and scaffold', NULL, NULL, NULL, NULL, NULL, 4),
(54494, NULL, 'G3DSA:3.10.250.10:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54495, NULL, 'G3DSA:3.40.50.150:FF:001777', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54496, NULL, 'G3DSA:3.30.300.10:FF:000037', NULL, NULL, 'Probable GMP synthase [glutamine-hydrolyzing]', NULL, NULL, NULL, NULL, NULL, 4),
(54497, NULL, 'G3DSA:1.10.10.2450:FF:000001', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(54498, NULL, 'G3DSA:3.40.630.10:FF:000104', NULL, NULL, 'Silver, isoform N', NULL, NULL, NULL, NULL, NULL, 4),
(54499, NULL, 'G3DSA:3.10.250.10:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54500, NULL, 'G3DSA:1.25.40.20:FF:001667', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(54501, NULL, 'G3DSA:1.20.1070.10:FF:001163', NULL, NULL, 'Alpha-1A adrenergic receptor', NULL, NULL, NULL, NULL, NULL, 4),
(54502, NULL, 'G3DSA:1.20.1560.10:FF:000666', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54503, NULL, 'G3DSA:2.130.10.10:FF:003475', NULL, NULL, 'AGAP010035-PA', NULL, NULL, NULL, NULL, NULL, 4),
(54504, NULL, 'G3DSA:1.20.5.110:FF:000119', NULL, NULL, '60S ribosomal protein L13', NULL, NULL, NULL, NULL, NULL, 4),
(54505, NULL, 'G3DSA:3.30.505.10:FF:000226', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54506, NULL, 'G3DSA:3.30.9.10:FF:000293', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54507, NULL, 'G3DSA:1.25.40.10:FF:001664', NULL, NULL, 'Tetratricopeptide repeat protein 7A', NULL, NULL, NULL, NULL, NULL, 4),
(54508, NULL, 'G3DSA:1.20.120.330:FF:000010', NULL, NULL, 'Dishevelled associated activator of morphogenesis 1', NULL, NULL, NULL, NULL, NULL, 4),
(54509, NULL, 'G3DSA:3.30.830.10:FF:000122', NULL, NULL, 'Ubiquinol-cytochrome c reductase core protein 2a', NULL, NULL, NULL, NULL, NULL, 4),
(54510, NULL, 'G3DSA:3.30.70.330:FF:001181', NULL, NULL, 'CBN-MEC-8 protein', NULL, NULL, NULL, NULL, NULL, 4),
(54511, NULL, 'G3DSA:3.10.20.30:FF:000056', NULL, NULL, 'developmentally-regulated GTP-binding protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(54512, NULL, 'G3DSA:3.40.50.300:FF:003874', NULL, NULL, 'ATP-binding cassette protein subfamily H, member 2', NULL, NULL, NULL, NULL, NULL, 4),
(54513, NULL, 'G3DSA:2.30.30.140:FF:000057', NULL, NULL, 'Histone-lysine N-methyltransferase NSD2', NULL, NULL, NULL, NULL, NULL, 4),
(54514, NULL, 'G3DSA:2.10.25.10:FF:000474', NULL, NULL, 'Teneurin transmembrane protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(54515, NULL, 'G3DSA:3.30.160.60:FF:000821', NULL, NULL, 'Zinc finger protein 524', NULL, NULL, NULL, NULL, NULL, 4),
(54516, NULL, 'G3DSA:2.40.420.20:FF:000045', NULL, NULL, 'Putative MacA', NULL, NULL, NULL, NULL, NULL, 4),
(54517, NULL, 'G3DSA:2.40.50.100:FF:000024', NULL, NULL, 'Exosome complex component CSL4', NULL, NULL, NULL, NULL, NULL, 4),
(54518, NULL, 'G3DSA:3.30.420.10:FF:000675', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54519, NULL, 'G3DSA:2.10.70.10:FF:000106', NULL, NULL, 'Complement factor H related 5', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(54520, NULL, 'G3DSA:2.60.120.200:FF:000686', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54521, NULL, 'G3DSA:1.20.120.340:FF:000013', NULL, NULL, 'Flagellar secretion chaperone FliS', NULL, NULL, NULL, NULL, NULL, 4),
(54522, NULL, 'G3DSA:2.30.30.40:FF:000027', NULL, NULL, 'Disks large homolog 3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(54523, NULL, 'G3DSA:3.40.50.150:FF:000338', NULL, NULL, 'Protein-L-isoaspartate (D-aspartate) O-methyltransferase domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(54524, NULL, 'G3DSA:3.40.710.10:FF:000162', NULL, NULL, 'Membrane transglycosylase and transpeptidase PBP1A', NULL, NULL, NULL, NULL, NULL, 4),
(54525, NULL, 'G3DSA:3.30.160.60:FF:005599', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54526, NULL, 'G3DSA:2.30.180.10:FF:000031', NULL, NULL, 'periostin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(54527, NULL, 'G3DSA:1.10.533.10:FF:000062', NULL, NULL, 'Fas-associated via death domain', NULL, NULL, NULL, NULL, NULL, 4),
(54528, NULL, 'G3DSA:3.30.160.60:FF:006217', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54529, NULL, 'G3DSA:3.40.50.920:FF:000030', NULL, NULL, 'Pyruvate dehydrogenase E1 component beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(54530, NULL, 'G3DSA:3.30.1330.20:FF:000007', NULL, NULL, 'Cell division protein ftsZ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(54531, NULL, 'G3DSA:2.60.120.10:FF:000560', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54532, NULL, 'G3DSA:3.40.50.300:FF:000221', NULL, NULL, 'Multidrug ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(54533, NULL, 'G3DSA:1.10.10.10:FF:001566', NULL, NULL, 'DsRNA activated Z-DNA binding protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(54534, NULL, 'G3DSA:2.160.20.70:FF:000030', NULL, NULL, 'Tubulin binding cofactor C-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(54535, NULL, 'G3DSA:2.60.40.10:FF:004115', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54536, NULL, 'G3DSA:2.40.420.20:FF:000051', NULL, NULL, 'Cation efflux system protein', NULL, NULL, NULL, NULL, NULL, 4),
(54537, NULL, 'G3DSA:3.40.50.720:FF:000684', NULL, NULL, 'PROBABLE SHORT-CHAIN TYPE DEHYDROGENASE/REDUCTASE', NULL, NULL, NULL, NULL, NULL, 4),
(54538, NULL, 'G3DSA:1.10.260.100:FF:000019', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(54539, NULL, 'G3DSA:3.50.7.10:FF:000002', NULL, NULL, 'T-complex protein 1 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(54540, NULL, 'G3DSA:1.25.40.10:FF:003811', NULL, NULL, 'UTP6 small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4),
(54541, NULL, 'G3DSA:3.10.110.20:FF:000002', NULL, NULL, 'FA complementation group L', NULL, NULL, NULL, NULL, NULL, 4),
(54542, NULL, 'G3DSA:3.30.70.980:FF:000054', NULL, NULL, 'YALI0E16214p', NULL, NULL, NULL, NULL, NULL, 4),
(54543, NULL, 'G3DSA:3.30.310.270:FF:000003', NULL, NULL, 'Blast:Protein bicaudal C', NULL, NULL, NULL, NULL, NULL, 4),
(54544, NULL, 'G3DSA:1.10.555.10:FF:000264', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54545, NULL, 'G3DSA:1.20.120.350:FF:000016', NULL, NULL, 'Potassium voltage-gated channel subfamily D member 3', NULL, NULL, NULL, NULL, NULL, 4),
(54546, NULL, 'G3DSA:3.40.720.10:FF:000078', NULL, NULL, 'GPI ethanolamine phosphate transferase 2 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(54547, NULL, 'G3DSA:1.10.510.10:FF:000172', NULL, NULL, 'serine/threonine-protein kinase Nek1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(54548, NULL, 'G3DSA:3.30.310.10:FF:000009', NULL, NULL, 'TatA box-binding protein-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(54549, NULL, 'G3DSA:3.30.70.330:FF:001652', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54550, NULL, 'G3DSA:1.25.10.10:FF:001729', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54551, NULL, 'G3DSA:1.10.10.1340:FF:000005', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 31', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(54552, NULL, 'G3DSA:1.10.287.660:FF:000004', NULL, NULL, 'tail-anchored protein insertion receptor WRB', NULL, NULL, NULL, NULL, NULL, 4),
(54553, NULL, 'G3DSA:3.30.160.60:FF:003469', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(54554, NULL, 'G3DSA:1.10.230.10:FF:000021', NULL, NULL, 'Citrate synthase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(54555, NULL, 'G3DSA:1.10.405.10:FF:000017', NULL, NULL, 'Guanosine nucleotide diphosphate dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(54556, NULL, 'G3DSA:2.30.29.30:FF:001117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54557, NULL, 'G3DSA:3.90.190.10:FF:000593', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(54558, NULL, 'G3DSA:3.40.50.2300:FF:001590', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54559, NULL, 'G3DSA:3.30.810.10:FF:000014', NULL, NULL, 'Phosphatidylinositol-4-phosphate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(54560, NULL, 'G3DSA:1.10.287.370:FF:000024', NULL, NULL, 'Prefoldin_subunit', NULL, NULL, NULL, NULL, NULL, 4),
(54561, NULL, 'G3DSA:3.40.1110.10:FF:000273', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54562, NULL, 'G3DSA:3.60.21.10:FF:000191', NULL, NULL, '5`-nucleotidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(54563, NULL, 'G3DSA:3.40.50.1820:FF:000743', NULL, NULL, 'Serine carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(54564, NULL, 'G3DSA:1.25.40.10:FF:000028', NULL, NULL, 'beta-soluble NSF attachment protein-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(54565, NULL, 'G3DSA:1.20.1110.10:FF:000262', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54566, NULL, 'G3DSA:1.20.1250.20:FF:001264', NULL, NULL, 'Major facilitator superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(54567, NULL, 'G3DSA:3.30.230.10:FF:000296', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(54568, NULL, 'G3DSA:3.40.470.10:FF:000007', NULL, NULL, 'Uracil-DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(54569, NULL, 'G3DSA:3.30.200.20:FF:001623', NULL, NULL, 'Putative cell division control protein 7-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(54570, NULL, 'G3DSA:2.120.10.30:FF:000120', NULL, NULL, 'Transmembrane serine/threonine-protein kinase D', NULL, NULL, NULL, NULL, NULL, 4),
(54571, NULL, 'G3DSA:1.10.472.80:FF:000053', NULL, NULL, 'TBC domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(54572, NULL, 'G3DSA:3.30.420.110:FF:000042', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(54573, NULL, 'G3DSA:3.40.50.10470:FF:000026', NULL, NULL, 'Methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(54574, NULL, 'G3DSA:3.90.1430.10:FF:000004', NULL, NULL, 'U5 small nuclear ribonuclear protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(54575, NULL, 'G3DSA:3.40.50.300:FF:001637', NULL, NULL, 'replication factor C subunit 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(54576, NULL, 'G3DSA:1.10.287.70:FF:000529', NULL, NULL, 'cation channel sperm-associated protein 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(54577, NULL, 'G3DSA:3.90.1720.10:FF:000015', NULL, NULL, 'Probable cell wall hydrolase LytN', NULL, NULL, NULL, NULL, NULL, 4),
(54578, NULL, 'G3DSA:3.80.10.10:FF:002935', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54579, NULL, 'G3DSA:3.30.450.90:FF:000010', NULL, NULL, 'Competence protein CglA', NULL, NULL, NULL, NULL, NULL, 4),
(54580, NULL, 'G3DSA:4.10.400.10:FF:000208', NULL, NULL, 'SCO-spondin', NULL, NULL, NULL, NULL, NULL, 4),
(54581, NULL, 'G3DSA:4.10.60.10:FF:000112', NULL, NULL, 'Ribosomal protein L15', NULL, NULL, NULL, NULL, NULL, 4),
(54582, NULL, 'G3DSA:1.20.140.10:FF:000085', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(54583, NULL, 'G3DSA:2.40.50.140:FF:000896', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54584, NULL, 'G3DSA:1.10.1410.10:FF:000051', NULL, NULL, 'DNA2/NAM7 helicase family protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(54585, NULL, 'G3DSA:3.90.260.10:FF:000025', NULL, NULL, 'DNA repair protein complementing XP-C cells homolog', NULL, NULL, NULL, NULL, NULL, 4),
(54586, NULL, 'G3DSA:1.25.10.10:FF:002134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54587, NULL, 'G3DSA:1.20.1070.10:FF:001056', NULL, NULL, 'Putative Class a rhodopsin g-protein coupled receptor gprop1', NULL, NULL, NULL, NULL, NULL, 4),
(54588, NULL, 'G3DSA:2.60.300.12:FF:000008', NULL, NULL, 'iron-sulfur assembly protein IscA, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(54589, NULL, 'G3DSA:1.50.40.10:FF:000330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54590, NULL, 'G3DSA:3.30.200.20:FF:000313', NULL, NULL, 'Leucine-rich repeat serine/threonine-protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(54591, NULL, 'G3DSA:3.30.1310.10:FF:000003', NULL, NULL, 'Nucleoid-associated protein MRA_3753', NULL, NULL, NULL, NULL, NULL, 4),
(54592, NULL, 'G3DSA:3.20.20.70:FF:000298', NULL, NULL, 'Delta-aminolevulinic acid dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(54593, NULL, 'G3DSA:1.25.40.10:FF:001338', NULL, NULL, 'WGS project CABT00000000 data, contig 2.24', NULL, NULL, NULL, NULL, NULL, 4),
(54594, NULL, 'G3DSA:2.30.29.30:FF:001230', NULL, NULL, 'PH and Rap-GAP domain-containing protein DDB_G0271806', NULL, NULL, NULL, NULL, NULL, 4),
(54595, NULL, 'G3DSA:2.60.40.150:FF:000280', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(54596, NULL, 'G3DSA:2.60.40.10:FF:003497', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54597, NULL, 'G3DSA:2.60.40.10:FF:003508', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54598, NULL, 'G3DSA:1.10.840.10:FF:000051', NULL, NULL, 'SH2 domain containing 3Ca', NULL, NULL, NULL, NULL, NULL, 4),
(54599, NULL, 'G3DSA:3.40.50.2000:FF:000668', NULL, NULL, 'Glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(54600, NULL, 'G3DSA:1.25.40.10:FF:003266', NULL, NULL, 'AGR398Wp', NULL, NULL, NULL, NULL, NULL, 4),
(54601, NULL, 'G3DSA:2.30.30.910:FF:000001', NULL, NULL, 'Basal-body rod modification protein FlgD', NULL, NULL, NULL, NULL, NULL, 4),
(54602, NULL, 'G3DSA:1.10.510.10:FF:001476', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(54603, NULL, 'G3DSA:2.40.10.10:FF:000152', NULL, NULL, 'Plasminogen activator', NULL, NULL, NULL, NULL, NULL, 4),
(54604, NULL, 'G3DSA:2.30.30.1020:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54605, NULL, 'G3DSA:2.60.34.20:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54606, NULL, 'G3DSA:2.10.69.10:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54607, NULL, 'G3DSA:1.10.10.60:FF:000013', NULL, NULL, 'DNA-binding transcriptional activator MarA', NULL, NULL, NULL, NULL, NULL, 4),
(54608, NULL, 'G3DSA:3.30.1360.120:FF:000023', NULL, NULL, 'Sarcosine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(54609, NULL, 'G3DSA:4.10.280.10:FF:000237', NULL, NULL, 'Id-1', NULL, NULL, NULL, NULL, NULL, 4),
(54610, NULL, 'G3DSA:2.80.10.50:FF:000033', NULL, NULL, 'Fibroblast growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(54611, NULL, 'G3DSA:3.30.2130.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54612, NULL, 'G3DSA:3.30.450.20:FF:000517', NULL, NULL, 'Slr0302 protein', NULL, NULL, NULL, NULL, NULL, 4),
(54613, NULL, 'G3DSA:1.50.40.10:FF:000094', NULL, NULL, 'Phosphate carrier protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(54614, NULL, 'G3DSA:2.130.10.10:FF:003677', NULL, NULL, 'Protein CBR-DAF-10', NULL, NULL, NULL, NULL, NULL, 4),
(54615, NULL, 'G3DSA:3.90.550.50:FF:000110', NULL, NULL, 'GD22797', NULL, NULL, NULL, NULL, NULL, 4),
(54616, NULL, 'G3DSA:3.40.50.11490:FF:000001', NULL, NULL, 'Chromo domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(54617, NULL, 'G3DSA:1.20.1250.20:FF:000657', NULL, NULL, 'Sugar transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(54618, NULL, 'G3DSA:1.10.8.430:FF:000009', NULL, NULL, 'Disease resistance protein CHS1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(54619, NULL, 'G3DSA:1.20.1070.10:FF:001415', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54620, NULL, 'G3DSA:2.30.30.140:FF:000309', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(54621, NULL, 'G3DSA:2.10.220.10:FF:000101', NULL, NULL, 'Fraser extracellular matrix complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(54622, NULL, 'G3DSA:3.50.50.60:FF:000936', NULL, NULL, 'Mercury(II) reductase', NULL, NULL, NULL, NULL, NULL, 4),
(54623, NULL, 'G3DSA:3.60.20.40:FF:000001', NULL, NULL, 'Gamma-glutamyltranspeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(54624, NULL, 'G3DSA:1.10.10.60:FF:000120', NULL, NULL, 'pogo transposable element with ZNF domain isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(54625, NULL, 'G3DSA:2.60.40.1130:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54626, NULL, 'G3DSA:1.25.40.470:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54627, NULL, 'G3DSA:3.90.79.20:FF:000011', NULL, NULL, 'NADH pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(54628, NULL, 'G3DSA:3.40.50.150:FF:000451', NULL, NULL, 'Probable methyltransferase PMT19', NULL, NULL, NULL, NULL, NULL, 4),
(54629, NULL, 'G3DSA:3.30.2130.30:FF:000029', NULL, NULL, 'Probable tRNA sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(54630, NULL, 'G3DSA:1.25.10.10:FF:000425', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(54631, NULL, 'G3DSA:3.30.70.330:FF:001961', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54632, NULL, 'G3DSA:2.10.270.10:FF:000014', NULL, NULL, 'Dextransucrase', NULL, NULL, NULL, NULL, NULL, 4),
(54633, NULL, 'G3DSA:3.40.50.150:FF:000142', NULL, NULL, 'Ubiquinone biosynthesis O-methyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(54634, NULL, 'G3DSA:1.20.1740.10:FF:000068', NULL, NULL, 'Branched-chain amino acid transport system carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(54635, NULL, 'G3DSA:1.10.510.10:FF:000481', NULL, NULL, 'Asator, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(54636, NULL, 'G3DSA:3.40.50.10490:FF:000139', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54637, NULL, 'G3DSA:2.130.10.10:FF:003368', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54638, NULL, 'G3DSA:3.90.420.10:FF:000010', NULL, NULL, 'DMSO/TMAO reductase YedYZ molybdopterin-dependent catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(54639, NULL, 'G3DSA:2.40.50.140:FF:001284', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54640, NULL, 'G3DSA:3.40.50.300:FF:002019', NULL, NULL, 'DNA helicase I', NULL, NULL, NULL, NULL, NULL, 4),
(54641, NULL, 'G3DSA:1.25.10.10:FF:003438', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54642, NULL, 'G3DSA:2.60.40.10:FF:002081', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(54643, NULL, 'G3DSA:3.30.930.10:FF:000394', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(54644, NULL, 'G3DSA:4.10.240.10:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54645, NULL, 'G3DSA:2.60.40.1120:FF:000006', NULL, NULL, 'Carboxypeptidase D', NULL, NULL, NULL, NULL, NULL, 4),
(54646, NULL, 'G3DSA:2.10.25.10:FF:000693', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(54647, NULL, 'G3DSA:1.10.20.10:FF:000302', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54648, NULL, 'G3DSA:3.30.479.20:FF:000038', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(54649, NULL, 'G3DSA:3.80.10.10:FF:003301', NULL, NULL, 'Si:ch73-236c18.2', NULL, NULL, NULL, NULL, NULL, 4),
(54650, NULL, 'G3DSA:2.170.190.11:FF:000016', NULL, NULL, 'Molybdenum cofactor synthesis domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(54651, NULL, 'G3DSA:3.40.50.200:FF:000180', NULL, NULL, 'Hypothetical phage protein', NULL, NULL, NULL, NULL, NULL, 4),
(54652, NULL, 'G3DSA:1.10.506.10:FF:000061', NULL, NULL, 'Plexin B3', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(54653, NULL, 'G3DSA:3.90.550.10:FF:000036', NULL, NULL, 'Dolichol-phosphate mannosyltransferase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(54654, NULL, 'G3DSA:3.90.550.20:FF:000039', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(54655, NULL, 'G3DSA:1.20.5.990:FF:000006', NULL, NULL, 'Centrosomal protein of 55 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(54656, NULL, 'G3DSA:3.40.50.2300:FF:000876', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54657, NULL, 'G3DSA:1.10.565.10:FF:000091', NULL, NULL, 'Retinoid x receptor', NULL, NULL, NULL, NULL, NULL, 4),
(54658, NULL, 'G3DSA:2.30.110.10:FF:000083', NULL, NULL, 'Flavin reductase domain protein FMN-binding', NULL, NULL, NULL, NULL, NULL, 4),
(54659, NULL, 'G3DSA:3.90.1290.10:FF:000015', NULL, NULL, 'dystonin isoform X7', NULL, NULL, NULL, NULL, NULL, 4),
(54660, NULL, 'G3DSA:2.130.10.10:FF:005931', NULL, NULL, 'TKL family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(54661, NULL, 'G3DSA:2.30.30.490:FF:000049', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(54662, NULL, 'G3DSA:3.30.9.10:FF:000074', NULL, NULL, 'FAD dependent oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(54663, NULL, 'G3DSA:1.25.40.10:FF:001809', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g29760, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(54664, NULL, 'G3DSA:1.20.272.10:FF:000003', NULL, NULL, 'DNA polymerase III subunit gamma/tau', NULL, NULL, NULL, NULL, NULL, 4),
(54665, NULL, 'G3DSA:1.25.40.120:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54666, NULL, 'G3DSA:2.40.50.140:FF:001194', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54667, NULL, 'G3DSA:3.30.70.100:FF:000167', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54668, NULL, 'G3DSA:2.40.30.180:FF:000010', NULL, NULL, 'Ubiquitin-activating enzyme E1', NULL, NULL, NULL, NULL, NULL, 4),
(54669, NULL, 'G3DSA:3.30.160.60:FF:000057', NULL, NULL, 'Zinc finger with KRAB and SCAN domains 4', NULL, NULL, NULL, NULL, NULL, 4),
(54670, NULL, 'G3DSA:1.10.510.10:FF:000711', NULL, NULL, 'Probable cyclin-dependent kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(54671, NULL, 'G3DSA:2.130.10.10:FF:005622', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(54672, NULL, 'G3DSA:3.40.630.30:FF:000419', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54673, NULL, 'G3DSA:1.20.5.650:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54674, NULL, 'G3DSA:3.20.20.70:FF:000079', NULL, NULL, 'GMP reductase', NULL, NULL, NULL, NULL, NULL, 4),
(54675, NULL, 'G3DSA:3.60.10.10:FF:000177', NULL, NULL, 'inositol polyphosphate 5-phosphatase K isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(54676, NULL, 'G3DSA:4.10.280.110:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54677, NULL, 'G3DSA:3.20.20.60:FF:000076', NULL, NULL, 'HpcH/HpaI aldolase/citrate lyase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(54678, NULL, 'G3DSA:1.50.10.10:FF:000137', NULL, NULL, 'ADL225Wp', NULL, NULL, NULL, NULL, NULL, 4),
(54679, NULL, 'G3DSA:2.10.25.10:FF:000783', NULL, NULL, 'Laminin subunit alpha-3', NULL, NULL, NULL, NULL, NULL, 4),
(54680, NULL, 'G3DSA:1.10.10.10:FF:001347', NULL, NULL, 'Cullin_family /Cullin_protein_neddylation_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(54681, NULL, 'G3DSA:1.20.58.60:FF:000639', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54682, NULL, 'G3DSA:3.40.50.10420:FF:000017', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(54683, NULL, 'G3DSA:3.80.10.10:FF:001047', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(54684, NULL, 'G3DSA:1.20.1270.420:FF:000004', NULL, NULL, 'Inhibitor of kappa light polypeptide gene enhancer in B-cells, kinase epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(54685, NULL, 'G3DSA:3.40.20.10:FF:000066', NULL, NULL, 'Secretory 24AB, isoform A', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(54686, NULL, 'G3DSA:3.30.1380.20:FF:000050', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(54687, NULL, 'G3DSA:2.40.128.20:FF:000017', NULL, NULL, 'OsWRKY4 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(54688, NULL, 'G3DSA:1.25.40.10:FF:001557', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(54689, NULL, 'G3DSA:2.60.40.1870:FF:000001', NULL, NULL, 'Interleukin-7 receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(54690, NULL, 'G3DSA:1.10.510.10:FF:003836', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54691, NULL, 'G3DSA:2.170.300.10:FF:000093', NULL, NULL, 'Netrin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(54692, NULL, 'G3DSA:3.40.50.11530:FF:000013', NULL, NULL, 'Si:ch211-207e14.4', NULL, NULL, NULL, NULL, NULL, 4),
(54693, NULL, 'G3DSA:3.80.10.10:FF:004392', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54694, NULL, 'G3DSA:2.60.40.10:FF:005857', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54695, NULL, 'G3DSA:3.30.1330.30:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54696, NULL, 'G3DSA:3.40.50.800:FF:000045', NULL, NULL, 'Threonine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(54697, NULL, 'G3DSA:3.40.1110.10:FF:000306', NULL, NULL, 'Calcium-transporting ATPase, endoplasmic reticulum-type', NULL, NULL, NULL, NULL, NULL, 4),
(54698, NULL, 'G3DSA:3.90.190.10:FF:000374', NULL, NULL, 'Protein-tyrosine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(54699, NULL, 'G3DSA:3.40.50.1110:FF:000154', NULL, NULL, 'GDSL esterase/lipase CPRD49', NULL, NULL, NULL, NULL, NULL, 4),
(54700, NULL, 'G3DSA:2.60.40.420:FF:000086', NULL, NULL, 'Multicopper oxidase abr1', NULL, NULL, NULL, NULL, NULL, 4),
(54701, NULL, 'G3DSA:2.130.10.10:FF:005257', NULL, NULL, 'WD repeat-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(54702, NULL, 'G3DSA:1.10.132.30:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54703, NULL, 'G3DSA:1.10.238.10:FF:000140', NULL, NULL, 'follistatin-related protein 5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(54704, NULL, 'G3DSA:2.60.40.10:FF:000153', NULL, NULL, 'Probable E3 ubiquitin-protein ligase MID2', NULL, NULL, NULL, NULL, NULL, 4),
(54705, NULL, 'G3DSA:1.10.510.10:FF:002190', NULL, NULL, 'Cyclin dependent kinase 16', NULL, NULL, NULL, NULL, NULL, 4),
(54706, NULL, 'G3DSA:2.40.10.10:FF:000371', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54707, NULL, 'G3DSA:3.30.870.10:FF:000006', NULL, NULL, 'CDP-diacylglycerol--serine O-phosphatidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(54708, NULL, 'G3DSA:1.25.70.10:FF:000002', NULL, NULL, 'transcription termination factor 3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(54709, NULL, 'G3DSA:3.40.50.300:FF:001856', NULL, NULL, 'RAS small monomeric GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(54710, NULL, 'G3DSA:1.10.510.10:FF:000149', NULL, NULL, 'phosphorylase b kinase gamma catalytic chain, liver/testis isoform', NULL, NULL, NULL, NULL, NULL, 4),
(54711, NULL, 'G3DSA:3.30.56.30:FF:000008', NULL, NULL, 'SRP19_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(54712, NULL, 'G3DSA:2.60.40.10:FF:004424', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54713, NULL, 'G3DSA:1.10.510.10:FF:004202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54714, NULL, 'G3DSA:3.80.10.10:FF:001300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54715, NULL, 'G3DSA:3.40.50.2300:FF:001281', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54716, NULL, 'G3DSA:1.10.510.10:FF:003584', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54717, NULL, 'G3DSA:2.60.120.10:FF:000251', NULL, NULL, 'cGMP-dependent protein kinase 1-3', NULL, NULL, NULL, NULL, NULL, 4),
(54718, NULL, 'G3DSA:3.40.50.10140:FF:000057', NULL, NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', NULL, NULL, NULL, NULL, NULL, 4),
(54719, NULL, 'G3DSA:2.60.120.920:FF:000115', NULL, NULL, 'Si:ch211-207e19.2', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(54720, NULL, 'G3DSA:1.10.10.2330:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54721, NULL, 'G3DSA:2.130.10.10:FF:002603', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54722, NULL, 'G3DSA:3.40.50.300:FF:005656', NULL, NULL, 'Putative DNA adenine methyltransferase and helicase, darB', NULL, NULL, NULL, NULL, NULL, 4),
(54723, NULL, 'G3DSA:3.40.50.300:FF:004262', NULL, NULL, 'AGAP013180-PA', NULL, NULL, NULL, NULL, NULL, 4),
(54724, NULL, 'G3DSA:3.30.160.60:FF:002311', NULL, NULL, 'zinc finger protein 236 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(54725, NULL, 'G3DSA:2.130.10.10:FF:001985', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit trm82', NULL, NULL, NULL, NULL, NULL, 4),
(54726, NULL, 'G3DSA:3.10.105.10:FF:000015', NULL, NULL, 'ABC transporter, substrate-binding protein, family 5', NULL, NULL, NULL, NULL, NULL, 4),
(54727, NULL, 'G3DSA:3.30.160.60:FF:001693', NULL, NULL, 'zinc finger and SCAN domain-containing protein 26 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(54728, NULL, 'G3DSA:1.10.4200.10:FF:000007', NULL, NULL, '2''-(5''''-triphosphoribosyl)-3''-dephospho-coenzyme A synthase', NULL, NULL, NULL, NULL, NULL, 4),
(54729, NULL, 'G3DSA:3.40.50.1760:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54730, NULL, 'G3DSA:2.60.120.40:FF:000012', NULL, NULL, 'Adipolin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(54731, NULL, 'G3DSA:2.60.120.290:FF:000095', NULL, NULL, 'LEV-10A protein', NULL, NULL, NULL, NULL, NULL, 4),
(54732, NULL, 'G3DSA:3.30.160.60:FF:005964', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54733, NULL, 'G3DSA:1.10.287.70:FF:000299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54734, NULL, 'G3DSA:3.40.630.20:FF:000001', NULL, NULL, 'Pyrrolidone-carboxylate peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(54735, NULL, 'G3DSA:3.30.160.60:FF:005493', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54736, NULL, 'G3DSA:1.10.238.200:FF:000003', NULL, NULL, 'DCN1-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(54737, NULL, 'G3DSA:1.10.1580.10:FF:000029', NULL, NULL, 'Guanine nucleotide-binding protein-like 3-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(54738, NULL, 'G3DSA:1.10.1670.40:FF:000017', NULL, NULL, 'DNA-3-methyladenine glycosidase II, putative', NULL, NULL, NULL, NULL, NULL, 4),
(54739, NULL, 'G3DSA:3.10.100.10:FF:000026', NULL, NULL, 'C-type mannose receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(54740, NULL, 'G3DSA:2.60.40.1730:FF:000083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54741, NULL, 'G3DSA:4.10.280.50:FF:000002', NULL, NULL, 'Glutamate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(54742, NULL, 'G3DSA:3.30.200.20:FF:001729', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54743, NULL, 'G3DSA:3.30.505.10:FF:000120', NULL, NULL, 'Tyrosine-protein kinase Fyn', NULL, NULL, NULL, NULL, NULL, 4),
(54744, NULL, 'G3DSA:2.40.50.140:FF:000210', NULL, NULL, 'Ribosomal protein S12 methylthiotransferase RimO', NULL, NULL, NULL, NULL, NULL, 4),
(54745, NULL, 'G3DSA:1.10.150.50:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54746, NULL, 'G3DSA:1.10.238.210:FF:000006', NULL, NULL, 'Putative glutaminase 2', NULL, NULL, NULL, NULL, NULL, 4),
(54747, NULL, 'G3DSA:2.70.98.30:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54748, NULL, 'G3DSA:1.25.10.10:FF:003219', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(54749, NULL, 'G3DSA:2.130.10.10:FF:005728', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54750, NULL, 'G3DSA:2.30.29.30:FF:001336', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54751, NULL, 'G3DSA:3.40.120.10:FF:000111', NULL, NULL, 'Probable phosphoribomutase', NULL, NULL, NULL, NULL, NULL, 4),
(54752, NULL, 'G3DSA:3.90.550.10:FF:000345', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(54753, NULL, 'G3DSA:1.20.1270.60:FF:000299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(54754, NULL, 'G3DSA:1.25.40.10:FF:003575', NULL, NULL, 'U6 snRNP complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(54755, NULL, 'G3DSA:2.30.30.220:FF:000002', NULL, NULL, 'ClpXP protease specificity-enhancing factor', NULL, NULL, NULL, NULL, NULL, 4),
(54756, NULL, 'G3DSA:2.10.220.10:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54757, NULL, 'G3DSA:1.10.510.10:FF:002403', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54758, NULL, 'G3DSA:2.30.30.140:FF:000276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54759, NULL, 'G3DSA:1.20.5.110:FF:000338', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54760, NULL, 'G3DSA:1.20.1560.10:FF:000447', NULL, NULL, 'AAA protein', NULL, NULL, NULL, NULL, NULL, 4),
(54761, NULL, 'G3DSA:1.10.510.10:FF:001785', NULL, NULL, 'Protein CBG00525', NULL, NULL, NULL, NULL, NULL, 4),
(54762, NULL, 'G3DSA:3.30.460.10:FF:000088', NULL, NULL, 'Protein HESO1', NULL, NULL, NULL, NULL, NULL, 4),
(54763, NULL, 'G3DSA:2.130.10.10:FF:001570', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(54764, NULL, 'G3DSA:3.40.50.300:FF:006061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54765, NULL, 'G3DSA:2.60.40.2240:FF:000011', NULL, NULL, 'Acyl-CoA thioesterase 4', NULL, NULL, NULL, NULL, NULL, 4),
(54766, NULL, 'G3DSA:1.10.1450.10:FF:000025', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(54767, NULL, 'G3DSA:1.25.40.10:FF:003917', NULL, NULL, 'Coatomer subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(54768, NULL, 'G3DSA:3.40.50.410:FF:000254', NULL, NULL, 'ANTXR cell adhesion molecule 1d', NULL, NULL, NULL, NULL, NULL, 4),
(54769, NULL, 'G3DSA:3.30.160.60:FF:004110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54770, NULL, 'G3DSA:3.60.110.10:FF:000095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54771, NULL, 'G3DSA:2.60.40.1480:FF:000007', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(54772, NULL, 'G3DSA:1.10.1740.10:FF:000036', NULL, NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(54773, NULL, 'G3DSA:1.10.10.60:FF:000119', NULL, NULL, 'Transcription factor GAMYB', NULL, NULL, NULL, NULL, NULL, 4),
(54774, NULL, 'G3DSA:3.30.70.100:FF:000077', NULL, NULL, 'Putative copper-transporting ATPase HMA5', NULL, NULL, NULL, NULL, NULL, 4),
(54775, NULL, 'G3DSA:1.20.1280.50:FF:000246', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(54776, NULL, 'G3DSA:3.40.1110.10:FF:000379', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54777, NULL, 'G3DSA:3.40.50.720:FF:000993', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(54778, NULL, 'G3DSA:3.60.10.10:FF:000267', NULL, NULL, 'Type IV inositol polyphosphate 5-phosphatase 6', NULL, NULL, NULL, NULL, NULL, 4),
(54779, NULL, 'G3DSA:3.30.310.130:FF:000012', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(54780, NULL, 'G3DSA:3.30.70.890:FF:000033', NULL, NULL, 'Phosphomevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(54781, NULL, 'G3DSA:1.10.1040.10:FF:000028', NULL, NULL, 'Mannitol 2-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(54782, NULL, 'G3DSA:1.10.565.10:FF:000181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54783, NULL, 'G3DSA:2.60.220.50:FF:000068', NULL, NULL, 'Adhesion G protein-coupled receptor G3', NULL, NULL, NULL, NULL, NULL, 4),
(54784, NULL, 'G3DSA:2.60.120.970:FF:000068', NULL, NULL, 'Nodal homolog 3-C', NULL, NULL, NULL, NULL, NULL, 4),
(54785, NULL, 'G3DSA:3.40.50.2300:FF:001039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54786, NULL, 'G3DSA:3.40.50.1220:FF:000097', NULL, NULL, 'Electron transfer flavoprotein alpha-subunit', NULL, NULL, NULL, NULL, NULL, 4),
(54787, NULL, 'G3DSA:2.20.110.10:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54788, NULL, 'G3DSA:3.30.70.330:FF:001742', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(54789, NULL, 'G3DSA:3.40.50.10130:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54790, NULL, 'G3DSA:3.30.160.60:FF:002165', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54791, NULL, 'G3DSA:3.30.70.580:FF:000041', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(54792, NULL, 'G3DSA:2.20.50.20:FF:000012', NULL, NULL, 'Vitellogenin-2', NULL, NULL, NULL, NULL, NULL, 4),
(54793, NULL, 'G3DSA:3.20.20.60:FF:000003', NULL, NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(54794, NULL, 'G3DSA:3.30.40.10:FF:000944', NULL, NULL, 'Lysine (K)-specific demethylase 5Ba', NULL, NULL, NULL, NULL, NULL, 4),
(54795, NULL, 'G3DSA:2.40.50.690:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54796, NULL, 'G3DSA:2.30.30.230:FF:000005', NULL, NULL, 'Fumarylacetoacetase', NULL, NULL, NULL, NULL, NULL, 4),
(54797, NULL, 'G3DSA:3.60.20.10:FF:000239', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54798, NULL, 'G3DSA:3.40.630.30:FF:000190', NULL, NULL, 'YGR111W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(54799, NULL, 'G3DSA:3.80.10.10:FF:002683', NULL, NULL, 'Receptor kinase-like protein Xa21', NULL, NULL, NULL, NULL, NULL, 4),
(54800, NULL, 'G3DSA:1.10.390.10:FF:000049', NULL, NULL, 'Transcription initiation factor TFIID subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(54801, NULL, 'G3DSA:3.40.50.300:FF:001946', NULL, NULL, 'DEAD box helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(54802, NULL, 'G3DSA:2.60.40.10:FF:000063', NULL, NULL, 'neural cell adhesion molecule L1', NULL, NULL, NULL, NULL, NULL, 4),
(54803, NULL, 'G3DSA:3.30.60.30:FF:000030', NULL, NULL, 'HtrA serine peptidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(54804, NULL, 'G3DSA:1.20.1250.20:FF:002259', NULL, NULL, 'Tetracycline-efflux transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(54805, NULL, 'G3DSA:1.25.40.10:FF:003356', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(54806, NULL, 'G3DSA:1.20.120.1070:FF:000014', NULL, NULL, 'Translation initiation factor eif-2B alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(54807, NULL, 'G3DSA:3.30.390.30:FF:000009', NULL, NULL, 'Pyridine nucleotide-disulfide oxidoreductase domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(54808, NULL, 'G3DSA:2.130.10.10:FF:005167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54809, NULL, 'G3DSA:2.60.120.920:FF:000205', NULL, NULL, 'Si:ch211-227p7.5', NULL, NULL, NULL, NULL, NULL, 4),
(54810, NULL, 'G3DSA:1.10.150.650:FF:000013', NULL, NULL, '3'',5''-nucleoside bisphosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(54811, NULL, 'G3DSA:2.40.30.10:FF:000170', NULL, NULL, 'Mitochondrial elongation factor Tu homologue', NULL, NULL, NULL, NULL, NULL, 4),
(54812, NULL, 'G3DSA:2.130.10.10:FF:005509', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54813, NULL, 'G3DSA:1.20.5.4770:FF:000003', NULL, NULL, 'OTU domain-containing protein 7B', NULL, NULL, NULL, NULL, NULL, 4),
(54814, NULL, 'G3DSA:2.30.31.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54815, NULL, 'G3DSA:2.60.40.10:FF:006004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54816, NULL, 'G3DSA:3.20.20.70:FF:000225', NULL, NULL, 'Thiamine-phosphate pyrophosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(54817, NULL, 'G3DSA:3.30.70.330:FF:001433', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54818, NULL, 'G3DSA:1.10.150.780:FF:000001', NULL, NULL, 'Vacuolar protein sorting-associated protein 16 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(54819, NULL, 'G3DSA:1.20.58.340:FF:000047', NULL, NULL, 'MGT2 magnesium transporter', NULL, NULL, NULL, NULL, NULL, 4),
(54820, NULL, 'G3DSA:3.40.1180.10:FF:000018', NULL, NULL, 'Alkyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(54821, NULL, 'G3DSA:1.10.286.20:FF:000001', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(54822, NULL, 'G3DSA:3.40.50.1460:FF:000129', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(54823, NULL, 'G3DSA:3.30.390.10:FF:000003', NULL, NULL, 'D-galactonate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(54824, NULL, 'G3DSA:1.20.1560.10:FF:000756', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54825, NULL, 'G3DSA:3.40.50.300:FF:006370', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54826, NULL, 'G3DSA:2.20.25.10:FF:000024', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(54827, NULL, 'G3DSA:1.20.120.1080:FF:000017', NULL, NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(54828, NULL, 'G3DSA:3.40.720.10:FF:000224', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(54829, NULL, 'G3DSA:3.40.800.10:FF:000011', NULL, NULL, 'Arginase-1', NULL, NULL, NULL, NULL, NULL, 4),
(54830, NULL, 'G3DSA:2.60.40.1730:FF:000116', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54831, NULL, 'G3DSA:1.10.274.80:FF:000002', NULL, NULL, 'Toxin B', NULL, NULL, NULL, NULL, NULL, 4),
(54832, NULL, 'G3DSA:3.40.1280.30:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54833, NULL, 'G3DSA:3.40.50.2000:FF:001073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54834, NULL, 'G3DSA:3.30.420.40:FF:000072', NULL, NULL, 'Pantothenate kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(54835, NULL, 'G3DSA:3.40.1800.20:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54836, NULL, 'G3DSA:2.60.200.40:FF:000047', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(54837, NULL, 'G3DSA:3.20.20.140:FF:000290', NULL, NULL, 'Phosphoesterase-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(54838, NULL, 'G3DSA:3.30.200.20:FF:001078', NULL, NULL, 'Putative cyclin-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(54839, NULL, 'G3DSA:3.40.800.20:FF:000014', NULL, NULL, 'Histone deacetylase 15', NULL, NULL, NULL, NULL, NULL, 4),
(54840, NULL, 'G3DSA:2.60.40.10:FF:005751', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54841, NULL, 'G3DSA:1.25.40.180:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54842, NULL, 'G3DSA:3.90.190.10:FF:000284', NULL, NULL, 'Dual specificity protein phosphatase 5', NULL, NULL, NULL, NULL, NULL, 4),
(54843, NULL, 'G3DSA:2.10.90.10:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54844, NULL, 'G3DSA:2.130.10.10:FF:001766', NULL, NULL, 'Transcription factor C subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(54845, NULL, 'G3DSA:2.60.40.10:FF:000372', NULL, NULL, 'Myosin light chain kinase, smooth muscle', NULL, NULL, NULL, NULL, NULL, 4),
(54846, NULL, 'G3DSA:3.40.50.300:FF:005908', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(54847, NULL, 'G3DSA:2.70.150.10:FF:000025', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(54848, NULL, 'G3DSA:2.60.40.10:FF:005970', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54849, NULL, 'G3DSA:2.60.200.20:FF:000260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54850, NULL, 'G3DSA:3.30.365.10:FF:000018', NULL, NULL, 'Xanthine dehydrogenase yagR molybdenum-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(54851, NULL, 'G3DSA:3.30.450.260:FF:000003', NULL, NULL, 'Soluble guanylate cyclase gcy-32', NULL, NULL, NULL, NULL, NULL, 4),
(54852, NULL, 'G3DSA:2.60.40.10:FF:005509', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54853, NULL, 'G3DSA:3.20.20.70:FF:000534', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54854, NULL, 'G3DSA:2.80.10.50:FF:000252', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(54855, NULL, 'G3DSA:3.40.50.150:FF:000029', NULL, NULL, 'Protein arginine N-methyltransferase 5', NULL, NULL, NULL, NULL, NULL, 4),
(54856, NULL, 'G3DSA:3.40.30.10:FF:000016', NULL, NULL, 'Glutathione S-transferase F2', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(54857, NULL, 'G3DSA:1.20.1420.30:FF:000010', NULL, NULL, 'Na+/Ca+ antiporter, CaCA family', NULL, NULL, NULL, NULL, NULL, 4),
(54858, NULL, 'G3DSA:3.30.505.10:FF:000007', NULL, NULL, 'E3 ubiquitin-protein ligase CBL', NULL, NULL, NULL, NULL, NULL, 4),
(54859, NULL, 'G3DSA:2.10.70.10:FF:000179', NULL, NULL, 'sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(54860, NULL, 'G3DSA:3.30.160.60:FF:002530', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(54861, NULL, 'G3DSA:3.40.33.10:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54862, NULL, 'G3DSA:3.80.10.10:FF:002593', NULL, NULL, 'NLR family CARD domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(54863, NULL, 'G3DSA:2.60.200.20:FF:000041', NULL, NULL, 'Protein phosphatase 2C 11', NULL, NULL, NULL, NULL, NULL, 4),
(54864, NULL, 'G3DSA:2.40.10.10:FF:000062', NULL, NULL, 'mannan-binding lectin serine protease 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(54865, NULL, 'G3DSA:2.40.270.10:FF:000007', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(54866, NULL, 'G3DSA:1.10.630.10:FF:000765', NULL, NULL, 'Cytochrome P450, family 7, subfamily B, polypeptide 1', NULL, NULL, NULL, NULL, NULL, 4),
(54867, NULL, 'G3DSA:1.25.40.10:FF:003047', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(54868, NULL, 'G3DSA:3.60.40.10:FF:000347', NULL, NULL, 'Os03g0104100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(54869, NULL, 'G3DSA:2.130.10.10:FF:005476', NULL, NULL, 'WD repeat-containing protein 3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(54870, NULL, 'G3DSA:3.40.1050.10:FF:000014', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(54871, NULL, 'G3DSA:3.40.50.10810:FF:000027', NULL, NULL, 'helicase-like transcription factor isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(54872, NULL, 'G3DSA:3.90.1150.170:FF:000001', NULL, NULL, 'Glutamate decarboxylase like 1', NULL, NULL, NULL, NULL, NULL, 4),
(54873, NULL, 'G3DSA:2.130.10.10:FF:002042', NULL, NULL, 'Chromatin assembly factor 1 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(54874, NULL, 'G3DSA:1.10.540.10:FF:000011', NULL, NULL, 'Predicted acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(54875, NULL, 'G3DSA:1.20.1110.10:FF:000172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54876, NULL, 'G3DSA:1.20.890.10:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(54877, NULL, 'G3DSA:3.30.20.10:FF:000004', NULL, NULL, 'Chitinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(54878, NULL, 'G3DSA:2.60.40.150:FF:000313', NULL, NULL, 'Putative ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(54879, NULL, 'G3DSA:3.30.1490.20:FF:000036', NULL, NULL, 'Phosphoribosylamine--glycine ligase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(54880, NULL, 'G3DSA:2.20.28.10:FF:000047', NULL, NULL, 'Rapid-growth-like protein 42', NULL, NULL, NULL, NULL, NULL, 4),
(54881, NULL, 'G3DSA:3.40.50.1440:FF:000123', NULL, NULL, 'Miscellaneous Zn(II)2Cys6 transcription factor (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(54882, NULL, 'G3DSA:2.60.120.10:FF:000812', NULL, NULL, 'Protein kinase, cAMP-dependent, regulatory, type II, alpha, B', NULL, NULL, NULL, NULL, NULL, 4),
(54883, NULL, 'G3DSA:3.40.50.2300:FF:001258', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54884, NULL, 'G3DSA:3.40.640.10:FF:000133', NULL, NULL, 'Dihydrodipicolinate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(54885, NULL, 'G3DSA:3.40.50.1000:FF:000014', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(54886, NULL, 'G3DSA:2.130.10.10:FF:001457', NULL, NULL, 'GM11645', NULL, NULL, NULL, NULL, NULL, 4),
(54887, NULL, 'G3DSA:3.30.200.20:FF:001387', NULL, NULL, 'Protein CBG16237', NULL, NULL, NULL, NULL, NULL, 4),
(54888, NULL, 'G3DSA:2.130.10.10:FF:005818', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(54889, NULL, 'G3DSA:2.60.120.10:FF:000470', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(54890, NULL, 'G3DSA:2.60.120.680:FF:000009', NULL, NULL, 'Blast:Protein real-time', NULL, NULL, NULL, NULL, NULL, 4),
(54891, NULL, 'G3DSA:2.30.30.40:FF:000011', NULL, NULL, 'Microtubule-actin cross-linking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(54892, NULL, 'G3DSA:1.10.8.10:FF:000166', NULL, NULL, 'RAD23A isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(54893, NULL, 'G3DSA:2.70.170.10:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54894, NULL, 'G3DSA:1.10.630.10:FF:000456', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54895, NULL, 'G3DSA:2.30.40.10:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54896, NULL, 'G3DSA:2.30.29.30:FF:000864', NULL, NULL, 'GM23249p', NULL, NULL, NULL, NULL, NULL, 4),
(54897, NULL, 'G3DSA:3.40.930.10:FF:000015', NULL, NULL, 'Anion exchange protein', NULL, NULL, NULL, NULL, NULL, 4),
(54898, NULL, 'G3DSA:3.40.50.300:FF:006151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54899, NULL, 'G3DSA:3.50.50.60:FF:001318', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54900, NULL, 'G3DSA:1.10.30.10:FF:000022', NULL, NULL, 'nucleolar transcription factor 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(54901, NULL, 'G3DSA:2.10.60.10:FF:000044', NULL, NULL, 'Serine/threonine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(54902, NULL, 'G3DSA:3.60.40.10:FF:000095', NULL, NULL, 'Protein phosphatase PPM9', NULL, NULL, NULL, NULL, NULL, 4),
(54903, NULL, 'G3DSA:3.10.580.10:FF:000039', NULL, NULL, 'Putative arabinose 5-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(54904, NULL, 'G3DSA:3.70.10.10:FF:000058', NULL, NULL, 'Cell cycle checkpoint protein hpr-9', NULL, NULL, NULL, NULL, NULL, 4),
(54905, NULL, 'G3DSA:4.10.40.20:FF:000007', NULL, NULL, 'Insulin-like growth factor-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(54906, NULL, 'G3DSA:1.25.40.180:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54907, NULL, 'G3DSA:2.10.220.10:FF:000207', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(54908, NULL, 'G3DSA:3.20.20.80:FF:000537', NULL, NULL, 'Glucan 1,6-alpha-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(54909, NULL, 'G3DSA:1.10.510.10:FF:002280', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54910, NULL, 'G3DSA:3.30.70.330:FF:001523', NULL, NULL, 'mRNA-binding ribosome biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(54911, NULL, 'G3DSA:2.60.40.150:FF:000061', NULL, NULL, 'dysferlin isoform X8', NULL, NULL, NULL, NULL, NULL, 4),
(54912, NULL, 'G3DSA:1.10.10.10:FF:001802', NULL, NULL, 'Selenocysteine-specific translation elongation factor', NULL, NULL, NULL, NULL, NULL, 4),
(54913, NULL, 'G3DSA:3.30.930.10:FF:000208', NULL, NULL, 'Glycine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(54914, NULL, 'G3DSA:2.60.120.10:FF:000357', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(54915, NULL, 'G3DSA:1.25.40.10:FF:005166', NULL, NULL, 'TPR domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(54916, NULL, 'G3DSA:1.10.1220.10:FF:000014', NULL, NULL, 'Antitoxin VapB41', NULL, NULL, NULL, NULL, NULL, 4),
(54917, NULL, 'G3DSA:1.10.238.20:FF:000019', NULL, NULL, 'GEO07291p1', NULL, NULL, NULL, NULL, NULL, 4),
(54918, NULL, 'G3DSA:1.20.1070.10:FF:000359', NULL, NULL, 'opsin, ultraviolet-sensitive', NULL, NULL, NULL, NULL, NULL, 4),
(54919, NULL, 'G3DSA:3.40.50.2300:FF:000887', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54920, NULL, 'G3DSA:3.10.490.20:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54921, NULL, 'G3DSA:1.20.1260.10:FF:000059', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(54922, NULL, 'G3DSA:4.10.110.10:FF:000006', NULL, NULL, 'Trefoil factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(54923, NULL, 'G3DSA:3.30.2170.10:FF:000003', NULL, NULL, 'Endonuclease V', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(54924, NULL, 'G3DSA:3.40.50.261:FF:000030', NULL, NULL, 'Acyl-CoA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(54925, NULL, 'G3DSA:3.30.160.60:FF:001575', NULL, NULL, 'zinc finger protein 646', NULL, NULL, NULL, NULL, NULL, 4),
(54926, NULL, 'G3DSA:3.80.10.10:FF:002688', NULL, NULL, 'Receptor-like protein kinase HSL1', NULL, NULL, NULL, NULL, NULL, 4),
(54927, NULL, 'G3DSA:3.30.70.890:FF:000050', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(54928, NULL, 'G3DSA:2.60.40.150:FF:000521', NULL, NULL, 'Rho GTPase-activating protein gacEE', NULL, NULL, NULL, NULL, NULL, 4),
(54929, NULL, 'G3DSA:1.50.10.10:FF:000154', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(54930, NULL, 'G3DSA:1.10.510.10:FF:004320', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54931, NULL, 'G3DSA:3.10.100.10:FF:000150', NULL, NULL, 'Mannose receptor, C type 2', NULL, NULL, NULL, NULL, NULL, 4),
(54932, NULL, 'G3DSA:3.30.160.60:FF:003699', NULL, NULL, 'D4, zinc and double PHD fingers family 1', NULL, NULL, NULL, NULL, NULL, 4),
(54933, NULL, 'G3DSA:3.40.50.300:FF:007909', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54934, NULL, 'G3DSA:3.40.50.620:FF:000867', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54935, NULL, 'G3DSA:3.20.20.70:FF:000539', NULL, NULL, 'L-lactate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(54936, NULL, 'G3DSA:1.25.10.10:FF:001965', NULL, NULL, 'NIMA related kinase 10', NULL, NULL, NULL, NULL, NULL, 4),
(54937, NULL, 'G3DSA:1.10.286.20:FF:000006', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(54938, NULL, 'G3DSA:2.20.70.30:FF:000005', NULL, NULL, 'Nascent polypeptide-associated complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(54939, NULL, 'G3DSA:1.25.40.20:FF:000273', NULL, NULL, 'Ankyrin repeat domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(54940, NULL, 'G3DSA:1.10.510.10:FF:002066', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(54941, NULL, 'G3DSA:3.40.50.300:FF:002008', NULL, NULL, 'Uridine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(54942, NULL, 'G3DSA:2.10.70.10:FF:000191', NULL, NULL, 'kielin/chordin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(54943, NULL, 'G3DSA:1.10.10.10:FF:001908', NULL, NULL, 'Os04g0176200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(54944, NULL, 'G3DSA:3.40.50.410:FF:000029', NULL, NULL, 'Cochlin', NULL, NULL, NULL, NULL, NULL, 4),
(54945, NULL, 'G3DSA:2.20.25.10:FF:000035', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(54946, NULL, 'G3DSA:3.40.50.1820:FF:001007', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(54947, NULL, 'G3DSA:3.80.10.10:FF:001165', NULL, NULL, 'Receptor kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(54948, NULL, 'G3DSA:3.40.50.720:FF:001061', NULL, NULL, 'Potassium transporter peripheral membrane component', NULL, NULL, NULL, NULL, NULL, 4),
(54949, NULL, 'G3DSA:3.50.50.60:FF:001420', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54950, NULL, 'G3DSA:3.30.70.1230:FF:000035', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(54951, NULL, 'G3DSA:1.10.472.130:FF:000071', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(54952, NULL, 'G3DSA:1.10.150.50:FF:000072', NULL, NULL, 'Sexual stage-specific protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(54953, NULL, 'G3DSA:3.30.40.10:FF:001427', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54954, NULL, 'G3DSA:1.20.120.350:FF:000139', NULL, NULL, 'Putative calcium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(54955, NULL, 'G3DSA:2.40.30.130:FF:000006', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(54956, NULL, 'G3DSA:1.10.238.10:FF:000016', NULL, NULL, 'Dystrobrevin alpha', NULL, NULL, NULL, NULL, NULL, 4),
(54957, NULL, 'G3DSA:1.10.238.200:FF:000014', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(54958, NULL, 'G3DSA:1.10.442.10:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54959, NULL, 'G3DSA:1.10.246.130:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54960, NULL, 'G3DSA:2.130.10.10:FF:005268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54961, NULL, 'G3DSA:3.30.70.340:FF:000003', NULL, NULL, 'Carboxypeptidase B2', NULL, NULL, NULL, NULL, NULL, 4),
(54962, NULL, 'G3DSA:1.50.40.10:FF:000077', NULL, NULL, 'Mitochondrial dicarboxylate carrier', NULL, NULL, NULL, NULL, NULL, 4),
(54963, NULL, 'G3DSA:1.10.510.10:FF:003589', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54964, NULL, 'G3DSA:3.20.20.370:FF:000026', NULL, NULL, 'Hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(54965, NULL, 'G3DSA:1.25.10.10:FF:001286', NULL, NULL, 'Importin subunit alpha-1', NULL, NULL, NULL, NULL, NULL, 4),
(54966, NULL, 'G3DSA:3.20.20.80:FF:000447', NULL, NULL, 'Putative beta-glucosidase 41', NULL, NULL, NULL, NULL, NULL, 4),
(54967, NULL, 'G3DSA:3.30.190.20:FF:000019', NULL, NULL, 'Mitochondrial Ribosomal Protein, Large', NULL, NULL, NULL, NULL, NULL, 4),
(54968, NULL, 'G3DSA:2.40.110.10:FF:000041', NULL, NULL, 'Acyl-CoA dehydrogenase FadE18', NULL, NULL, NULL, NULL, NULL, 4),
(54969, NULL, 'G3DSA:2.60.40.10:FF:006021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54970, NULL, 'G3DSA:3.20.20.140:FF:000188', NULL, NULL, 'RNA-binding RNA processing protein', NULL, NULL, NULL, NULL, NULL, 4),
(54971, NULL, 'G3DSA:2.80.10.50:FF:000044', NULL, NULL, 'Dolichyl-phosphate-mannose-protein mannosyltransferase 4', NULL, NULL, NULL, NULL, NULL, 4),
(54972, NULL, 'G3DSA:2.40.30.10:FF:000501', NULL, NULL, 'NADH-cytochrome b5 reductase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(54973, NULL, 'G3DSA:3.40.50.10190:FF:000252', NULL, NULL, 'YALI0B15576p', NULL, NULL, NULL, NULL, NULL, 4),
(54974, NULL, 'G3DSA:3.50.50.60:FF:000689', NULL, NULL, 'Phytoene dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(54975, NULL, 'G3DSA:1.25.40.10:FF:001793', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(54976, NULL, 'G3DSA:1.10.287.70:FF:000765', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(54977, NULL, 'G3DSA:3.40.720.10:FF:000331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54978, NULL, 'G3DSA:1.20.1250.20:FF:000674', NULL, NULL, 'Major facilitator superfamily transporter', NULL, NULL, NULL, NULL, NULL, 4),
(54979, NULL, 'G3DSA:1.10.510.10:FF:000621', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(54980, NULL, 'G3DSA:3.40.1110.10:FF:000177', NULL, NULL, 'Potassium/sodium eff', NULL, NULL, NULL, NULL, NULL, 4),
(54981, NULL, 'G3DSA:2.60.40.60:FF:000038', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(54982, NULL, 'G3DSA:3.40.50.1820:FF:000395', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(54983, NULL, 'G3DSA:3.30.160.60:FF:004430', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54984, NULL, 'G3DSA:2.60.40.1180:FF:000114', NULL, NULL, 'Alpha-amylase', NULL, NULL, NULL, NULL, NULL, 4),
(54985, NULL, 'G3DSA:2.20.100.10:FF:000096', NULL, NULL, 'Cartilage intermediate layer protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(54986, NULL, 'G3DSA:3.20.20.70:FF:000444', NULL, NULL, '3-dehydroquinate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(54987, NULL, 'G3DSA:1.25.40.20:FF:001796', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54988, NULL, 'G3DSA:2.30.29.30:FF:000954', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54989, NULL, 'G3DSA:2.60.40.10:FF:005841', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(54990, NULL, 'G3DSA:3.40.50.150:FF:001199', NULL, NULL, '3-hydroxy-5-methyl-1-naphthoate 3-O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(54991, NULL, 'G3DSA:3.40.50.10480:FF:000018', NULL, NULL, 'U3 small nucleolar ribonucleoprotein protein IMP4, putative (AFU_orthologue AFUA_1G13070)', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(54992, NULL, 'G3DSA:3.40.50.300:FF:005774', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54993, NULL, 'G3DSA:2.110.10.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54994, NULL, 'G3DSA:3.30.479.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(54995, NULL, 'G3DSA:2.130.10.10:FF:005482', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(54996, NULL, 'G3DSA:2.60.40.10:FF:000714', NULL, NULL, 'Titin novex-3', NULL, NULL, NULL, NULL, NULL, 4),
(54997, NULL, 'G3DSA:3.40.50.300:FF:001396', NULL, NULL, 'Structural maintenance of chromosomes protein', NULL, NULL, NULL, NULL, NULL, 4),
(54998, NULL, 'G3DSA:1.20.1070.10:FF:001511', NULL, NULL, 'Growth hormone secretagogue receptor', NULL, NULL, NULL, NULL, NULL, 4),
(54999, NULL, 'G3DSA:3.40.50.140:FF:000010', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(55000, NULL, 'G3DSA:3.30.160.60:FF:000052', NULL, NULL, 'zinc finger protein 546 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(55001, NULL, 'G3DSA:3.30.40.10:FF:000489', NULL, NULL, 'E3 ubiquitin-protein ligase PRT1', NULL, NULL, NULL, NULL, NULL, 4),
(55002, NULL, 'G3DSA:3.50.50.60:FF:001195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55003, NULL, 'G3DSA:1.10.555.10:FF:000135', NULL, NULL, 'Rho GTPase-activating protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(55004, NULL, 'G3DSA:1.20.1600.10:FF:000029', NULL, NULL, 'Outer membrane secretion protein', NULL, NULL, NULL, NULL, NULL, 4),
(55005, NULL, 'G3DSA:3.40.50.2000:FF:000999', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(55006, NULL, 'G3DSA:1.20.1250.20:FF:001612', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55007, NULL, 'G3DSA:2.170.150.80:FF:000016', NULL, NULL, 'Apical meristem formation protein-related', NULL, NULL, NULL, NULL, NULL, 4),
(55008, NULL, 'G3DSA:1.10.1240.10:FF:000009', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(55009, NULL, 'G3DSA:1.10.1410.10:FF:000040', NULL, NULL, 'Poly(U) Polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(55010, NULL, 'G3DSA:1.10.520.10:FF:000009', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(55011, NULL, 'G3DSA:3.90.550.20:FF:000034', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55012, NULL, 'G3DSA:3.40.50.10470:FF:000015', NULL, NULL, 'Eukaryotic translation initiation factor 2B subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(55013, NULL, 'G3DSA:1.25.40.20:FF:001807', NULL, NULL, 'Stress-activated protein kinase alpha', NULL, NULL, NULL, NULL, NULL, 4),
(55014, NULL, 'G3DSA:2.60.120.920:FF:000104', NULL, NULL, 'E3 ubiquitin-protein ligase RNF123', NULL, NULL, NULL, NULL, NULL, 4),
(55015, NULL, 'G3DSA:2.10.25.10:FF:000564', NULL, NULL, 'Fibulin 2', NULL, NULL, NULL, NULL, NULL, 4),
(55016, NULL, 'G3DSA:1.20.58.390:FF:000023', NULL, NULL, 'Nicotinic acetylcholine receptor subunit alpha6', NULL, NULL, NULL, NULL, NULL, 4),
(55017, NULL, 'G3DSA:3.30.160.60:FF:002401', NULL, NULL, 'zinc finger protein 39', NULL, NULL, NULL, NULL, NULL, 4),
(55018, NULL, 'G3DSA:1.25.40.10:FF:001804', NULL, NULL, 'Tetratricopeptide repeat protein 30 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(55019, NULL, 'G3DSA:3.10.50.40:FF:000140', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(55020, NULL, 'G3DSA:1.20.1250.20:FF:000769', NULL, NULL, 'Protein CBR-ENT-2', NULL, NULL, NULL, NULL, NULL, 4),
(55021, NULL, 'G3DSA:3.80.10.10:FF:000890', NULL, NULL, 'Toll-like receptor 7', NULL, NULL, NULL, NULL, NULL, 4),
(55022, NULL, 'G3DSA:3.90.190.10:FF:000514', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55023, NULL, 'G3DSA:1.10.30.10:FF:000027', NULL, NULL, 'Transcription factor SOX-30', NULL, NULL, NULL, NULL, NULL, 4),
(55024, NULL, 'G3DSA:1.20.5.110:FF:000209', NULL, NULL, 'Si:ch211-208k15.1', NULL, NULL, NULL, NULL, NULL, 4),
(55025, NULL, 'G3DSA:3.40.50.1700:FF:000033', NULL, NULL, 'Beta-glucosidase (Gentiobiase)', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(55026, NULL, 'G3DSA:2.130.10.10:FF:001783', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55027, NULL, 'G3DSA:3.10.290.10:FF:000028', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(55028, NULL, 'G3DSA:3.30.160.60:FF:002513', NULL, NULL, 'Zinc finger protein 606', NULL, NULL, NULL, NULL, NULL, 4),
(55029, NULL, 'G3DSA:3.40.140.10:FF:000123', NULL, NULL, 'Cytidine deaminase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55030, NULL, 'G3DSA:1.10.10.10:FF:000032', NULL, NULL, 'Forkhead box protein O4', NULL, NULL, NULL, NULL, NULL, 4),
(55031, NULL, 'G3DSA:3.50.30.30:FF:000033', NULL, NULL, 'Glutamate carboxypeptidase 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(55032, NULL, 'G3DSA:1.10.510.10:FF:004106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55033, NULL, 'G3DSA:3.90.550.10:FF:000031', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(55034, NULL, 'G3DSA:3.30.1360.180:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55035, NULL, 'G3DSA:3.30.810.10:FF:000019', NULL, NULL, 'Putative 1-phosphatidylinositol-4-phosphate 5-kinase/ zinc ion binding family', NULL, NULL, NULL, NULL, NULL, 4),
(55036, NULL, 'G3DSA:6.10.140.2220:FF:000080', NULL, NULL, 'Protein 5NUC-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(55037, NULL, 'G3DSA:3.60.21.10:FF:000180', NULL, NULL, 'Acid sphingomyelinase family phosphodiesterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55038, NULL, 'G3DSA:3.30.1490.20:FF:000053', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(55039, NULL, 'G3DSA:3.30.530.20:FF:000203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55040, NULL, 'G3DSA:1.10.630.10:FF:000782', NULL, NULL, 'Os09g0530275 protein', NULL, NULL, NULL, NULL, NULL, 4),
(55041, NULL, 'G3DSA:2.130.10.10:FF:004071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55042, NULL, 'G3DSA:1.10.510.10:FF:003494', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55043, NULL, 'G3DSA:3.30.930.10:FF:000085', NULL, NULL, 'Serine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(55044, NULL, 'G3DSA:3.30.1360.170:FF:000010', NULL, NULL, 'Thymidylate synthase complementing protein ThyX', NULL, NULL, NULL, NULL, NULL, 4),
(55045, NULL, 'G3DSA:1.10.405.10:FF:000040', NULL, NULL, 'L-amino-acid oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(55046, NULL, 'G3DSA:1.20.120.790:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55047, NULL, 'G3DSA:2.30.30.40:FF:000022', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(55048, NULL, 'G3DSA:3.50.50.60:FF:000104', NULL, NULL, 'Squalene monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(55049, NULL, 'G3DSA:3.30.428.30:FF:000002', NULL, NULL, 'CDP-diacylglycerol pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(55050, NULL, 'G3DSA:3.30.470.10:FF:000049', NULL, NULL, 'Probable branched-chain amino acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(55051, NULL, 'G3DSA:1.20.58.530:FF:000003', NULL, NULL, 'Myosin heavy chain 10', NULL, NULL, NULL, NULL, NULL, 4),
(55052, NULL, 'G3DSA:3.40.930.10:FF:000026', NULL, NULL, 'Nitrogen regulatory IIA protein', NULL, NULL, NULL, NULL, NULL, 4),
(55053, NULL, 'G3DSA:2.60.120.10:FF:000571', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(55054, NULL, 'G3DSA:1.10.418.10:FF:000114', NULL, NULL, 'Protein Hook homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(55055, NULL, 'G3DSA:3.40.50.10190:FF:000038', NULL, NULL, 'SMC5-SMC6 complex localization factor protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(55056, NULL, 'G3DSA:3.40.50.300:FF:002334', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(55057, NULL, 'G3DSA:2.60.40.10:FF:001816', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(55058, NULL, 'G3DSA:1.10.101.10:FF:000008', NULL, NULL, 'Probable CtpA-like serine protease', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(55059, NULL, 'G3DSA:2.60.40.10:FF:001928', NULL, NULL, 'neuroglian isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(55060, NULL, 'G3DSA:3.30.450.20:FF:000169', NULL, NULL, 'Bacteriophytochrome protein', NULL, NULL, NULL, NULL, NULL, 4),
(55061, NULL, 'G3DSA:2.10.25.10:FF:000917', NULL, NULL, 'Fibrillin-1', NULL, NULL, NULL, NULL, NULL, 4),
(55062, NULL, 'G3DSA:1.20.140.10:FF:000074', NULL, NULL, 'GD11444', NULL, NULL, NULL, NULL, NULL, 4),
(55063, NULL, 'G3DSA:1.20.58.240:FF:000006', NULL, NULL, 'Signal transducer and activator of transcription A', NULL, NULL, NULL, NULL, NULL, 4),
(55064, NULL, 'G3DSA:3.30.505.10:FF:000136', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55065, NULL, 'G3DSA:3.80.10.10:FF:003205', NULL, NULL, 'Decorin', NULL, NULL, NULL, NULL, NULL, 4),
(55066, NULL, 'G3DSA:1.20.1000.10:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55067, NULL, 'G3DSA:2.160.20.10:FF:000040', NULL, NULL, 'Probable exopolygalacturonase B', NULL, NULL, NULL, NULL, NULL, 4),
(55068, NULL, 'G3DSA:3.40.50.850:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55069, NULL, 'G3DSA:1.20.190.50:FF:000010', NULL, NULL, 'Nuclear pore complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(55070, NULL, 'G3DSA:3.30.70.330:FF:000697', NULL, NULL, 'Nucleic acid binding', NULL, NULL, NULL, NULL, NULL, 4),
(55071, NULL, 'G3DSA:1.10.418.20:FF:000005', NULL, NULL, 'sentrin-specific protease 6 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(55072, NULL, 'G3DSA:3.30.70.330:FF:001186', NULL, NULL, 'RNA-binding protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(55073, NULL, 'G3DSA:3.30.60.30:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55074, NULL, 'G3DSA:2.120.10.30:FF:000210', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(55075, NULL, 'G3DSA:2.60.40.650:FF:000025', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55076, NULL, 'G3DSA:2.60.40.10:FF:003587', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55077, NULL, 'G3DSA:1.10.1200.120:FF:000011', NULL, NULL, 'Large conductance mechanosensitive channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(55078, NULL, 'G3DSA:1.10.132.70:FF:000013', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(55079, NULL, 'G3DSA:3.20.20.70:FF:000332', NULL, NULL, 'Phospho-2-dehydro-3-deoxyheptonate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(55080, NULL, 'G3DSA:1.20.5.110:FF:000198', NULL, NULL, 'Qb+Qc-SNARE, SNAP33-family', NULL, NULL, NULL, NULL, NULL, 4),
(55081, NULL, 'G3DSA:3.30.565.10:FF:000224', NULL, NULL, 'Sensor kinase CitA', NULL, NULL, NULL, NULL, NULL, 4),
(55082, NULL, 'G3DSA:3.90.550.10:FF:000126', NULL, NULL, 'Exostosin glycosyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(55083, NULL, 'G3DSA:2.60.120.620:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55084, NULL, 'G3DSA:2.130.10.10:FF:001906', NULL, NULL, 'Uncharacterized WD repeat-containing protein C343.04c', NULL, NULL, NULL, NULL, NULL, 4),
(55085, NULL, 'G3DSA:1.20.1280.50:FF:000140', NULL, NULL, 'F-box/SPRY domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(55086, NULL, 'G3DSA:1.10.132.60:FF:000010', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(55087, NULL, 'G3DSA:3.40.50.1820:FF:001333', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55088, NULL, 'G3DSA:3.30.160.60:FF:003492', NULL, NULL, 'GD18769', NULL, NULL, NULL, NULL, NULL, 4),
(55089, NULL, 'G3DSA:3.90.190.10:FF:000609', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55090, NULL, 'G3DSA:3.40.50.1400:FF:000033', NULL, NULL, 'Sirohydrochlorin cobaltochelatase CbiKC', NULL, NULL, NULL, NULL, NULL, 4),
(55091, NULL, 'G3DSA:1.20.1560.10:FF:000655', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55092, NULL, 'G3DSA:1.25.40.10:FF:001681', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g33170 family', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(55093, NULL, 'G3DSA:3.30.160.60:FF:002390', NULL, NULL, 'zinc finger protein 404 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(55094, NULL, 'G3DSA:2.60.40.420:FF:000187', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55095, NULL, 'G3DSA:3.30.160.60:FF:000147', NULL, NULL, 'POZ-, AT hook-, and zinc finger-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(55096, NULL, 'G3DSA:2.70.150.10:FF:000014', NULL, NULL, 'Calcium-transporting ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55097, NULL, 'G3DSA:3.90.245.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55098, NULL, 'G3DSA:2.60.120.200:FF:000782', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(55099, NULL, 'G3DSA:2.30.180.10:FF:000160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55100, NULL, 'G3DSA:3.30.160.60:FF:005953', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55101, NULL, 'G3DSA:3.30.70.600:FF:000019', NULL, NULL, '40S ribosomal protein S20-1', NULL, NULL, NULL, NULL, NULL, 4),
(55102, NULL, 'G3DSA:1.25.40.20:FF:001684', NULL, NULL, 'CARD- and ANK-containing Inflammasome Adaptor Protein', NULL, NULL, NULL, NULL, NULL, 4),
(55103, NULL, 'G3DSA:3.40.50.10130:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55104, NULL, 'G3DSA:2.60.40.1480:FF:000002', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(55105, NULL, 'G3DSA:2.30.30.770:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55106, NULL, 'G3DSA:3.80.10.10:FF:002930', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55107, NULL, 'G3DSA:3.30.160.60:FF:005739', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55108, NULL, 'G3DSA:1.20.1070.10:FF:001623', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55109, NULL, 'G3DSA:3.50.50.60:FF:001083', NULL, NULL, 'Protein anon-37Cs-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(55110, NULL, 'G3DSA:3.40.50.300:FF:005886', NULL, NULL, 'ATP-dependent DNA helicase CHL1', NULL, NULL, NULL, NULL, NULL, 4),
(55111, NULL, 'G3DSA:2.60.120.200:FF:000568', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55112, NULL, 'G3DSA:2.60.40.10:FF:003492', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55113, NULL, 'G3DSA:3.30.420.40:FF:001067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55114, NULL, 'G3DSA:3.40.50.720:FF:002584', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(55115, NULL, 'G3DSA:3.20.100.30:FF:000002', NULL, NULL, 'Vacuolar transporter chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(55116, NULL, 'G3DSA:3.30.450.20:FF:000495', NULL, NULL, 'Response receiver sensor protein serine/threonine phosphatase, PP2C family, PAS and PAS domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(55117, NULL, 'G3DSA:2.40.50.140:FF:000929', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55118, NULL, 'G3DSA:3.40.50.2000:FF:000792', NULL, NULL, '3-deoxy-D-manno-octulosonic acid transferase', NULL, NULL, NULL, NULL, NULL, 4),
(55119, NULL, 'G3DSA:3.30.70.340:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55120, NULL, 'G3DSA:3.30.420.40:FF:000999', NULL, NULL, 'Stress-70 protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(55121, NULL, 'G3DSA:3.20.20.370:FF:000009', NULL, NULL, 'Chitin deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(55122, NULL, 'G3DSA:1.25.40.10:FF:005278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55123, NULL, 'G3DSA:1.10.10.10:FF:001881', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55124, NULL, 'G3DSA:3.30.200.20:FF:001628', NULL, NULL, 'Membrane-associated tyrosine-and threonine-specific cdc2-inhibitory kinase', NULL, NULL, NULL, NULL, NULL, 4),
(55125, NULL, 'G3DSA:2.60.40.10:FF:005178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55126, NULL, 'G3DSA:1.10.10.60:FF:000018', NULL, NULL, 'Homeobox A10', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(55127, NULL, 'G3DSA:3.30.200.20:FF:001292', NULL, NULL, 'Rhoptry protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(55128, NULL, 'G3DSA:2.30.180.10:FF:000143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55129, NULL, 'G3DSA:3.40.630.30:FF:000425', NULL, NULL, 'GNAT family N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(55130, NULL, 'G3DSA:1.10.225.10:FF:000037', NULL, NULL, 'Prosaposin', NULL, NULL, NULL, NULL, NULL, 4),
(55131, NULL, 'G3DSA:3.90.190.10:FF:000598', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55132, NULL, 'G3DSA:3.20.20.70:FF:000091', NULL, NULL, 'galactocerebrosidase precursor', NULL, NULL, NULL, NULL, NULL, 4),
(55133, NULL, 'G3DSA:1.10.510.10:FF:003831', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55134, NULL, 'G3DSA:3.40.605.10:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55135, NULL, 'G3DSA:2.30.29.30:FF:000971', NULL, NULL, 'Beta-1-syntrophin', NULL, NULL, NULL, NULL, NULL, 4),
(55136, NULL, 'G3DSA:3.90.1750.10:FF:000062', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55137, NULL, 'G3DSA:4.10.400.10:FF:000225', NULL, NULL, 'AGAP003656-PA', NULL, NULL, NULL, NULL, NULL, 4),
(55138, NULL, 'G3DSA:3.20.20.70:FF:000427', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(55139, NULL, 'G3DSA:1.25.40.20:FF:000256', NULL, NULL, 'HECT domain and ankyrin repeat containing E3 ubiquitin protein ligase 1', NULL, NULL, NULL, NULL, NULL, 4),
(55140, NULL, 'G3DSA:1.25.10.10:FF:001853', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(55141, NULL, 'G3DSA:3.40.50.1820:FF:001119', NULL, NULL, 'Alpha/beta fold hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(55142, NULL, 'G3DSA:3.20.20.140:FF:000430', NULL, NULL, 'Phosphotransferase, PolIIIAc domain-containing, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55143, NULL, 'G3DSA:3.90.400.10:FF:000014', NULL, NULL, 'Oligo-1,6-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(55144, NULL, 'G3DSA:3.30.160.60:FF:002064', NULL, NULL, 'Zinc finger protein 1078', NULL, NULL, NULL, NULL, NULL, 4),
(55145, NULL, 'G3DSA:3.40.50.720:FF:000908', NULL, NULL, 'Methenyl tetrahydrofolate cyclohydrolase / NADP-dependent methylene H4F dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(55146, NULL, 'G3DSA:1.10.246.190:FF:000006', NULL, NULL, 'Autophagy protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(55147, NULL, 'G3DSA:3.40.50.450:FF:000108', NULL, NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase LOG7', NULL, NULL, NULL, NULL, NULL, 4),
(55148, NULL, 'G3DSA:3.40.50.300:FF:008062', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(55149, NULL, 'G3DSA:3.50.50.60:FF:001178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55150, NULL, 'G3DSA:1.25.40.10:FF:001355', NULL, NULL, 'Pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(55151, NULL, 'G3DSA:3.40.20.10:FF:000156', NULL, NULL, 'Actin binding protein (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(55152, NULL, 'G3DSA:1.25.40.10:FF:000253', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(55153, NULL, 'G3DSA:3.10.120.10:FF:000033', NULL, NULL, 'Stearic acid desaturase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55154, NULL, 'G3DSA:1.10.10.160:FF:000039', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(55155, NULL, 'G3DSA:3.40.190.10:FF:000868', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55156, NULL, 'G3DSA:4.10.1240.10:FF:000013', NULL, NULL, 'Glucagon like peptide 1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(55157, NULL, 'G3DSA:1.10.555.10:FF:000152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55158, NULL, 'G3DSA:3.40.190.80:FF:000057', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55159, NULL, 'G3DSA:3.30.40.10:FF:001315', NULL, NULL, 'E3 ubiquitin-protein ligase SPL2', NULL, NULL, NULL, NULL, NULL, 4),
(55160, NULL, 'G3DSA:1.25.40.10:FF:003249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(55161, NULL, 'G3DSA:3.20.20.150:FF:000079', NULL, NULL, 'Protein arginine N-methyltransferase skb1', NULL, NULL, NULL, NULL, NULL, 4),
(55162, NULL, 'G3DSA:1.10.560.10:FF:000006', NULL, NULL, 'T-complex protein 1 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(55163, NULL, 'G3DSA:3.80.10.10:FF:004375', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55164, NULL, 'G3DSA:3.40.1110.10:FF:000391', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55165, NULL, 'G3DSA:3.30.70.1230:FF:000147', NULL, NULL, 'Guanylyl cyclase, membrane', NULL, NULL, NULL, NULL, NULL, 4),
(55166, NULL, 'G3DSA:2.60.120.970:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55167, NULL, 'G3DSA:3.80.10.10:FF:004279', NULL, NULL, 'Protein CBR-LET-413', NULL, NULL, NULL, NULL, NULL, 4),
(55168, NULL, 'G3DSA:1.10.560.10:FF:000102', NULL, NULL, 'T-complex protein 1 subunit eta', NULL, NULL, NULL, NULL, NULL, 4),
(55169, NULL, 'G3DSA:1.10.472.80:FF:000272', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55170, NULL, 'G3DSA:3.40.50.300:FF:007786', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55171, NULL, 'G3DSA:3.40.50.300:FF:002901', NULL, NULL, 'Antimicrobial peptide ABC transporter ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(55172, NULL, 'G3DSA:3.40.50.1820:FF:001221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55173, NULL, 'G3DSA:3.80.10.10:FF:003531', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55174, NULL, 'G3DSA:3.30.300.10:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55175, NULL, 'G3DSA:2.30.30.90:FF:000008', NULL, NULL, 'Ferrous iron transport protein A', NULL, NULL, NULL, NULL, NULL, 4),
(55176, NULL, 'G3DSA:3.10.50.40:FF:000123', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(55177, NULL, 'G3DSA:2.60.40.10:FF:005627', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55178, NULL, 'G3DSA:1.25.40.20:FF:000610', NULL, NULL, 'Protein CBR-CNT-1', NULL, NULL, NULL, NULL, NULL, 4),
(55179, NULL, 'G3DSA:3.40.50.300:FF:003857', NULL, NULL, 'RAB38, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(55180, NULL, 'G3DSA:3.40.50.1100:FF:000050', NULL, NULL, 'D-cysteine desulfhydrase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(55181, NULL, 'G3DSA:3.10.290.10:FF:000045', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(55182, NULL, 'G3DSA:2.60.40.60:FF:000252', NULL, NULL, 'Cadherin related family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(55183, NULL, 'G3DSA:3.30.9.10:FF:000276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55184, NULL, 'G3DSA:2.60.40.640:FF:000022', NULL, NULL, 'Arrestin 1', NULL, NULL, NULL, NULL, NULL, 4),
(55185, NULL, 'G3DSA:4.10.1060.10:FF:000044', NULL, NULL, 'Mitochondrial RNA binding complex 1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(55186, NULL, 'G3DSA:3.20.10.10:FF:000061', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(55187, NULL, 'G3DSA:3.30.300.20:FF:000057', NULL, NULL, 'Probable transcription termination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(55188, NULL, 'G3DSA:2.40.420.20:FF:000028', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(55189, NULL, 'G3DSA:1.25.10.10:FF:003298', NULL, NULL, 'Phosphoinositide 3-kinase regulatory subunit 4-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(55190, NULL, 'G3DSA:3.40.630.30:FF:000329', NULL, NULL, 'Acetyltransferase putative', NULL, NULL, NULL, NULL, NULL, 4),
(55191, NULL, 'G3DSA:1.10.20.10:FF:000201', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55192, NULL, 'G3DSA:3.40.1810.10:FF:000073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55193, NULL, 'G3DSA:2.130.10.10:FF:003806', NULL, NULL, 'Vacuolar protein sorting-associated protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(55194, NULL, 'G3DSA:2.170.260.10:FF:000026', NULL, NULL, 'Argonaute-like protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(55195, NULL, 'G3DSA:3.40.50.300:FF:007926', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55196, NULL, 'G3DSA:3.40.1170.60:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55197, NULL, 'G3DSA:3.10.110.10:FF:000201', NULL, NULL, 'Putative ubiquitin-conjugating enzyme family', NULL, NULL, NULL, NULL, NULL, 4),
(55198, NULL, 'G3DSA:3.30.160.60:FF:000490', NULL, NULL, 'Zinc finger protein 605', NULL, NULL, NULL, NULL, NULL, 4),
(55199, NULL, 'G3DSA:1.10.287.110:FF:000401', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55200, NULL, 'G3DSA:1.10.8.60:FF:000057', NULL, NULL, 'AAA family ATPase, CDC48 subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(55201, NULL, 'G3DSA:2.40.10.120:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55202, NULL, 'G3DSA:3.10.450.240:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55203, NULL, 'G3DSA:1.10.10.10:FF:001555', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55204, NULL, 'G3DSA:3.90.640.80:FF:000002', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(55205, NULL, 'G3DSA:2.60.40.10:FF:002631', NULL, NULL, 'Envelope glycoprotein C', NULL, NULL, NULL, NULL, NULL, 4),
(55206, NULL, 'G3DSA:3.40.250.10:FF:000244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55207, NULL, 'G3DSA:1.25.70.10:FF:000081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55208, NULL, 'G3DSA:1.10.287.470:FF:000037', NULL, NULL, 'Efflux transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(55209, NULL, 'G3DSA:1.20.1110.10:FF:000273', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55210, NULL, 'G3DSA:3.90.640.90:FF:000005', NULL, NULL, 'Putative b-cell translocation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(55211, NULL, 'G3DSA:1.10.246.20:FF:000009', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 15a-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(55212, NULL, 'G3DSA:1.10.150.50:FF:000055', NULL, NULL, 'Sterile alpha motif domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(55213, NULL, 'G3DSA:1.10.10.10:FF:002044', NULL, NULL, 'Transcriptional regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55214, NULL, 'G3DSA:3.30.160.60:FF:005627', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55215, NULL, 'G3DSA:3.40.50.300:FF:006263', NULL, NULL, 'SNF2 family N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(55216, NULL, 'G3DSA:1.20.1270.10:FF:000099', NULL, NULL, 'Heat shock 70 kDa protein-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(55217, NULL, 'G3DSA:3.30.70.330:FF:001635', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55218, NULL, 'G3DSA:2.130.10.10:FF:001671', NULL, NULL, 'WD domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(55219, NULL, 'G3DSA:3.90.1720.10:FF:000004', NULL, NULL, 'Bifunctional glutathionylspermidine synthetase/amidase', NULL, NULL, NULL, NULL, NULL, 4),
(55220, NULL, 'G3DSA:3.40.30.10:FF:000437', NULL, NULL, 'Phosducin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(55221, NULL, 'G3DSA:1.10.506.10:FF:000044', NULL, NULL, 'Plexin A3', NULL, NULL, NULL, NULL, NULL, 4),
(55222, NULL, 'G3DSA:2.60.40.650:FF:000008', NULL, NULL, 'Molybdopterin binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(55223, NULL, 'G3DSA:1.25.40.20:FF:001919', NULL, NULL, 'Ankyrin-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55224, NULL, 'G3DSA:3.30.70.330:FF:001309', NULL, NULL, 'Serrate RNA effector molecule homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(55225, NULL, 'G3DSA:1.10.630.10:FF:000670', NULL, NULL, 'Os02g0503800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(55226, NULL, 'G3DSA:2.60.120.330:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55227, NULL, 'G3DSA:1.10.540.10:FF:000106', NULL, NULL, 'Putative oxidoreductase involved in 2-Alkyl-4-hydroxymethylfuran-3-carboxylic acid biosynthesis, MmfH', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(55228, NULL, 'G3DSA:1.20.5.170:FF:000188', NULL, NULL, 'X-box Binding Protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(55229, NULL, 'G3DSA:1.10.510.10:FF:001706', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55230, NULL, 'G3DSA:3.40.50.410:FF:000355', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55231, NULL, 'G3DSA:3.90.550.10:FF:000143', NULL, NULL, 'Dolichyl-phosphate beta-glucosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55232, NULL, 'G3DSA:3.50.50.60:FF:001206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55233, NULL, 'G3DSA:2.60.40.640:FF:000005', NULL, NULL, 'Arrestin domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(55234, NULL, 'G3DSA:3.90.1410.10:FF:000020', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(55235, NULL, 'G3DSA:2.40.50.140:FF:000789', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55236, NULL, 'G3DSA:3.30.1330.30:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55237, NULL, 'G3DSA:1.25.40.10:FF:001916', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(55238, NULL, 'G3DSA:3.80.10.10:FF:001502', NULL, NULL, 'EIN3-binding F-box protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(55239, NULL, 'G3DSA:3.30.40.10:FF:001641', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55240, NULL, 'G3DSA:1.20.1070.10:FF:000797', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55241, NULL, 'G3DSA:2.60.40.630:FF:000002', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(55242, NULL, 'G3DSA:1.10.8.1120:FF:000007', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55243, NULL, 'G3DSA:2.10.25.10:FF:000794', NULL, NULL, 'Fibrillin-1', NULL, NULL, NULL, NULL, NULL, 4),
(55244, NULL, 'G3DSA:2.40.240.10:FF:000039', NULL, NULL, 'Glutamate-tRNA ligase / Glutamine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(55245, NULL, 'G3DSA:3.90.260.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55246, NULL, 'G3DSA:1.25.40.10:FF:003816', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55247, NULL, 'G3DSA:1.20.58.80:FF:000038', NULL, NULL, 'AGAP001945-PA', NULL, NULL, NULL, NULL, NULL, 4),
(55248, NULL, 'G3DSA:3.40.50.300:FF:005448', NULL, NULL, 'Uncharacterized protein B13D15.290', NULL, NULL, NULL, NULL, NULL, 4),
(55249, NULL, 'G3DSA:3.90.650.10:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55250, NULL, 'G3DSA:1.10.238.10:FF:000342', NULL, NULL, 'EF-hand calcium binding domain 6', NULL, NULL, NULL, NULL, NULL, 4),
(55251, NULL, 'G3DSA:1.25.40.10:FF:003480', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(55252, NULL, 'G3DSA:2.40.50.140:FF:001065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55253, NULL, 'G3DSA:3.40.50.1000:FF:000132', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(55254, NULL, 'G3DSA:2.10.90.10:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55255, NULL, 'G3DSA:2.130.10.10:FF:002154', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(55256, NULL, 'G3DSA:4.10.400.10:FF:000321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55257, NULL, 'G3DSA:3.20.20.330:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55258, NULL, 'G3DSA:3.20.20.80:FF:000661', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55259, NULL, 'G3DSA:3.40.50.150:FF:000030', NULL, NULL, 'Carboxy-S-adenosyl-L-methionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(55260, NULL, 'G3DSA:3.40.50.300:FF:004037', NULL, NULL, 'Disks large homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(55261, NULL, 'G3DSA:3.40.50.300:FF:000440', NULL, NULL, 'Ras-related protein Rab-30', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(55262, NULL, 'G3DSA:3.30.70.380:FF:000003', NULL, NULL, 'Phenylalanine--tRNA ligase chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(55263, NULL, 'G3DSA:1.10.10.10:FF:001785', NULL, NULL, 'Transcriptional regulator, MarR family', NULL, NULL, NULL, NULL, NULL, 4),
(55264, NULL, 'G3DSA:2.40.100.10:FF:000113', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(55265, NULL, 'G3DSA:3.40.50.1010:FF:000135', NULL, NULL, 'Unplaced genomic scaffold supercont1.6, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(55266, NULL, 'G3DSA:1.10.10.10:FF:002061', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55267, NULL, 'G3DSA:3.40.605.10:FF:000029', NULL, NULL, 'Aldehyde dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(55268, NULL, 'G3DSA:3.30.530.20:FF:000080', NULL, NULL, 'Abscisic acid receptor PYL3', NULL, NULL, NULL, NULL, NULL, 4),
(55269, NULL, 'G3DSA:2.130.10.10:FF:000260', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(55270, NULL, 'G3DSA:2.60.120.380:FF:000009', NULL, NULL, 'Calpain-6', NULL, NULL, NULL, NULL, NULL, 4),
(55271, NULL, 'G3DSA:2.70.50.30:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55272, NULL, 'G3DSA:3.30.720.220:FF:000002', NULL, NULL, 'Protein JTB', NULL, NULL, NULL, NULL, NULL, 4),
(55273, NULL, 'G3DSA:2.10.25.10:FF:000581', NULL, NULL, 'Axotactin, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(55274, NULL, 'G3DSA:1.10.510.10:FF:000604', NULL, NULL, 'AGC protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(55275, NULL, 'G3DSA:4.10.60.10:FF:000005', NULL, NULL, 'E3 ubiquitin-protein ligase RBBP6', NULL, NULL, NULL, NULL, NULL, 4),
(55276, NULL, 'G3DSA:1.10.8.10:FF:000284', NULL, NULL, 'UBA/TS-N domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55277, NULL, 'G3DSA:2.130.10.10:FF:001878', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55278, NULL, 'G3DSA:3.90.70.10:FF:000123', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(55279, NULL, 'G3DSA:3.60.40.10:FF:000229', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55280, NULL, 'G3DSA:2.30.30.490:FF:000038', NULL, NULL, 'AT-rich interactive domain-containing protein 5B', NULL, NULL, NULL, NULL, NULL, 4),
(55281, NULL, 'G3DSA:1.20.1640.10:FF:000026', NULL, NULL, 'Dispatched RND transporter family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(55282, NULL, 'G3DSA:1.10.287.310:FF:000017', NULL, NULL, 'Ribosomal L29 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(55283, NULL, 'G3DSA:1.20.20.20:FF:000001', NULL, NULL, 'Putative exported protein', NULL, NULL, NULL, NULL, NULL, 4),
(55284, NULL, 'G3DSA:2.60.120.370:FF:000006', NULL, NULL, 'YhcH/YjgK/YiaL family protein', NULL, NULL, NULL, NULL, NULL, 4),
(55285, NULL, 'G3DSA:3.30.160.60:FF:004216', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55286, NULL, 'G3DSA:2.10.25.10:FF:001070', NULL, NULL, 'Protein CBR-TAG-53', NULL, NULL, NULL, NULL, NULL, 4),
(55287, NULL, 'G3DSA:3.30.230.80:FF:000035', NULL, NULL, 'Endoplasmin', NULL, NULL, NULL, NULL, NULL, 4),
(55288, NULL, 'G3DSA:3.20.20.140:FF:000076', NULL, NULL, 'Dihydropyrimidinase like 2', NULL, NULL, NULL, NULL, NULL, 4),
(55289, NULL, 'G3DSA:1.10.10.2010:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55290, NULL, 'G3DSA:3.30.830.10:FF:000133', NULL, NULL, 'Metalloenzyme, LuxS/M16 peptidase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(55291, NULL, 'G3DSA:4.10.400.10:FF:000096', NULL, NULL, 'Transmembrane serine protease 6', NULL, NULL, NULL, NULL, NULL, 4),
(55292, NULL, 'G3DSA:3.40.190.290:FF:000011', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(55293, NULL, 'G3DSA:3.30.450.50:FF:000037', NULL, NULL, 'SNARE domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(55294, NULL, 'G3DSA:1.25.40.70:FF:000029', NULL, NULL, 'phosphatidylinositol 4-kinase beta 1-like', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(55295, NULL, 'G3DSA:1.10.510.10:FF:003477', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55296, NULL, 'G3DSA:2.30.29.30:FF:001229', NULL, NULL, 'Nucleoside diphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(55297, NULL, 'G3DSA:1.20.5.110:FF:000226', NULL, NULL, 'Probable syntaxin-8B', NULL, NULL, NULL, NULL, NULL, 4),
(55298, NULL, 'G3DSA:3.40.1030.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55299, NULL, 'G3DSA:1.20.1250.20:FF:000786', NULL, NULL, 'MFS multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55300, NULL, 'G3DSA:2.60.40.790:FF:000022', NULL, NULL, 'Protein SHQ1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(55301, NULL, 'G3DSA:3.40.710.10:FF:000049', NULL, NULL, 'Putative D-alanyl-D-alanine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(55302, NULL, 'G3DSA:3.90.228.10:FF:000041', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(55303, NULL, 'G3DSA:2.130.10.10:FF:005594', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55304, NULL, 'G3DSA:2.60.40.1180:FF:000226', NULL, NULL, 'Putative glucosylceramidase/O-glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(55305, NULL, 'G3DSA:3.40.50.11980:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55306, NULL, 'G3DSA:2.40.50.100:FF:000007', NULL, NULL, 'Cytochrome f', NULL, NULL, NULL, NULL, NULL, 4),
(55307, NULL, 'G3DSA:3.40.50.10420:FF:000028', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(55308, NULL, 'G3DSA:3.30.930.10:FF:000422', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(55309, NULL, 'G3DSA:3.40.1110.10:FF:000065', NULL, NULL, 'Copper-transporting ATPase RAN1', NULL, NULL, NULL, NULL, NULL, 4),
(55310, NULL, 'G3DSA:3.40.50.2300:FF:001376', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55311, NULL, 'G3DSA:1.10.405.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55312, NULL, 'G3DSA:1.25.40.180:FF:000283', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55313, NULL, 'G3DSA:3.40.710.10:FF:000145', NULL, NULL, 'Penicillin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(55314, NULL, 'G3DSA:1.10.510.10:FF:001577', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55315, NULL, 'G3DSA:2.130.10.10:FF:004312', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55316, NULL, 'G3DSA:3.30.450.40:FF:000034', NULL, NULL, 'Sensor domain-containing diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(55317, NULL, 'G3DSA:1.10.1780.10:FF:000016', NULL, NULL, 'Protein SMAX1-LIKE 2', NULL, NULL, NULL, NULL, NULL, 4),
(55318, NULL, 'G3DSA:3.80.10.10:FF:001406', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55319, NULL, 'G3DSA:3.30.420.10:FF:000552', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55320, NULL, 'G3DSA:3.40.50.10330:FF:000092', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55321, NULL, 'G3DSA:3.90.70.120:FF:000002', NULL, NULL, 'Large tegument protein deneddylase', NULL, NULL, NULL, NULL, NULL, 4),
(55322, NULL, 'G3DSA:2.60.40.10:FF:004216', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55323, NULL, 'G3DSA:2.60.40.10:FF:001575', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(55324, NULL, 'G3DSA:3.90.79.10:FF:000210', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(55325, NULL, 'G3DSA:3.40.50.1360:FF:000009', NULL, NULL, 'Probable 6-phosphogluconolactonase', NULL, NULL, NULL, NULL, NULL, 4),
(55326, NULL, 'G3DSA:1.20.1250.20:FF:001500', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55327, NULL, 'G3DSA:3.90.1480.20:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55328, NULL, 'G3DSA:1.10.287.70:FF:000439', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55329, NULL, 'G3DSA:1.20.120.350:FF:000241', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(55330, NULL, 'G3DSA:2.60.40.10:FF:001788', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', NULL, NULL, NULL, NULL, NULL, 4),
(55331, NULL, 'G3DSA:1.20.1720.10:FF:000078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55332, NULL, 'G3DSA:4.10.1240.50:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55333, NULL, 'G3DSA:2.60.40.10:FF:002064', NULL, NULL, 'Basal cell adhesion molecule', NULL, NULL, NULL, NULL, NULL, 4),
(55334, NULL, 'G3DSA:3.30.160.60:FF:000164', NULL, NULL, 'Fez family zinc finger protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(55335, NULL, 'G3DSA:3.30.60.30:FF:000119', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55336, NULL, 'G3DSA:2.30.30.140:FF:000068', NULL, NULL, 'E3 ubiquitin-protein ligase UHRF1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(55337, NULL, 'G3DSA:3.60.21.10:FF:000303', NULL, NULL, 'Tartrate-resistant acid phosphatase type 5', NULL, NULL, NULL, NULL, NULL, 4),
(55338, NULL, 'G3DSA:1.10.565.10:FF:000080', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(55339, NULL, 'G3DSA:2.30.29.30:FF:001022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55340, NULL, 'G3DSA:3.10.20.90:FF:000271', NULL, NULL, 'Type VII secretion integral membrane protein EccD', NULL, NULL, NULL, NULL, NULL, 4),
(55341, NULL, 'G3DSA:3.40.50.10810:FF:000151', NULL, NULL, 'Snf2-related CREBBP activator protein', NULL, NULL, NULL, NULL, NULL, 4),
(55342, NULL, 'G3DSA:1.10.150.900:FF:000004', NULL, NULL, 'Carboxypeptidase PM20D1.2', NULL, NULL, NULL, NULL, NULL, 4),
(55343, NULL, 'G3DSA:1.20.1440.90:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55344, NULL, 'G3DSA:3.90.70.130:FF:000005', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55345, NULL, 'G3DSA:4.10.1240.10:FF:000030', NULL, NULL, 'Vasoactive intestinal polypeptide receptor', NULL, NULL, NULL, NULL, NULL, 4),
(55346, NULL, 'G3DSA:2.60.40.10:FF:000265', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(55347, NULL, 'G3DSA:1.10.3720.10:FF:000041', NULL, NULL, 'Inner membrane ABC transporter permease ycjO', NULL, NULL, NULL, NULL, NULL, 4),
(55348, NULL, 'G3DSA:3.30.420.10:FF:000097', NULL, NULL, 'Ribonuclease H1', NULL, NULL, NULL, NULL, NULL, 4),
(55349, NULL, 'G3DSA:1.25.10.10:FF:002241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55350, NULL, 'G3DSA:3.30.40.10:FF:001203', NULL, NULL, 'E3 SUMO-protein ligase MMS21', NULL, NULL, NULL, NULL, NULL, 4),
(55351, NULL, 'G3DSA:3.30.505.10:FF:000232', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55352, NULL, 'G3DSA:1.10.10.10:FF:001993', NULL, NULL, 'H-N-H endonuclease F-TflIV', NULL, NULL, NULL, NULL, NULL, 4),
(55353, NULL, 'G3DSA:2.130.10.10:FF:003469', NULL, NULL, 'YALI0A03883p', NULL, NULL, NULL, NULL, NULL, 4),
(55354, NULL, 'G3DSA:3.40.50.360:FF:000076', NULL, NULL, 'Flavodoxin/Radical SAM superfamily/Wyosine base formation, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55355, NULL, 'G3DSA:3.40.50.300:FF:007573', NULL, NULL, 'Putative mitochondrial ATP-dependent helicase irc3', NULL, NULL, NULL, NULL, NULL, 4),
(55356, NULL, 'G3DSA:3.90.190.10:FF:000486', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55357, NULL, 'G3DSA:3.40.50.2020:FF:000090', NULL, NULL, 'Protein CBG07940', NULL, NULL, NULL, NULL, NULL, 4),
(55358, NULL, 'G3DSA:2.30.30.1020:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55359, NULL, 'G3DSA:3.30.200.20:FF:001516', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55360, NULL, 'G3DSA:4.10.410.10:FF:000041', NULL, NULL, 'Protein CBR-MLT-11', NULL, NULL, NULL, NULL, NULL, 4),
(55361, NULL, 'G3DSA:1.20.1110.10:FF:000155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55362, NULL, 'G3DSA:3.30.565.10:FF:000241', NULL, NULL, 'GAF domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(55363, NULL, 'G3DSA:3.30.200.20:FF:002022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(55364, NULL, 'G3DSA:3.30.200.20:FF:000898', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(55365, NULL, 'G3DSA:4.10.400.10:FF:000113', NULL, NULL, 'Low-density lipoprotein receptor-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(55366, NULL, 'G3DSA:3.30.70.80:FF:000051', NULL, NULL, 'Serine protease, subtilase family', NULL, NULL, NULL, NULL, NULL, 4),
(55367, NULL, 'G3DSA:1.10.510.10:FF:002420', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55368, NULL, 'G3DSA:1.10.510.10:FF:001914', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55369, NULL, 'G3DSA:3.30.930.10:FF:000181', NULL, NULL, 'Holocarboxylase synthetase 2', NULL, NULL, NULL, NULL, NULL, 4),
(55370, NULL, 'G3DSA:3.40.50.150:FF:000243', NULL, NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(55371, NULL, 'G3DSA:1.10.630.10:FF:000439', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55372, NULL, 'G3DSA:2.130.10.10:FF:005723', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55373, NULL, 'G3DSA:1.50.40.10:FF:000532', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55374, NULL, 'G3DSA:3.80.10.10:FF:000788', NULL, NULL, 'chaoptin', NULL, NULL, NULL, NULL, NULL, 4),
(55375, NULL, 'G3DSA:2.170.300.10:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55376, NULL, 'G3DSA:2.40.50.100:FF:000119', NULL, NULL, 'GD24941', NULL, NULL, NULL, NULL, NULL, 4),
(55377, NULL, 'G3DSA:3.40.50.1000:FF:000345', NULL, NULL, 'Cat eye syndrome critical region protein', NULL, NULL, NULL, NULL, NULL, 4),
(55378, NULL, 'G3DSA:3.40.50.720:FF:000785', NULL, NULL, 'Polyketide synthase Pks12', NULL, NULL, NULL, NULL, NULL, 4),
(55379, NULL, 'G3DSA:1.10.132.10:FF:000006', NULL, NULL, 'DNA topoisomerase type IB small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(55380, NULL, 'G3DSA:1.10.3380.10:FF:000071', NULL, NULL, 'GH18520p', NULL, NULL, NULL, NULL, NULL, 4),
(55381, NULL, 'G3DSA:1.10.1200.270:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55382, NULL, 'G3DSA:1.10.10.750:FF:000025', NULL, NULL, 'AGAP002392-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(55383, NULL, 'G3DSA:3.30.40.10:FF:001091', NULL, NULL, 'PHD-finger domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(55384, NULL, 'G3DSA:1.10.30.50:FF:000011', NULL, NULL, 'Zinc finger, RAN-binding domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(55385, NULL, 'G3DSA:3.80.10.10:FF:004167', NULL, NULL, 'PeroXidasiN (Drosophila peroxidase) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(55386, NULL, 'G3DSA:1.10.472.80:FF:000160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55387, NULL, 'G3DSA:3.40.30.10:FF:000780', NULL, NULL, 'Ubx domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55388, NULL, 'G3DSA:3.40.50.2300:FF:001163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55389, NULL, 'G3DSA:1.20.1070.10:FF:001062', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55390, NULL, 'G3DSA:3.80.10.10:FF:004487', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55391, NULL, 'G3DSA:1.25.40.10:FF:003693', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55392, NULL, 'G3DSA:1.10.287.110:FF:000064', NULL, NULL, 'Molecular chaperone DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(55393, NULL, 'G3DSA:3.80.10.10:FF:002929', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(55394, NULL, 'G3DSA:3.30.9.10:FF:000304', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55395, NULL, 'G3DSA:1.10.510.10:FF:001689', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55396, NULL, 'G3DSA:3.40.50.2300:FF:001264', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55397, NULL, 'G3DSA:3.30.40.10:FF:001192', NULL, NULL, 'RING/U-box superfamily protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(55398, NULL, 'G3DSA:1.10.287.130:FF:000183', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(55399, NULL, 'G3DSA:1.20.1110.10:FF:000060', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(55400, NULL, 'G3DSA:1.20.1070.10:FF:000808', NULL, NULL, 'AKH/corazonin-related peptide', NULL, NULL, NULL, NULL, NULL, 4),
(55401, NULL, 'G3DSA:2.130.10.10:FF:004520', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(55402, NULL, 'G3DSA:3.30.810.10:FF:000020', NULL, NULL, 'Putative phosphatidylinositol 4-phosphate 5-kinase 11', NULL, NULL, NULL, NULL, NULL, 4),
(55403, NULL, 'G3DSA:1.25.40.10:FF:001563', NULL, NULL, 'Clustered mitochondria protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(55404, NULL, 'G3DSA:3.30.40.10:FF:002288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55405, NULL, 'G3DSA:2.130.10.10:FF:003582', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55406, NULL, 'G3DSA:3.30.160.60:FF:000714', NULL, NULL, 'Zinc finger protein 335', NULL, NULL, NULL, NULL, NULL, 4),
(55407, NULL, 'G3DSA:3.30.70.980:FF:000060', NULL, NULL, 'Probable transcriptional regulatory protein glr2507', NULL, NULL, NULL, NULL, NULL, 4),
(55408, NULL, 'G3DSA:1.10.510.10:FF:002307', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55409, NULL, 'G3DSA:2.130.10.10:FF:004200', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55410, NULL, 'G3DSA:3.30.2410.10:FF:000056', NULL, NULL, 'Neural precursor cell expressed, developmentally down-regulated 4, E3 ubiquitin protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(55411, NULL, 'G3DSA:3.30.930.10:FF:000068', NULL, NULL, 'eIF-2-alpha kinase GCN2', NULL, NULL, NULL, NULL, NULL, 4),
(55412, NULL, 'G3DSA:1.10.760.10:FF:000100', NULL, NULL, 'Lipoprotein cytochrome c, 1 heme-binding site', NULL, NULL, NULL, NULL, NULL, 4),
(55413, NULL, 'G3DSA:3.90.190.10:FF:000059', NULL, NULL, 'Dual specificity phosphatase 13, isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(55414, NULL, 'G3DSA:3.10.580.10:FF:000034', NULL, NULL, 'Glycine betaine/choline ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(55415, NULL, 'G3DSA:3.40.50.720:FF:001723', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55416, NULL, 'G3DSA:3.40.1800.20:FF:000019', NULL, NULL, 'Zeste-white 5', NULL, NULL, NULL, NULL, NULL, 4),
(55417, NULL, 'G3DSA:1.20.1740.10:FF:000186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55418, NULL, 'G3DSA:2.60.120.10:FF:000806', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55419, NULL, 'G3DSA:3.40.1280.30:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55420, NULL, 'G3DSA:1.10.630.10:FF:000344', NULL, NULL, 'Cytochrome P450, family 8, subfamily B, polypeptide 1', NULL, NULL, NULL, NULL, NULL, 4),
(55421, NULL, 'G3DSA:3.80.10.10:FF:001614', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(55422, NULL, 'G3DSA:3.40.50.1000:FF:000250', NULL, NULL, 'Probable cation-transporting ATPase HI_0290', NULL, NULL, NULL, NULL, NULL, 4),
(55423, NULL, 'G3DSA:1.10.357.140:FF:000039', NULL, NULL, 'Naringenin 8-dimethylallyltransferase 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(55424, NULL, 'G3DSA:3.30.365.10:FF:000035', NULL, NULL, 'Nicotinate dehydrogenase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(55425, NULL, 'G3DSA:3.30.505.10:FF:000119', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(55426, NULL, 'G3DSA:1.25.10.10:FF:001527', NULL, NULL, 'Probable serine/threonine-protein kinase tsuA', NULL, NULL, NULL, NULL, NULL, 4),
(55427, NULL, 'G3DSA:2.30.30.100:FF:000197', NULL, NULL, 'Small nuclear ribonucleoprotein Sm D2', NULL, NULL, NULL, NULL, NULL, 4),
(55428, NULL, 'G3DSA:2.60.40.10:FF:000170', NULL, NULL, 'Kirre like nephrin family adhesion molecule 3', NULL, NULL, NULL, NULL, NULL, 4),
(55429, NULL, 'G3DSA:3.30.710.10:FF:000439', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(55430, NULL, 'G3DSA:3.40.50.1000:FF:000019', NULL, NULL, 'Mitochondrial import inner membrane translocase subunit TIM50', NULL, NULL, NULL, NULL, NULL, 4),
(55431, NULL, 'G3DSA:2.10.25.10:FF:000468', NULL, NULL, 'Crumbs cell polarity complex component 1', NULL, NULL, NULL, NULL, NULL, 4),
(55432, NULL, 'G3DSA:2.60.40.10:FF:005745', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55433, NULL, 'G3DSA:3.40.50.1010:FF:000253', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55434, NULL, 'G3DSA:2.70.98.30:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55435, NULL, 'G3DSA:1.20.1250.20:FF:001051', NULL, NULL, 'Citrate-proton symporter', NULL, NULL, NULL, NULL, NULL, 4),
(55436, NULL, 'G3DSA:1.10.150.650:FF:000007', NULL, NULL, 'PHP domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(55437, NULL, 'G3DSA:3.40.50.1820:FF:000956', NULL, NULL, 'Hydrolase, alpha/beta fold family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55438, NULL, 'G3DSA:3.30.505.10:FF:000024', NULL, NULL, 'Vav guanine nucleotide exchange factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(55439, NULL, 'G3DSA:1.20.1560.10:FF:000868', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55440, NULL, 'G3DSA:2.60.40.10:FF:003716', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55441, NULL, 'G3DSA:3.40.50.12800:FF:000001', NULL, NULL, 'Penicillin-binding protein 1b', NULL, NULL, NULL, NULL, NULL, 4),
(55442, NULL, 'G3DSA:3.20.20.140:FF:000317', NULL, NULL, 'Putative formylmethanofuran dehydrogenase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(55443, NULL, 'G3DSA:3.60.110.10:FF:000078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55444, NULL, 'G3DSA:2.60.40.150:FF:000066', NULL, NULL, 'Extended synaptotagmin-2', NULL, NULL, NULL, NULL, NULL, 4),
(55445, NULL, 'G3DSA:3.40.50.140:FF:000009', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(55446, NULL, 'G3DSA:3.30.160.60:FF:006015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55447, NULL, 'G3DSA:1.20.5.690:FF:000006', NULL, NULL, 'Importin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(55448, NULL, 'G3DSA:1.10.8.60:FF:000169', NULL, NULL, '26S proteasome ATPase subunit S4', NULL, NULL, NULL, NULL, NULL, 4),
(55449, NULL, 'G3DSA:3.30.420.40:FF:000431', NULL, NULL, 'Protein CBG18255', NULL, NULL, NULL, NULL, NULL, 4),
(55450, NULL, 'G3DSA:2.60.120.10:FF:000453', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(55451, NULL, 'G3DSA:3.80.10.10:FF:003290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55452, NULL, 'G3DSA:2.20.50.20:FF:000006', NULL, NULL, 'Vitellogenin 7', NULL, NULL, NULL, NULL, NULL, 4),
(55453, NULL, 'G3DSA:3.30.1130.10:FF:000012', NULL, NULL, 'GTP cyclohydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(55454, NULL, 'G3DSA:1.10.490.30:FF:000001', NULL, NULL, 'Colicin N', NULL, NULL, NULL, NULL, NULL, 4),
(55455, NULL, 'G3DSA:1.20.1310.10:FF:000142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55456, NULL, 'G3DSA:1.10.1740.10:FF:000019', NULL, NULL, 'DNA-directed RNA polymerase sigma-70 factor', NULL, NULL, NULL, NULL, NULL, 4),
(55457, NULL, 'G3DSA:3.30.530.20:FF:000074', NULL, NULL, 'Protein CBG02248', NULL, NULL, NULL, NULL, NULL, 4),
(55458, NULL, 'G3DSA:3.30.160.20:FF:000068', NULL, NULL, 'RNA polymerase II C-terminal domain phosphatase-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(55459, NULL, 'G3DSA:2.40.100.10:FF:000001', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(55460, NULL, 'G3DSA:1.20.1270.60:FF:000086', NULL, NULL, 'Rho GTPase-activating protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(55461, NULL, 'G3DSA:1.20.58.1100:FF:000004', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(55462, NULL, 'G3DSA:2.130.10.10:FF:000030', NULL, NULL, 'Actin-related protein 2/3 complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(55463, NULL, 'G3DSA:2.10.230.10:FF:000023', NULL, NULL, 'dnaJ homolog subfamily A member 2', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(55464, NULL, 'G3DSA:3.10.450.240:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55465, NULL, 'G3DSA:3.30.9.10:FF:000068', NULL, NULL, 'N,N-dimethylglycine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(55466, NULL, 'G3DSA:3.30.160.60:FF:000613', NULL, NULL, 'zinc finger protein 462 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(55467, NULL, 'G3DSA:1.20.58.1540:FF:000001', NULL, NULL, 'SRC kinase signaling inhibitor 1', NULL, NULL, NULL, NULL, NULL, 4),
(55468, NULL, 'G3DSA:3.90.70.10:FF:000235', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(55469, NULL, 'G3DSA:3.40.50.300:FF:007359', NULL, NULL, 'Exodeoxyribonuclease v gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(55470, NULL, 'G3DSA:1.20.5.170:FF:000194', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(55471, NULL, 'G3DSA:1.10.1420.10:FF:000080', NULL, NULL, 'DNA mismatch repair protein MSH5', NULL, NULL, NULL, NULL, NULL, 4),
(55472, NULL, 'G3DSA:2.70.98.20:FF:000030', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(55473, NULL, 'G3DSA:3.40.50.150:FF:001648', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55474, NULL, 'G3DSA:2.60.40.10:FF:003699', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55475, NULL, 'G3DSA:1.50.40.10:FF:000189', NULL, NULL, 'Mitochondrial ornithine transporter 1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(55476, NULL, 'G3DSA:2.130.10.10:FF:003683', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55477, NULL, 'G3DSA:2.60.40.10:FF:005392', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55478, NULL, 'G3DSA:3.30.70.330:FF:001074', NULL, NULL, 'Splicing factor, arginine/serine-rich 7', NULL, NULL, NULL, NULL, NULL, 4),
(55479, NULL, 'G3DSA:3.90.190.10:FF:000391', NULL, NULL, 'Cyclin-G-associated kinase', NULL, NULL, NULL, NULL, NULL, 4),
(55480, NULL, 'G3DSA:3.30.160.60:FF:005178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55481, NULL, 'G3DSA:1.25.10.10:FF:000212', NULL, NULL, 'Cell division control protein', NULL, NULL, NULL, NULL, NULL, 4),
(55482, NULL, 'G3DSA:3.40.50.300:FF:003649', NULL, NULL, 'Conjugal transfer protein TraD', NULL, NULL, NULL, NULL, NULL, 4),
(55483, NULL, 'G3DSA:3.30.450.200:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55484, NULL, 'G3DSA:1.10.3720.10:FF:000142', NULL, NULL, 'Sugar-transport integral membrane protein ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(55485, NULL, 'G3DSA:1.10.640.10:FF:000058', NULL, NULL, 'Peroxinectin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55486, NULL, 'G3DSA:3.30.1360.120:FF:000017', NULL, NULL, 'Glycine cleavage system T protein', NULL, NULL, NULL, NULL, NULL, 4),
(55487, NULL, 'G3DSA:1.50.40.10:FF:000105', NULL, NULL, 'Nicotinamide adenine dinucleotide transporter 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(55488, NULL, 'G3DSA:3.40.1190.20:FF:000174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55489, NULL, 'G3DSA:3.40.50.12780:FF:000169', NULL, NULL, 'Putative acetyl-CoA synethetase', NULL, NULL, NULL, NULL, NULL, 4),
(55490, NULL, 'G3DSA:1.20.1280.50:FF:000044', NULL, NULL, 'F-box/WD repeat-containing protein 9 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(55491, NULL, 'G3DSA:3.10.580.10:FF:000146', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(55492, NULL, 'G3DSA:1.10.510.10:FF:002515', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55493, NULL, 'G3DSA:1.10.510.10:FF:000054', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(55494, NULL, 'G3DSA:2.40.20.10:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55495, NULL, 'G3DSA:3.40.630.30:FF:000330', NULL, NULL, 'GNAT family N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(55496, NULL, 'G3DSA:3.30.160.60:FF:006442', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55497, NULL, 'G3DSA:1.20.1560.10:FF:000773', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(55498, NULL, 'G3DSA:3.40.800.20:FF:000031', NULL, NULL, 'Histone deacetylase-like amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(55499, NULL, 'G3DSA:3.30.572.10:FF:000033', NULL, NULL, 'Bifunctional dihydrofolate reductase-thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(55500, NULL, 'G3DSA:3.40.50.1580:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55501, NULL, 'G3DSA:3.40.50.880:FF:000220', NULL, NULL, 'Transcriptional regulator DJ-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55502, NULL, 'G3DSA:3.30.160.110:FF:000004', NULL, NULL, 'Siroheme biosynthesis protein MET8', NULL, NULL, NULL, NULL, NULL, 4),
(55503, NULL, 'G3DSA:3.40.20.10:FF:000162', NULL, NULL, 'Protovillin', NULL, NULL, NULL, NULL, NULL, 4),
(55504, NULL, 'G3DSA:3.40.630.30:FF:000537', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(55505, NULL, 'G3DSA:3.30.160.60:FF:002305', NULL, NULL, 'zinc finger protein 777', NULL, NULL, NULL, NULL, NULL, 4),
(55506, NULL, 'G3DSA:2.30.30.40:FF:000235', NULL, NULL, 'Myosin VIIb', NULL, NULL, NULL, NULL, NULL, 4),
(55507, NULL, 'G3DSA:3.30.30.30:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55508, NULL, 'G3DSA:3.10.20.90:FF:000506', NULL, NULL, 'SEP domain/UBX domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55509, NULL, 'G3DSA:1.10.3260.10:FF:000005', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(55510, NULL, 'G3DSA:3.40.50.300:FF:004700', NULL, NULL, 'Meiotic recombination protein DMC1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(55511, NULL, 'G3DSA:2.40.70.10:FF:000043', NULL, NULL, 'retroviral-like aspartic protease 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(55512, NULL, 'G3DSA:3.30.2020.30:FF:000010', NULL, NULL, 'Clavaminate synthase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(55513, NULL, 'G3DSA:1.10.10.10:FF:000150', NULL, NULL, 'HTH-type transcriptional repressor NanR', NULL, NULL, NULL, NULL, NULL, 4),
(55514, NULL, 'G3DSA:2.30.29.30:FF:001342', NULL, NULL, 'Protein tyrosine kinase 2 beta, a', NULL, NULL, NULL, NULL, NULL, 4),
(55515, NULL, 'G3DSA:3.40.50.200:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55516, NULL, 'G3DSA:1.25.40.10:FF:003581', NULL, NULL, 'Adenylyl cyclase class-3/4/guanylyl cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(55517, NULL, 'G3DSA:3.40.50.1440:FF:000016', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(55518, NULL, 'G3DSA:3.30.200.20:FF:001415', NULL, NULL, 'Putative Serine/threonine-protein kinase 17A', NULL, NULL, NULL, NULL, NULL, 4),
(55519, NULL, 'G3DSA:3.30.70.1230:FF:000052', NULL, NULL, 'Adenylate/guanylate cyclase catalytic domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(55520, NULL, 'G3DSA:2.60.40.10:FF:005953', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55521, NULL, 'G3DSA:1.25.40.470:FF:000049', NULL, NULL, 'WD repeat-containing protein dyf-2', NULL, NULL, NULL, NULL, NULL, 4),
(55522, NULL, 'G3DSA:2.70.130.10:FF:000131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55523, NULL, 'G3DSA:1.25.40.340:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55524, NULL, 'G3DSA:3.40.50.300:FF:001963', NULL, NULL, 'Obg family GTPase CgtA', NULL, NULL, NULL, NULL, NULL, 4),
(55525, NULL, 'G3DSA:3.40.50.1820:FF:001451', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55526, NULL, 'G3DSA:3.40.50.620:FF:000749', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55527, NULL, 'G3DSA:3.30.160.60:FF:003587', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55528, NULL, 'G3DSA:3.30.9.10:FF:000181', NULL, NULL, 'FAD-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(55529, NULL, 'G3DSA:2.40.50.1020:FF:000009', NULL, NULL, 'Response regulator BlpR', NULL, NULL, NULL, NULL, NULL, 4),
(55530, NULL, 'G3DSA:2.10.25.10:FF:000356', NULL, NULL, 'pro-neuregulin-4, membrane-bound isoform', NULL, NULL, NULL, NULL, NULL, 4),
(55531, NULL, 'G3DSA:1.10.560.10:FF:000091', NULL, NULL, 'T-complex protein 1 subunit eta', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(55532, NULL, 'G3DSA:2.130.10.10:FF:001991', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', NULL, NULL, NULL, NULL, NULL, 4),
(55533, NULL, 'G3DSA:1.25.40.10:FF:002878', NULL, NULL, 'Bardet-Biedl syndrome 4 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55534, NULL, 'G3DSA:1.10.238.10:FF:000134', NULL, NULL, 'polycystin-2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(55535, NULL, 'G3DSA:2.60.120.10:FF:000245', NULL, NULL, 'Lysophospholipase NTE1', NULL, NULL, NULL, NULL, NULL, 4),
(55536, NULL, 'G3DSA:1.10.20.10:FF:000100', NULL, NULL, 'Transcription initiation factor TFIID subunit 9B', NULL, NULL, NULL, NULL, NULL, 4),
(55537, NULL, 'G3DSA:3.80.10.10:FF:002576', NULL, NULL, 'leucine-rich repeat neuronal protein 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(55538, NULL, 'G3DSA:3.30.70.640:FF:000003', NULL, NULL, 'Molybdenum cofactor biosynthesis protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55539, NULL, 'G3DSA:4.10.280.10:FF:000232', NULL, NULL, 'MAX dimerization protein MLX', NULL, NULL, NULL, NULL, NULL, 4),
(55540, NULL, 'G3DSA:1.20.225.10:FF:000001', NULL, NULL, 'Carnocyclin-A', NULL, NULL, NULL, NULL, NULL, 4),
(55541, NULL, 'G3DSA:3.40.50.2300:FF:001617', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55542, NULL, 'G3DSA:3.40.50.300:FF:003762', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(55543, NULL, 'G3DSA:3.40.30.10:FF:000229', NULL, NULL, 'Thioredoxin (TRX)', NULL, NULL, NULL, NULL, NULL, 4),
(55544, NULL, 'G3DSA:3.40.50.2300:FF:000999', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55545, NULL, 'G3DSA:1.10.274.30:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55546, NULL, 'G3DSA:3.40.50.800:FF:000039', NULL, NULL, 'Histidine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(55547, NULL, 'G3DSA:3.30.559.10:FF:000188', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(55548, NULL, 'G3DSA:1.10.10.440:FF:000022', NULL, NULL, 'Pre-mRNA-processing protein 40A', NULL, NULL, NULL, NULL, NULL, 4),
(55549, NULL, 'G3DSA:1.25.40.20:FF:000161', NULL, NULL, 'ankyrin repeat domain-containing protein 17 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(55550, NULL, 'G3DSA:1.10.8.60:FF:000512', NULL, NULL, 'AAA ATPase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(55551, NULL, 'G3DSA:2.130.10.10:FF:005835', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55552, NULL, 'G3DSA:2.120.10.80:FF:000101', NULL, NULL, 'kelch-like protein 8 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(55553, NULL, 'G3DSA:2.40.50.1000:FF:000003', NULL, NULL, '40S ribosomal protein S11', NULL, NULL, NULL, NULL, NULL, 4),
(55554, NULL, 'G3DSA:3.40.50.300:FF:005892', NULL, NULL, 'Lincomycin resistance ABC-F type ribosomal protection protein', NULL, NULL, NULL, NULL, NULL, 4),
(55555, NULL, 'G3DSA:3.40.1350.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55556, NULL, 'G3DSA:3.30.70.1170:FF:000005', NULL, NULL, 'Sun-family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55557, NULL, 'G3DSA:3.30.70.1180:FF:000008', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(55558, NULL, 'G3DSA:2.70.170.10:FF:000240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55559, NULL, 'G3DSA:3.40.50.300:FF:002126', NULL, NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55560, NULL, 'G3DSA:1.10.8.60:FF:000158', NULL, NULL, 'Calmodulin-interacting protein 111', NULL, NULL, NULL, NULL, NULL, 4),
(55561, NULL, 'G3DSA:3.80.10.10:FF:000676', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', NULL, NULL, NULL, NULL, NULL, 4),
(55562, NULL, 'G3DSA:3.30.56.30:FF:000014', NULL, NULL, 'Signal recognition particle protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55563, NULL, 'G3DSA:1.50.40.10:FF:000543', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(55564, NULL, 'G3DSA:3.80.10.10:FF:003082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55565, NULL, 'G3DSA:2.130.10.10:FF:005605', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55566, NULL, 'G3DSA:3.80.10.10:FF:001053', NULL, NULL, 'Tubulin folding COfactor E-Like protein', NULL, NULL, NULL, NULL, NULL, 4),
(55567, NULL, 'G3DSA:3.40.50.720:FF:000897', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(55568, NULL, 'G3DSA:3.30.160.60:FF:001687', NULL, NULL, 'Zinc finger protein 217', NULL, NULL, NULL, NULL, NULL, 4),
(55569, NULL, 'G3DSA:3.90.1750.10:FF:000056', NULL, NULL, 'Ubiquitin ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55570, NULL, 'G3DSA:3.40.50.450:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55571, NULL, 'G3DSA:3.30.70.330:FF:000112', NULL, NULL, 'RNA-binding motif protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(55572, NULL, 'G3DSA:3.40.190.10:FF:000969', NULL, NULL, 'Nickel ABC transporter, solute-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(55573, NULL, 'G3DSA:2.60.300.12:FF:000003', NULL, NULL, 'Iron-sulfur cluster insertion protein ErpA', NULL, NULL, NULL, NULL, NULL, 4),
(55574, NULL, 'G3DSA:3.30.160.60:FF:005386', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55575, NULL, 'G3DSA:3.30.70.330:FF:001540', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55576, NULL, 'G3DSA:1.10.510.10:FF:001678', NULL, NULL, 'Muscle, skeletal receptor tyrosine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(55577, NULL, 'G3DSA:3.40.50.2300:FF:001275', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55578, NULL, 'G3DSA:3.30.870.10:FF:000012', NULL, NULL, 'Tyrosyl-DNA phosphodiesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(55579, NULL, 'G3DSA:3.40.50.720:FF:001173', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(55580, NULL, 'G3DSA:3.90.1760.10:FF:000001', NULL, NULL, 'Bifunctional hemolysin/adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(55581, NULL, 'G3DSA:3.30.200.20:FF:001393', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55582, NULL, 'G3DSA:2.60.40.10:FF:004430', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55583, NULL, 'G3DSA:2.30.30.1020:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55584, NULL, 'G3DSA:3.40.1010.10:FF:000012', NULL, NULL, 'S-adenosylmethionine-dependent methyltransferase, YraL family', NULL, NULL, NULL, NULL, NULL, 4),
(55585, NULL, 'G3DSA:1.20.1280.50:FF:000252', NULL, NULL, 'Putative F-box/kelch-repeat protein At1g12870', NULL, NULL, NULL, NULL, NULL, 4),
(55586, NULL, 'G3DSA:3.50.50.60:FF:001291', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55587, NULL, 'G3DSA:3.50.30.30:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55588, NULL, 'G3DSA:1.25.10.10:FF:000330', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(55589, NULL, 'G3DSA:3.40.120.10:FF:000015', NULL, NULL, 'Phosphoacetylglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(55590, NULL, 'G3DSA:1.10.1280.10:FF:000006', NULL, NULL, 'Larval serum protein 1 gamma', NULL, NULL, NULL, NULL, NULL, 4),
(55591, NULL, 'G3DSA:2.60.40.790:FF:000134', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55592, NULL, 'G3DSA:3.30.160.60:FF:003828', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55593, NULL, 'G3DSA:3.30.420.40:FF:000420', NULL, NULL, 'Actin-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(55594, NULL, 'G3DSA:3.30.70.330:FF:003108', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55595, NULL, 'G3DSA:3.20.20.220:FF:000010', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(55596, NULL, 'G3DSA:1.10.540.10:FF:000005', NULL, NULL, 'Crotonobetainyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(55597, NULL, 'G3DSA:2.60.120.200:FF:000669', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55598, NULL, 'G3DSA:3.30.160.60:FF:005841', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(55599, NULL, 'G3DSA:1.20.1440.100:FF:000009', NULL, NULL, 'HAD-IB family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(55600, NULL, 'G3DSA:1.10.8.60:FF:000271', NULL, NULL, 'Vacuolar protein sorting 4 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(55601, NULL, 'G3DSA:1.10.418.10:FF:000002', NULL, NULL, 'Microtubule-actin cross-linking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(55602, NULL, 'G3DSA:1.25.10.10:FF:002230', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55603, NULL, 'G3DSA:1.10.1900.10:FF:000010', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(55604, NULL, 'G3DSA:3.20.20.80:FF:000773', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55605, NULL, 'G3DSA:1.10.1420.10:FF:000203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55606, NULL, 'G3DSA:3.40.50.10190:FF:000370', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55607, NULL, 'G3DSA:3.60.21.10:FF:000067', NULL, NULL, 'Manganese-dependent ADP-ribose/CDP-alcohol diphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(55608, NULL, 'G3DSA:3.30.460.10:FF:000094', NULL, NULL, 'Ribosomal silencing factor RsfS', NULL, NULL, NULL, NULL, NULL, 4),
(55609, NULL, 'G3DSA:3.80.10.10:FF:000777', NULL, NULL, 'RNI-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(55610, NULL, 'G3DSA:3.40.30.10:FF:000342', NULL, NULL, 'Protein disulfide isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(55611, NULL, 'G3DSA:2.10.220.10:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55612, NULL, 'G3DSA:1.25.40.10:FF:003479', NULL, NULL, 'Os05g0112900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(55613, NULL, 'G3DSA:3.20.20.70:FF:000540', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55614, NULL, 'G3DSA:2.40.440.10:FF:000026', NULL, NULL, 'ErfK/YbiS/YcfS/YnhG family protein', NULL, NULL, NULL, NULL, NULL, 4),
(55615, NULL, 'G3DSA:3.90.226.10:FF:000103', NULL, NULL, 'POSSIBLE ENOYL-COA HYDRATASE', NULL, NULL, NULL, NULL, NULL, 4),
(55616, NULL, 'G3DSA:3.30.160.60:FF:003941', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55617, NULL, 'G3DSA:1.10.510.10:FF:000155', NULL, NULL, 'Casein kinase I isoform epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(55618, NULL, 'G3DSA:1.20.190.50:FF:000004', NULL, NULL, 'Nuclear pore complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(55619, NULL, 'G3DSA:2.60.40.10:FF:000501', NULL, NULL, 'Leptin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(55620, NULL, 'G3DSA:3.10.20.90:FF:000383', NULL, NULL, 'Ubiquitin like 4B', NULL, NULL, NULL, NULL, NULL, 4),
(55621, NULL, 'G3DSA:3.40.50.300:FF:007691', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55622, NULL, 'G3DSA:2.10.90.10:FF:000074', NULL, NULL, 'Interleukin cytokine-related protein 17.1', NULL, NULL, NULL, NULL, NULL, 4),
(55623, NULL, 'G3DSA:2.130.10.10:FF:000810', NULL, NULL, 'Nucleoporin 43', NULL, NULL, NULL, NULL, NULL, 4),
(55624, NULL, 'G3DSA:2.60.40.1120:FF:000023', NULL, NULL, 'TonB-dependent outer membrane receptor', NULL, NULL, NULL, NULL, NULL, 4),
(55625, NULL, 'G3DSA:2.60.40.200:FF:000008', NULL, NULL, 'Superoxide dismutase [Cu-Zn]', NULL, NULL, NULL, NULL, NULL, 4),
(55626, NULL, 'G3DSA:1.20.5.500:FF:000006', NULL, NULL, 'ATPase inhibitor, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(55627, NULL, 'G3DSA:1.10.287.70:FF:000647', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55628, NULL, 'G3DSA:3.40.140.10:FF:000005', NULL, NULL, 'tRNA-specific adenosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(55629, NULL, 'G3DSA:3.90.550.50:FF:000014', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(55630, NULL, 'G3DSA:2.40.20.10:FF:000006', NULL, NULL, 'Kremen protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(55631, NULL, 'G3DSA:1.20.190.40:FF:000001', NULL, NULL, 'Major DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(55632, NULL, 'G3DSA:3.30.980.40:FF:000001', NULL, NULL, 'DNA translocase FtsK', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(55633, NULL, 'G3DSA:3.30.160.60:FF:003486', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55634, NULL, 'G3DSA:3.30.70.330:FF:001427', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55635, NULL, 'G3DSA:2.40.170.20:FF:000036', NULL, NULL, 'TonB-dependent vitamin B12 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(55636, NULL, 'G3DSA:1.25.40.10:FF:004210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55637, NULL, 'G3DSA:3.30.200.20:FF:001954', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55638, NULL, 'G3DSA:2.30.29.30:FF:001134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55639, NULL, 'G3DSA:2.10.50.10:FF:000077', NULL, NULL, 'Ectodysplasin A receptor', NULL, NULL, NULL, NULL, NULL, 4),
(55640, NULL, 'G3DSA:1.10.580.10:FF:000002', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(55641, NULL, 'G3DSA:1.10.630.10:FF:000552', NULL, NULL, 'Os02g0217300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(55642, NULL, 'G3DSA:3.40.50.410:FF:000237', NULL, NULL, 'Integrator complex subunit 14', NULL, NULL, NULL, NULL, NULL, 4),
(55643, NULL, 'G3DSA:1.20.1070.10:FF:001303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55644, NULL, 'G3DSA:3.40.50.2020:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55645, NULL, 'G3DSA:4.10.40.20:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55646, NULL, 'G3DSA:1.20.1070.10:FF:000685', NULL, NULL, 'Octopamine receptor beta-1R', NULL, NULL, NULL, NULL, NULL, 4),
(55647, NULL, 'G3DSA:1.25.40.10:FF:003934', NULL, NULL, 'IFT complex B', NULL, NULL, NULL, NULL, NULL, 4),
(55648, NULL, 'G3DSA:1.20.58.2220:FF:000014', NULL, NULL, 'FH2 domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(55649, NULL, 'G3DSA:1.25.40.10:FF:003704', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(55650, NULL, 'G3DSA:1.10.1200.10:FF:000097', NULL, NULL, 'Fatty acyl-AMP ligase', NULL, NULL, NULL, NULL, NULL, 4),
(55651, NULL, 'G3DSA:2.60.40.640:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55652, NULL, 'G3DSA:3.90.1410.10:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55653, NULL, 'G3DSA:3.20.70.20:FF:000056', NULL, NULL, 'Gll3966 protein', NULL, NULL, NULL, NULL, NULL, 4),
(55654, NULL, 'G3DSA:2.30.29.30:FF:000858', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55655, NULL, 'G3DSA:4.10.1000.40:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55656, NULL, 'G3DSA:3.30.70.330:FF:001085', NULL, NULL, 'Related to TIF3-translation initiation factor eIF-4B', NULL, NULL, NULL, NULL, NULL, 4),
(55657, NULL, 'G3DSA:3.30.200.20:FF:002230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55658, NULL, 'G3DSA:1.25.40.650:FF:000002', NULL, NULL, 'Penicillin-binding protein activator LpoA', NULL, NULL, NULL, NULL, NULL, 4),
(55659, NULL, 'G3DSA:3.40.50.2000:FF:001067', NULL, NULL, 'Os06g0564800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(55660, NULL, 'G3DSA:1.25.40.660:FF:000005', NULL, NULL, 'Vacuolar protein sorting-associated protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(55661, NULL, 'G3DSA:3.40.30.10:FF:000903', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55662, NULL, 'G3DSA:1.20.120.1070:FF:000008', NULL, NULL, 'Related to GCN3-translation initiation factor eIF2B, 34 KD, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(55663, NULL, 'G3DSA:1.20.1270.60:FF:000327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55664, NULL, 'G3DSA:1.25.40.10:FF:003592', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(55665, NULL, 'G3DSA:2.40.50.140:FF:001177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55666, NULL, 'G3DSA:1.20.58.390:FF:000141', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(55667, NULL, 'G3DSA:1.10.287.1150:FF:000006', NULL, NULL, '2-oxoglutarate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(55668, NULL, 'G3DSA:1.20.1250.20:FF:001157', NULL, NULL, 'Solute carrier family 15 member 5', NULL, NULL, NULL, NULL, NULL, 4),
(55669, NULL, 'G3DSA:1.20.1310.20:FF:000044', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(55670, NULL, 'G3DSA:2.60.40.10:FF:001693', NULL, NULL, 'Dystroglycan, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(55671, NULL, 'G3DSA:2.30.30.40:FF:000134', NULL, NULL, 'src-like-adapter isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(55672, NULL, 'G3DSA:3.40.50.10470:FF:000021', NULL, NULL, 'Initiation factor 2 subunit family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55673, NULL, 'G3DSA:3.90.190.10:FF:000497', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55674, NULL, 'G3DSA:3.30.60.20:FF:000021', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(55675, NULL, 'G3DSA:3.15.20.10:FF:000006', NULL, NULL, 'BPI fold containing family C', NULL, NULL, NULL, NULL, NULL, 4),
(55676, NULL, 'G3DSA:3.20.20.70:FF:000770', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55677, NULL, 'G3DSA:2.60.120.290:FF:000191', NULL, NULL, 'AGAP005526-PA', NULL, NULL, NULL, NULL, NULL, 4),
(55678, NULL, 'G3DSA:1.10.10.10:FF:001673', NULL, NULL, 'Transcriptional regulator, MarR family', NULL, NULL, NULL, NULL, NULL, 4),
(55679, NULL, 'G3DSA:3.30.930.10:FF:000079', NULL, NULL, 'Lysine--tRNA ligase 1', NULL, NULL, NULL, NULL, NULL, 4),
(55680, NULL, 'G3DSA:1.20.1310.10:FF:000041', NULL, NULL, 'cullin-3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(55681, NULL, 'G3DSA:3.30.160.60:FF:004104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55682, NULL, 'G3DSA:1.10.533.10:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55683, NULL, 'G3DSA:3.30.60.30:FF:000024', NULL, NULL, 'Transmembrane agrin', NULL, NULL, NULL, NULL, NULL, 4),
(55684, NULL, 'G3DSA:3.30.420.10:FF:000670', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55685, NULL, 'G3DSA:3.40.33.10:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55686, NULL, 'G3DSA:3.30.2130.10:FF:000006', NULL, NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(55687, NULL, 'G3DSA:3.30.40.10:FF:000938', NULL, NULL, 'PHD transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(55688, NULL, 'G3DSA:1.20.120.340:FF:000018', NULL, NULL, 'Flagellar secretion chaperone FliS', NULL, NULL, NULL, NULL, NULL, 4),
(55689, NULL, 'G3DSA:1.10.10.440:FF:000033', NULL, NULL, 'Formin binding protein (FNB3)', NULL, NULL, NULL, NULL, NULL, 4),
(55690, NULL, 'G3DSA:3.40.50.300:FF:003969', NULL, NULL, 'ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(55691, NULL, 'G3DSA:3.60.110.10:FF:000089', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55692, NULL, 'G3DSA:3.40.50.10310:FF:000001', NULL, NULL, 'Creatininase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(55693, NULL, 'G3DSA:3.30.420.10:FF:000338', NULL, NULL, 'Polymerase (DNA directed), theta', NULL, NULL, NULL, NULL, NULL, 4),
(55694, NULL, 'G3DSA:3.40.50.1110:FF:000171', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55695, NULL, 'G3DSA:2.30.30.140:FF:000282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55696, NULL, 'G3DSA:1.25.40.470:FF:000038', NULL, NULL, 'Intraflagellar transport 122', NULL, NULL, NULL, NULL, NULL, 4),
(55697, NULL, 'G3DSA:1.20.1270.280:FF:000041', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(55698, NULL, 'G3DSA:3.30.40.10:FF:001214', NULL, NULL, 'Probable E3 ubiquitin-protein ligase makorin-3', NULL, NULL, NULL, NULL, NULL, 4),
(55699, NULL, 'G3DSA:2.80.10.50:FF:000156', NULL, NULL, 'Ricin B-like lectin', NULL, NULL, NULL, NULL, NULL, 4),
(55700, NULL, 'G3DSA:2.30.30.370:FF:000002', NULL, NULL, '2-hydroxyhepta-2,4-diene-1,7-dioate isomerase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(55701, NULL, 'G3DSA:3.40.140.10:FF:000224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55702, NULL, 'G3DSA:1.10.1450.10:FF:000031', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(55703, NULL, 'G3DSA:3.90.1420.10:FF:000060', NULL, NULL, 'Ribosomal lysine N-methyltransferase set10', NULL, NULL, NULL, NULL, NULL, 4),
(55704, NULL, 'G3DSA:1.25.40.20:FF:000722', NULL, NULL, 'Caseinolytic peptidase B protein homolog isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(55705, NULL, 'G3DSA:3.60.21.10:FF:000421', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55706, NULL, 'G3DSA:1.10.132.20:FF:000009', NULL, NULL, 'Similar to ribosome recycling factor', NULL, NULL, NULL, NULL, NULL, 4),
(55707, NULL, 'G3DSA:2.30.30.380:FF:000005', NULL, NULL, 'E3 ubiquitin-protein ligase Mdm2', NULL, NULL, NULL, NULL, NULL, 4),
(55708, NULL, 'G3DSA:2.60.120.290:FF:000089', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(55709, NULL, 'G3DSA:3.40.50.300:FF:007814', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55710, NULL, 'G3DSA:3.40.50.300:FF:004245', NULL, NULL, 'ATP-dependent RecD-like DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(55711, NULL, 'G3DSA:2.60.120.330:FF:000141', NULL, NULL, 'Protein DMR6-LIKE OXYGENASE 2', NULL, NULL, NULL, NULL, NULL, 4),
(55712, NULL, 'G3DSA:3.40.630.30:FF:000217', NULL, NULL, 'GNAT family N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(55713, NULL, 'G3DSA:2.70.170.10:FF:000010', NULL, NULL, 'neuronal acetylcholine receptor subunit alpha-9', NULL, NULL, NULL, NULL, NULL, 4),
(55714, NULL, 'G3DSA:1.20.58.60:FF:000746', NULL, NULL, 'Spectrin, beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(55715, NULL, 'G3DSA:3.40.50.150:FF:001098', NULL, NULL, 'N(2), N(2)-dimethylguanosine tRNA methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55716, NULL, 'G3DSA:1.10.510.10:FF:003943', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55717, NULL, 'G3DSA:3.10.580.10:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55718, NULL, 'G3DSA:1.10.150.50:FF:000167', NULL, NULL, 'Sphingomyelin synthase-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(55719, NULL, 'G3DSA:3.40.50.10330:FF:000007', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(55720, NULL, 'G3DSA:1.25.10.10:FF:001735', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55721, NULL, 'G3DSA:1.10.287.110:FF:000300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55722, NULL, 'G3DSA:1.10.555.10:FF:000247', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55723, NULL, 'G3DSA:2.10.250.10:FF:000018', NULL, NULL, 'Calreticulin 3', NULL, NULL, NULL, NULL, NULL, 4),
(55724, NULL, 'G3DSA:1.10.510.10:FF:001791', NULL, NULL, 'Protein CBG02188', NULL, NULL, NULL, NULL, NULL, 4),
(55725, NULL, 'G3DSA:1.10.1580.10:FF:000035', NULL, NULL, 'Probable ribosome biogenesis GTPase A', NULL, NULL, NULL, NULL, NULL, 4),
(55726, NULL, 'G3DSA:2.60.40.10:FF:002530', NULL, NULL, 'CBN-SAX-3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(55727, NULL, 'G3DSA:3.30.160.60:FF:006004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55728, NULL, 'G3DSA:1.10.230.10:FF:000004', NULL, NULL, 'ATP-citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(55729, NULL, 'G3DSA:2.130.10.10:FF:003705', NULL, NULL, 'TAF (TBP-associated transcription factor) family', NULL, NULL, NULL, NULL, NULL, 4),
(55730, NULL, 'G3DSA:1.25.10.10:FF:002011', NULL, NULL, 'ARM repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(55731, NULL, 'G3DSA:3.40.50.10320:FF:000004', NULL, NULL, 'N-acetylglucosaminylphosphatidylinositol de-N-acetylase', NULL, NULL, NULL, NULL, NULL, 4),
(55732, NULL, 'G3DSA:2.10.25.10:FF:000676', NULL, NULL, 'Protein eyes shut homolog', NULL, NULL, NULL, NULL, NULL, 4),
(55733, NULL, 'G3DSA:1.20.920.10:FF:000049', NULL, NULL, 'RSC complex member', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(55734, NULL, 'G3DSA:3.40.50.720:FF:000667', NULL, NULL, 'Alpha-aminoadipic semialdehyde synthase', NULL, NULL, NULL, NULL, NULL, 4),
(55735, NULL, 'G3DSA:3.40.50.150:FF:000125', NULL, NULL, 'Glutathione S-transferase C-terminal domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(55736, NULL, 'G3DSA:3.40.630.10:FF:000211', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(55737, NULL, 'G3DSA:3.40.50.300:FF:000535', NULL, NULL, 'rac-like GTP-binding protein RAC2', NULL, NULL, NULL, NULL, NULL, 4),
(55738, NULL, 'G3DSA:3.40.50.2300:FF:000769', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55739, NULL, 'G3DSA:3.30.830.10:FF:000015', NULL, NULL, 'Putative zinc metalloprotease', NULL, NULL, NULL, NULL, NULL, 4),
(55740, NULL, 'G3DSA:3.20.20.80:FF:000548', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55741, NULL, 'G3DSA:2.170.190.11:FF:000027', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(55742, NULL, 'G3DSA:3.50.50.60:FF:001414', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55743, NULL, 'G3DSA:3.40.50.720:FF:001055', NULL, NULL, 'UDP-glucose dehydrogenase Ugd1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55744, NULL, 'G3DSA:1.10.238.10:FF:000022', NULL, NULL, 'E3 ubiquitin-protein ligase CBL', NULL, NULL, NULL, NULL, NULL, 4),
(55745, NULL, 'G3DSA:1.25.40.20:FF:001897', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55746, NULL, 'G3DSA:3.80.10.10:FF:002694', NULL, NULL, 'CLL3 clavata1-like receptor S/T protein kinase protein', NULL, NULL, NULL, NULL, NULL, 4),
(55747, NULL, 'G3DSA:3.30.1120.10:FF:000056', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55748, NULL, 'G3DSA:2.20.25.190:FF:000002', NULL, NULL, 'Transcription elongation factor 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(55749, NULL, 'G3DSA:3.30.420.10:FF:000439', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55750, NULL, 'G3DSA:3.40.50.2300:FF:001505', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55751, NULL, 'G3DSA:3.30.40.10:FF:001433', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55752, NULL, 'G3DSA:3.30.565.10:FF:000011', NULL, NULL, 'Sensor histidine kinase CpxA', NULL, NULL, NULL, NULL, NULL, 4),
(55753, NULL, 'G3DSA:3.30.9.10:FF:000063', NULL, NULL, 'Oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55754, NULL, 'G3DSA:3.20.20.70:FF:000545', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55755, NULL, 'G3DSA:3.30.710.10:FF:000198', NULL, NULL, 'Germ cell-less, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(55756, NULL, 'G3DSA:3.10.450.10:FF:000030', NULL, NULL, 'Latexin', NULL, NULL, NULL, NULL, NULL, 4),
(55757, NULL, 'G3DSA:3.80.10.10:FF:003306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55758, NULL, 'G3DSA:3.40.50.2000:FF:000898', NULL, NULL, 'Glr3757 protein', NULL, NULL, NULL, NULL, NULL, 4),
(55759, NULL, 'G3DSA:3.50.50.60:FF:001296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55760, NULL, 'G3DSA:3.30.160.60:FF:004317', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55761, NULL, 'G3DSA:2.60.40.1170:FF:000010', NULL, NULL, 'AP-1 complex subunit mu-2', NULL, NULL, NULL, NULL, NULL, 4),
(55762, NULL, 'G3DSA:1.10.1220.10:FF:000008', NULL, NULL, 'Addiction module antitoxin, RelB/DinJ family', NULL, NULL, NULL, NULL, NULL, 4),
(55763, NULL, 'G3DSA:3.40.30.10:FF:000117', NULL, NULL, 'thioredoxin-related transmembrane protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(55764, NULL, 'G3DSA:2.60.120.330:FF:000028', NULL, NULL, 'Unplaced genomic scaffold supercont1.142, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(55765, NULL, 'G3DSA:1.20.870.10:FF:000033', NULL, NULL, 'Ras family guanine nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(55766, NULL, 'G3DSA:1.25.40.10:FF:005172', NULL, NULL, 'Signal recognition particle receptor FtsY', NULL, NULL, NULL, NULL, NULL, 4),
(55767, NULL, 'G3DSA:3.80.10.10:FF:001171', NULL, NULL, 'Centrosomal protein 97kDa, isoform B', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(55768, NULL, 'G3DSA:3.40.50.720:FF:002578', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55769, NULL, 'G3DSA:1.50.10.10:FF:000148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55770, NULL, 'G3DSA:3.30.70.890:FF:000044', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(55771, NULL, 'G3DSA:3.30.499.10:FF:000019', NULL, NULL, 'Aconitate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(55772, NULL, 'G3DSA:3.40.50.10330:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55773, NULL, 'G3DSA:3.40.50.300:FF:002014', NULL, NULL, 'DNA polymerase III, delta prime subunit', NULL, NULL, NULL, NULL, NULL, 4),
(55774, NULL, 'G3DSA:2.130.10.10:FF:005381', NULL, NULL, 'F21J9.19', NULL, NULL, NULL, NULL, NULL, 4),
(55775, NULL, 'G3DSA:3.40.50.300:FF:005780', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(55776, NULL, 'G3DSA:4.10.1240.10:FF:000024', NULL, NULL, 'latrophilin Cirl isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(55777, NULL, 'G3DSA:3.40.50.10190:FF:000139', NULL, NULL, 'Nibrin', NULL, NULL, NULL, NULL, NULL, 4),
(55778, NULL, 'G3DSA:3.30.200.20:FF:001174', NULL, NULL, 'Dual serine/threonine and tyrosine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(55779, NULL, 'G3DSA:2.70.150.10:FF:000020', NULL, NULL, 'Copper-exporting P-type ATPase A', NULL, NULL, NULL, NULL, NULL, 4),
(55780, NULL, 'G3DSA:2.60.40.10:FF:002070', NULL, NULL, 'roundabout homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(55781, NULL, 'G3DSA:1.10.20.10:FF:000307', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55782, NULL, 'G3DSA:2.70.130.10:FF:000013', NULL, NULL, 'Insulin-like growth factor 2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(55783, NULL, 'G3DSA:1.10.8.270:FF:000130', NULL, NULL, 'RabGAP/TBC protein', NULL, NULL, NULL, NULL, NULL, 4),
(55784, NULL, 'G3DSA:3.40.80.10:FF:000047', NULL, NULL, 'Peptidoglycan recognition protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(55785, NULL, 'G3DSA:1.20.1250.20:FF:000994', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(55786, NULL, 'G3DSA:1.10.246.20:FF:000010', NULL, NULL, 'Mediator complex subunit Med15', NULL, NULL, NULL, NULL, NULL, 4),
(55787, NULL, 'G3DSA:1.10.30.10:FF:000140', NULL, NULL, 'FACT complex subunit SSRP1', NULL, NULL, NULL, NULL, NULL, 4),
(55788, NULL, 'G3DSA:3.30.160.60:FF:000046', NULL, NULL, 'Putative B-cell lymphoma/leukemia 11A', NULL, NULL, NULL, NULL, NULL, 4),
(55789, NULL, 'G3DSA:1.10.8.430:FF:000004', NULL, NULL, 'Disease resistance protein (TIR-NBS-LRR class)', NULL, NULL, NULL, NULL, NULL, 4),
(55790, NULL, 'G3DSA:1.20.1070.10:FF:000786', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55791, NULL, 'G3DSA:2.60.40.10:FF:003267', NULL, NULL, 'Interleukin 13 receptor, alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(55792, NULL, 'G3DSA:2.60.40.60:FF:000370', NULL, NULL, 'FAT atypical cadherin 3', NULL, NULL, NULL, NULL, NULL, 4),
(55793, NULL, 'G3DSA:1.10.510.10:FF:003595', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55794, NULL, 'G3DSA:3.90.930.1:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55795, NULL, 'G3DSA:3.30.160.60:FF:002300', NULL, NULL, 'Kruppel like factor 18', NULL, NULL, NULL, NULL, NULL, 4),
(55796, NULL, 'G3DSA:2.60.120.10:FF:000458', NULL, NULL, 'Anti-sigma-E factor ChrR', NULL, NULL, NULL, NULL, NULL, 4),
(55797, NULL, 'G3DSA:3.30.160.60:FF:004424', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55798, NULL, 'G3DSA:1.20.1250.20:FF:000668', NULL, NULL, 'MFS drug efflux pump', NULL, NULL, NULL, NULL, NULL, 4),
(55799, NULL, 'G3DSA:3.30.40.10:FF:001540', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55800, NULL, 'G3DSA:1.10.8.420:FF:000001', NULL, NULL, 'Recombination protein RecR', NULL, NULL, NULL, NULL, NULL, 4),
(55801, NULL, 'G3DSA:1.20.5.930:FF:000005', NULL, NULL, 'Integrin, alpha 10', NULL, NULL, NULL, NULL, NULL, 4),
(55802, NULL, 'G3DSA:2.60.40.10:FF:003593', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(55803, NULL, 'G3DSA:3.40.30.10:FF:000224', NULL, NULL, 'Thioredoxin domain containing 2 (Spermatozoa)', NULL, NULL, NULL, NULL, NULL, 4),
(55804, NULL, 'G3DSA:1.10.132.70:FF:000007', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(55805, NULL, 'G3DSA:1.10.238.200:FF:000008', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(55806, NULL, 'G3DSA:2.30.30.140:FF:000304', NULL, NULL, 'Protein SAWADEE HOMEODOMAIN HOMOLOG 1', NULL, NULL, NULL, NULL, NULL, 4),
(55807, NULL, 'G3DSA:3.30.70.330:FF:001422', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55808, NULL, 'G3DSA:1.20.900.10:FF:000048', NULL, NULL, 'GL21162', NULL, NULL, NULL, NULL, NULL, 4),
(55809, NULL, 'G3DSA:2.40.10.10:FF:000500', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55810, NULL, 'G3DSA:1.10.533.10:FF:000303', NULL, NULL, 'Apoptosis 2 inhibitor-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(55811, NULL, 'G3DSA:3.40.50.1100:FF:000156', NULL, NULL, 'Os01g0695600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(55812, NULL, 'G3DSA:2.40.40.10:FF:000002', NULL, NULL, 'Membrane-bound lytic murein transglycosylase A', NULL, NULL, NULL, NULL, NULL, 4),
(55813, NULL, 'G3DSA:1.10.510.10:FF:003269', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55814, NULL, 'G3DSA:3.30.505.50:FF:000002', NULL, NULL, 'Ribosome hibernation promoting factor', NULL, NULL, NULL, NULL, NULL, 4),
(55815, NULL, 'G3DSA:3.50.50.60:FF:000695', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(55816, NULL, 'G3DSA:3.30.160.60:FF:000372', NULL, NULL, 'IKAROS family zinc finger 4', NULL, NULL, NULL, NULL, NULL, 4),
(55817, NULL, 'G3DSA:1.20.1270.60:FF:000209', NULL, NULL, 'Bridging integrator 3-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(55818, NULL, 'G3DSA:3.40.950.10:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55819, NULL, 'G3DSA:3.40.50.12110:FF:000002', NULL, NULL, 'Spore photoproduct lyase', NULL, NULL, NULL, NULL, NULL, 4),
(55820, NULL, 'G3DSA:3.30.60.20:FF:000015', NULL, NULL, 'Vav guanine nucleotide exchange factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(55821, NULL, 'G3DSA:2.40.40.20:FF:000005', NULL, NULL, 'Periplasmic nitrate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(55822, NULL, 'G3DSA:1.10.246.130:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55823, NULL, 'G3DSA:2.40.30.130:FF:000012', NULL, NULL, 'Predicted gene, 27029', NULL, NULL, NULL, NULL, NULL, 4),
(55824, NULL, 'G3DSA:2.30.30.620:FF:000004', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55825, NULL, 'G3DSA:2.20.50.20:FF:000001', NULL, NULL, 'Vitellogenin 5', NULL, NULL, NULL, NULL, NULL, 4),
(55826, NULL, 'G3DSA:2.60.120.620:FF:000008', NULL, NULL, 'transmembrane prolyl 4-hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(55827, NULL, 'G3DSA:2.70.170.10:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55828, NULL, 'G3DSA:3.40.50.300:FF:007808', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55829, NULL, 'G3DSA:1.10.286.20:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55830, NULL, 'G3DSA:3.30.60.30:FF:000018', NULL, NULL, 'Transmembrane agrin', NULL, NULL, NULL, NULL, NULL, 4),
(55831, NULL, 'G3DSA:3.10.20.90:FF:000170', NULL, NULL, 'Polycomb group RING finger protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(55832, NULL, 'G3DSA:1.20.272.60:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55833, NULL, 'G3DSA:1.10.150.50:FF:000066', NULL, NULL, 'ephrin type-A receptor 10', NULL, NULL, NULL, NULL, NULL, 4),
(55834, NULL, 'G3DSA:1.10.510.10:FF:002072', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(55835, NULL, 'G3DSA:3.40.50.1110:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55836, NULL, 'G3DSA:2.130.10.10:FF:003924', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55837, NULL, 'G3DSA:2.60.120.620:FF:000115', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(55838, NULL, 'G3DSA:3.30.930.10:FF:000416', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(55839, NULL, 'G3DSA:3.40.50.300:FF:007915', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55840, NULL, 'G3DSA:2.70.170.10:FF:000015', NULL, NULL, 'gamma-aminobutyric acid receptor subunit rho-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(55841, NULL, 'G3DSA:2.20.25.10:FF:000029', NULL, NULL, 'DNA-directed RNA polymerase subunit M', NULL, NULL, NULL, NULL, NULL, 4),
(55842, NULL, 'G3DSA:3.10.20.90:FF:000063', NULL, NULL, 'Talin 1', NULL, NULL, NULL, NULL, NULL, 4),
(55843, NULL, 'G3DSA:3.40.50.10760:FF:000001', NULL, NULL, 'Outer capsid protein lambda-2', NULL, NULL, NULL, NULL, NULL, 4),
(55844, NULL, 'G3DSA:3.40.630.30:FF:000094', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(55845, NULL, 'G3DSA:3.30.160.60:FF:001569', NULL, NULL, 'Zinc finger protein 341', NULL, NULL, NULL, NULL, NULL, 4),
(55846, NULL, 'G3DSA:3.40.50.2300:FF:001612', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55847, NULL, 'G3DSA:3.30.930.10:FF:000309', NULL, NULL, 'DNA polymerase subunit gamma-2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55848, NULL, 'G3DSA:1.10.510.10:FF:003488', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55849, NULL, 'G3DSA:3.50.30.30:FF:000027', NULL, NULL, 'E3 ubiquitin-protein ligase RNF130', NULL, NULL, NULL, NULL, NULL, 4),
(55850, NULL, 'G3DSA:3.40.140.10:FF:000117', NULL, NULL, 'Cytidine deaminase,putative', NULL, NULL, NULL, NULL, NULL, 4),
(55851, NULL, 'G3DSA:1.10.405.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55852, NULL, 'G3DSA:2.10.70.10:FF:000078', NULL, NULL, 'Complement decay-accelerating factor', NULL, NULL, NULL, NULL, NULL, 4),
(55853, NULL, 'G3DSA:6.10.140.2220:FF:000074', NULL, NULL, 'SET (Trithorax/polycomb) domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(55854, NULL, 'G3DSA:2.60.40.60:FF:000263', NULL, NULL, 'LOW QUALITY PROTEIN: protocadherin-23', NULL, NULL, NULL, NULL, NULL, 4),
(55855, NULL, 'G3DSA:2.40.50.140:FF:001071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55856, NULL, 'G3DSA:3.40.50.1820:FF:001232', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(55857, NULL, 'G3DSA:2.60.34.20:FF:000001', NULL, NULL, 'protein AAR2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(55858, NULL, 'G3DSA:1.25.40.10:FF:000045', NULL, NULL, 'Cell division cycle protein 27 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(55859, NULL, 'G3DSA:1.20.1250.20:FF:000887', NULL, NULL, 'Probable multidrug-efflux transporter MT1670', NULL, NULL, NULL, NULL, NULL, 4),
(55860, NULL, 'G3DSA:2.30.29.30:FF:001128', NULL, NULL, 'Nuclear pore complex component NPAP60L/NUP50, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55861, NULL, 'G3DSA:2.10.25.10:FF:001064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55862, NULL, 'G3DSA:1.10.8.270:FF:000023', NULL, NULL, 'TBC domain-containing protein C1778.09', NULL, NULL, NULL, NULL, NULL, 4),
(55863, NULL, 'G3DSA:1.10.1080.10:FF:000019', NULL, NULL, 'Glutathione synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55864, NULL, 'G3DSA:3.30.450.90:FF:000015', NULL, NULL, 'General secretion pathway protein E', NULL, NULL, NULL, NULL, NULL, 4),
(55865, NULL, 'G3DSA:3.40.50.1820:FF:001120', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(55866, NULL, 'G3DSA:3.30.200.20:FF:001960', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55867, NULL, 'G3DSA:1.10.510.10:FF:003376', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55868, NULL, 'G3DSA:1.20.1250.20:FF:001511', NULL, NULL, 'Solute carrier family 2, facilitated glucose transporter member 5', NULL, NULL, NULL, NULL, NULL, 4),
(55869, NULL, 'G3DSA:3.40.50.980:FF:000031', NULL, NULL, 'N-(5-amino-5-carboxypentanoyl)-L-cysteinyl-D-valine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(55870, NULL, 'G3DSA:3.40.140.20:FF:000008', NULL, NULL, 'Bifunctional purine biosynthesis protein PURH', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(55871, NULL, 'G3DSA:1.25.40.20:FF:000048', NULL, NULL, 'SH3 and multiple ankyrin repeat domains protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(55872, NULL, 'G3DSA:3.40.50.1700:FF:000027', NULL, NULL, 'Lin1840 protein', NULL, NULL, NULL, NULL, NULL, 4),
(55873, NULL, 'G3DSA:3.40.50.10470:FF:000009', NULL, NULL, 'Translation initiation factor eIF2B subunit', NULL, NULL, NULL, NULL, NULL, 4),
(55874, NULL, 'G3DSA:1.20.1270.60:FF:000198', NULL, NULL, 'YALI0B15686p', NULL, NULL, NULL, NULL, NULL, 4),
(55875, NULL, 'G3DSA:2.60.40.10:FF:003486', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55876, NULL, 'G3DSA:2.160.30.10:FF:000001', NULL, NULL, 'Short tail fiber protein gp12', NULL, NULL, NULL, NULL, NULL, 4),
(55877, NULL, 'G3DSA:2.40.10.170:FF:000014', NULL, NULL, 'ATP synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(55878, NULL, 'G3DSA:3.90.1410.10:FF:000126', NULL, NULL, 'ADR237Cp', NULL, NULL, NULL, NULL, NULL, 4),
(55879, NULL, 'G3DSA:2.30.40.10:FF:000087', NULL, NULL, 'Dihydropyrimidinase', NULL, NULL, NULL, NULL, NULL, 4),
(55880, NULL, 'G3DSA:1.10.30.10:FF:000033', NULL, NULL, 'nucleolar transcription factor 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(55881, NULL, 'G3DSA:1.10.1200.270:FF:000022', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(55882, NULL, 'G3DSA:3.30.2310.20:FF:000001', NULL, NULL, 'Addiction module toxin, Txe/YoeB family', NULL, NULL, NULL, NULL, NULL, 4),
(55883, NULL, 'G3DSA:1.10.1410.10:FF:000034', NULL, NULL, 'Os01g0702900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(55884, NULL, 'G3DSA:3.50.50.60:FF:000110', NULL, NULL, 'Nitrite reductase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(55885, NULL, 'G3DSA:2.130.10.10:FF:001777', NULL, NULL, 'Neural precursor cell-expressed, developmentally down-regulated 1', NULL, NULL, NULL, NULL, NULL, 4),
(55886, NULL, 'G3DSA:1.25.40.20:FF:000481', NULL, NULL, 'Oxysterol-binding family protein', NULL, NULL, NULL, NULL, NULL, 4),
(55887, NULL, 'G3DSA:3.70.10.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55888, NULL, 'G3DSA:1.10.10.10:FF:002050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55889, NULL, 'G3DSA:2.60.120.920:FF:000087', NULL, NULL, 'Tripartite motif-containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(55890, NULL, 'G3DSA:3.40.910.10:FF:000025', NULL, NULL, 'Deoxyhypusine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(55891, NULL, 'G3DSA:2.30.180.10:FF:000154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55892, NULL, 'G3DSA:3.40.50.1100:FF:000049', NULL, NULL, 'Cysteine synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55893, NULL, 'G3DSA:3.90.79.10:FF:000221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55894, NULL, 'G3DSA:1.20.1530.20:FF:000021', NULL, NULL, 'Probable sodium/metabolite cotransporter BASS4, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(55895, NULL, 'G3DSA:3.90.1430.10:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55896, NULL, 'G3DSA:3.30.565.10:FF:000230', NULL, NULL, 'PAS domain-containing sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(55897, NULL, 'G3DSA:2.30.180.10:FF:000042', NULL, NULL, 'Fasciclin domain family', NULL, NULL, NULL, NULL, NULL, 4),
(55898, NULL, 'G3DSA:3.30.1360.170:FF:000004', NULL, NULL, 'Flavin-dependent thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(55899, NULL, 'G3DSA:2.30.30.190:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55900, NULL, 'G3DSA:3.40.50.300:FF:003863', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55901, NULL, 'G3DSA:1.10.1200.120:FF:000005', NULL, NULL, 'Large-conductance mechanosensitive channel', NULL, NULL, NULL, NULL, NULL, 4),
(55902, NULL, 'G3DSA:1.10.10.10:FF:001561', NULL, NULL, 'Cullin 4B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55903, NULL, 'G3DSA:2.60.40.10:FF:004110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55904, NULL, 'G3DSA:3.40.50.10860:FF:000031', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(55905, NULL, 'G3DSA:1.20.1250.20:FF:000775', NULL, NULL, 'Drug resistance translocase', NULL, NULL, NULL, NULL, NULL, 4),
(55906, NULL, 'G3DSA:1.10.287.600:FF:000003', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(55907, NULL, 'G3DSA:2.60.120.330:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55908, NULL, 'G3DSA:3.50.50.60:FF:001077', NULL, NULL, 'Os04g0224900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(55909, NULL, 'G3DSA:3.40.50.300:FF:007578', NULL, NULL, 'Helicase, ATP-dependent, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55910, NULL, 'G3DSA:3.10.250.10:FF:000037', NULL, NULL, 'Transmembrane protease serine 3', NULL, NULL, NULL, NULL, NULL, 4),
(55911, NULL, 'G3DSA:3.30.810.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55912, NULL, 'G3DSA:1.10.8.870:FF:000001', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(55913, NULL, 'G3DSA:3.40.50.2000:FF:000909', NULL, NULL, 'UDP-N-acetylglucosamine 2-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(55914, NULL, 'G3DSA:3.30.1360.180:FF:000007', NULL, NULL, 'Nucleotide phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(55915, NULL, 'G3DSA:1.10.132.60:FF:000004', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(55916, NULL, 'G3DSA:3.40.50.300:FF:000086', NULL, NULL, 'Ras-related small GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(55917, NULL, 'G3DSA:1.10.10.60:FF:000350', NULL, NULL, 'Tigger transposable element derived 6', NULL, NULL, NULL, NULL, NULL, 4),
(55918, NULL, 'G3DSA:2.30.31.10:FF:000004', NULL, NULL, 'RNA polymerase II transcriptional coactivator KELP', NULL, NULL, NULL, NULL, NULL, 4),
(55919, NULL, 'G3DSA:1.25.40.10:FF:001905', NULL, NULL, 'Nephrocystin-3', NULL, NULL, NULL, NULL, NULL, 4),
(55920, NULL, 'G3DSA:3.30.70.330:FF:001192', NULL, NULL, 'TIA-1/TIAL RNA binding protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(55921, NULL, 'G3DSA:3.30.930.10:FF:000186', NULL, NULL, 'Aspartyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(55922, NULL, 'G3DSA:3.90.1780.10:FF:000002', NULL, NULL, 'Hemagglutinin', NULL, NULL, NULL, NULL, NULL, 4),
(55923, NULL, 'G3DSA:1.10.510.10:FF:004207', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55924, NULL, 'G3DSA:2.60.40.60:FF:000044', NULL, NULL, 'Cadherin, EGF LAG seven-pass G-type receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(55925, NULL, 'G3DSA:3.50.50.60:FF:001307', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(55926, NULL, 'G3DSA:3.90.730.10:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55927, NULL, 'G3DSA:1.25.40.20:FF:001678', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55928, NULL, 'G3DSA:2.60.40.650:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55929, NULL, 'G3DSA:2.130.10.10:FF:003464', NULL, NULL, 'Kinesin family member 21B', NULL, NULL, NULL, NULL, NULL, 4),
(55930, NULL, 'G3DSA:3.40.30.10:FF:000336', NULL, NULL, '2-hydroxychromene-2-carboxylate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(55931, NULL, 'G3DSA:3.90.550.10:FF:000132', NULL, NULL, 'UDP-glucose:glycoprotein glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(55932, NULL, 'G3DSA:2.160.20.70:FF:000035', NULL, NULL, 'Adenylyl cyclase-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(55933, NULL, 'G3DSA:3.30.160.60:FF:003716', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55934, NULL, 'G3DSA:1.25.40.10:FF:001675', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(55935, NULL, 'G3DSA:3.40.50.300:FF:002121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55936, NULL, 'G3DSA:2.60.40.10:FF:006015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55937, NULL, 'G3DSA:1.20.120.790:FF:000030', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55938, NULL, 'G3DSA:1.10.418.10:FF:000120', NULL, NULL, 'Calponin domain containing protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(55939, NULL, 'G3DSA:1.10.3200.20:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55940, NULL, 'G3DSA:3.30.420.10:FF:000658', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55941, NULL, 'G3DSA:1.20.1070.10:FF:001410', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55942, NULL, 'G3DSA:3.30.160.60:FF:000153', NULL, NULL, 'Zinc finger RNA-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(55943, NULL, 'G3DSA:1.25.40.20:FF:001908', NULL, NULL, 'Protein 21.1', NULL, NULL, NULL, NULL, NULL, 4),
(55944, NULL, 'G3DSA:4.10.1060.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55945, NULL, 'G3DSA:2.10.90.10:FF:000080', NULL, NULL, 'Nodal homolog 4-A', NULL, NULL, NULL, NULL, NULL, 4),
(55946, NULL, 'G3DSA:3.90.190.10:FF:000615', NULL, NULL, 'Protein tyrosine phosphatase, receptor type S', NULL, NULL, NULL, NULL, NULL, 4),
(55947, NULL, 'G3DSA:1.20.140.150:FF:000050', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(55948, NULL, 'G3DSA:3.40.605.10:FF:000018', NULL, NULL, 'Ethanolamine utilization aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(55949, NULL, 'G3DSA:3.30.200.20:FF:001067', NULL, NULL, 'CAMK/CAMKL protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(55950, NULL, 'G3DSA:2.60.40.1180:FF:000120', NULL, NULL, 'Glucosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55951, NULL, 'G3DSA:2.170.11.10:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55952, NULL, 'G3DSA:3.80.10.10:FF:000558', NULL, NULL, 'Si:ch211-11p18.6', NULL, NULL, NULL, NULL, NULL, 4),
(55953, NULL, 'G3DSA:1.20.120.350:FF:000252', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55954, NULL, 'G3DSA:1.20.140.10:FF:000080', NULL, NULL, 'Acyl-Coenzyme A dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(55955, NULL, 'G3DSA:2.30.29.30:FF:000853', NULL, NULL, 'SMEK (Dictyostelium Suppressor of MEK null) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(55956, NULL, 'G3DSA:3.30.1490.20:FF:000047', NULL, NULL, 'ATP-grasp domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(55957, NULL, 'G3DSA:2.60.40.10:FF:000613', NULL, NULL, 'Leptin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(55958, NULL, 'G3DSA:3.40.50.300:FF:004138', NULL, NULL, 'Related to Cell division control protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(55959, NULL, 'G3DSA:1.10.533.10:FF:000180', NULL, NULL, 'Si:dkeyp-97b10.3', NULL, NULL, NULL, NULL, NULL, 4),
(55960, NULL, 'G3DSA:1.10.630.10:FF:000776', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55961, NULL, 'G3DSA:3.10.20.410:FF:000007', NULL, NULL, 'Fimbrial outer membrane usher protein', NULL, NULL, NULL, NULL, NULL, 4),
(55962, NULL, 'G3DSA:2.70.50.70:FF:000002', NULL, NULL, 'Endoglucanase II', NULL, NULL, NULL, NULL, NULL, 4),
(55963, NULL, 'G3DSA:1.10.287.70:FF:000759', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(55964, NULL, 'G3DSA:2.60.40.640:FF:000016', NULL, NULL, 'thioredoxin-interacting protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(55965, NULL, 'G3DSA:1.20.5.110:FF:000215', NULL, NULL, 'Vesicle-trafficking protein SEC22b-B', NULL, NULL, NULL, NULL, NULL, 4),
(55966, NULL, 'G3DSA:3.30.40.10:FF:000697', NULL, NULL, 'Bonus, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(55967, NULL, 'G3DSA:2.40.420.20:FF:000034', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(55968, NULL, 'G3DSA:3.40.1180.10:FF:000007', NULL, NULL, 'Alkyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(55969, NULL, 'G3DSA:1.20.1440.100:FF:000015', NULL, NULL, 'MmyP', NULL, NULL, NULL, NULL, NULL, 4),
(55970, NULL, 'G3DSA:2.60.120.310:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55971, NULL, 'G3DSA:3.10.50.40:FF:000022', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(55972, NULL, 'G3DSA:2.60.120.10:FF:000239', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(55973, NULL, 'G3DSA:3.30.60.90:FF:000008', NULL, NULL, 'Transcriptional adapter 2', NULL, NULL, NULL, NULL, NULL, 4),
(55974, NULL, 'G3DSA:2.70.50.80:FF:000005', NULL, NULL, 'Transcription enhancer factor-like protein egl-44', NULL, NULL, NULL, NULL, NULL, 4),
(55975, NULL, 'G3DSA:3.40.50.1820:FF:000496', NULL, NULL, 'Protein AUXIN RESPONSE 4 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(55976, NULL, 'G3DSA:3.20.20.70:FF:000433', NULL, NULL, '2-isopropylmalate synthase 1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(55977, NULL, 'G3DSA:4.10.400.10:FF:000219', NULL, NULL, 'LDL receptor protein 1, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(55978, NULL, 'G3DSA:1.10.150.210:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55979, NULL, 'G3DSA:1.10.10.60:FF:000024', NULL, NULL, 'DNA-directed RNA polymerases I, II, and III subunit', NULL, NULL, NULL, NULL, NULL, 4),
(55980, NULL, 'G3DSA:3.30.160.60:FF:004205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55981, NULL, 'G3DSA:3.30.200.20:FF:001634', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55982, NULL, 'G3DSA:1.25.10.10:FF:002123', NULL, NULL, 'Serine/threonine-protein kinase ULK4', NULL, NULL, NULL, NULL, NULL, 4),
(55983, NULL, 'G3DSA:2.60.200.20:FF:000052', NULL, NULL, 'Microspherule protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(55984, NULL, 'G3DSA:3.30.160.60:FF:000158', NULL, NULL, 'Zinc finger protein 362', NULL, NULL, NULL, NULL, NULL, 4),
(55985, NULL, 'G3DSA:3.40.50.720:FF:001167', NULL, NULL, 'Pentafunctional AROM polypeptide, putative', NULL, NULL, NULL, NULL, NULL, 4),
(55986, NULL, 'G3DSA:3.30.450.260:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(55987, NULL, 'G3DSA:3.30.70.340:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55988, NULL, 'G3DSA:1.10.472.80:FF:000266', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55989, NULL, 'G3DSA:3.30.70.2280:FF:000001', NULL, NULL, 'ATP-dependent RNA helicase DDX50', NULL, NULL, NULL, NULL, NULL, 4),
(55990, NULL, 'G3DSA:3.30.890.10:FF:000013', NULL, NULL, 'Methyl-CpG-binding domain protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(55991, NULL, 'G3DSA:3.40.950.10:FF:000022', NULL, NULL, 'Periplasmic [Fe] hydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(55992, NULL, 'G3DSA:1.20.1280.50:FF:000151', NULL, NULL, 'F-box/kelch-repeat protein At5g42360', NULL, NULL, NULL, NULL, NULL, 4),
(55993, NULL, 'G3DSA:3.30.70.330:FF:000011', NULL, NULL, 'trinucleotide repeat-containing gene 6A protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(55994, NULL, 'G3DSA:2.130.10.10:FF:005829', NULL, NULL, 'Putative CPSF-domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(55995, NULL, 'G3DSA:2.60.200.40:FF:000058', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(55996, NULL, 'G3DSA:3.50.50.60:FF:001184', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(55997, NULL, 'G3DSA:1.10.246.190:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(55998, NULL, 'G3DSA:3.30.450.20:FF:000489', NULL, NULL, 'Sensor histidine kinase, PAS and GAF domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(55999, NULL, 'G3DSA:1.20.58.60:FF:000853', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56000, NULL, 'G3DSA:3.40.50.2000:FF:000786', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56001, NULL, 'G3DSA:3.30.930.10:FF:000293', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56002, NULL, 'G3DSA:1.10.132.70:FF:000002', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(56003, NULL, 'G3DSA:3.40.50.300:FF:006162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56004, NULL, 'G3DSA:3.20.20.370:FF:000015', NULL, NULL, 'Carbohydrate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(56005, NULL, 'G3DSA:1.25.10.10:FF:000217', NULL, NULL, '20S cyclosome subunit (APC1/BimE)', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(56006, NULL, 'G3DSA:1.10.150.200:FF:000002', NULL, NULL, 'Maltooligosyl trehalose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(56007, NULL, 'G3DSA:1.10.510.10:FF:001690', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56008, NULL, 'G3DSA:2.60.40.10:FF:003379', NULL, NULL, 'GM15906', NULL, NULL, NULL, NULL, NULL, 4),
(56009, NULL, 'G3DSA:1.10.246.20:FF:000015', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 15', NULL, NULL, NULL, NULL, NULL, 4),
(56010, NULL, 'G3DSA:1.10.630.10:FF:000557', NULL, NULL, 'Os01g0350200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(56011, NULL, 'G3DSA:3.40.250.10:FF:000238', NULL, NULL, 'Protein CBG23257', NULL, NULL, NULL, NULL, NULL, 4),
(56012, NULL, 'G3DSA:2.130.10.10:FF:001558', NULL, NULL, 'Eukaryotic translation initiation factor 2A', NULL, NULL, NULL, NULL, NULL, 4),
(56013, NULL, 'G3DSA:3.30.70.330:FF:001641', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56014, NULL, 'G3DSA:2.60.40.1860:FF:000003', NULL, NULL, 'Protein-arginine deiminase type-4', NULL, NULL, NULL, NULL, NULL, 4),
(56015, NULL, 'G3DSA:1.25.40.10:FF:000601', NULL, NULL, 'DNAJ heat shock N-terminal domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(56016, NULL, 'G3DSA:1.25.40.570:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56017, NULL, 'G3DSA:3.40.50.300:FF:005903', NULL, NULL, 'tRNA modification GTPase MnmE', NULL, NULL, NULL, NULL, NULL, 4),
(56018, NULL, 'G3DSA:1.25.40.10:FF:003148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56019, NULL, 'G3DSA:3.30.200.20:FF:001286', NULL, NULL, 'serine/threonine-protein kinase Chk1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(56020, NULL, 'G3DSA:1.25.40.180:FF:000277', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56021, NULL, 'G3DSA:2.120.10.30:FF:000002', NULL, NULL, 'low-density lipoprotein receptor isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(56022, NULL, 'G3DSA:2.30.110.10:FF:000105', NULL, NULL, 'Pyridoxamine 5''-phosphate oxidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(56023, NULL, 'G3DSA:1.10.510.10:FF:003483', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56024, NULL, 'G3DSA:3.40.50.300:FF:006504', NULL, NULL, 'GTP-binding protein hflx, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56025, NULL, 'G3DSA:1.25.40.20:FF:000604', NULL, NULL, 'CBN-TRP-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(56026, NULL, 'G3DSA:1.20.120.1750:FF:000111', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(56027, NULL, 'G3DSA:2.30.30.140:FF:000181', NULL, NULL, 'Ubiquitin family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56028, NULL, 'G3DSA:3.30.160.60:FF:006341', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56029, NULL, 'G3DSA:1.25.70.10:FF:000103', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56030, NULL, 'G3DSA:3.40.630.30:FF:000431', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56031, NULL, 'G3DSA:3.40.50.2000:FF:001062', NULL, NULL, 'Glycogen [starch] synthase', NULL, NULL, NULL, NULL, NULL, 4),
(56032, NULL, 'G3DSA:3.10.20.90:FF:000400', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56033, NULL, 'G3DSA:2.30.39.10:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56034, NULL, 'G3DSA:1.10.287.2250:FF:000010', NULL, NULL, 'AGAP002720-PA', NULL, NULL, NULL, NULL, NULL, 4),
(56035, NULL, 'G3DSA:3.30.9.10:FF:000282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56036, NULL, 'G3DSA:1.10.10.60:FF:001199', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56037, NULL, 'G3DSA:3.40.50.150:FF:001654', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56038, NULL, 'G3DSA:2.40.10.10:FF:000270', NULL, NULL, 'GM15595', NULL, NULL, NULL, NULL, NULL, 4),
(56039, NULL, 'G3DSA:3.20.20.80:FF:000329', NULL, NULL, 'Chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(56040, NULL, 'G3DSA:3.40.50.300:FF:001957', NULL, NULL, 'Disease resistance protein (TIR-NBS-LRR class)', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(56041, NULL, 'G3DSA:1.25.40.10:FF:002979', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(56042, NULL, 'G3DSA:1.25.10.10:FF:002016', NULL, NULL, 'Armadillo-type protein', NULL, NULL, NULL, NULL, NULL, 4),
(56043, NULL, 'G3DSA:1.10.290.10:FF:000002', NULL, NULL, 'DNA topoisomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(56044, NULL, 'G3DSA:2.130.10.10:FF:000035', NULL, NULL, 'Putative echinoderm microtubule-associated protein-like 6', NULL, NULL, NULL, NULL, NULL, 4),
(56045, NULL, 'G3DSA:2.60.60.20:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56046, NULL, 'G3DSA:2.30.30.30:FF:000013', NULL, NULL, 'Transcription elongation factor SPT5', NULL, NULL, NULL, NULL, NULL, 4),
(56047, NULL, 'G3DSA:2.30.30.100:FF:000079', NULL, NULL, 'Sm B', NULL, NULL, NULL, NULL, NULL, 4),
(56048, NULL, 'G3DSA:3.40.30.10:FF:000662', NULL, NULL, 'YALI0D11066p', NULL, NULL, NULL, NULL, NULL, 4),
(56049, NULL, 'G3DSA:3.30.60.20:FF:000122', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(56050, NULL, 'G3DSA:3.90.1200.10:FF:000077', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(56051, NULL, 'G3DSA:3.40.50.11980:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56052, NULL, 'G3DSA:3.30.60.30:FF:000125', NULL, NULL, 'GM10857', NULL, NULL, NULL, NULL, NULL, 4),
(56053, NULL, 'G3DSA:3.30.300.10:FF:000048', NULL, NULL, 'GMP synthase [glutamine-hydrolyzing]', NULL, NULL, NULL, NULL, NULL, 4),
(56054, NULL, 'G3DSA:3.30.565.10:FF:000016', NULL, NULL, 'Chemotaxis protein CheA, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56055, NULL, 'G3DSA:3.40.50.720:FF:000566', NULL, NULL, 'Putative xanthine dehydrogenase accessory factor subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(56056, NULL, 'G3DSA:3.40.50.1820:FF:000619', NULL, NULL, 'IP21433p', NULL, NULL, NULL, NULL, NULL, 4),
(56057, NULL, 'G3DSA:1.25.40.10:FF:003255', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(56058, NULL, 'G3DSA:2.70.50.30:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56059, NULL, 'G3DSA:1.20.1560.10:FF:000661', NULL, NULL, 'AGAP009835-PA', NULL, NULL, NULL, NULL, NULL, 4),
(56060, NULL, 'G3DSA:3.40.50.300:FF:006611', NULL, NULL, 'ATP binding cassette subfamily A member 2', NULL, NULL, NULL, NULL, NULL, 4),
(56061, NULL, 'G3DSA:1.10.8.60:FF:000495', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56062, NULL, 'G3DSA:3.40.50.300:FF:000434', NULL, NULL, 'Katanin p60 ATPase-containing subunit A-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(56063, NULL, 'G3DSA:2.60.40.1180:FF:000232', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(56064, NULL, 'G3DSA:1.10.555.10:FF:000146', NULL, NULL, 'Similar to rho-type GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(56065, NULL, 'G3DSA:2.30.29.30:FF:000965', NULL, NULL, 'AFR725Cp', NULL, NULL, NULL, NULL, NULL, 4),
(56066, NULL, 'G3DSA:1.10.1130.10:FF:000001', NULL, NULL, 'Periplasmic nitrate reductase, electron transfer subunit', NULL, NULL, NULL, NULL, NULL, 4),
(56067, NULL, 'G3DSA:2.60.40.10:FF:005852', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56068, NULL, 'G3DSA:3.30.70.1230:FF:000153', NULL, NULL, 'Guanylyl cyclase, membrane', NULL, NULL, NULL, NULL, NULL, 4),
(56069, NULL, 'G3DSA:1.10.1740.10:FF:000025', NULL, NULL, 'ECF RNA polymerase sigma factor SigM', NULL, NULL, NULL, NULL, NULL, 4),
(56070, NULL, 'G3DSA:2.60.120.370:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56071, NULL, 'G3DSA:3.90.1100.10:FF:000030', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(56072, NULL, 'G3DSA:1.25.40.20:FF:000262', NULL, NULL, 'E3 ubiquitin-protein ligase XBAT33', NULL, NULL, NULL, NULL, NULL, 4),
(56073, NULL, 'G3DSA:3.40.50.300:FF:002233', NULL, NULL, 'Signal recognition particle binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(56074, NULL, 'G3DSA:2.60.40.60:FF:000600', NULL, NULL, 'Protocadherin 1 gamma 32', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(56075, NULL, 'G3DSA:3.40.50.2000:FF:000679', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56076, NULL, 'G3DSA:3.40.1110.10:FF:000059', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(56077, NULL, 'G3DSA:1.10.437.10:FF:000035', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(56078, NULL, 'G3DSA:3.20.80.10:FF:000003', NULL, NULL, 'Heme-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(56079, NULL, 'G3DSA:1.50.40.10:FF:000206', NULL, NULL, 'Protein CBG03753', NULL, NULL, NULL, NULL, NULL, 4),
(56080, NULL, 'G3DSA:1.10.3080.10:FF:000019', NULL, NULL, 'Voltage-gated chloride channel', NULL, NULL, NULL, NULL, NULL, 4),
(56081, NULL, 'G3DSA:2.60.120.380:FF:000015', NULL, NULL, 'Calpain', NULL, NULL, NULL, NULL, NULL, 4),
(56082, NULL, 'G3DSA:3.40.50.140:FF:000021', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(56083, NULL, 'G3DSA:3.50.50.60:FF:001419', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56084, NULL, 'G3DSA:1.25.10.10:FF:001847', NULL, NULL, 'Dynein, axonemal, assembly factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(56085, NULL, 'G3DSA:3.20.20.70:FF:000326', NULL, NULL, 'Putative Dihydrodipicolinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(56086, NULL, 'G3DSA:1.10.8.1220:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56087, NULL, 'G3DSA:1.10.10.350:FF:000006', NULL, NULL, 'Glutamate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(56088, NULL, 'G3DSA:3.40.50.300:FF:002340', NULL, NULL, 'Axonemal dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(56089, NULL, 'G3DSA:2.40.240.10:FF:000045', NULL, NULL, 'Glutamine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(56090, NULL, 'G3DSA:2.40.50.100:FF:000013', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(56091, NULL, 'G3DSA:3.90.400.10:FF:000020', NULL, NULL, 'Alpha-amylase SusG', NULL, NULL, NULL, NULL, NULL, 4),
(56092, NULL, 'G3DSA:2.30.30.40:FF:000016', NULL, NULL, 'RIMS-binding protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(56093, NULL, 'G3DSA:1.25.40.10:FF:001349', NULL, NULL, 'Dia2p', NULL, NULL, NULL, NULL, NULL, 4),
(56094, NULL, 'G3DSA:1.25.40.10:FF:003474', NULL, NULL, 'Os05g0112900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(56095, NULL, 'G3DSA:2.30.29.30:FF:001016', NULL, NULL, 'IQ motif and SEC7 domain-containing protein 2 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(56096, NULL, 'G3DSA:2.10.25.10:FF:000788', NULL, NULL, 'Neurogenic locus notch homolog protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(56097, NULL, 'G3DSA:2.70.130.10:FF:000018', NULL, NULL, 'N-acetylglucosamine-1-phosphotransferase subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(56098, NULL, 'G3DSA:3.30.160.60:FF:002631', NULL, NULL, 'zinc finger protein 407 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(56099, NULL, 'G3DSA:3.30.2020.30:FF:000015', NULL, NULL, 'Taurine catabolism dioxygenase TauD, TfdA family-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(56100, NULL, 'G3DSA:3.30.1330.30:FF:000106', NULL, NULL, 'YALI0F07447p', NULL, NULL, NULL, NULL, NULL, 4),
(56101, NULL, 'G3DSA:2.60.40.640:FF:000011', NULL, NULL, 'S-arrestin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(56102, NULL, 'G3DSA:3.30.70.330:FF:001315', NULL, NULL, 'RNA-binding protein with serine-rich domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(56103, NULL, 'G3DSA:2.10.25.10:FF:001412', NULL, NULL, 'Protein lin-12', NULL, NULL, NULL, NULL, NULL, 4),
(56104, NULL, 'G3DSA:3.90.190.10:FF:000508', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56105, NULL, 'G3DSA:4.10.60.10:FF:000011', NULL, NULL, 'splicing factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(56106, NULL, 'G3DSA:3.90.245.10:FF:000018', NULL, NULL, 'Inosine-uridine preferring nucleoside hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(56107, NULL, 'G3DSA:3.30.160.60:FF:005285', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(56108, NULL, 'G3DSA:2.130.10.10:FF:000254', NULL, NULL, 'dmX-like protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(56109, NULL, 'G3DSA:2.40.10.10:FF:000163', NULL, NULL, 'AGAP001251-PA', NULL, NULL, NULL, NULL, NULL, 4),
(56110, NULL, 'G3DSA:1.10.630.10:FF:000664', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56111, NULL, 'G3DSA:2.120.10.30:FF:000221', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(56112, NULL, 'G3DSA:2.60.120.10:FF:000565', NULL, NULL, 'Cyclic AMP-dependent protein kinase-like protein regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(56113, NULL, 'G3DSA:2.60.40.650:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56114, NULL, 'G3DSA:3.90.1410.10:FF:000014', NULL, NULL, 'SET domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(56115, NULL, 'G3DSA:3.40.120.10:FF:000010', NULL, NULL, 'phosphomannomutase/phosphoglucomutase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(56116, NULL, 'G3DSA:2.30.29.30:FF:000746', NULL, NULL, 'Serine/threonine-protein kinase NrkA', NULL, NULL, NULL, NULL, NULL, 4),
(56117, NULL, 'G3DSA:1.20.1070.10:FF:000567', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56118, NULL, 'G3DSA:1.10.8.10:FF:000290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56119, NULL, 'G3DSA:1.10.506.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56120, NULL, 'G3DSA:3.30.200.20:FF:001179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56121, NULL, 'G3DSA:2.130.10.10:FF:001665', NULL, NULL, 'U3 small nucleolar RNA-associated protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(56122, NULL, 'G3DSA:3.10.450.240:FF:000030', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(56123, NULL, 'G3DSA:1.20.1720.10:FF:000084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56124, NULL, 'G3DSA:3.90.1480.20:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56125, NULL, 'G3DSA:2.60.40.10:FF:003598', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56126, NULL, 'G3DSA:3.20.20.60:FF:000104', NULL, NULL, 'Putative lysase', NULL, NULL, NULL, NULL, NULL, 4),
(56127, NULL, 'G3DSA:4.10.280.10:FF:000119', NULL, NULL, 'Helix Loop Helix', NULL, NULL, NULL, NULL, NULL, 4),
(56128, NULL, 'G3DSA:1.20.1110.10:FF:000048', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(56129, NULL, 'G3DSA:1.20.1070.10:FF:000909', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56130, NULL, 'G3DSA:1.20.1560.10:FF:000880', NULL, NULL, 'Chromosome 21, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(56131, NULL, 'G3DSA:1.25.10.10:FF:003427', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(56132, NULL, 'G3DSA:3.30.1040.20:FF:000002', NULL, NULL, 'Thiol-activated cytolysin', NULL, NULL, NULL, NULL, NULL, 4),
(56133, NULL, 'G3DSA:1.25.40.10:FF:003822', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56134, NULL, 'G3DSA:1.25.40.10:FF:003603', NULL, NULL, 'Squamous cell carcinoma antigen recognized by T-cells 3', NULL, NULL, NULL, NULL, NULL, 4),
(56135, NULL, 'G3DSA:3.30.360.10:FF:000041', NULL, NULL, 'Dihydrodipicolinate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(56136, NULL, 'G3DSA:3.40.50.410:FF:000349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56137, NULL, 'G3DSA:3.10.105.10:FF:000026', NULL, NULL, 'Extracellular solute-binding protein, family 5', NULL, NULL, NULL, NULL, NULL, 4),
(56138, NULL, 'G3DSA:1.25.40.70:FF:000035', NULL, NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(56139, NULL, 'G3DSA:3.30.65.10:FF:000001', NULL, NULL, 'DNA topoisomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(56140, NULL, 'G3DSA:1.20.1540.10:FF:000098', NULL, NULL, 'Integral membrane protein Rhomboid homolog', NULL, NULL, NULL, NULL, NULL, 4),
(56141, NULL, 'G3DSA:2.60.40.10:FF:001917', NULL, NULL, 'Protogenin', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(56142, NULL, 'G3DSA:2.40.30.10:FF:000046', NULL, NULL, 'Elongation factor Tu', NULL, NULL, NULL, NULL, NULL, 4),
(56143, NULL, 'G3DSA:3.40.720.10:FF:000325', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(56144, NULL, 'G3DSA:1.20.5.110:FF:000097', NULL, NULL, 'Syntaxin, Qa-SNARE family', NULL, NULL, NULL, NULL, NULL, 4),
(56145, NULL, 'G3DSA:2.130.10.10:FF:005936', NULL, NULL, 'Intraflagellar transport 140', NULL, NULL, NULL, NULL, NULL, 4),
(56146, NULL, 'G3DSA:3.90.550.10:FF:000137', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(56147, NULL, 'G3DSA:3.40.50.720:FF:002359', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56148, NULL, 'G3DSA:3.30.70.330:FF:001860', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56149, NULL, 'G3DSA:1.20.5.4090:FF:000002', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(56150, NULL, 'G3DSA:4.10.170.10:FF:000004', NULL, NULL, 'Nucleosome assembly protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(56151, NULL, 'G3DSA:3.40.1170.60:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56152, NULL, 'G3DSA:1.10.510.10:FF:001919', NULL, NULL, 'Protein CBR-TWK-5', NULL, NULL, NULL, NULL, NULL, 4),
(56153, NULL, 'G3DSA:3.10.290.10:FF:000039', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(56154, NULL, 'G3DSA:3.30.200.20:FF:001853', NULL, NULL, 'Ribosomal protein S6 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(56155, NULL, 'G3DSA:2.60.40.10:FF:000164', NULL, NULL, 'nexilin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(56156, NULL, 'G3DSA:1.10.10.60:FF:000243', NULL, NULL, 'Motor neuron and pancreas homeobox 1', NULL, NULL, NULL, NULL, NULL, 4),
(56157, NULL, 'G3DSA:3.80.10.10:FF:002817', NULL, NULL, 'Protein zer-1 homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(56158, NULL, 'G3DSA:1.25.40.10:FF:004311', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56159, NULL, 'G3DSA:3.30.500.10:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56160, NULL, 'G3DSA:3.40.630.30:FF:000650', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56161, NULL, 'G3DSA:3.30.160.60:FF:005498', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56162, NULL, 'G3DSA:2.60.120.10:FF:000346', NULL, NULL, 'Germin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(56163, NULL, 'G3DSA:2.130.10.10:FF:001884', NULL, NULL, 'WD domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(56164, NULL, 'G3DSA:3.40.50.720:FF:001274', NULL, NULL, 'Pentafunctional AROM polypeptide, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56165, NULL, 'G3DSA:3.40.50.2300:FF:001382', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56166, NULL, 'G3DSA:1.50.40.10:FF:000083', NULL, NULL, 'Mitochondrial substrate carrier family protein', NULL, NULL, NULL, NULL, NULL, 4),
(56167, NULL, 'G3DSA:3.30.450.20:FF:000618', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56168, NULL, 'G3DSA:3.20.20.80:FF:000655', NULL, NULL, 'Zgc:66313', NULL, NULL, NULL, NULL, NULL, 4),
(56169, NULL, 'G3DSA:3.40.1030.10:FF:000007', NULL, NULL, 'Anthranilate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(56170, NULL, 'G3DSA:3.30.160.60:FF:001788', NULL, NULL, 'ras-responsive element-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(56171, NULL, 'G3DSA:1.10.730.10:FF:000031', NULL, NULL, 'Putative Methionyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(56172, NULL, 'G3DSA:3.30.160.60:FF:006122', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56173, NULL, 'G3DSA:3.20.20.140:FF:000082', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(56174, NULL, 'G3DSA:2.40.30.190:FF:000002', NULL, NULL, 'Protein ORF2', NULL, NULL, NULL, NULL, NULL, 4),
(56175, NULL, 'G3DSA:3.30.160.60:FF:002070', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(56176, NULL, 'G3DSA:1.10.246.10:FF:000012', NULL, NULL, 'Serum albumin', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(56177, NULL, 'G3DSA:3.30.1310.20:FF:000001', NULL, NULL, 'DNA sequence', NULL, NULL, NULL, NULL, NULL, 4),
(56178, NULL, 'G3DSA:3.30.420.40:FF:000190', NULL, NULL, 'Hsp70 family chaperone Lhs1/Orp150', NULL, NULL, NULL, NULL, NULL, 4),
(56179, NULL, 'G3DSA:1.25.10.10:FF:002342', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56180, NULL, 'G3DSA:1.10.3380.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56181, NULL, 'G3DSA:3.30.505.10:FF:000125', NULL, NULL, 'GD21505', NULL, NULL, NULL, NULL, NULL, 4),
(56182, NULL, 'G3DSA:3.20.20.70:FF:000652', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56183, NULL, 'G3DSA:2.30.29.30:FF:001235', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(56184, NULL, 'G3DSA:3.40.50.720:FF:001622', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(56185, NULL, 'G3DSA:1.25.40.20:FF:000043', NULL, NULL, 'Transient receptor potential cation channel subfamily C member 7', NULL, NULL, NULL, NULL, NULL, 4),
(56186, NULL, 'G3DSA:1.20.58.90:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56187, NULL, 'G3DSA:3.40.50.720:FF:000998', NULL, NULL, 'Short-chain dehydrogenase/reductase SDR', NULL, NULL, NULL, NULL, NULL, 4),
(56188, NULL, 'G3DSA:2.60.40.1180:FF:000013', NULL, NULL, 'Alpha-L-fucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(56189, NULL, 'G3DSA:1.10.150.390:FF:000002', NULL, NULL, 'DNA-directed RNA polymerase subunit beta''''', NULL, NULL, NULL, NULL, NULL, 4),
(56190, NULL, 'G3DSA:1.25.40.10:FF:000040', NULL, NULL, 'Tetratricopeptide repeat domain 28', NULL, NULL, NULL, NULL, NULL, 4),
(56191, NULL, 'G3DSA:1.25.40.10:FF:001568', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g09900', NULL, NULL, NULL, NULL, NULL, 4),
(56192, NULL, 'G3DSA:3.30.230.80:FF:000029', NULL, NULL, 'Heat shock protein 82, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56193, NULL, 'G3DSA:1.10.510.10:FF:003825', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56194, NULL, 'G3DSA:1.20.5.5160:FF:000008', NULL, NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', NULL, NULL, NULL, NULL, NULL, 4),
(56195, NULL, 'G3DSA:3.90.1490.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56196, NULL, 'G3DSA:2.60.40.10:FF:005633', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56197, NULL, 'G3DSA:3.40.1110.10:FF:000278', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56198, NULL, 'G3DSA:2.60.40.10:FF:000506', NULL, NULL, 'HEPACAM family member 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(56199, NULL, 'G3DSA:2.130.10.10:FF:002160', NULL, NULL, 'Autophagy related 16 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(56200, NULL, 'G3DSA:1.20.58.70:FF:000041', NULL, NULL, 'Pep12p', NULL, NULL, NULL, NULL, NULL, 4),
(56201, NULL, 'G3DSA:3.20.20.140:FF:000424', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56202, NULL, 'G3DSA:1.20.58.80:FF:000044', NULL, NULL, 'SD04548p', NULL, NULL, NULL, NULL, NULL, 4),
(56203, NULL, 'G3DSA:3.90.1140.10:FF:000021', NULL, NULL, 'AaceriAEL214Cp', NULL, NULL, NULL, NULL, NULL, 4),
(56204, NULL, 'G3DSA:3.80.10.10:FF:002475', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56205, NULL, 'G3DSA:3.40.50.150:FF:001873', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56206, NULL, 'G3DSA:3.30.160.60:FF:002412', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(56207, NULL, 'G3DSA:3.10.490.20:FF:000030', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(56208, NULL, 'G3DSA:3.20.10.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56209, NULL, 'G3DSA:3.40.30.10:FF:000443', NULL, NULL, 'Ubiquitin regulatory X', NULL, NULL, NULL, NULL, NULL, 4),
(56210, NULL, 'G3DSA:1.10.8.60:FF:000276', NULL, NULL, 'Origin of replication binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56211, NULL, 'G3DSA:2.80.10.50:FF:000038', NULL, NULL, 'very large A-kinase anchor protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(56212, NULL, 'G3DSA:1.10.472.80:FF:000154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56213, NULL, 'G3DSA:3.90.190.10:FF:000492', NULL, NULL, 'Dual specificity phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(56214, NULL, 'G3DSA:3.90.70.10:FF:000128', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 15', NULL, NULL, NULL, NULL, NULL, 4),
(56215, NULL, 'G3DSA:3.30.200.20:FF:001522', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(56216, NULL, 'G3DSA:3.30.230.10:FF:000397', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56217, NULL, 'G3DSA:3.30.365.10:FF:000029', NULL, NULL, 'Aldehyde oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(56218, NULL, 'G3DSA:1.10.1900.10:FF:000015', NULL, NULL, 'Hyperplastic discs, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(56219, NULL, 'G3DSA:4.10.400.10:FF:000107', NULL, NULL, 'low-density lipoprotein receptor-related protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(56220, NULL, 'G3DSA:1.10.510.10:FF:002414', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56221, NULL, 'G3DSA:3.30.450.40:FF:000141', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(56222, NULL, 'G3DSA:1.10.510.10:FF:001796', NULL, NULL, 'UNC51-like kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56223, NULL, 'G3DSA:3.30.460.10:FF:000099', NULL, NULL, 'GM17777', NULL, NULL, NULL, NULL, NULL, 4),
(56224, NULL, 'G3DSA:3.40.50.300:FF:006050', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56225, NULL, 'G3DSA:1.25.10.10:FF:000105', NULL, NULL, 'Exportin for tRNA', NULL, NULL, NULL, NULL, NULL, 4),
(56226, NULL, 'G3DSA:3.30.70.330:FF:001753', NULL, NULL, 'RE24907p', NULL, NULL, NULL, NULL, NULL, 4),
(56227, NULL, 'G3DSA:1.10.3260.10:FF:000011', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(56228, NULL, 'G3DSA:3.40.720.10:FF:000090', NULL, NULL, 'DUF4976 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(56229, NULL, 'G3DSA:3.30.870.10:FF:000130', NULL, NULL, 'Putative endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(56230, NULL, 'G3DSA:1.20.120.1320:FF:000005', NULL, NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(56231, NULL, 'G3DSA:2.10.25.30:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56232, NULL, 'G3DSA:2.60.120.1540:FF:000003', NULL, NULL, 'Complement C3', NULL, NULL, NULL, NULL, NULL, 4),
(56233, NULL, 'G3DSA:3.80.10.10:FF:000906', NULL, NULL, 'Leucine Rich Repeat family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(56234, NULL, 'G3DSA:3.40.50.300:FF:000209', NULL, NULL, 'Cell division protein FtsK', NULL, NULL, NULL, NULL, NULL, 4),
(56235, NULL, 'G3DSA:2.60.40.690:FF:000003', NULL, NULL, 'Thioester-containing protein 2, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(56236, NULL, 'G3DSA:2.60.40.10:FF:000271', NULL, NULL, 'Sidekick cell adhesion molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(56237, NULL, 'G3DSA:3.30.200.20:FF:001398', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56238, NULL, 'G3DSA:3.10.20.90:FF:000512', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(56239, NULL, 'G3DSA:2.60.40.3210:FF:000004', NULL, NULL, 'oncoprotein-induced transcript 3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(56240, NULL, 'G3DSA:1.10.630.10:FF:000338', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56241, NULL, 'G3DSA:3.40.50.1440:FF:000022', NULL, NULL, 'Cell division protein FtsZ 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(56242, NULL, 'G3DSA:2.30.30.1020:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56243, NULL, 'G3DSA:1.50.40.10:FF:000431', NULL, NULL, 'Solute carrier family 25 member 31', NULL, NULL, NULL, NULL, NULL, 4),
(56244, NULL, 'G3DSA:3.30.2460.20:FF:000006', NULL, NULL, 'Protein Wnt', NULL, NULL, NULL, NULL, NULL, 4),
(56245, NULL, 'G3DSA:2.130.10.10:FF:001339', NULL, NULL, 'Guanine nucleotide-binding protein beta subunit-like protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(56246, NULL, 'G3DSA:1.10.840.10:FF:000039', NULL, NULL, 'Protein ste6', NULL, NULL, NULL, NULL, NULL, 4),
(56247, NULL, 'G3DSA:1.20.120.1760:FF:000002', NULL, NULL, 'Choline/ethanolamine phosphotransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(56248, NULL, 'G3DSA:3.40.50.360:FF:000082', NULL, NULL, 'Probable NAD(P)H dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(56249, NULL, 'G3DSA:3.30.1360.40:FF:000049', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(56250, NULL, 'G3DSA:1.25.40.10:FF:002170', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g22830', NULL, NULL, NULL, NULL, NULL, 4),
(56251, NULL, 'G3DSA:2.60.120.290:FF:000084', NULL, NULL, 'Zinc metalloproteinase', NULL, NULL, NULL, NULL, NULL, 4),
(56252, NULL, 'G3DSA:3.40.640.10:FF:000032', NULL, NULL, 'Histidinol-phosphate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(56253, NULL, 'G3DSA:2.130.10.10:FF:001446', NULL, NULL, 'WD domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(56254, NULL, 'G3DSA:2.130.10.10:FF:005717', NULL, NULL, 'Damage-specific DNA binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(56255, NULL, 'G3DSA:2.60.40.10:FF:003941', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56256, NULL, 'G3DSA:3.40.630.30:FF:000543', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56257, NULL, 'G3DSA:3.40.50.1460:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56258, NULL, 'G3DSA:3.40.50.300:FF:001738', NULL, NULL, 'Putative DNA repair helicase', NULL, NULL, NULL, NULL, NULL, 4),
(56259, NULL, 'G3DSA:3.40.250.10:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56260, NULL, 'G3DSA:1.10.287.110:FF:000171', NULL, NULL, 'Related to PAM16-Presequence translocase-Associated Motor', NULL, NULL, NULL, NULL, NULL, 4),
(56261, NULL, 'G3DSA:2.60.40.3200:FF:000001', NULL, NULL, 'Structural polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(56262, NULL, 'G3DSA:3.30.30.30:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56263, NULL, 'G3DSA:3.30.2440.10:FF:000002', NULL, NULL, 'SPI-2 type III secretion system effector SseJ', NULL, NULL, NULL, NULL, NULL, 4),
(56264, NULL, 'G3DSA:2.60.120.1560:FF:000009', NULL, NULL, 'Flocculation protein FLO9', NULL, NULL, NULL, NULL, NULL, 4),
(56265, NULL, 'G3DSA:3.40.50.150:FF:000350', NULL, NULL, 'Probable pectin methylesterase CGR3', NULL, NULL, NULL, NULL, NULL, 4),
(56266, NULL, 'G3DSA:3.30.930.10:FF:000074', NULL, NULL, 'Serine/threonine-protein kinase gcn2', NULL, NULL, NULL, NULL, NULL, 4),
(56267, NULL, 'G3DSA:3.10.250.10:FF:000149', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56268, NULL, 'G3DSA:3.30.160.60:FF:006116', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56269, NULL, 'G3DSA:1.10.132.10:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56270, NULL, 'G3DSA:3.40.190.80:FF:000052', NULL, NULL, 'AGAP001047-PA', NULL, NULL, NULL, NULL, NULL, 4),
(56271, NULL, 'G3DSA:1.10.132.20:FF:000015', NULL, NULL, 'Ribosome-recycling factor, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(56272, NULL, 'G3DSA:1.10.510.10:FF:001807', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56273, NULL, 'G3DSA:3.30.830.10:FF:000021', NULL, NULL, 'Cytochrome b-c1 complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(56274, NULL, 'G3DSA:3.40.50.2300:FF:001270', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56275, NULL, 'G3DSA:1.20.1560.10:FF:000767', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(56276, NULL, 'G3DSA:2.130.10.10:FF:003576', NULL, NULL, 'WD repeat domain 36', NULL, NULL, NULL, NULL, NULL, 4),
(56277, NULL, 'G3DSA:1.10.132.30:FF:000018', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(56278, NULL, 'G3DSA:2.40.50.830:FF:000001', NULL, NULL, 'mRNA-capping enzyme catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(56279, NULL, 'G3DSA:3.80.10.10:FF:004493', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(56280, NULL, 'G3DSA:3.50.70.10:FF:000012', NULL, NULL, 'Chalcone-flavonone isomerase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(56281, NULL, 'G3DSA:3.40.390.10:FF:000288', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56282, NULL, 'G3DSA:4.10.1000.10:FF:000147', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(56283, NULL, 'G3DSA:1.10.10.750:FF:000019', NULL, NULL, 'Unplaced genomic scaffold supercont1.13, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(56284, NULL, 'G3DSA:1.25.10.10:FF:001741', NULL, NULL, 'cell differentiation protein RCD1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(56285, NULL, 'G3DSA:3.40.50.200:FF:000062', NULL, NULL, 'Peptidase S53 propeptide', NULL, NULL, NULL, NULL, NULL, 4),
(56286, NULL, 'G3DSA:3.30.160.20:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56287, NULL, 'G3DSA:3.30.420.40:FF:000206', NULL, NULL, 'pantothenate kinase 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(56288, NULL, 'G3DSA:3.30.310.130:FF:000001', NULL, NULL, 'sentrin-specific protease 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(56289, NULL, 'G3DSA:3.40.50.2300:FF:001157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56290, NULL, 'G3DSA:3.30.40.10:FF:001085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56291, NULL, 'G3DSA:2.60.40.10:FF:001687', NULL, NULL, 'Neuroglian, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(56292, NULL, 'G3DSA:3.90.70.10:FF:000241', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(56293, NULL, 'G3DSA:1.10.510.10:FF:003937', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56294, NULL, 'G3DSA:3.60.10.10:FF:000278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56295, NULL, 'G3DSA:2.130.10.10:FF:005830', NULL, NULL, 'Intraflagellar transport 140 homolog (Chlamydomonas)', NULL, NULL, NULL, NULL, NULL, 4),
(56296, NULL, 'G3DSA:1.10.3380.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56297, NULL, 'G3DSA:1.10.150.20:FF:000299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56298, NULL, 'G3DSA:3.40.50.720:FF:000779', NULL, NULL, 'Homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(56299, NULL, 'G3DSA:3.40.50.10130:FF:000043', NULL, NULL, 'FA core complex-associated protein 24', NULL, NULL, NULL, NULL, NULL, 4),
(56300, NULL, 'G3DSA:3.40.33.10:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56301, NULL, 'G3DSA:1.10.565.10:FF:000192', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(56302, NULL, 'G3DSA:1.10.10.440:FF:000027', NULL, NULL, 'Formin binding protein (FNB3)', NULL, NULL, NULL, NULL, NULL, 4),
(56303, NULL, 'G3DSA:3.40.50.720:FF:001510', NULL, NULL, 'Dihydroflavonol-4-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(56304, NULL, 'G3DSA:1.20.1270.60:FF:000092', NULL, NULL, 'Gvp36p', NULL, NULL, NULL, NULL, NULL, 4),
(56305, NULL, 'G3DSA:1.10.540.10:FF:000112', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(56306, NULL, 'G3DSA:2.60.120.10:FF:000127', NULL, NULL, 'Glutamine-transport ATP-binding protein ABC transporter GLNQ', NULL, NULL, NULL, NULL, NULL, 4),
(56307, NULL, 'G3DSA:3.30.420.40:FF:000313', NULL, NULL, 'Actin family', NULL, NULL, NULL, NULL, NULL, 4),
(56308, NULL, 'G3DSA:3.40.50.150:FF:000237', NULL, NULL, 'N-methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(56309, NULL, 'G3DSA:1.20.920.30:FF:000021', NULL, NULL, 'Dynein heavy chain 6, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(56310, NULL, 'G3DSA:3.40.50.300:FF:008180', NULL, NULL, 'Protein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(56311, NULL, 'G3DSA:3.30.70.330:FF:003097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56312, NULL, 'G3DSA:2.130.10.10:FF:003795', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56313, NULL, 'G3DSA:3.30.160.60:FF:005279', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(56314, NULL, 'G3DSA:3.20.20.190:FF:000175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56315, NULL, 'G3DSA:1.10.10.10:FF:001903', NULL, NULL, 'N(4)-bis(aminopropyl)spermidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(56316, NULL, 'G3DSA:2.40.10.10:FF:000051', NULL, NULL, 'complement C2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(56317, NULL, 'G3DSA:1.50.40.10:FF:000318', NULL, NULL, 'Peroxisomal adenine nucleotide carrier 1', NULL, NULL, NULL, NULL, NULL, 4),
(56318, NULL, 'G3DSA:1.20.1250.20:FF:001163', NULL, NULL, 'Transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56319, NULL, 'G3DSA:1.20.5.110:FF:000327', NULL, NULL, 'Qa-SNARE, SYP2/Pep12p/Syntaxin 7-type', NULL, NULL, NULL, NULL, NULL, 4),
(56320, NULL, 'G3DSA:3.40.1110.10:FF:000172', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(56321, NULL, 'G3DSA:1.10.10.10:FF:000144', NULL, NULL, 'la-related protein 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(56322, NULL, 'G3DSA:2.40.50.690:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56323, NULL, 'G3DSA:3.40.1050.10:FF:000003', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(56324, NULL, 'G3DSA:3.40.50.150:FF:000018', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase K/L', NULL, NULL, NULL, NULL, NULL, 4),
(56325, NULL, 'G3DSA:1.10.510.10:FF:003718', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56326, NULL, 'G3DSA:3.60.130.10:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56327, NULL, 'G3DSA:2.40.30.10:FF:000052', NULL, NULL, 'Selenocysteine-specific elongation factor EF-Sec', NULL, NULL, NULL, NULL, NULL, 4),
(56328, NULL, 'G3DSA:3.40.50.1820:FF:000844', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56329, NULL, 'G3DSA:1.10.560.10:FF:000001', NULL, NULL, '60 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(56330, NULL, 'G3DSA:2.60.40.150:FF:000072', NULL, NULL, 'translocation protein SEC63 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(56331, NULL, 'G3DSA:3.40.50.150:FF:001547', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56332, NULL, 'G3DSA:3.30.160.60:FF:006009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56333, NULL, 'G3DSA:3.30.70.1230:FF:000046', NULL, NULL, 'Luxr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(56334, NULL, 'G3DSA:3.40.50.140:FF:000015', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(56335, NULL, 'G3DSA:1.20.5.990:FF:000001', NULL, NULL, 'TNFAIP3 interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(56336, NULL, 'G3DSA:2.70.98.30:FF:000027', NULL, NULL, 'Lysosomal alpha-mannosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56337, NULL, 'G3DSA:3.40.50.10070:FF:000002', NULL, NULL, 'Tol-Pal system protein TolB', NULL, NULL, NULL, NULL, NULL, 4),
(56338, NULL, 'G3DSA:3.60.10.10:FF:000059', NULL, NULL, 'Inositol phosphosphingolipids phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(56339, NULL, 'G3DSA:3.40.50.1010:FF:000247', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56340, NULL, 'G3DSA:3.90.1100.10:FF:000024', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(56341, NULL, 'G3DSA:1.10.287.1490:FF:000080', NULL, NULL, 'Bicaudal D', NULL, NULL, NULL, NULL, NULL, 4),
(56342, NULL, 'G3DSA:2.60.40.10:FF:002305', NULL, NULL, 'Basement membrane proteoglycan', NULL, NULL, NULL, NULL, NULL, 4),
(56343, NULL, 'G3DSA:1.25.10.10:FF:001960', NULL, NULL, 'RNA binding S1 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(56344, NULL, 'G3DSA:2.40.240.10:FF:000051', NULL, NULL, 'Glutamine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(56345, NULL, 'G3DSA:3.40.630.30:FF:000324', NULL, NULL, 'Autoinducer synthase', NULL, NULL, NULL, NULL, NULL, 4),
(56346, NULL, 'G3DSA:3.40.50.1000:FF:000025', NULL, NULL, 'HAD hydrolase, family IB', NULL, NULL, NULL, NULL, NULL, 4),
(56347, NULL, 'G3DSA:1.20.1280.50:FF:000038', NULL, NULL, 'F-box/LRR-repeat protein 17 isoform X3', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(56348, NULL, 'G3DSA:3.30.160.60:FF:000501', NULL, NULL, 'PR domain zinc finger protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(56349, NULL, 'G3DSA:3.40.33.10:FF:000028', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(56350, NULL, 'G3DSA:3.30.200.20:FF:001409', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(56351, NULL, 'G3DSA:2.40.170.20:FF:000042', NULL, NULL, 'TonB-linked outer membrane protein, SusC/RagA family', NULL, NULL, NULL, NULL, NULL, 4),
(56352, NULL, 'G3DSA:3.40.800.20:FF:000025', NULL, NULL, 'Histone deacetylase HOS1', NULL, NULL, NULL, NULL, NULL, 4),
(56353, NULL, 'G3DSA:1.25.40.10:FF:004204', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(56354, NULL, 'G3DSA:3.30.60.160:FF:000003', NULL, NULL, 'Polyhomeotic distal, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(56355, NULL, 'G3DSA:1.20.1600.10:FF:000030', NULL, NULL, 'TolC-like outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(56356, NULL, 'G3DSA:3.30.1150.10:FF:000007', NULL, NULL, 'Energy transducer TonB', NULL, NULL, NULL, NULL, NULL, 4),
(56357, NULL, 'G3DSA:3.40.50.1000:FF:000244', NULL, NULL, 'Haloacid dehalogenase-like hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(56358, NULL, 'G3DSA:3.30.40.10:FF:002389', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56359, NULL, 'G3DSA:3.40.850.10:FF:000548', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56360, NULL, 'G3DSA:3.40.50.720:FF:000892', NULL, NULL, 'Nuclear receptor binding factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(56361, NULL, 'G3DSA:1.20.58.2220:FF:000008', NULL, NULL, 'Grid2 interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(56362, NULL, 'G3DSA:1.10.20.10:FF:000190', NULL, NULL, 'Histone H2A', NULL, NULL, NULL, NULL, NULL, 4),
(56363, NULL, 'G3DSA:3.40.50.1010:FF:000028', NULL, NULL, '5''-3'' exonuclease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(56364, NULL, 'G3DSA:2.30.30.40:FF:000241', NULL, NULL, 'Menage a trois, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(56365, NULL, 'G3DSA:3.30.70.1660:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56366, NULL, 'G3DSA:2.130.10.10:FF:000029', NULL, NULL, 'WD repeat-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(56367, NULL, 'G3DSA:2.60.40.10:FF:005739', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56368, NULL, 'G3DSA:3.20.20.220:FF:000004', NULL, NULL, 'Bifunctional protein PutA', NULL, NULL, NULL, NULL, NULL, 4),
(56369, NULL, 'G3DSA:3.40.1090.10:FF:000112', NULL, NULL, 'Lysophospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(56370, NULL, 'G3DSA:1.10.3080.10:FF:000025', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(56371, NULL, 'G3DSA:3.30.70.390:FF:000001', NULL, NULL, 'EBNA1', NULL, NULL, NULL, NULL, NULL, 4),
(56372, NULL, 'G3DSA:3.40.50.150:FF:001766', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56373, NULL, 'G3DSA:1.10.510.10:FF:002521', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56374, NULL, 'G3DSA:2.40.10.10:FF:000612', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56375, NULL, 'G3DSA:3.40.50.300:FF:001845', NULL, NULL, 'Pre-mRNA-splicing helicase BRR2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56376, NULL, 'G3DSA:1.20.58.340:FF:000036', NULL, NULL, 'CorA-like Mg2+ transporter protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56377, NULL, 'G3DSA:2.10.25.10:FF:000569', NULL, NULL, 'Laminin subunit alpha 4', NULL, NULL, NULL, NULL, NULL, 4),
(56378, NULL, 'G3DSA:1.10.10.10:FF:001780', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56379, NULL, 'G3DSA:3.90.190.10:FF:000385', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56380, NULL, 'G3DSA:1.25.10.10:FF:001398', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(56381, NULL, 'G3DSA:3.60.10.10:FF:000391', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(56382, NULL, 'G3DSA:2.60.40.10:FF:004323', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56383, NULL, 'G3DSA:3.40.1800.20:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56384, NULL, 'G3DSA:3.40.50.300:FF:000428', NULL, NULL, 'TATA-binding protein-associated factor 172', NULL, NULL, NULL, NULL, NULL, 4),
(56385, NULL, 'G3DSA:3.30.70.1230:FF:000265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56386, NULL, 'G3DSA:1.10.630.10:FF:000445', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56387, NULL, 'G3DSA:3.30.70.330:FF:001534', NULL, NULL, 'RNA binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56388, NULL, 'G3DSA:3.20.20.210:FF:000001', NULL, NULL, 'Uroporphyrinogen decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(56389, NULL, 'G3DSA:1.10.442.10:FF:000002', NULL, NULL, 'Cytochrome c oxidase subunit V', NULL, NULL, NULL, NULL, NULL, 4),
(56390, NULL, 'G3DSA:1.20.1740.10:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56391, NULL, 'G3DSA:3.30.1960.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56392, NULL, 'G3DSA:1.25.40.10:FF:003367', NULL, NULL, 'Pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(56393, NULL, 'G3DSA:1.25.10.10:FF:001628', NULL, NULL, 'YALI0F19382p', NULL, NULL, NULL, NULL, NULL, 4),
(56394, NULL, 'G3DSA:1.10.10.1200:FF:000003', NULL, NULL, 'MAGE family member F1', NULL, NULL, NULL, NULL, NULL, 4),
(56395, NULL, 'G3DSA:3.90.1200.10:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56396, NULL, 'G3DSA:2.130.10.10:FF:002053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56397, NULL, 'G3DSA:4.10.400.10:FF:000220', NULL, NULL, 'Lipophorin receptor 2, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(56398, NULL, 'G3DSA:2.60.40.1730:FF:000094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56399, NULL, 'G3DSA:3.80.10.10:FF:000889', NULL, NULL, 'RE38148p', NULL, NULL, NULL, NULL, NULL, 4),
(56400, NULL, 'G3DSA:2.60.40.10:FF:001468', NULL, NULL, 'ICOS ligand isoform b', NULL, NULL, NULL, NULL, NULL, 4),
(56401, NULL, 'G3DSA:2.130.10.10:FF:003812', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56402, NULL, 'G3DSA:1.10.8.60:FF:000383', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56403, NULL, 'G3DSA:2.70.98.20:FF:000024', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(56404, NULL, 'G3DSA:3.20.20.370:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56405, NULL, 'G3DSA:3.30.1130.10:FF:000006', NULL, NULL, 'NADPH-dependent 7-cyano-7-deazaguanine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(56406, NULL, 'G3DSA:3.10.580.10:FF:000028', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(56407, NULL, 'G3DSA:3.40.50.300:FF:002452', NULL, NULL, 'ABC-type metal ion transporter', NULL, NULL, NULL, NULL, NULL, 4),
(56408, NULL, 'G3DSA:3.30.505.10:FF:000018', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type', NULL, NULL, NULL, NULL, NULL, 4),
(56409, NULL, 'G3DSA:1.20.1110.10:FF:000161', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56410, NULL, 'G3DSA:2.60.40.1730:FF:000105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56411, NULL, 'G3DSA:1.20.58.1100:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56412, NULL, 'G3DSA:2.70.98.10:FF:000021', NULL, NULL, 'Uncharacterized isomerase YNR071C', NULL, NULL, NULL, NULL, NULL, 4),
(56413, NULL, 'G3DSA:3.30.40.10:FF:001321', NULL, NULL, 'Polycomb group RING finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(56414, NULL, 'G3DSA:1.10.510.10:FF:002302', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56415, NULL, 'G3DSA:2.30.30.140:FF:000175', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(56416, NULL, 'G3DSA:3.80.10.10:FF:003200', NULL, NULL, 'Toll-like receptor 2', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(56417, NULL, 'G3DSA:1.10.3570.10:FF:000001', NULL, NULL, 'Nucleoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(56418, NULL, 'G3DSA:1.10.510.10:FF:004090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56419, NULL, 'G3DSA:2.30.110.10:FF:000094', NULL, NULL, 'AaceriAAR087Cp', NULL, NULL, NULL, NULL, NULL, 4),
(56420, NULL, 'G3DSA:3.90.1290.10:FF:000026', NULL, NULL, 'Dystonin', NULL, NULL, NULL, NULL, NULL, 4),
(56421, NULL, 'G3DSA:3.80.10.10:FF:002582', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56422, NULL, 'G3DSA:3.30.160.60:FF:004211', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56423, NULL, 'G3DSA:3.30.160.60:FF:003593', NULL, NULL, 'GM21248', NULL, NULL, NULL, NULL, NULL, 4),
(56424, NULL, 'G3DSA:1.10.274.30:FF:000004', NULL, NULL, 'Putative Chromatin modification-related protein eaf3', NULL, NULL, NULL, NULL, NULL, 4),
(56425, NULL, 'G3DSA:3.30.565.10:FF:000123', NULL, NULL, 'GHKL domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(56426, NULL, 'G3DSA:3.90.228.10:FF:000046', NULL, NULL, 'Probable inactive poly [ADP-ribose] polymerase SRO5', NULL, NULL, NULL, NULL, NULL, 4),
(56427, NULL, 'G3DSA:1.20.1250.20:FF:000449', NULL, NULL, 'monocarboxylate transporter 13', NULL, NULL, NULL, NULL, NULL, 4),
(56428, NULL, 'G3DSA:1.25.40.120:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56429, NULL, 'G3DSA:1.10.15.40:FF:000001', NULL, NULL, 'Ion-translocating oxidoreductase complex subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(56430, NULL, 'G3DSA:2.40.50.1020:FF:000015', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(56431, NULL, 'G3DSA:1.10.510.10:FF:004432', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56432, NULL, 'G3DSA:2.130.10.10:FF:003357', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56433, NULL, 'G3DSA:3.40.50.300:FF:003756', NULL, NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 10, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(56434, NULL, 'G3DSA:3.40.50.620:FF:000755', NULL, NULL, 'Os01g0259600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(56435, NULL, 'G3DSA:3.40.190.10:FF:000975', NULL, NULL, 'Peptide ABC transporter, peptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(56436, NULL, 'G3DSA:3.30.200.20:FF:000105', NULL, NULL, 'Casein kinase II subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(56437, NULL, 'G3DSA:3.90.70.10:FF:000022', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 24', NULL, NULL, NULL, NULL, NULL, 4),
(56438, NULL, 'G3DSA:3.50.50.60:FF:000003', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] flavoprotein subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(56439, NULL, 'G3DSA:1.10.287.70:FF:000198', NULL, NULL, 'TOK2 potassium channel', NULL, NULL, NULL, NULL, NULL, 4),
(56440, NULL, 'G3DSA:3.40.50.300:FF:007685', NULL, NULL, 'Protein CBR-RAB-30', NULL, NULL, NULL, NULL, NULL, 4),
(56441, NULL, 'G3DSA:2.130.10.10:FF:000361', NULL, NULL, 'Activating molecule in beclin-1-regulated autophagy', NULL, NULL, NULL, NULL, NULL, 4),
(56442, NULL, 'G3DSA:1.10.510.10:FF:000161', NULL, NULL, 'Wall-associated receptor kinase-like 20', NULL, NULL, NULL, NULL, NULL, 4),
(56443, NULL, 'G3DSA:1.10.220.10:FF:000060', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(56444, NULL, 'G3DSA:1.10.8.60:FF:000506', NULL, NULL, 'ATPase, AAA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(56445, NULL, 'G3DSA:3.10.20.90:FF:000731', NULL, NULL, 'SWAP (Suppressor-of-White-APricot)/surp domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(56446, NULL, 'G3DSA:3.40.50.150:FF:000131', NULL, NULL, 'tRNA wybutosine-synthesizing protein 2/3/4', NULL, NULL, NULL, NULL, NULL, 4),
(56447, NULL, 'G3DSA:2.60.40.10:FF:002182', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(56448, NULL, 'G3DSA:2.70.130.10:FF:000125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56449, NULL, 'G3DSA:3.80.10.10:FF:002924', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(56450, NULL, 'G3DSA:3.30.830.10:FF:000240', NULL, NULL, 'Probable mitochondrial-processing peptidase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(56451, NULL, 'G3DSA:1.10.238.10:FF:000128', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 32', NULL, NULL, NULL, NULL, NULL, 4),
(56452, NULL, 'G3DSA:3.30.9.10:FF:000175', NULL, NULL, 'N-methyl-L-tryptophan oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(56453, NULL, 'G3DSA:1.20.120.350:FF:000027', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(56454, NULL, 'G3DSA:3.80.10.10:FF:000783', NULL, NULL, 'Leucine-rich repeat-containing protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(56455, NULL, 'G3DSA:1.25.10.10:FF:000324', NULL, NULL, 'Tetratricopeptide repeat domain 12', NULL, NULL, NULL, NULL, NULL, 4),
(56456, NULL, 'G3DSA:3.40.50.300:FF:004032', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(56457, NULL, 'G3DSA:3.30.160.60:FF:003935', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56458, NULL, 'G3DSA:3.40.50.300:FF:000760', NULL, NULL, 'Cobalt ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(56459, NULL, 'G3DSA:3.20.20.70:FF:000764', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56460, NULL, 'G3DSA:1.10.287.610:FF:000006', NULL, NULL, 'DNA ligase B', NULL, NULL, NULL, NULL, NULL, 4),
(56461, NULL, 'G3DSA:3.60.21.10:FF:000073', NULL, NULL, 'Serine/threonine-protein phosphatase with EF-hands', NULL, NULL, NULL, NULL, NULL, 4),
(56462, NULL, 'G3DSA:3.40.1190.20:FF:000168', NULL, NULL, 'Carbohydrate kinase, PfkB family', NULL, NULL, NULL, NULL, NULL, 4),
(56463, NULL, 'G3DSA:1.10.418.20:FF:000011', NULL, NULL, 'Ubiquitin-like-specific protease 1D', NULL, NULL, NULL, NULL, NULL, 4),
(56464, NULL, 'G3DSA:1.20.1070.10:FF:000898', NULL, NULL, 'Vasoactive intestinal polypeptide receptor 2 variant 1', NULL, NULL, NULL, NULL, NULL, 4),
(56465, NULL, 'G3DSA:3.90.550.10:FF:000244', NULL, NULL, 'Ime2-dependent signaling-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(56466, NULL, 'G3DSA:3.20.20.80:FF:000767', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56467, NULL, 'G3DSA:2.60.40.10:FF:000052', NULL, NULL, 'Contactin 1', NULL, NULL, NULL, NULL, NULL, 4),
(56468, NULL, 'G3DSA:1.10.10.60:FF:000131', NULL, NULL, 'Ventral anterior homeobox 2', NULL, NULL, NULL, NULL, NULL, 4),
(56469, NULL, 'G3DSA:1.25.50.20:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56470, NULL, 'G3DSA:3.90.550.50:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56471, NULL, 'G3DSA:1.50.40.10:FF:000195', NULL, NULL, 'Mitochondrial carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56472, NULL, 'G3DSA:1.50.40.10:FF:000537', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56473, NULL, 'G3DSA:1.10.510.10:FF:000503', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(56474, NULL, 'G3DSA:1.20.1740.10:FF:000079', NULL, NULL, 'Amino acid APC family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(56475, NULL, 'G3DSA:1.25.40.10:FF:000152', NULL, NULL, 'Amyloid protein-binding protein 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(56476, NULL, 'G3DSA:3.30.160.60:FF:000265', NULL, NULL, 'IKAROS family zinc finger 1', NULL, NULL, NULL, NULL, NULL, 4),
(56477, NULL, 'G3DSA:3.30.1360.70:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56478, NULL, 'G3DSA:3.30.160.60:FF:006010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56479, NULL, 'G3DSA:3.30.200.20:FF:001741', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56480, NULL, 'G3DSA:3.40.120.10:FF:000009', NULL, NULL, 'Phosphoglucomutase, cytoplasmic 1', NULL, NULL, NULL, NULL, NULL, 4),
(56481, NULL, 'G3DSA:3.40.50.11190:FF:000001', NULL, NULL, 'Cytidylyltransferase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(56482, NULL, 'G3DSA:1.10.150.650:FF:000002', NULL, NULL, 'PHP domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(56483, NULL, 'G3DSA:3.40.50.10860:FF:000025', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(56484, NULL, 'G3DSA:1.25.40.20:FF:000155', NULL, NULL, 'Serine/threonine-protein kinase TNNI3K', NULL, NULL, NULL, NULL, NULL, 4),
(56485, NULL, 'G3DSA:1.10.10.10:FF:001448', NULL, NULL, 'Replication Factor A 28 kDa subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56486, NULL, 'G3DSA:4.10.280.10:FF:000226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56487, NULL, 'G3DSA:3.30.160.60:FF:000607', NULL, NULL, 'zinc finger X-chromosomal protein-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(56488, NULL, 'G3DSA:2.40.20.10:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56489, NULL, 'G3DSA:3.30.420.10:FF:000664', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56490, NULL, 'G3DSA:3.40.1350.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56491, NULL, 'G3DSA:1.25.40.10:FF:001456', NULL, NULL, 'Vegetative storage protein', NULL, NULL, NULL, NULL, NULL, 4),
(56492, NULL, 'G3DSA:3.40.50.200:FF:000168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56493, NULL, 'G3DSA:3.30.160.60:FF:005734', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56494, NULL, 'G3DSA:1.25.40.790:FF:000010', NULL, NULL, 'NTL-1a', NULL, NULL, NULL, NULL, NULL, 4),
(56495, NULL, 'G3DSA:3.80.10.10:FF:001401', NULL, NULL, 'F-box and leucine rich repeat protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(56496, NULL, 'G3DSA:1.20.120.350:FF:000140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56497, NULL, 'G3DSA:3.60.21.10:FF:000415', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56498, NULL, 'G3DSA:1.10.510.10:FF:000048', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(56499, NULL, 'G3DSA:2.60.40.10:FF:003828', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56500, NULL, 'G3DSA:1.10.287.3610:FF:000002', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(56501, NULL, 'G3DSA:1.10.238.10:FF:000241', NULL, NULL, 'Calpain-A, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(56502, NULL, 'G3DSA:3.30.70.100:FF:000066', NULL, NULL, 'Protein PYRICULARIA ORYZAE RESISTANCE 21', NULL, NULL, NULL, NULL, NULL, 4),
(56503, NULL, 'G3DSA:1.10.8.60:FF:000164', NULL, NULL, 'ATP-dependent Clp protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56504, NULL, 'G3DSA:3.40.30.10:FF:000555', NULL, NULL, 'Protein disulfide-isomerase domain', NULL, NULL, NULL, NULL, NULL, 4),
(56505, NULL, 'G3DSA:3.30.450.90:FF:000021', NULL, NULL, 'General secretion pathway protein E', NULL, NULL, NULL, NULL, NULL, 4),
(56506, NULL, 'G3DSA:3.30.70.270:FF:000089', NULL, NULL, 'Biofilm architecture maintenance protein mbaA', NULL, NULL, NULL, NULL, NULL, 4),
(56507, NULL, 'G3DSA:1.20.1070.10:FF:000679', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(56508, NULL, 'G3DSA:2.60.40.60:FF:000151', NULL, NULL, 'Cadherin 17', NULL, NULL, NULL, NULL, NULL, 4),
(56509, NULL, 'G3DSA:3.90.1740.10:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56510, NULL, 'G3DSA:1.10.10.790:FF:000003', NULL, NULL, 'Splicing factor, suppressor of white-apricot homolog', NULL, NULL, NULL, NULL, NULL, 4),
(56511, NULL, 'G3DSA:1.10.1200.270:FF:000016', NULL, NULL, 'Salicylate/benzoate carboxyl methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(56512, NULL, 'G3DSA:1.10.230.10:FF:000010', NULL, NULL, 'ATP-citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(56513, NULL, 'G3DSA:2.60.40.640:FF:000123', NULL, NULL, 'Meiotically up-regulated gene 170 protein', NULL, NULL, NULL, NULL, NULL, 4),
(56514, NULL, 'G3DSA:3.30.70.260:FF:000086', NULL, NULL, 'Methionine import ATP-binding protein MetN', NULL, NULL, NULL, NULL, NULL, 4),
(56515, NULL, 'G3DSA:1.25.40.10:FF:003586', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(56516, NULL, 'G3DSA:1.20.58.390:FF:000135', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(56517, NULL, 'G3DSA:1.10.560.10:FF:000107', NULL, NULL, 'T-complex protein 1 subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(56518, NULL, 'G3DSA:3.90.226.10:FF:000210', NULL, NULL, 'Peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(56519, NULL, 'G3DSA:3.90.550.20:FF:000028', NULL, NULL, 'Alpha-1,6-mannosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56520, NULL, 'G3DSA:3.10.20.90:FF:000057', NULL, NULL, 'Putative ubiquitin carboxyl-terminal hydrolase 7', NULL, NULL, NULL, NULL, NULL, 4),
(56521, NULL, 'G3DSA:2.10.25.10:FF:001300', NULL, NULL, 'cadherin EGF LAG seven-pass G-type receptor 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(56522, NULL, 'G3DSA:3.40.120.10:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56523, NULL, 'G3DSA:2.10.25.10:FF:000682', NULL, NULL, 'Fat-like cadherin-related tumor suppressor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(56524, NULL, 'G3DSA:2.60.120.920:FF:000093', NULL, NULL, 'Si:dkey-103k4.1', NULL, NULL, NULL, NULL, NULL, 4),
(56525, NULL, 'G3DSA:2.10.50.10:FF:000083', NULL, NULL, 'TNF receptor superfamily member 10c', NULL, NULL, NULL, NULL, NULL, 4),
(56526, NULL, 'G3DSA:1.10.555.10:FF:000253', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56527, NULL, 'G3DSA:1.20.58.60:FF:000398', NULL, NULL, 'VAB-10B protein', NULL, NULL, NULL, NULL, NULL, 4),
(56528, NULL, 'G3DSA:3.40.720.10:FF:000089', NULL, NULL, 'Sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(56529, NULL, 'G3DSA:3.30.70.1820:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56530, NULL, 'G3DSA:3.40.630.30:FF:000088', NULL, NULL, 'Ebony protein', NULL, NULL, NULL, NULL, NULL, 4),
(56531, NULL, 'G3DSA:2.130.10.10:FF:000142', NULL, NULL, 'Nuclear pore complex protein Nup214', NULL, NULL, NULL, NULL, NULL, 4),
(56532, NULL, 'G3DSA:3.80.10.10:FF:001620', NULL, NULL, 'Leucine-rich repeat receptor protein kinase EMS1', NULL, NULL, NULL, NULL, NULL, 4),
(56533, NULL, 'G3DSA:1.20.1250.20:FF:000781', NULL, NULL, 'Vesicular GLUtamate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(56534, NULL, 'G3DSA:3.40.20.10:FF:000055', NULL, NULL, 'Quail, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(56535, NULL, 'G3DSA:2.60.40.10:FF:004104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56536, NULL, 'G3DSA:4.10.900.10:FF:000022', NULL, NULL, 'Cadherin 26', NULL, NULL, NULL, NULL, NULL, 4),
(56537, NULL, 'G3DSA:1.25.40.20:FF:001459', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56538, NULL, 'G3DSA:1.10.150.50:FF:000173', NULL, NULL, 'Ephrin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(56539, NULL, 'G3DSA:3.40.50.2020:FF:000106', NULL, NULL, 'Uridine kinase, putative (AFU_orthologue AFUA_2G05430)', NULL, NULL, NULL, NULL, NULL, 4),
(56540, NULL, 'G3DSA:3.40.50.300:FF:007466', NULL, NULL, 'Uncharacterized protein ABCG33', NULL, NULL, NULL, NULL, NULL, 4),
(56541, NULL, 'G3DSA:3.10.290.10:FF:000040', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(56542, NULL, 'G3DSA:4.10.280.10:FF:000007', NULL, NULL, 'single-minded homolog 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(56543, NULL, 'G3DSA:3.40.50.300:FF:000541', NULL, NULL, 'Immunity related GTPase M', NULL, NULL, NULL, NULL, NULL, 4),
(56544, NULL, 'G3DSA:2.60.120.40:FF:000001', NULL, NULL, 'Complement C1q B chain', NULL, NULL, NULL, NULL, NULL, 4),
(56545, NULL, 'G3DSA:3.40.50.1400:FF:000038', NULL, NULL, 'Protoporphyrin ferrochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(56546, NULL, 'G3DSA:3.30.40.10:FF:001208', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(56547, NULL, 'G3DSA:4.10.240.10:FF:000229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56548, NULL, 'G3DSA:2.170.150.20:FF:000021', NULL, NULL, 'Peptide methionine sulfoxide reductase MsrB (R-form specific)', NULL, NULL, NULL, NULL, NULL, 4),
(56549, NULL, 'G3DSA:3.30.70.330:FF:001079', NULL, NULL, 'La protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(56550, NULL, 'G3DSA:3.10.50.40:FF:000128', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(56551, NULL, 'G3DSA:3.90.25.10:FF:000058', NULL, NULL, 'dTDP-4-dehydrorhamnose reductase', NULL, NULL, NULL, NULL, NULL, 4),
(56552, NULL, 'G3DSA:1.20.272.10:FF:000014', NULL, NULL, 'DNA polymerase clamp loader subunit', NULL, NULL, NULL, NULL, NULL, 4),
(56553, NULL, 'G3DSA:1.10.238.260:FF:000004', NULL, NULL, 'Homocitrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(56554, NULL, 'G3DSA:2.40.50.140:FF:001183', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56555, NULL, 'G3DSA:2.30.42.10:FF:000597', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56556, NULL, 'G3DSA:3.40.140.10:FF:000011', NULL, NULL, 'tRNA-specific adenosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(56557, NULL, 'G3DSA:3.30.1330.30:FF:000095', NULL, NULL, 'YALI0F27995p', NULL, NULL, NULL, NULL, NULL, 4),
(56558, NULL, 'G3DSA:3.40.50.300:FF:003975', NULL, NULL, 'Structural maintenance of chromosomes protein', NULL, NULL, NULL, NULL, NULL, 4),
(56559, NULL, 'G3DSA:1.10.510.10:FF:000380', NULL, NULL, 'Serine/threonine-protein kinase ppk15', NULL, NULL, NULL, NULL, NULL, 4),
(56560, NULL, 'G3DSA:4.10.400.10:FF:000326', NULL, NULL, 'glycoprotein 330-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(56561, NULL, 'G3DSA:1.10.565.10:FF:000079', NULL, NULL, 'Hepatocyte nuclear factor 4-alpha', NULL, NULL, NULL, NULL, NULL, 4),
(56562, NULL, 'G3DSA:3.30.160.60:FF:000720', NULL, NULL, 'zinc finger protein 18 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(56563, NULL, 'G3DSA:2.10.25.10:FF:000805', NULL, NULL, 'Low-density lipoprotein receptor-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(56564, NULL, 'G3DSA:1.10.220.160:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56565, NULL, 'G3DSA:2.130.10.30:FF:000148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56566, NULL, 'G3DSA:2.60.40.790:FF:000140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56567, NULL, 'G3DSA:3.40.140.20:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56568, NULL, 'G3DSA:3.90.550.10:FF:000025', NULL, NULL, 'Glycogenin-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(56569, NULL, 'G3DSA:3.30.70.330:FF:002838', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56570, NULL, 'G3DSA:3.40.50.2000:FF:000100', NULL, NULL, 'Glycosyltransferase family 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(56571, NULL, 'G3DSA:3.40.50.1820:FF:001226', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(56572, NULL, 'G3DSA:2.30.39.10:FF:000016', NULL, NULL, 'Probable non-inhibitory serpin-Z5', NULL, NULL, NULL, NULL, NULL, 4),
(56573, NULL, 'G3DSA:3.40.50.300:FF:004251', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(56574, NULL, 'G3DSA:1.10.8.720:FF:000080', NULL, NULL, 'Dynein heavy chain, cytosolic, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56575, NULL, 'G3DSA:1.10.390.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56576, NULL, 'G3DSA:1.20.1070.10:FF:001174', NULL, NULL, 'G-protein coupled receptor moody', NULL, NULL, NULL, NULL, NULL, 4),
(56577, NULL, 'G3DSA:3.40.50.1100:FF:000162', NULL, NULL, 'Cysteine synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56578, NULL, 'G3DSA:2.60.120.330:FF:000135', NULL, NULL, 'Putative 2-oxoacid dependent dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(56579, NULL, 'G3DSA:1.10.287.70:FF:000653', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56580, NULL, 'G3DSA:3.40.1010.10:FF:000006', NULL, NULL, 'Siroheme synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56581, NULL, 'G3DSA:3.40.50.10190:FF:000364', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56582, NULL, 'G3DSA:1.20.5.170:FF:000087', NULL, NULL, 'FOS like 1, AP-1 transcription factor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(56583, NULL, 'G3DSA:1.10.20.10:FF:000313', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56584, NULL, 'G3DSA:2.60.40.60:FF:000712', NULL, NULL, 'Cadherin 3', NULL, NULL, NULL, NULL, NULL, 4),
(56585, NULL, 'G3DSA:3.50.50.80:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(56586, NULL, 'G3DSA:3.40.50.880:FF:000113', NULL, NULL, 'Homoserine O-succinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(56587, NULL, 'G3DSA:3.15.20.10:FF:000012', NULL, NULL, 'Putative BPI/LBP family protein At1g04970', NULL, NULL, NULL, NULL, NULL, 4),
(56588, NULL, 'G3DSA:1.10.1000.11:FF:000004', NULL, NULL, 'PH and SEC7 domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(56589, NULL, 'G3DSA:2.60.40.200:FF:000014', NULL, NULL, 'Superoxide dismutase 1 copper chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(56590, NULL, 'G3DSA:2.40.50.140:FF:000688', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56591, NULL, 'G3DSA:3.30.2130.10:FF:000012', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(56592, NULL, 'G3DSA:3.40.50.1110:FF:000165', NULL, NULL, 'Iduronate-2-sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(56593, NULL, 'G3DSA:1.20.1310.20:FF:000038', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(56594, NULL, 'G3DSA:1.20.5.110:FF:000108', NULL, NULL, 'SNARE protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56595, NULL, 'G3DSA:2.130.10.10:FF:003918', NULL, NULL, 'Transcription factor tau subunit sfc6', NULL, NULL, NULL, NULL, NULL, 4),
(56596, NULL, 'G3DSA:3.10.110.10:FF:000100', NULL, NULL, 'RWD domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(56597, NULL, 'G3DSA:3.90.70.10:FF:000460', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56598, NULL, 'G3DSA:3.40.50.300:FF:008303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56599, NULL, 'G3DSA:3.40.50.300:FF:000322', NULL, NULL, 'probable ATP-dependent RNA helicase DDX23', NULL, NULL, NULL, NULL, NULL, 4),
(56600, NULL, 'G3DSA:1.25.40.20:FF:000374', NULL, NULL, 'Vacuolar protein sorting-associated protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(56601, NULL, 'G3DSA:1.10.10.10:FF:001667', NULL, NULL, 'Non-structural maintenance of chromosomes element 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(56602, NULL, 'G3DSA:1.10.533.10:FF:000073', NULL, NULL, 'Inactive caspase-12', NULL, NULL, NULL, NULL, NULL, 4),
(56603, NULL, 'G3DSA:1.10.287.130:FF:000177', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(56604, NULL, 'G3DSA:3.40.50.1820:FF:000389', NULL, NULL, 'Mono-and diacylglycerol lipase', NULL, NULL, NULL, NULL, NULL, 4),
(56605, NULL, 'G3DSA:1.10.530.10:FF:000050', NULL, NULL, 'Possible membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(56606, NULL, 'G3DSA:2.60.120.200:FF:000675', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56607, NULL, 'G3DSA:3.40.50.450:FF:000007', NULL, NULL, 'LOG family protein ygdH', NULL, NULL, NULL, NULL, NULL, 4),
(56608, NULL, 'G3DSA:1.10.238.10:FF:000460', NULL, NULL, 'Calcium-binding allergen Ole e 8', NULL, NULL, NULL, NULL, NULL, 4),
(56609, NULL, 'G3DSA:2.60.40.10:FF:003609', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56610, NULL, 'G3DSA:2.40.50.100:FF:000125', NULL, NULL, 'Efflux transporter, RND family, MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(56611, NULL, 'G3DSA:1.25.40.20:FF:001791', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56612, NULL, 'G3DSA:3.30.420.610:FF:000001', NULL, NULL, 'Meiosis regulator and mRNA stability factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(56613, NULL, 'G3DSA:3.50.30.30:FF:000134', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(56614, NULL, 'G3DSA:2.60.40.4070:FF:000003', NULL, NULL, 'Basal-body rod modification protein FlgD', NULL, NULL, NULL, NULL, NULL, 4),
(56615, NULL, 'G3DSA:1.25.10.10:FF:003197', NULL, NULL, 'PIKK family atypical protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(56616, NULL, 'G3DSA:3.30.2130.30:FF:000018', NULL, NULL, 'THUMP domain-containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(56617, NULL, 'G3DSA:2.130.10.10:FF:002727', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56618, NULL, 'G3DSA:3.30.565.10:FF:000005', NULL, NULL, 'Heat shock protein 90', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(56619, NULL, 'G3DSA:3.30.70.330:FF:003119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56620, NULL, 'G3DSA:1.10.20.140:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56621, NULL, 'G3DSA:3.40.1440.10:FF:000005', NULL, NULL, 'Structure-specific endonuclease subunit SLX1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(56622, NULL, 'G3DSA:1.25.10.10:FF:000869', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56623, NULL, 'G3DSA:3.80.10.10:FF:000069', NULL, NULL, 'leucine-rich repeat-containing protein 3B', NULL, NULL, NULL, NULL, NULL, 4),
(56624, NULL, 'G3DSA:2.60.260.20:FF:000005', NULL, NULL, 'Chaperone protein dnaJ 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(56625, NULL, 'G3DSA:3.30.160.60:FF:002671', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56626, NULL, 'G3DSA:1.20.1250.40:FF:000039', NULL, NULL, 'Protein CBG03003', NULL, NULL, NULL, NULL, NULL, 4),
(56627, NULL, 'G3DSA:3.40.50.2000:FF:000960', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56628, NULL, 'G3DSA:1.25.40.20:FF:000907', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56629, NULL, 'G3DSA:3.40.50.300:FF:001013', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(56630, NULL, 'G3DSA:3.40.50.300:FF:001452', NULL, NULL, 'U5 small nuclear ribonucleoprotein component', NULL, NULL, NULL, NULL, NULL, 4),
(56631, NULL, 'G3DSA:1.10.20.10:FF:000162', NULL, NULL, 'CBF/NF-Y transcription factor domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(56632, NULL, 'G3DSA:1.20.58.60:FF:000252', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(56633, NULL, 'G3DSA:3.10.110.10:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56634, NULL, 'G3DSA:3.10.20.770:FF:000019', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit beta isoform', NULL, NULL, NULL, NULL, NULL, 4),
(56635, NULL, 'G3DSA:3.20.20.10:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56636, NULL, 'G3DSA:3.30.70.330:FF:000365', NULL, NULL, 'U4/U6 snRNA-associated-splicing factor PRP24', NULL, NULL, NULL, NULL, NULL, 4),
(56637, NULL, 'G3DSA:3.10.100.10:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56638, NULL, 'G3DSA:2.10.25.10:FF:000232', NULL, NULL, 'thrombospondin-3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(56639, NULL, 'G3DSA:3.40.50.300:FF:004678', NULL, NULL, 'AGAP008081-PA', NULL, NULL, NULL, NULL, NULL, 4),
(56640, NULL, 'G3DSA:3.40.640.10:FF:000318', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56641, NULL, 'G3DSA:1.10.530.10:FF:000044', NULL, NULL, 'Lipoprotein LpqU', NULL, NULL, NULL, NULL, NULL, 4),
(56642, NULL, 'G3DSA:1.10.150.910:FF:000001', NULL, NULL, 'DNA damage-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(56643, NULL, 'G3DSA:3.40.50.1370:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56644, NULL, 'G3DSA:3.40.47.10:FF:000167', NULL, NULL, '3-oxoacyl-(Acyl carrier protein) synthase II', NULL, NULL, NULL, NULL, NULL, 4),
(56645, NULL, 'G3DSA:1.10.8.10:FF:000177', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(56646, NULL, 'G3DSA:3.40.50.10330:FF:000013', NULL, NULL, 'NAD kinase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(56647, NULL, 'G3DSA:1.20.80.10:FF:000030', NULL, NULL, 'Pez, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(56648, NULL, 'G3DSA:2.70.150.10:FF:000121', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(56649, NULL, 'G3DSA:1.20.20.10:FF:000021', NULL, NULL, 'ATP synthase subunit 9, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(56650, NULL, 'G3DSA:2.120.10.80:FF:000219', NULL, NULL, 'Kelch domain-containing protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(56651, NULL, 'G3DSA:3.30.160.60:FF:005425', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56652, NULL, 'G3DSA:3.90.550.10:FF:000233', NULL, NULL, 'Glycosyl transferase, group 2 family protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(56653, NULL, 'G3DSA:3.40.50.880:FF:000029', NULL, NULL, 'Carbamoyl-phosphate synthase small chain', NULL, NULL, NULL, NULL, NULL, 4),
(56654, NULL, 'G3DSA:2.40.50.140:FF:000699', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56655, NULL, 'G3DSA:1.20.1250.10:FF:000143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56656, NULL, 'G3DSA:3.30.470.10:FF:000010', NULL, NULL, 'Branched-chain-amino-acid aminotransferase-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(56657, NULL, 'G3DSA:1.10.630.10:FF:000580', NULL, NULL, 'Os10g0514300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(56658, NULL, 'G3DSA:3.90.190.10:FF:000250', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(56659, NULL, 'G3DSA:2.130.10.10:FF:005280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56660, NULL, 'G3DSA:3.40.350.10:FF:000038', NULL, NULL, 'Aminopeptidase P', NULL, NULL, NULL, NULL, NULL, 4),
(56661, NULL, 'G3DSA:3.30.565.10:FF:000477', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56662, NULL, 'G3DSA:3.30.160.60:FF:006414', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56663, NULL, 'G3DSA:2.20.25.90:FF:000008', NULL, NULL, 'Tetrathionate reductase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(56664, NULL, 'G3DSA:1.25.40.970:FF:000002', NULL, NULL, 'N-lysine methyltransferase SMYD2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(56665, NULL, 'G3DSA:2.80.10.50:FF:000100', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(56666, NULL, 'G3DSA:1.10.8.270:FF:000124', NULL, NULL, 'Si:ch211-266k8.4', NULL, NULL, NULL, NULL, NULL, 4),
(56667, NULL, 'G3DSA:3.40.50.150:FF:000962', NULL, NULL, 'mRNA cap guanine-N7 methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(56668, NULL, 'G3DSA:2.40.20.10:FF:000085', NULL, NULL, 'uncharacterized protein LOC101242091', NULL, NULL, NULL, NULL, NULL, 4),
(56669, NULL, 'G3DSA:3.30.2350.20:FF:000048', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(56670, NULL, 'G3DSA:3.40.50.300:FF:000024', NULL, NULL, 'ADP-ribosylation factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(56671, NULL, 'G3DSA:3.10.310.20:FF:000017', NULL, NULL, 'Exopolyphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(56672, NULL, 'G3DSA:3.30.40.10:FF:000450', NULL, NULL, 'RING finger protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(56673, NULL, 'G3DSA:1.10.287.370:FF:000052', NULL, NULL, 'Tubulin-binding prefolding complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(56674, NULL, 'G3DSA:2.60.40.10:FF:002603', NULL, NULL, 'Muscle M-line assembly protein unc-89-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(56675, NULL, 'G3DSA:1.20.1250.20:FF:001814', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56676, NULL, 'G3DSA:2.30.31.10:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56677, NULL, 'G3DSA:3.40.30.10:FF:000544', NULL, NULL, 'Hydrogenase subunit HymB, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56678, NULL, 'G3DSA:3.30.160.60:FF:003660', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56679, NULL, 'G3DSA:1.20.920.30:FF:000049', NULL, NULL, 'Dynein-1-beta heavy chain, flagellar inner arm I1 complex', NULL, NULL, NULL, NULL, NULL, 4),
(56680, NULL, 'G3DSA:2.60.120.200:FF:000349', NULL, NULL, 'H0201G08.2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(56681, NULL, 'G3DSA:3.40.50.1460:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56682, NULL, 'G3DSA:3.20.20.70:FF:000500', NULL, NULL, 'Component II, glutamine amidotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(56683, NULL, 'G3DSA:3.30.200.20:FF:002415', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56684, NULL, 'G3DSA:2.60.40.1180:FF:000058', NULL, NULL, 'Cysteine peptidase, Clan CA, family C2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56685, NULL, 'G3DSA:3.40.50.2300:FF:000308', NULL, NULL, 'Metabotropic glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(56686, NULL, 'G3DSA:1.10.486.10:FF:000058', NULL, NULL, 'ATP-dependent nuclease subunit A', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(56687, NULL, 'G3DSA:1.20.140.100:FF:000041', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(56688, NULL, 'G3DSA:3.30.160.60:FF:005897', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56689, NULL, 'G3DSA:1.20.1740.10:FF:000051', NULL, NULL, 'Amino acid permease', NULL, NULL, NULL, NULL, NULL, 4),
(56690, NULL, 'G3DSA:3.40.1160.10:FF:000023', NULL, NULL, 'Probable aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(56691, NULL, 'G3DSA:3.10.580.10:FF:000062', NULL, NULL, 'SNF1-related protein kinase regulatory subunit gamma-1-like', NULL, NULL, NULL, NULL, NULL, 4),
(56692, NULL, 'G3DSA:2.160.20.10:FF:000304', NULL, NULL, 'F-box containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56693, NULL, 'G3DSA:2.40.50.140:FF:000227', NULL, NULL, 'Ribonuclease R', NULL, NULL, NULL, NULL, NULL, 4),
(56694, NULL, 'G3DSA:3.40.1080.10:FF:000022', NULL, NULL, 'Acetyl-CoA hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(56695, NULL, 'G3DSA:2.40.30.270:FF:000026', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(56696, NULL, 'G3DSA:1.20.140.150:FF:000095', NULL, NULL, 'Calcium voltage-gated channel auxiliary subunit gamma 7', NULL, NULL, NULL, NULL, NULL, 4),
(56697, NULL, 'G3DSA:3.40.50.300:FF:004239', NULL, NULL, 'Mitochondrial Rho GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(56698, NULL, 'G3DSA:3.90.70.10:FF:000376', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(56699, NULL, 'G3DSA:1.10.10.10:FF:000717', NULL, NULL, 'Transcription factor of the Forkhead/HNF3 family', NULL, NULL, NULL, NULL, NULL, 4),
(56700, NULL, 'G3DSA:2.30.29.30:FF:000752', NULL, NULL, 'FERM domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(56701, NULL, 'G3DSA:3.90.1150.80:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56702, NULL, 'G3DSA:2.60.120.330:FF:000129', NULL, NULL, 'Oxidoreductase, 2OG-Fe oxygenase family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(56703, NULL, 'G3DSA:3.40.50.300:FF:005667', NULL, NULL, 'DNA double-strand break repair Rad50 ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(56704, NULL, 'G3DSA:1.10.510.10:FF:001942', NULL, NULL, 'Cdc2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56705, NULL, 'G3DSA:1.25.40.10:FF:003131', NULL, NULL, 'Developmental protein', NULL, NULL, NULL, NULL, NULL, 4),
(56706, NULL, 'G3DSA:3.80.10.10:FF:001497', NULL, NULL, 'Blast:F-box/LRR-repeat protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(56707, NULL, 'G3DSA:2.70.130.10:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56708, NULL, 'G3DSA:3.30.890.10:FF:000002', NULL, NULL, 'Bromodomain adjacent to zinc finger domain protein 2B', NULL, NULL, NULL, NULL, NULL, 4),
(56709, NULL, 'G3DSA:1.10.405.10:FF:000028', NULL, NULL, 'Guanosine nucleotide diphosphate dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(56710, NULL, 'G3DSA:3.40.1360.10:FF:000004', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(56711, NULL, 'G3DSA:3.30.1370.100:FF:000036', NULL, NULL, 'ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56712, NULL, 'G3DSA:1.20.120.1080:FF:000023', NULL, NULL, 'ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(56713, NULL, 'G3DSA:1.20.1250.20:FF:000472', NULL, NULL, 'Pantothenate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56714, NULL, 'G3DSA:1.20.5.190:FF:000076', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(56715, NULL, 'G3DSA:3.20.20.80:FF:000649', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(56716, NULL, 'G3DSA:3.40.50.11660:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56717, NULL, 'G3DSA:3.30.70.940:FF:000014', NULL, NULL, 'Transcription antitermination protein RfaH', NULL, NULL, NULL, NULL, NULL, 4),
(56718, NULL, 'G3DSA:2.40.320.10:FF:000017', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 18', NULL, NULL, NULL, NULL, NULL, 4),
(56719, NULL, 'G3DSA:2.60.40.420:FF:000226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(56720, NULL, 'G3DSA:3.40.50.300:FF:003430', NULL, NULL, 'DNA mismatch repair protein mutS, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56721, NULL, 'G3DSA:3.30.450.20:FF:000629', NULL, NULL, 'Serine phosphatase RsbU', NULL, NULL, NULL, NULL, NULL, 4),
(56722, NULL, 'G3DSA:3.90.20.20:FF:000022', NULL, NULL, 'Protein GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(56723, NULL, 'G3DSA:2.40.10.10:FF:000287', NULL, NULL, 'Coagulation factor XI', NULL, NULL, NULL, NULL, NULL, 4),
(56724, NULL, 'G3DSA:3.30.710.10:FF:000046', NULL, NULL, 'BTB/POZ domain-containing protein KCTD7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(56725, NULL, 'G3DSA:1.20.1560.10:FF:000806', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56726, NULL, 'G3DSA:2.60.40.10:FF:004520', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56727, NULL, 'G3DSA:1.10.390.10:FF:000072', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(56728, NULL, 'G3DSA:3.80.10.10:FF:002486', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(56729, NULL, 'G3DSA:1.25.40.710:FF:000003', NULL, NULL, 'Tripeptidyl-peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(56730, NULL, 'G3DSA:3.40.630.10:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56731, NULL, 'G3DSA:2.60.40.1390:FF:000003', NULL, NULL, 'myelin regulatory factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(56732, NULL, 'G3DSA:1.20.120.900:FF:000001', NULL, NULL, 'Putative peroxisomal biogenesis factor 19', NULL, NULL, NULL, NULL, NULL, 4),
(56733, NULL, 'G3DSA:3.30.2300.10:FF:000008', NULL, NULL, 'Probable tRNA sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(56734, NULL, 'G3DSA:3.30.160.60:FF:004469', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56735, NULL, 'G3DSA:3.90.660.10:FF:000062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56736, NULL, 'G3DSA:3.40.850.10:FF:000183', NULL, NULL, 'Kinesin-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(56737, NULL, 'G3DSA:2.30.110.10:FF:000116', NULL, NULL, 'Chromosome 21, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(56738, NULL, 'G3DSA:2.30.29.70:FF:000005', NULL, NULL, 'Proteasomal ubiquitin receptor ADRM1', NULL, NULL, NULL, NULL, NULL, 4),
(56739, NULL, 'G3DSA:1.20.5.170:FF:000070', NULL, NULL, 'CREB/ATF bZIP transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(56740, NULL, 'G3DSA:2.130.10.10:FF:004705', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(56741, NULL, 'G3DSA:1.20.5.1160:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56742, NULL, 'G3DSA:2.60.40.10:FF:004048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56743, NULL, 'G3DSA:3.40.50.300:FF:008101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56744, NULL, 'G3DSA:1.10.287.190:FF:000003', NULL, NULL, 'Transcription initiation factor IIA subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(56745, NULL, 'G3DSA:3.40.50.1820:FF:000063', NULL, NULL, 'Lipase member H', NULL, NULL, NULL, NULL, NULL, 4),
(56746, NULL, 'G3DSA:1.25.40.20:FF:001043', NULL, NULL, 'Kinase D-interacting substrate 220', NULL, NULL, NULL, NULL, NULL, 4),
(56747, NULL, 'G3DSA:1.25.10.10:FF:000077', NULL, NULL, 'Exportin 4', NULL, NULL, NULL, NULL, NULL, 4),
(56748, NULL, 'G3DSA:1.25.40.10:FF:000697', NULL, NULL, 'UNC-45', NULL, NULL, NULL, NULL, NULL, 4),
(56749, NULL, 'G3DSA:1.25.40.10:FF:004912', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g39710', NULL, NULL, NULL, NULL, NULL, 4),
(56750, NULL, 'G3DSA:2.60.40.150:FF:000302', NULL, NULL, 'C2 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(56751, NULL, 'G3DSA:2.170.120.12:FF:000007', NULL, NULL, 'DNA-directed RNA polymerases I and III subunit RPAC1', NULL, NULL, NULL, NULL, NULL, 4),
(56752, NULL, 'G3DSA:3.40.50.1580:FF:000002', NULL, NULL, 'Purine nucleoside phosphorylase DeoD-type', NULL, NULL, NULL, NULL, NULL, 4),
(56753, NULL, 'G3DSA:3.30.1380.20:FF:000022', NULL, NULL, 'Trafficking protein particle complex subunit 3 homolog', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(56754, NULL, 'G3DSA:2.60.40.10:FF:003059', NULL, NULL, 'Enterochelin esterase', NULL, NULL, NULL, NULL, NULL, 4),
(56755, NULL, 'G3DSA:2.60.120.10:FF:000638', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(56756, NULL, 'G3DSA:3.30.470.30:FF:000049', NULL, NULL, 'Methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56757, NULL, 'G3DSA:3.30.70.330:FF:001321', NULL, NULL, 'Glycine-rich RNA-binding, abscisic acid-inducible protein', NULL, NULL, NULL, NULL, NULL, 4),
(56758, NULL, 'G3DSA:1.10.150.50:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56759, NULL, 'G3DSA:1.25.40.990:FF:000008', NULL, NULL, 'Nuclear mRNA export protein SAC3', NULL, NULL, NULL, NULL, NULL, 4),
(56760, NULL, 'G3DSA:3.30.200.20:FF:001073', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(56761, NULL, 'G3DSA:1.25.40.820:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56762, NULL, 'G3DSA:2.60.40.10:FF:004992', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56763, NULL, 'G3DSA:3.30.70.330:FF:002310', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56764, NULL, 'G3DSA:3.30.200.20:FF:001898', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56765, NULL, 'G3DSA:3.90.1150.10:FF:000235', NULL, NULL, 'Cystathionine gamma-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(56766, NULL, 'G3DSA:3.40.50.620:FF:000182', NULL, NULL, 'YdcF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(56767, NULL, 'G3DSA:3.40.50.620:FF:000502', NULL, NULL, 'Glutamyl-tRNA synthetase (AFU_orthologue AFUA_5G03560)', NULL, NULL, NULL, NULL, NULL, 4),
(56768, NULL, 'G3DSA:3.90.226.10:FF:000227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56769, NULL, 'G3DSA:3.30.465.10:FF:000060', NULL, NULL, 'Probable dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(56770, NULL, 'G3DSA:2.60.40.10:FF:003531', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56771, NULL, 'G3DSA:2.30.30.140:FF:000124', NULL, NULL, 'Nuclease domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(56772, NULL, 'G3DSA:1.25.40.10:FF:004379', NULL, NULL, 'TPR repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(56773, NULL, 'G3DSA:3.40.50.1820:FF:000563', NULL, NULL, 'Lipase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56774, NULL, 'G3DSA:1.10.3720.10:FF:000114', NULL, NULL, 'NitT/TauT family transport system permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(56775, NULL, 'G3DSA:1.10.510.10:FF:000953', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56776, NULL, 'G3DSA:3.30.1740.20:FF:000005', NULL, NULL, '40S ribosomal protein S26', NULL, NULL, NULL, NULL, NULL, 4),
(56777, NULL, 'G3DSA:2.130.10.10:FF:003716', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56778, NULL, 'G3DSA:3.60.40.10:FF:000027', NULL, NULL, 'Probable protein phosphatase 2C 76', NULL, NULL, NULL, NULL, NULL, 4),
(56779, NULL, 'G3DSA:1.25.40.410:FF:000003', NULL, NULL, 'Dedicator of cytokinesis protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(56780, NULL, 'G3DSA:2.60.200.20:FF:000029', NULL, NULL, 'Mediator of DNA damage checkpoint protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(56781, NULL, 'G3DSA:2.100.10.30:FF:000008', NULL, NULL, 'Hemolysin', NULL, NULL, NULL, NULL, NULL, 4),
(56782, NULL, 'G3DSA:3.30.1330.60:FF:000036', NULL, NULL, 'Chemotaxis protein MotB', NULL, NULL, NULL, NULL, NULL, 4),
(56783, NULL, 'G3DSA:3.30.1460.20:FF:000023', NULL, NULL, 'Arp2/3 complex 34 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(56784, NULL, 'G3DSA:2.60.450.10:FF:000011', NULL, NULL, 'Cell envelope biogenesis protein YhbN', NULL, NULL, NULL, NULL, NULL, 4),
(56785, NULL, 'G3DSA:1.20.5.4820:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56786, NULL, 'G3DSA:2.60.40.10:FF:005829', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56787, NULL, 'G3DSA:1.20.1070.10:FF:000078', NULL, NULL, 'Neuromedin-K receptor', NULL, NULL, NULL, NULL, NULL, 4),
(56788, NULL, 'G3DSA:3.40.1690.20:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(56789, NULL, 'G3DSA:3.30.160.60:FF:003008', NULL, NULL, 'Zinc finger protein 989', NULL, NULL, NULL, NULL, NULL, 4),
(56790, NULL, 'G3DSA:3.10.450.50:FF:000042', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(56791, NULL, 'G3DSA:1.20.1530.20:FF:000015', NULL, NULL, 'Na(+)/H(+) antiporter 2', NULL, NULL, NULL, NULL, NULL, 4),
(56792, NULL, 'G3DSA:1.10.150.20:FF:000208', NULL, NULL, 'Meiotic recombination protein DMC1', NULL, NULL, NULL, NULL, NULL, 4),
(56793, NULL, 'G3DSA:2.60.220.50:FF:000074', NULL, NULL, 'Putative g protein-coupled receptor', NULL, NULL, NULL, NULL, NULL, 4),
(56794, NULL, 'G3DSA:3.40.50.300:FF:006595', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56795, NULL, 'G3DSA:4.10.1240.10:FF:000069', NULL, NULL, 'C1A receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56796, NULL, 'G3DSA:1.25.40.430:FF:000009', NULL, NULL, 'GD23333', NULL, NULL, NULL, NULL, NULL, 4),
(56797, NULL, 'G3DSA:3.30.559.10:FF:000064', NULL, NULL, 'Non-ribosomal peptide synthetase OfaC', NULL, NULL, NULL, NULL, NULL, 4),
(56798, NULL, 'G3DSA:4.10.900.10:FF:000033', NULL, NULL, 'Transcription factor 7 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(56799, NULL, 'G3DSA:1.25.40.730:FF:000009', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(56800, NULL, 'G3DSA:1.25.10.10:FF:002786', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(56801, NULL, 'G3DSA:1.20.1250.20:FF:000033', NULL, NULL, 'Hexose phosphate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(56802, NULL, 'G3DSA:3.30.750.24:FF:000062', NULL, NULL, 'Anti-anti-sigma regulatory factor (Antagonist of anti-sigma factor)', NULL, NULL, NULL, NULL, NULL, 4),
(56803, NULL, 'G3DSA:1.25.40.20:FF:000054', NULL, NULL, 'E3 ubiquitin-protein ligase HACE1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(56804, NULL, 'G3DSA:3.40.50.880:FF:000181', NULL, NULL, 'Anthranilate synthase component 2', NULL, NULL, NULL, NULL, NULL, 4),
(56805, NULL, 'G3DSA:1.25.40.10:FF:002142', NULL, NULL, 'Os07g0662700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(56806, NULL, 'G3DSA:3.30.160.60:FF:004969', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56807, NULL, 'G3DSA:3.40.50.1110:FF:000058', NULL, NULL, 'Isoamyl acetate-hydrolyzing esterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56808, NULL, 'G3DSA:3.30.420.40:FF:000667', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56809, NULL, 'G3DSA:1.20.1050.10:FF:000195', NULL, NULL, 'Elongation factor 1-gamma', NULL, NULL, NULL, NULL, NULL, 4),
(56810, NULL, 'G3DSA:3.20.20.100:FF:000114', NULL, NULL, 'Aldo/keto reductase', NULL, NULL, NULL, NULL, NULL, 4),
(56811, NULL, 'G3DSA:2.120.10.80:FF:000371', NULL, NULL, 'Acyl-CoA-binding domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(56812, NULL, 'G3DSA:1.20.58.2190:FF:000005', NULL, NULL, 'Plant UBX domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(56813, NULL, 'G3DSA:3.40.50.2020:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56814, NULL, 'G3DSA:3.90.780.10:FF:000042', NULL, NULL, '5'' nucleotidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56815, NULL, 'G3DSA:3.40.50.300:FF:006656', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(56816, NULL, 'G3DSA:3.40.50.1000:FF:000789', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56817, NULL, 'G3DSA:3.30.450.310:FF:000001', NULL, NULL, 'Bifunctional diguanylate cyclase/phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(56818, NULL, 'G3DSA:3.40.50.970:FF:000056', NULL, NULL, '3D-(3,5/4)-trihydroxycyclohexane-1,2-dione hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(56819, NULL, 'G3DSA:1.20.1070.10:FF:002023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56820, NULL, 'G3DSA:1.50.40.10:FF:000133', NULL, NULL, 'Solute carrier family 25 (Mitochondrial phosphate transporter), member 3', NULL, NULL, NULL, NULL, NULL, 4),
(56821, NULL, 'G3DSA:1.10.10.790:FF:000014', NULL, NULL, 'Splicing factor SWAP', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(56822, NULL, 'G3DSA:1.10.357.50:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56823, NULL, 'G3DSA:1.20.920.10:FF:000010', NULL, NULL, 'protein polybromo-1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(56824, NULL, 'G3DSA:1.10.1380.10:FF:000014', NULL, NULL, 'GH01974p', NULL, NULL, NULL, NULL, NULL, 4),
(56825, NULL, 'G3DSA:3.40.50.10240:FF:000019', NULL, NULL, 'Thiamine pyrophosphokinase Thi80', NULL, NULL, NULL, NULL, NULL, 4),
(56826, NULL, 'G3DSA:3.30.40.10:FF:000803', NULL, NULL, 'Mpe1p', NULL, NULL, NULL, NULL, NULL, 4),
(56827, NULL, 'G3DSA:1.25.40.20:FF:001835', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(56828, NULL, 'G3DSA:1.20.5.110:FF:000007', NULL, NULL, 'Synaptosomal-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(56829, NULL, 'G3DSA:1.25.40.10:FF:002642', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56830, NULL, 'G3DSA:3.30.1010.10:FF:000054', NULL, NULL, 'Putative phosphatidylinositol 3-related kinase', NULL, NULL, NULL, NULL, NULL, 4),
(56831, NULL, 'G3DSA:3.50.50.60:FF:001476', NULL, NULL, 'FAD-dependent oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(56832, NULL, 'G3DSA:3.30.450.40:FF:000023', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(56833, NULL, 'G3DSA:2.10.25.10:FF:001160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56834, NULL, 'G3DSA:1.10.472.10:FF:000408', NULL, NULL, 'AGAP004963-PA', NULL, NULL, NULL, NULL, NULL, 4),
(56835, NULL, 'G3DSA:1.25.10.10:FF:001325', NULL, NULL, 'Transporter of SR proteins', NULL, NULL, NULL, NULL, NULL, 4),
(56836, NULL, 'G3DSA:3.30.160.60:FF:001743', NULL, NULL, 'zinc finger protein 581', NULL, NULL, NULL, NULL, NULL, 4),
(56837, NULL, 'G3DSA:2.40.170.20:FF:000076', NULL, NULL, 'Probable outer membrane receptor for iron transport', NULL, NULL, NULL, NULL, NULL, 4),
(56838, NULL, 'G3DSA:1.25.40.10:FF:000197', NULL, NULL, 'Tetratricopeptide repeat domain 21B', NULL, NULL, NULL, NULL, NULL, 4),
(56839, NULL, 'G3DSA:3.30.70.330:FF:001293', NULL, NULL, 'Os07g0603100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(56840, NULL, 'G3DSA:3.40.50.300:FF:006156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56841, NULL, 'G3DSA:1.10.472.10:FF:000588', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56842, NULL, 'G3DSA:1.10.8.270:FF:000063', NULL, NULL, 'TBC1 domain family member', NULL, NULL, NULL, NULL, NULL, 4),
(56843, NULL, 'G3DSA:1.25.40.10:FF:002934', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56844, NULL, 'G3DSA:1.10.10.10:FF:001206', NULL, NULL, 'Transcriptional regulator,LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(56845, NULL, 'G3DSA:1.10.287.90:FF:000018', NULL, NULL, 'Cytochrome c oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(56846, NULL, 'G3DSA:1.20.1000.10:FF:000012', NULL, NULL, 'Guanylate-binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(56847, NULL, 'G3DSA:2.60.120.200:FF:000821', NULL, NULL, 'Putative neuramidase (Putative secreted protein)', NULL, NULL, NULL, NULL, NULL, 4),
(56848, NULL, 'G3DSA:3.40.50.1000:FF:000817', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56849, NULL, 'G3DSA:3.30.200.20:FF:001926', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56850, NULL, 'G3DSA:3.40.50.300:FF:008601', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(56851, NULL, 'G3DSA:1.20.120.1750:FF:000156', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(56852, NULL, 'G3DSA:3.40.50.1260:FF:000024', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(56853, NULL, 'G3DSA:1.25.10.10:FF:001797', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56854, NULL, 'G3DSA:3.90.1240.10:FF:000001', NULL, NULL, 'Botulinum neurotoxin type B', NULL, NULL, NULL, NULL, NULL, 4),
(56855, NULL, 'G3DSA:3.40.50.300:FF:000996', NULL, NULL, 'Cytoplasmic dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(56856, NULL, 'G3DSA:1.10.565.10:FF:000068', NULL, NULL, 'Nuclear hormone receptor family member nhr-86', NULL, NULL, NULL, NULL, NULL, 4),
(56857, NULL, 'G3DSA:1.10.287.110:FF:000053', NULL, NULL, 'Putative Mitochondrial DnaJ chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(56858, NULL, 'G3DSA:3.10.20.690:FF:000001', NULL, NULL, 'DNA gyrase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(56859, NULL, 'G3DSA:1.10.287.690:FF:000030', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(56860, NULL, 'G3DSA:2.10.110.10:FF:000278', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(56861, NULL, 'G3DSA:2.60.40.3350:FF:000001', NULL, NULL, 'Antireceptor', NULL, NULL, NULL, NULL, NULL, 4),
(56862, NULL, 'G3DSA:3.40.1190.20:FF:000180', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56863, NULL, 'G3DSA:3.90.70.10:FF:000729', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56864, NULL, 'G3DSA:2.60.120.260:FF:000440', NULL, NULL, 'Endo-beta-N-acetylglucosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(56865, NULL, 'G3DSA:2.30.30.40:FF:000387', NULL, NULL, 'ITSN (Intersectin) family', NULL, NULL, NULL, NULL, NULL, 4),
(56866, NULL, 'G3DSA:1.10.579.10:FF:000010', NULL, NULL, 'Deoxyribodipyrimidine photo-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(56867, NULL, 'G3DSA:3.60.15.10:FF:000194', NULL, NULL, 'Rubredoxin:oxygen/nitric oxide oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(56868, NULL, 'G3DSA:1.10.510.10:FF:001150', NULL, NULL, 'Os02g0136900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(56869, NULL, 'G3DSA:3.60.20.10:FF:000144', NULL, NULL, 'Glutamine-fructose-6-phosphate transaminase (Isomerizing) (GlmS-2)', NULL, NULL, NULL, NULL, NULL, 4),
(56870, NULL, 'G3DSA:1.20.58.70:FF:000081', NULL, NULL, 'SNAP receptor', NULL, NULL, NULL, NULL, NULL, 4),
(56871, NULL, 'G3DSA:1.10.1040.10:FF:000056', NULL, NULL, '3-hydroxyisobutyrate dehydrogenase a', NULL, NULL, NULL, NULL, NULL, 4),
(56872, NULL, 'G3DSA:1.10.10.10:FF:001353', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(56873, NULL, 'G3DSA:3.80.10.10:FF:000541', NULL, NULL, 'Si:dkey-190j3.2', NULL, NULL, NULL, NULL, NULL, 4),
(56874, NULL, 'G3DSA:1.25.40.20:FF:001543', NULL, NULL, 'Sex-determining protein fem-1', NULL, NULL, NULL, NULL, NULL, 4),
(56875, NULL, 'G3DSA:1.10.8.60:FF:000259', NULL, NULL, 'Cell division protein FstH', NULL, NULL, NULL, NULL, NULL, 4),
(56876, NULL, 'G3DSA:3.75.10.10:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56877, NULL, 'G3DSA:3.50.50.60:FF:001004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56878, NULL, 'G3DSA:3.10.129.10:FF:000025', NULL, NULL, 'GNAT family N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(56879, NULL, 'G3DSA:3.30.160.60:FF:003508', NULL, NULL, 'Zinc finger protein 639', NULL, NULL, NULL, NULL, NULL, 4),
(56880, NULL, 'G3DSA:1.20.1070.10:FF:000578', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(56881, NULL, 'G3DSA:1.10.287.70:FF:000451', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(56882, NULL, 'G3DSA:1.20.120.620:FF:000007', NULL, NULL, 'Sensor histidine kinase, KdpD', NULL, NULL, NULL, NULL, NULL, 4),
(56883, NULL, 'G3DSA:3.30.70.270:FF:000206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56884, NULL, 'G3DSA:1.10.730.10:FF:000025', NULL, NULL, 'Isoleucine--tRNA ligase cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(56885, NULL, 'G3DSA:3.40.33.10:FF:000197', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(56886, NULL, 'G3DSA:2.10.70.10:FF:000067', NULL, NULL, 'CUB and Sushi multiple domains 3', NULL, NULL, NULL, NULL, NULL, 4),
(56887, NULL, 'G3DSA:2.60.120.670:FF:000001', NULL, NULL, 'Spike protein P5', NULL, NULL, NULL, NULL, NULL, 4),
(56888, NULL, 'G3DSA:3.30.870.10:FF:000091', NULL, NULL, 'Phospholipase D', NULL, NULL, NULL, NULL, NULL, 4),
(56889, NULL, 'G3DSA:1.50.10.20:FF:000134', NULL, NULL, 'Protein farnesyltransferase subunit beta', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(56890, NULL, 'G3DSA:2.30.130.40:FF:000014', NULL, NULL, 'ATP-dependent protease La (LON) domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(56891, NULL, 'G3DSA:3.40.50.300:FF:007612', NULL, NULL, 'Senataxin', NULL, NULL, NULL, NULL, NULL, 4),
(56892, NULL, 'G3DSA:4.10.80.40:FF:000004', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] flavoprotein subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(56893, NULL, 'G3DSA:1.20.1280.50:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56894, NULL, 'G3DSA:3.40.367.20:FF:000023', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(56895, NULL, 'G3DSA:3.30.465.10:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56896, NULL, 'G3DSA:3.30.310.40:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56897, NULL, 'G3DSA:2.40.50.960:FF:000001', NULL, NULL, 'ACD, shelterin complex subunit and telomerase recruitment factor', NULL, NULL, NULL, NULL, NULL, 4),
(56898, NULL, 'G3DSA:2.160.20.10:FF:000276', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(56899, NULL, 'G3DSA:1.20.1540.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56900, NULL, 'G3DSA:2.130.10.10:FF:004352', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56901, NULL, 'G3DSA:3.90.470.20:FF:000061', NULL, NULL, 'L-aminoadipate-semialdehyde dehydrogenase-phosphopantetheinyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(56902, NULL, 'G3DSA:3.30.160.60:FF:006386', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56903, NULL, 'G3DSA:2.130.10.30:FF:000176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56904, NULL, 'G3DSA:2.130.10.10:FF:001890', NULL, NULL, 'TBC1 domain family, member 31', NULL, NULL, NULL, NULL, NULL, 4),
(56905, NULL, 'G3DSA:2.60.40.150:FF:000482', NULL, NULL, 'Phosphatidylinositol 3-kinase VPS34', NULL, NULL, NULL, NULL, NULL, 4),
(56906, NULL, 'G3DSA:3.30.70.3190:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56907, NULL, 'G3DSA:3.30.70.330:FF:002782', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56908, NULL, 'G3DSA:1.10.287.1490:FF:000102', NULL, NULL, 'NUP-1 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56909, NULL, 'G3DSA:3.90.640.10:FF:000032', NULL, NULL, 'heat shock 70 kDa protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(56910, NULL, 'G3DSA:4.10.410.10:FF:000097', NULL, NULL, 'Tissue factor pathway inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(56911, NULL, 'G3DSA:1.25.40.10:FF:001214', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g20540', NULL, NULL, NULL, NULL, NULL, 4),
(56912, NULL, 'G3DSA:2.60.40.10:FF:002283', NULL, NULL, 'Platelet-derived growth factor receptor alpha', NULL, NULL, NULL, NULL, NULL, 4),
(56913, NULL, 'G3DSA:2.30.42.10:FF:000271', NULL, NULL, 'Pdz domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56914, NULL, 'G3DSA:3.30.420.40:FF:000167', NULL, NULL, 'Actin-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(56915, NULL, 'G3DSA:3.30.450.190:FF:000010', NULL, NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(56916, NULL, 'G3DSA:3.40.50.300:FF:007584', NULL, NULL, 'eIF2-interacting protein ABC50, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56917, NULL, 'G3DSA:2.30.42.10:FF:000299', NULL, NULL, 'MAGI (Membrane Associated Guanylate kinase Inverted) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(56918, NULL, 'G3DSA:4.10.410.20:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56919, NULL, 'G3DSA:3.90.25.10:FF:000041', NULL, NULL, 'UDP-glucose 4-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(56920, NULL, 'G3DSA:2.60.40.150:FF:000774', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56921, NULL, 'G3DSA:2.30.29.30:FF:001241', NULL, NULL, 'Probable serine/threonine-protein kinase roco5', NULL, NULL, NULL, NULL, NULL, 4),
(56922, NULL, 'G3DSA:3.20.20.60:FF:000110', NULL, NULL, 'HpcH/HpaI aldolase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(56923, NULL, 'G3DSA:1.10.238.10:FF:000561', NULL, NULL, 'Myosin, essential light chain', NULL, NULL, NULL, NULL, NULL, 4),
(56924, NULL, 'G3DSA:4.10.60.10:FF:000045', NULL, NULL, 'CCHC-type zinc finger protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(56925, NULL, 'G3DSA:3.40.850.10:FF:000211', NULL, NULL, 'Kinesin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56926, NULL, 'G3DSA:3.30.200.20:FF:000437', NULL, NULL, 'Mixed lineage kinase domain-like pseudokinase', NULL, NULL, NULL, NULL, NULL, 4),
(56927, NULL, 'G3DSA:1.10.260.100:FF:000002', NULL, NULL, 'Stress-induced-phosphoprotein 1 (Hsp70/Hsp90-organizing)', NULL, NULL, NULL, NULL, NULL, 4),
(56928, NULL, 'G3DSA:3.40.50.10420:FF:000040', NULL, NULL, 'Methenyltetrahydrofolate synthetase domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(56929, NULL, 'G3DSA:3.40.1190.20:FF:000033', NULL, NULL, 'Sugar kinase', NULL, NULL, NULL, NULL, NULL, 4),
(56930, NULL, 'G3DSA:3.30.40.10:FF:001759', NULL, NULL, 'PHD finger domain protein, putative (AFU_orthologue AFUA_3G11940)', NULL, NULL, NULL, NULL, NULL, 4),
(56931, NULL, 'G3DSA:1.10.472.10:FF:000560', NULL, NULL, 'Putative cyclin-D7-1', NULL, NULL, NULL, NULL, NULL, 4),
(56932, NULL, 'G3DSA:3.80.10.10:FF:002778', NULL, NULL, 'LOC502201 protein', NULL, NULL, NULL, NULL, NULL, 4),
(56933, NULL, 'G3DSA:2.30.30.30:FF:000058', NULL, NULL, 'Transcription elongation factor SPT5', NULL, NULL, NULL, NULL, NULL, 4),
(56934, NULL, 'G3DSA:3.30.420.40:FF:000959', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(56935, NULL, 'G3DSA:3.40.190.10:FF:000475', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(56936, NULL, 'G3DSA:3.50.50.60:FF:000520', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(56937, NULL, 'G3DSA:3.30.70.260:FF:000024', NULL, NULL, 'Tyrosine 3-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(56938, NULL, 'G3DSA:3.10.100.10:FF:000414', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56939, NULL, 'G3DSA:2.130.10.10:FF:000018', NULL, NULL, 'Receptor for activated C kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(56940, NULL, 'G3DSA:2.10.25.10:FF:001188', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(56941, NULL, 'G3DSA:3.40.1110.10:FF:000284', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56942, NULL, 'G3DSA:3.30.40.10:FF:002395', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56943, NULL, 'G3DSA:2.60.40.60:FF:000679', NULL, NULL, 'Cadherin-4', NULL, NULL, NULL, NULL, NULL, 4),
(56944, NULL, 'G3DSA:3.10.180.10:FF:000014', NULL, NULL, 'glyoxalase domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(56945, NULL, 'G3DSA:1.25.40.10:FF:004620', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56946, NULL, 'G3DSA:1.20.1250.20:FF:001461', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(56947, NULL, 'G3DSA:3.30.590.10:FF:000018', NULL, NULL, 'GD11708', NULL, NULL, NULL, NULL, NULL, 4),
(56948, NULL, 'G3DSA:3.40.190.100:FF:000005', NULL, NULL, 'Amino acid ABC transporter, periplasmic amino acid-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(56949, NULL, 'G3DSA:1.20.120.330:FF:000044', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(56950, NULL, 'G3DSA:3.40.50.2000:FF:000808', NULL, NULL, 'Glycogen [starch] synthase', NULL, NULL, NULL, NULL, NULL, 4),
(56951, NULL, 'G3DSA:1.10.790.10:FF:000001', NULL, NULL, 'Major prion protein', NULL, NULL, NULL, NULL, NULL, 4),
(56952, NULL, 'G3DSA:1.20.58.760:FF:000033', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(56953, NULL, 'G3DSA:1.25.10.10:FF:003450', NULL, NULL, 'Crescerin-like protein che-12', NULL, NULL, NULL, NULL, NULL, 4),
(56954, NULL, 'G3DSA:3.80.10.10:FF:000569', NULL, NULL, 'Partner of Paired', NULL, NULL, NULL, NULL, NULL, 4),
(56955, NULL, 'G3DSA:3.10.20.90:FF:000647', NULL, NULL, 'Ubiquitin, putative', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(56956, NULL, 'G3DSA:3.40.50.300:FF:006948', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56957, NULL, 'G3DSA:2.30.30.390:FF:000002', NULL, NULL, 'Clp protease adapter protein ClpF, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(56958, NULL, 'G3DSA:3.40.190.10:FF:000036', NULL, NULL, 'Dipeptide ABC transporter, substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(56959, NULL, 'G3DSA:2.30.42.10:FF:000119', NULL, NULL, 'Membrane associated guanylate kinase, WW and PDZ domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(56960, NULL, 'G3DSA:3.40.250.10:FF:000154', NULL, NULL, 'Metallo-beta-lactamase', NULL, NULL, NULL, NULL, NULL, 4),
(56961, NULL, 'G3DSA:1.25.10.10:FF:002814', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(56962, NULL, 'G3DSA:2.10.25.10:FF:001721', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56963, NULL, 'G3DSA:3.30.160.60:FF:001182', NULL, NULL, 'Zinc finger, C2H2 type', NULL, NULL, NULL, NULL, NULL, 4),
(56964, NULL, 'G3DSA:1.20.58.1610:FF:000005', NULL, NULL, 'NADH-quinone oxidoreductase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(56965, NULL, 'G3DSA:1.25.10.10:FF:003303', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(56966, NULL, 'G3DSA:3.40.630.30:FF:000678', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(56967, NULL, 'G3DSA:3.40.50.300:FF:004178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56968, NULL, 'G3DSA:3.40.50.920:FF:000002', NULL, NULL, '1-deoxy-D-xylulose-5-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(56969, NULL, 'G3DSA:1.25.40.10:FF:000989', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g31430', NULL, NULL, NULL, NULL, NULL, 4),
(56970, NULL, 'G3DSA:3.30.160.60:FF:004177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56971, NULL, 'G3DSA:3.30.9.10:FF:000006', NULL, NULL, 'N-methyl-L-tryptophan oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(56972, NULL, 'G3DSA:1.20.1250.20:FF:000825', NULL, NULL, 'Cln7, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(56973, NULL, 'G3DSA:2.130.10.10:FF:000962', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(56974, NULL, 'G3DSA:3.40.50.1820:FF:001491', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56975, NULL, 'G3DSA:1.10.10.60:FF:000951', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56976, NULL, 'G3DSA:2.40.50.40:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56977, NULL, 'G3DSA:3.30.160.60:FF:000254', NULL, NULL, 'Odd-skipped related transciption factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(56978, NULL, 'G3DSA:3.30.450.20:FF:000276', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(56979, NULL, 'G3DSA:1.10.238.10:FF:000409', NULL, NULL, 'Magu, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(56980, NULL, 'G3DSA:2.40.10.240:FF:000002', NULL, NULL, 'S-adenosylmethionine:tRNA ribosyltransferase-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(56981, NULL, 'G3DSA:1.10.510.10:FF:003207', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56982, NULL, 'G3DSA:3.40.50.80:FF:000167', NULL, NULL, 'YALI0F07040p', NULL, NULL, NULL, NULL, NULL, 4),
(56983, NULL, 'G3DSA:3.40.50.300:FF:004739', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(56984, NULL, 'G3DSA:3.90.120.10:FF:000004', NULL, NULL, 'DNA (cytosine-5)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(56985, NULL, 'G3DSA:3.40.50.800:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56986, NULL, 'G3DSA:1.10.510.10:FF:003387', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56987, NULL, 'G3DSA:1.10.10.60:FF:000007', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(56988, NULL, 'G3DSA:3.20.20.190:FF:000040', NULL, NULL, 'Glycerophosphoryl diester phosphodiesterase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(56989, NULL, 'G3DSA:3.40.30.10:FF:000044', NULL, NULL, 'Glutathione S-transferase GSTU6', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(56990, NULL, 'G3DSA:3.40.50.1820:FF:000855', NULL, NULL, 'IP20428p', NULL, NULL, NULL, NULL, NULL, 4),
(56991, NULL, 'G3DSA:3.60.10.10:FF:000351', NULL, NULL, 'DNA-(apurinic or apyrimidinic site) lyase', NULL, NULL, NULL, NULL, NULL, 4),
(56992, NULL, 'G3DSA:1.25.40.10:FF:004087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(56993, NULL, 'G3DSA:2.40.50.360:FF:000001', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(56994, NULL, 'G3DSA:3.40.50.2300:FF:000460', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(56995, NULL, 'G3DSA:3.30.70.330:FF:001854', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(56996, NULL, 'G3DSA:1.20.120.1910:FF:000047', NULL, NULL, 'Probable cysteine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(56997, NULL, 'G3DSA:1.20.1420.10:FF:000004', NULL, NULL, 'Talin 2', NULL, NULL, NULL, NULL, NULL, 4),
(56998, NULL, 'G3DSA:1.10.287.130:FF:000031', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(56999, NULL, 'G3DSA:1.10.168.20:FF:000002', NULL, NULL, '40S ribosomal protein S8', NULL, NULL, NULL, NULL, NULL, 4),
(57000, NULL, 'G3DSA:3.40.50.720:FF:002331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57001, NULL, 'G3DSA:3.40.50.620:FF:000210', NULL, NULL, 'tRNA-specific 2-thiouridylase MnmA', NULL, NULL, NULL, NULL, NULL, 4),
(57002, NULL, 'G3DSA:2.30.29.30:FF:000313', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(57003, NULL, 'G3DSA:3.30.40.10:FF:000011', NULL, NULL, 'chromodomain-helicase-DNA-binding protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(57004, NULL, 'G3DSA:2.60.40.10:FF:000158', NULL, NULL, 'Sidekick cell adhesion molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(57005, NULL, 'G3DSA:3.30.40.10:FF:002248', NULL, NULL, 'AGAP007417-PA', NULL, NULL, NULL, NULL, NULL, 4),
(57006, NULL, 'G3DSA:1.20.1600.10:FF:000041', NULL, NULL, 'Outer membrane protein TolC', NULL, NULL, NULL, NULL, NULL, 4),
(57007, NULL, 'G3DSA:1.50.40.10:FF:000425', NULL, NULL, 'Oxoglutarate/malate carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(57008, NULL, 'G3DSA:1.10.287.70:FF:000012', NULL, NULL, 'Voltage-dependent N-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(57009, NULL, 'G3DSA:2.170.300.10:FF:000025', NULL, NULL, 'Platelet endothelial aggregation receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(57010, NULL, 'G3DSA:3.30.70.330:FF:002602', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57011, NULL, 'G3DSA:3.60.15.10:FF:000047', NULL, NULL, 'integrator complex subunit 11 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(57012, NULL, 'G3DSA:2.130.10.10:FF:002227', NULL, NULL, 'Kinesin family member 21A', NULL, NULL, NULL, NULL, NULL, 4),
(57013, NULL, 'G3DSA:3.40.720.10:FF:000319', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57014, NULL, 'G3DSA:1.10.510.10:FF:002870', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57015, NULL, 'G3DSA:2.30.40.10:FF:000137', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(57016, NULL, 'G3DSA:2.130.10.10:FF:005633', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(57017, NULL, 'G3DSA:2.30.30.40:FF:000679', NULL, NULL, 'Variant SH3 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(57018, NULL, 'G3DSA:3.30.710.10:FF:000338', NULL, NULL, 'zinc finger protein 55 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(57019, NULL, 'G3DSA:3.40.50.300:FF:000816', NULL, NULL, 'Adenylate isopentenyltransferase 5, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(57020, NULL, 'G3DSA:3.80.10.10:FF:003003', NULL, NULL, 'F-box protein FBW2', NULL, NULL, NULL, NULL, NULL, 4),
(57021, NULL, 'G3DSA:1.10.238.270:FF:000001', NULL, NULL, 'Odorant-binding protein 58c', NULL, NULL, NULL, NULL, NULL, 4),
(57022, NULL, 'G3DSA:2.60.40.420:FF:000198', NULL, NULL, 'Cytochrome c oxidase subunit II', NULL, NULL, NULL, NULL, NULL, 4),
(57023, NULL, 'G3DSA:3.30.70.470:FF:000002', NULL, NULL, 'Methyl-coenzyme M reductase I subunit beta', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(57024, NULL, 'G3DSA:3.20.20.190:FF:000068', NULL, NULL, 'Putative glycerophosphoryl diester phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(57025, NULL, 'G3DSA:2.60.40.10:FF:002103', NULL, NULL, 'Colony-stimulating factor 1 receptor, a', NULL, NULL, NULL, NULL, NULL, 4),
(57026, NULL, 'G3DSA:3.40.47.10:FF:000228', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57027, NULL, 'G3DSA:1.20.1550.10:FF:000008', NULL, NULL, 'Disulfide bond formation protein B', NULL, NULL, NULL, NULL, NULL, 4),
(57028, NULL, 'G3DSA:3.60.21.10:FF:000168', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(57029, NULL, 'G3DSA:1.10.533.10:FF:000258', NULL, NULL, 'Caspase-8', NULL, NULL, NULL, NULL, NULL, 4),
(57030, NULL, 'G3DSA:2.60.40.10:FF:001614', NULL, NULL, 'Down syndrome cell adhesion molecule 3, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(57031, NULL, 'G3DSA:2.170.140.10:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(57032, NULL, 'G3DSA:2.160.10.10:FF:000039', NULL, NULL, 'Dynactin subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(57033, NULL, 'G3DSA:1.10.1420.10:FF:000102', NULL, NULL, 'Mismatch repair ATPase Msh2', NULL, NULL, NULL, NULL, NULL, 4),
(57034, NULL, 'G3DSA:3.40.50.720:FF:000386', NULL, NULL, 'Quinate repressor protein', NULL, NULL, NULL, NULL, NULL, 4),
(57035, NULL, 'G3DSA:3.80.10.10:FF:002514', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', NULL, NULL, NULL, NULL, NULL, 4),
(57036, NULL, 'G3DSA:3.30.505.10:FF:000176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57037, NULL, 'G3DSA:3.90.190.10:FF:000542', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(57038, NULL, 'G3DSA:3.30.40.10:FF:002187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57039, NULL, 'G3DSA:3.50.30.30:FF:000061', NULL, NULL, 'Subtilisin-like protease SBT3.13', NULL, NULL, NULL, NULL, NULL, 4),
(57040, NULL, 'G3DSA:3.80.10.10:FF:002986', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57041, NULL, 'G3DSA:3.30.160.60:FF:005133', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57042, NULL, 'G3DSA:2.60.260.20:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57043, NULL, 'G3DSA:3.30.50.10:FF:000068', NULL, NULL, 'Transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(57044, NULL, 'G3DSA:1.10.390.10:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57045, NULL, 'G3DSA:3.40.50.300:FF:001744', NULL, NULL, 'Mitochondrial Rho GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(57046, NULL, 'G3DSA:2.60.40.60:FF:000179', NULL, NULL, 'Cadherin 24', NULL, NULL, NULL, NULL, NULL, 4),
(57047, NULL, 'G3DSA:2.170.270.10:FF:000027', NULL, NULL, 'PR domain zinc finger protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(57048, NULL, 'G3DSA:3.30.70.330:FF:002810', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57049, NULL, 'G3DSA:2.40.50.140:FF:000519', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(57050, NULL, 'G3DSA:1.10.510.10:FF:000806', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(57051, NULL, 'G3DSA:3.40.50.300:FF:007084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57052, NULL, 'G3DSA:2.70.40.10:FF:000017', NULL, NULL, 'dUTPase', NULL, NULL, NULL, NULL, NULL, 4),
(57053, NULL, 'G3DSA:3.40.718.10:FF:000022', NULL, NULL, 'Isocitrate dehydrogenase (NADP(+)) 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(57054, NULL, 'G3DSA:1.10.472.80:FF:000148', NULL, NULL, 'TBC domain-containing protein C1952.17c', NULL, NULL, NULL, NULL, NULL, 4),
(57055, NULL, 'G3DSA:2.60.40.150:FF:000274', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', NULL, NULL, NULL, NULL, NULL, 4),
(57056, NULL, 'G3DSA:3.30.420.40:FF:001095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57057, NULL, 'G3DSA:1.25.40.10:FF:001714', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g13040, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(57058, NULL, 'G3DSA:1.20.1050.130:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57059, NULL, 'G3DSA:3.30.465.10:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57060, NULL, 'G3DSA:3.30.1360.70:FF:000013', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(57061, NULL, 'G3DSA:2.60.40.10:FF:001794', NULL, NULL, 'Fasciclin 3, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(57062, NULL, 'G3DSA:3.60.15.10:FF:000255', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(57063, NULL, 'G3DSA:1.25.40.10:FF:004851', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57064, NULL, 'G3DSA:2.130.10.10:FF:002435', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(57065, NULL, 'G3DSA:3.90.170.10:FF:000007', NULL, NULL, 'Adenylosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(57066, NULL, 'G3DSA:3.30.565.10:FF:000185', NULL, NULL, 'Sensory box histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(57067, NULL, 'G3DSA:2.60.120.10:FF:000610', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(57068, NULL, 'G3DSA:1.20.5.780:FF:000011', NULL, NULL, 'FXYD domain-containing ion transport regulator', NULL, NULL, NULL, NULL, NULL, 4),
(57069, NULL, 'G3DSA:3.30.413.10:FF:000007', NULL, NULL, 'Nitrite reductase [NAD(P)H] large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(57070, NULL, 'G3DSA:1.10.10.10:FF:000425', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(57071, NULL, 'G3DSA:2.10.50.10:FF:000004', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 6', NULL, NULL, NULL, NULL, NULL, 4),
(57072, NULL, 'G3DSA:3.30.70.1450:FF:000056', NULL, NULL, 'Glutathione-gated K(+)-efflux system KefB', NULL, NULL, NULL, NULL, NULL, 4),
(57073, NULL, 'G3DSA:1.10.510.10:FF:002898', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57074, NULL, 'G3DSA:3.80.10.10:FF:003975', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57075, NULL, 'G3DSA:1.10.150.240:FF:000132', NULL, NULL, 'Imidazoleglycerol-phosphate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(57076, NULL, 'G3DSA:1.10.260.40:FF:000015', NULL, NULL, 'Endothelial differentiation-related factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(57077, NULL, 'G3DSA:1.10.418.80:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57078, NULL, 'G3DSA:3.30.40.10:FF:001731', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57079, NULL, 'G3DSA:2.30.29.30:FF:000605', NULL, NULL, 'Heavy chain, Unconventional Myosin', NULL, NULL, NULL, NULL, NULL, 4),
(57080, NULL, 'G3DSA:1.25.10.10:FF:002286', NULL, NULL, 'Pumilio homolog 14', NULL, NULL, NULL, NULL, NULL, 4),
(57081, NULL, 'G3DSA:1.20.1250.20:FF:000180', NULL, NULL, 'MFS monosaccharide transporter', NULL, NULL, NULL, NULL, NULL, 4),
(57082, NULL, 'G3DSA:1.10.510.10:FF:001381', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(57083, NULL, 'G3DSA:1.10.10.60:FF:000479', NULL, NULL, 'Homebox and aldo/keto reductase', NULL, NULL, NULL, NULL, NULL, 4),
(57084, NULL, 'G3DSA:3.40.30.10:FF:000252', NULL, NULL, 'Phosphoadenosine-phosphosulphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(57085, NULL, 'G3DSA:1.10.400.10:FF:000040', NULL, NULL, 'Odr-3', NULL, NULL, NULL, NULL, NULL, 4),
(57086, NULL, 'G3DSA:2.60.40.10:FF:000366', NULL, NULL, 'fibronectin type-III domain-containing protein 3A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(57087, NULL, 'G3DSA:3.40.220.10:FF:000034', NULL, NULL, 'Leucyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(57088, NULL, 'G3DSA:3.30.40.10:FF:000742', NULL, NULL, 'DNA-binding E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(57089, NULL, 'G3DSA:1.20.5.2480:FF:000002', NULL, NULL, 'Reticulon-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(57090, NULL, 'G3DSA:1.20.1560.10:FF:000245', NULL, NULL, 'Multidrug resistance protein pgp-1', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(57091, NULL, 'G3DSA:2.30.29.30:FF:001269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57092, NULL, 'G3DSA:4.10.1060.10:FF:000004', NULL, NULL, 'Zinc finger Ran-binding domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(57093, NULL, 'G3DSA:2.170.130.10:FF:000017', NULL, NULL, 'TonB-dependent siderophore receptor', NULL, NULL, NULL, NULL, NULL, 4),
(57094, NULL, 'G3DSA:3.80.10.10:FF:003503', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57095, NULL, 'G3DSA:3.40.50.200:FF:000112', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(57096, NULL, 'G3DSA:3.40.50.10190:FF:000280', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(57097, NULL, 'G3DSA:3.40.190.290:FF:000135', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(57098, NULL, 'G3DSA:1.10.510.10:FF:002459', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57099, NULL, 'G3DSA:1.10.3160.10:FF:000003', NULL, NULL, 'Putative surface antigen', NULL, NULL, NULL, NULL, NULL, 4),
(57100, NULL, 'G3DSA:1.20.5.190:FF:000137', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57101, NULL, 'G3DSA:3.30.830.10:FF:000173', NULL, NULL, 'Mitochondrial-processing peptidase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(57102, NULL, 'G3DSA:1.10.287.1490:FF:000074', NULL, NULL, 'Kinase interacting (KIP1-like) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(57103, NULL, 'G3DSA:1.10.510.10:FF:003415', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57104, NULL, 'G3DSA:1.10.287.10:FF:000040', NULL, NULL, 'Histidyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(57105, NULL, 'G3DSA:2.60.40.10:FF:003031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57106, NULL, 'G3DSA:1.20.120.160:FF:000032', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(57107, NULL, 'G3DSA:1.20.1050.10:FF:000015', NULL, NULL, 'Glutathione S-transferase YfcF', NULL, NULL, NULL, NULL, NULL, 4),
(57108, NULL, 'G3DSA:2.130.10.10:FF:001007', NULL, NULL, 'THO complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(57109, NULL, 'G3DSA:1.10.510.10:FF:003887', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57110, NULL, 'G3DSA:3.90.1150.10:FF:000382', NULL, NULL, 'Selenocysteine lyase', NULL, NULL, NULL, NULL, NULL, 4),
(57111, NULL, 'G3DSA:3.30.70.920:FF:000036', NULL, NULL, 'Lrp/AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(57112, NULL, 'G3DSA:2.160.20.10:FF:000012', NULL, NULL, 'Polygalacturonase At1g48100 family', NULL, NULL, NULL, NULL, NULL, 4),
(57113, NULL, 'G3DSA:1.20.920.10:FF:000190', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(57114, NULL, 'G3DSA:1.25.40.10:FF:003159', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(57115, NULL, 'G3DSA:3.90.70.10:FF:000668', NULL, NULL, 'Ubiquitin specific protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(57116, NULL, 'G3DSA:3.30.300.20:FF:000001', NULL, NULL, '30S ribosomal protein S3', NULL, NULL, NULL, NULL, NULL, 4),
(57117, NULL, 'G3DSA:3.40.50.720:FF:000886', NULL, NULL, 'Formate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(57118, NULL, 'G3DSA:2.60.40.10:FF:002311', NULL, NULL, 'Beta-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(57119, NULL, 'G3DSA:1.20.144.10:FF:000032', NULL, NULL, 'PAP2 superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(57120, NULL, 'G3DSA:2.30.29.30:FF:000460', NULL, NULL, 'Pleckstrin y domain-containing family H member 2', NULL, NULL, NULL, NULL, NULL, 4),
(57121, NULL, 'G3DSA:3.40.50.300:FF:005959', NULL, NULL, 'YALI0E01760p', NULL, NULL, NULL, NULL, NULL, 4),
(57122, NULL, 'G3DSA:3.40.50.720:FF:001403', NULL, NULL, 'GDPmannose 4,6-dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(57123, NULL, 'G3DSA:3.40.50.300:FF:000316', NULL, NULL, 'Putative neuron navigator 3', NULL, NULL, NULL, NULL, NULL, 4),
(57124, NULL, 'G3DSA:3.30.300.90:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(57125, NULL, 'G3DSA:1.20.1080.10:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57126, NULL, 'G3DSA:3.30.200.160:FF:000002', NULL, NULL, 'Transcription factor IIIC, subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(57127, NULL, 'G3DSA:1.25.40.10:FF:000725', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g63370, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(57128, NULL, 'G3DSA:3.30.110.10:FF:000017', NULL, NULL, 'Translation initiation factor IF-3', NULL, NULL, NULL, NULL, NULL, 4),
(57129, NULL, 'G3DSA:3.10.100.10:FF:000386', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57130, NULL, 'G3DSA:1.10.10.60:FF:000390', NULL, NULL, 'YDR026C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(57131, NULL, 'G3DSA:3.40.30.10:FF:000836', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(57132, NULL, 'G3DSA:3.30.160.60:FF:003952', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57133, NULL, 'G3DSA:3.40.50.150:FF:001007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57134, NULL, 'G3DSA:1.10.8.80:FF:000006', NULL, NULL, 'Mg-protoporphyrin IX chelatase', NULL, NULL, NULL, NULL, NULL, 4),
(57135, NULL, 'G3DSA:3.80.10.10:FF:004223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57136, NULL, 'G3DSA:2.20.100.10:FF:000135', NULL, NULL, 'F-spondin', NULL, NULL, NULL, NULL, NULL, 4),
(57137, NULL, 'G3DSA:2.40.10.10:FF:000579', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57138, NULL, 'G3DSA:3.10.100.10:FF:000122', NULL, NULL, 'Killer cell lectin-like receptor subfamily A, member 1', NULL, NULL, NULL, NULL, NULL, 4),
(57139, NULL, 'G3DSA:2.60.40.60:FF:000387', NULL, NULL, 'CAlSYntenin/Alcadein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(57140, NULL, 'G3DSA:2.40.50.140:FF:000671', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57141, NULL, 'G3DSA:3.30.200.20:FF:002354', NULL, NULL, 'Phosphorylase kinase, gamma 1b (muscle)', NULL, NULL, NULL, NULL, NULL, 4),
(57142, NULL, 'G3DSA:2.60.120.970:FF:000001', NULL, NULL, 'Growth/differentiation factor 8', NULL, NULL, NULL, NULL, NULL, 4),
(57143, NULL, 'G3DSA:3.30.1050.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57144, NULL, 'G3DSA:1.25.10.10:FF:003011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57145, NULL, 'G3DSA:3.40.190.10:FF:000183', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(57146, NULL, 'G3DSA:2.130.10.10:FF:003155', NULL, NULL, 'Vacuolar assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(57147, NULL, 'G3DSA:3.30.160.60:FF:005397', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57148, NULL, 'G3DSA:1.25.40.690:FF:000008', NULL, NULL, 'Nuclear pore complex protein Nup98-Nup96', NULL, NULL, NULL, NULL, NULL, 4),
(57149, NULL, 'G3DSA:2.130.10.10:FF:002699', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(57150, NULL, 'G3DSA:2.60.120.650:FF:000107', NULL, NULL, 'ARID/BRIGHT DNA binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(57151, NULL, 'G3DSA:1.25.40.10:FF:001978', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(57152, NULL, 'G3DSA:2.60.120.260:FF:000501', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57153, NULL, 'G3DSA:3.30.565.10:FF:000505', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57154, NULL, 'G3DSA:1.25.40.10:FF:001506', NULL, NULL, 'Os03g0317100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(57155, NULL, 'G3DSA:1.10.1750.10:FF:000003', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(57156, NULL, 'G3DSA:3.40.50.720:FF:002123', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(57157, NULL, 'G3DSA:1.20.58.390:FF:000197', NULL, NULL, 'Glutamate-gated chloride channel, putative', NULL, NULL, NULL, NULL, NULL, 4),
(57158, NULL, 'G3DSA:1.10.8.430:FF:000015', NULL, NULL, 'Disease resistance protein (CC-NBS-LRR class) family', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(57159, NULL, 'G3DSA:3.30.200.20:FF:000145', NULL, NULL, 'receptor-like serine/threonine-protein kinase SD1-8', NULL, NULL, NULL, NULL, NULL, 4),
(57160, NULL, 'G3DSA:3.20.140.10:FF:000015', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(57161, NULL, 'G3DSA:1.10.3460.10:FF:000015', NULL, NULL, 'Os02g0610700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(57162, NULL, 'G3DSA:3.40.50.300:FF:000788', NULL, NULL, 'DNA annealing helicase and endonuclease ZRANB3', NULL, NULL, NULL, NULL, NULL, 4),
(57163, NULL, 'G3DSA:2.130.10.10:FF:005925', NULL, NULL, 'EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(57164, NULL, 'G3DSA:3.10.450.40:FF:000005', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(57165, NULL, 'G3DSA:1.10.3380.10:FF:000014', NULL, NULL, 'Putative DEAD/DEAH box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(57166, NULL, 'G3DSA:3.40.50.880:FF:000001', NULL, NULL, 'GMP synthase [glutamine-hydrolyzing]', NULL, NULL, NULL, NULL, NULL, 4),
(57167, NULL, 'G3DSA:3.40.50.300:FF:007404', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57168, NULL, 'G3DSA:3.40.50.410:FF:000057', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(57169, NULL, 'G3DSA:3.30.160.60:FF:003188', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57170, NULL, 'G3DSA:3.40.50.300:FF:007292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57171, NULL, 'G3DSA:3.30.70.3400:FF:000017', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(57172, NULL, 'G3DSA:1.10.730.10:FF:000172', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(57173, NULL, 'G3DSA:3.10.20.90:FF:000939', NULL, NULL, 'CHD gene family protein containing chromodomain, helicase domain, and DNA-binding domain', NULL, NULL, NULL, NULL, NULL, 4),
(57174, NULL, 'G3DSA:1.10.357.110:FF:000007', NULL, NULL, 'Vacuolar sorting protein', NULL, NULL, NULL, NULL, NULL, 4),
(57175, NULL, 'G3DSA:3.40.50.720:FF:001667', NULL, NULL, 'Glyoxylate/hydroxypyruvate reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(57176, NULL, 'G3DSA:3.20.20.70:FF:000028', NULL, NULL, 'Dihydroorotate dehydrogenase (quinone)', NULL, NULL, NULL, NULL, NULL, 4),
(57177, NULL, 'G3DSA:3.40.50.2000:FF:000516', NULL, NULL, 'GD13807', NULL, NULL, NULL, NULL, NULL, 4),
(57178, NULL, 'G3DSA:3.30.160.60:FF:002171', NULL, NULL, 'Zinc finger and BTB domain-containing protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(57179, NULL, 'G3DSA:1.10.510.10:FF:003179', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57180, NULL, 'G3DSA:3.30.750.24:FF:000123', NULL, NULL, 'Sulfate transporter 2.1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(57181, NULL, 'G3DSA:2.10.25.10:FF:000732', NULL, NULL, 'Cryptic family protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(57182, NULL, 'G3DSA:3.30.230.70:FF:000139', NULL, NULL, 'Exosomal 3''-5'' exoribonuclease complex, subunit Rrp41, putative', NULL, NULL, NULL, NULL, NULL, 4),
(57183, NULL, 'G3DSA:1.10.486.10:FF:000030', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(57184, NULL, 'G3DSA:2.20.70.10:FF:000134', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(57185, NULL, 'G3DSA:1.10.565.10:FF:000040', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(57186, NULL, 'G3DSA:3.40.50.2300:FF:000016', NULL, NULL, 'Taste 1 receptor member 2', NULL, NULL, NULL, NULL, NULL, 4),
(57187, NULL, 'G3DSA:2.60.40.10:FF:005801', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57188, NULL, 'G3DSA:3.30.450.60:FF:000001', NULL, NULL, 'AP complex subunit sigma', NULL, NULL, NULL, NULL, NULL, 4),
(57189, NULL, 'G3DSA:3.30.710.10:FF:000107', NULL, NULL, 'Zinc finger and BTB domain containing 22', NULL, NULL, NULL, NULL, NULL, 4),
(57190, NULL, 'G3DSA:3.30.70.1660:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57191, NULL, 'G3DSA:2.10.25.10:FF:000171', NULL, NULL, 'Fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(57192, NULL, 'G3DSA:3.40.50.620:FF:000682', NULL, NULL, 'Protein CBR-VARS-1', NULL, NULL, NULL, NULL, NULL, 4),
(57193, NULL, 'G3DSA:1.25.40.20:FF:001190', NULL, NULL, 'KN motif and ankyrin repeat domains 3', NULL, NULL, NULL, NULL, NULL, 4),
(57194, NULL, 'G3DSA:1.20.1250.20:FF:002242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57195, NULL, 'G3DSA:3.30.1010.10:FF:000115', NULL, NULL, 'Ataxia telangiectasia mutated, putative', NULL, NULL, NULL, NULL, NULL, 4),
(57196, NULL, 'G3DSA:2.60.200.40:FF:000007', NULL, NULL, 'diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(57197, NULL, 'G3DSA:3.40.800.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57198, NULL, 'G3DSA:2.60.40.10:FF:002783', NULL, NULL, 'AMP-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(57199, NULL, 'G3DSA:3.40.50.300:FF:007792', NULL, NULL, 'ZRAB1B, member RAS oncogene family a', NULL, NULL, NULL, NULL, NULL, 4),
(57200, NULL, 'G3DSA:3.40.50.720:FF:000678', NULL, NULL, 'Aos1p', NULL, NULL, NULL, NULL, NULL, 4),
(57201, NULL, 'G3DSA:1.10.10.10:FF:000217', NULL, NULL, 'Peroxisomal membrane protein PEX14', NULL, NULL, NULL, NULL, NULL, 4),
(57202, NULL, 'G3DSA:3.30.40.10:FF:000950', NULL, NULL, 'Nhl repeat-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(57203, NULL, 'G3DSA:1.20.1070.10:FF:000550', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(57204, NULL, 'G3DSA:1.10.510.10:FF:003679', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57205, NULL, 'G3DSA:2.130.10.10:FF:004144', NULL, NULL, 'AGAP002345-PA', NULL, NULL, NULL, NULL, NULL, 4),
(57206, NULL, 'G3DSA:3.20.20.100:FF:000053', NULL, NULL, 'Aldo-keto oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(57207, NULL, 'G3DSA:1.25.10.10:FF:002022', NULL, NULL, 'Transportin-1', NULL, NULL, NULL, NULL, NULL, 4),
(57208, NULL, 'G3DSA:3.40.50.720:FF:000414', NULL, NULL, 'Calcium-activated potassium channel subunit alpha-1', NULL, NULL, NULL, NULL, NULL, 4),
(57209, NULL, 'G3DSA:2.130.10.10:FF:004852', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57210, NULL, 'G3DSA:3.90.660.10:FF:000123', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57211, NULL, 'G3DSA:3.30.300.130:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57212, NULL, 'G3DSA:3.40.50.1440:FF:000073', NULL, NULL, 'Cell division protein, GTPase domain', NULL, NULL, NULL, NULL, NULL, 4),
(57213, NULL, 'G3DSA:3.40.50.300:FF:000524', NULL, NULL, 'ATP-dependent RNA helicase DDX42', NULL, NULL, NULL, NULL, NULL, 4),
(57214, NULL, 'G3DSA:3.30.160.60:FF:004941', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57215, NULL, 'G3DSA:3.40.50.1970:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57216, NULL, 'G3DSA:4.10.1240.50:FF:000002', NULL, NULL, 'REST corepressor isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(57217, NULL, 'G3DSA:1.10.287.70:FF:000304', NULL, NULL, 'TWiK family of potassium channels', NULL, NULL, NULL, NULL, NULL, 4),
(57218, NULL, 'G3DSA:3.10.450.50:FF:000103', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(57219, NULL, 'G3DSA:2.120.10.80:FF:000399', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57220, NULL, 'G3DSA:3.30.160.60:FF:004880', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57221, NULL, 'G3DSA:2.60.40.1090:FF:000003', NULL, NULL, 'Fimbrial subunit', NULL, NULL, NULL, NULL, NULL, 4),
(57222, NULL, 'G3DSA:3.90.810.10:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57223, NULL, 'G3DSA:3.40.1190.20:FF:000241', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57224, NULL, 'G3DSA:3.50.50.60:FF:001268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57225, NULL, 'G3DSA:1.25.40.10:FF:001006', NULL, NULL, 'Sel1 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(57226, NULL, 'G3DSA:3.90.70.10:FF:000876', NULL, NULL, 'Protein CBG06541', NULL, NULL, NULL, NULL, NULL, 4),
(57227, NULL, 'G3DSA:3.80.10.10:FF:004431', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(57228, NULL, 'G3DSA:3.20.180.20:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57229, NULL, 'G3DSA:3.40.720.10:FF:000027', NULL, NULL, 'iduronate 2-sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(57230, NULL, 'G3DSA:2.60.40.10:FF:004020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57231, NULL, 'G3DSA:1.10.3430.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57232, NULL, 'G3DSA:2.10.25.10:FF:000996', NULL, NULL, 'Notch homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(57233, NULL, 'G3DSA:3.60.21.10:FF:000399', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(57234, NULL, 'G3DSA:3.30.40.10:FF:001467', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57235, NULL, 'G3DSA:3.30.200.20:FF:000645', NULL, NULL, 'Receptor-like protein kinase FERONIA', NULL, NULL, NULL, NULL, NULL, 4),
(57236, NULL, 'G3DSA:2.130.10.10:FF:002199', NULL, NULL, 'Probable elongator complex protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(57237, NULL, 'G3DSA:2.10.110.10:FF:000014', NULL, NULL, 'PDZ and LIM domain protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(57238, NULL, 'G3DSA:3.40.640.10:FF:000026', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(57239, NULL, 'G3DSA:2.40.10.10:FF:000079', NULL, NULL, 'Serine protease 53', NULL, NULL, NULL, NULL, NULL, 4),
(57240, NULL, 'G3DSA:3.30.70.330:FF:002574', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57241, NULL, 'G3DSA:3.40.50.300:FF:002733', NULL, NULL, 'Galactose-3-O-sulfotransferase 4', NULL, NULL, NULL, NULL, NULL, 4),
(57242, NULL, 'G3DSA:3.30.160.60:FF:002732', NULL, NULL, 'zinc finger protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(57243, NULL, 'G3DSA:1.20.950.20:FF:000020', NULL, NULL, 'Cytochrome b', NULL, NULL, NULL, NULL, NULL, 4),
(57244, NULL, 'G3DSA:2.130.10.10:FF:003363', NULL, NULL, 'Myosin heavy chain kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(57245, NULL, 'G3DSA:1.10.510.10:FF:001734', NULL, NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 130', NULL, NULL, NULL, NULL, NULL, 4),
(57246, NULL, 'G3DSA:3.30.2080.10:FF:000002', NULL, NULL, 'Glycosyl hydrolase family 92', NULL, NULL, NULL, NULL, NULL, 4),
(57247, NULL, 'G3DSA:2.40.30.10:FF:000378', NULL, NULL, 'Elongation factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(57248, NULL, 'G3DSA:3.40.50.1820:FF:001552', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57249, NULL, 'G3DSA:3.30.1640.30:FF:000006', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(57250, NULL, 'G3DSA:3.30.470.30:FF:000021', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(57251, NULL, 'G3DSA:3.40.50.1100:FF:000201', NULL, NULL, 'Threonine ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(57252, NULL, 'G3DSA:3.30.70.20:FF:000016', NULL, NULL, 'NADH-quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(57253, NULL, 'G3DSA:3.30.830.10:FF:000234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57254, NULL, 'G3DSA:3.10.350.10:FF:000045', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(57255, NULL, 'G3DSA:3.40.1110.10:FF:000312', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57256, NULL, 'G3DSA:1.10.1200.10:FF:000119', NULL, NULL, 'Polyketide synthase, putative (JCVI)', NULL, NULL, NULL, NULL, NULL, 4),
(57257, NULL, 'G3DSA:3.30.420.10:FF:000271', NULL, NULL, 'Ribonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(57258, NULL, 'G3DSA:3.30.30.10:FF:000005', NULL, NULL, 'Defensin', NULL, NULL, NULL, NULL, NULL, 4),
(57259, NULL, 'G3DSA:1.20.1070.10:FF:001567', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57260, NULL, 'G3DSA:2.130.10.10:FF:001979', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(57261, NULL, 'G3DSA:3.40.20.10:FF:000015', NULL, NULL, 'supervillin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(57262, NULL, 'G3DSA:1.10.8.60:FF:000170', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(57263, NULL, 'G3DSA:3.40.630.10:FF:000464', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57264, NULL, 'G3DSA:1.20.1560.10:FF:000306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57265, NULL, 'G3DSA:4.10.1010.10:FF:000001', NULL, NULL, 'Apical membrane antigen 1', NULL, NULL, NULL, NULL, NULL, 4),
(57266, NULL, 'G3DSA:3.40.30.10:FF:001033', NULL, NULL, 'Selenoprotein V', NULL, NULL, NULL, NULL, NULL, 4),
(57267, NULL, 'G3DSA:3.30.70.580:FF:000035', NULL, NULL, 'tRNA pseudouridine synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(57268, NULL, 'G3DSA:3.30.460.10:FF:000037', NULL, NULL, 'Lincosamide nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(57269, NULL, 'G3DSA:2.60.40.2030:FF:000032', NULL, NULL, 'Adhesion G protein-coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(57270, NULL, 'G3DSA:3.80.10.10:FF:002278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57271, NULL, 'G3DSA:2.60.40.60:FF:000887', NULL, NULL, 'Si:dkey-30k22.7', NULL, NULL, NULL, NULL, NULL, 4),
(57272, NULL, 'G3DSA:3.30.160.60:FF:004677', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57273, NULL, 'G3DSA:3.30.70.270:FF:000061', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(57274, NULL, 'G3DSA:1.25.40.20:FF:001251', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(57275, NULL, 'G3DSA:3.40.50.2000:FF:000308', NULL, NULL, 'Glycosyltransferase family 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(57276, NULL, 'G3DSA:2.60.40.10:FF:002575', NULL, NULL, 'Protein tyrosine phosphatase, receptor type Q', NULL, NULL, NULL, NULL, NULL, 4),
(57277, NULL, 'G3DSA:1.10.238.10:FF:000909', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(57278, NULL, 'G3DSA:1.10.490.10:FF:000017', NULL, NULL, 'Globin-like protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(57279, NULL, 'G3DSA:3.90.1150.10:FF:000443', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57280, NULL, 'G3DSA:2.30.42.10:FF:000327', NULL, NULL, 'Protein inturned', NULL, NULL, NULL, NULL, NULL, 4),
(57281, NULL, 'G3DSA:2.10.90.10:FF:000130', NULL, NULL, 'Noggin', NULL, NULL, NULL, NULL, NULL, 4),
(57282, NULL, 'G3DSA:1.25.40.10:FF:000489', NULL, NULL, 'cilia- and flagella-associated protein 70 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(57283, NULL, 'G3DSA:2.30.30.100:FF:000219', NULL, NULL, 'Sm protein', NULL, NULL, NULL, NULL, NULL, 4),
(57284, NULL, 'G3DSA:3.40.30.10:FF:001180', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(57285, NULL, 'G3DSA:2.120.10.30:FF:000137', NULL, NULL, 'Dappled', NULL, NULL, NULL, NULL, NULL, 4),
(57286, NULL, 'G3DSA:3.40.190.10:FF:000683', NULL, NULL, 'Putative glutamate receptor ionotropic kainate 3', NULL, NULL, NULL, NULL, NULL, 4),
(57287, NULL, 'G3DSA:3.10.20.90:FF:000439', NULL, NULL, 'Autophagy protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(57288, NULL, 'G3DSA:3.40.50.300:FF:002469', NULL, NULL, 'Cell division control protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(57289, NULL, 'G3DSA:3.40.50.1820:FF:000271', NULL, NULL, 'Neuroligin-1', NULL, NULL, NULL, NULL, NULL, 4),
(57290, NULL, 'G3DSA:3.30.450.20:FF:000068', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(57291, NULL, 'G3DSA:3.20.20.70:FF:000528', NULL, NULL, 'Fe hydrogenase maturation rSAM protein HydG', NULL, NULL, NULL, NULL, NULL, 4),
(57292, NULL, 'G3DSA:1.25.40.10:FF:003923', NULL, NULL, 'SnoRNA-binding rRNA-processing protein', NULL, NULL, NULL, NULL, NULL, 4),
(57293, NULL, 'G3DSA:3.30.160.60:FF:000462', NULL, NULL, 'Zinc finger protein 410', NULL, NULL, NULL, NULL, NULL, 4),
(57294, NULL, 'G3DSA:1.10.510.10:FF:004084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57295, NULL, 'G3DSA:1.10.287.110:FF:000345', NULL, NULL, 'Molecular chaperones (DnaJ family)', NULL, NULL, NULL, NULL, NULL, 4),
(57296, NULL, 'G3DSA:1.10.10.60:FF:000743', NULL, NULL, 'Transcription factor MYB57', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(57297, NULL, 'G3DSA:2.130.10.10:FF:000754', NULL, NULL, 'SMU1, DNA replication regulator and spliceosomal factor', NULL, NULL, NULL, NULL, NULL, 4),
(57298, NULL, 'G3DSA:1.20.58.60:FF:000313', NULL, NULL, 'Microtubule-actin cross-linking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(57299, NULL, 'G3DSA:2.60.40.10:FF:005184', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57300, NULL, 'G3DSA:2.60.120.430:FF:000013', NULL, NULL, 'Putative receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(57301, NULL, 'G3DSA:3.40.50.2000:FF:000196', NULL, NULL, 'UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase GtfA subunit', NULL, NULL, NULL, NULL, NULL, 4),
(57302, NULL, 'G3DSA:3.40.50.800:FF:000051', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(57303, NULL, 'G3DSA:3.10.290.60:FF:000009', NULL, NULL, 'Ubiquitin activating enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(57304, NULL, 'G3DSA:3.40.5.60:FF:000001', NULL, NULL, 'DNA replication complex GINS protein SLD5', NULL, NULL, NULL, NULL, NULL, 4),
(57305, NULL, 'G3DSA:2.60.120.10:FF:000110', NULL, NULL, 'AGC/AGC-SAR/CILIATE-E2B protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(57306, NULL, 'G3DSA:3.30.70.330:FF:002102', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57307, NULL, 'G3DSA:1.10.1670.10:FF:000002', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(57308, NULL, 'G3DSA:2.10.25.10:FF:001249', NULL, NULL, 'Matrilin 3a', NULL, NULL, NULL, NULL, NULL, 4),
(57309, NULL, 'G3DSA:1.10.510.10:FF:000453', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase HSL2', NULL, NULL, NULL, NULL, NULL, 4),
(57310, NULL, 'G3DSA:3.40.50.300:FF:001805', NULL, NULL, 'Similar to DNA repair protein rad50', NULL, NULL, NULL, NULL, NULL, 4),
(57311, NULL, 'G3DSA:1.25.40.10:FF:004587', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57312, NULL, 'G3DSA:1.25.40.330:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57313, NULL, 'G3DSA:2.30.29.30:FF:000105', NULL, NULL, 'Target of rapamycin complex 2 subunit MAPKAP1', NULL, NULL, NULL, NULL, NULL, 4),
(57314, NULL, 'G3DSA:3.30.540.10:FF:000038', NULL, NULL, 'Inositol-1-monophosphatase SuhB', NULL, NULL, NULL, NULL, NULL, 4),
(57315, NULL, 'G3DSA:1.25.40.10:FF:001153', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(57316, NULL, 'G3DSA:1.25.70.10:FF:000053', NULL, NULL, 'mTERF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(57317, NULL, 'G3DSA:1.25.10.10:FF:002606', NULL, NULL, 'LOC553344 protein', NULL, NULL, NULL, NULL, NULL, 4),
(57318, NULL, 'G3DSA:2.70.130.10:FF:000119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57319, NULL, 'G3DSA:1.10.30.10:FF:000016', NULL, NULL, 'FACT complex subunit SSRP1', NULL, NULL, NULL, NULL, NULL, 4),
(57320, NULL, 'G3DSA:1.20.1070.10:FF:000286', NULL, NULL, 'Neuropeptide CCHamide-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(57321, NULL, 'G3DSA:3.10.110.10:FF:000151', NULL, NULL, 'Ubiquitin-conjugating enzyme E2-17 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(57322, NULL, 'G3DSA:1.20.58.60:FF:000460', NULL, NULL, 'AGAP004440-PA', NULL, NULL, NULL, NULL, NULL, 4),
(57323, NULL, 'G3DSA:2.60.120.290:FF:000044', NULL, NULL, 'Complement C1r subcomponent like', NULL, NULL, NULL, NULL, NULL, 4),
(57324, NULL, 'G3DSA:2.60.40.10:FF:001406', NULL, NULL, 'Protein-glutamine gamma-glutamyltransferase 4', NULL, NULL, NULL, NULL, NULL, 4),
(57325, NULL, 'G3DSA:2.40.50.1020:FF:000021', NULL, NULL, 'Two-component system response regulator protein', NULL, NULL, NULL, NULL, NULL, 4),
(57326, NULL, 'G3DSA:3.30.70.330:FF:000157', NULL, NULL, 'RNA-binding protein 8A', NULL, NULL, NULL, NULL, NULL, 4),
(57327, NULL, 'G3DSA:1.10.287.1970:FF:000004', NULL, NULL, 'Aminotransferase, classes I and II family protein', NULL, NULL, NULL, NULL, NULL, 4),
(57328, NULL, 'G3DSA:3.30.160.380:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57329, NULL, 'G3DSA:3.30.40.10:FF:001259', NULL, NULL, 'Os11g0610600 protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(57330, NULL, 'G3DSA:4.10.400.10:FF:000332', NULL, NULL, 'Suppressor of tumorigenicity 14 protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(57331, NULL, 'G3DSA:1.10.10.10:FF:000689', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(57332, NULL, 'G3DSA:1.10.238.10:FF:000853', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57333, NULL, 'G3DSA:2.60.40.10:FF:005037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57334, NULL, 'G3DSA:3.30.70.100:FF:000173', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57335, NULL, 'G3DSA:1.20.272.10:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57336, NULL, 'G3DSA:1.20.58.160:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57337, NULL, 'G3DSA:3.30.390.50:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57338, NULL, 'G3DSA:2.130.10.10:FF:004644', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(57339, NULL, 'G3DSA:2.130.10.10:FF:003216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57340, NULL, 'G3DSA:4.10.270.10:FF:000006', NULL, NULL, 'Calmodulin-binding transcription activator 1', NULL, NULL, NULL, NULL, NULL, 4),
(57341, NULL, 'G3DSA:3.40.50.720:FF:000178', NULL, NULL, 'Saccharopine dehydrogenase-like oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(57342, NULL, 'G3DSA:2.30.110.10:FF:000088', NULL, NULL, 'Pyridoxamine 5''-phosphate oxidase-related FMN-binding', NULL, NULL, NULL, NULL, NULL, 4),
(57343, NULL, 'G3DSA:3.30.70.330:FF:000865', NULL, NULL, 'Plastid-specific 30S ribosomal protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(57344, NULL, 'G3DSA:2.40.50.140:FF:000727', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57345, NULL, 'G3DSA:3.30.70.1820:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57346, NULL, 'G3DSA:2.40.70.10:FF:000408', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57347, NULL, 'G3DSA:3.30.420.10:FF:000119', NULL, NULL, 'Ribonuclease H', NULL, NULL, NULL, NULL, NULL, 4),
(57348, NULL, 'G3DSA:1.20.1250.20:FF:000241', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(57349, NULL, 'G3DSA:3.30.390.30:FF:000015', NULL, NULL, 'Nitrite reductase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(57350, NULL, 'G3DSA:1.10.510.10:FF:002398', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57351, NULL, 'G3DSA:1.25.40.10:FF:002434', NULL, NULL, 'Putative pentatricopeptide repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(57352, NULL, 'G3DSA:1.10.287.70:FF:000512', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57353, NULL, 'G3DSA:3.40.50.300:FF:006364', NULL, NULL, 'Protein CBG21117', NULL, NULL, NULL, NULL, NULL, 4),
(57354, NULL, 'G3DSA:2.30.30.40:FF:000179', NULL, NULL, 'PML-RARA regulated adaptor molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(57355, NULL, 'G3DSA:3.80.10.10:FF:000480', NULL, NULL, 'Leucine rich repeat containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(57356, NULL, 'G3DSA:2.170.270.10:FF:000235', NULL, NULL, 'PR domain containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(57357, NULL, 'G3DSA:3.90.15.10:FF:000012', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(57358, NULL, 'G3DSA:1.20.1310.10:FF:000086', NULL, NULL, 'Cullin-like protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(57359, NULL, 'G3DSA:1.10.150.310:FF:000001', NULL, NULL, 'RNA-binding transcriptional accessory protein', NULL, NULL, NULL, NULL, NULL, 4),
(57360, NULL, 'G3DSA:3.90.190.10:FF:000278', NULL, NULL, 'Protein CBG26392', NULL, NULL, NULL, NULL, NULL, 4),
(57361, NULL, 'G3DSA:3.80.10.10:FF:002014', NULL, NULL, 'Receptor-like protein 30', NULL, NULL, NULL, NULL, NULL, 4),
(57362, NULL, 'G3DSA:3.30.40.10:FF:000539', NULL, NULL, 'Ring finger domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(57363, NULL, 'G3DSA:1.10.510.10:FF:000189', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(57364, NULL, 'G3DSA:2.60.110.10:FF:000020', NULL, NULL, 'Os08g0381600 protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(57365, NULL, 'G3DSA:2.40.70.10:FF:000296', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57366, NULL, 'G3DSA:3.40.50.1000:FF:000317', NULL, NULL, 'NLI interacting factor-like phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(57367, NULL, 'G3DSA:1.25.40.470:FF:000061', NULL, NULL, 'WD repeat-containing protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(57368, NULL, 'G3DSA:3.30.160.60:FF:001243', NULL, NULL, 'myeloid zinc finger 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(57369, NULL, 'G3DSA:2.10.25.10:FF:001660', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57370, NULL, 'G3DSA:3.80.10.10:FF:001558', NULL, NULL, 'Leucine rich repeat and phosphatase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(57371, NULL, 'G3DSA:2.60.40.150:FF:000010', NULL, NULL, 'Ras GTPase-activating protein nGAP isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(57372, NULL, 'G3DSA:2.30.29.30:FF:000813', NULL, NULL, 'Guanine nucleotide exchange factor UNC-73B', NULL, NULL, NULL, NULL, NULL, 4),
(57373, NULL, 'G3DSA:2.10.60.10:FF:000038', NULL, NULL, 'Serine/threonine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(57374, NULL, 'G3DSA:3.40.50.300:FF:001244', NULL, NULL, 'tRNA threonylcarbamoyl adenosine modification protein YjeE', NULL, NULL, NULL, NULL, NULL, 4),
(57375, NULL, 'G3DSA:4.10.280.10:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57376, NULL, 'G3DSA:1.25.40.120:FF:000040', NULL, NULL, 'Protein farnesyltransferase/geranylgeranyltransferase type-1 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(57377, NULL, 'G3DSA:4.10.60.10:FF:000106', NULL, NULL, 'Zinc finger protein containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(57378, NULL, 'G3DSA:3.30.70.141:FF:000023', NULL, NULL, 'Nucleoside diphosphate kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(57379, NULL, 'G3DSA:1.20.120.1750:FF:000095', NULL, NULL, 'Probable E3 ubiquitin-protein ligase ARI12', NULL, NULL, NULL, NULL, NULL, 4),
(57380, NULL, 'G3DSA:1.20.120.220:FF:000011', NULL, NULL, 'ATP synthase subunit a', NULL, NULL, NULL, NULL, NULL, 4),
(57381, NULL, 'G3DSA:1.10.472.170:FF:000009', NULL, NULL, 'Putative transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(57382, NULL, 'G3DSA:1.10.10.10:FF:001145', NULL, NULL, 'PCI domain-containing protein C1105.07c', NULL, NULL, NULL, NULL, NULL, 4),
(57383, NULL, 'G3DSA:1.20.1270.60:FF:000260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57384, NULL, 'G3DSA:1.10.238.10:FF:000089', NULL, NULL, 'calmodulin-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(57385, NULL, 'G3DSA:3.40.630.30:FF:000150', NULL, NULL, 'N-hydroxycinnamoyl-CoA:tyramine N-hydroxycinnamoyl transferase THT7-1', NULL, NULL, NULL, NULL, NULL, 4),
(57386, NULL, 'G3DSA:3.30.160.60:FF:003452', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57387, NULL, 'G3DSA:1.25.40.20:FF:000846', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(57388, NULL, 'G3DSA:1.20.1050.10:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57389, NULL, 'G3DSA:3.80.10.10:FF:003767', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57390, NULL, 'G3DSA:4.10.400.10:FF:000068', NULL, NULL, 'Low-density lipoprotein receptor-related protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(57391, NULL, 'G3DSA:2.40.50.120:FF:000013', NULL, NULL, 'Complement C3', NULL, NULL, NULL, NULL, NULL, 4),
(57392, NULL, 'G3DSA:3.30.870.10:FF:000147', NULL, NULL, 'Probable tyrosyl-DNA phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(57393, NULL, 'G3DSA:1.10.510.10:FF:002959', NULL, NULL, 'Chromosome 21, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(57394, NULL, 'G3DSA:2.10.25.10:FF:001513', NULL, NULL, 'Fibulin-1', NULL, NULL, NULL, NULL, NULL, 4),
(57395, NULL, 'G3DSA:1.10.3720.10:FF:000086', NULL, NULL, 'Glutathione transport system permease protein GsiC', NULL, NULL, NULL, NULL, NULL, 4),
(57396, NULL, 'G3DSA:3.40.190.10:FF:000536', NULL, NULL, 'Norspermidine sensor', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(57397, NULL, 'G3DSA:2.70.160.11:FF:000044', NULL, NULL, 'Histone-arginine methyltransferase CARM1', NULL, NULL, NULL, NULL, NULL, 4),
(57398, NULL, 'G3DSA:1.10.10.60:FF:000890', NULL, NULL, 'CHD gene family protein containing chromodomain, helicase domain, and DNA-binding domain', NULL, NULL, NULL, NULL, NULL, 4),
(57399, NULL, 'G3DSA:1.20.5.370:FF:000006', NULL, NULL, 'Myosin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(57400, NULL, 'G3DSA:1.25.10.10:FF:002494', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57401, NULL, 'G3DSA:1.20.1440.180:FF:000005', NULL, NULL, 'Probable serine/threonine-protein kinase irlD', NULL, NULL, NULL, NULL, NULL, 4),
(57402, NULL, 'G3DSA:3.30.160.60:FF:001390', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57403, NULL, 'G3DSA:1.20.1560.10:FF:000453', NULL, NULL, 'ABC transporter B family member 6', NULL, NULL, NULL, NULL, NULL, 4),
(57404, NULL, 'G3DSA:3.50.50.60:FF:000487', NULL, NULL, 'Thiol-specific monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(57405, NULL, 'G3DSA:2.30.150.10:FF:000001', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(57406, NULL, 'G3DSA:3.30.1370.10:FF:000075', NULL, NULL, 'KRR1 small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4),
(57407, NULL, 'G3DSA:3.50.50.100:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57408, NULL, 'G3DSA:3.40.50.10810:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57409, NULL, 'G3DSA:1.20.1270.60:FF:000108', NULL, NULL, 'Rho-GTPase-activating protein RGD2', NULL, NULL, NULL, NULL, NULL, 4),
(57410, NULL, 'G3DSA:3.40.50.1820:FF:000119', NULL, NULL, 'Alpha/beta hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(57411, NULL, 'G3DSA:3.30.70.330:FF:001793', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57412, NULL, 'G3DSA:2.60.210.10:FF:000084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57413, NULL, 'G3DSA:1.10.472.10:FF:000088', NULL, NULL, 'Cyclin-H', NULL, NULL, NULL, NULL, NULL, 4),
(57414, NULL, 'G3DSA:2.70.70.10:FF:000053', NULL, NULL, 'PTS beta-glucoside transporter subunit IIBCA', NULL, NULL, NULL, NULL, NULL, 4),
(57415, NULL, 'G3DSA:2.10.70.10:FF:000275', NULL, NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(57416, NULL, 'G3DSA:2.40.50.140:FF:000019', NULL, NULL, 'Translation initiation factor IF-1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(57417, NULL, 'G3DSA:1.25.40.10:FF:000225', NULL, NULL, 'Protein SMG7', NULL, NULL, NULL, NULL, NULL, 4),
(57418, NULL, 'G3DSA:1.10.1070.11:FF:000042', NULL, NULL, 'Phosphatidylinositol 3-kinase VPS34', NULL, NULL, NULL, NULL, NULL, 4),
(57419, NULL, 'G3DSA:3.30.420.40:FF:000375', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(57420, NULL, 'G3DSA:3.30.200.20:FF:001426', NULL, NULL, 'MAP kinase-interacting serine/threonine-protein kinase 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(57421, NULL, 'G3DSA:3.40.525.10:FF:000006', NULL, NULL, 'SEC14-like lipid binding 1', NULL, NULL, NULL, NULL, NULL, 4),
(57422, NULL, 'G3DSA:1.20.1160.11:FF:000002', NULL, NULL, 'Paired amphipathic helix protein SIN3', NULL, NULL, NULL, NULL, NULL, 4),
(57423, NULL, 'G3DSA:1.10.8.10:FF:000205', NULL, NULL, 'Ubiquitin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(57424, NULL, 'G3DSA:2.60.40.10:FF:001294', NULL, NULL, 'EGF like, fibronectin type III and laminin G domains', NULL, NULL, NULL, NULL, NULL, 4),
(57425, NULL, 'G3DSA:2.70.170.10:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57426, NULL, 'G3DSA:3.40.50.720:FF:001903', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57427, NULL, 'G3DSA:2.10.220.10:FF:000168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57428, NULL, 'G3DSA:2.30.29.30:FF:000252', NULL, NULL, 'ARF GTPase activator (Csx2)', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(57429, NULL, 'G3DSA:3.40.720.10:FF:000230', NULL, NULL, 'Arylsulfatase (A or B)', NULL, NULL, NULL, NULL, NULL, 4),
(57430, NULL, 'G3DSA:3.40.50.2000:FF:000460', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(57431, NULL, 'G3DSA:1.10.268.10:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57432, NULL, 'G3DSA:3.40.50.300:FF:008573', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57433, NULL, 'G3DSA:3.40.50.300:FF:006887', NULL, NULL, 'Predicted ATP-dependent endonuclease, OLD family', NULL, NULL, NULL, NULL, NULL, 4),
(57434, NULL, 'G3DSA:1.10.10.10:FF:001706', NULL, NULL, 'MW2463 protein', NULL, NULL, NULL, NULL, NULL, 4),
(57435, NULL, 'G3DSA:3.30.420.40:FF:000898', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57436, NULL, 'G3DSA:1.25.40.10:FF:003659', NULL, NULL, 'Transcription factor IIIC-gamma subunit', NULL, NULL, NULL, NULL, NULL, 4),
(57437, NULL, 'G3DSA:2.130.10.10:FF:005369', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57438, NULL, 'G3DSA:2.60.40.10:FF:004784', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57439, NULL, 'G3DSA:1.20.58.480:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57440, NULL, 'G3DSA:2.60.120.920:FF:000003', NULL, NULL, 'ryanodine receptor isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(57441, NULL, 'G3DSA:1.25.10.10:FF:003039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57442, NULL, 'G3DSA:2.60.120.330:FF:000040', NULL, NULL, 'Chromosome 21, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(57443, NULL, 'G3DSA:3.90.1110.10:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57444, NULL, 'G3DSA:1.10.287.70:FF:000720', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57445, NULL, 'G3DSA:3.40.50.300:FF:004150', NULL, NULL, 'Adapter protein unc-53', NULL, NULL, NULL, NULL, NULL, 4),
(57446, NULL, 'G3DSA:2.60.40.10:FF:004312', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57447, NULL, 'G3DSA:3.10.100.10:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57448, NULL, 'G3DSA:1.10.520.10:FF:000015', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(57449, NULL, 'G3DSA:1.25.40.10:FF:004648', NULL, NULL, 'Protein CBG11979', NULL, NULL, NULL, NULL, NULL, 4),
(57450, NULL, 'G3DSA:2.130.10.10:FF:005425', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57451, NULL, 'G3DSA:2.20.100.10:FF:000051', NULL, NULL, 'Cartilage intermediate layer protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(57452, NULL, 'G3DSA:3.40.50.10490:FF:000072', NULL, NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', NULL, NULL, NULL, NULL, NULL, 4),
(57453, NULL, 'G3DSA:3.40.50.1820:FF:000294', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(57454, NULL, 'G3DSA:1.10.472.30:FF:000010', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(57455, NULL, 'G3DSA:2.40.10.10:FF:000495', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57456, NULL, 'G3DSA:2.60.40.150:FF:000038', NULL, NULL, 'Type I inositol 3,4-bisphosphate 4-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(57457, NULL, 'G3DSA:1.25.40.10:FF:004704', NULL, NULL, 'Os06g0705300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(57458, NULL, 'G3DSA:2.40.10.10:FF:000551', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57459, NULL, 'G3DSA:2.10.25.10:FF:000816', NULL, NULL, 'Thrombomodulin', NULL, NULL, NULL, NULL, NULL, 4),
(57460, NULL, 'G3DSA:3.30.230.10:FF:000205', NULL, NULL, 'Phosphomevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(57461, NULL, 'G3DSA:1.10.510.10:FF:002662', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57462, NULL, 'G3DSA:3.90.640.10:FF:000263', NULL, NULL, 'Actin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(57463, NULL, 'G3DSA:3.30.540.10:FF:000015', NULL, NULL, '3'',5''-bisphosphate nucleotidase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(57464, NULL, 'G3DSA:3.40.50.300:FF:004094', NULL, NULL, 'Putative dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(57465, NULL, 'G3DSA:2.60.40.10:FF:004256', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57466, NULL, 'G3DSA:2.130.10.10:FF:004913', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57467, NULL, 'G3DSA:2.110.10.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57468, NULL, 'G3DSA:3.40.1090.10:FF:000051', NULL, NULL, 'Triacylglycerol lipase SDP1L', NULL, NULL, NULL, NULL, NULL, 4),
(57469, NULL, 'G3DSA:2.115.10.20:FF:000006', NULL, NULL, 'Glycoside hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(57470, NULL, 'G3DSA:3.40.50.12780:FF:000202', NULL, NULL, 'Solute carrier family 27 member 2', NULL, NULL, NULL, NULL, NULL, 4),
(57471, NULL, 'G3DSA:2.40.50.40:FF:000040', NULL, NULL, 'CCL4L2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(57472, NULL, 'G3DSA:1.10.10.10:FF:000661', NULL, NULL, 'Apoptotic protease-activating factor', NULL, NULL, NULL, NULL, NULL, 4),
(57473, NULL, 'G3DSA:1.20.1740.10:FF:000107', NULL, NULL, 'Amino acid permease-associated region', NULL, NULL, NULL, NULL, NULL, 4),
(57474, NULL, 'G3DSA:3.30.530.20:FF:000046', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(57475, NULL, 'G3DSA:3.60.10.10:FF:000087', NULL, NULL, 'Ngl1p', NULL, NULL, NULL, NULL, NULL, 4),
(57476, NULL, 'G3DSA:1.10.150.380:FF:000005', NULL, NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit E', NULL, NULL, NULL, NULL, NULL, 4),
(57477, NULL, 'G3DSA:1.10.150.50:FF:000015', NULL, NULL, 'ankyrin repeat and sterile alpha motif domain-containing protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(57478, NULL, 'G3DSA:3.40.50.1010:FF:000062', NULL, NULL, 'rRNA processing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(57479, NULL, 'G3DSA:2.30.29.230:FF:000008', NULL, NULL, 'Small G protein signaling modulator 2', NULL, NULL, NULL, NULL, NULL, 4),
(57480, NULL, 'G3DSA:3.40.50.150:FF:001154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57481, NULL, 'G3DSA:2.130.10.10:FF:001154', NULL, NULL, 'WD repeat and HMG-box DNA-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(57482, NULL, 'G3DSA:3.30.40.10:FF:001528', NULL, NULL, 'SLX1 homolog B, structure-specific endonuclease subunit', NULL, NULL, NULL, NULL, NULL, 4),
(57483, NULL, 'G3DSA:3.40.1110.10:FF:000076', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(57484, NULL, 'G3DSA:3.30.70.330:FF:001938', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57485, NULL, 'G3DSA:1.10.3470.10:FF:000049', NULL, NULL, 'Iron compound ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(57486, NULL, 'G3DSA:1.25.40.420:FF:000068', NULL, NULL, 'Topoisomerase TOP1-interacting protein BTBD1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(57487, NULL, 'G3DSA:2.130.10.10:FF:005897', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57488, NULL, 'G3DSA:1.10.10.60:FF:001143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57489, NULL, 'G3DSA:2.60.40.10:FF:001030', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(57490, NULL, 'G3DSA:3.30.420.110:FF:000076', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(57491, NULL, 'G3DSA:1.10.10.10:FF:000133', NULL, NULL, 'Regulatory protein RecX', NULL, NULL, NULL, NULL, NULL, 4),
(57492, NULL, 'G3DSA:3.20.20.80:FF:000065', NULL, NULL, 'Cytoplasmic alpha-amylase', NULL, NULL, NULL, NULL, NULL, 4),
(57493, NULL, 'G3DSA:1.10.420.10:FF:000007', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(57494, NULL, 'G3DSA:3.30.9.10:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57495, NULL, 'G3DSA:3.40.50.620:FF:000390', NULL, NULL, 'Ethanolamine-phosphate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(57496, NULL, 'G3DSA:3.90.1170.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57497, NULL, 'G3DSA:1.10.510.10:FF:002167', NULL, NULL, 'Serine/threonine-protein kinase/endoribonuclease ire-1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(57498, NULL, 'G3DSA:1.25.10.10:FF:000285', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(57499, NULL, 'G3DSA:3.40.50.10190:FF:000100', NULL, NULL, 'DNA polymerase II complex', NULL, NULL, NULL, NULL, NULL, 4),
(57500, NULL, 'G3DSA:3.30.160.60:FF:000962', NULL, NULL, 'zinc finger protein 513 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(57501, NULL, 'G3DSA:3.40.50.620:FF:000766', NULL, NULL, 'Os02g0134000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(57502, NULL, 'G3DSA:3.30.70.330:FF:002074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57503, NULL, 'G3DSA:3.20.20.140:FF:000194', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(57504, NULL, 'G3DSA:1.10.238.10:FF:000589', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57505, NULL, 'G3DSA:3.10.330.10:FF:000015', NULL, NULL, 'Ubiquitin fusion degradation protein 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(57506, NULL, 'G3DSA:2.60.40.10:FF:005301', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57507, NULL, 'G3DSA:3.40.50.150:FF:001682', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57508, NULL, 'G3DSA:3.80.10.10:FF:003211', NULL, NULL, 'Leucine-rich repeat (LRR) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(57509, NULL, 'G3DSA:3.40.50.2300:FF:000988', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57510, NULL, 'G3DSA:3.40.50.150:FF:001210', NULL, NULL, 'Modification methylase PvuII', NULL, NULL, NULL, NULL, NULL, 4),
(57511, NULL, 'G3DSA:3.30.342.10:FF:000016', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(57512, NULL, 'G3DSA:2.30.29.30:FF:000521', NULL, NULL, 'Cnk', NULL, NULL, NULL, NULL, NULL, 4),
(57513, NULL, 'G3DSA:3.40.50.300:FF:006387', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57514, NULL, 'G3DSA:3.80.10.10:FF:004515', NULL, NULL, 'Leucine-rich repeat receptor-like kinase', NULL, NULL, NULL, NULL, NULL, 4),
(57515, NULL, 'G3DSA:3.30.980.10:FF:000032', NULL, NULL, 'Alanyl-tRNA synthetase-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(57516, NULL, 'G3DSA:3.60.40.10:FF:000235', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(57517, NULL, 'G3DSA:3.30.160.60:FF:001035', NULL, NULL, 'zinc finger protein 697', NULL, NULL, NULL, NULL, NULL, 4),
(57518, NULL, 'G3DSA:3.30.420.40:FF:000398', NULL, NULL, 'Probable apyrase 6', NULL, NULL, NULL, NULL, NULL, 4),
(57519, NULL, 'G3DSA:1.25.40.20:FF:001274', NULL, NULL, 'Os09g0328600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(57520, NULL, 'G3DSA:3.40.640.10:FF:000173', NULL, NULL, 'Possible 8-amino-7-oxononanoate synthase bioF2', NULL, NULL, NULL, NULL, NULL, 4),
(57521, NULL, 'G3DSA:3.80.10.10:FF:004195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57522, NULL, 'G3DSA:1.10.238.10:FF:000117', NULL, NULL, 'multiple coagulation factor deficiency protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(57523, NULL, 'G3DSA:3.30.160.60:FF:002816', NULL, NULL, 'Protein TRANSPARENT TESTA 1', NULL, NULL, NULL, NULL, NULL, 4),
(57524, NULL, 'G3DSA:3.60.90.10:FF:000007', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(57525, NULL, 'G3DSA:2.60.120.200:FF:000613', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(57526, NULL, 'G3DSA:3.40.50.1440:FF:000157', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(57527, NULL, 'G3DSA:3.30.200.20:FF:001218', NULL, NULL, 'Serine/threonine-protein kinase Nek7', NULL, NULL, NULL, NULL, NULL, 4),
(57528, NULL, 'G3DSA:1.10.101.10:FF:000014', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase CwlH', NULL, NULL, NULL, NULL, NULL, 4),
(57529, NULL, 'G3DSA:1.10.10.60:FF:000682', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(57530, NULL, 'G3DSA:2.30.30.40:FF:000123', NULL, NULL, 'Ephexin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(57531, NULL, 'G3DSA:3.40.50.300:FF:008365', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(57532, NULL, 'G3DSA:3.60.10.10:FF:000143', NULL, NULL, 'PhosphoDiEsterase', NULL, NULL, NULL, NULL, NULL, 4),
(57533, NULL, 'G3DSA:3.40.50.1820:FF:001108', NULL, NULL, 'Putative alpha/beta hydrolase fold family protein', NULL, NULL, NULL, NULL, NULL, 4),
(57534, NULL, 'G3DSA:1.10.1070.11:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57535, NULL, 'G3DSA:3.80.10.10:FF:001266', NULL, NULL, 'Leucine-rich repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(57536, NULL, 'G3DSA:3.90.70.40:FF:000008', NULL, NULL, 'Machado-Joseph disease protein 1 (Ataxin-3), putative', NULL, NULL, NULL, NULL, NULL, 4),
(57537, NULL, 'G3DSA:3.20.20.80:FF:000560', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57538, NULL, 'G3DSA:1.10.1200.240:FF:000007', NULL, NULL, 'Ribosomal protein L19', NULL, NULL, NULL, NULL, NULL, 4),
(57539, NULL, 'G3DSA:1.10.418.10:FF:000215', NULL, NULL, 'Protein Hook homolog 3', NULL, NULL, NULL, NULL, NULL, 4),
(57540, NULL, 'G3DSA:3.90.76.10:FF:000035', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(57541, NULL, 'G3DSA:2.20.80.10:FF:000016', NULL, NULL, 'Vitellogenin', NULL, NULL, NULL, NULL, NULL, 4),
(57542, NULL, 'G3DSA:1.20.1250.20:FF:001989', NULL, NULL, 'Membrane protein, major facilitator superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(57543, NULL, 'G3DSA:1.25.40.10:FF:000433', NULL, NULL, 'mRNA, clone: RTFL01-04-G16', NULL, NULL, NULL, NULL, NULL, 4),
(57544, NULL, 'G3DSA:1.10.30.10:FF:000191', NULL, NULL, 'HMG', NULL, NULL, NULL, NULL, NULL, 4),
(57545, NULL, 'G3DSA:2.120.10.80:FF:000163', NULL, NULL, 'F-box domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(57546, NULL, 'G3DSA:3.20.180.20:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57547, NULL, 'G3DSA:3.30.450.20:FF:000101', NULL, NULL, 'Similar, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(57548, NULL, 'G3DSA:3.40.50.720:FF:000594', NULL, NULL, 'Short-chain oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(57549, NULL, 'G3DSA:3.30.1370.10:FF:000159', NULL, NULL, 'Putative eukaryotic LigT', NULL, NULL, NULL, NULL, NULL, 4),
(57550, NULL, 'G3DSA:3.10.580.20:FF:000008', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(57551, NULL, 'G3DSA:1.50.10.10:FF:000160', NULL, NULL, 'Glucan 14-alpha-glucosidase Cga', NULL, NULL, NULL, NULL, NULL, 4),
(57552, NULL, 'G3DSA:2.60.40.10:FF:001822', NULL, NULL, 'EBF transcription factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(57553, NULL, 'G3DSA:1.25.40.90:FF:000086', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(57554, NULL, 'G3DSA:3.30.530.20:FF:000102', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(57555, NULL, 'G3DSA:2.30.29.30:FF:000044', NULL, NULL, 'amyloid beta A4 precursor protein-binding family A member 1', NULL, NULL, NULL, NULL, NULL, 4),
(57556, NULL, 'G3DSA:1.10.10.10:FF:001914', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57557, NULL, 'G3DSA:1.20.1050.10:FF:000307', NULL, NULL, 'Glutathione s-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(57558, NULL, 'G3DSA:3.40.50.300:FF:001660', NULL, NULL, 'NF-X1 finger and helicase protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(57559, NULL, 'G3DSA:3.50.50.60:FF:001212', NULL, NULL, 'Dehydrogenase (Flavoprotein)', NULL, NULL, NULL, NULL, NULL, 4),
(57560, NULL, 'G3DSA:3.40.50.1820:FF:001636', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57561, NULL, 'G3DSA:1.25.10.10:FF:001589', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(57562, NULL, 'G3DSA:2.120.10.90:FF:000020', NULL, NULL, 'DNA topoisomerase 4 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(57563, NULL, 'G3DSA:3.30.160.60:FF:005217', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57564, NULL, 'G3DSA:1.10.472.10:FF:000324', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57565, NULL, 'G3DSA:1.10.1090.10:FF:000003', NULL, NULL, 'Ubiquinol-cytochrome c reductase complex subunit, putative', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(57566, NULL, 'G3DSA:2.40.50.90:FF:000094', NULL, NULL, 'GM17876', NULL, NULL, NULL, NULL, NULL, 4),
(57567, NULL, 'G3DSA:1.20.5.710:FF:000007', NULL, NULL, '50S ribosomal protein L7/L12', NULL, NULL, NULL, NULL, NULL, 4),
(57568, NULL, 'G3DSA:1.10.3290.10:FF:000007', NULL, NULL, 'Protein adenylyltransferase SoFic', NULL, NULL, NULL, NULL, NULL, 4),
(57569, NULL, 'G3DSA:1.25.40.60:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57570, NULL, 'G3DSA:1.20.58.1060:FF:000003', NULL, NULL, 'microtubule-actin cross-linking factor 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(57571, NULL, 'G3DSA:3.90.245.10:FF:000030', NULL, NULL, 'Nucleoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(57572, NULL, 'G3DSA:3.40.640.10:FF:000526', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57573, NULL, 'G3DSA:1.10.220.10:FF:000026', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(57574, NULL, 'G3DSA:3.40.50.300:FF:000732', NULL, NULL, 'Elongation factor like GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(57575, NULL, 'G3DSA:1.10.10.10:FF:000925', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(57576, NULL, 'G3DSA:1.10.510.10:FF:004112', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57577, NULL, 'G3DSA:1.25.40.540:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57578, NULL, 'G3DSA:3.40.50.300:FF:001221', NULL, NULL, 'Axonemal dynein heavy chain 8', NULL, NULL, NULL, NULL, NULL, 4),
(57579, NULL, 'G3DSA:1.20.1310.10:FF:000030', NULL, NULL, 'Cullin-4', NULL, NULL, NULL, NULL, NULL, 4),
(57580, NULL, 'G3DSA:2.60.40.10:FF:000889', NULL, NULL, 'fibrocystin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(57581, NULL, 'G3DSA:3.30.200.20:FF:002207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57582, NULL, 'G3DSA:3.40.50.720:FF:000650', NULL, NULL, 'NADH dehydrogenase 1 alpha subcomplex subunit 9', NULL, NULL, NULL, NULL, NULL, 4),
(57583, NULL, 'G3DSA:3.40.50.300:FF:005931', NULL, NULL, 'Spermatogenesis-associated protein 5-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(57584, NULL, 'G3DSA:3.30.450.20:FF:000045', NULL, NULL, 'Sensor histidine kinase DcuS', NULL, NULL, NULL, NULL, NULL, 4),
(57585, NULL, 'G3DSA:3.40.1260.20:FF:000005', NULL, NULL, 'Ribonuclease E/G-like protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(57586, NULL, 'G3DSA:2.30.140.10:FF:000028', NULL, NULL, 'Spermine/spermidine synthase-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(57587, NULL, 'G3DSA:3.40.1370.10:FF:000033', NULL, NULL, 'Plastid ribosomal protein L4', NULL, NULL, NULL, NULL, NULL, 4),
(57588, NULL, 'G3DSA:1.20.1080.10:FF:000135', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(57589, NULL, 'G3DSA:1.10.1170.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57590, NULL, 'G3DSA:3.40.50.12350:FF:000006', NULL, NULL, 'Eyes absent homolog 4', NULL, NULL, NULL, NULL, NULL, 4),
(57591, NULL, 'G3DSA:1.20.5.900:FF:000002', NULL, NULL, 'CD4', NULL, NULL, NULL, NULL, NULL, 4),
(57592, NULL, 'G3DSA:3.30.70.600:FF:000025', NULL, NULL, '30S ribosomal protein S10', NULL, NULL, NULL, NULL, NULL, 4),
(57593, NULL, 'G3DSA:1.10.630.10:FF:000372', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(57594, NULL, 'G3DSA:2.30.22.10:FF:000005', NULL, NULL, 'Co-chaperone GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(57595, NULL, 'G3DSA:2.30.30.40:FF:000595', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57596, NULL, 'G3DSA:3.40.50.300:FF:005403', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57597, NULL, 'G3DSA:3.30.1340.10:FF:000011', NULL, NULL, 'Phosphotransferase system, fructose-specific EI/HPr/EIIA components', NULL, NULL, NULL, NULL, NULL, 4),
(57598, NULL, 'G3DSA:3.30.160.60:FF:001474', NULL, NULL, 'zinc finger and BTB domain-containing protein 38', NULL, NULL, NULL, NULL, NULL, 4),
(57599, NULL, 'G3DSA:3.60.10.10:FF:000407', NULL, NULL, 'Inositol polyphosphate phosphatase-like protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(57600, NULL, 'G3DSA:3.10.290.10:FF:000051', NULL, NULL, '40S ribosomal protein S4, X isoform', NULL, NULL, NULL, NULL, NULL, 4),
(57601, NULL, 'G3DSA:1.25.40.10:FF:003715', NULL, NULL, 'Tetratricopeptide repeat protein 21B-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(57602, NULL, 'G3DSA:1.20.58.60:FF:000521', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57603, NULL, 'G3DSA:3.40.50.300:FF:005083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57604, NULL, 'G3DSA:2.160.20.70:FF:000007', NULL, NULL, 'tubulin-specific chaperone C', NULL, NULL, NULL, NULL, NULL, 4),
(57605, NULL, 'G3DSA:3.40.462.20:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57606, NULL, 'G3DSA:3.30.160.60:FF:004705', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57607, NULL, 'G3DSA:1.10.1450.10:FF:000019', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(57608, NULL, 'G3DSA:3.30.930.10:FF:000321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57609, NULL, 'G3DSA:1.20.1510.10:FF:000011', NULL, NULL, 'zinc transporter 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(57610, NULL, 'G3DSA:1.20.1250.20:FF:002006', NULL, NULL, 'Folate-like transporter DDB_G0272544', NULL, NULL, NULL, NULL, NULL, 4),
(57611, NULL, 'G3DSA:3.30.70.3490:FF:000027', NULL, NULL, 'Oxysterol-binding protein homolog C354.07c', NULL, NULL, NULL, NULL, NULL, 4),
(57612, NULL, 'G3DSA:2.160.20.50:FF:000001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57613, NULL, 'G3DSA:1.25.40.20:FF:000762', NULL, NULL, 'Zgc:113279', NULL, NULL, NULL, NULL, NULL, 4),
(57614, NULL, 'G3DSA:3.40.50.2000:FF:000691', NULL, NULL, 'Chitobiosyldiphosphodolichol beta-mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(57615, NULL, 'G3DSA:3.40.50.300:FF:005459', NULL, NULL, 'ABC ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(57616, NULL, 'G3DSA:3.80.10.10:FF:003683', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(57617, NULL, 'G3DSA:2.60.120.10:FF:000054', NULL, NULL, 'Global nitrogen regulator NtcA', NULL, NULL, NULL, NULL, NULL, 4),
(57618, NULL, 'G3DSA:1.20.1560.10:FF:000161', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(57619, NULL, 'G3DSA:3.30.2230.10:FF:000003', NULL, NULL, 'ubiquitin carboxyl-terminal hydrolase 15 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(57620, NULL, 'G3DSA:2.160.20.10:FF:000068', NULL, NULL, 'Polygalacturonase', NULL, NULL, NULL, NULL, NULL, 4),
(57621, NULL, 'G3DSA:2.30.29.30:FF:001033', NULL, NULL, 'cAMP-dependent protein kinase catalytic subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(57622, NULL, 'G3DSA:3.90.245.10:FF:000035', NULL, NULL, 'Uncharacterized protein C17G8.02', NULL, NULL, NULL, NULL, NULL, 4),
(57623, NULL, 'G3DSA:3.20.20.30:FF:000011', NULL, NULL, 'LLM class flavin-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(57624, NULL, 'G3DSA:3.60.15.10:FF:000278', NULL, NULL, 'AGAP000597-PA', NULL, NULL, NULL, NULL, NULL, 4),
(57625, NULL, 'G3DSA:3.30.40.10:FF:000242', NULL, NULL, 'E3 ubiquitin-protein ligase RNF8', NULL, NULL, NULL, NULL, NULL, 4),
(57626, NULL, 'G3DSA:3.40.50.150:FF:000754', NULL, NULL, 'Malonyl-[acyl-carrier protein] O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(57627, NULL, 'G3DSA:2.60.40.10:FF:005245', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57628, NULL, 'G3DSA:1.10.1040.50:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57629, NULL, 'G3DSA:3.30.2070.10:FF:000001', NULL, NULL, 'DMSO reductase', NULL, NULL, NULL, NULL, NULL, 4),
(57630, NULL, 'G3DSA:1.10.287.70:FF:000243', NULL, NULL, 'Voltage-gated potassium channel', NULL, NULL, NULL, NULL, NULL, 4),
(57631, NULL, 'G3DSA:2.30.29.30:FF:000049', NULL, NULL, 'pleckstrin homology domain-containing family A member 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(57632, NULL, 'G3DSA:2.30.30.100:FF:000163', NULL, NULL, 'Small nuclear ribonucleoprotein Sm D2', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(57633, NULL, 'G3DSA:1.10.600.10:FF:000016', NULL, NULL, 'decaprenyl-diphosphate synthase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(57634, NULL, 'G3DSA:3.40.50.720:FF:002100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57635, NULL, 'G3DSA:2.130.10.10:FF:003132', NULL, NULL, 'SEC31 homolog A, COPII coat complex component', NULL, NULL, NULL, NULL, NULL, 4),
(57636, NULL, 'G3DSA:3.20.20.140:FF:000250', NULL, NULL, '3'',5''-nucleoside bisphosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(57637, NULL, 'G3DSA:2.70.98.10:FF:000049', NULL, NULL, 'Glucose-6-phosphate 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(57638, NULL, 'G3DSA:2.130.10.10:FF:001682', NULL, NULL, 'U3 small nucleolar RNA-associated protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(57639, NULL, 'G3DSA:3.40.140.10:FF:000056', NULL, NULL, 'tRNA-specific adenosine deaminase TAD3 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(57640, NULL, 'G3DSA:3.40.50.300:FF:001188', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(57641, NULL, 'G3DSA:3.40.50.1240:FF:000069', NULL, NULL, 'Possible phosphoglycerate mutase gpm2', NULL, NULL, NULL, NULL, NULL, 4),
(57642, NULL, 'G3DSA:2.40.10.350:FF:000012', NULL, NULL, 'Cell shape-determining protein MreC', NULL, NULL, NULL, NULL, NULL, 4),
(57643, NULL, 'G3DSA:1.20.1250.20:FF:001606', NULL, NULL, 'MFS allantoate transporter, putative (AFU_orthologue AFUA_6G03720)', NULL, NULL, NULL, NULL, NULL, 4),
(57644, NULL, 'G3DSA:3.40.50.280:FF:000001', NULL, NULL, 'Methionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(57645, NULL, 'G3DSA:2.90.10.30:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57646, NULL, 'G3DSA:2.60.40.2150:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57647, NULL, 'G3DSA:3.30.300.30:FF:000066', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(57648, NULL, 'G3DSA:1.20.58.1080:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57649, NULL, 'G3DSA:2.60.40.150:FF:000566', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57650, NULL, 'G3DSA:2.130.10.10:FF:001507', NULL, NULL, 'Vacuolar protein sorting-associated protein 41 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(57651, NULL, 'G3DSA:1.10.340.30:FF:000075', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(57652, NULL, 'G3DSA:3.90.79.10:FF:000188', NULL, NULL, 'Isopentenyl-diphosphate Delta-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(57653, NULL, 'G3DSA:2.30.42.10:FF:000063', NULL, NULL, 'Peptidase, S41 family', NULL, NULL, NULL, NULL, NULL, 4),
(57654, NULL, 'G3DSA:3.90.660.20:FF:000008', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(57655, NULL, 'G3DSA:3.30.200.20:FF:002146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57656, NULL, 'G3DSA:3.30.1330.80:FF:000014', NULL, NULL, 'AT-hook motif nuclear-localized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57657, NULL, 'G3DSA:2.60.40.60:FF:000595', NULL, NULL, 'Protocadherin fat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(57658, NULL, 'G3DSA:1.10.10.570:FF:000004', NULL, NULL, 'Unplaced genomic scaffold supercont1.6, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(57659, NULL, 'G3DSA:3.40.190.290:FF:000051', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(57660, NULL, 'G3DSA:3.30.870.10:FF:000203', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(57661, NULL, 'G3DSA:3.30.450.20:FF:000540', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(57662, NULL, 'G3DSA:1.20.1280.290:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57663, NULL, 'G3DSA:3.40.50.10140:FF:000023', NULL, NULL, 'Sterile alpha and TIR motif-containing protein tir-1', NULL, NULL, NULL, NULL, NULL, 4),
(57664, NULL, 'G3DSA:3.40.50.10190:FF:000044', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(57665, NULL, 'G3DSA:3.30.760.10:FF:000021', NULL, NULL, 'Eukaryotic translation initiation factor 4E-3', NULL, NULL, NULL, NULL, NULL, 4),
(57666, NULL, 'G3DSA:3.20.20.80:FF:000121', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(57667, NULL, 'G3DSA:1.20.1250.20:FF:000680', NULL, NULL, 'Sugar efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(57668, NULL, 'G3DSA:3.50.7.10:FF:000019', NULL, NULL, 'McKusick-Kaufman syndrome', NULL, NULL, NULL, NULL, NULL, 4),
(57669, NULL, 'G3DSA:3.40.50.1220:FF:000063', NULL, NULL, '2-oxoglutarate decarboxylase/hydro-lyase/magnesium ion-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(57670, NULL, 'G3DSA:3.40.50.360:FF:000143', NULL, NULL, 'Uncharacterized protein MG342', NULL, NULL, NULL, NULL, NULL, 4),
(57671, NULL, 'G3DSA:1.25.40.10:FF:002850', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(57672, NULL, 'G3DSA:1.25.40.840:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57673, NULL, 'G3DSA:2.40.240.130:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(57674, NULL, 'G3DSA:2.130.10.10:FF:000698', NULL, NULL, 'Putative pre-mRNA splicing factor', NULL, NULL, NULL, NULL, NULL, 4),
(57675, NULL, 'G3DSA:2.60.40.60:FF:001084', NULL, NULL, 'Cadherin-related tumor suppressor-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(57676, NULL, 'G3DSA:3.40.1110.10:FF:000020', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(57677, NULL, 'G3DSA:3.40.50.300:FF:003514', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57678, NULL, 'G3DSA:3.30.70.260:FF:000108', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(57679, NULL, 'G3DSA:1.20.5.170:FF:000098', NULL, NULL, 'Basic leucine zipper 24', NULL, NULL, NULL, NULL, NULL, 4),
(57680, NULL, 'G3DSA:3.40.190.10:FF:000391', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(57681, NULL, 'G3DSA:3.40.630.10:FF:000228', NULL, NULL, 'Peptide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(57682, NULL, 'G3DSA:2.60.200.10:FF:000055', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(57683, NULL, 'G3DSA:1.20.1070.10:FF:001275', NULL, NULL, 'cDNA FLJ51399, highly similar to Cadherin EGF LAG seven-pass G-type receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(57684, NULL, 'G3DSA:3.30.50.10:FF:000012', NULL, NULL, 'Hepatocyte nuclear factor 4, alpha', NULL, NULL, NULL, NULL, NULL, 4),
(57685, NULL, 'G3DSA:3.40.50.300:FF:003458', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(57686, NULL, 'G3DSA:1.25.40.10:FF:005340', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g12300, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(57687, NULL, 'G3DSA:2.10.25.10:FF:001452', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57688, NULL, 'G3DSA:2.40.50.140:FF:000935', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57689, NULL, 'G3DSA:1.25.40.10:FF:005284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57690, NULL, 'G3DSA:2.40.70.10:FF:000088', NULL, NULL, 'Eukaryotic aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(57691, NULL, 'G3DSA:3.40.50.11500:FF:000021', NULL, NULL, 'DENN domain containing protein 2D', NULL, NULL, NULL, NULL, NULL, 4),
(57692, NULL, 'G3DSA:3.30.160.60:FF:000170', NULL, NULL, 'Zinc finger protein 711 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(57693, NULL, 'G3DSA:2.40.50.140:FF:001008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57694, NULL, 'G3DSA:3.20.20.60:FF:000082', NULL, NULL, 'GD14986', NULL, NULL, NULL, NULL, NULL, 4),
(57695, NULL, 'G3DSA:2.60.120.320:FF:000008', NULL, NULL, 'Thiamine pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(57696, NULL, 'G3DSA:3.10.20.90:FF:000916', NULL, NULL, 'Putative ubiquitin thioesterase otu1', NULL, NULL, NULL, NULL, NULL, 4),
(57697, NULL, 'G3DSA:3.30.457.50:FF:000002', NULL, NULL, 'Unplaced genomic scaffold supercont2.13, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(57698, NULL, 'G3DSA:3.30.300.30:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57699, NULL, 'G3DSA:4.10.280.10:FF:000035', NULL, NULL, 'Pancreas-specific transcription factor 1a', NULL, NULL, NULL, NULL, NULL, 4),
(57700, NULL, 'G3DSA:1.10.510.10:FF:000689', NULL, NULL, 'Tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(57701, NULL, 'G3DSA:3.40.50.1000:FF:000525', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57702, NULL, 'G3DSA:2.60.40.1120:FF:000063', NULL, NULL, 'Chitinase, GH18 family', NULL, NULL, NULL, NULL, NULL, 4),
(57703, NULL, 'G3DSA:1.25.40.10:FF:005104', NULL, NULL, 'DnaJ domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(57704, NULL, 'G3DSA:3.40.30.10:FF:001269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57705, NULL, 'G3DSA:2.60.40.150:FF:000510', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(57706, NULL, 'G3DSA:2.60.40.60:FF:000651', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57707, NULL, 'G3DSA:3.40.50.300:FF:003166', NULL, NULL, 'Sulfate adenylyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(57708, NULL, 'G3DSA:3.30.200.20:FF:000881', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(57709, NULL, 'G3DSA:3.30.160.60:FF:003688', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57710, NULL, 'G3DSA:1.10.150.80:FF:000035', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(57711, NULL, 'G3DSA:2.60.20.10:FF:000011', NULL, NULL, 'very large A-kinase anchor protein', NULL, NULL, NULL, NULL, NULL, 4),
(57712, NULL, 'G3DSA:1.25.10.10:FF:000280', NULL, NULL, 'serine/threonine-protein kinase 36 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(57713, NULL, 'G3DSA:3.10.129.10:FF:000289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57714, NULL, 'G3DSA:2.20.25.30:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57715, NULL, 'G3DSA:3.90.650.10:FF:000033', NULL, NULL, 'Trifunctional purine biosynthetic protein adenosine-3', NULL, NULL, NULL, NULL, NULL, 4),
(57716, NULL, 'G3DSA:2.130.10.10:FF:003508', NULL, NULL, 'E3 ubiquitin-protein ligase PEP5', NULL, NULL, NULL, NULL, NULL, 4),
(57717, NULL, 'G3DSA:3.30.70.330:FF:002338', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57718, NULL, 'G3DSA:1.10.510.10:FF:000745', NULL, NULL, 'Serine/threonine-protein kinase BUD32', NULL, NULL, NULL, NULL, NULL, 4),
(57719, NULL, 'G3DSA:1.10.3720.10:FF:000030', NULL, NULL, 'Maltose ABC transporter permease MalF', NULL, NULL, NULL, NULL, NULL, 4),
(57720, NULL, 'G3DSA:3.40.50.1980:FF:000094', NULL, NULL, 'Histidine biosynthesis trifunctional protein', NULL, NULL, NULL, NULL, NULL, 4),
(57721, NULL, 'G3DSA:3.30.1490.80:FF:000031', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(57722, NULL, 'G3DSA:1.10.220.160:FF:000012', NULL, NULL, 'SET domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(57723, NULL, 'G3DSA:2.60.120.1000:FF:000010', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(57724, NULL, 'G3DSA:3.40.50.300:FF:003661', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(57725, NULL, 'G3DSA:3.50.50.60:FF:000279', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(57726, NULL, 'G3DSA:1.10.510.10:FF:003095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57727, NULL, 'G3DSA:3.30.200.20:FF:000729', NULL, NULL, 'Serine/threonine-protein kinase Nek4', NULL, NULL, NULL, NULL, NULL, 4),
(57728, NULL, 'G3DSA:3.90.226.10:FF:000143', NULL, NULL, 'Acetyl-CoA carboxylase/pyruvate carboxylase fusion protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(57729, NULL, 'G3DSA:2.10.230.10:FF:000017', NULL, NULL, 'DnaJ heat shock protein family (Hsp40) member A3', NULL, NULL, NULL, NULL, NULL, 4),
(57730, NULL, 'G3DSA:3.90.228.20:FF:000010', NULL, NULL, 'Phosphoenolypyruvate CarboxyKinase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(57731, NULL, 'G3DSA:3.40.350.10:FF:000010', NULL, NULL, 'Probable Xaa-Pro aminopeptidase P', NULL, NULL, NULL, NULL, NULL, 4),
(57732, NULL, 'G3DSA:3.30.160.60:FF:000546', NULL, NULL, 'Zinc finger protein 333', NULL, NULL, NULL, NULL, NULL, 4),
(57733, NULL, 'G3DSA:3.30.70.330:FF:002490', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57734, NULL, 'G3DSA:3.40.50.2000:FF:000252', NULL, NULL, 'Trehalose-6-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(57735, NULL, 'G3DSA:1.10.860.10:FF:000029', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(57736, NULL, 'G3DSA:2.60.120.590:FF:000044', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(57737, NULL, 'G3DSA:3.90.110.10:FF:000003', NULL, NULL, 'L-lactate dehydrogenase A chain', NULL, NULL, NULL, NULL, NULL, 4),
(57738, NULL, 'G3DSA:3.40.50.150:FF:000226', NULL, NULL, 'probable methyltransferase-like protein 15 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(57739, NULL, 'G3DSA:2.70.130.10:FF:000030', NULL, NULL, 'Endoplasmic reticulum lectin 1', NULL, NULL, NULL, NULL, NULL, 4),
(57740, NULL, 'G3DSA:1.10.555.10:FF:000039', NULL, NULL, 'N-chimaerin isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(57741, NULL, 'G3DSA:1.10.472.10:FF:000296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57742, NULL, 'G3DSA:3.40.50.2300:FF:000191', NULL, NULL, 'D-allose-binding periplasmic protein (ALBP)', NULL, NULL, NULL, NULL, NULL, 4),
(57743, NULL, 'G3DSA:3.30.740.10:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57744, NULL, 'G3DSA:3.40.50.300:FF:007876', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57745, NULL, 'G3DSA:2.70.70.10:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57746, NULL, 'G3DSA:1.10.555.10:FF:000011', NULL, NULL, 'Rho GTPase-activating protein 39', NULL, NULL, NULL, NULL, NULL, 4),
(57747, NULL, 'G3DSA:3.90.1410.10:FF:000065', NULL, NULL, 'N-lysine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(57748, NULL, 'G3DSA:1.25.40.20:FF:001690', NULL, NULL, 'AGAP003151-PA', NULL, NULL, NULL, NULL, NULL, 4),
(57749, NULL, 'G3DSA:3.30.40.10:FF:002164', NULL, NULL, 'Structure-specific endonuclease subunit SLX1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(57750, NULL, 'G3DSA:3.10.20.340:FF:000008', NULL, NULL, 'Arginine biosynthesis bifunctional protein ArgJ 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(57751, NULL, 'G3DSA:3.40.50.720:FF:000914', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(57752, NULL, 'G3DSA:3.40.190.10:FF:000328', NULL, NULL, 'Glycerol-3-phosphate ABC transporter glycerol-3-phosphate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(57753, NULL, 'G3DSA:3.40.50.150:FF:000198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57754, NULL, 'G3DSA:3.30.200.20:FF:000206', NULL, NULL, 'Serine/threonine-protein kinase Ssp1', NULL, NULL, NULL, NULL, NULL, 4),
(57755, NULL, 'G3DSA:1.10.238.20:FF:000002', NULL, NULL, 'AGAP000641-PA', NULL, NULL, NULL, NULL, NULL, 4),
(57756, NULL, 'G3DSA:3.50.50.60:FF:000251', NULL, NULL, 'Ferrodoxin reductase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(57757, NULL, 'G3DSA:3.40.190.170:FF:000009', NULL, NULL, 'TRAP transporter substrate-binding protein DctP', NULL, NULL, NULL, NULL, NULL, 4),
(57758, NULL, 'G3DSA:2.60.120.920:FF:000008', NULL, NULL, 'Set1/Ash2 histone methyltransferase complex subunit ASH2', NULL, NULL, NULL, NULL, NULL, 4),
(57759, NULL, 'G3DSA:3.90.1280.20:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57760, NULL, 'G3DSA:2.60.40.10:FF:005240', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57761, NULL, 'G3DSA:3.40.1110.10:FF:000104', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(57762, NULL, 'G3DSA:3.30.160.40:FF:000012', NULL, NULL, 'Porphobilinogen deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(57763, NULL, 'G3DSA:1.20.1730.10:FF:000045', NULL, NULL, 'Solute carrier family 5 (sodium/sugar cotransporter), member 9', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(57764, NULL, 'G3DSA:3.30.450.40:FF:000107', NULL, NULL, 'Sensor histidine kinase KdpD', NULL, NULL, NULL, NULL, NULL, 4),
(57765, NULL, 'G3DSA:1.10.3470.10:FF:000044', NULL, NULL, 'ABC-type cobalamin uptake system permease component BtuC', NULL, NULL, NULL, NULL, NULL, 4),
(57766, NULL, 'G3DSA:1.25.40.10:FF:001922', NULL, NULL, 'Os01g0815900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(57767, NULL, 'G3DSA:1.10.1670.10:FF:000025', NULL, NULL, 'Ogg1p', NULL, NULL, NULL, NULL, NULL, 4),
(57768, NULL, 'G3DSA:1.20.1070.10:FF:001359', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57769, NULL, 'G3DSA:2.60.120.200:FF:000118', NULL, NULL, 'Growth arrest specific 6', NULL, NULL, NULL, NULL, NULL, 4),
(57770, NULL, 'G3DSA:2.120.10.80:FF:000427', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57771, NULL, 'G3DSA:3.30.60.220:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57772, NULL, 'G3DSA:1.20.140.10:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57773, NULL, 'G3DSA:1.25.10.10:FF:000841', NULL, NULL, 'Maestro heat like repeat family member 2B', NULL, NULL, NULL, NULL, NULL, 4),
(57774, NULL, 'G3DSA:1.20.5.1300:FF:000002', NULL, NULL, 'Histidinol dehydrogenase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(57775, NULL, 'G3DSA:3.30.360.10:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57776, NULL, 'G3DSA:2.130.10.10:FF:000693', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(57777, NULL, 'G3DSA:2.60.120.230:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57778, NULL, 'G3DSA:2.40.160.120:FF:000017', NULL, NULL, 'Oxysterol-binding protein homolog C2F12.05c', NULL, NULL, NULL, NULL, NULL, 4),
(57779, NULL, 'G3DSA:4.10.60.10:FF:000129', NULL, NULL, 'Phragmoplastin interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(57780, NULL, 'G3DSA:3.40.50.11610:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57781, NULL, 'G3DSA:1.20.1070.10:FF:002107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57782, NULL, 'G3DSA:3.30.1120.10:FF:000028', NULL, NULL, 'Choline-sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(57783, NULL, 'G3DSA:2.60.40.1730:FF:000004', NULL, NULL, 'Leukotriene A(4) hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(57784, NULL, 'G3DSA:2.10.25.10:FF:000440', NULL, NULL, 'Laminin subunit beta 3', NULL, NULL, NULL, NULL, NULL, 4),
(57785, NULL, 'G3DSA:3.40.30.10:FF:001241', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(57786, NULL, 'G3DSA:3.90.1480.20:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57787, NULL, 'G3DSA:3.30.1360.210:FF:000005', NULL, NULL, '60S ribosomal protein L22', NULL, NULL, NULL, NULL, NULL, 4),
(57788, NULL, 'G3DSA:2.60.120.200:FF:000793', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(57789, NULL, 'G3DSA:3.40.430.10:FF:000011', NULL, NULL, 'Rib7p', NULL, NULL, NULL, NULL, NULL, 4),
(57790, NULL, 'G3DSA:3.30.160.60:FF:005633', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57791, NULL, 'G3DSA:3.30.559.10:FF:000148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57792, NULL, 'G3DSA:3.30.700.10:FF:000017', NULL, NULL, 'MSHA minor pilin protein MshC', NULL, NULL, NULL, NULL, NULL, 4),
(57793, NULL, 'G3DSA:3.30.40.10:FF:000186', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(57794, NULL, 'G3DSA:1.20.1250.20:FF:000117', NULL, NULL, 'MFS hexose transporter', NULL, NULL, NULL, NULL, NULL, 4),
(57795, NULL, 'G3DSA:3.80.10.10:FF:003267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57796, NULL, 'G3DSA:3.40.50.10110:FF:000003', NULL, NULL, 'DNA polymerase III holoenzyme chi subunit', NULL, NULL, NULL, NULL, NULL, 4),
(57797, NULL, 'G3DSA:1.10.287.770:FF:000020', NULL, NULL, 'Blast:Pickpocket protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(57798, NULL, 'G3DSA:1.10.532.10:FF:000003', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(57799, NULL, 'G3DSA:1.25.40.20:FF:000346', NULL, NULL, 'Palmitoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(57800, NULL, 'G3DSA:2.40.40.20:FF:000033', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(57801, NULL, 'G3DSA:3.30.2160.10:FF:000059', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(57802, NULL, 'G3DSA:1.10.510.10:FF:004404', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57803, NULL, 'G3DSA:2.60.40.10:FF:002367', NULL, NULL, 'papilin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(57804, NULL, 'G3DSA:1.10.520.10:FF:000010', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(57805, NULL, 'G3DSA:1.20.58.390:FF:000017', NULL, NULL, 'Neuronal acetylcholine receptor subunit alpha-3', NULL, NULL, NULL, NULL, NULL, 4),
(57806, NULL, 'G3DSA:3.30.750.24:FF:000146', NULL, NULL, 'Chloride anion exchanger', NULL, NULL, NULL, NULL, NULL, 4),
(57807, NULL, 'G3DSA:3.30.2410.10:FF:000045', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(57808, NULL, 'G3DSA:1.10.287.810:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57809, NULL, 'G3DSA:2.60.40.10:FF:001878', NULL, NULL, 'Immunoglobulin heavy variable 1-4', NULL, NULL, NULL, NULL, NULL, 4),
(57810, NULL, 'G3DSA:1.25.10.10:FF:000605', NULL, NULL, 'Armadillo repeat containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(57811, NULL, 'G3DSA:1.20.140.140:FF:000002', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(57812, NULL, 'G3DSA:3.10.129.10:FF:000261', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57813, NULL, 'G3DSA:1.10.40.30:FF:000023', NULL, NULL, 'Argininosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(57814, NULL, 'G3DSA:2.60.40.60:FF:001140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57815, NULL, 'G3DSA:1.20.1600.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57816, NULL, 'G3DSA:3.40.50.720:FF:000122', NULL, NULL, 'Dehydrogenase/reductase SDR family member 7B', NULL, NULL, NULL, NULL, NULL, 4),
(57817, NULL, 'G3DSA:2.40.30.10:FF:000439', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57818, NULL, 'G3DSA:3.70.10.10:FF:000002', NULL, NULL, 'Beta sliding clamp', NULL, NULL, NULL, NULL, NULL, 4),
(57819, NULL, 'G3DSA:1.10.287.110:FF:000137', NULL, NULL, 'DnaJ homolog subfamily B member 1', NULL, NULL, NULL, NULL, NULL, 4),
(57820, NULL, 'G3DSA:2.130.10.10:FF:004060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57821, NULL, 'G3DSA:3.30.428.10:FF:000064', NULL, NULL, 'Wpkci', NULL, NULL, NULL, NULL, NULL, 4),
(57822, NULL, 'G3DSA:1.10.510.10:FF:000661', NULL, NULL, 'Receptor-interacting serine/threonine-protein kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(57823, NULL, 'G3DSA:2.30.30.140:FF:000040', NULL, NULL, 'PHD finger protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(57824, NULL, 'G3DSA:3.30.40.10:FF:002220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57825, NULL, 'G3DSA:1.10.10.10:FF:000189', NULL, NULL, 'HTH-type transcriptional regulator MntR', NULL, NULL, NULL, NULL, NULL, 4),
(57826, NULL, 'G3DSA:3.30.70.270:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57827, NULL, 'G3DSA:1.20.1250.20:FF:000264', NULL, NULL, 'vesicular glutamate transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(57828, NULL, 'G3DSA:2.130.10.10:FF:001710', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', NULL, NULL, NULL, NULL, NULL, 4),
(57829, NULL, 'G3DSA:2.130.10.10:FF:003424', NULL, NULL, 'Intraflagellar transport protein 140-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(57830, NULL, 'G3DSA:3.40.50.300:FF:000108', NULL, NULL, 'ATP-dependent RNA helicase RhlE', NULL, NULL, NULL, NULL, NULL, 4),
(57831, NULL, 'G3DSA:1.10.238.10:FF:001045', NULL, NULL, 'Calmodulin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(57832, NULL, 'G3DSA:1.10.510.10:FF:004399', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(57833, NULL, 'G3DSA:3.10.129.10:FF:000109', NULL, NULL, 'Acyl dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(57834, NULL, 'G3DSA:1.25.40.10:FF:000809', NULL, NULL, 'Os12g0289800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(57835, NULL, 'G3DSA:2.40.110.10:FF:000035', NULL, NULL, 'Putative acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(57836, NULL, 'G3DSA:3.30.200.20:FF:000353', NULL, NULL, 'Sterile20-like kinase, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(57837, NULL, 'G3DSA:3.40.1380.20:FF:000008', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(57838, NULL, 'G3DSA:1.25.40.10:FF:001361', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(57839, NULL, 'G3DSA:1.10.238.10:FF:000645', NULL, NULL, 'Respiratory burst oxidase-like protein F isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(57840, NULL, 'G3DSA:3.40.50.300:FF:005111', NULL, NULL, 'Elongator complex protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(57841, NULL, 'G3DSA:1.25.40.10:FF:003687', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57842, NULL, 'G3DSA:3.90.1030.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57843, NULL, 'G3DSA:1.25.40.10:FF:000961', NULL, NULL, 'Protein TONSOKU', NULL, NULL, NULL, NULL, NULL, 4),
(57844, NULL, 'G3DSA:3.30.70.330:FF:002866', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57845, NULL, 'G3DSA:3.30.70.240:FF:000046', NULL, NULL, 'Translation factor GUF1 homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(57846, NULL, 'G3DSA:3.40.50.10710:FF:000003', NULL, NULL, 'Ribonuclease J', NULL, NULL, NULL, NULL, NULL, 4),
(57847, NULL, 'G3DSA:1.10.150.530:FF:000011', NULL, NULL, 'Probable dual-specificity RNA methyltransferase RlmN', NULL, NULL, NULL, NULL, NULL, 4),
(57848, NULL, 'G3DSA:1.10.10.10:FF:000897', NULL, NULL, 'Transcriptional regulator, BadM/Rrf2 family', NULL, NULL, NULL, NULL, NULL, 4),
(57849, NULL, 'G3DSA:3.10.20.90:FF:000883', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57850, NULL, 'G3DSA:1.10.3170.10:FF:000004', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(57851, NULL, 'G3DSA:2.60.40.10:FF:003328', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57852, NULL, 'G3DSA:3.90.70.10:FF:000645', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57853, NULL, 'G3DSA:3.30.40.10:FF:000039', NULL, NULL, 'PHD finger protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(57854, NULL, 'G3DSA:1.10.20.10:FF:000246', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57855, NULL, 'G3DSA:3.30.1520.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57856, NULL, 'G3DSA:2.60.40.10:FF:003300', NULL, NULL, 'DLEC1, cilia and flagella associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(57857, NULL, 'G3DSA:1.10.150.120:FF:000006', NULL, NULL, 'Aldehyde oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(57858, NULL, 'G3DSA:1.25.10.10:FF:001241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57859, NULL, 'G3DSA:3.90.550.50:FF:000222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57860, NULL, 'G3DSA:3.40.50.620:FF:000238', NULL, NULL, 'Phosphopantetheine adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(57861, NULL, 'G3DSA:2.30.30.40:FF:000651', NULL, NULL, 'Tyrosine-protein kinase PR2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(57862, NULL, 'G3DSA:1.20.5.170:FF:000154', NULL, NULL, 'Cgmp-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(57863, NULL, 'G3DSA:2.60.34.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57864, NULL, 'G3DSA:1.10.3120.10:FF:000001', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(57865, NULL, 'G3DSA:3.30.160.60:FF:000815', NULL, NULL, 'zinc finger protein 621', NULL, NULL, NULL, NULL, NULL, 4),
(57866, NULL, 'G3DSA:2.130.10.10:FF:004621', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(57867, NULL, 'G3DSA:2.130.10.10:FF:004436', NULL, NULL, 'Met proto-oncogene', NULL, NULL, NULL, NULL, NULL, 4),
(57868, NULL, 'G3DSA:1.10.3090.10:FF:000003', NULL, NULL, 'Poly(A) polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(57869, NULL, 'G3DSA:3.40.50.300:FF:004386', NULL, NULL, 'IcmB', NULL, NULL, NULL, NULL, NULL, 4),
(57870, NULL, 'G3DSA:2.130.10.10:FF:005133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57871, NULL, 'G3DSA:2.60.40.10:FF:004604', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57872, NULL, 'G3DSA:3.80.10.10:FF:003498', NULL, NULL, 'AGAP006408-PA', NULL, NULL, NULL, NULL, NULL, 4),
(57873, NULL, 'G3DSA:3.40.50.2000:FF:000724', NULL, NULL, 'Similar to UDP-N-acetylglucosamine 2-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(57874, NULL, 'G3DSA:3.60.10.10:FF:000290', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(57875, NULL, 'G3DSA:3.40.50.1110:FF:000030', NULL, NULL, 'Transmembrane acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(57876, NULL, 'G3DSA:3.90.180.10:FF:000036', NULL, NULL, 'Zinc-dependent alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(57877, NULL, 'G3DSA:1.25.40.10:FF:004356', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(57878, NULL, 'G3DSA:2.60.40.10:FF:004548', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57879, NULL, 'G3DSA:1.20.1250.20:FF:000909', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57880, NULL, 'G3DSA:2.120.10.30:FF:000553', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57881, NULL, 'G3DSA:1.25.40.10:FF:004412', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57882, NULL, 'G3DSA:1.10.510.10:FF:002370', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57883, NULL, 'G3DSA:1.10.630.10:FF:000400', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57884, NULL, 'G3DSA:2.40.50.140:FF:000463', NULL, NULL, 'DNA repair protein RecO', NULL, NULL, NULL, NULL, NULL, 4),
(57885, NULL, 'G3DSA:3.90.550.10:FF:000469', NULL, NULL, 'N-acetylglucosaminyltransferase related protein (NodC-like)', NULL, NULL, NULL, NULL, NULL, 4),
(57886, NULL, 'G3DSA:1.10.357.10:FF:000045', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(57887, NULL, 'G3DSA:1.10.10.10:FF:002078', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(57888, NULL, 'G3DSA:3.30.60.90:FF:000019', NULL, NULL, 'Protein KRI1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(57889, NULL, 'G3DSA:2.40.50.700:FF:000002', NULL, NULL, 'Cell wall biogenesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(57890, NULL, 'G3DSA:1.20.120.1750:FF:000100', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(57891, NULL, 'G3DSA:3.40.50.1820:FF:000147', NULL, NULL, 'uncharacterized protein LOC108093882 isoform X9', NULL, NULL, NULL, NULL, NULL, 4),
(57892, NULL, 'G3DSA:3.30.710.10:FF:000490', NULL, NULL, 'Protein CBG09885', NULL, NULL, NULL, NULL, NULL, 4),
(57893, NULL, 'G3DSA:3.40.630.40:FF:000012', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(57894, NULL, 'G3DSA:1.50.10.10:FF:000013', NULL, NULL, 'Non-lysosomal glucosylceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(57895, NULL, 'G3DSA:3.90.550.10:FF:000525', NULL, NULL, 'Glycoside transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(57896, NULL, 'G3DSA:1.50.10.160:FF:000002', NULL, NULL, 'cis-abienol synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(57897, NULL, 'G3DSA:3.90.930.12:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57898, NULL, 'G3DSA:1.25.10.10:FF:003242', NULL, NULL, 'Formin-J', NULL, NULL, NULL, NULL, NULL, 4),
(57899, NULL, 'G3DSA:1.25.40.20:FF:001127', NULL, NULL, 'Kinase, NEK-frag', NULL, NULL, NULL, NULL, NULL, 4),
(57900, NULL, 'G3DSA:3.60.10.10:FF:000379', NULL, NULL, 'Angel homolog 1 (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(57901, NULL, 'G3DSA:3.30.70.330:FF:000073', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein L like', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(57902, NULL, 'G3DSA:1.25.40.10:FF:000141', NULL, NULL, 'Mitochondrial import receptor subunit TOM70', NULL, NULL, NULL, NULL, NULL, 4),
(57903, NULL, 'G3DSA:4.10.860.10:FF:000006', NULL, NULL, 'calcyclin-binding protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(57904, NULL, 'G3DSA:2.60.40.10:FF:000861', NULL, NULL, 'interleukin-13 receptor subunit alpha-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(57905, NULL, 'G3DSA:3.90.70.10:FF:000084', NULL, NULL, 'inactive ubiquitin carboxyl-terminal hydrolase 50', NULL, NULL, NULL, NULL, NULL, 4),
(57906, NULL, 'G3DSA:3.40.50.300:FF:008129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57907, NULL, 'G3DSA:3.30.460.10:FF:000161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57908, NULL, 'G3DSA:3.30.1370.50:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57909, NULL, 'G3DSA:1.20.1560.10:FF:000722', NULL, NULL, 'Putative ABC transporter ATP-binding protein MG014', NULL, NULL, NULL, NULL, NULL, 4),
(57910, NULL, 'G3DSA:1.10.3680.10:FF:000003', NULL, NULL, 'Tellurium resistance protein TerB', NULL, NULL, NULL, NULL, NULL, 4),
(57911, NULL, 'G3DSA:2.130.10.10:FF:005077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57912, NULL, 'G3DSA:1.10.10.60:FF:000974', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57913, NULL, 'G3DSA:3.40.50.2300:FF:000224', NULL, NULL, 'Asc operon transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(57914, NULL, 'G3DSA:3.40.850.10:FF:000267', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(57915, NULL, 'G3DSA:3.40.50.10810:FF:000207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57916, NULL, 'G3DSA:3.40.50.12760:FF:000011', NULL, NULL, 'Protein CBG15196', NULL, NULL, NULL, NULL, NULL, 4),
(57917, NULL, 'G3DSA:2.10.25.10:FF:000524', NULL, NULL, 'Neurogenic locus notch protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(57918, NULL, 'G3DSA:3.20.20.140:FF:000014', NULL, NULL, '5-methylthioadenosine/S-adenosylhomocysteine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(57919, NULL, 'G3DSA:3.40.390.10:FF:000187', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57920, NULL, 'G3DSA:3.40.50.150:FF:001502', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57921, NULL, 'G3DSA:2.130.10.10:FF:003896', NULL, NULL, 'Predicted Ca-binding lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(57922, NULL, 'G3DSA:3.40.50.300:FF:006095', NULL, NULL, 'ATP-binding cassette transporter, subfamily B, member 2, group MDR/PGP protein PpABCB2', NULL, NULL, NULL, NULL, NULL, 4),
(57923, NULL, 'G3DSA:2.60.40.10:FF:002991', NULL, NULL, 'Vesicle-associated protein 1-1', NULL, NULL, NULL, NULL, NULL, 4),
(57924, NULL, 'G3DSA:3.30.230.10:FF:000352', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57925, NULL, 'G3DSA:3.10.180.10:FF:000037', NULL, NULL, 'Catechol 2,3-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(57926, NULL, 'G3DSA:4.10.1080.10:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57927, NULL, 'G3DSA:2.20.25.350:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57928, NULL, 'G3DSA:1.25.40.10:FF:002703', NULL, NULL, 'Bardet-Biedl syndrome 4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(57929, NULL, 'G3DSA:3.30.2020.30:FF:000004', NULL, NULL, 'Nucleotide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(57930, NULL, 'G3DSA:3.30.930.10:FF:000118', NULL, NULL, 'Asparagine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(57931, NULL, 'G3DSA:1.20.200.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57932, NULL, 'G3DSA:3.40.630.30:FF:000442', NULL, NULL, 'Polyamine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(57933, NULL, 'G3DSA:3.40.50.1000:FF:000289', NULL, NULL, 'Haloacid_dehalogenase-like_hydrolase/HAD-hyrolase-like', NULL, NULL, NULL, NULL, NULL, 4),
(57934, NULL, 'G3DSA:3.40.50.1820:FF:001783', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(57935, NULL, 'G3DSA:3.30.70.3040:FF:000010', NULL, NULL, 'Cell division protein FtsX', NULL, NULL, NULL, NULL, NULL, 4),
(57936, NULL, 'G3DSA:3.80.10.10:FF:001789', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57937, NULL, 'G3DSA:3.40.50.620:FF:000002', NULL, NULL, 'Sulfate adenylyltransferase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(57938, NULL, 'G3DSA:3.40.50.620:FF:000474', NULL, NULL, 'Putative membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(57939, NULL, 'G3DSA:3.40.50.720:FF:000206', NULL, NULL, 'Adenylyltransferase and sulfurtransferase MOCS3', NULL, NULL, NULL, NULL, NULL, 4),
(57940, NULL, 'G3DSA:4.10.1000.10:FF:000091', NULL, NULL, 'GH07148p', NULL, NULL, NULL, NULL, NULL, 4),
(57941, NULL, 'G3DSA:1.10.437.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57942, NULL, 'G3DSA:3.90.226.10:FF:000199', NULL, NULL, 'Nisin-resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(57943, NULL, 'G3DSA:3.20.20.80:FF:000357', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(57944, NULL, 'G3DSA:1.10.10.10:FF:001622', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(57945, NULL, 'G3DSA:1.20.1720.10:FF:000016', NULL, NULL, 'EmrB/QacA family drug resistance transporter', NULL, NULL, NULL, NULL, NULL, 4),
(57946, NULL, 'G3DSA:3.30.160.60:FF:006330', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57947, NULL, 'G3DSA:3.40.50.12780:FF:000017', NULL, NULL, 'Crotonobetaine/carnitine--CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(57948, NULL, 'G3DSA:3.40.630.30:FF:000386', NULL, NULL, 'Transcriptional regulator, MarR family', NULL, NULL, NULL, NULL, NULL, 4),
(57949, NULL, 'G3DSA:2.40.10.10:FF:000348', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57950, NULL, 'G3DSA:3.30.1520.10:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57951, NULL, 'G3DSA:2.30.170.20:FF:000005', NULL, NULL, '60S ribosomal protein L24, putative', NULL, NULL, NULL, NULL, NULL, 4),
(57952, NULL, 'G3DSA:2.60.40.60:FF:000920', NULL, NULL, 'AGAP011529-PA', NULL, NULL, NULL, NULL, NULL, 4),
(57953, NULL, 'G3DSA:1.20.1270.10:FF:000003', NULL, NULL, 'heat shock cognate 71 kDa protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(57954, NULL, 'G3DSA:3.90.25.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57955, NULL, 'G3DSA:1.10.8.60:FF:000175', NULL, NULL, 'Msp1p', NULL, NULL, NULL, NULL, NULL, 4),
(57956, NULL, 'G3DSA:1.10.238.10:FF:000792', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(57957, NULL, 'G3DSA:3.30.160.60:FF:001327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57958, NULL, 'G3DSA:3.40.1310.10:FF:000001', NULL, NULL, 'Replication protein E1', NULL, NULL, NULL, NULL, NULL, 4),
(57959, NULL, 'G3DSA:3.30.160.60:FF:004672', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57960, NULL, 'G3DSA:1.25.40.200:FF:000002', NULL, NULL, 'Ran GTPase activating protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(57961, NULL, 'G3DSA:3.40.50.1000:FF:000609', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57962, NULL, 'G3DSA:3.30.470.20:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57963, NULL, 'G3DSA:3.20.20.140:FF:000486', NULL, NULL, 'Os07g0157900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(57964, NULL, 'G3DSA:3.40.50.2300:FF:000696', NULL, NULL, 'Glutamate receptor IIB', NULL, NULL, NULL, NULL, NULL, 4),
(57965, NULL, 'G3DSA:3.30.70.2120:FF:000004', NULL, NULL, 'Flagellin', NULL, NULL, NULL, NULL, NULL, 4),
(57966, NULL, 'G3DSA:1.20.1250.20:FF:001697', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57967, NULL, 'G3DSA:3.40.50.300:FF:004442', NULL, NULL, 'Ras-related protein Rab-11A', NULL, NULL, NULL, NULL, NULL, 4),
(57968, NULL, 'G3DSA:3.80.10.10:FF:000805', NULL, NULL, 'Blast:F-box/LRR-repeat protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(57969, NULL, 'G3DSA:3.40.250.10:FF:000070', NULL, NULL, 'Sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(57970, NULL, 'G3DSA:3.40.630.10:FF:000380', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57971, NULL, 'G3DSA:3.30.40.10:FF:001675', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(57972, NULL, 'G3DSA:2.60.120.200:FF:000321', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(57973, NULL, 'G3DSA:3.30.70.330:FF:001377', NULL, NULL, 'Os01g0945800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(57974, NULL, 'G3DSA:3.30.460.10:FF:000009', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(57975, NULL, 'G3DSA:3.30.2350.10:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57976, NULL, 'G3DSA:1.20.1250.20:FF:000533', NULL, NULL, 'Siderophore iron transporter mirC', NULL, NULL, NULL, NULL, NULL, 4),
(57977, NULL, 'G3DSA:1.10.287.70:FF:000804', NULL, NULL, 'Voltage-gated Ca2+ channel, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(57978, NULL, 'G3DSA:1.10.1300.10:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57979, NULL, 'G3DSA:3.50.50.60:FF:000756', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(57980, NULL, 'G3DSA:3.40.1090.10:FF:000079', NULL, NULL, 'Cytosolic phospholipase A2 gamma', NULL, NULL, NULL, NULL, NULL, 4),
(57981, NULL, 'G3DSA:1.10.1200.10:FF:000035', NULL, NULL, 'Polyketide synthetase mbtD', NULL, NULL, NULL, NULL, NULL, 4),
(57982, NULL, 'G3DSA:3.40.50.410:FF:000001', NULL, NULL, 'Collagen, type XII, alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(57983, NULL, 'G3DSA:1.10.472.10:FF:000616', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(57984, NULL, 'G3DSA:2.40.50.1060:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57985, NULL, 'G3DSA:3.60.20.10:FF:000205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57986, NULL, 'G3DSA:3.30.70.100:FF:000201', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57987, NULL, 'G3DSA:2.130.10.10:FF:000985', NULL, NULL, 'Ribosome biogenesis protein YTM1', NULL, NULL, NULL, NULL, NULL, 4),
(57988, NULL, 'G3DSA:2.40.30.170:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57989, NULL, 'G3DSA:3.40.190.10:FF:000767', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(57990, NULL, 'G3DSA:3.10.20.90:FF:000355', NULL, NULL, 'Dual specificity mitogen-activated protein kinase kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(57991, NULL, 'G3DSA:1.25.10.10:FF:001533', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(57992, NULL, 'G3DSA:1.10.287.110:FF:000429', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57993, NULL, 'G3DSA:2.30.29.30:FF:000336', NULL, NULL, 'protein Dok-7 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(57994, NULL, 'G3DSA:1.20.272.10:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57995, NULL, 'G3DSA:3.20.20.300:FF:000085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(57996, NULL, 'G3DSA:3.60.21.10:FF:000404', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(57997, NULL, 'G3DSA:1.25.10.10:FF:000313', NULL, NULL, 'Importin beta-2 subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(57998, NULL, 'G3DSA:1.20.1250.20:FF:001045', NULL, NULL, 'Solute carrier family 17 (sodium phosphate), member 3', NULL, NULL, NULL, NULL, NULL, 4),
(57999, NULL, 'G3DSA:3.30.70.330:FF:003035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58000, NULL, 'G3DSA:1.10.1420.10:FF:000074', NULL, NULL, 'MutS protein homolog him-14', NULL, NULL, NULL, NULL, NULL, 4),
(58001, NULL, 'G3DSA:1.10.510.10:FF:004168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58002, NULL, 'G3DSA:2.60.40.10:FF:002659', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58003, NULL, 'G3DSA:3.40.50.2300:FF:001005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(58004, NULL, 'G3DSA:1.20.1640.10:FF:000015', NULL, NULL, 'Dispatched RND transporter family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(58005, NULL, 'G3DSA:3.40.20.10:FF:000010', NULL, NULL, 'Putative destrin', NULL, NULL, NULL, NULL, NULL, 4),
(58006, NULL, 'G3DSA:2.70.150.10:FF:000205', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(58007, NULL, 'G3DSA:3.10.20.90:FF:000411', NULL, NULL, 'ESX-4 secretion system protein EccD4', NULL, NULL, NULL, NULL, NULL, 4),
(58008, NULL, 'G3DSA:1.10.8.60:FF:000231', NULL, NULL, 'Origin recognition complex subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(58009, NULL, 'G3DSA:1.10.238.10:FF:000937', NULL, NULL, 'Calmodulin like 6', NULL, NULL, NULL, NULL, NULL, 4),
(58010, NULL, 'G3DSA:1.20.1250.20:FF:001753', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58011, NULL, 'G3DSA:2.170.150.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58012, NULL, 'G3DSA:3.30.160.60:FF:005402', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58013, NULL, 'G3DSA:3.80.10.10:FF:002250', NULL, NULL, 'F-box protein At-B', NULL, NULL, NULL, NULL, NULL, 4),
(58014, NULL, 'G3DSA:1.10.238.10:FF:001101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58015, NULL, 'G3DSA:3.90.550.50:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58016, NULL, 'G3DSA:1.10.150.20:FF:000147', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(58017, NULL, 'G3DSA:3.40.140.100:FF:000012', NULL, NULL, 'Ubiquitin-like modifier-activating enzyme ATG7', NULL, NULL, NULL, NULL, NULL, 4),
(58018, NULL, 'G3DSA:3.30.1640.10:FF:000028', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(58019, NULL, 'G3DSA:1.50.10.20:FF:000073', NULL, NULL, 'Mannan endo-1,6-alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(58020, NULL, 'G3DSA:3.50.50.60:FF:000812', NULL, NULL, 'Flavoprotein monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58021, NULL, 'G3DSA:1.20.1070.10:FF:001798', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58022, NULL, 'G3DSA:2.60.120.200:FF:000265', NULL, NULL, 'FlaMIngo (Cadherin plus 7TM domain) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(58023, NULL, 'G3DSA:2.30.30.140:FF:000332', NULL, NULL, 'Sop-2-related protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(58024, NULL, 'G3DSA:1.10.730.10:FF:000109', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(58025, NULL, 'G3DSA:3.90.70.10:FF:000229', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(58026, NULL, 'G3DSA:3.30.230.70:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58027, NULL, 'G3DSA:3.20.20.30:FF:000039', NULL, NULL, 'Alkanal monooxygenase beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(58028, NULL, 'G3DSA:3.40.50.1820:FF:000799', NULL, NULL, 'Carboxylesterase', NULL, NULL, NULL, NULL, NULL, 4),
(58029, NULL, 'G3DSA:3.30.160.60:FF:003744', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58030, NULL, 'G3DSA:3.40.50.2300:FF:000752', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58031, NULL, 'G3DSA:3.30.420.610:FF:000012', NULL, NULL, 'Tudor domain-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(58032, NULL, 'G3DSA:2.60.120.260:FF:000496', NULL, NULL, 'Protein CBG04403', NULL, NULL, NULL, NULL, NULL, 4),
(58033, NULL, 'G3DSA:3.30.230.10:FF:000172', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(58034, NULL, 'G3DSA:2.130.10.10:FF:004728', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58035, NULL, 'G3DSA:3.40.190.10:FF:000244', NULL, NULL, 'Putative solute-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(58036, NULL, 'G3DSA:1.25.10.10:FF:002078', NULL, NULL, 'Serine/threonine kinase 36 (fused homolog, Drosophila)', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(58037, NULL, 'G3DSA:2.30.39.10:FF:000100', NULL, NULL, 'Protein CBG10463', NULL, NULL, NULL, NULL, NULL, 4),
(58038, NULL, 'G3DSA:3.90.1170.50:FF:000018', NULL, NULL, 'Aldehyde oxidase / xanthine dehydrogenase family molybdopterin cytosine dinucleotide-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(58039, NULL, 'G3DSA:3.20.110.10:FF:000042', NULL, NULL, 'Lysosomal alpha-mannosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58040, NULL, 'G3DSA:3.60.120.10:FF:000011', NULL, NULL, 'Aminodeoxychorismate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(58041, NULL, 'G3DSA:3.40.50.2000:FF:000016', NULL, NULL, 'UDP-N-acetylglucosamine--N-acetylmuramyl-(pentapeptide) pyrophosphoryl-undecaprenol N-acetylglucosamine transferase', NULL, NULL, NULL, NULL, NULL, 4),
(58042, NULL, 'G3DSA:3.80.10.10:FF:000625', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(58043, NULL, 'G3DSA:2.40.30.10:FF:000147', NULL, NULL, 'Sulfate adenylyltransferase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(58044, NULL, 'G3DSA:2.60.40.10:FF:001586', NULL, NULL, 'Single Ig IL-1-related receptor', NULL, NULL, NULL, NULL, NULL, 4),
(58045, NULL, 'G3DSA:2.40.50.910:FF:000003', NULL, NULL, 'ESX-3 secretion system ATPase EccB3', NULL, NULL, NULL, NULL, NULL, 4),
(58046, NULL, 'G3DSA:3.30.960.10:FF:000002', NULL, NULL, 'Eukaryotic peptide chain release factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(58047, NULL, 'G3DSA:3.90.1170.30:FF:000012', NULL, NULL, 'Pyrimidine-nucleoside phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(58048, NULL, 'G3DSA:4.10.240.10:FF:000061', NULL, NULL, 'Transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(58049, NULL, 'G3DSA:3.40.50.300:FF:008281', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58050, NULL, 'G3DSA:3.40.50.12550:FF:000010', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(58051, NULL, 'G3DSA:1.20.58.900:FF:000002', NULL, NULL, 'small G protein signaling modulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(58052, NULL, 'G3DSA:3.40.50.720:FF:001611', NULL, NULL, 'Putative precorrin-2 dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(58053, NULL, 'G3DSA:3.90.70.10:FF:000140', NULL, NULL, 'Ubiquitin C-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(58054, NULL, 'G3DSA:3.90.640.10:FF:000116', NULL, NULL, 'Heat shock protein 70 putative', NULL, NULL, NULL, NULL, NULL, 4),
(58055, NULL, 'G3DSA:3.30.70.1170:FF:000011', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase B', NULL, NULL, NULL, NULL, NULL, 4),
(58056, NULL, 'G3DSA:3.30.760.10:FF:000049', NULL, NULL, 'Eukaryotic translation initiation factor 4E family member 1c', NULL, NULL, NULL, NULL, NULL, 4),
(58057, NULL, 'G3DSA:3.60.21.10:FF:000371', NULL, NULL, '5'' nucleotidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58058, NULL, 'G3DSA:2.40.100.10:FF:000153', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(58059, NULL, 'G3DSA:3.30.200.20:FF:001134', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(58060, NULL, 'G3DSA:1.25.40.10:FF:000517', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g50270', NULL, NULL, NULL, NULL, NULL, 4),
(58061, NULL, 'G3DSA:3.40.50.300:FF:003930', NULL, NULL, 'RAB34, member RAS oncogene family a', NULL, NULL, NULL, NULL, NULL, 4),
(58062, NULL, 'G3DSA:3.40.309.10:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58063, NULL, 'G3DSA:3.30.70.2470:FF:000002', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase N2 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(58064, NULL, 'G3DSA:3.40.50.300:FF:003222', NULL, NULL, 'ABC transporter ATP-binding protein YtrE', NULL, NULL, NULL, NULL, NULL, 4),
(58065, NULL, 'G3DSA:3.40.50.1370:FF:000001', NULL, NULL, 'Aspartate carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(58066, NULL, 'G3DSA:3.40.50.450:FF:000018', NULL, NULL, 'Lysine decarboxylase-like protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(58067, NULL, 'G3DSA:2.130.10.30:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58068, NULL, 'G3DSA:3.30.200.20:FF:001842', NULL, NULL, 'Proto-oncogene receptor tyrosine protein kinase ret, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58069, NULL, 'G3DSA:2.40.70.10:FF:000324', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58070, NULL, 'G3DSA:3.90.550.10:FF:000289', NULL, NULL, 'GalNAc(5)-diNAcBac-PP-undecaprenol beta-1,3-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(58071, NULL, 'G3DSA:3.60.40.10:FF:000004', NULL, NULL, 'Probable protein phosphatase 2C 22', NULL, NULL, NULL, NULL, NULL, 4),
(58072, NULL, 'G3DSA:3.60.110.10:FF:000038', NULL, NULL, 'Glutamine-dependent NAD(+) synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(58073, NULL, 'G3DSA:2.40.50.140:FF:000643', NULL, NULL, 'Single-stranded DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(58074, NULL, 'G3DSA:3.30.420.10:FF:000035', NULL, NULL, 'Poly(A)-specific ribonuclease PARN', NULL, NULL, NULL, NULL, NULL, 4),
(58075, NULL, 'G3DSA:3.90.920.10:FF:000014', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(58076, NULL, 'G3DSA:2.60.40.10:FF:000097', NULL, NULL, 'Bent, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(58077, NULL, 'G3DSA:2.60.40.420:FF:000142', NULL, NULL, 'Multicopper oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(58078, NULL, 'G3DSA:1.10.150.190:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58079, NULL, 'G3DSA:1.10.3430.10:FF:000070', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58080, NULL, 'G3DSA:3.30.160.60:FF:001979', NULL, NULL, 'Zinc finger protein 222', NULL, NULL, NULL, NULL, NULL, 4),
(58081, NULL, 'G3DSA:2.120.10.30:FF:000373', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58082, NULL, 'G3DSA:3.40.50.1970:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58083, NULL, 'G3DSA:3.30.1330.30:FF:000140', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58084, NULL, 'G3DSA:1.10.10.440:FF:000016', NULL, NULL, 'pre-mRNA-processing factor 40 homolog B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(58085, NULL, 'G3DSA:3.30.70.330:FF:000781', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase E', NULL, NULL, NULL, NULL, NULL, 4),
(58086, NULL, 'G3DSA:1.10.760.10:FF:000117', NULL, NULL, 'Glr3801 protein', NULL, NULL, NULL, NULL, NULL, 4),
(58087, NULL, 'G3DSA:2.60.40.10:FF:005532', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58088, NULL, 'G3DSA:1.25.40.180:FF:000035', NULL, NULL, 'snRNA cap binding complex subunit (Gcr3)', NULL, NULL, NULL, NULL, NULL, 4),
(58089, NULL, 'G3DSA:3.30.40.10:FF:001495', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58090, NULL, 'G3DSA:2.20.70.10:FF:000218', NULL, NULL, 'Rho GTPase-activating protein 27,-like', NULL, NULL, NULL, NULL, NULL, 4),
(58091, NULL, 'G3DSA:3.40.850.10:FF:000503', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58092, NULL, 'G3DSA:3.90.1150.10:FF:000151', NULL, NULL, 'Alanine aminotransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(58093, NULL, 'G3DSA:1.10.510.10:FF:001386', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58094, NULL, 'G3DSA:1.10.8.20:FF:000011', NULL, NULL, 'Retinol-binding protein pinta', NULL, NULL, NULL, NULL, NULL, 4),
(58095, NULL, 'G3DSA:3.30.1010.10:FF:000110', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58096, NULL, 'G3DSA:1.10.510.10:FF:001442', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(58097, NULL, 'G3DSA:1.10.3210.10:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58098, NULL, 'G3DSA:1.10.565.10:FF:000124', NULL, NULL, 'Tailless ortholog', NULL, NULL, NULL, NULL, NULL, 4),
(58099, NULL, 'G3DSA:3.40.850.10:FF:000447', NULL, NULL, 'RT07324p', NULL, NULL, NULL, NULL, NULL, 4),
(58100, NULL, 'G3DSA:3.40.50.2000:FF:000544', NULL, NULL, 'Alpha,alpha-trehalose-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(58101, NULL, 'G3DSA:3.40.50.720:FF:001898', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(58102, NULL, 'G3DSA:3.30.200.20:FF:002438', NULL, NULL, 'Os10g0200000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(58103, NULL, 'G3DSA:1.25.40.20:FF:001779', NULL, NULL, 'Pho81p', NULL, NULL, NULL, NULL, NULL, 4),
(58104, NULL, 'G3DSA:1.20.1280.140:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58105, NULL, 'G3DSA:3.30.160.60:FF:002255', NULL, NULL, 'Zinc finger protein 460', NULL, NULL, NULL, NULL, NULL, 4),
(58106, NULL, 'G3DSA:3.40.50.1000:FF:000761', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58107, NULL, 'G3DSA:2.70.170.10:FF:000004', NULL, NULL, 'Gamma-aminobutyric acid receptor subunit beta-2 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(58108, NULL, 'G3DSA:3.10.10.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58109, NULL, 'G3DSA:2.130.10.10:FF:000462', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1', NULL, NULL, NULL, NULL, NULL, 4),
(58110, NULL, 'G3DSA:2.30.30.40:FF:000207', NULL, NULL, 'CLUMA_CG020965, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(58111, NULL, 'G3DSA:1.10.720.60:FF:000017', NULL, NULL, 'Enolase-phosphatase E1', NULL, NULL, NULL, NULL, NULL, 4),
(58112, NULL, 'G3DSA:3.40.50.2000:FF:000488', NULL, NULL, 'Alpha-1,3-mannosyltransferase ALG2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58113, NULL, 'G3DSA:3.40.50.1000:FF:000233', NULL, NULL, 'Haloacid dehalogenase-like hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(58114, NULL, 'G3DSA:3.30.160.60:FF:002199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58115, NULL, 'G3DSA:2.10.25.10:FF:001744', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58116, NULL, 'G3DSA:1.20.1310.10:FF:000114', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58117, NULL, 'G3DSA:1.20.1560.10:FF:000014', NULL, NULL, 'Multidrug resistance-associated protein member 4', NULL, NULL, NULL, NULL, NULL, 4),
(58118, NULL, 'G3DSA:2.130.10.10:FF:004149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58119, NULL, 'G3DSA:3.30.420.10:FF:000563', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58120, NULL, 'G3DSA:3.30.70.1230:FF:000254', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(58121, NULL, 'G3DSA:2.130.10.10:FF:004880', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58122, NULL, 'G3DSA:1.25.10.10:FF:002314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58123, NULL, 'G3DSA:3.40.50.10490:FF:000105', NULL, NULL, 'Glucosamine-fructose-6-phosphate aminotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58124, NULL, 'G3DSA:3.30.1320.10:FF:000009', NULL, NULL, '30S ribosomal protein S16', NULL, NULL, NULL, NULL, NULL, 4),
(58125, NULL, 'G3DSA:2.60.120.560:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58126, NULL, 'G3DSA:3.40.50.620:FF:000710', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58127, NULL, 'G3DSA:3.30.40.210:FF:000014', NULL, NULL, 'Transcription initiation protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58128, NULL, 'G3DSA:3.30.40.10:FF:000511', NULL, NULL, 'PHD and RING finger domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(58129, NULL, 'G3DSA:2.170.270.10:FF:000151', NULL, NULL, 'SET (Trithorax/polycomb) domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(58130, NULL, 'G3DSA:3.50.50.60:FF:000195', NULL, NULL, 'L-ornithine N(5)-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(58131, NULL, 'G3DSA:2.60.120.260:FF:000529', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58132, NULL, 'G3DSA:3.30.160.60:FF:004385', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58133, NULL, 'G3DSA:3.30.70.1220:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58134, NULL, 'G3DSA:3.30.1390.10:FF:000014', NULL, NULL, 'ATP-dependent Clp protease adaptor protein ClpS', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(58135, NULL, 'G3DSA:2.30.220.10:FF:000001', NULL, NULL, 'Flagellin', NULL, NULL, NULL, NULL, NULL, 4),
(58136, NULL, 'G3DSA:2.60.40.150:FF:000802', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58137, NULL, 'G3DSA:3.40.50.300:FF:002817', NULL, NULL, 'ESX-3 secretion system protein EccC3', NULL, NULL, NULL, NULL, NULL, 4),
(58138, NULL, 'G3DSA:1.10.1240.60:FF:000002', NULL, NULL, 'CRE-EAT-16 protein', NULL, NULL, NULL, NULL, NULL, 4),
(58139, NULL, 'G3DSA:3.40.50.1980:FF:000150', NULL, NULL, 'Iron-uptake system binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(58140, NULL, 'G3DSA:3.30.160.60:FF:006094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58141, NULL, 'G3DSA:2.60.120.10:FF:000138', NULL, NULL, 'Homogentisate 1,2-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(58142, NULL, 'G3DSA:1.10.510.10:FF:003151', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58143, NULL, 'G3DSA:3.40.309.10:FF:000055', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(58144, NULL, 'G3DSA:2.60.40.10:FF:001058', NULL, NULL, 'Sallimus, isoform P', NULL, NULL, NULL, NULL, NULL, 4),
(58145, NULL, 'G3DSA:1.10.287.470:FF:000048', NULL, NULL, 'Efflux transporter, RND family, MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(58146, NULL, 'G3DSA:2.60.40.60:FF:000448', NULL, NULL, 'Cadherin 2', NULL, NULL, NULL, NULL, NULL, 4),
(58147, NULL, 'G3DSA:3.10.450.490:FF:000003', NULL, NULL, 'Elastase', NULL, NULL, NULL, NULL, NULL, 4),
(58148, NULL, 'G3DSA:1.20.58.1120:FF:000010', NULL, NULL, 'Dynein heavy chain domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(58149, NULL, 'G3DSA:2.60.200.20:FF:000237', NULL, NULL, 'GGDEF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(58150, NULL, 'G3DSA:2.30.42.10:FF:000619', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58151, NULL, 'G3DSA:3.30.479.20:FF:000004', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(58152, NULL, 'G3DSA:1.10.10.60:FF:001227', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58153, NULL, 'G3DSA:2.10.60.10:FF:000010', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(58154, NULL, 'G3DSA:3.90.1600.10:FF:000017', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(58155, NULL, 'G3DSA:2.60.40.10:FF:001114', NULL, NULL, 'Chitinase A1', NULL, NULL, NULL, NULL, NULL, 4),
(58156, NULL, 'G3DSA:3.10.200.10:FF:000006', NULL, NULL, 'Carbonic anhydrase-related protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(58157, NULL, 'G3DSA:1.10.400.10:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58158, NULL, 'G3DSA:3.30.160.60:FF:003216', NULL, NULL, 'Zinc finger protein 451', NULL, NULL, NULL, NULL, NULL, 4),
(58159, NULL, 'G3DSA:1.10.10.60:FF:000451', NULL, NULL, 'Homeobox protein vent1', NULL, NULL, NULL, NULL, NULL, 4),
(58160, NULL, 'G3DSA:1.50.40.10:FF:000217', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(58161, NULL, 'G3DSA:1.10.10.10:FF:001061', NULL, NULL, 'Cullin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(58162, NULL, 'G3DSA:1.20.58.60:FF:000605', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(58163, NULL, 'G3DSA:3.30.1490.290:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58164, NULL, 'G3DSA:3.40.50.1010:FF:000146', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(58165, NULL, 'G3DSA:1.20.1270.60:FF:000024', NULL, NULL, 'growth arrest-specific protein 7 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(58166, NULL, 'G3DSA:1.20.1050.130:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58167, NULL, 'G3DSA:2.130.10.10:FF:005841', NULL, NULL, 'Apaf-1 related killer DARK', NULL, NULL, NULL, NULL, NULL, 4),
(58168, NULL, 'G3DSA:3.50.50.60:FF:000048', NULL, NULL, '2-octaprenyl-3-methyl-6-methoxy-1,4-benzoquinol hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(58169, NULL, 'G3DSA:2.130.10.10:FF:002019', NULL, NULL, 'Protein ROOT INITIATION DEFECTIVE 3', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(58170, NULL, 'G3DSA:3.40.50.2300:FF:001477', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58171, NULL, 'G3DSA:1.25.40.180:FF:000182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58172, NULL, 'G3DSA:3.40.1490.10:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58173, NULL, 'G3DSA:3.40.50.10890:FF:000012', NULL, NULL, 'Cleavage and polyadenylation specificity factor', NULL, NULL, NULL, NULL, NULL, 4),
(58174, NULL, 'G3DSA:3.40.532.10:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58175, NULL, 'G3DSA:2.60.40.10:FF:005329', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58176, NULL, 'G3DSA:1.20.1080.10:FF:000079', NULL, NULL, 'Delta-TIP homolog', NULL, NULL, NULL, NULL, NULL, 4),
(58177, NULL, 'G3DSA:3.10.120.10:FF:000005', NULL, NULL, 'E3 ubiquitin-protein ligase HERC2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(58178, NULL, 'G3DSA:3.30.70.330:FF:000449', NULL, NULL, 'splicing factor U2AF 35 kDa subunit isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(58179, NULL, 'G3DSA:1.20.1070.10:FF:000634', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58180, NULL, 'G3DSA:3.30.1780.10:FF:000010', NULL, NULL, 'Ornithine cyclodeaminase', NULL, NULL, NULL, NULL, NULL, 4),
(58181, NULL, 'G3DSA:3.40.50.300:FF:004947', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58182, NULL, 'G3DSA:3.40.50.150:FF:000518', NULL, NULL, 'Salicylate carboxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(58183, NULL, 'G3DSA:3.20.20.100:FF:000137', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58184, NULL, 'G3DSA:3.40.50.300:FF:001513', NULL, NULL, 'Structural maintenance of chromosomes protein', NULL, NULL, NULL, NULL, NULL, 4),
(58185, NULL, 'G3DSA:1.25.10.10:FF:002258', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58186, NULL, 'G3DSA:3.30.830.10:FF:000318', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58187, NULL, 'G3DSA:1.25.40.10:FF:003070', NULL, NULL, 'Crooked neck protein, putative, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(58188, NULL, 'G3DSA:3.30.70.330:FF:000629', NULL, NULL, 'ATP-dependent RNA helicase DeaD', NULL, NULL, NULL, NULL, NULL, 4),
(58189, NULL, 'G3DSA:3.30.420.40:FF:000723', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(58190, NULL, 'G3DSA:4.10.1000.30:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58191, NULL, 'G3DSA:2.40.30.10:FF:000350', NULL, NULL, 'Iron only hydrogenase large subunit, C-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(58192, NULL, 'G3DSA:3.50.30.30:FF:000089', NULL, NULL, 'Probable E3 ubiquitin-protein ligase plr-1', NULL, NULL, NULL, NULL, NULL, 4),
(58193, NULL, 'G3DSA:1.25.10.10:FF:001297', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58194, NULL, 'G3DSA:3.40.50.720:FF:001375', NULL, NULL, 'Glyoxylate reductase protein', NULL, NULL, NULL, NULL, NULL, 4),
(58195, NULL, 'G3DSA:3.40.1280.10:FF:000003', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(58196, NULL, 'G3DSA:3.30.260.10:FF:000033', NULL, NULL, 'Chaperonin-containing T-complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(58197, NULL, 'G3DSA:3.30.160.60:FF:005689', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58198, NULL, 'G3DSA:2.70.150.10:FF:000149', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(58199, NULL, 'G3DSA:3.30.450.20:FF:000337', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(58200, NULL, 'G3DSA:3.30.200.20:FF:002062', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(58201, NULL, 'G3DSA:2.40.50.40:FF:000068', NULL, NULL, 'Chromodomain protein, Y-like', NULL, NULL, NULL, NULL, NULL, 4),
(58202, NULL, 'G3DSA:3.90.1150.10:FF:000527', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58203, NULL, 'G3DSA:3.30.420.40:FF:000903', NULL, NULL, 'Heat shock protein, putative', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(58204, NULL, 'G3DSA:1.20.120.1760:FF:000013', NULL, NULL, 'Inner membrane protein YnjF', NULL, NULL, NULL, NULL, NULL, 4),
(58205, NULL, 'G3DSA:1.25.10.10:FF:000369', NULL, NULL, 'Vimar', NULL, NULL, NULL, NULL, NULL, 4),
(58206, NULL, 'G3DSA:1.20.58.60:FF:000044', NULL, NULL, 'Short stop, isoform K', NULL, NULL, NULL, NULL, NULL, 4),
(58207, NULL, 'G3DSA:3.40.50.300:FF:006712', NULL, NULL, 'Thymidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(58208, NULL, 'G3DSA:3.40.1280.30:FF:000009', NULL, NULL, 'tRNA (Guanine-N(1)-)-methyltransferase TRM10, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58209, NULL, 'G3DSA:2.130.10.10:FF:001238', NULL, NULL, 'Small nucleolar ribonucleoprotein complex subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58210, NULL, 'G3DSA:1.25.40.10:FF:002086', NULL, NULL, 'RNA processing factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(58211, NULL, 'G3DSA:1.20.120.1630:FF:000025', NULL, NULL, 'DUF1295 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(58212, NULL, 'G3DSA:1.10.630.10:FF:000080', NULL, NULL, 'Carotene epsilon-monooxygenase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(58213, NULL, 'G3DSA:3.90.1310.10:FF:000006', NULL, NULL, 'Penicillin-binding A domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(58214, NULL, 'G3DSA:1.20.58.60:FF:000752', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58215, NULL, 'G3DSA:3.30.710.10:FF:000102', NULL, NULL, 'Potassium voltage-gated channel subfamily S member 1', NULL, NULL, NULL, NULL, NULL, 4),
(58216, NULL, 'G3DSA:3.40.50.150:FF:000670', NULL, NULL, 'Amine N-MethylTransferase', NULL, NULL, NULL, NULL, NULL, 4),
(58217, NULL, 'G3DSA:1.10.287.3440:FF:000007', NULL, NULL, 'Biosynthetic arginine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(58218, NULL, 'G3DSA:1.10.418.10:FF:000182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58219, NULL, 'G3DSA:2.60.40.10:FF:000658', NULL, NULL, 'Neural cell adhesion molecule L1', NULL, NULL, NULL, NULL, NULL, 4),
(58220, NULL, 'G3DSA:3.40.50.300:FF:007112', NULL, NULL, 'Small GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58221, NULL, 'G3DSA:3.60.15.10:FF:000171', NULL, NULL, 'Beta-lactamase superfamily domain/DNA repair metallo-beta-lactamase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58222, NULL, 'G3DSA:2.130.10.10:FF:002351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58223, NULL, 'G3DSA:3.40.50.300:FF:007820', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58224, NULL, 'G3DSA:1.25.50.20:FF:000083', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(58225, NULL, 'G3DSA:1.20.58.860:FF:000006', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(58226, NULL, 'G3DSA:2.60.120.260:FF:000024', NULL, NULL, 'SUN domain containing ossification factor', NULL, NULL, NULL, NULL, NULL, 4),
(58227, NULL, 'G3DSA:3.40.50.80:FF:000139', NULL, NULL, 'Flavodoxin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(58228, NULL, 'G3DSA:1.10.10.60:FF:000395', NULL, NULL, 'GS homeobox 2', NULL, NULL, NULL, NULL, NULL, 4),
(58229, NULL, 'G3DSA:2.40.37.10:FF:000028', NULL, NULL, 'Alanine racemase', NULL, NULL, NULL, NULL, NULL, 4),
(58230, NULL, 'G3DSA:1.10.1520.10:FF:000110', NULL, NULL, 'Dicer-like ribonuclease with helicase and Rnase III domains', NULL, NULL, NULL, NULL, NULL, 4),
(58231, NULL, 'G3DSA:3.30.1360.70:FF:000018', NULL, NULL, 'Arginyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(58232, NULL, 'G3DSA:3.40.718.10:FF:000027', NULL, NULL, 'Probable LYS12-Homo-isocitrate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(58233, NULL, 'G3DSA:3.40.50.150:FF:001446', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58234, NULL, 'G3DSA:1.20.120.430:FF:000017', NULL, NULL, 'tRNA modification GTPase GTPBP3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(58235, NULL, 'G3DSA:3.30.420.40:FF:000870', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58236, NULL, 'G3DSA:2.10.110.10:FF:000306', NULL, NULL, 'LIM domain-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(58237, NULL, 'G3DSA:1.25.40.10:FF:003631', NULL, NULL, 'Tetratricopeptide repeat domain 37', NULL, NULL, NULL, NULL, NULL, 4),
(58238, NULL, 'G3DSA:3.30.230.70:FF:000055', NULL, NULL, 'RNasePH-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(58239, NULL, 'G3DSA:2.10.90.10:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58240, NULL, 'G3DSA:3.40.30.10:FF:000600', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(58241, NULL, 'G3DSA:3.40.50.300:FF:005167', NULL, NULL, 'Plasmid stability/partitioning determinant RepA', NULL, NULL, NULL, NULL, NULL, 4),
(58242, NULL, 'G3DSA:3.30.70.330:FF:000596', NULL, NULL, 'RNA-binding protein Musashi homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(58243, NULL, 'G3DSA:3.40.50.300:FF:002441', NULL, NULL, 'ABC transporter B family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(58244, NULL, 'G3DSA:1.20.5.340:FF:000082', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58245, NULL, 'G3DSA:1.10.30.50:FF:000005', NULL, NULL, 'HNH endonuclease domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(58246, NULL, 'G3DSA:3.20.20.80:FF:000413', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58247, NULL, 'G3DSA:2.120.10.30:FF:000406', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58248, NULL, 'G3DSA:1.10.760.10:FF:000084', NULL, NULL, 'Di-heme enzyme, MXAN_0977 family', NULL, NULL, NULL, NULL, NULL, 4),
(58249, NULL, 'G3DSA:2.60.120.290:FF:000128', NULL, NULL, 'mannan-binding lectin serine protease 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(58250, NULL, 'G3DSA:1.20.1070.10:FF:000814', NULL, NULL, 'Taste receptor type 2', NULL, NULL, NULL, NULL, NULL, 4),
(58251, NULL, 'G3DSA:1.20.120.1200:FF:000014', NULL, NULL, 'NADH-ubiquinone oxidoreductase chain 6', NULL, NULL, NULL, NULL, NULL, 4),
(58252, NULL, 'G3DSA:1.10.268.10:FF:000001', NULL, NULL, 'DNA gyrase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(58253, NULL, 'G3DSA:2.130.10.110:FF:000003', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(58254, NULL, 'G3DSA:3.40.50.300:FF:005875', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58255, NULL, 'G3DSA:3.30.460.80:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58256, NULL, 'G3DSA:1.20.5.350:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58257, NULL, 'G3DSA:1.10.510.10:FF:002931', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58258, NULL, 'G3DSA:1.10.510.10:FF:003331', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58259, NULL, 'G3DSA:3.30.160.60:FF:002963', NULL, NULL, 'Transcriptional repressor CTCF', NULL, NULL, NULL, NULL, NULL, 4),
(58260, NULL, 'G3DSA:1.10.1820.10:FF:000003', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(58261, NULL, 'G3DSA:2.10.25.10:FF:001688', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58262, NULL, 'G3DSA:2.130.10.10:FF:001390', NULL, NULL, 'U3 small nucleolar RNA-associated protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(58263, NULL, 'G3DSA:3.40.640.10:FF:000257', NULL, NULL, 'DegT/DnrJ/EryC1/StrS family aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(58264, NULL, 'G3DSA:3.30.230.130:FF:000027', NULL, NULL, 'Cullin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(58265, NULL, 'G3DSA:3.40.50.300:FF:000496', NULL, NULL, 'Nucleolar GTP-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(58266, NULL, 'G3DSA:1.10.10.10:FF:000509', NULL, NULL, 'transcription factor ETV7', NULL, NULL, NULL, NULL, NULL, 4),
(58267, NULL, 'G3DSA:1.20.1070.10:FF:000106', NULL, NULL, 'Apelin receptor a', NULL, NULL, NULL, NULL, NULL, 4),
(58268, NULL, 'G3DSA:3.20.100.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58269, NULL, 'G3DSA:3.20.80.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58270, NULL, 'G3DSA:1.10.1870.10:FF:000006', NULL, NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(58271, NULL, 'G3DSA:3.60.130.10:FF:000040', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58272, NULL, 'G3DSA:3.80.10.10:FF:002194', NULL, NULL, 'Toll-like receptor 21', NULL, NULL, NULL, NULL, NULL, 4),
(58273, NULL, 'G3DSA:3.30.310.50:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58274, NULL, 'G3DSA:1.10.1900.10:FF:000004', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(58275, NULL, 'G3DSA:3.30.70.330:FF:000421', NULL, NULL, 'CUGBP Elav-like family member 4', NULL, NULL, NULL, NULL, NULL, 4),
(58276, NULL, 'G3DSA:2.120.10.30:FF:000261', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58277, NULL, 'G3DSA:1.10.8.480:FF:000013', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(58278, NULL, 'G3DSA:3.40.850.10:FF:000559', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58279, NULL, 'G3DSA:3.30.160.60:FF:003183', NULL, NULL, 'KLUmpfuss related', NULL, NULL, NULL, NULL, NULL, 4),
(58280, NULL, 'G3DSA:3.40.50.300:FF:001980', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NUBP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(58281, NULL, 'G3DSA:1.10.10.580:FF:000013', NULL, NULL, 'Segregation and condensation protein A', NULL, NULL, NULL, NULL, NULL, 4),
(58282, NULL, 'G3DSA:1.10.472.10:FF:000532', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58283, NULL, 'G3DSA:3.60.20.10:FF:000121', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(58284, NULL, 'G3DSA:1.10.150.60:FF:000024', NULL, NULL, 'SWI/SNF chromatin-remodeling complex subunit SWI1', NULL, NULL, NULL, NULL, NULL, 4),
(58285, NULL, 'G3DSA:1.10.565.10:FF:000012', NULL, NULL, 'Nuclear receptor subfamily 2 group C member 1', NULL, NULL, NULL, NULL, NULL, 4),
(58286, NULL, 'G3DSA:3.40.50.2000:FF:000432', NULL, NULL, '3-deoxy-D-manno-octulosonic acid transferase', NULL, NULL, NULL, NULL, NULL, 4),
(58287, NULL, 'G3DSA:2.30.30.210:FF:000016', NULL, NULL, 'ribonuclease P protein subunit p29-like', NULL, NULL, NULL, NULL, NULL, 4),
(58288, NULL, 'G3DSA:1.10.132.130:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58289, NULL, 'G3DSA:1.25.40.10:FF:004064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58290, NULL, 'G3DSA:1.10.287.280:FF:000002', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(58291, NULL, 'G3DSA:3.90.550.50:FF:000082', NULL, NULL, 'GM18192', NULL, NULL, NULL, NULL, NULL, 4),
(58292, NULL, 'G3DSA:3.30.70.270:FF:000229', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58293, NULL, 'G3DSA:1.25.40.20:FF:001419', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58294, NULL, 'G3DSA:1.20.58.60:FF:000196', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(58295, NULL, 'G3DSA:3.40.1480.10:FF:000007', NULL, NULL, 'Glycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(58296, NULL, 'G3DSA:3.40.50.300:FF:004734', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58297, NULL, 'G3DSA:1.10.510.10:FF:000037', NULL, NULL, 'Serine/threonine-protein kinase tousled-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(58298, NULL, 'G3DSA:1.20.1070.10:FF:001983', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58299, NULL, 'G3DSA:3.30.160.60:FF:004913', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58300, NULL, 'G3DSA:3.90.70.10:FF:000432', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58301, NULL, 'G3DSA:1.20.120.810:FF:000002', NULL, NULL, 'Vinculin b', NULL, NULL, NULL, NULL, NULL, 4),
(58302, NULL, 'G3DSA:2.70.130.10:FF:000114', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58303, NULL, 'G3DSA:2.40.128.330:FF:000009', NULL, NULL, 'Magnesium ion transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58304, NULL, 'G3DSA:3.30.70.2630:FF:000005', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(58305, NULL, 'G3DSA:3.40.50.1100:FF:000257', NULL, NULL, 'Pyridoxal-5''-phosphate-dependent protein beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(58306, NULL, 'G3DSA:3.30.420.40:FF:000291', NULL, NULL, 'Actin, alpha skeletal muscle', NULL, NULL, NULL, NULL, NULL, 4),
(58307, NULL, 'G3DSA:3.40.50.970:FF:000180', NULL, NULL, 'Oxoglutarate dehydrogenase (Succinyl-transferring), E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(58308, NULL, 'G3DSA:1.25.10.10:FF:000925', NULL, NULL, 'Proteasome activator complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(58309, NULL, 'G3DSA:3.20.20.70:FF:000023', NULL, NULL, 'Lipoyl synthase', NULL, NULL, NULL, NULL, NULL, 4),
(58310, NULL, 'G3DSA:3.90.1140.10:FF:000061', NULL, NULL, 'Protein UBASH3A homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(58311, NULL, 'G3DSA:3.40.50.150:FF:000485', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(58312, NULL, 'G3DSA:3.30.2160.10:FF:000031', NULL, NULL, 'E3 ubiquitin-protein ligase hecd-1', NULL, NULL, NULL, NULL, NULL, 4),
(58313, NULL, 'G3DSA:3.80.10.10:FF:000125', NULL, NULL, 'Brassinosteroid LRR receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(58314, NULL, 'G3DSA:2.60.40.10:FF:002159', NULL, NULL, 'Cilia and flagella associated protein 65', NULL, NULL, NULL, NULL, NULL, 4),
(58315, NULL, 'G3DSA:3.30.200.20:FF:000173', NULL, NULL, 'Probable serine/threonine-protein kinase At1g01540', NULL, NULL, NULL, NULL, NULL, 4),
(58316, NULL, 'G3DSA:3.40.140.10:FF:000269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58317, NULL, 'G3DSA:1.10.510.10:FF:000458', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(58318, NULL, 'G3DSA:3.40.30.10:FF:000488', NULL, NULL, 'Unplaced genomic scaffold supercont2.20, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(58319, NULL, 'G3DSA:1.10.238.10:FF:000437', NULL, NULL, 'Ede1p', NULL, NULL, NULL, NULL, NULL, 4),
(58320, NULL, 'G3DSA:1.20.58.70:FF:000086', NULL, NULL, 'Syntaxin-12', NULL, NULL, NULL, NULL, NULL, 4),
(58321, NULL, 'G3DSA:2.30.230.10:FF:000007', NULL, NULL, 'Apolipoprotein lipid transfer particle', NULL, NULL, NULL, NULL, NULL, 4),
(58322, NULL, 'G3DSA:1.20.1050.10:FF:000251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58323, NULL, 'G3DSA:2.10.220.10:FF:000112', NULL, NULL, 'Furin-like protease 2', NULL, NULL, NULL, NULL, NULL, 4),
(58324, NULL, 'G3DSA:3.40.50.300:FF:005291', NULL, NULL, 'Arl_A64 protein', NULL, NULL, NULL, NULL, NULL, 4),
(58325, NULL, 'G3DSA:1.20.1310.10:FF:000119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58326, NULL, 'G3DSA:3.40.50.2000:FF:000483', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(58327, NULL, 'G3DSA:2.60.120.10:FF:000262', NULL, NULL, 'Homogentisate 1,2-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(58328, NULL, 'G3DSA:3.40.50.20:FF:000020', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(58329, NULL, 'G3DSA:1.25.40.20:FF:000970', NULL, NULL, 'YALI0F16940p', NULL, NULL, NULL, NULL, NULL, 4),
(58330, NULL, 'G3DSA:3.30.450.60:FF:000006', NULL, NULL, 'AP-1 complex subunit mu-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(58331, NULL, 'G3DSA:3.80.10.10:FF:003891', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58332, NULL, 'G3DSA:1.25.40.10:FF:000753', NULL, NULL, 'KIF1-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(58333, NULL, 'G3DSA:1.10.10.60:FF:000827', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58334, NULL, 'G3DSA:2.40.50.140:FF:000704', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58335, NULL, 'G3DSA:2.30.29.30:FF:000257', NULL, NULL, 'Pleckstrin homology domain-containing family M member 3', NULL, NULL, NULL, NULL, NULL, 4),
(58336, NULL, 'G3DSA:1.20.1250.20:FF:001758', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(58337, NULL, 'G3DSA:3.90.480.10:FF:000002', NULL, NULL, 'Sulfite reductase [ferredoxin]', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(58338, NULL, 'G3DSA:3.60.20.10:FF:000172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58339, NULL, 'G3DSA:3.90.740.10:FF:000040', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(58340, NULL, 'G3DSA:3.40.50.1460:FF:000056', NULL, NULL, 'Asparaginyl peptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58341, NULL, 'G3DSA:2.60.120.280:FF:000002', NULL, NULL, 'Transcriptional regulator, AraC family', NULL, NULL, NULL, NULL, NULL, 4),
(58342, NULL, 'G3DSA:3.40.50.970:FF:000079', NULL, NULL, 'Indolepyruvate ferredoxin oxidoreductase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(58343, NULL, 'G3DSA:3.30.160.20:FF:000034', NULL, NULL, 'NFKB repressing factor', NULL, NULL, NULL, NULL, NULL, 4),
(58344, NULL, 'G3DSA:3.30.590.10:FF:000013', NULL, NULL, 'Related to fluG protein', NULL, NULL, NULL, NULL, NULL, 4),
(58345, NULL, 'G3DSA:3.40.1180.10:FF:000030', NULL, NULL, 'Tritrans,polycis-undecaprenyl-diphosphate synthase (geranylgeranyl-diphosphate specific)', NULL, NULL, NULL, NULL, NULL, 4),
(58346, NULL, 'G3DSA:3.10.20.90:FF:000703', NULL, NULL, 'Protein DDI1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(58347, NULL, 'G3DSA:2.170.300.10:FF:000002', NULL, NULL, 'Multiple epidermal growth factor-like domains 10', NULL, NULL, NULL, NULL, NULL, 4),
(58348, NULL, 'G3DSA:3.40.47.10:FF:000223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58349, NULL, 'G3DSA:3.30.160.60:FF:004964', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58350, NULL, 'G3DSA:3.40.50.300:FF:008045', NULL, NULL, 'Atlastin GTPase 3', NULL, NULL, NULL, NULL, NULL, 4),
(58351, NULL, 'G3DSA:3.40.50.1820:FF:001428', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58352, NULL, 'G3DSA:3.40.1380.10:FF:000011', NULL, NULL, 'ATP synthase subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(58353, NULL, 'G3DSA:3.40.50.1000:FF:000492', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58354, NULL, 'G3DSA:1.25.10.10:FF:000021', NULL, NULL, 'Importin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(58355, NULL, 'G3DSA:3.30.1010.10:FF:000082', NULL, NULL, 'Chromosome 12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(58356, NULL, 'G3DSA:2.130.10.10:FF:004228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58357, NULL, 'G3DSA:1.20.1720.10:FF:000044', NULL, NULL, 'Putative multidrug resistance protein B', NULL, NULL, NULL, NULL, NULL, 4),
(58358, NULL, 'G3DSA:3.90.190.10:FF:000194', NULL, NULL, 'Protein tyrosine phosphatase putative', NULL, NULL, NULL, NULL, NULL, 4),
(58359, NULL, 'G3DSA:1.10.8.60:FF:000203', NULL, NULL, 'ESX-2 secretion system protein EccA2', NULL, NULL, NULL, NULL, NULL, 4),
(58360, NULL, 'G3DSA:3.30.70.270:FF:000330', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58361, NULL, 'G3DSA:1.20.58.860:FF:000001', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(58362, NULL, 'G3DSA:3.40.50.620:FF:000446', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(58363, NULL, 'G3DSA:3.40.630.10:FF:000195', NULL, NULL, 'Probable M28 family peptidase (Homolog to aminopeptidase YwaD)', NULL, NULL, NULL, NULL, NULL, 4),
(58364, NULL, 'G3DSA:3.90.550.10:FF:000177', NULL, NULL, 'MNN5p Alpha-1,2-mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(58365, NULL, 'G3DSA:1.10.510.10:FF:001818', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58366, NULL, 'G3DSA:3.10.260.10:FF:000010', NULL, NULL, 'Mycelial growth factor-1', NULL, NULL, NULL, NULL, NULL, 4),
(58367, NULL, 'G3DSA:2.40.70.10:FF:000352', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58368, NULL, 'G3DSA:2.10.25.10:FF:000608', NULL, NULL, 'Laminin subunit beta 4', NULL, NULL, NULL, NULL, NULL, 4),
(58369, NULL, 'G3DSA:2.10.50.10:FF:000009', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 14', NULL, NULL, NULL, NULL, NULL, 4),
(58370, NULL, 'G3DSA:3.80.10.10:FF:002430', NULL, NULL, 'Leucine-rich repeat-containing 15', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(58371, NULL, 'G3DSA:1.20.1300.10:FF:000001', NULL, NULL, 'Succinate dehydrogenase hydrophobic membrane anchor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(58372, NULL, 'G3DSA:3.80.10.10:FF:001974', NULL, NULL, 'Erbb2-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(58373, NULL, 'G3DSA:3.30.160.60:FF:004121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58374, NULL, 'G3DSA:3.10.129.10:FF:000002', NULL, NULL, '1,4-dihydroxy-2-naphthoyl-CoA hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(58375, NULL, 'G3DSA:1.10.510.10:FF:002454', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58376, NULL, 'G3DSA:3.50.30.30:FF:000145', NULL, NULL, 'Signal peptide peptidase like 2B', NULL, NULL, NULL, NULL, NULL, 4),
(58377, NULL, 'G3DSA:2.130.10.10:FF:005577', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58378, NULL, 'G3DSA:3.50.50.60:FF:001032', NULL, NULL, 'N,N-dimethylglycine oxidase, putative (AFU_orthologue AFUA_8G06470)', NULL, NULL, NULL, NULL, NULL, 4),
(58379, NULL, 'G3DSA:2.30.30.40:FF:000382', NULL, NULL, 'ABl Interactor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(58380, NULL, 'G3DSA:3.40.250.10:FF:000210', NULL, NULL, 'tRNA sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(58381, NULL, 'G3DSA:3.90.1420.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58382, NULL, 'G3DSA:1.20.1250.20:FF:000409', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(58383, NULL, 'G3DSA:2.30.30.30:FF:000114', NULL, NULL, 'Translation elongation factor EF-P', NULL, NULL, NULL, NULL, NULL, 4),
(58384, NULL, 'G3DSA:3.40.50.300:FF:008096', NULL, NULL, 'RNA cytidine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(58385, NULL, 'G3DSA:2.10.220.10:FF:000163', NULL, NULL, 'CXC-rich protein', NULL, NULL, NULL, NULL, NULL, 4),
(58386, NULL, 'G3DSA:1.20.1050.10:FF:000200', NULL, NULL, 'Glutathione S-transferase theta-2B', NULL, NULL, NULL, NULL, NULL, 4),
(58387, NULL, 'G3DSA:3.30.40.10:FF:001815', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58388, NULL, 'G3DSA:3.20.140.10:FF:000038', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(58389, NULL, 'G3DSA:1.25.40.10:FF:004935', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58390, NULL, 'G3DSA:3.40.50.300:FF:006600', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58391, NULL, 'G3DSA:1.10.472.10:FF:000144', NULL, NULL, 'Cyclin 4', NULL, NULL, NULL, NULL, NULL, 4),
(58392, NULL, 'G3DSA:3.60.10.10:FF:000295', NULL, NULL, 'Inositol-1,4,5-trisphosphate 5-phosphatase 2', NULL, NULL, NULL, NULL, NULL, 4),
(58393, NULL, 'G3DSA:2.130.10.10:FF:001474', NULL, NULL, 'Cleavage and polyadenylation specificity factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(58394, NULL, 'G3DSA:1.25.40.10:FF:002198', NULL, NULL, 'DNA polymerase interacting tpr containing protein of 47kD, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(58395, NULL, 'G3DSA:1.10.10.10:FF:000341', NULL, NULL, 'Forkhead box protein N2', NULL, NULL, NULL, NULL, NULL, 4),
(58396, NULL, 'G3DSA:1.25.40.500:FF:000002', NULL, NULL, 'TAF5-like RNA polymerase II p300/CBP-associated factor-associated factor 65 kDa subunit 5L', NULL, NULL, NULL, NULL, NULL, 4),
(58397, NULL, 'G3DSA:1.10.10.10:FF:000453', NULL, NULL, 'Transcriptional regulator, RpiR family', NULL, NULL, NULL, NULL, NULL, 4),
(58398, NULL, 'G3DSA:1.10.287.70:FF:000456', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(58399, NULL, 'G3DSA:2.60.40.10:FF:000361', NULL, NULL, 'versican core protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(58400, NULL, 'G3DSA:2.10.10.20:FF:000004', NULL, NULL, 'Peptidase M28', NULL, NULL, NULL, NULL, NULL, 4),
(58401, NULL, 'G3DSA:3.40.50.1010:FF:000270', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58402, NULL, 'G3DSA:3.40.50.300:FF:003374', NULL, NULL, 'Ribose ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(58403, NULL, 'G3DSA:2.30.110.20:FF:000001', NULL, NULL, 'Type VI secretion system effector', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(58404, NULL, 'G3DSA:1.10.287.130:FF:000036', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(58405, NULL, 'G3DSA:2.30.130.40:FF:000019', NULL, NULL, 'Lon protease', NULL, NULL, NULL, NULL, NULL, 4),
(58406, NULL, 'G3DSA:3.20.20.80:FF:000273', NULL, NULL, 'Glucan endo-1,3-beta-glucosidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(58407, NULL, 'G3DSA:1.50.40.10:FF:000509', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58408, NULL, 'G3DSA:2.60.40.1660:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58409, NULL, 'G3DSA:3.20.20.70:FF:000848', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58410, NULL, 'G3DSA:3.30.43.40:FF:000004', NULL, NULL, 'Pre-mRNA processing factor 8', NULL, NULL, NULL, NULL, NULL, 4),
(58411, NULL, 'G3DSA:3.30.160.60:FF:004172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58412, NULL, 'G3DSA:3.30.1330.40:FF:000002', NULL, NULL, 'Endoribonuclease L-PSP family protein', NULL, NULL, NULL, NULL, NULL, 4),
(58413, NULL, 'G3DSA:2.130.10.10:FF:004380', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58414, NULL, 'G3DSA:2.60.40.2840:FF:000005', NULL, NULL, 'inositol polyphosphate 5-phosphatase K', NULL, NULL, NULL, NULL, NULL, 4),
(58415, NULL, 'G3DSA:1.50.40.10:FF:000009', NULL, NULL, 'Mitochondrial 2-oxoglutarate/malate carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(58416, NULL, 'G3DSA:1.20.144.10:FF:000037', NULL, NULL, 'Phosphatidic acid phosphatase protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(58417, NULL, 'G3DSA:3.30.70.141:FF:000028', NULL, NULL, 'NME/NM23 family member 5', NULL, NULL, NULL, NULL, NULL, 4),
(58418, NULL, 'G3DSA:3.80.10.10:FF:000985', NULL, NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(58419, NULL, 'G3DSA:3.30.930.10:FF:000034', NULL, NULL, 'Serine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(58420, NULL, 'G3DSA:1.25.10.10:FF:001010', NULL, NULL, 'Tubulin folding cofactor D', NULL, NULL, NULL, NULL, NULL, 4),
(58421, NULL, 'G3DSA:3.40.50.800:FF:000056', NULL, NULL, 'Prolyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58422, NULL, 'G3DSA:1.10.220.150:FF:000003', NULL, NULL, 'ARF GTPase-activating protein GIT2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(58423, NULL, 'G3DSA:1.10.510.10:FF:000829', NULL, NULL, 'Serine/threonine-protein kinase TOS3', NULL, NULL, NULL, NULL, NULL, 4),
(58424, NULL, 'G3DSA:3.30.40.10:FF:000394', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(58425, NULL, 'G3DSA:1.25.40.10:FF:002939', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58426, NULL, 'G3DSA:3.40.50.300:FF:008157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58427, NULL, 'G3DSA:2.60.40.10:FF:000310', NULL, NULL, 'Down syndrome cell adhesion molecule, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(58428, NULL, 'G3DSA:1.25.40.10:FF:000641', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(58429, NULL, 'G3DSA:3.40.50.300:FF:002385', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58430, NULL, 'G3DSA:3.30.160.60:FF:002608', NULL, NULL, 'Zinc finger protein 337', NULL, NULL, NULL, NULL, NULL, 4),
(58431, NULL, 'G3DSA:3.90.226.10:FF:000351', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(58432, NULL, 'G3DSA:3.30.160.60:FF:001187', NULL, NULL, 'Zinc finger protein 599', NULL, NULL, NULL, NULL, NULL, 4),
(58433, NULL, 'G3DSA:1.10.238.10:FF:000325', NULL, NULL, 'EF-hand calcium binding domain 6', NULL, NULL, NULL, NULL, NULL, 4),
(58434, NULL, 'G3DSA:3.30.450.220:FF:000002', NULL, NULL, 'Autoinducer 2 sensor kinase/phosphatase LuxQ', NULL, NULL, NULL, NULL, NULL, 4),
(58435, NULL, 'G3DSA:3.30.160.60:FF:000698', NULL, NULL, 'Zinc finger with KRAB and SCAN domains 7', NULL, NULL, NULL, NULL, NULL, 4),
(58436, NULL, 'G3DSA:3.30.40.10:FF:002304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(58437, NULL, 'G3DSA:3.40.50.300:FF:001749', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(58438, NULL, 'G3DSA:3.10.290.10:FF:000079', NULL, NULL, 'Uncharacterized RNA pseudouridine synthase slr1629', NULL, NULL, NULL, NULL, NULL, 4),
(58439, NULL, 'G3DSA:1.20.1070.10:FF:001562', NULL, NULL, 'Adhesion G protein-coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(58440, NULL, 'G3DSA:3.80.10.10:FF:004307', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58441, NULL, 'G3DSA:2.160.20.60:FF:000010', NULL, NULL, 'Putative formylmethanofurane dehydrogenase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(58442, NULL, 'G3DSA:3.15.20.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58443, NULL, 'G3DSA:3.40.50.970:FF:000028', NULL, NULL, 'Transketolase isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(58444, NULL, 'G3DSA:2.40.30.270:FF:000003', NULL, NULL, 'DNA-binding protein SMUBP-2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(58445, NULL, 'G3DSA:3.90.640.10:FF:000055', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(58446, NULL, 'G3DSA:3.10.110.10:FF:000235', NULL, NULL, 'AFR314Wp', NULL, NULL, NULL, NULL, NULL, 4),
(58447, NULL, 'G3DSA:1.20.1310.20:FF:000027', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(58448, NULL, 'G3DSA:1.10.10.10:FF:000392', NULL, NULL, 'FEV, ETS transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(58449, NULL, 'G3DSA:3.30.559.70:FF:000031', NULL, NULL, 'Choline oacetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58450, NULL, 'G3DSA:3.40.50.150:FF:001002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58451, NULL, 'G3DSA:1.25.40.10:FF:000702', NULL, NULL, 'Trafficking protein particle complex subunit 12', NULL, NULL, NULL, NULL, NULL, 4),
(58452, NULL, 'G3DSA:3.80.10.10:FF:001474', NULL, NULL, 'Piriformospora indica-insensitive protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(58453, NULL, 'G3DSA:1.20.1110.10:FF:000189', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58454, NULL, 'G3DSA:3.50.30.40:FF:000002', NULL, NULL, '4-carboxy-4-hydroxy-2-oxoadipate aldolase/oxaloacetate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(58455, NULL, 'G3DSA:3.20.20.60:FF:000115', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(58456, NULL, 'G3DSA:2.30.30.40:FF:000331', NULL, NULL, 'Signal transducing adapter molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(58457, NULL, 'G3DSA:3.40.50.300:FF:007056', NULL, NULL, 'ATP-binding cassette protein', NULL, NULL, NULL, NULL, NULL, 4),
(58458, NULL, 'G3DSA:2.60.120.10:FF:000666', NULL, NULL, 'RmlC-like cupins superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(58459, NULL, 'G3DSA:1.10.20.40:FF:000002', NULL, NULL, 'Diaphanous, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(58460, NULL, 'G3DSA:1.10.340.70:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58461, NULL, 'G3DSA:3.30.365.10:FF:000001', NULL, NULL, 'Xanthine dehydrogenase oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(58462, NULL, 'G3DSA:3.30.565.10:FF:000533', NULL, NULL, 'Peroxide stress-activated histidine kinase mak3', NULL, NULL, NULL, NULL, NULL, 4),
(58463, NULL, 'G3DSA:3.50.50.60:FF:000043', NULL, NULL, 'Putative dihydrolipoyl dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(58464, NULL, 'G3DSA:3.30.1330.60:FF:000008', NULL, NULL, 'Outer membrane protein OmpA', NULL, NULL, NULL, NULL, NULL, 4),
(58465, NULL, 'G3DSA:3.40.50.12160:FF:000011', NULL, NULL, 'CDK5 regulatory subunit associated protein 1-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(58466, NULL, 'G3DSA:3.40.50.11030:FF:000009', NULL, NULL, 'Threonylcarbamoyl-AMP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(58467, NULL, 'G3DSA:1.20.5.190:FF:000053', NULL, NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(58468, NULL, 'G3DSA:3.30.160.60:FF:002547', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(58469, NULL, 'G3DSA:2.60.40.10:FF:005032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58470, NULL, 'G3DSA:3.30.300.20:FF:000006', NULL, NULL, '40S ribosomal protein S3', NULL, NULL, NULL, NULL, NULL, 4),
(58471, NULL, 'G3DSA:3.40.50.670:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58472, NULL, 'G3DSA:3.30.450.60:FF:000057', NULL, NULL, 'Probable coatomer subunit zeta-A', NULL, NULL, NULL, NULL, NULL, 4),
(58473, NULL, 'G3DSA:3.30.160.60:FF:000310', NULL, NULL, 'GLIS family zinc finger 2', NULL, NULL, NULL, NULL, NULL, 4),
(58474, NULL, 'G3DSA:3.30.70.3270:FF:000017', NULL, NULL, '4Fe-4S ferredoxin iron-sulfur binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(58475, NULL, 'G3DSA:3.40.50.620:FF:000558', NULL, NULL, '7-cyano-7-deazaguanine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(58476, NULL, 'G3DSA:1.20.900.10:FF:000003', NULL, NULL, 'Rho guanine nucleotide exchange factor 10 like', NULL, NULL, NULL, NULL, NULL, 4),
(58477, NULL, 'G3DSA:2.40.50.140:FF:001211', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58478, NULL, 'G3DSA:1.10.472.10:FF:000644', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58479, NULL, 'G3DSA:3.30.1890.10:FF:000007', NULL, NULL, 'Chain-length determining protein', NULL, NULL, NULL, NULL, NULL, 4),
(58480, NULL, 'G3DSA:4.10.60.10:FF:000101', NULL, NULL, 'Serine/arginine-rich splicing factor RSZ21A isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(58481, NULL, 'G3DSA:1.10.10.10:FF:001701', NULL, NULL, 'Rubisco operon transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(58482, NULL, 'G3DSA:3.90.280.10:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58483, NULL, 'G3DSA:1.10.506.10:FF:000078', NULL, NULL, 'Plexin C1', NULL, NULL, NULL, NULL, NULL, 4),
(58484, NULL, 'G3DSA:1.20.930.20:FF:000013', NULL, NULL, 'Mixed lineage kinase domain like pseudokinase', NULL, NULL, NULL, NULL, NULL, 4),
(58485, NULL, 'G3DSA:2.120.10.80:FF:000343', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58486, NULL, 'G3DSA:1.20.930.40:FF:000019', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58487, NULL, 'G3DSA:3.30.1330.30:FF:000084', NULL, NULL, 'SECIS (SeCis) Binding Protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(58488, NULL, 'G3DSA:1.10.238.10:FF:000376', NULL, NULL, 'CAMK/CDPK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(58489, NULL, 'G3DSA:1.10.510.10:FF:000930', NULL, NULL, 'Blast:Serine/threonine-protein kinase PINK1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(58490, NULL, 'G3DSA:1.25.40.20:FF:001307', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58491, NULL, 'G3DSA:3.80.10.10:FF:004228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58492, NULL, 'G3DSA:3.40.50.1580:FF:000007', NULL, NULL, 'Purine nucleoside phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(58493, NULL, 'G3DSA:3.40.50.620:FF:000507', NULL, NULL, 'Cryptochrome DASH', NULL, NULL, NULL, NULL, NULL, 4),
(58494, NULL, 'G3DSA:1.25.10.10:FF:000521', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(58495, NULL, 'G3DSA:3.30.430.20:FF:000010', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 10', NULL, NULL, NULL, NULL, NULL, 4),
(58496, NULL, 'G3DSA:3.40.50.300:FF:006651', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58497, NULL, 'G3DSA:1.25.40.10:FF:002147', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(58498, NULL, 'G3DSA:3.90.190.10:FF:000126', NULL, NULL, 'Metal ion binding/oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(58499, NULL, 'G3DSA:3.80.10.10:FF:000193', NULL, NULL, 'Leucine-rich repeat-containing protein 40', NULL, NULL, NULL, NULL, NULL, 4),
(58500, NULL, 'G3DSA:1.25.40.760:FF:000001', NULL, NULL, 'Nonsense-mediated mRNA decay protein', NULL, NULL, NULL, NULL, NULL, 4),
(58501, NULL, 'G3DSA:3.40.50.2300:FF:000044', NULL, NULL, 'Two-component system response regulator NarL', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(58502, NULL, 'G3DSA:2.40.10.330:FF:000001', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(58503, NULL, 'G3DSA:3.40.50.720:FF:002275', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58504, NULL, 'G3DSA:3.10.450.50:FF:000047', NULL, NULL, 'Aklanonic acid methyl ester cyclase AcmA', NULL, NULL, NULL, NULL, NULL, 4),
(58505, NULL, 'G3DSA:1.20.1540.10:FF:000007', NULL, NULL, 'Rhomboid like 2', NULL, NULL, NULL, NULL, NULL, 4),
(58506, NULL, 'G3DSA:3.40.50.720:FF:001370', NULL, NULL, '2-hydroxyacid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(58507, NULL, 'G3DSA:3.10.450.50:FF:000098', NULL, NULL, 'MIP14975p', NULL, NULL, NULL, NULL, NULL, 4),
(58508, NULL, 'G3DSA:6.20.10.30:FF:000003', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(58509, NULL, 'G3DSA:3.80.10.10:FF:002042', NULL, NULL, 'Acid labile subunit', NULL, NULL, NULL, NULL, NULL, 4),
(58510, NULL, 'G3DSA:2.10.110.10:FF:000042', NULL, NULL, 'lipoma-preferred partner isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(58511, NULL, 'G3DSA:3.20.20.10:FF:000033', NULL, NULL, 'Alanine racemase', NULL, NULL, NULL, NULL, NULL, 4),
(58512, NULL, 'G3DSA:3.30.470.10:FF:000015', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(58513, NULL, 'G3DSA:3.30.160.60:FF:001266', NULL, NULL, 'Zinc finger protein 662', NULL, NULL, NULL, NULL, NULL, 4),
(58514, NULL, 'G3DSA:3.40.50.300:FF:000468', NULL, NULL, 'ATP-dependent RNA helicase RhlE', NULL, NULL, NULL, NULL, NULL, 4),
(58515, NULL, 'G3DSA:2.60.110.10:FF:000025', NULL, NULL, 'Thaumatin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(58516, NULL, 'G3DSA:1.20.1250.20:FF:001837', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58517, NULL, 'G3DSA:2.10.70.10:FF:000123', NULL, NULL, 'Coagulation factor XIII B chain', NULL, NULL, NULL, NULL, NULL, 4),
(58518, NULL, 'G3DSA:3.90.79.10:FF:000081', NULL, NULL, '54S ribosomal protein L17, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(58519, NULL, 'G3DSA:3.30.70.850:FF:000015', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(58520, NULL, 'G3DSA:1.20.910.10:FF:000009', NULL, NULL, 'Aminopyrimidine aminohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(58521, NULL, 'G3DSA:3.40.50.1820:FF:001075', NULL, NULL, 'Endo-1,4-beta-xylanase Z', NULL, NULL, NULL, NULL, NULL, 4),
(58522, NULL, 'G3DSA:3.30.365.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58523, NULL, 'G3DSA:3.80.10.10:FF:000013', NULL, NULL, 'Erbin isoform 7', NULL, NULL, NULL, NULL, NULL, 4),
(58524, NULL, 'G3DSA:3.30.200.20:FF:002090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58525, NULL, 'G3DSA:1.20.120.530:FF:000008', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(58526, NULL, 'G3DSA:1.10.3710.10:FF:000001', NULL, NULL, 'Replication-associated recombination protein A', NULL, NULL, NULL, NULL, NULL, 4),
(58527, NULL, 'G3DSA:1.20.5.560:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58528, NULL, 'G3DSA:2.60.120.200:FF:000473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58529, NULL, 'G3DSA:3.30.930.10:FF:000113', NULL, NULL, 'eIF-2-alpha kinase GCN2', NULL, NULL, NULL, NULL, NULL, 4),
(58530, NULL, 'G3DSA:1.10.3660.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58531, NULL, 'G3DSA:3.50.70.10:FF:000001', NULL, NULL, 'Fatty-acid-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(58532, NULL, 'G3DSA:2.60.40.10:FF:002047', NULL, NULL, 'Mesocentin', NULL, NULL, NULL, NULL, NULL, 4),
(58533, NULL, 'G3DSA:1.25.40.10:FF:000692', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g13880', NULL, NULL, NULL, NULL, NULL, 4),
(58534, NULL, 'G3DSA:2.10.25.10:FF:000255', NULL, NULL, 'Sushi, nidogen and EGF-like domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(58535, NULL, 'G3DSA:1.10.357.120:FF:000016', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(58536, NULL, 'G3DSA:3.20.20.140:FF:000042', NULL, NULL, 'Isoaspartyl dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(58537, NULL, 'G3DSA:3.40.50.1820:FF:000939', NULL, NULL, 'Acetylcholinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(58538, NULL, 'G3DSA:3.30.1380.20:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58539, NULL, 'G3DSA:1.20.1070.10:FF:002000', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58540, NULL, 'G3DSA:1.20.58.70:FF:000018', NULL, NULL, 'SNARE domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(58541, NULL, 'G3DSA:3.30.40.10:FF:000798', NULL, NULL, 'RING finger protein 121', NULL, NULL, NULL, NULL, NULL, 4),
(58542, NULL, 'G3DSA:1.10.10.820:FF:000006', NULL, NULL, 'Myosin IIIA', NULL, NULL, NULL, NULL, NULL, 4),
(58543, NULL, 'G3DSA:1.10.506.10:FF:000027', NULL, NULL, 'Plexin A, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(58544, NULL, 'G3DSA:1.25.10.10:FF:000572', NULL, NULL, 'Importin 5', NULL, NULL, NULL, NULL, NULL, 4),
(58545, NULL, 'G3DSA:3.40.50.1820:FF:000911', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58546, NULL, 'G3DSA:2.20.25.20:FF:000004', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(58547, NULL, 'G3DSA:2.60.40.10:FF:002098', NULL, NULL, 'Immunoglobulin heavy variable 3-72', NULL, NULL, NULL, NULL, NULL, 4),
(58548, NULL, 'G3DSA:3.40.47.10:FF:000291', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58549, NULL, 'G3DSA:3.40.640.10:FF:000021', NULL, NULL, 'Glutamate-1-semialdehyde 2,1-aminomutase', NULL, NULL, NULL, NULL, NULL, 4),
(58550, NULL, 'G3DSA:3.30.559.30:FF:000047', NULL, NULL, 'Plipastatin synthase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(58551, NULL, 'G3DSA:1.20.20.10:FF:000026', NULL, NULL, 'ATP synthase subunit 9, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(58552, NULL, 'G3DSA:1.20.5.780:FF:000016', NULL, NULL, 'FXYD domain-containing ion transport regulator', NULL, NULL, NULL, NULL, NULL, 4),
(58553, NULL, 'G3DSA:1.20.1070.10:FF:000926', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58554, NULL, 'G3DSA:3.30.360.10:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58555, NULL, 'G3DSA:3.40.50.300:FF:001036', NULL, NULL, 'SWI/SNF related, matrix associated, actin dependent regulator of chromatin, subfamily a like 1', NULL, NULL, NULL, NULL, NULL, 4),
(58556, NULL, 'G3DSA:4.10.860.10:FF:000001', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(58557, NULL, 'G3DSA:3.20.20.80:FF:000301', NULL, NULL, 'Os03g0323350 protein', NULL, NULL, NULL, NULL, NULL, 4),
(58558, NULL, 'G3DSA:1.10.510.10:FF:003735', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58559, NULL, 'G3DSA:3.30.70.330:FF:000388', NULL, NULL, 'RNA-binding protein 24-B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(58560, NULL, 'G3DSA:1.20.58.60:FF:000549', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58561, NULL, 'G3DSA:3.90.70.10:FF:000792', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58562, NULL, 'G3DSA:3.30.1540.20:FF:000001', NULL, NULL, 'DNA mismatch repair endonuclease MutL', NULL, NULL, NULL, NULL, NULL, 4),
(58563, NULL, 'G3DSA:3.40.570.10:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58564, NULL, 'G3DSA:3.40.50.150:FF:000546', NULL, NULL, 'Phosphoethanolamine MethylTransferase', NULL, NULL, NULL, NULL, NULL, 4),
(58565, NULL, 'G3DSA:1.20.1110.10:FF:000138', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58566, NULL, 'G3DSA:1.25.40.10:FF:002439', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(58567, NULL, 'G3DSA:3.40.250.10:FF:000098', NULL, NULL, '3-mercaptopyruvate sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(58568, NULL, 'G3DSA:1.10.150.20:FF:000271', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58569, NULL, 'G3DSA:2.60.120.580:FF:000002', NULL, NULL, 'Formamidase FmdS', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(58570, NULL, 'G3DSA:3.40.720.10:FF:000022', NULL, NULL, 'Phosphoethanolamine transferase eptA', NULL, NULL, NULL, NULL, NULL, 4),
(58571, NULL, 'G3DSA:1.25.40.20:FF:000582', NULL, NULL, 'Os11g0435300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(58572, NULL, 'G3DSA:1.25.40.20:FF:001487', NULL, NULL, 'Putative huntingtin interacting protein (HIP)', NULL, NULL, NULL, NULL, NULL, 4),
(58573, NULL, 'G3DSA:3.30.160.60:FF:000198', NULL, NULL, 'zinc finger protein 10 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(58574, NULL, 'G3DSA:3.90.320.10:FF:000008', NULL, NULL, 'ATP-dependent helicase/nuclease subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(58575, NULL, 'G3DSA:3.40.30.10:FF:000128', NULL, NULL, 'endoplasmic reticulum resident protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(58576, NULL, 'G3DSA:3.40.50.10330:FF:000069', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(58577, NULL, 'G3DSA:1.20.5.990:FF:000012', NULL, NULL, 'Muscle myosin heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58578, NULL, 'G3DSA:1.10.510.10:FF:003443', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58579, NULL, 'G3DSA:3.30.1540.20:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58580, NULL, 'G3DSA:1.10.10.60:FF:000895', NULL, NULL, 'Chromatin remodeling factor CHD3 (PICKLE)', NULL, NULL, NULL, NULL, NULL, 4),
(58581, NULL, 'G3DSA:3.40.50.150:FF:000838', NULL, NULL, 'Methyltransferase FkbM family', NULL, NULL, NULL, NULL, NULL, 4),
(58582, NULL, 'G3DSA:2.60.260.20:FF:000033', NULL, NULL, 'DnaJ family protein', NULL, NULL, NULL, NULL, NULL, 4),
(58583, NULL, 'G3DSA:3.30.160.60:FF:004525', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58584, NULL, 'G3DSA:3.30.505.10:FF:000092', NULL, NULL, 'SH2 domain containing 1B', NULL, NULL, NULL, NULL, NULL, 4),
(58585, NULL, 'G3DSA:1.25.10.10:FF:002319', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58586, NULL, 'G3DSA:3.30.200.20:FF:000914', NULL, NULL, 'Cytoplasmic export protein', NULL, NULL, NULL, NULL, NULL, 4),
(58587, NULL, 'G3DSA:3.10.100.10:FF:000358', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58588, NULL, 'G3DSA:2.60.40.1090:FF:000008', NULL, NULL, 'Fimbrial major subunit StfA', NULL, NULL, NULL, NULL, NULL, 4),
(58589, NULL, 'G3DSA:3.30.200.20:FF:001550', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58590, NULL, 'G3DSA:3.30.230.10:FF:000413', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58591, NULL, 'G3DSA:1.20.1250.20:FF:000477', NULL, NULL, 'MFS monosaccharide transporter (Hxt8), putative', NULL, NULL, NULL, NULL, NULL, 4),
(58592, NULL, 'G3DSA:1.10.287.70:FF:000748', NULL, NULL, 'Glutamate receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58593, NULL, 'G3DSA:3.40.50.2300:FF:001421', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58594, NULL, 'G3DSA:2.60.40.10:FF:004576', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58595, NULL, 'G3DSA:3.30.70.330:FF:001669', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58596, NULL, 'G3DSA:2.130.10.10:FF:005285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58597, NULL, 'G3DSA:3.30.70.20:FF:000044', NULL, NULL, 'Ion-translocating oxidoreductase complex subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(58598, NULL, 'G3DSA:3.40.50.1000:FF:000441', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(58599, NULL, 'G3DSA:2.10.109.10:FF:000056', NULL, NULL, 'Signal peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(58600, NULL, 'G3DSA:3.40.50.1820:FF:001816', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58601, NULL, 'G3DSA:1.10.472.10:FF:000032', NULL, NULL, 'G2/mitotic-specific cyclin-1', NULL, NULL, NULL, NULL, NULL, 4),
(58602, NULL, 'G3DSA:2.40.70.10:FF:000240', NULL, NULL, 'Acid protease', NULL, NULL, NULL, NULL, NULL, 4),
(58603, NULL, 'G3DSA:1.20.120.1760:FF:000069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58604, NULL, 'G3DSA:1.25.40.10:FF:005020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(58605, NULL, 'G3DSA:1.25.40.180:FF:000187', NULL, NULL, 'MA3 domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58606, NULL, 'G3DSA:3.30.565.10:FF:000449', NULL, NULL, 'DNA mismatch repair protein PMS1', NULL, NULL, NULL, NULL, NULL, 4),
(58607, NULL, 'G3DSA:3.30.460.10:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58608, NULL, 'G3DSA:3.30.1370.60:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58609, NULL, 'G3DSA:2.60.40.10:FF:000653', NULL, NULL, 'Follistatin like 4', NULL, NULL, NULL, NULL, NULL, 4),
(58610, NULL, 'G3DSA:2.30.30.40:FF:000090', NULL, NULL, 'E3 ubiquitin-protein ligase MIB1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(58611, NULL, 'G3DSA:1.20.1530.20:FF:000010', NULL, NULL, 'Solute carrier family 10 member 6', NULL, NULL, NULL, NULL, NULL, 4),
(58612, NULL, 'G3DSA:3.40.50.300:FF:008449', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58613, NULL, 'G3DSA:1.20.140.100:FF:000046', NULL, NULL, 'Dynein heavy chain, cytosolic, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58614, NULL, 'G3DSA:2.40.50.100:FF:000058', NULL, NULL, 'ABC sugar transporter, ATP-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(58615, NULL, 'G3DSA:2.130.10.10:FF:002463', NULL, NULL, 'Transducin beta protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(58616, NULL, 'G3DSA:3.30.420.10:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58617, NULL, 'G3DSA:1.10.510.10:FF:002375', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58618, NULL, 'G3DSA:3.40.190.10:FF:000660', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(58619, NULL, 'G3DSA:3.20.20.140:FF:000334', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58620, NULL, 'G3DSA:3.80.10.10:FF:001553', NULL, NULL, 'AGAP001807-PA', NULL, NULL, NULL, NULL, NULL, 4),
(58621, NULL, 'G3DSA:3.30.70.330:FF:002107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58622, NULL, 'G3DSA:3.30.70.330:FF:001618', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58623, NULL, 'G3DSA:1.10.287.70:FF:000799', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58624, NULL, 'G3DSA:2.60.40.640:FF:000056', NULL, NULL, 'Vacuolar protein sorting/targeting protein VPS26', NULL, NULL, NULL, NULL, NULL, 4),
(58625, NULL, 'G3DSA:1.25.40.10:FF:003507', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(58626, NULL, 'G3DSA:1.20.1260.80:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58627, NULL, 'G3DSA:1.10.510.10:FF:001886', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58628, NULL, 'G3DSA:3.40.850.10:FF:000508', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(58629, NULL, 'G3DSA:3.80.10.10:FF:003739', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58630, NULL, 'G3DSA:1.10.10.2670:FF:000005', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(58631, NULL, 'G3DSA:1.25.10.70:FF:000011', NULL, NULL, 'Nucleoporin nup184', NULL, NULL, NULL, NULL, NULL, 4),
(58632, NULL, 'G3DSA:1.20.1250.20:FF:002326', NULL, NULL, 'Organic cation/carnitine transporter 7', NULL, NULL, NULL, NULL, NULL, 4),
(58633, NULL, 'G3DSA:2.30.29.30:FF:001325', NULL, NULL, 'Zinc finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58634, NULL, 'G3DSA:1.20.1270.60:FF:000232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58635, NULL, 'G3DSA:2.130.10.10:FF:001362', NULL, NULL, 'WD repeat-containing protein 70', NULL, NULL, NULL, NULL, NULL, 4),
(58636, NULL, 'G3DSA:2.40.320.10:FF:000012', NULL, NULL, 'Thiamine triphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(58637, NULL, 'G3DSA:3.40.50.720:FF:001931', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(58638, NULL, 'G3DSA:2.60.120.920:FF:000188', NULL, NULL, 'Si:dkey-23n7.10', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(58639, NULL, 'G3DSA:2.60.120.200:FF:000085', NULL, NULL, 'collagen alpha-1(XXVII) chain isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(58640, NULL, 'G3DSA:1.25.40.10:FF:004795', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58641, NULL, 'G3DSA:1.20.1070.10:FF:000134', NULL, NULL, 'proto-oncogene Mas', NULL, NULL, NULL, NULL, NULL, 4),
(58642, NULL, 'G3DSA:3.40.50.2300:FF:001472', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58643, NULL, 'G3DSA:2.60.60.20:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58644, NULL, 'G3DSA:2.60.40.10:FF:000602', NULL, NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein', NULL, NULL, NULL, NULL, NULL, 4),
(58645, NULL, 'G3DSA:1.20.1250.10:FF:000019', NULL, NULL, 'Interleukin 20', NULL, NULL, NULL, NULL, NULL, 4),
(58646, NULL, 'G3DSA:1.20.900.10:FF:000071', NULL, NULL, 'Phosphatidylinositol 3,4,5-trisphosphate-dependent Rac exchanger 2 protein isoform a', NULL, NULL, NULL, NULL, NULL, 4),
(58647, NULL, 'G3DSA:1.10.8.60:FF:000315', NULL, NULL, 'Chromosome 12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(58648, NULL, 'G3DSA:3.30.160.20:FF:000085', NULL, NULL, 'Peptidyl-tRNA hydrolase ICT1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58649, NULL, 'G3DSA:2.60.40.10:FF:003115', NULL, NULL, 'Plexin B, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(58650, NULL, 'G3DSA:3.30.160.60:FF:001215', NULL, NULL, 'Zinc finger 202 m1', NULL, NULL, NULL, NULL, NULL, 4),
(58651, NULL, 'G3DSA:3.40.50.300:FF:002317', NULL, NULL, 'ADP-ribosylation factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58652, NULL, 'G3DSA:2.40.240.10:FF:000011', NULL, NULL, 'Glutamine--tRNA ligase cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(58653, NULL, 'G3DSA:1.20.1090.10:FF:000017', NULL, NULL, 'Alcohol dehydrogenase lateral transfer candidate', NULL, NULL, NULL, NULL, NULL, 4),
(58654, NULL, 'G3DSA:2.160.20.10:FF:000309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58655, NULL, 'G3DSA:1.20.140.10:FF:000091', NULL, NULL, 'Acyl-CoA dehydrogenase short/branched chain', NULL, NULL, NULL, NULL, NULL, 4),
(58656, NULL, 'G3DSA:2.10.110.10:FF:000334', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58657, NULL, 'G3DSA:2.60.40.10:FF:002839', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58658, NULL, 'G3DSA:2.60.40.10:FF:004525', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58659, NULL, 'G3DSA:3.80.10.10:FF:000917', NULL, NULL, 'Si:dkey-26m3.3', NULL, NULL, NULL, NULL, NULL, 4),
(58660, NULL, 'G3DSA:3.40.1280.10:FF:000026', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4),
(58661, NULL, 'G3DSA:3.20.20.80:FF:000352', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58662, NULL, 'G3DSA:1.25.40.10:FF:005071', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g49170, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(58663, NULL, 'G3DSA:2.60.40.820:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58664, NULL, 'G3DSA:2.40.50.140:FF:000755', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58665, NULL, 'G3DSA:3.40.50.300:FF:005139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58666, NULL, 'G3DSA:1.10.238.10:FF:000033', NULL, NULL, 'Troponin C, slow skeletal and cardiac muscles', NULL, NULL, NULL, NULL, NULL, 4),
(58667, NULL, 'G3DSA:2.60.40.420:FF:000254', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58668, NULL, 'G3DSA:3.90.1310.10:FF:000001', NULL, NULL, 'Peptidoglycan D,D-transpeptidase MrdA', NULL, NULL, NULL, NULL, NULL, 4),
(58669, NULL, 'G3DSA:3.40.50.410:FF:000321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58670, NULL, 'G3DSA:3.30.160.60:FF:005077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58671, NULL, 'G3DSA:3.40.190.10:FF:000559', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(58672, NULL, 'G3DSA:2.60.40.60:FF:000235', NULL, NULL, 'Dachsous cadherin-related 1', NULL, NULL, NULL, NULL, NULL, 4),
(58673, NULL, 'G3DSA:1.25.40.820:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58674, NULL, 'G3DSA:3.30.40.10:FF:002243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58675, NULL, 'G3DSA:2.40.50.100:FF:000030', NULL, NULL, 'Macrolide transporter subunit MacA', NULL, NULL, NULL, NULL, NULL, 4),
(58676, NULL, 'G3DSA:3.30.310.40:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58677, NULL, 'G3DSA:3.50.50.60:FF:000604', NULL, NULL, 'Ferredoxin NADP+ reductase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(58678, NULL, 'G3DSA:1.20.81.30:FF:000004', NULL, NULL, 'Toxin co-regulated pilus biosynthesis protein E', NULL, NULL, NULL, NULL, NULL, 4),
(58679, NULL, 'G3DSA:2.30.39.10:FF:000095', NULL, NULL, 'Serpin 7', NULL, NULL, NULL, NULL, NULL, 4),
(58680, NULL, 'G3DSA:3.40.50.11660:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58681, NULL, 'G3DSA:3.40.190.10:FF:000031', NULL, NULL, 'Arogenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(58682, NULL, 'G3DSA:3.90.120.10:FF:000009', NULL, NULL, 'DNA methyltransferase Dim-2', NULL, NULL, NULL, NULL, NULL, 4),
(58683, NULL, 'G3DSA:3.30.1330.30:FF:000016', NULL, NULL, 'H/ACA ribonucleoprotein complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(58684, NULL, 'G3DSA:3.30.450.380:FF:000005', NULL, NULL, 'ATPase TadA', NULL, NULL, NULL, NULL, NULL, 4),
(58685, NULL, 'G3DSA:2.40.50.120:FF:000036', NULL, NULL, 'TIMP metallopeptidase inhibitor 4, tandem duplicate 3', NULL, NULL, NULL, NULL, NULL, 4),
(58686, NULL, 'G3DSA:3.40.50.300:FF:007140', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58687, NULL, 'G3DSA:3.40.50.150:FF:000777', NULL, NULL, 'Polyprotein P1234', NULL, NULL, NULL, NULL, NULL, 4),
(58688, NULL, 'G3DSA:3.40.50.300:FF:006572', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58689, NULL, 'G3DSA:3.40.50.720:FF:002387', NULL, NULL, 'Alcohol dehydrogenase, zinc-containing', NULL, NULL, NULL, NULL, NULL, 4),
(58690, NULL, 'G3DSA:3.30.160.60:FF:004621', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58691, NULL, 'G3DSA:2.130.10.10:FF:002379', NULL, NULL, 'Guanine nucleotide-binding protein subunit beta, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58692, NULL, 'G3DSA:3.90.190.10:FF:000014', NULL, NULL, 'receptor-type tyrosine-protein phosphatase U isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(58693, NULL, 'G3DSA:1.25.40.10:FF:001658', NULL, NULL, 'Bardet-Biedl syndrome 4 protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(58694, NULL, 'G3DSA:3.30.70.330:FF:002754', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58695, NULL, 'G3DSA:1.20.1250.20:FF:000820', NULL, NULL, 'Sucrose transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58696, NULL, 'G3DSA:3.30.160.60:FF:000759', NULL, NULL, 'zinc finger protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(58697, NULL, 'G3DSA:3.30.450.70:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58698, NULL, 'G3DSA:3.80.10.10:FF:003059', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58699, NULL, 'G3DSA:3.30.200.20:FF:000465', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 6', NULL, NULL, NULL, NULL, NULL, 4),
(58700, NULL, 'G3DSA:2.10.70.80:FF:000020', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(58701, NULL, 'G3DSA:1.10.10.160:FF:000062', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(58702, NULL, 'G3DSA:1.10.510.10:FF:002903', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58703, NULL, 'G3DSA:1.25.40.20:FF:000138', NULL, NULL, 'leucine-rich repeat serine/threonine-protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(58704, NULL, 'G3DSA:2.60.300.12:FF:000014', NULL, NULL, 'Iron-sulfur cluster assembly accessory protein Isa2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58705, NULL, 'G3DSA:3.30.420.40:FF:000111', NULL, NULL, 'Sedoheptulokinase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(58706, NULL, 'G3DSA:1.25.10.10:FF:002730', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58707, NULL, 'G3DSA:2.10.70.10:FF:000011', NULL, NULL, 'CUB and sushi domain-containing protein 3 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(58708, NULL, 'G3DSA:3.10.20.520:FF:000001', NULL, NULL, 'Phenylacetate-CoA oxygenase, PaaH subunit', NULL, NULL, NULL, NULL, NULL, 4),
(58709, NULL, 'G3DSA:3.90.70.10:FF:000724', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58710, NULL, 'G3DSA:1.20.140.10:FF:000040', NULL, NULL, 'Acyl-CoA dehydrogenase FadE21', NULL, NULL, NULL, NULL, NULL, 4),
(58711, NULL, 'G3DSA:4.10.740.10:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58712, NULL, 'G3DSA:1.10.10.10:FF:000953', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(58713, NULL, 'G3DSA:1.10.238.10:FF:000729', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58714, NULL, 'G3DSA:3.30.160.60:FF:003896', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58715, NULL, 'G3DSA:3.30.470.20:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58716, NULL, 'G3DSA:2.60.40.1910:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58717, NULL, 'G3DSA:3.20.20.70:FF:000736', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58718, NULL, 'G3DSA:3.30.1230.20:FF:000011', NULL, NULL, '40S ribosomal protein S21', NULL, NULL, NULL, NULL, NULL, 4),
(58719, NULL, 'G3DSA:3.40.50.1000:FF:000784', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58720, NULL, 'G3DSA:1.10.287.660:FF:000010', NULL, NULL, 'Isy1 splicing protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(58721, NULL, 'G3DSA:2.60.120.20:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58722, NULL, 'G3DSA:3.30.1370.210:FF:000013', NULL, NULL, 'Zinc finger CCCH domain-containing protein 46', NULL, NULL, NULL, NULL, NULL, 4),
(58723, NULL, 'G3DSA:1.20.920.10:FF:000015', NULL, NULL, 'protein polybromo-1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(58724, NULL, 'G3DSA:3.40.30.10:FF:000196', NULL, NULL, 'Glutathione S-transferase theta-4', NULL, NULL, NULL, NULL, NULL, 4),
(58725, NULL, 'G3DSA:2.30.180.10:FF:000126', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58726, NULL, 'G3DSA:3.40.50.620:FF:000154', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(58727, NULL, 'G3DSA:2.10.90.10:FF:000006', NULL, NULL, 'growth/differentiation factor 8', NULL, NULL, NULL, NULL, NULL, 4),
(58728, NULL, 'G3DSA:3.30.200.20:FF:001893', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58729, NULL, 'G3DSA:3.30.1370.10:FF:000131', NULL, NULL, 'Exosome complex exonuclease RRP40', NULL, NULL, NULL, NULL, NULL, 4),
(58730, NULL, 'G3DSA:3.30.70.370:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58731, NULL, 'G3DSA:2.130.10.10:FF:004672', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(58732, NULL, 'G3DSA:1.25.40.990:FF:000036', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58733, NULL, 'G3DSA:2.60.40.60:FF:000864', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58734, NULL, 'G3DSA:3.30.420.10:FF:000304', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(58735, NULL, 'G3DSA:1.25.40.480:FF:000007', NULL, NULL, 'Fanconi anemia, complementation group E', NULL, NULL, NULL, NULL, NULL, 4),
(58736, NULL, 'G3DSA:1.20.1070.10:FF:000022', NULL, NULL, 'Pituitary adenylate cyclase-activating polypeptide type I receptor', NULL, NULL, NULL, NULL, NULL, 4),
(58737, NULL, 'G3DSA:2.60.40.10:FF:003295', NULL, NULL, 'Leukemia inhibitory factor receptor alpha b', NULL, NULL, NULL, NULL, NULL, 4),
(58738, NULL, 'G3DSA:2.40.30.10:FF:000355', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58739, NULL, 'G3DSA:1.10.555.10:FF:000270', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58740, NULL, 'G3DSA:3.40.970.10:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(58741, NULL, 'G3DSA:3.30.70.330:FF:001326', NULL, NULL, 'Pre-rRNA-processing protein ESF2', NULL, NULL, NULL, NULL, NULL, 4),
(58742, NULL, 'G3DSA:2.30.30.100:FF:000051', NULL, NULL, 'RNA-binding protein Hfq', NULL, NULL, NULL, NULL, NULL, 4),
(58743, NULL, 'G3DSA:3.30.40.10:FF:001287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58744, NULL, 'G3DSA:1.20.120.1750:FF:000151', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(58745, NULL, 'G3DSA:1.25.40.10:FF:002226', NULL, NULL, 'Tetratricopeptide repeat', NULL, NULL, NULL, NULL, NULL, 4),
(58746, NULL, 'G3DSA:2.60.120.40:FF:000029', NULL, NULL, 'Complement C1q tumor necrosis factor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(58747, NULL, 'G3DSA:1.20.120.1420:FF:000001', NULL, NULL, 'Nuclear targeted protein LntA', NULL, NULL, NULL, NULL, NULL, 4),
(58748, NULL, 'G3DSA:4.10.240.10:FF:000010', NULL, NULL, 'Fungal transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(58749, NULL, 'G3DSA:3.30.70.3020:FF:000004', NULL, NULL, 'U3 small nucleolar RNA-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(58750, NULL, 'G3DSA:2.60.40.10:FF:000810', NULL, NULL, 'Tyrosine-protein kinase receptor UFO', NULL, NULL, NULL, NULL, NULL, 4),
(58751, NULL, 'G3DSA:4.10.280.10:FF:000187', NULL, NULL, 'YALI0F05126p', NULL, NULL, NULL, NULL, NULL, 4),
(58752, NULL, 'G3DSA:2.60.120.10:FF:000554', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58753, NULL, 'G3DSA:3.30.160.60:FF:003632', NULL, NULL, 'Zinc finger protein 131', NULL, NULL, NULL, NULL, NULL, 4),
(58754, NULL, 'G3DSA:3.10.100.10:FF:000066', NULL, NULL, 'Lymphocyte antigen 75', NULL, NULL, NULL, NULL, NULL, 4),
(58755, NULL, 'G3DSA:4.10.400.10:FF:000012', NULL, NULL, 'Low-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(58756, NULL, 'G3DSA:3.30.230.10:FF:000121', NULL, NULL, 'Phosphomevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(58757, NULL, 'G3DSA:2.40.50.140:FF:000412', NULL, NULL, '40S ribosomal protein S23', NULL, NULL, NULL, NULL, NULL, 4),
(58758, NULL, 'G3DSA:2.10.110.10:FF:000222', NULL, NULL, 'LIM and senescent cell antigen-like-containing domain protein 2 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(58759, NULL, 'G3DSA:4.10.320.10:FF:000011', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(58760, NULL, 'G3DSA:1.10.357.50:FF:000006', NULL, NULL, 'Exocyst complex component sec6', NULL, NULL, NULL, NULL, NULL, 4),
(58761, NULL, 'G3DSA:2.40.30.10:FF:000198', NULL, NULL, 'Bifunctional cytochrome P450/NADPH--P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(58762, NULL, 'G3DSA:3.90.1290.10:FF:000009', NULL, NULL, 'microtubule-actin cross-linking factor 1 isoform X13', NULL, NULL, NULL, NULL, NULL, 4),
(58763, NULL, 'G3DSA:2.30.29.30:FF:000549', NULL, NULL, 'Nuclear Pore complex Protein', NULL, NULL, NULL, NULL, NULL, 4),
(58764, NULL, 'G3DSA:1.20.1250.20:FF:001466', NULL, NULL, 'Peptide transporter family 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(58765, NULL, 'G3DSA:2.130.10.10:FF:002643', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 16', NULL, NULL, NULL, NULL, NULL, 4),
(58766, NULL, 'G3DSA:3.50.50.60:FF:001392', NULL, NULL, 'Amine oxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58767, NULL, 'G3DSA:3.40.50.720:FF:001139', NULL, NULL, 'Nicotinamide nucleotide transhydrogenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(58768, NULL, 'G3DSA:2.60.200.20:FF:000024', NULL, NULL, 'afadin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(58769, NULL, 'G3DSA:3.40.50.300:FF:004234', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(58770, NULL, 'G3DSA:2.10.25.10:FF:000204', NULL, NULL, 'LDL receptor related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(58771, NULL, 'G3DSA:1.20.1260.10:FF:000025', NULL, NULL, '5-demethoxyubiquinone hydroxylase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(58772, NULL, 'G3DSA:1.10.510.10:FF:004292', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(58773, NULL, 'G3DSA:3.30.160.60:FF:006419', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58774, NULL, 'G3DSA:2.70.130.10:FF:000086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58775, NULL, 'G3DSA:3.30.70.330:FF:000337', NULL, NULL, 'nuclear cap-binding protein subunit 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(58776, NULL, 'G3DSA:1.25.40.10:FF:004564', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58777, NULL, 'G3DSA:2.60.120.200:FF:000534', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(58778, NULL, 'G3DSA:3.40.50.10330:FF:000018', NULL, NULL, 'Probable NAD kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(58779, NULL, 'G3DSA:3.40.1160.10:FF:000079', NULL, NULL, 'Acetylglutamate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(58780, NULL, 'G3DSA:3.30.70.420:FF:000004', NULL, NULL, '3-hydroxy-3-methylglutaryl-coenzyme A reductase 2', NULL, NULL, NULL, NULL, NULL, 4),
(58781, NULL, 'G3DSA:1.10.287.110:FF:000373', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58782, NULL, 'G3DSA:1.10.1740.100:FF:000008', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-36 specific', NULL, NULL, NULL, NULL, NULL, 4),
(58783, NULL, 'G3DSA:1.20.1070.10:FF:002051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58784, NULL, 'G3DSA:2.130.10.10:FF:002755', NULL, NULL, 'SET1-complex chromatin-modification component, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58785, NULL, 'G3DSA:2.60.120.260:FF:000445', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58786, NULL, 'G3DSA:3.30.200.20:FF:000089', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(58787, NULL, 'G3DSA:3.40.50.10190:FF:000105', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(58788, NULL, 'G3DSA:3.40.190.10:FF:000891', NULL, NULL, 'Nodulation protein D 1', NULL, NULL, NULL, NULL, NULL, 4),
(58789, NULL, 'G3DSA:3.90.1170.40:FF:000009', NULL, NULL, 'Molybdopterin-guanine dinucleotide biosynthesis protein MobB', NULL, NULL, NULL, NULL, NULL, 4),
(58790, NULL, 'G3DSA:3.90.640.10:FF:000268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58791, NULL, 'G3DSA:2.130.10.10:FF:001131', NULL, NULL, 'Related to UTP21-U3 snoRNP protein', NULL, NULL, NULL, NULL, NULL, 4),
(58792, NULL, 'G3DSA:2.60.40.10:FF:004284', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58793, NULL, 'G3DSA:3.20.20.10:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58794, NULL, 'G3DSA:1.20.1250.10:FF:000120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58795, NULL, 'G3DSA:2.120.10.80:FF:000135', NULL, NULL, 'Protein GLUTELIN PRECURSOR ACCUMULATION 3', NULL, NULL, NULL, NULL, NULL, 4),
(58796, NULL, 'G3DSA:3.80.10.10:FF:001261', NULL, NULL, 'Si:dkey-191j3.2', NULL, NULL, NULL, NULL, NULL, 4),
(58797, NULL, 'G3DSA:3.30.70.1230:FF:000170', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(58798, NULL, 'G3DSA:2.120.10.80:FF:000247', NULL, NULL, 'Development protein DG1106', NULL, NULL, NULL, NULL, NULL, 4),
(58799, NULL, 'G3DSA:1.25.40.10:FF:002378', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(58800, NULL, 'G3DSA:3.30.710.10:FF:000282', NULL, NULL, 'GM13105', NULL, NULL, NULL, NULL, NULL, 4),
(58801, NULL, 'G3DSA:3.40.30.10:FF:000460', NULL, NULL, 'Thioredoxin-like, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58802, NULL, 'G3DSA:1.20.120.1080:FF:000079', NULL, NULL, 'Putative ATP-dependent DEAD/H RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(58803, NULL, 'G3DSA:3.40.50.1240:FF:000041', NULL, NULL, 'Phosphoglucomutase-2', NULL, NULL, NULL, NULL, NULL, 4),
(58804, NULL, 'G3DSA:2.60.40.2240:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58805, NULL, 'G3DSA:3.90.550.10:FF:000738', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(58806, NULL, 'G3DSA:1.25.10.10:FF:000364', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(58807, NULL, 'G3DSA:1.20.1000.10:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58808, NULL, 'G3DSA:3.40.50.300:FF:002997', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(58809, NULL, 'G3DSA:2.60.40.10:FF:004817', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58810, NULL, 'G3DSA:1.20.990.10:FF:000020', NULL, NULL, 'Sulfite reductase [NADPH] flavoprotein alpha-component', NULL, NULL, NULL, NULL, NULL, 4),
(58811, NULL, 'G3DSA:1.10.510.10:FF:000981', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58812, NULL, 'G3DSA:1.10.418.10:FF:000210', NULL, NULL, 'Microtubule-associated protein RP/EB family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(58813, NULL, 'G3DSA:2.40.50.90:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58814, NULL, 'G3DSA:1.10.930.10:FF:000001', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(58815, NULL, 'G3DSA:2.70.160.11:FF:000100', NULL, NULL, 'Protein arginine Nmethyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58816, NULL, 'G3DSA:3.80.10.10:FF:003447', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58817, NULL, 'G3DSA:1.10.20.140:FF:000001', NULL, NULL, 'tRNA dimethylallyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(58818, NULL, 'G3DSA:2.60.40.10:FF:003407', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58819, NULL, 'G3DSA:3.90.380.10:FF:000017', NULL, NULL, 'Terephthalate 1,2-dioxygenase oxygenase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(58820, NULL, 'G3DSA:2.60.40.10:FF:000574', NULL, NULL, 'neurofascin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(58821, NULL, 'G3DSA:1.25.40.10:FF:003215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58822, NULL, 'G3DSA:1.10.275.30:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58823, NULL, 'G3DSA:3.30.780.10:FF:000056', NULL, NULL, 'Translation machinery-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(58824, NULL, 'G3DSA:1.25.40.20:FF:000402', NULL, NULL, 'Transient receptor potential channel', NULL, NULL, NULL, NULL, NULL, 4),
(58825, NULL, 'G3DSA:2.10.25.10:FF:000047', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(58826, NULL, 'G3DSA:3.40.50.300:FF:005583', NULL, NULL, 'Si:dkey-96f10.1', NULL, NULL, NULL, NULL, NULL, 4),
(58827, NULL, 'G3DSA:3.40.850.10:FF:000216', NULL, NULL, 'Kinesin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58828, NULL, 'G3DSA:1.20.58.60:FF:000757', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58829, NULL, 'G3DSA:1.10.510.10:FF:003623', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58830, NULL, 'G3DSA:2.20.100.10:FF:000112', NULL, NULL, 'Thrombospondin-related apical membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(58831, NULL, 'G3DSA:2.60.40.10:FF:003183', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58832, NULL, 'G3DSA:3.40.50.1370:FF:000029', NULL, NULL, 'Ornithine carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(58833, NULL, 'G3DSA:3.30.450.20:FF:000192', NULL, NULL, 'Sensory box sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(58834, NULL, 'G3DSA:3.30.160.60:FF:006381', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58835, NULL, 'G3DSA:3.30.500.50:FF:000002', NULL, NULL, 'Envelope glycoprotein H', NULL, NULL, NULL, NULL, NULL, 4),
(58836, NULL, 'G3DSA:3.40.50.880:FF:000153', NULL, NULL, 'Anthranilate synthase beta subunit 1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(58837, NULL, 'G3DSA:3.40.50.150:FF:001215', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58838, NULL, 'G3DSA:1.10.510.10:FF:001094', NULL, NULL, 'RIO kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(58839, NULL, 'G3DSA:3.40.50.300:FF:007668', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58840, NULL, 'G3DSA:1.25.40.10:FF:001130', NULL, NULL, 'Clustered mitochondria protein homolog', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(58841, NULL, 'G3DSA:2.60.120.10:FF:000762', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58842, NULL, 'G3DSA:3.40.390.10:FF:000012', NULL, NULL, 'Protein MtfA', NULL, NULL, NULL, NULL, NULL, 4),
(58843, NULL, 'G3DSA:3.40.390.10:FF:000136', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(58844, NULL, 'G3DSA:1.10.730.10:FF:000020', NULL, NULL, 'Leucine--tRNA ligase cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(58845, NULL, 'G3DSA:1.20.5.5270:FF:000002', NULL, NULL, 'Lon protease homolog', NULL, NULL, NULL, NULL, NULL, 4),
(58846, NULL, 'G3DSA:3.30.1640.10:FF:000079', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(58847, NULL, 'G3DSA:3.40.50.1820:FF:001024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58848, NULL, 'G3DSA:3.10.100.10:FF:000178', NULL, NULL, 'GM16582', NULL, NULL, NULL, NULL, NULL, 4),
(58849, NULL, 'G3DSA:3.30.750.24:FF:000090', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(58850, NULL, 'G3DSA:3.40.50.300:FF:002025', NULL, NULL, 'DEAD box helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58851, NULL, 'G3DSA:2.30.29.110:FF:000001', NULL, NULL, 'inositol polyphosphate 5-phosphatase OCRL-1', NULL, NULL, NULL, NULL, NULL, 4),
(58852, NULL, 'G3DSA:1.10.630.10:FF:000748', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58853, NULL, 'G3DSA:1.20.1250.20:FF:001258', NULL, NULL, 'High-affinity glucose transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58854, NULL, 'G3DSA:3.40.50.1780:FF:000034', NULL, NULL, '4Fe-4S ferredoxin iron-sulfur binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(58855, NULL, 'G3DSA:2.30.29.30:FF:000757', NULL, NULL, 'GTPase-activating protein testicular GAP1', NULL, NULL, NULL, NULL, NULL, 4),
(58856, NULL, 'G3DSA:1.25.10.10:FF:001038', NULL, NULL, 'Importin beta-3 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(58857, NULL, 'G3DSA:3.60.10.10:FF:000031', NULL, NULL, 'Calcofluor white hypersensitive protein', NULL, NULL, NULL, NULL, NULL, 4),
(58858, NULL, 'G3DSA:3.90.1150.10:FF:000387', NULL, NULL, 'Probable glycine dehydrogenase (decarboxylating) subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(58859, NULL, 'G3DSA:1.10.540.10:FF:000078', NULL, NULL, 'Acyl-CoA dehydrogenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(58860, NULL, 'G3DSA:2.170.8.10:FF:000005', NULL, NULL, 'Phosphoenolypyruvate CarboxyKinase', NULL, NULL, NULL, NULL, NULL, 4),
(58861, NULL, 'G3DSA:3.40.470.10:FF:000013', NULL, NULL, 'Type-4 uracil-DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(58862, NULL, 'G3DSA:3.30.980.10:FF:000037', NULL, NULL, 'Alanyl-tRNA editing protein AlaX-S', NULL, NULL, NULL, NULL, NULL, 4),
(58863, NULL, 'G3DSA:1.10.1200.10:FF:000086', NULL, NULL, 'Nonribosomal peptide synthase SidC', NULL, NULL, NULL, NULL, NULL, 4),
(58864, NULL, 'G3DSA:1.10.10.10:FF:001201', NULL, NULL, 'RNA polymerase sigma factor sigD, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(58865, NULL, 'G3DSA:2.60.40.10:FF:002608', NULL, NULL, 'KALlmann syndrome homolog', NULL, NULL, NULL, NULL, NULL, 4),
(58866, NULL, 'G3DSA:1.25.40.20:FF:000790', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58867, NULL, 'G3DSA:3.40.50.2000:FF:000140', NULL, NULL, 'L-arabinokinase', NULL, NULL, NULL, NULL, NULL, 4),
(58868, NULL, 'G3DSA:3.30.200.20:FF:002331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58869, NULL, 'G3DSA:3.30.559.30:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58870, NULL, 'G3DSA:3.90.550.10:FF:000109', NULL, NULL, 'Exostosin like glycosyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(58871, NULL, 'G3DSA:1.20.5.340:FF:000019', NULL, NULL, 'Myosin heavy chain, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(58872, NULL, 'G3DSA:3.40.50.1820:FF:001608', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58873, NULL, 'G3DSA:2.30.29.30:FF:000196', NULL, NULL, 'unconventional myosin-X', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(58874, NULL, 'G3DSA:1.20.1270.280:FF:000018', NULL, NULL, 'Dynein heavy chain 4', NULL, NULL, NULL, NULL, NULL, 4),
(58875, NULL, 'G3DSA:2.40.30.10:FF:000434', NULL, NULL, 'Elongation factor Tu C-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(58876, NULL, 'G3DSA:1.10.1410.10:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58877, NULL, 'G3DSA:2.10.25.10:FF:001396', NULL, NULL, 'Basement membrane proteoglycan', NULL, NULL, NULL, NULL, NULL, 4),
(58878, NULL, 'G3DSA:1.10.10.2830:FF:000008', NULL, NULL, 'Chromosome partitioning protein, ParB family', NULL, NULL, NULL, NULL, NULL, 4),
(58879, NULL, 'G3DSA:1.10.510.10:FF:003100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58880, NULL, 'G3DSA:1.20.1050.10:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58881, NULL, 'G3DSA:1.10.472.10:FF:000352', NULL, NULL, 'Cyclin domain-containing protein, variant 1', NULL, NULL, NULL, NULL, NULL, 4),
(58882, NULL, 'G3DSA:3.30.160.60:FF:004733', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58883, NULL, 'G3DSA:1.20.1070.10:FF:001039', NULL, NULL, 'C-X-C motif chemokine receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(58884, NULL, 'G3DSA:2.70.98.50:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58885, NULL, 'G3DSA:3.10.580.20:FF:000003', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(58886, NULL, 'G3DSA:1.20.970.10:FF:000018', NULL, NULL, 'Anthranilate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(58887, NULL, 'G3DSA:3.40.50.10260:FF:000025', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(58888, NULL, 'G3DSA:2.60.120.260:FF:000237', NULL, NULL, 'Uncharacterized protein YdaN', NULL, NULL, NULL, NULL, NULL, 4),
(58889, NULL, 'G3DSA:3.40.50.300:FF:005791', NULL, NULL, 'ATP synthase subunit alpha, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(58890, NULL, 'G3DSA:3.30.40.10:FF:000163', NULL, NULL, 'Putative ring finger protein 37', NULL, NULL, NULL, NULL, NULL, 4),
(58891, NULL, 'G3DSA:2.10.25.10:FF:000940', NULL, NULL, 'Hemolectin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(58892, NULL, 'G3DSA:1.25.40.90:FF:000119', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58893, NULL, 'G3DSA:3.40.50.2300:FF:000336', NULL, NULL, 'Stage II sporulation protein E', NULL, NULL, NULL, NULL, NULL, 4),
(58894, NULL, 'G3DSA:1.25.40.10:FF:003007', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(58895, NULL, 'G3DSA:2.130.10.10:FF:002255', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(58896, NULL, 'G3DSA:3.80.10.10:FF:003970', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58897, NULL, 'G3DSA:2.60.40.10:FF:004076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58898, NULL, 'G3DSA:3.40.50.970:FF:000112', NULL, NULL, 'Dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(58899, NULL, 'G3DSA:3.60.21.10:FF:000455', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58900, NULL, 'G3DSA:3.40.50.1100:FF:000145', NULL, NULL, 'Pyridoxal-5''-phosphate-dependent enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(58901, NULL, 'G3DSA:3.40.50.2020:FF:000022', NULL, NULL, 'Adenine phosphoribosyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(58902, NULL, 'G3DSA:3.30.70.330:FF:000601', NULL, NULL, 'CC1-like, splicing factor', NULL, NULL, NULL, NULL, NULL, 4),
(58903, NULL, 'G3DSA:3.40.50.300:FF:006943', NULL, NULL, 'Elongator complex protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(58904, NULL, 'G3DSA:2.40.10.10:FF:000135', NULL, NULL, 'Coagulation factor II (thrombin)', NULL, NULL, NULL, NULL, NULL, 4),
(58905, NULL, 'G3DSA:2.60.120.330:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58906, NULL, 'G3DSA:3.30.200.20:FF:000589', NULL, NULL, 'Discoidin domain receptor tyrosine kinase 1', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(58907, NULL, 'G3DSA:2.130.10.10:FF:000226', NULL, NULL, 'TBC1 domain family member 31', NULL, NULL, NULL, NULL, NULL, 4),
(58908, NULL, 'G3DSA:4.10.640.10:FF:000018', NULL, NULL, '28S ribosomal protein S18C, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(58909, NULL, 'G3DSA:2.30.29.170:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58910, NULL, 'G3DSA:3.90.660.10:FF:000090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58911, NULL, 'G3DSA:3.40.430.10:FF:000016', NULL, NULL, 'Possible bifunctional enzyme riboflavin biosynthesis protein ribD: diaminohydroxyphosphoribosylaminopyrimidine deaminase + 5-amino-6-(5-phosphoribosylamino)uracil reductase', NULL, NULL, NULL, NULL, NULL, 4),
(58912, NULL, 'G3DSA:2.130.10.10:FF:003891', NULL, NULL, 'Nucleoporin 214', NULL, NULL, NULL, NULL, NULL, 4),
(58913, NULL, 'G3DSA:3.10.20.770:FF:000014', NULL, NULL, 'Phosphatidylinositol 3-kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(58914, NULL, 'G3DSA:3.30.70.330:FF:002630', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58915, NULL, 'G3DSA:1.20.58.60:FF:000257', NULL, NULL, 'Uncharacterized protein, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(58916, NULL, 'G3DSA:2.40.150.20:FF:000018', NULL, NULL, 'Ribosomal protein L14, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58917, NULL, 'G3DSA:3.90.70.10:FF:000089', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(58918, NULL, 'G3DSA:1.10.3210.10:FF:000036', NULL, NULL, 'GTP pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(58919, NULL, 'G3DSA:3.10.129.10:FF:000053', NULL, NULL, 'Probable enoyl-CoA hydratase 1', NULL, NULL, NULL, NULL, NULL, 4),
(58920, NULL, 'G3DSA:3.30.830.10:FF:000049', NULL, NULL, 'Mitochondrial processing peptidase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(58921, NULL, 'G3DSA:1.10.10.60:FF:000215', NULL, NULL, 'dnaJ homolog subfamily C member 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(58922, NULL, 'G3DSA:1.20.120.1770:FF:000022', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58923, NULL, 'G3DSA:3.40.50.10810:FF:000067', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(58924, NULL, 'G3DSA:3.40.50.620:FF:000890', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58925, NULL, 'G3DSA:1.10.3730.20:FF:000005', NULL, NULL, 'Cystine transporter YijE', NULL, NULL, NULL, NULL, NULL, 4),
(58926, NULL, 'G3DSA:3.80.10.10:FF:003239', NULL, NULL, 'F-box protein SKIP28', NULL, NULL, NULL, NULL, NULL, 4),
(58927, NULL, 'G3DSA:1.10.150.50:FF:000190', NULL, NULL, 'Stromal interaction molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(58928, NULL, 'G3DSA:3.40.50.1820:FF:001367', NULL, NULL, 'Os02g0633000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(58929, NULL, 'G3DSA:3.50.50.60:FF:000543', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(58930, NULL, 'G3DSA:2.40.160.40:FF:000002', NULL, NULL, 'N-acetylneuraminic acid outer membrane channel protein NanC', NULL, NULL, NULL, NULL, NULL, 4),
(58931, NULL, 'G3DSA:3.90.640.10:FF:000004', NULL, NULL, 'Heat shock 70 kDa protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(58932, NULL, 'G3DSA:1.20.920.20:FF:000075', NULL, NULL, 'Dynein heavy chain 9', NULL, NULL, NULL, NULL, NULL, 4),
(58933, NULL, 'G3DSA:2.90.10.30:FF:000004', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(58934, NULL, 'G3DSA:1.10.630.10:FF:000405', NULL, NULL, 'Cytochrome P450, putative (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(58935, NULL, 'G3DSA:3.40.930.10:FF:000009', NULL, NULL, 'PTS system, fructose specific IIABC component', NULL, NULL, NULL, NULL, NULL, 4),
(58936, NULL, 'G3DSA:3.40.850.10:FF:000008', NULL, NULL, 'Putative unconventional myosin-IXa', NULL, NULL, NULL, NULL, NULL, 4),
(58937, NULL, 'G3DSA:1.25.10.10:FF:003455', NULL, NULL, 'Maestro heat-like repeat-containing protein family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(58938, NULL, 'G3DSA:2.30.30.40:FF:000443', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(58939, NULL, 'G3DSA:3.40.50.620:FF:000215', NULL, NULL, 'Os03g0241600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(58940, NULL, 'G3DSA:1.25.10.10:FF:000864', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58941, NULL, 'G3DSA:1.25.10.10:FF:002550', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(58942, NULL, 'G3DSA:2.130.10.10:FF:005869', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58943, NULL, 'G3DSA:2.30.280.10:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58944, NULL, 'G3DSA:3.30.160.60:FF:002204', NULL, NULL, 'Zinc finger protein 790', NULL, NULL, NULL, NULL, NULL, 4),
(58945, NULL, 'G3DSA:1.10.238.10:FF:000668', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58946, NULL, 'G3DSA:1.20.890.10:FF:000017', NULL, NULL, 'Hypothetical_protein', NULL, NULL, NULL, NULL, NULL, 4),
(58947, NULL, 'G3DSA:1.10.510.10:FF:001206', NULL, NULL, 'putative receptor-like protein kinase At1g80870', NULL, NULL, NULL, NULL, NULL, 4),
(58948, NULL, 'G3DSA:3.10.20.90:FF:000771', NULL, NULL, 'Autophagy protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(58949, NULL, 'G3DSA:2.40.160.60:FF:000008', NULL, NULL, 'Probable outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(58950, NULL, 'G3DSA:3.80.10.10:FF:002722', NULL, NULL, 'Os06g0185966 protein', NULL, NULL, NULL, NULL, NULL, 4),
(58951, NULL, 'G3DSA:1.20.1060.20:FF:000018', NULL, NULL, 'Structural maintenance of chromosomes protein', NULL, NULL, NULL, NULL, NULL, 4),
(58952, NULL, 'G3DSA:2.120.10.30:FF:000081', NULL, NULL, 'NHL repeat-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(58953, NULL, 'G3DSA:3.40.50.1820:FF:000647', NULL, NULL, 'Serine carboxypeptidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(58954, NULL, 'G3DSA:2.60.200.20:FF:000092', NULL, NULL, 'FHA domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(58955, NULL, 'G3DSA:2.60.40.150:FF:000454', NULL, NULL, 'extended synaptotagmin-2 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(58956, NULL, 'G3DSA:3.60.20.10:FF:000200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58957, NULL, 'G3DSA:1.25.40.280:FF:000003', NULL, NULL, 'RHPN1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(58958, NULL, 'G3DSA:1.10.8.10:FF:000093', NULL, NULL, 'Ubiquitin-associated and SH3 domain-containing protein B', NULL, NULL, NULL, NULL, NULL, 4),
(58959, NULL, 'G3DSA:2.40.50.140:FF:000547', NULL, NULL, '26S protease regulatory subunit 7, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58960, NULL, 'G3DSA:1.10.3260.10:FF:000039', NULL, NULL, 'ATP dependent DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(58961, NULL, 'G3DSA:1.10.3720.10:FF:000119', NULL, NULL, 'ABC transporter permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(58962, NULL, 'G3DSA:3.90.1150.10:FF:000179', NULL, NULL, 'Aminotransferase, class III', NULL, NULL, NULL, NULL, NULL, 4),
(58963, NULL, 'G3DSA:3.20.20.70:FF:000231', NULL, NULL, 'Pyridoxine biosynthetic enzyme pdx1', NULL, NULL, NULL, NULL, NULL, 4),
(58964, NULL, 'G3DSA:4.10.410.20:FF:000010', NULL, NULL, 'Sushi domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(58965, NULL, 'G3DSA:3.30.40.10:FF:001523', NULL, NULL, 'Putative peroxisome assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(58966, NULL, 'G3DSA:2.170.270.10:FF:000055', NULL, NULL, 'PR/SET domain 2', NULL, NULL, NULL, NULL, NULL, 4),
(58967, NULL, 'G3DSA:3.50.50.60:FF:001324', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58968, NULL, 'G3DSA:3.80.10.10:FF:002542', NULL, NULL, 'NLR family CARD domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(58969, NULL, 'G3DSA:3.40.800.10:FF:000005', NULL, NULL, 'Arginase', NULL, NULL, NULL, NULL, NULL, 4),
(58970, NULL, 'G3DSA:2.130.10.10:FF:005689', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58971, NULL, 'G3DSA:2.170.270.10:FF:000179', NULL, NULL, 'PR domain 4', NULL, NULL, NULL, NULL, NULL, 4),
(58972, NULL, 'G3DSA:2.60.40.10:FF:004464', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(58973, NULL, 'G3DSA:2.60.40.10:FF:001327', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(58974, NULL, 'G3DSA:1.20.1270.50:FF:000015', NULL, NULL, 'Lysosomal alpha-mannosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(58975, NULL, 'G3DSA:3.55.50.30:FF:000029', NULL, NULL, 'Fec operon regulator FecR', NULL, NULL, NULL, NULL, NULL, 4),
(58976, NULL, 'G3DSA:1.20.1250.20:FF:002265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58977, NULL, 'G3DSA:1.10.20.10:FF:000010', NULL, NULL, 'Histone H3', NULL, NULL, NULL, NULL, NULL, 4),
(58978, NULL, 'G3DSA:3.40.50.10490:FF:000156', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58979, NULL, 'G3DSA:2.30.30.30:FF:000002', NULL, NULL, 'Transcription termination/antitermination factor NusG', NULL, NULL, NULL, NULL, NULL, 4),
(58980, NULL, 'G3DSA:1.20.5.170:FF:000126', NULL, NULL, 'Unplaced genomic scaffold supercont1.19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(58981, NULL, 'G3DSA:3.40.920.10:FF:000003', NULL, NULL, 'Pyruvate ferredoxin oxidoreductase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(58982, NULL, 'G3DSA:3.30.160.60:FF:004413', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58983, NULL, 'G3DSA:3.40.50.300:FF:000844', NULL, NULL, 'Nuclear GTP-binding protein NUG1', NULL, NULL, NULL, NULL, NULL, 4),
(58984, NULL, 'G3DSA:1.20.5.860:FF:000001', NULL, NULL, 'Cytochrome b559 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(58985, NULL, 'G3DSA:3.30.43.10:FF:000012', NULL, NULL, 'Cytokinin dehydrogenase 7', NULL, NULL, NULL, NULL, NULL, 4),
(58986, NULL, 'G3DSA:1.10.10.10:FF:000745', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(58987, NULL, 'G3DSA:3.40.390.10:FF:000080', NULL, NULL, 'A disintegrin and metallopeptidase domain 30', NULL, NULL, NULL, NULL, NULL, 4),
(58988, NULL, 'G3DSA:1.25.40.10:FF:000192', NULL, NULL, 'G-protein-signaling modulator 1 isoform a', NULL, NULL, NULL, NULL, NULL, 4),
(58989, NULL, 'G3DSA:2.170.300.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(58990, NULL, 'G3DSA:3.40.50.1820:FF:000086', NULL, NULL, 'Diacylglycerol acyltransferase/mycolyltransferase Ag85C', NULL, NULL, NULL, NULL, NULL, 4),
(58991, NULL, 'G3DSA:1.10.8.60:FF:000467', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58992, NULL, 'G3DSA:3.90.70.10:FF:000224', NULL, NULL, 'GM06507p', NULL, NULL, NULL, NULL, NULL, 4),
(58993, NULL, 'G3DSA:2.60.120.290:FF:000100', NULL, NULL, 'RIKEN cDNA 5430419D17 gene', NULL, NULL, NULL, NULL, NULL, 4),
(58994, NULL, 'G3DSA:1.10.890.20:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(58995, NULL, 'G3DSA:3.40.50.300:FF:008606', NULL, NULL, 'Peroxisome biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(58996, NULL, 'G3DSA:1.20.1070.10:FF:000994', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(58997, NULL, 'G3DSA:2.60.120.380:FF:000094', NULL, NULL, 'Alpha-xylosidase BoGH31A', NULL, NULL, NULL, NULL, NULL, 4),
(58998, NULL, 'G3DSA:1.10.10.10:FF:000869', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(58999, NULL, 'G3DSA:3.30.420.10:FF:000647', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59000, NULL, 'G3DSA:2.70.170.10:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59001, NULL, 'G3DSA:1.20.1070.10:FF:001270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59002, NULL, 'G3DSA:3.40.350.10:FF:000015', NULL, NULL, 'Xaa-Pro aminopeptidase app-1', NULL, NULL, NULL, NULL, NULL, 4),
(59003, NULL, 'G3DSA:3.40.50.300:FF:000968', NULL, NULL, 'Helicase and polymerase-containing protein TEBICHI', NULL, NULL, NULL, NULL, NULL, 4),
(59004, NULL, 'G3DSA:1.10.238.100:FF:000001', NULL, NULL, 'BZIP transcription factor (AP-1)', NULL, NULL, NULL, NULL, NULL, 4),
(59005, NULL, 'G3DSA:3.40.50.300:FF:005515', NULL, NULL, 'ATP-dependent DEAD/H RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59006, NULL, 'G3DSA:3.40.50.720:FF:001870', NULL, NULL, 'Uncharacterized oxidoreductase C19A8.06', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(59007, NULL, 'G3DSA:3.40.1190.20:FF:000185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59008, NULL, 'G3DSA:3.40.50.410:FF:000260', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59009, NULL, 'G3DSA:1.25.40.460:FF:000001', NULL, NULL, 'Teg12', NULL, NULL, NULL, NULL, NULL, 4),
(59010, NULL, 'G3DSA:3.60.21.10:FF:000112', NULL, NULL, 'YNL217W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(59011, NULL, 'G3DSA:1.10.3020.20:FF:000002', NULL, NULL, 'CocE/NonD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(59012, NULL, 'G3DSA:2.40.50.960:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59013, NULL, 'G3DSA:3.40.50.720:FF:000234', NULL, NULL, '2-hydroxyacid dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59014, NULL, 'G3DSA:3.40.50.1000:FF:000845', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59015, NULL, 'G3DSA:1.20.140.20:FF:000009', NULL, NULL, '[pyruvate dehydrogenase [lipoamide]] kinase, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59016, NULL, 'G3DSA:1.25.40.10:FF:003283', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(59017, NULL, 'G3DSA:1.10.510.10:FF:001998', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59018, NULL, 'G3DSA:3.90.550.50:FF:000161', NULL, NULL, 'Hydroxyproline O-galactosyltransferase GALT4', NULL, NULL, NULL, NULL, NULL, 4),
(59019, NULL, 'G3DSA:1.25.40.10:FF:000933', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(59020, NULL, 'G3DSA:3.10.20.340:FF:000003', NULL, NULL, 'Arginine biosynthesis bifunctional protein ArgJ', NULL, NULL, NULL, NULL, NULL, 4),
(59021, NULL, 'G3DSA:3.40.50.10880:FF:000003', NULL, NULL, 'Pantothenate kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(59022, NULL, 'G3DSA:1.10.510.10:FF:003235', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59023, NULL, 'G3DSA:3.80.10.10:FF:003391', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59024, NULL, 'G3DSA:3.30.70.260:FF:000001', NULL, NULL, 'Acetolactate synthase, small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(59025, NULL, 'G3DSA:2.30.30.40:FF:000623', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59026, NULL, 'G3DSA:3.10.100.10:FF:000419', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59027, NULL, 'G3DSA:1.25.10.10:FF:001302', NULL, NULL, 'Exportin-6', NULL, NULL, NULL, NULL, NULL, 4),
(59028, NULL, 'G3DSA:3.40.50.300:FF:003453', NULL, NULL, '26S protease regulatory subunit 6A', NULL, NULL, NULL, NULL, NULL, 4),
(59029, NULL, 'G3DSA:1.20.5.1000:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59030, NULL, 'G3DSA:2.20.110.10:FF:000017', NULL, NULL, 'ALS2 C-terminal like', NULL, NULL, NULL, NULL, NULL, 4),
(59031, NULL, 'G3DSA:3.30.1240.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59032, NULL, 'G3DSA:3.30.260.10:FF:000084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59033, NULL, 'G3DSA:3.40.50.80:FF:000111', NULL, NULL, 'Respiratory burst oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(59034, NULL, 'G3DSA:3.30.70.330:FF:001118', NULL, NULL, 'Nucleolin like 2', NULL, NULL, NULL, NULL, NULL, 4),
(59035, NULL, 'G3DSA:3.10.129.10:FF:000233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59036, NULL, 'G3DSA:3.30.450.40:FF:000282', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(59037, NULL, 'G3DSA:1.25.40.10:FF:004643', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(59038, NULL, 'G3DSA:3.30.200.20:FF:000201', NULL, NULL, 'TP53-regulating kinase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(59039, NULL, 'G3DSA:3.40.50.150:FF:000434', NULL, NULL, 'Arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(59040, NULL, 'G3DSA:1.50.40.10:FF:000577', NULL, NULL, 'Solute carrier family 25 (mitochondrial carrier; phosphate carrier), member 24, like', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(59041, NULL, 'G3DSA:3.40.50.720:FF:000358', NULL, NULL, 'NADH-ubiquinone oxidoreductase 39 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(59042, NULL, 'G3DSA:3.65.10.20:FF:000001', NULL, NULL, 'RNA terminal phosphate cyclase-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(59043, NULL, 'G3DSA:3.90.1010.10:FF:000017', NULL, NULL, 'Iron-sulfur cluster assembly scaffold protein', NULL, NULL, NULL, NULL, NULL, 4),
(59044, NULL, 'G3DSA:2.130.10.30:FF:000120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59045, NULL, 'G3DSA:2.60.220.50:FF:000130', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59046, NULL, 'G3DSA:2.40.50.140:FF:000204', NULL, NULL, '30S ribosomal protein S17', NULL, NULL, NULL, NULL, NULL, 4),
(59047, NULL, 'G3DSA:1.10.275.40:FF:000004', NULL, NULL, 'DNA repair helicase RAD3', NULL, NULL, NULL, NULL, NULL, 4),
(59048, NULL, 'G3DSA:3.40.50.300:FF:002093', NULL, NULL, 'Structural maintenance of chromosomes protein', NULL, NULL, NULL, NULL, NULL, 4),
(59049, NULL, 'G3DSA:3.40.50.300:FF:008388', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59050, NULL, 'G3DSA:1.10.1520.10:FF:000014', NULL, NULL, '60S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(59051, NULL, 'G3DSA:3.30.710.10:FF:000462', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59052, NULL, 'G3DSA:1.25.40.20:FF:001830', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(59053, NULL, 'G3DSA:1.10.510.10:FF:001026', NULL, NULL, 'probable L-type lectin-domain containing receptor kinase S.5', NULL, NULL, NULL, NULL, NULL, 4),
(59054, NULL, 'G3DSA:2.90.20.10:FF:000004', NULL, NULL, 'Wall-associated receptor kinase-like 18', NULL, NULL, NULL, NULL, NULL, 4),
(59055, NULL, 'G3DSA:3.30.160.20:FF:000242', NULL, NULL, 'Mitochondrial translation release factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(59056, NULL, 'G3DSA:1.10.1600.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59057, NULL, 'G3DSA:3.90.550.10:FF:000385', NULL, NULL, 'Glycoside transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(59058, NULL, 'G3DSA:1.10.150.80:FF:000030', NULL, NULL, 'Ribonuclease D', NULL, NULL, NULL, NULL, NULL, 4),
(59059, NULL, 'G3DSA:2.60.40.150:FF:000797', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59060, NULL, 'G3DSA:2.30.42.10:FF:000294', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(59061, NULL, 'G3DSA:1.25.40.20:FF:000470', NULL, NULL, 'Suppressor protein SPT23, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59062, NULL, 'G3DSA:3.30.450.20:FF:000124', NULL, NULL, 'uncharacterized protein LOC108093306', NULL, NULL, NULL, NULL, NULL, 4),
(59063, NULL, 'G3DSA:1.10.287.600:FF:000020', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(59064, NULL, 'G3DSA:3.40.50.1000:FF:000284', NULL, NULL, 'Nuclear LIM interactor-interacting factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(59065, NULL, 'G3DSA:3.40.30.10:FF:001213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59066, NULL, 'G3DSA:1.20.5.1430:FF:000013', NULL, NULL, 'Microtubule-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59067, NULL, 'G3DSA:3.40.630.30:FF:000526', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(59068, NULL, 'G3DSA:3.30.40.10:FF:001787', NULL, NULL, 'Ubiquitination factor E4a, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59069, NULL, 'G3DSA:3.30.200.20:FF:002270', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59070, NULL, 'G3DSA:1.10.238.10:FF:001106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59071, NULL, 'G3DSA:1.10.540.10:FF:000022', NULL, NULL, 'Isovaleryl-CoA dehydrogenase isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(59072, NULL, 'G3DSA:3.80.10.10:FF:001710', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', NULL, NULL, NULL, NULL, NULL, 4),
(59073, NULL, 'G3DSA:3.40.190.10:FF:000323', NULL, NULL, 'Related to HEM3-porphobilinogen deaminase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(59074, NULL, 'G3DSA:1.10.357.110:FF:000002', NULL, NULL, 'Vacuolar protein sorting-associated protein 53 A', NULL, NULL, NULL, NULL, NULL, 4),
(59075, NULL, 'G3DSA:1.25.40.10:FF:000910', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g14080', NULL, NULL, NULL, NULL, NULL, 4),
(59076, NULL, 'G3DSA:3.30.500.10:FF:000013', NULL, NULL, 'Histocompatibility 2, blastocyst', NULL, NULL, NULL, NULL, NULL, 4),
(59077, NULL, 'G3DSA:3.40.309.10:FF:000116', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59078, NULL, 'G3DSA:2.130.10.10:FF:001631', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(59079, NULL, 'G3DSA:3.30.420.40:FF:000403', NULL, NULL, 'Actin 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(59080, NULL, 'G3DSA:3.40.190.10:FF:000267', NULL, NULL, 'HTH-type transcriptional regulator HdfR', NULL, NULL, NULL, NULL, NULL, 4),
(59081, NULL, 'G3DSA:3.50.50.60:FF:000312', NULL, NULL, 'GMC-type oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(59082, NULL, 'G3DSA:3.30.40.10:FF:001967', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59083, NULL, 'G3DSA:1.20.58.400:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59084, NULL, 'G3DSA:2.60.40.60:FF:000527', NULL, NULL, 'Dachsous cadherin-related 1a', NULL, NULL, NULL, NULL, NULL, 4),
(59085, NULL, 'G3DSA:3.40.630.10:FF:000352', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59086, NULL, 'G3DSA:2.60.40.10:FF:003744', NULL, NULL, 'Cellulose 1,4-beta-cellobiosidase', NULL, NULL, NULL, NULL, NULL, 4),
(59087, NULL, 'G3DSA:2.40.70.10:FF:000032', NULL, NULL, 'renin', NULL, NULL, NULL, NULL, NULL, 4),
(59088, NULL, 'G3DSA:1.10.287.1250:FF:000002', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(59089, NULL, 'G3DSA:3.30.70.330:FF:000949', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(59090, NULL, 'G3DSA:1.25.40.1050:FF:000001', NULL, NULL, '5''-3'' exoribonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(59091, NULL, 'G3DSA:3.80.10.10:FF:002166', NULL, NULL, 'GM14094', NULL, NULL, NULL, NULL, NULL, 4),
(59092, NULL, 'G3DSA:1.10.940.10:FF:000007', NULL, NULL, 'rRNA cytosine-C5-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(59093, NULL, 'G3DSA:3.80.10.10:FF:002222', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59094, NULL, 'G3DSA:2.60.40.10:FF:003800', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59095, NULL, 'G3DSA:1.10.510.10:FF:003174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59096, NULL, 'G3DSA:3.30.200.20:FF:000706', NULL, NULL, 'Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(59097, NULL, 'G3DSA:3.40.50.300:FF:007432', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59098, NULL, 'G3DSA:3.30.160.60:FF:000574', NULL, NULL, 'sal-like protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(59099, NULL, 'G3DSA:1.25.40.10:FF:001366', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(59100, NULL, 'G3DSA:3.40.50.1360:FF:000060', NULL, NULL, '6-phosphogluconolactonase', NULL, NULL, NULL, NULL, NULL, 4),
(59101, NULL, 'G3DSA:2.40.30.170:FF:000030', NULL, NULL, 'Membrane fusion protein (MFP) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(59102, NULL, 'G3DSA:2.60.120.1190:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59103, NULL, 'G3DSA:1.20.1270.60:FF:000052', NULL, NULL, 'Rho GTPase activating protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(59104, NULL, 'G3DSA:3.30.70.330:FF:003030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59105, NULL, 'G3DSA:3.30.230.70:FF:000116', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59106, NULL, 'G3DSA:1.20.120.520:FF:000016', NULL, NULL, 'Glutaredoxin/malate transporter fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(59107, NULL, 'G3DSA:3.90.70.10:FF:000909', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(59108, NULL, 'G3DSA:3.90.1150.10:FF:000466', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59109, NULL, 'G3DSA:4.10.240.10:FF:000089', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(59110, NULL, 'G3DSA:3.30.540.10:FF:000066', NULL, NULL, 'Probable inositol-1(Or 4)-monophosphatase / fructose-1,6-bisphosphatase, archaeal-type', NULL, NULL, NULL, NULL, NULL, 4),
(59111, NULL, 'G3DSA:2.60.120.650:FF:000023', NULL, NULL, 'Probable lysine-specific demethylase ELF6', NULL, NULL, NULL, NULL, NULL, 4),
(59112, NULL, 'G3DSA:1.20.120.1900:FF:000050', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(59113, NULL, 'G3DSA:3.80.10.10:FF:002273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59114, NULL, 'G3DSA:3.30.70.100:FF:000049', NULL, NULL, 'copper-transporting ATPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(59115, NULL, 'G3DSA:3.10.310.10:FF:000008', NULL, NULL, 'Trans-L-3-hydroxyproline dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(59116, NULL, 'G3DSA:3.40.50.720:FF:002151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59117, NULL, 'G3DSA:2.130.10.10:FF:002143', NULL, NULL, 'Brevis plant1', NULL, NULL, NULL, NULL, NULL, 4),
(59118, NULL, 'G3DSA:3.50.50.60:FF:001509', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59119, NULL, 'G3DSA:3.40.50.300:FF:006920', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59120, NULL, 'G3DSA:3.10.129.10:FF:000284', NULL, NULL, 'Probable enoyl-CoA hydratase 2', NULL, NULL, NULL, NULL, NULL, 4),
(59121, NULL, 'G3DSA:3.30.420.10:FF:000012', NULL, NULL, 'DNA polymerase III subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(59122, NULL, 'G3DSA:3.20.190.10:FF:000018', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59123, NULL, 'G3DSA:3.30.160.270:FF:000007', NULL, NULL, '2-isopropylmalate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(59124, NULL, 'G3DSA:1.10.510.10:FF:004409', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59125, NULL, 'G3DSA:2.10.25.10:FF:001373', NULL, NULL, 'Fibropellin-1', NULL, NULL, NULL, NULL, NULL, 4),
(59126, NULL, 'G3DSA:1.10.510.10:FF:003123', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59127, NULL, 'G3DSA:1.10.540.10:FF:000073', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(59128, NULL, 'G3DSA:3.90.226.10:FF:000171', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(59129, NULL, 'G3DSA:2.30.18.10:FF:000018', NULL, NULL, 'Transcription initiation factor IIA subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(59130, NULL, 'G3DSA:3.40.50.300:FF:000288', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(59131, NULL, 'G3DSA:1.10.560.10:FF:000080', NULL, NULL, 'TCP-1 chaperonin subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(59132, NULL, 'G3DSA:2.40.50.100:FF:000215', NULL, NULL, 'Cytoplasmic membrane protein for maltose uptake', NULL, NULL, NULL, NULL, NULL, 4),
(59133, NULL, 'G3DSA:1.25.10.10:FF:001538', NULL, NULL, 'V-type proton ATPase subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(59134, NULL, 'G3DSA:3.80.20.20:FF:000011', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(59135, NULL, 'G3DSA:3.30.160.60:FF:003340', NULL, NULL, 'Zinc finger protein 574', NULL, NULL, NULL, NULL, NULL, 4),
(59136, NULL, 'G3DSA:1.20.58.1120:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59137, NULL, 'G3DSA:2.130.10.10:FF:002194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59138, NULL, 'G3DSA:3.40.30.10:FF:001264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59139, NULL, 'G3DSA:3.10.28.10:FF:000051', NULL, NULL, 'Probable intron-encoded endonuclease aI3', NULL, NULL, NULL, NULL, NULL, 4),
(59140, NULL, 'G3DSA:1.25.40.10:FF:001473', NULL, NULL, 'Os08g0162200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(59141, NULL, 'G3DSA:1.10.1320.10:FF:000010', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(59142, NULL, 'G3DSA:1.20.59.10:FF:000014', NULL, NULL, 'Chorismate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(59143, NULL, 'G3DSA:3.40.50.300:FF:002593', NULL, NULL, 'SNF2 family helicase/ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59144, NULL, 'G3DSA:3.40.50.300:FF:007325', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59145, NULL, 'G3DSA:3.40.50.10810:FF:000235', NULL, NULL, 'Protein CHROMATIN REMODELING 24', NULL, NULL, NULL, NULL, NULL, 4),
(59146, NULL, 'G3DSA:2.60.120.200:FF:000293', NULL, NULL, 'NeuReXin related', NULL, NULL, NULL, NULL, NULL, 4),
(59147, NULL, 'G3DSA:3.40.50.300:FF:006864', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NUBP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(59148, NULL, 'G3DSA:3.30.1640.10:FF:000056', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(59149, NULL, 'G3DSA:4.10.240.10:FF:000145', NULL, NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(59150, NULL, 'G3DSA:2.130.10.10:FF:002087', NULL, NULL, 'Intraflagellar transport protein 122', NULL, NULL, NULL, NULL, NULL, 4),
(59151, NULL, 'G3DSA:1.20.1070.10:FF:001831', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59152, NULL, 'G3DSA:3.100.10.10:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59153, NULL, 'G3DSA:3.30.300.130:FF:000021', NULL, NULL, 'BnaA04g19200D protein', NULL, NULL, NULL, NULL, NULL, 4),
(59154, NULL, 'G3DSA:3.90.79.20:FF:000022', NULL, NULL, 'NAD+ diphosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59155, NULL, 'G3DSA:3.30.70.920:FF:000008', NULL, NULL, 'Transcriptional regulator, AsnC family', NULL, NULL, NULL, NULL, NULL, 4),
(59156, NULL, 'G3DSA:3.30.200.20:FF:000757', NULL, NULL, 'Serine/threonine-protein kinase SSN3', NULL, NULL, NULL, NULL, NULL, 4),
(59157, NULL, 'G3DSA:3.30.9.10:FF:000158', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(59158, NULL, 'G3DSA:3.40.50.1980:FF:000026', NULL, NULL, 'Histidinol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(59159, NULL, 'G3DSA:1.10.8.60:FF:000523', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59160, NULL, 'G3DSA:3.30.230.10:FF:000256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59161, NULL, 'G3DSA:2.60.40.4100:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59162, NULL, 'G3DSA:2.60.40.60:FF:000572', NULL, NULL, 'Cadherin 15, type 1, M-cadherin (myotubule)', NULL, NULL, NULL, NULL, NULL, 4),
(59163, NULL, 'G3DSA:3.90.550.10:FF:000497', NULL, NULL, 'Nucleotide-diphospho-sugar transferase', NULL, NULL, NULL, NULL, NULL, 4),
(59164, NULL, 'G3DSA:3.60.15.10:FF:000227', NULL, NULL, 'Cleavage and polyadenylation specificity factor 73-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(59165, NULL, 'G3DSA:1.10.630.10:FF:000248', NULL, NULL, 'Cytochrome p450-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(59166, NULL, 'G3DSA:1.50.40.10:FF:000341', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59167, NULL, 'G3DSA:3.30.70.330:FF:002462', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59168, NULL, 'G3DSA:3.30.450.40:FF:000231', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(59169, NULL, 'G3DSA:3.80.10.10:FF:000709', NULL, NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(59170, NULL, 'G3DSA:3.40.50.720:FF:002095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59171, NULL, 'G3DSA:1.10.640.10:FF:000081', NULL, NULL, 'Peroxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59172, NULL, 'G3DSA:3.30.565.10:FF:000325', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(59173, NULL, 'G3DSA:1.20.1070.10:FF:000314', NULL, NULL, 'Adenosine receptor, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(59174, NULL, 'G3DSA:3.60.21.10:FF:000376', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(59175, NULL, 'G3DSA:3.30.559.10:FF:000272', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59176, NULL, 'G3DSA:1.20.85.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59177, NULL, 'G3DSA:3.40.50.2000:FF:000640', NULL, NULL, 'O-antigen polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(59178, NULL, 'G3DSA:3.40.50.620:FF:000715', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59179, NULL, 'G3DSA:3.30.50.10:FF:000040', NULL, NULL, 'GATA-type zinc finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(59180, NULL, 'G3DSA:1.10.472.80:FF:000120', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(59181, NULL, 'G3DSA:3.30.1380.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59182, NULL, 'G3DSA:2.130.10.10:FF:002879', NULL, NULL, 'Denticleless protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(59183, NULL, 'G3DSA:3.30.565.10:FF:000157', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(59184, NULL, 'G3DSA:3.40.50.280:FF:000006', NULL, NULL, 'Methionine synthase (B12-dependent)', NULL, NULL, NULL, NULL, NULL, 4),
(59185, NULL, 'G3DSA:1.25.40.10:FF:002726', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59186, NULL, 'G3DSA:3.40.50.2300:FF:000691', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59187, NULL, 'G3DSA:3.30.9.10:FF:000265', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59188, NULL, 'G3DSA:1.10.238.10:FF:000168', NULL, NULL, 'Solute carrier family 25 member 24', NULL, NULL, NULL, NULL, NULL, 4),
(59189, NULL, 'G3DSA:2.20.70.10:FF:000246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59190, NULL, 'G3DSA:1.25.40.20:FF:001751', NULL, NULL, 'Phosphocholine transferase AnkX', NULL, NULL, NULL, NULL, NULL, 4),
(59191, NULL, 'G3DSA:3.30.70.330:FF:000101', NULL, NULL, 'Protein MEI2-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(59192, NULL, 'G3DSA:1.10.10.10:FF:001066', NULL, NULL, 'Cullin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(59193, NULL, 'G3DSA:3.40.50.2000:FF:000752', NULL, NULL, 'UGT protein', NULL, NULL, NULL, NULL, NULL, 4),
(59194, NULL, 'G3DSA:3.30.40.10:FF:000663', NULL, NULL, 'Histone-lysine N-methyltransferase NSD2', NULL, NULL, NULL, NULL, NULL, 4),
(59195, NULL, 'G3DSA:3.40.50.300:FF:003958', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(59196, NULL, 'G3DSA:2.130.10.10:FF:003503', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(59197, NULL, 'G3DSA:2.30.29.90:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59198, NULL, 'G3DSA:3.90.70.10:FF:000168', NULL, NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', NULL, NULL, NULL, NULL, NULL, 4),
(59199, NULL, 'G3DSA:1.20.1560.10:FF:000222', NULL, NULL, 'ABC transporter B family member 19 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(59200, NULL, 'G3DSA:3.30.70.1730:FF:000050', NULL, NULL, '54S ribosomal protein L11, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(59201, NULL, 'G3DSA:3.40.50.300:FF:001300', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor CFD1', NULL, NULL, NULL, NULL, NULL, 4),
(59202, NULL, 'G3DSA:2.60.120.290:FF:000123', NULL, NULL, 'GD12774', NULL, NULL, NULL, NULL, NULL, 4),
(59203, NULL, 'G3DSA:3.10.110.10:FF:000027', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 36', NULL, NULL, NULL, NULL, NULL, 4),
(59204, NULL, 'G3DSA:2.70.170.10:FF:000268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59205, NULL, 'G3DSA:2.10.25.10:FF:000024', NULL, NULL, 'Putative latent-transforming growth factor beta-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(59206, NULL, 'G3DSA:3.30.70.2170:FF:000002', NULL, NULL, 'V-type ATP synthase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(59207, NULL, 'G3DSA:1.20.200.10:FF:000039', NULL, NULL, 'Adenylosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(59208, NULL, 'G3DSA:3.90.1750.10:FF:000028', NULL, NULL, 'HECT E3 ubiquitin ligase', NULL, NULL, NULL, NULL, NULL, 4),
(59209, NULL, 'G3DSA:2.170.150.10:FF:000001', NULL, NULL, 'Tumor protein, translationally-controlled 1', NULL, NULL, NULL, NULL, NULL, 4),
(59210, NULL, 'G3DSA:3.30.40.10:FF:001231', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(59211, NULL, 'G3DSA:3.40.850.10:FF:000239', NULL, NULL, 'Kinesin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59212, NULL, 'G3DSA:3.40.50.1820:FF:001760', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59213, NULL, 'G3DSA:1.20.120.730:FF:000012', NULL, NULL, 'Protein transport protein Sec24A', NULL, NULL, NULL, NULL, NULL, 4),
(59214, NULL, 'G3DSA:3.30.450.50:FF:000060', NULL, NULL, 'Synaptobrevin', NULL, NULL, NULL, NULL, NULL, 4),
(59215, NULL, 'G3DSA:3.30.40.10:FF:000118', NULL, NULL, 'Putative polycomb group RING finger protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(59216, NULL, 'G3DSA:3.40.50.1240:FF:000046', NULL, NULL, 'Phosphoglycerate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(59217, NULL, 'G3DSA:1.10.510.10:FF:000245', NULL, NULL, 'serine/threonine-protein kinase STK11', NULL, NULL, NULL, NULL, NULL, 4),
(59218, NULL, 'G3DSA:3.40.50.11260:FF:000016', NULL, NULL, 'Hsp90 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(59219, NULL, 'G3DSA:3.90.550.10:FF:000441', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59220, NULL, 'G3DSA:1.25.40.720:FF:000012', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59221, NULL, 'G3DSA:3.90.550.10:FF:000553', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59222, NULL, 'G3DSA:3.40.50.300:FF:003902', NULL, NULL, 'RE19845p', NULL, NULL, NULL, NULL, NULL, 4),
(59223, NULL, 'G3DSA:1.20.1250.20:FF:000185', NULL, NULL, 'sodium-dependent lysophosphatidylcholine symporter 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(59224, NULL, 'G3DSA:3.40.1350.10:FF:000026', NULL, NULL, 'tRNA-splicing endonuclease subunit Sen2', NULL, NULL, NULL, NULL, NULL, 4),
(59225, NULL, 'G3DSA:1.25.40.20:FF:000638', NULL, NULL, 'WGS project CABT00000000 data, contig 2.8', NULL, NULL, NULL, NULL, NULL, 4),
(59226, NULL, 'G3DSA:1.10.357.10:FF:000017', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(59227, NULL, 'G3DSA:1.50.10.20:FF:000050', NULL, NULL, 'Geranylgeranyl transferase type-1 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(59228, NULL, 'G3DSA:1.10.510.10:FF:004516', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59229, NULL, 'G3DSA:1.20.1070.10:FF:001775', NULL, NULL, 'Olfactory receptor 282', NULL, NULL, NULL, NULL, NULL, 4),
(59230, NULL, 'G3DSA:3.30.160.60:FF:006206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59231, NULL, 'G3DSA:3.30.300.30:FF:000127', NULL, NULL, 'Acetyl-CoA synthetase (Acetate-CoA ligase) carboxy-end. (AcsA-3)', NULL, NULL, NULL, NULL, NULL, 4),
(59232, NULL, 'G3DSA:1.50.40.10:FF:000397', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59233, NULL, 'G3DSA:3.90.226.10:FF:000019', NULL, NULL, 'Enoyl-CoA hydratase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(59234, NULL, 'G3DSA:3.30.450.40:FF:000175', NULL, NULL, 'Regulator of polyketide synthase expression', NULL, NULL, NULL, NULL, NULL, 4),
(59235, NULL, 'G3DSA:3.80.10.10:FF:001761', NULL, NULL, 'Toll-like receptor 19', NULL, NULL, NULL, NULL, NULL, 4),
(59236, NULL, 'G3DSA:1.10.10.10:FF:000976', NULL, NULL, 'Protein CBG12577', NULL, NULL, NULL, NULL, NULL, 4),
(59237, NULL, 'G3DSA:1.20.120.1750:FF:000072', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(59238, NULL, 'G3DSA:1.10.460.10:FF:000021', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(59239, NULL, 'G3DSA:1.20.1070.10:FF:002175', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59240, NULL, 'G3DSA:3.30.1370.50:FF:000013', NULL, NULL, 'Unplaced genomic scaffold supercont2.5, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(59241, NULL, 'G3DSA:1.50.40.10:FF:000285', NULL, NULL, 'Peroxisomal membrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59242, NULL, 'G3DSA:1.10.1370.40:FF:000005', NULL, NULL, 'Organellar oligopeptidase A, chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(59243, NULL, 'G3DSA:1.20.58.60:FF:000021', NULL, NULL, 'Microtubule-actin cross-linking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(59244, NULL, 'G3DSA:1.10.441.10:FF:000005', NULL, NULL, 'Mannose-6-phosphate isomerase, class I', NULL, NULL, NULL, NULL, NULL, 4),
(59245, NULL, 'G3DSA:3.40.120.10:FF:000049', NULL, NULL, 'Phosphoacetylglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(59246, NULL, 'G3DSA:3.10.129.10:FF:000177', NULL, NULL, '4-hydroxybenzoyl-CoA thioesterase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(59247, NULL, 'G3DSA:2.60.40.10:FF:003795', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59248, NULL, 'G3DSA:1.10.510.10:FF:003067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59249, NULL, 'G3DSA:3.40.50.300:FF:003161', NULL, NULL, 'Protein Rep68', NULL, NULL, NULL, NULL, NULL, 4),
(59250, NULL, 'G3DSA:3.40.50.12440:FF:000005', NULL, NULL, 'Nitrate reductase NarX', NULL, NULL, NULL, NULL, NULL, 4),
(59251, NULL, 'G3DSA:3.30.160.60:FF:003396', NULL, NULL, 'Zinc finger protein GLIS2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(59252, NULL, 'G3DSA:3.40.50.300:FF:000176', NULL, NULL, 'bifunctional heparan sulfate N-deacetylase/N-sulfotransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(59253, NULL, 'G3DSA:3.40.50.300:FF:004447', NULL, NULL, 'Replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(59254, NULL, 'G3DSA:3.40.30.10:FF:000696', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(59255, NULL, 'G3DSA:2.60.120.260:FF:000468', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59256, NULL, 'G3DSA:2.30.29.90:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59257, NULL, 'G3DSA:2.30.29.30:FF:001089', NULL, NULL, 'IL2-inducible T cell kinase', NULL, NULL, NULL, NULL, NULL, 4),
(59258, NULL, 'G3DSA:3.40.50.2300:FF:000516', NULL, NULL, 'Metabotropic glutamate receptor-like protein A', NULL, NULL, NULL, NULL, NULL, 4),
(59259, NULL, 'G3DSA:3.20.20.70:FF:000236', NULL, NULL, 'Deoxyribose-phosphate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(59260, NULL, 'G3DSA:3.30.160.60:FF:004756', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59261, NULL, 'G3DSA:1.10.510.10:FF:002611', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59262, NULL, 'G3DSA:3.40.50.360:FF:000115', NULL, NULL, 'NADPH--cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(59263, NULL, 'G3DSA:2.60.40.2030:FF:000055', NULL, NULL, 'Adhesion G-protein coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(59264, NULL, 'G3DSA:1.10.357.50:FF:000001', NULL, NULL, 'Protein unc-13 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(59265, NULL, 'G3DSA:2.40.420.20:FF:000062', NULL, NULL, 'Probable membrane-fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(59266, NULL, 'G3DSA:1.10.357.10:FF:000068', NULL, NULL, 'Copper outer membrane regulator', NULL, NULL, NULL, NULL, NULL, 4),
(59267, NULL, 'G3DSA:3.40.50.300:FF:002761', NULL, NULL, 'DNA repair protein RAD55', NULL, NULL, NULL, NULL, NULL, 4),
(59268, NULL, 'G3DSA:3.40.1110.10:FF:000025', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(59269, NULL, 'G3DSA:3.90.110.10:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59270, NULL, 'G3DSA:2.30.29.30:FF:000544', NULL, NULL, 'Binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(59271, NULL, 'G3DSA:3.90.1150.10:FF:000522', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59272, NULL, 'G3DSA:2.20.28.10:FF:000036', NULL, NULL, 'DNA replication licensing factor, MCM2/3/5 family', NULL, NULL, NULL, NULL, NULL, 4),
(59273, NULL, 'G3DSA:3.30.200.20:FF:001106', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(59274, NULL, 'G3DSA:1.20.1270.60:FF:000001', NULL, NULL, 'Rho GTPase-activating protein 26', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(59275, NULL, 'G3DSA:3.50.50.60:FF:000256', NULL, NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(59276, NULL, 'G3DSA:3.10.20.90:FF:000591', NULL, NULL, 'Fermitin family homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(59277, NULL, 'G3DSA:2.60.40.2860:FF:000011', NULL, NULL, 'Transmission-blocking target antigen S230', NULL, NULL, NULL, NULL, NULL, 4),
(59278, NULL, 'G3DSA:2.60.40.10:FF:000922', NULL, NULL, 'hepatocyte cell adhesion molecule isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(59279, NULL, 'G3DSA:2.40.50.90:FF:000066', NULL, NULL, 'Tudor domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(59280, NULL, 'G3DSA:2.60.120.970:FF:000113', NULL, NULL, 'Bone morphogenetic protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(59281, NULL, 'G3DSA:3.20.20.80:FF:000857', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59282, NULL, 'G3DSA:3.80.10.10:FF:003508', NULL, NULL, 'RNI-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(59283, NULL, 'G3DSA:3.40.50.2300:FF:001180', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59284, NULL, 'G3DSA:3.40.1380.20:FF:000076', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(59285, NULL, 'G3DSA:3.40.50.12780:FF:000197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59286, NULL, 'G3DSA:4.10.400.10:FF:000124', NULL, NULL, 'Low density lipoprotein receptor', NULL, NULL, NULL, NULL, NULL, 4),
(59287, NULL, 'G3DSA:3.40.190.10:FF:000216', NULL, NULL, 'Porphobilinogen deaminase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(59288, NULL, 'G3DSA:1.25.40.10:FF:004351', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(59289, NULL, 'G3DSA:1.20.960.40:FF:000004', NULL, NULL, 'Oral-facial-digital syndrome 1', NULL, NULL, NULL, NULL, NULL, 4),
(59290, NULL, 'G3DSA:2.60.40.1670:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59291, NULL, 'G3DSA:2.20.140.10:FF:000002', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(59292, NULL, 'G3DSA:3.30.70.330:FF:000152', NULL, NULL, 'poly(U)-binding-splicing factor PUF60 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(59293, NULL, 'G3DSA:1.25.40.450:FF:000015', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(59294, NULL, 'G3DSA:2.160.20.10:FF:000192', NULL, NULL, 'F-box only protein 11-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(59295, NULL, 'G3DSA:2.40.50.140:FF:000435', NULL, NULL, 'Ribonuclease R', NULL, NULL, NULL, NULL, NULL, 4),
(59296, NULL, 'G3DSA:1.20.1160.20:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59297, NULL, 'G3DSA:3.30.1490.100:FF:000046', NULL, NULL, 'AAR136Wp', NULL, NULL, NULL, NULL, NULL, 4),
(59298, NULL, 'G3DSA:3.40.50.1240:FF:000097', NULL, NULL, 'Histidine phosphatase superfamily (Branch 1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(59299, NULL, 'G3DSA:3.90.190.10:FF:000306', NULL, NULL, 'Protein-tyrosine phosphatase n9, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59300, NULL, 'G3DSA:2.40.10.10:FF:000427', NULL, NULL, 'IP19441p', NULL, NULL, NULL, NULL, NULL, 4),
(59301, NULL, 'G3DSA:3.40.50.300:FF:005408', NULL, NULL, 'Probable helicase DDB_G0274399', NULL, NULL, NULL, NULL, NULL, 4),
(59302, NULL, 'G3DSA:3.40.50.720:FF:000419', NULL, NULL, 'Decaprenylphosphoryl-D-2-keto erythropentose reductase', NULL, NULL, NULL, NULL, NULL, 4),
(59303, NULL, 'G3DSA:3.30.1520.10:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59304, NULL, 'G3DSA:1.20.58.60:FF:000072', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(59305, NULL, 'G3DSA:3.30.160.60:FF:002839', NULL, NULL, 'Zinc finger protein 621', NULL, NULL, NULL, NULL, NULL, 4),
(59306, NULL, 'G3DSA:1.25.40.10:FF:003390', NULL, NULL, 'Pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(59307, NULL, 'G3DSA:2.40.30.10:FF:000142', NULL, NULL, 'Ferredoxin NADP reductase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(59308, NULL, 'G3DSA:1.20.1250.20:FF:001489', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59309, NULL, 'G3DSA:2.120.10.30:FF:000429', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59310, NULL, 'G3DSA:3.30.70.330:FF:001113', NULL, NULL, 'RNP domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(59311, NULL, 'G3DSA:3.60.130.10:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59312, NULL, 'G3DSA:3.40.850.10:FF:000391', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(59313, NULL, 'G3DSA:3.30.200.20:FF:002382', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59314, NULL, 'G3DSA:3.10.40.10:FF:000001', NULL, NULL, 'Aerolysin', NULL, NULL, NULL, NULL, NULL, 4),
(59315, NULL, 'G3DSA:3.30.160.60:FF:005189', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59316, NULL, 'G3DSA:3.90.226.10:FF:000194', NULL, NULL, 'Enoyl-CoA hydratase/isomerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59317, NULL, 'G3DSA:3.30.60.270:FF:000002', NULL, NULL, 'Sortilin-related receptor isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(59318, NULL, 'G3DSA:1.20.58.340:FF:000019', NULL, NULL, 'CorA-like Mg2+ transporter protein', NULL, NULL, NULL, NULL, NULL, 4),
(59319, NULL, 'G3DSA:3.80.10.10:FF:001822', NULL, NULL, 'GH22922p', NULL, NULL, NULL, NULL, NULL, 4),
(59320, NULL, 'G3DSA:1.20.5.110:FF:000187', NULL, NULL, 'SNARE domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(59321, NULL, 'G3DSA:1.20.5.110:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59322, NULL, 'G3DSA:3.30.450.20:FF:000309', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(59323, NULL, 'G3DSA:3.50.50.60:FF:000200', NULL, NULL, 'Thioredoxin reductase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(59324, NULL, 'G3DSA:3.10.129.10:FF:000210', NULL, NULL, 'Thioesterase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(59325, NULL, 'G3DSA:3.80.10.10:FF:001766', NULL, NULL, 'MstProx', NULL, NULL, NULL, NULL, NULL, 4),
(59326, NULL, 'G3DSA:1.20.1250.20:FF:000741', NULL, NULL, 'Phosphate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(59327, NULL, 'G3DSA:1.10.760.10:FF:000061', NULL, NULL, 'Di-heme cytochrome C peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(59328, NULL, 'G3DSA:2.130.10.10:FF:005009', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(59329, NULL, 'G3DSA:3.30.70.330:FF:000837', NULL, NULL, 'Hrp1p', NULL, NULL, NULL, NULL, NULL, 4),
(59330, NULL, 'G3DSA:3.30.160.780:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59331, NULL, 'G3DSA:1.20.58.80:FF:000078', NULL, NULL, 'Related to yeast Vacuolar Protein Sorting factor', NULL, NULL, NULL, NULL, NULL, 4),
(59332, NULL, 'G3DSA:3.40.50.150:FF:001507', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59333, NULL, 'G3DSA:3.80.10.10:FF:000249', NULL, NULL, 'Leucine rich repeat containing 39', NULL, NULL, NULL, NULL, NULL, 4),
(59334, NULL, 'G3DSA:1.20.1070.10:FF:001770', NULL, NULL, 'Olfactory receptor 1415', NULL, NULL, NULL, NULL, NULL, 4),
(59335, NULL, 'G3DSA:1.20.1250.20:FF:001197', NULL, NULL, 'Glucose/mannose transporter GlcP', NULL, NULL, NULL, NULL, NULL, 4),
(59336, NULL, 'G3DSA:1.10.8.60:FF:000023', NULL, NULL, 'Holliday junction ATP-dependent DNA helicase RuvB', NULL, NULL, NULL, NULL, NULL, 4),
(59337, NULL, 'G3DSA:1.25.40.20:FF:001195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59338, NULL, 'G3DSA:3.60.10.10:FF:000019', NULL, NULL, 'Type IV inositol polyphosphate 5-phosphatase 7', NULL, NULL, NULL, NULL, NULL, 4),
(59339, NULL, 'G3DSA:1.20.120.1630:FF:000002', NULL, NULL, 'Steroid 5 alpha-reductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(59340, NULL, 'G3DSA:3.30.1370.10:FF:000187', NULL, NULL, 'YALI0C05324p', NULL, NULL, NULL, NULL, NULL, 4),
(59341, NULL, 'G3DSA:1.25.40.270:FF:000006', NULL, NULL, 'Glucan synthase-like 10', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(59342, NULL, 'G3DSA:3.40.50.300:FF:007320', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59343, NULL, 'G3DSA:1.10.2000.10:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59344, NULL, 'G3DSA:1.10.3050.10:FF:000001', NULL, NULL, 'Nucleoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(59345, NULL, 'G3DSA:1.10.418.10:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59346, NULL, 'G3DSA:1.20.5.190:FF:000109', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59347, NULL, 'G3DSA:3.80.30.20:FF:000017', NULL, NULL, 'Threonylcarbamoyladenosine tRNA methylthiotransferase MtaB', NULL, NULL, NULL, NULL, NULL, 4),
(59348, NULL, 'G3DSA:2.60.40.10:FF:000866', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', NULL, NULL, NULL, NULL, NULL, 4),
(59349, NULL, 'G3DSA:1.20.5.600:FF:000002', NULL, NULL, 'Potassium voltage-gated channel, shaker-related subfamily, member 4', NULL, NULL, NULL, NULL, NULL, 4),
(59350, NULL, 'G3DSA:3.30.40.100:FF:000009', NULL, NULL, 'Zinc ion binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(59351, NULL, 'G3DSA:3.30.420.40:FF:000515', NULL, NULL, 'Glycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(59352, NULL, 'G3DSA:1.20.58.80:FF:000027', NULL, NULL, 'AMSH-like protease', NULL, NULL, NULL, NULL, NULL, 4),
(59353, NULL, 'G3DSA:3.30.470.20:FF:000075', NULL, NULL, 'Putative periplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(59354, NULL, 'G3DSA:2.60.40.10:FF:001142', NULL, NULL, 'Immunoglobulin heavy variable 5-15', NULL, NULL, NULL, NULL, NULL, 4),
(59355, NULL, 'G3DSA:1.20.1250.20:FF:001545', NULL, NULL, 'Folate-biopterin transporter', NULL, NULL, NULL, NULL, NULL, 4),
(59356, NULL, 'G3DSA:2.60.40.1180:FF:000030', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(59357, NULL, 'G3DSA:1.10.1200.10:FF:000030', NULL, NULL, 'Ebony protein', NULL, NULL, NULL, NULL, NULL, 4),
(59358, NULL, 'G3DSA:3.30.1490.20:FF:000064', NULL, NULL, 'Alpha-L-glutamate ligase, RimK family', NULL, NULL, NULL, NULL, NULL, 4),
(59359, NULL, 'G3DSA:1.20.1740.10:FF:000219', NULL, NULL, 'AGAP011500-PA', NULL, NULL, NULL, NULL, NULL, 4),
(59360, NULL, 'G3DSA:3.30.70.2850:FF:000015', NULL, NULL, 'DNA-directed RNA polymerase I subunit rpa1', NULL, NULL, NULL, NULL, NULL, 4),
(59361, NULL, 'G3DSA:3.40.50.2000:FF:000701', NULL, NULL, 'Glycosyl transferase group 1', NULL, NULL, NULL, NULL, NULL, 4),
(59362, NULL, 'G3DSA:2.60.200.20:FF:000209', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59363, NULL, 'G3DSA:3.30.200.20:FF:000701', NULL, NULL, 'CMGC/DYRK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(59364, NULL, 'G3DSA:2.120.10.30:FF:000530', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59365, NULL, 'G3DSA:2.60.40.10:FF:001086', NULL, NULL, 'Cell surface glycoprotein MUC18', NULL, NULL, NULL, NULL, NULL, 4),
(59366, NULL, 'G3DSA:3.30.479.30:FF:000041', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59367, NULL, 'G3DSA:2.40.10.10:FF:000472', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59368, NULL, 'G3DSA:2.40.30.170:FF:000035', NULL, NULL, 'Resistance-Nodulation-Cell Division (RND) efflux membrane fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(59369, NULL, 'G3DSA:1.10.510.10:FF:002723', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59370, NULL, 'G3DSA:2.130.10.10:FF:005072', NULL, NULL, 'WD-40 repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59371, NULL, 'G3DSA:3.80.10.10:FF:003559', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59372, NULL, 'G3DSA:3.30.230.10:FF:000200', NULL, NULL, 'N-acetylgalactosamine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(59373, NULL, 'G3DSA:2.60.40.2450:FF:000001', NULL, NULL, 'Beta-1,3-xylanase', NULL, NULL, NULL, NULL, NULL, 4),
(59374, NULL, 'G3DSA:1.10.238.10:FF:001129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59375, NULL, 'G3DSA:1.20.5.170:FF:000103', NULL, NULL, 'tropomyosin alpha-1 chain isoform X10', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(59376, NULL, 'G3DSA:1.20.120.520:FF:000011', NULL, NULL, 'Heavy metal translocating P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(59377, NULL, 'G3DSA:1.50.10.10:FF:000221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59378, NULL, 'G3DSA:1.10.10.60:FF:001171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59379, NULL, 'G3DSA:1.10.10.830:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59380, NULL, 'G3DSA:1.20.1160.20:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59381, NULL, 'G3DSA:3.20.20.80:FF:000621', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59382, NULL, 'G3DSA:2.30.30.1020:FF:000028', NULL, NULL, 'GD24003', NULL, NULL, NULL, NULL, NULL, 4),
(59383, NULL, 'G3DSA:3.30.530.20:FF:000170', NULL, NULL, 'Abscisic acid receptor PYL9', NULL, NULL, NULL, NULL, NULL, 4),
(59384, NULL, 'G3DSA:1.10.238.10:FF:001281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59385, NULL, 'G3DSA:1.10.418.10:FF:000154', NULL, NULL, 'girdin', NULL, NULL, NULL, NULL, NULL, 4),
(59386, NULL, 'G3DSA:3.20.20.150:FF:000051', NULL, NULL, 'Xylose isomerase-like TIM barrel', NULL, NULL, NULL, NULL, NULL, 4),
(59387, NULL, 'G3DSA:1.10.600.10:FF:000128', NULL, NULL, 'Geranylgeranyl pyrophosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(59388, NULL, 'G3DSA:1.10.510.10:FF:000301', NULL, NULL, 'Serine/threonine-protein kinase Chk1', NULL, NULL, NULL, NULL, NULL, 4),
(59389, NULL, 'G3DSA:2.40.50.140:FF:000486', NULL, NULL, 'Ribonuclease, Rne/Rng family', NULL, NULL, NULL, NULL, NULL, 4),
(59390, NULL, 'G3DSA:2.40.10.10:FF:000028', NULL, NULL, 'Serine protease easter', NULL, NULL, NULL, NULL, NULL, 4),
(59391, NULL, 'G3DSA:2.60.40.10:FF:001434', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(59392, NULL, 'G3DSA:3.40.50.960:FF:000019', NULL, NULL, '6,7-dimethyl-8-ribityllumazine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(59393, NULL, 'G3DSA:1.20.210.10:FF:000040', NULL, NULL, 'COX1-i7 protein, alternatively spliced', NULL, NULL, NULL, NULL, NULL, 4),
(59394, NULL, 'G3DSA:1.10.10.10:FF:000009', NULL, NULL, 'LexA repressor', NULL, NULL, NULL, NULL, NULL, 4),
(59395, NULL, 'G3DSA:3.40.390.10:FF:000248', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59396, NULL, 'G3DSA:3.40.50.300:FF:007264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59397, NULL, 'G3DSA:2.60.40.150:FF:000162', NULL, NULL, 'Synaptotagmin-15', NULL, NULL, NULL, NULL, NULL, 4),
(59398, NULL, 'G3DSA:1.10.940.10:FF:000002', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase B', NULL, NULL, NULL, NULL, NULL, 4),
(59399, NULL, 'G3DSA:3.40.50.10810:FF:000128', NULL, NULL, 'SNF2_family_N-terminal_domain /Helicase_conserved_C-terminal_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(59400, NULL, 'G3DSA:1.20.1560.10:FF:000166', NULL, NULL, 'Putative ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(59401, NULL, 'G3DSA:1.25.10.10:FF:002994', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59402, NULL, 'G3DSA:3.90.190.10:FF:000418', NULL, NULL, 'Dual specificity protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59403, NULL, 'G3DSA:3.40.50.790:FF:000002', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(59404, NULL, 'G3DSA:2.40.70.10:FF:000532', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59405, NULL, 'G3DSA:1.25.40.10:FF:000017', NULL, NULL, 'NADPH oxidase regulator NoxR', NULL, NULL, NULL, NULL, NULL, 4),
(59406, NULL, 'G3DSA:2.10.25.10:FF:000884', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(59407, NULL, 'G3DSA:3.30.160.60:FF:002940', NULL, NULL, 'Zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(59408, NULL, 'G3DSA:2.130.10.110:FF:000008', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(59409, NULL, 'G3DSA:3.40.50.620:FF:000030', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(59410, NULL, 'G3DSA:1.25.10.10:FF:003270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59411, NULL, 'G3DSA:1.10.1300.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59412, NULL, 'G3DSA:3.20.20.70:FF:000287', NULL, NULL, '2-isopropylmalate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(59413, NULL, 'G3DSA:2.130.10.10:FF:003211', NULL, NULL, 'Transducin/WD-40 repeat protein family', NULL, NULL, NULL, NULL, NULL, 4),
(59414, NULL, 'G3DSA:3.40.50.12780:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59415, NULL, 'G3DSA:1.20.1560.10:FF:000514', NULL, NULL, 'YALI0A19580p', NULL, NULL, NULL, NULL, NULL, 4),
(59416, NULL, 'G3DSA:3.30.420.10:FF:000063', NULL, NULL, 'Retrovirus-related Pol polyprotein from transposon 297-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(59417, NULL, 'G3DSA:3.30.450.20:FF:000461', NULL, NULL, 'Hypoxia-inducible factor 1 subunit alpha,-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(59418, NULL, 'G3DSA:2.30.30.140:FF:000091', NULL, NULL, 'Tudor domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(59419, NULL, 'G3DSA:1.20.58.1120:FF:000033', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59420, NULL, 'G3DSA:2.60.220.30:FF:000028', NULL, NULL, 'Unc-5 netrin receptor B', NULL, NULL, NULL, NULL, NULL, 4),
(59421, NULL, 'G3DSA:1.10.510.10:FF:002162', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59422, NULL, 'G3DSA:1.10.150.20:FF:000091', NULL, NULL, 'Unplaced genomic scaffold supercont1.20, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(59423, NULL, 'G3DSA:3.40.50.10490:FF:000100', NULL, NULL, 'MurR/RpiR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(59424, NULL, 'G3DSA:1.20.1560.10:FF:000458', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59425, NULL, 'G3DSA:2.120.10.30:FF:000581', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59426, NULL, 'G3DSA:3.30.160.60:FF:001827', NULL, NULL, 'zinc finger protein 629 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(59427, NULL, 'G3DSA:3.30.160.60:FF:002991', NULL, NULL, 'C2H2 transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59428, NULL, 'G3DSA:3.40.50.300:FF:003610', NULL, NULL, 'RAB24, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(59429, NULL, 'G3DSA:1.10.1200.80:FF:000011', NULL, NULL, 'tRNA-dihydrouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(59430, NULL, 'G3DSA:2.40.37.10:FF:000005', NULL, NULL, 'Ornithine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(59431, NULL, 'G3DSA:3.80.20.20:FF:000016', NULL, NULL, 'Cell wall protein ECM33', NULL, NULL, NULL, NULL, NULL, 4),
(59432, NULL, 'G3DSA:3.40.50.2000:FF:000696', NULL, NULL, 'Glycosyltransferase, group 1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(59433, NULL, 'G3DSA:2.60.40.150:FF:000561', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59434, NULL, 'G3DSA:2.70.170.10:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59435, NULL, 'G3DSA:2.40.50.140:FF:000143', NULL, NULL, 'DIS3-like exonuclease 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(59436, NULL, 'G3DSA:2.30.130.30:FF:000005', NULL, NULL, 'UPF0267 protein VC_1576', NULL, NULL, NULL, NULL, NULL, 4),
(59437, NULL, 'G3DSA:2.60.40.10:FF:005324', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59438, NULL, 'G3DSA:1.25.40.570:FF:000034', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(59439, NULL, 'G3DSA:1.10.8.60:FF:000579', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59440, NULL, 'G3DSA:3.30.160.60:FF:001479', NULL, NULL, 'ZFP69 zinc finger protein B', NULL, NULL, NULL, NULL, NULL, 4),
(59441, NULL, 'G3DSA:2.20.25.10:FF:000119', NULL, NULL, 'Transcription factor S-II-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(59442, NULL, 'G3DSA:3.40.720.10:FF:000286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(59443, NULL, 'G3DSA:1.10.472.130:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59444, NULL, 'G3DSA:1.20.58.60:FF:000813', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59445, NULL, 'G3DSA:3.40.640.10:FF:000285', NULL, NULL, 'dTDP-4-dehydro-6-deoxy-D-glucose 4-aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(59446, NULL, 'G3DSA:1.50.40.10:FF:000392', NULL, NULL, 'Solute carrier family 25 member 18', NULL, NULL, NULL, NULL, NULL, 4),
(59447, NULL, 'G3DSA:2.60.120.260:FF:000524', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59448, NULL, 'G3DSA:2.60.120.970:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59449, NULL, 'G3DSA:1.10.10.10:FF:000633', NULL, NULL, 'U5 small nuclear ribonucleoprotein-specific protein', NULL, NULL, NULL, NULL, NULL, 4),
(59450, NULL, 'G3DSA:3.30.70.330:FF:000096', NULL, NULL, 'U2 snRNP auxiliary factor large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(59451, NULL, 'G3DSA:1.10.10.10:FF:001122', NULL, NULL, 'Manganese transport regulator MntR', NULL, NULL, NULL, NULL, NULL, 4),
(59452, NULL, 'G3DSA:3.10.100.10:FF:000234', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59453, NULL, 'G3DSA:1.10.150.770:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59454, NULL, 'G3DSA:2.130.10.10:FF:004796', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59455, NULL, 'G3DSA:3.30.160.60:FF:003391', NULL, NULL, 'TPR-containing protein DDB_G0280363', NULL, NULL, NULL, NULL, NULL, 4),
(59456, NULL, 'G3DSA:1.20.1070.10:FF:000258', NULL, NULL, 'G-protein coupled receptor', NULL, NULL, NULL, NULL, NULL, 4),
(59457, NULL, 'G3DSA:1.25.40.470:FF:000066', NULL, NULL, 'Osm-1', NULL, NULL, NULL, NULL, NULL, 4),
(59458, NULL, 'G3DSA:3.40.50.720:FF:002544', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59459, NULL, 'G3DSA:3.30.565.10:FF:000269', NULL, NULL, 'Sensory box histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(59460, NULL, 'G3DSA:3.40.50.150:FF:000277', NULL, NULL, 'RNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(59461, NULL, 'G3DSA:3.20.20.300:FF:000062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59462, NULL, 'G3DSA:3.30.470.20:FF:000131', NULL, NULL, 'ATP domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(59463, NULL, 'G3DSA:1.20.5.1500:FF:000006', NULL, NULL, 'Testis-specific Y-encoded-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(59464, NULL, 'G3DSA:1.25.10.10:FF:002106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59465, NULL, 'G3DSA:1.10.472.10:FF:000375', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59466, NULL, 'G3DSA:3.30.930.10:FF:000326', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59467, NULL, 'G3DSA:3.40.190.80:FF:000012', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(59468, NULL, 'G3DSA:2.60.120.260:FF:000176', NULL, NULL, 'Si:ch211-12m10.1', NULL, NULL, NULL, NULL, NULL, 4),
(59469, NULL, 'G3DSA:2.60.40.10:FF:005537', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59470, NULL, 'G3DSA:3.40.50.150:FF:001570', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59471, NULL, 'G3DSA:1.10.150.480:FF:000001', NULL, NULL, 'Fibronectin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(59472, NULL, 'G3DSA:3.60.21.60:FF:000037', NULL, NULL, 'DNA polymerase epsilon subunit', NULL, NULL, NULL, NULL, NULL, 4),
(59473, NULL, 'G3DSA:2.40.290.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59474, NULL, 'G3DSA:1.10.10.60:FF:000619', NULL, NULL, 'Protein OVEREXPRESSOR OF CATIONIC PEROXIDASE 3', NULL, NULL, NULL, NULL, NULL, 4),
(59475, NULL, 'G3DSA:2.30.42.10:FF:000451', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59476, NULL, 'G3DSA:2.40.50.700:FF:000007', NULL, NULL, 'Putative rrp44p homologue', NULL, NULL, NULL, NULL, NULL, 4),
(59477, NULL, 'G3DSA:3.40.1230.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(59478, NULL, 'G3DSA:2.40.37.10:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59479, NULL, 'G3DSA:3.10.490.10:FF:000055', NULL, NULL, 'Gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(59480, NULL, 'G3DSA:1.25.10.10:FF:003118', NULL, NULL, 'Meiotic check point regulator-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(59481, NULL, 'G3DSA:2.30.30.490:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59482, NULL, 'G3DSA:3.80.10.10:FF:003615', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59483, NULL, 'G3DSA:1.20.90.10:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59484, NULL, 'G3DSA:3.40.50.1000:FF:000109', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(59485, NULL, 'G3DSA:3.40.50.1820:FF:000243', NULL, NULL, 'Alpha/beta hydrolase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(59486, NULL, 'G3DSA:3.30.160.60:FF:000467', NULL, NULL, 'Zinc finger and SCAN domain-containing 21', NULL, NULL, NULL, NULL, NULL, 4),
(59487, NULL, 'G3DSA:2.60.40.10:FF:001266', NULL, NULL, 'Protein tyrosine phosphatase, receptor type Q', NULL, NULL, NULL, NULL, NULL, 4),
(59488, NULL, 'G3DSA:1.25.40.10:FF:003783', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(59489, NULL, 'G3DSA:3.40.390.10:FF:000304', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59490, NULL, 'G3DSA:1.10.10.10:FF:000684', NULL, NULL, 'Transcriptional regulator, MarR family', NULL, NULL, NULL, NULL, NULL, 4),
(59491, NULL, 'G3DSA:3.40.30.10:FF:000752', NULL, NULL, 'Iodothyronine deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(59492, NULL, 'G3DSA:3.90.550.10:FF:000446', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59493, NULL, 'G3DSA:3.40.50.10810:FF:000179', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(59494, NULL, 'G3DSA:3.30.310.80:FF:000002', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(59495, NULL, 'G3DSA:3.40.50.300:FF:005015', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59496, NULL, 'G3DSA:1.10.10.60:FF:001019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59497, NULL, 'G3DSA:3.20.20.80:FF:000565', NULL, NULL, 'Glucosylceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(59498, NULL, 'G3DSA:3.80.10.10:FF:000305', NULL, NULL, 'Adenylate cyclase AcyA', NULL, NULL, NULL, NULL, NULL, 4),
(59499, NULL, 'G3DSA:2.120.10.80:FF:000079', NULL, NULL, 'Putative LOV domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(59500, NULL, 'G3DSA:2.70.150.10:FF:000273', NULL, NULL, 'Phospholipid-transporting ATPase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(59501, NULL, 'G3DSA:3.30.1370.10:FF:000136', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59502, NULL, 'G3DSA:2.60.120.970:FF:000006', NULL, NULL, 'Transforming growth factor beta', NULL, NULL, NULL, NULL, NULL, 4),
(59503, NULL, 'G3DSA:2.60.40.10:FF:001827', NULL, NULL, 'Immunoglobulin kappa variable 4-1', NULL, NULL, NULL, NULL, NULL, 4),
(59504, NULL, 'G3DSA:3.40.50.720:FF:001583', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59505, NULL, 'G3DSA:1.20.58.60:FF:000600', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59506, NULL, 'G3DSA:3.30.420.40:FF:000347', NULL, NULL, 'actin-related protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(59507, NULL, 'G3DSA:3.30.70.330:FF:000045', NULL, NULL, 'Nucleolysin tiar isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(59508, NULL, 'G3DSA:3.50.50.60:FF:000548', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(59509, NULL, 'G3DSA:1.20.120.730:FF:000017', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(59510, NULL, 'G3DSA:2.130.10.10:FF:002935', NULL, NULL, 'Protein HIRA', NULL, NULL, NULL, NULL, NULL, 4),
(59511, NULL, 'G3DSA:3.30.160.60:FF:005138', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(59512, NULL, 'G3DSA:3.80.10.10:FF:004015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59513, NULL, 'G3DSA:1.20.920.20:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59514, NULL, 'G3DSA:3.40.1110.10:FF:000317', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59515, NULL, 'G3DSA:3.40.50.300:FF:001305', NULL, NULL, 'ABCG transporter ABC superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(59516, NULL, 'G3DSA:3.30.70.330:FF:000657', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit G', NULL, NULL, NULL, NULL, NULL, 4),
(59517, NULL, 'G3DSA:2.130.10.10:FF:001923', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59518, NULL, 'G3DSA:3.30.300.70:FF:000004', NULL, NULL, 'Ribosome maturation factor RimP', NULL, NULL, NULL, NULL, NULL, 4),
(59519, NULL, 'G3DSA:1.25.10.10:FF:000633', NULL, NULL, 'Deoxyhypusine hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(59520, NULL, 'G3DSA:6.10.140.2220:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59521, NULL, 'G3DSA:2.40.50.90:FF:000178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59522, NULL, 'G3DSA:3.40.50.1820:FF:000642', NULL, NULL, 'Phospholipase A1 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(59523, NULL, 'G3DSA:2.160.10.10:FF:000034', NULL, NULL, 'Galactoside O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(59524, NULL, 'G3DSA:3.30.1330.40:FF:000025', NULL, NULL, 'Chorismate mutase AroH', NULL, NULL, NULL, NULL, NULL, 4),
(59525, NULL, 'G3DSA:3.30.200.20:FF:002562', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59526, NULL, 'G3DSA:1.20.120.310:FF:000010', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(59527, NULL, 'G3DSA:2.60.120.920:FF:000183', NULL, NULL, 'Trithorax protein ash2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59528, NULL, 'G3DSA:3.40.1110.10:FF:000368', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59529, NULL, 'G3DSA:3.40.1110.10:FF:000424', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59530, NULL, 'G3DSA:3.30.420.40:FF:000639', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59531, NULL, 'G3DSA:3.30.497.10:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59532, NULL, 'G3DSA:3.90.79.10:FF:000249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59533, NULL, 'G3DSA:1.10.1450.10:FF:000014', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(59534, NULL, 'G3DSA:1.20.1390.10:FF:000006', NULL, NULL, 'zinc finger CCCH domain-containing protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(59535, NULL, 'G3DSA:3.30.1390.20:FF:000028', NULL, NULL, '60S ribosomal protein L7-2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59536, NULL, 'G3DSA:3.40.50.410:FF:000265', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59537, NULL, 'G3DSA:3.80.10.10:FF:000417', NULL, NULL, 'F-box/LRR-repeat protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(59538, NULL, 'G3DSA:1.25.10.10:FF:000577', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(59539, NULL, 'G3DSA:3.50.7.10:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59540, NULL, 'G3DSA:3.30.60.30:FF:000108', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(59541, NULL, 'G3DSA:1.20.1260.100:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59542, NULL, 'G3DSA:3.40.1650.10:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59543, NULL, 'G3DSA:2.60.220.50:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59544, NULL, 'G3DSA:3.20.20.80:FF:000801', NULL, NULL, 'Protein CBR-AGL-1', NULL, NULL, NULL, NULL, NULL, 4),
(59545, NULL, 'G3DSA:3.40.50.720:FF:001875', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(59546, NULL, 'G3DSA:1.20.1270.60:FF:000288', NULL, NULL, 'FES proto-oncogene, tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(59547, NULL, 'G3DSA:1.20.58.60:FF:000544', NULL, NULL, 'Microtubule actin crosslinking factor 1a', NULL, NULL, NULL, NULL, NULL, 4),
(59548, NULL, 'G3DSA:3.40.50.2000:FF:000191', NULL, NULL, 'Lipopolysaccharide core heptosyltransferase RfaQ', NULL, NULL, NULL, NULL, NULL, 4),
(59549, NULL, 'G3DSA:1.10.555.10:FF:000163', NULL, NULL, 'Rgd1p', NULL, NULL, NULL, NULL, NULL, 4),
(59550, NULL, 'G3DSA:2.10.110.10:FF:000065', NULL, NULL, 'Testin', NULL, NULL, NULL, NULL, NULL, 4),
(59551, NULL, 'G3DSA:3.90.79.10:FF:000305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59552, NULL, 'G3DSA:2.30.40.10:FF:000053', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(59553, NULL, 'G3DSA:3.90.70.10:FF:000617', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59554, NULL, 'G3DSA:1.20.5.110:FF:000131', NULL, NULL, 'QA-SNARE protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(59555, NULL, 'G3DSA:3.90.1150.10:FF:000230', NULL, NULL, 'Aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(59556, NULL, 'G3DSA:1.25.10.10:FF:001089', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(59557, NULL, 'G3DSA:3.40.50.300:FF:000737', NULL, NULL, 'Bifunctional polynucleotide phosphatase/kinase', NULL, NULL, NULL, NULL, NULL, 4),
(59558, NULL, 'G3DSA:2.60.120.200:FF:000585', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59559, NULL, 'G3DSA:3.40.50.300:FF:001249', NULL, NULL, 'DNA mismatch repair protein MSH4', NULL, NULL, NULL, NULL, NULL, 4),
(59560, NULL, 'G3DSA:3.30.70.330:FF:002861', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59561, NULL, 'G3DSA:2.60.40.10:FF:003452', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59562, NULL, 'G3DSA:2.130.10.10:FF:002486', NULL, NULL, 'HEAT repeat domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(59563, NULL, 'G3DSA:2.130.10.10:FF:000338', NULL, NULL, 'WD repeat and HMG-box DNA binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(59564, NULL, 'G3DSA:3.40.720.10:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59565, NULL, 'G3DSA:3.30.200.20:FF:000358', NULL, NULL, 'Tau tubulin kinase 2b', NULL, NULL, NULL, NULL, NULL, 4),
(59566, NULL, 'G3DSA:3.30.70.330:FF:000713', NULL, NULL, 'Pre-mRNA-splicing factor CWC2', NULL, NULL, NULL, NULL, NULL, 4),
(59567, NULL, 'G3DSA:3.30.360.20:FF:000010', NULL, NULL, 'RNA 3''-terminal phosphate cyclase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(59568, NULL, 'G3DSA:1.10.3370.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59569, NULL, 'G3DSA:1.20.1560.10:FF:000565', NULL, NULL, 'Pgp-1', NULL, NULL, NULL, NULL, NULL, 4),
(59570, NULL, 'G3DSA:2.130.10.10:FF:001974', NULL, NULL, 'Protein required for cell viability, possible role in assembly of the ribosome', NULL, NULL, NULL, NULL, NULL, 4),
(59571, NULL, 'G3DSA:3.30.420.40:FF:000746', NULL, NULL, 'Actin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59572, NULL, 'G3DSA:1.20.900.10:FF:000008', NULL, NULL, 'rho guanine nucleotide exchange factor 25', NULL, NULL, NULL, NULL, NULL, 4),
(59573, NULL, 'G3DSA:2.30.30.140:FF:000208', NULL, NULL, 'GM23618', NULL, NULL, NULL, NULL, NULL, 4),
(59574, NULL, 'G3DSA:3.40.140.10:FF:000084', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(59575, NULL, 'G3DSA:1.25.40.10:FF:003895', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59576, NULL, 'G3DSA:3.40.640.10:FF:000465', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59577, NULL, 'G3DSA:1.20.58.1220:FF:000006', NULL, NULL, 'Exocyst complex component EXO84, variant', NULL, NULL, NULL, NULL, NULL, 4),
(59578, NULL, 'G3DSA:1.25.40.10:FF:001765', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(59579, NULL, 'G3DSA:1.20.1250.20:FF:002034', NULL, NULL, 'MFS drug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59580, NULL, 'G3DSA:2.10.25.10:FF:001665', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59581, NULL, 'G3DSA:2.60.40.420:FF:000203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59582, NULL, 'G3DSA:3.30.70.330:FF:000606', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(59583, NULL, 'G3DSA:2.80.10.50:FF:000128', NULL, NULL, 'Endo-1,4-beta-xylanase A', NULL, NULL, NULL, NULL, NULL, 4),
(59584, NULL, 'G3DSA:1.10.3380.30:FF:000020', NULL, NULL, 'Ski2-like RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(59585, NULL, 'G3DSA:2.120.10.80:FF:000404', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59586, NULL, 'G3DSA:3.50.50.60:FF:001217', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(59587, NULL, 'G3DSA:1.10.472.10:FF:000083', NULL, NULL, 'Transcription initiation factor IIB', NULL, NULL, NULL, NULL, NULL, 4),
(59588, NULL, 'G3DSA:1.20.1070.10:FF:000606', NULL, NULL, 'Olfactory receptor 536', NULL, NULL, NULL, NULL, NULL, 4),
(59589, NULL, 'G3DSA:1.25.40.90:FF:000114', NULL, NULL, 'Nine-cis-epoxycarotenoid dioxygenase7', NULL, NULL, NULL, NULL, NULL, 4),
(59590, NULL, 'G3DSA:3.50.50.60:FF:000599', NULL, NULL, 'Methylenetetrahydrofolate--tRNA-(uracil-5-)-methyltransferase TrmFO', NULL, NULL, NULL, NULL, NULL, 4),
(59591, NULL, 'G3DSA:3.90.1410.10:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59592, NULL, 'G3DSA:1.25.40.90:FF:000058', NULL, NULL, 'Hse1p', NULL, NULL, NULL, NULL, NULL, 4),
(59593, NULL, 'G3DSA:3.40.630.30:FF:000122', NULL, NULL, 'Acetyltransferase (GNAT) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(59594, NULL, 'G3DSA:3.40.50.80:FF:000223', NULL, NULL, 'NADH-cytochrome b5 reductase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(59595, NULL, 'G3DSA:1.20.120.770:FF:000001', NULL, NULL, 'Amyloid beta A4 protein-like isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(59596, NULL, 'G3DSA:2.40.330.10:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59597, NULL, 'G3DSA:3.30.40.10:FF:002136', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(59598, NULL, 'G3DSA:1.10.1370.10:FF:000013', NULL, NULL, 'Peptidase family M3', NULL, NULL, NULL, NULL, NULL, 4),
(59599, NULL, 'G3DSA:2.130.10.10:FF:005521', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59600, NULL, 'G3DSA:1.10.150.240:FF:000076', NULL, NULL, 'Possible phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(59601, NULL, 'G3DSA:2.130.10.10:FF:001182', NULL, NULL, 'Unplaced genomic scaffold supercont1.58, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(59602, NULL, 'G3DSA:3.30.160.60:FF:002047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59603, NULL, 'G3DSA:3.40.720.10:FF:000235', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59604, NULL, 'G3DSA:3.40.50.2020:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59605, NULL, 'G3DSA:1.25.40.180:FF:000243', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59606, NULL, 'G3DSA:2.40.160.210:FF:000016', NULL, NULL, 'Peroxisomal Acyl-CoA thioesterase Tes1p, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59607, NULL, 'G3DSA:1.10.510.10:FF:002954', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59608, NULL, 'G3DSA:3.30.70.580:FF:000030', NULL, NULL, 'Putative tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(59609, NULL, 'G3DSA:1.20.120.790:FF:000007', NULL, NULL, 'Heat shock protein 90', NULL, NULL, NULL, NULL, NULL, 4),
(59610, NULL, 'G3DSA:2.60.120.200:FF:000641', NULL, NULL, 'Neurogenic locus notch, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59611, NULL, 'G3DSA:3.40.50.2300:FF:000067', NULL, NULL, 'Olfactory receptor C family, h1', NULL, NULL, NULL, NULL, NULL, 4),
(59612, NULL, 'G3DSA:2.60.40.10:FF:000597', NULL, NULL, 'tyrosine-protein kinase receptor Tie-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(59613, NULL, 'G3DSA:2.60.220.50:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59614, NULL, 'G3DSA:3.40.50.150:FF:001238', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59615, NULL, 'G3DSA:3.20.20.100:FF:000002', NULL, NULL, '2,5-diketo-D-gluconic acid reductase A', NULL, NULL, NULL, NULL, NULL, 4),
(59616, NULL, 'G3DSA:1.10.10.10:FF:000902', NULL, NULL, 'Related to Histone H1', NULL, NULL, NULL, NULL, NULL, 4),
(59617, NULL, 'G3DSA:3.30.450.20:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59618, NULL, 'G3DSA:3.30.2130.30:FF:000041', NULL, NULL, 'Probable tRNA sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(59619, NULL, 'G3DSA:3.40.50.300:FF:002941', NULL, NULL, 'Pre-mRNA-processing ATP-dependent RNA helicase PRP5', NULL, NULL, NULL, NULL, NULL, 4),
(59620, NULL, 'G3DSA:3.20.20.30:FF:000016', NULL, NULL, 'Oxidoreductase, LLM family', NULL, NULL, NULL, NULL, NULL, 4),
(59621, NULL, 'G3DSA:2.70.160.11:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59622, NULL, 'G3DSA:2.60.40.10:FF:006049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59623, NULL, 'G3DSA:3.90.1150.160:FF:000004', NULL, NULL, 'Glutamate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(59624, NULL, 'G3DSA:3.30.70.330:FF:001169', NULL, NULL, 'Zinc finger protein containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(59625, NULL, 'G3DSA:1.10.340.70:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59626, NULL, 'G3DSA:1.25.10.10:FF:002781', NULL, NULL, 'STE family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(59627, NULL, 'G3DSA:1.10.275.40:FF:000009', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(59628, NULL, 'G3DSA:1.25.40.70:FF:000052', NULL, NULL, 'Phosphatidylinositol 3-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(59629, NULL, 'G3DSA:1.20.1290.10:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59630, NULL, 'G3DSA:1.10.1370.30:FF:000019', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(59631, NULL, 'G3DSA:2.60.40.1180:FF:000086', NULL, NULL, 'Glycogen debranching enzyme GlgX', NULL, NULL, NULL, NULL, NULL, 4),
(59632, NULL, 'G3DSA:3.40.50.300:FF:007033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59633, NULL, 'G3DSA:1.10.8.10:FF:000317', NULL, NULL, 'UBA domain-containing protein Mud1', NULL, NULL, NULL, NULL, NULL, 4),
(59634, NULL, 'G3DSA:2.30.30.40:FF:000674', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59635, NULL, 'G3DSA:1.10.860.10:FF:000001', NULL, NULL, 'Replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(59636, NULL, 'G3DSA:3.40.640.10:FF:000234', NULL, NULL, 'Adenosylmethionine-8-amino-7-oxononanoate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(59637, NULL, 'G3DSA:3.30.559.30:FF:000042', NULL, NULL, 'Nonribosomal peptide synthase Pes1', NULL, NULL, NULL, NULL, NULL, 4),
(59638, NULL, 'G3DSA:3.20.20.80:FF:000060', NULL, NULL, 'Lysozyme M1', NULL, NULL, NULL, NULL, NULL, 4),
(59639, NULL, 'G3DSA:3.30.420.40:FF:000791', NULL, NULL, 'O-Sialoglycoprotein Endopeptidase family', NULL, NULL, NULL, NULL, NULL, 4),
(59640, NULL, 'G3DSA:1.10.1710.10:FF:000001', NULL, NULL, 'RNA chaperone ProQ', NULL, NULL, NULL, NULL, NULL, 4),
(59641, NULL, 'G3DSA:2.60.40.10:FF:001035', NULL, NULL, 'Down syndrome cell adhesion molecule-like protein Dscam2', NULL, NULL, NULL, NULL, NULL, 4),
(59642, NULL, 'G3DSA:3.30.450.40:FF:000287', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(59643, NULL, 'G3DSA:3.10.490.10:FF:000004', NULL, NULL, 'Gamma-glutamyl cyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(59644, NULL, 'G3DSA:1.20.890.10:FF:000012', NULL, NULL, 'DPY30 domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(59645, NULL, 'G3DSA:4.10.520.10:FF:000015', NULL, NULL, 'DNA-binding protein HU', NULL, NULL, NULL, NULL, NULL, 4),
(59646, NULL, 'G3DSA:3.80.10.10:FF:002834', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(59647, NULL, 'G3DSA:3.40.50.300:FF:003722', NULL, NULL, 'ATPase, AAA family', NULL, NULL, NULL, NULL, NULL, 4),
(59648, NULL, 'G3DSA:3.40.50.2000:FF:000988', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59649, NULL, 'G3DSA:1.20.1250.40:FF:000011', NULL, NULL, 'RNA polymerase C', NULL, NULL, NULL, NULL, NULL, 4),
(59650, NULL, 'G3DSA:3.30.200.20:FF:001718', NULL, NULL, 'Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(59651, NULL, 'G3DSA:3.10.450.10:FF:000058', NULL, NULL, 'Cysteine proteinase inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(59652, NULL, 'G3DSA:1.10.3860.10:FF:000012', NULL, NULL, 'Amino acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(59653, NULL, 'G3DSA:3.40.50.10490:FF:000044', NULL, NULL, 'Transcriptional regulator, RpiR family', NULL, NULL, NULL, NULL, NULL, 4),
(59654, NULL, 'G3DSA:3.30.420.10:FF:000355', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59655, NULL, 'G3DSA:3.30.40.10:FF:000955', NULL, NULL, 'Putative phosphatidylinositol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(59656, NULL, 'G3DSA:2.130.10.10:FF:005341', NULL, NULL, 'U3 small nucleolar RNA-associated protein 4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(59657, NULL, 'G3DSA:2.60.40.10:FF:004756', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59658, NULL, 'G3DSA:3.40.1440.60:FF:000003', NULL, NULL, 'Primosomal protein N''', NULL, NULL, NULL, NULL, NULL, 4),
(59659, NULL, 'G3DSA:2.60.40.10:FF:004868', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59660, NULL, 'G3DSA:2.70.150.10:FF:000093', NULL, NULL, 'Cation-transporting ATPase, E1-E2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(59661, NULL, 'G3DSA:3.40.50.150:FF:001058', NULL, NULL, 'Methyltransferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(59662, NULL, 'G3DSA:3.60.15.10:FF:000103', NULL, NULL, 'ETHE1, persulfide dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(59663, NULL, 'G3DSA:3.20.20.70:FF:000579', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59664, NULL, 'G3DSA:3.90.1170.10:FF:000006', NULL, NULL, '60S ribosomal protein L10', NULL, NULL, NULL, NULL, NULL, 4),
(59665, NULL, 'G3DSA:3.40.50.1000:FF:000553', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59666, NULL, 'G3DSA:1.25.40.10:FF:005076', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(59667, NULL, 'G3DSA:2.10.25.10:FF:001772', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59668, NULL, 'G3DSA:1.10.510.10:FF:001594', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59669, NULL, 'G3DSA:1.10.510.10:FF:001650', NULL, NULL, 'Serine/threonine protein kinase Chk2,putative', NULL, NULL, NULL, NULL, NULL, 4),
(59670, NULL, 'G3DSA:2.70.170.10:FF:000212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59671, NULL, 'G3DSA:3.40.50.10380:FF:000011', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(59672, NULL, 'G3DSA:3.40.50.300:FF:005807', NULL, NULL, 'DNA helicase, SNF2/RAD54 family', NULL, NULL, NULL, NULL, NULL, 4),
(59673, NULL, 'G3DSA:3.90.1010.10:FF:000012', NULL, NULL, 'Cysteine desulfuration protein SufE', NULL, NULL, NULL, NULL, NULL, 4),
(59674, NULL, 'G3DSA:3.30.710.10:FF:000170', NULL, NULL, 'SKP1-like protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(59675, NULL, 'G3DSA:1.10.10.1770:FF:000005', NULL, NULL, 'Glr3962 protein', NULL, NULL, NULL, NULL, NULL, 4),
(59676, NULL, 'G3DSA:3.60.10.10:FF:000082', NULL, NULL, 'Endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(59677, NULL, 'G3DSA:1.10.20.10:FF:000167', NULL, NULL, 'Histone H2A', NULL, NULL, NULL, NULL, NULL, 4),
(59678, NULL, 'G3DSA:3.30.160.60:FF:003901', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59679, NULL, 'G3DSA:1.10.1170.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59680, NULL, 'G3DSA:2.60.120.260:FF:000232', NULL, NULL, 'Protein CBG03913', NULL, NULL, NULL, NULL, NULL, 4),
(59681, NULL, 'G3DSA:3.10.330.10:FF:000010', NULL, NULL, 'vesicle-fusing ATPase 2', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(59682, NULL, 'G3DSA:2.170.120.12:FF:000002', NULL, NULL, 'DNA-directed RNA polymerase II subunit RPB3', NULL, NULL, NULL, NULL, NULL, 4),
(59683, NULL, 'G3DSA:3.40.50.12650:FF:000006', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(59684, NULL, 'G3DSA:3.20.20.140:FF:000222', NULL, NULL, 'Phospho-furanose lactonase', NULL, NULL, NULL, NULL, NULL, 4),
(59685, NULL, 'G3DSA:3.30.1610.20:FF:000001', NULL, NULL, 'Methyltransferase type 12', NULL, NULL, NULL, NULL, NULL, 4),
(59686, NULL, 'G3DSA:3.40.850.10:FF:000059', NULL, NULL, 'Myosin type-2 heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(59687, NULL, 'G3DSA:3.40.50.1000:FF:000733', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59688, NULL, 'G3DSA:1.20.920.10:FF:000066', NULL, NULL, 'Transcription initiation factor TFIID subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(59689, NULL, 'G3DSA:3.40.640.10:FF:000178', NULL, NULL, 'Aminotransferase, class I/II domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(59690, NULL, 'G3DSA:1.25.10.10:FF:001937', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59691, NULL, 'G3DSA:3.40.50.300:FF:002885', NULL, NULL, 'GTP-binding protein YPTM1', NULL, NULL, NULL, NULL, NULL, 4),
(59692, NULL, 'G3DSA:1.25.40.10:FF:005312', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59693, NULL, 'G3DSA:3.20.20.140:FF:000278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59694, NULL, 'G3DSA:2.60.40.10:FF:006105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59695, NULL, 'G3DSA:3.40.50.12780:FF:000141', NULL, NULL, 'AMP-binding enzyme, putative (AFU_orthologue AFUA_5G04270)', NULL, NULL, NULL, NULL, NULL, 4),
(59696, NULL, 'G3DSA:3.40.50.1820:FF:000535', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(59697, NULL, 'G3DSA:1.20.970.10:FF:000013', NULL, NULL, 'Anthranilate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(59698, NULL, 'G3DSA:1.10.510.10:FF:002667', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59699, NULL, 'G3DSA:3.30.60.20:FF:000162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59700, NULL, 'G3DSA:3.40.800.10:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59701, NULL, 'G3DSA:3.30.230.10:FF:000144', NULL, NULL, 'Phosphomevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(59702, NULL, 'G3DSA:3.80.10.10:FF:003907', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(59703, NULL, 'G3DSA:3.30.160.60:FF:003160', NULL, NULL, 'Si:ch73-221f6.3', NULL, NULL, NULL, NULL, NULL, 4),
(59704, NULL, 'G3DSA:1.10.950.10:FF:000008', NULL, NULL, 'Quail, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(59705, NULL, 'G3DSA:3.40.640.10:FF:000521', NULL, NULL, 'Serine--pyruvate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(59706, NULL, 'G3DSA:3.30.2230.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59707, NULL, 'G3DSA:1.20.120.1080:FF:000028', NULL, NULL, 'ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(59708, NULL, 'G3DSA:1.10.10.60:FF:000327', NULL, NULL, 'Myb transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(59709, NULL, 'G3DSA:3.40.190.10:FF:000828', NULL, NULL, 'Sugar ABC transporter, periplasmic sugar-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(59710, NULL, 'G3DSA:2.130.10.10:FF:000670', NULL, NULL, 'Tomosyn, isoform K', NULL, NULL, NULL, NULL, NULL, 4),
(59711, NULL, 'G3DSA:3.40.50.150:FF:001390', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59712, NULL, 'G3DSA:3.40.50.300:FF:002609', NULL, NULL, 'GD23605', NULL, NULL, NULL, NULL, NULL, 4),
(59713, NULL, 'G3DSA:2.60.120.620:FF:000031', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59714, NULL, 'G3DSA:3.40.50.1820:FF:000411', NULL, NULL, 'Probable carboxylesterase Os04g0669600', NULL, NULL, NULL, NULL, NULL, 4),
(59715, NULL, 'G3DSA:4.10.1240.10:FF:000041', NULL, NULL, 'Putative diuretic hormone 44 receptor', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(59716, NULL, 'G3DSA:3.40.1160.10:FF:000028', NULL, NULL, 'Uridylate kinase isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(59717, NULL, 'G3DSA:3.80.10.10:FF:001997', NULL, NULL, 'Putative leucine-rich repeat receptor-like serine/threonine-protein kinase isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(59718, NULL, 'G3DSA:3.30.450.20:FF:000416', NULL, NULL, 'Sensor box histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(59719, NULL, 'G3DSA:1.20.58.1880:FF:000013', NULL, NULL, 'WGS project CABT00000000 data, contig 2.5', NULL, NULL, NULL, NULL, NULL, 4),
(59720, NULL, 'G3DSA:2.60.40.10:FF:001322', NULL, NULL, '1,4-alpha-glucan-branching enzyme 3', NULL, NULL, NULL, NULL, NULL, 4),
(59721, NULL, 'G3DSA:3.90.1480.20:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59722, NULL, 'G3DSA:3.40.630.30:FF:000234', NULL, NULL, 'GH28833p', NULL, NULL, NULL, NULL, NULL, 4),
(59723, NULL, 'G3DSA:3.30.70.1250:FF:000001', NULL, NULL, 'Phosphopentomutase', NULL, NULL, NULL, NULL, NULL, 4),
(59724, NULL, 'G3DSA:4.10.240.10:FF:000033', NULL, NULL, 'C6 transcription factor (AflR)', NULL, NULL, NULL, NULL, NULL, 4),
(59725, NULL, 'G3DSA:1.10.630.10:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59726, NULL, 'G3DSA:3.90.550.10:FF:000677', NULL, NULL, 'UDP-N-acetylglucosamine pyrophosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(59727, NULL, 'G3DSA:1.10.10.10:FF:001414', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(59728, NULL, 'G3DSA:1.10.510.10:FF:001318', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(59729, NULL, 'G3DSA:3.40.570.10:FF:000021', NULL, NULL, 'GM23913', NULL, NULL, NULL, NULL, NULL, 4),
(59730, NULL, 'G3DSA:3.30.160.60:FF:001535', NULL, NULL, 'Zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(59731, NULL, 'G3DSA:3.30.450.20:FF:000017', NULL, NULL, 'SIM bHLH transcription factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(59732, NULL, 'G3DSA:1.10.10.10:FF:000577', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(59733, NULL, 'G3DSA:3.90.1150.10:FF:000174', NULL, NULL, 'Putrescine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(59734, NULL, 'G3DSA:3.30.70.1470:FF:000011', NULL, NULL, 'Caspase 2', NULL, NULL, NULL, NULL, NULL, 4),
(59735, NULL, 'G3DSA:3.30.40.10:FF:000270', NULL, NULL, 'pathogenesis-related homeodomain protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(59736, NULL, 'G3DSA:2.130.10.10:FF:001070', NULL, NULL, 'Dynein intermediate chain, cytosolic', NULL, NULL, NULL, NULL, NULL, 4),
(59737, NULL, 'G3DSA:3.40.50.300:FF:001536', NULL, NULL, 'Probable VPS21-Rab5-like GTPase involved in vacuolar protein sorting', NULL, NULL, NULL, NULL, NULL, 4),
(59738, NULL, 'G3DSA:1.10.730.10:FF:000233', NULL, NULL, 'Valyl tRNA Synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59739, NULL, 'G3DSA:2.40.30.10:FF:000086', NULL, NULL, 'Bifunctional cytochrome P450/NADPH--P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(59740, NULL, 'G3DSA:2.130.10.10:FF:003104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59741, NULL, 'G3DSA:2.120.10.80:FF:000186', NULL, NULL, 'tRNA wybutosine-synthesizing protein 2/3/4', NULL, NULL, NULL, NULL, NULL, 4),
(59742, NULL, 'G3DSA:2.130.10.10:FF:002704', NULL, NULL, 'WD repeat domain phosphoinositide-interacting protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(59743, NULL, 'G3DSA:2.30.29.30:FF:000021', NULL, NULL, 'Rho guanine nucleotide exchange factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(59744, NULL, 'G3DSA:3.40.850.10:FF:000003', NULL, NULL, 'Myosin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(59745, NULL, 'G3DSA:3.40.50.150:FF:000726', NULL, NULL, 'Ribosomal RNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(59746, NULL, 'G3DSA:2.30.30.940:FF:000004', NULL, NULL, 'Tetratricopeptide repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(59747, NULL, 'G3DSA:1.20.1070.10:FF:000426', NULL, NULL, 'Transmembrane receptor LIN-17', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(59748, NULL, 'G3DSA:1.20.120.1150:FF:000004', NULL, NULL, 'Serine/threonine-protein phosphatase 2A activator 1', NULL, NULL, NULL, NULL, NULL, 4),
(59749, NULL, 'G3DSA:1.20.1280.290:FF:000068', NULL, NULL, 'PQ loop repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(59750, NULL, 'G3DSA:1.10.1670.10:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59751, NULL, 'G3DSA:3.40.50.1460:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59752, NULL, 'G3DSA:1.25.40.10:FF:000984', NULL, NULL, 'Os05g0572900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(59753, NULL, 'G3DSA:1.20.58.390:FF:000225', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59754, NULL, 'G3DSA:2.60.120.650:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59755, NULL, 'G3DSA:1.20.1250.20:FF:001253', NULL, NULL, 'Major facilitator superfamily domain-containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(59756, NULL, 'G3DSA:3.40.630.10:FF:000172', NULL, NULL, 'Succinylglutamate desuccinylase', NULL, NULL, NULL, NULL, NULL, 4),
(59757, NULL, 'G3DSA:3.90.260.10:FF:000014', NULL, NULL, 'DNA repair protein RAD4 isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(59758, NULL, 'G3DSA:1.10.30.10:FF:000067', NULL, NULL, 'Lysine-specific histone demethylase Aof2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59759, NULL, 'G3DSA:3.30.1520.10:FF:000076', NULL, NULL, 'Sorting nexin 20', NULL, NULL, NULL, NULL, NULL, 4),
(59760, NULL, 'G3DSA:1.10.510.10:FF:003628', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59761, NULL, 'G3DSA:1.10.472.10:FF:000700', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59762, NULL, 'G3DSA:3.30.160.60:FF:005245', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59763, NULL, 'G3DSA:1.25.10.10:FF:003163', NULL, NULL, 'Beta subunit of clathrin adaptor complex AP2', NULL, NULL, NULL, NULL, NULL, 4),
(59764, NULL, 'G3DSA:3.40.50.1820:FF:001316', NULL, NULL, 'AFR306Cp', NULL, NULL, NULL, NULL, NULL, 4),
(59765, NULL, 'G3DSA:3.40.50.720:FF:000127', NULL, NULL, 'Enoyl-[acyl-carrier-protein] reductase [NADH]', NULL, NULL, NULL, NULL, NULL, 4),
(59766, NULL, 'G3DSA:1.25.10.10:FF:001033', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(59767, NULL, 'G3DSA:1.10.287.660:FF:000015', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59768, NULL, 'G3DSA:3.10.20.90:FF:000203', NULL, NULL, 'FERM and PDZ domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(59769, NULL, 'G3DSA:1.20.1060.10:FF:000021', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(59770, NULL, 'G3DSA:3.40.50.11270:FF:000002', NULL, NULL, 'mRNA, clone: RTFL01-07-F02', NULL, NULL, NULL, NULL, NULL, 4),
(59771, NULL, 'G3DSA:2.60.34.10:FF:000032', NULL, NULL, 'Heat shock 70 kDa protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59772, NULL, 'G3DSA:1.20.58.60:FF:000364', NULL, NULL, 'Spectrin repeat-containing, nuclear envelope family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(59773, NULL, 'G3DSA:1.10.101.10:FF:000019', NULL, NULL, 'General secretion pathway protein A', NULL, NULL, NULL, NULL, NULL, 4),
(59774, NULL, 'G3DSA:1.25.40.10:FF:000309', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(59775, NULL, 'G3DSA:3.40.630.30:FF:000178', NULL, NULL, 'GNAT family N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(59776, NULL, 'G3DSA:2.10.25.10:FF:000592', NULL, NULL, 'Cadherin-related tumor suppressor', NULL, NULL, NULL, NULL, NULL, 4),
(59777, NULL, 'G3DSA:2.60.40.10:FF:002339', NULL, NULL, 'Protein-tyrosine-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(59778, NULL, 'G3DSA:3.30.70.260:FF:000052', NULL, NULL, 'Glycine cleavage system transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(59779, NULL, 'G3DSA:3.20.180.20:FF:000021', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(59780, NULL, 'G3DSA:3.10.20.90:FF:000147', NULL, NULL, 'Inhibitor of nuclear factor kappa B kinase subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(59781, NULL, 'G3DSA:3.30.2160.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59782, NULL, 'G3DSA:2.60.450.20:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59783, NULL, 'G3DSA:3.30.200.20:FF:000196', NULL, NULL, 'Myosin light chain kinase family, member 4', NULL, NULL, NULL, NULL, NULL, 4),
(59784, NULL, 'G3DSA:2.30.29.30:FF:000600', NULL, NULL, 'CRE-TAG-318 protein', NULL, NULL, NULL, NULL, NULL, 4),
(59785, NULL, 'G3DSA:3.40.50.1220:FF:000119', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59786, NULL, 'G3DSA:2.30.130.110:FF:000005', NULL, NULL, 'D-galactarate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(59787, NULL, 'G3DSA:3.10.100.10:FF:000127', NULL, NULL, 'CD209f antigen', NULL, NULL, NULL, NULL, NULL, 4),
(59788, NULL, 'G3DSA:2.40.50.90:FF:000122', NULL, NULL, 'Slr6011 protein', NULL, NULL, NULL, NULL, NULL, 4),
(59789, NULL, 'G3DSA:3.40.50.300:FF:000232', NULL, NULL, 'ATP-binding cassette, sub-family A (ABC1), member 1', NULL, NULL, NULL, NULL, NULL, 4),
(59790, NULL, 'G3DSA:1.10.150.50:FF:000083', NULL, NULL, 'Kinase suppressor of ras', NULL, NULL, NULL, NULL, NULL, 4),
(59791, NULL, 'G3DSA:2.30.30.40:FF:000095', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(59792, NULL, 'G3DSA:3.90.280.10:FF:000009', NULL, NULL, 'Carboxypeptidase Y inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(59793, NULL, 'G3DSA:2.30.30.30:FF:000053', NULL, NULL, 'Protein RNA-directed DNA methylation 3', NULL, NULL, NULL, NULL, NULL, 4),
(59794, NULL, 'G3DSA:3.60.150.10:FF:000007', NULL, NULL, 'Chorismate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(59795, NULL, 'G3DSA:3.30.230.10:FF:000088', NULL, NULL, 'U5 small nuclear ribonuclear protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59796, NULL, 'G3DSA:1.10.287.3490:FF:000005', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 11', NULL, NULL, NULL, NULL, NULL, 4),
(59797, NULL, 'G3DSA:1.20.930.10:FF:000016', NULL, NULL, 'IWS1-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59798, NULL, 'G3DSA:2.40.100.10:FF:000029', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(59799, NULL, 'G3DSA:1.10.238.10:FF:000617', NULL, NULL, 'Fimbrin-2', NULL, NULL, NULL, NULL, NULL, 4),
(59800, NULL, 'G3DSA:3.30.160.40:FF:000017', NULL, NULL, 'Porphobilinogen deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(59801, NULL, 'G3DSA:3.40.1550.10:FF:000007', NULL, NULL, 'CheY-P-specific phosphatase CheC', NULL, NULL, NULL, NULL, NULL, 4),
(59802, NULL, 'G3DSA:2.60.120.650:FF:000135', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59803, NULL, 'G3DSA:2.60.40.10:FF:003290', NULL, NULL, 'Mcam protein', NULL, NULL, NULL, NULL, NULL, 4),
(59804, NULL, 'G3DSA:2.130.10.10:FF:002648', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59805, NULL, 'G3DSA:1.25.10.10:FF:000813', NULL, NULL, 'D-Importin 7/RanBP7', NULL, NULL, NULL, NULL, NULL, 4),
(59806, NULL, 'G3DSA:3.60.20.40:FF:000012', NULL, NULL, 'Probable bifunctional acylase ggtA: cephalosporin acylase + gamma-glutamyltranspeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(59807, NULL, 'G3DSA:3.40.50.300:FF:000575', NULL, NULL, 'ATP-dependent helicase hrpA', NULL, NULL, NULL, NULL, NULL, 4),
(59808, NULL, 'G3DSA:3.30.160.60:FF:002884', NULL, NULL, 'ZNF429 isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(59809, NULL, 'G3DSA:1.25.40.10:FF:004295', NULL, NULL, 'Putative ERAD-associated E3 ubiquitin-protein ligase component', NULL, NULL, NULL, NULL, NULL, 4),
(59810, NULL, 'G3DSA:3.90.180.10:FF:000013', NULL, NULL, 'L-arabinitol 4-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(59811, NULL, 'G3DSA:3.40.50.1820:FF:001659', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59812, NULL, 'G3DSA:1.20.5.5270:FF:000007', NULL, NULL, 'Lon protease', NULL, NULL, NULL, NULL, NULL, 4),
(59813, NULL, 'G3DSA:3.30.40.10:FF:001736', NULL, NULL, 'DNA repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(59814, NULL, 'G3DSA:2.130.10.10:FF:000850', NULL, NULL, 'WD40 repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(59815, NULL, 'G3DSA:2.60.120.260:FF:000288', NULL, NULL, 'Beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(59816, NULL, 'G3DSA:2.40.50.1070:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59817, NULL, 'G3DSA:3.30.160.60:FF:000810', NULL, NULL, 'Zgc:174563 protein', NULL, NULL, NULL, NULL, NULL, 4),
(59818, NULL, 'G3DSA:1.10.10.10:FF:000397', NULL, NULL, 'Vacuolar-sorting protein SNF8', NULL, NULL, NULL, NULL, NULL, 4),
(59819, NULL, 'G3DSA:3.40.50.2300:FF:000960', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59820, NULL, 'G3DSA:3.30.540.10:FF:000010', NULL, NULL, 'Sedoheptulose-1,7-bisphosphatase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(59821, NULL, 'G3DSA:1.20.1250.20:FF:002214', NULL, NULL, 'High affinity nitrate transporter 2.7', NULL, NULL, NULL, NULL, NULL, 4),
(59822, NULL, 'G3DSA:2.60.40.10:FF:001378', NULL, NULL, 'Immunoglobulin kappa variable 4-1', NULL, NULL, NULL, NULL, NULL, 4),
(59823, NULL, 'G3DSA:1.10.10.60:FF:000507', NULL, NULL, 'transcription factor LBX2', NULL, NULL, NULL, NULL, NULL, 4),
(59824, NULL, 'G3DSA:3.90.70.10:FF:000437', NULL, NULL, 'Cysteine protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59825, NULL, 'G3DSA:3.40.30.10:FF:000864', NULL, NULL, 'Calsequestrin', NULL, NULL, NULL, NULL, NULL, 4),
(59826, NULL, 'G3DSA:3.40.50.1100:FF:000196', NULL, NULL, 'D-cysteine desulfhydrase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(59827, NULL, 'G3DSA:3.40.50.2300:FF:000628', NULL, NULL, 'Glutamate receptor ionotropic, NMDA 3B', NULL, NULL, NULL, NULL, NULL, 4),
(59828, NULL, 'G3DSA:2.30.42.10:FF:000563', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59829, NULL, 'G3DSA:3.40.50.1820:FF:000355', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(59830, NULL, 'G3DSA:3.60.21.10:FF:000163', NULL, NULL, 'Nuclease SbcCD subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(59831, NULL, 'G3DSA:2.10.109.10:FF:000033', NULL, NULL, 'Peptidase S26B, signal peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(59832, NULL, 'G3DSA:1.20.58.760:FF:000010', NULL, NULL, 'ATP-dependent zinc metalloprotease FTSH', NULL, NULL, NULL, NULL, NULL, 4),
(59833, NULL, 'G3DSA:3.40.140.10:FF:000264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59834, NULL, 'G3DSA:2.40.50.140:FF:000199', NULL, NULL, 'tRNA-aminoacylation cofactor ARC1', NULL, NULL, NULL, NULL, NULL, 4),
(59835, NULL, 'G3DSA:2.30.29.30:FF:000201', NULL, NULL, 'arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(59836, NULL, 'G3DSA:2.60.120.330:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59837, NULL, 'G3DSA:3.40.50.620:FF:000322', NULL, NULL, 'Electron transfer flavoprotein alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(59838, NULL, 'G3DSA:3.40.50.720:FF:000526', NULL, NULL, 'D-mandelate dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59839, NULL, 'G3DSA:3.40.50.1820:FF:000299', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(59840, NULL, 'G3DSA:2.130.10.10:FF:000518', NULL, NULL, 'Small nucleolar ribonucleoprotein complex subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59841, NULL, 'G3DSA:2.10.25.10:FF:000991', NULL, NULL, 'Mucin-19', NULL, NULL, NULL, NULL, NULL, 4),
(59842, NULL, 'G3DSA:2.40.50.140:FF:000255', NULL, NULL, 'Single-stranded DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(59843, NULL, 'G3DSA:1.25.40.1040:FF:000015', NULL, NULL, 'Unplaced genomic scaffold supercont1.13, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(59844, NULL, 'G3DSA:1.10.287.130:FF:000087', NULL, NULL, 'Ethylene receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(59845, NULL, 'G3DSA:3.30.565.10:FF:000556', NULL, NULL, 'AAL093Cp', NULL, NULL, NULL, NULL, NULL, 4),
(59846, NULL, 'G3DSA:3.30.420.40:FF:000459', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(59847, NULL, 'G3DSA:1.10.287.70:FF:000220', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(59848, NULL, 'G3DSA:3.40.50.1000:FF:000677', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59849, NULL, 'G3DSA:3.10.50.10:FF:000058', NULL, NULL, 'Chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59850, NULL, 'G3DSA:1.20.1250.20:FF:000977', NULL, NULL, 'Solute carrier organic anion transporter family, member 5A1', NULL, NULL, NULL, NULL, NULL, 4),
(59851, NULL, 'G3DSA:3.40.50.12780:FF:000085', NULL, NULL, 'RfbL protein', NULL, NULL, NULL, NULL, NULL, 4),
(59852, NULL, 'G3DSA:1.20.58.2140:FF:000007', NULL, NULL, 'Translin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(59853, NULL, 'G3DSA:1.25.10.10:FF:000757', NULL, NULL, 'BHLHB9 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(59854, NULL, 'G3DSA:3.30.70.3490:FF:000004', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(59855, NULL, 'G3DSA:3.90.340.10:FF:000015', NULL, NULL, 'Nitric oxide synthase, inducible', NULL, NULL, NULL, NULL, NULL, 4),
(59856, NULL, 'G3DSA:1.20.58.390:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59857, NULL, 'G3DSA:3.30.497.10:FF:000043', NULL, NULL, 'Serine protease inhibitor (serpin) 19', NULL, NULL, NULL, NULL, NULL, 4),
(59858, NULL, 'G3DSA:3.30.420.10:FF:000299', NULL, NULL, 'Argonaute (Plant)-Like protein', NULL, NULL, NULL, NULL, NULL, 4),
(59859, NULL, 'G3DSA:3.20.20.300:FF:000017', NULL, NULL, 'Glycoside hydrolase family 3', NULL, NULL, NULL, NULL, NULL, 4),
(59860, NULL, 'G3DSA:2.60.120.200:FF:000242', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(59861, NULL, 'G3DSA:3.40.50.300:FF:003666', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59862, NULL, 'G3DSA:3.20.20.100:FF:000058', NULL, NULL, 'Aldose reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59863, NULL, 'G3DSA:3.90.228.20:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59864, NULL, 'G3DSA:2.130.10.30:FF:000171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59865, NULL, 'G3DSA:1.10.472.140:FF:000001', NULL, NULL, 'Retinoblastoma-like 2, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(59866, NULL, 'G3DSA:1.20.1070.10:FF:001483', NULL, NULL, 'Platelet-activating factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(59867, NULL, 'G3DSA:1.10.10.160:FF:000067', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(59868, NULL, 'G3DSA:3.40.50.2000:FF:000932', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59869, NULL, 'G3DSA:3.30.160.60:FF:001715', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59870, NULL, 'G3DSA:2.60.40.10:FF:004812', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59871, NULL, 'G3DSA:3.30.460.10:FF:000133', NULL, NULL, '2''-5''-oligoadenylate synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(59872, NULL, 'G3DSA:1.25.10.20:FF:000018', NULL, NULL, 'Microsomal triglyceride transfer protein large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(59873, NULL, 'G3DSA:3.30.40.10:FF:001175', NULL, NULL, 'Protein CBG13933', NULL, NULL, NULL, NULL, NULL, 4),
(59874, NULL, 'G3DSA:1.10.418.40:FF:000022', NULL, NULL, 'Beclin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(59875, NULL, 'G3DSA:1.10.10.10:FF:001358', NULL, NULL, 'Cell death protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(59876, NULL, 'G3DSA:1.10.287.940:FF:000009', NULL, NULL, 'P2X purinoceptor', NULL, NULL, NULL, NULL, NULL, 4),
(59877, NULL, 'G3DSA:1.25.40.10:FF:005132', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g15820, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(59878, NULL, 'G3DSA:3.40.50.300:FF:008337', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(59879, NULL, 'G3DSA:1.20.5.4820:FF:000013', NULL, NULL, 'LOW QUALITY PROTEIN: unconventional myosin-Ib', NULL, NULL, NULL, NULL, NULL, 4),
(59880, NULL, 'G3DSA:1.20.120.350:FF:000050', NULL, NULL, 'Solute carrier family 9 member C1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(59881, NULL, 'G3DSA:1.10.287.70:FF:000164', NULL, NULL, 'Voltage-sensitive potassium channel', NULL, NULL, NULL, NULL, NULL, 4),
(59882, NULL, 'G3DSA:1.25.40.10:FF:000461', NULL, NULL, 'cilia- and flagella-associated protein 70 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(59883, NULL, 'G3DSA:3.30.420.140:FF:000028', NULL, NULL, 'Suppressor of Ty 6 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(59884, NULL, 'G3DSA:1.20.1260.80:FF:000001', NULL, NULL, 'BARP protein', NULL, NULL, NULL, NULL, NULL, 4),
(59885, NULL, 'G3DSA:1.25.40.10:FF:000585', NULL, NULL, 'Tetratricopeptide repeat domain 37', NULL, NULL, NULL, NULL, NULL, 4),
(59886, NULL, 'G3DSA:3.90.550.10:FF:000733', NULL, NULL, 'Probable two-domain glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(59887, NULL, 'G3DSA:1.20.140.150:FF:000090', NULL, NULL, 'uncharacterized protein LOC100183788 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(59888, NULL, 'G3DSA:1.10.640.10:FF:000018', NULL, NULL, 'Peroxinectin A', NULL, NULL, NULL, NULL, NULL, 4),
(59889, NULL, 'G3DSA:2.60.40.60:FF:000128', NULL, NULL, 'neural-cadherin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(59890, NULL, 'G3DSA:4.10.280.10:FF:000030', NULL, NULL, 'Twist transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(59891, NULL, 'G3DSA:2.10.25.10:FF:000316', NULL, NULL, 'matrilin-2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(59892, NULL, 'G3DSA:3.30.900.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59893, NULL, 'G3DSA:1.10.472.80:FF:000064', NULL, NULL, 'GTPase-activating protein GYP3', NULL, NULL, NULL, NULL, NULL, 4),
(59894, NULL, 'G3DSA:3.30.70.270:FF:000274', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59895, NULL, 'G3DSA:1.10.287.920:FF:000003', NULL, NULL, 'Pheromone receptor', NULL, NULL, NULL, NULL, NULL, 4),
(59896, NULL, 'G3DSA:2.40.50.140:FF:000379', NULL, NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase PRP22', NULL, NULL, NULL, NULL, NULL, 4),
(59897, NULL, 'G3DSA:3.40.30.10:FF:000988', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59898, NULL, 'G3DSA:2.40.20.10:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59899, NULL, 'G3DSA:3.50.50.60:FF:000835', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(59900, NULL, 'G3DSA:3.30.40.10:FF:002012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59901, NULL, 'G3DSA:3.40.710.10:FF:000173', NULL, NULL, 'ABC1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(59902, NULL, 'G3DSA:3.30.200.20:FF:000937', NULL, NULL, 'Related to checkpoint kinase chk1', NULL, NULL, NULL, NULL, NULL, 4),
(59903, NULL, 'G3DSA:1.25.40.20:FF:001482', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59904, NULL, 'G3DSA:2.40.70.10:FF:000083', NULL, NULL, 'lysosomal aspartic protease', NULL, NULL, NULL, NULL, NULL, 4),
(59905, NULL, 'G3DSA:3.40.50.2300:FF:000808', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59906, NULL, 'G3DSA:1.10.1410.10:FF:000017', NULL, NULL, 'Putative nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(59907, NULL, 'G3DSA:2.60.40.10:FF:003851', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59908, NULL, 'G3DSA:1.10.730.10:FF:000177', NULL, NULL, 'Leucyl-tRNA synthetase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(59909, NULL, 'G3DSA:1.10.287.380:FF:000021', NULL, NULL, 'ABC transporter related', NULL, NULL, NULL, NULL, NULL, 4),
(59910, NULL, 'G3DSA:1.20.1730.10:FF:000106', NULL, NULL, 'Sodium-dependent glucose transporter SGLT-I', NULL, NULL, NULL, NULL, NULL, 4),
(59911, NULL, 'G3DSA:3.30.1490.80:FF:000003', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(59912, NULL, 'G3DSA:3.30.1010.10:FF:000031', NULL, NULL, 'Phosphatidylinositol 4-kinase beta', NULL, NULL, NULL, NULL, NULL, 4),
(59913, NULL, 'G3DSA:2.60.40.340:FF:000005', NULL, NULL, 'RELB proto-oncogene, NF-kB subunit', NULL, NULL, NULL, NULL, NULL, 4),
(59914, NULL, 'G3DSA:2.60.120.330:FF:000045', NULL, NULL, 'Oxidoreductase, 2OG-Fe(II) oxygenase family, putative', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(59915, NULL, 'G3DSA:2.60.40.790:FF:000174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59916, NULL, 'G3DSA:3.30.160.60:FF:000754', NULL, NULL, 'Zinc finger protein 585A', NULL, NULL, NULL, NULL, NULL, 4),
(59917, NULL, 'G3DSA:1.10.1380.10:FF:000019', NULL, NULL, 'Fra mauro, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(59918, NULL, 'G3DSA:3.30.200.20:FF:001213', NULL, NULL, 'Os04g0616200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(59919, NULL, 'G3DSA:1.25.10.10:FF:000072', NULL, NULL, 'dnaJ homolog subfamily C member 13 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(59920, NULL, 'G3DSA:2.40.50.140:FF:001216', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59921, NULL, 'G3DSA:2.130.10.10:FF:004560', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59922, NULL, 'G3DSA:1.10.1200.240:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59923, NULL, 'G3DSA:2.40.50.690:FF:000009', NULL, NULL, 'Probable DIS3 3`-5` exoribonuclease required for 3` end formation of 5.8S rRNA', NULL, NULL, NULL, NULL, NULL, 4),
(59924, NULL, 'G3DSA:3.30.70.330:FF:002282', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59925, NULL, 'G3DSA:1.20.1250.20:FF:000292', NULL, NULL, 'Inner membrane transporter YdiM', NULL, NULL, NULL, NULL, NULL, 4),
(59926, NULL, 'G3DSA:2.20.70.10:FF:000139', NULL, NULL, 'E3 ubiquitin-protein ligase Smurf1', NULL, NULL, NULL, NULL, NULL, 4),
(59927, NULL, 'G3DSA:3.40.50.620:FF:000266', NULL, NULL, 'Isoleucine--tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59928, NULL, 'G3DSA:1.10.287.70:FF:000563', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59929, NULL, 'G3DSA:1.10.3470.10:FF:000021', NULL, NULL, 'Staphyloferrin B ABC transporter permease subunit', NULL, NULL, NULL, NULL, NULL, 4),
(59930, NULL, 'G3DSA:3.10.20.90:FF:000708', NULL, NULL, 'Ubiquilin', NULL, NULL, NULL, NULL, NULL, 4),
(59931, NULL, 'G3DSA:3.40.50.720:FF:000706', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(59932, NULL, 'G3DSA:3.30.200.20:FF:000414', NULL, NULL, 'Putative serine/threonine-protein kinase haspin', NULL, NULL, NULL, NULL, NULL, 4),
(59933, NULL, 'G3DSA:1.10.287.110:FF:000261', NULL, NULL, 'DnaJ_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(59934, NULL, 'G3DSA:3.40.50.1000:FF:000497', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(59935, NULL, 'G3DSA:1.20.1270.10:FF:000026', NULL, NULL, 'Heat shock 70-related protein 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(59936, NULL, 'G3DSA:2.170.120.40:FF:000003', NULL, NULL, 'YbbR-like domain-containing protein ybbR', NULL, NULL, NULL, NULL, NULL, 4),
(59937, NULL, 'G3DSA:2.60.40.10:FF:002491', NULL, NULL, 'T cell receptor beta variable 12-4', NULL, NULL, NULL, NULL, NULL, 4),
(59938, NULL, 'G3DSA:1.20.144.10:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59939, NULL, 'G3DSA:3.30.160.60:FF:001030', NULL, NULL, 'Zinc finger protein 407', NULL, NULL, NULL, NULL, NULL, 4),
(59940, NULL, 'G3DSA:4.10.60.10:FF:000157', NULL, NULL, 'Cleavage and polyadenylation specificity factor 30 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(59941, NULL, 'G3DSA:1.10.510.10:FF:000537', NULL, NULL, 'Putative receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(59942, NULL, 'G3DSA:1.25.40.10:FF:004856', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59943, NULL, 'G3DSA:3.30.160.60:FF:004464', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59944, NULL, 'G3DSA:3.80.10.10:FF:000693', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase EFR', NULL, NULL, NULL, NULL, NULL, 4),
(59945, NULL, 'G3DSA:3.40.50.300:FF:007376', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59946, NULL, 'G3DSA:2.60.40.770:FF:000016', NULL, NULL, 'AGAP002852-PA', NULL, NULL, NULL, NULL, NULL, 4),
(59947, NULL, 'G3DSA:3.30.565.10:FF:000213', NULL, NULL, 'Sensor histidine kinase, KdpD', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(59948, NULL, 'G3DSA:1.25.40.10:FF:001422', NULL, NULL, 'HAT1-interacting factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(59949, NULL, 'G3DSA:3.40.225.10:FF:000017', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(59950, NULL, 'G3DSA:1.20.1560.10:FF:000801', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59951, NULL, 'G3DSA:1.10.510.10:FF:001830', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59952, NULL, 'G3DSA:3.30.160.60:FF:001631', NULL, NULL, 'Zinc finger protein 836', NULL, NULL, NULL, NULL, NULL, 4),
(59953, NULL, 'G3DSA:1.25.10.10:FF:001437', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59954, NULL, 'G3DSA:1.10.8.720:FF:000029', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59955, NULL, 'G3DSA:1.10.1420.10:FF:000170', NULL, NULL, 'Gll4003 protein', NULL, NULL, NULL, NULL, NULL, 4),
(59956, NULL, 'G3DSA:2.30.29.30:FF:000364', NULL, NULL, 'Rho guanyl nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(59957, NULL, 'G3DSA:2.130.10.10:FF:003767', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59958, NULL, 'G3DSA:1.20.1560.10:FF:000374', NULL, NULL, 'HlyB/MsbA family ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(59959, NULL, 'G3DSA:3.80.10.10:FF:000620', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(59960, NULL, 'G3DSA:1.10.472.10:FF:000476', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59961, NULL, 'G3DSA:2.10.110.10:FF:000357', NULL, NULL, 'LIM domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(59962, NULL, 'G3DSA:3.60.20.10:FF:000065', NULL, NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', NULL, NULL, NULL, NULL, NULL, 4),
(59963, NULL, 'G3DSA:3.30.40.10:FF:000871', NULL, NULL, 'SNF2 family helicase/ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59964, NULL, 'G3DSA:1.20.1070.10:FF:001455', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59965, NULL, 'G3DSA:2.40.170.20:FF:000008', NULL, NULL, 'TonB-linked outer membrane protein, SusC/RagA family', NULL, NULL, NULL, NULL, NULL, 4),
(59966, NULL, 'G3DSA:1.10.8.270:FF:000175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59967, NULL, 'G3DSA:2.130.10.10:FF:000541', NULL, NULL, 'PWP2, small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4),
(59968, NULL, 'G3DSA:1.20.1440.340:FF:000008', NULL, NULL, 'Galactokinase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(59969, NULL, 'G3DSA:3.40.50.10090:FF:000036', NULL, NULL, 'Uroporphyrinogen-iii synthase', NULL, NULL, NULL, NULL, NULL, 4),
(59970, NULL, 'G3DSA:3.40.50.2000:FF:000376', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(59971, NULL, 'G3DSA:1.20.58.390:FF:000293', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59972, NULL, 'G3DSA:3.40.50.10900:FF:000021', NULL, NULL, 'Proteasome assembly chaperone 2', NULL, NULL, NULL, NULL, NULL, 4),
(59973, NULL, 'G3DSA:3.40.50.10380:FF:000016', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(59974, NULL, 'G3DSA:1.10.510.10:FF:004264', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59975, NULL, 'G3DSA:1.10.8.10:FF:000126', NULL, NULL, 'Enhancer of EfL-1 mutant phenotype', NULL, NULL, NULL, NULL, NULL, 4),
(59976, NULL, 'G3DSA:1.20.58.150:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59977, NULL, 'G3DSA:1.20.1070.10:FF:001938', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59978, NULL, 'G3DSA:1.10.1370.30:FF:000047', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(59979, NULL, 'G3DSA:1.10.10.10:FF:000768', NULL, NULL, 'Transcriptional regulator, MarR family', NULL, NULL, NULL, NULL, NULL, 4),
(59980, NULL, 'G3DSA:3.40.50.2300:FF:000359', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(59981, NULL, 'G3DSA:2.30.30.40:FF:000319', NULL, NULL, 'CIN85 and CD2AP related, isoform C', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(59982, NULL, 'G3DSA:1.10.510.10:FF:000565', NULL, NULL, 'Serine/threonine-protein kinase ATG1a', NULL, NULL, NULL, NULL, NULL, 4),
(59983, NULL, 'G3DSA:3.20.20.60:FF:000059', NULL, NULL, 'Acyl-CoA lyase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(59984, NULL, 'G3DSA:1.25.40.10:FF:003991', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(59985, NULL, 'G3DSA:2.30.30.40:FF:000275', NULL, NULL, 'Chemotaxis protein CheW', NULL, NULL, NULL, NULL, NULL, 4),
(59986, NULL, 'G3DSA:3.40.50.1000:FF:000738', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59987, NULL, 'G3DSA:2.60.120.1030:FF:000002', NULL, NULL, 'Clp1-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59988, NULL, 'G3DSA:1.20.1260.10:FF:000020', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(59989, NULL, 'G3DSA:1.20.58.60:FF:000201', NULL, NULL, 'nesprin-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(59990, NULL, 'G3DSA:1.10.287.110:FF:000457', NULL, NULL, 'DnaJ (Hsp40), subfamily C, member 13, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59991, NULL, 'G3DSA:3.50.50.60:FF:000419', NULL, NULL, 'Probable dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(59992, NULL, 'G3DSA:3.90.1150.210:FF:000002', NULL, NULL, 'F-actin-capping protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(59993, NULL, 'G3DSA:2.40.30.10:FF:000119', NULL, NULL, 'Blast:Translation initiation factor IF-2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(59994, NULL, 'G3DSA:3.40.1190.20:FF:000112', NULL, NULL, 'PfkB-like carbohydrate kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(59995, NULL, 'G3DSA:1.20.1310.10:FF:000226', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(59996, NULL, 'G3DSA:3.40.850.10:FF:000132', NULL, NULL, 'Kinesin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(59997, NULL, 'G3DSA:3.40.190.10:FF:000907', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(59998, NULL, 'G3DSA:3.40.50.740:FF:000021', NULL, NULL, 'NADH:ubiquinone oxidoreductase core subunit S1', NULL, NULL, NULL, NULL, NULL, 4),
(59999, NULL, 'G3DSA:1.25.10.10:FF:002426', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60000, NULL, 'G3DSA:2.20.70.10:FF:000038', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(60001, NULL, 'G3DSA:3.40.50.300:FF:002492', NULL, NULL, 'GTP-binding protein YPT11', NULL, NULL, NULL, NULL, NULL, 4),
(60002, NULL, 'G3DSA:2.30.30.380:FF:000033', NULL, NULL, 'Endonuclease/Exonuclease/phosphatase family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(60003, NULL, 'G3DSA:3.40.630.10:FF:000251', NULL, NULL, 'Putative N-acyl-L-amino acid amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(60004, NULL, 'G3DSA:3.40.30.10:FF:000595', NULL, NULL, 'Cytochrome c oxidase assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(60005, NULL, 'G3DSA:2.130.10.10:FF:006038', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(60006, NULL, 'G3DSA:3.40.50.1820:FF:000451', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(60007, NULL, 'G3DSA:3.30.1490.40:FF:000002', NULL, NULL, 'CD2 antigen cytoplasmic tail-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(60008, NULL, 'G3DSA:3.30.300.110:FF:000015', NULL, NULL, 'Protein CBG19351', NULL, NULL, NULL, NULL, NULL, 4),
(60009, NULL, 'G3DSA:1.10.110.10:FF:000001', NULL, NULL, 'Bifunctional inhibitor/lipid-transfer protein/seed storage 2S albumin superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(60010, NULL, 'G3DSA:1.25.10.10:FF:000818', NULL, NULL, 'Pumilio homolog 24', NULL, NULL, NULL, NULL, NULL, 4),
(60011, NULL, 'G3DSA:1.10.3720.10:FF:000226', NULL, NULL, 'Putative polyamine transport system, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(60012, NULL, 'G3DSA:3.40.1110.10:FF:000233', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60013, NULL, 'G3DSA:2.10.25.10:FF:000283', NULL, NULL, 'sushi, nidogen and EGF-like domain-containing protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(60014, NULL, 'G3DSA:1.10.10.10:FF:000329', NULL, NULL, 'regulator of G-protein signaling 9 isoform X2', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(60015, NULL, 'G3DSA:3.30.40.10:FF:001490', NULL, NULL, 'Putative zinc finger in N-recognin-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(60016, NULL, 'G3DSA:1.10.510.10:FF:003319', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60017, NULL, 'G3DSA:1.10.730.10:FF:000093', NULL, NULL, 'Methionine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(60018, NULL, 'G3DSA:3.40.50.300:FF:001873', NULL, NULL, 'ABC transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(60019, NULL, 'G3DSA:1.25.40.10:FF:002563', NULL, NULL, 'Leucine-rich PPR motif-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(60020, NULL, 'G3DSA:2.130.10.10:FF:003284', NULL, NULL, 'Pre-mRNA-splicing factor RSE1', NULL, NULL, NULL, NULL, NULL, 4),
(60021, NULL, 'G3DSA:3.30.70.2600:FF:000002', NULL, NULL, 'Dipeptidyl peptidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(60022, NULL, 'G3DSA:1.20.58.120:FF:000009', NULL, NULL, 'BAG family molecular chaperone regulator 5', NULL, NULL, NULL, NULL, NULL, 4),
(60023, NULL, 'G3DSA:3.90.550.10:FF:000284', NULL, NULL, 'Glycosyl transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(60024, NULL, 'G3DSA:3.30.70.330:FF:000314', NULL, NULL, 'RNA-binding protein Musashi Rbp6', NULL, NULL, NULL, NULL, NULL, 4),
(60025, NULL, 'G3DSA:3.90.320.10:FF:000036', NULL, NULL, 'CRISPR-associated exonuclease Cas4', NULL, NULL, NULL, NULL, NULL, 4),
(60026, NULL, 'G3DSA:1.25.10.10:FF:002382', NULL, NULL, 'Cullin-associated NEDD8-dissociated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(60027, NULL, 'G3DSA:3.40.50.300:FF:006235', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(60028, NULL, 'G3DSA:1.20.1070.10:FF:002074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60029, NULL, 'G3DSA:3.90.550.10:FF:000654', NULL, NULL, 'Dolichyl-phosphate beta-D-mannosyltransferase related protein', NULL, NULL, NULL, NULL, NULL, 4),
(60030, NULL, 'G3DSA:3.30.460.20:FF:000023', NULL, NULL, 'Magnesium/cobalt transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(60031, NULL, 'G3DSA:3.40.30.10:FF:001112', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(60032, NULL, 'G3DSA:1.20.58.2050:FF:000008', NULL, NULL, 'DNA replication complex GINS protein psf3', NULL, NULL, NULL, NULL, NULL, 4),
(60033, NULL, 'G3DSA:1.20.1310.10:FF:000182', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60034, NULL, 'G3DSA:1.25.40.120:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60035, NULL, 'G3DSA:2.130.10.30:FF:000108', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60036, NULL, 'G3DSA:2.130.10.10:FF:002339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60037, NULL, 'G3DSA:2.70.150.10:FF:000172', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(60038, NULL, 'G3DSA:3.90.1260.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60039, NULL, 'G3DSA:3.40.50.450:FF:000041', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(60040, NULL, 'G3DSA:3.40.720.10:FF:000050', NULL, NULL, 'Extracellular sulfatase SULF-1', NULL, NULL, NULL, NULL, NULL, 4),
(60041, NULL, 'G3DSA:3.10.440.10:FF:000001', NULL, NULL, '60S ribosomal protein L31', NULL, NULL, NULL, NULL, NULL, 4),
(60042, NULL, 'G3DSA:1.20.58.60:FF:000673', NULL, NULL, 'Nesprin-2', NULL, NULL, NULL, NULL, NULL, 4),
(60043, NULL, 'G3DSA:2.102.10.10:FF:000020', NULL, NULL, 'Aromatic ring-hydroxylating dioxygenase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(60044, NULL, 'G3DSA:2.40.160.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60045, NULL, 'G3DSA:1.25.40.1040:FF:000043', NULL, NULL, 'Chromosome 21, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(60046, NULL, 'G3DSA:1.10.418.10:FF:000058', NULL, NULL, 'F-actin-methionine sulfoxide oxidase MICAL1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(60047, NULL, 'G3DSA:2.40.50.140:FF:001267', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(60048, NULL, 'G3DSA:3.40.50.1910:FF:000017', NULL, NULL, 'BnaA02g18530D protein', NULL, NULL, NULL, NULL, NULL, 4),
(60049, NULL, 'G3DSA:3.30.160.60:FF:003429', NULL, NULL, 'Zinc finger protein 1179', NULL, NULL, NULL, NULL, NULL, 4),
(60050, NULL, 'G3DSA:1.20.120.420:FF:000020', NULL, NULL, 'Translation initiation factor EIF-2B subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(60051, NULL, 'G3DSA:1.10.10.10:FF:001274', NULL, NULL, '(R,S)-reticuline 7-O-methyltransferase isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(60052, NULL, 'G3DSA:3.30.160.60:FF:004857', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60053, NULL, 'G3DSA:2.60.40.10:FF:003643', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60054, NULL, 'G3DSA:2.60.40.10:FF:001182', NULL, NULL, 'T-cell immunoreceptor with Ig and ITIM domains', NULL, NULL, NULL, NULL, NULL, 4),
(60055, NULL, 'G3DSA:3.40.50.300:FF:000928', NULL, NULL, 'Pilus assembly protein CpaF', NULL, NULL, NULL, NULL, NULL, 4),
(60056, NULL, 'G3DSA:2.30.250.10:FF:000014', NULL, NULL, 'Clan MH, family M18, aspartyl aminopeptidase-like metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(60057, NULL, 'G3DSA:2.70.170.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60058, NULL, 'G3DSA:3.30.40.10:FF:002327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60059, NULL, 'G3DSA:3.90.180.10:FF:000064', NULL, NULL, 'NADPH-dependent alkenal/one oxidoreductase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(60060, NULL, 'G3DSA:3.60.10.10:FF:000430', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(60061, NULL, 'G3DSA:1.10.150.20:FF:000259', NULL, NULL, 'Probable DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(60062, NULL, 'G3DSA:2.60.40.10:FF:000237', NULL, NULL, 'Sidekick cell adhesion molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(60063, NULL, 'G3DSA:1.10.8.60:FF:000310', NULL, NULL, 'RAD17 checkpoint clamp loader component', NULL, NULL, NULL, NULL, NULL, 4),
(60064, NULL, 'G3DSA:3.30.50.10:FF:000164', NULL, NULL, 'Zinc finger, C4 type, putative', NULL, NULL, NULL, NULL, NULL, 4),
(60065, NULL, 'G3DSA:1.20.1460.10:FF:000001', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(60066, NULL, 'G3DSA:1.10.510.10:FF:000902', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(60067, NULL, 'G3DSA:3.30.450.20:FF:000225', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(60068, NULL, 'G3DSA:2.60.40.60:FF:000319', NULL, NULL, 'FAT atypical cadherin 1b', NULL, NULL, NULL, NULL, NULL, 4),
(60069, NULL, 'G3DSA:2.60.40.10:FF:004632', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60070, NULL, 'G3DSA:1.20.1050.10:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60071, NULL, 'G3DSA:3.30.200.20:FF:000858', NULL, NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(60072, NULL, 'G3DSA:3.40.50.80:FF:000246', NULL, NULL, 'NADPH oxidase 4', NULL, NULL, NULL, NULL, NULL, 4),
(60073, NULL, 'G3DSA:3.40.1280.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60074, NULL, 'G3DSA:3.40.50.1980:FF:000127', NULL, NULL, 'Vitamin B12 ABC transporter, B12-binding component BtuF', NULL, NULL, NULL, NULL, NULL, 4),
(60075, NULL, 'G3DSA:3.30.230.10:FF:000357', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60076, NULL, 'G3DSA:1.25.40.10:FF:003182', NULL, NULL, 'Os03g0283500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(60077, NULL, 'G3DSA:1.25.40.530:FF:000005', NULL, NULL, 'Kinesin-like calmodulin-binding protein (ZWICHEL)', NULL, NULL, NULL, NULL, NULL, 4),
(60078, NULL, 'G3DSA:3.40.50.11380:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60079, NULL, 'G3DSA:3.40.630.30:FF:000627', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60080, NULL, 'G3DSA:3.30.870.10:FF:000170', NULL, NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(60081, NULL, 'G3DSA:3.90.45.10:FF:000003', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(60082, NULL, 'G3DSA:3.40.50.970:FF:000005', NULL, NULL, '1-deoxy-D-xylulose-5-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(60083, NULL, 'G3DSA:2.10.70.10:FF:000016', NULL, NULL, 'Mannan-binding lectin serine protease 1', NULL, NULL, NULL, NULL, NULL, 4),
(60084, NULL, 'G3DSA:1.20.140.30:FF:000006', NULL, NULL, 'Mob1p', NULL, NULL, NULL, NULL, NULL, 4),
(60085, NULL, 'G3DSA:1.10.1520.10:FF:000115', NULL, NULL, 'Dicer-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(60086, NULL, 'G3DSA:3.40.50.300:FF:005616', NULL, NULL, 'Dynein, axonemal, heavy chain 11', NULL, NULL, NULL, NULL, NULL, 4),
(60087, NULL, 'G3DSA:1.25.10.10:FF:002735', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60088, NULL, 'G3DSA:3.40.50.300:FF:007180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60089, NULL, 'G3DSA:3.30.559.10:FF:000013', NULL, NULL, 'Peroxisomal carnitine O-octanoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(60090, NULL, 'G3DSA:2.30.29.30:FF:000701', NULL, NULL, 'Vacuolar protein-sorting-associated protein 36', NULL, NULL, NULL, NULL, NULL, 4),
(60091, NULL, 'G3DSA:3.30.160.60:FF:000675', NULL, NULL, 'Zinc finger protein 624', NULL, NULL, NULL, NULL, NULL, 4),
(60092, NULL, 'G3DSA:1.20.58.1070:FF:000012', NULL, NULL, 'WGS project CABT00000000 data, contig 2.4', NULL, NULL, NULL, NULL, NULL, 4),
(60093, NULL, 'G3DSA:3.40.50.150:FF:001367', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60094, NULL, 'G3DSA:1.20.80.10:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60095, NULL, 'G3DSA:3.40.50.1000:FF:000429', NULL, NULL, '4-nitrophenylphosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(60096, NULL, 'G3DSA:3.80.10.10:FF:001446', NULL, NULL, 'Si:ch211-11p18.6', NULL, NULL, NULL, NULL, NULL, 4),
(60097, NULL, 'G3DSA:1.20.5.190:FF:000025', NULL, NULL, 'IQ motif containing E', NULL, NULL, NULL, NULL, NULL, 4),
(60098, NULL, 'G3DSA:3.30.420.40:FF:000246', NULL, NULL, 'Xks1p', NULL, NULL, NULL, NULL, NULL, 4),
(60099, NULL, 'G3DSA:3.40.50.10800:FF:000007', NULL, NULL, 'Quinolinate synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(60100, NULL, 'G3DSA:3.30.420.10:FF:000720', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60101, NULL, 'G3DSA:1.20.1070.10:FF:000027', NULL, NULL, 'alpha-1A adrenergic receptor', NULL, NULL, NULL, NULL, NULL, 4),
(60102, NULL, 'G3DSA:3.30.70.330:FF:001725', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60103, NULL, 'G3DSA:3.30.559.30:FF:000019', NULL, NULL, 'Nonribosomal siderophore peptide synthase SidC', NULL, NULL, NULL, NULL, NULL, 4),
(60104, NULL, 'G3DSA:3.30.2090.10:FF:000008', NULL, NULL, 'Cation efflux system protein CusA', NULL, NULL, NULL, NULL, NULL, 4),
(60105, NULL, 'G3DSA:2.10.60.10:FF:000061', NULL, NULL, 'TGF-beta receptor type-2', NULL, NULL, NULL, NULL, NULL, 4),
(60106, NULL, 'G3DSA:1.10.10.2830:FF:000003', NULL, NULL, 'Probable chromosome 2-partitioning protein ParB', NULL, NULL, NULL, NULL, NULL, 4),
(60107, NULL, 'G3DSA:3.10.450.50:FF:000093', NULL, NULL, 'Uncharacterized protein C11D3.04c', NULL, NULL, NULL, NULL, NULL, 4),
(60108, NULL, 'G3DSA:1.25.40.10:FF:004019', NULL, NULL, 'Lysine (K)-specific demethylase 6A,-like', NULL, NULL, NULL, NULL, NULL, 4),
(60109, NULL, 'G3DSA:2.60.40.10:FF:005088', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60110, NULL, 'G3DSA:3.30.750.24:FF:000011', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(60111, NULL, 'G3DSA:3.40.5.10:FF:000026', NULL, NULL, '50S ribosomal protein L9 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(60112, NULL, 'G3DSA:1.25.40.20:FF:000003', NULL, NULL, 'Ankyrin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(60113, NULL, 'G3DSA:3.80.10.10:FF:002065', NULL, NULL, 'Disease resistance protein RPS6', NULL, NULL, NULL, NULL, NULL, 4),
(60114, NULL, 'G3DSA:3.40.50.2300:FF:000729', NULL, NULL, 'Olfactory receptor C family, g2', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(60115, NULL, 'G3DSA:1.10.287.1080:FF:000018', NULL, NULL, 'Nucleotide pyrophosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(60116, NULL, 'G3DSA:1.10.533.10:FF:000129', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(60117, NULL, 'G3DSA:3.20.20.80:FF:000245', NULL, NULL, 'Histone H2B', NULL, NULL, NULL, NULL, NULL, 4),
(60118, NULL, 'G3DSA:3.40.50.150:FF:000850', NULL, NULL, 'Uncharacterized methyltransferase C977.03', NULL, NULL, NULL, NULL, NULL, 4),
(60119, NULL, 'G3DSA:2.60.40.2170:FF:000012', NULL, NULL, 'AGAP006405-PA', NULL, NULL, NULL, NULL, NULL, 4),
(60120, NULL, 'G3DSA:2.170.270.10:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60121, NULL, 'G3DSA:2.60.40.10:FF:004941', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60122, NULL, 'G3DSA:2.60.40.1930:FF:000013', NULL, NULL, 'Alpha-2-macroglobulin like 1', NULL, NULL, NULL, NULL, NULL, 4),
(60123, NULL, 'G3DSA:4.10.1000.10:FF:000107', NULL, NULL, 'Nuclear fragile X mental retardation-interacting protein 1-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(60124, NULL, 'G3DSA:1.20.1070.10:FF:001808', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60125, NULL, 'G3DSA:2.40.100.10:FF:000057', NULL, NULL, 'Cyclophilin 14, putative', NULL, NULL, NULL, NULL, NULL, 4),
(60126, NULL, 'G3DSA:2.10.25.10:FF:001581', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(60127, NULL, 'G3DSA:1.20.120.720:FF:000003', NULL, NULL, 'Putative unconventional myosin-IXa', NULL, NULL, NULL, NULL, NULL, 4),
(60128, NULL, 'G3DSA:2.30.30.100:FF:000011', NULL, NULL, 'small nuclear ribonucleoprotein F', NULL, NULL, NULL, NULL, NULL, 4),
(60129, NULL, 'G3DSA:1.20.120.80:FF:000014', NULL, NULL, 'Cytochrome c oxidase subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(60130, NULL, 'G3DSA:1.10.510.10:FF:001993', NULL, NULL, 'Serine/threonine-protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(60131, NULL, 'G3DSA:2.60.40.3170:FF:000003', NULL, NULL, 'tripeptidyl-peptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(60132, NULL, 'G3DSA:3.20.20.70:FF:000388', NULL, NULL, 'Histone acetyltransferase Elp3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(60133, NULL, 'G3DSA:2.40.50.140:FF:000648', NULL, NULL, 'Mitochondrial 37S ribosomal protein S17', NULL, NULL, NULL, NULL, NULL, 4),
(60134, NULL, 'G3DSA:1.25.40.10:FF:002693', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60135, NULL, 'G3DSA:2.40.50.140:FF:000278', NULL, NULL, 'rRNA biogenesis protein rrp5', NULL, NULL, NULL, NULL, NULL, 4),
(60136, NULL, 'G3DSA:2.60.120.200:FF:000141', NULL, NULL, 'L-type lectin-domain containing receptor kinase VIII.1', NULL, NULL, NULL, NULL, NULL, 4),
(60137, NULL, 'G3DSA:2.130.10.30:FF:000064', NULL, NULL, 'RCC1 domain-containing protein RUG3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(60138, NULL, 'G3DSA:2.40.10.10:FF:000236', NULL, NULL, 'Putative trypsin', NULL, NULL, NULL, NULL, NULL, 4),
(60139, NULL, 'G3DSA:1.25.40.10:FF:004963', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g62260, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(60140, NULL, 'G3DSA:3.30.310.10:FF:000049', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(60141, NULL, 'G3DSA:2.10.110.10:FF:000227', NULL, NULL, 'Protein DA1-related 5', NULL, NULL, NULL, NULL, NULL, 4),
(60142, NULL, 'G3DSA:2.30.42.10:FF:000187', NULL, NULL, 'Na(+)/H(+) exchange regulatory cofactor NHE-RF3', NULL, NULL, NULL, NULL, NULL, 4),
(60143, NULL, 'G3DSA:1.25.40.860:FF:000020', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(60144, NULL, 'G3DSA:2.60.40.10:FF:003008', NULL, NULL, 'Probable beta-D-xylosidase 5', NULL, NULL, NULL, NULL, NULL, 4),
(60145, NULL, 'G3DSA:3.90.70.10:FF:000325', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 33', NULL, NULL, NULL, NULL, NULL, 4),
(60146, NULL, 'G3DSA:3.40.50.620:FF:000131', NULL, NULL, '7-cyano-7-deazaguanine synthase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(60147, NULL, 'G3DSA:1.25.10.10:FF:003371', NULL, NULL, 'Unc-45 homolog B (C. elegans) (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(60148, NULL, 'G3DSA:3.30.160.60:FF:004048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60149, NULL, 'G3DSA:2.40.70.10:FF:000228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60150, NULL, 'G3DSA:3.40.30.10:FF:000948', NULL, NULL, 'Thioredoxin domain containing 12', NULL, NULL, NULL, NULL, NULL, 4),
(60151, NULL, 'G3DSA:2.10.50.10:FF:000133', NULL, NULL, 'Ephrin type-B receptor 5', NULL, NULL, NULL, NULL, NULL, 4),
(60152, NULL, 'G3DSA:3.80.10.10:FF:003846', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(60153, NULL, 'G3DSA:3.30.720.170:FF:000004', NULL, NULL, 'Perilipin', NULL, NULL, NULL, NULL, NULL, 4),
(60154, NULL, 'G3DSA:3.40.50.150:FF:000541', NULL, NULL, 'Putative O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(60155, NULL, 'G3DSA:3.90.740.10:FF:000028', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(60156, NULL, 'G3DSA:2.60.40.60:FF:000780', NULL, NULL, 'Cadherin 15, type 1, M-cadherin (myotubule)', NULL, NULL, NULL, NULL, NULL, 4),
(60157, NULL, 'G3DSA:3.30.70.330:FF:002670', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60158, NULL, 'G3DSA:1.10.260.50:FF:000001', NULL, NULL, 'Selenocysteine lyase', NULL, NULL, NULL, NULL, NULL, 4),
(60159, NULL, 'G3DSA:3.30.1370.210:FF:000018', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(60160, NULL, 'G3DSA:1.20.1070.10:FF:000527', NULL, NULL, 'Parathyroid hormone/parathyroid hormone-related peptide receptor', NULL, NULL, NULL, NULL, NULL, 4),
(60161, NULL, 'G3DSA:3.40.50.1820:FF:000804', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(60162, NULL, 'G3DSA:3.50.50.60:FF:000728', NULL, NULL, 'WGS project CABT00000000 data, contig 2.37', NULL, NULL, NULL, NULL, NULL, 4),
(60163, NULL, 'G3DSA:1.25.40.10:FF:003210', NULL, NULL, 'SEL-1', NULL, NULL, NULL, NULL, NULL, 4),
(60164, NULL, 'G3DSA:3.20.20.190:FF:000091', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(60165, NULL, 'G3DSA:2.60.260.20:FF:000117', NULL, NULL, 'DnaJ protein', NULL, NULL, NULL, NULL, NULL, 4),
(60166, NULL, 'G3DSA:1.25.10.10:FF:002073', NULL, NULL, 'Transportin2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(60167, NULL, 'G3DSA:1.10.510.10:FF:000874', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(60168, NULL, 'G3DSA:1.20.1250.20:FF:000393', NULL, NULL, 'solute carrier family 45 member 3', NULL, NULL, NULL, NULL, NULL, 4),
(60169, NULL, 'G3DSA:1.10.510.10:FF:003336', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60170, NULL, 'G3DSA:3.30.160.60:FF:005537', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60171, NULL, 'G3DSA:1.10.510.10:FF:002482', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60172, NULL, 'G3DSA:1.10.730.10:FF:000076', NULL, NULL, 'Leucyl-tRNA synthetase, cytoplasmic, putative', NULL, NULL, NULL, NULL, NULL, 4),
(60173, NULL, 'G3DSA:1.20.990.10:FF:000025', NULL, NULL, 'Oxidoreductase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(60174, NULL, 'G3DSA:3.90.320.10:FF:000053', NULL, NULL, 'CRISPR-associated exonuclease Cas4', NULL, NULL, NULL, NULL, NULL, 4),
(60175, NULL, 'G3DSA:3.30.420.150:FF:000014', NULL, NULL, 'Ectonucleoside triphosphate diphosphohydrolase 6', NULL, NULL, NULL, NULL, NULL, 4),
(60176, NULL, 'G3DSA:1.20.1070.10:FF:002091', NULL, NULL, 'Transmembrane receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(60177, NULL, 'G3DSA:3.90.25.10:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60178, NULL, 'G3DSA:3.40.50.2000:FF:000600', NULL, NULL, 'GD20680', NULL, NULL, NULL, NULL, NULL, 4),
(60179, NULL, 'G3DSA:3.40.50.1700:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60180, NULL, 'G3DSA:2.30.29.30:FF:001292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(60181, NULL, 'G3DSA:3.30.565.10:FF:000073', NULL, NULL, 'DNA topoisomerase II large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(60182, NULL, 'G3DSA:1.10.287.1490:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60183, NULL, 'G3DSA:3.30.40.10:FF:000399', NULL, NULL, 'SNF2 helicase, putative (ISWI)', NULL, NULL, NULL, NULL, NULL, 4),
(60184, NULL, 'G3DSA:3.30.40.10:FF:000219', NULL, NULL, 'PHD finger protein 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(60185, NULL, 'G3DSA:2.20.110.10:FF:000012', NULL, NULL, 'Junctophilin', NULL, NULL, NULL, NULL, NULL, 4),
(60186, NULL, 'G3DSA:2.130.10.10:FF:002356', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60187, NULL, 'G3DSA:2.60.40.10:FF:001535', NULL, NULL, 'Basal cell adhesion molecule', NULL, NULL, NULL, NULL, NULL, 4),
(60188, NULL, 'G3DSA:3.40.47.10:FF:000279', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60189, NULL, 'G3DSA:2.60.220.50:FF:000023', NULL, NULL, 'Adhesion G protein-coupled receptor G3', NULL, NULL, NULL, NULL, NULL, 4),
(60190, NULL, 'G3DSA:3.30.200.20:FF:000488', NULL, NULL, 'Related to severin kinase', NULL, NULL, NULL, NULL, NULL, 4),
(60191, NULL, 'G3DSA:1.10.238.10:FF:000432', NULL, NULL, 'Calcium-dependent protein kinase 18', NULL, NULL, NULL, NULL, NULL, 4),
(60192, NULL, 'G3DSA:2.160.20.10:FF:000225', NULL, NULL, 'Os01g0549000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(60193, NULL, 'G3DSA:1.25.40.10:FF:004828', NULL, NULL, 'Enhanced entry protein enhC, tetratricopeptide repeat family', NULL, NULL, NULL, NULL, NULL, 4),
(60194, NULL, 'G3DSA:1.25.10.10:FF:000948', NULL, NULL, 'Related to KOG1-Subunit of TORC1, a rapamycin-sensitive complex involved in growth control', NULL, NULL, NULL, NULL, NULL, 4),
(60195, NULL, 'G3DSA:3.30.420.40:FF:000616', NULL, NULL, 'Putative glycerol kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(60196, NULL, 'G3DSA:3.30.70.330:FF:000736', NULL, NULL, 'Polyadenylate-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(60197, NULL, 'G3DSA:1.10.287.110:FF:000002', NULL, NULL, 'putative tyrosine-protein phosphatase auxilin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(60198, NULL, 'G3DSA:1.20.1090.10:FF:000057', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(60199, NULL, 'G3DSA:3.80.10.10:FF:002435', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60200, NULL, 'G3DSA:3.40.50.1110:FF:000007', NULL, NULL, 'Acyloxyacyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(60201, NULL, 'G3DSA:2.60.40.10:FF:004469', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60202, NULL, 'G3DSA:2.40.160.10:FF:000050', NULL, NULL, 'Probable mitochondrial import receptor subunit TOM40-2', NULL, NULL, NULL, NULL, NULL, 4),
(60203, NULL, 'G3DSA:3.40.50.1000:FF:000868', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60204, NULL, 'G3DSA:1.10.510.10:FF:001493', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(60205, NULL, 'G3DSA:3.30.160.60:FF:001159', NULL, NULL, 'Protein glass', NULL, NULL, NULL, NULL, NULL, 4),
(60206, NULL, 'G3DSA:3.10.310.60:FF:000001', NULL, NULL, 'Yos9p', NULL, NULL, NULL, NULL, NULL, 4),
(60207, NULL, 'G3DSA:1.25.10.10:FF:000509', NULL, NULL, 'AP-2 complex subunit alpha, putative', NULL, NULL, NULL, NULL, NULL, 4),
(60208, NULL, 'G3DSA:2.60.40.10:FF:005897', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60209, NULL, 'G3DSA:3.90.640.10:FF:000083', NULL, NULL, 'Protein CBG05834', NULL, NULL, NULL, NULL, NULL, 4),
(60210, NULL, 'G3DSA:3.30.70.330:FF:002198', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60211, NULL, 'G3DSA:1.10.565.10:FF:000017', NULL, NULL, 'Peroxisome proliferator-activated receptor gamma', NULL, NULL, NULL, NULL, NULL, 4),
(60212, NULL, 'G3DSA:3.90.45.10:FF:000020', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(60213, NULL, 'G3DSA:3.40.50.11660:FF:000001', NULL, NULL, 'alpha-(1,3)-fucosyltransferase 9', NULL, NULL, NULL, NULL, NULL, 4),
(60214, NULL, 'G3DSA:3.30.50.10:FF:000147', NULL, NULL, 'YALI0E02442p', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(60215, NULL, 'G3DSA:3.90.228.10:FF:000001', NULL, NULL, 'Poly [ADP-ribose] polymerase tankyrase-2', NULL, NULL, NULL, NULL, NULL, 4),
(60216, NULL, 'G3DSA:1.10.1420.10:FF:000153', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(60217, NULL, 'G3DSA:3.30.830.10:FF:000077', NULL, NULL, 'YOL098Cp-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(60218, NULL, 'G3DSA:1.10.8.270:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60219, NULL, 'G3DSA:1.10.472.10:FF:000459', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60220, NULL, 'G3DSA:3.30.1490.190:FF:000005', NULL, NULL, 'Fur family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(60221, NULL, 'G3DSA:1.25.40.20:FF:001594', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(60222, NULL, 'G3DSA:3.30.1010.10:FF:000003', NULL, NULL, 'Phosphatidylinositol 4-kinase, catalytic, beta', NULL, NULL, NULL, NULL, NULL, 4),
(60223, NULL, 'G3DSA:3.60.40.10:FF:000139', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(60224, NULL, 'G3DSA:3.30.2340.10:FF:000005', NULL, NULL, 'tRNA pseudouridine synthase D', NULL, NULL, NULL, NULL, NULL, 4),
(60225, NULL, 'G3DSA:3.30.710.10:FF:000467', NULL, NULL, 'Protein CBG00481', NULL, NULL, NULL, NULL, NULL, 4),
(60226, NULL, 'G3DSA:2.30.29.30:FF:000673', NULL, NULL, 'Src kinase associated phosphoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(60227, NULL, 'G3DSA:1.10.472.10:FF:000537', NULL, NULL, 'Meiosis-specific cyclin crs1', NULL, NULL, NULL, NULL, NULL, 4),
(60228, NULL, 'G3DSA:2.60.40.10:FF:006077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60229, NULL, 'G3DSA:3.40.50.620:FF:000570', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60230, NULL, 'G3DSA:4.10.800.10:FF:000020', NULL, NULL, 'Magu, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(60231, NULL, 'G3DSA:3.30.160.60:FF:004918', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60232, NULL, 'G3DSA:1.20.5.470:FF:000002', NULL, NULL, 'Argininosuccinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(60233, NULL, 'G3DSA:3.30.450.40:FF:000074', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(60234, NULL, 'G3DSA:3.40.50.2000:FF:000729', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60235, NULL, 'G3DSA:2.130.10.10:FF:005684', NULL, NULL, 'Vacuolar protein sorting/targeting protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(60236, NULL, 'G3DSA:2.10.25.10:FF:000311', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(60237, NULL, 'G3DSA:2.130.10.10:FF:004256', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(60238, NULL, 'G3DSA:1.25.40.1030:FF:000023', NULL, NULL, 'Protein transport protein Sec31, putative', NULL, NULL, NULL, NULL, NULL, 4),
(60239, NULL, 'G3DSA:3.20.20.100:FF:000165', NULL, NULL, 'Oxidoreductase, aldo/keto reductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(60240, NULL, 'G3DSA:1.10.287.3240:FF:000026', NULL, NULL, 'V-type h-atpase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(60241, NULL, 'G3DSA:2.60.120.330:FF:000197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60242, NULL, 'G3DSA:3.30.160.60:FF:002592', NULL, NULL, 'Zinc finger protein 527', NULL, NULL, NULL, NULL, NULL, 4),
(60243, NULL, 'G3DSA:2.60.120.260:FF:000491', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60244, NULL, 'G3DSA:3.40.630.30:FF:000599', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60245, NULL, 'G3DSA:1.10.510.10:FF:001049', NULL, NULL, 'YPL236C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(60246, NULL, 'G3DSA:3.40.50.300:FF:008489', NULL, NULL, 'Protein CBG24214', NULL, NULL, NULL, NULL, NULL, 4),
(60247, NULL, 'G3DSA:3.40.50.300:FF:000384', NULL, NULL, 'Thymidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(60248, NULL, 'G3DSA:1.10.10.10:FF:001302', NULL, NULL, 'RNA polymerase sigma factor sigD, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(60249, NULL, 'G3DSA:3.30.40.10:FF:000062', NULL, NULL, 'E3 ubiquitin-protein ligase RNF185', NULL, NULL, NULL, NULL, NULL, 4),
(60250, NULL, 'G3DSA:1.10.287.130:FF:000008', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(60251, NULL, 'G3DSA:2.30.30.40:FF:000628', NULL, NULL, 'Wu:fi04e12', NULL, NULL, NULL, NULL, NULL, 4),
(60252, NULL, 'G3DSA:3.30.200.20:FF:001022', NULL, NULL, 'Serine/threonine-protein kinase STE7 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(60253, NULL, 'G3DSA:1.20.58.740:FF:000004', NULL, NULL, 'Dedicator of cytokinesis protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(60254, NULL, 'G3DSA:1.10.287.950:FF:000046', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(60255, NULL, 'G3DSA:3.30.450.20:FF:000197', NULL, NULL, 'Probable sensor histidine kinase pdtaS', NULL, NULL, NULL, NULL, NULL, 4),
(60256, NULL, 'G3DSA:3.80.10.10:FF:000592', NULL, NULL, 'Toll-like receptor 5', NULL, NULL, NULL, NULL, NULL, 4),
(60257, NULL, 'G3DSA:3.40.50.1100:FF:000089', NULL, NULL, 'Threonine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(60258, NULL, 'G3DSA:3.30.710.10:FF:000130', NULL, NULL, 'SKP1-like protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(60259, NULL, 'G3DSA:3.40.50.300:FF:008461', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60260, NULL, 'G3DSA:1.25.40.10:FF:000337', NULL, NULL, 'Poly-beta-1,6 N-acetyl-D-glucosamine export porin PgaA', NULL, NULL, NULL, NULL, NULL, 4),
(60261, NULL, 'G3DSA:2.60.40.10:FF:005560', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60262, NULL, 'G3DSA:3.40.50.1000:FF:000076', NULL, NULL, 'Haloacid dehalogenase hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(60263, NULL, 'G3DSA:3.40.50.2000:FF:000067', NULL, NULL, 'Digalactosyldiacylglycerol synthase 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(60264, NULL, 'G3DSA:1.20.1050.10:FF:000083', NULL, NULL, 'Glutathione S-transferase Mu 1', NULL, NULL, NULL, NULL, NULL, 4),
(60265, NULL, 'G3DSA:3.40.50.720:FF:000818', NULL, NULL, 'NAD(P)-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(60266, NULL, 'G3DSA:3.30.30.30:FF:000011', NULL, NULL, 'heat shock protein 105 kDa isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(60267, NULL, 'G3DSA:1.20.5.490:FF:000008', NULL, NULL, 'AraJ, Arabinose efflux permease', NULL, NULL, NULL, NULL, NULL, 4),
(60268, NULL, 'G3DSA:2.120.10.30:FF:000266', NULL, NULL, 'Probable TolB protein', NULL, NULL, NULL, NULL, NULL, 4),
(60269, NULL, 'G3DSA:3.40.850.10:FF:000115', NULL, NULL, 'Myosin heavy polypeptide 6', NULL, NULL, NULL, NULL, NULL, 4),
(60270, NULL, 'G3DSA:3.40.50.300:FF:002845', NULL, NULL, 'ATP-binding cassette subfamily B member 5', NULL, NULL, NULL, NULL, NULL, 4),
(60271, NULL, 'G3DSA:3.40.50.10490:FF:000049', NULL, NULL, 'Putative arabinose 5-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(60272, NULL, 'G3DSA:1.10.8.720:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60273, NULL, 'G3DSA:3.10.20.90:FF:000568', NULL, NULL, 'UV excision repair RAD23 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(60274, NULL, 'G3DSA:3.40.50.300:FF:002862', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(60275, NULL, 'G3DSA:1.10.720.30:FF:000025', NULL, NULL, 'Protein THO1', NULL, NULL, NULL, NULL, NULL, 4),
(60276, NULL, 'G3DSA:1.20.1250.20:FF:001101', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(60277, NULL, 'G3DSA:2.40.128.180:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60278, NULL, 'G3DSA:3.10.129.10:FF:000076', NULL, NULL, '3-hydroxyacyl-[acyl-carrier-protein] dehydratase FabZ', NULL, NULL, NULL, NULL, NULL, 4),
(60279, NULL, 'G3DSA:1.10.1410.10:FF:000096', NULL, NULL, 'U3 small nucleolar RNA-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(60280, NULL, 'G3DSA:3.40.50.620:FF:000261', NULL, NULL, 'Ethanolamine-phosphate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(60281, NULL, 'G3DSA:2.130.10.10:FF:002811', NULL, NULL, 'DNA damage-binding protein CMR1', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(60282, NULL, 'G3DSA:2.20.100.10:FF:000247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60283, NULL, 'G3DSA:2.60.40.10:FF:004924', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60284, NULL, 'G3DSA:1.10.150.50:FF:000111', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(60285, NULL, 'G3DSA:1.10.10.60:FF:000058', NULL, NULL, 'zinc finger homeobox protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(60286, NULL, 'G3DSA:3.40.190.10:FF:000115', NULL, NULL, 'ATP phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(60287, NULL, 'G3DSA:3.30.830.10:FF:000094', NULL, NULL, 'Zn-dependent peptidase putative', NULL, NULL, NULL, NULL, NULL, 4),
(60288, NULL, 'G3DSA:1.10.238.10:FF:001258', NULL, NULL, 'Rhomboid-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(60289, NULL, 'G3DSA:2.40.160.110:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60290, NULL, 'G3DSA:3.40.50.300:FF:003790', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(60291, NULL, 'G3DSA:3.40.50.80:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60292, NULL, 'G3DSA:1.20.930.80:FF:000008', NULL, NULL, 'DNA primase large subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(60293, NULL, 'G3DSA:3.30.470.20:FF:000108', NULL, NULL, 'D-alanine--d-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(60294, NULL, 'G3DSA:3.60.10.10:FF:000300', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(60295, NULL, 'G3DSA:1.25.40.180:FF:000322', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60296, NULL, 'G3DSA:1.20.144.10:FF:000144', NULL, NULL, 'Putative lipid phosphate phosphatase 3 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(60297, NULL, 'G3DSA:3.40.50.300:FF:002992', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(60298, NULL, 'G3DSA:1.20.940.10:FF:000005', NULL, NULL, 'protein transport protein Sec31B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(60299, NULL, 'G3DSA:1.25.40.170:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60300, NULL, 'G3DSA:1.10.150.810:FF:000005', NULL, NULL, 'DNA polymerase kappa-like', NULL, NULL, NULL, NULL, NULL, 4),
(60301, NULL, 'G3DSA:1.25.40.10:FF:000776', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g13880', NULL, NULL, NULL, NULL, NULL, 4),
(60302, NULL, 'G3DSA:3.30.590.10:FF:000041', NULL, NULL, 'Glutamine synthetase catalytic region', NULL, NULL, NULL, NULL, NULL, 4),
(60303, NULL, 'G3DSA:1.25.40.10:FF:001265', NULL, NULL, 'Pentatricopeptide repeat-containing protein isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(60304, NULL, 'G3DSA:1.25.40.10:FF:000646', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(60305, NULL, 'G3DSA:3.40.50.300:FF:008152', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(60306, NULL, 'G3DSA:2.20.150.10:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60307, NULL, 'G3DSA:3.20.20.80:FF:000700', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60308, NULL, 'G3DSA:3.30.70.330:FF:002653', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60309, NULL, 'G3DSA:3.30.200.20:FF:001005', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase HSL2', NULL, NULL, NULL, NULL, NULL, 4),
(60310, NULL, 'G3DSA:1.25.10.10:FF:002865', NULL, NULL, 'Maestro heat-like repeat-containing protein family member 2B', NULL, NULL, NULL, NULL, NULL, 4),
(60311, NULL, 'G3DSA:2.60.40.10:FF:002154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60312, NULL, 'G3DSA:3.80.10.10:FF:000518', NULL, NULL, 'F-box family protein', NULL, NULL, NULL, NULL, NULL, 4),
(60313, NULL, 'G3DSA:1.10.730.10:FF:000104', NULL, NULL, 'Methionine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(60314, NULL, 'G3DSA:3.80.10.10:FF:003054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(60315, NULL, 'G3DSA:3.40.30.10:FF:000965', NULL, NULL, '2-hydroxychromene-2-carboxylate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(60316, NULL, 'G3DSA:1.25.40.10:FF:005008', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(60317, NULL, 'G3DSA:3.40.50.720:FF:000026', NULL, NULL, 'Glyoxylate/hydroxypyruvate reductase B', NULL, NULL, NULL, NULL, NULL, 4),
(60318, NULL, 'G3DSA:3.30.160.60:FF:003076', NULL, NULL, 'zinc finger and BTB domain-containing protein 49 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(60319, NULL, 'G3DSA:2.10.25.10:FF:000620', NULL, NULL, 'Mutant fibrillin-1', NULL, NULL, NULL, NULL, NULL, 4),
(60320, NULL, 'G3DSA:2.130.10.10:FF:005993', NULL, NULL, 'Protein CBR-KLP-12', NULL, NULL, NULL, NULL, NULL, 4),
(60321, NULL, 'G3DSA:2.60.40.2610:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60322, NULL, 'G3DSA:2.60.40.10:FF:003660', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60323, NULL, 'G3DSA:4.10.1000.10:FF:000063', NULL, NULL, 'Zinc finger C-x8-C-x5-C-x3-H type (And similar), putative', NULL, NULL, NULL, NULL, NULL, 4),
(60324, NULL, 'G3DSA:3.60.15.10:FF:000098', NULL, NULL, 'Ribonuclease Z', NULL, NULL, NULL, NULL, NULL, 4),
(60325, NULL, 'G3DSA:3.40.50.300:FF:003481', NULL, NULL, 'Phosphomevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(60326, NULL, 'G3DSA:3.30.40.10:FF:001708', NULL, NULL, 'Peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(60327, NULL, 'G3DSA:1.20.1070.10:FF:001146', NULL, NULL, 'Rhodopsin, GQ-coupled', NULL, NULL, NULL, NULL, NULL, 4),
(60328, NULL, 'G3DSA:3.30.70.330:FF:001242', NULL, NULL, 'CLUMA_CG015149, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(60329, NULL, 'G3DSA:3.30.565.10:FF:000056', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(60330, NULL, 'G3DSA:1.25.40.10:FF:005317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60331, NULL, 'G3DSA:2.60.40.60:FF:000336', NULL, NULL, 'Protocadherin Fat', NULL, NULL, NULL, NULL, NULL, 4),
(60332, NULL, 'G3DSA:3.30.40.10:FF:002344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60333, NULL, 'G3DSA:3.30.160.60:FF:001614', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60334, NULL, 'G3DSA:2.60.120.260:FF:000052', NULL, NULL, 'Reelin', NULL, NULL, NULL, NULL, NULL, 4),
(60335, NULL, 'G3DSA:3.80.10.10:FF:001929', NULL, NULL, 'Ran GTPase activating protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(60336, NULL, 'G3DSA:1.20.1280.140:FF:000001', NULL, NULL, 'Cell wall serine-threonine-rich galactomannoprotein Mp1', NULL, NULL, NULL, NULL, NULL, 4),
(60337, NULL, 'G3DSA:3.40.30.10:FF:000140', NULL, NULL, 'polyglutamine-binding protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(60338, NULL, 'G3DSA:3.90.70.10:FF:000297', NULL, NULL, 'Dipeptidyl aminopeptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(60339, NULL, 'G3DSA:3.40.850.10:FF:000262', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(60340, NULL, 'G3DSA:3.30.160.60:FF:003300', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(60341, NULL, 'G3DSA:2.60.200.20:FF:000097', NULL, NULL, 'AGAP005560-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(60342, NULL, 'G3DSA:3.80.10.10:FF:003363', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60343, NULL, 'G3DSA:1.25.10.10:FF:001454', NULL, NULL, 'DAAM (Disheveled-Associated Activator of Morphogenesis) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(60344, NULL, 'G3DSA:2.170.40.20:FF:000004', NULL, NULL, 'Envelope glycoprotein gp160', NULL, NULL, NULL, NULL, NULL, 4),
(60345, NULL, 'G3DSA:1.25.10.10:FF:003354', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60346, NULL, 'G3DSA:3.30.230.130:FF:000055', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(60347, NULL, 'G3DSA:3.40.50.620:FF:000114', NULL, NULL, 'Pantothenate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(60348, NULL, 'G3DSA:2.10.25.10:FF:001137', NULL, NULL, 'GM15468', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(60349, NULL, 'G3DSA:4.10.60.10:FF:000096', NULL, NULL, 'Zinc finger CCHC-type containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(60350, NULL, 'G3DSA:2.130.10.10:FF:000069', NULL, NULL, 'WD repeat domain 33', NULL, NULL, NULL, NULL, NULL, 4),
(60351, NULL, 'G3DSA:3.80.10.10:FF:002727', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60352, NULL, 'G3DSA:3.30.420.130:FF:000003', NULL, NULL, 'Cation efflux system protein', NULL, NULL, NULL, NULL, NULL, 4),
(60353, NULL, 'G3DSA:2.60.40.1170:FF:000089', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60354, NULL, 'G3DSA:3.80.10.10:FF:001901', NULL, NULL, 'Protein TORNADO 1', NULL, NULL, NULL, NULL, NULL, 4),
(60355, NULL, 'G3DSA:3.40.50.300:FF:007533', NULL, NULL, 'ATP-binding cassette transporter, subfamily F, member 9 protein PpABCF9', NULL, NULL, NULL, NULL, NULL, 4),
(60356, NULL, 'G3DSA:3.10.20.90:FF:000698', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60357, NULL, 'G3DSA:2.60.220.50:FF:000006', NULL, NULL, 'Adhesion G-protein coupled receptor G6', NULL, NULL, NULL, NULL, NULL, 4),
(60358, NULL, 'G3DSA:3.30.160.60:FF:000203', NULL, NULL, 'Zinc finger protein 366', NULL, NULL, NULL, NULL, NULL, 4),
(60359, NULL, 'G3DSA:2.60.40.10:FF:002715', NULL, NULL, 'Secreted trypsin-like serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(60360, NULL, 'G3DSA:1.10.238.10:FF:000741', NULL, NULL, 'Novel protein similar to human signal transducer and activator of transcription (STAT)', NULL, NULL, NULL, NULL, NULL, 4),
(60361, NULL, 'G3DSA:3.30.210.10:FF:000002', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(60362, NULL, 'G3DSA:2.60.120.260:FF:000361', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(60363, NULL, 'G3DSA:1.10.238.10:FF:000769', NULL, NULL, 'Apicoplast calcium binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(60364, NULL, 'G3DSA:3.80.10.10:FF:002418', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60365, NULL, 'G3DSA:3.60.110.10:FF:000033', NULL, NULL, 'Putative nitrilase', NULL, NULL, NULL, NULL, NULL, 4),
(60366, NULL, 'G3DSA:3.30.70.330:FF:000753', NULL, NULL, 'Serine/arginine-rich SC35-like splicing factor SCL28', NULL, NULL, NULL, NULL, NULL, 4),
(60367, NULL, 'G3DSA:2.60.120.1440:FF:000018', NULL, NULL, 'Fec operon regulator FecR', NULL, NULL, NULL, NULL, NULL, 4),
(60368, NULL, 'G3DSA:3.20.20.220:FF:000072', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(60369, NULL, 'G3DSA:2.60.40.10:FF:005588', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60370, NULL, 'G3DSA:3.80.10.10:FF:001890', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(60371, NULL, 'G3DSA:3.30.160.60:FF:004609', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60372, NULL, 'G3DSA:2.130.10.10:FF:004565', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60373, NULL, 'G3DSA:3.40.532.10:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60374, NULL, 'G3DSA:1.20.140.50:FF:000001', NULL, NULL, 'programmed cell death 6-interacting protein-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(60375, NULL, 'G3DSA:2.60.40.1660:FF:000011', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(60376, NULL, 'G3DSA:2.30.39.10:FF:000151', NULL, NULL, 'Protein CBG10463', NULL, NULL, NULL, NULL, NULL, 4),
(60377, NULL, 'G3DSA:3.30.160.60:FF:003531', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60378, NULL, 'G3DSA:3.90.650.10:FF:000038', NULL, NULL, 'Hydrogenase expression/formation protein HypE', NULL, NULL, NULL, NULL, NULL, 4),
(60379, NULL, 'G3DSA:3.90.70.80:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60380, NULL, 'G3DSA:2.170.16.10:FF:000024', NULL, NULL, 'Replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(60381, NULL, 'G3DSA:2.60.40.1910:FF:000018', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(60382, NULL, 'G3DSA:2.60.40.10:FF:005116', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(60383, NULL, 'G3DSA:3.40.50.2300:FF:000701', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60384, NULL, 'G3DSA:3.30.450.40:FF:000091', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(60385, NULL, 'G3DSA:3.20.20.190:FF:000017', NULL, NULL, 'glycerophosphodiester phosphodiesterase domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(60386, NULL, 'G3DSA:2.60.40.1220:FF:000008', NULL, NULL, 'Internalin protein', NULL, NULL, NULL, NULL, NULL, 4),
(60387, NULL, 'G3DSA:1.10.10.60:FF:000867', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60388, NULL, 'G3DSA:1.20.1250.20:FF:001910', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60389, NULL, 'G3DSA:2.60.40.10:FF:002463', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(60390, NULL, 'G3DSA:3.40.50.300:FF:007724', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60391, NULL, 'G3DSA:1.20.1270.60:FF:000237', NULL, NULL, 'Mental retardation GTPase activating protein homolog 4', NULL, NULL, NULL, NULL, NULL, 4),
(60392, NULL, 'G3DSA:2.130.10.120:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60393, NULL, 'G3DSA:2.10.110.10:FF:000166', NULL, NULL, 'LIM domain containing protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(60394, NULL, 'G3DSA:3.60.20.10:FF:000256', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60395, NULL, 'G3DSA:3.40.50.150:FF:000878', NULL, NULL, 'Os06g0315000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(60396, NULL, 'G3DSA:3.10.250.10:FF:000110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60397, NULL, 'G3DSA:3.40.50.720:FF:000257', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(60398, NULL, 'G3DSA:1.10.1200.10:FF:000142', NULL, NULL, 'Putative acyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(60399, NULL, 'G3DSA:1.20.1070.10:FF:001590', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60400, NULL, 'G3DSA:2.60.40.60:FF:000763', NULL, NULL, 'Fat-like cadherin-related tumor suppressor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(60401, NULL, 'G3DSA:3.50.50.60:FF:001116', NULL, NULL, 'Os10g0554300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(60402, NULL, 'G3DSA:3.40.1810.10:FF:000045', NULL, NULL, 'Floral homeotic protein APETALA 1', NULL, NULL, NULL, NULL, NULL, 4),
(60403, NULL, 'G3DSA:3.40.50.1110:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60404, NULL, 'G3DSA:3.40.109.10:FF:000039', NULL, NULL, 'Nitroreductase', NULL, NULL, NULL, NULL, NULL, 4),
(60405, NULL, 'G3DSA:3.30.70.850:FF:000010', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 2', NULL, NULL, NULL, NULL, NULL, 4),
(60406, NULL, 'G3DSA:1.10.1670.10:FF:000070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60407, NULL, 'G3DSA:2.30.29.30:FF:000229', NULL, NULL, 'Dual adapter for phosphotyrosine and 3-phosphotyrosine and 3-phosphoinositide', NULL, NULL, NULL, NULL, NULL, 4),
(60408, NULL, 'G3DSA:1.25.40.10:FF:004463', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60409, NULL, 'G3DSA:1.25.40.10:FF:004519', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(60410, NULL, 'G3DSA:3.40.50.2300:FF:000600', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(60411, NULL, 'G3DSA:1.25.10.10:FF:001246', NULL, NULL, 'Cytoskeleton-associated protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(60412, NULL, 'G3DSA:2.70.98.110:FF:000005', NULL, NULL, 'Blast:Mannosyl-oligosaccharide glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(60413, NULL, 'G3DSA:1.25.40.20:FF:001622', NULL, NULL, 'Skeletrophin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(60414, NULL, 'G3DSA:2.60.40.420:FF:000147', NULL, NULL, 'Os12g0150500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(60415, NULL, 'G3DSA:3.40.50.300:FF:004335', NULL, NULL, 'ABC-type multidrug transport system, ATPase component', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(60416, NULL, 'G3DSA:3.40.190.10:FF:000716', NULL, NULL, 'Sll0224 protein', NULL, NULL, NULL, NULL, NULL, 4),
(60417, NULL, 'G3DSA:1.10.510.10:FF:002791', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60418, NULL, 'G3DSA:3.40.50.1820:FF:001631', NULL, NULL, 'Carboxypeptidase sxa2', NULL, NULL, NULL, NULL, NULL, 4),
(60419, NULL, 'G3DSA:2.130.10.10:FF:000878', NULL, NULL, 'Ribosome biogenesis protein WDR12 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(60420, NULL, 'G3DSA:3.30.160.60:FF:002912', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60421, NULL, 'G3DSA:3.30.2010.10:FF:000020', NULL, NULL, 'Peptidase M48 Ste24p', NULL, NULL, NULL, NULL, NULL, 4),
(60422, NULL, 'G3DSA:1.10.10.650:FF:000017', NULL, NULL, 'Transcription elongation factor Spt6', NULL, NULL, NULL, NULL, NULL, 4),
(60423, NULL, 'G3DSA:3.30.160.60:FF:000866', NULL, NULL, 'zinc finger protein 212', NULL, NULL, NULL, NULL, NULL, 4),
(60424, NULL, 'G3DSA:1.10.490.10:FF:000040', NULL, NULL, 'Globin X', NULL, NULL, NULL, NULL, NULL, 4),
(60425, NULL, 'G3DSA:3.30.200.20:FF:002511', NULL, NULL, 'Os01g0568800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(60426, NULL, 'G3DSA:3.40.50.1820:FF:000203', NULL, NULL, 'Feruloyl esterase B', NULL, NULL, NULL, NULL, NULL, 4),
(60427, NULL, 'G3DSA:3.40.50.2300:FF:001320', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60428, NULL, 'G3DSA:2.60.120.920:FF:000132', NULL, NULL, 'neuralized-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(60429, NULL, 'G3DSA:3.40.1700.10:FF:000008', NULL, NULL, 'Diadenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(60430, NULL, 'G3DSA:2.60.40.150:FF:000706', NULL, NULL, 'Phosphatidylinositol 3-kinase class, putative', NULL, NULL, NULL, NULL, NULL, 4),
(60431, NULL, 'G3DSA:3.40.50.11060:FF:000001', NULL, NULL, 'GTPase HflX', NULL, NULL, NULL, NULL, NULL, 4),
(60432, NULL, 'G3DSA:3.30.420.10:FF:000248', NULL, NULL, 'CCR4-NOT transcription complex subunit 8', NULL, NULL, NULL, NULL, NULL, 4),
(60433, NULL, 'G3DSA:3.40.50.300:FF:005055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60434, NULL, 'G3DSA:1.20.120.20:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60435, NULL, 'G3DSA:3.40.50.720:FF:002191', NULL, NULL, '3-hydroxyisobutyrate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(60436, NULL, 'G3DSA:2.30.42.10:FF:000203', NULL, NULL, 'DiSHevelled related', NULL, NULL, NULL, NULL, NULL, 4),
(60437, NULL, 'G3DSA:1.50.10.10:FF:000064', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(60438, NULL, 'G3DSA:1.25.40.10:FF:000568', NULL, NULL, 'Tetratricopeptide repeat domain 21A', NULL, NULL, NULL, NULL, NULL, 4),
(60439, NULL, 'G3DSA:3.40.47.10:FF:000251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60440, NULL, 'G3DSA:3.90.230.10:FF:000046', NULL, NULL, 'Xaa-Pro aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(60441, NULL, 'G3DSA:1.50.40.10:FF:000476', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(60442, NULL, 'G3DSA:1.25.40.20:FF:000767', NULL, NULL, 'KN motif and ankyrin repeat domains 4', NULL, NULL, NULL, NULL, NULL, 4),
(60443, NULL, 'G3DSA:3.40.50.300:FF:004762', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(60444, NULL, 'G3DSA:2.160.20.10:FF:000208', NULL, NULL, 'Pectin lyase-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(60445, NULL, 'G3DSA:1.25.40.10:FF:004036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60446, NULL, 'G3DSA:1.25.10.10:FF:000156', NULL, NULL, 'Serine/threonine-protein phosphatase 4 regulatory subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(60447, NULL, 'G3DSA:3.80.10.10:FF:004543', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60448, NULL, 'G3DSA:3.40.630.10:FF:000060', NULL, NULL, 'Putative metallocarboxypeptidase ecm14', NULL, NULL, NULL, NULL, NULL, 4),
(60449, NULL, 'G3DSA:3.40.50.670:FF:000005', NULL, NULL, 'DNA gyrase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(60450, NULL, 'G3DSA:1.20.1250.20:FF:000376', NULL, NULL, '3-(3-hydroxy-phenyl)propionate transporter MhpT', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(60451, NULL, 'G3DSA:3.30.470.30:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60452, NULL, 'G3DSA:1.20.210.10:FF:000012', NULL, NULL, 'Cytochrome c oxidase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(60453, NULL, 'G3DSA:3.40.50.360:FF:000031', NULL, NULL, 'NADPH:quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(60454, NULL, 'G3DSA:3.10.450.320:FF:000003', NULL, NULL, 'Protein CBG23912', NULL, NULL, NULL, NULL, NULL, 4),
(60455, NULL, 'G3DSA:3.80.10.10:FF:002082', NULL, NULL, 'MGC115736 protein', NULL, NULL, NULL, NULL, NULL, 4),
(60456, NULL, 'G3DSA:3.60.10.10:FF:000328', NULL, NULL, 'DNA-(apurinic or apyrimidinic site) lyase', NULL, NULL, NULL, NULL, NULL, 4),
(60457, NULL, 'G3DSA:3.30.160.60:FF:004357', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60458, NULL, 'G3DSA:3.20.20.220:FF:000055', NULL, NULL, 'AGAP007479-PA', NULL, NULL, NULL, NULL, NULL, 4),
(60459, NULL, 'G3DSA:2.40.30.10:FF:000462', NULL, NULL, 'Putative nitrate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(60460, NULL, 'G3DSA:2.40.37.20:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60461, NULL, 'G3DSA:1.10.287.70:FF:000580', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60462, NULL, 'G3DSA:2.60.120.200:FF:000478', NULL, NULL, 'Neurexin-1', NULL, NULL, NULL, NULL, NULL, 4),
(60463, NULL, 'G3DSA:3.90.780.10:FF:000019', NULL, NULL, 'Bifunctional 5-nucleotidase/2,3-cyclic phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(60464, NULL, 'G3DSA:2.60.120.920:FF:000031', NULL, NULL, 'E3 ubiquitin-protein ligase RNF123', NULL, NULL, NULL, NULL, NULL, 4),
(60465, NULL, 'G3DSA:3.40.50.720:FF:000043', NULL, NULL, 'Ketol-acid reductoisomerase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(60466, NULL, 'G3DSA:2.40.270.10:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60467, NULL, 'G3DSA:3.40.50.740:FF:000049', NULL, NULL, 'NADH-ubiquinone reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(60468, NULL, 'G3DSA:3.30.200.20:FF:002174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60469, NULL, 'G3DSA:3.30.2350.20:FF:000071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60470, NULL, 'G3DSA:2.130.10.10:FF:005892', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60471, NULL, 'G3DSA:1.20.58.60:FF:000701', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60472, NULL, 'G3DSA:3.40.50.450:FF:000069', NULL, NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(60473, NULL, 'G3DSA:1.25.40.10:FF:001282', NULL, NULL, 'Pentatricopeptide repeat-containing protein ATP4, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(60474, NULL, 'G3DSA:3.30.457.60:FF:000016', NULL, NULL, 'Mdf-1', NULL, NULL, NULL, NULL, NULL, 4),
(60475, NULL, 'G3DSA:3.20.20.70:FF:000051', NULL, NULL, 'tRNA-dihydrouridine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(60476, NULL, 'G3DSA:1.25.40.20:FF:000458', NULL, NULL, 'NF-kappa-B inhibitor cactus', NULL, NULL, NULL, NULL, NULL, 4),
(60477, NULL, 'G3DSA:3.30.160.60:FF:002148', NULL, NULL, 'Zinc finger protein 668', NULL, NULL, NULL, NULL, NULL, 4),
(60478, NULL, 'G3DSA:2.30.29.30:FF:000881', NULL, NULL, 'Insulin receptor SubsTrate homolog', NULL, NULL, NULL, NULL, NULL, 4),
(60479, NULL, 'G3DSA:2.60.40.60:FF:000971', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60480, NULL, 'G3DSA:1.10.418.10:FF:000075', NULL, NULL, 'Transgelin', NULL, NULL, NULL, NULL, NULL, 4),
(60481, NULL, 'G3DSA:2.40.50.140:FF:000087', NULL, NULL, 'Protein lin-28 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(60482, NULL, 'G3DSA:3.40.50.300:FF:007516', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(60483, NULL, 'G3DSA:1.20.920.30:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60484, NULL, 'G3DSA:2.70.170.10:FF:000055', NULL, NULL, 'Proton-gated ion channel subunit pbo-6', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(60485, NULL, 'G3DSA:1.10.287.950:FF:000029', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(60486, NULL, 'G3DSA:1.20.120.230:FF:000053', NULL, NULL, 'Talin-1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(60487, NULL, 'G3DSA:1.20.1070.10:FF:001910', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(60488, NULL, 'G3DSA:1.10.287.70:FF:000271', NULL, NULL, 'Potassium channel subunit-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(60489, NULL, 'G3DSA:3.30.70.330:FF:002422', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60490, NULL, 'G3DSA:1.10.510.40:FF:000006', NULL, NULL, 'Siderophore biosynthesis protein SbnF', NULL, NULL, NULL, NULL, NULL, 4),
(60491, NULL, 'G3DSA:3.40.980.10:FF:000035', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(60492, NULL, 'G3DSA:3.90.1150.10:FF:000123', NULL, NULL, 'Ornithine aminotransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(60493, NULL, 'G3DSA:2.40.50.40:FF:000017', NULL, NULL, 'chromodomain-helicase-DNA-binding protein 3 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(60494, NULL, 'G3DSA:3.90.640.10:FF:000291', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(60495, NULL, 'G3DSA:3.40.50.20:FF:000043', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(60496, NULL, 'G3DSA:3.40.50.300:FF:000945', NULL, NULL, 'Dynein axonemal heavy chain 9', NULL, NULL, NULL, NULL, NULL, 4),
(60497, NULL, 'G3DSA:1.25.40.10:FF:000877', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(60498, NULL, 'G3DSA:2.60.40.10:FF:000546', NULL, NULL, 'Collagen alpha-1(XIV) chain isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(60499, NULL, 'G3DSA:2.60.40.820:FF:000014', NULL, NULL, 'Optomotor-blind protein', NULL, NULL, NULL, NULL, NULL, 4),
(60500, NULL, 'G3DSA:3.10.180.10:FF:000082', NULL, NULL, 'Glr1161 protein', NULL, NULL, NULL, NULL, NULL, 4),
(60501, NULL, 'G3DSA:2.40.70.10:FF:000476', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60502, NULL, 'G3DSA:3.30.70.260:FF:000136', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(60503, NULL, 'G3DSA:2.30.33.40:FF:000017', NULL, NULL, 'Chaperonin 10 kd subunit', NULL, NULL, NULL, NULL, NULL, 4),
(60504, NULL, 'G3DSA:2.10.220.10:FF:000039', NULL, NULL, 'Extracellular matrix protein FRAS1', NULL, NULL, NULL, NULL, NULL, 4),
(60505, NULL, 'G3DSA:3.60.21.10:FF:000247', NULL, NULL, 'Vacuolar protein sorting-associated protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(60506, NULL, 'G3DSA:3.40.50.1910:FF:000034', NULL, NULL, 'Vacuolar protein sorting-associated protein 33B', NULL, NULL, NULL, NULL, NULL, 4),
(60507, NULL, 'G3DSA:2.60.40.10:FF:001165', NULL, NULL, 'PKHD1 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(60508, NULL, 'G3DSA:2.60.40.10:FF:004969', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60509, NULL, 'G3DSA:3.40.50.1820:FF:001423', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60510, NULL, 'G3DSA:2.130.10.10:FF:005184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60511, NULL, 'G3DSA:1.10.1070.11:FF:000121', NULL, NULL, 'Uncharacterized PI3/PI4-kinase family protein C1F5.11c', NULL, NULL, NULL, NULL, NULL, 4),
(60512, NULL, 'G3DSA:3.30.710.10:FF:000259', NULL, NULL, 'Protein maternal effect lethal 26', NULL, NULL, NULL, NULL, NULL, 4),
(60513, NULL, 'G3DSA:2.40.70.10:FF:000537', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60514, NULL, 'G3DSA:1.10.472.10:FF:000667', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60515, NULL, 'G3DSA:3.40.1190.20:FF:000084', NULL, NULL, 'Bifunctional protein HldE', NULL, NULL, NULL, NULL, NULL, 4),
(60516, NULL, 'G3DSA:1.20.1050.10:FF:000291', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60517, NULL, 'G3DSA:2.60.40.10:FF:005217', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60518, NULL, 'G3DSA:2.60.40.10:FF:004599', NULL, NULL, 'Synaptogenesis protein syg-2', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(60519, NULL, 'G3DSA:2.30.30.100:FF:000039', NULL, NULL, 'U7 snRNA-associated Sm-like protein LSm10', NULL, NULL, NULL, NULL, NULL, 4),
(60520, NULL, 'G3DSA:3.30.930.10:FF:000006', NULL, NULL, 'Glycine--tRNA ligase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(60521, NULL, 'G3DSA:2.60.200.20:FF:000125', NULL, NULL, 'Aprataxin', NULL, NULL, NULL, NULL, NULL, 4),
(60522, NULL, 'G3DSA:3.30.200.20:FF:000521', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(60523, NULL, 'G3DSA:2.30.42.10:FF:000411', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60524, NULL, 'G3DSA:1.10.10.60:FF:000659', NULL, NULL, 'Myb domain protein 4r1', NULL, NULL, NULL, NULL, NULL, 4),
(60525, NULL, 'G3DSA:3.40.50.10860:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60526, NULL, 'G3DSA:3.40.1180.10:FF:000035', NULL, NULL, 'Alkyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(60527, NULL, 'G3DSA:1.25.40.20:FF:000666', NULL, NULL, 'Zinc finger CCCH domain-containing protein 56', NULL, NULL, NULL, NULL, NULL, 4),
(60528, NULL, 'G3DSA:3.30.420.10:FF:000512', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60529, NULL, 'G3DSA:1.20.1270.60:FF:000029', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(60530, NULL, 'G3DSA:1.20.920.10:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60531, NULL, 'G3DSA:3.40.630.10:FF:000279', NULL, NULL, 'Zinc carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(60532, NULL, 'G3DSA:1.20.1250.20:FF:001702', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60533, NULL, 'G3DSA:3.30.70.2000:FF:000002', NULL, NULL, 'BTB/POZ domain-containing protein KCTD5-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(60534, NULL, 'G3DSA:1.20.1720.10:FF:000128', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60535, NULL, 'G3DSA:3.40.50.2000:FF:000937', NULL, NULL, 'WbcN protein', NULL, NULL, NULL, NULL, NULL, 4),
(60536, NULL, 'G3DSA:3.40.50.970:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60537, NULL, 'G3DSA:1.10.472.10:FF:000329', NULL, NULL, 'Cyclin Dx', NULL, NULL, NULL, NULL, NULL, 4),
(60538, NULL, 'G3DSA:3.40.50.300:FF:004099', NULL, NULL, 'ABC transporter, ATP binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(60539, NULL, 'G3DSA:3.40.50.720:FF:002090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60540, NULL, 'G3DSA:3.30.420.40:FF:000055', NULL, NULL, 'Glucokinase', NULL, NULL, NULL, NULL, NULL, 4),
(60541, NULL, 'G3DSA:3.30.519.10:FF:000022', NULL, NULL, 'Rab proteins geranylgeranyltransferase component A', NULL, NULL, NULL, NULL, NULL, 4),
(60542, NULL, 'G3DSA:3.90.25.10:FF:000018', NULL, NULL, 'Nucleoside-diphosphate-sugar epimerase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(60543, NULL, 'G3DSA:3.40.190.10:FF:000924', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(60544, NULL, 'G3DSA:3.40.50.150:FF:001030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60545, NULL, 'G3DSA:1.25.10.10:FF:002882', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(60546, NULL, 'G3DSA:3.40.50.1820:FF:001732', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(60547, NULL, 'G3DSA:3.30.1520.10:FF:000188', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(60548, NULL, 'G3DSA:2.60.120.260:FF:000283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60549, NULL, 'G3DSA:2.60.40.3470:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60550, NULL, 'G3DSA:3.80.20.20:FF:000084', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(60551, NULL, 'G3DSA:3.30.870.10:FF:000068', NULL, NULL, 'Phospholipase D/Transphosphatidylase', NULL, NULL, NULL, NULL, NULL, 4),
(60552, NULL, 'G3DSA:1.10.10.1100:FF:000001', NULL, NULL, 'Bacterioferritin-associated ferredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(60553, NULL, 'G3DSA:1.20.144.10:FF:000009', NULL, NULL, 'Phosphatidate phosphatase PPAPDC1A', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(60554, NULL, 'G3DSA:3.20.20.70:FF:000360', NULL, NULL, 'N-(5''-phosphoribosyl)anthranilate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(60555, NULL, 'G3DSA:1.20.1640.10:FF:000066', NULL, NULL, 'Protein-export membrane protein SecF', NULL, NULL, NULL, NULL, NULL, 4),
(60556, NULL, 'G3DSA:1.20.1250.20:FF:000584', NULL, NULL, 'Putative integral membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(60557, NULL, 'G3DSA:3.30.70.270:FF:000257', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60558, NULL, 'G3DSA:3.20.20.140:FF:000227', NULL, NULL, 'Histidinol-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(60559, NULL, 'G3DSA:2.30.38.10:FF:000008', NULL, NULL, 'Benzoate-CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(60560, NULL, 'G3DSA:3.30.160.60:FF:002603', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60561, NULL, 'G3DSA:1.25.40.20:FF:000975', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60562, NULL, 'G3DSA:3.30.428.10:FF:000069', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(60563, NULL, 'G3DSA:3.30.200.20:FF:000830', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(60564, NULL, 'G3DSA:3.30.70.330:FF:000545', NULL, NULL, 'RNA-binding protein lark', NULL, NULL, NULL, NULL, NULL, 4),
(60565, NULL, 'G3DSA:2.40.10.10:FF:000663', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60566, NULL, 'G3DSA:3.30.420.40:FF:000807', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(60567, NULL, 'G3DSA:3.80.10.10:FF:004190', NULL, NULL, 'Tubulin specific chaperone E', NULL, NULL, NULL, NULL, NULL, 4),
(60568, NULL, 'G3DSA:1.20.1020.10:FF:000007', NULL, NULL, 'BTB/POZ and TAZ domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(60569, NULL, 'G3DSA:3.40.1280.10:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60570, NULL, 'G3DSA:2.60.120.10:FF:000189', NULL, NULL, 'Cysteine dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(60571, NULL, 'G3DSA:1.20.1280.20:FF:000001', NULL, NULL, 'Co-chaperone protein HscB', NULL, NULL, NULL, NULL, NULL, 4),
(60572, NULL, 'G3DSA:2.30.42.10:FF:000512', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60573, NULL, 'G3DSA:2.30.30.490:FF:000066', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(60574, NULL, 'G3DSA:3.30.230.70:FF:000004', NULL, NULL, 'Exosome complex component Rrp41', NULL, NULL, NULL, NULL, NULL, 4),
(60575, NULL, 'G3DSA:3.90.550.10:FF:000637', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60576, NULL, 'G3DSA:1.10.150.180:FF:000001', NULL, NULL, 'Gag polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(60577, NULL, 'G3DSA:1.10.510.10:FF:002010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60578, NULL, 'G3DSA:2.60.40.150:FF:000353', NULL, NULL, 'Synaptotagmin 7, isoform I', NULL, NULL, NULL, NULL, NULL, 4),
(60579, NULL, 'G3DSA:3.40.640.10:FF:000206', NULL, NULL, 'L-allo-threonine aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(60580, NULL, 'G3DSA:3.30.750.24:FF:000039', NULL, NULL, 'Putative anti-anti-sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(60581, NULL, 'G3DSA:3.90.1720.10:FF:000032', NULL, NULL, 'Probable endopeptidase YddH', NULL, NULL, NULL, NULL, NULL, 4),
(60582, NULL, 'G3DSA:3.40.50.300:FF:000283', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(60583, NULL, 'G3DSA:1.10.20.10:FF:000274', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60584, NULL, 'G3DSA:1.10.510.10:FF:000110', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(60585, NULL, 'G3DSA:2.40.50.140:FF:000295', NULL, NULL, 'Nodulation efficiency protein NfeD', NULL, NULL, NULL, NULL, NULL, 4),
(60586, NULL, 'G3DSA:1.10.940.10:FF:000030', NULL, NULL, 'Transcription antitermination protein NusB', NULL, NULL, NULL, NULL, NULL, 4),
(60587, NULL, 'G3DSA:1.20.120.140:FF:000009', NULL, NULL, 'Signal sequence receptor alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(60588, NULL, 'G3DSA:1.20.120.1760:FF:000064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(60589, NULL, 'G3DSA:1.20.58.60:FF:000656', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60590, NULL, 'G3DSA:3.40.50.1220:FF:000012', NULL, NULL, 'NAD-dependent protein deacetylase sirtuin-6', NULL, NULL, NULL, NULL, NULL, 4),
(60591, NULL, 'G3DSA:3.40.50.1240:FF:000018', NULL, NULL, 'Phosphoglycerate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(60592, NULL, 'G3DSA:3.90.1070.20:FF:000007', NULL, NULL, 'DNA-directed RNA polymerase I subunit RPA2', NULL, NULL, NULL, NULL, NULL, 4),
(60593, NULL, 'G3DSA:3.40.50.300:FF:001564', NULL, NULL, 'DNA helicase Ercc3', NULL, NULL, NULL, NULL, NULL, 4),
(60594, NULL, 'G3DSA:2.130.10.10:FF:001030', NULL, NULL, 'WD domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(60595, NULL, 'G3DSA:2.60.40.10:FF:000445', NULL, NULL, 'Adhesion G protein-coupled receptor A3', NULL, NULL, NULL, NULL, NULL, 4),
(60596, NULL, 'G3DSA:2.40.50.140:FF:000148', NULL, NULL, 'protein RRP5 homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(60597, NULL, 'G3DSA:3.40.630.30:FF:000127', NULL, NULL, 'RNA cytidine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(60598, NULL, 'G3DSA:3.90.226.10:FF:000250', NULL, NULL, 'Methylcrotonoyl-CoA carboxylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(60599, NULL, 'G3DSA:3.90.79.10:FF:000036', NULL, NULL, 'Nudix hydrolase 11', NULL, NULL, NULL, NULL, NULL, 4),
(60600, NULL, 'G3DSA:3.40.50.150:FF:000069', NULL, NULL, 'tRNA (Guanine(10)-N2)-methyltransferase homolog isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(60601, NULL, 'G3DSA:2.60.40.1500:FF:000002', NULL, NULL, 'Iduronidase alpha-L-', NULL, NULL, NULL, NULL, NULL, 4),
(60602, NULL, 'G3DSA:1.10.10.60:FF:000558', NULL, NULL, 'Transcriptional regulator, AraC family', NULL, NULL, NULL, NULL, NULL, 4),
(60603, NULL, 'G3DSA:3.30.2350.10:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60604, NULL, 'G3DSA:3.30.40.10:FF:001843', NULL, NULL, 'RING finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(60605, NULL, 'G3DSA:2.10.25.10:FF:000412', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(60606, NULL, 'G3DSA:3.30.160.60:FF:006190', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60607, NULL, 'G3DSA:3.80.10.10:FF:000148', NULL, NULL, 'Leucine rich repeat and coiled-coil centrosomal protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(60608, NULL, 'G3DSA:3.40.850.10:FF:000340', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(60609, NULL, 'G3DSA:1.20.120.850:FF:000031', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit E', NULL, NULL, NULL, NULL, NULL, 4),
(60610, NULL, 'G3DSA:3.30.9.90:FF:000007', NULL, NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(60611, NULL, 'G3DSA:1.10.220.100:FF:000005', NULL, NULL, 'Enhancer of mRNA decapping 4', NULL, NULL, NULL, NULL, NULL, 4),
(60612, NULL, 'G3DSA:2.60.120.650:FF:000028', NULL, NULL, 'Lysine-specific demethylase lid', NULL, NULL, NULL, NULL, NULL, 4),
(60613, NULL, 'G3DSA:1.20.1250.20:FF:001202', NULL, NULL, 'Transmembrane transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(60614, NULL, 'G3DSA:1.10.150.80:FF:000007', NULL, NULL, 'Ribonuclease D', NULL, NULL, NULL, NULL, NULL, 4),
(60615, NULL, 'G3DSA:3.40.850.10:FF:000054', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(60616, NULL, 'G3DSA:3.90.1170.40:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60617, NULL, 'G3DSA:3.30.830.10:FF:000105', NULL, NULL, 'Mitochondrial processing peptidase alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(60618, NULL, 'G3DSA:1.10.510.10:FF:000773', NULL, NULL, 'MOK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(60619, NULL, 'G3DSA:3.80.10.10:FF:003571', NULL, NULL, 'Putative leucine-rich repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(60620, NULL, 'G3DSA:2.10.260.10:FF:000002', NULL, NULL, 'Antitoxin MazE', NULL, NULL, NULL, NULL, NULL, 4),
(60621, NULL, 'G3DSA:2.20.70.10:FF:000269', NULL, NULL, 'Rho GTPase activating protein 27', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(60622, NULL, 'G3DSA:1.20.1050.90:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60623, NULL, 'G3DSA:2.40.50.140:FF:000750', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60624, NULL, 'G3DSA:1.50.10.160:FF:000007', NULL, NULL, 'Ent-kaurene synthase-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(60625, NULL, 'G3DSA:3.90.226.10:FF:000295', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(60626, NULL, 'G3DSA:1.10.390.10:FF:000021', NULL, NULL, 'M1 family aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(60627, NULL, 'G3DSA:2.40.30.70:FF:000002', NULL, NULL, 'tRNA (Adenine(37)-N6)-methyltransferase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(60628, NULL, 'G3DSA:3.40.50.80:FF:000055', NULL, NULL, 'NADPH-dependent diflavin oxidoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(60629, NULL, 'G3DSA:3.30.360.50:FF:000002', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(60630, NULL, 'G3DSA:2.60.120.1040:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60631, NULL, 'G3DSA:1.20.1250.10:FF:000064', NULL, NULL, 'Growth hormone d23', NULL, NULL, NULL, NULL, NULL, 4),
(60632, NULL, 'G3DSA:3.30.420.10:FF:000703', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60633, NULL, 'G3DSA:3.40.50.720:FF:001471', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60634, NULL, 'G3DSA:1.10.533.10:FF:000146', NULL, NULL, 'Caspase recruitment domain family, member 6', NULL, NULL, NULL, NULL, NULL, 4),
(60635, NULL, 'G3DSA:3.40.50.300:FF:006544', NULL, NULL, 'Rnd1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(60636, NULL, 'G3DSA:1.10.3120.10:FF:000006', NULL, NULL, 'Foldase protein PrsA', NULL, NULL, NULL, NULL, NULL, 4),
(60637, NULL, 'G3DSA:1.10.220.20:FF:000012', NULL, NULL, 'Cytohesin 4a', NULL, NULL, NULL, NULL, NULL, 4),
(60638, NULL, 'G3DSA:1.10.443.10:FF:000010', NULL, NULL, 'Tyrosine recombinase XerS', NULL, NULL, NULL, NULL, NULL, 4),
(60639, NULL, 'G3DSA:3.40.390.10:FF:000113', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(60640, NULL, 'G3DSA:2.30.40.10:FF:000025', NULL, NULL, 'Amidohydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(60641, NULL, 'G3DSA:1.25.40.10:FF:002254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60642, NULL, 'G3DSA:1.20.58.1030:FF:000011', NULL, NULL, 'DNA replication complex GINS protein SLD5', NULL, NULL, NULL, NULL, NULL, 4),
(60643, NULL, 'G3DSA:1.20.1510.10:FF:000085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60644, NULL, 'G3DSA:2.102.10.10:FF:000048', NULL, NULL, 'Benzene 1,2-dioxygenase system ferredoxin component, putative', NULL, NULL, NULL, NULL, NULL, 4),
(60645, NULL, 'G3DSA:1.20.140.150:FF:000027', NULL, NULL, 'Claudin', NULL, NULL, NULL, NULL, NULL, 4),
(60646, NULL, 'G3DSA:3.30.160.60:FF:001423', NULL, NULL, 'Zinc finger protein 518A', NULL, NULL, NULL, NULL, NULL, 4),
(60647, NULL, 'G3DSA:1.10.150.60:FF:000001', NULL, NULL, 'Putative lysine-specific demethylase 5b', NULL, NULL, NULL, NULL, NULL, 4),
(60648, NULL, 'G3DSA:2.60.40.10:FF:002816', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(60649, NULL, 'G3DSA:3.30.450.20:FF:000652', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(60650, NULL, 'G3DSA:3.30.70.330:FF:001450', NULL, NULL, 'Protein painting of fourth', NULL, NULL, NULL, NULL, NULL, 4),
(60651, NULL, 'G3DSA:2.10.25.10:FF:001480', NULL, NULL, 'Wall-associated receptor kinase 5 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(60652, NULL, 'G3DSA:2.60.40.10:FF:001726', NULL, NULL, 'Signal-regulatory protein beta 3', NULL, NULL, NULL, NULL, NULL, 4),
(60653, NULL, 'G3DSA:2.20.70.10:FF:000055', NULL, NULL, 'E3 ubiquitin-protein ligase NEDD4-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(60654, NULL, 'G3DSA:3.30.70.1230:FF:000203', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(60655, NULL, 'G3DSA:1.20.1270.60:FF:000131', NULL, NULL, 'Variant sh3 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(60656, NULL, 'G3DSA:3.30.160.60:FF:005329', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60657, NULL, 'G3DSA:3.10.100.10:FF:000190', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60658, NULL, 'G3DSA:2.60.40.1120:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60659, NULL, 'G3DSA:3.30.950.10:FF:000024', NULL, NULL, 'Uroporphyrinogen-III C-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(60660, NULL, 'G3DSA:1.20.5.170:FF:000002', NULL, NULL, 'Type I keratin KA11', NULL, NULL, NULL, NULL, NULL, 4),
(60661, NULL, 'G3DSA:2.60.40.2660:FF:000002', NULL, NULL, 'Ankyrin-1 isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(60662, NULL, 'G3DSA:1.20.1110.10:FF:000245', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60663, NULL, 'G3DSA:1.25.40.510:FF:000011', NULL, NULL, 'EMB1745', NULL, NULL, NULL, NULL, NULL, 4),
(60664, NULL, 'G3DSA:1.10.287.470:FF:000099', NULL, NULL, 'Sll0180 protein', NULL, NULL, NULL, NULL, NULL, 4),
(60665, NULL, 'G3DSA:3.40.250.10:FF:000042', NULL, NULL, 'Thiosulfate sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(60666, NULL, 'G3DSA:1.20.5.190:FF:000008', NULL, NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(60667, NULL, 'G3DSA:1.20.1070.10:FF:000157', NULL, NULL, 'C-X-C chemokine receptor type 2', NULL, NULL, NULL, NULL, NULL, 4),
(60668, NULL, 'G3DSA:1.20.1250.20:FF:002321', NULL, NULL, 'Protein NRT1/ PTR FAMILY 7.1', NULL, NULL, NULL, NULL, NULL, 4),
(60669, NULL, 'G3DSA:1.10.150.130:FF:000003', NULL, NULL, 'Lambda integrase', NULL, NULL, NULL, NULL, NULL, 4),
(60670, NULL, 'G3DSA:2.140.10.10:FF:000006', NULL, NULL, 'Glucose dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(60671, NULL, 'G3DSA:3.40.1360.10:FF:000055', NULL, NULL, 'Chromosome 12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(60672, NULL, 'G3DSA:3.30.160.60:FF:000658', NULL, NULL, 'Zinc finger protein 652', NULL, NULL, NULL, NULL, NULL, 4),
(60673, NULL, 'G3DSA:2.130.10.10:FF:000569', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(60674, NULL, 'G3DSA:3.10.110.10:FF:000280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60675, NULL, 'G3DSA:2.60.120.200:FF:000372', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60676, NULL, 'G3DSA:3.30.230.120:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60677, NULL, 'G3DSA:3.30.40.10:FF:001388', NULL, NULL, 'Putative dna damage-responsive repressor gis1/rph1 jumonji superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(60678, NULL, 'G3DSA:2.40.128.20:FF:000034', NULL, NULL, 'Karl, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(60679, NULL, 'G3DSA:1.20.1530.20:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60680, NULL, 'G3DSA:1.20.1740.10:FF:000130', NULL, NULL, 'General amino-acid permease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(60681, NULL, 'G3DSA:2.40.50.140:FF:001003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60682, NULL, 'G3DSA:3.30.559.10:FF:000143', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(60683, NULL, 'G3DSA:1.10.760.10:FF:000033', NULL, NULL, 'Cytochrome c5', NULL, NULL, NULL, NULL, NULL, 4),
(60684, NULL, 'G3DSA:1.10.10.820:FF:000001', NULL, NULL, 'Myosin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(60685, NULL, 'G3DSA:2.40.50.140:FF:000603', NULL, NULL, '30S ribosomal protein S17', NULL, NULL, NULL, NULL, NULL, 4),
(60686, NULL, 'G3DSA:3.40.50.1010:FF:000197', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60687, NULL, 'G3DSA:2.60.40.1250:FF:000006', NULL, NULL, 'C-type cytochrome biogenesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(60688, NULL, 'G3DSA:3.30.200.20:FF:002275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60689, NULL, 'G3DSA:1.20.58.1480:FF:000028', NULL, NULL, 'Protein cereblon homolog', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(60690, NULL, 'G3DSA:2.60.40.10:FF:005689', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60691, NULL, 'G3DSA:3.10.310.10:FF:000048', NULL, NULL, 'Diaminopimelate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(60692, NULL, 'G3DSA:2.130.10.10:FF:004464', NULL, NULL, 'E3 ubiquitin-protein ligase RFWD3', NULL, NULL, NULL, NULL, NULL, 4),
(60693, NULL, 'G3DSA:2.130.10.10:FF:002778', NULL, NULL, 'WD repeat-containing protein 76', NULL, NULL, NULL, NULL, NULL, 4),
(60694, NULL, 'G3DSA:2.60.40.790:FF:000078', NULL, NULL, 'CS domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(60695, NULL, 'G3DSA:3.40.228.10:FF:000012', NULL, NULL, 'DMSO reductase', NULL, NULL, NULL, NULL, NULL, 4),
(60696, NULL, 'G3DSA:3.90.550.10:FF:000076', NULL, NULL, 'Beta-1,4 N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(60697, NULL, 'G3DSA:3.30.565.10:FF:000426', NULL, NULL, 'Bacteriophytochrome (Light-regulated signal transduction histidine kinase), PhyB2', NULL, NULL, NULL, NULL, NULL, 4),
(60698, NULL, 'G3DSA:1.10.12.10:FF:000019', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(60699, NULL, 'G3DSA:1.25.40.530:FF:000022', NULL, NULL, 'Kinesin-like calmodulin binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(60700, NULL, 'G3DSA:1.20.58.60:FF:000095', NULL, NULL, 'microtubule-actin cross-linking factor 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(60701, NULL, 'G3DSA:3.40.1110.10:FF:000441', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60702, NULL, 'G3DSA:3.40.50.720:FF:002044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60703, NULL, 'G3DSA:2.60.120.10:FF:000498', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(60704, NULL, 'G3DSA:2.20.100.10:FF:000056', NULL, NULL, 'R-spondin 1', NULL, NULL, NULL, NULL, NULL, 4),
(60705, NULL, 'G3DSA:1.10.3430.10:FF:000007', NULL, NULL, 'Ammonium transporter', NULL, NULL, NULL, NULL, NULL, 4),
(60706, NULL, 'G3DSA:3.80.10.10:FF:001581', NULL, NULL, 'Transforming growth factor beta activator LRRC33', NULL, NULL, NULL, NULL, NULL, 4),
(60707, NULL, 'G3DSA:3.40.50.300:FF:005263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60708, NULL, 'G3DSA:1.25.40.120:FF:000017', NULL, NULL, 'Protein prenylyltransferase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(60709, NULL, 'G3DSA:3.30.200.20:FF:000066', NULL, NULL, 'Ribosomal protein S6 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(60710, NULL, 'G3DSA:1.25.40.10:FF:001074', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(60711, NULL, 'G3DSA:1.25.40.10:FF:001849', NULL, NULL, 'Protein CBG05584', NULL, NULL, NULL, NULL, NULL, 4),
(60712, NULL, 'G3DSA:3.10.660.10:FF:000012', NULL, NULL, 'AGAP010609-PA', NULL, NULL, NULL, NULL, NULL, 4),
(60713, NULL, 'G3DSA:1.25.40.20:FF:001386', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60714, NULL, 'G3DSA:2.60.40.640:FF:000084', NULL, NULL, 'Subunit of retromer complex', NULL, NULL, NULL, NULL, NULL, 4),
(60715, NULL, 'G3DSA:1.25.40.180:FF:000131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60716, NULL, 'G3DSA:3.30.590.50:FF:000002', NULL, NULL, 'Glutamate--cysteine ligase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(60717, NULL, 'G3DSA:1.20.1070.10:FF:000718', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60718, NULL, 'G3DSA:3.40.50.11210:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60719, NULL, 'G3DSA:3.40.640.10:FF:000094', NULL, NULL, 'Probable cystathionine gamma-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(60720, NULL, 'G3DSA:3.40.50.620:FF:000362', NULL, NULL, 'Valyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(60721, NULL, 'G3DSA:3.40.50.10090:FF:000053', NULL, NULL, 'Putative uroporphyrinogen-III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(60722, NULL, 'G3DSA:2.120.10.30:FF:000058', NULL, NULL, 'Low-density lipoprotein receptor-related protein 2', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(60723, NULL, 'G3DSA:1.20.140.100:FF:000018', NULL, NULL, 'Glutathione S-transferase class-mu 26 kDa isozyme', NULL, NULL, NULL, NULL, NULL, 4),
(60724, NULL, 'G3DSA:3.90.215.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60725, NULL, 'G3DSA:2.60.40.3440:FF:000005', NULL, NULL, 'Integrin beta-like protein A', NULL, NULL, NULL, NULL, NULL, 4),
(60726, NULL, 'G3DSA:3.30.1370.110:FF:000005', NULL, NULL, 'Endonuclease MutS2', NULL, NULL, NULL, NULL, NULL, 4),
(60727, NULL, 'G3DSA:3.40.50.960:FF:000014', NULL, NULL, '6,7-dimethyl-8-ribityllumazine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(60728, NULL, 'G3DSA:2.60.120.650:FF:000175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60729, NULL, 'G3DSA:3.40.50.300:FF:007988', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60730, NULL, 'G3DSA:3.30.1330.10:FF:000033', NULL, NULL, 'Uncharacterized protein sll0787', NULL, NULL, NULL, NULL, NULL, 4),
(60731, NULL, 'G3DSA:2.40.50.100:FF:000086', NULL, NULL, 'Molybdenum transport operon repressor MopB', NULL, NULL, NULL, NULL, NULL, 4),
(60732, NULL, 'G3DSA:3.40.50.300:FF:007163', NULL, NULL, 'Uncharacterized protein MJECL43', NULL, NULL, NULL, NULL, NULL, 4),
(60733, NULL, 'G3DSA:3.90.1280.20:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60734, NULL, 'G3DSA:2.30.130.10:FF:000022', NULL, NULL, 'Glutamate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(60735, NULL, 'G3DSA:3.40.50.1820:FF:001529', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60736, NULL, 'G3DSA:1.20.1740.10:FF:000028', NULL, NULL, 'Inner membrane transporter YqeG', NULL, NULL, NULL, NULL, NULL, 4),
(60737, NULL, 'G3DSA:2.60.40.10:FF:004863', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60738, NULL, 'G3DSA:2.40.160.160:FF:000001', NULL, NULL, 'Intimin-like inverse autotransporter SinH', NULL, NULL, NULL, NULL, NULL, 4),
(60739, NULL, 'G3DSA:3.90.226.10:FF:000148', NULL, NULL, 'Possible protease IV sppA (Endopeptidase IV)', NULL, NULL, NULL, NULL, NULL, 4),
(60740, NULL, 'G3DSA:3.40.50.300:FF:000592', NULL, NULL, 'ATP-dependent helicase DinG', NULL, NULL, NULL, NULL, NULL, 4),
(60741, NULL, 'G3DSA:3.40.50.1820:FF:000304', NULL, NULL, 'Haloalkane dehalogenase 3', NULL, NULL, NULL, NULL, NULL, 4),
(60742, NULL, 'G3DSA:1.10.472.30:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60743, NULL, 'G3DSA:2.10.109.10:FF:000084', NULL, NULL, 'Mitochondrial inner membrane protease subunit', NULL, NULL, NULL, NULL, NULL, 4),
(60744, NULL, 'G3DSA:1.10.287.110:FF:000474', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(60745, NULL, 'G3DSA:2.60.40.10:FF:005352', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60746, NULL, 'G3DSA:3.40.50.80:FF:000032', NULL, NULL, 'NADPH-dependent diflavin oxidoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(60747, NULL, 'G3DSA:1.10.600.10:FF:000123', NULL, NULL, 'Putative vetispiradiene synthase', NULL, NULL, NULL, NULL, NULL, 4),
(60748, NULL, 'G3DSA:3.30.160.60:FF:004273', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60749, NULL, 'G3DSA:1.10.4160.10:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60750, NULL, 'G3DSA:1.10.238.10:FF:000538', NULL, NULL, 'EF-hand calcium-binding domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(60751, NULL, 'G3DSA:2.60.40.180:FF:000002', NULL, NULL, 'Transthyretin', NULL, NULL, NULL, NULL, NULL, 4),
(60752, NULL, 'G3DSA:3.40.50.620:FF:000345', NULL, NULL, 'Protein CBG05149', NULL, NULL, NULL, NULL, NULL, 4),
(60753, NULL, 'G3DSA:2.60.40.60:FF:001033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60754, NULL, 'G3DSA:3.80.10.10:FF:003262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60755, NULL, 'G3DSA:2.40.37.10:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60756, NULL, 'G3DSA:3.30.450.20:FF:000433', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60757, NULL, 'G3DSA:1.20.1250.20:FF:001657', NULL, NULL, 'Multidrug resistance protein B', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(60758, NULL, 'G3DSA:3.40.1110.10:FF:000132', NULL, NULL, 'Probable cobalt/nickel-exporting P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(60759, NULL, 'G3DSA:3.40.50.1820:FF:000350', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(60760, NULL, 'G3DSA:1.10.10.2660:FF:000019', NULL, NULL, 'Ubiquitin-activating enzyme e1 1 putative', NULL, NULL, NULL, NULL, NULL, 4),
(60761, NULL, 'G3DSA:3.30.1520.10:FF:000008', NULL, NULL, 'Sorting nexin-17 isoform1', NULL, NULL, NULL, NULL, NULL, 4),
(60762, NULL, 'G3DSA:1.20.1070.10:FF:000421', NULL, NULL, 'FMRFamide receptor', NULL, NULL, NULL, NULL, NULL, 4),
(60763, NULL, 'G3DSA:3.90.870.10:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60764, NULL, 'G3DSA:3.30.40.10:FF:000293', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(60765, NULL, 'G3DSA:4.10.70.10:FF:000006', NULL, NULL, 'ADAM like decysin 1', NULL, NULL, NULL, NULL, NULL, 4),
(60766, NULL, 'G3DSA:2.60.40.10:FF:001081', NULL, NULL, 'Leucine-rich repeat and fibronectin type-III domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(60767, NULL, 'G3DSA:1.25.10.10:FF:002527', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(60768, NULL, 'G3DSA:2.40.30.10:FF:000018', NULL, NULL, 'Ferredoxin--NADP(+) reductase', NULL, NULL, NULL, NULL, NULL, 4),
(60769, NULL, 'G3DSA:3.40.50.300:FF:006819', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60770, NULL, 'G3DSA:2.10.220.10:FF:000011', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(60771, NULL, 'G3DSA:3.40.850.10:FF:000031', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(60772, NULL, 'G3DSA:3.40.1190.20:FF:000213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60773, NULL, 'G3DSA:1.10.418.10:FF:000159', NULL, NULL, 'Actinin, alpha 2b', NULL, NULL, NULL, NULL, NULL, 4),
(60774, NULL, 'G3DSA:2.70.98.10:FF:000105', NULL, NULL, 'Aldose 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(60775, NULL, 'G3DSA:1.10.10.60:FF:001250', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60776, NULL, 'G3DSA:1.10.10.60:FF:000631', NULL, NULL, 'Chitin synthase 6', NULL, NULL, NULL, NULL, NULL, 4),
(60777, NULL, 'G3DSA:1.10.287.70:FF:000136', NULL, NULL, 'Voltage-dependent T-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(60778, NULL, 'G3DSA:3.40.850.10:FF:000470', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(60779, NULL, 'G3DSA:2.30.42.10:FF:000439', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60780, NULL, 'G3DSA:1.10.10.1700:FF:000001', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(60781, NULL, 'G3DSA:2.130.10.10:FF:000642', NULL, NULL, 'Cleavage and polyadenylation specificity factor (CPSF) A subunit protein', NULL, NULL, NULL, NULL, NULL, 4),
(60782, NULL, 'G3DSA:3.80.10.10:FF:003790', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60783, NULL, 'G3DSA:3.40.50.150:FF:001575', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60784, NULL, 'G3DSA:3.40.1000.50:FF:000012', NULL, NULL, 'Repressor of RNA polymerase III transcription MAF1', NULL, NULL, NULL, NULL, NULL, 4),
(60785, NULL, 'G3DSA:1.10.8.60:FF:000574', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(60786, NULL, 'G3DSA:2.40.10.230:FF:000010', NULL, NULL, 'Transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(60787, NULL, 'G3DSA:3.40.50.620:FF:000822', NULL, NULL, 'Diphthine--ammonia ligase', NULL, NULL, NULL, NULL, NULL, 4),
(60788, NULL, 'G3DSA:1.20.1250.20:FF:001129', NULL, NULL, 'EmrB/QacA family drug resistance transporter', NULL, NULL, NULL, NULL, NULL, 4),
(60789, NULL, 'G3DSA:3.40.20.10:FF:000083', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(60790, NULL, 'G3DSA:1.10.10.10:FF:001858', NULL, NULL, 'Activating signal cointegrator 1 complex subunit 3, helc1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(60791, NULL, 'G3DSA:1.10.3450.40:FF:000006', NULL, NULL, 'Signal recognition particle subunit SRP68', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(60792, NULL, 'G3DSA:2.120.10.30:FF:000160', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(60793, NULL, 'G3DSA:2.60.40.10:FF:004733', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60794, NULL, 'G3DSA:3.30.160.60:FF:001530', NULL, NULL, 'Zinc finger protein 268', NULL, NULL, NULL, NULL, NULL, 4),
(60795, NULL, 'G3DSA:2.40.70.10:FF:000453', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60796, NULL, 'G3DSA:3.40.140.10:FF:000168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60797, NULL, 'G3DSA:1.10.238.10:FF:001157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60798, NULL, 'G3DSA:2.40.10.10:FF:000444', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60799, NULL, 'G3DSA:1.10.520.10:FF:000066', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(60800, NULL, 'G3DSA:1.10.10.10:FF:000077', NULL, NULL, 'DNA-binding transcriptional regulator CpxR', NULL, NULL, NULL, NULL, NULL, 4),
(60801, NULL, 'G3DSA:3.30.40.10:FF:000770', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(60802, NULL, 'G3DSA:1.20.58.1120:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60803, NULL, 'G3DSA:1.10.400.10:FF:000012', NULL, NULL, 'G protein alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(60804, NULL, 'G3DSA:2.60.120.260:FF:000260', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(60805, NULL, 'G3DSA:3.30.390.110:FF:000011', NULL, NULL, 'Ribosomal L28e/Mak16', NULL, NULL, NULL, NULL, NULL, 4),
(60806, NULL, 'G3DSA:3.90.180.10:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60807, NULL, 'G3DSA:1.20.120.1900:FF:000038', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(60808, NULL, 'G3DSA:1.10.1300.10:FF:000003', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(60809, NULL, 'G3DSA:3.30.70.3000:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60810, NULL, 'G3DSA:3.80.10.10:FF:003947', NULL, NULL, 'Putative surface antigen protein', NULL, NULL, NULL, NULL, NULL, 4),
(60811, NULL, 'G3DSA:2.60.120.380:FF:000043', NULL, NULL, 'Calpain 13', NULL, NULL, NULL, NULL, NULL, 4),
(60812, NULL, 'G3DSA:2.10.110.10:FF:000019', NULL, NULL, 'Lim and senescent cell antigen-like-containing', NULL, NULL, NULL, NULL, NULL, 4),
(60813, NULL, 'G3DSA:1.20.58.80:FF:000095', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(60814, NULL, 'G3DSA:2.60.40.150:FF:000145', NULL, NULL, 'Synaptotagmin 13', NULL, NULL, NULL, NULL, NULL, 4),
(60815, NULL, 'G3DSA:3.40.50.10140:FF:000074', NULL, NULL, 'Myeloid differentiation factor 88', NULL, NULL, NULL, NULL, NULL, 4),
(60816, NULL, 'G3DSA:3.40.50.410:FF:000080', NULL, NULL, 'X-ray repair-complementing defective repair in Chinese hamster cells 6', NULL, NULL, NULL, NULL, NULL, 4),
(60817, NULL, 'G3DSA:3.30.70.330:FF:000961', NULL, NULL, 'OSJNBa0023J03.10 protein', NULL, NULL, NULL, NULL, NULL, 4),
(60818, NULL, 'G3DSA:3.40.50.300:FF:005824', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60819, NULL, 'G3DSA:1.20.120.230:FF:000036', NULL, NULL, 'Alpha-catenin-like protein hmp-1', NULL, NULL, NULL, NULL, NULL, 4),
(60820, NULL, 'G3DSA:3.30.160.60:FF:005801', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60821, NULL, 'G3DSA:1.10.8.10:FF:000025', NULL, NULL, 'TGF-beta-activated kinase 1 and MAP3K7-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(60822, NULL, 'G3DSA:2.60.220.50:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60823, NULL, 'G3DSA:2.60.40.10:FF:000462', NULL, NULL, 'Interleukin 1 receptor accessory protein', NULL, NULL, NULL, NULL, NULL, 4),
(60824, NULL, 'G3DSA:1.25.10.10:FF:002966', NULL, NULL, 'Tubulin-specific chaperone D', NULL, NULL, NULL, NULL, NULL, 4),
(60825, NULL, 'G3DSA:3.60.21.10:FF:000483', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(60826, NULL, 'G3DSA:3.40.1280.10:FF:000127', NULL, NULL, 'SPOUT domain-containing methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(60827, NULL, 'G3DSA:3.30.900.10:FF:000061', NULL, NULL, 'DNA polymerase zeta processivity subunit', NULL, NULL, NULL, NULL, NULL, 4),
(60828, NULL, 'G3DSA:2.60.120.650:FF:000074', NULL, NULL, 'JmjC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(60829, NULL, 'G3DSA:3.30.160.60:FF:002709', NULL, NULL, 'Zinc finger protein 724', NULL, NULL, NULL, NULL, NULL, 4),
(60830, NULL, 'G3DSA:3.30.40.10:FF:001579', NULL, NULL, 'E3 ubiquitin-protein ligase RHA1B', NULL, NULL, NULL, NULL, NULL, 4),
(60831, NULL, 'G3DSA:4.10.240.10:FF:000038', NULL, NULL, 'TY1 enhancer activator', NULL, NULL, NULL, NULL, NULL, 4),
(60832, NULL, 'G3DSA:1.10.10.10:FF:000184', NULL, NULL, 'Response regulator receiver', NULL, NULL, NULL, NULL, NULL, 4),
(60833, NULL, 'G3DSA:3.40.50.300:FF:008258', NULL, NULL, '10-formyltetrahydrofolate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(60834, NULL, 'G3DSA:2.60.40.10:FF:004840', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60835, NULL, 'G3DSA:1.20.58.1880:FF:000018', NULL, NULL, 'Chromosome 17 open reading frame 49', NULL, NULL, NULL, NULL, NULL, 4),
(60836, NULL, 'G3DSA:1.20.1560.10:FF:000273', NULL, NULL, 'Putative ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(60837, NULL, 'G3DSA:2.60.40.2030:FF:000004', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(60838, NULL, 'G3DSA:3.40.50.300:FF:003110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60839, NULL, 'G3DSA:1.10.20.10:FF:000358', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60840, NULL, 'G3DSA:2.120.10.80:FF:000056', NULL, NULL, 'Kelch-like family member 14', NULL, NULL, NULL, NULL, NULL, 4),
(60841, NULL, 'G3DSA:1.10.510.10:FF:001622', NULL, NULL, 'Serine/threonine-protein kinase PINK1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(60842, NULL, 'G3DSA:3.30.950.30:FF:000002', NULL, NULL, 'Schlafen family member 11', NULL, NULL, NULL, NULL, NULL, 4),
(60843, NULL, 'G3DSA:3.30.160.60:FF:002339', NULL, NULL, 'Zinc finger protein 322', NULL, NULL, NULL, NULL, NULL, 4),
(60844, NULL, 'G3DSA:3.30.70.330:FF:001034', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(60845, NULL, 'G3DSA:1.25.40.10:FF:000540', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(60846, NULL, 'G3DSA:1.10.1070.11:FF:000019', NULL, NULL, 'Phosphatidylinositol 4-kinase beta 1', NULL, NULL, NULL, NULL, NULL, 4),
(60847, NULL, 'G3DSA:3.30.710.10:FF:000361', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60848, NULL, 'G3DSA:2.60.120.260:FF:000153', NULL, NULL, 'Uncharacterized conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(60849, NULL, 'G3DSA:3.30.70.330:FF:001141', NULL, NULL, 'Ras GTPase-activating protein-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(60850, NULL, 'G3DSA:2.120.10.30:FF:000513', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60851, NULL, 'G3DSA:1.20.1560.10:FF:000582', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(60852, NULL, 'G3DSA:2.30.29.30:FF:001084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60853, NULL, 'G3DSA:1.20.1510.10:FF:000062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60854, NULL, 'G3DSA:1.10.10.10:FF:001965', NULL, NULL, '30S ribosomal protein S25e', NULL, NULL, NULL, NULL, NULL, 4),
(60855, NULL, 'G3DSA:2.160.20.10:FF:000017', NULL, NULL, 'F-box only protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(60856, NULL, 'G3DSA:3.40.50.300:FF:001772', NULL, NULL, 'DNA replication origin-binding helicase', NULL, NULL, NULL, NULL, NULL, 4),
(60857, NULL, 'G3DSA:3.30.1360.10:FF:000006', NULL, NULL, 'DNA-directed RNA polymerases I and III subunit RPAC2', NULL, NULL, NULL, NULL, NULL, 4),
(60858, NULL, 'G3DSA:1.10.510.10:FF:000790', NULL, NULL, 'Cyclin-dependent kinase G-1', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(60859, NULL, 'G3DSA:3.20.20.80:FF:000806', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(60860, NULL, 'G3DSA:3.40.50.300:FF:004998', NULL, NULL, 'ARF-like GTPase ARLP2, atypical', NULL, NULL, NULL, NULL, NULL, 4),
(60861, NULL, 'G3DSA:1.20.1280.50:FF:000229', NULL, NULL, 'F-box protein pof6', NULL, NULL, NULL, NULL, NULL, 4),
(60862, NULL, 'G3DSA:3.90.1150.10:FF:000359', NULL, NULL, 'Nucleotide-sugar aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(60863, NULL, 'G3DSA:2.30.30.100:FF:000112', NULL, NULL, 'U6 snRNA-associated Sm family protein LSm2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(60864, NULL, 'G3DSA:3.30.565.10:FF:000281', NULL, NULL, 'Sensor histidine kinase YvrG', NULL, NULL, NULL, NULL, NULL, 4),
(60865, NULL, 'G3DSA:3.40.390.10:FF:000321', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60866, NULL, 'G3DSA:3.30.30.30:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60867, NULL, 'G3DSA:3.10.20.90:FF:000467', NULL, NULL, 'ikappaB kinase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(60868, NULL, 'G3DSA:1.10.10.10:FF:000554', NULL, NULL, 'Anaphase-promoting complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(60869, NULL, 'G3DSA:3.90.550.10:FF:000429', NULL, NULL, '2-C-methyl-D-erythritol 4-phosphate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(60870, NULL, 'G3DSA:3.30.310.80:FF:000025', NULL, NULL, 'SNF1-like protein kinase ssp2', NULL, NULL, NULL, NULL, NULL, 4),
(60871, NULL, 'G3DSA:3.40.50.300:FF:005038', NULL, NULL, 'tRNA delta(2)-isopentenylpyrophosphate transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(60872, NULL, 'G3DSA:1.20.920.20:FF:000007', NULL, NULL, 'Cytoplasmic dynein 1 heavy chain 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(60873, NULL, 'G3DSA:3.40.50.12790:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60874, NULL, 'G3DSA:2.130.10.10:FF:004481', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60875, NULL, 'G3DSA:3.40.109.10:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60876, NULL, 'G3DSA:2.10.25.10:FF:000384', NULL, NULL, 'Integrin subunit beta like 1', NULL, NULL, NULL, NULL, NULL, 4),
(60877, NULL, 'G3DSA:3.40.50.720:FF:001690', NULL, NULL, 'Formate dehydrogenase chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(60878, NULL, 'G3DSA:1.25.40.190:FF:000004', NULL, NULL, 'Actin-related protein 2/3 complex subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(60879, NULL, 'G3DSA:3.40.630.30:FF:000498', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(60880, NULL, 'G3DSA:2.130.10.10:FF:000333', NULL, NULL, 'WD repeat-containing protein 55', NULL, NULL, NULL, NULL, NULL, 4),
(60881, NULL, 'G3DSA:3.30.800.10:FF:000002', NULL, NULL, 'Phosphatidylinositol 5-phosphate 4-kinase type-2 beta', NULL, NULL, NULL, NULL, NULL, 4),
(60882, NULL, 'G3DSA:1.10.150.670:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60883, NULL, 'G3DSA:3.40.50.1440:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60884, NULL, 'G3DSA:1.25.40.10:FF:002355', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60885, NULL, 'G3DSA:2.40.50.140:FF:000064', NULL, NULL, 'Replication protein A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(60886, NULL, 'G3DSA:3.40.630.30:FF:000043', NULL, NULL, 'Glucosamine 6-phosphate N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(60887, NULL, 'G3DSA:1.20.272.10:FF:000082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60888, NULL, 'G3DSA:3.40.720.10:FF:000151', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(60889, NULL, 'G3DSA:1.10.630.10:FF:000260', NULL, NULL, 'Putative cytochrome P450 superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(60890, NULL, 'G3DSA:1.20.1390.10:FF:000001', NULL, NULL, 'RNA-binding protein 26 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(60891, NULL, 'G3DSA:3.20.20.450:FF:000011', NULL, NULL, 'Cyclic di-GMP phosphodiesterase YfgF', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(60892, NULL, 'G3DSA:1.10.390.10:FF:000105', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(60893, NULL, 'G3DSA:2.130.10.10:FF:001261', NULL, NULL, 'Chromatin assembly factor 1 P55 subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(60894, NULL, 'G3DSA:3.30.420.10:FF:000142', NULL, NULL, 'Ribonuclease HII', NULL, NULL, NULL, NULL, NULL, 4),
(60895, NULL, 'G3DSA:3.30.413.10:FF:000030', NULL, NULL, 'Sulfite reductase, assimilatory', NULL, NULL, NULL, NULL, NULL, 4),
(60896, NULL, 'G3DSA:3.40.850.10:FF:000363', NULL, NULL, 'Chitin synthase-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(60897, NULL, 'G3DSA:1.10.8.10:FF:000334', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(60898, NULL, 'G3DSA:2.60.120.830:FF:000004', NULL, NULL, 'Lonely heart, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(60899, NULL, 'G3DSA:1.10.3720.10:FF:000081', NULL, NULL, '2-aminoethylphosphonate ABC transport system, membrane component PhnV', NULL, NULL, NULL, NULL, NULL, 4),
(60900, NULL, 'G3DSA:3.10.150.10:FF:000029', NULL, NULL, 'Proliferating cell nuclear antigen', NULL, NULL, NULL, NULL, NULL, 4),
(60901, NULL, 'G3DSA:1.25.10.20:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60902, NULL, 'G3DSA:3.40.50.2000:FF:000628', NULL, NULL, 'YALI0A10296p', NULL, NULL, NULL, NULL, NULL, 4),
(60903, NULL, 'G3DSA:1.20.1410.10:FF:000026', NULL, NULL, 'Cyclin-D1-binding protein 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(60904, NULL, 'G3DSA:3.80.10.10:FF:002643', NULL, NULL, 'Transforming growth factor beta activator LRRC33', NULL, NULL, NULL, NULL, NULL, 4),
(60905, NULL, 'G3DSA:1.20.5.10:FF:000002', NULL, NULL, 'adenomatous polyposis coli protein-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(60906, NULL, 'G3DSA:1.10.287.110:FF:000249', NULL, NULL, 'DnaJ-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(60907, NULL, 'G3DSA:2.60.40.790:FF:000179', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60908, NULL, 'G3DSA:3.20.20.140:FF:000126', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(60909, NULL, 'G3DSA:3.40.50.720:FF:000066', NULL, NULL, 'Putative ubiquitin-like modifier-activating enzyme 5', NULL, NULL, NULL, NULL, NULL, 4),
(60910, NULL, 'G3DSA:3.30.70.330:FF:000522', NULL, NULL, 'RNA recognition motif (RRM)-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(60911, NULL, 'G3DSA:3.40.50.10810:FF:000191', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(60912, NULL, 'G3DSA:3.40.190.80:FF:000080', NULL, NULL, 'Glr0190 protein', NULL, NULL, NULL, NULL, NULL, 4),
(60913, NULL, 'G3DSA:3.10.180.20:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60914, NULL, 'G3DSA:6.10.140.2220:FF:000023', NULL, NULL, 'SET_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(60915, NULL, 'G3DSA:3.80.10.10:FF:000721', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60916, NULL, 'G3DSA:3.30.70.20:FF:000145', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60917, NULL, 'G3DSA:1.10.510.10:FF:003527', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60918, NULL, 'G3DSA:3.30.70.1660:FF:000006', NULL, NULL, 'Peptide chain release factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(60919, NULL, 'G3DSA:1.10.510.10:FF:000801', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(60920, NULL, 'G3DSA:1.20.970.10:FF:000041', NULL, NULL, 'Thymidine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(60921, NULL, 'G3DSA:1.10.357.70:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60922, NULL, 'G3DSA:3.30.70.360:FF:000065', NULL, NULL, 'Cytosolic non-specific dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(60923, NULL, 'G3DSA:3.40.50.300:FF:004419', NULL, NULL, 'Orc1/CDC6', NULL, NULL, NULL, NULL, NULL, 4),
(60924, NULL, 'G3DSA:2.130.10.10:FF:005004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60925, NULL, 'G3DSA:2.70.20.60:FF:000003', NULL, NULL, 'Matrix protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(60926, NULL, 'G3DSA:1.25.10.10:FF:000392', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(60927, NULL, 'G3DSA:2.60.40.4100:FF:000018', NULL, NULL, 'Zona pellucida glycoprotein 3c', NULL, NULL, NULL, NULL, NULL, 4),
(60928, NULL, 'G3DSA:1.10.10.10:FF:001510', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(60929, NULL, 'G3DSA:3.40.50.1970:FF:000029', NULL, NULL, 'Iron-containing alcohol dehydrogenase RfbM', NULL, NULL, NULL, NULL, NULL, 4),
(60930, NULL, 'G3DSA:3.100.10.10:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60931, NULL, 'G3DSA:3.30.559.10:FF:000221', NULL, NULL, 'Chondramide synthase cmdD', NULL, NULL, NULL, NULL, NULL, 4),
(60932, NULL, 'G3DSA:1.10.418.10:FF:000266', NULL, NULL, 'Microtubule-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(60933, NULL, 'G3DSA:2.170.120.12:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60934, NULL, 'G3DSA:1.10.730.10:FF:000205', NULL, NULL, 'Protein CBR-LARS-2', NULL, NULL, NULL, NULL, NULL, 4),
(60935, NULL, 'G3DSA:3.10.20.90:FF:000012', NULL, NULL, 'Serine/threonine-protein kinase WNK1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(60936, NULL, 'G3DSA:1.25.10.10:FF:002174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60937, NULL, 'G3DSA:3.60.21.10:FF:000011', NULL, NULL, 'Double-strand break repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(60938, NULL, 'G3DSA:2.60.40.1170:FF:000049', NULL, NULL, 'Coatomer subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(60939, NULL, 'G3DSA:3.40.50.300:FF:006443', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60940, NULL, 'G3DSA:2.170.16.10:FF:000041', NULL, NULL, 'Vitamin B12-dependent ribonucleotide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(60941, NULL, 'G3DSA:3.30.160.60:FF:004020', NULL, NULL, 'Broad, isoform M', NULL, NULL, NULL, NULL, NULL, 4),
(60942, NULL, 'G3DSA:3.30.200.160:FF:000007', NULL, NULL, 'GTF3C5 isoform 9', NULL, NULL, NULL, NULL, NULL, 4),
(60943, NULL, 'G3DSA:3.80.10.10:FF:004083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60944, NULL, 'G3DSA:2.60.120.260:FF:000592', NULL, NULL, 'uncharacterized protein LOC100177071', NULL, NULL, NULL, NULL, NULL, 4),
(60945, NULL, 'G3DSA:3.30.200.20:FF:000297', NULL, NULL, 'serine/threonine-protein kinase 16', NULL, NULL, NULL, NULL, NULL, 4),
(60946, NULL, 'G3DSA:1.20.1310.10:FF:000081', NULL, NULL, 'Cullin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(60947, NULL, 'G3DSA:1.20.1060.20:FF:000013', NULL, NULL, 'Structural maintenance of chromosomes protein', NULL, NULL, NULL, NULL, NULL, 4),
(60948, NULL, 'G3DSA:2.30.30.40:FF:000174', NULL, NULL, 'rho guanine nucleotide exchange factor 37', NULL, NULL, NULL, NULL, NULL, 4),
(60949, NULL, 'G3DSA:1.20.58.60:FF:000881', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60950, NULL, 'G3DSA:1.10.238.110:FF:000021', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(60951, NULL, 'G3DSA:1.25.40.10:FF:003890', NULL, NULL, 'Tetratricopeptide repeat domain 7A', NULL, NULL, NULL, NULL, NULL, 4),
(60952, NULL, 'G3DSA:1.20.58.60:FF:000572', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(60953, NULL, 'G3DSA:2.60.40.1180:FF:000081', NULL, NULL, '1,4-alpha-glucan branching enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(60954, NULL, 'G3DSA:3.80.10.10:FF:003138', NULL, NULL, 'Leiomodin 1', NULL, NULL, NULL, NULL, NULL, 4),
(60955, NULL, 'G3DSA:3.30.460.10:FF:000032', NULL, NULL, 'DNA-directed DNA/RNA polymerase mu', NULL, NULL, NULL, NULL, NULL, 4),
(60956, NULL, 'G3DSA:2.30.29.30:FF:000572', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60957, NULL, 'G3DSA:3.30.70.330:FF:002759', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60958, NULL, 'G3DSA:3.80.10.10:FF:000412', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase PXL1', NULL, NULL, NULL, NULL, NULL, 4),
(60959, NULL, 'G3DSA:3.40.50.300:FF:002637', NULL, NULL, 'Putative ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(60960, NULL, 'G3DSA:3.90.640.10:FF:000212', NULL, NULL, 'Actin-Related Proteins', NULL, NULL, NULL, NULL, NULL, 4),
(60961, NULL, 'G3DSA:1.10.150.240:FF:000053', NULL, NULL, 'Haloacid dehalogenase/epoxide hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(60962, NULL, 'G3DSA:2.30.30.550:FF:000005', NULL, NULL, 'Major vault protein', NULL, NULL, NULL, NULL, NULL, 4),
(60963, NULL, 'G3DSA:2.10.25.10:FF:000075', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(60964, NULL, 'G3DSA:3.20.20.150:FF:000039', NULL, NULL, 'AP endonuclease, family 2', NULL, NULL, NULL, NULL, NULL, 4),
(60965, NULL, 'G3DSA:3.90.180.10:FF:000148', NULL, NULL, 'S or R-dihydroxypropanesulfonate-2-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(60966, NULL, 'G3DSA:3.20.10.10:FF:000004', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(60967, NULL, 'G3DSA:1.20.1250.20:FF:002057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60968, NULL, 'G3DSA:3.40.50.300:FF:002946', NULL, NULL, 'Probable DNA repair protein RAD50', NULL, NULL, NULL, NULL, NULL, 4),
(60969, NULL, 'G3DSA:3.10.180.10:FF:000110', NULL, NULL, '4-hydroxyphenylpyruvate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(60970, NULL, 'G3DSA:1.10.640.10:FF:000013', NULL, NULL, 'Thyroid peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(60971, NULL, 'G3DSA:3.30.160.60:FF:003637', NULL, NULL, 'Tripartite motif-containing 25', NULL, NULL, NULL, NULL, NULL, 4),
(60972, NULL, 'G3DSA:3.30.420.140:FF:000023', NULL, NULL, 'Holliday-junction_resolvase-like_of_SPT6 /SH2_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(60973, NULL, 'G3DSA:3.40.50.10810:FF:000230', NULL, NULL, 'Uncharacterized ATP-dependent helicase MG018', NULL, NULL, NULL, NULL, NULL, 4),
(60974, NULL, 'G3DSA:3.30.830.10:FF:000178', NULL, NULL, 'Processing protease', NULL, NULL, NULL, NULL, NULL, 4),
(60975, NULL, 'G3DSA:3.30.160.20:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60976, NULL, 'G3DSA:2.20.100.10:FF:000163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60977, NULL, 'G3DSA:4.10.400.10:FF:000175', NULL, NULL, 'GM20388', NULL, NULL, NULL, NULL, NULL, 4),
(60978, NULL, 'G3DSA:1.10.287.2720:FF:000005', NULL, NULL, 'Oxysterol binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(60979, NULL, 'G3DSA:1.20.58.70:FF:000119', NULL, NULL, 'Syntaxin pep12', NULL, NULL, NULL, NULL, NULL, 4),
(60980, NULL, 'G3DSA:3.30.40.10:FF:002113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60981, NULL, 'G3DSA:3.40.50.300:FF:007308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60982, NULL, 'G3DSA:1.25.40.10:FF:001490', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(60983, NULL, 'G3DSA:1.20.1740.10:FF:000231', NULL, NULL, 'Na-K-Cl cotransporter', NULL, NULL, NULL, NULL, NULL, 4),
(60984, NULL, 'G3DSA:2.130.10.10:FF:005313', NULL, NULL, 'Cleavage and polyadenylation specificity factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(60985, NULL, 'G3DSA:3.10.100.10:FF:000318', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(60986, NULL, 'G3DSA:1.10.10.60:FF:000322', NULL, NULL, 'Transcription factor TFIIIB component B', NULL, NULL, NULL, NULL, NULL, 4),
(60987, NULL, 'G3DSA:2.60.120.920:FF:000059', NULL, NULL, 'E3 ubiquitin-protein ligase RNF135', NULL, NULL, NULL, NULL, NULL, 4),
(60988, NULL, 'G3DSA:1.10.1070.11:FF:000014', NULL, NULL, 'Phosphatidylinositol 3-kinase, root isoform', NULL, NULL, NULL, NULL, NULL, 4),
(60989, NULL, 'G3DSA:1.20.58.1480:FF:000005', NULL, NULL, 'Lon protease homolog 2, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(60990, NULL, 'G3DSA:1.25.40.20:FF:000689', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60991, NULL, 'G3DSA:2.170.120.40:FF:000008', NULL, NULL, 'YbbR-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(60992, NULL, 'G3DSA:2.130.10.10:FF:002547', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(60993, NULL, 'G3DSA:2.130.10.10:FF:004801', NULL, NULL, 'Eukaryotic translation initiation factor 2A', NULL, NULL, NULL, NULL, NULL, 4),
(60994, NULL, 'G3DSA:1.20.1300.10:FF:000029', NULL, NULL, 'Succinate dehydrogenase hydrophobic membrane anchor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(60995, NULL, 'G3DSA:2.130.10.10:FF:003059', NULL, NULL, 'FI12409p', NULL, NULL, NULL, NULL, NULL, 4),
(60996, NULL, 'G3DSA:1.25.40.990:FF:000031', NULL, NULL, 'Protein CBG17718', NULL, NULL, NULL, NULL, NULL, 4),
(60997, NULL, 'G3DSA:1.10.1370.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(60998, NULL, 'G3DSA:1.10.287.80:FF:000009', NULL, NULL, 'ATP synthase gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(60999, NULL, 'G3DSA:2.40.240.20:FF:000008', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4),
(61000, NULL, 'G3DSA:3.90.230.10:FF:000029', NULL, NULL, 'Methionine aminopeptidase 1c, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61001, NULL, 'G3DSA:2.40.70.10:FF:000583', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61002, NULL, 'G3DSA:1.25.10.10:FF:000712', NULL, NULL, 'KAP122p Karyopherin beta', NULL, NULL, NULL, NULL, NULL, 4),
(61003, NULL, 'G3DSA:3.30.70.330:FF:003142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61004, NULL, 'G3DSA:3.40.140.10:FF:000292', NULL, NULL, 'tRNA-specific adenosine deaminase subunit tad2', NULL, NULL, NULL, NULL, NULL, 4),
(61005, NULL, 'G3DSA:1.20.1560.10:FF:000610', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61006, NULL, 'G3DSA:2.70.98.10:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61007, NULL, 'G3DSA:2.60.40.1360:FF:000011', NULL, NULL, 'Alpha-mannosidase F', NULL, NULL, NULL, NULL, NULL, 4),
(61008, NULL, 'G3DSA:1.10.20.10:FF:000375', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61009, NULL, 'G3DSA:1.10.287.130:FF:000244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61010, NULL, 'G3DSA:3.40.50.150:FF:001159', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61011, NULL, 'G3DSA:3.40.50.720:FF:001662', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(61012, NULL, 'G3DSA:3.30.200.20:FF:002202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61013, NULL, 'G3DSA:3.30.505.10:FF:000209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61014, NULL, 'G3DSA:1.25.10.10:FF:000173', NULL, NULL, 'Tuberin isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(61015, NULL, 'G3DSA:1.10.10.60:FF:001120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61016, NULL, 'G3DSA:1.20.1250.20:FF:001438', NULL, NULL, 'AGAP000137-PA', NULL, NULL, NULL, NULL, NULL, 4),
(61017, NULL, 'G3DSA:3.30.1300.10:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61018, NULL, 'G3DSA:3.50.50.60:FF:000627', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(61019, NULL, 'G3DSA:1.20.5.110:FF:000136', NULL, NULL, 'Vesicle transport v-SNARE 13', NULL, NULL, NULL, NULL, NULL, 4),
(61020, NULL, 'G3DSA:2.60.120.260:FF:000136', NULL, NULL, 'Allantoicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61021, NULL, 'G3DSA:3.30.70.260:FF:000153', NULL, NULL, 'GTP pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(61022, NULL, 'G3DSA:1.10.4100.10:FF:000005', NULL, NULL, 'Catabolic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(61023, NULL, 'G3DSA:1.20.1280.50:FF:000100', NULL, NULL, 'F-box protein dre-1', NULL, NULL, NULL, NULL, NULL, 4),
(61024, NULL, 'G3DSA:1.25.40.10:FF:005233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61025, NULL, 'G3DSA:3.40.30.10:FF:001218', NULL, NULL, '2-hydroxychromene-2-carboxylate isomerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61026, NULL, 'G3DSA:3.20.20.20:FF:000042', NULL, NULL, 'Corrinoid/iron-sulfur protein, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(61027, NULL, 'G3DSA:3.40.50.300:FF:003565', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(61028, NULL, 'G3DSA:3.30.1140.40:FF:000010', NULL, NULL, 'Flagellar outer dynein arm light chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(61029, NULL, 'G3DSA:3.90.1150.10:FF:000022', NULL, NULL, '4-aminobutyrate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(61030, NULL, 'G3DSA:3.30.1490.120:FF:000029', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(61031, NULL, 'G3DSA:1.10.287.70:FF:000355', NULL, NULL, 'Potassium voltage-gated channel, KQT-like subfamily, member 1.2', NULL, NULL, NULL, NULL, NULL, 4),
(61032, NULL, 'G3DSA:1.10.510.10:FF:003191', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61033, NULL, 'G3DSA:3.40.50.300:FF:003907', NULL, NULL, 'ABC transporter-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(61034, NULL, 'G3DSA:1.25.40.10:FF:000793', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(61035, NULL, 'G3DSA:3.55.50.30:FF:000006', NULL, NULL, 'TonB-dependent siderophore receptor', NULL, NULL, NULL, NULL, NULL, 4),
(61036, NULL, 'G3DSA:1.10.510.10:FF:004039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61037, NULL, 'G3DSA:1.25.40.20:FF:000874', NULL, NULL, 'ATP-dependent RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61038, NULL, 'G3DSA:1.10.510.10:FF:001313', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 15', NULL, NULL, NULL, NULL, NULL, 4),
(61039, NULL, 'G3DSA:3.50.50.60:FF:000863', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(61040, NULL, 'G3DSA:3.30.160.360:FF:000006', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(61041, NULL, 'G3DSA:3.30.1490.100:FF:000023', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(61042, NULL, 'G3DSA:2.60.120.290:FF:000016', NULL, NULL, 'neuropilin and tolloid-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(61043, NULL, 'G3DSA:2.10.25.10:FF:001828', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61044, NULL, 'G3DSA:3.40.1410.10:FF:000037', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(61045, NULL, 'G3DSA:3.90.1750.10:FF:000096', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(61046, NULL, 'G3DSA:3.30.70.250:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61047, NULL, 'G3DSA:2.40.50.100:FF:000187', NULL, NULL, 'Putative ABC transporter ATP-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(61048, NULL, 'G3DSA:3.80.10.10:FF:001682', NULL, NULL, 'MAP kinase phosphatase with leucine-rich repeats protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(61049, NULL, 'G3DSA:1.20.1730.10:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61050, NULL, 'G3DSA:1.10.135.10:FF:000007', NULL, NULL, 'arginine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(61051, NULL, 'G3DSA:3.40.50.12470:FF:000008', NULL, NULL, '2-oxoglutarate dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(61052, NULL, 'G3DSA:1.20.120.350:FF:000179', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61053, NULL, 'G3DSA:1.10.2000.10:FF:000060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61054, NULL, 'G3DSA:2.10.25.10:FF:001800', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(61055, NULL, 'G3DSA:2.60.120.620:FF:000076', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(61056, NULL, 'G3DSA:2.40.70.10:FF:000436', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61057, NULL, 'G3DSA:3.30.930.10:FF:000377', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61058, NULL, 'G3DSA:3.40.50.1360:FF:000032', NULL, NULL, 'Deoxyribonucleoside regulator', NULL, NULL, NULL, NULL, NULL, 4),
(61059, NULL, 'G3DSA:3.30.160.60:FF:004256', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61060, NULL, 'G3DSA:1.10.510.10:FF:002111', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61061, NULL, 'G3DSA:2.60.120.260:FF:000389', NULL, NULL, 'Cytosolic endo-beta-N-acetylglucosaminidase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(61062, NULL, 'G3DSA:2.60.40.1080:FF:000011', NULL, NULL, 'Nuclear pore membrane glycoprotein 210-like', NULL, NULL, NULL, NULL, NULL, 4),
(61063, NULL, 'G3DSA:3.40.50.11350:FF:000010', NULL, NULL, 'GDP-fucose protein O-fucosyltransferase 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61064, NULL, 'G3DSA:3.40.50.2300:FF:000623', NULL, NULL, 'Vomeronasal 2, receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(61065, NULL, 'G3DSA:3.30.160.60:FF:000911', NULL, NULL, 'Zinc finger protein 641', NULL, NULL, NULL, NULL, NULL, 4),
(61066, NULL, 'G3DSA:2.20.70.10:FF:000078', NULL, NULL, 'Formin binding protein (FNB3)', NULL, NULL, NULL, NULL, NULL, 4),
(61067, NULL, 'G3DSA:3.30.200.20:FF:000752', NULL, NULL, 'Unplaced genomic scaffold supercont2.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(61068, NULL, 'G3DSA:3.40.190.10:FF:000351', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(61069, NULL, 'G3DSA:3.50.50.60:FF:000644', NULL, NULL, 'H(2):CoB-CoM heterodisulfide,ferredoxin reductase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(61070, NULL, 'G3DSA:3.40.50.10580:FF:000003', NULL, NULL, 'V-type proton ATPase subunit F', NULL, NULL, NULL, NULL, NULL, 4),
(61071, NULL, 'G3DSA:3.30.830.10:FF:000206', NULL, NULL, 'Insulin degrading enzyme-like zinc peptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61072, NULL, 'G3DSA:2.60.120.10:FF:000397', NULL, NULL, 'Oxalate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(61073, NULL, 'G3DSA:1.25.40.10:FF:004272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61074, NULL, 'G3DSA:2.160.10.10:FF:000062', NULL, NULL, 'Serine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(61075, NULL, 'G3DSA:2.170.130.10:FF:000062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61076, NULL, 'G3DSA:3.40.1830.10:FF:000001', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(61077, NULL, 'G3DSA:1.20.1070.10:FF:001707', NULL, NULL, 'Olfactory receptor 1434', NULL, NULL, NULL, NULL, NULL, 4),
(61078, NULL, 'G3DSA:3.40.50.150:FF:000625', NULL, NULL, 'Spermidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(61079, NULL, 'G3DSA:3.40.630.30:FF:000026', NULL, NULL, 'Phosphinothricin acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(61080, NULL, 'G3DSA:3.40.50.720:FF:000173', NULL, NULL, '3-oxoacyl-[acyl-carrier protein] reductase', NULL, NULL, NULL, NULL, NULL, 4),
(61081, NULL, 'G3DSA:3.90.79.10:FF:000300', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(61082, NULL, 'G3DSA:3.10.20.90:FF:000670', NULL, NULL, 'Ubiquitin family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61083, NULL, 'G3DSA:2.130.10.10:FF:002587', NULL, NULL, 'Conserved WD40 and TPR repeat-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61084, NULL, 'G3DSA:3.40.50.300:FF:004526', NULL, NULL, 'Putative elongator complex protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(61085, NULL, 'G3DSA:3.30.200.20:FF:000257', NULL, NULL, '3-phosphoinositide-dependent protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(61086, NULL, 'G3DSA:3.40.190.10:FF:000823', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61087, NULL, 'G3DSA:3.30.420.110:FF:000025', NULL, NULL, 'Msh4p', NULL, NULL, NULL, NULL, NULL, 4),
(61088, NULL, 'G3DSA:1.25.10.10:FF:000257', NULL, NULL, 'Conidiophore development protein hymA', NULL, NULL, NULL, NULL, NULL, 4),
(61089, NULL, 'G3DSA:1.10.510.10:FF:004056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61090, NULL, 'G3DSA:3.30.250.20:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61091, NULL, 'G3DSA:3.30.60.20:FF:000083', NULL, NULL, 'Thymidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(61092, NULL, 'G3DSA:3.40.50.880:FF:000052', NULL, NULL, 'ThiJ/pfpI family protein', NULL, NULL, NULL, NULL, NULL, 4),
(61093, NULL, 'G3DSA:3.30.70.660:FF:000060', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(61094, NULL, 'G3DSA:3.40.50.300:FF:005510', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(61095, NULL, 'G3DSA:3.55.10.10:FF:000004', NULL, NULL, 'Zinc finger and BTB domain containing 8 opposite strand', NULL, NULL, NULL, NULL, NULL, 4),
(61096, NULL, 'G3DSA:3.10.620.30:FF:000004', NULL, NULL, 'Peptidase (PNG1)', NULL, NULL, NULL, NULL, NULL, 4),
(61097, NULL, 'G3DSA:1.20.1270.10:FF:000054', NULL, NULL, 'Chaperone protein DnaK', NULL, NULL, NULL, NULL, NULL, 4),
(61098, NULL, 'G3DSA:3.40.20.10:FF:000122', NULL, NULL, 'Drebrin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(61099, NULL, 'G3DSA:3.30.2160.10:FF:000008', NULL, NULL, 'Apoptosis-resistant E3 ubiquitin protein ligase 1', NULL, NULL, NULL, NULL, NULL, 4),
(61100, NULL, 'G3DSA:3.10.580.10:FF:000202', NULL, NULL, 'CBS domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(61101, NULL, 'G3DSA:1.20.58.1220:FF:000001', NULL, NULL, 'Exocyst complex component EXO84B', NULL, NULL, NULL, NULL, NULL, 4),
(61102, NULL, 'G3DSA:2.130.10.10:FF:005420', NULL, NULL, 'Serine threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61103, NULL, 'G3DSA:3.30.413.10:FF:000035', NULL, NULL, 'Precorrin-3B synthase', NULL, NULL, NULL, NULL, NULL, 4),
(61104, NULL, 'G3DSA:2.60.40.3510:FF:000021', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(61105, NULL, 'G3DSA:2.30.30.40:FF:000067', NULL, NULL, 'Growth factor receptor-bound protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(61106, NULL, 'G3DSA:3.40.50.1000:FF:000093', NULL, NULL, 'NLI interacting factor-like phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(61107, NULL, 'G3DSA:2.10.25.10:FF:000867', NULL, NULL, 'Aggrecan a', NULL, NULL, NULL, NULL, NULL, 4),
(61108, NULL, 'G3DSA:3.30.70.2740:FF:000010', NULL, NULL, 'FAD-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(61109, NULL, 'G3DSA:2.40.50.140:FF:000194', NULL, NULL, 'Programmed cell death 11', NULL, NULL, NULL, NULL, NULL, 4),
(61110, NULL, 'G3DSA:3.90.70.10:FF:000409', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61111, NULL, 'G3DSA:3.40.50.1950:FF:000006', NULL, NULL, 'Flavin prenyltransferase UbiX', NULL, NULL, NULL, NULL, NULL, 4),
(61112, NULL, 'G3DSA:3.90.470.10:FF:000047', NULL, NULL, '60S ribosomal protein L17-2', NULL, NULL, NULL, NULL, NULL, 4),
(61113, NULL, 'G3DSA:2.60.40.60:FF:000555', NULL, NULL, 'cadherin EGF LAG seven-pass G-type receptor 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(61114, NULL, 'G3DSA:2.60.40.10:FF:003082', NULL, NULL, 'CD226 antigen (Predicted), isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(61115, NULL, 'G3DSA:2.30.29.30:FF:000100', NULL, NULL, 'Rho GTPase activating protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(61116, NULL, 'G3DSA:2.40.110.10:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61117, NULL, 'G3DSA:3.40.50.410:FF:000052', NULL, NULL, 'collagen alpha-2(VI) chain isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(61118, NULL, 'G3DSA:3.40.50.2300:FF:000128', NULL, NULL, 'Glutamate ionotropic receptor NMDA type subunit 3A', NULL, NULL, NULL, NULL, NULL, 4),
(61119, NULL, 'G3DSA:3.40.1380.20:FF:000059', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(61120, NULL, 'G3DSA:2.30.39.10:FF:000044', NULL, NULL, 'Alaserpin', NULL, NULL, NULL, NULL, NULL, 4),
(61121, NULL, 'G3DSA:1.50.10.130:FF:000010', NULL, NULL, 'Ent-kaurene synthase-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(61122, NULL, 'G3DSA:1.25.40.10:FF:004699', NULL, NULL, 'Os06g0228900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(61123, NULL, 'G3DSA:1.20.120.160:FF:000004', NULL, NULL, 'Phosphotransferase RcsD', NULL, NULL, NULL, NULL, NULL, 4),
(61124, NULL, 'G3DSA:3.30.160.60:FF:004492', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61125, NULL, 'G3DSA:2.10.25.10:FF:000491', NULL, NULL, 'Laminin subunit alpha 4', NULL, NULL, NULL, NULL, NULL, 4),
(61126, NULL, 'G3DSA:3.40.50.2300:FF:000584', NULL, NULL, 'Uncharacterized protein C30A5.10', NULL, NULL, NULL, NULL, NULL, 4),
(61127, NULL, 'G3DSA:3.40.50.10190:FF:000212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(61128, NULL, 'G3DSA:1.20.910.10:FF:000032', NULL, NULL, 'Aminopyrimidine aminohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(61129, NULL, 'G3DSA:1.10.10.520:FF:000001', NULL, NULL, 'NEDD8-activating enzyme E1 catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(61130, NULL, 'G3DSA:3.40.630.10:FF:000357', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61131, NULL, 'G3DSA:3.40.50.2300:FF:000932', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61132, NULL, 'G3DSA:1.25.40.10:FF:001973', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(61133, NULL, 'G3DSA:2.20.80.10:FF:000011', NULL, NULL, 'Vitellogenin-6', NULL, NULL, NULL, NULL, NULL, 4),
(61134, NULL, 'G3DSA:3.30.160.60:FF:003328', NULL, NULL, 'Zn finger homeodomain 2', NULL, NULL, NULL, NULL, NULL, 4),
(61135, NULL, 'G3DSA:1.10.510.10:FF:003999', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61136, NULL, 'G3DSA:1.20.140.150:FF:000128', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(61137, NULL, 'G3DSA:2.40.50.140:FF:000047', NULL, NULL, 'tyrosine--tRNA ligase, cytoplasmic isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(61138, NULL, 'G3DSA:3.40.50.2300:FF:001112', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61139, NULL, 'G3DSA:1.20.58.390:FF:000068', NULL, NULL, 'zinc-activated ligand-gated ion channel', NULL, NULL, NULL, NULL, NULL, 4),
(61140, NULL, 'G3DSA:3.30.2130.30:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61141, NULL, 'G3DSA:3.30.40.10:FF:001944', NULL, NULL, 'Os02g0528000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(61142, NULL, 'G3DSA:1.10.555.10:FF:000062', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(61143, NULL, 'G3DSA:2.60.120.200:FF:000181', NULL, NULL, 'Crumbs, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(61144, NULL, 'G3DSA:3.40.50.1240:FF:000125', NULL, NULL, 'Phosphoglycerate mutase protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61145, NULL, 'G3DSA:1.10.10.10:FF:001173', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(61146, NULL, 'G3DSA:3.40.50.12780:FF:000129', NULL, NULL, '2-succinylbenzoate--CoA ligase, chloroplastic/peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(61147, NULL, 'G3DSA:1.25.40.20:FF:000559', NULL, NULL, 'Mann-cup, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(61148, NULL, 'G3DSA:1.10.533.10:FF:000045', NULL, NULL, 'Nucleotide-binding oligomerization domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(61149, NULL, 'G3DSA:3.10.450.40:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61150, NULL, 'G3DSA:2.70.130.10:FF:000081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61151, NULL, 'G3DSA:3.40.50.300:FF:003115', NULL, NULL, 'FHA domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(61152, NULL, 'G3DSA:3.30.390.50:FF:000021', NULL, NULL, 'Xanthine dehydrogenase/oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(61153, NULL, 'G3DSA:2.130.10.10:FF:003076', NULL, NULL, 'WD repeat domain 18', NULL, NULL, NULL, NULL, NULL, 4),
(61154, NULL, 'G3DSA:3.40.47.10:FF:000015', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(61155, NULL, 'G3DSA:3.40.525.10:FF:000034', NULL, NULL, 'IRA2p GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(61156, NULL, 'G3DSA:3.40.50.2300:FF:000275', NULL, NULL, 'Transcriptional regulator, LacI family', NULL, NULL, NULL, NULL, NULL, 4),
(61157, NULL, 'G3DSA:3.40.50.1820:FF:001159', NULL, NULL, 'Prolylcarboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61158, NULL, 'G3DSA:1.20.1540.10:FF:000047', NULL, NULL, 'Rhomboid like 3', NULL, NULL, NULL, NULL, NULL, 4),
(61159, NULL, 'G3DSA:1.10.8.60:FF:000102', NULL, NULL, 'Cell division control protein', NULL, NULL, NULL, NULL, NULL, 4),
(61160, NULL, 'G3DSA:3.40.50.1000:FF:000654', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61161, NULL, 'G3DSA:1.25.10.10:FF:000965', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(61162, NULL, 'G3DSA:1.20.1250.20:FF:000168', NULL, NULL, 'Transporter, major facilitator family', NULL, NULL, NULL, NULL, NULL, 4),
(61163, NULL, 'G3DSA:1.10.455.10:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61164, NULL, 'G3DSA:3.30.497.10:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61165, NULL, 'G3DSA:3.30.1240.10:FF:000043', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(61166, NULL, 'G3DSA:1.25.70.10:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61167, NULL, 'G3DSA:3.10.400.10:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61168, NULL, 'G3DSA:2.40.50.140:FF:001031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61169, NULL, 'G3DSA:2.120.10.80:FF:000051', NULL, NULL, 'Multiple epidermal growth factor-like domains protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(61170, NULL, 'G3DSA:2.60.40.150:FF:000459', NULL, NULL, 'Bud/polarization protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61171, NULL, 'G3DSA:1.10.10.440:FF:000089', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(61172, NULL, 'G3DSA:1.10.238.10:FF:001230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61173, NULL, 'G3DSA:1.10.8.10:FF:000020', NULL, NULL, 'NSFL1 (p97) cofactor (p47)', NULL, NULL, NULL, NULL, NULL, 4),
(61174, NULL, 'G3DSA:3.30.160.60:FF:001400', NULL, NULL, 'Zinc finger X-linked protein ZXDB', NULL, NULL, NULL, NULL, NULL, 4),
(61175, NULL, 'G3DSA:3.40.50.10260:FF:000020', NULL, NULL, 'NAD(P)H-hydrate epimerase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(61176, NULL, 'G3DSA:3.30.70.60:FF:000028', NULL, NULL, 'Elongation factor 1-delta', NULL, NULL, NULL, NULL, NULL, 4),
(61177, NULL, 'G3DSA:1.20.1410.10:FF:000043', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(61178, NULL, 'G3DSA:3.30.60.30:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61179, NULL, 'G3DSA:3.30.70.3290:FF:000012', NULL, NULL, 'Polyketide synthase type I', NULL, NULL, NULL, NULL, NULL, 4),
(61180, NULL, 'G3DSA:2.20.70.10:FF:000263', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(61181, NULL, 'G3DSA:3.40.50.720:FF:000482', NULL, NULL, 'Alcohol dehydrogenase D', NULL, NULL, NULL, NULL, NULL, 4),
(61182, NULL, 'G3DSA:1.10.10.10:FF:001482', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(61183, NULL, 'G3DSA:3.60.21.10:FF:000264', NULL, NULL, 'Phosphoesterase ykuE', NULL, NULL, NULL, NULL, NULL, 4),
(61184, NULL, 'G3DSA:1.20.58.60:FF:000465', NULL, NULL, 'Protein CBG15811', NULL, NULL, NULL, NULL, NULL, 4),
(61185, NULL, 'G3DSA:1.10.10.60:FF:000428', NULL, NULL, 'Transcription factor MYB39', NULL, NULL, NULL, NULL, NULL, 4),
(61186, NULL, 'G3DSA:2.120.10.30:FF:000497', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61187, NULL, 'G3DSA:4.10.800.30:FF:000003', NULL, NULL, 'Essential meiotic structure-specific endonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(61188, NULL, 'G3DSA:2.60.40.790:FF:000095', NULL, NULL, '18.5 kDa class I heat shock protein', NULL, NULL, NULL, NULL, NULL, 4),
(61189, NULL, 'G3DSA:3.30.40.10:FF:000635', NULL, NULL, 'E3 ubiquitin-protein ligase DZIP3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(61190, NULL, 'G3DSA:1.10.400.10:FF:000091', NULL, NULL, 'Guanine nucleotide-binding protein alpha-4 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(61191, NULL, 'G3DSA:1.20.1070.10:FF:000073', NULL, NULL, 'Adhesion G-protein coupled receptor D1', NULL, NULL, NULL, NULL, NULL, 4),
(61192, NULL, 'G3DSA:3.40.50.720:FF:000251', NULL, NULL, 'Sterol-4-alpha-carboxylate 3-dehydrogenase, decarboxylating', NULL, NULL, NULL, NULL, NULL, 4),
(61193, NULL, 'G3DSA:2.130.10.10:FF:003531', NULL, NULL, 'F-box/wd-repeat protein lin-23', NULL, NULL, NULL, NULL, NULL, 4),
(61194, NULL, 'G3DSA:2.60.40.10:FF:002946', NULL, NULL, 'Neuron-glia cell adhesion molecule (Ng-CAM)', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(61195, NULL, 'G3DSA:2.10.25.10:FF:001036', NULL, NULL, 'Distracted, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(61196, NULL, 'G3DSA:3.30.730.10:FF:000013', NULL, NULL, 'AINTEGUMENTA-like 6', NULL, NULL, NULL, NULL, NULL, 4),
(61197, NULL, 'G3DSA:2.60.40.2750:FF:000001', NULL, NULL, 'Heparin and heparin-sulfate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(61198, NULL, 'G3DSA:3.40.50.300:FF:001800', NULL, NULL, 'Rab family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(61199, NULL, 'G3DSA:1.10.238.10:FF:000196', NULL, NULL, 'Mitochondrial substrate carrier family protein', NULL, NULL, NULL, NULL, NULL, 4),
(61200, NULL, 'G3DSA:3.80.10.10:FF:004116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61201, NULL, 'G3DSA:1.10.472.10:FF:000240', NULL, NULL, 'Cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(61202, NULL, 'G3DSA:3.40.630.10:FF:000048', NULL, NULL, 'carboxypeptidase D isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(61203, NULL, 'G3DSA:1.10.10.10:FF:001038', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(61204, NULL, 'G3DSA:3.30.310.50:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61205, NULL, 'G3DSA:3.20.20.70:FF:000843', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61206, NULL, 'G3DSA:1.20.120.1750:FF:000044', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(61207, NULL, 'G3DSA:1.20.58.70:FF:000013', NULL, NULL, 'Syntaxin 132', NULL, NULL, NULL, NULL, NULL, 4),
(61208, NULL, 'G3DSA:1.10.287.70:FF:000372', NULL, NULL, 'cGMP-gated cation channel alpha-1', NULL, NULL, NULL, NULL, NULL, 4),
(61209, NULL, 'G3DSA:3.80.10.10:FF:003610', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61210, NULL, 'G3DSA:1.25.40.10:FF:000085', NULL, NULL, 'Cell division cycle 27 homolog (S. cerevisiae)', NULL, NULL, NULL, NULL, NULL, 4),
(61211, NULL, 'G3DSA:3.90.1800.10:FF:000016', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(61212, NULL, 'G3DSA:2.10.25.10:FF:001564', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61213, NULL, 'G3DSA:1.25.40.20:FF:001723', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61214, NULL, 'G3DSA:1.20.1070.10:FF:001691', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(61215, NULL, 'G3DSA:1.20.1560.10:FF:000138', NULL, NULL, 'Competence factor transporting ATP-binding protein/permease ComA', NULL, NULL, NULL, NULL, NULL, 4),
(61216, NULL, 'G3DSA:3.40.50.300:FF:003346', NULL, NULL, 'HSR1 MMR1 domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61217, NULL, 'G3DSA:3.10.50.40:FF:000050', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(61218, NULL, 'G3DSA:3.40.50.1240:FF:000142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61219, NULL, 'G3DSA:2.60.40.1180:FF:000187', NULL, NULL, '4-alpha-glucanotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(61220, NULL, 'G3DSA:3.40.640.10:FF:000077', NULL, NULL, 'Spore coat polysaccharide biosynthesis protein spsC', NULL, NULL, NULL, NULL, NULL, 4),
(61221, NULL, 'G3DSA:2.30.42.10:FF:000642', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61222, NULL, 'G3DSA:2.60.120.200:FF:000742', NULL, NULL, 'Calnexin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61223, NULL, 'G3DSA:1.10.12.70:FF:000003', NULL, NULL, 'Serine/threonine-protein kinase 25', NULL, NULL, NULL, NULL, NULL, 4),
(61224, NULL, 'G3DSA:3.40.50.300:FF:008236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61225, NULL, 'G3DSA:3.40.50.300:FF:007617', NULL, NULL, 'Replication protein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(61226, NULL, 'G3DSA:1.10.510.10:FF:004511', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61227, NULL, 'G3DSA:1.25.40.10:FF:001181', NULL, NULL, 'PPR containing plant-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(61228, NULL, 'G3DSA:3.10.20.70:FF:000017', NULL, NULL, 'Probable glutamine synthetase glnA3', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(61229, NULL, 'G3DSA:3.40.50.12470:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61230, NULL, 'G3DSA:2.120.10.80:FF:000034', NULL, NULL, 'Attractin', NULL, NULL, NULL, NULL, NULL, 4),
(61231, NULL, 'G3DSA:2.60.420.10:FF:000015', NULL, NULL, 'Cyclic beta-(1,2)-glucan synthase NdvB', NULL, NULL, NULL, NULL, NULL, 4),
(61232, NULL, 'G3DSA:2.30.130.40:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61233, NULL, 'G3DSA:3.30.310.10:FF:000066', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(61234, NULL, 'G3DSA:1.25.40.10:FF:000562', NULL, NULL, 'SNAP protein (Soluble N-ethylmaleimide-sensitive factor attachment protein)', NULL, NULL, NULL, NULL, NULL, 4),
(61235, NULL, 'G3DSA:1.10.1040.10:FF:000051', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase (NAD(+))', NULL, NULL, NULL, NULL, NULL, 4),
(61236, NULL, 'G3DSA:2.60.120.650:FF:000158', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(61237, NULL, 'G3DSA:2.10.50.30:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61238, NULL, 'G3DSA:3.40.50.720:FF:001246', NULL, NULL, 'Oxidoreductase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(61239, NULL, 'G3DSA:2.60.40.790:FF:000106', NULL, NULL, 'CS_domain/TPR_repeat/Tetratricopeptide_repeat_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(61240, NULL, 'G3DSA:3.40.1690.20:FF:000021', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(61241, NULL, 'G3DSA:1.10.1670.10:FF:000076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61242, NULL, 'G3DSA:1.25.40.570:FF:000006', NULL, NULL, 'COP9 signalosome complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(61243, NULL, 'G3DSA:2.60.40.10:FF:001951', NULL, NULL, 'Beta-galactosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61244, NULL, 'G3DSA:1.10.472.80:FF:000199', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61245, NULL, 'G3DSA:2.130.10.10:FF:001822', NULL, NULL, 'F-box and WD-40 domain-containing protein MET30', NULL, NULL, NULL, NULL, NULL, 4),
(61246, NULL, 'G3DSA:1.10.10.60:FF:001047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61247, NULL, 'G3DSA:3.30.420.40:FF:000690', NULL, NULL, 'YALI0F10923p', NULL, NULL, NULL, NULL, NULL, 4),
(61248, NULL, 'G3DSA:3.20.20.80:FF:000161', NULL, NULL, 'Heparanase', NULL, NULL, NULL, NULL, NULL, 4),
(61249, NULL, 'G3DSA:3.40.1380.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61250, NULL, 'G3DSA:3.30.750.200:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61251, NULL, 'G3DSA:1.25.40.20:FF:000998', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61252, NULL, 'G3DSA:3.10.129.10:FF:000093', NULL, NULL, 'Acyl-coenzyme A thioesterase PaaI', NULL, NULL, NULL, NULL, NULL, 4),
(61253, NULL, 'G3DSA:3.40.1110.10:FF:000469', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61254, NULL, 'G3DSA:3.40.120.10:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61255, NULL, 'G3DSA:3.40.190.10:FF:000132', NULL, NULL, 'Lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(61256, NULL, 'G3DSA:3.30.420.60:FF:000010', NULL, NULL, 'Pelo protein', NULL, NULL, NULL, NULL, NULL, 4),
(61257, NULL, 'G3DSA:3.90.960.10:FF:000011', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(61258, NULL, 'G3DSA:3.30.70.330:FF:001798', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61259, NULL, 'G3DSA:3.40.50.2000:FF:000831', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61260, NULL, 'G3DSA:1.10.630.10:FF:000821', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61261, NULL, 'G3DSA:3.10.590.10:FF:000012', NULL, NULL, '30-kDa cleavage and polyadenylation specificity factor 30', NULL, NULL, NULL, NULL, NULL, 4),
(61262, NULL, 'G3DSA:1.20.1420.30:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61263, NULL, 'G3DSA:1.10.10.350:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(61264, NULL, 'G3DSA:3.40.630.10:FF:000487', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61265, NULL, 'G3DSA:3.30.160.60:FF:005240', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61266, NULL, 'G3DSA:3.40.605.10:FF:000052', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(61267, NULL, 'G3DSA:3.10.110.10:FF:000364', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(61268, NULL, 'G3DSA:1.10.720.30:FF:000042', NULL, NULL, 'Os11g0483600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(61269, NULL, 'G3DSA:3.30.70.660:FF:000020', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(61270, NULL, 'G3DSA:1.10.510.10:FF:000329', NULL, NULL, 'Titin a', NULL, NULL, NULL, NULL, NULL, 4),
(61271, NULL, 'G3DSA:2.180.10.10:FF:000016', NULL, NULL, 'Teneurin transmembrane protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(61272, NULL, 'G3DSA:3.40.50.300:FF:006999', NULL, NULL, 'Ras-related protein Rab6-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(61273, NULL, 'G3DSA:1.10.10.10:FF:000532', NULL, NULL, 'Cell division control protein', NULL, NULL, NULL, NULL, NULL, 4),
(61274, NULL, 'G3DSA:3.90.79.10:FF:000261', NULL, NULL, 'NUDIX domain hydrolase1', NULL, NULL, NULL, NULL, NULL, 4),
(61275, NULL, 'G3DSA:2.60.34.10:FF:000060', NULL, NULL, 'Protein CBG07033', NULL, NULL, NULL, NULL, NULL, 4),
(61276, NULL, 'G3DSA:1.10.510.10:FF:001419', NULL, NULL, '3-phosphoinositide-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(61277, NULL, 'G3DSA:3.30.760.10:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61278, NULL, 'G3DSA:2.30.30.1150:FF:000011', NULL, NULL, 'E3 ubiquitin ligase Np95, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61279, NULL, 'G3DSA:3.30.70.330:FF:001809', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61280, NULL, 'G3DSA:3.30.1360.30:FF:000001', NULL, NULL, 'Aspartate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(61281, NULL, 'G3DSA:1.20.5.170:FF:000042', NULL, NULL, 'Cyclic AMP-responsive element-binding protein 3-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(61282, NULL, 'G3DSA:3.30.200.20:FF:000622', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(61283, NULL, 'G3DSA:2.30.30.30:FF:000081', NULL, NULL, '60S ribosomal protein L40, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(61284, NULL, 'G3DSA:3.40.50.880:FF:000158', NULL, NULL, 'ES1 protein homolog, mitochondrial isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(61285, NULL, 'G3DSA:2.130.10.10:FF:002912', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61286, NULL, 'G3DSA:1.25.40.10:FF:002119', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(61287, NULL, 'G3DSA:3.30.1490.420:FF:000001', NULL, NULL, 'Ubiquitin C-terminal hydrolase L3', NULL, NULL, NULL, NULL, NULL, 4),
(61288, NULL, 'G3DSA:3.40.50.1820:FF:001524', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61289, NULL, 'G3DSA:1.10.30.10:FF:000095', NULL, NULL, 'High mobility group protein-like tdp-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61290, NULL, 'G3DSA:3.90.1640.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61291, NULL, 'G3DSA:1.10.150.20:FF:000023', NULL, NULL, 'DNA integrity scanning protein DisA', NULL, NULL, NULL, NULL, NULL, 4),
(61292, NULL, 'G3DSA:1.20.5.170:FF:000238', NULL, NULL, 'AP-1-like transcription factor YAP5', NULL, NULL, NULL, NULL, NULL, 4),
(61293, NULL, 'G3DSA:1.25.10.10:FF:001353', NULL, NULL, 'Maestro heat-like repeat family member 4', NULL, NULL, NULL, NULL, NULL, 4),
(61294, NULL, 'G3DSA:3.40.1110.10:FF:000216', NULL, NULL, 'Putative P-type cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(61295, NULL, 'G3DSA:4.10.70.30:FF:000001', NULL, NULL, 'ADAM 17-like protease', NULL, NULL, NULL, NULL, NULL, 4),
(61296, NULL, 'G3DSA:3.30.70.330:FF:001489', NULL, NULL, 'Putative RNA binding protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(61297, NULL, 'G3DSA:1.20.1250.20:FF:001573', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61298, NULL, 'G3DSA:1.10.238.20:FF:000053', NULL, NULL, 'AGAP012323-PA', NULL, NULL, NULL, NULL, NULL, 4),
(61299, NULL, 'G3DSA:3.90.470.20:FF:000038', NULL, NULL, '4-phosphopantetheinyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(61300, NULL, 'G3DSA:2.130.10.10:FF:001603', NULL, NULL, 'Fritz, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(61301, NULL, 'G3DSA:3.30.710.10:FF:000158', NULL, NULL, 'Ankyrin repeat and BTB/POZ domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(61302, NULL, 'G3DSA:1.10.510.10:FF:002566', NULL, NULL, 'Mitosis inhibitor protein kinase SWE1', NULL, NULL, NULL, NULL, NULL, 4),
(61303, NULL, 'G3DSA:3.30.70.120:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61304, NULL, 'G3DSA:3.30.1370.10:FF:000182', NULL, NULL, 'KH domain containing 4, pre-mRNA splicing factor', NULL, NULL, NULL, NULL, NULL, 4),
(61305, NULL, 'G3DSA:1.10.10.1590:FF:000007', NULL, NULL, 'NAD-reducing hydrogenase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(61306, NULL, 'G3DSA:1.20.58.190:FF:000002', NULL, NULL, 'Translin-associated factor X', NULL, NULL, NULL, NULL, NULL, 4),
(61307, NULL, 'G3DSA:1.10.287.410:FF:000002', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(61308, NULL, 'G3DSA:3.30.70.330:FF:002523', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61309, NULL, 'G3DSA:3.30.190.20:FF:000042', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(61310, NULL, 'G3DSA:3.30.300.180:FF:000002', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(61311, NULL, 'G3DSA:1.10.238.10:FF:000516', NULL, NULL, 'Caltractin', NULL, NULL, NULL, NULL, NULL, 4),
(61312, NULL, 'G3DSA:2.60.40.760:FF:000002', NULL, NULL, 'Beta-expansin 3', NULL, NULL, NULL, NULL, NULL, 4),
(61313, NULL, 'G3DSA:3.90.550.10:FF:000093', NULL, NULL, 'Colanic acid biosynthesis glycosyltransferase WcaE', NULL, NULL, NULL, NULL, NULL, 4),
(61314, NULL, 'G3DSA:2.40.50.140:FF:000839', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61315, NULL, 'G3DSA:1.25.40.10:FF:001866', NULL, NULL, 'Paraflagellar rod component', NULL, NULL, NULL, NULL, NULL, 4),
(61316, NULL, 'G3DSA:1.20.50.70:FF:000001', NULL, NULL, 'CD109 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(61317, NULL, 'G3DSA:3.60.21.10:FF:000348', NULL, NULL, 'Protein CBG05769', NULL, NULL, NULL, NULL, NULL, 4),
(61318, NULL, 'G3DSA:1.10.275.40:FF:000021', NULL, NULL, 'Fanconi anemia group J protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(61319, NULL, 'G3DSA:3.30.40.10:FF:001927', NULL, NULL, 'Ubiquitin-protein ligase CIP8', NULL, NULL, NULL, NULL, NULL, 4),
(61320, NULL, 'G3DSA:1.10.472.170:FF:000004', NULL, NULL, 'Transcription initiation factor TFIIB, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61321, NULL, 'G3DSA:3.90.70.10:FF:000516', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61322, NULL, 'G3DSA:3.30.559.10:FF:000036', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(61323, NULL, 'G3DSA:2.60.15.10:FF:000010', NULL, NULL, 'ATP synthase epsilon chain', NULL, NULL, NULL, NULL, NULL, 4),
(61324, NULL, 'G3DSA:3.40.190.10:FF:000790', NULL, NULL, 'Putative solute binding transport lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(61325, NULL, 'G3DSA:3.80.10.10:FF:001210', NULL, NULL, 'Toll receptor', NULL, NULL, NULL, NULL, NULL, 4),
(61326, NULL, 'G3DSA:1.10.510.10:FF:002802', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61327, NULL, 'G3DSA:2.30.29.30:FF:000920', NULL, NULL, '3-phosphoinositide-dependent protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(61328, NULL, 'G3DSA:1.10.20.140:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61329, NULL, 'G3DSA:2.60.40.60:FF:000994', NULL, NULL, 'Protein CBR-CDH-12', NULL, NULL, NULL, NULL, NULL, 4),
(61330, NULL, 'G3DSA:3.80.10.10:FF:001137', NULL, NULL, 'F-box domain containing protein, expressed', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(61331, NULL, 'G3DSA:3.30.70.100:FF:000021', NULL, NULL, 'Monooxygenase ydhR', NULL, NULL, NULL, NULL, NULL, 4),
(61332, NULL, 'G3DSA:3.20.190.10:FF:000013', NULL, NULL, 'Endonuclease VIII', NULL, NULL, NULL, NULL, NULL, 4),
(61333, NULL, 'G3DSA:1.20.930.60:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61334, NULL, 'G3DSA:2.60.40.10:FF:004172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61335, NULL, 'G3DSA:3.40.50.720:FF:000627', NULL, NULL, 'Saccharopine dehydrogenase [NAD(+), L-lysine-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(61336, NULL, 'G3DSA:3.20.70.20:FF:000005', NULL, NULL, 'Ribonucleoside-diphosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(61337, NULL, 'G3DSA:1.10.10.10:FF:001257', NULL, NULL, 'FYVE finger-containing phosphoinositide kinase, fyv1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61338, NULL, 'G3DSA:1.10.1450.10:FF:000115', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(61339, NULL, 'G3DSA:3.90.550.50:FF:000054', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(61340, NULL, 'G3DSA:3.40.50.620:FF:000367', NULL, NULL, 'Phosphoadenosine phosphosulfate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(61341, NULL, 'G3DSA:2.30.29.30:FF:001393', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61342, NULL, 'G3DSA:1.20.1250.20:FF:000713', NULL, NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(61343, NULL, 'G3DSA:2.60.40.10:FF:002570', NULL, NULL, 'Protein-tyrosine-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(61344, NULL, 'G3DSA:2.40.160.110:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61345, NULL, 'G3DSA:3.40.1480.10:FF:000002', NULL, NULL, 'Glycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(61346, NULL, 'G3DSA:3.80.10.10:FF:001665', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(61347, NULL, 'G3DSA:3.40.50.300:FF:000367', NULL, NULL, 'ABC transporter G family member 24', NULL, NULL, NULL, NULL, NULL, 4),
(61348, NULL, 'G3DSA:3.30.1370.110:FF:000022', NULL, NULL, 'Smr (Small MutS Related) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(61349, NULL, 'G3DSA:3.40.50.2000:FF:000292', NULL, NULL, 'Glycosyltransferase GtfE', NULL, NULL, NULL, NULL, NULL, 4),
(61350, NULL, 'G3DSA:3.40.50.1380:FF:000026', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(61351, NULL, 'G3DSA:2.30.30.140:FF:000220', NULL, NULL, 'Enhanced RNAI (RNA interference)', NULL, NULL, NULL, NULL, NULL, 4),
(61352, NULL, 'G3DSA:3.60.21.10:FF:000039', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(61353, NULL, 'G3DSA:2.60.120.200:FF:000377', NULL, NULL, 'Protein S', NULL, NULL, NULL, NULL, NULL, 4),
(61354, NULL, 'G3DSA:3.30.160.60:FF:004817', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61355, NULL, 'G3DSA:3.80.10.10:FF:004335', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61356, NULL, 'G3DSA:3.90.226.10:FF:000255', NULL, NULL, 'Carboxyl-terminal protease', NULL, NULL, NULL, NULL, NULL, 4),
(61357, NULL, 'G3DSA:3.30.40.10:FF:000854', NULL, NULL, 'Transcription factor BYE1', NULL, NULL, NULL, NULL, NULL, 4),
(61358, NULL, 'G3DSA:3.30.70.330:FF:002214', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61359, NULL, 'G3DSA:1.25.40.20:FF:001414', NULL, NULL, 'Oxysterol-binding protein homolog C2F12.05c', NULL, NULL, NULL, NULL, NULL, 4),
(61360, NULL, 'G3DSA:1.25.40.10:FF:001501', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g37230', NULL, NULL, NULL, NULL, NULL, 4),
(61361, NULL, 'G3DSA:2.10.25.10:FF:000417', NULL, NULL, 'neural-cadherin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(61362, NULL, 'G3DSA:3.90.190.10:FF:000121', NULL, NULL, 'Corkscrew, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(61363, NULL, 'G3DSA:3.30.465.10:FF:000037', NULL, NULL, 'Magnesium and cobalt transporter', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(61364, NULL, 'G3DSA:1.10.472.130:FF:000043', NULL, NULL, 'Putative dynein heavy chain, cytosolic', NULL, NULL, NULL, NULL, NULL, 4),
(61365, NULL, 'G3DSA:1.20.90.10:FF:000019', NULL, NULL, 'AGAP004730-PA', NULL, NULL, NULL, NULL, NULL, 4),
(61366, NULL, 'G3DSA:3.30.420.80:FF:000016', NULL, NULL, 'Mitochondrial Ribosomal Protein, Small', NULL, NULL, NULL, NULL, NULL, 4),
(61367, NULL, 'G3DSA:2.130.10.10:FF:002694', NULL, NULL, 'WD40-repeat-containing domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(61368, NULL, 'G3DSA:3.10.100.10:FF:000335', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61369, NULL, 'G3DSA:3.30.1640.10:FF:000051', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(61370, NULL, 'G3DSA:1.20.5.420:FF:000004', NULL, NULL, 'Chromosome partition protein MukB', NULL, NULL, NULL, NULL, NULL, 4),
(61371, NULL, 'G3DSA:1.10.640.10:FF:000086', NULL, NULL, 'Oxidase/peroxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61372, NULL, 'G3DSA:3.30.40.10:FF:002080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61373, NULL, 'G3DSA:1.20.5.110:FF:000030', NULL, NULL, 'syntaxin-51 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(61374, NULL, 'G3DSA:2.130.10.10:FF:003840', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61375, NULL, 'G3DSA:3.80.10.10:FF:000064', NULL, NULL, 'Scribbled planar cell polarity protein', NULL, NULL, NULL, NULL, NULL, 4),
(61376, NULL, 'G3DSA:1.10.8.60:FF:000208', NULL, NULL, 'DNA polymerase epsilon subunit', NULL, NULL, NULL, NULL, NULL, 4),
(61377, NULL, 'G3DSA:3.40.1280.10:FF:000094', NULL, NULL, 'rRNA methyltransferase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(61378, NULL, 'G3DSA:3.40.50.620:FF:000906', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(61379, NULL, 'G3DSA:3.40.710.10:FF:000105', NULL, NULL, 'Penicillin-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61380, NULL, 'G3DSA:2.40.30.30:FF:000013', NULL, NULL, 'Riboflavin kinase', NULL, NULL, NULL, NULL, NULL, 4),
(61381, NULL, 'G3DSA:2.40.50.90:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61382, NULL, 'G3DSA:3.10.20.90:FF:000776', NULL, NULL, 'YALI0D16335p', NULL, NULL, NULL, NULL, NULL, 4),
(61383, NULL, 'G3DSA:3.40.50.300:FF:004970', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61384, NULL, 'G3DSA:3.50.50.60:FF:000071', NULL, NULL, 'apoptosis-inducing factor 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(61385, NULL, 'G3DSA:3.40.50.1000:FF:000177', NULL, NULL, 'Putative Alpha,alpha-trehalose phosphate synthase subunit Tps3', NULL, NULL, NULL, NULL, NULL, 4),
(61386, NULL, 'G3DSA:2.60.40.10:FF:002238', NULL, NULL, 'Titin, tandem duplicate 1', NULL, NULL, NULL, NULL, NULL, 4),
(61387, NULL, 'G3DSA:1.10.20.10:FF:000139', NULL, NULL, 'AaceriACL158Wp', NULL, NULL, NULL, NULL, NULL, 4),
(61388, NULL, 'G3DSA:3.10.620.30:FF:000021', NULL, NULL, 'Transglutaminase-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(61389, NULL, 'G3DSA:2.20.70.10:FF:000185', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(61390, NULL, 'G3DSA:3.30.710.10:FF:000231', NULL, NULL, 'Inhibitor of Bruton tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(61391, NULL, 'G3DSA:2.170.120.30:FF:000011', NULL, NULL, 'YbbR-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(61392, NULL, 'G3DSA:3.40.50.300:FF:003037', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(61393, NULL, 'G3DSA:1.10.490.160:FF:000004', NULL, NULL, 'Ryanodine receptor, isoform J', NULL, NULL, NULL, NULL, NULL, 4),
(61394, NULL, 'G3DSA:1.20.870.10:FF:000005', NULL, NULL, 'Rap guanine nucleotide exchange factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(61395, NULL, 'G3DSA:3.40.50.2300:FF:000168', NULL, NULL, 'Penicillin-binding protein activator LpoA', NULL, NULL, NULL, NULL, NULL, 4),
(61396, NULL, 'G3DSA:3.40.50.1000:FF:000885', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61397, NULL, 'G3DSA:1.25.10.10:FF:000734', NULL, NULL, 'Ubiquitin ligase e3', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(61398, NULL, 'G3DSA:3.80.10.10:FF:000373', NULL, NULL, 'T-complex-associated testis-expressed protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(61399, NULL, 'G3DSA:3.80.10.10:FF:003716', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61400, NULL, 'G3DSA:2.60.200.20:FF:000108', NULL, NULL, 'FHA domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(61401, NULL, 'G3DSA:3.30.160.60:FF:002783', NULL, NULL, 'Zinc finger and SCAN domain containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(61402, NULL, 'G3DSA:3.30.9.10:FF:000001', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(61403, NULL, 'G3DSA:3.30.420.40:FF:000471', NULL, NULL, 'Glucokinase', NULL, NULL, NULL, NULL, NULL, 4),
(61404, NULL, 'G3DSA:3.30.160.60:FF:003401', NULL, NULL, 'LD15405p', NULL, NULL, NULL, NULL, NULL, 4),
(61405, NULL, 'G3DSA:3.90.190.10:FF:000430', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61406, NULL, 'G3DSA:3.20.110.10:FF:000019', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(61407, NULL, 'G3DSA:3.30.540.10:FF:000089', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(61408, NULL, 'G3DSA:3.90.70.10:FF:000196', NULL, NULL, 'Clan CA, family C1, cathepsin B-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(61409, NULL, 'G3DSA:3.20.20.80:FF:000380', NULL, NULL, 'RE12027p', NULL, NULL, NULL, NULL, NULL, 4),
(61410, NULL, 'G3DSA:3.40.33.10:FF:000062', NULL, NULL, 'Predicted extracellular protein', NULL, NULL, NULL, NULL, NULL, 4),
(61411, NULL, 'G3DSA:3.30.70.1730:FF:000022', NULL, NULL, '50S ribosomal protein L10', NULL, NULL, NULL, NULL, NULL, 4),
(61412, NULL, 'G3DSA:3.30.160.60:FF:000889', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(61413, NULL, 'G3DSA:1.10.287.970:FF:000001', NULL, NULL, 'Aerobic respiration control sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(61414, NULL, 'G3DSA:3.30.70.330:FF:000197', NULL, NULL, 'Scaffold attachment factor B2', NULL, NULL, NULL, NULL, NULL, 4),
(61415, NULL, 'G3DSA:3.30.70.1230:FF:000198', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(61416, NULL, 'G3DSA:3.40.50.720:FF:002516', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61417, NULL, 'G3DSA:3.30.760.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61418, NULL, 'G3DSA:3.40.50.1820:FF:000220', NULL, NULL, '4,5:9,10-diseco-3-hydroxy-5,9,17-trioxoandrosta-1(10),2-diene-4-oate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(61419, NULL, 'G3DSA:1.20.1260.30:FF:000003', NULL, NULL, 'Type I restriction-modification system, M subunit', NULL, NULL, NULL, NULL, NULL, 4),
(61420, NULL, 'G3DSA:3.40.50.300:FF:002076', NULL, NULL, 'Ras-related protein rab-5', NULL, NULL, NULL, NULL, NULL, 4),
(61421, NULL, 'G3DSA:2.130.10.10:FF:005785', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61422, NULL, 'G3DSA:3.40.50.150:FF:000647', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(61423, NULL, 'G3DSA:1.50.40.10:FF:000493', NULL, NULL, 'Mitochondrial carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61424, NULL, 'G3DSA:3.40.50.720:FF:002174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61425, NULL, 'G3DSA:2.60.40.10:FF:000681', NULL, NULL, 'Centrosomal protein of 192 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(61426, NULL, 'G3DSA:3.90.190.10:FF:000227', NULL, NULL, 'Protein tyrosine phosphatase, receptor type E', NULL, NULL, NULL, NULL, NULL, 4),
(61427, NULL, 'G3DSA:2.60.40.10:FF:004368', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61428, NULL, 'G3DSA:3.40.50.150:FF:001266', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61429, NULL, 'G3DSA:1.25.10.10:FF:002842', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61430, NULL, 'G3DSA:1.25.10.10:FF:002657', NULL, NULL, 'HEAT repeatcontaining protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(61431, NULL, 'G3DSA:2.130.10.10:FF:004695', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61432, NULL, 'G3DSA:1.10.287.990:FF:000007', NULL, NULL, 'Superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(61433, NULL, 'G3DSA:3.40.50.920:FF:000007', NULL, NULL, 'Pyruvate:ferredoxin (Flavodoxin) oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(61434, NULL, 'G3DSA:1.10.630.10:FF:000512', NULL, NULL, 'Os01g0700500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(61435, NULL, 'G3DSA:1.10.10.10:FF:000638', NULL, NULL, 'Transcriptional regulator PtsJ', NULL, NULL, NULL, NULL, NULL, 4),
(61436, NULL, 'G3DSA:3.30.2350.20:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61437, NULL, 'G3DSA:3.10.20.10:FF:000045', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(61438, NULL, 'G3DSA:3.60.40.10:FF:000151', NULL, NULL, 'Phosphoserine phosphatase RsbP', NULL, NULL, NULL, NULL, NULL, 4),
(61439, NULL, 'G3DSA:3.50.50.60:FF:000380', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(61440, NULL, 'G3DSA:3.40.640.10:FF:000313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61441, NULL, 'G3DSA:3.30.40.10:FF:000326', NULL, NULL, 'Bassoon presynaptic cytomatrix protein', NULL, NULL, NULL, NULL, NULL, 4),
(61442, NULL, 'G3DSA:3.40.50.360:FF:000014', NULL, NULL, 'NADPH-dependent FMN reductase', NULL, NULL, NULL, NULL, NULL, 4),
(61443, NULL, 'G3DSA:3.20.20.70:FF:000135', NULL, NULL, 'Pentafunctional AROM polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(61444, NULL, 'G3DSA:3.40.470.10:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61445, NULL, 'G3DSA:3.30.530.20:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61446, NULL, 'G3DSA:1.20.120.980:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61447, NULL, 'G3DSA:2.70.40.10:FF:000012', NULL, NULL, 'Deoxyuridine 5''-triphosphate nucleotidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(61448, NULL, 'G3DSA:3.50.50.60:FF:001341', NULL, NULL, 'Mercuric reductase', NULL, NULL, NULL, NULL, NULL, 4),
(61449, NULL, 'G3DSA:2.130.10.10:FF:003312', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(61450, NULL, 'G3DSA:2.30.30.190:FF:000010', NULL, NULL, 'centrosome-associated protein 350 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(61451, NULL, 'G3DSA:3.30.50.10:FF:000141', NULL, NULL, 'AGAP012222-PA', NULL, NULL, NULL, NULL, NULL, 4),
(61452, NULL, 'G3DSA:4.10.60.10:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61453, NULL, 'G3DSA:3.30.160.60:FF:005346', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61454, NULL, 'G3DSA:3.30.60.90:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61455, NULL, 'G3DSA:2.80.10.50:FF:000196', NULL, NULL, 'Inositol 1,4,5-trisphosphate receptor, type 3', NULL, NULL, NULL, NULL, NULL, 4),
(61456, NULL, 'G3DSA:1.20.1250.20:FF:000404', NULL, NULL, 'Monocarboxylate transporter 6-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(61457, NULL, 'G3DSA:2.10.25.10:FF:001345', NULL, NULL, 'Notch receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(61458, NULL, 'G3DSA:2.60.40.10:FF:005133', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61459, NULL, 'G3DSA:3.30.870.10:FF:000063', NULL, NULL, 'Nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(61460, NULL, 'G3DSA:3.30.420.40:FF:001090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61461, NULL, 'G3DSA:1.25.40.10:FF:002827', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(61462, NULL, 'G3DSA:3.30.200.20:FF:001477', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(61463, NULL, 'G3DSA:2.60.200.30:FF:000010', NULL, NULL, 'NAD kinase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(61464, NULL, 'G3DSA:2.120.10.30:FF:000188', NULL, NULL, 'AGAP010610-PA', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(61465, NULL, 'G3DSA:1.25.10.10:FF:001662', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61466, NULL, 'G3DSA:3.30.70.330:FF:000652', NULL, NULL, 'Eukaryotic translation initiation factor 4B', NULL, NULL, NULL, NULL, NULL, 4),
(61467, NULL, 'G3DSA:3.30.450.20:FF:000208', NULL, NULL, 'Periplasmic [Fe] hydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(61468, NULL, 'G3DSA:3.90.25.10:FF:000013', NULL, NULL, 'UDP-glucuronate decarboxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(61469, NULL, 'G3DSA:3.90.70.80:FF:000065', NULL, NULL, 'Cysteine proteinases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(61470, NULL, 'G3DSA:1.25.40.10:FF:005211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61471, NULL, 'G3DSA:1.25.40.10:FF:003103', NULL, NULL, 'AGAP003265-PA', NULL, NULL, NULL, NULL, NULL, 4),
(61472, NULL, 'G3DSA:3.90.830.10:FF:000002', NULL, NULL, 'Vacuolar protein sorting-associated protein 45', NULL, NULL, NULL, NULL, NULL, 4),
(61473, NULL, 'G3DSA:3.30.470.30:FF:000072', NULL, NULL, 'Multifunctional non-homologous end joining protein LigD', NULL, NULL, NULL, NULL, NULL, 4),
(61474, NULL, 'G3DSA:1.20.1070.10:FF:000382', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61475, NULL, 'G3DSA:1.25.40.10:FF:002485', NULL, NULL, 'Os11g0109800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(61476, NULL, 'G3DSA:2.70.150.10:FF:000278', NULL, NULL, 'Putative phospholipid-transporting ATPase C6C3.06c', NULL, NULL, NULL, NULL, NULL, 4),
(61477, NULL, 'G3DSA:3.30.9.10:FF:000130', NULL, NULL, 'Monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61478, NULL, 'G3DSA:3.30.200.20:FF:002191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61479, NULL, 'G3DSA:2.10.110.10:FF:000126', NULL, NULL, 'Chromosome 23, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(61480, NULL, 'G3DSA:3.40.50.300:FF:001328', NULL, NULL, 'Dynein heavy chain 6, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(61481, NULL, 'G3DSA:1.25.40.420:FF:000012', NULL, NULL, 'BTB/POZ and TAZ domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(61482, NULL, 'G3DSA:1.20.58.1030:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61483, NULL, 'G3DSA:2.130.10.10:FF:001367', NULL, NULL, 'Dynein, cytoplasmic 1, intermediate chain 2b', NULL, NULL, NULL, NULL, NULL, 4),
(61484, NULL, 'G3DSA:3.30.420.40:FF:000139', NULL, NULL, 'Chromatin remodeling complex subunit (Arp5)', NULL, NULL, NULL, NULL, NULL, 4),
(61485, NULL, 'G3DSA:3.30.160.60:FF:001075', NULL, NULL, 'Zinc finger, C2H2-type/integrase, DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(61486, NULL, 'G3DSA:2.60.40.10:FF:001619', NULL, NULL, 'Beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(61487, NULL, 'G3DSA:1.25.40.10:FF:003974', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61488, NULL, 'G3DSA:1.20.1250.20:FF:001882', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61489, NULL, 'G3DSA:3.40.50.300:FF:002418', NULL, NULL, 'ABC transporter PMR5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61490, NULL, 'G3DSA:1.10.10.10:FF:000785', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(61491, NULL, 'G3DSA:2.60.120.290:FF:000151', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(61492, NULL, 'G3DSA:2.120.10.80:FF:000287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61493, NULL, 'G3DSA:2.60.40.10:FF:003188', NULL, NULL, 'GM14906', NULL, NULL, NULL, NULL, NULL, 4),
(61494, NULL, 'G3DSA:1.10.1450.10:FF:000082', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(61495, NULL, 'G3DSA:3.40.50.20:FF:000060', NULL, NULL, 'Trifunctional purine biosynthetic protein adenosine-3', NULL, NULL, NULL, NULL, NULL, 4),
(61496, NULL, 'G3DSA:2.60.40.820:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61497, NULL, 'G3DSA:3.30.10.30:FF:000004', NULL, NULL, 'dual specificity tyrosine-phosphorylation-regulated kinase 2', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(61498, NULL, 'G3DSA:1.50.40.10:FF:000021', NULL, NULL, 'SFC1p Mitochondrial succinate-fumarate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(61499, NULL, 'G3DSA:3.40.50.80:FF:000162', NULL, NULL, 'NADH-cytochrome b5 reductase-like', NULL, NULL, NULL, NULL, NULL, 4),
(61500, NULL, 'G3DSA:3.10.110.10:FF:000055', NULL, NULL, 'ubiquitin-conjugating enzyme E2 Q2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(61501, NULL, 'G3DSA:3.30.70.270:FF:000010', NULL, NULL, 'DNA repair protein REV1', NULL, NULL, NULL, NULL, NULL, 4),
(61502, NULL, 'G3DSA:1.20.1530.20:FF:000066', NULL, NULL, 'Cation/H(+) antiporter 7', NULL, NULL, NULL, NULL, NULL, 4),
(61503, NULL, 'G3DSA:1.10.20.70:FF:000005', NULL, NULL, 'Pti1p', NULL, NULL, NULL, NULL, NULL, 4),
(61504, NULL, 'G3DSA:3.80.10.10:FF:002626', NULL, NULL, 'Transmembrane receptors / ATP binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(61505, NULL, 'G3DSA:1.20.900.10:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61506, NULL, 'G3DSA:2.30.40.10:FF:000132', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(61507, NULL, 'G3DSA:3.30.200.20:FF:001786', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(61508, NULL, 'G3DSA:3.40.50.300:FF:006128', NULL, NULL, 'ABC transporter ATP-binding protein RamA', NULL, NULL, NULL, NULL, NULL, 4),
(61509, NULL, 'G3DSA:1.25.40.10:FF:002670', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g15690, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(61510, NULL, 'G3DSA:1.20.1050.10:FF:000274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61511, NULL, 'G3DSA:3.20.20.140:FF:000143', NULL, NULL, 'Ribonuclease P protein subunit p30, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61512, NULL, 'G3DSA:3.30.420.40:FF:000847', NULL, NULL, 'Actin-related protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(61513, NULL, 'G3DSA:2.30.29.110:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61514, NULL, 'G3DSA:3.40.50.2300:FF:001657', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61515, NULL, 'G3DSA:3.40.50.1980:FF:000021', NULL, NULL, 'Iron-uptake system-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(61516, NULL, 'G3DSA:3.30.70.330:FF:000505', NULL, NULL, 'Splicing factor 3B subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(61517, NULL, 'G3DSA:3.30.450.40:FF:000219', NULL, NULL, 'Phytochrome-like protein cph2', NULL, NULL, NULL, NULL, NULL, 4),
(61518, NULL, 'G3DSA:3.40.190.10:FF:000587', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(61519, NULL, 'G3DSA:3.30.70.360:FF:000048', NULL, NULL, 'Amidohydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(61520, NULL, 'G3DSA:1.10.8.270:FF:000091', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(61521, NULL, 'G3DSA:2.10.110.10:FF:000273', NULL, NULL, 'Four and a half LIM domains protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(61522, NULL, 'G3DSA:2.60.120.10:FF:000161', NULL, NULL, 'Acireductone dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(61523, NULL, 'G3DSA:2.40.160.50:FF:000022', NULL, NULL, 'SAM50-like protein gop-3', NULL, NULL, NULL, NULL, NULL, 4),
(61524, NULL, 'G3DSA:3.60.20.10:FF:000149', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(61525, NULL, 'G3DSA:3.60.130.10:FF:000017', NULL, NULL, 'Putative clavaminic acid synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(61526, NULL, 'G3DSA:3.40.50.1820:FF:000434', NULL, NULL, 'Related to FSH3-putative serine hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(61527, NULL, 'G3DSA:1.20.58.60:FF:000100', NULL, NULL, 'spectrin alpha chain, non-erythrocytic 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(61528, NULL, 'G3DSA:2.40.10.10:FF:000219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61529, NULL, 'G3DSA:3.40.50.2000:FF:000145', NULL, NULL, 'Probable glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(61530, NULL, 'G3DSA:3.40.50.1010:FF:000202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(61531, NULL, 'G3DSA:4.10.410.10:FF:000001', NULL, NULL, 'Amyloid beta A4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(61532, NULL, 'G3DSA:2.60.40.10:FF:001642', NULL, NULL, 'Jitterbug, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(61533, NULL, 'G3DSA:3.30.1140.32:FF:000009', NULL, NULL, '30S ribosomal protein S3', NULL, NULL, NULL, NULL, NULL, 4),
(61534, NULL, 'G3DSA:1.20.140.10:FF:000012', NULL, NULL, 'Acyl-CoA dehydrogenase fadE12', NULL, NULL, NULL, NULL, NULL, 4),
(61535, NULL, 'G3DSA:2.160.20.10:FF:000091', NULL, NULL, 'Possible serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(61536, NULL, 'G3DSA:1.20.5.2700:FF:000001', NULL, NULL, 'NADH-quinone oxidoreductase, L subunit', NULL, NULL, NULL, NULL, NULL, 4),
(61537, NULL, 'G3DSA:3.30.930.10:FF:000141', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(61538, NULL, 'G3DSA:3.40.140.10:FF:000185', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(61539, NULL, 'G3DSA:1.10.510.10:FF:002908', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61540, NULL, 'G3DSA:2.40.50.40:FF:000124', NULL, NULL, 'CHD gene family protein containing chromodomain, helicase domain, and DNA-binding domain', NULL, NULL, NULL, NULL, NULL, 4),
(61541, NULL, 'G3DSA:3.40.50.300:FF:001457', NULL, NULL, 'Ras-related protein Rab-5B', NULL, NULL, NULL, NULL, NULL, 4),
(61542, NULL, 'G3DSA:3.50.50.60:FF:001009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61543, NULL, 'G3DSA:3.30.160.60:FF:001294', NULL, NULL, 'Zinc finger protein 770', NULL, NULL, NULL, NULL, NULL, 4),
(61544, NULL, 'G3DSA:2.60.120.40:FF:000046', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(61545, NULL, 'G3DSA:3.40.1000.30:FF:000017', NULL, NULL, 'F-box protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(61546, NULL, 'G3DSA:3.40.50.300:FF:003801', NULL, NULL, 'Ras-related protein RabY', NULL, NULL, NULL, NULL, NULL, 4),
(61547, NULL, 'G3DSA:3.60.10.10:FF:000014', NULL, NULL, 'Type I inositol polyphosphate 5-phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(61548, NULL, 'G3DSA:3.40.50.720:FF:001555', NULL, NULL, 'HesA/MoeB/ThiF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(61549, NULL, 'G3DSA:1.20.5.340:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61550, NULL, 'G3DSA:2.60.200.10:FF:000015', NULL, NULL, 'Interferon regulatory factor 7', NULL, NULL, NULL, NULL, NULL, 4),
(61551, NULL, 'G3DSA:1.25.40.20:FF:000110', NULL, NULL, 'Mindbomb E3 ubiquitin protein ligase 2', NULL, NULL, NULL, NULL, NULL, 4),
(61552, NULL, 'G3DSA:3.80.10.10:FF:003155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61553, NULL, 'G3DSA:2.130.10.10:FF:001058', NULL, NULL, 'Rho guanine nucleotide exchange factor (GEF) 10-like a', NULL, NULL, NULL, NULL, NULL, 4),
(61554, NULL, 'G3DSA:1.20.58.400:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61555, NULL, 'G3DSA:3.40.50.2300:FF:001348', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61556, NULL, 'G3DSA:2.60.120.10:FF:000503', NULL, NULL, 'cAMP/cGMP-dependent 3'',5''-cAMP/cGMP phosphodiesterase B', NULL, NULL, NULL, NULL, NULL, 4),
(61557, NULL, 'G3DSA:1.10.1070.11:FF:000093', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(61558, NULL, 'G3DSA:1.20.120.20:FF:000002', NULL, NULL, 'Apolipoprotein E', NULL, NULL, NULL, NULL, NULL, 4),
(61559, NULL, 'G3DSA:1.25.40.10:FF:002794', NULL, NULL, 'Intraflagellar transport protein 56 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(61560, NULL, 'G3DSA:3.30.1360.120:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61561, NULL, 'G3DSA:1.10.472.10:FF:000583', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(61562, NULL, 'G3DSA:2.40.30.10:FF:000327', NULL, NULL, 'NADPH--cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(61563, NULL, 'G3DSA:1.10.630.10:FF:000057', NULL, NULL, 'Cytochrome P450 724B1', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(61564, NULL, 'G3DSA:3.30.70.860:FF:000001', NULL, NULL, 'UPF0234 protein YajQ', NULL, NULL, NULL, NULL, NULL, 4),
(61565, NULL, 'G3DSA:1.20.5.460:FF:000005', NULL, NULL, 'Formate dehydrogenase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(61566, NULL, 'G3DSA:2.60.40.2380:FF:000002', NULL, NULL, 'Lost Adherence Sensor, LadS', NULL, NULL, NULL, NULL, NULL, 4),
(61567, NULL, 'G3DSA:3.90.1150.10:FF:000128', NULL, NULL, '5-aminolevulinic acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(61568, NULL, 'G3DSA:3.30.830.10:FF:000285', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(61569, NULL, 'G3DSA:3.40.50.80:FF:000015', NULL, NULL, 'NADPH oxidase 4', NULL, NULL, NULL, NULL, NULL, 4),
(61570, NULL, 'G3DSA:2.60.40.420:FF:000119', NULL, NULL, 'Cytochrome c oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(61571, NULL, 'G3DSA:3.60.10.10:FF:000323', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(61572, NULL, 'G3DSA:1.20.1280.290:FF:000023', NULL, NULL, 'Cystinosin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(61573, NULL, 'G3DSA:2.40.10.10:FF:000680', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61574, NULL, 'G3DSA:3.10.310.10:FF:000020', NULL, NULL, 'Phenazine biosynthesis-like domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(61575, NULL, 'G3DSA:3.30.70.1350:FF:000020', NULL, NULL, 'Os03g0346800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(61576, NULL, 'G3DSA:2.130.10.10:FF:000439', NULL, NULL, 'SH3KBP1 binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(61577, NULL, 'G3DSA:3.30.470.20:FF:000007', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(61578, NULL, 'G3DSA:3.10.280.10:FF:000022', NULL, NULL, 'Complement C1q binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(61579, NULL, 'G3DSA:3.40.190.10:FF:000896', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(61580, NULL, 'G3DSA:1.20.1560.10:FF:000357', NULL, NULL, 'p-GlycoProtein related', NULL, NULL, NULL, NULL, NULL, 4),
(61581, NULL, 'G3DSA:2.160.20.10:FF:000124', NULL, NULL, 'SPbeta prophage-derived uncharacterized protein YorA', NULL, NULL, NULL, NULL, NULL, 4),
(61582, NULL, 'G3DSA:1.10.8.270:FF:000068', NULL, NULL, 'Tbc domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(61583, NULL, 'G3DSA:3.40.50.1000:FF:000632', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61584, NULL, 'G3DSA:3.30.160.60:FF:006274', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61585, NULL, 'G3DSA:2.60.40.150:FF:000370', NULL, NULL, 'Unc-13 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(61586, NULL, 'G3DSA:2.60.40.10:FF:005661', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61587, NULL, 'G3DSA:1.10.510.10:FF:002347', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61588, NULL, 'G3DSA:2.30.29.30:FF:000465', NULL, NULL, 'Adaptin ear-binding coat-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(61589, NULL, 'G3DSA:3.40.720.10:FF:000134', NULL, NULL, 'Iduronate-2-sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(61590, NULL, 'G3DSA:2.40.50.40:FF:000091', NULL, NULL, 'C-C motif chemokine', NULL, NULL, NULL, NULL, NULL, 4),
(61591, NULL, 'G3DSA:1.10.8.10:FF:000109', NULL, NULL, 'Ubiquitin-like protein DSK2', NULL, NULL, NULL, NULL, NULL, 4),
(61592, NULL, 'G3DSA:3.40.50.300:FF:006460', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61593, NULL, 'G3DSA:2.70.170.10:FF:000280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61594, NULL, 'G3DSA:3.60.15.10:FF:000204', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(61595, NULL, 'G3DSA:3.90.1150.10:FF:000494', NULL, NULL, 'Putative diaminobutyrate-pyruvate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(61596, NULL, 'G3DSA:1.25.40.10:FF:002338', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(61597, NULL, 'G3DSA:1.25.10.10:FF:002281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(61598, NULL, 'G3DSA:3.20.20.80:FF:000014', NULL, NULL, 'Alpha,alpha-phosphotrehalase', NULL, NULL, NULL, NULL, NULL, 4),
(61599, NULL, 'G3DSA:3.40.50.720:FF:001807', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(61600, NULL, 'G3DSA:3.30.1550.10:FF:000021', NULL, NULL, 'Mitochondrial ribosomal protein L11', NULL, NULL, NULL, NULL, NULL, 4),
(61601, NULL, 'G3DSA:3.40.390.10:FF:000243', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61602, NULL, 'G3DSA:3.30.1680.10:FF:000025', NULL, NULL, 'Sema domain, transmembrane domain (TM), and cytoplasmic domain, (semaphorin) 6D, like', NULL, NULL, NULL, NULL, NULL, 4),
(61603, NULL, 'G3DSA:1.10.472.10:FF:000436', NULL, NULL, 'Cya-1', NULL, NULL, NULL, NULL, NULL, 4),
(61604, NULL, 'G3DSA:1.20.1050.10:FF:000060', NULL, NULL, 'Glutamate-tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61605, NULL, 'G3DSA:2.60.40.10:FF:000990', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(61606, NULL, 'G3DSA:3.40.640.10:FF:000442', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61607, NULL, 'G3DSA:3.30.420.40:FF:000162', NULL, NULL, 'Transcriptional regulator, ROK family', NULL, NULL, NULL, NULL, NULL, 4),
(61608, NULL, 'G3DSA:3.40.50.150:FF:000086', NULL, NULL, 'Demethylmenaquinone methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(61609, NULL, 'G3DSA:1.10.10.60:FF:000086', NULL, NULL, 'transcriptional-regulating factor 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(61610, NULL, 'G3DSA:1.10.510.10:FF:002038', NULL, NULL, 'CK1 family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(61611, NULL, 'G3DSA:3.40.50.720:FF:002207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61612, NULL, 'G3DSA:1.10.287.470:FF:000071', NULL, NULL, 'Multidrug efflux RND transporter periplasmic adaptor subunit MexX', NULL, NULL, NULL, NULL, NULL, 4),
(61613, NULL, 'G3DSA:3.40.50.300:FF:001081', NULL, NULL, 'Spermatogenesis-associated protein 5-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(61614, NULL, 'G3DSA:2.60.40.10:FF:001390', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(61615, NULL, 'G3DSA:1.10.3730.20:FF:000056', NULL, NULL, 'Permease', NULL, NULL, NULL, NULL, NULL, 4),
(61616, NULL, 'G3DSA:3.40.50.300:FF:000940', NULL, NULL, 'Nucleotide-binding oligomerization domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(61617, NULL, 'G3DSA:1.20.90.10:FF:000008', NULL, NULL, 'Phospholipase A(2)', NULL, NULL, NULL, NULL, NULL, 4),
(61618, NULL, 'G3DSA:3.40.50.10190:FF:000201', NULL, NULL, 'DNA ligase 4', NULL, NULL, NULL, NULL, NULL, 4),
(61619, NULL, 'G3DSA:1.10.3430.10:FF:000002', NULL, NULL, 'urea transporter 2', NULL, NULL, NULL, NULL, NULL, 4),
(61620, NULL, 'G3DSA:1.10.510.40:FF:000001', NULL, NULL, 'Aerobactin siderophore biosynthesis protein iucC', NULL, NULL, NULL, NULL, NULL, 4),
(61621, NULL, 'G3DSA:3.20.20.70:FF:000495', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61622, NULL, 'G3DSA:2.60.40.10:FF:002710', NULL, NULL, 'Flagellar-associated_PapD-like/Zeta_toxin_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(61623, NULL, 'G3DSA:4.10.640.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61624, NULL, 'G3DSA:1.10.472.20:FF:000001', NULL, NULL, 'Cobalt-containing nitrile hydratase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(61625, NULL, 'G3DSA:3.40.50.1820:FF:001384', NULL, NULL, 'GPI inositol-deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(61626, NULL, 'G3DSA:1.20.5.340:FF:000087', NULL, NULL, 'Transcriptional repressor tup12', NULL, NULL, NULL, NULL, NULL, 4),
(61627, NULL, 'G3DSA:1.20.50.20:FF:000003', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(61628, NULL, 'G3DSA:2.20.70.10:FF:000050', NULL, NULL, 'pre-mRNA-processing factor 40 homolog B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(61629, NULL, 'G3DSA:3.40.50.720:FF:000493', NULL, NULL, 'Glutathione-dependent formaldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(61630, NULL, 'G3DSA:2.40.10.240:FF:000007', NULL, NULL, 'S-adenosylmethionine:tRNA ribosyltransferase-isomerase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(61631, NULL, 'G3DSA:2.10.25.10:FF:000176', NULL, NULL, 'Selectin P', NULL, NULL, NULL, NULL, NULL, 4),
(61632, NULL, 'G3DSA:1.10.510.10:FF:003752', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61633, NULL, 'G3DSA:3.30.9.10:FF:000113', NULL, NULL, 'FAD/NAD(P)-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(61634, NULL, 'G3DSA:3.30.40.10:FF:001383', NULL, NULL, 'Myotubularin-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(61635, NULL, 'G3DSA:3.30.559.30:FF:000126', NULL, NULL, 'Plipastatin synthase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(61636, NULL, 'G3DSA:1.10.2000.10:FF:000071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61637, NULL, 'G3DSA:1.10.630.10:FF:000052', NULL, NULL, 'Ent-kaurenoic acid oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(61638, NULL, 'G3DSA:3.30.160.70:FF:000004', NULL, NULL, 'Methylated-DNA--protein-cysteine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(61639, NULL, 'G3DSA:2.130.10.10:FF:001053', NULL, NULL, 'Mitochondrial division protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(61640, NULL, 'G3DSA:2.160.20.10:FF:000248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61641, NULL, 'G3DSA:2.40.50.140:FF:000272', NULL, NULL, 'exosome complex component RRP40', NULL, NULL, NULL, NULL, NULL, 4),
(61642, NULL, 'G3DSA:3.40.630.30:FF:000251', NULL, NULL, 'Ss-alanyl conjugating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(61643, NULL, 'G3DSA:3.30.160.60:FF:005902', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61644, NULL, 'G3DSA:2.60.40.10:FF:002598', NULL, NULL, 'Muscle M-line assembly protein unc-89-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(61645, NULL, 'G3DSA:3.40.50.300:FF:005723', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(61646, NULL, 'G3DSA:3.90.550.10:FF:000761', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61647, NULL, 'G3DSA:3.40.640.10:FF:000425', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(61648, NULL, 'G3DSA:3.40.50.2000:FF:001000', NULL, NULL, 'Granule-bound starch synthase 1 chloroplastic/amyloplastic', NULL, NULL, NULL, NULL, NULL, 4),
(61649, NULL, 'G3DSA:2.10.110.10:FF:000351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61650, NULL, 'G3DSA:3.30.1520.10:FF:000109', NULL, NULL, 'Vacuolar protein sorting-associated protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(61651, NULL, 'G3DSA:3.40.50.1910:FF:000011', NULL, NULL, 'SNARE-interacting protein KEULE', NULL, NULL, NULL, NULL, NULL, 4),
(61652, NULL, 'G3DSA:1.10.730.10:FF:000099', NULL, NULL, 'LD44376p', NULL, NULL, NULL, NULL, NULL, 4),
(61653, NULL, 'G3DSA:2.130.10.10:FF:004812', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61654, NULL, 'G3DSA:1.25.40.10:FF:003075', NULL, NULL, 'YALI0B00528p', NULL, NULL, NULL, NULL, NULL, 4),
(61655, NULL, 'G3DSA:3.30.559.10:FF:000120', NULL, NULL, 'Novel protein similar to vertebrate carnitine acetyltransferase (CRAT)', NULL, NULL, NULL, NULL, NULL, 4),
(61656, NULL, 'G3DSA:1.25.40.180:FF:000215', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61657, NULL, 'G3DSA:1.10.1420.10:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61658, NULL, 'G3DSA:1.20.1250.20:FF:000718', NULL, NULL, 'Multidrug MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(61659, NULL, 'G3DSA:2.60.40.10:FF:005453', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61660, NULL, 'G3DSA:2.30.29.30:FF:001297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61661, NULL, 'G3DSA:1.25.10.10:FF:000504', NULL, NULL, 'Splicing factor 3B subunit 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61662, NULL, 'G3DSA:3.90.1640.10:FF:000003', NULL, NULL, 'Prune homolog 2 with BCH domain', NULL, NULL, NULL, NULL, NULL, 4),
(61663, NULL, 'G3DSA:1.50.10.20:FF:000106', NULL, NULL, 'Geranylgeranyl transferase type-2 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(61664, NULL, 'G3DSA:2.60.40.10:FF:004947', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(61665, NULL, 'G3DSA:3.30.70.330:FF:002658', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61666, NULL, 'G3DSA:1.20.1250.20:FF:002282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61667, NULL, 'G3DSA:1.10.8.1070:FF:000003', NULL, NULL, 'Ribulose bisphosphate carboxylase/oxygenase activase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(61668, NULL, 'G3DSA:1.20.1020.10:FF:000002', NULL, NULL, 'E1A binding protein p300', NULL, NULL, NULL, NULL, NULL, 4),
(61669, NULL, 'G3DSA:1.10.533.10:FF:000253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61670, NULL, 'G3DSA:2.60.40.10:FF:001979', NULL, NULL, 'Myosin binding protein C, slow type', NULL, NULL, NULL, NULL, NULL, 4),
(61671, NULL, 'G3DSA:3.10.20.90:FF:000220', NULL, NULL, 'Ubiquitin-like protein DskB', NULL, NULL, NULL, NULL, NULL, 4),
(61672, NULL, 'G3DSA:1.10.150.50:FF:000116', NULL, NULL, 'Endonuclease III homolog', NULL, NULL, NULL, NULL, NULL, 4),
(61673, NULL, 'G3DSA:2.60.210.10:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61674, NULL, 'G3DSA:3.80.10.10:FF:000513', NULL, NULL, 'Leucine-rich repeat receptor protein kinase EMS1', NULL, NULL, NULL, NULL, NULL, 4),
(61675, NULL, 'G3DSA:1.20.1280.160:FF:000001', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(61676, NULL, 'G3DSA:3.10.110.10:FF:000286', NULL, NULL, 'Ubiquitin-conjugating enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61677, NULL, 'G3DSA:1.10.10.10:FF:001381', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(61678, NULL, 'G3DSA:3.30.559.10:FF:000019', NULL, NULL, 'Carnitine acetyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(61679, NULL, 'G3DSA:3.90.470.20:FF:000033', NULL, NULL, 'Biosurfactant biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(61680, NULL, 'G3DSA:1.10.590.10:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61681, NULL, 'G3DSA:2.40.50.360:FF:000006', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(61682, NULL, 'G3DSA:3.30.200.20:FF:002308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61683, NULL, 'G3DSA:1.20.58.60:FF:000780', NULL, NULL, 'Nesprin-1', NULL, NULL, NULL, NULL, NULL, 4),
(61684, NULL, 'G3DSA:3.30.160.60:FF:001619', NULL, NULL, 'zinc finger protein 133 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(61685, NULL, 'G3DSA:2.30.30.30:FF:000070', NULL, NULL, '60S ribosomal protein L6', NULL, NULL, NULL, NULL, NULL, 4),
(61686, NULL, 'G3DSA:3.40.190.10:FF:000901', NULL, NULL, 'Probable sensor/response regulator hybrid', NULL, NULL, NULL, NULL, NULL, 4),
(61687, NULL, 'G3DSA:3.30.420.180:FF:000001', NULL, NULL, 'Cobalamin biosynthesis domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(61688, NULL, 'G3DSA:1.10.287.70:FF:000035', NULL, NULL, 'Potassium voltage-gated channel, subfamily H (Eag-related), member 1', NULL, NULL, NULL, NULL, NULL, 4),
(61689, NULL, 'G3DSA:3.20.20.140:FF:000351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61690, NULL, 'G3DSA:3.30.70.120:FF:000004', NULL, NULL, 'Divalent-cation tolerance protein CutA', NULL, NULL, NULL, NULL, NULL, 4),
(61691, NULL, 'G3DSA:2.40.160.110:FF:000003', NULL, NULL, 'ATPase H+ transporting accessory protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(61692, NULL, 'G3DSA:3.50.50.60:FF:000852', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(61693, NULL, 'G3DSA:3.10.330.20:FF:000024', NULL, NULL, 'tRNA (adenine(58)-N(1))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(61694, NULL, 'G3DSA:2.70.150.10:FF:000065', NULL, NULL, 'HAD ATPase, P-type, family IC', NULL, NULL, NULL, NULL, NULL, 4),
(61695, NULL, 'G3DSA:2.40.180.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61696, NULL, 'G3DSA:3.90.70.10:FF:000853', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61697, NULL, 'G3DSA:3.60.110.10:FF:000010', NULL, NULL, 'Carbon-nitrogen hydrolase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(61698, NULL, 'G3DSA:2.60.40.150:FF:000358', NULL, NULL, 'Rab-11 Family Interacting-Protein', NULL, NULL, NULL, NULL, NULL, 4),
(61699, NULL, 'G3DSA:3.40.630.180:FF:000001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61700, NULL, 'G3DSA:2.20.25.10:FF:000086', NULL, NULL, 'Putative Trm112 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(61701, NULL, 'G3DSA:3.40.50.300:FF:007168', NULL, NULL, 'Small GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61702, NULL, 'G3DSA:1.25.40.10:FF:001630', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g43790', NULL, NULL, NULL, NULL, NULL, 4),
(61703, NULL, 'G3DSA:3.40.640.10:FF:000330', NULL, NULL, 'Aromatic-amino-acid transaminase, hypothetical (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(61704, NULL, 'G3DSA:1.20.120.1200:FF:000019', NULL, NULL, 'NADH-quinone oxidoreductase subunit J', NULL, NULL, NULL, NULL, NULL, 4),
(61705, NULL, 'G3DSA:3.30.450.20:FF:000332', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(61706, NULL, 'G3DSA:2.60.40.640:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61707, NULL, 'G3DSA:3.30.200.20:FF:002522', NULL, NULL, 'SRSF protein kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(61708, NULL, 'G3DSA:2.60.40.10:FF:006072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61709, NULL, 'G3DSA:3.40.50.1110:FF:000002', NULL, NULL, 'isoamyl acetate-hydrolyzing esterase 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(61710, NULL, 'G3DSA:3.30.1330.90:FF:000023', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(61711, NULL, 'G3DSA:1.10.510.10:FF:001414', NULL, NULL, 'Probable inactive receptor-like kinase BSK12', NULL, NULL, NULL, NULL, NULL, 4),
(61712, NULL, 'G3DSA:3.30.420.40:FF:000611', NULL, NULL, 'Chaperone protein dnaK', NULL, NULL, NULL, NULL, NULL, 4),
(61713, NULL, 'G3DSA:2.130.10.10:FF:005105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61714, NULL, 'G3DSA:2.130.10.10:FF:005217', NULL, NULL, 'WD repeat-containing protein 91 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(61715, NULL, 'G3DSA:3.30.160.60:FF:002917', NULL, NULL, 'Zinc finger protein 324', NULL, NULL, NULL, NULL, NULL, 4),
(61716, NULL, 'G3DSA:2.40.340.10:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61717, NULL, 'G3DSA:3.40.50.720:FF:000279', NULL, NULL, '7-alpha-hydroxysteroid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(61718, NULL, 'G3DSA:1.25.10.10:FF:003247', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(61719, NULL, 'G3DSA:3.30.1330.40:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61720, NULL, 'G3DSA:2.10.90.10:FF:000023', NULL, NULL, 'Platelet-derived growth factor subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(61721, NULL, 'G3DSA:2.40.30.10:FF:000338', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61722, NULL, 'G3DSA:2.10.25.10:FF:000968', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61723, NULL, 'G3DSA:3.40.50.720:FF:001802', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61724, NULL, 'G3DSA:4.10.60.10:FF:000073', NULL, NULL, 'Msl5p', NULL, NULL, NULL, NULL, NULL, 4),
(61725, NULL, 'G3DSA:1.20.1070.10:FF:000151', NULL, NULL, 'olfactory receptor 10K1-like', NULL, NULL, NULL, NULL, NULL, 4),
(61726, NULL, 'G3DSA:1.10.287.1060:FF:000018', NULL, NULL, 'Conserved oligomeric Golgi complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(61727, NULL, 'G3DSA:3.40.50.80:FF:000240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61728, NULL, 'G3DSA:3.40.1190.20:FF:000005', NULL, NULL, 'Probable fructokinase-2', NULL, NULL, NULL, NULL, NULL, 4),
(61729, NULL, 'G3DSA:1.10.260.30:FF:000001', NULL, NULL, 'Signal recognition particle protein', NULL, NULL, NULL, NULL, NULL, 4),
(61730, NULL, 'G3DSA:3.30.1370.10:FF:000052', NULL, NULL, 'Kep1, isoform A', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(61731, NULL, 'G3DSA:3.30.70.270:FF:000021', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(61732, NULL, 'G3DSA:3.40.50.620:FF:000137', NULL, NULL, 'Isoleucyl-tRNA synthetase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(61733, NULL, 'G3DSA:2.130.10.10:FF:000434', NULL, NULL, 'Aladin isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(61734, NULL, 'G3DSA:1.20.5.730:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61735, NULL, 'G3DSA:2.60.40.790:FF:000090', NULL, NULL, 'uncharacterized protein CG16817', NULL, NULL, NULL, NULL, NULL, 4),
(61736, NULL, 'G3DSA:3.40.50.300:FF:007640', NULL, NULL, 'Os11g0648500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(61737, NULL, 'G3DSA:1.20.1270.60:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61738, NULL, 'G3DSA:3.30.160.60:FF:004481', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61739, NULL, 'G3DSA:2.30.42.10:FF:000647', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61740, NULL, 'G3DSA:2.60.260.20:FF:000112', NULL, NULL, 'DNAJB1 isoform 10', NULL, NULL, NULL, NULL, NULL, 4),
(61741, NULL, 'G3DSA:3.40.50.11210:FF:000007', NULL, NULL, 'Tuberous sclerosis 2', NULL, NULL, NULL, NULL, NULL, 4),
(61742, NULL, 'G3DSA:1.10.10.60:FF:000423', NULL, NULL, 'Slingshot protein phosphatase 1a', NULL, NULL, NULL, NULL, NULL, 4),
(61743, NULL, 'G3DSA:1.10.150.20:FF:000332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61744, NULL, 'G3DSA:1.25.40.10:FF:001158', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g18840', NULL, NULL, NULL, NULL, NULL, 4),
(61745, NULL, 'G3DSA:2.60.40.10:FF:004508', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61746, NULL, 'G3DSA:3.30.160.60:FF:004593', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61747, NULL, 'G3DSA:3.80.10.10:FF:003470', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(61748, NULL, 'G3DSA:1.20.1250.20:FF:001449', NULL, NULL, 'Transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61749, NULL, 'G3DSA:1.20.120.1920:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61750, NULL, 'G3DSA:1.10.10.60:FF:000878', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61751, NULL, 'G3DSA:1.20.5.170:FF:000025', NULL, NULL, 'nuclear factor interleukin-3-regulated protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(61752, NULL, 'G3DSA:1.20.120.420:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61753, NULL, 'G3DSA:3.20.20.80:FF:000705', NULL, NULL, 'Endoglycoceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(61754, NULL, 'G3DSA:3.40.50.300:FF:001345', NULL, NULL, 'Related to ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(61755, NULL, 'G3DSA:3.30.1490.120:FF:000001', NULL, NULL, 'DNA-directed RNA polymerase II subunit RPB7', NULL, NULL, NULL, NULL, NULL, 4),
(61756, NULL, 'G3DSA:1.10.357.10:FF:000040', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(61757, NULL, 'G3DSA:1.10.510.10:FF:001869', NULL, NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', NULL, NULL, NULL, NULL, NULL, 4),
(61758, NULL, 'G3DSA:3.30.420.10:FF:000164', NULL, NULL, 'DNA-directed DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(61759, NULL, 'G3DSA:1.10.443.10:FF:000015', NULL, NULL, 'Prophage integrase IntF', NULL, NULL, NULL, NULL, NULL, 4),
(61760, NULL, 'G3DSA:1.25.40.10:FF:003979', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61761, NULL, 'G3DSA:1.10.8.80:FF:000001', NULL, NULL, 'Mg-protoporphyrin IX chelatase', NULL, NULL, NULL, NULL, NULL, 4),
(61762, NULL, 'G3DSA:2.30.29.30:FF:001185', NULL, NULL, 'Uncharacterized PH domain-containing protein PB16A4.02c', NULL, NULL, NULL, NULL, NULL, 4),
(61763, NULL, 'G3DSA:3.30.450.40:FF:000208', NULL, NULL, 'PAS sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(61764, NULL, 'G3DSA:1.20.120.1750:FF:000049', NULL, NULL, 'Probable E3 ubiquitin-protein ligase ARI15', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(61765, NULL, 'G3DSA:3.40.190.10:FF:000582', NULL, NULL, 'Nickel ABC transporter, nickel/metallophore periplasmic binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(61766, NULL, 'G3DSA:3.30.60.30:FF:000187', NULL, NULL, 'cDNA FLJ59287, highly similar to Serine protease inhibitor Kazal-type 5', NULL, NULL, NULL, NULL, NULL, 4),
(61767, NULL, 'G3DSA:1.25.40.820:FF:000008', NULL, NULL, 'putative RNA polymerase II subunit B1 CTD phosphatase RPAP2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(61768, NULL, 'G3DSA:3.30.70.20:FF:000123', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61769, NULL, 'G3DSA:2.10.109.10:FF:000073', NULL, NULL, 'Mitochondrial inner membrane protease subunit', NULL, NULL, NULL, NULL, NULL, 4),
(61770, NULL, 'G3DSA:1.25.40.20:FF:001066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61771, NULL, 'G3DSA:1.25.40.10:FF:005003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61772, NULL, 'G3DSA:1.10.1140.10:FF:000013', NULL, NULL, 'ATP synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(61773, NULL, 'G3DSA:1.10.1410.10:FF:000091', NULL, NULL, 'U3 small nucleolar RNA-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(61774, NULL, 'G3DSA:3.40.50.10470:FF:000066', NULL, NULL, 'Initiation factor 2 subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(61775, NULL, 'G3DSA:1.25.40.10:FF:000118', NULL, NULL, 'Lipopolysaccharide assembly protein B', NULL, NULL, NULL, NULL, NULL, 4),
(61776, NULL, 'G3DSA:3.30.70.330:FF:000860', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein A1', NULL, NULL, NULL, NULL, NULL, 4),
(61777, NULL, 'G3DSA:2.70.170.10:FF:000291', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61778, NULL, 'G3DSA:4.10.800.10:FF:000025', NULL, NULL, 'Insulin-like growth factor binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(61779, NULL, 'G3DSA:3.40.50.300:FF:000709', NULL, NULL, 'Iron-sulfur protein NUBPL isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(61780, NULL, 'G3DSA:1.10.238.10:FF:000876', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(61781, NULL, 'G3DSA:1.10.10.10:FF:000762', NULL, NULL, 'RPS19 isoform 5', NULL, NULL, NULL, NULL, NULL, 4),
(61782, NULL, 'G3DSA:1.25.40.10:FF:000332', NULL, NULL, 'Putative tpr repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(61783, NULL, 'G3DSA:1.25.10.10:FF:002758', NULL, NULL, 'Coatomer subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(61784, NULL, 'G3DSA:2.10.70.10:FF:000140', NULL, NULL, 'Sushi domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(61785, NULL, 'G3DSA:3.40.50.300:FF:005370', NULL, NULL, 'Primosomal protein N''', NULL, NULL, NULL, NULL, NULL, 4),
(61786, NULL, 'G3DSA:3.10.450.320:FF:000008', NULL, NULL, 'Mitochondrial import inner membrane translocase subunit TIM21', NULL, NULL, NULL, NULL, NULL, 4),
(61787, NULL, 'G3DSA:3.40.50.620:FF:000007', NULL, NULL, 'Glutamate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(61788, NULL, 'G3DSA:3.40.250.10:FF:000047', NULL, NULL, 'Rhodanese-like domain-containing protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(61789, NULL, 'G3DSA:3.40.50.300:FF:008466', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61790, NULL, 'G3DSA:2.60.40.10:FF:000670', NULL, NULL, 'Myomesin 2', NULL, NULL, NULL, NULL, NULL, 4),
(61791, NULL, 'G3DSA:3.30.40.10:FF:000085', NULL, NULL, 'E3 ubiquitin-protein ligase MIB1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(61792, NULL, 'G3DSA:1.20.140.10:FF:000023', NULL, NULL, 'Acyl-CoA dehydrogenase family member 9', NULL, NULL, NULL, NULL, NULL, 4),
(61793, NULL, 'G3DSA:3.30.450.20:FF:000202', NULL, NULL, 'Voltage-dependent calcium channel unc-36', NULL, NULL, NULL, NULL, NULL, 4),
(61794, NULL, 'G3DSA:1.25.10.10:FF:001561', NULL, NULL, 'Importin beta-like SAD2', NULL, NULL, NULL, NULL, NULL, 4),
(61795, NULL, 'G3DSA:1.20.1070.10:FF:000522', NULL, NULL, 'Muscarinic acetylcholine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(61796, NULL, 'G3DSA:3.40.50.2000:FF:000044', NULL, NULL, 'Sulfoquinovosyl transferase SQD2', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(61797, NULL, 'G3DSA:1.10.418.10:FF:000053', NULL, NULL, 'nesprin-2 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(61798, NULL, 'G3DSA:2.60.110.10:FF:000008', NULL, NULL, 'Osmotin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(61799, NULL, 'G3DSA:1.20.930.40:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61800, NULL, 'G3DSA:3.40.50.410:FF:000181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61801, NULL, 'G3DSA:1.20.58.830:FF:000037', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(61802, NULL, 'G3DSA:1.20.140.100:FF:000029', NULL, NULL, 'Dynein gamma chain, flagellar outer arm', NULL, NULL, NULL, NULL, NULL, 4),
(61803, NULL, 'G3DSA:3.90.215.10:FF:000011', NULL, NULL, 'Intelectin 1', NULL, NULL, NULL, NULL, NULL, 4),
(61804, NULL, 'G3DSA:3.40.50.1820:FF:000439', NULL, NULL, 'Non-ribosomal peptide synthetase OfaC', NULL, NULL, NULL, NULL, NULL, 4),
(61805, NULL, 'G3DSA:3.50.50.60:FF:000964', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61806, NULL, 'G3DSA:3.40.50.2300:FF:000353', NULL, NULL, 'Branched-chain amino acid ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(61807, NULL, 'G3DSA:3.30.70.920:FF:000031', NULL, NULL, 'AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(61808, NULL, 'G3DSA:2.40.160.50:FF:000039', NULL, NULL, 'AGR392Cp', NULL, NULL, NULL, NULL, NULL, 4),
(61809, NULL, 'G3DSA:3.30.160.60:FF:006279', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61810, NULL, 'G3DSA:1.10.238.10:FF:000084', NULL, NULL, 'ralBP1-associated Eps domain-containing protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(61811, NULL, 'G3DSA:1.25.40.10:FF:002586', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g44880', NULL, NULL, NULL, NULL, NULL, 4),
(61812, NULL, 'G3DSA:3.40.50.300:FF:003806', NULL, NULL, 'Ras homolog family member Q', NULL, NULL, NULL, NULL, NULL, 4),
(61813, NULL, 'G3DSA:2.60.120.200:FF:000034', NULL, NULL, 'pikachurin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(61814, NULL, 'G3DSA:3.30.70.330:FF:002203', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61815, NULL, 'G3DSA:3.80.10.10:FF:000968', NULL, NULL, 'Receptor-like protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(61816, NULL, 'G3DSA:2.60.40.10:FF:001187', NULL, NULL, 'immunoglobulin superfamily member 10', NULL, NULL, NULL, NULL, NULL, 4),
(61817, NULL, 'G3DSA:3.40.47.10:FF:000240', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61818, NULL, 'G3DSA:3.30.160.60:FF:001507', NULL, NULL, 'Zinc finger and BTB domain containing 12', NULL, NULL, NULL, NULL, NULL, 4),
(61819, NULL, 'G3DSA:1.10.287.1080:FF:000013', NULL, NULL, 'Nucleotide pyrophosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(61820, NULL, 'G3DSA:2.60.40.10:FF:004964', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61821, NULL, 'G3DSA:3.30.40.10:FF:000747', NULL, NULL, 'Histone deacetylase complex subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61822, NULL, 'G3DSA:2.30.30.100:FF:000034', NULL, NULL, 'sm-like protein LSM7', NULL, NULL, NULL, NULL, NULL, 4),
(61823, NULL, 'G3DSA:3.30.200.20:FF:000482', NULL, NULL, 'probable serine/threonine-protein kinase PBL7', NULL, NULL, NULL, NULL, NULL, 4),
(61824, NULL, 'G3DSA:1.20.120.1080:FF:000051', NULL, NULL, 'ATP-dependent RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61825, NULL, 'G3DSA:3.40.390.10:FF:000119', NULL, NULL, 'Calmodulin-sensitive adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(61826, NULL, 'G3DSA:3.30.200.20:FF:000061', NULL, NULL, 'Dual specificity protein kinase CLK2', NULL, NULL, NULL, NULL, NULL, 4),
(61827, NULL, 'G3DSA:1.25.40.800:FF:000002', NULL, NULL, 'CCR4-Not complex component, Not1', NULL, NULL, NULL, NULL, NULL, 4),
(61828, NULL, 'G3DSA:2.60.40.60:FF:000786', NULL, NULL, 'Cadherin 13, H-cadherin (heart)', NULL, NULL, NULL, NULL, NULL, 4),
(61829, NULL, 'G3DSA:3.40.1380.20:FF:000031', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(61830, NULL, 'G3DSA:3.30.2300.10:FF:000003', NULL, NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(61831, NULL, 'G3DSA:1.25.10.10:FF:001802', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(61832, NULL, 'G3DSA:2.130.10.10:FF:004700', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(61833, NULL, 'G3DSA:3.60.15.10:FF:000087', NULL, NULL, 'MBL fold metallo-hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(61834, NULL, 'G3DSA:1.10.238.180:FF:000002', NULL, NULL, 'Stromal interaction molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(61835, NULL, 'G3DSA:3.30.40.10:FF:001023', NULL, NULL, 'E3 ubiquitin-protein ligase ORTHRUS 2', NULL, NULL, NULL, NULL, NULL, 4),
(61836, NULL, 'G3DSA:1.10.486.10:FF:000053', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(61837, NULL, 'G3DSA:1.25.10.10:FF:002421', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(61838, NULL, 'G3DSA:3.90.45.10:FF:000008', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(61839, NULL, 'G3DSA:1.20.80.10:FF:000053', NULL, NULL, 'Putative acyl-CoA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(61840, NULL, 'G3DSA:3.30.70.2330:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61841, NULL, 'G3DSA:1.10.287.1490:FF:000046', NULL, NULL, 'Similar to GTPase-activating protein GYP5', NULL, NULL, NULL, NULL, NULL, 4),
(61842, NULL, 'G3DSA:3.40.30.10:FF:000179', NULL, NULL, 'NADH-ubiquinone oxidoreductase 10.5 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(61843, NULL, 'G3DSA:3.30.160.60:FF:003295', NULL, NULL, 'Zinc finger protein 337', NULL, NULL, NULL, NULL, NULL, 4),
(61844, NULL, 'G3DSA:3.30.160.60:FF:005009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61845, NULL, 'G3DSA:1.20.1070.10:FF:002079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61846, NULL, 'G3DSA:1.10.1420.10:FF:000046', NULL, NULL, 'DNA mismatch repair protein Msh1', NULL, NULL, NULL, NULL, NULL, 4),
(61847, NULL, 'G3DSA:2.60.120.820:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61848, NULL, 'G3DSA:2.60.40.820:FF:000037', NULL, NULL, 'Putative T-box protein 31', NULL, NULL, NULL, NULL, NULL, 4),
(61849, NULL, 'G3DSA:1.10.510.10:FF:000346', NULL, NULL, 'Serine/threonine-protein kinase NIM1', NULL, NULL, NULL, NULL, NULL, 4),
(61850, NULL, 'G3DSA:2.60.40.1910:FF:000013', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(61851, NULL, 'G3DSA:2.120.10.30:FF:000614', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61852, NULL, 'G3DSA:3.40.50.300:FF:004655', NULL, NULL, 'Methyl coenzyme M reductase system, component A2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(61853, NULL, 'G3DSA:2.160.10.10:FF:000051', NULL, NULL, 'Glucose-1-phosphate adenylyltransferase (ADP-glucose pyrophosphorylase)', NULL, NULL, NULL, NULL, NULL, 4),
(61854, NULL, 'G3DSA:3.30.470.20:FF:000215', NULL, NULL, 'Succinate-CoA ligase, ADP-forming, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(61855, NULL, 'G3DSA:2.40.50.90:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61856, NULL, 'G3DSA:3.40.50.1820:FF:001737', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(61857, NULL, 'G3DSA:1.25.40.10:FF:004143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61858, NULL, 'G3DSA:2.10.25.10:FF:001587', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61859, NULL, 'G3DSA:3.20.200.10:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61860, NULL, 'G3DSA:3.30.160.60:FF:004604', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61861, NULL, 'G3DSA:3.30.40.10:FF:000404', NULL, NULL, 'RING-H2 finger protein ATL72-like', NULL, NULL, NULL, NULL, NULL, 4),
(61862, NULL, 'G3DSA:1.10.238.10:FF:000960', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(61863, NULL, 'G3DSA:3.40.50.300:FF:004751', NULL, NULL, 'Helicase required for RNAi-mediated heterochromatin assembly 1', NULL, NULL, NULL, NULL, NULL, 4),
(61864, NULL, 'G3DSA:3.30.1330.30:FF:000033', NULL, NULL, '40S ribosomal protein S12', NULL, NULL, NULL, NULL, NULL, 4),
(61865, NULL, 'G3DSA:3.90.20.20:FF:000027', NULL, NULL, 'Protein GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(61866, NULL, 'G3DSA:3.40.50.1000:FF:000424', NULL, NULL, 'Trehalose 6-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(61867, NULL, 'G3DSA:1.25.40.530:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61868, NULL, 'G3DSA:1.20.1070.10:FF:001674', NULL, NULL, 'Zgo8', NULL, NULL, NULL, NULL, NULL, 4),
(61869, NULL, 'G3DSA:2.60.120.200:FF:000517', NULL, NULL, 'Mannose-specific lectin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(61870, NULL, 'G3DSA:3.30.1330.10:FF:000038', NULL, NULL, 'Thiamine-monophosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(61871, NULL, 'G3DSA:3.30.40.10:FF:001366', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(61872, NULL, 'G3DSA:3.40.50.10330:FF:000041', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(61873, NULL, 'G3DSA:3.80.10.10:FF:000485', NULL, NULL, 'Protein NSP-INTERACTING KINASE 2', NULL, NULL, NULL, NULL, NULL, 4),
(61874, NULL, 'G3DSA:2.160.20.10:FF:000332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61875, NULL, 'G3DSA:3.40.1000.70:FF:000001', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(61876, NULL, 'G3DSA:1.10.238.10:FF:000988', NULL, NULL, 'Calpain 8', NULL, NULL, NULL, NULL, NULL, 4),
(61877, NULL, 'G3DSA:3.30.70.330:FF:000972', NULL, NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(61878, NULL, 'G3DSA:1.25.40.10:FF:004047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61879, NULL, 'G3DSA:3.10.20.310:FF:000039', NULL, NULL, 'ShlB/FhaC/HecB family hemolysin secretion/activation protein', NULL, NULL, NULL, NULL, NULL, 4),
(61880, NULL, 'G3DSA:3.30.420.270:FF:000039', NULL, NULL, 'Tol-Pal system protein TolR', NULL, NULL, NULL, NULL, NULL, 4),
(61881, NULL, 'G3DSA:2.60.40.10:FF:000782', NULL, NULL, 'Vascular cell adhesion molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(61882, NULL, 'G3DSA:3.40.50.300:FF:008596', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(61883, NULL, 'G3DSA:3.40.50.1820:FF:000327', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(61884, NULL, 'G3DSA:3.90.105.20:FF:000011', NULL, NULL, 'Ribosome assembly factor mrt4', NULL, NULL, NULL, NULL, NULL, 4),
(61885, NULL, 'G3DSA:1.25.40.10:FF:003867', NULL, NULL, 'Tetratricopeptide repeatcontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(61886, NULL, 'G3DSA:1.10.287.130:FF:000115', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(61887, NULL, 'G3DSA:3.30.70.2000:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61888, NULL, 'G3DSA:1.20.1280.50:FF:000089', NULL, NULL, 'F-box and leucine-rich repeat protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(61889, NULL, 'G3DSA:2.120.10.80:FF:000394', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61890, NULL, 'G3DSA:3.40.390.10:FF:000220', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61891, NULL, 'G3DSA:3.30.420.40:FF:000370', NULL, NULL, 'Putative pantothenate kinase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(61892, NULL, 'G3DSA:3.30.565.10:FF:000421', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(61893, NULL, 'G3DSA:3.30.160.60:FF:001850', NULL, NULL, 'Zinc finger protein 467', NULL, NULL, NULL, NULL, NULL, 4),
(61894, NULL, 'G3DSA:1.10.3080.10:FF:000076', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(61895, NULL, 'G3DSA:1.25.40.20:FF:000661', NULL, NULL, 'Protein accellerated cell death 6', NULL, NULL, NULL, NULL, NULL, 4),
(61896, NULL, 'G3DSA:3.80.10.10:FF:003582', NULL, NULL, 'Leucine-rich repeat-containing 8 VRAC subunit C', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(61897, NULL, 'G3DSA:3.30.420.80:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61898, NULL, 'G3DSA:2.40.10.10:FF:000343', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61899, NULL, 'G3DSA:3.40.33.10:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61900, NULL, 'G3DSA:3.30.70.560:FF:000001', NULL, NULL, '2-amino-4-hydroxy-6-hydroxymethyldihydropteridine pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(61901, NULL, 'G3DSA:2.60.40.4100:FF:000007', NULL, NULL, 'oncoprotein-induced transcript 3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(61902, NULL, 'G3DSA:1.25.10.10:FF:000493', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(61903, NULL, 'G3DSA:3.40.30.10:FF:001005', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(61904, NULL, 'G3DSA:3.20.20.150:FF:000028', NULL, NULL, 'Probable AP endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(61905, NULL, 'G3DSA:2.130.10.10:FF:003391', NULL, NULL, 'Semaphorin-5A', NULL, NULL, NULL, NULL, NULL, 4),
(61906, NULL, 'G3DSA:1.25.40.20:FF:000891', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61907, NULL, 'G3DSA:3.40.1110.10:FF:000340', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61908, NULL, 'G3DSA:1.20.1070.10:FF:000281', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(61909, NULL, 'G3DSA:1.20.120.980:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61910, NULL, 'G3DSA:3.40.630.10:FF:000144', NULL, NULL, 'Succinylglutamate desuccinylase', NULL, NULL, NULL, NULL, NULL, 4),
(61911, NULL, 'G3DSA:3.40.50.150:FF:000985', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61912, NULL, 'G3DSA:3.40.309.10:FF:000032', NULL, NULL, 'Probable aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(61913, NULL, 'G3DSA:3.40.50.300:FF:002626', NULL, NULL, 'Adenylate kinase-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(61914, NULL, 'G3DSA:1.50.40.10:FF:000026', NULL, NULL, 'Putative mitochondrial glutamate carrier 2', NULL, NULL, NULL, NULL, NULL, 4),
(61915, NULL, 'G3DSA:3.40.50.720:FF:000830', NULL, NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase, NAD-binding', NULL, NULL, NULL, NULL, NULL, 4),
(61916, NULL, 'G3DSA:3.30.1250.10:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61917, NULL, 'G3DSA:2.60.40.10:FF:003424', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61918, NULL, 'G3DSA:3.80.10.10:FF:004324', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61919, NULL, 'G3DSA:3.30.420.100:FF:000016', NULL, NULL, '50S ribosomal protein L18', NULL, NULL, NULL, NULL, NULL, 4),
(61920, NULL, 'G3DSA:3.90.190.10:FF:000222', NULL, NULL, 'Protein-tyrosine phosphatase 1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(61921, NULL, 'G3DSA:2.40.30.10:FF:000226', NULL, NULL, 'Elongation factor 2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(61922, NULL, 'G3DSA:3.90.226.10:FF:000272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61923, NULL, 'G3DSA:2.70.98.10:FF:000089', NULL, NULL, 'Galactose mutarotase-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(61924, NULL, 'G3DSA:2.60.120.10:FF:000745', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61925, NULL, 'G3DSA:1.10.10.60:FF:000766', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61926, NULL, 'G3DSA:2.30.42.10:FF:000304', NULL, NULL, 'Endopeptidase La', NULL, NULL, NULL, NULL, NULL, 4),
(61927, NULL, 'G3DSA:3.40.50.970:FF:000096', NULL, NULL, 'Pyruvate dehydrogenase E1 alpha 1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(61928, NULL, 'G3DSA:3.40.50.300:FF:002497', NULL, NULL, 'DNA replication protein', NULL, NULL, NULL, NULL, NULL, 4),
(61929, NULL, 'G3DSA:3.50.50.60:FF:000172', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(61930, NULL, 'G3DSA:3.90.79.10:FF:000289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(61931, NULL, 'G3DSA:1.10.10.60:FF:001042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61932, NULL, 'G3DSA:4.10.410.10:FF:000102', NULL, NULL, 'CG42827-PC, CG42827-PD', NULL, NULL, NULL, NULL, NULL, 4),
(61933, NULL, 'G3DSA:1.10.287.110:FF:000452', NULL, NULL, 'Protein CBR-DNJ-9', NULL, NULL, NULL, NULL, NULL, 4),
(61934, NULL, 'G3DSA:3.30.230.10:FF:000104', NULL, NULL, 'ATP-dependent protease La', NULL, NULL, NULL, NULL, NULL, 4),
(61935, NULL, 'G3DSA:3.30.160.60:FF:000782', NULL, NULL, 'Zinc finger protein 33A', NULL, NULL, NULL, NULL, NULL, 4),
(61936, NULL, 'G3DSA:3.40.50.150:FF:000855', NULL, NULL, 'CalS11', NULL, NULL, NULL, NULL, NULL, 4),
(61937, NULL, 'G3DSA:3.40.50.150:FF:001474', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61938, NULL, 'G3DSA:2.30.30.140:FF:000017', NULL, NULL, 'hepatoma-derived growth factor isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(61939, NULL, 'G3DSA:3.90.190.10:FF:000435', NULL, NULL, 'DEP-1a', NULL, NULL, NULL, NULL, NULL, 4),
(61940, NULL, 'G3DSA:3.30.200.20:FF:000605', NULL, NULL, 'Serine/threonine-protein kinase haspin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(61941, NULL, 'G3DSA:3.30.930.10:FF:000017', NULL, NULL, 'Elongation factor P--(R)-beta-lysine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(61942, NULL, 'G3DSA:1.25.40.20:FF:001150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61943, NULL, 'G3DSA:1.10.418.10:FF:000070', NULL, NULL, 'Calmodulin regulated spectrin-associated protein 1b', NULL, NULL, NULL, NULL, NULL, 4),
(61944, NULL, 'G3DSA:2.60.40.10:FF:002682', NULL, NULL, 'Transglutaminase 3, gene 1', NULL, NULL, NULL, NULL, NULL, 4),
(61945, NULL, 'G3DSA:1.25.40.10:FF:001613', NULL, NULL, 'UT01249p', NULL, NULL, NULL, NULL, NULL, 4),
(61946, NULL, 'G3DSA:1.20.5.190:FF:000132', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61947, NULL, 'G3DSA:1.10.510.10:FF:004269', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61948, NULL, 'G3DSA:3.30.1490.100:FF:000006', NULL, NULL, 'DNA polymerase eta', NULL, NULL, NULL, NULL, NULL, 4),
(61949, NULL, 'G3DSA:3.40.50.300:FF:007185', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(61950, NULL, 'G3DSA:3.30.160.60:FF:002676', NULL, NULL, 'Zinc finger protein 426', NULL, NULL, NULL, NULL, NULL, 4),
(61951, NULL, 'G3DSA:1.10.390.30:FF:000004', NULL, NULL, 'Family with sequence similarity 115, member C', NULL, NULL, NULL, NULL, NULL, 4),
(61952, NULL, 'G3DSA:1.10.540.10:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61953, NULL, 'G3DSA:3.40.50.1820:FF:001507', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61954, NULL, 'G3DSA:3.30.750.24:FF:000016', NULL, NULL, 'Anion exchange transporter', NULL, NULL, NULL, NULL, NULL, 4),
(61955, NULL, 'G3DSA:1.20.1070.10:FF:000494', NULL, NULL, 'Methuselah-like 15, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(61956, NULL, 'G3DSA:3.20.110.10:FF:000002', NULL, NULL, 'alpha-mannosidase 2C1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(61957, NULL, 'G3DSA:1.20.58.1480:FF:000022', NULL, NULL, 'Lon protease', NULL, NULL, NULL, NULL, NULL, 4),
(61958, NULL, 'G3DSA:3.30.160.60:FF:005110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61959, NULL, 'G3DSA:1.10.510.10:FF:002807', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61960, NULL, 'G3DSA:3.40.50.300:FF:006549', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61961, NULL, 'G3DSA:3.40.50.2300:FF:000836', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61962, NULL, 'G3DSA:2.130.10.130:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61963, NULL, 'G3DSA:3.30.565.10:FF:000292', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(61964, NULL, 'G3DSA:3.30.870.10:FF:000175', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(61965, NULL, 'G3DSA:3.30.160.60:FF:003424', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(61966, NULL, 'G3DSA:3.30.200.20:FF:000965', NULL, NULL, 'Cell division protein kinase (Ctk1), putative', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(61967, NULL, 'G3DSA:3.40.50.720:FF:001010', NULL, NULL, 'Alanine dehydrogenase, truncation', NULL, NULL, NULL, NULL, NULL, 4),
(61968, NULL, 'G3DSA:1.20.58.1070:FF:000017', NULL, NULL, 'Survival motor neuron interacting protein 1-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(61969, NULL, 'G3DSA:2.40.160.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61970, NULL, 'G3DSA:3.60.20.10:FF:000060', NULL, NULL, 'Related to DUG3-probable glutamine amidotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(61971, NULL, 'G3DSA:3.30.70.270:FF:000246', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61972, NULL, 'G3DSA:3.40.50.10800:FF:000002', NULL, NULL, 'Quinolinate synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(61973, NULL, 'G3DSA:1.20.1250.20:FF:000140', NULL, NULL, 'Putative MFS phospholipid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(61974, NULL, 'G3DSA:2.10.70.80:FF:000003', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(61975, NULL, 'G3DSA:1.10.10.10:FF:001830', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(61976, NULL, 'G3DSA:2.60.40.180:FF:000013', NULL, NULL, '5-hydroxyisourate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(61977, NULL, 'G3DSA:1.10.8.10:FF:000233', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(61978, NULL, 'G3DSA:3.10.110.10:FF:000156', NULL, NULL, 'Putative ubiquitin-conjugating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(61979, NULL, 'G3DSA:1.10.3120.10:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61980, NULL, 'G3DSA:2.130.10.10:FF:002772', NULL, NULL, 'Cleavage and polyadenylation-specific factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(61981, NULL, 'G3DSA:1.10.472.10:FF:000009', NULL, NULL, 'cyclin-T2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(61982, NULL, 'G3DSA:2.60.40.150:FF:000246', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(61983, NULL, 'G3DSA:1.10.486.10:FF:000070', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(61984, NULL, 'G3DSA:1.10.10.10:FF:000324', NULL, NULL, 'LuxR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(61985, NULL, 'G3DSA:2.120.10.80:FF:000264', NULL, NULL, 'Cellular morphogenesis protein (Rax2), putative (AFU_orthologue AFUA_7G05340)', NULL, NULL, NULL, NULL, NULL, 4),
(61986, NULL, 'G3DSA:1.10.510.10:FF:004371', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61987, NULL, 'G3DSA:1.20.1270.60:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61988, NULL, 'G3DSA:2.60.120.290:FF:000252', NULL, NULL, 'Cubilin-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(61989, NULL, 'G3DSA:1.20.1530.20:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61990, NULL, 'G3DSA:1.20.210.10:FF:000017', NULL, NULL, 'Cytochrome c oxidase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(61991, NULL, 'G3DSA:3.90.70.10:FF:000769', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61992, NULL, 'G3DSA:3.40.50.1820:FF:001867', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(61993, NULL, 'G3DSA:3.30.230.70:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61994, NULL, 'G3DSA:3.30.200.20:FF:001241', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', NULL, NULL, NULL, NULL, NULL, 4),
(61995, NULL, 'G3DSA:3.30.160.60:FF:004834', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(61996, NULL, 'G3DSA:3.50.50.100:FF:000035', NULL, NULL, 'Apoptosis-inducing factor-like A', NULL, NULL, NULL, NULL, NULL, 4),
(61997, NULL, 'G3DSA:3.80.10.10:FF:000142', NULL, NULL, 'Ran GTPase activating protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(61998, NULL, 'G3DSA:3.90.70.10:FF:000741', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(61999, NULL, 'G3DSA:3.40.50.12780:FF:000101', NULL, NULL, 'Acetate-CoA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(62000, NULL, 'G3DSA:2.70.150.10:FF:000177', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(62001, NULL, 'G3DSA:1.10.8.50:FF:000003', NULL, NULL, 'Formamidopyrimidine-DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(62002, NULL, 'G3DSA:3.30.70.580:FF:000007', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(62003, NULL, 'G3DSA:3.20.20.70:FF:000040', NULL, NULL, 'Lipoyl synthase', NULL, NULL, NULL, NULL, NULL, 4),
(62004, NULL, 'G3DSA:2.60.120.200:FF:000394', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(62005, NULL, 'G3DSA:3.40.50.10540:FF:000014', NULL, NULL, 'Solute carrier family 45 member 2', NULL, NULL, NULL, NULL, NULL, 4),
(62006, NULL, 'G3DSA:2.30.30.1150:FF:000016', NULL, NULL, 'Histone-lysine N-methyltransferase ATXR6', NULL, NULL, NULL, NULL, NULL, 4),
(62007, NULL, 'G3DSA:3.20.20.80:FF:000256', NULL, NULL, 'Amino acid Transporter GlycoProtein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(62008, NULL, 'G3DSA:1.10.287.10:FF:000045', NULL, NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(62009, NULL, 'G3DSA:1.25.40.10:FF:004486', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62010, NULL, 'G3DSA:1.20.1560.10:FF:000481', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62011, NULL, 'G3DSA:2.80.10.50:FF:000095', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(62012, NULL, 'G3DSA:1.10.510.10:FF:000907', NULL, NULL, 'tyrosine-protein kinase RYK', NULL, NULL, NULL, NULL, NULL, 4),
(62013, NULL, 'G3DSA:1.20.58.340:FF:000087', NULL, NULL, 'Mg2+ transporter protein, CorA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(62014, NULL, 'G3DSA:3.40.366.10:FF:000018', NULL, NULL, 'Fatty acid synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(62015, NULL, 'G3DSA:3.10.100.10:FF:000442', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62016, NULL, 'G3DSA:4.10.1000.10:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62017, NULL, 'G3DSA:3.30.450.20:FF:000091', NULL, NULL, 'Neuronal PAS domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(62018, NULL, 'G3DSA:3.30.420.10:FF:000147', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(62019, NULL, 'G3DSA:3.30.1360.120:FF:000074', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(62020, NULL, 'G3DSA:1.10.472.80:FF:000204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62021, NULL, 'G3DSA:3.30.70.1050:FF:000020', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(62022, NULL, 'G3DSA:3.40.50.620:FF:000581', NULL, NULL, 'Isoleucyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(62023, NULL, 'G3DSA:3.30.470.30:FF:000089', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(62024, NULL, 'G3DSA:3.30.50.10:FF:000124', NULL, NULL, 'Peroxisome proliferator-activated receptor alpha', NULL, NULL, NULL, NULL, NULL, 4),
(62025, NULL, 'G3DSA:3.40.50.300:FF:006100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62026, NULL, 'G3DSA:3.40.50.300:FF:005482', NULL, NULL, 'ATP-dependent DNA helicase tlh2', NULL, NULL, NULL, NULL, NULL, 4),
(62027, NULL, 'G3DSA:3.30.420.40:FF:000583', NULL, NULL, 'Actin', NULL, NULL, NULL, NULL, NULL, 4),
(62028, NULL, 'G3DSA:3.30.40.10:FF:001719', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM56', NULL, NULL, NULL, NULL, NULL, 4),
(62029, NULL, 'G3DSA:3.30.160.60:FF:000338', NULL, NULL, 'zinc finger protein 383', NULL, NULL, NULL, NULL, NULL, 4),
(62030, NULL, 'G3DSA:3.30.360.10:FF:000108', NULL, NULL, 'NADP(+) coupled glycerol dehydrogenase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(62031, NULL, 'G3DSA:2.60.120.200:FF:000164', NULL, NULL, 'Putative L-type lectin-domain containing receptor kinase S.5', NULL, NULL, NULL, NULL, NULL, 4),
(62032, NULL, 'G3DSA:3.30.465.10:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(62033, NULL, 'G3DSA:2.30.29.30:FF:000128', NULL, NULL, 'arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(62034, NULL, 'G3DSA:3.60.15.10:FF:000199', NULL, NULL, 'Metallo-beta-lactamase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(62035, NULL, 'G3DSA:3.10.20.90:FF:000462', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(62036, NULL, 'G3DSA:3.80.10.10:FF:001457', NULL, NULL, 'Os06g0179800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(62037, NULL, 'G3DSA:1.20.1070.10:FF:001702', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62038, NULL, 'G3DSA:3.40.50.720:FF:000734', NULL, NULL, 'Chloroplast envelope quinone oxidoreductase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(62039, NULL, 'G3DSA:1.20.1070.10:FF:001803', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62040, NULL, 'G3DSA:3.20.20.100:FF:000154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62041, NULL, 'G3DSA:3.30.160.60:FF:002468', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(62042, NULL, 'G3DSA:3.30.200.20:FF:002067', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62043, NULL, 'G3DSA:3.90.640.10:FF:000072', NULL, NULL, 'Conserved hypothetical proline rich protein', NULL, NULL, NULL, NULL, NULL, 4),
(62044, NULL, 'G3DSA:1.25.40.10:FF:000669', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g33990', NULL, NULL, NULL, NULL, NULL, 4),
(62045, NULL, 'G3DSA:1.10.150.20:FF:000254', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(62046, NULL, 'G3DSA:3.40.109.10:FF:000051', NULL, NULL, 'Putative NAD(P)H nitroreductase', NULL, NULL, NULL, NULL, NULL, 4),
(62047, NULL, 'G3DSA:3.40.50.300:FF:002289', NULL, NULL, 'DNA or RNA helicase of superfamily II', NULL, NULL, NULL, NULL, NULL, 4),
(62048, NULL, 'G3DSA:1.20.144.10:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62049, NULL, 'G3DSA:3.30.70.20:FF:000140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62050, NULL, 'G3DSA:2.130.10.10:FF:004037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62051, NULL, 'G3DSA:3.90.660.10:FF:000067', NULL, NULL, 'Polyamine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(62052, NULL, 'G3DSA:2.130.10.10:FF:000777', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(62053, NULL, 'G3DSA:3.90.550.10:FF:000418', NULL, NULL, 'ATP synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(62054, NULL, 'G3DSA:1.20.58.1040:FF:000025', NULL, NULL, '1,3-beta-glucanosyltransferase gas2', NULL, NULL, NULL, NULL, NULL, 4),
(62055, NULL, 'G3DSA:3.40.630.30:FF:000493', NULL, NULL, 'Ribosomal-protein-alanine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(62056, NULL, 'G3DSA:2.60.40.150:FF:000807', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62057, NULL, 'G3DSA:2.30.110.10:FF:000032', NULL, NULL, 'PPOX class F420-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(62058, NULL, 'G3DSA:3.40.50.300:FF:000159', NULL, NULL, 'Katanin p60 ATPase-containing subunit A1', NULL, NULL, NULL, NULL, NULL, 4),
(62059, NULL, 'G3DSA:3.30.450.40:FF:000079', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(62060, NULL, 'G3DSA:1.25.40.10:FF:002698', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62061, NULL, 'G3DSA:1.25.40.10:FF:004839', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62062, NULL, 'G3DSA:3.60.40.10:FF:000263', NULL, NULL, 'Protein phosphatase 2C-like domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(62063, NULL, 'G3DSA:1.10.8.60:FF:000332', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(62064, NULL, 'G3DSA:2.30.30.40:FF:000522', NULL, NULL, 'Disks large homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(62065, NULL, 'G3DSA:1.25.40.10:FF:002810', NULL, NULL, 'Os07g0260000 protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(62066, NULL, 'G3DSA:1.10.238.10:FF:000297', NULL, NULL, 'Calcium-binding EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(62067, NULL, 'G3DSA:1.10.45.10:FF:000005', NULL, NULL, 'L-gulono-1,4-lactone dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(62068, NULL, 'G3DSA:1.10.150.110:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62069, NULL, 'G3DSA:3.30.70.270:FF:000038', NULL, NULL, 'Diguanylate cyclase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(62070, NULL, 'G3DSA:3.40.5.10:FF:000003', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(62071, NULL, 'G3DSA:2.40.70.10:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62072, NULL, 'G3DSA:3.10.28.10:FF:000023', NULL, NULL, 'Probable cell division protein WhiA', NULL, NULL, NULL, NULL, NULL, 4),
(62073, NULL, 'G3DSA:2.120.10.30:FF:000390', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62074, NULL, 'G3DSA:3.80.10.10:FF:002413', NULL, NULL, 'CCR4-NOT transcription complex subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(62075, NULL, 'G3DSA:2.40.50.140:FF:000626', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(62076, NULL, 'G3DSA:1.20.5.320:FF:000008', NULL, NULL, '6-phosphogluconate dehydrogenase, decarboxylating', NULL, NULL, NULL, NULL, NULL, 4),
(62077, NULL, 'G3DSA:3.20.20.190:FF:000124', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62078, NULL, 'G3DSA:3.30.342.10:FF:000044', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(62079, NULL, 'G3DSA:3.30.200.20:FF:000853', NULL, NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 185', NULL, NULL, NULL, NULL, NULL, 4),
(62080, NULL, 'G3DSA:1.25.40.10:FF:002799', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g61360', NULL, NULL, NULL, NULL, NULL, 4),
(62081, NULL, 'G3DSA:3.30.40.10:FF:001832', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62082, NULL, 'G3DSA:1.10.220.30:FF:000004', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(62083, NULL, 'G3DSA:2.10.25.10:FF:000631', NULL, NULL, 'Vitamin K-dependent protein S', NULL, NULL, NULL, NULL, NULL, 4),
(62084, NULL, 'G3DSA:3.40.1170.10:FF:000006', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(62085, NULL, 'G3DSA:2.40.33.10:FF:000036', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(62086, NULL, 'G3DSA:3.40.50.300:FF:000491', NULL, NULL, 'E3 ubiquitin-protein ligase RNF213', NULL, NULL, NULL, NULL, NULL, 4),
(62087, NULL, 'G3DSA:2.60.40.10:FF:004385', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62088, NULL, 'G3DSA:1.20.140.150:FF:000016', NULL, NULL, 'Epithelial membrane protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(62089, NULL, 'G3DSA:3.90.70.10:FF:000191', NULL, NULL, 'CYLinDromatosis (Human disease gene) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(62090, NULL, 'G3DSA:1.50.40.10:FF:000369', NULL, NULL, 'Mitochondrial folate carrier protein Flx1', NULL, NULL, NULL, NULL, NULL, 4),
(62091, NULL, 'G3DSA:3.30.505.10:FF:000069', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(62092, NULL, 'G3DSA:3.30.310.80:FF:000042', NULL, NULL, 'CBL-interacting serine/threonine-protein kinase 11', NULL, NULL, NULL, NULL, NULL, 4),
(62093, NULL, 'G3DSA:1.25.40.20:FF:001178', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(62094, NULL, 'G3DSA:1.10.340.30:FF:000052', NULL, NULL, 'A/G specific adenine glycosylase, repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(62095, NULL, 'G3DSA:1.20.120.430:FF:000012', NULL, NULL, 'GTP binding protein 3 (Mitochondrial)', NULL, NULL, NULL, NULL, NULL, 4),
(62096, NULL, 'G3DSA:3.30.1330.60:FF:000031', NULL, NULL, 'Peptidoglycan associated lipoprotein (Omp18)', NULL, NULL, NULL, NULL, NULL, 4),
(62097, NULL, 'G3DSA:1.20.1740.10:FF:000236', NULL, NULL, 'Y+LAT1B, putative', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(62098, NULL, 'G3DSA:3.80.10.10:FF:000272', NULL, NULL, 'Leucine rich repeat containing 49', NULL, NULL, NULL, NULL, NULL, 4),
(62099, NULL, 'G3DSA:1.20.5.300:FF:000002', NULL, NULL, 'Cyclic nucleotide-gated channel alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(62100, NULL, 'G3DSA:3.90.1420.10:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62101, NULL, 'G3DSA:2.60.120.650:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62102, NULL, 'G3DSA:3.30.160.60:FF:005453', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62103, NULL, 'G3DSA:1.25.40.10:FF:003316', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g55740, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(62104, NULL, 'G3DSA:2.170.140.10:FF:000046', NULL, NULL, 'IP16275p', NULL, NULL, NULL, NULL, NULL, 4),
(62105, NULL, 'G3DSA:3.30.420.270:FF:000011', NULL, NULL, 'Biopolymer transport protein ExbD', NULL, NULL, NULL, NULL, NULL, 4),
(62106, NULL, 'G3DSA:1.10.510.10:FF:001526', NULL, NULL, 'BUB1 mitotic checkpoint serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(62107, NULL, 'G3DSA:2.40.50.140:FF:001132', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62108, NULL, 'G3DSA:3.40.50.300:FF:003245', NULL, NULL, 'ORC1-type DNA replication protein', NULL, NULL, NULL, NULL, NULL, 4),
(62109, NULL, 'G3DSA:1.10.238.10:FF:001253', NULL, NULL, 'EF hand', NULL, NULL, NULL, NULL, NULL, 4),
(62110, NULL, 'G3DSA:3.20.20.70:FF:000152', NULL, NULL, 'radical S-adenosyl methionine domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(62111, NULL, 'G3DSA:3.40.50.300:FF:006679', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62112, NULL, 'G3DSA:3.90.320.10:FF:000031', NULL, NULL, 'CRISPR-associated exonuclease Csa1', NULL, NULL, NULL, NULL, NULL, 4),
(62113, NULL, 'G3DSA:3.40.30.10:FF:000151', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(62114, NULL, 'G3DSA:1.20.58.390:FF:000309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62115, NULL, 'G3DSA:3.40.1190.20:FF:000117', NULL, NULL, 'Pyridoxal kinase', NULL, NULL, NULL, NULL, NULL, 4),
(62116, NULL, 'G3DSA:2.30.29.30:FF:000448', NULL, NULL, 'Syntrophin gamma 1', NULL, NULL, NULL, NULL, NULL, 4),
(62117, NULL, 'G3DSA:3.40.630.10:FF:000256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62118, NULL, 'G3DSA:3.30.160.60:FF:003323', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62119, NULL, 'G3DSA:1.25.40.10:FF:003524', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62120, NULL, 'G3DSA:2.60.40.10:FF:000001', NULL, NULL, 'Filamin-C isoform b', NULL, NULL, NULL, NULL, NULL, 4),
(62121, NULL, 'G3DSA:3.90.226.10:FF:000042', NULL, NULL, 'Enoyl-CoA hydratase EchA1', NULL, NULL, NULL, NULL, NULL, 4),
(62122, NULL, 'G3DSA:3.80.10.10:FF:001570', NULL, NULL, 'Type III effector NopM1-1', NULL, NULL, NULL, NULL, NULL, 4),
(62123, NULL, 'G3DSA:3.40.30.10:FF:000729', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62124, NULL, 'G3DSA:3.40.50.150:FF:001715', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62125, NULL, 'G3DSA:3.40.50.300:FF:005274', NULL, NULL, 'Origin recognition complex subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(62126, NULL, 'G3DSA:2.130.10.10:FF:001715', NULL, NULL, 'WD repeat and HMG-box DNA-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(62127, NULL, 'G3DSA:2.40.10.10:FF:000455', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62128, NULL, 'G3DSA:3.40.50.1370:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62129, NULL, 'G3DSA:1.20.1280.290:FF:000040', NULL, NULL, 'PQ loop repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(62130, NULL, 'G3DSA:2.40.290.10:FF:000031', NULL, NULL, 'ATP-dependent DNA helicase 2 subunit KU70', NULL, NULL, NULL, NULL, NULL, 4),
(62131, NULL, 'G3DSA:3.90.190.10:FF:000334', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62132, NULL, 'G3DSA:1.10.600.10:FF:000095', NULL, NULL, 'Farnesyl-diphosphate farnesyltransferase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(62133, NULL, 'G3DSA:3.40.50.720:FF:002067', NULL, NULL, 'YALI0E19789p', NULL, NULL, NULL, NULL, NULL, 4),
(62134, NULL, 'G3DSA:1.25.10.10:FF:003135', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62135, NULL, 'G3DSA:3.90.1530.10:FF:000012', NULL, NULL, 'Sulfiredoxin-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(62136, NULL, 'G3DSA:3.30.1010.10:FF:000014', NULL, NULL, 'Phosphatidylinositol 4-kinase STT4', NULL, NULL, NULL, NULL, NULL, 4),
(62137, NULL, 'G3DSA:3.30.497.10:FF:000015', NULL, NULL, 'Serpin family B member 7', NULL, NULL, NULL, NULL, NULL, 4),
(62138, NULL, 'G3DSA:1.20.58.60:FF:000212', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(62139, NULL, 'G3DSA:2.60.60.20:FF:000005', NULL, NULL, 'Lipoxygenase homology domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(62140, NULL, 'G3DSA:3.40.50.720:FF:002179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62141, NULL, 'G3DSA:1.10.560.10:FF:000057', NULL, NULL, '60 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(62142, NULL, 'G3DSA:1.10.238.10:FF:001152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62143, NULL, 'G3DSA:2.60.40.10:FF:001530', NULL, NULL, 'Wide awake, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(62144, NULL, 'G3DSA:3.90.550.10:FF:000317', NULL, NULL, 'LPS 1,3-galactosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(62145, NULL, 'G3DSA:3.30.1370.120:FF:000019', NULL, NULL, 'Type IV pilus secretin lipoprotein PilQ', NULL, NULL, NULL, NULL, NULL, 4),
(62146, NULL, 'G3DSA:3.30.40.10:FF:000298', NULL, NULL, 'non-structural maintenance of chromosomes element 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(62147, NULL, 'G3DSA:1.25.40.1040:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62148, NULL, 'G3DSA:3.40.47.10:FF:000032', NULL, NULL, 'Peroxisomal 3-ketoacyl-CoA thiolase', NULL, NULL, NULL, NULL, NULL, 4),
(62149, NULL, 'G3DSA:3.40.47.10:FF:000144', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62150, NULL, 'G3DSA:3.90.70.10:FF:000292', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62151, NULL, 'G3DSA:3.40.50.1220:FF:000035', NULL, NULL, 'Electron transfer flavoprotein alpha subunit apoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(62152, NULL, 'G3DSA:2.70.98.10:FF:000072', NULL, NULL, 'YALI0C09570p', NULL, NULL, NULL, NULL, NULL, 4),
(62153, NULL, 'G3DSA:3.30.590.10:FF:000030', NULL, NULL, 'Arginine kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(62154, NULL, 'G3DSA:3.100.10.10:FF:000010', NULL, NULL, '50S ribosomal protein L15', NULL, NULL, NULL, NULL, NULL, 4),
(62155, NULL, 'G3DSA:3.30.160.60:FF:003087', NULL, NULL, 'U-shaped, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(62156, NULL, 'G3DSA:3.40.50.1820:FF:001288', NULL, NULL, 'Putative secreted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62157, NULL, 'G3DSA:3.30.230.130:FF:000044', NULL, NULL, 'Cullin-5', NULL, NULL, NULL, NULL, NULL, 4),
(62158, NULL, 'G3DSA:1.20.1110.10:FF:000110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62159, NULL, 'G3DSA:3.30.70.330:FF:001017', NULL, NULL, 'La protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(62160, NULL, 'G3DSA:1.25.40.180:FF:000119', NULL, NULL, 'Eukaryotic translation initiation factor eif-5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(62161, NULL, 'G3DSA:3.90.1150.210:FF:000025', NULL, NULL, 'F-actin-capping protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(62162, NULL, 'G3DSA:1.20.58.60:FF:000336', NULL, NULL, 'SMAll', NULL, NULL, NULL, NULL, NULL, 4),
(62163, NULL, 'G3DSA:3.30.200.20:FF:002298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62164, NULL, 'G3DSA:1.10.510.10:FF:000554', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62165, NULL, 'G3DSA:3.30.160.20:FF:000113', NULL, NULL, 'Dicer-like 4', NULL, NULL, NULL, NULL, NULL, 4),
(62166, NULL, 'G3DSA:1.25.10.10:FF:001898', NULL, NULL, 'PDS5 cohesin-associated factor A', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(62167, NULL, 'G3DSA:1.10.10.60:FF:000535', NULL, NULL, 'Sigma-54 dependent transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(62168, NULL, 'G3DSA:1.10.110.10:FF:000006', NULL, NULL, '17kDa alpha-amylase/trypsin inhibitor 1', NULL, NULL, NULL, NULL, NULL, 4),
(62169, NULL, 'G3DSA:2.60.40.60:FF:000443', NULL, NULL, 'AGAP003579-PA', NULL, NULL, NULL, NULL, NULL, 4),
(62170, NULL, 'G3DSA:4.10.400.10:FF:000276', NULL, NULL, 'Serine protease nudel', NULL, NULL, NULL, NULL, NULL, 4),
(62171, NULL, 'G3DSA:3.30.160.60:FF:000670', NULL, NULL, 'zinc finger protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(62172, NULL, 'G3DSA:1.10.8.710:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62173, NULL, 'G3DSA:2.130.10.10:FF:000546', NULL, NULL, 'TLE family member 6, subcortical maternal complex member', NULL, NULL, NULL, NULL, NULL, 4),
(62174, NULL, 'G3DSA:1.10.510.10:FF:003314', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62175, NULL, 'G3DSA:3.30.1680.10:FF:000042', NULL, NULL, 'Semaphorin 3G', NULL, NULL, NULL, NULL, NULL, 4),
(62176, NULL, 'G3DSA:3.10.450.50:FF:000070', NULL, NULL, 'mRNA export factor MEX67', NULL, NULL, NULL, NULL, NULL, 4),
(62177, NULL, 'G3DSA:2.10.25.10:FF:001457', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(62178, NULL, 'G3DSA:3.60.40.10:FF:000055', NULL, NULL, 'Adenylate cyclase AcyA', NULL, NULL, NULL, NULL, NULL, 4),
(62179, NULL, 'G3DSA:3.40.50.360:FF:000019', NULL, NULL, 'Nitric oxide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(62180, NULL, 'G3DSA:1.20.1070.10:FF:001466', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62181, NULL, 'G3DSA:2.30.42.10:FF:000535', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62182, NULL, 'G3DSA:1.25.40.10:FF:004255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62183, NULL, 'G3DSA:2.60.40.10:FF:004593', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62184, NULL, 'G3DSA:3.40.50.1970:FF:000001', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(62185, NULL, 'G3DSA:3.40.50.300:FF:004543', NULL, NULL, 'Deoxycytidine monophosphate deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(62186, NULL, 'G3DSA:3.30.950.10:FF:000013', NULL, NULL, 'Bifunctional S-adenosyl-L-methionine-precorrin-2 methyl transferase/precorrin-3 methylase', NULL, NULL, NULL, NULL, NULL, 4),
(62187, NULL, 'G3DSA:1.10.472.10:FF:000661', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62188, NULL, 'G3DSA:3.40.190.10:FF:000340', NULL, NULL, 'Phosphonate ABC transporter, phosphate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(62189, NULL, 'G3DSA:3.40.190.290:FF:000079', NULL, NULL, 'HTH-type transcriptional regulator PtxR', NULL, NULL, NULL, NULL, NULL, 4),
(62190, NULL, 'G3DSA:1.10.150.60:FF:000007', NULL, NULL, 'AT-rich interactive domain-containing protein 3C', NULL, NULL, NULL, NULL, NULL, 4),
(62191, NULL, 'G3DSA:3.40.50.10190:FF:000072', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(62192, NULL, 'G3DSA:3.40.630.30:FF:000594', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62193, NULL, 'G3DSA:1.10.10.980:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62194, NULL, 'G3DSA:1.20.1540.10:FF:000030', NULL, NULL, 'Rhomboid protease ROM6, putative', NULL, NULL, NULL, NULL, NULL, 4),
(62195, NULL, 'G3DSA:3.30.70.330:FF:002546', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62196, NULL, 'G3DSA:2.40.30.20:FF:000004', NULL, NULL, 'Riboflavin synthase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(62197, NULL, 'G3DSA:3.30.160.60:FF:002704', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62198, NULL, 'G3DSA:3.30.70.1730:FF:000027', NULL, NULL, '60S acidic ribosomal protein P0', NULL, NULL, NULL, NULL, NULL, 4),
(62199, NULL, 'G3DSA:3.30.70.330:FF:000180', NULL, NULL, 'Deleted in azoospermia-like', NULL, NULL, NULL, NULL, NULL, 4),
(62200, NULL, 'G3DSA:1.20.1050.10:FF:000167', NULL, NULL, 'Gtt11p', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(62201, NULL, 'G3DSA:3.30.559.10:FF:000249', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62202, NULL, 'G3DSA:1.10.287.70:FF:000147', NULL, NULL, 'Potassium channel, putative', NULL, NULL, NULL, NULL, NULL, 4),
(62203, NULL, 'G3DSA:3.40.50.150:FF:000193', NULL, NULL, 'tRNA (guanine(37)-N1)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(62204, NULL, 'G3DSA:3.10.20.90:FF:000563', NULL, NULL, 'UV excision repair protein RAD23 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(62205, NULL, 'G3DSA:1.10.287.130:FF:000227', NULL, NULL, 'Two-component sensor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(62206, NULL, 'G3DSA:3.90.79.10:FF:000160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62207, NULL, 'G3DSA:1.10.1520.10:FF:000082', NULL, NULL, 'Dicer-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(62208, NULL, 'G3DSA:3.30.160.60:FF:005341', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62209, NULL, 'G3DSA:1.10.150.40:FF:000001', NULL, NULL, 'Barrier-to-autointegration factor B', NULL, NULL, NULL, NULL, NULL, 4),
(62210, NULL, 'G3DSA:3.40.50.300:FF:007977', NULL, NULL, 'Peroxisomal ATPase pex1', NULL, NULL, NULL, NULL, NULL, 4),
(62211, NULL, 'G3DSA:3.90.870.10:FF:000004', NULL, NULL, 'Threonylcarbamoyl-AMP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(62212, NULL, 'G3DSA:1.10.10.1870:FF:000001', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(62213, NULL, 'G3DSA:1.20.1250.20:FF:000157', NULL, NULL, 'Inorganic phosphate cotransporter', NULL, NULL, NULL, NULL, NULL, 4),
(62214, NULL, 'G3DSA:2.40.50.100:FF:000075', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(62215, NULL, 'G3DSA:2.130.10.10:FF:002334', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62216, NULL, 'G3DSA:2.130.10.10:FF:005768', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62217, NULL, 'G3DSA:3.30.1140.32:FF:000004', NULL, NULL, '40S ribosomal protein S3', NULL, NULL, NULL, NULL, NULL, 4),
(62218, NULL, 'G3DSA:1.20.120.1900:FF:000033', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(62219, NULL, 'G3DSA:1.20.120.230:FF:000059', NULL, NULL, 'Probable vinculin', NULL, NULL, NULL, NULL, NULL, 4),
(62220, NULL, 'G3DSA:2.170.270.10:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62221, NULL, 'G3DSA:2.130.10.10:FF:002800', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(62222, NULL, 'G3DSA:3.30.450.20:FF:000444', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(62223, NULL, 'G3DSA:2.60.40.2610:FF:000004', NULL, NULL, 'Putative fimbrial outer membrane usher', NULL, NULL, NULL, NULL, NULL, 4),
(62224, NULL, 'G3DSA:1.20.58.1120:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62225, NULL, 'G3DSA:3.20.20.80:FF:000144', NULL, NULL, 'Chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(62226, NULL, 'G3DSA:2.30.30.140:FF:000225', NULL, NULL, 'YALI0B03960p', NULL, NULL, NULL, NULL, NULL, 4),
(62227, NULL, 'G3DSA:3.30.1240.10:FF:000048', NULL, NULL, 'Phosphatase YwpJ', NULL, NULL, NULL, NULL, NULL, 4),
(62228, NULL, 'G3DSA:2.60.40.1170:FF:000066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62229, NULL, 'G3DSA:1.20.1250.20:FF:002051', NULL, NULL, 'Sugar transporter ERD6-like 9', NULL, NULL, NULL, NULL, NULL, 4),
(62230, NULL, 'G3DSA:3.40.50.2300:FF:000483', NULL, NULL, 'Chemotaxis protein CheY', NULL, NULL, NULL, NULL, NULL, 4),
(62231, NULL, 'G3DSA:3.40.50.720:FF:001459', NULL, NULL, 'Dehydrogenase/reductase SDR family protein 7-like', NULL, NULL, NULL, NULL, NULL, 4),
(62232, NULL, 'G3DSA:2.60.40.10:FF:004716', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62233, NULL, 'G3DSA:1.20.5.1200:FF:000006', NULL, NULL, 'Alpha tocopherol transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(62234, NULL, 'G3DSA:3.40.50.2300:FF:001101', NULL, NULL, 'Metabotropic glutamate receptor 8', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(62235, NULL, 'G3DSA:3.10.450.10:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62236, NULL, 'G3DSA:1.10.3380.20:FF:000006', NULL, NULL, 'helicase POLQ-like', NULL, NULL, NULL, NULL, NULL, 4),
(62237, NULL, 'G3DSA:3.30.160.60:FF:004149', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62238, NULL, 'G3DSA:3.60.15.10:FF:000093', NULL, NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(62239, NULL, 'G3DSA:3.40.50.1820:FF:001496', NULL, NULL, 'Zgc:174932 protein', NULL, NULL, NULL, NULL, NULL, 4),
(62240, NULL, 'G3DSA:3.20.20.100:FF:000030', NULL, NULL, 'Aldo-keto reductase family 1 member E2', NULL, NULL, NULL, NULL, NULL, 4),
(62241, NULL, 'G3DSA:3.30.70.1450:FF:000033', NULL, NULL, 'Trk system potassium uptake protein trkA', NULL, NULL, NULL, NULL, NULL, 4),
(62242, NULL, 'G3DSA:1.10.3720.10:FF:000221', NULL, NULL, 'ABC transporter permease fused to pyrimidine biosynthesis enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(62243, NULL, 'G3DSA:3.40.30.10:FF:000960', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62244, NULL, 'G3DSA:3.80.10.10:FF:003368', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62245, NULL, 'G3DSA:1.10.1370.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62246, NULL, 'G3DSA:3.40.50.10190:FF:000313', NULL, NULL, 'Nibrin', NULL, NULL, NULL, NULL, NULL, 4),
(62247, NULL, 'G3DSA:1.20.120.350:FF:000078', NULL, NULL, 'Cation channel sperm associated 1', NULL, NULL, NULL, NULL, NULL, 4),
(62248, NULL, 'G3DSA:3.90.550.50:FF:000059', NULL, NULL, 'Glycoprotein-N-acetylgalactosamine 3-beta-galactosyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(62249, NULL, 'G3DSA:1.10.287.70:FF:000248', NULL, NULL, 'KCNK3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(62250, NULL, 'G3DSA:3.40.50.720:FF:000622', NULL, NULL, 'D-beta-hydroxybutyrate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(62251, NULL, 'G3DSA:2.130.10.30:FF:000075', NULL, NULL, 'SCF-associated factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(62252, NULL, 'G3DSA:3.30.70.330:FF:001826', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62253, NULL, 'G3DSA:2.130.10.10:FF:000889', NULL, NULL, 'CPSF (Cleavage and polyadenylation specific factor)', NULL, NULL, NULL, NULL, NULL, 4),
(62254, NULL, 'G3DSA:3.40.50.2000:FF:001112', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(62255, NULL, 'G3DSA:1.10.630.10:FF:000164', NULL, NULL, 'Cytochrome P450 71A1 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(62256, NULL, 'G3DSA:1.20.120.160:FF:000009', NULL, NULL, 'Hpt sensor hybrid histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(62257, NULL, 'G3DSA:1.50.10.20:FF:000078', NULL, NULL, 'Geranylgeranyl transferase type II beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(62258, NULL, 'G3DSA:3.30.420.40:FF:000954', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(62259, NULL, 'G3DSA:1.10.555.10:FF:000202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62260, NULL, 'G3DSA:3.40.50.2000:FF:000836', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62261, NULL, 'G3DSA:1.10.1050.10:FF:000006', NULL, NULL, '30S ribosomal protein S4', NULL, NULL, NULL, NULL, NULL, 4),
(62262, NULL, 'G3DSA:1.10.472.10:FF:000453', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62263, NULL, 'G3DSA:3.30.70.330:FF:002445', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62264, NULL, 'G3DSA:2.130.10.10:FF:004588', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62265, NULL, 'G3DSA:1.20.58.60:FF:000128', NULL, NULL, 'Dystrophin related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(62266, NULL, 'G3DSA:1.10.1370.30:FF:000036', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(62267, NULL, 'G3DSA:2.60.40.2300:FF:000012', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(62268, NULL, 'G3DSA:3.40.250.10:FF:000053', NULL, NULL, 'Rhodanese like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(62269, NULL, 'G3DSA:1.25.40.180:FF:000327', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62270, NULL, 'G3DSA:3.90.1200.10:FF:000032', NULL, NULL, 'Probable ethanolamine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(62271, NULL, 'G3DSA:1.20.1050.10:FF:000043', NULL, NULL, 'Failed axon connections, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(62272, NULL, 'G3DSA:3.40.850.10:FF:000155', NULL, NULL, 'Chitin synthase 8', NULL, NULL, NULL, NULL, NULL, 4),
(62273, NULL, 'G3DSA:3.90.1290.10:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62274, NULL, 'G3DSA:2.60.40.1390:FF:000008', NULL, NULL, 'Myelin regulatory factor', NULL, NULL, NULL, NULL, NULL, 4),
(62275, NULL, 'G3DSA:3.40.50.2300:FF:000724', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62276, NULL, 'G3DSA:3.40.1190.20:FF:000218', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62277, NULL, 'G3DSA:3.40.50.150:FF:001362', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62278, NULL, 'G3DSA:3.30.160.390:FF:000004', NULL, NULL, 'Site-specific recombinase, phage integrase family', NULL, NULL, NULL, NULL, NULL, 4),
(62279, NULL, 'G3DSA:1.20.5.170:FF:000255', NULL, NULL, 'AFL160Cp', NULL, NULL, NULL, NULL, NULL, 4),
(62280, NULL, 'G3DSA:1.20.1250.20:FF:002186', NULL, NULL, 'Inositol transporter 4', NULL, NULL, NULL, NULL, NULL, 4),
(62281, NULL, 'G3DSA:2.60.40.60:FF:000544', NULL, NULL, 'Cadherin 16, KSP-cadherin', NULL, NULL, NULL, NULL, NULL, 4),
(62282, NULL, 'G3DSA:1.10.510.10:FF:004483', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62283, NULL, 'G3DSA:2.40.70.10:FF:000329', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62284, NULL, 'G3DSA:3.50.50.60:FF:001369', NULL, NULL, 'AER292Cp', NULL, NULL, NULL, NULL, NULL, 4),
(62285, NULL, 'G3DSA:3.40.50.2300:FF:001000', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62286, NULL, 'G3DSA:3.80.10.10:FF:002519', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62287, NULL, 'G3DSA:1.10.238.10:FF:000533', NULL, NULL, 'Centrin', NULL, NULL, NULL, NULL, NULL, 4),
(62288, NULL, 'G3DSA:2.60.40.10:FF:000102', NULL, NULL, 'filamin-B isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(62289, NULL, 'G3DSA:3.50.7.10:FF:000064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62290, NULL, 'G3DSA:3.40.1280.10:FF:000110', NULL, NULL, 'tRNA (pseudouridine(54)-N(1))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(62291, NULL, 'G3DSA:1.10.10.10:FF:000892', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(62292, NULL, 'G3DSA:2.30.29.30:FF:000780', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62293, NULL, 'G3DSA:1.20.1070.10:FF:000730', NULL, NULL, 'Adhesion G protein-coupled receptor G3', NULL, NULL, NULL, NULL, NULL, 4),
(62294, NULL, 'G3DSA:3.90.810.10:FF:000017', NULL, NULL, 'Wiskott-Aldrich syndrome (eczema-thrombocytopenia) b', NULL, NULL, NULL, NULL, NULL, 4),
(62295, NULL, 'G3DSA:3.30.200.110:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62296, NULL, 'G3DSA:2.60.40.1180:FF:000182', NULL, NULL, 'Alpha-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(62297, NULL, 'G3DSA:3.20.20.120:FF:000036', NULL, NULL, 'L-amino acid-D/L-Glu epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(62298, NULL, 'G3DSA:3.40.50.720:FF:001791', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(62299, NULL, 'G3DSA:1.25.40.20:FF:000447', NULL, NULL, 'synphilin-1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(62300, NULL, 'G3DSA:1.10.10.1120:FF:000001', NULL, NULL, 'Lysin B', NULL, NULL, NULL, NULL, NULL, 4),
(62301, NULL, 'G3DSA:3.40.50.720:FF:000381', NULL, NULL, 'Probable polyketide synthase pks17', NULL, NULL, NULL, NULL, NULL, 4),
(62302, NULL, 'G3DSA:2.40.70.10:FF:000009', NULL, NULL, 'Aspartic proteinase A1', NULL, NULL, NULL, NULL, NULL, 4),
(62303, NULL, 'G3DSA:3.80.10.10:FF:004088', NULL, NULL, 'Tubulin-specific chaperone E', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(62304, NULL, 'G3DSA:2.60.120.260:FF:000384', NULL, NULL, 'Beta-galactosidase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(62305, NULL, 'G3DSA:1.10.472.170:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62306, NULL, 'G3DSA:3.15.10.20:FF:000003', NULL, NULL, 'Activator of Hsp90 ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(62307, NULL, 'G3DSA:2.10.50.10:FF:000032', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(62308, NULL, 'G3DSA:1.20.1250.20:FF:000056', NULL, NULL, 'Enterobactin exporter EntS', NULL, NULL, NULL, NULL, NULL, 4),
(62309, NULL, 'G3DSA:3.80.10.10:FF:003823', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62310, NULL, 'G3DSA:1.10.150.530:FF:000016', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase N', NULL, NULL, NULL, NULL, NULL, 4),
(62311, NULL, 'G3DSA:3.40.50.300:FF:002525', NULL, NULL, 'mRNA cleavage and polyadenylation factor CLP1', NULL, NULL, NULL, NULL, NULL, 4),
(62312, NULL, 'G3DSA:3.30.70.330:FF:000730', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(62313, NULL, 'G3DSA:2.30.40.10:FF:000036', NULL, NULL, 'Probable N-acetylglucosamine-6-phosphate deacetylase nagA', NULL, NULL, NULL, NULL, NULL, 4),
(62314, NULL, 'G3DSA:2.60.40.1730:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62315, NULL, 'G3DSA:3.40.190.10:FF:000008', NULL, NULL, 'ATP phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(62316, NULL, 'G3DSA:3.30.559.70:FF:000008', NULL, NULL, 'carnitine O-palmitoyltransferase 1, brain isoform', NULL, NULL, NULL, NULL, NULL, 4),
(62317, NULL, 'G3DSA:1.25.40.20:FF:001167', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(62318, NULL, 'G3DSA:1.25.40.20:FF:000902', NULL, NULL, 'Predicted ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(62319, NULL, 'G3DSA:3.40.1110.10:FF:000109', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(62320, NULL, 'G3DSA:1.10.12.10:FF:000031', NULL, NULL, 'Putative enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(62321, NULL, 'G3DSA:3.40.50.10810:FF:000090', NULL, NULL, 'Similarity to HELICASE MOT1', NULL, NULL, NULL, NULL, NULL, 4),
(62322, NULL, 'G3DSA:1.20.1250.20:FF:001337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62323, NULL, 'G3DSA:1.20.5.110:FF:000035', NULL, NULL, 'Syntaxin-22 like', NULL, NULL, NULL, NULL, NULL, 4),
(62324, NULL, 'G3DSA:1.25.10.10:FF:000717', NULL, NULL, 'Ycg1p', NULL, NULL, NULL, NULL, NULL, 4),
(62325, NULL, 'G3DSA:1.10.460.10:FF:000004', NULL, NULL, 'DNA topoisomerase 3', NULL, NULL, NULL, NULL, NULL, 4),
(62326, NULL, 'G3DSA:3.40.50.300:FF:002868', NULL, NULL, 'Eukaryotic translation elongation factor 1 alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(62327, NULL, 'G3DSA:2.130.10.10:FF:004245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62328, NULL, 'G3DSA:3.40.50.1820:FF:000670', NULL, NULL, 'Lipase', NULL, NULL, NULL, NULL, NULL, 4),
(62329, NULL, 'G3DSA:3.30.160.60:FF:001951', NULL, NULL, 'Stp4p', NULL, NULL, NULL, NULL, NULL, 4),
(62330, NULL, 'G3DSA:1.25.50.20:FF:000032', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(62331, NULL, 'G3DSA:3.30.200.20:FF:002410', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62332, NULL, 'G3DSA:1.10.510.10:FF:003544', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62333, NULL, 'G3DSA:6.10.140.2220:FF:000012', NULL, NULL, 'zinc finger MYND domain-containing protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(62334, NULL, 'G3DSA:3.40.50.1110:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62335, NULL, 'G3DSA:2.80.10.50:FF:000201', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62336, NULL, 'G3DSA:1.25.10.10:FF:001117', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(62337, NULL, 'G3DSA:1.20.120.1240:FF:000003', NULL, NULL, 'Dynamin-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(62338, NULL, 'G3DSA:3.30.70.1390:FF:000004', NULL, NULL, 'Leucine-rich repeat kinase, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(62339, NULL, 'G3DSA:2.60.120.650:FF:000051', NULL, NULL, 'JmjC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(62340, NULL, 'G3DSA:3.30.565.10:FF:000393', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(62341, NULL, 'G3DSA:2.60.40.10:FF:003536', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62342, NULL, 'G3DSA:2.160.20.10:FF:000220', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62343, NULL, 'G3DSA:3.90.740.10:FF:000023', NULL, NULL, 'Isoleucine--tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(62344, NULL, 'G3DSA:1.20.1310.10:FF:000221', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62345, NULL, 'G3DSA:3.30.450.190:FF:000015', NULL, NULL, 'GTP-binding protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(62346, NULL, 'G3DSA:2.60.40.1940:FF:000005', NULL, NULL, 'Thioester-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(62347, NULL, 'G3DSA:2.10.50.30:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62348, NULL, 'G3DSA:2.60.40.10:FF:002255', NULL, NULL, 'Izumo sperm-egg fusion 1', NULL, NULL, NULL, NULL, NULL, 4),
(62349, NULL, 'G3DSA:3.50.4.10:FF:000041', NULL, NULL, 'Glycosyltransferase family 31 protein', NULL, NULL, NULL, NULL, NULL, 4),
(62350, NULL, 'G3DSA:2.30.30.40:FF:000191', NULL, NULL, 'E3 ubiquitin-protein ligase SH3RF2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(62351, NULL, 'G3DSA:2.70.20.10:FF:000027', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(62352, NULL, 'G3DSA:3.30.160.60:FF:001058', NULL, NULL, 'zinc finger and BTB domain-containing protein 38', NULL, NULL, NULL, NULL, NULL, 4),
(62353, NULL, 'G3DSA:3.30.160.60:FF:000439', NULL, NULL, 'Zinc finger RNA-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(62354, NULL, 'G3DSA:3.40.50.720:FF:000942', NULL, NULL, 'Phosphoglycerate dehydrogenase-like enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(62355, NULL, 'G3DSA:2.130.10.10:FF:005998', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62356, NULL, 'G3DSA:3.30.420.40:FF:000499', NULL, NULL, 'Fumble family protein', NULL, NULL, NULL, NULL, NULL, 4),
(62357, NULL, 'G3DSA:3.90.1150.10:FF:000258', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(62358, NULL, 'G3DSA:1.20.5.420:FF:000021', NULL, NULL, 'Vta1 like, putative', NULL, NULL, NULL, NULL, NULL, 4),
(62359, NULL, 'G3DSA:1.10.510.10:FF:001173', NULL, NULL, 'Mitogen-activated protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(62360, NULL, 'G3DSA:2.30.30.40:FF:000314', NULL, NULL, 'Unplaced genomic scaffold supercont1.257, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(62361, NULL, 'G3DSA:3.30.450.60:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62362, NULL, 'G3DSA:1.25.40.20:FF:001728', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62363, NULL, 'G3DSA:3.80.10.10:FF:002851', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62364, NULL, 'G3DSA:3.50.50.60:FF:000739', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62365, NULL, 'G3DSA:3.40.50.720:FF:000049', NULL, NULL, 'Alanine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(62366, NULL, 'G3DSA:2.10.110.10:FF:000143', NULL, NULL, 'Protein CBG21573', NULL, NULL, NULL, NULL, NULL, 4),
(62367, NULL, 'G3DSA:2.150.10.10:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62368, NULL, 'G3DSA:3.90.120.10:FF:000032', NULL, NULL, 'DNA (cytosine-5)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(62369, NULL, 'G3DSA:1.10.510.10:FF:000897', NULL, NULL, 'AGC protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(62370, NULL, 'G3DSA:1.10.510.10:FF:002583', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62371, NULL, 'G3DSA:1.10.220.150:FF:000071', NULL, NULL, 'ArfGAP with RhoGAP domain, ankyrin repeat and PH domain 1', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(62372, NULL, 'G3DSA:2.60.40.60:FF:000100', NULL, NULL, 'protocadherin Fat 2', NULL, NULL, NULL, NULL, NULL, 4),
(62373, NULL, 'G3DSA:3.10.450.350:FF:000006', NULL, NULL, 'Peptidase M23', NULL, NULL, NULL, NULL, NULL, 4),
(62374, NULL, 'G3DSA:3.30.160.60:FF:006178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62375, NULL, 'G3DSA:2.60.120.1030:FF:000007', NULL, NULL, 'Protein CLP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(62376, NULL, 'G3DSA:1.10.472.10:FF:000223', NULL, NULL, 'BRF2, RNA polymerase III transcription initiation factor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(62377, NULL, 'G3DSA:3.40.30.10:FF:000628', NULL, NULL, 'Glutaredoxin-like protein C5orf63 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(62378, NULL, 'G3DSA:3.30.160.60:FF:000990', NULL, NULL, 'zinc finger protein 629 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(62379, NULL, 'G3DSA:2.60.40.2030:FF:000009', NULL, NULL, 'adhesion G-protein coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(62380, NULL, 'G3DSA:3.90.180.10:FF:000053', NULL, NULL, 'Chloroplast envelope quinone oxidoreductase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(62381, NULL, 'G3DSA:3.30.379.10:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62382, NULL, 'G3DSA:2.40.110.10:FF:000007', NULL, NULL, 'Medium-chain specific acyl-CoA dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(62383, NULL, 'G3DSA:3.30.160.60:FF:000097', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(62384, NULL, 'G3DSA:3.40.50.300:FF:004863', NULL, NULL, 'MutS family protein', NULL, NULL, NULL, NULL, NULL, 4),
(62385, NULL, 'G3DSA:1.20.1270.240:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62386, NULL, 'G3DSA:2.120.10.30:FF:000502', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62387, NULL, 'G3DSA:2.60.40.10:FF:003879', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62388, NULL, 'G3DSA:1.10.565.10:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62389, NULL, 'G3DSA:2.60.120.200:FF:000405', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(62390, NULL, 'G3DSA:3.40.50.10240:FF:000014', NULL, NULL, 'AGAP002968-PA', NULL, NULL, NULL, NULL, NULL, 4),
(62391, NULL, 'G3DSA:2.40.50.730:FF:000022', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(62392, NULL, 'G3DSA:3.60.10.10:FF:000227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62393, NULL, 'G3DSA:1.25.40.10:FF:004952', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62394, NULL, 'G3DSA:3.30.160.60:FF:005661', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62395, NULL, 'G3DSA:3.40.50.2000:FF:000275', NULL, NULL, 'Sterol 3-beta-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(62396, NULL, 'G3DSA:1.10.8.60:FF:000091', NULL, NULL, 'Lon protease homolog 2, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(62397, NULL, 'G3DSA:2.60.40.10:FF:004155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62398, NULL, 'G3DSA:3.40.50.10860:FF:000076', NULL, NULL, 'Methylenetetrahydrofolate dehydrogenase/ methylenetetrahydrofolate cyclohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(62399, NULL, 'G3DSA:3.30.2350.20:FF:000060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62400, NULL, 'G3DSA:3.40.50.10900:FF:000026', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62401, NULL, 'G3DSA:2.40.100.10:FF:000046', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase E', NULL, NULL, NULL, NULL, NULL, 4),
(62402, NULL, 'G3DSA:3.30.710.10:FF:000153', NULL, NULL, 'rho-related BTB domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(62403, NULL, 'G3DSA:3.30.200.20:FF:000510', NULL, NULL, 'serine/threonine-protein kinase D6PKL2', NULL, NULL, NULL, NULL, NULL, 4),
(62404, NULL, 'G3DSA:3.30.519.10:FF:000011', NULL, NULL, 'Rab GDP dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(62405, NULL, 'G3DSA:2.130.10.10:FF:000193', NULL, NULL, 'Protein transport protein SEC31, putative', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(62406, NULL, 'G3DSA:1.20.1560.10:FF:000705', NULL, NULL, 'Multidrug resistance ABC transporter ATP-binding and permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(62407, NULL, 'G3DSA:1.50.40.10:FF:000268', NULL, NULL, 'Mitochondrial dicarboxylate carrier', NULL, NULL, NULL, NULL, NULL, 4),
(62408, NULL, 'G3DSA:3.80.10.10:FF:002290', NULL, NULL, 'AGAP001470-PA', NULL, NULL, NULL, NULL, NULL, 4),
(62409, NULL, 'G3DSA:1.10.10.60:FF:000182', NULL, NULL, 'Paired like homeobox 2B', NULL, NULL, NULL, NULL, NULL, 4),
(62410, NULL, 'G3DSA:3.30.830.10:FF:000072', NULL, NULL, 'Presequence protease', NULL, NULL, NULL, NULL, NULL, 4),
(62411, NULL, 'G3DSA:2.30.30.180:FF:000001', NULL, NULL, 'Ribosome maturation factor RimP', NULL, NULL, NULL, NULL, NULL, 4),
(62412, NULL, 'G3DSA:3.30.465.10:FF:000020', NULL, NULL, 'HlyC/CorC family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(62413, NULL, 'G3DSA:3.90.1150.220:FF:000011', NULL, NULL, 'AGAP005461-PA', NULL, NULL, NULL, NULL, NULL, 4),
(62414, NULL, 'G3DSA:1.20.1250.20:FF:000617', NULL, NULL, 'YALI0F19118p', NULL, NULL, NULL, NULL, NULL, 4),
(62415, NULL, 'G3DSA:3.40.50.300:FF:003582', NULL, NULL, 'Lipopolysaccharide/O-antigen transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(62416, NULL, 'G3DSA:1.25.40.10:FF:005216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62417, NULL, 'G3DSA:2.60.240.10:FF:000001', NULL, NULL, 'Chemokine binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(62418, NULL, 'G3DSA:2.30.29.30:FF:001398', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62419, NULL, 'G3DSA:3.20.20.70:FF:000601', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62420, NULL, 'G3DSA:1.20.1730.10:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62421, NULL, 'G3DSA:1.10.8.710:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62422, NULL, 'G3DSA:2.130.10.10:FF:002671', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62423, NULL, 'G3DSA:3.40.50.1820:FF:001390', NULL, NULL, 'Carboxylesterase SOBER1', NULL, NULL, NULL, NULL, NULL, 4),
(62424, NULL, 'G3DSA:1.10.3450.20:FF:000006', NULL, NULL, 'Nuclear pore complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(62425, NULL, 'G3DSA:3.80.10.10:FF:002750', NULL, NULL, 'Os08g0195900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(62426, NULL, 'G3DSA:3.30.200.20:FF:001230', NULL, NULL, 'Non-specific protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(62427, NULL, 'G3DSA:3.10.105.10:FF:000077', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(62428, NULL, 'G3DSA:2.60.40.10:FF:000557', NULL, NULL, 'Myosin binding protein Ha', NULL, NULL, NULL, NULL, NULL, 4),
(62429, NULL, 'G3DSA:2.60.40.420:FF:000018', NULL, NULL, 'Lamin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(62430, NULL, 'G3DSA:3.40.50.300:FF:006336', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62431, NULL, 'G3DSA:3.30.160.60:FF:003761', NULL, NULL, 'GH19651p', NULL, NULL, NULL, NULL, NULL, 4),
(62432, NULL, 'G3DSA:3.40.50.720:FF:001111', NULL, NULL, '2-hydroxyacid dehydrogenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(62433, NULL, 'G3DSA:2.130.10.10:FF:003183', NULL, NULL, 'Polyadenylation factor subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(62434, NULL, 'G3DSA:1.25.40.10:FF:002462', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g25360', NULL, NULL, NULL, NULL, NULL, 4),
(62435, NULL, 'G3DSA:3.90.810.10:FF:000012', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(62436, NULL, 'G3DSA:2.20.100.10:FF:000039', NULL, NULL, 'thrombospondin type-1 domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(62437, NULL, 'G3DSA:1.50.10.10:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62438, NULL, 'G3DSA:2.40.70.10:FF:000560', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62439, NULL, 'G3DSA:3.10.20.90:FF:000804', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(62440, NULL, 'G3DSA:3.40.50.80:FF:000038', NULL, NULL, 'Vibriobactin utilization protein ViuB', NULL, NULL, NULL, NULL, NULL, 4),
(62441, NULL, 'G3DSA:1.20.920.10:FF:000206', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62442, NULL, 'G3DSA:1.20.120.550:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62443, NULL, 'G3DSA:3.40.1000.30:FF:000012', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62444, NULL, 'G3DSA:1.20.90.10:FF:000014', NULL, NULL, 'Secretory phospholipase A2', NULL, NULL, NULL, NULL, NULL, 4),
(62445, NULL, 'G3DSA:2.60.40.60:FF:000999', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62446, NULL, 'G3DSA:2.60.40.3180:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62447, NULL, 'G3DSA:3.90.1530.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62448, NULL, 'G3DSA:1.10.10.250:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62449, NULL, 'G3DSA:2.60.200.40:FF:000002', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(62450, NULL, 'G3DSA:1.25.40.180:FF:000114', NULL, NULL, 'Protein CBR-SMG-3', NULL, NULL, NULL, NULL, NULL, 4),
(62451, NULL, 'G3DSA:3.40.50.1000:FF:000637', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62452, NULL, 'G3DSA:3.40.140.10:FF:000180', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit F', NULL, NULL, NULL, NULL, NULL, 4),
(62453, NULL, 'G3DSA:3.90.850.10:FF:000014', NULL, NULL, 'Uncharacterized mitochondrial hydrolase FMP41', NULL, NULL, NULL, NULL, NULL, 4),
(62454, NULL, 'G3DSA:3.90.830.10:FF:000007', NULL, NULL, 'Vacuolar protein sorting-associated protein 45', NULL, NULL, NULL, NULL, NULL, 4),
(62455, NULL, 'G3DSA:3.40.50.2300:FF:001449', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62456, NULL, 'G3DSA:1.10.150.50:FF:000122', NULL, NULL, 'CG5272 protein', NULL, NULL, NULL, NULL, NULL, 4),
(62457, NULL, 'G3DSA:3.90.550.50:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62458, NULL, 'G3DSA:1.10.20.10:FF:000263', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62459, NULL, 'G3DSA:3.30.830.10:FF:000313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62460, NULL, 'G3DSA:2.60.120.620:FF:000059', NULL, NULL, 'Proline-4-hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(62461, NULL, 'G3DSA:3.30.2290.10:FF:000012', NULL, NULL, 'PmbA/TldD related protein', NULL, NULL, NULL, NULL, NULL, 4),
(62462, NULL, 'G3DSA:3.30.420.40:FF:000931', NULL, NULL, 'Actin-like protein arp10', NULL, NULL, NULL, NULL, NULL, 4),
(62463, NULL, 'G3DSA:3.40.190.10:FF:000795', NULL, NULL, 'Arogenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(62464, NULL, 'G3DSA:3.40.50.2300:FF:001556', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62465, NULL, 'G3DSA:3.40.50.2300:FF:000937', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62466, NULL, 'G3DSA:3.40.50.720:FF:001004', NULL, NULL, 'HesA/MoeB/ThiF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(62467, NULL, 'G3DSA:2.40.50.140:FF:000171', NULL, NULL, 'meiosis-specific with OB domain-containing protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(62468, NULL, 'G3DSA:3.90.1150.10:FF:000027', NULL, NULL, 'Adenosylmethionine-8-amino-7-oxononanoate aminotransferase, probable', NULL, NULL, NULL, NULL, NULL, 4),
(62469, NULL, 'G3DSA:1.10.150.20:FF:000012', NULL, NULL, 'Holliday junction ATP-dependent DNA helicase RuvA', NULL, NULL, NULL, NULL, NULL, 4),
(62470, NULL, 'G3DSA:3.40.220.10:FF:000006', NULL, NULL, 'ganglioside-induced differentiation-associated protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(62471, NULL, 'G3DSA:3.10.350.10:FF:000022', NULL, NULL, 'Cell wall hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(62472, NULL, 'G3DSA:1.10.510.10:FF:004163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62473, NULL, 'G3DSA:1.25.10.10:FF:003146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(62474, NULL, 'G3DSA:3.30.2350.10:FF:000051', NULL, NULL, 'H/ACA ribonucleoprotein complex subunit DKC1', NULL, NULL, NULL, NULL, NULL, 4),
(62475, NULL, 'G3DSA:2.70.160.11:FF:000016', NULL, NULL, 'Protein arginine methyltransferase RmtB', NULL, NULL, NULL, NULL, NULL, 4),
(62476, NULL, 'G3DSA:3.30.1370.210:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62477, NULL, 'G3DSA:1.25.40.10:FF:005109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62478, NULL, 'G3DSA:1.10.10.60:FF:000187', NULL, NULL, 'homeobox protein DBX2', NULL, NULL, NULL, NULL, NULL, 4),
(62479, NULL, 'G3DSA:3.40.50.1820:FF:000771', NULL, NULL, 'Hydrolase, alpha/beta fold family-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(62480, NULL, 'G3DSA:3.40.190.10:FF:000688', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62481, NULL, 'G3DSA:2.130.10.10:FF:002564', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62482, NULL, 'G3DSA:2.40.160.50:FF:000045', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62483, NULL, 'G3DSA:2.10.110.10:FF:000250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62484, NULL, 'G3DSA:1.20.5.110:FF:000260', NULL, NULL, 'Synaptobrevin-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(62485, NULL, 'G3DSA:3.60.15.10:FF:000070', NULL, NULL, 'Glyoxylase, beta-lactamase superfamily II', NULL, NULL, NULL, NULL, NULL, 4),
(62486, NULL, 'G3DSA:3.30.710.10:FF:000147', NULL, NULL, 'Predicted gene 4858', NULL, NULL, NULL, NULL, NULL, 4),
(62487, NULL, 'G3DSA:1.20.1070.10:FF:001354', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(62488, NULL, 'G3DSA:3.30.160.60:FF:004380', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62489, NULL, 'G3DSA:2.130.10.10:FF:001047', NULL, NULL, 'Stress protein', NULL, NULL, NULL, NULL, NULL, 4),
(62490, NULL, 'G3DSA:3.40.50.150:FF:000642', NULL, NULL, 'Fibrillarin putative', NULL, NULL, NULL, NULL, NULL, 4),
(62491, NULL, 'G3DSA:3.30.200.20:FF:001797', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(62492, NULL, 'G3DSA:1.20.900.10:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62493, NULL, 'G3DSA:3.40.50.300:FF:008472', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62494, NULL, 'G3DSA:3.30.200.20:FF:000274', NULL, NULL, 'Calcium/calmodulin-regulated receptor-like kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(62495, NULL, 'G3DSA:2.40.30.10:FF:000451', NULL, NULL, 'Mitochondrial ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(62496, NULL, 'G3DSA:1.25.40.10:FF:000326', NULL, NULL, 'ER membrane protein complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(62497, NULL, 'G3DSA:2.40.50.140:FF:000856', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62498, NULL, 'G3DSA:3.40.50.300:FF:002969', NULL, NULL, 'Putative ATP-dependent DNA helicase DDX11', NULL, NULL, NULL, NULL, NULL, 4),
(62499, NULL, 'G3DSA:3.20.20.70:FF:000596', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62500, NULL, 'G3DSA:1.20.1250.20:FF:000724', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(62501, NULL, 'G3DSA:1.10.1370.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62502, NULL, 'G3DSA:3.40.50.300:FF:000608', NULL, NULL, 'Mov10 RISC complex RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(62503, NULL, 'G3DSA:2.30.180.10:FF:000098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62504, NULL, 'G3DSA:3.10.20.90:FF:000799', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62505, NULL, 'G3DSA:3.40.50.2300:FF:000252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62506, NULL, 'G3DSA:4.10.280.10:FF:000052', NULL, NULL, 'Protein atonal homolog 8', NULL, NULL, NULL, NULL, NULL, 4),
(62507, NULL, 'G3DSA:3.10.450.350:FF:000001', NULL, NULL, 'Murein DD-endopeptidase MepM', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(62508, NULL, 'G3DSA:3.30.710.10:FF:000254', NULL, NULL, 'Potassium voltage-gated channel, putative', NULL, NULL, NULL, NULL, NULL, 4),
(62509, NULL, 'G3DSA:1.10.490.10:FF:000057', NULL, NULL, 'GLoBin related', NULL, NULL, NULL, NULL, NULL, 4),
(62510, NULL, 'G3DSA:2.60.40.10:FF:002699', NULL, NULL, 'Gingipain R2', NULL, NULL, NULL, NULL, NULL, 4),
(62511, NULL, 'G3DSA:1.10.10.540:FF:000001', NULL, NULL, 'UV excision repair protein RAD23 B', NULL, NULL, NULL, NULL, NULL, 4),
(62512, NULL, 'G3DSA:3.40.50.720:FF:002308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62513, NULL, 'G3DSA:1.10.238.10:FF:000977', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62514, NULL, 'G3DSA:2.60.40.10:FF:003216', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62515, NULL, 'G3DSA:3.90.70.10:FF:000533', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(62516, NULL, 'G3DSA:3.30.70.60:FF:000005', NULL, NULL, 'Pilus assembly protein, PilO', NULL, NULL, NULL, NULL, NULL, 4),
(62517, NULL, 'G3DSA:2.130.10.10:FF:000209', NULL, NULL, 'sterol regulatory element-binding protein cleavage-activating protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(62518, NULL, 'G3DSA:1.20.1250.20:FF:001562', NULL, NULL, 'Transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(62519, NULL, 'G3DSA:2.60.40.10:FF:003323', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62520, NULL, 'G3DSA:2.60.120.200:FF:000506', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(62521, NULL, 'G3DSA:3.30.160.60:FF:000102', NULL, NULL, 'zinc finger protein 850 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(62522, NULL, 'G3DSA:4.10.640.10:FF:000035', NULL, NULL, '28S ribosomal protein S18a, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(62523, NULL, 'G3DSA:1.10.30.10:FF:000084', NULL, NULL, 'HMG type nucleosome/chromatin assembly factor', NULL, NULL, NULL, NULL, NULL, 4),
(62524, NULL, 'G3DSA:1.10.287.820:FF:000007', NULL, NULL, 'Pickpocket 12', NULL, NULL, NULL, NULL, NULL, 4),
(62525, NULL, 'G3DSA:2.130.10.10:FF:005318', NULL, NULL, 'Vegetative incompatibility WD repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(62526, NULL, 'G3DSA:3.40.30.10:FF:000387', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62527, NULL, 'G3DSA:1.20.1070.10:FF:001247', NULL, NULL, 'Adhesion G protein-coupled receptor G1', NULL, NULL, NULL, NULL, NULL, 4),
(62528, NULL, 'G3DSA:2.60.120.260:FF:000159', NULL, NULL, 'Monopolar spindle', NULL, NULL, NULL, NULL, NULL, 4),
(62529, NULL, 'G3DSA:3.30.1320.10:FF:000004', NULL, NULL, '28S ribosomal protein S16, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(62530, NULL, 'G3DSA:1.10.3370.10:FF:000053', NULL, NULL, 'Preprotein translocase secY subunit', NULL, NULL, NULL, NULL, NULL, 4),
(62531, NULL, 'G3DSA:1.10.510.10:FF:000796', NULL, NULL, 'Stress response kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(62532, NULL, 'G3DSA:2.130.10.10:FF:000198', NULL, NULL, 'VPS10 domain-containing receptor SorCS1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(62533, NULL, 'G3DSA:2.60.40.60:FF:000095', NULL, NULL, 'Cadherin 13', NULL, NULL, NULL, NULL, NULL, 4),
(62534, NULL, 'G3DSA:3.30.70.270:FF:000015', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(62535, NULL, 'G3DSA:3.30.1010.10:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62536, NULL, 'G3DSA:1.25.40.10:FF:003766', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62537, NULL, 'G3DSA:1.10.238.10:FF:000292', NULL, NULL, 'Calcium-binding protein CML38', NULL, NULL, NULL, NULL, NULL, 4),
(62538, NULL, 'G3DSA:1.25.10.10:FF:001229', NULL, NULL, 'Armadillo/beta-catenin-like_repeat_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(62539, NULL, 'G3DSA:2.120.10.30:FF:000053', NULL, NULL, 'protein yellow', NULL, NULL, NULL, NULL, NULL, 4),
(62540, NULL, 'G3DSA:2.60.40.10:FF:001395', NULL, NULL, 'Platelet-derived growth factor receptor-like protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(62541, NULL, 'G3DSA:3.90.1310.10:FF:000029', NULL, NULL, 'Penicillin-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(62542, NULL, 'G3DSA:1.20.5.420:FF:000027', NULL, NULL, 'Ribonuclease P protein component 4', NULL, NULL, NULL, NULL, NULL, 4),
(62543, NULL, 'G3DSA:3.40.50.300:FF:005032', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62544, NULL, 'G3DSA:1.10.10.60:FF:001036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62545, NULL, 'G3DSA:1.25.40.20:FF:001627', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(62546, NULL, 'G3DSA:3.60.21.50:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62547, NULL, 'G3DSA:1.20.58.390:FF:000085', NULL, NULL, 'Gamma-aminobutyric acid type A receptor pi subunit', NULL, NULL, NULL, NULL, NULL, 4),
(62548, NULL, 'G3DSA:3.30.1330.20:FF:000047', NULL, NULL, 'Beta tubulin,putative', NULL, NULL, NULL, NULL, NULL, 4),
(62549, NULL, 'G3DSA:1.20.1070.10:FF:000735', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(62550, NULL, 'G3DSA:3.40.50.12470:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62551, NULL, 'G3DSA:3.30.40.10:FF:001591', NULL, NULL, 'Histone-lysine N-methyltransferase set-26', NULL, NULL, NULL, NULL, NULL, 4),
(62552, NULL, 'G3DSA:1.25.40.570:FF:000017', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(62553, NULL, 'G3DSA:3.30.60.20:FF:000066', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(62554, NULL, 'G3DSA:1.10.238.10:FF:000752', NULL, NULL, 'RAB11 family-interacting protein 3 (class II)', NULL, NULL, NULL, NULL, NULL, 4),
(62555, NULL, 'G3DSA:1.20.58.1380:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62556, NULL, 'G3DSA:3.30.497.10:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62557, NULL, 'G3DSA:3.30.760.10:FF:000077', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62558, NULL, 'G3DSA:3.30.60.20:FF:000089', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(62559, NULL, 'G3DSA:2.10.50.30:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62560, NULL, 'G3DSA:1.20.120.20:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62561, NULL, 'G3DSA:3.40.50.1820:FF:001176', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62562, NULL, 'G3DSA:1.50.10.130:FF:000015', NULL, NULL, 'Acyclic sesquiterpene synthase', NULL, NULL, NULL, NULL, NULL, 4),
(62563, NULL, 'G3DSA:2.40.50.730:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62564, NULL, 'G3DSA:1.10.510.10:FF:000666', NULL, NULL, 'myosin light chain kinase, smooth muscle isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(62565, NULL, 'G3DSA:4.10.60.10:FF:000174', NULL, NULL, 'mRNA-binding translational activator', NULL, NULL, NULL, NULL, NULL, 4),
(62566, NULL, 'G3DSA:1.25.10.10:FF:002634', NULL, NULL, 'GH03057p', NULL, NULL, NULL, NULL, NULL, 4),
(62567, NULL, 'G3DSA:1.20.1080.10:FF:000112', NULL, NULL, 'Aquaporin rerated protein', NULL, NULL, NULL, NULL, NULL, 4),
(62568, NULL, 'G3DSA:2.60.120.200:FF:000169', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(62569, NULL, 'G3DSA:3.30.428.10:FF:000041', NULL, NULL, 'HIT family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(62570, NULL, 'G3DSA:3.30.40.10:FF:000079', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(62571, NULL, 'G3DSA:4.10.60.10:FF:000197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62572, NULL, 'G3DSA:3.40.630.10:FF:000043', NULL, NULL, 'Carboxypeptidase D', NULL, NULL, NULL, NULL, NULL, 4),
(62573, NULL, 'G3DSA:3.30.70.960:FF:000020', NULL, NULL, 'Transmembrane protease serine', NULL, NULL, NULL, NULL, NULL, 4),
(62574, NULL, 'G3DSA:1.20.58.60:FF:000448', NULL, NULL, 'Spectrin alpha chain, erythrocytic 1', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(62575, NULL, 'G3DSA:1.10.510.10:FF:001285', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(62576, NULL, 'G3DSA:3.30.70.330:FF:000528', NULL, NULL, 'RNA exonuclease 5', NULL, NULL, NULL, NULL, NULL, 4),
(62577, NULL, 'G3DSA:3.10.50.40:FF:000078', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(62578, NULL, 'G3DSA:2.60.40.10:FF:006066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62579, NULL, 'G3DSA:3.90.650.10:FF:000010', NULL, NULL, 'Selenide, water dikinase', NULL, NULL, NULL, NULL, NULL, 4),
(62580, NULL, 'G3DSA:2.40.170.20:FF:000109', NULL, NULL, 'Outer membrane protein Omp121', NULL, NULL, NULL, NULL, NULL, 4),
(62581, NULL, 'G3DSA:2.130.10.10:FF:003868', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62582, NULL, 'G3DSA:3.10.20.90:FF:000911', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62583, NULL, 'G3DSA:3.30.160.60:FF:001844', NULL, NULL, 'Zinc finger protein 33A', NULL, NULL, NULL, NULL, NULL, 4),
(62584, NULL, 'G3DSA:2.60.40.1910:FF:000007', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(62585, NULL, 'G3DSA:3.40.190.10:FF:000576', NULL, NULL, 'Extracellular solute-binding protein family 5', NULL, NULL, NULL, NULL, NULL, 4),
(62586, NULL, 'G3DSA:3.30.420.40:FF:000824', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(62587, NULL, 'G3DSA:3.50.50.60:FF:000751', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(62588, NULL, 'G3DSA:2.60.40.150:FF:000690', NULL, NULL, 'AAL103Wp', NULL, NULL, NULL, NULL, NULL, 4),
(62589, NULL, 'G3DSA:3.40.190.10:FF:000800', NULL, NULL, 'Excitatory amino acid transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(62590, NULL, 'G3DSA:2.60.40.1090:FF:000031', NULL, NULL, 'Fimbrial protein SthD', NULL, NULL, NULL, NULL, NULL, 4),
(62591, NULL, 'G3DSA:3.30.70.980:FF:000026', NULL, NULL, 'YGR021W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(62592, NULL, 'G3DSA:3.30.420.110:FF:000008', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(62593, NULL, 'G3DSA:3.30.40.10:FF:001158', NULL, NULL, 'IP04788p', NULL, NULL, NULL, NULL, NULL, 4),
(62594, NULL, 'G3DSA:2.60.120.200:FF:000725', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62595, NULL, 'G3DSA:3.40.50.2000:FF:000168', NULL, NULL, 'Alpha-1,2-mannosyltransferase (Alg11), putative', NULL, NULL, NULL, NULL, NULL, 4),
(62596, NULL, 'G3DSA:3.30.450.20:FF:000096', NULL, NULL, 'High affinity cAMP-specific and IBMX-insensitive 3'',5''-cyclic phosphodiesterase 8', NULL, NULL, NULL, NULL, NULL, 4),
(62597, NULL, 'G3DSA:3.40.50.2300:FF:000140', NULL, NULL, 'Catabolite control protein A', NULL, NULL, NULL, NULL, NULL, 4),
(62598, NULL, 'G3DSA:3.90.70.10:FF:000752', NULL, NULL, 'Clan CA, family C1, cathepsin L-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(62599, NULL, 'G3DSA:1.25.40.10:FF:003311', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g26900, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(62600, NULL, 'G3DSA:1.10.1090.10:FF:000008', NULL, NULL, 'Cytochrome b-c1 complex subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(62601, NULL, 'G3DSA:3.40.50.720:FF:002527', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62602, NULL, 'G3DSA:1.25.40.10:FF:000545', NULL, NULL, 'Vacuolar protein sorting-associated protein 41 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(62603, NULL, 'G3DSA:1.10.287.80:FF:000026', NULL, NULL, 'ATP synthase gamma chain 1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(62604, NULL, 'G3DSA:3.40.50.300:FF:008253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62605, NULL, 'G3DSA:3.30.70.330:FF:002883', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62606, NULL, 'G3DSA:3.30.70.660:FF:000043', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(62607, NULL, 'G3DSA:1.20.1250.20:FF:001781', NULL, NULL, 'Permease, putative', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(62608, NULL, 'G3DSA:2.30.30.100:FF:000135', NULL, NULL, 'Protein CBG17705', NULL, NULL, NULL, NULL, NULL, 4),
(62609, NULL, 'G3DSA:1.10.150.170:FF:000009', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase H', NULL, NULL, NULL, NULL, NULL, 4),
(62610, NULL, 'G3DSA:1.10.2000.10:FF:000065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62611, NULL, 'G3DSA:2.10.25.10:FF:001805', NULL, NULL, 'Protein glp-1', NULL, NULL, NULL, NULL, NULL, 4),
(62612, NULL, 'G3DSA:3.80.10.10:FF:000277', NULL, NULL, 'Leucine-rich repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(62613, NULL, 'G3DSA:1.20.1250.20:FF:002181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62614, NULL, 'G3DSA:3.60.90.10:FF:000002', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(62615, NULL, 'G3DSA:1.20.58.1360:FF:000003', NULL, NULL, 'Lysine-specific demethylase 7A', NULL, NULL, NULL, NULL, NULL, 4),
(62616, NULL, 'G3DSA:2.60.40.10:FF:002704', NULL, NULL, 'Myosin, light chain kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(62617, NULL, 'G3DSA:1.20.120.850:FF:000014', NULL, NULL, 'DNA repair and recombination protein RDH54', NULL, NULL, NULL, NULL, NULL, 4),
(62618, NULL, 'G3DSA:2.30.180.10:FF:000093', NULL, NULL, 'Transforming growth factor-beta-induced protein Ig-H3', NULL, NULL, NULL, NULL, NULL, 4),
(62619, NULL, 'G3DSA:3.30.420.580:FF:000008', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(62620, NULL, 'G3DSA:2.40.50.140:FF:001020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62621, NULL, 'G3DSA:3.40.1280.10:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62622, NULL, 'G3DSA:3.10.450.10:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62623, NULL, 'G3DSA:2.60.40.10:FF:003435', NULL, NULL, 'hydrocephalus-inducing protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(62624, NULL, 'G3DSA:3.90.980.20:FF:000004', NULL, NULL, 'Cysteine-rich protein 2-binding protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(62625, NULL, 'G3DSA:1.10.510.10:FF:003651', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62626, NULL, 'G3DSA:3.30.450.20:FF:000545', NULL, NULL, 'Uncharacterized protein DHKH', NULL, NULL, NULL, NULL, NULL, 4),
(62627, NULL, 'G3DSA:3.20.20.70:FF:000719', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62628, NULL, 'G3DSA:2.60.40.2080:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62629, NULL, 'G3DSA:3.40.190.290:FF:000056', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(62630, NULL, 'G3DSA:2.60.40.150:FF:000701', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62631, NULL, 'G3DSA:3.30.2090.10:FF:000019', NULL, NULL, 'Transporter, AcrB/D/F family', NULL, NULL, NULL, NULL, NULL, 4),
(62632, NULL, 'G3DSA:1.20.1280.50:FF:000095', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62633, NULL, 'G3DSA:3.10.330.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62634, NULL, 'G3DSA:1.10.287.80:FF:000021', NULL, NULL, 'ATP synthase subunit gamma, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(62635, NULL, 'G3DSA:3.60.10.10:FF:000222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62636, NULL, 'G3DSA:3.30.70.330:FF:001585', NULL, NULL, 'U1 small nuclear ribonucleoprotein 70 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(62637, NULL, 'G3DSA:1.10.418.10:FF:000283', NULL, NULL, 'Actinin alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(62638, NULL, 'G3DSA:2.60.40.10:FF:005228', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62639, NULL, 'G3DSA:3.50.4.10:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62640, NULL, 'G3DSA:1.25.10.10:FF:002415', NULL, NULL, 'Exportin-5', NULL, NULL, NULL, NULL, NULL, 4),
(62641, NULL, 'G3DSA:3.30.40.10:FF:002119', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62642, NULL, 'G3DSA:3.40.50.1820:FF:000226', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(62643, NULL, 'G3DSA:1.10.287.3440:FF:000002', NULL, NULL, 'Biosynthetic arginine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(62644, NULL, 'G3DSA:3.40.1110.10:FF:000008', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(62645, NULL, 'G3DSA:3.30.559.10:FF:000244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62646, NULL, 'G3DSA:3.80.10.10:FF:001238', NULL, NULL, 'Toll-like receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(62647, NULL, 'G3DSA:3.30.70.330:FF:001933', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62648, NULL, 'G3DSA:2.130.10.10:FF:000647', NULL, NULL, 'Regulatory-associated protein of TOR 1', NULL, NULL, NULL, NULL, NULL, 4),
(62649, NULL, 'G3DSA:3.30.300.130:FF:000004', NULL, NULL, 'cytosolic iron-sulfur assembly component 2A', NULL, NULL, NULL, NULL, NULL, 4),
(62650, NULL, 'G3DSA:1.25.40.20:FF:000211', NULL, NULL, 'Integrin-linked protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(62651, NULL, 'G3DSA:3.30.1600.10:FF:000037', NULL, NULL, 'Sirtuin type, putative', NULL, NULL, NULL, NULL, NULL, 4),
(62652, NULL, 'G3DSA:3.30.1120.30:FF:000006', NULL, NULL, 'Polo like kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(62653, NULL, 'G3DSA:3.40.50.970:FF:000219', NULL, NULL, 'Uncharacterized protein, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(62654, NULL, 'G3DSA:2.130.10.10:FF:001266', NULL, NULL, 'AGAP007544-PA', NULL, NULL, NULL, NULL, NULL, 4),
(62655, NULL, 'G3DSA:3.30.420.40:FF:000038', NULL, NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(62656, NULL, 'G3DSA:3.30.450.40:FF:000214', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(62657, NULL, 'G3DSA:3.30.200.20:FF:001578', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62658, NULL, 'G3DSA:3.30.40.10:FF:001596', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62659, NULL, 'G3DSA:3.40.50.300:FF:001665', NULL, NULL, 'DNA repair protein RAD51 4', NULL, NULL, NULL, NULL, NULL, 4),
(62660, NULL, 'G3DSA:3.30.160.60:FF:002356', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62661, NULL, 'G3DSA:1.10.10.60:FF:001255', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62662, NULL, 'G3DSA:2.120.10.80:FF:000039', NULL, NULL, 'influenza virus NS1A-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(62663, NULL, 'G3DSA:2.60.40.10:FF:000338', NULL, NULL, 'intercellular adhesion molecule 5', NULL, NULL, NULL, NULL, NULL, 4),
(62664, NULL, 'G3DSA:3.40.228.10:FF:000018', NULL, NULL, 'Dimethyl sulfoxide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(62665, NULL, 'G3DSA:1.10.630.10:FF:000265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62666, NULL, 'G3DSA:3.10.100.10:FF:000330', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62667, NULL, 'G3DSA:1.10.600.10:FF:000100', NULL, NULL, '(E,E)-geranyllinalool synthase', NULL, NULL, NULL, NULL, NULL, 4),
(62668, NULL, 'G3DSA:3.40.50.2300:FF:001668', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62669, NULL, 'G3DSA:1.20.1070.10:FF:000050', NULL, NULL, '5-hydroxytryptamine receptor 1B', NULL, NULL, NULL, NULL, NULL, 4),
(62670, NULL, 'G3DSA:1.10.150.20:FF:000124', NULL, NULL, 'Exonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(62671, NULL, 'G3DSA:1.10.287.70:FF:000703', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62672, NULL, 'G3DSA:1.20.140.10:FF:000017', NULL, NULL, 'very long-chain specific acyl-CoA dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(62673, NULL, 'G3DSA:1.20.58.60:FF:000229', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(62674, NULL, 'G3DSA:3.30.930.10:FF:000242', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(62675, NULL, 'G3DSA:3.30.230.10:FF:000228', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(62676, NULL, 'G3DSA:3.30.450.20:FF:000438', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(62677, NULL, 'G3DSA:3.30.70.1230:FF:000097', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(62678, NULL, 'G3DSA:3.30.40.10:FF:000410', NULL, NULL, 'At1g47570', NULL, NULL, NULL, NULL, NULL, 4),
(62679, NULL, 'G3DSA:2.60.40.10:FF:004609', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62680, NULL, 'G3DSA:1.20.1050.10:FF:000279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62681, NULL, 'G3DSA:1.20.140.40:FF:000015', NULL, NULL, 'Pectinesterase 3', NULL, NULL, NULL, NULL, NULL, 4),
(62682, NULL, 'G3DSA:3.30.200.20:FF:002197', NULL, NULL, 'Protein kinase MAPKKKK, MAP4K-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(62683, NULL, 'G3DSA:3.20.20.80:FF:000037', NULL, NULL, 'Putative family 31 glucosidase KIAA1161', NULL, NULL, NULL, NULL, NULL, 4),
(62684, NULL, 'G3DSA:3.80.10.10:FF:000833', NULL, NULL, 'Protein TOO MANY MOUTHS', NULL, NULL, NULL, NULL, NULL, 4),
(62685, NULL, 'G3DSA:2.60.200.10:FF:000004', NULL, NULL, 'Mothers against decapentaplegic homolog', NULL, NULL, NULL, NULL, NULL, 4),
(62686, NULL, 'G3DSA:1.10.490.160:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62687, NULL, 'G3DSA:1.25.40.10:FF:002243', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(62688, NULL, 'G3DSA:1.10.510.10:FF:002139', NULL, NULL, 'Dual specificity protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(62689, NULL, 'G3DSA:3.60.10.10:FF:000115', NULL, NULL, 'DNAse I-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(62690, NULL, 'G3DSA:2.70.170.10:FF:000285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62691, NULL, 'G3DSA:3.90.226.10:FF:000047', NULL, NULL, 'Probable 3-hydroxyacyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(62692, NULL, 'G3DSA:3.40.50.300:FF:006555', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62693, NULL, 'G3DSA:3.40.5.50:FF:000004', NULL, NULL, 'Putative Psf2', NULL, NULL, NULL, NULL, NULL, 4),
(62694, NULL, 'G3DSA:3.40.50.720:FF:001908', NULL, NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(62695, NULL, 'G3DSA:3.40.50.2000:FF:000387', NULL, NULL, 'Sucrose synthase 3', NULL, NULL, NULL, NULL, NULL, 4),
(62696, NULL, 'G3DSA:2.30.42.10:FF:000086', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type 13', NULL, NULL, NULL, NULL, NULL, 4),
(62697, NULL, 'G3DSA:3.30.70.270:FF:000252', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62698, NULL, 'G3DSA:2.60.40.180:FF:000007', NULL, NULL, '5-hydroxyisourate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(62699, NULL, 'G3DSA:3.30.160.60:FF:001395', NULL, NULL, 'Krueppel-like factor 7', NULL, NULL, NULL, NULL, NULL, 4),
(62700, NULL, 'G3DSA:2.60.120.40:FF:000057', NULL, NULL, 'Precerebellin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(62701, NULL, 'G3DSA:3.40.50.300:FF:000597', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(62702, NULL, 'G3DSA:1.20.920.10:FF:000083', NULL, NULL, 'WGS project CABT00000000 data, contig 2.8', NULL, NULL, NULL, NULL, NULL, 4),
(62703, NULL, 'G3DSA:2.40.100.10:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62704, NULL, 'G3DSA:2.40.50.40:FF:000096', NULL, NULL, 'Chromodomain Y-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(62705, NULL, 'G3DSA:2.130.10.10:FF:004829', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62706, NULL, 'G3DSA:3.90.79.10:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62707, NULL, 'G3DSA:1.10.510.10:FF:002246', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62708, NULL, 'G3DSA:1.10.246.220:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62709, NULL, 'G3DSA:3.40.710.10:FF:000100', NULL, NULL, 'Penicillin-binding protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(62710, NULL, 'G3DSA:3.40.50.2300:FF:000145', NULL, NULL, 'Glutamate receptor, metabotropic', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(62711, NULL, 'G3DSA:3.30.420.10:FF:000372', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62712, NULL, 'G3DSA:3.30.70.660:FF:000048', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(62713, NULL, 'G3DSA:2.60.40.150:FF:000589', NULL, NULL, 'FAM62', NULL, NULL, NULL, NULL, NULL, 4),
(62714, NULL, 'G3DSA:1.20.1250.20:FF:002293', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62715, NULL, 'G3DSA:3.10.310.10:FF:000025', NULL, NULL, 'Diaminopimelate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(62716, NULL, 'G3DSA:3.30.200.20:FF:002539', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(62717, NULL, 'G3DSA:1.10.10.60:FF:000294', NULL, NULL, 'NK1 transcription factor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(62718, NULL, 'G3DSA:3.40.50.720:FF:002415', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62719, NULL, 'G3DSA:1.10.150.170:FF:000004', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase H', NULL, NULL, NULL, NULL, NULL, 4),
(62720, NULL, 'G3DSA:3.80.10.10:FF:004200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62721, NULL, 'G3DSA:3.30.910.20:FF:000013', NULL, NULL, 'Putative outer membrane protein OmpH', NULL, NULL, NULL, NULL, NULL, 4),
(62722, NULL, 'G3DSA:3.40.50.150:FF:001603', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62723, NULL, 'G3DSA:3.60.40.10:FF:000156', NULL, NULL, 'Integrin-linked kinase-associated serine/threonine phosphatase 2C', NULL, NULL, NULL, NULL, NULL, 4),
(62724, NULL, 'G3DSA:3.40.50.300:FF:002632', NULL, NULL, 'Primosomal protein N''', NULL, NULL, NULL, NULL, NULL, 4),
(62725, NULL, 'G3DSA:3.40.850.10:FF:000475', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(62726, NULL, 'G3DSA:2.60.40.10:FF:003430', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62727, NULL, 'G3DSA:2.60.120.560:FF:000024', NULL, NULL, 'Sucrose-6-phosphate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(62728, NULL, 'G3DSA:2.130.10.10:FF:004487', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62729, NULL, 'G3DSA:2.120.10.30:FF:000401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62730, NULL, 'G3DSA:3.40.50.300:FF:005162', NULL, NULL, 'Sugar ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(62731, NULL, 'G3DSA:3.30.2140.20:FF:000010', NULL, NULL, 'Arylamine N-acetyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(62732, NULL, 'G3DSA:1.10.472.10:FF:000684', NULL, NULL, 'CYC2-like cyclin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(62733, NULL, 'G3DSA:3.80.10.10:FF:003924', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62734, NULL, 'G3DSA:3.40.50.150:FF:000861', NULL, NULL, 'Protein-L-isoaspartate O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(62735, NULL, 'G3DSA:3.10.20.30:FF:000028', NULL, NULL, 'threonine--tRNA ligase, mitochondrial isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(62736, NULL, 'G3DSA:2.10.25.10:FF:001356', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62737, NULL, 'G3DSA:2.60.120.260:FF:000029', NULL, NULL, 'Beta-galactosidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(62738, NULL, 'G3DSA:3.80.10.10:FF:004330', NULL, NULL, 'Os04g0291900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(62739, NULL, 'G3DSA:3.20.20.140:FF:000019', NULL, NULL, 'Cytosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(62740, NULL, 'G3DSA:3.30.70.1230:FF:000102', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(62741, NULL, 'G3DSA:3.30.530.20:FF:000153', NULL, NULL, 'MLP-like protein 43', NULL, NULL, NULL, NULL, NULL, 4),
(62742, NULL, 'G3DSA:3.40.50.300:FF:004886', NULL, NULL, 'Septin 5a', NULL, NULL, NULL, NULL, NULL, 4),
(62743, NULL, 'G3DSA:3.40.50.150:FF:001261', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62744, NULL, 'G3DSA:3.40.50.10140:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(62745, NULL, 'G3DSA:3.30.160.60:FF:002463', NULL, NULL, 'Zinc finger protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(62746, NULL, 'G3DSA:1.50.40.10:FF:000032', NULL, NULL, 'Solute carrier family 25 member 33', NULL, NULL, NULL, NULL, NULL, 4),
(62747, NULL, 'G3DSA:3.50.7.10:FF:000087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62748, NULL, 'G3DSA:3.30.160.60:FF:001052', NULL, NULL, 'Zinc finger protein 668', NULL, NULL, NULL, NULL, NULL, 4),
(62749, NULL, 'G3DSA:1.10.510.10:FF:001178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62750, NULL, 'G3DSA:3.20.20.60:FF:000031', NULL, NULL, 'HpcH/HpaI aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(62751, NULL, 'G3DSA:3.40.50.1000:FF:000418', NULL, NULL, 'D,D-heptose 1,7-bisphosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(62752, NULL, 'G3DSA:3.30.200.20:FF:001235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62753, NULL, 'G3DSA:3.40.50.150:FF:001131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62754, NULL, 'G3DSA:3.30.160.20:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62755, NULL, 'G3DSA:1.10.3450.40:FF:000001', NULL, NULL, 'Signal recognition particle subunit SRP68', NULL, NULL, NULL, NULL, NULL, 4),
(62756, NULL, 'G3DSA:1.20.1740.10:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62757, NULL, 'G3DSA:4.10.860.10:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62758, NULL, 'G3DSA:2.70.98.10:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62759, NULL, 'G3DSA:3.10.20.10:FF:000022', NULL, NULL, 'Cell death-inducing DFFA-like effector b', NULL, NULL, NULL, NULL, NULL, 4),
(62760, NULL, 'G3DSA:2.30.30.40:FF:000415', NULL, NULL, 'LIM and SH3 domain protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(62761, NULL, 'G3DSA:1.20.1560.10:FF:000149', NULL, NULL, 'ATP-binding cassette protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(62762, NULL, 'G3DSA:3.30.160.60:FF:002811', NULL, NULL, 'Zinc finger protein 679', NULL, NULL, NULL, NULL, NULL, 4),
(62763, NULL, 'G3DSA:1.20.1280.290:FF:000046', NULL, NULL, 'Sugar transporter SWEET', NULL, NULL, NULL, NULL, NULL, 4),
(62764, NULL, 'G3DSA:2.60.40.1170:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62765, NULL, 'G3DSA:3.30.1490.20:FF:000103', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(62766, NULL, 'G3DSA:3.40.50.1820:FF:001395', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62767, NULL, 'G3DSA:3.30.70.100:FF:000010', NULL, NULL, 'Small-conductance mechanosensitive channel MscS', NULL, NULL, NULL, NULL, NULL, 4),
(62768, NULL, 'G3DSA:1.20.120.1240:FF:000026', NULL, NULL, 'Dynamin-related protein 1E', NULL, NULL, NULL, NULL, NULL, 4),
(62769, NULL, 'G3DSA:3.30.260.10:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62770, NULL, 'G3DSA:2.60.40.4100:FF:000013', NULL, NULL, 'Protein dyf-7', NULL, NULL, NULL, NULL, NULL, 4),
(62771, NULL, 'G3DSA:3.30.70.330:FF:000281', NULL, NULL, 'la-related protein 7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(62772, NULL, 'G3DSA:1.25.40.180:FF:000007', NULL, NULL, 'Eukaryotic translation initiation factor 4 gamma 2', NULL, NULL, NULL, NULL, NULL, 4),
(62773, NULL, 'G3DSA:1.20.1640.10:FF:000083', NULL, NULL, 'Trehalose monomycolate exporter MmpL3', NULL, NULL, NULL, NULL, NULL, 4),
(62774, NULL, 'G3DSA:3.40.640.10:FF:000105', NULL, NULL, 'Cysteine desulfurase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(62775, NULL, 'G3DSA:3.40.50.300:FF:002284', NULL, NULL, 'Rab family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(62776, NULL, 'G3DSA:1.25.10.10:FF:003141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62777, NULL, 'G3DSA:3.40.1170.10:FF:000001', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(62778, NULL, 'G3DSA:1.10.10.10:FF:000318', NULL, NULL, 'Transcriptional regulator, IclR family', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(62779, NULL, 'G3DSA:1.10.150.240:FF:000036', NULL, NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(62780, NULL, 'G3DSA:1.10.8.350:FF:000002', NULL, NULL, 'Lytic transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(62781, NULL, 'G3DSA:2.120.10.30:FF:000396', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62782, NULL, 'G3DSA:1.20.120.1220:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62783, NULL, 'G3DSA:1.10.510.10:FF:002589', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62784, NULL, 'G3DSA:2.60.40.10:FF:004739', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62785, NULL, 'G3DSA:3.15.30.10:FF:000001', NULL, NULL, 'Major capsid protein E', NULL, NULL, NULL, NULL, NULL, 4),
(62786, NULL, 'G3DSA:1.10.1450.10:FF:000087', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(62787, NULL, 'G3DSA:2.40.10.10:FF:000556', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62788, NULL, 'G3DSA:1.20.58.60:FF:000105', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(62789, NULL, 'G3DSA:3.30.950.30:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62790, NULL, 'G3DSA:3.30.40.10:FF:000534', NULL, NULL, 'Toutatis, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(62791, NULL, 'G3DSA:1.20.1250.20:FF:002074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62792, NULL, 'G3DSA:2.60.40.10:FF:002811', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(62793, NULL, 'G3DSA:2.130.10.10:FF:003520', NULL, NULL, 'Small nucleolar ribonucleoprotein complex subunit Dip2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(62794, NULL, 'G3DSA:3.90.190.10:FF:000441', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62795, NULL, 'G3DSA:1.10.630.10:FF:000613', NULL, NULL, 'Os03g0650200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(62796, NULL, 'G3DSA:1.10.10.990:FF:000001', NULL, NULL, 'RecBCD enzyme subunit RecC', NULL, NULL, NULL, NULL, NULL, 4),
(62797, NULL, 'G3DSA:1.10.10.10:FF:000537', NULL, NULL, 'HMG-Y-related protein A', NULL, NULL, NULL, NULL, NULL, 4),
(62798, NULL, 'G3DSA:3.30.70.330:FF:000966', NULL, NULL, 'Related to CWC2-involved in mRNA splicing', NULL, NULL, NULL, NULL, NULL, 4),
(62799, NULL, 'G3DSA:2.40.50.40:FF:000101', NULL, NULL, 'Chromodomain helicase DNA-binding protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(62800, NULL, 'G3DSA:3.40.50.12780:FF:000225', NULL, NULL, 'Pantothenate kinase subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(62801, NULL, 'G3DSA:1.10.10.60:FF:000979', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62802, NULL, 'G3DSA:1.20.1250.20:FF:000612', NULL, NULL, 'Peptide transporter 3', NULL, NULL, NULL, NULL, NULL, 4),
(62803, NULL, 'G3DSA:1.10.150.20:FF:000248', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(62804, NULL, 'G3DSA:3.40.50.2300:FF:000488', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(62805, NULL, 'G3DSA:3.90.190.10:FF:000093', NULL, NULL, 'Initiator tRNA phosphoribosyl transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(62806, NULL, 'G3DSA:2.10.110.10:FF:000149', NULL, NULL, 'FHL1 isoform 27', NULL, NULL, NULL, NULL, NULL, 4),
(62807, NULL, 'G3DSA:1.20.1070.10:FF:000842', NULL, NULL, 'G protein-coupled receptor EGL-6 isoform b', NULL, NULL, NULL, NULL, NULL, 4),
(62808, NULL, 'G3DSA:1.10.4160.10:FF:000032', NULL, NULL, 'Purine-cytosine permease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(62809, NULL, 'G3DSA:1.20.140.80:FF:000004', NULL, NULL, 'Transcription factor-like protein DPA', NULL, NULL, NULL, NULL, NULL, 4),
(62810, NULL, 'G3DSA:3.30.70.2460:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62811, NULL, 'G3DSA:2.40.50.140:FF:000851', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62812, NULL, 'G3DSA:3.30.1360.10:FF:000001', NULL, NULL, 'DNA-directed RNA polymerase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(62813, NULL, 'G3DSA:3.50.50.60:FF:001133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62814, NULL, 'G3DSA:1.40.20.10:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62815, NULL, 'G3DSA:3.80.10.10:FF:003711', NULL, NULL, 'Septation initiation network scaffold protein cdc11', NULL, NULL, NULL, NULL, NULL, 4),
(62816, NULL, 'G3DSA:2.130.10.10:FF:001614', NULL, NULL, 'WD repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(62817, NULL, 'G3DSA:2.30.30.100:FF:000028', NULL, NULL, 'N-alpha-acetyltransferase 38, NatC auxiliary subunit', NULL, NULL, NULL, NULL, NULL, 4),
(62818, NULL, 'G3DSA:1.20.58.1030:FF:000034', NULL, NULL, 'Chromosome 15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(62819, NULL, 'G3DSA:1.10.10.10:FF:000993', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(62820, NULL, 'G3DSA:2.60.40.10:FF:001518', NULL, NULL, 'Enterochelin esterase', NULL, NULL, NULL, NULL, NULL, 4),
(62821, NULL, 'G3DSA:3.90.70.80:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62822, NULL, 'G3DSA:1.20.1250.20:FF:001674', NULL, NULL, 'Protein NRT1/ PTR FAMILY 5.1', NULL, NULL, NULL, NULL, NULL, 4),
(62823, NULL, 'G3DSA:1.20.5.170:FF:000250', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62824, NULL, 'G3DSA:3.90.1600.10:FF:000012', NULL, NULL, 'DNA polymerase epsilon catalytic subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(62825, NULL, 'G3DSA:3.30.200.110:FF:000004', NULL, NULL, 'Ipk1, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(62826, NULL, 'G3DSA:1.10.3210.10:FF:000019', NULL, NULL, 'Probable GTP diphosphokinase CRSH, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(62827, NULL, 'G3DSA:1.10.12.10:FF:000036', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(62828, NULL, 'G3DSA:3.30.470.30:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62829, NULL, 'G3DSA:2.90.10.10:FF:000026', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(62830, NULL, 'G3DSA:3.10.660.10:FF:000017', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62831, NULL, 'G3DSA:1.10.10.440:FF:000084', NULL, NULL, 'YALI0D02827p', NULL, NULL, NULL, NULL, NULL, 4),
(62832, NULL, 'G3DSA:1.10.238.10:FF:000308', NULL, NULL, 'EF-hand domain family member B', NULL, NULL, NULL, NULL, NULL, 4),
(62833, NULL, 'G3DSA:3.55.50.30:FF:000001', NULL, NULL, 'Type III secretion system outer membrane pore InvG', NULL, NULL, NULL, NULL, NULL, 4),
(62834, NULL, 'G3DSA:3.40.50.12160:FF:000039', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62835, NULL, 'G3DSA:3.30.70.330:FF:001697', NULL, NULL, 'RNA Binding Motif protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(62836, NULL, 'G3DSA:2.60.40.10:FF:005110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62837, NULL, 'G3DSA:3.30.70.20:FF:000128', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62838, NULL, 'G3DSA:3.30.70.330:FF:002315', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62839, NULL, 'G3DSA:3.30.390.30:FF:000043', NULL, NULL, 'Mercuric reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(62840, NULL, 'G3DSA:2.60.40.10:FF:004492', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62841, NULL, 'G3DSA:2.60.200.20:FF:000232', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(62842, NULL, 'G3DSA:3.40.50.200:FF:000005', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 7', NULL, NULL, NULL, NULL, NULL, 4),
(62843, NULL, 'G3DSA:2.60.40.10:FF:001850', NULL, NULL, 'KETtiN (Drosophila actin-binding) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(62844, NULL, 'G3DSA:2.60.120.260:FF:000597', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62845, NULL, 'G3DSA:3.30.450.30:FF:000082', NULL, NULL, 'Profilin', NULL, NULL, NULL, NULL, NULL, 4),
(62846, NULL, 'G3DSA:3.40.50.10810:FF:000106', NULL, NULL, 'Probable global transcription activator SNF2L2', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(62847, NULL, 'G3DSA:1.20.1070.10:FF:001697', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62848, NULL, 'G3DSA:1.20.58.1030:FF:000028', NULL, NULL, 'DNA replication complex GINS protein SLD5', NULL, NULL, NULL, NULL, NULL, 4),
(62849, NULL, 'G3DSA:2.60.40.790:FF:000207', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62850, NULL, 'G3DSA:2.60.40.1360:FF:000016', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(62851, NULL, 'G3DSA:1.10.760.10:FF:000038', NULL, NULL, 'Cytochrome c6', NULL, NULL, NULL, NULL, NULL, 4),
(62852, NULL, 'G3DSA:3.70.10.10:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62853, NULL, 'G3DSA:1.10.101.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62854, NULL, 'G3DSA:2.60.120.590:FF:000016', NULL, NULL, 'Alkylated DNA repair protein alkB 8', NULL, NULL, NULL, NULL, NULL, 4),
(62855, NULL, 'G3DSA:2.60.40.10:FF:002362', NULL, NULL, 'CD4-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(62856, NULL, 'G3DSA:2.160.20.20:FF:000009', NULL, NULL, 'Protein CBG23155', NULL, NULL, NULL, NULL, NULL, 4),
(62857, NULL, 'G3DSA:2.60.120.290:FF:000027', NULL, NULL, 'Transmembrane serine protease 6', NULL, NULL, NULL, NULL, NULL, 4),
(62858, NULL, 'G3DSA:3.30.70.330:FF:000174', NULL, NULL, 'cold-inducible RNA-binding protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(62859, NULL, 'G3DSA:3.30.70.260:FF:000029', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(62860, NULL, 'G3DSA:2.160.20.10:FF:000113', NULL, NULL, 'Os01g0172900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(62861, NULL, 'G3DSA:3.40.50.2300:FF:001213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62862, NULL, 'G3DSA:1.25.40.280:FF:000020', NULL, NULL, 'Enhancer of Glp-One (Glp-1)', NULL, NULL, NULL, NULL, NULL, 4),
(62863, NULL, 'G3DSA:3.40.50.720:FF:001347', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(62864, NULL, 'G3DSA:1.20.58.2220:FF:000065', NULL, NULL, 'Formin-J', NULL, NULL, NULL, NULL, NULL, 4),
(62865, NULL, 'G3DSA:1.25.10.10:FF:002179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62866, NULL, 'G3DSA:2.60.40.1670:FF:000008', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(62867, NULL, 'G3DSA:1.20.1050.10:FF:000066', NULL, NULL, 'Gdap1, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(62868, NULL, 'G3DSA:3.40.50.620:FF:000575', NULL, NULL, 'FAD synthase', NULL, NULL, NULL, NULL, NULL, 4),
(62869, NULL, 'G3DSA:3.40.50.720:FF:000835', NULL, NULL, 'Putative hydroxyacid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(62870, NULL, 'G3DSA:2.70.20.10:FF:000022', NULL, NULL, 'DNA topoisomerase IA, putative', NULL, NULL, NULL, NULL, NULL, 4),
(62871, NULL, 'G3DSA:3.40.50.10810:FF:000095', NULL, NULL, 'Helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(62872, NULL, 'G3DSA:2.60.40.2030:FF:000015', NULL, NULL, 'FRAS1-related extracellular matrix protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(62873, NULL, 'G3DSA:3.30.360.10:FF:000097', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase 2 (Gapdh)(Nad(P)-dependent glyceraldehyde-3-phosphate dehydrogenase)', NULL, NULL, NULL, NULL, NULL, 4),
(62874, NULL, 'G3DSA:3.90.940.10:FF:000004', NULL, NULL, 'DNA-directed RNA polymerases I, II, and III subunit RPABC2', NULL, NULL, NULL, NULL, NULL, 4),
(62875, NULL, 'G3DSA:3.30.70.860:FF:000007', NULL, NULL, 'UPF0234 protein D6716_11750', NULL, NULL, NULL, NULL, NULL, 4),
(62876, NULL, 'G3DSA:3.30.70.1730:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62877, NULL, 'G3DSA:3.40.50.300:FF:005375', NULL, NULL, 'Protein CLP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(62878, NULL, 'G3DSA:3.60.130.10:FF:000028', NULL, NULL, 'WGS project CABT00000000 data, contig 2.12', NULL, NULL, NULL, NULL, NULL, 4),
(62879, NULL, 'G3DSA:2.60.120.200:FF:000057', NULL, NULL, 'Laminin subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(62880, NULL, 'G3DSA:3.30.160.60:FF:006066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(62881, NULL, 'G3DSA:2.10.25.10:FF:000625', NULL, NULL, 'Notch receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(62882, NULL, 'G3DSA:1.20.140.140:FF:000007', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62883, NULL, 'G3DSA:3.40.50.150:FF:001822', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62884, NULL, 'G3DSA:3.30.565.10:FF:000286', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(62885, NULL, 'G3DSA:1.10.510.10:FF:002471', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62886, NULL, 'G3DSA:2.30.30.140:FF:000012', NULL, NULL, 'AT-rich interactive domain-containing protein 4A', NULL, NULL, NULL, NULL, NULL, 4),
(62887, NULL, 'G3DSA:2.130.10.10:FF:003632', NULL, NULL, 'Small nuclear ribonucleoprotein prp4', NULL, NULL, NULL, NULL, NULL, 4),
(62888, NULL, 'G3DSA:2.130.10.10:FF:001502', NULL, NULL, 'Unplaced genomic scaffold supercont1.30, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(62889, NULL, 'G3DSA:3.40.50.300:FF:001901', NULL, NULL, 'U5 small nuclear ribonucleoprotein-specific protein', NULL, NULL, NULL, NULL, NULL, 4),
(62890, NULL, 'G3DSA:3.80.10.10:FF:003599', NULL, NULL, 'Plekhe1 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(62891, NULL, 'G3DSA:3.40.50.1980:FF:000122', NULL, NULL, 'Iron(III) dicitrate transport system permease protein FecB', NULL, NULL, NULL, NULL, NULL, 4),
(62892, NULL, 'G3DSA:3.40.190.10:FF:000452', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(62893, NULL, 'G3DSA:2.140.10.10:FF:000001', NULL, NULL, 'Quinoprotein glucose dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(62894, NULL, 'G3DSA:2.40.10.10:FF:000686', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62895, NULL, 'G3DSA:3.40.920.10:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62896, NULL, 'G3DSA:3.40.630.10:FF:000149', NULL, NULL, 'Aspartyl aminopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(62897, NULL, 'G3DSA:1.10.630.10:FF:000501', NULL, NULL, 'Probable cytochrome P450 T9E850', NULL, NULL, NULL, NULL, NULL, 4),
(62898, NULL, 'G3DSA:2.40.50.770:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62899, NULL, 'G3DSA:3.40.850.10:FF:000368', NULL, NULL, 'Myosin IHb', NULL, NULL, NULL, NULL, NULL, 4),
(62900, NULL, 'G3DSA:3.10.110.10:FF:000044', NULL, NULL, 'protein PEROXIN-4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(62901, NULL, 'G3DSA:3.40.50.720:FF:000150', NULL, NULL, 'UDP-glucuronic acid decarboxylase 6', NULL, NULL, NULL, NULL, NULL, 4),
(62902, NULL, 'G3DSA:1.25.40.10:FF:003423', NULL, NULL, 'Co-chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(62903, NULL, 'G3DSA:1.25.40.120:FF:000012', NULL, NULL, 'Protein prenyltransferase alpha subunit repeat containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(62904, NULL, 'G3DSA:3.40.50.150:FF:000294', NULL, NULL, 'O-methyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(62905, NULL, 'G3DSA:3.40.630.150:FF:000003', NULL, NULL, 'MaLonyl CoA Decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(62906, NULL, 'G3DSA:3.40.50.300:FF:003014', NULL, NULL, 'Protein CHROMATIN REMODELING 19 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(62907, NULL, 'G3DSA:3.60.21.10:FF:000472', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(62908, NULL, 'G3DSA:1.20.1540.10:FF:000024', NULL, NULL, 'Blast:Protein rhomboid', NULL, NULL, NULL, NULL, NULL, 4),
(62909, NULL, 'G3DSA:1.25.10.10:FF:000049', NULL, NULL, 'Engulfment and cell motility 1 (Ced-12 homolog)', NULL, NULL, NULL, NULL, NULL, 4),
(62910, NULL, 'G3DSA:1.10.472.10:FF:000228', NULL, NULL, 'D-type cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(62911, NULL, 'G3DSA:3.80.10.10:FF:002295', NULL, NULL, 'Leucine-rich repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(62912, NULL, 'G3DSA:1.20.910.10:FF:000037', NULL, NULL, 'Putative heme oxygenase 3', NULL, NULL, NULL, NULL, NULL, 4),
(62913, NULL, 'G3DSA:2.60.120.260:FF:000608', NULL, NULL, 'Ferritin/ribonucleotide reductase-like family protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(62914, NULL, 'G3DSA:2.60.40.10:FF:005009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62915, NULL, 'G3DSA:1.20.1250.20:FF:000269', NULL, NULL, 'Uncharacterized MFS-type transporter YfcJ', NULL, NULL, NULL, NULL, NULL, 4),
(62916, NULL, 'G3DSA:3.30.70.1390:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62917, NULL, 'G3DSA:1.10.510.10:FF:003994', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62918, NULL, 'G3DSA:3.10.580.10:FF:000197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62919, NULL, 'G3DSA:3.40.50.300:FF:007303', NULL, NULL, 'Dynein, axonemal, heavy chain 7', NULL, NULL, NULL, NULL, NULL, 4),
(62920, NULL, 'G3DSA:2.130.10.10:FF:001491', NULL, NULL, 'Paralyzed_flagella_protein_20', NULL, NULL, NULL, NULL, NULL, 4),
(62921, NULL, 'G3DSA:3.30.420.40:FF:000263', NULL, NULL, 'Type II pantothenate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(62922, NULL, 'G3DSA:1.20.120.140:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62923, NULL, 'G3DSA:3.30.200.20:FF:000960', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(62924, NULL, 'G3DSA:1.20.58.70:FF:000114', NULL, NULL, 'Syntaxin 2a', NULL, NULL, NULL, NULL, NULL, 4),
(62925, NULL, 'G3DSA:2.20.70.10:FF:000286', NULL, NULL, 'Neural cell expressed, developmentally down-regulated 4-like', NULL, NULL, NULL, NULL, NULL, 4),
(62926, NULL, 'G3DSA:2.60.120.290:FF:000140', NULL, NULL, 'Cubilin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(62927, NULL, 'G3DSA:3.30.160.60:FF:006173', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62928, NULL, 'G3DSA:1.10.1820.10:FF:000026', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(62929, NULL, 'G3DSA:3.30.70.2850:FF:000032', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(62930, NULL, 'G3DSA:3.80.10.10:FF:000165', NULL, NULL, 'Centrosomal protein of 97 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(62931, NULL, 'G3DSA:1.20.58.1780:FF:000005', NULL, NULL, 'Nuclear pore complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(62932, NULL, 'G3DSA:3.30.2230.10:FF:000008', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 11', NULL, NULL, NULL, NULL, NULL, 4),
(62933, NULL, 'G3DSA:1.20.1070.10:FF:001011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62934, NULL, 'G3DSA:1.10.10.60:FF:001148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62935, NULL, 'G3DSA:1.20.1070.10:FF:000393', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62936, NULL, 'G3DSA:1.10.630.10:FF:000720', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62937, NULL, 'G3DSA:1.25.40.10:FF:003530', NULL, NULL, 'Serine/threonine-protein kinase ATR-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(62938, NULL, 'G3DSA:1.10.238.10:FF:001146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62939, NULL, 'G3DSA:1.10.10.10:FF:000088', NULL, NULL, 'Forkhead box protein J3', NULL, NULL, NULL, NULL, NULL, 4),
(62940, NULL, 'G3DSA:2.10.25.10:FF:001244', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(62941, NULL, 'G3DSA:1.10.10.60:FF:000636', NULL, NULL, 'Protein CHROMATIN REMODELING 4', NULL, NULL, NULL, NULL, NULL, 4),
(62942, NULL, 'G3DSA:3.30.40.10:FF:000427', NULL, NULL, 'Non-structural maintenance of chromosomes element 1', NULL, NULL, NULL, NULL, NULL, 4),
(62943, NULL, 'G3DSA:3.80.10.10:FF:000041', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase ERECTA', NULL, NULL, NULL, NULL, NULL, 4),
(62944, NULL, 'G3DSA:2.120.10.30:FF:000165', NULL, NULL, 'RT02937p', NULL, NULL, NULL, NULL, NULL, 4),
(62945, NULL, 'G3DSA:3.30.160.60:FF:002575', NULL, NULL, 'Zinc finger protein 616', NULL, NULL, NULL, NULL, NULL, 4),
(62946, NULL, 'G3DSA:2.10.70.10:FF:000258', NULL, NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(62947, NULL, 'G3DSA:2.130.10.10:FF:000086', NULL, NULL, 'target of rapamycin complex subunit LST8', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(62948, NULL, 'G3DSA:2.60.40.10:FF:005796', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62949, NULL, 'G3DSA:2.60.40.10:FF:005902', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62950, NULL, 'G3DSA:2.30.42.10:FF:000434', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62951, NULL, 'G3DSA:3.30.457.50:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62952, NULL, 'G3DSA:3.30.559.70:FF:000003', NULL, NULL, 'Carnitine acetyl transferase FacC', NULL, NULL, NULL, NULL, NULL, 4),
(62953, NULL, 'G3DSA:1.20.1740.10:FF:000023', NULL, NULL, 'Amino acid permease', NULL, NULL, NULL, NULL, NULL, 4),
(62954, NULL, 'G3DSA:3.60.40.10:FF:000050', NULL, NULL, 'probable protein phosphatase 2C 4', NULL, NULL, NULL, NULL, NULL, 4),
(62955, NULL, 'G3DSA:3.40.50.1970:FF:000006', NULL, NULL, 'Probable multifunctional protein ADE2', NULL, NULL, NULL, NULL, NULL, 4),
(62956, NULL, 'G3DSA:3.40.30.10:FF:000735', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(62957, NULL, 'G3DSA:1.10.1600.10:FF:000032', NULL, NULL, 'DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(62958, NULL, 'G3DSA:1.25.10.10:FF:002977', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62959, NULL, 'G3DSA:1.10.238.10:FF:000640', NULL, NULL, 'Caltractin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(62960, NULL, 'G3DSA:3.40.50.720:FF:001454', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(62961, NULL, 'G3DSA:1.25.10.10:FF:002522', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62962, NULL, 'G3DSA:3.40.50.2000:FF:001005', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(62963, NULL, 'G3DSA:2.60.120.10:FF:000402', NULL, NULL, 'UDP-2-acetamido-2,6-beta-L-arabino-hexul-4-ose reductase', NULL, NULL, NULL, NULL, NULL, 4),
(62964, NULL, 'G3DSA:1.20.1560.10:FF:000037', NULL, NULL, 'ATP-binding cassette subfamily C member 10', NULL, NULL, NULL, NULL, NULL, 4),
(62965, NULL, 'G3DSA:1.20.1310.10:FF:000215', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62966, NULL, 'G3DSA:1.10.510.10:FF:001066', NULL, NULL, 'Probable serine/threonine-protein kinase irlE', NULL, NULL, NULL, NULL, NULL, 4),
(62967, NULL, 'G3DSA:3.90.80.10:FF:000011', NULL, NULL, 'Pyrophosphatase (inorganic) 1', NULL, NULL, NULL, NULL, NULL, 4),
(62968, NULL, 'G3DSA:3.30.420.40:FF:001100', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(62969, NULL, 'G3DSA:1.10.287.580:FF:000002', NULL, NULL, 'Serpin family E member 2', NULL, NULL, NULL, NULL, NULL, 4),
(62970, NULL, 'G3DSA:3.30.160.20:FF:000225', NULL, NULL, 'Double-stranded RNA-activated protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(62971, NULL, 'G3DSA:2.130.10.10:FF:004357', NULL, NULL, 'Anaphase-promoting complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(62972, NULL, 'G3DSA:1.20.120.420:FF:000003', NULL, NULL, 'Methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(62973, NULL, 'G3DSA:1.20.58.390:FF:000298', NULL, NULL, 'Hypothetical protein LOC100135106', NULL, NULL, NULL, NULL, NULL, 4),
(62974, NULL, 'G3DSA:1.10.510.10:FF:002690', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62975, NULL, 'G3DSA:3.40.50.720:FF:001566', NULL, NULL, 'Reticulon-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(62976, NULL, 'G3DSA:3.40.50.12780:FF:000118', NULL, NULL, 'Acetyl-coenzyme A synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(62977, NULL, 'G3DSA:3.30.40.10:FF:000303', NULL, NULL, 'Zinc finger CCCH domain-containing protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(62978, NULL, 'G3DSA:1.20.930.80:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62979, NULL, 'G3DSA:2.60.40.10:FF:001743', NULL, NULL, 'filamin-A isoform X8', NULL, NULL, NULL, NULL, NULL, 4),
(62980, NULL, 'G3DSA:3.40.50.300:FF:005268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62981, NULL, 'G3DSA:1.20.80.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(62982, NULL, 'G3DSA:3.20.20.80:FF:000481', NULL, NULL, 'Glycoside hydrolase superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(62983, NULL, 'G3DSA:3.30.160.60:FF:002699', NULL, NULL, 'Zinc finger protein 998', NULL, NULL, NULL, NULL, NULL, 4),
(62984, NULL, 'G3DSA:1.20.1560.10:FF:000930', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62985, NULL, 'G3DSA:1.10.10.1420:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62986, NULL, 'G3DSA:3.80.10.10:FF:001688', NULL, NULL, 'GM20660', NULL, NULL, NULL, NULL, NULL, 4),
(62987, NULL, 'G3DSA:1.10.510.10:FF:003090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(62988, NULL, 'G3DSA:2.30.30.1190:FF:000017', NULL, NULL, 'Zinc finger nuclease 2', NULL, NULL, NULL, NULL, NULL, 4),
(62989, NULL, 'G3DSA:2.60.40.60:FF:000656', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62990, NULL, 'G3DSA:1.10.150.50:FF:000010', NULL, NULL, 'Fli-1 proto-oncogene, ETS transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(62991, NULL, 'G3DSA:2.130.10.10:FF:002918', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(62992, NULL, 'G3DSA:3.60.20.10:FF:000048', NULL, NULL, 'Proteasome subunit alpha type-2', NULL, NULL, NULL, NULL, NULL, 4),
(62993, NULL, 'G3DSA:1.25.40.10:FF:002911', NULL, NULL, 'PsbB mRNA maturation factor Mbb1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(62994, NULL, 'G3DSA:1.10.40.30:FF:000028', NULL, NULL, 'Argininosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(62995, NULL, 'G3DSA:1.10.510.10:FF:001627', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(62996, NULL, 'G3DSA:1.10.10.60:FF:000075', NULL, NULL, 'LIM/homeobox protein Lhx1', NULL, NULL, NULL, NULL, NULL, 4),
(62997, NULL, 'G3DSA:3.30.505.10:FF:000075', NULL, NULL, 'SH2 domain containing 2A', NULL, NULL, NULL, NULL, NULL, 4),
(62998, NULL, 'G3DSA:2.130.10.10:FF:001159', NULL, NULL, 'SIR4-interacting protein SIF2', NULL, NULL, NULL, NULL, NULL, 4),
(62999, NULL, 'G3DSA:1.25.10.10:FF:003034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63000, NULL, 'G3DSA:3.30.50.10:FF:000017', NULL, NULL, 'Oxysterols receptor LXR-alpha isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(63001, NULL, 'G3DSA:3.20.20.150:FF:000011', NULL, NULL, 'Putative hydroxypyruvate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(63002, NULL, 'G3DSA:3.20.20.80:FF:000149', NULL, NULL, 'Chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(63003, NULL, 'G3DSA:3.40.50.880:FF:000057', NULL, NULL, 'Protein/nucleic acid deglycase DJ-1', NULL, NULL, NULL, NULL, NULL, 4),
(63004, NULL, 'G3DSA:3.40.50.150:FF:001710', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63005, NULL, 'G3DSA:3.30.160.60:FF:002120', NULL, NULL, 'Zinc finger protein 554', NULL, NULL, NULL, NULL, NULL, 4),
(63006, NULL, 'G3DSA:2.60.40.10:FF:005341', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63007, NULL, 'G3DSA:4.10.270.10:FF:000001', NULL, NULL, 'Myosin heavy chain, non-muscle', NULL, NULL, NULL, NULL, NULL, 4),
(63008, NULL, 'G3DSA:1.10.10.1400:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63009, NULL, 'G3DSA:2.60.40.60:FF:001056', NULL, NULL, 'Cadherin-4', NULL, NULL, NULL, NULL, NULL, 4),
(63010, NULL, 'G3DSA:3.40.50.11610:FF:000003', NULL, NULL, '2-oxoglutarate dehydrogenase, isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(63011, NULL, 'G3DSA:3.30.200.20:FF:002303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63012, NULL, 'G3DSA:1.20.1740.10:FF:000135', NULL, NULL, 'Amino acid permease', NULL, NULL, NULL, NULL, NULL, 4),
(63013, NULL, 'G3DSA:3.40.50.300:FF:006780', NULL, NULL, 'ATP-binding cassette, sub-family A (ABC1), member 2', NULL, NULL, NULL, NULL, NULL, 4),
(63014, NULL, 'G3DSA:1.20.1070.10:FF:000174', NULL, NULL, 'beta-3 adrenergic receptor', NULL, NULL, NULL, NULL, NULL, 4),
(63015, NULL, 'G3DSA:3.30.200.20:FF:001685', NULL, NULL, 'Pim-3 proto-oncogene, serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(63016, NULL, 'G3DSA:3.90.1150.10:FF:000483', NULL, NULL, 'Phosphoserine aminotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(63017, NULL, 'G3DSA:1.25.40.20:FF:001279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63018, NULL, 'G3DSA:1.10.150.110:FF:000014', NULL, NULL, 'DNA polymerase lambda subunit', NULL, NULL, NULL, NULL, NULL, 4),
(63019, NULL, 'G3DSA:3.10.400.20:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63020, NULL, 'G3DSA:1.25.40.10:FF:002018', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g13600', NULL, NULL, NULL, NULL, NULL, 4),
(63021, NULL, 'G3DSA:1.10.10.10:FF:001162', NULL, NULL, 'EmrB/QacA subfamily drug resistance transporter', NULL, NULL, NULL, NULL, NULL, 4),
(63022, NULL, 'G3DSA:3.90.1150.210:FF:000019', NULL, NULL, 'F-actin-capping protein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(63023, NULL, 'G3DSA:3.10.110.10:FF:000263', NULL, NULL, 'Ubiquitin-conjugating enzyme E2Z', NULL, NULL, NULL, NULL, NULL, 4),
(63024, NULL, 'G3DSA:3.30.160.60:FF:001283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63025, NULL, 'G3DSA:3.30.300.30:FF:000094', NULL, NULL, 'Nonribosomal peptide synthase Pes1', NULL, NULL, NULL, NULL, NULL, 4),
(63026, NULL, 'G3DSA:3.30.300.110:FF:000010', NULL, NULL, 'tRNA-dimethyltransferase protein', NULL, NULL, NULL, NULL, NULL, 4),
(63027, NULL, 'G3DSA:2.40.10.10:FF:000449', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63028, NULL, 'G3DSA:3.40.50.2300:FF:000595', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(63029, NULL, 'G3DSA:3.30.160.60:FF:005554', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63030, NULL, 'G3DSA:3.30.1050.10:FF:000005', NULL, NULL, 'hydroxysteroid dehydrogenase-like protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(63031, NULL, 'G3DSA:2.120.10.30:FF:000289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63032, NULL, 'G3DSA:3.30.160.60:FF:006285', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63033, NULL, 'G3DSA:1.25.10.10:FF:000268', NULL, NULL, 'tubulin-specific chaperone D', NULL, NULL, NULL, NULL, NULL, 4),
(63034, NULL, 'G3DSA:3.30.930.10:FF:000130', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(63035, NULL, 'G3DSA:1.10.472.10:FF:000116', NULL, NULL, 'Cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(63036, NULL, 'G3DSA:3.30.540.10:FF:000083', NULL, NULL, 'Inositol monophosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(63037, NULL, 'G3DSA:1.10.510.10:FF:002358', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63038, NULL, 'G3DSA:3.30.160.60:FF:003317', NULL, NULL, 'Zinc finger protein 322', NULL, NULL, NULL, NULL, NULL, 4),
(63039, NULL, 'G3DSA:3.40.1130.10:FF:000004', NULL, NULL, 'Acyl-phosphate glycerol 3-phosphate acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(63040, NULL, 'G3DSA:2.40.50.140:FF:000620', NULL, NULL, 'Protection of telomeres 1b protein', NULL, NULL, NULL, NULL, NULL, 4),
(63041, NULL, 'G3DSA:3.30.420.40:FF:000482', NULL, NULL, 'Heat shock 70 kDa protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(63042, NULL, 'G3DSA:1.20.1280.50:FF:000201', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(63043, NULL, 'G3DSA:2.170.270.10:FF:000139', NULL, NULL, 'PR domain zinc finger protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(63044, NULL, 'G3DSA:3.30.465.10:FF:000014', NULL, NULL, 'D-lactate dehydrogenase (Cytochrome), putative', NULL, NULL, NULL, NULL, NULL, 4),
(63045, NULL, 'G3DSA:3.30.70.330:FF:002097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63046, NULL, 'G3DSA:1.10.510.10:FF:004376', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63047, NULL, 'G3DSA:2.130.10.10:FF:002795', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63048, NULL, 'G3DSA:3.10.590.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63049, NULL, 'G3DSA:1.20.1420.30:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63050, NULL, 'G3DSA:3.30.40.10:FF:001607', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(63051, NULL, 'G3DSA:3.50.50.60:FF:001240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63052, NULL, 'G3DSA:2.130.10.10:FF:003071', NULL, NULL, 'WD domain', NULL, NULL, NULL, NULL, NULL, 4),
(63053, NULL, 'G3DSA:3.40.50.300:FF:003470', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(63054, NULL, 'G3DSA:3.40.50.300:FF:006448', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(63055, NULL, 'G3DSA:1.25.40.90:FF:000081', NULL, NULL, 'CID domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(63056, NULL, 'G3DSA:1.25.40.10:FF:004480', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63057, NULL, 'G3DSA:2.20.70.10:FF:000162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63058, NULL, 'G3DSA:3.40.50.300:FF:004318', NULL, NULL, 'Exopolysaccharide export protein', NULL, NULL, NULL, NULL, NULL, 4),
(63059, NULL, 'G3DSA:1.25.40.10:FF:002350', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(63060, NULL, 'G3DSA:3.30.870.10:FF:000198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63061, NULL, 'G3DSA:3.30.70.330:FF:002439', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63062, NULL, 'G3DSA:3.50.80.10:FF:000018', NULL, NULL, 'D-aminoacyl-tRNA deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(63063, NULL, 'G3DSA:2.60.40.10:FF:004380', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63064, NULL, 'G3DSA:1.20.1250.20:FF:000505', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(63065, NULL, 'G3DSA:3.40.50.1440:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63066, NULL, 'G3DSA:3.40.50.300:FF:007741', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63067, NULL, 'G3DSA:3.30.160.60:FF:000883', NULL, NULL, 'Zinc finger protein 142', NULL, NULL, NULL, NULL, NULL, 4),
(63068, NULL, 'G3DSA:3.30.70.3290:FF:000023', NULL, NULL, '6-deoxyerythronolide-B synthase EryA1, modules 1 and 2', NULL, NULL, NULL, NULL, NULL, 4),
(63069, NULL, 'G3DSA:3.90.290.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63070, NULL, 'G3DSA:3.40.525.10:FF:000023', NULL, NULL, 'Csr1p', NULL, NULL, NULL, NULL, NULL, 4),
(63071, NULL, 'G3DSA:3.30.710.10:FF:000366', NULL, NULL, 'Zinc finger and BTB domain-containing 25', NULL, NULL, NULL, NULL, NULL, 4),
(63072, NULL, 'G3DSA:3.30.200.20:FF:001342', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(63073, NULL, 'G3DSA:1.10.150.20:FF:000231', NULL, NULL, 'YALI0D12364p', NULL, NULL, NULL, NULL, NULL, 4),
(63074, NULL, 'G3DSA:2.30.30.140:FF:000231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63075, NULL, 'G3DSA:3.30.1240.10:FF:000054', NULL, NULL, 'Haloacid dehalogenase-like hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(63076, NULL, 'G3DSA:3.40.50.2300:FF:000831', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63077, NULL, 'G3DSA:1.20.58.1120:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63078, NULL, 'G3DSA:2.60.40.10:FF:003087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63079, NULL, 'G3DSA:2.10.25.10:FF:000064', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(63080, NULL, 'G3DSA:3.10.28.10:FF:000028', NULL, NULL, 'Laglidadg endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(63081, NULL, 'G3DSA:3.90.180.10:FF:000160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63082, NULL, 'G3DSA:3.30.200.20:FF:000049', NULL, NULL, 'cyclin-dependent kinase-like 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(63083, NULL, 'G3DSA:3.30.565.10:FF:000409', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63084, NULL, 'G3DSA:1.25.40.10:FF:001057', NULL, NULL, 'Vacuolar protein sorting-associated protein 41 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(63085, NULL, 'G3DSA:1.20.1250.20:FF:000163', NULL, NULL, 'Putative monocarboxylate transporter 13', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(63086, NULL, 'G3DSA:3.40.50.150:FF:000417', NULL, NULL, 'tRNA (Guanine(10)-N2)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(63087, NULL, 'G3DSA:4.10.240.10:FF:000162', NULL, NULL, 'YALI0C22990p', NULL, NULL, NULL, NULL, NULL, 4),
(63088, NULL, 'G3DSA:3.90.640.10:FF:000184', NULL, NULL, 'Actin-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(63089, NULL, 'G3DSA:3.40.50.300:FF:002177', NULL, NULL, 'DEAD/DEAH box helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(63090, NULL, 'G3DSA:3.40.50.10990:FF:000008', NULL, NULL, '3,4-dihydroxy-2-butanone 4-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(63091, NULL, 'G3DSA:3.40.50.300:FF:005611', NULL, NULL, 'RING finger-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(63092, NULL, 'G3DSA:3.50.7.10:FF:000070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63093, NULL, 'G3DSA:2.60.40.60:FF:000550', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63094, NULL, 'G3DSA:3.80.10.10:FF:001002', NULL, NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase IMK2', NULL, NULL, NULL, NULL, NULL, 4),
(63095, NULL, 'G3DSA:1.20.1070.10:FF:001915', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63096, NULL, 'G3DSA:1.10.220.30:FF:000009', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(63097, NULL, 'G3DSA:3.40.1160.10:FF:000051', NULL, NULL, 'Isopentenyl phosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(63098, NULL, 'G3DSA:1.50.10.10:FF:000081', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(63099, NULL, 'G3DSA:3.80.10.10:FF:001345', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(63100, NULL, 'G3DSA:3.90.780.10:FF:000014', NULL, NULL, 'YHR202W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(63101, NULL, 'G3DSA:1.20.58.400:FF:000026', NULL, NULL, 'Vesicle transport through interaction with t-SNAREs-like protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(63102, NULL, 'G3DSA:3.90.550.50:FF:000065', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(63103, NULL, 'G3DSA:3.90.70.10:FF:000308', NULL, NULL, 'Similar to ubiquitin C-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(63104, NULL, 'G3DSA:1.50.10.150:FF:000010', NULL, NULL, 'Tellurite resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(63105, NULL, 'G3DSA:1.25.40.10:FF:004727', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63106, NULL, 'G3DSA:3.40.50.11350:FF:000015', NULL, NULL, 'alpha-(1,6)-fucosyltransferase-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(63107, NULL, 'G3DSA:3.40.1190.20:FF:000224', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63108, NULL, 'G3DSA:3.80.10.10:FF:000726', NULL, NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(63109, NULL, 'G3DSA:3.10.20.70:FF:000012', NULL, NULL, 'Glutamine synthetase, type I', NULL, NULL, NULL, NULL, NULL, 4),
(63110, NULL, 'G3DSA:3.30.420.100:FF:000011', NULL, NULL, '60S ribosomal protein L5', NULL, NULL, NULL, NULL, NULL, 4),
(63111, NULL, 'G3DSA:3.40.50.11660:FF:000007', NULL, NULL, 'alpha-(1,3)-fucosyltransferase 6-like', NULL, NULL, NULL, NULL, NULL, 4),
(63112, NULL, 'G3DSA:1.10.238.10:FF:000185', NULL, NULL, 'Mitochondrial Rho GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(63113, NULL, 'G3DSA:3.30.70.330:FF:001478', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63114, NULL, 'G3DSA:1.20.58.1040:FF:000020', NULL, NULL, '1,3-beta-glucanosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(63115, NULL, 'G3DSA:3.60.21.10:FF:000359', NULL, NULL, '5'' nucleotidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(63116, NULL, 'G3DSA:3.30.710.10:FF:000023', NULL, NULL, 'Ectoderm-neural cortex protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(63117, NULL, 'G3DSA:1.10.10.10:FF:001049', NULL, NULL, 'Non-SMC element 1, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(63118, NULL, 'G3DSA:3.30.310.50:FF:000038', NULL, NULL, 'YALI0F21373p', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(63119, NULL, 'G3DSA:2.60.40.10:FF:002923', NULL, NULL, 'Granulocyte-macrophage colony-stimulating factor receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(63120, NULL, 'G3DSA:3.30.60.30:FF:000075', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(63121, NULL, 'G3DSA:3.30.1370.120:FF:000014', NULL, NULL, 'Type II secretion system protein', NULL, NULL, NULL, NULL, NULL, 4),
(63122, NULL, 'G3DSA:1.25.40.10:FF:000096', NULL, NULL, 'Tetratricopeptide repeat domain 28', NULL, NULL, NULL, NULL, NULL, 4),
(63123, NULL, 'G3DSA:1.20.120.1530:FF:000006', NULL, NULL, 'Atypical/HisK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(63124, NULL, 'G3DSA:3.30.40.10:FF:000646', NULL, NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(63125, NULL, 'G3DSA:2.30.36.70:FF:000010', NULL, NULL, 'Actin-related protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(63126, NULL, 'G3DSA:1.25.40.540:FF:000019', NULL, NULL, 'PP2A regulatory subunit TAP46', NULL, NULL, NULL, NULL, NULL, 4),
(63127, NULL, 'G3DSA:3.30.160.60:FF:003536', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63128, NULL, 'G3DSA:3.80.10.10:FF:003475', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(63129, NULL, 'G3DSA:3.50.50.60:FF:000621', NULL, NULL, '2-polyprenyl-6-methoxyphenol hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(63130, NULL, 'G3DSA:3.30.160.60:FF:001406', NULL, NULL, 'Zinc finger and BTB domain-containing protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(63131, NULL, 'G3DSA:2.130.10.10:FF:005212', NULL, NULL, 'ELongator complex Protein Component', NULL, NULL, NULL, NULL, NULL, 4),
(63132, NULL, 'G3DSA:1.10.8.10:FF:000121', NULL, NULL, 'Ancient ubiquitous protein', NULL, NULL, NULL, NULL, NULL, 4),
(63133, NULL, 'G3DSA:3.90.70.10:FF:000640', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(63134, NULL, 'G3DSA:1.25.40.20:FF:000554', NULL, NULL, 'Os08g0401100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(63135, NULL, 'G3DSA:1.10.287.110:FF:000238', NULL, NULL, 'Chaperone protein DNAj, putative', NULL, NULL, NULL, NULL, NULL, 4),
(63136, NULL, 'G3DSA:4.10.400.10:FF:000040', NULL, NULL, 'low-density lipoprotein receptor-related protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(63137, NULL, 'G3DSA:3.90.950.10:FF:000050', NULL, NULL, 'At2g25500', NULL, NULL, NULL, NULL, NULL, 4),
(63138, NULL, 'G3DSA:3.40.20.10:FF:000111', NULL, NULL, 'Protein tyrosine kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(63139, NULL, 'G3DSA:1.10.240.10:FF:000016', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(63140, NULL, 'G3DSA:2.60.40.10:FF:002468', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(63141, NULL, 'G3DSA:3.90.79.10:FF:000272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63142, NULL, 'G3DSA:2.30.30.40:FF:000308', NULL, NULL, 'Bud site selection protein', NULL, NULL, NULL, NULL, NULL, 4),
(63143, NULL, 'G3DSA:3.30.450.60:FF:000080', NULL, NULL, 'Adaptor-related protein complex 3 subunit sigma 2', NULL, NULL, NULL, NULL, NULL, 4),
(63144, NULL, 'G3DSA:1.10.20.10:FF:000038', NULL, NULL, 'dr1-associated corepressor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(63145, NULL, 'G3DSA:3.40.50.1360:FF:000043', NULL, NULL, '6-phosphogluconolactonase', NULL, NULL, NULL, NULL, NULL, 4),
(63146, NULL, 'G3DSA:2.130.10.10:FF:004936', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63147, NULL, 'G3DSA:1.20.140.150:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63148, NULL, 'G3DSA:3.10.20.90:FF:000675', NULL, NULL, 'UBX domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(63149, NULL, 'G3DSA:2.30.180.10:FF:000109', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63150, NULL, 'G3DSA:3.40.50.300:FF:004993', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63151, NULL, 'G3DSA:1.10.238.10:FF:000746', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(63152, NULL, 'G3DSA:2.40.128.20:FF:000051', NULL, NULL, 'Sll0497 protein', NULL, NULL, NULL, NULL, NULL, 4),
(63153, NULL, 'G3DSA:1.25.10.10:FF:000942', NULL, NULL, 'Nuclear transport receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(63154, NULL, 'G3DSA:3.80.10.10:FF:002306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63155, NULL, 'G3DSA:3.40.50.1000:FF:000862', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63156, NULL, 'G3DSA:2.130.10.10:FF:006049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63157, NULL, 'G3DSA:2.40.70.10:FF:000116', NULL, NULL, 'Cathepsin D', NULL, NULL, NULL, NULL, NULL, 4),
(63158, NULL, 'G3DSA:1.20.120.1750:FF:000055', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(63159, NULL, 'G3DSA:3.40.50.1820:FF:001844', NULL, NULL, 'Lypla1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(63160, NULL, 'G3DSA:3.40.50.2300:FF:000376', NULL, NULL, 'Response regulator BlpR', NULL, NULL, NULL, NULL, NULL, 4),
(63161, NULL, 'G3DSA:1.10.3720.10:FF:000215', NULL, NULL, 'Hydroxymethylpyrimidine ABC transporter, transmembrane component', NULL, NULL, NULL, NULL, NULL, 4),
(63162, NULL, 'G3DSA:3.30.70.270:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63163, NULL, 'G3DSA:3.40.50.720:FF:000274', NULL, NULL, 'SUMO-activating enzyme subunit 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(63164, NULL, 'G3DSA:1.10.8.60:FF:000107', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(63165, NULL, 'G3DSA:1.10.20.10:FF:000370', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63166, NULL, 'G3DSA:3.80.10.10:FF:004436', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(63167, NULL, 'G3DSA:1.25.40.20:FF:000897', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63168, NULL, 'G3DSA:1.10.238.10:FF:001022', NULL, NULL, 'Myosin regulatory light chain', NULL, NULL, NULL, NULL, NULL, 4),
(63169, NULL, 'G3DSA:1.25.10.10:FF:000381', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(63170, NULL, 'G3DSA:2.40.50.100:FF:000182', NULL, NULL, 'RND efflux system, membrane fusion protein CmeA', NULL, NULL, NULL, NULL, NULL, 4),
(63171, NULL, 'G3DSA:1.10.510.10:FF:000560', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(63172, NULL, 'G3DSA:3.80.10.10:FF:001906', NULL, NULL, 'Calmodulin-binding receptor kinase CaMRLK', NULL, NULL, NULL, NULL, NULL, 4),
(63173, NULL, 'G3DSA:2.130.10.10:FF:004251', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(63174, NULL, 'G3DSA:1.10.10.520:FF:000006', NULL, NULL, 'SUMO-activating enzyme subunit', NULL, NULL, NULL, NULL, NULL, 4),
(63175, NULL, 'G3DSA:2.40.50.140:FF:000963', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63176, NULL, 'G3DSA:3.90.226.10:FF:000278', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(63177, NULL, 'G3DSA:1.10.110.10:FF:000012', NULL, NULL, 'F23N19.16', NULL, NULL, NULL, NULL, NULL, 4),
(63178, NULL, 'G3DSA:1.10.420.10:FF:000002', NULL, NULL, 'Catalase-peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(63179, NULL, 'G3DSA:3.30.200.20:FF:000628', NULL, NULL, 'AGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(63180, NULL, 'G3DSA:2.100.10.30:FF:000003', NULL, NULL, 'OSJNBa0016N04.16-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(63181, NULL, 'G3DSA:3.90.105.10:FF:000025', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(63182, NULL, 'G3DSA:1.25.40.20:FF:001173', NULL, NULL, 'Transient receptor potential cation channel subfamily A member 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(63183, NULL, 'G3DSA:1.10.510.10:FF:003196', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63184, NULL, 'G3DSA:3.10.129.10:FF:000070', NULL, NULL, 'Acyl-CoA thioesterase II', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(63185, NULL, 'G3DSA:3.40.50.300:FF:002738', NULL, NULL, 'Putative ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(63186, NULL, 'G3DSA:1.10.390.10:FF:000004', NULL, NULL, 'Aminopeptidase N', NULL, NULL, NULL, NULL, NULL, 4),
(63187, NULL, 'G3DSA:3.90.740.10:FF:000017', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(63188, NULL, 'G3DSA:1.25.40.10:FF:000770', NULL, NULL, 'pentatricopeptide repeat-containing protein At5g39980, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(63189, NULL, 'G3DSA:1.10.1160.10:FF:000003', NULL, NULL, 'Glutamate--tRNA ligase 2', NULL, NULL, NULL, NULL, NULL, 4),
(63190, NULL, 'G3DSA:3.30.390.110:FF:000016', NULL, NULL, 'Protein MAK16 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(63191, NULL, 'G3DSA:3.40.50.300:FF:003138', NULL, NULL, 'DEAD-box helicase 5', NULL, NULL, NULL, NULL, NULL, 4),
(63192, NULL, 'G3DSA:3.30.40.10:FF:002321', NULL, NULL, 'BRCA1-associated RING domain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(63193, NULL, 'G3DSA:2.130.10.10:FF:003975', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63194, NULL, 'G3DSA:3.40.120.10:FF:000066', NULL, NULL, 'Putative phosphoglucosamine mutase protein', NULL, NULL, NULL, NULL, NULL, 4),
(63195, NULL, 'G3DSA:1.25.40.20:FF:001515', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63196, NULL, 'G3DSA:1.10.10.60:FF:000530', NULL, NULL, 'Sigma-54-dependent transcriptional response regulator PilR', NULL, NULL, NULL, NULL, NULL, 4),
(63197, NULL, 'G3DSA:3.40.50.12710:FF:000013', NULL, NULL, 'SAM-dependent methyltransferase, MidA family', NULL, NULL, NULL, NULL, NULL, 4),
(63198, NULL, 'G3DSA:2.40.100.10:FF:000052', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(63199, NULL, 'G3DSA:3.30.70.100:FF:000122', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63200, NULL, 'G3DSA:3.30.160.20:FF:000006', NULL, NULL, 'interleukin enhancer-binding factor 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(63201, NULL, 'G3DSA:3.30.1180.20:FF:000001', NULL, NULL, 'Dihydroxyacetone kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(63202, NULL, 'G3DSA:3.30.200.20:FF:000381', NULL, NULL, 'tribbles homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(63203, NULL, 'G3DSA:1.20.1250.10:FF:000047', NULL, NULL, 'Growth hormone d21', NULL, NULL, NULL, NULL, NULL, 4),
(63204, NULL, 'G3DSA:3.50.50.60:FF:000060', NULL, NULL, 'L-aspartate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(63205, NULL, 'G3DSA:2.30.30.40:FF:000527', NULL, NULL, 'Plectin', NULL, NULL, NULL, NULL, NULL, 4),
(63206, NULL, 'G3DSA:3.90.70.10:FF:000185', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(63207, NULL, 'G3DSA:3.40.50.300:FF:007409', NULL, NULL, 'ATP-binding cassette transporter, subfamily C, member 14, group MRP protein PpABCC14', NULL, NULL, NULL, NULL, NULL, 4),
(63208, NULL, 'G3DSA:3.40.50.300:FF:008028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63209, NULL, 'G3DSA:1.20.272.10:FF:000071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63210, NULL, 'G3DSA:3.30.565.10:FF:000180', NULL, NULL, 'Histidine kinase sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(63211, NULL, 'G3DSA:3.90.1290.10:FF:000083', NULL, NULL, 'Dystonin', NULL, NULL, NULL, NULL, NULL, 4),
(63212, NULL, 'G3DSA:3.40.50.11370:FF:000010', NULL, NULL, 'Inositol-tetrakisphosphate 1-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(63213, NULL, 'G3DSA:3.80.10.10:FF:004094', NULL, NULL, 'N-CAM Ig domain-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(63214, NULL, 'G3DSA:3.30.1010.10:FF:000008', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(63215, NULL, 'G3DSA:3.40.50.1820:FF:001283', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(63216, NULL, 'G3DSA:3.40.50.1820:FF:000664', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63217, NULL, 'G3DSA:2.40.50.120:FF:000064', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(63218, NULL, 'G3DSA:3.30.70.360:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63219, NULL, 'G3DSA:3.20.20.190:FF:000012', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(63220, NULL, 'G3DSA:1.10.30.10:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63221, NULL, 'G3DSA:2.20.100.10:FF:000152', NULL, NULL, 'SCO-spondin isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(63222, NULL, 'G3DSA:2.40.70.10:FF:000459', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63223, NULL, 'G3DSA:3.40.1090.10:FF:000056', NULL, NULL, 'Lysophospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(63224, NULL, 'G3DSA:3.30.160.60:FF:005116', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63225, NULL, 'G3DSA:1.20.58.390:FF:000192', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(63226, NULL, 'G3DSA:1.10.1370.30:FF:000042', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(63227, NULL, 'G3DSA:3.90.470.10:FF:000024', NULL, NULL, 'Ribosomal protein L22', NULL, NULL, NULL, NULL, NULL, 4),
(63228, NULL, 'G3DSA:3.40.50.20:FF:000048', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(63229, NULL, 'G3DSA:3.40.50.2000:FF:000623', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63230, NULL, 'G3DSA:1.25.40.20:FF:001734', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(63231, NULL, 'G3DSA:2.40.20.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63232, NULL, 'G3DSA:1.10.560.10:FF:000164', NULL, NULL, '60 kDa heat shock protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(63233, NULL, 'G3DSA:3.40.50.300:FF:008360', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63234, NULL, 'G3DSA:1.25.40.10:FF:000438', NULL, NULL, 'Zinc finger MYND-type containing 12', NULL, NULL, NULL, NULL, NULL, 4),
(63235, NULL, 'G3DSA:3.40.630.10:FF:000481', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63236, NULL, 'G3DSA:2.40.180.10:FF:000045', NULL, NULL, 'Catalase', NULL, NULL, NULL, NULL, NULL, 4),
(63237, NULL, 'G3DSA:1.10.510.10:FF:001521', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(63238, NULL, 'G3DSA:2.60.120.1030:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63239, NULL, 'G3DSA:1.10.1050.10:FF:000012', NULL, NULL, 'Ribosomal protein S4, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(63240, NULL, 'G3DSA:1.10.274.100:FF:000012', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(63241, NULL, 'G3DSA:3.30.160.60:FF:000445', NULL, NULL, 'Vascular endothelial zinc finger 1', NULL, NULL, NULL, NULL, NULL, 4),
(63242, NULL, 'G3DSA:3.30.70.3160:FF:000001', NULL, NULL, 'Probable tRNA pseudouridine synthase D', NULL, NULL, NULL, NULL, NULL, 4),
(63243, NULL, 'G3DSA:1.10.260.30:FF:000006', NULL, NULL, 'Signal recognition particle subunit SRP54', NULL, NULL, NULL, NULL, NULL, 4),
(63244, NULL, 'G3DSA:3.80.10.10:FF:000384', NULL, NULL, 'Nuclear RNA export factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(63245, NULL, 'G3DSA:3.40.630.30:FF:000487', NULL, NULL, 'GNAT family acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(63246, NULL, 'G3DSA:3.90.79.10:FF:000053', NULL, NULL, 'Coenzyme A diphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(63247, NULL, 'G3DSA:3.90.550.10:FF:000424', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(63248, NULL, 'G3DSA:2.30.42.10:FF:000198', NULL, NULL, 'E3 ubiquitin-protein ligase LNX isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(63249, NULL, 'G3DSA:3.40.50.1100:FF:000229', NULL, NULL, 'Cysteine synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(63250, NULL, 'G3DSA:3.40.50.300:FF:003357', NULL, NULL, 'Regulator of telomere elongation helicase 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(63251, NULL, 'G3DSA:3.40.50.1000:FF:000188', NULL, NULL, 'Trehalose-phosphatase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(63252, NULL, 'G3DSA:1.25.40.10:FF:004148', NULL, NULL, 'Probable mitochondrial import receptor subunit tom70', NULL, NULL, NULL, NULL, NULL, 4),
(63253, NULL, 'G3DSA:3.10.25.10:FF:000005', NULL, NULL, 'Methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(63254, NULL, 'G3DSA:2.60.120.200:FF:000618', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63255, NULL, 'G3DSA:3.40.30.10:FF:001117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63256, NULL, 'G3DSA:3.30.70.330:FF:002990', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63257, NULL, 'G3DSA:3.40.50.300:FF:004650', NULL, NULL, 'Helicase SEN1', NULL, NULL, NULL, NULL, NULL, 4),
(63258, NULL, 'G3DSA:3.30.160.60:FF:003879', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63259, NULL, 'G3DSA:3.100.10.10:FF:000027', NULL, NULL, '50S ribosomal protein L15', NULL, NULL, NULL, NULL, NULL, 4),
(63260, NULL, 'G3DSA:3.10.20.90:FF:000456', NULL, NULL, 'Rad60, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(63261, NULL, 'G3DSA:2.110.10.10:FF:000036', NULL, NULL, 'Matrix metalloproteinase 16', NULL, NULL, NULL, NULL, NULL, 4),
(63262, NULL, 'G3DSA:1.25.40.20:FF:000863', NULL, NULL, 'Ankyrin repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(63263, NULL, 'G3DSA:3.80.10.10:FF:001660', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(63264, NULL, 'G3DSA:1.20.1730.10:FF:000123', NULL, NULL, 'Putative symporter ywcA', NULL, NULL, NULL, NULL, NULL, 4),
(63265, NULL, 'G3DSA:2.40.37.10:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63266, NULL, 'G3DSA:2.130.10.10:FF:004335', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63267, NULL, 'G3DSA:3.40.50.2300:FF:000943', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63268, NULL, 'G3DSA:1.20.1070.10:FF:000415', NULL, NULL, 'Si:dkey-117a8.1', NULL, NULL, NULL, NULL, NULL, 4),
(63269, NULL, 'G3DSA:3.40.30.10:FF:000061', NULL, NULL, 'Fas associated factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(63270, NULL, 'G3DSA:3.40.50.300:FF:003060', NULL, NULL, 'Cytidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(63271, NULL, 'G3DSA:3.40.190.10:FF:000845', NULL, NULL, 'Gll3456 protein', NULL, NULL, NULL, NULL, NULL, 4),
(63272, NULL, 'G3DSA:1.25.10.10:FF:002477', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63273, NULL, 'G3DSA:2.60.40.10:FF:005346', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63274, NULL, 'G3DSA:1.50.10.20:FF:000151', NULL, NULL, 'Terpene cyclase/mutase family member', NULL, NULL, NULL, NULL, NULL, 4),
(63275, NULL, 'G3DSA:1.10.510.10:FF:003224', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63276, NULL, 'G3DSA:3.80.10.10:FF:003784', NULL, NULL, 'AGAP007451-PA', NULL, NULL, NULL, NULL, NULL, 4),
(63277, NULL, 'G3DSA:3.40.30.10:FF:001163', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(63278, NULL, 'G3DSA:1.10.600.10:FF:000117', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(63279, NULL, 'G3DSA:3.30.70.270:FF:000223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63280, NULL, 'G3DSA:1.10.238.10:FF:000983', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63281, NULL, 'G3DSA:3.40.367.20:FF:000040', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(63282, NULL, 'G3DSA:2.60.40.10:FF:003222', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63283, NULL, 'G3DSA:3.40.50.170:FF:000013', NULL, NULL, 'Phosphoribosylamine-glycine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(63284, NULL, 'G3DSA:3.20.20.80:FF:000020', NULL, NULL, 'Beta-glucosidase 12', NULL, NULL, NULL, NULL, NULL, 4),
(63285, NULL, 'G3DSA:3.40.50.300:FF:005184', NULL, NULL, 'ABC-transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(63286, NULL, 'G3DSA:2.40.10.200:FF:000001', NULL, NULL, 'Integrating conjugative element relaxase, PFGI-1 class', NULL, NULL, NULL, NULL, NULL, 4),
(63287, NULL, 'G3DSA:3.40.140.10:FF:000281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(63288, NULL, 'G3DSA:2.40.180.10:FF:000028', NULL, NULL, 'Catalase', NULL, NULL, NULL, NULL, NULL, 4),
(63289, NULL, 'G3DSA:3.40.50.2300:FF:001399', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63290, NULL, 'G3DSA:2.60.120.200:FF:000512', NULL, NULL, 'Glycosyl hydrolases family 16 protein', NULL, NULL, NULL, NULL, NULL, 4),
(63291, NULL, 'G3DSA:3.10.129.110:FF:000006', NULL, NULL, 'Aspergillus niger contig An11c0010, genomic contig', NULL, NULL, NULL, NULL, NULL, 4),
(63292, NULL, 'G3DSA:3.60.15.10:FF:000064', NULL, NULL, 'Probable 3'',5''-cyclic-nucleotide phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(63293, NULL, 'G3DSA:1.10.10.60:FF:000581', NULL, NULL, 'Homeobox protein six1a', NULL, NULL, NULL, NULL, NULL, 4),
(63294, NULL, 'G3DSA:1.20.140.150:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63295, NULL, 'G3DSA:2.30.180.10:FF:000199', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63296, NULL, 'G3DSA:3.50.50.60:FF:000357', NULL, NULL, 'Hydrogen cyanide synthase HcnC', NULL, NULL, NULL, NULL, NULL, 4),
(63297, NULL, 'G3DSA:3.30.70.1290:FF:000002', NULL, NULL, 'IS1004 transposase', NULL, NULL, NULL, NULL, NULL, 4),
(63298, NULL, 'G3DSA:1.20.58.1880:FF:000024', NULL, NULL, 'Protein CBR-SPR-1', NULL, NULL, NULL, NULL, NULL, 4),
(63299, NULL, 'G3DSA:2.130.10.30:FF:000013', NULL, NULL, 'Retinitis pigmentosa GTPase regulator isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(63300, NULL, 'G3DSA:1.10.10.10:FF:001223', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(63301, NULL, 'G3DSA:1.20.1070.10:FF:001876', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63302, NULL, 'G3DSA:2.60.40.10:FF:001131', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(63303, NULL, 'G3DSA:2.130.10.10:FF:003233', NULL, NULL, 'WD repeat-containing protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(63304, NULL, 'G3DSA:3.40.640.10:FF:000274', NULL, NULL, 'Taurine--pyruvate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(63305, NULL, 'G3DSA:1.10.8.270:FF:000080', NULL, NULL, 'Rab GTPase activating protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(63306, NULL, 'G3DSA:3.90.550.50:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63307, NULL, 'G3DSA:3.80.10.10:FF:002323', NULL, NULL, 'Leucine-rich repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(63308, NULL, 'G3DSA:2.40.10.10:FF:000450', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63309, NULL, 'G3DSA:3.40.1190.20:FF:000050', NULL, NULL, 'ketohexokinase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(63310, NULL, 'G3DSA:3.40.50.2300:FF:000297', NULL, NULL, 'Phosphate regulon transcriptional regulatory protein PhoB', NULL, NULL, NULL, NULL, NULL, 4),
(63311, NULL, 'G3DSA:4.10.60.10:FF:000028', NULL, NULL, 'Gag polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(63312, NULL, 'G3DSA:2.60.40.10:FF:004357', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63313, NULL, 'G3DSA:3.80.10.10:FF:004301', NULL, NULL, 'NACHT, LRR and PYD domains-containing protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(63314, NULL, 'G3DSA:2.60.40.10:FF:004683', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63315, NULL, 'G3DSA:1.10.510.10:FF:004359', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63316, NULL, 'G3DSA:3.40.1090.10:FF:000096', NULL, NULL, 'Lysophospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(63317, NULL, 'G3DSA:1.10.238.10:FF:001207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63318, NULL, 'G3DSA:3.30.40.10:FF:000820', NULL, NULL, 'TRIM49 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(63319, NULL, 'G3DSA:2.40.10.10:FF:000596', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63320, NULL, 'G3DSA:3.40.50.150:FF:000592', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 36a', NULL, NULL, NULL, NULL, NULL, 4),
(63321, NULL, 'G3DSA:3.50.50.60:FF:001459', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(63322, NULL, 'G3DSA:3.30.1490.100:FF:000001', NULL, NULL, 'DNA repair protein REV1', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(63323, NULL, 'G3DSA:2.170.270.10:FF:000218', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(63324, NULL, 'G3DSA:1.20.1250.20:FF:002080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63325, NULL, 'G3DSA:1.25.40.10:FF:002951', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(63326, NULL, 'G3DSA:3.90.480.10:FF:000008', NULL, NULL, 'Anaerobic sulfite reductase, subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(63327, NULL, 'G3DSA:1.25.40.10:FF:001523', NULL, NULL, 'Clustered mitochondria protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(63328, NULL, 'G3DSA:1.20.1560.10:FF:000323', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(63329, NULL, 'G3DSA:3.40.850.10:FF:000520', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63330, NULL, 'G3DSA:3.30.200.20:FF:000128', NULL, NULL, 'Serine/threonine-protein kinase ksg1', NULL, NULL, NULL, NULL, NULL, 4),
(63331, NULL, 'G3DSA:2.60.120.650:FF:000124', NULL, NULL, 'YALI0F28105p', NULL, NULL, NULL, NULL, NULL, 4),
(63332, NULL, 'G3DSA:3.90.70.10:FF:000746', NULL, NULL, 'Clan CA, family C1, cathepsin F-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(63333, NULL, 'G3DSA:2.60.40.150:FF:000465', NULL, NULL, 'PDZ/DHR/GLGF domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(63334, NULL, 'G3DSA:3.40.1410.10:FF:000020', NULL, NULL, 'Chorismate pyruvate-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(63335, NULL, 'G3DSA:2.160.20.10:FF:000293', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(63336, NULL, 'G3DSA:3.20.140.10:FF:000032', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(63337, NULL, 'G3DSA:1.10.150.170:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63338, NULL, 'G3DSA:1.20.1070.10:FF:000741', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(63339, NULL, 'G3DSA:1.10.1580.10:FF:000012', NULL, NULL, 'Nucleolar GTP-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(63340, NULL, 'G3DSA:2.60.120.260:FF:000423', NULL, NULL, 'Lipase/acylhydrolase, GDSL family', NULL, NULL, NULL, NULL, NULL, 4),
(63341, NULL, 'G3DSA:3.30.70.141:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63342, NULL, 'G3DSA:1.10.150.20:FF:000164', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(63343, NULL, 'G3DSA:3.30.230.10:FF:000306', NULL, NULL, 'U5 snRNP GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(63344, NULL, 'G3DSA:3.30.750.24:FF:000106', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(63345, NULL, 'G3DSA:3.30.200.20:FF:000807', NULL, NULL, 'Serine/threonine-protein kinase UCNL', NULL, NULL, NULL, NULL, NULL, 4),
(63346, NULL, 'G3DSA:1.25.40.20:FF:001526', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(63347, NULL, 'G3DSA:3.10.100.10:FF:000105', NULL, NULL, 'Lectin', NULL, NULL, NULL, NULL, NULL, 4),
(63348, NULL, 'G3DSA:1.25.40.10:FF:000860', NULL, NULL, 'Putative Heat shock protein STI', NULL, NULL, NULL, NULL, NULL, 4),
(63349, NULL, 'G3DSA:2.60.40.2810:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63350, NULL, 'G3DSA:1.10.1660.10:FF:000013', NULL, NULL, 'First ORF in transposon ISC1904', NULL, NULL, NULL, NULL, NULL, 4),
(63351, NULL, 'G3DSA:2.60.40.10:FF:002912', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63352, NULL, 'G3DSA:3.40.50.80:FF:000184', NULL, NULL, 'Frp1p', NULL, NULL, NULL, NULL, NULL, 4),
(63353, NULL, 'G3DSA:3.10.129.10:FF:000008', NULL, NULL, 'Acyl-CoA thioester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(63354, NULL, 'G3DSA:2.60.120.200:FF:000192', NULL, NULL, 'Crumbs, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(63355, NULL, 'G3DSA:1.20.1050.10:FF:000206', NULL, NULL, 'YALI0E03432p', NULL, NULL, NULL, NULL, NULL, 4),
(63356, NULL, 'G3DSA:3.40.190.10:FF:000519', NULL, NULL, 'Transferrin-a', NULL, NULL, NULL, NULL, NULL, 4),
(63357, NULL, 'G3DSA:1.10.10.60:FF:000288', NULL, NULL, 'Sex combs reduced', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(63358, NULL, 'G3DSA:4.10.1000.10:FF:000012', NULL, NULL, 'cleavage and polyadenylation specificity factor subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(63359, NULL, 'G3DSA:3.30.160.60:FF:000737', NULL, NULL, 'Zinc finger protein 565', NULL, NULL, NULL, NULL, NULL, 4),
(63360, NULL, 'G3DSA:3.30.1520.10:FF:000154', NULL, NULL, 'Sorting nexin 1', NULL, NULL, NULL, NULL, NULL, 4),
(63361, NULL, 'G3DSA:3.30.40.10:FF:002265', NULL, NULL, 'Putative postmeiotic segregation increased 2-like protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(63362, NULL, 'G3DSA:2.60.40.4060:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63363, NULL, 'G3DSA:3.40.50.720:FF:000223', NULL, NULL, 'Chlorophyll(Ide) b reductase NOL, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(63364, NULL, 'G3DSA:1.10.472.10:FF:000690', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63365, NULL, 'G3DSA:3.30.1300.30:FF:000003', NULL, NULL, 'General secretion pathway protein I', NULL, NULL, NULL, NULL, NULL, 4),
(63366, NULL, 'G3DSA:1.10.287.4280:FF:000001', NULL, NULL, 'transcription factor COE1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(63367, NULL, 'G3DSA:3.30.465.10:FF:000104', NULL, NULL, 'FAD linked oxidase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(63368, NULL, 'G3DSA:1.10.1390.10:FF:000003', NULL, NULL, 'Glucose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(63369, NULL, 'G3DSA:3.30.830.10:FF:000156', NULL, NULL, 'Insulinase family metalloprotease', NULL, NULL, NULL, NULL, NULL, 4),
(63370, NULL, 'G3DSA:1.25.40.180:FF:000260', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63371, NULL, 'G3DSA:3.40.50.620:FF:000491', NULL, NULL, 'Glutamine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(63372, NULL, 'G3DSA:1.10.1520.10:FF:000003', NULL, NULL, 'Drosha ribonuclease III', NULL, NULL, NULL, NULL, NULL, 4),
(63373, NULL, 'G3DSA:3.40.50.300:FF:005504', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63374, NULL, 'G3DSA:2.30.30.790:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63375, NULL, 'G3DSA:1.20.120.610:FF:000021', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(63376, NULL, 'G3DSA:3.80.10.10:FF:000406', NULL, NULL, 'Leucine-rich repeat (LRR) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(63377, NULL, 'G3DSA:1.20.120.350:FF:000100', NULL, NULL, 'Voltage-gated Ion Channel (VIC) Superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(63378, NULL, 'G3DSA:2.10.25.10:FF:000069', NULL, NULL, 'Laminin subunit alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(63379, NULL, 'G3DSA:2.70.70.10:FF:000036', NULL, NULL, 'Membrane-bound metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(63380, NULL, 'G3DSA:2.30.30.490:FF:000015', NULL, NULL, 'Chromatin structure-remodeling complex subunit RSC1', NULL, NULL, NULL, NULL, NULL, 4),
(63381, NULL, 'G3DSA:2.70.170.10:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63382, NULL, 'G3DSA:1.10.510.10:FF:002914', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63383, NULL, 'G3DSA:1.20.120.310:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63384, NULL, 'G3DSA:1.20.120.720:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63385, NULL, 'G3DSA:4.10.830.40:FF:000002', NULL, NULL, 'probable E3 ubiquitin-protein ligase MID2', NULL, NULL, NULL, NULL, NULL, 4),
(63386, NULL, 'G3DSA:1.20.91.20:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63387, NULL, 'G3DSA:3.40.50.300:FF:002924', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(63388, NULL, 'G3DSA:1.25.40.10:FF:000708', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(63389, NULL, 'G3DSA:2.40.50.100:FF:000165', NULL, NULL, 'Efflux pump, RND family, membrane fusion lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(63390, NULL, 'G3DSA:3.30.200.20:FF:000454', NULL, NULL, 'Leucine-rich repeat receptor-like tyrosine-protein kinase PXC3', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(63391, NULL, 'G3DSA:2.130.10.10:FF:004661', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63392, NULL, 'G3DSA:1.20.58.760:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63393, NULL, 'G3DSA:1.10.418.30:FF:000002', NULL, NULL, 'NDC80, kinetochore complex component', NULL, NULL, NULL, NULL, NULL, 4),
(63394, NULL, 'G3DSA:2.60.260.20:FF:000168', NULL, NULL, 'Chaperone protein DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(63395, NULL, 'G3DSA:3.30.390.110:FF:000005', NULL, NULL, '60S ribosomal protein L28', NULL, NULL, NULL, NULL, NULL, 4),
(63396, NULL, 'G3DSA:3.30.420.40:FF:000976', NULL, NULL, 'Protein CBG02160', NULL, NULL, NULL, NULL, NULL, 4),
(63397, NULL, 'G3DSA:2.130.10.10:FF:005150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63398, NULL, 'G3DSA:3.60.20.10:FF:000014', NULL, NULL, 'Proteasome subunit beta type-7', NULL, NULL, NULL, NULL, NULL, 4),
(63399, NULL, 'G3DSA:3.30.70.330:FF:000674', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(63400, NULL, 'G3DSA:1.25.10.10:FF:001016', NULL, NULL, 'Importin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(63401, NULL, 'G3DSA:1.25.40.10:FF:004749', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63402, NULL, 'G3DSA:3.40.630.10:FF:000037', NULL, NULL, 'Peptidase B', NULL, NULL, NULL, NULL, NULL, 4),
(63403, NULL, 'G3DSA:2.60.40.10:FF:003901', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63404, NULL, 'G3DSA:3.30.50.10:FF:000113', NULL, NULL, 'LD32549p', NULL, NULL, NULL, NULL, NULL, 4),
(63405, NULL, 'G3DSA:6.10.140.2220:FF:000017', NULL, NULL, 'Histone-lysine N-methyltransferase SMYD3', NULL, NULL, NULL, NULL, NULL, 4),
(63406, NULL, 'G3DSA:2.130.10.10:FF:000299', NULL, NULL, 'NACHT and WD repeat domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(63407, NULL, 'G3DSA:2.40.50.140:FF:000862', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63408, NULL, 'G3DSA:3.30.200.20:FF:002545', NULL, NULL, 'Serine/threonine-protein kinase ppk31', NULL, NULL, NULL, NULL, NULL, 4),
(63409, NULL, 'G3DSA:1.20.1250.20:FF:000342', NULL, NULL, 'Major facilitator superfamily domain-containing 8', NULL, NULL, NULL, NULL, NULL, 4),
(63410, NULL, 'G3DSA:3.30.428.10:FF:000018', NULL, NULL, 'Zinc finger CCCH domain-containing protein 59', NULL, NULL, NULL, NULL, NULL, 4),
(63411, NULL, 'G3DSA:2.60.40.60:FF:000196', NULL, NULL, 'Si:dkey-22o22.2', NULL, NULL, NULL, NULL, NULL, 4),
(63412, NULL, 'G3DSA:3.10.100.10:FF:000431', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63413, NULL, 'G3DSA:2.20.70.10:FF:000089', NULL, NULL, 'Blast:WW domain-containing adapter protein with coiled-coil', NULL, NULL, NULL, NULL, NULL, 4),
(63414, NULL, 'G3DSA:3.90.550.10:FF:000396', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(63415, NULL, 'G3DSA:3.40.50.300:FF:004195', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(63416, NULL, 'G3DSA:3.30.497.10:FF:000094', NULL, NULL, 'Serpin 7', NULL, NULL, NULL, NULL, NULL, 4),
(63417, NULL, 'G3DSA:3.30.70.360:FF:000071', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(63418, NULL, 'G3DSA:3.30.70.330:FF:001776', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63419, NULL, 'G3DSA:1.10.418.40:FF:000005', NULL, NULL, 'Autophagy protein Apg6, putative', NULL, NULL, NULL, NULL, NULL, 4),
(63420, NULL, 'G3DSA:1.25.10.10:FF:000706', NULL, NULL, 'Proteasome (Prosome, macropain) 26S subunit, non-ATPase, 5', NULL, NULL, NULL, NULL, NULL, 4),
(63421, NULL, 'G3DSA:1.10.472.10:FF:000425', NULL, NULL, 'Putative cyclin-A3-1', NULL, NULL, NULL, NULL, NULL, 4),
(63422, NULL, 'G3DSA:3.40.50.300:FF:000979', NULL, NULL, 'Ribose 1,5-bisphosphate phosphokinase PhnN', NULL, NULL, NULL, NULL, NULL, 4),
(63423, NULL, 'G3DSA:3.30.200.20:FF:001909', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63424, NULL, 'G3DSA:3.10.20.80:FF:000009', NULL, NULL, 'Translation initiation factor 3 (IF-3) family protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(63425, NULL, 'G3DSA:3.40.50.300:FF:006965', NULL, NULL, 'Uncharacterized protein racV', NULL, NULL, NULL, NULL, NULL, 4),
(63426, NULL, 'G3DSA:1.10.245.10:FF:000010', NULL, NULL, 'MDM4 isoform 5', NULL, NULL, NULL, NULL, NULL, 4),
(63427, NULL, 'G3DSA:3.40.50.720:FF:002314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63428, NULL, 'G3DSA:1.20.1250.20:FF:001944', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63429, NULL, 'G3DSA:3.40.50.2000:FF:000325', NULL, NULL, 'Digalactosyldiacylglycerol synthase 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(63430, NULL, 'G3DSA:3.30.70.330:FF:000056', NULL, NULL, 'epithelial splicing regulatory protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(63431, NULL, 'G3DSA:2.70.150.10:FF:000284', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(63432, NULL, 'G3DSA:3.90.70.80:FF:000014', NULL, NULL, 'Cysteine proteinases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(63433, NULL, 'G3DSA:3.10.20.70:FF:000006', NULL, NULL, 'Glutamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(63434, NULL, 'G3DSA:3.90.550.10:FF:000716', NULL, NULL, 'Putative transferase', NULL, NULL, NULL, NULL, NULL, 4),
(63435, NULL, 'G3DSA:3.30.413.10:FF:000024', NULL, NULL, 'Nitrite reductase', NULL, NULL, NULL, NULL, NULL, 4),
(63436, NULL, 'G3DSA:3.40.50.300:FF:006286', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(63437, NULL, 'G3DSA:1.10.3630.10:FF:000006', NULL, NULL, 'Golgi phosphoprotein 3-like', NULL, NULL, NULL, NULL, NULL, 4),
(63438, NULL, 'G3DSA:3.30.710.10:FF:000416', NULL, NULL, 'Ankyrin repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(63439, NULL, 'G3DSA:1.10.238.10:FF:001180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63440, NULL, 'G3DSA:2.60.120.430:FF:000030', NULL, NULL, 'Di-glucose binding protein with Kinesin motor domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(63441, NULL, 'G3DSA:2.10.25.10:FF:000541', NULL, NULL, 'Notch homolog 4, [Drosophila]', NULL, NULL, NULL, NULL, NULL, 4),
(63442, NULL, 'G3DSA:1.10.510.10:FF:001133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63443, NULL, 'G3DSA:3.30.420.40:FF:000297', NULL, NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(63444, NULL, 'G3DSA:1.20.1070.10:FF:000241', NULL, NULL, 'Hydroxycarboxylic acid receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(63445, NULL, 'G3DSA:1.20.1250.20:FF:002107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63446, NULL, 'G3DSA:1.25.40.10:FF:003440', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g12100, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(63447, NULL, 'G3DSA:1.10.510.10:FF:000644', NULL, NULL, 'Poly(A) specific ribonuclease subunit PAN3', NULL, NULL, NULL, NULL, NULL, 4),
(63448, NULL, 'G3DSA:1.20.200.10:FF:000017', NULL, NULL, 'argininosuccinate lyase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(63449, NULL, 'G3DSA:3.30.60.30:FF:000182', NULL, NULL, 'Kazal type serine peptidase inhibitor domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(63450, NULL, 'G3DSA:3.30.160.60:FF:003351', NULL, NULL, 'Regulator of sex limited protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(63451, NULL, 'G3DSA:3.40.50.300:FF:002896', NULL, NULL, 'ras-related protein RABA2a-like', NULL, NULL, NULL, NULL, NULL, 4),
(63452, NULL, 'G3DSA:3.40.1090.10:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63453, NULL, 'G3DSA:1.20.920.20:FF:000029', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(63454, NULL, 'G3DSA:3.40.220.10:FF:000017', NULL, NULL, 'ORF1a polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(63455, NULL, 'G3DSA:3.40.50.150:FF:000945', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63456, NULL, 'G3DSA:3.20.20.140:FF:000469', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(63457, NULL, 'G3DSA:2.130.10.10:FF:000945', NULL, NULL, 'Protein transport protein SEC31', NULL, NULL, NULL, NULL, NULL, 4),
(63458, NULL, 'G3DSA:2.10.25.140:FF:000006', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(63459, NULL, 'G3DSA:3.40.640.10:FF:000448', NULL, NULL, 'Alanine aminotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(63460, NULL, 'G3DSA:1.20.1560.10:FF:000262', NULL, NULL, 'Multidrug resistance protein pgp-1', NULL, NULL, NULL, NULL, NULL, 4),
(63461, NULL, 'G3DSA:3.40.50.300:FF:000041', NULL, NULL, 'Guanine nucleotide-binding protein G(I) subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(63462, NULL, 'G3DSA:2.60.120.20:FF:000012', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(63463, NULL, 'G3DSA:1.10.3520.10:FF:000003', NULL, NULL, 'glycolipid transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(63464, NULL, 'G3DSA:1.10.238.10:FF:001000', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63465, NULL, 'G3DSA:2.60.120.10:FF:000301', NULL, NULL, 'cGMP-dependent protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(63466, NULL, 'G3DSA:3.40.30.10:FF:000999', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63467, NULL, 'G3DSA:2.60.40.10:FF:002766', NULL, NULL, 'AGAP002708-PB', NULL, NULL, NULL, NULL, NULL, 4),
(63468, NULL, 'G3DSA:3.40.50.2000:FF:000297', NULL, NULL, 'G protein-coupled receptor', NULL, NULL, NULL, NULL, NULL, 4),
(63469, NULL, 'G3DSA:3.40.50.720:FF:000077', NULL, NULL, 'L-threonine 3-dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(63470, NULL, 'G3DSA:1.10.238.10:FF:000718', NULL, NULL, 'Cta3p', NULL, NULL, NULL, NULL, NULL, 4),
(63471, NULL, 'G3DSA:2.60.40.10:FF:001305', NULL, NULL, 'Cell adhesion molecule-related/down-regulated by oncogenes', NULL, NULL, NULL, NULL, NULL, 4),
(63472, NULL, 'G3DSA:3.40.50.620:FF:000811', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63473, NULL, 'G3DSA:3.40.50.300:FF:001322', NULL, NULL, 'Schlafen family member 11', NULL, NULL, NULL, NULL, NULL, 4),
(63474, NULL, 'G3DSA:3.40.630.30:FF:000369', NULL, NULL, 'AGAP006447-PA', NULL, NULL, NULL, NULL, NULL, 4),
(63475, NULL, 'G3DSA:3.80.10.10:FF:001188', NULL, NULL, 'F-box/LRR-repeat protein 15 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(63476, NULL, 'G3DSA:3.30.70.920:FF:000019', NULL, NULL, 'Transcriptional regulatory protein, asnC family', NULL, NULL, NULL, NULL, NULL, 4),
(63477, NULL, 'G3DSA:3.90.70.10:FF:000685', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63478, NULL, 'G3DSA:3.90.70.200:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63479, NULL, 'G3DSA:3.30.310.80:FF:000047', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(63480, NULL, 'G3DSA:3.90.70.10:FF:000393', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(63481, NULL, 'G3DSA:1.10.8.10:FF:000014', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(63482, NULL, 'G3DSA:3.40.630.10:FF:000363', NULL, NULL, 'Glutamate carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(63483, NULL, 'G3DSA:3.30.9.30:FF:000001', NULL, NULL, 'Probable FAD-dependent monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(63484, NULL, 'G3DSA:1.20.1070.10:FF:002040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63485, NULL, 'G3DSA:3.20.20.300:FF:000039', NULL, NULL, 'Putative beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(63486, NULL, 'G3DSA:3.40.50.300:FF:006639', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(63487, NULL, 'G3DSA:1.25.40.10:FF:000388', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(63488, NULL, 'G3DSA:1.10.196.10:FF:000002', NULL, NULL, 'Axin 1', NULL, NULL, NULL, NULL, NULL, 4),
(63489, NULL, 'G3DSA:2.170.140.10:FF:000006', NULL, NULL, 'Mucin related 89F, isoform B', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(63490, NULL, 'G3DSA:1.25.10.10:FF:000886', NULL, NULL, 'HEAT repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(63491, NULL, 'G3DSA:3.80.10.10:FF:004240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63492, NULL, 'G3DSA:3.30.450.20:FF:000500', NULL, NULL, 'PleD-like-protein', NULL, NULL, NULL, NULL, NULL, 4),
(63493, NULL, 'G3DSA:1.10.472.130:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63494, NULL, 'G3DSA:2.20.100.10:FF:000213', NULL, NULL, 'Thrombospondin type-1 domain-containing protein 7B', NULL, NULL, NULL, NULL, NULL, 4),
(63495, NULL, 'G3DSA:2.30.30.30:FF:000160', NULL, NULL, 'SPT5 homolog, DSIF elongation factor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(63496, NULL, 'G3DSA:3.40.50.11260:FF:000005', NULL, NULL, 'Heat shock protein 90', NULL, NULL, NULL, NULL, NULL, 4),
(63497, NULL, 'G3DSA:1.25.40.10:FF:004542', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63498, NULL, 'G3DSA:1.10.510.10:FF:002768', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63499, NULL, 'G3DSA:1.10.510.10:FF:001633', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(63500, NULL, 'G3DSA:3.30.160.60:FF:004778', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63501, NULL, 'G3DSA:2.60.40.420:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63502, NULL, 'G3DSA:3.80.10.10:FF:000086', NULL, NULL, 'F-box/LRR-repeat protein 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(63503, NULL, 'G3DSA:3.40.50.1700:FF:000010', NULL, NULL, 'Glycoside hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(63504, NULL, 'G3DSA:3.40.190.10:FF:000492', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(63505, NULL, 'G3DSA:3.40.50.2000:FF:000651', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(63506, NULL, 'G3DSA:2.60.40.10:FF:000288', NULL, NULL, 'target of Nesh-SH3 isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(63507, NULL, 'G3DSA:2.10.25.10:FF:001497', NULL, NULL, 'Faulty attraction, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(63508, NULL, 'G3DSA:3.30.505.10:FF:000159', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63509, NULL, 'G3DSA:1.20.1250.20:FF:001444', NULL, NULL, 'MFS multidrug transporter, putative (AFU_orthologue AFUA_3G14560)', NULL, NULL, NULL, NULL, NULL, 4),
(63510, NULL, 'G3DSA:3.40.50.300:FF:003121', NULL, NULL, 'Polyphosphate:AMP phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(63511, NULL, 'G3DSA:1.20.58.60:FF:000235', NULL, NULL, 'Spectrin repeat containing nuclear envelope protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(63512, NULL, 'G3DSA:2.60.40.60:FF:000696', NULL, NULL, 'Cadherin-4', NULL, NULL, NULL, NULL, NULL, 4),
(63513, NULL, 'G3DSA:2.40.30.10:FF:000187', NULL, NULL, 'Translation factor GUF1 homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(63514, NULL, 'G3DSA:3.30.70.330:FF:000702', NULL, NULL, 'Putative RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(63515, NULL, 'G3DSA:2.40.50.140:FF:000536', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(63516, NULL, 'G3DSA:2.40.50.90:FF:000021', NULL, NULL, 'putative ATP-dependent RNA helicase TDRD12', NULL, NULL, NULL, NULL, NULL, 4),
(63517, NULL, 'G3DSA:1.20.120.330:FF:000027', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(63518, NULL, 'G3DSA:2.10.25.10:FF:000215', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(63519, NULL, 'G3DSA:3.30.1360.40:FF:000015', NULL, NULL, 'Ribosome-recycling factor', NULL, NULL, NULL, NULL, NULL, 4),
(63520, NULL, 'G3DSA:1.20.58.1610:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63521, NULL, 'G3DSA:2.30.42.10:FF:000136', NULL, NULL, 'Caspase recruitment domain family member 11', NULL, NULL, NULL, NULL, NULL, 4),
(63522, NULL, 'G3DSA:1.10.10.60:FF:000934', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63523, NULL, 'G3DSA:3.40.50.150:FF:000799', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(63524, NULL, 'G3DSA:3.40.50.1820:FF:001389', NULL, NULL, 'FAM172 family protein homolog Y75B8A.31', NULL, NULL, NULL, NULL, NULL, 4),
(63525, NULL, 'G3DSA:2.60.40.150:FF:000639', NULL, NULL, 'Meiotically up-regulated gene 190 protein', NULL, NULL, NULL, NULL, NULL, 4),
(63526, NULL, 'G3DSA:1.25.10.10:FF:003320', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(63527, NULL, 'G3DSA:3.30.500.40:FF:000005', NULL, NULL, 'A kinase anchor protein', NULL, NULL, NULL, NULL, NULL, 4),
(63528, NULL, 'G3DSA:3.40.50.300:FF:001143', NULL, NULL, 'Dynein axonemal heavy chain 6', NULL, NULL, NULL, NULL, NULL, 4),
(63529, NULL, 'G3DSA:1.10.10.10:FF:000408', NULL, NULL, 'AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(63530, NULL, 'G3DSA:1.20.1250.20:FF:000842', NULL, NULL, 'Putative efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(63531, NULL, 'G3DSA:3.30.54.20:FF:000001', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(63532, NULL, 'G3DSA:3.40.50.80:FF:000212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63533, NULL, 'G3DSA:3.90.70.10:FF:000067', NULL, NULL, 'Senescence-specific cysteine protease', NULL, NULL, NULL, NULL, NULL, 4),
(63534, NULL, 'G3DSA:3.40.50.10190:FF:000206', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(63535, NULL, 'G3DSA:1.10.150.50:FF:000240', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(63536, NULL, 'G3DSA:1.10.238.10:FF:000483', NULL, NULL, 'Probable calcium-binding protein CML9', NULL, NULL, NULL, NULL, NULL, 4),
(63537, NULL, 'G3DSA:3.40.850.10:FF:000492', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(63538, NULL, 'G3DSA:3.40.50.620:FF:000165', NULL, NULL, 'Phosphoadenosine phosphosulfate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(63539, NULL, 'G3DSA:3.80.10.10:FF:003958', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63540, NULL, 'G3DSA:2.40.30.10:FF:000479', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63541, NULL, 'G3DSA:2.60.40.1170:FF:000038', NULL, NULL, 'AP-4 complex subunit mu,putative', NULL, NULL, NULL, NULL, NULL, 4),
(63542, NULL, 'G3DSA:1.20.1070.10:FF:001197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63543, NULL, 'G3DSA:1.25.40.10:FF:004396', NULL, NULL, 'TPR repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(63544, NULL, 'G3DSA:3.40.640.10:FF:000420', NULL, NULL, 'Serine hydroxymethyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(63545, NULL, 'G3DSA:1.25.10.10:FF:001403', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(63546, NULL, 'G3DSA:3.60.21.10:FF:000298', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(63547, NULL, 'G3DSA:1.10.620.20:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63548, NULL, 'G3DSA:2.30.30.10:FF:000002', NULL, NULL, 'Endogenous retrovirus group K member 6 Pol protein', NULL, NULL, NULL, NULL, NULL, 4),
(63549, NULL, 'G3DSA:1.10.510.10:FF:000970', NULL, NULL, 'Discs overgrown, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(63550, NULL, 'G3DSA:3.30.230.70:FF:000156', NULL, NULL, 'Exosome complex exonuclease RRP46-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(63551, NULL, 'G3DSA:3.40.50.300:FF:005330', NULL, NULL, 'ATPases and helicase subunits involved in DNA replication', NULL, NULL, NULL, NULL, NULL, 4),
(63552, NULL, 'G3DSA:3.30.40.10:FF:000141', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(63553, NULL, 'G3DSA:1.10.418.10:FF:000137', NULL, NULL, 'PLS3 isoform 7', NULL, NULL, NULL, NULL, NULL, 4),
(63554, NULL, 'G3DSA:3.20.20.80:FF:000166', NULL, NULL, 'Exo-beta-D-glucosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(63555, NULL, 'G3DSA:3.50.50.60:FF:000296', NULL, NULL, 'Salicylate hydroxylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(63556, NULL, 'G3DSA:3.30.450.70:FF:000021', NULL, NULL, 'YEL048C-like protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(63557, NULL, 'G3DSA:1.20.1280.50:FF:000179', NULL, NULL, 'F-box-like, putative', NULL, NULL, NULL, NULL, NULL, 4),
(63558, NULL, 'G3DSA:2.30.130.40:FF:000031', NULL, NULL, 'Lon protease homolog', NULL, NULL, NULL, NULL, NULL, 4),
(63559, NULL, 'G3DSA:3.30.70.330:FF:002473', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63560, NULL, 'G3DSA:2.60.200.40:FF:000024', NULL, NULL, 'Sphingosine kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(63561, NULL, 'G3DSA:2.100.10.50:FF:000003', NULL, NULL, 'Multivesicular body subunit 12A', NULL, NULL, NULL, NULL, NULL, 4),
(63562, NULL, 'G3DSA:1.20.1070.10:FF:000095', NULL, NULL, 'G-protein coupled receptor 26', NULL, NULL, NULL, NULL, NULL, 4),
(63563, NULL, 'G3DSA:3.60.160.10:FF:000002', NULL, NULL, 'BnaA02g25390D protein', NULL, NULL, NULL, NULL, NULL, 4),
(63564, NULL, 'G3DSA:3.10.20.90:FF:000956', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63565, NULL, 'G3DSA:3.40.1640.10:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63566, NULL, 'G3DSA:1.20.1050.10:FF:000032', NULL, NULL, 'Eukaryotic translation elongation factor 1 epsilon-1', NULL, NULL, NULL, NULL, NULL, 4),
(63567, NULL, 'G3DSA:3.40.50.1820:FF:000900', NULL, NULL, 'Yolk polypeptide 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(63568, NULL, 'G3DSA:3.30.200.20:FF:000746', NULL, NULL, 'Cyclin-dependent kinase-like 5', NULL, NULL, NULL, NULL, NULL, 4),
(63569, NULL, 'G3DSA:1.10.3380.30:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63570, NULL, 'G3DSA:3.30.230.10:FF:000245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63571, NULL, 'G3DSA:1.25.40.420:FF:000023', NULL, NULL, 'BTB-POZ and math domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(63572, NULL, 'G3DSA:1.10.3130.10:FF:000013', NULL, NULL, 'Serine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(63573, NULL, 'G3DSA:3.30.160.60:FF:003025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63574, NULL, 'G3DSA:1.20.1110.10:FF:000003', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(63575, NULL, 'G3DSA:3.60.40.10:FF:000162', NULL, NULL, 'Protein serine/threonine phosphatase 2C', NULL, NULL, NULL, NULL, NULL, 4),
(63576, NULL, 'G3DSA:1.20.1540.10:FF:000053', NULL, NULL, 'Rhomboid family protein', NULL, NULL, NULL, NULL, NULL, 4),
(63577, NULL, 'G3DSA:2.130.10.10:FF:002098', NULL, NULL, 'MGC78960 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(63578, NULL, 'G3DSA:3.40.50.1440:FF:000056', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(63579, NULL, 'G3DSA:3.30.470.20:FF:000029', NULL, NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(63580, NULL, 'G3DSA:3.40.50.2300:FF:001106', NULL, NULL, 'Extracellular calcium-sensing receptor', NULL, NULL, NULL, NULL, NULL, 4),
(63581, NULL, 'G3DSA:1.20.5.190:FF:000093', NULL, NULL, 'Abnormal spindle microtubule assembly', NULL, NULL, NULL, NULL, NULL, 4),
(63582, NULL, 'G3DSA:3.40.50.300:FF:004841', NULL, NULL, 'Replication factor C subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(63583, NULL, 'G3DSA:3.80.10.10:FF:000232', NULL, NULL, 'Si:dkey-16p6.1', NULL, NULL, NULL, NULL, NULL, 4),
(63584, NULL, 'G3DSA:3.30.530.20:FF:000147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63585, NULL, 'G3DSA:3.30.559.10:FF:000081', NULL, NULL, 'Aspergillus niger contig An11c0010, genomic contig', NULL, NULL, NULL, NULL, NULL, 4),
(63586, NULL, 'G3DSA:3.30.450.20:FF:000146', NULL, NULL, 'PAS domain S-box protein', NULL, NULL, NULL, NULL, NULL, 4),
(63587, NULL, 'G3DSA:3.50.7.10:FF:000093', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63588, NULL, 'G3DSA:3.10.110.10:FF:000342', NULL, NULL, 'Ubiquitin-conjugating enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(63589, NULL, 'G3DSA:1.25.40.430:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63590, NULL, 'G3DSA:3.30.70.1590:FF:000002', NULL, NULL, 'unconventional myosin-VI isoform X1', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(63591, NULL, 'G3DSA:3.20.20.100:FF:000131', NULL, NULL, 'NADP(+) coupled glycerol dehydrogenase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(63592, NULL, 'G3DSA:2.130.10.10:FF:004835', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63593, NULL, 'G3DSA:2.60.40.10:FF:004711', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63594, NULL, 'G3DSA:1.25.40.10:FF:003114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63595, NULL, 'G3DSA:1.20.58.2140:FF:000001', NULL, NULL, 'Haloacid dehalogenase', NULL, NULL, NULL, NULL, NULL, 4),
(63596, NULL, 'G3DSA:2.120.10.80:FF:000354', NULL, NULL, 'Multiple EGF like domains 8', NULL, NULL, NULL, NULL, NULL, 4),
(63597, NULL, 'G3DSA:3.50.50.60:FF:000650', NULL, NULL, 'Styrene monooxygenase StyA', NULL, NULL, NULL, NULL, NULL, 4),
(63598, NULL, 'G3DSA:3.30.70.3030:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63599, NULL, 'G3DSA:1.10.8.100:FF:000017', NULL, NULL, 'Probable ribosomal RNA small subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(63600, NULL, 'G3DSA:2.60.40.150:FF:000791', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(63601, NULL, 'G3DSA:3.80.10.10:FF:003397', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63602, NULL, 'G3DSA:3.40.50.2300:FF:000617', NULL, NULL, 'Sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(63603, NULL, 'G3DSA:2.60.40.10:FF:005200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63604, NULL, 'G3DSA:3.40.50.12230:FF:000015', NULL, NULL, 'YALI0F06820p', NULL, NULL, NULL, NULL, NULL, 4),
(63605, NULL, 'G3DSA:2.40.70.10:FF:000307', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63606, NULL, 'G3DSA:2.20.28.200:FF:000001', NULL, NULL, 'NAD-dependent protein deacetylase sirtuin-6', NULL, NULL, NULL, NULL, NULL, 4),
(63607, NULL, 'G3DSA:1.25.40.10:FF:002625', NULL, NULL, 'Transcription Factor ThreeC subunit (GTF3C homolog)', NULL, NULL, NULL, NULL, NULL, 4),
(63608, NULL, 'G3DSA:3.40.50.11660:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63609, NULL, 'G3DSA:1.10.472.10:FF:000717', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63610, NULL, 'G3DSA:1.20.1250.20:FF:000516', NULL, NULL, 'Alternative sulfate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(63611, NULL, 'G3DSA:2.20.70.10:FF:000117', NULL, NULL, 'Pre-mRNA-processing protein 40B', NULL, NULL, NULL, NULL, NULL, 4),
(63612, NULL, 'G3DSA:1.20.1280.20:FF:000018', NULL, NULL, 'Chaperone protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(63613, NULL, 'G3DSA:2.130.10.10:FF:005324', NULL, NULL, 'Periodic tryptophan protein 2 homolog-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(63614, NULL, 'G3DSA:3.40.225.10:FF:000039', NULL, NULL, 'Putative hu li tai shao', NULL, NULL, NULL, NULL, NULL, 4),
(63615, NULL, 'G3DSA:1.20.1560.10:FF:000823', NULL, NULL, 'AGAP001777-PA', NULL, NULL, NULL, NULL, NULL, 4),
(63616, NULL, 'G3DSA:3.50.50.60:FF:000857', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(63617, NULL, 'G3DSA:3.40.1390.30:FF:000001', NULL, NULL, 'GTP cyclohydrolase 1 type 2', NULL, NULL, NULL, NULL, NULL, 4),
(63618, NULL, 'G3DSA:3.10.20.90:FF:000338', NULL, NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(63619, NULL, 'G3DSA:3.30.70.330:FF:000348', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase E', NULL, NULL, NULL, NULL, NULL, 4),
(63620, NULL, 'G3DSA:3.30.710.10:FF:000181', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(63621, NULL, 'G3DSA:3.40.190.10:FF:000166', NULL, NULL, 'Nitrate ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(63622, NULL, 'G3DSA:3.30.559.30:FF:000087', NULL, NULL, 'Nonribosomal peptide synthase, putative (JCVI)', NULL, NULL, NULL, NULL, NULL, 4),
(63623, NULL, 'G3DSA:3.40.850.10:FF:000166', NULL, NULL, 'Kinesin family member 21B', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(63624, NULL, 'G3DSA:1.10.287.70:FF:000321', NULL, NULL, 'Voltage-dependent calcium channel subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(63625, NULL, 'G3DSA:1.25.40.20:FF:001852', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63626, NULL, 'G3DSA:3.30.1010.10:FF:000037', NULL, NULL, 'MEC1p protein', NULL, NULL, NULL, NULL, NULL, 4),
(63627, NULL, 'G3DSA:1.10.357.10:FF:000028', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(63628, NULL, 'G3DSA:1.20.1250.20:FF:001770', NULL, NULL, 'Putative inorganic phosphate cotransporter-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(63629, NULL, 'G3DSA:3.40.50.300:FF:002278', NULL, NULL, 'Ras like without CAAX 2', NULL, NULL, NULL, NULL, NULL, 4),
(63630, NULL, 'G3DSA:1.20.900.10:FF:000110', NULL, NULL, 'GH01987p', NULL, NULL, NULL, NULL, NULL, 4),
(63631, NULL, 'G3DSA:1.10.3460.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63632, NULL, 'G3DSA:1.10.630.10:FF:000271', NULL, NULL, 'Cytochrome P450 monooxygenase PikC', NULL, NULL, NULL, NULL, NULL, 4),
(63633, NULL, 'G3DSA:3.30.40.10:FF:000348', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(63634, NULL, 'G3DSA:3.40.50.2000:FF:000090', NULL, NULL, 'Starch synthase, chloroplastic/amyloplastic', NULL, NULL, NULL, NULL, NULL, 4),
(63635, NULL, 'G3DSA:2.60.40.1360:FF:000005', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(63636, NULL, 'G3DSA:3.40.50.150:FF:000619', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63637, NULL, 'G3DSA:1.25.10.10:FF:002505', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63638, NULL, 'G3DSA:1.20.80.10:FF:000013', NULL, NULL, 'Unconventional myosin-VIIa', NULL, NULL, NULL, NULL, NULL, 4),
(63639, NULL, 'G3DSA:3.60.10.10:FF:000042', NULL, NULL, 'DNA-(apurinic or apyrimidinic site) lyase', NULL, NULL, NULL, NULL, NULL, 4),
(63640, NULL, 'G3DSA:1.10.510.10:FF:002561', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(63641, NULL, 'G3DSA:3.30.70.1050:FF:000014', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(63642, NULL, 'G3DSA:1.10.510.10:FF:001307', NULL, NULL, 'Protein NSP-INTERACTING KINASE 2', NULL, NULL, NULL, NULL, NULL, 4),
(63643, NULL, 'G3DSA:3.40.20.10:FF:000116', NULL, NULL, 'Coactosin like F-actin binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(63644, NULL, 'G3DSA:2.30.29.30:FF:000622', NULL, NULL, 'WGS project CABT00000000 data, contig 2.5', NULL, NULL, NULL, NULL, NULL, 4),
(63645, NULL, 'G3DSA:1.10.437.10:FF:000001', NULL, NULL, 'Bcl-2-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(63646, NULL, 'G3DSA:3.40.50.460:FF:000010', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(63647, NULL, 'G3DSA:1.10.3380.10:FF:000031', NULL, NULL, 'DNaJ domain (Prokaryotic heat shock protein)', NULL, NULL, NULL, NULL, NULL, 4),
(63648, NULL, 'G3DSA:2.40.170.20:FF:000059', NULL, NULL, 'Ferric siderophore receptor protein', NULL, NULL, NULL, NULL, NULL, 4),
(63649, NULL, 'G3DSA:1.10.730.10:FF:000155', NULL, NULL, 'Leucyl-tRNA synthetase (AFU_orthologue AFUA_6G04910)', NULL, NULL, NULL, NULL, NULL, 4),
(63650, NULL, 'G3DSA:2.10.110.10:FF:000295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63651, NULL, 'G3DSA:3.40.50.1000:FF:000508', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63652, NULL, 'G3DSA:3.40.50.720:FF:002022', NULL, NULL, 'Os10g0477900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(63653, NULL, 'G3DSA:3.40.50.1820:FF:000080', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(63654, NULL, 'G3DSA:1.10.1040.10:FF:000073', NULL, NULL, 'Putative 3-hydroxyisobutyrate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(63655, NULL, 'G3DSA:1.10.510.10:FF:003050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63656, NULL, 'G3DSA:3.40.50.880:FF:000046', NULL, NULL, 'Protein/nucleic acid deglycase DJ-1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(63657, NULL, 'G3DSA:2.10.25.10:FF:001558', NULL, NULL, 'Lrp1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(63658, NULL, 'G3DSA:1.10.510.10:FF:000762', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(63659, NULL, 'G3DSA:3.10.129.10:FF:000042', NULL, NULL, 'MaoC domain protein dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(63660, NULL, 'G3DSA:1.20.1070.10:FF:000123', NULL, NULL, 'cadherin EGF LAG seven-pass G-type receptor 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(63661, NULL, 'G3DSA:1.20.1420.30:FF:000027', NULL, NULL, 'Vacuolar calcium ion transporter', NULL, NULL, NULL, NULL, NULL, 4),
(63662, NULL, 'G3DSA:3.40.50.200:FF:000011', NULL, NULL, 'subtilisin-like protease SBT6.1', NULL, NULL, NULL, NULL, NULL, 4),
(63663, NULL, 'G3DSA:3.40.50.1820:FF:000580', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(63664, NULL, 'G3DSA:3.90.180.10:FF:000030', NULL, NULL, 'Synaptic vesicle membrane protein VAT-1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(63665, NULL, 'G3DSA:3.80.10.10:FF:004122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63666, NULL, 'G3DSA:1.10.8.500:FF:000014', NULL, NULL, 'Chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(63667, NULL, 'G3DSA:3.90.120.10:FF:000021', NULL, NULL, 'Cytosine-C5 specific DNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(63668, NULL, 'G3DSA:3.40.50.300:FF:002778', NULL, NULL, 'Pre-mRNA-processing ATP-dependent RNA helicase PRP5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(63669, NULL, 'G3DSA:3.30.1370.10:FF:000030', NULL, NULL, 'KH domain-containing, RNA-binding, signal transduction-associated protein 3 isoformX2', NULL, NULL, NULL, NULL, NULL, 4),
(63670, NULL, 'G3DSA:3.30.1330.60:FF:000019', NULL, NULL, 'Outer membrane protein OmpA', NULL, NULL, NULL, NULL, NULL, 4),
(63671, NULL, 'G3DSA:3.40.50.1400:FF:000010', NULL, NULL, 'Sirohydrochlorin cobaltochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(63672, NULL, 'G3DSA:2.60.40.790:FF:000157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63673, NULL, 'G3DSA:2.30.42.10:FF:000580', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63674, NULL, 'G3DSA:2.60.40.10:FF:002884', NULL, NULL, 'Neurolin-like cell adhesion molecule', NULL, NULL, NULL, NULL, NULL, 4),
(63675, NULL, 'G3DSA:3.40.50.720:FF:001297', NULL, NULL, 'Tissue-specific transplantation antigen P35B', NULL, NULL, NULL, NULL, NULL, 4),
(63676, NULL, 'G3DSA:1.20.1420.10:FF:000021', NULL, NULL, 'TaLiN', NULL, NULL, NULL, NULL, NULL, 4),
(63677, NULL, 'G3DSA:2.60.40.10:FF:005700', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63678, NULL, 'G3DSA:1.10.1410.20:FF:000003', NULL, NULL, '2''-5'' oligoadenylate synthetase 1E', NULL, NULL, NULL, NULL, NULL, 4),
(63679, NULL, 'G3DSA:2.30.30.190:FF:000015', NULL, NULL, 'Kinesin family member 13A', NULL, NULL, NULL, NULL, NULL, 4),
(63680, NULL, 'G3DSA:1.10.12.10:FF:000042', NULL, NULL, 'Enoyl-CoA hydratase domain-containing protein 3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(63681, NULL, 'G3DSA:3.40.50.1240:FF:000086', NULL, NULL, 'Protein CBG23268', NULL, NULL, NULL, NULL, NULL, 4),
(63682, NULL, 'G3DSA:2.30.170.40:FF:000005', NULL, NULL, '50S ribosomal L28, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(63683, NULL, 'G3DSA:3.30.160.60:FF:000771', NULL, NULL, 'zinc finger protein 648', NULL, NULL, NULL, NULL, NULL, 4),
(63684, NULL, 'G3DSA:3.80.10.10:FF:000850', NULL, NULL, 'Os03g0773300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(63685, NULL, 'G3DSA:2.130.10.10:FF:003525', NULL, NULL, 'WD repeat domain 90', NULL, NULL, NULL, NULL, NULL, 4),
(63686, NULL, 'G3DSA:3.40.50.300:FF:006578', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(63687, NULL, 'G3DSA:1.10.1040.10:FF:000101', NULL, NULL, 'Oxidoreductase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(63688, NULL, 'G3DSA:3.10.20.90:FF:000990', NULL, NULL, 'Myosin-I heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(63689, NULL, 'G3DSA:3.90.70.10:FF:000567', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(63690, NULL, 'G3DSA:3.30.70.330:FF:002265', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63691, NULL, 'G3DSA:2.120.10.80:FF:000028', NULL, NULL, 'Kelch repeat and BTB (POZ) domain-containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(63692, NULL, 'G3DSA:1.10.10.10:FF:001515', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63693, NULL, 'G3DSA:3.40.50.2300:FF:000117', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(63694, NULL, 'G3DSA:3.40.50.1220:FF:000080', NULL, NULL, 'Electron transfer flavoprotein subunit alpha, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(63695, NULL, 'G3DSA:2.30.170.30:FF:000002', NULL, NULL, 'Ethanolamine ammonia-lyase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(63696, NULL, 'G3DSA:1.10.472.10:FF:000279', NULL, NULL, 'Cyclin, N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(63697, NULL, 'G3DSA:2.170.300.10:FF:000042', NULL, NULL, 'Platelet endothelial aggregation receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(63698, NULL, 'G3DSA:1.25.10.10:FF:002769', NULL, NULL, 'AER055Wp', NULL, NULL, NULL, NULL, NULL, 4),
(63699, NULL, 'G3DSA:2.60.120.260:FF:000131', NULL, NULL, 'Beta-galactosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(63700, NULL, 'G3DSA:3.90.1300.10:FF:000017', NULL, NULL, 'General amidase', NULL, NULL, NULL, NULL, NULL, 4),
(63701, NULL, 'G3DSA:3.30.70.330:FF:002911', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63702, NULL, 'G3DSA:3.10.50.10:FF:000041', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(63703, NULL, 'G3DSA:3.90.190.10:FF:000115', NULL, NULL, 'Tyrosine-protein phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(63704, NULL, 'G3DSA:2.130.10.10:FF:002536', NULL, NULL, 'GM17963', NULL, NULL, NULL, NULL, NULL, 4),
(63705, NULL, 'G3DSA:1.10.510.10:FF:003988', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63706, NULL, 'G3DSA:3.40.1770.10:FF:000007', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(63707, NULL, 'G3DSA:3.55.40.20:FF:000008', NULL, NULL, 'Superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(63708, NULL, 'G3DSA:3.30.310.50:FF:000033', NULL, NULL, 'Phosphomannomutase (Pmm)', NULL, NULL, NULL, NULL, NULL, 4),
(63709, NULL, 'G3DSA:1.10.10.10:FF:000526', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(63710, NULL, 'G3DSA:3.30.780.10:FF:000011', NULL, NULL, 'Translation machinery-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(63711, NULL, 'G3DSA:3.30.160.60:FF:004986', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63712, NULL, 'G3DSA:3.30.1370.10:FF:000119', NULL, NULL, 'KH type 1 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(63713, NULL, 'G3DSA:1.10.472.10:FF:000190', NULL, NULL, 'Cyclin-D5-1', NULL, NULL, NULL, NULL, NULL, 4),
(63714, NULL, 'G3DSA:2.60.120.650:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63715, NULL, 'G3DSA:3.30.1010.10:FF:000071', NULL, NULL, 'Phosphatidylinositol 3-kinase 1 putative', NULL, NULL, NULL, NULL, NULL, 4),
(63716, NULL, 'G3DSA:3.20.20.150:FF:000005', NULL, NULL, 'Mannonate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(63717, NULL, 'G3DSA:1.20.1560.10:FF:000615', NULL, NULL, 'P-glycoprotein 2', NULL, NULL, NULL, NULL, NULL, 4),
(63718, NULL, 'G3DSA:1.25.10.10:FF:001050', NULL, NULL, 'VAC (Yeast VACuole morphology)-Like', NULL, NULL, NULL, NULL, NULL, 4),
(63719, NULL, 'G3DSA:3.40.50.1000:FF:000834', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63720, NULL, 'G3DSA:3.30.40.10:FF:001568', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63721, NULL, 'G3DSA:2.130.10.10:FF:002862', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One component system)', NULL, NULL, NULL, NULL, NULL, 4),
(63722, NULL, 'G3DSA:2.60.200.20:FF:000277', NULL, NULL, 'AGAP005804-PA', NULL, NULL, NULL, NULL, NULL, 4),
(63723, NULL, 'G3DSA:1.10.8.270:FF:000046', NULL, NULL, 'TBC1 domain family member 25', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(63724, NULL, 'G3DSA:4.10.60.10:FF:000062', NULL, NULL, 'zinc finger CCHC-type and RNA-binding motif-containing protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(63725, NULL, 'G3DSA:1.10.630.10:FF:000006', NULL, NULL, 'Cytochrome P450 302a1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(63726, NULL, 'G3DSA:3.40.850.10:FF:000374', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(63727, NULL, 'G3DSA:2.40.170.20:FF:000093', NULL, NULL, 'Transporter, outer membrane receptor (OMR) family', NULL, NULL, NULL, NULL, NULL, 4),
(63728, NULL, 'G3DSA:3.90.79.10:FF:000148', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(63729, NULL, 'G3DSA:2.60.40.60:FF:000078', NULL, NULL, 'Protocadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(63730, NULL, 'G3DSA:3.40.50.1260:FF:000041', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(63731, NULL, 'G3DSA:1.25.40.10:FF:002333', NULL, NULL, 'Os02g0818800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(63732, NULL, 'G3DSA:3.90.640.10:FF:000015', NULL, NULL, 'Actin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(63733, NULL, 'G3DSA:1.20.58.60:FF:000061', NULL, NULL, 'microtubule-actin cross-linking factor 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(63734, NULL, 'G3DSA:3.30.160.60:FF:005560', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63735, NULL, 'G3DSA:3.30.70.330:FF:000556', NULL, NULL, 'Os06g0220600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(63736, NULL, 'G3DSA:3.40.390.10:FF:000181', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63737, NULL, 'G3DSA:3.60.10.10:FF:000008', NULL, NULL, 'Synaptojanin 2', NULL, NULL, NULL, NULL, NULL, 4),
(63738, NULL, 'G3DSA:1.10.1410.40:FF:000009', NULL, NULL, 'Transmembrane protein 102', NULL, NULL, NULL, NULL, NULL, 4),
(63739, NULL, 'G3DSA:3.80.10.10:FF:000524', NULL, NULL, 'Predicted gene 16427', NULL, NULL, NULL, NULL, NULL, 4),
(63740, NULL, 'G3DSA:3.30.160.60:FF:001434', NULL, NULL, 'zinc finger protein 286A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(63741, NULL, 'G3DSA:1.10.10.10:FF:000998', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63742, NULL, 'G3DSA:2.60.40.10:FF:003401', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63743, NULL, 'G3DSA:3.90.1860.10:FF:000019', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(63744, NULL, 'G3DSA:3.40.50.720:FF:001976', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(63745, NULL, 'G3DSA:3.30.9.10:FF:000023', NULL, NULL, 'Sarcosine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(63746, NULL, 'G3DSA:2.130.10.10:FF:004189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63747, NULL, 'G3DSA:3.50.50.60:FF:000649', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(63748, NULL, 'G3DSA:3.30.465.10:FF:000043', NULL, NULL, 'Gliding motility-associated protein GldE', NULL, NULL, NULL, NULL, NULL, 4),
(63749, NULL, 'G3DSA:1.20.58.70:FF:000064', NULL, NULL, 'Target SNARE, putative', NULL, NULL, NULL, NULL, NULL, 4),
(63750, NULL, 'G3DSA:2.60.120.260:FF:000395', NULL, NULL, 'Protein-L-isoaspartate O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(63751, NULL, 'G3DSA:2.40.50.140:FF:000362', NULL, NULL, 'Ribonuclease R', NULL, NULL, NULL, NULL, NULL, 4),
(63752, NULL, 'G3DSA:3.40.1410.10:FF:000048', NULL, NULL, 'HTH-type transcriptional repressor YvoA', NULL, NULL, NULL, NULL, NULL, 4),
(63753, NULL, 'G3DSA:3.30.420.80:FF:000022', NULL, NULL, 'Structural constituent of ribosome', NULL, NULL, NULL, NULL, NULL, 4),
(63754, NULL, 'G3DSA:2.40.160.50:FF:000016', NULL, NULL, 'Sorting and assembly machinery component 50', NULL, NULL, NULL, NULL, NULL, 4),
(63755, NULL, 'G3DSA:2.60.40.60:FF:001005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63756, NULL, 'G3DSA:3.30.40.10:FF:000433', NULL, NULL, 'Putative homeodomain-like transcription factor superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(63757, NULL, 'G3DSA:2.30.30.1150:FF:000005', NULL, NULL, 'PHD finger protein EHD3 isoform A', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(63758, NULL, 'G3DSA:3.30.230.70:FF:000038', NULL, NULL, 'Unplaced genomic scaffold supercont2.9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(63759, NULL, 'G3DSA:3.30.160.60:FF:005503', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63760, NULL, 'G3DSA:1.10.510.10:FF:001072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63761, NULL, 'G3DSA:3.30.160.20:FF:000012', NULL, NULL, 'Drosha ribonuclease III', NULL, NULL, NULL, NULL, NULL, 4),
(63762, NULL, 'G3DSA:3.30.110.20:FF:000008', NULL, NULL, 'DNA/RNA-binding protein Alba 1', NULL, NULL, NULL, NULL, NULL, 4),
(63763, NULL, 'G3DSA:3.90.550.10:FF:000750', NULL, NULL, 'Putative mannan synthase 7', NULL, NULL, NULL, NULL, NULL, 4),
(63764, NULL, 'G3DSA:3.30.160.70:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63765, NULL, 'G3DSA:3.30.230.10:FF:000071', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(63766, NULL, 'G3DSA:2.40.30.130:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63767, NULL, 'G3DSA:1.10.640.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63768, NULL, 'G3DSA:3.40.50.10810:FF:000196', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(63769, NULL, 'G3DSA:2.10.110.10:FF:000323', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63770, NULL, 'G3DSA:3.90.1030.10:FF:000007', NULL, NULL, '39S ribosomal protein L17, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(63771, NULL, 'G3DSA:3.30.420.140:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63772, NULL, 'G3DSA:3.10.20.90:FF:000782', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63773, NULL, 'G3DSA:3.40.50.2300:FF:000325', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63774, NULL, 'G3DSA:1.10.486.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63775, NULL, 'G3DSA:2.30.29.30:FF:000914', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(63776, NULL, 'G3DSA:3.90.950.10:FF:000033', NULL, NULL, 'Inosine triphosphate pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(63777, NULL, 'G3DSA:3.40.50.1820:FF:000372', NULL, NULL, 'Protein phosphatase methylesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(63778, NULL, 'G3DSA:1.20.5.340:FF:000065', NULL, NULL, 'E3 ubiquitin protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(63779, NULL, 'G3DSA:1.25.40.180:FF:000142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63780, NULL, 'G3DSA:3.30.70.1450:FF:000011', NULL, NULL, 'Sulfur deprivation response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(63781, NULL, 'G3DSA:3.30.160.60:FF:002569', NULL, NULL, 'Zinc finger protein 562', NULL, NULL, NULL, NULL, NULL, 4),
(63782, NULL, 'G3DSA:3.30.420.40:FF:000476', NULL, NULL, 'RE20574p', NULL, NULL, NULL, NULL, NULL, 4),
(63783, NULL, 'G3DSA:1.10.10.10:FF:000734', NULL, NULL, 'RNA polymerase Rpc34 subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(63784, NULL, 'G3DSA:2.160.20.10:FF:000321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63785, NULL, 'G3DSA:2.30.40.10:FF:000154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63786, NULL, 'G3DSA:3.30.70.270:FF:000162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63787, NULL, 'G3DSA:3.20.20.80:FF:000520', NULL, NULL, 'Endoglucanase H', NULL, NULL, NULL, NULL, NULL, 4),
(63788, NULL, 'G3DSA:3.40.50.300:FF:000479', NULL, NULL, 'Multidrug resistance protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(63789, NULL, 'G3DSA:3.10.110.10:FF:000257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63790, NULL, 'G3DSA:3.30.1520.10:FF:000036', NULL, NULL, 'HCLS1 binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(63791, NULL, 'G3DSA:1.25.40.10:FF:002479', NULL, NULL, 'LP07472p', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(63792, NULL, 'G3DSA:2.130.10.10:FF:001108', NULL, NULL, 'WD_domain_-_G-beta_repeat/Utp21_specific_WD40_ass ociated_putative_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(63793, NULL, 'G3DSA:1.20.120.1530:FF:000012', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(63794, NULL, 'G3DSA:3.30.1370.10:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63795, NULL, 'G3DSA:3.40.50.1820:FF:001827', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(63796, NULL, 'G3DSA:3.40.50.300:FF:001530', NULL, NULL, 'ABC multidrug transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(63797, NULL, 'G3DSA:1.10.472.10:FF:000543', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63798, NULL, 'G3DSA:1.20.930.20:FF:000002', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(63799, NULL, 'G3DSA:2.40.10.10:FF:000478', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63800, NULL, 'G3DSA:3.40.1110.10:FF:000121', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(63801, NULL, 'G3DSA:2.10.25.10:FF:000423', NULL, NULL, 'Neurogenic locus notch homolog protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(63802, NULL, 'G3DSA:3.40.30.10:FF:001224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63803, NULL, 'G3DSA:1.10.20.10:FF:000353', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63804, NULL, 'G3DSA:3.30.40.10:FF:001776', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63805, NULL, 'G3DSA:1.20.1070.10:FF:000180', NULL, NULL, 'neuropeptide Y receptor type 5', NULL, NULL, NULL, NULL, NULL, 4),
(63806, NULL, 'G3DSA:2.120.10.30:FF:000328', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63807, NULL, 'G3DSA:2.60.40.420:FF:000035', NULL, NULL, 'Coagulation factor VIII (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(63808, NULL, 'G3DSA:3.40.50.410:FF:000102', NULL, NULL, 'ATP-dependent DNA helicase 2 subunit KU80', NULL, NULL, NULL, NULL, NULL, 4),
(63809, NULL, 'G3DSA:2.60.420.10:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63810, NULL, 'G3DSA:3.40.50.2300:FF:000382', NULL, NULL, 'Vomeronasal 2, receptor 55', NULL, NULL, NULL, NULL, NULL, 4),
(63811, NULL, 'G3DSA:3.10.20.230:FF:000015', NULL, NULL, 'Doublecortin domain containing 2C', NULL, NULL, NULL, NULL, NULL, 4),
(63812, NULL, 'G3DSA:1.10.510.10:FF:002853', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63813, NULL, 'G3DSA:1.25.40.10:FF:002597', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g26630, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(63814, NULL, 'G3DSA:1.20.1270.220:FF:000006', NULL, NULL, 'Transcription factor GTE1', NULL, NULL, NULL, NULL, NULL, 4),
(63815, NULL, 'G3DSA:2.120.10.30:FF:000446', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63816, NULL, 'G3DSA:3.10.110.10:FF:000196', NULL, NULL, 'Ubiquitin-conjugating enzyme E2', NULL, NULL, NULL, NULL, NULL, 4),
(63817, NULL, 'G3DSA:1.20.120.1750:FF:000139', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(63818, NULL, 'G3DSA:1.20.1270.10:FF:000104', NULL, NULL, 'Heat shock 70 kDa protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(63819, NULL, 'G3DSA:3.80.10.10:FF:001659', NULL, NULL, 'RNI-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(63820, NULL, 'G3DSA:2.60.120.10:FF:000829', NULL, NULL, 'Gll3293 protein', NULL, NULL, NULL, NULL, NULL, 4),
(63821, NULL, 'G3DSA:1.10.287.860:FF:000002', NULL, NULL, 'GTP pyrophosphokinase YwaC', NULL, NULL, NULL, NULL, NULL, 4),
(63822, NULL, 'G3DSA:1.25.10.10:FF:001988', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(63823, NULL, 'G3DSA:1.10.167.10:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63824, NULL, 'G3DSA:1.10.555.10:FF:000112', NULL, NULL, 'SLIT-ROBO Rho GTPase-activating protein 3', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(63825, NULL, 'G3DSA:3.30.260.10:FF:000073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63826, NULL, 'G3DSA:3.30.70.660:FF:000071', NULL, NULL, 'Pseudouridylate synthase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(63827, NULL, 'G3DSA:3.40.50.720:FF:000841', NULL, NULL, 'NADPH:quinone reductase', NULL, NULL, NULL, NULL, NULL, 4),
(63828, NULL, 'G3DSA:3.30.160.60:FF:004571', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63829, NULL, 'G3DSA:2.40.240.20:FF:000003', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4),
(63830, NULL, 'G3DSA:3.40.250.10:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63831, NULL, 'G3DSA:2.60.34.10:FF:000083', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(63832, NULL, 'G3DSA:1.50.40.10:FF:000588', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63833, NULL, 'G3DSA:1.10.150.60:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63834, NULL, 'G3DSA:2.130.10.30:FF:000131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63835, NULL, 'G3DSA:3.40.50.620:FF:000373', NULL, NULL, 'ATP-binding region containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(63836, NULL, 'G3DSA:1.10.150.50:FF:000032', NULL, NULL, 'caskin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(63837, NULL, 'G3DSA:3.30.565.10:FF:000494', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63838, NULL, 'G3DSA:1.10.238.10:FF:000691', NULL, NULL, '45 kDa calcium-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(63839, NULL, 'G3DSA:1.25.40.20:FF:001560', NULL, NULL, 'Ankyrin repeat domain 31', NULL, NULL, NULL, NULL, NULL, 4),
(63840, NULL, 'G3DSA:3.40.50.720:FF:000105', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(63841, NULL, 'G3DSA:3.30.70.330:FF:002147', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63842, NULL, 'G3DSA:3.30.200.20:FF:000600', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(63843, NULL, 'G3DSA:2.10.25.10:FF:000070', NULL, NULL, 'Thrombospondin 2', NULL, NULL, NULL, NULL, NULL, 4),
(63844, NULL, 'G3DSA:3.30.70.3490:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63845, NULL, 'G3DSA:3.50.50.60:FF:000442', NULL, NULL, 'Putative GMC-type oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(63846, NULL, 'G3DSA:1.10.560.10:FF:000147', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(63847, NULL, 'G3DSA:3.20.20.80:FF:000374', NULL, NULL, 'Glycoprotein endo-alpha-1,2-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(63848, NULL, 'G3DSA:3.30.70.3290:FF:000017', NULL, NULL, 'Non-ribosomal peptide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(63849, NULL, 'G3DSA:1.10.510.10:FF:003106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63850, NULL, 'G3DSA:1.10.150.20:FF:000225', NULL, NULL, 'UPF0758 protein SPO0054', NULL, NULL, NULL, NULL, NULL, 4),
(63851, NULL, 'G3DSA:1.10.287.70:FF:000260', NULL, NULL, 'Outward-rectifier potassium channel TOK1', NULL, NULL, NULL, NULL, NULL, 4),
(63852, NULL, 'G3DSA:3.80.10.10:FF:000732', NULL, NULL, 'GD11101', NULL, NULL, NULL, NULL, NULL, 4),
(63853, NULL, 'G3DSA:1.20.900.10:FF:000025', NULL, NULL, 'Rho guanine nucleotide exchange factor 17', NULL, NULL, NULL, NULL, NULL, 4),
(63854, NULL, 'G3DSA:1.10.10.60:FF:000788', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63855, NULL, 'G3DSA:1.10.3500.10:FF:000002', NULL, NULL, 'RNA-binding transcriptional accessory protein', NULL, NULL, NULL, NULL, NULL, 4),
(63856, NULL, 'G3DSA:2.20.110.10:FF:000006', NULL, NULL, 'Histone-lysine N-methyltransferase SETD7', NULL, NULL, NULL, NULL, NULL, 4),
(63857, NULL, 'G3DSA:2.30.42.10:FF:000170', NULL, NULL, 'tight junction protein ZO-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(63858, NULL, 'G3DSA:3.20.110.10:FF:000025', NULL, NULL, 'NADPH--cytochrome P450 reductase 2', NULL, NULL, NULL, NULL, NULL, 4),
(63859, NULL, 'G3DSA:2.120.10.80:FF:000293', NULL, NULL, 'Flagellar outer dynein arm heavy chain alpha', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(63860, NULL, 'G3DSA:1.25.40.10:FF:003968', NULL, NULL, 'Tetratricopeptide repeatcontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(63861, NULL, 'G3DSA:2.60.120.290:FF:000145', NULL, NULL, 'Suppressor of tumorigenicity 14 protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(63862, NULL, 'G3DSA:3.30.200.20:FF:000246', NULL, NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 152', NULL, NULL, NULL, NULL, NULL, 4),
(63863, NULL, 'G3DSA:3.10.170.20:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63864, NULL, 'G3DSA:2.40.100.10:FF:000136', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 4-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(63865, NULL, 'G3DSA:3.100.10.10:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63866, NULL, 'G3DSA:3.30.1490.100:FF:000029', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(63867, NULL, 'G3DSA:3.40.1160.10:FF:000101', NULL, NULL, 'Carbamate kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(63868, NULL, 'G3DSA:3.20.80.10:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63869, NULL, 'G3DSA:3.60.130.20:FF:000003', NULL, NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(63870, NULL, 'G3DSA:2.10.110.10:FF:000177', NULL, NULL, 'LIM homeobox 9', NULL, NULL, NULL, NULL, NULL, 4),
(63871, NULL, 'G3DSA:3.40.1080.10:FF:000005', NULL, NULL, '3-oxoacid CoA-transferase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(63872, NULL, 'G3DSA:3.40.50.1000:FF:000626', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63873, NULL, 'G3DSA:1.25.40.10:FF:002833', NULL, NULL, 'RNA_polymerase-associated_protein_CTR9_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(63874, NULL, 'G3DSA:2.130.10.10:FF:002598', NULL, NULL, 'NACHT and WD repeat domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(63875, NULL, 'G3DSA:3.30.160.60:FF:001552', NULL, NULL, 'Zinc finger protein 425', NULL, NULL, NULL, NULL, NULL, 4),
(63876, NULL, 'G3DSA:2.10.25.10:FF:001351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63877, NULL, 'G3DSA:1.25.40.20:FF:001408', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63878, NULL, 'G3DSA:3.40.50.850:FF:000003', NULL, NULL, 'Isochorismatase hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(63879, NULL, 'G3DSA:2.60.40.10:FF:003137', NULL, NULL, 'Plexin C1', NULL, NULL, NULL, NULL, NULL, 4),
(63880, NULL, 'G3DSA:1.10.10.10:FF:000791', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(63881, NULL, 'G3DSA:1.10.10.60:FF:001305', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63882, NULL, 'G3DSA:1.25.40.10:FF:004188', NULL, NULL, 'MSHA biogenesis protein MshN', NULL, NULL, NULL, NULL, NULL, 4),
(63883, NULL, 'G3DSA:3.30.160.60:FF:002980', NULL, NULL, 'Si:ch73-299h12.8', NULL, NULL, NULL, NULL, NULL, 4),
(63884, NULL, 'G3DSA:1.20.1050.10:FF:000178', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(63885, NULL, 'G3DSA:2.10.22.10:FF:000001', NULL, NULL, 'Cysteine-rich motor neuron 1 protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(63886, NULL, 'G3DSA:1.25.40.10:FF:001405', NULL, NULL, 'Putative beta-barrel assembly-enhancing protease', NULL, NULL, NULL, NULL, NULL, 4),
(63887, NULL, 'G3DSA:3.60.10.10:FF:000160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63888, NULL, 'G3DSA:3.40.109.10:FF:000028', NULL, NULL, 'Nitroreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(63889, NULL, 'G3DSA:2.130.10.10:FF:001316', NULL, NULL, 'Semaphorin 7A', NULL, NULL, NULL, NULL, NULL, 4),
(63890, NULL, 'G3DSA:2.160.20.10:FF:000175', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(63891, NULL, 'G3DSA:3.40.1440.10:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63892, NULL, 'G3DSA:3.90.105.10:FF:000008', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(63893, NULL, 'G3DSA:3.40.50.1820:FF:001709', NULL, NULL, 'GPI inositol-deacylase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(63894, NULL, 'G3DSA:2.130.10.10:FF:002744', NULL, NULL, 'Protein CBR-EPG-6', NULL, NULL, NULL, NULL, NULL, 4),
(63895, NULL, 'G3DSA:2.60.200.20:FF:000159', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(63896, NULL, 'G3DSA:1.10.510.10:FF:002353', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63897, NULL, 'G3DSA:3.30.70.940:FF:000031', NULL, NULL, 'Transcription elongation factor SPT5', NULL, NULL, NULL, NULL, NULL, 4),
(63898, NULL, 'G3DSA:1.20.120.1240:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63899, NULL, 'G3DSA:2.120.10.30:FF:000480', NULL, NULL, 'Similar to peptidylglycine monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(63900, NULL, 'G3DSA:3.80.10.10:FF:004329', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(63901, NULL, 'G3DSA:2.130.10.10:FF:005116', NULL, NULL, 'Striatin', NULL, NULL, NULL, NULL, NULL, 4),
(63902, NULL, 'G3DSA:2.40.30.10:FF:000333', NULL, NULL, 'GTP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(63903, NULL, 'G3DSA:3.30.450.20:FF:000354', NULL, NULL, 'Nitrogen fixation negative regulator NifL', NULL, NULL, NULL, NULL, NULL, 4),
(63904, NULL, 'G3DSA:1.20.1250.20:FF:000550', NULL, NULL, 'Inner membrane protein YbjJ', NULL, NULL, NULL, NULL, NULL, 4),
(63905, NULL, 'G3DSA:3.80.10.10:FF:001867', NULL, NULL, 'Peroxidasin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(63906, NULL, 'G3DSA:1.20.1250.20:FF:000308', NULL, NULL, 'MFS efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(63907, NULL, 'G3DSA:1.10.150.20:FF:000282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63908, NULL, 'G3DSA:3.90.70.10:FF:000359', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(63909, NULL, 'G3DSA:3.30.200.20:FF:002045', NULL, NULL, 'Serine/threonine-protein kinase ppk22', NULL, NULL, NULL, NULL, NULL, 4),
(63910, NULL, 'G3DSA:3.10.100.10:FF:000077', NULL, NULL, 'Killer cell lectin-like receptor subfamily B member 1A', NULL, NULL, NULL, NULL, NULL, 4),
(63911, NULL, 'G3DSA:3.40.1740.10:FF:000005', NULL, NULL, 'AT3g29240/MXO21_9', NULL, NULL, NULL, NULL, NULL, 4),
(63912, NULL, 'G3DSA:1.25.10.10:FF:000594', NULL, NULL, 'WAPL cohesin release factor a', NULL, NULL, NULL, NULL, NULL, 4),
(63913, NULL, 'G3DSA:1.10.20.10:FF:000145', NULL, NULL, 'Chromatin accessibility complex protein 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(63914, NULL, 'G3DSA:3.40.50.300:FF:000715', NULL, NULL, 'ATP-dependent DNA helicase RecG', NULL, NULL, NULL, NULL, NULL, 4),
(63915, NULL, 'G3DSA:2.130.10.10:FF:000799', NULL, NULL, 'Probable cytosolic iron-sulfur protein assembly protein CIAO1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(63916, NULL, 'G3DSA:2.60.220.50:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63917, NULL, 'G3DSA:3.40.50.2000:FF:001022', NULL, NULL, 'Os02g0210800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(63918, NULL, 'G3DSA:3.40.50.720:FF:001858', NULL, NULL, 'Non-ribosomal peptide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(63919, NULL, 'G3DSA:3.30.70.330:FF:002501', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63920, NULL, 'G3DSA:3.40.50.150:FF:001316', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63921, NULL, 'G3DSA:3.30.1370.10:FF:000237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63922, NULL, 'G3DSA:1.20.20.10:FF:000004', NULL, NULL, 'ATP synthase subunit c', NULL, NULL, NULL, NULL, NULL, 4),
(63923, NULL, 'G3DSA:2.60.40.60:FF:000842', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63924, NULL, 'G3DSA:1.10.630.10:FF:000063', NULL, NULL, 'Cytochrome P450 monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(63925, NULL, 'G3DSA:3.90.550.50:FF:000149', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(63926, NULL, 'G3DSA:3.90.550.10:FF:000508', NULL, NULL, 'Glycosyl transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(63927, NULL, 'G3DSA:1.20.1250.20:FF:001736', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(63928, NULL, 'G3DSA:3.10.20.90:FF:000838', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63929, NULL, 'G3DSA:3.80.10.10:FF:003812', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63930, NULL, 'G3DSA:3.30.430.20:FF:000055', NULL, NULL, 'Cysteine-rich repeat secretory protein 38', NULL, NULL, NULL, NULL, NULL, 4),
(63931, NULL, 'G3DSA:1.25.40.20:FF:001352', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63932, NULL, 'G3DSA:3.90.190.10:FF:000233', NULL, NULL, 'Protein Tyrosine Phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(63933, NULL, 'G3DSA:1.10.510.10:FF:003016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63934, NULL, 'G3DSA:3.30.160.60:FF:001288', NULL, NULL, 'Zinc finger protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(63935, NULL, 'G3DSA:3.90.930.12:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63936, NULL, 'G3DSA:2.30.30.40:FF:000578', NULL, NULL, 'Chemotaxis signal transduction protein', NULL, NULL, NULL, NULL, NULL, 4),
(63937, NULL, 'G3DSA:3.40.50.10810:FF:000078', NULL, NULL, 'Helicase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(63938, NULL, 'G3DSA:2.10.110.10:FF:000087', NULL, NULL, 'LIM zinc-binding domain-containing Nebulette', NULL, NULL, NULL, NULL, NULL, 4),
(63939, NULL, 'G3DSA:2.30.30.100:FF:000062', NULL, NULL, 'Probable U6 snRNA-associated Sm-like protein LSm7', NULL, NULL, NULL, NULL, NULL, 4),
(63940, NULL, 'G3DSA:3.40.50.80:FF:000066', NULL, NULL, 'Vanillate O-demethylase oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(63941, NULL, 'G3DSA:4.10.1000.10:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63942, NULL, 'G3DSA:1.25.40.10:FF:004278', NULL, NULL, 'Pre-mRNA-splicing factor SYF1', NULL, NULL, NULL, NULL, NULL, 4),
(63943, NULL, 'G3DSA:3.40.50.2300:FF:000735', NULL, NULL, 'Two component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(63944, NULL, 'G3DSA:3.40.50.12780:FF:000124', NULL, NULL, 'Isocyanide synthase-NRPS hybrid crmA', NULL, NULL, NULL, NULL, NULL, 4),
(63945, NULL, 'G3DSA:3.30.930.10:FF:000135', NULL, NULL, 'GCN2p Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(63946, NULL, 'G3DSA:1.10.510.10:FF:004298', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63947, NULL, 'G3DSA:3.30.60.20:FF:000145', NULL, NULL, 'Kinase suppressor of Ras B', NULL, NULL, NULL, NULL, NULL, 4),
(63948, NULL, 'G3DSA:1.10.418.10:FF:000255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63949, NULL, 'G3DSA:2.160.20.10:FF:000085', NULL, NULL, 'Glycoside hydrolase family 55 protein', NULL, NULL, NULL, NULL, NULL, 4),
(63950, NULL, 'G3DSA:3.30.230.10:FF:000127', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(63951, NULL, 'G3DSA:2.10.109.10:FF:000050', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(63952, NULL, 'G3DSA:2.60.40.150:FF:000673', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(63953, NULL, 'G3DSA:1.25.40.20:FF:000537', NULL, NULL, 'Rab GTPase activating protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(63954, NULL, 'G3DSA:3.40.50.150:FF:001373', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63955, NULL, 'G3DSA:3.80.10.10:FF:003458', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63956, NULL, 'G3DSA:2.30.29.30:FF:000504', NULL, NULL, 'FACT complex subunit SSRP1', NULL, NULL, NULL, NULL, NULL, 4),
(63957, NULL, 'G3DSA:3.90.1150.10:FF:000191', NULL, NULL, '4-aminobutyrate aminotransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(63958, NULL, 'G3DSA:1.20.58.60:FF:000622', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63959, NULL, 'G3DSA:1.10.238.10:FF:000398', NULL, NULL, 'Calmodulin-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(63960, NULL, 'G3DSA:3.90.640.10:FF:000223', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(63961, NULL, 'G3DSA:2.30.30.40:FF:000488', NULL, NULL, 'Protein CBR-CED-5', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(63962, NULL, 'G3DSA:3.30.760.10:FF:000009', NULL, NULL, 'eukaryotic translation initiation factor 4E type 2', NULL, NULL, NULL, NULL, NULL, 4),
(63963, NULL, 'G3DSA:3.40.50.11550:FF:000002', NULL, NULL, 'Dermonecrotic toxin', NULL, NULL, NULL, NULL, NULL, 4),
(63964, NULL, 'G3DSA:2.130.10.10:FF:004953', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63965, NULL, 'G3DSA:1.25.40.10:FF:000534', NULL, NULL, 'TPR repeat-containing thioredoxin TTL4', NULL, NULL, NULL, NULL, NULL, 4),
(63966, NULL, 'G3DSA:2.60.40.1510:FF:000039', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(63967, NULL, 'G3DSA:3.40.50.880:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63968, NULL, 'G3DSA:3.30.70.330:FF:002411', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63969, NULL, 'G3DSA:3.40.50.10130:FF:000003', NULL, NULL, 'Crossover junction endonuclease MUS81', NULL, NULL, NULL, NULL, NULL, 4),
(63970, NULL, 'G3DSA:1.25.40.10:FF:002125', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g53700, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(63971, NULL, 'G3DSA:1.20.920.20:FF:000030', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(63972, NULL, 'G3DSA:1.10.287.70:FF:000203', NULL, NULL, 'Potassium channel subfamily K member 1', NULL, NULL, NULL, NULL, NULL, 4),
(63973, NULL, 'G3DSA:1.10.510.10:FF:002089', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63974, NULL, 'G3DSA:2.60.40.3500:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(63975, NULL, 'G3DSA:3.80.10.10:FF:000171', NULL, NULL, 'Leucine rich repeat and coiled-coil centrosomal protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(63976, NULL, 'G3DSA:3.80.10.10:FF:000114', NULL, NULL, 'leucine-rich repeat-containing protein 41 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(63977, NULL, 'G3DSA:3.40.570.10:FF:000004', NULL, NULL, 'Nuclease 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(63978, NULL, 'G3DSA:2.40.50.140:FF:000418', NULL, NULL, 'Single-stranded DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(63979, NULL, 'G3DSA:3.40.50.2020:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63980, NULL, 'G3DSA:3.40.50.10140:FF:000006', NULL, NULL, 'Toll-like receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(63981, NULL, 'G3DSA:3.40.190.290:FF:000034', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(63982, NULL, 'G3DSA:3.30.710.10:FF:000063', NULL, NULL, 'Ankyrin repeat and BTB/POZ domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(63983, NULL, 'G3DSA:1.20.1250.20:FF:002141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63984, NULL, 'G3DSA:3.30.160.60:FF:001081', NULL, NULL, 'Combgap, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(63985, NULL, 'G3DSA:1.10.10.160:FF:000016', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(63986, NULL, 'G3DSA:2.60.40.60:FF:000578', NULL, NULL, 'Desmocollin 2 like', NULL, NULL, NULL, NULL, NULL, 4),
(63987, NULL, 'G3DSA:1.25.40.720:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63988, NULL, 'G3DSA:1.50.10.20:FF:000090', NULL, NULL, 'Complement component 4A (Rodgers blood group)', NULL, NULL, NULL, NULL, NULL, 4),
(63989, NULL, 'G3DSA:3.40.850.10:FF:000020', NULL, NULL, 'unconventional myosin-XVIIIa isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(63990, NULL, 'G3DSA:3.90.1150.10:FF:000134', NULL, NULL, 'HISTIDINE BIOSYNTHESIS 6B', NULL, NULL, NULL, NULL, NULL, 4),
(63991, NULL, 'G3DSA:3.40.190.10:FF:000284', NULL, NULL, 'Glutamate receptor ionotropic, kainate 3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(63992, NULL, 'G3DSA:3.30.2430.10:FF:000001', NULL, NULL, 'Type III effector phosphothreonine lyase', NULL, NULL, NULL, NULL, NULL, 4),
(63993, NULL, 'G3DSA:2.40.50.140:FF:000570', NULL, NULL, 'WGS project CABT00000000 data, contig 2.1', NULL, NULL, NULL, NULL, NULL, 4),
(63994, NULL, 'G3DSA:3.60.110.10:FF:000055', NULL, NULL, 'Carbon-nitrogen hydrolase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(63995, NULL, 'G3DSA:2.60.40.60:FF:000488', NULL, NULL, 'Cadherin 17, LI cadherin (Liver-intestine)', NULL, NULL, NULL, NULL, NULL, 4),
(63996, NULL, 'G3DSA:3.40.50.300:FF:003705', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63997, NULL, 'G3DSA:3.30.420.40:FF:000684', NULL, NULL, 'cDNA clone:002-183-D01, full insert sequence', NULL, NULL, NULL, NULL, NULL, 4),
(63998, NULL, 'G3DSA:1.25.40.10:FF:002743', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(63999, NULL, 'G3DSA:2.20.70.10:FF:000235', NULL, NULL, 'WW domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(64000, NULL, 'G3DSA:2.130.10.10:FF:000592', NULL, NULL, 'UV-damaged DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(64001, NULL, 'G3DSA:2.120.10.80:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64002, NULL, 'G3DSA:3.90.79.10:FF:000266', NULL, NULL, 'Nudix hydrolase 17 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(64003, NULL, 'G3DSA:1.10.420.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64004, NULL, 'G3DSA:3.30.70.330:FF:000820', NULL, NULL, 'RNA recognition motif-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(64005, NULL, 'G3DSA:1.20.144.10:FF:000077', NULL, NULL, 'Phospholipid phosphatase-related 4', NULL, NULL, NULL, NULL, NULL, 4),
(64006, NULL, 'G3DSA:2.60.40.1390:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64007, NULL, 'G3DSA:4.10.520.10:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64008, NULL, 'G3DSA:1.25.10.10:FF:003112', NULL, NULL, 'AGAP005033-PA', NULL, NULL, NULL, NULL, NULL, 4),
(64009, NULL, 'G3DSA:1.10.510.10:FF:001425', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64010, NULL, 'G3DSA:3.80.10.10:FF:000024', NULL, NULL, 'Somatic embryogenesis receptor kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(64011, NULL, 'G3DSA:1.20.1280.290:FF:000017', NULL, NULL, 'lysosomal amino acid transporter 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(64012, NULL, 'G3DSA:3.30.1140.32:FF:000015', NULL, NULL, '30S ribosomal protein S3, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(64013, NULL, 'G3DSA:1.10.132.60:FF:000049', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(64014, NULL, 'G3DSA:1.50.10.10:FF:000030', NULL, NULL, 'Glucosidase YgjK', NULL, NULL, NULL, NULL, NULL, 4),
(64015, NULL, 'G3DSA:3.40.50.2000:FF:000151', NULL, NULL, 'UDP-glycosyltransferase 76E9', NULL, NULL, NULL, NULL, NULL, 4),
(64016, NULL, 'G3DSA:3.30.40.10:FF:001922', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64017, NULL, 'G3DSA:1.25.40.10:FF:000798', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g49170, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(64018, NULL, 'G3DSA:3.40.190.10:FF:000227', NULL, NULL, 'Peptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(64019, NULL, 'G3DSA:1.10.8.1310:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64020, NULL, 'G3DSA:3.40.30.10:FF:001078', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64021, NULL, 'G3DSA:3.40.50.11350:FF:000032', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64022, NULL, 'G3DSA:3.30.470.30:FF:000066', NULL, NULL, 'RNA capping enzyme, nuclear', NULL, NULL, NULL, NULL, NULL, 4),
(64023, NULL, 'G3DSA:1.20.1510.10:FF:000051', NULL, NULL, 'Cation efflux family protein', NULL, NULL, NULL, NULL, NULL, 4),
(64024, NULL, 'G3DSA:3.30.160.60:FF:003143', NULL, NULL, 'ZNF749 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(64025, NULL, 'G3DSA:1.10.472.10:FF:000397', NULL, NULL, 'Cyclin domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(64026, NULL, 'G3DSA:2.130.10.10:FF:004806', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64027, NULL, 'G3DSA:2.60.40.2470:FF:000001', NULL, NULL, 'Thiosulfate oxidation carrier protein SoxY', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(64028, NULL, 'G3DSA:4.10.1240.30:FF:000007', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(64029, NULL, 'G3DSA:1.50.10.20:FF:000033', NULL, NULL, 'Mannan endo-1,6-alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(64030, NULL, 'G3DSA:3.30.387.10:FF:000001', NULL, NULL, 'Envelope glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(64031, NULL, 'G3DSA:3.30.160.60:FF:004368', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64032, NULL, 'G3DSA:1.10.510.10:FF:000498', NULL, NULL, 'U-box domain-containing protein 51', NULL, NULL, NULL, NULL, NULL, 4),
(64033, NULL, 'G3DSA:2.60.120.40:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64034, NULL, 'G3DSA:1.25.40.820:FF:000019', NULL, NULL, 'Putative RNA polymerase II subunit B1 CTD phosphatase rpap2', NULL, NULL, NULL, NULL, NULL, 4),
(64035, NULL, 'G3DSA:3.40.50.300:FF:004369', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(64036, NULL, 'G3DSA:3.40.390.10:FF:000147', NULL, NULL, 'Lethal factor', NULL, NULL, NULL, NULL, NULL, 4),
(64037, NULL, 'G3DSA:3.30.479.30:FF:000024', NULL, NULL, 'Prohibitin-1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(64038, NULL, 'G3DSA:1.20.1560.10:FF:000380', NULL, NULL, 'ABC transporter HlyB/MsbA family', NULL, NULL, NULL, NULL, NULL, 4),
(64039, NULL, 'G3DSA:1.10.150.20:FF:000107', NULL, NULL, 'DNA repair endonuclease XPF', NULL, NULL, NULL, NULL, NULL, 4),
(64040, NULL, 'G3DSA:2.30.29.30:FF:000414', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(64041, NULL, 'G3DSA:3.30.70.330:FF:002029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64042, NULL, 'G3DSA:3.40.50.620:FF:000401', NULL, NULL, 'Isoleucyl-tRNA synthetase (Mitochondrial)', NULL, NULL, NULL, NULL, NULL, 4),
(64043, NULL, 'G3DSA:3.90.226.10:FF:000126', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(64044, NULL, 'G3DSA:1.20.1250.20:FF:002225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64045, NULL, 'G3DSA:3.80.20.20:FF:000062', NULL, NULL, 'Sporulation-specific protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(64046, NULL, 'G3DSA:3.30.230.70:FF:000072', NULL, NULL, 'Exosome complex exonuclease RRP46-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(64047, NULL, 'G3DSA:3.40.309.10:FF:000072', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(64048, NULL, 'G3DSA:3.30.479.20:FF:000021', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(64049, NULL, 'G3DSA:2.40.50.140:FF:000805', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64050, NULL, 'G3DSA:2.30.29.30:FF:000358', NULL, NULL, 'Inner membrane complex sub-compartment protein 1 (ISP1)', NULL, NULL, NULL, NULL, NULL, 4),
(64051, NULL, 'G3DSA:3.40.50.10900:FF:000015', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64052, NULL, 'G3DSA:1.25.40.10:FF:003030', NULL, NULL, 'ERAD-associated E3 ubiquitin-protein ligase component HRD3A', NULL, NULL, NULL, NULL, NULL, 4),
(64053, NULL, 'G3DSA:1.20.1050.10:FF:000296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64054, NULL, 'G3DSA:3.30.1120.30:FF:000023', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(64055, NULL, 'G3DSA:2.60.40.60:FF:000960', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64056, NULL, 'G3DSA:2.40.50.40:FF:000028', NULL, NULL, 'LytR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(64057, NULL, 'G3DSA:3.30.160.60:FF:003233', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64058, NULL, 'G3DSA:2.80.10.70:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64059, NULL, 'G3DSA:3.30.70.120:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64060, NULL, 'G3DSA:1.20.1250.20:FF:000078', NULL, NULL, 'MFS maltose transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(64061, NULL, 'G3DSA:1.10.10.10:FF:001280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(64062, NULL, 'G3DSA:3.30.900.10:FF:000010', NULL, NULL, 'Autophagy-related protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(64063, NULL, 'G3DSA:1.10.10.10:FF:000818', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(64064, NULL, 'G3DSA:3.30.420.10:FF:000400', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64065, NULL, 'G3DSA:3.30.300.130:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64066, NULL, 'G3DSA:1.20.272.10:FF:000037', NULL, NULL, 'DNA polymerase III, delta prime subunit', NULL, NULL, NULL, NULL, NULL, 4),
(64067, NULL, 'G3DSA:1.10.1290.10:FF:000001', NULL, NULL, 'Tegument protein VP16', NULL, NULL, NULL, NULL, NULL, 4),
(64068, NULL, 'G3DSA:3.10.100.10:FF:000195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64069, NULL, 'G3DSA:1.10.1450.10:FF:000149', NULL, NULL, 'Tetraspanin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(64070, NULL, 'G3DSA:3.30.70.330:FF:002557', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64071, NULL, 'G3DSA:3.40.800.10:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64072, NULL, 'G3DSA:1.10.1300.10:FF:000054', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(64073, NULL, 'G3DSA:1.20.58.60:FF:000151', NULL, NULL, 'dystrophin, isoforms A/C/F/G/H isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(64074, NULL, 'G3DSA:1.20.5.170:FF:000171', NULL, NULL, 'Related to spindle assembly checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(64075, NULL, 'G3DSA:3.40.50.300:FF:003205', NULL, NULL, 'CTP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(64076, NULL, 'G3DSA:2.40.30.10:FF:000069', NULL, NULL, 'NADH-cytochrome b5 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(64077, NULL, 'G3DSA:1.20.120.1900:FF:000089', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(64078, NULL, 'G3DSA:3.40.800.20:FF:000048', NULL, NULL, 'Histone deacetylase 6', NULL, NULL, NULL, NULL, NULL, 4),
(64079, NULL, 'G3DSA:1.10.287.2620:FF:000020', NULL, NULL, 'Dynein heavy chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(64080, NULL, 'G3DSA:3.30.200.20:FF:000662', NULL, NULL, 'Cyclin-dependent kinase C-3', NULL, NULL, NULL, NULL, NULL, 4),
(64081, NULL, 'G3DSA:1.25.40.10:FF:000916', NULL, NULL, 'Hat1 interacting factor', NULL, NULL, NULL, NULL, NULL, 4),
(64082, NULL, 'G3DSA:1.10.533.10:FF:000298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64083, NULL, 'G3DSA:3.40.50.720:FF:001589', NULL, NULL, 'Very-long-chain 3-oxoacyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(64084, NULL, 'G3DSA:3.40.50.150:FF:001047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64085, NULL, 'G3DSA:2.60.40.3620:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64086, NULL, 'G3DSA:2.40.230.20:FF:000002', NULL, NULL, 'Nucleoside-specific outer membrane porin OmpK', NULL, NULL, NULL, NULL, NULL, 4),
(64087, NULL, 'G3DSA:2.30.31.20:FF:000001', NULL, NULL, 'SsgA family sporulation/cell division regulator', NULL, NULL, NULL, NULL, NULL, 4),
(64088, NULL, 'G3DSA:3.40.50.300:FF:001058', NULL, NULL, 'ATP-dependent DNA helicase DinG', NULL, NULL, NULL, NULL, NULL, 4),
(64089, NULL, 'G3DSA:1.10.1670.10:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64090, NULL, 'G3DSA:1.10.472.10:FF:000633', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64091, NULL, 'G3DSA:3.60.20.10:FF:000222', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64092, NULL, 'G3DSA:1.25.10.10:FF:000768', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(64093, NULL, 'G3DSA:3.30.70.330:FF:000466', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein HRP1', NULL, NULL, NULL, NULL, NULL, 4),
(64094, NULL, 'G3DSA:3.30.160.60:FF:002570', NULL, NULL, 'Molting defective, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(64095, NULL, 'G3DSA:1.20.1280.290:FF:000107', NULL, NULL, 'Sugar transporter SemiSWEET', NULL, NULL, NULL, NULL, NULL, 4),
(64096, NULL, 'G3DSA:1.25.10.10:FF:000824', NULL, NULL, 'Importin beta-3 family protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(64097, NULL, 'G3DSA:1.20.1260.10:FF:000014', NULL, NULL, 'Bacterioferritin', NULL, NULL, NULL, NULL, NULL, 4),
(64098, NULL, 'G3DSA:1.20.120.1880:FF:000009', NULL, NULL, 'Nuclear Pore complex Protein', NULL, NULL, NULL, NULL, NULL, 4),
(64099, NULL, 'G3DSA:3.10.450.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64100, NULL, 'G3DSA:3.20.20.100:FF:000013', NULL, NULL, 'NADPH-dependent codeinone reductase 1-1', NULL, NULL, NULL, NULL, NULL, 4),
(64101, NULL, 'G3DSA:3.40.20.10:FF:000032', NULL, NULL, 'Drebrin 1', NULL, NULL, NULL, NULL, NULL, 4),
(64102, NULL, 'G3DSA:3.40.50.1000:FF:000744', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64103, NULL, 'G3DSA:3.30.70.870:FF:000044', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(64104, NULL, 'G3DSA:1.25.10.10:FF:003202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64105, NULL, 'G3DSA:1.20.1070.10:FF:002124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64106, NULL, 'G3DSA:3.80.10.10:FF:001749', NULL, NULL, 'FBXL3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(64107, NULL, 'G3DSA:3.50.80.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64108, NULL, 'G3DSA:3.40.50.1000:FF:000688', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64109, NULL, 'G3DSA:3.30.160.60:FF:004694', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64110, NULL, 'G3DSA:1.25.40.10:FF:004811', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64111, NULL, 'G3DSA:3.40.630.10:FF:000447', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64112, NULL, 'G3DSA:3.50.4.10:FF:000029', NULL, NULL, 'Merozoite adhesive erythrocytic binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(64113, NULL, 'G3DSA:2.60.260.20:FF:000106', NULL, NULL, 'DnaJ heat shock protein family (Hsp40) member B1', NULL, NULL, NULL, NULL, NULL, 4),
(64114, NULL, 'G3DSA:1.20.58.60:FF:000830', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64115, NULL, 'G3DSA:2.10.25.10:FF:001761', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64116, NULL, 'G3DSA:3.40.720.10:FF:000100', NULL, NULL, 'YhbX/YhjW/YijP/YjdB family protein', NULL, NULL, NULL, NULL, NULL, 4),
(64117, NULL, 'G3DSA:3.40.50.300:FF:003149', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64118, NULL, 'G3DSA:3.30.559.10:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64119, NULL, 'G3DSA:3.90.1150.10:FF:000460', NULL, NULL, 'Kynureninase', NULL, NULL, NULL, NULL, NULL, 4),
(64120, NULL, 'G3DSA:3.40.50.2300:FF:001022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64121, NULL, 'G3DSA:3.40.640.10:FF:000419', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64122, NULL, 'G3DSA:1.20.920.10:FF:000111', NULL, NULL, 'Bromodomain-containing protein, 140kD, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(64123, NULL, 'G3DSA:3.10.450.50:FF:000087', NULL, NULL, 'RNA-binding (RRM-RBD-RNP motif) domain nuclear transport factor 2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(64124, NULL, 'G3DSA:3.60.70.12:FF:000003', NULL, NULL, 'Putative cysteine transferase', NULL, NULL, NULL, NULL, NULL, 4),
(64125, NULL, 'G3DSA:3.40.50.300:FF:003003', NULL, NULL, 'Si:dkey-7i4.1', NULL, NULL, NULL, NULL, NULL, 4),
(64126, NULL, 'G3DSA:2.30.42.10:FF:000018', NULL, NULL, 'SH3 and multiple ankyrin repeat domains protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(64127, NULL, 'G3DSA:3.40.50.12780:FF:000039', NULL, NULL, 'Peroxisomal-coenzyme A synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(64128, NULL, 'G3DSA:2.30.30.110:FF:000008', NULL, NULL, 'Endoribonuclease MazF3', NULL, NULL, NULL, NULL, NULL, 4),
(64129, NULL, 'G3DSA:2.20.70.10:FF:000151', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(64130, NULL, 'G3DSA:3.60.10.10:FF:000250', NULL, NULL, 'Putative neutral sphingomyelinase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(64131, NULL, 'G3DSA:1.20.1070.10:FF:000033', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(64132, NULL, 'G3DSA:2.40.70.10:FF:000397', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64133, NULL, 'G3DSA:1.20.1090.10:FF:000040', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(64134, NULL, 'G3DSA:1.20.1250.20:FF:000134', NULL, NULL, 'MFS sugar transporter protein', NULL, NULL, NULL, NULL, NULL, 4),
(64135, NULL, 'G3DSA:1.10.8.10:FF:000132', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(64136, NULL, 'G3DSA:3.30.750.24:FF:000163', NULL, NULL, 'Sulfate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(64137, NULL, 'G3DSA:1.20.1420.30:FF:000061', NULL, NULL, 'Na+/Ca+ antiporter, CaCA family', NULL, NULL, NULL, NULL, NULL, 4),
(64138, NULL, 'G3DSA:3.40.50.800:FF:000011', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(64139, NULL, 'G3DSA:1.20.58.60:FF:000353', NULL, NULL, 'VAB-10B protein', NULL, NULL, NULL, NULL, NULL, 4),
(64140, NULL, 'G3DSA:1.20.80.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64141, NULL, 'G3DSA:2.30.30.100:FF:000005', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm4', NULL, NULL, NULL, NULL, NULL, 4),
(64142, NULL, 'G3DSA:3.30.40.10:FF:000551', NULL, NULL, 'RING-H2 finger protein ATL3', NULL, NULL, NULL, NULL, NULL, 4),
(64143, NULL, 'G3DSA:2.130.10.10:FF:004599', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64144, NULL, 'G3DSA:3.10.129.10:FF:000126', NULL, NULL, 'Itaconyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(64145, NULL, 'G3DSA:2.30.29.30:FF:000212', NULL, NULL, 'Dynamin-2A', NULL, NULL, NULL, NULL, NULL, 4),
(64146, NULL, 'G3DSA:3.40.50.300:FF:006078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64147, NULL, 'G3DSA:3.30.450.20:FF:000231', NULL, NULL, 'PAS domain-containing sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(64148, NULL, 'G3DSA:3.80.10.10:FF:004032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64149, NULL, 'G3DSA:3.40.190.10:FF:000637', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(64150, NULL, 'G3DSA:3.30.160.60:FF:003435', NULL, NULL, 'AGAP007883-PA', NULL, NULL, NULL, NULL, NULL, 4),
(64151, NULL, 'G3DSA:2.130.10.10:FF:003441', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64152, NULL, 'G3DSA:3.40.640.10:FF:000482', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64153, NULL, 'G3DSA:3.40.50.720:FF:000285', NULL, NULL, 'Carbonyl reductase family member 4', NULL, NULL, NULL, NULL, NULL, 4),
(64154, NULL, 'G3DSA:1.20.190.20:FF:000001', NULL, NULL, '14-3-3 gamma 1', NULL, NULL, NULL, NULL, NULL, 4),
(64155, NULL, 'G3DSA:3.40.50.300:FF:007218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64156, NULL, 'G3DSA:3.30.40.10:FF:002203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64157, NULL, 'G3DSA:3.40.50.10740:FF:000001', NULL, NULL, 'Murein tetrapeptide carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(64158, NULL, 'G3DSA:2.130.10.10:FF:000861', NULL, NULL, 'WD repeat domain 45B', NULL, NULL, NULL, NULL, NULL, 4),
(64159, NULL, 'G3DSA:3.40.50.720:FF:000341', NULL, NULL, 'very-long-chain 3-oxoacyl-CoA reductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(64160, NULL, 'G3DSA:2.130.10.110:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64161, NULL, 'G3DSA:1.10.1040.10:FF:000011', NULL, NULL, 'putative oxidoreductase GLYR1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(64162, NULL, 'G3DSA:3.30.1490.80:FF:000014', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(64163, NULL, 'G3DSA:2.60.120.10:FF:000739', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64164, NULL, 'G3DSA:3.40.50.620:FF:000603', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(64165, NULL, 'G3DSA:2.30.30.40:FF:000606', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64166, NULL, 'G3DSA:3.40.50.300:FF:005392', NULL, NULL, 'ABC transporter G family member 16', NULL, NULL, NULL, NULL, NULL, 4),
(64167, NULL, 'G3DSA:2.130.10.120:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64168, NULL, 'G3DSA:2.30.30.140:FF:000023', NULL, NULL, 'Hydrogenase assembly chaperone protein HypC', NULL, NULL, NULL, NULL, NULL, 4),
(64169, NULL, 'G3DSA:3.30.160.60:FF:001344', NULL, NULL, 'Zinc finger protein 16 like', NULL, NULL, NULL, NULL, NULL, 4),
(64170, NULL, 'G3DSA:1.25.40.10:FF:000596', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(64171, NULL, 'G3DSA:3.40.47.10:FF:000268', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64172, NULL, 'G3DSA:3.30.1490.70:FF:000011', NULL, NULL, 'LIG3 isoform 10', NULL, NULL, NULL, NULL, NULL, 4),
(64173, NULL, 'G3DSA:3.90.70.10:FF:000628', NULL, NULL, 'Protein CBR-DUO-3', NULL, NULL, NULL, NULL, NULL, 4),
(64174, NULL, 'G3DSA:1.10.150.240:FF:000059', NULL, NULL, 'Predicted phosphatase/phosphohexomutase', NULL, NULL, NULL, NULL, NULL, 4),
(64175, NULL, 'G3DSA:1.25.40.20:FF:001088', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64176, NULL, 'G3DSA:3.40.50.300:FF:005622', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(64177, NULL, 'G3DSA:1.25.40.20:FF:000599', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(64178, NULL, 'G3DSA:2.60.120.590:FF:000027', NULL, NULL, 'Alkylated DNA repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(64179, NULL, 'G3DSA:3.90.1150.10:FF:000308', NULL, NULL, 'Aspartate aminotransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(64180, NULL, 'G3DSA:1.10.287.380:FF:000010', NULL, NULL, 'Macrolide-transport ATP-binding protein ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(64181, NULL, 'G3DSA:2.130.10.10:FF:002952', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(64182, NULL, 'G3DSA:2.60.120.200:FF:000304', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(64183, NULL, 'G3DSA:2.40.33.40:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64184, NULL, 'G3DSA:3.40.50.300:FF:004779', NULL, NULL, 'DExH-box ATP-dependent RNA helicase DExH18 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(64185, NULL, 'G3DSA:3.30.70.20:FF:000117', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64186, NULL, 'G3DSA:3.30.40.10:FF:000056', NULL, NULL, 'Putative E3 ubiquitin-protein ligase NEURL1B', NULL, NULL, NULL, NULL, NULL, 4),
(64187, NULL, 'G3DSA:3.40.532.10:FF:000017', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(64188, NULL, 'G3DSA:3.30.40.10:FF:002147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64189, NULL, 'G3DSA:3.10.180.10:FF:000059', NULL, NULL, 'Glyoxalase-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(64190, NULL, 'G3DSA:3.90.180.10:FF:000058', NULL, NULL, 'Alcohol dehydrogenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(64191, NULL, 'G3DSA:1.25.10.10:FF:002915', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64192, NULL, 'G3DSA:3.40.50.720:FF:002432', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(64193, NULL, 'G3DSA:3.30.470.20:FF:000114', NULL, NULL, 'Putative RimK-like ATP-grasp domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(64194, NULL, 'G3DSA:3.30.160.60:FF:000855', NULL, NULL, 'CDKN1A interacting zinc finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(64195, NULL, 'G3DSA:1.20.5.1940:FF:000003', NULL, NULL, 'Hepatocyte growth factor-regulated tyrosine kinase substrate', NULL, NULL, NULL, NULL, NULL, 4),
(64196, NULL, 'G3DSA:1.10.510.10:FF:004477', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64197, NULL, 'G3DSA:1.25.10.10:FF:001134', NULL, NULL, 'Importin-13 homolog A', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(64198, NULL, 'G3DSA:4.10.60.10:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64199, NULL, 'G3DSA:1.20.58.60:FF:000027', NULL, NULL, 'Microtubule-actin cross-linking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(64200, NULL, 'G3DSA:2.60.40.10:FF:004565', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64201, NULL, 'G3DSA:3.30.160.60:FF:005060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64202, NULL, 'G3DSA:4.10.60.10:FF:000146', NULL, NULL, 'Nucleic acid binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(64203, NULL, 'G3DSA:1.10.510.10:FF:002297', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64204, NULL, 'G3DSA:1.10.460.10:FF:000027', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(64205, NULL, 'G3DSA:3.90.260.10:FF:000059', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64206, NULL, 'G3DSA:3.40.50.1820:FF:001597', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64207, NULL, 'G3DSA:1.10.1410.10:FF:000085', NULL, NULL, 'Nucleolar protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(64208, NULL, 'G3DSA:3.40.30.10:FF:001106', NULL, NULL, 'Glutathione S-transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(64209, NULL, 'G3DSA:2.10.25.10:FF:001435', NULL, NULL, 'LP19846p', NULL, NULL, NULL, NULL, NULL, 4),
(64210, NULL, 'G3DSA:3.30.160.60:FF:002946', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64211, NULL, 'G3DSA:3.40.50.150:FF:001524', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64212, NULL, 'G3DSA:3.40.50.300:FF:001351', NULL, NULL, 'Heat shock protein 101, putative', NULL, NULL, NULL, NULL, NULL, 4),
(64213, NULL, 'G3DSA:2.60.40.10:FF:004475', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64214, NULL, 'G3DSA:2.130.10.10:FF:006044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64215, NULL, 'G3DSA:3.60.150.10:FF:000001', NULL, NULL, 'Chorismate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(64216, NULL, 'G3DSA:1.10.472.10:FF:000689', NULL, NULL, 'Transcription initiation factor IIB (TFIIB)', NULL, NULL, NULL, NULL, NULL, 4),
(64217, NULL, 'G3DSA:1.25.40.180:FF:000052', NULL, NULL, 'Nonsense-mediated mRNA decay factor', NULL, NULL, NULL, NULL, NULL, 4),
(64218, NULL, 'G3DSA:2.40.10.10:FF:000388', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64219, NULL, 'G3DSA:3.40.1170.60:FF:000004', NULL, NULL, 'DNA repair protein REV1', NULL, NULL, NULL, NULL, NULL, 4),
(64220, NULL, 'G3DSA:2.70.150.10:FF:000166', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(64221, NULL, 'G3DSA:3.40.50.300:FF:003531', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(64222, NULL, 'G3DSA:1.10.10.2130:FF:000001', NULL, NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(64223, NULL, 'G3DSA:2.60.40.10:FF:000883', NULL, NULL, 'tenascin-X', NULL, NULL, NULL, NULL, NULL, 4),
(64224, NULL, 'G3DSA:3.90.70.80:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64225, NULL, 'G3DSA:1.10.630.10:FF:000506', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64226, NULL, 'G3DSA:1.10.10.10:FF:000616', NULL, NULL, 'Developmental regulator FlbA', NULL, NULL, NULL, NULL, NULL, 4),
(64227, NULL, 'G3DSA:3.90.190.10:FF:000025', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type 1', NULL, NULL, NULL, NULL, NULL, 4),
(64228, NULL, 'G3DSA:1.20.5.190:FF:000177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64229, NULL, 'G3DSA:1.10.10.60:FF:000996', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64230, NULL, 'G3DSA:3.30.590.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64231, NULL, 'G3DSA:3.30.1370.10:FF:000029', NULL, NULL, 'ankyrin repeat and KH domain-containing protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(64232, NULL, 'G3DSA:3.90.290.10:FF:000033', NULL, NULL, 'Follistatin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(64233, NULL, 'G3DSA:1.20.120.1750:FF:000078', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(64234, NULL, 'G3DSA:3.80.10.10:FF:003992', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64235, NULL, 'G3DSA:1.10.1900.40:FF:000002', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(64236, NULL, 'G3DSA:3.30.260.10:FF:000016', NULL, NULL, 'McKusick-Kaufman syndrome', NULL, NULL, NULL, NULL, NULL, 4),
(64237, NULL, 'G3DSA:3.90.190.20:FF:000028', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(64238, NULL, 'G3DSA:1.25.40.10:FF:005121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64239, NULL, 'G3DSA:1.10.530.10:FF:000089', NULL, NULL, 'Lysozyme g', NULL, NULL, NULL, NULL, NULL, 4),
(64240, NULL, 'G3DSA:3.30.200.20:FF:002516', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64241, NULL, 'G3DSA:1.10.510.10:FF:001190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64242, NULL, 'G3DSA:2.40.30.110:FF:000012', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(64243, NULL, 'G3DSA:3.40.50.300:FF:001906', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64244, NULL, 'G3DSA:3.10.100.10:FF:000313', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64245, NULL, 'G3DSA:3.80.10.10:FF:003666', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64246, NULL, 'G3DSA:3.40.190.10:FF:000727', NULL, NULL, 'Glutamate receptor, ionotropic, AMPA 3a', NULL, NULL, NULL, NULL, NULL, 4),
(64247, NULL, 'G3DSA:2.60.40.2030:FF:000038', NULL, NULL, 'Adhesion G-protein coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(64248, NULL, 'G3DSA:1.25.40.20:FF:000981', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64249, NULL, 'G3DSA:1.20.1730.10:FF:000005', NULL, NULL, 'sodium/glucose cotransporter 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(64250, NULL, 'G3DSA:2.30.29.30:FF:001286', NULL, NULL, 'Histonearginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(64251, NULL, 'G3DSA:3.30.70.330:FF:002383', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64252, NULL, 'G3DSA:1.25.40.470:FF:000015', NULL, NULL, 'Intraflagellar transport particle protein 140', NULL, NULL, NULL, NULL, NULL, 4),
(64253, NULL, 'G3DSA:3.30.420.110:FF:000059', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(64254, NULL, 'G3DSA:3.30.160.60:FF:000945', NULL, NULL, 'POZ-, AT hook-, and zinc finger-containing protein 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(64255, NULL, 'G3DSA:1.25.40.10:FF:000742', NULL, NULL, 'Tetratricopeptide repeat domain 37', NULL, NULL, NULL, NULL, NULL, 4),
(64256, NULL, 'G3DSA:2.60.40.10:FF:001193', NULL, NULL, 'Jitterbug, isoform M', NULL, NULL, NULL, NULL, NULL, 4),
(64257, NULL, 'G3DSA:1.10.10.10:FF:000588', NULL, NULL, 'Ribokinase', NULL, NULL, NULL, NULL, NULL, 4),
(64258, NULL, 'G3DSA:3.40.640.10:FF:000392', NULL, NULL, 'Glutamic-oxaloacetic transaminase 1-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(64259, NULL, 'G3DSA:2.30.30.30:FF:000098', NULL, NULL, '50S ribosomal protein L24', NULL, NULL, NULL, NULL, NULL, 4),
(64260, NULL, 'G3DSA:3.40.50.300:FF:008495', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64261, NULL, 'G3DSA:3.40.50.720:FF:000431', NULL, NULL, 'SUMO-activating enzyme subunit', NULL, NULL, NULL, NULL, NULL, 4),
(64262, NULL, 'G3DSA:1.20.58.900:FF:000024', NULL, NULL, 'Small G protein-signaling modulator 2', NULL, NULL, NULL, NULL, NULL, 4),
(64263, NULL, 'G3DSA:1.10.720.180:FF:000002', NULL, NULL, 'Decaheme cytochrome c MtrF', NULL, NULL, NULL, NULL, NULL, 4),
(64264, NULL, 'G3DSA:3.10.180.10:FF:000054', NULL, NULL, 'Catechol 2,3-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(64265, NULL, 'G3DSA:2.130.10.10:FF:000709', NULL, NULL, 'U3 small nucleolar RNA-associated protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(64266, NULL, 'G3DSA:1.10.510.10:FF:000880', NULL, NULL, 'WEE protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(64267, NULL, 'G3DSA:2.130.10.10:FF:004745', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(64268, NULL, 'G3DSA:3.30.710.10:FF:000124', NULL, NULL, 'Protein CBG09126', NULL, NULL, NULL, NULL, NULL, 4),
(64269, NULL, 'G3DSA:1.20.960.20:FF:000004', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(64270, NULL, 'G3DSA:3.40.50.2300:FF:000533', NULL, NULL, 'Chromosome 16 SCAF15113, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(64271, NULL, 'G3DSA:1.25.40.20:FF:000745', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64272, NULL, 'G3DSA:3.40.50.300:FF:006696', NULL, NULL, 'Elongation factor EF-3', NULL, NULL, NULL, NULL, NULL, 4),
(64273, NULL, 'G3DSA:3.40.50.1820:FF:000164', NULL, NULL, 'Mycophenolic acid acyl-glucuronide esterase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(64274, NULL, 'G3DSA:3.30.1430.10:FF:000001', NULL, NULL, '60S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(64275, NULL, 'G3DSA:3.40.50.2000:FF:000409', NULL, NULL, 'GDP-mannose-dependent alpha-(1-6)-phosphatidylinositol dimannoside mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(64276, NULL, 'G3DSA:1.10.418.10:FF:000047', NULL, NULL, 'Growth arrest specific 2 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(64277, NULL, 'G3DSA:3.40.50.300:FF:006881', NULL, NULL, 'ATP-binding cassette transporter, subfamily G, member 8, group WBC protein PpABCG8', NULL, NULL, NULL, NULL, NULL, 4),
(64278, NULL, 'G3DSA:3.40.190.10:FF:000930', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64279, NULL, 'G3DSA:3.30.200.20:FF:001151', NULL, NULL, 'Glycogen Synthase Kinase Alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(64280, NULL, 'G3DSA:3.30.470.20:FF:000119', NULL, NULL, 'Carbamoyl-phosphate synthase L chain, ATP-binding', NULL, NULL, NULL, NULL, NULL, 4),
(64281, NULL, 'G3DSA:3.30.160.60:FF:004924', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64282, NULL, 'G3DSA:3.30.710.10:FF:000271', NULL, NULL, 'BTB-V protein domain', NULL, NULL, NULL, NULL, NULL, 4),
(64283, NULL, 'G3DSA:3.90.660.10:FF:000140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64284, NULL, 'G3DSA:3.40.50.1100:FF:000095', NULL, NULL, 'serine racemase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(64285, NULL, 'G3DSA:1.20.1560.10:FF:000407', NULL, NULL, 'ABC transporter protein AtrC', NULL, NULL, NULL, NULL, NULL, 4),
(64286, NULL, 'G3DSA:1.10.238.10:FF:000898', NULL, NULL, 'AGAP006116-PA', NULL, NULL, NULL, NULL, NULL, 4),
(64287, NULL, 'G3DSA:2.40.37.20:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64288, NULL, 'G3DSA:1.10.100.10:FF:000006', NULL, NULL, 'Probable insulin-like peptide beta-type 4', NULL, NULL, NULL, NULL, NULL, 4),
(64289, NULL, 'G3DSA:3.30.1520.10:FF:000070', NULL, NULL, 'YPR097W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(64290, NULL, 'G3DSA:3.10.100.10:FF:000369', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64291, NULL, 'G3DSA:2.40.50.140:FF:000098', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(64292, NULL, 'G3DSA:3.30.450.20:FF:000410', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(64293, NULL, 'G3DSA:3.30.420.40:FF:000892', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64294, NULL, 'G3DSA:3.30.420.10:FF:000080', NULL, NULL, 'Small RNA degrading nuclease 3', NULL, NULL, NULL, NULL, NULL, 4),
(64295, NULL, 'G3DSA:2.60.40.1400:FF:000006', NULL, NULL, 'G protein-activated inward rectifier potassium channel 1', NULL, NULL, NULL, NULL, NULL, 4),
(64296, NULL, 'G3DSA:3.30.1560.10:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64297, NULL, 'G3DSA:3.30.70.20:FF:000089', NULL, NULL, 'Indolepyruvate oxidoreductase subunit IorA', NULL, NULL, NULL, NULL, NULL, 4),
(64298, NULL, 'G3DSA:3.30.750.60:FF:000001', NULL, NULL, 'Catalytic beta propeller domain of endosialidase', NULL, NULL, NULL, NULL, NULL, 4),
(64299, NULL, 'G3DSA:3.30.1490.480:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64300, NULL, 'G3DSA:3.40.50.410:FF:000310', NULL, NULL, 'Mesocentin', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(64301, NULL, 'G3DSA:1.20.1070.10:FF:001668', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64302, NULL, 'G3DSA:1.25.40.10:FF:004665', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64303, NULL, 'G3DSA:3.20.20.100:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64304, NULL, 'G3DSA:2.40.70.10:FF:000543', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64305, NULL, 'G3DSA:2.60.120.200:FF:000427', NULL, NULL, 'Laminin, alpha 5', NULL, NULL, NULL, NULL, NULL, 4),
(64306, NULL, 'G3DSA:1.25.40.10:FF:004339', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(64307, NULL, 'G3DSA:2.10.25.10:FF:000305', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(64308, NULL, 'G3DSA:3.30.160.60:FF:004868', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64309, NULL, 'G3DSA:3.40.50.1100:FF:000010', NULL, NULL, 'Cystathionine beta-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(64310, NULL, 'G3DSA:1.25.10.10:FF:001460', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(64311, NULL, 'G3DSA:3.30.40.10:FF:001984', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64312, NULL, 'G3DSA:3.80.10.10:FF:001098', NULL, NULL, 'Leucine rich repeat and phosphatase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(64313, NULL, 'G3DSA:3.30.420.10:FF:000170', NULL, NULL, 'Possible transposase', NULL, NULL, NULL, NULL, NULL, 4),
(64314, NULL, 'G3DSA:1.20.144.10:FF:000015', NULL, NULL, 'Aureobasidin resistance protein Aur1', NULL, NULL, NULL, NULL, NULL, 4),
(64315, NULL, 'G3DSA:1.10.1420.10:FF:000147', NULL, NULL, 'DNA mismatch repair protein msh3', NULL, NULL, NULL, NULL, NULL, 4),
(64316, NULL, 'G3DSA:1.10.287.20:FF:000003', NULL, NULL, 'Cytochrome b-c1 complex subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(64317, NULL, 'G3DSA:3.30.160.60:FF:005150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64318, NULL, 'G3DSA:1.25.10.10:FF:000914', NULL, NULL, 'Protein CBG03194', NULL, NULL, NULL, NULL, NULL, 4),
(64319, NULL, 'G3DSA:3.40.718.10:FF:000005', NULL, NULL, 'Isocitrate dehydrogenase [NADP]', NULL, NULL, NULL, NULL, NULL, 4),
(64320, NULL, 'G3DSA:1.20.58.760:FF:000016', NULL, NULL, 'Transmembrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(64321, NULL, 'G3DSA:2.40.160.210:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64322, NULL, 'G3DSA:3.40.50.1110:FF:000013', NULL, NULL, 'Putative lipase/acylhydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(64323, NULL, 'G3DSA:2.30.29.30:FF:000353', NULL, NULL, 'Nuclear pore complex protein NUP50A', NULL, NULL, NULL, NULL, NULL, 4),
(64324, NULL, 'G3DSA:1.10.220.10:FF:000009', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(64325, NULL, 'G3DSA:1.20.1720.10:FF:000033', NULL, NULL, 'Multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(64326, NULL, 'G3DSA:1.10.533.10:FF:000096', NULL, NULL, 'Neurotrophin receptor associated death domain', NULL, NULL, NULL, NULL, NULL, 4),
(64327, NULL, 'G3DSA:3.40.50.620:FF:000108', NULL, NULL, 'Ethanolamine-phosphate cytidylyltransferase isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(64328, NULL, 'G3DSA:3.30.565.10:FF:000371', NULL, NULL, 'Sensory box histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(64329, NULL, 'G3DSA:1.20.1310.10:FF:000193', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64330, NULL, 'G3DSA:2.30.30.40:FF:000286', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(64331, NULL, 'G3DSA:3.30.420.40:FF:000089', NULL, NULL, 'Actin, alpha skeletal muscle', NULL, NULL, NULL, NULL, NULL, 4),
(64332, NULL, 'G3DSA:1.10.150.240:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64333, NULL, 'G3DSA:1.10.150.240:FF:000087', NULL, NULL, 'Phosphoglycolate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(64334, NULL, 'G3DSA:3.90.830.10:FF:000024', NULL, NULL, 'Vacuolar protein sorting-associated protein 33', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(64335, NULL, 'G3DSA:3.40.50.920:FF:000047', NULL, NULL, 'Pyruvate ferredoxin oxidoreductase D', NULL, NULL, NULL, NULL, NULL, 4),
(64336, NULL, 'G3DSA:1.20.1070.10:FF:000179', NULL, NULL, 'Probable G-protein coupled receptor 75', NULL, NULL, NULL, NULL, NULL, 4),
(64337, NULL, 'G3DSA:3.20.20.100:FF:000215', NULL, NULL, 'Sorting nexin 2B', NULL, NULL, NULL, NULL, NULL, 4),
(64338, NULL, 'G3DSA:1.20.960.10:FF:000001', NULL, NULL, 'Mitochondrial import receptor subunit TOM20 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(64339, NULL, 'G3DSA:2.40.420.20:FF:000011', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(64340, NULL, 'G3DSA:1.10.10.60:FF:000991', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64341, NULL, 'G3DSA:3.30.160.60:FF:000653', NULL, NULL, 'Zinc finger protein Pegasus', NULL, NULL, NULL, NULL, NULL, 4),
(64342, NULL, 'G3DSA:1.25.40.10:FF:004957', NULL, NULL, 'Developmental protein DG1091', NULL, NULL, NULL, NULL, NULL, 4),
(64343, NULL, 'G3DSA:3.40.50.11210:FF:000013', NULL, NULL, 'Rap/Ran GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(64344, NULL, 'G3DSA:3.30.750.70:FF:000004', NULL, NULL, 'Acetyl-CoA hydrolase/transferase', NULL, NULL, NULL, NULL, NULL, 4),
(64345, NULL, 'G3DSA:3.30.70.330:FF:002181', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64346, NULL, 'G3DSA:3.30.497.10:FF:000178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64347, NULL, 'G3DSA:3.20.20.140:FF:000031', NULL, NULL, 'ribonuclease P protein subunit p30', NULL, NULL, NULL, NULL, NULL, 4),
(64348, NULL, 'G3DSA:3.30.70.330:FF:001692', NULL, NULL, 'LD21345p', NULL, NULL, NULL, NULL, NULL, 4),
(64349, NULL, 'G3DSA:3.30.160.60:FF:003109', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64350, NULL, 'G3DSA:3.90.180.10:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64351, NULL, 'G3DSA:1.20.1250.20:FF:002023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64352, NULL, 'G3DSA:3.90.226.10:FF:000036', NULL, NULL, 'p-hydroxycinnamoyl CoA hydratase/lyase', NULL, NULL, NULL, NULL, NULL, 4),
(64353, NULL, 'G3DSA:3.90.70.10:FF:000831', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64354, NULL, 'G3DSA:3.90.550.50:FF:000060', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(64355, NULL, 'G3DSA:3.40.50.1240:FF:000176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64356, NULL, 'G3DSA:3.80.10.10:FF:003576', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64357, NULL, 'G3DSA:3.40.50.360:FF:000036', NULL, NULL, 'NADPH--cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(64358, NULL, 'G3DSA:3.40.50.720:FF:002229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64359, NULL, 'G3DSA:1.10.510.10:FF:000728', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(64360, NULL, 'G3DSA:3.10.250.10:FF:000088', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64361, NULL, 'G3DSA:4.10.400.10:FF:000259', NULL, NULL, 'LDL receptor protein 1, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(64362, NULL, 'G3DSA:1.25.10.10:FF:002393', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64363, NULL, 'G3DSA:3.30.160.20:FF:000130', NULL, NULL, 'Endoribonuclease Dicer-like 2 isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(64364, NULL, 'G3DSA:1.25.40.20:FF:000655', NULL, NULL, 'GM18187', NULL, NULL, NULL, NULL, NULL, 4),
(64365, NULL, 'G3DSA:3.10.10.10:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64366, NULL, 'G3DSA:3.20.20.220:FF:000049', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(64367, NULL, 'G3DSA:2.60.40.2170:FF:000001', NULL, NULL, 'WNT inhibitory factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(64368, NULL, 'G3DSA:3.90.70.10:FF:000775', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64369, NULL, 'G3DSA:3.40.190.180:FF:000001', NULL, NULL, 'High affinity transport system protein p37', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(64370, NULL, 'G3DSA:3.90.1150.10:FF:000073', NULL, NULL, 'Cystathionine gamma-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(64371, NULL, 'G3DSA:3.20.20.150:FF:000034', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(64372, NULL, 'G3DSA:3.40.50.620:FF:000081', NULL, NULL, 'Asparagine synthetase (Glutamine-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4),
(64373, NULL, 'G3DSA:3.30.2230.10:FF:000020', NULL, NULL, 'Probable ubiquitin carboxyl-terminal hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(64374, NULL, 'G3DSA:1.10.357.10:FF:000085', NULL, NULL, 'TetR family transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(64375, NULL, 'G3DSA:2.130.10.10:FF:004127', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(64376, NULL, 'G3DSA:3.40.50.300:FF:002986', NULL, NULL, 'AAA family ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(64377, NULL, 'G3DSA:1.25.40.20:FF:001291', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64378, NULL, 'G3DSA:3.40.190.10:FF:000109', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(64379, NULL, 'G3DSA:1.10.10.10:FF:000498', NULL, NULL, 'Telomere repeat-binding factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(64380, NULL, 'G3DSA:3.40.50.10440:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64381, NULL, 'G3DSA:1.10.238.10:FF:001264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64382, NULL, 'G3DSA:2.60.40.150:FF:000549', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(64383, NULL, 'G3DSA:3.40.390.10:FF:000265', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64384, NULL, 'G3DSA:1.10.8.60:FF:000012', NULL, NULL, 'Replication factor C subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(64385, NULL, 'G3DSA:1.10.238.10:FF:000775', NULL, NULL, 'Calcium-binding EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(64386, NULL, 'G3DSA:2.30.30.110:FF:000003', NULL, NULL, 'mRNA interferase', NULL, NULL, NULL, NULL, NULL, 4),
(64387, NULL, 'G3DSA:2.130.10.10:FF:003025', NULL, NULL, 'WD40-repeat-containing domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(64388, NULL, 'G3DSA:3.50.7.10:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64389, NULL, 'G3DSA:1.10.510.10:FF:001217', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(64390, NULL, 'G3DSA:1.10.1370.10:FF:000002', NULL, NULL, 'Oligopeptidase A', NULL, NULL, NULL, NULL, NULL, 4),
(64391, NULL, 'G3DSA:3.80.10.10:FF:002115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64392, NULL, 'G3DSA:2.130.10.10:FF:000384', NULL, NULL, 'WD repeat containing, antisense to TP73', NULL, NULL, NULL, NULL, NULL, 4),
(64393, NULL, 'G3DSA:3.30.460.10:FF:000200', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64394, NULL, 'G3DSA:3.40.50.1980:FF:000077', NULL, NULL, 'Probable FeIII-dicitrate-binding periplasmic lipoprotein fecB', NULL, NULL, NULL, NULL, NULL, 4),
(64395, NULL, 'G3DSA:1.10.10.60:FF:000373', NULL, NULL, 'Blast:Brain-specific homeobox protein', NULL, NULL, NULL, NULL, NULL, 4),
(64396, NULL, 'G3DSA:3.30.160.60:FF:003261', NULL, NULL, 'Zinc finger protein 860', NULL, NULL, NULL, NULL, NULL, 4),
(64397, NULL, 'G3DSA:3.30.565.10:FF:000404', NULL, NULL, 'Sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(64398, NULL, 'G3DSA:3.30.40.10:FF:002350', NULL, NULL, 'Peroxisome biogenesis factor 10-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(64399, NULL, 'G3DSA:3.40.50.720:FF:000515', NULL, NULL, 'Ubiquitin-activating enzyme E1', NULL, NULL, NULL, NULL, NULL, 4),
(64400, NULL, 'G3DSA:2.60.40.10:FF:002497', NULL, NULL, 'Beat-VII', NULL, NULL, NULL, NULL, NULL, 4),
(64401, NULL, 'G3DSA:2.10.25.10:FF:000131', NULL, NULL, 'Fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(64402, NULL, 'G3DSA:1.20.58.1070:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(64403, NULL, 'G3DSA:2.40.70.10:FF:000487', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64404, NULL, 'G3DSA:1.10.132.60:FF:000050', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(64405, NULL, 'G3DSA:1.10.400.10:FF:000046', NULL, NULL, 'Guanine nucleotide-binding protein G(O) subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(64406, NULL, 'G3DSA:2.40.70.10:FF:000217', NULL, NULL, 'Chromosome 16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(64407, NULL, 'G3DSA:3.40.50.10140:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64408, NULL, 'G3DSA:3.30.1360.120:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64409, NULL, 'G3DSA:3.60.130.10:FF:000062', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64410, NULL, 'G3DSA:3.40.50.1760:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64411, NULL, 'G3DSA:3.40.50.1780:FF:000017', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', NULL, NULL, NULL, NULL, NULL, 4),
(64412, NULL, 'G3DSA:3.40.50.300:FF:002839', NULL, NULL, 'p-glycoprotein 6, putative', NULL, NULL, NULL, NULL, NULL, 4),
(64413, NULL, 'G3DSA:1.20.80.10:FF:000070', NULL, NULL, 'E3 ubiquitin-protein ligase MYLIP', NULL, NULL, NULL, NULL, NULL, 4),
(64414, NULL, 'G3DSA:3.80.10.10:FF:002205', NULL, NULL, 'NLR family CARD domain-containing 6', NULL, NULL, NULL, NULL, NULL, 4),
(64415, NULL, 'G3DSA:1.10.287.70:FF:000411', NULL, NULL, 'TWiK family of potassium channels', NULL, NULL, NULL, NULL, NULL, 4),
(64416, NULL, 'G3DSA:1.10.287.110:FF:000446', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64417, NULL, 'G3DSA:3.40.50.300:FF:003475', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64418, NULL, 'G3DSA:3.10.100.10:FF:000285', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64419, NULL, 'G3DSA:3.30.70.3460:FF:000001', NULL, NULL, 'Heme d1 biosynthesis protein NirG', NULL, NULL, NULL, NULL, NULL, 4),
(64420, NULL, 'G3DSA:1.25.40.20:FF:001144', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(64421, NULL, 'G3DSA:3.30.470.160:FF:000016', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(64422, NULL, 'G3DSA:2.60.40.10:FF:002676', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase dep-1', NULL, NULL, NULL, NULL, NULL, 4),
(64423, NULL, 'G3DSA:3.30.200.20:FF:000044', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(64424, NULL, 'G3DSA:1.10.238.10:FF:000954', NULL, NULL, 'EF-hand domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(64425, NULL, 'G3DSA:1.10.800.10:FF:000014', NULL, NULL, 'Tyrosine/tryptophan monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(64426, NULL, 'G3DSA:3.40.50.300:FF:007191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64427, NULL, 'G3DSA:2.120.10.80:FF:000118', NULL, NULL, 'F-box/kelch-repeat protein At1g55270', NULL, NULL, NULL, NULL, NULL, 4),
(64428, NULL, 'G3DSA:3.30.46.10:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64429, NULL, 'G3DSA:1.25.40.80:FF:000010', NULL, NULL, 'Phr1p', NULL, NULL, NULL, NULL, NULL, 4),
(64430, NULL, 'G3DSA:4.10.800.10:FF:000014', NULL, NULL, 'Thyroglobulin', NULL, NULL, NULL, NULL, NULL, 4),
(64431, NULL, 'G3DSA:2.40.30.10:FF:000097', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(64432, NULL, 'G3DSA:3.40.50.2000:FF:000033', NULL, NULL, '2-hydroxyacylsphingosine 1-beta-galactosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(64433, NULL, 'G3DSA:2.130.10.10:FF:003115', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(64434, NULL, 'G3DSA:1.10.8.540:FF:000003', NULL, NULL, 'Flagellar biosynthesis protein FlhA', NULL, NULL, NULL, NULL, NULL, 4),
(64435, NULL, 'G3DSA:3.40.140.10:FF:000163', NULL, NULL, 'Apolipoprotein B mRNA editing enzyme catalytic subunit 3B', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(64436, NULL, 'G3DSA:1.20.1070.10:FF:001758', NULL, NULL, 'Beta-1 adrenergic receptor', NULL, NULL, NULL, NULL, NULL, 4),
(64437, NULL, 'G3DSA:2.60.40.10:FF:003019', NULL, NULL, 'B6.2', NULL, NULL, NULL, NULL, NULL, 4),
(64438, NULL, 'G3DSA:1.25.40.90:FF:000013', NULL, NULL, 'U2 snRNP-associated SURP motif-containing protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(64439, NULL, 'G3DSA:4.10.800.20:FF:000017', NULL, NULL, 'ADR119Wp', NULL, NULL, NULL, NULL, NULL, 4),
(64440, NULL, 'G3DSA:2.60.40.1120:FF:000046', NULL, NULL, 'Carboxypeptidase A', NULL, NULL, NULL, NULL, NULL, 4),
(64441, NULL, 'G3DSA:3.30.160.60:FF:005234', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64442, NULL, 'G3DSA:1.10.486.10:FF:000013', NULL, NULL, 'ATP-dependent DNA helicase Rep', NULL, NULL, NULL, NULL, NULL, 4),
(64443, NULL, 'G3DSA:3.40.50.300:FF:005420', NULL, NULL, 'Atlastin-2', NULL, NULL, NULL, NULL, NULL, 4),
(64444, NULL, 'G3DSA:3.75.10.10:FF:000014', NULL, NULL, 'N-dimethylarginine dimethylaminohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(64445, NULL, 'G3DSA:3.40.50.300:FF:003823', NULL, NULL, 'SNF2 family helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(64446, NULL, 'G3DSA:1.25.40.10:FF:000652', NULL, NULL, 'Bacterial transcriptional activator domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(64447, NULL, 'G3DSA:3.90.79.10:FF:000295', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(64448, NULL, 'G3DSA:3.30.1490.190:FF:000011', NULL, NULL, 'Fur family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(64449, NULL, 'G3DSA:3.30.830.10:FF:000066', NULL, NULL, 'Putative zinc protease mug138', NULL, NULL, NULL, NULL, NULL, 4),
(64450, NULL, 'G3DSA:2.60.120.10:FF:000071', NULL, NULL, 'XRE family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(64451, NULL, 'G3DSA:1.20.1250.20:FF:000281', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(64452, NULL, 'G3DSA:3.40.570.10:FF:000009', NULL, NULL, 'Endonuclease domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(64453, NULL, 'G3DSA:3.40.50.10140:FF:000001', NULL, NULL, 'Toll-like receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(64454, NULL, 'G3DSA:3.10.600.10:FF:000008', NULL, NULL, 'Pyruvate carboxylase b', NULL, NULL, NULL, NULL, NULL, 4),
(64455, NULL, 'G3DSA:1.25.40.10:FF:003322', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g16860', NULL, NULL, NULL, NULL, NULL, 4),
(64456, NULL, 'G3DSA:3.40.50.300:FF:005004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64457, NULL, 'G3DSA:3.40.50.720:FF:000195', NULL, NULL, 'Glyoxylate reductase/hydroxypyruvate reductase b', NULL, NULL, NULL, NULL, NULL, 4),
(64458, NULL, 'G3DSA:3.30.730.10:FF:000007', NULL, NULL, 'ethylene-responsive transcription factor-like protein At4g13040', NULL, NULL, NULL, NULL, NULL, 4),
(64459, NULL, 'G3DSA:3.40.190.10:FF:000553', NULL, NULL, 'DNA-binding transcriptional activator GcvA', NULL, NULL, NULL, NULL, NULL, 4),
(64460, NULL, 'G3DSA:3.20.20.190:FF:000023', NULL, NULL, 'Glycerophosphodiester phosphodiesterase GDPD5', NULL, NULL, NULL, NULL, NULL, 4),
(64461, NULL, 'G3DSA:2.60.40.60:FF:000757', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64462, NULL, 'G3DSA:2.130.10.10:FF:004571', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64463, NULL, 'G3DSA:2.60.40.10:FF:003986', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64464, NULL, 'G3DSA:3.30.60.20:FF:000061', NULL, NULL, 'Kinase suppressor of Ras', NULL, NULL, NULL, NULL, NULL, 4),
(64465, NULL, 'G3DSA:1.10.8.1220:FF:000003', NULL, NULL, 'Dynein cytoplasmic 2 heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(64466, NULL, 'G3DSA:2.60.470.10:FF:000001', NULL, NULL, 'Acid-sensing (proton-gated) ion channel family member 4a', NULL, NULL, NULL, NULL, NULL, 4),
(64467, NULL, 'G3DSA:3.40.50.300:FF:002840', NULL, NULL, 'Pre-mRNA splicing factor ATP-dependent RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(64468, NULL, 'G3DSA:3.30.200.20:FF:000370', NULL, NULL, 'Receptor-like protein kinase 4', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(64469, NULL, 'G3DSA:2.30.30.100:FF:000146', NULL, NULL, 'SnRNP Sm-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(64470, NULL, 'G3DSA:2.60.490.10:FF:000002', NULL, NULL, 'P2X purinoceptor', NULL, NULL, NULL, NULL, NULL, 4),
(64471, NULL, 'G3DSA:3.40.50.150:FF:000827', NULL, NULL, 'Magnesium-protoporphyrin O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(64472, NULL, 'G3DSA:2.30.30.40:FF:000516', NULL, NULL, 'zinc finger protein (ZZ-type)-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(64473, NULL, 'G3DSA:3.50.50.60:FF:000560', NULL, NULL, 'Opine oxidase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(64474, NULL, 'G3DSA:2.130.10.10:FF:001401', NULL, NULL, 'Dug2p', NULL, NULL, NULL, NULL, NULL, 4),
(64475, NULL, 'G3DSA:2.40.340.10:FF:000002', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(64476, NULL, 'G3DSA:1.25.10.10:FF:002680', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64477, NULL, 'G3DSA:3.30.710.10:FF:000501', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64478, NULL, 'G3DSA:2.60.40.10:FF:001423', NULL, NULL, 'Ig heavy chain V region 5-84', NULL, NULL, NULL, NULL, NULL, 4),
(64479, NULL, 'G3DSA:1.25.40.10:FF:001231', NULL, NULL, 'Pentatricopeptide repeat-containing protein ELI1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(64480, NULL, 'G3DSA:3.40.50.2000:FF:000235', NULL, NULL, 'Lipopolysaccharide core biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(64481, NULL, 'G3DSA:3.30.70.240:FF:000029', NULL, NULL, 'CRISPR-associated endoribonuclease Cas2', NULL, NULL, NULL, NULL, NULL, 4),
(64482, NULL, 'G3DSA:3.40.50.300:FF:004925', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64483, NULL, 'G3DSA:1.10.150.240:FF:000031', NULL, NULL, 'HAD hydrolase, family IA, variant 3', NULL, NULL, NULL, NULL, NULL, 4),
(64484, NULL, 'G3DSA:3.80.10.10:FF:002031', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(64485, NULL, 'G3DSA:2.30.29.30:FF:000066', NULL, NULL, 'FERM and PDZ domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(64486, NULL, 'G3DSA:2.160.10.10:FF:000079', NULL, NULL, 'Nucleotidyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(64487, NULL, 'G3DSA:1.20.142.10:FF:000033', NULL, NULL, 'Poly [ADP-ribose] polymerase tankyrase', NULL, NULL, NULL, NULL, NULL, 4),
(64488, NULL, 'G3DSA:3.30.200.20:FF:002129', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64489, NULL, 'G3DSA:1.10.510.10:FF:003460', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64490, NULL, 'G3DSA:3.40.190.10:FF:000082', NULL, NULL, 'ATP phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(64491, NULL, 'G3DSA:1.20.1250.20:FF:001860', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64492, NULL, 'G3DSA:1.25.10.10:FF:000678', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(64493, NULL, 'G3DSA:3.40.50.720:FF:001774', NULL, NULL, 'Ketopantoate reductase PanE/ApbA-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(64494, NULL, 'G3DSA:3.90.45.10:FF:000031', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(64495, NULL, 'G3DSA:2.60.200.20:FF:000075', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(64496, NULL, 'G3DSA:1.10.287.130:FF:000132', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(64497, NULL, 'G3DSA:3.40.1190.20:FF:000016', NULL, NULL, 'Sulfofructose kinase', NULL, NULL, NULL, NULL, NULL, 4),
(64498, NULL, 'G3DSA:3.30.70.330:FF:000758', NULL, NULL, 'CUGBP Elav-like family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(64499, NULL, 'G3DSA:3.30.50.10:FF:000175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64500, NULL, 'G3DSA:2.30.29.30:FF:000027', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(64501, NULL, 'G3DSA:3.40.50.150:FF:000884', NULL, NULL, 'tRNA (Uracil-5-)-methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(64502, NULL, 'G3DSA:1.25.40.10:FF:005031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64503, NULL, 'G3DSA:3.40.1170.10:FF:000012', NULL, NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(64504, NULL, 'G3DSA:2.80.10.50:FF:000286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64505, NULL, 'G3DSA:3.30.70.330:FF:002416', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64506, NULL, 'G3DSA:3.90.1150.10:FF:000218', NULL, NULL, 'Ornithine--oxo-acid transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(64507, NULL, 'G3DSA:2.170.270.10:FF:000128', NULL, NULL, 'SMYD family member 5', NULL, NULL, NULL, NULL, NULL, 4),
(64508, NULL, 'G3DSA:3.40.1190.10:FF:000013', NULL, NULL, 'UDP-N-acetylmuramoyl-L-alanyl-D-glutamate--2,6-diaminopimelate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(64509, NULL, 'G3DSA:3.30.200.20:FF:002461', NULL, NULL, 'Myosin, light chain kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(64510, NULL, 'G3DSA:2.10.25.10:FF:000041', NULL, NULL, 'matrilin-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(64511, NULL, 'G3DSA:3.50.50.60:FF:000447', NULL, NULL, 'Guanosine nucleotide diphosphate dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(64512, NULL, 'G3DSA:1.10.510.10:FF:001223', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64513, NULL, 'G3DSA:1.25.40.20:FF:001234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64514, NULL, 'G3DSA:3.60.40.10:FF:000313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64515, NULL, 'G3DSA:1.20.1250.20:FF:000426', NULL, NULL, 'Sugar baby, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(64516, NULL, 'G3DSA:3.40.50.300:FF:001261', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(64517, NULL, 'G3DSA:3.50.50.60:FF:000503', NULL, NULL, 'Putative malatequinone oxidoreductase protein', NULL, NULL, NULL, NULL, NULL, 4),
(64518, NULL, 'G3DSA:1.25.10.10:FF:000971', NULL, NULL, 'Protein CELLULOSE SYNTHASE INTERACTIVE 1', NULL, NULL, NULL, NULL, NULL, 4),
(64519, NULL, 'G3DSA:3.10.310.10:FF:000054', NULL, NULL, 'Trans-L-3-hydroxyproline dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(64520, NULL, 'G3DSA:1.25.40.10:FF:004249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64521, NULL, 'G3DSA:2.10.70.20:FF:000002', NULL, NULL, 'General secretion pathway protein J', NULL, NULL, NULL, NULL, NULL, 4),
(64522, NULL, 'G3DSA:3.10.20.90:FF:000664', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64523, NULL, 'G3DSA:2.40.50.140:FF:001025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64524, NULL, 'G3DSA:3.40.30.10:FF:000943', NULL, NULL, 'Peroxiredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(64525, NULL, 'G3DSA:3.40.50.300:FF:001204', NULL, NULL, 'Small GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(64526, NULL, 'G3DSA:3.30.70.20:FF:000090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64527, NULL, 'G3DSA:1.10.150.20:FF:000310', NULL, NULL, 'DNA topoisomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(64528, NULL, 'G3DSA:3.30.160.60:FF:006493', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64529, NULL, 'G3DSA:3.90.550.10:FF:000632', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64530, NULL, 'G3DSA:1.10.510.10:FF:000436', NULL, NULL, 'NIMA related kinase 11', NULL, NULL, NULL, NULL, NULL, 4),
(64531, NULL, 'G3DSA:3.90.1150.10:FF:000275', NULL, NULL, 'kynurenine--oxoglutarate transaminase 1', NULL, NULL, NULL, NULL, NULL, 4),
(64532, NULL, 'G3DSA:3.80.10.10:FF:001952', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3', NULL, NULL, NULL, NULL, NULL, 4),
(64533, NULL, 'G3DSA:3.100.10.10:FF:000004', NULL, NULL, '50S ribosomal protein L15', NULL, NULL, NULL, NULL, NULL, 4),
(64534, NULL, 'G3DSA:3.40.50.10860:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(64535, NULL, 'G3DSA:2.40.280.10:FF:000002', NULL, NULL, 'SsrA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(64536, NULL, 'G3DSA:2.70.170.10:FF:000257', NULL, NULL, 'Protein CBG01602', NULL, NULL, NULL, NULL, NULL, 4),
(64537, NULL, 'G3DSA:3.40.630.30:FF:000695', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64538, NULL, 'G3DSA:3.40.50.1000:FF:000396', NULL, NULL, 'GH10306p', NULL, NULL, NULL, NULL, NULL, 4),
(64539, NULL, 'G3DSA:1.10.287.130:FF:000019', NULL, NULL, 'Sensor histidine kinase RcsC', NULL, NULL, NULL, NULL, NULL, 4),
(64540, NULL, 'G3DSA:3.40.50.300:FF:004638', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(64541, NULL, 'G3DSA:3.40.50.10310:FF:000018', NULL, NULL, 'Creatininase', NULL, NULL, NULL, NULL, NULL, 4),
(64542, NULL, 'G3DSA:1.25.10.10:FF:002387', NULL, NULL, 'Sister chromatid cohesion protein PDS5 homolog B-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(64543, NULL, 'G3DSA:3.30.710.10:FF:000208', NULL, NULL, 'Ethylene-overproduction protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(64544, NULL, 'G3DSA:2.130.10.10:FF:004419', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64545, NULL, 'G3DSA:3.40.50.1820:FF:001474', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64546, NULL, 'G3DSA:3.30.56.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64547, NULL, 'G3DSA:2.60.120.340:FF:000003', NULL, NULL, 'Nucleoplasmin 2', NULL, NULL, NULL, NULL, NULL, 4),
(64548, NULL, 'G3DSA:2.60.40.60:FF:001123', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64549, NULL, 'G3DSA:3.30.420.390:FF:000007', NULL, NULL, 'DNA polymerase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(64550, NULL, 'G3DSA:1.20.5.370:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64551, NULL, 'G3DSA:4.10.1240.30:FF:000002', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(64552, NULL, 'G3DSA:1.10.238.10:FF:001090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64553, NULL, 'G3DSA:3.30.160.60:FF:004363', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64554, NULL, 'G3DSA:1.10.238.10:FF:000628', NULL, NULL, 'Serine/threonine-protein phosphatase 2A regulatory subunit B'''' subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(64555, NULL, 'G3DSA:1.20.58.60:FF:000206', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(64556, NULL, 'G3DSA:1.20.1250.20:FF:002079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64557, NULL, 'G3DSA:3.30.200.20:FF:000572', NULL, NULL, 'Interleukin-1 receptor-associated kinase', NULL, NULL, NULL, NULL, NULL, 4),
(64558, NULL, 'G3DSA:2.130.10.30:FF:000103', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64559, NULL, 'G3DSA:2.60.210.10:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64560, NULL, 'G3DSA:3.30.160.60:FF:001108', NULL, NULL, 'GLI family zinc finger 4', NULL, NULL, NULL, NULL, NULL, 4),
(64561, NULL, 'G3DSA:1.10.287.70:FF:000698', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64562, NULL, 'G3DSA:3.30.540.10:FF:000055', NULL, NULL, 'WGS project CABT00000000 data, contig 2.2', NULL, NULL, NULL, NULL, NULL, 4),
(64563, NULL, 'G3DSA:1.25.40.10:FF:004626', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64564, NULL, 'G3DSA:3.40.30.10:FF:001073', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64565, NULL, 'G3DSA:1.25.10.10:FF:002567', NULL, NULL, 'DNA repair/transcription protein met18/mms19, putative', NULL, NULL, NULL, NULL, NULL, 4),
(64566, NULL, 'G3DSA:3.30.1510.10:FF:000002', NULL, NULL, 'C-1-tetrahydrofolate synthase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(64567, NULL, 'G3DSA:1.20.1070.10:FF:001489', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64568, NULL, 'G3DSA:2.60.120.260:FF:000277', NULL, NULL, 'Arabinogalactan endo-beta-1,4-galactanase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(64569, NULL, 'G3DSA:3.40.50.1910:FF:000039', NULL, NULL, 'Syntaxin-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(64570, NULL, 'G3DSA:3.30.200.20:FF:002168', NULL, NULL, 'Serine/threonine protein kinase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(64571, NULL, 'G3DSA:1.10.510.10:FF:001043', NULL, NULL, 'YMR291W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(64572, NULL, 'G3DSA:1.10.10.60:FF:000665', NULL, NULL, 'Myb domain protein 101', NULL, NULL, NULL, NULL, NULL, 4),
(64573, NULL, 'G3DSA:2.130.10.10:FF:000619', NULL, NULL, 'U3 snoRNA-associated small subunit rRNA processing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(64574, NULL, 'G3DSA:1.20.120.350:FF:000185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64575, NULL, 'G3DSA:3.30.70.330:FF:002703', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64576, NULL, 'G3DSA:3.30.420.40:FF:000358', NULL, NULL, 'Acetate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(64577, NULL, 'G3DSA:2.130.10.10:FF:002328', NULL, NULL, 'Flagellar outer dynein arm intermediate chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(64578, NULL, 'G3DSA:2.60.40.10:FF:003132', NULL, NULL, 'Usher syndrome 2A (autosomal recessive, mild)', NULL, NULL, NULL, NULL, NULL, 4),
(64579, NULL, 'G3DSA:3.40.50.300:FF:003059', NULL, NULL, 'GTP-binding nuclear protein', NULL, NULL, NULL, NULL, NULL, 4),
(64580, NULL, 'G3DSA:1.20.920.30:FF:000066', NULL, NULL, 'Dynein heavy chain 3', NULL, NULL, NULL, NULL, NULL, 4),
(64581, NULL, 'G3DSA:2.40.50.140:FF:000244', NULL, NULL, 'Single-stranded DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(64582, NULL, 'G3DSA:1.20.140.150:FF:000078', NULL, NULL, 'Potential membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(64583, NULL, 'G3DSA:3.30.70.1230:FF:000001', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(64584, NULL, 'G3DSA:3.60.15.10:FF:000148', NULL, NULL, 'Beta-lactamase', NULL, NULL, NULL, NULL, NULL, 4),
(64585, NULL, 'G3DSA:2.40.260.10:FF:000001', NULL, NULL, 'Class A sortase SrtA', NULL, NULL, NULL, NULL, NULL, 4),
(64586, NULL, 'G3DSA:3.40.50.2300:FF:000443', NULL, NULL, 'Glutamate ionotropic receptor NMDA type subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(64587, NULL, 'G3DSA:2.130.10.10:FF:000676', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(64588, NULL, 'G3DSA:3.40.50.1000:FF:000598', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64589, NULL, 'G3DSA:3.40.50.620:FF:000255', NULL, NULL, 'Probable nicotinate-nucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(64590, NULL, 'G3DSA:1.20.1250.20:FF:000224', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(64591, NULL, 'G3DSA:3.30.559.10:FF:000255', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(64592, NULL, 'G3DSA:3.10.20.10:FF:000011', NULL, NULL, '60S ribosomal protein L18a', NULL, NULL, NULL, NULL, NULL, 4),
(64593, NULL, 'G3DSA:1.20.1250.20:FF:002315', NULL, NULL, 'Multidrug resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(64594, NULL, 'G3DSA:1.20.90.10:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64595, NULL, 'G3DSA:1.10.3720.10:FF:000193', NULL, NULL, 'Osmoprotection protein (ProWX)', NULL, NULL, NULL, NULL, NULL, 4),
(64596, NULL, 'G3DSA:2.30.42.10:FF:000405', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64597, NULL, 'G3DSA:1.10.20.10:FF:000229', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64598, NULL, 'G3DSA:2.40.50.140:FF:000772', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64599, NULL, 'G3DSA:3.30.460.10:FF:000054', NULL, NULL, 'Iojap-like ribosome-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(64600, NULL, 'G3DSA:3.30.110.70:FF:000001', NULL, NULL, 'Outer membrane lipoprotein RcsF', NULL, NULL, NULL, NULL, NULL, 4),
(64601, NULL, 'G3DSA:3.30.70.260:FF:000041', NULL, NULL, 'Phosphoserine phosphatase SerB', NULL, NULL, NULL, NULL, NULL, 4),
(64602, NULL, 'G3DSA:2.30.30.40:FF:000573', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(64603, NULL, 'G3DSA:1.10.238.10:FF:001123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64604, NULL, 'G3DSA:2.60.40.820:FF:000008', NULL, NULL, 'T-box transcription factor TBX20', NULL, NULL, NULL, NULL, NULL, 4),
(64605, NULL, 'G3DSA:1.10.510.10:FF:001751', NULL, NULL, 'Os04g0517500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(64606, NULL, 'G3DSA:1.20.1560.10:FF:000413', NULL, NULL, 'Multidrug resistance-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(64607, NULL, 'G3DSA:3.40.50.300:FF:003621', NULL, NULL, 'DNA repair helicase XPB-R', NULL, NULL, NULL, NULL, NULL, 4),
(64608, NULL, 'G3DSA:3.40.50.300:FF:005061', NULL, NULL, 'DNA repair protein XRCC3', NULL, NULL, NULL, NULL, NULL, 4),
(64609, NULL, 'G3DSA:3.30.40.10:FF:001894', NULL, NULL, 'Os07g0497100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(64610, NULL, 'G3DSA:1.25.40.10:FF:002451', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g13040, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(64611, NULL, 'G3DSA:3.40.50.1910:FF:000040', NULL, NULL, 'Putative Sec1/Munc18 related protein', NULL, NULL, NULL, NULL, NULL, 4),
(64612, NULL, 'G3DSA:3.30.70.3490:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64613, NULL, 'G3DSA:3.40.50.300:FF:004077', NULL, NULL, 'Probable second part of macrolide-transport ATP-binding protein ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(64614, NULL, 'G3DSA:1.10.274.30:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64615, NULL, 'G3DSA:1.20.1070.10:FF:001961', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64616, NULL, 'G3DSA:2.60.40.10:FF:004913', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64617, NULL, 'G3DSA:3.30.540.30:FF:000010', NULL, NULL, 'Dipeptidyl peptidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(64618, NULL, 'G3DSA:1.20.1700.10:FF:000003', NULL, NULL, 'Pantothenate kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(64619, NULL, 'G3DSA:1.10.150.20:FF:000080', NULL, NULL, 'Meiotic recombination protein DMC1', NULL, NULL, NULL, NULL, NULL, 4),
(64620, NULL, 'G3DSA:3.30.70.270:FF:000044', NULL, NULL, 'Diguanylate cyclase (GGDEF)-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(64621, NULL, 'G3DSA:1.20.5.170:FF:000261', NULL, NULL, 'cGMP-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(64622, NULL, 'G3DSA:1.25.40.20:FF:001436', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64623, NULL, 'G3DSA:1.20.140.10:FF:000141', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(64624, NULL, 'G3DSA:2.60.40.60:FF:000286', NULL, NULL, 'Cadherin-related tumor suppressor', NULL, NULL, NULL, NULL, NULL, 4),
(64625, NULL, 'G3DSA:1.25.40.10:FF:002541', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64626, NULL, 'G3DSA:2.60.40.10:FF:000552', NULL, NULL, 'Related to glucoamylase', NULL, NULL, NULL, NULL, NULL, 4),
(64627, NULL, 'G3DSA:2.40.50.140:FF:000154', NULL, NULL, 'nucleolar protein of 40 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(64628, NULL, 'G3DSA:3.40.50.300:FF:008438', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64629, NULL, 'G3DSA:1.10.287.70:FF:000265', NULL, NULL, 'TWiK family of potassium channels', NULL, NULL, NULL, NULL, NULL, 4),
(64630, NULL, 'G3DSA:3.30.160.60:FF:005711', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64631, NULL, 'G3DSA:2.30.42.10:FF:000372', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64632, NULL, 'G3DSA:3.40.50.1820:FF:000254', NULL, NULL, 'Phospholipase A1 PLIP3, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(64633, NULL, 'G3DSA:3.30.40.10:FF:001040', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(64634, NULL, 'G3DSA:1.20.1070.10:FF:001904', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(64635, NULL, 'G3DSA:1.25.40.10:FF:000826', NULL, NULL, 'Ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(64636, NULL, 'G3DSA:1.10.287.1490:FF:000029', NULL, NULL, 'Epidermal growth factor receptor substrate 15', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(64637, NULL, 'G3DSA:1.10.287.770:FF:000003', NULL, NULL, 'acid-sensing ion channel 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(64638, NULL, 'G3DSA:3.80.10.10:FF:000316', NULL, NULL, 'Baculoviral IAP repeat-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(64639, NULL, 'G3DSA:1.10.287.1260:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64640, NULL, 'G3DSA:1.25.40.20:FF:000829', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64641, NULL, 'G3DSA:3.30.1450.10:FF:000002', NULL, NULL, 'Osmotically inducible lipoprotein E', NULL, NULL, NULL, NULL, NULL, 4),
(64642, NULL, 'G3DSA:3.40.50.410:FF:000220', NULL, NULL, 'von Willebrand factor', NULL, NULL, NULL, NULL, NULL, 4),
(64643, NULL, 'G3DSA:3.40.50.300:FF:001912', NULL, NULL, 'Replication factor C subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(64644, NULL, 'G3DSA:2.10.109.10:FF:000078', NULL, NULL, 'Peptidase S24/S26A/S26B/S26C family protein', NULL, NULL, NULL, NULL, NULL, 4),
(64645, NULL, 'G3DSA:3.30.70.360:FF:000014', NULL, NULL, 'N-acyl-L-amino acid amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(64646, NULL, 'G3DSA:1.20.5.170:FF:000204', NULL, NULL, 'tropomyosin, smooth muscle/fibroblast CTM1-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(64647, NULL, 'G3DSA:3.90.10.10:FF:000001', NULL, NULL, 'Cytochrome C', NULL, NULL, NULL, NULL, NULL, 4),
(64648, NULL, 'G3DSA:3.30.230.10:FF:000043', NULL, NULL, 'DNA topoisomerase (ATP-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4),
(64649, NULL, 'G3DSA:1.10.10.10:FF:000296', NULL, NULL, 'Peroxisomal membrane protein PEX14', NULL, NULL, NULL, NULL, NULL, 4),
(64650, NULL, 'G3DSA:3.40.50.12780:FF:000040', NULL, NULL, 'Acyl-CoA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(64651, NULL, 'G3DSA:2.60.120.260:FF:000187', NULL, NULL, 'Cytochrome C biogenesis protein DipZ', NULL, NULL, NULL, NULL, NULL, 4),
(64652, NULL, 'G3DSA:1.10.10.60:FF:001070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64653, NULL, 'G3DSA:3.90.76.10:FF:000018', NULL, NULL, 'Peptide ABC transporter, periplasmic peptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(64654, NULL, 'G3DSA:3.30.160.60:FF:001018', NULL, NULL, 'Combgap, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(64655, NULL, 'G3DSA:2.130.10.10:FF:001024', NULL, NULL, 'Protein transport protein Sec13, putative', NULL, NULL, NULL, NULL, NULL, 4),
(64656, NULL, 'G3DSA:3.30.70.370:FF:000017', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64657, NULL, 'G3DSA:1.10.10.60:FF:000608', NULL, NULL, 'DDE-recombinase A', NULL, NULL, NULL, NULL, NULL, 4),
(64658, NULL, 'G3DSA:3.40.50.12370:FF:000001', NULL, NULL, 'Universal stress protein E', NULL, NULL, NULL, NULL, NULL, 4),
(64659, NULL, 'G3DSA:2.70.160.11:FF:000027', NULL, NULL, 'Protein arginine N-methyltransferase 7', NULL, NULL, NULL, NULL, NULL, 4),
(64660, NULL, 'G3DSA:3.40.190.290:FF:000118', NULL, NULL, 'Transcriptional regulator LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(64661, NULL, 'G3DSA:3.40.50.10240:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64662, NULL, 'G3DSA:2.60.40.10:FF:000439', NULL, NULL, 'Down syndrome cell adhesion molecule, isoform J', NULL, NULL, NULL, NULL, NULL, 4),
(64663, NULL, 'G3DSA:3.10.129.10:FF:000216', NULL, NULL, 'Thioesterase-like superfamily, putative', NULL, NULL, NULL, NULL, NULL, 4),
(64664, NULL, 'G3DSA:1.25.40.10:FF:004250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64665, NULL, 'G3DSA:1.10.220.30:FF:000021', NULL, NULL, 'Flagellar motor switch protein fliG', NULL, NULL, NULL, NULL, NULL, 4),
(64666, NULL, 'G3DSA:1.20.1050.10:FF:000240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64667, NULL, 'G3DSA:3.30.1370.10:FF:000092', NULL, NULL, 'PRE-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(64668, NULL, 'G3DSA:3.30.470.20:FF:000030', NULL, NULL, 'Carbamoyl-phosphate synthase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(64669, NULL, 'G3DSA:2.40.30.270:FF:000009', NULL, NULL, 'DNA helicase A', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(64670, NULL, 'G3DSA:1.20.1740.10:FF:000034', NULL, NULL, 'cationic amino acid transporter 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(64671, NULL, 'G3DSA:3.40.50.150:FF:000176', NULL, NULL, 'tRNA (cytidine(32)/guanosine(34)-2''-O)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(64672, NULL, 'G3DSA:3.20.180.10:FF:000006', NULL, NULL, 'Iron-chelator utilization protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(64673, NULL, 'G3DSA:1.10.10.60:FF:000850', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64674, NULL, 'G3DSA:1.25.40.10:FF:002209', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g06270', NULL, NULL, NULL, NULL, NULL, 4),
(64675, NULL, 'G3DSA:3.30.160.20:FF:000017', NULL, NULL, 'ATP-dependent RNA helicase DHX30 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(64676, NULL, 'G3DSA:1.25.40.10:FF:000208', NULL, NULL, 'Protein sel-1 homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(64677, NULL, 'G3DSA:1.20.1280.290:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64678, NULL, 'G3DSA:2.30.42.10:FF:000462', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64679, NULL, 'G3DSA:1.25.10.10:FF:003404', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64680, NULL, 'G3DSA:3.80.10.10:FF:003189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64681, NULL, 'G3DSA:3.20.180.20:FF:000009', NULL, NULL, 'Dynein beta chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(64682, NULL, 'G3DSA:3.40.50.300:FF:008348', NULL, NULL, 'Inner dynein arm 1 heavy chain 1-ALPHa', NULL, NULL, NULL, NULL, NULL, 4),
(64683, NULL, 'G3DSA:1.20.1250.20:FF:001298', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(64684, NULL, 'G3DSA:3.30.420.140:FF:000017', NULL, NULL, 'Transcription elongation factor Spt6', NULL, NULL, NULL, NULL, NULL, 4),
(64685, NULL, 'G3DSA:1.20.1250.20:FF:001388', NULL, NULL, 'Major facilitator superfamily transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(64686, NULL, 'G3DSA:3.30.565.10:FF:000258', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(64687, NULL, 'G3DSA:3.40.850.10:FF:000104', NULL, NULL, 'Myosin C', NULL, NULL, NULL, NULL, NULL, 4),
(64688, NULL, 'G3DSA:2.60.40.10:FF:004857', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64689, NULL, 'G3DSA:3.90.190.20:FF:000034', NULL, NULL, 'Putative folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(64690, NULL, 'G3DSA:3.30.70.330:FF:000382', NULL, NULL, 'G-patch domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(64691, NULL, 'G3DSA:3.30.160.60:FF:002598', NULL, NULL, 'zinc finger protein 582 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(64692, NULL, 'G3DSA:3.30.1360.10:FF:000063', NULL, NULL, 'RNA polymerase Rpb3/Rpb11 dimerisation domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(64693, NULL, 'G3DSA:2.120.10.30:FF:000244', NULL, NULL, 'Probable L-sorbosone dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(64694, NULL, 'G3DSA:2.60.120.650:FF:000034', NULL, NULL, 'Transcription factor jumonji (JmjC) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(64695, NULL, 'G3DSA:3.20.20.240:FF:000004', NULL, NULL, 'Probable methylmalonyl-CoA mutase small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(64696, NULL, 'G3DSA:3.40.850.10:FF:000290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64697, NULL, 'G3DSA:1.10.472.10:FF:000307', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64698, NULL, 'G3DSA:3.30.70.1400:FF:000018', NULL, NULL, 'Dimethylglycine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(64699, NULL, 'G3DSA:2.130.10.10:FF:002418', NULL, NULL, 'THO complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(64700, NULL, 'G3DSA:1.10.630.10:FF:000799', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64701, NULL, 'G3DSA:3.40.850.10:FF:000048', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(64702, NULL, 'G3DSA:3.40.50.720:FF:002084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(64703, NULL, 'G3DSA:3.30.160.60:FF:001636', NULL, NULL, 'CLUMA_CG004886, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(64704, NULL, 'G3DSA:3.40.50.300:FF:004695', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64705, NULL, 'G3DSA:2.130.10.10:FF:005442', NULL, NULL, 'WD repeat domain 3', NULL, NULL, NULL, NULL, NULL, 4),
(64706, NULL, 'G3DSA:3.90.190.10:FF:000031', NULL, NULL, 'dual specificity protein phosphatase CDC14B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(64707, NULL, 'G3DSA:3.30.160.100:FF:000013', NULL, NULL, 'Ribosome hibernation promoting factor', NULL, NULL, NULL, NULL, NULL, 4),
(64708, NULL, 'G3DSA:3.30.565.10:FF:000168', NULL, NULL, 'Autoinducer 1 sensor kinase/phosphatase LuxN', NULL, NULL, NULL, NULL, NULL, 4),
(64709, NULL, 'G3DSA:2.60.120.650:FF:000181', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64710, NULL, 'G3DSA:3.30.70.120:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64711, NULL, 'G3DSA:1.10.510.10:FF:000767', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(64712, NULL, 'G3DSA:2.60.120.200:FF:000630', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64713, NULL, 'G3DSA:2.130.10.10:FF:002660', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64714, NULL, 'G3DSA:1.10.472.10:FF:000217', NULL, NULL, 'TFIIB zinc-binding, putative', NULL, NULL, NULL, NULL, NULL, 4),
(64715, NULL, 'G3DSA:3.60.15.10:FF:000238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64716, NULL, 'G3DSA:3.40.390.10:FF:000063', NULL, NULL, 'Putative cytosolic oligopeptidase A-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(64717, NULL, 'G3DSA:2.30.29.30:FF:000830', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64718, NULL, 'G3DSA:3.30.1370.10:FF:000035', NULL, NULL, 'KH domain-containing 4, pre-mRNA-splicing factor', NULL, NULL, NULL, NULL, NULL, 4),
(64719, NULL, 'G3DSA:3.20.20.70:FF:000045', NULL, NULL, '2-isopropylmalate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(64720, NULL, 'G3DSA:3.40.50.2300:FF:000387', NULL, NULL, 'Argonaute (Plant)-Like protein', NULL, NULL, NULL, NULL, NULL, 4),
(64721, NULL, 'G3DSA:2.60.40.10:FF:000967', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(64722, NULL, 'G3DSA:3.30.1330.200:FF:000002', NULL, NULL, 'Probable chemoreceptor glutamine deamidase CheD', NULL, NULL, NULL, NULL, NULL, 4),
(64723, NULL, 'G3DSA:3.30.40.10:FF:002057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64724, NULL, 'G3DSA:3.30.160.60:FF:001260', NULL, NULL, 'zinc finger protein 629 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(64725, NULL, 'G3DSA:3.40.50.300:FF:006494', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64726, NULL, 'G3DSA:3.40.47.10:FF:000184', NULL, NULL, 'Acetoacetyl CoA synthase NphT7', NULL, NULL, NULL, NULL, NULL, 4),
(64727, NULL, 'G3DSA:3.40.47.10:FF:000127', NULL, NULL, 'Acetyl-CoA acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(64728, NULL, 'G3DSA:2.130.10.10:FF:001171', NULL, NULL, 'U3 small nucleolar RNA-associated protein 15,putative', NULL, NULL, NULL, NULL, NULL, 4),
(64729, NULL, 'G3DSA:3.40.50.720:FF:002230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64730, NULL, 'G3DSA:2.60.40.10:FF:004239', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64731, NULL, 'G3DSA:3.30.460.20:FF:000001', NULL, NULL, 'Zinc transport protein ZntB', NULL, NULL, NULL, NULL, NULL, 4),
(64732, NULL, 'G3DSA:2.60.40.150:FF:000347', NULL, NULL, 'C2 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(64733, NULL, 'G3DSA:1.25.10.10:FF:002713', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64734, NULL, 'G3DSA:1.20.59.10:FF:000003', NULL, NULL, 'Bifunctional 3-deoxy-7-phosphoheptulonate synthase/chorismate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(64735, NULL, 'G3DSA:1.10.10.10:FF:000970', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(64736, NULL, 'G3DSA:1.10.10.60:FF:001160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64737, NULL, 'G3DSA:1.25.40.120:FF:000023', NULL, NULL, 'Ecm9p', NULL, NULL, NULL, NULL, NULL, 4),
(64738, NULL, 'G3DSA:3.20.20.80:FF:000048', NULL, NULL, 'Brain chitinase and chia', NULL, NULL, NULL, NULL, NULL, 4),
(64739, NULL, 'G3DSA:3.30.160.60:FF:000799', NULL, NULL, 'myeloid zinc finger 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(64740, NULL, 'G3DSA:3.40.50.150:FF:001608', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64741, NULL, 'G3DSA:2.40.10.10:FF:000657', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64742, NULL, 'G3DSA:1.10.10.10:FF:001313', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(64743, NULL, 'G3DSA:3.40.50.12670:FF:000006', NULL, NULL, 'Serine carboxypeptidase-like 18', NULL, NULL, NULL, NULL, NULL, 4),
(64744, NULL, 'G3DSA:3.10.390.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64745, NULL, 'G3DSA:2.60.40.60:FF:001067', NULL, NULL, 'Fat1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(64746, NULL, 'G3DSA:3.40.50.620:FF:000311', NULL, NULL, 'Nicotinamide nucleotide adenylyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(64747, NULL, 'G3DSA:3.30.420.40:FF:000561', NULL, NULL, 'Actin-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(64748, NULL, 'G3DSA:1.10.150.20:FF:000309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64749, NULL, 'G3DSA:1.20.1070.10:FF:000325', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64750, NULL, 'G3DSA:1.10.600.10:FF:000033', NULL, NULL, 'Farnesyl pyrophosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(64751, NULL, 'G3DSA:3.40.190.10:FF:000929', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64752, NULL, 'G3DSA:3.40.50.2000:FF:000089', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(64753, NULL, 'G3DSA:1.20.900.10:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64754, NULL, 'G3DSA:2.30.42.10:FF:000552', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64755, NULL, 'G3DSA:1.20.1050.10:FF:000150', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64756, NULL, 'G3DSA:3.40.50.1820:FF:000310', NULL, NULL, 'Phosphatidylcholine-sterol O-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(64757, NULL, 'G3DSA:2.60.40.10:FF:005262', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64758, NULL, 'G3DSA:1.20.1050.10:FF:000094', NULL, NULL, 'Glutathione S-transferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(64759, NULL, 'G3DSA:2.60.120.260:FF:000333', NULL, NULL, 'Sun domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(64760, NULL, 'G3DSA:3.40.640.10:FF:000190', NULL, NULL, '7-keto-8-aminopelargonate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(64761, NULL, 'G3DSA:1.25.40.10:FF:003232', NULL, NULL, 'YALI0A15686p', NULL, NULL, NULL, NULL, NULL, 4),
(64762, NULL, 'G3DSA:3.40.50.150:FF:000737', NULL, NULL, 'Methyltransferase like 7A', NULL, NULL, NULL, NULL, NULL, 4),
(64763, NULL, 'G3DSA:3.40.50.1470:FF:000008', NULL, NULL, 'Peptidyl-tRNA hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(64764, NULL, 'G3DSA:1.10.510.10:FF:003550', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64765, NULL, 'G3DSA:2.60.120.200:FF:000012', NULL, NULL, 'neuronal pentraxin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(64766, NULL, 'G3DSA:3.40.50.300:FF:007421', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(64767, NULL, 'G3DSA:3.40.50.300:FF:001822', NULL, NULL, 'RAB family', NULL, NULL, NULL, NULL, NULL, 4),
(64768, NULL, 'G3DSA:1.10.472.10:FF:000274', NULL, NULL, 'CYCLIN B15', NULL, NULL, NULL, NULL, NULL, 4),
(64769, NULL, 'G3DSA:3.30.1460.50:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64770, NULL, 'G3DSA:1.25.70.10:FF:000036', NULL, NULL, 'Mitochondrial transcription termination factor 4', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(64771, NULL, 'G3DSA:1.25.10.10:FF:002623', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64772, NULL, 'G3DSA:3.40.50.720:FF:002140', NULL, NULL, 'D-beta-hydroxybutyrate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(64773, NULL, 'G3DSA:2.60.40.10:FF:004149', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64774, NULL, 'G3DSA:1.20.5.1160:FF:000016', NULL, NULL, 'Intermediate filament protein A', NULL, NULL, NULL, NULL, NULL, 4),
(64775, NULL, 'G3DSA:3.30.160.60:FF:005998', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64776, NULL, 'G3DSA:2.60.120.290:FF:000061', NULL, NULL, 'cubilin', NULL, NULL, NULL, NULL, NULL, 4),
(64777, NULL, 'G3DSA:1.10.3810.10:FF:000020', NULL, NULL, 'Penicillin-binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(64778, NULL, 'G3DSA:3.30.559.70:FF:000048', NULL, NULL, 'Choline O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(64779, NULL, 'G3DSA:3.40.47.10:FF:000094', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(64780, NULL, 'G3DSA:3.20.20.100:FF:000070', NULL, NULL, 'Aldo/keto reductase', NULL, NULL, NULL, NULL, NULL, 4),
(64781, NULL, 'G3DSA:2.130.10.10:FF:001081', NULL, NULL, 'TAF5-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(64782, NULL, 'G3DSA:3.40.50.300:FF:006550', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64783, NULL, 'G3DSA:2.70.98.10:FF:000066', NULL, NULL, 'Transglycolase epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(64784, NULL, 'G3DSA:3.40.190.120:FF:000005', NULL, NULL, 'Lipoprotein LPQZ', NULL, NULL, NULL, NULL, NULL, 4),
(64785, NULL, 'G3DSA:2.60.40.1180:FF:000165', NULL, NULL, 'Alpha-L-fucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(64786, NULL, 'G3DSA:3.20.20.70:FF:000101', NULL, NULL, 'Delta-aminolevulinic acid dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(64787, NULL, 'G3DSA:3.90.550.10:FF:000688', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64788, NULL, 'G3DSA:3.40.50.960:FF:000008', NULL, NULL, '6,7-dimethyl-8-ribityllumazine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(64789, NULL, 'G3DSA:3.40.50.300:FF:002508', NULL, NULL, 'Tetronasin ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(64790, NULL, 'G3DSA:3.40.50.300:FF:000895', NULL, NULL, 'probable ATP-dependent RNA helicase DHX37', NULL, NULL, NULL, NULL, NULL, 4),
(64791, NULL, 'G3DSA:3.40.50.1460:FF:000005', NULL, NULL, 'Vacuolar-processing enzyme beta-isozyme', NULL, NULL, NULL, NULL, NULL, 4),
(64792, NULL, 'G3DSA:3.40.50.10090:FF:000002', NULL, NULL, 'Bifunctional uroporphyrinogen-III C-methyltransferase/uroporphyrinogen-III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(64793, NULL, 'G3DSA:1.50.40.10:FF:000150', NULL, NULL, 'Adenine nucleotide transporter BT1, chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(64794, NULL, 'G3DSA:3.30.497.10:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64795, NULL, 'G3DSA:3.20.20.120:FF:000019', NULL, NULL, 'Dipeptide epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(64796, NULL, 'G3DSA:3.30.160.60:FF:002564', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(64797, NULL, 'G3DSA:3.90.810.10:FF:000023', NULL, NULL, 'p21-activated kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(64798, NULL, 'G3DSA:2.40.10.10:FF:000096', NULL, NULL, 'Glyoxysomal processing protease glyoxysomal', NULL, NULL, NULL, NULL, NULL, 4),
(64799, NULL, 'G3DSA:3.20.20.80:FF:000104', NULL, NULL, 'Endo-1,4-beta-xylanase A', NULL, NULL, NULL, NULL, NULL, 4),
(64800, NULL, 'G3DSA:3.40.50.150:FF:001232', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64801, NULL, 'G3DSA:3.40.720.10:FF:000044', NULL, NULL, 'Arylsulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(64802, NULL, 'G3DSA:3.40.50.970:FF:000073', NULL, NULL, '2-oxoisovalerate dehydrogenase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(64803, NULL, 'G3DSA:3.30.1520.10:FF:000031', NULL, NULL, 'Sorting nexin 4', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(64804, NULL, 'G3DSA:3.30.200.20:FF:002371', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64805, NULL, 'G3DSA:3.90.1170.10:FF:000017', NULL, NULL, 'Ribosomal protein L10e/L16', NULL, NULL, NULL, NULL, NULL, 4),
(64806, NULL, 'G3DSA:3.30.70.330:FF:000472', NULL, NULL, 'Cold inducible RNA binding protein a', NULL, NULL, NULL, NULL, NULL, 4),
(64807, NULL, 'G3DSA:3.30.450.40:FF:000186', NULL, NULL, 'Diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(64808, NULL, 'G3DSA:1.10.10.60:FF:001013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64809, NULL, 'G3DSA:2.10.25.10:FF:001289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64810, NULL, 'G3DSA:2.10.25.10:FF:001379', NULL, NULL, 'C901 protein', NULL, NULL, NULL, NULL, NULL, 4),
(64811, NULL, 'G3DSA:2.60.40.10:FF:004767', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64812, NULL, 'G3DSA:3.30.50.10:FF:000085', NULL, NULL, 'Diphosphomevalonate decarboxylase MVD2', NULL, NULL, NULL, NULL, NULL, 4),
(64813, NULL, 'G3DSA:3.30.200.20:FF:002281', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(64814, NULL, 'G3DSA:2.40.30.10:FF:000417', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64815, NULL, 'G3DSA:3.30.160.60:FF:002654', NULL, NULL, 'Related to epithelial zinc-finger ezf protein', NULL, NULL, NULL, NULL, NULL, 4),
(64816, NULL, 'G3DSA:2.130.10.10:FF:004458', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64817, NULL, 'G3DSA:3.80.10.10:FF:002969', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64818, NULL, 'G3DSA:2.40.10.10:FF:000186', NULL, NULL, 'Serine protease PepA', NULL, NULL, NULL, NULL, NULL, 4),
(64819, NULL, 'G3DSA:1.25.40.10:FF:002395', NULL, NULL, 'Pre-mRNA-splicing factor CLF1', NULL, NULL, NULL, NULL, NULL, 4),
(64820, NULL, 'G3DSA:3.90.55.10:FF:000003', NULL, NULL, 'Probable biotin sulfoxide reductase bisC', NULL, NULL, NULL, NULL, NULL, 4),
(64821, NULL, 'G3DSA:3.30.40.10:FF:000910', NULL, NULL, 'Bloodthirsty-related gene family, member 1', NULL, NULL, NULL, NULL, NULL, 4),
(64822, NULL, 'G3DSA:3.30.70.270:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64823, NULL, 'G3DSA:1.10.10.10:FF:000908', NULL, NULL, 'ForKHead transcription factor family', NULL, NULL, NULL, NULL, NULL, 4),
(64824, NULL, 'G3DSA:3.40.640.10:FF:000509', NULL, NULL, 'Aminotransferase, conjectural', NULL, NULL, NULL, NULL, NULL, 4),
(64825, NULL, 'G3DSA:2.60.40.10:FF:000496', NULL, NULL, 'Adhesion G protein-coupled receptor A2', NULL, NULL, NULL, NULL, NULL, 4),
(64826, NULL, 'G3DSA:3.40.50.720:FF:002050', NULL, NULL, 'Hsd17b14 protein', NULL, NULL, NULL, NULL, NULL, 4),
(64827, NULL, 'G3DSA:3.90.1860.10:FF:000014', NULL, NULL, 'Putative RctB family protein', NULL, NULL, NULL, NULL, NULL, 4),
(64828, NULL, 'G3DSA:1.20.1260.10:FF:000008', NULL, NULL, 'YciF protein', NULL, NULL, NULL, NULL, NULL, 4),
(64829, NULL, 'G3DSA:1.20.58.1030:FF:000005', NULL, NULL, 'DNA replication complex GINS protein SLD5', NULL, NULL, NULL, NULL, NULL, 4),
(64830, NULL, 'G3DSA:3.90.550.10:FF:000598', NULL, NULL, 'Cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(64831, NULL, 'G3DSA:3.30.70.2190:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64832, NULL, 'G3DSA:1.10.490.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64833, NULL, 'G3DSA:1.25.40.180:FF:000344', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64834, NULL, 'G3DSA:2.60.220.50:FF:000034', NULL, NULL, 'Adhesion G protein-coupled receptor D2', NULL, NULL, NULL, NULL, NULL, 4),
(64835, NULL, 'G3DSA:3.30.450.20:FF:000028', NULL, NULL, 'Aryl hydrocarbon receptor nuclear translocator 1', NULL, NULL, NULL, NULL, NULL, 4),
(64836, NULL, 'G3DSA:3.30.519.10:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64837, NULL, 'G3DSA:3.20.20.100:FF:000160', NULL, NULL, 'AGAP012851-PA', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(64838, NULL, 'G3DSA:3.40.50.970:FF:000163', NULL, NULL, 'Transketolase putative', NULL, NULL, NULL, NULL, NULL, 4),
(64839, NULL, 'G3DSA:2.40.30.130:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64840, NULL, 'G3DSA:3.90.1030.10:FF:000002', NULL, NULL, '50S ribosomal protein L17', NULL, NULL, NULL, NULL, NULL, 4),
(64841, NULL, 'G3DSA:3.40.50.410:FF:000074', NULL, NULL, 'Mediator complex subunit 25', NULL, NULL, NULL, NULL, NULL, 4),
(64842, NULL, 'G3DSA:1.20.58.1040:FF:000008', NULL, NULL, 'Glucan endo-1,3-beta-glucosidase 13', NULL, NULL, NULL, NULL, NULL, 4),
(64843, NULL, 'G3DSA:2.60.120.650:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64844, NULL, 'G3DSA:3.40.50.2000:FF:000179', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(64845, NULL, 'G3DSA:3.20.20.80:FF:000722', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64846, NULL, 'G3DSA:3.60.40.10:FF:000280', NULL, NULL, 'Putative protein phosphatase 2C-like protein 45', NULL, NULL, NULL, NULL, NULL, 4),
(64847, NULL, 'G3DSA:1.10.1450.10:FF:000059', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(64848, NULL, 'G3DSA:1.20.1250.20:FF:001859', NULL, NULL, 'Major facilitator superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(64849, NULL, 'G3DSA:2.120.10.30:FF:000154', NULL, NULL, 'AGAP011034-PA', NULL, NULL, NULL, NULL, NULL, 4),
(64850, NULL, 'G3DSA:2.50.20.10:FF:000017', NULL, NULL, 'Outer-membrane lipoprotein carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(64851, NULL, 'G3DSA:3.40.50.1820:FF:000400', NULL, NULL, 'YOR059C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(64852, NULL, 'G3DSA:3.30.530.20:FF:000029', NULL, NULL, 'START domain-containing protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(64853, NULL, 'G3DSA:2.60.120.340:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64854, NULL, 'G3DSA:1.10.238.10:FF:001056', NULL, NULL, 'Polcalcin Cup a 4', NULL, NULL, NULL, NULL, NULL, 4),
(64855, NULL, 'G3DSA:1.20.120.1530:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64856, NULL, 'G3DSA:1.25.40.10:FF:004126', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g14080', NULL, NULL, NULL, NULL, NULL, 4),
(64857, NULL, 'G3DSA:2.40.30.20:FF:000021', NULL, NULL, 'ATP synthase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(64858, NULL, 'G3DSA:2.40.30.30:FF:000024', NULL, NULL, 'Riboflavin kinase', NULL, NULL, NULL, NULL, NULL, 4),
(64859, NULL, 'G3DSA:2.60.40.1150:FF:000004', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(64860, NULL, 'G3DSA:3.40.50.720:FF:002145', NULL, NULL, 'Nicotinamide nucleotide transhydrogenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(64861, NULL, 'G3DSA:1.10.238.10:FF:000488', NULL, NULL, 'GTPase activating protein (Gyp2)', NULL, NULL, NULL, NULL, NULL, 4),
(64862, NULL, 'G3DSA:1.10.8.1190:FF:000005', NULL, NULL, 'Polyprotein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(64863, NULL, 'G3DSA:3.60.40.10:FF:000072', NULL, NULL, 'Stage II sporulation protein E', NULL, NULL, NULL, NULL, NULL, 4),
(64864, NULL, 'G3DSA:3.30.70.270:FF:000167', NULL, NULL, 'Response regulator PleD', NULL, NULL, NULL, NULL, NULL, 4),
(64865, NULL, 'G3DSA:3.40.50.1380:FF:000021', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(64866, NULL, 'G3DSA:3.30.479.30:FF:000030', NULL, NULL, 'Stomatin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(64867, NULL, 'G3DSA:3.40.50.300:FF:005302', NULL, NULL, 'Shikimate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(64868, NULL, 'G3DSA:1.10.4160.10:FF:000043', NULL, NULL, 'Probable transporter', NULL, NULL, NULL, NULL, NULL, 4),
(64869, NULL, 'G3DSA:3.40.50.300:FF:001019', NULL, NULL, 'Cell division protein ZapE', NULL, NULL, NULL, NULL, NULL, 4),
(64870, NULL, 'G3DSA:1.10.287.1260:FF:000011', NULL, NULL, 'Mechanosensitive ion channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(64871, NULL, 'G3DSA:3.40.50.20:FF:000071', NULL, NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(64872, NULL, 'G3DSA:3.40.50.720:FF:000021', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(64873, NULL, 'G3DSA:2.130.10.10:FF:004279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64874, NULL, 'G3DSA:3.80.10.10:FF:000081', NULL, NULL, 'leucine-rich repeat and calponin homology domain-containing protein 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(64875, NULL, 'G3DSA:1.10.10.10:FF:000178', NULL, NULL, 'Putative Transcription factor RFX4', NULL, NULL, NULL, NULL, NULL, 4),
(64876, NULL, 'G3DSA:3.40.190.10:FF:000317', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(64877, NULL, 'G3DSA:3.40.309.10:FF:000066', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(64878, NULL, 'G3DSA:3.40.50.300:FF:005240', NULL, NULL, 'ABC transporter G family member 35', NULL, NULL, NULL, NULL, NULL, 4),
(64879, NULL, 'G3DSA:3.40.50.300:FF:007331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64880, NULL, 'G3DSA:3.30.230.120:FF:000007', NULL, NULL, 'GHMP kinase', NULL, NULL, NULL, NULL, NULL, 4),
(64881, NULL, 'G3DSA:1.10.10.60:FF:001300', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64882, NULL, 'G3DSA:1.10.10.60:FF:000732', NULL, NULL, 'Homeobox protein ceh-8', NULL, NULL, NULL, NULL, NULL, 4),
(64883, NULL, 'G3DSA:1.20.1270.60:FF:000102', NULL, NULL, 'WGS project CABT00000000 data, contig 2.23', NULL, NULL, NULL, NULL, NULL, 4),
(64884, NULL, 'G3DSA:1.10.510.10:FF:001077', NULL, NULL, 'Phytosulfokine receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(64885, NULL, 'G3DSA:3.40.50.2000:FF:000527', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64886, NULL, 'G3DSA:3.30.40.10:FF:000438', NULL, NULL, 'Bloodthirsty-related gene family, member 25', NULL, NULL, NULL, NULL, NULL, 4),
(64887, NULL, 'G3DSA:3.90.1180.10:FF:000018', NULL, NULL, '50S ribosomal protein L13', NULL, NULL, NULL, NULL, NULL, 4),
(64888, NULL, 'G3DSA:2.130.10.10:FF:002093', NULL, NULL, 'WD repeat-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(64889, NULL, 'G3DSA:3.30.420.40:FF:001016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64890, NULL, 'G3DSA:1.20.85.10:FF:000007', NULL, NULL, 'Photosynthetic reaction center subunit M', NULL, NULL, NULL, NULL, NULL, 4),
(64891, NULL, 'G3DSA:3.30.1540.10:FF:000009', NULL, NULL, 'Probable CoA-transferase Rv1866', NULL, NULL, NULL, NULL, NULL, 4),
(64892, NULL, 'G3DSA:3.30.160.60:FF:003227', NULL, NULL, 'Zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(64893, NULL, 'G3DSA:1.20.1310.10:FF:000075', NULL, NULL, 'Ubiquitin ligase subunit CulD', NULL, NULL, NULL, NULL, NULL, 4),
(64894, NULL, 'G3DSA:2.30.29.30:FF:000420', NULL, NULL, 'CLNS1A isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(64895, NULL, 'G3DSA:3.40.1110.10:FF:000126', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(64896, NULL, 'G3DSA:3.40.50.10900:FF:000009', NULL, NULL, 'Proteasome assembly chaperone 2', NULL, NULL, NULL, NULL, NULL, 4),
(64897, NULL, 'G3DSA:3.80.30.20:FF:000028', NULL, NULL, 'Oxygen-independent coproporphyrinogen III oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(64898, NULL, 'G3DSA:1.10.238.10:FF:000393', NULL, NULL, 'Calcium-dependent protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(64899, NULL, 'G3DSA:2.130.10.10:FF:001732', NULL, NULL, 'WD repeat-containing protein 74', NULL, NULL, NULL, NULL, NULL, 4),
(64900, NULL, 'G3DSA:3.40.50.1970:FF:000035', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(64901, NULL, 'G3DSA:3.30.40.10:FF:001866', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64902, NULL, 'G3DSA:2.30.30.40:FF:000168', NULL, NULL, 'SH3 domain protein (Cyk3)', NULL, NULL, NULL, NULL, NULL, 4),
(64903, NULL, 'G3DSA:2.60.40.1140:FF:000001', NULL, NULL, 'Collagen adhesin', NULL, NULL, NULL, NULL, NULL, 4),
(64904, NULL, 'G3DSA:3.80.10.10:FF:003902', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(64905, NULL, 'G3DSA:3.30.160.60:FF:001136', NULL, NULL, 'Zinc finger protein 408', NULL, NULL, NULL, NULL, NULL, 4),
(64906, NULL, 'G3DSA:3.30.230.70:FF:000066', NULL, NULL, 'GD11151', NULL, NULL, NULL, NULL, NULL, 4),
(64907, NULL, 'G3DSA:2.40.50.140:FF:000660', NULL, NULL, 'Recombination-defective, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(64908, NULL, 'G3DSA:3.90.1150.10:FF:000516', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64909, NULL, 'G3DSA:3.30.420.40:FF:000353', NULL, NULL, 'Actin-related protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(64910, NULL, 'G3DSA:1.20.920.30:FF:000061', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64911, NULL, 'G3DSA:3.40.190.10:FF:000222', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(64912, NULL, 'G3DSA:2.10.25.10:FF:001227', NULL, NULL, 'Fibulin 1', NULL, NULL, NULL, NULL, NULL, 4),
(64913, NULL, 'G3DSA:1.10.506.10:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64914, NULL, 'G3DSA:3.40.50.150:FF:001732', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64915, NULL, 'G3DSA:3.30.260.10:FF:000078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64916, NULL, 'G3DSA:3.30.70.870:FF:000038', NULL, NULL, 'Elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(64917, NULL, 'G3DSA:3.40.190.10:FF:000368', NULL, NULL, 'Serotransferrin', NULL, NULL, NULL, NULL, NULL, 4),
(64918, NULL, 'G3DSA:3.40.1110.10:FF:000031', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(64919, NULL, 'G3DSA:3.30.710.10:FF:000091', NULL, NULL, 'Lola, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(64920, NULL, 'G3DSA:3.10.100.10:FF:000307', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64921, NULL, 'G3DSA:2.130.10.10:FF:002834', NULL, NULL, 'Prolactin regulatory element-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(64922, NULL, 'G3DSA:3.40.50.720:FF:000072', NULL, NULL, 'Saccharopine dehydrogenase [NADP(+), L-glutamate-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(64923, NULL, 'G3DSA:2.60.120.200:FF:000343', NULL, NULL, 'LAMinin related. See also lmb', NULL, NULL, NULL, NULL, NULL, 4),
(64924, NULL, 'G3DSA:3.40.50.410:FF:000130', NULL, NULL, 'Inverted repeat-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(64925, NULL, 'G3DSA:3.80.10.10:FF:004245', NULL, NULL, 'Tubulin-specific chaperone E', NULL, NULL, NULL, NULL, NULL, 4),
(64926, NULL, 'G3DSA:1.10.287.2620:FF:000014', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(64927, NULL, 'G3DSA:3.80.10.10:FF:000176', NULL, NULL, 'Thyrotropin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(64928, NULL, 'G3DSA:3.40.710.10:FF:000015', NULL, NULL, 'Serine beta-lactamase-like protein LACTB, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(64929, NULL, 'G3DSA:2.40.50.140:FF:000334', NULL, NULL, 'Translation initiation factor 5A', NULL, NULL, NULL, NULL, NULL, 4),
(64930, NULL, 'G3DSA:1.25.40.10:FF:001321', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g57430, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(64931, NULL, 'G3DSA:1.10.357.150:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64932, NULL, 'G3DSA:1.25.40.20:FF:001324', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64933, NULL, 'G3DSA:3.90.70.10:FF:000269', NULL, NULL, 'Cysteine protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(64934, NULL, 'G3DSA:1.10.287.3810:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64935, NULL, 'G3DSA:3.40.50.1820:FF:000018', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(64936, NULL, 'G3DSA:2.30.42.10:FF:000338', NULL, NULL, 'Syndecan binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(64937, NULL, 'G3DSA:1.10.357.140:FF:000011', NULL, NULL, 'Homogentisate phytyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(64938, NULL, 'G3DSA:2.60.40.150:FF:000667', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(64939, NULL, 'G3DSA:3.50.50.60:FF:000155', NULL, NULL, 'Monodehydroascorbate reductase 3', NULL, NULL, NULL, NULL, NULL, 4),
(64940, NULL, 'G3DSA:1.10.287.940:FF:000015', NULL, NULL, 'C12orf76 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(64941, NULL, 'G3DSA:2.60.40.10:FF:003053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64942, NULL, 'G3DSA:2.60.40.10:FF:005987', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64943, NULL, 'G3DSA:1.50.10.20:FF:000095', NULL, NULL, 'Terpene cyclase/mutase family member', NULL, NULL, NULL, NULL, NULL, 4),
(64944, NULL, 'G3DSA:3.40.50.150:FF:001053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64945, NULL, 'G3DSA:2.70.130.10:FF:000165', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64946, NULL, 'G3DSA:3.80.10.10:FF:000030', NULL, NULL, 'C-Maf-inducing protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(64947, NULL, 'G3DSA:2.60.34.10:FF:000138', NULL, NULL, 'Heat shock 70 kDa protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(64948, NULL, 'G3DSA:3.30.710.10:FF:000411', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64949, NULL, 'G3DSA:3.30.450.40:FF:000181', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(64950, NULL, 'G3DSA:3.30.1370.10:FF:000209', NULL, NULL, 'KRR1 small subunit processome component homolog-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(64951, NULL, 'G3DSA:3.40.50.300:FF:006437', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64952, NULL, 'G3DSA:3.30.160.60:FF:002659', NULL, NULL, 'Zinc finger protein 526', NULL, NULL, NULL, NULL, NULL, 4),
(64953, NULL, 'G3DSA:3.30.1050.10:FF:000039', NULL, NULL, 'Putative stomatin-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(64954, NULL, 'G3DSA:2.40.70.10:FF:000077', NULL, NULL, 'Aspartic proteinase nepenthesin-2', NULL, NULL, NULL, NULL, NULL, 4),
(64955, NULL, 'G3DSA:2.30.29.30:FF:000471', NULL, NULL, 'Serine threonine protein phosphatase 2a 59 kDa regulatory subunit b', NULL, NULL, NULL, NULL, NULL, 4),
(64956, NULL, 'G3DSA:3.40.640.10:FF:000476', NULL, NULL, 'Putative serine/threonine-protein phosphatase 2A regulatory subunit B'''' subunit TON2', NULL, NULL, NULL, NULL, NULL, 4),
(64957, NULL, 'G3DSA:3.40.50.2300:FF:000415', NULL, NULL, 'Chemotactic response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(64958, NULL, 'G3DSA:3.30.40.10:FF:000343', NULL, NULL, 'E3 SUMO-protein ligase NSE2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(64959, NULL, 'G3DSA:1.20.5.1500:FF:000012', NULL, NULL, 'Gag polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(64960, NULL, 'G3DSA:1.20.1250.20:FF:000191', NULL, NULL, 'Transporter, major facilitator family', NULL, NULL, NULL, NULL, NULL, 4),
(64961, NULL, 'G3DSA:3.40.50.2000:FF:000853', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(64962, NULL, 'G3DSA:2.60.40.60:FF:000426', NULL, NULL, 'Protocadherin-15', NULL, NULL, NULL, NULL, NULL, 4),
(64963, NULL, 'G3DSA:1.20.930.80:FF:000003', NULL, NULL, 'DNA primase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(64964, NULL, 'G3DSA:3.30.420.10:FF:000113', NULL, NULL, 'Ribonuclease HII', NULL, NULL, NULL, NULL, NULL, 4),
(64965, NULL, 'G3DSA:3.30.160.60:FF:003553', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64966, NULL, 'G3DSA:3.30.200.20:FF:000982', NULL, NULL, 'CBN-JKK-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(64967, NULL, 'G3DSA:3.30.160.60:FF:000861', NULL, NULL, 'zinc finger protein 358', NULL, NULL, NULL, NULL, NULL, 4),
(64968, NULL, 'G3DSA:3.30.470.20:FF:000232', NULL, NULL, 'Inositol-tetrakisphosphate 1-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(64969, NULL, 'G3DSA:3.30.870.10:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64970, NULL, 'G3DSA:3.30.470.30:FF:000061', NULL, NULL, 'DNA ligase 4', NULL, NULL, NULL, NULL, NULL, 4),
(64971, NULL, 'G3DSA:1.10.3720.10:FF:000075', NULL, NULL, 'Peptide ABC transporter permease component', NULL, NULL, NULL, NULL, NULL, 4),
(64972, NULL, 'G3DSA:1.20.1070.10:FF:000213', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(64973, NULL, 'G3DSA:1.20.1510.10:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64974, NULL, 'G3DSA:1.20.1420.30:FF:000055', NULL, NULL, 'Uncharacterized protein, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(64975, NULL, 'G3DSA:3.40.50.800:FF:000005', NULL, NULL, 'bifunctional glutamate/proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(64976, NULL, 'G3DSA:3.30.160.60:FF:003441', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64977, NULL, 'G3DSA:3.30.870.10:FF:000046', NULL, NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(64978, NULL, 'G3DSA:3.40.50.620:FF:000721', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64979, NULL, 'G3DSA:3.30.70.330:FF:002175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64980, NULL, 'G3DSA:3.30.565.10:FF:000163', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(64981, NULL, 'G3DSA:2.30.29.30:FF:000206', NULL, NULL, 'Rho GTPase activating protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(64982, NULL, 'G3DSA:2.130.10.10:FF:000743', NULL, NULL, 'U3 small nucleolar RNA associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(64983, NULL, 'G3DSA:2.60.40.150:FF:000729', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64984, NULL, 'G3DSA:2.60.40.60:FF:000847', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(64985, NULL, 'G3DSA:1.10.225.10:FF:000003', NULL, NULL, 'Mesencephalic astrocyte-derived neurotrophic factor', NULL, NULL, NULL, NULL, NULL, 4),
(64986, NULL, 'G3DSA:3.40.47.10:FF:000274', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64987, NULL, 'G3DSA:2.60.120.10:FF:000211', NULL, NULL, 'Protein kinase A regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(64988, NULL, 'G3DSA:3.30.70.1350:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(64989, NULL, 'G3DSA:2.130.10.10:FF:000855', NULL, NULL, '3-carboxy-cis,cis-mucoante lactonizing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(64990, NULL, 'G3DSA:3.10.350.10:FF:000067', NULL, NULL, 'Putative lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(64991, NULL, 'G3DSA:2.60.120.200:FF:000068', NULL, NULL, 'collagen alpha-1(XXI) chain isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(64992, NULL, 'G3DSA:3.60.10.10:FF:000244', NULL, NULL, 'DNA-(apurinic or apyrimidinic site) lyase', NULL, NULL, NULL, NULL, NULL, 4),
(64993, NULL, 'G3DSA:3.30.1490.80:FF:000008', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(64994, NULL, 'G3DSA:2.60.120.260:FF:000625', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(64995, NULL, 'G3DSA:2.130.10.110:FF:000014', NULL, NULL, 'Clathrin heavy chain-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(64996, NULL, 'G3DSA:2.60.40.60:FF:000752', NULL, NULL, 'Cadherin-4', NULL, NULL, NULL, NULL, NULL, 4),
(64997, NULL, 'G3DSA:3.30.740.10:FF:000008', NULL, NULL, 'Dynein light chain', NULL, NULL, NULL, NULL, NULL, 4),
(64998, NULL, 'G3DSA:1.20.1050.130:FF:000042', NULL, NULL, 'Elongation factor 1-beta', NULL, NULL, NULL, NULL, NULL, 4),
(64999, NULL, 'G3DSA:1.10.510.10:FF:000088', NULL, NULL, 'cyclin-dependent kinase 8 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(65000, NULL, 'G3DSA:1.10.472.10:FF:000195', NULL, NULL, 'Putative Cyclin-L1', NULL, NULL, NULL, NULL, NULL, 4),
(65001, NULL, 'G3DSA:3.30.710.10:FF:000506', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65002, NULL, 'G3DSA:1.10.10.1270:FF:000001', NULL, NULL, 'Fibrinogen-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(65003, NULL, 'G3DSA:2.60.40.10:FF:000765', NULL, NULL, 'CD86 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(65004, NULL, 'G3DSA:1.10.238.10:FF:001270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65005, NULL, 'G3DSA:3.40.50.150:FF:001406', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65006, NULL, 'G3DSA:1.20.1090.10:FF:000034', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(65007, NULL, 'G3DSA:1.10.10.10:FF:001072', NULL, NULL, 'Fur family zinc uptake transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(65008, NULL, 'G3DSA:2.60.40.10:FF:002856', NULL, NULL, 'Iron-sulfur cluster binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(65009, NULL, 'G3DSA:2.130.10.120:FF:000017', NULL, NULL, 'Oligopeptidase B protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65010, NULL, 'G3DSA:4.10.430.10:FF:000002', NULL, NULL, 'DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(65011, NULL, 'G3DSA:3.90.780.10:FF:000048', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(65012, NULL, 'G3DSA:3.90.290.10:FF:000027', NULL, NULL, 'Fibrillin-1', NULL, NULL, NULL, NULL, NULL, 4),
(65013, NULL, 'G3DSA:3.30.70.330:FF:002237', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65014, NULL, 'G3DSA:1.20.1260.140:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65015, NULL, 'G3DSA:2.120.10.30:FF:000098', NULL, NULL, 'LDL receptor protein 1, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(65016, NULL, 'G3DSA:3.50.50.100:FF:000018', NULL, NULL, 'Pyridine nucleotide-disulphide oxidoreductase AMID-like, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65017, NULL, 'G3DSA:3.40.390.10:FF:000203', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65018, NULL, 'G3DSA:2.30.29.30:FF:000145', NULL, NULL, 'Sorting nexin-17 isoform1', NULL, NULL, NULL, NULL, NULL, 4),
(65019, NULL, 'G3DSA:3.30.70.330:FF:001040', NULL, NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(65020, NULL, 'G3DSA:1.20.58.410:FF:000001', NULL, NULL, 'Peptide chain release factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(65021, NULL, 'G3DSA:1.10.238.10:FF:001005', NULL, NULL, 'DCN1-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(65022, NULL, 'G3DSA:3.60.40.10:FF:000021', NULL, NULL, 'Protein phosphatase, Mg2+/Mn2+-dependent, 1E', NULL, NULL, NULL, NULL, NULL, 4),
(65023, NULL, 'G3DSA:1.10.472.10:FF:000695', NULL, NULL, 'Cyclin-D2-1', NULL, NULL, NULL, NULL, NULL, 4),
(65024, NULL, 'G3DSA:1.20.5.110:FF:000052', NULL, NULL, 'synaptosomal-associated protein 47', NULL, NULL, NULL, NULL, NULL, 4),
(65025, NULL, 'G3DSA:3.40.309.10:FF:000015', NULL, NULL, 'Delta-1-pyrroline-5-carboxylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(65026, NULL, 'G3DSA:1.20.1250.20:FF:000314', NULL, NULL, 'Transporter, MFS superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(65027, NULL, 'G3DSA:3.30.60.190:FF:000017', NULL, NULL, 'Zinc finger domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(65028, NULL, 'G3DSA:1.20.58.420:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65029, NULL, 'G3DSA:2.130.10.10:FF:002946', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65030, NULL, 'G3DSA:2.120.10.30:FF:000356', NULL, NULL, 'Protein STRICTOSIDINE SYNTHASE-LIKE 2', NULL, NULL, NULL, NULL, NULL, 4),
(65031, NULL, 'G3DSA:3.40.50.10810:FF:000073', NULL, NULL, 'DNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65032, NULL, 'G3DSA:3.40.1170.60:FF:000010', NULL, NULL, 'DNA polymerase V subunit', NULL, NULL, NULL, NULL, NULL, 4),
(65033, NULL, 'G3DSA:1.20.120.980:FF:000025', NULL, NULL, 'AGAP004015-PA', NULL, NULL, NULL, NULL, NULL, 4),
(65034, NULL, 'G3DSA:2.30.30.30:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65035, NULL, 'G3DSA:3.30.70.330:FF:001686', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65036, NULL, 'G3DSA:3.90.660.10:FF:000101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65037, NULL, 'G3DSA:3.40.50.1820:FF:001479', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65038, NULL, 'G3DSA:6.20.250.70:FF:000002', NULL, NULL, 'RNA polymerase A', NULL, NULL, NULL, NULL, NULL, 4),
(65039, NULL, 'G3DSA:3.30.230.100:FF:000001', NULL, NULL, 'Proteasome chaperone 4', NULL, NULL, NULL, NULL, NULL, 4),
(65040, NULL, 'G3DSA:3.30.160.60:FF:001350', NULL, NULL, 'zinc finger protein 483 isoform X1', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(65041, NULL, 'G3DSA:3.40.350.10:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65042, NULL, 'G3DSA:3.10.50.10:FF:000013', NULL, NULL, 'Probable chitinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(65043, NULL, 'G3DSA:1.20.142.10:FF:000005', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(65044, NULL, 'G3DSA:2.60.200.20:FF:000215', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(65045, NULL, 'G3DSA:3.90.70.10:FF:000595', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(65046, NULL, 'G3DSA:1.20.1540.10:FF:000058', NULL, NULL, 'Rhomboid family intramembrane serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(65047, NULL, 'G3DSA:1.10.3450.40:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65048, NULL, 'G3DSA:2.60.34.10:FF:000026', NULL, NULL, 'Heat shock 70 kDa protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(65049, NULL, 'G3DSA:3.30.1370.10:FF:000086', NULL, NULL, 'Oocyte-expressed protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(65050, NULL, 'G3DSA:1.20.58.530:FF:000037', NULL, NULL, 'Chitin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(65051, NULL, 'G3DSA:1.25.40.10:FF:000478', NULL, NULL, 'GG16802', NULL, NULL, NULL, NULL, NULL, 4),
(65052, NULL, 'G3DSA:2.40.70.10:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65053, NULL, 'G3DSA:2.30.42.10:FF:000226', NULL, NULL, 'Golgi reassembly-stacking protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(65054, NULL, 'G3DSA:3.40.50.1860:FF:000002', NULL, NULL, 'Glutamate racemase', NULL, NULL, NULL, NULL, NULL, 4),
(65055, NULL, 'G3DSA:2.10.25.10:FF:001553', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65056, NULL, 'G3DSA:3.40.109.10:FF:000034', NULL, NULL, 'Nitroreductase', NULL, NULL, NULL, NULL, NULL, 4),
(65057, NULL, 'G3DSA:1.25.10.10:FF:000976', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(65058, NULL, 'G3DSA:2.60.120.200:FF:000017', NULL, NULL, 'Vesicular integral-membrane protein VIP36', NULL, NULL, NULL, NULL, NULL, 4),
(65059, NULL, 'G3DSA:2.60.40.3070:FF:000001', NULL, NULL, 'Lactonase, 7-bladed beta-propeller domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(65060, NULL, 'G3DSA:2.130.10.10:FF:000794', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(65061, NULL, 'G3DSA:3.40.50.300:FF:007426', NULL, NULL, 'ABC transporter protein family', NULL, NULL, NULL, NULL, NULL, 4),
(65062, NULL, 'G3DSA:3.40.50.300:FF:004785', NULL, NULL, 'ATPase involved in chromosome partitioning, ParA/MinD family', NULL, NULL, NULL, NULL, NULL, 4),
(65063, NULL, 'G3DSA:3.40.190.10:FF:000643', NULL, NULL, 'Prephenate dehydratase / chorismate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(65064, NULL, 'G3DSA:1.20.58.60:FF:000145', NULL, NULL, 'Spectrin beta chain, non-erythrocytic', NULL, NULL, NULL, NULL, NULL, 4),
(65065, NULL, 'G3DSA:1.10.10.60:FF:000783', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(65066, NULL, 'G3DSA:3.30.160.60:FF:003502', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65067, NULL, 'G3DSA:1.20.58.70:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65068, NULL, 'G3DSA:1.25.40.10:FF:004194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65069, NULL, 'G3DSA:3.40.50.1820:FF:001558', NULL, NULL, 'Uncharacterized membrane protein C6F6.13c', NULL, NULL, NULL, NULL, NULL, 4),
(65070, NULL, 'G3DSA:1.10.10.1020:FF:000005', NULL, NULL, 'RecBCD enzyme subunit RecD', NULL, NULL, NULL, NULL, NULL, 4),
(65071, NULL, 'G3DSA:2.60.120.650:FF:000129', NULL, NULL, 'lysine-specific demethylase 3B', NULL, NULL, NULL, NULL, NULL, 4),
(65072, NULL, 'G3DSA:3.40.50.720:FF:000133', NULL, NULL, 'Methionine adenosyltransferase 2 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(65073, NULL, 'G3DSA:2.60.40.10:FF:005470', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(65074, NULL, 'G3DSA:3.40.30.10:FF:001039', NULL, NULL, 'AhpC/TSA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(65075, NULL, 'G3DSA:2.60.120.330:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65076, NULL, 'G3DSA:3.10.180.10:FF:000060', NULL, NULL, 'Putative enzyme related to lactoylglutathione lyase', NULL, NULL, NULL, NULL, NULL, 4),
(65077, NULL, 'G3DSA:1.10.287.690:FF:000018', NULL, NULL, 'DNA polymerase epsilon catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(65078, NULL, 'G3DSA:3.40.50.300:FF:005414', NULL, NULL, 'Putative RNA helicase armi-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(65079, NULL, 'G3DSA:1.20.58.120:FF:000004', NULL, NULL, 'BAG family molecular chaperone regulator 5', NULL, NULL, NULL, NULL, NULL, 4),
(65080, NULL, 'G3DSA:3.30.160.60:FF:003115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65081, NULL, 'G3DSA:1.20.58.60:FF:000066', NULL, NULL, 'Short stop, isoform K', NULL, NULL, NULL, NULL, NULL, 4),
(65082, NULL, 'G3DSA:3.40.50.150:FF:000889', NULL, NULL, 'Slr0907 protein', NULL, NULL, NULL, NULL, NULL, 4),
(65083, NULL, 'G3DSA:1.10.8.10:FF:000250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65084, NULL, 'G3DSA:3.30.160.60:FF:000939', NULL, NULL, 'zinc finger protein 8 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(65085, NULL, 'G3DSA:1.10.287.470:FF:000003', NULL, NULL, 'UPF0194 membrane protein YbhG', NULL, NULL, NULL, NULL, NULL, 4),
(65086, NULL, 'G3DSA:1.10.287.130:FF:000250', NULL, NULL, 'Response receiver histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(65087, NULL, 'G3DSA:3.20.10.10:FF:000010', NULL, NULL, 'Branched-chain amino acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(65088, NULL, 'G3DSA:3.30.200.20:FF:002376', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65089, NULL, 'G3DSA:3.30.450.20:FF:000023', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(65090, NULL, 'G3DSA:3.90.1150.10:FF:000393', NULL, NULL, 'Serine--pyruvate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(65091, NULL, 'G3DSA:1.20.5.320:FF:000031', NULL, NULL, 'Si:ch1073-184j22.1', NULL, NULL, NULL, NULL, NULL, 4),
(65092, NULL, 'G3DSA:1.10.10.1010:FF:000002', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(65093, NULL, 'G3DSA:3.40.50.300:FF:002368', NULL, NULL, 'DNA replication factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65094, NULL, 'G3DSA:1.20.58.110:FF:000001', NULL, NULL, '30S ribosomal protein S20', NULL, NULL, NULL, NULL, NULL, 4),
(65095, NULL, 'G3DSA:2.40.33.10:FF:000019', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(65096, NULL, 'G3DSA:3.40.190.10:FF:000429', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(65097, NULL, 'G3DSA:3.30.40.10:FF:000264', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(65098, NULL, 'G3DSA:2.130.10.10:FF:000468', NULL, NULL, 'WD repeat domain 43', NULL, NULL, NULL, NULL, NULL, 4),
(65099, NULL, 'G3DSA:3.10.110.10:FF:000252', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(65100, NULL, 'G3DSA:3.80.10.10:FF:002328', NULL, NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', NULL, NULL, NULL, NULL, NULL, 4),
(65101, NULL, 'G3DSA:3.40.50.150:FF:000597', NULL, NULL, 'O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(65102, NULL, 'G3DSA:3.10.20.90:FF:000866', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65103, NULL, 'G3DSA:3.30.160.60:FF:004981', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65104, NULL, 'G3DSA:1.20.58.60:FF:000420', NULL, NULL, 'AGAP009554-PA', NULL, NULL, NULL, NULL, NULL, 4),
(65105, NULL, 'G3DSA:1.10.10.60:FF:000844', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65106, NULL, 'G3DSA:3.40.50.1240:FF:000119', NULL, NULL, 'Thiamine-repressible acid phosphatase SPBC21H7.03c', NULL, NULL, NULL, NULL, NULL, 4),
(65107, NULL, 'G3DSA:3.40.50.1820:FF:000170', NULL, NULL, 'Alpha/beta-Hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(65108, NULL, 'G3DSA:3.90.1150.10:FF:000342', NULL, NULL, 'Serine-pyruvate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(65109, NULL, 'G3DSA:1.20.1310.10:FF:000187', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65110, NULL, 'G3DSA:3.90.470.10:FF:000013', NULL, NULL, '50S ribosomal protein L22', NULL, NULL, NULL, NULL, NULL, 4),
(65111, NULL, 'G3DSA:2.30.42.10:FF:000613', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65112, NULL, 'G3DSA:1.20.1560.10:FF:000121', NULL, NULL, 'ABC transporter B family member 9', NULL, NULL, NULL, NULL, NULL, 4),
(65113, NULL, 'G3DSA:1.20.1280.50:FF:000010', NULL, NULL, 'F-box only protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(65114, NULL, 'G3DSA:1.20.1060.10:FF:000027', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(65115, NULL, 'G3DSA:1.20.1070.10:FF:000185', NULL, NULL, 'Alpha-2B adrenergic receptor', NULL, NULL, NULL, NULL, NULL, 4),
(65116, NULL, 'G3DSA:2.60.40.10:FF:001428', NULL, NULL, 'CD166 antigen', NULL, NULL, NULL, NULL, NULL, 4),
(65117, NULL, 'G3DSA:3.30.40.10:FF:001692', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65118, NULL, 'G3DSA:3.30.160.60:FF:000647', NULL, NULL, 'myeloid zinc finger 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(65119, NULL, 'G3DSA:3.40.630.10:FF:000178', NULL, NULL, 'M20 domain-containing peptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65120, NULL, 'G3DSA:3.90.470.20:FF:000016', NULL, NULL, '4-phosphopantetheinyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(65121, NULL, 'G3DSA:3.40.140.10:FF:000157', NULL, NULL, 'Pre-mRNA splicing factor Prp8, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65122, NULL, 'G3DSA:2.60.34.10:FF:000077', NULL, NULL, 'Hsp70 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65123, NULL, 'G3DSA:3.40.50.1820:FF:000456', NULL, NULL, 'Homoserine O-succinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(65124, NULL, 'G3DSA:1.20.1270.10:FF:000020', NULL, NULL, 'Phosphorylated CTD-interacting factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(65125, NULL, 'G3DSA:1.10.287.3510:FF:000006', NULL, NULL, 'NADH-quinone oxidoreductase subunit K', NULL, NULL, NULL, NULL, NULL, 4),
(65126, NULL, 'G3DSA:2.30.230.10:FF:000024', NULL, NULL, 'Vitellogenin', NULL, NULL, NULL, NULL, NULL, 4),
(65127, NULL, 'G3DSA:1.20.1230.10:FF:000006', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(65128, NULL, 'G3DSA:2.60.40.10:FF:000198', NULL, NULL, 'Tripartite motif-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(65129, NULL, 'G3DSA:1.10.3470.10:FF:000027', NULL, NULL, 'Iron ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(65130, NULL, 'G3DSA:3.40.50.11610:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65131, NULL, 'G3DSA:3.50.50.60:FF:000773', NULL, NULL, 'Flavin-containing monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65132, NULL, 'G3DSA:3.30.160.60:FF:005144', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65133, NULL, 'G3DSA:2.60.40.10:FF:001136', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', NULL, NULL, NULL, NULL, NULL, 4),
(65134, NULL, 'G3DSA:4.10.60.10:FF:000152', NULL, NULL, 'Cold shock domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(65135, NULL, 'G3DSA:3.90.1150.10:FF:000016', NULL, NULL, 'Lysine decarboxylase, inducible', NULL, NULL, NULL, NULL, NULL, 4),
(65136, NULL, 'G3DSA:3.30.160.60:FF:004576', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65137, NULL, 'G3DSA:1.10.150.60:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65138, NULL, 'G3DSA:3.40.630.10:FF:000127', NULL, NULL, 'Nicastrin, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(65139, NULL, 'G3DSA:1.20.1250.20:FF:001096', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(65140, NULL, 'G3DSA:3.30.40.10:FF:001978', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65141, NULL, 'G3DSA:1.25.10.10:FF:001370', NULL, NULL, 'Resistance to inhibitor of cholinesterase 8', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(65142, NULL, 'G3DSA:2.30.180.10:FF:000194', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65143, NULL, 'G3DSA:2.20.70.10:FF:000033', NULL, NULL, 'Growth arrest specific 7', NULL, NULL, NULL, NULL, NULL, 4),
(65144, NULL, 'G3DSA:2.40.10.10:FF:000326', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65145, NULL, 'G3DSA:1.10.10.60:FF:000457', NULL, NULL, 'Trihelix transcription factor GTL2', NULL, NULL, NULL, NULL, NULL, 4),
(65146, NULL, 'G3DSA:2.40.15.10:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65147, NULL, 'G3DSA:1.10.10.60:FF:001221', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65148, NULL, 'G3DSA:3.40.50.2000:FF:000415', NULL, NULL, 'Asparagine Linked Glycosylation (ALG) homolog, Nematode', NULL, NULL, NULL, NULL, NULL, 4),
(65149, NULL, 'G3DSA:2.40.160.180:FF:000001', NULL, NULL, 'Porin', NULL, NULL, NULL, NULL, NULL, 4),
(65150, NULL, 'G3DSA:2.40.30.170:FF:000041', NULL, NULL, 'Cation efflux system (CzcB-like)', NULL, NULL, NULL, NULL, NULL, 4),
(65151, NULL, 'G3DSA:1.20.120.220:FF:000022', NULL, NULL, 'ATP synthase F0, A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(65152, NULL, 'G3DSA:3.30.200.20:FF:000931', NULL, NULL, 'tyrosine-protein kinase receptor torso', NULL, NULL, NULL, NULL, NULL, 4),
(65153, NULL, 'G3DSA:2.130.10.10:FF:003109', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65154, NULL, 'G3DSA:3.40.50.720:FF:000751', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(65155, NULL, 'G3DSA:3.40.50.150:FF:001114', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65156, NULL, 'G3DSA:3.90.1750.20:FF:000014', NULL, NULL, 'Site-specific recombinase', NULL, NULL, NULL, NULL, NULL, 4),
(65157, NULL, 'G3DSA:1.20.5.190:FF:000115', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65158, NULL, 'G3DSA:3.80.10.10:FF:002093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65159, NULL, 'G3DSA:1.10.10.10:FF:000678', NULL, NULL, 'Ribosomal protein S25', NULL, NULL, NULL, NULL, NULL, 4),
(65160, NULL, 'G3DSA:3.40.190.10:FF:000840', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(65161, NULL, 'G3DSA:3.40.50.720:FF:001656', NULL, NULL, 'Probable arogenate/prephenate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(65162, NULL, 'G3DSA:1.20.1270.10:FF:000071', NULL, NULL, 'Cytosol-type hsp70', NULL, NULL, NULL, NULL, NULL, 4),
(65163, NULL, 'G3DSA:3.40.50.300:FF:005009', NULL, NULL, 'Septin 6', NULL, NULL, NULL, NULL, NULL, 4),
(65164, NULL, 'G3DSA:3.30.200.160:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65165, NULL, 'G3DSA:3.30.40.10:FF:002029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65166, NULL, 'G3DSA:3.40.50.1820:FF:000405', NULL, NULL, 'Related to CLD1-mitochondrial cardiolipin-specific phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(65167, NULL, 'G3DSA:3.90.1170.10:FF:000012', NULL, NULL, 'Unplaced genomic scaffold supercont2.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(65168, NULL, 'G3DSA:2.130.10.10:FF:003031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65169, NULL, 'G3DSA:1.20.120.230:FF:000025', NULL, NULL, 'Vinculin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(65170, NULL, 'G3DSA:2.60.40.10:FF:005144', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65171, NULL, 'G3DSA:2.30.29.30:FF:001376', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(65172, NULL, 'G3DSA:3.80.10.10:FF:001536', NULL, NULL, 'F-box/leucine rich repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65173, NULL, 'G3DSA:3.40.50.720:FF:002319', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(65174, NULL, 'G3DSA:3.30.428.10:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65175, NULL, 'G3DSA:1.25.40.180:FF:000136', NULL, NULL, 'Eukaryotic initiation factor', NULL, NULL, NULL, NULL, NULL, 4),
(65176, NULL, 'G3DSA:1.25.40.10:FF:003092', NULL, NULL, 'AGAP010426-PA', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(65177, NULL, 'G3DSA:1.10.287.70:FF:000405', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65178, NULL, 'G3DSA:3.30.1520.10:FF:000126', NULL, NULL, 'Rho GTPase activator (Bem3), putative (AFU_orthologue AFUA_6G06400)', NULL, NULL, NULL, NULL, NULL, 4),
(65179, NULL, 'G3DSA:3.30.830.10:FF:000280', NULL, NULL, 'FI23714p1', NULL, NULL, NULL, NULL, NULL, 4),
(65180, NULL, 'G3DSA:3.50.50.60:FF:000329', NULL, NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(65181, NULL, 'G3DSA:3.40.50.2300:FF:000241', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(65182, NULL, 'G3DSA:1.10.132.60:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65183, NULL, 'G3DSA:2.130.10.10:FF:002593', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(65184, NULL, 'G3DSA:3.30.160.60:FF:002985', NULL, NULL, 'Zinc finger protein 567', NULL, NULL, NULL, NULL, NULL, 4),
(65185, NULL, 'G3DSA:1.10.3720.10:FF:000187', NULL, NULL, 'Binding-protein-dependent transport systems inner membrane component', NULL, NULL, NULL, NULL, NULL, 4),
(65186, NULL, 'G3DSA:3.40.190.290:FF:000096', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(65187, NULL, 'G3DSA:3.20.20.80:FF:000222', NULL, NULL, 'Hexosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(65188, NULL, 'G3DSA:3.60.15.10:FF:000233', NULL, NULL, 'YALI0E32527p', NULL, NULL, NULL, NULL, NULL, 4),
(65189, NULL, 'G3DSA:1.25.40.10:FF:004452', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65190, NULL, 'G3DSA:3.10.330.20:FF:000007', NULL, NULL, 'tRNA (adenine(58)-N(1))-methyltransferase catalytic subunit TRM61', NULL, NULL, NULL, NULL, NULL, 4),
(65191, NULL, 'G3DSA:3.30.710.10:FF:000214', NULL, NULL, 'Potassium voltage-gated channel protein shk-1', NULL, NULL, NULL, NULL, NULL, 4),
(65192, NULL, 'G3DSA:2.130.10.10:FF:001311', NULL, NULL, 'Bromodomain and WD repeat domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(65193, NULL, 'G3DSA:2.20.70.10:FF:000084', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(65194, NULL, 'G3DSA:2.40.50.40:FF:000062', NULL, NULL, 'Chromodomain-helicase-DNA-binding protein 1, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(65195, NULL, 'G3DSA:2.60.40.790:FF:000073', NULL, NULL, 'Heat shock protein', NULL, NULL, NULL, NULL, NULL, 4),
(65196, NULL, 'G3DSA:3.40.50.360:FF:000042', NULL, NULL, 'Multimeric flavodoxin WrbA', NULL, NULL, NULL, NULL, NULL, 4),
(65197, NULL, 'G3DSA:3.40.47.10:FF:000009', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(65198, NULL, 'G3DSA:1.10.1070.11:FF:000048', NULL, NULL, 'Phosphatidylinositol 3-kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65199, NULL, 'G3DSA:3.90.180.10:FF:000120', NULL, NULL, 'Quinone oxidoreductase-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(65200, NULL, 'G3DSA:3.30.390.50:FF:000015', NULL, NULL, 'Lipoyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(65201, NULL, 'G3DSA:3.30.70.330:FF:000051', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(65202, NULL, 'G3DSA:2.120.10.80:FF:000085', NULL, NULL, 'host cell factor 1 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(65203, NULL, 'G3DSA:2.130.10.10:FF:003205', NULL, NULL, 'WD repeat-containing protein 38', NULL, NULL, NULL, NULL, NULL, 4),
(65204, NULL, 'G3DSA:3.30.70.1290:FF:000007', NULL, NULL, 'Transposase', NULL, NULL, NULL, NULL, NULL, 4),
(65205, NULL, 'G3DSA:3.60.10.10:FF:000132', NULL, NULL, 'Inositol 5-phosphatase, putative (AFU_orthologue AFUA_5G07600)', NULL, NULL, NULL, NULL, NULL, 4),
(65206, NULL, 'G3DSA:3.10.330.10:FF:000004', NULL, NULL, 'Peroxisome biogenesis factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(65207, NULL, 'G3DSA:1.20.1560.10:FF:000172', NULL, NULL, 'p-GlycoProtein related', NULL, NULL, NULL, NULL, NULL, 4),
(65208, NULL, 'G3DSA:1.20.1070.10:FF:001545', NULL, NULL, 'Dopamine receptor D4a', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(65209, NULL, 'G3DSA:1.10.340.30:FF:000086', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(65210, NULL, 'G3DSA:2.60.40.10:FF:000939', NULL, NULL, 'Tenascin C', NULL, NULL, NULL, NULL, NULL, 4),
(65211, NULL, 'G3DSA:2.70.170.10:FF:000162', NULL, NULL, 'Neurotransmitter gated ion channel, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65212, NULL, 'G3DSA:3.40.640.10:FF:000279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65213, NULL, 'G3DSA:2.10.22.10:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65214, NULL, 'G3DSA:3.40.50.720:FF:000700', NULL, NULL, 'Calcium-activated potassium channel subunit alpha-1', NULL, NULL, NULL, NULL, NULL, 4),
(65215, NULL, 'G3DSA:1.10.340.30:FF:000035', NULL, NULL, 'Base excision DNA repair protein, HhH-GPD family', NULL, NULL, NULL, NULL, NULL, 4),
(65216, NULL, 'G3DSA:2.40.180.10:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(65217, NULL, 'G3DSA:3.30.70.330:FF:000258', NULL, NULL, 'Split ends, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(65218, NULL, 'G3DSA:3.30.430.20:FF:000027', NULL, NULL, 'Cysteine-rich repeat secretory protein 55', NULL, NULL, NULL, NULL, NULL, 4),
(65219, NULL, 'G3DSA:1.20.1070.10:FF:001848', NULL, NULL, 'Arginine vasopressin receptor 2,-like', NULL, NULL, NULL, NULL, NULL, 4),
(65220, NULL, 'G3DSA:1.20.58.60:FF:000471', NULL, NULL, 'AGAP009554-PA', NULL, NULL, NULL, NULL, NULL, 4),
(65221, NULL, 'G3DSA:1.20.120.1780:FF:000013', NULL, NULL, '4-hydroxybenzoate polyprenyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(65222, NULL, 'G3DSA:3.30.160.60:FF:005470', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65223, NULL, 'G3DSA:1.10.10.160:FF:000011', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(65224, NULL, 'G3DSA:2.60.40.820:FF:000003', NULL, NULL, 'T-box transcription factor TBX3', NULL, NULL, NULL, NULL, NULL, 4),
(65225, NULL, 'G3DSA:2.130.10.10:FF:003082', NULL, NULL, 'UTP15 C terminal, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65226, NULL, 'G3DSA:3.40.50.720:FF:001982', NULL, NULL, 'Oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65227, NULL, 'G3DSA:3.40.50.1170:FF:000008', NULL, NULL, 'L-asparaginase 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65228, NULL, 'G3DSA:3.30.200.20:FF:000038', NULL, NULL, 'LIM domain kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(65229, NULL, 'G3DSA:3.40.50.170:FF:000041', NULL, NULL, 'Phosphoribosylglycinamide formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(65230, NULL, 'G3DSA:2.60.120.260:FF:000451', NULL, NULL, 'Beta-glucuronidase', NULL, NULL, NULL, NULL, NULL, 4),
(65231, NULL, 'G3DSA:3.30.300.20:FF:000023', NULL, NULL, 'GTPase Der', NULL, NULL, NULL, NULL, NULL, 4),
(65232, NULL, 'G3DSA:2.130.10.10:FF:004958', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65233, NULL, 'G3DSA:1.10.730.10:FF:000065', NULL, NULL, 'Leucyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(65234, NULL, 'G3DSA:1.20.900.10:FF:000020', NULL, NULL, 'FERM, RhoGEF and pleckstrin domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(65235, NULL, 'G3DSA:3.40.50.300:FF:003262', NULL, NULL, 'CTP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(65236, NULL, 'G3DSA:1.10.150.20:FF:000220', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4),
(65237, NULL, 'G3DSA:3.40.50.2000:FF:000027', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(65238, NULL, 'G3DSA:2.60.200.20:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65239, NULL, 'G3DSA:4.10.800.10:FF:000008', NULL, NULL, 'tumor-associated calcium signal transducer 2', NULL, NULL, NULL, NULL, NULL, 4),
(65240, NULL, 'G3DSA:2.20.100.10:FF:000180', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(65241, NULL, 'G3DSA:2.130.10.10:FF:005234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65242, NULL, 'G3DSA:1.10.472.80:FF:000221', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(65243, NULL, 'G3DSA:3.30.50.10:FF:000057', NULL, NULL, 'Gat2p', NULL, NULL, NULL, NULL, NULL, 4),
(65244, NULL, 'G3DSA:4.10.470.20:FF:000002', NULL, NULL, 'FI02838p', NULL, NULL, NULL, NULL, NULL, 4),
(65245, NULL, 'G3DSA:3.50.50.60:FF:000481', NULL, NULL, '2-polyprenyl-6-methoxyphenol hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(65246, NULL, 'G3DSA:3.10.150.10:FF:000018', NULL, NULL, 'DNA polymerase III subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(65247, NULL, 'G3DSA:2.40.10.10:FF:000652', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65248, NULL, 'G3DSA:1.10.472.10:FF:000369', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65249, NULL, 'G3DSA:1.20.80.60:FF:000005', NULL, NULL, 'Sorting NeXin', NULL, NULL, NULL, NULL, NULL, 4),
(65250, NULL, 'G3DSA:1.25.40.10:FF:002277', NULL, NULL, 'Chitin biosynthesis effector, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65251, NULL, 'G3DSA:3.40.50.720:FF:002196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65252, NULL, 'G3DSA:1.25.10.10:FF:003264', NULL, NULL, 'Serine/threonine-protein kinase ppk19', NULL, NULL, NULL, NULL, NULL, 4),
(65253, NULL, 'G3DSA:3.30.300.30:FF:000026', NULL, NULL, 'Short-chain-fatty-acid--CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(65254, NULL, 'G3DSA:1.50.10.130:FF:000004', NULL, NULL, 'Carene synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(65255, NULL, 'G3DSA:3.40.50.300:FF:004397', NULL, NULL, 'AAA+-type ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65256, NULL, 'G3DSA:3.40.50.300:FF:003211', NULL, NULL, 'Elongator complex protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65257, NULL, 'G3DSA:1.10.10.10:FF:002095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65258, NULL, 'G3DSA:3.40.50.300:FF:002929', NULL, NULL, 'Helicase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(65259, NULL, 'G3DSA:3.30.460.10:FF:000110', NULL, NULL, 'DNA-directed DNA/RNA polymerase mu', NULL, NULL, NULL, NULL, NULL, 4),
(65260, NULL, 'G3DSA:2.130.10.10:FF:002188', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(65261, NULL, 'G3DSA:2.130.10.10:FF:000417', NULL, NULL, 'Endoplasmic reticulum to nucleus signaling 2', NULL, NULL, NULL, NULL, NULL, 4),
(65262, NULL, 'G3DSA:1.20.1530.20:FF:000061', NULL, NULL, 'Arsenical-resistance protein ACR3', NULL, NULL, NULL, NULL, NULL, 4),
(65263, NULL, 'G3DSA:3.40.50.720:FF:000521', NULL, NULL, 'NAD(P)H-dependent glutamate synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65264, NULL, 'G3DSA:2.30.42.10:FF:000052', NULL, NULL, 'Syntrophin beta 1', NULL, NULL, NULL, NULL, NULL, 4),
(65265, NULL, 'G3DSA:3.40.50.150:FF:001165', NULL, NULL, 'Probable polyketide synthase 31', NULL, NULL, NULL, NULL, NULL, 4),
(65266, NULL, 'G3DSA:3.30.70.330:FF:002563', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65267, NULL, 'G3DSA:3.90.1100.10:FF:000064', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(65268, NULL, 'G3DSA:3.40.630.10:FF:000453', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65269, NULL, 'G3DSA:3.40.50.1220:FF:000113', NULL, NULL, 'NAD-dependent histone deacetylase sir2', NULL, NULL, NULL, NULL, NULL, 4),
(65270, NULL, 'G3DSA:3.30.450.30:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65271, NULL, 'G3DSA:2.60.40.150:FF:000555', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65272, NULL, 'G3DSA:3.40.50.2300:FF:000527', NULL, NULL, 'GLutamate Receptor family (AMPA)', NULL, NULL, NULL, NULL, NULL, 4),
(65273, NULL, 'G3DSA:1.20.1580.10:FF:000004', NULL, NULL, 'UvrABC system protein A', NULL, NULL, NULL, NULL, NULL, 4),
(65274, NULL, 'G3DSA:1.10.260.40:FF:000037', NULL, NULL, 'Type II toxin-antitoxin system HigA family antitoxin', NULL, NULL, NULL, NULL, NULL, 4),
(65275, NULL, 'G3DSA:3.40.640.10:FF:000072', NULL, NULL, 'Putative cystathionine beta-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(65276, NULL, 'G3DSA:3.30.200.20:FF:000656', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(65277, NULL, 'G3DSA:1.10.10.60:FF:000406', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(65278, NULL, 'G3DSA:1.25.40.20:FF:000868', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65279, NULL, 'G3DSA:3.90.180.10:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65280, NULL, 'G3DSA:2.120.10.10:FF:000024', NULL, NULL, 'Laminin G', NULL, NULL, NULL, NULL, NULL, 4),
(65281, NULL, 'G3DSA:2.30.30.100:FF:000213', NULL, NULL, 'Gem-associated protein 7 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(65282, NULL, 'G3DSA:3.50.80.10:FF:000007', NULL, NULL, 'D-aminoacyl-tRNA deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(65283, NULL, 'G3DSA:3.40.50.720:FF:000425', NULL, NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(65284, NULL, 'G3DSA:3.30.70.20:FF:000095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65285, NULL, 'G3DSA:3.90.1150.10:FF:000067', NULL, NULL, 'Maltose regulon modulator MalY', NULL, NULL, NULL, NULL, NULL, 4),
(65286, NULL, 'G3DSA:3.30.710.10:FF:000006', NULL, NULL, 'Kelch repeat and BTB domain-containing 6', NULL, NULL, NULL, NULL, NULL, 4),
(65287, NULL, 'G3DSA:1.10.10.60:FF:000378', NULL, NULL, 'Notochord homeobox', NULL, NULL, NULL, NULL, NULL, 4),
(65288, NULL, 'G3DSA:3.30.420.40:FF:000645', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(65289, NULL, 'G3DSA:1.25.10.10:FF:001201', NULL, NULL, 'Putative tubulin folding cofactor D', NULL, NULL, NULL, NULL, NULL, 4),
(65290, NULL, 'G3DSA:2.30.29.30:FF:001168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65291, NULL, 'G3DSA:3.40.50.11950:FF:000004', NULL, NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(65292, NULL, 'G3DSA:3.40.50.300:FF:002834', NULL, NULL, 'GPN-loop GTPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(65293, NULL, 'G3DSA:3.40.50.11960:FF:000007', NULL, NULL, 'Uncharacterized protein C19A8.11c', NULL, NULL, NULL, NULL, NULL, 4),
(65294, NULL, 'G3DSA:3.40.140.10:FF:000039', NULL, NULL, 'tRNA-specific adenosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(65295, NULL, 'G3DSA:3.30.70.330:FF:000707', NULL, NULL, 'RNA binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65296, NULL, 'G3DSA:3.40.50.300:FF:005010', NULL, NULL, 'DUF2431 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(65297, NULL, 'G3DSA:3.90.25.10:FF:000030', NULL, NULL, 'NAD(P)-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(65298, NULL, 'G3DSA:3.30.1390.20:FF:000034', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(65299, NULL, 'G3DSA:3.30.70.60:FF:000045', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(65300, NULL, 'G3DSA:2.60.120.260:FF:000075', NULL, NULL, 'Retinoschisin 1', NULL, NULL, NULL, NULL, NULL, 4),
(65301, NULL, 'G3DSA:3.30.60.30:FF:000058', NULL, NULL, 'agrin isoform X9', NULL, NULL, NULL, NULL, NULL, 4),
(65302, NULL, 'G3DSA:2.10.110.10:FF:000121', NULL, NULL, 'Rho GTPase activator Rga', NULL, NULL, NULL, NULL, NULL, 4),
(65303, NULL, 'G3DSA:3.30.1360.40:FF:000010', NULL, NULL, 'DNA topoisomerase (ATP-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4),
(65304, NULL, 'G3DSA:2.160.10.10:FF:000028', NULL, NULL, 'Bifunctional protein GlmU', NULL, NULL, NULL, NULL, NULL, 4),
(65305, NULL, 'G3DSA:3.90.20.20:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65306, NULL, 'G3DSA:1.10.510.10:FF:002892', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65307, NULL, 'G3DSA:3.30.200.20:FF:001027', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65308, NULL, 'G3DSA:1.10.400.10:FF:000085', NULL, NULL, 'Heterotrimeric G protein alpha subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(65309, NULL, 'G3DSA:2.130.10.10:FF:000294', NULL, NULL, 'WD repeat-containing protein 70', NULL, NULL, NULL, NULL, NULL, 4),
(65310, NULL, 'G3DSA:3.90.70.10:FF:000623', NULL, NULL, 'Calpain, putative cysteine peptidase, Clan CA, family C2, putative', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(65311, NULL, 'G3DSA:3.90.1150.10:FF:000281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65312, NULL, 'G3DSA:1.10.1510.30:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65313, NULL, 'G3DSA:2.10.110.10:FF:000059', NULL, NULL, 'LIM domain only 2', NULL, NULL, NULL, NULL, NULL, 4),
(65314, NULL, 'G3DSA:1.25.10.10:FF:002775', NULL, NULL, 'Beta subunit of clathrin adaptor protein AP3', NULL, NULL, NULL, NULL, NULL, 4),
(65315, NULL, 'G3DSA:3.40.50.10180:FF:000001', NULL, NULL, 'Glycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(65316, NULL, 'G3DSA:3.40.50.11500:FF:000004', NULL, NULL, 'DENN domain-containing protein 2C isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(65317, NULL, 'G3DSA:1.10.150.240:FF:000025', NULL, NULL, 'Haloacid dehalogenase-like hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(65318, NULL, 'G3DSA:3.30.760.10:FF:000043', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(65319, NULL, 'G3DSA:2.30.42.10:FF:000046', NULL, NULL, 'MAGUK p55 subfamily member 7', NULL, NULL, NULL, NULL, NULL, 4),
(65320, NULL, 'G3DSA:3.40.50.2300:FF:000174', NULL, NULL, 'Acetoacetate metabolism regulatory protein AtoC', NULL, NULL, NULL, NULL, NULL, 4),
(65321, NULL, 'G3DSA:2.30.29.30:FF:000712', NULL, NULL, 'Virus Induced Reporter Off', NULL, NULL, NULL, NULL, NULL, 4),
(65322, NULL, 'G3DSA:2.30.30.100:FF:000152', NULL, NULL, 'Gem nuclear organelle associated protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(65323, NULL, 'G3DSA:3.30.710.10:FF:000383', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65324, NULL, 'G3DSA:1.25.40.180:FF:000350', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65325, NULL, 'G3DSA:1.25.40.70:FF:000001', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(65326, NULL, 'G3DSA:2.60.40.10:FF:004981', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65327, NULL, 'G3DSA:1.25.40.90:FF:000007', NULL, NULL, 'Regulation of nuclear pre-mRNA domain-containing protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(65328, NULL, 'G3DSA:1.20.140.30:FF:000001', NULL, NULL, 'MOB kinase activator 1A', NULL, NULL, NULL, NULL, NULL, 4),
(65329, NULL, 'G3DSA:1.20.1070.10:FF:000651', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65330, NULL, 'G3DSA:2.60.120.200:FF:000635', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65331, NULL, 'G3DSA:1.20.1050.130:FF:000008', NULL, NULL, 'Glutamate-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(65332, NULL, 'G3DSA:3.40.50.300:FF:004964', NULL, NULL, 'Zgc:136870 protein', NULL, NULL, NULL, NULL, NULL, 4),
(65333, NULL, 'G3DSA:3.40.50.10190:FF:000004', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(65334, NULL, 'G3DSA:2.60.120.10:FF:000599', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(65335, NULL, 'G3DSA:3.90.1410.10:FF:000048', NULL, NULL, 'SET domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(65336, NULL, 'G3DSA:4.10.1000.10:FF:000040', NULL, NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(65337, NULL, 'G3DSA:3.50.50.60:FF:000981', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65338, NULL, 'G3DSA:1.20.1050.120:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65339, NULL, 'G3DSA:2.60.120.650:FF:000208', NULL, NULL, 'ABR167Cp', NULL, NULL, NULL, NULL, NULL, 4),
(65340, NULL, 'G3DSA:3.30.60.20:FF:000055', NULL, NULL, 'PDZ domain-containing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(65341, NULL, 'G3DSA:3.30.40.10:FF:002181', NULL, NULL, 'RING finger-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65342, NULL, 'G3DSA:1.25.40.80:FF:000004', NULL, NULL, 'Deoxyribodipyrimidine photolyase', NULL, NULL, NULL, NULL, NULL, 4),
(65343, NULL, 'G3DSA:3.30.2350.10:FF:000023', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(65344, NULL, 'G3DSA:3.80.10.10:FF:001991', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(65345, NULL, 'G3DSA:3.30.160.60:FF:004458', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65346, NULL, 'G3DSA:3.30.40.10:FF:002142', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(65347, NULL, 'G3DSA:2.60.120.560:FF:000007', NULL, NULL, 'Alpha-N-arabinofuranosidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(65348, NULL, 'G3DSA:2.60.40.10:FF:004705', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65349, NULL, 'G3DSA:2.60.260.20:FF:000084', NULL, NULL, 'Chaperone protein DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(65350, NULL, 'G3DSA:2.60.40.10:FF:004655', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65351, NULL, 'G3DSA:1.20.1070.10:FF:002096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65352, NULL, 'G3DSA:2.130.10.10:FF:003110', NULL, NULL, 'YALI0E00506p', NULL, NULL, NULL, NULL, NULL, 4),
(65353, NULL, 'G3DSA:1.25.10.10:FF:000476', NULL, NULL, 'Armadillo repeat only 2', NULL, NULL, NULL, NULL, NULL, 4),
(65354, NULL, 'G3DSA:3.10.250.10:FF:000003', NULL, NULL, 'Deleted in malignant brain tumors 1', NULL, NULL, NULL, NULL, NULL, 4),
(65355, NULL, 'G3DSA:3.20.20.70:FF:000686', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65356, NULL, 'G3DSA:3.90.226.10:FF:000249', NULL, NULL, 'probable methylcrotonoyl-CoA carboxylase beta chain, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(65357, NULL, 'G3DSA:1.10.10.1320:FF:000005', NULL, NULL, 'Anti-sigma-K factor RskA', NULL, NULL, NULL, NULL, NULL, 4),
(65358, NULL, 'G3DSA:1.25.40.180:FF:000018', NULL, NULL, 'eukaryotic translation initiation factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(65359, NULL, 'G3DSA:3.40.50.300:FF:002891', NULL, NULL, 'GTPBP2 isoform 12', NULL, NULL, NULL, NULL, NULL, 4),
(65360, NULL, 'G3DSA:1.10.20.10:FF:000297', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65361, NULL, 'G3DSA:1.10.472.10:FF:000723', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65362, NULL, 'G3DSA:1.10.1450.10:FF:000065', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(65363, NULL, 'G3DSA:1.10.10.60:FF:000283', NULL, NULL, 'Transcription factor RAX3', NULL, NULL, NULL, NULL, NULL, 4),
(65364, NULL, 'G3DSA:1.10.150.20:FF:000192', NULL, NULL, '5'' flap endonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65365, NULL, 'G3DSA:3.40.1190.20:FF:000022', NULL, NULL, 'Ribokinase', NULL, NULL, NULL, NULL, NULL, 4),
(65366, NULL, 'G3DSA:3.30.50.10:FF:000169', NULL, NULL, 'Estrogen receptor-related receptor', NULL, NULL, NULL, NULL, NULL, 4),
(65367, NULL, 'G3DSA:3.40.50.2000:FF:000241', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(65368, NULL, 'G3DSA:3.30.70.330:FF:000612', NULL, NULL, 'Glycine-rich RNA-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(65369, NULL, 'G3DSA:1.25.40.10:FF:002653', NULL, NULL, 'Trafficking protein particle complex 12', NULL, NULL, NULL, NULL, NULL, 4),
(65370, NULL, 'G3DSA:2.60.40.10:FF:001221', NULL, NULL, 'T-cell surface glycoprotein CD4', NULL, NULL, NULL, NULL, NULL, 4),
(65371, NULL, 'G3DSA:3.40.50.300:FF:008287', NULL, NULL, 'Katanin p60 ATPase-containing subunit A1', NULL, NULL, NULL, NULL, NULL, 4),
(65372, NULL, 'G3DSA:1.10.238.10:FF:000842', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65373, NULL, 'G3DSA:3.40.50.300:FF:001406', NULL, NULL, 'Putative vesicular transport protein (CDC48)', NULL, NULL, NULL, NULL, NULL, 4),
(65374, NULL, 'G3DSA:2.60.40.2130:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65375, NULL, 'G3DSA:1.25.40.10:FF:004744', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65376, NULL, 'G3DSA:1.10.510.10:FF:000649', NULL, NULL, 'Si:dkey-34d22.3', NULL, NULL, NULL, NULL, NULL, 4),
(65377, NULL, 'G3DSA:3.10.20.10:FF:000005', NULL, NULL, 'Cell death activator CIDE-B', NULL, NULL, NULL, NULL, NULL, 4),
(65378, NULL, 'G3DSA:1.25.40.20:FF:001032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65379, NULL, 'G3DSA:3.40.50.720:FF:000633', NULL, NULL, 'Pentafunctional AROM polypeptide', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(65380, NULL, 'G3DSA:3.40.640.10:FF:000184', NULL, NULL, 'Putative threonine aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(65381, NULL, 'G3DSA:2.40.10.10:FF:000298', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65382, NULL, 'G3DSA:2.130.10.10:FF:005240', NULL, NULL, 'CPSF A subunit region family protein', NULL, NULL, NULL, NULL, NULL, 4),
(65383, NULL, 'G3DSA:2.10.25.10:FF:001519', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(65384, NULL, 'G3DSA:3.40.50.720:FF:000313', NULL, NULL, 'Chloroplast stem-loop binding protein of 41 kDa b, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(65385, NULL, 'G3DSA:1.10.1420.10:FF:000029', NULL, NULL, 'DNA mismatch repair protein MSH2', NULL, NULL, NULL, NULL, NULL, 4),
(65386, NULL, 'G3DSA:3.90.650.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65387, NULL, 'G3DSA:2.40.50.140:FF:000042', NULL, NULL, 'Methionine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(65388, NULL, 'G3DSA:3.30.2350.20:FF:000026', NULL, NULL, 'tRNA pseudouridine synthase D (TruD), variant', NULL, NULL, NULL, NULL, NULL, 4),
(65389, NULL, 'G3DSA:2.60.200.40:FF:000030', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(65390, NULL, 'G3DSA:2.60.40.420:FF:000102', NULL, NULL, 'Multi-copper oxidase type I family protein', NULL, NULL, NULL, NULL, NULL, 4),
(65391, NULL, 'G3DSA:3.40.50.2300:FF:000853', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65392, NULL, 'G3DSA:3.30.540.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65393, NULL, 'G3DSA:3.30.230.10:FF:000301', NULL, NULL, 'AFR226Cp', NULL, NULL, NULL, NULL, NULL, 4),
(65394, NULL, 'G3DSA:1.20.1250.20:FF:002085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65395, NULL, 'G3DSA:2.60.120.990:FF:000001', NULL, NULL, 'Aldos-2-ulose dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(65396, NULL, 'G3DSA:2.60.210.10:FF:000038', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(65397, NULL, 'G3DSA:3.40.30.10:FF:001191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65398, NULL, 'G3DSA:3.40.640.10:FF:000364', NULL, NULL, 'Aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(65399, NULL, 'G3DSA:2.20.100.10:FF:000011', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 3', NULL, NULL, NULL, NULL, NULL, 4),
(65400, NULL, 'G3DSA:1.25.40.10:FF:003120', NULL, NULL, 'Os04g0488200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(65401, NULL, 'G3DSA:3.10.310.10:FF:000003', NULL, NULL, 'Proline racemase', NULL, NULL, NULL, NULL, NULL, 4),
(65402, NULL, 'G3DSA:3.40.50.150:FF:001491', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65403, NULL, 'G3DSA:3.30.420.40:FF:000853', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65404, NULL, 'G3DSA:3.10.28.10:FF:000068', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(65405, NULL, 'G3DSA:2.30.30.40:FF:000668', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65406, NULL, 'G3DSA:3.30.559.10:FF:000042', NULL, NULL, 'Carnitine Palmitoyl Transferase', NULL, NULL, NULL, NULL, NULL, 4),
(65407, NULL, 'G3DSA:3.30.420.390:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65408, NULL, 'G3DSA:1.10.510.10:FF:004354', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65409, NULL, 'G3DSA:1.10.3810.10:FF:000014', NULL, NULL, 'Penicillin-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(65410, NULL, 'G3DSA:3.30.70.330:FF:002057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65411, NULL, 'G3DSA:1.20.1250.20:FF:000011', NULL, NULL, 'MFS multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65412, NULL, 'G3DSA:3.10.110.10:FF:000139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65413, NULL, 'G3DSA:2.60.40.10:FF:001041', NULL, NULL, 'Erythropoietin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(65414, NULL, 'G3DSA:2.130.10.10:FF:003317', NULL, NULL, 'WD40-repeat-containing domain protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(65415, NULL, 'G3DSA:1.10.287.70:FF:000170', NULL, NULL, 'Outward-rectifier potassium channel TOK1', NULL, NULL, NULL, NULL, NULL, 4),
(65416, NULL, 'G3DSA:1.20.140.40:FF:000088', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65417, NULL, 'G3DSA:3.60.90.10:FF:000024', NULL, NULL, 'Putative S-adenosylmethionine decarboxylase proenzyme-like', NULL, NULL, NULL, NULL, NULL, 4),
(65418, NULL, 'G3DSA:2.60.40.10:FF:003345', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65419, NULL, 'G3DSA:3.60.10.10:FF:000126', NULL, NULL, 'Inositol phosphorylsphingolipid-phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(65420, NULL, 'G3DSA:2.130.10.30:FF:000041', NULL, NULL, 'Guanine nucleotide exchange factor SRM1', NULL, NULL, NULL, NULL, NULL, 4),
(65421, NULL, 'G3DSA:3.40.50.1820:FF:000248', NULL, NULL, 'Serine esterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65422, NULL, 'G3DSA:3.10.20.90:FF:000658', NULL, NULL, 'Cordon-bleu WH2 repeat protein-like 1b', NULL, NULL, NULL, NULL, NULL, 4),
(65423, NULL, 'G3DSA:3.40.630.30:FF:000689', NULL, NULL, 'N-acetyl-transferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(65424, NULL, 'G3DSA:1.10.287.70:FF:000052', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(65425, NULL, 'G3DSA:1.10.575.10:FF:000001', NULL, NULL, 'Phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(65426, NULL, 'G3DSA:3.40.50.12620:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65427, NULL, 'G3DSA:4.10.860.120:FF:000018', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(65428, NULL, 'G3DSA:1.20.120.1880:FF:000010', NULL, NULL, 'Nuclear pore complex protein Nup155', NULL, NULL, NULL, NULL, NULL, 4),
(65429, NULL, 'G3DSA:3.40.50.80:FF:000010', NULL, NULL, 'Flavohemoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(65430, NULL, 'G3DSA:3.30.1550.10:FF:000004', NULL, NULL, 'Mitochondrial 54S ribosomal protein YmL19', NULL, NULL, NULL, NULL, NULL, 4),
(65431, NULL, 'G3DSA:2.40.50.140:FF:000249', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(65432, NULL, 'G3DSA:3.30.56.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65433, NULL, 'G3DSA:1.25.40.1050:FF:000006', NULL, NULL, '5''-3'' exoribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(65434, NULL, 'G3DSA:1.10.10.10:FF:000583', NULL, NULL, 'NUDIX hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(65435, NULL, 'G3DSA:2.10.25.10:FF:001671', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65436, NULL, 'G3DSA:3.40.50.80:FF:000122', NULL, NULL, 'Repressed by TUP1 protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(65437, NULL, 'G3DSA:3.30.70.330:FF:001899', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65438, NULL, 'G3DSA:3.90.550.10:FF:000683', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(65439, NULL, 'G3DSA:1.10.630.10:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65440, NULL, 'G3DSA:3.90.550.10:FF:000626', NULL, NULL, 'Adenosylcobinamide-phosphate guanylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(65441, NULL, 'G3DSA:1.20.5.370:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65442, NULL, 'G3DSA:1.10.10.850:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65443, NULL, 'G3DSA:3.40.50.80:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65444, NULL, 'G3DSA:1.20.1260.60:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65445, NULL, 'G3DSA:1.10.1670.10:FF:000008', NULL, NULL, 'Endonuclease III', NULL, NULL, NULL, NULL, NULL, 4),
(65446, NULL, 'G3DSA:3.40.50.300:FF:004689', NULL, NULL, 'ATPase, AAA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(65447, NULL, 'G3DSA:2.40.110.10:FF:000075', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(65448, NULL, 'G3DSA:3.40.50.300:FF:000923', NULL, NULL, 'ABC transporter C family member 10', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(65449, NULL, 'G3DSA:2.160.10.10:FF:000085', NULL, NULL, 'Translation initiation factor eif-2b epsilon subunit', NULL, NULL, NULL, NULL, NULL, 4),
(65450, NULL, 'G3DSA:3.30.450.20:FF:000562', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(65451, NULL, 'G3DSA:1.25.40.1010:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65452, NULL, 'G3DSA:4.10.60.10:FF:000264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65453, NULL, 'G3DSA:1.20.1080.10:FF:000039', NULL, NULL, 'Formate-nitrite transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65454, NULL, 'G3DSA:3.30.160.60:FF:005032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65455, NULL, 'G3DSA:3.40.50.150:FF:001614', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65456, NULL, 'G3DSA:3.30.460.10:FF:000060', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(65457, NULL, 'G3DSA:3.30.70.660:FF:000014', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(65458, NULL, 'G3DSA:2.130.10.10:FF:000389', NULL, NULL, 'WD repeat-containing protein 55', NULL, NULL, NULL, NULL, NULL, 4),
(65459, NULL, 'G3DSA:3.30.70.330:FF:000500', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(65460, NULL, 'G3DSA:3.30.420.40:FF:000920', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65461, NULL, 'G3DSA:3.40.50.300:FF:008562', NULL, NULL, 'Blr8088 protein', NULL, NULL, NULL, NULL, NULL, 4),
(65462, NULL, 'G3DSA:3.30.70.330:FF:000764', NULL, NULL, 'Poly(A) binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(65463, NULL, 'G3DSA:1.10.238.10:FF:000567', NULL, NULL, 'AT10229p', NULL, NULL, NULL, NULL, NULL, 4),
(65464, NULL, 'G3DSA:3.40.50.2300:FF:000292', NULL, NULL, 'Low molecular weight phosphotyrosine protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(65465, NULL, 'G3DSA:4.10.400.20:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65466, NULL, 'G3DSA:1.10.510.10:FF:001105', NULL, NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(65467, NULL, 'G3DSA:1.20.1160.11:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65468, NULL, 'G3DSA:1.10.950.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65469, NULL, 'G3DSA:3.90.1640.10:FF:000037', NULL, NULL, 'Probable manganese-dependent inorganic pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(65470, NULL, 'G3DSA:3.30.200.20:FF:002455', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65471, NULL, 'G3DSA:1.25.10.10:FF:002825', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65472, NULL, 'G3DSA:2.130.10.10:FF:001283', NULL, NULL, 'Pre-mRNA-splicing factor RSE1', NULL, NULL, NULL, NULL, NULL, 4),
(65473, NULL, 'G3DSA:3.90.470.20:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65474, NULL, 'G3DSA:3.40.50.300:FF:002598', NULL, NULL, 'GTPase Der', NULL, NULL, NULL, NULL, NULL, 4),
(65475, NULL, 'G3DSA:3.90.45.10:FF:000025', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(65476, NULL, 'G3DSA:2.60.40.10:FF:000698', NULL, NULL, 'brevican core protein', NULL, NULL, NULL, NULL, NULL, 4),
(65477, NULL, 'G3DSA:2.30.40.10:FF:000002', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(65478, NULL, 'G3DSA:3.40.47.10:FF:000178', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase', NULL, NULL, NULL, NULL, NULL, 4),
(65479, NULL, 'G3DSA:1.10.418.10:FF:000199', NULL, NULL, 'Interaptin', NULL, NULL, NULL, NULL, NULL, 4),
(65480, NULL, 'G3DSA:3.80.10.10:FF:002087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65481, NULL, 'G3DSA:3.40.50.620:FF:000316', NULL, NULL, 'Methionyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(65482, NULL, 'G3DSA:3.30.200.20:FF:000364', NULL, NULL, 'Interleukin 1 receptor associated kinase 3', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(65483, NULL, 'G3DSA:1.20.5.1700:FF:000015', NULL, NULL, 'Viral A-type inclusion protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65484, NULL, 'G3DSA:3.30.1120.100:FF:000003', NULL, NULL, 'Putative sterigmatocystin biosynthesis fatty acid synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(65485, NULL, 'G3DSA:1.10.10.60:FF:001272', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65486, NULL, 'G3DSA:3.10.20.90:FF:000872', NULL, NULL, 'PARKIN', NULL, NULL, NULL, NULL, NULL, 4),
(65487, NULL, 'G3DSA:3.30.470.20:FF:000024', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(65488, NULL, 'G3DSA:2.70.150.10:FF:000099', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(65489, NULL, 'G3DSA:3.90.1010.10:FF:000006', NULL, NULL, 'NifU-like N terminal domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(65490, NULL, 'G3DSA:3.40.640.10:FF:000307', NULL, NULL, 'Aminotransferase, class III', NULL, NULL, NULL, NULL, NULL, 4),
(65491, NULL, 'G3DSA:2.10.25.10:FF:001766', NULL, NULL, 'Laminin subunit alpha 5', NULL, NULL, NULL, NULL, NULL, 4),
(65492, NULL, 'G3DSA:3.60.15.10:FF:000154', NULL, NULL, 'Cleavage and polyadenylation specificity factor subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(65493, NULL, 'G3DSA:3.30.470.30:FF:000027', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(65494, NULL, 'G3DSA:1.10.472.10:FF:000077', NULL, NULL, 'RNA polymerase II holoenzyme cyclin-like subunit', NULL, NULL, NULL, NULL, NULL, 4),
(65495, NULL, 'G3DSA:1.25.40.10:FF:004244', NULL, NULL, 'Chromosome 1 SCAF14751, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(65496, NULL, 'G3DSA:2.60.120.260:FF:000007', NULL, NULL, 'Discoidin domain receptor tyrosine kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(65497, NULL, 'G3DSA:3.40.50.1460:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65498, NULL, 'G3DSA:3.30.2350.20:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65499, NULL, 'G3DSA:1.20.5.110:FF:000001', NULL, NULL, 'syntaxin-binding protein 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(65500, NULL, 'G3DSA:1.20.58.60:FF:000358', NULL, NULL, 'SMAll', NULL, NULL, NULL, NULL, NULL, 4),
(65501, NULL, 'G3DSA:3.40.50.1980:FF:000105', NULL, NULL, 'Nitrogenase MoFe cofactor biosynthesis protein NifN', NULL, NULL, NULL, NULL, NULL, 4),
(65502, NULL, 'G3DSA:3.30.160.60:FF:006049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65503, NULL, 'G3DSA:3.90.470.10:FF:000007', NULL, NULL, '50S ribosomal protein L22', NULL, NULL, NULL, NULL, NULL, 4),
(65504, NULL, 'G3DSA:3.90.226.10:FF:000238', NULL, NULL, 'Tail-specific protease', NULL, NULL, NULL, NULL, NULL, 4),
(65505, NULL, 'G3DSA:3.30.2350.10:FF:000034', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(65506, NULL, 'G3DSA:1.20.5.120:FF:000004', NULL, NULL, 'Proteasome activator complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(65507, NULL, 'G3DSA:3.40.1390.30:FF:000006', NULL, NULL, 'Dinuclear metal center protein, YbgI family', NULL, NULL, NULL, NULL, NULL, 4),
(65508, NULL, 'G3DSA:3.30.200.20:FF:000544', NULL, NULL, 'Calmodulin-binding receptor-like cytoplasmic kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(65509, NULL, 'G3DSA:1.20.1080.10:FF:000028', NULL, NULL, 'Probable formate transporter 2', NULL, NULL, NULL, NULL, NULL, 4),
(65510, NULL, 'G3DSA:3.40.50.12780:FF:000034', NULL, NULL, '2-succinylbenzoate--CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(65511, NULL, 'G3DSA:3.30.40.10:FF:002063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65512, NULL, 'G3DSA:1.10.220.150:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65513, NULL, 'G3DSA:1.10.760.10:FF:000067', NULL, NULL, '10S-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(65514, NULL, 'G3DSA:2.170.140.10:FF:000012', NULL, NULL, 'peritrophin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(65515, NULL, 'G3DSA:3.30.70.330:FF:002675', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(65516, NULL, 'G3DSA:2.60.120.240:FF:000001', NULL, NULL, 'Protective antigen', NULL, NULL, NULL, NULL, NULL, 4),
(65517, NULL, 'G3DSA:3.30.160.60:FF:002777', NULL, NULL, 'Transcription factor Ken 2', NULL, NULL, NULL, NULL, NULL, 4),
(65518, NULL, 'G3DSA:1.10.1670.10:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65519, NULL, 'G3DSA:3.10.110.10:FF:000347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65520, NULL, 'G3DSA:1.25.10.10:FF:000763', NULL, NULL, 'Suppressor protein MPT5', NULL, NULL, NULL, NULL, NULL, 4),
(65521, NULL, 'G3DSA:3.30.160.60:FF:005239', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65522, NULL, 'G3DSA:3.30.470.10:FF:000021', NULL, NULL, 'Branched-chain amino acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(65523, NULL, 'G3DSA:1.20.1280.290:FF:000074', NULL, NULL, 'YALI0D02046p', NULL, NULL, NULL, NULL, NULL, 4),
(65524, NULL, 'G3DSA:3.80.10.10:FF:001828', NULL, NULL, 'Reduced ocelli, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(65525, NULL, 'G3DSA:3.30.230.10:FF:000037', NULL, NULL, 'L-arabinokinase', NULL, NULL, NULL, NULL, NULL, 4),
(65526, NULL, 'G3DSA:3.30.230.130:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65527, NULL, 'G3DSA:1.10.287.70:FF:000113', NULL, NULL, 'Potassium voltage-gated channel subfamily KQT member 1', NULL, NULL, NULL, NULL, NULL, 4),
(65528, NULL, 'G3DSA:3.50.50.60:FF:000088', NULL, NULL, '3-phenylpropionate/cinnamic acid dioxygenase ferredoxin--NAD(+) reductase component', NULL, NULL, NULL, NULL, NULL, 4),
(65529, NULL, 'G3DSA:3.40.50.720:FF:002224', NULL, NULL, 'Glyoxylate/hydroxypyruvate reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65530, NULL, 'G3DSA:1.25.40.20:FF:001296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65531, NULL, 'G3DSA:3.40.50.720:FF:001948', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65532, NULL, 'G3DSA:1.10.533.10:FF:000236', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(65533, NULL, 'G3DSA:2.60.40.10:FF:002289', NULL, NULL, 'Protein sidekick homolog', NULL, NULL, NULL, NULL, NULL, 4),
(65534, NULL, 'G3DSA:3.30.70.330:FF:002916', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65535, NULL, 'G3DSA:3.40.190.10:FF:000194', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(65536, NULL, 'G3DSA:1.10.510.10:FF:000588', NULL, NULL, 'Calcium-dependent protein kinase 7', NULL, NULL, NULL, NULL, NULL, 4),
(65537, NULL, 'G3DSA:2.130.10.10:FF:004099', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(65538, NULL, 'G3DSA:2.60.40.10:FF:000973', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(65539, NULL, 'G3DSA:3.30.160.60:FF:003053', NULL, NULL, 'GM22706', NULL, NULL, NULL, NULL, NULL, 4),
(65540, NULL, 'G3DSA:3.30.2230.10:FF:000025', NULL, NULL, 'Ubiquitin specific peptidase 15', NULL, NULL, NULL, NULL, NULL, 4),
(65541, NULL, 'G3DSA:2.60.40.3330:FF:000001', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(65542, NULL, 'G3DSA:3.30.830.10:FF:000279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65543, NULL, 'G3DSA:3.30.160.60:FF:001024', NULL, NULL, 'Zinc finger and SCAN domain-containing protein 20', NULL, NULL, NULL, NULL, NULL, 4),
(65544, NULL, 'G3DSA:3.10.450.50:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65545, NULL, 'G3DSA:1.20.1250.20:FF:000640', NULL, NULL, 'Protein NUCLEAR FUSION DEFECTIVE 4', NULL, NULL, NULL, NULL, NULL, 4),
(65546, NULL, 'G3DSA:1.20.1070.10:FF:000090', NULL, NULL, 'Long-wave-sensitive opsin 1', NULL, NULL, NULL, NULL, NULL, 4),
(65547, NULL, 'G3DSA:1.25.10.10:FF:003056', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(65548, NULL, 'G3DSA:1.20.1730.10:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65549, NULL, 'G3DSA:3.30.160.60:FF:002738', NULL, NULL, 'ras-responsive element-binding protein 1 isoform X4', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(65550, NULL, 'G3DSA:2.120.10.30:FF:000536', NULL, NULL, 'Protein STRICTOSIDINE SYNTHASE-LIKE 11', NULL, NULL, NULL, NULL, NULL, 4),
(65551, NULL, 'G3DSA:1.10.510.10:FF:002729', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65552, NULL, 'G3DSA:2.10.110.10:FF:000290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65553, NULL, 'G3DSA:2.40.340.10:FF:000007', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(65554, NULL, 'G3DSA:3.30.2350.10:FF:000091', NULL, NULL, 'Zinc finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65555, NULL, 'G3DSA:2.40.128.80:FF:000001', NULL, NULL, 'Dipeptidyl peptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(65556, NULL, 'G3DSA:1.25.40.20:FF:001650', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65557, NULL, 'G3DSA:3.30.70.330:FF:000146', NULL, NULL, 'RNA-binding protein 47 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(65558, NULL, 'G3DSA:3.40.1190.20:FF:000140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65559, NULL, 'G3DSA:1.10.10.10:FF:001021', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(65560, NULL, 'G3DSA:3.30.160.60:FF:002890', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65561, NULL, 'G3DSA:1.20.1740.10:FF:000040', NULL, NULL, 'Solute carrier family 12 member 6', NULL, NULL, NULL, NULL, NULL, 4),
(65562, NULL, 'G3DSA:2.40.50.140:FF:000480', NULL, NULL, 'Single-stranded DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(65563, NULL, 'G3DSA:3.30.1550.10:FF:000015', NULL, NULL, '60S ribosomal protein L12, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65564, NULL, 'G3DSA:3.30.50.10:FF:000091', NULL, NULL, 'Peroxisome proliferator-activated receptor gamma', NULL, NULL, NULL, NULL, NULL, 4),
(65565, NULL, 'G3DSA:1.25.10.10:FF:001140', NULL, NULL, 'Protein CBG09896', NULL, NULL, NULL, NULL, NULL, 4),
(65566, NULL, 'G3DSA:2.60.40.60:FF:000398', NULL, NULL, 'Protocadherin cluster 1 gamma 26a', NULL, NULL, NULL, NULL, NULL, 4),
(65567, NULL, 'G3DSA:2.160.20.10:FF:000265', NULL, NULL, 'Pectinesterase 31', NULL, NULL, NULL, NULL, NULL, 4),
(65568, NULL, 'G3DSA:3.80.10.10:FF:000204', NULL, NULL, 'Scribbled, isoform O', NULL, NULL, NULL, NULL, NULL, 4),
(65569, NULL, 'G3DSA:1.20.140.150:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65570, NULL, 'G3DSA:1.10.1070.11:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65571, NULL, 'G3DSA:2.30.29.70:FF:000016', NULL, NULL, 'Protein CBG15320', NULL, NULL, NULL, NULL, NULL, 4),
(65572, NULL, 'G3DSA:3.40.50.300:FF:001474', NULL, NULL, 'Putative AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(65573, NULL, 'G3DSA:1.20.58.60:FF:000712', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65574, NULL, 'G3DSA:1.25.40.860:FF:000014', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(65575, NULL, 'G3DSA:3.40.1470.10:FF:000001', NULL, NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit beta 1', NULL, NULL, NULL, NULL, NULL, 4),
(65576, NULL, 'G3DSA:2.60.40.10:FF:003227', NULL, NULL, 'Novel immune-type receptor 9', NULL, NULL, NULL, NULL, NULL, 4),
(65577, NULL, 'G3DSA:1.25.40.10:FF:002389', NULL, NULL, 'Pentatricopeptide_repeat_domain/PPR_repeat /PPR_repeat_family_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(65578, NULL, 'G3DSA:2.30.42.10:FF:000456', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65579, NULL, 'G3DSA:3.30.519.10:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65580, NULL, 'G3DSA:3.10.290.70:FF:000001', NULL, NULL, '40S ribosomal protein S8', NULL, NULL, NULL, NULL, NULL, 4),
(65581, NULL, 'G3DSA:3.90.370.10:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65582, NULL, 'G3DSA:3.40.50.300:FF:000569', NULL, NULL, 'Rho-related GTP-binding protein Rho6', NULL, NULL, NULL, NULL, NULL, 4),
(65583, NULL, 'G3DSA:3.40.50.300:FF:001463', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(65584, NULL, 'G3DSA:2.130.10.10:FF:001406', NULL, NULL, 'Related to pyrimidine 5-nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(65585, NULL, 'G3DSA:3.40.50.12710:FF:000030', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7', NULL, NULL, NULL, NULL, NULL, 4),
(65586, NULL, 'G3DSA:3.10.580.10:FF:000101', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(65587, NULL, 'G3DSA:3.40.367.20:FF:000012', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(65588, NULL, 'G3DSA:2.10.110.10:FF:000233', NULL, NULL, 'LIM and PET domains protein', NULL, NULL, NULL, NULL, NULL, 4),
(65589, NULL, 'G3DSA:3.40.50.300:FF:004897', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(65590, NULL, 'G3DSA:3.30.40.10:FF:002349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65591, NULL, 'G3DSA:1.20.900.10:FF:000115', NULL, NULL, 'Phosphatidylinositol-3,4,5-trisphosphate-dependent Rac exchange factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(65592, NULL, 'G3DSA:3.40.50.80:FF:000009', NULL, NULL, 'NADH-cytochrome b5 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(65593, NULL, 'G3DSA:3.40.1390.20:FF:000003', NULL, NULL, 'HPr kinase/phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(65594, NULL, 'G3DSA:2.130.10.10:FF:000625', NULL, NULL, 'mRNA cleavage and polyadenylation factor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(65595, NULL, 'G3DSA:3.30.70.260:FF:000046', NULL, NULL, 'Protein MgtC', NULL, NULL, NULL, NULL, NULL, 4),
(65596, NULL, 'G3DSA:3.30.70.270:FF:000049', NULL, NULL, 'Gag-Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(65597, NULL, 'G3DSA:3.40.50.300:FF:003615', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65598, NULL, 'G3DSA:1.10.10.60:FF:000614', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65599, NULL, 'G3DSA:3.20.20.80:FF:000110', NULL, NULL, 'Alpha-L-arabinofuranosidase C', NULL, NULL, NULL, NULL, NULL, 4),
(65600, NULL, 'G3DSA:2.60.40.1760:FF:000007', NULL, NULL, 'Alpha-glucosidase yihQ', NULL, NULL, NULL, NULL, NULL, 4),
(65601, NULL, 'G3DSA:1.10.357.10:FF:000023', NULL, NULL, 'Coenzyme Q9', NULL, NULL, NULL, NULL, NULL, 4),
(65602, NULL, 'G3DSA:3.20.20.30:FF:000022', NULL, NULL, 'Possible oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(65603, NULL, 'G3DSA:1.50.10.20:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65604, NULL, 'G3DSA:3.30.450.30:FF:000060', NULL, NULL, 'Ragulator complex protein LAMTOR3', NULL, NULL, NULL, NULL, NULL, 4),
(65605, NULL, 'G3DSA:3.80.10.10:FF:001980', NULL, NULL, 'Si:ch211-256e16.11', NULL, NULL, NULL, NULL, NULL, 4),
(65606, NULL, 'G3DSA:3.40.50.1000:FF:000683', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65607, NULL, 'G3DSA:3.40.50.300:FF:000682', NULL, NULL, 'Dynein axonemal heavy chain 17', NULL, NULL, NULL, NULL, NULL, 4),
(65608, NULL, 'G3DSA:3.40.190.10:FF:000935', NULL, NULL, 'Glutamate receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65609, NULL, 'G3DSA:1.25.40.90:FF:000041', NULL, NULL, 'Regulator of Ty1 transposition', NULL, NULL, NULL, NULL, NULL, 4),
(65610, NULL, 'G3DSA:3.40.50.2000:FF:000802', NULL, NULL, 'Protein CBR-UGT-32', NULL, NULL, NULL, NULL, NULL, 4),
(65611, NULL, 'G3DSA:3.90.70.10:FF:000887', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65612, NULL, 'G3DSA:3.80.10.10:FF:000642', NULL, NULL, 'Leucine-rich receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(65613, NULL, 'G3DSA:1.25.10.10:FF:001701', NULL, NULL, 'Nipped-B protein', NULL, NULL, NULL, NULL, NULL, 4),
(65614, NULL, 'G3DSA:2.60.40.10:FF:002564', NULL, NULL, 'AGAP003610-PA', NULL, NULL, NULL, NULL, NULL, 4),
(65615, NULL, 'G3DSA:1.10.3110.10:FF:000006', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(65616, NULL, 'G3DSA:1.10.8.750:FF:000004', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(65617, NULL, 'G3DSA:2.120.10.30:FF:000148', NULL, NULL, 'Bll2172 protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(65618, NULL, 'G3DSA:3.100.10.20:FF:000002', NULL, NULL, 'CRISPR-associated endonuclease Cas1', NULL, NULL, NULL, NULL, NULL, 4),
(65619, NULL, 'G3DSA:3.30.465.10:FF:000110', NULL, NULL, 'Oxidoreductase, oxygen dependent, FAD-dependent protein', NULL, NULL, NULL, NULL, NULL, 4),
(65620, NULL, 'G3DSA:3.30.1680.10:FF:000019', NULL, NULL, 'Semaphorin 4A', NULL, NULL, NULL, NULL, NULL, 4),
(65621, NULL, 'G3DSA:1.25.40.10:FF:004805', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65622, NULL, 'G3DSA:3.40.50.300:FF:006488', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65623, NULL, 'G3DSA:3.40.50.300:FF:004279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65624, NULL, 'G3DSA:1.10.472.10:FF:000487', NULL, NULL, 'Cyclin, cyclin d, cell cycle control', NULL, NULL, NULL, NULL, NULL, 4),
(65625, NULL, 'G3DSA:1.20.1250.20:FF:000286', NULL, NULL, 'MFS efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(65626, NULL, 'G3DSA:3.30.160.60:FF:006487', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65627, NULL, 'G3DSA:2.60.220.50:FF:000028', NULL, NULL, 'Adhesion G protein-coupled receptor A2', NULL, NULL, NULL, NULL, NULL, 4),
(65628, NULL, 'G3DSA:1.50.10.10:FF:000120', NULL, NULL, 'Six-hairpin glycosidase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(65629, NULL, 'G3DSA:3.40.50.150:FF:000389', NULL, NULL, 'NOL1/NOP2/sun family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65630, NULL, 'G3DSA:3.40.50.360:FF:000160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65631, NULL, 'G3DSA:1.10.1380.10:FF:000025', NULL, NULL, 'Endothelin-converting enzyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(65632, NULL, 'G3DSA:1.10.8.740:FF:000001', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(65633, NULL, 'G3DSA:1.25.10.10:FF:002275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65634, NULL, 'G3DSA:1.10.8.60:FF:000124', NULL, NULL, 'Putative replication factor C3', NULL, NULL, NULL, NULL, NULL, 4),
(65635, NULL, 'G3DSA:1.10.600.10:FF:000027', NULL, NULL, 'GM22336', NULL, NULL, NULL, NULL, NULL, 4),
(65636, NULL, 'G3DSA:3.40.50.1220:FF:000046', NULL, NULL, 'Putative indole-3-pyruvate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(65637, NULL, 'G3DSA:1.10.10.440:FF:000067', NULL, NULL, 'Pre-mRNA processing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65638, NULL, 'G3DSA:3.30.40.10:FF:000904', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65639, NULL, 'G3DSA:3.20.20.100:FF:000007', NULL, NULL, 'NAD(P)H-dependent D-xylose reductase xyl1', NULL, NULL, NULL, NULL, NULL, 4),
(65640, NULL, 'G3DSA:3.40.850.10:FF:000110', NULL, NULL, 'Neither inactivation nor afterpotential protein C', NULL, NULL, NULL, NULL, NULL, 4),
(65641, NULL, 'G3DSA:3.30.1510.10:FF:000007', NULL, NULL, 'Formate--tetrahydrofolate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(65642, NULL, 'G3DSA:3.30.1330.40:FF:000070', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(65643, NULL, 'G3DSA:2.130.10.10:FF:002654', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65644, NULL, 'G3DSA:2.60.40.10:FF:005779', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65645, NULL, 'G3DSA:3.30.200.20:FF:001999', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65646, NULL, 'G3DSA:2.170.140.10:FF:000001', NULL, NULL, 'Acidic mammalian chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(65647, NULL, 'G3DSA:3.50.50.60:FF:000705', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(65648, NULL, 'G3DSA:3.30.300.160:FF:000013', NULL, NULL, 'Type II secretion system protein GspE', NULL, NULL, NULL, NULL, NULL, 4),
(65649, NULL, 'G3DSA:2.70.40.10:FF:000006', NULL, NULL, 'dCTP deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(65650, NULL, 'G3DSA:3.90.1860.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65651, NULL, 'G3DSA:3.30.300.180:FF:000019', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(65652, NULL, 'G3DSA:3.30.230.10:FF:000312', NULL, NULL, 'AGAP012568-PA', NULL, NULL, NULL, NULL, NULL, 4),
(65653, NULL, 'G3DSA:2.20.70.10:FF:000145', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(65654, NULL, 'G3DSA:1.25.10.10:FF:000684', NULL, NULL, 'Nucleolar protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(65655, NULL, 'G3DSA:1.20.1250.20:FF:001646', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(65656, NULL, 'G3DSA:3.40.50.2300:FF:001230', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65657, NULL, 'G3DSA:3.30.160.60:FF:005352', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65658, NULL, 'G3DSA:1.10.10.10:FF:001307', NULL, NULL, 'Putative HTH-type transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(65659, NULL, 'G3DSA:2.40.70.10:FF:000431', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65660, NULL, 'G3DSA:1.10.730.10:FF:000183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65661, NULL, 'G3DSA:3.90.1150.10:FF:000224', NULL, NULL, 'Glutamate-1-semialdehyde aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(65662, NULL, 'G3DSA:2.40.10.10:FF:000534', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65663, NULL, 'G3DSA:1.25.40.10:FF:000591', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65664, NULL, 'G3DSA:1.10.8.270:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65665, NULL, 'G3DSA:1.10.10.60:FF:000491', NULL, NULL, 'Imitation switch isoform alias nucleosome remodeling factor 140 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(65666, NULL, 'G3DSA:1.10.287.380:FF:000015', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(65667, NULL, 'G3DSA:1.10.357.150:FF:000008', NULL, NULL, 'Centromere/kinetochore protein zw10-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(65668, NULL, 'G3DSA:1.20.1540.10:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65669, NULL, 'G3DSA:3.40.50.300:FF:006763', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65670, NULL, 'G3DSA:2.10.50.30:FF:000004', NULL, NULL, 'Taste receptor type 1 member 3-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(65671, NULL, 'G3DSA:1.25.10.10:FF:002893', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65672, NULL, 'G3DSA:1.20.1050.10:FF:000088', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(65673, NULL, 'G3DSA:2.40.50.140:FF:000328', NULL, NULL, 'Proteasome regulatory ATPase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(65674, NULL, 'G3DSA:3.40.50.720:FF:001768', NULL, NULL, 'GDP-D-mannose dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(65675, NULL, 'G3DSA:1.10.8.240:FF:000003', NULL, NULL, 'LPPG domain protein containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(65676, NULL, 'G3DSA:3.40.50.150:FF:001283', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65677, NULL, 'G3DSA:3.40.30.10:FF:000937', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(65678, NULL, 'G3DSA:3.30.559.10:FF:000053', NULL, NULL, 'Nonribosomal peptide synthase GliP', NULL, NULL, NULL, NULL, NULL, 4),
(65679, NULL, 'G3DSA:3.20.70.20:FF:000022', NULL, NULL, 'Vitamin B12-dependent ribonucleotide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(65680, NULL, 'G3DSA:3.40.30.10:FF:000994', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65681, NULL, 'G3DSA:3.30.497.10:FF:000116', NULL, NULL, 'Serpin peptidase inhibitor 30', NULL, NULL, NULL, NULL, NULL, 4),
(65682, NULL, 'G3DSA:1.10.150.20:FF:000315', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65683, NULL, 'G3DSA:2.30.30.40:FF:000281', NULL, NULL, 'uncharacterized protein LOC108099255 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(65684, NULL, 'G3DSA:1.20.1560.10:FF:000054', NULL, NULL, 'ABC bile acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(65685, NULL, 'G3DSA:3.50.50.60:FF:000363', NULL, NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(65686, NULL, 'G3DSA:1.20.1250.20:FF:000022', NULL, NULL, 'Multidrug resistance protein MdtG', NULL, NULL, NULL, NULL, NULL, 4),
(65687, NULL, 'G3DSA:3.10.129.10:FF:000098', NULL, NULL, 'YER182W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(65688, NULL, 'G3DSA:3.40.1090.10:FF:000152', NULL, NULL, 'Phospholipase A2', NULL, NULL, NULL, NULL, NULL, 4),
(65689, NULL, 'G3DSA:1.20.5.1160:FF:000022', NULL, NULL, 'Lamin A', NULL, NULL, NULL, NULL, NULL, 4),
(65690, NULL, 'G3DSA:3.30.1360.230:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65691, NULL, 'G3DSA:2.60.40.1180:FF:000159', NULL, NULL, 'Alpha-L-fucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(65692, NULL, 'G3DSA:1.25.10.10:FF:002836', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(65693, NULL, 'G3DSA:3.30.160.60:FF:001642', NULL, NULL, 'Zinc finger protein 628', NULL, NULL, NULL, NULL, NULL, 4),
(65694, NULL, 'G3DSA:3.40.850.10:FF:000284', NULL, NULL, 'Kinesin family member 18A', NULL, NULL, NULL, NULL, NULL, 4),
(65695, NULL, 'G3DSA:2.10.25.10:FF:001727', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(65696, NULL, 'G3DSA:3.20.20.450:FF:000028', NULL, NULL, 'Cyclic diguanylate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(65697, NULL, 'G3DSA:1.20.58.2220:FF:000048', NULL, NULL, 'GH12052p', NULL, NULL, NULL, NULL, NULL, 4),
(65698, NULL, 'G3DSA:1.10.30.10:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65699, NULL, 'G3DSA:3.40.30.10:FF:001157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65700, NULL, 'G3DSA:3.40.30.10:FF:000589', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65701, NULL, 'G3DSA:3.30.1490.190:FF:000016', NULL, NULL, 'Ferric uptake regulation protein', NULL, NULL, NULL, NULL, NULL, 4),
(65702, NULL, 'G3DSA:3.40.50.20:FF:000065', NULL, NULL, 'UDP-2,3-diacylglucosamine pyrophosphatase LpxI', NULL, NULL, NULL, NULL, NULL, 4),
(65703, NULL, 'G3DSA:1.25.10.10:FF:000919', NULL, NULL, 'Protein CBR-TAG-184', NULL, NULL, NULL, NULL, NULL, 4),
(65704, NULL, 'G3DSA:2.40.10.10:FF:000539', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65705, NULL, 'G3DSA:2.30.42.10:FF:000400', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65706, NULL, 'G3DSA:2.40.30.30:FF:000018', NULL, NULL, 'Riboflavin biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(65707, NULL, 'G3DSA:3.40.50.1390:FF:000018', NULL, NULL, 'Recombinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(65708, NULL, 'G3DSA:1.10.238.10:FF:001062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65709, NULL, 'G3DSA:1.10.1070.11:FF:000082', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(65710, NULL, 'G3DSA:3.40.50.720:FF:000015', NULL, NULL, 'Ubiquitin-activating enzyme E1 1', NULL, NULL, NULL, NULL, NULL, 4),
(65711, NULL, 'G3DSA:3.80.10.10:FF:001654', NULL, NULL, 'Leucine-rich repeats and immunoglobulin-like domains 2', NULL, NULL, NULL, NULL, NULL, 4),
(65712, NULL, 'G3DSA:1.10.630.10:FF:000630', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65713, NULL, 'G3DSA:3.40.50.1380:FF:000015', NULL, NULL, 'Carbamoyl-phosphate synthase arginine-specific large chain', NULL, NULL, NULL, NULL, NULL, 4),
(65714, NULL, 'G3DSA:3.40.47.10:FF:000122', NULL, NULL, 'Nonspecific lipid-transfer protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65715, NULL, 'G3DSA:2.30.42.10:FF:000344', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(65716, NULL, 'G3DSA:3.40.630.10:FF:000296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65717, NULL, 'G3DSA:1.25.40.20:FF:000857', NULL, NULL, 'Kinase, NEK-like', NULL, NULL, NULL, NULL, NULL, 4),
(65718, NULL, 'G3DSA:1.10.472.10:FF:000482', NULL, NULL, 'Cyclin J-like', NULL, NULL, NULL, NULL, NULL, 4),
(65719, NULL, 'G3DSA:3.30.1490.180:FF:000013', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(65720, NULL, 'G3DSA:3.30.720.210:FF:000027', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(65721, NULL, 'G3DSA:3.30.230.120:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65722, NULL, 'G3DSA:1.10.150.60:FF:000030', NULL, NULL, 'Arid/bright domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(65723, NULL, 'G3DSA:1.10.510.10:FF:003230', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65724, NULL, 'G3DSA:1.10.357.140:FF:000005', NULL, NULL, 'UbiA prenyltransferase domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(65725, NULL, 'G3DSA:1.20.1070.10:FF:001882', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(65726, NULL, 'G3DSA:3.30.160.60:FF:004812', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65727, NULL, 'G3DSA:2.110.10.10:FF:000019', NULL, NULL, 'Matrix metallopeptidase 28', NULL, NULL, NULL, NULL, NULL, 4),
(65728, NULL, 'G3DSA:2.60.34.10:FF:000088', NULL, NULL, 'Os01g0688900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(65729, NULL, 'G3DSA:3.30.160.60:FF:004863', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65730, NULL, 'G3DSA:3.40.50.2300:FF:000409', NULL, NULL, 'Low molecular weight phosphotyrosine protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65731, NULL, 'G3DSA:1.10.1660.10:FF:000007', NULL, NULL, 'HTH-type transcriptional regulator MlrA', NULL, NULL, NULL, NULL, NULL, 4),
(65732, NULL, 'G3DSA:2.40.160.10:FF:000027', NULL, NULL, 'Mitochondrial import receptor subunit tom-40', NULL, NULL, NULL, NULL, NULL, 4),
(65733, NULL, 'G3DSA:3.10.129.110:FF:000012', NULL, NULL, 'PKS-NRPS hybrid synthetase psoA', NULL, NULL, NULL, NULL, NULL, 4),
(65734, NULL, 'G3DSA:3.30.70.330:FF:001894', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65735, NULL, 'G3DSA:3.10.110.10:FF:000134', NULL, NULL, 'Baculoviral IAP repeat-containing 6', NULL, NULL, NULL, NULL, NULL, 4),
(65736, NULL, 'G3DSA:3.30.160.60:FF:001086', NULL, NULL, 'zinc finger and BTB domain-containing protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(65737, NULL, 'G3DSA:1.25.40.10:FF:000854', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(65738, NULL, 'G3DSA:1.20.1280.290:FF:000012', NULL, NULL, 'Vacuolar membrane PQ loop repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(65739, NULL, 'G3DSA:1.10.510.10:FF:002229', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65740, NULL, 'G3DSA:3.40.50.300:FF:004633', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(65741, NULL, 'G3DSA:1.10.600.10:FF:000061', NULL, NULL, 'Probable phytoene synthase', NULL, NULL, NULL, NULL, NULL, 4),
(65742, NULL, 'G3DSA:3.40.50.12670:FF:000001', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(65743, NULL, 'G3DSA:3.40.1090.10:FF:000039', NULL, NULL, 'Patatin', NULL, NULL, NULL, NULL, NULL, 4),
(65744, NULL, 'G3DSA:3.30.40.10:FF:001916', NULL, NULL, 'Peroxisome assembly protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65745, NULL, 'G3DSA:1.10.3460.10:FF:000026', NULL, NULL, 'Chlorophyll a-b binding protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(65746, NULL, 'G3DSA:1.25.40.10:FF:002945', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65747, NULL, 'G3DSA:3.30.590.10:FF:000007', NULL, NULL, 'Protein-arginine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(65748, NULL, 'G3DSA:3.60.20.10:FF:000071', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(65749, NULL, 'G3DSA:1.10.8.270:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65750, NULL, 'G3DSA:3.40.50.300:FF:003054', NULL, NULL, 'GTP-binding protein RAD', NULL, NULL, NULL, NULL, NULL, 4),
(65751, NULL, 'G3DSA:2.70.98.10:FF:000061', NULL, NULL, 'Alpha-1,2-mannosidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(65752, NULL, 'G3DSA:2.120.10.30:FF:000362', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(65753, NULL, 'G3DSA:3.40.33.10:FF:000101', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(65754, NULL, 'G3DSA:3.30.930.10:FF:000040', NULL, NULL, 'Asparagine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(65755, NULL, 'G3DSA:1.10.510.10:FF:002555', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65756, NULL, 'G3DSA:3.40.50.12370:FF:000006', NULL, NULL, 'Cation/H(+) antiporter 28', NULL, NULL, NULL, NULL, NULL, 4),
(65757, NULL, 'G3DSA:1.10.472.10:FF:000431', NULL, NULL, 'Cyclin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(65758, NULL, 'G3DSA:1.25.40.690:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65759, NULL, 'G3DSA:2.60.40.10:FF:004363', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65760, NULL, 'G3DSA:2.40.50.140:FF:000654', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(65761, NULL, 'G3DSA:1.20.1510.10:FF:000017', NULL, NULL, 'zinc transporter 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(65762, NULL, 'G3DSA:3.30.70.330:FF:001568', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65763, NULL, 'G3DSA:3.40.190.290:FF:000039', NULL, NULL, 'Iron-regulated virulence regulatory protein IrgB', NULL, NULL, NULL, NULL, NULL, 4),
(65764, NULL, 'G3DSA:1.20.1250.20:FF:000522', NULL, NULL, 'Chloramphenicol resistance protein DHA1', NULL, NULL, NULL, NULL, NULL, 4),
(65765, NULL, 'G3DSA:3.40.850.10:FF:000514', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(65766, NULL, 'G3DSA:3.40.630.10:FF:000245', NULL, NULL, 'Amidohydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(65767, NULL, 'G3DSA:1.10.472.80:FF:000013', NULL, NULL, 'TBC1 domain family member 8B', NULL, NULL, NULL, NULL, NULL, 4),
(65768, NULL, 'G3DSA:2.40.50.140:FF:000710', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65769, NULL, 'G3DSA:3.20.10.10:FF:000021', NULL, NULL, 'Unplaced genomic scaffold supercont1.114, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(65770, NULL, 'G3DSA:2.40.50.100:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65771, NULL, 'G3DSA:3.40.309.10:FF:000009', NULL, NULL, 'Aldehyde dehydrogenase A', NULL, NULL, NULL, NULL, NULL, 4),
(65772, NULL, 'G3DSA:1.25.10.10:FF:003000', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65773, NULL, 'G3DSA:3.80.10.10:FF:003745', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(65774, NULL, 'G3DSA:3.30.420.40:FF:001022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65775, NULL, 'G3DSA:3.40.50.720:FF:002106', NULL, NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(65776, NULL, 'G3DSA:3.40.50.20:FF:000014', NULL, NULL, 'beta-citrylglutamate synthase B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(65777, NULL, 'G3DSA:1.10.510.10:FF:002499', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65778, NULL, 'G3DSA:1.20.120.980:FF:000019', NULL, NULL, 'Protein CBG01710', NULL, NULL, NULL, NULL, NULL, 4),
(65779, NULL, 'G3DSA:3.80.10.10:FF:001547', NULL, NULL, 'NLR family CARD domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(65780, NULL, 'G3DSA:3.40.190.10:FF:000374', NULL, NULL, 'Osmoprotectant transport system substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(65781, NULL, 'G3DSA:1.20.1310.10:FF:000069', NULL, NULL, 'Cul3p', NULL, NULL, NULL, NULL, NULL, 4),
(65782, NULL, 'G3DSA:1.10.10.10:FF:000291', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(65783, NULL, 'G3DSA:3.90.190.10:FF:000351', NULL, NULL, 'Putative dual-specificity protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(65784, NULL, 'G3DSA:3.30.40.10:FF:000500', NULL, NULL, 'SNF2 family domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(65785, NULL, 'G3DSA:1.20.1560.10:FF:000003', NULL, NULL, 'ABC transporter C family member 10', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(65786, NULL, 'G3DSA:1.20.1280.20:FF:000024', NULL, NULL, 'J-type co-chaperone jac1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(65787, NULL, 'G3DSA:3.30.160.60:FF:001142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65788, NULL, 'G3DSA:1.10.220.30:FF:000026', NULL, NULL, 'Type III secretion system protein', NULL, NULL, NULL, NULL, NULL, 4),
(65789, NULL, 'G3DSA:1.10.3890.10:FF:000002', NULL, NULL, 'High frequency lysogenization protein HflD homolog', NULL, NULL, NULL, NULL, NULL, 4),
(65790, NULL, 'G3DSA:3.40.47.10:FF:000066', NULL, NULL, 'Fatty acid synthase subunit alpha, fungi type', NULL, NULL, NULL, NULL, NULL, 4),
(65791, NULL, 'G3DSA:3.40.50.970:FF:000129', NULL, NULL, 'Transketolase', NULL, NULL, NULL, NULL, NULL, 4),
(65792, NULL, 'G3DSA:3.30.160.60:FF:000529', NULL, NULL, 'Zinc finger with KRAB and SCAN domains 8', NULL, NULL, NULL, NULL, NULL, 4),
(65793, NULL, 'G3DSA:1.10.3970.10:FF:000003', NULL, NULL, 'Dos2p', NULL, NULL, NULL, NULL, NULL, 4),
(65794, NULL, 'G3DSA:3.30.70.270:FF:000280', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65795, NULL, 'G3DSA:3.40.50.300:FF:002486', NULL, NULL, 'DNA repair protein (Rad57), putative', NULL, NULL, NULL, NULL, NULL, 4),
(65796, NULL, 'G3DSA:3.40.50.300:FF:006757', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65797, NULL, 'G3DSA:1.20.1740.10:FF:000101', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(65798, NULL, 'G3DSA:3.40.50.2300:FF:000561', NULL, NULL, 'Protein argonaute 2', NULL, NULL, NULL, NULL, NULL, 4),
(65799, NULL, 'G3DSA:2.170.150.10:FF:000007', NULL, NULL, 'Putative IgE-dependent histamine-releasing factor', NULL, NULL, NULL, NULL, NULL, 4),
(65800, NULL, 'G3DSA:4.10.280.110:FF:000001', NULL, NULL, 'pre-mRNA-splicing factor 18 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(65801, NULL, 'G3DSA:3.40.50.2000:FF:000533', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(65802, NULL, 'G3DSA:1.20.1050.10:FF:000026', NULL, NULL, 'Methionine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(65803, NULL, 'G3DSA:3.40.50.300:FF:004577', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(65804, NULL, 'G3DSA:3.30.46.10:FF:000002', NULL, NULL, 'Glycine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(65805, NULL, 'G3DSA:3.30.70.330:FF:000264', NULL, NULL, 'nucleolin', NULL, NULL, NULL, NULL, NULL, 4),
(65806, NULL, 'G3DSA:2.30.30.30:FF:000159', NULL, NULL, 'Global transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(65807, NULL, 'G3DSA:3.30.230.10:FF:000363', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65808, NULL, 'G3DSA:3.30.40.10:FF:001809', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(65809, NULL, 'G3DSA:1.20.58.1040:FF:000003', NULL, NULL, 'glucan endo-1,3-beta-glucosidase 7', NULL, NULL, NULL, NULL, NULL, 4),
(65810, NULL, 'G3DSA:2.60.120.200:FF:000074', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(65811, NULL, 'G3DSA:1.25.10.10:FF:002269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65812, NULL, 'G3DSA:3.30.200.20:FF:000864', NULL, NULL, 'Raf homolog serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(65813, NULL, 'G3DSA:3.30.200.20:FF:000920', NULL, NULL, 'Os12g0432000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(65814, NULL, 'G3DSA:3.10.100.10:FF:000364', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65815, NULL, 'G3DSA:1.10.3720.10:FF:000069', NULL, NULL, 'Iron ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(65816, NULL, 'G3DSA:3.10.310.10:FF:000059', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(65817, NULL, 'G3DSA:1.20.1070.10:FF:000207', NULL, NULL, 'Probable G-protein coupled receptor 149', NULL, NULL, NULL, NULL, NULL, 4),
(65818, NULL, 'G3DSA:2.40.70.10:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65819, NULL, 'G3DSA:3.10.260.20:FF:000001', NULL, NULL, 'Dachshund homolog 1', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(65820, NULL, 'G3DSA:1.20.1560.10:FF:000110', NULL, NULL, 'Multidrug ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(65821, NULL, 'G3DSA:3.30.390.50:FF:000009', NULL, NULL, 'Lipoate-protein ligase A', NULL, NULL, NULL, NULL, NULL, 4),
(65822, NULL, 'G3DSA:3.30.70.330:FF:002355', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65823, NULL, 'G3DSA:2.60.40.10:FF:000759', NULL, NULL, 'Immunoglobulin superfamily DCC subclass member 4', NULL, NULL, NULL, NULL, NULL, 4),
(65824, NULL, 'G3DSA:3.40.50.1000:FF:000391', NULL, NULL, 'Nuclear LIM interactor-interacting factor 3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65825, NULL, 'G3DSA:3.40.50.1240:FF:000108', NULL, NULL, 'Histidine phosphatase superfamily (Branch 1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(65826, NULL, 'G3DSA:3.30.50.10:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65827, NULL, 'G3DSA:3.40.50.1820:FF:001766', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65828, NULL, 'G3DSA:2.60.200.20:FF:000198', NULL, NULL, 'DUF2662 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(65829, NULL, 'G3DSA:2.60.40.3980:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65830, NULL, 'G3DSA:3.20.20.80:FF:000172', NULL, NULL, 'Chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(65831, NULL, 'G3DSA:2.60.40.10:FF:003014', NULL, NULL, 'Immunoglobulin lambda variable 3-22', NULL, NULL, NULL, NULL, NULL, 4),
(65832, NULL, 'G3DSA:3.50.50.60:FF:000037', NULL, NULL, 'Dihydrolipoyl dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(65833, NULL, 'G3DSA:3.40.50.2000:FF:000207', NULL, NULL, 'Phosphatidyl-myo-inositol mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(65834, NULL, 'G3DSA:3.30.1330.60:FF:000014', NULL, NULL, 'Flagellar motor protein MotB', NULL, NULL, NULL, NULL, NULL, 4),
(65835, NULL, 'G3DSA:3.10.20.90:FF:000597', NULL, NULL, 'MGC80376 protein', NULL, NULL, NULL, NULL, NULL, 4),
(65836, NULL, 'G3DSA:3.30.160.60:FF:001193', NULL, NULL, 'Zinc finger protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(65837, NULL, 'G3DSA:1.20.1070.10:FF:001837', NULL, NULL, 'Putative neuropeptide receptor', NULL, NULL, NULL, NULL, NULL, 4),
(65838, NULL, 'G3DSA:1.10.287.130:FF:000137', NULL, NULL, 'Sensor histidine kinase YbdK', NULL, NULL, NULL, NULL, NULL, 4),
(65839, NULL, 'G3DSA:2.170.300.10:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65840, NULL, 'G3DSA:3.40.250.10:FF:000204', NULL, NULL, 'YALI0F24585p', NULL, NULL, NULL, NULL, NULL, 4),
(65841, NULL, 'G3DSA:3.40.50.1820:FF:000136', NULL, NULL, 'Pheophytinase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(65842, NULL, 'G3DSA:1.10.1540.10:FF:000004', NULL, NULL, 'Neutral sphingomyelinase (N-SMase) activation-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(65843, NULL, 'G3DSA:1.10.510.10:FF:004472', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65844, NULL, 'G3DSA:3.40.50.11030:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65845, NULL, 'G3DSA:3.40.50.1820:FF:001822', NULL, NULL, 'Protein phosphatase methylesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(65846, NULL, 'G3DSA:3.40.50.150:FF:000384', NULL, NULL, 'Protein arginine methyltransferase 9', NULL, NULL, NULL, NULL, NULL, 4),
(65847, NULL, 'G3DSA:3.30.1340.30:FF:000011', NULL, NULL, 'Type III export protein PscD', NULL, NULL, NULL, NULL, NULL, 4),
(65848, NULL, 'G3DSA:3.30.300.20:FF:000012', NULL, NULL, 'Ribosome-binding factor A', NULL, NULL, NULL, NULL, NULL, 4),
(65849, NULL, 'G3DSA:2.40.50.140:FF:000980', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65850, NULL, 'G3DSA:1.10.630.10:FF:000411', NULL, NULL, 'LOC100145642 protein', NULL, NULL, NULL, NULL, NULL, 4),
(65851, NULL, 'G3DSA:1.20.1070.10:FF:001556', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(65852, NULL, 'G3DSA:1.10.510.10:FF:002448', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65853, NULL, 'G3DSA:1.20.1250.20:FF:001938', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(65854, NULL, 'G3DSA:2.60.40.790:FF:000067', NULL, NULL, 'Tudor domain-containing 12', NULL, NULL, NULL, NULL, NULL, 4),
(65855, NULL, 'G3DSA:3.30.40.110:FF:000001', NULL, NULL, 'Type III effector hopAB3', NULL, NULL, NULL, NULL, NULL, 4),
(65856, NULL, 'G3DSA:1.10.340.30:FF:000024', NULL, NULL, 'DNA-3-methyladenine glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(65857, NULL, 'G3DSA:3.90.70.80:FF:000020', NULL, NULL, 'OTU-like cysteine protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65858, NULL, 'G3DSA:1.20.1080.10:FF:000073', NULL, NULL, 'Aquaporin 5', NULL, NULL, NULL, NULL, NULL, 4),
(65859, NULL, 'G3DSA:3.30.300.30:FF:000015', NULL, NULL, 'Nonribosomal peptide synthase SidD', NULL, NULL, NULL, NULL, NULL, 4),
(65860, NULL, 'G3DSA:3.40.630.10:FF:000189', NULL, NULL, 'Cytosolic non-specific dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(65861, NULL, 'G3DSA:2.130.10.10:FF:002828', NULL, NULL, 'Anaphase-promoting complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(65862, NULL, 'G3DSA:1.25.40.20:FF:001532', NULL, NULL, 'Kinase, NEK-frag', NULL, NULL, NULL, NULL, NULL, 4),
(65863, NULL, 'G3DSA:3.80.10.10:FF:004453', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65864, NULL, 'G3DSA:3.30.50.10:FF:000107', NULL, NULL, 'GATA transcription factor 29', NULL, NULL, NULL, NULL, NULL, 4),
(65865, NULL, 'G3DSA:3.30.565.10:FF:000376', NULL, NULL, 'Hybrid sensory kinase', NULL, NULL, NULL, NULL, NULL, 4),
(65866, NULL, 'G3DSA:2.60.120.200:FF:000135', NULL, NULL, 'Related to KRE6-glucan synthase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(65867, NULL, 'G3DSA:3.40.50.10440:FF:000001', NULL, NULL, 'Dihydroxyacetone kinase, DhaK subunit', NULL, NULL, NULL, NULL, NULL, 4),
(65868, NULL, 'G3DSA:1.10.287.70:FF:000613', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65869, NULL, 'G3DSA:1.20.5.170:FF:000047', NULL, NULL, 'male-specific lethal 1 homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(65870, NULL, 'G3DSA:3.10.50.10:FF:000007', NULL, NULL, 'chitinase-like protein Idgf4', NULL, NULL, NULL, NULL, NULL, 4),
(65871, NULL, 'G3DSA:3.40.50.720:FF:000190', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(65872, NULL, 'G3DSA:3.30.160.60:FF:000299', NULL, NULL, 'Zinc finger protein 593', NULL, NULL, NULL, NULL, NULL, 4),
(65873, NULL, 'G3DSA:2.30.230.10:FF:000013', NULL, NULL, 'Hemelipoglyco-carrier protein CP3', NULL, NULL, NULL, NULL, NULL, 4),
(65874, NULL, 'G3DSA:3.60.15.10:FF:000272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65875, NULL, 'G3DSA:2.60.120.260:FF:000631', NULL, NULL, 'Similar to c-type cytochrome', NULL, NULL, NULL, NULL, NULL, 4),
(65876, NULL, 'G3DSA:3.90.550.10:FF:000278', NULL, NULL, 'Alpha-1,6-mannosyl-glycoprotein beta-1,2-N-acetylglucosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(65877, NULL, 'G3DSA:3.60.20.10:FF:000020', NULL, NULL, 'Proteasome subunit alpha type', NULL, NULL, NULL, NULL, NULL, 4),
(65878, NULL, 'G3DSA:3.40.50.300:FF:007213', NULL, NULL, 'ADP ribosylation factor like GTPase 3', NULL, NULL, NULL, NULL, NULL, 4),
(65879, NULL, 'G3DSA:3.40.190.10:FF:000486', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(65880, NULL, 'G3DSA:2.160.20.10:FF:000203', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(65881, NULL, 'G3DSA:2.70.130.10:FF:000159', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65882, NULL, 'G3DSA:3.40.190.10:FF:000430', NULL, NULL, 'Sensor domain-containing diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(65883, NULL, 'G3DSA:2.130.10.30:FF:000007', NULL, NULL, 'E3 ubiquitin-protein ligase UBR5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(65884, NULL, 'G3DSA:3.30.40.10:FF:000612', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65885, NULL, 'G3DSA:1.25.40.10:FF:001315', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(65886, NULL, 'G3DSA:4.10.530.10:FF:000004', NULL, NULL, 'Fibrinogen beta chain', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(65887, NULL, 'G3DSA:3.40.50.1220:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65888, NULL, 'G3DSA:3.30.160.20:FF:000135', NULL, NULL, 'Double-stranded RNA-specific editase Adar-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(65889, NULL, 'G3DSA:3.80.10.10:FF:001328', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase PEPR1', NULL, NULL, NULL, NULL, NULL, 4),
(65890, NULL, 'G3DSA:2.130.10.10:FF:000737', NULL, NULL, 'Elongator complex protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(65891, NULL, 'G3DSA:2.30.29.30:FF:000999', NULL, NULL, 'EAP30/Vps36 family-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(65892, NULL, 'G3DSA:3.10.290.20:FF:000003', NULL, NULL, 'Ubiquitin-activating enzyme E1 C', NULL, NULL, NULL, NULL, NULL, 4),
(65893, NULL, 'G3DSA:1.20.120.1240:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65894, NULL, 'G3DSA:3.80.10.10:FF:001598', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(65895, NULL, 'G3DSA:3.40.1410.10:FF:000014', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(65896, NULL, 'G3DSA:1.20.1440.180:FF:000016', NULL, NULL, 'Serine/threonine-protein kinase/endoribonuclease IRE1a', NULL, NULL, NULL, NULL, NULL, 4),
(65897, NULL, 'G3DSA:2.60.120.650:FF:000186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65898, NULL, 'G3DSA:1.10.1520.10:FF:000121', NULL, NULL, 'Dicer-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(65899, NULL, 'G3DSA:1.10.760.10:FF:000016', NULL, NULL, 'Cytochrome c4', NULL, NULL, NULL, NULL, NULL, 4),
(65900, NULL, 'G3DSA:3.40.366.10:FF:000041', NULL, NULL, 'Putative acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(65901, NULL, 'G3DSA:3.10.110.10:FF:000078', NULL, NULL, 'ubiquitin-conjugating enzyme E2 H isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(65902, NULL, 'G3DSA:3.20.20.80:FF:000402', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(65903, NULL, 'G3DSA:3.30.870.10:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65904, NULL, 'G3DSA:2.170.120.20:FF:000008', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(65905, NULL, 'G3DSA:2.60.40.60:FF:000634', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65906, NULL, 'G3DSA:1.25.40.20:FF:001318', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65907, NULL, 'G3DSA:3.30.720.10:FF:000007', NULL, NULL, 'Signal recognition particle subunit SRP14', NULL, NULL, NULL, NULL, NULL, 4),
(65908, NULL, 'G3DSA:3.60.20.30:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65909, NULL, 'G3DSA:2.120.10.30:FF:000474', NULL, NULL, 'Low density lipoprotein receptor', NULL, NULL, NULL, NULL, NULL, 4),
(65910, NULL, 'G3DSA:2.30.30.30:FF:000047', NULL, NULL, '60S ribosomal protein L2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(65911, NULL, 'G3DSA:3.40.50.1820:FF:001266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65912, NULL, 'G3DSA:1.10.10.60:FF:000726', NULL, NULL, 'Oocyte-specific homeobox 3', NULL, NULL, NULL, NULL, NULL, 4),
(65913, NULL, 'G3DSA:3.40.50.300:FF:002716', NULL, NULL, 'Elongation factor G2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(65914, NULL, 'G3DSA:3.90.220.20:FF:000003', NULL, NULL, 'Type I restriction-modification system, S subunit', NULL, NULL, NULL, NULL, NULL, 4),
(65915, NULL, 'G3DSA:3.30.56.10:FF:000008', NULL, NULL, 'Phenylalanyl-tRNA synthetase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(65916, NULL, 'G3DSA:3.30.70.270:FF:000105', NULL, NULL, 'Polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(65917, NULL, 'G3DSA:2.60.40.60:FF:000639', NULL, NULL, 'AGAP002828-PA', NULL, NULL, NULL, NULL, NULL, 4),
(65918, NULL, 'G3DSA:1.20.5.320:FF:000025', NULL, NULL, 'COL1A1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(65919, NULL, 'G3DSA:2.130.10.10:FF:004397', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(65920, NULL, 'G3DSA:3.30.428.10:FF:000075', NULL, NULL, 'Hit family protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(65921, NULL, 'G3DSA:3.80.10.10:FF:004234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65922, NULL, 'G3DSA:3.40.50.1820:FF:000462', NULL, NULL, 'S-formylglutathione hydrolase FrmB', NULL, NULL, NULL, NULL, NULL, 4),
(65923, NULL, 'G3DSA:1.10.510.10:FF:002774', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65924, NULL, 'G3DSA:3.30.70.260:FF:000102', NULL, NULL, 'Glycine cleavage system transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(65925, NULL, 'G3DSA:1.20.1070.10:FF:000533', NULL, NULL, 'MAS1 proto-oncogene-like, G protein-coupled receptor', NULL, NULL, NULL, NULL, NULL, 4),
(65926, NULL, 'G3DSA:2.30.230.10:FF:000018', NULL, NULL, 'Apolipoprotein B-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(65927, NULL, 'G3DSA:3.40.190.10:FF:000435', NULL, NULL, 'Peptide ABC transporter, periplasmic peptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(65928, NULL, 'G3DSA:1.25.40.20:FF:001313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65929, NULL, 'G3DSA:1.10.10.60:FF:000496', NULL, NULL, 'GL13020', NULL, NULL, NULL, NULL, NULL, 4),
(65930, NULL, 'G3DSA:2.120.10.30:FF:000087', NULL, NULL, 'Megalin, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(65931, NULL, 'G3DSA:3.40.50.11260:FF:000011', NULL, NULL, 'Cation-transporting ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65932, NULL, 'G3DSA:1.20.58.60:FF:000414', NULL, NULL, 'AGAP009554-PA', NULL, NULL, NULL, NULL, NULL, 4),
(65933, NULL, 'G3DSA:3.60.70.12:FF:000008', NULL, NULL, 'S58 family peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(65934, NULL, 'G3DSA:1.20.930.20:FF:000007', NULL, NULL, 'Cbl proto-oncogene C, E3 ubiquitin protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(65935, NULL, 'G3DSA:3.40.50.150:FF:001171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65936, NULL, 'G3DSA:1.10.510.10:FF:003342', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65937, NULL, 'G3DSA:3.30.1490.20:FF:000013', NULL, NULL, 'Formate-dependent phosphoribosylglycinamide formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(65938, NULL, 'G3DSA:1.20.1560.10:FF:000059', NULL, NULL, 'ABC transporter B family member 26, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(65939, NULL, 'G3DSA:1.10.287.70:FF:000057', NULL, NULL, 'Potassium channel subfamily K member', NULL, NULL, NULL, NULL, NULL, 4),
(65940, NULL, 'G3DSA:2.60.120.740:FF:000005', NULL, NULL, 'polycystic kidney disease protein 1-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(65941, NULL, 'G3DSA:3.40.50.2300:FF:000235', NULL, NULL, 'Probable nik-1 protein (Os-1p protein)', NULL, NULL, NULL, NULL, NULL, 4),
(65942, NULL, 'G3DSA:1.10.238.10:FF:000724', NULL, NULL, 'Probable calcium-binding protein CML34', NULL, NULL, NULL, NULL, NULL, 4),
(65943, NULL, 'G3DSA:1.20.20.10:FF:000032', NULL, NULL, 'ATP synthase subunit 9, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(65944, NULL, 'G3DSA:3.30.70.1530:FF:000001', NULL, NULL, 'Lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(65945, NULL, 'G3DSA:1.25.40.10:FF:002097', NULL, NULL, 'Pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(65946, NULL, 'G3DSA:2.10.25.10:FF:000209', NULL, NULL, 'Laminin subunit alpha 5', NULL, NULL, NULL, NULL, NULL, 4),
(65947, NULL, 'G3DSA:3.40.50.620:FF:000159', NULL, NULL, 'Putative receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(65948, NULL, 'G3DSA:3.40.630.150:FF:000020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(65949, NULL, 'G3DSA:3.30.40.10:FF:000225', NULL, NULL, 'Death-inducer obliterator 1', NULL, NULL, NULL, NULL, NULL, 4),
(65950, NULL, 'G3DSA:3.80.10.10:FF:003964', NULL, NULL, 'Si:dkey-31n13.4', NULL, NULL, NULL, NULL, NULL, 4),
(65951, NULL, 'G3DSA:3.40.190.10:FF:000379', NULL, NULL, 'D-methionine-binding lipoprotein MetQ', NULL, NULL, NULL, NULL, NULL, 4),
(65952, NULL, 'G3DSA:2.40.70.10:FF:000195', NULL, NULL, 'Aspartic peptidase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(65953, NULL, 'G3DSA:2.60.40.10:FF:003340', NULL, NULL, 'Mast/stem cell growth factor receptor kita', NULL, NULL, NULL, NULL, NULL, 4),
(65954, NULL, 'G3DSA:3.90.1750.20:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65955, NULL, 'G3DSA:2.40.50.90:FF:000015', NULL, NULL, 'Ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(65956, NULL, 'G3DSA:3.40.50.1820:FF:000810', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(65957, NULL, 'G3DSA:2.60.120.730:FF:000002', NULL, NULL, 'Major capsid protein P2', NULL, NULL, NULL, NULL, NULL, 4),
(65958, NULL, 'G3DSA:3.60.110.10:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(65959, NULL, 'G3DSA:3.40.50.300:FF:001137', NULL, NULL, 'DEAD/DEAH box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(65960, NULL, 'G3DSA:2.130.10.10:FF:004453', NULL, NULL, 'Ribosome biogenesis protein WDR12 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(65961, NULL, 'G3DSA:3.40.30.10:FF:000819', NULL, NULL, 'Glutathione S-Transferase', NULL, NULL, NULL, NULL, NULL, 4),
(65962, NULL, 'G3DSA:3.40.50.1010:FF:000101', NULL, NULL, 'Exonuclease I, putative', NULL, NULL, NULL, NULL, NULL, 4),
(65963, NULL, 'G3DSA:2.170.140.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65964, NULL, 'G3DSA:3.40.50.150:FF:000951', NULL, NULL, 'Small RNA 2''-O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(65965, NULL, 'G3DSA:1.25.10.10:FF:002595', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65966, NULL, 'G3DSA:2.90.10.10:FF:000009', NULL, NULL, 'Receptor-like serine/threonine-protein kinase SD1-8', NULL, NULL, NULL, NULL, NULL, 4),
(65967, NULL, 'G3DSA:2.20.70.10:FF:000027', NULL, NULL, 'pleckstrin homology domain-containing family A member 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(65968, NULL, 'G3DSA:3.90.1110.10:FF:000008', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(65969, NULL, 'G3DSA:3.30.559.30:FF:000093', NULL, NULL, 'Enniatin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(65970, NULL, 'G3DSA:3.30.40.10:FF:001686', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(65971, NULL, 'G3DSA:2.60.120.260:FF:000338', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65972, NULL, 'G3DSA:1.10.287.110:FF:000098', NULL, NULL, 'Chaperone protein dnaJ 20, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(65973, NULL, 'G3DSA:1.10.510.10:FF:001543', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 41', NULL, NULL, NULL, NULL, NULL, 4),
(65974, NULL, 'G3DSA:3.30.200.20:FF:002337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65975, NULL, 'G3DSA:3.80.10.10:FF:002441', NULL, NULL, 'Leucine-rich repeat protein (LRRP)', NULL, NULL, NULL, NULL, NULL, 4),
(65976, NULL, 'G3DSA:3.30.70.330:FF:000438', NULL, NULL, 'RNA-binding motif protein 15B', NULL, NULL, NULL, NULL, NULL, 4),
(65977, NULL, 'G3DSA:2.30.29.30:FF:000151', NULL, NULL, 'Rho guanine nucleotide exchange factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(65978, NULL, 'G3DSA:3.30.450.40:FF:000068', NULL, NULL, 'Diguanylate cyclase (GGDEF) domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(65979, NULL, 'G3DSA:3.30.360.10:FF:000075', NULL, NULL, 'Aspartate-semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(65980, NULL, 'G3DSA:3.30.420.40:FF:000566', NULL, NULL, 'Actin 12', NULL, NULL, NULL, NULL, NULL, 4),
(65981, NULL, 'G3DSA:3.30.160.60:FF:002446', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65982, NULL, 'G3DSA:3.40.50.300:FF:001182', NULL, NULL, 'DExH-box ATP-dependent RNA helicase DExH15 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(65983, NULL, 'G3DSA:3.30.450.30:FF:000065', NULL, NULL, 'Profilin', NULL, NULL, NULL, NULL, NULL, 4),
(65984, NULL, 'G3DSA:3.90.1150.10:FF:000336', NULL, NULL, 'Capreomycidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(65985, NULL, 'G3DSA:2.160.20.10:FF:000080', NULL, NULL, 'F-box protein 11a', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(65986, NULL, 'G3DSA:1.10.510.10:FF:001195', NULL, NULL, 'VRK serine/threonine kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(65987, NULL, 'G3DSA:2.60.110.10:FF:000031', NULL, NULL, 'Os10g0147200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(65988, NULL, 'G3DSA:1.20.1110.10:FF:000088', NULL, NULL, 'Plasma membrane ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(65989, NULL, 'G3DSA:2.60.40.10:FF:001541', NULL, NULL, 'Glycoside hydrolase family 2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(65990, NULL, 'G3DSA:3.80.10.10:FF:002036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(65991, NULL, 'G3DSA:3.30.1330.50:FF:000011', NULL, NULL, 'Uncharacterized protein MG459', NULL, NULL, NULL, NULL, NULL, 4),
(65992, NULL, 'G3DSA:3.30.450.20:FF:000062', NULL, NULL, 'Diguanylate cyclase (GGDEF) domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(65993, NULL, 'G3DSA:2.60.40.10:FF:002446', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(65994, NULL, 'G3DSA:3.40.50.11660:FF:000029', NULL, NULL, 'Alpha 1,3 fucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(65995, NULL, 'G3DSA:3.90.70.10:FF:000387', NULL, NULL, 'GM22024', NULL, NULL, NULL, NULL, NULL, 4),
(65996, NULL, 'G3DSA:1.25.40.10:FF:000298', NULL, NULL, 'N-lysine methyltransferase SMYD2', NULL, NULL, NULL, NULL, NULL, 4),
(65997, NULL, 'G3DSA:2.60.120.200:FF:000079', NULL, NULL, 'Hydroxyproline O-galactosyltransferase GALT6', NULL, NULL, NULL, NULL, NULL, 4),
(65998, NULL, 'G3DSA:3.30.310.80:FF:000053', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(65999, NULL, 'G3DSA:3.40.50.300:FF:005066', NULL, NULL, 'Os01g0229400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(66000, NULL, 'G3DSA:2.70.20.10:FF:000005', NULL, NULL, 'DNA topoisomerase III', NULL, NULL, NULL, NULL, NULL, 4),
(66001, NULL, 'G3DSA:3.40.710.10:FF:000004', NULL, NULL, 'Peptidoglycan D,D-transpeptidase MrdA', NULL, NULL, NULL, NULL, NULL, 4),
(66002, NULL, 'G3DSA:3.30.1490.40:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66003, NULL, 'G3DSA:1.25.40.10:FF:001310', NULL, NULL, 'XPA binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(66004, NULL, 'G3DSA:3.30.428.10:FF:000024', NULL, NULL, 'CWF19-like cell cycle control factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(66005, NULL, 'G3DSA:2.130.10.10:FF:005976', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(66006, NULL, 'G3DSA:2.60.40.10:FF:004918', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66007, NULL, 'G3DSA:3.30.420.40:FF:000914', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66008, NULL, 'G3DSA:1.10.472.10:FF:000189', NULL, NULL, 'Hypothetical_protein', NULL, NULL, NULL, NULL, NULL, 4),
(66009, NULL, 'G3DSA:3.40.50.720:FF:001089', NULL, NULL, 'Thiamine biosynthesis protein ThiF', NULL, NULL, NULL, NULL, NULL, 4),
(66010, NULL, 'G3DSA:1.25.10.10:FF:002157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66011, NULL, 'G3DSA:3.20.20.80:FF:000514', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66012, NULL, 'G3DSA:3.30.70.1350:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66013, NULL, 'G3DSA:3.10.100.10:FF:000072', NULL, NULL, 'Narrow, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(66014, NULL, 'G3DSA:1.25.40.10:FF:002838', NULL, NULL, 'Tetratricopeptide repeat domain 25', NULL, NULL, NULL, NULL, NULL, 4),
(66015, NULL, 'G3DSA:3.30.230.10:FF:000251', NULL, NULL, 'Lon protease homolog 2, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(66016, NULL, 'G3DSA:3.10.28.10:FF:000006', NULL, NULL, 'FeS assembly protein SufB', NULL, NULL, NULL, NULL, NULL, 4),
(66017, NULL, 'G3DSA:1.20.920.10:FF:000116', NULL, NULL, 'SP110 nuclear body protein, tandem duplicate 3', NULL, NULL, NULL, NULL, NULL, 4),
(66018, NULL, 'G3DSA:3.40.50.300:FF:001704', NULL, NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(66019, NULL, 'G3DSA:1.50.10.20:FF:000005', NULL, NULL, 'Geranylgeranyl transferase type-1 subunit beta', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(66020, NULL, 'G3DSA:3.40.50.150:FF:001108', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66021, NULL, 'G3DSA:3.40.640.10:FF:000414', NULL, NULL, 'Os09g0278300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(66022, NULL, 'G3DSA:3.40.50.300:FF:006426', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66023, NULL, 'G3DSA:3.30.160.60:FF:006369', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66024, NULL, 'G3DSA:3.50.50.60:FF:000149', NULL, NULL, 'Dimethylglycine dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(66025, NULL, 'G3DSA:1.20.1250.20:FF:001983', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(66026, NULL, 'G3DSA:1.50.10.10:FF:000002', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(66027, NULL, 'G3DSA:2.160.20.10:FF:000147', NULL, NULL, 'Polygalacturonase', NULL, NULL, NULL, NULL, NULL, 4),
(66028, NULL, 'G3DSA:2.160.20.10:FF:000315', NULL, NULL, 'F-box only protein 11-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(66029, NULL, 'G3DSA:2.30.40.10:FF:000160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66030, NULL, 'G3DSA:1.10.630.10:FF:000304', NULL, NULL, '25-hydroxycholesterol 7-alpha-hydroxylase-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(66031, NULL, 'G3DSA:3.40.1490.10:FF:000002', NULL, NULL, 'Peptidyl-tRNA hydrolase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(66032, NULL, 'G3DSA:1.10.10.10:FF:000846', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(66033, NULL, 'G3DSA:3.30.160.60:FF:002098', NULL, NULL, 'Zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(66034, NULL, 'G3DSA:3.40.640.10:FF:000066', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(66035, NULL, 'G3DSA:1.25.40.10:FF:000416', NULL, NULL, 'Tetratricopeptide repeat protein 28', NULL, NULL, NULL, NULL, NULL, 4),
(66036, NULL, 'G3DSA:2.120.10.10:FF:000030', NULL, NULL, 'Trans-sialidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66037, NULL, 'G3DSA:2.60.40.10:FF:005138', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66038, NULL, 'G3DSA:3.40.50.300:FF:001356', NULL, NULL, 'ADP ribosylation factor like GTPase 8B', NULL, NULL, NULL, NULL, NULL, 4),
(66039, NULL, 'G3DSA:3.40.390.10:FF:000029', NULL, NULL, 'Mitochondrial intermediate peptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(66040, NULL, 'G3DSA:3.40.850.10:FF:000109', NULL, NULL, 'Transcription initiation factor TFIID subunit 13', NULL, NULL, NULL, NULL, NULL, 4),
(66041, NULL, 'G3DSA:2.60.120.650:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66042, NULL, 'G3DSA:2.60.40.10:FF:001215', NULL, NULL, 'Uncharacterized protein, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(66043, NULL, 'G3DSA:2.60.120.200:FF:000130', NULL, NULL, 'Crumbs 2, cell polarity complex component', NULL, NULL, NULL, NULL, NULL, 4),
(66044, NULL, 'G3DSA:1.20.1250.20:FF:001764', NULL, NULL, 'Transport protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66045, NULL, 'G3DSA:1.10.30.10:FF:000174', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(66046, NULL, 'G3DSA:3.30.710.10:FF:000001', NULL, NULL, 'Kelch-like family member 20', NULL, NULL, NULL, NULL, NULL, 4),
(66047, NULL, 'G3DSA:3.40.80.10:FF:000013', NULL, NULL, 'Autolysin amidase', NULL, NULL, NULL, NULL, NULL, 4),
(66048, NULL, 'G3DSA:3.30.160.60:FF:002772', NULL, NULL, 'Zinc finger protein 142', NULL, NULL, NULL, NULL, NULL, 4),
(66049, NULL, 'G3DSA:2.30.29.240:FF:000023', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(66050, NULL, 'G3DSA:2.130.10.10:FF:001524', NULL, NULL, 'CPSF A subunit region protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66051, NULL, 'G3DSA:3.30.420.10:FF:000405', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66052, NULL, 'G3DSA:3.30.200.20:FF:002163', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(66053, NULL, 'G3DSA:3.10.450.10:FF:000064', NULL, NULL, 'AGAP002879-PB', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(66054, NULL, 'G3DSA:4.10.1000.10:FF:000006', NULL, NULL, 'Putative pre-mrna-splicing factor rbm22', NULL, NULL, NULL, NULL, NULL, 4),
(66055, NULL, 'G3DSA:2.40.50.140:FF:000542', NULL, NULL, 'mRNA-capping enzyme subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(66056, NULL, 'G3DSA:2.30.29.230:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66057, NULL, 'G3DSA:3.30.1360.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66058, NULL, 'G3DSA:1.25.40.10:FF:002771', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66059, NULL, 'G3DSA:3.30.1050.10:FF:000045', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(66060, NULL, 'G3DSA:3.30.70.330:FF:000590', NULL, NULL, 'Polyadenylate-binding protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(66061, NULL, 'G3DSA:3.40.50.1170:FF:000014', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(66062, NULL, 'G3DSA:2.60.200.20:FF:000193', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(66063, NULL, 'G3DSA:3.80.20.20:FF:000067', NULL, NULL, 'Cell wall protein ecm33', NULL, NULL, NULL, NULL, NULL, 4),
(66064, NULL, 'G3DSA:3.30.160.60:FF:001760', NULL, NULL, 'Zinc finger protein 1057', NULL, NULL, NULL, NULL, NULL, 4),
(66065, NULL, 'G3DSA:1.10.10.10:FF:002089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66066, NULL, 'G3DSA:3.40.50.10240:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66067, NULL, 'G3DSA:1.10.150.20:FF:000158', NULL, NULL, 'DNA integrity scanning protein DisA', NULL, NULL, NULL, NULL, NULL, 4),
(66068, NULL, 'G3DSA:2.40.30.10:FF:000193', NULL, NULL, 'Possible oxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(66069, NULL, 'G3DSA:3.40.50.150:FF:000676', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66070, NULL, 'G3DSA:2.60.40.1170:FF:000095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66071, NULL, 'G3DSA:2.120.10.30:FF:000036', NULL, NULL, 'Pro-epidermal growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(66072, NULL, 'G3DSA:1.10.340.30:FF:000029', NULL, NULL, 'AGAP001854-PA', NULL, NULL, NULL, NULL, NULL, 4),
(66073, NULL, 'G3DSA:1.10.1450.10:FF:000177', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(66074, NULL, 'G3DSA:2.60.200.10:FF:000038', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(66075, NULL, 'G3DSA:3.40.50.2300:FF:000179', NULL, NULL, 'Transcriptional regulator, LuxR family', NULL, NULL, NULL, NULL, NULL, 4),
(66076, NULL, 'G3DSA:1.25.40.10:FF:002619', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(66077, NULL, 'G3DSA:3.40.1090.10:FF:000034', NULL, NULL, 'Patatin', NULL, NULL, NULL, NULL, NULL, 4),
(66078, NULL, 'G3DSA:3.40.50.10390:FF:000002', NULL, NULL, 'Gingipain R2', NULL, NULL, NULL, NULL, NULL, 4),
(66079, NULL, 'G3DSA:1.20.1560.10:FF:000115', NULL, NULL, 'multidrug resistance-associated protein 4 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(66080, NULL, 'G3DSA:2.60.40.10:FF:004649', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66081, NULL, 'G3DSA:3.10.150.10:FF:000024', NULL, NULL, 'Beta sliding clamp', NULL, NULL, NULL, NULL, NULL, 4),
(66082, NULL, 'G3DSA:1.10.720.50:FF:000003', NULL, NULL, 'DNA (cytosine-5-)-methyltransferase 3 beta, duplicate b.2', NULL, NULL, NULL, NULL, NULL, 4),
(66083, NULL, 'G3DSA:3.30.1370.240:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66084, NULL, 'G3DSA:1.20.1740.10:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66085, NULL, 'G3DSA:3.90.640.10:FF:000105', NULL, NULL, 'Heat shock protein 70, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66086, NULL, 'G3DSA:1.20.1230.10:FF:000012', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(66087, NULL, 'G3DSA:1.25.40.10:FF:003108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(66088, NULL, 'G3DSA:1.25.10.10:FF:003051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66089, NULL, 'G3DSA:3.40.50.300:FF:006645', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66090, NULL, 'G3DSA:1.25.40.420:FF:000017', NULL, NULL, 'Influenza virus NS1A-binding protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(66091, NULL, 'G3DSA:1.20.1050.10:FF:000245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66092, NULL, 'G3DSA:3.30.342.10:FF:000010', NULL, NULL, 'DNA polymerase epsilon catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(66093, NULL, 'G3DSA:1.10.10.10:FF:001521', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(66094, NULL, 'G3DSA:3.40.50.2000:FF:000645', NULL, NULL, 'Alphaalpha-trehalose-phosphate synthase [UDP-forming] 5', NULL, NULL, NULL, NULL, NULL, 4),
(66095, NULL, 'G3DSA:1.20.1250.20:FF:000303', NULL, NULL, 'Inner membrane protein YqcE', NULL, NULL, NULL, NULL, NULL, 4),
(66096, NULL, 'G3DSA:3.40.50.2300:FF:001539', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66097, NULL, 'G3DSA:3.40.50.150:FF:001401', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66098, NULL, 'G3DSA:3.40.190.10:FF:000609', NULL, NULL, 'Twin-arginine translocation pathway signal protein', NULL, NULL, NULL, NULL, NULL, 4),
(66099, NULL, 'G3DSA:3.30.450.380:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66100, NULL, 'G3DSA:2.30.30.490:FF:000010', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(66101, NULL, 'G3DSA:1.25.40.10:FF:004418', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66102, NULL, 'G3DSA:2.30.30.190:FF:000021', NULL, NULL, 'Cylindromatosis (turban tumor syndrome), like', NULL, NULL, NULL, NULL, NULL, 4),
(66103, NULL, 'G3DSA:3.40.50.720:FF:000307', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(66104, NULL, 'G3DSA:2.30.170.40:FF:000011', NULL, NULL, '50S ribosomal protein L28', NULL, NULL, NULL, NULL, NULL, 4),
(66105, NULL, 'G3DSA:1.10.8.500:FF:000008', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(66106, NULL, 'G3DSA:2.40.50.120:FF:000030', NULL, NULL, 'AGAP003319-PA', NULL, NULL, NULL, NULL, NULL, 4),
(66107, NULL, 'G3DSA:3.90.650.10:FF:000044', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(66108, NULL, 'G3DSA:3.90.190.10:FF:000020', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type 5', NULL, NULL, NULL, NULL, NULL, 4),
(66109, NULL, 'G3DSA:3.30.780.10:FF:000005', NULL, NULL, 'Sui1 translation initiation factor', NULL, NULL, NULL, NULL, NULL, 4),
(66110, NULL, 'G3DSA:2.30.29.30:FF:000706', NULL, NULL, 'Amyloid beta (A4) precursor protein-binding, family B, member 2b', NULL, NULL, NULL, NULL, NULL, 4),
(66111, NULL, 'G3DSA:1.10.30.20:FF:000002', NULL, NULL, 'DNA repair helicase RAD3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66112, NULL, 'G3DSA:3.80.10.10:FF:004060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66113, NULL, 'G3DSA:2.10.110.10:FF:000115', NULL, NULL, 'Rho GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(66114, NULL, 'G3DSA:2.60.120.260:FF:000069', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(66115, NULL, 'G3DSA:2.60.120.260:FF:000125', NULL, NULL, 'Intracellular beta-galactosidase BgaD', NULL, NULL, NULL, NULL, NULL, 4),
(66116, NULL, 'G3DSA:1.25.40.20:FF:001083', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(66117, NULL, 'G3DSA:1.25.10.10:FF:001139', NULL, NULL, 'HEAT repeat containing 5a', NULL, NULL, NULL, NULL, NULL, 4),
(66118, NULL, 'G3DSA:3.30.40.10:FF:000051', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(66119, NULL, 'G3DSA:2.60.40.10:FF:000760', NULL, NULL, 'tenascin-X', NULL, NULL, NULL, NULL, NULL, 4),
(66120, NULL, 'G3DSA:3.40.50.300:FF:000687', NULL, NULL, 'Ras-related protein RABF2b', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(66121, NULL, 'G3DSA:3.30.160.60:FF:001428', NULL, NULL, 'zinc finger and BTB domain-containing protein 38', NULL, NULL, NULL, NULL, NULL, 4),
(66122, NULL, 'G3DSA:1.25.40.10:FF:001080', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(66123, NULL, 'G3DSA:3.40.50.2300:FF:000123', NULL, NULL, 'Vomeronasal 2, receptor 105', NULL, NULL, NULL, NULL, NULL, 4),
(66124, NULL, 'G3DSA:1.10.238.10:FF:000836', NULL, NULL, 'Uncharacterized calcium-binding protein B0563.7', NULL, NULL, NULL, NULL, NULL, 4),
(66125, NULL, 'G3DSA:3.30.43.10:FF:000029', NULL, NULL, 'FAD-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(66126, NULL, 'G3DSA:2.40.50.140:FF:000036', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(66127, NULL, 'G3DSA:3.40.50.620:FF:000047', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(66128, NULL, 'G3DSA:1.10.1510.30:FF:000008', NULL, NULL, 'Probable tRNA pseudouridine synthase D', NULL, NULL, NULL, NULL, NULL, 4),
(66129, NULL, 'G3DSA:3.40.50.720:FF:002437', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(66130, NULL, 'G3DSA:2.130.10.10:FF:004627', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66131, NULL, 'G3DSA:3.40.50.11660:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66132, NULL, 'G3DSA:3.40.50.10240:FF:000042', NULL, NULL, 'Thiamin pyrophosphokinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(66133, NULL, 'G3DSA:1.10.10.2430:FF:000001', NULL, NULL, 'Nuclear factor related to kappaB binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(66134, NULL, 'G3DSA:2.30.180.10:FF:000076', NULL, NULL, 'Stabilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(66135, NULL, 'G3DSA:3.40.50.150:FF:001440', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66136, NULL, 'G3DSA:3.40.50.410:FF:000315', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(66137, NULL, 'G3DSA:3.30.70.660:FF:000065', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(66138, NULL, 'G3DSA:2.60.40.150:FF:000229', NULL, NULL, 'Translocation protein SEC63', NULL, NULL, NULL, NULL, NULL, 4),
(66139, NULL, 'G3DSA:3.30.200.20:FF:001994', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66140, NULL, 'G3DSA:2.60.40.10:FF:002890', NULL, NULL, 'Alpha-1-B glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(66141, NULL, 'G3DSA:3.30.760.10:FF:000004', NULL, NULL, 'Eukaryotic translation initiation factor 4E-1', NULL, NULL, NULL, NULL, NULL, 4),
(66142, NULL, 'G3DSA:3.90.25.10:FF:000024', NULL, NULL, 'GAL10p UDP-glucose-4-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(66143, NULL, 'G3DSA:2.130.10.10:FF:002542', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(66144, NULL, 'G3DSA:3.40.850.10:FF:000222', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(66145, NULL, 'G3DSA:3.40.30.10:FF:000302', NULL, NULL, 'Oligosaccharyl transferase subunit (Gamma), putative', NULL, NULL, NULL, NULL, NULL, 4),
(66146, NULL, 'G3DSA:3.30.200.20:FF:001887', NULL, NULL, 'cAMP-dependent protein kinase catalytic subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66147, NULL, 'G3DSA:3.40.850.10:FF:000172', NULL, NULL, 'Kinesin protein kif7', NULL, NULL, NULL, NULL, NULL, 4),
(66148, NULL, 'G3DSA:1.10.1510.10:FF:000002', NULL, NULL, 'Altered inheritance of mitochondria protein 41, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(66149, NULL, 'G3DSA:2.130.10.10:FF:004666', NULL, NULL, 'Protein CBR-ELP-1', NULL, NULL, NULL, NULL, NULL, 4),
(66150, NULL, 'G3DSA:2.40.70.10:FF:000369', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66151, NULL, 'G3DSA:2.40.70.10:FF:000425', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66152, NULL, 'G3DSA:3.40.50.1000:FF:000840', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66153, NULL, 'G3DSA:3.40.50.1860:FF:000007', NULL, NULL, 'Glutamate racemase', NULL, NULL, NULL, NULL, NULL, 4),
(66154, NULL, 'G3DSA:1.20.5.1940:FF:000008', NULL, NULL, 'Class E vacuolar protein-sorting machinery protein hse1', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(66155, NULL, 'G3DSA:3.90.190.20:FF:000062', NULL, NULL, 'Folylpolyglutamate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(66156, NULL, 'G3DSA:1.20.950.20:FF:000003', NULL, NULL, 'Ni/Fe-hydrogenase 1 b-type cytochrome subunit', NULL, NULL, NULL, NULL, NULL, 4),
(66157, NULL, 'G3DSA:3.40.50.1110:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66158, NULL, 'G3DSA:3.40.390.10:FF:000142', NULL, NULL, 'Astacin', NULL, NULL, NULL, NULL, NULL, 4),
(66159, NULL, 'G3DSA:3.40.50.300:FF:001581', NULL, NULL, 'Blast:Protein scarlet', NULL, NULL, NULL, NULL, NULL, 4),
(66160, NULL, 'G3DSA:1.10.20.10:FF:000347', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66161, NULL, 'G3DSA:2.60.120.260:FF:000182', NULL, NULL, 'Exo-beta-D-glucosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(66162, NULL, 'G3DSA:3.30.1880.10:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66163, NULL, 'G3DSA:1.25.10.10:FF:002831', NULL, NULL, 'Beta-tubulin cofactor D family protein', NULL, NULL, NULL, NULL, NULL, 4),
(66164, NULL, 'G3DSA:2.40.30.10:FF:000209', NULL, NULL, 'GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66165, NULL, 'G3DSA:2.10.110.10:FF:000172', NULL, NULL, 'Protein CBG11874', NULL, NULL, NULL, NULL, NULL, 4),
(66166, NULL, 'G3DSA:1.10.730.10:FF:000071', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(66167, NULL, 'G3DSA:1.20.1560.10:FF:000621', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(66168, NULL, 'G3DSA:1.10.10.10:FF:000852', NULL, NULL, 'Nse1p', NULL, NULL, NULL, NULL, NULL, 4),
(66169, NULL, 'G3DSA:3.40.50.10190:FF:000330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66170, NULL, 'G3DSA:1.20.1530.20:FF:000055', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(66171, NULL, 'G3DSA:2.60.40.420:FF:000153', NULL, NULL, 'Coagulation factor V', NULL, NULL, NULL, NULL, NULL, 4),
(66172, NULL, 'G3DSA:3.40.50.300:FF:004285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66173, NULL, 'G3DSA:1.20.58.90:FF:000013', NULL, NULL, 'Type III secretion system effector protein-E3 Ubiquitin ligase', NULL, NULL, NULL, NULL, NULL, 4),
(66174, NULL, 'G3DSA:3.30.200.20:FF:001033', NULL, NULL, 'PK3', NULL, NULL, NULL, NULL, NULL, 4),
(66175, NULL, 'G3DSA:1.50.10.10:FF:000114', NULL, NULL, 'Putative 4-alpha-glucanotransferase / amylo-1,6-glucosidase (Glycogen-debranching enzyme)', NULL, NULL, NULL, NULL, NULL, 4),
(66176, NULL, 'G3DSA:2.120.10.80:FF:000348', NULL, NULL, 'RING finger protein B', NULL, NULL, NULL, NULL, NULL, 4),
(66177, NULL, 'G3DSA:1.10.630.10:FF:000181', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(66178, NULL, 'G3DSA:2.120.10.80:FF:000298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66179, NULL, 'G3DSA:3.10.20.230:FF:000021', NULL, NULL, 'Serine/threonine-protein kinase GA29083', NULL, NULL, NULL, NULL, NULL, 4),
(66180, NULL, 'G3DSA:2.70.70.10:FF:000008', NULL, NULL, 'Stage II sporulation protein', NULL, NULL, NULL, NULL, NULL, 4),
(66181, NULL, 'G3DSA:3.10.20.90:FF:000984', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66182, NULL, 'G3DSA:3.90.640.10:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66183, NULL, 'G3DSA:2.10.50.30:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66184, NULL, 'G3DSA:3.40.50.720:FF:002550', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(66185, NULL, 'G3DSA:1.10.510.10:FF:002847', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(66186, NULL, 'G3DSA:3.40.50.11500:FF:000010', NULL, NULL, 'Protein CBR-AEX-3', NULL, NULL, NULL, NULL, NULL, 4),
(66187, NULL, 'G3DSA:3.30.450.20:FF:000236', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(66188, NULL, 'G3DSA:2.60.40.1170:FF:000044', NULL, NULL, 'AP-4 complex subunit mu', NULL, NULL, NULL, NULL, NULL, 4),
(66189, NULL, 'G3DSA:1.10.510.10:FF:000756', NULL, NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 168', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(66190, NULL, 'G3DSA:3.30.1370.10:FF:000024', NULL, NULL, 'Branchpoint-bridging protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(66191, NULL, 'G3DSA:3.30.420.40:FF:000971', NULL, NULL, 'Heat shock protein 70 (HSP70), putative', NULL, NULL, NULL, NULL, NULL, 4),
(66192, NULL, 'G3DSA:2.60.40.10:FF:004975', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66193, NULL, 'G3DSA:3.80.10.10:FF:003453', NULL, NULL, 'LOC100170560 protein', NULL, NULL, NULL, NULL, NULL, 4),
(66194, NULL, 'G3DSA:3.30.160.60:FF:005026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66195, NULL, 'G3DSA:1.10.418.10:FF:000261', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66196, NULL, 'G3DSA:1.20.120.1870:FF:000001', NULL, NULL, 'Death on curing protein, Doc toxin', NULL, NULL, NULL, NULL, NULL, 4),
(66197, NULL, 'G3DSA:3.40.710.10:FF:000010', NULL, NULL, 'Penicillin-binding protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(66198, NULL, 'G3DSA:2.130.10.10:FF:003323', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66199, NULL, 'G3DSA:3.30.379.10:FF:000005', NULL, NULL, 'N-acetyl-alpha-glucosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(66200, NULL, 'G3DSA:3.40.50.10190:FF:000111', NULL, NULL, 'DNA polymerase II complex', NULL, NULL, NULL, NULL, NULL, 4),
(66201, NULL, 'G3DSA:3.80.10.10:FF:003346', NULL, NULL, 'Leucine-rich repeat and transmembrane domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(66202, NULL, 'G3DSA:2.10.25.10:FF:000210', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(66203, NULL, 'G3DSA:3.30.160.60:FF:000973', NULL, NULL, 'Zinc finger protein 668', NULL, NULL, NULL, NULL, NULL, 4),
(66204, NULL, 'G3DSA:1.20.1070.10:FF:002045', NULL, NULL, 'Protein CBR-NPR-17', NULL, NULL, NULL, NULL, NULL, 4),
(66205, NULL, 'G3DSA:3.40.190.10:FF:000761', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(66206, NULL, 'G3DSA:3.40.50.300:FF:000974', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(66207, NULL, 'G3DSA:3.30.830.10:FF:000274', NULL, NULL, 'Insulin-degrading enzyme homolog', NULL, NULL, NULL, NULL, NULL, 4),
(66208, NULL, 'G3DSA:3.40.50.80:FF:000004', NULL, NULL, 'NADPH oxidase isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(66209, NULL, 'G3DSA:3.40.50.300:FF:006196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66210, NULL, 'G3DSA:3.80.10.10:FF:000530', NULL, NULL, 'Receptor-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(66211, NULL, 'G3DSA:1.25.40.10:FF:004570', NULL, NULL, 'Pentatricopeptide repeat-containing protein 4, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(66212, NULL, 'G3DSA:1.50.10.20:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66213, NULL, 'G3DSA:2.60.120.200:FF:000422', NULL, NULL, 'Adhesion G-protein-coupled receptor G6', NULL, NULL, NULL, NULL, NULL, 4),
(66214, NULL, 'G3DSA:3.40.367.20:FF:000006', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(66215, NULL, 'G3DSA:1.20.120.1880:FF:000004', NULL, NULL, 'Non-repetitive nucleoporin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66216, NULL, 'G3DSA:2.160.20.10:FF:000259', NULL, NULL, 'Pectinesterase 31', NULL, NULL, NULL, NULL, NULL, 4),
(66217, NULL, 'G3DSA:1.10.150.670:FF:000013', NULL, NULL, 'Endonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66218, NULL, 'G3DSA:3.40.640.10:FF:000358', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66219, NULL, 'G3DSA:2.130.10.10:FF:001232', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66220, NULL, 'G3DSA:2.60.40.10:FF:000647', NULL, NULL, 'Semaphorin-4D', NULL, NULL, NULL, NULL, NULL, 4),
(66221, NULL, 'G3DSA:3.30.70.890:FF:000078', NULL, NULL, 'Diphosphomevalonate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(66222, NULL, 'G3DSA:1.10.10.10:FF:000796', NULL, NULL, 'Unplaced genomic scaffold supercont2.3, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(66223, NULL, 'G3DSA:1.25.40.10:FF:004750', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(66224, NULL, 'G3DSA:3.40.50.1440:FF:000168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66225, NULL, 'G3DSA:2.40.50.140:FF:000093', NULL, NULL, 'cold shock domain-containing protein E1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(66226, NULL, 'G3DSA:3.90.950.10:FF:000027', NULL, NULL, 'dTTP/UTP pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(66227, NULL, 'G3DSA:3.30.70.330:FF:000882', NULL, NULL, 'Polypyrimidine tract-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(66228, NULL, 'G3DSA:2.70.150.10:FF:000048', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(66229, NULL, 'G3DSA:2.40.128.320:FF:000001', NULL, NULL, 'Protein HRI1', NULL, NULL, NULL, NULL, NULL, 4),
(66230, NULL, 'G3DSA:1.20.120.1750:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66231, NULL, 'G3DSA:3.40.50.300:FF:006319', NULL, NULL, 'RecBCD enzyme subunit RecC', NULL, NULL, NULL, NULL, NULL, 4),
(66232, NULL, 'G3DSA:3.30.160.60:FF:006375', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66233, NULL, 'G3DSA:1.25.10.10:FF:000358', NULL, NULL, 'Serine/threonine-protein phosphatase 4 regulatory subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(66234, NULL, 'G3DSA:1.25.10.10:FF:002449', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(66235, NULL, 'G3DSA:3.90.320.10:FF:000002', NULL, NULL, 'DNA replication ATP-dependent helicase/nuclease DNA2', NULL, NULL, NULL, NULL, NULL, 4),
(66236, NULL, 'G3DSA:2.80.10.50:FF:000078', NULL, NULL, 'Interleukin 36 beta', NULL, NULL, NULL, NULL, NULL, 4),
(66237, NULL, 'G3DSA:2.60.260.20:FF:000078', NULL, NULL, 'Chaperone protein dnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(66238, NULL, 'G3DSA:2.170.30.10:FF:000001', NULL, NULL, 'Minor capsid protein VP1', NULL, NULL, NULL, NULL, NULL, 4),
(66239, NULL, 'G3DSA:4.10.60.10:FF:000270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66240, NULL, 'G3DSA:3.30.750.24:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66241, NULL, 'G3DSA:2.40.128.330:FF:000004', NULL, NULL, 'Magnesium transporter MRS2-11, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(66242, NULL, 'G3DSA:2.20.25.10:FF:000069', NULL, NULL, 'TRMT112 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(66243, NULL, 'G3DSA:3.40.50.300:FF:008556', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(66244, NULL, 'G3DSA:3.90.370.10:FF:000005', NULL, NULL, 'Tissue inhibitor of metalloproteinase', NULL, NULL, NULL, NULL, NULL, 4),
(66245, NULL, 'G3DSA:1.25.40.10:FF:003002', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(66246, NULL, 'G3DSA:2.40.110.10:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66247, NULL, 'G3DSA:2.40.30.10:FF:000485', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66248, NULL, 'G3DSA:2.60.120.260:FF:000344', NULL, NULL, 'Alpha-1,3-mannosyl-glycoprotein 4-beta-N-acetylglucosaminyltransferase C', NULL, NULL, NULL, NULL, NULL, 4),
(66249, NULL, 'G3DSA:3.10.390.10:FF:000002', NULL, NULL, 'Putative ski oncogene', NULL, NULL, NULL, NULL, NULL, 4),
(66250, NULL, 'G3DSA:3.40.50.620:FF:000160', NULL, NULL, 'Pantoate--beta-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(66251, NULL, 'G3DSA:1.10.287.80:FF:000004', NULL, NULL, 'ATP synthase gamma chain, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(66252, NULL, 'G3DSA:3.40.50.80:FF:000061', NULL, NULL, 'Metalloreductase transmembrane component, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66253, NULL, 'G3DSA:1.10.10.10:FF:000740', NULL, NULL, 'Transcriptional regulator, MarR family', NULL, NULL, NULL, NULL, NULL, 4),
(66254, NULL, 'G3DSA:2.10.25.10:FF:000193', NULL, NULL, 'Laminin subunit gamma 1', NULL, NULL, NULL, NULL, NULL, 4),
(66255, NULL, 'G3DSA:1.10.1410.40:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66256, NULL, 'G3DSA:2.40.160.50:FF:000011', NULL, NULL, 'Sorting assembly machinery 50 kDa subunit,putative', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(66257, NULL, 'G3DSA:3.30.470.20:FF:000237', NULL, NULL, 'Pyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(66258, NULL, 'G3DSA:3.30.1370.10:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66259, NULL, 'G3DSA:1.10.630.10:FF:000012', NULL, NULL, 'Cytochrome P450 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(66260, NULL, 'G3DSA:3.30.70.2660:FF:000003', NULL, NULL, 'CRISPR-associated protein Cas5', NULL, NULL, NULL, NULL, NULL, 4),
(66261, NULL, 'G3DSA:1.10.287.70:FF:000001', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(66262, NULL, 'G3DSA:1.20.120.230:FF:000031', NULL, NULL, 'catenin alpha-2', NULL, NULL, NULL, NULL, NULL, 4),
(66263, NULL, 'G3DSA:3.30.559.30:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66264, NULL, 'G3DSA:1.10.510.10:FF:000975', NULL, NULL, 'Poly(A) specific ribonuclease subunit PAN3', NULL, NULL, NULL, NULL, NULL, 4),
(66265, NULL, 'G3DSA:3.50.50.60:FF:000655', NULL, NULL, 'Amino acid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(66266, NULL, 'G3DSA:1.25.10.10:FF:001252', NULL, NULL, 'Sterile alpha and TIR motif-containing protein tir-1', NULL, NULL, NULL, NULL, NULL, 4),
(66267, NULL, 'G3DSA:2.60.40.420:FF:000041', NULL, NULL, 'Blue copper oxidase CueO', NULL, NULL, NULL, NULL, NULL, 4),
(66268, NULL, 'G3DSA:2.40.50.150:FF:000039', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(66269, NULL, 'G3DSA:1.10.287.690:FF:000013', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(66270, NULL, 'G3DSA:2.40.50.730:FF:000005', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(66271, NULL, 'G3DSA:3.40.50.2000:FF:000353', NULL, NULL, 'Glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(66272, NULL, 'G3DSA:3.50.4.10:FF:000024', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(66273, NULL, 'G3DSA:3.30.750.24:FF:000101', NULL, NULL, 'Sodium-independent anion transporter', NULL, NULL, NULL, NULL, NULL, 4),
(66274, NULL, 'G3DSA:2.40.30.130:FF:000046', NULL, NULL, 'Alanine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(66275, NULL, 'G3DSA:1.25.10.10:FF:002943', NULL, NULL, 'Cellular apoptosis susceptibility protein', NULL, NULL, NULL, NULL, NULL, 4),
(66276, NULL, 'G3DSA:3.40.50.300:FF:005740', NULL, NULL, 'Tight junction protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(66277, NULL, 'G3DSA:3.30.1550.10:FF:000010', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(66278, NULL, 'G3DSA:2.60.40.60:FF:000965', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(66279, NULL, 'G3DSA:3.40.50.300:FF:001412', NULL, NULL, 'Peptidase domain-containing ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(66280, NULL, 'G3DSA:3.40.50.300:FF:006937', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(66281, NULL, 'G3DSA:1.25.40.180:FF:000024', NULL, NULL, 'Eukaryotic translation initiation factor 4G', NULL, NULL, NULL, NULL, NULL, 4),
(66282, NULL, 'G3DSA:2.40.50.40:FF:000023', NULL, NULL, 'Lymphotactin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(66283, NULL, 'G3DSA:3.40.50.620:FF:000103', NULL, NULL, 'tyrosine--tRNA ligase 1, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(66284, NULL, 'G3DSA:2.60.40.10:FF:000428', NULL, NULL, 'striated muscle preferentially expressed protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(66285, NULL, 'G3DSA:1.20.1250.20:FF:001596', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(66286, NULL, 'G3DSA:3.90.1030.10:FF:000013', NULL, NULL, '50S ribosomal protein L17', NULL, NULL, NULL, NULL, NULL, 4),
(66287, NULL, 'G3DSA:1.20.1260.10:FF:000019', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(66288, NULL, 'G3DSA:2.70.170.10:FF:000049', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(66289, NULL, 'G3DSA:1.25.40.10:FF:002327', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(66290, NULL, 'G3DSA:3.30.559.10:FF:000103', NULL, NULL, 'Nonribosomal peptide synthetase 13', NULL, NULL, NULL, NULL, NULL, 4),
(66291, NULL, 'G3DSA:1.25.40.10:FF:002384', NULL, NULL, 'transmembrane and TPR repeat-containing protein CG5038', NULL, NULL, NULL, NULL, NULL, 4),
(66292, NULL, 'G3DSA:3.40.50.300:FF:003503', NULL, NULL, 'P. aerophilum family 417, putative ATP binding', NULL, NULL, NULL, NULL, NULL, 4),
(66293, NULL, 'G3DSA:3.90.120.10:FF:000015', NULL, NULL, 'DNA (cytosine-5)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(66294, NULL, 'G3DSA:3.30.559.10:FF:000160', NULL, NULL, 'Nonribosomal peptide synthase inpB', NULL, NULL, NULL, NULL, NULL, 4),
(66295, NULL, 'G3DSA:3.30.420.40:FF:000802', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(66296, NULL, 'G3DSA:3.90.226.10:FF:000188', NULL, NULL, 'Carboxyl-terminal protease', NULL, NULL, NULL, NULL, NULL, 4),
(66297, NULL, 'G3DSA:3.40.50.300:FF:005122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66298, NULL, 'G3DSA:1.20.1250.20:FF:001539', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(66299, NULL, 'G3DSA:3.20.20.190:FF:000141', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66300, NULL, 'G3DSA:2.40.10.350:FF:000001', NULL, NULL, 'Cell shape-determining protein MreC', NULL, NULL, NULL, NULL, NULL, 4),
(66301, NULL, 'G3DSA:2.130.10.10:FF:004447', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66302, NULL, 'G3DSA:1.10.510.10:FF:000936', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(66303, NULL, 'G3DSA:1.10.260.40:FF:000032', NULL, NULL, 'Transcriptional regulator ClgR', NULL, NULL, NULL, NULL, NULL, 4),
(66304, NULL, 'G3DSA:3.50.50.60:FF:000436', NULL, NULL, 'Putative dihydrolipoamide dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(66305, NULL, 'G3DSA:3.30.40.10:FF:002355', NULL, NULL, 'Pleckstrin homology domain-containing, family F (with FYVE domain) member 1', NULL, NULL, NULL, NULL, NULL, 4),
(66306, NULL, 'G3DSA:1.20.5.190:FF:000098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66307, NULL, 'G3DSA:3.30.70.270:FF:000111', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(66308, NULL, 'G3DSA:1.10.8.60:FF:000017', NULL, NULL, 'ATP-dependent chaperone ClpB', NULL, NULL, NULL, NULL, NULL, 4),
(66309, NULL, 'G3DSA:3.30.160.60:FF:005301', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66310, NULL, 'G3DSA:3.40.50.10470:FF:000049', NULL, NULL, 'Translation initiation factor eIF-2B subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(66311, NULL, 'G3DSA:3.50.50.60:FF:000150', NULL, NULL, 'Polyamine oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(66312, NULL, 'G3DSA:1.20.5.1700:FF:000010', NULL, NULL, 'Bone marrow stromal antigen 2 type B', NULL, NULL, NULL, NULL, NULL, 4),
(66313, NULL, 'G3DSA:3.10.129.10:FF:000160', NULL, NULL, '4-hydroxybenzoyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(66314, NULL, 'G3DSA:1.25.10.10:FF:002887', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66315, NULL, 'G3DSA:3.30.200.20:FF:000538', NULL, NULL, 'Putative Casein kinase I', NULL, NULL, NULL, NULL, NULL, 4),
(66316, NULL, 'G3DSA:3.30.2350.10:FF:000028', NULL, NULL, 'RluA family pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(66317, NULL, 'G3DSA:3.40.50.300:FF:004846', NULL, NULL, 'Putative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(66318, NULL, 'G3DSA:3.50.50.60:FF:000094', NULL, NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', NULL, NULL, NULL, NULL, NULL, 4),
(66319, NULL, 'G3DSA:3.40.309.10:FF:000010', NULL, NULL, 'Gamma-aminobutyraldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(66320, NULL, 'G3DSA:1.20.120.720:FF:000026', NULL, NULL, 'Myosin C', NULL, NULL, NULL, NULL, NULL, 4),
(66321, NULL, 'G3DSA:3.30.70.1990:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66322, NULL, 'G3DSA:2.30.280.10:FF:000004', NULL, NULL, 'E3 ubiquitin-protein ligase UHRF2', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(66323, NULL, 'G3DSA:3.90.79.10:FF:000143', NULL, NULL, 'DNA mismatch repair protein MutT', NULL, NULL, NULL, NULL, NULL, 4),
(66324, NULL, 'G3DSA:1.20.1080.10:FF:000034', NULL, NULL, 'Aquaglyceroporin', NULL, NULL, NULL, NULL, NULL, 4),
(66325, NULL, 'G3DSA:3.40.50.300:FF:003267', NULL, NULL, 'ADP-ribosylation factor-related', NULL, NULL, NULL, NULL, NULL, 4),
(66326, NULL, 'G3DSA:1.10.1520.10:FF:000008', NULL, NULL, 'Dicer-like 104', NULL, NULL, NULL, NULL, NULL, 4),
(66327, NULL, 'G3DSA:3.40.50.1000:FF:000278', NULL, NULL, 'RNA polymerase II subunit A domain phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(66328, NULL, 'G3DSA:3.90.930.12:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66329, NULL, 'G3DSA:3.30.750.24:FF:000045', NULL, NULL, 'Unplaced genomic scaffold supercont2.6, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(66330, NULL, 'G3DSA:1.10.510.10:FF:001251', NULL, NULL, 'Inactive serine/threonine-protein kinase At1g67470', NULL, NULL, NULL, NULL, NULL, 4),
(66331, NULL, 'G3DSA:1.20.1250.20:FF:000016', NULL, NULL, 'Glycerol-3-phosphate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(66332, NULL, 'G3DSA:3.30.430.20:FF:000061', NULL, NULL, 'Putative DUF26-domain protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(66333, NULL, 'G3DSA:3.40.850.10:FF:000402', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(66334, NULL, 'G3DSA:1.10.1600.10:FF:000009', NULL, NULL, 'ATP-dependent DNA helicase II subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(66335, NULL, 'G3DSA:3.30.70.330:FF:000551', NULL, NULL, 'U2 snRNP auxiliary factor large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(66336, NULL, 'G3DSA:1.20.1540.10:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66337, NULL, 'G3DSA:3.40.190.170:FF:000003', NULL, NULL, 'Lactate-binding periplasmic protein TTHA0766', NULL, NULL, NULL, NULL, NULL, 4),
(66338, NULL, 'G3DSA:1.20.58.60:FF:000706', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66339, NULL, 'G3DSA:2.130.10.10:FF:000176', NULL, NULL, 'Intraflagellar transport protein 122 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(66340, NULL, 'G3DSA:3.90.70.10:FF:000836', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66341, NULL, 'G3DSA:1.10.510.10:FF:001212', NULL, NULL, 'Protein tyrosine kinase 2 beta, b', NULL, NULL, NULL, NULL, NULL, 4),
(66342, NULL, 'G3DSA:1.20.5.190:FF:000059', NULL, NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(66343, NULL, 'G3DSA:3.30.420.40:FF:000858', NULL, NULL, 'ROK family protein', NULL, NULL, NULL, NULL, NULL, 4),
(66344, NULL, 'G3DSA:2.60.210.10:FF:000033', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(66345, NULL, 'G3DSA:1.10.220.150:FF:000054', NULL, NULL, 'Un-named sa1614', NULL, NULL, NULL, NULL, NULL, 4),
(66346, NULL, 'G3DSA:3.80.10.10:FF:001873', NULL, NULL, 'At1g04210', NULL, NULL, NULL, NULL, NULL, 4),
(66347, NULL, 'G3DSA:3.60.40.10:FF:000302', NULL, NULL, 'Amino-acid permease BAT1', NULL, NULL, NULL, NULL, NULL, 4),
(66348, NULL, 'G3DSA:3.30.559.10:FF:000047', NULL, NULL, 'Phthiocerol/phthiodiolone dimycocerosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(66349, NULL, 'G3DSA:1.20.1250.10:FF:000013', NULL, NULL, 'Erythropoietin', NULL, NULL, NULL, NULL, NULL, 4),
(66350, NULL, 'G3DSA:1.10.10.60:FF:000165', NULL, NULL, 'Two-component system nitrogen regulation response regulator NtrX', NULL, NULL, NULL, NULL, NULL, 4),
(66351, NULL, 'G3DSA:3.40.30.10:FF:001084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66352, NULL, 'G3DSA:3.40.366.10:FF:000035', NULL, NULL, 'Yersiniabactin polyketide/non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(66353, NULL, 'G3DSA:2.60.40.2170:FF:000006', NULL, NULL, 'Inactive tyrosine-protein kinase RYK', NULL, NULL, NULL, NULL, NULL, 4),
(66354, NULL, 'G3DSA:1.10.10.10:FF:001015', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(66355, NULL, 'G3DSA:2.60.40.1400:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66356, NULL, 'G3DSA:1.10.8.710:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66357, NULL, 'G3DSA:3.40.1440.10:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66358, NULL, 'G3DSA:1.10.150.20:FF:000046', NULL, NULL, 'Fanconi anemia core complex-associated protein 24', NULL, NULL, NULL, NULL, NULL, 4),
(66359, NULL, 'G3DSA:1.10.400.10:FF:000080', NULL, NULL, 'G protein subunit alpha transducin 2', NULL, NULL, NULL, NULL, NULL, 4),
(66360, NULL, 'G3DSA:2.60.40.10:FF:002671', NULL, NULL, 'Connectin', NULL, NULL, NULL, NULL, NULL, 4),
(66361, NULL, 'G3DSA:3.30.730.10:FF:000002', NULL, NULL, 'AP2-like ethylene-responsive transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(66362, NULL, 'G3DSA:1.10.510.10:FF:003229', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66363, NULL, 'G3DSA:3.90.850.10:FF:000031', NULL, NULL, 'Putative hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(66364, NULL, 'G3DSA:3.10.129.10:FF:000047', NULL, NULL, 'Acyl-CoA thioester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(66365, NULL, 'G3DSA:1.10.340.30:FF:000030', NULL, NULL, 'Ada regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(66366, NULL, 'G3DSA:3.40.50.300:FF:000917', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(66367, NULL, 'G3DSA:3.40.50.300:FF:003323', NULL, NULL, 'Rab family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(66368, NULL, 'G3DSA:2.130.10.10:FF:002980', NULL, NULL, 'WD40-repeat-containing domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(66369, NULL, 'G3DSA:1.20.1260.60:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66370, NULL, 'G3DSA:3.50.30.30:FF:000100', NULL, NULL, 'Glutamate carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66371, NULL, 'G3DSA:1.20.5.170:FF:000053', NULL, NULL, 'BZIP transcription factor AtfA', NULL, NULL, NULL, NULL, NULL, 4),
(66372, NULL, 'G3DSA:3.30.300.180:FF:000025', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(66373, NULL, 'G3DSA:2.130.10.10:FF:005122', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(66374, NULL, 'G3DSA:1.10.10.60:FF:000906', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66375, NULL, 'G3DSA:1.25.40.20:FF:001644', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(66376, NULL, 'G3DSA:3.30.40.10:FF:000556', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-4 specific', NULL, NULL, NULL, NULL, NULL, 4),
(66377, NULL, 'G3DSA:1.10.10.10:FF:000739', NULL, NULL, 'Related to RFX1-major transcriptional repressor of DNA-damage-regulated genes', NULL, NULL, NULL, NULL, NULL, 4),
(66378, NULL, 'G3DSA:1.10.150.60:FF:000029', NULL, NULL, 'Brahma associated protein 170kD', NULL, NULL, NULL, NULL, NULL, 4),
(66379, NULL, 'G3DSA:3.30.300.30:FF:000060', NULL, NULL, 'Nonribosomal peptide synthase SidE', NULL, NULL, NULL, NULL, NULL, 4),
(66380, NULL, 'G3DSA:1.25.40.20:FF:001700', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(66381, NULL, 'G3DSA:3.30.160.60:FF:001316', NULL, NULL, 'PR domain zinc finger protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(66382, NULL, 'G3DSA:3.80.10.10:FF:000350', NULL, NULL, 'volume-regulated anion channel subunit LRRC8A', NULL, NULL, NULL, NULL, NULL, 4),
(66383, NULL, 'G3DSA:2.30.42.10:FF:000164', NULL, NULL, 'Ligand of numb-protein X 2', NULL, NULL, NULL, NULL, NULL, 4),
(66384, NULL, 'G3DSA:1.10.287.4070:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66385, NULL, 'G3DSA:3.30.300.30:FF:000021', NULL, NULL, 'Enterobactin synthase component E', NULL, NULL, NULL, NULL, NULL, 4),
(66386, NULL, 'G3DSA:3.30.200.20:FF:000252', NULL, NULL, 'Serine/threonine-protein kinase 26', NULL, NULL, NULL, NULL, NULL, 4),
(66387, NULL, 'G3DSA:3.90.980.20:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66388, NULL, 'G3DSA:1.25.40.10:FF:001203', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(66389, NULL, 'G3DSA:1.25.40.20:FF:001206', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(66390, NULL, 'G3DSA:2.60.40.10:FF:002738', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(66391, NULL, 'G3DSA:3.80.10.10:FF:004127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66392, NULL, 'G3DSA:3.40.630.10:FF:000419', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(66393, NULL, 'G3DSA:1.25.40.1010:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66394, NULL, 'G3DSA:1.25.40.10:FF:004637', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase, cyclophilin-type', NULL, NULL, NULL, NULL, NULL, 4),
(66395, NULL, 'G3DSA:3.90.79.10:FF:000087', NULL, NULL, 'Nudix (nucleoside diphosphate linked moiety X)-type motif 22', NULL, NULL, NULL, NULL, NULL, 4),
(66396, NULL, 'G3DSA:3.30.1120.30:FF:000028', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(66397, NULL, 'G3DSA:1.10.8.270:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66398, NULL, 'G3DSA:2.60.40.10:FF:004470', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66399, NULL, 'G3DSA:3.30.465.10:FF:000048', NULL, NULL, 'FAD-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(66400, NULL, 'G3DSA:3.10.350.10:FF:000005', NULL, NULL, 'L,D-transpeptidase YnhG', NULL, NULL, NULL, NULL, NULL, 4),
(66401, NULL, 'G3DSA:2.30.30.140:FF:000141', NULL, NULL, 'DNA damage repair protein (Rad9)', NULL, NULL, NULL, NULL, NULL, 4),
(66402, NULL, 'G3DSA:3.30.70.330:FF:002349', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66403, NULL, 'G3DSA:2.60.40.1110:FF:000009', NULL, NULL, 'Type I pullulanase', NULL, NULL, NULL, NULL, NULL, 4),
(66404, NULL, 'G3DSA:3.40.50.2300:FF:000741', NULL, NULL, 'Vomeronasal 2 receptor, 57', NULL, NULL, NULL, NULL, NULL, 4),
(66405, NULL, 'G3DSA:3.40.50.300:FF:003380', NULL, NULL, 'Rad25/xp-B DNA repair helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66406, NULL, 'G3DSA:2.130.10.10:FF:000917', NULL, NULL, 'Dynein intermediate chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66407, NULL, 'G3DSA:3.30.200.20:FF:000870', NULL, NULL, 'Inactive tyrosine-protein kinase kin-32', NULL, NULL, NULL, NULL, NULL, 4),
(66408, NULL, 'G3DSA:2.60.120.200:FF:000186', NULL, NULL, 'Contactin-associated protein-like 4', NULL, NULL, NULL, NULL, NULL, 4),
(66409, NULL, 'G3DSA:3.60.140.10:FF:000001', NULL, NULL, 'Polyphenol oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(66410, NULL, 'G3DSA:1.20.1250.20:FF:000073', NULL, NULL, 'MFS myo-inositol transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66411, NULL, 'G3DSA:3.30.70.330:FF:002063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66412, NULL, 'G3DSA:1.20.1560.10:FF:000402', NULL, NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 4', NULL, NULL, NULL, NULL, NULL, 4),
(66413, NULL, 'G3DSA:3.40.630.30:FF:000577', NULL, NULL, 'Uncharacterized N-acetyltransferase C550.08', NULL, NULL, NULL, NULL, NULL, 4),
(66414, NULL, 'G3DSA:1.10.3260.10:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66415, NULL, 'G3DSA:3.40.525.10:FF:000057', NULL, NULL, 'Retinaldehyde binding protein 1, like', NULL, NULL, NULL, NULL, NULL, 4),
(66416, NULL, 'G3DSA:2.170.300.10:FF:000047', NULL, NULL, 'Scavenger receptor class F member 1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(66417, NULL, 'G3DSA:3.30.710.10:FF:000332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66418, NULL, 'G3DSA:2.40.70.10:FF:000482', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66419, NULL, 'G3DSA:3.30.200.20:FF:000690', NULL, NULL, 'Receptor tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(66420, NULL, 'G3DSA:3.30.1240.10:FF:000020', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(66421, NULL, 'G3DSA:3.40.50.1820:FF:001592', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66422, NULL, 'G3DSA:3.30.710.10:FF:000276', NULL, NULL, 'Phototropic-responsive NPH3 family protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(66423, NULL, 'G3DSA:1.10.443.10:FF:000004', NULL, NULL, 'Integrase', NULL, NULL, NULL, NULL, NULL, 4),
(66424, NULL, 'G3DSA:2.30.30.40:FF:000494', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(66425, NULL, 'G3DSA:1.20.1560.10:FF:000060', NULL, NULL, 'Cysteine/glutathione ABC transporter ATP-binding protein/permease CydC', NULL, NULL, NULL, NULL, NULL, 4),
(66426, NULL, 'G3DSA:1.25.40.20:FF:001026', NULL, NULL, 'Putative ankyrin repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(66427, NULL, 'G3DSA:1.10.1300.10:FF:000026', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(66428, NULL, 'G3DSA:3.90.1300.10:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66429, NULL, 'G3DSA:3.90.550.10:FF:000391', NULL, NULL, 'Beta-1,3-N-acetylglucosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(66430, NULL, 'G3DSA:3.30.160.750:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66431, NULL, 'G3DSA:1.25.40.10:FF:000747', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(66432, NULL, 'G3DSA:1.20.1070.10:FF:001663', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66433, NULL, 'G3DSA:1.25.40.10:FF:000528', NULL, NULL, 'Transmembrane and TPR repeat-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(66434, NULL, 'G3DSA:3.30.1330.10:FF:000027', NULL, NULL, 'Thiamine monophosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(66435, NULL, 'G3DSA:3.90.660.10:FF:000106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66436, NULL, 'G3DSA:1.10.287.130:FF:000143', NULL, NULL, 'Two-component system sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(66437, NULL, 'G3DSA:3.30.160.740:FF:000002', NULL, NULL, '2-isopropylmalate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(66438, NULL, 'G3DSA:3.30.70.3030:FF:000013', NULL, NULL, 'Nucleolar protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(66439, NULL, 'G3DSA:1.20.1250.20:FF:001652', NULL, NULL, 'MFS transporter, DHA2 family, multidrug resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(66440, NULL, 'G3DSA:1.25.40.10:FF:001023', NULL, NULL, 'Cell division cycle 16', NULL, NULL, NULL, NULL, NULL, 4),
(66441, NULL, 'G3DSA:3.10.20.90:FF:000546', NULL, NULL, 'UBA/TS-N domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(66442, NULL, 'G3DSA:1.10.238.10:FF:000893', NULL, NULL, 'Dual oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(66443, NULL, 'G3DSA:3.30.160.60:FF:000012', NULL, NULL, 'RB-associated KRAB zinc finger protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(66444, NULL, 'G3DSA:3.30.70.920:FF:000014', NULL, NULL, 'Lrp/AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(66445, NULL, 'G3DSA:2.20.100.10:FF:000005', NULL, NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 9', NULL, NULL, NULL, NULL, NULL, 4),
(66446, NULL, 'G3DSA:3.80.10.10:FF:000294', NULL, NULL, 'Leucine-rich repeat-containing 8 VRAC subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(66447, NULL, 'G3DSA:1.25.10.10:FF:000139', NULL, NULL, 'protein EFR3 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(66448, NULL, 'G3DSA:3.90.70.10:FF:000893', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(66449, NULL, 'G3DSA:2.120.10.80:FF:000242', NULL, NULL, 'Development protein DG1106', NULL, NULL, NULL, NULL, NULL, 4),
(66450, NULL, 'G3DSA:3.40.190.10:FF:000722', NULL, NULL, 'Protein CBR-NMR-2', NULL, NULL, NULL, NULL, NULL, 4),
(66451, NULL, 'G3DSA:1.20.1070.10:FF:002006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66452, NULL, 'G3DSA:1.20.1250.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66453, NULL, 'G3DSA:3.40.50.1820:FF:001715', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(66454, NULL, 'G3DSA:3.30.1140.32:FF:000021', NULL, NULL, '30S ribosomal protein S3', NULL, NULL, NULL, NULL, NULL, 4),
(66455, NULL, 'G3DSA:3.40.630.10:FF:000239', NULL, NULL, 'Putative carboxypeptidase PM20D1', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(66456, NULL, 'G3DSA:1.10.510.10:FF:001431', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66457, NULL, 'G3DSA:3.30.70.1440:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66458, NULL, 'G3DSA:3.30.710.10:FF:000057', NULL, NULL, 'SKP1-like protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(66459, NULL, 'G3DSA:3.80.10.10:FF:000018', NULL, NULL, 'Reticulon 4 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(66460, NULL, 'G3DSA:2.20.100.10:FF:000062', NULL, NULL, 'Thrombospondin type 1 domain containing 7B', NULL, NULL, NULL, NULL, NULL, 4),
(66461, NULL, 'G3DSA:3.30.40.10:FF:001574', NULL, NULL, 'RING-H2 finger protein ATL33', NULL, NULL, NULL, NULL, NULL, 4),
(66462, NULL, 'G3DSA:3.40.1190.20:FF:000134', NULL, NULL, 'Bifunctional NAD(P)H-hydrate repair enzyme Nnr', NULL, NULL, NULL, NULL, NULL, 4),
(66463, NULL, 'G3DSA:2.60.120.200:FF:000309', NULL, NULL, 'Sialidase', NULL, NULL, NULL, NULL, NULL, 4),
(66464, NULL, 'G3DSA:1.10.510.10:FF:004247', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66465, NULL, 'G3DSA:1.10.238.10:FF:000275', NULL, NULL, 'Probable calcium-binding protein CML27', NULL, NULL, NULL, NULL, NULL, 4),
(66466, NULL, 'G3DSA:1.10.3660.10:FF:000013', NULL, NULL, 'Prephenate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(66467, NULL, 'G3DSA:3.30.70.1450:FF:000016', NULL, NULL, 'Potassium uptake protein, Trk family', NULL, NULL, NULL, NULL, NULL, 4),
(66468, NULL, 'G3DSA:3.30.200.20:FF:000813', NULL, NULL, 'Mitogen-activated protein kinase kinase 9', NULL, NULL, NULL, NULL, NULL, 4),
(66469, NULL, 'G3DSA:1.20.1250.20:FF:000634', NULL, NULL, 'Fosmidomycin resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(66470, NULL, 'G3DSA:3.40.50.10140:FF:000012', NULL, NULL, 'Sterile alpha and TIR motif-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(66471, NULL, 'G3DSA:3.40.50.620:FF:000608', NULL, NULL, 'Arginine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(66472, NULL, 'G3DSA:1.10.3720.10:FF:000182', NULL, NULL, 'Amino acid ABC transporter permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(66473, NULL, 'G3DSA:3.30.70.330:FF:002624', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66474, NULL, 'G3DSA:3.30.160.60:FF:004806', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66475, NULL, 'G3DSA:3.50.50.60:FF:000711', NULL, NULL, 'Monooxygenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(66476, NULL, 'G3DSA:3.30.420.10:FF:000698', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66477, NULL, 'G3DSA:1.25.40.10:FF:004457', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66478, NULL, 'G3DSA:3.30.2350.10:FF:000085', NULL, NULL, 'tRNA pseudouridine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(66479, NULL, 'G3DSA:3.90.550.50:FF:000155', NULL, NULL, 'Os10g0551000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(66480, NULL, 'G3DSA:1.20.1050.130:FF:000003', NULL, NULL, 'Cysteinyl-tRNA synthetase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(66481, NULL, 'G3DSA:2.130.10.10:FF:004902', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66482, NULL, 'G3DSA:2.60.11.10:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66483, NULL, 'G3DSA:3.30.70.330:FF:002681', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66484, NULL, 'G3DSA:3.40.50.1220:FF:000052', NULL, NULL, 'Putative 2-hydroxyacyl-CoA lyase', NULL, NULL, NULL, NULL, NULL, 4),
(66485, NULL, 'G3DSA:2.60.40.60:FF:000926', NULL, NULL, 'Protocadherin 1 gamma 9', NULL, NULL, NULL, NULL, NULL, 4),
(66486, NULL, 'G3DSA:1.25.40.20:FF:000189', NULL, NULL, 'Protein phosphatase 1 regulatory subunit 27', NULL, NULL, NULL, NULL, NULL, 4),
(66487, NULL, 'G3DSA:3.90.132.10:FF:000026', NULL, NULL, 'GP63-like', NULL, NULL, NULL, NULL, NULL, 4),
(66488, NULL, 'G3DSA:3.40.50.1000:FF:000839', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66489, NULL, 'G3DSA:3.40.50.1370:FF:000012', NULL, NULL, 'Aspartate carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(66490, NULL, 'G3DSA:1.10.150.20:FF:000102', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(66491, NULL, 'G3DSA:1.10.8.60:FF:000130', NULL, NULL, 'Replication factor C subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(66492, NULL, 'G3DSA:2.60.40.10:FF:002558', NULL, NULL, 'Interleukin-1 receptor accessory protein-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(66493, NULL, 'G3DSA:1.25.40.480:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66494, NULL, 'G3DSA:3.40.1620.10:FF:000002', NULL, NULL, 'Antitoxin', NULL, NULL, NULL, NULL, NULL, 4),
(66495, NULL, 'G3DSA:1.25.40.10:FF:000186', NULL, NULL, 'Tetratricopeptide repeat domain 30A', NULL, NULL, NULL, NULL, NULL, 4),
(66496, NULL, 'G3DSA:3.40.1700.10:FF:000003', NULL, NULL, 'Diadenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(66497, NULL, 'G3DSA:3.60.21.10:FF:000449', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66498, NULL, 'G3DSA:1.25.10.10:FF:000471', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(66499, NULL, 'G3DSA:3.10.350.10:FF:000062', NULL, NULL, 'Chlorophenol reductase', NULL, NULL, NULL, NULL, NULL, 4),
(66500, NULL, 'G3DSA:1.10.287.110:FF:000328', NULL, NULL, 'Chaperone protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66501, NULL, 'G3DSA:1.20.910.10:FF:000003', NULL, NULL, 'Hydroxymethylpyrimidine/phosphomethylpyrimidine kinase THI20', NULL, NULL, NULL, NULL, NULL, 4),
(66502, NULL, 'G3DSA:1.20.960.10:FF:000006', NULL, NULL, 'Mitochondrial outer membrane translocase complex, subunit Tom20 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(66503, NULL, 'G3DSA:3.90.226.10:FF:000244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66504, NULL, 'G3DSA:3.90.70.10:FF:000275', NULL, NULL, 'Cysteine protease 13', NULL, NULL, NULL, NULL, NULL, 4),
(66505, NULL, 'G3DSA:3.30.160.60:FF:005700', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66506, NULL, 'G3DSA:1.25.40.470:FF:000010', NULL, NULL, 'Intraflagellar transport 140 homolog (Chlamydomonas)', NULL, NULL, NULL, NULL, NULL, 4),
(66507, NULL, 'G3DSA:1.25.40.20:FF:001431', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66508, NULL, 'G3DSA:1.10.10.820:FF:000029', NULL, NULL, 'Type II myosin heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66509, NULL, 'G3DSA:3.80.10.10:FF:004352', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66510, NULL, 'G3DSA:2.20.100.10:FF:000101', NULL, NULL, 'No long nerve cord, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(66511, NULL, 'G3DSA:1.10.1300.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66512, NULL, 'G3DSA:2.40.50.140:FF:000811', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66513, NULL, 'G3DSA:3.30.420.40:FF:000881', NULL, NULL, 'Actin-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(66514, NULL, 'G3DSA:1.20.120.1900:FF:000095', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(66515, NULL, 'G3DSA:3.30.750.24:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66516, NULL, 'G3DSA:3.30.1490.100:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66517, NULL, 'G3DSA:3.90.79.10:FF:000019', NULL, NULL, 'Thiamin pyrophosphokinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66518, NULL, 'G3DSA:2.60.40.10:FF:002654', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66519, NULL, 'G3DSA:3.30.1490.190:FF:000022', NULL, NULL, 'Transcriptional regulator, Fur family', NULL, NULL, NULL, NULL, NULL, 4),
(66520, NULL, 'G3DSA:3.30.479.30:FF:000018', NULL, NULL, 'STOM isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(66521, NULL, 'G3DSA:3.90.176.10:FF:000003', NULL, NULL, 'NAD(P)(+)--arginine ADP-ribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(66522, NULL, 'G3DSA:3.40.50.410:FF:000023', NULL, NULL, 'Collagen type VI alpha 3 chain', NULL, NULL, NULL, NULL, NULL, 4),
(66523, NULL, 'G3DSA:3.10.100.10:FF:000156', NULL, NULL, 'GD24202', NULL, NULL, NULL, NULL, NULL, 4),
(66524, NULL, 'G3DSA:1.10.238.10:FF:001112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(66525, NULL, 'G3DSA:3.40.50.300:FF:000884', NULL, NULL, 'Dynein axonemal heavy chain 10', NULL, NULL, NULL, NULL, NULL, 4),
(66526, NULL, 'G3DSA:2.60.40.10:FF:004778', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66527, NULL, 'G3DSA:4.10.240.10:FF:000100', NULL, NULL, 'YKL222C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(66528, NULL, 'G3DSA:3.40.800.10:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66529, NULL, 'G3DSA:3.40.50.300:FF:001390', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(66530, NULL, 'G3DSA:3.30.1490.480:FF:000002', NULL, NULL, 'Endolytic murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(66531, NULL, 'G3DSA:1.10.287.4070:FF:000005', NULL, NULL, 'SnoRNA binding domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(66532, NULL, 'G3DSA:1.10.630.10:FF:000203', NULL, NULL, 'Cytochrome P450 81D1', NULL, NULL, NULL, NULL, NULL, 4),
(66533, NULL, 'G3DSA:2.20.25.420:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66534, NULL, 'G3DSA:1.20.1640.10:FF:000049', NULL, NULL, 'Transmembrane transport protein MmpL11', NULL, NULL, NULL, NULL, NULL, 4),
(66535, NULL, 'G3DSA:1.10.1740.140:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66536, NULL, 'G3DSA:3.90.70.10:FF:000797', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(66537, NULL, 'G3DSA:2.130.10.10:FF:001204', NULL, NULL, 'Vacuolar protein sorting-associated protein 41 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(66538, NULL, 'G3DSA:1.20.1720.10:FF:000100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66539, NULL, 'G3DSA:1.20.1250.10:FF:000081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66540, NULL, 'G3DSA:2.60.40.10:FF:003160', NULL, NULL, 'Sortilin-related receptor, L(DLR class) A repeats containing', NULL, NULL, NULL, NULL, NULL, 4),
(66541, NULL, 'G3DSA:3.40.50.1010:FF:000112', NULL, NULL, 'ERCC excision repair 5, endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(66542, NULL, 'G3DSA:1.25.40.10:FF:000276', NULL, NULL, 'Mitochondrial ribonuclease P catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(66543, NULL, 'G3DSA:3.40.390.10:FF:000052', NULL, NULL, 'Matrix metallopeptidase 26', NULL, NULL, NULL, NULL, NULL, 4),
(66544, NULL, 'G3DSA:2.115.10.20:FF:000012', NULL, NULL, 'Probable sucrose-6-phosphate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(66545, NULL, 'G3DSA:1.20.1250.70:FF:000003', NULL, NULL, 'Interleukin', NULL, NULL, NULL, NULL, NULL, 4),
(66546, NULL, 'G3DSA:3.30.40.10:FF:001973', NULL, NULL, 'Cellulose synthase/ transferase transferring glycosyl groups', NULL, NULL, NULL, NULL, NULL, 4),
(66547, NULL, 'G3DSA:1.10.470.10:FF:000005', NULL, NULL, 'Variant surface glycoprotein (VSG, atypical), putative', NULL, NULL, NULL, NULL, NULL, 4),
(66548, NULL, 'G3DSA:3.60.10.10:FF:000137', NULL, NULL, 'Metal-dependent hydrolase, endonuclease/exonuclease/phosphatase family', NULL, NULL, NULL, NULL, NULL, 4),
(66549, NULL, 'G3DSA:1.25.40.10:FF:004654', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(66550, NULL, 'G3DSA:1.25.40.10:FF:000955', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(66551, NULL, 'G3DSA:1.25.10.10:FF:000774', NULL, NULL, 'Adapter-related protein complex 3 (AP-3) subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66552, NULL, 'G3DSA:2.60.120.200:FF:000450', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66553, NULL, 'G3DSA:3.40.50.1000:FF:000694', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66554, NULL, 'G3DSA:1.20.1540.10:FF:000002', NULL, NULL, 'Rhomboid, veinlet-like 3 (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(66555, NULL, 'G3DSA:3.30.160.60:FF:005363', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66556, NULL, 'G3DSA:1.25.40.20:FF:000958', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(66557, NULL, 'G3DSA:1.20.1250.20:FF:002219', NULL, NULL, 'Solute carrier family 22 member 18', NULL, NULL, NULL, NULL, NULL, 4),
(66558, NULL, 'G3DSA:2.120.10.30:FF:000249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66559, NULL, 'G3DSA:2.30.42.10:FF:000350', NULL, NULL, 'MAGI (Membrane Associated Guanylate kinase Inverted) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(66560, NULL, 'G3DSA:3.40.50.12370:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66561, NULL, 'G3DSA:1.10.510.10:FF:002656', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66562, NULL, 'G3DSA:1.20.90.10:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66563, NULL, 'G3DSA:2.60.40.770:FF:000022', NULL, NULL, 'Putative phosphatidylglycerol/phosphatidylinositol transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(66564, NULL, 'G3DSA:1.20.1070.10:FF:002118', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(66565, NULL, 'G3DSA:3.40.190.10:FF:000424', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(66566, NULL, 'G3DSA:3.40.50.150:FF:001530', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66567, NULL, 'G3DSA:1.25.10.10:FF:000448', NULL, NULL, 'Calcium binding protein 39', NULL, NULL, NULL, NULL, NULL, 4),
(66568, NULL, 'G3DSA:3.40.50.2300:FF:000522', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66569, NULL, 'G3DSA:2.60.260.20:FF:000056', NULL, NULL, 'Chaperone protein DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(66570, NULL, 'G3DSA:2.40.30.110:FF:000006', NULL, NULL, 'Sarcosine dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(66571, NULL, 'G3DSA:3.40.50.300:FF:004627', NULL, NULL, 'ABC transporter, ATP-binding/permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(66572, NULL, 'G3DSA:2.60.40.60:FF:001090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66573, NULL, 'G3DSA:1.10.3470.10:FF:000055', NULL, NULL, 'Probable metal transport system membrane protein CT_417', NULL, NULL, NULL, NULL, NULL, 4),
(66574, NULL, 'G3DSA:2.20.120.10:FF:000001', NULL, NULL, 'Lysozyme', NULL, NULL, NULL, NULL, NULL, 4),
(66575, NULL, 'G3DSA:2.60.40.60:FF:000628', NULL, NULL, 'Cadherin-related neuronal receptor 10', NULL, NULL, NULL, NULL, NULL, 4),
(66576, NULL, 'G3DSA:2.40.128.620:FF:000001', NULL, NULL, 'neuropilin and tolloid-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(66577, NULL, 'G3DSA:3.30.160.60:FF:002766', NULL, NULL, 'Zinc finger protein 227-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(66578, NULL, 'G3DSA:2.30.29.240:FF:000017', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(66579, NULL, 'G3DSA:3.30.56.10:FF:000031', NULL, NULL, 'Putative phenylalanyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(66580, NULL, 'G3DSA:3.30.70.330:FF:001888', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66581, NULL, 'G3DSA:2.60.40.2860:FF:000005', NULL, NULL, 'Transmission-blocking target antigen s230', NULL, NULL, NULL, NULL, NULL, 4),
(66582, NULL, 'G3DSA:1.20.1250.20:FF:000084', NULL, NULL, 'Synaptic vesicle 2-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(66583, NULL, 'G3DSA:2.130.10.10:FF:001530', NULL, NULL, 'Splicing factor 3b subunit 3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66584, NULL, 'G3DSA:3.30.160.20:FF:000141', NULL, NULL, 'Double-stranded RNA-binding domain (DsRBD)-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(66585, NULL, 'G3DSA:3.20.100.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66586, NULL, 'G3DSA:3.40.50.720:FF:002252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66587, NULL, 'G3DSA:3.40.1440.60:FF:000008', NULL, NULL, 'Primosomal protein N''', NULL, NULL, NULL, NULL, NULL, 4),
(66588, NULL, 'G3DSA:3.30.70.330:FF:002714', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66589, NULL, 'G3DSA:3.40.50.1820:FF:000821', NULL, NULL, 'Protein-tyrosine phosphatase-like protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(66590, NULL, 'G3DSA:2.40.128.630:FF:000004', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(66591, NULL, 'G3DSA:3.40.47.10:FF:000116', NULL, NULL, 'GumO', NULL, NULL, NULL, NULL, NULL, 4),
(66592, NULL, 'G3DSA:3.40.50.300:FF:006718', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66593, NULL, 'G3DSA:3.40.50.300:FF:000558', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(66594, NULL, 'G3DSA:3.40.50.1370:FF:000006', NULL, NULL, 'Aspartate carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(66595, NULL, 'G3DSA:3.40.640.10:FF:000369', NULL, NULL, 'Ornithine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(66596, NULL, 'G3DSA:3.30.160.60:FF:006465', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66597, NULL, 'G3DSA:3.30.40.10:FF:000236', NULL, NULL, 'Lysine-specific demethylase 4A', NULL, NULL, NULL, NULL, NULL, 4),
(66598, NULL, 'G3DSA:3.10.520.10:FF:000002', NULL, NULL, 'NADH-dependent fumarate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(66599, NULL, 'G3DSA:3.40.50.1380:FF:000009', NULL, NULL, 'Carbamoyl-phosphate synthase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(66600, NULL, 'G3DSA:3.30.900.10:FF:000004', NULL, NULL, 'Mitotic spindle checkpoint protein MAD2', NULL, NULL, NULL, NULL, NULL, 4),
(66601, NULL, 'G3DSA:1.10.286.10:FF:000009', NULL, NULL, 'GTP cyclohydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(66602, NULL, 'G3DSA:1.10.760.10:FF:000078', NULL, NULL, 'Similar to c-type cytochrome', NULL, NULL, NULL, NULL, NULL, 4),
(66603, NULL, 'G3DSA:1.25.10.10:FF:002909', NULL, NULL, 'Armadillo repeat-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66604, NULL, 'G3DSA:2.60.40.10:FF:001552', NULL, NULL, 'PKHD1 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(66605, NULL, 'G3DSA:3.90.228.20:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66606, NULL, 'G3DSA:3.40.50.720:FF:000644', NULL, NULL, 'NAD dependent epimerase/dehydratase family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66607, NULL, 'G3DSA:3.30.450.20:FF:000051', NULL, NULL, 'Cell wall metabolism sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(66608, NULL, 'G3DSA:3.10.180.10:FF:000065', NULL, NULL, 'Methylmalonyl-CoA epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(66609, NULL, 'G3DSA:2.60.120.10:FF:000689', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66610, NULL, 'G3DSA:2.60.40.420:FF:000164', NULL, NULL, 'Coagulation factor VIII, procoagulant component', NULL, NULL, NULL, NULL, NULL, 4),
(66611, NULL, 'G3DSA:3.30.710.10:FF:000304', NULL, NULL, 'SKp1 Related (Ubiquitin ligase complex component)', NULL, NULL, NULL, NULL, NULL, 4),
(66612, NULL, 'G3DSA:1.10.1070.11:FF:000076', NULL, NULL, 'Phosphatidylinositol 4-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(66613, NULL, 'G3DSA:3.40.50.10050:FF:000018', NULL, NULL, 'Translational initiation factor IF2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66614, NULL, 'G3DSA:2.30.29.230:FF:000014', NULL, NULL, 'TBC1 domain family, member 17', NULL, NULL, NULL, NULL, NULL, 4),
(66615, NULL, 'G3DSA:2.40.50.140:FF:000441', NULL, NULL, 'ATP-dependent DNA helicase RecG', NULL, NULL, NULL, NULL, NULL, 4),
(66616, NULL, 'G3DSA:3.40.630.10:FF:000088', NULL, NULL, 'Peptidase M20', NULL, NULL, NULL, NULL, NULL, 4),
(66617, NULL, 'G3DSA:1.10.1870.10:FF:000001', NULL, NULL, 'Alpha-aminoadipic semialdehyde synthase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(66618, NULL, 'G3DSA:1.10.287.70:FF:000400', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66619, NULL, 'G3DSA:1.10.220.150:FF:000026', NULL, NULL, 'GTPase activating protein for Arf, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66620, NULL, 'G3DSA:3.30.450.30:FF:000054', NULL, NULL, 'Dynein light chain roadblock', NULL, NULL, NULL, NULL, NULL, 4),
(66621, NULL, 'G3DSA:3.30.450.40:FF:000057', NULL, NULL, 'Two-component system sensor molecule', NULL, NULL, NULL, NULL, NULL, 4),
(66622, NULL, 'G3DSA:1.10.10.10:FF:000931', NULL, NULL, 'Cullin family protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(66623, NULL, 'G3DSA:3.10.310.10:FF:000065', NULL, NULL, 'Proline racemase', NULL, NULL, NULL, NULL, NULL, 4),
(66624, NULL, 'G3DSA:1.10.287.370:FF:000001', NULL, NULL, 'Prefoldin subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(66625, NULL, 'G3DSA:1.10.1040.10:FF:000005', NULL, NULL, 'Ketol-acid reductoisomerase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(66626, NULL, 'G3DSA:1.25.40.10:FF:004328', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66627, NULL, 'G3DSA:1.10.287.380:FF:000004', NULL, NULL, 'Valine--tRNA ligase mitochondrial 1', NULL, NULL, NULL, NULL, NULL, 4),
(66628, NULL, 'G3DSA:3.40.50.1980:FF:000083', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(66629, NULL, 'G3DSA:3.30.1490.80:FF:000020', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(66630, NULL, 'G3DSA:3.30.420.40:FF:000555', NULL, NULL, 'Hexokinase-1', NULL, NULL, NULL, NULL, NULL, 4),
(66631, NULL, 'G3DSA:3.90.1150.160:FF:000009', NULL, NULL, 'Glutamate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(66632, NULL, 'G3DSA:2.60.40.10:FF:002980', NULL, NULL, 'AGAP011650-PA', NULL, NULL, NULL, NULL, NULL, 4),
(66633, NULL, 'G3DSA:1.10.287.110:FF:000087', NULL, NULL, 'DnaJ homolog subfamily C member 4', NULL, NULL, NULL, NULL, NULL, 4),
(66634, NULL, 'G3DSA:3.80.10.10:FF:004026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66635, NULL, 'G3DSA:2.60.120.650:FF:000219', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(66636, NULL, 'G3DSA:1.25.40.20:FF:001105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66637, NULL, 'G3DSA:3.30.160.60:FF:005037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66638, NULL, 'G3DSA:3.30.70.330:FF:002361', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66639, NULL, 'G3DSA:1.10.287.130:FF:000160', NULL, NULL, 'Two-component system, OmpR family, sensor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(66640, NULL, 'G3DSA:3.30.1360.10:FF:000068', NULL, NULL, 'DNA-directed RNA polymerases II IV and V subunit 11', NULL, NULL, NULL, NULL, NULL, 4),
(66641, NULL, 'G3DSA:3.40.50.150:FF:000378', NULL, NULL, 'Phosphoethanolamine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(66642, NULL, 'G3DSA:3.10.20.580:FF:000002', NULL, NULL, 'Ribonuclease J', NULL, NULL, NULL, NULL, NULL, 4),
(66643, NULL, 'G3DSA:2.60.40.10:FF:004099', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66644, NULL, 'G3DSA:3.40.50.1000:FF:000368', NULL, NULL, 'Putative Alpha,alpha-trehalose-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(66645, NULL, 'G3DSA:2.60.120.650:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66646, NULL, 'G3DSA:1.25.10.10:FF:002691', NULL, NULL, 'Beta-adaptin-like protein C', NULL, NULL, NULL, NULL, NULL, 4),
(66647, NULL, 'G3DSA:2.160.20.80:FF:000010', NULL, NULL, 'Synaptic vesicle glycoprotein 2C', NULL, NULL, NULL, NULL, NULL, 4),
(66648, NULL, 'G3DSA:3.90.190.10:FF:000019', NULL, NULL, 'receptor-type tyrosine-protein phosphatase U isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(66649, NULL, 'G3DSA:3.50.50.60:FF:000099', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(66650, NULL, 'G3DSA:3.30.420.40:FF:001061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66651, NULL, 'G3DSA:1.10.10.2740:FF:000009', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(66652, NULL, 'G3DSA:3.50.7.10:FF:000025', NULL, NULL, 'TCP-1 chaperonin subunit zeta protein', NULL, NULL, NULL, NULL, NULL, 4),
(66653, NULL, 'G3DSA:2.30.30.60:FF:000005', NULL, NULL, 'Mechanosensitive ion channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(66654, NULL, 'G3DSA:3.40.50.2000:FF:000230', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(66655, NULL, 'G3DSA:1.25.40.10:FF:002193', NULL, NULL, 'Transcriptional activator CadC, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66656, NULL, 'G3DSA:3.40.50.300:FF:001064', NULL, NULL, 'Selenocysteine-specific translation elongation factor', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(66657, NULL, 'G3DSA:1.10.220.30:FF:000032', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(66658, NULL, 'G3DSA:2.60.120.200:FF:000080', NULL, NULL, 'neurexin 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(66659, NULL, 'G3DSA:2.160.10.10:FF:000118', NULL, NULL, 'Kinesin-8, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66660, NULL, 'G3DSA:3.40.50.12780:FF:000045', NULL, NULL, 'Acetyl-CoA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66661, NULL, 'G3DSA:2.30.30.50:FF:000002', NULL, NULL, 'Ferredoxin-thioredoxin reductase, variable chain', NULL, NULL, NULL, NULL, NULL, 4),
(66662, NULL, 'G3DSA:3.40.50.620:FF:000070', NULL, NULL, 'Bifunctional glutamate/proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(66663, NULL, 'G3DSA:3.30.428.70:FF:000008', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(66664, NULL, 'G3DSA:1.10.400.10:FF:000057', NULL, NULL, 'Guanine nucleotide-binding protein subunit alpha-13', NULL, NULL, NULL, NULL, NULL, 4),
(66665, NULL, 'G3DSA:2.60.120.590:FF:000050', NULL, NULL, 'Alkylated DNA repair protein AlkB', NULL, NULL, NULL, NULL, NULL, 4),
(66666, NULL, 'G3DSA:1.10.510.10:FF:001228', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(66667, NULL, 'G3DSA:3.90.260.10:FF:000065', NULL, NULL, 'Chromosome 15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(66668, NULL, 'G3DSA:3.40.50.720:FF:000318', NULL, NULL, 'ADP-ribosyl cyclase/cyclic ADP-ribose hydrolase 2', NULL, NULL, NULL, NULL, NULL, 4),
(66669, NULL, 'G3DSA:2.10.25.10:FF:001429', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66670, NULL, 'G3DSA:3.30.40.10:FF:002170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66671, NULL, 'G3DSA:3.40.850.10:FF:000306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66672, NULL, 'G3DSA:3.80.10.10:FF:001755', NULL, NULL, 'Disease resistance protein RPS5', NULL, NULL, NULL, NULL, NULL, 4),
(66673, NULL, 'G3DSA:3.40.50.1470:FF:000003', NULL, NULL, 'Peptidyl-tRNA hydrolase 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(66674, NULL, 'G3DSA:2.60.40.10:FF:001226', NULL, NULL, 'protein turtle isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(66675, NULL, 'G3DSA:3.40.50.2300:FF:000229', NULL, NULL, 'Receptor-type adenylate cyclase GRESAG 4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66676, NULL, 'G3DSA:1.20.120.1490:FF:000005', NULL, NULL, 'Periplasmic protein cpxP, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66677, NULL, 'G3DSA:2.60.40.10:FF:004571', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66678, NULL, 'G3DSA:2.30.42.10:FF:000041', NULL, NULL, 'protein scribble homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(66679, NULL, 'G3DSA:3.80.10.10:FF:003537', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66680, NULL, 'G3DSA:1.10.441.10:FF:000011', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(66681, NULL, 'G3DSA:3.60.15.10:FF:000126', NULL, NULL, 'Glyoxylase, beta-lactamase superfamily II', NULL, NULL, NULL, NULL, NULL, 4),
(66682, NULL, 'G3DSA:3.40.50.300:FF:007550', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66683, NULL, 'G3DSA:2.40.50.180:FF:000020', NULL, NULL, 'Chemotaxis protein CheZ', NULL, NULL, NULL, NULL, NULL, 4),
(66684, NULL, 'G3DSA:2.60.40.10:FF:000737', NULL, NULL, 'brother of CDO isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(66685, NULL, 'G3DSA:2.10.25.10:FF:000018', NULL, NULL, 'Delta-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(66686, NULL, 'G3DSA:3.30.300.30:FF:000133', NULL, NULL, 'Ferrichrome siderophore peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(66687, NULL, 'G3DSA:3.30.200.20:FF:000549', NULL, NULL, 'hydroxylysine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(66688, NULL, 'G3DSA:1.25.40.20:FF:001094', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(66689, NULL, 'G3DSA:1.25.40.10:FF:001102', NULL, NULL, 'Pentatricopeptide repeat domain 1', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(66690, NULL, 'G3DSA:3.30.230.10:FF:000048', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(66691, NULL, 'G3DSA:1.20.1560.10:FF:000065', NULL, NULL, 'ABC transporter ATP-binding protein/permease', NULL, NULL, NULL, NULL, NULL, 4),
(66692, NULL, 'G3DSA:1.25.40.10:FF:001091', NULL, NULL, 'Os11g0213500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(66693, NULL, 'G3DSA:1.25.40.990:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66694, NULL, 'G3DSA:1.10.287.70:FF:000080', NULL, NULL, 'Glutamate receptor ionotropic, kainate', NULL, NULL, NULL, NULL, NULL, 4),
(66695, NULL, 'G3DSA:3.30.1060.10:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66696, NULL, 'G3DSA:1.10.238.10:FF:000595', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(66697, NULL, 'G3DSA:3.30.160.60:FF:001322', NULL, NULL, 'GLI family zinc finger 4', NULL, NULL, NULL, NULL, NULL, 4),
(66698, NULL, 'G3DSA:3.90.550.20:FF:000011', NULL, NULL, 'Mannosyl phosphorylinositol ceramide synthase SUR1', NULL, NULL, NULL, NULL, NULL, 4),
(66699, NULL, 'G3DSA:3.10.120.10:FF:000039', NULL, NULL, 'Nitrate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(66700, NULL, 'G3DSA:3.40.50.720:FF:000009', NULL, NULL, 'Fatty oxidation complex, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(66701, NULL, 'G3DSA:2.130.10.10:FF:004756', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66702, NULL, 'G3DSA:3.40.50.150:FF:000687', NULL, NULL, 'Methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66703, NULL, 'G3DSA:2.60.210.10:FF:000016', NULL, NULL, 'Ubiquitin-specific protease', NULL, NULL, NULL, NULL, NULL, 4),
(66704, NULL, 'G3DSA:1.25.10.10:FF:001600', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66705, NULL, 'G3DSA:1.10.238.10:FF:000915', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(66706, NULL, 'G3DSA:2.160.20.10:FF:000046', NULL, NULL, 'Polygalacturonase QRT3', NULL, NULL, NULL, NULL, NULL, 4),
(66707, NULL, 'G3DSA:2.130.10.10:FF:002295', NULL, NULL, 'Vacuolar protein sorting-associated protein 39 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(66708, NULL, 'G3DSA:1.10.1670.10:FF:000036', NULL, NULL, 'Endonuclease III homolog', NULL, NULL, NULL, NULL, NULL, 4),
(66709, NULL, 'G3DSA:3.40.1110.10:FF:000250', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66710, NULL, 'G3DSA:3.40.50.300:FF:005072', NULL, NULL, 'Ras-related protein Rab-6A', NULL, NULL, NULL, NULL, NULL, 4),
(66711, NULL, 'G3DSA:2.170.150.10:FF:000029', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(66712, NULL, 'G3DSA:1.20.1730.10:FF:000011', NULL, NULL, 'sodium-dependent multivitamin transporter isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(66713, NULL, 'G3DSA:3.60.60.10:FF:000011', NULL, NULL, 'Bile salt hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(66714, NULL, 'G3DSA:3.40.850.10:FF:000441', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(66715, NULL, 'G3DSA:2.130.10.10:FF:004739', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66716, NULL, 'G3DSA:3.80.10.10:FF:003672', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66717, NULL, 'G3DSA:2.60.260.20:FF:000073', NULL, NULL, 'DnaJ homolog, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(66718, NULL, 'G3DSA:3.40.30.10:FF:001275', NULL, NULL, 'AGAP000044-PA', NULL, NULL, NULL, NULL, NULL, 4),
(66719, NULL, 'G3DSA:3.40.50.300:FF:003508', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(66720, NULL, 'G3DSA:3.30.70.2510:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66721, NULL, 'G3DSA:3.10.180.10:FF:000048', NULL, NULL, '4-hydroxyphenylpyruvate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(66722, NULL, 'G3DSA:1.20.1250.20:FF:001495', NULL, NULL, 'Zgc:171501', NULL, NULL, NULL, NULL, NULL, 4),
(66723, NULL, 'G3DSA:3.40.190.10:FF:000733', NULL, NULL, 'Proline/glycine betaine ABC superfamily ATP binding cassette transporter, membrane protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(66724, NULL, 'G3DSA:1.20.900.10:FF:000031', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(66725, NULL, 'G3DSA:3.60.15.10:FF:000143', NULL, NULL, 'MBL fold metallo-hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(66726, NULL, 'G3DSA:3.40.50.300:FF:003172', NULL, NULL, 'Katanin p60 ATPase-containing subunit A1', NULL, NULL, NULL, NULL, NULL, 4),
(66727, NULL, 'G3DSA:3.10.20.90:FF:000389', NULL, NULL, 'Os10g0200000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(66728, NULL, 'G3DSA:2.10.25.10:FF:001738', NULL, NULL, 'FEEL-1', NULL, NULL, NULL, NULL, NULL, 4),
(66729, NULL, 'G3DSA:2.60.120.260:FF:000535', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66730, NULL, 'G3DSA:3.60.130.10:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66731, NULL, 'G3DSA:3.30.70.660:FF:000003', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(66732, NULL, 'G3DSA:3.40.50.1220:FF:000057', NULL, NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(66733, NULL, 'G3DSA:3.40.50.150:FF:001221', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66734, NULL, 'G3DSA:1.10.3170.10:FF:000010', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(66735, NULL, 'G3DSA:3.30.70.330:FF:002731', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66736, NULL, 'G3DSA:1.10.10.10:FF:000594', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(66737, NULL, 'G3DSA:3.90.1300.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66738, NULL, 'G3DSA:3.40.50.2300:FF:000185', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(66739, NULL, 'G3DSA:3.30.160.60:FF:006482', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66740, NULL, 'G3DSA:1.10.287.70:FF:000063', NULL, NULL, 'ATP-sensitive inward rectifier potassium channel 14', NULL, NULL, NULL, NULL, NULL, 4),
(66741, NULL, 'G3DSA:2.120.10.80:FF:000096', NULL, NULL, 'Dynein heavy chain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(66742, NULL, 'G3DSA:2.130.10.30:FF:000125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66743, NULL, 'G3DSA:2.60.120.260:FF:000670', NULL, NULL, 'Beta-mannanase', NULL, NULL, NULL, NULL, NULL, 4),
(66744, NULL, 'G3DSA:1.10.600.10:FF:000038', NULL, NULL, '(2E,6E)-farnesyl diphosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(66745, NULL, 'G3DSA:3.40.50.410:FF:000006', NULL, NULL, 'voltage-dependent calcium channel subunit alpha-2/delta-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(66746, NULL, 'G3DSA:1.10.800.10:FF:000020', NULL, NULL, 'Tyrosine 3-monooxygenase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(66747, NULL, 'G3DSA:1.10.10.60:FF:000693', NULL, NULL, 'Reproductive homeobox 3A', NULL, NULL, NULL, NULL, NULL, 4),
(66748, NULL, 'G3DSA:2.60.40.60:FF:000937', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66749, NULL, 'G3DSA:4.10.80.100:FF:000001', NULL, NULL, 'Nucleoside diphosphate-linked moiety X motif 6', NULL, NULL, NULL, NULL, NULL, 4),
(66750, NULL, 'G3DSA:3.40.250.10:FF:000103', NULL, NULL, 'Rodhanase family domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(66751, NULL, 'G3DSA:3.40.190.10:FF:000087', NULL, NULL, 'glutamate receptor 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(66752, NULL, 'G3DSA:1.20.1070.10:FF:001764', NULL, NULL, 'Olfactory receptor 61', NULL, NULL, NULL, NULL, NULL, 4),
(66753, NULL, 'G3DSA:3.30.565.10:FF:000365', NULL, NULL, 'Heat shock protein 75 kDa, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(66754, NULL, 'G3DSA:1.10.510.10:FF:004438', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66755, NULL, 'G3DSA:1.10.510.10:FF:000739', NULL, NULL, 'CAMK/CDPK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(66756, NULL, 'G3DSA:3.30.70.1230:FF:000012', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(66757, NULL, 'G3DSA:3.30.260.10:FF:000022', NULL, NULL, 'T-complex protein 1 subunit eta', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(66758, NULL, 'G3DSA:3.40.50.150:FF:001513', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66759, NULL, 'G3DSA:3.30.200.20:FF:002483', NULL, NULL, 'Myosin light chain kinase b', NULL, NULL, NULL, NULL, NULL, 4),
(66760, NULL, 'G3DSA:2.30.30.100:FF:000157', NULL, NULL, 'Small nuclear ribonucleoprotein E', NULL, NULL, NULL, NULL, NULL, 4),
(66761, NULL, 'G3DSA:3.60.140.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66762, NULL, 'G3DSA:3.30.160.60:FF:004874', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66763, NULL, 'G3DSA:3.30.1370.10:FF:000007', NULL, NULL, 'far upstream element-binding protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(66764, NULL, 'G3DSA:1.20.1070.10:FF:001629', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(66765, NULL, 'G3DSA:1.10.1070.11:FF:000059', NULL, NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(66766, NULL, 'G3DSA:2.130.10.10:FF:003121', NULL, NULL, 'Eukaryotic translation initiation factor 2A', NULL, NULL, NULL, NULL, NULL, 4),
(66767, NULL, 'G3DSA:3.90.226.10:FF:000339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66768, NULL, 'G3DSA:3.50.50.60:FF:000571', NULL, NULL, 'Rab geranylgeranyl transferase component A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66769, NULL, 'G3DSA:1.25.40.10:FF:004345', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(66770, NULL, 'G3DSA:1.20.120.1900:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66771, NULL, 'G3DSA:3.30.360.10:FF:000069', NULL, NULL, 'Saccharopine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(66772, NULL, 'G3DSA:3.40.309.10:FF:000105', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(66773, NULL, 'G3DSA:1.10.1040.10:FF:000022', NULL, NULL, '3-sulfolactaldehyde reductase', NULL, NULL, NULL, NULL, NULL, 4),
(66774, NULL, 'G3DSA:1.20.1560.10:FF:000391', NULL, NULL, 'Lipid A export ATP-binding/permease protein MsbA', NULL, NULL, NULL, NULL, NULL, 4),
(66775, NULL, 'G3DSA:3.90.1150.10:FF:000286', NULL, NULL, 'Gamma-aminobutyrate transaminase POP2 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(66776, NULL, 'G3DSA:3.90.660.20:FF:000014', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(66777, NULL, 'G3DSA:3.40.50.300:FF:000867', NULL, NULL, 'Caspase recruitment domain family member 10', NULL, NULL, NULL, NULL, NULL, 4),
(66778, NULL, 'G3DSA:3.40.50.720:FF:001763', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66779, NULL, 'G3DSA:2.30.29.30:FF:000055', NULL, NULL, 'Phosphatidylinositol 3,4,5-trisphosphate-dependent Rac exchanger 1 protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(66780, NULL, 'G3DSA:3.40.50.880:FF:000097', NULL, NULL, 'Imidazole glycerol phosphate synthase subunit HisH', NULL, NULL, NULL, NULL, NULL, 4),
(66781, NULL, 'G3DSA:2.120.10.30:FF:000558', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66782, NULL, 'G3DSA:3.30.70.270:FF:000302', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66783, NULL, 'G3DSA:3.30.230.10:FF:000374', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66784, NULL, 'G3DSA:3.40.1230.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66785, NULL, 'G3DSA:3.40.800.10:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66786, NULL, 'G3DSA:3.30.160.60:FF:005054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66787, NULL, 'G3DSA:3.30.479.30:FF:000035', NULL, NULL, 'Flotillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(66788, NULL, 'G3DSA:1.20.5.4010:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66789, NULL, 'G3DSA:3.40.630.50:FF:000004', NULL, NULL, 'D-aminoacyl-tRNA deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(66790, NULL, 'G3DSA:3.30.200.20:FF:000875', NULL, NULL, 'Protein kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(66791, NULL, 'G3DSA:2.70.170.10:FF:000246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(66792, NULL, 'G3DSA:3.90.550.10:FF:000593', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66793, NULL, 'G3DSA:3.60.70.12:FF:000014', NULL, NULL, 'Glutamate N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(66794, NULL, 'G3DSA:1.10.8.10:FF:000143', NULL, NULL, 'Protein Gawky', NULL, NULL, NULL, NULL, NULL, 4),
(66795, NULL, 'G3DSA:3.40.50.1000:FF:000385', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66796, NULL, 'G3DSA:3.40.50.720:FF:002561', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66797, NULL, 'G3DSA:3.30.70.3250:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66798, NULL, 'G3DSA:2.130.10.10:FF:001221', NULL, NULL, 'Tusp, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(66799, NULL, 'G3DSA:3.90.660.10:FF:000011', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(66800, NULL, 'G3DSA:3.50.7.10:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66801, NULL, 'G3DSA:3.40.50.1580:FF:000053', NULL, NULL, 'Purine nucleoside phosphorylase 4b', NULL, NULL, NULL, NULL, NULL, 4),
(66802, NULL, 'G3DSA:3.30.160.60:FF:000849', NULL, NULL, 'Zinc finger protein 408', NULL, NULL, NULL, NULL, NULL, 4),
(66803, NULL, 'G3DSA:3.40.630.40:FF:000001', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(66804, NULL, 'G3DSA:1.25.40.10:FF:000938', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(66805, NULL, 'G3DSA:1.10.630.10:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66806, NULL, 'G3DSA:3.80.10.10:FF:000311', NULL, NULL, 'Chondroadherin-like a', NULL, NULL, NULL, NULL, NULL, 4),
(66807, NULL, 'G3DSA:3.30.420.10:FF:000411', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66808, NULL, 'G3DSA:1.25.40.10:FF:000629', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(66809, NULL, 'G3DSA:1.10.10.60:FF:001210', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66810, NULL, 'G3DSA:1.10.510.10:FF:001021', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(66811, NULL, 'G3DSA:3.10.290.70:FF:000012', NULL, NULL, '40S ribosomal protein S8', NULL, NULL, NULL, NULL, NULL, 4),
(66812, NULL, 'G3DSA:1.25.40.10:FF:002546', NULL, NULL, 'Os08g0340900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(66813, NULL, 'G3DSA:3.60.40.10:FF:000111', NULL, NULL, 'Probable protein phosphatase 2C 75', NULL, NULL, NULL, NULL, NULL, 4),
(66814, NULL, 'G3DSA:3.40.630.10:FF:000234', NULL, NULL, 'Os07g0249900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(66815, NULL, 'G3DSA:3.10.10.10:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66816, NULL, 'G3DSA:2.40.70.10:FF:000493', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66817, NULL, 'G3DSA:3.40.390.10:FF:000035', NULL, NULL, 'Matrix metallopeptidase 27', NULL, NULL, NULL, NULL, NULL, 4),
(66818, NULL, 'G3DSA:3.40.50.1240:FF:000209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66819, NULL, 'G3DSA:3.30.530.20:FF:000198', NULL, NULL, 'Protein retinal degeneration B-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(66820, NULL, 'G3DSA:1.20.1250.20:FF:002236', NULL, NULL, 'Os03g0235300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(66821, NULL, 'G3DSA:3.40.50.1820:FF:000512', NULL, NULL, 'Probable serine hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(66822, NULL, 'G3DSA:1.20.920.10:FF:000122', NULL, NULL, 'Polybromo 1', NULL, NULL, NULL, NULL, NULL, 4),
(66823, NULL, 'G3DSA:3.40.50.300:FF:001710', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(66824, NULL, 'G3DSA:2.60.120.200:FF:000124', NULL, NULL, 'Galectin-4', NULL, NULL, NULL, NULL, NULL, 4),
(66825, NULL, 'G3DSA:2.60.410.10:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66826, NULL, 'G3DSA:2.60.120.260:FF:000209', NULL, NULL, 'E3 ubiquitin-protein ligase highwire', NULL, NULL, NULL, NULL, NULL, 4),
(66827, NULL, 'G3DSA:1.10.486.10:FF:000007', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(66828, NULL, 'G3DSA:3.50.50.60:FF:000806', NULL, NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(66829, NULL, 'G3DSA:3.40.50.720:FF:000335', NULL, NULL, 'Peroxisomal trans-2-enoyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(66830, NULL, 'G3DSA:1.10.150.20:FF:000085', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(66831, NULL, 'G3DSA:1.25.40.20:FF:001801', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66832, NULL, 'G3DSA:3.30.160.60:FF:002749', NULL, NULL, 'Zinc finger protein 518A', NULL, NULL, NULL, NULL, NULL, 4),
(66833, NULL, 'G3DSA:2.30.29.30:FF:000038', NULL, NULL, 'Myotubularin 1, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(66834, NULL, 'G3DSA:1.10.287.770:FF:000014', NULL, NULL, 'Nach, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(66835, NULL, 'G3DSA:2.40.50.140:FF:000665', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66836, NULL, 'G3DSA:2.40.30.110:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66837, NULL, 'G3DSA:3.30.40.10:FF:000371', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(66838, NULL, 'G3DSA:1.20.1050.10:FF:000318', NULL, NULL, 'tRNA binding domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(66839, NULL, 'G3DSA:3.20.20.100:FF:000182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66840, NULL, 'G3DSA:3.40.50.720:FF:001746', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(66841, NULL, 'G3DSA:2.130.10.10:FF:002941', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66842, NULL, 'G3DSA:2.20.70.10:FF:000140', NULL, NULL, 'GL18629', NULL, NULL, NULL, NULL, NULL, 4),
(66843, NULL, 'G3DSA:2.120.10.30:FF:000575', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66844, NULL, 'G3DSA:2.40.70.10:FF:000184', NULL, NULL, 'Peptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66845, NULL, 'G3DSA:3.80.10.10:FF:002109', NULL, NULL, 'Si:dkey-1h4.4', NULL, NULL, NULL, NULL, NULL, 4),
(66846, NULL, 'G3DSA:3.40.50.720:FF:002235', NULL, NULL, 'uncharacterized protein LOC100178832', NULL, NULL, NULL, NULL, NULL, 4),
(66847, NULL, 'G3DSA:3.90.190.20:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66848, NULL, 'G3DSA:3.50.50.60:FF:000880', NULL, NULL, 'FAD-dependent oxidoreductase domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(66849, NULL, 'G3DSA:1.20.58.1420:FF:000004', NULL, NULL, 'COPI vesicle fusion protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66850, NULL, 'G3DSA:3.90.640.10:FF:000111', NULL, NULL, 'Heat shock protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66851, NULL, 'G3DSA:1.20.58.60:FF:000510', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66852, NULL, 'G3DSA:1.25.40.10:FF:004800', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66853, NULL, 'G3DSA:3.30.1060.10:FF:000006', NULL, NULL, 'Peptide methionine sulfoxide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(66854, NULL, 'G3DSA:1.10.150.240:FF:000109', NULL, NULL, 'HAD superfamily hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(66855, NULL, 'G3DSA:2.40.30.130:FF:000029', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(66856, NULL, 'G3DSA:1.25.40.990:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66857, NULL, 'G3DSA:3.40.50.970:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66858, NULL, 'G3DSA:3.40.50.1580:FF:000070', NULL, NULL, 'Purine nucleoside phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(66859, NULL, 'G3DSA:3.90.550.10:FF:000267', NULL, NULL, 'Probable glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(66860, NULL, 'G3DSA:1.25.40.570:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66861, NULL, 'G3DSA:3.40.50.300:FF:007224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(66862, NULL, 'G3DSA:1.10.357.10:FF:000079', NULL, NULL, 'TetR/AcrR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(66863, NULL, 'G3DSA:2.130.10.10:FF:002278', NULL, NULL, 'General transcription factor IIIC, polypeptide 2, beta', NULL, NULL, NULL, NULL, NULL, 4),
(66864, NULL, 'G3DSA:3.30.230.10:FF:000065', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(66865, NULL, 'G3DSA:1.10.1670.10:FF:000019', NULL, NULL, 'Endonuclease III', NULL, NULL, NULL, NULL, NULL, 4),
(66866, NULL, 'G3DSA:3.30.200.20:FF:000566', NULL, NULL, 'Phytosulfokine receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(66867, NULL, 'G3DSA:3.90.70.40:FF:000014', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(66868, NULL, 'G3DSA:3.40.30.10:FF:000010', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(66869, NULL, 'G3DSA:3.40.50.300:FF:006735', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66870, NULL, 'G3DSA:3.40.50.10810:FF:000275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66871, NULL, 'G3DSA:1.20.120.1880:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66872, NULL, 'G3DSA:3.40.50.300:FF:003301', NULL, NULL, 'Helicase/secretion CpaE-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(66873, NULL, 'G3DSA:3.10.100.10:FF:000291', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66874, NULL, 'G3DSA:3.10.129.10:FF:000255', NULL, NULL, 'Hydroxyacyl-thioester dehydratase type 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(66875, NULL, 'G3DSA:1.10.220.150:FF:000043', NULL, NULL, 'ARF GAP', NULL, NULL, NULL, NULL, NULL, 4),
(66876, NULL, 'G3DSA:1.20.1560.10:FF:000211', NULL, NULL, 'Ste6p', NULL, NULL, NULL, NULL, NULL, 4),
(66877, NULL, 'G3DSA:2.60.40.2960:FF:000002', NULL, NULL, 'Type 2 DNA topoisomerase 6 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(66878, NULL, 'G3DSA:1.10.10.60:FF:000367', NULL, NULL, 'homeobox even-skipped homolog protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(66879, NULL, 'G3DSA:3.30.420.40:FF:000908', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66880, NULL, 'G3DSA:2.130.10.10:FF:004094', NULL, NULL, 'WD repeat-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(66881, NULL, 'G3DSA:3.30.450.20:FF:000242', NULL, NULL, 'Cyclic di-GMP phosphodiesterase Gmr', NULL, NULL, NULL, NULL, NULL, 4),
(66882, NULL, 'G3DSA:3.40.1090.10:FF:000028', NULL, NULL, 'Patatin', NULL, NULL, NULL, NULL, NULL, 4),
(66883, NULL, 'G3DSA:1.20.1070.10:FF:000320', NULL, NULL, 'Pteropsin4', NULL, NULL, NULL, NULL, NULL, 4),
(66884, NULL, 'G3DSA:3.40.50.300:FF:005633', NULL, NULL, 'YTH domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(66885, NULL, 'G3DSA:3.40.50.920:FF:000053', NULL, NULL, 'Protein CBR-TAG-173', NULL, NULL, NULL, NULL, NULL, 4),
(66886, NULL, 'G3DSA:1.25.10.10:FF:002718', NULL, NULL, 'Protein CBG09629', NULL, NULL, NULL, NULL, NULL, 4),
(66887, NULL, 'G3DSA:3.40.190.10:FF:000750', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(66888, NULL, 'G3DSA:3.90.70.10:FF:000808', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66889, NULL, 'G3DSA:3.50.50.60:FF:000245', NULL, NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(66890, NULL, 'G3DSA:3.30.1050.10:FF:000051', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(66891, NULL, 'G3DSA:1.10.30.10:FF:000168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66892, NULL, 'G3DSA:3.10.490.10:FF:000049', NULL, NULL, 'Putative gamma-glutamylcyclotransferase MJ1514', NULL, NULL, NULL, NULL, NULL, 4),
(66893, NULL, 'G3DSA:2.60.40.1400:FF:000012', NULL, NULL, 'Inward rectifier potassium channel 16', NULL, NULL, NULL, NULL, NULL, 4),
(66894, NULL, 'G3DSA:3.40.50.150:FF:001204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66895, NULL, 'G3DSA:3.30.420.110:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(66896, NULL, 'G3DSA:1.10.10.1760:FF:000013', NULL, NULL, '60S ribosomal protein L36', NULL, NULL, NULL, NULL, NULL, 4),
(66897, NULL, 'G3DSA:2.10.25.10:FF:001755', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66898, NULL, 'G3DSA:3.30.70.330:FF:000444', NULL, NULL, 'Zinc finger CCCH domain-containing protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(66899, NULL, 'G3DSA:3.40.640.10:FF:000471', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(66900, NULL, 'G3DSA:2.60.120.650:FF:000236', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(66901, NULL, 'G3DSA:2.60.40.60:FF:000954', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(66902, NULL, 'G3DSA:1.25.40.10:FF:004980', NULL, NULL, 'Developmental protein DG1091', NULL, NULL, NULL, NULL, NULL, 4),
(66903, NULL, 'G3DSA:2.130.10.10:FF:000687', NULL, NULL, 'WD repeat domain 75', NULL, NULL, NULL, NULL, NULL, 4),
(66904, NULL, 'G3DSA:3.30.200.20:FF:002157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66905, NULL, 'G3DSA:1.10.10.60:FF:000676', NULL, NULL, 'Phosphoglycerate transport system transcriptional regulatory protein PgtA', NULL, NULL, NULL, NULL, NULL, 4),
(66906, NULL, 'G3DSA:3.40.50.10860:FF:000048', NULL, NULL, 'Bifunctional protein FolD', NULL, NULL, NULL, NULL, NULL, 4),
(66907, NULL, 'G3DSA:3.90.1140.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66908, NULL, 'G3DSA:3.80.10.10:FF:003981', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66909, NULL, 'G3DSA:3.90.190.10:FF:000036', NULL, NULL, 'Serine/threonine/tyrosine-interacting protein a', NULL, NULL, NULL, NULL, NULL, 4),
(66910, NULL, 'G3DSA:3.40.50.11500:FF:000015', NULL, NULL, 'DENN domain containing protein 2D', NULL, NULL, NULL, NULL, NULL, 4),
(66911, NULL, 'G3DSA:3.90.550.50:FF:000037', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(66912, NULL, 'G3DSA:3.40.50.300:FF:001401', NULL, NULL, 'Dynein, axonemal, heavy chain 7', NULL, NULL, NULL, NULL, NULL, 4),
(66913, NULL, 'G3DSA:1.10.10.10:FF:000285', NULL, NULL, 'RNA polymerase sigma factor RpoH', NULL, NULL, NULL, NULL, NULL, 4),
(66914, NULL, 'G3DSA:3.90.79.10:FF:000199', NULL, NULL, 'diphosphoinositol polyphosphate phosphohydrolase 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(66915, NULL, 'G3DSA:3.40.50.1860:FF:000013', NULL, NULL, 'Glutamate racemase', NULL, NULL, NULL, NULL, NULL, 4),
(66916, NULL, 'G3DSA:1.25.40.10:FF:004671', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66917, NULL, 'G3DSA:3.40.50.620:FF:000423', NULL, NULL, 'Electron transfer flavoprotein alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(66918, NULL, 'G3DSA:3.30.200.20:FF:002466', NULL, NULL, 'Receptor tyrosine-protein kinase erbB-4', NULL, NULL, NULL, NULL, NULL, 4),
(66919, NULL, 'G3DSA:2.130.10.10:FF:002839', NULL, NULL, 'Protein HIRA', NULL, NULL, NULL, NULL, NULL, 4),
(66920, NULL, 'G3DSA:2.130.10.10:FF:000378', NULL, NULL, 'U3 small nucleolar RNA-associated protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(66921, NULL, 'G3DSA:2.20.25.100:FF:000003', NULL, NULL, '40S ribosomal protein S27', NULL, NULL, NULL, NULL, NULL, 4),
(66922, NULL, 'G3DSA:3.40.220.10:FF:000040', NULL, NULL, 'SNF2 family DNA-dependent ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(66923, NULL, 'G3DSA:3.30.200.20:FF:001977', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66924, NULL, 'G3DSA:1.20.1560.10:FF:000520', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66925, NULL, 'G3DSA:3.40.50.12780:FF:000062', NULL, NULL, 'Nonribosomal peptide synthetase gliP', NULL, NULL, NULL, NULL, NULL, 4),
(66926, NULL, 'G3DSA:2.60.34.10:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66927, NULL, 'G3DSA:2.60.120.200:FF:000433', NULL, NULL, 'Lectin family integral membrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66928, NULL, 'G3DSA:3.80.10.10:FF:001946', NULL, NULL, 'Phytosulfokine receptor 1', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(66929, NULL, 'G3DSA:3.40.50.150:FF:000833', NULL, NULL, 'Protein-L-isoaspartate O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(66930, NULL, 'G3DSA:2.10.25.10:FF:000002', NULL, NULL, 'Latent-transforming growth factor beta-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(66931, NULL, 'G3DSA:3.50.50.60:FF:000554', NULL, NULL, 'Glutamate synthase beta subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66932, NULL, 'G3DSA:1.25.40.10:FF:002754', NULL, NULL, 'CCR4-NOT transcription complex subunit 10, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66933, NULL, 'G3DSA:1.25.10.10:FF:001145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66934, NULL, 'G3DSA:3.20.20.80:FF:000306', NULL, NULL, 'Solute carrier family 3 member 2a', NULL, NULL, NULL, NULL, NULL, 4),
(66935, NULL, 'G3DSA:3.30.420.10:FF:000203', NULL, NULL, 'CAF1 family ribonuclease containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(66936, NULL, 'G3DSA:3.40.50.300:FF:004392', NULL, NULL, 'Small GTPase EhRabX16, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66937, NULL, 'G3DSA:3.30.460.10:FF:000211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66938, NULL, 'G3DSA:2.130.10.10:FF:000833', NULL, NULL, 'WD repeat-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(66939, NULL, 'G3DSA:3.75.10.10:FF:000008', NULL, NULL, 'Eukaryotic translation initiation factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(66940, NULL, 'G3DSA:3.30.497.10:FF:000173', NULL, NULL, 'Serpin peptidase inhibitor 26', NULL, NULL, NULL, NULL, NULL, 4),
(66941, NULL, 'G3DSA:3.30.70.20:FF:000084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66942, NULL, 'G3DSA:3.30.40.10:FF:001681', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(66943, NULL, 'G3DSA:2.60.200.20:FF:000182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66944, NULL, 'G3DSA:2.40.50.180:FF:000003', NULL, NULL, 'Chemotaxis protein CheV', NULL, NULL, NULL, NULL, NULL, 4),
(66945, NULL, 'G3DSA:3.40.190.10:FF:000615', NULL, NULL, 'Molybdate transport system substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(66946, NULL, 'G3DSA:3.30.470.20:FF:000142', NULL, NULL, 'Ribosomal protein S6 glutaminyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(66947, NULL, 'G3DSA:2.80.10.50:FF:000179', NULL, NULL, 'Fascin', NULL, NULL, NULL, NULL, NULL, 4),
(66948, NULL, 'G3DSA:2.30.29.30:FF:000072', NULL, NULL, 'Rho guanine nucleotide exchange factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(66949, NULL, 'G3DSA:2.60.40.10:FF:004554', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66950, NULL, 'G3DSA:2.60.40.10:FF:005060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66951, NULL, 'G3DSA:1.10.3640.10:FF:000001', NULL, NULL, 'Putative oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(66952, NULL, 'G3DSA:1.10.10.10:FF:002084', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(66953, NULL, 'G3DSA:2.60.40.10:FF:000754', NULL, NULL, 'Cytokine receptor common subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(66954, NULL, 'G3DSA:3.40.50.720:FF:002443', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66955, NULL, 'G3DSA:3.90.550.10:FF:000475', NULL, NULL, 'Flagellin modification protein', NULL, NULL, NULL, NULL, NULL, 4),
(66956, NULL, 'G3DSA:3.40.50.1580:FF:000036', NULL, NULL, 'Possible DNA repair photolyase', NULL, NULL, NULL, NULL, NULL, 4),
(66957, NULL, 'G3DSA:2.10.110.10:FF:000109', NULL, NULL, 'Lipoma preferred partner', NULL, NULL, NULL, NULL, NULL, 4),
(66958, NULL, 'G3DSA:3.30.43.10:FF:000035', NULL, NULL, 'FAD-linked oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(66959, NULL, 'G3DSA:3.30.160.60:FF:000288', NULL, NULL, 'Putative zinc finger protein 143', NULL, NULL, NULL, NULL, NULL, 4),
(66960, NULL, 'G3DSA:2.60.34.10:FF:000015', NULL, NULL, 'Molecular chaperone HscC', NULL, NULL, NULL, NULL, NULL, 4),
(66961, NULL, 'G3DSA:3.30.40.10:FF:000045', NULL, NULL, 'RING finger protein 113A', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(66962, NULL, 'G3DSA:3.10.20.90:FF:001024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66963, NULL, 'G3DSA:2.70.170.10:FF:000263', NULL, NULL, 'Acetylcholine receptor subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(66964, NULL, 'G3DSA:2.40.50.140:FF:000457', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(66965, NULL, 'G3DSA:1.25.10.10:FF:003180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66966, NULL, 'G3DSA:1.20.120.1780:FF:000002', NULL, NULL, '1,4-dihydroxy-2-naphthoate octaprenyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(66967, NULL, 'G3DSA:2.130.10.10:FF:005127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66968, NULL, 'G3DSA:3.30.60.30:FF:000159', NULL, NULL, 'Follistatin', NULL, NULL, NULL, NULL, NULL, 4),
(66969, NULL, 'G3DSA:1.20.1560.10:FF:000183', NULL, NULL, 'Cytochrome biosyntheisis ABC transporter ATP-binding protein/permease CydD', NULL, NULL, NULL, NULL, NULL, 4),
(66970, NULL, 'G3DSA:3.30.160.60:FF:002957', NULL, NULL, 'Zinc finger protein 625', NULL, NULL, NULL, NULL, NULL, 4),
(66971, NULL, 'G3DSA:3.30.70.330:FF:000135', NULL, NULL, 'RNA-binding protein 39 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(66972, NULL, 'G3DSA:1.20.1070.10:FF:002152', NULL, NULL, 'Adhesion G protein-coupled receptor E1', NULL, NULL, NULL, NULL, NULL, 4),
(66973, NULL, 'G3DSA:1.10.238.10:FF:000786', NULL, NULL, 'Mitochondrial substrate carrier family protein', NULL, NULL, NULL, NULL, NULL, 4),
(66974, NULL, 'G3DSA:2.40.70.10:FF:000419', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66975, NULL, 'G3DSA:2.30.29.30:FF:000173', NULL, NULL, 'Arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(66976, NULL, 'G3DSA:3.90.15.10:FF:000001', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(66977, NULL, 'G3DSA:3.40.50.2000:FF:000084', NULL, NULL, 'Digalactosyldiacylglycerol synthase 2 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(66978, NULL, 'G3DSA:1.10.150.20:FF:000293', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(66979, NULL, 'G3DSA:1.20.1250.20:FF:000230', NULL, NULL, 'Solute carrier family 45 member 3', NULL, NULL, NULL, NULL, NULL, 4),
(66980, NULL, 'G3DSA:3.40.50.300:FF:005425', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(66981, NULL, 'G3DSA:1.20.5.1930:FF:000011', NULL, NULL, 'GAF sensor signal transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(66982, NULL, 'G3DSA:2.60.120.200:FF:000107', NULL, NULL, 'Sex hormone-binding globulin', NULL, NULL, NULL, NULL, NULL, 4),
(66983, NULL, 'G3DSA:2.40.70.10:FF:000375', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(66984, NULL, 'G3DSA:3.20.20.80:FF:000407', NULL, NULL, 'Beta-glucosidase 47', NULL, NULL, NULL, NULL, NULL, 4),
(66985, NULL, 'G3DSA:1.20.1530.20:FF:000049', NULL, NULL, 'Na(+)/H(+) antiporter', NULL, NULL, NULL, NULL, NULL, 4),
(66986, NULL, 'G3DSA:3.40.50.10810:FF:000157', NULL, NULL, 'Putative SNF2 family helicase', NULL, NULL, NULL, NULL, NULL, 4),
(66987, NULL, 'G3DSA:3.50.50.60:FF:000453', NULL, NULL, 'Putative oxidoreductase TDA3', NULL, NULL, NULL, NULL, NULL, 4),
(66988, NULL, 'G3DSA:1.10.1370.10:FF:000007', NULL, NULL, 'Mitochondrial intermediate peptidase, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4),
(66989, NULL, 'G3DSA:3.40.50.410:FF:000214', NULL, NULL, 'ATP-dependent DNA helicase II subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(66990, NULL, 'G3DSA:3.40.50.1820:FF:001777', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66991, NULL, 'G3DSA:4.10.1000.10:FF:000141', NULL, NULL, 'tRNA-dihydrouridine(47) synthase [NAD(P)(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(66992, NULL, 'G3DSA:3.40.50.2000:FF:000128', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(66993, NULL, 'G3DSA:3.30.70.330:FF:002170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(66994, NULL, 'G3DSA:1.20.940.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66995, NULL, 'G3DSA:2.30.30.40:FF:000567', NULL, NULL, 'Rho GTPase-activating protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(66996, NULL, 'G3DSA:1.20.58.60:FF:000381', NULL, NULL, 'VAB-10B protein', NULL, NULL, NULL, NULL, NULL, 4),
(66997, NULL, 'G3DSA:2.30.230.10:FF:000029', NULL, NULL, 'Vitellogenin', NULL, NULL, NULL, NULL, NULL, 4),
(66998, NULL, 'G3DSA:1.20.200.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(66999, NULL, 'G3DSA:3.40.50.300:FF:004919', NULL, NULL, 'Ras-related protein RabT2', NULL, NULL, NULL, NULL, NULL, 4),
(67000, NULL, 'G3DSA:3.40.50.2300:FF:000230', NULL, NULL, 'Unplaced genomic scaffold supercont1.240, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(67001, NULL, 'G3DSA:3.90.470.10:FF:000002', NULL, NULL, '50S ribosomal protein L22', NULL, NULL, NULL, NULL, NULL, 4),
(67002, NULL, 'G3DSA:3.30.70.330:FF:000236', NULL, NULL, 'Polyadenylate-binding protein RBP45C', NULL, NULL, NULL, NULL, NULL, 4),
(67003, NULL, 'G3DSA:3.90.1150.10:FF:000432', NULL, NULL, 'Sphingosine-1-phosphate lyase 1', NULL, NULL, NULL, NULL, NULL, 4),
(67004, NULL, 'G3DSA:1.25.10.10:FF:002674', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67005, NULL, 'G3DSA:1.20.58.1520:FF:000001', NULL, NULL, 'Protein regulator of cytokinesis 1', NULL, NULL, NULL, NULL, NULL, 4),
(67006, NULL, 'G3DSA:1.10.8.100:FF:000023', NULL, NULL, 'Probable ribosomal RNA small subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(67007, NULL, 'G3DSA:1.10.1170.10:FF:000026', NULL, NULL, 'Baculoviral IAP repeat containing 6', NULL, NULL, NULL, NULL, NULL, 4),
(67008, NULL, 'G3DSA:3.40.30.10:FF:000786', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(67009, NULL, 'G3DSA:1.10.10.10:FF:001420', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(67010, NULL, 'G3DSA:2.60.120.1560:FF:000003', NULL, NULL, 'Epa1p', NULL, NULL, NULL, NULL, NULL, 4),
(67011, NULL, 'G3DSA:3.80.10.10:FF:003880', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67012, NULL, 'G3DSA:2.60.220.50:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67013, NULL, 'G3DSA:1.10.510.10:FF:003027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67014, NULL, 'G3DSA:1.20.1070.10:FF:000218', NULL, NULL, 'melanin-concentrating hormone receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(67015, NULL, 'G3DSA:3.40.50.2300:FF:000746', NULL, NULL, 'Metabotropic glutamate receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(67016, NULL, 'G3DSA:1.20.1250.20:FF:001747', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67017, NULL, 'G3DSA:3.40.50.1110:FF:000024', NULL, NULL, 'GDSL esterase/lipase At1g31550', NULL, NULL, NULL, NULL, NULL, 4),
(67018, NULL, 'G3DSA:3.80.10.10:FF:002452', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67019, NULL, 'G3DSA:1.10.3110.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67020, NULL, 'G3DSA:1.20.1070.10:FF:001646', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67021, NULL, 'G3DSA:3.40.640.10:FF:000515', NULL, NULL, 'Serine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(67022, NULL, 'G3DSA:3.30.470.20:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67023, NULL, 'G3DSA:1.20.1250.20:FF:000319', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(67024, NULL, 'G3DSA:3.60.140.10:FF:000006', NULL, NULL, 'YfiH family protein', NULL, NULL, NULL, NULL, NULL, 4),
(67025, NULL, 'G3DSA:3.30.230.10:FF:000402', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67026, NULL, 'G3DSA:3.40.50.300:FF:003200', NULL, NULL, 'DNA clamp loader, putative', NULL, NULL, NULL, NULL, NULL, 4),
(67027, NULL, 'G3DSA:3.30.830.10:FF:000268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(67028, NULL, 'G3DSA:3.40.50.10810:FF:000258', NULL, NULL, 'Excision repair cross-complementing rodent repair deficiency, complementation group 6', NULL, NULL, NULL, NULL, NULL, 4),
(67029, NULL, 'G3DSA:2.60.40.60:FF:000499', NULL, NULL, 'Desmocollin 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(67030, NULL, 'G3DSA:3.40.30.10:FF:001067', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(67031, NULL, 'G3DSA:3.30.70.580:FF:000069', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(67032, NULL, 'G3DSA:3.90.180.10:FF:000182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67033, NULL, 'G3DSA:2.40.70.10:FF:000066', NULL, NULL, 'Napsin A aspartic peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(67034, NULL, 'G3DSA:1.10.3470.10:FF:000038', NULL, NULL, 'Ferrichrome transport system permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(67035, NULL, 'G3DSA:2.60.40.60:FF:001117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67036, NULL, 'G3DSA:3.90.1150.10:FF:000005', NULL, NULL, 'Serine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(67037, NULL, 'G3DSA:3.30.460.10:FF:000003', NULL, NULL, 'interleukin enhancer-binding factor 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(67038, NULL, 'G3DSA:3.40.190.10:FF:000407', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(67039, NULL, 'G3DSA:3.90.820.10:FF:000001', NULL, NULL, 'MbtH family protein', NULL, NULL, NULL, NULL, NULL, 4),
(67040, NULL, 'G3DSA:2.20.25.30:FF:000018', NULL, NULL, '60S ribosomal protein L37, putative', NULL, NULL, NULL, NULL, NULL, 4),
(67041, NULL, 'G3DSA:2.60.40.10:FF:004762', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67042, NULL, 'G3DSA:3.60.20.10:FF:000211', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67043, NULL, 'G3DSA:3.40.190.10:FF:000295', NULL, NULL, 'PROBABLE SUGAR-BINDING LIPOPROTEIN LPQY', NULL, NULL, NULL, NULL, NULL, 4),
(67044, NULL, 'G3DSA:2.130.10.10:FF:003093', NULL, NULL, 'Probable cytosolic iron-sulfur protein assembly protein CIAO1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(67045, NULL, 'G3DSA:2.120.10.30:FF:000351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67046, NULL, 'G3DSA:3.40.50.150:FF:000569', NULL, NULL, 'Methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(67047, NULL, 'G3DSA:3.40.50.12670:FF:000012', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(67048, NULL, 'G3DSA:3.40.50.1820:FF:000260', NULL, NULL, 'Feruloyl esterase A', NULL, NULL, NULL, NULL, NULL, 4),
(67049, NULL, 'G3DSA:1.20.5.520:FF:000006', NULL, NULL, 'thymosin beta-12', NULL, NULL, NULL, NULL, NULL, 4),
(67050, NULL, 'G3DSA:3.30.460.20:FF:000006', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(67051, NULL, 'G3DSA:2.60.40.1150:FF:000009', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(67052, NULL, 'G3DSA:1.25.10.10:FF:000920', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(67053, NULL, 'G3DSA:3.30.160.60:FF:001013', NULL, NULL, 'Zinc finger and BTB domain-containing protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(67054, NULL, 'G3DSA:2.160.20.10:FF:000164', NULL, NULL, 'Pectin lyase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(67055, NULL, 'G3DSA:1.25.40.180:FF:000030', NULL, NULL, 'Regulator of nonsense transcripts UPF2', NULL, NULL, NULL, NULL, NULL, 4),
(67056, NULL, 'G3DSA:1.10.455.10:FF:000009', NULL, NULL, 'Ribosomal protein S7', NULL, NULL, NULL, NULL, NULL, 4),
(67057, NULL, 'G3DSA:3.30.160.60:FF:006448', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67058, NULL, 'G3DSA:1.20.1230.10:FF:000001', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(67059, NULL, 'G3DSA:1.20.5.510:FF:000003', NULL, NULL, 'Ubiquinol-cytochrome c reductase iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4),
(67060, NULL, 'G3DSA:2.30.30.30:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(67061, NULL, 'G3DSA:3.30.160.100:FF:000007', NULL, NULL, 'Ribosomal subunit interface protein', NULL, NULL, NULL, NULL, NULL, 4),
(67062, NULL, 'G3DSA:3.60.20.10:FF:000110', NULL, NULL, 'Proteasome subunit beta type-6, putative', NULL, NULL, NULL, NULL, NULL, 4),
(67063, NULL, 'G3DSA:4.10.520.10:FF:000021', NULL, NULL, 'Non-specific DNA-binding protein HU-1', NULL, NULL, NULL, NULL, NULL, 4),
(67064, NULL, 'G3DSA:1.10.287.690:FF:000007', NULL, NULL, 'DNA-directed DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(67065, NULL, 'G3DSA:3.40.50.620:FF:000406', NULL, NULL, 'Cytidylyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(67066, NULL, 'G3DSA:1.25.40.10:FF:003957', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67067, NULL, 'G3DSA:3.30.160.60:FF:004666', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67068, NULL, 'G3DSA:3.50.4.10:FF:000018', NULL, NULL, 'No-mechanoreceptor potential A short isoform', NULL, NULL, NULL, NULL, NULL, 4),
(67069, NULL, 'G3DSA:2.60.40.10:FF:001108', NULL, NULL, 'palladin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(67070, NULL, 'G3DSA:3.30.160.60:FF:004239', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67071, NULL, 'G3DSA:2.60.34.10:FF:000116', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(67072, NULL, 'G3DSA:3.40.50.300:FF:008444', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67073, NULL, 'G3DSA:3.40.50.300:FF:005307', NULL, NULL, 'Cobinamide kinase/cobinamide phosphate guanylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(67074, NULL, 'G3DSA:3.40.366.10:FF:000063', NULL, NULL, 'Probable polyketide synthase 37', NULL, NULL, NULL, NULL, NULL, 4),
(67075, NULL, 'G3DSA:1.10.510.10:FF:002639', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67076, NULL, 'G3DSA:3.40.50.10490:FF:000111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67077, NULL, 'G3DSA:1.20.1280.290:FF:000085', NULL, NULL, 'Uncharacterized membrane protein YOL092W homologue, putative', NULL, NULL, NULL, NULL, NULL, 4),
(67078, NULL, 'G3DSA:2.60.120.260:FF:000226', NULL, NULL, 'Zgc:114081', NULL, NULL, NULL, NULL, NULL, 4),
(67079, NULL, 'G3DSA:3.30.70.2570:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67080, NULL, 'G3DSA:1.25.10.30:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67081, NULL, 'G3DSA:1.25.40.10:FF:005025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67082, NULL, 'G3DSA:3.40.50.10350:FF:000002', NULL, NULL, 'Glycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(67083, NULL, 'G3DSA:3.30.70.3490:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67084, NULL, 'G3DSA:1.20.1070.10:FF:001438', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67085, NULL, 'G3DSA:1.20.142.10:FF:000027', NULL, NULL, 'Poly', NULL, NULL, NULL, NULL, NULL, 4),
(67086, NULL, 'G3DSA:1.50.10.20:FF:000022', NULL, NULL, 'Terpene cyclase/mutase family member', NULL, NULL, NULL, NULL, NULL, 4),
(67087, NULL, 'G3DSA:2.130.10.10:FF:004874', NULL, NULL, 'AGAP007423-PA', NULL, NULL, NULL, NULL, NULL, 4),
(67088, NULL, 'G3DSA:1.10.510.10:FF:000487', NULL, NULL, 'Anti-Muellerian hormone type-2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(67089, NULL, 'G3DSA:2.60.40.150:FF:000544', NULL, NULL, 'Toll-interacting protein A', NULL, NULL, NULL, NULL, NULL, 4),
(67090, NULL, 'G3DSA:3.40.525.10:FF:000074', NULL, NULL, 'Phosphatidylinositol phosphatidylcholine transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(67091, NULL, 'G3DSA:3.80.10.10:FF:001637', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67092, NULL, 'G3DSA:3.60.120.10:FF:000005', NULL, NULL, 'isochorismate synthase, chloroplastic-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(67093, NULL, 'G3DSA:1.10.238.10:FF:000477', NULL, NULL, 'Myosin 1 light chain cam2', NULL, NULL, NULL, NULL, NULL, 4),
(67094, NULL, 'G3DSA:1.10.150.240:FF:000082', NULL, NULL, 'HAD-superfamily hydrolase, subfamily IA, variant 3 containing protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(67095, NULL, 'G3DSA:3.90.730.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67096, NULL, 'G3DSA:3.30.60.20:FF:000156', NULL, NULL, 'Probable Rho-type GTPase-activating protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(67097, NULL, 'G3DSA:1.10.8.710:FF:000009', NULL, NULL, 'Dynein heavy chain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(67098, NULL, 'G3DSA:3.90.190.20:FF:000056', NULL, NULL, 'Dihydrofolate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(67099, NULL, 'G3DSA:1.25.40.20:FF:000296', NULL, NULL, 'Ankyrin repeat and fibronectin type III domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(67100, NULL, 'G3DSA:1.10.150.20:FF:000304', NULL, NULL, 'NADH:ubiquinone oxidoreductase 41 kD complex I subunit', NULL, NULL, NULL, NULL, NULL, 4),
(67101, NULL, 'G3DSA:3.30.230.10:FF:000166', NULL, NULL, 'Ribosome assembly protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(67102, NULL, 'G3DSA:2.40.70.10:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67103, NULL, 'G3DSA:2.30.42.10:FF:000248', NULL, NULL, 'Protease Do-like 7', NULL, NULL, NULL, NULL, NULL, 4),
(67104, NULL, 'G3DSA:3.30.160.60:FF:003154', NULL, NULL, 'Histone-lysine N-methyltransferase PRDM9-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(67105, NULL, 'G3DSA:1.25.40.240:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67106, NULL, 'G3DSA:2.40.30.10:FF:000299', NULL, NULL, 'GTP-binding elongation factor', NULL, NULL, NULL, NULL, NULL, 4),
(67107, NULL, 'G3DSA:2.60.40.10:FF:003126', NULL, NULL, 'Tyrosine-protein phosphatase 4', NULL, NULL, NULL, NULL, NULL, 4),
(67108, NULL, 'G3DSA:3.40.50.720:FF:001729', NULL, NULL, 'Homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(67109, NULL, 'G3DSA:3.30.70.1150:FF:000005', NULL, NULL, 'Acetolactate synthase 3 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(67110, NULL, 'G3DSA:2.40.50.140:FF:000339', NULL, NULL, 'mRNA-capping enzyme isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(67111, NULL, 'G3DSA:3.40.50.2000:FF:000538', NULL, NULL, 'Probable UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SPINDLY', NULL, NULL, NULL, NULL, NULL, 4),
(67112, NULL, 'G3DSA:2.170.150.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67113, NULL, 'G3DSA:3.40.50.300:FF:001373', NULL, NULL, 'Helicase with zinc finger domain 2', NULL, NULL, NULL, NULL, NULL, 4),
(67114, NULL, 'G3DSA:2.60.40.10:FF:000855', NULL, NULL, 'Interleukin-6 receptor subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(67115, NULL, 'G3DSA:3.20.20.100:FF:000210', NULL, NULL, 'Bifunctional protein STORR', NULL, NULL, NULL, NULL, NULL, 4),
(67116, NULL, 'G3DSA:3.80.10.10:FF:000103', NULL, NULL, 'Immunoglobulin superfamily member 10', NULL, NULL, NULL, NULL, NULL, 4),
(67117, NULL, 'G3DSA:3.40.47.10:FF:000296', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67118, NULL, 'G3DSA:1.20.1070.10:FF:001747', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67119, NULL, 'G3DSA:1.10.1760.20:FF:000001', NULL, NULL, 'Cobalt transport protein CbiM', NULL, NULL, NULL, NULL, NULL, 4),
(67120, NULL, 'G3DSA:1.20.58.810:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67121, NULL, 'G3DSA:2.40.50.810:FF:000001', NULL, NULL, 'Single-stranded TG1-3 telomere G-tails binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(67122, NULL, 'G3DSA:3.80.10.10:FF:002244', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(67123, NULL, 'G3DSA:3.40.50.300:FF:001255', NULL, NULL, 'DNA polymerase III subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(67124, NULL, 'G3DSA:1.25.40.10:FF:000293', NULL, NULL, 'Clustered mitochondria protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(67125, NULL, 'G3DSA:1.25.10.10:FF:002573', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67126, NULL, 'G3DSA:3.30.40.10:FF:001990', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67127, NULL, 'G3DSA:1.20.1250.20:FF:002028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(67128, NULL, 'G3DSA:3.40.50.2000:FF:000229', NULL, NULL, 'Trehalose-phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(67129, NULL, 'G3DSA:2.60.40.10:FF:002199', NULL, NULL, 'Scs2p', NULL, NULL, NULL, NULL, NULL, 4),
(67130, NULL, 'G3DSA:3.80.10.10:FF:000092', NULL, NULL, 'keratocan isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(67131, NULL, 'G3DSA:2.40.50.140:FF:000250', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(67132, NULL, 'G3DSA:2.60.220.50:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67133, NULL, 'G3DSA:1.10.357.140:FF:000016', NULL, NULL, '1,4-dihydroxy-2-naphthoate octaprenyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(67134, NULL, 'G3DSA:3.40.50.10050:FF:000002', NULL, NULL, 'Eukaryotic translation initiation factor 5B', NULL, NULL, NULL, NULL, NULL, 4),
(67135, NULL, 'G3DSA:2.60.40.150:FF:000662', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67136, NULL, 'G3DSA:2.60.40.60:FF:000819', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67137, NULL, 'G3DSA:1.20.1250.20:FF:002220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67138, NULL, 'G3DSA:3.40.50.300:FF:006752', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67139, NULL, 'G3DSA:1.10.10.60:FF:000822', NULL, NULL, 'MIS18-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(67140, NULL, 'G3DSA:1.10.600.10:FF:000140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67141, NULL, 'G3DSA:1.25.10.10:FF:000465', NULL, NULL, 'Putative exportin-1', NULL, NULL, NULL, NULL, NULL, 4),
(67142, NULL, 'G3DSA:1.20.1510.10:FF:000028', NULL, NULL, 'Zrc1p', NULL, NULL, NULL, NULL, NULL, 4),
(67143, NULL, 'G3DSA:2.170.130.10:FF:000028', NULL, NULL, 'TonB-dependent siderophore receptor', NULL, NULL, NULL, NULL, NULL, 4),
(67144, NULL, 'G3DSA:3.10.50.10:FF:000018', NULL, NULL, 'Chitodextrinase', NULL, NULL, NULL, NULL, NULL, 4),
(67145, NULL, 'G3DSA:3.30.420.40:FF:000763', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(67146, NULL, 'G3DSA:3.40.50.1980:FF:000049', NULL, NULL, 'Manganese ABC transporter substrate-binding lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(67147, NULL, 'G3DSA:1.25.40.180:FF:000029', NULL, NULL, 'Nuclear cap-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(67148, NULL, 'G3DSA:3.10.129.10:FF:000154', NULL, NULL, 'PaaI family thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(67149, NULL, 'G3DSA:3.20.180.20:FF:000015', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(67150, NULL, 'G3DSA:3.40.309.10:FF:000004', NULL, NULL, 'Succinate-semialdehyde dehydrogenase I', NULL, NULL, NULL, NULL, NULL, 4),
(67151, NULL, 'G3DSA:1.25.40.10:FF:002872', NULL, NULL, 'YALI0B10362p', NULL, NULL, NULL, NULL, NULL, 4),
(67152, NULL, 'G3DSA:3.90.199.10:FF:000011', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(67153, NULL, 'G3DSA:1.25.10.10:FF:002365', NULL, NULL, 'Hsp70 nucleotide exchange factor FES1', NULL, NULL, NULL, NULL, NULL, 4),
(67154, NULL, 'G3DSA:3.30.56.10:FF:000014', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(67155, NULL, 'G3DSA:1.25.40.10:FF:004772', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67156, NULL, 'G3DSA:1.10.3720.10:FF:000165', NULL, NULL, 'Glycine betaine/proline ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(67157, NULL, 'G3DSA:3.90.70.10:FF:000488', NULL, NULL, 'At5g05930', NULL, NULL, NULL, NULL, NULL, 4),
(67158, NULL, 'G3DSA:2.30.29.30:FF:000482', NULL, NULL, 'mRNA-decapping enzyme subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(67159, NULL, 'G3DSA:3.60.40.10:FF:000010', NULL, NULL, 'Probable protein phosphatase 2C 39', NULL, NULL, NULL, NULL, NULL, 4),
(67160, NULL, 'G3DSA:1.10.3430.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67161, NULL, 'G3DSA:1.20.1090.10:FF:000012', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(67162, NULL, 'G3DSA:1.20.1440.170:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67163, NULL, 'G3DSA:3.40.50.1970:FF:000046', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(67164, NULL, 'G3DSA:2.60.40.150:FF:000398', NULL, NULL, 'Unc-13, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(67165, NULL, 'G3DSA:2.120.10.10:FF:000002', NULL, NULL, 'Neuraminidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(67166, NULL, 'G3DSA:3.40.50.2000:FF:000022', NULL, NULL, 'ADP-heptose--LPS heptosyltransferase II', NULL, NULL, NULL, NULL, NULL, 4),
(67167, NULL, 'G3DSA:3.30.420.40:FF:001027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67168, NULL, 'G3DSA:3.80.10.10:FF:002143', NULL, NULL, 'Outer arm dynein light chain 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(67169, NULL, 'G3DSA:1.25.40.1040:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67170, NULL, 'G3DSA:3.30.70.1400:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67171, NULL, 'G3DSA:1.20.58.900:FF:000030', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(67172, NULL, 'G3DSA:1.20.225.30:FF:000001', NULL, NULL, 'tRNA-dihydrouridine(16) synthase', NULL, NULL, NULL, NULL, NULL, 4),
(67173, NULL, 'G3DSA:2.40.50.40:FF:000051', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(67174, NULL, 'G3DSA:3.40.50.300:FF:008298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67175, NULL, 'G3DSA:3.30.420.390:FF:000002', NULL, NULL, 'DNA polymerase gamma, catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(67176, NULL, 'G3DSA:3.30.900.10:FF:000021', NULL, NULL, 'Rev7, putative', NULL, NULL, NULL, NULL, NULL, 4),
(67177, NULL, 'G3DSA:1.10.10.10:FF:001111', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(67178, NULL, 'G3DSA:3.20.20.330:FF:000003', NULL, NULL, 'Betaine--homocysteine S-methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(67179, NULL, 'G3DSA:1.10.472.10:FF:000167', NULL, NULL, 'Mitotic cyclin 6', NULL, NULL, NULL, NULL, NULL, 4),
(67180, NULL, 'G3DSA:3.40.47.10:FF:000190', NULL, NULL, '3-hydroxy-3-methylglutaryl coenzyme A synthase', NULL, NULL, NULL, NULL, NULL, 4),
(67181, NULL, 'G3DSA:2.10.25.10:FF:001637', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(67182, NULL, 'G3DSA:3.60.15.10:FF:000244', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(67183, NULL, 'G3DSA:1.10.510.10:FF:003145', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67184, NULL, 'G3DSA:3.30.1680.10:FF:000008', NULL, NULL, 'semaphorin-3B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(67185, NULL, 'G3DSA:2.60.40.1510:FF:000062', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(67186, NULL, 'G3DSA:3.30.70.330:FF:001051', NULL, NULL, 'Ribonucleoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(67187, NULL, 'G3DSA:2.30.29.30:FF:000381', NULL, NULL, 'FERM domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(67188, NULL, 'G3DSA:3.40.50.300:FF:004498', NULL, NULL, 'Cobalt ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(67189, NULL, 'G3DSA:3.20.20.80:FF:000200', NULL, NULL, 'Alpha-amylase', NULL, NULL, NULL, NULL, NULL, 4),
(67190, NULL, 'G3DSA:3.70.10.10:FF:000098', NULL, NULL, 'Beta sliding clamp', NULL, NULL, NULL, NULL, NULL, 4),
(67191, NULL, 'G3DSA:3.40.50.300:FF:007016', NULL, NULL, 'DNA repair protein rlp1', NULL, NULL, NULL, NULL, NULL, 4),
(67192, NULL, 'G3DSA:3.40.50.620:FF:000614', NULL, NULL, 'Glutamate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(67193, NULL, 'G3DSA:1.20.58.390:FF:000276', NULL, NULL, 'SD09326p', NULL, NULL, NULL, NULL, NULL, 4),
(67194, NULL, 'G3DSA:3.20.20.150:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67195, NULL, 'G3DSA:3.40.190.10:FF:000306', NULL, NULL, 'Probable molybdate-binding lipoprotein modA', NULL, NULL, NULL, NULL, NULL, 4),
(67196, NULL, 'G3DSA:3.30.420.40:FF:000864', NULL, NULL, 'Actin related protein 10 homolog', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(67197, NULL, 'G3DSA:3.10.20.90:FF:000198', NULL, NULL, 'Ubiquilin 3', NULL, NULL, NULL, NULL, NULL, 4),
(67198, NULL, 'G3DSA:3.40.50.300:FF:004599', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67199, NULL, 'G3DSA:3.30.70.120:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67200, NULL, 'G3DSA:1.20.1250.20:FF:000112', NULL, NULL, 'glucose-6-phosphate exchanger SLC37A4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(67201, NULL, 'G3DSA:3.90.70.10:FF:000590', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67202, NULL, 'G3DSA:1.20.1070.10:FF:000112', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(67203, NULL, 'G3DSA:1.10.10.60:FF:000159', NULL, NULL, 'Homeobox-leucine zipper protein HAT5', NULL, NULL, NULL, NULL, NULL, 4),
(67204, NULL, 'G3DSA:3.40.47.10:FF:000088', NULL, NULL, 'Putative chalcone synthase', NULL, NULL, NULL, NULL, NULL, 4),
(67205, NULL, 'G3DSA:3.40.50.300:FF:003273', NULL, NULL, 'Probable LSG1-Large-Subunit GTPase involved in 60S ribosomal subunit biogenesis', NULL, NULL, NULL, NULL, NULL, 4),
(67206, NULL, 'G3DSA:1.20.1420.30:FF:000050', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(67207, NULL, 'G3DSA:3.40.140.10:FF:000258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67208, NULL, 'G3DSA:2.130.10.10:FF:003020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67209, NULL, 'G3DSA:3.40.50.12780:FF:000163', NULL, NULL, 'Nonribosomal peptide synthase nlsA', NULL, NULL, NULL, NULL, NULL, 4),
(67210, NULL, 'G3DSA:3.30.565.10:FF:000264', NULL, NULL, 'Sensory histidine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(67211, NULL, 'G3DSA:3.80.10.10:FF:003329', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(67212, NULL, 'G3DSA:3.30.160.60:FF:002648', NULL, NULL, 'C2H2 finger domain protein, putative (AFU_orthologue AFUA_4G11480)', NULL, NULL, NULL, NULL, NULL, 4),
(67213, NULL, 'G3DSA:2.10.25.10:FF:001547', NULL, NULL, 'Adhesion G protein-coupled receptor E5a', NULL, NULL, NULL, NULL, NULL, 4),
(67214, NULL, 'G3DSA:3.30.160.60:FF:004548', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67215, NULL, 'G3DSA:1.10.1300.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67216, NULL, 'G3DSA:3.10.450.40:FF:000016', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(67217, NULL, 'G3DSA:1.10.238.10:FF:000269', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(67218, NULL, 'G3DSA:3.30.230.10:FF:000150', NULL, NULL, 'DNA repair protein RadA', NULL, NULL, NULL, NULL, NULL, 4),
(67219, NULL, 'G3DSA:3.30.450.150:FF:000009', NULL, NULL, 'Slr1406 protein', NULL, NULL, NULL, NULL, NULL, 4),
(67220, NULL, 'G3DSA:1.20.1310.10:FF:000165', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67221, NULL, 'G3DSA:2.30.30.40:FF:000258', NULL, NULL, 'Chemotaxis protein CheW', NULL, NULL, NULL, NULL, NULL, 4),
(67222, NULL, 'G3DSA:3.30.720.200:FF:000002', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(67223, NULL, 'G3DSA:3.40.50.2000:FF:000437', NULL, NULL, 'Alpha-1,3/1,6-mannosyltransferase alg2', NULL, NULL, NULL, NULL, NULL, 4),
(67224, NULL, 'G3DSA:1.20.1070.10:FF:001955', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67225, NULL, 'G3DSA:3.90.79.10:FF:000137', NULL, NULL, 'Translation initiation factor eIF-2B subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(67226, NULL, 'G3DSA:3.40.50.300:FF:002699', NULL, NULL, 'ATP-binding cassette protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(67227, NULL, 'G3DSA:3.40.50.300:FF:006853', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67228, NULL, 'G3DSA:3.30.720.210:FF:000005', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(67229, NULL, 'G3DSA:3.90.1150.10:FF:000314', NULL, NULL, 'Serine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(67230, NULL, 'G3DSA:3.40.390.10:FF:000170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67231, NULL, 'G3DSA:6.10.250.3370:FF:000002', NULL, NULL, 'Siderophore staphylobactin biosynthesis protein SbnE', NULL, NULL, NULL, NULL, NULL, 4),
(67232, NULL, 'G3DSA:3.30.559.70:FF:000054', NULL, NULL, 'Carnitine O-palmitoyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(67233, NULL, 'G3DSA:3.30.160.60:FF:001114', NULL, NULL, 'Zinc finger protein SNAI2', NULL, NULL, NULL, NULL, NULL, 4),
(67234, NULL, 'G3DSA:3.30.70.370:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67235, NULL, 'G3DSA:3.50.50.60:FF:000144', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(67236, NULL, 'G3DSA:3.10.450.50:FF:000019', NULL, NULL, 'Nuclear transport factor 2 (NTF2), putative', NULL, NULL, NULL, NULL, NULL, 4),
(67237, NULL, 'G3DSA:3.80.10.10:FF:001429', NULL, NULL, 'Probable disease resistance protein At1g61190', NULL, NULL, NULL, NULL, NULL, 4),
(67238, NULL, 'G3DSA:1.10.10.10:FF:000493', NULL, NULL, 'HMG-Y-related protein A', NULL, NULL, NULL, NULL, NULL, 4),
(67239, NULL, 'G3DSA:1.10.630.10:FF:000074', NULL, NULL, '25-hydroxycholesterol 7-alpha-hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(67240, NULL, 'G3DSA:3.40.50.1820:FF:000142', NULL, NULL, 'Enterobactin synthetase component F', NULL, NULL, NULL, NULL, NULL, 4),
(67241, NULL, 'G3DSA:2.130.10.10:FF:001075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67242, NULL, 'G3DSA:3.40.50.720:FF:002134', NULL, NULL, 'Hydroxy-delta-5-steroid dehydrogenase, 3 beta- and steroid delta-isomerase 7', NULL, NULL, NULL, NULL, NULL, 4),
(67243, NULL, 'G3DSA:3.30.70.270:FF:000291', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67244, NULL, 'G3DSA:3.40.50.300:FF:005116', NULL, NULL, 'DNA repair protein RAD51 homolog 3-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(67245, NULL, 'G3DSA:1.25.40.10:FF:000259', NULL, NULL, 'Protein SGT1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(67246, NULL, 'G3DSA:3.40.50.300:FF:006398', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67247, NULL, 'G3DSA:3.30.200.20:FF:001769', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(67248, NULL, 'G3DSA:3.30.70.360:FF:000020', NULL, NULL, 'Peptidase, M20/M25/M40 family', NULL, NULL, NULL, NULL, NULL, 4),
(67249, NULL, 'G3DSA:1.20.1250.20:FF:002012', NULL, NULL, 'Transporter belonging to the MFS superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(67250, NULL, 'G3DSA:1.10.10.60:FF:001064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67251, NULL, 'G3DSA:3.40.718.10:FF:000033', NULL, NULL, 'Isocitrate dehydrogenase [NADP]', NULL, NULL, NULL, NULL, NULL, 4),
(67252, NULL, 'G3DSA:3.40.50.12280:FF:000002', NULL, NULL, 'NADH-quinone oxidoreductase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(67253, NULL, 'G3DSA:3.40.50.1820:FF:001586', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67254, NULL, 'G3DSA:3.10.20.30:FF:000096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67255, NULL, 'G3DSA:3.40.710.10:FF:000122', NULL, NULL, 'Serine-type D-Ala-D-Ala carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(67256, NULL, 'G3DSA:3.90.550.50:FF:000228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67257, NULL, 'G3DSA:1.20.1250.20:FF:000421', NULL, NULL, 'Inorganic phosphate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(67258, NULL, 'G3DSA:3.30.465.10:FF:000054', NULL, NULL, 'FAD linked oxidase, C-terminal domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(67259, NULL, 'G3DSA:1.20.58.60:FF:000038', NULL, NULL, 'Short stop, isoform N', NULL, NULL, NULL, NULL, NULL, 4),
(67260, NULL, 'G3DSA:2.60.120.200:FF:000006', NULL, NULL, 'receptor-type tyrosine-protein phosphatase T isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(67261, NULL, 'G3DSA:1.10.510.10:FF:001700', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(67262, NULL, 'G3DSA:3.80.10.10:FF:001738', NULL, NULL, 'F-box protein YLR352W', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(67263, NULL, 'G3DSA:1.20.90.10:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67264, NULL, 'G3DSA:2.60.120.260:FF:000327', NULL, NULL, 'EPH receptor B4', NULL, NULL, NULL, NULL, NULL, 4),
(67265, NULL, 'G3DSA:3.40.50.300:FF:007106', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(67266, NULL, 'G3DSA:3.30.760.10:FF:000032', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(67267, NULL, 'G3DSA:1.10.150.240:FF:000098', NULL, NULL, 'Phosphoglycolate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(67268, NULL, 'G3DSA:3.40.1110.10:FF:000042', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(67269, NULL, 'G3DSA:1.20.1070.10:FF:000319', NULL, NULL, 'Drm corazonin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(67270, NULL, 'G3DSA:3.40.50.620:FF:000305', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(67271, NULL, 'G3DSA:1.10.510.10:FF:002982', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67272, NULL, 'G3DSA:3.30.40.10:FF:002153', NULL, NULL, 'Structure-specific endonuclease subunit SLX1', NULL, NULL, NULL, NULL, NULL, 4),
(67273, NULL, 'G3DSA:1.10.150.60:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67274, NULL, 'G3DSA:3.10.580.10:FF:000011', NULL, NULL, 'TerC family inner membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(67275, NULL, 'G3DSA:1.25.40.10:FF:002092', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(67276, NULL, 'G3DSA:3.40.50.2300:FF:000084', NULL, NULL, 'Lysine decarboxylase, inducible', NULL, NULL, NULL, NULL, NULL, 4),
(67277, NULL, 'G3DSA:1.25.10.10:FF:002926', NULL, NULL, 'Protein HEATR9', NULL, NULL, NULL, NULL, NULL, 4),
(67278, NULL, 'G3DSA:2.70.150.10:FF:000155', NULL, NULL, 'Proton motive ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(67279, NULL, 'G3DSA:1.25.40.10:FF:004862', NULL, NULL, 'Vacuolar protein sorting-associated protein 41 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(67280, NULL, 'G3DSA:3.30.1370.10:FF:000108', NULL, NULL, 'DEAD box polypeptide 43 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(67281, NULL, 'G3DSA:3.30.160.60:FF:000496', NULL, NULL, 'Zinc finger with KRAB and SCAN domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(67282, NULL, 'G3DSA:3.90.70.80:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67283, NULL, 'G3DSA:3.30.40.10:FF:000253', NULL, NULL, 'E3 ubiquitin-protein ligase RNF126', NULL, NULL, NULL, NULL, NULL, 4),
(67284, NULL, 'G3DSA:3.10.20.90:FF:000759', NULL, NULL, 'Ubiquitin-associated /TS-N domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(67285, NULL, 'G3DSA:3.40.50.300:FF:004953', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67286, NULL, 'G3DSA:1.20.1250.20:FF:001865', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(67287, NULL, 'G3DSA:2.60.120.260:FF:000636', NULL, NULL, 'Putative Pol polyprotein from transposon element Bs1', NULL, NULL, NULL, NULL, NULL, 4),
(67288, NULL, 'G3DSA:3.30.1120.30:FF:000034', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(67289, NULL, 'G3DSA:1.25.40.10:FF:004199', NULL, NULL, 'Alpha-soluble NSF attachment protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(67290, NULL, 'G3DSA:2.130.10.10:FF:004773', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67291, NULL, 'G3DSA:3.30.450.20:FF:000034', NULL, NULL, 'Phytochrome', NULL, NULL, NULL, NULL, NULL, 4),
(67292, NULL, 'G3DSA:1.10.300.10:FF:000010', NULL, NULL, 'Adenylosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(67293, NULL, 'G3DSA:1.10.472.10:FF:000622', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67294, NULL, 'G3DSA:2.60.40.420:FF:000046', NULL, NULL, 'Multicopper oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(67295, NULL, 'G3DSA:1.20.58.1120:FF:000004', NULL, NULL, 'Dynein axonemal heavy chain 5', NULL, NULL, NULL, NULL, NULL, 4),
(67296, NULL, 'G3DSA:3.10.120.10:FF:000056', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(67297, NULL, 'G3DSA:1.20.970.30:FF:000002', NULL, NULL, 'Translation initiation factor eIF4G', NULL, NULL, NULL, NULL, NULL, 4),
(67298, NULL, 'G3DSA:1.25.70.10:FF:000087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67299, NULL, 'G3DSA:1.10.238.10:FF:000932', NULL, NULL, 'EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(67300, NULL, 'G3DSA:2.120.10.30:FF:000457', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67301, NULL, 'G3DSA:3.30.450.30:FF:000037', NULL, NULL, 'Roadblock/LC7 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(67302, NULL, 'G3DSA:3.90.1600.10:FF:000068', NULL, NULL, 'DNA polymerase delta subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(67303, NULL, 'G3DSA:1.10.238.10:FF:000578', NULL, NULL, 'p25-alpha_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(67304, NULL, 'G3DSA:3.30.160.60:FF:000967', NULL, NULL, 'zinc finger protein 436 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(67305, NULL, 'G3DSA:3.30.230.70:FF:000061', NULL, NULL, 'Exosome complex component rrp42', NULL, NULL, NULL, NULL, NULL, 4),
(67306, NULL, 'G3DSA:2.10.110.10:FF:000312', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67307, NULL, 'G3DSA:2.10.109.10:FF:000027', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(67308, NULL, 'G3DSA:3.40.50.1820:FF:000703', NULL, NULL, 'Hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(67309, NULL, 'G3DSA:2.60.40.10:FF:002963', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67310, NULL, 'G3DSA:1.10.400.10:FF:000074', NULL, NULL, 'Guanine nucleotide binding protein, alpha activating activity polypeptide O', NULL, NULL, NULL, NULL, NULL, 4),
(67311, NULL, 'G3DSA:2.70.98.90:FF:000011', NULL, NULL, 'Membrane protein insertase YidC', NULL, NULL, NULL, NULL, NULL, 4),
(67312, NULL, 'G3DSA:3.30.70.330:FF:002276', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67313, NULL, 'G3DSA:3.30.40.10:FF:000562', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(67314, NULL, 'G3DSA:2.60.120.200:FF:000315', NULL, NULL, 'Anaplastic lymphoma kinase, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(67315, NULL, 'G3DSA:2.60.120.650:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67316, NULL, 'G3DSA:3.30.50.10:FF:000181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67317, NULL, 'G3DSA:3.40.1280.10:FF:000054', NULL, NULL, 'rRNA methylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(67318, NULL, 'G3DSA:2.60.40.150:FF:000089', NULL, NULL, 'otoferlin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(67319, NULL, 'G3DSA:3.30.110.110:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67320, NULL, 'G3DSA:1.25.40.20:FF:001122', NULL, NULL, 'UPF0507 protein C2_02840C_A', NULL, NULL, NULL, NULL, NULL, 4),
(67321, NULL, 'G3DSA:3.40.50.1820:FF:000613', NULL, NULL, 'N-myc downstream-regulated gene 1b', NULL, NULL, NULL, NULL, NULL, 4),
(67322, NULL, 'G3DSA:3.10.20.90:FF:000861', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67323, NULL, 'G3DSA:2.60.40.60:FF:001016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67324, NULL, 'G3DSA:4.10.260.20:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67325, NULL, 'G3DSA:1.10.246.10:FF:000018', NULL, NULL, 'Serum albumin', NULL, NULL, NULL, NULL, NULL, 4),
(67326, NULL, 'G3DSA:2.10.25.10:FF:000103', NULL, NULL, 'Fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(67327, NULL, 'G3DSA:3.80.10.10:FF:004043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67328, NULL, 'G3DSA:1.10.10.60:FF:000249', NULL, NULL, 'H2.0-like homeobox protein', NULL, NULL, NULL, NULL, NULL, 4),
(67329, NULL, 'G3DSA:3.30.1520.10:FF:000025', NULL, NULL, 'Sorting nexin 20', NULL, NULL, NULL, NULL, NULL, 4),
(67330, NULL, 'G3DSA:1.25.40.20:FF:001329', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67331, NULL, 'G3DSA:1.10.2020.20:FF:000007', NULL, NULL, '26S proteasome regulatory subunit RPN13,putative', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(67332, NULL, 'G3DSA:3.90.660.10:FF:000112', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67333, NULL, 'G3DSA:1.10.530.10:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67334, NULL, 'G3DSA:2.40.10.10:FF:000399', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67335, NULL, 'G3DSA:3.40.50.620:FF:000053', NULL, NULL, 'Probable tRNA sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(67336, NULL, 'G3DSA:3.10.110.10:FF:000128', NULL, NULL, 'YLR419Wp putative helicase', NULL, NULL, NULL, NULL, NULL, 4),
(67337, NULL, 'G3DSA:3.10.20.230:FF:000026', NULL, NULL, 'Protein doublecortin', NULL, NULL, NULL, NULL, NULL, 4),
(67338, NULL, 'G3DSA:3.20.20.100:FF:000064', NULL, NULL, 'Aldo-keto reductase 1a', NULL, NULL, NULL, NULL, NULL, 4),
(67339, NULL, 'G3DSA:3.90.640.60:FF:000002', NULL, NULL, 'Actin-like protein ARP9', NULL, NULL, NULL, NULL, NULL, 4),
(67340, NULL, 'G3DSA:2.60.40.10:FF:004806', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67341, NULL, 'G3DSA:1.20.1070.10:FF:002017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67342, NULL, 'G3DSA:2.10.25.10:FF:001328', NULL, NULL, 'Protein eyes shut homolog', NULL, NULL, NULL, NULL, NULL, 4),
(67343, NULL, 'G3DSA:3.80.10.10:FF:000119', NULL, NULL, 'Leucine-rich repeat-containing 14 isoform b', NULL, NULL, NULL, NULL, NULL, 4),
(67344, NULL, 'G3DSA:3.40.640.10:FF:000280', NULL, NULL, 'Acetylornithine aminotransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(67345, NULL, 'G3DSA:2.40.160.110:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67346, NULL, 'G3DSA:3.40.50.12230:FF:000004', NULL, NULL, 'Methionyl-tRNA formyltransferase family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(67347, NULL, 'G3DSA:2.130.10.10:FF:004329', NULL, NULL, 'LLGL1, scribble cell polarity complex component', NULL, NULL, NULL, NULL, NULL, 4),
(67348, NULL, 'G3DSA:3.40.50.300:FF:004728', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67349, NULL, 'G3DSA:2.130.10.10:FF:002733', NULL, NULL, 'DDB1- and CUL4-associated factor 7 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(67350, NULL, 'G3DSA:3.40.50.150:FF:001631', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67351, NULL, 'G3DSA:2.40.30.170:FF:000018', NULL, NULL, 'Hemolysin D', NULL, NULL, NULL, NULL, NULL, 4),
(67352, NULL, 'G3DSA:1.25.10.10:FF:000347', NULL, NULL, 'EFR3 homolog A (S. cerevisiae)', NULL, NULL, NULL, NULL, NULL, 4),
(67353, NULL, 'G3DSA:3.30.70.260:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67354, NULL, 'G3DSA:3.40.50.300:FF:005190', NULL, NULL, 'Female sterile (1) Yb', NULL, NULL, NULL, NULL, NULL, 4),
(67355, NULL, 'G3DSA:1.25.10.10:FF:000875', NULL, NULL, 'Protein CELLULOSE SYNTHASE INTERACTIVE 1', NULL, NULL, NULL, NULL, NULL, 4),
(67356, NULL, 'G3DSA:2.40.30.30:FF:000030', NULL, NULL, 'Riboflavin kinase', NULL, NULL, NULL, NULL, NULL, 4),
(67357, NULL, 'G3DSA:3.40.50.12240:FF:000007', NULL, NULL, 'V-type proton ATPase subunit B, brain isoform', NULL, NULL, NULL, NULL, NULL, 4),
(67358, NULL, 'G3DSA:1.20.58.60:FF:000302', NULL, NULL, 'Spectrin beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(67359, NULL, 'G3DSA:3.10.110.10:FF:000229', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 Q2', NULL, NULL, NULL, NULL, NULL, 4),
(67360, NULL, 'G3DSA:3.30.565.10:FF:000483', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67361, NULL, 'G3DSA:3.30.70.270:FF:000173', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67362, NULL, 'G3DSA:1.20.272.40:FF:000001', NULL, NULL, 'ATP-dependent RNA helicase SUPV3L1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(67363, NULL, 'G3DSA:3.40.50.12780:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67364, NULL, 'G3DSA:3.30.920.10:FF:000005', NULL, NULL, 'Iron-sulfur cluster assembly protein CyaY', NULL, NULL, NULL, NULL, NULL, 4),
(67365, NULL, 'G3DSA:2.130.10.10:FF:004857', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(67366, NULL, 'G3DSA:3.40.50.150:FF:001092', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67367, NULL, 'G3DSA:3.30.230.10:FF:000149', NULL, NULL, 'Lon protease', NULL, NULL, NULL, NULL, NULL, 4),
(67368, NULL, 'G3DSA:3.90.70.10:FF:000898', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67369, NULL, 'G3DSA:2.130.10.10:FF:005959', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67370, NULL, 'G3DSA:1.10.510.10:FF:001127', NULL, NULL, 'NEK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(67371, NULL, 'G3DSA:3.10.450.40:FF:000033', NULL, NULL, 'Baseplate assembly protein W', NULL, NULL, NULL, NULL, NULL, 4),
(67372, NULL, 'G3DSA:4.10.240.10:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67373, NULL, 'G3DSA:3.10.450.50:FF:000036', NULL, NULL, 'Putative transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(67374, NULL, 'G3DSA:1.25.40.10:FF:003125', NULL, NULL, 'Paf1 complex component', NULL, NULL, NULL, NULL, NULL, 4),
(67375, NULL, 'G3DSA:3.30.160.60:FF:006364', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67376, NULL, 'G3DSA:1.25.40.10:FF:000377', NULL, NULL, 'Tetratricopeptide repeat domain 21B', NULL, NULL, NULL, NULL, NULL, 4),
(67377, NULL, 'G3DSA:3.90.1750.10:FF:000079', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(67378, NULL, 'G3DSA:3.60.15.10:FF:000025', NULL, NULL, 'Inactive cytidine monophosphate-N-acetylneuraminic acid hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(67379, NULL, 'G3DSA:1.20.58.1180:FF:000005', NULL, NULL, 'AGR361Wp', NULL, NULL, NULL, NULL, NULL, 4),
(67380, NULL, 'G3DSA:3.30.70.330:FF:000359', NULL, NULL, 'CUGBP Elav-like family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(67381, NULL, 'G3DSA:3.10.100.10:FF:000257', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67382, NULL, 'G3DSA:3.30.160.20:FF:000040', NULL, NULL, 'Peptide chain release factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(67383, NULL, 'G3DSA:3.40.710.10:FF:000021', NULL, NULL, 'Penicillin-binding protein 1C', NULL, NULL, NULL, NULL, NULL, 4),
(67384, NULL, 'G3DSA:1.25.10.10:FF:002483', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(67385, NULL, 'G3DSA:2.60.120.260:FF:000417', NULL, NULL, 'Periplasmic beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(67386, NULL, 'G3DSA:1.25.40.20:FF:001330', NULL, NULL, 'Ankyrin repeat domain 6a', NULL, NULL, NULL, NULL, NULL, 4),
(67387, NULL, 'G3DSA:3.80.10.10:FF:004251', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(67388, NULL, 'G3DSA:3.30.70.270:FF:000066', NULL, NULL, 'Endogenous retrovirus group K member 6 Pol protein', NULL, NULL, NULL, NULL, NULL, 4),
(67389, NULL, 'G3DSA:3.40.50.12580:FF:000002', NULL, NULL, 'Minor teichoic acid biosynthesis protein GgaB', NULL, NULL, NULL, NULL, NULL, 4),
(67390, NULL, 'G3DSA:2.40.50.90:FF:000043', NULL, NULL, 'Tudor staphylococcal nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(67391, NULL, 'G3DSA:1.20.1250.20:FF:002118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67392, NULL, 'G3DSA:3.30.420.140:FF:000040', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(67393, NULL, 'G3DSA:1.20.140.40:FF:000083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67394, NULL, 'G3DSA:3.30.200.20:FF:002365', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67395, NULL, 'G3DSA:2.60.40.10:FF:001018', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(67396, NULL, 'G3DSA:3.80.10.10:FF:000226', NULL, NULL, 'leucine-rich repeat-containing protein 32 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(67397, NULL, 'G3DSA:1.25.40.10:FF:004755', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67398, NULL, 'G3DSA:3.40.50.300:FF:005201', NULL, NULL, 'Thymidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(67399, NULL, 'G3DSA:3.40.50.10490:FF:000021', NULL, NULL, 'Glucose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(67400, NULL, 'G3DSA:3.30.420.40:FF:000982', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(67401, NULL, 'G3DSA:1.10.730.10:FF:000149', NULL, NULL, 'Valyl tRNA Synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(67402, NULL, 'G3DSA:1.10.601.10:FF:000001', NULL, NULL, 'RNA polymerase sigma factor SigA', NULL, NULL, NULL, NULL, NULL, 4),
(67403, NULL, 'G3DSA:2.60.40.10:FF:000945', NULL, NULL, 'Neural cell adhesion molecule L1', NULL, NULL, NULL, NULL, NULL, 4),
(67404, NULL, 'G3DSA:1.10.10.160:FF:000022', NULL, NULL, 'RecBCD enzyme subunit RecC', NULL, NULL, NULL, NULL, NULL, 4),
(67405, NULL, 'G3DSA:3.30.750.24:FF:000056', NULL, NULL, 'YPR003C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(67406, NULL, 'G3DSA:3.30.559.10:FF:000058', NULL, NULL, 'Carnitine palmitoyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(67407, NULL, 'G3DSA:3.30.230.70:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67408, NULL, 'G3DSA:3.60.10.10:FF:000036', NULL, NULL, 'Inositol polyphosphate phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(67409, NULL, 'G3DSA:1.10.260.40:FF:000043', NULL, NULL, 'DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(67410, NULL, 'G3DSA:3.30.870.30:FF:000001', NULL, NULL, 'MIT domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(67411, NULL, 'G3DSA:3.40.50.150:FF:000479', NULL, NULL, 'Protein-lysine N-methyltransferase EFM6', NULL, NULL, NULL, NULL, NULL, 4),
(67412, NULL, 'G3DSA:3.90.70.200:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67413, NULL, 'G3DSA:3.10.580.10:FF:000112', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(67414, NULL, 'G3DSA:3.30.450.70:FF:000015', NULL, NULL, 'Component of TRAPP complex', NULL, NULL, NULL, NULL, NULL, 4),
(67415, NULL, 'G3DSA:3.90.190.10:FF:000244', NULL, NULL, 'Tyrosine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(67416, NULL, 'G3DSA:2.130.10.10:FF:004964', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(67417, NULL, 'G3DSA:2.130.10.10:FF:000479', NULL, NULL, 'Topless-related protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(67418, NULL, 'G3DSA:3.40.50.720:FF:001538', NULL, NULL, 'YALI0E27764p', NULL, NULL, NULL, NULL, NULL, 4),
(67419, NULL, 'G3DSA:1.20.1260.60:FF:000017', NULL, NULL, 'Vacuolar protein sorting-associated protein ist1', NULL, NULL, NULL, NULL, NULL, 4),
(67420, NULL, 'G3DSA:2.60.40.10:FF:002553', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(67421, NULL, 'G3DSA:2.10.25.10:FF:001654', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67422, NULL, 'G3DSA:3.30.160.60:FF:003710', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67423, NULL, 'G3DSA:3.40.50.300:FF:000985', NULL, NULL, 'Guanine nucleotide-binding protein subunit alpha-15', NULL, NULL, NULL, NULL, NULL, 4),
(67424, NULL, 'G3DSA:1.10.10.60:FF:000575', NULL, NULL, 'Transcription factor MYB30', NULL, NULL, NULL, NULL, NULL, 4),
(67425, NULL, 'G3DSA:3.40.50.150:FF:001103', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67426, NULL, 'G3DSA:3.30.200.20:FF:002258', NULL, NULL, 'CAMK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(67427, NULL, 'G3DSA:1.10.287.130:FF:000261', NULL, NULL, 'Phosphate regulon sensor protein PhoR', NULL, NULL, NULL, NULL, NULL, 4),
(67428, NULL, 'G3DSA:2.130.10.10:FF:000586', NULL, NULL, 'Pre-mRNA-splicing factor rse1', NULL, NULL, NULL, NULL, NULL, 4),
(67429, NULL, 'G3DSA:3.30.300.320:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67430, NULL, 'G3DSA:1.20.20.10:FF:000015', NULL, NULL, 'ATP synthase subunit c', NULL, NULL, NULL, NULL, NULL, 4),
(67431, NULL, 'G3DSA:3.40.50.720:FF:001645', NULL, NULL, 'NAD-dependent epimerase/dehydratase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(67432, NULL, 'G3DSA:2.30.30.790:FF:000021', NULL, NULL, '54S ribosomal protein subunit img1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(67433, NULL, 'G3DSA:3.40.850.10:FF:000407', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(67434, NULL, 'G3DSA:2.60.40.10:FF:000299', NULL, NULL, 'protogenin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(67435, NULL, 'G3DSA:1.25.40.10:FF:004446', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67436, NULL, 'G3DSA:3.10.100.10:FF:000408', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67437, NULL, 'G3DSA:3.80.10.10:FF:003638', NULL, NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g56140', NULL, NULL, NULL, NULL, NULL, 4),
(67438, NULL, 'G3DSA:3.40.225.10:FF:000028', NULL, NULL, 'Putative aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(67439, NULL, 'G3DSA:3.30.420.40:FF:000673', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67440, NULL, 'G3DSA:3.50.50.60:FF:000470', NULL, NULL, 'Monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(67441, NULL, 'G3DSA:3.30.200.20:FF:000460', NULL, NULL, 'CMGC/MAPK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(67442, NULL, 'G3DSA:1.10.10.60:FF:000468', NULL, NULL, 'Distal-less homeobox 6', NULL, NULL, NULL, NULL, NULL, 4),
(67443, NULL, 'G3DSA:3.40.50.1000:FF:000795', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67444, NULL, 'G3DSA:1.20.1540.10:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67445, NULL, 'G3DSA:2.60.40.10:FF:005150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67446, NULL, 'G3DSA:3.30.1520.10:FF:000160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67447, NULL, 'G3DSA:3.10.350.10:FF:000073', NULL, NULL, 'Cell wall endopeptidase family M23/M37', NULL, NULL, NULL, NULL, NULL, 4),
(67448, NULL, 'G3DSA:3.30.160.60:FF:006257', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67449, NULL, 'G3DSA:3.40.50.300:FF:006971', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67450, NULL, 'G3DSA:1.10.10.10:FF:000386', NULL, NULL, 'Response regulator receiver domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(67451, NULL, 'G3DSA:1.10.510.10:FF:003600', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67452, NULL, 'G3DSA:3.30.1010.10:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67453, NULL, 'G3DSA:1.25.40.80:FF:000015', NULL, NULL, 'DNA photolyase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(67454, NULL, 'G3DSA:3.40.50.300:FF:000676', NULL, NULL, 'Ras homolog family member F', NULL, NULL, NULL, NULL, NULL, 4),
(67455, NULL, 'G3DSA:3.30.470.30:FF:000055', NULL, NULL, 'DNA ligase 4', NULL, NULL, NULL, NULL, NULL, 4),
(67456, NULL, 'G3DSA:3.40.50.2000:FF:000319', NULL, NULL, '3-deoxy-D-manno-octulosonic acid transferase', NULL, NULL, NULL, NULL, NULL, 4),
(67457, NULL, 'G3DSA:2.30.42.10:FF:000602', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67458, NULL, 'G3DSA:1.25.40.10:FF:000175', NULL, NULL, 'transmembrane and TPR repeat-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(67459, NULL, 'G3DSA:2.40.10.10:FF:000293', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67460, NULL, 'G3DSA:3.40.50.300:FF:001165', NULL, NULL, 'RNA cytidine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(67461, NULL, 'G3DSA:1.10.3170.10:FF:000009', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(67462, NULL, 'G3DSA:1.10.8.100:FF:000006', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(67463, NULL, 'G3DSA:3.40.50.1000:FF:000267', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(67464, NULL, 'G3DSA:2.60.120.650:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67465, NULL, 'G3DSA:3.80.10.10:FF:002008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67466, NULL, 'G3DSA:3.30.1360.150:FF:000004', NULL, NULL, 'Alkaline phosphatase PhoV', NULL, NULL, NULL, NULL, NULL, 4),
(67467, NULL, 'G3DSA:1.10.150.20:FF:000170', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4),
(67468, NULL, 'G3DSA:3.40.50.720:FF:001847', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(67469, NULL, 'G3DSA:3.40.970.40:FF:000004', NULL, NULL, 'Fibronectin/fibrinogen-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(67470, NULL, 'G3DSA:3.40.50.970:FF:000034', NULL, NULL, 'Probable 2-oxoglutarate dehydrogenase E1 component DHKTD1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(67471, NULL, 'G3DSA:3.40.50.150:FF:001305', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67472, NULL, 'G3DSA:3.30.1140.32:FF:000026', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(67473, NULL, 'G3DSA:1.10.10.10:FF:001010', NULL, NULL, 'Putative transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(67474, NULL, 'G3DSA:3.90.70.10:FF:000589', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67475, NULL, 'G3DSA:3.40.50.1000:FF:000486', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67476, NULL, 'G3DSA:3.30.470.20:FF:000052', NULL, NULL, 'Ribosomal protein S6 modification enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(67477, NULL, 'G3DSA:3.50.50.60:FF:000700', NULL, NULL, 'sarcosine dehydrogenase, mitochondrial-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(67478, NULL, 'G3DSA:1.10.472.10:FF:000268', NULL, NULL, 'WGS project CABT00000000 data, contig 2.8', NULL, NULL, NULL, NULL, NULL, 4),
(67479, NULL, 'G3DSA:3.90.640.10:FF:000026', NULL, NULL, 'Actin-related protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(67480, NULL, 'G3DSA:2.40.30.270:FF:000032', NULL, NULL, 'Protein CBR-DNA-2', NULL, NULL, NULL, NULL, NULL, 4),
(67481, NULL, 'G3DSA:2.30.30.40:FF:000483', NULL, NULL, 'Protein app1', NULL, NULL, NULL, NULL, NULL, 4),
(67482, NULL, 'G3DSA:3.30.1370.10:FF:000215', NULL, NULL, 'ATP-dependent RNA helicase p62-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(67483, NULL, 'G3DSA:3.30.160.60:FF:003014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67484, NULL, 'G3DSA:1.10.238.10:FF:001213', NULL, NULL, 'Kv channel-interacting protein 3b, calsenilin', NULL, NULL, NULL, NULL, NULL, 4),
(67485, NULL, 'G3DSA:1.10.3130.10:FF:000007', NULL, NULL, 'serine acetyltransferase 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(67486, NULL, 'G3DSA:2.20.70.10:FF:000095', NULL, NULL, 'Pre-mRNA-processing factor 40', NULL, NULL, NULL, NULL, NULL, 4),
(67487, NULL, 'G3DSA:1.25.40.10:FF:000484', NULL, NULL, 'Glycosyltransferase family 41 protein', NULL, NULL, NULL, NULL, NULL, 4),
(67488, NULL, 'G3DSA:1.10.840.10:FF:000011', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(67489, NULL, 'G3DSA:2.60.120.20:FF:000001', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(67490, NULL, 'G3DSA:1.20.1250.20:FF:000320', NULL, NULL, 'Monocarboxylate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(67491, NULL, 'G3DSA:3.30.1360.40:FF:000021', NULL, NULL, 'Ribosome recycling factor', NULL, NULL, NULL, NULL, NULL, 4),
(67492, NULL, 'G3DSA:3.30.1360.140:FF:000001', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(67493, NULL, 'G3DSA:2.60.120.260:FF:000097', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(67494, NULL, 'G3DSA:3.40.390.10:FF:000260', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67495, NULL, 'G3DSA:1.10.510.10:FF:000947', NULL, NULL, 'serine/threonine-protein kinase OSR1', NULL, NULL, NULL, NULL, NULL, 4),
(67496, NULL, 'G3DSA:2.60.120.260:FF:000108', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(67497, NULL, 'G3DSA:1.10.640.10:FF:000030', NULL, NULL, 'Myeloperoxidase', NULL, NULL, NULL, NULL, NULL, 4),
(67498, NULL, 'G3DSA:3.90.1150.10:FF:000078', NULL, NULL, 'Kynureninase', NULL, NULL, NULL, NULL, NULL, 4),
(67499, NULL, 'G3DSA:2.130.10.10:FF:004638', NULL, NULL, 'Dynein intermediate chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(67500, NULL, 'G3DSA:2.170.130.10:FF:000045', NULL, NULL, 'Iron(III) compound receptor', NULL, NULL, NULL, NULL, NULL, 4),
(67501, NULL, 'G3DSA:2.30.30.490:FF:000021', NULL, NULL, 'Winged eye, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(67502, NULL, 'G3DSA:2.30.29.30:FF:000263', NULL, NULL, 'Stress activated MAP kinase interacting protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(67503, NULL, 'G3DSA:1.25.40.10:FF:004227', NULL, NULL, 'Pre-mRNA-splicing factor SYF1', NULL, NULL, NULL, NULL, NULL, 4),
(67504, NULL, 'G3DSA:1.10.472.10:FF:000419', NULL, NULL, 'Cyclin-D2-1', NULL, NULL, NULL, NULL, NULL, 4),
(67505, NULL, 'G3DSA:1.10.10.60:FF:000940', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67506, NULL, 'G3DSA:1.25.10.10:FF:002264', NULL, NULL, 'Importin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(67507, NULL, 'G3DSA:3.90.226.10:FF:000233', NULL, NULL, 'ATP-dependent Clp protease proteolytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(67508, NULL, 'G3DSA:1.20.1250.20:FF:001966', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67509, NULL, 'G3DSA:3.30.420.40:FF:000454', NULL, NULL, 'Actin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(67510, NULL, 'G3DSA:3.40.50.720:FF:001971', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67511, NULL, 'G3DSA:3.30.70.141:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67512, NULL, 'G3DSA:1.10.3430.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67513, NULL, 'G3DSA:2.70.70.10:FF:000042', NULL, NULL, 'M23 family peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(67514, NULL, 'G3DSA:3.40.47.10:FF:000217', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67515, NULL, 'G3DSA:3.90.550.10:FF:000492', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67516, NULL, 'G3DSA:3.30.1390.10:FF:000008', NULL, NULL, '50S ribosomal protein L7/L12', NULL, NULL, NULL, NULL, NULL, 4),
(67517, NULL, 'G3DSA:1.20.58.60:FF:000611', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(67518, NULL, 'G3DSA:1.20.120.720:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67519, NULL, 'G3DSA:3.80.10.10:FF:003099', NULL, NULL, 'NACHT, LRR and PYD domains-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(67520, NULL, 'G3DSA:1.10.437.10:FF:000012', NULL, NULL, 'Bcl-2-related protein A1', NULL, NULL, NULL, NULL, NULL, 4),
(67521, NULL, 'G3DSA:3.90.1380.10:FF:000005', NULL, NULL, 'Putative threonine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(67522, NULL, 'G3DSA:3.60.21.10:FF:000438', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67523, NULL, 'G3DSA:1.10.287.130:FF:000042', NULL, NULL, 'Sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(67524, NULL, 'G3DSA:3.40.850.10:FF:000177', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(67525, NULL, 'G3DSA:3.30.740.10:FF:000014', NULL, NULL, 'Dynein light chain', NULL, NULL, NULL, NULL, NULL, 4),
(67526, NULL, 'G3DSA:3.40.50.300:FF:000766', NULL, NULL, 'Recombination factor protein RarA', NULL, NULL, NULL, NULL, NULL, 4),
(67527, NULL, 'G3DSA:3.40.50.1820:FF:000041', NULL, NULL, 'Mesoderm-specific transcript homolog protein', NULL, NULL, NULL, NULL, NULL, 4),
(67528, NULL, 'G3DSA:3.60.10.10:FF:000401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67529, NULL, 'G3DSA:3.30.60.20:FF:000038', NULL, NULL, 'A-kinase anchor protein 13 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(67530, NULL, 'G3DSA:3.30.70.330:FF:002613', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67531, NULL, 'G3DSA:1.25.10.10:FF:000549', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(67532, NULL, 'G3DSA:1.10.510.10:FF:002881', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67533, NULL, 'G3DSA:1.10.472.10:FF:000414', NULL, NULL, 'Putative cyclin L1 variant 2', NULL, NULL, NULL, NULL, NULL, 4),
(67534, NULL, 'G3DSA:3.40.50.720:FF:000083', NULL, NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(67535, NULL, 'G3DSA:3.40.50.620:FF:000513', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(67536, NULL, 'G3DSA:2.60.40.10:FF:002772', NULL, NULL, 'Amalgam, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(67537, NULL, 'G3DSA:2.130.10.10:FF:005021', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(67538, NULL, 'G3DSA:3.30.1010.10:FF:000060', NULL, NULL, 'Phosphatidylinositol 4-kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(67539, NULL, 'G3DSA:3.40.50.300:FF:008551', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67540, NULL, 'G3DSA:3.30.70.2260:FF:000001', NULL, NULL, 'Exopolyphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(67541, NULL, 'G3DSA:1.10.238.10:FF:001174', NULL, NULL, 'Flagellar protofilament ribbon protein rib74; Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67542, NULL, 'G3DSA:3.10.20.90:FF:001007', NULL, NULL, 'FERM domain-containing protein B', NULL, NULL, NULL, NULL, NULL, 4),
(67543, NULL, 'G3DSA:3.30.160.60:FF:001221', NULL, NULL, 'putative transcription factor Ovo-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(67544, NULL, 'G3DSA:1.10.510.10:FF:000638', NULL, NULL, 'Serine/threonine-protein kinase NEK', NULL, NULL, NULL, NULL, NULL, 4),
(67545, NULL, 'G3DSA:2.30.230.10:FF:000030', NULL, NULL, 'Microsomal triglyceride transfer protein large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(67546, NULL, 'G3DSA:1.20.140.40:FF:000066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67547, NULL, 'G3DSA:1.10.510.10:FF:003044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67548, NULL, 'G3DSA:3.30.160.60:FF:003345', NULL, NULL, 'Zinc finger protein 544', NULL, NULL, NULL, NULL, NULL, 4),
(67549, NULL, 'G3DSA:4.10.60.10:FF:000039', NULL, NULL, 'Universal minicircle sequence binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(67550, NULL, 'G3DSA:3.40.50.620:FF:000171', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(67551, NULL, 'G3DSA:1.20.1250.20:FF:002113', NULL, NULL, 'Solute carrier organic anion transporter family, member 6d1', NULL, NULL, NULL, NULL, NULL, 4),
(67552, NULL, 'G3DSA:3.40.50.150:FF:000939', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67553, NULL, 'G3DSA:3.30.40.10:FF:000461', NULL, NULL, 'RING-H2 finger protein ATL66', NULL, NULL, NULL, NULL, NULL, 4),
(67554, NULL, 'G3DSA:3.30.70.330:FF:002922', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67555, NULL, 'G3DSA:3.30.710.10:FF:000068', NULL, NULL, 'Influenza virus NS1A-binding protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(67556, NULL, 'G3DSA:3.20.20.300:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67557, NULL, 'G3DSA:3.60.20.10:FF:000003', NULL, NULL, 'Proteasome subunit beta type-3', NULL, NULL, NULL, NULL, NULL, 4),
(67558, NULL, 'G3DSA:2.30.42.10:FF:000265', NULL, NULL, 'Tail-specific protease', NULL, NULL, NULL, NULL, NULL, 4),
(67559, NULL, 'G3DSA:1.25.10.10:FF:002792', NULL, NULL, 'Ubiquitin homeostasis protein lub1', NULL, NULL, NULL, NULL, NULL, 4),
(67560, NULL, 'G3DSA:3.80.10.10:FF:002334', NULL, NULL, 'OSJNBa0093O08.1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(67561, NULL, 'G3DSA:2.130.10.10:FF:000951', NULL, NULL, 'intraflagellar transport protein 172 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(67562, NULL, 'G3DSA:3.30.497.10:FF:000088', NULL, NULL, 'IP10416p', NULL, NULL, NULL, NULL, NULL, 4),
(67563, NULL, 'G3DSA:2.30.30.40:FF:000157', NULL, NULL, 'adapter molecule crk isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(67564, NULL, 'G3DSA:1.20.120.230:FF:000019', NULL, NULL, 'Catenin alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(67565, NULL, 'G3DSA:2.10.110.10:FF:000328', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67566, NULL, 'G3DSA:1.20.1310.10:FF:000064', NULL, NULL, 'Cullin 4B', NULL, NULL, NULL, NULL, NULL, 4),
(67567, NULL, 'G3DSA:1.10.10.60:FF:000805', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67568, NULL, 'G3DSA:1.20.120.220:FF:000016', NULL, NULL, 'ATP synthase subunit a', NULL, NULL, NULL, NULL, NULL, 4),
(67569, NULL, 'G3DSA:3.30.160.60:FF:000597', NULL, NULL, 'zinc finger protein 236 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(67570, NULL, 'G3DSA:1.10.418.40:FF:000011', NULL, NULL, 'Beclin 2', NULL, NULL, NULL, NULL, NULL, 4),
(67571, NULL, 'G3DSA:1.10.510.10:FF:000296', NULL, NULL, 'Dual specificity mitogen-activated protein kinase kinase 5', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(67572, NULL, 'G3DSA:1.20.150.10:FF:000001', NULL, NULL, 'Egg-lysin', NULL, NULL, NULL, NULL, NULL, 4),
(67573, NULL, 'G3DSA:1.20.5.170:FF:000210', NULL, NULL, 'Male-specific lethal 1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(67574, NULL, 'G3DSA:1.10.510.10:FF:001436', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67575, NULL, 'G3DSA:2.40.320.10:FF:000006', NULL, NULL, 'Phosphoribulokinase / Uridine kinase family', NULL, NULL, NULL, NULL, NULL, 4),
(67576, NULL, 'G3DSA:3.10.129.10:FF:000019', NULL, NULL, 'peroxisomal multifunctional enzyme type 2', NULL, NULL, NULL, NULL, NULL, 4),
(67577, NULL, 'G3DSA:1.10.472.10:FF:000638', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67578, NULL, 'G3DSA:1.50.10.20:FF:000128', NULL, NULL, 'Protein farnesyltransferase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(67579, NULL, 'G3DSA:3.60.20.30:FF:000009', NULL, NULL, 'TASPase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(67580, NULL, 'G3DSA:2.60.450.10:FF:000005', NULL, NULL, 'LPS export ABC transporter periplasmic protein LptC', NULL, NULL, NULL, NULL, NULL, 4),
(67581, NULL, 'G3DSA:3.30.310.40:FF:000007', NULL, NULL, 'DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(67582, NULL, 'G3DSA:2.60.40.1450:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67583, NULL, 'G3DSA:3.40.50.2300:FF:000640', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(67584, NULL, 'G3DSA:2.60.40.10:FF:004907', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67585, NULL, 'G3DSA:3.30.40.10:FF:001888', NULL, NULL, 'RING/U-box superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(67586, NULL, 'G3DSA:1.20.120.610:FF:000010', NULL, NULL, 'V-type proton ATPase subunit c''''1', NULL, NULL, NULL, NULL, NULL, 4),
(67587, NULL, 'G3DSA:2.40.30.10:FF:000529', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67588, NULL, 'G3DSA:1.10.1040.10:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67589, NULL, 'G3DSA:1.10.287.630:FF:000006', NULL, NULL, 'Cyclic Nucleotide Gated channel', NULL, NULL, NULL, NULL, NULL, 4),
(67590, NULL, 'G3DSA:3.90.120.10:FF:000010', NULL, NULL, 'Cytosine-specific DNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(67591, NULL, 'G3DSA:3.30.310.20:FF:000001', NULL, NULL, 'DNA-3-methyladenine glycosylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(67592, NULL, 'G3DSA:3.30.70.270:FF:000212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67593, NULL, 'G3DSA:3.30.920.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67594, NULL, 'G3DSA:3.40.50.300:FF:004509', NULL, NULL, 'Putative elongator complex protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(67595, NULL, 'G3DSA:3.40.50.1820:FF:001687', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67596, NULL, 'G3DSA:3.90.70.10:FF:000679', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67597, NULL, 'G3DSA:1.20.120.1750:FF:000027', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(67598, NULL, 'G3DSA:1.25.40.10:FF:000394', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(67599, NULL, 'G3DSA:2.60.40.10:FF:003042', NULL, NULL, '1,4-alpha-glucan branching enzyme GlgB', NULL, NULL, NULL, NULL, NULL, 4),
(67600, NULL, 'G3DSA:3.30.70.330:FF:002832', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67601, NULL, 'G3DSA:3.30.300.30:FF:000032', NULL, NULL, 'Fatty-acid-CoA ligase FadD19', NULL, NULL, NULL, NULL, NULL, 4),
(67602, NULL, 'G3DSA:2.60.40.10:FF:000636', NULL, NULL, 'Neural cell adhesion molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(67603, NULL, 'G3DSA:1.20.120.310:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67604, NULL, 'G3DSA:1.10.10.60:FF:000721', NULL, NULL, 'Hematopoietically-expressed homeobox protein HHEX', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(67605, NULL, 'G3DSA:3.30.780.10:FF:000033', NULL, NULL, 'Density-regulated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(67606, NULL, 'G3DSA:3.40.50.1820:FF:000057', NULL, NULL, 'Lipase', NULL, NULL, NULL, NULL, NULL, 4),
(67607, NULL, 'G3DSA:1.20.1270.10:FF:000110', NULL, NULL, 'Chaperone protein DnaK', NULL, NULL, NULL, NULL, NULL, 4),
(67608, NULL, 'G3DSA:3.30.540.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67609, NULL, 'G3DSA:3.80.10.10:FF:000535', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(67610, NULL, 'G3DSA:1.20.190.20:FF:000006', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(67611, NULL, 'G3DSA:1.25.40.20:FF:001021', NULL, NULL, 'Ankyrin repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(67612, NULL, 'G3DSA:3.40.309.10:FF:000077', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(67613, NULL, 'G3DSA:2.70.50.50:FF:000002', NULL, NULL, 'Chitin binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(67614, NULL, 'G3DSA:1.25.40.20:FF:000397', NULL, NULL, 'ATP binding', NULL, NULL, NULL, NULL, NULL, 4),
(67615, NULL, 'G3DSA:2.70.98.10:FF:000044', NULL, NULL, 'Aldose 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(67616, NULL, 'G3DSA:2.60.450.20:FF:000008', NULL, NULL, 'T complex protein-10 (Tcp-10b) mRNA', NULL, NULL, NULL, NULL, NULL, 4),
(67617, NULL, 'G3DSA:2.30.42.10:FF:000349', NULL, NULL, 'Periplasmic serine endoprotease DegP-like', NULL, NULL, NULL, NULL, NULL, 4),
(67618, NULL, 'G3DSA:1.25.10.10:FF:002820', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67619, NULL, 'G3DSA:3.40.1090.10:FF:000118', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(67620, NULL, 'G3DSA:1.20.5.170:FF:000064', NULL, NULL, 'fibronectin type III and SPRY domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(67621, NULL, 'G3DSA:1.20.58.60:FF:000156', NULL, NULL, 'Spectrin beta chain, non-erythrocytic', NULL, NULL, NULL, NULL, NULL, 4),
(67622, NULL, 'G3DSA:2.60.40.10:FF:002862', NULL, NULL, 'Cytotoxic and regulatory T-cell molecule', NULL, NULL, NULL, NULL, NULL, 4),
(67623, NULL, 'G3DSA:1.10.510.10:FF:000964', NULL, NULL, 'CMGC/CDK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(67624, NULL, 'G3DSA:1.10.3380.30:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67625, NULL, 'G3DSA:3.30.70.330:FF:002467', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67626, NULL, 'G3DSA:2.60.260.20:FF:000157', NULL, NULL, 'AGAP007565-PB', NULL, NULL, NULL, NULL, NULL, 4),
(67627, NULL, 'G3DSA:3.40.50.1820:FF:001468', NULL, NULL, 'Baculoviral IAP repeat-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(67628, NULL, 'G3DSA:2.130.10.10:FF:004655', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67629, NULL, 'G3DSA:1.20.1070.10:FF:001539', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(67630, NULL, 'G3DSA:3.30.40.10:FF:001765', NULL, NULL, 'Receptor homology region transmembrane domain-and RING domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(67631, NULL, 'G3DSA:3.30.70.270:FF:000083', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(67632, NULL, 'G3DSA:2.130.10.10:FF:002749', NULL, NULL, 'YALI0E03542p', NULL, NULL, NULL, NULL, NULL, 4),
(67633, NULL, 'G3DSA:3.100.10.10:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67634, NULL, 'G3DSA:3.30.750.24:FF:000073', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(67635, NULL, 'G3DSA:2.30.180.10:FF:000177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67636, NULL, 'G3DSA:3.80.10.10:FF:000209', NULL, NULL, 'leucine-rich repeat and fibronectin type-III domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(67637, NULL, 'G3DSA:2.40.50.90:FF:000150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67638, NULL, 'G3DSA:2.60.40.10:FF:004346', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(67639, NULL, 'G3DSA:3.30.430.20:FF:000050', NULL, NULL, 'Putative cysteine-rich receptor-like protein kinase 43', NULL, NULL, NULL, NULL, NULL, 4),
(67640, NULL, 'G3DSA:3.40.50.300:FF:003082', NULL, NULL, 'PhoH family protein', NULL, NULL, NULL, NULL, NULL, 4),
(67641, NULL, 'G3DSA:3.10.20.90:FF:000299', NULL, NULL, 'Rad23p', NULL, NULL, NULL, NULL, NULL, 4),
(67642, NULL, 'G3DSA:3.30.559.10:FF:000204', NULL, NULL, 'Carnitine O-palmitoyltransferase 2, mitochondrial-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(67643, NULL, 'G3DSA:1.10.238.10:FF:001320', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67644, NULL, 'G3DSA:1.10.260.40:FF:000060', NULL, NULL, 'LacI family DNA-binding transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(67645, NULL, 'G3DSA:4.10.280.10:FF:000001', NULL, NULL, 'Putative transcription factor 12', NULL, NULL, NULL, NULL, NULL, 4),
(67646, NULL, 'G3DSA:1.10.238.10:FF:000831', NULL, NULL, 'GD19277', NULL, NULL, NULL, NULL, NULL, 4),
(67647, NULL, 'G3DSA:3.30.200.20:FF:000095', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 12', NULL, NULL, NULL, NULL, NULL, 4),
(67648, NULL, 'G3DSA:1.20.1050.130:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67649, NULL, 'G3DSA:3.40.50.460:FF:000004', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(67650, NULL, 'G3DSA:3.40.50.2300:FF:000437', NULL, NULL, 'LuxR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(67651, NULL, 'G3DSA:3.30.160.60:FF:003019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67652, NULL, 'G3DSA:3.30.70.1990:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67653, NULL, 'G3DSA:3.90.79.10:FF:000244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67654, NULL, 'G3DSA:2.40.50.140:FF:000356', NULL, NULL, 'Single-stranded DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(67655, NULL, 'G3DSA:3.10.110.10:FF:000319', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67656, NULL, 'G3DSA:3.30.70.330:FF:002815', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67657, NULL, 'G3DSA:3.90.1150.10:FF:000415', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67658, NULL, 'G3DSA:3.90.25.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67659, NULL, 'G3DSA:3.30.450.60:FF:000012', NULL, NULL, 'AP-3 complex subunit mu-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(67660, NULL, 'G3DSA:3.30.160.60:FF:003238', NULL, NULL, 'Zinc finger protein 341', NULL, NULL, NULL, NULL, NULL, 4),
(67661, NULL, 'G3DSA:2.30.30.40:FF:000376', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(67662, NULL, 'G3DSA:3.30.780.10:FF:000016', NULL, NULL, 'eukaryotic translation initiation factor 2D', NULL, NULL, NULL, NULL, NULL, 4),
(67663, NULL, 'G3DSA:1.20.1070.10:FF:000128', NULL, NULL, 'Seven TM Receptor', NULL, NULL, NULL, NULL, NULL, 4),
(67664, NULL, 'G3DSA:4.10.80.160:FF:000002', NULL, NULL, 'Putative regulator of nonsense transcripts 2', NULL, NULL, NULL, NULL, NULL, 4),
(67665, NULL, 'G3DSA:2.60.40.4060:FF:000006', NULL, NULL, 'Reelin', NULL, NULL, NULL, NULL, NULL, 4),
(67666, NULL, 'G3DSA:3.30.2310.40:FF:000001', NULL, NULL, 'mRNA interferase toxin MqsR', NULL, NULL, NULL, NULL, NULL, 4),
(67667, NULL, 'G3DSA:2.60.40.150:FF:000768', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67668, NULL, 'G3DSA:3.90.550.10:FF:000576', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67669, NULL, 'G3DSA:2.60.40.60:FF:000393', NULL, NULL, 'Cadherin-23', NULL, NULL, NULL, NULL, NULL, 4),
(67670, NULL, 'G3DSA:2.60.40.4070:FF:000009', NULL, NULL, 'OmpA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(67671, NULL, 'G3DSA:2.10.25.10:FF:000092', NULL, NULL, 'Neurogenic locus notch protein 1', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(67672, NULL, 'G3DSA:1.10.132.60:FF:000027', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(67673, NULL, 'G3DSA:3.40.50.300:FF:003424', NULL, NULL, 'Developmentally-regulated GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(67674, NULL, 'G3DSA:3.40.50.300:FF:000783', NULL, NULL, 'DEAD-box ATP-dependent RNA helicase CshA', NULL, NULL, NULL, NULL, NULL, 4),
(67675, NULL, 'G3DSA:3.30.40.10:FF:002035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67676, NULL, 'G3DSA:3.90.950.10:FF:000022', NULL, NULL, 'Inosine triphosphate pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(67677, NULL, 'G3DSA:3.80.10.10:FF:001839', NULL, NULL, '2mit, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(67678, NULL, 'G3DSA:3.30.50.10:FF:000063', NULL, NULL, 'CRE-NHR-48 protein', NULL, NULL, NULL, NULL, NULL, 4),
(67679, NULL, 'G3DSA:2.170.270.10:FF:000078', NULL, NULL, 'SMYD family member 5', NULL, NULL, NULL, NULL, NULL, 4),
(67680, NULL, 'G3DSA:3.40.50.12230:FF:000009', NULL, NULL, '10-formyltetrahydrofolate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(67681, NULL, 'G3DSA:1.10.510.10:FF:001004', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(67682, NULL, 'G3DSA:3.30.50.10:FF:000102', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(67683, NULL, 'G3DSA:3.40.190.10:FF:000508', NULL, NULL, 'Dipeptide ABC transporter (Dipeptide-binding protein)', NULL, NULL, NULL, NULL, NULL, 4),
(67684, NULL, 'G3DSA:1.10.510.10:FF:003353', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67685, NULL, 'G3DSA:3.40.367.20:FF:000017', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(67686, NULL, 'G3DSA:1.25.10.10:FF:000566', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(67687, NULL, 'G3DSA:2.10.25.10:FF:000221', NULL, NULL, 'Protein kinase C-binding protein NELL1', NULL, NULL, NULL, NULL, NULL, 4),
(67688, NULL, 'G3DSA:3.40.225.10:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67689, NULL, 'G3DSA:1.10.730.10:FF:000059', NULL, NULL, 'Arginine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(67690, NULL, 'G3DSA:3.30.40.10:FF:000680', NULL, NULL, 'Putative RING zinc finger domain superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(67691, NULL, 'G3DSA:1.20.1070.10:FF:002034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67692, NULL, 'G3DSA:3.40.50.620:FF:000732', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67693, NULL, 'G3DSA:3.40.50.300:FF:006297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67694, NULL, 'G3DSA:3.40.50.11660:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67695, NULL, 'G3DSA:3.30.710.10:FF:000175', NULL, NULL, 'Bric-a-brac', NULL, NULL, NULL, NULL, NULL, 4),
(67696, NULL, 'G3DSA:3.80.10.10:FF:004161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67697, NULL, 'G3DSA:1.25.10.10:FF:000656', NULL, NULL, 'AP-1 complex subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(67698, NULL, 'G3DSA:3.30.40.10:FF:002254', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(67699, NULL, 'G3DSA:3.10.350.10:FF:000090', NULL, NULL, 'Os01g0546000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(67700, NULL, 'G3DSA:1.10.10.10:FF:001083', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC6', NULL, NULL, NULL, NULL, NULL, 4),
(67701, NULL, 'G3DSA:1.25.40.10:FF:000068', NULL, NULL, 'Anaphase promoting complex subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(67702, NULL, 'G3DSA:3.30.1540.20:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67703, NULL, 'G3DSA:2.130.10.10:FF:000816', NULL, NULL, 'Probable cytosolic iron-sulfur protein assembly protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(67704, NULL, 'G3DSA:1.25.40.10:FF:001208', NULL, NULL, 'Tetratricopeptide repeat domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(67705, NULL, 'G3DSA:3.60.40.10:FF:000201', NULL, NULL, 'Protein phosphatase, Mg2+/Mn2+-dependent, 1K', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(67706, NULL, 'G3DSA:3.30.200.20:FF:000443', NULL, NULL, 'Serine/threonine-protein kinase/endoribonuclease IRE1', NULL, NULL, NULL, NULL, NULL, 4),
(67707, NULL, 'G3DSA:3.30.980.20:FF:000001', NULL, NULL, 'Glucosyl-3-phosphoglycerate/mannosyl-3-phosphoglycerate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(67708, NULL, 'G3DSA:3.30.70.330:FF:002506', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67709, NULL, 'G3DSA:3.50.50.60:FF:000335', NULL, NULL, 'Nitrite reductase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(67710, NULL, 'G3DSA:3.30.2080.10:FF:000007', NULL, NULL, 'Alpha-1,2-mannosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(67711, NULL, 'G3DSA:1.20.150.20:FF:000004', NULL, NULL, 'ATP synthase subunit alpha, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(67712, NULL, 'G3DSA:3.90.320.10:FF:000070', NULL, NULL, 'Superfamily I DNA and RNA helicase and helicase subunits-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(67713, NULL, 'G3DSA:1.10.8.440:FF:000001', NULL, NULL, 'Phosphoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(67714, NULL, 'G3DSA:3.90.226.10:FF:000087', NULL, NULL, 'Si:ch211-198n5.11', NULL, NULL, NULL, NULL, NULL, 4),
(67715, NULL, 'G3DSA:1.25.40.10:FF:000719', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(67716, NULL, 'G3DSA:3.10.20.820:FF:000001', NULL, NULL, 'Succinate dehydrogenase flavoprotein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(67717, NULL, 'G3DSA:1.25.40.770:FF:000010', NULL, NULL, 'Transcription initiation factor TFIID subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(67718, NULL, 'G3DSA:3.40.50.1000:FF:000469', NULL, NULL, 'AT02326p', NULL, NULL, NULL, NULL, NULL, 4),
(67719, NULL, 'G3DSA:2.60.120.740:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67720, NULL, 'G3DSA:2.40.180.10:FF:000017', NULL, NULL, 'Catalase-related peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(67721, NULL, 'G3DSA:3.30.160.60:FF:004891', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67722, NULL, 'G3DSA:2.30.30.30:FF:000154', NULL, NULL, '54S ribosomal protein L40, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(67723, NULL, 'G3DSA:3.30.565.10:FF:000455', NULL, NULL, 'Flagellar sensor histidine kinase FleS', NULL, NULL, NULL, NULL, NULL, 4),
(67724, NULL, 'G3DSA:3.40.1770.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67725, NULL, 'G3DSA:3.40.50.720:FF:000212', NULL, NULL, 'Glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(67726, NULL, 'G3DSA:2.60.40.10:FF:003261', NULL, NULL, 'GM10182', NULL, NULL, NULL, NULL, NULL, 4),
(67727, NULL, 'G3DSA:3.40.350.10:FF:000044', NULL, NULL, 'Metallopeptidase, family M24', NULL, NULL, NULL, NULL, NULL, 4),
(67728, NULL, 'G3DSA:2.130.10.30:FF:000142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67729, NULL, 'G3DSA:3.10.290.20:FF:000014', NULL, NULL, 'Ubiquitin-activating enzyme E1-like', NULL, NULL, NULL, NULL, NULL, 4),
(67730, NULL, 'G3DSA:2.30.30.40:FF:000466', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67731, NULL, 'G3DSA:3.40.50.2300:FF:000314', NULL, NULL, 'Multi-sensor hybrid histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(67732, NULL, 'G3DSA:3.40.570.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67733, NULL, 'G3DSA:3.90.1150.10:FF:000106', NULL, NULL, 'Related to acetylornithine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(67734, NULL, 'G3DSA:3.40.50.300:FF:004835', NULL, NULL, 'Mitochondrial Rho GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(67735, NULL, 'G3DSA:3.90.640.10:FF:000009', NULL, NULL, 'Actin-like 6A, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(67736, NULL, 'G3DSA:1.25.40.20:FF:001240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67737, NULL, 'G3DSA:1.10.3720.10:FF:000064', NULL, NULL, 'ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(67738, NULL, 'G3DSA:3.30.160.60:FF:004649', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(67739, NULL, 'G3DSA:3.30.1370.10:FF:000232', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(67740, NULL, 'G3DSA:1.20.1070.10:FF:001854', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67741, NULL, 'G3DSA:1.25.40.10:FF:004429', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67742, NULL, 'G3DSA:3.40.850.10:FF:000323', NULL, NULL, 'Kinesin-like protein KLP1', NULL, NULL, NULL, NULL, NULL, 4),
(67743, NULL, 'G3DSA:3.20.20.150:FF:000056', NULL, NULL, 'Probable ketose 3-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(67744, NULL, 'G3DSA:3.40.50.300:FF:003402', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(67745, NULL, 'G3DSA:1.20.5.2120:FF:000001', NULL, NULL, 'Integrin alpha L', NULL, NULL, NULL, NULL, NULL, 4),
(67746, NULL, 'G3DSA:3.30.450.20:FF:000141', NULL, NULL, 'Similar, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(67747, NULL, 'G3DSA:2.170.260.40:FF:000007', NULL, NULL, '5''-3'' exoribonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(67748, NULL, 'G3DSA:3.55.40.20:FF:000014', NULL, NULL, 'Superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(67749, NULL, 'G3DSA:3.40.50.300:FF:002784', NULL, NULL, 'Structural maintenance of chromosomes', NULL, NULL, NULL, NULL, NULL, 4),
(67750, NULL, 'G3DSA:3.20.20.70:FF:000787', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67751, NULL, 'G3DSA:1.10.510.10:FF:001330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67752, NULL, 'G3DSA:3.40.50.300:FF:007134', NULL, NULL, 'Unclassified GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(67753, NULL, 'G3DSA:3.40.50.1240:FF:000092', NULL, NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(67754, NULL, 'G3DSA:3.10.100.10:FF:000392', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67755, NULL, 'G3DSA:2.40.70.10:FF:000274', NULL, NULL, 'Putative aspartic endopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(67756, NULL, 'G3DSA:3.60.15.10:FF:000261', NULL, NULL, 'Ribonuclease Z, putative', NULL, NULL, NULL, NULL, NULL, 4),
(67757, NULL, 'G3DSA:2.130.10.10:FF:002385', NULL, NULL, 'Rtt10p', NULL, NULL, NULL, NULL, NULL, 4),
(67758, NULL, 'G3DSA:3.30.465.10:FF:000082', NULL, NULL, 'Hemolysins-related protein containing CBS domains', NULL, NULL, NULL, NULL, NULL, 4),
(67759, NULL, 'G3DSA:1.10.472.10:FF:000184', NULL, NULL, 'CTD kinase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(67760, NULL, 'G3DSA:3.75.10.10:FF:000020', NULL, NULL, 'Glycine amidinotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(67761, NULL, 'G3DSA:2.130.10.10:FF:003003', NULL, NULL, 'WD repeat domain 60', NULL, NULL, NULL, NULL, NULL, 4),
(67762, NULL, 'G3DSA:1.20.1250.20:FF:001949', NULL, NULL, 'Facilitated trehalose transporter Tret1-2 homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(67763, NULL, 'G3DSA:2.60.40.1930:FF:000030', NULL, NULL, 'Cpras2, large protein with the cpRAS domain', NULL, NULL, NULL, NULL, NULL, 4),
(67764, NULL, 'G3DSA:3.30.428.10:FF:000013', NULL, NULL, 'Hit family protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(67765, NULL, 'G3DSA:3.80.10.10:FF:003554', NULL, NULL, 'Si:zfos-323e3.4', NULL, NULL, NULL, NULL, NULL, 4),
(67766, NULL, 'G3DSA:2.60.260.20:FF:000179', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(67767, NULL, 'G3DSA:3.40.30.10:FF:000887', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(67768, NULL, 'G3DSA:2.30.30.100:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67769, NULL, 'G3DSA:3.40.1280.10:FF:000037', NULL, NULL, 'RNA methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(67770, NULL, 'G3DSA:3.30.160.60:FF:004565', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67771, NULL, 'G3DSA:3.90.660.10:FF:000117', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67772, NULL, 'G3DSA:3.30.390.50:FF:000004', NULL, NULL, 'Xanthine dehydrogenase, FAD binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(67773, NULL, 'G3DSA:3.10.290.20:FF:000020', NULL, NULL, 'Ubiquitin-activating enzyme E1b, putative', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(67774, NULL, 'G3DSA:2.60.40.10:FF:003025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67775, NULL, 'G3DSA:3.90.1150.10:FF:000331', NULL, NULL, 'Adenosylmethionine-8-amino-7-oxononanoate aminotransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(67776, NULL, 'G3DSA:1.10.238.10:FF:000685', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(67777, NULL, 'G3DSA:2.40.100.10:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67778, NULL, 'G3DSA:3.30.200.20:FF:000459', NULL, NULL, 'Wall-associated receptor kinase-like 8', NULL, NULL, NULL, NULL, NULL, 4),
(67779, NULL, 'G3DSA:2.20.70.10:FF:000241', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(67780, NULL, 'G3DSA:1.10.10.10:FF:000476', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(67781, NULL, 'G3DSA:1.25.40.10:FF:004901', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67782, NULL, 'G3DSA:3.30.1330.10:FF:000016', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(67783, NULL, 'G3DSA:2.60.120.260:FF:000552', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67784, NULL, 'G3DSA:3.30.70.330:FF:002271', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67785, NULL, 'G3DSA:1.20.58.60:FF:000482', NULL, NULL, 'Spectrin repeat containing, nuclear envelope 1a', NULL, NULL, NULL, NULL, NULL, 4),
(67786, NULL, 'G3DSA:3.30.2350.10:FF:000017', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(67787, NULL, 'G3DSA:3.40.50.720:FF:002336', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(67788, NULL, 'G3DSA:3.30.160.60:FF:001440', NULL, NULL, 'Zinc finger homeobox protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(67789, NULL, 'G3DSA:3.50.50.60:FF:000026', NULL, NULL, 'Succinate dehydrogenase flavoprotein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(67790, NULL, 'G3DSA:3.40.50.300:FF:006527', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67791, NULL, 'G3DSA:2.40.70.10:FF:000268', NULL, NULL, 'Aspartic peptidase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(67792, NULL, 'G3DSA:3.40.190.10:FF:000514', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(67793, NULL, 'G3DSA:1.25.10.10:FF:002819', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67794, NULL, 'G3DSA:2.60.120.200:FF:000208', NULL, NULL, 'Blast:Protein eyes shut', NULL, NULL, NULL, NULL, NULL, 4),
(67795, NULL, 'G3DSA:3.40.1390.30:FF:000023', NULL, NULL, 'GTP cyclohydrolase 1 type 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(67796, NULL, 'G3DSA:3.80.10.10:FF:001845', NULL, NULL, 'PH domain leucine-rich repeat-containing protein phosphatase 1 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(67797, NULL, 'G3DSA:1.20.1440.180:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67798, NULL, 'G3DSA:1.10.420.10:FF:000047', NULL, NULL, 'Putative L-ascorbate peroxidase 6', NULL, NULL, NULL, NULL, NULL, 4),
(67799, NULL, 'G3DSA:3.80.10.10:FF:003969', NULL, NULL, 'Toll-like receptor 1-like protein b', NULL, NULL, NULL, NULL, NULL, 4),
(67800, NULL, 'G3DSA:1.20.1560.10:FF:000301', NULL, NULL, 'AGAP009835-PA', NULL, NULL, NULL, NULL, NULL, 4),
(67801, NULL, 'G3DSA:1.20.1160.11:FF:000007', NULL, NULL, 'paired amphipathic helix protein Sin3b', NULL, NULL, NULL, NULL, NULL, 4),
(67802, NULL, 'G3DSA:3.90.180.10:FF:000081', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(67803, NULL, 'G3DSA:2.130.10.10:FF:000732', NULL, NULL, 'EARP-interacting protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(67804, NULL, 'G3DSA:3.30.70.330:FF:000562', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(67805, NULL, 'G3DSA:1.20.1510.10:FF:000045', NULL, NULL, 'Cation diffusion facilitator family protein 1', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(67806, NULL, 'G3DSA:3.30.40.10:FF:001782', NULL, NULL, 'Tnf receptor-associated factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(67807, NULL, 'G3DSA:4.10.60.10:FF:000258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67808, NULL, 'G3DSA:3.90.79.10:FF:000098', NULL, NULL, 'MutT/nudix family protein', NULL, NULL, NULL, NULL, NULL, 4),
(67809, NULL, 'G3DSA:1.20.5.190:FF:000087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67810, NULL, 'G3DSA:1.10.238.10:FF:001303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67811, NULL, 'G3DSA:1.25.10.10:FF:001044', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(67812, NULL, 'G3DSA:3.40.50.10190:FF:000010', NULL, NULL, 'DNA topoisomerase II binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(67813, NULL, 'G3DSA:3.20.20.300:FF:000028', NULL, NULL, 'Thermostable beta-glucosidase B', NULL, NULL, NULL, NULL, NULL, 4),
(67814, NULL, 'G3DSA:1.10.3720.10:FF:000148', NULL, NULL, 'Amino acid ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(67815, NULL, 'G3DSA:3.30.430.20:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67816, NULL, 'G3DSA:2.60.40.10:FF:003351', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67817, NULL, 'G3DSA:2.60.40.60:FF:000718', NULL, NULL, 'Cdh-4', NULL, NULL, NULL, NULL, NULL, 4),
(67818, NULL, 'G3DSA:1.20.58.670:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67819, NULL, 'G3DSA:3.30.720.50:FF:000002', NULL, NULL, 'Putative e3 ubiquitin-protein ligase huwe1 isoform x2', NULL, NULL, NULL, NULL, NULL, 4),
(67820, NULL, 'G3DSA:3.90.70.10:FF:000718', NULL, NULL, 'AGAP001960-PA', NULL, NULL, NULL, NULL, NULL, 4),
(67821, NULL, 'G3DSA:3.40.250.10:FF:000120', NULL, NULL, 'Adenylyltransferase and sulfurtransferase MOCS3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(67822, NULL, 'G3DSA:3.10.100.10:FF:000279', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67823, NULL, 'G3DSA:1.10.510.10:FF:004455', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67824, NULL, 'G3DSA:3.30.2060.10:FF:000006', NULL, NULL, 'Penicillin-binding protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(67825, NULL, 'G3DSA:2.40.110.10:FF:000069', NULL, NULL, 'Acyl-CoA oxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(67826, NULL, 'G3DSA:3.40.50.300:FF:005532', NULL, NULL, 'RNA polymerase II elongator complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(67827, NULL, 'G3DSA:1.10.150.20:FF:000203', NULL, NULL, 'Flap endonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(67828, NULL, 'G3DSA:3.10.129.10:FF:000036', NULL, NULL, 'Acyl-ACP thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(67829, NULL, 'G3DSA:2.60.40.640:FF:000039', NULL, NULL, 'GM14300', NULL, NULL, NULL, NULL, NULL, 4),
(67830, NULL, 'G3DSA:1.10.510.10:FF:004348', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67831, NULL, 'G3DSA:1.10.2020.20:FF:000002', NULL, NULL, '26S proteasome regulatory subunit RPN13', NULL, NULL, NULL, NULL, NULL, 4),
(67832, NULL, 'G3DSA:1.10.10.60:FF:001103', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67833, NULL, 'G3DSA:1.25.40.10:FF:002176', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(67834, NULL, 'G3DSA:3.40.50.300:FF:003391', NULL, NULL, 'ATP-dependent RNA helicase MAK5', NULL, NULL, NULL, NULL, NULL, 4),
(67835, NULL, 'G3DSA:3.50.30.30:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67836, NULL, 'G3DSA:2.20.70.10:FF:000128', NULL, NULL, 'WW domain-containing protein tag-325', NULL, NULL, NULL, NULL, NULL, 4),
(67837, NULL, 'G3DSA:3.40.190.290:FF:000028', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(67838, NULL, 'G3DSA:3.30.200.20:FF:000802', NULL, NULL, 'Ephrin receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(67839, NULL, 'G3DSA:3.30.70.330:FF:000343', NULL, NULL, 'RNA-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(67840, NULL, 'G3DSA:3.30.110.20:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(67841, NULL, 'G3DSA:3.30.565.10:FF:000039', NULL, NULL, 'Sensor histidine kinase BtsS', NULL, NULL, NULL, NULL, NULL, 4),
(67842, NULL, 'G3DSA:3.30.70.1440:FF:000002', NULL, NULL, 'Multidrug resistance protein MdtC', NULL, NULL, NULL, NULL, NULL, 4),
(67843, NULL, 'G3DSA:3.10.129.10:FF:000238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67844, NULL, 'G3DSA:1.20.5.340:FF:000059', NULL, NULL, 'Myosin-3', NULL, NULL, NULL, NULL, NULL, 4),
(67845, NULL, 'G3DSA:3.40.50.2300:FF:000331', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(67846, NULL, 'G3DSA:1.10.730.10:FF:000166', NULL, NULL, 'Methionine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(67847, NULL, 'G3DSA:3.90.70.10:FF:000825', NULL, NULL, 'Ubiquitin-specific protease', NULL, NULL, NULL, NULL, NULL, 4),
(67848, NULL, 'G3DSA:3.40.630.10:FF:000318', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67849, NULL, 'G3DSA:3.30.60.190:FF:000012', NULL, NULL, 'Putative box C/D snoRNA protein SPCC613.07', NULL, NULL, NULL, NULL, NULL, 4),
(67850, NULL, 'G3DSA:3.30.56.50:FF:000003', NULL, NULL, 'Translation initiation factor IF-2', NULL, NULL, NULL, NULL, NULL, 4),
(67851, NULL, 'G3DSA:2.170.270.10:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67852, NULL, 'G3DSA:1.10.10.10:FF:001190', NULL, NULL, 'HTH-type transcriptional regulator NsrR', NULL, NULL, NULL, NULL, NULL, 4),
(67853, NULL, 'G3DSA:1.10.3460.10:FF:000021', NULL, NULL, 'Chlorophyll a-b binding protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(67854, NULL, 'G3DSA:2.20.100.10:FF:000073', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 9 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(67855, NULL, 'G3DSA:3.40.30.10:FF:001185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67856, NULL, 'G3DSA:3.60.90.10:FF:000030', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(67857, NULL, 'G3DSA:1.10.1450.10:FF:000172', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(67858, NULL, 'G3DSA:1.10.10.10:FF:000695', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC3', NULL, NULL, NULL, NULL, NULL, 4),
(67859, NULL, 'G3DSA:2.60.40.10:FF:003244', NULL, NULL, 'Defective proboscis extension response', NULL, NULL, NULL, NULL, NULL, 4),
(67860, NULL, 'G3DSA:1.20.5.220:FF:000006', NULL, NULL, 'Transcriptional regulator, MarR family', NULL, NULL, NULL, NULL, NULL, 4),
(67861, NULL, 'G3DSA:2.60.40.1450:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67862, NULL, 'G3DSA:3.60.10.10:FF:000053', NULL, NULL, 'Type IV inositol polyphosphate 5-phosphatase 9', NULL, NULL, NULL, NULL, NULL, 4),
(67863, NULL, 'G3DSA:1.20.1310.10:FF:000148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67864, NULL, 'G3DSA:1.20.1250.10:FF:000002', NULL, NULL, 'Growth hormone', NULL, NULL, NULL, NULL, NULL, 4),
(67865, NULL, 'G3DSA:2.70.98.10:FF:000027', NULL, NULL, 'Aldose 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(67866, NULL, 'G3DSA:3.30.160.60:FF:001131', NULL, NULL, 'Zinc finger protein 462', NULL, NULL, NULL, NULL, NULL, 4),
(67867, NULL, 'G3DSA:3.40.47.10:FF:000307', NULL, NULL, 'Polyketide synthase RzxD', NULL, NULL, NULL, NULL, NULL, 4),
(67868, NULL, 'G3DSA:1.20.5.210:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67869, NULL, 'G3DSA:1.10.3430.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67870, NULL, 'G3DSA:3.40.50.300:FF:004818', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67871, NULL, 'G3DSA:3.30.110.10:FF:000011', NULL, NULL, 'Translation initiation factor IF-3', NULL, NULL, NULL, NULL, NULL, 4),
(67872, NULL, 'G3DSA:2.60.40.10:FF:004880', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67873, NULL, 'G3DSA:1.20.1250.20:FF:000005', NULL, NULL, 'vesicular glutamate transporter 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(67874, NULL, 'G3DSA:3.40.1090.10:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(67875, NULL, 'G3DSA:2.130.10.10:FF:002856', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(67876, NULL, 'G3DSA:1.25.40.320:FF:000004', NULL, NULL, 'Peptidase M1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(67877, NULL, 'G3DSA:4.10.1060.10:FF:000010', NULL, NULL, 'Calpain 15', NULL, NULL, NULL, NULL, NULL, 4),
(67878, NULL, 'G3DSA:2.60.120.690:FF:000001', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 9', NULL, NULL, NULL, NULL, NULL, 4),
(67879, NULL, 'G3DSA:1.20.1070.10:FF:000544', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(67880, NULL, 'G3DSA:1.20.58.60:FF:000173', NULL, NULL, 'Spectrin repeat containing nuclear envelope protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(67881, NULL, 'G3DSA:3.40.50.620:FF:000530', NULL, NULL, 'Arginyl-tRNA synthetase 2, mitochondrial (putative)', NULL, NULL, NULL, NULL, NULL, 4),
(67882, NULL, 'G3DSA:3.40.50.170:FF:000002', NULL, NULL, '10-formyltetrahydrofolate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(67883, NULL, 'G3DSA:3.10.50.10:FF:000035', NULL, NULL, 'Protein CBG22612', NULL, NULL, NULL, NULL, NULL, 4),
(67884, NULL, 'G3DSA:1.20.58.60:FF:000263', NULL, NULL, 'Alpha spectrin, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(67885, NULL, 'G3DSA:1.10.510.10:FF:000857', NULL, NULL, 'NEK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(67886, NULL, 'G3DSA:1.20.1050.10:FF:000021', NULL, NULL, 'Elongation factor 1-gamma', NULL, NULL, NULL, NULL, NULL, 4),
(67887, NULL, 'G3DSA:2.60.40.10:FF:002637', NULL, NULL, 'Zwei Ig domain protein zig-8', NULL, NULL, NULL, NULL, NULL, 4),
(67888, NULL, 'G3DSA:3.40.50.150:FF:000608', NULL, NULL, 'Putative s-adenosylmethionine-dependent methyltransferase superfamily domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(67889, NULL, 'G3DSA:2.40.50.90:FF:000133', NULL, NULL, 'FI02030p', NULL, NULL, NULL, NULL, NULL, 4),
(67890, NULL, 'G3DSA:3.40.50.150:FF:000940', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67891, NULL, 'G3DSA:3.40.50.720:FF:000560', NULL, NULL, 'SUMO activating enzyme (AosA), putative', NULL, NULL, NULL, NULL, NULL, 4),
(67892, NULL, 'G3DSA:2.130.10.10:FF:003222', NULL, NULL, 'WD-repeat membrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(67893, NULL, 'G3DSA:1.20.1080.10:FF:000045', NULL, NULL, 'Formate/nitrite transporter family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(67894, NULL, 'G3DSA:3.90.1410.10:FF:000149', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(67895, NULL, 'G3DSA:3.40.50.1000:FF:000576', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67896, NULL, 'G3DSA:1.25.40.310:FF:000001', NULL, NULL, 'Aconitate hydratase B', NULL, NULL, NULL, NULL, NULL, 4),
(67897, NULL, 'G3DSA:1.10.10.10:FF:000947', NULL, NULL, 'WGS project CABT00000000 data, contig 2.2', NULL, NULL, NULL, NULL, NULL, 4),
(67898, NULL, 'G3DSA:3.30.160.60:FF:003036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67899, NULL, 'G3DSA:3.30.40.10:FF:000146', NULL, NULL, 'RING/FYVE/PHD zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(67900, NULL, 'G3DSA:1.20.1050.130:FF:000014', NULL, NULL, 'Putative glutathione S-transferase alpha-5', NULL, NULL, NULL, NULL, NULL, 4),
(67901, NULL, 'G3DSA:2.30.29.30:FF:000611', NULL, NULL, 'Motor AXon guidance', NULL, NULL, NULL, NULL, NULL, 4),
(67902, NULL, 'G3DSA:3.50.50.60:FF:000228', NULL, NULL, 'FAD-containing monooxygenase EthA', NULL, NULL, NULL, NULL, NULL, 4),
(67903, NULL, 'G3DSA:3.30.1370.10:FF:000125', NULL, NULL, 'Scp160p', NULL, NULL, NULL, NULL, NULL, 4),
(67904, NULL, 'G3DSA:1.10.287.110:FF:000396', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(67905, NULL, 'G3DSA:2.60.120.200:FF:000540', NULL, NULL, 'Sex hormone-binding globulin', NULL, NULL, NULL, NULL, NULL, 4),
(67906, NULL, 'G3DSA:3.40.50.1000:FF:000828', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67907, NULL, 'G3DSA:3.30.497.10:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67908, NULL, 'G3DSA:1.10.20.10:FF:000196', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(67909, NULL, 'G3DSA:1.10.246.90:FF:000002', NULL, NULL, 'U4/U6 small nuclear ribonucleoprotein Prp31', NULL, NULL, NULL, NULL, NULL, 4),
(67910, NULL, 'G3DSA:1.10.10.1320:FF:000011', NULL, NULL, 'Glr1159 protein', NULL, NULL, NULL, NULL, NULL, 4),
(67911, NULL, 'G3DSA:1.10.3660.10:FF:000002', NULL, NULL, 'Prephenate dehydrogenase [NADP(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(67912, NULL, 'G3DSA:1.25.10.10:FF:000791', NULL, NULL, 'SERAC1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(67913, NULL, 'G3DSA:3.30.160.60:FF:004784', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67914, NULL, 'G3DSA:3.30.70.1450:FF:000005', NULL, NULL, 'Citrate transporter protein', NULL, NULL, NULL, NULL, NULL, 4),
(67915, NULL, 'G3DSA:1.25.10.10:FF:003062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67916, NULL, 'G3DSA:2.30.29.30:FF:000302', NULL, NULL, 'Rho GTPase-activating protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(67917, NULL, 'G3DSA:3.40.50.1100:FF:000297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67918, NULL, 'G3DSA:2.170.270.10:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67919, NULL, 'G3DSA:3.20.140.10:FF:000009', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(67920, NULL, 'G3DSA:3.30.565.10:FF:000348', NULL, NULL, 'Lost Adherence Sensor, LadS', NULL, NULL, NULL, NULL, NULL, 4),
(67921, NULL, 'G3DSA:3.10.450.40:FF:000011', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(67922, NULL, 'G3DSA:1.10.510.10:FF:003128', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67923, NULL, 'G3DSA:1.25.40.330:FF:000007', NULL, NULL, 'Adenylyl cyclase-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(67924, NULL, 'G3DSA:3.40.50.12230:FF:000026', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(67925, NULL, 'G3DSA:2.170.130.10:FF:000023', NULL, NULL, 'SusC/RagA family TonB-linked outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(67926, NULL, 'G3DSA:3.40.50.170:FF:000024', NULL, NULL, 'Methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(67927, NULL, 'G3DSA:3.40.30.10:FF:000578', NULL, NULL, '[Fe] hydrogenase, HymA subunit', NULL, NULL, NULL, NULL, NULL, 4),
(67928, NULL, 'G3DSA:3.40.50.150:FF:001176', NULL, NULL, 'RNA capping enzyme, nuclear', NULL, NULL, NULL, NULL, NULL, 4),
(67929, NULL, 'G3DSA:3.30.40.10:FF:000455', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(67930, NULL, 'G3DSA:3.40.50.300:FF:007241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67931, NULL, 'G3DSA:3.30.200.20:FF:000791', NULL, NULL, 'Serine/threonine-protein kinase RIO3', NULL, NULL, NULL, NULL, NULL, 4),
(67932, NULL, 'G3DSA:3.40.50.12820:FF:000001', NULL, NULL, 'Acetyl-CoA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(67933, NULL, 'G3DSA:1.10.1420.10:FF:000198', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(67934, NULL, 'G3DSA:3.40.50.20:FF:000003', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(67935, NULL, 'G3DSA:3.90.1150.10:FF:000095', NULL, NULL, 'Aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(67936, NULL, 'G3DSA:3.30.70.330:FF:000253', NULL, NULL, 'splicing factor 3B subunit 6-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(67937, NULL, 'G3DSA:1.25.10.10:FF:001263', NULL, NULL, 'Testis-expressed sequence 10 protein', NULL, NULL, NULL, NULL, NULL, 4),
(67938, NULL, 'G3DSA:3.40.50.10810:FF:000174', NULL, NULL, 'Uncharacterized protein, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(67939, NULL, 'G3DSA:3.30.200.20:FF:001876', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(67940, NULL, 'G3DSA:2.60.40.1840:FF:000003', NULL, NULL, 'Peptidase M1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(67941, NULL, 'G3DSA:1.25.40.10:FF:004536', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67942, NULL, 'G3DSA:3.30.930.10:FF:000051', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(67943, NULL, 'G3DSA:2.60.40.10:FF:001243', NULL, NULL, 'Protein turtle homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(67944, NULL, 'G3DSA:3.30.70.2820:FF:000006', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(67945, NULL, 'G3DSA:3.40.50.40:FF:000009', NULL, NULL, 'L-asparaginase', NULL, NULL, NULL, NULL, NULL, 4),
(67946, NULL, 'G3DSA:3.30.70.3490:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67947, NULL, 'G3DSA:3.40.50.1240:FF:000198', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67948, NULL, 'G3DSA:1.10.10.60:FF:000266', NULL, NULL, 'Distal-less homeobox 4a', NULL, NULL, NULL, NULL, NULL, 4),
(67949, NULL, 'G3DSA:3.40.50.720:FF:002027', NULL, NULL, '3-hydroxybutyrate dehydrogenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(67950, NULL, 'G3DSA:3.40.1800.20:FF:000002', NULL, NULL, 'Weckle, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(67951, NULL, 'G3DSA:1.10.150.240:FF:000008', NULL, NULL, 'Pyrophosphatase PpaX', NULL, NULL, NULL, NULL, NULL, 4),
(67952, NULL, 'G3DSA:3.40.50.720:FF:001954', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(67953, NULL, 'G3DSA:1.20.1250.20:FF:001972', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67954, NULL, 'G3DSA:2.60.120.650:FF:000091', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(67955, NULL, 'G3DSA:1.20.58.760:FF:000055', NULL, NULL, 'Glr2649 protein', NULL, NULL, NULL, NULL, NULL, 4),
(67956, NULL, 'G3DSA:3.30.420.10:FF:000220', NULL, NULL, 'ISDet2, transposase orfB', NULL, NULL, NULL, NULL, NULL, 4),
(67957, NULL, 'G3DSA:1.10.10.10:FF:000841', NULL, NULL, 'Listeriolysin regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(67958, NULL, 'G3DSA:3.20.140.10:FF:000010', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(67959, NULL, 'G3DSA:3.30.70.330:FF:002052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67960, NULL, 'G3DSA:3.90.640.10:FF:000010', NULL, NULL, 'heat shock 70 kDa protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(67961, NULL, 'G3DSA:1.20.1070.10:FF:000235', NULL, NULL, 'mas-related G-protein coupled receptor member F', NULL, NULL, NULL, NULL, NULL, 4),
(67962, NULL, 'G3DSA:3.80.10.10:FF:003863', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67963, NULL, 'G3DSA:2.40.30.10:FF:000384', NULL, NULL, 'Translation elongation factor G, Ef-G', NULL, NULL, NULL, NULL, NULL, 4),
(67964, NULL, 'G3DSA:3.40.640.10:FF:000386', NULL, NULL, 'Serine--pyruvate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(67965, NULL, 'G3DSA:1.10.150.220:FF:000002', NULL, NULL, 'protein phosphatase 1 regulatory subunit 14A', NULL, NULL, NULL, NULL, NULL, 4),
(67966, NULL, 'G3DSA:3.30.710.10:FF:000321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67967, NULL, 'G3DSA:1.25.40.10:FF:002737', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67968, NULL, 'G3DSA:3.40.50.300:FF:005223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67969, NULL, 'G3DSA:3.60.20.10:FF:000082', NULL, NULL, 'Glutamate synthase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(67970, NULL, 'G3DSA:3.30.450.20:FF:000360', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(67971, NULL, 'G3DSA:2.60.270.50:FF:000003', NULL, NULL, 'Uncharacterized protein DDB_G0272682', NULL, NULL, NULL, NULL, NULL, 4),
(67972, NULL, 'G3DSA:2.60.40.420:FF:000271', NULL, NULL, 'Cytochrome c oxidase subunit II', NULL, NULL, NULL, NULL, NULL, 4),
(67973, NULL, 'G3DSA:2.30.30.790:FF:000004', NULL, NULL, '50S ribosomal protein L19, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(67974, NULL, 'G3DSA:3.30.230.70:FF:000145', NULL, NULL, 'Exosome complex component RRP46', NULL, NULL, NULL, NULL, NULL, 4),
(67975, NULL, 'G3DSA:3.80.20.20:FF:000039', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(67976, NULL, 'G3DSA:3.40.50.720:FF:000228', NULL, NULL, 'Putative oxidoreductase yhhX', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(67977, NULL, 'G3DSA:1.10.520.20:FF:000001', NULL, NULL, 'ATP synthase subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(67978, NULL, 'G3DSA:2.40.10.10:FF:000618', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67979, NULL, 'G3DSA:1.25.40.20:FF:000852', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(67980, NULL, 'G3DSA:1.10.510.10:FF:002875', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67981, NULL, 'G3DSA:1.20.58.560:FF:000001', NULL, NULL, 'CCA-adding enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(67982, NULL, 'G3DSA:3.30.760.10:FF:000015', NULL, NULL, 'Translation initiation factor eIF4E3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(67983, NULL, 'G3DSA:3.40.190.10:FF:000278', NULL, NULL, 'Serotransferrin', NULL, NULL, NULL, NULL, NULL, 4),
(67984, NULL, 'G3DSA:2.130.10.10:FF:000277', NULL, NULL, 'transcription initiation factor TFIID subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(67985, NULL, 'G3DSA:3.40.50.300:FF:006836', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67986, NULL, 'G3DSA:3.40.50.150:FF:001412', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67987, NULL, 'G3DSA:1.10.510.10:FF:002965', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67988, NULL, 'G3DSA:2.60.40.150:FF:000746', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(67989, NULL, 'G3DSA:3.40.50.1820:FF:000035', NULL, NULL, 'Acetyl esterase', NULL, NULL, NULL, NULL, NULL, 4),
(67990, NULL, 'G3DSA:2.130.10.10:FF:004296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67991, NULL, 'G3DSA:3.10.100.10:FF:000173', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(67992, NULL, 'G3DSA:2.130.10.10:FF:000838', NULL, NULL, 'Mitochondrial division protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(67993, NULL, 'G3DSA:2.40.160.200:FF:000002', NULL, NULL, 'Protein LURP-one-related 7', NULL, NULL, NULL, NULL, NULL, 4),
(67994, NULL, 'G3DSA:1.10.10.10:FF:000728', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(67995, NULL, 'G3DSA:1.20.1540.10:FF:000092', NULL, NULL, 'Rhomboid family serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(67996, NULL, 'G3DSA:2.130.10.10:FF:001114', NULL, NULL, 'p21-activated protein kinase-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(67997, NULL, 'G3DSA:2.70.150.10:FF:000239', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(67998, NULL, 'G3DSA:3.40.50.720:FF:001499', NULL, NULL, 'Short-chain dehydrogenase/reductase pkfC', NULL, NULL, NULL, NULL, NULL, 4),
(67999, NULL, 'G3DSA:2.10.110.10:FF:000183', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(68000, NULL, 'G3DSA:3.60.15.10:FF:000042', NULL, NULL, 'Cleavage and polyadenylation specificity factor,putative', NULL, NULL, NULL, NULL, NULL, 4),
(68001, NULL, 'G3DSA:2.60.40.10:FF:000529', NULL, NULL, 'Tenascin C', NULL, NULL, NULL, NULL, NULL, 4),
(68002, NULL, 'G3DSA:2.10.25.10:FF:001199', NULL, NULL, 'Multiple epidermal growth factor-like domains protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(68003, NULL, 'G3DSA:3.80.10.10:FF:003773', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68004, NULL, 'G3DSA:3.40.1620.70:FF:000003', NULL, NULL, 'Collagen type XVIII alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(68005, NULL, 'G3DSA:3.40.50.300:FF:002475', NULL, NULL, 'DNA helicase related protein', NULL, NULL, NULL, NULL, NULL, 4),
(68006, NULL, 'G3DSA:1.25.40.90:FF:000125', NULL, NULL, 'Huntingtin interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(68007, NULL, 'G3DSA:3.90.180.10:FF:000002', NULL, NULL, 'Alcohol dehydrogenase AdhP', NULL, NULL, NULL, NULL, NULL, 4),
(68008, NULL, 'G3DSA:3.40.50.11850:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68009, NULL, 'G3DSA:1.25.40.20:FF:000020', NULL, NULL, 'Arf-GAP with coiled-coil, ANK repeat and PH domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(68010, NULL, 'G3DSA:2.130.10.10:FF:004548', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(68011, NULL, 'G3DSA:1.10.630.10:FF:000113', NULL, NULL, 'Cytochrome P450 monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68012, NULL, 'G3DSA:3.20.20.80:FF:000290', NULL, NULL, 'Alpha-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(68013, NULL, 'G3DSA:3.40.30.10:FF:000201', NULL, NULL, 'Protein disulfide isomerase-like 1-5', NULL, NULL, NULL, NULL, NULL, 4),
(68014, NULL, 'G3DSA:3.40.850.10:FF:000071', NULL, NULL, 'Kinesin-like KIF24', NULL, NULL, NULL, NULL, NULL, 4),
(68015, NULL, 'G3DSA:1.25.40.10:FF:002956', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(68016, NULL, 'G3DSA:1.10.510.10:FF:003022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68017, NULL, 'G3DSA:2.60.40.10:FF:004986', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68018, NULL, 'G3DSA:1.20.120.2010:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68019, NULL, 'G3DSA:1.20.1250.20:FF:002135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68020, NULL, 'G3DSA:3.30.420.10:FF:000001', NULL, NULL, 'Protein argonaute-2', NULL, NULL, NULL, NULL, NULL, 4),
(68021, NULL, 'G3DSA:2.30.30.100:FF:000056', NULL, NULL, 'Small nuclear ribonucleoprotein E', NULL, NULL, NULL, NULL, NULL, 4),
(68022, NULL, 'G3DSA:1.20.1560.10:FF:000290', NULL, NULL, 'ABC transporter B family member 20', NULL, NULL, NULL, NULL, NULL, 4),
(68023, NULL, 'G3DSA:3.40.50.80:FF:000072', NULL, NULL, 'Ferric reductase', NULL, NULL, NULL, NULL, NULL, 4),
(68024, NULL, 'G3DSA:3.40.366.10:FF:000046', NULL, NULL, 'AaceriACR108Cp', NULL, NULL, NULL, NULL, NULL, 4),
(68025, NULL, 'G3DSA:1.10.510.10:FF:002746', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(68026, NULL, 'G3DSA:3.90.1150.10:FF:000185', NULL, NULL, 'Cysteine desulfurase', NULL, NULL, NULL, NULL, NULL, 4),
(68027, NULL, 'G3DSA:4.10.1000.10:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68028, NULL, 'G3DSA:2.130.10.10:FF:005043', NULL, NULL, 'SOF1 protein-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(68029, NULL, 'G3DSA:1.10.418.10:FF:000249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68030, NULL, 'G3DSA:3.30.160.60:FF:002873', NULL, NULL, 'GD16882', NULL, NULL, NULL, NULL, NULL, 4),
(68031, NULL, 'G3DSA:3.90.1720.30:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68032, NULL, 'G3DSA:2.120.10.80:FF:000197', NULL, NULL, 'Kelch domain-containing protein 8B', NULL, NULL, NULL, NULL, NULL, 4),
(68033, NULL, 'G3DSA:1.25.40.10:FF:002428', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(68034, NULL, 'G3DSA:3.40.350.10:FF:000066', NULL, NULL, 'Xaa-Pro aminopeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(68035, NULL, 'G3DSA:1.10.630.10:FF:000422', NULL, NULL, 'Putative cytochrome P450 superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(68036, NULL, 'G3DSA:3.40.50.300:FF:001171', NULL, NULL, 'DNA-binding protein SMUBP-2', NULL, NULL, NULL, NULL, NULL, 4),
(68037, NULL, 'G3DSA:3.30.40.10:FF:000017', NULL, NULL, 'Protein kinase C-binding protein 1 isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(68038, NULL, 'G3DSA:2.60.40.10:FF:000838', NULL, NULL, 'Uncharacterized protein, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(68039, NULL, 'G3DSA:2.40.160.10:FF:000016', NULL, NULL, 'Por1p', NULL, NULL, NULL, NULL, NULL, 4),
(68040, NULL, 'G3DSA:3.40.50.2000:FF:000454', NULL, NULL, 'Glycosyltransferase, group 1 family', NULL, NULL, NULL, NULL, NULL, 4),
(68041, NULL, 'G3DSA:1.25.40.90:FF:000035', NULL, NULL, 'Putative clathrin assembly protein At4g40080', NULL, NULL, NULL, NULL, NULL, 4),
(68042, NULL, 'G3DSA:1.10.8.10:FF:000042', NULL, NULL, 'Ubiquitin domain-containing protein DSK2b', NULL, NULL, NULL, NULL, NULL, 4),
(68043, NULL, 'G3DSA:3.80.10.10:FF:002227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68044, NULL, 'G3DSA:3.30.1740.10:FF:000013', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(68045, NULL, 'G3DSA:3.80.10.10:FF:000120', NULL, NULL, 'PH domain and leucine rich repeat protein phosphatase 2', NULL, NULL, NULL, NULL, NULL, 4),
(68046, NULL, 'G3DSA:1.25.10.10:FF:002590', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68047, NULL, 'G3DSA:2.40.50.140:FF:000025', NULL, NULL, '40S ribosomal protein S28', NULL, NULL, NULL, NULL, NULL, 4),
(68048, NULL, 'G3DSA:1.20.920.20:FF:000024', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(68049, NULL, 'G3DSA:3.40.390.10:FF:000153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68050, NULL, 'G3DSA:1.20.920.30:FF:000027', NULL, NULL, 'GM17107', NULL, NULL, NULL, NULL, NULL, 4),
(68051, NULL, 'G3DSA:2.130.10.10:FF:001423', NULL, NULL, 'Damaged DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(68052, NULL, 'G3DSA:1.20.120.1750:FF:000134', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(68053, NULL, 'G3DSA:2.130.10.10:FF:000496', NULL, NULL, 'LLGL2, scribble cell polarity complex component', NULL, NULL, NULL, NULL, NULL, 4),
(68054, NULL, 'G3DSA:2.30.42.10:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68055, NULL, 'G3DSA:3.40.50.150:FF:001070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68056, NULL, 'G3DSA:3.40.50.300:FF:001480', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(68057, NULL, 'G3DSA:3.40.50.720:FF:002117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68058, NULL, 'G3DSA:3.30.200.20:FF:002348', NULL, NULL, 'Oncogene tyrosine protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(68059, NULL, 'G3DSA:1.20.900.10:FF:000132', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(68060, NULL, 'G3DSA:2.160.20.10:FF:000271', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68061, NULL, 'G3DSA:2.30.30.780:FF:000001', NULL, NULL, 'Dda DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(68062, NULL, 'G3DSA:2.60.40.10:FF:004677', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68063, NULL, 'G3DSA:1.10.10.10:FF:000167', NULL, NULL, 'forkhead box protein N3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(68064, NULL, 'G3DSA:3.30.160.60:FF:003800', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68065, NULL, 'G3DSA:3.30.420.40:FF:000538', NULL, NULL, 'Actin-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(68066, NULL, 'G3DSA:1.10.10.60:FF:000485', NULL, NULL, 'Rhox homeobox family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(68067, NULL, 'G3DSA:3.30.720.210:FF:000022', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(68068, NULL, 'G3DSA:3.40.718.10:FF:000050', NULL, NULL, 'Isocitrate dehydrogenase [NADP]', NULL, NULL, NULL, NULL, NULL, 4),
(68069, NULL, 'G3DSA:1.10.238.10:FF:001067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68070, NULL, 'G3DSA:3.40.50.410:FF:000107', NULL, NULL, 'Putative ribonucleoprotein related-protein', NULL, NULL, NULL, NULL, NULL, 4),
(68071, NULL, 'G3DSA:2.60.40.150:FF:000437', NULL, NULL, 'Phosphatidylinositol 3-kinase piki-1', NULL, NULL, NULL, NULL, NULL, 4),
(68072, NULL, 'G3DSA:1.10.510.10:FF:002437', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68073, NULL, 'G3DSA:2.40.50.180:FF:000008', NULL, NULL, 'Chemotaxis protein CheV', NULL, NULL, NULL, NULL, NULL, 4),
(68074, NULL, 'G3DSA:2.40.10.10:FF:000528', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68075, NULL, 'G3DSA:1.10.472.10:FF:000493', NULL, NULL, 'Cyclin puc1', NULL, NULL, NULL, NULL, NULL, 4),
(68076, NULL, 'G3DSA:1.10.8.270:FF:000158', NULL, NULL, 'GTPase activating protein Gyp51', NULL, NULL, NULL, NULL, NULL, 4),
(68077, NULL, 'G3DSA:2.60.120.20:FF:000017', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(68078, NULL, 'G3DSA:2.60.120.10:FF:000104', NULL, NULL, 'Protein phosphatase 2C and cyclic nucleotide-binding/kinase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(68079, NULL, 'G3DSA:3.30.200.60:FF:000005', NULL, NULL, 'Ubiquitin thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(68080, NULL, 'G3DSA:3.30.450.20:FF:000270', NULL, NULL, 'Sensor histidine kinase RcsC', NULL, NULL, NULL, NULL, NULL, 4),
(68081, NULL, 'G3DSA:3.20.20.80:FF:000071', NULL, NULL, 'Imaginal disc growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(68082, NULL, 'G3DSA:3.30.420.40:FF:000780', NULL, NULL, 'Heat shock protein 70 putative', NULL, NULL, NULL, NULL, NULL, 4),
(68083, NULL, 'G3DSA:3.20.20.80:FF:000323', NULL, NULL, 'Glucosylceramidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68084, NULL, 'G3DSA:3.30.450.40:FF:000276', NULL, NULL, 'Receptor-like histidine kinase BpdS', NULL, NULL, NULL, NULL, NULL, 4),
(68085, NULL, 'G3DSA:1.20.1270.280:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68086, NULL, 'G3DSA:4.10.520.10:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68087, NULL, 'G3DSA:1.25.10.10:FF:002348', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68088, NULL, 'G3DSA:1.20.1050.10:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68089, NULL, 'G3DSA:2.130.10.10:FF:002750', NULL, NULL, 'Transducin-like enhancer of split 3 (E(Sp1) homolog, Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(68090, NULL, 'G3DSA:3.60.110.10:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68091, NULL, 'G3DSA:2.60.40.10:FF:005043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68092, NULL, 'G3DSA:3.40.50.300:FF:001148', NULL, NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase DHX15/PRP43', NULL, NULL, NULL, NULL, NULL, 4),
(68093, NULL, 'G3DSA:1.20.120.1240:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68094, NULL, 'G3DSA:1.25.40.720:FF:000017', NULL, NULL, 'YALI0D22979p', NULL, NULL, NULL, NULL, NULL, 4),
(68095, NULL, 'G3DSA:3.30.70.330:FF:000814', NULL, NULL, 'Polyadenylate-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68096, NULL, 'G3DSA:3.30.70.20:FF:000067', NULL, NULL, 'Long irondependent hydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68097, NULL, 'G3DSA:3.90.650.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68098, NULL, 'G3DSA:3.30.160.60:FF:001237', NULL, NULL, 'zinc finger protein 660', NULL, NULL, NULL, NULL, NULL, 4),
(68099, NULL, 'G3DSA:1.20.920.10:FF:000021', NULL, NULL, 'ATPase family AAA domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(68100, NULL, 'G3DSA:2.70.160.11:FF:000050', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(68101, NULL, 'G3DSA:3.40.50.150:FF:000794', NULL, NULL, 'Jasmonate O-methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68102, NULL, 'G3DSA:3.30.870.10:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68103, NULL, 'G3DSA:1.20.1050.10:FF:000127', NULL, NULL, 'Os05g0148900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(68104, NULL, 'G3DSA:3.60.15.10:FF:000019', NULL, NULL, 'Hydroxyacylglutathione hydrolase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(68105, NULL, 'G3DSA:2.160.20.10:FF:000181', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(68106, NULL, 'G3DSA:1.10.10.60:FF:000794', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68107, NULL, 'G3DSA:3.30.200.20:FF:002039', NULL, NULL, 'Serine/threonine-protein kinase srk1', NULL, NULL, NULL, NULL, NULL, 4),
(68108, NULL, 'G3DSA:3.40.190.10:FF:000188', NULL, NULL, 'Ionotropic receptor 64a', NULL, NULL, NULL, NULL, NULL, 4),
(68109, NULL, 'G3DSA:3.30.420.40:FF:000229', NULL, NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(68110, NULL, 'G3DSA:3.20.20.100:FF:000103', NULL, NULL, 'Putative oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(68111, NULL, 'G3DSA:2.70.170.10:FF:000038', NULL, NULL, 'Glutamate-gated chloride channel alpha', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(68112, NULL, 'G3DSA:3.40.50.720:FF:001864', NULL, NULL, 'Malate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(68113, NULL, 'G3DSA:3.40.50.150:FF:001322', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68114, NULL, 'G3DSA:1.25.40.10:FF:002647', NULL, NULL, 'Small glutamine-rich tetratricopeptide repeat-containing protein alpha-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(68115, NULL, 'G3DSA:3.30.420.10:FF:000310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68116, NULL, 'G3DSA:3.90.1150.10:FF:000437', NULL, NULL, 'RE16411p', NULL, NULL, NULL, NULL, NULL, 4),
(68117, NULL, 'G3DSA:3.40.190.10:FF:000497', NULL, NULL, 'ABC transporter amino acid permease', NULL, NULL, NULL, NULL, NULL, 4),
(68118, NULL, 'G3DSA:2.40.50.40:FF:000034', NULL, NULL, 'C-C motif chemokine', NULL, NULL, NULL, NULL, NULL, 4),
(68119, NULL, 'G3DSA:2.30.29.30:FF:000156', NULL, NULL, 'PTB-containing, cubilin and LRP1-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(68120, NULL, 'G3DSA:2.60.40.10:FF:001333', NULL, NULL, 'collagen alpha-1(VII) chain isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(68121, NULL, 'G3DSA:1.10.150.20:FF:000276', NULL, NULL, 'ERCC4 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(68122, NULL, 'G3DSA:1.10.287.470:FF:000014', NULL, NULL, 'RND family efflux transporter, MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(68123, NULL, 'G3DSA:2.60.40.10:FF:001119', NULL, NULL, 'Immunoglobulin heavy variable 4-30-4', NULL, NULL, NULL, NULL, NULL, 4),
(68124, NULL, 'G3DSA:3.40.50.300:FF:003632', NULL, NULL, 'ABC multidrug transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(68125, NULL, 'G3DSA:2.60.120.390:FF:000001', NULL, NULL, 'Olfactory marker protein', NULL, NULL, NULL, NULL, NULL, 4),
(68126, NULL, 'G3DSA:1.20.1560.10:FF:000430', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(68127, NULL, 'G3DSA:3.80.20.20:FF:000056', NULL, NULL, 'Fibronectin domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(68128, NULL, 'G3DSA:1.25.40.620:FF:000004', NULL, NULL, 'Ycf53-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(68129, NULL, 'G3DSA:1.10.150.20:FF:000057', NULL, NULL, 'RAD2p Single-stranded DNA endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(68130, NULL, 'G3DSA:3.90.550.50:FF:000144', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(68131, NULL, 'G3DSA:3.40.800.10:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68132, NULL, 'G3DSA:2.40.70.10:FF:000498', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68133, NULL, 'G3DSA:1.20.1070.10:FF:001399', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68134, NULL, 'G3DSA:2.60.40.1400:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68135, NULL, 'G3DSA:1.25.40.10:FF:002518', NULL, NULL, 'GM14768', NULL, NULL, NULL, NULL, NULL, 4),
(68136, NULL, 'G3DSA:3.40.50.12780:FF:000152', NULL, NULL, 'NRPS-like enzyme, putative (JCVI)', NULL, NULL, NULL, NULL, NULL, 4),
(68137, NULL, 'G3DSA:2.60.40.10:FF:005402', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68138, NULL, 'G3DSA:1.20.1250.20:FF:002231', NULL, NULL, 'Transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68139, NULL, 'G3DSA:1.20.20.10:FF:000009', NULL, NULL, 'ATP synthase subunit 9, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(68140, NULL, 'G3DSA:3.30.420.40:FF:000869', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68141, NULL, 'G3DSA:1.20.5.260:FF:000001', NULL, NULL, 'Cytochrome b-c1 complex subunit 9', NULL, NULL, NULL, NULL, NULL, 4),
(68142, NULL, 'G3DSA:1.25.40.630:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68143, NULL, 'G3DSA:3.80.10.10:FF:002800', NULL, NULL, 'Toll-like receptor 4a', NULL, NULL, NULL, NULL, NULL, 4),
(68144, NULL, 'G3DSA:1.10.1200.10:FF:000001', NULL, NULL, 'Acyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(68145, NULL, 'G3DSA:3.90.1560.10:FF:000002', NULL, NULL, '2-phosphosulfolactate phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(68146, NULL, 'G3DSA:1.10.10.10:FF:001330', NULL, NULL, 'Heme response regulator HssR', NULL, NULL, NULL, NULL, NULL, 4),
(68147, NULL, 'G3DSA:2.60.40.2950:FF:000004', NULL, NULL, 'Thioester-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(68148, NULL, 'G3DSA:3.30.2130.30:FF:000001', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase K/L', NULL, NULL, NULL, NULL, NULL, 4),
(68149, NULL, 'G3DSA:1.20.5.270:FF:000004', NULL, NULL, 'Cytochrome b-c1 complex subunit Rieske, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(68150, NULL, 'G3DSA:3.30.70.330:FF:001995', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68151, NULL, 'G3DSA:3.40.50.1000:FF:000587', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68152, NULL, 'G3DSA:3.30.200.20:FF:000235', NULL, NULL, 'serine/threonine-protein kinase STK11', NULL, NULL, NULL, NULL, NULL, 4),
(68153, NULL, 'G3DSA:1.25.40.180:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68154, NULL, 'G3DSA:1.25.40.770:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68155, NULL, 'G3DSA:1.25.10.10:FF:000881', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68156, NULL, 'G3DSA:3.40.50.720:FF:001639', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68157, NULL, 'G3DSA:3.30.70.1400:FF:000013', NULL, NULL, 'Pyruvate Dehydrogenase Phosphatase Regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(68158, NULL, 'G3DSA:3.30.40.10:FF:002046', NULL, NULL, 'putative E3 ubiquitin-protein ligase RING1a', NULL, NULL, NULL, NULL, NULL, 4),
(68159, NULL, 'G3DSA:3.40.50.880:FF:000136', NULL, NULL, 'Cobyric acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(68160, NULL, 'G3DSA:3.30.1520.10:FF:000047', NULL, NULL, 'Sorting nexin', NULL, NULL, NULL, NULL, NULL, 4),
(68161, NULL, 'G3DSA:3.30.70.330:FF:002607', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68162, NULL, 'G3DSA:3.40.50.720:FF:000442', NULL, NULL, 'NAD-dependent dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(68163, NULL, 'G3DSA:3.90.550.50:FF:000239', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(68164, NULL, 'G3DSA:1.10.490.10:FF:000012', NULL, NULL, 'Flavohemoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(68165, NULL, 'G3DSA:3.40.50.300:FF:001603', NULL, NULL, 'GPN-loop GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(68166, NULL, 'G3DSA:3.20.180.10:FF:000001', NULL, NULL, 'Glutamyl-tRNA reductase-binding protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(68167, NULL, 'G3DSA:3.10.20.90:FF:000754', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(68168, NULL, 'G3DSA:3.30.830.10:FF:000263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68169, NULL, 'G3DSA:1.10.10.10:FF:000599', NULL, NULL, 'Crp family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(68170, NULL, 'G3DSA:3.90.1100.10:FF:000047', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(68171, NULL, 'G3DSA:2.30.29.30:FF:001359', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68172, NULL, 'G3DSA:3.90.70.200:FF:000021', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(68173, NULL, 'G3DSA:1.10.472.10:FF:000627', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68174, NULL, 'G3DSA:2.40.10.10:FF:000394', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68175, NULL, 'G3DSA:3.40.50.80:FF:000077', NULL, NULL, 'Putative nitrate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(68176, NULL, 'G3DSA:3.30.56.10:FF:000019', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(68177, NULL, 'G3DSA:3.30.200.20:FF:000561', NULL, NULL, 'Calcium/calmodulin-dependent protein kinase type 1D', NULL, NULL, NULL, NULL, NULL, 4),
(68178, NULL, 'G3DSA:3.30.70.2510:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68179, NULL, 'G3DSA:3.40.50.620:FF:000300', NULL, NULL, 'Electron transfer flavoprotein alpha subunit', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(68180, NULL, 'G3DSA:2.130.10.10:FF:003340', NULL, NULL, 'Protein tipD', NULL, NULL, NULL, NULL, NULL, 4),
(68181, NULL, 'G3DSA:3.30.230.10:FF:000060', NULL, NULL, '30S ribosomal protein S9', NULL, NULL, NULL, NULL, NULL, 4),
(68182, NULL, 'G3DSA:3.30.70.580:FF:000058', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(68183, NULL, 'G3DSA:1.20.1730.10:FF:000016', NULL, NULL, 'Sodium symporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(68184, NULL, 'G3DSA:3.20.20.20:FF:000002', NULL, NULL, 'Methionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(68185, NULL, 'G3DSA:2.120.10.80:FF:000326', NULL, NULL, 'Adagio protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(68186, NULL, 'G3DSA:2.60.120.260:FF:000316', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(68187, NULL, 'G3DSA:3.40.50.300:FF:007005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68188, NULL, 'G3DSA:3.30.160.60:FF:000956', NULL, NULL, 'DNA polymerase kappa', NULL, NULL, NULL, NULL, NULL, 4),
(68189, NULL, 'G3DSA:1.25.40.10:FF:000383', NULL, NULL, 'Rna polymerase-associated protein ctr9', NULL, NULL, NULL, NULL, NULL, 4),
(68190, NULL, 'G3DSA:3.20.20.30:FF:000005', NULL, NULL, '5,10-methylene tetrahydromethanopterin reductase', NULL, NULL, NULL, NULL, NULL, 4),
(68191, NULL, 'G3DSA:3.40.50.12280:FF:000013', NULL, NULL, 'YALI0F06050p', NULL, NULL, NULL, NULL, NULL, 4),
(68192, NULL, 'G3DSA:3.30.70.3490:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68193, NULL, 'G3DSA:3.40.50.300:FF:008528', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68194, NULL, 'G3DSA:3.40.50.300:FF:004829', NULL, NULL, 'Protein CHROMATIN REMODELING 24', NULL, NULL, NULL, NULL, NULL, 4),
(68195, NULL, 'G3DSA:3.40.50.2000:FF:000106', NULL, NULL, 'Lipopolysaccharide heptosyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(68196, NULL, 'G3DSA:3.30.920.10:FF:000011', NULL, NULL, 'Frataxin, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(68197, NULL, 'G3DSA:2.30.30.40:FF:000589', NULL, NULL, 'CD2-associated protein like', NULL, NULL, NULL, NULL, NULL, 4),
(68198, NULL, 'G3DSA:3.10.20.90:FF:000849', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68199, NULL, 'G3DSA:2.60.120.10:FF:000796', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68200, NULL, 'G3DSA:1.20.58.760:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68201, NULL, 'G3DSA:1.20.5.190:FF:000183', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68202, NULL, 'G3DSA:1.20.58.60:FF:000403', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68203, NULL, 'G3DSA:2.10.109.10:FF:000022', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(68204, NULL, 'G3DSA:1.25.40.10:FF:003024', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g10690', NULL, NULL, NULL, NULL, NULL, 4),
(68205, NULL, 'G3DSA:3.30.160.60:FF:006358', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68206, NULL, 'G3DSA:1.10.10.10:FF:000824', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(68207, NULL, 'G3DSA:3.80.10.10:FF:002121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68208, NULL, 'G3DSA:3.30.430.20:FF:000044', NULL, NULL, 'CRK1', NULL, NULL, NULL, NULL, NULL, 4),
(68209, NULL, 'G3DSA:3.10.450.40:FF:000027', NULL, NULL, 'Primary amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(68210, NULL, 'G3DSA:3.30.70.330:FF:000904', NULL, NULL, 'RNA-binding protein RBP6, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68211, NULL, 'G3DSA:3.30.420.40:FF:000448', NULL, NULL, 'GM21720', NULL, NULL, NULL, NULL, NULL, 4),
(68212, NULL, 'G3DSA:1.10.274.60:FF:000002', NULL, NULL, 'Minor ampullate spidroin', NULL, NULL, NULL, NULL, NULL, 4),
(68213, NULL, 'G3DSA:3.40.850.10:FF:000076', NULL, NULL, 'MYH7', NULL, NULL, NULL, NULL, NULL, 4),
(68214, NULL, 'G3DSA:3.40.50.720:FF:001965', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(68215, NULL, 'G3DSA:3.90.1150.10:FF:000421', NULL, NULL, 'Ornithine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(68216, NULL, 'G3DSA:3.40.50.12230:FF:000010', NULL, NULL, 'Methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(68217, NULL, 'G3DSA:3.10.129.10:FF:000132', NULL, NULL, 'PaaI family thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(68218, NULL, 'G3DSA:2.170.130.10:FF:000039', NULL, NULL, 'Colicin I receptor', NULL, NULL, NULL, NULL, NULL, 4),
(68219, NULL, 'G3DSA:3.90.70.10:FF:000483', NULL, NULL, 'Cathepsin l-like protease', NULL, NULL, NULL, NULL, NULL, 4),
(68220, NULL, 'G3DSA:3.40.50.1820:FF:000602', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(68221, NULL, 'G3DSA:3.80.10.10:FF:004150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68222, NULL, 'G3DSA:1.25.10.10:FF:000667', NULL, NULL, 'AP-3 complex subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(68223, NULL, 'G3DSA:3.90.190.20:FF:000051', NULL, NULL, 'Tetrahydrofolylpolyglutamate synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68224, NULL, 'G3DSA:3.40.718.10:FF:000044', NULL, NULL, 'Peroxisomal isocitrate dehydrogenase [NADP]', NULL, NULL, NULL, NULL, NULL, 4),
(68225, NULL, 'G3DSA:3.40.50.300:FF:002694', NULL, NULL, 'HAlF transporter (PGP related)', NULL, NULL, NULL, NULL, NULL, 4),
(68226, NULL, 'G3DSA:2.130.10.10:FF:004537', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68227, NULL, 'G3DSA:2.40.30.10:FF:000294', NULL, NULL, 'GTP-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(68228, NULL, 'G3DSA:3.40.50.150:FF:000917', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68229, NULL, 'G3DSA:1.10.510.10:FF:002858', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68230, NULL, 'G3DSA:3.40.50.300:FF:004476', NULL, NULL, 'Protein CBR-RAB-21', NULL, NULL, NULL, NULL, NULL, 4),
(68231, NULL, 'G3DSA:1.25.10.10:FF:000555', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(68232, NULL, 'G3DSA:2.10.25.10:FF:001648', NULL, NULL, 'Neurocan b', NULL, NULL, NULL, NULL, NULL, 4),
(68233, NULL, 'G3DSA:1.10.730.10:FF:000048', NULL, NULL, 'Arginine--tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68234, NULL, 'G3DSA:2.30.29.30:FF:000050', NULL, NULL, 'Vav guanine nucleotide exchange factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(68235, NULL, 'G3DSA:1.25.10.10:FF:001061', NULL, NULL, 'Deoxyhypusine hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(68236, NULL, 'G3DSA:2.40.70.10:FF:000414', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68237, NULL, 'G3DSA:1.10.238.10:FF:001314', NULL, NULL, 'Solute carrier family 25 member 24', NULL, NULL, NULL, NULL, NULL, 4),
(68238, NULL, 'G3DSA:2.130.10.10:FF:002525', NULL, NULL, 'Polyubiquitin binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68239, NULL, 'G3DSA:1.20.144.10:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68240, NULL, 'G3DSA:1.10.1450.10:FF:000048', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(68241, NULL, 'G3DSA:2.40.50.120:FF:000002', NULL, NULL, 'netrin-4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(68242, NULL, 'G3DSA:3.50.50.60:FF:000464', NULL, NULL, 'Protein MTO1 homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(68243, NULL, 'G3DSA:1.10.1060.10:FF:000012', NULL, NULL, 'Glycolate oxidase iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4),
(68244, NULL, 'G3DSA:3.40.50.2000:FF:000095', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(68245, NULL, 'G3DSA:3.40.570.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68246, NULL, 'G3DSA:1.10.10.60:FF:000474', NULL, NULL, 'Blast:Protein gooseberry-neuro', NULL, NULL, NULL, NULL, NULL, 4),
(68247, NULL, 'G3DSA:1.10.238.10:FF:000825', NULL, NULL, 'Mitochondrial calcium uptake 1', NULL, NULL, NULL, NULL, NULL, 4),
(68248, NULL, 'G3DSA:2.60.120.650:FF:000231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(68249, NULL, 'G3DSA:2.130.10.10:FF:003126', NULL, NULL, 'Membrane glycoprotein spo14, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68250, NULL, 'G3DSA:2.60.220.50:FF:000051', NULL, NULL, 'Adhesion G protein-coupled receptor G1', NULL, NULL, NULL, NULL, NULL, 4),
(68251, NULL, 'G3DSA:2.60.40.10:FF:002547', NULL, NULL, 'Cell surface glycoprotein CD200 receptor 1-A', NULL, NULL, NULL, NULL, NULL, 4),
(68252, NULL, 'G3DSA:3.40.190.10:FF:000059', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(68253, NULL, 'G3DSA:2.130.10.10:FF:003014', NULL, NULL, 'PWP2, small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4),
(68254, NULL, 'G3DSA:3.40.640.10:FF:000055', NULL, NULL, 'Alanine--glyoxylate aminotransferase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(68255, NULL, 'G3DSA:3.40.630.30:FF:000200', NULL, NULL, 'N-alpha-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(68256, NULL, 'G3DSA:1.25.40.10:FF:004873', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68257, NULL, 'G3DSA:3.40.50.2300:FF:000078', NULL, NULL, 'D-xylose ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(68258, NULL, 'G3DSA:2.10.110.10:FF:000093', NULL, NULL, 'prickle-like protein 4 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(68259, NULL, 'G3DSA:3.40.50.300:FF:002789', NULL, NULL, 'DEAD-box ATP-dependent RNA helicase 22', NULL, NULL, NULL, NULL, NULL, 4),
(68260, NULL, 'G3DSA:1.20.58.60:FF:000050', NULL, NULL, 'Short stop, isoform N', NULL, NULL, NULL, NULL, NULL, 4),
(68261, NULL, 'G3DSA:1.25.40.10:FF:000169', NULL, NULL, 'tetratricopeptide repeat protein 8 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(68262, NULL, 'G3DSA:2.60.40.10:FF:002968', NULL, NULL, 'GP63-like', NULL, NULL, NULL, NULL, NULL, 4),
(68263, NULL, 'G3DSA:3.40.225.10:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68264, NULL, 'G3DSA:3.90.1150.10:FF:000084', NULL, NULL, 'Phosphoserine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(68265, NULL, 'G3DSA:3.90.1150.10:FF:000196', NULL, NULL, 'Aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(68266, NULL, 'G3DSA:1.10.420.10:FF:000064', NULL, NULL, 'Catalase/peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(68267, NULL, 'G3DSA:2.60.40.10:FF:001350', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(68268, NULL, 'G3DSA:3.40.190.10:FF:000738', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(68269, NULL, 'G3DSA:2.60.40.10:FF:002761', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68270, NULL, 'G3DSA:2.40.70.10:FF:000509', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68271, NULL, 'G3DSA:3.20.180.20:FF:000004', NULL, NULL, 'Dynein axonemal heavy chain 6', NULL, NULL, NULL, NULL, NULL, 4),
(68272, NULL, 'G3DSA:1.10.3430.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68273, NULL, 'G3DSA:3.60.15.10:FF:000250', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(68274, NULL, 'G3DSA:3.40.50.300:FF:007117', NULL, NULL, 'Probable thymidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(68275, NULL, 'G3DSA:3.30.70.270:FF:000072', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(68276, NULL, 'G3DSA:3.30.160.60:FF:003132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68277, NULL, 'G3DSA:3.20.20.100:FF:000075', NULL, NULL, 'GD18440', NULL, NULL, NULL, NULL, NULL, 4),
(68278, NULL, 'G3DSA:2.60.120.200:FF:000231', NULL, NULL, 'Eyes shut homolog', NULL, NULL, NULL, NULL, NULL, 4),
(68279, NULL, 'G3DSA:1.20.58.60:FF:000515', NULL, NULL, 'Spectrin repeat containing, nuclear envelope 1a', NULL, NULL, NULL, NULL, NULL, 4),
(68280, NULL, 'G3DSA:2.40.30.10:FF:000389', NULL, NULL, 'Probable translation initiation factor IF-2', NULL, NULL, NULL, NULL, NULL, 4),
(68281, NULL, 'G3DSA:2.30.29.30:FF:000515', NULL, NULL, 'AT4g11790/T5C23_220', NULL, NULL, NULL, NULL, NULL, 4),
(68282, NULL, 'G3DSA:3.40.50.1240:FF:000075', NULL, NULL, 'Blast:Lysosomal acid phosphatase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(68283, NULL, 'G3DSA:3.30.50.10:FF:000203', NULL, NULL, 'Nuclear receptor subfamily 1 group I member 3', NULL, NULL, NULL, NULL, NULL, 4),
(68284, NULL, 'G3DSA:3.75.10.10:FF:000003', NULL, NULL, 'Protein-arginine deiminase type-2', NULL, NULL, NULL, NULL, NULL, 4),
(68285, NULL, 'G3DSA:1.10.510.10:FF:002763', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68286, NULL, 'G3DSA:1.10.100.10:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68287, NULL, 'G3DSA:3.30.497.10:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68288, NULL, 'G3DSA:1.25.10.10:FF:002921', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68289, NULL, 'G3DSA:3.40.190.10:FF:000952', NULL, NULL, '4-phytase', NULL, NULL, NULL, NULL, NULL, 4),
(68290, NULL, 'G3DSA:3.90.190.10:FF:000143', NULL, NULL, 'Inositol_hexakisphosphate', NULL, NULL, NULL, NULL, NULL, 4),
(68291, NULL, 'G3DSA:2.30.30.40:FF:000477', NULL, NULL, 'Scaffold protein CheW associated with MCPs of classes 40H and 40+24H', NULL, NULL, NULL, NULL, NULL, 4),
(68292, NULL, 'G3DSA:3.30.200.20:FF:002359', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68293, NULL, 'G3DSA:3.30.450.20:FF:000039', NULL, NULL, 'Phytochrome', NULL, NULL, NULL, NULL, NULL, 4),
(68294, NULL, 'G3DSA:3.90.180.10:FF:000103', NULL, NULL, 'IMP dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(68295, NULL, 'G3DSA:1.10.486.10:FF:000002', NULL, NULL, 'ATP-dependent DNA helicase Rep', NULL, NULL, NULL, NULL, NULL, 4),
(68296, NULL, 'G3DSA:1.25.40.80:FF:000021', NULL, NULL, 'DNA photolyase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68297, NULL, 'G3DSA:1.25.10.10:FF:003410', NULL, NULL, 'Protein Mo25', NULL, NULL, NULL, NULL, NULL, 4),
(68298, NULL, 'G3DSA:2.10.110.10:FF:000188', NULL, NULL, 'PDZ and LIM domain protein Zasp-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(68299, NULL, 'G3DSA:2.130.10.10:FF:000485', NULL, NULL, 'Putative WD repeat-containing protein C17D11.16', NULL, NULL, NULL, NULL, NULL, 4),
(68300, NULL, 'G3DSA:1.10.8.60:FF:000141', NULL, NULL, 'AAA family ATPase, CDC48 subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(68301, NULL, 'G3DSA:1.25.40.90:FF:000024', NULL, NULL, 'Calcium homeostasis endoplasmic reticulum protein', NULL, NULL, NULL, NULL, NULL, 4),
(68302, NULL, 'G3DSA:3.40.50.1580:FF:000058', NULL, NULL, 'Purine nucleoside phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(68303, NULL, 'G3DSA:3.40.50.720:FF:001853', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68304, NULL, 'G3DSA:2.120.10.30:FF:000570', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68305, NULL, 'G3DSA:3.40.50.150:FF:001311', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68306, NULL, 'G3DSA:2.20.70.10:FF:000224', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(68307, NULL, 'G3DSA:1.25.40.610:FF:000001', NULL, NULL, 'Adhesion G protein-coupled receptor L2', NULL, NULL, NULL, NULL, NULL, 4),
(68308, NULL, 'G3DSA:2.40.50.430:FF:000005', NULL, NULL, 'DNA polymerase delta small subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68309, NULL, 'G3DSA:1.10.2020.20:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68310, NULL, 'G3DSA:3.40.640.10:FF:000504', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68311, NULL, 'G3DSA:3.30.70.141:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68312, NULL, 'G3DSA:3.30.50.10:FF:000192', NULL, NULL, 'C2C2-GATA transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(68313, NULL, 'G3DSA:1.10.150.20:FF:000169', NULL, NULL, 'DNA repair protein Rad1 homologue, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68314, NULL, 'G3DSA:3.40.50.300:FF:003520', NULL, NULL, 'Helicase putative', NULL, NULL, NULL, NULL, NULL, 4),
(68315, NULL, 'G3DSA:3.40.50.1820:FF:001788', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68316, NULL, 'G3DSA:1.10.260.170:FF:000006', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(68317, NULL, 'G3DSA:1.20.1250.20:FF:002343', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68318, NULL, 'G3DSA:2.60.120.780:FF:000011', NULL, NULL, 'E3 SUMO-protein ligase PIAS2', NULL, NULL, NULL, NULL, NULL, 4),
(68319, NULL, 'G3DSA:2.60.98.20:FF:000002', NULL, NULL, 'Flagellar hook protein FlgE', NULL, NULL, NULL, NULL, NULL, 4),
(68320, NULL, 'G3DSA:1.20.58.1520:FF:000006', NULL, NULL, 'Microtubule_associated_protein_(MAP65/ASE1_family )_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(68321, NULL, 'G3DSA:3.40.50.300:FF:001620', NULL, NULL, 'Peroxisome biogenesis protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(68322, NULL, 'G3DSA:2.130.10.10:FF:002851', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68323, NULL, 'G3DSA:1.20.1530.20:FF:000038', NULL, NULL, 'Glutathione-regulated potassium-efflux system protein KefKL', NULL, NULL, NULL, NULL, NULL, 4),
(68324, NULL, 'G3DSA:1.10.287.1490:FF:000097', NULL, NULL, 'Elastin microfibril interfacer 3', NULL, NULL, NULL, NULL, NULL, 4),
(68325, NULL, 'G3DSA:2.60.40.770:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68326, NULL, 'G3DSA:2.30.30.30:FF:000148', NULL, NULL, 'Mitochondrial ribosomal protein L24', NULL, NULL, NULL, NULL, NULL, 4),
(68327, NULL, 'G3DSA:3.40.50.300:FF:008545', NULL, NULL, 'Mitochondrial GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(68328, NULL, 'G3DSA:1.25.40.470:FF:000021', NULL, NULL, 'Intraflagellar transport protein osm-1', NULL, NULL, NULL, NULL, NULL, 4),
(68329, NULL, 'G3DSA:1.10.510.10:FF:002196', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(68330, NULL, 'G3DSA:1.20.142.10:FF:000022', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(68331, NULL, 'G3DSA:1.20.1510.10:FF:000040', NULL, NULL, 'Blast:Zinc transporter 2', NULL, NULL, NULL, NULL, NULL, 4),
(68332, NULL, 'G3DSA:2.60.120.290:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68333, NULL, 'G3DSA:1.25.40.10:FF:000736', NULL, NULL, 'Zinc finger C3H1-type containing', NULL, NULL, NULL, NULL, NULL, 4),
(68334, NULL, 'G3DSA:3.40.50.1000:FF:000699', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68335, NULL, 'G3DSA:1.20.120.350:FF:000269', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68336, NULL, 'G3DSA:3.30.200.20:FF:000347', NULL, NULL, 'serine/threonine-protein kinase 32A isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(68337, NULL, 'G3DSA:2.40.128.620:FF:000006', NULL, NULL, 'Lipoprotein receptor', NULL, NULL, NULL, NULL, NULL, 4),
(68338, NULL, 'G3DSA:3.30.160.60:FF:001445', NULL, NULL, 'Zinc finger protein 142', NULL, NULL, NULL, NULL, NULL, 4),
(68339, NULL, 'G3DSA:3.40.50.2000:FF:000123', NULL, NULL, 'D-inositol-3-phosphate glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(68340, NULL, 'G3DSA:1.25.40.10:FF:001012', NULL, NULL, 'Protein RMD9, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(68341, NULL, 'G3DSA:1.25.40.20:FF:001015', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(68342, NULL, 'G3DSA:3.80.10.10:FF:000434', NULL, NULL, 'Relaxin family peptide receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(68343, NULL, 'G3DSA:4.10.1000.10:FF:000017', NULL, NULL, 'Cleavage and polyadenylation specificity factor 30 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(68344, NULL, 'G3DSA:3.90.640.10:FF:000234', NULL, NULL, 'ALP3', NULL, NULL, NULL, NULL, NULL, 4),
(68345, NULL, 'G3DSA:2.10.25.10:FF:000108', NULL, NULL, 'Fibulin-1', NULL, NULL, NULL, NULL, NULL, 4),
(68346, NULL, 'G3DSA:2.40.128.630:FF:000009', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(68347, NULL, 'G3DSA:2.60.40.10:FF:003036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68348, NULL, 'G3DSA:3.30.40.10:FF:002158', NULL, NULL, 'Structure-specific endonuclease subunit SLX1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(68349, NULL, 'G3DSA:2.130.10.10:FF:002497', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(68350, NULL, 'G3DSA:2.70.98.10:FF:000038', NULL, NULL, 'Carbohydrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(68351, NULL, 'G3DSA:2.10.110.10:FF:000104', NULL, NULL, 'Ras association domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(68352, NULL, 'G3DSA:1.25.40.20:FF:000739', NULL, NULL, 'Ankyrin repeat domain 50', NULL, NULL, NULL, NULL, NULL, 4),
(68353, NULL, 'G3DSA:3.40.50.1000:FF:000475', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68354, NULL, 'G3DSA:1.20.1070.10:FF:001871', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68355, NULL, 'G3DSA:2.60.120.260:FF:000193', NULL, NULL, 'Hemolectin, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(68356, NULL, 'G3DSA:3.80.10.10:FF:001295', NULL, NULL, 'Malignant fibrous histiocytoma-amplified sequence 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(68357, NULL, 'G3DSA:1.10.150.240:FF:000093', NULL, NULL, 'HAD-superfamily hydrolase, subfamily IA, variant 3', NULL, NULL, NULL, NULL, NULL, 4),
(68358, NULL, 'G3DSA:2.60.40.10:FF:000395', NULL, NULL, 'Protein tyrosine kinase 7 (inactive)', NULL, NULL, NULL, NULL, NULL, 4),
(68359, NULL, 'G3DSA:1.20.58.2240:FF:000003', NULL, NULL, 'MPA43p protein', NULL, NULL, NULL, NULL, NULL, 4),
(68360, NULL, 'G3DSA:3.10.100.10:FF:000375', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68361, NULL, 'G3DSA:3.90.1520.10:FF:000005', NULL, NULL, 'Soluble guanylate cyclase gcy-36', NULL, NULL, NULL, NULL, NULL, 4),
(68362, NULL, 'G3DSA:3.30.160.60:FF:002968', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68363, NULL, 'G3DSA:1.10.3720.10:FF:000058', NULL, NULL, 'D,D-dipeptide ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(68364, NULL, 'G3DSA:2.40.50.40:FF:000039', NULL, NULL, 'RE36324p', NULL, NULL, NULL, NULL, NULL, 4),
(68365, NULL, 'G3DSA:3.90.1600.10:FF:000057', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(68366, NULL, 'G3DSA:1.10.418.10:FF:000244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68367, NULL, 'G3DSA:3.30.40.10:FF:002260', NULL, NULL, 'PHD finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68368, NULL, 'G3DSA:3.20.20.80:FF:000531', NULL, NULL, 'Blood-group-substance endo-1,4-beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(68369, NULL, 'G3DSA:1.20.1070.10:FF:002028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68370, NULL, 'G3DSA:3.90.226.10:FF:000093', NULL, NULL, 'Biotin carboxylase subunit of acetyl CoA carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(68371, NULL, 'G3DSA:1.25.40.10:FF:004435', NULL, NULL, 'Slr2048 protein', NULL, NULL, NULL, NULL, NULL, 4),
(68372, NULL, 'G3DSA:2.40.70.10:FF:000291', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68373, NULL, 'G3DSA:3.50.50.60:FF:000913', NULL, NULL, 'Amine oxidase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(68374, NULL, 'G3DSA:1.25.40.10:FF:002535', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(68375, NULL, 'G3DSA:3.30.70.330:FF:002484', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68376, NULL, 'G3DSA:2.40.30.10:FF:000277', NULL, NULL, 'Elongation factor 1-alpha', NULL, NULL, NULL, NULL, NULL, 4),
(68377, NULL, 'G3DSA:2.30.29.30:FF:000403', NULL, NULL, 'Unplaced genomic scaffold supercont1.125, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(68378, NULL, 'G3DSA:3.40.30.10:FF:000100', NULL, NULL, 'Glutathione S-transferase Z1', NULL, NULL, NULL, NULL, NULL, 4),
(68379, NULL, 'G3DSA:1.25.10.10:FF:002696', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68380, NULL, 'G3DSA:3.30.200.20:FF:002247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68381, NULL, 'G3DSA:1.25.10.10:FF:001510', NULL, NULL, 'Condensin-2 complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(68382, NULL, 'G3DSA:3.30.780.10:FF:000022', NULL, NULL, 'Mitochondrial ribosomal protein L49', NULL, NULL, NULL, NULL, NULL, 4),
(68383, NULL, 'G3DSA:2.70.170.10:FF:000139', NULL, NULL, 'Nicotinic acetylcholine receptor a10 subunit splice variant', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(68384, NULL, 'G3DSA:1.10.1240.20:FF:000001', NULL, NULL, 'Soluble lytic murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(68385, NULL, 'G3DSA:1.10.1420.10:FF:000097', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(68386, NULL, 'G3DSA:2.60.260.20:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68387, NULL, 'G3DSA:3.60.10.10:FF:000261', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68388, NULL, 'G3DSA:3.90.550.10:FF:000486', NULL, NULL, 'Glycosyl transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(68389, NULL, 'G3DSA:3.30.420.40:FF:000662', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(68390, NULL, 'G3DSA:2.60.40.150:FF:000297', NULL, NULL, 'YOR296W', NULL, NULL, NULL, NULL, NULL, 4),
(68391, NULL, 'G3DSA:2.130.10.10:FF:004751', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68392, NULL, 'G3DSA:1.10.2000.10:FF:000003', NULL, NULL, 'Frizzled class receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(68393, NULL, 'G3DSA:2.10.110.10:FF:000076', NULL, NULL, 'Zyxin', NULL, NULL, NULL, NULL, NULL, 4),
(68394, NULL, 'G3DSA:3.100.10.10:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68395, NULL, 'G3DSA:3.40.50.620:FF:000058', NULL, NULL, 'Mitochondrial arginyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(68396, NULL, 'G3DSA:2.130.10.10:FF:000597', NULL, NULL, 'Guanine nucleotide-exchange factor SEC12', NULL, NULL, NULL, NULL, NULL, 4),
(68397, NULL, 'G3DSA:1.10.1240.40:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68398, NULL, 'G3DSA:3.40.50.2300:FF:000095', NULL, NULL, 'Positive transcription regulator evgA', NULL, NULL, NULL, NULL, NULL, 4),
(68399, NULL, 'G3DSA:1.10.510.10:FF:000397', NULL, NULL, 'Serine/threonine-protein kinase KIN4', NULL, NULL, NULL, NULL, NULL, 4),
(68400, NULL, 'G3DSA:3.30.70.330:FF:002821', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68401, NULL, 'G3DSA:3.40.50.880:FF:000119', NULL, NULL, 'Glutamine amidotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(68402, NULL, 'G3DSA:3.40.50.150:FF:001423', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68403, NULL, 'G3DSA:2.60.40.10:FF:004559', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68404, NULL, 'G3DSA:3.40.30.10:FF:000797', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68405, NULL, 'G3DSA:3.30.160.60:FF:003244', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(68406, NULL, 'G3DSA:2.30.42.10:FF:000029', NULL, NULL, 'tight junction protein ZO-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(68407, NULL, 'G3DSA:3.10.20.870:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68408, NULL, 'G3DSA:1.20.1310.10:FF:000058', NULL, NULL, 'Anaphase-promoting complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(68409, NULL, 'G3DSA:2.60.40.60:FF:001011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68410, NULL, 'G3DSA:3.40.190.10:FF:000531', NULL, NULL, 'ABC-type phosphate transport system, periplasmic component', NULL, NULL, NULL, NULL, NULL, 4),
(68411, NULL, 'G3DSA:3.30.70.330:FF:000360', NULL, NULL, 'RNA-binding motif protein 15B', NULL, NULL, NULL, NULL, NULL, 4),
(68412, NULL, 'G3DSA:3.40.50.10490:FF:000010', NULL, NULL, '40S ribosomal protein S0', NULL, NULL, NULL, NULL, NULL, 4),
(68413, NULL, 'G3DSA:3.30.750.24:FF:000067', NULL, NULL, 'Sulfate permease family protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(68414, NULL, 'G3DSA:3.40.190.10:FF:000289', NULL, NULL, 'Ionotropic receptor 10a', NULL, NULL, NULL, NULL, NULL, 4),
(68415, NULL, 'G3DSA:2.130.10.10:FF:004649', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68416, NULL, 'G3DSA:4.10.60.10:FF:000135', NULL, NULL, 'Putative poly-zinc finger protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(68417, NULL, 'G3DSA:1.20.1070.10:FF:000443', NULL, NULL, 'Integral membrane protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(68418, NULL, 'G3DSA:1.10.357.10:FF:000091', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(68419, NULL, 'G3DSA:1.25.10.10:FF:000779', NULL, NULL, 'Proteasome component ECM29', NULL, NULL, NULL, NULL, NULL, 4),
(68420, NULL, 'G3DSA:2.30.29.30:FF:000274', NULL, NULL, 'Rhotekin 2', NULL, NULL, NULL, NULL, NULL, 4),
(68421, NULL, 'G3DSA:3.80.10.10:FF:001862', NULL, NULL, 'Internalin-I', NULL, NULL, NULL, NULL, NULL, 4),
(68422, NULL, 'G3DSA:1.20.1250.20:FF:002017', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68423, NULL, 'G3DSA:1.20.58.60:FF:000162', NULL, NULL, 'dystrophin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(68424, NULL, 'G3DSA:3.30.160.60:FF:005161', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68425, NULL, 'G3DSA:1.10.1670.10:FF:000031', NULL, NULL, 'Endonuclease III, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68426, NULL, 'G3DSA:1.10.600.10:FF:000145', NULL, NULL, 'Terpene cyclase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68427, NULL, 'G3DSA:3.30.160.60:FF:004885', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68428, NULL, 'G3DSA:3.30.1640.10:FF:000096', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(68429, NULL, 'G3DSA:3.90.930.12:FF:000012', NULL, NULL, 'Large subunit ribosomal protein L6', NULL, NULL, NULL, NULL, NULL, 4),
(68430, NULL, 'G3DSA:3.40.390.10:FF:000271', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68431, NULL, 'G3DSA:1.10.510.10:FF:001240', NULL, NULL, 'Kinase, ULK', NULL, NULL, NULL, NULL, NULL, 4),
(68432, NULL, 'G3DSA:1.20.1080.10:FF:000062', NULL, NULL, 'Aquaporin A', NULL, NULL, NULL, NULL, NULL, 4),
(68433, NULL, 'G3DSA:1.10.510.10:FF:000958', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(68434, NULL, 'G3DSA:3.30.740.10:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68435, NULL, 'G3DSA:2.60.40.60:FF:000735', NULL, NULL, 'Cadherin-4', NULL, NULL, NULL, NULL, NULL, 4),
(68436, NULL, 'G3DSA:2.60.260.20:FF:000163', NULL, NULL, 'Molecular chaperone, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68437, NULL, 'G3DSA:1.25.10.10:FF:002679', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68438, NULL, 'G3DSA:1.10.10.60:FF:000586', NULL, NULL, 'LIM domain family', NULL, NULL, NULL, NULL, NULL, 4),
(68439, NULL, 'G3DSA:3.40.50.620:FF:000075', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(68440, NULL, 'G3DSA:3.90.70.10:FF:000466', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68441, NULL, 'G3DSA:3.30.160.20:FF:000051', NULL, NULL, 'Microprocessor complex subunit DGCR8', NULL, NULL, NULL, NULL, NULL, 4),
(68442, NULL, 'G3DSA:1.10.2000.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68443, NULL, 'G3DSA:1.25.10.10:FF:002472', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68444, NULL, 'G3DSA:3.30.40.10:FF:000129', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(68445, NULL, 'G3DSA:3.30.1370.10:FF:000226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68446, NULL, 'G3DSA:1.25.40.10:FF:004761', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68447, NULL, 'G3DSA:2.30.42.10:FF:000355', NULL, NULL, 'protein lin-7 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(68448, NULL, 'G3DSA:3.30.160.60:FF:004655', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68449, NULL, 'G3DSA:3.40.47.10:FF:000195', NULL, NULL, 'Amino acid adenylation domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(68450, NULL, 'G3DSA:2.10.109.10:FF:000005', NULL, NULL, 'Mitochondrial inner membrane protease subunit', NULL, NULL, NULL, NULL, NULL, 4),
(68451, NULL, 'G3DSA:2.10.25.10:FF:001536', NULL, NULL, 'Neurogenic locus notch homolog protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(68452, NULL, 'G3DSA:2.70.130.10:FF:000148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(68453, NULL, 'G3DSA:3.10.100.10:FF:000049', NULL, NULL, 'Lymphocyte antigen 75 variant', NULL, NULL, NULL, NULL, NULL, 4),
(68454, NULL, 'G3DSA:3.30.70.330:FF:000567', NULL, NULL, 'RNA-binding protein musashi, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68455, NULL, 'G3DSA:3.30.470.20:FF:000041', NULL, NULL, 'Protein lysine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(68456, NULL, 'G3DSA:3.40.50.300:FF:002677', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(68457, NULL, 'G3DSA:3.40.30.10:FF:001056', NULL, NULL, 'Peroxiredoxin, probable', NULL, NULL, NULL, NULL, NULL, 4),
(68458, NULL, 'G3DSA:3.30.470.30:FF:000044', NULL, NULL, 'mRNA-capping enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(68459, NULL, 'G3DSA:3.40.309.10:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68460, NULL, 'G3DSA:2.60.40.1460:FF:000007', NULL, NULL, 'Integrin subunit alpha 9', NULL, NULL, NULL, NULL, NULL, 4),
(68461, NULL, 'G3DSA:2.60.40.10:FF:004885', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68462, NULL, 'G3DSA:3.30.870.10:FF:000029', NULL, NULL, 'Cardiolipin synthase C', NULL, NULL, NULL, NULL, NULL, 4),
(68463, NULL, 'G3DSA:3.30.160.60:FF:003570', NULL, NULL, 'LD24968p', NULL, NULL, NULL, NULL, NULL, 4),
(68464, NULL, 'G3DSA:1.10.1070.11:FF:000071', NULL, NULL, 'PIKK family atypical protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(68465, NULL, 'G3DSA:2.60.120.260:FF:000428', NULL, NULL, 'Reelin', NULL, NULL, NULL, NULL, NULL, 4),
(68466, NULL, 'G3DSA:3.40.50.720:FF:000116', NULL, NULL, 'Glyoxylate/hydroxypyruvate reductase A', NULL, NULL, NULL, NULL, NULL, 4),
(68467, NULL, 'G3DSA:2.60.40.1450:FF:000004', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(68468, NULL, 'G3DSA:3.30.70.330:FF:002158', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68469, NULL, 'G3DSA:1.10.238.10:FF:001191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68470, NULL, 'G3DSA:1.20.1250.20:FF:001528', NULL, NULL, 'General substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(68471, NULL, 'G3DSA:1.25.10.10:FF:000908', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(68472, NULL, 'G3DSA:3.40.640.10:FF:000381', NULL, NULL, 'Glycine dehydrogenase (Decarboxylating)', NULL, NULL, NULL, NULL, NULL, 4),
(68473, NULL, 'G3DSA:2.130.10.10:FF:001209', NULL, NULL, 'Periodic tryptophan protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(68474, NULL, 'G3DSA:3.40.50.10190:FF:000122', NULL, NULL, 'Pescadillo homolog', NULL, NULL, NULL, NULL, NULL, 4),
(68475, NULL, 'G3DSA:3.30.2160.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68476, NULL, 'G3DSA:3.80.10.10:FF:002351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68477, NULL, 'G3DSA:3.40.50.300:FF:004493', NULL, NULL, 'ATP-dependent DEAD/H RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68478, NULL, 'G3DSA:1.25.40.10:FF:002861', NULL, NULL, 'CCR4-NOT transcription complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(68479, NULL, 'G3DSA:2.40.50.140:FF:000446', NULL, NULL, 'Eukaryotic translation initiation factor 5A', NULL, NULL, NULL, NULL, NULL, 4),
(68480, NULL, 'G3DSA:3.20.20.140:FF:000300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68481, NULL, 'G3DSA:3.30.559.10:FF:000171', NULL, NULL, 'HC-toxin synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(68482, NULL, 'G3DSA:2.70.70.10:FF:000031', NULL, NULL, 'Peptidase M23B', NULL, NULL, NULL, NULL, NULL, 4),
(68483, NULL, 'G3DSA:1.20.1070.10:FF:000230', NULL, NULL, 'F2R-like thrombin or trypsin receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(68484, NULL, 'G3DSA:2.130.10.10:FF:000726', NULL, NULL, 'Neural precursor cell-expressed, developmentally down-regulated 1', NULL, NULL, NULL, NULL, NULL, 4),
(68485, NULL, 'G3DSA:2.130.10.10:FF:001002', NULL, NULL, 'A/G-specific adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(68486, NULL, 'G3DSA:3.40.50.970:FF:000045', NULL, NULL, 'Transketolase', NULL, NULL, NULL, NULL, NULL, 4),
(68487, NULL, 'G3DSA:3.40.720.10:FF:000201', NULL, NULL, 'Arylsulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(68488, NULL, 'G3DSA:1.10.10.60:FF:000715', NULL, NULL, 'One cut domain family member', NULL, NULL, NULL, NULL, NULL, 4),
(68489, NULL, 'G3DSA:3.40.50.300:FF:000777', NULL, NULL, 'tRNA (N6-adenosine(37)-N6)-threonylcarbamoyltransferase complex ATPase TsaE', NULL, NULL, NULL, NULL, NULL, 4),
(68490, NULL, 'G3DSA:1.20.1070.10:FF:002130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68491, NULL, 'G3DSA:3.30.70.330:FF:001978', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68492, NULL, 'G3DSA:3.40.50.980:FF:000048', NULL, NULL, 'CDA peptide synthetase III', NULL, NULL, NULL, NULL, NULL, 4),
(68493, NULL, 'G3DSA:2.10.25.10:FF:000125', NULL, NULL, 'Neurogenic locus notch protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(68494, NULL, 'G3DSA:3.40.50.300:FF:006393', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68495, NULL, 'G3DSA:3.40.50.2300:FF:000218', NULL, NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase SSU72', NULL, NULL, NULL, NULL, NULL, 4),
(68496, NULL, 'G3DSA:2.30.40.10:FF:000070', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(68497, NULL, 'G3DSA:1.10.1300.10:FF:000048', NULL, NULL, 'cGMP-specific 3'',5''-cyclic phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(68498, NULL, 'G3DSA:1.20.1050.130:FF:000025', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(68499, NULL, 'G3DSA:1.10.510.10:FF:003701', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68500, NULL, 'G3DSA:1.10.238.10:FF:000808', NULL, NULL, 'Mitochondrial carrier domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(68501, NULL, 'G3DSA:1.10.3470.10:FF:000050', NULL, NULL, 'Manganese ABC transporter, inner membrane permease protein SitC', NULL, NULL, NULL, NULL, NULL, 4),
(68502, NULL, 'G3DSA:3.30.160.60:FF:001119', NULL, NULL, 'zinc finger protein 408', NULL, NULL, NULL, NULL, NULL, 4),
(68503, NULL, 'G3DSA:2.60.40.10:FF:002985', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(68504, NULL, 'G3DSA:3.30.230.10:FF:000155', NULL, NULL, 'Ribonuclease P protein component', NULL, NULL, NULL, NULL, NULL, 4),
(68505, NULL, 'G3DSA:2.120.10.30:FF:000339', NULL, NULL, 'Alanyl dipeptidyl peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(68506, NULL, 'G3DSA:3.40.50.720:FF:001398', NULL, NULL, 'Zinc-binding oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68507, NULL, 'G3DSA:1.10.1040.10:FF:000112', NULL, NULL, 'Ketopantoate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(68508, NULL, 'G3DSA:3.40.50.300:FF:001266', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68509, NULL, 'G3DSA:3.30.70.330:FF:002254', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68510, NULL, 'G3DSA:3.90.79.10:FF:000238', NULL, NULL, 'Hydrolase, NUDIX family protein', NULL, NULL, NULL, NULL, NULL, 4),
(68511, NULL, 'G3DSA:3.10.20.90:FF:000737', NULL, NULL, 'Plexin-A2', NULL, NULL, NULL, NULL, NULL, 4),
(68512, NULL, 'G3DSA:2.40.50.90:FF:000144', NULL, NULL, 'YALI0B03960p', NULL, NULL, NULL, NULL, NULL, 4),
(68513, NULL, 'G3DSA:3.90.550.10:FF:000609', NULL, NULL, 'Similar to glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(68514, NULL, 'G3DSA:1.10.10.10:FF:000936', NULL, NULL, 'Forkhead box protein O', NULL, NULL, NULL, NULL, NULL, 4),
(68515, NULL, 'G3DSA:3.30.1490.80:FF:000025', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(68516, NULL, 'G3DSA:1.10.630.10:FF:000001', NULL, NULL, 'Cytochrome P450, family 2', NULL, NULL, NULL, NULL, NULL, 4),
(68517, NULL, 'G3DSA:1.20.1050.10:FF:000122', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(68518, NULL, 'G3DSA:1.20.1250.20:FF:000331', NULL, NULL, 'Protein NRT1/ PTR FAMILY 4.2', NULL, NULL, NULL, NULL, NULL, 4),
(68519, NULL, 'G3DSA:3.30.160.60:FF:004559', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(68520, NULL, 'G3DSA:3.30.428.10:FF:000007', NULL, NULL, 'HIT family protein', NULL, NULL, NULL, NULL, NULL, 4),
(68521, NULL, 'G3DSA:3.40.50.10890:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68522, NULL, 'G3DSA:3.80.10.10:FF:003548', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(68523, NULL, 'G3DSA:3.40.50.1820:FF:001676', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(68524, NULL, 'G3DSA:3.30.40.10:FF:001669', NULL, NULL, 'Kinase', NULL, NULL, NULL, NULL, NULL, 4),
(68525, NULL, 'G3DSA:2.130.10.10:FF:002963', NULL, NULL, 'AGAP006735-PA', NULL, NULL, NULL, NULL, NULL, 4),
(68526, NULL, 'G3DSA:2.60.120.200:FF:000214', NULL, NULL, 'DE cadherin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(68527, NULL, 'G3DSA:3.20.20.150:FF:000062', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(68528, NULL, 'G3DSA:3.30.1360.10:FF:000046', NULL, NULL, 'DNA-directed RNA polymerases II IV and V subunit 11', NULL, NULL, NULL, NULL, NULL, 4),
(68529, NULL, 'G3DSA:3.40.850.10:FF:000317', NULL, NULL, 'Kinesin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68530, NULL, 'G3DSA:3.40.50.2300:FF:000645', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(68531, NULL, 'G3DSA:1.25.40.10:FF:000624', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(68532, NULL, 'G3DSA:2.60.40.10:FF:001900', NULL, NULL, 'Myotactin form B', NULL, NULL, NULL, NULL, NULL, 4),
(68533, NULL, 'G3DSA:2.30.30.30:FF:000036', NULL, NULL, 'Elongation factor P-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(68534, NULL, 'G3DSA:2.60.40.150:FF:000763', NULL, NULL, 'Ingression protein fic1', NULL, NULL, NULL, NULL, NULL, 4),
(68535, NULL, 'G3DSA:3.40.50.1820:FF:000052', NULL, NULL, 'Putative aminoacrylate hydrolase RutD', NULL, NULL, NULL, NULL, NULL, 4),
(68536, NULL, 'G3DSA:3.30.300.30:FF:000043', NULL, NULL, 'Lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(68537, NULL, 'G3DSA:3.30.160.60:FF:001333', NULL, NULL, 'Zinc finger with KRAB and SCAN domains 4', NULL, NULL, NULL, NULL, NULL, 4),
(68538, NULL, 'G3DSA:1.10.10.60:FF:000923', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68539, NULL, 'G3DSA:3.30.260.10:FF:000011', NULL, NULL, 'T-complex protein 1 subunit zeta', NULL, NULL, NULL, NULL, NULL, 4),
(68540, NULL, 'G3DSA:3.90.660.10:FF:000022', NULL, NULL, 'Flavin containing polyamine oxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68541, NULL, 'G3DSA:1.25.40.20:FF:001228', NULL, NULL, 'Mechanosensory transduction channel NOMPC', NULL, NULL, NULL, NULL, NULL, 4),
(68542, NULL, 'G3DSA:1.10.1200.150:FF:000003', NULL, NULL, 'Transcriptional regulator CtsR', NULL, NULL, NULL, NULL, NULL, 4),
(68543, NULL, 'G3DSA:2.60.40.4060:FF:000017', NULL, NULL, 'Spondin-1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(68544, NULL, 'G3DSA:3.30.60.60:FF:000022', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(68545, NULL, 'G3DSA:3.80.10.10:FF:000322', NULL, NULL, 'Matrix remodeling associated 5', NULL, NULL, NULL, NULL, NULL, 4),
(68546, NULL, 'G3DSA:2.60.120.590:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68547, NULL, 'G3DSA:3.90.640.10:FF:000122', NULL, NULL, 'WGS project CABT00000000 data, contig 2.6', NULL, NULL, NULL, NULL, NULL, 4),
(68548, NULL, 'G3DSA:3.40.50.300:FF:006634', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(68549, NULL, 'G3DSA:3.40.1280.10:FF:000043', NULL, NULL, 'EMG1/NEP1 methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68550, NULL, 'G3DSA:1.10.287.470:FF:000020', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(68551, NULL, 'G3DSA:3.90.660.20:FF:000025', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(68552, NULL, 'G3DSA:2.30.42.10:FF:000147', NULL, NULL, 'Pro-interleukin-16', NULL, NULL, NULL, NULL, NULL, 4),
(68553, NULL, 'G3DSA:3.90.110.10:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(68554, NULL, 'G3DSA:2.70.150.10:FF:000256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68555, NULL, 'G3DSA:1.20.1540.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68556, NULL, 'G3DSA:3.40.605.10:FF:000001', NULL, NULL, 'Aldehyde dehydrogenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(68557, NULL, 'G3DSA:1.10.287.70:FF:000422', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(68558, NULL, 'G3DSA:3.90.740.10:FF:000068', NULL, NULL, 'Os05g0241100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(68559, NULL, 'G3DSA:1.20.1250.20:FF:000432', NULL, NULL, 'MFS transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(68560, NULL, 'G3DSA:3.10.180.10:FF:000043', NULL, NULL, '27 kDa antigen Cfp30B', NULL, NULL, NULL, NULL, NULL, 4),
(68561, NULL, 'G3DSA:3.40.50.150:FF:000934', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68562, NULL, 'G3DSA:3.20.20.300:FF:000034', NULL, NULL, 'Beta-glucosidase-like glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(68563, NULL, 'G3DSA:2.130.10.10:FF:000934', NULL, NULL, 'sperm-associated antigen 16 protein', NULL, NULL, NULL, NULL, NULL, 4),
(68564, NULL, 'G3DSA:3.30.70.330:FF:002366', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68565, NULL, 'G3DSA:1.10.1870.10:FF:000012', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(68566, NULL, 'G3DSA:3.30.1520.10:FF:000143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68567, NULL, 'G3DSA:3.10.430.100:FF:000012', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(68568, NULL, 'G3DSA:3.30.2080.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68569, NULL, 'G3DSA:3.40.50.300:FF:005105', NULL, NULL, 'Septation protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(68570, NULL, 'G3DSA:3.40.50.620:FF:000524', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68571, NULL, 'G3DSA:1.10.238.10:FF:000359', NULL, NULL, 'Dystrophin-1', NULL, NULL, NULL, NULL, NULL, 4),
(68572, NULL, 'G3DSA:3.40.50.1760:FF:000005', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(68573, NULL, 'G3DSA:3.10.10.10:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68574, NULL, 'G3DSA:3.40.190.10:FF:000076', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(68575, NULL, 'G3DSA:3.30.260.10:FF:000106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68576, NULL, 'G3DSA:1.10.10.10:FF:000369', NULL, NULL, 'Werner syndrome ATP-dependent helicase', NULL, NULL, NULL, NULL, NULL, 4),
(68577, NULL, 'G3DSA:3.20.20.380:FF:000001', NULL, NULL, 'Copper homeostasis protein CutC', NULL, NULL, NULL, NULL, NULL, 4),
(68578, NULL, 'G3DSA:1.20.1510.10:FF:000039', NULL, NULL, 'Related to zinc transporter', NULL, NULL, NULL, NULL, NULL, 4),
(68579, NULL, 'G3DSA:2.130.10.10:FF:005026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68580, NULL, 'G3DSA:3.40.50.1980:FF:000072', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(68581, NULL, 'G3DSA:3.30.160.60:FF:003362', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68582, NULL, 'G3DSA:3.40.50.2000:FF:000561', NULL, NULL, 'Putative glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(68583, NULL, 'G3DSA:3.80.10.10:FF:002025', NULL, NULL, 'F-box family protein', NULL, NULL, NULL, NULL, NULL, 4),
(68584, NULL, 'G3DSA:1.25.40.10:FF:002069', NULL, NULL, 'Putative ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(68585, NULL, 'G3DSA:1.10.510.10:FF:000279', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(68586, NULL, 'G3DSA:1.10.760.10:FF:000089', NULL, NULL, 'Cytochrome c, mono-and diheme variants', NULL, NULL, NULL, NULL, NULL, 4),
(68587, NULL, 'G3DSA:1.10.238.10:FF:000590', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(68588, NULL, 'G3DSA:1.10.10.10:FF:001100', NULL, NULL, 'Regulatory protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(68589, NULL, 'G3DSA:1.20.1250.20:FF:001854', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68590, NULL, 'G3DSA:3.40.50.300:FF:001154', NULL, NULL, 'RAS (RAD and GEM)-like GTP-binding 2', NULL, NULL, NULL, NULL, NULL, 4),
(68591, NULL, 'G3DSA:1.10.472.10:FF:000178', NULL, NULL, 'Unplaced genomic scaffold supercont2.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(68592, NULL, 'G3DSA:3.40.50.1820:FF:000153', NULL, NULL, 'Surfactin synthase thioesterase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(68593, NULL, 'G3DSA:3.40.50.300:FF:006729', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(68594, NULL, 'G3DSA:3.40.50.970:FF:000051', NULL, NULL, 'Sulfite reductase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(68595, NULL, 'G3DSA:2.30.42.10:FF:000260', NULL, NULL, 'membrane-associated guanylate kinase, WW and PDZ domain-containing protein 1-like isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(68596, NULL, 'G3DSA:3.90.1150.10:FF:000325', NULL, NULL, '(S)-3,5-dihydroxyphenylglycine transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(68597, NULL, 'G3DSA:3.30.50.10:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68598, NULL, 'G3DSA:3.40.630.10:FF:000099', NULL, NULL, 'Cytosolic non-specific dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(68599, NULL, 'G3DSA:1.10.220.150:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68600, NULL, 'G3DSA:3.30.40.10:FF:001995', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68601, NULL, 'G3DSA:3.30.230.70:FF:000162', NULL, NULL, 'Exosomal 3''-5'' exoribonuclease complex, subunit Rrp42, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68602, NULL, 'G3DSA:1.25.40.20:FF:000947', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68603, NULL, 'G3DSA:2.160.20.120:FF:000001', NULL, NULL, 'Protein FAM185A', NULL, NULL, NULL, NULL, NULL, 4),
(68604, NULL, 'G3DSA:3.80.10.10:FF:003868', NULL, NULL, 'Endonuclease/Exonuclease/phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(68605, NULL, 'G3DSA:3.40.850.10:FF:000525', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(68606, NULL, 'G3DSA:3.30.70.330:FF:000455', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(68607, NULL, 'G3DSA:2.30.29.230:FF:000003', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(68608, NULL, 'G3DSA:1.25.40.20:FF:001341', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68609, NULL, 'G3DSA:1.25.10.10:FF:000785', NULL, NULL, 'Adaptor related protein complex 3 subunit delta 1', NULL, NULL, NULL, NULL, NULL, 4),
(68610, NULL, 'G3DSA:2.20.70.10:FF:000016', NULL, NULL, 'Transcription elongation regulator 1 (CA150)', NULL, NULL, NULL, NULL, NULL, 4),
(68611, NULL, 'G3DSA:3.50.50.60:FF:000352', NULL, NULL, 'Mycothione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(68612, NULL, 'G3DSA:3.80.10.10:FF:003756', NULL, NULL, 'Receptor-like protein 33', NULL, NULL, NULL, NULL, NULL, 4),
(68613, NULL, 'G3DSA:2.40.10.10:FF:000635', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68614, NULL, 'G3DSA:3.30.160.60:FF:002761', NULL, NULL, 'Zinc finger protein 845', NULL, NULL, NULL, NULL, NULL, 4),
(68615, NULL, 'G3DSA:1.20.120.1240:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68616, NULL, 'G3DSA:1.25.40.10:FF:004098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68617, NULL, 'G3DSA:1.25.40.10:FF:000944', NULL, NULL, 'BnaC07g00040D protein', NULL, NULL, NULL, NULL, NULL, 4),
(68618, NULL, 'G3DSA:1.10.510.10:FF:003134', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68619, NULL, 'G3DSA:1.10.472.10:FF:000386', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(68620, NULL, 'G3DSA:1.10.472.10:FF:000498', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68621, NULL, 'G3DSA:2.20.110.10:FF:000040', NULL, NULL, 'Phosphatidylinositol 4-phosphate 5-kinase 6', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(68622, NULL, 'G3DSA:3.40.50.1070:FF:000001', NULL, NULL, 'L-fucose isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(68623, NULL, 'G3DSA:3.40.50.1100:FF:000179', NULL, NULL, 'Pyridoxal-phosphate dependent enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(68624, NULL, 'G3DSA:1.25.40.10:FF:000832', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(68625, NULL, 'G3DSA:3.40.50.970:FF:000146', NULL, NULL, '2-hydroxyacyl-CoA lyase', NULL, NULL, NULL, NULL, NULL, 4),
(68626, NULL, 'G3DSA:3.40.50.300:FF:003065', NULL, NULL, 'GTP-binding nuclear protein', NULL, NULL, NULL, NULL, NULL, 4),
(68627, NULL, 'G3DSA:3.40.50.170:FF:000018', NULL, NULL, '10-formyltetrahydrofolate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(68628, NULL, 'G3DSA:1.10.10.60:FF:000592', NULL, NULL, 'AraC/XylS family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(68629, NULL, 'G3DSA:3.30.70.330:FF:000028', NULL, NULL, 'Putative serine/arginine-rich splicing factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(68630, NULL, 'G3DSA:3.60.15.10:FF:000036', NULL, NULL, 'DNA internalization-related competence protein ComEC/Rec2', NULL, NULL, NULL, NULL, NULL, 4),
(68631, NULL, 'G3DSA:3.30.565.10:FF:000472', NULL, NULL, 'Hybrid sensory kinase', NULL, NULL, NULL, NULL, NULL, 4),
(68632, NULL, 'G3DSA:3.40.50.300:FF:001507', NULL, NULL, 'X-ray repair cross complementing 2', NULL, NULL, NULL, NULL, NULL, 4),
(68633, NULL, 'G3DSA:3.40.50.150:FF:001182', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68634, NULL, 'G3DSA:3.40.50.720:FF:000088', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(68635, NULL, 'G3DSA:3.10.129.110:FF:000001', NULL, NULL, 'Sterigmatocystin biosynthesis polyketide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(68636, NULL, 'G3DSA:1.25.40.420:FF:000034', NULL, NULL, 'Os01g0968600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(68637, NULL, 'G3DSA:3.40.630.10:FF:000436', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68638, NULL, 'G3DSA:2.40.37.10:FF:000073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68639, NULL, 'G3DSA:3.40.50.2300:FF:000544', NULL, NULL, 'Two component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(68640, NULL, 'G3DSA:3.30.70.330:FF:000921', NULL, NULL, 'Clustered-asparagine-rich protein', NULL, NULL, NULL, NULL, NULL, 4),
(68641, NULL, 'G3DSA:3.30.160.60:FF:001232', NULL, NULL, 'zinc finger protein 62 homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(68642, NULL, 'G3DSA:1.20.1070.10:FF:000331', NULL, NULL, 'Opioid receptor delta 1', NULL, NULL, NULL, NULL, NULL, 4),
(68643, NULL, 'G3DSA:1.20.1720.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68644, NULL, 'G3DSA:3.50.50.60:FF:000234', NULL, NULL, 'Flavocytochrome C sulfide dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(68645, NULL, 'G3DSA:3.90.245.10:FF:000001', NULL, NULL, 'Pyrimidine-specific ribonucleoside hydrolase RihA', NULL, NULL, NULL, NULL, NULL, 4),
(68646, NULL, 'G3DSA:1.10.8.270:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68647, NULL, 'G3DSA:3.40.50.1480:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68648, NULL, 'G3DSA:2.40.30.160:FF:000004', NULL, NULL, 'Glycine cleavage T-protein', NULL, NULL, NULL, NULL, NULL, 4),
(68649, NULL, 'G3DSA:3.40.50.1240:FF:000193', NULL, NULL, 'Chromosome 23, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(68650, NULL, 'G3DSA:1.10.472.10:FF:000291', NULL, NULL, 'Putative cyclin-A3-1', NULL, NULL, NULL, NULL, NULL, 4),
(68651, NULL, 'G3DSA:1.25.40.20:FF:001442', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68652, NULL, 'G3DSA:2.10.25.10:FF:001087', NULL, NULL, 'LP19846p', NULL, NULL, NULL, NULL, NULL, 4),
(68653, NULL, 'G3DSA:1.10.150.20:FF:000074', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(68654, NULL, 'G3DSA:3.40.850.10:FF:000430', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(68655, NULL, 'G3DSA:3.40.50.300:FF:005217', NULL, NULL, 'Phage protein', NULL, NULL, NULL, NULL, NULL, 4),
(68656, NULL, 'G3DSA:3.30.200.20:FF:000673', NULL, NULL, 'cyclin-dependent kinase 9', NULL, NULL, NULL, NULL, NULL, 4),
(68657, NULL, 'G3DSA:2.130.10.10:FF:001440', NULL, NULL, 'WD domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(68658, NULL, 'G3DSA:2.40.30.170:FF:000007', NULL, NULL, 'Macrolide transporter subunit MacA', NULL, NULL, NULL, NULL, NULL, 4),
(68659, NULL, 'G3DSA:2.60.40.60:FF:000943', NULL, NULL, 'Protocadherin gamma subfamily C, 3', NULL, NULL, NULL, NULL, NULL, 4),
(68660, NULL, 'G3DSA:1.25.40.570:FF:000051', NULL, NULL, '26S proteasome regulatory complex component', NULL, NULL, NULL, NULL, NULL, 4),
(68661, NULL, 'G3DSA:1.20.1250.20:FF:000218', NULL, NULL, 'facilitated trehalose transporter Tret1', NULL, NULL, NULL, NULL, NULL, 4),
(68662, NULL, 'G3DSA:1.10.510.10:FF:004449', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68663, NULL, 'G3DSA:3.30.70.270:FF:000190', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68664, NULL, 'G3DSA:3.40.50.1820:FF:001575', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(68665, NULL, 'G3DSA:3.30.160.60:FF:002856', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68666, NULL, 'G3DSA:1.20.920.20:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68667, NULL, 'G3DSA:3.40.50.720:FF:002342', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68668, NULL, 'G3DSA:2.30.30.40:FF:000359', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(68669, NULL, 'G3DSA:1.20.1070.10:FF:001865', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68670, NULL, 'G3DSA:3.40.395.10:FF:000046', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(68671, NULL, 'G3DSA:1.20.5.170:FF:000300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68672, NULL, 'G3DSA:1.10.1450.10:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68673, NULL, 'G3DSA:3.40.50.1460:FF:000022', NULL, NULL, 'GPI8p transamidase', NULL, NULL, NULL, NULL, NULL, 4),
(68674, NULL, 'G3DSA:1.10.10.60:FF:000687', NULL, NULL, 'Middle operon regulator', NULL, NULL, NULL, NULL, NULL, 4),
(68675, NULL, 'G3DSA:1.20.58.60:FF:000049', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(68676, NULL, 'G3DSA:3.80.10.10:FF:003661', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68677, NULL, 'G3DSA:1.20.80.10:FF:000002', NULL, NULL, 'radixin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(68678, NULL, 'G3DSA:2.60.40.10:FF:003250', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68679, NULL, 'G3DSA:2.40.50.140:FF:000901', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68680, NULL, 'G3DSA:2.30.230.10:FF:000041', NULL, NULL, 'Vitellogenin-3', NULL, NULL, NULL, NULL, NULL, 4),
(68681, NULL, 'G3DSA:3.40.50.300:FF:003183', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(68682, NULL, 'G3DSA:1.20.920.30:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68683, NULL, 'G3DSA:3.10.129.10:FF:000244', NULL, NULL, 'Acyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(68684, NULL, 'G3DSA:1.20.1560.10:FF:000200', NULL, NULL, 'HlyB/MsbA family ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(68685, NULL, 'G3DSA:3.90.70.10:FF:000819', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 30 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(68686, NULL, 'G3DSA:3.30.1740.10:FF:000030', NULL, NULL, 'Poly [ADP-ribose] polymerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(68687, NULL, 'G3DSA:3.30.40.10:FF:001557', NULL, NULL, 'MNAT1, CDK activating kinase assembly factor', NULL, NULL, NULL, NULL, NULL, 4),
(68688, NULL, 'G3DSA:2.30.30.40:FF:000590', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(68689, NULL, 'G3DSA:3.50.50.60:FF:000672', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(68690, NULL, 'G3DSA:2.60.120.200:FF:000326', NULL, NULL, 'Vesicular integral membrane protein VIP36, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68691, NULL, 'G3DSA:2.60.40.10:FF:001007', NULL, NULL, 'nectin-4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(68692, NULL, 'G3DSA:3.30.450.40:FF:000259', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(68693, NULL, 'G3DSA:1.20.1050.10:FF:000234', NULL, NULL, 'Glutathione S-transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68694, NULL, 'G3DSA:3.30.160.60:FF:004447', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68695, NULL, 'G3DSA:2.60.40.10:FF:000389', NULL, NULL, 'Immunoglobulin superfamily member 9B', NULL, NULL, NULL, NULL, NULL, 4),
(68696, NULL, 'G3DSA:1.20.1070.10:FF:002129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68697, NULL, 'G3DSA:3.10.100.10:FF:000280', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68698, NULL, 'G3DSA:2.40.70.10:FF:000386', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68699, NULL, 'G3DSA:3.30.710.10:FF:000074', NULL, NULL, 'Zinc finger and BTB domain-containing 48', NULL, NULL, NULL, NULL, NULL, 4),
(68700, NULL, 'G3DSA:1.25.10.10:FF:001611', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68701, NULL, 'G3DSA:3.20.20.80:FF:000430', NULL, NULL, 'Glucosylceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(68702, NULL, 'G3DSA:3.30.190.20:FF:000002', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(68703, NULL, 'G3DSA:3.40.50.970:FF:000157', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(68704, NULL, 'G3DSA:3.10.50.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68705, NULL, 'G3DSA:2.40.50.140:FF:000351', NULL, NULL, 'ATP-dependent DNA helicase RecG', NULL, NULL, NULL, NULL, NULL, 4),
(68706, NULL, 'G3DSA:1.10.510.10:FF:002971', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68707, NULL, 'G3DSA:3.90.70.40:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68708, NULL, 'G3DSA:1.20.58.90:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68709, NULL, 'G3DSA:3.30.70.330:FF:001883', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68710, NULL, 'G3DSA:3.30.450.70:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68711, NULL, 'G3DSA:3.10.10.10:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68712, NULL, 'G3DSA:1.20.120.1240:FF:000060', NULL, NULL, 'Interferon-induced GTP-binding protein Mx1', NULL, NULL, NULL, NULL, NULL, 4),
(68713, NULL, 'G3DSA:3.40.390.10:FF:000057', NULL, NULL, 'Zinc metalloproteinase', NULL, NULL, NULL, NULL, NULL, 4),
(68714, NULL, 'G3DSA:1.25.10.10:FF:000993', NULL, NULL, 'Protein CBG22497', NULL, NULL, NULL, NULL, NULL, 4),
(68715, NULL, 'G3DSA:3.90.640.10:FF:000133', NULL, NULL, 'SWI/SNF and RSC complexes subunit arp42', NULL, NULL, NULL, NULL, NULL, 4),
(68716, NULL, 'G3DSA:3.30.200.20:FF:001050', NULL, NULL, 'Elongation factor 2 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(68717, NULL, 'G3DSA:1.25.40.180:FF:000041', NULL, NULL, 'Nuclear cap-binding protein subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(68718, NULL, 'G3DSA:2.60.120.340:FF:000008', NULL, NULL, 'FK506-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68719, NULL, 'G3DSA:3.40.50.10810:FF:000168', NULL, NULL, 'DNA repair and recombination protein RAD54B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68720, NULL, 'G3DSA:3.40.50.300:FF:001715', NULL, NULL, 'ATP-dependent helicase/nuclease subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(68721, NULL, 'G3DSA:3.30.200.20:FF:000774', NULL, NULL, 'Serine/threonine-protein kinase SSN3', NULL, NULL, NULL, NULL, NULL, 4),
(68722, NULL, 'G3DSA:3.30.450.20:FF:000253', NULL, NULL, 'Phytochrome-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(68723, NULL, 'G3DSA:3.40.50.2000:FF:000550', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68724, NULL, 'G3DSA:2.60.410.10:FF:000003', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase DacF', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(68725, NULL, 'G3DSA:2.40.128.30:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68726, NULL, 'G3DSA:2.40.30.150:FF:000001', NULL, NULL, 'Phage baseplate hub subunit', NULL, NULL, NULL, NULL, NULL, 4),
(68727, NULL, 'G3DSA:3.60.120.10:FF:000016', NULL, NULL, 'Aminodeoxychorismate synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(68728, NULL, 'G3DSA:1.25.10.10:FF:002707', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68729, NULL, 'G3DSA:2.170.130.10:FF:000040', NULL, NULL, 'Transporter, outer membrane receptor (OMR) family', NULL, NULL, NULL, NULL, NULL, 4),
(68730, NULL, 'G3DSA:3.40.190.10:FF:000626', NULL, NULL, 'N-methyl-D-aspartate receptor subunit 2D variant', NULL, NULL, NULL, NULL, NULL, 4),
(68731, NULL, 'G3DSA:3.30.70.330:FF:002046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68732, NULL, 'G3DSA:3.90.650.10:FF:000061', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(68733, NULL, 'G3DSA:3.30.40.10:FF:001658', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68734, NULL, 'G3DSA:3.30.479.20:FF:000010', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(68735, NULL, 'G3DSA:1.20.1070.10:FF:000342', NULL, NULL, 'Opioid receptor delta 1', NULL, NULL, NULL, NULL, NULL, 4),
(68736, NULL, 'G3DSA:2.60.40.150:FF:000752', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68737, NULL, 'G3DSA:2.60.120.200:FF:000225', NULL, NULL, 'MAM and LDL receptor class A domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(68738, NULL, 'G3DSA:3.30.465.10:FF:000065', NULL, NULL, 'CBS domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(68739, NULL, 'G3DSA:3.40.50.720:FF:000004', NULL, NULL, 'Adenosylhomocysteinase', NULL, NULL, NULL, NULL, NULL, 4),
(68740, NULL, 'G3DSA:1.10.10.2740:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68741, NULL, 'G3DSA:3.90.100.10:FF:000003', NULL, NULL, 'Orn/Arg/Lys decarboxylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68742, NULL, 'G3DSA:3.40.462.20:FF:000003', NULL, NULL, 'FAD-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(68743, NULL, 'G3DSA:3.30.479.30:FF:000013', NULL, NULL, 'Hypersensitive-induced response protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(68744, NULL, 'G3DSA:2.60.40.1170:FF:000027', NULL, NULL, 'Adaptor complexes medium subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(68745, NULL, 'G3DSA:2.60.40.10:FF:004773', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68746, NULL, 'G3DSA:2.10.25.10:FF:000013', NULL, NULL, 'Teneurin transmembrane protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(68747, NULL, 'G3DSA:1.10.600.10:FF:000050', NULL, NULL, 'Squalene synthase HpnC', NULL, NULL, NULL, NULL, NULL, 4),
(68748, NULL, 'G3DSA:3.40.50.720:FF:000324', NULL, NULL, 'uncharacterized protein ycf39 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(68749, NULL, 'G3DSA:3.40.640.10:FF:000493', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68750, NULL, 'G3DSA:3.30.710.10:FF:000315', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68751, NULL, 'G3DSA:3.40.350.10:FF:000049', NULL, NULL, 'GD20570', NULL, NULL, NULL, NULL, NULL, 4),
(68752, NULL, 'G3DSA:2.120.10.30:FF:000238', NULL, NULL, 'Haloacid dehalogenase-like hydrolase domain-containing protein Sgpp', NULL, NULL, NULL, NULL, NULL, 4),
(68753, NULL, 'G3DSA:2.30.29.30:FF:000723', NULL, NULL, 'RAN binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(68754, NULL, 'G3DSA:3.40.50.300:FF:006842', NULL, NULL, 'Heparan-sulfate 6-O-sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(68755, NULL, 'G3DSA:1.20.1440.120:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68756, NULL, 'G3DSA:2.60.40.630:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68757, NULL, 'G3DSA:2.30.30.100:FF:000073', NULL, NULL, 'LSM2 homolog, U6 small nuclear RNA and mRNA degradation associated', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(68758, NULL, 'G3DSA:1.10.620.20:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68759, NULL, 'G3DSA:3.40.640.10:FF:000263', NULL, NULL, 'Kynurenine aminotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68760, NULL, 'G3DSA:1.20.140.150:FF:000073', NULL, NULL, 'Calcium channel, voltage-dependent, gamma subunit 3a', NULL, NULL, NULL, NULL, NULL, 4),
(68761, NULL, 'G3DSA:3.40.30.10:FF:001168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68762, NULL, 'G3DSA:3.90.1300.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68763, NULL, 'G3DSA:1.20.1440.130:FF:000007', NULL, NULL, 'vitamin K epoxide reductase complex subunit 1-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(68764, NULL, 'G3DSA:3.40.50.920:FF:000058', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(68765, NULL, 'G3DSA:3.40.50.300:FF:000889', NULL, NULL, 'Cobalamin synthesis protein P47K', NULL, NULL, NULL, NULL, NULL, 4),
(68766, NULL, 'G3DSA:3.30.720.210:FF:000016', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(68767, NULL, 'G3DSA:3.30.40.10:FF:000034', NULL, NULL, 'Histone acetyltransferase p300', NULL, NULL, NULL, NULL, NULL, 4),
(68768, NULL, 'G3DSA:3.30.559.70:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68769, NULL, 'G3DSA:1.25.40.90:FF:000018', NULL, NULL, 'ENTH/VHS family protein isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(68770, NULL, 'G3DSA:3.20.140.10:FF:000004', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(68771, NULL, 'G3DSA:3.40.50.150:FF:000468', NULL, NULL, 'SD03208p', NULL, NULL, NULL, NULL, NULL, 4),
(68772, NULL, 'G3DSA:3.30.980.10:FF:000003', NULL, NULL, 'Threonine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(68773, NULL, 'G3DSA:2.10.25.10:FF:001750', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(68774, NULL, 'G3DSA:3.60.40.10:FF:000100', NULL, NULL, 'Stage II sporulation protein E', NULL, NULL, NULL, NULL, NULL, 4),
(68775, NULL, 'G3DSA:3.40.50.2300:FF:000106', NULL, NULL, 'Glutamate receptor ionotropic, kainate', NULL, NULL, NULL, NULL, NULL, 4),
(68776, NULL, 'G3DSA:3.30.160.60:FF:000838', NULL, NULL, 'Zinc finger protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(68777, NULL, 'G3DSA:1.25.40.10:FF:001107', NULL, NULL, 'Protein NRDE2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(68778, NULL, 'G3DSA:2.60.40.10:FF:005610', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68779, NULL, 'G3DSA:2.10.25.10:FF:001295', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(68780, NULL, 'G3DSA:2.60.40.10:FF:002873', NULL, NULL, 'Interleukin 13 receptor, alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(68781, NULL, 'G3DSA:3.40.47.10:FF:000077', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(68782, NULL, 'G3DSA:3.30.230.70:FF:000049', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(68783, NULL, 'G3DSA:1.10.472.10:FF:000509', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68784, NULL, 'G3DSA:3.40.190.10:FF:000065', NULL, NULL, 'Sulfate ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(68785, NULL, 'G3DSA:1.25.40.10:FF:002962', NULL, NULL, 'Anaphase promoting complex subunit 7, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(68786, NULL, 'G3DSA:1.10.1170.10:FF:000015', NULL, NULL, 'Baculoviral IAP repeat-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(68787, NULL, 'G3DSA:3.90.1140.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68788, NULL, 'G3DSA:3.40.50.1000:FF:000716', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68789, NULL, 'G3DSA:1.20.1070.10:FF:001966', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68790, NULL, 'G3DSA:2.60.40.60:FF:000269', NULL, NULL, 'Dachsous cadherin-related 2', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(68791, NULL, 'G3DSA:3.40.50.1470:FF:000014', NULL, NULL, 'Peptidyl-tRNA hydrolase mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(68792, NULL, 'G3DSA:3.30.160.60:FF:005043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68793, NULL, 'G3DSA:3.40.50.300:FF:004588', NULL, NULL, 'Dynein heavy chain, cytosolic, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68794, NULL, 'G3DSA:2.30.29.30:FF:000162', NULL, NULL, 'protein ECT2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(68795, NULL, 'G3DSA:3.40.1090.10:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68796, NULL, 'G3DSA:3.40.50.300:FF:005206', NULL, NULL, 'Ypt7p', NULL, NULL, NULL, NULL, NULL, 4),
(68797, NULL, 'G3DSA:3.30.160.60:FF:002867', NULL, NULL, 'Zinc finger protein 715', NULL, NULL, NULL, NULL, NULL, 4),
(68798, NULL, 'G3DSA:3.40.50.1460:FF:000011', NULL, NULL, 'Caspase-7', NULL, NULL, NULL, NULL, NULL, 4),
(68799, NULL, 'G3DSA:3.40.50.1480:FF:000017', NULL, NULL, 'Adenosylhomocysteinase', NULL, NULL, NULL, NULL, NULL, 4),
(68800, NULL, 'G3DSA:2.120.10.30:FF:000227', NULL, NULL, 'Blr7870 protein', NULL, NULL, NULL, NULL, NULL, 4),
(68801, NULL, 'G3DSA:2.40.50.90:FF:000026', NULL, NULL, 'Tudor domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(68802, NULL, 'G3DSA:3.30.160.60:FF:004767', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68803, NULL, 'G3DSA:3.40.50.410:FF:000113', NULL, NULL, 'Protein CBR-CUT-6', NULL, NULL, NULL, NULL, NULL, 4),
(68804, NULL, 'G3DSA:3.40.366.10:FF:000052', NULL, NULL, 'Acyl transferase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(68805, NULL, 'G3DSA:3.80.10.10:FF:001396', NULL, NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', NULL, NULL, NULL, NULL, NULL, 4),
(68806, NULL, 'G3DSA:3.40.50.300:FF:003306', NULL, NULL, 'ATP-dependent dethiobiotin synthetase BioD', NULL, NULL, NULL, NULL, NULL, 4),
(68807, NULL, 'G3DSA:2.40.50.140:FF:000238', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(68808, NULL, 'G3DSA:3.30.420.340:FF:000004', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4),
(68809, NULL, 'G3DSA:3.90.550.10:FF:000694', NULL, NULL, 'Galactosylgalactosylxylosylprotein 3beta-glucuronosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68810, NULL, 'G3DSA:3.90.70.10:FF:000578', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(68811, NULL, 'G3DSA:1.10.510.10:FF:001335', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68812, NULL, 'G3DSA:3.10.110.10:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68813, NULL, 'G3DSA:1.10.8.100:FF:000012', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(68814, NULL, 'G3DSA:3.20.100.10:FF:000007', NULL, NULL, 'mRNA capping enzyme, beta chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68815, NULL, 'G3DSA:3.30.70.270:FF:000313', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68816, NULL, 'G3DSA:3.30.470.20:FF:000153', NULL, NULL, 'Tubulin tyrosine ligase protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68817, NULL, 'G3DSA:3.40.1120.10:FF:000003', NULL, NULL, 'Ribosomal protein L15', NULL, NULL, NULL, NULL, NULL, 4),
(68818, NULL, 'G3DSA:3.30.420.40:FF:001050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68819, NULL, 'G3DSA:3.10.110.10:FF:000095', NULL, NULL, 'NEDD8-conjugating enzyme UBC12, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68820, NULL, 'G3DSA:2.130.10.30:FF:000018', NULL, NULL, 'probable E3 ubiquitin-protein ligase HERC3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(68821, NULL, 'G3DSA:3.30.420.330:FF:000001', NULL, NULL, 'Non-structural protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(68822, NULL, 'G3DSA:1.25.40.10:FF:004334', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(68823, NULL, 'G3DSA:3.30.497.10:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68824, NULL, 'G3DSA:3.80.10.10:FF:000333', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RCH1', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(68825, NULL, 'G3DSA:3.30.40.10:FF:000472', NULL, NULL, 'E3 ubiquitin-protein ligase ORTHRUS 2', NULL, NULL, NULL, NULL, NULL, 4),
(68826, NULL, 'G3DSA:1.10.760.10:FF:000090', NULL, NULL, 'Fructose dehydrogenase cytochrome subunit', NULL, NULL, NULL, NULL, NULL, 4),
(68827, NULL, 'G3DSA:3.40.50.300:FF:000991', NULL, NULL, 'Dephospho-CoA kinase', NULL, NULL, NULL, NULL, NULL, 4),
(68828, NULL, 'G3DSA:2.60.40.60:FF:001106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68829, NULL, 'G3DSA:3.40.50.300:FF:006179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68830, NULL, 'G3DSA:1.10.238.10:FF:001073', NULL, NULL, 'troponin C, skeletal muscle', NULL, NULL, NULL, NULL, NULL, 4),
(68831, NULL, 'G3DSA:3.30.1360.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68832, NULL, 'G3DSA:3.30.750.24:FF:000168', NULL, NULL, 'Sulfate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(68833, NULL, 'G3DSA:3.30.40.10:FF:002372', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68834, NULL, 'G3DSA:2.30.30.790:FF:000010', NULL, NULL, 'Mitochondrial ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(68835, NULL, 'G3DSA:3.30.720.50:FF:000007', NULL, NULL, 'CCCH-type zinc finger antiviral protein', NULL, NULL, NULL, NULL, NULL, 4),
(68836, NULL, 'G3DSA:3.30.160.60:FF:005262', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68837, NULL, 'G3DSA:2.60.200.20:FF:000069', NULL, NULL, 'AGAP000662-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(68838, NULL, 'G3DSA:1.20.1420.30:FF:000038', NULL, NULL, 'Solute carrier family 24 member 6a', NULL, NULL, NULL, NULL, NULL, 4),
(68839, NULL, 'G3DSA:2.160.10.10:FF:000017', NULL, NULL, 'Mannose-1-phosphate guanyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(68840, NULL, 'G3DSA:1.20.58.200:FF:000005', NULL, NULL, 'Translin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68841, NULL, 'G3DSA:1.10.238.10:FF:000797', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68842, NULL, 'G3DSA:2.60.40.4370:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68843, NULL, 'G3DSA:1.25.10.10:FF:002584', NULL, NULL, 'CLIP-associating protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(68844, NULL, 'G3DSA:1.25.40.10:FF:004553', NULL, NULL, 'Pentatricopeptide repeat-containing protein 4, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(68845, NULL, 'G3DSA:3.80.10.10:FF:001957', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(68846, NULL, 'G3DSA:1.20.120.720:FF:000043', NULL, NULL, 'FI20293p1', NULL, NULL, NULL, NULL, NULL, 4),
(68847, NULL, 'G3DSA:3.40.50.300:FF:008079', NULL, NULL, 'Deoxyuridine 5''-triphosphate nucleotidohydrolase, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68848, NULL, 'G3DSA:3.40.50.300:FF:000659', NULL, NULL, 'Deoxyguanosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(68849, NULL, 'G3DSA:2.60.120.10:FF:000588', NULL, NULL, 'Cupin superfamily barrel domain helix-turn-helix transcriptional regulator, AraC/XylS family', NULL, NULL, NULL, NULL, NULL, 4),
(68850, NULL, 'G3DSA:3.40.630.10:FF:000335', NULL, NULL, 'Carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68851, NULL, 'G3DSA:1.10.20.10:FF:000089', NULL, NULL, 'Histone H2A', NULL, NULL, NULL, NULL, NULL, 4),
(68852, NULL, 'G3DSA:3.40.50.150:FF:000698', NULL, NULL, 'Putative methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(68853, NULL, 'G3DSA:2.40.50.140:FF:000912', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68854, NULL, 'G3DSA:3.30.420.40:FF:000774', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(68855, NULL, 'G3DSA:2.115.10.20:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(68856, NULL, 'G3DSA:3.90.1150.10:FF:000533', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68857, NULL, 'G3DSA:1.10.1350.10:FF:000001', NULL, NULL, 'Intermediate capsid protein VP6', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(68858, NULL, 'G3DSA:1.25.40.10:FF:002299', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(68859, NULL, 'G3DSA:4.10.240.10:FF:000111', NULL, NULL, 'Related to PPR1-Zinc finger transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(68860, NULL, 'G3DSA:2.60.40.10:FF:001120', NULL, NULL, 'Major sperm protein 19/31/40/45/50/51/53/59/61/65/81/113/142', NULL, NULL, NULL, NULL, NULL, 4),
(68861, NULL, 'G3DSA:3.30.70.330:FF:002720', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68862, NULL, 'G3DSA:2.130.10.10:FF:004863', NULL, NULL, 'Protein CBR-GAD-1', NULL, NULL, NULL, NULL, NULL, 4),
(68863, NULL, 'G3DSA:3.40.50.2000:FF:000218', NULL, NULL, 'Digalactosyldiacylglycerol synthase 1, chloroplastic-like', NULL, NULL, NULL, NULL, NULL, 4),
(68864, NULL, 'G3DSA:3.30.1010.10:FF:000059', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(68865, NULL, 'G3DSA:3.40.50.720:FF:002353', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68866, NULL, 'G3DSA:3.10.350.10:FF:000101', NULL, NULL, 'Gll1142 protein', NULL, NULL, NULL, NULL, NULL, 4),
(68867, NULL, 'G3DSA:2.60.450.20:FF:000003', NULL, NULL, 'T-complex protein 10b', NULL, NULL, NULL, NULL, NULL, 4),
(68868, NULL, 'G3DSA:3.40.50.10050:FF:000013', NULL, NULL, 'Mitochondrial translational initiation factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(68869, NULL, 'G3DSA:1.20.58.60:FF:000280', NULL, NULL, 'Spectrin beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(68870, NULL, 'G3DSA:1.10.287.110:FF:000289', NULL, NULL, 'DnaJ homolog subfamily C member 7 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(68871, NULL, 'G3DSA:3.30.70.660:FF:000082', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(68872, NULL, 'G3DSA:3.10.100.10:FF:000167', NULL, NULL, 'Phospholipase A2 receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(68873, NULL, 'G3DSA:3.80.10.10:FF:002233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68874, NULL, 'G3DSA:1.20.120.1750:FF:000128', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(68875, NULL, 'G3DSA:3.40.33.10:FF:000011', NULL, NULL, 'Peptidase inhibitor 16', NULL, NULL, NULL, NULL, NULL, 4),
(68876, NULL, 'G3DSA:3.30.300.30:FF:000144', NULL, NULL, 'HC-toxin synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(68877, NULL, 'G3DSA:2.60.40.10:FF:000844', NULL, NULL, 'roundabout homolog 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(68878, NULL, 'G3DSA:3.40.50.10490:FF:000122', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68879, NULL, 'G3DSA:2.60.120.260:FF:000546', NULL, NULL, 'Zgc:153722', NULL, NULL, NULL, NULL, NULL, 4),
(68880, NULL, 'G3DSA:1.20.200.10:FF:000028', NULL, NULL, 'Argininosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(68881, NULL, 'G3DSA:4.10.60.10:FF:000253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68882, NULL, 'G3DSA:1.20.1250.20:FF:001955', NULL, NULL, 'Major facilitator superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(68883, NULL, 'G3DSA:3.30.420.40:FF:000875', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68884, NULL, 'G3DSA:3.10.490.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68885, NULL, 'G3DSA:3.40.50.300:FF:000890', NULL, NULL, 'DNA polymerase III subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(68886, NULL, 'G3DSA:1.25.40.10:FF:002524', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(68887, NULL, 'G3DSA:3.30.230.10:FF:000161', NULL, NULL, 'G elongation factor, mitochondrial 2', NULL, NULL, NULL, NULL, NULL, 4),
(68888, NULL, 'G3DSA:3.40.1190.20:FF:000151', NULL, NULL, 'ketohexokinase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(68889, NULL, 'G3DSA:1.10.510.10:FF:001560', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 19', NULL, NULL, NULL, NULL, NULL, 4),
(68890, NULL, 'G3DSA:3.30.559.30:FF:000076', NULL, NULL, 'HC-toxin synthetase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(68891, NULL, 'G3DSA:1.10.10.10:FF:000723', NULL, NULL, 'Arsenical resistance operon repressor', NULL, NULL, NULL, NULL, NULL, 4),
(68892, NULL, 'G3DSA:3.90.550.50:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68893, NULL, 'G3DSA:3.20.20.210:FF:000018', NULL, NULL, '5-methyltetrahydropteroyltriglutamate--homocysteine methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(68894, NULL, 'G3DSA:3.40.50.300:FF:001502', NULL, NULL, 'Transcription termination factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(68895, NULL, 'G3DSA:3.40.50.720:FF:000543', NULL, NULL, 'SLOwpoke potassium channel family', NULL, NULL, NULL, NULL, NULL, 4),
(68896, NULL, 'G3DSA:3.30.160.60:FF:006459', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68897, NULL, 'G3DSA:3.40.50.1000:FF:000593', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68898, NULL, 'G3DSA:3.40.50.620:FF:000283', NULL, NULL, 'Kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(68899, NULL, 'G3DSA:1.10.10.10:FF:001324', NULL, NULL, 'OmpR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(68900, NULL, 'G3DSA:1.10.150.20:FF:000063', NULL, NULL, 'DNA repair protein RAD1', NULL, NULL, NULL, NULL, NULL, 4),
(68901, NULL, 'G3DSA:2.10.109.10:FF:000016', NULL, NULL, 'HTH-type transcriptional regulator prtR', NULL, NULL, NULL, NULL, NULL, 4),
(68902, NULL, 'G3DSA:3.30.160.150:FF:000005', NULL, NULL, 'LPS-assembly lipoprotein LptE', NULL, NULL, NULL, NULL, NULL, 4),
(68903, NULL, 'G3DSA:3.30.1060.10:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68904, NULL, 'G3DSA:3.30.70.330:FF:000910', NULL, NULL, 'RNA-binding protein 8A', NULL, NULL, NULL, NULL, NULL, 4),
(68905, NULL, 'G3DSA:2.130.10.10:FF:001103', NULL, NULL, 'WD repeat domain 90', NULL, NULL, NULL, NULL, NULL, 4),
(68906, NULL, 'G3DSA:3.30.710.10:FF:000310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68907, NULL, 'G3DSA:3.90.470.20:FF:000078', NULL, NULL, 'Phosphopantetheinyl transferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(68908, NULL, 'G3DSA:3.30.559.10:FF:000070', NULL, NULL, 'Hydroxamate-type ferrichrome siderophore peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(68909, NULL, 'G3DSA:3.10.20.90:FF:000855', NULL, NULL, 'Ubiquitin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68910, NULL, 'G3DSA:3.40.50.12280:FF:000007', NULL, NULL, 'NADH:ubiquinone oxidoreductase core subunit S7', NULL, NULL, NULL, NULL, NULL, 4),
(68911, NULL, 'G3DSA:2.130.10.10:FF:000491', NULL, NULL, 'Syntaxin binding protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(68912, NULL, 'G3DSA:2.40.50.140:FF:000233', NULL, NULL, 'Elongation factor P-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(68913, NULL, 'G3DSA:2.60.40.60:FF:000948', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68914, NULL, 'G3DSA:1.20.58.760:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68915, NULL, 'G3DSA:2.40.70.10:FF:000515', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68916, NULL, 'G3DSA:3.90.550.10:FF:000699', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68917, NULL, 'G3DSA:2.60.40.10:FF:002648', NULL, NULL, 'Neurotrimin', NULL, NULL, NULL, NULL, NULL, 4),
(68918, NULL, 'G3DSA:3.30.420.340:FF:000009', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4),
(68919, NULL, 'G3DSA:3.40.50.170:FF:000007', NULL, NULL, 'Phosphoribosylglycinamide formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(68920, NULL, 'G3DSA:3.30.110.20:FF:000003', NULL, NULL, 'DNA/RNA-binding protein Alba 1', NULL, NULL, NULL, NULL, NULL, 4),
(68921, NULL, 'G3DSA:2.130.10.10:FF:001092', NULL, NULL, 'Protein transport protein sec13', NULL, NULL, NULL, NULL, NULL, 4),
(68922, NULL, 'G3DSA:2.60.40.10:FF:005503', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68923, NULL, 'G3DSA:3.40.50.10300:FF:000004', NULL, NULL, 'DNA / pantothenate metabolism flavoprotein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68924, NULL, 'G3DSA:3.40.50.80:FF:000083', NULL, NULL, 'Ferric reduction oxidase 2', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(68925, NULL, 'G3DSA:1.20.1070.10:FF:001298', NULL, NULL, 'Long wavelength opsin B14', NULL, NULL, NULL, NULL, NULL, 4),
(68926, NULL, 'G3DSA:3.40.50.1820:FF:000501', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(68927, NULL, 'G3DSA:1.10.10.60:FF:001081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(68928, NULL, 'G3DSA:3.40.190.10:FF:000744', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68929, NULL, 'G3DSA:1.20.1730.10:FF:000022', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(68930, NULL, 'G3DSA:2.10.25.10:FF:000333', NULL, NULL, 'netrin-4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(68931, NULL, 'G3DSA:2.60.40.10:FF:002755', NULL, NULL, 'Suppressor of choline sensitivity', NULL, NULL, NULL, NULL, NULL, 4),
(68932, NULL, 'G3DSA:1.10.8.400:FF:000001', NULL, NULL, 'Enoyl-[acyl-carrier-protein] reductase [NADH]', NULL, NULL, NULL, NULL, NULL, 4),
(68933, NULL, 'G3DSA:3.90.550.50:FF:000245', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(68934, NULL, 'G3DSA:1.20.1250.20:FF:002130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68935, NULL, 'G3DSA:3.30.230.10:FF:000054', NULL, NULL, 'DNA mismatch repair protein PMS1', NULL, NULL, NULL, NULL, NULL, 4),
(68936, NULL, 'G3DSA:3.30.200.20:FF:000555', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(68937, NULL, 'G3DSA:1.20.58.900:FF:000007', NULL, NULL, 'DENN domain-containing protein 5B', NULL, NULL, NULL, NULL, NULL, 4),
(68938, NULL, 'G3DSA:2.130.10.10:FF:004762', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68939, NULL, 'G3DSA:2.70.98.40:FF:000013', NULL, NULL, 'Glycoside hydrolase family 65 protein', NULL, NULL, NULL, NULL, NULL, 4),
(68940, NULL, 'G3DSA:3.40.50.150:FF:000586', NULL, NULL, 'tRNA (adenine(58)-N(1))-methyltransferase catalytic subunit TRMT61A', NULL, NULL, NULL, NULL, NULL, 4),
(68941, NULL, 'G3DSA:1.25.40.10:FF:001001', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(68942, NULL, 'G3DSA:1.10.8.60:FF:000040', NULL, NULL, 'caseinolytic peptidase B protein homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(68943, NULL, 'G3DSA:1.10.287.370:FF:000102', NULL, NULL, 'Prefoldin subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(68944, NULL, 'G3DSA:3.90.70.10:FF:000696', NULL, NULL, 'Ubiquitin specific peptidase 50', NULL, NULL, NULL, NULL, NULL, 4),
(68945, NULL, 'G3DSA:3.90.930.12:FF:000006', NULL, NULL, '50S ribosomal protein L6', NULL, NULL, NULL, NULL, NULL, 4),
(68946, NULL, 'G3DSA:3.40.50.620:FF:000176', NULL, NULL, 'Isoleucine-tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68947, NULL, 'G3DSA:3.40.50.1010:FF:000011', NULL, NULL, 'Flap endonuclease Xni', NULL, NULL, NULL, NULL, NULL, 4),
(68948, NULL, 'G3DSA:3.30.70.370:FF:000012', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(68949, NULL, 'G3DSA:1.10.238.10:FF:000707', NULL, NULL, 'CALmodulin related genes', NULL, NULL, NULL, NULL, NULL, 4),
(68950, NULL, 'G3DSA:1.10.630.10:FF:000102', NULL, NULL, 'Cytochrome P450 52A5', NULL, NULL, NULL, NULL, NULL, 4),
(68951, NULL, 'G3DSA:1.10.287.70:FF:000181', NULL, NULL, 'Cyclic nucleotide-gated potassium channel mll3241', NULL, NULL, NULL, NULL, NULL, 4),
(68952, NULL, 'G3DSA:2.60.40.10:FF:001232', NULL, NULL, 'Immunoglobulin-like and fibronectin type III domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(68953, NULL, 'G3DSA:2.10.110.10:FF:000194', NULL, NULL, 'LIM domain-containing protein PLIM2c', NULL, NULL, NULL, NULL, NULL, 4),
(68954, NULL, 'G3DSA:3.30.1120.160:FF:000004', NULL, NULL, 'Calcium channel, voltage-dependent, L type, alpha 1D subunit', NULL, NULL, NULL, NULL, NULL, 4),
(68955, NULL, 'G3DSA:1.10.510.10:FF:001234', NULL, NULL, 'Serine/threonine-protein kinase par-4', NULL, NULL, NULL, NULL, NULL, 4),
(68956, NULL, 'G3DSA:3.40.50.80:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68957, NULL, 'G3DSA:1.20.58.60:FF:000723', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(68958, NULL, 'G3DSA:3.90.1150.10:FF:000090', NULL, NULL, 'Bifunctional dethiobiotin synthetase/7,8-diamino-pelargonic acid aminotransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(68959, NULL, 'G3DSA:2.130.10.10:FF:001210', NULL, NULL, 'Probable cytosolic iron-sulfur protein assembly protein CIAO1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(68960, NULL, 'G3DSA:3.30.1120.150:FF:000001', NULL, NULL, 'N-hydroxyarylamine O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(68961, NULL, 'G3DSA:3.30.420.40:FF:000768', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68962, NULL, 'G3DSA:1.10.220.10:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68963, NULL, 'G3DSA:3.40.30.10:FF:001062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68964, NULL, 'G3DSA:1.25.10.10:FF:002578', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68965, NULL, 'G3DSA:2.10.25.10:FF:000226', NULL, NULL, 'EGF-like repeat and discoidin I-like domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(68966, NULL, 'G3DSA:1.25.40.770:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68967, NULL, 'G3DSA:3.30.70.1400:FF:000007', NULL, NULL, 'Glycine cleavage system aminomethyltransferase T', NULL, NULL, NULL, NULL, NULL, 4),
(68968, NULL, 'G3DSA:3.80.10.10:FF:001856', NULL, NULL, 'Gp150 protein', NULL, NULL, NULL, NULL, NULL, 4),
(68969, NULL, 'G3DSA:1.10.510.10:FF:000852', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 17', NULL, NULL, NULL, NULL, NULL, 4),
(68970, NULL, 'G3DSA:2.60.40.10:FF:001125', NULL, NULL, 'Ephrin type-A receptor 10', NULL, NULL, NULL, NULL, NULL, 4),
(68971, NULL, 'G3DSA:3.40.190.10:FF:000851', NULL, NULL, 'Ionotropic glutamate receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(68972, NULL, 'G3DSA:3.10.110.10:FF:000336', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68973, NULL, 'G3DSA:3.40.50.720:FF:000217', NULL, NULL, 'Saccharopine dehydrogenase [NAD(+), L-lysine-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(68974, NULL, 'G3DSA:3.40.50.300:FF:002918', NULL, NULL, 'CobQ/CobB/MinD/ParA family nucleotide binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(68975, NULL, 'G3DSA:1.20.1250.20:FF:001287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68976, NULL, 'G3DSA:3.30.70.330:FF:000573', NULL, NULL, 'Nop6p', NULL, NULL, NULL, NULL, NULL, 4),
(68977, NULL, 'G3DSA:1.10.238.10:FF:001308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68978, NULL, 'G3DSA:3.40.190.10:FF:000525', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68979, NULL, 'G3DSA:3.40.50.1820:FF:000720', NULL, NULL, 'Phosphatidylcholine-sterol acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(68980, NULL, 'G3DSA:3.40.50.150:FF:000693', NULL, NULL, 'Methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(68981, NULL, 'G3DSA:1.10.400.10:FF:000063', NULL, NULL, 'G-protein subunit alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(68982, NULL, 'G3DSA:2.40.30.10:FF:000176', NULL, NULL, 'Ring-1,2-phenylacetyl-CoA epoxidase subunit PaaE', NULL, NULL, NULL, NULL, NULL, 4),
(68983, NULL, 'G3DSA:1.10.1020.10:FF:000004', NULL, NULL, 'Site-specific DNA-methyltransferase (adenine-specific)', NULL, NULL, NULL, NULL, NULL, 4),
(68984, NULL, 'G3DSA:3.30.40.10:FF:002271', NULL, NULL, 'Protein CBG15729', NULL, NULL, NULL, NULL, NULL, 4),
(68985, NULL, 'G3DSA:3.40.50.300:FF:002688', NULL, NULL, 'F-box DNA helicase 1', NULL, NULL, NULL, NULL, NULL, 4),
(68986, NULL, 'G3DSA:2.130.10.10:FF:004543', NULL, NULL, 'Axonemal inner arm I1 intermediate chain dynein IC138', NULL, NULL, NULL, NULL, NULL, 4),
(68987, NULL, 'G3DSA:3.40.630.10:FF:000094', NULL, NULL, 'Transferrrin receptor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(68988, NULL, 'G3DSA:1.25.10.10:FF:000673', NULL, NULL, 'Adapter protein complex 3 subunit beta 2', NULL, NULL, NULL, NULL, NULL, 4),
(68989, NULL, 'G3DSA:3.90.226.10:FF:000328', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(68990, NULL, 'G3DSA:3.40.50.2300:FF:000196', NULL, NULL, 'Glutamate metabotropic receptor 7', NULL, NULL, NULL, NULL, NULL, 4),
(68991, NULL, 'G3DSA:2.60.40.10:FF:002974', NULL, NULL, 'Stretchin-Mlck, isoform V', NULL, NULL, NULL, NULL, NULL, 4),
(68992, NULL, 'G3DSA:1.10.2000.10:FF:000014', NULL, NULL, 'frizzled-6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(68993, NULL, 'G3DSA:3.30.420.40:FF:000549', NULL, NULL, 'Glucokinase', NULL, NULL, NULL, NULL, NULL, 4),
(68994, NULL, 'G3DSA:1.10.300.10:FF:000004', NULL, NULL, 'Adenylosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(68995, NULL, 'G3DSA:2.130.10.10:FF:002289', NULL, NULL, 'RIC1-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(68996, NULL, 'G3DSA:1.10.10.60:FF:000480', NULL, NULL, 'Si:ch73-376l24.4', NULL, NULL, NULL, NULL, NULL, 4),
(68997, NULL, 'G3DSA:3.30.430.20:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(68998, NULL, 'G3DSA:2.60.40.10:FF:002429', NULL, NULL, 'KETtiN (Drosophila actin-binding) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(68999, NULL, 'G3DSA:1.20.5.190:FF:000082', NULL, NULL, 'Myosin IIIB', NULL, NULL, NULL, NULL, NULL, 4),
(69000, NULL, 'G3DSA:1.20.1270.60:FF:000310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69001, NULL, 'G3DSA:1.25.40.10:FF:001220', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g35030, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(69002, NULL, 'G3DSA:3.90.70.10:FF:000477', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69003, NULL, 'G3DSA:1.10.246.60:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69004, NULL, 'G3DSA:1.25.70.10:FF:000098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69005, NULL, 'G3DSA:3.40.50.2000:FF:000331', NULL, NULL, 'Trehalose-6-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(69006, NULL, 'G3DSA:3.30.70.330:FF:002708', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69007, NULL, 'G3DSA:2.10.110.10:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69008, NULL, 'G3DSA:1.10.510.10:FF:002976', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69009, NULL, 'G3DSA:1.25.40.10:FF:002417', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g18485', NULL, NULL, NULL, NULL, NULL, 4),
(69010, NULL, 'G3DSA:2.60.260.20:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69011, NULL, 'G3DSA:1.10.132.30:FF:000001', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(69012, NULL, 'G3DSA:3.80.10.10:FF:004144', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(69013, NULL, 'G3DSA:2.60.40.60:FF:000729', NULL, NULL, 'Cadherin-4', NULL, NULL, NULL, NULL, NULL, 4),
(69014, NULL, 'G3DSA:3.10.20.90:FF:000962', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69015, NULL, 'G3DSA:3.30.160.60:FF:005155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69016, NULL, 'G3DSA:1.25.40.20:FF:001223', NULL, NULL, 'Espin like a', NULL, NULL, NULL, NULL, NULL, 4),
(69017, NULL, 'G3DSA:3.40.50.11660:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69018, NULL, 'G3DSA:1.25.40.90:FF:000030', NULL, NULL, 'DUF618 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(69019, NULL, 'G3DSA:3.20.20.100:FF:000081', NULL, NULL, 'Uncharacterized oxidoreductase MSMEG_2408', NULL, NULL, NULL, NULL, NULL, 4),
(69020, NULL, 'G3DSA:2.40.30.10:FF:000395', NULL, NULL, 'NADPH-dependent diflavin oxidoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(69021, NULL, 'G3DSA:3.10.20.30:FF:000079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69022, NULL, 'G3DSA:1.20.1560.10:FF:000531', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(69023, NULL, 'G3DSA:2.20.100.10:FF:000202', NULL, NULL, 'Thrombospondin type-1 domain-containing protein 7B', NULL, NULL, NULL, NULL, NULL, 4),
(69024, NULL, 'G3DSA:2.40.70.10:FF:000285', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(69025, NULL, 'G3DSA:1.10.510.10:FF:002757', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69026, NULL, 'G3DSA:2.20.25.90:FF:000014', NULL, NULL, 'Probable oxidoreductase YyaE', NULL, NULL, NULL, NULL, NULL, 4),
(69027, NULL, 'G3DSA:3.10.20.870:FF:000004', NULL, NULL, 'Phospholipase A-2-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(69028, NULL, 'G3DSA:3.40.50.300:FF:001721', NULL, NULL, 'AAA family ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(69029, NULL, 'G3DSA:1.20.1250.20:FF:000090', NULL, NULL, 'MFS sugar transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(69030, NULL, 'G3DSA:3.40.850.10:FF:000082', NULL, NULL, 'OSM3-like kinesin', NULL, NULL, NULL, NULL, NULL, 4),
(69031, NULL, 'G3DSA:3.30.1240.10:FF:000003', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(69032, NULL, 'G3DSA:3.30.160.60:FF:002974', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69033, NULL, 'G3DSA:3.50.50.60:FF:000565', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(69034, NULL, 'G3DSA:1.25.10.10:FF:001162', NULL, NULL, 'AGAP008392-PA', NULL, NULL, NULL, NULL, NULL, 4),
(69035, NULL, 'G3DSA:1.10.3370.10:FF:000002', NULL, NULL, 'Transport Sec61 subunit alpha isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(69036, NULL, 'G3DSA:2.60.40.420:FF:000063', NULL, NULL, 'Cytochrome c oxidase subunit 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(69037, NULL, 'G3DSA:3.40.50.720:FF:000436', NULL, NULL, 'ADP-ribosyl cyclase/cyclic ADP-ribose hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(69038, NULL, 'G3DSA:2.60.40.10:FF:001344', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(69039, NULL, 'G3DSA:3.40.50.300:FF:007123', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(69040, NULL, 'G3DSA:3.40.50.12780:FF:000051', NULL, NULL, 'Acyl-CoA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(69041, NULL, 'G3DSA:3.30.710.10:FF:000203', NULL, NULL, 'Leucine-zipper-like transcription regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(69042, NULL, 'G3DSA:1.10.3470.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69043, NULL, 'G3DSA:3.40.850.10:FF:000312', NULL, NULL, 'Os04g0442800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(69044, NULL, 'G3DSA:3.40.50.300:FF:006499', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69045, NULL, 'G3DSA:3.10.129.10:FF:000031', NULL, NULL, 'Acyl-coenzyme A thioesterase 9, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(69046, NULL, 'G3DSA:2.40.50.140:FF:000126', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(69047, NULL, 'G3DSA:2.20.25.80:FF:000011', NULL, NULL, 'Disease resistance protein RRS1', NULL, NULL, NULL, NULL, NULL, 4),
(69048, NULL, 'G3DSA:2.60.270.60:FF:000001', NULL, NULL, 'Cik1 suppressing-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(69049, NULL, 'G3DSA:3.90.79.10:FF:000227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69050, NULL, 'G3DSA:3.10.20.90:FF:000748', NULL, NULL, 'KRIT 1 (Krev interaction trapped/cerebral cavernous malformation 1) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(69051, NULL, 'G3DSA:3.40.50.300:FF:004942', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69052, NULL, 'G3DSA:3.40.50.2300:FF:000207', NULL, NULL, 'Two-component osmosensing histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(69053, NULL, 'G3DSA:3.30.530.20:FF:000097', NULL, NULL, 'Carbon monoxide dehydrogenase operon G protein', NULL, NULL, NULL, NULL, NULL, 4),
(69054, NULL, 'G3DSA:1.10.630.10:FF:000321', NULL, NULL, 'Chromosome 23, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(69055, NULL, 'G3DSA:2.60.40.150:FF:000196', NULL, NULL, 'Protein fantom', NULL, NULL, NULL, NULL, NULL, 4),
(69056, NULL, 'G3DSA:1.10.132.50:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69057, NULL, 'G3DSA:3.30.40.10:FF:000028', NULL, NULL, 'Putative hepatocyte growth factor-regulated tyrosine kinase substrate', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(69058, NULL, 'G3DSA:2.130.10.10:FF:001322', NULL, NULL, 'Echinoderm microtubule-associated protein-like CG42247', NULL, NULL, NULL, NULL, NULL, 4),
(69059, NULL, 'G3DSA:3.40.50.620:FF:000064', NULL, NULL, 'Cryptochrome circadian regulator 2', NULL, NULL, NULL, NULL, NULL, 4),
(69060, NULL, 'G3DSA:3.30.200.20:FF:000336', NULL, NULL, 'Eukaryotic elongation factor 2 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(69061, NULL, 'G3DSA:3.30.2160.10:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69062, NULL, 'G3DSA:1.25.40.10:FF:004660', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g61800', NULL, NULL, NULL, NULL, NULL, 4),
(69063, NULL, 'G3DSA:3.90.1150.10:FF:000213', NULL, NULL, 'DegT/DnrJ/EryC1/StrS aminotransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(69064, NULL, 'G3DSA:3.30.70.330:FF:000803', NULL, NULL, 'Nam8p', NULL, NULL, NULL, NULL, NULL, 4),
(69065, NULL, 'G3DSA:3.40.640.10:FF:000268', NULL, NULL, 'Glutamic-oxaloacetic transaminase 1, soluble', NULL, NULL, NULL, NULL, NULL, 4),
(69066, NULL, 'G3DSA:3.80.10.10:FF:001289', NULL, NULL, 'Toll-like receptor Tollo', NULL, NULL, NULL, NULL, NULL, 4),
(69067, NULL, 'G3DSA:1.10.10.10:FF:001105', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(69068, NULL, 'G3DSA:2.130.10.10:FF:002519', NULL, NULL, 'follistatin-related protein 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(69069, NULL, 'G3DSA:2.70.160.11:FF:000061', NULL, NULL, 'YALI0E00660p', NULL, NULL, NULL, NULL, NULL, 4),
(69070, NULL, 'G3DSA:3.30.70.330:FF:001989', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69071, NULL, 'G3DSA:2.10.25.10:FF:000114', NULL, NULL, 'Multiple epidermal growth factor-like domains protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(69072, NULL, 'G3DSA:3.90.70.10:FF:000691', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69073, NULL, 'G3DSA:1.10.238.10:FF:000819', NULL, NULL, 'Reticulocalbin 3', NULL, NULL, NULL, NULL, NULL, 4),
(69074, NULL, 'G3DSA:2.60.120.650:FF:000225', NULL, NULL, '40S ribosomal protein S4-3', NULL, NULL, NULL, NULL, NULL, 4),
(69075, NULL, 'G3DSA:3.40.50.300:FF:003407', NULL, NULL, 'GD20873', NULL, NULL, NULL, NULL, NULL, 4),
(69076, NULL, 'G3DSA:3.30.40.10:FF:002052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69077, NULL, 'G3DSA:2.60.120.260:FF:000322', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(69078, NULL, 'G3DSA:3.30.710.10:FF:000192', NULL, NULL, 'Non-expressor of PR1', NULL, NULL, NULL, NULL, NULL, 4),
(69079, NULL, 'G3DSA:2.60.220.50:FF:000045', NULL, NULL, 'Adhesion G protein-coupled receptor G1', NULL, NULL, NULL, NULL, NULL, 4),
(69080, NULL, 'G3DSA:3.90.950.10:FF:000005', NULL, NULL, '7-methyl-GTP pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(69081, NULL, 'G3DSA:2.120.10.80:FF:000225', NULL, NULL, 'Epithiospecifier protein', NULL, NULL, NULL, NULL, NULL, 4),
(69082, NULL, 'G3DSA:3.30.40.10:FF:000921', NULL, NULL, 'U-box domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(69083, NULL, 'G3DSA:2.130.10.10:FF:003008', NULL, NULL, 'Oligoxyloglucan-reducing end-specific xyloglucanase', NULL, NULL, NULL, NULL, NULL, 4),
(69084, NULL, 'G3DSA:1.10.510.10:FF:002538', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(69085, NULL, 'G3DSA:2.130.10.10:FF:002845', NULL, NULL, 'WD40 repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(69086, NULL, 'G3DSA:3.10.100.10:FF:000274', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69087, NULL, 'G3DSA:1.10.150.20:FF:000175', NULL, NULL, 'ATP-dependent DNA helicase Hel308', NULL, NULL, NULL, NULL, NULL, 4),
(69088, NULL, 'G3DSA:1.10.3330.10:FF:000005', NULL, NULL, 'Urate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(69089, NULL, 'G3DSA:2.60.40.10:FF:004672', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69090, NULL, 'G3DSA:3.40.50.1820:FF:001794', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(69091, NULL, 'G3DSA:1.20.1250.20:FF:000213', NULL, NULL, 'Probable anion transporter 6, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(69092, NULL, 'G3DSA:3.40.50.1000:FF:000823', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69093, NULL, 'G3DSA:2.60.120.20:FF:000006', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(69094, NULL, 'G3DSA:3.30.565.10:FF:000359', NULL, NULL, 'MutL DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(69095, NULL, 'G3DSA:1.20.5.1160:FF:000011', NULL, NULL, 'protein enabled isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(69096, NULL, 'G3DSA:3.40.850.10:FF:000205', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(69097, NULL, 'G3DSA:1.20.920.10:FF:000032', NULL, NULL, 'Transcriptional activator spt7', NULL, NULL, NULL, NULL, NULL, 4),
(69098, NULL, 'G3DSA:1.10.10.750:FF:000002', NULL, NULL, 'Ecotropic viral integration site 5', NULL, NULL, NULL, NULL, NULL, 4),
(69099, NULL, 'G3DSA:3.40.50.10490:FF:000004', NULL, NULL, 'Glucose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(69100, NULL, 'G3DSA:1.25.40.10:FF:002294', NULL, NULL, 'Pentatricopeptide (PPR) repeat-containing protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(69101, NULL, 'G3DSA:2.170.150.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69102, NULL, 'G3DSA:3.30.70.141:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69103, NULL, 'G3DSA:2.20.25.90:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69104, NULL, 'G3DSA:3.40.390.10:FF:000158', NULL, NULL, 'Matrix metallopeptidase 15a', NULL, NULL, NULL, NULL, NULL, 4),
(69105, NULL, 'G3DSA:1.10.472.130:FF:000088', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(69106, NULL, 'G3DSA:1.10.472.10:FF:000066', NULL, NULL, 'Transcription factor IIIB subunit', NULL, NULL, NULL, NULL, NULL, 4),
(69107, NULL, 'G3DSA:3.40.50.80:FF:000206', NULL, NULL, 'Benzoyl-CoA oxygenase, A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(69108, NULL, 'G3DSA:3.30.50.10:FF:000186', NULL, NULL, 'Glucocorticoid receptor', NULL, NULL, NULL, NULL, NULL, 4),
(69109, NULL, 'G3DSA:3.10.430.100:FF:000017', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(69110, NULL, 'G3DSA:3.40.50.300:FF:004268', NULL, NULL, 'Protein CBR-TAG-343', NULL, NULL, NULL, NULL, NULL, 4),
(69111, NULL, 'G3DSA:3.40.50.300:FF:001614', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(69112, NULL, 'G3DSA:1.25.40.10:FF:002636', NULL, NULL, 'Rab GTPase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(69113, NULL, 'G3DSA:2.60.120.10:FF:000003', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(69114, NULL, 'G3DSA:2.130.10.10:FF:005251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69115, NULL, 'G3DSA:3.30.420.10:FF:000321', NULL, NULL, '3''-5'' exonuclease domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(69116, NULL, 'G3DSA:3.40.50.720:FF:002460', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69117, NULL, 'G3DSA:1.20.1070.10:FF:000005', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(69118, NULL, 'G3DSA:2.30.42.10:FF:000035', NULL, NULL, 'Glutamate receptor interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(69119, NULL, 'G3DSA:1.20.920.30:FF:000038', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(69120, NULL, 'G3DSA:3.40.50.300:FF:001272', NULL, NULL, 'SMG9 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(69121, NULL, 'G3DSA:3.50.50.60:FF:000239', NULL, NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(69122, NULL, 'G3DSA:1.10.510.10:FF:001015', NULL, NULL, 'Pab1p-dependent poly(A) ribonuclease subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(69123, NULL, 'G3DSA:3.60.15.10:FF:000137', NULL, NULL, 'Putative metallo-beta-lactamase', NULL, NULL, NULL, NULL, NULL, 4),
(69124, NULL, 'G3DSA:2.130.10.10:FF:004981', NULL, NULL, 'Os01g0607600 protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(69125, NULL, 'G3DSA:3.40.50.10480:FF:000001', NULL, NULL, 'IMP4, U3 small nucleolar ribonucleoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(69126, NULL, 'G3DSA:3.40.350.10:FF:000061', NULL, NULL, 'Xaa-Pro aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(69127, NULL, 'G3DSA:3.40.50.300:FF:008197', NULL, NULL, 'Glucose-6-phosphate 1-dehydrogenase 4 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(69128, NULL, 'G3DSA:3.10.20.90:FF:000967', NULL, NULL, 'STE protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(69129, NULL, 'G3DSA:3.30.160.60:FF:001451', NULL, NULL, 'zinc finger protein 41 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(69130, NULL, 'G3DSA:3.40.50.150:FF:000709', NULL, NULL, 'Enniatin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(69131, NULL, 'G3DSA:2.60.40.150:FF:000645', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(69132, NULL, 'G3DSA:2.20.25.80:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69133, NULL, 'G3DSA:3.90.550.10:FF:000587', NULL, NULL, 'Dolichol-phosphate mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(69134, NULL, 'G3DSA:1.20.1050.10:FF:000228', NULL, NULL, 'Glutathione S-transferase theta 1a', NULL, NULL, NULL, NULL, NULL, 4),
(69135, NULL, 'G3DSA:2.130.10.10:FF:000939', NULL, NULL, 'Periodic tryptophan protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(69136, NULL, 'G3DSA:2.40.50.140:FF:000452', NULL, NULL, 'Putative ABC sugar transporter, ATP-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(69137, NULL, 'G3DSA:1.20.920.20:FF:000035', NULL, NULL, 'Dynein, axonemal, heavy chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(69138, NULL, 'G3DSA:1.25.40.10:FF:004093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69139, NULL, 'G3DSA:3.30.40.10:FF:000702', NULL, NULL, 'Ssm4p', NULL, NULL, NULL, NULL, NULL, 4),
(69140, NULL, 'G3DSA:1.20.1260.10:FF:000042', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(69141, NULL, 'G3DSA:3.30.230.10:FF:000380', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(69142, NULL, 'G3DSA:2.30.29.30:FF:000061', NULL, NULL, 'Oxysterol binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(69143, NULL, 'G3DSA:2.120.10.30:FF:000564', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69144, NULL, 'G3DSA:3.90.1600.10:FF:000063', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(69145, NULL, 'G3DSA:2.60.120.260:FF:000092', NULL, NULL, 'Laminin subunit alpha-3', NULL, NULL, NULL, NULL, NULL, 4),
(69146, NULL, 'G3DSA:1.10.10.10:FF:000942', NULL, NULL, 'Sugar-binding transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(69147, NULL, 'G3DSA:1.20.272.40:FF:000006', NULL, NULL, 'SUV3p ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(69148, NULL, 'G3DSA:3.55.40.20:FF:000003', NULL, NULL, 'Superoxide dismutase [Mn], mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(69149, NULL, 'G3DSA:1.20.1560.10:FF:000205', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(69150, NULL, 'G3DSA:1.10.1070.11:FF:000065', NULL, NULL, 'PIKK family atypical protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(69151, NULL, 'G3DSA:1.10.238.220:FF:000003', NULL, NULL, 'Phosphoprotein phosphatase 2A regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(69152, NULL, 'G3DSA:3.40.50.12230:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69153, NULL, 'G3DSA:1.25.10.10:FF:000892', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(69154, NULL, 'G3DSA:1.20.120.1900:FF:000084', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(69155, NULL, 'G3DSA:1.25.40.10:FF:004441', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69156, NULL, 'G3DSA:1.10.510.10:FF:002645', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69157, NULL, 'G3DSA:1.10.287.110:FF:000188', NULL, NULL, 'AGAP010609-PA', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(69158, NULL, 'G3DSA:1.20.80.10:FF:000007', NULL, NULL, 'Talin 2', NULL, NULL, NULL, NULL, NULL, 4),
(69159, NULL, 'G3DSA:3.40.50.150:FF:001075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69160, NULL, 'G3DSA:1.10.238.230:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69161, NULL, 'G3DSA:2.40.50.140:FF:000800', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69162, NULL, 'G3DSA:2.60.40.2130:FF:000006', NULL, NULL, 'Spondin-1', NULL, NULL, NULL, NULL, NULL, 4),
(69163, NULL, 'G3DSA:1.10.3480.10:FF:000005', NULL, NULL, 'Respiratory nitrate reductase delta chain NarJ', NULL, NULL, NULL, NULL, NULL, 4),
(69164, NULL, 'G3DSA:3.40.50.300:FF:008539', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(69165, NULL, 'G3DSA:1.10.1670.40:FF:000011', NULL, NULL, 'DNA-3-methyladenine glycosylase 2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(69166, NULL, 'G3DSA:1.25.40.10:FF:002187', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g18110, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(69167, NULL, 'G3DSA:2.10.109.10:FF:000011', NULL, NULL, 'Signal peptidase I W', NULL, NULL, NULL, NULL, NULL, 4),
(69168, NULL, 'G3DSA:1.10.8.590:FF:000001', NULL, NULL, 'tRNA:Cm32/Um32 methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(69169, NULL, 'G3DSA:2.60.120.260:FF:000541', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69170, NULL, 'G3DSA:1.10.1900.40:FF:000007', NULL, NULL, 'Erythrocyte membrane protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(69171, NULL, 'G3DSA:3.40.50.2000:FF:000117', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(69172, NULL, 'G3DSA:1.25.10.10:FF:002685', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69173, NULL, 'G3DSA:3.30.40.10:FF:000354', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(69174, NULL, 'G3DSA:3.40.640.10:FF:000156', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(69175, NULL, 'G3DSA:3.40.140.10:FF:000247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69176, NULL, 'G3DSA:1.20.120.1080:FF:000101', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(69177, NULL, 'G3DSA:3.40.850.10:FF:000531', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69178, NULL, 'G3DSA:2.60.120.650:FF:000006', NULL, NULL, 'histone lysine demethylase PHF8 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(69179, NULL, 'G3DSA:3.40.50.410:FF:000012', NULL, NULL, 'Integrin, alpha 10', NULL, NULL, NULL, NULL, NULL, 4),
(69180, NULL, 'G3DSA:2.60.120.260:FF:000434', NULL, NULL, 'Beta-1,4-mannosidase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(69181, NULL, 'G3DSA:4.10.1000.10:FF:000023', NULL, NULL, 'Zinc finger CCCH domain-containing protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(69182, NULL, 'G3DSA:3.30.70.330:FF:000680', NULL, NULL, 'NOP4p Nucleolar protein', NULL, NULL, NULL, NULL, NULL, 4),
(69183, NULL, 'G3DSA:2.30.30.60:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(69184, NULL, 'G3DSA:1.20.58.670:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69185, NULL, 'G3DSA:1.10.3460.10:FF:000009', NULL, NULL, 'Chlorophyll a-b binding protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(69186, NULL, 'G3DSA:1.10.150.20:FF:000068', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(69187, NULL, 'G3DSA:2.20.25.160:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69188, NULL, 'G3DSA:3.40.640.10:FF:000049', NULL, NULL, 'serine palmitoyltransferase 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(69189, NULL, 'G3DSA:2.40.30.110:FF:000017', NULL, NULL, 'Pyruvate Dehydrogenase Phosphatase Regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(69190, NULL, 'G3DSA:2.40.10.10:FF:000629', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69191, NULL, 'G3DSA:3.30.200.20:FF:002472', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(69192, NULL, 'G3DSA:3.40.50.300:FF:005324', NULL, NULL, 'tRNA (Adenosine(37)-N6)-threonylcarbamoyltransferase complex ATPase subunit type 1 TsaE', NULL, NULL, NULL, NULL, NULL, 4),
(69193, NULL, 'G3DSA:2.60.40.420:FF:000170', NULL, NULL, 'Laccase 2', NULL, NULL, NULL, NULL, NULL, 4),
(69194, NULL, 'G3DSA:1.20.120.330:FF:000038', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(69195, NULL, 'G3DSA:2.120.10.30:FF:000345', NULL, NULL, 'Chloroplast protein HCF243', NULL, NULL, NULL, NULL, NULL, 4),
(69196, NULL, 'G3DSA:2.30.29.30:FF:000280', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(69197, NULL, 'G3DSA:3.30.160.60:FF:003031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69198, NULL, 'G3DSA:1.10.420.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69199, NULL, 'G3DSA:1.20.1250.20:FF:001399', NULL, NULL, 'Major facilitator superfamily MFS_1', NULL, NULL, NULL, NULL, NULL, 4),
(69200, NULL, 'G3DSA:3.30.2350.10:FF:000006', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(69201, NULL, 'G3DSA:2.20.25.20:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69202, NULL, 'G3DSA:2.60.120.260:FF:000215', NULL, NULL, 'Anaphase-promoting complex subunit 10', NULL, NULL, NULL, NULL, NULL, 4),
(69203, NULL, 'G3DSA:3.30.70.330:FF:000915', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69204, NULL, 'G3DSA:1.10.510.10:FF:003140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69205, NULL, 'G3DSA:1.20.120.720:FF:000048', NULL, NULL, 'Myosin-2 heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(69206, NULL, 'G3DSA:3.30.70.600:FF:000002', NULL, NULL, '40S ribosomal protein S20', NULL, NULL, NULL, NULL, NULL, 4),
(69207, NULL, 'G3DSA:3.40.50.80:FF:000190', NULL, NULL, 'Dihydroorotate dehydrogenase B (NAD(+)), electron transfer subunit', NULL, NULL, NULL, NULL, NULL, 4),
(69208, NULL, 'G3DSA:1.10.238.10:FF:000696', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(69209, NULL, 'G3DSA:2.60.40.10:FF:000962', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(69210, NULL, 'G3DSA:3.40.50.410:FF:000231', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(69211, NULL, 'G3DSA:3.40.50.11860:FF:000011', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(69212, NULL, 'G3DSA:1.20.1050.130:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69213, NULL, 'G3DSA:3.40.50.300:FF:001053', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(69214, NULL, 'G3DSA:1.10.10.60:FF:001204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69215, NULL, 'G3DSA:3.80.10.10:FF:003762', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(69216, NULL, 'G3DSA:3.40.50.1580:FF:000047', NULL, NULL, 'Purine nucleoside phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(69217, NULL, 'G3DSA:3.30.420.40:FF:000437', NULL, NULL, 'Heat shock protein 70, putative', NULL, NULL, NULL, NULL, NULL, 4),
(69218, NULL, 'G3DSA:3.30.70.330:FF:001984', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69219, NULL, 'G3DSA:2.10.25.10:FF:001194', NULL, NULL, 'Delta/notch-like EGF repeat-containing', NULL, NULL, NULL, NULL, NULL, 4),
(69220, NULL, 'G3DSA:3.30.750.140:FF:000001', NULL, NULL, 'Flagellar hook-length control protein', NULL, NULL, NULL, NULL, NULL, 4),
(69221, NULL, 'G3DSA:3.40.50.720:FF:001959', NULL, NULL, '1-deoxy-11-beta-hydroxypentalenate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(69222, NULL, 'G3DSA:1.10.10.10:FF:001431', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(69223, NULL, 'G3DSA:3.40.50.150:FF:001417', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69224, NULL, 'G3DSA:2.70.70.10:FF:000025', NULL, NULL, 'M23 family peptidase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(69225, NULL, 'G3DSA:1.25.10.10:FF:002808', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69226, NULL, 'G3DSA:2.60.40.10:FF:001451', NULL, NULL, 'immunoglobulin superfamily member 22', NULL, NULL, NULL, NULL, NULL, 4),
(69227, NULL, 'G3DSA:1.20.1050.10:FF:000009', NULL, NULL, 'Glutathione S-transferase omega-1', NULL, NULL, NULL, NULL, NULL, 4),
(69228, NULL, 'G3DSA:3.30.70.330:FF:002260', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69229, NULL, 'G3DSA:2.30.30.100:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69230, NULL, 'G3DSA:1.10.10.60:FF:000928', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69231, NULL, 'G3DSA:3.40.50.300:FF:007011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69232, NULL, 'G3DSA:3.40.50.300:FF:006954', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(69233, NULL, 'G3DSA:3.90.190.20:FF:000045', NULL, NULL, 'Dihydrofolate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(69234, NULL, 'G3DSA:3.40.50.720:FF:002016', NULL, NULL, 'Probable UDP-glucose epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(69235, NULL, 'G3DSA:1.10.510.10:FF:002864', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69236, NULL, 'G3DSA:1.10.10.60:FF:000709', NULL, NULL, 'GG10235', NULL, NULL, NULL, NULL, NULL, 4),
(69237, NULL, 'G3DSA:2.30.42.10:FF:000142', NULL, NULL, 'Serine protease HTRA1', NULL, NULL, NULL, NULL, NULL, 4),
(69238, NULL, 'G3DSA:3.40.50.2300:FF:000089', NULL, NULL, 'Sporulation initiation phosphotransferase F', NULL, NULL, NULL, NULL, NULL, 4),
(69239, NULL, 'G3DSA:3.30.740.10:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69240, NULL, 'G3DSA:1.25.40.10:FF:002529', NULL, NULL, 'DNAJ heat shock N-terminal domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(69241, NULL, 'G3DSA:3.30.160.100:FF:000018', NULL, NULL, 'Ribosome hibernation promoting factor', NULL, NULL, NULL, NULL, NULL, 4),
(69242, NULL, 'G3DSA:3.50.50.60:FF:000458', NULL, NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(69243, NULL, 'G3DSA:3.90.190.10:FF:000042', NULL, NULL, 'receptor-type tyrosine-protein phosphatase C isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(69244, NULL, 'G3DSA:1.25.10.10:FF:001055', NULL, NULL, 'Tubulin-specific chaperone d', NULL, NULL, NULL, NULL, NULL, 4),
(69245, NULL, 'G3DSA:3.60.40.10:FF:000105', NULL, NULL, 'Protein phosphatase 2C like domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(69246, NULL, 'G3DSA:3.40.50.300:FF:004487', NULL, NULL, 'ATPase involved in DNA repair', NULL, NULL, NULL, NULL, NULL, 4),
(69247, NULL, 'G3DSA:2.130.10.10:FF:002626', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69248, NULL, 'G3DSA:3.30.420.40:FF:000656', NULL, NULL, 'Actin-related protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(69249, NULL, 'G3DSA:3.90.1520.10:FF:000011', NULL, NULL, 'Soluble guanylate cyclase gcy-31', NULL, NULL, NULL, NULL, NULL, 4),
(69250, NULL, 'G3DSA:2.10.25.10:FF:001749', NULL, NULL, 'Protein crumbs-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(69251, NULL, 'G3DSA:3.30.830.10:FF:000257', NULL, NULL, 'Putative mitochondrial-processing peptidase subunit alpha-2 chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(69252, NULL, 'G3DSA:3.40.50.10810:FF:000269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69253, NULL, 'G3DSA:3.30.70.330:FF:000354', NULL, NULL, 'RNA splicing factor Pad-1', NULL, NULL, NULL, NULL, NULL, 4),
(69254, NULL, 'G3DSA:3.40.50.300:FF:002683', NULL, NULL, 'ABC Transporter, Mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(69255, NULL, 'G3DSA:3.30.200.20:FF:002253', NULL, NULL, 'AGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(69256, NULL, 'G3DSA:1.20.1070.10:FF:000224', NULL, NULL, 'Tachykinin receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(69257, NULL, 'G3DSA:1.25.40.470:FF:000032', NULL, NULL, 'Coatomer alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(69258, NULL, 'G3DSA:3.40.50.150:FF:000928', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69259, NULL, 'G3DSA:3.40.640.10:FF:000375', NULL, NULL, 'Os01g0711400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(69260, NULL, 'G3DSA:2.130.10.10:FF:004088', NULL, NULL, 'Chromatin assembly factor I P60 subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(69261, NULL, 'G3DSA:2.30.42.10:FF:000361', NULL, NULL, 'LIM domain kinase 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(69262, NULL, 'G3DSA:3.30.1200.10:FF:000001', NULL, NULL, 'UPF0235 protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(69263, NULL, 'G3DSA:3.30.70.3370:FF:000002', NULL, NULL, '40S ribosomal protein S24', NULL, NULL, NULL, NULL, NULL, 4),
(69264, NULL, 'G3DSA:3.30.470.30:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69265, NULL, 'G3DSA:3.10.100.10:FF:000381', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69266, NULL, 'G3DSA:2.10.110.10:FF:000082', NULL, NULL, 'LIM domain kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(69267, NULL, 'G3DSA:1.10.630.10:FF:000214', NULL, NULL, 'Os06g0640800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(69268, NULL, 'G3DSA:2.130.10.10:FF:001215', NULL, NULL, 'phosphoinositide 3-kinase regulatory subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(69269, NULL, 'G3DSA:3.30.450.20:FF:000152', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(69270, NULL, 'G3DSA:2.60.40.10:FF:004891', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69271, NULL, 'G3DSA:3.40.50.2000:FF:000336', NULL, NULL, 'Lipopolysaccharide biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(69272, NULL, 'G3DSA:1.10.490.10:FF:000006', NULL, NULL, 'Neuroglobin', NULL, NULL, NULL, NULL, NULL, 4),
(69273, NULL, 'G3DSA:3.30.470.10:FF:000032', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(69274, NULL, 'G3DSA:3.90.70.80:FF:000003', NULL, NULL, 'OTU domain-containing protein 6B', NULL, NULL, NULL, NULL, NULL, 4),
(69275, NULL, 'G3DSA:3.30.70.580:FF:000064', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(69276, NULL, 'G3DSA:1.10.10.10:FF:001212', NULL, NULL, 'Transcriptional regulator ahyR/asaR family', NULL, NULL, NULL, NULL, NULL, 4),
(69277, NULL, 'G3DSA:3.40.50.300:FF:007230', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(69278, NULL, 'G3DSA:3.30.1060.10:FF:000012', NULL, NULL, 'Putative methionine-S-sulfoxide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(69279, NULL, 'G3DSA:3.30.470.20:FF:000035', NULL, NULL, 'Formate-dependent phosphoribosylglycinamide formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(69280, NULL, 'G3DSA:3.30.1370.10:FF:000097', NULL, NULL, 'Splicing factor-like protein 1 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(69281, NULL, 'G3DSA:3.30.260.10:FF:000005', NULL, NULL, 'T-complex protein 1 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(69282, NULL, 'G3DSA:3.90.1300.10:FF:000023', NULL, NULL, 'Amidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(69283, NULL, 'G3DSA:1.20.120.660:FF:000002', NULL, NULL, 'Cag pathogenicity island protein', NULL, NULL, NULL, NULL, NULL, 4),
(69284, NULL, 'G3DSA:2.60.220.50:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69285, NULL, 'G3DSA:3.40.47.10:FF:000189', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69286, NULL, 'G3DSA:1.25.10.10:FF:002466', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69287, NULL, 'G3DSA:1.20.1080.10:FF:000056', NULL, NULL, 'MIP family channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(69288, NULL, 'G3DSA:1.20.58.60:FF:000504', NULL, NULL, 'Spectrin repeat-containing, nuclear envelope family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(69289, NULL, 'G3DSA:1.10.620.20:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69290, NULL, 'G3DSA:3.30.56.10:FF:000025', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(69291, NULL, 'G3DSA:3.40.190.290:FF:000129', NULL, NULL, 'Transcriptional regulator LysR family', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(69292, NULL, 'G3DSA:3.30.40.10:FF:000135', NULL, NULL, 'E3 ubiquitin-protein ligase mib1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(69293, NULL, 'G3DSA:3.30.450.40:FF:000158', NULL, NULL, 'Stage II sporulation E family protein', NULL, NULL, NULL, NULL, NULL, 4),
(69294, NULL, 'G3DSA:1.20.1560.10:FF:000424', NULL, NULL, 'ATP-dependent permease, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4),
(69295, NULL, 'G3DSA:3.30.50.10:FF:000074', NULL, NULL, 'Nuclear receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(69296, NULL, 'G3DSA:3.20.20.80:FF:000312', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69297, NULL, 'G3DSA:3.30.9.10:FF:000299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69298, NULL, 'G3DSA:2.130.10.10:FF:002957', NULL, NULL, 'Dynein intermediate chain', NULL, NULL, NULL, NULL, NULL, 4),
(69299, NULL, 'G3DSA:2.60.200.20:FF:000176', NULL, NULL, 'MAP kinase phosphatase 5', NULL, NULL, NULL, NULL, NULL, 4),
(69300, NULL, 'G3DSA:3.30.70.330:FF:002259', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69301, NULL, 'G3DSA:3.40.50.2300:FF:000651', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(69302, NULL, 'G3DSA:3.30.565.10:FF:000247', NULL, NULL, 'Development and carotenogenesis control-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(69303, NULL, 'G3DSA:1.20.1250.20:FF:000325', NULL, NULL, 'Transporter, major facilitator family protein', NULL, NULL, NULL, NULL, NULL, 4),
(69304, NULL, 'G3DSA:2.70.50.40:FF:000010', NULL, NULL, 'protein unc-119 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(69305, NULL, 'G3DSA:2.10.220.10:FF:000197', NULL, NULL, 'Erb-b2 receptor tyrosine kinase 3a', NULL, NULL, NULL, NULL, NULL, 4),
(69306, NULL, 'G3DSA:3.30.300.30:FF:000037', NULL, NULL, 'acetoacetyl-CoA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(69307, NULL, 'G3DSA:1.20.1070.10:FF:000117', NULL, NULL, 'adhesion G-protein coupled receptor G1', NULL, NULL, NULL, NULL, NULL, 4),
(69308, NULL, 'G3DSA:3.30.1360.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69309, NULL, 'G3DSA:2.160.20.10:FF:000057', NULL, NULL, 'Poly(Beta-D-mannuronate) C5 epimerase 3', NULL, NULL, NULL, NULL, NULL, 4),
(69310, NULL, 'G3DSA:1.25.40.10:FF:002748', NULL, NULL, 'rRNA biogenesis protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(69311, NULL, 'G3DSA:2.60.120.200:FF:000220', NULL, NULL, 'Collagen type XII alpha 1 chain', NULL, NULL, NULL, NULL, NULL, 4),
(69312, NULL, 'G3DSA:3.40.50.300:FF:003290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69313, NULL, 'G3DSA:1.20.1420.30:FF:000033', NULL, NULL, 'YDL206W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(69314, NULL, 'G3DSA:3.90.1150.10:FF:000319', NULL, NULL, 'Probable L-aspartate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(69315, NULL, 'G3DSA:1.10.10.2480:FF:000004', NULL, NULL, 'Translation initiation factor IF-2', NULL, NULL, NULL, NULL, NULL, 4),
(69316, NULL, 'G3DSA:1.10.287.630:FF:000001', NULL, NULL, 'Cyclic nucleotide-gated channel alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(69317, NULL, 'G3DSA:3.20.20.100:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69318, NULL, 'G3DSA:2.60.34.10:FF:000009', NULL, NULL, 'Hypoxia up-regulated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(69319, NULL, 'G3DSA:3.60.15.10:FF:000249', NULL, NULL, '7,8-dihydropterin-6-methyl-4-(beta-D-ribofuranosyl)-aminobenzene-5''-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(69320, NULL, 'G3DSA:3.40.50.300:FF:001160', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(69321, NULL, 'G3DSA:3.50.30.50:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69322, NULL, 'G3DSA:3.40.50.970:FF:000039', NULL, NULL, 'Indolepyruvate oxidoreductase subunit IorA', NULL, NULL, NULL, NULL, NULL, 4),
(69323, NULL, 'G3DSA:2.60.40.10:FF:005054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69324, NULL, 'G3DSA:3.50.50.60:FF:000127', NULL, NULL, 'Glucose-methanol-choline oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(69325, NULL, 'G3DSA:3.40.50.300:FF:006628', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(69326, NULL, 'G3DSA:1.20.1250.20:FF:001961', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(69327, NULL, 'G3DSA:3.80.10.10:FF:002019', NULL, NULL, 'Protein CBG18939', NULL, NULL, NULL, NULL, NULL, 4),
(69328, NULL, 'G3DSA:3.30.160.60:FF:005610', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69329, NULL, 'G3DSA:3.90.640.10:FF:000021', NULL, NULL, 'Heat shock protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(69330, NULL, 'G3DSA:1.20.1560.10:FF:000082', NULL, NULL, 'ABC transporter, multidrug resistance associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(69331, NULL, 'G3DSA:3.30.1310.10:FF:000009', NULL, NULL, 'Nucleoid-associated protein TC_0612', NULL, NULL, NULL, NULL, NULL, 4),
(69332, NULL, 'G3DSA:1.10.8.840:FF:000003', NULL, NULL, 'DNaJ domain (Prokaryotic heat shock protein)', NULL, NULL, NULL, NULL, NULL, 4),
(69333, NULL, 'G3DSA:3.40.50.1240:FF:000187', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69334, NULL, 'G3DSA:3.40.50.2000:FF:000662', NULL, NULL, 'Glycosyl transferase group 1', NULL, NULL, NULL, NULL, NULL, 4),
(69335, NULL, 'G3DSA:2.40.50.140:FF:000564', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(69336, NULL, 'G3DSA:3.90.550.10:FF:000368', NULL, NULL, 'Protein with potential galactosyl transferase activity', NULL, NULL, NULL, NULL, NULL, 4),
(69337, NULL, 'G3DSA:3.40.1230.10:FF:000006', NULL, NULL, 'Protein_of_uncharacterized_function_(DUF498/DUF59 8)_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(69338, NULL, 'G3DSA:2.60.40.150:FF:000757', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(69339, NULL, 'G3DSA:1.20.1050.10:FF:000116', NULL, NULL, 'Thiol-dependent reductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(69340, NULL, 'G3DSA:2.60.40.10:FF:005161', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69341, NULL, 'G3DSA:2.130.10.10:FF:000827', NULL, NULL, 'Protein HIRA', NULL, NULL, NULL, NULL, NULL, 4),
(69342, NULL, 'G3DSA:2.120.10.10:FF:000007', NULL, NULL, 'Hemagglutinin glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(69343, NULL, 'G3DSA:1.10.10.10:FF:000375', NULL, NULL, 'Interferon regulatory factor 7', NULL, NULL, NULL, NULL, NULL, 4),
(69344, NULL, 'G3DSA:1.10.510.10:FF:003033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69345, NULL, 'G3DSA:1.20.144.10:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69346, NULL, 'G3DSA:3.30.70.20:FF:000078', NULL, NULL, 'ABC transporter related', NULL, NULL, NULL, NULL, NULL, 4),
(69347, NULL, 'G3DSA:2.160.20.10:FF:000063', NULL, NULL, 'Pectin esterase', NULL, NULL, NULL, NULL, NULL, 4),
(69348, NULL, 'G3DSA:3.30.1380.20:FF:000056', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(69349, NULL, 'G3DSA:1.10.1520.10:FF:000031', NULL, NULL, 'Dicer-like protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(69350, NULL, 'G3DSA:1.25.40.10:FF:002855', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(69351, NULL, 'G3DSA:3.40.850.10:FF:000424', NULL, NULL, 'Di-glucose binding with Kinesin motor domain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(69352, NULL, 'G3DSA:3.40.50.800:FF:000022', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(69353, NULL, 'G3DSA:2.30.230.10:FF:000035', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(69354, NULL, 'G3DSA:3.10.10.10:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69355, NULL, 'G3DSA:1.20.58.60:FF:000055', NULL, NULL, 'Short stop, isoform K', NULL, NULL, NULL, NULL, NULL, 4),
(69356, NULL, 'G3DSA:3.30.420.10:FF:000102', NULL, NULL, 'Gag-Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(69357, NULL, 'G3DSA:3.80.10.10:FF:003655', NULL, NULL, 'F-box/leucine rich repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(69358, NULL, 'G3DSA:2.20.70.10:FF:000229', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(69359, NULL, 'G3DSA:3.40.50.1980:FF:000066', NULL, NULL, 'Vibriobactin and enterobactin ABC transporter, periplasmic ferric vibriobactin/enterobactin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(69360, NULL, 'G3DSA:3.40.190.10:FF:000396', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(69361, NULL, 'G3DSA:3.40.50.10730:FF:000003', NULL, NULL, 'Urocanate hydratase 1', NULL, NULL, NULL, NULL, NULL, 4),
(69362, NULL, 'G3DSA:3.40.50.1970:FF:000063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69363, NULL, 'G3DSA:3.20.20.70:FF:000202', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(69364, NULL, 'G3DSA:3.20.20.80:FF:000205', NULL, NULL, 'Unplaced genomic scaffold supercont1.19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(69365, NULL, 'G3DSA:3.30.450.20:FF:000040', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(69366, NULL, 'G3DSA:2.30.42.10:FF:000473', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69367, NULL, 'G3DSA:3.30.60.60:FF:000016', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(69368, NULL, 'G3DSA:2.30.30.40:FF:000365', NULL, NULL, 'Endophilin-A homolog', NULL, NULL, NULL, NULL, NULL, 4),
(69369, NULL, 'G3DSA:3.30.160.60:FF:004992', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69370, NULL, 'G3DSA:1.20.120.220:FF:000005', NULL, NULL, 'ATP synthase subunit a', NULL, NULL, NULL, NULL, NULL, 4),
(69371, NULL, 'G3DSA:3.40.50.720:FF:002241', NULL, NULL, 'Chromosome 15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(69372, NULL, 'G3DSA:3.40.50.11850:FF:000002', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(69373, NULL, 'G3DSA:3.40.50.1820:FF:000046', NULL, NULL, 'Putative lysophospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(69374, NULL, 'G3DSA:1.20.1070.10:FF:001753', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(69375, NULL, 'G3DSA:2.60.120.650:FF:000113', NULL, NULL, 'JmjC domain containing protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(69376, NULL, 'G3DSA:3.30.420.40:FF:001044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69377, NULL, 'G3DSA:3.40.50.2300:FF:000319', NULL, NULL, 'HTH-type transcriptional repressor PurR', NULL, NULL, NULL, NULL, NULL, 4),
(69378, NULL, 'G3DSA:1.25.40.10:FF:000618', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(69379, NULL, 'G3DSA:1.25.40.420:FF:000040', NULL, NULL, 'Kelch-like ECH-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(69380, NULL, 'G3DSA:2.60.40.10:FF:000849', NULL, NULL, 'Uncharacterized protein, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(69381, NULL, 'G3DSA:3.30.70.330:FF:000129', NULL, NULL, 'DAZ-associated protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(69382, NULL, 'G3DSA:3.40.50.1470:FF:000019', NULL, NULL, 'Peptidyl-tRNA hydrolase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(69383, NULL, 'G3DSA:3.40.50.300:FF:001047', NULL, NULL, 'DExH-box ATP-dependent RNA helicase DExH11', NULL, NULL, NULL, NULL, NULL, 4),
(69384, NULL, 'G3DSA:2.40.50.90:FF:000032', NULL, NULL, 'Tudor domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(69385, NULL, 'G3DSA:1.20.1540.10:FF:000081', NULL, NULL, 'Rhomboid protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(69386, NULL, 'G3DSA:3.30.160.60:FF:002862', NULL, NULL, 'STP2p Transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(69387, NULL, 'G3DSA:3.30.2310.10:FF:000009', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(69388, NULL, 'G3DSA:1.10.472.10:FF:000285', NULL, NULL, 'Cyclin I family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(69389, NULL, 'G3DSA:3.40.50.11860:FF:000005', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(69390, NULL, 'G3DSA:3.30.160.60:FF:001007', NULL, NULL, 'Zinc finger protein 1184', NULL, NULL, NULL, NULL, NULL, 4),
(69391, NULL, 'G3DSA:3.10.20.90:FF:001018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(69392, NULL, 'G3DSA:3.40.50.300:FF:006960', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(69393, NULL, 'G3DSA:2.30.29.30:FF:000510', NULL, NULL, 'Switch-associated protein 70', NULL, NULL, NULL, NULL, NULL, 4),
(69394, NULL, 'G3DSA:3.40.50.620:FF:000631', NULL, NULL, 'Electron transfer flavoprotein subunit alpha/FixB family protein', NULL, NULL, NULL, NULL, NULL, 4),
(69395, NULL, 'G3DSA:3.30.200.20:FF:000903', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(69396, NULL, 'G3DSA:2.60.40.10:FF:000956', NULL, NULL, 'T-cell surface glycoprotein CD8 alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(69397, NULL, 'G3DSA:3.30.40.10:FF:000247', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(69398, NULL, 'G3DSA:3.30.40.10:FF:001989', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69399, NULL, 'G3DSA:1.10.472.10:FF:000392', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69400, NULL, 'G3DSA:1.10.286.40:FF:000001', NULL, NULL, 'Photosystem I reaction center subunit psaK', NULL, NULL, NULL, NULL, NULL, 4),
(69401, NULL, 'G3DSA:1.25.40.10:FF:000950', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(69402, NULL, 'G3DSA:2.130.10.10:FF:004195', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(69403, NULL, 'G3DSA:2.40.30.10:FF:000518', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(69404, NULL, 'G3DSA:3.30.160.60:FF:002755', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69405, NULL, 'G3DSA:1.20.58.1560:FF:000001', NULL, NULL, 'Malate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(69406, NULL, 'G3DSA:3.60.110.10:FF:000072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69407, NULL, 'G3DSA:3.30.160.60:FF:004879', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69408, NULL, 'G3DSA:3.90.840.10:FF:000002', NULL, NULL, 'Thiol-activated cytolysin', NULL, NULL, NULL, NULL, NULL, 4),
(69409, NULL, 'G3DSA:1.10.8.270:FF:000147', NULL, NULL, 'GTPase-activating protein gyp2', NULL, NULL, NULL, NULL, NULL, 4),
(69410, NULL, 'G3DSA:3.60.40.10:FF:000212', NULL, NULL, 'Unplaced genomic scaffold supercont2.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(69411, NULL, 'G3DSA:1.10.10.10:FF:000268', NULL, NULL, 'DNA translocase FtsK', NULL, NULL, NULL, NULL, NULL, 4),
(69412, NULL, 'G3DSA:1.10.510.10:FF:003252', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69413, NULL, 'G3DSA:3.10.129.10:FF:000250', NULL, NULL, 'Putative esterase aq_1494', NULL, NULL, NULL, NULL, NULL, 4),
(69414, NULL, 'G3DSA:1.25.40.20:FF:000953', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(69415, NULL, 'G3DSA:1.20.1250.20:FF:001629', NULL, NULL, 'Sugar phosphate exchanger 3', NULL, NULL, NULL, NULL, NULL, 4),
(69416, NULL, 'G3DSA:3.40.50.300:FF:002576', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(69417, NULL, 'G3DSA:3.30.1520.10:FF:000042', NULL, NULL, 'Sorting nexin mvp1', NULL, NULL, NULL, NULL, NULL, 4),
(69418, NULL, 'G3DSA:3.30.200.20:FF:002360', NULL, NULL, 'Zgc:112307 protein', NULL, NULL, NULL, NULL, NULL, 4),
(69419, NULL, 'G3DSA:3.30.70.330:FF:000461', NULL, NULL, 'Serine/arginine-rich splicing factor SR45', NULL, NULL, NULL, NULL, NULL, 4),
(69420, NULL, 'G3DSA:2.60.40.1890:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69421, NULL, 'G3DSA:3.80.10.10:FF:003874', NULL, NULL, 'Leucine rich repeat containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(69422, NULL, 'G3DSA:2.40.30.270:FF:000037', NULL, NULL, 'Immunoglobulin mu DNA binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(69423, NULL, 'G3DSA:3.40.50.300:FF:006847', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(69424, NULL, 'G3DSA:1.10.10.60:FF:000816', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69425, NULL, 'G3DSA:3.90.1140.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(69426, NULL, 'G3DSA:2.30.42.10:FF:000254', NULL, NULL, 'Caspase recruitment domain family, member 14', NULL, NULL, NULL, NULL, NULL, 4),
(69427, NULL, 'G3DSA:3.40.50.150:FF:001081', NULL, NULL, 'Ubiquinone biosynthesis O-methyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(69428, NULL, 'G3DSA:3.30.200.20:FF:000667', NULL, NULL, 'PTI1-like tyrosine-protein kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(69429, NULL, 'G3DSA:2.130.10.10:FF:002177', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(69430, NULL, 'G3DSA:3.40.50.2000:FF:000443', NULL, NULL, 'Uncharacterized UDP-glucosyltransferase YjiC', NULL, NULL, NULL, NULL, NULL, 4),
(69431, NULL, 'G3DSA:1.20.120.230:FF:000008', NULL, NULL, 'Catenin alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(69432, NULL, 'G3DSA:2.160.20.10:FF:000170', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(69433, NULL, 'G3DSA:2.10.110.10:FF:000317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69434, NULL, 'G3DSA:2.160.20.10:FF:000282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69435, NULL, 'G3DSA:3.40.47.10:FF:000083', NULL, NULL, 'Probable acyl-CoA thiolase', NULL, NULL, NULL, NULL, NULL, 4),
(69436, NULL, 'G3DSA:3.40.1010.30:FF:000001', NULL, NULL, 'Chromo domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(69437, NULL, 'G3DSA:1.10.760.10:FF:000095', NULL, NULL, 'Nitrite reductase protein N', NULL, NULL, NULL, NULL, NULL, 4),
(69438, NULL, 'G3DSA:3.30.500.10:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69439, NULL, 'G3DSA:3.40.50.261:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69440, NULL, 'G3DSA:1.20.58.70:FF:000058', NULL, NULL, 'Syntaxin 19', NULL, NULL, NULL, NULL, NULL, 4),
(69441, NULL, 'G3DSA:1.20.120.1240:FF:000065', NULL, NULL, 'Dynamin-related GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(69442, NULL, 'G3DSA:3.30.160.60:FF:000389', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(69443, NULL, 'G3DSA:3.80.10.10:FF:000221', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase PXL1', NULL, NULL, NULL, NULL, NULL, 4),
(69444, NULL, 'G3DSA:3.40.50.300:FF:004594', NULL, NULL, 'ATP-dependent 3''-5'' DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(69445, NULL, 'G3DSA:3.30.40.10:FF:000360', NULL, NULL, 'E3 ubiquitin-protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(69446, NULL, 'G3DSA:3.30.70.270:FF:000201', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69447, NULL, 'G3DSA:3.30.70.870:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69448, NULL, 'G3DSA:3.50.50.60:FF:000346', NULL, NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(69449, NULL, 'G3DSA:2.130.10.10:FF:005032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69450, NULL, 'G3DSA:1.10.472.10:FF:000515', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69451, NULL, 'G3DSA:1.50.10.20:FF:000140', NULL, NULL, 'Alpha-onocerin synthase LCD', NULL, NULL, NULL, NULL, NULL, 4),
(69452, NULL, 'G3DSA:1.25.40.10:FF:000731', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(69453, NULL, 'G3DSA:2.60.40.10:FF:004447', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69454, NULL, 'G3DSA:2.40.128.680:FF:000002', NULL, NULL, 'Ribonuclease H2 non-catalytic subunit (Ylr154p-like), putative', NULL, NULL, NULL, NULL, NULL, 4),
(69455, NULL, 'G3DSA:3.40.50.720:FF:002128', NULL, NULL, 'Carbon monoxide dehydrogenase F protein', NULL, NULL, NULL, NULL, NULL, 4),
(69456, NULL, 'G3DSA:3.40.50.1820:FF:001569', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69457, NULL, 'G3DSA:2.120.10.30:FF:000452', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69458, NULL, 'G3DSA:3.40.50.620:FF:000412', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(69459, NULL, 'G3DSA:3.30.720.200:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69460, NULL, 'G3DSA:3.40.50.300:FF:005431', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(69461, NULL, 'G3DSA:3.30.565.10:FF:000466', NULL, NULL, 'Putative heat shock protein HSP 90-beta 4', NULL, NULL, NULL, NULL, NULL, 4),
(69462, NULL, 'G3DSA:1.20.1250.20:FF:001848', NULL, NULL, 'Protein CBG12247', NULL, NULL, NULL, NULL, NULL, 4),
(69463, NULL, 'G3DSA:1.20.1280.290:FF:000091', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(69464, NULL, 'G3DSA:2.60.40.150:FF:000538', NULL, NULL, 'ER-targeted preprotein translocase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(69465, NULL, 'G3DSA:3.90.640.10:FF:000240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69466, NULL, 'G3DSA:3.30.559.70:FF:000059', NULL, NULL, 'Choline O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(69467, NULL, 'G3DSA:3.40.50.720:FF:000094', NULL, NULL, 'Bifunctional protein FolD', NULL, NULL, NULL, NULL, NULL, 4),
(69468, NULL, 'G3DSA:3.30.160.60:FF:003250', NULL, NULL, 'zinc finger protein 579', NULL, NULL, NULL, NULL, NULL, 4),
(69469, NULL, 'G3DSA:2.40.50.40:FF:000045', NULL, NULL, 'Chromo domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(69470, NULL, 'G3DSA:3.30.260.10:FF:000112', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69471, NULL, 'G3DSA:3.40.630.10:FF:000442', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69472, NULL, 'G3DSA:3.80.10.10:FF:002126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69473, NULL, 'G3DSA:3.40.50.2300:FF:000538', NULL, NULL, 'Trehalose operon transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(69474, NULL, 'G3DSA:3.40.350.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69475, NULL, 'G3DSA:2.60.120.260:FF:000653', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(69476, NULL, 'G3DSA:1.10.10.60:FF:001311', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69477, NULL, 'G3DSA:3.30.1120.30:FF:000051', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(69478, NULL, 'G3DSA:1.10.10.10:FF:000829', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(69479, NULL, 'G3DSA:3.90.1150.10:FF:000426', NULL, NULL, 'Serine--pyruvate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(69480, NULL, 'G3DSA:3.30.160.60:FF:001226', NULL, NULL, 'Combgap, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(69481, NULL, 'G3DSA:1.10.600.10:FF:000044', NULL, NULL, '(2Z,6E)-hedycaryol synthase', NULL, NULL, NULL, NULL, NULL, 4),
(69482, NULL, 'G3DSA:3.40.50.970:FF:000152', NULL, NULL, 'Indolepyruvate oxidoreductase subunit IorA', NULL, NULL, NULL, NULL, NULL, 4),
(69483, NULL, 'G3DSA:1.10.418.10:FF:000238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69484, NULL, 'G3DSA:3.20.20.80:FF:000082', NULL, NULL, '4-alpha-glucanotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(69485, NULL, 'G3DSA:2.20.110.10:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69486, NULL, 'G3DSA:2.60.40.10:FF:001013', NULL, NULL, 'Complement C3', NULL, NULL, NULL, NULL, NULL, 4),
(69487, NULL, 'G3DSA:1.20.1090.10:FF:000006', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(69488, NULL, 'G3DSA:3.90.226.10:FF:000098', NULL, NULL, 'GD18835', NULL, NULL, NULL, NULL, NULL, 4),
(69489, NULL, 'G3DSA:2.60.120.200:FF:000113', NULL, NULL, 'Calreticulin 3', NULL, NULL, NULL, NULL, NULL, 4),
(69490, NULL, 'G3DSA:1.20.1280.290:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69491, NULL, 'G3DSA:3.40.190.10:FF:000177', NULL, NULL, 'Glutamate [NMDA] receptor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(69492, NULL, 'G3DSA:1.25.10.10:FF:001504', NULL, NULL, 'Formin-E', NULL, NULL, NULL, NULL, NULL, 4),
(69493, NULL, 'G3DSA:3.10.450.120:FF:000005', NULL, NULL, 'PUA domain protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(69494, NULL, 'G3DSA:2.10.25.10:FF:000120', NULL, NULL, 'Protein kinase C-binding protein NELL1', NULL, NULL, NULL, NULL, NULL, 4),
(69495, NULL, 'G3DSA:1.10.3720.10:FF:000159', NULL, NULL, 'Putative oligopeptide ABC transporter permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(69496, NULL, 'G3DSA:1.10.260.170:FF:000012', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', NULL, NULL, NULL, NULL, NULL, 4),
(69497, NULL, 'G3DSA:1.25.10.10:FF:002359', NULL, NULL, 'Rapamycin-insensitive companion of mTOR, putative', NULL, NULL, NULL, NULL, NULL, 4),
(69498, NULL, 'G3DSA:3.30.1360.140:FF:000006', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(69499, NULL, 'G3DSA:3.30.200.20:FF:000780', NULL, NULL, 'Tyrosine-protein kinase PR2', NULL, NULL, NULL, NULL, NULL, 4),
(69500, NULL, 'G3DSA:3.30.70.3490:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69501, NULL, 'G3DSA:1.10.472.80:FF:000030', NULL, NULL, 'TBC1 domain family member 8 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(69502, NULL, 'G3DSA:2.30.30.40:FF:000584', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69503, NULL, 'G3DSA:2.160.20.10:FF:000169', NULL, NULL, 'Protein CBG15150', NULL, NULL, NULL, NULL, NULL, 4),
(69504, NULL, 'G3DSA:1.25.40.10:FF:005042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69505, NULL, 'G3DSA:1.20.1070.10:FF:001859', NULL, NULL, 'Tachykinin receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(69506, NULL, 'G3DSA:2.170.130.10:FF:000034', NULL, NULL, 'TonB-dependent receptor', NULL, NULL, NULL, NULL, NULL, 4),
(69507, NULL, 'G3DSA:1.10.2020.20:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69508, NULL, 'G3DSA:3.30.160.60:FF:004099', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69509, NULL, 'G3DSA:3.30.450.40:FF:000265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69510, NULL, 'G3DSA:2.60.120.200:FF:000332', NULL, NULL, 'LAMinin related. See also lmb', NULL, NULL, NULL, NULL, NULL, 4),
(69511, NULL, 'G3DSA:2.40.110.10:FF:000058', NULL, NULL, 'Pimeloyl-CoA dehydrogenase small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(69512, NULL, 'G3DSA:3.30.43.10:FF:000052', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(69513, NULL, 'G3DSA:2.40.70.10:FF:000392', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69514, NULL, 'G3DSA:3.30.450.20:FF:000601', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69515, NULL, 'G3DSA:3.30.70.330:FF:002153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69516, NULL, 'G3DSA:1.25.40.10:FF:001113', NULL, NULL, 'Ypp1p', NULL, NULL, NULL, NULL, NULL, 4),
(69517, NULL, 'G3DSA:3.90.1150.10:FF:000207', NULL, NULL, 'Serine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(69518, NULL, 'G3DSA:3.40.390.10:FF:000164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69519, NULL, 'G3DSA:1.20.5.1150:FF:000002', NULL, NULL, '28S ribosomal protein S21, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(69520, NULL, 'G3DSA:1.25.40.10:FF:000495', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(69521, NULL, 'G3DSA:1.10.1170.10:FF:000009', NULL, NULL, 'Baculoviral IAP repeat-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(69522, NULL, 'G3DSA:3.30.710.10:FF:000422', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69523, NULL, 'G3DSA:1.50.10.20:FF:000027', NULL, NULL, 'Terpene cyclase/mutase family member', NULL, NULL, NULL, NULL, NULL, 4),
(69524, NULL, 'G3DSA:2.130.10.10:FF:004650', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69525, NULL, 'G3DSA:3.80.10.10:FF:000440', NULL, NULL, 'Ribonuclease inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(69526, NULL, 'G3DSA:3.80.10.10:FF:004037', NULL, NULL, 'F-box/LRR-repeat protein 4-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(69527, NULL, 'G3DSA:1.10.510.10:FF:001009', NULL, NULL, 'Atypical/RIO/RIO2 protein kinase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(69528, NULL, 'G3DSA:2.60.40.60:FF:000836', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69529, NULL, 'G3DSA:1.10.287.110:FF:000295', NULL, NULL, 'ER organization and biogenesis-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(69530, NULL, 'G3DSA:2.40.50.140:FF:000345', NULL, NULL, 'RecQ-mediated genome instability-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(69531, NULL, 'G3DSA:2.60.40.10:FF:002867', NULL, NULL, 'T-cell surface antigen CD2', NULL, NULL, NULL, NULL, NULL, 4),
(69532, NULL, 'G3DSA:1.25.40.20:FF:001116', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(69533, NULL, 'G3DSA:1.10.3430.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69534, NULL, 'G3DSA:1.10.10.10:FF:000487', NULL, NULL, 'Meiotic recombination protein SPO11-2', NULL, NULL, NULL, NULL, NULL, 4),
(69535, NULL, 'G3DSA:2.30.30.1230:FF:000001', NULL, NULL, 'Envelope glycoprotein B', NULL, NULL, NULL, NULL, NULL, 4),
(69536, NULL, 'G3DSA:2.115.10.20:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69537, NULL, 'G3DSA:1.20.1510.10:FF:000034', NULL, NULL, 'Protein CBG00606', NULL, NULL, NULL, NULL, NULL, 4),
(69538, NULL, 'G3DSA:3.30.230.10:FF:000273', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(69539, NULL, 'G3DSA:3.40.50.720:FF:000330', NULL, NULL, 'UDP-glucose lipid carrier transferase', NULL, NULL, NULL, NULL, NULL, 4),
(69540, NULL, 'G3DSA:1.20.5.1160:FF:000005', NULL, NULL, 'vasodilator-stimulated phosphoprotein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(69541, NULL, 'G3DSA:2.40.50.120:FF:000007', NULL, NULL, 'Metalloproteinase inhibitor 2', NULL, NULL, NULL, NULL, NULL, 4),
(69542, NULL, 'G3DSA:3.40.190.10:FF:000290', NULL, NULL, 'Putative ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(69543, NULL, 'G3DSA:1.10.287.70:FF:000310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69544, NULL, 'G3DSA:3.55.60.10:FF:000001', NULL, NULL, 'Outer capsid protein lambda-2', NULL, NULL, NULL, NULL, NULL, 4),
(69545, NULL, 'G3DSA:4.10.1240.30:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69546, NULL, 'G3DSA:3.40.50.2300:FF:000870', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69547, NULL, 'G3DSA:3.60.20.10:FF:000104', NULL, NULL, 'YML096W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(69548, NULL, 'G3DSA:2.130.10.10:FF:002738', NULL, NULL, 'Sec13', NULL, NULL, NULL, NULL, NULL, 4),
(69549, NULL, 'G3DSA:3.40.50.300:FF:003413', NULL, NULL, 'OSJNBb0016D16.17 protein', NULL, NULL, NULL, NULL, NULL, 4),
(69550, NULL, 'G3DSA:2.60.120.330:FF:000011', NULL, NULL, 'Aspartate beta-hydroxylase domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(69551, NULL, 'G3DSA:3.30.160.60:FF:001900', NULL, NULL, 'ZFP30 zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(69552, NULL, 'G3DSA:3.40.50.150:FF:000816', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69553, NULL, 'G3DSA:2.170.270.10:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69554, NULL, 'G3DSA:3.80.10.10:FF:001963', NULL, NULL, 'Putative F-box/LRR-repeat protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(69555, NULL, 'G3DSA:3.40.50.300:FF:002795', NULL, NULL, 'RecBCD enzyme subunit RecD', NULL, NULL, NULL, NULL, NULL, 4),
(69556, NULL, 'G3DSA:1.20.1070.10:FF:000336', NULL, NULL, 'Probable G-protein coupled receptor 160', NULL, NULL, NULL, NULL, NULL, 4),
(69557, NULL, 'G3DSA:1.20.1250.20:FF:000106', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(69558, NULL, 'G3DSA:2.60.40.60:FF:000494', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69559, NULL, 'G3DSA:3.30.900.10:FF:000015', NULL, NULL, 'DNA polymerase zeta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(69560, NULL, 'G3DSA:2.40.70.10:FF:000279', NULL, NULL, 'Pepsin A', NULL, NULL, NULL, NULL, NULL, 4),
(69561, NULL, 'G3DSA:3.30.750.24:FF:000174', NULL, NULL, 'Sulfate permease', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(69562, NULL, 'G3DSA:2.130.10.10:FF:002396', NULL, NULL, 'U4/U6-U5 snRNP complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(69563, NULL, 'G3DSA:3.30.465.10:FF:000071', NULL, NULL, 'CBS domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(69564, NULL, 'G3DSA:3.40.640.10:FF:000487', NULL, NULL, 'Alanine aminotransferase 2 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(69565, NULL, 'G3DSA:1.25.40.370:FF:000002', NULL, NULL, 'Telomerase associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(69566, NULL, 'G3DSA:1.10.357.140:FF:000022', NULL, NULL, 'Protoheme IX farnesyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(69567, NULL, 'G3DSA:2.60.120.340:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69568, NULL, 'G3DSA:2.10.25.10:FF:001643', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69569, NULL, 'G3DSA:1.25.10.10:FF:000903', NULL, NULL, 'Exportin-4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(69570, NULL, 'G3DSA:2.170.300.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69571, NULL, 'G3DSA:3.30.200.20:FF:000448', NULL, NULL, 'cyclin-dependent kinase 19 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(69572, NULL, 'G3DSA:3.40.50.10050:FF:000007', NULL, NULL, 'Sporozoite surface antigen MB2', NULL, NULL, NULL, NULL, NULL, 4),
(69573, NULL, 'G3DSA:3.40.250.10:FF:000002', NULL, NULL, 'TBC1 domain family member 23', NULL, NULL, NULL, NULL, NULL, 4),
(69574, NULL, 'G3DSA:3.30.70.330:FF:001877', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69575, NULL, 'G3DSA:3.40.225.10:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69576, NULL, 'G3DSA:3.30.760.10:FF:000026', NULL, NULL, 'Eukaryotic translation initiation factor 4E', NULL, NULL, NULL, NULL, NULL, 4),
(69577, NULL, 'G3DSA:3.30.450.60:FF:000023', NULL, NULL, 'Signal sequence receptor alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(69578, NULL, 'G3DSA:3.40.50.300:FF:004936', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69579, NULL, 'G3DSA:1.20.1250.10:FF:000103', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69580, NULL, 'G3DSA:3.40.50.10190:FF:000021', NULL, NULL, 'DNA topoisomerase II binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(69581, NULL, 'G3DSA:3.40.50.300:FF:003071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69582, NULL, 'G3DSA:3.30.710.10:FF:000080', NULL, NULL, 'kelch-like protein 7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(69583, NULL, 'G3DSA:2.40.30.160:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69584, NULL, 'G3DSA:2.40.30.170:FF:000013', NULL, NULL, 'Glycoside hydrolase family 43', NULL, NULL, NULL, NULL, NULL, 4),
(69585, NULL, 'G3DSA:3.40.50.300:FF:005212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69586, NULL, 'G3DSA:3.40.190.290:FF:000017', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(69587, NULL, 'G3DSA:3.80.10.10:FF:000108', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3', NULL, NULL, NULL, NULL, NULL, 4),
(69588, NULL, 'G3DSA:3.30.720.50:FF:000013', NULL, NULL, 'Protein deltex', NULL, NULL, NULL, NULL, NULL, 4),
(69589, NULL, 'G3DSA:1.20.1070.10:FF:002135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69590, NULL, 'G3DSA:3.90.70.10:FF:000707', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(69591, NULL, 'G3DSA:1.20.1560.10:FF:000312', NULL, NULL, 'ATP-binding cassette sub-family D member 2', NULL, NULL, NULL, NULL, NULL, 4),
(69592, NULL, 'G3DSA:3.30.1220.10:FF:000002', NULL, NULL, 'At1g80480', NULL, NULL, NULL, NULL, NULL, 4),
(69593, NULL, 'G3DSA:3.30.450.70:FF:000026', NULL, NULL, 'TRansport Protein Particle', NULL, NULL, NULL, NULL, NULL, 4),
(69594, NULL, 'G3DSA:1.10.510.10:FF:001341', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(69595, NULL, 'G3DSA:3.80.10.10:FF:001744', NULL, NULL, 'GD14831', NULL, NULL, NULL, NULL, NULL, 4),
(69596, NULL, 'G3DSA:1.20.58.390:FF:000259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69597, NULL, 'G3DSA:3.90.260.10:FF:000048', NULL, NULL, 'AGAP001967-PA', NULL, NULL, NULL, NULL, NULL, 4),
(69598, NULL, 'G3DSA:1.20.58.60:FF:000274', NULL, NULL, 'dystrophin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(69599, NULL, 'G3DSA:1.10.510.10:FF:000846', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase SD3-1', NULL, NULL, NULL, NULL, NULL, 4),
(69600, NULL, 'G3DSA:4.10.60.10:FF:000247', NULL, NULL, 'ATP-dependent RNA helicase glh-3', NULL, NULL, NULL, NULL, NULL, 4),
(69601, NULL, 'G3DSA:4.10.1060.10:FF:000021', NULL, NULL, 'MUTL protein homolog 3', NULL, NULL, NULL, NULL, NULL, 4),
(69602, NULL, 'G3DSA:1.10.150.60:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69603, NULL, 'G3DSA:3.40.50.1470:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69604, NULL, 'G3DSA:3.30.70.270:FF:000307', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69605, NULL, 'G3DSA:3.10.450.50:FF:000025', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(69606, NULL, 'G3DSA:3.80.10.10:FF:000327', NULL, NULL, 'leucine-rich repeat protein SHOC-2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(69607, NULL, 'G3DSA:1.10.510.10:FF:001122', NULL, NULL, 'Receptor-like tyrosine-protein kinase kin-15', NULL, NULL, NULL, NULL, NULL, 4),
(69608, NULL, 'G3DSA:3.30.1370.10:FF:000114', NULL, NULL, 'Exosome complex component RRP40', NULL, NULL, NULL, NULL, NULL, 4),
(69609, NULL, 'G3DSA:3.90.226.10:FF:000334', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69610, NULL, 'G3DSA:3.80.10.10:FF:002020', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(69611, NULL, 'G3DSA:1.10.8.1290:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69612, NULL, 'G3DSA:3.40.50.300:FF:007342', NULL, NULL, 'ERCC2/XPD/Rad3-related DNA repair helicase', NULL, NULL, NULL, NULL, NULL, 4),
(69613, NULL, 'G3DSA:3.30.60.20:FF:000139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69614, NULL, 'G3DSA:3.30.160.60:FF:004773', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69615, NULL, 'G3DSA:3.40.30.10:FF:000679', NULL, NULL, 'Glutathione S-transferase D7-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(69616, NULL, 'G3DSA:3.40.50.2000:FF:000224', NULL, NULL, 'Trehalose-phosphatase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(69617, NULL, 'G3DSA:3.30.160.60:FF:003137', NULL, NULL, 'Zinc finger protein 433', NULL, NULL, NULL, NULL, NULL, 4),
(69618, NULL, 'G3DSA:3.30.70.380:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69619, NULL, 'G3DSA:1.20.140.150:FF:000067', NULL, NULL, 'Transmembrane protein 225', NULL, NULL, NULL, NULL, NULL, 4),
(69620, NULL, 'G3DSA:1.10.533.10:FF:000197', NULL, NULL, 'V-FLIP', NULL, NULL, NULL, NULL, NULL, 4),
(69621, NULL, 'G3DSA:3.40.47.10:FF:000206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69622, NULL, 'G3DSA:3.30.70.370:FF:000006', NULL, NULL, 'DNA polymerase I type A', NULL, NULL, NULL, NULL, NULL, 4),
(69623, NULL, 'G3DSA:1.20.1070.10:FF:001972', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69624, NULL, 'G3DSA:2.130.10.10:FF:000608', NULL, NULL, 'F-box/WD repeat-containing protein 9 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(69625, NULL, 'G3DSA:1.20.120.610:FF:000015', NULL, NULL, 'ATP synthase subunit K', NULL, NULL, NULL, NULL, NULL, 4),
(69626, NULL, 'G3DSA:1.25.40.10:FF:001332', NULL, NULL, 'pentatricopeptide repeat-containing protein At5g55740, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(69627, NULL, 'G3DSA:3.30.428.10:FF:000002', NULL, NULL, 'Galactose-1-phosphate uridylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(69628, NULL, 'G3DSA:1.10.238.10:FF:001202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(69629, NULL, 'G3DSA:3.30.300.30:FF:000150', NULL, NULL, 'Acetyl-coenzyme A synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(69630, NULL, 'G3DSA:3.30.70.360:FF:000003', NULL, NULL, 'Acetylornithine deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(69631, NULL, 'G3DSA:3.30.70.330:FF:002372', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69632, NULL, 'G3DSA:3.40.50.2300:FF:000432', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(69633, NULL, 'G3DSA:3.30.70.1590:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69634, NULL, 'G3DSA:3.30.70.330:FF:002591', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69635, NULL, 'G3DSA:1.10.640.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69636, NULL, 'G3DSA:1.25.40.20:FF:001335', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69637, NULL, 'G3DSA:3.30.1010.10:FF:000065', NULL, NULL, 'NUC194_domain/Phosphatidylinositol_3-_and_4 -kinase_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(69638, NULL, 'G3DSA:1.10.196.10:FF:000013', NULL, NULL, 'Regulator of G-protein signaling 13', NULL, NULL, NULL, NULL, NULL, 4),
(69639, NULL, 'G3DSA:3.90.800.10:FF:000005', NULL, NULL, 'Glutamate--tRNA ligase 2', NULL, NULL, NULL, NULL, NULL, 4),
(69640, NULL, 'G3DSA:1.25.40.10:FF:004547', NULL, NULL, 'ABL100Wp', NULL, NULL, NULL, NULL, NULL, 4),
(69641, NULL, 'G3DSA:3.30.540.10:FF:000044', NULL, NULL, 'Inositol monophosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(69642, NULL, 'G3DSA:1.20.58.200:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69643, NULL, 'G3DSA:3.40.1280.10:FF:000048', NULL, NULL, '23S rRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(69644, NULL, 'G3DSA:3.30.710.10:FF:000309', NULL, NULL, 'CG10830', NULL, NULL, NULL, NULL, NULL, 4),
(69645, NULL, 'G3DSA:3.30.160.60:FF:000844', NULL, NULL, 'Transcription factor Ovo 2', NULL, NULL, NULL, NULL, NULL, 4),
(69646, NULL, 'G3DSA:3.40.30.10:FF:001174', NULL, NULL, 'Glutathione S-transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(69647, NULL, 'G3DSA:3.50.30.30:FF:000010', NULL, NULL, 'Transferrin receptor protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(69648, NULL, 'G3DSA:2.130.10.10:FF:000940', NULL, NULL, 'WD repeat domain 37', NULL, NULL, NULL, NULL, NULL, 4),
(69649, NULL, 'G3DSA:1.20.1440.130:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69650, NULL, 'G3DSA:3.40.630.10:FF:000329', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69651, NULL, 'G3DSA:3.10.129.10:FF:000137', NULL, NULL, 'Protein CBG14719', NULL, NULL, NULL, NULL, NULL, 4),
(69652, NULL, 'G3DSA:3.30.110.30:FF:000006', NULL, NULL, 'Prolyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(69653, NULL, 'G3DSA:1.10.3130.10:FF:000018', NULL, NULL, 'Serine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(69654, NULL, 'G3DSA:3.40.190.10:FF:000632', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(69655, NULL, 'G3DSA:3.50.50.60:FF:000801', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69656, NULL, 'G3DSA:1.10.1080.10:FF:000002', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(69657, NULL, 'G3DSA:3.40.50.300:FF:004717', NULL, NULL, 'ATLastiN (Endoplasmic reticulum GTPase) related', NULL, NULL, NULL, NULL, NULL, 4),
(69658, NULL, 'G3DSA:2.60.120.200:FF:000551', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69659, NULL, 'G3DSA:3.60.21.10:FF:000197', NULL, NULL, 'Purple acid phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(69660, NULL, 'G3DSA:2.60.120.200:FF:000219', NULL, NULL, 'Wing blister, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(69661, NULL, 'G3DSA:2.60.120.260:FF:000198', NULL, NULL, 'Beta-glucuronidase', NULL, NULL, NULL, NULL, NULL, 4),
(69662, NULL, 'G3DSA:3.90.70.10:FF:000584', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(69663, NULL, 'G3DSA:2.10.25.10:FF:000007', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(69664, NULL, 'G3DSA:2.60.40.60:FF:001112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69665, NULL, 'G3DSA:1.20.58.900:FF:000013', NULL, NULL, 'pleckstrin homology domain-containing family M member 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(69666, NULL, 'G3DSA:2.60.40.10:FF:003143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69667, NULL, 'G3DSA:1.10.238.10:FF:000926', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69668, NULL, 'G3DSA:1.10.340.30:FF:000007', NULL, NULL, 'Methyl-CpG-binding domain protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(69669, NULL, 'G3DSA:3.40.50.11260:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69670, NULL, 'G3DSA:2.130.10.30:FF:000024', NULL, NULL, 'RCC1-like G exchanging factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(69671, NULL, 'G3DSA:3.40.50.1820:FF:000265', NULL, NULL, 'Lysosomal Pro-X carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(69672, NULL, 'G3DSA:1.10.287.130:FF:000053', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(69673, NULL, 'G3DSA:3.90.660.20:FF:000019', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(69674, NULL, 'G3DSA:3.30.497.10:FF:000077', NULL, NULL, 'Putative serpin A13', NULL, NULL, NULL, NULL, NULL, 4),
(69675, NULL, 'G3DSA:1.10.238.10:FF:000584', NULL, NULL, 'Nuclear receptor coactivator 5', NULL, NULL, NULL, NULL, NULL, 4),
(69676, NULL, 'G3DSA:1.25.40.20:FF:000498', NULL, NULL, 'E3 ubiquitin-protein ligase HACE1 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(69677, NULL, 'G3DSA:1.25.40.10:FF:000837', NULL, NULL, 'Tetratricopeptide repeat protein 30 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(69678, NULL, 'G3DSA:1.25.10.10:FF:000780', NULL, NULL, 'BP28CT domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(69679, NULL, 'G3DSA:3.90.740.10:FF:000074', NULL, NULL, 'Leucyl-tRNA synthetase b', NULL, NULL, NULL, NULL, NULL, 4),
(69680, NULL, 'G3DSA:3.90.1180.10:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69681, NULL, 'G3DSA:1.20.1310.10:FF:000159', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69682, NULL, 'G3DSA:3.60.120.10:FF:000022', NULL, NULL, 'Isochorismate synthase EntC', NULL, NULL, NULL, NULL, NULL, 4),
(69683, NULL, 'G3DSA:3.10.450.40:FF:000022', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(69684, NULL, 'G3DSA:3.20.20.300:FF:000040', NULL, NULL, 'Periplasmic beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(69685, NULL, 'G3DSA:1.10.8.140:FF:000001', NULL, NULL, 'Programmed cell death protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(69686, NULL, 'G3DSA:3.30.40.10:FF:001883', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69687, NULL, 'G3DSA:3.40.30.10:FF:000898', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(69688, NULL, 'G3DSA:3.40.50.1820:FF:001682', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(69689, NULL, 'G3DSA:3.10.50.10:FF:000024', NULL, NULL, 'Chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(69690, NULL, 'G3DSA:3.40.50.2300:FF:000090', NULL, NULL, 'Transcriptional regulator, AraC family', NULL, NULL, NULL, NULL, NULL, 4),
(69691, NULL, 'G3DSA:3.90.660.10:FF:000016', NULL, NULL, 'L-amino acid oxidase LaoA', NULL, NULL, NULL, NULL, NULL, 4),
(69692, NULL, 'G3DSA:2.60.40.10:FF:004902', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69693, NULL, 'G3DSA:3.40.50.300:FF:008427', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(69694, NULL, 'G3DSA:3.30.200.20:FF:000229', NULL, NULL, 'Serine/threonine-protein kinase Chk1', NULL, NULL, NULL, NULL, NULL, 4),
(69695, NULL, 'G3DSA:3.30.420.340:FF:000010', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4),
(69696, NULL, 'G3DSA:2.60.40.1510:FF:000045', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(69697, NULL, 'G3DSA:2.60.40.10:FF:002716', NULL, NULL, 'Pullulanase 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(69698, NULL, 'G3DSA:3.40.50.1380:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69699, NULL, 'G3DSA:1.10.1070.11:FF:000094', NULL, NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(69700, NULL, 'G3DSA:1.10.600.10:FF:000073', NULL, NULL, 'Ent-copalyl diphosphate synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(69701, NULL, 'G3DSA:3.40.50.620:FF:000295', NULL, NULL, 'Glutamate-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(69702, NULL, 'G3DSA:2.130.10.10:FF:000603', NULL, NULL, 'U3 snoRNA-associated small subunit rRNA processing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(69703, NULL, 'G3DSA:3.40.50.150:FF:000603', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(69704, NULL, 'G3DSA:3.30.1120.30:FF:000035', NULL, NULL, 'Polo kinase-like protein, copy C', NULL, NULL, NULL, NULL, NULL, 4),
(69705, NULL, 'G3DSA:2.30.42.10:FF:000412', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69706, NULL, 'G3DSA:1.10.3430.10:FF:000008', NULL, NULL, 'Ammonium transporter', NULL, NULL, NULL, NULL, NULL, 4),
(69707, NULL, 'G3DSA:1.10.10.10:FF:001819', NULL, NULL, 'Transcriptional adapter', NULL, NULL, NULL, NULL, NULL, 4),
(69708, NULL, 'G3DSA:3.30.479.20:FF:000033', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(69709, NULL, 'G3DSA:3.40.50.300:FF:002554', NULL, NULL, 'NLR family pyrin domain containing 11', NULL, NULL, NULL, NULL, NULL, 4),
(69710, NULL, 'G3DSA:3.50.50.60:FF:000280', NULL, NULL, 'Tryptophan halogenase', NULL, NULL, NULL, NULL, NULL, 4),
(69711, NULL, 'G3DSA:3.40.50.720:FF:000027', NULL, NULL, 'Trk system potassium transporter TrkA', NULL, NULL, NULL, NULL, NULL, 4),
(69712, NULL, 'G3DSA:3.30.9.10:FF:000119', NULL, NULL, 'D-amino acid oxidase family', NULL, NULL, NULL, NULL, NULL, 4),
(69713, NULL, 'G3DSA:2.10.25.10:FF:001773', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(69714, NULL, 'G3DSA:2.30.29.30:FF:000426', NULL, NULL, 'Ysp1p', NULL, NULL, NULL, NULL, NULL, 4),
(69715, NULL, 'G3DSA:2.130.10.10:FF:003829', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69716, NULL, 'G3DSA:4.10.280.10:FF:000064', NULL, NULL, 'Transcription factor MUTE', NULL, NULL, NULL, NULL, NULL, 4),
(69717, NULL, 'G3DSA:3.20.20.70:FF:000613', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69718, NULL, 'G3DSA:3.30.200.20:FF:000730', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(69719, NULL, 'G3DSA:3.40.50.11730:FF:000001', NULL, NULL, 'Pex22p', NULL, NULL, NULL, NULL, NULL, 4),
(69720, NULL, 'G3DSA:3.40.50.1360:FF:000021', NULL, NULL, '6-phosphogluconolactonase', NULL, NULL, NULL, NULL, NULL, 4),
(69721, NULL, 'G3DSA:3.40.50.20:FF:000077', NULL, NULL, 'D-alanine--D-alanine ligase B', NULL, NULL, NULL, NULL, NULL, 4),
(69722, NULL, 'G3DSA:2.60.120.380:FF:000004', NULL, NULL, 'Inhibitor of g-type lysozyme', NULL, NULL, NULL, NULL, NULL, 4),
(69723, NULL, 'G3DSA:1.10.238.20:FF:000031', NULL, NULL, 'Odorant-binding protein 83cd', NULL, NULL, NULL, NULL, NULL, 4),
(69724, NULL, 'G3DSA:3.40.50.150:FF:001059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69725, NULL, 'G3DSA:2.60.120.620:FF:000032', NULL, NULL, 'Unplaced genomic scaffold supercont1.16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(69726, NULL, 'G3DSA:2.40.50.90:FF:000004', NULL, NULL, 'Staphylococcal nuclease domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(69727, NULL, 'G3DSA:1.20.1250.20:FF:001574', NULL, NULL, 'Thiamine transporter 2', NULL, NULL, NULL, NULL, NULL, 4),
(69728, NULL, 'G3DSA:3.30.70.1820:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69729, NULL, 'G3DSA:3.30.160.60:FF:004762', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69730, NULL, 'G3DSA:1.25.10.10:FF:003063', NULL, NULL, 'Importin beta', NULL, NULL, NULL, NULL, NULL, 4),
(69731, NULL, 'G3DSA:2.60.40.1170:FF:000022', NULL, NULL, 'AP-1 complex subunit mu', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(69732, NULL, 'G3DSA:1.25.40.180:FF:000064', NULL, NULL, 'Translation initiation factor 4G', NULL, NULL, NULL, NULL, NULL, 4),
(69733, NULL, 'G3DSA:3.40.50.720:FF:001488', NULL, NULL, 'dTDP-fucopyranose mutase', NULL, NULL, NULL, NULL, NULL, 4),
(69734, NULL, 'G3DSA:3.40.50.12670:FF:000013', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(69735, NULL, 'G3DSA:1.20.5.170:FF:000183', NULL, NULL, 'Desiccation-related protein At2g46140', NULL, NULL, NULL, NULL, NULL, 4),
(69736, NULL, 'G3DSA:1.20.1250.20:FF:000585', NULL, NULL, 'BSC6p protein', NULL, NULL, NULL, NULL, NULL, 4),
(69737, NULL, 'G3DSA:1.50.40.10:FF:000246', NULL, NULL, 'Putative mitochondrial carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(69738, NULL, 'G3DSA:3.30.190.20:FF:000031', NULL, NULL, 'Ribosomal protein L1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(69739, NULL, 'G3DSA:1.25.40.10:FF:004672', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69740, NULL, 'G3DSA:1.20.1560.10:FF:000919', NULL, NULL, 'Protein CBR-HMT-1', NULL, NULL, NULL, NULL, NULL, 4),
(69741, NULL, 'G3DSA:1.20.120.1080:FF:000136', NULL, NULL, 'Helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(69742, NULL, 'G3DSA:1.10.2000.10:FF:000077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69743, NULL, 'G3DSA:3.40.630.10:FF:000313', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(69744, NULL, 'G3DSA:3.40.50.300:FF:006769', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69745, NULL, 'G3DSA:3.30.160.60:FF:003773', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(69746, NULL, 'G3DSA:3.40.30.10:FF:000657', NULL, NULL, 'Peroxiredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(69747, NULL, 'G3DSA:1.10.10.1100:FF:000002', NULL, NULL, 'Nitrite reductase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(69748, NULL, 'G3DSA:2.60.40.3470:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69749, NULL, 'G3DSA:3.30.559.10:FF:000177', NULL, NULL, 'Nonribosomal peptide synthase nlsA', NULL, NULL, NULL, NULL, NULL, 4),
(69750, NULL, 'G3DSA:3.30.420.10:FF:000412', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69751, NULL, 'G3DSA:1.20.920.10:FF:000123', NULL, NULL, 'Transcription factor GTE7', NULL, NULL, NULL, NULL, NULL, 4),
(69752, NULL, 'G3DSA:1.20.1740.10:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69753, NULL, 'G3DSA:2.40.160.110:FF:000009', NULL, NULL, 'Blast:Lysosome-associated membrane glycoprotein 5', NULL, NULL, NULL, NULL, NULL, 4),
(69754, NULL, 'G3DSA:3.40.50.720:FF:000499', NULL, NULL, 'Protein TIC 62, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(69755, NULL, 'G3DSA:1.25.40.10:FF:000338', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(69756, NULL, 'G3DSA:3.30.710.10:FF:000159', NULL, NULL, 'Speckle-type POZ protein B', NULL, NULL, NULL, NULL, NULL, 4),
(69757, NULL, 'G3DSA:3.10.580.10:FF:000175', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(69758, NULL, 'G3DSA:3.30.1370.110:FF:000006', NULL, NULL, 'Endonuclease MutS2', NULL, NULL, NULL, NULL, NULL, 4),
(69759, NULL, 'G3DSA:3.40.50.300:FF:003543', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(69760, NULL, 'G3DSA:2.20.20.100:FF:000001', NULL, NULL, 'Sensor histidine kinase LuxQ', NULL, NULL, NULL, NULL, NULL, 4),
(69761, NULL, 'G3DSA:1.10.472.10:FF:000381', NULL, NULL, 'Retinoblastoma susceptibility protein', NULL, NULL, NULL, NULL, NULL, 4),
(69762, NULL, 'G3DSA:1.10.287.70:FF:000625', NULL, NULL, 'Voltage-gated potassium channel', NULL, NULL, NULL, NULL, NULL, 4),
(69763, NULL, 'G3DSA:3.40.50.1000:FF:000610', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69764, NULL, 'G3DSA:3.30.70.330:FF:000478', NULL, NULL, 'heterogeneous nuclear ribonucleoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(69765, NULL, 'G3DSA:1.10.630.10:FF:000693', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(69766, NULL, 'G3DSA:3.40.50.12780:FF:000107', NULL, NULL, 'Putative fatty-acid--CoA ligase fadD11', NULL, NULL, NULL, NULL, NULL, 4),
(69767, NULL, 'G3DSA:3.30.565.10:FF:000118', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(69768, NULL, 'G3DSA:3.30.900.10:FF:000022', NULL, NULL, 'IP20312p', NULL, NULL, NULL, NULL, NULL, 4),
(69769, NULL, 'G3DSA:3.60.110.10:FF:000067', NULL, NULL, 'Glutamine-dependent NAD(+) synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(69770, NULL, 'G3DSA:3.40.50.2000:FF:000281', NULL, NULL, 'Alanine-rich transferase', NULL, NULL, NULL, NULL, NULL, 4),
(69771, NULL, 'G3DSA:3.40.50.720:FF:001016', NULL, NULL, 'Formate dehydrogenase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(69772, NULL, 'G3DSA:3.30.160.60:FF:002784', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69773, NULL, 'G3DSA:1.25.10.10:FF:002927', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69774, NULL, 'G3DSA:2.120.10.30:FF:000430', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69775, NULL, 'G3DSA:1.20.58.400:FF:000004', NULL, NULL, 'Golgi SNAP receptor complex member 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(69776, NULL, 'G3DSA:1.10.940.10:FF:000031', NULL, NULL, 'Transcription antitermination protein NusB', NULL, NULL, NULL, NULL, NULL, 4),
(69777, NULL, 'G3DSA:1.20.1020.10:FF:000008', NULL, NULL, 'BTB/POZ and TAZ domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(69778, NULL, 'G3DSA:3.40.50.2000:FF:000601', NULL, NULL, 'Glycosyl transferase group 1', NULL, NULL, NULL, NULL, NULL, 4),
(69779, NULL, 'G3DSA:3.20.110.10:FF:000008', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(69780, NULL, 'G3DSA:3.80.10.10:FF:003908', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69781, NULL, 'G3DSA:2.40.30.110:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69782, NULL, 'G3DSA:1.10.472.10:FF:000701', NULL, NULL, 'Cyclin9', NULL, NULL, NULL, NULL, NULL, 4),
(69783, NULL, 'G3DSA:2.40.100.10:FF:000119', NULL, NULL, 'Peptidyl-prolyl isomerase CWC27', NULL, NULL, NULL, NULL, NULL, 4),
(69784, NULL, 'G3DSA:3.30.160.60:FF:005538', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69785, NULL, 'G3DSA:3.10.105.10:FF:000050', NULL, NULL, 'Oligopeptide ABC transporter periplasmic oligopeptide-binding protein OppA', NULL, NULL, NULL, NULL, NULL, 4),
(69786, NULL, 'G3DSA:3.30.70.330:FF:002423', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69787, NULL, 'G3DSA:1.10.1410.10:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69788, NULL, 'G3DSA:2.130.10.10:FF:004818', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69789, NULL, 'G3DSA:3.10.50.10:FF:000019', NULL, NULL, 'Glycoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(69790, NULL, 'G3DSA:2.130.10.10:FF:002048', NULL, NULL, 'WD repeat domain 43', NULL, NULL, NULL, NULL, NULL, 4),
(69791, NULL, 'G3DSA:3.10.20.90:FF:000440', NULL, NULL, 'Inhibitor of nuclear factor kappa-B kinase subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(69792, NULL, 'G3DSA:1.10.510.10:FF:003180', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69793, NULL, 'G3DSA:1.10.10.10:FF:000038', NULL, NULL, 'Glycine cleavage system transcriptional activator', NULL, NULL, NULL, NULL, NULL, 4),
(69794, NULL, 'G3DSA:1.20.1070.10:FF:000371', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(69795, NULL, 'G3DSA:3.30.160.60:FF:003301', NULL, NULL, 'Zinc finger and BTB domain containing 41', NULL, NULL, NULL, NULL, NULL, 4),
(69796, NULL, 'G3DSA:3.40.20.10:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69797, NULL, 'G3DSA:3.40.50.300:FF:005308', NULL, NULL, 'Ras-related protein Rap-1b', NULL, NULL, NULL, NULL, NULL, 4),
(69798, NULL, 'G3DSA:3.40.1170.60:FF:000016', NULL, NULL, 'DNA damage repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(69799, NULL, 'G3DSA:3.30.310.210:FF:000008', NULL, NULL, 'Heterogeneous nuclear RibonucleoProtein (HnRNP) K homolog', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(69800, NULL, 'G3DSA:1.10.472.130:FF:000077', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(69801, NULL, 'G3DSA:3.40.50.2300:FF:000573', NULL, NULL, 'Cellobiose-specific PTS system IIC component', NULL, NULL, NULL, NULL, NULL, 4),
(69802, NULL, 'G3DSA:1.20.1560.10:FF:000066', NULL, NULL, 'ABC multidrug transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(69803, NULL, 'G3DSA:3.90.1410.10:FF:000094', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(69804, NULL, 'G3DSA:1.25.40.10:FF:003244', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(69805, NULL, 'G3DSA:3.20.20.140:FF:000099', NULL, NULL, 'Amidohydrolase 2', NULL, NULL, NULL, NULL, NULL, 4),
(69806, NULL, 'G3DSA:1.10.860.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69807, NULL, 'G3DSA:3.40.50.1820:FF:000204', NULL, NULL, 'Tripeptidyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(69808, NULL, 'G3DSA:3.80.10.10:FF:003588', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', NULL, NULL, NULL, NULL, NULL, 4),
(69809, NULL, 'G3DSA:1.20.1070.10:FF:000219', NULL, NULL, 'Opsin 5-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(69810, NULL, 'G3DSA:1.20.58.900:FF:000031', NULL, NULL, 'AGAP004080-PA', NULL, NULL, NULL, NULL, NULL, 4),
(69811, NULL, 'G3DSA:2.10.80.10:FF:000006', NULL, NULL, 'Colipase-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(69812, NULL, 'G3DSA:2.30.30.40:FF:000500', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69813, NULL, 'G3DSA:3.30.760.10:FF:000050', NULL, NULL, 'Eukaryotic translation initiation factor 4E type 5', NULL, NULL, NULL, NULL, NULL, 4),
(69814, NULL, 'G3DSA:3.80.10.10:FF:001290', NULL, NULL, 'Leucine rich repeat and phosphatase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(69815, NULL, 'G3DSA:3.30.40.100:FF:000010', NULL, NULL, 'SNF2 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(69816, NULL, 'G3DSA:3.20.20.300:FF:000023', NULL, NULL, 'Probable conserved lipoprotein LpqI', NULL, NULL, NULL, NULL, NULL, 4),
(69817, NULL, 'G3DSA:1.25.40.20:FF:000667', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(69818, NULL, 'G3DSA:2.130.10.10:FF:003037', NULL, NULL, 'Uncharacterized WD repeat-containing protein slr1410', NULL, NULL, NULL, NULL, NULL, 4),
(69819, NULL, 'G3DSA:1.10.8.530:FF:000012', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(69820, NULL, 'G3DSA:3.30.930.10:FF:000203', NULL, NULL, 'ATP phosphoribosyltransferase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(69821, NULL, 'G3DSA:1.25.40.20:FF:001595', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69822, NULL, 'G3DSA:3.90.180.10:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69823, NULL, 'G3DSA:2.10.50.30:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69824, NULL, 'G3DSA:3.40.50.720:FF:002444', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(69825, NULL, 'G3DSA:3.40.50.1240:FF:000070', NULL, NULL, 'Probable phosphoglycerate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(69826, NULL, 'G3DSA:2.10.110.10:FF:000099', NULL, NULL, 'Uncoordinated 115a, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(69827, NULL, 'G3DSA:2.30.30.40:FF:000028', NULL, NULL, 'endophilin-B2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(69828, NULL, 'G3DSA:2.60.40.10:FF:006078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69829, NULL, 'G3DSA:3.30.160.60:FF:000867', NULL, NULL, 'Zinc finger protein 341', NULL, NULL, NULL, NULL, NULL, 4),
(69830, NULL, 'G3DSA:1.20.58.60:FF:000365', NULL, NULL, 'SMAll', NULL, NULL, NULL, NULL, NULL, 4),
(69831, NULL, 'G3DSA:4.10.400.10:FF:000153', NULL, NULL, 'LDL receptor related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(69832, NULL, 'G3DSA:2.60.40.2170:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(69833, NULL, 'G3DSA:1.20.5.470:FF:000003', NULL, NULL, 'Argininosuccinate synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(69834, NULL, 'G3DSA:3.30.280.10:FF:000001', NULL, NULL, 'Urease subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(69835, NULL, 'G3DSA:3.40.50.300:FF:005460', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(69836, NULL, 'G3DSA:1.10.30.10:FF:000101', NULL, NULL, 'Testis-enriched HMG-box-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(69837, NULL, 'G3DSA:3.40.1110.10:FF:000425', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69838, NULL, 'G3DSA:3.40.50.720:FF:002005', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(69839, NULL, 'G3DSA:2.60.120.200:FF:000142', NULL, NULL, 'MAM domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(69840, NULL, 'G3DSA:1.20.120.1900:FF:000011', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(69841, NULL, 'G3DSA:3.30.70.360:FF:000021', NULL, NULL, 'ACY1-like metalloprotease', NULL, NULL, NULL, NULL, NULL, 4),
(69842, NULL, 'G3DSA:2.160.20.10:FF:000097', NULL, NULL, 'Endo-xylogalacturonan hydrolase A', NULL, NULL, NULL, NULL, NULL, 4),
(69843, NULL, 'G3DSA:2.80.10.50:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69844, NULL, 'G3DSA:1.25.40.10:FF:002755', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69845, NULL, 'G3DSA:3.40.50.360:FF:000048', NULL, NULL, 'Bifunctional cytochrome P450/NADPH--P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(69846, NULL, 'G3DSA:3.40.50.720:FF:000819', NULL, NULL, 'Short-chain dehydrogenase/reductase SDR', NULL, NULL, NULL, NULL, NULL, 4),
(69847, NULL, 'G3DSA:1.10.287.130:FF:000205', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(69848, NULL, 'G3DSA:2.30.42.10:FF:000092', NULL, NULL, 'PDZ domain containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(69849, NULL, 'G3DSA:3.30.70.890:FF:000005', NULL, NULL, 'Diphosphomevalonate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(69850, NULL, 'G3DSA:3.40.190.10:FF:000649', NULL, NULL, 'Probable porphobilinogen deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(69851, NULL, 'G3DSA:2.40.10.10:FF:000080', NULL, NULL, 'peroxisomal leader peptide-processing protease', NULL, NULL, NULL, NULL, NULL, 4),
(69852, NULL, 'G3DSA:3.80.10.10:FF:003116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69853, NULL, 'G3DSA:3.40.50.300:FF:004971', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69854, NULL, 'G3DSA:2.70.170.10:FF:000297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69855, NULL, 'G3DSA:3.90.110.10:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69856, NULL, 'G3DSA:3.30.497.10:FF:000044', NULL, NULL, 'GM22272', NULL, NULL, NULL, NULL, NULL, 4),
(69857, NULL, 'G3DSA:3.40.50.300:FF:001565', NULL, NULL, 'Orc1-type DNA replication protein', NULL, NULL, NULL, NULL, NULL, 4),
(69858, NULL, 'G3DSA:2.40.50.140:FF:000492', NULL, NULL, 'S1 RNA-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(69859, NULL, 'G3DSA:3.30.200.20:FF:002175', NULL, NULL, 'Cyclin-dependent kinase C-2', NULL, NULL, NULL, NULL, NULL, 4),
(69860, NULL, 'G3DSA:3.60.90.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69861, NULL, 'G3DSA:2.60.40.10:FF:001727', NULL, NULL, 'Protein tyrosine phosphatase, receptor type B', NULL, NULL, NULL, NULL, NULL, 4),
(69862, NULL, 'G3DSA:3.30.160.20:FF:000203', NULL, NULL, 'STAUfen (DsRNA binding protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(69863, NULL, 'G3DSA:3.30.200.20:FF:001539', NULL, NULL, 'Probable protein kinase DDB_G0291842', NULL, NULL, NULL, NULL, NULL, 4),
(69864, NULL, 'G3DSA:3.30.1370.10:FF:000221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69865, NULL, 'G3DSA:2.60.40.10:FF:000951', NULL, NULL, 'Terribly reduced optic lobes, isoform AI', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(69866, NULL, 'G3DSA:2.70.160.11:FF:000096', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(69867, NULL, 'G3DSA:3.40.50.300:FF:005960', NULL, NULL, 'Ribosome biogenesis GTPase A', NULL, NULL, NULL, NULL, NULL, 4),
(69868, NULL, 'G3DSA:3.50.50.60:FF:000633', NULL, NULL, 'D-proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(69869, NULL, 'G3DSA:3.30.70.260:FF:000137', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(69870, NULL, 'G3DSA:3.80.10.10:FF:002127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69871, NULL, 'G3DSA:1.10.10.10:FF:000982', NULL, NULL, 'EAP30/Vps36 family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(69872, NULL, 'G3DSA:2.60.40.10:FF:005089', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69873, NULL, 'G3DSA:3.40.50.1820:FF:001665', NULL, NULL, 'Acetoin dehydrogenase complex, E2 component, dihydrolipoamide acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(69874, NULL, 'G3DSA:3.90.1310.10:FF:000030', NULL, NULL, 'Cell division protein FtsI [Peptidoglycan synthetase]', NULL, NULL, NULL, NULL, NULL, 4),
(69875, NULL, 'G3DSA:3.30.40.10:FF:000124', NULL, NULL, 'STIP1 homology and U box-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(69876, NULL, 'G3DSA:3.30.70.660:FF:000021', NULL, NULL, 'tRNA pseudouridine synthase A-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(69877, NULL, 'G3DSA:3.30.420.40:FF:000308', NULL, NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(69878, NULL, 'G3DSA:3.30.70.100:FF:000022', NULL, NULL, 'Putative cadmium/zinc-transporting ATPase 3', NULL, NULL, NULL, NULL, NULL, 4),
(69879, NULL, 'G3DSA:2.120.10.80:FF:000012', NULL, NULL, 'Kelch domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(69880, NULL, 'G3DSA:3.90.550.10:FF:000346', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(69881, NULL, 'G3DSA:1.20.5.110:FF:000272', NULL, NULL, 'Vesicle transport v-SNARE protein N-terminus, putative', NULL, NULL, NULL, NULL, NULL, 4),
(69882, NULL, 'G3DSA:1.10.287.1130:FF:000012', NULL, NULL, 'Unplaced genomic scaffold supercont1.28, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(69883, NULL, 'G3DSA:1.25.40.770:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69884, NULL, 'G3DSA:2.60.120.10:FF:000431', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(69885, NULL, 'G3DSA:3.30.2130.30:FF:000007', NULL, NULL, 'THUMP domain-containing protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(69886, NULL, 'G3DSA:3.50.7.10:FF:000076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69887, NULL, 'G3DSA:1.20.1560.10:FF:000566', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69888, NULL, 'G3DSA:2.60.40.10:FF:005622', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69889, NULL, 'G3DSA:1.20.58.60:FF:000426', NULL, NULL, 'Spectrin repeat containing nuclear envelope protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(69890, NULL, 'G3DSA:3.30.160.60:FF:000367', NULL, NULL, 'Zinc finger protein 572', NULL, NULL, NULL, NULL, NULL, 4),
(69891, NULL, 'G3DSA:1.10.400.10:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69892, NULL, 'G3DSA:1.20.920.20:FF:000013', NULL, NULL, 'Dynein Heavy Chain', NULL, NULL, NULL, NULL, NULL, 4),
(69893, NULL, 'G3DSA:2.30.30.100:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69894, NULL, 'G3DSA:1.10.238.10:FF:001130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69895, NULL, 'G3DSA:3.30.230.70:FF:000140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69896, NULL, 'G3DSA:1.20.5.210:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69897, NULL, 'G3DSA:3.30.430.20:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69898, NULL, 'G3DSA:3.40.50.300:FF:003190', NULL, NULL, 'ABC transporter putative', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(69899, NULL, 'G3DSA:2.40.30.10:FF:000463', NULL, NULL, 'Iron-chelator utilization protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(69900, NULL, 'G3DSA:1.25.40.10:FF:001799', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(69901, NULL, 'G3DSA:1.20.1080.10:FF:000017', NULL, NULL, 'Probable aquaporin TIP5-1', NULL, NULL, NULL, NULL, NULL, 4),
(69902, NULL, 'G3DSA:3.30.70.330:FF:000006', NULL, NULL, 'ELAV-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(69903, NULL, 'G3DSA:1.10.8.60:FF:000052', NULL, NULL, 'Nuclear valosin-containing protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(69904, NULL, 'G3DSA:2.60.40.60:FF:000972', NULL, NULL, 'AGAP004166-PA', NULL, NULL, NULL, NULL, NULL, 4),
(69905, NULL, 'G3DSA:1.25.40.20:FF:001656', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(69906, NULL, 'G3DSA:2.10.60.10:FF:000062', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(69907, NULL, 'G3DSA:3.40.140.10:FF:000085', NULL, NULL, 'Mov34/MPN/PAD-1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(69908, NULL, 'G3DSA:3.90.190.10:FF:000363', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69909, NULL, 'G3DSA:1.10.510.10:FF:000274', NULL, NULL, 'Stress response kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(69910, NULL, 'G3DSA:2.60.260.20:FF:000118', NULL, NULL, 'Chaperone protein DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(69911, NULL, 'G3DSA:2.70.150.10:FF:000234', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(69912, NULL, 'G3DSA:3.40.50.12780:FF:000046', NULL, NULL, 'L-2-aminoadipate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(69913, NULL, 'G3DSA:1.10.8.10:FF:000318', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69914, NULL, 'G3DSA:1.20.58.1120:FF:000067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69915, NULL, 'G3DSA:2.60.40.10:FF:000890', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(69916, NULL, 'G3DSA:1.10.220.30:FF:000033', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(69917, NULL, 'G3DSA:2.60.40.10:FF:003352', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(69918, NULL, 'G3DSA:3.90.1490.10:FF:000014', NULL, NULL, 'Transcriptional regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(69919, NULL, 'G3DSA:2.130.10.10:FF:001531', NULL, NULL, 'Similar to periodic tryptophan protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(69920, NULL, 'G3DSA:2.60.40.150:FF:000415', NULL, NULL, 'Tb-292 membrane associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(69921, NULL, 'G3DSA:2.30.30.140:FF:000237', NULL, NULL, 'MutS 6 isoform 1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(69922, NULL, 'G3DSA:1.10.555.10:FF:000063', NULL, NULL, 'Lrg1p', NULL, NULL, NULL, NULL, NULL, 4),
(69923, NULL, 'G3DSA:1.10.287.70:FF:000272', NULL, NULL, 'Potassium channel protein kcv', NULL, NULL, NULL, NULL, NULL, 4),
(69924, NULL, 'G3DSA:3.30.160.60:FF:005690', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69925, NULL, 'G3DSA:3.40.50.150:FF:001531', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69926, NULL, 'G3DSA:3.40.190.10:FF:000149', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(69927, NULL, 'G3DSA:3.30.70.3490:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69928, NULL, 'G3DSA:2.40.50.1000:FF:000009', NULL, NULL, '40S ribosomal protein S11', NULL, NULL, NULL, NULL, NULL, 4),
(69929, NULL, 'G3DSA:2.60.40.150:FF:000595', NULL, NULL, 'Type III restriction enzyme, res subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(69930, NULL, 'G3DSA:1.25.40.20:FF:000167', NULL, NULL, 'peroxisomal NADH pyrophosphatase NUDT12', NULL, NULL, NULL, NULL, NULL, 4),
(69931, NULL, 'G3DSA:3.40.50.300:FF:003482', NULL, NULL, 'Ring finger protein 112, gene 2', NULL, NULL, NULL, NULL, NULL, 4),
(69932, NULL, 'G3DSA:3.80.10.10:FF:001790', NULL, NULL, 'Cytoplasmic membrane protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(69933, NULL, 'G3DSA:3.30.200.20:FF:000258', NULL, NULL, 'Ethanolamine kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(69934, NULL, 'G3DSA:1.25.40.10:FF:001266', NULL, NULL, 'Hypothetical_protein', NULL, NULL, NULL, NULL, NULL, 4),
(69935, NULL, 'G3DSA:3.60.10.10:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69936, NULL, 'G3DSA:3.60.21.60:FF:000010', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(69937, NULL, 'G3DSA:1.25.40.10:FF:003744', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(69938, NULL, 'G3DSA:1.10.3720.10:FF:000227', NULL, NULL, 'ABC transporter, permease protein, HisMQ family', NULL, NULL, NULL, NULL, NULL, 4),
(69939, NULL, 'G3DSA:3.40.50.300:FF:001918', NULL, NULL, 'Small GTP-binding protein Rab18', NULL, NULL, NULL, NULL, NULL, 4),
(69940, NULL, 'G3DSA:3.80.10.10:FF:003088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69941, NULL, 'G3DSA:2.40.10.10:FF:000580', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69942, NULL, 'G3DSA:3.30.505.10:FF:000261', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69943, NULL, 'G3DSA:3.40.1280.10:FF:000116', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(69944, NULL, 'G3DSA:1.10.150.40:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69945, NULL, 'G3DSA:2.130.10.10:FF:005454', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69946, NULL, 'G3DSA:1.20.58.60:FF:000718', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69947, NULL, 'G3DSA:3.30.70.330:FF:002395', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69948, NULL, 'G3DSA:1.25.40.470:FF:000027', NULL, NULL, 'Intraflagellar transport protein 172 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(69949, NULL, 'G3DSA:3.90.180.10:FF:000065', NULL, NULL, 'Zinc-binding dehydrogenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(69950, NULL, 'G3DSA:3.90.640.10:FF:000145', NULL, NULL, 'Actin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(69951, NULL, 'G3DSA:3.30.360.10:FF:000002', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(69952, NULL, 'G3DSA:2.60.40.10:FF:003644', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69953, NULL, 'G3DSA:3.40.50.300:FF:007697', NULL, NULL, 'Septin 1', NULL, NULL, NULL, NULL, NULL, 4),
(69954, NULL, 'G3DSA:3.30.40.10:FF:002069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69955, NULL, 'G3DSA:2.30.30.1020:FF:000001', NULL, NULL, 'Putative CCR4-NOT transcription complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(69956, NULL, 'G3DSA:2.30.29.30:FF:001062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69957, NULL, 'G3DSA:3.30.160.60:FF:002845', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69958, NULL, 'G3DSA:3.30.1490.20:FF:000025', NULL, NULL, 'Alpha-aminoadipate--LysW ligase LysX protein', NULL, NULL, NULL, NULL, NULL, 4),
(69959, NULL, 'G3DSA:1.10.418.10:FF:000059', NULL, NULL, 'RIKEN cDNA 6430531B16 gene', NULL, NULL, NULL, NULL, NULL, 4),
(69960, NULL, 'G3DSA:3.20.20.80:FF:000442', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69961, NULL, 'G3DSA:1.25.10.10:FF:002899', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(69962, NULL, 'G3DSA:3.40.50.970:FF:000169', NULL, NULL, 'Pyruvate dehydrogenase E1 component beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(69963, NULL, 'G3DSA:3.10.180.10:FF:000066', NULL, NULL, 'Methylglyoxalase', NULL, NULL, NULL, NULL, NULL, 4),
(69964, NULL, 'G3DSA:3.80.10.10:FF:004544', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69965, NULL, 'G3DSA:3.30.230.10:FF:000049', NULL, NULL, 'DNA repair protein RadA', NULL, NULL, NULL, NULL, NULL, 4),
(69966, NULL, 'G3DSA:1.10.730.10:FF:000138', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(69967, NULL, 'G3DSA:1.10.472.10:FF:000229', NULL, NULL, 'CYclin B', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(69968, NULL, 'G3DSA:1.25.10.10:FF:000662', NULL, NULL, 'rRNA-processing protein FCF1', NULL, NULL, NULL, NULL, NULL, 4),
(69969, NULL, 'G3DSA:3.30.1370.10:FF:000160', NULL, NULL, 'Branchpoint-bridging protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(69970, NULL, 'G3DSA:3.30.559.10:FF:000205', NULL, NULL, 'N-(5-amino-5-carboxypentanoyl)-L-cysteinyl-D-valine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(69971, NULL, 'G3DSA:3.90.640.10:FF:000292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69972, NULL, 'G3DSA:3.30.70.60:FF:000034', NULL, NULL, 'Putative fimbrial assembly protein PilO-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(69973, NULL, 'G3DSA:1.20.1560.10:FF:000419', NULL, NULL, 'ABC transporter B family member 9', NULL, NULL, NULL, NULL, NULL, 4),
(69974, NULL, 'G3DSA:3.80.10.10:FF:004105', NULL, NULL, 'PeroXidasiN (Drosophila peroxidase) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(69975, NULL, 'G3DSA:3.50.50.60:FF:001117', NULL, NULL, 'Zeta-carotene desaturase', NULL, NULL, NULL, NULL, NULL, 4),
(69976, NULL, 'G3DSA:3.40.50.720:FF:000971', NULL, NULL, 'Putative daunorubicin C-13 ketoreductase DnrU', NULL, NULL, NULL, NULL, NULL, 4),
(69977, NULL, 'G3DSA:2.120.10.80:FF:000192', NULL, NULL, 'Kelch like family member 42', NULL, NULL, NULL, NULL, NULL, 4),
(69978, NULL, 'G3DSA:2.40.50.140:FF:000020', NULL, NULL, '60S ribosomal protein L2', NULL, NULL, NULL, NULL, NULL, 4),
(69979, NULL, 'G3DSA:3.40.190.10:FF:000296', NULL, NULL, 'Chorismate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(69980, NULL, 'G3DSA:3.10.670.10:FF:000002', NULL, NULL, 'Toxin PAU_02230', NULL, NULL, NULL, NULL, NULL, 4),
(69981, NULL, 'G3DSA:1.25.40.10:FF:005009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69982, NULL, 'G3DSA:3.40.50.300:FF:000637', NULL, NULL, 'ATP-dependent RNA helicase DHX37/DHR1', NULL, NULL, NULL, NULL, NULL, 4),
(69983, NULL, 'G3DSA:3.30.160.60:FF:001356', NULL, NULL, 'Human immunodeficiency virus type I enhancer-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(69984, NULL, 'G3DSA:3.30.40.10:FF:000916', NULL, NULL, 'E3 ubiquitin-protein ligase RFI2', NULL, NULL, NULL, NULL, NULL, 4),
(69985, NULL, 'G3DSA:1.20.140.10:FF:000029', NULL, NULL, 'Acyl-CoA dehydrogenase FadE6', NULL, NULL, NULL, NULL, NULL, 4),
(69986, NULL, 'G3DSA:2.60.120.200:FF:000203', NULL, NULL, 'Thrombospondin type laminin G domain and EAR repeats', NULL, NULL, NULL, NULL, NULL, 4),
(69987, NULL, 'G3DSA:3.40.50.300:FF:003043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(69988, NULL, 'G3DSA:1.25.10.10:FF:001146', NULL, NULL, 'PDS5 cohesin associated factor B', NULL, NULL, NULL, NULL, NULL, 4),
(69989, NULL, 'G3DSA:2.60.40.10:FF:003205', NULL, NULL, 'T cell receptor alpha variable 2', NULL, NULL, NULL, NULL, NULL, 4),
(69990, NULL, 'G3DSA:3.50.50.60:FF:001089', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(69991, NULL, 'G3DSA:2.170.16.10:FF:000025', NULL, NULL, 'Hedgehog protein', NULL, NULL, NULL, NULL, NULL, 4),
(69992, NULL, 'G3DSA:2.40.50.140:FF:000992', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69993, NULL, 'G3DSA:1.10.1370.30:FF:000048', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(69994, NULL, 'G3DSA:3.40.850.10:FF:000296', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(69995, NULL, 'G3DSA:3.30.70.20:FF:000129', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(69996, NULL, 'G3DSA:3.10.250.10:FF:000010', NULL, NULL, 'T-cell differentiation antigen CD6', NULL, NULL, NULL, NULL, NULL, 4),
(69997, NULL, 'G3DSA:3.40.50.720:FF:000999', NULL, NULL, 'Oxidoreductase, short-chain dehydrogenase/reductase family', NULL, NULL, NULL, NULL, NULL, 4),
(69998, NULL, 'G3DSA:2.60.40.60:FF:000472', NULL, NULL, 'Protein CBR-CDH-12', NULL, NULL, NULL, NULL, NULL, 4),
(69999, NULL, 'G3DSA:3.60.40.10:FF:000292', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(70000, NULL, 'G3DSA:1.50.10.150:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(70001, NULL, 'G3DSA:3.40.50.12370:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70002, NULL, 'G3DSA:1.10.510.10:FF:002691', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70003, NULL, 'G3DSA:1.10.1450.10:FF:000043', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(70004, NULL, 'G3DSA:1.25.10.10:FF:001438', NULL, NULL, 'Serine/threonine-protein kinase tor', NULL, NULL, NULL, NULL, NULL, 4),
(70005, NULL, 'G3DSA:2.60.40.150:FF:000123', NULL, NULL, 'protein unc-13 homolog D', NULL, NULL, NULL, NULL, NULL, 4),
(70006, NULL, 'G3DSA:3.60.20.10:FF:000257', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70007, NULL, 'G3DSA:1.20.1250.20:FF:000646', NULL, NULL, 'High-affinity glucose transporter SNF3, variant', NULL, NULL, NULL, NULL, NULL, 4),
(70008, NULL, 'G3DSA:2.60.40.1730:FF:000089', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70009, NULL, 'G3DSA:1.10.510.10:FF:004309', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70010, NULL, 'G3DSA:1.20.58.150:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70011, NULL, 'G3DSA:1.10.10.10:FF:001466', NULL, NULL, 'Aliphatic amidase regulator', NULL, NULL, NULL, NULL, NULL, 4),
(70012, NULL, 'G3DSA:1.10.1370.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70013, NULL, 'G3DSA:1.10.238.10:FF:000202', NULL, NULL, 'Calmodulin-like protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(70014, NULL, 'G3DSA:1.25.10.10:FF:003124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70015, NULL, 'G3DSA:3.40.50.300:FF:007225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70016, NULL, 'G3DSA:1.20.1280.290:FF:000029', NULL, NULL, 'Integral to membrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70017, NULL, 'G3DSA:2.60.120.680:FF:000004', NULL, NULL, 'FYVE and coiled-coil domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(70018, NULL, 'G3DSA:3.30.40.10:FF:000624', NULL, NULL, 'RING-H2 finger protein ATL47', NULL, NULL, NULL, NULL, NULL, 4),
(70019, NULL, 'G3DSA:2.30.29.30:FF:000926', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(70020, NULL, 'G3DSA:3.40.50.2000:FF:001118', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(70021, NULL, 'G3DSA:3.30.40.10:FF:002041', NULL, NULL, 'GEO12067p1', NULL, NULL, NULL, NULL, NULL, 4),
(70022, NULL, 'G3DSA:1.10.800.10:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70023, NULL, 'G3DSA:2.30.180.10:FF:000003', NULL, NULL, 'periostin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(70024, NULL, 'G3DSA:1.20.1250.20:FF:000085', NULL, NULL, 'MFS peptide transporter Ptr2', NULL, NULL, NULL, NULL, NULL, 4),
(70025, NULL, 'G3DSA:1.10.510.10:FF:000566', NULL, NULL, 'Serine/threonine-protein kinase rio2', NULL, NULL, NULL, NULL, NULL, 4),
(70026, NULL, 'G3DSA:3.40.630.30:FF:000471', NULL, NULL, 'GNAT family N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(70027, NULL, 'G3DSA:1.10.510.10:FF:003028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70028, NULL, 'G3DSA:2.60.220.50:FF:000187', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(70029, NULL, 'G3DSA:1.10.640.10:FF:000047', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(70030, NULL, 'G3DSA:1.10.10.650:FF:000018', NULL, NULL, 'Transcription elongation factor SPT6', NULL, NULL, NULL, NULL, NULL, 4),
(70031, NULL, 'G3DSA:3.30.70.270:FF:000027', NULL, NULL, 'RNase E specificity factor CsrD', NULL, NULL, NULL, NULL, NULL, 4),
(70032, NULL, 'G3DSA:3.20.20.70:FF:000113', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(70033, NULL, 'G3DSA:1.25.40.10:FF:000490', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(70034, NULL, 'G3DSA:3.30.230.130:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70035, NULL, 'G3DSA:1.20.1070.10:FF:001860', NULL, NULL, 'Serpentine receptor class gamma-47', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(70036, NULL, 'G3DSA:3.40.720.10:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70037, NULL, 'G3DSA:3.10.590.10:FF:000001', NULL, NULL, 'YTH domain family 1, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(70038, NULL, 'G3DSA:3.80.10.10:FF:000362', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase IRK', NULL, NULL, NULL, NULL, NULL, 4),
(70039, NULL, 'G3DSA:3.40.50.2300:FF:000101', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(70040, NULL, 'G3DSA:3.40.50.1820:FF:000676', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(70041, NULL, 'G3DSA:3.20.90.10:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70042, NULL, 'G3DSA:2.60.120.260:FF:000053', NULL, NULL, 'Reelin', NULL, NULL, NULL, NULL, NULL, 4),
(70043, NULL, 'G3DSA:3.40.50.300:FF:001126', NULL, NULL, 'Baculoviral IAP repeat-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(70044, NULL, 'G3DSA:2.60.120.650:FF:000080', NULL, NULL, 'JmjC domain-containing protein A', NULL, NULL, NULL, NULL, NULL, 4),
(70045, NULL, 'G3DSA:1.20.1250.20:FF:001927', NULL, NULL, 'Uncharacterized MFS-type transporter C18.02', NULL, NULL, NULL, NULL, NULL, 4),
(70046, NULL, 'G3DSA:3.40.50.200:FF:000080', NULL, NULL, 'Peptidase, S8/S53 family', NULL, NULL, NULL, NULL, NULL, 4),
(70047, NULL, 'G3DSA:3.40.50.11040:FF:000007', NULL, NULL, 'RNA cytidine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(70048, NULL, 'G3DSA:2.60.220.30:FF:000001', NULL, NULL, 'Ankyrin-3 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(70049, NULL, 'G3DSA:3.40.50.150:FF:000103', NULL, NULL, 'SABATH methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(70050, NULL, 'G3DSA:3.30.70.2820:FF:000001', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(70051, NULL, 'G3DSA:2.60.40.60:FF:000180', NULL, NULL, 'FAT atypical cadherin 4', NULL, NULL, NULL, NULL, NULL, 4),
(70052, NULL, 'G3DSA:2.60.40.10:FF:005330', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70053, NULL, 'G3DSA:3.30.30.30:FF:000012', NULL, NULL, 'Heat shock 70 kDa protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(70054, NULL, 'G3DSA:3.40.50.1010:FF:000259', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70055, NULL, 'G3DSA:2.40.70.10:FF:000437', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70056, NULL, 'G3DSA:1.25.40.10:FF:005161', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(70057, NULL, 'G3DSA:1.10.268.10:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70058, NULL, 'G3DSA:1.10.10.10:FF:000510', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(70059, NULL, 'G3DSA:1.20.58.60:FF:000073', NULL, NULL, 'Nesprin-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(70060, NULL, 'G3DSA:3.40.50.450:FF:000042', NULL, NULL, '6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(70061, NULL, 'G3DSA:3.30.200.20:FF:000230', NULL, NULL, 'Eukaryotic elongation factor 2 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(70062, NULL, 'G3DSA:1.10.510.10:FF:003972', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70063, NULL, 'G3DSA:2.130.10.10:FF:003329', NULL, NULL, 'YALI0C23386p', NULL, NULL, NULL, NULL, NULL, 4),
(70064, NULL, 'G3DSA:3.10.290.60:FF:000010', NULL, NULL, 'Ubiquitin-like modifier-activating enzyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(70065, NULL, 'G3DSA:3.40.50.2300:FF:000281', NULL, NULL, 'Metabotropic glutamate receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(70066, NULL, 'G3DSA:3.80.10.10:FF:002599', NULL, NULL, 'Vasorin a', NULL, NULL, NULL, NULL, NULL, 4),
(70067, NULL, 'G3DSA:3.30.160.60:FF:002020', NULL, NULL, 'Odd skipped', NULL, NULL, NULL, NULL, NULL, 4),
(70068, NULL, 'G3DSA:3.50.50.60:FF:000341', NULL, NULL, 'Baeyer-Villiger monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(70069, NULL, 'G3DSA:3.30.160.60:FF:002284', NULL, NULL, 'Zinc finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70070, NULL, 'G3DSA:1.25.40.10:FF:001827', NULL, NULL, 'Os02g0167200 protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(70071, NULL, 'G3DSA:2.10.25.10:FF:000345', NULL, NULL, 'Pro-epidermal growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(70072, NULL, 'G3DSA:3.40.30.10:FF:001146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70073, NULL, 'G3DSA:1.20.930.80:FF:000009', NULL, NULL, 'DNA primase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(70074, NULL, 'G3DSA:1.25.40.10:FF:005189', NULL, NULL, 'Tetratricopeptide repeat protein 21B-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(70075, NULL, 'G3DSA:3.10.100.10:FF:000235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70076, NULL, 'G3DSA:1.10.10.10:FF:000690', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(70077, NULL, 'G3DSA:1.10.10.60:FF:001109', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70078, NULL, 'G3DSA:2.30.30.100:FF:000220', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(70079, NULL, 'G3DSA:2.20.100.10:FF:000248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70080, NULL, 'G3DSA:2.150.10.10:FF:000001', NULL, NULL, 'Serralysin', NULL, NULL, NULL, NULL, NULL, 4),
(70081, NULL, 'G3DSA:3.20.20.70:FF:000260', NULL, NULL, 'Quinate repressor protein', NULL, NULL, NULL, NULL, NULL, 4),
(70082, NULL, 'G3DSA:2.60.40.10:FF:001699', NULL, NULL, 'Serine peptidase inhibitor, Kunitz type 1', NULL, NULL, NULL, NULL, NULL, 4),
(70083, NULL, 'G3DSA:3.30.40.10:FF:001552', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(70084, NULL, 'G3DSA:1.20.1250.20:FF:001102', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70085, NULL, 'G3DSA:3.90.550.10:FF:000054', NULL, NULL, 'UDP-glucose:glycoprotein glucosyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(70086, NULL, 'G3DSA:3.30.1120.90:FF:000007', NULL, NULL, 'NAP1-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(70087, NULL, 'G3DSA:1.20.930.60:FF:000003', NULL, NULL, 'DUF89-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(70088, NULL, 'G3DSA:1.10.10.10:FF:001027', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(70089, NULL, 'G3DSA:1.10.10.10:FF:000538', NULL, NULL, 'Checkpoint suppressor homologue', NULL, NULL, NULL, NULL, NULL, 4),
(70090, NULL, 'G3DSA:1.10.472.10:FF:000201', NULL, NULL, 'Cyclin pch1', NULL, NULL, NULL, NULL, NULL, 4),
(70091, NULL, 'G3DSA:1.10.720.30:FF:000026', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(70092, NULL, 'G3DSA:1.10.630.10:FF:000221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70093, NULL, 'G3DSA:1.10.510.10:FF:004489', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70094, NULL, 'G3DSA:3.10.580.10:FF:000203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70095, NULL, 'G3DSA:1.10.10.41:FF:000003', NULL, NULL, 'DNA topoisomerase I, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(70096, NULL, 'G3DSA:1.20.120.1240:FF:000032', NULL, NULL, 'Dynamin-1 family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70097, NULL, 'G3DSA:3.30.160.60:FF:000075', NULL, NULL, 'Putative zinc finger protein 536', NULL, NULL, NULL, NULL, NULL, 4),
(70098, NULL, 'G3DSA:3.30.70.80:FF:000012', NULL, NULL, 'Os01g0795400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(70099, NULL, 'G3DSA:1.10.3810.10:FF:000026', NULL, NULL, 'Penicillin-binding protein, class 1A', NULL, NULL, NULL, NULL, NULL, 4),
(70100, NULL, 'G3DSA:3.90.470.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70101, NULL, 'G3DSA:2.40.50.120:FF:000042', NULL, NULL, 'uncharacterized protein YBL113C-like', NULL, NULL, NULL, NULL, NULL, 4),
(70102, NULL, 'G3DSA:1.20.940.10:FF:000006', NULL, NULL, 'steroid receptor RNA activator 1', NULL, NULL, NULL, NULL, NULL, 4),
(70103, NULL, 'G3DSA:1.20.1310.10:FF:000227', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70104, NULL, 'G3DSA:1.10.600.10:FF:000101', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(70105, NULL, 'G3DSA:3.90.550.50:FF:000190', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(70106, NULL, 'G3DSA:1.50.10.10:FF:000126', NULL, NULL, 'Phosphorylase b kinase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(70107, NULL, 'G3DSA:1.20.50.30:FF:000001', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(70108, NULL, 'G3DSA:2.60.40.1530:FF:000001', NULL, NULL, 'Integrin subunit alpha 7', NULL, NULL, NULL, NULL, NULL, 4),
(70109, NULL, 'G3DSA:2.40.240.50:FF:000001', NULL, NULL, 'Membrane-bound lytic murein transglycosylase A', NULL, NULL, NULL, NULL, NULL, 4),
(70110, NULL, 'G3DSA:1.20.810.10:FF:000002', NULL, NULL, 'Cytochrome b', NULL, NULL, NULL, NULL, NULL, 4),
(70111, NULL, 'G3DSA:3.40.50.300:FF:001273', NULL, NULL, 'Aliphatic sulfonates import ATP-binding protein SsuB', NULL, NULL, NULL, NULL, NULL, 4),
(70112, NULL, 'G3DSA:2.130.10.10:FF:002992', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70113, NULL, 'G3DSA:2.30.30.1190:FF:000006', NULL, NULL, 'Zinc finger CCCH domain-containing protein 58', NULL, NULL, NULL, NULL, NULL, 4),
(70114, NULL, 'G3DSA:3.30.450.20:FF:000097', NULL, NULL, 'Aryl hydrocarbon receptor repressor', NULL, NULL, NULL, NULL, NULL, 4),
(70115, NULL, 'G3DSA:1.20.1050.10:FF:000128', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(70116, NULL, 'G3DSA:2.30.30.40:FF:000528', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(70117, NULL, 'G3DSA:2.30.42.10:FF:000120', NULL, NULL, 'Ligand of numb-protein X 2', NULL, NULL, NULL, NULL, NULL, 4),
(70118, NULL, 'G3DSA:2.30.30.190:FF:000027', NULL, NULL, 'Similar to tubulin-specific chaperone E', NULL, NULL, NULL, NULL, NULL, 4),
(70119, NULL, 'G3DSA:3.40.50.1240:FF:000098', NULL, NULL, 'Phytase', NULL, NULL, NULL, NULL, NULL, 4),
(70120, NULL, 'G3DSA:4.10.60.10:FF:000219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70121, NULL, 'G3DSA:3.20.20.70:FF:000321', NULL, NULL, 'tRNA-dihydrouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(70122, NULL, 'G3DSA:3.40.50.12710:FF:000014', NULL, NULL, 'Class I SAM-dependent methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(70123, NULL, 'G3DSA:2.30.29.30:FF:000134', NULL, NULL, 'Putative FERM domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(70124, NULL, 'G3DSA:3.40.50.10130:FF:000010', NULL, NULL, 'Crossover junction endonuclease eme1', NULL, NULL, NULL, NULL, NULL, 4),
(70125, NULL, 'G3DSA:2.30.30.40:FF:000472', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70126, NULL, 'G3DSA:3.30.160.60:FF:001295', NULL, NULL, 'Zinc finger and BTB domain containing 47', NULL, NULL, NULL, NULL, NULL, 4),
(70127, NULL, 'G3DSA:4.10.860.10:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70128, NULL, 'G3DSA:3.40.50.300:FF:002262', NULL, NULL, 'Translation initiation factor IF-2', NULL, NULL, NULL, NULL, NULL, 4),
(70129, NULL, 'G3DSA:3.40.1280.30:FF:000010', NULL, NULL, 'Protein CBG14899', NULL, NULL, NULL, NULL, NULL, 4),
(70130, NULL, 'G3DSA:3.40.390.10:FF:000305', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70131, NULL, 'G3DSA:2.30.42.10:FF:000592', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70132, NULL, 'G3DSA:3.40.30.10:FF:000365', NULL, NULL, 'Phosducin-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(70133, NULL, 'G3DSA:1.20.1250.20:FF:000293', NULL, NULL, 'Inner membrane protein YqcE', NULL, NULL, NULL, NULL, NULL, 4),
(70134, NULL, 'G3DSA:3.30.470.20:FF:000160', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(70135, NULL, 'G3DSA:3.80.10.10:FF:003616', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(70136, NULL, 'G3DSA:3.40.630.30:FF:000499', NULL, NULL, 'Beta-N-acetylglucosaminidase, putative (AFU_orthologue AFUA_3G11780)', NULL, NULL, NULL, NULL, NULL, 4),
(70137, NULL, 'G3DSA:3.40.50.1220:FF:000092', NULL, NULL, 'DHS-like NAD/FAD-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(70138, NULL, 'G3DSA:2.60.40.60:FF:000680', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70139, NULL, 'G3DSA:2.40.10.170:FF:000015', NULL, NULL, 'ATP-dependent DNA helicase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(70140, NULL, 'G3DSA:1.10.490.160:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70141, NULL, 'G3DSA:3.40.50.620:FF:000587', NULL, NULL, 'Arginyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70142, NULL, 'G3DSA:2.10.25.10:FF:001626', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70143, NULL, 'G3DSA:2.10.220.10:FF:000220', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 4, furin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70144, NULL, 'G3DSA:2.60.120.260:FF:000614', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(70145, NULL, 'G3DSA:3.40.50.300:FF:005488', NULL, NULL, 'ATP-dependent DNA helicase tlh2', NULL, NULL, NULL, NULL, NULL, 4),
(70146, NULL, 'G3DSA:3.30.70.330:FF:001759', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70147, NULL, 'G3DSA:1.10.10.10:FF:000010', NULL, NULL, 'Forkhead box P2 isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(70148, NULL, 'G3DSA:2.130.10.10:FF:000783', NULL, NULL, 'WD repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(70149, NULL, 'G3DSA:3.10.20.90:FF:000468', NULL, NULL, 'Autophagy protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(70150, NULL, 'G3DSA:1.10.10.2420:FF:000004', NULL, NULL, 'Glutamine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(70151, NULL, 'G3DSA:1.10.287.130:FF:000144', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(70152, NULL, 'G3DSA:2.60.450.20:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70153, NULL, 'G3DSA:2.10.25.10:FF:000492', NULL, NULL, 'agrin isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(70154, NULL, 'G3DSA:3.90.660.10:FF:000028', NULL, NULL, 'Flavin containing amine oxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70155, NULL, 'G3DSA:3.90.1150.10:FF:000287', NULL, NULL, 'Nucleotide-sugar aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(70156, NULL, 'G3DSA:3.40.630.10:FF:000493', NULL, NULL, 'Clan MH, family M18, aspartyl aminopeptidase-like metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(70157, NULL, 'G3DSA:2.20.70.10:FF:000191', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(70158, NULL, 'G3DSA:3.30.300.30:FF:000004', NULL, NULL, 'Acetyl-coenzyme A synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(70159, NULL, 'G3DSA:1.10.10.10:FF:000482', NULL, NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(70160, NULL, 'G3DSA:3.10.350.10:FF:000074', NULL, NULL, 'Putative lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(70161, NULL, 'G3DSA:3.40.50.720:FF:000319', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(70162, NULL, 'G3DSA:1.20.144.10:FF:000145', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(70163, NULL, 'G3DSA:1.10.510.10:FF:003472', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70164, NULL, 'G3DSA:3.40.50.300:FF:006477', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70165, NULL, 'G3DSA:3.30.70.360:FF:000049', NULL, NULL, 'Acetylornithine deacetylase/Succinyl-diaminopimelate desuccinylase', NULL, NULL, NULL, NULL, NULL, 4),
(70166, NULL, 'G3DSA:2.160.20.10:FF:000125', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(70167, NULL, 'G3DSA:3.30.60.90:FF:000043', NULL, NULL, 'SeQueSTosome related', NULL, NULL, NULL, NULL, NULL, 4),
(70168, NULL, 'G3DSA:1.25.40.10:FF:004380', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70169, NULL, 'G3DSA:2.40.50.140:FF:001037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70170, NULL, 'G3DSA:6.10.140.2220:FF:000001', NULL, NULL, 'CBFA2/RUNX1 translocation partner 3', NULL, NULL, NULL, NULL, NULL, 4),
(70171, NULL, 'G3DSA:3.30.210.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(70172, NULL, 'G3DSA:3.30.830.10:FF:000078', NULL, NULL, 'Putative insulinase', NULL, NULL, NULL, NULL, NULL, 4),
(70173, NULL, 'G3DSA:2.10.110.10:FF:000127', NULL, NULL, 'LIM domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(70174, NULL, 'G3DSA:3.40.50.2300:FF:000073', NULL, NULL, 'DNA-binding response regulator RprY', NULL, NULL, NULL, NULL, NULL, 4),
(70175, NULL, 'G3DSA:1.25.40.20:FF:001095', NULL, NULL, 'Serine/threonine-protein kinase NEK', NULL, NULL, NULL, NULL, NULL, 4),
(70176, NULL, 'G3DSA:3.40.50.720:FF:001308', NULL, NULL, 'UDP-galactopyranose mutase', NULL, NULL, NULL, NULL, NULL, 4),
(70177, NULL, 'G3DSA:3.30.200.20:FF:002467', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(70178, NULL, 'G3DSA:2.60.40.10:FF:005561', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70179, NULL, 'G3DSA:1.20.1530.20:FF:000067', NULL, NULL, 'Cation/H(+) antiporter 15', NULL, NULL, NULL, NULL, NULL, 4),
(70180, NULL, 'G3DSA:2.60.40.10:FF:002424', NULL, NULL, 'Protein CBG19196', NULL, NULL, NULL, NULL, NULL, 4),
(70181, NULL, 'G3DSA:1.20.272.10:FF:000083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70182, NULL, 'G3DSA:1.20.80.10:FF:000082', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(70183, NULL, 'G3DSA:2.130.10.10:FF:002492', NULL, NULL, 'Histidine kinase/response regulator hybrid protein', NULL, NULL, NULL, NULL, NULL, 4),
(70184, NULL, 'G3DSA:2.60.120.970:FF:000114', NULL, NULL, 'Glass bottom boat2', NULL, NULL, NULL, NULL, NULL, 4),
(70185, NULL, 'G3DSA:3.10.100.10:FF:000027', NULL, NULL, 'Mannose receptor, C type 1', NULL, NULL, NULL, NULL, NULL, 4),
(70186, NULL, 'G3DSA:2.130.10.10:FF:002020', NULL, NULL, 'Autophagic-related protein 16.1', NULL, NULL, NULL, NULL, NULL, 4),
(70187, NULL, 'G3DSA:3.30.40.10:FF:001052', NULL, NULL, 'TNF receptor-associated factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(70188, NULL, 'G3DSA:1.25.40.10:FF:001619', NULL, NULL, 'Stress-induced-phosphoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(70189, NULL, 'G3DSA:1.25.40.530:FF:000006', NULL, NULL, 'MYO7B isoform 7', NULL, NULL, NULL, NULL, NULL, 4),
(70190, NULL, 'G3DSA:1.10.357.20:FF:000015', NULL, NULL, 'Solute carrier family 41 member 1', NULL, NULL, NULL, NULL, NULL, 4),
(70191, NULL, 'G3DSA:2.60.40.10:FF:001435', NULL, NULL, 'Immunoglobulin-like and fibronectin type III domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(70192, NULL, 'G3DSA:1.20.960.50:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70193, NULL, 'G3DSA:3.30.70.330:FF:002715', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70194, NULL, 'G3DSA:3.40.225.10:FF:000023', NULL, NULL, 'Fuculose phosphate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(70195, NULL, 'G3DSA:2.40.10.10:FF:000372', NULL, NULL, 'Myeloblastin', NULL, NULL, NULL, NULL, NULL, 4),
(70196, NULL, 'G3DSA:1.25.40.10:FF:003391', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(70197, NULL, 'G3DSA:3.30.160.60:FF:005246', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70198, NULL, 'G3DSA:3.40.910.10:FF:000003', NULL, NULL, 'Deoxyhypusine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(70199, NULL, 'G3DSA:3.40.50.300:FF:007197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70200, NULL, 'G3DSA:1.25.40.20:FF:000728', NULL, NULL, 'Tumor protein p53-binding protein, 2b', NULL, NULL, NULL, NULL, NULL, 4),
(70201, NULL, 'G3DSA:2.60.40.1730:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70202, NULL, 'G3DSA:3.50.30.10:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70203, NULL, 'G3DSA:1.20.1270.280:FF:000047', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(70204, NULL, 'G3DSA:1.10.510.10:FF:000919', NULL, NULL, 'NPR1p Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(70205, NULL, 'G3DSA:3.60.21.10:FF:000220', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(70206, NULL, 'G3DSA:3.30.420.10:FF:000120', NULL, NULL, 'Poly(A)-specific ribonuclease PARN', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(70207, NULL, 'G3DSA:2.10.50.10:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70208, NULL, 'G3DSA:3.30.930.10:FF:000142', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(70209, NULL, 'G3DSA:2.160.20.70:FF:000036', NULL, NULL, 'Tubulin-specific chaperone C', NULL, NULL, NULL, NULL, NULL, 4),
(70210, NULL, 'G3DSA:2.30.30.100:FF:000012', NULL, NULL, 'RNA-binding protein Hfq', NULL, NULL, NULL, NULL, NULL, 4),
(70211, NULL, 'G3DSA:3.30.160.60:FF:005190', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70212, NULL, 'G3DSA:3.90.150.10:FF:000006', NULL, NULL, 'Variant surface glycoprotein (VSG), putative', NULL, NULL, NULL, NULL, NULL, 4),
(70213, NULL, 'G3DSA:1.10.8.50:FF:000015', NULL, NULL, '30S ribosomal protein-like protein S13', NULL, NULL, NULL, NULL, NULL, 4),
(70214, NULL, 'G3DSA:1.10.510.10:FF:003528', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70215, NULL, 'G3DSA:1.10.8.1220:FF:000015', NULL, NULL, 'Dynein heavy chain 6, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(70216, NULL, 'G3DSA:1.10.540.10:FF:000130', NULL, NULL, 'Cyclohexane-1-carbonyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(70217, NULL, 'G3DSA:3.40.50.300:FF:003690', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(70218, NULL, 'G3DSA:2.60.40.650:FF:000003', NULL, NULL, 'Sulfite oxidase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(70219, NULL, 'G3DSA:3.30.750.24:FF:000028', NULL, NULL, 'Sulfate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70220, NULL, 'G3DSA:3.30.160.60:FF:006027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70221, NULL, 'G3DSA:3.30.70.270:FF:000319', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70222, NULL, 'G3DSA:1.10.150.110:FF:000026', NULL, NULL, 'Crossover junction endonuclease MUS81', NULL, NULL, NULL, NULL, NULL, 4),
(70223, NULL, 'G3DSA:4.10.80.100:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70224, NULL, 'G3DSA:1.25.10.10:FF:002635', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70225, NULL, 'G3DSA:1.20.120.20:FF:000003', NULL, NULL, 'Apolipoprotein E', NULL, NULL, NULL, NULL, NULL, 4),
(70226, NULL, 'G3DSA:3.90.230.10:FF:000007', NULL, NULL, 'Xaa-Pro aminopeptidase P', NULL, NULL, NULL, NULL, NULL, 4),
(70227, NULL, 'G3DSA:1.10.472.100:FF:000001', NULL, NULL, 'Presenilin', NULL, NULL, NULL, NULL, NULL, 4),
(70228, NULL, 'G3DSA:3.60.10.10:FF:000200', NULL, NULL, 'Endonuclease/exonuclease/phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(70229, NULL, 'G3DSA:1.25.10.10:FF:001207', NULL, NULL, 'HEAT-like_repeat_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(70230, NULL, 'G3DSA:1.10.533.10:FF:000282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70231, NULL, 'G3DSA:3.30.160.60:FF:002637', NULL, NULL, 'Zinc finger protein 732', NULL, NULL, NULL, NULL, NULL, 4),
(70232, NULL, 'G3DSA:3.30.40.10:FF:000271', NULL, NULL, 'helicase-like transcription factor isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(70233, NULL, 'G3DSA:1.10.287.3240:FF:000027', NULL, NULL, 'V-type ATP synthase subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(70234, NULL, 'G3DSA:3.30.70.120:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70235, NULL, 'G3DSA:2.20.100.10:FF:000017', NULL, NULL, 'Thrombospondin type 1 domain containing 7A', NULL, NULL, NULL, NULL, NULL, 4),
(70236, NULL, 'G3DSA:3.40.30.10:FF:000157', NULL, NULL, 'DOT5p Nuclear thiol peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(70237, NULL, 'G3DSA:3.10.20.90:FF:000732', NULL, NULL, 'NAD(P)(+)--arginine ADP-ribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(70238, NULL, 'G3DSA:1.10.287.70:FF:000064', NULL, NULL, 'Glutamate receptor ionotropic, kainate', NULL, NULL, NULL, NULL, NULL, 4),
(70239, NULL, 'G3DSA:3.30.200.20:FF:002236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70240, NULL, 'G3DSA:1.10.150.20:FF:000029', NULL, NULL, 'DNA repair protein RAD51 homolog', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(70241, NULL, 'G3DSA:2.60.40.10:FF:000007', NULL, NULL, 'Filamin-B isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(70242, NULL, 'G3DSA:1.20.58.60:FF:000218', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(70243, NULL, 'G3DSA:1.25.40.20:FF:000959', NULL, NULL, 'transient receptor potential cation channel subfamily V member 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(70244, NULL, 'G3DSA:3.10.450.40:FF:000034', NULL, NULL, 'DCL protein', NULL, NULL, NULL, NULL, NULL, 4),
(70245, NULL, 'G3DSA:3.60.20.10:FF:000049', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(70246, NULL, 'G3DSA:3.40.50.300:FF:002054', NULL, NULL, 'DNA mismatch repair protein MSH4', NULL, NULL, NULL, NULL, NULL, 4),
(70247, NULL, 'G3DSA:3.10.105.10:FF:000111', NULL, NULL, 'ABC-type transport system periplasmic substrate-binding protein (Probable substrate dipeptide/oligopeptide)', NULL, NULL, NULL, NULL, NULL, 4),
(70248, NULL, 'G3DSA:2.60.40.10:FF:000479', NULL, NULL, 'Vascular endothelial growth factor receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(70249, NULL, 'G3DSA:3.40.50.620:FF:000323', NULL, NULL, 'tRNA-specific 2-thiouridylase MnmA', NULL, NULL, NULL, NULL, NULL, 4),
(70250, NULL, 'G3DSA:3.30.300.180:FF:000008', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(70251, NULL, 'G3DSA:2.60.120.10:FF:000459', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70252, NULL, 'G3DSA:1.20.900.10:FF:000032', NULL, NULL, 'rho guanine nucleotide exchange factor 38', NULL, NULL, NULL, NULL, NULL, 4),
(70253, NULL, 'G3DSA:3.30.930.10:FF:000350', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70254, NULL, 'G3DSA:3.30.450.20:FF:000361', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(70255, NULL, 'G3DSA:3.30.1370.10:FF:000188', NULL, NULL, 'Protein CBG16603', NULL, NULL, NULL, NULL, NULL, 4),
(70256, NULL, 'G3DSA:3.90.320.10:FF:000037', NULL, NULL, 'Putative helicase 2', NULL, NULL, NULL, NULL, NULL, 4),
(70257, NULL, 'G3DSA:3.40.50.620:FF:000907', NULL, NULL, 'Isoleucine--tRNA ligase chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(70258, NULL, 'G3DSA:3.80.10.10:FF:000070', NULL, NULL, 'Centrosomal protein of 78 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(70259, NULL, 'G3DSA:3.30.2230.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70260, NULL, 'G3DSA:3.40.50.300:FF:000429', NULL, NULL, 'Preprotein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(70261, NULL, 'G3DSA:3.30.70.270:FF:000174', NULL, NULL, 'DNA polymerase kappa', NULL, NULL, NULL, NULL, NULL, 4),
(70262, NULL, 'G3DSA:3.30.420.10:FF:000384', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70263, NULL, 'G3DSA:1.10.238.10:FF:001158', NULL, NULL, 'rab11 family-interacting protein 3-like', NULL, NULL, NULL, NULL, NULL, 4),
(70264, NULL, 'G3DSA:2.60.40.150:FF:000387', NULL, NULL, 'PI-3 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(70265, NULL, 'G3DSA:3.50.30.30:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70266, NULL, 'G3DSA:1.25.40.10:FF:001035', NULL, NULL, 'Selenium-binding protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(70267, NULL, 'G3DSA:2.60.120.10:FF:000370', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(70268, NULL, 'G3DSA:3.30.450.70:FF:000004', NULL, NULL, 'Trafficking protein particle complex 1', NULL, NULL, NULL, NULL, NULL, 4),
(70269, NULL, 'G3DSA:3.30.160.60:FF:000103', NULL, NULL, 'FEZ family zinc finger 1', NULL, NULL, NULL, NULL, NULL, 4),
(70270, NULL, 'G3DSA:1.20.120.720:FF:000004', NULL, NULL, 'unconventional myosin-Ib isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(70271, NULL, 'G3DSA:3.90.740.10:FF:000029', NULL, NULL, 'Mitochondrial isoleucyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(70272, NULL, 'G3DSA:1.25.40.10:FF:004172', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(70273, NULL, 'G3DSA:3.80.10.10:FF:002627', NULL, NULL, 'Putative RAN GTPase activating family protein', NULL, NULL, NULL, NULL, NULL, 4),
(70274, NULL, 'G3DSA:2.30.30.550:FF:000006', NULL, NULL, 'Major vault protein beta', NULL, NULL, NULL, NULL, NULL, 4),
(70275, NULL, 'G3DSA:1.10.357.140:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70276, NULL, 'G3DSA:3.40.1190.20:FF:000146', NULL, NULL, 'Ribokinase', NULL, NULL, NULL, NULL, NULL, 4),
(70277, NULL, 'G3DSA:3.30.420.40:FF:000488', NULL, NULL, 'Chaperone protein DNAK, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70278, NULL, 'G3DSA:2.60.120.330:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70279, NULL, 'G3DSA:3.80.10.10:FF:004336', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70280, NULL, 'G3DSA:2.60.40.10:FF:002216', NULL, NULL, 'Paired immunoglobulin-like receptor B', NULL, NULL, NULL, NULL, NULL, 4),
(70281, NULL, 'G3DSA:2.130.10.10:FF:001300', NULL, NULL, 'U4/U6 small nuclear ribonucleoprotein Prp4', NULL, NULL, NULL, NULL, NULL, 4),
(70282, NULL, 'G3DSA:1.20.1250.20:FF:001074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70283, NULL, 'G3DSA:3.40.109.10:FF:000012', NULL, NULL, 'Nitroreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(70284, NULL, 'G3DSA:3.40.50.2000:FF:000573', NULL, NULL, 'Glycosyltransferase WbuB', NULL, NULL, NULL, NULL, NULL, 4),
(70285, NULL, 'G3DSA:3.50.50.60:FF:000780', NULL, NULL, 'Fumarate reductase flavoprotein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(70286, NULL, 'G3DSA:2.30.29.30:FF:000365', NULL, NULL, 'Related to CDC24-GTP/GDP exchange factor for Cdc42p', NULL, NULL, NULL, NULL, NULL, 4),
(70287, NULL, 'G3DSA:2.60.40.1120:FF:000029', NULL, NULL, 'Carboxypeptidase D, b', NULL, NULL, NULL, NULL, NULL, 4),
(70288, NULL, 'G3DSA:1.25.40.1040:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70289, NULL, 'G3DSA:3.40.50.2060:FF:000012', NULL, NULL, 'Syntaxin binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70290, NULL, 'G3DSA:1.25.40.430:FF:000010', NULL, NULL, 'BUB1 mitotic checkpoint serine/threonine kinase Bb', NULL, NULL, NULL, NULL, NULL, 4),
(70291, NULL, 'G3DSA:3.30.70.330:FF:002923', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70292, NULL, 'G3DSA:3.80.10.10:FF:000593', NULL, NULL, 'Tubulin-specific chaperone E', NULL, NULL, NULL, NULL, NULL, 4),
(70293, NULL, 'G3DSA:3.90.226.10:FF:000109', NULL, NULL, 'Enoyl-CoA hydratase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70294, NULL, 'G3DSA:1.10.630.10:FF:000513', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70295, NULL, 'G3DSA:3.40.190.10:FF:000088', NULL, NULL, 'HTH-type transcriptional regulator LeuO', NULL, NULL, NULL, NULL, NULL, 4),
(70296, NULL, 'G3DSA:2.130.10.10:FF:002548', NULL, NULL, 'QUInine non-avoider', NULL, NULL, NULL, NULL, NULL, 4),
(70297, NULL, 'G3DSA:3.30.40.10:FF:001260', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(70298, NULL, 'G3DSA:1.25.40.10:FF:002547', NULL, NULL, 'Os05g0574800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(70299, NULL, 'G3DSA:3.40.50.1000:FF:000582', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70300, NULL, 'G3DSA:3.30.160.60:FF:000928', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70301, NULL, 'G3DSA:3.80.10.10:FF:001851', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(70302, NULL, 'G3DSA:3.40.50.300:FF:000929', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(70303, NULL, 'G3DSA:3.30.450.20:FF:000422', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(70304, NULL, 'G3DSA:1.10.238.10:FF:000702', NULL, NULL, 'Reticulocalbin 3, EF-hand calcium-binding domain', NULL, NULL, NULL, NULL, NULL, 4),
(70305, NULL, 'G3DSA:1.20.1540.10:FF:000036', NULL, NULL, 'Rhomboid family serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(70306, NULL, 'G3DSA:1.25.40.120:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(70307, NULL, 'G3DSA:1.10.510.10:FF:003680', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70308, NULL, 'G3DSA:2.102.10.10:FF:000021', NULL, NULL, 'Ferredoxin, Rieske superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(70309, NULL, 'G3DSA:3.30.160.60:FF:005038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70310, NULL, 'G3DSA:3.50.50.60:FF:001297', NULL, NULL, 'Dihydrolipoyl dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(70311, NULL, 'G3DSA:3.40.50.300:FF:005808', NULL, NULL, 'Hydin', NULL, NULL, NULL, NULL, NULL, 4),
(70312, NULL, 'G3DSA:1.20.120.980:FF:000003', NULL, NULL, 'Serine protease 16', NULL, NULL, NULL, NULL, NULL, 4),
(70313, NULL, 'G3DSA:3.40.1110.10:FF:000217', NULL, NULL, 'Cation transporter P-type ATPase A', NULL, NULL, NULL, NULL, NULL, 4),
(70314, NULL, 'G3DSA:3.40.1550.10:FF:000008', NULL, NULL, 'Chemotaxis operon protein', NULL, NULL, NULL, NULL, NULL, 4),
(70315, NULL, 'G3DSA:3.40.50.720:FF:000471', NULL, NULL, 'epimerase family protein SDR39U1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(70316, NULL, 'G3DSA:3.40.190.10:FF:000796', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(70317, NULL, 'G3DSA:3.90.148.10:FF:000001', NULL, NULL, 'DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(70318, NULL, 'G3DSA:1.10.730.10:FF:000077', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(70319, NULL, 'G3DSA:3.90.70.10:FF:000197', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 17-like protein E', NULL, NULL, NULL, NULL, NULL, 4),
(70320, NULL, 'G3DSA:1.20.920.10:FF:000095', NULL, NULL, 'PolyBRoMo domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(70321, NULL, 'G3DSA:1.50.40.10:FF:000538', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70322, NULL, 'G3DSA:2.70.98.10:FF:000078', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(70323, NULL, 'G3DSA:1.10.10.10:FF:001258', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(70324, NULL, 'G3DSA:2.60.120.200:FF:000703', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70325, NULL, 'G3DSA:3.90.228.10:FF:000002', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(70326, NULL, 'G3DSA:1.20.120.420:FF:000004', NULL, NULL, 'Methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(70327, NULL, 'G3DSA:3.40.50.300:FF:004824', NULL, NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily-related, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70328, NULL, 'G3DSA:2.20.70.10:FF:000039', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(70329, NULL, 'G3DSA:3.30.70.960:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70330, NULL, 'G3DSA:1.20.1110.10:FF:000015', NULL, NULL, 'Sodium ion P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(70331, NULL, 'G3DSA:2.130.10.10:FF:004173', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(70332, NULL, 'G3DSA:3.90.640.10:FF:000084', NULL, NULL, 'Related to ARP5-Actin-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(70333, NULL, 'G3DSA:2.60.40.10:FF:000979', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', NULL, NULL, NULL, NULL, NULL, 4),
(70334, NULL, 'G3DSA:2.10.25.10:FF:000637', NULL, NULL, 'Weary, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(70335, NULL, 'G3DSA:1.10.510.10:FF:004197', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70336, NULL, 'G3DSA:3.40.50.300:FF:007433', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(70337, NULL, 'G3DSA:3.90.226.10:FF:000020', NULL, NULL, 'ATP-dependent Clp protease proteolytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(70338, NULL, 'G3DSA:1.10.3720.10:FF:000199', NULL, NULL, 'ABC-type peptide uptake system permease component 1 SapB', NULL, NULL, NULL, NULL, NULL, 4),
(70339, NULL, 'G3DSA:2.10.110.10:FF:000071', NULL, NULL, 'nebulin-related-anchoring protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(70340, NULL, 'G3DSA:3.10.310.10:FF:000009', NULL, NULL, 'Diaminopimelate epimerase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(70341, NULL, 'G3DSA:3.30.1490.40:FF:000003', NULL, NULL, 'Zinc finger CCCH domain-containing protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(70342, NULL, 'G3DSA:3.40.50.720:FF:001960', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70343, NULL, 'G3DSA:3.40.720.10:FF:000320', NULL, NULL, 'Arylsulfatase G', NULL, NULL, NULL, NULL, NULL, 4),
(70344, NULL, 'G3DSA:1.10.8.10:FF:000262', NULL, NULL, 'Similar to putative TRAF and TNF receptor associated protein, isoform CRA_c', NULL, NULL, NULL, NULL, NULL, 4),
(70345, NULL, 'G3DSA:3.10.20.90:FF:000940', NULL, NULL, 'U-box domain-containing protein 57', NULL, NULL, NULL, NULL, NULL, 4),
(70346, NULL, 'G3DSA:3.90.70.10:FF:000461', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(70347, NULL, 'G3DSA:3.30.2160.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70348, NULL, 'G3DSA:1.20.58.60:FF:000573', NULL, NULL, 'Plectin', NULL, NULL, NULL, NULL, NULL, 4),
(70349, NULL, 'G3DSA:1.10.287.70:FF:000564', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70350, NULL, 'G3DSA:3.40.710.10:FF:000106', NULL, NULL, 'Penicillin-binding protein 2X', NULL, NULL, NULL, NULL, NULL, 4),
(70351, NULL, 'G3DSA:1.10.30.10:FF:000129', NULL, NULL, 'High mobility group-T protein', NULL, NULL, NULL, NULL, NULL, 4),
(70352, NULL, 'G3DSA:3.20.20.190:FF:000153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70353, NULL, 'G3DSA:3.40.570.10:FF:000050', NULL, NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase 3', NULL, NULL, NULL, NULL, NULL, 4),
(70354, NULL, 'G3DSA:1.25.10.10:FF:002135', NULL, NULL, 'V-type proton ATPase subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(70355, NULL, 'G3DSA:3.40.50.300:FF:001334', NULL, NULL, 'ATP-dependent DNA helicase Q-like 5', NULL, NULL, NULL, NULL, NULL, 4),
(70356, NULL, 'G3DSA:1.10.3380.30:FF:000021', NULL, NULL, 'SKI (Yeast SuperKIller) Helicase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(70357, NULL, 'G3DSA:3.40.50.2300:FF:000781', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70358, NULL, 'G3DSA:3.30.565.10:FF:000562', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70359, NULL, 'G3DSA:2.40.50.140:FF:000109', NULL, NULL, 'AAA ATPase forming ring-shaped complexes', NULL, NULL, NULL, NULL, NULL, 4),
(70360, NULL, 'G3DSA:2.130.10.10:FF:004757', NULL, NULL, 'Histone transcription regulator slm9', NULL, NULL, NULL, NULL, NULL, 4),
(70361, NULL, 'G3DSA:2.60.40.790:FF:000051', NULL, NULL, 'nudC domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(70362, NULL, 'G3DSA:1.25.10.10:FF:000954', NULL, NULL, 'Spindle pole body protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70363, NULL, 'G3DSA:3.30.70.330:FF:000978', NULL, NULL, 'UBP1-associated protein 2A', NULL, NULL, NULL, NULL, NULL, 4),
(70364, NULL, 'G3DSA:3.40.50.300:FF:004471', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(70365, NULL, 'G3DSA:3.40.1090.10:FF:000080', NULL, NULL, 'MGC108045 protein', NULL, NULL, NULL, NULL, NULL, 4),
(70366, NULL, 'G3DSA:1.10.3370.10:FF:000037', NULL, NULL, 'Os12g0612600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(70367, NULL, 'G3DSA:1.10.620.20:FF:000021', NULL, NULL, 'Ribonucleoside-diphosphate reductase small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(70368, NULL, 'G3DSA:2.60.40.10:FF:001199', NULL, NULL, 'B-cell receptor CD22', NULL, NULL, NULL, NULL, NULL, 4),
(70369, NULL, 'G3DSA:2.130.10.10:FF:001823', NULL, NULL, 'Tricorn protease', NULL, NULL, NULL, NULL, NULL, 4),
(70370, NULL, 'G3DSA:1.20.1310.10:FF:000199', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70371, NULL, 'G3DSA:3.10.110.10:FF:000264', NULL, NULL, 'Ubiquitin-conjugating enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(70372, NULL, 'G3DSA:1.25.40.10:FF:003452', NULL, NULL, 'AGAP000136-PA', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(70373, NULL, 'G3DSA:3.30.1310.10:FF:000004', NULL, NULL, 'Nucleoid-associated protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(70374, NULL, 'G3DSA:1.10.8.100:FF:000001', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(70375, NULL, 'G3DSA:2.60.120.200:FF:000642', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(70376, NULL, 'G3DSA:3.30.160.60:FF:004993', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70377, NULL, 'G3DSA:2.70.170.10:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70378, NULL, 'G3DSA:3.40.50.1820:FF:001457', NULL, NULL, 'Alpha/beta-Hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(70379, NULL, 'G3DSA:2.30.30.490:FF:000027', NULL, NULL, 'DNA (cytosine-5)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(70380, NULL, 'G3DSA:3.40.50.12650:FF:000035', NULL, NULL, 'ADR250Cp', NULL, NULL, NULL, NULL, NULL, 4),
(70381, NULL, 'G3DSA:1.10.510.10:FF:001263', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70382, NULL, 'G3DSA:4.10.60.10:FF:000158', NULL, NULL, 'RNA binding motif protein 4 [', NULL, NULL, NULL, NULL, NULL, 4),
(70383, NULL, 'G3DSA:3.90.1150.10:FF:000495', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70384, NULL, 'G3DSA:3.10.20.30:FF:000057', NULL, NULL, 'Threonine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(70385, NULL, 'G3DSA:1.25.40.20:FF:001156', NULL, NULL, 'L-asparaginase', NULL, NULL, NULL, NULL, NULL, 4),
(70386, NULL, 'G3DSA:3.30.559.30:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70387, NULL, 'G3DSA:3.40.50.300:FF:005752', NULL, NULL, 'Dicer-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(70388, NULL, 'G3DSA:3.40.50.150:FF:000042', NULL, NULL, '50S ribosomal protein L3 glutamine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(70389, NULL, 'G3DSA:3.10.450.50:FF:000008', NULL, NULL, '3-phenylpropionate/cinnamic acid dioxygenase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(70390, NULL, 'G3DSA:2.60.40.10:FF:004633', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70391, NULL, 'G3DSA:1.10.238.10:FF:000966', NULL, NULL, 'reticulocalbin-2-like', NULL, NULL, NULL, NULL, NULL, 4),
(70392, NULL, 'G3DSA:2.60.120.260:FF:000406', NULL, NULL, 'Beta-xylanase', NULL, NULL, NULL, NULL, NULL, 4),
(70393, NULL, 'G3DSA:3.30.450.20:FF:000158', NULL, NULL, 'Circadian locomoter output cycles protein kaput', NULL, NULL, NULL, NULL, NULL, 4),
(70394, NULL, 'G3DSA:1.20.1610.10:FF:000008', NULL, NULL, 'Glycoside hydrolase family 92 protein', NULL, NULL, NULL, NULL, NULL, 4),
(70395, NULL, 'G3DSA:3.40.960.10:FF:000006', NULL, NULL, 'Cullin, a subunit of E3 ubiquitin ligase', NULL, NULL, NULL, NULL, NULL, 4),
(70396, NULL, 'G3DSA:3.30.40.10:FF:000332', NULL, NULL, 'Peroxisome biogenesis factor 10', NULL, NULL, NULL, NULL, NULL, 4),
(70397, NULL, 'G3DSA:1.20.1070.10:FF:001208', NULL, NULL, 'Chemokine (C-X-C motif) receptor 3, tandem duplicate 1', NULL, NULL, NULL, NULL, NULL, 4),
(70398, NULL, 'G3DSA:1.25.40.860:FF:000021', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(70399, NULL, 'G3DSA:1.25.40.10:FF:004733', NULL, NULL, 'Tetratricopeptide repeat protein 21 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(70400, NULL, 'G3DSA:3.30.40.10:FF:001760', NULL, NULL, 'Chromatin modification-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(70401, NULL, 'G3DSA:2.10.25.10:FF:001565', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70402, NULL, 'G3DSA:3.40.50.360:FF:000020', NULL, NULL, 'Flavodoxin_1, Flavodoxin', NULL, NULL, NULL, NULL, NULL, 4),
(70403, NULL, 'G3DSA:2.10.25.10:FF:000845', NULL, NULL, 'laminin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(70404, NULL, 'G3DSA:1.25.10.10:FF:003416', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(70405, NULL, 'G3DSA:3.30.310.260:FF:000001', NULL, NULL, '8-oxoguanine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(70406, NULL, 'G3DSA:3.60.150.10:FF:000013', NULL, NULL, 'Chorismate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(70407, NULL, 'G3DSA:1.20.1420.30:FF:000011', NULL, NULL, 'Vacuolar calcium ion transporter', NULL, NULL, NULL, NULL, NULL, 4),
(70408, NULL, 'G3DSA:3.30.40.10:FF:000855', NULL, NULL, 'Pre-mRNA-splicing factor CWC24', NULL, NULL, NULL, NULL, NULL, 4),
(70409, NULL, 'G3DSA:3.30.2020.30:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70410, NULL, 'G3DSA:3.50.50.60:FF:000841', NULL, NULL, 'Zgc:77439', NULL, NULL, NULL, NULL, NULL, 4),
(70411, NULL, 'G3DSA:1.20.1250.40:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70412, NULL, 'G3DSA:3.30.70.330:FF:000506', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(70413, NULL, 'G3DSA:3.40.50.80:FF:000016', NULL, NULL, 'NAD(P)H-flavin reductase', NULL, NULL, NULL, NULL, NULL, 4),
(70414, NULL, 'G3DSA:3.40.190.10:FF:000588', NULL, NULL, 'Oligopeptide ABC transporter, periplasmic oligopeptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(70415, NULL, 'G3DSA:3.40.718.10:FF:000051', NULL, NULL, 'Isocitrate dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70416, NULL, 'G3DSA:3.40.20.10:FF:000128', NULL, NULL, 'SD03793p', NULL, NULL, NULL, NULL, NULL, 4),
(70417, NULL, 'G3DSA:3.40.50.620:FF:000087', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(70418, NULL, 'G3DSA:3.30.920.20:FF:000003', NULL, NULL, 'Growth arrest-specific 2 like 3', NULL, NULL, NULL, NULL, NULL, 4),
(70419, NULL, 'G3DSA:1.10.630.10:FF:000721', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70420, NULL, 'G3DSA:2.60.40.10:FF:002688', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70421, NULL, 'G3DSA:3.40.50.410:FF:000350', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70422, NULL, 'G3DSA:1.20.58.100:FF:000004', NULL, NULL, 'Succinate dehydrogenase flavoprotein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(70423, NULL, 'G3DSA:3.30.160.60:FF:000575', NULL, NULL, 'Zinc finger protein OZF', NULL, NULL, NULL, NULL, NULL, 4),
(70424, NULL, 'G3DSA:1.20.1720.10:FF:000101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70425, NULL, 'G3DSA:1.20.120.350:FF:000051', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(70426, NULL, 'G3DSA:1.10.287.110:FF:000458', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70427, NULL, 'G3DSA:3.30.70.1230:FF:000075', NULL, NULL, 'Adenylate/guanylate cyclase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(70428, NULL, 'G3DSA:1.10.575.10:FF:000007', NULL, NULL, 'p1/s1 nuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70429, NULL, 'G3DSA:3.90.550.10:FF:000554', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70430, NULL, 'G3DSA:3.40.50.150:FF:000867', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(70431, NULL, 'G3DSA:3.40.50.2300:FF:000629', NULL, NULL, 'Glutamate receptor 1.3', NULL, NULL, NULL, NULL, NULL, 4),
(70432, NULL, 'G3DSA:1.25.40.10:FF:000838', NULL, NULL, 'Unplaced genomic scaffold supercont1.20, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(70433, NULL, 'G3DSA:2.60.40.150:FF:000623', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70434, NULL, 'G3DSA:1.20.58.1710:FF:000002', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 8', NULL, NULL, NULL, NULL, NULL, 4),
(70435, NULL, 'G3DSA:3.30.310.80:FF:000031', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(70436, NULL, 'G3DSA:2.30.30.40:FF:000680', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70437, NULL, 'G3DSA:1.25.40.20:FF:000375', NULL, NULL, 'ankyrin repeat domain-containing protein 42', NULL, NULL, NULL, NULL, NULL, 4),
(70438, NULL, 'G3DSA:2.30.42.10:FF:000384', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(70439, NULL, 'G3DSA:1.20.1560.10:FF:000358', NULL, NULL, 'ABC multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70440, NULL, 'G3DSA:3.30.420.10:FF:000620', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70441, NULL, 'G3DSA:3.40.50.10810:FF:000028', NULL, NULL, 'Chromatin-remodeling complex ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(70442, NULL, 'G3DSA:1.20.1640.10:FF:000100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70443, NULL, 'G3DSA:2.60.40.10:FF:003144', NULL, NULL, 'Protein tyrosine phosphatase receptor type b', NULL, NULL, NULL, NULL, NULL, 4),
(70444, NULL, 'G3DSA:3.40.1050.10:FF:000015', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(70445, NULL, 'G3DSA:1.10.260.30:FF:000007', NULL, NULL, 'Chorismate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(70446, NULL, 'G3DSA:3.40.640.10:FF:000078', NULL, NULL, 'Adenosylmethionine-8-amino-7-oxononanoate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(70447, NULL, 'G3DSA:1.25.10.10:FF:002399', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70448, NULL, 'G3DSA:3.40.50.720:FF:001808', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70449, NULL, 'G3DSA:3.80.10.10:FF:003408', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70450, NULL, 'G3DSA:3.40.50.150:FF:001267', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70451, NULL, 'G3DSA:3.80.10.10:FF:003296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70452, NULL, 'G3DSA:3.40.50.10090:FF:000037', NULL, NULL, 'Uroporphyrinogen-III synthase HemD', NULL, NULL, NULL, NULL, NULL, 4),
(70453, NULL, 'G3DSA:3.80.10.10:FF:000946', NULL, NULL, 'AGAP011229-PA', NULL, NULL, NULL, NULL, NULL, 4),
(70454, NULL, 'G3DSA:3.40.50.620:FF:000795', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70455, NULL, 'G3DSA:3.30.70.1070:FF:000004', NULL, NULL, 'Cell division protein DamX', NULL, NULL, NULL, NULL, NULL, 4),
(70456, NULL, 'G3DSA:1.20.1050.10:FF:000280', NULL, NULL, 'Glutathione stransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70457, NULL, 'G3DSA:3.70.10.10:FF:000059', NULL, NULL, 'Cell cycle checkpoint protein RAD1 homolog mrt-2', NULL, NULL, NULL, NULL, NULL, 4),
(70458, NULL, 'G3DSA:3.40.50.720:FF:000527', NULL, NULL, '4-hydroxy-tetrahydrodipicolinate reductase 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(70459, NULL, 'G3DSA:3.40.50.10330:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70460, NULL, 'G3DSA:1.20.1070.10:FF:002136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70461, NULL, 'G3DSA:3.30.70.330:FF:001698', NULL, NULL, 'Polynucleotide adenylyltransferase domain/RNA recognition motif protein', NULL, NULL, NULL, NULL, NULL, 4),
(70462, NULL, 'G3DSA:3.30.70.20:FF:000073', NULL, NULL, 'H(2):CoB-CoM heterodisulfide,ferredoxin reductase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(70463, NULL, 'G3DSA:3.30.710.10:FF:000367', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70464, NULL, 'G3DSA:3.30.830.10:FF:000286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70465, NULL, 'G3DSA:3.40.50.300:FF:006977', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70466, NULL, 'G3DSA:2.10.25.10:FF:000284', NULL, NULL, 'von Willebrand factor', NULL, NULL, NULL, NULL, NULL, 4),
(70467, NULL, 'G3DSA:3.40.50.300:FF:006269', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(70468, NULL, 'G3DSA:1.20.120.1150:FF:000005', NULL, NULL, 'Serine/threonine-protein phosphatase 2A activator', NULL, NULL, NULL, NULL, NULL, 4),
(70469, NULL, 'G3DSA:3.10.129.10:FF:000138', NULL, NULL, 'Putative thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(70470, NULL, 'G3DSA:3.40.850.10:FF:000324', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70471, NULL, 'G3DSA:3.30.420.40:FF:000691', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(70472, NULL, 'G3DSA:3.40.50.300:FF:006680', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70473, NULL, 'G3DSA:1.10.510.10:FF:002752', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase mlk-1', NULL, NULL, NULL, NULL, NULL, 4),
(70474, NULL, 'G3DSA:1.10.150.670:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70475, NULL, 'G3DSA:2.60.40.10:FF:003852', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70476, NULL, 'G3DSA:3.30.1120.10:FF:000057', NULL, NULL, 'N-acetylgalactosamine 6-sulfatase (GALNS)', NULL, NULL, NULL, NULL, NULL, 4),
(70477, NULL, 'G3DSA:3.30.200.20:FF:000758', NULL, NULL, 'cyclin-dependent kinase-like 5 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(70478, NULL, 'G3DSA:3.90.1300.10:FF:000001', NULL, NULL, 'Fatty-acid amide hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(70479, NULL, 'G3DSA:2.130.10.10:FF:003268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70480, NULL, 'G3DSA:3.30.300.30:FF:000151', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(70481, NULL, 'G3DSA:3.40.1810.10:FF:000079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70482, NULL, 'G3DSA:1.10.20.70:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70483, NULL, 'G3DSA:3.30.160.60:FF:001856', NULL, NULL, 'Zinc finger protein 655', NULL, NULL, NULL, NULL, NULL, 4),
(70484, NULL, 'G3DSA:1.20.58.390:FF:000046', NULL, NULL, 'AcetylCholine Receptor', NULL, NULL, NULL, NULL, NULL, 4),
(70485, NULL, 'G3DSA:3.30.160.60:FF:004318', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70486, NULL, 'G3DSA:2.60.40.10:FF:003705', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70487, NULL, 'G3DSA:3.90.80.10:FF:000023', NULL, NULL, 'Inorganic pyrophosphatase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(70488, NULL, 'G3DSA:3.40.50.1700:FF:000022', NULL, NULL, 'Thermostable beta-glucosidase B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70489, NULL, 'G3DSA:4.10.1060.10:FF:000056', NULL, NULL, 'Putative nf-kappa b regulator ap20/cezanne', NULL, NULL, NULL, NULL, NULL, 4),
(70490, NULL, 'G3DSA:2.60.120.10:FF:000723', NULL, NULL, 'Protein CBG15463', NULL, NULL, NULL, NULL, NULL, 4),
(70491, NULL, 'G3DSA:2.40.50.140:FF:000520', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(70492, NULL, 'G3DSA:3.40.50.1000:FF:000110', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(70493, NULL, 'G3DSA:3.40.50.300:FF:008214', NULL, NULL, 'MutS homolog 6 (E. coli)', NULL, NULL, NULL, NULL, NULL, 4),
(70494, NULL, 'G3DSA:2.60.40.1830:FF:000001', NULL, NULL, 'BPP', NULL, NULL, NULL, NULL, NULL, 4),
(70495, NULL, 'G3DSA:2.60.40.180:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70496, NULL, 'G3DSA:3.30.565.10:FF:000298', NULL, NULL, 'DNA mismatch repair protein pms2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70497, NULL, 'G3DSA:3.90.1150.170:FF:000002', NULL, NULL, 'pyridoxal-dependent decarboxylase domain-containing protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(70498, NULL, 'G3DSA:3.90.190.10:FF:000071', NULL, NULL, 'Dual specificity protein phosphatase 19', NULL, NULL, NULL, NULL, NULL, 4),
(70499, NULL, 'G3DSA:3.30.750.24:FF:000175', NULL, NULL, 'Sulfate transporter 1.2', NULL, NULL, NULL, NULL, NULL, 4),
(70500, NULL, 'G3DSA:1.10.287.70:FF:000417', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70501, NULL, 'G3DSA:3.30.470.20:FF:000013', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(70502, NULL, 'G3DSA:1.20.1250.20:FF:000146', NULL, NULL, 'Amino acid/peptide transporter', NULL, NULL, NULL, NULL, NULL, 4),
(70503, NULL, 'G3DSA:2.60.40.10:FF:004369', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70504, NULL, 'G3DSA:2.40.50.140:FF:000784', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70505, NULL, 'G3DSA:1.10.390.10:FF:000005', NULL, NULL, 'transcription initiation factor TFIID subunit 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(70506, NULL, 'G3DSA:3.20.20.80:FF:000381', NULL, NULL, 'Glucosylceramidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70507, NULL, 'G3DSA:3.40.50.880:FF:000114', NULL, NULL, 'ThiJ/PfpI family protein', NULL, NULL, NULL, NULL, NULL, 4),
(70508, NULL, 'G3DSA:2.40.30.10:FF:000171', NULL, NULL, 'Mrpl9p', NULL, NULL, NULL, NULL, NULL, 4),
(70509, NULL, 'G3DSA:3.30.830.10:FF:000139', NULL, NULL, 'Processing protease', NULL, NULL, NULL, NULL, NULL, 4),
(70510, NULL, 'G3DSA:1.10.287.380:FF:000022', NULL, NULL, 'Hypothetical ABC transporter ATP-binding protein ybiT', NULL, NULL, NULL, NULL, NULL, 4),
(70511, NULL, 'G3DSA:2.40.420.20:FF:000023', NULL, NULL, 'Multidrug resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(70512, NULL, 'G3DSA:2.60.200.20:FF:000261', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70513, NULL, 'G3DSA:3.30.70.330:FF:003120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70514, NULL, 'G3DSA:2.40.160.10:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70515, NULL, 'G3DSA:2.60.40.10:FF:005914', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70516, NULL, 'G3DSA:2.30.29.30:FF:000718', NULL, NULL, 'Si:ch73-111k22.3', NULL, NULL, NULL, NULL, NULL, 4),
(70517, NULL, 'G3DSA:1.20.1250.20:FF:002355', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(70518, NULL, 'G3DSA:1.10.1670.10:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70519, NULL, 'G3DSA:3.10.129.10:FF:000290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70520, NULL, 'G3DSA:1.20.1730.10:FF:000074', NULL, NULL, 'High-affinity choline transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70521, NULL, 'G3DSA:3.30.160.60:FF:003801', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70522, NULL, 'G3DSA:3.40.1380.20:FF:000037', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(70523, NULL, 'G3DSA:3.40.50.450:FF:000103', NULL, NULL, 'Phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(70524, NULL, 'G3DSA:3.40.50.300:FF:006005', NULL, NULL, 'Disease resistance protein RGA4', NULL, NULL, NULL, NULL, NULL, 4),
(70525, NULL, 'G3DSA:3.40.50.1820:FF:000176', NULL, NULL, 'Cutinase Cut4', NULL, NULL, NULL, NULL, NULL, 4),
(70526, NULL, 'G3DSA:2.170.150.20:FF:000022', NULL, NULL, 'Peptide methionine sulfoxide reductase MsrA', NULL, NULL, NULL, NULL, NULL, 4),
(70527, NULL, 'G3DSA:3.40.30.10:FF:001085', NULL, NULL, 'Putative SCO1/SenC family protein/methylamine utilization protein MauG', NULL, NULL, NULL, NULL, NULL, 4),
(70528, NULL, 'G3DSA:1.25.40.10:FF:000990', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(70529, NULL, 'G3DSA:3.40.50.2000:FF:000101', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(70530, NULL, 'G3DSA:1.10.10.60:FF:001048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70531, NULL, 'G3DSA:2.60.120.260:FF:000553', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70532, NULL, 'G3DSA:1.10.510.10:FF:002191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70533, NULL, 'G3DSA:2.40.50.40:FF:000130', NULL, NULL, 'Chromodomain Y like 2', NULL, NULL, NULL, NULL, NULL, 4),
(70534, NULL, 'G3DSA:3.90.1150.10:FF:000348', NULL, NULL, 'Pleiotropic regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(70535, NULL, 'G3DSA:3.30.420.40:FF:000016', NULL, NULL, 'Rod shape-determining protein mreB', NULL, NULL, NULL, NULL, NULL, 4),
(70536, NULL, 'G3DSA:3.80.20.20:FF:000045', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(70537, NULL, 'G3DSA:1.20.1070.10:FF:000899', NULL, NULL, 'Olfactory receptor 1260', NULL, NULL, NULL, NULL, NULL, 4),
(70538, NULL, 'G3DSA:3.90.960.10:FF:000012', NULL, NULL, 'Probable proline-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(70539, NULL, 'G3DSA:2.130.10.10:FF:001059', NULL, NULL, 'WD repeat and HMG-box DNA binding protein 1', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(70540, NULL, 'G3DSA:3.40.50.1910:FF:000023', NULL, NULL, 'GM10243', NULL, NULL, NULL, NULL, NULL, 4),
(70541, NULL, 'G3DSA:1.20.1270.10:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70542, NULL, 'G3DSA:3.40.30.10:FF:000073', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(70543, NULL, 'G3DSA:2.130.10.30:FF:000025', NULL, NULL, 'HECT and RLD domain containing E3 ubiquitin protein ligase 5', NULL, NULL, NULL, NULL, NULL, 4),
(70544, NULL, 'G3DSA:3.60.20.40:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70545, NULL, 'G3DSA:3.40.50.1820:FF:001396', NULL, NULL, 'Initiation factor 4F subunit (DUF1350)', NULL, NULL, NULL, NULL, NULL, 4),
(70546, NULL, 'G3DSA:1.20.870.10:FF:000039', NULL, NULL, 'YALI0F32043p', NULL, NULL, NULL, NULL, NULL, 4),
(70547, NULL, 'G3DSA:3.40.50.300:FF:005691', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(70548, NULL, 'G3DSA:1.10.3080.10:FF:000054', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(70549, NULL, 'G3DSA:3.80.10.10:FF:001082', NULL, NULL, 'Receptor-like protein Cf-9', NULL, NULL, NULL, NULL, NULL, 4),
(70550, NULL, 'G3DSA:3.40.1160.10:FF:000080', NULL, NULL, 'Molybdenum storage protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(70551, NULL, 'G3DSA:1.20.1250.10:FF:000048', NULL, NULL, 'Kit ligand b', NULL, NULL, NULL, NULL, NULL, 4),
(70552, NULL, 'G3DSA:3.40.50.2300:FF:000365', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(70553, NULL, 'G3DSA:1.20.1280.50:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70554, NULL, 'G3DSA:1.10.510.10:FF:003236', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70555, NULL, 'G3DSA:2.40.240.10:FF:000040', NULL, NULL, 'Ribosomal protein L25/Gln-tRNA synthetase, anti-codon-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(70556, NULL, 'G3DSA:3.30.230.120:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70557, NULL, 'G3DSA:3.40.50.1820:FF:000884', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70558, NULL, 'G3DSA:2.60.40.10:FF:002132', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(70559, NULL, 'G3DSA:1.20.1270.10:FF:000055', NULL, NULL, 'Heat shock 70 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(70560, NULL, 'G3DSA:3.40.50.1820:FF:000412', NULL, NULL, 'Protein phosphatase methylesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(70561, NULL, 'G3DSA:3.80.10.10:FF:000570', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM1', NULL, NULL, NULL, NULL, NULL, 4),
(70562, NULL, 'G3DSA:3.30.70.1230:FF:000103', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(70563, NULL, 'G3DSA:1.10.287.110:FF:000374', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70564, NULL, 'G3DSA:3.20.20.140:FF:000363', NULL, NULL, 'Amidohydrolase family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70565, NULL, 'G3DSA:1.10.287.110:FF:000430', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70566, NULL, 'G3DSA:3.40.50.1820:FF:000940', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70567, NULL, 'G3DSA:1.20.5.3730:FF:000001', NULL, NULL, 'Zona pellucida sperm-binding protein 3 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(70568, NULL, 'G3DSA:3.40.367.20:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70569, NULL, 'G3DSA:1.20.58.390:FF:000310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70570, NULL, 'G3DSA:3.90.1520.10:FF:000012', NULL, NULL, 'Chromosome undetermined SCAF14725, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(70571, NULL, 'G3DSA:1.25.40.20:FF:001920', NULL, NULL, 'Ankyrin-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70572, NULL, 'G3DSA:3.40.50.1820:FF:001873', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(70573, NULL, 'G3DSA:1.10.510.10:FF:003764', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70574, NULL, 'G3DSA:3.40.190.10:FF:000857', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70575, NULL, 'G3DSA:1.25.10.10:FF:000893', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(70576, NULL, 'G3DSA:3.40.50.720:FF:002213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70577, NULL, 'G3DSA:1.20.1070.10:FF:001944', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70578, NULL, 'G3DSA:2.60.120.200:FF:000411', NULL, NULL, 'FAT atypical cadherin 1b', NULL, NULL, NULL, NULL, NULL, 4),
(70579, NULL, 'G3DSA:3.30.110.110:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70580, NULL, 'G3DSA:3.40.50.10330:FF:000070', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(70581, NULL, 'G3DSA:3.80.10.10:FF:004313', NULL, NULL, 'Si:ch211-213a13.2', NULL, NULL, NULL, NULL, NULL, 4),
(70582, NULL, 'G3DSA:1.25.40.10:FF:002047', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g21300', NULL, NULL, NULL, NULL, NULL, 4),
(70583, NULL, 'G3DSA:2.60.220.50:FF:000012', NULL, NULL, 'Adhesion G protein-coupled receptor A2', NULL, NULL, NULL, NULL, NULL, 4),
(70584, NULL, 'G3DSA:3.30.70.260:FF:000081', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(70585, NULL, 'G3DSA:1.10.150.390:FF:000008', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(70586, NULL, 'G3DSA:3.50.50.60:FF:000369', NULL, NULL, 'FAD-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(70587, NULL, 'G3DSA:1.20.1070.10:FF:000427', NULL, NULL, 'Leucine-rich repeat containing G protein-coupled receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(70588, NULL, 'G3DSA:3.10.20.90:FF:000176', NULL, NULL, 'Rho guanyl nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(70589, NULL, 'G3DSA:1.20.1070.10:FF:000955', NULL, NULL, 'GoNadotropin-Releasing hormone Receptor (GnRHR) related', NULL, NULL, NULL, NULL, NULL, 4),
(70590, NULL, 'G3DSA:3.30.70.1710:FF:000005', NULL, NULL, 'Ethanolamine utilization microcompartment protein EutK', NULL, NULL, NULL, NULL, NULL, 4),
(70591, NULL, 'G3DSA:3.10.400.10:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70592, NULL, 'G3DSA:3.40.50.880:FF:000086', NULL, NULL, 'Carbamoyl-phosphate synthase small chain', NULL, NULL, NULL, NULL, NULL, 4),
(70593, NULL, 'G3DSA:1.10.10.10:FF:001730', NULL, NULL, 'Response regulator receiver', NULL, NULL, NULL, NULL, NULL, 4),
(70594, NULL, 'G3DSA:3.40.50.790:FF:000003', NULL, NULL, '39S ribosomal protein L1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(70595, NULL, 'G3DSA:3.30.160.60:FF:002104', NULL, NULL, 'Si:ch211-266d19.4', NULL, NULL, NULL, NULL, NULL, 4),
(70596, NULL, 'G3DSA:3.50.50.60:FF:000425', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(70597, NULL, 'G3DSA:2.120.10.30:FF:000166', NULL, NULL, 'Exported gluconolactonase', NULL, NULL, NULL, NULL, NULL, 4),
(70598, NULL, 'G3DSA:3.80.10.10:FF:002335', NULL, NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g56140', NULL, NULL, NULL, NULL, NULL, 4),
(70599, NULL, 'G3DSA:3.30.420.40:FF:000516', NULL, NULL, 'Glycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(70600, NULL, 'G3DSA:3.30.450.30:FF:000015', NULL, NULL, 'Profilin', NULL, NULL, NULL, NULL, NULL, 4),
(70601, NULL, 'G3DSA:1.10.8.100:FF:000024', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(70602, NULL, 'G3DSA:3.40.250.10:FF:000003', NULL, NULL, 'tRNA sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(70603, NULL, 'G3DSA:2.40.128.180:FF:000004', NULL, NULL, 'Fas apoptotic inhibitory molecule', NULL, NULL, NULL, NULL, NULL, 4),
(70604, NULL, 'G3DSA:2.40.70.10:FF:000145', NULL, NULL, 'Aspartic protease', NULL, NULL, NULL, NULL, NULL, 4),
(70605, NULL, 'G3DSA:3.40.50.410:FF:000086', NULL, NULL, 'Circumsporozoite-and TRAP-related protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(70606, NULL, 'G3DSA:1.10.20.10:FF:000067', NULL, NULL, 'Transcription initiation factor TFIID subunit 13', NULL, NULL, NULL, NULL, NULL, 4),
(70607, NULL, 'G3DSA:3.60.21.10:FF:000017', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(70608, NULL, 'G3DSA:3.30.40.10:FF:001288', NULL, NULL, 'Putative RING zinc finger domain superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(70609, NULL, 'G3DSA:3.30.420.40:FF:000988', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70610, NULL, 'G3DSA:3.30.40.10:FF:001344', NULL, NULL, 'E3 ubiquitin-protein ligase LubX', NULL, NULL, NULL, NULL, NULL, 4),
(70611, NULL, 'G3DSA:1.20.120.350:FF:000112', NULL, NULL, 'Voltage-gated Ca2+ channel, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(70612, NULL, 'G3DSA:2.60.40.10:FF:004897', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70613, NULL, 'G3DSA:3.30.200.20:FF:002383', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70614, NULL, 'G3DSA:2.130.10.10:FF:001800', NULL, NULL, 'Similar to WD repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(70615, NULL, 'G3DSA:1.20.58.1480:FF:000006', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(70616, NULL, 'G3DSA:1.20.58.390:FF:000254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70617, NULL, 'G3DSA:3.30.420.40:FF:000196', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(70618, NULL, 'G3DSA:2.60.40.10:FF:003913', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70619, NULL, 'G3DSA:2.40.70.10:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70620, NULL, 'G3DSA:3.40.50.2000:FF:000337', NULL, NULL, 'Lipopolysaccharide biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(70621, NULL, 'G3DSA:3.40.50.1460:FF:000080', NULL, NULL, 'GPI-anchor transamidase', NULL, NULL, NULL, NULL, NULL, 4),
(70622, NULL, 'G3DSA:3.30.519.10:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70623, NULL, 'G3DSA:1.25.40.10:FF:003952', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70624, NULL, 'G3DSA:2.130.10.10:FF:004673', NULL, NULL, 'TNF receptor-associated factor 7', NULL, NULL, NULL, NULL, NULL, 4),
(70625, NULL, 'G3DSA:1.10.10.10:FF:001235', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(70626, NULL, 'G3DSA:1.10.225.10:FF:000015', NULL, NULL, 'Sphingomyelin phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(70627, NULL, 'G3DSA:3.90.1170.20:FF:000004', NULL, NULL, 'Nicotinate-nucleotide pyrophosphorylase [carboxylating]', NULL, NULL, NULL, NULL, NULL, 4),
(70628, NULL, 'G3DSA:2.60.120.430:FF:000042', NULL, NULL, 'Cellulase', NULL, NULL, NULL, NULL, NULL, 4),
(70629, NULL, 'G3DSA:3.40.50.300:FF:006505', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(70630, NULL, 'G3DSA:3.20.70.20:FF:000006', NULL, NULL, 'Anaerobic ribonucleoside-triphosphate reductase NrdD', NULL, NULL, NULL, NULL, NULL, 4),
(70631, NULL, 'G3DSA:1.20.1070.10:FF:001888', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70632, NULL, 'G3DSA:3.30.365.10:FF:000081', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(70633, NULL, 'G3DSA:2.60.200.20:FF:000053', NULL, NULL, 'Os06g0275900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(70634, NULL, 'G3DSA:3.30.160.60:FF:000159', NULL, NULL, 'Mds1 and evi1 complex locus protein', NULL, NULL, NULL, NULL, NULL, 4),
(70635, NULL, 'G3DSA:3.30.160.60:FF:006319', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70636, NULL, 'G3DSA:1.10.246.10:FF:000013', NULL, NULL, 'Serum albumin', NULL, NULL, NULL, NULL, NULL, 4),
(70637, NULL, 'G3DSA:3.90.550.10:FF:000138', NULL, NULL, 'Cellulose synthase isolog', NULL, NULL, NULL, NULL, NULL, 4),
(70638, NULL, 'G3DSA:3.30.530.20:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70639, NULL, 'G3DSA:2.40.50.140:FF:000284', NULL, NULL, 'Single-stranded DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(70640, NULL, 'G3DSA:1.10.287.70:FF:000480', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70641, NULL, 'G3DSA:3.90.190.10:FF:000155', NULL, NULL, 'Dual specificity protein phosphatase PPS1', NULL, NULL, NULL, NULL, NULL, 4),
(70642, NULL, 'G3DSA:3.30.70.330:FF:003143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70643, NULL, 'G3DSA:3.40.50.2020:FF:000023', NULL, NULL, 'Probable uracil phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(70644, NULL, 'G3DSA:1.20.120.1080:FF:000080', NULL, NULL, 'Putative DEAH-box RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(70645, NULL, 'G3DSA:2.130.10.10:FF:002784', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70646, NULL, 'G3DSA:2.60.40.200:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70647, NULL, 'G3DSA:1.25.40.280:FF:000004', NULL, NULL, 'BRO1 domain-containing protein BROX', NULL, NULL, NULL, NULL, NULL, 4),
(70648, NULL, 'G3DSA:1.10.418.10:FF:000031', NULL, NULL, 'Fimbrin-2 like', NULL, NULL, NULL, NULL, NULL, 4),
(70649, NULL, 'G3DSA:2.30.130.40:FF:000043', NULL, NULL, 'Lon protease homolog', NULL, NULL, NULL, NULL, NULL, 4),
(70650, NULL, 'G3DSA:2.60.40.10:FF:003436', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70651, NULL, 'G3DSA:3.10.20.90:FF:000968', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70652, NULL, 'G3DSA:1.10.8.270:FF:000029', NULL, NULL, 'TBC1 domain family member 21', NULL, NULL, NULL, NULL, NULL, 4),
(70653, NULL, 'G3DSA:2.60.40.150:FF:000331', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(70654, NULL, 'G3DSA:2.60.34.20:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70655, NULL, 'G3DSA:3.40.50.150:FF:001795', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70656, NULL, 'G3DSA:3.30.470.20:FF:000244', NULL, NULL, 'Glutathione synthetase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(70657, NULL, 'G3DSA:1.50.40.10:FF:000038', NULL, NULL, 'S-adenosylmethionine carrier 1 chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(70658, NULL, 'G3DSA:3.20.20.70:FF:000405', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70659, NULL, 'G3DSA:3.20.20.80:FF:000178', NULL, NULL, '1,3-beta-glucanosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(70660, NULL, 'G3DSA:3.80.10.10:FF:000418', NULL, NULL, 'protein toll', NULL, NULL, NULL, NULL, NULL, 4),
(70661, NULL, 'G3DSA:3.40.50.1820:FF:000092', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(70662, NULL, 'G3DSA:3.30.160.60:FF:004021', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(70663, NULL, 'G3DSA:3.30.1490.20:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70664, NULL, 'G3DSA:2.60.40.10:FF:002924', NULL, NULL, 'Sensory AXon guidance', NULL, NULL, NULL, NULL, NULL, 4),
(70665, NULL, 'G3DSA:3.40.50.300:FF:002762', NULL, NULL, 'GTP-binding protein YqeH', NULL, NULL, NULL, NULL, NULL, 4),
(70666, NULL, 'G3DSA:3.30.2310.20:FF:000007', NULL, NULL, 'Toxin', NULL, NULL, NULL, NULL, NULL, 4),
(70667, NULL, 'G3DSA:3.30.230.10:FF:000021', NULL, NULL, 'Ribonuclease P protein component', NULL, NULL, NULL, NULL, NULL, 4),
(70668, NULL, 'G3DSA:3.30.450.60:FF:000030', NULL, NULL, 'APM2p protein', NULL, NULL, NULL, NULL, NULL, 4),
(70669, NULL, 'G3DSA:1.10.1040.10:FF:000085', NULL, NULL, 'Putative 2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(70670, NULL, 'G3DSA:2.170.120.12:FF:000031', NULL, NULL, 'DNA-directed RNA polymerase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(70671, NULL, 'G3DSA:1.20.1250.20:FF:001310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70672, NULL, 'G3DSA:1.10.3720.10:FF:000019', NULL, NULL, 'Antimicrobial peptide ABC transporter permease SapC', NULL, NULL, NULL, NULL, NULL, 4),
(70673, NULL, 'G3DSA:3.30.70.660:FF:000049', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(70674, NULL, 'G3DSA:1.25.40.990:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70675, NULL, 'G3DSA:2.60.40.1090:FF:000032', NULL, NULL, 'Fimbrial protein StdA', NULL, NULL, NULL, NULL, NULL, 4),
(70676, NULL, 'G3DSA:1.10.287.1490:FF:000007', NULL, NULL, 'Golgin B1', NULL, NULL, NULL, NULL, NULL, 4),
(70677, NULL, 'G3DSA:3.30.450.60:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70678, NULL, 'G3DSA:2.160.20.10:FF:000209', NULL, NULL, 'Polygalacturonase QRT2', NULL, NULL, NULL, NULL, NULL, 4),
(70679, NULL, 'G3DSA:2.30.30.30:FF:000082', NULL, NULL, '50S ribosomal protein L24', NULL, NULL, NULL, NULL, NULL, 4),
(70680, NULL, 'G3DSA:3.40.50.720:FF:001696', NULL, NULL, 'GDP-mannose dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(70681, NULL, 'G3DSA:6.10.140.2220:FF:000024', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(70682, NULL, 'G3DSA:3.40.30.10:FF:000865', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70683, NULL, 'G3DSA:3.30.1380.20:FF:000051', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(70684, NULL, 'G3DSA:1.20.1250.20:FF:000910', NULL, NULL, 'Sugar transport protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(70685, NULL, 'G3DSA:3.20.20.100:FF:000143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70686, NULL, 'G3DSA:3.30.60.20:FF:000128', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(70687, NULL, 'G3DSA:3.30.160.60:FF:003565', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70688, NULL, 'G3DSA:1.25.40.180:FF:000272', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70689, NULL, 'G3DSA:1.20.120.680:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70690, NULL, 'G3DSA:2.20.28.200:FF:000013', NULL, NULL, 'Class IV sirtuin', NULL, NULL, NULL, NULL, NULL, 4),
(70691, NULL, 'G3DSA:3.20.140.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70692, NULL, 'G3DSA:1.20.58.530:FF:000015', NULL, NULL, 'Unconventional myosin-IXa', NULL, NULL, NULL, NULL, NULL, 4),
(70693, NULL, 'G3DSA:2.40.10.10:FF:000169', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(70694, NULL, 'G3DSA:1.10.238.10:FF:000882', NULL, NULL, 'EFHC2', NULL, NULL, NULL, NULL, NULL, 4),
(70695, NULL, 'G3DSA:3.40.630.10:FF:000105', NULL, NULL, 'Nicalin', NULL, NULL, NULL, NULL, NULL, 4),
(70696, NULL, 'G3DSA:1.25.40.10:FF:004880', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70697, NULL, 'G3DSA:2.10.220.10:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70698, NULL, 'G3DSA:3.40.50.300:FF:003751', NULL, NULL, 'Dynamin-related GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(70699, NULL, 'G3DSA:2.30.42.10:FF:000204', NULL, NULL, 'Fife, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(70700, NULL, 'G3DSA:3.30.160.60:FF:003037', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(70701, NULL, 'G3DSA:3.60.21.10:FF:000192', NULL, NULL, 'Protein phosphatase 3 catalytic subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(70702, NULL, 'G3DSA:3.30.1520.10:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70703, NULL, 'G3DSA:3.40.50.300:FF:007489', NULL, NULL, 'Uncharacterized protein ABCG33', NULL, NULL, NULL, NULL, NULL, 4),
(70704, NULL, 'G3DSA:3.30.70.250:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70705, NULL, 'G3DSA:3.80.10.10:FF:001879', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(70706, NULL, 'G3DSA:3.30.40.10:FF:000708', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(70707, NULL, 'G3DSA:3.40.1500.10:FF:000005', NULL, NULL, 'Oxygen-dependent coproporphyrinogen-III oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(70708, NULL, 'G3DSA:2.130.10.10:FF:002312', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(70709, NULL, 'G3DSA:3.40.850.10:FF:000088', NULL, NULL, 'Myosin C', NULL, NULL, NULL, NULL, NULL, 4),
(70710, NULL, 'G3DSA:1.25.40.10:FF:001535', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(70711, NULL, 'G3DSA:1.10.287.2620:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70712, NULL, 'G3DSA:3.40.190.10:FF:000060', NULL, NULL, 'Glutamate receptor ionotropic, kainate 1', NULL, NULL, NULL, NULL, NULL, 4),
(70713, NULL, 'G3DSA:3.40.50.2300:FF:001618', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70714, NULL, 'G3DSA:2.60.40.10:FF:005061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70715, NULL, 'G3DSA:3.60.15.10:FF:000132', NULL, NULL, 'MBL fold metallo-hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(70716, NULL, 'G3DSA:1.10.510.10:FF:001347', NULL, NULL, 'Actin-regulating kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70717, NULL, 'G3DSA:1.10.287.600:FF:000009', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(70718, NULL, 'G3DSA:1.20.1110.10:FF:000190', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70719, NULL, 'G3DSA:3.30.200.20:FF:001511', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70720, NULL, 'G3DSA:3.30.450.20:FF:000658', NULL, NULL, 'Histidine kinase response regulator hybrid protein', NULL, NULL, NULL, NULL, NULL, 4),
(70721, NULL, 'G3DSA:1.20.1250.20:FF:000410', NULL, NULL, 'POT family protein', NULL, NULL, NULL, NULL, NULL, 4),
(70722, NULL, 'G3DSA:2.60.40.420:FF:000283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70723, NULL, 'G3DSA:2.40.50.140:FF:001240', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70724, NULL, 'G3DSA:3.30.40.10:FF:002272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70725, NULL, 'G3DSA:3.40.850.10:FF:000408', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(70726, NULL, 'G3DSA:3.80.10.10:FF:002863', NULL, NULL, 'N-CAM Ig domain-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70727, NULL, 'G3DSA:1.20.1070.10:FF:001416', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70728, NULL, 'G3DSA:3.30.160.60:FF:002576', NULL, NULL, 'zinc finger protein 473 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(70729, NULL, 'G3DSA:3.40.50.970:FF:000085', NULL, NULL, 'Sulfite reductase [NADPH] subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(70730, NULL, 'G3DSA:2.130.10.10:FF:000367', NULL, NULL, 'U3 small nucleolar RNA-associated protein 4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(70731, NULL, 'G3DSA:3.30.70.330:FF:000742', NULL, NULL, 'Telomere maintenance protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70732, NULL, 'G3DSA:2.130.10.10:FF:005185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70733, NULL, 'G3DSA:3.30.70.330:FF:002215', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70734, NULL, 'G3DSA:1.20.5.170:FF:000239', NULL, NULL, 'nuclear pore glycoprotein p62-like', NULL, NULL, NULL, NULL, NULL, 4),
(70735, NULL, 'G3DSA:2.60.40.60:FF:000264', NULL, NULL, 'Cadherin-related family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(70736, NULL, 'G3DSA:3.90.1640.10:FF:000015', NULL, NULL, 'Putative acidocalcisomal exopolyphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(70737, NULL, 'G3DSA:1.25.40.10:FF:004941', NULL, NULL, 'Intraflagellar transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(70738, NULL, 'G3DSA:1.10.10.60:FF:000356', NULL, NULL, 'MYB transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(70739, NULL, 'G3DSA:3.30.710.10:FF:000423', NULL, NULL, 'Protein CBG11420', NULL, NULL, NULL, NULL, NULL, 4),
(70740, NULL, 'G3DSA:3.30.40.10:FF:000832', NULL, NULL, 'E3 ubiquitin-protein ligase RFWD3', NULL, NULL, NULL, NULL, NULL, 4),
(70741, NULL, 'G3DSA:1.50.40.10:FF:000510', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70742, NULL, 'G3DSA:3.20.20.220:FF:000033', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(70743, NULL, 'G3DSA:3.40.50.1820:FF:001401', NULL, NULL, 'Esterase', NULL, NULL, NULL, NULL, NULL, 4),
(70744, NULL, 'G3DSA:3.40.630.30:FF:000263', NULL, NULL, 'Acyl-homoserine-lactone synthase', NULL, NULL, NULL, NULL, NULL, 4),
(70745, NULL, 'G3DSA:3.20.20.100:FF:000082', NULL, NULL, 'Oxidoreductase, aldo/keto reductase family', NULL, NULL, NULL, NULL, NULL, 4),
(70746, NULL, 'G3DSA:1.10.150.20:FF:000237', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NUBP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(70747, NULL, 'G3DSA:2.60.120.650:FF:000136', NULL, NULL, 'AaceriAFL127Cp', NULL, NULL, NULL, NULL, NULL, 4),
(70748, NULL, 'G3DSA:3.10.20.90:FF:000232', NULL, NULL, 'Serine/threonine-protein kinase WNK8', NULL, NULL, NULL, NULL, NULL, 4),
(70749, NULL, 'G3DSA:3.40.50.850:FF:000015', NULL, NULL, 'Phenazine biosynthesis protein PhzD', NULL, NULL, NULL, NULL, NULL, 4),
(70750, NULL, 'G3DSA:3.40.50.2300:FF:001293', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70751, NULL, 'G3DSA:2.60.120.330:FF:000158', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(70752, NULL, 'G3DSA:2.60.200.20:FF:000058', NULL, NULL, 'GM26347', NULL, NULL, NULL, NULL, NULL, 4),
(70753, NULL, 'G3DSA:3.30.160.60:FF:005982', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70754, NULL, 'G3DSA:3.40.47.10:FF:000252', NULL, NULL, 'Acetyl-CoA C-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(70755, NULL, 'G3DSA:3.30.160.60:FF:005015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70756, NULL, 'G3DSA:3.90.70.10:FF:000697', NULL, NULL, 'Cathepsin B endopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70757, NULL, 'G3DSA:3.30.1460.50:FF:000004', NULL, NULL, 'Autophagy-related protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(70758, NULL, 'G3DSA:3.20.20.80:FF:000206', NULL, NULL, 'Amylo-alpha-1, 6-glucosidase, 4-alpha-glucanotransferase b', NULL, NULL, NULL, NULL, NULL, 4),
(70759, NULL, 'G3DSA:2.70.150.10:FF:000150', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(70760, NULL, 'G3DSA:3.30.70.330:FF:002159', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70761, NULL, 'G3DSA:1.20.970.10:FF:000042', NULL, NULL, 'Thymidine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(70762, NULL, 'G3DSA:3.30.160.60:FF:005510', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70763, NULL, 'G3DSA:3.40.50.10140:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70764, NULL, 'G3DSA:1.10.10.200:FF:000001', NULL, NULL, 'Probable transcriptional regulatory protein YebC', NULL, NULL, NULL, NULL, NULL, 4),
(70765, NULL, 'G3DSA:3.40.50.300:FF:004999', NULL, NULL, 'Novel protein similar to Rho GTP-binding proteins', NULL, NULL, NULL, NULL, NULL, 4),
(70766, NULL, 'G3DSA:3.30.710.10:FF:000428', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70767, NULL, 'G3DSA:3.90.105.20:FF:000023', NULL, NULL, 'Ribosomal protein L10 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(70768, NULL, 'G3DSA:1.25.40.10:FF:001119', NULL, NULL, 'Protein THYLAKOID ASSEMBLY 8-like, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(70769, NULL, 'G3DSA:2.10.90.10:FF:000007', NULL, NULL, 'Luteinizing hormone beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(70770, NULL, 'G3DSA:3.90.79.10:FF:000278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70771, NULL, 'G3DSA:2.60.40.10:FF:000507', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(70772, NULL, 'G3DSA:3.40.50.2000:FF:000073', NULL, NULL, 'Starch synthase, chloroplastic/amyloplastic', NULL, NULL, NULL, NULL, NULL, 4),
(70773, NULL, 'G3DSA:3.30.565.10:FF:000326', NULL, NULL, 'Putative histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(70774, NULL, 'G3DSA:3.30.70.330:FF:002687', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70775, NULL, 'G3DSA:3.40.50.300:FF:004763', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70776, NULL, 'G3DSA:3.40.47.10:FF:000049', NULL, NULL, '3-oxoacyl-Acyl-carrier-protein synthase III', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(70777, NULL, 'G3DSA:3.30.160.60:FF:005454', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70778, NULL, 'G3DSA:3.10.300.10:FF:000008', NULL, NULL, 'Putative 3-methyladenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(70779, NULL, 'G3DSA:3.80.10.10:FF:000098', NULL, NULL, 'leucine-rich repeat-containing protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(70780, NULL, 'G3DSA:3.30.70.330:FF:000450', NULL, NULL, 'RNA binding motif, single stranded interacting protein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(70781, NULL, 'G3DSA:2.160.10.10:FF:000063', NULL, NULL, 'Antibiotic acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(70782, NULL, 'G3DSA:1.25.40.20:FF:001072', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(70783, NULL, 'G3DSA:3.40.50.2020:FF:000079', NULL, NULL, 'Ribose-phosphate pyrophosphokinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70784, NULL, 'G3DSA:3.40.50.720:FF:002528', NULL, NULL, 'Fatty acid synthase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(70785, NULL, 'G3DSA:2.60.40.10:FF:004869', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70786, NULL, 'G3DSA:2.30.30.140:FF:000092', NULL, NULL, 'DNA/RNA-binding protein KIN17', NULL, NULL, NULL, NULL, NULL, 4),
(70787, NULL, 'G3DSA:3.80.10.10:FF:001407', NULL, NULL, 'uncharacterized protein LOC100179784', NULL, NULL, NULL, NULL, NULL, 4),
(70788, NULL, 'G3DSA:1.10.510.10:FF:000835', NULL, NULL, 'Serine/threonine-protein kinase BLUS1', NULL, NULL, NULL, NULL, NULL, 4),
(70789, NULL, 'G3DSA:1.10.10.10:FF:000802', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(70790, NULL, 'G3DSA:2.40.50.140:FF:000312', NULL, NULL, 'Exosome complex component CSL4', NULL, NULL, NULL, NULL, NULL, 4),
(70791, NULL, 'G3DSA:3.30.160.60:FF:001648', NULL, NULL, 'zinc finger protein 527 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(70792, NULL, 'G3DSA:1.25.40.20:FF:001448', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70793, NULL, 'G3DSA:3.30.50.10:FF:000097', NULL, NULL, 'Nuclear receptor subfamily 2 group E member 1', NULL, NULL, NULL, NULL, NULL, 4),
(70794, NULL, 'G3DSA:1.20.1250.20:FF:000354', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(70795, NULL, 'G3DSA:3.30.70.330:FF:000214', NULL, NULL, 'Serine/arginine-rich splicing factor 7', NULL, NULL, NULL, NULL, NULL, 4),
(70796, NULL, 'G3DSA:3.80.10.10:FF:001935', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(70797, NULL, 'G3DSA:3.40.50.1240:FF:000159', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70798, NULL, 'G3DSA:1.20.1050.10:FF:000105', NULL, NULL, 'Maleylacetoacetate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(70799, NULL, 'G3DSA:3.40.50.300:FF:008422', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70800, NULL, 'G3DSA:3.10.20.70:FF:000018', NULL, NULL, 'Glutamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(70801, NULL, 'G3DSA:3.30.200.20:FF:001747', NULL, NULL, 'Serine/threonine-protein kinase Nek5', NULL, NULL, NULL, NULL, NULL, 4),
(70802, NULL, 'G3DSA:3.30.310.10:FF:000022', NULL, NULL, 'Transcription initiation factor-like protein (TFIID-like protein)', NULL, NULL, NULL, NULL, NULL, 4),
(70803, NULL, 'G3DSA:1.10.472.80:FF:000177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70804, NULL, 'G3DSA:3.30.590.10:FF:000042', NULL, NULL, 'Glutamate-ligase like protein', NULL, NULL, NULL, NULL, NULL, 4),
(70805, NULL, 'G3DSA:1.20.1250.20:FF:001366', NULL, NULL, 'MFS transporter of unkown specificity (AFU_orthologue AFUA_5G09940)', NULL, NULL, NULL, NULL, NULL, 4),
(70806, NULL, 'G3DSA:2.60.34.10:FF:000089', NULL, NULL, 'Galactosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70807, NULL, 'G3DSA:2.30.330.10:FF:000004', NULL, NULL, 'Flagellar motor switch protein FliM', NULL, NULL, NULL, NULL, NULL, 4),
(70808, NULL, 'G3DSA:3.30.60.90:FF:000020', NULL, NULL, 'Transcriptional adapter', NULL, NULL, NULL, NULL, NULL, 4),
(70809, NULL, 'G3DSA:3.40.30.10:FF:000921', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(70810, NULL, 'G3DSA:2.30.30.790:FF:000022', NULL, NULL, 'Mitochondrial ribosomal protein L19', NULL, NULL, NULL, NULL, NULL, 4),
(70811, NULL, 'G3DSA:1.25.40.20:FF:001420', NULL, NULL, 'Ankyrin repeat and SOCS box-containing 5a', NULL, NULL, NULL, NULL, NULL, 4),
(70812, NULL, 'G3DSA:2.40.128.80:FF:000007', NULL, NULL, 'Dipeptidyl-peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(70813, NULL, 'G3DSA:2.60.260.20:FF:000034', NULL, NULL, 'Chaperone protein DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(70814, NULL, 'G3DSA:2.90.10.10:FF:000055', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase LECRK3', NULL, NULL, NULL, NULL, NULL, 4),
(70815, NULL, 'G3DSA:1.20.120.790:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70816, NULL, 'G3DSA:3.30.70.330:FF:001198', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(70817, NULL, 'G3DSA:3.10.450.540:FF:000002', NULL, NULL, 'ORF13-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(70818, NULL, 'G3DSA:3.20.20.80:FF:000734', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70819, NULL, 'G3DSA:2.60.120.260:FF:000345', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70820, NULL, 'G3DSA:2.60.40.10:FF:004925', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70821, NULL, 'G3DSA:1.20.5.110:FF:000356', NULL, NULL, 'Syntaxin 1A (brain)', NULL, NULL, NULL, NULL, NULL, 4),
(70822, NULL, 'G3DSA:3.40.250.10:FF:000059', NULL, NULL, 'Thiosulfate sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(70823, NULL, 'G3DSA:3.40.50.300:FF:000345', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(70824, NULL, 'G3DSA:3.50.30.30:FF:000090', NULL, NULL, 'Ring finger protein 215', NULL, NULL, NULL, NULL, NULL, 4),
(70825, NULL, 'G3DSA:2.120.10.10:FF:000008', NULL, NULL, 'Exo-alpha-sialidase', NULL, NULL, NULL, NULL, NULL, 4),
(70826, NULL, 'G3DSA:1.10.287.370:FF:000081', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(70827, NULL, 'G3DSA:3.40.50.150:FF:000991', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70828, NULL, 'G3DSA:1.10.510.10:FF:001494', NULL, NULL, 'Kinase, NAK', NULL, NULL, NULL, NULL, NULL, 4),
(70829, NULL, 'G3DSA:1.10.530.10:FF:000073', NULL, NULL, 'Basic endochitinase B', NULL, NULL, NULL, NULL, NULL, 4),
(70830, NULL, 'G3DSA:1.20.5.110:FF:000064', NULL, NULL, 'Vesicle associated membrane protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(70831, NULL, 'G3DSA:2.60.40.350:FF:000003', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(70832, NULL, 'G3DSA:3.90.190.10:FF:000571', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(70833, NULL, 'G3DSA:3.30.160.60:FF:005307', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70834, NULL, 'G3DSA:3.40.630.10:FF:000049', NULL, NULL, 'cytosolic carboxypeptidase-like protein 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(70835, NULL, 'G3DSA:3.80.10.10:FF:000446', NULL, NULL, 'Protein phosphatase 1 regulatory subunit SDS22', NULL, NULL, NULL, NULL, NULL, 4),
(70836, NULL, 'G3DSA:3.40.50.720:FF:002152', NULL, NULL, 'Os03g0147150 protein', NULL, NULL, NULL, NULL, NULL, 4),
(70837, NULL, 'G3DSA:1.10.287.950:FF:000007', NULL, NULL, 'HAMP domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(70838, NULL, 'G3DSA:3.90.190.20:FF:000012', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(70839, NULL, 'G3DSA:2.120.10.80:FF:000248', NULL, NULL, 'leucine-zipper-like transcriptional regulator 1 isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(70840, NULL, 'G3DSA:2.60.40.1180:FF:000143', NULL, NULL, 'Oligo-1,6-glucosidase IMA1', NULL, NULL, NULL, NULL, NULL, 4),
(70841, NULL, 'G3DSA:3.30.70.330:FF:001226', NULL, NULL, 'SRA stem-loop interacting RNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(70842, NULL, 'G3DSA:1.20.1320.30:FF:000003', NULL, NULL, 'Probable ATP-dependent RNA helicase DHX58', NULL, NULL, NULL, NULL, NULL, 4),
(70843, NULL, 'G3DSA:1.20.1250.20:FF:001843', NULL, NULL, 'Transporter', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(70844, NULL, 'G3DSA:3.30.200.20:FF:000494', NULL, NULL, 'serine/threonine-protein kinase WNK2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(70845, NULL, 'G3DSA:3.40.50.1820:FF:000384', NULL, NULL, 'YGR031W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(70846, NULL, 'G3DSA:1.20.1250.20:FF:001658', NULL, NULL, 'Unplaced genomic scaffold supercont2.10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(70847, NULL, 'G3DSA:1.10.150.390:FF:000003', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(70848, NULL, 'G3DSA:1.10.110.10:FF:000018', NULL, NULL, '2S seed storage protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(70849, NULL, 'G3DSA:1.10.150.130:FF:000009', NULL, NULL, 'Tyrosine recombinase XerC', NULL, NULL, NULL, NULL, NULL, 4),
(70850, NULL, 'G3DSA:3.60.140.10:FF:000007', NULL, NULL, 'Polyphenol oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(70851, NULL, 'G3DSA:1.20.1070.10:FF:000399', NULL, NULL, 'KISS1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(70852, NULL, 'G3DSA:2.130.10.10:FF:004257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70853, NULL, 'G3DSA:3.40.50.1460:FF:000017', NULL, NULL, 'Caspase-12', NULL, NULL, NULL, NULL, NULL, 4),
(70854, NULL, 'G3DSA:2.30.250.10:FF:000003', NULL, NULL, 'Probable M18 family aminopeptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(70855, NULL, 'G3DSA:3.40.50.150:FF:000811', NULL, NULL, 'F16P17.4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(70856, NULL, 'G3DSA:1.20.120.1080:FF:000052', NULL, NULL, 'Probable ATP-dependent RNA helicase spindle-E', NULL, NULL, NULL, NULL, NULL, 4),
(70857, NULL, 'G3DSA:1.20.140.80:FF:000005', NULL, NULL, 'Transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(70858, NULL, 'G3DSA:2.10.50.10:FF:000089', NULL, NULL, 'Neurotrophin receptor associated death domain', NULL, NULL, NULL, NULL, NULL, 4),
(70859, NULL, 'G3DSA:1.10.8.60:FF:000136', NULL, NULL, 'Fis family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(70860, NULL, 'G3DSA:3.40.225.10:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70861, NULL, 'G3DSA:3.90.1440.10:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70862, NULL, 'G3DSA:2.30.29.30:FF:000657', NULL, NULL, 'Rho GTPase Activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(70863, NULL, 'G3DSA:3.30.160.60:FF:004493', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70864, NULL, 'G3DSA:3.20.20.70:FF:000821', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70865, NULL, 'G3DSA:1.10.533.10:FF:000079', NULL, NULL, 'IGF like family receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(70866, NULL, 'G3DSA:2.60.40.10:FF:004841', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70867, NULL, 'G3DSA:3.60.40.10:FF:000112', NULL, NULL, 'Ptc6p', NULL, NULL, NULL, NULL, NULL, 4),
(70868, NULL, 'G3DSA:1.20.1250.20:FF:002294', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70869, NULL, 'G3DSA:1.25.40.10:FF:002991', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g13770, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(70870, NULL, 'G3DSA:2.40.50.90:FF:000179', NULL, NULL, 'Tudor domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(70871, NULL, 'G3DSA:2.30.42.10:FF:000620', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70872, NULL, 'G3DSA:3.30.830.10:FF:000050', NULL, NULL, 'Mitochondrial processing peptidase, beta subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70873, NULL, 'G3DSA:2.10.109.10:FF:000062', NULL, NULL, 'Mitochondrial inner membrane protease subunit', NULL, NULL, NULL, NULL, NULL, 4),
(70874, NULL, 'G3DSA:2.130.10.10:FF:004965', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70875, NULL, 'G3DSA:1.20.1440.370:FF:000001', NULL, NULL, 'Multifunctional virulence effector protein DrrA', NULL, NULL, NULL, NULL, NULL, 4),
(70876, NULL, 'G3DSA:2.60.120.40:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70877, NULL, 'G3DSA:3.40.1620.10:FF:000008', NULL, NULL, 'Antitoxin', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(70878, NULL, 'G3DSA:2.40.30.170:FF:000019', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(70879, NULL, 'G3DSA:1.20.1250.10:FF:000109', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70880, NULL, 'G3DSA:1.10.630.10:FF:000249', NULL, NULL, 'Cholesterol side-chain cleavage enzyme, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(70881, NULL, 'G3DSA:1.10.238.10:FF:000466', NULL, NULL, 'Sorting nexin Mvp1', NULL, NULL, NULL, NULL, NULL, 4),
(70882, NULL, 'G3DSA:2.40.50.140:FF:001245', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70883, NULL, 'G3DSA:3.40.50.300:FF:001834', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(70884, NULL, 'G3DSA:3.30.200.20:FF:001455', NULL, NULL, 'Calcium and calcium/calmodulin-dependent serine/threonine-protein kinase DMI-3 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(70885, NULL, 'G3DSA:2.120.10.80:FF:000304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70886, NULL, 'G3DSA:3.40.50.300:FF:000873', NULL, NULL, 'p-loop nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(70887, NULL, 'G3DSA:3.40.50.2300:FF:001326', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70888, NULL, 'G3DSA:1.20.1560.10:FF:000335', NULL, NULL, 'Multiple drug resistance-associated protein-like transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(70889, NULL, 'G3DSA:1.25.40.20:FF:001364', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70890, NULL, 'G3DSA:3.30.200.20:FF:000819', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70891, NULL, 'G3DSA:3.90.190.10:FF:000419', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70892, NULL, 'G3DSA:3.30.160.60:FF:001620', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70893, NULL, 'G3DSA:1.25.40.10:FF:002463', NULL, NULL, 'Pentatricopeptide (PPR) domain protein 40', NULL, NULL, NULL, NULL, NULL, 4),
(70894, NULL, 'G3DSA:3.40.850.10:FF:000116', NULL, NULL, 'Putative kinesin', NULL, NULL, NULL, NULL, NULL, 4),
(70895, NULL, 'G3DSA:3.40.50.410:FF:000142', NULL, NULL, 'Integrator complex subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(70896, NULL, 'G3DSA:3.20.20.60:FF:000015', NULL, NULL, 'Oxaloacetate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(70897, NULL, 'G3DSA:3.30.200.210:FF:000006', NULL, NULL, 'Formate dehydrogenase 2 subunit alpha (cytochrome c-553)', NULL, NULL, NULL, NULL, NULL, 4),
(70898, NULL, 'G3DSA:3.30.50.10:FF:000153', NULL, NULL, 'Protein CBG13679', NULL, NULL, NULL, NULL, NULL, 4),
(70899, NULL, 'G3DSA:1.20.1560.10:FF:000830', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70900, NULL, 'G3DSA:1.10.420.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70901, NULL, 'G3DSA:3.40.50.720:FF:000735', NULL, NULL, '(R,R)-butanediol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(70902, NULL, 'G3DSA:1.10.510.10:FF:001763', NULL, NULL, 'Serine-threonine kinase Stk1', NULL, NULL, NULL, NULL, NULL, 4),
(70903, NULL, 'G3DSA:1.10.10.60:FF:000772', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70904, NULL, 'G3DSA:1.10.510.10:FF:001055', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(70905, NULL, 'G3DSA:3.40.50.970:FF:000141', NULL, NULL, 'Acetolactate synthase-1/2/3 large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(70906, NULL, 'G3DSA:3.40.50.2000:FF:000865', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(70907, NULL, 'G3DSA:3.30.390.30:FF:000044', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(70908, NULL, 'G3DSA:2.60.40.10:FF:002188', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(70909, NULL, 'G3DSA:2.120.10.30:FF:000222', NULL, NULL, 'Dopachrome conversion enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(70910, NULL, 'G3DSA:2.30.29.30:FF:000281', NULL, NULL, 'Actin associated protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(70911, NULL, 'G3DSA:3.40.50.150:FF:001300', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70912, NULL, 'G3DSA:2.40.10.10:FF:000164', NULL, NULL, 'Jonah 66Cii', NULL, NULL, NULL, NULL, NULL, 4),
(70913, NULL, 'G3DSA:3.50.50.60:FF:001353', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(70914, NULL, 'G3DSA:3.50.50.60:FF:000864', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70915, NULL, 'G3DSA:3.40.50.800:FF:000080', NULL, NULL, 'Prolyl Amino-acyl tRNA Synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(70916, NULL, 'G3DSA:3.40.50.720:FF:001224', NULL, NULL, 'RE17220p', NULL, NULL, NULL, NULL, NULL, 4),
(70917, NULL, 'G3DSA:3.20.20.140:FF:000335', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(70918, NULL, 'G3DSA:3.40.190.10:FF:000913', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(70919, NULL, 'G3DSA:3.40.50.10240:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70920, NULL, 'G3DSA:1.25.10.10:FF:001707', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70921, NULL, 'G3DSA:2.60.40.60:FF:000769', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70922, NULL, 'G3DSA:3.30.70.1970:FF:000004', NULL, NULL, 'Terminal uridylyltransferase 3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70923, NULL, 'G3DSA:3.30.70.2740:FF:000011', NULL, NULL, 'FAD-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(70924, NULL, 'G3DSA:2.60.490.10:FF:000014', NULL, NULL, 'Purinergic receptor P2X 7', NULL, NULL, NULL, NULL, NULL, 4),
(70925, NULL, 'G3DSA:3.40.50.2300:FF:000129', NULL, NULL, 'Lactose operon repressor', NULL, NULL, NULL, NULL, NULL, 4),
(70926, NULL, 'G3DSA:3.30.70.141:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70927, NULL, 'G3DSA:3.30.710.10:FF:000395', NULL, NULL, 'BTB/POZ domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(70928, NULL, 'G3DSA:2.40.50.90:FF:000151', NULL, NULL, 'Protein C3orf33 homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(70929, NULL, 'G3DSA:3.30.200.20:FF:001803', NULL, NULL, 'Serine/threonine-protein kinase RAD53', NULL, NULL, NULL, NULL, NULL, 4),
(70930, NULL, 'G3DSA:3.40.50.150:FF:001823', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70931, NULL, 'G3DSA:3.30.160.60:FF:001272', NULL, NULL, 'Zinc finger protein 683', NULL, NULL, NULL, NULL, NULL, 4),
(70932, NULL, 'G3DSA:1.25.40.10:FF:002839', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(70933, NULL, 'G3DSA:1.10.510.10:FF:003000', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70934, NULL, 'G3DSA:2.130.10.30:FF:000053', NULL, NULL, 'Regulator of chromosome condensation', NULL, NULL, NULL, NULL, NULL, 4),
(70935, NULL, 'G3DSA:3.40.47.10:FF:000196', NULL, NULL, 'Polyketide synthase, putative (JCVI)', NULL, NULL, NULL, NULL, NULL, 4),
(70936, NULL, 'G3DSA:3.30.160.60:FF:001087', NULL, NULL, 'Zinc finger and SCAN domain-containing protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(70937, NULL, 'G3DSA:3.30.70.1220:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70938, NULL, 'G3DSA:3.40.33.10:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70939, NULL, 'G3DSA:3.80.10.10:FF:002571', NULL, NULL, 'Transmembrane receptors / ATP binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(70940, NULL, 'G3DSA:3.30.160.60:FF:000783', NULL, NULL, 'Zinc finger and BTB domain-containing protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(70941, NULL, 'G3DSA:1.20.1110.10:FF:000223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70942, NULL, 'G3DSA:1.20.58.1080:FF:000010', NULL, NULL, 'ATP-dependent RNA and DNA helicase, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70943, NULL, 'G3DSA:2.60.40.10:FF:002896', NULL, NULL, 'Ig and fibronectin type-III', NULL, NULL, NULL, NULL, NULL, 4),
(70944, NULL, 'G3DSA:1.20.1420.10:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(70945, NULL, 'G3DSA:3.30.1360.40:FF:000022', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(70946, NULL, 'G3DSA:4.10.1000.10:FF:000052', NULL, NULL, 'Zinc finger CCCH domain-containing protein 33', NULL, NULL, NULL, NULL, NULL, 4),
(70947, NULL, 'G3DSA:2.40.128.20:FF:000035', NULL, NULL, 'Pufferfish saxitoxin and tetrodotoxin binding protein type 2_1', NULL, NULL, NULL, NULL, NULL, 4),
(70948, NULL, 'G3DSA:3.30.420.10:FF:000704', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70949, NULL, 'G3DSA:3.80.10.10:FF:001374', NULL, NULL, 'RNI-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(70950, NULL, 'G3DSA:3.30.450.20:FF:000153', NULL, NULL, 'Protein TWIN LOV 1 isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(70951, NULL, 'G3DSA:3.40.50.300:FF:005016', NULL, NULL, 'DNA repair protein RAD51 homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(70952, NULL, 'G3DSA:1.20.190.60:FF:000002', NULL, NULL, 'Protein CBR-SMG-7', NULL, NULL, NULL, NULL, NULL, 4),
(70953, NULL, 'G3DSA:2.170.300.10:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70954, NULL, 'G3DSA:1.10.720.30:FF:000003', NULL, NULL, 'Mesencephalic astrocyte-derived neurotrophic factor', NULL, NULL, NULL, NULL, NULL, 4),
(70955, NULL, 'G3DSA:3.30.40.10:FF:002305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70956, NULL, 'G3DSA:3.10.129.10:FF:000054', NULL, NULL, 'Putative tol-pal system-associated acyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(70957, NULL, 'G3DSA:2.130.10.10:FF:000311', NULL, NULL, 'general transcription factor 3C polypeptide 2', NULL, NULL, NULL, NULL, NULL, 4),
(70958, NULL, 'G3DSA:1.25.40.10:FF:000574', NULL, NULL, 'Tetratricopeptide repeat domain 37', NULL, NULL, NULL, NULL, NULL, 4),
(70959, NULL, 'G3DSA:1.20.1420.30:FF:000039', NULL, NULL, 'WGS project CABT00000000 data, contig 2.3', NULL, NULL, NULL, NULL, NULL, 4),
(70960, NULL, 'G3DSA:3.40.50.1820:FF:001688', NULL, NULL, 'N-(5-amino-5-carboxypentanoyl)-L-cysteinyl-D-valine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(70961, NULL, 'G3DSA:2.130.10.10:FF:001295', NULL, NULL, 'Putative ubiquitin hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(70962, NULL, 'G3DSA:3.40.50.720:FF:000263', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(70963, NULL, 'G3DSA:3.40.190.10:FF:000565', NULL, NULL, 'GH25591p', NULL, NULL, NULL, NULL, NULL, 4),
(70964, NULL, 'G3DSA:1.25.40.10:FF:000102', NULL, NULL, 'hsp70-Hsp90 organizing protein 3-like', NULL, NULL, NULL, NULL, NULL, 4),
(70965, NULL, 'G3DSA:1.10.10.10:FF:001999', NULL, NULL, 'Glr1369 protein', NULL, NULL, NULL, NULL, NULL, 4),
(70966, NULL, 'G3DSA:3.10.250.10:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70967, NULL, 'G3DSA:3.40.50.11350:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70968, NULL, 'G3DSA:3.90.1300.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70969, NULL, 'G3DSA:3.40.50.300:FF:008186', NULL, NULL, 'GTP-binding protein-related', NULL, NULL, NULL, NULL, NULL, 4),
(70970, NULL, 'G3DSA:1.20.1510.10:FF:000063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70971, NULL, 'G3DSA:2.60.40.60:FF:000825', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70972, NULL, 'G3DSA:3.30.160.60:FF:004998', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70973, NULL, 'G3DSA:3.30.450.20:FF:000630', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70974, NULL, 'G3DSA:1.25.10.10:FF:001590', NULL, NULL, 'Sister chromatid cohesion protein', NULL, NULL, NULL, NULL, NULL, 4),
(70975, NULL, 'G3DSA:3.30.428.10:FF:000025', NULL, NULL, 'Histidine triad protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70976, NULL, 'G3DSA:3.40.140.20:FF:000003', NULL, NULL, 'Bifunctional purine biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(70977, NULL, 'G3DSA:3.40.1110.10:FF:000341', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(70978, NULL, 'G3DSA:3.30.70.20:FF:000101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70979, NULL, 'G3DSA:1.10.238.10:FF:000697', NULL, NULL, 'EF-hand domain pair/EF-hand domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(70980, NULL, 'G3DSA:2.60.120.200:FF:000226', NULL, NULL, 'Multidomain scavenger receptor', NULL, NULL, NULL, NULL, NULL, 4),
(70981, NULL, 'G3DSA:3.40.190.10:FF:000621', NULL, NULL, 'Sulfonate transport system substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(70982, NULL, 'G3DSA:3.40.50.12160:FF:000012', NULL, NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(70983, NULL, 'G3DSA:3.30.70.330:FF:001670', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70984, NULL, 'G3DSA:3.30.2340.10:FF:000006', NULL, NULL, 'tRNA pseudouridine synthase D', NULL, NULL, NULL, NULL, NULL, 4),
(70985, NULL, 'G3DSA:3.10.129.10:FF:000110', NULL, NULL, 'Bifunctional hydroxyacyl-CoA dehydrogenase/enoyl-CoA hydratase fox2', NULL, NULL, NULL, NULL, NULL, 4),
(70986, NULL, 'G3DSA:3.40.1280.10:FF:000055', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4),
(70987, NULL, 'G3DSA:1.20.1440.90:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(70988, NULL, 'G3DSA:1.10.10.10:FF:001527', NULL, NULL, 'Amx-1', NULL, NULL, NULL, NULL, NULL, 4),
(70989, NULL, 'G3DSA:1.25.10.10:FF:001062', NULL, NULL, 'Exportin 4', NULL, NULL, NULL, NULL, NULL, 4),
(70990, NULL, 'G3DSA:1.20.1070.10:FF:001124', NULL, NULL, 'Neuropeptide FF receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(70991, NULL, 'G3DSA:3.30.200.20:FF:000527', NULL, NULL, 'mitogen-activated protein kinase kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(70992, NULL, 'G3DSA:1.10.220.150:FF:000004', NULL, NULL, 'Putative ADP-ribosylation factor GTPase-activating protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(70993, NULL, 'G3DSA:3.50.50.60:FF:000572', NULL, NULL, 'Tryptophan 2-monooxygenase oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(70994, NULL, 'G3DSA:3.30.460.10:FF:000122', NULL, NULL, 'YALI0D12364p', NULL, NULL, NULL, NULL, NULL, 4),
(70995, NULL, 'G3DSA:3.50.7.10:FF:000020', NULL, NULL, 'Chaperonin 1 60 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(70996, NULL, 'G3DSA:2.120.10.30:FF:000514', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70997, NULL, 'G3DSA:2.30.29.30:FF:000573', NULL, NULL, 'Oxysterol-binding family protein', NULL, NULL, NULL, NULL, NULL, 4),
(70998, NULL, 'G3DSA:3.10.20.230:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(70999, NULL, 'G3DSA:2.60.40.10:FF:004133', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71000, NULL, 'G3DSA:3.40.366.10:FF:000024', NULL, NULL, 'Phenolpthiocerol synthesis type-I polyketide synthase PPSE', NULL, NULL, NULL, NULL, NULL, 4),
(71001, NULL, 'G3DSA:3.30.160.60:FF:002868', NULL, NULL, 'GD16882', NULL, NULL, NULL, NULL, NULL, 4),
(71002, NULL, 'G3DSA:1.10.357.50:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71003, NULL, 'G3DSA:3.20.20.140:FF:000071', NULL, NULL, 'Dihydroorotase, homodimeric type, variant', NULL, NULL, NULL, NULL, NULL, 4),
(71004, NULL, 'G3DSA:1.20.1250.20:FF:001282', NULL, NULL, 'Basic amino acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(71005, NULL, 'G3DSA:3.30.200.20:FF:001039', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71006, NULL, 'G3DSA:3.40.1110.10:FF:000009', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(71007, NULL, 'G3DSA:3.80.10.10:FF:002419', NULL, NULL, 'Extracellular matrix protein 2, female organ and adipocyte-specific, gene 2', NULL, NULL, NULL, NULL, NULL, 4),
(71008, NULL, 'G3DSA:3.40.50.2000:FF:000629', NULL, NULL, 'Protein CBR-UGT-50', NULL, NULL, NULL, NULL, NULL, 4),
(71009, NULL, 'G3DSA:2.60.40.10:FF:003621', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71010, NULL, 'G3DSA:4.10.60.10:FF:000074', NULL, NULL, 'Cleavage polyadenylation factor subunit', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(71011, NULL, 'G3DSA:3.50.50.60:FF:000717', NULL, NULL, 'Glutamate synthase, small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(71012, NULL, 'G3DSA:3.80.10.10:FF:002043', NULL, NULL, 'Acid labile subunit', NULL, NULL, NULL, NULL, NULL, 4),
(71013, NULL, 'G3DSA:1.10.275.10:FF:000018', NULL, NULL, 'Argininosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(71014, NULL, 'G3DSA:3.40.50.410:FF:000378', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71015, NULL, 'G3DSA:2.10.25.10:FF:000429', NULL, NULL, 'Cubilin', NULL, NULL, NULL, NULL, NULL, 4),
(71016, NULL, 'G3DSA:2.130.10.10:FF:004526', NULL, NULL, 'Protein CBG07276', NULL, NULL, NULL, NULL, NULL, 4),
(71017, NULL, 'G3DSA:2.40.70.10:FF:000229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71018, NULL, 'G3DSA:3.20.20.300:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71019, NULL, 'G3DSA:1.10.472.10:FF:000673', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71020, NULL, 'G3DSA:4.10.60.10:FF:000130', NULL, NULL, 'Cellular nucleic acid binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71021, NULL, 'G3DSA:3.40.50.300:FF:003835', NULL, NULL, 'Twitching motility pilus retraction ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(71022, NULL, 'G3DSA:1.10.510.10:FF:002275', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71023, NULL, 'G3DSA:1.20.930.10:FF:000005', NULL, NULL, 'PC4 and SFRS1-interacting protein-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(71024, NULL, 'G3DSA:1.25.10.10:FF:000746', NULL, NULL, 'Dynein assembly factor 5, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(71025, NULL, 'G3DSA:1.20.5.320:FF:000014', NULL, NULL, 'Fibritin', NULL, NULL, NULL, NULL, NULL, 4),
(71026, NULL, 'G3DSA:2.170.150.20:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71027, NULL, 'G3DSA:2.40.100.10:FF:000058', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(71028, NULL, 'G3DSA:3.40.50.300:FF:003779', NULL, NULL, '6-phosphofructo 2-kinase/fructose 2,6-bisphosphatase short form', NULL, NULL, NULL, NULL, NULL, 4),
(71029, NULL, 'G3DSA:1.25.40.10:FF:000046', NULL, NULL, 'Prolyl 3-hydroxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(71030, NULL, 'G3DSA:2.60.40.10:FF:001171', NULL, NULL, 'PKHD1, fibrocystin/polyductin', NULL, NULL, NULL, NULL, NULL, 4),
(71031, NULL, 'G3DSA:2.50.20.10:FF:000001', NULL, NULL, 'Outer-membrane lipoprotein carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(71032, NULL, 'G3DSA:1.20.1070.10:FF:000719', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71033, NULL, 'G3DSA:2.60.120.200:FF:000698', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71034, NULL, 'G3DSA:3.10.110.10:FF:000325', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71035, NULL, 'G3DSA:1.20.144.10:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71036, NULL, 'G3DSA:1.20.1070.10:FF:001596', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71037, NULL, 'G3DSA:3.30.1180.20:FF:000007', NULL, NULL, 'Dihydroxyacetone kinase', NULL, NULL, NULL, NULL, NULL, 4),
(71038, NULL, 'G3DSA:1.20.5.170:FF:000003', NULL, NULL, 'cAMP-responsive element modulator isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(71039, NULL, 'G3DSA:2.130.10.130:FF:000010', NULL, NULL, 'Glycosylphosphatidylinositol specific phospholipase D1', NULL, NULL, NULL, NULL, NULL, 4),
(71040, NULL, 'G3DSA:1.20.120.1750:FF:000005', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(71041, NULL, 'G3DSA:1.20.120.420:FF:000009', NULL, NULL, 'Gcd7p', NULL, NULL, NULL, NULL, NULL, 4),
(71042, NULL, 'G3DSA:3.30.230.10:FF:000313', NULL, NULL, 'GHMP kinases putative ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(71043, NULL, 'G3DSA:3.30.460.10:FF:000066', NULL, NULL, 'Dephospho-CoA kinase', NULL, NULL, NULL, NULL, NULL, 4),
(71044, NULL, 'G3DSA:3.30.540.10:FF:000067', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(71045, NULL, 'G3DSA:3.40.50.1820:FF:000704', NULL, NULL, 'Peptide synthetase ORF5', NULL, NULL, NULL, NULL, NULL, 4),
(71046, NULL, 'G3DSA:1.10.630.10:FF:000305', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71047, NULL, 'G3DSA:3.30.160.60:FF:002492', NULL, NULL, 'ZNF683 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(71048, NULL, 'G3DSA:3.80.10.10:FF:000862', NULL, NULL, 'NACHT, LRR and PYD domains-containing protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(71049, NULL, 'G3DSA:2.120.10.30:FF:000458', NULL, NULL, 'Nhl repeat-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71050, NULL, 'G3DSA:1.25.40.10:FF:004317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71051, NULL, 'G3DSA:3.40.50.2300:FF:000657', NULL, NULL, 'Two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(71052, NULL, 'G3DSA:4.10.1240.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71053, NULL, 'G3DSA:1.10.1760.20:FF:000002', NULL, NULL, 'Sensor histidine kinase YpdA', NULL, NULL, NULL, NULL, NULL, 4),
(71054, NULL, 'G3DSA:1.10.418.10:FF:000267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71055, NULL, 'G3DSA:1.10.8.60:FF:000552', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71056, NULL, 'G3DSA:1.25.10.10:FF:001910', NULL, NULL, 'Probable serine/threonine-protein kinase vps15', NULL, NULL, NULL, NULL, NULL, 4),
(71057, NULL, 'G3DSA:3.90.226.10:FF:000048', NULL, NULL, '3,2-trans-enoyl-CoA isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(71058, NULL, 'G3DSA:1.25.40.10:FF:003008', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At3g15130', NULL, NULL, NULL, NULL, NULL, 4),
(71059, NULL, 'G3DSA:3.40.50.620:FF:000379', NULL, NULL, 'RE11660p', NULL, NULL, NULL, NULL, NULL, 4),
(71060, NULL, 'G3DSA:3.30.160.20:FF:000142', NULL, NULL, 'Tapas, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(71061, NULL, 'G3DSA:4.10.240.10:FF:000202', NULL, NULL, 'Uncharacterized transcriptional regulatory protein C1773.16c', NULL, NULL, NULL, NULL, NULL, 4),
(71062, NULL, 'G3DSA:3.10.110.10:FF:000180', NULL, NULL, 'Ubiquitin-conjugating enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(71063, NULL, 'G3DSA:2.30.39.10:FF:000005', NULL, NULL, 'neuroserpin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(71064, NULL, 'G3DSA:3.80.20.20:FF:000040', NULL, NULL, 'Cell surface GPI-anchored protein ECM33', NULL, NULL, NULL, NULL, NULL, 4),
(71065, NULL, 'G3DSA:3.30.2350.20:FF:000077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71066, NULL, 'G3DSA:3.90.550.10:FF:000582', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(71067, NULL, 'G3DSA:3.40.1190.20:FF:000085', NULL, NULL, 'Carbohydrate kinase, PfkB family', NULL, NULL, NULL, NULL, NULL, 4),
(71068, NULL, 'G3DSA:2.10.25.10:FF:000761', NULL, NULL, 'Protein lin-3', NULL, NULL, NULL, NULL, NULL, 4),
(71069, NULL, 'G3DSA:3.40.50.2000:FF:001034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71070, NULL, 'G3DSA:3.80.10.10:FF:003824', NULL, NULL, 'F-box/LRR-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71071, NULL, 'G3DSA:3.30.70.870:FF:000022', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(71072, NULL, 'G3DSA:1.10.10.60:FF:000300', NULL, NULL, 'Myb transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(71073, NULL, 'G3DSA:3.40.50.1360:FF:000049', NULL, NULL, '6-phosphogluconolactonase', NULL, NULL, NULL, NULL, NULL, 4),
(71074, NULL, 'G3DSA:3.10.110.10:FF:000269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71075, NULL, 'G3DSA:1.10.8.270:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71076, NULL, 'G3DSA:1.20.120.550:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71077, NULL, 'G3DSA:2.60.40.10:FF:000390', NULL, NULL, 'Protein tyrosine kinase 7 (inactive)', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(71078, NULL, 'G3DSA:1.10.630.10:FF:000018', NULL, NULL, 'Cytochrome P450 monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(71079, NULL, 'G3DSA:2.10.25.10:FF:001273', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(71080, NULL, 'G3DSA:1.25.40.620:FF:000005', NULL, NULL, 'Slr1958 protein', NULL, NULL, NULL, NULL, NULL, 4),
(71081, NULL, 'G3DSA:3.20.20.190:FF:000092', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(71082, NULL, 'G3DSA:3.30.1490.180:FF:000020', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(71083, NULL, 'G3DSA:3.40.630.10:FF:000285', NULL, NULL, 'Putative aminopeptidase C13A11.05', NULL, NULL, NULL, NULL, NULL, 4),
(71084, NULL, 'G3DSA:3.90.370.10:FF:000012', NULL, NULL, 'AGAP003319-PA', NULL, NULL, NULL, NULL, NULL, 4),
(71085, NULL, 'G3DSA:3.30.420.40:FF:000808', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71086, NULL, 'G3DSA:1.25.40.340:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71087, NULL, 'G3DSA:3.40.50.300:FF:003127', NULL, NULL, 'Polyphosphate:AMP phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(71088, NULL, 'G3DSA:3.30.70.3270:FF:000018', NULL, NULL, 'NADH-quinone oxidoreductase subunit I 2', NULL, NULL, NULL, NULL, NULL, 4),
(71089, NULL, 'G3DSA:3.30.750.24:FF:000091', NULL, NULL, 'GM25771', NULL, NULL, NULL, NULL, NULL, 4),
(71090, NULL, 'G3DSA:3.40.50.300:FF:001418', NULL, NULL, 'Heparan sulfate 2-o-sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(71091, NULL, 'G3DSA:2.130.10.10:FF:003745', NULL, NULL, 'Uncharacterized WD repeat-containing protein C2A9.03', NULL, NULL, NULL, NULL, NULL, 4),
(71092, NULL, 'G3DSA:3.40.50.10810:FF:000264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71093, NULL, 'G3DSA:1.10.472.130:FF:000021', NULL, NULL, 'Dynein beta chain, ciliary', NULL, NULL, NULL, NULL, NULL, 4),
(71094, NULL, 'G3DSA:3.40.50.2000:FF:000781', NULL, NULL, 'Os04g0271800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(71095, NULL, 'G3DSA:3.40.50.720:FF:001516', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71096, NULL, 'G3DSA:3.40.50.150:FF:001031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71097, NULL, 'G3DSA:3.30.1640.10:FF:000085', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(71098, NULL, 'G3DSA:3.20.20.80:FF:000650', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71099, NULL, 'G3DSA:1.25.40.180:FF:000087', NULL, NULL, 'Putative eukaryotic translation initation factor 4 gamma', NULL, NULL, NULL, NULL, NULL, 4),
(71100, NULL, 'G3DSA:1.25.10.10:FF:000218', NULL, NULL, 'lisH domain and HEAT repeat-containing protein KIAA1468 homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(71101, NULL, 'G3DSA:2.130.10.10:FF:005038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71102, NULL, 'G3DSA:1.20.1250.20:FF:000438', NULL, NULL, 'Major facilitator transporter', NULL, NULL, NULL, NULL, NULL, 4),
(71103, NULL, 'G3DSA:3.40.50.1820:FF:001429', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71104, NULL, 'G3DSA:1.10.287.70:FF:000333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71105, NULL, 'G3DSA:1.20.1250.20:FF:000062', NULL, NULL, 'Protein NRT1/ PTR FAMILY 1.2', NULL, NULL, NULL, NULL, NULL, 4),
(71106, NULL, 'G3DSA:1.10.287.70:FF:000709', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(71107, NULL, 'G3DSA:1.10.1420.10:FF:000215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71108, NULL, 'G3DSA:3.30.160.60:FF:001564', NULL, NULL, 'zinc finger protein 827 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(71109, NULL, 'G3DSA:3.40.50.300:FF:008506', NULL, NULL, 'UvrD/REP helicase domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71110, NULL, 'G3DSA:3.30.70.3250:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(71111, NULL, 'G3DSA:3.30.300.160:FF:000025', NULL, NULL, 'General secretion pathway protein E', NULL, NULL, NULL, NULL, NULL, 4),
(71112, NULL, 'G3DSA:3.40.1190.10:FF:000025', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(71113, NULL, 'G3DSA:3.20.20.150:FF:000017', NULL, NULL, 'Endonuclease IV related protein', NULL, NULL, NULL, NULL, NULL, 4),
(71114, NULL, 'G3DSA:1.20.120.810:FF:000003', NULL, NULL, 'Vinculin b', NULL, NULL, NULL, NULL, NULL, 4),
(71115, NULL, 'G3DSA:2.10.25.10:FF:000053', NULL, NULL, 'Slit guidance ligand 2', NULL, NULL, NULL, NULL, NULL, 4),
(71116, NULL, 'G3DSA:1.10.472.20:FF:000002', NULL, NULL, 'Nitrile hydratase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(71117, NULL, 'G3DSA:3.30.559.10:FF:000093', NULL, NULL, 'Carnitine acyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71118, NULL, 'G3DSA:1.20.5.510:FF:000004', NULL, NULL, 'Ephrin type-A receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(71119, NULL, 'G3DSA:1.25.40.10:FF:005245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71120, NULL, 'G3DSA:3.90.1150.10:FF:000056', NULL, NULL, 'Kynureninase', NULL, NULL, NULL, NULL, NULL, 4),
(71121, NULL, 'G3DSA:1.20.1560.10:FF:000627', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71122, NULL, 'G3DSA:3.40.850.10:FF:000032', NULL, NULL, 'kinesin-like protein KIN-4A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(71123, NULL, 'G3DSA:3.80.10.10:FF:001115', NULL, NULL, 'Protein phosphatase 2C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71124, NULL, 'G3DSA:1.10.472.10:FF:000145', NULL, NULL, 'Plant-specific TFIIB-related protein PTF2', NULL, NULL, NULL, NULL, NULL, 4),
(71125, NULL, 'G3DSA:3.30.70.330:FF:001142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71126, NULL, 'G3DSA:3.30.1240.10:FF:000004', NULL, NULL, 'Cof-like hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(71127, NULL, 'G3DSA:3.40.50.150:FF:000047', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase G', NULL, NULL, NULL, NULL, NULL, 4),
(71128, NULL, 'G3DSA:2.130.10.10:FF:005370', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71129, NULL, 'G3DSA:3.30.160.60:FF:006235', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71130, NULL, 'G3DSA:3.30.930.10:FF:000411', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71131, NULL, 'G3DSA:3.100.10.10:FF:000016', NULL, NULL, '50S ribosomal protein L15', NULL, NULL, NULL, NULL, NULL, 4),
(71132, NULL, 'G3DSA:3.40.50.300:FF:001042', NULL, NULL, 'DNA repair protein RAD51 homolog 4', NULL, NULL, NULL, NULL, NULL, 4),
(71133, NULL, 'G3DSA:2.10.10.20:FF:000005', NULL, NULL, 'Chitodextrinase', NULL, NULL, NULL, NULL, NULL, 4),
(71134, NULL, 'G3DSA:2.60.40.1190:FF:000005', NULL, NULL, 'Glycoside hydrolase family 93', NULL, NULL, NULL, NULL, NULL, 4),
(71135, NULL, 'G3DSA:1.10.472.100:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71136, NULL, 'G3DSA:3.60.40.10:FF:000056', NULL, NULL, 'Probable protein phosphatase 2C 18', NULL, NULL, NULL, NULL, NULL, 4),
(71137, NULL, 'G3DSA:1.10.1790.10:FF:000001', NULL, NULL, 'Cryptic beta-glucoside bgl operon antiterminator', NULL, NULL, NULL, NULL, NULL, 4),
(71138, NULL, 'G3DSA:1.10.510.10:FF:000982', NULL, NULL, 'AGC protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(71139, NULL, 'G3DSA:6.10.140.2150:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71140, NULL, 'G3DSA:2.40.70.10:FF:000381', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71141, NULL, 'G3DSA:2.60.40.10:FF:004077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71142, NULL, 'G3DSA:3.40.50.720:FF:000443', NULL, NULL, 'FAD dependent oxidoreductase superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(71143, NULL, 'G3DSA:1.25.40.10:FF:002608', NULL, NULL, 'Os03g0582100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(71144, NULL, 'G3DSA:1.25.10.10:FF:000926', NULL, NULL, '26S proteasome regulatory subunit, putative', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(71145, NULL, 'G3DSA:2.130.10.10:FF:001475', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71146, NULL, 'G3DSA:2.60.40.150:FF:000707', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(71147, NULL, 'G3DSA:3.90.70.10:FF:000753', NULL, NULL, 'Cathepsin 3', NULL, NULL, NULL, NULL, NULL, 4),
(71148, NULL, 'G3DSA:1.25.40.10:FF:003160', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g30700', NULL, NULL, NULL, NULL, NULL, 4),
(71149, NULL, 'G3DSA:3.40.50.1980:FF:000055', NULL, NULL, 'Putative iron ABC transporter, substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(71150, NULL, 'G3DSA:1.10.510.10:FF:002308', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71151, NULL, 'G3DSA:3.10.450.50:FF:000071', NULL, NULL, 'Protein translocase subunit SecA 1', NULL, NULL, NULL, NULL, NULL, 4),
(71152, NULL, 'G3DSA:3.30.310.80:FF:000059', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(71153, NULL, 'G3DSA:2.60.40.10:FF:003060', NULL, NULL, 'Interleukin 12 receptor subunit beta 2', NULL, NULL, NULL, NULL, NULL, 4),
(71154, NULL, 'G3DSA:1.25.40.10:FF:000754', NULL, NULL, 'TPR repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(71155, NULL, 'G3DSA:2.30.30.140:FF:000001', NULL, NULL, 'Fragile X mental retardation 1, isoform CRA_e', NULL, NULL, NULL, NULL, NULL, 4),
(71156, NULL, 'G3DSA:1.25.40.10:FF:000810', NULL, NULL, 'protein SMG5', NULL, NULL, NULL, NULL, NULL, 4),
(71157, NULL, 'G3DSA:3.40.50.200:FF:000141', NULL, NULL, 'Subtilisin-like serine endopeptidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(71158, NULL, 'G3DSA:1.20.1270.60:FF:000081', NULL, NULL, 'Sorting nexin 2B', NULL, NULL, NULL, NULL, NULL, 4),
(71159, NULL, 'G3DSA:1.20.58.60:FF:000134', NULL, NULL, 'microtubule-actin cross-linking factor 1 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(71160, NULL, 'G3DSA:2.60.120.230:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71161, NULL, 'G3DSA:2.60.120.330:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71162, NULL, 'G3DSA:3.40.50.2300:FF:001585', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71163, NULL, 'G3DSA:2.30.29.30:FF:001298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71164, NULL, 'G3DSA:4.10.260.10:FF:000001', NULL, NULL, 'Guanine nucleotide-binding protein subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(71165, NULL, 'G3DSA:1.20.58.1800:FF:000001', NULL, NULL, 'Alpha,alpha-trehalose-phosphate synthase [UDP-forming] 1', NULL, NULL, NULL, NULL, NULL, 4),
(71166, NULL, 'G3DSA:1.20.1250.20:FF:002063', NULL, NULL, 'Solute carrier family 2, facilitated glucose transporter member 5', NULL, NULL, NULL, NULL, NULL, 4),
(71167, NULL, 'G3DSA:3.30.870.10:FF:000024', NULL, NULL, 'Cardiolipin synthase C', NULL, NULL, NULL, NULL, NULL, 4),
(71168, NULL, 'G3DSA:1.10.510.10:FF:002836', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71169, NULL, 'G3DSA:3.40.50.1820:FF:000468', NULL, NULL, 'Esterase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(71170, NULL, 'G3DSA:3.60.10.10:FF:000228', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71171, NULL, 'G3DSA:3.40.50.11260:FF:000017', NULL, NULL, 'Chaperone protein HtpG', NULL, NULL, NULL, NULL, NULL, 4),
(71172, NULL, 'G3DSA:2.60.120.260:FF:000261', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(71173, NULL, 'G3DSA:2.30.29.30:FF:001354', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71174, NULL, 'G3DSA:2.60.40.10:FF:001204', NULL, NULL, 'T-cell surface glycoprotein CD4', NULL, NULL, NULL, NULL, NULL, 4),
(71175, NULL, 'G3DSA:3.30.70.270:FF:000258', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71176, NULL, 'G3DSA:1.20.1070.10:FF:002052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71177, NULL, 'G3DSA:2.130.10.10:FF:005746', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71178, NULL, 'G3DSA:2.10.25.10:FF:000609', NULL, NULL, 'delta and Notch-like epidermal growth factor-related receptor', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(71179, NULL, 'G3DSA:3.80.10.10:FF:002099', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71180, NULL, 'G3DSA:3.30.70.590:FF:000005', NULL, NULL, 'Nuclear poly(A) polymerase 3', NULL, NULL, NULL, NULL, NULL, 4),
(71181, NULL, 'G3DSA:2.170.270.10:FF:000112', NULL, NULL, 'ATP-grasp domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71182, NULL, 'G3DSA:3.60.20.10:FF:000021', NULL, NULL, 'glutamine--fructose-6-phosphate aminotransferase [isomerizing] 1', NULL, NULL, NULL, NULL, NULL, 4),
(71183, NULL, 'G3DSA:1.10.510.10:FF:002983', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71184, NULL, 'G3DSA:3.30.70.3030:FF:000002', NULL, NULL, 'U3 small nucleolar RNA-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(71185, NULL, 'G3DSA:1.10.472.80:FF:000233', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71186, NULL, 'G3DSA:3.40.50.2300:FF:000601', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71187, NULL, 'G3DSA:3.30.750.44:FF:000006', NULL, NULL, 'retinol-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(71188, NULL, 'G3DSA:1.25.40.10:FF:001030', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g09190', NULL, NULL, NULL, NULL, NULL, 4),
(71189, NULL, 'G3DSA:2.60.40.10:FF:001019', NULL, NULL, 'Sallimus, isoform P', NULL, NULL, NULL, NULL, NULL, 4),
(71190, NULL, 'G3DSA:3.30.200.20:FF:000022', NULL, NULL, 'Homeodomain-interacting protein kinase 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(71191, NULL, 'G3DSA:1.10.460.10:FF:000005', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(71192, NULL, 'G3DSA:1.10.8.590:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71193, NULL, 'G3DSA:3.30.70.100:FF:000106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71194, NULL, 'G3DSA:2.160.20.120:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71195, NULL, 'G3DSA:3.30.710.10:FF:000136', NULL, NULL, 'BTB-POZ and math domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(71196, NULL, 'G3DSA:3.30.1330.30:FF:000045', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71197, NULL, 'G3DSA:3.90.290.10:FF:000011', NULL, NULL, 'Fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(71198, NULL, 'G3DSA:1.20.58.60:FF:000281', NULL, NULL, 'Utrophin', NULL, NULL, NULL, NULL, NULL, 4),
(71199, NULL, 'G3DSA:3.40.50.1100:FF:000022', NULL, NULL, 'Threonine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(71200, NULL, 'G3DSA:3.30.559.30:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71201, NULL, 'G3DSA:4.10.800.10:FF:000026', NULL, NULL, 'Insulin-like growth factor binding protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(71202, NULL, 'G3DSA:2.60.40.420:FF:000047', NULL, NULL, 'Coagulation factor VIII', NULL, NULL, NULL, NULL, NULL, 4),
(71203, NULL, 'G3DSA:2.130.10.10:FF:003184', NULL, NULL, 'NLE (NUC135) domain/WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71204, NULL, 'G3DSA:2.60.120.970:FF:000086', NULL, NULL, 'Growth differentiation factor 9', NULL, NULL, NULL, NULL, NULL, 4),
(71205, NULL, 'G3DSA:3.40.50.1000:FF:000666', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71206, NULL, 'G3DSA:1.10.10.250:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71207, NULL, 'G3DSA:1.10.510.10:FF:004017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71208, NULL, 'G3DSA:3.30.740.10:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71209, NULL, 'G3DSA:3.40.50.300:FF:000401', NULL, NULL, 'UvrABC system protein B', NULL, NULL, NULL, NULL, NULL, 4),
(71210, NULL, 'G3DSA:3.30.479.20:FF:000056', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(71211, NULL, 'G3DSA:3.30.950.10:FF:000025', NULL, NULL, 'Uroporphyrinogen-III C-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(71212, NULL, 'G3DSA:1.10.10.10:FF:000746', NULL, NULL, 'Arabinose metabolism transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(71213, NULL, 'G3DSA:3.90.215.10:FF:000023', NULL, NULL, 'Angiopoietin-like 3', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(71214, NULL, 'G3DSA:3.30.2010.10:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71215, NULL, 'G3DSA:2.130.10.10:FF:001328', NULL, NULL, 'Ribosome biogenesis protein WDR12 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(71216, NULL, 'G3DSA:1.20.1720.10:FF:000073', NULL, NULL, 'Efflux pump protein', NULL, NULL, NULL, NULL, NULL, 4),
(71217, NULL, 'G3DSA:2.60.120.260:FF:000637', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71218, NULL, 'G3DSA:2.20.70.10:FF:000275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71219, NULL, 'G3DSA:3.30.70.1620:FF:000006', NULL, NULL, 'Structural maintenance of chromosomes protein', NULL, NULL, NULL, NULL, NULL, 4),
(71220, NULL, 'G3DSA:4.10.830.40:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71221, NULL, 'G3DSA:3.30.70.330:FF:001703', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71222, NULL, 'G3DSA:1.25.40.10:FF:000607', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(71223, NULL, 'G3DSA:3.30.590.50:FF:000003', NULL, NULL, 'Glutamate--cysteine ligase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(71224, NULL, 'G3DSA:3.80.10.10:FF:000154', NULL, NULL, 'Follicle-stimulating hormone receptor', NULL, NULL, NULL, NULL, NULL, 4),
(71225, NULL, 'G3DSA:1.20.1310.10:FF:000019', NULL, NULL, 'Cullin 1', NULL, NULL, NULL, NULL, NULL, 4),
(71226, NULL, 'G3DSA:3.40.850.10:FF:000560', NULL, NULL, 'Kinesin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71227, NULL, 'G3DSA:3.90.70.80:FF:000026', NULL, NULL, 'Ovarian tumor-like cysteine protease', NULL, NULL, NULL, NULL, NULL, 4),
(71228, NULL, 'G3DSA:2.10.70.80:FF:000009', NULL, NULL, 'Vacuolar protein sorting/targeting protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(71229, NULL, 'G3DSA:1.20.920.10:FF:000179', NULL, NULL, 'Bromodomain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(71230, NULL, 'G3DSA:3.40.50.20:FF:000021', NULL, NULL, 'Biotin carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(71231, NULL, 'G3DSA:3.30.420.40:FF:000960', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71232, NULL, 'G3DSA:3.80.10.10:FF:003791', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71233, NULL, 'G3DSA:2.20.110.10:FF:000018', NULL, NULL, 'MORN repeat-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(71234, NULL, 'G3DSA:2.30.39.10:FF:000152', NULL, NULL, 'Serpin peptidase inhibitor, clade B (ovalbumin), member 1', NULL, NULL, NULL, NULL, NULL, 4),
(71235, NULL, 'G3DSA:3.30.60.60:FF:000005', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(71236, NULL, 'G3DSA:3.10.100.10:FF:000443', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71237, NULL, 'G3DSA:3.30.260.10:FF:000085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71238, NULL, 'G3DSA:3.30.56.10:FF:000020', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(71239, NULL, 'G3DSA:1.20.900.10:FF:000037', NULL, NULL, 'Protostome-specific GEF, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(71240, NULL, 'G3DSA:1.20.1070.10:FF:001091', NULL, NULL, 'Dopamine receptor D6b', NULL, NULL, NULL, NULL, NULL, 4),
(71241, NULL, 'G3DSA:3.30.1680.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71242, NULL, 'G3DSA:3.40.390.10:FF:000277', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71243, NULL, 'G3DSA:3.40.50.880:FF:000030', NULL, NULL, 'Gamma-glutamyl-gamma-aminobutyrate hydrolase PuuD', NULL, NULL, NULL, NULL, NULL, 4),
(71244, NULL, 'G3DSA:1.25.10.10:FF:002219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71245, NULL, 'G3DSA:3.40.50.300:FF:008130', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71246, NULL, 'G3DSA:3.40.50.150:FF:000575', NULL, NULL, 'Type 11 methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(71247, NULL, 'G3DSA:1.10.8.720:FF:000007', NULL, NULL, 'Dynein axonemal heavy chain 6', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(71248, NULL, 'G3DSA:3.75.10.20:FF:000001', NULL, NULL, 'N-succinylarginine dihydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(71249, NULL, 'G3DSA:2.40.50.140:FF:000604', NULL, NULL, 'Ribosomal protein S28-like', NULL, NULL, NULL, NULL, NULL, 4),
(71250, NULL, 'G3DSA:3.40.1110.10:FF:000397', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71251, NULL, 'G3DSA:3.30.420.10:FF:000468', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71252, NULL, 'G3DSA:2.40.30.10:FF:000255', NULL, NULL, 'Siderophore-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(71253, NULL, 'G3DSA:1.10.510.10:FF:000330', NULL, NULL, '3-phosphoinositide-dependent protein kinase 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(71254, NULL, 'G3DSA:2.30.30.40:FF:000444', NULL, NULL, 'neutrophil cytosolic factor 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(71255, NULL, 'G3DSA:3.30.9.10:FF:000035', NULL, NULL, 'Putative oxidoreductase TDA3', NULL, NULL, NULL, NULL, NULL, 4),
(71256, NULL, 'G3DSA:1.20.1250.10:FF:000020', NULL, NULL, 'Interleukin-12 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(71257, NULL, 'G3DSA:1.10.287.130:FF:000060', NULL, NULL, 'ATPase/histidine kinase/DNA gyrase B/HSP90 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(71258, NULL, 'G3DSA:2.170.16.10:FF:000002', NULL, NULL, 'Desert hedgehog', NULL, NULL, NULL, NULL, NULL, 4),
(71259, NULL, 'G3DSA:3.40.50.300:FF:007725', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71260, NULL, 'G3DSA:3.40.50.10190:FF:000005', NULL, NULL, 'Tumor suppressor p53-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(71261, NULL, 'G3DSA:3.90.25.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71262, NULL, 'G3DSA:1.20.140.40:FF:000044', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(71263, NULL, 'G3DSA:3.30.160.60:FF:003273', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71264, NULL, 'G3DSA:3.30.200.20:FF:002528', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(71265, NULL, 'G3DSA:2.40.37.10:FF:000085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71266, NULL, 'G3DSA:3.60.10.10:FF:000380', NULL, NULL, 'DNA-(Apurinic or apyrimidinic site) lyase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(71267, NULL, 'G3DSA:1.20.1070.10:FF:000163', NULL, NULL, 'Thromboxane A2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(71268, NULL, 'G3DSA:2.170.140.10:FF:000052', NULL, NULL, 'Prion-like-(Q/N-rich)-domain-bearing protein', NULL, NULL, NULL, NULL, NULL, 4),
(71269, NULL, 'G3DSA:2.130.10.10:FF:002817', NULL, NULL, 'Chromatin assembly factor 1 subunit B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71270, NULL, 'G3DSA:2.80.10.50:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71271, NULL, 'G3DSA:3.40.50.300:FF:002346', NULL, NULL, 'DNA2/NAM7 helicase', NULL, NULL, NULL, NULL, NULL, 4),
(71272, NULL, 'G3DSA:3.80.10.10:FF:004044', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71273, NULL, 'G3DSA:1.10.620.20:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71274, NULL, 'G3DSA:3.30.470.20:FF:000188', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71275, NULL, 'G3DSA:3.20.20.70:FF:000349', NULL, NULL, 'Putative glutamate synthase [NADPH], large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(71276, NULL, 'G3DSA:2.40.290.10:FF:000043', NULL, NULL, 'X-ray repair complementing defective repair in Chinese hamster cells 6', NULL, NULL, NULL, NULL, NULL, 4),
(71277, NULL, 'G3DSA:3.40.50.720:FF:001988', NULL, NULL, '3-oxoacyl-(Acyl-carrier-protein) reductase', NULL, NULL, NULL, NULL, NULL, 4),
(71278, NULL, 'G3DSA:1.25.40.20:FF:000723', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(71279, NULL, 'G3DSA:1.20.58.70:FF:000047', NULL, NULL, 'Related to PEP12 syntaxin (t-SNARE), vacuolar', NULL, NULL, NULL, NULL, NULL, 4),
(71280, NULL, 'G3DSA:2.60.40.10:FF:005566', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(71281, NULL, 'G3DSA:4.10.240.10:FF:000146', NULL, NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(71282, NULL, 'G3DSA:1.20.5.110:FF:000300', NULL, NULL, 'Vesicle-associated membrane protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(71283, NULL, 'G3DSA:3.90.226.10:FF:000104', NULL, NULL, 'Related to enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(71284, NULL, 'G3DSA:1.25.40.10:FF:003536', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(71285, NULL, 'G3DSA:3.30.40.10:FF:000563', NULL, NULL, 'Piccolo presynaptic cytomatrix protein', NULL, NULL, NULL, NULL, NULL, 4),
(71286, NULL, 'G3DSA:3.10.450.330:FF:000001', NULL, NULL, 'Sucrose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(71287, NULL, 'G3DSA:3.40.50.300:FF:003274', NULL, NULL, 'DDX39A isoform 12', NULL, NULL, NULL, NULL, NULL, 4),
(71288, NULL, 'G3DSA:3.40.50.10880:FF:000004', NULL, NULL, 'Pantothenate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(71289, NULL, 'G3DSA:1.20.5.190:FF:000161', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71290, NULL, 'G3DSA:2.60.40.10:FF:002508', NULL, NULL, 'Synaptogenesis protein syg-1', NULL, NULL, NULL, NULL, NULL, 4),
(71291, NULL, 'G3DSA:3.40.50.11850:FF:000008', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(71292, NULL, 'G3DSA:1.10.10.60:FF:001284', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71293, NULL, 'G3DSA:2.60.40.1120:FF:000024', NULL, NULL, 'Carboxypeptidase D', NULL, NULL, NULL, NULL, NULL, 4),
(71294, NULL, 'G3DSA:1.10.10.2170:FF:000002', NULL, NULL, 'DNA-binding protein RAP1', NULL, NULL, NULL, NULL, NULL, 4),
(71295, NULL, 'G3DSA:2.10.50.10:FF:000033', NULL, NULL, 'CD27 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(71296, NULL, 'G3DSA:3.60.21.10:FF:000309', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(71297, NULL, 'G3DSA:3.30.160.60:FF:003981', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71298, NULL, 'G3DSA:1.25.40.10:FF:004464', NULL, NULL, 'Intraflagellar transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(71299, NULL, 'G3DSA:3.80.10.10:FF:003644', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71300, NULL, 'G3DSA:3.40.720.10:FF:000348', NULL, NULL, 'Iduronate 2-sulfatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71301, NULL, 'G3DSA:3.90.1750.10:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71302, NULL, 'G3DSA:3.30.420.10:FF:000092', NULL, NULL, '3''-5'' exonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(71303, NULL, 'G3DSA:1.10.10.990:FF:000007', NULL, NULL, 'RecBCD enzyme subunit RecC', NULL, NULL, NULL, NULL, NULL, 4),
(71304, NULL, 'G3DSA:2.130.10.10:FF:003240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71305, NULL, 'G3DSA:3.90.190.10:FF:000099', NULL, NULL, 'Blast:Cyclin-G-associated kinase', NULL, NULL, NULL, NULL, NULL, 4),
(71306, NULL, 'G3DSA:3.40.30.10:FF:000449', NULL, NULL, 'Protein disulfide isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(71307, NULL, 'G3DSA:3.40.640.10:FF:000347', NULL, NULL, 'Cys/Met metabolism pyridoxal-phosphate-dependent protein', NULL, NULL, NULL, NULL, NULL, 4),
(71308, NULL, 'G3DSA:3.40.50.1110:FF:000082', NULL, NULL, 'GDSL esterase/lipase At4g30140', NULL, NULL, NULL, NULL, NULL, 4),
(71309, NULL, 'G3DSA:1.50.40.10:FF:000454', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71310, NULL, 'G3DSA:2.60.40.3120:FF:000006', NULL, NULL, 'Cytosolic carboxypeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(71311, NULL, 'G3DSA:3.40.190.170:FF:000010', NULL, NULL, 'Alpha-keto acid-binding periplasmic protein TakP', NULL, NULL, NULL, NULL, NULL, 4),
(71312, NULL, 'G3DSA:3.90.1140.10:FF:000027', NULL, NULL, 'RNA ligase/cyclic nucleotide phosphodiesterase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(71313, NULL, 'G3DSA:3.10.450.350:FF:000007', NULL, NULL, 'Lysine transporter LysM', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(71314, NULL, 'G3DSA:3.30.230.10:FF:000257', NULL, NULL, 'Phosphomevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(71315, NULL, 'G3DSA:1.10.1520.10:FF:000015', NULL, NULL, 'Dicer-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(71316, NULL, 'G3DSA:2.30.130.10:FF:000023', NULL, NULL, 'Glutamate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(71317, NULL, 'G3DSA:2.40.30.10:FF:000199', NULL, NULL, 'Ferredoxin--NADP reductase', NULL, NULL, NULL, NULL, NULL, 4),
(71318, NULL, 'G3DSA:1.10.10.430:FF:000008', NULL, NULL, 'protein phosphatase 1A-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(71319, NULL, 'G3DSA:3.90.550.50:FF:000015', NULL, NULL, 'Beta-1,3-galactosyltransferase GALT1', NULL, NULL, NULL, NULL, NULL, 4),
(71320, NULL, 'G3DSA:1.20.1270.340:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71321, NULL, 'G3DSA:3.40.50.300:FF:003307', NULL, NULL, 'Putative metal ion ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(71322, NULL, 'G3DSA:3.10.50.40:FF:000011', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(71323, NULL, 'G3DSA:2.40.50.140:FF:000548', NULL, NULL, 'Protein CBG11069', NULL, NULL, NULL, NULL, NULL, 4),
(71324, NULL, 'G3DSA:3.60.10.10:FF:000195', NULL, NULL, 'Endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(71325, NULL, 'G3DSA:2.130.10.10:FF:002256', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(71326, NULL, 'G3DSA:3.30.420.40:FF:001028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71327, NULL, 'G3DSA:3.10.20.770:FF:000020', NULL, NULL, 'Phosphatidylinositol 3-kinase class, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71328, NULL, 'G3DSA:3.90.1600.10:FF:000069', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(71329, NULL, 'G3DSA:1.50.10.10:FF:000065', NULL, NULL, 'Phosphorylase b kinase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(71330, NULL, 'G3DSA:1.10.1420.10:FF:000159', NULL, NULL, 'MutS domain III family protein', NULL, NULL, NULL, NULL, NULL, 4),
(71331, NULL, 'G3DSA:3.40.50.300:FF:002907', NULL, NULL, 'Protein CBG02097', NULL, NULL, NULL, NULL, NULL, 4),
(71332, NULL, 'G3DSA:3.40.50.1000:FF:000846', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71333, NULL, 'G3DSA:3.40.50.920:FF:000059', NULL, NULL, '2-oxoacid ferredoxin oxidoreductase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(71334, NULL, 'G3DSA:1.10.20.10:FF:000011', NULL, NULL, 'Transcription initiation factor TFIID subunit 12', NULL, NULL, NULL, NULL, NULL, 4),
(71335, NULL, 'G3DSA:2.60.40.1230:FF:000001', NULL, NULL, 'ADP-ribosylation factor-binding protein GGA1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(71336, NULL, 'G3DSA:3.40.50.1110:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71337, NULL, 'G3DSA:3.30.70.330:FF:000686', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71338, NULL, 'G3DSA:1.20.1740.10:FF:000248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71339, NULL, 'G3DSA:2.60.40.1400:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71340, NULL, 'G3DSA:1.20.1070.10:FF:000871', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71341, NULL, 'G3DSA:3.30.2350.10:FF:000035', NULL, NULL, 'tRNA pseudouridine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(71342, NULL, 'G3DSA:3.40.50.10490:FF:000157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71343, NULL, 'G3DSA:1.10.287.550:FF:000011', NULL, NULL, 'Steroid sulfatase (microsomal), isozyme S', NULL, NULL, NULL, NULL, NULL, 4),
(71344, NULL, 'G3DSA:3.30.70.1230:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71345, NULL, 'G3DSA:1.10.150.180:FF:000002', NULL, NULL, 'Natural cytotoxicity triggering receptor 3 ligand 1', NULL, NULL, NULL, NULL, NULL, 4),
(71346, NULL, 'G3DSA:1.10.287.4070:FF:000006', NULL, NULL, 'U4/U6 small nuclear ribonucleoprotein PRP31', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(71347, NULL, 'G3DSA:3.30.390.150:FF:000006', NULL, NULL, 'Pulmonary surfactant-associated protein C', NULL, NULL, NULL, NULL, NULL, 4),
(71348, NULL, 'G3DSA:1.10.10.410:FF:000002', NULL, NULL, 'Aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(71349, NULL, 'G3DSA:3.30.70.2520:FF:000001', NULL, NULL, 'L-gulonolactone oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(71350, NULL, 'G3DSA:1.25.10.10:FF:003147', NULL, NULL, 'Diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(71351, NULL, 'G3DSA:2.130.10.10:FF:003801', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71352, NULL, 'G3DSA:3.40.50.300:FF:007017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71353, NULL, 'G3DSA:3.40.50.300:FF:007202', NULL, NULL, 'Putative ATP-dependent RNA helicase C25D12.06', NULL, NULL, NULL, NULL, NULL, 4),
(71354, NULL, 'G3DSA:3.40.50.1000:FF:000138', NULL, NULL, 'HAD-superfamily hydrolase, subfamily IIA', NULL, NULL, NULL, NULL, NULL, 4),
(71355, NULL, 'G3DSA:1.10.10.10:FF:000566', NULL, NULL, 'Response regulator receiver domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(71356, NULL, 'G3DSA:1.25.10.10:FF:003332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71357, NULL, 'G3DSA:2.170.270.10:FF:000056', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-4 specific', NULL, NULL, NULL, NULL, NULL, 4),
(71358, NULL, 'G3DSA:1.10.1200.10:FF:000143', NULL, NULL, 'Acyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(71359, NULL, 'G3DSA:2.30.40.10:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71360, NULL, 'G3DSA:3.40.920.10:FF:000004', NULL, NULL, 'Sulfite reductase [NADPH] flavoprotein component', NULL, NULL, NULL, NULL, NULL, 4),
(71361, NULL, 'G3DSA:3.40.50.10330:FF:000103', NULL, NULL, 'Ceramide kinase-like isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(71362, NULL, 'G3DSA:3.60.15.10:FF:000076', NULL, NULL, 'Cleavage and polyadenylation specificity factor,putative', NULL, NULL, NULL, NULL, NULL, 4),
(71363, NULL, 'G3DSA:3.40.50.80:FF:000196', NULL, NULL, 'Ferric reduction oxidase 8, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(71364, NULL, 'G3DSA:3.30.70.330:FF:002631', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71365, NULL, 'G3DSA:3.40.50.620:FF:000615', NULL, NULL, 'FAD synthase', NULL, NULL, NULL, NULL, NULL, 4),
(71366, NULL, 'G3DSA:3.10.129.110:FF:000018', NULL, NULL, 'Polyketide synthase RzxE', NULL, NULL, NULL, NULL, NULL, 4),
(71367, NULL, 'G3DSA:3.30.40.10:FF:000416', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(71368, NULL, 'G3DSA:1.10.238.10:FF:000410', NULL, NULL, 'Secretory pathway protein Ssp120, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71369, NULL, 'G3DSA:1.10.3660.10:FF:000020', NULL, NULL, 'Prephenate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(71370, NULL, 'G3DSA:1.20.58.60:FF:000657', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71371, NULL, 'G3DSA:2.30.42.10:FF:000148', NULL, NULL, 'membrane-associated guanylate kinase, WW and PDZ domain-containing protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(71372, NULL, 'G3DSA:1.20.58.60:FF:000842', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71373, NULL, 'G3DSA:3.40.50.150:FF:001587', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71374, NULL, 'G3DSA:3.90.1170.40:FF:000010', NULL, NULL, 'Molybdopterin synthase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(71375, NULL, 'G3DSA:3.40.190.10:FF:000273', NULL, NULL, 'Oligopeptide ABC transporter, oligopeptide-binding protein AliB', NULL, NULL, NULL, NULL, NULL, 4),
(71376, NULL, 'G3DSA:2.30.42.10:FF:000356', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71377, NULL, 'G3DSA:3.90.226.10:FF:000076', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(71378, NULL, 'G3DSA:3.30.1520.10:FF:000014', NULL, NULL, 'Sorting nexin 13', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(71379, NULL, 'G3DSA:2.130.10.10:FF:005870', NULL, NULL, 'Two-component system sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(71380, NULL, 'G3DSA:3.30.1640.10:FF:000080', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(71381, NULL, 'G3DSA:2.60.40.180:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71382, NULL, 'G3DSA:3.20.20.80:FF:000026', NULL, NULL, 'galactocerebrosidase precursor', NULL, NULL, NULL, NULL, NULL, 4),
(71383, NULL, 'G3DSA:2.130.10.10:FF:001587', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(71384, NULL, 'G3DSA:1.25.40.10:FF:000866', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(71385, NULL, 'G3DSA:3.30.230.70:FF:000084', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71386, NULL, 'G3DSA:3.80.10.10:FF:001666', NULL, NULL, 'Receptor kinase-like protein Xa21', NULL, NULL, NULL, NULL, NULL, 4),
(71387, NULL, 'G3DSA:3.40.50.300:FF:002498', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71388, NULL, 'G3DSA:3.90.380.10:FF:000018', NULL, NULL, 'Benzoate 1,2-dioxygenase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(71389, NULL, 'G3DSA:3.30.70.330:FF:001962', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71390, NULL, 'G3DSA:3.40.30.10:FF:001169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71391, NULL, 'G3DSA:3.40.50.300:FF:002610', NULL, NULL, 'Deoxyguanosine kinase/deoxyadenosine kinase subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71392, NULL, 'G3DSA:2.60.40.60:FF:000477', NULL, NULL, 'Cadherin-87A', NULL, NULL, NULL, NULL, NULL, 4),
(71393, NULL, 'G3DSA:1.10.560.10:FF:000041', NULL, NULL, 'T-complex protein 1 subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(71394, NULL, 'G3DSA:3.30.200.20:FF:000674', NULL, NULL, 'BUD32 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(71395, NULL, 'G3DSA:3.30.160.60:FF:000491', NULL, NULL, 'zinc finger matrin-type protein 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(71396, NULL, 'G3DSA:3.90.1150.10:FF:000472', NULL, NULL, 'Perosamine synthetase-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(71397, NULL, 'G3DSA:3.40.50.300:FF:003066', NULL, NULL, 'Small GTPase EhRabX2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71398, NULL, 'G3DSA:2.70.98.10:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71399, NULL, 'G3DSA:2.60.120.260:FF:000429', NULL, NULL, 'Probable beta-galactosidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(71400, NULL, 'G3DSA:4.10.280.110:FF:000013', NULL, NULL, 'WD domain, G-beta repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(71401, NULL, 'G3DSA:1.25.40.120:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71402, NULL, 'G3DSA:3.40.20.10:FF:000044', NULL, NULL, 'Cofilin/actin-depolymerizing factor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(71403, NULL, 'G3DSA:3.30.40.10:FF:001928', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71404, NULL, 'G3DSA:2.40.160.10:FF:000039', NULL, NULL, 'Porin', NULL, NULL, NULL, NULL, NULL, 4),
(71405, NULL, 'G3DSA:3.40.50.620:FF:000790', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(71406, NULL, 'G3DSA:3.40.50.450:FF:000047', NULL, NULL, '6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(71407, NULL, 'G3DSA:1.10.238.10:FF:001074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71408, NULL, 'G3DSA:3.40.1410.10:FF:000026', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(71409, NULL, 'G3DSA:1.10.1670.40:FF:000006', NULL, NULL, 'DNA-3-methyladenine glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(71410, NULL, 'G3DSA:1.10.510.10:FF:002567', NULL, NULL, 'Protein kinase domain-containing protein (AFU_orthologue AFUA_3G08710)', NULL, NULL, NULL, NULL, NULL, 4),
(71411, NULL, 'G3DSA:1.10.287.70:FF:000148', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(71412, NULL, 'G3DSA:3.30.1490.180:FF:000025', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(71413, NULL, 'G3DSA:3.30.160.60:FF:003245', NULL, NULL, 'Oocyte zinc finger protein XlCOF28', NULL, NULL, NULL, NULL, NULL, 4),
(71414, NULL, 'G3DSA:3.60.10.10:FF:000048', NULL, NULL, 'Type I inositol polyphosphate 5-phosphatase 2', NULL, NULL, NULL, NULL, NULL, 4),
(71415, NULL, 'G3DSA:2.60.120.10:FF:000375', NULL, NULL, 'Cyclic Nucleotide Gated channel', NULL, NULL, NULL, NULL, NULL, 4),
(71416, NULL, 'G3DSA:3.20.20.80:FF:000465', NULL, NULL, 'Carbohydrate hydrolase-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(71417, NULL, 'G3DSA:2.60.40.10:FF:000002', NULL, NULL, 'Titin a', NULL, NULL, NULL, NULL, NULL, 4),
(71418, NULL, 'G3DSA:2.10.25.10:FF:001278', NULL, NULL, 'Low-density lipoprotein RecePtor related', NULL, NULL, NULL, NULL, NULL, 4),
(71419, NULL, 'G3DSA:3.30.160.60:FF:001480', NULL, NULL, 'Si:cabz01071911.3', NULL, NULL, NULL, NULL, NULL, 4),
(71420, NULL, 'G3DSA:3.30.40.10:FF:001024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71421, NULL, 'G3DSA:3.40.50.720:FF:000943', NULL, NULL, 'Oxidoreductase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(71422, NULL, 'G3DSA:3.30.1490.40:FF:000008', NULL, NULL, 'Lin1p', NULL, NULL, NULL, NULL, NULL, 4),
(71423, NULL, 'G3DSA:3.80.10.10:FF:001615', NULL, NULL, 'F-box protein SKP2A isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(71424, NULL, 'G3DSA:3.30.559.10:FF:000233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71425, NULL, 'G3DSA:1.20.1250.20:FF:000202', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(71426, NULL, 'G3DSA:1.10.287.70:FF:000569', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71427, NULL, 'G3DSA:2.60.120.970:FF:000030', NULL, NULL, 'Glass bottom boat', NULL, NULL, NULL, NULL, NULL, 4),
(71428, NULL, 'G3DSA:2.70.98.10:FF:000022', NULL, NULL, 'Glucose-6-phosphate 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(71429, NULL, 'G3DSA:3.30.200.20:FF:001663', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(71430, NULL, 'G3DSA:3.40.30.10:FF:001118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71431, NULL, 'G3DSA:1.20.1500.20:FF:000003', NULL, NULL, 'Antiviral helicase SKI2', NULL, NULL, NULL, NULL, NULL, 4),
(71432, NULL, 'G3DSA:1.50.10.10:FF:000121', NULL, NULL, 'Putative large secreted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71433, NULL, 'G3DSA:2.130.10.10:FF:002104', NULL, NULL, 'WD repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(71434, NULL, 'G3DSA:3.30.160.20:FF:000147', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71435, NULL, 'G3DSA:3.30.70.1730:FF:000011', NULL, NULL, '50S ribosomal protein L10, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71436, NULL, 'G3DSA:3.30.1490.20:FF:000020', NULL, NULL, 'Protein lysine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(71437, NULL, 'G3DSA:2.60.40.10:FF:004217', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71438, NULL, 'G3DSA:2.60.40.10:FF:000423', NULL, NULL, 'Fibroblast growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(71439, NULL, 'G3DSA:2.60.40.3170:FF:000009', NULL, NULL, 'Tripeptidyl-peptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(71440, NULL, 'G3DSA:3.30.565.10:FF:000293', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(71441, NULL, 'G3DSA:1.10.3210.10:FF:000121', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71442, NULL, 'G3DSA:4.10.10.10:FF:000003', NULL, NULL, 'Metallothionein', NULL, NULL, NULL, NULL, NULL, 4),
(71443, NULL, 'G3DSA:3.40.50.450:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71444, NULL, 'G3DSA:1.50.40.10:FF:000302', NULL, NULL, 'Mitochondrial substrate carrier family protein S', NULL, NULL, NULL, NULL, NULL, 4),
(71445, NULL, 'G3DSA:3.40.1190.20:FF:000118', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(71446, NULL, 'G3DSA:2.30.30.1190:FF:000001', NULL, NULL, 'zinc finger CCCH-type with G patch domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(71447, NULL, 'G3DSA:3.40.309.10:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71448, NULL, 'G3DSA:3.20.20.80:FF:000414', NULL, NULL, 'Beta-galactosidase BoGH2A', NULL, NULL, NULL, NULL, NULL, 4),
(71449, NULL, 'G3DSA:3.60.130.10:FF:000074', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71450, NULL, 'G3DSA:1.20.58.340:FF:000020', NULL, NULL, 'Magnesium transport protein CorA', NULL, NULL, NULL, NULL, NULL, 4),
(71451, NULL, 'G3DSA:3.30.160.60:FF:002289', NULL, NULL, 'Zinc finger protein 813', NULL, NULL, NULL, NULL, NULL, 4),
(71452, NULL, 'G3DSA:1.20.120.1240:FF:000055', NULL, NULL, 'Dynamin-A', NULL, NULL, NULL, NULL, NULL, 4),
(71453, NULL, 'G3DSA:3.100.10.10:FF:000011', NULL, NULL, '50S ribosomal subunit protein L15', NULL, NULL, NULL, NULL, NULL, 4),
(71454, NULL, 'G3DSA:3.40.190.80:FF:000092', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(71455, NULL, 'G3DSA:1.10.640.10:FF:000042', NULL, NULL, 'Protein CBR-PXN-2', NULL, NULL, NULL, NULL, NULL, 4),
(71456, NULL, 'G3DSA:2.60.200.20:FF:000266', NULL, NULL, 'Zgc:165656', NULL, NULL, NULL, NULL, NULL, 4),
(71457, NULL, 'G3DSA:3.40.50.300:FF:006825', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(71458, NULL, 'G3DSA:1.25.40.180:FF:000328', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71459, NULL, 'G3DSA:1.10.510.10:FF:001999', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(71460, NULL, 'G3DSA:2.60.40.2030:FF:000061', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71461, NULL, 'G3DSA:2.60.120.290:FF:000005', NULL, NULL, 'Procollagen C-endopeptidase enhancer 1', NULL, NULL, NULL, NULL, NULL, 4),
(71462, NULL, 'G3DSA:3.40.50.300:FF:003807', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71463, NULL, 'G3DSA:3.40.50.1820:FF:000199', NULL, NULL, 'Hormone-sensitive lipase', NULL, NULL, NULL, NULL, NULL, 4),
(71464, NULL, 'G3DSA:2.60.120.260:FF:000530', NULL, NULL, 'AE binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(71465, NULL, 'G3DSA:2.60.40.10:FF:004638', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71466, NULL, 'G3DSA:1.10.45.10:FF:000006', NULL, NULL, 'FAD-linked oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(71467, NULL, 'G3DSA:3.40.50.2000:FF:000596', NULL, NULL, 'UDP-GlucuronosylTransferase', NULL, NULL, NULL, NULL, NULL, 4),
(71468, NULL, 'G3DSA:2.60.120.200:FF:000198', NULL, NULL, 'Probable L-type lectin-domain containing receptor kinase S.5', NULL, NULL, NULL, NULL, NULL, 4),
(71469, NULL, 'G3DSA:1.25.40.10:FF:003188', NULL, NULL, 'Putative pentatricopeptide repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(71470, NULL, 'G3DSA:3.90.132.10:FF:000021', NULL, NULL, 'GP63-like', NULL, NULL, NULL, NULL, NULL, 4),
(71471, NULL, 'G3DSA:2.130.10.10:FF:004021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71472, NULL, 'G3DSA:3.40.50.2300:FF:001085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71473, NULL, 'G3DSA:3.90.640.10:FF:000117', NULL, NULL, 'Heat shock protein 70, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71474, NULL, 'G3DSA:3.90.550.10:FF:000470', NULL, NULL, 'Glycosyl transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(71475, NULL, 'G3DSA:3.30.800.10:FF:000014', NULL, NULL, 'Putative phosphatidylinositol (3,5) kinase', NULL, NULL, NULL, NULL, NULL, 4),
(71476, NULL, 'G3DSA:1.10.510.10:FF:002516', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71477, NULL, 'G3DSA:1.20.1560.10:FF:000190', NULL, NULL, 'ABC multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71478, NULL, 'G3DSA:1.10.287.110:FF:000110', NULL, NULL, 'DnaJ domain protein (AFU_orthologue AFUA_2G13210)', NULL, NULL, NULL, NULL, NULL, 4),
(71479, NULL, 'G3DSA:3.40.1380.20:FF:000032', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(71480, NULL, 'G3DSA:3.40.1810.10:FF:000074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71481, NULL, 'G3DSA:3.30.160.60:FF:001379', NULL, NULL, 'zinc finger X-linked protein ZXDB', NULL, NULL, NULL, NULL, NULL, 4),
(71482, NULL, 'G3DSA:1.25.40.10:FF:002732', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71483, NULL, 'G3DSA:2.60.40.10:FF:002340', NULL, NULL, 'Unc-5 netrin receptor A', NULL, NULL, NULL, NULL, NULL, 4),
(71484, NULL, 'G3DSA:1.10.287.110:FF:000222', NULL, NULL, 'HscB mitochondrial iron-sulfur cluster cochaperone', NULL, NULL, NULL, NULL, NULL, 4),
(71485, NULL, 'G3DSA:1.10.840.10:FF:000023', NULL, NULL, 'Rho GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(71486, NULL, 'G3DSA:3.30.720.150:FF:000004', NULL, NULL, 'UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase 110 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(71487, NULL, 'G3DSA:3.40.50.720:FF:002500', NULL, NULL, 'Protein CLP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(71488, NULL, 'G3DSA:2.60.40.790:FF:000135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71489, NULL, 'G3DSA:2.20.70.10:FF:000163', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(71490, NULL, 'G3DSA:1.10.274.30:FF:000005', NULL, NULL, 'Chromatin modification-related protein EAF3', NULL, NULL, NULL, NULL, NULL, 4),
(71491, NULL, 'G3DSA:3.10.20.90:FF:000496', NULL, NULL, 'Ubiquitin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(71492, NULL, 'G3DSA:3.10.20.30:FF:000001', NULL, NULL, 'Ribosome-binding ATPase YchF', NULL, NULL, NULL, NULL, NULL, 4),
(71493, NULL, 'G3DSA:3.30.160.60:FF:001851', NULL, NULL, 'Zinc finger protein 418', NULL, NULL, NULL, NULL, NULL, 4),
(71494, NULL, 'G3DSA:3.80.10.10:FF:004521', NULL, NULL, 'F-box only protein 39-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(71495, NULL, 'G3DSA:1.20.1050.80:FF:000020', NULL, NULL, 'Vacuolar protein sorting-associated protein 9b', NULL, NULL, NULL, NULL, NULL, 4),
(71496, NULL, 'G3DSA:1.10.510.10:FF:004484', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71497, NULL, 'G3DSA:3.40.50.360:FF:000172', NULL, NULL, 'NAD(P)H dehydrogenase, quinone 1', NULL, NULL, NULL, NULL, NULL, 4),
(71498, NULL, 'G3DSA:1.25.40.420:FF:000029', NULL, NULL, 'KLHL34 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(71499, NULL, 'G3DSA:1.10.10.10:FF:001022', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(71500, NULL, 'G3DSA:1.20.1070.10:FF:001624', NULL, NULL, 'Corticotropin releasing factor receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71501, NULL, 'G3DSA:1.25.40.860:FF:000026', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(71502, NULL, 'G3DSA:1.25.10.10:FF:001562', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71503, NULL, 'G3DSA:3.30.70.330:FF:002367', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71504, NULL, 'G3DSA:3.10.20.30:FF:000113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71505, NULL, 'G3DSA:3.30.300.30:FF:000095', NULL, NULL, 'Probable non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(71506, NULL, 'G3DSA:3.30.70.330:FF:001170', NULL, NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(71507, NULL, 'G3DSA:3.30.160.20:FF:000198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71508, NULL, 'G3DSA:3.30.450.200:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71509, NULL, 'G3DSA:3.30.460.90:FF:000011', NULL, NULL, 'Mitochondrial elongation factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(71510, NULL, 'G3DSA:2.30.30.100:FF:000068', NULL, NULL, 'Small nuclear ribonucleoprotein Sm D1', NULL, NULL, NULL, NULL, NULL, 4),
(71511, NULL, 'G3DSA:4.10.400.10:FF:000029', NULL, NULL, 'prolow-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(71512, NULL, 'G3DSA:2.60.40.10:FF:000827', NULL, NULL, 'Immunoglobulin superfamily member 3', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(71513, NULL, 'G3DSA:1.10.443.10:FF:000016', NULL, NULL, 'Integrase', NULL, NULL, NULL, NULL, NULL, 4),
(71514, NULL, 'G3DSA:1.20.1420.20:FF:000002', NULL, NULL, 'Iron-regulated protein A', NULL, NULL, NULL, NULL, NULL, 4),
(71515, NULL, 'G3DSA:1.25.40.20:FF:001600', NULL, NULL, 'Ankyrin repeat and LEM domain-containing protein 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(71516, NULL, 'G3DSA:1.10.287.130:FF:000228', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(71517, NULL, 'G3DSA:1.10.8.60:FF:000428', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(71518, NULL, 'G3DSA:3.10.20.90:FF:000384', NULL, NULL, 'Partitioning defective protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(71519, NULL, 'G3DSA:1.20.140.10:FF:000024', NULL, NULL, 'Flavin-dependent monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(71520, NULL, 'G3DSA:3.40.50.2000:FF:000545', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(71521, NULL, 'G3DSA:3.30.40.10:FF:001136', NULL, NULL, 'PHd Finger family', NULL, NULL, NULL, NULL, NULL, 4),
(71522, NULL, 'G3DSA:3.40.250.10:FF:000211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71523, NULL, 'G3DSA:2.60.40.10:FF:002391', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(71524, NULL, 'G3DSA:3.40.50.300:FF:003015', NULL, NULL, 'Origin recognition complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(71525, NULL, 'G3DSA:3.30.450.20:FF:000074', NULL, NULL, 'Aryl hydrocarbon receptor', NULL, NULL, NULL, NULL, NULL, 4),
(71526, NULL, 'G3DSA:1.10.472.80:FF:000025', NULL, NULL, 'TBC1 domain family member 15', NULL, NULL, NULL, NULL, NULL, 4),
(71527, NULL, 'G3DSA:2.60.40.10:FF:003649', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71528, NULL, 'G3DSA:3.20.20.140:FF:000104', NULL, NULL, 'Hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(71529, NULL, 'G3DSA:1.10.357.10:FF:000074', NULL, NULL, 'Transcriptional repressor, TetR family', NULL, NULL, NULL, NULL, NULL, 4),
(71530, NULL, 'G3DSA:1.25.40.10:FF:002783', NULL, NULL, 'Intraflagellar transport particle protein IFT88', NULL, NULL, NULL, NULL, NULL, 4),
(71531, NULL, 'G3DSA:2.130.10.10:FF:005010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71532, NULL, 'G3DSA:1.20.5.110:FF:000148', NULL, NULL, 'Molecular chaperone HscB', NULL, NULL, NULL, NULL, NULL, 4),
(71533, NULL, 'G3DSA:3.30.160.60:FF:004638', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71534, NULL, 'G3DSA:2.170.260.10:FF:000027', NULL, NULL, 'Endoribonuclease Dicer-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(71535, NULL, 'G3DSA:3.30.70.330:FF:001911', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71536, NULL, 'G3DSA:2.120.10.80:FF:000068', NULL, NULL, 'Kelch-like 6 (Drosophila) (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(71537, NULL, 'G3DSA:1.10.357.70:FF:000013', NULL, NULL, 'Exocyst complex component 3', NULL, NULL, NULL, NULL, NULL, 4),
(71538, NULL, 'G3DSA:2.40.30.10:FF:000339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71539, NULL, 'G3DSA:2.130.10.10:FF:001536', NULL, NULL, 'Phosphoinositide 3-kinase regulatory subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(71540, NULL, 'G3DSA:3.40.20.10:FF:000095', NULL, NULL, 'Twinfilin', NULL, NULL, NULL, NULL, NULL, 4),
(71541, NULL, 'G3DSA:1.25.10.10:FF:002551', NULL, NULL, 'Sister chromatid cohesion protein', NULL, NULL, NULL, NULL, NULL, 4),
(71542, NULL, 'G3DSA:2.90.10.30:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71543, NULL, 'G3DSA:3.50.30.50:FF:000005', NULL, NULL, 'Cyclase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(71544, NULL, 'G3DSA:2.130.10.10:FF:004521', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71545, NULL, 'G3DSA:3.30.70.270:FF:000022', NULL, NULL, 'DNA polymerase eta', NULL, NULL, NULL, NULL, NULL, 4),
(71546, NULL, 'G3DSA:3.30.1240.10:FF:000032', NULL, NULL, 'Cof-type HAD-IIB family hydrolase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(71547, NULL, 'G3DSA:3.30.930.10:FF:000226', NULL, NULL, 'Biotin--[acetyl-CoA-carboxylase] ligase', NULL, NULL, NULL, NULL, NULL, 4),
(71548, NULL, 'G3DSA:3.60.21.10:FF:000225', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(71549, NULL, 'G3DSA:3.40.630.10:FF:000257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71550, NULL, 'G3DSA:3.30.310.50:FF:000011', NULL, NULL, 'Transcription factor Pcc1', NULL, NULL, NULL, NULL, NULL, 4),
(71551, NULL, 'G3DSA:1.20.1260.10:FF:000026', NULL, NULL, 'Ring oxydation complex/ phenylacetic acid degradation', NULL, NULL, NULL, NULL, NULL, 4),
(71552, NULL, 'G3DSA:3.40.30.10:FF:000713', NULL, NULL, 'Eef-1G', NULL, NULL, NULL, NULL, NULL, 4),
(71553, NULL, 'G3DSA:1.10.220.30:FF:000038', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(71554, NULL, 'G3DSA:1.20.1720.10:FF:000106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71555, NULL, 'G3DSA:3.20.20.190:FF:000125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71556, NULL, 'G3DSA:3.40.50.2300:FF:001034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71557, NULL, 'G3DSA:3.30.1600.10:FF:000015', NULL, NULL, 'NAD-dependent protein deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(71558, NULL, 'G3DSA:1.10.10.10:FF:001994', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71559, NULL, 'G3DSA:3.40.50.2300:FF:000545', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(71560, NULL, 'G3DSA:2.60.120.740:FF:000011', NULL, NULL, 'Beta-galactosidase 7', NULL, NULL, NULL, NULL, NULL, 4),
(71561, NULL, 'G3DSA:1.10.287.1040:FF:000013', NULL, NULL, 'Exodeoxyribonuclease 7 small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(71562, NULL, 'G3DSA:3.30.70.980:FF:000055', NULL, NULL, 'Probable transcriptional regulatory protein BEST7613_5720', NULL, NULL, NULL, NULL, NULL, 4),
(71563, NULL, 'G3DSA:2.40.10.10:FF:000377', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71564, NULL, 'G3DSA:3.30.230.70:FF:000016', NULL, NULL, 'Exosome complex component RRP42', NULL, NULL, NULL, NULL, NULL, 4),
(71565, NULL, 'G3DSA:1.25.40.20:FF:000695', NULL, NULL, 'Multiple ankyrin repeats single KH domain, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(71566, NULL, 'G3DSA:1.10.400.10:FF:000029', NULL, NULL, 'guanine nucleotide-binding protein G(Olf) subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(71567, NULL, 'G3DSA:3.30.470.20:FF:000036', NULL, NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(71568, NULL, 'G3DSA:1.25.40.10:FF:001322', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g16610', NULL, NULL, NULL, NULL, NULL, 4),
(71569, NULL, 'G3DSA:3.40.50.150:FF:001183', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71570, NULL, 'G3DSA:3.30.160.60:FF:002789', NULL, NULL, 'tRNA dimethylallyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(71571, NULL, 'G3DSA:1.10.1670.10:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71572, NULL, 'G3DSA:2.120.10.30:FF:000435', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71573, NULL, 'G3DSA:3.10.20.90:FF:000884', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71574, NULL, 'G3DSA:1.10.510.10:FF:002016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71575, NULL, 'G3DSA:3.40.33.10:FF:000074', NULL, NULL, 'Si:dkey-2n12.1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(71576, NULL, 'G3DSA:3.40.50.150:FF:001475', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71577, NULL, 'G3DSA:3.30.70.260:FF:000114', NULL, NULL, 'Glycine cleavage system regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(71578, NULL, 'G3DSA:3.10.129.10:FF:000166', NULL, NULL, 'PaaI family thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(71579, NULL, 'G3DSA:3.50.50.60:FF:000156', NULL, NULL, 'Salicylate hydroxylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71580, NULL, 'G3DSA:2.60.40.10:FF:003296', NULL, NULL, 'Immunoglobulin superfamily, member 3', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(71581, NULL, 'G3DSA:3.30.420.40:FF:000483', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(71582, NULL, 'G3DSA:1.20.1250.20:FF:001990', NULL, NULL, 'Major facilitator superfamily domain-containing protein 12-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(71583, NULL, 'G3DSA:2.40.10.340:FF:000004', NULL, NULL, 'Cell shape-determining protein MreC', NULL, NULL, NULL, NULL, NULL, 4),
(71584, NULL, 'G3DSA:2.30.18.10:FF:000007', NULL, NULL, 'TOA1p TFIIA large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(71585, NULL, 'G3DSA:3.30.300.360:FF:000001', NULL, NULL, 'DUF2498 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(71586, NULL, 'G3DSA:1.25.40.10:FF:003688', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(71587, NULL, 'G3DSA:1.25.10.10:FF:002904', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(71588, NULL, 'G3DSA:2.130.10.10:FF:005802', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71589, NULL, 'G3DSA:3.40.309.10:FF:000016', NULL, NULL, 'NADP-dependent glyceraldehyde-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(71590, NULL, 'G3DSA:1.10.10.60:FF:001076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71591, NULL, 'G3DSA:3.30.530.20:FF:000075', NULL, NULL, 'Phosphatidylinositol transfer protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(71592, NULL, 'G3DSA:1.25.40.10:FF:004256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71593, NULL, 'G3DSA:3.30.200.20:FF:000314', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(71594, NULL, 'G3DSA:1.10.287.1060:FF:000019', NULL, NULL, 'Snf7, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71595, NULL, 'G3DSA:2.60.40.150:FF:000067', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(71596, NULL, 'G3DSA:3.30.342.10:FF:000045', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71597, NULL, 'G3DSA:3.40.50.300:FF:007169', NULL, NULL, 'Ras family protein', NULL, NULL, NULL, NULL, NULL, 4),
(71598, NULL, 'G3DSA:2.30.29.30:FF:000550', NULL, NULL, 'Vacuolar protein-sorting-associated protein 36', NULL, NULL, NULL, NULL, NULL, 4),
(71599, NULL, 'G3DSA:3.30.40.10:FF:001996', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71600, NULL, 'G3DSA:3.30.160.60:FF:005162', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71601, NULL, 'G3DSA:3.10.290.10:FF:000012', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(71602, NULL, 'G3DSA:2.60.120.10:FF:000779', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71603, NULL, 'G3DSA:3.30.160.60:FF:000131', NULL, NULL, 'protein indeterminate-domain 5, chloroplastic-like', NULL, NULL, NULL, NULL, NULL, 4),
(71604, NULL, 'G3DSA:2.130.10.10:FF:003953', NULL, NULL, 'Protein CBG00124', NULL, NULL, NULL, NULL, NULL, 4),
(71605, NULL, 'G3DSA:1.20.1250.20:FF:000702', NULL, NULL, 'Sugar transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(71606, NULL, 'G3DSA:1.10.238.10:FF:001186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71607, NULL, 'G3DSA:2.60.40.420:FF:000103', NULL, NULL, 'H0303G06.17 protein', NULL, NULL, NULL, NULL, NULL, 4),
(71608, NULL, 'G3DSA:1.20.1280.290:FF:000092', NULL, NULL, 'Seven transmembrane protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(71609, NULL, 'G3DSA:1.20.5.190:FF:000166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71610, NULL, 'G3DSA:2.70.160.11:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71611, NULL, 'G3DSA:1.20.58.1030:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71612, NULL, 'G3DSA:2.60.200.40:FF:000031', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(71613, NULL, 'G3DSA:3.30.497.10:FF:000049', NULL, NULL, 'GM12900', NULL, NULL, NULL, NULL, NULL, 4),
(71614, NULL, 'G3DSA:2.10.25.10:FF:000789', NULL, NULL, 'Teratocarcinoma-derived growth factor 1', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(71615, NULL, 'G3DSA:3.30.160.60:FF:000423', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71616, NULL, 'G3DSA:3.10.129.10:FF:000115', NULL, NULL, 'Hydroxyacyl-thioester dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(71617, NULL, 'G3DSA:3.30.40.10:FF:000568', NULL, NULL, 'Os12g0140700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(71618, NULL, 'G3DSA:3.40.50.12780:FF:000102', NULL, NULL, 'ATP-dependent acyl-CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(71619, NULL, 'G3DSA:3.30.559.70:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71620, NULL, 'G3DSA:1.10.1760.20:FF:000007', NULL, NULL, 'Riboflavin transporter', NULL, NULL, NULL, NULL, NULL, 4),
(71621, NULL, 'G3DSA:3.90.550.50:FF:000223', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(71622, NULL, 'G3DSA:1.25.10.10:FF:000134', NULL, NULL, 'Integrator complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(71623, NULL, 'G3DSA:3.30.70.980:FF:000004', NULL, NULL, 'Probable transcriptional regulatory protein YeeN', NULL, NULL, NULL, NULL, NULL, 4),
(71624, NULL, 'G3DSA:2.60.120.620:FF:000037', NULL, NULL, 'Phytanoyl-CoA_dioxygenase_(PhyH)/2OG-Fe(II )_oxygenase_superfamily_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(71625, NULL, 'G3DSA:1.20.5.170:FF:000059', NULL, NULL, 'unconventional myosin-X', NULL, NULL, NULL, NULL, NULL, 4),
(71626, NULL, 'G3DSA:3.30.70.2850:FF:000021', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(71627, NULL, 'G3DSA:3.30.720.10:FF:000013', NULL, NULL, 'Signal recognition particle 9', NULL, NULL, NULL, NULL, NULL, 4),
(71628, NULL, 'G3DSA:1.20.1250.80:FF:000001', NULL, NULL, 'Interleukin-34', NULL, NULL, NULL, NULL, NULL, 4),
(71629, NULL, 'G3DSA:3.10.100.10:FF:000151', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71630, NULL, 'G3DSA:1.10.238.10:FF:001135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71631, NULL, 'G3DSA:3.30.1330.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71632, NULL, 'G3DSA:3.30.960.10:FF:000003', NULL, NULL, 'Peptide chain release factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(71633, NULL, 'G3DSA:1.20.1740.10:FF:000136', NULL, NULL, 'Neutral amino acid transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71634, NULL, 'G3DSA:1.10.520.10:FF:000044', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(71635, NULL, 'G3DSA:2.70.170.10:FF:000292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71636, NULL, 'G3DSA:3.40.50.10130:FF:000015', NULL, NULL, 'SsDNA endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(71637, NULL, 'G3DSA:1.10.600.10:FF:000096', NULL, NULL, 'Farnesyl-diphosphate farnesyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(71638, NULL, 'G3DSA:2.120.10.30:FF:000486', NULL, NULL, 'Gll2869 protein', NULL, NULL, NULL, NULL, NULL, 4),
(71639, NULL, 'G3DSA:2.60.40.10:FF:001851', NULL, NULL, 'Peroxidasin', NULL, NULL, NULL, NULL, NULL, 4),
(71640, NULL, 'G3DSA:2.60.120.590:FF:000005', NULL, NULL, 'Alpha-ketoglutarate-dependent dioxygenase AlkB', NULL, NULL, NULL, NULL, NULL, 4),
(71641, NULL, 'G3DSA:2.130.10.10:FF:001036', NULL, NULL, 'DDB1-and CUL4-associated factor 13', NULL, NULL, NULL, NULL, NULL, 4),
(71642, NULL, 'G3DSA:3.30.750.24:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71643, NULL, 'G3DSA:1.10.287.2480:FF:000001', NULL, NULL, 'Fusion glycoprotein F0', NULL, NULL, NULL, NULL, NULL, 4),
(71644, NULL, 'G3DSA:3.40.980.10:FF:000013', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(71645, NULL, 'G3DSA:3.40.50.720:FF:001140', NULL, NULL, 'dTDP-4-dehydrorhamnose reductase', NULL, NULL, NULL, NULL, NULL, 4),
(71646, NULL, 'G3DSA:1.10.510.10:FF:004192', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71647, NULL, 'G3DSA:3.40.800.20:FF:000026', NULL, NULL, 'Acetoin utilization protein AcuC', NULL, NULL, NULL, NULL, NULL, 4),
(71648, NULL, 'G3DSA:3.40.50.300:FF:004908', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(71649, NULL, 'G3DSA:3.40.50.300:FF:006000', NULL, NULL, 'AGAP011652-PA', NULL, NULL, NULL, NULL, NULL, 4),
(71650, NULL, 'G3DSA:1.25.40.720:FF:000001', NULL, NULL, 'Telomere length regulation protein TEL2', NULL, NULL, NULL, NULL, NULL, 4),
(71651, NULL, 'G3DSA:1.20.1070.10:FF:001383', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71652, NULL, 'G3DSA:3.40.50.300:FF:005724', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(71653, NULL, 'G3DSA:1.10.10.60:FF:001025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71654, NULL, 'G3DSA:1.25.10.10:FF:002955', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71655, NULL, 'G3DSA:3.60.130.10:FF:000006', NULL, NULL, 'Clavaminate synthase-like protein At3g21360', NULL, NULL, NULL, NULL, NULL, 4),
(71656, NULL, 'G3DSA:1.20.1730.10:FF:000051', NULL, NULL, 'Low affinity sodium-glucose cotransporter-like', NULL, NULL, NULL, NULL, NULL, 4),
(71657, NULL, 'G3DSA:3.30.2130.30:FF:000002', NULL, NULL, 'tRNA sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(71658, NULL, 'G3DSA:3.50.50.60:FF:000105', NULL, NULL, 'Kynurenine 3-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(71659, NULL, 'G3DSA:2.60.40.10:FF:003700', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71660, NULL, 'G3DSA:3.40.50.1950:FF:000007', NULL, NULL, 'Flavin prenyltransferase UbiX', NULL, NULL, NULL, NULL, NULL, 4),
(71661, NULL, 'G3DSA:3.30.70.330:FF:001411', NULL, NULL, 'Uncharacterized protein, isoform K', NULL, NULL, NULL, NULL, NULL, 4),
(71662, NULL, 'G3DSA:3.40.50.2000:FF:000949', NULL, NULL, 'UDP-glycosyltransferase 73C4', NULL, NULL, NULL, NULL, NULL, 4),
(71663, NULL, 'G3DSA:3.10.580.10:FF:000170', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(71664, NULL, 'G3DSA:3.40.390.10:FF:000221', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71665, NULL, 'G3DSA:1.10.8.10:FF:000234', NULL, NULL, 'ATP-dependent protease ATPase subunit HslU2', NULL, NULL, NULL, NULL, NULL, 4),
(71666, NULL, 'G3DSA:1.10.3430.10:FF:000036', NULL, NULL, 'YALI0A02244p', NULL, NULL, NULL, NULL, NULL, 4),
(71667, NULL, 'G3DSA:1.20.58.60:FF:000781', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71668, NULL, 'G3DSA:1.50.10.20:FF:000011', NULL, NULL, 'Terpene cyclase/mutase family member', NULL, NULL, NULL, NULL, NULL, 4),
(71669, NULL, 'G3DSA:2.30.30.40:FF:000556', NULL, NULL, 'Cortactin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71670, NULL, 'G3DSA:2.130.10.10:FF:001615', NULL, NULL, 'Protein CBG22378', NULL, NULL, NULL, NULL, NULL, 4),
(71671, NULL, 'G3DSA:2.10.60.10:FF:000067', NULL, NULL, 'Serine/threonine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(71672, NULL, 'G3DSA:3.40.50.300:FF:002110', NULL, NULL, 'tRNA dimethylallyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(71673, NULL, 'G3DSA:1.20.1560.10:FF:000122', NULL, NULL, 'Multidrug ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(71674, NULL, 'G3DSA:1.20.1250.20:FF:000141', NULL, NULL, 'Solute carrier family 16, member 4', NULL, NULL, NULL, NULL, NULL, 4),
(71675, NULL, 'G3DSA:1.10.238.180:FF:000003', NULL, NULL, 'stromal interaction molecule homolog isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(71676, NULL, 'G3DSA:3.40.1030.10:FF:000008', NULL, NULL, 'Anthranilate phosphoribosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71677, NULL, 'G3DSA:2.60.120.290:FF:000073', NULL, NULL, 'Protein bark beetle', NULL, NULL, NULL, NULL, NULL, 4),
(71678, NULL, 'G3DSA:2.60.120.200:FF:000086', NULL, NULL, 'L-type lectin-domain containing receptor kinase S.4', NULL, NULL, NULL, NULL, NULL, 4),
(71679, NULL, 'G3DSA:3.30.1740.10:FF:000025', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(71680, NULL, 'G3DSA:3.40.50.1820:FF:000148', NULL, NULL, 'Serine carboxypeptidase-like 11', NULL, NULL, NULL, NULL, NULL, 4),
(71681, NULL, 'G3DSA:1.10.8.60:FF:000496', NULL, NULL, 'Spastin-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(71682, NULL, 'G3DSA:3.30.870.10:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(71683, NULL, 'G3DSA:3.10.20.90:FF:000788', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71684, NULL, 'G3DSA:1.10.510.10:FF:002628', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71685, NULL, 'G3DSA:3.30.559.10:FF:000172', NULL, NULL, 'HC-toxin synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(71686, NULL, 'G3DSA:4.10.400.10:FF:000097', NULL, NULL, 'Transmembrane serine protease 6', NULL, NULL, NULL, NULL, NULL, 4),
(71687, NULL, 'G3DSA:3.40.50.300:FF:004004', NULL, NULL, 'DNA repair protein RAD50', NULL, NULL, NULL, NULL, NULL, 4),
(71688, NULL, 'G3DSA:1.25.10.10:FF:001674', NULL, NULL, 'Protein CBR-EVL-14', NULL, NULL, NULL, NULL, NULL, 4),
(71689, NULL, 'G3DSA:2.130.10.10:FF:001087', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(71690, NULL, 'G3DSA:3.40.50.1820:FF:001660', NULL, NULL, 'Serine carboxypeptidase-like 19', NULL, NULL, NULL, NULL, NULL, 4),
(71691, NULL, 'G3DSA:3.40.50.2000:FF:000157', NULL, NULL, 'Alpha-1,3-glucan synthase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(71692, NULL, 'G3DSA:1.20.1070.10:FF:001332', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(71693, NULL, 'G3DSA:3.30.70.330:FF:001462', NULL, NULL, 'AlkB homolog 8, tRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(71694, NULL, 'G3DSA:2.30.30.1150:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71695, NULL, 'G3DSA:3.90.180.10:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71696, NULL, 'G3DSA:2.60.120.260:FF:000581', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71697, NULL, 'G3DSA:3.80.10.10:FF:003532', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71698, NULL, 'G3DSA:1.20.1560.10:FF:000482', NULL, NULL, 'ABC transporter, ATP-binding/membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(71699, NULL, 'G3DSA:3.90.640.10:FF:000229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71700, NULL, 'G3DSA:1.20.1070.10:FF:001675', NULL, NULL, 'Olfactory receptor 541', NULL, NULL, NULL, NULL, NULL, 4),
(71701, NULL, 'G3DSA:1.20.58.190:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71702, NULL, 'G3DSA:3.40.1690.10:FF:000013', NULL, NULL, 'EscU/YscU/HrcU family type III secretion system export apparatus switch protein', NULL, NULL, NULL, NULL, NULL, 4),
(71703, NULL, 'G3DSA:2.30.29.30:FF:000893', NULL, NULL, 'uncharacterized protein LOC778851 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(71704, NULL, 'G3DSA:3.40.850.10:FF:000301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71705, NULL, 'G3DSA:3.30.2010.30:FF:000004', NULL, NULL, 'Arginyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(71706, NULL, 'G3DSA:2.60.15.10:FF:000022', NULL, NULL, 'ATP synthase epsilon chain, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(71707, NULL, 'G3DSA:3.40.50.10810:FF:000152', NULL, NULL, 'Protein CBG00336', NULL, NULL, NULL, NULL, NULL, 4),
(71708, NULL, 'G3DSA:1.10.10.10:FF:001090', NULL, NULL, 'Vacuolar membrane-associated protein iml1', NULL, NULL, NULL, NULL, NULL, 4),
(71709, NULL, 'G3DSA:1.20.58.390:FF:000170', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71710, NULL, 'G3DSA:1.10.8.60:FF:000316', NULL, NULL, 'Peroxin-1', NULL, NULL, NULL, NULL, NULL, 4),
(71711, NULL, 'G3DSA:3.90.550.10:FF:000402', NULL, NULL, 'Glycosyltransferase family 2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(71712, NULL, 'G3DSA:3.90.1290.10:FF:000010', NULL, NULL, 'Envoplakin a', NULL, NULL, NULL, NULL, NULL, 4),
(71713, NULL, 'G3DSA:2.70.150.10:FF:000178', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(71714, NULL, 'G3DSA:3.80.10.10:FF:000710', NULL, NULL, 'MDIS1-interacting receptor like kinase 2 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(71715, NULL, 'G3DSA:3.30.420.10:FF:000709', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71716, NULL, 'G3DSA:1.25.40.20:FF:001712', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(71717, NULL, 'G3DSA:2.60.40.1910:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71718, NULL, 'G3DSA:3.40.50.11500:FF:000022', NULL, NULL, 'DENN/MADD domain-containing 1B', NULL, NULL, NULL, NULL, NULL, 4),
(71719, NULL, 'G3DSA:3.40.50.1100:FF:000258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71720, NULL, 'G3DSA:3.30.60.90:FF:000048', NULL, NULL, 'zinc finger protein (ZZ-type)-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(71721, NULL, 'G3DSA:3.30.559.10:FF:000121', NULL, NULL, 'NonRibosomal Peptide Synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(71722, NULL, 'G3DSA:2.130.10.10:FF:001828', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71723, NULL, 'G3DSA:3.40.390.10:FF:000272', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71724, NULL, 'G3DSA:1.20.58.2240:FF:000004', NULL, NULL, 'Putative phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(71725, NULL, 'G3DSA:2.40.30.10:FF:000047', NULL, NULL, '50S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(71726, NULL, 'G3DSA:3.90.850.10:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71727, NULL, 'G3DSA:3.30.420.60:FF:000022', NULL, NULL, 'Eukaryotic peptide chain release factor subunit 1-2', NULL, NULL, NULL, NULL, NULL, 4),
(71728, NULL, 'G3DSA:3.30.160.60:FF:003296', NULL, NULL, 'Zinc finger protein 844', NULL, NULL, NULL, NULL, NULL, 4),
(71729, NULL, 'G3DSA:2.60.120.40:FF:000030', NULL, NULL, 'Lymphotoxin-beta', NULL, NULL, NULL, NULL, NULL, 4),
(71730, NULL, 'G3DSA:3.30.450.20:FF:000366', NULL, NULL, 'Neuronal PAS domain protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(71731, NULL, 'G3DSA:3.90.810.10:FF:000001', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(71732, NULL, 'G3DSA:3.40.50.300:FF:004347', NULL, NULL, 'Torsin-2A', NULL, NULL, NULL, NULL, NULL, 4),
(71733, NULL, 'G3DSA:2.10.70.80:FF:000004', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(71734, NULL, 'G3DSA:3.30.70.330:FF:000973', NULL, NULL, 'Os02g0602600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(71735, NULL, 'G3DSA:2.10.25.10:FF:000840', NULL, NULL, 'Latent transforming growth factor beta binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(71736, NULL, 'G3DSA:3.40.1110.10:FF:000161', NULL, NULL, 'Copper resistance-associated P-type ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71737, NULL, 'G3DSA:1.20.140.40:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71738, NULL, 'G3DSA:2.60.40.1180:FF:000227', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(71739, NULL, 'G3DSA:1.10.510.10:FF:002067', NULL, NULL, 'MAP/microtubule affinity-regulating kinase 4-like', NULL, NULL, NULL, NULL, NULL, 4),
(71740, NULL, 'G3DSA:1.25.40.10:FF:000815', NULL, NULL, 'Nuclear autoantigenic sperm protein', NULL, NULL, NULL, NULL, NULL, 4),
(71741, NULL, 'G3DSA:2.130.10.10:FF:000598', NULL, NULL, 'E3 ubiquitin-protein ligase RFWD3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(71742, NULL, 'G3DSA:3.30.300.30:FF:000027', NULL, NULL, '2-succinylbenzoate--CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(71743, NULL, 'G3DSA:3.40.850.10:FF:000352', NULL, NULL, 'Gamma-soluble NSF attachment protein', NULL, NULL, NULL, NULL, NULL, 4),
(71744, NULL, 'G3DSA:1.10.340.30:FF:000036', NULL, NULL, '8-oxoguanine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(71745, NULL, 'G3DSA:3.55.50.30:FF:000030', NULL, NULL, 'Fec operon regulator FecR', NULL, NULL, NULL, NULL, NULL, 4),
(71746, NULL, 'G3DSA:1.25.40.10:FF:004177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71747, NULL, 'G3DSA:2.30.29.30:FF:000842', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71748, NULL, 'G3DSA:3.40.50.10490:FF:000005', NULL, NULL, '30S ribosomal protein S2', NULL, NULL, NULL, NULL, NULL, 4),
(71749, NULL, 'G3DSA:1.10.420.10:FF:000031', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(71750, NULL, 'G3DSA:1.10.10.60:FF:000587', NULL, NULL, 'SWITCH/sucrose nonfermenting 3A', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(71751, NULL, 'G3DSA:3.90.1290.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71752, NULL, 'G3DSA:3.20.20.80:FF:000818', NULL, NULL, 'Glucosidase, alpha; acid (Pompe disease, glycogen storage disease type II)', NULL, NULL, NULL, NULL, NULL, 4),
(71753, NULL, 'G3DSA:3.40.1190.20:FF:000202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71754, NULL, 'G3DSA:3.80.10.10:FF:003583', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71755, NULL, 'G3DSA:1.10.287.130:FF:000149', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(71756, NULL, 'G3DSA:2.130.10.10:FF:003392', NULL, NULL, 'YALI0E33774p', NULL, NULL, NULL, NULL, NULL, 4),
(71757, NULL, 'G3DSA:3.60.40.10:FF:000376', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71758, NULL, 'G3DSA:2.160.20.10:FF:000153', NULL, NULL, 'Pectinesterase 31', NULL, NULL, NULL, NULL, NULL, 4),
(71759, NULL, 'G3DSA:3.90.1410.10:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71760, NULL, 'G3DSA:3.40.50.720:FF:002449', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71761, NULL, 'G3DSA:1.10.40.60:FF:000004', NULL, NULL, 'Type II secretion system protein K', NULL, NULL, NULL, NULL, NULL, 4),
(71762, NULL, 'G3DSA:4.10.280.10:FF:000036', NULL, NULL, 'Transcription factor AP-4', NULL, NULL, NULL, NULL, NULL, 4),
(71763, NULL, 'G3DSA:1.10.1070.11:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71764, NULL, 'G3DSA:3.30.1490.100:FF:000007', NULL, NULL, 'DNA polymerase eta', NULL, NULL, NULL, NULL, NULL, 4),
(71765, NULL, 'G3DSA:3.40.50.12710:FF:000042', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7', NULL, NULL, NULL, NULL, NULL, 4),
(71766, NULL, 'G3DSA:3.30.70.1050:FF:000021', NULL, NULL, 'Trigger factor-like protein TIG Chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(71767, NULL, 'G3DSA:3.30.43.10:FF:000041', NULL, NULL, 'UDP-N-acetylenolpyruvoylglucosamine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(71768, NULL, 'G3DSA:2.10.25.10:FF:001357', NULL, NULL, 'GM19112', NULL, NULL, NULL, NULL, NULL, 4),
(71769, NULL, 'G3DSA:1.25.40.10:FF:003300', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g62590', NULL, NULL, NULL, NULL, NULL, 4),
(71770, NULL, 'G3DSA:2.60.40.60:FF:001045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71771, NULL, 'G3DSA:1.20.5.170:FF:000008', NULL, NULL, 'probable global transcription activator SNF2L2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(71772, NULL, 'G3DSA:3.30.300.10:FF:000021', NULL, NULL, 'S-adenosylmethionine synthetase 1', NULL, NULL, NULL, NULL, NULL, 4),
(71773, NULL, 'G3DSA:3.30.200.20:FF:000606', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(71774, NULL, 'G3DSA:3.90.1150.210:FF:000008', NULL, NULL, 'F-actin-capping protein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(71775, NULL, 'G3DSA:3.30.230.10:FF:000105', NULL, NULL, 'Ribonuclease P protein component', NULL, NULL, NULL, NULL, NULL, 4),
(71776, NULL, 'G3DSA:1.10.3200.20:FF:000005', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(71777, NULL, 'G3DSA:1.10.510.10:FF:001286', NULL, NULL, 'Possible serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(71778, NULL, 'G3DSA:3.30.160.60:FF:000311', NULL, NULL, 'protein odd-skipped-related 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(71779, NULL, 'G3DSA:3.30.780.10:FF:000017', NULL, NULL, 'Protein translation factor SUI1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(71780, NULL, 'G3DSA:3.40.50.1820:FF:001160', NULL, NULL, 'Homoserine O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(71781, NULL, 'G3DSA:1.25.40.80:FF:000022', NULL, NULL, 'Cryptochrome photolyase family 1', NULL, NULL, NULL, NULL, NULL, 4),
(71782, NULL, 'G3DSA:3.10.20.90:FF:000996', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71783, NULL, 'G3DSA:1.20.1440.80:FF:000004', NULL, NULL, 'Gap junction epsilon-1 protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(71784, NULL, 'G3DSA:2.60.40.10:FF:002952', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(71785, NULL, 'G3DSA:3.90.190.20:FF:000017', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(71786, NULL, 'G3DSA:3.40.50.620:FF:000059', NULL, NULL, 'Universal stress protein F', NULL, NULL, NULL, NULL, NULL, 4),
(71787, NULL, 'G3DSA:3.30.420.580:FF:000009', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(71788, NULL, 'G3DSA:1.25.40.20:FF:000583', NULL, NULL, 'Os11g0435300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(71789, NULL, 'G3DSA:1.10.3730.20:FF:000034', NULL, NULL, 'DMT family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(71790, NULL, 'G3DSA:2.30.42.10:FF:000064', NULL, NULL, 'protein lap4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(71791, NULL, 'G3DSA:1.20.1070.10:FF:001175', NULL, NULL, 'Prostaglandin E2 receptor EP4 subtype', NULL, NULL, NULL, NULL, NULL, 4),
(71792, NULL, 'G3DSA:2.30.39.10:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71793, NULL, 'G3DSA:3.40.390.10:FF:000193', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71794, NULL, 'G3DSA:3.30.420.10:FF:000209', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(71795, NULL, 'G3DSA:3.30.160.60:FF:003537', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71796, NULL, 'G3DSA:3.30.1370.10:FF:000036', NULL, NULL, 'KH RNA binding domain containing, signal transduction associated 1', NULL, NULL, NULL, NULL, NULL, 4),
(71797, NULL, 'G3DSA:1.10.10.790:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71798, NULL, 'G3DSA:3.30.300.10:FF:000049', NULL, NULL, 'S-adenosylmethionine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(71799, NULL, 'G3DSA:3.40.50.10860:FF:000026', NULL, NULL, 'Pentafunctional AROM polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(71800, NULL, 'G3DSA:1.10.510.10:FF:000190', NULL, NULL, 'Proto-oncogene tyrosine-protein kinase receptor Ret', NULL, NULL, NULL, NULL, NULL, 4),
(71801, NULL, 'G3DSA:2.70.70.10:FF:000014', NULL, NULL, 'Peptidase, M23 family', NULL, NULL, NULL, NULL, NULL, 4),
(71802, NULL, 'G3DSA:3.40.50.300:FF:005544', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(71803, NULL, 'G3DSA:3.40.50.80:FF:000191', NULL, NULL, 'Superoxide-generating NADPH oxidase heavy chain subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(71804, NULL, 'G3DSA:3.40.50.300:FF:004976', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71805, NULL, 'G3DSA:2.60.120.200:FF:000647', NULL, NULL, 'Laminin subunit alpha-3', NULL, NULL, NULL, NULL, NULL, 4),
(71806, NULL, 'G3DSA:2.10.50.10:FF:000061', NULL, NULL, 'Cysteine repeat modular protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(71807, NULL, 'G3DSA:1.10.10.10:FF:002039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71808, NULL, 'G3DSA:3.60.40.10:FF:000325', NULL, NULL, 'Os05g0111800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(71809, NULL, 'G3DSA:3.30.70.660:FF:000077', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(71810, NULL, 'G3DSA:2.30.40.10:FF:000014', NULL, NULL, 'Cytosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(71811, NULL, 'G3DSA:2.60.120.10:FF:000667', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71812, NULL, 'G3DSA:1.10.510.10:FF:002960', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71813, NULL, 'G3DSA:1.25.40.10:FF:002671', NULL, NULL, 'Peroxisomal targeting signal 1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(71814, NULL, 'G3DSA:1.20.5.1300:FF:000003', NULL, NULL, 'Histidinol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(71815, NULL, 'G3DSA:2.30.170.20:FF:000011', NULL, NULL, '60S ribosomal protein L24, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71816, NULL, 'G3DSA:2.60.40.150:FF:000179', NULL, NULL, 'synaptotagmin-5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(71817, NULL, 'G3DSA:1.10.10.60:FF:000295', NULL, NULL, 'Distal-less homeobox 4', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(71818, NULL, 'G3DSA:3.40.30.10:FF:000421', NULL, NULL, 'Thioredoxin related transmembrane protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(71819, NULL, 'G3DSA:3.40.50.1820:FF:000209', NULL, NULL, 'Protein phosphatase methylesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(71820, NULL, 'G3DSA:3.30.70.2450:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71821, NULL, 'G3DSA:1.10.3270.10:FF:000001', NULL, NULL, '3-hydroxy-3-methylglutaryl coenzyme A reductase', NULL, NULL, NULL, NULL, NULL, 4),
(71822, NULL, 'G3DSA:3.40.50.300:FF:000132', NULL, NULL, 'Phosphate import ATP-binding protein PstB', NULL, NULL, NULL, NULL, NULL, 4),
(71823, NULL, 'G3DSA:3.30.310.10:FF:000027', NULL, NULL, 'TBP-like factor', NULL, NULL, NULL, NULL, NULL, 4),
(71824, NULL, 'G3DSA:3.40.50.720:FF:001836', NULL, NULL, 'Myo-inositol-1-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(71825, NULL, 'G3DSA:1.10.533.10:FF:000074', NULL, NULL, 'NLR family pyrin domain containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(71826, NULL, 'G3DSA:3.30.70.2430:FF:000002', NULL, NULL, 'Acyl transferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(71827, NULL, 'G3DSA:3.30.230.10:FF:000026', NULL, NULL, 'DNA repair protein RadA', NULL, NULL, NULL, NULL, NULL, 4),
(71828, NULL, 'G3DSA:1.10.1040.10:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71829, NULL, 'G3DSA:1.20.1560.10:FF:000690', NULL, NULL, 'Uncharacterized protein ABCC16', NULL, NULL, NULL, NULL, NULL, 4),
(71830, NULL, 'G3DSA:3.30.160.60:FF:002340', NULL, NULL, 'Zinc finger protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(71831, NULL, 'G3DSA:3.90.1800.10:FF:000022', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71832, NULL, 'G3DSA:3.40.50.300:FF:003358', NULL, NULL, 'Helicase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(71833, NULL, 'G3DSA:2.40.50.140:FF:000964', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71834, NULL, 'G3DSA:3.90.1150.10:FF:000180', NULL, NULL, 'Aspartate aminotransferase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(71835, NULL, 'G3DSA:3.10.50.40:FF:000062', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(71836, NULL, 'G3DSA:3.30.70.330:FF:000681', NULL, NULL, 'X16 splicing factor, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(71837, NULL, 'G3DSA:1.10.10.350:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71838, NULL, 'G3DSA:2.10.25.10:FF:000109', NULL, NULL, 'Notch homolog 4, [Drosophila]', NULL, NULL, NULL, NULL, NULL, 4),
(71839, NULL, 'G3DSA:4.10.1000.10:FF:000001', NULL, NULL, 'zinc finger CCCH domain-containing protein 15-like', NULL, NULL, NULL, NULL, NULL, 4),
(71840, NULL, 'G3DSA:3.40.50.410:FF:000226', NULL, NULL, 'AGAP009043-PA', NULL, NULL, NULL, NULL, NULL, 4),
(71841, NULL, 'G3DSA:3.40.50.11340:FF:000002', NULL, NULL, 'GDP-fucose protein O-fucosyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(71842, NULL, 'G3DSA:3.40.930.10:FF:000010', NULL, NULL, 'Mannitol-specific cryptic phosphotransferase enzyme IIA component', NULL, NULL, NULL, NULL, NULL, 4),
(71843, NULL, 'G3DSA:3.40.50.300:FF:000761', NULL, NULL, 'Thymidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(71844, NULL, 'G3DSA:1.10.1200.10:FF:000148', NULL, NULL, 'Hydroxamate-type ferrichrome siderophore peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(71845, NULL, 'G3DSA:1.25.40.10:FF:002283', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(71846, NULL, 'G3DSA:2.40.110.10:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71847, NULL, 'G3DSA:3.40.250.10:FF:000031', NULL, NULL, 'Thiosulfate sulfurtransferase like domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(71848, NULL, 'G3DSA:1.10.490.10:FF:000046', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71849, NULL, 'G3DSA:1.20.930.20:FF:000014', NULL, NULL, 'E3 ubiquitin-protein ligase CBL-B', NULL, NULL, NULL, NULL, NULL, 4),
(71850, NULL, 'G3DSA:3.30.20.10:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(71851, NULL, 'G3DSA:2.20.100.10:FF:000192', NULL, NULL, 'Thrombospondin type-1 domain-containing protein 7B', NULL, NULL, NULL, NULL, NULL, 4),
(71852, NULL, 'G3DSA:3.30.760.10:FF:000055', NULL, NULL, 'Eukaryotic translation initiation factor 4E; Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71853, NULL, 'G3DSA:1.10.238.110:FF:000022', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(71854, NULL, 'G3DSA:3.30.70.330:FF:002867', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71855, NULL, 'G3DSA:3.80.10.10:FF:001323', NULL, NULL, 'F-box family protein', NULL, NULL, NULL, NULL, NULL, 4),
(71856, NULL, 'G3DSA:1.25.40.10:FF:002339', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(71857, NULL, 'G3DSA:3.50.7.10:FF:000071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71858, NULL, 'G3DSA:3.10.290.10:FF:000080', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(71859, NULL, 'G3DSA:3.80.10.10:FF:000385', NULL, NULL, 'Leucine-rich repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(71860, NULL, 'G3DSA:3.50.50.60:FF:001241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71861, NULL, 'G3DSA:3.10.20.90:FF:000092', NULL, NULL, 'Small ubiquitin-related modifier', NULL, NULL, NULL, NULL, NULL, 4),
(71862, NULL, 'G3DSA:1.10.8.1070:FF:000004', NULL, NULL, 'Os11g0707100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(71863, NULL, 'G3DSA:1.10.10.10:FF:001590', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71864, NULL, 'G3DSA:1.10.287.690:FF:000019', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(71865, NULL, 'G3DSA:2.60.120.10:FF:000515', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71866, NULL, 'G3DSA:1.25.40.720:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71867, NULL, 'G3DSA:3.40.50.300:FF:002902', NULL, NULL, 'ABC transporter, ATP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71868, NULL, 'G3DSA:3.40.50.300:FF:006213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71869, NULL, 'G3DSA:2.60.40.420:FF:000171', NULL, NULL, 'Multicopper oxidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(71870, NULL, 'G3DSA:3.90.950.10:FF:000039', NULL, NULL, 'Probable inosine/xanthosine triphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(71871, NULL, 'G3DSA:3.30.2070.10:FF:000002', NULL, NULL, 'Probable oxidoreductase YyaE', NULL, NULL, NULL, NULL, NULL, 4),
(71872, NULL, 'G3DSA:3.30.200.20:FF:000106', NULL, NULL, 'serine/threonine-protein kinase TBK1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(71873, NULL, 'G3DSA:3.30.160.60:FF:004526', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71874, NULL, 'G3DSA:1.25.40.180:FF:000036', NULL, NULL, 'Eukaryotic translation initiation factor isoform 4G-2', NULL, NULL, NULL, NULL, NULL, 4),
(71875, NULL, 'G3DSA:1.20.930.40:FF:000020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71876, NULL, 'G3DSA:2.60.40.10:FF:003088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71877, NULL, 'G3DSA:4.10.1000.30:FF:000007', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71878, NULL, 'G3DSA:1.20.58.1070:FF:000001', NULL, NULL, 'Gem-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(71879, NULL, 'G3DSA:1.10.8.10:FF:000054', NULL, NULL, 'E3 ubiquitin protein ligase RIN2', NULL, NULL, NULL, NULL, NULL, 4),
(71880, NULL, 'G3DSA:3.30.40.10:FF:001636', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71881, NULL, 'G3DSA:3.90.226.10:FF:000317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71882, NULL, 'G3DSA:3.70.10.10:FF:000003', NULL, NULL, 'Beta sliding clamp', NULL, NULL, NULL, NULL, NULL, 4),
(71883, NULL, 'G3DSA:1.20.1070.10:FF:001916', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71884, NULL, 'G3DSA:1.10.150.240:FF:000037', NULL, NULL, 'Phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(71885, NULL, 'G3DSA:4.10.1090.10:FF:000001', NULL, NULL, 'Tail spike protein', NULL, NULL, NULL, NULL, NULL, 4),
(71886, NULL, 'G3DSA:1.20.920.20:FF:000036', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(71887, NULL, 'G3DSA:2.10.70.10:FF:000124', NULL, NULL, 'Complement factor H related 4', NULL, NULL, NULL, NULL, NULL, 4),
(71888, NULL, 'G3DSA:1.10.400.10:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71889, NULL, 'G3DSA:2.10.25.10:FF:000340', NULL, NULL, 'Terribly reduced optic lobes, isoform AT', NULL, NULL, NULL, NULL, NULL, 4),
(71890, NULL, 'G3DSA:3.40.50.720:FF:000651', NULL, NULL, 'Glutathione-regulated potassium-efflux system protein KefB', NULL, NULL, NULL, NULL, NULL, 4),
(71891, NULL, 'G3DSA:1.20.140.20:FF:000010', NULL, NULL, '[Pyruvate dehydrogenase (Acetyl-transferring)] kinase mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(71892, NULL, 'G3DSA:1.10.510.10:FF:002808', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71893, NULL, 'G3DSA:3.30.1120.10:FF:000001', NULL, NULL, 'Arylsulfatase E', NULL, NULL, NULL, NULL, NULL, 4),
(71894, NULL, 'G3DSA:1.20.58.400:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71895, NULL, 'G3DSA:3.60.15.10:FF:000071', NULL, NULL, 'Ribonuclease J', NULL, NULL, NULL, NULL, NULL, 4),
(71896, NULL, 'G3DSA:1.10.287.70:FF:000120', NULL, NULL, 'Voltage-dependent T-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(71897, NULL, 'G3DSA:2.60.40.10:FF:003200', NULL, NULL, 'Plexin A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71898, NULL, 'G3DSA:2.60.120.920:FF:000037', NULL, NULL, 'Si:dkey-191j3.2', NULL, NULL, NULL, NULL, NULL, 4),
(71899, NULL, 'G3DSA:2.70.160.11:FF:000005', NULL, NULL, 'protein arginine N-methyltransferase 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(71900, NULL, 'G3DSA:3.30.390.150:FF:000001', NULL, NULL, 'leukocyte cell-derived chemotaxin 1', NULL, NULL, NULL, NULL, NULL, 4),
(71901, NULL, 'G3DSA:1.20.120.1900:FF:000067', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(71902, NULL, 'G3DSA:2.60.40.150:FF:000567', NULL, NULL, 'Ca2+dependent plant phosphoribosyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(71903, NULL, 'G3DSA:1.10.472.130:FF:000072', NULL, NULL, 'YALI0E32857p', NULL, NULL, NULL, NULL, NULL, 4),
(71904, NULL, 'G3DSA:2.60.40.10:FF:005274', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71905, NULL, 'G3DSA:1.25.40.20:FF:000431', NULL, NULL, 'Transient receptor potential cation channel subfamily V member 4', NULL, NULL, NULL, NULL, NULL, 4),
(71906, NULL, 'G3DSA:2.40.128.330:FF:000010', NULL, NULL, 'Magnesium transporter MRS2-6, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(71907, NULL, 'G3DSA:1.10.600.10:FF:000045', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(71908, NULL, 'G3DSA:2.40.50.140:FF:000317', NULL, NULL, 'Replication protein A2', NULL, NULL, NULL, NULL, NULL, 4),
(71909, NULL, 'G3DSA:3.80.10.10:FF:003240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71910, NULL, 'G3DSA:3.40.30.10:FF:000101', NULL, NULL, '2-cys peroxiredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(71911, NULL, 'G3DSA:2.60.120.340:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71912, NULL, 'G3DSA:3.40.30.10:FF:000213', NULL, NULL, 'APD1p protein', NULL, NULL, NULL, NULL, NULL, 4),
(71913, NULL, 'G3DSA:3.30.70.270:FF:000230', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71914, NULL, 'G3DSA:3.30.420.10:FF:000417', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71915, NULL, 'G3DSA:1.10.238.220:FF:000004', NULL, NULL, 'Putative phosphatase 2A regulatory subunit-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(71916, NULL, 'G3DSA:1.25.10.10:FF:002455', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71917, NULL, 'G3DSA:3.40.50.720:FF:000494', NULL, NULL, 'Adenylate kinase 7', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(71918, NULL, 'G3DSA:3.40.50.300:FF:001542', NULL, NULL, 'Thiol reductant ABC exporter subunit CydD', NULL, NULL, NULL, NULL, NULL, 4),
(71919, NULL, 'G3DSA:1.25.40.470:FF:000022', NULL, NULL, 'Intraflagellar transport protein 172', NULL, NULL, NULL, NULL, NULL, 4),
(71920, NULL, 'G3DSA:3.30.70.3290:FF:000024', NULL, NULL, 'Probable polyketide synthase 37', NULL, NULL, NULL, NULL, NULL, 4),
(71921, NULL, 'G3DSA:6.10.250.3420:FF:000001', NULL, NULL, 'Hsc70-interacting protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(71922, NULL, 'G3DSA:2.40.50.40:FF:000074', NULL, NULL, 'C-C motif chemokine', NULL, NULL, NULL, NULL, NULL, 4),
(71923, NULL, 'G3DSA:3.90.550.10:FF:000110', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(71924, NULL, 'G3DSA:3.30.160.60:FF:003745', NULL, NULL, 'Zinc finger protein 1143', NULL, NULL, NULL, NULL, NULL, 4),
(71925, NULL, 'G3DSA:1.25.10.10:FF:002579', NULL, NULL, 'Proteasome activator complex subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71926, NULL, 'G3DSA:1.20.120.850:FF:000015', NULL, NULL, 'Rad5p', NULL, NULL, NULL, NULL, NULL, 4),
(71927, NULL, 'G3DSA:2.130.10.10:FF:004734', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71928, NULL, 'G3DSA:2.10.220.10:FF:000012', NULL, NULL, 'R-spondin 4', NULL, NULL, NULL, NULL, NULL, 4),
(71929, NULL, 'G3DSA:3.40.50.2000:FF:000045', NULL, NULL, 'Glycogen [starch] synthase', NULL, NULL, NULL, NULL, NULL, 4),
(71930, NULL, 'G3DSA:3.20.20.30:FF:000040', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71931, NULL, 'G3DSA:1.25.10.10:FF:001382', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(71932, NULL, 'G3DSA:3.30.160.60:FF:005370', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71933, NULL, 'G3DSA:1.20.920.10:FF:000128', NULL, NULL, 'PolyBRoMo domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(71934, NULL, 'G3DSA:1.20.1070.10:FF:002113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71935, NULL, 'G3DSA:1.20.1560.10:FF:000414', NULL, NULL, 'Cystic Fibrosis Transmembrane conductance regulator homolog', NULL, NULL, NULL, NULL, NULL, 4),
(71936, NULL, 'G3DSA:2.170.130.10:FF:000074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71937, NULL, 'G3DSA:3.30.160.60:FF:005774', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71938, NULL, 'G3DSA:3.40.390.10:FF:000041', NULL, NULL, 'Kuzbanian-like, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(71939, NULL, 'G3DSA:3.30.70.330:FF:002479', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71940, NULL, 'G3DSA:1.20.1730.10:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71941, NULL, 'G3DSA:2.60.40.10:FF:000715', NULL, NULL, 'Platelet-derived growth factor receptor beta', NULL, NULL, NULL, NULL, NULL, 4),
(71942, NULL, 'G3DSA:3.40.50.300:FF:003566', NULL, NULL, 'Sulfotransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(71943, NULL, 'G3DSA:1.25.40.320:FF:000005', NULL, NULL, 'Aminopeptidase ltah-1.1', NULL, NULL, NULL, NULL, NULL, 4),
(71944, NULL, 'G3DSA:1.25.40.10:FF:004469', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71945, NULL, 'G3DSA:1.10.630.10:FF:000777', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71946, NULL, 'G3DSA:3.20.20.330:FF:000010', NULL, NULL, 'Bifunctional homocysteine S-methyltransferase/methylenetetrahydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(71947, NULL, 'G3DSA:1.10.20.10:FF:000359', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71948, NULL, 'G3DSA:3.40.50.1110:FF:000087', NULL, NULL, 'Protein CBG02607', NULL, NULL, NULL, NULL, NULL, 4),
(71949, NULL, 'G3DSA:1.20.5.100:FF:000027', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(71950, NULL, 'G3DSA:3.80.10.10:FF:001727', NULL, NULL, 'F-box/LRR-repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(71951, NULL, 'G3DSA:3.50.50.60:FF:000509', NULL, NULL, 'Steroid monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71952, NULL, 'G3DSA:3.40.50.300:FF:005932', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(71953, NULL, 'G3DSA:3.40.50.12780:FF:000023', NULL, NULL, 'Long-chain-fatty-acid--CoA ligase ACSBG1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(71954, NULL, 'G3DSA:3.40.50.261:FF:000025', NULL, NULL, 'Succinyl-CoA ligase [GDP-forming] subunit beta, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(71955, NULL, 'G3DSA:3.30.60.20:FF:000016', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(71956, NULL, 'G3DSA:1.20.120.230:FF:000037', NULL, NULL, 'Alpha-catenin-like protein hmp-1', NULL, NULL, NULL, NULL, NULL, 4),
(71957, NULL, 'G3DSA:1.25.40.90:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71958, NULL, 'G3DSA:3.30.70.330:FF:000394', NULL, NULL, 'Nucleolysin tiar isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(71959, NULL, 'G3DSA:1.10.1410.40:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71960, NULL, 'G3DSA:1.20.1250.20:FF:000933', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(71961, NULL, 'G3DSA:2.60.260.20:FF:000146', NULL, NULL, 'DnaJ-like protein subfamily B member 1', NULL, NULL, NULL, NULL, NULL, 4),
(71962, NULL, 'G3DSA:3.10.590.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71963, NULL, 'G3DSA:2.40.30.10:FF:000491', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71964, NULL, 'G3DSA:3.30.70.330:FF:002979', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71965, NULL, 'G3DSA:3.30.870.30:FF:000002', NULL, NULL, 'MIT domain-containing protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(71966, NULL, 'G3DSA:3.30.430.20:FF:000039', NULL, NULL, 'Antifungal protein ginkbilobin-2', NULL, NULL, NULL, NULL, NULL, 4),
(71967, NULL, 'G3DSA:1.20.900.10:FF:000088', NULL, NULL, 'Putative rho guanine nucleotide exchange factor cdep', NULL, NULL, NULL, NULL, NULL, 4),
(71968, NULL, 'G3DSA:1.10.10.10:FF:000858', NULL, NULL, 'Transcriptional regulator, GntR family', NULL, NULL, NULL, NULL, NULL, 4),
(71969, NULL, 'G3DSA:1.20.870.10:FF:000034', NULL, NULL, 'Ral guanine nucleotide dissociation stimulator-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(71970, NULL, 'G3DSA:3.30.200.20:FF:001163', NULL, NULL, 'Serine/threonine-protein kinase cbk1', NULL, NULL, NULL, NULL, NULL, 4),
(71971, NULL, 'G3DSA:3.40.50.150:FF:000570', NULL, NULL, 'MTQ1p S-adenosylmethionine-dependent methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(71972, NULL, 'G3DSA:2.40.50.140:FF:000840', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71973, NULL, 'G3DSA:1.20.58.60:FF:000550', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71974, NULL, 'G3DSA:1.10.10.10:FF:001382', NULL, NULL, 'Si:rp71-45k5.2', NULL, NULL, NULL, NULL, NULL, 4),
(71975, NULL, 'G3DSA:2.60.120.10:FF:000403', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71976, NULL, 'G3DSA:3.40.470.10:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71977, NULL, 'G3DSA:2.60.40.10:FF:001963', NULL, NULL, 'GH11366', NULL, NULL, NULL, NULL, NULL, 4),
(71978, NULL, 'G3DSA:3.40.50.150:FF:001244', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71979, NULL, 'G3DSA:1.10.238.20:FF:000054', NULL, NULL, 'Odorant binding protein b', NULL, NULL, NULL, NULL, NULL, 4),
(71980, NULL, 'G3DSA:2.10.70.10:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71981, NULL, 'G3DSA:1.10.286.40:FF:000002', NULL, NULL, 'Photosystem I reaction center subunit V', NULL, NULL, NULL, NULL, NULL, 4),
(71982, NULL, 'G3DSA:3.10.250.10:FF:000015', NULL, NULL, 'Scavenger receptor cysteine-rich type 1 protein M130', NULL, NULL, NULL, NULL, NULL, 4),
(71983, NULL, 'G3DSA:3.30.310.50:FF:000039', NULL, NULL, 'Phosphoacetylglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(71984, NULL, 'G3DSA:1.25.40.10:FF:004756', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(71985, NULL, 'G3DSA:3.90.1150.10:FF:000028', NULL, NULL, 'Putrescine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(71986, NULL, 'G3DSA:3.30.40.10:FF:000647', NULL, NULL, 'Os06g0540200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(71987, NULL, 'G3DSA:3.40.630.20:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71988, NULL, 'G3DSA:3.10.20.310:FF:000012', NULL, NULL, 'Outer envelope protein 80, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(71989, NULL, 'G3DSA:3.30.200.20:FF:002523', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71990, NULL, 'G3DSA:1.20.1070.10:FF:000394', NULL, NULL, 'Opsin 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(71991, NULL, 'G3DSA:3.10.330.10:FF:000016', NULL, NULL, 'AAA ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(71992, NULL, 'G3DSA:1.25.40.10:FF:004205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71993, NULL, 'G3DSA:2.130.10.10:FF:002672', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71994, NULL, 'G3DSA:3.20.20.190:FF:000097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(71995, NULL, 'G3DSA:1.10.418.10:FF:000115', NULL, NULL, 'Plastin 1', NULL, NULL, NULL, NULL, NULL, 4),
(71996, NULL, 'G3DSA:3.30.1520.10:FF:000082', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(71997, NULL, 'G3DSA:2.20.25.10:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(71998, NULL, 'G3DSA:3.30.160.20:FF:000226', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(71999, NULL, 'G3DSA:3.30.160.60:FF:003357', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72000, NULL, 'G3DSA:3.30.70.1990:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72001, NULL, 'G3DSA:3.30.200.20:FF:002444', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72002, NULL, 'G3DSA:1.25.40.10:FF:003396', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g04760, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(72003, NULL, 'G3DSA:2.170.130.30:FF:000001', NULL, NULL, 'Cobalamin binding intrinsic factor', NULL, NULL, NULL, NULL, NULL, 4),
(72004, NULL, 'G3DSA:3.40.50.2000:FF:000606', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(72005, NULL, 'G3DSA:2.60.220.50:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72006, NULL, 'G3DSA:3.40.50.410:FF:000165', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(72007, NULL, 'G3DSA:3.40.50.300:FF:006713', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(72008, NULL, 'G3DSA:3.50.50.60:FF:000448', NULL, NULL, 'Putative polyamine oxidase 5 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(72009, NULL, 'G3DSA:2.160.20.10:FF:000092', NULL, NULL, 'Putative pectinesterase 57', NULL, NULL, NULL, NULL, NULL, 4),
(72010, NULL, 'G3DSA:3.40.50.720:FF:001432', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(72011, NULL, 'G3DSA:2.60.40.10:FF:000215', NULL, NULL, 'Down syndrome cell adhesion molecule a', NULL, NULL, NULL, NULL, NULL, 4),
(72012, NULL, 'G3DSA:3.30.60.10:FF:000002', NULL, NULL, 'Chitinase B', NULL, NULL, NULL, NULL, NULL, 4),
(72013, NULL, 'G3DSA:3.10.310.40:FF:000001', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(72014, NULL, 'G3DSA:1.10.3810.10:FF:000021', NULL, NULL, 'Penicillin-binding protein PbpC', NULL, NULL, NULL, NULL, NULL, 4),
(72015, NULL, 'G3DSA:1.10.10.10:FF:001943', NULL, NULL, 'General transcription factor IIE, polypeptide 1, alpha', NULL, NULL, NULL, NULL, NULL, 4),
(72016, NULL, 'G3DSA:2.30.30.40:FF:000348', NULL, NULL, 'Unconventional myosin heavy chain 6', NULL, NULL, NULL, NULL, NULL, 4),
(72017, NULL, 'G3DSA:3.40.50.2300:FF:000253', NULL, NULL, 'Extracellular calcium-sensing receptor', NULL, NULL, NULL, NULL, NULL, 4),
(72018, NULL, 'G3DSA:2.30.30.30:FF:000115', NULL, NULL, 'Transcription elongation factor SPT5', NULL, NULL, NULL, NULL, NULL, 4),
(72019, NULL, 'G3DSA:2.40.10.10:FF:000669', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(72020, NULL, 'G3DSA:1.20.58.610:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72021, NULL, 'G3DSA:2.60.120.10:FF:000162', NULL, NULL, 'Beta-conglycinin beta subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(72022, NULL, 'G3DSA:1.10.1820.10:FF:000004', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(72023, NULL, 'G3DSA:1.20.5.420:FF:000005', NULL, NULL, 'Hsc70 cochaperone (SGT), putative', NULL, NULL, NULL, NULL, NULL, 4),
(72024, NULL, 'G3DSA:3.60.110.10:FF:000062', NULL, NULL, 'Carbon-nitrogen hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(72025, NULL, 'G3DSA:3.40.50.1000:FF:000054', NULL, NULL, 'alpha,alpha-trehalose-phosphate synthase [UDP-forming] 6', NULL, NULL, NULL, NULL, NULL, 4),
(72026, NULL, 'G3DSA:3.90.740.10:FF:000057', NULL, NULL, 'Valyl tRNA Synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(72027, NULL, 'G3DSA:3.80.10.10:FF:003740', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72028, NULL, 'G3DSA:2.60.40.150:FF:000359', NULL, NULL, 'DNAJ domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(72029, NULL, 'G3DSA:3.40.140.10:FF:000118', NULL, NULL, 'tRNA-specific adenosine deaminase subunit TAD3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(72030, NULL, 'G3DSA:3.80.10.10:FF:002104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72031, NULL, 'G3DSA:3.40.50.2000:FF:000365', NULL, NULL, 'Glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(72032, NULL, 'G3DSA:3.30.160.60:FF:006494', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72033, NULL, 'G3DSA:2.10.25.10:FF:001806', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(72034, NULL, 'G3DSA:3.40.366.10:FF:000047', NULL, NULL, 'Polyketide synthase, putative (JCVI)', NULL, NULL, NULL, NULL, NULL, 4),
(72035, NULL, 'G3DSA:1.20.58.1780:FF:000006', NULL, NULL, 'Nuclear pore complex protein Nup155', NULL, NULL, NULL, NULL, NULL, 4),
(72036, NULL, 'G3DSA:1.10.10.60:FF:000912', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72037, NULL, 'G3DSA:2.30.29.30:FF:000157', NULL, NULL, 'Putative rho GTPase-activating protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(72038, NULL, 'G3DSA:3.90.1150.10:FF:000404', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72039, NULL, 'G3DSA:3.30.160.60:FF:001328', NULL, NULL, 'paternally-expressed gene 3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(72040, NULL, 'G3DSA:2.10.25.10:FF:000901', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72041, NULL, 'G3DSA:2.120.10.30:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72042, NULL, 'G3DSA:3.30.70.120:FF:000005', NULL, NULL, 'CUTA isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(72043, NULL, 'G3DSA:1.10.20.10:FF:000191', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72044, NULL, 'G3DSA:3.40.50.300:FF:001481', NULL, NULL, 'Centromere protein M', NULL, NULL, NULL, NULL, NULL, 4),
(72045, NULL, 'G3DSA:3.40.50.1100:FF:000106', NULL, NULL, 'L-serine dehydratase/L-threonine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(72046, NULL, 'G3DSA:3.40.50.2300:FF:000596', NULL, NULL, 'Two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(72047, NULL, 'G3DSA:2.60.40.1360:FF:000017', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(72048, NULL, 'G3DSA:3.40.50.2300:FF:001534', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72049, NULL, 'G3DSA:2.60.40.4070:FF:000004', NULL, NULL, 'Basal-body rod modification protein FlgD', NULL, NULL, NULL, NULL, NULL, 4),
(72050, NULL, 'G3DSA:3.40.50.620:FF:000290', NULL, NULL, 'Isoleucyl-tRNA synthetase (Mitochondrial)', NULL, NULL, NULL, NULL, NULL, 4),
(72051, NULL, 'G3DSA:1.20.1270.10:FF:000032', NULL, NULL, 'Heat shock 70 kDa protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(72052, NULL, 'G3DSA:2.60.40.2170:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72053, NULL, 'G3DSA:3.40.720.10:FF:000135', NULL, NULL, 'Protein CBG05971', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(72054, NULL, 'G3DSA:1.10.287.3290:FF:000002', NULL, NULL, 'AFR652Wp', NULL, NULL, NULL, NULL, NULL, 4),
(72055, NULL, 'G3DSA:1.10.10.2210:FF:000003', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(72056, NULL, 'G3DSA:3.30.1550.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72057, NULL, 'G3DSA:3.30.710.10:FF:000187', NULL, NULL, 'Protein CBR-EXP-2', NULL, NULL, NULL, NULL, NULL, 4),
(72058, NULL, 'G3DSA:1.10.1740.10:FF:000003', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(72059, NULL, 'G3DSA:1.10.472.10:FF:000257', NULL, NULL, 'cyclin-L1-like', NULL, NULL, NULL, NULL, NULL, 4),
(72060, NULL, 'G3DSA:1.25.10.10:FF:002663', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72061, NULL, 'G3DSA:1.10.268.10:FF:000002', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(72062, NULL, 'G3DSA:2.30.42.10:FF:000417', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72063, NULL, 'G3DSA:1.10.101.10:FF:000043', NULL, NULL, 'General secretion pathway protein A', NULL, NULL, NULL, NULL, NULL, 4),
(72064, NULL, 'G3DSA:3.40.50.300:FF:005432', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(72065, NULL, 'G3DSA:1.10.510.10:FF:003005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72066, NULL, 'G3DSA:2.120.10.10:FF:000036', NULL, NULL, 'Glycoside hydrolase family 93', NULL, NULL, NULL, NULL, NULL, 4),
(72067, NULL, 'G3DSA:2.40.50.120:FF:000065', NULL, NULL, 'Secreted frizzled-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(72068, NULL, 'G3DSA:3.20.20.150:FF:000012', NULL, NULL, 'Related to UV-endonuclease UVE-1', NULL, NULL, NULL, NULL, NULL, 4),
(72069, NULL, 'G3DSA:3.40.50.880:FF:000058', NULL, NULL, 'GMP synthase [glutamine-hydrolyzing]', NULL, NULL, NULL, NULL, NULL, 4),
(72070, NULL, 'G3DSA:4.10.1250.10:FF:000003', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(72071, NULL, 'G3DSA:2.40.160.50:FF:000023', NULL, NULL, 'ShlB/FhaC/HecB family hemolysin secretion/activation protein', NULL, NULL, NULL, NULL, NULL, 4),
(72072, NULL, 'G3DSA:3.40.50.300:FF:005696', NULL, NULL, 'AGAP010924-PA', NULL, NULL, NULL, NULL, NULL, 4),
(72073, NULL, 'G3DSA:1.10.510.10:FF:001903', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(72074, NULL, 'G3DSA:3.90.79.10:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72075, NULL, 'G3DSA:3.40.50.300:FF:005191', NULL, NULL, 'Elongator complex protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(72076, NULL, 'G3DSA:2.130.10.10:FF:003796', NULL, NULL, 'LD30439p', NULL, NULL, NULL, NULL, NULL, 4),
(72077, NULL, 'G3DSA:3.40.50.1980:FF:000151', NULL, NULL, 'Iron ABC transporter, periplasmic iron-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(72078, NULL, 'G3DSA:1.20.5.260:FF:000002', NULL, NULL, 'cytochrome b-c1 complex subunit 9', NULL, NULL, NULL, NULL, NULL, 4),
(72079, NULL, 'G3DSA:3.40.190.10:FF:000773', NULL, NULL, 'Tripartite tricarboxylate transporter family receptor', NULL, NULL, NULL, NULL, NULL, 4),
(72080, NULL, 'G3DSA:1.25.40.10:FF:004548', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72081, NULL, 'G3DSA:1.20.920.30:FF:000078', NULL, NULL, 'Dynein, axonemal, heavy chain 11', NULL, NULL, NULL, NULL, NULL, 4),
(72082, NULL, 'G3DSA:3.90.640.10:FF:000061', NULL, NULL, 'Actin-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(72083, NULL, 'G3DSA:3.30.30.30:FF:000068', NULL, NULL, 'ADR128Cp', NULL, NULL, NULL, NULL, NULL, 4),
(72084, NULL, 'G3DSA:3.40.30.10:FF:000601', NULL, NULL, 'Nucleoredoxin-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(72085, NULL, 'G3DSA:2.60.40.60:FF:000977', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72086, NULL, 'G3DSA:3.40.50.11990:FF:000005', NULL, NULL, 'Cell division cycle-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(72087, NULL, 'G3DSA:3.40.630.10:FF:000369', NULL, NULL, 'Leucine aminopeptidase 2 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(72088, NULL, 'G3DSA:3.80.10.10:FF:001166', NULL, NULL, 'Cf2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(72089, NULL, 'G3DSA:4.10.800.30:FF:000004', NULL, NULL, 'Essential meiotic structure-specific endonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(72090, NULL, 'G3DSA:4.10.1170.10:FF:000002', NULL, NULL, 'MAP kinase-activated protein kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(72091, NULL, 'G3DSA:2.60.40.10:FF:004189', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72092, NULL, 'G3DSA:3.90.70.200:FF:000004', NULL, NULL, 'Zinc knuckle (CCHC-type) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(72093, NULL, 'G3DSA:4.10.280.10:FF:000148', NULL, NULL, 'Basic helix-loop-helix (BHLH) DNA-binding superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(72094, NULL, 'G3DSA:1.50.10.130:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72095, NULL, 'G3DSA:3.40.50.20:FF:000049', NULL, NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(72096, NULL, 'G3DSA:3.40.50.10190:FF:000185', NULL, NULL, 'DNA-repair protein xrcc1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(72097, NULL, 'G3DSA:2.60.40.10:FF:005206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72098, NULL, 'G3DSA:3.40.50.200:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72099, NULL, 'G3DSA:1.10.1870.10:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72100, NULL, 'G3DSA:3.40.50.11350:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72101, NULL, 'G3DSA:1.10.1300.10:FF:000032', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(72102, NULL, 'G3DSA:3.90.550.50:FF:000066', NULL, NULL, 'Lactosylceramide', NULL, NULL, NULL, NULL, NULL, 4),
(72103, NULL, 'G3DSA:2.60.40.10:FF:002744', NULL, NULL, 'Glycogen debranching enzyme GlgX', NULL, NULL, NULL, NULL, NULL, 4),
(72104, NULL, 'G3DSA:2.60.40.10:FF:002868', NULL, NULL, 'CD276 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(72105, NULL, 'G3DSA:3.10.430.100:FF:000001', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(72106, NULL, 'G3DSA:1.10.510.10:FF:002224', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72107, NULL, 'G3DSA:3.20.20.80:FF:000234', NULL, NULL, 'Glucuronoxylanase XynC', NULL, NULL, NULL, NULL, NULL, 4),
(72108, NULL, 'G3DSA:1.20.58.60:FF:000893', NULL, NULL, 'BIV spectrin', NULL, NULL, NULL, NULL, NULL, 4),
(72109, NULL, 'G3DSA:1.20.1090.10:FF:000046', NULL, NULL, 'Iron-containing alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(72110, NULL, 'G3DSA:3.40.50.300:FF:007961', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72111, NULL, 'G3DSA:1.20.1250.20:FF:001107', NULL, NULL, 'MFS multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(72112, NULL, 'G3DSA:3.40.525.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72113, NULL, 'G3DSA:3.40.1160.10:FF:000052', NULL, NULL, 'Delta-1-pyrroline-5-carboxylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(72114, NULL, 'G3DSA:2.40.30.130:FF:000058', NULL, NULL, 'Alanine--tRNA ligase, mitochondrial-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(72115, NULL, 'G3DSA:1.10.10.60:FF:000795', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72116, NULL, 'G3DSA:3.30.470.30:FF:000073', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(72117, NULL, 'G3DSA:3.10.20.90:FF:000676', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72118, NULL, 'G3DSA:3.30.160.60:FF:002109', NULL, NULL, 'ras-responsive element-binding protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(72119, NULL, 'G3DSA:2.130.10.10:FF:003453', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(72120, NULL, 'G3DSA:3.40.50.720:FF:000712', NULL, NULL, 'Probable short-chain type dehydrogenase/reductase', NULL, NULL, NULL, NULL, NULL, 4),
(72121, NULL, 'G3DSA:1.10.150.20:FF:000232', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(72122, NULL, 'G3DSA:3.40.50.1010:FF:000170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72123, NULL, 'G3DSA:1.10.150.20:FF:000153', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4),
(72124, NULL, 'G3DSA:3.60.10.10:FF:000020', NULL, NULL, 'Endonuclease/exonuclease/phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(72125, NULL, 'G3DSA:3.10.105.10:FF:000055', NULL, NULL, 'Extracellular solute-binding protein family 5', NULL, NULL, NULL, NULL, NULL, 4),
(72126, NULL, 'G3DSA:1.10.510.10:FF:004433', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72127, NULL, 'G3DSA:3.40.640.10:FF:000134', NULL, NULL, 'Serine hydroxymethyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(72128, NULL, 'G3DSA:1.50.40.10:FF:000241', NULL, NULL, 'Putative mitochondrial carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(72129, NULL, 'G3DSA:1.20.1070.10:FF:001736', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72130, NULL, 'G3DSA:3.40.50.620:FF:000851', NULL, NULL, 'FAD synthase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(72131, NULL, 'G3DSA:2.30.30.140:FF:000232', NULL, NULL, 'FI02030p', NULL, NULL, NULL, NULL, NULL, 4),
(72132, NULL, 'G3DSA:3.30.160.60:FF:006151', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72133, NULL, 'G3DSA:3.30.450.50:FF:000021', NULL, NULL, 'SNARE protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(72134, NULL, 'G3DSA:3.30.540.30:FF:000022', NULL, NULL, 'Dipeptidyl peptidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(72135, NULL, 'G3DSA:3.30.160.60:FF:002840', NULL, NULL, 'Spalt-like transcription factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(72136, NULL, 'G3DSA:3.30.40.10:FF:000068', NULL, NULL, 'U4/U6.U5 tri-snRNP-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(72137, NULL, 'G3DSA:1.10.565.10:FF:000125', NULL, NULL, 'nuclear receptor isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(72138, NULL, 'G3DSA:3.30.10.30:FF:000005', NULL, NULL, 'Dual-specificity protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(72139, NULL, 'G3DSA:1.10.730.10:FF:000133', NULL, NULL, 'Probable methionine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(72140, NULL, 'G3DSA:1.10.10.160:FF:000023', NULL, NULL, 'ATP-dependent DNA helicase Rep', NULL, NULL, NULL, NULL, NULL, 4),
(72141, NULL, 'G3DSA:1.25.40.10:FF:001058', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(72142, NULL, 'G3DSA:3.60.20.10:FF:000105', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(72143, NULL, 'G3DSA:3.30.40.10:FF:000911', NULL, NULL, 'Chromatin accessibility complex (CHRAC)', NULL, NULL, NULL, NULL, NULL, 4),
(72144, NULL, 'G3DSA:2.30.29.30:FF:001270', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(72145, NULL, 'G3DSA:3.40.50.150:FF:000339', NULL, NULL, 'Nuclear transcription factor Y subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(72146, NULL, 'G3DSA:1.25.40.10:FF:000658', NULL, NULL, 'Hsp70-Hsp90 organizing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(72147, NULL, 'G3DSA:1.10.287.470:FF:000072', NULL, NULL, 'Multidrug resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(72148, NULL, 'G3DSA:2.60.120.200:FF:000439', NULL, NULL, 'EGFLAM isoform 11', NULL, NULL, NULL, NULL, NULL, 4),
(72149, NULL, 'G3DSA:3.90.1200.10:FF:000016', NULL, NULL, 'Possible aminoglycoside phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(72150, NULL, 'G3DSA:3.30.450.70:FF:000027', NULL, NULL, 'Trafficking protein particle complex subunit 2/Sedlin, putative (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(72151, NULL, 'G3DSA:3.40.50.300:FF:008181', NULL, NULL, 'Ras homolog family member T2', NULL, NULL, NULL, NULL, NULL, 4),
(72152, NULL, 'G3DSA:3.40.190.10:FF:000852', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72153, NULL, 'G3DSA:1.10.10.10:FF:001314', NULL, NULL, 'DNA-directed RNA polymerase sigma-70 factor', NULL, NULL, NULL, NULL, NULL, 4),
(72154, NULL, 'G3DSA:1.25.40.1040:FF:000021', NULL, NULL, 'N-terminal acetyltransferase B complex subunit NAA25 homolog', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(72155, NULL, 'G3DSA:3.30.70.1230:FF:000131', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(72156, NULL, 'G3DSA:3.60.10.10:FF:000144', NULL, NULL, 'DNA-(apurinic or apyrimidinic site) lyase', NULL, NULL, NULL, NULL, NULL, 4),
(72157, NULL, 'G3DSA:3.40.50.850:FF:000010', NULL, NULL, 'Nicotinamidase', NULL, NULL, NULL, NULL, NULL, 4),
(72158, NULL, 'G3DSA:1.10.10.500:FF:000001', NULL, NULL, 'Prospero homeobox protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(72159, NULL, 'G3DSA:1.25.40.10:FF:001951', NULL, NULL, 'PPR2', NULL, NULL, NULL, NULL, NULL, 4),
(72160, NULL, 'G3DSA:3.40.710.10:FF:000027', NULL, NULL, 'Penicillin-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(72161, NULL, 'G3DSA:3.40.1620.60:FF:000001', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 3', NULL, NULL, NULL, NULL, NULL, 4),
(72162, NULL, 'G3DSA:2.60.40.1140:FF:000002', NULL, NULL, 'Collagen adhesin', NULL, NULL, NULL, NULL, NULL, 4),
(72163, NULL, 'G3DSA:3.20.20.70:FF:000136', NULL, NULL, 'Multifunctional tryptophan biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(72164, NULL, 'G3DSA:3.30.70.330:FF:000326', NULL, NULL, 'RNA-binding protein 39 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(72165, NULL, 'G3DSA:1.25.40.20:FF:001212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72166, NULL, 'G3DSA:3.40.50.920:FF:000031', NULL, NULL, 'Pyruvate dehydrogenase E1 component subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(72167, NULL, 'G3DSA:3.30.70.60:FF:000006', NULL, NULL, '30S ribosomal protein S6 alpha, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(72168, NULL, 'G3DSA:3.80.10.10:FF:002447', NULL, NULL, 'Receptor-like protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(72169, NULL, 'G3DSA:1.25.40.20:FF:000936', NULL, NULL, 'Phytochrome-interacting ankyrin-repeat protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(72170, NULL, 'G3DSA:1.20.1280.120:FF:000001', NULL, NULL, 'Catalase-related peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(72171, NULL, 'G3DSA:3.40.50.720:FF:001775', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(72172, NULL, 'G3DSA:1.20.1050.10:FF:000313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72173, NULL, 'G3DSA:3.30.40.10:FF:001428', NULL, NULL, 'Sister chromatid cohesion protein', NULL, NULL, NULL, NULL, NULL, 4),
(72174, NULL, 'G3DSA:4.10.375.10:FF:000003', NULL, NULL, 'Lipoxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(72175, NULL, 'G3DSA:3.40.50.12660:FF:000004', NULL, NULL, 'Putative metacaspase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(72176, NULL, 'G3DSA:3.90.79.10:FF:000273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72177, NULL, 'G3DSA:1.25.40.10:FF:002491', NULL, NULL, 'Os01g0101150 protein', NULL, NULL, NULL, NULL, NULL, 4),
(72178, NULL, 'G3DSA:2.40.160.110:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72179, NULL, 'G3DSA:2.120.10.30:FF:000374', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(72180, NULL, 'G3DSA:1.10.10.2260:FF:000001', NULL, NULL, 'Chromosome partition protein MukE', NULL, NULL, NULL, NULL, NULL, 4),
(72181, NULL, 'G3DSA:3.40.50.300:FF:002559', NULL, NULL, 'Death-associated protein kinase dapk-1', NULL, NULL, NULL, NULL, NULL, 4),
(72182, NULL, 'G3DSA:2.130.10.10:FF:002604', NULL, NULL, 'WD40-repeat-containing domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(72183, NULL, 'G3DSA:3.80.10.10:FF:001907', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72184, NULL, 'G3DSA:1.20.58.90:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72185, NULL, 'G3DSA:3.30.460.10:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72186, NULL, 'G3DSA:3.30.70.330:FF:002136', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72187, NULL, 'G3DSA:3.40.50.300:FF:001149', NULL, NULL, 'Rab40, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(72188, NULL, 'G3DSA:3.90.1600.10:FF:000041', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(72189, NULL, 'G3DSA:1.10.1420.10:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72190, NULL, 'G3DSA:3.10.490.20:FF:000002', NULL, NULL, 'Dynein axonemal heavy chain 17', NULL, NULL, NULL, NULL, NULL, 4),
(72191, NULL, 'G3DSA:3.40.50.1360:FF:000044', NULL, NULL, 'Probable ribose-5-phosphate isomerase 4, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(72192, NULL, 'G3DSA:3.30.1180.20:FF:000002', NULL, NULL, 'Dihydroxyacetone kinase subunit DhaK', NULL, NULL, NULL, NULL, NULL, 4),
(72193, NULL, 'G3DSA:1.10.10.520:FF:000007', NULL, NULL, 'UBA3p', NULL, NULL, NULL, NULL, NULL, 4),
(72194, NULL, 'G3DSA:1.20.1280.290:FF:000024', NULL, NULL, 'Putative membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(72195, NULL, 'G3DSA:3.40.50.720:FF:000151', NULL, NULL, '3-phenylpropionate-dihydrodiol/cinnamic acid-dihydrodiol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(72196, NULL, 'G3DSA:3.40.850.10:FF:000291', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(72197, NULL, 'G3DSA:3.90.470.10:FF:000025', NULL, NULL, '50S ribosomal protein L22', NULL, NULL, NULL, NULL, NULL, 4),
(72198, NULL, 'G3DSA:3.10.110.10:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72199, NULL, 'G3DSA:1.10.3130.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72200, NULL, 'G3DSA:1.10.10.60:FF:001233', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72201, NULL, 'G3DSA:1.20.120.70:FF:000001', NULL, NULL, 'Capsid protein', NULL, NULL, NULL, NULL, NULL, 4),
(72202, NULL, 'G3DSA:3.30.70.330:FF:002659', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72203, NULL, 'G3DSA:2.60.40.1170:FF:000106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72204, NULL, 'G3DSA:1.10.2050.10:FF:000001', NULL, NULL, 'Outer capsid protein mu-1', NULL, NULL, NULL, NULL, NULL, 4),
(72205, NULL, 'G3DSA:1.20.58.150:FF:000002', NULL, NULL, 'clathrin coat assembly protein AP180', NULL, NULL, NULL, NULL, NULL, 4),
(72206, NULL, 'G3DSA:3.30.479.20:FF:000005', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(72207, NULL, 'G3DSA:3.40.605.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72208, NULL, 'G3DSA:3.40.30.10:FF:001270', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(72209, NULL, 'G3DSA:1.25.40.10:FF:001390', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(72210, NULL, 'G3DSA:3.10.110.10:FF:000320', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(72211, NULL, 'G3DSA:1.20.1740.10:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72212, NULL, 'G3DSA:1.25.10.10:FF:002843', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72213, NULL, 'G3DSA:2.130.10.10:FF:001244', NULL, NULL, 'Mitotic checkpoint protein BUB3.3', NULL, NULL, NULL, NULL, NULL, 4),
(72214, NULL, 'G3DSA:2.130.10.10:FF:004813', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72215, NULL, 'G3DSA:3.40.50.300:FF:003919', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72216, NULL, 'G3DSA:3.30.200.20:FF:000382', NULL, NULL, 'homeodomain-interacting protein kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(72217, NULL, 'G3DSA:3.30.40.10:FF:000355', NULL, NULL, 'rabenosyn-5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(72218, NULL, 'G3DSA:3.10.450.50:FF:000003', NULL, NULL, 'Nuclear transport factor 2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(72219, NULL, 'G3DSA:4.10.860.120:FF:000013', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(72220, NULL, 'G3DSA:3.30.1540.20:FF:000018', NULL, NULL, 'DNA mismatch repair protein mutL, putative', NULL, NULL, NULL, NULL, NULL, 4),
(72221, NULL, 'G3DSA:1.10.510.10:FF:001050', NULL, NULL, 'Serine/threonine-protein kinase CTR1', NULL, NULL, NULL, NULL, NULL, 4),
(72222, NULL, 'G3DSA:1.10.510.10:FF:000482', NULL, NULL, 'MAP kinase kinase kinase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(72223, NULL, 'G3DSA:1.10.150.340:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72224, NULL, 'G3DSA:2.130.10.10:FF:004285', NULL, NULL, 'Embryo sac development arrest 7', NULL, NULL, NULL, NULL, NULL, 4),
(72225, NULL, 'G3DSA:2.60.120.1000:FF:000011', NULL, NULL, 'Collagen alpha-1(XXVII) chain', NULL, NULL, NULL, NULL, NULL, 4),
(72226, NULL, 'G3DSA:2.10.220.10:FF:000017', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 6', NULL, NULL, NULL, NULL, NULL, 4),
(72227, NULL, 'G3DSA:3.40.50.620:FF:000407', NULL, NULL, 'Membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(72228, NULL, 'G3DSA:3.30.70.270:FF:000179', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72229, NULL, 'G3DSA:3.90.1600.10:FF:000046', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(72230, NULL, 'G3DSA:3.30.160.110:FF:000005', NULL, NULL, 'Spermine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(72231, NULL, 'G3DSA:3.90.1140.10:FF:000022', NULL, NULL, 'U6 snRNA phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(72232, NULL, 'G3DSA:3.90.1200.10:FF:000061', NULL, NULL, 'Hydroxylysine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(72233, NULL, 'G3DSA:3.10.440.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72234, NULL, 'G3DSA:1.25.40.20:FF:001443', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72235, NULL, 'G3DSA:1.20.1310.10:FF:000143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72236, NULL, 'G3DSA:3.30.200.20:FF:000090', NULL, NULL, 'Ribosomal protein S6 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(72237, NULL, 'G3DSA:3.80.10.10:FF:004364', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72238, NULL, 'G3DSA:1.25.40.20:FF:000875', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72239, NULL, 'G3DSA:2.30.30.40:FF:000236', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(72240, NULL, 'G3DSA:1.20.1250.20:FF:001719', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72241, NULL, 'G3DSA:1.10.10.820:FF:000035', NULL, NULL, 'Unconventional myosin-IXAb', NULL, NULL, NULL, NULL, NULL, 4),
(72242, NULL, 'G3DSA:3.30.950.10:FF:000002', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase I', NULL, NULL, NULL, NULL, NULL, 4),
(72243, NULL, 'G3DSA:3.90.360.10:FF:000011', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit DDB_G0275159', NULL, NULL, NULL, NULL, NULL, 4),
(72244, NULL, 'G3DSA:3.30.40.10:FF:000411', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(72245, NULL, 'G3DSA:1.20.272.40:FF:000007', NULL, NULL, 'Unplaced genomic scaffold supercont1.245, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(72246, NULL, 'G3DSA:3.30.565.10:FF:000450', NULL, NULL, 'Mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(72247, NULL, 'G3DSA:1.25.40.20:FF:001387', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72248, NULL, 'G3DSA:1.20.920.30:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72249, NULL, 'G3DSA:3.40.50.1370:FF:000030', NULL, NULL, 'Aspartate carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(72250, NULL, 'G3DSA:3.90.1150.10:FF:000528', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72251, NULL, 'G3DSA:3.40.47.10:FF:000128', NULL, NULL, 'Fatty acid synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(72252, NULL, 'G3DSA:2.40.10.10:FF:000613', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72253, NULL, 'G3DSA:2.30.30.380:FF:000045', NULL, NULL, 'Endonuclease/exonuclease/phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(72254, NULL, 'G3DSA:3.90.820.10:FF:000002', NULL, NULL, 'MbtH family protein', NULL, NULL, NULL, NULL, NULL, 4),
(72255, NULL, 'G3DSA:3.30.40.10:FF:000299', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(72256, NULL, 'G3DSA:1.20.58.60:FF:000213', NULL, NULL, 'nesprin-1 isoform X11', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(72257, NULL, 'G3DSA:3.30.160.60:FF:001148', NULL, NULL, 'Zinc finger protein 668', NULL, NULL, NULL, NULL, NULL, 4),
(72258, NULL, 'G3DSA:1.25.40.10:FF:002963', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72259, NULL, 'G3DSA:3.30.160.60:FF:005431', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72260, NULL, 'G3DSA:1.25.10.10:FF:002394', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(72261, NULL, 'G3DSA:1.25.40.20:FF:000931', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72262, NULL, 'G3DSA:3.30.950.30:FF:000008', NULL, NULL, 'Schlafen family member 5', NULL, NULL, NULL, NULL, NULL, 4),
(72263, NULL, 'G3DSA:2.130.10.10:FF:003740', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(72264, NULL, 'G3DSA:3.30.70.270:FF:000235', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72265, NULL, 'G3DSA:1.20.1310.10:FF:000087', NULL, NULL, 'CUL4A isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(72266, NULL, 'G3DSA:3.80.10.10:FF:003852', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(72267, NULL, 'G3DSA:3.60.40.10:FF:000140', NULL, NULL, 'Protein phosphatase 2C', NULL, NULL, NULL, NULL, NULL, 4),
(72268, NULL, 'G3DSA:1.25.10.10:FF:001882', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(72269, NULL, 'G3DSA:1.20.1310.10:FF:000194', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72270, NULL, 'G3DSA:1.10.8.60:FF:000108', NULL, NULL, 'Peroxisomal biogenesis factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(72271, NULL, 'G3DSA:2.40.30.20:FF:000033', NULL, NULL, 'ATP synthase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(72272, NULL, 'G3DSA:1.10.1370.30:FF:000020', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(72273, NULL, 'G3DSA:1.10.10.10:FF:000302', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(72274, NULL, 'G3DSA:1.10.472.10:FF:000437', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72275, NULL, 'G3DSA:3.80.10.10:FF:000093', NULL, NULL, 'Putative leucine-rich repeat protein shoc-2', NULL, NULL, NULL, NULL, NULL, 4),
(72276, NULL, 'G3DSA:3.10.450.240:FF:000002', NULL, NULL, 'Mitochondrial import inner membrane translocase subunit TIM44', NULL, NULL, NULL, NULL, NULL, 4),
(72277, NULL, 'G3DSA:3.40.50.300:FF:005252', NULL, NULL, 'Smf-1', NULL, NULL, NULL, NULL, NULL, 4),
(72278, NULL, 'G3DSA:1.10.10.60:FF:001312', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72279, NULL, 'G3DSA:3.40.850.10:FF:000532', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72280, NULL, 'G3DSA:3.40.50.2000:FF:000388', NULL, NULL, 'UDP-glycosyltransferase 79', NULL, NULL, NULL, NULL, NULL, 4),
(72281, NULL, 'G3DSA:1.10.287.70:FF:000305', NULL, NULL, 'Uncharacterized protein B0310.1', NULL, NULL, NULL, NULL, NULL, 4),
(72282, NULL, 'G3DSA:3.10.100.10:FF:000319', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72283, NULL, 'G3DSA:2.70.98.20:FF:000019', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(72284, NULL, 'G3DSA:2.130.10.10:FF:004178', NULL, NULL, 'WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(72285, NULL, 'G3DSA:1.10.260.40:FF:000049', NULL, NULL, 'XRE family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(72286, NULL, 'G3DSA:2.30.30.40:FF:000287', NULL, NULL, 'BAI1-associated protein 2-like 2b', NULL, NULL, NULL, NULL, NULL, 4),
(72287, NULL, 'G3DSA:3.40.50.1010:FF:000175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72288, NULL, 'G3DSA:3.40.50.1010:FF:000231', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72289, NULL, 'G3DSA:3.30.470.30:FF:000022', NULL, NULL, 'mRNA capping enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(72290, NULL, 'G3DSA:3.30.460.10:FF:000038', NULL, NULL, 'Topoisomerase-related function protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(72291, NULL, 'G3DSA:3.60.40.10:FF:000033', NULL, NULL, 'Protein phosphatase 1K, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(72292, NULL, 'G3DSA:3.10.20.360:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72293, NULL, 'G3DSA:1.10.150.780:FF:000002', NULL, NULL, 'Probable vacuolar protein sorting-associated protein 16 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(72294, NULL, 'G3DSA:3.20.20.100:FF:000019', NULL, NULL, 'NADP-dependent D-sorbitol-6-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(72295, NULL, 'G3DSA:4.10.400.10:FF:000361', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72296, NULL, 'G3DSA:1.20.58.60:FF:000157', NULL, NULL, 'Nesprin-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(72297, NULL, 'G3DSA:2.130.10.10:FF:000070', NULL, NULL, 'DNA damage-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(72298, NULL, 'G3DSA:3.60.20.10:FF:000026', NULL, NULL, 'Proteasome subunit alpha type-1', NULL, NULL, NULL, NULL, NULL, 4),
(72299, NULL, 'G3DSA:2.130.10.10:FF:005538', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72300, NULL, 'G3DSA:2.40.50.140:FF:000672', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72301, NULL, 'G3DSA:3.30.450.20:FF:000602', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72302, NULL, 'G3DSA:2.40.10.10:FF:000664', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72303, NULL, 'G3DSA:1.25.10.10:FF:002343', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72304, NULL, 'G3DSA:3.40.50.300:FF:008006', NULL, NULL, 'ADP-ribosylation factor GTPase-activating protein AGD12', NULL, NULL, NULL, NULL, NULL, 4),
(72305, NULL, 'G3DSA:3.30.160.60:FF:004818', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72306, NULL, 'G3DSA:3.30.50.10:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72307, NULL, 'G3DSA:1.20.1250.20:FF:000433', NULL, NULL, 'Aminotriazole resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(72308, NULL, 'G3DSA:1.20.144.10:FF:000061', NULL, NULL, 'PAP2-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(72309, NULL, 'G3DSA:3.90.740.10:FF:000001', NULL, NULL, 'Leucine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(72310, NULL, 'G3DSA:3.40.50.300:FF:004684', NULL, NULL, 'SPbeta prophage-derived sublancin-168-processing and transport ATP-binding protein SunT', NULL, NULL, NULL, NULL, NULL, 4),
(72311, NULL, 'G3DSA:1.10.3720.10:FF:000194', NULL, NULL, 'Dipeptide ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(72312, NULL, 'G3DSA:2.60.40.150:FF:000628', NULL, NULL, 'Synaptotagmin 56', NULL, NULL, NULL, NULL, NULL, 4),
(72313, NULL, 'G3DSA:3.40.50.2300:FF:000753', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72314, NULL, 'G3DSA:2.40.100.10:FF:000030', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(72315, NULL, 'G3DSA:1.25.40.10:FF:005329', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72316, NULL, 'G3DSA:1.10.3720.10:FF:000087', NULL, NULL, 'Amino acid ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(72317, NULL, 'G3DSA:3.30.505.10:FF:000002', NULL, NULL, 'Tensin 1', NULL, NULL, NULL, NULL, NULL, 4),
(72318, NULL, 'G3DSA:2.130.10.10:FF:001267', NULL, NULL, 'Os07g0660700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(72319, NULL, 'G3DSA:3.40.50.150:FF:001800', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72320, NULL, 'G3DSA:1.10.8.60:FF:000260', NULL, NULL, 'Replication-associated recombination protein A', NULL, NULL, NULL, NULL, NULL, 4),
(72321, NULL, 'G3DSA:2.60.120.10:FF:000223', NULL, NULL, 'Uncharacterized NTE family protein ZK370.4', NULL, NULL, NULL, NULL, NULL, 4),
(72322, NULL, 'G3DSA:2.130.10.30:FF:000076', NULL, NULL, 'E3 ubiquitin-protein ligase hyd', NULL, NULL, NULL, NULL, NULL, 4),
(72323, NULL, 'G3DSA:1.10.10.60:FF:001256', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72324, NULL, 'G3DSA:3.40.47.10:FF:000173', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72325, NULL, 'G3DSA:3.60.10.10:FF:000312', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(72326, NULL, 'G3DSA:3.30.160.60:FF:004077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72327, NULL, 'G3DSA:3.40.250.10:FF:000054', NULL, NULL, 'Dual specificity phosphatase 9', NULL, NULL, NULL, NULL, NULL, 4),
(72328, NULL, 'G3DSA:2.130.10.120:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72329, NULL, 'G3DSA:2.60.40.150:FF:000735', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72330, NULL, 'G3DSA:3.30.40.10:FF:002209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72331, NULL, 'G3DSA:2.130.10.10:FF:001323', NULL, NULL, 'Intraflagellar transport 140', NULL, NULL, NULL, NULL, NULL, 4),
(72332, NULL, 'G3DSA:4.10.1000.10:FF:000024', NULL, NULL, 'Zinc finger CCCH domain-containing protein 11A', NULL, NULL, NULL, NULL, NULL, 4),
(72333, NULL, 'G3DSA:1.10.1580.10:FF:000024', NULL, NULL, 'Nucleolar GTP-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(72334, NULL, 'G3DSA:1.20.140.100:FF:000002', NULL, NULL, 'Cytoplasmic dynein heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(72335, NULL, 'G3DSA:3.40.47.10:FF:000280', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72336, NULL, 'G3DSA:1.10.3160.10:FF:000004', NULL, NULL, 'Outer surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(72337, NULL, 'G3DSA:1.20.1250.20:FF:000377', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(72338, NULL, 'G3DSA:3.40.50.2300:FF:001321', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72339, NULL, 'G3DSA:1.10.20.10:FF:000016', NULL, NULL, 'Histone H2B', NULL, NULL, NULL, NULL, NULL, 4),
(72340, NULL, 'G3DSA:2.30.30.140:FF:000153', NULL, NULL, 'GM26024', NULL, NULL, NULL, NULL, NULL, 4),
(72341, NULL, 'G3DSA:3.60.21.10:FF:000068', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(72342, NULL, 'G3DSA:1.20.1250.20:FF:001782', NULL, NULL, 'Probable 3-phenylpropionic acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(72343, NULL, 'G3DSA:3.30.70.330:FF:000219', NULL, NULL, 'Putative polyadenylation factor subunit CstF64', NULL, NULL, NULL, NULL, NULL, 4),
(72344, NULL, 'G3DSA:1.10.10.60:FF:000851', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72345, NULL, 'G3DSA:1.10.720.80:FF:000001', NULL, NULL, 'E3 ubiquitin-protein ligase HECTD1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(72346, NULL, 'G3DSA:1.10.3380.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72347, NULL, 'G3DSA:2.60.40.1510:FF:000028', NULL, NULL, 'integrin alpha-PS1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(72348, NULL, 'G3DSA:3.40.190.10:FF:000560', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(72349, NULL, 'G3DSA:3.40.50.300:FF:004791', NULL, NULL, 'Putative tRNA delta(2)-isopentenylpyrophosphate transferase', NULL, NULL, NULL, NULL, NULL, 4),
(72350, NULL, 'G3DSA:3.30.300.20:FF:000035', NULL, NULL, 'OsmC family peroxiredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(72351, NULL, 'G3DSA:1.10.3720.10:FF:000143', NULL, NULL, 'Amino acid ABC transporter permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(72352, NULL, 'G3DSA:3.50.30.30:FF:000062', NULL, NULL, 'N-acetylated-alpha-linked acidic dipeptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(72353, NULL, 'G3DSA:3.90.228.10:FF:000030', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(72354, NULL, 'G3DSA:1.20.120.1910:FF:000008', NULL, NULL, 'Cysteine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(72355, NULL, 'G3DSA:3.90.1300.10:FF:000006', NULL, NULL, 'Urea amidolyase', NULL, NULL, NULL, NULL, NULL, 4),
(72356, NULL, 'G3DSA:2.10.25.10:FF:001621', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(72357, NULL, 'G3DSA:1.10.287.1490:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72358, NULL, 'G3DSA:1.25.40.730:FF:000015', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(72359, NULL, 'G3DSA:3.40.50.1220:FF:000064', NULL, NULL, 'SIR2 family protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(72360, NULL, 'G3DSA:3.30.160.60:FF:004970', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72361, NULL, 'G3DSA:1.10.510.10:FF:001847', NULL, NULL, 'Serine/threonine-protein kinase ATG1t isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(72362, NULL, 'G3DSA:3.40.50.150:FF:001744', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72363, NULL, 'G3DSA:3.30.200.20:FF:001450', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72364, NULL, 'G3DSA:3.40.50.300:FF:005988', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72365, NULL, 'G3DSA:1.20.1510.10:FF:000068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72366, NULL, 'G3DSA:2.60.40.60:FF:000820', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72367, NULL, 'G3DSA:1.25.40.10:FF:000546', NULL, NULL, 'Tetratricopeptide repeat domain 37', NULL, NULL, NULL, NULL, NULL, 4),
(72368, NULL, 'G3DSA:1.25.40.20:FF:000083', NULL, NULL, 'Uveal autoantigen with coiled-coil domains and ankyrin repeats', NULL, NULL, NULL, NULL, NULL, 4),
(72369, NULL, 'G3DSA:2.130.10.10:FF:000811', NULL, NULL, 'Intraflagellar transport 140', NULL, NULL, NULL, NULL, NULL, 4),
(72370, NULL, 'G3DSA:3.30.30.170:FF:000001', NULL, NULL, 'Eukaryotic translation initiation factor 2 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(72371, NULL, 'G3DSA:3.10.350.10:FF:000079', NULL, NULL, 'Fused lipid transporter subunits of ABC superfamily: membrane component/ATP-binding component', NULL, NULL, NULL, NULL, NULL, 4),
(72372, NULL, 'G3DSA:2.130.10.10:FF:000923', NULL, NULL, 'Protein transport protein (LST8), putative', NULL, NULL, NULL, NULL, NULL, 4),
(72373, NULL, 'G3DSA:2.130.10.10:FF:005134', NULL, NULL, 'Intraflagellar transport 140', NULL, NULL, NULL, NULL, NULL, 4),
(72374, NULL, 'G3DSA:3.30.420.10:FF:000204', NULL, NULL, 'Ribonuclease HII', NULL, NULL, NULL, NULL, NULL, 4),
(72375, NULL, 'G3DSA:1.10.1900.40:FF:000008', NULL, NULL, 'Erythrocyte membrane protein 1 (PfEMP1)', NULL, NULL, NULL, NULL, NULL, 4),
(72376, NULL, 'G3DSA:1.10.630.10:FF:000541', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72377, NULL, 'G3DSA:3.30.160.60:FF:004026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72378, NULL, 'G3DSA:3.30.1740.20:FF:000011', NULL, NULL, '40S ribosomal protein S26', NULL, NULL, NULL, NULL, NULL, 4),
(72379, NULL, 'G3DSA:1.25.40.10:FF:002171', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(72380, NULL, 'G3DSA:2.40.70.10:FF:000257', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72381, NULL, 'G3DSA:3.30.420.270:FF:000012', NULL, NULL, 'Biopolymer transporter ExbD', NULL, NULL, NULL, NULL, NULL, 4),
(72382, NULL, 'G3DSA:2.70.40.10:FF:000018', NULL, NULL, 'dCTP deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(72383, NULL, 'G3DSA:3.50.50.60:FF:001061', NULL, NULL, 'Pcyox1l protein', NULL, NULL, NULL, NULL, NULL, 4),
(72384, NULL, 'G3DSA:1.10.620.20:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72385, NULL, 'G3DSA:3.30.420.40:FF:001096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72386, NULL, 'G3DSA:1.10.645.10:FF:000007', NULL, NULL, 'Sulfhydrogenase 1 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(72387, NULL, 'G3DSA:1.10.10.10:FF:001606', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72388, NULL, 'G3DSA:2.60.220.50:FF:000080', NULL, NULL, 'Adhesion G protein-coupled receptor D2', NULL, NULL, NULL, NULL, NULL, 4),
(72389, NULL, 'G3DSA:2.10.220.10:FF:000068', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(72390, NULL, 'G3DSA:1.20.920.30:FF:000022', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(72391, NULL, 'G3DSA:1.10.10.60:FF:000800', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72392, NULL, 'G3DSA:3.40.50.1000:FF:000402', NULL, NULL, 'Copper-translocating P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(72393, NULL, 'G3DSA:2.60.40.10:FF:002975', NULL, NULL, 'Vein, isoform C', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(72394, NULL, 'G3DSA:2.130.10.10:FF:000862', NULL, NULL, 'Guanine nucleotide-exchange factor SEC12', NULL, NULL, NULL, NULL, NULL, 4),
(72395, NULL, 'G3DSA:3.10.20.90:FF:000108', NULL, NULL, 'Elongin-B', NULL, NULL, NULL, NULL, NULL, 4),
(72396, NULL, 'G3DSA:2.60.40.10:FF:004425', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72397, NULL, 'G3DSA:3.30.70.270:FF:000286', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72398, NULL, 'G3DSA:1.10.10.160:FF:000028', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(72399, NULL, 'G3DSA:3.30.450.270:FF:000001', NULL, NULL, 'Phytochrome', NULL, NULL, NULL, NULL, NULL, 4),
(72400, NULL, 'G3DSA:4.10.1000.10:FF:000075', NULL, NULL, 'Zinc finger CCCH domain-containing protein 42', NULL, NULL, NULL, NULL, NULL, 4),
(72401, NULL, 'G3DSA:2.10.25.10:FF:001065', NULL, NULL, 'Epidermal growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(72402, NULL, 'G3DSA:1.20.1070.10:FF:000551', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(72403, NULL, 'G3DSA:1.10.287.40:FF:000021', NULL, NULL, 'Seryl-tRNA synthetase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(72404, NULL, 'G3DSA:1.10.150.20:FF:000176', NULL, NULL, 'DNA ligase B', NULL, NULL, NULL, NULL, NULL, 4),
(72405, NULL, 'G3DSA:3.30.505.10:FF:000053', NULL, NULL, 'Dual adapter for phosphotyrosine and 3-phosphotyrosine and 3-phosphoinositide', NULL, NULL, NULL, NULL, NULL, 4),
(72406, NULL, 'G3DSA:3.30.160.60:FF:001204', NULL, NULL, 'Zinc finger protein 524', NULL, NULL, NULL, NULL, NULL, 4),
(72407, NULL, 'G3DSA:1.25.40.10:FF:003531', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72408, NULL, 'G3DSA:1.20.120.720:FF:000032', NULL, NULL, 'Neither inactivation nor afterpotential protein C', NULL, NULL, NULL, NULL, NULL, 4),
(72409, NULL, 'G3DSA:2.60.40.10:FF:003065', NULL, NULL, 'Kekkon5, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(72410, NULL, 'G3DSA:1.25.40.10:FF:004817', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(72411, NULL, 'G3DSA:3.90.70.80:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72412, NULL, 'G3DSA:1.10.238.150:FF:000011', NULL, NULL, 'Formin-F', NULL, NULL, NULL, NULL, NULL, 4),
(72413, NULL, 'G3DSA:3.60.40.10:FF:000084', NULL, NULL, 'Protein phosphatase, Mg2+/Mn2+ dependent 1A', NULL, NULL, NULL, NULL, NULL, 4),
(72414, NULL, 'G3DSA:3.40.50.300:FF:004639', NULL, NULL, 'Recombinase RecB', NULL, NULL, NULL, NULL, NULL, 4),
(72415, NULL, 'G3DSA:1.20.1560.10:FF:000751', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72416, NULL, 'G3DSA:2.60.40.820:FF:000015', NULL, NULL, 'T-box transcription factor mls-1', NULL, NULL, NULL, NULL, NULL, 4),
(72417, NULL, 'G3DSA:3.30.70.330:FF:002243', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72418, NULL, 'G3DSA:3.70.10.10:FF:000115', NULL, NULL, 'Proliferating cell nuclear antigen', NULL, NULL, NULL, NULL, NULL, 4),
(72419, NULL, 'G3DSA:1.10.3080.10:FF:000003', NULL, NULL, 'Chloride channel 2', NULL, NULL, NULL, NULL, NULL, 4),
(72420, NULL, 'G3DSA:3.40.710.10:FF:000134', NULL, NULL, 'Beta-lactamase', NULL, NULL, NULL, NULL, NULL, 4),
(72421, NULL, 'G3DSA:3.40.50.300:FF:003279', NULL, NULL, 'Ca2+-channel-protein-beta-subunit, isoform M', NULL, NULL, NULL, NULL, NULL, 4),
(72422, NULL, 'G3DSA:3.30.1360.40:FF:000027', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(72423, NULL, 'G3DSA:2.30.29.30:FF:000213', NULL, NULL, 'Docking protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(72424, NULL, 'G3DSA:3.40.630.70:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72425, NULL, 'G3DSA:1.20.144.10:FF:000066', NULL, NULL, 'Phospholipid phosphatase 5', NULL, NULL, NULL, NULL, NULL, 4),
(72426, NULL, 'G3DSA:1.10.10.10:FF:000246', NULL, NULL, 'Transcriptional regulator, ArsR family', NULL, NULL, NULL, NULL, NULL, 4),
(72427, NULL, 'G3DSA:2.40.50.140:FF:001161', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72428, NULL, 'G3DSA:3.90.190.10:FF:000094', NULL, NULL, 'Probable tyrosine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(72429, NULL, 'G3DSA:1.25.40.730:FF:000010', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(72430, NULL, 'G3DSA:3.30.160.60:FF:003121', NULL, NULL, 'zinc finger protein 250', NULL, NULL, NULL, NULL, NULL, 4),
(72431, NULL, 'G3DSA:3.30.2060.10:FF:000001', NULL, NULL, 'Penicillin-binding protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(72432, NULL, 'G3DSA:1.20.930.10:FF:000028', NULL, NULL, 'Transcription elongation factor (TFIIS) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(72433, NULL, 'G3DSA:1.20.5.900:FF:000003', NULL, NULL, 'CD4', NULL, NULL, NULL, NULL, NULL, 4),
(72434, NULL, 'G3DSA:1.10.10.10:FF:001651', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72435, NULL, 'G3DSA:3.30.160.60:FF:002497', NULL, NULL, 'Regulatory protein MIG2', NULL, NULL, NULL, NULL, NULL, 4),
(72436, NULL, 'G3DSA:2.130.10.10:FF:002609', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72437, NULL, 'G3DSA:2.60.40.1510:FF:000023', NULL, NULL, 'integrin alpha-PS3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(72438, NULL, 'G3DSA:3.40.140.100:FF:000013', NULL, NULL, 'Ubiquitin-like modifier-activating enzyme ATG7', NULL, NULL, NULL, NULL, NULL, 4),
(72439, NULL, 'G3DSA:3.30.760.10:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72440, NULL, 'G3DSA:3.40.50.300:FF:006949', NULL, NULL, 'Putative twitching motility protein PilT', NULL, NULL, NULL, NULL, NULL, 4),
(72441, NULL, 'G3DSA:3.30.70.870:FF:000027', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(72442, NULL, 'G3DSA:3.30.420.40:FF:000191', NULL, NULL, 'Retrograde regulation protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(72443, NULL, 'G3DSA:3.40.1620.60:FF:000006', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 5', NULL, NULL, NULL, NULL, NULL, 4),
(72444, NULL, 'G3DSA:2.60.40.10:FF:000159', NULL, NULL, 'neural cell adhesion molecule 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(72445, NULL, 'G3DSA:2.30.42.10:FF:000232', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(72446, NULL, 'G3DSA:3.40.50.720:FF:002236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72447, NULL, 'G3DSA:1.10.260.40:FF:000044', NULL, NULL, 'Homeobox domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(72448, NULL, 'G3DSA:3.80.10.10:FF:004196', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(72449, NULL, 'G3DSA:3.90.226.10:FF:000256', NULL, NULL, 'PDZ domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(72450, NULL, 'G3DSA:3.80.10.10:FF:004252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72451, NULL, 'G3DSA:1.10.260.40:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72452, NULL, 'G3DSA:2.30.42.10:FF:000176', NULL, NULL, 'Signal-induced proliferation-associated 1', NULL, NULL, NULL, NULL, NULL, 4),
(72453, NULL, 'G3DSA:1.10.1380.10:FF:000020', NULL, NULL, 'NEPrilysin metallopeptidase family', NULL, NULL, NULL, NULL, NULL, 4),
(72454, NULL, 'G3DSA:2.60.210.10:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72455, NULL, 'G3DSA:3.40.50.300:FF:007517', NULL, NULL, 'P. aerophilum family 417, putative ATP binding', NULL, NULL, NULL, NULL, NULL, 4),
(72456, NULL, 'G3DSA:3.60.21.50:FF:000001', NULL, NULL, 'DNA polymerase delta 2, accessory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(72457, NULL, 'G3DSA:3.30.160.60:FF:003065', NULL, NULL, 'Small nuclear ribonucleoprotein associated', NULL, NULL, NULL, NULL, NULL, 4),
(72458, NULL, 'G3DSA:1.10.10.990:FF:000002', NULL, NULL, 'RecBCD enzyme subunit RecC', NULL, NULL, NULL, NULL, NULL, 4),
(72459, NULL, 'G3DSA:3.90.700.10:FF:000004', NULL, NULL, 'Succinate dehydrogenase flavoprotein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(72460, NULL, 'G3DSA:1.20.58.1280:FF:000002', NULL, NULL, 'DNA repair protein REV1', NULL, NULL, NULL, NULL, NULL, 4),
(72461, NULL, 'G3DSA:3.90.226.10:FF:000312', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(72462, NULL, 'G3DSA:1.20.58.70:FF:000042', NULL, NULL, 'Syntaxin 11b, tandem duplicate 2', NULL, NULL, NULL, NULL, NULL, 4),
(72463, NULL, 'G3DSA:1.10.510.10:FF:003360', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72464, NULL, 'G3DSA:1.20.1250.20:FF:001607', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72465, NULL, 'G3DSA:2.60.40.10:FF:005774', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72466, NULL, 'G3DSA:3.80.10.10:FF:000941', NULL, NULL, 'Blast resistance protein Pi-ta variant 9', NULL, NULL, NULL, NULL, NULL, 4),
(72467, NULL, 'G3DSA:3.40.1360.10:FF:000033', NULL, NULL, 'Meiosis-specific topoisomerase Spo11, putative', NULL, NULL, NULL, NULL, NULL, 4),
(72468, NULL, 'G3DSA:2.60.40.10:FF:002008', NULL, NULL, 'Frazzled, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(72469, NULL, 'G3DSA:3.40.630.30:FF:000139', NULL, NULL, 'L-ornithine N5-acetyltransferase NATA1', NULL, NULL, NULL, NULL, NULL, 4),
(72470, NULL, 'G3DSA:2.60.40.10:FF:006050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72471, NULL, 'G3DSA:1.20.1070.10:FF:000843', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72472, NULL, 'G3DSA:2.130.10.30:FF:000002', NULL, NULL, 'E3 ubiquitin-protein ligase MYCBP2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(72473, NULL, 'G3DSA:2.10.110.10:FF:000239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72474, NULL, 'G3DSA:1.20.1270.60:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72475, NULL, 'G3DSA:2.10.25.10:FF:000261', NULL, NULL, 'Fibrillin-1', NULL, NULL, NULL, NULL, NULL, 4),
(72476, NULL, 'G3DSA:1.25.40.280:FF:000009', NULL, NULL, 'Bro1p', NULL, NULL, NULL, NULL, NULL, 4),
(72477, NULL, 'G3DSA:1.20.5.110:FF:000305', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(72478, NULL, 'G3DSA:1.10.472.10:FF:000549', NULL, NULL, 'Cyclin, N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(72479, NULL, 'G3DSA:1.20.1280.50:FF:000022', NULL, NULL, 'F-box protein FBW2', NULL, NULL, NULL, NULL, NULL, 4),
(72480, NULL, 'G3DSA:3.40.50.10880:FF:000009', NULL, NULL, 'DUF89 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(72481, NULL, 'G3DSA:3.30.470.30:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72482, NULL, 'G3DSA:1.25.40.10:FF:000597', NULL, NULL, 'Pre-mRNA-splicing factor CLF1', NULL, NULL, NULL, NULL, NULL, 4),
(72483, NULL, 'G3DSA:2.160.20.10:FF:000333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72484, NULL, 'G3DSA:3.10.620.30:FF:000005', NULL, NULL, 'SH3 domain protein (Cyk3), putative', NULL, NULL, NULL, NULL, NULL, 4),
(72485, NULL, 'G3DSA:3.40.50.1000:FF:000638', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72486, NULL, 'G3DSA:3.30.930.10:FF:000018', NULL, NULL, 'Serine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(72487, NULL, 'G3DSA:4.10.60.10:FF:000006', NULL, NULL, 'cellular nucleic acid-binding protein-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(72488, NULL, 'G3DSA:2.60.120.200:FF:000726', NULL, NULL, 'Legume-like lectin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(72489, NULL, 'G3DSA:3.50.50.60:FF:000785', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72490, NULL, 'G3DSA:2.30.130.10:FF:000028', NULL, NULL, 'PUA domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(72491, NULL, 'G3DSA:1.25.10.10:FF:000426', NULL, NULL, 'Proteasome 26S subunit, non-ATPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(72492, NULL, 'G3DSA:3.30.60.30:FF:000053', NULL, NULL, 'Complement component C7', NULL, NULL, NULL, NULL, NULL, 4),
(72493, NULL, 'G3DSA:1.10.1900.20:FF:000002', NULL, NULL, '50S ribosomal protein L20, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(72494, NULL, 'G3DSA:1.20.1250.10:FF:000025', NULL, NULL, 'Interleukin-2', NULL, NULL, NULL, NULL, NULL, 4),
(72495, NULL, 'G3DSA:3.30.160.60:FF:003514', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72496, NULL, 'G3DSA:1.10.510.10:FF:001842', NULL, NULL, 'eIF-2 alpha kinase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(72497, NULL, 'G3DSA:3.30.420.40:FF:000932', NULL, NULL, 'Os01g0517850 protein', NULL, NULL, NULL, NULL, NULL, 4),
(72498, NULL, 'G3DSA:1.10.10.820:FF:000030', NULL, NULL, 'Myosin, heavy polypeptide 1.1, skeletal muscle', NULL, NULL, NULL, NULL, NULL, 4),
(72499, NULL, 'G3DSA:3.20.70.20:FF:000034', NULL, NULL, 'Ribonucleoside-diphosphate reductase large chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(72500, NULL, 'G3DSA:3.40.50.720:FF:001275', NULL, NULL, 'Pentafunctional AROM polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(72501, NULL, 'G3DSA:3.30.70.330:FF:002636', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72502, NULL, 'G3DSA:1.20.1410.10:FF:000027', NULL, NULL, 'Cyclin-D1-binding protein 1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(72503, NULL, 'G3DSA:1.25.40.10:FF:004705', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72504, NULL, 'G3DSA:2.60.40.10:FF:000558', NULL, NULL, 'Leptin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(72505, NULL, 'G3DSA:1.10.12.10:FF:000020', NULL, NULL, 'Carnitinyl-CoA dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(72506, NULL, 'G3DSA:1.20.920.10:FF:000207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72507, NULL, 'G3DSA:2.60.120.200:FF:000378', NULL, NULL, 'Collagen, type V, alpha 3a', NULL, NULL, NULL, NULL, NULL, 4),
(72508, NULL, 'G3DSA:3.30.230.10:FF:000381', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72509, NULL, 'G3DSA:1.10.10.60:FF:000856', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72510, NULL, 'G3DSA:1.10.472.80:FF:000205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72511, NULL, 'G3DSA:3.40.50.1000:FF:000346', NULL, NULL, 'Haloacid dehalogenase family hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(72512, NULL, 'G3DSA:2.30.42.10:FF:000125', NULL, NULL, 'PATJ, crumbs cell polarity complex component', NULL, NULL, NULL, NULL, NULL, 4),
(72513, NULL, 'G3DSA:3.30.160.60:FF:003806', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72514, NULL, 'G3DSA:2.130.10.10:FF:000867', NULL, NULL, 'Small nucleolar ribonucleoprotein complex subunit Utp15, putative', NULL, NULL, NULL, NULL, NULL, 4),
(72515, NULL, 'G3DSA:3.65.10.10:FF:000021', NULL, NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(72516, NULL, 'G3DSA:3.30.420.10:FF:000148', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(72517, NULL, 'G3DSA:1.10.10.10:FF:000358', NULL, NULL, 'Acetylserotonin O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(72518, NULL, 'G3DSA:1.25.40.10:FF:000602', NULL, NULL, 'rRNA biogenesis protein rrp5', NULL, NULL, NULL, NULL, NULL, 4),
(72519, NULL, 'G3DSA:1.10.238.10:FF:000961', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72520, NULL, 'G3DSA:2.60.40.10:FF:002632', NULL, NULL, 'YEL043W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(72521, NULL, 'G3DSA:3.80.10.10:FF:001110', NULL, NULL, 'CBN-CRML-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(72522, NULL, 'G3DSA:3.40.50.800:FF:000017', NULL, NULL, 'Histidine--tRNA ligase chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(72523, NULL, 'G3DSA:3.40.50.1000:FF:000689', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72524, NULL, 'G3DSA:1.20.1050.10:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72525, NULL, 'G3DSA:1.50.10.20:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72526, NULL, 'G3DSA:1.10.150.780:FF:000007', NULL, NULL, 'Vacuolar protein sorting-associated protein 16 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(72527, NULL, 'G3DSA:2.40.110.10:FF:000036', NULL, NULL, 'Acyl-CoA dehydrogenase FadE16', NULL, NULL, NULL, NULL, NULL, 4),
(72528, NULL, 'G3DSA:3.40.50.1220:FF:000120', NULL, NULL, 'Sir2-type regulatory transcription factor silent information regulator protein', NULL, NULL, NULL, NULL, NULL, 4),
(72529, NULL, 'G3DSA:2.40.50.140:FF:000609', NULL, NULL, 'Eukaryotic translation initiation factor 5A', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(72530, NULL, 'G3DSA:2.40.10.120:FF:000017', NULL, NULL, 'HtrA-like serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(72531, NULL, 'G3DSA:1.10.287.70:FF:000356', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72532, NULL, 'G3DSA:3.40.50.2300:FF:001377', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72533, NULL, 'G3DSA:2.30.29.30:FF:000218', NULL, NULL, 'Epidermal growth factor receptor kinase substrate 8-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(72534, NULL, 'G3DSA:1.20.1070.10:FF:000039', NULL, NULL, 'somatostatin receptor type 2', NULL, NULL, NULL, NULL, NULL, 4),
(72535, NULL, 'G3DSA:1.10.287.70:FF:000412', NULL, NULL, 'Putative calcium/potassium channel (CAKC)', NULL, NULL, NULL, NULL, NULL, 4),
(72536, NULL, 'G3DSA:3.40.1280.30:FF:000038', NULL, NULL, 'tRNA methyltransferase 10A', NULL, NULL, NULL, NULL, NULL, 4),
(72537, NULL, 'G3DSA:1.25.40.10:FF:000254', NULL, NULL, 'Cell cycle control protein', NULL, NULL, NULL, NULL, NULL, 4),
(72538, NULL, 'G3DSA:2.40.160.50:FF:000028', NULL, NULL, 'Heme/hemopexin transporter protein HuxB', NULL, NULL, NULL, NULL, NULL, 4),
(72539, NULL, 'G3DSA:3.30.200.20:FF:000882', NULL, NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(72540, NULL, 'G3DSA:1.25.10.10:FF:002287', NULL, NULL, 'UTP20 small subunit (SSU) processome component', NULL, NULL, NULL, NULL, NULL, 4),
(72541, NULL, 'G3DSA:2.40.50.140:FF:001009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72542, NULL, 'G3DSA:3.90.400.10:FF:000015', NULL, NULL, 'Sucrose phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(72543, NULL, 'G3DSA:3.40.30.10:FF:000045', NULL, NULL, 'Disulfide-isomerase A3', NULL, NULL, NULL, NULL, NULL, 4),
(72544, NULL, 'G3DSA:1.10.150.570:FF:000001', NULL, NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', NULL, NULL, NULL, NULL, NULL, 4),
(72545, NULL, 'G3DSA:3.80.10.10:FF:000834', NULL, NULL, 'Probable disease resistance protein At1g15890', NULL, NULL, NULL, NULL, NULL, 4),
(72546, NULL, 'G3DSA:3.10.290.70:FF:000007', NULL, NULL, '40S ribosomal protein S8', NULL, NULL, NULL, NULL, NULL, 4),
(72547, NULL, 'G3DSA:2.40.30.330:FF:000011', NULL, NULL, 'mRNA cleavage and polyadenylation factor CLP1', NULL, NULL, NULL, NULL, NULL, 4),
(72548, NULL, 'G3DSA:2.20.25.100:FF:000004', NULL, NULL, '30S ribosomal protein S27e', NULL, NULL, NULL, NULL, NULL, 4),
(72549, NULL, 'G3DSA:1.20.120.1750:FF:000157', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(72550, NULL, 'G3DSA:3.40.1280.10:FF:000032', NULL, NULL, 'rRNA methyltransferase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(72551, NULL, 'G3DSA:3.30.710.10:FF:000344', NULL, NULL, 'MigA', NULL, NULL, NULL, NULL, NULL, 4),
(72552, NULL, 'G3DSA:3.40.350.10:FF:000095', NULL, NULL, 'Xaa-Pro aminopeptidase 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(72553, NULL, 'G3DSA:2.60.120.200:FF:000434', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72554, NULL, 'G3DSA:3.30.710.10:FF:000131', NULL, NULL, 'Blast:Broad-complex core protein isoform 6', NULL, NULL, NULL, NULL, NULL, 4),
(72555, NULL, 'G3DSA:3.30.160.60:FF:003857', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72556, NULL, 'G3DSA:3.40.50.12470:FF:000009', NULL, NULL, '2-oxoglutarate dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(72557, NULL, 'G3DSA:3.90.470.20:FF:000062', NULL, NULL, '4''-phosphopantetheinyl transferase PfaE', NULL, NULL, NULL, NULL, NULL, 4),
(72558, NULL, 'G3DSA:2.60.40.10:FF:001519', NULL, NULL, 'Sidestep, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(72559, NULL, 'G3DSA:3.30.30.170:FF:000006', NULL, NULL, 'Eukaryotic translation initiation factor 2 beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(72560, NULL, 'G3DSA:2.60.40.10:FF:003121', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(72561, NULL, 'G3DSA:3.30.300.20:FF:000030', NULL, NULL, 'Ribosome-binding factor A', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(72562, NULL, 'G3DSA:2.60.40.150:FF:000679', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(72563, NULL, 'G3DSA:3.30.70.330:FF:002075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72564, NULL, 'G3DSA:3.40.50.1820:FF:000024', NULL, NULL, 'acyl-coenzyme A thioesterase 4', NULL, NULL, NULL, NULL, NULL, 4),
(72565, NULL, 'G3DSA:3.20.20.70:FF:000473', NULL, NULL, 'Fructose-bisphosphate aldolase 3 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(72566, NULL, 'G3DSA:3.40.50.300:FF:006157', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(72567, NULL, 'G3DSA:3.20.20.80:FF:000257', NULL, NULL, 'Glycogen debranching enzyme putative', NULL, NULL, NULL, NULL, NULL, 4),
(72568, NULL, 'G3DSA:3.30.930.10:FF:000170', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(72569, NULL, 'G3DSA:1.20.1420.30:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72570, NULL, 'G3DSA:2.60.40.10:FF:000210', NULL, NULL, 'Fibronectin type III domain containing 3A', NULL, NULL, NULL, NULL, NULL, 4),
(72571, NULL, 'G3DSA:3.30.499.10:FF:000003', NULL, NULL, 'Aconitate hydratase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(72572, NULL, 'G3DSA:2.40.50.40:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72573, NULL, 'G3DSA:3.30.420.510:FF:000005', NULL, NULL, 'Probable pantothenate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(72574, NULL, 'G3DSA:3.30.460.10:FF:000145', NULL, NULL, 'Ribosomal silencing factor RsfS', NULL, NULL, NULL, NULL, NULL, 4),
(72575, NULL, 'G3DSA:2.60.120.10:FF:000167', NULL, NULL, 'DNA-binding transcriptional activator YeiL', NULL, NULL, NULL, NULL, NULL, 4),
(72576, NULL, 'G3DSA:3.60.10.10:FF:000256', NULL, NULL, 'Probable secreted protein', NULL, NULL, NULL, NULL, NULL, 4),
(72577, NULL, 'G3DSA:3.30.230.10:FF:000318', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72578, NULL, 'G3DSA:3.30.70.2690:FF:000001', NULL, NULL, 'Lysine-ketoglutarate reductase/saccharopine dehydrogenase1', NULL, NULL, NULL, NULL, NULL, 4),
(72579, NULL, 'G3DSA:3.40.50.300:FF:003335', NULL, NULL, 'Ras family protein', NULL, NULL, NULL, NULL, NULL, 4),
(72580, NULL, 'G3DSA:3.30.1360.100:FF:000001', NULL, NULL, 'Type II secretion system protein M', NULL, NULL, NULL, NULL, NULL, 4),
(72581, NULL, 'G3DSA:3.30.2140.10:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72582, NULL, 'G3DSA:3.90.320.10:FF:000014', NULL, NULL, 'ATP-dependent helicase/nuclease subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(72583, NULL, 'G3DSA:3.90.830.10:FF:000008', NULL, NULL, 'SNARE-interacting protein KEULE', NULL, NULL, NULL, NULL, NULL, 4),
(72584, NULL, 'G3DSA:3.30.470.20:FF:000249', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(72585, NULL, 'G3DSA:3.40.50.1820:FF:000709', NULL, NULL, 'Alpha/beta fold hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(72586, NULL, 'G3DSA:3.40.50.300:FF:001885', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(72587, NULL, 'G3DSA:3.40.50.1110:FF:000143', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(72588, NULL, 'G3DSA:3.30.420.40:FF:000752', NULL, NULL, 'AGR099Cp', NULL, NULL, NULL, NULL, NULL, 4),
(72589, NULL, 'G3DSA:2.60.40.10:FF:002683', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(72590, NULL, 'G3DSA:3.40.50.10330:FF:000042', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(72591, NULL, 'G3DSA:3.30.590.50:FF:000008', NULL, NULL, 'Gamma-glutamylcysteine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(72592, NULL, 'G3DSA:3.60.10.10:FF:000205', NULL, NULL, 'Phosphatidylinositol 3,4,5-trisphosphate 5-phosphatase 2B', NULL, NULL, NULL, NULL, NULL, 4),
(72593, NULL, 'G3DSA:1.20.58.1970:FF:000001', NULL, NULL, 'Conserved oligomeric Golgi complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(72594, NULL, 'G3DSA:1.10.1420.10:FF:000187', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(72595, NULL, 'G3DSA:1.10.630.10:FF:000485', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(72596, NULL, 'G3DSA:2.130.10.10:FF:002380', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(72597, NULL, 'G3DSA:3.40.50.300:FF:007045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72598, NULL, 'G3DSA:3.90.25.10:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72599, NULL, 'G3DSA:3.90.370.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72600, NULL, 'G3DSA:1.20.1420.30:FF:000016', NULL, NULL, 'Membrane bound cation transporter', NULL, NULL, NULL, NULL, NULL, 4),
(72601, NULL, 'G3DSA:3.40.1280.10:FF:000083', NULL, NULL, 'RNA methyltransferase, TrmH family, group 3', NULL, NULL, NULL, NULL, NULL, 4),
(72602, NULL, 'G3DSA:1.20.58.1520:FF:000007', NULL, NULL, 'Spd-1', NULL, NULL, NULL, NULL, NULL, 4),
(72603, NULL, 'G3DSA:2.170.270.10:FF:000180', NULL, NULL, 'Si:dkeyp-41f9.4', NULL, NULL, NULL, NULL, NULL, 4),
(72604, NULL, 'G3DSA:2.170.130.20:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72605, NULL, 'G3DSA:3.40.50.300:FF:006556', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72606, NULL, 'G3DSA:1.20.120.20:FF:000008', NULL, NULL, 'Apolipoprotein A-IV a', NULL, NULL, NULL, NULL, NULL, 4),
(72607, NULL, 'G3DSA:3.80.10.10:FF:003796', NULL, NULL, 'EIN3-binding F-box protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(72608, NULL, 'G3DSA:3.40.367.20:FF:000024', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(72609, NULL, 'G3DSA:1.20.58.60:FF:000106', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(72610, NULL, 'G3DSA:2.160.20.10:FF:000277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72611, NULL, 'G3DSA:1.25.40.10:FF:004525', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72612, NULL, 'G3DSA:3.40.50.200:FF:000113', NULL, NULL, 'Clan SB, family S8, subtilisin-like serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(72613, NULL, 'G3DSA:3.20.20.140:FF:000239', NULL, NULL, 'Adenosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(72614, NULL, 'G3DSA:1.20.120.1760:FF:000042', NULL, NULL, 'Bifunctional IPC transferase and DIPP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(72615, NULL, 'G3DSA:3.40.50.10380:FF:000028', NULL, NULL, 'NADP-dependent malic enzyme 4 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(72616, NULL, 'G3DSA:3.10.290.20:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72617, NULL, 'G3DSA:2.60.40.10:FF:001671', NULL, NULL, 'Immunoglobulin lambda variable 4-69', NULL, NULL, NULL, NULL, NULL, 4),
(72618, NULL, 'G3DSA:3.40.50.300:FF:005196', NULL, NULL, 'Septin-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(72619, NULL, 'G3DSA:4.10.240.10:FF:000207', NULL, NULL, 'Uncharacterized transcriptional regulatory protein C25B8.11', NULL, NULL, NULL, NULL, NULL, 4),
(72620, NULL, 'G3DSA:1.25.40.20:FF:001151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72621, NULL, 'G3DSA:1.25.40.10:FF:001614', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(72622, NULL, 'G3DSA:1.10.3860.10:FF:000029', NULL, NULL, 'Amino acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(72623, NULL, 'G3DSA:3.40.850.10:FF:000476', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(72624, NULL, 'G3DSA:3.30.750.140:FF:000002', NULL, NULL, 'Flagellar hook-length control protein', NULL, NULL, NULL, NULL, NULL, 4),
(72625, NULL, 'G3DSA:3.40.50.150:FF:000783', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72626, NULL, 'G3DSA:3.40.50.1400:FF:000022', NULL, NULL, 'Ferrochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(72627, NULL, 'G3DSA:2.30.30.60:FF:000006', NULL, NULL, 'Predicted mechanosensitive ion channel', NULL, NULL, NULL, NULL, NULL, 4),
(72628, NULL, 'G3DSA:3.80.10.10:FF:004072', NULL, NULL, 'Tubulin folding cofactor E', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(72629, NULL, 'G3DSA:2.30.42.10:FF:000648', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72630, NULL, 'G3DSA:3.90.25.10:FF:000042', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(72631, NULL, 'G3DSA:1.25.70.10:FF:000082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72632, NULL, 'G3DSA:1.25.40.990:FF:000060', NULL, NULL, 'Putative 26S proteasome non-ATPase regulatory subunit 8 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(72633, NULL, 'G3DSA:2.130.10.10:FF:001879', NULL, NULL, 'Intraflagellar transport protein 80', NULL, NULL, NULL, NULL, NULL, 4),
(72634, NULL, 'G3DSA:1.25.40.90:FF:000019', NULL, NULL, 'Clathrin coat assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(72635, NULL, 'G3DSA:3.40.50.620:FF:000115', NULL, NULL, 'tRNA-specific 2-thiouridylase MnmA', NULL, NULL, NULL, NULL, NULL, 4),
(72636, NULL, 'G3DSA:3.80.10.10:FF:001958', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(72637, NULL, 'G3DSA:3.40.50.920:FF:000036', NULL, NULL, 'Indolepyruvate oxidoreductase subunit IorA', NULL, NULL, NULL, NULL, NULL, 4),
(72638, NULL, 'G3DSA:3.40.50.1100:FF:000101', NULL, NULL, 'Putative pyridoxal-phosphate dependent protein F13B12.4', NULL, NULL, NULL, NULL, NULL, 4),
(72639, NULL, 'G3DSA:1.20.140.30:FF:000007', NULL, NULL, 'MOB kinase activator 1B', NULL, NULL, NULL, NULL, NULL, 4),
(72640, NULL, 'G3DSA:1.25.10.10:FF:002686', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72641, NULL, 'G3DSA:1.10.510.10:FF:000774', NULL, NULL, 'Kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(72642, NULL, 'G3DSA:3.30.530.20:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72643, NULL, 'G3DSA:3.90.650.10:FF:000062', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(72644, NULL, 'G3DSA:3.40.50.2000:FF:000096', NULL, NULL, 'ALG1, chitobiosyldiphosphodolichol beta-mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(72645, NULL, 'G3DSA:3.30.60.20:FF:000067', NULL, NULL, 'uncharacterized protein LOC108093793 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(72646, NULL, 'G3DSA:3.30.60.20:FF:000123', NULL, NULL, 'Serine/threonine-protein kinase dkf-2', NULL, NULL, NULL, NULL, NULL, 4),
(72647, NULL, 'G3DSA:3.30.40.10:FF:002193', NULL, NULL, 'Vacuolar segregation protein pep7', NULL, NULL, NULL, NULL, NULL, 4),
(72648, NULL, 'G3DSA:1.20.1070.10:FF:000663', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(72649, NULL, 'G3DSA:2.10.50.10:FF:000010', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 21', NULL, NULL, NULL, NULL, NULL, 4),
(72650, NULL, 'G3DSA:1.20.140.10:FF:000001', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(72651, NULL, 'G3DSA:3.40.50.11980:FF:000019', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(72652, NULL, 'G3DSA:1.10.287.470:FF:000077', NULL, NULL, 'Acriflavin resistance periplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(72653, NULL, 'G3DSA:3.30.70.1320:FF:000006', NULL, NULL, 'Transporter AcrB/D/F family protein', NULL, NULL, NULL, NULL, NULL, 4),
(72654, NULL, 'G3DSA:1.10.510.10:FF:002859', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72655, NULL, 'G3DSA:3.40.640.10:FF:000139', NULL, NULL, 'Long chain base biosynthesis protein 2a', NULL, NULL, NULL, NULL, NULL, 4),
(72656, NULL, 'G3DSA:1.20.1270.60:FF:000249', NULL, NULL, 'Probable Rho-GTPase-activating protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(72657, NULL, 'G3DSA:3.30.420.10:FF:000592', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72658, NULL, 'G3DSA:3.30.200.20:FF:001955', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72659, NULL, 'G3DSA:1.10.510.10:FF:000830', NULL, NULL, 'PX domain-containing serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(72660, NULL, 'G3DSA:3.30.70.660:FF:000026', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(72661, NULL, 'G3DSA:2.40.50.140:FF:000048', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(72662, NULL, 'G3DSA:3.40.630.30:FF:000027', NULL, NULL, 'Protein RibT', NULL, NULL, NULL, NULL, NULL, 4),
(72663, NULL, 'G3DSA:3.40.1690.10:FF:000018', NULL, NULL, 'Type III secretion system protein', NULL, NULL, NULL, NULL, NULL, 4),
(72664, NULL, 'G3DSA:3.40.30.10:FF:000949', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(72665, NULL, 'G3DSA:3.90.70.10:FF:000674', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72666, NULL, 'G3DSA:3.40.50.720:FF:002505', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72667, NULL, 'G3DSA:1.20.1090.10:FF:000041', NULL, NULL, 'Hydroxyacid-oxoacid transhydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(72668, NULL, 'G3DSA:2.30.30.490:FF:000022', NULL, NULL, 'Blast:Metastasis-associated protein MTA3', NULL, NULL, NULL, NULL, NULL, 4),
(72669, NULL, 'G3DSA:3.40.50.300:FF:002846', NULL, NULL, 'Os06g0310200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(72670, NULL, 'G3DSA:2.130.10.10:FF:003009', NULL, NULL, 'Eukaryotic translation initiation factor 2A', NULL, NULL, NULL, NULL, NULL, 4),
(72671, NULL, 'G3DSA:2.60.120.920:FF:000144', NULL, NULL, 'Cabz01076234.2', NULL, NULL, NULL, NULL, NULL, 4),
(72672, NULL, 'G3DSA:3.40.50.1000:FF:000790', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72673, NULL, 'G3DSA:3.40.50.10860:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72674, NULL, 'G3DSA:1.10.730.10:FF:000026', NULL, NULL, 'Methionine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(72675, NULL, 'G3DSA:1.10.287.70:FF:000013', NULL, NULL, 'Glutamate receptor, ionotropic, AMPA 4', NULL, NULL, NULL, NULL, NULL, 4),
(72676, NULL, 'G3DSA:3.40.50.11060:FF:000013', NULL, NULL, 'Putative GTP-binding protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(72677, NULL, 'G3DSA:3.30.40.10:FF:000063', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(72678, NULL, 'G3DSA:3.40.50.300:FF:008574', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72679, NULL, 'G3DSA:1.25.40.20:FF:001100', NULL, NULL, 'Notch homolog', NULL, NULL, NULL, NULL, NULL, 4),
(72680, NULL, 'G3DSA:2.130.10.10:FF:003116', NULL, NULL, 'Dynein intermediate chain', NULL, NULL, NULL, NULL, NULL, 4),
(72681, NULL, 'G3DSA:3.10.120.10:FF:000034', NULL, NULL, 'Fatty acid 2-hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(72682, NULL, 'G3DSA:1.10.533.10:FF:000231', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(72683, NULL, 'G3DSA:2.160.10.10:FF:000091', NULL, NULL, 'Transferase hexapeptide repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(72684, NULL, 'G3DSA:2.40.50.1000:FF:000004', NULL, NULL, '40S ribosomal proteins S11', NULL, NULL, NULL, NULL, NULL, 4),
(72685, NULL, 'G3DSA:1.10.238.10:FF:000910', NULL, NULL, 'Proline-serine-threonine phosphatase interacting protein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(72686, NULL, 'G3DSA:1.10.10.480:FF:000006', NULL, NULL, 'Diphosphate-fructose-6-phosphate 1-phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(72687, NULL, 'G3DSA:3.80.10.10:FF:004021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72688, NULL, 'G3DSA:3.30.70.3330:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72689, NULL, 'G3DSA:3.30.160.60:FF:001772', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72690, NULL, 'G3DSA:1.25.40.10:FF:005037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72691, NULL, 'G3DSA:3.30.497.10:FF:000128', NULL, NULL, 'Serpin family I member 2', NULL, NULL, NULL, NULL, NULL, 4),
(72692, NULL, 'G3DSA:3.40.50.300:FF:003515', NULL, NULL, 'Activator 1 subunit putative', NULL, NULL, NULL, NULL, NULL, 4),
(72693, NULL, 'G3DSA:1.10.555.10:FF:000068', NULL, NULL, 'RhoGAP domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(72694, NULL, 'G3DSA:1.10.555.10:FF:000124', NULL, NULL, 'Phosphoinositide-3-kinase, regulatory subunit 2 (beta)', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(72695, NULL, 'G3DSA:3.40.850.10:FF:000240', NULL, NULL, 'Centromere protein E', NULL, NULL, NULL, NULL, NULL, 4),
(72696, NULL, 'G3DSA:3.90.190.10:FF:000599', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72697, NULL, 'G3DSA:1.10.510.10:FF:002011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72698, NULL, 'G3DSA:1.20.950.20:FF:000021', NULL, NULL, 'Cytochrome b', NULL, NULL, NULL, NULL, NULL, 4),
(72699, NULL, 'G3DSA:1.20.5.110:FF:000036', NULL, NULL, 'Putative Syntaxin-8', NULL, NULL, NULL, NULL, NULL, 4),
(72700, NULL, 'G3DSA:3.40.50.720:FF:000420', NULL, NULL, 'UDP-glucose 4-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(72701, NULL, 'G3DSA:1.20.58.60:FF:000449', NULL, NULL, 'Spectrin beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(72702, NULL, 'G3DSA:1.25.40.70:FF:000013', NULL, NULL, 'Phosphatidylinositol 4-kinase alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(72703, NULL, 'G3DSA:1.20.1530.20:FF:000016', NULL, NULL, 'Solute carrier family 10 member 1', NULL, NULL, NULL, NULL, NULL, 4),
(72704, NULL, 'G3DSA:1.10.1040.10:FF:000057', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(72705, NULL, 'G3DSA:3.20.20.80:FF:000706', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72706, NULL, 'G3DSA:3.90.1150.170:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72707, NULL, 'G3DSA:1.50.40.10:FF:000010', NULL, NULL, 'Probable YHM1 (Mitochondrial carrier)', NULL, NULL, NULL, NULL, NULL, 4),
(72708, NULL, 'G3DSA:1.10.10.10:FF:000589', NULL, NULL, 'HSF-type DNA-binding, putative', NULL, NULL, NULL, NULL, NULL, 4),
(72709, NULL, 'G3DSA:3.40.630.10:FF:000021', NULL, NULL, 'Nicalin', NULL, NULL, NULL, NULL, NULL, 4),
(72710, NULL, 'G3DSA:3.30.70.330:FF:002131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72711, NULL, 'G3DSA:3.30.160.60:FF:003913', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72712, NULL, 'G3DSA:2.60.40.10:FF:004993', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72713, NULL, 'G3DSA:1.25.10.10:FF:003355', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(72714, NULL, 'G3DSA:1.20.1000.10:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72715, NULL, 'G3DSA:2.10.90.10:FF:000131', NULL, NULL, 'Noggin-3', NULL, NULL, NULL, NULL, NULL, 4),
(72716, NULL, 'G3DSA:2.10.50.30:FF:000016', NULL, NULL, 'Vomeronasal 2, receptor 18', NULL, NULL, NULL, NULL, NULL, 4),
(72717, NULL, 'G3DSA:1.10.287.2620:FF:000021', NULL, NULL, 'Dynein heavy chain 3', NULL, NULL, NULL, NULL, NULL, 4),
(72718, NULL, 'G3DSA:3.40.710.10:FF:000022', NULL, NULL, 'Penicillin-binding protein A', NULL, NULL, NULL, NULL, NULL, 4),
(72719, NULL, 'G3DSA:3.30.710.10:FF:000400', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72720, NULL, 'G3DSA:3.20.20.140:FF:000127', NULL, NULL, 'Putative deoxyribonuclease YjjV', NULL, NULL, NULL, NULL, NULL, 4),
(72721, NULL, 'G3DSA:3.40.50.150:FF:001295', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72722, NULL, 'G3DSA:3.30.900.10:FF:000050', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(72723, NULL, 'G3DSA:3.30.1370.10:FF:000081', NULL, NULL, 'RNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(72724, NULL, 'G3DSA:1.20.120.1880:FF:000016', NULL, NULL, 'Putative nuclear pore complex protein (NUP155)', NULL, NULL, NULL, NULL, NULL, 4),
(72725, NULL, 'G3DSA:2.40.50.140:FF:000380', NULL, NULL, 'DIS3-like exonuclease 2', NULL, NULL, NULL, NULL, NULL, 4),
(72726, NULL, 'G3DSA:3.40.640.10:FF:000426', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72727, NULL, 'G3DSA:3.10.20.90:FF:000945', NULL, NULL, 'Ubiquitin specific peptidase 7 (herpes virus-associated)', NULL, NULL, NULL, NULL, NULL, 4),
(72728, NULL, 'G3DSA:3.80.10.10:FF:000542', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(72729, NULL, 'G3DSA:2.130.10.10:FF:003161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(72730, NULL, 'G3DSA:2.60.40.420:FF:000108', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(72731, NULL, 'G3DSA:3.20.20.20:FF:000031', NULL, NULL, 'Dihydropteroate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(72732, NULL, 'G3DSA:3.40.930.10:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72733, NULL, 'G3DSA:3.90.870.10:FF:000005', NULL, NULL, 'Bifunctional riboflavin biosynthesis protein RIBA 1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(72734, NULL, 'G3DSA:1.20.90.10:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72735, NULL, 'G3DSA:1.20.1070.10:FF:000950', NULL, NULL, 'Neuropeptide FF receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(72736, NULL, 'G3DSA:3.40.50.80:FF:000128', NULL, NULL, 'Protein CBG08008', NULL, NULL, NULL, NULL, NULL, 4),
(72737, NULL, 'G3DSA:2.60.120.330:FF:000006', NULL, NULL, '2-oxoglutarate-Fe(II) type oxidoreductase hxnY', NULL, NULL, NULL, NULL, NULL, 4),
(72738, NULL, 'G3DSA:2.60.40.10:FF:001047', NULL, NULL, 'amphoterin-induced protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(72739, NULL, 'G3DSA:3.10.490.10:FF:000016', NULL, NULL, 'Gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(72740, NULL, 'G3DSA:3.20.20.80:FF:000526', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(72741, NULL, 'G3DSA:2.130.10.10:FF:000575', NULL, NULL, 'Elongator acetyltransferase complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(72742, NULL, 'G3DSA:1.25.40.10:FF:000310', NULL, NULL, 'Regulator of microtubule dynamics protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(72743, NULL, 'G3DSA:3.40.50.1820:FF:000316', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(72744, NULL, 'G3DSA:3.40.50.10190:FF:000073', NULL, NULL, 'Pescadillo homolog', NULL, NULL, NULL, NULL, NULL, 4),
(72745, NULL, 'G3DSA:1.10.150.40:FF:000002', NULL, NULL, 'Barrier to autointegration factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(72746, NULL, 'G3DSA:1.25.40.790:FF:000005', NULL, NULL, 'CCR4-NOT transcription complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(72747, NULL, 'G3DSA:3.30.70.330:FF:000950', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72748, NULL, 'G3DSA:3.90.1150.10:FF:000079', NULL, NULL, 'Molybdenum cofactor sulfurase', NULL, NULL, NULL, NULL, NULL, 4),
(72749, NULL, 'G3DSA:3.60.21.10:FF:000012', NULL, NULL, 'UDP-2,3-diacylglucosamine hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(72750, NULL, 'G3DSA:1.10.10.10:FF:001319', NULL, NULL, 'Redox-sensing transcriptional repressor Rex', NULL, NULL, NULL, NULL, NULL, 4),
(72751, NULL, 'G3DSA:2.60.200.40:FF:000036', NULL, NULL, 'Sphingosine kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(72752, NULL, 'G3DSA:3.30.70.330:FF:000894', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein A0', NULL, NULL, NULL, NULL, NULL, 4),
(72753, NULL, 'G3DSA:3.40.50.300:FF:006264', NULL, NULL, 'CSB (Cockayne Syndrome B) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(72754, NULL, 'G3DSA:3.30.70.330:FF:001967', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72755, NULL, 'G3DSA:2.60.40.10:FF:001227', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(72756, NULL, 'G3DSA:3.30.160.60:FF:006387', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72757, NULL, 'G3DSA:1.10.220.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72758, NULL, 'G3DSA:3.30.70.330:FF:001350', NULL, NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(72759, NULL, 'G3DSA:2.70.170.10:FF:000117', NULL, NULL, 'GH14445p', NULL, NULL, NULL, NULL, NULL, 4),
(72760, NULL, 'G3DSA:1.10.238.20:FF:000003', NULL, NULL, 'AGAP010409-PA', NULL, NULL, NULL, NULL, NULL, 4),
(72761, NULL, 'G3DSA:1.10.10.10:FF:001207', NULL, NULL, 'Transcriptional regulator lysR family', NULL, NULL, NULL, NULL, NULL, 4),
(72762, NULL, 'G3DSA:1.20.1250.20:FF:002271', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72763, NULL, 'G3DSA:2.60.110.10:FF:000009', NULL, NULL, 'Osmotin, thaumatin-like protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(72764, NULL, 'G3DSA:3.30.54.20:FF:000007', NULL, NULL, 'Threonine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(72765, NULL, 'G3DSA:2.30.110.10:FF:000089', NULL, NULL, 'Nitroreductase family deazaflavin-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(72766, NULL, 'G3DSA:2.130.10.10:FF:005246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72767, NULL, 'G3DSA:3.90.1150.80:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72768, NULL, 'G3DSA:1.20.1070.10:FF:001967', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72769, NULL, 'G3DSA:1.10.10.1100:FF:000007', NULL, NULL, '(2Fe-2S)-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(72770, NULL, 'G3DSA:1.25.10.10:FF:002051', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(72771, NULL, 'G3DSA:3.40.50.2300:FF:000921', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72772, NULL, 'G3DSA:3.80.10.10:FF:002739', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', NULL, NULL, NULL, NULL, NULL, 4),
(72773, NULL, 'G3DSA:1.10.510.10:FF:004141', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72774, NULL, 'G3DSA:1.10.10.10:FF:000807', NULL, NULL, 'Unplaced genomic scaffold supercont1.16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(72775, NULL, 'G3DSA:1.20.120.1960:FF:000001', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(72776, NULL, 'G3DSA:1.25.40.10:FF:001507', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g01030, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(72777, NULL, 'G3DSA:1.10.150.50:FF:000100', NULL, NULL, 'Polycomb protein Scm', NULL, NULL, NULL, NULL, NULL, 4),
(72778, NULL, 'G3DSA:3.40.50.2300:FF:000360', NULL, NULL, 'NEK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(72779, NULL, 'G3DSA:3.30.70.330:FF:001018', NULL, NULL, 'BnaC06g10090D protein', NULL, NULL, NULL, NULL, NULL, 4),
(72780, NULL, 'G3DSA:3.40.50.300:FF:001593', NULL, NULL, 'ATP-dependent RNA helicase DDX24', NULL, NULL, NULL, NULL, NULL, 4),
(72781, NULL, 'G3DSA:1.25.40.20:FF:001044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72782, NULL, 'G3DSA:1.25.10.10:FF:003411', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(72783, NULL, 'G3DSA:1.20.58.830:FF:000015', NULL, NULL, 'Erythrocyte binding antigen-181', NULL, NULL, NULL, NULL, NULL, 4),
(72784, NULL, 'G3DSA:3.30.70.330:FF:000618', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(72785, NULL, 'G3DSA:1.10.510.10:FF:001499', NULL, NULL, 'Kinase, STE STE20', NULL, NULL, NULL, NULL, NULL, 4),
(72786, NULL, 'G3DSA:2.60.40.10:FF:003413', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72787, NULL, 'G3DSA:3.30.420.40:FF:000696', NULL, NULL, 'Sugar kinase', NULL, NULL, NULL, NULL, NULL, 4),
(72788, NULL, 'G3DSA:3.80.10.10:FF:003291', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72789, NULL, 'G3DSA:2.30.30.40:FF:000579', NULL, NULL, 'AEL241Wp', NULL, NULL, NULL, NULL, NULL, 4),
(72790, NULL, 'G3DSA:3.30.200.20:FF:001899', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(72791, NULL, 'G3DSA:2.40.50.140:FF:000104', NULL, NULL, 'Cytochrome c-type biogenesis protein CcmE', NULL, NULL, NULL, NULL, NULL, 4),
(72792, NULL, 'G3DSA:3.40.850.10:FF:000184', NULL, NULL, 'Kinesin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(72793, NULL, 'G3DSA:3.30.9.10:FF:000114', NULL, NULL, 'Anaerobic glycerol-3-phosphate dehydrogenase, subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(72794, NULL, 'G3DSA:1.10.238.10:FF:000854', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(72795, NULL, 'G3DSA:2.40.128.130:FF:000006', NULL, NULL, 'Peptidase S8', NULL, NULL, NULL, NULL, NULL, 4),
(72796, NULL, 'G3DSA:2.20.100.10:FF:000080', NULL, NULL, 'SCO-spondin', NULL, NULL, NULL, NULL, NULL, 4),
(72797, NULL, 'G3DSA:3.20.20.70:FF:000580', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(72798, NULL, 'G3DSA:3.40.50.300:FF:003627', NULL, NULL, 'Gll3851 protein', NULL, NULL, NULL, NULL, NULL, 4),
(72799, NULL, 'G3DSA:1.25.40.10:FF:003183', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(72800, NULL, 'G3DSA:3.30.40.10:FF:000804', NULL, NULL, 'PHD finger domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(72801, NULL, 'G3DSA:3.30.420.40:FF:000983', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(72802, NULL, 'G3DSA:1.25.40.180:FF:000148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72803, NULL, 'G3DSA:3.40.120.10:FF:000050', NULL, NULL, 'Glucose 1,6-bisphosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(72804, NULL, 'G3DSA:3.30.710.10:FF:000075', NULL, NULL, 'zinc finger and BTB domain-containing protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(72805, NULL, 'G3DSA:2.60.40.60:FF:000421', NULL, NULL, 'Protein CBG29115', NULL, NULL, NULL, NULL, NULL, 4),
(72806, NULL, 'G3DSA:3.65.10.20:FF:000018', NULL, NULL, 'RNA 3''-terminal phosphate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(72807, NULL, 'G3DSA:1.25.40.10:FF:005217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72808, NULL, 'G3DSA:3.40.50.1000:FF:000458', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72809, NULL, 'G3DSA:3.60.15.10:FF:000008', NULL, NULL, 'Cleavage and polyadenylation specificity factor subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(72810, NULL, 'G3DSA:3.30.60.10:FF:000007', NULL, NULL, 'Class V chitinase, putative (AFU_orthologue AFUA_3G07160)', NULL, NULL, NULL, NULL, NULL, 4),
(72811, NULL, 'G3DSA:4.10.240.10:FF:000090', NULL, NULL, 'C6 finger domain transcription factor nscR', NULL, NULL, NULL, NULL, NULL, 4),
(72812, NULL, 'G3DSA:2.60.120.260:FF:000137', NULL, NULL, 'F-box only protein 44 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(72813, NULL, 'G3DSA:6.10.140.2220:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72814, NULL, 'G3DSA:2.30.42.10:FF:000468', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72815, NULL, 'G3DSA:3.40.50.720:FF:001668', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72816, NULL, 'G3DSA:3.40.50.1260:FF:000053', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(72817, NULL, 'G3DSA:3.30.70.100:FF:000050', NULL, NULL, 'Copper-transporting ATPase HMA5', NULL, NULL, NULL, NULL, NULL, 4),
(72818, NULL, 'G3DSA:1.25.40.10:FF:004020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72819, NULL, 'G3DSA:2.60.40.10:FF:002576', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(72820, NULL, 'G3DSA:3.40.850.10:FF:000060', NULL, NULL, 'unconventional myosin-XIX isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(72821, NULL, 'G3DSA:1.10.150.50:FF:000224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72822, NULL, 'G3DSA:3.40.50.1820:FF:000592', NULL, NULL, 'Aclacinomycin methylesterase RdmC', NULL, NULL, NULL, NULL, NULL, 4),
(72823, NULL, 'G3DSA:1.10.630.10:FF:000193', NULL, NULL, 'Cytochrome p450-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(72824, NULL, 'G3DSA:3.80.10.10:FF:000654', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', NULL, NULL, NULL, NULL, NULL, 4),
(72825, NULL, 'G3DSA:1.20.1280.50:FF:000073', NULL, NULL, 'F-box protein At5g07670', NULL, NULL, NULL, NULL, NULL, 4),
(72826, NULL, 'G3DSA:3.30.2350.20:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72827, NULL, 'G3DSA:2.60.120.920:FF:000088', NULL, NULL, 'SPRY domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(72828, NULL, 'G3DSA:3.40.50.970:FF:000080', NULL, NULL, 'Indolepyruvate oxidoreductase subunit IorA', NULL, NULL, NULL, NULL, NULL, 4),
(72829, NULL, 'G3DSA:3.30.160.60:FF:000715', NULL, NULL, 'Transcription factor E4F1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(72830, NULL, 'G3DSA:2.30.30.490:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(72831, NULL, 'G3DSA:1.10.510.10:FF:000594', NULL, NULL, 'Myosin light chain kinase isoform-III', NULL, NULL, NULL, NULL, NULL, 4),
(72832, NULL, 'G3DSA:1.20.930.20:FF:000019', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(72833, NULL, 'G3DSA:3.30.530.20:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72834, NULL, 'G3DSA:3.40.50.720:FF:001724', NULL, NULL, 'Calcium-activated potassium channel subunit alpha-1', NULL, NULL, NULL, NULL, NULL, 4),
(72835, NULL, 'G3DSA:1.25.40.20:FF:000987', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72836, NULL, 'G3DSA:2.30.38.10:FF:000014', NULL, NULL, 'Nonribosomal peptide synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(72837, NULL, 'G3DSA:1.10.490.10:FF:000041', NULL, NULL, 'Hemoglobin subunit epsilon 1', NULL, NULL, NULL, NULL, NULL, 4),
(72838, NULL, 'G3DSA:1.10.196.10:FF:000008', NULL, NULL, 'Locomotion defects, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(72839, NULL, 'G3DSA:2.60.120.10:FF:000510', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72840, NULL, 'G3DSA:1.20.1250.20:FF:002119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72841, NULL, 'G3DSA:3.30.1640.30:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72842, NULL, 'G3DSA:3.30.160.60:FF:000659', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(72843, NULL, 'G3DSA:3.40.140.10:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72844, NULL, 'G3DSA:2.130.10.10:FF:004465', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72845, NULL, 'G3DSA:1.10.420.10:FF:000036', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(72846, NULL, 'G3DSA:3.40.50.150:FF:000963', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72847, NULL, 'G3DSA:2.30.29.30:FF:000505', NULL, NULL, 'FACT complex subunit SSRP1', NULL, NULL, NULL, NULL, NULL, 4),
(72848, NULL, 'G3DSA:1.20.5.2230:FF:000001', NULL, NULL, 'Inner centromere protein', NULL, NULL, NULL, NULL, NULL, 4),
(72849, NULL, 'G3DSA:2.10.110.20:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72850, NULL, 'G3DSA:1.10.238.10:FF:000674', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(72851, NULL, 'G3DSA:2.30.30.100:FF:000225', NULL, NULL, 'Small nuclear ribonucleoprotein E', NULL, NULL, NULL, NULL, NULL, 4),
(72852, NULL, 'G3DSA:2.40.100.10:FF:000086', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(72853, NULL, 'G3DSA:2.60.40.3170:FF:000004', NULL, NULL, 'Tripeptidyl-peptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(72854, NULL, 'G3DSA:1.50.40.10:FF:000134', NULL, NULL, 'Peroxisomal membrane protein PMP47B', NULL, NULL, NULL, NULL, NULL, 4),
(72855, NULL, 'G3DSA:2.10.25.10:FF:000896', NULL, NULL, 'Pro-epidermal growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(72856, NULL, 'G3DSA:2.40.170.20:FF:000037', NULL, NULL, 'Iron-regulated outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(72857, NULL, 'G3DSA:3.40.50.720:FF:002000', NULL, NULL, 'Short chain dehydrogenase/reductase family 42E, member 2', NULL, NULL, NULL, NULL, NULL, 4),
(72858, NULL, 'G3DSA:3.60.110.10:FF:000011', NULL, NULL, 'Cyanide hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(72859, NULL, 'G3DSA:3.40.30.10:FF:000769', NULL, NULL, 'Glutathione S-transferase kappa', NULL, NULL, NULL, NULL, NULL, 4),
(72860, NULL, 'G3DSA:3.40.30.10:FF:000152', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(72861, NULL, 'G3DSA:4.10.92.10:FF:000001', NULL, NULL, '5-aminolevulinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(72862, NULL, 'G3DSA:1.10.287.70:FF:000125', NULL, NULL, 'Voltage-dependent T-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(72863, NULL, 'G3DSA:3.60.40.10:FF:000320', NULL, NULL, 'Protein phosphatase 1J (PP2C domain containing)', NULL, NULL, NULL, NULL, NULL, 4),
(72864, NULL, 'G3DSA:3.30.519.10:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(72865, NULL, 'G3DSA:3.40.50.300:FF:005140', NULL, NULL, 'Branched-chain amino acid ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(72866, NULL, 'G3DSA:3.40.50.1460:FF:000012', NULL, NULL, 'Caspase 9', NULL, NULL, NULL, NULL, NULL, 4),
(72867, NULL, 'G3DSA:2.60.120.920:FF:000032', NULL, NULL, 'Tripartite motif-containing protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(72868, NULL, 'G3DSA:1.25.10.10:FF:003068', NULL, NULL, 'Dynein assembly factor 5, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(72869, NULL, 'G3DSA:3.30.200.20:FF:000651', NULL, NULL, 'Fibroblast growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(72870, NULL, 'G3DSA:3.90.1150.210:FF:000003', NULL, NULL, 'F-actin-capping protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(72871, NULL, 'G3DSA:1.10.630.10:FF:000373', NULL, NULL, '9-divinyl ether synthase', NULL, NULL, NULL, NULL, NULL, 4),
(72872, NULL, 'G3DSA:1.25.40.10:FF:000889', NULL, NULL, 'ST13 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(72873, NULL, 'G3DSA:3.40.50.410:FF:000058', NULL, NULL, 'von Willebrand factor A domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(72874, NULL, 'G3DSA:2.60.120.200:FF:000147', NULL, NULL, 'Hydroxyproline O-galactosyltransferase GALT2', NULL, NULL, NULL, NULL, NULL, 4),
(72875, NULL, 'G3DSA:3.40.630.10:FF:000077', NULL, NULL, 'p-aminobenzoyl-glutamate hydrolase, A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(72876, NULL, 'G3DSA:2.60.40.640:FF:000118', NULL, NULL, 'Arrestin family protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(72877, NULL, 'G3DSA:1.25.10.10:FF:001090', NULL, NULL, 'Scy1p', NULL, NULL, NULL, NULL, NULL, 4),
(72878, NULL, 'G3DSA:3.50.50.60:FF:000493', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(72879, NULL, 'G3DSA:3.30.1330.90:FF:000012', NULL, NULL, 'Phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(72880, NULL, 'G3DSA:3.30.450.20:FF:000130', NULL, NULL, 'Period protein homolog lin-42', NULL, NULL, NULL, NULL, NULL, 4),
(72881, NULL, 'G3DSA:1.10.8.10:FF:000211', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(72882, NULL, 'G3DSA:1.10.510.10:FF:001555', NULL, NULL, 'Probable serine/threonine-protein kinase iksA', NULL, NULL, NULL, NULL, NULL, 4),
(72883, NULL, 'G3DSA:1.10.150.130:FF:000004', NULL, NULL, 'Phage integrase', NULL, NULL, NULL, NULL, NULL, 4),
(72884, NULL, 'G3DSA:3.40.50.300:FF:001773', NULL, NULL, 'Small GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(72885, NULL, 'G3DSA:1.20.1250.20:FF:001214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72886, NULL, 'G3DSA:1.10.510.10:FF:001611', NULL, NULL, 'Protein CBG08942', NULL, NULL, NULL, NULL, NULL, 4),
(72887, NULL, 'G3DSA:1.20.1720.10:FF:000129', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72888, NULL, 'G3DSA:2.10.25.10:FF:000497', NULL, NULL, 'Stabilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(72889, NULL, 'G3DSA:2.10.25.10:FF:000553', NULL, NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(72890, NULL, 'G3DSA:3.30.160.60:FF:006443', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72891, NULL, 'G3DSA:3.40.50.1580:FF:000031', NULL, NULL, 'Purine nucleoside phosphorylase lateral transfer candidate', NULL, NULL, NULL, NULL, NULL, 4),
(72892, NULL, 'G3DSA:2.60.40.10:FF:005830', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72893, NULL, 'G3DSA:3.40.50.2000:FF:000657', NULL, NULL, 'Glycosyl transferase family 1', NULL, NULL, NULL, NULL, NULL, 4),
(72894, NULL, 'G3DSA:2.30.29.30:FF:000449', NULL, NULL, 'Histone-arginine methyltransferase CARMER', NULL, NULL, NULL, NULL, NULL, 4),
(72895, NULL, 'G3DSA:3.40.50.960:FF:000020', NULL, NULL, '6,7-dimethyl-8-ribityllumazine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(72896, NULL, 'G3DSA:3.30.1370.50:FF:000025', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(72897, NULL, 'G3DSA:3.40.140.10:FF:000225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(72898, NULL, 'G3DSA:3.10.450.10:FF:000019', NULL, NULL, 'Cystatin 11', NULL, NULL, NULL, NULL, NULL, 4),
(72899, NULL, 'G3DSA:3.80.10.10:FF:001379', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(72900, NULL, 'G3DSA:1.10.150.50:FF:000044', NULL, NULL, 'kinase D-interacting substrate of 220 kDa isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(72901, NULL, 'G3DSA:1.25.40.10:FF:003800', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72902, NULL, 'G3DSA:3.90.190.10:FF:000543', NULL, NULL, 'Dual specificity protein phosphatase CDC14A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(72903, NULL, 'G3DSA:3.30.460.10:FF:000190', NULL, NULL, '2''-5'' oligoadenylate synthetase 1F', NULL, NULL, NULL, NULL, NULL, 4),
(72904, NULL, 'G3DSA:1.25.40.10:FF:000366', NULL, NULL, 'Pentatricopeptide (PPR) repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(72905, NULL, 'G3DSA:3.40.50.12240:FF:000002', NULL, NULL, 'Flagellum-specific ATP synthase FliI', NULL, NULL, NULL, NULL, NULL, 4),
(72906, NULL, 'G3DSA:1.10.287.110:FF:000166', NULL, NULL, 'Molecular chaperone, DnaJ family', NULL, NULL, NULL, NULL, NULL, 4),
(72907, NULL, 'G3DSA:3.40.5.10:FF:000004', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(72908, NULL, 'G3DSA:3.30.70.330:FF:002928', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72909, NULL, 'G3DSA:1.20.1250.20:FF:000938', NULL, NULL, 'AGAP012419-PA', NULL, NULL, NULL, NULL, NULL, 4),
(72910, NULL, 'G3DSA:1.10.10.60:FF:000564', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(72911, NULL, 'G3DSA:3.60.40.10:FF:000264', NULL, NULL, 'Phosphatase 2C-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(72912, NULL, 'G3DSA:3.30.420.40:FF:000640', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72913, NULL, 'G3DSA:2.160.20.10:FF:000041', NULL, NULL, 'Putative polygalacturonase', NULL, NULL, NULL, NULL, NULL, 4),
(72914, NULL, 'G3DSA:3.40.50.300:FF:001250', NULL, NULL, 'Putative ATP-dependent RNA helicase DDX11', NULL, NULL, NULL, NULL, NULL, 4),
(72915, NULL, 'G3DSA:3.40.430.10:FF:000040', NULL, NULL, 'Dihydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(72916, NULL, 'G3DSA:3.30.160.60:FF:000991', NULL, NULL, 'Zinc finger protein 366', NULL, NULL, NULL, NULL, NULL, 4),
(72917, NULL, 'G3DSA:2.60.40.60:FF:000764', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72918, NULL, 'G3DSA:1.25.10.10:FF:000718', NULL, NULL, 'Importin-5', NULL, NULL, NULL, NULL, NULL, 4),
(72919, NULL, 'G3DSA:2.60.40.10:FF:000266', NULL, NULL, 'Sidekick cell adhesion molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(72920, NULL, 'G3DSA:3.30.50.10:FF:000069', NULL, NULL, 'Transcriptional regulatory protein ASH1', NULL, NULL, NULL, NULL, NULL, 4),
(72921, NULL, 'G3DSA:3.90.550.10:FF:000458', NULL, NULL, 'Putative colanic acid biosynthesis glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(72922, NULL, 'G3DSA:3.20.20.190:FF:000102', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(72923, NULL, 'G3DSA:1.20.1560.10:FF:000127', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(72924, NULL, 'G3DSA:2.130.10.10:FF:000755', NULL, NULL, 'WD repeat-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(72925, NULL, 'G3DSA:3.40.710.10:FF:000078', NULL, NULL, 'PASTA domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(72926, NULL, 'G3DSA:2.60.260.20:FF:000039', NULL, NULL, 'HSP40, subfamily A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(72927, NULL, 'G3DSA:1.20.1050.10:FF:000044', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(72928, NULL, 'G3DSA:1.10.20.10:FF:000308', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72929, NULL, 'G3DSA:1.20.58.1030:FF:000012', NULL, NULL, 'Unplaced genomic scaffold supercont1.201, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(72930, NULL, 'G3DSA:1.10.132.10:FF:000007', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(72931, NULL, 'G3DSA:3.30.70.330:FF:002187', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72932, NULL, 'G3DSA:2.30.29.30:FF:000106', NULL, NULL, 'ran-binding protein 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(72933, NULL, 'G3DSA:3.30.160.60:FF:005662', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72934, NULL, 'G3DSA:3.30.200.20:FF:000994', NULL, NULL, 'Homoserine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(72935, NULL, 'G3DSA:2.130.10.10:FF:001031', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(72936, NULL, 'G3DSA:1.10.472.150:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72937, NULL, 'G3DSA:2.120.10.80:FF:000309', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(72938, NULL, 'G3DSA:1.25.40.180:FF:000204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72939, NULL, 'G3DSA:2.150.10.10:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72940, NULL, 'G3DSA:4.10.1240.10:FF:000002', NULL, NULL, 'Adhesion G protein-coupled receptor B2', NULL, NULL, NULL, NULL, NULL, 4),
(72941, NULL, 'G3DSA:2.60.40.790:FF:000079', NULL, NULL, 'SGT1 and CS domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(72942, NULL, 'G3DSA:3.30.390.30:FF:000021', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(72943, NULL, 'G3DSA:3.90.550.10:FF:000638', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72944, NULL, 'G3DSA:3.10.20.310:FF:000017', NULL, NULL, 'Outer membrane protein assembly factor', NULL, NULL, NULL, NULL, NULL, 4),
(72945, NULL, 'G3DSA:2.60.40.10:FF:002396', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72946, NULL, 'G3DSA:2.60.200.20:FF:000210', NULL, NULL, 'Pleckstrin homology-like domain, family B, member 1a', NULL, NULL, NULL, NULL, NULL, 4),
(72947, NULL, 'G3DSA:3.90.1420.10:FF:000004', NULL, NULL, 'Ribulose-1,5 bisphosphate carboxylase/oxygenase large subunit N-methyltransferase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(72948, NULL, 'G3DSA:1.20.1560.10:FF:000706', NULL, NULL, 'ABC transporter transmembrane region family protein', NULL, NULL, NULL, NULL, NULL, 4),
(72949, NULL, 'G3DSA:3.30.450.20:FF:000653', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72950, NULL, 'G3DSA:1.20.1250.20:FF:001490', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72951, NULL, 'G3DSA:2.130.10.10:FF:005426', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72952, NULL, 'G3DSA:2.170.150.10:FF:000013', NULL, NULL, 'Similar to tumor protein, translationally-controlled 1', NULL, NULL, NULL, NULL, NULL, 4),
(72953, NULL, 'G3DSA:2.60.120.1250:FF:000001', NULL, NULL, 'TRPM8 channel-associated factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(72954, NULL, 'G3DSA:1.25.10.10:FF:000870', NULL, NULL, 'BP28CT domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(72955, NULL, 'G3DSA:2.30.30.110:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72956, NULL, 'G3DSA:1.10.510.10:FF:001735', NULL, NULL, 'T0011027 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(72957, NULL, 'G3DSA:3.40.50.300:FF:005483', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(72958, NULL, 'G3DSA:3.30.200.20:FF:000319', NULL, NULL, 'Inka box actin regulator 2', NULL, NULL, NULL, NULL, NULL, 4),
(72959, NULL, 'G3DSA:3.30.160.60:FF:005482', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72960, NULL, 'G3DSA:1.25.40.10:FF:001327', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(72961, NULL, 'G3DSA:1.25.10.10:FF:001270', NULL, NULL, 'Armadillo segment polarity protein', NULL, NULL, NULL, NULL, NULL, 4),
(72962, NULL, 'G3DSA:2.40.160.120:FF:000046', NULL, NULL, 'Obr-2', NULL, NULL, NULL, NULL, NULL, 4),
(72963, NULL, 'G3DSA:3.40.50.300:FF:008394', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72964, NULL, 'G3DSA:3.30.450.20:FF:000310', NULL, NULL, 'Two-component system histidine kinase, FrrD', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(72965, NULL, 'G3DSA:3.30.450.40:FF:000136', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(72966, NULL, 'G3DSA:1.20.1050.10:FF:000100', NULL, NULL, 'Glutathione S-transferase omega-2', NULL, NULL, NULL, NULL, NULL, 4),
(72967, NULL, 'G3DSA:1.25.40.20:FF:000588', NULL, NULL, 'Ankyrin repeat domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(72968, NULL, 'G3DSA:3.40.50.11340:FF:000007', NULL, NULL, 'GDP-fucose protein O-fucosyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(72969, NULL, 'G3DSA:2.30.29.30:FF:000781', NULL, NULL, 'Mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(72970, NULL, 'G3DSA:3.80.10.10:FF:000598', NULL, NULL, 'Glucose-repressible alcohol dehydrogenase transcriptional effector', NULL, NULL, NULL, NULL, NULL, 4),
(72971, NULL, 'G3DSA:2.40.70.10:FF:000549', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72972, NULL, 'G3DSA:3.30.50.10:FF:000125', NULL, NULL, 'FXRbeta', NULL, NULL, NULL, NULL, NULL, 4),
(72973, NULL, 'G3DSA:3.30.160.60:FF:004369', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72974, NULL, 'G3DSA:3.50.50.60:FF:000892', NULL, NULL, 'Pyridine nucleotide-disulfide oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(72975, NULL, 'G3DSA:3.40.50.980:FF:000026', NULL, NULL, 'Acyl-CoA synthetase, AMP-forming', NULL, NULL, NULL, NULL, NULL, 4),
(72976, NULL, 'G3DSA:4.10.1240.30:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72977, NULL, 'G3DSA:3.30.390.50:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72978, NULL, 'G3DSA:3.40.50.2000:FF:001113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72979, NULL, 'G3DSA:2.70.50.30:FF:000002', NULL, NULL, 'Rho GDP-dissociation inhibitor 1', NULL, NULL, NULL, NULL, NULL, 4),
(72980, NULL, 'G3DSA:1.20.5.370:FF:000012', NULL, NULL, 'DNA repair protein XRCC4', NULL, NULL, NULL, NULL, NULL, 4),
(72981, NULL, 'G3DSA:1.25.10.10:FF:000538', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72982, NULL, 'G3DSA:1.20.1250.20:FF:001158', NULL, NULL, 'Efflux pump afoB', NULL, NULL, NULL, NULL, NULL, 4),
(72983, NULL, 'G3DSA:2.60.40.1730:FF:000033', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(72984, NULL, 'G3DSA:3.40.50.410:FF:000114', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(72985, NULL, 'G3DSA:2.60.40.10:FF:003357', NULL, NULL, 'Protein CBR-UNC-22', NULL, NULL, NULL, NULL, NULL, 4),
(72986, NULL, 'G3DSA:3.30.70.330:FF:003148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72987, NULL, 'G3DSA:1.10.533.10:FF:000287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72988, NULL, 'G3DSA:2.40.30.170:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72989, NULL, 'G3DSA:1.20.1560.10:FF:000307', NULL, NULL, 'ATP-binding cassette, sub-family B (MDR/TAP), member 11b', NULL, NULL, NULL, NULL, NULL, 4),
(72990, NULL, 'G3DSA:2.10.70.10:FF:000129', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(72991, NULL, 'G3DSA:3.30.200.20:FF:002231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72992, NULL, 'G3DSA:3.40.50.2000:FF:000713', NULL, NULL, 'Glycosyl transferase group 1', NULL, NULL, NULL, NULL, NULL, 4),
(72993, NULL, 'G3DSA:1.10.10.60:FF:001020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(72994, NULL, 'G3DSA:2.10.25.10:FF:001514', NULL, NULL, 'Notch receptor 1b', NULL, NULL, NULL, NULL, NULL, 4),
(72995, NULL, 'G3DSA:3.90.1150.10:FF:000135', NULL, NULL, 'Glutamate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(72996, NULL, 'G3DSA:1.10.287.1490:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(72997, NULL, 'G3DSA:2.40.30.110:FF:000001', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(72998, NULL, 'G3DSA:1.20.120.1240:FF:000004', NULL, NULL, 'dynamin-3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(72999, NULL, 'G3DSA:3.40.50.300:FF:000137', NULL, NULL, 'Replication-associated recombination protein A', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(73000, NULL, 'G3DSA:2.40.50.90:FF:000027', NULL, NULL, 'Tudor domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(73001, NULL, 'G3DSA:3.40.50.2000:FF:000314', NULL, NULL, '1-acyl-sn-glycerol-3-phosphate acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(73002, NULL, 'G3DSA:1.25.10.10:FF:001831', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73003, NULL, 'G3DSA:1.10.10.60:FF:000744', NULL, NULL, 'MYB transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(73004, NULL, 'G3DSA:2.60.40.10:FF:004717', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73005, NULL, 'G3DSA:2.40.10.10:FF:000321', NULL, NULL, 'GM13374', NULL, NULL, NULL, NULL, NULL, 4),
(73006, NULL, 'G3DSA:3.50.50.60:FF:000217', NULL, NULL, 'Oleate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(73007, NULL, 'G3DSA:1.25.40.720:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73008, NULL, 'G3DSA:1.20.1270.10:FF:000083', NULL, NULL, 'Mitochondrial-type HSP70, putative', NULL, NULL, NULL, NULL, NULL, 4),
(73009, NULL, 'G3DSA:3.40.50.2300:FF:000865', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73010, NULL, 'G3DSA:1.20.1070.10:FF:001388', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73011, NULL, 'G3DSA:2.40.30.130:FF:000007', NULL, NULL, 'Probable alanine--tRNA ligase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(73012, NULL, 'G3DSA:2.60.40.3610:FF:000001', NULL, NULL, 'Outer membrane protein SusE', NULL, NULL, NULL, NULL, NULL, 4),
(73013, NULL, 'G3DSA:1.10.287.470:FF:000021', NULL, NULL, 'Efflux transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(73014, NULL, 'G3DSA:1.10.8.1220:FF:000010', NULL, NULL, 'Dynein beta chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(73015, NULL, 'G3DSA:4.10.970.10:FF:000004', NULL, NULL, 'ATP-dependent DNA helicase 2 subunit KU70', NULL, NULL, NULL, NULL, NULL, 4),
(73016, NULL, 'G3DSA:2.130.10.10:FF:005302', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(73017, NULL, 'G3DSA:3.40.50.300:FF:005701', NULL, NULL, 'NLR family CARD domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(73018, NULL, 'G3DSA:3.50.50.60:FF:001510', NULL, NULL, 'Putative glutamate synthase small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(73019, NULL, 'G3DSA:3.40.50.2000:FF:000837', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73020, NULL, 'G3DSA:1.10.287.70:FF:000069', NULL, NULL, 'Potassium sodium-activated channel subfamily T member 1', NULL, NULL, NULL, NULL, NULL, 4),
(73021, NULL, 'G3DSA:2.60.120.10:FF:000111', NULL, NULL, 'Cyclic nucleotide binding domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(73022, NULL, 'G3DSA:3.40.50.720:FF:000763', NULL, NULL, 'Unplaced genomic scaffold supercont1.203, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(73023, NULL, 'G3DSA:3.30.70.330:FF:000427', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein 27C', NULL, NULL, NULL, NULL, NULL, 4),
(73024, NULL, 'G3DSA:3.90.870.10:FF:000033', NULL, NULL, 'Slr0006 protein', NULL, NULL, NULL, NULL, NULL, 4),
(73025, NULL, 'G3DSA:1.10.630.10:FF:000642', NULL, NULL, 'Cytochrome P450, family 4, subfamily f, polypeptide 13', NULL, NULL, NULL, NULL, NULL, 4),
(73026, NULL, 'G3DSA:3.90.190.10:FF:000312', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(73027, NULL, 'G3DSA:2.40.10.500:FF:000002', NULL, NULL, 'CRE-NHL-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(73028, NULL, 'G3DSA:3.90.810.10:FF:000024', NULL, NULL, 'Kinase, STE STE20', NULL, NULL, NULL, NULL, NULL, 4),
(73029, NULL, 'G3DSA:2.60.40.150:FF:000483', NULL, NULL, 'Phosphatidylinositol 3-kinase VPS34', NULL, NULL, NULL, NULL, NULL, 4),
(73030, NULL, 'G3DSA:1.25.40.10:FF:000922', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(73031, NULL, 'G3DSA:3.30.500.10:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73032, NULL, 'G3DSA:1.25.10.10:FF:002978', NULL, NULL, 'HEAT repeat family protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(73033, NULL, 'G3DSA:2.130.10.10:FF:001643', NULL, NULL, 'Mak11p', NULL, NULL, NULL, NULL, NULL, 4),
(73034, NULL, 'G3DSA:2.20.25.30:FF:000002', NULL, NULL, '60S ribosomal protein L37a', NULL, NULL, NULL, NULL, NULL, 4),
(73035, NULL, 'G3DSA:3.40.50.300:FF:003594', NULL, NULL, 'Rab family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(73036, NULL, 'G3DSA:3.40.50.300:FF:007293', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73037, NULL, 'G3DSA:1.10.10.60:FF:000643', NULL, NULL, 'Transcription factor MYB14 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(73038, NULL, 'G3DSA:3.30.40.10:FF:001501', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73039, NULL, 'G3DSA:3.30.70.3190:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73040, NULL, 'G3DSA:1.10.3470.10:FF:000022', NULL, NULL, 'Iron compound ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(73041, NULL, 'G3DSA:1.10.510.10:FF:002140', NULL, NULL, 'Striated muscle-enriched protein kinase a', NULL, NULL, NULL, NULL, NULL, 4),
(73042, NULL, 'G3DSA:1.10.510.10:FF:001634', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73043, NULL, 'G3DSA:3.30.70.330:FF:002474', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73044, NULL, 'G3DSA:3.40.30.10:FF:001225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73045, NULL, 'G3DSA:3.40.50.300:FF:003122', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(73046, NULL, 'G3DSA:2.130.10.10:FF:005342', NULL, NULL, 'WD40-repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(73047, NULL, 'G3DSA:1.20.120.1900:FF:000062', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(73048, NULL, 'G3DSA:3.30.70.330:FF:000866', NULL, NULL, 'RNA-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(73049, NULL, 'G3DSA:3.30.160.60:FF:000007', NULL, NULL, 'Basic krueppel-like factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(73050, NULL, 'G3DSA:3.30.559.70:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73051, NULL, 'G3DSA:1.25.10.10:FF:003484', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(73052, NULL, 'G3DSA:3.90.180.10:FF:000177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73053, NULL, 'G3DSA:3.20.10.10:FF:000033', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(73054, NULL, 'G3DSA:3.30.565.10:FF:000539', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(73055, NULL, 'G3DSA:3.80.10.10:FF:001722', NULL, NULL, 'GD24204', NULL, NULL, NULL, NULL, NULL, 4),
(73056, NULL, 'G3DSA:3.30.160.60:FF:002733', NULL, NULL, 'Zinc finger family protein', NULL, NULL, NULL, NULL, NULL, 4),
(73057, NULL, 'G3DSA:1.10.1670.10:FF:000003', NULL, NULL, 'Endonuclease III homolog', NULL, NULL, NULL, NULL, NULL, 4),
(73058, NULL, 'G3DSA:2.60.40.10:FF:003756', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73059, NULL, 'G3DSA:1.10.238.10:FF:000562', NULL, NULL, 'Calumenin isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(73060, NULL, 'G3DSA:3.40.50.720:FF:000611', NULL, NULL, 'Ubiquitin-activating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(73061, NULL, 'G3DSA:1.20.58.60:FF:000786', NULL, NULL, 'Dystonin', NULL, NULL, NULL, NULL, NULL, 4),
(73062, NULL, 'G3DSA:2.40.50.40:FF:000001', NULL, NULL, 'chromodomain-helicase-DNA-binding protein 8 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(73063, NULL, 'G3DSA:3.10.450.50:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73064, NULL, 'G3DSA:2.70.160.11:FF:000028', NULL, NULL, 'Protein arginine N-methyltransferase 5', NULL, NULL, NULL, NULL, NULL, 4),
(73065, NULL, 'G3DSA:3.90.640.10:FF:000224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73066, NULL, 'G3DSA:2.60.120.380:FF:000055', NULL, NULL, 'Cysteine peptidase, Clan CA, family C2, putative', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(73067, NULL, 'G3DSA:3.40.190.10:FF:000228', NULL, NULL, 'Chorismate mutase/prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(73068, NULL, 'G3DSA:1.20.1560.10:FF:000487', NULL, NULL, 'Probable ATP-binding component of ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(73069, NULL, 'G3DSA:3.40.50.300:FF:002503', NULL, NULL, 'Phosphate import ATP-binding protein PstB', NULL, NULL, NULL, NULL, NULL, 4),
(73070, NULL, 'G3DSA:2.40.50.100:FF:000227', NULL, NULL, 'Putative ABC transporter ATP-binding protein MG187', NULL, NULL, NULL, NULL, NULL, 4),
(73071, NULL, 'G3DSA:2.30.42.10:FF:000463', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73072, NULL, 'G3DSA:2.60.40.60:FF:000921', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73073, NULL, 'G3DSA:3.40.50.620:FF:000244', NULL, NULL, 'Deoxyribodipyrimidine photo-lyase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(73074, NULL, 'G3DSA:3.30.2350.10:FF:000063', NULL, NULL, 'tRNA pseudouridine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(73075, NULL, 'G3DSA:1.20.5.650:FF:000001', NULL, NULL, 'transcription factor IIIB 90 kDa subunit isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(73076, NULL, 'G3DSA:3.40.50.300:FF:004111', NULL, NULL, 'ATP-dependent rRNA helicase SPB4', NULL, NULL, NULL, NULL, NULL, 4),
(73077, NULL, 'G3DSA:3.30.160.60:FF:004178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73078, NULL, 'G3DSA:2.130.10.10:FF:001160', NULL, NULL, 'YBL104C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(73079, NULL, 'G3DSA:3.40.50.1440:FF:000118', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(73080, NULL, 'G3DSA:3.40.50.720:FF:000078', NULL, NULL, 'Alanine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(73081, NULL, 'G3DSA:1.10.8.10:FF:000239', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(73082, NULL, 'G3DSA:3.60.20.10:FF:000178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73083, NULL, 'G3DSA:2.10.25.10:FF:001722', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73084, NULL, 'G3DSA:1.10.10.2840:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73085, NULL, 'G3DSA:3.90.550.10:FF:000767', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(73086, NULL, 'G3DSA:1.10.510.10:FF:004377', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73087, NULL, 'G3DSA:3.30.70.2610:FF:000005', NULL, NULL, 'General transcription factor IIH subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(73088, NULL, 'G3DSA:3.30.70.330:FF:001855', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73089, NULL, 'G3DSA:1.10.3450.40:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73090, NULL, 'G3DSA:1.10.460.10:FF:000033', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(73091, NULL, 'G3DSA:2.130.10.10:FF:000654', NULL, NULL, 'Apoptotic protease-activating factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(73092, NULL, 'G3DSA:2.60.40.1170:FF:000073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73093, NULL, 'G3DSA:1.20.58.1210:FF:000010', NULL, NULL, 'Exocyst complex component EXO84', NULL, NULL, NULL, NULL, NULL, 4),
(73094, NULL, 'G3DSA:1.10.730.10:FF:000217', NULL, NULL, 'Putative leucine--tRNA ligase CDC60', NULL, NULL, NULL, NULL, NULL, 4),
(73095, NULL, 'G3DSA:3.30.160.60:FF:000479', NULL, NULL, 'Zinc finger protein 287', NULL, NULL, NULL, NULL, NULL, 4),
(73096, NULL, 'G3DSA:3.30.750.24:FF:000124', NULL, NULL, 'High affinity sulfate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(73097, NULL, 'G3DSA:1.20.1070.10:FF:001568', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73098, NULL, 'G3DSA:1.10.510.10:FF:002623', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73099, NULL, 'G3DSA:1.10.10.10:FF:001078', NULL, NULL, 'O-methyltransferase tpcA', NULL, NULL, NULL, NULL, NULL, 4),
(73100, NULL, 'G3DSA:3.40.50.720:FF:002056', NULL, NULL, 'Cis-retinol/3alpha hydroxysterol short-chain dehydrogenase-like protein isoform', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(73101, NULL, 'G3DSA:3.10.310.10:FF:000032', NULL, NULL, 'Diaminopimelate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(73102, NULL, 'G3DSA:3.40.50.300:FF:006348', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73103, NULL, 'G3DSA:1.25.40.20:FF:001544', NULL, NULL, 'Ankyrin repeat domain 31', NULL, NULL, NULL, NULL, NULL, 4),
(73104, NULL, 'G3DSA:3.10.129.10:FF:000189', NULL, NULL, 'Fatty acid synthase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(73105, NULL, 'G3DSA:3.40.50.620:FF:000727', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73106, NULL, 'G3DSA:2.60.120.330:FF:000001', NULL, NULL, 'Protein SRG1', NULL, NULL, NULL, NULL, NULL, 4),
(73107, NULL, 'G3DSA:3.80.10.10:FF:004465', NULL, NULL, 'Os06g0585982 protein', NULL, NULL, NULL, NULL, NULL, 4),
(73108, NULL, 'G3DSA:3.60.10.10:FF:000104', NULL, NULL, 'Endonuclease/exonuclease/phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(73109, NULL, 'G3DSA:2.130.10.10:FF:003088', NULL, NULL, 'AGAP007423-PA', NULL, NULL, NULL, NULL, NULL, 4),
(73110, NULL, 'G3DSA:2.130.10.10:FF:003408', NULL, NULL, 'Sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(73111, NULL, 'G3DSA:2.30.29.30:FF:000005', NULL, NULL, 'Amyloid beta (A4) protein b', NULL, NULL, NULL, NULL, NULL, 4),
(73112, NULL, 'G3DSA:3.30.559.10:FF:000126', NULL, NULL, 'Transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(73113, NULL, 'G3DSA:1.25.40.10:FF:005240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73114, NULL, 'G3DSA:1.25.10.10:FF:002539', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73115, NULL, 'G3DSA:3.40.1190.20:FF:000225', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73116, NULL, 'G3DSA:3.40.50.150:FF:001160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73117, NULL, 'G3DSA:3.20.20.80:FF:000521', NULL, NULL, 'protein O-GlcNAcase-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(73118, NULL, 'G3DSA:3.20.20.70:FF:000181', NULL, NULL, 'Ribulose-phosphate 3-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(73119, NULL, 'G3DSA:3.30.420.40:FF:000729', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73120, NULL, 'G3DSA:1.10.760.10:FF:000045', NULL, NULL, 'Cytochrome c554', NULL, NULL, NULL, NULL, NULL, 4),
(73121, NULL, 'G3DSA:2.130.10.10:FF:003397', NULL, NULL, 'Prp-8', NULL, NULL, NULL, NULL, NULL, 4),
(73122, NULL, 'G3DSA:2.60.40.10:FF:005038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73123, NULL, 'G3DSA:3.30.40.10:FF:000675', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(73124, NULL, 'G3DSA:3.40.850.10:FF:000245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73125, NULL, 'G3DSA:2.10.60.10:FF:000011', NULL, NULL, 'lymphocyte antigen 6H isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(73126, NULL, 'G3DSA:3.30.70.2190:FF:000014', NULL, NULL, 'D-lactate dehydrogenase (Dld)', NULL, NULL, NULL, NULL, NULL, 4),
(73127, NULL, 'G3DSA:1.25.40.10:FF:004284', NULL, NULL, 'Slr1196 protein', NULL, NULL, NULL, NULL, NULL, 4),
(73128, NULL, 'G3DSA:2.40.70.10:FF:000358', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73129, NULL, 'G3DSA:2.60.220.50:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73130, NULL, 'G3DSA:3.30.160.20:FF:000254', NULL, NULL, 'Interleukin enhancer-binding factor 3a', NULL, NULL, NULL, NULL, NULL, 4),
(73131, NULL, 'G3DSA:1.20.58.1380:FF:000015', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(73132, NULL, 'G3DSA:3.40.50.150:FF:000171', NULL, NULL, 'Chemotaxis protein methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(73133, NULL, 'G3DSA:3.40.50.1820:FF:000564', NULL, NULL, 'Alpha/beta-Hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(73134, NULL, 'G3DSA:2.50.20.10:FF:000006', NULL, NULL, 'Outer-membrane lipoprotein carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(73135, NULL, 'G3DSA:3.40.50.300:FF:003931', NULL, NULL, 'Rho family GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(73136, NULL, 'G3DSA:3.30.830.10:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73137, NULL, 'G3DSA:3.30.428.10:FF:000053', NULL, NULL, 'Galactose-1-phosphate uridylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(73138, NULL, 'G3DSA:3.30.300.90:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73139, NULL, 'G3DSA:4.10.60.10:FF:000079', NULL, NULL, 'Nucleic acid binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(73140, NULL, 'G3DSA:2.100.10.30:FF:000009', NULL, NULL, 'Protein RESTRICTED TEV MOVEMENT 1', NULL, NULL, NULL, NULL, NULL, 4),
(73141, NULL, 'G3DSA:3.30.1330.40:FF:000059', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(73142, NULL, 'G3DSA:3.40.850.10:FF:000375', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73143, NULL, 'G3DSA:1.10.510.10:FF:000678', NULL, NULL, 'Serine/threonine-protein kinase STN7, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(73144, NULL, 'G3DSA:3.30.70.1660:FF:000035', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(73145, NULL, 'G3DSA:2.60.40.10:FF:000367', NULL, NULL, 'Neural cell adhesion molecule L1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(73146, NULL, 'G3DSA:3.40.50.620:FF:000683', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73147, NULL, 'G3DSA:3.90.650.10:FF:000022', NULL, NULL, 'selenide, water dikinase 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(73148, NULL, 'G3DSA:2.60.120.260:FF:000165', NULL, NULL, 'Beta-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(73149, NULL, 'G3DSA:3.40.80.10:FF:000008', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(73150, NULL, 'G3DSA:2.30.30.100:FF:000141', NULL, NULL, 'Probable U6 snRNA-associated Sm-like protein LSm4', NULL, NULL, NULL, NULL, NULL, 4),
(73151, NULL, 'G3DSA:1.25.40.10:FF:003795', NULL, NULL, 'MxaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(73152, NULL, 'G3DSA:2.30.30.40:FF:000079', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase', NULL, NULL, NULL, NULL, NULL, 4),
(73153, NULL, 'G3DSA:3.30.160.60:FF:000316', NULL, NULL, 'Zinc finger and BTB domain-containing 14', NULL, NULL, NULL, NULL, NULL, 4),
(73154, NULL, 'G3DSA:1.10.8.60:FF:000001', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(73155, NULL, 'G3DSA:3.40.50.1260:FF:000025', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(73156, NULL, 'G3DSA:1.20.900.10:FF:000009', NULL, NULL, 'Vav guanine nucleotide exchange factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(73157, NULL, 'G3DSA:3.40.50.300:FF:004420', NULL, NULL, 'GTP-binding nuclear protein Ran', NULL, NULL, NULL, NULL, NULL, 4),
(73158, NULL, 'G3DSA:3.30.700.10:FF:000006', NULL, NULL, 'Fimbrial assembly protein PilE', NULL, NULL, NULL, NULL, NULL, 4),
(73159, NULL, 'G3DSA:3.30.160.60:FF:003352', NULL, NULL, 'Zinc finger protein 792', NULL, NULL, NULL, NULL, NULL, 4),
(73160, NULL, 'G3DSA:2.60.40.60:FF:000112', NULL, NULL, 'neural-cadherin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(73161, NULL, 'G3DSA:3.60.110.10:FF:000016', NULL, NULL, 'Nitrilase blr3397', NULL, NULL, NULL, NULL, NULL, 4),
(73162, NULL, 'G3DSA:3.30.70.660:FF:000072', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(73163, NULL, 'G3DSA:1.25.50.20:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73164, NULL, 'G3DSA:1.20.58.1080:FF:000015', NULL, NULL, 'DExH-box ATP-dependent RNA helicase DExH18 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(73165, NULL, 'G3DSA:1.20.1070.10:FF:001259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73166, NULL, 'G3DSA:3.40.50.11610:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73167, NULL, 'G3DSA:3.30.40.10:FF:000984', NULL, NULL, 'Putative RING zinc finger domain superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(73168, NULL, 'G3DSA:3.55.50.30:FF:000018', NULL, NULL, 'Putative anti-sigma factor', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(73169, NULL, 'G3DSA:1.10.238.10:FF:001181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73170, NULL, 'G3DSA:3.30.200.20:FF:001135', NULL, NULL, 'Casein kinase I isoform alpha', NULL, NULL, NULL, NULL, NULL, 4),
(73171, NULL, 'G3DSA:2.60.120.260:FF:000474', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(73172, NULL, 'G3DSA:2.30.29.30:FF:000477', NULL, NULL, 'TBC1 domain family member 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(73173, NULL, 'G3DSA:3.20.20.150:FF:000040', NULL, NULL, 'Xylose isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(73174, NULL, 'G3DSA:3.30.470.20:FF:000081', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(73175, NULL, 'G3DSA:3.40.50.1820:FF:000255', NULL, NULL, 'Alpha/beta hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(73176, NULL, 'G3DSA:1.10.600.10:FF:000022', NULL, NULL, 'NADH dehydrogenase complex assembly factor 6-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(73177, NULL, 'G3DSA:2.130.10.10:FF:001290', NULL, NULL, 'WD repeat domain 11', NULL, NULL, NULL, NULL, NULL, 4),
(73178, NULL, 'G3DSA:3.30.70.330:FF:001046', NULL, NULL, 'Nucleolin 1', NULL, NULL, NULL, NULL, NULL, 4),
(73179, NULL, 'G3DSA:3.80.10.10:FF:003167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73180, NULL, 'G3DSA:2.40.128.700:FF:000003', NULL, NULL, 'Fatty acid synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(73181, NULL, 'G3DSA:1.20.120.140:FF:000010', NULL, NULL, 'signal recognition particle receptor subunit alpha isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(73182, NULL, 'G3DSA:1.10.8.80:FF:000007', NULL, NULL, 'Putative moxR protein', NULL, NULL, NULL, NULL, NULL, 4),
(73183, NULL, 'G3DSA:3.15.10.10:FF:000006', NULL, NULL, 'phospholipid transfer protein isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(73184, NULL, 'G3DSA:3.40.50.300:FF:008282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73185, NULL, 'G3DSA:1.10.357.10:FF:000046', NULL, NULL, 'Transcriptional regulator, TetR family', NULL, NULL, NULL, NULL, NULL, 4),
(73186, NULL, 'G3DSA:1.10.287.950:FF:000030', NULL, NULL, 'Chemotaxis transducer', NULL, NULL, NULL, NULL, NULL, 4),
(73187, NULL, 'G3DSA:2.130.10.10:FF:004386', NULL, NULL, 'Activated protein kinase C receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(73188, NULL, 'G3DSA:2.60.40.420:FF:000131', NULL, NULL, 'GM22848', NULL, NULL, NULL, NULL, NULL, 4),
(73189, NULL, 'G3DSA:3.40.50.300:FF:007646', NULL, NULL, 'Dephospho-CoA kinase', NULL, NULL, NULL, NULL, NULL, 4),
(73190, NULL, 'G3DSA:3.30.40.10:FF:002120', NULL, NULL, 'Os01g0123700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(73191, NULL, 'G3DSA:1.10.10.10:FF:000089', NULL, NULL, 'Alkaline phosphatase synthesis response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(73192, NULL, 'G3DSA:3.30.930.10:FF:000254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73193, NULL, 'G3DSA:1.20.120.160:FF:000016', NULL, NULL, 'Signal transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(73194, NULL, 'G3DSA:2.120.10.30:FF:000542', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73195, NULL, 'G3DSA:2.30.30.40:FF:000551', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73196, NULL, 'G3DSA:1.10.10.10:FF:000459', NULL, NULL, 'Ferric uptake regulation protein', NULL, NULL, NULL, NULL, NULL, 4),
(73197, NULL, 'G3DSA:3.40.630.30:FF:000050', NULL, NULL, 'Acetyltransferase YhhY', NULL, NULL, NULL, NULL, NULL, 4),
(73198, NULL, 'G3DSA:2.30.39.10:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73199, NULL, 'G3DSA:2.130.10.10:FF:004706', NULL, NULL, 'CPSF A subunit region family protein', NULL, NULL, NULL, NULL, NULL, 4),
(73200, NULL, 'G3DSA:1.10.196.10:FF:000003', NULL, NULL, 'regulator of G-protein signaling 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(73201, NULL, 'G3DSA:3.30.710.10:FF:000260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(73202, NULL, 'G3DSA:1.10.3110.10:FF:000001', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(73203, NULL, 'G3DSA:1.20.1250.20:FF:000534', NULL, NULL, 'Major facilitator superfamily domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(73204, NULL, 'G3DSA:1.25.10.10:FF:000741', NULL, NULL, 'Armadillo repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(73205, NULL, 'G3DSA:3.30.540.10:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73206, NULL, 'G3DSA:1.20.90.10:FF:000020', NULL, NULL, 'Otoconin 90', NULL, NULL, NULL, NULL, NULL, 4),
(73207, NULL, 'G3DSA:3.60.130.10:FF:000029', NULL, NULL, 'Clavaminate synthase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(73208, NULL, 'G3DSA:2.130.10.10:FF:003897', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73209, NULL, 'G3DSA:1.25.10.10:FF:001230', NULL, NULL, 'ARM repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(73210, NULL, 'G3DSA:3.30.200.20:FF:000179', NULL, NULL, 'SCY1 like pseudokinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(73211, NULL, 'G3DSA:1.20.1370.30:FF:000001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73212, NULL, 'G3DSA:3.40.50.300:FF:002975', NULL, NULL, 'ESX-2 type VII secretion system protein EccC', NULL, NULL, NULL, NULL, NULL, 4),
(73213, NULL, 'G3DSA:3.40.50.2000:FF:001006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73214, NULL, 'G3DSA:2.60.120.290:FF:000028', NULL, NULL, 'Complement C1r subcomponent', NULL, NULL, NULL, NULL, NULL, 4),
(73215, NULL, 'G3DSA:3.30.160.60:FF:003413', NULL, NULL, 'Expressed sequence AI877918', NULL, NULL, NULL, NULL, NULL, 4),
(73216, NULL, 'G3DSA:3.80.10.10:FF:003476', NULL, NULL, 'F-box domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(73217, NULL, 'G3DSA:3.30.2450.30:FF:000003', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(73218, NULL, 'G3DSA:1.25.40.10:FF:002704', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73219, NULL, 'G3DSA:3.40.720.10:FF:000180', NULL, NULL, 'Arylsulfatase family member H', NULL, NULL, NULL, NULL, NULL, 4),
(73220, NULL, 'G3DSA:2.10.25.10:FF:000733', NULL, NULL, 'Wall-associated receptor kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(73221, NULL, 'G3DSA:3.30.505.10:FF:000210', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73222, NULL, 'G3DSA:3.60.21.10:FF:000040', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(73223, NULL, 'G3DSA:3.30.160.60:FF:003189', NULL, NULL, 'ZNF235 isoform 5', NULL, NULL, NULL, NULL, NULL, 4),
(73224, NULL, 'G3DSA:3.30.60.20:FF:000095', NULL, NULL, 'Thymidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(73225, NULL, 'G3DSA:3.80.10.10:FF:000750', NULL, NULL, 'PH domain leucine-rich repeat-containing protein phosphatase 1 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(73226, NULL, 'G3DSA:2.30.42.10:FF:000524', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73227, NULL, 'G3DSA:1.20.1740.10:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73228, NULL, 'G3DSA:2.170.140.10:FF:000024', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(73229, NULL, 'G3DSA:2.120.10.30:FF:000379', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73230, NULL, 'G3DSA:3.50.50.60:FF:000392', NULL, NULL, 'FAD/NAD(P)-binding oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(73231, NULL, 'G3DSA:3.30.70.260:FF:000058', NULL, NULL, 'Ribose 5-phosphate isomerase A', NULL, NULL, NULL, NULL, NULL, 4),
(73232, NULL, 'G3DSA:1.10.10.10:FF:000561', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(73233, NULL, 'G3DSA:1.25.40.10:FF:000698', NULL, NULL, 'Peroxisomal targeting signal receptor', NULL, NULL, NULL, NULL, NULL, 4),
(73234, NULL, 'G3DSA:1.10.600.10:FF:000005', NULL, NULL, 'Ent-kaur-16-ene synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(73235, NULL, 'G3DSA:1.10.10.10:FF:001415', NULL, NULL, 'ORC1-type DNA replication protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(73236, NULL, 'G3DSA:3.30.9.10:FF:000007', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(73237, NULL, 'G3DSA:3.50.50.60:FF:000212', NULL, NULL, 'Dihydrolipoyl dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(73238, NULL, 'G3DSA:1.20.1250.20:FF:001023', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(73239, NULL, 'G3DSA:3.40.50.1460:FF:000113', NULL, NULL, 'AGAP010827-PA', NULL, NULL, NULL, NULL, NULL, 4),
(73240, NULL, 'G3DSA:3.30.230.10:FF:000341', NULL, NULL, 'Elongation factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(73241, NULL, 'G3DSA:1.25.40.420:FF:000024', NULL, NULL, 'Kelch repeat and BTB domain containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(73242, NULL, 'G3DSA:3.30.200.20:FF:000842', NULL, NULL, 'Cyclin-dependent kinase C-2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(73243, NULL, 'G3DSA:2.60.40.60:FF:000904', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73244, NULL, 'G3DSA:1.20.1070.10:FF:000303', NULL, NULL, 'Blast:Alpha-2C adrenergic receptor', NULL, NULL, NULL, NULL, NULL, 4),
(73245, NULL, 'G3DSA:1.25.40.10:FF:001850', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(73246, NULL, 'G3DSA:2.40.50.140:FF:000071', NULL, NULL, 'Eukaryotic translation initiation factor 1A', NULL, NULL, NULL, NULL, NULL, 4),
(73247, NULL, 'G3DSA:3.30.1010.10:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73248, NULL, 'G3DSA:2.10.25.10:FF:000424', NULL, NULL, 'Delta and Notch-like epidermal growth factor-related receptor', NULL, NULL, NULL, NULL, NULL, 4),
(73249, NULL, 'G3DSA:3.40.220.10:FF:000035', NULL, NULL, 'Probable cytosol aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(73250, NULL, 'G3DSA:1.10.10.60:FF:001132', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73251, NULL, 'G3DSA:1.10.150.170:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73252, NULL, 'G3DSA:3.40.50.300:FF:005376', NULL, NULL, 'Guanine nucleotide-binding protein alpha-4 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(73253, NULL, 'G3DSA:3.40.50.1860:FF:000008', NULL, NULL, 'Glutamate racemase', NULL, NULL, NULL, NULL, NULL, 4),
(73254, NULL, 'G3DSA:3.30.420.40:FF:000831', NULL, NULL, 'Actin-related protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(73255, NULL, 'G3DSA:3.60.20.10:FF:000206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73256, NULL, 'G3DSA:3.40.50.720:FF:000387', NULL, NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(73257, NULL, 'G3DSA:2.40.70.10:FF:000460', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73258, NULL, 'G3DSA:1.25.10.10:FF:002556', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73259, NULL, 'G3DSA:3.80.10.10:FF:002650', NULL, NULL, 'Transforming growth factor beta activator LRRC33', NULL, NULL, NULL, NULL, NULL, 4),
(73260, NULL, 'G3DSA:3.40.30.10:FF:001242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73261, NULL, 'G3DSA:3.90.1030.10:FF:000008', NULL, NULL, '50S ribosomal protein L17', NULL, NULL, NULL, NULL, NULL, 4),
(73262, NULL, 'G3DSA:2.130.10.10:FF:005797', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73263, NULL, 'G3DSA:2.60.40.1730:FF:000038', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(73264, NULL, 'G3DSA:2.10.25.10:FF:001705', NULL, NULL, 'Transmembrane cell adhesion receptor mua-3', NULL, NULL, NULL, NULL, NULL, 4),
(73265, NULL, 'G3DSA:3.40.50.800:FF:000113', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(73266, NULL, 'G3DSA:3.40.630.10:FF:000381', NULL, NULL, 'Diaminopropionate ammonia-lyase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(73267, NULL, 'G3DSA:3.10.129.10:FF:000222', NULL, NULL, 'acyl-coenzyme A thioesterase 9, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(73268, NULL, 'G3DSA:1.25.10.10:FF:003175', NULL, NULL, 'ATR serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(73269, NULL, 'G3DSA:3.30.160.60:FF:003661', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(73270, NULL, 'G3DSA:1.25.40.10:FF:004604', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g30610, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(73271, NULL, 'G3DSA:1.20.1250.20:FF:000517', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73272, NULL, 'G3DSA:1.10.1450.10:FF:000094', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(73273, NULL, 'G3DSA:2.130.10.10:FF:003425', NULL, NULL, 'Cleavage stimulation factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(73274, NULL, 'G3DSA:3.60.21.10:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73275, NULL, 'G3DSA:2.30.36.70:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73276, NULL, 'G3DSA:2.20.70.10:FF:000168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73277, NULL, 'G3DSA:3.90.190.10:FF:000442', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73278, NULL, 'G3DSA:3.90.190.10:FF:000003', NULL, NULL, 'receptor-type tyrosine-protein phosphatase kappa isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(73279, NULL, 'G3DSA:3.40.1410.10:FF:000049', NULL, NULL, 'Putative GntR-family regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(73280, NULL, 'G3DSA:2.30.40.10:FF:000138', NULL, NULL, '5-methylthioadenosine/S-adenosylhomocysteine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(73281, NULL, 'G3DSA:2.60.40.150:FF:000174', NULL, NULL, 'Multiple C2 domains, transmembrane 2a', NULL, NULL, NULL, NULL, NULL, 4),
(73282, NULL, 'G3DSA:2.40.30.10:FF:000103', NULL, NULL, 'NADPH oxidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(73283, NULL, 'G3DSA:3.40.1190.20:FF:000242', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73284, NULL, 'G3DSA:1.20.1050.10:FF:000196', NULL, NULL, 'Em:AP000351.3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(73285, NULL, 'G3DSA:3.40.50.2300:FF:000489', NULL, NULL, 'Protein CBG01593', NULL, NULL, NULL, NULL, NULL, 4),
(73286, NULL, 'G3DSA:2.40.50.90:FF:000072', NULL, NULL, 'Transcription factor (Snd1/p100), putative', NULL, NULL, NULL, NULL, NULL, 4),
(73287, NULL, 'G3DSA:2.60.40.10:FF:005673', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73288, NULL, 'G3DSA:2.30.30.40:FF:000449', NULL, NULL, 'SH3 domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(73289, NULL, 'G3DSA:3.30.40.10:FF:000175', NULL, NULL, 'Putative E3 ubiquitin-protein ligase MYLIP', NULL, NULL, NULL, NULL, NULL, 4),
(73290, NULL, 'G3DSA:3.40.50.620:FF:000374', NULL, NULL, 'Electron transfer flavoprotein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(73291, NULL, 'G3DSA:1.20.1250.20:FF:000034', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(73292, NULL, 'G3DSA:1.10.640.10:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73293, NULL, 'G3DSA:1.10.390.10:FF:000117', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(73294, NULL, 'G3DSA:3.30.160.60:FF:000816', NULL, NULL, 'myoneurin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(73295, NULL, 'G3DSA:1.25.10.10:FF:002995', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73296, NULL, 'G3DSA:1.10.287.2610:FF:000001', NULL, NULL, 'Chromosome segregation protein SMC', NULL, NULL, NULL, NULL, NULL, 4),
(73297, NULL, 'G3DSA:3.50.50.60:FF:000549', NULL, NULL, 'FAD binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(73298, NULL, 'G3DSA:1.10.10.10:FF:000898', NULL, NULL, 'Homologous-pairing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(73299, NULL, 'G3DSA:3.30.70.920:FF:000037', NULL, NULL, 'Transcriptional regulator, AsnC family', NULL, NULL, NULL, NULL, NULL, 4),
(73300, NULL, 'G3DSA:1.25.10.10:FF:000078', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(73301, NULL, 'G3DSA:2.60.220.50:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73302, NULL, 'G3DSA:3.40.640.10:FF:000319', NULL, NULL, 'Pyridoxamine--pyruvate transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(73303, NULL, 'G3DSA:3.90.810.10:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73304, NULL, 'G3DSA:3.30.565.10:FF:000186', NULL, NULL, 'Two-component system sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(73305, NULL, 'G3DSA:1.20.1070.10:FF:001731', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73306, NULL, 'G3DSA:1.10.510.10:FF:000223', NULL, NULL, 'probable receptor-like protein kinase At1g80640', NULL, NULL, NULL, NULL, NULL, 4),
(73307, NULL, 'G3DSA:2.20.100.10:FF:000040', NULL, NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 9', NULL, NULL, NULL, NULL, NULL, 4),
(73308, NULL, 'G3DSA:3.30.70.100:FF:000134', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73309, NULL, 'G3DSA:1.25.40.10:FF:001395', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g53700, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(73310, NULL, 'G3DSA:3.30.70.330:FF:002344', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73311, NULL, 'G3DSA:1.10.510.10:FF:002595', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73312, NULL, 'G3DSA:3.30.70.1660:FF:000018', NULL, NULL, 'Mitochondrial translation release factor', NULL, NULL, NULL, NULL, NULL, 4),
(73313, NULL, 'G3DSA:1.20.1560.10:FF:000515', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73314, NULL, 'G3DSA:3.10.180.10:FF:000015', NULL, NULL, 'Metallothiol transferase FosB', NULL, NULL, NULL, NULL, NULL, 4),
(73315, NULL, 'G3DSA:3.20.20.80:FF:000493', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73316, NULL, 'G3DSA:3.30.200.20:FF:002287', NULL, NULL, 'CDPK-related kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(73317, NULL, 'G3DSA:1.25.40.10:FF:003295', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(73318, NULL, 'G3DSA:3.20.20.80:FF:000830', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(73319, NULL, 'G3DSA:1.10.510.10:FF:000695', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(73320, NULL, 'G3DSA:2.170.300.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73321, NULL, 'G3DSA:2.130.10.10:FF:005325', NULL, NULL, 'Protein rigor mortis', NULL, NULL, NULL, NULL, NULL, 4),
(73322, NULL, 'G3DSA:1.25.10.10:FF:002848', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73323, NULL, 'G3DSA:1.20.5.110:FF:000160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73324, NULL, 'G3DSA:3.30.160.60:FF:000024', NULL, NULL, 'zinc finger protein 140 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(73325, NULL, 'G3DSA:3.30.70.330:FF:001838', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73326, NULL, 'G3DSA:3.90.660.10:FF:000096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73327, NULL, 'G3DSA:3.40.50.970:FF:000118', NULL, NULL, 'Indolepyruvate oxidoreductase subunit IorA', NULL, NULL, NULL, NULL, NULL, 4),
(73328, NULL, 'G3DSA:1.10.287.70:FF:000704', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73329, NULL, 'G3DSA:2.60.40.10:FF:001648', NULL, NULL, 'Immunoglobulin heavy variable 4-3', NULL, NULL, NULL, NULL, NULL, 4),
(73330, NULL, 'G3DSA:2.30.29.170:FF:000002', NULL, NULL, 'EF-hand domain (C-terminal) containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(73331, NULL, 'G3DSA:3.40.50.720:FF:001567', NULL, NULL, 'Probable oxidoreductase (Short-chain dehydrogenase family)', NULL, NULL, NULL, NULL, NULL, 4),
(73332, NULL, 'G3DSA:3.80.10.10:FF:003976', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73333, NULL, 'G3DSA:2.40.330.10:FF:000007', NULL, NULL, 'AP2/ERF and B3 domain-containing transcription factor RAV1', NULL, NULL, NULL, NULL, NULL, 4),
(73334, NULL, 'G3DSA:3.30.40.10:FF:002018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(73335, NULL, 'G3DSA:1.20.120.1240:FF:000009', NULL, NULL, 'Dynamin-related protein 1C', NULL, NULL, NULL, NULL, NULL, 4),
(73336, NULL, 'G3DSA:3.30.160.60:FF:002716', NULL, NULL, 'Zinc finger protein 212', NULL, NULL, NULL, NULL, NULL, 4),
(73337, NULL, 'G3DSA:3.30.2350.10:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73338, NULL, 'G3DSA:1.20.1260.10:FF:000003', NULL, NULL, 'DNA protection during starvation protein', NULL, NULL, NULL, NULL, NULL, 4),
(73339, NULL, 'G3DSA:1.10.1410.10:FF:000029', NULL, NULL, 'Poly(A) RNA polymerase gld-4', NULL, NULL, NULL, NULL, NULL, 4),
(73340, NULL, 'G3DSA:3.90.640.10:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73341, NULL, 'G3DSA:3.40.50.2300:FF:000152', NULL, NULL, 'G protein-coupled receptor class C group 6 member A', NULL, NULL, NULL, NULL, NULL, 4),
(73342, NULL, 'G3DSA:1.25.40.20:FF:000116', NULL, NULL, 'Ankyrin repeat and FYVE domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(73343, NULL, 'G3DSA:3.40.140.10:FF:000197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73344, NULL, 'G3DSA:2.30.140.10:FF:000006', NULL, NULL, 'thermospermine synthase ACAULIS5', NULL, NULL, NULL, NULL, NULL, 4),
(73345, NULL, 'G3DSA:3.40.1370.10:FF:000011', NULL, NULL, '50S ribosomal protein L4', NULL, NULL, NULL, NULL, NULL, 4),
(73346, NULL, 'G3DSA:2.20.100.10:FF:000068', NULL, NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 9', NULL, NULL, NULL, NULL, NULL, 4),
(73347, NULL, 'G3DSA:2.60.120.380:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73348, NULL, 'G3DSA:3.30.160.20:FF:000119', NULL, NULL, 'R2D2', NULL, NULL, NULL, NULL, NULL, 4),
(73349, NULL, 'G3DSA:1.25.40.180:FF:000143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73350, NULL, 'G3DSA:1.10.150.120:FF:000012', NULL, NULL, 'Xanthine dehydrogenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(73351, NULL, 'G3DSA:3.30.160.60:FF:001435', NULL, NULL, 'zinc finger protein 777', NULL, NULL, NULL, NULL, NULL, 4),
(73352, NULL, 'G3DSA:1.20.58.90:FF:000020', NULL, NULL, 'RalA-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(73353, NULL, 'G3DSA:1.25.40.10:FF:002676', NULL, NULL, 'N-ethylmaleimide-sensitive factor attachment protein, beta b', NULL, NULL, NULL, NULL, NULL, 4),
(73354, NULL, 'G3DSA:4.10.410.20:FF:000016', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(73355, NULL, 'G3DSA:3.40.50.10810:FF:000096', NULL, NULL, 'Helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(73356, NULL, 'G3DSA:1.25.40.10:FF:005138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73357, NULL, 'G3DSA:3.40.50.2000:FF:000522', NULL, NULL, 'Scopoletin glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(73358, NULL, 'G3DSA:3.30.200.20:FF:002416', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73359, NULL, 'G3DSA:1.10.8.10:FF:000110', NULL, NULL, 'NEDD8 ultimate buster 1', NULL, NULL, NULL, NULL, NULL, 4),
(73360, NULL, 'G3DSA:3.30.1370.170:FF:000001', NULL, NULL, 'Erythronate-4-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(73361, NULL, 'G3DSA:2.40.270.10:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73362, NULL, 'G3DSA:3.30.160.60:FF:002233', NULL, NULL, 'transcription factor E4F1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(73363, NULL, 'G3DSA:1.25.40.20:FF:000779', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73364, NULL, 'G3DSA:3.50.50.60:FF:001038', NULL, NULL, 'Rab proteins geranylgeranyltransferase component A', NULL, NULL, NULL, NULL, NULL, 4),
(73365, NULL, 'G3DSA:1.10.630.10:FF:000272', NULL, NULL, 'Cytochrome P450 oxidoreductase GliF', NULL, NULL, NULL, NULL, NULL, 4),
(73366, NULL, 'G3DSA:3.80.10.10:FF:002548', NULL, NULL, 'Putative serine/threonine-protein kinase pats1', NULL, NULL, NULL, NULL, NULL, 4),
(73367, NULL, 'G3DSA:3.40.50.1010:FF:000208', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73368, NULL, 'G3DSA:3.40.50.1000:FF:000559', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(73369, NULL, 'G3DSA:3.30.2410.10:FF:000001', NULL, NULL, 'E3 ubiquitin-protein ligase NEDD4-like', NULL, NULL, NULL, NULL, NULL, 4),
(73370, NULL, 'G3DSA:3.20.20.105:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73371, NULL, 'G3DSA:1.20.5.710:FF:000013', NULL, NULL, '54S ribosomal protein L12, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(73372, NULL, 'G3DSA:1.20.1420.10:FF:000005', NULL, NULL, 'Talin 2', NULL, NULL, NULL, NULL, NULL, 4),
(73373, NULL, 'G3DSA:2.40.70.10:FF:000488', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73374, NULL, 'G3DSA:2.60.40.10:FF:002284', NULL, NULL, 'Twitchin', NULL, NULL, NULL, NULL, NULL, 4),
(73375, NULL, 'G3DSA:3.80.10.10:FF:003959', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73376, NULL, 'G3DSA:3.40.50.2000:FF:000961', NULL, NULL, 'UDP-glycosyltransferase 73C5', NULL, NULL, NULL, NULL, NULL, 4),
(73377, NULL, 'G3DSA:3.60.130.10:FF:000046', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(73378, NULL, 'G3DSA:2.60.120.10:FF:000190', NULL, NULL, 'Cysteine dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(73379, NULL, 'G3DSA:3.40.50.720:FF:002073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73380, NULL, 'G3DSA:3.30.465.10:FF:000122', NULL, NULL, 'D-lactate dehydrogenase [cytochrome] mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(73381, NULL, 'G3DSA:3.30.200.20:FF:000207', NULL, NULL, 'proline-rich receptor-like protein kinase PERK1', NULL, NULL, NULL, NULL, NULL, 4),
(73382, NULL, 'G3DSA:1.10.10.10:FF:001387', NULL, NULL, 'Ets variant 1', NULL, NULL, NULL, NULL, NULL, 4),
(73383, NULL, 'G3DSA:3.30.160.60:FF:001744', NULL, NULL, 'Zinc finger protein 425', NULL, NULL, NULL, NULL, NULL, 4),
(73384, NULL, 'G3DSA:1.10.533.10:FF:000259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73385, NULL, 'G3DSA:3.40.720.10:FF:000163', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(73386, NULL, 'G3DSA:3.30.559.30:FF:000003', NULL, NULL, 'Nonribosomal peptide synthase SidD', NULL, NULL, NULL, NULL, NULL, 4),
(73387, NULL, 'G3DSA:1.25.40.20:FF:000908', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73388, NULL, 'G3DSA:1.10.238.10:FF:001051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73389, NULL, 'G3DSA:3.30.1940.10:FF:000001', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(73390, NULL, 'G3DSA:3.30.160.60:FF:001305', NULL, NULL, 'Zinc finger protein 48', NULL, NULL, NULL, NULL, NULL, 4),
(73391, NULL, 'G3DSA:3.80.10.10:FF:004448', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(73392, NULL, 'G3DSA:1.20.1250.20:FF:002203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73393, NULL, 'G3DSA:1.25.40.10:FF:002367', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g42920, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(73394, NULL, 'G3DSA:1.25.40.10:FF:001878', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(73395, NULL, 'G3DSA:3.90.1750.10:FF:000001', NULL, NULL, 'E3 ubiquitin-protein ligase NEDD4-like', NULL, NULL, NULL, NULL, NULL, 4),
(73396, NULL, 'G3DSA:3.30.70.330:FF:002783', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73397, NULL, 'G3DSA:2.10.25.10:FF:000396', NULL, NULL, 'matrilin-2 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(73398, NULL, 'G3DSA:3.65.10.20:FF:000030', NULL, NULL, 'RNA 3''-terminal phosphate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(73399, NULL, 'G3DSA:1.25.40.20:FF:001527', NULL, NULL, 'Protein 21.1', NULL, NULL, NULL, NULL, NULL, 4),
(73400, NULL, 'G3DSA:3.80.10.10:FF:003829', NULL, NULL, 'Receptor like protein 28', NULL, NULL, NULL, NULL, NULL, 4),
(73401, NULL, 'G3DSA:3.30.40.10:FF:002092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73402, NULL, 'G3DSA:2.40.30.70:FF:000014', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(73403, NULL, 'G3DSA:1.10.260.100:FF:000003', NULL, NULL, 'Ubiquilin 1', NULL, NULL, NULL, NULL, NULL, 4),
(73404, NULL, 'G3DSA:3.30.200.20:FF:002107', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(73405, NULL, 'G3DSA:3.20.20.70:FF:000164', NULL, NULL, '23S rRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(73406, NULL, 'G3DSA:3.80.10.10:FF:002211', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(73407, NULL, 'G3DSA:1.10.555.10:FF:000012', NULL, NULL, 'Putative inositol polyphosphate 5-phosphatase OCRL-1', NULL, NULL, NULL, NULL, NULL, 4),
(73408, NULL, 'G3DSA:3.40.5.10:FF:000009', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(73409, NULL, 'G3DSA:3.30.2320.80:FF:000003', NULL, NULL, 'Hydrogenase maturation factor HypA', NULL, NULL, NULL, NULL, NULL, 4),
(73410, NULL, 'G3DSA:1.10.760.10:FF:000062', NULL, NULL, 'Cytochrome c family protein', NULL, NULL, NULL, NULL, NULL, 4),
(73411, NULL, 'G3DSA:1.25.40.10:FF:001215', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(73412, NULL, 'G3DSA:3.40.220.10:FF:000018', NULL, NULL, 'Protein-ADP-ribose hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(73413, NULL, 'G3DSA:3.30.2140.20:FF:000011', NULL, NULL, 'Arylamine N-acetyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(73414, NULL, 'G3DSA:3.10.20.90:FF:000491', NULL, NULL, 'WGS project CABT00000000 data, contig 2.11', NULL, NULL, NULL, NULL, NULL, 4),
(73415, NULL, 'G3DSA:3.15.10.30:FF:000001', NULL, NULL, 'Takeout-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(73416, NULL, 'G3DSA:3.30.420.140:FF:000006', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(73417, NULL, 'G3DSA:1.10.3210.10:FF:000048', NULL, NULL, 'Diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(73418, NULL, 'G3DSA:3.10.100.10:FF:000139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73419, NULL, 'G3DSA:2.60.40.10:FF:004745', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73420, NULL, 'G3DSA:2.60.40.150:FF:000466', NULL, NULL, 'Copine III', NULL, NULL, NULL, NULL, NULL, 4),
(73421, NULL, 'G3DSA:3.10.580.10:FF:000107', NULL, NULL, 'Putative CBS domains protein', NULL, NULL, NULL, NULL, NULL, 4),
(73422, NULL, 'G3DSA:2.60.40.3310:FF:000001', NULL, NULL, 'Hypothetical fimbrial subunit', NULL, NULL, NULL, NULL, NULL, 4),
(73423, NULL, 'G3DSA:3.40.30.10:FF:000606', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(73424, NULL, 'G3DSA:1.20.58.60:FF:000814', NULL, NULL, 'Titin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(73425, NULL, 'G3DSA:1.50.40.10:FF:000297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73426, NULL, 'G3DSA:3.30.160.60:FF:005330', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73427, NULL, 'G3DSA:2.60.40.10:FF:005690', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73428, NULL, 'G3DSA:1.25.40.180:FF:000013', NULL, NULL, 'Nuclear cap-binding protein subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(73429, NULL, 'G3DSA:2.30.30.100:FF:000124', NULL, NULL, 'Small nuclear ribonucleoprotein Sm D2', NULL, NULL, NULL, NULL, NULL, 4),
(73430, NULL, 'G3DSA:3.40.50.300:FF:004892', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(73431, NULL, 'G3DSA:2.40.20.10:FF:000086', NULL, NULL, 'Plasminogen', NULL, NULL, NULL, NULL, NULL, 4),
(73432, NULL, 'G3DSA:3.40.190.10:FF:000700', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73433, NULL, 'G3DSA:1.25.40.10:FF:004621', NULL, NULL, 'Intraflagellar transport protein 56', NULL, NULL, NULL, NULL, NULL, 4),
(73434, NULL, 'G3DSA:1.25.40.10:FF:005110', NULL, NULL, 'Clustered mitochondria protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(73435, NULL, 'G3DSA:2.20.70.10:FF:000270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73436, NULL, 'G3DSA:1.20.1280.290:FF:000052', NULL, NULL, 'Sugar transporter SWEET', NULL, NULL, NULL, NULL, NULL, 4),
(73437, NULL, 'G3DSA:3.40.190.10:FF:000728', NULL, NULL, 'Ionotropic receptor 7a', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(73438, NULL, 'G3DSA:3.40.50.1220:FF:000024', NULL, NULL, '2-hydroxyacyl-CoA lyase', NULL, NULL, NULL, NULL, NULL, 4),
(73439, NULL, 'G3DSA:1.25.50.20:FF:000061', NULL, NULL, 'Aminopeptidase A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(73440, NULL, 'G3DSA:1.20.58.1610:FF:000006', NULL, NULL, 'NADH-ubiquinone oxidoreductase chain 3', NULL, NULL, NULL, NULL, NULL, 4),
(73441, NULL, 'G3DSA:3.30.40.10:FF:000192', NULL, NULL, 'G2/M phase-specific E3 ubiquitin-protein ligase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(73442, NULL, 'G3DSA:1.10.418.10:FF:000188', NULL, NULL, 'Zgc:66426', NULL, NULL, NULL, NULL, NULL, 4),
(73443, NULL, 'G3DSA:3.40.50.720:FF:000948', NULL, NULL, 'Probable 2-hydroxyacid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(73444, NULL, 'G3DSA:1.10.472.10:FF:000589', NULL, NULL, 'Os03g0392000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(73445, NULL, 'G3DSA:3.30.160.60:FF:004841', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73446, NULL, 'G3DSA:3.30.300.130:FF:000005', NULL, NULL, 'Mitotic spindle-associated mmxd complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(73447, NULL, 'G3DSA:3.40.50.2000:FF:000652', NULL, NULL, 'UDP-glucosyltransferase 74AE2', NULL, NULL, NULL, NULL, NULL, 4),
(73448, NULL, 'G3DSA:2.60.20.10:FF:000012', NULL, NULL, 'Beta-crystallin A2', NULL, NULL, NULL, NULL, NULL, 4),
(73449, NULL, 'G3DSA:3.40.50.1000:FF:000661', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73450, NULL, 'G3DSA:3.40.50.150:FF:001351', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73451, NULL, 'G3DSA:3.40.50.410:FF:000327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73452, NULL, 'G3DSA:1.10.287.3080:FF:000001', NULL, NULL, 'Cytochrome c-552', NULL, NULL, NULL, NULL, NULL, 4),
(73453, NULL, 'G3DSA:3.30.70.1620:FF:000001', NULL, NULL, 'Structural maintenance of chromosomes 1B', NULL, NULL, NULL, NULL, NULL, 4),
(73454, NULL, 'G3DSA:2.60.40.10:FF:003464', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73455, NULL, 'G3DSA:2.60.40.150:FF:000819', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73456, NULL, 'G3DSA:1.20.120.310:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73457, NULL, 'G3DSA:1.25.40.820:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73458, NULL, 'G3DSA:1.10.287.70:FF:000384', NULL, NULL, 'Potassium intermediate/small conductance calcium-activated channel, subfamily N, member 4', NULL, NULL, NULL, NULL, NULL, 4),
(73459, NULL, 'G3DSA:2.130.10.10:FF:004577', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73460, NULL, 'G3DSA:3.40.50.510:FF:000003', NULL, NULL, 'PTS-dependent dihydroxyacetone kinase phosphotransferase subunit DhaM', NULL, NULL, NULL, NULL, NULL, 4),
(73461, NULL, 'G3DSA:3.30.700.30:FF:000001', NULL, NULL, 'Propionyl-CoA carboxylase alpha chain, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(73462, NULL, 'G3DSA:3.20.20.190:FF:000041', NULL, NULL, 'Glycerophosphocholine phosphodiesterase GPCPD1', NULL, NULL, NULL, NULL, NULL, 4),
(73463, NULL, 'G3DSA:3.40.190.80:FF:000013', NULL, NULL, 'Inositol monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(73464, NULL, 'G3DSA:3.30.70.330:FF:002327', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73465, NULL, 'G3DSA:1.20.1440.50:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73466, NULL, 'G3DSA:1.10.10.440:FF:000096', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(73467, NULL, 'G3DSA:2.60.120.590:FF:000028', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(73468, NULL, 'G3DSA:2.60.200.20:FF:000238', NULL, NULL, 'Type III export protein PscD', NULL, NULL, NULL, NULL, NULL, 4),
(73469, NULL, 'G3DSA:3.30.1300.30:FF:000004', NULL, NULL, 'Adhesin', NULL, NULL, NULL, NULL, NULL, 4),
(73470, NULL, 'G3DSA:3.40.50.2000:FF:000730', NULL, NULL, 'OSJNBa0052O21.10 protein', NULL, NULL, NULL, NULL, NULL, 4),
(73471, NULL, 'G3DSA:1.25.40.570:FF:000018', NULL, NULL, '26S proteasome non-ATPase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(73472, NULL, 'G3DSA:3.10.20.70:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73473, NULL, 'G3DSA:2.70.20.10:FF:000034', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(73474, NULL, 'G3DSA:3.30.450.20:FF:000681', NULL, NULL, 'Blr6052 protein', NULL, NULL, NULL, NULL, NULL, 4),
(73475, NULL, 'G3DSA:3.40.50.300:FF:007629', NULL, NULL, 'Uncharacterized protein YfjK', NULL, NULL, NULL, NULL, NULL, 4),
(73476, NULL, 'G3DSA:2.100.10.40:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73477, NULL, 'G3DSA:1.20.120.1750:FF:000056', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(73478, NULL, 'G3DSA:3.30.160.60:FF:005667', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73479, NULL, 'G3DSA:3.40.1280.10:FF:000004', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase H', NULL, NULL, NULL, NULL, NULL, 4),
(73480, NULL, 'G3DSA:1.20.1070.10:FF:000612', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(73481, NULL, 'G3DSA:3.40.50.360:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73482, NULL, 'G3DSA:3.30.1330.30:FF:000040', NULL, NULL, 'SECIS-binding protein 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(73483, NULL, 'G3DSA:2.40.10.10:FF:000692', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73484, NULL, 'G3DSA:2.130.10.10:FF:000199', NULL, NULL, 'autophagy-related protein 16-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(73485, NULL, 'G3DSA:3.40.50.300:FF:000749', NULL, NULL, 'probable ATP-dependent RNA helicase DHX37', NULL, NULL, NULL, NULL, NULL, 4),
(73486, NULL, 'G3DSA:1.20.1070.10:FF:001231', NULL, NULL, 'Corticotropin releasing hormone receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(73487, NULL, 'G3DSA:1.25.40.120:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73488, NULL, 'G3DSA:1.25.10.10:FF:002787', NULL, NULL, 'Tetratricopeptide repeat protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(73489, NULL, 'G3DSA:3.40.50.300:FF:004448', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(73490, NULL, 'G3DSA:3.40.50.2300:FF:000713', NULL, NULL, 'Ribose ABC transporter, periplasmic ribose-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(73491, NULL, 'G3DSA:3.10.110.10:FF:000376', NULL, NULL, 'RWD domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(73492, NULL, 'G3DSA:1.25.40.20:FF:001735', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73493, NULL, 'G3DSA:2.60.120.860:FF:000002', NULL, NULL, 'Distal tail protein', NULL, NULL, NULL, NULL, NULL, 4),
(73494, NULL, 'G3DSA:3.60.10.10:FF:000352', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73495, NULL, 'G3DSA:3.40.50.10190:FF:000342', NULL, NULL, 'S-M checkpoint control protein rad4', NULL, NULL, NULL, NULL, NULL, 4),
(73496, NULL, 'G3DSA:3.30.1780.10:FF:000011', NULL, NULL, 'Ornithine cyclodeaminase', NULL, NULL, NULL, NULL, NULL, 4),
(73497, NULL, 'G3DSA:3.30.420.270:FF:000017', NULL, NULL, 'Tol-Pal system protein TolR', NULL, NULL, NULL, NULL, NULL, 4),
(73498, NULL, 'G3DSA:1.10.8.10:FF:000341', NULL, NULL, 'Ubiquilin 4', NULL, NULL, NULL, NULL, NULL, 4),
(73499, NULL, 'G3DSA:4.10.60.10:FF:000181', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(73500, NULL, 'G3DSA:1.10.472.80:FF:000109', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(73501, NULL, 'G3DSA:3.30.750.44:FF:000001', NULL, NULL, 'S41 family peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(73502, NULL, 'G3DSA:3.30.200.20:FF:000281', NULL, NULL, 'Mitogen-activated protein kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(73503, NULL, 'G3DSA:2.120.10.80:FF:000416', NULL, NULL, 'Kelch like ECH associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(73504, NULL, 'G3DSA:2.120.10.80:FF:000372', NULL, NULL, 'Tip elongation aberrant protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(73505, NULL, 'G3DSA:3.90.1750.20:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(73506, NULL, 'G3DSA:3.10.100.10:FF:000347', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73507, NULL, 'G3DSA:1.25.40.90:FF:000064', NULL, NULL, 'Regulation of nuclear pre-mRNA domain-containing protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(73508, NULL, 'G3DSA:2.60.40.10:FF:005229', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73509, NULL, 'G3DSA:1.10.10.10:FF:000870', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(73510, NULL, 'G3DSA:3.40.1690.20:FF:000027', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(73511, NULL, 'G3DSA:3.30.160.60:FF:004150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73512, NULL, 'G3DSA:3.20.20.140:FF:000020', NULL, NULL, 'Adenosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(73513, NULL, 'G3DSA:3.40.50.720:FF:001937', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73514, NULL, 'G3DSA:1.20.58.60:FF:000606', NULL, NULL, 'Dystonin', NULL, NULL, NULL, NULL, NULL, 4),
(73515, NULL, 'G3DSA:2.30.30.140:FF:000024', NULL, NULL, 'Mortality factor 4-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(73516, NULL, 'G3DSA:3.30.70.1230:FF:000007', NULL, NULL, 'Guanylate cyclase soluble subunit alpha-3', NULL, NULL, NULL, NULL, NULL, 4),
(73517, NULL, 'G3DSA:2.60.120.620:FF:000161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73518, NULL, 'G3DSA:3.40.50.2300:FF:000814', NULL, NULL, 'Vomeronasal 2, receptor 73', NULL, NULL, NULL, NULL, NULL, 4),
(73519, NULL, 'G3DSA:1.20.1250.20:FF:001815', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(73520, NULL, 'G3DSA:2.40.50.90:FF:000100', NULL, NULL, 'Putative ATP-dependent RNA helicase TDRD12', NULL, NULL, NULL, NULL, NULL, 4),
(73521, NULL, 'G3DSA:3.40.50.150:FF:001508', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73522, NULL, 'G3DSA:2.60.40.10:FF:002845', NULL, NULL, 'Macrophage stimulating 1 receptor a', NULL, NULL, NULL, NULL, NULL, 4),
(73523, NULL, 'G3DSA:3.40.850.10:FF:000392', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73524, NULL, 'G3DSA:1.20.1300.10:FF:000030', NULL, NULL, 'Succinate dehydrogenase/fumarate reductase, cytochrome b558 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(73525, NULL, 'G3DSA:3.30.1240.10:FF:000055', NULL, NULL, 'Cof-type HAD-IIB family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(73526, NULL, 'G3DSA:3.40.80.10:FF:000025', NULL, NULL, 'Peptidoglycan-recognition protein LD', NULL, NULL, NULL, NULL, NULL, 4),
(73527, NULL, 'G3DSA:3.40.50.1820:FF:001744', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73528, NULL, 'G3DSA:1.10.10.60:FF:001071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73529, NULL, 'G3DSA:1.25.40.550:FF:000012', NULL, NULL, 'protein AAR2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(73530, NULL, 'G3DSA:3.90.550.10:FF:000003', NULL, NULL, '2-C-methyl-D-erythritol 4-phosphate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(73531, NULL, 'G3DSA:3.50.50.60:FF:000521', NULL, NULL, 'FAD dependent oxidoreductase domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(73532, NULL, 'G3DSA:1.20.58.60:FF:000022', NULL, NULL, 'Microtubule-actin cross-linking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(73533, NULL, 'G3DSA:2.60.120.200:FF:000271', NULL, NULL, 'Laminin alpha 5', NULL, NULL, NULL, NULL, NULL, 4),
(73534, NULL, 'G3DSA:2.30.39.10:FF:000056', NULL, NULL, 'leukocyte elastase inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(73535, NULL, 'G3DSA:1.20.1070.10:FF:001276', NULL, NULL, 'GPR insulin like receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(73536, NULL, 'G3DSA:3.40.50.11660:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73537, NULL, 'G3DSA:3.40.50.11610:FF:000015', NULL, NULL, 'Putative 2-oxoglutarate dehydrogenase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(73538, NULL, 'G3DSA:3.10.450.50:FF:000076', NULL, NULL, 'Nuclear pore RNA shuttling protein Mtr2', NULL, NULL, NULL, NULL, NULL, 4),
(73539, NULL, 'G3DSA:3.40.50.12610:FF:000006', NULL, NULL, 'Dolichyl-phosphooligosaccharide-protein glycotransferase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(73540, NULL, 'G3DSA:3.30.559.10:FF:000048', NULL, NULL, 'Nonribosomal peptide synthase inpB', NULL, NULL, NULL, NULL, NULL, 4),
(73541, NULL, 'G3DSA:2.40.50.140:FF:000099', NULL, NULL, 'Ribosomal protein S12, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(73542, NULL, 'G3DSA:3.30.390.30:FF:000049', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(73543, NULL, 'G3DSA:3.90.1230.10:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73544, NULL, 'G3DSA:3.40.1380.20:FF:000060', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(73545, NULL, 'G3DSA:3.80.10.10:FF:001694', NULL, NULL, 'F-box/LRR-repeat protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(73546, NULL, 'G3DSA:1.25.10.10:FF:000269', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(73547, NULL, 'G3DSA:3.30.40.10:FF:001529', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(73548, NULL, 'G3DSA:3.90.70.10:FF:000781', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73549, NULL, 'G3DSA:3.40.50.970:FF:000220', NULL, NULL, '2-oxoisovalerate dehydrogenase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(73550, NULL, 'G3DSA:3.40.50.2300:FF:001433', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73551, NULL, 'G3DSA:1.10.510.10:FF:003096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73552, NULL, 'G3DSA:3.40.50.800:FF:000085', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(73553, NULL, 'G3DSA:1.20.1250.20:FF:000489', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(73554, NULL, 'G3DSA:1.10.287.70:FF:000176', NULL, NULL, 'Potassium channel subfamily K member 9', NULL, NULL, NULL, NULL, NULL, 4),
(73555, NULL, 'G3DSA:3.40.50.720:FF:002556', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73556, NULL, 'G3DSA:2.10.25.10:FF:000216', NULL, NULL, 'Adhesion G protein-coupled receptor E2', NULL, NULL, NULL, NULL, NULL, 4),
(73557, NULL, 'G3DSA:2.130.10.10:FF:000463', NULL, NULL, 'intraflagellar transport protein 80 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(73558, NULL, 'G3DSA:1.20.1250.20:FF:001231', NULL, NULL, 'Autophagy-related protein 22-1', NULL, NULL, NULL, NULL, NULL, 4),
(73559, NULL, 'G3DSA:2.130.10.10:FF:001143', NULL, NULL, 'Pre-mRNA-splicing factor rse-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(73560, NULL, 'G3DSA:1.10.472.80:FF:000020', NULL, NULL, 'TBC1 domain family, member 16', NULL, NULL, NULL, NULL, NULL, 4),
(73561, NULL, 'G3DSA:1.10.630.10:FF:000142', NULL, NULL, 'Mycocyclosin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(73562, NULL, 'G3DSA:3.40.50.1970:FF:000030', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(73563, NULL, 'G3DSA:2.40.30.170:FF:000064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73564, NULL, 'G3DSA:3.40.190.10:FF:000245', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(73565, NULL, 'G3DSA:3.40.390.10:FF:000018', NULL, NULL, 'Metalloendoproteinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(73566, NULL, 'G3DSA:2.130.10.10:FF:001188', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(73567, NULL, 'G3DSA:1.20.1250.20:FF:000725', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73568, NULL, 'G3DSA:3.30.160.60:FF:006286', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73569, NULL, 'G3DSA:3.40.190.10:FF:000829', NULL, NULL, 'Phosphate-binding protein PstS', NULL, NULL, NULL, NULL, NULL, 4),
(73570, NULL, 'G3DSA:2.40.170.20:FF:000110', NULL, NULL, 'TonB-dependent receptor SusC', NULL, NULL, NULL, NULL, NULL, 4),
(73571, NULL, 'G3DSA:2.40.50.140:FF:000863', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73572, NULL, 'G3DSA:1.10.472.10:FF:000460', NULL, NULL, 'Cyclin, N-terminal domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(73573, NULL, 'G3DSA:3.40.50.300:FF:001014', NULL, NULL, 'Torsin', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(73574, NULL, 'G3DSA:3.40.1190.20:FF:000034', NULL, NULL, 'Putative hydroxymethylpyrimidine/ phosphomethylpyrimidine kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(73575, NULL, 'G3DSA:3.40.190.10:FF:000672', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73576, NULL, 'G3DSA:3.40.50.300:FF:006909', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73577, NULL, 'G3DSA:2.30.42.10:FF:000316', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73578, NULL, 'G3DSA:3.40.50.880:FF:000182', NULL, NULL, 'Imidazole glycerol phosphate synthase subunit HisH', NULL, NULL, NULL, NULL, NULL, 4),
(73579, NULL, 'G3DSA:1.10.10.60:FF:001177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73580, NULL, 'G3DSA:4.10.280.10:FF:000204', NULL, NULL, 'Neuronal stem cell leukemia 2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(73581, NULL, 'G3DSA:3.30.70.270:FF:000050', NULL, NULL, 'DNA repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(73582, NULL, 'G3DSA:3.60.10.10:FF:000121', NULL, NULL, 'Cytolethal distending toxin B subunit', NULL, NULL, NULL, NULL, NULL, 4),
(73583, NULL, 'G3DSA:2.20.28.10:FF:000014', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(73584, NULL, 'G3DSA:1.10.730.10:FF:000234', NULL, NULL, 'Methionine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(73585, NULL, 'G3DSA:3.90.920.10:FF:000015', NULL, NULL, 'DNA primase small subunit PriS', NULL, NULL, NULL, NULL, NULL, 4),
(73586, NULL, 'G3DSA:3.40.50.300:FF:005067', NULL, NULL, 'ADP ribosylation factor', NULL, NULL, NULL, NULL, NULL, 4),
(73587, NULL, 'G3DSA:3.40.50.10490:FF:000050', NULL, NULL, 'Related to MRP4-mitochondrial ribosomal protein, small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(73588, NULL, 'G3DSA:3.90.76.10:FF:000013', NULL, NULL, 'Putative lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(73589, NULL, 'G3DSA:3.90.1170.50:FF:000024', NULL, NULL, 'Aerobic-type carbon monoxide dehydrogenase, large subunit-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(73590, NULL, 'G3DSA:1.10.418.10:FF:000216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73591, NULL, 'G3DSA:3.40.50.620:FF:000166', NULL, NULL, 'Electron transfer flavoprotein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(73592, NULL, 'G3DSA:1.10.287.70:FF:000485', NULL, NULL, 'Calcium/potassium channel (CAKC), putative', NULL, NULL, NULL, NULL, NULL, 4),
(73593, NULL, 'G3DSA:3.30.1490.80:FF:000015', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(73594, NULL, 'G3DSA:1.50.10.10:FF:000205', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(73595, NULL, 'G3DSA:2.60.40.420:FF:000159', NULL, NULL, 'Auracyanin-B', NULL, NULL, NULL, NULL, NULL, 4),
(73596, NULL, 'G3DSA:1.25.40.10:FF:000361', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(73597, NULL, 'G3DSA:2.40.50.100:FF:000199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73598, NULL, 'G3DSA:3.30.160.60:FF:005931', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73599, NULL, 'G3DSA:1.10.510.10:FF:001443', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73600, NULL, 'G3DSA:3.40.50.10930:FF:000002', NULL, NULL, 'RecBCD enzyme subunit RecC', NULL, NULL, NULL, NULL, NULL, 4),
(73601, NULL, 'G3DSA:3.30.750.80:FF:000002', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase I', NULL, NULL, NULL, NULL, NULL, 4),
(73602, NULL, 'G3DSA:3.30.200.20:FF:002079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73603, NULL, 'G3DSA:1.20.1270.60:FF:000030', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(73604, NULL, 'G3DSA:1.20.1310.20:FF:000005', NULL, NULL, 'Erythrocyte-binding antigen 175', NULL, NULL, NULL, NULL, NULL, 4),
(73605, NULL, 'G3DSA:1.20.1730.10:FF:000006', NULL, NULL, 'Urea active transporter', NULL, NULL, NULL, NULL, NULL, 4),
(73606, NULL, 'G3DSA:1.10.510.10:FF:003904', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(73607, NULL, 'G3DSA:2.60.40.10:FF:000030', NULL, NULL, 'Semaphorin 3F like', NULL, NULL, NULL, NULL, NULL, 4),
(73608, NULL, 'G3DSA:2.130.10.10:FF:002924', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73609, NULL, 'G3DSA:1.10.510.10:FF:002123', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(73610, NULL, 'G3DSA:2.30.29.30:FF:000786', NULL, NULL, 'Ran-binding protein (RanBP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(73611, NULL, 'G3DSA:3.40.50.2300:FF:001006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73612, NULL, 'G3DSA:3.30.1330.60:FF:000037', NULL, NULL, 'Outer membrane porin F', NULL, NULL, NULL, NULL, NULL, 4),
(73613, NULL, 'G3DSA:3.80.10.10:FF:001267', NULL, NULL, 'Receptor-like protein 9DC2', NULL, NULL, NULL, NULL, NULL, 4),
(73614, NULL, 'G3DSA:3.40.50.300:FF:001469', NULL, NULL, 'Replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(73615, NULL, 'G3DSA:2.60.40.820:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73616, NULL, 'G3DSA:1.10.220.10:FF:000004', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(73617, NULL, 'G3DSA:1.20.140.10:FF:000052', NULL, NULL, 'Putative acyl-CoA dehydrogenase YdbM', NULL, NULL, NULL, NULL, NULL, 4),
(73618, NULL, 'G3DSA:2.60.40.60:FF:000876', NULL, NULL, 'E-cadherin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(73619, NULL, 'G3DSA:3.40.630.10:FF:000072', NULL, NULL, 'Aminoacyl-histidine dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(73620, NULL, 'G3DSA:1.10.486.10:FF:000059', NULL, NULL, 'ADR113Wp', NULL, NULL, NULL, NULL, NULL, 4),
(73621, NULL, 'G3DSA:1.20.1250.20:FF:000989', NULL, NULL, 'MFS sugar transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(73622, NULL, 'G3DSA:1.20.1510.10:FF:000012', NULL, NULL, 'Metal tolerance protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(73623, NULL, 'G3DSA:1.20.5.170:FF:000054', NULL, NULL, 'Cyclic AMP-responsive element-binding protein 3-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(73624, NULL, 'G3DSA:1.20.120.1080:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73625, NULL, 'G3DSA:3.60.40.10:FF:000180', NULL, NULL, 'Putative protein phosphatase 2C-like protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(73626, NULL, 'G3DSA:3.40.50.1820:FF:000108', NULL, NULL, 'Lipid particle protein', NULL, NULL, NULL, NULL, NULL, 4),
(73627, NULL, 'G3DSA:3.40.50.300:FF:000396', NULL, NULL, 'RNA helicase aquarius', NULL, NULL, NULL, NULL, NULL, 4),
(73628, NULL, 'G3DSA:1.25.40.10:FF:001187', NULL, NULL, 'Superkiller 3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(73629, NULL, 'G3DSA:1.10.10.60:FF:000452', NULL, NULL, 'Chromatin complexes subunit BAP18', NULL, NULL, NULL, NULL, NULL, 4),
(73630, NULL, 'G3DSA:3.20.10.10:FF:000016', NULL, NULL, 'Aminodeoxychorismate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(73631, NULL, 'G3DSA:3.40.50.1820:FF:000816', NULL, NULL, 'Gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(73632, NULL, 'G3DSA:1.20.80.10:FF:000059', NULL, NULL, 'Acyl-CoA binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(73633, NULL, 'G3DSA:3.30.420.40:FF:000859', NULL, NULL, 'Glucokinase (ROK family protein), conjectural', NULL, NULL, NULL, NULL, NULL, 4),
(73634, NULL, 'G3DSA:1.10.238.10:FF:001034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73635, NULL, 'G3DSA:2.60.40.60:FF:000449', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(73636, NULL, 'G3DSA:3.60.40.10:FF:000269', NULL, NULL, 'Phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(73637, NULL, 'G3DSA:2.130.10.10:FF:005903', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(73638, NULL, 'G3DSA:2.60.40.10:FF:003773', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73639, NULL, 'G3DSA:3.40.50.1370:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73640, NULL, 'G3DSA:2.10.220.10:FF:000040', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(73641, NULL, 'G3DSA:3.40.50.2000:FF:000421', NULL, NULL, 'GG16746', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(73642, NULL, 'G3DSA:2.40.30.10:FF:000367', NULL, NULL, '5-methyltetrahydrofolate-homocysteine methyltransferase reductase', NULL, NULL, NULL, NULL, NULL, 4),
(73643, NULL, 'G3DSA:3.30.40.10:FF:002148', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(73644, NULL, 'G3DSA:3.30.1330.40:FF:000031', NULL, NULL, '3-hydroxybenzoate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(73645, NULL, 'G3DSA:3.30.9.10:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73646, NULL, 'G3DSA:3.30.710.10:FF:000288', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(73647, NULL, 'G3DSA:1.10.533.10:FF:000130', NULL, NULL, 'Protein Tube', NULL, NULL, NULL, NULL, NULL, 4),
(73648, NULL, 'G3DSA:2.130.10.10:FF:000671', NULL, NULL, 'WD repeat containing, antisense to TP73', NULL, NULL, NULL, NULL, NULL, 4),
(73649, NULL, 'G3DSA:3.30.559.10:FF:000256', NULL, NULL, 'Peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(73650, NULL, 'G3DSA:1.10.510.10:FF:001504', NULL, NULL, 'Related to MAPKK kinase', NULL, NULL, NULL, NULL, NULL, 4),
(73651, NULL, 'G3DSA:2.60.40.10:FF:002492', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73652, NULL, 'G3DSA:1.10.1070.11:FF:000026', NULL, NULL, 'Phosphotransferases/inositol or phosphatidylinositol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(73653, NULL, 'G3DSA:2.60.40.10:FF:005010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73654, NULL, 'G3DSA:1.10.510.10:FF:000886', NULL, NULL, 'CK1 family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(73655, NULL, 'G3DSA:1.10.225.10:FF:000010', NULL, NULL, 'Sphingomyelin phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(73656, NULL, 'G3DSA:3.30.450.20:FF:000029', NULL, NULL, 'VWFA and cache domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(73657, NULL, 'G3DSA:2.120.10.80:FF:000063', NULL, NULL, 'Kelch-like protein 4 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(73658, NULL, 'G3DSA:2.60.40.10:FF:004392', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73659, NULL, 'G3DSA:1.25.40.20:FF:000807', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(73660, NULL, 'G3DSA:1.20.920.50:FF:000005', NULL, NULL, 'Salivary androgen-binding protein gamma subunit', NULL, NULL, NULL, NULL, NULL, 4),
(73661, NULL, 'G3DSA:2.60.40.1280:FF:000004', NULL, NULL, 'Fibronectin-binding protein A', NULL, NULL, NULL, NULL, NULL, 4),
(73662, NULL, 'G3DSA:2.30.29.30:FF:000022', NULL, NULL, 'Putative FERM domain-containing protein 4A', NULL, NULL, NULL, NULL, NULL, 4),
(73663, NULL, 'G3DSA:2.70.98.30:FF:000005', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(73664, NULL, 'G3DSA:3.30.420.10:FF:000041', NULL, NULL, 'Exonuclease 3''-5'' domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(73665, NULL, 'G3DSA:3.30.430.20:FF:000016', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 10', NULL, NULL, NULL, NULL, NULL, 4),
(73666, NULL, 'G3DSA:2.130.10.10:FF:002571', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73667, NULL, 'G3DSA:3.40.190.290:FF:000068', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(73668, NULL, 'G3DSA:1.10.287.370:FF:000053', NULL, NULL, 'Unconventional prefoldin RPB5 interactor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(73669, NULL, 'G3DSA:3.80.10.10:FF:003728', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73670, NULL, 'G3DSA:1.25.10.10:FF:000769', NULL, NULL, 'Importin beta-5 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(73671, NULL, 'G3DSA:1.10.8.270:FF:000125', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(73672, NULL, 'G3DSA:3.50.50.60:FF:000976', NULL, NULL, 'FAD/NAD(P)-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(73673, NULL, 'G3DSA:3.30.40.10:FF:001029', NULL, NULL, 'PHD transcription factor (Rum1), putative (AFU_orthologue AFUA_5G03430)', NULL, NULL, NULL, NULL, NULL, 4),
(73674, NULL, 'G3DSA:1.20.1280.50:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(73675, NULL, 'G3DSA:1.10.510.10:FF:003551', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73676, NULL, 'G3DSA:2.60.120.970:FF:000035', NULL, NULL, 'Dawdle, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(73677, NULL, 'G3DSA:3.40.50.300:FF:003723', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73678, NULL, 'G3DSA:2.30.29.30:FF:000685', NULL, NULL, 'Kinesin protein unc-104', NULL, NULL, NULL, NULL, NULL, 4),
(73679, NULL, 'G3DSA:3.40.50.720:FF:001376', NULL, NULL, 'Formate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(73680, NULL, 'G3DSA:3.10.270.10:FF:000005', NULL, NULL, 'Uricase', NULL, NULL, NULL, NULL, NULL, 4),
(73681, NULL, 'G3DSA:2.130.10.10:FF:003852', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73682, NULL, 'G3DSA:1.10.510.10:FF:001651', NULL, NULL, 'SRSF protein kinase 1a', NULL, NULL, NULL, NULL, NULL, 4),
(73683, NULL, 'G3DSA:3.90.70.80:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73684, NULL, 'G3DSA:2.10.25.10:FF:001694', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73685, NULL, 'G3DSA:1.25.40.710:FF:000004', NULL, NULL, 'Tripeptidyl-peptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(73686, NULL, 'G3DSA:3.30.70.1730:FF:000034', NULL, NULL, '50S ribosomal protein L10', NULL, NULL, NULL, NULL, NULL, 4),
(73687, NULL, 'G3DSA:3.30.10.20:FF:000013', NULL, NULL, 'Transmembrane serine/threonine-protein kinase B', NULL, NULL, NULL, NULL, NULL, 4),
(73688, NULL, 'G3DSA:3.20.20.70:FF:000501', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73689, NULL, 'G3DSA:3.40.50.800:FF:000012', NULL, NULL, 'Histidine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(73690, NULL, 'G3DSA:4.10.75.10:FF:000012', NULL, NULL, 'Protein Wfdc21', NULL, NULL, NULL, NULL, NULL, 4),
(73691, NULL, 'G3DSA:3.40.50.1000:FF:000189', NULL, NULL, 'Vegetative storage protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(73692, NULL, 'G3DSA:3.30.70.330:FF:001355', NULL, NULL, 'Unplaced genomic scaffold supercont2.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(73693, NULL, 'G3DSA:3.30.70.3490:FF:000005', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(73694, NULL, 'G3DSA:3.10.580.20:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73695, NULL, 'G3DSA:1.10.645.10:FF:000002', NULL, NULL, 'Hydrogenase 2 large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(73696, NULL, 'G3DSA:1.10.340.30:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73697, NULL, 'G3DSA:2.30.33.40:FF:000001', NULL, NULL, '10 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(73698, NULL, 'G3DSA:3.40.50.300:FF:002958', NULL, NULL, 'Endoribonuclease Dicer homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(73699, NULL, 'G3DSA:3.80.10.10:FF:000502', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(73700, NULL, 'G3DSA:3.40.390.10:FF:000226', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73701, NULL, 'G3DSA:3.60.90.10:FF:000008', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(73702, NULL, 'G3DSA:1.25.40.10:FF:002159', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(73703, NULL, 'G3DSA:1.10.10.10:FF:001842', NULL, NULL, 'DNA replication licensing factor, MCM2/3/5 family', NULL, NULL, NULL, NULL, NULL, 4),
(73704, NULL, 'G3DSA:3.90.20.20:FF:000039', NULL, NULL, 'Protein GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(73705, NULL, 'G3DSA:3.20.20.70:FF:000400', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73706, NULL, 'G3DSA:3.30.160.60:FF:001513', NULL, NULL, 'Zinc finger, C2H2 type', NULL, NULL, NULL, NULL, NULL, 4),
(73707, NULL, 'G3DSA:3.30.1050.10:FF:000017', NULL, NULL, 'Potential peroxisomal lipid carrier', NULL, NULL, NULL, NULL, NULL, 4),
(73708, NULL, 'G3DSA:3.30.160.60:FF:003222', NULL, NULL, 'Zinc finger protein 473', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(73709, NULL, 'G3DSA:1.25.40.10:FF:001423', NULL, NULL, 'TRP domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(73710, NULL, 'G3DSA:1.25.40.10:FF:004149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73711, NULL, 'G3DSA:3.80.10.10:FF:002195', NULL, NULL, 'Toll-like receptor 21', NULL, NULL, NULL, NULL, NULL, 4),
(73712, NULL, 'G3DSA:3.40.50.300:FF:001677', NULL, NULL, 'Bifunctional dethiobiotin synthetase/adenosylmethionine-8-amino-7-oxononanoate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(73713, NULL, 'G3DSA:3.30.160.60:FF:002132', NULL, NULL, 'Zinc finger protein 445', NULL, NULL, NULL, NULL, NULL, 4),
(73714, NULL, 'G3DSA:3.40.1620.10:FF:000003', NULL, NULL, 'Antitoxin', NULL, NULL, NULL, NULL, NULL, 4),
(73715, NULL, 'G3DSA:3.80.10.10:FF:000603', NULL, NULL, 'Gp150, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(73716, NULL, 'G3DSA:2.130.10.10:FF:001082', NULL, NULL, 'Protein CBR-SMP-1', NULL, NULL, NULL, NULL, NULL, 4),
(73717, NULL, 'G3DSA:3.10.100.10:FF:000095', NULL, NULL, 'Furrowed, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(73718, NULL, 'G3DSA:3.90.660.10:FF:000107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73719, NULL, 'G3DSA:1.10.287.70:FF:000693', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73720, NULL, 'G3DSA:3.20.20.60:FF:000043', NULL, NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(73721, NULL, 'G3DSA:3.30.70.330:FF:001254', NULL, NULL, 'HNRNPH1 isoform 19', NULL, NULL, NULL, NULL, NULL, 4),
(73722, NULL, 'G3DSA:1.10.540.10:FF:000051', NULL, NULL, 'Acyl-CoA dehydrogenase FadE34', NULL, NULL, NULL, NULL, NULL, 4),
(73723, NULL, 'G3DSA:1.10.10.60:FF:000660', NULL, NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily A member 5', NULL, NULL, NULL, NULL, NULL, 4),
(73724, NULL, 'G3DSA:3.40.50.1820:FF:000917', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(73725, NULL, 'G3DSA:2.60.40.10:FF:001064', NULL, NULL, 'Interleukin 1 receptor, type I', NULL, NULL, NULL, NULL, NULL, 4),
(73726, NULL, 'G3DSA:2.10.25.10:FF:001121', NULL, NULL, 'Protein eyes shut homolog', NULL, NULL, NULL, NULL, NULL, 4),
(73727, NULL, 'G3DSA:1.10.510.10:FF:002932', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73728, NULL, 'G3DSA:3.30.710.10:FF:000390', NULL, NULL, 'AGAP000475-PA', NULL, NULL, NULL, NULL, NULL, 4),
(73729, NULL, 'G3DSA:1.20.1560.10:FF:000942', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73730, NULL, 'G3DSA:3.10.400.20:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73731, NULL, 'G3DSA:4.10.400.10:FF:000041', NULL, NULL, 'Sortilin related receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(73732, NULL, 'G3DSA:1.20.5.170:FF:000262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73733, NULL, 'G3DSA:1.10.220.150:FF:000009', NULL, NULL, 'stromal membrane-associated protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(73734, NULL, 'G3DSA:3.50.50.100:FF:000047', NULL, NULL, 'Type-II NADH dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(73735, NULL, 'G3DSA:3.40.50.300:FF:003622', NULL, NULL, 'GTPase, IMAP family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(73736, NULL, 'G3DSA:3.40.50.1220:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73737, NULL, 'G3DSA:2.60.120.10:FF:000291', NULL, NULL, '5-deoxy-glucuronate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(73738, NULL, 'G3DSA:2.10.220.10:FF:000141', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(73739, NULL, 'G3DSA:3.90.780.10:FF:000026', NULL, NULL, 'Vacuolar protein', NULL, NULL, NULL, NULL, NULL, 4),
(73740, NULL, 'G3DSA:2.10.110.10:FF:000048', NULL, NULL, 'Four and a half LIM domains protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(73741, NULL, 'G3DSA:3.30.160.60:FF:006095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(73742, NULL, 'G3DSA:3.40.50.920:FF:000019', NULL, NULL, 'Sulfite reductase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(73743, NULL, 'G3DSA:3.40.50.1110:FF:000031', NULL, NULL, 'GDSL family lipase', NULL, NULL, NULL, NULL, NULL, 4),
(73744, NULL, 'G3DSA:1.10.8.60:FF:000029', NULL, NULL, 'Replication-associated recombination protein A', NULL, NULL, NULL, NULL, NULL, 4),
(73745, NULL, 'G3DSA:1.10.238.10:FF:001242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73746, NULL, 'G3DSA:3.40.50.300:FF:000188', NULL, NULL, 'signal recognition particle receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(73747, NULL, 'G3DSA:2.60.40.1090:FF:000037', NULL, NULL, 'Putative minor fimbrial subunit', NULL, NULL, NULL, NULL, NULL, 4),
(73748, NULL, 'G3DSA:2.60.40.10:FF:005482', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73749, NULL, 'G3DSA:3.30.160.60:FF:005122', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73750, NULL, 'G3DSA:2.60.40.60:FF:001068', NULL, NULL, 'Novel protein similar to human procadherin 15 (PCDH15)', NULL, NULL, NULL, NULL, NULL, 4),
(73751, NULL, 'G3DSA:1.10.630.10:FF:000081', NULL, NULL, 'Cytochrome P450 CYP81N5', NULL, NULL, NULL, NULL, NULL, 4),
(73752, NULL, 'G3DSA:3.90.550.10:FF:000689', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73753, NULL, 'G3DSA:3.30.300.30:FF:000128', NULL, NULL, '4-chlorobenzoate--CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(73754, NULL, 'G3DSA:1.50.10.10:FF:000014', NULL, NULL, 'Sulfoquinovose isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(73755, NULL, 'G3DSA:3.30.40.10:FF:001956', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73756, NULL, 'G3DSA:3.90.190.10:FF:000251', NULL, NULL, 'Unplaced genomic scaffold supercont1.9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(73757, NULL, 'G3DSA:3.40.50.150:FF:000671', NULL, NULL, 'S-adenosylmethionine sensor upstream of mTORC1', NULL, NULL, NULL, NULL, NULL, 4),
(73758, NULL, 'G3DSA:3.30.200.20:FF:002315', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73759, NULL, 'G3DSA:1.25.40.10:FF:004413', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73760, NULL, 'G3DSA:3.80.10.10:FF:004095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73761, NULL, 'G3DSA:1.25.40.10:FF:003323', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(73762, NULL, 'G3DSA:3.40.50.1980:FF:000139', NULL, NULL, 'Periplasmic binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(73763, NULL, 'G3DSA:4.10.280.10:FF:000160', NULL, NULL, 'Putative transcription factor bHLH041', NULL, NULL, NULL, NULL, NULL, 4),
(73764, NULL, 'G3DSA:3.90.950.10:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73765, NULL, 'G3DSA:4.10.780.10:FF:000006', NULL, NULL, 'Pyruvate-flavodoxin oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(73766, NULL, 'G3DSA:1.10.30.50:FF:000006', NULL, NULL, 'SNF2 DNA repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(73767, NULL, 'G3DSA:2.130.10.10:FF:004369', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73768, NULL, 'G3DSA:1.10.510.10:FF:002168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73769, NULL, 'G3DSA:2.40.10.10:FF:000349', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73770, NULL, 'G3DSA:3.60.15.10:FF:000239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73771, NULL, 'G3DSA:3.40.50.1000:FF:000453', NULL, NULL, 'Copper-transporting ATPase PAA1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(73772, NULL, 'G3DSA:3.30.420.100:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73773, NULL, 'G3DSA:1.20.1560.10:FF:000178', NULL, NULL, 'ABC transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(73774, NULL, 'G3DSA:3.90.1600.10:FF:000018', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(73775, NULL, 'G3DSA:3.80.10.10:FF:001222', NULL, NULL, 'Leucine rich repeat protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(73776, NULL, 'G3DSA:3.90.190.10:FF:000104', NULL, NULL, 'Dual specificity phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(73777, NULL, 'G3DSA:2.130.10.10:FF:001391', NULL, NULL, 'Damaged DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(73778, NULL, 'G3DSA:1.20.1440.200:FF:000001', NULL, NULL, 'Vacuolar protein sorting-associated protein 28 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(73779, NULL, 'G3DSA:3.40.50.300:FF:005831', NULL, NULL, 'Os01g0976100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(73780, NULL, 'G3DSA:1.10.238.10:FF:000062', NULL, NULL, 'Centrin 2', NULL, NULL, NULL, NULL, NULL, 4),
(73781, NULL, 'G3DSA:3.30.70.330:FF:000635', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(73782, NULL, 'G3DSA:3.40.1170.10:FF:000013', NULL, NULL, 'DNA mismatch repair protein MSH2', NULL, NULL, NULL, NULL, NULL, 4),
(73783, NULL, 'G3DSA:3.40.50.1820:FF:001536', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73784, NULL, 'G3DSA:3.40.50.880:FF:000081', NULL, NULL, 'DJ-1/PfpI family intracellular protease', NULL, NULL, NULL, NULL, NULL, 4),
(73785, NULL, 'G3DSA:2.120.10.30:FF:000407', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73786, NULL, 'G3DSA:2.60.40.2030:FF:000016', NULL, NULL, 'Adhesion G protein-coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(73787, NULL, 'G3DSA:3.40.50.300:FF:004903', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73788, NULL, 'G3DSA:3.40.50.300:FF:005168', NULL, NULL, 'Si:ch211-208g24.8', NULL, NULL, NULL, NULL, NULL, 4),
(73789, NULL, 'G3DSA:1.20.1060.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73790, NULL, 'G3DSA:1.10.8.60:FF:000440', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(73791, NULL, 'G3DSA:1.10.274.100:FF:000013', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(73792, NULL, 'G3DSA:1.20.1070.10:FF:000511', NULL, NULL, 'Putative neuropeptide G protein-coupled receptor', NULL, NULL, NULL, NULL, NULL, 4),
(73793, NULL, 'G3DSA:3.40.1110.10:FF:000346', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73794, NULL, 'G3DSA:1.20.1260.60:FF:000007', NULL, NULL, 'Regulator of Vps4 activity in the MVB pathway protein', NULL, NULL, NULL, NULL, NULL, 4),
(73795, NULL, 'G3DSA:3.40.50.720:FF:001112', NULL, NULL, 'Alanine dehydrogenase (Ald)', NULL, NULL, NULL, NULL, NULL, 4),
(73796, NULL, 'G3DSA:3.30.70.330:FF:002682', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73797, NULL, 'G3DSA:3.30.200.20:FF:000634', NULL, NULL, 'Calcium-dependent protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(73798, NULL, 'G3DSA:3.30.40.10:FF:000203', NULL, NULL, 'E3 ubiquitin-protein ligase CHFR isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(73799, NULL, 'G3DSA:3.30.710.10:FF:000243', NULL, NULL, 'Leucine-zipper-like transcriptional regulator 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(73800, NULL, 'G3DSA:3.40.50.1820:FF:001845', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(73801, NULL, 'G3DSA:1.20.120.430:FF:000018', NULL, NULL, 'tRNA modification GTPase MnmE', NULL, NULL, NULL, NULL, NULL, 4),
(73802, NULL, 'G3DSA:3.80.10.10:FF:001930', NULL, NULL, 'Type III effector protein XopAC', NULL, NULL, NULL, NULL, NULL, 4),
(73803, NULL, 'G3DSA:3.40.50.720:FF:000403', NULL, NULL, 'Potassium calcium-activated channel subfamily U member 1', NULL, NULL, NULL, NULL, NULL, 4),
(73804, NULL, 'G3DSA:3.30.300.160:FF:000020', NULL, NULL, 'Type 4 pili biogenesis protein (Nuleotide-binding protein)', NULL, NULL, NULL, NULL, NULL, 4),
(73805, NULL, 'G3DSA:3.30.70.1230:FF:000108', NULL, NULL, 'Adenylate cyclase CyaC', NULL, NULL, NULL, NULL, NULL, 4),
(73806, NULL, 'G3DSA:1.20.1720.10:FF:000022', NULL, NULL, 'MFS drug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(73807, NULL, 'G3DSA:1.10.287.110:FF:000379', NULL, NULL, 'Heat shock protein', NULL, NULL, NULL, NULL, NULL, 4),
(73808, NULL, 'G3DSA:3.40.50.150:FF:001851', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73809, NULL, 'G3DSA:3.30.930.10:FF:000271', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(73810, NULL, 'G3DSA:3.30.1490.190:FF:000017', NULL, NULL, 'Fur family transcriptional regulator, ferric uptake regulator', NULL, NULL, NULL, NULL, NULL, 4),
(73811, NULL, 'G3DSA:2.60.40.1260:FF:000009', NULL, NULL, 'Non-neuronal cytoplasmic intermediate filament protein A', NULL, NULL, NULL, NULL, NULL, 4),
(73812, NULL, 'G3DSA:3.40.630.10:FF:000173', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(73813, NULL, 'G3DSA:2.60.40.10:FF:004953', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73814, NULL, 'G3DSA:2.60.120.200:FF:000619', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(73815, NULL, 'G3DSA:3.40.50.300:FF:000497', NULL, NULL, 'Atlastin-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(73816, NULL, 'G3DSA:3.90.110.10:FF:000009', NULL, NULL, 'Malate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(73817, NULL, 'G3DSA:1.10.510.10:FF:000015', NULL, NULL, 'Ephrin type-B receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(73818, NULL, 'G3DSA:1.10.20.10:FF:000179', NULL, NULL, 'Transcriptional activator hap3', NULL, NULL, NULL, NULL, NULL, 4),
(73819, NULL, 'G3DSA:3.40.50.80:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73820, NULL, 'G3DSA:3.40.50.150:FF:001143', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyl transferase PigF', NULL, NULL, NULL, NULL, NULL, 4),
(73821, NULL, 'G3DSA:1.10.510.10:FF:003449', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73822, NULL, 'G3DSA:1.10.238.10:FF:000770', NULL, NULL, 'N-terminal EF-hand calcium binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(73823, NULL, 'G3DSA:2.30.18.10:FF:000002', NULL, NULL, 'Transcription initiation factor IIA subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(73824, NULL, 'G3DSA:3.40.50.2300:FF:000505', NULL, NULL, 'Response regulator VieB', NULL, NULL, NULL, NULL, NULL, 4),
(73825, NULL, 'G3DSA:3.30.450.60:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73826, NULL, 'G3DSA:3.40.1110.10:FF:000037', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(73827, NULL, 'G3DSA:1.10.510.10:FF:004068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73828, NULL, 'G3DSA:1.20.1730.10:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73829, NULL, 'G3DSA:3.30.70.330:FF:002991', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73830, NULL, 'G3DSA:3.30.200.20:FF:000943', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(73831, NULL, 'G3DSA:3.30.70.330:FF:000074', NULL, NULL, 'U2 snRNP auxiliary factor large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(73832, NULL, 'G3DSA:3.30.50.10:FF:000029', NULL, NULL, 'mineralocorticoid receptor isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(73833, NULL, 'G3DSA:3.30.530.20:FF:000182', NULL, NULL, 'Polyketide cyclase/dehydrase and lipid transport superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(73834, NULL, 'G3DSA:3.40.50.2300:FF:001478', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73835, NULL, 'G3DSA:3.20.20.80:FF:000049', NULL, NULL, 'Beta-hexosaminidase A', NULL, NULL, NULL, NULL, NULL, 4),
(73836, NULL, 'G3DSA:1.10.8.60:FF:000131', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(73837, NULL, 'G3DSA:3.30.450.20:FF:000338', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(73838, NULL, 'G3DSA:2.10.110.10:FF:000150', NULL, NULL, 'Actin binding LIM protein family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(73839, NULL, 'G3DSA:3.40.50.620:FF:000452', NULL, NULL, 'Lon protease homolog', NULL, NULL, NULL, NULL, NULL, 4),
(73840, NULL, 'G3DSA:2.60.120.200:FF:000063', NULL, NULL, 'Laminin subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(73841, NULL, 'G3DSA:3.40.50.150:FF:001290', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73842, NULL, 'G3DSA:1.10.10.10:FF:000914', NULL, NULL, 'LuxR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(73843, NULL, 'G3DSA:2.160.20.80:FF:000005', NULL, NULL, 'SPI-1 type III secretion system effector HECT-type E3 ubiquitin transferase SopA', NULL, NULL, NULL, NULL, NULL, 4),
(73844, NULL, 'G3DSA:2.10.25.10:FF:001385', NULL, NULL, 'protein eyes shut-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(73845, NULL, 'G3DSA:3.40.50.620:FF:000828', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73846, NULL, 'G3DSA:2.40.180.10:FF:000046', NULL, NULL, 'Catalase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(73847, NULL, 'G3DSA:2.130.10.10:FF:001952', NULL, NULL, 'Radiation sensitive protein 28 homologue, putative', NULL, NULL, NULL, NULL, NULL, 4),
(73848, NULL, 'G3DSA:3.10.20.90:FF:000709', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(73849, NULL, 'G3DSA:1.10.3500.10:FF:000020', NULL, NULL, 'Transcription elongation factor Spt6', NULL, NULL, NULL, NULL, NULL, 4),
(73850, NULL, 'G3DSA:1.20.1050.10:FF:000095', NULL, NULL, 'Probable glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(73851, NULL, 'G3DSA:3.90.70.10:FF:000438', NULL, NULL, 'ubiquitin carboxyl-terminal hydrolase 32', NULL, NULL, NULL, NULL, NULL, 4),
(73852, NULL, 'G3DSA:3.30.1490.120:FF:000013', NULL, NULL, 'GD22536', NULL, NULL, NULL, NULL, NULL, 4),
(73853, NULL, 'G3DSA:1.20.910.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73854, NULL, 'G3DSA:3.30.70.330:FF:002535', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73855, NULL, 'G3DSA:2.30.29.30:FF:001303', NULL, NULL, 'Pleckstrin 2', NULL, NULL, NULL, NULL, NULL, 4),
(73856, NULL, 'G3DSA:3.40.50.2300:FF:000961', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73857, NULL, 'G3DSA:1.25.40.10:FF:000097', NULL, NULL, 'DnaJ homolog subfamily C member 7 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(73858, NULL, 'G3DSA:3.40.50.300:FF:005729', NULL, NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(73859, NULL, 'G3DSA:3.90.228.20:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73860, NULL, 'G3DSA:2.10.25.10:FF:000502', NULL, NULL, 'Netrin G1', NULL, NULL, NULL, NULL, NULL, 4),
(73861, NULL, 'G3DSA:1.10.287.110:FF:000115', NULL, NULL, 'DnaJ domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(73862, NULL, 'G3DSA:1.50.40.10:FF:000403', NULL, NULL, 'Oxodicarboxylate carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(73863, NULL, 'G3DSA:3.40.309.10:FF:000061', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(73864, NULL, 'G3DSA:3.10.20.10:FF:000028', NULL, NULL, '60S ribosomal protein L18a', NULL, NULL, NULL, NULL, NULL, 4),
(73865, NULL, 'G3DSA:1.20.1740.10:FF:000035', NULL, NULL, 'Cationic amino acid transporter 5', NULL, NULL, NULL, NULL, NULL, 4),
(73866, NULL, 'G3DSA:2.130.10.10:FF:002469', NULL, NULL, 'Plexin A1', NULL, NULL, NULL, NULL, NULL, 4),
(73867, NULL, 'G3DSA:3.90.230.10:FF:000030', NULL, NULL, 'Xaa-pro aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(73868, NULL, 'G3DSA:1.20.58.70:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73869, NULL, 'G3DSA:3.80.10.10:FF:002756', NULL, NULL, 'F-box/LRR-repeat protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(73870, NULL, 'G3DSA:1.10.400.10:FF:000024', NULL, NULL, 'Concertina, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(73871, NULL, 'G3DSA:3.40.50.970:FF:000017', NULL, NULL, 'pyruvate decarboxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(73872, NULL, 'G3DSA:2.30.30.40:FF:000096', NULL, NULL, 'Neutrophil cytosol factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(73873, NULL, 'G3DSA:3.30.2160.10:FF:000037', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(73874, NULL, 'G3DSA:2.130.10.10:FF:002677', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(73875, NULL, 'G3DSA:1.20.1730.10:FF:000079', NULL, NULL, 'Solute carrier family 5 (sodium/glucose cotransporter), member 2', NULL, NULL, NULL, NULL, NULL, 4),
(73876, NULL, 'G3DSA:3.40.50.1820:FF:000356', NULL, NULL, '3-oxoadipate enol-lactone hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(73877, NULL, 'G3DSA:1.10.357.110:FF:000008', NULL, NULL, 'VPS53 subunit of GARP complex', NULL, NULL, NULL, NULL, NULL, 4),
(73878, NULL, 'G3DSA:1.10.8.10:FF:000150', NULL, NULL, 'Rhomboid domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(73879, NULL, 'G3DSA:3.90.550.50:FF:000094', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(73880, NULL, 'G3DSA:3.30.70.2390:FF:000001', NULL, NULL, 'Possible conserved protein CpsA', NULL, NULL, NULL, NULL, NULL, 4),
(73881, NULL, 'G3DSA:3.40.1110.10:FF:000138', NULL, NULL, 'Potassium/sodium P-type ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(73882, NULL, 'G3DSA:2.60.40.10:FF:001620', NULL, NULL, 'Down syndrome cell adhesion molecule-like protein Dscam2', NULL, NULL, NULL, NULL, NULL, 4),
(73883, NULL, 'G3DSA:1.10.20.140:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73884, NULL, 'G3DSA:1.10.150.60:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73885, NULL, 'G3DSA:3.90.70.10:FF:000865', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73886, NULL, 'G3DSA:3.60.20.10:FF:000077', NULL, NULL, 'Proteasome subunit alpha type-3', NULL, NULL, NULL, NULL, NULL, 4),
(73887, NULL, 'G3DSA:1.10.472.10:FF:000488', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(73888, NULL, 'G3DSA:3.50.50.60:FF:000318', NULL, NULL, 'Oxidoreductase, pyridine nucleotide-disulfide, class I', NULL, NULL, NULL, NULL, NULL, 4),
(73889, NULL, 'G3DSA:1.20.1600.10:FF:000002', NULL, NULL, 'Multidrug resistance outer membrane protein mdtP', NULL, NULL, NULL, NULL, NULL, 4),
(73890, NULL, 'G3DSA:1.10.10.580:FF:000025', NULL, NULL, 'N terminus of Rad21 / Rec8 like protein', NULL, NULL, NULL, NULL, NULL, 4),
(73891, NULL, 'G3DSA:2.60.120.330:FF:000102', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(73892, NULL, 'G3DSA:3.40.1090.10:FF:000057', NULL, NULL, 'Patatin-like phospholipase domain containing 4, isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(73893, NULL, 'G3DSA:3.40.1440.10:FF:000011', NULL, NULL, 'Structure-specific endonuclease subunit SLX1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(73894, NULL, 'G3DSA:1.25.10.10:FF:000842', NULL, NULL, 'HEAT repeat domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(73895, NULL, 'G3DSA:1.10.510.10:FF:002724', NULL, NULL, 'Probable inactive protein kinase DDB_G0270444', NULL, NULL, NULL, NULL, NULL, 4),
(73896, NULL, 'G3DSA:1.25.40.10:FF:002468', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73897, NULL, 'G3DSA:3.40.367.20:FF:000007', NULL, NULL, 'Glucokinase', NULL, NULL, NULL, NULL, NULL, 4),
(73898, NULL, 'G3DSA:2.70.150.10:FF:000077', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(73899, NULL, 'G3DSA:2.60.60.20:FF:000006', NULL, NULL, 'Lipoprotein lipase', NULL, NULL, NULL, NULL, NULL, 4),
(73900, NULL, 'G3DSA:1.20.1070.10:FF:000848', NULL, NULL, 'Leukotriene B4 receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(73901, NULL, 'G3DSA:2.60.120.260:FF:000373', NULL, NULL, 'Endo-1,4-beta-xylanase Z', NULL, NULL, NULL, NULL, NULL, 4),
(73902, NULL, 'G3DSA:3.30.160.60:FF:000108', NULL, NULL, 'Vascular endothelial zinc finger 1', NULL, NULL, NULL, NULL, NULL, 4),
(73903, NULL, 'G3DSA:3.40.50.740:FF:000033', NULL, NULL, 'NUAM protein', NULL, NULL, NULL, NULL, NULL, 4),
(73904, NULL, 'G3DSA:2.60.200.40:FF:000008', NULL, NULL, 'Probable lipid kinase YegS', NULL, NULL, NULL, NULL, NULL, 4),
(73905, NULL, 'G3DSA:3.30.70.330:FF:002575', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73906, NULL, 'G3DSA:1.10.510.10:FF:003657', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73907, NULL, 'G3DSA:1.20.1070.10:FF:001467', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(73908, NULL, 'G3DSA:1.20.5.340:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73909, NULL, 'G3DSA:1.10.3040.10:FF:000001', NULL, NULL, 'Nucleoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(73910, NULL, 'G3DSA:3.90.1100.10:FF:000008', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(73911, NULL, 'G3DSA:1.10.110.10:FF:000013', NULL, NULL, 'Chymotrypsin inhibitor WCI', NULL, NULL, NULL, NULL, NULL, 4),
(73912, NULL, 'G3DSA:1.20.1250.20:FF:002187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73913, NULL, 'G3DSA:2.60.200.20:FF:000002', NULL, NULL, 'Kinesin family member 13A', NULL, NULL, NULL, NULL, NULL, 4),
(73914, NULL, 'G3DSA:2.60.40.10:FF:003329', NULL, NULL, 'Fibronectin 1b', NULL, NULL, NULL, NULL, NULL, 4),
(73915, NULL, 'G3DSA:3.30.565.10:FF:000438', NULL, NULL, 'Two-component sensor CbrA', NULL, NULL, NULL, NULL, NULL, 4),
(73916, NULL, 'G3DSA:3.30.200.20:FF:002332', NULL, NULL, 'Death-associated protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(73917, NULL, 'G3DSA:3.30.40.10:FF:000776', NULL, NULL, 'Ecm5p', NULL, NULL, NULL, NULL, NULL, 4),
(73918, NULL, 'G3DSA:3.10.300.10:FF:000003', NULL, NULL, 'Putative 3-methyladenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(73919, NULL, 'G3DSA:1.10.510.10:FF:004276', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73920, NULL, 'G3DSA:1.10.30.10:FF:000197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73921, NULL, 'G3DSA:3.90.190.10:FF:000211', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(73922, NULL, 'G3DSA:1.20.990.10:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73923, NULL, 'G3DSA:3.40.50.300:FF:002397', NULL, NULL, 'Oligopeptide ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(73924, NULL, 'G3DSA:3.40.50.300:FF:003167', NULL, NULL, 'Tripartite terminase subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(73925, NULL, 'G3DSA:3.40.50.1820:FF:001289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73926, NULL, 'G3DSA:3.90.420.10:FF:000005', NULL, NULL, 'Nitrate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(73927, NULL, 'G3DSA:3.40.850.10:FF:000144', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(73928, NULL, 'G3DSA:3.30.40.10:FF:000304', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(73929, NULL, 'G3DSA:1.25.10.10:FF:001022', NULL, NULL, 'Coatomer subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(73930, NULL, 'G3DSA:2.130.10.10:FF:001744', NULL, NULL, 'Nuclear pore complex protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(73931, NULL, 'G3DSA:3.30.160.60:FF:003088', NULL, NULL, 'Kruppel-like factor 15', NULL, NULL, NULL, NULL, NULL, 4),
(73932, NULL, 'G3DSA:1.10.1420.10:FF:000075', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(73933, NULL, 'G3DSA:3.40.50.300:FF:005145', NULL, NULL, 'Cell division inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(73934, NULL, 'G3DSA:1.20.58.390:FF:000198', NULL, NULL, 'Transmembrane ion channel', NULL, NULL, NULL, NULL, NULL, 4),
(73935, NULL, 'G3DSA:2.60.120.200:FF:000299', NULL, NULL, 'DE-cadherin', NULL, NULL, NULL, NULL, NULL, 4),
(73936, NULL, 'G3DSA:1.25.40.10:FF:002575', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g09040, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(73937, NULL, 'G3DSA:3.80.10.10:FF:003375', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73938, NULL, 'G3DSA:3.30.1520.10:FF:000115', NULL, NULL, 'Ribosomal protein S6 kinase C1', NULL, NULL, NULL, NULL, NULL, 4),
(73939, NULL, 'G3DSA:3.30.930.10:FF:000046', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(73940, NULL, 'G3DSA:2.30.42.10:FF:000199', NULL, NULL, 'Na(+)/H(+) exchange regulatory cofactor NHE-RF4', NULL, NULL, NULL, NULL, NULL, 4),
(73941, NULL, 'G3DSA:2.170.270.10:FF:000168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(73942, NULL, 'G3DSA:3.40.50.1000:FF:000762', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73943, NULL, 'G3DSA:2.60.390.10:FF:000001', NULL, NULL, 'Beta-galactosidase A', NULL, NULL, NULL, NULL, NULL, 4),
(73944, NULL, 'G3DSA:1.10.150.50:FF:000140', NULL, NULL, 'Ephrin type-A receptor 5', NULL, NULL, NULL, NULL, NULL, 4),
(73945, NULL, 'G3DSA:2.10.25.10:FF:000632', NULL, NULL, 'Nidogen 1', NULL, NULL, NULL, NULL, NULL, 4),
(73946, NULL, 'G3DSA:3.10.20.90:FF:000917', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73947, NULL, 'G3DSA:3.30.1870.10:FF:000001', NULL, NULL, 'Erythromycin esterase', NULL, NULL, NULL, NULL, NULL, 4),
(73948, NULL, 'G3DSA:3.20.20.220:FF:000084', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(73949, NULL, 'G3DSA:2.20.70.10:FF:000062', NULL, NULL, 'IQ motif containing GTPase activating protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(73950, NULL, 'G3DSA:3.30.70.141:FF:000001', NULL, NULL, 'Nucleoside diphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(73951, NULL, 'G3DSA:3.30.70.580:FF:000019', NULL, NULL, 'RNA pseudouridylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(73952, NULL, 'G3DSA:1.10.150.20:FF:000125', NULL, NULL, 'DNA polymerase subunit gamma-1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(73953, NULL, 'G3DSA:3.30.160.60:FF:001199', NULL, NULL, 'Zinc finger protein 771', NULL, NULL, NULL, NULL, NULL, 4),
(73954, NULL, 'G3DSA:3.40.50.300:FF:007438', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73955, NULL, 'G3DSA:3.30.200.20:FF:000078', NULL, NULL, 'Serine/threonine-protein kinase nrc-2', NULL, NULL, NULL, NULL, NULL, 4),
(73956, NULL, 'G3DSA:1.10.510.10:FF:003343', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73957, NULL, 'G3DSA:3.90.70.10:FF:000337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73958, NULL, 'G3DSA:3.40.367.20:FF:000001', NULL, NULL, 'Hexokinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(73959, NULL, 'G3DSA:3.40.30.10:FF:000505', NULL, NULL, 'Thioredoxin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(73960, NULL, 'G3DSA:3.40.630.10:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73961, NULL, 'G3DSA:3.50.4.10:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73962, NULL, 'G3DSA:2.160.20.10:FF:000254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73963, NULL, 'G3DSA:3.40.50.620:FF:000019', NULL, NULL, 'Argininosuccinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(73964, NULL, 'G3DSA:1.20.1270.220:FF:000001', NULL, NULL, 'bromodomain-containing protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(73965, NULL, 'G3DSA:1.25.40.10:FF:004520', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73966, NULL, 'G3DSA:3.40.50.2300:FF:000860', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73967, NULL, 'G3DSA:1.20.120.1910:FF:000020', NULL, NULL, 'Cysteine--tRNA ligase 1 cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(73968, NULL, 'G3DSA:1.10.150.310:FF:000002', NULL, NULL, 'Putative transcription modulator/accessory protein', NULL, NULL, NULL, NULL, NULL, 4),
(73969, NULL, 'G3DSA:3.40.50.300:FF:007545', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(73970, NULL, 'G3DSA:3.40.50.150:FF:000070', NULL, NULL, 'Protein arginine N-methyltransferase 7', NULL, NULL, NULL, NULL, NULL, 4),
(73971, NULL, 'G3DSA:1.10.238.10:FF:000298', NULL, NULL, 'Calcium-binding protein CP1', NULL, NULL, NULL, NULL, NULL, 4),
(73972, NULL, 'G3DSA:2.60.40.10:FF:005802', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73973, NULL, 'G3DSA:2.40.260.10:FF:000002', NULL, NULL, 'SrtB family sortase', NULL, NULL, NULL, NULL, NULL, 4),
(73974, NULL, 'G3DSA:1.20.1740.10:FF:000012', NULL, NULL, 'Arginine/ornithine antiporter transporter', NULL, NULL, NULL, NULL, NULL, 4),
(73975, NULL, 'G3DSA:1.10.1420.10:FF:000182', NULL, NULL, 'Sperm protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(73976, NULL, 'G3DSA:3.80.10.10:FF:001031', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine/tyrosine-protein kinase SOBIR1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(73977, NULL, 'G3DSA:3.40.630.30:FF:000639', NULL, NULL, 'uncharacterized protein LOC100184264 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(73978, NULL, 'G3DSA:1.10.150.110:FF:000021', NULL, NULL, 'DNA-directed DNA/RNA polymerase mu', NULL, NULL, NULL, NULL, NULL, 4),
(73979, NULL, 'G3DSA:3.40.50.2000:FF:000758', NULL, NULL, 'UDP-N-acetylglucosamine transferase subunit ALG14', NULL, NULL, NULL, NULL, NULL, 4),
(73980, NULL, 'G3DSA:3.30.420.10:FF:000069', NULL, NULL, 'Helicase and polymerase-containing protein TEBICHI', NULL, NULL, NULL, NULL, NULL, 4),
(73981, NULL, 'G3DSA:1.20.210.10:FF:000041', NULL, NULL, 'Probable intron-encoded endonuclease aI2', NULL, NULL, NULL, NULL, NULL, 4),
(73982, NULL, 'G3DSA:2.30.29.90:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73983, NULL, 'G3DSA:3.40.50.150:FF:000755', NULL, NULL, 'Protein-L-isoaspartate O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(73984, NULL, 'G3DSA:3.40.50.720:FF:000842', NULL, NULL, 'Probable alcohol dehydrogenase adh', NULL, NULL, NULL, NULL, NULL, 4),
(73985, NULL, 'G3DSA:1.20.5.1930:FF:000006', NULL, NULL, 'Two component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(73986, NULL, 'G3DSA:1.10.510.10:FF:001420', NULL, NULL, 'Serine/threonine-protein kinase ppk4', NULL, NULL, NULL, NULL, NULL, 4),
(73987, NULL, 'G3DSA:3.80.10.10:FF:001458', NULL, NULL, 'Leucine_Rich_Repeat_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(73988, NULL, 'G3DSA:3.40.50.150:FF:001391', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73989, NULL, 'G3DSA:3.30.70.560:FF:000013', NULL, NULL, 'Dihydropteroate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(73990, NULL, 'G3DSA:2.30.42.10:FF:000564', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(73991, NULL, 'G3DSA:3.40.50.300:FF:002402', NULL, NULL, 'Branched-chain amino acid ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(73992, NULL, 'G3DSA:1.25.40.10:FF:000670', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(73993, NULL, 'G3DSA:1.20.5.20:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73994, NULL, 'G3DSA:3.30.40.10:FF:000091', NULL, NULL, 'transcriptional regulator ATRX isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(73995, NULL, 'G3DSA:2.60.40.420:FF:000232', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(73996, NULL, 'G3DSA:2.60.40.60:FF:000213', NULL, NULL, 'neural-cadherin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(73997, NULL, 'G3DSA:2.30.29.30:FF:000713', NULL, NULL, 'Nuclear Pore complex Protein', NULL, NULL, NULL, NULL, NULL, 4),
(73998, NULL, 'G3DSA:3.40.30.10:FF:001017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(73999, NULL, 'G3DSA:3.30.1120.100:FF:000004', NULL, NULL, 'Fatty acid synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(74000, NULL, 'G3DSA:3.10.110.10:FF:000292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74001, NULL, 'G3DSA:3.90.980.10:FF:000007', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(74002, NULL, 'G3DSA:3.20.20.190:FF:000001', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(74003, NULL, 'G3DSA:1.25.40.10:FF:005341', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g52620', NULL, NULL, NULL, NULL, NULL, 4),
(74004, NULL, 'G3DSA:2.60.40.150:FF:000691', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(74005, NULL, 'G3DSA:3.60.15.10:FF:000183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74006, NULL, 'G3DSA:1.10.12.10:FF:000043', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(74007, NULL, 'G3DSA:3.30.710.10:FF:000052', NULL, NULL, 'Longitudinals lacking protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(74008, NULL, 'G3DSA:2.130.10.10:FF:002363', NULL, NULL, 'K7_Rpn14p', NULL, NULL, NULL, NULL, NULL, 4),
(74009, NULL, 'G3DSA:1.25.40.10:FF:003896', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(74010, NULL, 'G3DSA:3.30.710.10:FF:000479', NULL, NULL, 'Zinc finger and BTB domain-containing 25', NULL, NULL, NULL, NULL, NULL, 4),
(74011, NULL, 'G3DSA:3.40.30.10:FF:000977', NULL, NULL, 'Peroxiredoxin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(74012, NULL, 'G3DSA:3.30.420.10:FF:000608', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74013, NULL, 'G3DSA:1.25.10.10:FF:003276', NULL, NULL, 'PIKK family atypical protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(74014, NULL, 'G3DSA:3.40.50.300:FF:007062', NULL, NULL, 'Rab_C83 protein', NULL, NULL, NULL, NULL, NULL, 4),
(74015, NULL, 'G3DSA:3.40.50.300:FF:006449', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74016, NULL, 'G3DSA:2.130.10.10:FF:003633', NULL, NULL, 'WD repeat-containing protein 38', NULL, NULL, NULL, NULL, NULL, 4),
(74017, NULL, 'G3DSA:1.10.238.10:FF:001282', NULL, NULL, 'Secretagogin, EF-hand calcium binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(74018, NULL, 'G3DSA:1.25.40.120:FF:000001', NULL, NULL, 'Geranylgeranyl transferase type-2 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(74019, NULL, 'G3DSA:3.30.160.60:FF:000215', NULL, NULL, 'Spalt-like transcription factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(74020, NULL, 'G3DSA:2.60.40.60:FF:000685', NULL, NULL, 'Cadherin-4', NULL, NULL, NULL, NULL, NULL, 4),
(74021, NULL, 'G3DSA:1.20.58.1360:FF:000004', NULL, NULL, 'JmjC domain-containing histone demethylation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(74022, NULL, 'G3DSA:2.170.300.10:FF:000014', NULL, NULL, 'Multiple epidermal growth factor-like domains protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(74023, NULL, 'G3DSA:1.20.120.330:FF:000005', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(74024, NULL, 'G3DSA:3.20.20.100:FF:000031', NULL, NULL, 'D-arabinose dehydrogenase heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(74025, NULL, 'G3DSA:3.40.50.2300:FF:000258', NULL, NULL, 'Glutamate metabotropic receptor 5', NULL, NULL, NULL, NULL, NULL, 4),
(74026, NULL, 'G3DSA:2.30.40.10:FF:000037', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(74027, NULL, 'G3DSA:3.80.10.10:FF:001823', NULL, NULL, 'Leucine-rich repeat transmembrane protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(74028, NULL, 'G3DSA:3.80.10.10:FF:002442', NULL, NULL, 'Leucine-rich repeat-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(74029, NULL, 'G3DSA:1.10.1520.10:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74030, NULL, 'G3DSA:2.10.25.10:FF:001486', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74031, NULL, 'G3DSA:3.40.50.720:FF:002320', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74032, NULL, 'G3DSA:3.10.450.10:FF:000087', NULL, NULL, 'Kininogen 2', NULL, NULL, NULL, NULL, NULL, 4),
(74033, NULL, 'G3DSA:3.40.50.150:FF:000446', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(74034, NULL, 'G3DSA:1.25.10.10:FF:002764', NULL, NULL, 'Adaptin N terminal region family protein', NULL, NULL, NULL, NULL, NULL, 4),
(74035, NULL, 'G3DSA:2.60.40.150:FF:000382', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(74036, NULL, 'G3DSA:1.20.1560.10:FF:000279', NULL, NULL, 'Protease secretion ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(74037, NULL, 'G3DSA:2.10.25.10:FF:000997', NULL, NULL, 'Starry night', NULL, NULL, NULL, NULL, NULL, 4),
(74038, NULL, 'G3DSA:3.10.20.90:FF:000608', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(74039, NULL, 'G3DSA:1.10.510.10:FF:002359', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74040, NULL, 'G3DSA:1.10.540.10:FF:000079', NULL, NULL, 'Acyl-Coenzyme A dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(74041, NULL, 'G3DSA:1.10.510.10:FF:002387', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74042, NULL, 'G3DSA:3.30.310.10:FF:000050', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(74043, NULL, 'G3DSA:1.50.10.20:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74044, NULL, 'G3DSA:1.50.10.20:FF:000118', NULL, NULL, 'Farnesyltransferase, CAAX box, beta', NULL, NULL, NULL, NULL, NULL, 4),
(74045, NULL, 'G3DSA:3.90.25.10:FF:000025', NULL, NULL, 'dTDP-4-dehydrorhamnose reductase', NULL, NULL, NULL, NULL, NULL, 4),
(74046, NULL, 'G3DSA:1.20.1070.10:FF:000056', NULL, NULL, 'Melatonin receptor type 1A', NULL, NULL, NULL, NULL, NULL, 4),
(74047, NULL, 'G3DSA:3.80.10.10:FF:000839', NULL, NULL, 'Gp150, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(74048, NULL, 'G3DSA:3.30.1430.10:FF:000002', NULL, NULL, 'Ribosomal protein L3-like', NULL, NULL, NULL, NULL, NULL, 4),
(74049, NULL, 'G3DSA:1.10.506.10:FF:000039', NULL, NULL, 'Plexin-2', NULL, NULL, NULL, NULL, NULL, 4),
(74050, NULL, 'G3DSA:3.90.45.10:FF:000032', NULL, NULL, 'Peptide deformylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(74051, NULL, 'G3DSA:2.30.230.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74052, NULL, 'G3DSA:3.90.320.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74053, NULL, 'G3DSA:3.30.200.20:FF:002551', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(74054, NULL, 'G3DSA:2.60.40.1930:FF:000020', NULL, NULL, 'Thioester-containing protein 2, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(74055, NULL, 'G3DSA:1.20.1070.10:FF:001040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74056, NULL, 'G3DSA:3.30.160.60:FF:005561', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74057, NULL, 'G3DSA:1.25.40.10:FF:003087', NULL, NULL, 'Pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(74058, NULL, 'G3DSA:1.10.1320.10:FF:000016', NULL, NULL, 'DNA-directed RNA polymerase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(74059, NULL, 'G3DSA:2.30.110.10:FF:000061', NULL, NULL, 'Flavin oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(74060, NULL, 'G3DSA:1.20.1270.60:FF:000058', NULL, NULL, 'Rho GTPase activating protein 45', NULL, NULL, NULL, NULL, NULL, 4),
(74061, NULL, 'G3DSA:1.25.40.10:FF:003901', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74062, NULL, 'G3DSA:2.60.40.10:FF:004970', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74063, NULL, 'G3DSA:3.80.10.10:FF:000042', NULL, NULL, 'F-box/LRR-repeat protein 20 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(74064, NULL, 'G3DSA:3.90.550.10:FF:000559', NULL, NULL, '2-phospho-L-lactate guanylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(74065, NULL, 'G3DSA:3.30.870.10:FF:000075', NULL, NULL, 'Phosphatidylcholine-hydrolyzing phospholipase D (PLD) family', NULL, NULL, NULL, NULL, NULL, 4),
(74066, NULL, 'G3DSA:1.10.630.10:FF:000417', NULL, NULL, 'Cytochrome P450, family 71, subfamily B, polypeptide 32', NULL, NULL, NULL, NULL, NULL, 4),
(74067, NULL, 'G3DSA:3.40.30.10:FF:000180', NULL, NULL, 'Circadian clock protein KaiB', NULL, NULL, NULL, NULL, NULL, 4),
(74068, NULL, 'G3DSA:1.20.1050.10:FF:000049', NULL, NULL, 'Glutathione S-transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(74069, NULL, 'G3DSA:2.130.10.10:FF:001379', NULL, NULL, 'Periodic tryptophan protein 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(74070, NULL, 'G3DSA:2.30.29.70:FF:000011', NULL, NULL, 'AT31219p', NULL, NULL, NULL, NULL, NULL, 4),
(74071, NULL, 'G3DSA:2.10.110.10:FF:000256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74072, NULL, 'G3DSA:3.30.460.20:FF:000035', NULL, NULL, 'Magnesium/cobalt transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(74073, NULL, 'G3DSA:1.10.472.10:FF:000358', NULL, NULL, 'Cyclin subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74074, NULL, 'G3DSA:3.40.640.10:FF:000218', NULL, NULL, 'Aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(74075, NULL, 'G3DSA:1.20.1110.10:FF:000111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74076, NULL, 'G3DSA:1.10.630.10:FF:000378', NULL, NULL, 'Putative cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(74077, NULL, 'G3DSA:1.25.40.10:FF:005032', NULL, NULL, 'OSJNBa0060P14.4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(74078, NULL, 'G3DSA:3.40.50.300:FF:001778', NULL, NULL, 'Type VII secretion AAA-ATPase EccA', NULL, NULL, NULL, NULL, NULL, 4),
(74079, NULL, 'G3DSA:3.30.50.10:FF:000046', NULL, NULL, 'Gat4p', NULL, NULL, NULL, NULL, NULL, 4),
(74080, NULL, 'G3DSA:3.40.50.2300:FF:000730', NULL, NULL, 'Nitrogen fixation master sigma-54-dependent transcriptional response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(74081, NULL, 'G3DSA:3.30.420.150:FF:000026', NULL, NULL, 'Ectonucleoside triphosphate diphosphohydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(74082, NULL, 'G3DSA:3.50.50.60:FF:001010', NULL, NULL, 'L-amino-acid oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(74083, NULL, 'G3DSA:3.40.640.10:FF:000454', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74084, NULL, 'G3DSA:3.30.1520.10:FF:000138', NULL, NULL, 'Neutrophil cytosol factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(74085, NULL, 'G3DSA:1.10.510.10:FF:001398', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74086, NULL, 'G3DSA:3.30.160.60:FF:001519', NULL, NULL, 'Zinc finger 202 m1', NULL, NULL, NULL, NULL, NULL, 4),
(74087, NULL, 'G3DSA:1.25.40.10:FF:002592', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74088, NULL, 'G3DSA:1.10.510.10:FF:003348', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74089, NULL, 'G3DSA:2.120.10.80:FF:000299', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74090, NULL, 'G3DSA:1.20.1250.20:FF:001259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74091, NULL, 'G3DSA:3.30.420.40:FF:001101', NULL, NULL, 'Zgc:172295', NULL, NULL, NULL, NULL, NULL, 4),
(74092, NULL, 'G3DSA:3.30.70.3040:FF:000011', NULL, NULL, 'Cell division protein FtsX', NULL, NULL, NULL, NULL, NULL, 4),
(74093, NULL, 'G3DSA:3.20.20.60:FF:000144', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74094, NULL, 'G3DSA:1.20.5.50:FF:000003', NULL, NULL, 'Fibrinogen gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(74095, NULL, 'G3DSA:2.60.40.10:FF:002020', NULL, NULL, 'Poliovirus receptor-related 2 like', NULL, NULL, NULL, NULL, NULL, 4),
(74096, NULL, 'G3DSA:3.40.50.620:FF:000475', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(74097, NULL, 'G3DSA:3.80.10.10:FF:003931', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74098, NULL, 'G3DSA:1.25.10.10:FF:001331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74099, NULL, 'G3DSA:2.10.110.10:FF:000251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74100, NULL, 'G3DSA:2.60.40.60:FF:000792', NULL, NULL, 'Desmocollin 3', NULL, NULL, NULL, NULL, NULL, 4),
(74101, NULL, 'G3DSA:2.60.40.10:FF:002059', NULL, NULL, 'Protein-glutamine gamma-glutamyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(74102, NULL, 'G3DSA:2.70.150.10:FF:000094', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(74103, NULL, 'G3DSA:3.30.160.60:FF:003560', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74104, NULL, 'G3DSA:3.10.290.20:FF:000009', NULL, NULL, 'Ubiquitin-activating enzyme E1-like', NULL, NULL, NULL, NULL, NULL, 4),
(74105, NULL, 'G3DSA:3.60.40.10:FF:000163', NULL, NULL, 'Protein serine/threonine phosphatase 2C', NULL, NULL, NULL, NULL, NULL, 4),
(74106, NULL, 'G3DSA:3.30.70.1450:FF:000045', NULL, NULL, 'Transporter, divalent anion:sodium symporter family', NULL, NULL, NULL, NULL, NULL, 4),
(74107, NULL, 'G3DSA:1.10.287.110:FF:000014', NULL, NULL, 'dnaJ homolog subfamily A member 1', NULL, NULL, NULL, NULL, NULL, 4),
(74108, NULL, 'G3DSA:3.40.50.300:FF:000289', NULL, NULL, 'ABC transporter G family member 31', NULL, NULL, NULL, NULL, NULL, 4),
(74109, NULL, 'G3DSA:2.170.270.10:FF:000163', NULL, NULL, 'SET domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(74110, NULL, 'G3DSA:3.90.1150.10:FF:000505', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(74111, NULL, 'G3DSA:2.60.40.10:FF:001311', NULL, NULL, 'Sallimus, isoform U', NULL, NULL, NULL, NULL, NULL, 4),
(74112, NULL, 'G3DSA:1.25.40.10:FF:002940', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(74113, NULL, 'G3DSA:3.30.160.60:FF:004739', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74114, NULL, 'G3DSA:2.30.30.100:FF:000040', NULL, NULL, 'Gem-associated protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(74115, NULL, 'G3DSA:3.40.50.720:FF:002101', NULL, NULL, 'Siroheme synthesis protein, conjectural', NULL, NULL, NULL, NULL, NULL, 4),
(74116, NULL, 'G3DSA:3.40.1020.10:FF:000002', NULL, NULL, 'L-threonine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(74117, NULL, 'G3DSA:1.10.510.10:FF:003652', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74118, NULL, 'G3DSA:3.40.50.150:FF:000862', NULL, NULL, 'rRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(74119, NULL, 'G3DSA:2.30.180.10:FF:000099', NULL, NULL, 'DUF5108 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(74120, NULL, 'G3DSA:1.10.630.10:FF:000041', NULL, NULL, 'Cytochrome P450 26A1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(74121, NULL, 'G3DSA:2.60.40.10:FF:001750', NULL, NULL, 'Leptin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(74122, NULL, 'G3DSA:3.40.50.300:FF:005275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74123, NULL, 'G3DSA:3.30.1370.210:FF:000042', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74124, NULL, 'G3DSA:2.60.40.10:FF:002929', NULL, NULL, 'AGAP000937-PA', NULL, NULL, NULL, NULL, NULL, 4),
(74125, NULL, 'G3DSA:3.40.50.300:FF:001441', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(74126, NULL, 'G3DSA:1.20.1070.10:FF:001012', NULL, NULL, 'Annetocin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(74127, NULL, 'G3DSA:1.25.40.10:FF:002120', NULL, NULL, 'Putative pentatricopeptide repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(74128, NULL, 'G3DSA:1.25.40.20:FF:000796', NULL, NULL, 'AGAP001061-PB', NULL, NULL, NULL, NULL, NULL, 4),
(74129, NULL, 'G3DSA:3.40.50.2300:FF:001242', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74130, NULL, 'G3DSA:2.60.120.330:FF:000107', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74131, NULL, 'G3DSA:3.10.280.10:FF:000034', NULL, NULL, 'Mitochondrial glycoprotein family protein', NULL, NULL, NULL, NULL, NULL, 4),
(74132, NULL, 'G3DSA:3.40.50.300:FF:002767', NULL, NULL, 'Fe(3+) ions import ATP-binding protein FbpC', NULL, NULL, NULL, NULL, NULL, 4),
(74133, NULL, 'G3DSA:1.20.1250.20:FF:000298', NULL, NULL, 'Thiamine transporter', NULL, NULL, NULL, NULL, NULL, 4),
(74134, NULL, 'G3DSA:3.60.10.10:FF:000335', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74135, NULL, 'G3DSA:1.10.1520.10:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74136, NULL, 'G3DSA:3.40.50.10420:FF:000001', NULL, NULL, 'Methenyltetrahydrofolate synthase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(74137, NULL, 'G3DSA:1.10.555.10:FF:000192', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74138, NULL, 'G3DSA:3.90.70.10:FF:000882', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(74139, NULL, 'G3DSA:3.40.47.10:FF:000145', NULL, NULL, 'Polyketide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(74140, NULL, 'G3DSA:3.90.70.10:FF:000646', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74141, NULL, 'G3DSA:1.20.58.2190:FF:000011', NULL, NULL, 'GM19889', NULL, NULL, NULL, NULL, NULL, 4),
(74142, NULL, 'G3DSA:3.40.50.2000:FF:000505', NULL, NULL, 'Glycosyl transferase family 1', NULL, NULL, NULL, NULL, NULL, 4),
(74143, NULL, 'G3DSA:2.30.42.10:FF:000569', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74144, NULL, 'G3DSA:3.20.20.140:FF:000251', NULL, NULL, 'Allantoinase', NULL, NULL, NULL, NULL, NULL, 4),
(74145, NULL, 'G3DSA:3.40.50.300:FF:001093', NULL, NULL, 'DNA polymerase III subunit delta', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(74146, NULL, 'G3DSA:1.10.340.70:FF:000042', NULL, NULL, 'OSJNBa0059D20.8-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(74147, NULL, 'G3DSA:3.80.10.10:FF:002751', NULL, NULL, 'OSIGBa0107E14.8 protein', NULL, NULL, NULL, NULL, NULL, 4),
(74148, NULL, 'G3DSA:3.30.460.10:FF:000162', NULL, NULL, 'Pol lambda-related class X DNA repair polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(74149, NULL, 'G3DSA:3.30.43.10:FF:000018', NULL, NULL, 'D-lactate dehydrogenase (Dld)', NULL, NULL, NULL, NULL, NULL, 4),
(74150, NULL, 'G3DSA:2.60.60.20:FF:000023', NULL, NULL, 'Multidomain scavenger receptor', NULL, NULL, NULL, NULL, NULL, 4),
(74151, NULL, 'G3DSA:2.30.29.30:FF:000606', NULL, NULL, 'Sterol 3-beta-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(74152, NULL, 'G3DSA:1.10.10.60:FF:000749', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(74153, NULL, 'G3DSA:3.30.70.330:FF:002558', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74154, NULL, 'G3DSA:2.30.30.140:FF:000041', NULL, NULL, 'Scm-like with four mbt domains 1, isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(74155, NULL, 'G3DSA:1.20.1050.130:FF:000009', NULL, NULL, 'Elongation factor 1-beta', NULL, NULL, NULL, NULL, NULL, 4),
(74156, NULL, 'G3DSA:1.25.10.10:FF:003259', NULL, NULL, 'Chromatin structure-remodeling complex subunit rsc9', NULL, NULL, NULL, NULL, NULL, 4),
(74157, NULL, 'G3DSA:3.60.20.10:FF:000150', NULL, NULL, 'Proteasome endopeptidase complex', NULL, NULL, NULL, NULL, NULL, 4),
(74158, NULL, 'G3DSA:3.30.200.20:FF:000387', NULL, NULL, 'Serine/threonine-protein kinase STE11', NULL, NULL, NULL, NULL, NULL, 4),
(74159, NULL, 'G3DSA:2.10.25.10:FF:000525', NULL, NULL, 'Fat-like cadherin-related tumor suppressor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(74160, NULL, 'G3DSA:2.130.10.10:FF:003661', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74161, NULL, 'G3DSA:1.20.5.340:FF:000127', NULL, NULL, 'Tropomyosin 3', NULL, NULL, NULL, NULL, NULL, 4),
(74162, NULL, 'G3DSA:3.30.70.960:FF:000026', NULL, NULL, 'Suppression of tumorigenicity 14b', NULL, NULL, NULL, NULL, NULL, 4),
(74163, NULL, 'G3DSA:3.40.50.1370:FF:000035', NULL, NULL, 'Aspartate carbamoyltransferase, catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(74164, NULL, 'G3DSA:3.40.190.10:FF:000481', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74165, NULL, 'G3DSA:3.30.40.10:FF:002221', NULL, NULL, 'Protein CBG05218', NULL, NULL, NULL, NULL, NULL, 4),
(74166, NULL, 'G3DSA:1.20.920.10:FF:000090', NULL, NULL, 'GD18270', NULL, NULL, NULL, NULL, NULL, 4),
(74167, NULL, 'G3DSA:2.130.10.10:FF:002368', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74168, NULL, 'G3DSA:3.40.50.10190:FF:000078', NULL, NULL, 'DNA polymerase III subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(74169, NULL, 'G3DSA:1.20.1070.10:FF:000051', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(74170, NULL, 'G3DSA:3.30.70.330:FF:000321', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase E', NULL, NULL, NULL, NULL, NULL, 4),
(74171, NULL, 'G3DSA:2.10.25.10:FF:001014', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(74172, NULL, 'G3DSA:3.30.420.510:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74173, NULL, 'G3DSA:1.10.3380.10:FF:000015', NULL, NULL, 'U5 small nuclear ribonucleoprotein-specific protein', NULL, NULL, NULL, NULL, NULL, 4),
(74174, NULL, 'G3DSA:1.25.10.10:FF:000533', NULL, NULL, 'MOT1p protein', NULL, NULL, NULL, NULL, NULL, 4),
(74175, NULL, 'G3DSA:2.40.50.90:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74176, NULL, 'G3DSA:3.40.50.720:FF:000050', NULL, NULL, 'D-lactate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(74177, NULL, 'G3DSA:1.10.150.50:FF:000016', NULL, NULL, 'Ankyrin repeat and sterile alpha motif domain-containing protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(74178, NULL, 'G3DSA:3.40.50.12710:FF:000019', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(74179, NULL, 'G3DSA:2.10.70.10:FF:000028', NULL, NULL, 'mannan-binding lectin serine protease 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(74180, NULL, 'G3DSA:3.90.320.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74181, NULL, 'G3DSA:1.10.238.10:FF:000337', NULL, NULL, 'CALmodulin related genes', NULL, NULL, NULL, NULL, NULL, 4),
(74182, NULL, 'G3DSA:2.60.120.290:FF:000253', NULL, NULL, 'Cubilin-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(74183, NULL, 'G3DSA:3.30.230.10:FF:000369', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74184, NULL, 'G3DSA:3.40.50.300:FF:003386', NULL, NULL, 'DNA repair protein RAD57', NULL, NULL, NULL, NULL, NULL, 4),
(74185, NULL, 'G3DSA:2.60.120.330:FF:000074', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74186, NULL, 'G3DSA:1.10.472.80:FF:000126', NULL, NULL, 'TBC/Rab GTPase activating domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(74187, NULL, 'G3DSA:2.40.10.10:FF:000113', NULL, NULL, 'Zgc:112285', NULL, NULL, NULL, NULL, NULL, 4),
(74188, NULL, 'G3DSA:2.60.40.10:FF:004184', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74189, NULL, 'G3DSA:1.20.1260.60:FF:000001', NULL, NULL, 'IST1 homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(74190, NULL, 'G3DSA:2.60.40.10:FF:003548', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74191, NULL, 'G3DSA:3.20.80.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74192, NULL, 'G3DSA:1.20.1270.130:FF:000002', NULL, NULL, 'Type III secretion system effector protein-E3 Ubiquitin ligase', NULL, NULL, NULL, NULL, NULL, 4),
(74193, NULL, 'G3DSA:2.120.10.80:FF:000271', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74194, NULL, 'G3DSA:1.20.1220.12:FF:000003', NULL, NULL, 'Malate synthase (GlcB)', NULL, NULL, NULL, NULL, NULL, 4),
(74195, NULL, 'G3DSA:3.40.1090.10:FF:000085', NULL, NULL, 'Patatin-like phospholipase domain-containing protein SPAC1786.01c', NULL, NULL, NULL, NULL, NULL, 4),
(74196, NULL, 'G3DSA:3.40.50.2300:FF:001669', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74197, NULL, 'G3DSA:2.40.100.10:FF:000081', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(74198, NULL, 'G3DSA:3.80.10.10:FF:001806', NULL, NULL, 'Os05g0501600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(74199, NULL, 'G3DSA:2.110.10.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74200, NULL, 'G3DSA:2.30.40.10:FF:000054', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(74201, NULL, 'G3DSA:3.80.10.10:FF:000047', NULL, NULL, 'protein phosphatase 1 regulatory subunit 29', NULL, NULL, NULL, NULL, NULL, 4),
(74202, NULL, 'G3DSA:1.25.40.10:FF:003424', NULL, NULL, 'Protein SGT1-like protein A', NULL, NULL, NULL, NULL, NULL, 4),
(74203, NULL, 'G3DSA:2.40.50.140:FF:000969', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74204, NULL, 'G3DSA:3.30.2380.10:FF:000003', NULL, NULL, 'At4g34412', NULL, NULL, NULL, NULL, NULL, 4),
(74205, NULL, 'G3DSA:3.30.200.20:FF:001798', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(74206, NULL, 'G3DSA:3.30.300.20:FF:000018', NULL, NULL, 'Ribosome-binding factor A', NULL, NULL, NULL, NULL, NULL, 4),
(74207, NULL, 'G3DSA:3.90.1820.10:FF:000001', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(74208, NULL, 'G3DSA:3.20.20.80:FF:000605', NULL, NULL, 'Beta-glucosidase 11', NULL, NULL, NULL, NULL, NULL, 4),
(74209, NULL, 'G3DSA:3.30.70.100:FF:000151', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74210, NULL, 'G3DSA:2.10.50.10:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74211, NULL, 'G3DSA:3.30.160.60:FF:002941', NULL, NULL, 'Zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(74212, NULL, 'G3DSA:2.30.29.30:FF:000230', NULL, NULL, 'Polarized growth protein (Boi2)', NULL, NULL, NULL, NULL, NULL, 4),
(74213, NULL, 'G3DSA:2.130.10.10:FF:004622', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(74214, NULL, 'G3DSA:3.10.110.10:FF:000157', NULL, NULL, 'Ubiquitin-conjugating enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(74215, NULL, 'G3DSA:3.40.50.80:FF:000140', NULL, NULL, 'Ferric reductase like transmembrane component', NULL, NULL, NULL, NULL, NULL, 4),
(74216, NULL, 'G3DSA:2.60.40.1930:FF:000025', NULL, NULL, 'Complement component 4', NULL, NULL, NULL, NULL, NULL, 4),
(74217, NULL, 'G3DSA:1.20.1250.20:FF:001894', NULL, NULL, 'Pyrazinamidase/nicotinamidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74218, NULL, 'G3DSA:2.40.128.430:FF:000001', NULL, NULL, 'ATPase RavA', NULL, NULL, NULL, NULL, NULL, 4),
(74219, NULL, 'G3DSA:3.40.50.720:FF:000639', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(74220, NULL, 'G3DSA:2.60.120.10:FF:000302', NULL, NULL, 'cGMP-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(74221, NULL, 'G3DSA:1.20.120.730:FF:000018', NULL, NULL, 'Protein transport protein Sec24-like CEF', NULL, NULL, NULL, NULL, NULL, 4),
(74222, NULL, 'G3DSA:3.40.50.300:FF:004656', NULL, NULL, 'Methyl coenzyme M reductase system, component A2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(74223, NULL, 'G3DSA:2.130.10.10:FF:005241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74224, NULL, 'G3DSA:1.10.530.10:FF:000022', NULL, NULL, 'Lysozyme g-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(74225, NULL, 'G3DSA:2.130.10.10:FF:005111', NULL, NULL, 'Protein HIRA', NULL, NULL, NULL, NULL, NULL, 4),
(74226, NULL, 'G3DSA:3.30.70.330:FF:001810', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74227, NULL, 'G3DSA:2.130.10.10:FF:005550', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74228, NULL, 'G3DSA:1.20.144.10:FF:000049', NULL, NULL, 'Lipid phosphate phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74229, NULL, 'G3DSA:1.10.10.60:FF:000188', NULL, NULL, 'Anaerobic nitric oxide reductase transcription regulator NorR', NULL, NULL, NULL, NULL, NULL, 4),
(74230, NULL, 'G3DSA:1.20.1250.20:FF:001714', NULL, NULL, 'Melibiose carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(74231, NULL, 'G3DSA:2.60.120.260:FF:000401', NULL, NULL, 'Putative Epithelial discoidin domain-containing receptor', NULL, NULL, NULL, NULL, NULL, 4),
(74232, NULL, 'G3DSA:1.10.510.10:FF:001550', NULL, NULL, 'Wall-associated receptor kinase-like 6', NULL, NULL, NULL, NULL, NULL, 4),
(74233, NULL, 'G3DSA:2.130.10.10:FF:003296', NULL, NULL, 'Transducin (beta)-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(74234, NULL, 'G3DSA:3.30.160.60:FF:000996', NULL, NULL, 'Zinc finger protein 181', NULL, NULL, NULL, NULL, NULL, 4),
(74235, NULL, 'G3DSA:1.20.1250.20:FF:001006', NULL, NULL, 'solute carrier family 2, facilitated glucose transporter member 6 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(74236, NULL, 'G3DSA:2.130.10.10:FF:000570', NULL, NULL, 'Vacuolar protein sorting-associated protein 11 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(74237, NULL, 'G3DSA:1.10.390.10:FF:000033', NULL, NULL, 'Endoplasmic reticulum aminopeptidase 1b', NULL, NULL, NULL, NULL, NULL, 4),
(74238, NULL, 'G3DSA:3.40.640.10:FF:000235', NULL, NULL, 'Aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(74239, NULL, 'G3DSA:3.30.420.40:FF:000140', NULL, NULL, 'Heat shock protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(74240, NULL, 'G3DSA:3.30.540.10:FF:000016', NULL, NULL, 'SAL1 phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(74241, NULL, 'G3DSA:1.25.40.10:FF:003115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74242, NULL, 'G3DSA:3.30.450.20:FF:000102', NULL, NULL, 'Sensor protein kinase WalK', NULL, NULL, NULL, NULL, NULL, 4),
(74243, NULL, 'G3DSA:3.90.226.10:FF:000177', NULL, NULL, 'Carboxyl-terminal-processing peptidase 3, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(74244, NULL, 'G3DSA:3.10.28.10:FF:000057', NULL, NULL, 'Replication factor C small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(74245, NULL, 'G3DSA:1.10.630.10:FF:000833', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(74246, NULL, 'G3DSA:1.10.510.10:FF:001403', NULL, NULL, 'Rab GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74247, NULL, 'G3DSA:1.10.1200.240:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74248, NULL, 'G3DSA:2.40.50.40:FF:000102', NULL, NULL, 'Chemokine (C-C motif) ligand 39, duplicate 4', NULL, NULL, NULL, NULL, NULL, 4),
(74249, NULL, 'G3DSA:3.40.50.300:FF:008366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74250, NULL, 'G3DSA:1.25.10.10:FF:001803', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74251, NULL, 'G3DSA:3.50.30.30:FF:000106', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74252, NULL, 'G3DSA:3.40.50.300:FF:005640', NULL, NULL, 'Putative ATP-dependent RNA helicase TDRD12', NULL, NULL, NULL, NULL, NULL, 4),
(74253, NULL, 'G3DSA:3.30.160.60:FF:005358', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74254, NULL, 'G3DSA:2.60.120.590:FF:000045', NULL, NULL, '2OG-Fe(II) oxygenase superfamily, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74255, NULL, 'G3DSA:1.25.10.10:FF:001461', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(74256, NULL, 'G3DSA:2.130.10.10:FF:004841', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74257, NULL, 'G3DSA:3.80.20.20:FF:000017', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(74258, NULL, 'G3DSA:1.20.210.10:FF:000024', NULL, NULL, 'Intron-encoded DNA endonuclease aI3', NULL, NULL, NULL, NULL, NULL, 4),
(74259, NULL, 'G3DSA:2.130.10.10:FF:004280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74260, NULL, 'G3DSA:1.25.40.180:FF:000227', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74261, NULL, 'G3DSA:3.30.160.60:FF:004869', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74262, NULL, 'G3DSA:1.50.40.10:FF:000033', NULL, NULL, 'Solute carrier family 25 member 44', NULL, NULL, NULL, NULL, NULL, 4),
(74263, NULL, 'G3DSA:3.40.430.10:FF:000045', NULL, NULL, 'Dihydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(74264, NULL, 'G3DSA:2.60.200.30:FF:000022', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(74265, NULL, 'G3DSA:1.50.10.160:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74266, NULL, 'G3DSA:1.10.238.10:FF:001265', NULL, NULL, 'Calcium-binding EF-hand domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(74267, NULL, 'G3DSA:1.20.1260.80:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74268, NULL, 'G3DSA:1.10.472.10:FF:000561', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74269, NULL, 'G3DSA:3.40.50.300:FF:008057', NULL, NULL, 'TrwK protein', NULL, NULL, NULL, NULL, NULL, 4),
(74270, NULL, 'G3DSA:1.20.5.780:FF:000017', NULL, NULL, 'FXYD domain-containing ion transport regulator', NULL, NULL, NULL, NULL, NULL, 4),
(74271, NULL, 'G3DSA:1.20.59.10:FF:000015', NULL, NULL, 'Chorismate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(74272, NULL, 'G3DSA:3.40.50.300:FF:003695', NULL, NULL, 'DEXH (Asp-Glu-X-His) box polypeptide 58', NULL, NULL, NULL, NULL, NULL, 4),
(74273, NULL, 'G3DSA:1.20.58.1070:FF:000024', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74274, NULL, 'G3DSA:3.30.160.60:FF:000687', NULL, NULL, 'Zinc finger and AT-hook domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(74275, NULL, 'G3DSA:1.10.287.70:FF:000592', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74276, NULL, 'G3DSA:2.60.40.10:FF:004493', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74277, NULL, 'G3DSA:3.50.50.60:FF:001140', NULL, NULL, 'FAD-dependent oxidoreductase domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(74278, NULL, 'G3DSA:1.20.1250.10:FF:000076', NULL, NULL, 'Erythropoietin', NULL, NULL, NULL, NULL, NULL, 4),
(74279, NULL, 'G3DSA:1.10.510.10:FF:001179', NULL, NULL, 'Serine/threonine-protein kinase LMTK1', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(74280, NULL, 'G3DSA:1.20.920.30:FF:000005', NULL, NULL, 'Dynein, axonemal, heavy chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(74281, NULL, 'G3DSA:3.90.940.10:FF:000005', NULL, NULL, 'Probable DNA-directed RNA polymerases I, II, and III subunit RPABC2', NULL, NULL, NULL, NULL, NULL, 4),
(74282, NULL, 'G3DSA:3.30.1490.20:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74283, NULL, 'G3DSA:3.40.50.11380:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74284, NULL, 'G3DSA:4.10.520.10:FF:000004', NULL, NULL, 'HU family DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(74285, NULL, 'G3DSA:1.10.510.10:FF:000779', NULL, NULL, 'CAMK/CAMKL protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(74286, NULL, 'G3DSA:3.90.550.10:FF:000666', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74287, NULL, 'G3DSA:1.25.40.10:FF:000467', NULL, NULL, 'Putative rRNA biogenesis protein RRP5', NULL, NULL, NULL, NULL, NULL, 4),
(74288, NULL, 'G3DSA:2.30.30.140:FF:000260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74289, NULL, 'G3DSA:3.40.50.150:FF:001407', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74290, NULL, 'G3DSA:3.30.420.40:FF:000595', NULL, NULL, '105/110 kDa heat shock protein, nucleotide-binding domain', NULL, NULL, NULL, NULL, NULL, 4),
(74291, NULL, 'G3DSA:1.20.1270.60:FF:000261', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74292, NULL, 'G3DSA:3.40.50.2020:FF:000152', NULL, NULL, 'Probable adenine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(74293, NULL, 'G3DSA:4.10.410.10:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74294, NULL, 'G3DSA:3.30.40.10:FF:002249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74295, NULL, 'G3DSA:1.25.10.10:FF:000639', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(74296, NULL, 'G3DSA:2.60.40.10:FF:001856', NULL, NULL, 'Hemicentin 2', NULL, NULL, NULL, NULL, NULL, 4),
(74297, NULL, 'G3DSA:1.10.472.10:FF:000252', NULL, NULL, 'Protein CBG20098', NULL, NULL, NULL, NULL, NULL, 4),
(74298, NULL, 'G3DSA:2.60.40.10:FF:000822', NULL, NULL, 'tenascin-X', NULL, NULL, NULL, NULL, NULL, 4),
(74299, NULL, 'G3DSA:3.40.50.1170:FF:000003', NULL, NULL, '60 kDa lysophospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(74300, NULL, 'G3DSA:3.40.50.720:FF:001792', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(74301, NULL, 'G3DSA:2.10.90.10:FF:000030', NULL, NULL, 'Vascular endothelial growth factor B', NULL, NULL, NULL, NULL, NULL, 4),
(74302, NULL, 'G3DSA:3.80.10.10:FF:002520', NULL, NULL, 'Erbb2 interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(74303, NULL, 'G3DSA:3.40.50.2000:FF:000736', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(74304, NULL, 'G3DSA:3.30.30.30:FF:000040', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74305, NULL, 'G3DSA:3.30.1140.32:FF:000010', NULL, NULL, '30S ribosomal protein S3', NULL, NULL, NULL, NULL, NULL, 4),
(74306, NULL, 'G3DSA:3.30.420.40:FF:000067', NULL, NULL, 'Pantothenate kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(74307, NULL, 'G3DSA:3.40.50.300:FF:001222', NULL, NULL, 'Torsin family 3, member A', NULL, NULL, NULL, NULL, NULL, 4),
(74308, NULL, 'G3DSA:1.10.510.10:FF:004040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74309, NULL, 'G3DSA:3.40.250.10:FF:000082', NULL, NULL, 'Thiosulfate:glutathione sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(74310, NULL, 'G3DSA:2.30.110.10:FF:000044', NULL, NULL, 'POSSIBLE OXIDOREDUCTASE', NULL, NULL, NULL, NULL, NULL, 4),
(74311, NULL, 'G3DSA:3.40.50.970:FF:000012', NULL, NULL, 'Pyruvate:ferredoxin (Flavodoxin) oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(74312, NULL, 'G3DSA:3.50.30.30:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74313, NULL, 'G3DSA:3.40.190.10:FF:000037', NULL, NULL, 'HTH-type transcriptional regulator CysB', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(74314, NULL, 'G3DSA:3.30.63.10:FF:000003', NULL, NULL, 'Membrane-associated guanylate kinase, WW and PDZ domain-containing protein 3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(74315, NULL, 'G3DSA:3.30.1490.20:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74316, NULL, 'G3DSA:3.40.50.300:FF:001694', NULL, NULL, 'Adenylate kinase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(74317, NULL, 'G3DSA:3.40.50.300:FF:004875', NULL, NULL, 'ATP-dependent RNA and DNA helicase, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74318, NULL, 'G3DSA:2.40.50.90:FF:000095', NULL, NULL, 'Qin', NULL, NULL, NULL, NULL, NULL, 4),
(74319, NULL, 'G3DSA:1.20.1560.10:FF:000734', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74320, NULL, 'G3DSA:3.40.50.300:FF:006584', NULL, NULL, 'ABC transporter AbcG18, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74321, NULL, 'G3DSA:3.50.50.60:FF:000993', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74322, NULL, 'G3DSA:3.80.10.10:FF:000278', NULL, NULL, 'PH domain and leucine rich repeat protein phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(74323, NULL, 'G3DSA:1.10.510.10:FF:003421', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74324, NULL, 'G3DSA:3.30.420.80:FF:000028', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74325, NULL, 'G3DSA:3.90.660.10:FF:000079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74326, NULL, 'G3DSA:2.30.30.100:FF:000164', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm1', NULL, NULL, NULL, NULL, NULL, 4),
(74327, NULL, 'G3DSA:3.30.160.60:FF:006179', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74328, NULL, 'G3DSA:3.10.290.70:FF:000002', NULL, NULL, '40S ribosomal protein S8', NULL, NULL, NULL, NULL, NULL, 4),
(74329, NULL, 'G3DSA:3.30.70.330:FF:002760', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74330, NULL, 'G3DSA:1.10.287.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74331, NULL, 'G3DSA:1.20.1000.10:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74332, NULL, 'G3DSA:1.10.8.10:FF:000003', NULL, NULL, 'UV excision repair protein RAD23 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(74333, NULL, 'G3DSA:1.25.40.10:FF:003340', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g15630, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(74334, NULL, 'G3DSA:2.60.40.1180:FF:000199', NULL, NULL, 'Glucosylceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(74335, NULL, 'G3DSA:3.30.365.10:FF:000002', NULL, NULL, 'Xanthine dehydrogenase oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(74336, NULL, 'G3DSA:3.90.79.10:FF:000166', NULL, NULL, 'Isopentenyl-diphosphate delta-isomerase, type 1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(74337, NULL, 'G3DSA:3.90.190.10:FF:000026', NULL, NULL, 'tyrosine-protein phosphatase non-receptor type 9', NULL, NULL, NULL, NULL, NULL, 4),
(74338, NULL, 'G3DSA:2.130.10.10:FF:001508', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(74339, NULL, 'G3DSA:2.60.120.200:FF:000754', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74340, NULL, 'G3DSA:1.10.12.70:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74341, NULL, 'G3DSA:1.10.150.850:FF:000006', NULL, NULL, 'Transcription elongation factor SPT6', NULL, NULL, NULL, NULL, NULL, 4),
(74342, NULL, 'G3DSA:3.40.50.200:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74343, NULL, 'G3DSA:2.130.10.10:FF:003060', NULL, NULL, 'Echinoderm microtubule-associated protein-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(74344, NULL, 'G3DSA:2.60.40.1530:FF:000006', NULL, NULL, 'Integrin subunit alpha 5', NULL, NULL, NULL, NULL, NULL, 4),
(74345, NULL, 'G3DSA:2.60.40.2300:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74346, NULL, 'G3DSA:3.10.20.10:FF:000023', NULL, NULL, 'Cell death-inducing DFFA-like effector a', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(74347, NULL, 'G3DSA:1.20.1560.10:FF:000251', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(74348, NULL, 'G3DSA:3.40.50.720:FF:000156', NULL, NULL, 'Ubiquitin-like modifier-activating enzyme ATG7', NULL, NULL, NULL, NULL, NULL, 4),
(74349, NULL, 'G3DSA:2.60.40.10:FF:002475', NULL, NULL, 'CRE-UNC-22 protein', NULL, NULL, NULL, NULL, NULL, 4),
(74350, NULL, 'G3DSA:3.40.50.300:FF:008618', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74351, NULL, 'G3DSA:3.30.200.20:FF:001371', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(74352, NULL, 'G3DSA:2.60.40.10:FF:003565', NULL, NULL, 'Interferon alpha/beta receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(74353, NULL, 'G3DSA:3.40.50.410:FF:000182', NULL, NULL, 'Uncharacterized protein, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(74354, NULL, 'G3DSA:1.10.260.40:FF:000021', NULL, NULL, 'Trehalose operon repressor', NULL, NULL, NULL, NULL, NULL, 4),
(74355, NULL, 'G3DSA:2.30.29.30:FF:000680', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(74356, NULL, 'G3DSA:3.40.30.10:FF:001034', NULL, NULL, 'Selenoprotein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74357, NULL, 'G3DSA:3.40.190.290:FF:000085', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(74358, NULL, 'G3DSA:2.40.10.10:FF:000220', NULL, NULL, 'Serine protease 1', NULL, NULL, NULL, NULL, NULL, 4),
(74359, NULL, 'G3DSA:3.40.1170.10:FF:000030', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(74360, NULL, 'G3DSA:3.30.2300.20:FF:000001', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase M', NULL, NULL, NULL, NULL, NULL, 4),
(74361, NULL, 'G3DSA:3.20.20.70:FF:000372', NULL, NULL, 'Biotin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(74362, NULL, 'G3DSA:3.40.50.300:FF:005600', NULL, NULL, 'Dhx38 protein', NULL, NULL, NULL, NULL, NULL, 4),
(74363, NULL, 'G3DSA:1.20.1060.10:FF:000005', NULL, NULL, 'DNA polymerase 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74364, NULL, 'G3DSA:1.10.150.20:FF:000260', NULL, NULL, 'DNA repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74365, NULL, 'G3DSA:3.30.70.330:FF:000630', NULL, NULL, 'RNA-binding motif protein 12B', NULL, NULL, NULL, NULL, NULL, 4),
(74366, NULL, 'G3DSA:1.25.40.10:FF:001086', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g33170', NULL, NULL, NULL, NULL, NULL, 4),
(74367, NULL, 'G3DSA:3.90.1010.10:FF:000018', NULL, NULL, 'Iron-sulfur cluster assembly protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(74368, NULL, 'G3DSA:3.30.428.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74369, NULL, 'G3DSA:1.20.5.4820:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74370, NULL, 'G3DSA:1.10.287.110:FF:000031', NULL, NULL, 'Molecular chaperone DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(74371, NULL, 'G3DSA:1.10.287.130:FF:000037', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(74372, NULL, 'G3DSA:3.90.170.10:FF:000013', NULL, NULL, 'Adenylosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(74373, NULL, 'G3DSA:1.10.287.70:FF:000277', NULL, NULL, 'KCNN (Potassium K ChaNNel, calcium activated)-Like', NULL, NULL, NULL, NULL, NULL, 4),
(74374, NULL, 'G3DSA:1.25.10.10:FF:000494', NULL, NULL, 'Sister chromatid cohesion protein', NULL, NULL, NULL, NULL, NULL, 4),
(74375, NULL, 'G3DSA:3.40.440.10:FF:000001', NULL, NULL, 'Adenylosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(74376, NULL, 'G3DSA:3.30.450.20:FF:000574', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74377, NULL, 'G3DSA:1.10.238.10:FF:000753', NULL, NULL, 'Hydroxymethylglutaryl-CoA lyase, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74378, NULL, 'G3DSA:3.30.230.80:FF:000002', NULL, NULL, 'Molecular chaperone HtpG', NULL, NULL, NULL, NULL, NULL, 4),
(74379, NULL, 'G3DSA:2.10.25.10:FF:001469', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(74380, NULL, 'G3DSA:1.10.420.10:FF:000008', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(74381, NULL, 'G3DSA:1.10.441.10:FF:000006', NULL, NULL, 'mannose-6-phosphate isomerase isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(74382, NULL, 'G3DSA:3.40.50.300:FF:001705', NULL, NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(74383, NULL, 'G3DSA:2.60.40.10:FF:000131', NULL, NULL, 'Plexin A2', NULL, NULL, NULL, NULL, NULL, 4),
(74384, NULL, 'G3DSA:2.60.40.10:FF:004509', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74385, NULL, 'G3DSA:1.20.1050.10:FF:000179', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(74386, NULL, 'G3DSA:3.30.160.60:FF:004633', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74387, NULL, 'G3DSA:1.10.1670.40:FF:000001', NULL, NULL, 'Probable DNA-3-methyladenine glycosylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(74388, NULL, 'G3DSA:1.10.20.10:FF:000140', NULL, NULL, 'Histone H3-like centromeric protein cse-4', NULL, NULL, NULL, NULL, NULL, 4),
(74389, NULL, 'G3DSA:2.130.10.10:FF:001727', NULL, NULL, 'F-box/WD repeat-containing protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(74390, NULL, 'G3DSA:2.60.40.770:FF:000005', NULL, NULL, 'Lymphocyte antigen 86', NULL, NULL, NULL, NULL, NULL, 4),
(74391, NULL, 'G3DSA:3.10.180.10:FF:000094', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(74392, NULL, 'G3DSA:3.40.50.300:FF:008473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74393, NULL, 'G3DSA:3.30.70.330:FF:002119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74394, NULL, 'G3DSA:1.20.890.10:FF:000018', NULL, NULL, 'COMPASS component SDC1', NULL, NULL, NULL, NULL, NULL, 4),
(74395, NULL, 'G3DSA:1.10.287.1970:FF:000005', NULL, NULL, 'Alanine aminotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74396, NULL, 'G3DSA:1.50.10.10:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74397, NULL, 'G3DSA:3.20.20.80:FF:000066', NULL, NULL, 'Beta-amylase', NULL, NULL, NULL, NULL, NULL, 4),
(74398, NULL, 'G3DSA:3.90.1530.10:FF:000018', NULL, NULL, 'ParB domain protein nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(74399, NULL, 'G3DSA:3.30.160.40:FF:000024', NULL, NULL, 'Porphobilinogen deaminase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(74400, NULL, 'G3DSA:2.40.30.20:FF:000005', NULL, NULL, 'Riboflavin synthase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(74401, NULL, 'G3DSA:1.10.418.10:FF:000087', NULL, NULL, 'p-loop nucleoside triphosphate hydrolase superfamily protein with CH (Calponin Homology) domain', NULL, NULL, NULL, NULL, NULL, 4),
(74402, NULL, 'G3DSA:1.10.8.60:FF:000024', NULL, NULL, 'DnaA regulatory inactivator Hda', NULL, NULL, NULL, NULL, NULL, 4),
(74403, NULL, 'G3DSA:3.30.70.1530:FF:000002', NULL, NULL, 'Lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(74404, NULL, 'G3DSA:3.30.450.40:FF:000001', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(74405, NULL, 'G3DSA:3.30.1050.10:FF:000034', NULL, NULL, 'Spore associated protein, SapD', NULL, NULL, NULL, NULL, NULL, 4),
(74406, NULL, 'G3DSA:1.10.3500.10:FF:000003', NULL, NULL, 'S1 RNA-binding domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(74407, NULL, 'G3DSA:1.10.630.10:FF:000726', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74408, NULL, 'G3DSA:3.40.350.10:FF:000027', NULL, NULL, 'Aminopeptidase P', NULL, NULL, NULL, NULL, NULL, 4),
(74409, NULL, 'G3DSA:2.40.50.40:FF:000029', NULL, NULL, 'chromodomain Y-like protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(74410, NULL, 'G3DSA:3.40.50.10330:FF:000047', NULL, NULL, 'ATP-NAD kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(74411, NULL, 'G3DSA:2.40.160.110:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74412, NULL, 'G3DSA:2.80.10.50:FF:000101', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(74413, NULL, 'G3DSA:3.30.1370.100:FF:000014', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(74414, NULL, 'G3DSA:3.40.50.1220:FF:000041', NULL, NULL, 'NAD-dependent protein deacetylase sirtuin-3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(74415, NULL, 'G3DSA:3.40.50.2300:FF:000944', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74416, NULL, 'G3DSA:3.90.780.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74417, NULL, 'G3DSA:4.10.280.10:FF:000199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74418, NULL, 'G3DSA:1.10.10.1180:FF:000003', NULL, NULL, 'Heh2p', NULL, NULL, NULL, NULL, NULL, 4),
(74419, NULL, 'G3DSA:2.60.40.60:FF:001085', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74420, NULL, 'G3DSA:1.20.58.60:FF:000713', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74421, NULL, 'G3DSA:2.160.20.10:FF:000232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74422, NULL, 'G3DSA:2.120.10.30:FF:000082', NULL, NULL, 'Sorbosone dehydrogenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(74423, NULL, 'G3DSA:3.30.450.190:FF:000027', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(74424, NULL, 'G3DSA:3.30.40.10:FF:000220', NULL, NULL, 'E3 ubiquitin-protein ligase RNF31 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(74425, NULL, 'G3DSA:3.40.50.300:FF:006820', NULL, NULL, 'Axonemal dynein heavy chain isotype 11', NULL, NULL, NULL, NULL, NULL, 4),
(74426, NULL, 'G3DSA:1.10.3380.30:FF:000026', NULL, NULL, 'SKI complex RNA helicase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(74427, NULL, 'G3DSA:3.40.50.1820:FF:001053', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(74428, NULL, 'G3DSA:3.30.160.60:FF:005903', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74429, NULL, 'G3DSA:1.10.2000.10:FF:000072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74430, NULL, 'G3DSA:3.60.10.10:FF:000251', NULL, NULL, 'Deoxyribonuclease gamma [precursor]', NULL, NULL, NULL, NULL, NULL, 4),
(74431, NULL, 'G3DSA:3.50.50.60:FF:000285', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(74432, NULL, 'G3DSA:1.25.10.10:FF:001258', NULL, NULL, 'HEAT repeat containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(74433, NULL, 'G3DSA:3.30.70.260:FF:000165', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74434, NULL, 'G3DSA:1.10.246.230:FF:000002', NULL, NULL, 'Gamma-glutamyltranspeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(74435, NULL, 'G3DSA:4.10.270.10:FF:000007', NULL, NULL, 'Myosin II homolog (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(74436, NULL, 'G3DSA:1.10.287.860:FF:000003', NULL, NULL, 'GTP pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(74437, NULL, 'G3DSA:3.40.50.1240:FF:000047', NULL, NULL, 'Putative phosphoglycerate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(74438, NULL, 'G3DSA:2.60.40.150:FF:000730', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74439, NULL, 'G3DSA:3.40.1280.10:FF:000111', NULL, NULL, 'tRNA/rRNA methyltransferase (SpoU) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(74440, NULL, 'G3DSA:2.60.120.330:FF:000181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74441, NULL, 'G3DSA:3.40.50.150:FF:001716', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74442, NULL, 'G3DSA:1.20.1280.50:FF:000230', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74443, NULL, 'G3DSA:3.80.10.10:FF:004549', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74444, NULL, 'G3DSA:1.10.10.2660:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74445, NULL, 'G3DSA:3.30.160.60:FF:000890', NULL, NULL, 'U1 small nuclear ribonucleoprotein C', NULL, NULL, NULL, NULL, NULL, 4),
(74446, NULL, 'G3DSA:1.25.40.20:FF:001628', NULL, NULL, 'Mindbomb E3 ubiquitin protein ligase 2', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(74447, NULL, 'G3DSA:3.90.190.10:FF:000335', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74448, NULL, 'G3DSA:1.10.510.10:FF:002707', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(74449, NULL, 'G3DSA:1.20.1250.20:FF:001478', NULL, NULL, 'Protein NRT1/ PTR FAMILY 4.2', NULL, NULL, NULL, NULL, NULL, 4),
(74450, NULL, 'G3DSA:1.20.120.850:FF:000043', NULL, NULL, 'Helicase of the snf2/rad54 family (Amino end), hypothetical', NULL, NULL, NULL, NULL, NULL, 4),
(74451, NULL, 'G3DSA:3.80.10.10:FF:000497', NULL, NULL, 'Leucine-rich repeat transmembrane protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(74452, NULL, 'G3DSA:3.40.1160.10:FF:000057', NULL, NULL, 'Glutamate 5-kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74453, NULL, 'G3DSA:3.30.160.60:FF:002924', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74454, NULL, 'G3DSA:1.25.40.410:FF:000004', NULL, NULL, 'Dedicator of cytokinesis protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(74455, NULL, 'G3DSA:1.10.4160.10:FF:000021', NULL, NULL, 'Similar to purine-cytosine permease', NULL, NULL, NULL, NULL, NULL, 4),
(74456, NULL, 'G3DSA:2.10.50.10:FF:000162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74457, NULL, 'G3DSA:3.30.450.60:FF:000007', NULL, NULL, 'AP complex subunit sigma', NULL, NULL, NULL, NULL, NULL, 4),
(74458, NULL, 'G3DSA:1.25.40.10:FF:004593', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74459, NULL, 'G3DSA:3.90.1170.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74460, NULL, 'G3DSA:3.40.50.300:FF:006112', NULL, NULL, 'ADP ribosylation factor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(74461, NULL, 'G3DSA:3.40.50.720:FF:001483', NULL, NULL, 'Short-chain dehydrogenase/reductase SDR', NULL, NULL, NULL, NULL, NULL, 4),
(74462, NULL, 'G3DSA:2.30.30.140:FF:000125', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74463, NULL, 'G3DSA:1.10.10.60:FF:000879', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74464, NULL, 'G3DSA:3.40.50.2000:FF:000197', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(74465, NULL, 'G3DSA:3.30.70.330:FF:002428', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74466, NULL, 'G3DSA:1.20.140.50:FF:000013', NULL, NULL, 'pH-response regulator protein palA/RIM20', NULL, NULL, NULL, NULL, NULL, 4),
(74467, NULL, 'G3DSA:3.90.1200.10:FF:000033', NULL, NULL, 'Spore coat protein S', NULL, NULL, NULL, NULL, NULL, 4),
(74468, NULL, 'G3DSA:2.20.25.240:FF:000006', NULL, NULL, 'Lola-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(74469, NULL, 'G3DSA:2.30.22.10:FF:000006', NULL, NULL, 'Protein GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(74470, NULL, 'G3DSA:1.25.40.1030:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74471, NULL, 'G3DSA:2.20.100.10:FF:000141', NULL, NULL, 'Lonely heart, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(74472, NULL, 'G3DSA:1.20.1080.10:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74473, NULL, 'G3DSA:1.10.510.10:FF:004293', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74474, NULL, 'G3DSA:1.25.40.20:FF:001319', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74475, NULL, 'G3DSA:1.20.990.10:FF:000037', NULL, NULL, 'NADPH--cytochrome P450 reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74476, NULL, 'G3DSA:3.90.480.10:FF:000003', NULL, NULL, 'Sulfite reductase', NULL, NULL, NULL, NULL, NULL, 4),
(74477, NULL, 'G3DSA:3.40.1390.20:FF:000015', NULL, NULL, 'Probable manganese-dependent inorganic pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(74478, NULL, 'G3DSA:3.30.559.10:FF:000020', NULL, NULL, 'Enterobactin synthetase component F', NULL, NULL, NULL, NULL, NULL, 4),
(74479, NULL, 'G3DSA:3.50.50.60:FF:001246', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(74480, NULL, 'G3DSA:3.30.40.10:FF:000759', NULL, NULL, 'COMPASS component SPP1', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(74481, NULL, 'G3DSA:4.10.60.10:FF:000107', NULL, NULL, 'Putative Zinc knuckle domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(74482, NULL, 'G3DSA:3.40.630.30:FF:000151', NULL, NULL, 'Ribosomal-protein-alanine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(74483, NULL, 'G3DSA:2.70.160.11:FF:000045', NULL, NULL, 'Protein arginine N-methyltransferase 9', NULL, NULL, NULL, NULL, NULL, 4),
(74484, NULL, 'G3DSA:1.25.40.90:FF:000087', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74485, NULL, 'G3DSA:1.10.510.10:FF:003112', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74486, NULL, 'G3DSA:3.40.850.10:FF:000161', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(74487, NULL, 'G3DSA:1.20.1070.10:FF:001832', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74488, NULL, 'G3DSA:1.20.1540.10:FF:000031', NULL, NULL, 'RHOMBOID-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(74489, NULL, 'G3DSA:2.60.120.200:FF:000046', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(74490, NULL, 'G3DSA:3.30.200.20:FF:002096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74491, NULL, 'G3DSA:3.80.10.10:FF:003392', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74492, NULL, 'G3DSA:1.25.40.120:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74493, NULL, 'G3DSA:3.40.50.300:FF:006893', NULL, NULL, 'Type II secretion system protein, conjectural', NULL, NULL, NULL, NULL, NULL, 4),
(74494, NULL, 'G3DSA:3.30.160.60:FF:003649', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74495, NULL, 'G3DSA:4.10.1060.10:FF:000005', NULL, NULL, 'RNA-binding protein 10 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(74496, NULL, 'G3DSA:1.25.40.430:FF:000015', NULL, NULL, 'Checkpoint serine/threonine-protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74497, NULL, 'G3DSA:1.20.1250.20:FF:000950', NULL, NULL, 'Predicted arabinose efflux permease, MFS family', NULL, NULL, NULL, NULL, NULL, 4),
(74498, NULL, 'G3DSA:3.40.50.11550:FF:000003', NULL, NULL, 'Putative lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(74499, NULL, 'G3DSA:1.20.1070.10:FF:000742', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74500, NULL, 'G3DSA:3.30.70.330:FF:000557', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(74501, NULL, 'G3DSA:3.30.60.30:FF:000188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74502, NULL, 'G3DSA:2.60.40.10:FF:000928', NULL, NULL, 'Leucine rich repeat, Ig-like and transmembrane domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(74503, NULL, 'G3DSA:2.60.40.2070:FF:000005', NULL, NULL, 'Outer membrane fimbrial usher protein', NULL, NULL, NULL, NULL, NULL, 4),
(74504, NULL, 'G3DSA:3.60.21.10:FF:000276', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(74505, NULL, 'G3DSA:3.30.160.60:FF:004942', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74506, NULL, 'G3DSA:3.30.70.1230:FF:000215', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(74507, NULL, 'G3DSA:1.10.287.130:FF:000256', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(74508, NULL, 'G3DSA:2.60.120.650:FF:000052', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74509, NULL, 'G3DSA:1.10.287.470:FF:000009', NULL, NULL, 'Multidrug resistance protein MdtN', NULL, NULL, NULL, NULL, NULL, 4),
(74510, NULL, 'G3DSA:1.10.472.10:FF:000706', NULL, NULL, 'G2/M mitosis-specific cyclin B, copy C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(74511, NULL, 'G3DSA:3.10.20.650:FF:000001', NULL, NULL, 'Calmodulin-like protein containing EF hand domain', NULL, NULL, NULL, NULL, NULL, 4),
(74512, NULL, 'G3DSA:3.40.50.300:FF:006365', NULL, NULL, 'Small GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74513, NULL, 'G3DSA:3.40.50.1820:FF:001761', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(74514, NULL, 'G3DSA:3.90.1640.20:FF:000001', NULL, NULL, 'D-glutamate cyclase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(74515, NULL, 'G3DSA:3.30.30.30:FF:000017', NULL, NULL, 'Chaperone DnaK', NULL, NULL, NULL, NULL, NULL, 4),
(74516, NULL, 'G3DSA:2.40.240.10:FF:000017', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(74517, NULL, 'G3DSA:3.30.360.10:FF:000137', NULL, NULL, 'Bifunctional aspartate kinase/homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(74518, NULL, 'G3DSA:3.90.1150.10:FF:000399', NULL, NULL, 'Alanine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(74519, NULL, 'G3DSA:3.30.420.10:FF:000524', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74520, NULL, 'G3DSA:2.30.30.490:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74521, NULL, 'G3DSA:1.25.40.70:FF:000081', NULL, NULL, 'Zgc:158659', NULL, NULL, NULL, NULL, NULL, 4),
(74522, NULL, 'G3DSA:2.60.40.10:FF:001547', NULL, NULL, 'Cytokine receptor-like factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(74523, NULL, 'G3DSA:3.20.20.80:FF:000627', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74524, NULL, 'G3DSA:3.40.50.1820:FF:000671', NULL, NULL, 'Platelet-activating factor acetylhydrolase, isoform II', NULL, NULL, NULL, NULL, NULL, 4),
(74525, NULL, 'G3DSA:1.25.40.800:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74526, NULL, 'G3DSA:3.30.930.10:FF:000355', NULL, NULL, 'Histidyl-tRNA synthetase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(74527, NULL, 'G3DSA:2.60.40.60:FF:000320', NULL, NULL, 'CaDHerin family', NULL, NULL, NULL, NULL, NULL, 4),
(74528, NULL, 'G3DSA:2.60.40.10:FF:002840', NULL, NULL, 'Protein NBR1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(74529, NULL, 'G3DSA:1.10.3120.10:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74530, NULL, 'G3DSA:3.40.50.620:FF:000036', NULL, NULL, 'Glutamine-dependent NAD(+) synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(74531, NULL, 'G3DSA:3.10.20.90:FF:000592', NULL, NULL, 'UBX domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(74532, NULL, 'G3DSA:3.40.50.80:FF:000067', NULL, NULL, 'WGS project CABT00000000 data, contig 2.6', NULL, NULL, NULL, NULL, NULL, 4),
(74533, NULL, 'G3DSA:1.25.10.10:FF:001567', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74534, NULL, 'G3DSA:1.20.1740.10:FF:000052', NULL, NULL, 'Lysine histidine transporter-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(74535, NULL, 'G3DSA:1.20.1070.10:FF:000539', NULL, NULL, 'GH13988p', NULL, NULL, NULL, NULL, NULL, 4),
(74536, NULL, 'G3DSA:1.20.1250.20:FF:001787', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74537, NULL, 'G3DSA:3.30.200.160:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74538, NULL, 'G3DSA:3.40.720.10:FF:000371', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74539, NULL, 'G3DSA:3.30.160.380:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74540, NULL, 'G3DSA:3.30.160.60:FF:002688', NULL, NULL, 'Crooked legs, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(74541, NULL, 'G3DSA:1.25.40.20:FF:001504', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74542, NULL, 'G3DSA:1.10.1270.10:FF:000001', NULL, NULL, 'Trp operon repressor', NULL, NULL, NULL, NULL, NULL, 4),
(74543, NULL, 'G3DSA:3.40.50.1970:FF:000013', NULL, NULL, 'Phosphoribosylaminoimidazole carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(74544, NULL, 'G3DSA:3.30.497.10:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74545, NULL, 'G3DSA:1.10.565.10:FF:000029', NULL, NULL, 'Ecdysone-induced protein 75B, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(74546, NULL, 'G3DSA:1.25.40.10:FF:002699', NULL, NULL, 'U3 small nucleolar RNA-associated protein 6-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(74547, NULL, 'G3DSA:3.30.1010.10:FF:000015', NULL, NULL, 'Serine-protein kinase ATM', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(74548, NULL, 'G3DSA:3.20.20.140:FF:000048', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(74549, NULL, 'G3DSA:3.40.50.150:FF:001374', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74550, NULL, 'G3DSA:1.20.58.60:FF:000680', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74551, NULL, 'G3DSA:1.10.3470.10:FF:000005', NULL, NULL, 'Zinc ABC transporter, permease component', NULL, NULL, NULL, NULL, NULL, 4),
(74552, NULL, 'G3DSA:1.10.10.10:FF:002112', NULL, NULL, 'Response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(74553, NULL, 'G3DSA:2.40.10.220:FF:000002', NULL, NULL, 'Flagellar brake protein YcgR', NULL, NULL, NULL, NULL, NULL, 4),
(74554, NULL, 'G3DSA:1.10.10.10:FF:001494', NULL, NULL, 'Cullin-2', NULL, NULL, NULL, NULL, NULL, 4),
(74555, NULL, 'G3DSA:3.40.50.200:FF:000012', NULL, NULL, 'Tripeptidyl-peptidase 1 preproprotein', NULL, NULL, NULL, NULL, NULL, 4),
(74556, NULL, 'G3DSA:1.20.58.60:FF:000005', NULL, NULL, 'Actinin alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(74557, NULL, 'G3DSA:2.60.120.10:FF:000066', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(74558, NULL, 'G3DSA:1.10.3210.30:FF:000003', NULL, NULL, 'CRISPR-associated endonuclease/helicase Cas3', NULL, NULL, NULL, NULL, NULL, 4),
(74559, NULL, 'G3DSA:1.10.3430.10:FF:000031', NULL, NULL, 'Rh', NULL, NULL, NULL, NULL, NULL, 4),
(74560, NULL, 'G3DSA:3.60.10.10:FF:000357', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74561, NULL, 'G3DSA:1.20.1250.20:FF:000618', NULL, NULL, 'Sialic acid-transport membrane protein nanT', NULL, NULL, NULL, NULL, NULL, 4),
(74562, NULL, 'G3DSA:3.90.226.10:FF:000071', NULL, NULL, 'Putative enoyl-CoA hydratase PaaB', NULL, NULL, NULL, NULL, NULL, 4),
(74563, NULL, 'G3DSA:1.25.40.10:FF:004065', NULL, NULL, 'Dnaj-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(74564, NULL, 'G3DSA:1.20.58.60:FF:000477', NULL, NULL, 'Spectrin repeat containing nuclear envelope protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(74565, NULL, 'G3DSA:3.40.50.300:FF:007854', NULL, NULL, 'PeRoXisome assembly factor', NULL, NULL, NULL, NULL, NULL, 4),
(74566, NULL, 'G3DSA:2.60.40.10:FF:000586', NULL, NULL, 'motile sperm domain-containing protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(74567, NULL, 'G3DSA:2.60.40.1170:FF:000090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74568, NULL, 'G3DSA:3.30.70.330:FF:002451', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74569, NULL, 'G3DSA:2.40.10.240:FF:000008', NULL, NULL, 'S-adenosylmethionine:tRNA ribosyltransferase-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(74570, NULL, 'G3DSA:1.25.40.20:FF:001651', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(74571, NULL, 'G3DSA:1.50.40.10:FF:000398', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74572, NULL, 'G3DSA:3.30.710.10:FF:000283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74573, NULL, 'G3DSA:3.40.190.10:FF:000801', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74574, NULL, 'G3DSA:2.60.260.20:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74575, NULL, 'G3DSA:3.30.2300.10:FF:000009', NULL, NULL, 'THUMP domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(74576, NULL, 'G3DSA:3.20.20.60:FF:000060', NULL, NULL, 'Citrate lyase beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(74577, NULL, 'G3DSA:2.60.120.10:FF:000408', NULL, NULL, 'cGMP-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(74578, NULL, 'G3DSA:3.40.50.1010:FF:000107', NULL, NULL, 'Ribonuclease VapC1', NULL, NULL, NULL, NULL, NULL, 4),
(74579, NULL, 'G3DSA:3.40.50.300:FF:002998', NULL, NULL, 'UCK2 isoform 5', NULL, NULL, NULL, NULL, NULL, 4),
(74580, NULL, 'G3DSA:3.10.20.90:FF:000120', NULL, NULL, 'Plexin b1a', NULL, NULL, NULL, NULL, NULL, 4),
(74581, NULL, 'G3DSA:1.10.510.10:FF:000706', NULL, NULL, 'Cyclin-dependent kinase 1', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(74582, NULL, 'G3DSA:2.60.120.200:FF:000193', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(74583, NULL, 'G3DSA:2.130.10.10:FF:002599', NULL, NULL, 'Sema domain, immunoglobulin domain (Ig), short basic domain, secreted, (semaphorin) 3Gb', NULL, NULL, NULL, NULL, NULL, 4),
(74584, NULL, 'G3DSA:1.25.40.10:FF:001406', NULL, NULL, 'Protein SULFUR DEFICIENCY-INDUCED 2', NULL, NULL, NULL, NULL, NULL, 4),
(74585, NULL, 'G3DSA:2.130.10.10:FF:003217', NULL, NULL, 'Flagellar associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(74586, NULL, 'G3DSA:2.30.30.180:FF:000002', NULL, NULL, 'Ribosome maturation factor RimP', NULL, NULL, NULL, NULL, NULL, 4),
(74587, NULL, 'G3DSA:3.30.230.10:FF:000133', NULL, NULL, 'Mlh3p', NULL, NULL, NULL, NULL, NULL, 4),
(74588, NULL, 'G3DSA:3.40.630.30:FF:000403', NULL, NULL, 'Cilia- and flagella-associated protein 61', NULL, NULL, NULL, NULL, NULL, 4),
(74589, NULL, 'G3DSA:3.80.20.20:FF:000096', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74590, NULL, 'G3DSA:1.20.1250.20:FF:000309', NULL, NULL, 'Glucuronide carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(74591, NULL, 'G3DSA:1.10.150.50:FF:000123', NULL, NULL, 'Transcription factor ets-4', NULL, NULL, NULL, NULL, NULL, 4),
(74592, NULL, 'G3DSA:2.40.50.140:FF:000733', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74593, NULL, 'G3DSA:3.10.20.80:FF:000004', NULL, NULL, 'Translation initiation factor IF-3', NULL, NULL, NULL, NULL, NULL, 4),
(74594, NULL, 'G3DSA:2.10.220.10:FF:000169', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(74595, NULL, 'G3DSA:1.25.10.10:FF:002894', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74596, NULL, 'G3DSA:1.10.555.10:FF:000203', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74597, NULL, 'G3DSA:3.30.160.60:FF:002469', NULL, NULL, 'Zinc finger protein 322', NULL, NULL, NULL, NULL, NULL, 4),
(74598, NULL, 'G3DSA:2.60.120.10:FF:000774', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74599, NULL, 'G3DSA:2.40.50.250:FF:000002', NULL, NULL, 'Elongation factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74600, NULL, 'G3DSA:1.10.10.10:FF:000875', NULL, NULL, 'Pre-mRNA-splicing helicase BRR2', NULL, NULL, NULL, NULL, NULL, 4),
(74601, NULL, 'G3DSA:1.10.437.10:FF:000007', NULL, NULL, 'bcl-2 homologous antagonist/killer', NULL, NULL, NULL, NULL, NULL, 4),
(74602, NULL, 'G3DSA:1.20.1070.10:FF:000287', NULL, NULL, 'Dopamine receptor D3', NULL, NULL, NULL, NULL, NULL, 4),
(74603, NULL, 'G3DSA:3.40.50.300:FF:002874', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(74604, NULL, 'G3DSA:2.40.50.140:FF:000205', NULL, NULL, 'Breast cancer susceptibility protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(74605, NULL, 'G3DSA:1.10.357.140:FF:000006', NULL, NULL, 'Protoheme IX farnesyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(74606, NULL, 'G3DSA:1.25.40.20:FF:000015', NULL, NULL, 'calmodulin-binding transcription activator 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(74607, NULL, 'G3DSA:1.10.150.240:FF:000065', NULL, NULL, 'Phosphoglycolate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(74608, NULL, 'G3DSA:3.60.15.10:FF:000109', NULL, NULL, 'Bifunctional adenosylcobinamide kinase/adenosylcobinamide-phosphate guanylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(74609, NULL, 'G3DSA:3.30.300.30:FF:000100', NULL, NULL, 'Nonribosomal peptide synthetase 13', NULL, NULL, NULL, NULL, NULL, 4),
(74610, NULL, 'G3DSA:3.40.710.10:FF:000090', NULL, NULL, 'Penicillin-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(74611, NULL, 'G3DSA:2.40.70.10:FF:000561', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74612, NULL, 'G3DSA:3.30.70.330:FF:001271', NULL, NULL, 'RNP domain protein (AFU_orthologue AFUA_6G12300)', NULL, NULL, NULL, NULL, NULL, 4),
(74613, NULL, 'G3DSA:3.40.50.12780:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74614, NULL, 'G3DSA:1.10.150.870:FF:000001', NULL, NULL, 'DNA polymerase III subunit alpha', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(74615, NULL, 'G3DSA:3.30.70.580:FF:000036', NULL, NULL, 'Pseudouridylate synthase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(74616, NULL, 'G3DSA:3.30.465.10:FF:000021', NULL, NULL, 'Cytokinin dehydrogenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(74617, NULL, 'G3DSA:3.40.570.10:FF:000010', NULL, NULL, 'DNA/RNA non-specific endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(74618, NULL, 'G3DSA:3.30.420.10:FF:000272', NULL, NULL, 'CCR4-NOT transcription complex subunit 8', NULL, NULL, NULL, NULL, NULL, 4),
(74619, NULL, 'G3DSA:2.60.40.10:FF:001295', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', NULL, NULL, NULL, NULL, NULL, 4),
(74620, NULL, 'G3DSA:1.20.5.170:FF:000132', NULL, NULL, 'BZIP transcription factor family', NULL, NULL, NULL, NULL, NULL, 4),
(74621, NULL, 'G3DSA:1.25.40.180:FF:000249', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74622, NULL, 'G3DSA:2.60.40.150:FF:000275', NULL, NULL, 'Phosphatidylinositol 3-kinase VPS34', NULL, NULL, NULL, NULL, NULL, 4),
(74623, NULL, 'G3DSA:3.40.50.1820:FF:000125', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(74624, NULL, 'G3DSA:1.10.860.10:FF:000007', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(74625, NULL, 'G3DSA:3.40.390.10:FF:000148', NULL, NULL, 'Lethal factor', NULL, NULL, NULL, NULL, NULL, 4),
(74626, NULL, 'G3DSA:3.30.230.70:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74627, NULL, 'G3DSA:3.30.40.10:FF:000198', NULL, NULL, 'PHD finger protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(74628, NULL, 'G3DSA:3.30.160.60:FF:003453', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74629, NULL, 'G3DSA:2.160.20.10:FF:000029', NULL, NULL, 'Pectinesterase 4', NULL, NULL, NULL, NULL, NULL, 4),
(74630, NULL, 'G3DSA:2.70.170.10:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74631, NULL, 'G3DSA:3.80.10.10:FF:000733', NULL, NULL, 'F-box/LRR-repeat protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(74632, NULL, 'G3DSA:3.40.50.620:FF:000582', NULL, NULL, 'Isoleucine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(74633, NULL, 'G3DSA:3.30.70.270:FF:000281', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74634, NULL, 'G3DSA:2.130.10.10:FF:003402', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(74635, NULL, 'G3DSA:3.30.160.360:FF:000018', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(74636, NULL, 'G3DSA:3.10.20.620:FF:000003', NULL, NULL, 'Autophagy protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(74637, NULL, 'G3DSA:2.40.10.10:FF:000585', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74638, NULL, 'G3DSA:1.20.140.10:FF:000136', NULL, NULL, 'Acyl-CoA dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74639, NULL, 'G3DSA:2.40.50.140:FF:001133', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74640, NULL, 'G3DSA:2.40.70.10:FF:000252', NULL, NULL, 'Aspartic proteinase nepenthesin-2', NULL, NULL, NULL, NULL, NULL, 4),
(74641, NULL, 'G3DSA:1.25.10.10:FF:002186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74642, NULL, 'G3DSA:3.30.160.60:FF:003306', NULL, NULL, 'Zinc finger and SCAN domain-containing protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(74643, NULL, 'G3DSA:1.10.375.10:FF:000003', NULL, NULL, 'Gag polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(74644, NULL, 'G3DSA:3.90.850.10:FF:000015', NULL, NULL, '2-keto-4-pentenoate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(74645, NULL, 'G3DSA:2.60.120.260:FF:000058', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(74646, NULL, 'G3DSA:2.40.50.140:FF:000424', NULL, NULL, 'Unplaced genomic scaffold supercont1.10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(74647, NULL, 'G3DSA:2.40.50.140:FF:000172', NULL, NULL, 'Sugar ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(74648, NULL, 'G3DSA:3.30.420.40:FF:000628', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(74649, NULL, 'G3DSA:3.30.420.40:FF:000376', NULL, NULL, 'Hexokinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(74650, NULL, 'G3DSA:3.30.559.10:FF:000273', NULL, NULL, 'Os05g0250500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(74651, NULL, 'G3DSA:2.70.98.110:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74652, NULL, 'G3DSA:2.30.42.10:FF:000547', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74653, NULL, 'G3DSA:3.30.40.10:FF:001400', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(74654, NULL, 'G3DSA:3.40.50.10190:FF:000314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74655, NULL, 'G3DSA:1.10.533.10:FF:000023', NULL, NULL, 'DNA-binding death effector domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(74656, NULL, 'G3DSA:3.20.20.70:FF:000748', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74657, NULL, 'G3DSA:1.25.40.20:FF:000690', NULL, NULL, 'ANKS1B isoform 5', NULL, NULL, NULL, NULL, NULL, 4),
(74658, NULL, 'G3DSA:1.20.5.470:FF:000008', NULL, NULL, 'Argininosuccinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(74659, NULL, 'G3DSA:1.10.287.70:FF:000513', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74660, NULL, 'G3DSA:3.30.1490.100:FF:000035', NULL, NULL, 'Related to DNA polymerase eta', NULL, NULL, NULL, NULL, NULL, 4),
(74661, NULL, 'G3DSA:3.40.1190.20:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74662, NULL, 'G3DSA:2.10.110.10:FF:000178', NULL, NULL, 'LIM domain family', NULL, NULL, NULL, NULL, NULL, 4),
(74663, NULL, 'G3DSA:3.20.20.80:FF:000285', NULL, NULL, 'Klotho', NULL, NULL, NULL, NULL, NULL, 4),
(74664, NULL, 'G3DSA:1.25.40.10:FF:003879', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74665, NULL, 'G3DSA:3.10.28.10:FF:000035', NULL, NULL, 'Laglidadg endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(74666, NULL, 'G3DSA:2.120.10.30:FF:000278', NULL, NULL, 'Lipoprotein receptor', NULL, NULL, NULL, NULL, NULL, 4),
(74667, NULL, 'G3DSA:3.90.20.20:FF:000011', NULL, NULL, 'GrpE protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(74668, NULL, 'G3DSA:3.40.50.1820:FF:000339', NULL, NULL, 'Lipase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74669, NULL, 'G3DSA:2.60.120.260:FF:000390', NULL, NULL, 'discoidin domain-containing receptor 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(74670, NULL, 'G3DSA:3.10.250.10:FF:000122', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74671, NULL, 'G3DSA:3.40.50.720:FF:002079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74672, NULL, 'G3DSA:2.40.50.140:FF:000880', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74673, NULL, 'G3DSA:3.40.50.1580:FF:000019', NULL, NULL, 'Uridine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(74674, NULL, 'G3DSA:3.40.50.300:FF:003706', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74675, NULL, 'G3DSA:3.90.70.10:FF:000101', NULL, NULL, 'Ubiquitin specific peptidase 40', NULL, NULL, NULL, NULL, NULL, 4),
(74676, NULL, 'G3DSA:3.30.2290.10:FF:000013', NULL, NULL, 'Putative modulator of DNA gyrase', NULL, NULL, NULL, NULL, NULL, 4),
(74677, NULL, 'G3DSA:3.30.360.20:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74678, NULL, 'G3DSA:4.10.320.10:FF:000023', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(74679, NULL, 'G3DSA:3.80.10.10:FF:003953', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74680, NULL, 'G3DSA:2.160.20.10:FF:000338', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74681, NULL, 'G3DSA:3.40.50.620:FF:000800', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74682, NULL, 'G3DSA:1.20.1250.20:FF:000641', NULL, NULL, 'MFS transporter, SHS family, lactate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(74683, NULL, 'G3DSA:1.20.5.190:FF:000138', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(74684, NULL, 'G3DSA:2.60.40.10:FF:003801', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74685, NULL, 'G3DSA:3.30.1120.10:FF:000006', NULL, NULL, 'Arylsulfatase G', NULL, NULL, NULL, NULL, NULL, 4),
(74686, NULL, 'G3DSA:1.10.405.10:FF:000001', NULL, NULL, 'Rab GDP dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(74687, NULL, 'G3DSA:1.20.58.1120:FF:000062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74688, NULL, 'G3DSA:1.10.10.10:FF:001151', NULL, NULL, 'Interferon regulatory factor 8', NULL, NULL, NULL, NULL, NULL, 4),
(74689, NULL, 'G3DSA:3.40.1350.60:FF:000002', NULL, NULL, 'Sugar fermentation stimulation protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(74690, NULL, 'G3DSA:3.40.50.300:FF:006926', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74691, NULL, 'G3DSA:1.10.472.80:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74692, NULL, 'G3DSA:3.90.70.10:FF:000410', NULL, NULL, 'Putative cysteine protease RD19C', NULL, NULL, NULL, NULL, NULL, 4),
(74693, NULL, 'G3DSA:3.30.420.40:FF:000937', NULL, NULL, 'Actin-42A-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(74694, NULL, 'G3DSA:3.30.413.10:FF:000013', NULL, NULL, 'Sulfite reductase [ferredoxin]', NULL, NULL, NULL, NULL, NULL, 4),
(74695, NULL, 'G3DSA:3.20.20.80:FF:000594', NULL, NULL, 'LYSozyme', NULL, NULL, NULL, NULL, NULL, 4),
(74696, NULL, 'G3DSA:1.10.8.720:FF:000030', NULL, NULL, 'GD21850', NULL, NULL, NULL, NULL, NULL, 4),
(74697, NULL, 'G3DSA:3.40.5.60:FF:000002', NULL, NULL, 'DNA replication complex GINS protein SLD5', NULL, NULL, NULL, NULL, NULL, 4),
(74698, NULL, 'G3DSA:1.25.40.20:FF:000324', NULL, NULL, 'Ankyrin repeat domain 53', NULL, NULL, NULL, NULL, NULL, 4),
(74699, NULL, 'G3DSA:3.30.1540.20:FF:000013', NULL, NULL, 'DNA mismatch repair protein MLH3', NULL, NULL, NULL, NULL, NULL, 4),
(74700, NULL, 'G3DSA:1.25.10.10:FF:002747', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74701, NULL, 'G3DSA:2.20.130.10:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74702, NULL, 'G3DSA:2.30.42.10:FF:000333', NULL, NULL, 'Membrane-associated guanylate kinase, WW and PDZ domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(74703, NULL, 'G3DSA:1.10.575.10:FF:000002', NULL, NULL, 'Endonuclease 2', NULL, NULL, NULL, NULL, NULL, 4),
(74704, NULL, 'G3DSA:3.30.1120.90:FF:000002', NULL, NULL, 'Testis-specific Y-encoded-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(74705, NULL, 'G3DSA:2.60.40.720:FF:000007', NULL, NULL, 'Cellular tumor antigen p53', NULL, NULL, NULL, NULL, NULL, 4),
(74706, NULL, 'G3DSA:2.60.40.420:FF:000024', NULL, NULL, 'FET5p Multicopper oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(74707, NULL, 'G3DSA:3.30.40.10:FF:002013', NULL, NULL, 'Putative E3 ubiquitin-protein ligase UNKL', NULL, NULL, NULL, NULL, NULL, 4),
(74708, NULL, 'G3DSA:2.20.25.20:FF:000005', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(74709, NULL, 'G3DSA:2.30.29.30:FF:000921', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74710, NULL, 'G3DSA:3.40.50.620:FF:000351', NULL, NULL, 'Cholinephosphate cytidylyltransferase A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74711, NULL, 'G3DSA:2.40.50.60:FF:000001', NULL, NULL, 'Antifungal protein', NULL, NULL, NULL, NULL, NULL, 4),
(74712, NULL, 'G3DSA:3.80.10.10:FF:000626', NULL, NULL, 'Leucine-rich repeat receptor protein kinase MSP1', NULL, NULL, NULL, NULL, NULL, 4),
(74713, NULL, 'G3DSA:3.90.850.10:FF:000026', NULL, NULL, '2-keto-4-pentenoate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(74714, NULL, 'G3DSA:3.40.50.150:FF:000547', NULL, NULL, 'Malonyl-[acyl-carrier protein] O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(74715, NULL, 'G3DSA:2.60.40.10:FF:003228', NULL, NULL, 'Interferon alpha and beta receptor subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(74716, NULL, 'G3DSA:3.40.50.10900:FF:000027', NULL, NULL, 'Clast3-related', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(74717, NULL, 'G3DSA:3.30.200.20:FF:001242', NULL, NULL, 'Lectin-domain containing receptor kinase A4.3', NULL, NULL, NULL, NULL, NULL, 4),
(74718, NULL, 'G3DSA:4.10.240.10:FF:000062', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(74719, NULL, 'G3DSA:1.10.418.10:FF:000183', NULL, NULL, 'Neuron navigator 3', NULL, NULL, NULL, NULL, NULL, 4),
(74720, NULL, 'G3DSA:3.30.160.60:FF:004285', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74721, NULL, 'G3DSA:1.10.3090.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74722, NULL, 'G3DSA:1.10.238.10:FF:000989', NULL, NULL, 'AGAP012066-PA', NULL, NULL, NULL, NULL, NULL, 4),
(74723, NULL, 'G3DSA:3.40.50.1010:FF:000074', NULL, NULL, 'Ribonuclease VapC', NULL, NULL, NULL, NULL, NULL, 4),
(74724, NULL, 'G3DSA:2.20.100.10:FF:000063', NULL, NULL, 'Thrombospondin type 1 domain containing 7B', NULL, NULL, NULL, NULL, NULL, 4),
(74725, NULL, 'G3DSA:1.10.287.70:FF:000732', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74726, NULL, 'G3DSA:3.30.9.10:FF:000131', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(74727, NULL, 'G3DSA:1.10.20.10:FF:000168', NULL, NULL, 'Nuclear transcription factor Y subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(74728, NULL, 'G3DSA:3.40.50.2300:FF:000949', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74729, NULL, 'G3DSA:2.60.220.30:FF:000006', NULL, NULL, 'Unc-5 netrin receptor D', NULL, NULL, NULL, NULL, NULL, 4),
(74730, NULL, 'G3DSA:2.60.40.60:FF:000005', NULL, NULL, 'Protocadherin 9', NULL, NULL, NULL, NULL, NULL, 4),
(74731, NULL, 'G3DSA:2.102.10.10:FF:000026', NULL, NULL, 'mRNA, clone: RTFL01-01-M20', NULL, NULL, NULL, NULL, NULL, 4),
(74732, NULL, 'G3DSA:1.25.40.1040:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74733, NULL, 'G3DSA:3.40.50.720:FF:001123', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(74734, NULL, 'G3DSA:1.20.900.10:FF:000116', NULL, NULL, 'Rho guanine nucleotide exchange factor gef2', NULL, NULL, NULL, NULL, NULL, 4),
(74735, NULL, 'G3DSA:1.10.10.1180:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74736, NULL, 'G3DSA:3.40.1000.50:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74737, NULL, 'G3DSA:2.40.50.640:FF:000001', NULL, NULL, 'Exoribonuclease 2', NULL, NULL, NULL, NULL, NULL, 4),
(74738, NULL, 'G3DSA:3.40.50.1820:FF:000783', NULL, NULL, 'Alpha/beta hydrolase fold protein', NULL, NULL, NULL, NULL, NULL, 4),
(74739, NULL, 'G3DSA:1.20.1250.20:FF:002086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74740, NULL, 'G3DSA:3.40.50.720:FF:000504', NULL, NULL, 'Siroheme synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74741, NULL, 'G3DSA:3.30.710.10:FF:000266', NULL, NULL, 'ETO1-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(74742, NULL, 'G3DSA:1.20.58.60:FF:000258', NULL, NULL, 'Spectrin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(74743, NULL, 'G3DSA:2.130.10.10:FF:004830', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(74744, NULL, 'G3DSA:3.40.50.80:FF:000044', NULL, NULL, 'Ring-1,2-phenylacetyl-CoA epoxidase subunit PaaE', NULL, NULL, NULL, NULL, NULL, 4),
(74745, NULL, 'G3DSA:1.10.1450.10:FF:000099', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(74746, NULL, 'G3DSA:3.30.450.20:FF:000445', NULL, NULL, 'Sporulation kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(74747, NULL, 'G3DSA:3.40.50.2000:FF:000966', NULL, NULL, 'Mannosyltransferase B', NULL, NULL, NULL, NULL, NULL, 4),
(74748, NULL, 'G3DSA:2.10.70.10:FF:000253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74749, NULL, 'G3DSA:1.20.120.230:FF:000060', NULL, NULL, 'Probable vinculin', NULL, NULL, NULL, NULL, NULL, 4),
(74750, NULL, 'G3DSA:3.10.20.90:FF:000816', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(74751, NULL, 'G3DSA:3.30.230.10:FF:000122', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(74752, NULL, 'G3DSA:1.25.10.10:FF:002972', NULL, NULL, 'AGAP002100-PA', NULL, NULL, NULL, NULL, NULL, 4),
(74753, NULL, 'G3DSA:3.40.1390.10:FF:000001', NULL, NULL, 'UDP-3-O-(3-hydroxymyristoyl)glucosamine N-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(74754, NULL, 'G3DSA:1.25.40.20:FF:001280', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74755, NULL, 'G3DSA:3.40.50.300:FF:003487', NULL, NULL, 'Dynein heavy chain 9, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(74756, NULL, 'G3DSA:3.40.50.720:FF:002551', NULL, NULL, 'Glutamyl-tRNA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(74757, NULL, 'G3DSA:3.30.160.60:FF:000440', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM23', NULL, NULL, NULL, NULL, NULL, 4),
(74758, NULL, 'G3DSA:1.20.120.160:FF:000010', NULL, NULL, 'Phosphorelay intermediate protein YPD1', NULL, NULL, NULL, NULL, NULL, 4),
(74759, NULL, 'G3DSA:3.30.420.40:FF:000836', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(74760, NULL, 'G3DSA:3.30.70.330:FF:000534', NULL, NULL, 'Pre-rRNA-processing protein ESF2', NULL, NULL, NULL, NULL, NULL, 4),
(74761, NULL, 'G3DSA:2.60.40.10:FF:002823', NULL, NULL, 'Gingipain R1', NULL, NULL, NULL, NULL, NULL, 4),
(74762, NULL, 'G3DSA:1.25.40.10:FF:004609', NULL, NULL, 'Cell division cycle protein 27 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(74763, NULL, 'G3DSA:2.40.70.10:FF:000465', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74764, NULL, 'G3DSA:3.40.1810.10:FF:000023', NULL, NULL, 'MADS-box protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(74765, NULL, 'G3DSA:2.10.25.10:FF:000401', NULL, NULL, 'von Willebrand factor C and EGF domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(74766, NULL, 'G3DSA:1.20.120.720:FF:000009', NULL, NULL, 'Unconventional myosin-Id', NULL, NULL, NULL, NULL, NULL, 4),
(74767, NULL, 'G3DSA:2.60.40.10:FF:000895', NULL, NULL, 'NPHS1, nephrin', NULL, NULL, NULL, NULL, NULL, 4),
(74768, NULL, 'G3DSA:3.80.10.10:FF:002655', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74769, NULL, 'G3DSA:3.90.980.20:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74770, NULL, 'G3DSA:1.10.8.60:FF:000007', NULL, NULL, '26S proteasome regulatory subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(74771, NULL, 'G3DSA:3.90.550.50:FF:000195', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(74772, NULL, 'G3DSA:3.90.1150.10:FF:000051', NULL, NULL, 'Probable gamma-aminobutyrate transaminase 3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(74773, NULL, 'G3DSA:3.40.50.300:FF:005415', NULL, NULL, 'ABC transporter A family member 7', NULL, NULL, NULL, NULL, NULL, 4),
(74774, NULL, 'G3DSA:1.10.10.60:FF:000536', NULL, NULL, 'SWR1-complex protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(74775, NULL, 'G3DSA:1.10.220.60:FF:000002', NULL, NULL, 'Golgin subfamily A member 1', NULL, NULL, NULL, NULL, NULL, 4),
(74776, NULL, 'G3DSA:3.30.300.180:FF:000003', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(74777, NULL, 'G3DSA:1.25.40.10:FF:005133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74778, NULL, 'G3DSA:1.25.10.10:FF:001253', NULL, NULL, 'Protein CLASP-2', NULL, NULL, NULL, NULL, NULL, 4),
(74779, NULL, 'G3DSA:3.30.2090.10:FF:000020', NULL, NULL, 'RND multidrug efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(74780, NULL, 'G3DSA:3.30.40.210:FF:000015', NULL, NULL, 'Transcription elongation factor SPT4', NULL, NULL, NULL, NULL, NULL, 4),
(74781, NULL, 'G3DSA:2.40.40.20:FF:000062', NULL, NULL, 'Periplasmically oriented, membrane-bound formate dehydrogenase, major subunit, selenocysteine-containing', NULL, NULL, NULL, NULL, NULL, 4),
(74782, NULL, 'G3DSA:2.30.30.870:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74783, NULL, 'G3DSA:3.40.50.1820:FF:001300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(74784, NULL, 'G3DSA:2.130.10.10:FF:000547', NULL, NULL, 'Cilia- and flagella-associated protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(74785, NULL, 'G3DSA:3.40.50.920:FF:000008', NULL, NULL, 'transketolase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(74786, NULL, 'G3DSA:3.30.1230.20:FF:000012', NULL, NULL, '40S ribosomal protein S21', NULL, NULL, NULL, NULL, NULL, 4),
(74787, NULL, 'G3DSA:3.40.190.10:FF:000705', NULL, NULL, 'Leucyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(74788, NULL, 'G3DSA:3.90.550.50:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74789, NULL, 'G3DSA:3.30.470.10:FF:000016', NULL, NULL, 'Class IV aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(74790, NULL, 'G3DSA:3.40.50.300:FF:000744', NULL, NULL, 'intron-binding protein aquarius isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(74791, NULL, 'G3DSA:3.90.20.20:FF:000028', NULL, NULL, 'Putative co-chaperone, GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(74792, NULL, 'G3DSA:2.60.40.1230:FF:000006', NULL, NULL, 'AP-1 complex subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(74793, NULL, 'G3DSA:1.20.1460.10:FF:000007', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(74794, NULL, 'G3DSA:1.10.260.40:FF:000004', NULL, NULL, 'Cut-like homeobox 1a', NULL, NULL, NULL, NULL, NULL, 4),
(74795, NULL, 'G3DSA:1.10.8.10:FF:000346', NULL, NULL, 'Inhibitor of apoptosis protein 1 and 2, iap1, iap2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74796, NULL, 'G3DSA:3.90.45.10:FF:000009', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(74797, NULL, 'G3DSA:3.30.1010.10:FF:000144', NULL, NULL, 'UVSB PI-3 kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74798, NULL, 'G3DSA:2.30.140.10:FF:000001', NULL, NULL, 'SPE3p Spermidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(74799, NULL, 'G3DSA:3.10.450.50:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74800, NULL, 'G3DSA:1.20.1540.10:FF:000059', NULL, NULL, 'Rhomboid 5 homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(74801, NULL, 'G3DSA:3.30.70.330:FF:002900', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74802, NULL, 'G3DSA:3.90.70.10:FF:000545', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74803, NULL, 'G3DSA:1.10.1410.20:FF:000010', NULL, NULL, '2''-5''-oligoadenylate synthase 3', NULL, NULL, NULL, NULL, NULL, 4),
(74804, NULL, 'G3DSA:1.25.40.10:FF:002148', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g29760, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(74805, NULL, 'G3DSA:3.20.20.140:FF:000155', NULL, NULL, 'D-glutamate deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(74806, NULL, 'G3DSA:3.40.50.2300:FF:000045', NULL, NULL, 'HTH-type transcriptional repressor PurR', NULL, NULL, NULL, NULL, NULL, 4),
(74807, NULL, 'G3DSA:3.30.70.330:FF:000181', NULL, NULL, 'RNA binding motif protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(74808, NULL, 'G3DSA:2.60.220.50:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74809, NULL, 'G3DSA:3.50.50.60:FF:000656', NULL, NULL, 'FAD/NAD(P)-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(74810, NULL, 'G3DSA:3.80.10.10:FF:004212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74811, NULL, 'G3DSA:3.80.10.10:FF:004100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74812, NULL, 'G3DSA:1.20.1150.12:FF:000003', NULL, NULL, 'Protein disulfide isomerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74813, NULL, 'G3DSA:3.20.20.140:FF:000043', NULL, NULL, 'Amidohydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(74814, NULL, 'G3DSA:2.10.110.10:FF:000043', NULL, NULL, 'protein-methionine sulfoxide oxidase MICAL3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(74815, NULL, 'G3DSA:1.10.800.10:FF:000009', NULL, NULL, 'Tyrosine/tryptophan monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74816, NULL, 'G3DSA:3.40.50.11500:FF:000005', NULL, NULL, 'DENN domain containing 5A', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(74817, NULL, 'G3DSA:3.30.160.60:FF:005223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74818, NULL, 'G3DSA:1.20.5.300:FF:000003', NULL, NULL, 'Spike glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(74819, NULL, 'G3DSA:3.40.720.10:FF:000056', NULL, NULL, 'Phosphatidylinositol glycan, class O', NULL, NULL, NULL, NULL, NULL, 4),
(74820, NULL, 'G3DSA:3.30.160.60:FF:000923', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM71', NULL, NULL, NULL, NULL, NULL, 4),
(74821, NULL, 'G3DSA:2.60.40.60:FF:000909', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74822, NULL, 'G3DSA:3.40.50.880:FF:000187', NULL, NULL, 'Cyanophycinase', NULL, NULL, NULL, NULL, NULL, 4),
(74823, NULL, 'G3DSA:1.10.510.10:FF:003444', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74824, NULL, 'G3DSA:2.40.50.90:FF:000111', NULL, NULL, 'Tudor domain containing 12', NULL, NULL, NULL, NULL, NULL, 4),
(74825, NULL, 'G3DSA:3.20.20.80:FF:000835', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74826, NULL, 'G3DSA:3.40.50.300:FF:008158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74827, NULL, 'G3DSA:1.10.510.10:FF:003556', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74828, NULL, 'G3DSA:1.10.287.470:FF:000004', NULL, NULL, 'UPF0194 membrane protein YbhG', NULL, NULL, NULL, NULL, NULL, 4),
(74829, NULL, 'G3DSA:2.60.40.10:FF:001412', NULL, NULL, 'Plexin A1a', NULL, NULL, NULL, NULL, NULL, 4),
(74830, NULL, 'G3DSA:3.30.70.330:FF:002788', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74831, NULL, 'G3DSA:2.130.10.10:FF:003532', NULL, NULL, 'F-box/wd-repeat protein lin-23, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74832, NULL, 'G3DSA:3.40.50.410:FF:000322', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74833, NULL, 'G3DSA:3.40.1280.10:FF:000009', NULL, NULL, 'tRNA (guanosine(18)-2''-O)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(74834, NULL, 'G3DSA:2.60.40.10:FF:001300', NULL, NULL, 'protein-glutamine gamma-glutamyltransferase Z', NULL, NULL, NULL, NULL, NULL, 4),
(74835, NULL, 'G3DSA:3.90.1480.20:FF:000022', NULL, NULL, 'ST3 beta-galactoside alpha-2,3-sialyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(74836, NULL, 'G3DSA:2.60.40.10:FF:002609', NULL, NULL, 'Chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(74837, NULL, 'G3DSA:1.20.1560.10:FF:000594', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74838, NULL, 'G3DSA:3.30.160.60:FF:001963', NULL, NULL, 'Replication initiator 1', NULL, NULL, NULL, NULL, NULL, 4),
(74839, NULL, 'G3DSA:3.30.420.140:FF:000001', NULL, NULL, 'RNA-binding transcriptional accessory protein', NULL, NULL, NULL, NULL, NULL, 4),
(74840, NULL, 'G3DSA:3.60.130.10:FF:000023', NULL, NULL, 'Pyoverdine chromophore biosynthetic protein PvcA', NULL, NULL, NULL, NULL, NULL, 4),
(74841, NULL, 'G3DSA:2.40.50.140:FF:000868', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74842, NULL, 'G3DSA:3.30.420.110:FF:000037', NULL, NULL, 'DNA mismatch repair protein spellchecker 1', NULL, NULL, NULL, NULL, NULL, 4),
(74843, NULL, 'G3DSA:1.20.1510.10:FF:000091', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74844, NULL, 'G3DSA:2.60.40.10:FF:002031', NULL, NULL, 'Protein tyrosine phosphatase, receptor type B', NULL, NULL, NULL, NULL, NULL, 4),
(74845, NULL, 'G3DSA:1.10.750.20:FF:000002', NULL, NULL, 'Suppressor of cytokine signaling 2', NULL, NULL, NULL, NULL, NULL, 4),
(74846, NULL, 'G3DSA:3.30.870.10:FF:000108', NULL, NULL, 'Phospholipase D', NULL, NULL, NULL, NULL, NULL, 4),
(74847, NULL, 'G3DSA:2.120.10.30:FF:000418', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74848, NULL, 'G3DSA:2.120.10.80:FF:000377', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74849, NULL, 'G3DSA:2.60.34.10:FF:000061', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(74850, NULL, 'G3DSA:3.40.50.300:FF:001233', NULL, NULL, 'Probable ATP-dependent RNA helicase DDX58', NULL, NULL, NULL, NULL, NULL, 4),
(74851, NULL, 'G3DSA:2.130.10.10:FF:002576', NULL, NULL, 'DNA damage-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(74852, NULL, 'G3DSA:1.10.287.370:FF:000058', NULL, NULL, 'RNA polymerase II subunit 5-mediating protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(74853, NULL, 'G3DSA:1.10.150.240:FF:000060', NULL, NULL, 'Hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(74854, NULL, 'G3DSA:3.30.200.20:FF:000623', NULL, NULL, 'L-type lectin-domain containing receptor kinase IV.1', NULL, NULL, NULL, NULL, NULL, 4),
(74855, NULL, 'G3DSA:2.60.40.1670:FF:000003', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(74856, NULL, 'G3DSA:3.30.40.10:FF:001496', NULL, NULL, 'Zn-finger domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74857, NULL, 'G3DSA:4.10.280.10:FF:000171', NULL, NULL, 'Basic helix-loop-helix family protein', NULL, NULL, NULL, NULL, NULL, 4),
(74858, NULL, 'G3DSA:1.10.287.3700:FF:000007', NULL, NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', NULL, NULL, NULL, NULL, NULL, 4),
(74859, NULL, 'G3DSA:2.30.180.10:FF:000110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74860, NULL, 'G3DSA:3.30.430.20:FF:000011', NULL, NULL, 'Cysteine-rich repeat secretory protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(74861, NULL, 'G3DSA:2.10.25.10:FF:000289', NULL, NULL, 'Slit guidance ligand 2', NULL, NULL, NULL, NULL, NULL, 4),
(74862, NULL, 'G3DSA:3.40.50.1000:FF:000554', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74863, NULL, 'G3DSA:1.10.10.60:FF:000199', NULL, NULL, 'Activity-dependent neuroprotector homeobox b', NULL, NULL, NULL, NULL, NULL, 4),
(74864, NULL, 'G3DSA:2.30.30.190:FF:000022', NULL, NULL, 'Tubulin-specific chaperone B', NULL, NULL, NULL, NULL, NULL, 4),
(74865, NULL, 'G3DSA:1.10.630.10:FF:000165', NULL, NULL, 'Cytochrome P450, family 2, subfamily Y, polypeptide 3', NULL, NULL, NULL, NULL, NULL, 4),
(74866, NULL, 'G3DSA:2.130.10.10:FF:001166', NULL, NULL, 'WD repeat protein (AFU_orthologue AFUA_4G09620)', NULL, NULL, NULL, NULL, NULL, 4),
(74867, NULL, 'G3DSA:3.90.650.10:FF:000045', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74868, NULL, 'G3DSA:2.40.70.10:FF:000353', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74869, NULL, 'G3DSA:1.10.30.10:FF:000096', NULL, NULL, 'Chromodomain helicase DNA binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(74870, NULL, 'G3DSA:2.60.120.920:FF:000060', NULL, NULL, 'Tripartite motif containing 39', NULL, NULL, NULL, NULL, NULL, 4),
(74871, NULL, 'G3DSA:3.30.70.420:FF:000005', NULL, NULL, '3-hydroxy-3-methylglutaryl-CoA reductase a', NULL, NULL, NULL, NULL, NULL, 4),
(74872, NULL, 'G3DSA:3.30.870.10:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74873, NULL, 'G3DSA:1.20.920.10:FF:000230', NULL, NULL, 'SNF2 family N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(74874, NULL, 'G3DSA:2.30.30.100:FF:000017', NULL, NULL, 'Small nuclear ribonucleoprotein G', NULL, NULL, NULL, NULL, NULL, 4),
(74875, NULL, 'G3DSA:1.10.150.20:FF:000024', NULL, NULL, 'DNA polymerase gamma, catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(74876, NULL, 'G3DSA:1.10.238.10:FF:000197', NULL, NULL, 'probable calcium-binding protein CML21', NULL, NULL, NULL, NULL, NULL, 4),
(74877, NULL, 'G3DSA:2.60.120.200:FF:000518', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74878, NULL, 'G3DSA:3.40.50.620:FF:000722', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74879, NULL, 'G3DSA:1.10.10.60:FF:001155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74880, NULL, 'G3DSA:3.30.460.10:FF:000061', NULL, NULL, 'Poly(A) RNA polymerase gld-2', NULL, NULL, NULL, NULL, NULL, 4),
(74881, NULL, 'G3DSA:1.20.58.80:FF:000005', NULL, NULL, 'ribosomal protein S6 kinase delta-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(74882, NULL, 'G3DSA:3.90.1230.10:FF:000001', NULL, NULL, 'Nitric oxide synthase, brain', NULL, NULL, NULL, NULL, NULL, 4),
(74883, NULL, 'G3DSA:1.10.1410.10:FF:000102', NULL, NULL, 'DNA polymerase sigma-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(74884, NULL, 'G3DSA:3.20.110.10:FF:000020', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(74885, NULL, 'G3DSA:1.10.472.10:FF:000696', NULL, NULL, 'Cyclin-D2-1', NULL, NULL, NULL, NULL, NULL, 4),
(74886, NULL, 'G3DSA:1.10.506.10:FF:000011', NULL, NULL, 'Ras GTPase-activating protein 2 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(74887, NULL, 'G3DSA:2.60.200.30:FF:000011', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(74888, NULL, 'G3DSA:3.40.50.1580:FF:000008', NULL, NULL, 'S-methyl-5''-thioadenosine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(74889, NULL, 'G3DSA:4.10.60.10:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74890, NULL, 'G3DSA:1.25.40.180:FF:000120', NULL, NULL, 'Translation initiation factor eif-2b epsilon subunit', NULL, NULL, NULL, NULL, NULL, 4),
(74891, NULL, 'G3DSA:1.10.10.2830:FF:000009', NULL, NULL, 'ParB-like partition protein', NULL, NULL, NULL, NULL, NULL, 4),
(74892, NULL, 'G3DSA:1.20.58.480:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74893, NULL, 'G3DSA:2.40.10.10:FF:000456', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74894, NULL, 'G3DSA:2.60.40.1170:FF:000078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74895, NULL, 'G3DSA:3.40.50.11610:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74896, NULL, 'G3DSA:3.30.70.1230:FF:000002', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(74897, NULL, 'G3DSA:1.10.10.10:FF:001073', NULL, NULL, 'Ferric uptake regulation protein', NULL, NULL, NULL, NULL, NULL, 4),
(74898, NULL, 'G3DSA:3.40.50.300:FF:005836', NULL, NULL, 'ABC transporter (ATP-binding protein) homolog ygaD', NULL, NULL, NULL, NULL, NULL, 4),
(74899, NULL, 'G3DSA:3.40.50.300:FF:003375', NULL, NULL, 'ATP-dependent helicase Lhr', NULL, NULL, NULL, NULL, NULL, 4),
(74900, NULL, 'G3DSA:3.40.120.10:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74901, NULL, 'G3DSA:1.20.1250.20:FF:000169', NULL, NULL, 'Sucrose transport protein SUC3', NULL, NULL, NULL, NULL, NULL, 4),
(74902, NULL, 'G3DSA:3.40.50.2300:FF:001113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74903, NULL, 'G3DSA:1.10.860.10:FF:000002', NULL, NULL, 'Replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(74904, NULL, 'G3DSA:1.10.10.10:FF:000903', NULL, NULL, 'Methylated-DNA--protein-cysteine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(74905, NULL, 'G3DSA:3.30.70.330:FF:002890', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74906, NULL, 'G3DSA:3.40.440.10:FF:000006', NULL, NULL, 'Adenylosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(74907, NULL, 'G3DSA:3.40.50.300:FF:007753', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74908, NULL, 'G3DSA:3.30.40.10:FF:002125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74909, NULL, 'G3DSA:3.30.40.10:FF:001849', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74910, NULL, 'G3DSA:1.10.150.170:FF:000010', NULL, NULL, 'probable methyltransferase-like protein 15 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(74911, NULL, 'G3DSA:2.40.50.140:FF:000413', NULL, NULL, 'Cold shock protein B cspB', NULL, NULL, NULL, NULL, NULL, 4),
(74912, NULL, 'G3DSA:2.130.10.10:FF:003083', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(74913, NULL, 'G3DSA:3.90.640.10:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74914, NULL, 'G3DSA:3.30.559.10:FF:000250', NULL, NULL, 'Protein CBG17205', NULL, NULL, NULL, NULL, NULL, 4),
(74915, NULL, 'G3DSA:3.30.160.60:FF:002609', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(74916, NULL, 'G3DSA:3.40.1110.10:FF:000032', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(74917, NULL, 'G3DSA:2.30.29.30:FF:000258', NULL, NULL, 'SET binding factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(74918, NULL, 'G3DSA:3.40.50.2300:FF:000837', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74919, NULL, 'G3DSA:3.40.50.150:FF:000659', NULL, NULL, 'tRNA (adenine(58)-N(1))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(74920, NULL, 'G3DSA:1.10.630.10:FF:000518', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74921, NULL, 'G3DSA:2.130.10.10:FF:001519', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74922, NULL, 'G3DSA:3.30.9.10:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74923, NULL, 'G3DSA:3.40.80.10:FF:000003', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(74924, NULL, 'G3DSA:3.10.100.10:FF:000100', NULL, NULL, 'Lymphocyte antigen 75', NULL, NULL, NULL, NULL, NULL, 4),
(74925, NULL, 'G3DSA:3.80.10.10:FF:000738', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74926, NULL, 'G3DSA:2.60.40.420:FF:000154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74927, NULL, 'G3DSA:2.130.10.10:FF:001183', NULL, NULL, 'Cell cycle arrest protein BUB3', NULL, NULL, NULL, NULL, NULL, 4),
(74928, NULL, 'G3DSA:1.25.40.20:FF:000223', NULL, NULL, 'ankyrin repeat and SOCS box protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(74929, NULL, 'G3DSA:2.60.40.10:FF:003880', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74930, NULL, 'G3DSA:3.10.310.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74931, NULL, 'G3DSA:2.60.40.1260:FF:000004', NULL, NULL, 'LamC, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(74932, NULL, 'G3DSA:1.10.287.2720:FF:000011', NULL, NULL, 'Oxysterol-binding protein homolog C354.07c', NULL, NULL, NULL, NULL, NULL, 4),
(74933, NULL, 'G3DSA:3.30.160.60:FF:004397', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74934, NULL, 'G3DSA:2.60.120.620:FF:000088', NULL, NULL, '2-oxoglutarate-Fe(II) oxygenase EGLN2', NULL, NULL, NULL, NULL, NULL, 4),
(74935, NULL, 'G3DSA:1.25.10.10:FF:000185', NULL, NULL, 'serine/threonine-protein kinase ATR', NULL, NULL, NULL, NULL, NULL, 4),
(74936, NULL, 'G3DSA:3.30.70.330:FF:000990', NULL, NULL, 'RNA recognition motif-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(74937, NULL, 'G3DSA:3.10.350.10:FF:000051', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase XlyA', NULL, NULL, NULL, NULL, NULL, 4),
(74938, NULL, 'G3DSA:3.40.190.10:FF:000695', NULL, NULL, 'Bicarbonate-binding protein CmpA', NULL, NULL, NULL, NULL, NULL, 4),
(74939, NULL, 'G3DSA:1.25.40.10:FF:004969', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74940, NULL, 'G3DSA:1.20.1530.10:FF:000002', NULL, NULL, 'Na(+)/H(+) antiporter NhaA', NULL, NULL, NULL, NULL, NULL, 4),
(74941, NULL, 'G3DSA:3.10.20.230:FF:000004', NULL, NULL, 'Doublecortin domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(74942, NULL, 'G3DSA:3.20.20.100:FF:000042', NULL, NULL, 'Probable voltage-gated potassium channel subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(74943, NULL, 'G3DSA:3.40.50.150:FF:001036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74944, NULL, 'G3DSA:3.40.50.720:FF:001011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74945, NULL, 'G3DSA:3.40.1110.10:FF:000453', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74946, NULL, 'G3DSA:3.30.70.141:FF:000012', NULL, NULL, 'Thioredoxin domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(74947, NULL, 'G3DSA:2.130.10.10:FF:005561', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74948, NULL, 'G3DSA:3.40.190.10:FF:000352', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(74949, NULL, 'G3DSA:4.10.240.10:FF:000174', NULL, NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(74950, NULL, 'G3DSA:3.40.850.10:FF:000509', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(74951, NULL, 'G3DSA:1.10.274.100:FF:000018', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(74952, NULL, 'G3DSA:3.30.420.10:FF:000277', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74953, NULL, 'G3DSA:4.10.780.10:FF:000001', NULL, NULL, 'Probable pyruvate-flavodoxin oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(74954, NULL, 'G3DSA:2.60.120.290:FF:000022', NULL, NULL, 'seizure 6-like protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(74955, NULL, 'G3DSA:1.20.1720.10:FF:000045', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(74956, NULL, 'G3DSA:3.40.50.300:FF:006472', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(74957, NULL, 'G3DSA:3.90.180.10:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74958, NULL, 'G3DSA:1.25.40.120:FF:000029', NULL, NULL, 'Protein farnesyltransferase/geranylgeranyltransferase type-1 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(74959, NULL, 'G3DSA:1.25.40.10:FF:001743', NULL, NULL, 'Prolyl 4-hydroxylase subunit alpha-2', NULL, NULL, NULL, NULL, NULL, 4),
(74960, NULL, 'G3DSA:3.40.50.300:FF:005853', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(74961, NULL, 'G3DSA:2.60.40.10:FF:000114', NULL, NULL, 'Neuronal cell adhesion molecule', NULL, NULL, NULL, NULL, NULL, 4),
(74962, NULL, 'G3DSA:3.30.200.20:FF:000735', NULL, NULL, 'MOK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(74963, NULL, 'G3DSA:3.30.230.10:FF:000234', NULL, NULL, 'Elongation factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(74964, NULL, 'G3DSA:1.10.10.10:FF:001522', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74965, NULL, 'G3DSA:3.40.50.720:FF:001915', NULL, NULL, 'Os07g0602050 protein', NULL, NULL, NULL, NULL, NULL, 4),
(74966, NULL, 'G3DSA:3.30.200.110:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74967, NULL, 'G3DSA:2.40.50.140:FF:001032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74968, NULL, 'G3DSA:3.30.160.60:FF:002368', NULL, NULL, 'Zinc finger protein 124', NULL, NULL, NULL, NULL, NULL, 4),
(74969, NULL, 'G3DSA:1.10.3630.10:FF:000001', NULL, NULL, 'Golgi phosphoprotein 3', NULL, NULL, NULL, NULL, NULL, 4),
(74970, NULL, 'G3DSA:1.20.58.1380:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74971, NULL, 'G3DSA:2.130.10.10:FF:002464', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74972, NULL, 'G3DSA:3.40.50.12780:FF:000231', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74973, NULL, 'G3DSA:1.20.1110.10:FF:000010', NULL, NULL, 'Calcium-transporting ATPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(74974, NULL, 'G3DSA:2.30.42.10:FF:000339', NULL, NULL, 'Golgi reassembly stacking protein (GRASP homologue), putative', NULL, NULL, NULL, NULL, NULL, 4),
(74975, NULL, 'G3DSA:3.30.60.20:FF:000090', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(74976, NULL, 'G3DSA:3.30.1370.10:FF:000053', NULL, NULL, 'Fragile X mental retardation syndrome-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(74977, NULL, 'G3DSA:1.20.1250.20:FF:000270', NULL, NULL, 'Major facilitator superfamily domain-containing protein 4A', NULL, NULL, NULL, NULL, NULL, 4),
(74978, NULL, 'G3DSA:2.40.110.10:FF:000019', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(74979, NULL, 'G3DSA:3.40.1090.10:FF:000068', NULL, NULL, 'Cell division protein', NULL, NULL, NULL, NULL, NULL, 4),
(74980, NULL, 'G3DSA:1.50.10.10:FF:000093', NULL, NULL, 'Glycoside hydrolase family 15 protein', NULL, NULL, NULL, NULL, NULL, 4),
(74981, NULL, 'G3DSA:1.10.8.10:FF:000363', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74982, NULL, 'G3DSA:3.30.420.100:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74983, NULL, 'G3DSA:3.40.228.10:FF:000024', NULL, NULL, 'Molybdopterin-binding iron-sulfur cluster-binding oxidoreductase MopB-3', NULL, NULL, NULL, NULL, NULL, 4),
(74984, NULL, 'G3DSA:3.40.309.10:FF:000067', NULL, NULL, 'Putative aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(74985, NULL, 'G3DSA:1.20.1560.10:FF:000173', NULL, NULL, 'Peroxisomal ABC transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(74986, NULL, 'G3DSA:1.20.120.1870:FF:000002', NULL, NULL, 'Doc protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(74987, NULL, 'G3DSA:1.25.70.10:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74988, NULL, 'G3DSA:1.10.472.130:FF:000049', NULL, NULL, 'GM10109', NULL, NULL, NULL, NULL, NULL, 4),
(74989, NULL, 'G3DSA:2.130.10.10:FF:005218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74990, NULL, 'G3DSA:2.110.10.10:FF:000048', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(74991, NULL, 'G3DSA:3.30.40.10:FF:001945', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(74992, NULL, 'G3DSA:3.50.4.10:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(74993, NULL, 'G3DSA:3.30.40.10:FF:000670', NULL, NULL, 'SH3 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(74994, NULL, 'G3DSA:3.40.30.10:FF:000281', NULL, NULL, 'Thioredoxin-like protein CDSP32, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(74995, NULL, 'G3DSA:3.40.50.2000:FF:000174', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(74996, NULL, 'G3DSA:1.20.1070.10:FF:001692', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(74997, NULL, 'G3DSA:3.30.200.20:FF:000174', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(74998, NULL, 'G3DSA:3.40.50.300:FF:007410', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(74999, NULL, 'G3DSA:1.25.40.410:FF:000009', NULL, NULL, 'RE54856p', NULL, NULL, NULL, NULL, NULL, 4),
(75000, NULL, 'G3DSA:1.25.40.10:FF:004840', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75001, NULL, 'G3DSA:3.20.20.80:FF:000386', NULL, NULL, 'Glycoside hydrolase superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(75002, NULL, 'G3DSA:2.70.98.10:FF:000005', NULL, NULL, 'Aldose 1-epimerase subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(75003, NULL, 'G3DSA:1.20.1270.60:FF:000266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75004, NULL, 'G3DSA:3.30.1330.20:FF:000059', NULL, NULL, 'Alpha-tubulin 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75005, NULL, 'G3DSA:1.10.10.10:FF:000454', NULL, NULL, 'RNA polymerase sigma factor SigF', NULL, NULL, NULL, NULL, NULL, 4),
(75006, NULL, 'G3DSA:3.40.50.970:FF:000225', NULL, NULL, '2-oxoisovalerate dehydrogenase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(75007, NULL, 'G3DSA:2.60.40.60:FF:000899', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75008, NULL, 'G3DSA:3.30.40.10:FF:000439', NULL, NULL, 'Putative E3 ubiquitin-protein ligase UBR7', NULL, NULL, NULL, NULL, NULL, 4),
(75009, NULL, 'G3DSA:2.40.128.20:FF:000063', NULL, NULL, 'Cellular retinoic acid-binding protein 2, a', NULL, NULL, NULL, NULL, NULL, 4),
(75010, NULL, 'G3DSA:2.40.50.100:FF:000188', NULL, NULL, 'Probable cation efflux system', NULL, NULL, NULL, NULL, NULL, 4),
(75011, NULL, 'G3DSA:3.90.550.10:FF:000762', NULL, NULL, 'Putative polypeptide N-acetylgalactosaminyltransferase 11', NULL, NULL, NULL, NULL, NULL, 4),
(75012, NULL, 'G3DSA:3.90.1310.10:FF:000035', NULL, NULL, 'Stage V sporulation protein D', NULL, NULL, NULL, NULL, NULL, 4),
(75013, NULL, 'G3DSA:1.20.1280.50:FF:000005', NULL, NULL, 'F-box/LRR-repeat protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(75014, NULL, 'G3DSA:3.30.930.10:FF:000147', NULL, NULL, 'Related to GCN2-ser/thr protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(75015, NULL, 'G3DSA:1.25.40.90:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75016, NULL, 'G3DSA:2.40.70.10:FF:000010', NULL, NULL, 'Aspartyl protease family protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(75017, NULL, 'G3DSA:1.25.40.10:FF:001400', NULL, NULL, 'Mitochondrial import receptor subunit ATOM69', NULL, NULL, NULL, NULL, NULL, 4),
(75018, NULL, 'G3DSA:1.10.135.10:FF:000008', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(75019, NULL, 'G3DSA:3.40.50.720:FF:001932', NULL, NULL, 'dTDP-4-dehydrorhamnose reductase', NULL, NULL, NULL, NULL, NULL, 4),
(75020, NULL, 'G3DSA:2.60.110.10:FF:000026', NULL, NULL, 'Pathogenesis-related thaumatin superfamily protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(75021, NULL, 'G3DSA:3.40.50.410:FF:000305', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(75022, NULL, 'G3DSA:2.40.30.10:FF:000356', NULL, NULL, 'Flavohemoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(75023, NULL, 'G3DSA:3.50.50.60:FF:000768', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(75024, NULL, 'G3DSA:3.30.160.380:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75025, NULL, 'G3DSA:1.20.120.20:FF:000031', NULL, NULL, 'Apolipoprotein Ea', NULL, NULL, NULL, NULL, NULL, 4),
(75026, NULL, 'G3DSA:1.25.40.20:FF:001179', NULL, NULL, 'Transient receptor potential cation channel, subfamily A, member 1a', NULL, NULL, NULL, NULL, NULL, 4),
(75027, NULL, 'G3DSA:3.30.160.60:FF:005111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75028, NULL, 'G3DSA:3.40.1190.10:FF:000020', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(75029, NULL, 'G3DSA:3.30.497.10:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75030, NULL, 'G3DSA:2.10.110.10:FF:000155', NULL, NULL, 'Protein CBG12788', NULL, NULL, NULL, NULL, NULL, 4),
(75031, NULL, 'G3DSA:3.30.1680.10:FF:000054', NULL, NULL, 'G-protein coupled receptor 98-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(75032, NULL, 'G3DSA:3.30.60.270:FF:000003', NULL, NULL, 'Sortilin-related VPS10 domain containing receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(75033, NULL, 'G3DSA:3.10.129.10:FF:000211', NULL, NULL, 'Acyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(75034, NULL, 'G3DSA:2.40.50.40:FF:000006', NULL, NULL, 'Chromobox protein homolog 7', NULL, NULL, NULL, NULL, NULL, 4),
(75035, NULL, 'G3DSA:1.20.140.150:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75036, NULL, 'G3DSA:3.20.110.10:FF:000003', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(75037, NULL, 'G3DSA:1.20.5.170:FF:000155', NULL, NULL, 'CREB/ATF bZIP transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(75038, NULL, 'G3DSA:2.130.10.10:FF:003644', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75039, NULL, 'G3DSA:3.60.90.10:FF:000019', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(75040, NULL, 'G3DSA:2.130.10.10:FF:000210', NULL, NULL, 'WD repeat-containing protein 11 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(75041, NULL, 'G3DSA:2.40.50.140:FF:000756', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75042, NULL, 'G3DSA:1.20.1250.20:FF:001579', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75043, NULL, 'G3DSA:1.10.10.60:FF:000896', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75044, NULL, 'G3DSA:3.40.50.2300:FF:001017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75045, NULL, 'G3DSA:2.60.40.10:FF:004526', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75046, NULL, 'G3DSA:1.10.510.10:FF:002937', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75047, NULL, 'G3DSA:3.40.1110.10:FF:000110', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(75048, NULL, 'G3DSA:3.30.160.60:FF:003880', NULL, NULL, 'GM22919', NULL, NULL, NULL, NULL, NULL, 4),
(75049, NULL, 'G3DSA:1.10.8.40:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75050, NULL, 'G3DSA:2.40.30.30:FF:000025', NULL, NULL, 'Riboflavin biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(75051, NULL, 'G3DSA:1.20.1070.10:FF:000747', NULL, NULL, 'Alkaline phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(75052, NULL, 'G3DSA:1.10.10.10:FF:002011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75053, NULL, 'G3DSA:2.60.40.10:FF:005015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75054, NULL, 'G3DSA:2.40.10.10:FF:000473', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75055, NULL, 'G3DSA:1.25.40.10:FF:003660', NULL, NULL, 'Tetratricopeptide repeat domain 21A', NULL, NULL, NULL, NULL, NULL, 4),
(75056, NULL, 'G3DSA:1.20.5.350:FF:000006', NULL, NULL, 'TropoNin T', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(75057, NULL, 'G3DSA:2.70.160.11:FF:000022', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(75058, NULL, 'G3DSA:3.30.1010.10:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75059, NULL, 'G3DSA:4.10.60.10:FF:000186', NULL, NULL, 'ATP-dependent RNA helicase glh-4', NULL, NULL, NULL, NULL, NULL, 4),
(75060, NULL, 'G3DSA:1.20.1440.200:FF:000006', NULL, NULL, 'Vacuolar protein sorting-associated protein 28 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(75061, NULL, 'G3DSA:3.20.20.80:FF:000043', NULL, NULL, 'cytosolic endo-beta-N-acetylglucosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(75062, NULL, 'G3DSA:1.10.287.130:FF:000245', NULL, NULL, 'Sensory box sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(75063, NULL, 'G3DSA:3.20.20.70:FF:000506', NULL, NULL, 'Dihydrodipicolinate synthase/N-acetylneuraminate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(75064, NULL, 'G3DSA:3.40.190.10:FF:000256', NULL, NULL, 'ABC transporter, periplasmic substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(75065, NULL, 'G3DSA:2.60.40.10:FF:005145', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75066, NULL, 'G3DSA:3.80.10.10:FF:001683', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(75067, NULL, 'G3DSA:1.10.472.80:FF:000093', NULL, NULL, 'GTPase-activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75068, NULL, 'G3DSA:3.40.80.10:FF:000020', NULL, NULL, 'Peptidoglycan recognition protein LC, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(75069, NULL, 'G3DSA:3.40.50.150:FF:001166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75070, NULL, 'G3DSA:3.40.50.10810:FF:000101', NULL, NULL, 'SWI/SNF-related, matrix-associated, actin-dependent regulator of', NULL, NULL, NULL, NULL, NULL, 4),
(75071, NULL, 'G3DSA:1.20.1250.20:FF:002198', NULL, NULL, 'LP07553p', NULL, NULL, NULL, NULL, NULL, 4),
(75072, NULL, 'G3DSA:1.25.40.10:FF:002715', NULL, NULL, 'CoxI translation protein CYA5', NULL, NULL, NULL, NULL, NULL, 4),
(75073, NULL, 'G3DSA:1.10.510.10:FF:001527', NULL, NULL, 'Kinase, AGC MAST', NULL, NULL, NULL, NULL, NULL, 4),
(75074, NULL, 'G3DSA:3.30.559.10:FF:000149', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(75075, NULL, 'G3DSA:3.30.530.20:FF:000058', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(75076, NULL, 'G3DSA:3.40.50.720:FF:002421', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75077, NULL, 'G3DSA:1.10.1670.10:FF:000082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75078, NULL, 'G3DSA:1.20.140.100:FF:000047', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(75079, NULL, 'G3DSA:3.80.10.10:FF:001587', NULL, NULL, 'RNI-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(75080, NULL, 'G3DSA:2.10.80.10:FF:000001', NULL, NULL, 'Dickkopf WNT-signaling pathway inhibitor 2', NULL, NULL, NULL, NULL, NULL, 4),
(75081, NULL, 'G3DSA:3.10.350.10:FF:000034', NULL, NULL, 'Class V chitinase Chi100', NULL, NULL, NULL, NULL, NULL, 4),
(75082, NULL, 'G3DSA:3.30.450.20:FF:000006', NULL, NULL, 'aryl hydrocarbon receptor nuclear translocator-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(75083, NULL, 'G3DSA:2.60.210.10:FF:000062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75084, NULL, 'G3DSA:3.80.10.10:FF:000177', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase At1g17230', NULL, NULL, NULL, NULL, NULL, 4),
(75085, NULL, 'G3DSA:3.30.40.10:FF:000540', NULL, NULL, 'E3 ubiquitin-protein ligase RDUF1', NULL, NULL, NULL, NULL, NULL, 4),
(75086, NULL, 'G3DSA:3.90.150.10:FF:000001', NULL, NULL, 'Variant surface glycoprotein (VSG), putative', NULL, NULL, NULL, NULL, NULL, 4),
(75087, NULL, 'G3DSA:1.10.1030.10:FF:000005', NULL, NULL, 'Carbamoyl-phosphate synthase (glutamine-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(75088, NULL, 'G3DSA:1.10.10.60:FF:001172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75089, NULL, 'G3DSA:3.30.260.10:FF:000062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75090, NULL, 'G3DSA:1.10.1450.10:FF:000127', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(75091, NULL, 'G3DSA:1.25.40.10:FF:002811', NULL, NULL, 'Pentatricopeptide repeat-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75092, NULL, 'G3DSA:3.30.70.20:FF:000045', NULL, NULL, 'Ferredoxin, 4Fe-4S', NULL, NULL, NULL, NULL, NULL, 4),
(75093, NULL, 'G3DSA:1.20.1250.20:FF:002327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75094, NULL, 'G3DSA:3.90.1150.10:FF:000163', NULL, NULL, 'Kynureninase', NULL, NULL, NULL, NULL, NULL, 4),
(75095, NULL, 'G3DSA:3.40.1110.10:FF:000470', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75096, NULL, 'G3DSA:2.60.40.10:FF:000474', NULL, NULL, 'Sallimus, isoform Q', NULL, NULL, NULL, NULL, NULL, 4),
(75097, NULL, 'G3DSA:1.10.940.10:FF:000036', NULL, NULL, 'tRNA/rRNA cytosine-C5-methylase, NOL1/NOP2/Sun family, fused to N-terminal NusB regulator domain', NULL, NULL, NULL, NULL, NULL, 4),
(75098, NULL, 'G3DSA:1.10.10.10:FF:000111', NULL, NULL, 'Transcriptional repressor MprA', NULL, NULL, NULL, NULL, NULL, 4),
(75099, NULL, 'G3DSA:3.20.10.10:FF:000005', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(75100, NULL, 'G3DSA:1.10.10.540:FF:000013', NULL, NULL, 'Ubiquitin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(75101, NULL, 'G3DSA:3.30.160.60:FF:001980', NULL, NULL, 'Zinc finger protein 45', NULL, NULL, NULL, NULL, NULL, 4),
(75102, NULL, 'G3DSA:3.30.450.20:FF:000462', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(75103, NULL, 'G3DSA:1.10.10.2840:FF:000001', NULL, NULL, 'Carbohydrate diacid transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(75104, NULL, 'G3DSA:1.20.1250.20:FF:001681', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75105, NULL, 'G3DSA:3.40.50.300:FF:000261', NULL, NULL, 'GTP-binding protein SAR1A', NULL, NULL, NULL, NULL, NULL, 4),
(75106, NULL, 'G3DSA:2.60.40.60:FF:000556', NULL, NULL, 'FAT atypical cadherin 2', NULL, NULL, NULL, NULL, NULL, 4),
(75107, NULL, 'G3DSA:3.40.50.300:FF:002189', NULL, NULL, 'Os07g0598300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(75108, NULL, 'G3DSA:3.90.810.10:FF:000029', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(75109, NULL, 'G3DSA:1.20.58.60:FF:000472', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(75110, NULL, 'G3DSA:3.40.20.10:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75111, NULL, 'G3DSA:4.10.400.10:FF:000046', NULL, NULL, 'Very low density lipoprotein receptor', NULL, NULL, NULL, NULL, NULL, 4),
(75112, NULL, 'G3DSA:2.60.120.430:FF:000019', NULL, NULL, '1,4-beta-D-glucan glucohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(75113, NULL, 'G3DSA:3.40.33.10:FF:000203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75114, NULL, 'G3DSA:3.50.50.60:FF:000740', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75115, NULL, 'G3DSA:1.20.140.10:FF:000041', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(75116, NULL, 'G3DSA:2.130.10.10:FF:004493', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75117, NULL, 'G3DSA:3.40.50.1970:FF:000018', NULL, NULL, 'Related to 2-epi-5-epi-valiolone synthase', NULL, NULL, NULL, NULL, NULL, 4),
(75118, NULL, 'G3DSA:3.30.1120.30:FF:000012', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(75119, NULL, 'G3DSA:3.40.50.300:FF:005292', NULL, NULL, 'ADP-ribosylation factor-like protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(75120, NULL, 'G3DSA:1.20.1050.10:FF:000072', NULL, NULL, 'Omega class glutathione transferase', NULL, NULL, NULL, NULL, NULL, 4),
(75121, NULL, 'G3DSA:3.40.50.200:FF:000017', NULL, NULL, 'Intracellular serine protease', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(75122, NULL, 'G3DSA:3.40.50.1820:FF:000120', NULL, NULL, 'Alpha/beta-Hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(75123, NULL, 'G3DSA:1.20.58.1030:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75124, NULL, 'G3DSA:3.40.50.300:FF:007641', NULL, NULL, 'GTP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(75125, NULL, 'G3DSA:1.25.40.20:FF:000111', NULL, NULL, 'Ankyrin repeat domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(75126, NULL, 'G3DSA:1.10.357.10:FF:000057', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(75127, NULL, 'G3DSA:3.30.40.10:FF:001153', NULL, NULL, 'E3 ubiquitin-protein ligase RHF1A', NULL, NULL, NULL, NULL, NULL, 4),
(75128, NULL, 'G3DSA:3.30.450.30:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75129, NULL, 'G3DSA:3.80.10.10:FF:004128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75130, NULL, 'G3DSA:3.30.70.330:FF:000085', NULL, NULL, 'RNA-binding protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(75131, NULL, 'G3DSA:2.60.40.1660:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75132, NULL, 'G3DSA:2.130.10.10:FF:004049', NULL, NULL, 'V-type proton ATPase proteolipid subunit', NULL, NULL, NULL, NULL, NULL, 4),
(75133, NULL, 'G3DSA:1.25.40.570:FF:000012', NULL, NULL, 'probable 26S proteasome non-ATPase regulatory subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(75134, NULL, 'G3DSA:3.40.50.2300:FF:001225', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75135, NULL, 'G3DSA:3.20.20.70:FF:000265', NULL, NULL, 'Lipoyl synthase', NULL, NULL, NULL, NULL, NULL, 4),
(75136, NULL, 'G3DSA:2.60.120.10:FF:000083', NULL, NULL, 'Cyclic nucleotide binding domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(75137, NULL, 'G3DSA:2.60.120.590:FF:000022', NULL, NULL, 'DNA repair family protein', NULL, NULL, NULL, NULL, NULL, 4),
(75138, NULL, 'G3DSA:2.60.40.1970:FF:000003', NULL, NULL, 'MLLT1, super elongation complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(75139, NULL, 'G3DSA:3.30.70.1350:FF:000021', NULL, NULL, 'Cation diffusion facilitator family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(75140, NULL, 'G3DSA:3.30.460.10:FF:000173', NULL, NULL, 'Polynucleotide adenylyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(75141, NULL, 'G3DSA:3.55.50.30:FF:000013', NULL, NULL, 'Anti-sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(75142, NULL, 'G3DSA:2.60.40.10:FF:004498', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75143, NULL, 'G3DSA:2.20.70.10:FF:000292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75144, NULL, 'G3DSA:3.80.10.10:FF:003032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75145, NULL, 'G3DSA:3.30.300.20:FF:000007', NULL, NULL, 'Ribosome-binding factor A', NULL, NULL, NULL, NULL, NULL, 4),
(75146, NULL, 'G3DSA:3.30.160.60:FF:005566', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75147, NULL, 'G3DSA:1.10.510.10:FF:001870', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(75148, NULL, 'G3DSA:2.60.120.650:FF:000164', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(75149, NULL, 'G3DSA:1.20.1440.30:FF:000001', NULL, NULL, 'Erythromycin esterase', NULL, NULL, NULL, NULL, NULL, 4),
(75150, NULL, 'G3DSA:2.30.30.1020:FF:000006', NULL, NULL, 'CCR4-NOT transcription complex, subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(75151, NULL, 'G3DSA:3.90.1750.10:FF:000006', NULL, NULL, 'E3 ubiquitin-protein ligase TRIP12 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(75152, NULL, 'G3DSA:1.25.40.10:FF:004857', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75153, NULL, 'G3DSA:1.10.472.80:FF:000121', NULL, NULL, 'Putative GTPase activator protein', NULL, NULL, NULL, NULL, NULL, 4),
(75154, NULL, 'G3DSA:2.160.20.10:FF:000024', NULL, NULL, 'F-box only protein 11', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(75155, NULL, 'G3DSA:1.10.10.440:FF:000101', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(75156, NULL, 'G3DSA:3.90.70.10:FF:000096', NULL, NULL, 'Cathepsin B-like cysteine protease', NULL, NULL, NULL, NULL, NULL, 4),
(75157, NULL, 'G3DSA:3.30.465.10:FF:000049', NULL, NULL, 'L-galactono-1,4-lactone dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(75158, NULL, 'G3DSA:3.30.230.10:FF:000364', NULL, NULL, 'Ribonuclease P protein component', NULL, NULL, NULL, NULL, NULL, 4),
(75159, NULL, 'G3DSA:1.25.40.10:FF:001631', NULL, NULL, 'Tetratricopeptide_repeat/TPR_repeat', NULL, NULL, NULL, NULL, NULL, 4),
(75160, NULL, 'G3DSA:3.30.1360.10:FF:000007', NULL, NULL, 'DNA-directed RNA polymerase II subunit RPB11-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(75161, NULL, 'G3DSA:2.60.200.20:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75162, NULL, 'G3DSA:3.90.180.10:FF:000042', NULL, NULL, 'Erythritol/L-threitol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(75163, NULL, 'G3DSA:3.40.50.300:FF:005387', NULL, NULL, 'Sperm flagellar protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(75164, NULL, 'G3DSA:2.140.10.30:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75165, NULL, 'G3DSA:3.30.200.20:FF:000966', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75166, NULL, 'G3DSA:3.80.10.10:FF:003509', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75167, NULL, 'G3DSA:1.10.10.10:FF:001634', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(75168, NULL, 'G3DSA:2.30.42.10:FF:000108', NULL, NULL, 'Multiple PDZ domain protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(75169, NULL, 'G3DSA:3.30.2320.30:FF:000005', NULL, NULL, 'V-type proton ATPase subunit E', NULL, NULL, NULL, NULL, NULL, 4),
(75170, NULL, 'G3DSA:3.30.70.1730:FF:000039', NULL, NULL, 'YALI0C10802p', NULL, NULL, NULL, NULL, NULL, 4),
(75171, NULL, 'G3DSA:1.25.40.10:FF:003429', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75172, NULL, 'G3DSA:1.25.40.10:FF:002709', NULL, NULL, 'Tetratricopeptide repeat protein 8, tpr8, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75173, NULL, 'G3DSA:3.90.190.10:FF:000447', NULL, NULL, 'Lmo1800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(75174, NULL, 'G3DSA:3.80.10.10:FF:001795', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75175, NULL, 'G3DSA:1.20.120.160:FF:000038', NULL, NULL, 'Chemotaxis signal transduction system histidine kinase CheA', NULL, NULL, NULL, NULL, NULL, 4),
(75176, NULL, 'G3DSA:3.80.10.10:FF:001475', NULL, NULL, 'TLR4', NULL, NULL, NULL, NULL, NULL, 4),
(75177, NULL, 'G3DSA:3.40.50.10800:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75178, NULL, 'G3DSA:3.40.190.10:FF:000144', NULL, NULL, 'LysR family hydrogen peroxide-inducible transcriptional activator', NULL, NULL, NULL, NULL, NULL, 4),
(75179, NULL, 'G3DSA:1.10.1520.10:FF:000094', NULL, NULL, 'Minimal dicer', NULL, NULL, NULL, NULL, NULL, 4),
(75180, NULL, 'G3DSA:3.90.190.10:FF:000127', NULL, NULL, 'Chromosome 21, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(75181, NULL, 'G3DSA:1.10.8.680:FF:000001', NULL, NULL, 'TBC1 domain family, member 7', NULL, NULL, NULL, NULL, NULL, 4),
(75182, NULL, 'G3DSA:3.40.190.10:FF:000464', NULL, NULL, 'Dipeptide-binding ABC transporter, periplasmic substrate-binding component', NULL, NULL, NULL, NULL, NULL, 4),
(75183, NULL, 'G3DSA:4.10.410.10:FF:000002', NULL, NULL, 'WAP, follistatin/kazal, immunoglobulin, kunitz and netrin domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(75184, NULL, 'G3DSA:1.25.40.20:FF:000010', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(75185, NULL, 'G3DSA:3.60.15.10:FF:000216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75186, NULL, 'G3DSA:2.60.40.60:FF:000348', NULL, NULL, 'Fat-like cadherin-related tumor suppressor homolog', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(75187, NULL, 'G3DSA:3.30.70.260:FF:000053', NULL, NULL, 'Ribose-5-phosphate isomerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75188, NULL, 'G3DSA:3.40.50.1820:FF:001637', NULL, NULL, 'Esterase-6-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(75189, NULL, 'G3DSA:3.20.20.80:FF:000173', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(75190, NULL, 'G3DSA:2.60.120.200:FF:000069', NULL, NULL, 'Calsyntenin 3', NULL, NULL, NULL, NULL, NULL, 4),
(75191, NULL, 'G3DSA:1.20.1080.10:FF:000012', NULL, NULL, 'Aquaporin-1', NULL, NULL, NULL, NULL, NULL, 4),
(75192, NULL, 'G3DSA:3.30.70.1230:FF:000232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75193, NULL, 'G3DSA:2.40.30.270:FF:000004', NULL, NULL, 'DNA-binding protein SMUBP-2', NULL, NULL, NULL, NULL, NULL, 4),
(75194, NULL, 'G3DSA:3.40.50.10590:FF:000001', NULL, NULL, 'Probable aminopeptidase NPEPL1', NULL, NULL, NULL, NULL, NULL, 4),
(75195, NULL, 'G3DSA:1.10.10.60:FF:000980', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75196, NULL, 'G3DSA:3.40.50.150:FF:001828', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75197, NULL, 'G3DSA:3.50.50.60:FF:000077', NULL, NULL, 'Glutamate synthase small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(75198, NULL, 'G3DSA:3.40.50.2020:FF:000051', NULL, NULL, 'Ribose-phosphate pyrophosphokinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(75199, NULL, 'G3DSA:3.40.50.720:FF:000847', NULL, NULL, 'NADPH-dependent alkenal/one oxidoreductase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(75200, NULL, 'G3DSA:1.25.40.30:FF:000001', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(75201, NULL, 'G3DSA:1.10.238.10:FF:000646', NULL, NULL, 'Calmodulin, striated muscle', NULL, NULL, NULL, NULL, NULL, 4),
(75202, NULL, 'G3DSA:3.40.50.150:FF:000098', NULL, NULL, 'Trmt1-like isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(75203, NULL, 'G3DSA:3.40.50.790:FF:000031', NULL, NULL, 'Ribosomal protein L1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75204, NULL, 'G3DSA:3.30.710.10:FF:000496', NULL, NULL, 'AT19737p', NULL, NULL, NULL, NULL, NULL, 4),
(75205, NULL, 'G3DSA:1.10.460.10:FF:000022', NULL, NULL, 'DNA topoisomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(75206, NULL, 'G3DSA:3.20.20.100:FF:000059', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(75207, NULL, 'G3DSA:1.25.40.10:FF:002923', NULL, NULL, 'Transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(75208, NULL, 'G3DSA:2.60.40.60:FF:000668', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75209, NULL, 'G3DSA:2.60.40.10:FF:005706', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75210, NULL, 'G3DSA:3.30.50.10:FF:000041', NULL, NULL, 'GATA transcription factor 14', NULL, NULL, NULL, NULL, NULL, 4),
(75211, NULL, 'G3DSA:1.20.1070.10:FF:001607', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75212, NULL, 'G3DSA:3.40.50.300:FF:003942', NULL, NULL, 'Shikimate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(75213, NULL, 'G3DSA:3.40.50.1820:FF:000811', NULL, NULL, '6-deoxyerythronolide-B synthase EryA3, modules 5 and 6', NULL, NULL, NULL, NULL, NULL, 4),
(75214, NULL, 'G3DSA:3.30.420.150:FF:000021', NULL, NULL, 'Exopolyphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(75215, NULL, 'G3DSA:2.30.29.30:FF:000819', NULL, NULL, 'Pleckstrin homology like domain family B member 1', NULL, NULL, NULL, NULL, NULL, 4),
(75216, NULL, 'G3DSA:1.25.10.10:FF:001691', NULL, NULL, 'Hsp70-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(75217, NULL, 'G3DSA:3.10.20.90:FF:000575', NULL, NULL, 'Ubiquitin-60S ribosomal protein L40', NULL, NULL, NULL, NULL, NULL, 4),
(75218, NULL, 'G3DSA:3.30.160.60:FF:003436', NULL, NULL, 'Si:ch211-223a21.4', NULL, NULL, NULL, NULL, NULL, 4),
(75219, NULL, 'G3DSA:3.30.40.10:FF:002356', NULL, NULL, 'Uncharacterized protein ZK632.12', NULL, NULL, NULL, NULL, NULL, 4),
(75220, NULL, 'G3DSA:3.40.33.10:FF:000091', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(75221, NULL, 'G3DSA:1.10.390.20:FF:000002', NULL, NULL, 'Microbial collagenase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(75222, NULL, 'G3DSA:3.30.1010.10:FF:000032', NULL, NULL, 'Serine/threonine-protein kinase TEL1', NULL, NULL, NULL, NULL, NULL, 4),
(75223, NULL, 'G3DSA:3.40.50.1170:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75224, NULL, 'G3DSA:2.130.10.10:FF:004381', NULL, NULL, 'AGAP012868-PA', NULL, NULL, NULL, NULL, NULL, 4),
(75225, NULL, 'G3DSA:2.60.40.4100:FF:000019', NULL, NULL, 'POM121 and ZP3 fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(75226, NULL, 'G3DSA:3.30.559.70:FF:000015', NULL, NULL, 'Protein CBG23894', NULL, NULL, NULL, NULL, NULL, 4),
(75227, NULL, 'G3DSA:3.30.70.141:FF:000029', NULL, NULL, 'Flagellar_Member_1', NULL, NULL, NULL, NULL, NULL, 4),
(75228, NULL, 'G3DSA:3.30.565.10:FF:000197', NULL, NULL, 'Probable two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(75229, NULL, 'G3DSA:3.30.200.20:FF:002091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75230, NULL, 'G3DSA:2.60.40.10:FF:002368', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(75231, NULL, 'G3DSA:3.20.20.450:FF:000012', NULL, NULL, 'Diguanylate cyclase/phosphodiesterase domain 2 (EAL)', NULL, NULL, NULL, NULL, NULL, 4),
(75232, NULL, 'G3DSA:1.10.472.10:FF:000566', NULL, NULL, 'G2/mitotic-specific cyclin A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75233, NULL, 'G3DSA:3.30.450.20:FF:000349', NULL, NULL, 'Circadian locomoter output cycles protein kaput-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(75234, NULL, 'G3DSA:1.25.40.10:FF:004048', NULL, NULL, 'UPF0656 protein C926.02', NULL, NULL, NULL, NULL, NULL, 4),
(75235, NULL, 'G3DSA:2.30.42.10:FF:000440', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75236, NULL, 'G3DSA:2.120.10.100:FF:000003', NULL, NULL, 'Apyrase calcium-activated nucleotidase SCAN-1-like protein signal peptide', NULL, NULL, NULL, NULL, NULL, 4),
(75237, NULL, 'G3DSA:3.40.50.1010:FF:000102', NULL, NULL, 'Exosome complex exonuclease RRP44, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75238, NULL, 'G3DSA:3.40.50.300:FF:006921', NULL, NULL, 'AGAP003075-PA', NULL, NULL, NULL, NULL, NULL, 4),
(75239, NULL, 'G3DSA:2.120.10.30:FF:000295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75240, NULL, 'G3DSA:1.10.640.10:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75241, NULL, 'G3DSA:1.10.510.10:FF:001078', NULL, NULL, 'Kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(75242, NULL, 'G3DSA:3.30.470.30:FF:000005', NULL, NULL, 'mRNA capping enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75243, NULL, 'G3DSA:3.40.50.300:FF:002638', NULL, NULL, 'ATP-dependent RNA helicase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(75244, NULL, 'G3DSA:3.80.10.10:FF:002312', NULL, NULL, 'Leucine-rich repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(75245, NULL, 'G3DSA:3.20.20.70:FF:000057', NULL, NULL, 'GTP 3'',8-cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(75246, NULL, 'G3DSA:3.90.1150.10:FF:000394', NULL, NULL, 'Putative alanine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(75247, NULL, 'G3DSA:1.10.3520.10:FF:000010', NULL, NULL, 'Glycolipid transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(75248, NULL, 'G3DSA:1.25.10.10:FF:000393', NULL, NULL, 'EFR3 homolog Bb (S. cerevisiae)', NULL, NULL, NULL, NULL, NULL, 4),
(75249, NULL, 'G3DSA:3.30.160.20:FF:000018', NULL, NULL, 'RISC-loading complex subunit TARBP2 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(75250, NULL, 'G3DSA:3.30.70.330:FF:002007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75251, NULL, 'G3DSA:2.40.50.100:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75252, NULL, 'G3DSA:3.40.50.300:FF:007309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75253, NULL, 'G3DSA:3.30.560.10:FF:000006', NULL, NULL, 'Ecdysone oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(75254, NULL, 'G3DSA:1.10.630.10:FF:000069', NULL, NULL, 'Cytochrome P450, putative (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(75255, NULL, 'G3DSA:3.80.10.10:FF:002094', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(75256, NULL, 'G3DSA:1.20.144.10:FF:000038', NULL, NULL, 'Lipid phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(75257, NULL, 'G3DSA:1.25.10.10:FF:001011', NULL, NULL, 'Proteasome activator subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(75258, NULL, 'G3DSA:3.30.160.60:FF:004947', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75259, NULL, 'G3DSA:3.10.110.10:FF:000056', NULL, NULL, 'ubiquitin-conjugating enzyme E2 32', NULL, NULL, NULL, NULL, NULL, 4),
(75260, NULL, 'G3DSA:1.10.510.10:FF:001971', NULL, NULL, 'Putative mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(75261, NULL, 'G3DSA:3.40.30.10:FF:000522', NULL, NULL, 'Thioredoxin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75262, NULL, 'G3DSA:3.40.50.720:FF:002096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75263, NULL, 'G3DSA:1.25.10.10:FF:003040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75264, NULL, 'G3DSA:1.10.287.410:FF:000014', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(75265, NULL, 'G3DSA:1.50.40.10:FF:000162', NULL, NULL, 'Mitochondrial substrate carrier protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(75266, NULL, 'G3DSA:3.90.79.10:FF:000065', NULL, NULL, 'Invasion-associated protein A', NULL, NULL, NULL, NULL, NULL, 4),
(75267, NULL, 'G3DSA:1.25.10.10:FF:000977', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(75268, NULL, 'G3DSA:3.80.10.10:FF:003936', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75269, NULL, 'G3DSA:3.40.1110.10:FF:000240', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75270, NULL, 'G3DSA:2.130.10.10:FF:002705', NULL, NULL, 'YALI0D18788p', NULL, NULL, NULL, NULL, NULL, 4),
(75271, NULL, 'G3DSA:3.40.50.300:FF:004667', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75272, NULL, 'G3DSA:3.40.50.150:FF:000204', NULL, NULL, 'Methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(75273, NULL, 'G3DSA:3.40.50.10490:FF:000073', NULL, NULL, 'MurR/RpiR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(75274, NULL, 'G3DSA:2.10.25.10:FF:001374', NULL, NULL, 'Fibropellin-1', NULL, NULL, NULL, NULL, NULL, 4),
(75275, NULL, 'G3DSA:3.30.70.330:FF:003064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75276, NULL, 'G3DSA:3.40.50.1820:FF:000440', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(75277, NULL, 'G3DSA:2.120.10.30:FF:000306', NULL, NULL, 'Cell growth-regulated gene 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(75278, NULL, 'G3DSA:3.40.47.10:FF:000156', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75279, NULL, 'G3DSA:3.30.565.10:FF:000534', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(75280, NULL, 'G3DSA:3.40.30.10:FF:001141', NULL, NULL, 'Chloride intracellular channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(75281, NULL, 'G3DSA:2.60.40.10:FF:001542', NULL, NULL, 'Sallimus, isoform U', NULL, NULL, NULL, NULL, NULL, 4),
(75282, NULL, 'G3DSA:3.30.310.80:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75283, NULL, 'G3DSA:2.60.120.260:FF:000289', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(75284, NULL, 'G3DSA:3.30.2140.20:FF:000016', NULL, NULL, 'arylamine N-acetyltransferase, liver isozyme', NULL, NULL, NULL, NULL, NULL, 4),
(75285, NULL, 'G3DSA:3.30.200.160:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75286, NULL, 'G3DSA:1.10.8.60:FF:000451', NULL, NULL, 'Lon protease', NULL, NULL, NULL, NULL, NULL, 4),
(75287, NULL, 'G3DSA:3.30.70.3420:FF:000001', NULL, NULL, 'Chlorite dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(75288, NULL, 'G3DSA:2.60.120.290:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75289, NULL, 'G3DSA:1.10.8.10:FF:000133', NULL, NULL, 'UBA/TS-N domain containing protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(75290, NULL, 'G3DSA:2.120.10.80:FF:000164', NULL, NULL, 'Attractin-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(75291, NULL, 'G3DSA:2.60.40.10:FF:000923', NULL, NULL, 'Chaperone, PapD family protein', NULL, NULL, NULL, NULL, NULL, 4),
(75292, NULL, 'G3DSA:3.40.50.2300:FF:000606', NULL, NULL, 'Receptor-type adenylate cyclase GRESAG 4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75293, NULL, 'G3DSA:3.30.160.60:FF:003228', NULL, NULL, 'Zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(75294, NULL, 'G3DSA:2.130.10.10:FF:000890', NULL, NULL, 'Probable E3 ubiquitin ligase complex SCF subunit sconB', NULL, NULL, NULL, NULL, NULL, 4),
(75295, NULL, 'G3DSA:2.30.30.40:FF:000427', NULL, NULL, 'Peroxin 13, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75296, NULL, 'G3DSA:3.40.50.1010:FF:000091', NULL, NULL, 'Yen1p', NULL, NULL, NULL, NULL, NULL, 4),
(75297, NULL, 'G3DSA:2.60.40.60:FF:001062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75298, NULL, 'G3DSA:3.60.15.10:FF:000104', NULL, NULL, 'Ribonuclease Z', NULL, NULL, NULL, NULL, NULL, 4),
(75299, NULL, 'G3DSA:2.130.10.10:FF:003324', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75300, NULL, 'G3DSA:3.20.200.10:FF:000010', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(75301, NULL, 'G3DSA:2.130.10.10:FF:001632', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(75302, NULL, 'G3DSA:3.90.190.10:FF:000239', NULL, NULL, 'Phosphatase and tensin homologue, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75303, NULL, 'G3DSA:3.40.1000.70:FF:000002', NULL, NULL, 'Lipoprotein LpqA', NULL, NULL, NULL, NULL, NULL, 4),
(75304, NULL, 'G3DSA:1.20.1560.10:FF:000043', NULL, NULL, 'Multidrug resistance protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(75305, NULL, 'G3DSA:3.50.50.60:FF:001033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75306, NULL, 'G3DSA:3.40.50.2300:FF:000388', NULL, NULL, 'Vomeronasal 2, receptor 23', NULL, NULL, NULL, NULL, NULL, 4),
(75307, NULL, 'G3DSA:3.30.1640.10:FF:000057', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(75308, NULL, 'G3DSA:1.20.1560.10:FF:000381', NULL, NULL, 'Probable ABC transporter ATP-binding/permease protein HI_0664', NULL, NULL, NULL, NULL, NULL, 4),
(75309, NULL, 'G3DSA:2.30.29.30:FF:000241', NULL, NULL, 'Vacuolar protein sorting 36 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(75310, NULL, 'G3DSA:1.10.1070.11:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75311, NULL, 'G3DSA:3.30.428.10:FF:000076', NULL, NULL, 'Galactose-1-phosphate uridylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(75312, NULL, 'G3DSA:3.80.10.10:FF:004460', NULL, NULL, 'Leucine-rich repeat receptor protein kinase EMS1', NULL, NULL, NULL, NULL, NULL, 4),
(75313, NULL, 'G3DSA:3.60.20.10:FF:000173', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75314, NULL, 'G3DSA:1.10.287.70:FF:000620', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75315, NULL, 'G3DSA:3.40.50.300:FF:007298', NULL, NULL, 'Conserved within P. aerophilum', NULL, NULL, NULL, NULL, NULL, 4),
(75316, NULL, 'G3DSA:1.20.1440.230:FF:000004', NULL, NULL, 'GD25625', NULL, NULL, NULL, NULL, NULL, 4),
(75317, NULL, 'G3DSA:3.40.1410.10:FF:000043', NULL, NULL, 'DNA-binding transcriptional regulator FrlR', NULL, NULL, NULL, NULL, NULL, 4),
(75318, NULL, 'G3DSA:3.30.300.30:FF:000105', NULL, NULL, 'Enniatin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(75319, NULL, 'G3DSA:2.60.120.260:FF:000507', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75320, NULL, 'G3DSA:3.40.50.300:FF:001913', NULL, NULL, 'ABC transporter E family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(75321, NULL, 'G3DSA:1.10.240.10:FF:000011', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(75322, NULL, 'G3DSA:1.20.120.1530:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75323, NULL, 'G3DSA:3.30.40.10:FF:000309', NULL, NULL, 'E3 ubiquitin-protein ligase MBR2', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(75324, NULL, 'G3DSA:1.10.8.60:FF:000237', NULL, NULL, 'Sigma-54 dependent transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(75325, NULL, 'G3DSA:3.30.750.24:FF:000129', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(75326, NULL, 'G3DSA:3.40.50.20:FF:000072', NULL, NULL, 'ATP domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(75327, NULL, 'G3DSA:1.10.510.10:FF:002696', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75328, NULL, 'G3DSA:1.20.1070.10:FF:001815', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75329, NULL, 'G3DSA:1.10.510.10:FF:000459', NULL, NULL, 'Casein kinase II subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(75330, NULL, 'G3DSA:2.40.50.770:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75331, NULL, 'G3DSA:3.20.20.190:FF:000029', NULL, NULL, 'Glycerophosphodiester phosphodiesterase 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(75332, NULL, 'G3DSA:1.20.58.60:FF:000241', NULL, NULL, 'microtubule-actin cross-linking factor 1 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(75333, NULL, 'G3DSA:2.60.120.620:FF:000060', NULL, NULL, 'WGS project CABT00000000 data, contig 2.4', NULL, NULL, NULL, NULL, NULL, 4),
(75334, NULL, 'G3DSA:3.30.70.330:FF:001939', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75335, NULL, 'G3DSA:3.10.100.10:FF:000128', NULL, NULL, 'Mannose receptor, C type 1b', NULL, NULL, NULL, NULL, NULL, 4),
(75336, NULL, 'G3DSA:3.80.10.10:FF:004004', NULL, NULL, 'Si:ch211-159i8.4', NULL, NULL, NULL, NULL, NULL, 4),
(75337, NULL, 'G3DSA:1.10.620.20:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75338, NULL, 'G3DSA:3.30.200.20:FF:001354', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75339, NULL, 'G3DSA:3.40.50.2000:FF:001130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75340, NULL, 'G3DSA:1.10.510.10:FF:002488', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75341, NULL, 'G3DSA:1.10.640.10:FF:000019', NULL, NULL, 'Eosinophil peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(75342, NULL, 'G3DSA:3.30.540.10:FF:000095', NULL, NULL, 'Putative PAP-specific phosphatase mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(75343, NULL, 'G3DSA:3.40.1110.10:FF:000026', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(75344, NULL, 'G3DSA:3.40.50.300:FF:008613', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75345, NULL, 'G3DSA:1.25.40.10:FF:000462', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(75346, NULL, 'G3DSA:1.10.10.10:FF:000797', NULL, NULL, 'RHO1 GDP-GTP exchange protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(75347, NULL, 'G3DSA:1.25.40.10:FF:002362', NULL, NULL, 'ERAD-associated E3 ubiquitin-protein ligase component HRD3A', NULL, NULL, NULL, NULL, NULL, 4),
(75348, NULL, 'G3DSA:1.25.10.10:FF:002079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75349, NULL, 'G3DSA:1.10.1320.10:FF:000011', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(75350, NULL, 'G3DSA:1.10.10.2590:FF:000004', NULL, NULL, 'BEN domain-containing protein 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(75351, NULL, 'G3DSA:2.40.50.140:FF:000655', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75352, NULL, 'G3DSA:3.40.720.10:FF:000264', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(75353, NULL, 'G3DSA:1.20.1280.20:FF:000007', NULL, NULL, 'Fe-S protein assembly co-chaperone HscB', NULL, NULL, NULL, NULL, NULL, 4),
(75354, NULL, 'G3DSA:1.20.1260.10:FF:000009', NULL, NULL, 'Ferritin light chain', NULL, NULL, NULL, NULL, NULL, 4),
(75355, NULL, 'G3DSA:3.30.160.60:FF:001171', NULL, NULL, 'Zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(75356, NULL, 'G3DSA:1.25.40.190:FF:000005', NULL, NULL, 'Actin-related protein 2/3 complex subunit 5', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(75357, NULL, 'G3DSA:3.40.1170.60:FF:000011', NULL, NULL, 'Polymerase (DNA directed), eta', NULL, NULL, NULL, NULL, NULL, 4),
(75358, NULL, 'G3DSA:1.10.10.60:FF:000328', NULL, NULL, 'MYB transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(75359, NULL, 'G3DSA:1.10.238.10:FF:000438', NULL, NULL, 'Probable calcium-binding protein CML15', NULL, NULL, NULL, NULL, NULL, 4),
(75360, NULL, 'G3DSA:3.30.420.140:FF:000029', NULL, NULL, 'Putative pre-16S rRNA nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(75361, NULL, 'G3DSA:1.10.472.10:FF:000128', NULL, NULL, 'TFIIK subunit', NULL, NULL, NULL, NULL, NULL, 4),
(75362, NULL, 'G3DSA:3.40.50.720:FF:002180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75363, NULL, 'G3DSA:3.40.50.450:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75364, NULL, 'G3DSA:1.10.510.10:FF:000358', NULL, NULL, 'Putative leucine-rich repeat receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(75365, NULL, 'G3DSA:3.10.28.10:FF:000052', NULL, NULL, 'Uncharacterized cox1 intron-1 45.6 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(75366, NULL, 'G3DSA:2.120.10.80:FF:000405', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75367, NULL, 'G3DSA:1.10.287.1490:FF:000058', NULL, NULL, 'Centrosomal protein of 83 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(75368, NULL, 'G3DSA:2.60.40.1180:FF:000087', NULL, NULL, 'Trehalose-6-phosphate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(75369, NULL, 'G3DSA:1.20.1560.10:FF:000622', NULL, NULL, 'Serine protease/ABC transporter B family protein tagA', NULL, NULL, NULL, NULL, NULL, 4),
(75370, NULL, 'G3DSA:2.60.120.260:FF:000497', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75371, NULL, 'G3DSA:3.40.50.300:FF:002970', NULL, NULL, 'ABC-F type ribosomal protection protein', NULL, NULL, NULL, NULL, NULL, 4),
(75372, NULL, 'G3DSA:1.20.120.770:FF:000002', NULL, NULL, 'beta-amyloid-like protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(75373, NULL, 'G3DSA:2.130.10.10:FF:002913', NULL, NULL, 'Pre-rRNA-processing protein pro-1', NULL, NULL, NULL, NULL, NULL, 4),
(75374, NULL, 'G3DSA:3.40.50.720:FF:000280', NULL, NULL, 'Nitrogen metabolite repression regulator NmrA', NULL, NULL, NULL, NULL, NULL, 4),
(75375, NULL, 'G3DSA:1.10.3500.10:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75376, NULL, 'G3DSA:1.25.10.10:FF:001814', NULL, NULL, 'LD12333p', NULL, NULL, NULL, NULL, NULL, 4),
(75377, NULL, 'G3DSA:3.40.30.10:FF:000730', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75378, NULL, 'G3DSA:3.40.190.290:FF:000080', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(75379, NULL, 'G3DSA:2.170.300.10:FF:000037', NULL, NULL, 'Netrin-B, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(75380, NULL, 'G3DSA:3.40.50.1260:FF:000036', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(75381, NULL, 'G3DSA:3.10.20.90:FF:000928', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75382, NULL, 'G3DSA:1.10.510.10:FF:004388', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75383, NULL, 'G3DSA:3.30.1360.30:FF:000002', NULL, NULL, 'Aspartate--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(75384, NULL, 'G3DSA:3.30.450.20:FF:000557', NULL, NULL, 'Histidine kinase sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(75385, NULL, 'G3DSA:2.60.120.260:FF:000154', NULL, NULL, 'laminin subunit alpha-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(75386, NULL, 'G3DSA:1.20.1250.20:FF:002299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75387, NULL, 'G3DSA:3.40.50.1820:FF:000232', NULL, NULL, 'Probable carboxylesterase SOBER1-like', NULL, NULL, NULL, NULL, NULL, 4),
(75388, NULL, 'G3DSA:2.130.10.10:FF:004942', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75389, NULL, 'G3DSA:1.10.3380.30:FF:000009', NULL, NULL, 'DExH-box ATP-dependent RNA helicase DExH9', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(75390, NULL, 'G3DSA:2.60.40.10:FF:004734', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75391, NULL, 'G3DSA:1.10.287.130:FF:000020', NULL, NULL, 'Sensor histidine kinase DpiB', NULL, NULL, NULL, NULL, NULL, 4),
(75392, NULL, 'G3DSA:2.70.98.10:FF:000090', NULL, NULL, 'Putative glucose-6-phosphate 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(75393, NULL, 'G3DSA:3.40.50.1010:FF:000203', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75394, NULL, 'G3DSA:3.30.450.20:FF:000214', NULL, NULL, 'Hypoxia-inducible factor 1-alpha', NULL, NULL, NULL, NULL, NULL, 4),
(75395, NULL, 'G3DSA:1.20.1250.10:FF:000071', NULL, NULL, 'Interleukin 4', NULL, NULL, NULL, NULL, NULL, 4),
(75396, NULL, 'G3DSA:1.10.600.10:FF:000106', NULL, NULL, 'Terpene synthase', NULL, NULL, NULL, NULL, NULL, 4),
(75397, NULL, 'G3DSA:1.10.510.10:FF:001319', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75398, NULL, 'G3DSA:1.10.10.570:FF:000005', NULL, NULL, 'Vacuolar protein-sorting-associated protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(75399, NULL, 'G3DSA:1.10.555.10:FF:000220', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75400, NULL, 'G3DSA:3.30.200.20:FF:000415', NULL, NULL, 'receptor-like serine/threonine-protein kinase NCRK', NULL, NULL, NULL, NULL, NULL, 4),
(75401, NULL, 'G3DSA:1.10.510.10:FF:001639', NULL, NULL, 'RE09533p', NULL, NULL, NULL, NULL, NULL, 4),
(75402, NULL, 'G3DSA:1.10.10.60:FF:000087', NULL, NULL, 'DNA methyltransferase 1-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(75403, NULL, 'G3DSA:3.30.2410.10:FF:000006', NULL, NULL, 'probable E3 ubiquitin-protein ligase HERC1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(75404, NULL, 'G3DSA:2.60.200.20:FF:000249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75405, NULL, 'G3DSA:2.60.20.10:FF:000017', NULL, NULL, 'Beta-gamma-crystallin', NULL, NULL, NULL, NULL, NULL, 4),
(75406, NULL, 'G3DSA:3.30.420.270:FF:000040', NULL, NULL, 'Tol-Pal system protein TolR', NULL, NULL, NULL, NULL, NULL, 4),
(75407, NULL, 'G3DSA:3.30.420.10:FF:000176', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(75408, NULL, 'G3DSA:1.25.40.10:FF:002603', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(75409, NULL, 'G3DSA:1.20.58.390:FF:000102', NULL, NULL, 'Glycine receptor subunit beta-type 4', NULL, NULL, NULL, NULL, NULL, 4),
(75410, NULL, 'G3DSA:3.30.160.60:FF:000002', NULL, NULL, 'Zinc finger protein 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(75411, NULL, 'G3DSA:1.10.630.10:FF:000277', NULL, NULL, 'Brain aromatase', NULL, NULL, NULL, NULL, NULL, 4),
(75412, NULL, 'G3DSA:3.30.160.60:FF:001412', NULL, NULL, 'Zinc finger protein 546', NULL, NULL, NULL, NULL, NULL, 4),
(75413, NULL, 'G3DSA:1.50.40.10:FF:000370', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75414, NULL, 'G3DSA:1.20.120.980:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75415, NULL, 'G3DSA:3.40.50.2000:FF:000753', NULL, NULL, 'Protein CBG17955', NULL, NULL, NULL, NULL, NULL, 4),
(75416, NULL, 'G3DSA:3.30.1370.120:FF:000020', NULL, NULL, 'Type II secretion system lipoprotein GspD, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75417, NULL, 'G3DSA:3.60.20.10:FF:000072', NULL, NULL, 'Proteasome subunit alpha type', NULL, NULL, NULL, NULL, NULL, 4),
(75418, NULL, 'G3DSA:3.30.160.60:FF:004846', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75419, NULL, 'G3DSA:3.40.50.360:FF:000155', NULL, NULL, 'Putative cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(75420, NULL, 'G3DSA:3.30.1330.40:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75421, NULL, 'G3DSA:3.40.50.300:FF:000053', NULL, NULL, 'Signal recognition particle receptor FtsY', NULL, NULL, NULL, NULL, NULL, 4),
(75422, NULL, 'G3DSA:3.15.10.30:FF:000006', NULL, NULL, 'GM10322', NULL, NULL, NULL, NULL, NULL, 4),
(75423, NULL, 'G3DSA:1.20.1080.10:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(75424, NULL, 'G3DSA:2.30.30.100:FF:000147', NULL, NULL, 'Probable U6 snRNA-associated Sm-like protein LSm5', NULL, NULL, NULL, NULL, NULL, 4),
(75425, NULL, 'G3DSA:1.10.238.10:FF:001057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75426, NULL, 'G3DSA:2.60.40.150:FF:000258', NULL, NULL, 'Misfire, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(75427, NULL, 'G3DSA:1.10.3450.20:FF:000001', NULL, NULL, 'Nuclear pore complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(75428, NULL, 'G3DSA:1.25.10.10:FF:001915', NULL, NULL, 'Probable serine/threonine-protein kinase vps15', NULL, NULL, NULL, NULL, NULL, 4),
(75429, NULL, 'G3DSA:2.40.50.40:FF:000107', NULL, NULL, 'C-C motif chemokine', NULL, NULL, NULL, NULL, NULL, 4),
(75430, NULL, 'G3DSA:3.30.70.240:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75431, NULL, 'G3DSA:3.40.630.30:FF:000055', NULL, NULL, 'Ribosomal-protein-alanine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(75432, NULL, 'G3DSA:3.90.70.10:FF:000657', NULL, NULL, 'Battenin', NULL, NULL, NULL, NULL, NULL, 4),
(75433, NULL, 'G3DSA:3.30.70.1940:FF:000001', NULL, NULL, 'tRNA(cytosine(8)) deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(75434, NULL, 'G3DSA:1.20.1250.20:FF:000511', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(75435, NULL, 'G3DSA:3.10.400.20:FF:000036', NULL, NULL, 'Ligatin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75436, NULL, 'G3DSA:3.40.50.12760:FF:000012', NULL, NULL, 'E3 ubiquitin-protein ligase RNF8', NULL, NULL, NULL, NULL, NULL, 4),
(75437, NULL, 'G3DSA:1.10.3450.40:FF:000007', NULL, NULL, 'Signal recognition particle protein SRP68', NULL, NULL, NULL, NULL, NULL, 4),
(75438, NULL, 'G3DSA:3.40.850.10:FF:000268', NULL, NULL, 'Kinesin KP1', NULL, NULL, NULL, NULL, NULL, 4),
(75439, NULL, 'G3DSA:3.10.20.90:FF:000024', NULL, NULL, 'Erythrocyte membrane protein band 4.1-like 5', NULL, NULL, NULL, NULL, NULL, 4),
(75440, NULL, 'G3DSA:1.10.10.10:FF:001281', NULL, NULL, 'Ribosomal protein S19e, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75441, NULL, 'G3DSA:3.40.50.670:FF:000012', NULL, NULL, 'DNA gyrase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(75442, NULL, 'G3DSA:2.40.10.10:FF:000568', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75443, NULL, 'G3DSA:3.30.160.60:FF:000895', NULL, NULL, 'Zinc finger protein 597', NULL, NULL, NULL, NULL, NULL, 4),
(75444, NULL, 'G3DSA:3.40.50.10990:FF:000014', NULL, NULL, '3,4-dihydroxy-2-butanone 4-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(75445, NULL, 'G3DSA:2.10.90.10:FF:000035', NULL, NULL, 'Spz1', NULL, NULL, NULL, NULL, NULL, 4),
(75446, NULL, 'G3DSA:3.40.50.620:FF:000267', NULL, NULL, 'Isoleucine--tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75447, NULL, 'G3DSA:1.10.10.10:FF:001623', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(75448, NULL, 'G3DSA:2.120.10.30:FF:000065', NULL, NULL, 'Hemomucin', NULL, NULL, NULL, NULL, NULL, 4),
(75449, NULL, 'G3DSA:3.40.50.300:FF:005044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75450, NULL, 'G3DSA:2.40.30.10:FF:000468', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75451, NULL, 'G3DSA:3.30.70.330:FF:000293', NULL, NULL, 'insulin-like growth factor 2 mRNA-binding protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(75452, NULL, 'G3DSA:3.30.70.330:FF:001035', NULL, NULL, 'Ribosome biogenesis', NULL, NULL, NULL, NULL, NULL, 4),
(75453, NULL, 'G3DSA:3.40.50.620:FF:000143', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(75454, NULL, 'G3DSA:3.30.200.20:FF:001034', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(75455, NULL, 'G3DSA:3.40.30.10:FF:001247', NULL, NULL, 'Bidirectional NAD-reducing hydrogenase, diaphorase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(75456, NULL, 'G3DSA:1.25.40.20:FF:001521', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(75457, NULL, 'G3DSA:2.60.40.10:FF:000682', NULL, NULL, 'Tenascin R', NULL, NULL, NULL, NULL, NULL, 4),
(75458, NULL, 'G3DSA:3.40.50.300:FF:003144', NULL, NULL, 'Putative multidrug resistance-associated protein lethal(2)03659-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(75459, NULL, 'G3DSA:1.10.565.10:FF:000046', NULL, NULL, 'Hormone receptor 51', NULL, NULL, NULL, NULL, NULL, 4),
(75460, NULL, 'G3DSA:3.60.40.10:FF:000168', NULL, NULL, 'Protein phosphatase 2C', NULL, NULL, NULL, NULL, NULL, 4),
(75461, NULL, 'G3DSA:3.30.2350.10:FF:000086', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(75462, NULL, 'G3DSA:3.30.160.60:FF:002817', NULL, NULL, 'Transcriptional regulator MNL1', NULL, NULL, NULL, NULL, NULL, 4),
(75463, NULL, 'G3DSA:1.25.10.10:FF:002534', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75464, NULL, 'G3DSA:4.10.1000.10:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75465, NULL, 'G3DSA:1.25.40.10:FF:001642', NULL, NULL, 'Selenium-binding protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(75466, NULL, 'G3DSA:2.130.10.10:FF:000991', NULL, NULL, 'Transducin beta like 3', NULL, NULL, NULL, NULL, NULL, 4),
(75467, NULL, 'G3DSA:2.60.40.10:FF:003672', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75468, NULL, 'G3DSA:1.20.58.1200:FF:000001', NULL, NULL, 'Si:ch211-108d22.2', NULL, NULL, NULL, NULL, NULL, 4),
(75469, NULL, 'G3DSA:3.30.300.150:FF:000005', NULL, NULL, 'DNA polymerase III subunit gamma/tau', NULL, NULL, NULL, NULL, NULL, 4),
(75470, NULL, 'G3DSA:3.20.20.70:FF:000720', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75471, NULL, 'G3DSA:1.20.1070.10:FF:000635', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75472, NULL, 'G3DSA:1.10.510.10:FF:002590', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75473, NULL, 'G3DSA:2.30.29.30:FF:000466', NULL, NULL, 'carboxyl-terminal PDZ ligand of neuronal nitric oxide synthase protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(75474, NULL, 'G3DSA:2.130.10.10:FF:000098', NULL, NULL, 'WD repeat-containing protein slp1', NULL, NULL, NULL, NULL, NULL, 4),
(75475, NULL, 'G3DSA:1.25.10.10:FF:003383', NULL, NULL, 'Dynein axonemal assembly factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(75476, NULL, 'G3DSA:3.60.110.10:FF:000039', NULL, NULL, 'Glutamine-dependent NAD(+) synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(75477, NULL, 'G3DSA:3.30.70.270:FF:000151', NULL, NULL, 'Polymerase (DNA directed) kappa', NULL, NULL, NULL, NULL, NULL, 4),
(75478, NULL, 'G3DSA:2.130.10.10:FF:005662', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75479, NULL, 'G3DSA:3.30.710.10:FF:000058', NULL, NULL, 'Zinc finger and BTB domain containing 40', NULL, NULL, NULL, NULL, NULL, 4),
(75480, NULL, 'G3DSA:3.40.1190.20:FF:000011', NULL, NULL, '2-dehydro-3-deoxygluconokinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75481, NULL, 'G3DSA:3.40.50.300:FF:004768', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(75482, NULL, 'G3DSA:3.30.70.860:FF:000002', NULL, NULL, 'DUF406 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(75483, NULL, 'G3DSA:1.20.1530.20:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75484, NULL, 'G3DSA:2.30.29.30:FF:000342', NULL, NULL, 'beta-1-syntrophin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(75485, NULL, 'G3DSA:2.60.40.10:FF:005353', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75486, NULL, 'G3DSA:2.60.40.150:FF:000590', NULL, NULL, 'MecKel-Gruber Syndrome (MKS) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(75487, NULL, 'G3DSA:1.20.1280.50:FF:000090', NULL, NULL, 'F-box protein', NULL, NULL, NULL, NULL, NULL, 4),
(75488, NULL, 'G3DSA:2.60.120.470:FF:000003', NULL, NULL, 'DUF1000 domain protein (AFU_orthologue AFUA_1G09230)', NULL, NULL, NULL, NULL, NULL, 4),
(75489, NULL, 'G3DSA:1.10.4160.10:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75490, NULL, 'G3DSA:2.30.30.40:FF:000657', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(75491, NULL, 'G3DSA:3.40.640.10:FF:000443', NULL, NULL, 'Cystathionase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75492, NULL, 'G3DSA:2.40.37.10:FF:000034', NULL, NULL, 'S-adenosylmethionine decarboxylase/ornithine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(75493, NULL, 'G3DSA:3.40.50.10190:FF:000218', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(75494, NULL, 'G3DSA:3.40.50.1110:FF:000019', NULL, NULL, 'GDSL Lipase/Acylhydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(75495, NULL, 'G3DSA:3.50.50.60:FF:000313', NULL, NULL, 'Possible oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(75496, NULL, 'G3DSA:2.60.200.10:FF:000016', NULL, NULL, 'Mothers against decapentaplegic homolog', NULL, NULL, NULL, NULL, NULL, 4),
(75497, NULL, 'G3DSA:2.60.40.10:FF:001643', NULL, NULL, 'Putative Sortilin-related receptor', NULL, NULL, NULL, NULL, NULL, 4),
(75498, NULL, 'G3DSA:3.30.420.40:FF:001000', NULL, NULL, 'Heat shock 70 kDa protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(75499, NULL, 'G3DSA:3.40.50.10090:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75500, NULL, 'G3DSA:1.10.287.110:FF:000481', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75501, NULL, 'G3DSA:1.10.10.10:FF:000662', NULL, NULL, 'Poly (ADP-ribose) polymerase family, member 12', NULL, NULL, NULL, NULL, NULL, 4),
(75502, NULL, 'G3DSA:3.40.50.410:FF:000294', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(75503, NULL, 'G3DSA:3.40.50.1820:FF:000575', NULL, NULL, 'Putative carboxypeptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(75504, NULL, 'G3DSA:2.10.25.10:FF:000317', NULL, NULL, 'latent-transforming growth factor beta-binding protein 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(75505, NULL, 'G3DSA:3.30.160.60:FF:003666', NULL, NULL, 'Zgc:110821', NULL, NULL, NULL, NULL, NULL, 4),
(75506, NULL, 'G3DSA:3.30.200.20:FF:000073', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(75507, NULL, 'G3DSA:3.30.420.40:FF:000724', NULL, NULL, 'actin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(75508, NULL, 'G3DSA:1.20.1270.250:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75509, NULL, 'G3DSA:1.10.287.70:FF:000041', NULL, NULL, 'Transient receptor potential cation channel subfamily C member 7', NULL, NULL, NULL, NULL, NULL, 4),
(75510, NULL, 'G3DSA:3.30.1370.10:FF:000165', NULL, NULL, 'Far upstream element (FUSE)-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(75511, NULL, 'G3DSA:2.30.30.380:FF:000062', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(75512, NULL, 'G3DSA:3.30.565.10:FF:000433', NULL, NULL, 'Sensory histidine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(75513, NULL, 'G3DSA:1.25.40.10:FF:001081', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g20540', NULL, NULL, NULL, NULL, NULL, 4),
(75514, NULL, 'G3DSA:3.40.50.2000:FF:001017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75515, NULL, 'G3DSA:3.40.47.10:FF:000257', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75516, NULL, 'G3DSA:1.25.10.10:FF:000634', NULL, NULL, 'integrator complex subunit 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(75517, NULL, 'G3DSA:2.80.10.50:FF:000106', NULL, NULL, 'Pierisin', NULL, NULL, NULL, NULL, NULL, 4),
(75518, NULL, 'G3DSA:4.10.320.30:FF:000001', NULL, NULL, 'Myelin transcription factor 1-like, a', NULL, NULL, NULL, NULL, NULL, 4),
(75519, NULL, 'G3DSA:1.10.8.720:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75520, NULL, 'G3DSA:1.20.58.1220:FF:000007', NULL, NULL, 'Exocyst complex component', NULL, NULL, NULL, NULL, NULL, 4),
(75521, NULL, 'G3DSA:3.90.550.10:FF:000211', NULL, NULL, 'Putative glycosyltransferase EpsJ', NULL, NULL, NULL, NULL, NULL, 4),
(75522, NULL, 'G3DSA:1.20.1250.20:FF:000854', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(75523, NULL, 'G3DSA:1.20.1070.10:FF:001484', NULL, NULL, 'Si:ch211-137j23.7', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(75524, NULL, 'G3DSA:3.10.20.90:FF:000367', NULL, NULL, 'Unplaced genomic scaffold supercont1.15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(75525, NULL, 'G3DSA:3.40.630.10:FF:000392', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75526, NULL, 'G3DSA:1.20.120.1910:FF:000025', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(75527, NULL, 'G3DSA:1.20.58.60:FF:000230', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(75528, NULL, 'G3DSA:1.25.40.860:FF:000009', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(75529, NULL, 'G3DSA:2.60.40.150:FF:000488', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75530, NULL, 'G3DSA:3.30.310.210:FF:000003', NULL, NULL, 'IGF-II mRNA-binding protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(75531, NULL, 'G3DSA:1.20.1270.60:FF:000165', NULL, NULL, 'BAI1-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(75532, NULL, 'G3DSA:3.30.160.60:FF:000232', NULL, NULL, 'Krueppel-like factor 9', NULL, NULL, NULL, NULL, NULL, 4),
(75533, NULL, 'G3DSA:1.10.10.60:FF:000648', NULL, NULL, 'GD18444', NULL, NULL, NULL, NULL, NULL, 4),
(75534, NULL, 'G3DSA:2.40.50.140:FF:000076', NULL, NULL, '26S protease regulatory subunit 6A', NULL, NULL, NULL, NULL, NULL, 4),
(75535, NULL, 'G3DSA:1.20.120.1630:FF:000031', NULL, NULL, 'Prostatic steroid 5-alpha-reductase type I, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75536, NULL, 'G3DSA:1.20.1250.20:FF:001130', NULL, NULL, 'Uncharacterized MFS-type transporter YfiU', NULL, NULL, NULL, NULL, NULL, 4),
(75537, NULL, 'G3DSA:1.10.720.30:FF:000054', NULL, NULL, '3''-5'' exoribonuclease 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(75538, NULL, 'G3DSA:1.10.510.10:FF:000690', NULL, NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 128', NULL, NULL, NULL, NULL, NULL, 4),
(75539, NULL, 'G3DSA:3.30.40.10:FF:001737', NULL, NULL, 'Si:ch211-119o8.6', NULL, NULL, NULL, NULL, NULL, 4),
(75540, NULL, 'G3DSA:3.40.50.11660:FF:000013', NULL, NULL, 'Alpha1,3fucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(75541, NULL, 'G3DSA:2.130.10.10:FF:000659', NULL, NULL, 'Transducin beta-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(75542, NULL, 'G3DSA:3.40.50.300:FF:001458', NULL, NULL, 'Bifunctional cobinamide kinase/cobinamide phosphate guanylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(75543, NULL, 'G3DSA:3.60.21.60:FF:000015', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(75544, NULL, 'G3DSA:3.40.50.1240:FF:000154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75545, NULL, 'G3DSA:1.10.287.70:FF:000165', NULL, NULL, 'Two-pore potassium channel 5', NULL, NULL, NULL, NULL, NULL, 4),
(75546, NULL, 'G3DSA:3.40.630.30:FF:000398', NULL, NULL, '[Citrate [pro-3S]-lyase] ligase', NULL, NULL, NULL, NULL, NULL, 4),
(75547, NULL, 'G3DSA:3.80.10.10:FF:003268', NULL, NULL, 'Adhesion molecule with Ig like domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(75548, NULL, 'G3DSA:3.40.1000.30:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75549, NULL, 'G3DSA:2.60.40.10:FF:005358', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75550, NULL, 'G3DSA:3.40.50.300:FF:001464', NULL, NULL, 'Arginyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(75551, NULL, 'G3DSA:1.10.10.850:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75552, NULL, 'G3DSA:2.20.100.10:FF:000057', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 5', NULL, NULL, NULL, NULL, NULL, 4),
(75553, NULL, 'G3DSA:1.50.10.10:FF:000222', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(75554, NULL, 'G3DSA:1.10.472.10:FF:000010', NULL, NULL, 'G1/S-specific cyclin Cln1', NULL, NULL, NULL, NULL, NULL, 4),
(75555, NULL, 'G3DSA:2.10.25.10:FF:000188', NULL, NULL, 'Laminin subunit gamma 2', NULL, NULL, NULL, NULL, NULL, 4),
(75556, NULL, 'G3DSA:2.80.10.50:FF:000005', NULL, NULL, 'Inositol 1,4,5-trisphosphate receptor type 2', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(75557, NULL, 'G3DSA:3.40.850.10:FF:000037', NULL, NULL, 'kinesin-like protein KIF19', NULL, NULL, NULL, NULL, NULL, 4),
(75558, NULL, 'G3DSA:3.40.390.10:FF:000013', NULL, NULL, 'Mitochondrial intermediate peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(75559, NULL, 'G3DSA:1.20.58.760:FF:000011', NULL, NULL, 'Probable inactive ATP-dependent zinc metalloprotease FTSHI 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(75560, NULL, 'G3DSA:1.10.600.10:FF:000129', NULL, NULL, 'Diterpene cyclase DtcycA', NULL, NULL, NULL, NULL, NULL, 4),
(75561, NULL, 'G3DSA:3.30.160.60:FF:005914', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75562, NULL, 'G3DSA:3.30.160.60:FF:001643', NULL, NULL, 'Zinc finger with KRAB and SCAN domains 5', NULL, NULL, NULL, NULL, NULL, 4),
(75563, NULL, 'G3DSA:1.20.1560.10:FF:000386', NULL, NULL, 'ABC transporter, ATP-binding transmembrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(75564, NULL, 'G3DSA:3.50.50.60:FF:001370', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(75565, NULL, 'G3DSA:2.60.260.20:FF:000017', NULL, NULL, 'dnaJ homolog subfamily A member 3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(75566, NULL, 'G3DSA:3.40.50.300:FF:004212', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(75567, NULL, 'G3DSA:3.90.470.20:FF:000045', NULL, NULL, 'Phosphopantetheinyl transferase PptB', NULL, NULL, NULL, NULL, NULL, 4),
(75568, NULL, 'G3DSA:2.130.10.10:FF:003301', NULL, NULL, 'WD repeat-containing protein PCN', NULL, NULL, NULL, NULL, NULL, 4),
(75569, NULL, 'G3DSA:3.40.640.10:FF:000342', NULL, NULL, 'Cystathionine gamma-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(75570, NULL, 'G3DSA:3.40.50.300:FF:003700', NULL, NULL, 'DExD/H-box helicase 58', NULL, NULL, NULL, NULL, NULL, 4),
(75571, NULL, 'G3DSA:3.40.50.10490:FF:000078', NULL, NULL, 'Galactosamine 6-phosphate isomerase AgaS', NULL, NULL, NULL, NULL, NULL, 4),
(75572, NULL, 'G3DSA:2.40.30.70:FF:000003', NULL, NULL, 'tRNA (Adenine(37)-N6)-methyltransferase isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(75573, NULL, 'G3DSA:3.30.160.60:FF:006426', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75574, NULL, 'G3DSA:1.25.10.10:FF:000409', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75575, NULL, 'G3DSA:1.20.58.60:FF:000685', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(75576, NULL, 'G3DSA:1.10.10.10:FF:000667', NULL, NULL, 'Arginine repressor', NULL, NULL, NULL, NULL, NULL, 4),
(75577, NULL, 'G3DSA:2.130.10.10:FF:003189', NULL, NULL, 'Cilia- and flagella-associated protein 43', NULL, NULL, NULL, NULL, NULL, 4),
(75578, NULL, 'G3DSA:3.30.1360.220:FF:000003', NULL, NULL, 'Zinc finger FYVE domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(75579, NULL, 'G3DSA:1.25.40.1030:FF:000052', NULL, NULL, 'Protein transport protein sec31', NULL, NULL, NULL, NULL, NULL, 4),
(75580, NULL, 'G3DSA:1.10.10.10:FF:001179', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(75581, NULL, 'G3DSA:2.60.40.10:FF:001087', NULL, NULL, 'Colony stimulating factor 2 receptor alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(75582, NULL, 'G3DSA:3.30.40.10:FF:000883', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(75583, NULL, 'G3DSA:3.50.50.60:FF:000757', NULL, NULL, 'Rab proteins geranylgeranyltransferase component A', NULL, NULL, NULL, NULL, NULL, 4),
(75584, NULL, 'G3DSA:3.40.50.300:FF:008478', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75585, NULL, 'G3DSA:1.25.10.10:FF:001354', NULL, NULL, 'U3 small nucleolar RNA-associated protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(75586, NULL, 'G3DSA:1.20.920.10:FF:000224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75587, NULL, 'G3DSA:1.10.8.10:FF:000138', NULL, NULL, 'UV excision repair RAD23-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(75588, NULL, 'G3DSA:1.10.472.30:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75589, NULL, 'G3DSA:3.30.40.230:FF:000009', NULL, NULL, 'Glycine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(75590, NULL, 'G3DSA:3.20.20.140:FF:000256', NULL, NULL, 'AGAP006162-PA', NULL, NULL, NULL, NULL, NULL, 4),
(75591, NULL, 'G3DSA:1.10.630.10:FF:000064', NULL, NULL, 'Cytochrome P450 monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(75592, NULL, 'G3DSA:2.60.120.260:FF:000266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75593, NULL, 'G3DSA:1.10.287.70:FF:000726', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75594, NULL, 'G3DSA:3.30.40.10:FF:001395', NULL, NULL, 'Putative histone-lysine n-methyltransferase 2c-like isoform x6', NULL, NULL, NULL, NULL, NULL, 4),
(75595, NULL, 'G3DSA:1.10.510.10:FF:000010', NULL, NULL, 'Ribosomal protein S6 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(75596, NULL, 'G3DSA:2.120.10.80:FF:000169', NULL, NULL, 'F-box family protein', NULL, NULL, NULL, NULL, NULL, 4),
(75597, NULL, 'G3DSA:2.40.37.10:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75598, NULL, 'G3DSA:2.30.30.490:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75599, NULL, 'G3DSA:2.60.40.10:FF:004846', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75600, NULL, 'G3DSA:3.40.50.300:FF:000952', NULL, NULL, 'Replication factor C subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(75601, NULL, 'G3DSA:3.40.390.10:FF:000120', NULL, NULL, 'Protein CBG24150', NULL, NULL, NULL, NULL, NULL, 4),
(75602, NULL, 'G3DSA:3.40.50.300:FF:008490', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75603, NULL, 'G3DSA:3.40.50.10190:FF:000106', NULL, NULL, 'RNA polymerase II C-terminal domain phosphatase-like 4', NULL, NULL, NULL, NULL, NULL, 4),
(75604, NULL, 'G3DSA:1.25.10.10:FF:000398', NULL, NULL, 'HEAT repeat containing 6', NULL, NULL, NULL, NULL, NULL, 4),
(75605, NULL, 'G3DSA:2.30.40.10:FF:000161', NULL, NULL, 'Imidazolonepropionase', NULL, NULL, NULL, NULL, NULL, 4),
(75606, NULL, 'G3DSA:3.30.2290.10:FF:000018', NULL, NULL, 'Metalloprotease slr1322', NULL, NULL, NULL, NULL, NULL, 4),
(75607, NULL, 'G3DSA:1.10.287.370:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75608, NULL, 'G3DSA:2.20.25.10:FF:000103', NULL, NULL, 'Transcription factor S, archaeal', NULL, NULL, NULL, NULL, NULL, 4),
(75609, NULL, 'G3DSA:1.25.40.180:FF:000221', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75610, NULL, 'G3DSA:3.80.10.10:FF:002071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75611, NULL, 'G3DSA:2.120.10.80:FF:000276', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(75612, NULL, 'G3DSA:2.60.40.10:FF:000575', NULL, NULL, 'Neural cell adhesion molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(75613, NULL, 'G3DSA:3.40.50.300:FF:001357', NULL, NULL, 'Guanine nucleotide-binding protein G(i) subunit alpha-1', NULL, NULL, NULL, NULL, NULL, 4),
(75614, NULL, 'G3DSA:3.40.50.720:FF:000398', NULL, NULL, 'Probable 2-deoxy-D-gluconate 3-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(75615, NULL, 'G3DSA:3.30.1470.10:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75616, NULL, 'G3DSA:1.20.1250.20:FF:001473', NULL, NULL, 'MonoCarboxylate Transporter family', NULL, NULL, NULL, NULL, NULL, 4),
(75617, NULL, 'G3DSA:1.10.8.270:FF:000092', NULL, NULL, 'Rab GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75618, NULL, 'G3DSA:3.40.50.10240:FF:000020', NULL, NULL, 'Thiamine pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(75619, NULL, 'G3DSA:3.30.70.330:FF:000765', NULL, NULL, 'RNA-binding protein TIA-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75620, NULL, 'G3DSA:3.40.140.10:FF:000186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75621, NULL, 'G3DSA:1.10.287.3490:FF:000006', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 11', NULL, NULL, NULL, NULL, NULL, 4),
(75622, NULL, 'G3DSA:3.90.1150.10:FF:000371', NULL, NULL, 'Cystathionine gamma-synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75623, NULL, 'G3DSA:2.40.50.140:FF:000177', NULL, NULL, 'DIS3-like exonuclease 2', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(75624, NULL, 'G3DSA:1.10.530.10:FF:000005', NULL, NULL, 'Basic endochitinase', NULL, NULL, NULL, NULL, NULL, 4),
(75625, NULL, 'G3DSA:1.20.1250.20:FF:000742', NULL, NULL, 'MHS family proline/betaine transporter-like MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(75626, NULL, 'G3DSA:1.20.5.110:FF:000171', NULL, NULL, 'Syntaxin-binding protein 5-like', NULL, NULL, NULL, NULL, NULL, 4),
(75627, NULL, 'G3DSA:3.30.2350.20:FF:000072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75628, NULL, 'G3DSA:3.40.50.10190:FF:000213', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(75629, NULL, 'G3DSA:2.20.100.10:FF:000164', NULL, NULL, 'Zinc metalloproteinase', NULL, NULL, NULL, NULL, NULL, 4),
(75630, NULL, 'G3DSA:3.30.9.10:FF:000030', NULL, NULL, 'L-2-hydroxyglutarate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(75631, NULL, 'G3DSA:1.10.10.10:FF:000774', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(75632, NULL, 'G3DSA:3.40.1390.20:FF:000010', NULL, NULL, 'Manganese-dependent inorganic pyrophosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75633, NULL, 'G3DSA:3.40.1000.10:FF:000012', NULL, NULL, 'PsbP domain-containing protein 4, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(75634, NULL, 'G3DSA:3.30.70.2740:FF:000016', NULL, NULL, 'Ac2-202', NULL, NULL, NULL, NULL, NULL, 4),
(75635, NULL, 'G3DSA:3.30.830.10:FF:000319', NULL, NULL, 'Transmembrane 9 superfamily member', NULL, NULL, NULL, NULL, NULL, 4),
(75636, NULL, 'G3DSA:3.40.50.300:FF:005628', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75637, NULL, 'G3DSA:1.25.40.20:FF:001864', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75638, NULL, 'G3DSA:1.10.287.810:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75639, NULL, 'G3DSA:3.40.50.920:FF:000014', NULL, NULL, '1-deoxy-D-xylulose 5-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(75640, NULL, 'G3DSA:3.40.50.1100:FF:000123', NULL, NULL, '1-aminocyclopropane-1-carboxylate deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(75641, NULL, 'G3DSA:3.90.1860.10:FF:000003', NULL, NULL, 'RNA-splicing ligase RtcB', NULL, NULL, NULL, NULL, NULL, 4),
(75642, NULL, 'G3DSA:3.40.50.10580:FF:000009', NULL, NULL, 'GEO02534p1', NULL, NULL, NULL, NULL, NULL, 4),
(75643, NULL, 'G3DSA:2.30.30.140:FF:000029', NULL, NULL, 'SAGA-associated factor 29 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(75644, NULL, 'G3DSA:3.30.210.10:FF:000014', NULL, NULL, 'DNA-directed DNA polymerase, family X', NULL, NULL, NULL, NULL, NULL, 4),
(75645, NULL, 'G3DSA:2.120.10.30:FF:000519', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75646, NULL, 'G3DSA:3.30.450.20:FF:000237', NULL, NULL, 'Integral membrane sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(75647, NULL, 'G3DSA:3.10.129.10:FF:000082', NULL, NULL, 'Protein CBG18926', NULL, NULL, NULL, NULL, NULL, 4),
(75648, NULL, 'G3DSA:3.90.25.10:FF:000002', NULL, NULL, 'GDP-L-fucose synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(75649, NULL, 'G3DSA:3.50.50.60:FF:000072', NULL, NULL, 'Lysine-specific histone demethylase 1B', NULL, NULL, NULL, NULL, NULL, 4),
(75650, NULL, 'G3DSA:3.40.50.1110:FF:000014', NULL, NULL, 'Diglucosylglycerate octanoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(75651, NULL, 'G3DSA:1.10.533.10:FF:000158', NULL, NULL, 'Baculoviral IAP repeat-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(75652, NULL, 'G3DSA:3.20.20.450:FF:000017', NULL, NULL, 'Protein FimX', NULL, NULL, NULL, NULL, NULL, 4),
(75653, NULL, 'G3DSA:3.40.190.10:FF:000487', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(75654, NULL, 'G3DSA:2.130.10.10:FF:001851', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(75655, NULL, 'G3DSA:2.60.40.10:FF:003560', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75656, NULL, 'G3DSA:3.30.420.40:FF:000623', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(75657, NULL, 'G3DSA:3.40.50.300:FF:000738', NULL, NULL, 'Dynein heavy chain axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(75658, NULL, 'G3DSA:3.40.50.1580:FF:000014', NULL, NULL, 'Probable S-methyl-5''-thioinosine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(75659, NULL, 'G3DSA:2.30.29.30:FF:000578', NULL, NULL, 'Vacuolar protein sorting-associated protein 36', NULL, NULL, NULL, NULL, NULL, 4),
(75660, NULL, 'G3DSA:2.60.40.10:FF:001194', NULL, NULL, 'Sallimus, isoform Q', NULL, NULL, NULL, NULL, NULL, 4),
(75661, NULL, 'G3DSA:3.90.1150.10:FF:000152', NULL, NULL, 'Ornithine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(75662, NULL, 'G3DSA:1.10.238.10:FF:000758', NULL, NULL, 'EF-hand calcium-binding domain 6', NULL, NULL, NULL, NULL, NULL, 4),
(75663, NULL, 'G3DSA:3.30.200.20:FF:000522', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(75664, NULL, 'G3DSA:3.40.50.300:FF:007085', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(75665, NULL, 'G3DSA:1.50.40.10:FF:000050', NULL, NULL, 'mitochondrial carnitine/acylcarnitine carrier-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(75666, NULL, 'G3DSA:2.60.120.650:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75667, NULL, 'G3DSA:1.20.58.60:FF:000578', NULL, NULL, 'Dystonin', NULL, NULL, NULL, NULL, NULL, 4),
(75668, NULL, 'G3DSA:1.25.40.10:FF:000237', NULL, NULL, 'Bardet-Biedl syndrome 4 (Human)', NULL, NULL, NULL, NULL, NULL, 4),
(75669, NULL, 'G3DSA:3.40.630.10:FF:000509', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75670, NULL, 'G3DSA:1.20.210.10:FF:000029', NULL, NULL, 'Cytochrome c oxidase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(75671, NULL, 'G3DSA:3.40.50.300:FF:006573', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75672, NULL, 'G3DSA:3.40.50.12160:FF:000040', NULL, NULL, 'tRNA modification enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75673, NULL, 'G3DSA:3.30.63.10:FF:000008', NULL, NULL, 'Guanylate kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75674, NULL, 'G3DSA:1.10.150.240:FF:000054', NULL, NULL, 'HAD superfamily hydrolase (TIGR01509 family)/HAD superfamily hydrolase (TIGR01549 family)', NULL, NULL, NULL, NULL, NULL, 4),
(75675, NULL, 'G3DSA:3.30.1370.10:FF:000064', NULL, NULL, 'protein bicaudal C homolog 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(75676, NULL, 'G3DSA:3.30.420.10:FF:000732', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75677, NULL, 'G3DSA:3.60.21.10:FF:000489', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(75678, NULL, 'G3DSA:2.60.40.10:FF:005465', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75679, NULL, 'G3DSA:2.30.29.70:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75680, NULL, 'G3DSA:2.10.70.10:FF:000045', NULL, NULL, 'Pappalysin 1', NULL, NULL, NULL, NULL, NULL, 4),
(75681, NULL, 'G3DSA:3.40.1110.10:FF:000245', NULL, NULL, 'Cation transporter', NULL, NULL, NULL, NULL, NULL, 4),
(75682, NULL, 'G3DSA:3.15.10.30:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75683, NULL, 'G3DSA:3.30.450.20:FF:000107', NULL, NULL, 'PAS domain-containing sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(75684, NULL, 'G3DSA:3.10.290.20:FF:000004', NULL, NULL, 'SUMO-activating enzyme subunit', NULL, NULL, NULL, NULL, NULL, 4),
(75685, NULL, 'G3DSA:2.10.50.10:FF:000038', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 4', NULL, NULL, NULL, NULL, NULL, 4),
(75686, NULL, 'G3DSA:3.90.226.10:FF:000284', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(75687, NULL, 'G3DSA:1.20.1060.20:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75688, NULL, 'G3DSA:1.20.58.80:FF:000011', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 8', NULL, NULL, NULL, NULL, NULL, 4),
(75689, NULL, 'G3DSA:1.20.1090.10:FF:000063', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(75690, NULL, 'G3DSA:3.30.160.60:FF:001536', NULL, NULL, 'CLUMA_CG004886, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(75691, NULL, 'G3DSA:3.30.200.20:FF:002427', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75692, NULL, 'G3DSA:1.10.418.10:FF:000082', NULL, NULL, 'cytospin-A isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(75693, NULL, 'G3DSA:1.10.1200.10:FF:000064', NULL, NULL, 'Acyl-CoA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75694, NULL, 'G3DSA:3.40.50.720:FF:001707', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75695, NULL, 'G3DSA:4.10.410.10:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75696, NULL, 'G3DSA:3.40.710.10:FF:000095', NULL, NULL, 'Penicillin-binding protein 2x', NULL, NULL, NULL, NULL, NULL, 4),
(75697, NULL, 'G3DSA:4.10.95.10:FF:000002', NULL, NULL, 'Cytochrome c oxidase subunit Via', NULL, NULL, NULL, NULL, NULL, 4),
(75698, NULL, 'G3DSA:3.10.20.310:FF:000040', NULL, NULL, 'Blr6126 protein', NULL, NULL, NULL, NULL, NULL, 4),
(75699, NULL, 'G3DSA:1.10.1300.10:FF:000009', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(75700, NULL, 'G3DSA:1.10.510.10:FF:004169', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75701, NULL, 'G3DSA:3.90.70.10:FF:000758', NULL, NULL, 'Cysteine proteinase cathepsin L, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75702, NULL, 'G3DSA:1.20.1200.10:FF:000005', NULL, NULL, 'cob(I)yrinic acid a,c-diamide adenosyltransferase, mitochondrial-like', NULL, NULL, NULL, NULL, NULL, 4),
(75703, NULL, 'G3DSA:3.20.20.80:FF:000622', NULL, NULL, 'Endo-1,3-beta-glucanase', NULL, NULL, NULL, NULL, NULL, 4),
(75704, NULL, 'G3DSA:2.30.40.10:FF:000031', NULL, NULL, 'Adenine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(75705, NULL, 'G3DSA:1.10.510.10:FF:000807', NULL, NULL, 'Checkpoint serine/threonine-protein kinase bub1', NULL, NULL, NULL, NULL, NULL, 4),
(75706, NULL, 'G3DSA:2.70.170.10:FF:000084', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(75707, NULL, 'G3DSA:1.20.1270.60:FF:000272', NULL, NULL, 'Protein kinase C alpha binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75708, NULL, 'G3DSA:3.30.160.60:FF:005807', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75709, NULL, 'G3DSA:3.40.50.720:FF:000286', NULL, NULL, 'Dihydrodipicolinate reductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(75710, NULL, 'G3DSA:3.40.190.10:FF:000806', NULL, NULL, 'Polar amino acid uptake family ABC transporter, periplasmic substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(75711, NULL, 'G3DSA:3.30.420.10:FF:000513', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75712, NULL, 'G3DSA:1.25.40.990:FF:000037', NULL, NULL, 'Os01g0836400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(75713, NULL, 'G3DSA:3.40.50.10540:FF:000003', NULL, NULL, 'CoA-transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(75714, NULL, 'G3DSA:3.40.50.300:FF:001227', NULL, NULL, 'Dephospho-CoA kinase CAB5', NULL, NULL, NULL, NULL, NULL, 4),
(75715, NULL, 'G3DSA:1.10.10.10:FF:001286', NULL, NULL, 'RFX-like DNA-binding protein RFX2', NULL, NULL, NULL, NULL, NULL, 4),
(75716, NULL, 'G3DSA:3.40.50.12610:FF:000001', NULL, NULL, 'Dolichyl-diphosphooligosaccharide--protein glycosyltransferase subunit STT3B', NULL, NULL, NULL, NULL, NULL, 4),
(75717, NULL, 'G3DSA:1.20.58.1610:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75718, NULL, 'G3DSA:1.10.510.10:FF:002831', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75719, NULL, 'G3DSA:3.40.50.2000:FF:000972', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(75720, NULL, 'G3DSA:2.130.10.10:FF:000339', NULL, NULL, 'WD-repeat protein pop3', NULL, NULL, NULL, NULL, NULL, 4),
(75721, NULL, 'G3DSA:2.60.40.10:FF:003104', NULL, NULL, 'Neuron-glia cell adhesion molecule (Ng-CAM)', NULL, NULL, NULL, NULL, NULL, 4),
(75722, NULL, 'G3DSA:2.60.40.10:FF:000794', NULL, NULL, 'Tenascin-X', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(75723, NULL, 'G3DSA:1.20.1560.10:FF:000723', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75724, NULL, 'G3DSA:2.60.40.420:FF:000255', NULL, NULL, 'Cytochrome C oxidase subunit II', NULL, NULL, NULL, NULL, NULL, 4),
(75725, NULL, 'G3DSA:3.40.50.300:FF:005409', NULL, NULL, 'Atlastin-2', NULL, NULL, NULL, NULL, NULL, 4),
(75726, NULL, 'G3DSA:2.40.70.10:FF:000566', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75727, NULL, 'G3DSA:3.30.160.60:FF:004386', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75728, NULL, 'G3DSA:1.20.1070.10:FF:001591', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(75729, NULL, 'G3DSA:1.10.555.10:FF:000208', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75730, NULL, 'G3DSA:2.60.40.2300:FF:000018', NULL, NULL, 'Neutral ceramidase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(75731, NULL, 'G3DSA:2.40.50.90:FF:000105', NULL, NULL, 'Transcription factor (Snd1/p100), putative', NULL, NULL, NULL, NULL, NULL, 4),
(75732, NULL, 'G3DSA:3.30.200.20:FF:001938', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75733, NULL, 'G3DSA:3.10.250.10:FF:000111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75734, NULL, 'G3DSA:3.20.20.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75735, NULL, 'G3DSA:3.40.50.10190:FF:000325', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75736, NULL, 'G3DSA:1.20.1070.10:FF:002080', NULL, NULL, 'Novopsin-10', NULL, NULL, NULL, NULL, NULL, 4),
(75737, NULL, 'G3DSA:3.30.160.60:FF:005010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75738, NULL, 'G3DSA:3.30.230.30:FF:000004', NULL, NULL, 'IMPACT family member C14C8.09c', NULL, NULL, NULL, NULL, NULL, 4),
(75739, NULL, 'G3DSA:1.10.150.50:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75740, NULL, 'G3DSA:1.20.272.10:FF:000088', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75741, NULL, 'G3DSA:3.30.40.10:FF:002333', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(75742, NULL, 'G3DSA:1.20.1250.20:FF:000961', NULL, NULL, 'Predicted arabinose efflux permease, MFS family', NULL, NULL, NULL, NULL, NULL, 4),
(75743, NULL, 'G3DSA:2.60.210.10:FF:000073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75744, NULL, 'G3DSA:1.25.40.20:FF:001752', NULL, NULL, 'Arginine N-methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(75745, NULL, 'G3DSA:1.10.10.250:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75746, NULL, 'G3DSA:3.40.525.10:FF:000035', NULL, NULL, 'Sec14p-like phosphatidylinositol transfer family protein', NULL, NULL, NULL, NULL, NULL, 4),
(75747, NULL, 'G3DSA:2.20.100.10:FF:000169', NULL, NULL, 'Complement factor properdin', NULL, NULL, NULL, NULL, NULL, 4),
(75748, NULL, 'G3DSA:2.10.25.10:FF:000076', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(75749, NULL, 'G3DSA:2.130.10.30:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75750, NULL, 'G3DSA:3.30.160.60:FF:001755', NULL, NULL, 'Zinc finger protein 989', NULL, NULL, NULL, NULL, NULL, 4),
(75751, NULL, 'G3DSA:2.30.30.40:FF:000652', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75752, NULL, 'G3DSA:3.30.160.60:FF:005802', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75753, NULL, 'G3DSA:1.10.167.10:FF:000003', NULL, NULL, 'Axin 1', NULL, NULL, NULL, NULL, NULL, 4),
(75754, NULL, 'G3DSA:1.10.1300.10:FF:000004', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(75755, NULL, 'G3DSA:3.40.50.300:FF:005623', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75756, NULL, 'G3DSA:4.10.470.20:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75757, NULL, 'G3DSA:3.40.50.300:FF:004100', NULL, NULL, 'Uncharacterized GTP-binding protein E02H1.2', NULL, NULL, NULL, NULL, NULL, 4),
(75758, NULL, 'G3DSA:3.40.50.10810:FF:000236', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(75759, NULL, 'G3DSA:1.25.40.180:FF:000244', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75760, NULL, 'G3DSA:3.50.50.60:FF:001488', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75761, NULL, 'G3DSA:3.30.160.60:FF:004509', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75762, NULL, 'G3DSA:2.40.160.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75763, NULL, 'G3DSA:2.60.40.10:FF:001980', NULL, NULL, 'Hemicentin 2', NULL, NULL, NULL, NULL, NULL, 4),
(75764, NULL, 'G3DSA:3.20.20.100:FF:000036', NULL, NULL, 'NADP-dependent oxidoreductase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(75765, NULL, 'G3DSA:1.10.1420.10:FF:000058', NULL, NULL, 'MSH (MutS Homolog) family', NULL, NULL, NULL, NULL, NULL, 4),
(75766, NULL, 'G3DSA:3.40.850.10:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75767, NULL, 'G3DSA:1.10.8.60:FF:000232', NULL, NULL, 'Katanin p60 ATPase-containing subunit A-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(75768, NULL, 'G3DSA:2.60.40.10:FF:000687', NULL, NULL, 'transmembrane protein 131-like isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(75769, NULL, 'G3DSA:1.10.10.10:FF:001067', NULL, NULL, 'Double-stranded RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(75770, NULL, 'G3DSA:2.70.170.10:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75771, NULL, 'G3DSA:3.90.1420.10:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75772, NULL, 'G3DSA:1.25.40.10:FF:004834', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75773, NULL, 'G3DSA:2.60.120.260:FF:000396', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75774, NULL, 'G3DSA:2.60.40.10:FF:004976', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75775, NULL, 'G3DSA:3.60.40.10:FF:000393', NULL, NULL, 'Serine phosphatase RsbU', NULL, NULL, NULL, NULL, NULL, 4),
(75776, NULL, 'G3DSA:1.20.1000.10:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75777, NULL, 'G3DSA:1.25.40.10:FF:004492', NULL, NULL, 'Slr2048 protein', NULL, NULL, NULL, NULL, NULL, 4),
(75778, NULL, 'G3DSA:1.10.245.10:FF:000005', NULL, NULL, 'E3 ubiquitin-protein ligase Mdm2', NULL, NULL, NULL, NULL, NULL, 4),
(75779, NULL, 'G3DSA:3.40.50.280:FF:000007', NULL, NULL, 'Monomethylamine corrinoid protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(75780, NULL, 'G3DSA:2.160.20.10:FF:000237', NULL, NULL, 'Os07g0207800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(75781, NULL, 'G3DSA:3.40.390.10:FF:000125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75782, NULL, 'G3DSA:2.40.20.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75783, NULL, 'G3DSA:3.30.40.10:FF:000771', NULL, NULL, 'Uncharacterized protein, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(75784, NULL, 'G3DSA:3.40.50.80:FF:000168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75785, NULL, 'G3DSA:1.10.3520.10:FF:000015', NULL, NULL, 'Protein CBG06218', NULL, NULL, NULL, NULL, NULL, 4),
(75786, NULL, 'G3DSA:2.30.29.30:FF:001197', NULL, NULL, 'Docking protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(75787, NULL, 'G3DSA:2.10.25.10:FF:001593', NULL, NULL, 'Matrilin 3a', NULL, NULL, NULL, NULL, NULL, 4),
(75788, NULL, 'G3DSA:3.30.465.10:FF:000026', NULL, NULL, 'D-lactate dehydrogenase (Dld)', NULL, NULL, NULL, NULL, NULL, 4),
(75789, NULL, 'G3DSA:3.90.1150.10:FF:000157', NULL, NULL, 'Probable hercynylcysteine sulfoxide lyase', NULL, NULL, NULL, NULL, NULL, 4),
(75790, NULL, 'G3DSA:3.30.300.130:FF:000022', NULL, NULL, 'Iron-sulfur cluster carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(75791, NULL, 'G3DSA:1.10.10.2560:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75792, NULL, 'G3DSA:1.20.120.1900:FF:000039', NULL, NULL, 'gamma-tubulin complex component 6 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(75793, NULL, 'G3DSA:1.10.437.10:FF:000002', NULL, NULL, 'Induced myeloid leukemia cell differentiation protein Mcl-1', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(75794, NULL, 'G3DSA:3.80.10.10:FF:001014', NULL, NULL, 'EIN3-binding F-box protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(75795, NULL, 'G3DSA:1.10.510.10:FF:000122', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(75796, NULL, 'G3DSA:3.30.40.10:FF:000664', NULL, NULL, 'BRCA1-associated RING domain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(75797, NULL, 'G3DSA:2.60.120.290:FF:000157', NULL, NULL, 'LEV-10A protein', NULL, NULL, NULL, NULL, NULL, 4),
(75798, NULL, 'G3DSA:3.40.30.10:FF:000972', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75799, NULL, 'G3DSA:1.20.1560.10:FF:000167', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(75800, NULL, 'G3DSA:3.40.5.60:FF:000007', NULL, NULL, 'DNA replication complex GINS protein SLD5', NULL, NULL, NULL, NULL, NULL, 4),
(75801, NULL, 'G3DSA:3.30.70.1350:FF:000026', NULL, NULL, 'Cation-efflux pump FieF protein', NULL, NULL, NULL, NULL, NULL, 4),
(75802, NULL, 'G3DSA:3.30.230.70:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75803, NULL, 'G3DSA:1.25.10.10:FF:000050', NULL, NULL, 'Cytoskeleton-associated protein 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(75804, NULL, 'G3DSA:1.25.40.570:FF:000035', NULL, NULL, 'Proteasome 26S subunit, non-ATPase 6', NULL, NULL, NULL, NULL, NULL, 4),
(75805, NULL, 'G3DSA:6.10.140.2220:FF:000029', NULL, NULL, 'HIF prolyl hydroxylase, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(75806, NULL, 'G3DSA:1.25.40.820:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75807, NULL, 'G3DSA:3.30.470.20:FF:000221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75808, NULL, 'G3DSA:3.40.50.300:FF:000957', NULL, NULL, 'ATP-dependent RNA helicase SUV3L, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(75809, NULL, 'G3DSA:1.10.1030.10:FF:000011', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(75810, NULL, 'G3DSA:3.30.413.10:FF:000036', NULL, NULL, 'Assimilatory ferredoxin-dependent nitrite reductase', NULL, NULL, NULL, NULL, NULL, 4),
(75811, NULL, 'G3DSA:3.10.580.10:FF:000091', NULL, NULL, 'CBS domain-containing protein CBSX6', NULL, NULL, NULL, NULL, NULL, 4),
(75812, NULL, 'G3DSA:1.20.58.1370:FF:000001', NULL, NULL, 'lysine-specific demethylase 6A isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(75813, NULL, 'G3DSA:3.30.200.20:FF:001011', NULL, NULL, 'Os12g0203000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(75814, NULL, 'G3DSA:1.10.10.10:FF:001174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75815, NULL, 'G3DSA:3.40.50.2300:FF:000500', NULL, NULL, 'Histidine kinase response regulator hybrid protein', NULL, NULL, NULL, NULL, NULL, 4),
(75816, NULL, 'G3DSA:3.20.20.190:FF:000024', NULL, NULL, 'Glycerophosphodiester phosphodiesterase gde1', NULL, NULL, NULL, NULL, NULL, 4),
(75817, NULL, 'G3DSA:2.170.300.10:FF:000031', NULL, NULL, 'Dendrite extension defective protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(75818, NULL, 'G3DSA:3.40.630.10:FF:000280', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(75819, NULL, 'G3DSA:2.30.30.180:FF:000013', NULL, NULL, 'Ribosome maturation factor RimP', NULL, NULL, NULL, NULL, NULL, 4),
(75820, NULL, 'G3DSA:3.100.10.10:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75821, NULL, 'G3DSA:2.130.10.10:FF:002812', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75822, NULL, 'G3DSA:3.30.420.10:FF:000625', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75823, NULL, 'G3DSA:1.20.1530.20:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75824, NULL, 'G3DSA:2.130.10.10:FF:004605', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(75825, NULL, 'G3DSA:1.10.1410.10:FF:000001', NULL, NULL, 'Putative poly(A) polymerase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(75826, NULL, 'G3DSA:1.20.120.1750:FF:000073', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(75827, NULL, 'G3DSA:3.60.21.10:FF:000141', NULL, NULL, 'Serine/threonine-protein phosphatase with EF-hands', NULL, NULL, NULL, NULL, NULL, 4),
(75828, NULL, 'G3DSA:2.30.29.30:FF:001202', NULL, NULL, 'RAN binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(75829, NULL, 'G3DSA:1.10.10.1700:FF:000002', NULL, NULL, 'Suppressor of variegation 4-20 protein-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(75830, NULL, 'G3DSA:3.40.50.620:FF:000716', NULL, NULL, 'AFR721Wp', NULL, NULL, NULL, NULL, NULL, 4),
(75831, NULL, 'G3DSA:1.20.5.170:FF:000031', NULL, NULL, 'BZIP transcription factor (MeaB)', NULL, NULL, NULL, NULL, NULL, 4),
(75832, NULL, 'G3DSA:1.20.5.190:FF:000037', NULL, NULL, 'Myosin VB', NULL, NULL, NULL, NULL, NULL, 4),
(75833, NULL, 'G3DSA:3.30.420.10:FF:000283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75834, NULL, 'G3DSA:2.130.10.10:FF:005898', NULL, NULL, 'Tyrosine-protein kinase receptor svh-2', NULL, NULL, NULL, NULL, NULL, 4),
(75835, NULL, 'G3DSA:1.10.274.100:FF:000024', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(75836, NULL, 'G3DSA:3.30.360.20:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75837, NULL, 'G3DSA:4.10.320.30:FF:000006', NULL, NULL, 'Myelin transcription factor 1b', NULL, NULL, NULL, NULL, NULL, 4),
(75838, NULL, 'G3DSA:3.20.20.80:FF:000841', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75839, NULL, 'G3DSA:3.60.15.10:FF:000099', NULL, NULL, '3'',5''-cyclic-nucleotide phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(75840, NULL, 'G3DSA:2.40.30.20:FF:000016', NULL, NULL, 'Related to RIB5-riboflavin synthase, alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(75841, NULL, 'G3DSA:1.25.40.10:FF:001182', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g18520, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(75842, NULL, 'G3DSA:2.40.10.10:FF:000248', NULL, NULL, 'Anionic trypsin-2', NULL, NULL, NULL, NULL, NULL, 4),
(75843, NULL, 'G3DSA:1.20.1070.10:FF:000972', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75844, NULL, 'G3DSA:3.40.50.10090:FF:000065', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(75845, NULL, 'G3DSA:2.60.120.920:FF:000161', NULL, NULL, 'Protein TRAUCO', NULL, NULL, NULL, NULL, NULL, 4),
(75846, NULL, 'G3DSA:3.40.50.620:FF:000823', NULL, NULL, 'Diphthine--ammonia ligase', NULL, NULL, NULL, NULL, NULL, 4),
(75847, NULL, 'G3DSA:3.30.70.260:FF:000160', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(75848, NULL, 'G3DSA:3.40.50.620:FF:000031', NULL, NULL, 'Asparagine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(75849, NULL, 'G3DSA:3.30.497.10:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75850, NULL, 'G3DSA:1.25.40.10:FF:000782', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(75851, NULL, 'G3DSA:1.10.10.800:FF:000001', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(75852, NULL, 'G3DSA:3.30.1490.100:FF:000030', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(75853, NULL, 'G3DSA:3.30.70.330:FF:001147', NULL, NULL, 'Pre-rRNA-processing protein esf-2', NULL, NULL, NULL, NULL, NULL, 4),
(75854, NULL, 'G3DSA:1.10.10.10:FF:001735', NULL, NULL, 'Two-component system regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(75855, NULL, 'G3DSA:3.40.50.410:FF:000193', NULL, NULL, 'Ubiquitin-conjugating enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(75856, NULL, 'G3DSA:2.40.70.10:FF:000128', NULL, NULL, 'Plasmepsin IX', NULL, NULL, NULL, NULL, NULL, 4),
(75857, NULL, 'G3DSA:3.40.50.150:FF:001727', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75858, NULL, 'G3DSA:3.30.710.10:FF:000491', NULL, NULL, 'Tumor necrosis factor, alpha-induced protein 1 (endothelial)', NULL, NULL, NULL, NULL, NULL, 4),
(75859, NULL, 'G3DSA:3.30.70.260:FF:000030', NULL, NULL, 'Homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(75860, NULL, 'G3DSA:1.20.1270.60:FF:000053', NULL, NULL, 'SH3 domain-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(75861, NULL, 'G3DSA:3.40.1170.20:FF:000004', NULL, NULL, 'tRNA-splicing endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(75862, NULL, 'G3DSA:4.10.410.10:FF:000007', NULL, NULL, 'Collagen type VI alpha 3 chain', NULL, NULL, NULL, NULL, NULL, 4),
(75863, NULL, 'G3DSA:3.40.50.720:FF:001584', NULL, NULL, 'Probable oxidoreductase (Short-chain dehydrogenase family)', NULL, NULL, NULL, NULL, NULL, 4),
(75864, NULL, 'G3DSA:3.30.420.40:FF:001005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75865, NULL, 'G3DSA:1.20.58.390:FF:000203', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(75866, NULL, 'G3DSA:2.60.40.1180:FF:000194', NULL, NULL, 'Alpha-galactosidase Mel36A', NULL, NULL, NULL, NULL, NULL, 4),
(75867, NULL, 'G3DSA:3.90.20.20:FF:000034', NULL, NULL, 'GrpE protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(75868, NULL, 'G3DSA:3.40.50.150:FF:001379', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75869, NULL, 'G3DSA:2.60.120.200:FF:000743', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75870, NULL, 'G3DSA:3.30.160.60:FF:002929', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75871, NULL, 'G3DSA:1.20.1070.10:FF:001023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75872, NULL, 'G3DSA:2.30.30.490:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75873, NULL, 'G3DSA:3.30.160.60:FF:002593', NULL, NULL, 'Zinc finger protein 80', NULL, NULL, NULL, NULL, NULL, 4),
(75874, NULL, 'G3DSA:1.10.1200.10:FF:000171', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(75875, NULL, 'G3DSA:2.20.25.240:FF:000001', NULL, NULL, 'FLYWCH-type zinc finger-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(75876, NULL, 'G3DSA:1.20.1390.10:FF:000007', NULL, NULL, 'CCCH zinc finger and RRM domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(75877, NULL, 'G3DSA:3.20.10.10:FF:000011', NULL, NULL, 'Branched-chain-amino-acid aminotransferase-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(75878, NULL, 'G3DSA:3.30.70.330:FF:000877', NULL, NULL, 'Myelin expression factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(75879, NULL, 'G3DSA:2.60.120.10:FF:000532', NULL, NULL, 'Protein kinase cGMP-dependent 1b', NULL, NULL, NULL, NULL, NULL, 4),
(75880, NULL, 'G3DSA:3.30.160.60:FF:003329', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(75881, NULL, 'G3DSA:1.20.1070.10:FF:000534', NULL, NULL, 'Muscarinic acetylcholine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(75882, NULL, 'G3DSA:1.20.58.60:FF:000466', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75883, NULL, 'G3DSA:4.10.400.10:FF:000052', NULL, NULL, 'Sortilin related receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(75884, NULL, 'G3DSA:1.10.287.70:FF:000721', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75885, NULL, 'G3DSA:3.30.70.330:FF:000658', NULL, NULL, 'RNA-binding protein, putative, UPB1', NULL, NULL, NULL, NULL, NULL, 4),
(75886, NULL, 'G3DSA:3.40.50.1000:FF:000329', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(75887, NULL, 'G3DSA:2.40.240.10:FF:000012', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(75888, NULL, 'G3DSA:1.25.10.10:FF:003271', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(75889, NULL, 'G3DSA:2.60.120.650:FF:000057', NULL, NULL, 'Cupin-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(75890, NULL, 'G3DSA:3.40.50.300:FF:007192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75891, NULL, 'G3DSA:3.40.50.1820:FF:000463', NULL, NULL, 'Alpha/beta-Hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(75892, NULL, 'G3DSA:3.40.50.12780:FF:000006', NULL, NULL, 'long-chain-fatty-acid--CoA ligase 6 isoform X2', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(75893, NULL, 'G3DSA:1.25.10.10:FF:001359', NULL, NULL, 'Armadillo-type protein', NULL, NULL, NULL, NULL, NULL, 4),
(75894, NULL, 'G3DSA:3.40.50.1980:FF:000027', NULL, NULL, 'Ferrichrome ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(75895, NULL, 'G3DSA:1.10.10.10:FF:000229', NULL, NULL, 'HSF-type DNA-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(75896, NULL, 'G3DSA:3.80.10.10:FF:000525', NULL, NULL, 'GLC7-interacting protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(75897, NULL, 'G3DSA:2.60.110.10:FF:000032', NULL, NULL, 'Pathogenesis-related thaumatin superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(75898, NULL, 'G3DSA:3.40.50.300:FF:006792', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75899, NULL, 'G3DSA:3.40.250.10:FF:000071', NULL, NULL, 'Rodhanase family domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(75900, NULL, 'G3DSA:1.25.40.20:FF:000566', NULL, NULL, '6-phosphofructo-2-kinase/fructose-2,6-biphosphata se-1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(75901, NULL, 'G3DSA:1.10.472.10:FF:000465', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75902, NULL, 'G3DSA:3.40.50.1820:FF:000333', NULL, NULL, 'Steryl ester hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75903, NULL, 'G3DSA:3.40.50.1000:FF:000874', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75904, NULL, 'G3DSA:3.30.60.20:FF:000084', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(75905, NULL, 'G3DSA:1.25.70.10:FF:000065', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(75906, NULL, 'G3DSA:4.10.372.10:FF:000002', NULL, NULL, 'Lipoxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(75907, NULL, 'G3DSA:3.80.10.10:FF:004229', NULL, NULL, 'Tubulin-specific chaperone E-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(75908, NULL, 'G3DSA:3.40.50.720:FF:002545', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75909, NULL, 'G3DSA:3.80.10.10:FF:003487', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75910, NULL, 'G3DSA:3.40.50.1100:FF:000230', NULL, NULL, 'Putative inactive cysteine synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(75911, NULL, 'G3DSA:3.40.50.300:FF:007540', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75912, NULL, 'G3DSA:3.40.630.30:FF:000504', NULL, NULL, 'Acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(75913, NULL, 'G3DSA:1.10.287.1250:FF:000003', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(75914, NULL, 'G3DSA:1.25.40.10:FF:000911', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(75915, NULL, 'G3DSA:3.30.710.10:FF:000035', NULL, NULL, 'Elongin C transcription elongation factor', NULL, NULL, NULL, NULL, NULL, 4),
(75916, NULL, 'G3DSA:1.25.40.10:FF:004273', NULL, NULL, 'AGAP006324-PA', NULL, NULL, NULL, NULL, NULL, 4),
(75917, NULL, 'G3DSA:1.20.140.150:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75918, NULL, 'G3DSA:1.10.510.10:FF:003213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75919, NULL, 'G3DSA:1.10.287.130:FF:000121', NULL, NULL, 'Histidine kinase sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(75920, NULL, 'G3DSA:1.25.10.10:FF:002871', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75921, NULL, 'G3DSA:2.10.70.10:FF:000040', NULL, NULL, 'Complement C1r subcomponent', NULL, NULL, NULL, NULL, NULL, 4),
(75922, NULL, 'G3DSA:3.40.50.1820:FF:000805', NULL, NULL, 'Triacylglycerol lipase', NULL, NULL, NULL, NULL, NULL, 4),
(75923, NULL, 'G3DSA:3.30.420.150:FF:000015', NULL, NULL, 'WGS project CABT00000000 data, contig 2.1', NULL, NULL, NULL, NULL, NULL, 4),
(75924, NULL, 'G3DSA:3.30.160.60:FF:003082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75925, NULL, 'G3DSA:3.30.40.10:FF:001951', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75926, NULL, 'G3DSA:3.90.870.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(75927, NULL, 'G3DSA:3.30.420.100:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75928, NULL, 'G3DSA:3.60.21.10:FF:000484', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(75929, NULL, 'G3DSA:1.20.58.400:FF:000044', NULL, NULL, 'Vesicle transport through interaction with t-SNAREs 1B', NULL, NULL, NULL, NULL, NULL, 4),
(75930, NULL, 'G3DSA:3.30.420.10:FF:000064', NULL, NULL, 'RNA exonuclease 4', NULL, NULL, NULL, NULL, NULL, 4),
(75931, NULL, 'G3DSA:3.90.1200.10:FF:000044', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(75932, NULL, 'G3DSA:3.30.750.24:FF:000023', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(75933, NULL, 'G3DSA:1.10.287.160:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75934, NULL, 'G3DSA:1.10.3210.10:FF:000020', NULL, NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(75935, NULL, 'G3DSA:3.40.50.670:FF:000017', NULL, NULL, 'Putative type II DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(75936, NULL, 'G3DSA:1.20.1070.10:FF:001708', NULL, NULL, 'Uncharacterized protein LOPA7', NULL, NULL, NULL, NULL, NULL, 4),
(75937, NULL, 'G3DSA:3.80.10.10:FF:002998', NULL, NULL, 'Os11g0641200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(75938, NULL, 'G3DSA:3.40.630.30:FF:000156', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(75939, NULL, 'G3DSA:3.30.2010.10:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75940, NULL, 'G3DSA:3.40.50.300:FF:003830', NULL, NULL, 'GTP-binding family protein', NULL, NULL, NULL, NULL, NULL, 4),
(75941, NULL, 'G3DSA:3.10.20.90:FF:000125', NULL, NULL, 'pleckstrin homology domain-containing family H member 2', NULL, NULL, NULL, NULL, NULL, 4),
(75942, NULL, 'G3DSA:2.40.150.20:FF:000002', NULL, NULL, '50S ribosomal protein L14, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(75943, NULL, 'G3DSA:3.30.559.10:FF:000025', NULL, NULL, 'Carnitine acetyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(75944, NULL, 'G3DSA:1.10.10.820:FF:000007', NULL, NULL, 'unconventional myosin-Id', NULL, NULL, NULL, NULL, NULL, 4),
(75945, NULL, 'G3DSA:3.30.230.10:FF:000009', NULL, NULL, '116 kDa U5 small nuclear ribonucleoprotein component', NULL, NULL, NULL, NULL, NULL, 4),
(75946, NULL, 'G3DSA:1.10.510.10:FF:000914', NULL, NULL, 'Anti-Muellerian hormone type-2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(75947, NULL, 'G3DSA:1.10.1040.10:FF:000080', NULL, NULL, '2-hydroxymethylglutarate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(75948, NULL, 'G3DSA:2.60.40.10:FF:004397', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75949, NULL, 'G3DSA:1.10.510.10:FF:002376', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75950, NULL, 'G3DSA:3.40.1190.20:FF:000017', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(75951, NULL, 'G3DSA:1.10.730.10:FF:000009', NULL, NULL, 'Valine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(75952, NULL, 'G3DSA:2.60.40.420:FF:000148', NULL, NULL, 'Cytochrome C oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(75953, NULL, 'G3DSA:3.40.50.10580:FF:000004', NULL, NULL, 'V-type proton ATPase subunit F', NULL, NULL, NULL, NULL, NULL, 4),
(75954, NULL, 'G3DSA:1.10.8.270:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75955, NULL, 'G3DSA:1.10.8.50:FF:000010', NULL, NULL, 'endonuclease 8-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(75956, NULL, 'G3DSA:3.30.70.330:FF:002108', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75957, NULL, 'G3DSA:1.20.1070.10:FF:000079', NULL, NULL, 'Calcitonin gene-related peptide type 1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(75958, NULL, 'G3DSA:1.25.40.10:FF:003328', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(75959, NULL, 'G3DSA:2.60.40.10:FF:005122', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(75960, NULL, 'G3DSA:2.130.10.10:FF:001407', NULL, NULL, 'Intraflagellar transport protein 172 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(75961, NULL, 'G3DSA:3.40.50.150:FF:000311', NULL, NULL, 'Methyltransferase protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(75962, NULL, 'G3DSA:3.40.50.10140:FF:000007', NULL, NULL, 'Disease resistance protein (TIR-NBS-LRR class)', NULL, NULL, NULL, NULL, NULL, 4),
(75963, NULL, 'G3DSA:3.40.390.10:FF:000249', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75964, NULL, 'G3DSA:4.10.1000.10:FF:000108', NULL, NULL, 'An-Nup2 Nuclear pore complex protein (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(75965, NULL, 'G3DSA:3.30.460.10:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75966, NULL, 'G3DSA:2.100.10.50:FF:000010', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(75967, NULL, 'G3DSA:2.40.50.140:FF:000525', NULL, NULL, 'DNA replication licensing factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75968, NULL, 'G3DSA:3.15.10.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75969, NULL, 'G3DSA:1.20.1560.10:FF:000150', NULL, NULL, 'ATP-binding Cassette (ABC) Superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(75970, NULL, 'G3DSA:3.30.710.10:FF:000507', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(75971, NULL, 'G3DSA:1.25.10.10:FF:001702', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75972, NULL, 'G3DSA:3.90.110.10:FF:000004', NULL, NULL, 'Malate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(75973, NULL, 'G3DSA:1.10.630.10:FF:000406', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(75974, NULL, 'G3DSA:3.40.50.360:FF:000043', NULL, NULL, 'NAD(P)H dehydrogenase, quinone family', NULL, NULL, NULL, NULL, NULL, 4),
(75975, NULL, 'G3DSA:3.30.1140.32:FF:000016', NULL, NULL, '30S ribosomal protein S3', NULL, NULL, NULL, NULL, NULL, 4),
(75976, NULL, 'G3DSA:3.40.630.30:FF:000611', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(75977, NULL, 'G3DSA:3.40.50.300:FF:001806', NULL, NULL, 'rho-related GTP-binding protein RhoD isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(75978, NULL, 'G3DSA:1.10.8.60:FF:000344', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(75979, NULL, 'G3DSA:3.30.870.10:FF:000092', NULL, NULL, 'Phospholipase D', NULL, NULL, NULL, NULL, NULL, 4),
(75980, NULL, 'G3DSA:2.30.42.10:FF:000209', NULL, NULL, 'PDZ domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(75981, NULL, 'G3DSA:3.90.230.10:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75982, NULL, 'G3DSA:3.20.20.100:FF:000166', NULL, NULL, 'Glutamate--cysteine ligase regulatory subunit-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(75983, NULL, 'G3DSA:1.20.5.300:FF:000008', NULL, NULL, 'Phosphoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(75984, NULL, 'G3DSA:3.40.50.1980:FF:000134', NULL, NULL, 'Histidinol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(75985, NULL, 'G3DSA:2.10.25.10:FF:001481', NULL, NULL, 'slit homolog 2 protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(75986, NULL, 'G3DSA:1.10.10.60:FF:000873', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75987, NULL, 'G3DSA:1.20.1330.10:FF:000009', NULL, NULL, 'Flagellin', NULL, NULL, NULL, NULL, NULL, 4),
(75988, NULL, 'G3DSA:3.40.50.150:FF:000199', NULL, NULL, 'arginine-hydroxylase NDUFAF5, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(75989, NULL, 'G3DSA:1.20.58.70:FF:000019', NULL, NULL, 't-SNARE', NULL, NULL, NULL, NULL, NULL, 4),
(75990, NULL, 'G3DSA:3.30.1340.30:FF:000006', NULL, NULL, 'Putative signal peptide protein', NULL, NULL, NULL, NULL, NULL, 4),
(75991, NULL, 'G3DSA:1.10.12.10:FF:000048', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(75992, NULL, 'G3DSA:3.30.70.920:FF:000048', NULL, NULL, 'Lrp/AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(75993, NULL, 'G3DSA:2.130.10.10:FF:001396', NULL, NULL, 'Syntaxin-binding protein 5', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(75994, NULL, 'G3DSA:3.30.160.60:FF:003430', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75995, NULL, 'G3DSA:3.30.420.40:FF:000168', NULL, NULL, 'Xylulose kinase', NULL, NULL, NULL, NULL, NULL, 4),
(75996, NULL, 'G3DSA:3.30.300.30:FF:000111', NULL, NULL, 'Nonribosomal peptide synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(75997, NULL, 'G3DSA:2.30.30.440:FF:000001', NULL, NULL, 'DUF1918 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(75998, NULL, 'G3DSA:3.30.160.60:FF:006078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(75999, NULL, 'G3DSA:3.30.1360.120:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76000, NULL, 'G3DSA:1.20.120.80:FF:000021', NULL, NULL, 'Cytochrome c oxidase subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(76001, NULL, 'G3DSA:1.20.1250.20:FF:001922', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76002, NULL, 'G3DSA:2.130.10.10:FF:003537', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', NULL, NULL, NULL, NULL, NULL, 4),
(76003, NULL, 'G3DSA:3.40.50.300:FF:003936', NULL, NULL, 'RabD', NULL, NULL, NULL, NULL, NULL, 4),
(76004, NULL, 'G3DSA:1.10.220.120:FF:000001', NULL, NULL, 'RNA polymerase sigma factor RpoD', NULL, NULL, NULL, NULL, NULL, 4),
(76005, NULL, 'G3DSA:2.60.120.290:FF:000045', NULL, NULL, 'Cubilin', NULL, NULL, NULL, NULL, NULL, 4),
(76006, NULL, 'G3DSA:1.20.1740.10:FF:000260', NULL, NULL, 'Cationic amino acid transporter 3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(76007, NULL, 'G3DSA:1.10.8.240:FF:000004', NULL, NULL, '2-phospho-L-lactate transferase', NULL, NULL, NULL, NULL, NULL, 4),
(76008, NULL, 'G3DSA:1.10.510.10:FF:003899', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76009, NULL, 'G3DSA:1.20.1270.60:FF:000160', NULL, NULL, 'ADP-ribosylation factor-interacting protein 2a', NULL, NULL, NULL, NULL, NULL, 4),
(76010, NULL, 'G3DSA:2.40.50.100:FF:000087', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(76011, NULL, 'G3DSA:2.130.10.10:FF:000884', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(76012, NULL, 'G3DSA:3.40.50.720:FF:001691', NULL, NULL, '2-hydroxyacid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(76013, NULL, 'G3DSA:3.30.160.60:FF:000682', NULL, NULL, 'ras-responsive element-binding protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(76014, NULL, 'G3DSA:2.30.42.10:FF:000541', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76015, NULL, 'G3DSA:3.30.160.20:FF:000243', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(76016, NULL, 'G3DSA:3.40.250.10:FF:000183', NULL, NULL, 'Thiosulfate sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(76017, NULL, 'G3DSA:3.40.720.10:FF:000051', NULL, NULL, 'Arylsulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(76018, NULL, 'G3DSA:1.10.1380.10:FF:000003', NULL, NULL, 'endothelin-converting enzyme-like 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(76019, NULL, 'G3DSA:4.10.1000.10:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76020, NULL, 'G3DSA:3.30.70.330:FF:000186', NULL, NULL, 'heterogeneous nuclear ribonucleoprotein A/B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(76021, NULL, 'G3DSA:1.10.287.130:FF:000251', NULL, NULL, 'Hybrid sensory kinase', NULL, NULL, NULL, NULL, NULL, 4),
(76022, NULL, 'G3DSA:3.40.50.2300:FF:001118', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76023, NULL, 'G3DSA:1.10.510.10:FF:003101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76024, NULL, 'G3DSA:3.40.50.10800:FF:000008', NULL, NULL, 'Quinolinate synthase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(76025, NULL, 'G3DSA:1.25.40.10:FF:004964', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76026, NULL, 'G3DSA:3.90.960.10:FF:000017', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(76027, NULL, 'G3DSA:1.10.472.10:FF:000353', NULL, NULL, 'YALI0C15114p', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(76028, NULL, 'G3DSA:2.60.40.10:FF:001755', NULL, NULL, 'Immunoglobulin superfamily DCC subclass member 4', NULL, NULL, NULL, NULL, NULL, 4),
(76029, NULL, 'G3DSA:3.40.50.300:FF:007534', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76030, NULL, 'G3DSA:3.90.70.80:FF:000072', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(76031, NULL, 'G3DSA:2.40.50.140:FF:000632', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76032, NULL, 'G3DSA:3.30.160.60:FF:001188', NULL, NULL, 'zinc finger protein 629 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(76033, NULL, 'G3DSA:1.20.1460.10:FF:000002', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(76034, NULL, 'G3DSA:3.80.10.10:FF:003723', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76035, NULL, 'G3DSA:2.60.120.430:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76036, NULL, 'G3DSA:3.30.70.1730:FF:000051', NULL, NULL, '50S ribosomal protein L10', NULL, NULL, NULL, NULL, NULL, 4),
(76037, NULL, 'G3DSA:1.10.10.10:FF:001050', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(76038, NULL, 'G3DSA:1.20.58.60:FF:000342', NULL, NULL, 'Microtubule-actin cross-linking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(76039, NULL, 'G3DSA:3.30.70.100:FF:000027', NULL, NULL, 'Copper chaperone for superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(76040, NULL, 'G3DSA:3.40.33.10:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76041, NULL, 'G3DSA:1.25.40.420:FF:000001', NULL, NULL, 'Kelch-like family member 12', NULL, NULL, NULL, NULL, NULL, 4),
(76042, NULL, 'G3DSA:3.30.40.10:FF:000208', NULL, NULL, 'Zinc finger protein-related isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(76043, NULL, 'G3DSA:1.20.1560.10:FF:000835', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76044, NULL, 'G3DSA:1.20.1280.20:FF:000002', NULL, NULL, 'HscB mitochondrial iron-sulfur cluster co-chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(76045, NULL, 'G3DSA:1.10.510.10:FF:001864', NULL, NULL, 'Calcium-dependent protein kinase SK5', NULL, NULL, NULL, NULL, NULL, 4),
(76046, NULL, 'G3DSA:1.25.40.10:FF:000675', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(76047, NULL, 'G3DSA:3.40.50.1220:FF:000047', NULL, NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(76048, NULL, 'G3DSA:3.30.160.60:FF:004953', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76049, NULL, 'G3DSA:1.25.40.10:FF:002816', NULL, NULL, 'Tetratricopeptide repeat domain 17', NULL, NULL, NULL, NULL, NULL, 4),
(76050, NULL, 'G3DSA:2.40.30.10:FF:000120', NULL, NULL, 'Respiratory burst oxidase homolog protein C', NULL, NULL, NULL, NULL, NULL, 4),
(76051, NULL, 'G3DSA:3.20.20.70:FF:000849', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76052, NULL, 'G3DSA:3.30.70.330:FF:001041', NULL, NULL, 'RNA-binding protein CP33, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(76053, NULL, 'G3DSA:1.10.560.10:FF:000069', NULL, NULL, 'T-complex protein 1 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(76054, NULL, 'G3DSA:2.10.25.10:FF:001149', NULL, NULL, 'Neurocan core protein', NULL, NULL, NULL, NULL, NULL, 4),
(76055, NULL, 'G3DSA:3.90.70.10:FF:000202', NULL, NULL, 'Unplaced genomic scaffold supercont1.10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(76056, NULL, 'G3DSA:1.10.565.10:FF:000153', NULL, NULL, 'nuclear receptor isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(76057, NULL, 'G3DSA:3.30.70.330:FF:000079', NULL, NULL, 'Putative splicing factor 45', NULL, NULL, NULL, NULL, NULL, 4),
(76058, NULL, 'G3DSA:2.10.110.10:FF:000279', NULL, NULL, 'YALI0F13211p', NULL, NULL, NULL, NULL, NULL, 4),
(76059, NULL, 'G3DSA:1.20.1070.10:FF:000186', NULL, NULL, 'thyrotropin-releasing hormone receptor', NULL, NULL, NULL, NULL, NULL, 4),
(76060, NULL, 'G3DSA:3.30.160.60:FF:003205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(76061, NULL, 'G3DSA:1.10.1540.10:FF:000005', NULL, NULL, 'BEACH domain-containing protein C1', NULL, NULL, NULL, NULL, NULL, 4),
(76062, NULL, 'G3DSA:3.40.50.1460:FF:000085', NULL, NULL, 'Protein CBG22515', NULL, NULL, NULL, NULL, NULL, 4),
(76063, NULL, 'G3DSA:2.40.50.230:FF:000002', NULL, NULL, 'Type VI secretion protein VgrG', NULL, NULL, NULL, NULL, NULL, 4),
(76064, NULL, 'G3DSA:1.10.3450.40:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76065, NULL, 'G3DSA:3.30.2140.20:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76066, NULL, 'G3DSA:2.130.10.10:FF:002121', NULL, NULL, 'Endoplasmic reticulum to nucleus signaling 2', NULL, NULL, NULL, NULL, NULL, 4),
(76067, NULL, 'G3DSA:3.30.420.40:FF:000275', NULL, NULL, 'Putative xylulokinase', NULL, NULL, NULL, NULL, NULL, 4),
(76068, NULL, 'G3DSA:3.80.10.10:FF:002200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76069, NULL, 'G3DSA:2.130.10.30:FF:000109', NULL, NULL, 'E3 ubiquitin-protein ligase HERC2', NULL, NULL, NULL, NULL, NULL, 4),
(76070, NULL, 'G3DSA:3.40.309.10:FF:000044', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(76071, NULL, 'G3DSA:3.30.420.40:FF:000387', NULL, NULL, 'Conserved hypothetical proline and threonine rich protein', NULL, NULL, NULL, NULL, NULL, 4),
(76072, NULL, 'G3DSA:3.30.1490.100:FF:000024', NULL, NULL, 'DNA polymerase kappa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(76073, NULL, 'G3DSA:1.25.40.10:FF:001530', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(76074, NULL, 'G3DSA:2.60.40.10:FF:001536', NULL, NULL, 'Sidestep, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(76075, NULL, 'G3DSA:1.10.472.10:FF:000572', NULL, NULL, 'Cyclin D3', NULL, NULL, NULL, NULL, NULL, 4),
(76076, NULL, 'G3DSA:3.20.190.10:FF:000019', NULL, NULL, 'Fpg1p', NULL, NULL, NULL, NULL, NULL, 4),
(76077, NULL, 'G3DSA:3.30.930.10:FF:000035', NULL, NULL, 'Putative lipoyltransferase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(76078, NULL, 'G3DSA:3.40.50.1360:FF:000061', NULL, NULL, '6-phosphogluconolactonase', NULL, NULL, NULL, NULL, NULL, 4),
(76079, NULL, 'G3DSA:3.30.40.10:FF:000315', NULL, NULL, 'RING finger protein 215', NULL, NULL, NULL, NULL, NULL, 4),
(76080, NULL, 'G3DSA:3.30.750.24:FF:000135', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(76081, NULL, 'G3DSA:2.40.240.20:FF:000009', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4),
(76082, NULL, 'G3DSA:1.25.60.10:FF:000002', NULL, NULL, 'Magnesium transporter MgtE', NULL, NULL, NULL, NULL, NULL, 4),
(76083, NULL, 'G3DSA:1.20.1420.30:FF:000090', NULL, NULL, 'Potassium-dependent sodium-calcium exchanger, putative', NULL, NULL, NULL, NULL, NULL, 4),
(76084, NULL, 'G3DSA:3.60.21.10:FF:000377', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76085, NULL, 'G3DSA:1.20.120.980:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76086, NULL, 'G3DSA:3.40.50.300:FF:006685', NULL, NULL, 'Uncharacterized protein, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(76087, NULL, 'G3DSA:1.20.5.170:FF:000267', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(76088, NULL, 'G3DSA:2.60.40.2030:FF:000033', NULL, NULL, 'Adhesion G protein-coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(76089, NULL, 'G3DSA:2.130.10.10:FF:000103', NULL, NULL, 'Meiosis regulator for oocyte development', NULL, NULL, NULL, NULL, NULL, 4),
(76090, NULL, 'G3DSA:3.30.519.10:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76091, NULL, 'G3DSA:1.10.8.1310:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76092, NULL, 'G3DSA:3.30.70.330:FF:002552', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76093, NULL, 'G3DSA:1.20.144.10:FF:000044', NULL, NULL, 'Lipid A 1-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(76094, NULL, 'G3DSA:3.40.630.150:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(76095, NULL, 'G3DSA:3.40.50.300:FF:000502', NULL, NULL, 'Apoptotic protease-activating factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(76096, NULL, 'G3DSA:1.25.40.20:FF:000791', NULL, NULL, 'Ankyrin repeats (3 copies), putative', NULL, NULL, NULL, NULL, NULL, 4),
(76097, NULL, 'G3DSA:1.20.140.150:FF:000028', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(76098, NULL, 'G3DSA:3.90.1150.10:FF:000500', NULL, NULL, 'Glycine cleavage system P protein', NULL, NULL, NULL, NULL, NULL, 4),
(76099, NULL, 'G3DSA:3.90.226.10:FF:000172', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(76100, NULL, 'G3DSA:3.10.580.10:FF:000102', NULL, NULL, 'Chloride channel, voltage-sensitive 2a', NULL, NULL, NULL, NULL, NULL, 4),
(76101, NULL, 'G3DSA:3.30.160.60:FF:005459', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76102, NULL, 'G3DSA:3.10.110.10:FF:000168', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(76103, NULL, 'G3DSA:3.90.1150.10:FF:000388', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76104, NULL, 'G3DSA:2.60.40.4190:FF:000001', NULL, NULL, 'Major S-layer protein', NULL, NULL, NULL, NULL, NULL, 4),
(76105, NULL, 'G3DSA:3.40.1170.10:FF:000018', NULL, NULL, 'MutS family protein', NULL, NULL, NULL, NULL, NULL, 4),
(76106, NULL, 'G3DSA:3.40.50.300:FF:003251', NULL, NULL, 'SNF2 family helicase-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(76107, NULL, 'G3DSA:1.10.150.60:FF:000013', NULL, NULL, 'AT-rich interactive domain-containing protein 4B', NULL, NULL, NULL, NULL, NULL, 4),
(76108, NULL, 'G3DSA:3.30.160.60:FF:001300', NULL, NULL, 'Zinc finger and BTB domain-containing protein 47', NULL, NULL, NULL, NULL, NULL, 4),
(76109, NULL, 'G3DSA:1.20.1050.10:FF:000173', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(76110, NULL, 'G3DSA:1.10.220.30:FF:000010', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(76111, NULL, 'G3DSA:3.90.660.10:FF:000091', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76112, NULL, 'G3DSA:2.40.50.140:FF:001144', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76113, NULL, 'G3DSA:2.30.29.30:FF:000235', NULL, NULL, 'Coactivator-associated arginine methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(76114, NULL, 'G3DSA:3.30.70.850:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76115, NULL, 'G3DSA:1.20.1070.10:FF:000404', NULL, NULL, 'Cyclic AMP receptor-like protein A', NULL, NULL, NULL, NULL, NULL, 4),
(76116, NULL, 'G3DSA:3.90.1750.10:FF:000012', NULL, NULL, 'E3 ubiquitin-protein ligase UPL7', NULL, NULL, NULL, NULL, NULL, 4),
(76117, NULL, 'G3DSA:3.30.200.20:FF:000865', NULL, NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(76118, NULL, 'G3DSA:3.30.200.160:FF:000008', NULL, NULL, 'Transcription factor TFIIIC subunit', NULL, NULL, NULL, NULL, NULL, 4),
(76119, NULL, 'G3DSA:1.10.10.10:FF:001628', NULL, NULL, 'Lambda phage replication protein O', NULL, NULL, NULL, NULL, NULL, 4),
(76120, NULL, 'G3DSA:1.10.510.10:FF:002483', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76121, NULL, 'G3DSA:1.20.1640.10:FF:000095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76122, NULL, 'G3DSA:3.80.10.10:FF:000963', NULL, NULL, 'Nucleotide excision NEF4 component', NULL, NULL, NULL, NULL, NULL, 4),
(76123, NULL, 'G3DSA:2.60.40.10:FF:002267', NULL, NULL, 'Myotactin form A', NULL, NULL, NULL, NULL, NULL, 4),
(76124, NULL, 'G3DSA:3.30.230.10:FF:000358', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76125, NULL, 'G3DSA:1.10.260.40:FF:000027', NULL, NULL, 'Homeobox protein cut-like', NULL, NULL, NULL, NULL, NULL, 4),
(76126, NULL, 'G3DSA:2.20.70.10:FF:000067', NULL, NULL, 'Pre-mRNA-processing protein 40C', NULL, NULL, NULL, NULL, NULL, 4),
(76127, NULL, 'G3DSA:2.160.20.10:FF:000018', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(76128, NULL, 'G3DSA:3.90.550.50:FF:000083', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(76129, NULL, 'G3DSA:1.20.1250.10:FF:000065', NULL, NULL, 'Prolactin, gene 2', NULL, NULL, NULL, NULL, NULL, 4),
(76130, NULL, 'G3DSA:1.20.58.70:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76131, NULL, 'G3DSA:2.30.29.170:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76132, NULL, 'G3DSA:1.20.5.190:FF:000149', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76133, NULL, 'G3DSA:1.10.510.10:FF:004517', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76134, NULL, 'G3DSA:1.10.565.10:FF:000041', NULL, NULL, 'Nuclear hormone receptor HR78', NULL, NULL, NULL, NULL, NULL, 4),
(76135, NULL, 'G3DSA:1.10.238.10:FF:000545', NULL, NULL, 'EF-hand calcium-binding domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(76136, NULL, 'G3DSA:3.40.50.1820:FF:000912', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76137, NULL, 'G3DSA:3.40.50.12760:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76138, NULL, 'G3DSA:3.30.40.10:FF:001844', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76139, NULL, 'G3DSA:3.40.50.720:FF:001359', NULL, NULL, 'Glutamyl-tRNA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(76140, NULL, 'G3DSA:3.30.160.60:FF:004734', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76141, NULL, 'G3DSA:1.25.10.10:FF:002427', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76142, NULL, 'G3DSA:2.60.120.200:FF:000294', NULL, NULL, 'NeuReXin related', NULL, NULL, NULL, NULL, NULL, 4),
(76143, NULL, 'G3DSA:2.60.40.10:FF:005807', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76144, NULL, 'G3DSA:1.10.510.10:FF:003320', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76145, NULL, 'G3DSA:3.40.50.740:FF:000050', NULL, NULL, 'NADH-quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(76146, NULL, 'G3DSA:1.10.287.130:FF:000014', NULL, NULL, 'Signal transduction histidine-protein kinase BaeS', NULL, NULL, NULL, NULL, NULL, 4),
(76147, NULL, 'G3DSA:3.30.420.10:FF:000171', NULL, NULL, '3''-5'' exoribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(76148, NULL, 'G3DSA:1.20.120.140:FF:000038', NULL, NULL, 'GTP-binding signal recognition particle SRP54 G-domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(76149, NULL, 'G3DSA:3.40.20.10:FF:000016', NULL, NULL, 'supervillin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(76150, NULL, 'G3DSA:3.30.559.30:FF:000020', NULL, NULL, 'Nonribosomal peptide synthase SidD', NULL, NULL, NULL, NULL, NULL, 4),
(76151, NULL, 'G3DSA:1.25.40.20:FF:000004', NULL, NULL, 'Phosphatase 1 regulatory subunit 12A', NULL, NULL, NULL, NULL, NULL, 4),
(76152, NULL, 'G3DSA:1.10.590.10:FF:000003', NULL, NULL, 'Chorismate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(76153, NULL, 'G3DSA:2.60.40.1510:FF:000006', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(76154, NULL, 'G3DSA:3.20.20.80:FF:000274', NULL, NULL, 'Alpha-L-fucosidase-like', NULL, NULL, NULL, NULL, NULL, 4),
(76155, NULL, 'G3DSA:3.50.50.60:FF:000420', NULL, NULL, '2-octaprenyl-6-methoxyphenyl hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(76156, NULL, 'G3DSA:3.30.1520.10:FF:000110', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(76157, NULL, 'G3DSA:1.10.620.20:FF:000004', NULL, NULL, 'Ribonucleoside-diphosphate reductase subunit M2 B', NULL, NULL, NULL, NULL, NULL, 4),
(76158, NULL, 'G3DSA:1.10.150.80:FF:000019', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(76159, NULL, 'G3DSA:3.30.300.20:FF:000013', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(76160, NULL, 'G3DSA:1.25.40.20:FF:000459', NULL, NULL, 'Ankyrin_repeats_(3_copies)/Ankyrin_repeat/Ankyrin _repeats_(Many_copies)', NULL, NULL, NULL, NULL, NULL, 4),
(76161, NULL, 'G3DSA:3.30.1140.40:FF:000011', NULL, NULL, 'Predicted gene 3448', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(76162, NULL, 'G3DSA:2.60.120.200:FF:000170', NULL, NULL, 'neurexin-1 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(76163, NULL, 'G3DSA:3.30.70.141:FF:000006', NULL, NULL, 'Nucleoside diphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(76164, NULL, 'G3DSA:3.60.10.10:FF:000127', NULL, NULL, 'DNase I superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(76165, NULL, 'G3DSA:1.25.40.10:FF:003435', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g35130, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(76166, NULL, 'G3DSA:1.20.1070.10:FF:000298', NULL, NULL, 'Integral membrane protein GPR155', NULL, NULL, NULL, NULL, NULL, 4),
(76167, NULL, 'G3DSA:1.10.3380.20:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76168, NULL, 'G3DSA:3.40.50.300:FF:008607', NULL, NULL, 'Peroxisomal ATPase pex6', NULL, NULL, NULL, NULL, NULL, 4),
(76169, NULL, 'G3DSA:3.40.50.300:FF:007989', NULL, NULL, 'DNA replication helicase DNA2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(76170, NULL, 'G3DSA:3.40.50.1000:FF:000767', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76171, NULL, 'G3DSA:1.20.5.350:FF:000001', NULL, NULL, 'Troponin T, fast skeletal muscle', NULL, NULL, NULL, NULL, NULL, 4),
(76172, NULL, 'G3DSA:3.40.605.10:FF:000081', NULL, NULL, 'Gamma-glutamyl phosphate reductase 2', NULL, NULL, NULL, NULL, NULL, 4),
(76173, NULL, 'G3DSA:3.20.20.80:FF:000150', NULL, NULL, 'Class III chitinase ChiA1', NULL, NULL, NULL, NULL, NULL, 4),
(76174, NULL, 'G3DSA:2.60.40.10:FF:005246', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76175, NULL, 'G3DSA:3.90.79.10:FF:000290', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(76176, NULL, 'G3DSA:1.25.40.10:FF:002598', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g22070', NULL, NULL, NULL, NULL, NULL, 4),
(76177, NULL, 'G3DSA:1.20.1560.10:FF:000274', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(76178, NULL, 'G3DSA:1.10.8.10:FF:000026', NULL, NULL, 'E3 ubiquitin-protein ligase AMFR', NULL, NULL, NULL, NULL, NULL, 4),
(76179, NULL, 'G3DSA:1.25.40.10:FF:003216', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(76180, NULL, 'G3DSA:3.30.200.20:FF:002208', NULL, NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 178', NULL, NULL, NULL, NULL, NULL, 4),
(76181, NULL, 'G3DSA:3.10.330.10:FF:000044', NULL, NULL, 'Peroxisomal ATPase pex1', NULL, NULL, NULL, NULL, NULL, 4),
(76182, NULL, 'G3DSA:1.20.120.160:FF:000033', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(76183, NULL, 'G3DSA:3.40.50.300:FF:008265', NULL, NULL, 'DsRNA-specific nuclease dicer and related ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(76184, NULL, 'G3DSA:3.10.100.10:FF:000342', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76185, NULL, 'G3DSA:3.30.70.3020:FF:000005', NULL, NULL, 'U3 small nucleolar RNA-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(76186, NULL, 'G3DSA:1.10.287.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76187, NULL, 'G3DSA:2.60.40.10:FF:002828', NULL, NULL, 'Si:ch211-150o23.3', NULL, NULL, NULL, NULL, NULL, 4),
(76188, NULL, 'G3DSA:3.30.160.60:FF:001749', NULL, NULL, 'Zinc finger protein 263', NULL, NULL, NULL, NULL, NULL, 4),
(76189, NULL, 'G3DSA:3.30.1430.10:FF:000007', NULL, NULL, '60S ribosomal protein L3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(76190, NULL, 'G3DSA:2.60.120.260:FF:000502', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76191, NULL, 'G3DSA:1.10.3120.10:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76192, NULL, 'G3DSA:2.130.10.10:FF:005555', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(76193, NULL, 'G3DSA:1.20.1000.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76194, NULL, 'G3DSA:2.60.120.10:FF:000307', NULL, NULL, 'RmlC-like jelly roll fold protein', NULL, NULL, NULL, NULL, NULL, 4),
(76195, NULL, 'G3DSA:3.30.70.330:FF:001602', NULL, NULL, 'Peroxisome proliferator-activated receptor gamma, coactivator-related 1', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(76196, NULL, 'G3DSA:3.30.1240.10:FF:000072', NULL, NULL, 'Glr0833 protein', NULL, NULL, NULL, NULL, NULL, 4),
(76197, NULL, 'G3DSA:2.60.40.60:FF:000893', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76198, NULL, 'G3DSA:1.25.40.10:FF:005346', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g12300, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(76199, NULL, 'G3DSA:1.25.10.10:FF:001466', NULL, NULL, 'Dynein axonemal assembly factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(76200, NULL, 'G3DSA:1.20.920.10:FF:000100', NULL, NULL, 'Chromatin remodeling-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(76201, NULL, 'G3DSA:3.30.565.10:FF:000427', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76202, NULL, 'G3DSA:2.170.120.12:FF:000036', NULL, NULL, 'RNA polymerase Rpb3/Rpb11 dimerisation domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(76203, NULL, 'G3DSA:3.30.160.60:FF:002025', NULL, NULL, 'zinc finger protein 473 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(76204, NULL, 'G3DSA:2.120.10.30:FF:000290', NULL, NULL, 'Teneurin-m-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(76205, NULL, 'G3DSA:3.40.50.720:FF:000634', NULL, NULL, '6-phosphogluconate dehydrogenase, decarboxylating', NULL, NULL, NULL, NULL, NULL, 4),
(76206, NULL, 'G3DSA:3.40.50.2300:FF:000736', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(76207, NULL, 'G3DSA:3.40.50.360:FF:000149', NULL, NULL, 'Oxygen-independent protoporphyrinogen oxidase HemG', NULL, NULL, NULL, NULL, NULL, 4),
(76208, NULL, 'G3DSA:2.40.50.40:FF:000113', NULL, NULL, 'C-C motif chemokine 5', NULL, NULL, NULL, NULL, NULL, 4),
(76209, NULL, 'G3DSA:2.60.40.150:FF:000606', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(76210, NULL, 'G3DSA:3.50.50.60:FF:001145', NULL, NULL, 'FAD dependent oxidoreductase domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(76211, NULL, 'G3DSA:1.10.510.10:FF:000465', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(76212, NULL, 'G3DSA:2.60.40.10:FF:004285', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76213, NULL, 'G3DSA:1.20.1280.50:FF:000106', NULL, NULL, 'Transcription factor jumonji domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(76214, NULL, 'G3DSA:3.90.70.10:FF:000888', NULL, NULL, 'Protein CBG06541', NULL, NULL, NULL, NULL, NULL, 4),
(76215, NULL, 'G3DSA:1.25.40.10:FF:002255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76216, NULL, 'G3DSA:3.20.20.70:FF:000052', NULL, NULL, 'Fructose-bisphosphate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(76217, NULL, 'G3DSA:3.40.50.1820:FF:000569', NULL, NULL, 'Blast:Protein SERAC1', NULL, NULL, NULL, NULL, NULL, 4),
(76218, NULL, 'G3DSA:1.10.630.10:FF:000625', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76219, NULL, 'G3DSA:2.30.42.10:FF:000103', NULL, NULL, 'membrane-associated guanylate kinase, WW and PDZ domain-containing protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(76220, NULL, 'G3DSA:3.90.650.10:FF:000039', NULL, NULL, 'Selenide, water dikinase', NULL, NULL, NULL, NULL, NULL, 4),
(76221, NULL, 'G3DSA:1.20.120.230:FF:000065', NULL, NULL, 'Cas scaffold protein family member 4', NULL, NULL, NULL, NULL, NULL, 4),
(76222, NULL, 'G3DSA:3.90.550.10:FF:000661', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(76223, NULL, 'G3DSA:3.30.160.60:FF:004498', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76224, NULL, 'G3DSA:3.50.50.60:FF:000869', NULL, NULL, 'Amine oxidase (Flavin-containing)', NULL, NULL, NULL, NULL, NULL, 4),
(76225, NULL, 'G3DSA:3.40.1480.10:FF:000008', NULL, NULL, 'Glycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(76226, NULL, 'G3DSA:3.30.160.60:FF:000788', NULL, NULL, 'Zinc finger protein 574', NULL, NULL, NULL, NULL, NULL, 4),
(76227, NULL, 'G3DSA:3.30.160.60:FF:005791', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(76228, NULL, 'G3DSA:2.130.10.10:FF:004594', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76229, NULL, 'G3DSA:3.30.800.10:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76230, NULL, 'G3DSA:3.70.10.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76231, NULL, 'G3DSA:1.25.40.10:FF:004385', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76232, NULL, 'G3DSA:3.90.228.10:FF:000007', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(76233, NULL, 'G3DSA:1.20.1250.20:FF:001686', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76234, NULL, 'G3DSA:1.25.40.10:FF:001979', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(76235, NULL, 'G3DSA:3.90.1150.10:FF:000264', NULL, NULL, 'DegT/DnrJ/EryC1/StrS aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(76236, NULL, 'G3DSA:1.10.150.20:FF:000136', NULL, NULL, 'DNA ligase B', NULL, NULL, NULL, NULL, NULL, 4),
(76237, NULL, 'G3DSA:2.60.120.820:FF:000024', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(76238, NULL, 'G3DSA:1.20.1250.20:FF:002304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76239, NULL, 'G3DSA:2.70.130.10:FF:000087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76240, NULL, 'G3DSA:3.80.10.10:FF:000289', NULL, NULL, 'leucine-rich repeat-containing protein 30', NULL, NULL, NULL, NULL, NULL, 4),
(76241, NULL, 'G3DSA:2.60.120.260:FF:000160', NULL, NULL, 'Spindle pole body-associated protein sad1', NULL, NULL, NULL, NULL, NULL, 4),
(76242, NULL, 'G3DSA:2.60.40.10:FF:004740', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76243, NULL, 'G3DSA:3.90.640.10:FF:000089', NULL, NULL, 'Heat shock protein family A (Hsp70) member 13', NULL, NULL, NULL, NULL, NULL, 4),
(76244, NULL, 'G3DSA:4.10.240.10:FF:000067', NULL, NULL, 'TOG1p Transcriptional activator', NULL, NULL, NULL, NULL, NULL, 4),
(76245, NULL, 'G3DSA:1.20.58.1070:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76246, NULL, 'G3DSA:3.10.580.10:FF:000208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76247, NULL, 'G3DSA:3.40.50.300:FF:000160', NULL, NULL, 'ATP-dependent RNA helicase DDX3X', NULL, NULL, NULL, NULL, NULL, 4),
(76248, NULL, 'G3DSA:3.40.190.10:FF:000936', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76249, NULL, 'G3DSA:3.10.350.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76250, NULL, 'G3DSA:2.60.40.740:FF:000002', NULL, NULL, 'Cell surface antigen I/II', NULL, NULL, NULL, NULL, NULL, 4),
(76251, NULL, 'G3DSA:3.40.50.2000:FF:000860', NULL, NULL, 'Glycogen synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(76252, NULL, 'G3DSA:3.30.1300.30:FF:000009', NULL, NULL, 'Type II secretion system protein K', NULL, NULL, NULL, NULL, NULL, 4),
(76253, NULL, 'G3DSA:1.10.4160.10:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76254, NULL, 'G3DSA:3.30.200.20:FF:000067', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(76255, NULL, 'G3DSA:3.30.160.60:FF:005353', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76256, NULL, 'G3DSA:1.25.40.10:FF:001075', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(76257, NULL, 'G3DSA:3.40.50.150:FF:001615', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76258, NULL, 'G3DSA:1.20.5.1930:FF:000001', NULL, NULL, 'Sensor histidine protein kinase UhpB', NULL, NULL, NULL, NULL, NULL, 4),
(76259, NULL, 'G3DSA:1.25.10.10:FF:001808', NULL, NULL, 'YALI0D11132p', NULL, NULL, NULL, NULL, NULL, 4),
(76260, NULL, 'G3DSA:3.30.160.60:FF:001064', NULL, NULL, 'Zinc finger protein 425', NULL, NULL, NULL, NULL, NULL, 4),
(76261, NULL, 'G3DSA:3.40.1350.10:FF:000004', NULL, NULL, 'Fanconi-associated nuclease', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(76262, NULL, 'G3DSA:3.50.50.60:FF:000526', NULL, NULL, 'FAD-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(76263, NULL, 'G3DSA:3.40.190.10:FF:000357', NULL, NULL, 'ABC-type nitrate/sulfonate/bicarbonate transport system, substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(76264, NULL, 'G3DSA:3.30.450.20:FF:000001', NULL, NULL, 'Potassium voltage-gated channel subfamily H member 7', NULL, NULL, NULL, NULL, NULL, 4),
(76265, NULL, 'G3DSA:3.80.10.10:FF:001582', NULL, NULL, 'Slit homolog 2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(76266, NULL, 'G3DSA:3.40.50.720:FF:000055', NULL, NULL, 'NAD-dependent malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(76267, NULL, 'G3DSA:1.10.510.10:FF:001426', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76268, NULL, 'G3DSA:1.10.555.10:FF:000091', NULL, NULL, 'Rho GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(76269, NULL, 'G3DSA:3.30.70.1390:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76270, NULL, 'G3DSA:3.40.50.11210:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76271, NULL, 'G3DSA:1.25.40.10:FF:001636', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g20540', NULL, NULL, NULL, NULL, NULL, 4),
(76272, NULL, 'G3DSA:3.40.50.1820:FF:001188', NULL, NULL, 'Serine carboxypeptidase S28 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(76273, NULL, 'G3DSA:3.50.50.60:FF:000184', NULL, NULL, 'Phytoene dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(76274, NULL, 'G3DSA:2.60.420.10:FF:000004', NULL, NULL, 'Uncharacterized glycosyl hydrolase Rv3401', NULL, NULL, NULL, NULL, NULL, 4),
(76275, NULL, 'G3DSA:3.40.50.10260:FF:000026', NULL, NULL, 'Bifunctional NAD(P)H-hydrate repair enzyme Nnr', NULL, NULL, NULL, NULL, NULL, 4),
(76276, NULL, 'G3DSA:2.60.34.10:FF:000066', NULL, NULL, 'Heat shock 70kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(76277, NULL, 'G3DSA:3.40.50.410:FF:000081', NULL, NULL, 'Vesicle coat component', NULL, NULL, NULL, NULL, NULL, 4),
(76278, NULL, 'G3DSA:2.60.40.640:FF:000085', NULL, NULL, 'Vacuolar sorting protein 26 putative', NULL, NULL, NULL, NULL, NULL, 4),
(76279, NULL, 'G3DSA:1.10.287.3700:FF:000002', NULL, NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', NULL, NULL, NULL, NULL, NULL, 4),
(76280, NULL, 'G3DSA:2.160.10.10:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76281, NULL, 'G3DSA:1.25.10.10:FF:001123', NULL, NULL, 'Catenin (cadherin-associated protein), delta 2a', NULL, NULL, NULL, NULL, NULL, 4),
(76282, NULL, 'G3DSA:2.60.40.10:FF:005701', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76283, NULL, 'G3DSA:1.20.5.110:FF:000165', NULL, NULL, 'Coiled-coil domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(76284, NULL, 'G3DSA:3.40.50.2000:FF:000528', NULL, NULL, 'Sulfoquinovosyl transferase SQD2', NULL, NULL, NULL, NULL, NULL, 4),
(76285, NULL, 'G3DSA:3.90.79.10:FF:000177', NULL, NULL, 'Nudix (nucleoside diphosphate-linked moiety X)-type motif 5', NULL, NULL, NULL, NULL, NULL, 4),
(76286, NULL, 'G3DSA:1.10.10.60:FF:000435', NULL, NULL, 'Transcription factor MYB124', NULL, NULL, NULL, NULL, NULL, 4),
(76287, NULL, 'G3DSA:2.10.109.10:FF:000085', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(76288, NULL, 'G3DSA:2.10.70.10:FF:000152', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(76289, NULL, 'G3DSA:1.20.120.1910:FF:000031', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(76290, NULL, 'G3DSA:1.20.120.420:FF:000021', NULL, NULL, 'Methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(76291, NULL, 'G3DSA:1.25.40.180:FF:000019', NULL, NULL, 'CBP80/20-dependent translation initiation factor isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(76292, NULL, 'G3DSA:2.30.29.30:FF:000472', NULL, NULL, 'Pleckstrin y domain-containing family H member 2', NULL, NULL, NULL, NULL, NULL, 4),
(76293, NULL, 'G3DSA:3.40.50.300:FF:004555', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(76294, NULL, 'G3DSA:3.40.47.10:FF:000044', NULL, NULL, 'Probable acetyl-CoA acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(76295, NULL, 'G3DSA:3.30.70.330:FF:002895', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76296, NULL, 'G3DSA:3.40.50.720:FF:000179', NULL, NULL, 'Biliverdin reductase A', NULL, NULL, NULL, NULL, NULL, 4),
(76297, NULL, 'G3DSA:1.25.10.10:FF:001247', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(76298, NULL, 'G3DSA:2.80.10.50:FF:000112', NULL, NULL, 'Hisactophilin-1', NULL, NULL, NULL, NULL, NULL, 4),
(76299, NULL, 'G3DSA:3.40.1110.10:FF:000133', NULL, NULL, 'Probable cation-transporting P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(76300, NULL, 'G3DSA:1.25.10.10:FF:000847', NULL, NULL, 'Sister chromatid cohesion protein', NULL, NULL, NULL, NULL, NULL, 4),
(76301, NULL, 'G3DSA:3.30.200.20:FF:001247', NULL, NULL, 'Protein CBG08151', NULL, NULL, NULL, NULL, NULL, 4),
(76302, NULL, 'G3DSA:1.20.1250.20:FF:001467', NULL, NULL, 'Putative monocarboxylate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(76303, NULL, 'G3DSA:2.40.30.30:FF:000002', NULL, NULL, 'Riboflavin kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(76304, NULL, 'G3DSA:3.40.630.10:FF:000386', NULL, NULL, 'Carboxypeptidase D, b', NULL, NULL, NULL, NULL, NULL, 4),
(76305, NULL, 'G3DSA:3.90.190.10:FF:000234', NULL, NULL, 'Inactive protein-tyrosine phosphatase egg-5', NULL, NULL, NULL, NULL, NULL, 4),
(76306, NULL, 'G3DSA:3.30.200.20:FF:002540', NULL, NULL, 'Ribosomal protein S6 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(76307, NULL, 'G3DSA:2.130.10.10:FF:004156', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit wuho', NULL, NULL, NULL, NULL, NULL, 4),
(76308, NULL, 'G3DSA:1.20.58.390:FF:000097', NULL, NULL, 'Gamma-aminobutyric acid (GABA) A receptor, beta 2', NULL, NULL, NULL, NULL, NULL, 4),
(76309, NULL, 'G3DSA:2.30.39.10:FF:000073', NULL, NULL, 'RCG21015, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(76310, NULL, 'G3DSA:3.40.50.300:FF:001121', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(76311, NULL, 'G3DSA:3.40.50.300:FF:004898', NULL, NULL, 'Drug resistance protein 1 (Truncated)', NULL, NULL, NULL, NULL, NULL, 4),
(76312, NULL, 'G3DSA:1.10.220.100:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76313, NULL, 'G3DSA:2.30.30.30:FF:000087', NULL, NULL, 'Ribosomal Protein, Large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(76314, NULL, 'G3DSA:3.40.50.150:FF:000654', NULL, NULL, 'Rab geranylgeranyl transferase component A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(76315, NULL, 'G3DSA:1.20.1110.10:FF:000122', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76316, NULL, 'G3DSA:3.30.230.60:FF:000002', NULL, NULL, 'Formaldehyde-activating enzyme domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(76317, NULL, 'G3DSA:3.40.50.300:FF:000845', NULL, NULL, 'Mitochondrial helicase twinkle', NULL, NULL, NULL, NULL, NULL, 4),
(76318, NULL, 'G3DSA:1.10.20.10:FF:000275', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76319, NULL, 'G3DSA:3.30.1490.180:FF:000008', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(76320, NULL, 'G3DSA:1.25.40.180:FF:000351', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76321, NULL, 'G3DSA:1.25.10.10:FF:000286', NULL, NULL, 'rap1 GTPase-GDP dissociation stimulator 1 isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(76322, NULL, 'G3DSA:2.160.20.20:FF:000010', NULL, NULL, 'Adhesion and penetration protein autotransporter', NULL, NULL, NULL, NULL, NULL, 4),
(76323, NULL, 'G3DSA:2.70.98.10:FF:000106', NULL, NULL, 'Aldose 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(76324, NULL, 'G3DSA:3.40.50.2300:FF:001450', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76325, NULL, 'G3DSA:3.40.50.1820:FF:001749', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76326, NULL, 'G3DSA:2.60.40.1910:FF:000019', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(76327, NULL, 'G3DSA:3.30.40.10:FF:002226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(76328, NULL, 'G3DSA:3.40.1390.30:FF:000007', NULL, NULL, 'Dinuclear metal center protein, YbgI family', NULL, NULL, NULL, NULL, NULL, 4),
(76329, NULL, 'G3DSA:2.20.80.10:FF:000017', NULL, NULL, 'Apolipoprotein Bb, tandem duplicate 1', NULL, NULL, NULL, NULL, NULL, 4),
(76330, NULL, 'G3DSA:2.130.10.10:FF:000446', NULL, NULL, 'protein ANTHESIS POMOTING FACTOR 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(76331, NULL, 'G3DSA:3.80.10.10:FF:002543', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76332, NULL, 'G3DSA:3.60.20.10:FF:000066', NULL, NULL, 'Proteasome subunit alpha type', NULL, NULL, NULL, NULL, NULL, 4),
(76333, NULL, 'G3DSA:3.30.43.10:FF:000013', NULL, NULL, 'FAD binding domain in molybdopterin dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(76334, NULL, 'G3DSA:2.30.30.140:FF:000136', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(76335, NULL, 'G3DSA:3.40.220.10:FF:000012', NULL, NULL, 'Protein mono-ADP-ribosyltransferase PARP9', NULL, NULL, NULL, NULL, NULL, 4),
(76336, NULL, 'G3DSA:1.10.8.270:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76337, NULL, 'G3DSA:2.40.10.10:FF:000012', NULL, NULL, 'protease Do-like 9', NULL, NULL, NULL, NULL, NULL, 4),
(76338, NULL, 'G3DSA:2.40.330.10:FF:000002', NULL, NULL, 'B3 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(76339, NULL, 'G3DSA:3.30.590.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76340, NULL, 'G3DSA:3.20.20.140:FF:000150', NULL, NULL, 'Error-prone DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(76341, NULL, 'G3DSA:1.20.1080.10:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76342, NULL, 'G3DSA:3.40.50.2300:FF:000157', NULL, NULL, 'Sugar ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(76343, NULL, 'G3DSA:4.10.400.10:FF:000288', NULL, NULL, 'Sortilin-related receptor', NULL, NULL, NULL, NULL, NULL, 4),
(76344, NULL, 'G3DSA:1.20.120.850:FF:000032', NULL, NULL, 'Protein CBG00336', NULL, NULL, NULL, NULL, NULL, 4),
(76345, NULL, 'G3DSA:3.40.350.10:FF:000016', NULL, NULL, 'Xaa-Pro aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(76346, NULL, 'G3DSA:3.40.140.10:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76347, NULL, 'G3DSA:3.30.70.330:FF:000422', NULL, NULL, 'serine/arginine-rich splicing factor 12', NULL, NULL, NULL, NULL, NULL, 4),
(76348, NULL, 'G3DSA:1.10.340.30:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76349, NULL, 'G3DSA:2.30.29.30:FF:000814', NULL, NULL, 'IQ motif and Sec7 domain 2', NULL, NULL, NULL, NULL, NULL, 4),
(76350, NULL, 'G3DSA:1.25.40.10:FF:001294', NULL, NULL, 'OJ991214_12.4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(76351, NULL, 'G3DSA:2.130.10.10:FF:005117', NULL, NULL, 'CKA And Striatin Homolog', NULL, NULL, NULL, NULL, NULL, 4),
(76352, NULL, 'G3DSA:2.130.10.10:FF:004717', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76353, NULL, 'G3DSA:3.60.15.10:FF:000211', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(76354, NULL, 'G3DSA:3.30.200.20:FF:000286', NULL, NULL, 'Titin a', NULL, NULL, NULL, NULL, NULL, 4),
(76355, NULL, 'G3DSA:3.40.50.300:FF:005516', NULL, NULL, 'ATPase involved in DNA repair', NULL, NULL, NULL, NULL, NULL, 4),
(76356, NULL, 'G3DSA:3.30.565.10:FF:000085', NULL, NULL, 'Sensor histidine kinase KdpD', NULL, NULL, NULL, NULL, NULL, 4),
(76357, NULL, 'G3DSA:3.10.110.10:FF:000281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76358, NULL, 'G3DSA:3.40.50.970:FF:000113', NULL, NULL, 'Oxalate oxidoreductase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(76359, NULL, 'G3DSA:3.30.9.90:FF:000008', NULL, NULL, 'Electron-transferring-flavoprotein dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(76360, NULL, 'G3DSA:3.40.50.300:FF:000946', NULL, NULL, 'putative ATP-dependent RNA helicase TDRD9', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(76361, NULL, 'G3DSA:2.120.10.30:FF:000267', NULL, NULL, 'Rme-2', NULL, NULL, NULL, NULL, NULL, 4),
(76362, NULL, 'G3DSA:3.40.50.410:FF:000041', NULL, NULL, 'Collagen alpha-1(XXI) chain isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(76363, NULL, 'G3DSA:3.90.1150.210:FF:000020', NULL, NULL, 'F-actin-capping protein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(76364, NULL, 'G3DSA:3.40.50.1010:FF:000130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76365, NULL, 'G3DSA:3.10.100.10:FF:000218', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76366, NULL, 'G3DSA:1.10.510.10:FF:001572', NULL, NULL, 'Si:dkey-31m5.5', NULL, NULL, NULL, NULL, NULL, 4),
(76367, NULL, 'G3DSA:3.40.50.2000:FF:000438', NULL, NULL, 'UDP-glycosyltransferase 85A3', NULL, NULL, NULL, NULL, NULL, 4),
(76368, NULL, 'G3DSA:3.40.50.10490:FF:000084', NULL, NULL, 'Glucose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(76369, NULL, 'G3DSA:1.20.1250.20:FF:000629', NULL, NULL, 'Staphyloferrin B transporter', NULL, NULL, NULL, NULL, NULL, 4),
(76370, NULL, 'G3DSA:3.40.190.10:FF:000279', NULL, NULL, 'PROBABLE SUGAR-BINDING LIPOPROTEIN LPQY', NULL, NULL, NULL, NULL, NULL, 4),
(76371, NULL, 'G3DSA:2.60.40.10:FF:004796', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76372, NULL, 'G3DSA:1.20.120.350:FF:000213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76373, NULL, 'G3DSA:1.10.150.50:FF:000027', NULL, NULL, 'scm-like with four MBT domains protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(76374, NULL, 'G3DSA:2.130.10.10:FF:002683', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(76375, NULL, 'G3DSA:1.10.10.60:FF:001211', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76376, NULL, 'G3DSA:2.60.40.10:FF:001570', NULL, NULL, 'Cell surface glycoprotein STIM, contains SAM domain', NULL, NULL, NULL, NULL, NULL, 4),
(76377, NULL, 'G3DSA:3.30.420.40:FF:000943', NULL, NULL, 'Actin-like protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(76378, NULL, 'G3DSA:1.10.472.10:FF:000538', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76379, NULL, 'G3DSA:1.10.287.4070:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76380, NULL, 'G3DSA:1.20.1560.10:FF:000436', NULL, NULL, 'ABC transporter B family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(76381, NULL, 'G3DSA:3.90.1150.10:FF:000039', NULL, NULL, 'Serine--pyruvate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(76382, NULL, 'G3DSA:3.30.40.10:FF:000933', NULL, NULL, 'Phd finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(76383, NULL, 'G3DSA:1.10.510.10:FF:002674', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76384, NULL, 'G3DSA:3.90.470.20:FF:000039', NULL, NULL, '4-phosphopantetheinyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(76385, NULL, 'G3DSA:3.30.160.60:FF:005381', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76386, NULL, 'G3DSA:3.30.160.60:FF:001047', NULL, NULL, 'Zinc finger and SCAN domain-containing protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(76387, NULL, 'G3DSA:1.10.150.20:FF:000131', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4),
(76388, NULL, 'G3DSA:1.25.10.10:FF:000792', NULL, NULL, 'E3 ubiquitin ligase', NULL, NULL, NULL, NULL, NULL, 4),
(76389, NULL, 'G3DSA:1.25.40.10:FF:004716', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76390, NULL, 'G3DSA:2.10.25.10:FF:001817', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76391, NULL, 'G3DSA:3.90.470.10:FF:000036', NULL, NULL, '39S ribosomal protein L22, mitochondrial-like', NULL, NULL, NULL, NULL, NULL, 4),
(76392, NULL, 'G3DSA:3.80.10.10:FF:004414', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76393, NULL, 'G3DSA:3.90.70.10:FF:000859', NULL, NULL, 'Ubiquitin-specific protease', NULL, NULL, NULL, NULL, NULL, 4),
(76394, NULL, 'G3DSA:3.40.390.10:FF:000114', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(76395, NULL, 'G3DSA:2.20.70.10:FF:000056', NULL, NULL, 'Formin binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(76396, NULL, 'G3DSA:1.20.990.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76397, NULL, 'G3DSA:1.25.10.10:FF:003107', NULL, NULL, 'Armadillo repeat-containing protein 8-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(76398, NULL, 'G3DSA:2.10.110.10:FF:000262', NULL, NULL, 'Protein CBR-LIM-7', NULL, NULL, NULL, NULL, NULL, 4),
(76399, NULL, 'G3DSA:3.40.640.10:FF:000387', NULL, NULL, '2''-deamino-2''-hydroxyneamine transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(76400, NULL, 'G3DSA:3.30.40.10:FF:000254', NULL, NULL, 'Probable E3 ubiquitin-protein ligase DTX3', NULL, NULL, NULL, NULL, NULL, 4),
(76401, NULL, 'G3DSA:3.40.50.12780:FF:000063', NULL, NULL, 'Acetyl-coenzyme A synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(76402, NULL, 'G3DSA:1.20.1270.10:FF:000010', NULL, NULL, 'Heat shock 70 kDa protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(76403, NULL, 'G3DSA:3.30.40.10:FF:002378', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76404, NULL, 'G3DSA:3.30.160.60:FF:003138', NULL, NULL, 'Zinc finger protein 214', NULL, NULL, NULL, NULL, NULL, 4),
(76405, NULL, 'G3DSA:1.10.220.150:FF:000077', NULL, NULL, 'ADP-ribosylation factor GTPase-activating protein AGD10', NULL, NULL, NULL, NULL, NULL, 4),
(76406, NULL, 'G3DSA:3.20.20.70:FF:000130', NULL, NULL, 'Ribulose-phosphate 3-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(76407, NULL, 'G3DSA:3.90.320.10:FF:000054', NULL, NULL, 'Exonuclease V', NULL, NULL, NULL, NULL, NULL, 4),
(76408, NULL, 'G3DSA:1.10.8.1120:FF:000002', NULL, NULL, 'RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(76409, NULL, 'G3DSA:3.40.50.300:FF:005297', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(76410, NULL, 'G3DSA:1.20.58.100:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76411, NULL, 'G3DSA:2.130.10.30:FF:000126', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76412, NULL, 'G3DSA:3.10.20.90:FF:000923', NULL, NULL, 'Histidine ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(76413, NULL, 'G3DSA:2.30.42.10:FF:000249', NULL, NULL, 'membrane-associated guanylate kinase, WW and PDZ domain-containing protein 1-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(76414, NULL, 'G3DSA:2.30.30.140:FF:000254', NULL, NULL, 'Histone acetyltransferase ESA1', NULL, NULL, NULL, NULL, NULL, 4),
(76415, NULL, 'G3DSA:1.25.40.20:FF:000976', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76416, NULL, 'G3DSA:3.40.50.300:FF:005151', NULL, NULL, 'ABC transporter, ATP binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(76417, NULL, 'G3DSA:2.60.40.150:FF:000578', NULL, NULL, 'Copine family member IX', NULL, NULL, NULL, NULL, NULL, 4),
(76418, NULL, 'G3DSA:3.80.10.10:FF:003897', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76419, NULL, 'G3DSA:1.20.1270.60:FF:000064', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(76420, NULL, 'G3DSA:3.40.50.150:FF:000120', NULL, NULL, 'probable 28S rRNA (Cytosine(4447)-C(5))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(76421, NULL, 'G3DSA:3.30.70.3490:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76422, NULL, 'G3DSA:3.20.20.80:FF:000133', NULL, NULL, 'Chitinase C1', NULL, NULL, NULL, NULL, NULL, 4),
(76423, NULL, 'G3DSA:3.10.450.10:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76424, NULL, 'G3DSA:2.60.34.10:FF:000049', NULL, NULL, 'Protein CBG00051', NULL, NULL, NULL, NULL, NULL, 4),
(76425, NULL, 'G3DSA:3.30.160.60:FF:003290', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76426, NULL, 'G3DSA:1.25.10.10:FF:003433', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(76427, NULL, 'G3DSA:3.40.190.10:FF:000958', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76428, NULL, 'G3DSA:2.130.10.10:FF:004448', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(76429, NULL, 'G3DSA:3.40.630.30:FF:000162', NULL, NULL, 'AT4g28030/T13J8_140', NULL, NULL, NULL, NULL, NULL, 4),
(76430, NULL, 'G3DSA:3.40.50.80:FF:000151', NULL, NULL, 'NADPH reductase TAH18', NULL, NULL, NULL, NULL, NULL, 4),
(76431, NULL, 'G3DSA:3.20.20.190:FF:000170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76432, NULL, 'G3DSA:3.40.30.10:FF:000174', NULL, NULL, 'Protein disulfide-isomerase 5-4', NULL, NULL, NULL, NULL, NULL, 4),
(76433, NULL, 'G3DSA:3.40.50.2300:FF:000910', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76434, NULL, 'G3DSA:2.30.29.30:FF:000382', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(76435, NULL, 'G3DSA:3.50.50.60:FF:000763', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(76436, NULL, 'G3DSA:3.10.20.90:FF:000131', NULL, NULL, 'trans-2,3-enoyl-CoA reductase-like', NULL, NULL, NULL, NULL, NULL, 4),
(76437, NULL, 'G3DSA:3.10.390.10:FF:000003', NULL, NULL, 'glucocorticoid modulatory element-binding protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(76438, NULL, 'G3DSA:3.30.70.330:FF:000815', NULL, NULL, 'Serine/arginine-rich splicing factor SR30', NULL, NULL, NULL, NULL, NULL, 4),
(76439, NULL, 'G3DSA:3.20.20.140:FF:000262', NULL, NULL, 'Carbohydrate esterase family 9 protein', NULL, NULL, NULL, NULL, NULL, 4),
(76440, NULL, 'G3DSA:3.30.830.10:FF:000269', NULL, NULL, 'FI23714p1', NULL, NULL, NULL, NULL, NULL, 4),
(76441, NULL, 'G3DSA:2.130.10.10:FF:000120', NULL, NULL, 'Semaphorin 4D', NULL, NULL, NULL, NULL, NULL, 4),
(76442, NULL, 'G3DSA:1.10.1820.10:FF:000015', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(76443, NULL, 'G3DSA:2.60.40.2860:FF:000023', NULL, NULL, 'Merozoite surface protein P41', NULL, NULL, NULL, NULL, NULL, 4),
(76444, NULL, 'G3DSA:2.40.37.10:FF:000012', NULL, NULL, 'Arginine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(76445, NULL, 'G3DSA:1.25.40.470:FF:000044', NULL, NULL, 'WD repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(76446, NULL, 'G3DSA:1.20.1260.10:FF:000071', NULL, NULL, 'Ferritin light chain', NULL, NULL, NULL, NULL, NULL, 4),
(76447, NULL, 'G3DSA:2.120.10.30:FF:000593', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76448, NULL, 'G3DSA:3.30.70.590:FF:000022', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(76449, NULL, 'G3DSA:3.60.15.10:FF:000177', NULL, NULL, 'MBL fold metallo-hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(76450, NULL, 'G3DSA:3.90.1010.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76451, NULL, 'G3DSA:1.25.40.1040:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76452, NULL, 'G3DSA:1.10.287.70:FF:000142', NULL, NULL, 'Calcium channel subunit Cch1', NULL, NULL, NULL, NULL, NULL, 4),
(76453, NULL, 'G3DSA:3.30.710.10:FF:000322', NULL, NULL, 'YALI0D10087p', NULL, NULL, NULL, NULL, NULL, 4),
(76454, NULL, 'G3DSA:3.60.40.10:FF:000303', NULL, NULL, 'Protein RTF1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(76455, NULL, 'G3DSA:3.30.60.30:FF:000210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76456, NULL, 'G3DSA:3.40.50.970:FF:000186', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(76457, NULL, 'G3DSA:1.10.418.10:FF:000076', NULL, NULL, 'Coiled-coil domain containing 88B', NULL, NULL, NULL, NULL, NULL, 4),
(76458, NULL, 'G3DSA:3.10.180.10:FF:000083', NULL, NULL, 'Uncharacterized 4-hydroxyphenylpyruvate dioxygenase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(76459, NULL, 'G3DSA:1.10.760.10:FF:000096', NULL, NULL, 'Probable L-sorbosone dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(76460, NULL, 'G3DSA:3.40.50.300:FF:001609', NULL, NULL, 'Cell division ATP-binding protein FtsE', NULL, NULL, NULL, NULL, NULL, 4),
(76461, NULL, 'G3DSA:3.30.230.10:FF:000419', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76462, NULL, 'G3DSA:1.50.10.130:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(76463, NULL, 'G3DSA:3.30.160.60:FF:004599', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76464, NULL, 'G3DSA:3.90.190.20:FF:000057', NULL, NULL, 'Mur ligase', NULL, NULL, NULL, NULL, NULL, 4),
(76465, NULL, 'G3DSA:3.30.70.60:FF:000017', NULL, NULL, '30S ribosomal protein S6', NULL, NULL, NULL, NULL, NULL, 4),
(76466, NULL, 'G3DSA:3.80.10.10:FF:002436', NULL, NULL, 'F-box/LRR-repeat protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(76467, NULL, 'G3DSA:3.30.70.330:FF:002732', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76468, NULL, 'G3DSA:2.30.30.100:FF:000203', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(76469, NULL, 'G3DSA:3.40.50.150:FF:001429', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76470, NULL, 'G3DSA:3.50.4.10:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76471, NULL, 'G3DSA:3.40.50.720:FF:000662', NULL, NULL, 'GDP-mannose 3'',5''-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(76472, NULL, 'G3DSA:1.25.40.10:FF:005026', NULL, NULL, 'AGAP000136-PA', NULL, NULL, NULL, NULL, NULL, 4),
(76473, NULL, 'G3DSA:3.30.365.10:FF:000007', NULL, NULL, 'Carbon monoxide dehydrogenase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(76474, NULL, 'G3DSA:1.20.120.1380:FF:000006', NULL, NULL, 'Flagellar biosynthesis protein FlhF (Flagella-associated GTP-binding protein)', NULL, NULL, NULL, NULL, NULL, 4),
(76475, NULL, 'G3DSA:1.10.390.10:FF:000022', NULL, NULL, 'Transcription initiation factor TFIID subunit', NULL, NULL, NULL, NULL, NULL, 4),
(76476, NULL, 'G3DSA:3.40.50.11660:FF:000002', NULL, NULL, 'Alpha-(1,3)-fucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(76477, NULL, 'G3DSA:3.30.160.60:FF:001373', NULL, NULL, 'Zinc finger protein 135', NULL, NULL, NULL, NULL, NULL, 4),
(76478, NULL, 'G3DSA:2.40.50.140:FF:000503', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(76479, NULL, 'G3DSA:2.30.29.30:FF:000056', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(76480, NULL, 'G3DSA:3.90.190.10:FF:000054', NULL, NULL, 'laforin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(76481, NULL, 'G3DSA:3.40.1690.20:FF:000010', NULL, NULL, 'AFG3-like protein spg-7', NULL, NULL, NULL, NULL, NULL, 4),
(76482, NULL, 'G3DSA:1.20.5.170:FF:000020', NULL, NULL, 'BZIP transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(76483, NULL, 'G3DSA:1.20.5.1300:FF:000014', NULL, NULL, 'Histidinol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(76484, NULL, 'G3DSA:2.60.40.10:FF:000788', NULL, NULL, 'Cell adhesion molecule-related/down-regulated by oncogenes', NULL, NULL, NULL, NULL, NULL, 4),
(76485, NULL, 'G3DSA:1.10.1040.10:FF:000040', NULL, NULL, '6-phosphogluconate dehydrogenase, decarboxylating', NULL, NULL, NULL, NULL, NULL, 4),
(76486, NULL, 'G3DSA:2.170.300.10:FF:000008', NULL, NULL, 'Laminin subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(76487, NULL, 'G3DSA:3.90.1150.10:FF:000365', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76488, NULL, 'G3DSA:1.20.940.10:FF:000023', NULL, NULL, 'Protein transport protein Sec31A', NULL, NULL, NULL, NULL, NULL, 4),
(76489, NULL, 'G3DSA:2.60.120.260:FF:000536', NULL, NULL, 'Netrin 4', NULL, NULL, NULL, NULL, NULL, 4),
(76490, NULL, 'G3DSA:2.60.40.650:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76491, NULL, 'G3DSA:2.60.210.10:FF:000067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76492, NULL, 'G3DSA:3.40.50.620:FF:000632', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(76493, NULL, 'G3DSA:2.40.420.20:FF:000040', NULL, NULL, 'Multidrug efflux RND transporter periplasmic adaptor subunit MexX', NULL, NULL, NULL, NULL, NULL, 4),
(76494, NULL, 'G3DSA:2.60.40.1930:FF:000014', NULL, NULL, 'Alpha-2-macroglobulin', NULL, NULL, NULL, NULL, NULL, 4),
(76495, NULL, 'G3DSA:2.40.50.120:FF:000025', NULL, NULL, 'Netrin unc-6', NULL, NULL, NULL, NULL, NULL, 4),
(76496, NULL, 'G3DSA:1.20.58.2010:FF:000008', NULL, NULL, 'Rop guanine nucleotide exchange factor 9', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(76497, NULL, 'G3DSA:3.40.50.1820:FF:000193', NULL, NULL, 'Ab-hydrolase associated lipase', NULL, NULL, NULL, NULL, NULL, 4),
(76498, NULL, 'G3DSA:3.40.50.300:FF:001256', NULL, NULL, 'Pentafunctional AROM polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(76499, NULL, 'G3DSA:1.50.10.10:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76500, NULL, 'G3DSA:3.40.50.300:FF:007242', NULL, NULL, 'DNA topology modulation kinase FlaR, putative', NULL, NULL, NULL, NULL, NULL, 4),
(76501, NULL, 'G3DSA:3.40.50.1820:FF:000513', NULL, NULL, 'Palmitoyl protein thioesterase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(76502, NULL, 'G3DSA:3.30.870.10:FF:000069', NULL, NULL, 'Cardiolipin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(76503, NULL, 'G3DSA:1.10.3380.20:FF:000001', NULL, NULL, 'DNA polymerase theta', NULL, NULL, NULL, NULL, NULL, 4),
(76504, NULL, 'G3DSA:1.25.40.10:FF:000973', NULL, NULL, 'Anaphase-promoting complex subunit 3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(76505, NULL, 'G3DSA:2.30.40.10:FF:000060', NULL, NULL, 'Cytosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(76506, NULL, 'G3DSA:1.20.1250.20:FF:001883', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76507, NULL, 'G3DSA:2.130.10.10:FF:003346', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76508, NULL, 'G3DSA:3.40.50.1400:FF:000005', NULL, NULL, 'Ferrochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(76509, NULL, 'G3DSA:3.40.50.620:FF:000132', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(76510, NULL, 'G3DSA:2.30.29.30:FF:000117', NULL, NULL, 'ras-specific guanine nucleotide-releasing factor 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(76511, NULL, 'G3DSA:3.30.70.2510:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76512, NULL, 'G3DSA:3.30.70.330:FF:002086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76513, NULL, 'G3DSA:2.60.40.10:FF:002879', NULL, NULL, 'Dorsal-related immunity factor, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(76514, NULL, 'G3DSA:3.40.50.150:FF:001222', NULL, NULL, 'Methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(76515, NULL, 'G3DSA:3.80.10.10:FF:004061', NULL, NULL, 'AGAP005961-PA', NULL, NULL, NULL, NULL, NULL, 4),
(76516, NULL, 'G3DSA:1.20.1050.10:FF:000145', NULL, NULL, 'Amino acyl-tRNA synthetase complex component, putative', NULL, NULL, NULL, NULL, NULL, 4),
(76517, NULL, 'G3DSA:2.40.50.40:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76518, NULL, 'G3DSA:3.30.40.10:FF:000580', NULL, NULL, 'DNA repair protein RAD5', NULL, NULL, NULL, NULL, NULL, 4),
(76519, NULL, 'G3DSA:1.10.3380.30:FF:000004', NULL, NULL, 'Superkiller viralicidic activity 2-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(76520, NULL, 'G3DSA:3.60.10.10:FF:000155', NULL, NULL, 'DNA-(apurinic or apyrimidinic site) lyase', NULL, NULL, NULL, NULL, NULL, 4),
(76521, NULL, 'G3DSA:2.60.120.10:FF:000122', NULL, NULL, 'Neuropathy target esterase sws', NULL, NULL, NULL, NULL, NULL, 4),
(76522, NULL, 'G3DSA:3.40.50.10190:FF:000112', NULL, NULL, 'DNA polymerase II complex', NULL, NULL, NULL, NULL, NULL, 4),
(76523, NULL, 'G3DSA:3.30.200.20:FF:000393', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(76524, NULL, 'G3DSA:3.90.1070.10:FF:000005', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(76525, NULL, 'G3DSA:3.40.50.1820:FF:001295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76526, NULL, 'G3DSA:2.130.10.10:FF:000766', NULL, NULL, 'Cleavage and polyadenylation specificity factor cpsf', NULL, NULL, NULL, NULL, NULL, 4),
(76527, NULL, 'G3DSA:2.60.40.790:FF:000096', NULL, NULL, 'Heat shock protein 20', NULL, NULL, NULL, NULL, NULL, 4),
(76528, NULL, 'G3DSA:3.40.50.300:FF:001935', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NBP35', NULL, NULL, NULL, NULL, NULL, 4),
(76529, NULL, 'G3DSA:2.60.40.60:FF:000663', NULL, NULL, 'Cadherin 17', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(76530, NULL, 'G3DSA:3.80.10.10:FF:000345', NULL, NULL, 'PH domain and leucine rich repeat protein phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(76531, NULL, 'G3DSA:1.10.8.60:FF:000361', NULL, NULL, 'Proteasome-activating nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(76532, NULL, 'G3DSA:3.30.2290.10:FF:000024', NULL, NULL, 'Zinc-dependent protease, TldD/PmbA family', NULL, NULL, NULL, NULL, NULL, 4),
(76533, NULL, 'G3DSA:2.70.170.10:FF:000308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76534, NULL, 'G3DSA:2.10.25.10:FF:001464', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76535, NULL, 'G3DSA:1.20.1070.10:FF:001989', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76536, NULL, 'G3DSA:3.30.1370.10:FF:000058', NULL, NULL, 'poly(RC)-binding protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(76537, NULL, 'G3DSA:1.20.58.60:FF:000735', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(76538, NULL, 'G3DSA:3.40.1280.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76539, NULL, 'G3DSA:1.10.405.20:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76540, NULL, 'G3DSA:2.60.40.1210:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76541, NULL, 'G3DSA:3.30.160.60:FF:004919', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76542, NULL, 'G3DSA:2.10.70.10:FF:000051', NULL, NULL, 'von Willebrand factor C and EGF domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(76543, NULL, 'G3DSA:3.30.200.20:FF:002484', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76544, NULL, 'G3DSA:3.90.650.10:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76545, NULL, 'G3DSA:3.30.420.60:FF:000011', NULL, NULL, 'Eukaryotic polypeptide chain release factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(76546, NULL, 'G3DSA:2.130.10.10:FF:002857', NULL, NULL, 'Pre-mRNA-processing factor 19', NULL, NULL, NULL, NULL, NULL, 4),
(76547, NULL, 'G3DSA:1.10.10.60:FF:000694', NULL, NULL, 'Transcription factor MYB10', NULL, NULL, NULL, NULL, NULL, 4),
(76548, NULL, 'G3DSA:3.40.50.2300:FF:000264', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(76549, NULL, 'G3DSA:2.60.40.10:FF:005313', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76550, NULL, 'G3DSA:3.30.420.10:FF:000075', NULL, NULL, 'Transposase, IS30 family', NULL, NULL, NULL, NULL, NULL, 4),
(76551, NULL, 'G3DSA:3.30.559.10:FF:000014', NULL, NULL, 'Tryptamine hydroxycinnamoyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(76552, NULL, 'G3DSA:2.170.8.10:FF:000012', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(76553, NULL, 'G3DSA:3.40.50.11500:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76554, NULL, 'G3DSA:3.30.450.20:FF:000259', NULL, NULL, 'Phytochrome-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(76555, NULL, 'G3DSA:1.20.58.60:FF:000056', NULL, NULL, 'utrophin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(76556, NULL, 'G3DSA:3.30.420.40:FF:000617', NULL, NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(76557, NULL, 'G3DSA:3.40.50.1440:FF:000169', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(76558, NULL, 'G3DSA:3.40.50.10140:FF:000030', NULL, NULL, 'Toll-like receptor 5b', NULL, NULL, NULL, NULL, NULL, 4),
(76559, NULL, 'G3DSA:1.20.910.10:FF:000021', NULL, NULL, 'Biliverdin-producing heme oxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(76560, NULL, 'G3DSA:3.30.70.330:FF:000495', NULL, NULL, 'Putative G-patch DNA repair protein (Drt111)', NULL, NULL, NULL, NULL, NULL, 4),
(76561, NULL, 'G3DSA:1.25.40.10:FF:004981', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76562, NULL, 'G3DSA:3.30.200.20:FF:001410', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76563, NULL, 'G3DSA:1.10.287.70:FF:000316', NULL, NULL, 'FI03418p', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(76564, NULL, 'G3DSA:2.40.50.140:FF:000357', NULL, NULL, 'Primosomal replication protein N', NULL, NULL, NULL, NULL, NULL, 4),
(76565, NULL, 'G3DSA:2.10.25.10:FF:000362', NULL, NULL, 'Pro-epidermal growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(76566, NULL, 'G3DSA:2.40.50.140:FF:000649', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76567, NULL, 'G3DSA:3.30.160.60:FF:004892', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76568, NULL, 'G3DSA:3.40.50.300:FF:000300', NULL, NULL, 'Transcription-repair-coupling factor', NULL, NULL, NULL, NULL, NULL, 4),
(76569, NULL, 'G3DSA:3.30.70.330:FF:000787', NULL, NULL, 'Serine/arginine-rich splicing factor 8', NULL, NULL, NULL, NULL, NULL, 4),
(76570, NULL, 'G3DSA:1.10.10.60:FF:000755', NULL, NULL, 'Transcription factor MYB36', NULL, NULL, NULL, NULL, NULL, 4),
(76571, NULL, 'G3DSA:3.40.50.410:FF:000215', NULL, NULL, 'Collagen, type VI, alpha 4a', NULL, NULL, NULL, NULL, NULL, 4),
(76572, NULL, 'G3DSA:2.60.40.10:FF:005252', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76573, NULL, 'G3DSA:2.120.10.80:FF:000349', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(76574, NULL, 'G3DSA:3.40.50.2000:FF:000264', NULL, NULL, 'Lipopolysaccharide heptosyltransferase II', NULL, NULL, NULL, NULL, NULL, 4),
(76575, NULL, 'G3DSA:3.30.200.20:FF:002158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76576, NULL, 'G3DSA:3.30.160.20:FF:000220', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(76577, NULL, 'G3DSA:3.40.50.300:FF:001582', NULL, NULL, 'GTP-binding protein BRASSINAZOLE INSENSITIVE PALE GREEN 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(76578, NULL, 'G3DSA:3.10.50.10:FF:000036', NULL, NULL, 'Chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(76579, NULL, 'G3DSA:3.30.160.60:FF:003610', NULL, NULL, 'Zinc finger protein 277', NULL, NULL, NULL, NULL, NULL, 4),
(76580, NULL, 'G3DSA:2.30.30.100:FF:000175', NULL, NULL, 'Small nuclear ribonucleoprotein E', NULL, NULL, NULL, NULL, NULL, 4),
(76581, NULL, 'G3DSA:3.80.10.10:FF:003925', NULL, NULL, 'AGAP012123-PA', NULL, NULL, NULL, NULL, NULL, 4),
(76582, NULL, 'G3DSA:3.30.70.1230:FF:000030', NULL, NULL, 'Si:ch211-215j19.12', NULL, NULL, NULL, NULL, NULL, 4),
(76583, NULL, 'G3DSA:1.20.58.60:FF:000382', NULL, NULL, 'Nesprin-1', NULL, NULL, NULL, NULL, NULL, 4),
(76584, NULL, 'G3DSA:3.30.420.10:FF:000103', NULL, NULL, 'piRNA biogenesis protein EXD1', NULL, NULL, NULL, NULL, NULL, 4),
(76585, NULL, 'G3DSA:2.40.50.90:FF:000134', NULL, NULL, 'Transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(76586, NULL, 'G3DSA:1.10.8.1220:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76587, NULL, 'G3DSA:1.10.4020.10:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76588, NULL, 'G3DSA:2.10.25.10:FF:000654', NULL, NULL, 'Neurexin 1, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(76589, NULL, 'G3DSA:3.40.50.300:FF:005325', NULL, NULL, 'tRNA threonylcarbamoyladenosine biosynthesis protein TsaE', NULL, NULL, NULL, NULL, NULL, 4),
(76590, NULL, 'G3DSA:3.40.1800.20:FF:000008', NULL, NULL, 'AGAP003961-PA', NULL, NULL, NULL, NULL, NULL, 4),
(76591, NULL, 'G3DSA:3.30.70.330:FF:001597', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76592, NULL, 'G3DSA:2.30.29.30:FF:000443', NULL, NULL, 'Sprouty related EVH1 domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(76593, NULL, 'G3DSA:3.40.50.1110:FF:000160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76594, NULL, 'G3DSA:3.40.710.10:FF:000005', NULL, NULL, 'Glutaminase', NULL, NULL, NULL, NULL, NULL, 4),
(76595, NULL, 'G3DSA:3.30.720.50:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76596, NULL, 'G3DSA:1.25.50.20:FF:000010', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(76597, NULL, 'G3DSA:1.25.10.10:FF:001281', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(76598, NULL, 'G3DSA:2.40.30.10:FF:000446', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(76599, NULL, 'G3DSA:1.10.630.10:FF:000530', NULL, NULL, 'Putative cytochrome P450 superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(76600, NULL, 'G3DSA:3.40.50.620:FF:000278', NULL, NULL, '(6-4)DNA photolyase', NULL, NULL, NULL, NULL, NULL, 4),
(76601, NULL, 'G3DSA:3.30.50.10:FF:000198', NULL, NULL, 'Putative GATA transcription factor family protein', NULL, NULL, NULL, NULL, NULL, 4),
(76602, NULL, 'G3DSA:3.40.140.10:FF:000068', NULL, NULL, 'tRNA-specific adenosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(76603, NULL, 'G3DSA:1.20.1070.10:FF:001782', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76604, NULL, 'G3DSA:1.20.120.1080:FF:000006', NULL, NULL, 'ATP-dependent RNA helicase A protein', NULL, NULL, NULL, NULL, NULL, 4),
(76605, NULL, 'G3DSA:2.60.40.60:FF:000955', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(76606, NULL, 'G3DSA:1.10.3210.10:FF:000099', NULL, NULL, 'GTP diphosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(76607, NULL, 'G3DSA:3.30.9.10:FF:000136', NULL, NULL, 'Lethal (2) 37Bb', NULL, NULL, NULL, NULL, NULL, 4),
(76608, NULL, 'G3DSA:1.10.287.130:FF:000161', NULL, NULL, 'Histidine kinase A domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(76609, NULL, 'G3DSA:2.30.180.10:FF:000020', NULL, NULL, 'Stabilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(76610, NULL, 'G3DSA:2.60.120.590:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76611, NULL, 'G3DSA:1.10.600.10:FF:000056', NULL, NULL, 'Putative phytoene synthase', NULL, NULL, NULL, NULL, NULL, 4),
(76612, NULL, 'G3DSA:2.60.120.290:FF:000112', NULL, NULL, 'AGAP011912-PA', NULL, NULL, NULL, NULL, NULL, 4),
(76613, NULL, 'G3DSA:1.10.1520.10:FF:000116', NULL, NULL, 'Ribonuclease III, putative', NULL, NULL, NULL, NULL, NULL, 4),
(76614, NULL, 'G3DSA:3.30.70.330:FF:001012', NULL, NULL, 'RNA splicing factor (Pad-1)', NULL, NULL, NULL, NULL, NULL, 4),
(76615, NULL, 'G3DSA:3.30.160.60:FF:003464', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76616, NULL, 'G3DSA:3.30.200.20:FF:000893', NULL, NULL, 'Choline kinase', NULL, NULL, NULL, NULL, NULL, 4),
(76617, NULL, 'G3DSA:3.40.47.10:FF:000151', NULL, NULL, 'Beta-ketoacyl synthase PigJ', NULL, NULL, NULL, NULL, NULL, 4),
(76618, NULL, 'G3DSA:2.40.10.190:FF:000010', NULL, NULL, 'Selenocysteine-specific elongation factor', NULL, NULL, NULL, NULL, NULL, 4),
(76619, NULL, 'G3DSA:3.75.10.10:FF:000009', NULL, NULL, 'Eukaryotic translation initiation factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(76620, NULL, 'G3DSA:3.30.230.10:FF:000392', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76621, NULL, 'G3DSA:3.90.180.10:FF:000109', NULL, NULL, 'Acryloyl-coenzyme A reductase', NULL, NULL, NULL, NULL, NULL, 4),
(76622, NULL, 'G3DSA:1.10.1740.140:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76623, NULL, 'G3DSA:3.30.910.20:FF:000014', NULL, NULL, 'Outer membrane chaperone Skp (OmpH)', NULL, NULL, NULL, NULL, NULL, 4),
(76624, NULL, 'G3DSA:4.10.40.20:FF:000002', NULL, NULL, 'Endothelial cell-specific molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(76625, NULL, 'G3DSA:3.90.25.10:FF:000019', NULL, NULL, 'UDP-glucose 4-epimerase galE1', NULL, NULL, NULL, NULL, NULL, 4),
(76626, NULL, 'G3DSA:1.25.40.10:FF:000647', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g33990', NULL, NULL, NULL, NULL, NULL, 4),
(76627, NULL, 'G3DSA:3.40.50.1220:FF:000075', NULL, NULL, 'Related to NAD-dependent histone deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(76628, NULL, 'G3DSA:3.30.70.1050:FF:000009', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(76629, NULL, 'G3DSA:1.25.40.10:FF:003109', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(76630, NULL, 'G3DSA:3.40.190.10:FF:000751', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(76631, NULL, 'G3DSA:3.30.479.20:FF:000050', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(76632, NULL, 'G3DSA:2.60.200.30:FF:000016', NULL, NULL, 'Inorganic polyphosphate/ATP-NAD kinase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(76633, NULL, 'G3DSA:1.20.1070.10:FF:000062', NULL, NULL, 'Neuropeptide Y receptor type 1', NULL, NULL, NULL, NULL, NULL, 4),
(76634, NULL, 'G3DSA:1.10.8.10:FF:000161', NULL, NULL, 'AGAP004245-PA', NULL, NULL, NULL, NULL, NULL, 4),
(76635, NULL, 'G3DSA:3.40.50.2300:FF:000590', NULL, NULL, 'Sucrose operon repressor ScrR LacI family', NULL, NULL, NULL, NULL, NULL, 4),
(76636, NULL, 'G3DSA:3.30.70.370:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76637, NULL, 'G3DSA:3.30.420.40:FF:000590', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76638, NULL, 'G3DSA:3.40.50.300:FF:004662', NULL, NULL, 'Pentamidine resistance protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(76639, NULL, 'G3DSA:2.40.30.110:FF:000007', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(76640, NULL, 'G3DSA:2.60.40.420:FF:000210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76641, NULL, 'G3DSA:3.30.420.40:FF:000882', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(76642, NULL, 'G3DSA:1.25.40.180:FF:000047', NULL, NULL, 'Nonsense-mediated mRNA decay factor (Upf2)', NULL, NULL, NULL, NULL, NULL, 4),
(76643, NULL, 'G3DSA:1.20.1070.10:FF:000680', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(76644, NULL, 'G3DSA:3.20.19.10:FF:000002', NULL, NULL, 'Aconitate hydratase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(76645, NULL, 'G3DSA:3.40.309.10:FF:000123', NULL, NULL, 'tRNA (Uracil-5-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(76646, NULL, 'G3DSA:2.60.120.650:FF:000237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76647, NULL, 'G3DSA:1.25.40.10:FF:004655', NULL, NULL, 'Anaphase-promoting complex subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(76648, NULL, 'G3DSA:3.40.50.300:FF:006786', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(76649, NULL, 'G3DSA:3.30.70.3370:FF:000003', NULL, NULL, 'Glutathione S-transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(76650, NULL, 'G3DSA:1.20.1250.20:FF:002254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76651, NULL, 'G3DSA:2.10.50.30:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76652, NULL, 'G3DSA:1.25.40.10:FF:004363', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76653, NULL, 'G3DSA:1.10.486.10:FF:000008', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(76654, NULL, 'G3DSA:3.30.40.10:FF:002171', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(76655, NULL, 'G3DSA:3.20.20.100:FF:000183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76656, NULL, 'G3DSA:3.40.50.300:FF:002863', NULL, NULL, 'Pre-mRNA-splicing factor cwf11', NULL, NULL, NULL, NULL, NULL, 4),
(76657, NULL, 'G3DSA:2.60.200.40:FF:000019', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(76658, NULL, 'G3DSA:1.20.920.10:FF:000140', NULL, NULL, 'Predicted bromodomain protein', NULL, NULL, NULL, NULL, NULL, 4),
(76659, NULL, 'G3DSA:3.30.70.1450:FF:000039', NULL, NULL, 'Probable sodium/sulfate cotransporter 3', NULL, NULL, NULL, NULL, NULL, 4),
(76660, NULL, 'G3DSA:3.40.50.300:FF:001435', NULL, NULL, 'NACHT, LRR and PYD domains-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(76661, NULL, 'G3DSA:1.10.20.140:FF:000007', NULL, NULL, 'tRNA dimethylallyltransferase 9', NULL, NULL, NULL, NULL, NULL, 4),
(76662, NULL, 'G3DSA:1.20.120.1780:FF:000003', NULL, NULL, '4-hydroxybenzoate polyprenyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(76663, NULL, 'G3DSA:1.25.10.10:FF:000999', NULL, NULL, 'Sister chromatid cohesion protein', NULL, NULL, NULL, NULL, NULL, 4),
(76664, NULL, 'G3DSA:3.40.50.2000:FF:000910', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(76665, NULL, 'G3DSA:3.40.366.10:FF:000007', NULL, NULL, 'Fatty acid synthase beta subunit dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(76666, NULL, 'G3DSA:3.30.420.280:FF:000003', NULL, NULL, 'Terminase, large subunit gp2', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(76667, NULL, 'G3DSA:3.30.70.260:FF:000007', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(76668, NULL, 'G3DSA:3.30.160.60:FF:001665', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76669, NULL, 'G3DSA:3.30.710.10:FF:000176', NULL, NULL, 'Protein CBG09661', NULL, NULL, NULL, NULL, NULL, 4),
(76670, NULL, 'G3DSA:3.90.190.10:FF:000346', NULL, NULL, 'Protein-tyrosine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(76671, NULL, 'G3DSA:3.30.40.10:FF:000607', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(76672, NULL, 'G3DSA:3.40.250.10:FF:000104', NULL, NULL, 'Rodhanase family domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(76673, NULL, 'G3DSA:2.10.25.10:FF:000036', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(76674, NULL, 'G3DSA:2.20.100.10:FF:000091', NULL, NULL, 'Somatomedin B and thrombospondin type 1 domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(76675, NULL, 'G3DSA:3.30.70.330:FF:000169', NULL, NULL, 'protein alan shepard isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(76676, NULL, 'G3DSA:3.30.160.60:FF:005055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76677, NULL, 'G3DSA:1.10.472.80:FF:000132', NULL, NULL, 'SD08625p', NULL, NULL, NULL, NULL, NULL, 4),
(76678, NULL, 'G3DSA:3.50.50.80:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76679, NULL, 'G3DSA:3.60.110.10:FF:000084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76680, NULL, 'G3DSA:2.60.220.50:FF:000057', NULL, NULL, 'Adhesion G protein-coupled receptor D1', NULL, NULL, NULL, NULL, NULL, 4),
(76681, NULL, 'G3DSA:3.30.460.10:FF:000021', NULL, NULL, 'DNA polymerase beta', NULL, NULL, NULL, NULL, NULL, 4),
(76682, NULL, 'G3DSA:3.30.70.660:FF:000004', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(76683, NULL, 'G3DSA:3.80.10.10:FF:002262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76684, NULL, 'G3DSA:2.60.40.1180:FF:000188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76685, NULL, 'G3DSA:1.10.10.1760:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76686, NULL, 'G3DSA:3.40.30.10:FF:001276', NULL, NULL, 'Protein disulfide isomerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(76687, NULL, 'G3DSA:3.40.390.10:FF:000086', NULL, NULL, 'Disintegrin and metalloproteinase domain-containing protein unc-71', NULL, NULL, NULL, NULL, NULL, 4),
(76688, NULL, 'G3DSA:1.20.1310.10:FF:000098', NULL, NULL, 'Ubiquitin ligase subunit CulD', NULL, NULL, NULL, NULL, NULL, 4),
(76689, NULL, 'G3DSA:1.10.565.10:FF:000170', NULL, NULL, 'Nuclear receptor subfamily 2, group E, member 3', NULL, NULL, NULL, NULL, NULL, 4),
(76690, NULL, 'G3DSA:3.30.70.330:FF:002440', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76691, NULL, 'G3DSA:1.10.630.10:FF:000119', NULL, NULL, 'Alkane hydroxylase MAH1', NULL, NULL, NULL, NULL, NULL, 4),
(76692, NULL, 'G3DSA:3.30.40.10:FF:001889', NULL, NULL, 'Putative RING zinc finger domain superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(76693, NULL, 'G3DSA:1.20.1070.10:FF:000354', NULL, NULL, '5-hydroxytryptamine receptor 1A', NULL, NULL, NULL, NULL, NULL, 4),
(76694, NULL, 'G3DSA:1.10.510.10:FF:003337', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76695, NULL, 'G3DSA:2.60.200.20:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76696, NULL, 'G3DSA:3.30.70.270:FF:000336', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76697, NULL, 'G3DSA:1.20.58.60:FF:000409', NULL, NULL, 'SPeCtrin', NULL, NULL, NULL, NULL, NULL, 4),
(76698, NULL, 'G3DSA:3.40.50.1820:FF:000367', NULL, NULL, 'Probable oxidoreductase EphD', NULL, NULL, NULL, NULL, NULL, 4),
(76699, NULL, 'G3DSA:3.40.50.720:FF:001797', NULL, NULL, 'NmrA-like family domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(76700, NULL, 'G3DSA:2.60.120.260:FF:000362', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(76701, NULL, 'G3DSA:3.90.70.10:FF:000652', NULL, NULL, 'Ubiquitin carboxylterminal hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(76702, NULL, 'G3DSA:3.30.230.10:FF:000066', NULL, NULL, 'Putative ATP-dependent protease', NULL, NULL, NULL, NULL, NULL, 4),
(76703, NULL, 'G3DSA:1.20.1560.10:FF:000083', NULL, NULL, 'phosphatidylcholine translocator ABCB4 isoform X7', NULL, NULL, NULL, NULL, NULL, 4),
(76704, NULL, 'G3DSA:2.30.42.10:FF:000575', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76705, NULL, 'G3DSA:3.30.200.20:FF:000567', NULL, NULL, 'Serine/threonine-protein kinase MARK2', NULL, NULL, NULL, NULL, NULL, 4),
(76706, NULL, 'G3DSA:3.80.10.10:FF:000671', NULL, NULL, 'Receptor-like protein kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(76707, NULL, 'G3DSA:3.40.50.1370:FF:000041', NULL, NULL, 'Aspartate carbamoyltransferase, catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(76708, NULL, 'G3DSA:1.10.532.10:FF:000010', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(76709, NULL, 'G3DSA:1.25.40.570:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76710, NULL, 'G3DSA:3.40.50.2300:FF:000438', NULL, NULL, 'Putative sugar ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(76711, NULL, 'G3DSA:3.30.710.10:FF:000029', NULL, NULL, 'potassium voltage-gated channel subfamily S member 2', NULL, NULL, NULL, NULL, NULL, 4),
(76712, NULL, 'G3DSA:3.40.50.300:FF:003173', NULL, NULL, 'Quinate repressor protein', NULL, NULL, NULL, NULL, NULL, 4),
(76713, NULL, 'G3DSA:2.130.10.10:FF:001222', NULL, NULL, 'Transducin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(76714, NULL, 'G3DSA:1.25.40.10:FF:003261', NULL, NULL, 'Uncharacterized protein CaJ7.0066', NULL, NULL, NULL, NULL, NULL, 4),
(76715, NULL, 'G3DSA:3.40.50.150:FF:001076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76716, NULL, 'G3DSA:1.25.40.90:FF:000098', NULL, NULL, 'CMGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(76717, NULL, 'G3DSA:3.40.50.300:FF:002071', NULL, NULL, 'Ras family GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(76718, NULL, 'G3DSA:3.80.10.10:FF:001773', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76719, NULL, 'G3DSA:2.10.25.10:FF:001756', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76720, NULL, 'G3DSA:3.10.110.10:FF:000163', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(76721, NULL, 'G3DSA:2.60.410.10:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76722, NULL, 'G3DSA:3.40.50.10810:FF:000219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76723, NULL, 'G3DSA:3.60.10.10:FF:000301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76724, NULL, 'G3DSA:2.170.40.20:FF:000005', NULL, NULL, 'Envelope glycoprotein gp160', NULL, NULL, NULL, NULL, NULL, 4),
(76725, NULL, 'G3DSA:3.80.10.10:FF:004235', NULL, NULL, 'F-box/TPR repeat protein pof3', NULL, NULL, NULL, NULL, NULL, 4),
(76726, NULL, 'G3DSA:1.20.1050.10:FF:000319', NULL, NULL, 'Eukaryotic translation elongation factor 1 gamma', NULL, NULL, NULL, NULL, NULL, 4),
(76727, NULL, 'G3DSA:3.90.660.10:FF:000045', NULL, NULL, 'lysine-specific histone demethylase 1A', NULL, NULL, NULL, NULL, NULL, 4),
(76728, NULL, 'G3DSA:3.30.160.60:FF:003790', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76729, NULL, 'G3DSA:3.30.460.20:FF:000024', NULL, NULL, 'Magnesium and cobalt transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(76730, NULL, 'G3DSA:1.10.8.270:FF:000193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76731, NULL, 'G3DSA:3.80.10.10:FF:000053', NULL, NULL, 'Leucine-rich repeat-containing 8 VRAC subunit Ab', NULL, NULL, NULL, NULL, NULL, 4),
(76732, NULL, 'G3DSA:1.10.10.10:FF:001336', NULL, NULL, 'Epithelium specific ets factor 3, ese3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(76733, NULL, 'G3DSA:3.90.180.10:FF:000082', NULL, NULL, 'Reticulon-4-interacting protein 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(76734, NULL, 'G3DSA:1.25.40.10:FF:002772', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76735, NULL, 'G3DSA:3.40.1190.20:FF:000163', NULL, NULL, 'Carbohydrate kinase PfkB family', NULL, NULL, NULL, NULL, NULL, 4),
(76736, NULL, 'G3DSA:3.30.70.330:FF:001889', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76737, NULL, 'G3DSA:3.40.30.10:FF:000966', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(76738, NULL, 'G3DSA:3.30.1490.10:FF:000005', NULL, NULL, 'Mitochondrial 40S ribosomal protein S8', NULL, NULL, NULL, NULL, NULL, 4),
(76739, NULL, 'G3DSA:3.40.50.720:FF:000336', NULL, NULL, 'Aldehyde reductase', NULL, NULL, NULL, NULL, NULL, 4),
(76740, NULL, 'G3DSA:1.25.10.10:FF:000819', NULL, NULL, 'Inscuteable', NULL, NULL, NULL, NULL, NULL, 4),
(76741, NULL, 'G3DSA:2.40.10.10:FF:000563', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76742, NULL, 'G3DSA:3.90.640.10:FF:000162', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(76743, NULL, 'G3DSA:3.30.1520.10:FF:000060', NULL, NULL, 'Phox (PX) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(76744, NULL, 'G3DSA:2.130.10.10:FF:001429', NULL, NULL, 'Similar to DUF1339 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(76745, NULL, 'G3DSA:2.80.10.50:FF:000230', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(76746, NULL, 'G3DSA:2.60.40.720:FF:000002', NULL, NULL, 'Cellular tumor antigen p53', NULL, NULL, NULL, NULL, NULL, 4),
(76747, NULL, 'G3DSA:3.30.565.10:FF:000309', NULL, NULL, 'PMS1 homolog 1, mismatch repair system component', NULL, NULL, NULL, NULL, NULL, 4),
(76748, NULL, 'G3DSA:1.10.357.140:FF:000034', NULL, NULL, 'UbiA prenyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(76749, NULL, 'G3DSA:3.30.200.20:FF:001056', NULL, NULL, 'CAMKK/ELM protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(76750, NULL, 'G3DSA:2.60.120.330:FF:000113', NULL, NULL, '2-oxoglutarate (2OG) and Fe(II)-dependent oxygenase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(76751, NULL, 'G3DSA:3.60.20.10:FF:000127', NULL, NULL, 'Glutamine amidotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(76752, NULL, 'G3DSA:3.30.1490.20:FF:000008', NULL, NULL, 'Synapsin I', NULL, NULL, NULL, NULL, NULL, 4),
(76753, NULL, 'G3DSA:1.10.10.10:FF:000847', NULL, NULL, 'Regulatory protein RecX', NULL, NULL, NULL, NULL, NULL, 4),
(76754, NULL, 'G3DSA:2.60.120.290:FF:000051', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(76755, NULL, 'G3DSA:3.30.420.580:FF:000003', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(76756, NULL, 'G3DSA:3.30.160.60:FF:001401', NULL, NULL, 'zinc finger protein 527 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(76757, NULL, 'G3DSA:2.60.40.10:FF:003514', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76758, NULL, 'G3DSA:3.40.50.300:FF:003352', NULL, NULL, 'HELicase Q homolog', NULL, NULL, NULL, NULL, NULL, 4),
(76759, NULL, 'G3DSA:2.70.40.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76760, NULL, 'G3DSA:1.25.40.10:FF:002238', NULL, NULL, 'Auxilin-like clathrin uncoating factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(76761, NULL, 'G3DSA:1.10.12.70:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76762, NULL, 'G3DSA:3.30.470.20:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76763, NULL, 'G3DSA:1.20.1250.20:FF:000337', NULL, NULL, 'Solute carrier family 16 member 5', NULL, NULL, NULL, NULL, NULL, 4),
(76764, NULL, 'G3DSA:1.10.630.10:FF:000412', NULL, NULL, 'Cytochrome P450 52E2', NULL, NULL, NULL, NULL, NULL, 4),
(76765, NULL, 'G3DSA:1.10.238.10:FF:001321', NULL, NULL, 'Mitochondrial Rho GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(76766, NULL, 'G3DSA:2.10.25.10:FF:000536', NULL, NULL, 'von Willebrand factor D and EGF domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(76767, NULL, 'G3DSA:2.90.10.10:FF:000038', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(76768, NULL, 'G3DSA:1.25.10.10:FF:001163', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(76769, NULL, 'G3DSA:2.30.29.30:FF:000090', NULL, NULL, 'RAS p21 protein activator 1', NULL, NULL, NULL, NULL, NULL, 4),
(76770, NULL, 'G3DSA:3.80.10.10:FF:002470', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76771, NULL, 'G3DSA:3.90.79.10:FF:000172', NULL, NULL, 'Nucleoside diphosphate-linked moiety X motif 6', NULL, NULL, NULL, NULL, NULL, 4),
(76772, NULL, 'G3DSA:3.30.160.60:FF:001339', NULL, NULL, 'Zinc finger protein 232', NULL, NULL, NULL, NULL, NULL, 4),
(76773, NULL, 'G3DSA:3.30.70.330:FF:000669', NULL, NULL, 'U2 snRNP auxiliary factor large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(76774, NULL, 'G3DSA:2.130.10.10:FF:005145', NULL, NULL, 'Vacuolar protein sorting-associated protein 41 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(76775, NULL, 'G3DSA:3.10.180.20:FF:000001', NULL, NULL, 'alpha-1,3-mannosyl-glycoprotein 2-beta-N-acetylglucosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(76776, NULL, 'G3DSA:1.10.10.10:FF:001044', NULL, NULL, 'ELL complex EAP30 subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(76777, NULL, 'G3DSA:3.30.420.40:FF:000589', NULL, NULL, 'Actin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(76778, NULL, 'G3DSA:3.30.360.20:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76779, NULL, 'G3DSA:3.40.850.10:FF:000279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76780, NULL, 'G3DSA:2.160.10.30:FF:000001', NULL, NULL, 'UDP-sugar pyrophosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(76781, NULL, 'G3DSA:3.40.50.150:FF:001840', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76782, NULL, 'G3DSA:1.10.1020.10:FF:000005', NULL, NULL, 'Site-specific DNA-methyltransferase (adenine-specific)', NULL, NULL, NULL, NULL, NULL, 4),
(76783, NULL, 'G3DSA:3.50.7.10:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76784, NULL, 'G3DSA:1.10.441.10:FF:000012', NULL, NULL, 'Mannose-6-phosphate isomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(76785, NULL, 'G3DSA:2.20.25.240:FF:000012', NULL, NULL, 'AGAP004541-PA', NULL, NULL, NULL, NULL, NULL, 4),
(76786, NULL, 'G3DSA:3.30.160.60:FF:002975', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76787, NULL, 'G3DSA:3.30.1360.30:FF:000007', NULL, NULL, 'Aspartyl-tRNA synthetase, mitochondrial, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(76788, NULL, 'G3DSA:3.20.20.80:FF:000751', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76789, NULL, 'G3DSA:1.20.120.720:FF:000049', NULL, NULL, 'Heavy chain, Unconventional Myosin', NULL, NULL, NULL, NULL, NULL, 4),
(76790, NULL, 'G3DSA:3.20.20.80:FF:000280', NULL, NULL, 'Glycoside hydrolase family 5', NULL, NULL, NULL, NULL, NULL, 4),
(76791, NULL, 'G3DSA:2.60.120.200:FF:000804', NULL, NULL, 'Os03g0772700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(76792, NULL, 'G3DSA:3.30.70.2460:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76793, NULL, 'G3DSA:3.40.50.2000:FF:000146', NULL, NULL, 'Glycogen [starch] synthase', NULL, NULL, NULL, NULL, NULL, 4),
(76794, NULL, 'G3DSA:1.10.1040.10:FF:000006', NULL, NULL, '3-hydroxyisobutyrate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(76795, NULL, 'G3DSA:3.30.300.30:FF:000049', NULL, NULL, 'Bifunctional enzyme mbtA: salicyl-AMP ligase + salicyl-S-ArCP synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(76796, NULL, 'G3DSA:3.30.160.60:FF:005201', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76797, NULL, 'G3DSA:1.10.340.30:FF:000058', NULL, NULL, 'Endonuclease 3', NULL, NULL, NULL, NULL, NULL, 4),
(76798, NULL, 'G3DSA:3.90.70.80:FF:000009', NULL, NULL, 'OTU domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(76799, NULL, 'G3DSA:2.170.270.10:FF:000039', NULL, NULL, 'Histone-lysine N-methyltransferase SMYD3', NULL, NULL, NULL, NULL, NULL, 4),
(76800, NULL, 'G3DSA:2.60.40.60:FF:000781', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(76801, NULL, 'G3DSA:2.30.230.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76802, NULL, 'G3DSA:3.40.250.10:FF:000076', NULL, NULL, 'Ubiquitin-activating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(76803, NULL, 'G3DSA:3.40.50.720:FF:000218', NULL, NULL, '2-hydroxy-3-oxopropionate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(76804, NULL, 'G3DSA:3.40.50.80:FF:000179', NULL, NULL, 'FAD-binding domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(76805, NULL, 'G3DSA:2.60.40.10:FF:003043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76806, NULL, 'G3DSA:3.30.40.10:FF:000641', NULL, NULL, 'RABaptiN (Rab effector)', NULL, NULL, NULL, NULL, NULL, 4),
(76807, NULL, 'G3DSA:2.40.400.10:FF:000002', NULL, NULL, 'Acetoacetate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(76808, NULL, 'G3DSA:3.30.450.20:FF:000052', NULL, NULL, 'Sigma-54 dependent transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(76809, NULL, 'G3DSA:3.40.50.300:FF:007096', NULL, NULL, 'Small GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(76810, NULL, 'G3DSA:1.20.1560.10:FF:000144', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(76811, NULL, 'G3DSA:1.10.510.10:FF:003371', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76812, NULL, 'G3DSA:3.40.50.12780:FF:000029', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(76813, NULL, 'G3DSA:2.40.50.140:FF:000475', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(76814, NULL, 'G3DSA:3.40.50.620:FF:000486', NULL, NULL, 'Valyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(76815, NULL, 'G3DSA:3.30.70.1350:FF:000009', NULL, NULL, 'Cation diffusion facilitator 1', NULL, NULL, NULL, NULL, NULL, 4),
(76816, NULL, 'G3DSA:1.20.5.110:FF:000081', NULL, NULL, 'Syntaxin 16', NULL, NULL, NULL, NULL, NULL, 4),
(76817, NULL, 'G3DSA:2.60.40.10:FF:002997', NULL, NULL, 'Tyrosine-protein kinase-like otk', NULL, NULL, NULL, NULL, NULL, 4),
(76818, NULL, 'G3DSA:1.20.1270.60:FF:000210', NULL, NULL, 'arfaptin-2-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(76819, NULL, 'G3DSA:3.40.50.1820:FF:000221', NULL, NULL, 'Group XV phospholipase A2', NULL, NULL, NULL, NULL, NULL, 4),
(76820, NULL, 'G3DSA:3.40.50.720:FF:002461', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76821, NULL, 'G3DSA:3.30.160.60:FF:000884', NULL, NULL, 'Zinc finger protein 507', NULL, NULL, NULL, NULL, NULL, 4),
(76822, NULL, 'G3DSA:1.20.58.900:FF:000014', NULL, NULL, 'Run domain Beclin-1-interacting and cysteine-rich domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(76823, NULL, 'G3DSA:3.30.1490.20:FF:000042', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(76824, NULL, 'G3DSA:1.20.1070.10:FF:000236', NULL, NULL, 'G protein-coupled receptor 84', NULL, NULL, NULL, NULL, NULL, 4),
(76825, NULL, 'G3DSA:2.130.10.130:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76826, NULL, 'G3DSA:3.20.20.70:FF:000422', NULL, NULL, 'FMN-dependent 2-nitropropane dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(76827, NULL, 'G3DSA:3.40.1110.10:FF:000003', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(76828, NULL, 'G3DSA:3.40.50.1460:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76829, NULL, 'G3DSA:3.40.50.1240:FF:000199', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76830, NULL, 'G3DSA:3.30.40.10:FF:002086', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(76831, NULL, 'G3DSA:3.10.20.90:FF:000895', NULL, NULL, 'Cell polarity protein alp11', NULL, NULL, NULL, NULL, NULL, 4),
(76832, NULL, 'G3DSA:3.10.260.20:FF:000002', NULL, NULL, 'SKI-like oncogene a', NULL, NULL, NULL, NULL, NULL, 4),
(76833, NULL, 'G3DSA:3.40.640.10:FF:000533', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76834, NULL, 'G3DSA:3.40.390.10:FF:000294', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(76835, NULL, 'G3DSA:1.10.3380.10:FF:000026', NULL, NULL, 'ATP-dependent DNA helicase HFM1/MER3', NULL, NULL, NULL, NULL, NULL, 4),
(76836, NULL, 'G3DSA:2.60.120.260:FF:000036', NULL, NULL, 'Reelin', NULL, NULL, NULL, NULL, NULL, 4),
(76837, NULL, 'G3DSA:3.40.50.300:FF:004869', NULL, NULL, 'RecBCD enzyme subunit RecC', NULL, NULL, NULL, NULL, NULL, 4),
(76838, NULL, 'G3DSA:3.40.630.10:FF:000504', NULL, NULL, 'Glr2658 protein', NULL, NULL, NULL, NULL, NULL, 4),
(76839, NULL, 'G3DSA:3.80.10.10:FF:004027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76840, NULL, 'G3DSA:1.10.1870.10:FF:000018', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(76841, NULL, 'G3DSA:3.40.50.12760:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76842, NULL, 'G3DSA:1.20.58.690:FF:000001', NULL, NULL, 'MIX protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(76843, NULL, 'G3DSA:2.30.29.30:FF:000617', NULL, NULL, 'PH domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(76844, NULL, 'G3DSA:3.50.50.60:FF:000471', NULL, NULL, 'Probable malate:quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(76845, NULL, 'G3DSA:3.40.50.1820:FF:000693', NULL, NULL, 'EF-hand calcium-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(76846, NULL, 'G3DSA:3.30.450.60:FF:000013', NULL, NULL, 'Coatomer subunit zeta', NULL, NULL, NULL, NULL, NULL, 4),
(76847, NULL, 'G3DSA:3.30.70.2450:FF:000002', NULL, NULL, '3-(3-hydroxyphenyl)propionate hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(76848, NULL, 'G3DSA:2.130.10.10:FF:005471', NULL, NULL, 'WD repeat domain 62', NULL, NULL, NULL, NULL, NULL, 4),
(76849, NULL, 'G3DSA:1.25.40.10:FF:004481', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76850, NULL, 'G3DSA:3.90.1150.10:FF:000186', NULL, NULL, 'Biogenic Amine Synthesis related', NULL, NULL, NULL, NULL, NULL, 4),
(76851, NULL, 'G3DSA:3.40.50.720:FF:000370', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(76852, NULL, 'G3DSA:3.40.109.10:FF:000057', NULL, NULL, 'PnbA', NULL, NULL, NULL, NULL, NULL, 4),
(76853, NULL, 'G3DSA:1.10.1080.10:FF:000014', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(76854, NULL, 'G3DSA:3.40.50.300:FF:005443', NULL, NULL, 'Putative ABC transporter involved in multidrug resistance', NULL, NULL, NULL, NULL, NULL, 4),
(76855, NULL, 'G3DSA:3.90.640.10:FF:000128', NULL, NULL, 'Brahma associated protein 55kD', NULL, NULL, NULL, NULL, NULL, 4),
(76856, NULL, 'G3DSA:3.40.30.10:FF:000320', NULL, NULL, 'NHL repeat-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(76857, NULL, 'G3DSA:3.30.450.50:FF:000010', NULL, NULL, 'vesicle-trafficking protein SEC22a isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(76858, NULL, 'G3DSA:1.20.1560.10:FF:000728', NULL, NULL, 'p-glycoprotein 6, putative', NULL, NULL, NULL, NULL, NULL, 4),
(76859, NULL, 'G3DSA:3.20.20.80:FF:000425', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(76860, NULL, 'G3DSA:1.25.40.10:FF:000529', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(76861, NULL, 'G3DSA:3.40.50.1110:FF:000042', NULL, NULL, 'Rhamnogalacturonan acetylesterase RhgT', NULL, NULL, NULL, NULL, NULL, 4),
(76862, NULL, 'G3DSA:1.20.58.760:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76863, NULL, 'G3DSA:1.10.10.10:FF:000639', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(76864, NULL, 'G3DSA:1.25.40.20:FF:001465', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76865, NULL, 'G3DSA:3.40.50.300:FF:006871', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76866, NULL, 'G3DSA:3.30.420.40:FF:000797', NULL, NULL, 'Heat shock 70 kDa protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(76867, NULL, 'G3DSA:1.20.58.400:FF:000021', NULL, NULL, 'Vesicle transport v-SNARE protein N-terminus, putative', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(76868, NULL, 'G3DSA:1.10.510.10:FF:001538', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(76869, NULL, 'G3DSA:1.10.20.10:FF:000258', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76870, NULL, 'G3DSA:3.10.20.770:FF:000003', NULL, NULL, 'phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit beta isoform', NULL, NULL, NULL, NULL, NULL, 4),
(76871, NULL, 'G3DSA:2.10.25.10:FF:000328', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(76872, NULL, 'G3DSA:3.40.1170.60:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76873, NULL, 'G3DSA:3.40.30.10:FF:001129', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(76874, NULL, 'G3DSA:3.40.50.1000:FF:000739', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76875, NULL, 'G3DSA:3.30.450.20:FF:000467', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76876, NULL, 'G3DSA:3.90.190.10:FF:000172', NULL, NULL, 'Dual specificity protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(76877, NULL, 'G3DSA:2.130.10.10:FF:002649', NULL, NULL, 'WD repeat and HMG-box DNA-binding protein 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(76878, NULL, 'G3DSA:3.30.559.10:FF:000222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76879, NULL, 'G3DSA:3.40.1110.10:FF:000060', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(76880, NULL, 'G3DSA:3.40.850.10:FF:000133', NULL, NULL, 'Putative kinesin', NULL, NULL, NULL, NULL, NULL, 4),
(76881, NULL, 'G3DSA:3.30.565.10:FF:000399', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(76882, NULL, 'G3DSA:3.40.20.10:FF:000022', NULL, NULL, 'supervillin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(76883, NULL, 'G3DSA:1.25.40.10:FF:001344', NULL, NULL, 'SET (Trithorax/polycomb) domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(76884, NULL, 'G3DSA:2.60.40.420:FF:000064', NULL, NULL, 'Cytochrome c oxidase subunit 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(76885, NULL, 'G3DSA:1.10.630.10:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76886, NULL, 'G3DSA:1.20.1720.10:FF:000090', NULL, NULL, 'Bcr/CflA family efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(76887, NULL, 'G3DSA:1.10.150.50:FF:000061', NULL, NULL, 'Ets DNA-binding protein pokkuri', NULL, NULL, NULL, NULL, NULL, 4),
(76888, NULL, 'G3DSA:1.25.40.20:FF:001347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76889, NULL, 'G3DSA:1.25.10.10:FF:002944', NULL, NULL, 'Integrator complex subunit 4-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(76890, NULL, 'G3DSA:3.60.130.10:FF:000052', NULL, NULL, 'Gamma-butyrobetaine hydroxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(76891, NULL, 'G3DSA:2.60.120.200:FF:000333', NULL, NULL, 'Laminin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(76892, NULL, 'G3DSA:2.60.40.10:FF:005813', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76893, NULL, 'G3DSA:3.40.50.410:FF:000007', NULL, NULL, 'Calcium voltage-gated channel auxiliary subunit alpha2delta 3', NULL, NULL, NULL, NULL, NULL, 4),
(76894, NULL, 'G3DSA:3.30.1140.60:FF:000011', NULL, NULL, 'F-actin-capping protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(76895, NULL, 'G3DSA:3.40.50.2000:FF:000882', NULL, NULL, 'Glycosyl transferase, family 9', NULL, NULL, NULL, NULL, NULL, 4),
(76896, NULL, 'G3DSA:1.10.4100.10:FF:000006', NULL, NULL, '2-methylcitrate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(76897, NULL, 'G3DSA:3.40.50.10240:FF:000003', NULL, NULL, 'Thiamine pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(76898, NULL, 'G3DSA:2.60.40.10:FF:004942', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76899, NULL, 'G3DSA:1.20.1250.20:FF:000601', NULL, NULL, 'YCR023C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(76900, NULL, 'G3DSA:3.30.1490.480:FF:000003', NULL, NULL, 'Endolytic murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(76901, NULL, 'G3DSA:3.40.140.10:FF:000276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(76902, NULL, 'G3DSA:1.10.238.10:FF:000539', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(76903, NULL, 'G3DSA:2.130.10.30:FF:000098', NULL, NULL, 'E3 ubiquitin-protein ligase MYCBP2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(76904, NULL, 'G3DSA:3.40.50.1950:FF:000001', NULL, NULL, 'Flavin prenyltransferase UbiX', NULL, NULL, NULL, NULL, NULL, 4),
(76905, NULL, 'G3DSA:1.20.58.60:FF:000174', NULL, NULL, 'Spectrin repeat-containing, nuclear envelope 2', NULL, NULL, NULL, NULL, NULL, 4),
(76906, NULL, 'G3DSA:3.40.50.300:FF:003088', NULL, NULL, 'ADP-ribosylation factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(76907, NULL, 'G3DSA:3.50.50.60:FF:000942', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76908, NULL, 'G3DSA:3.30.590.50:FF:000020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(76909, NULL, 'G3DSA:1.20.1270.10:FF:000009', NULL, NULL, 'DnaK-type molecular chaperone BiP', NULL, NULL, NULL, NULL, NULL, 4),
(76910, NULL, 'G3DSA:1.10.238.10:FF:000596', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(76911, NULL, 'G3DSA:1.10.1200.10:FF:000103', NULL, NULL, 'Nonribosomal peptide synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(76912, NULL, 'G3DSA:3.10.20.90:FF:000777', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76913, NULL, 'G3DSA:3.30.70.330:FF:002614', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76914, NULL, 'G3DSA:1.10.4160.10:FF:000015', NULL, NULL, 'Cytosine/purine/uracil/thiamine/allantoin permease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(76915, NULL, 'G3DSA:1.10.510.10:FF:003163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76916, NULL, 'G3DSA:3.60.15.10:FF:000059', NULL, NULL, 'N-acetylphosphatidylethanolamine-hydrolyzing phospholipase D', NULL, NULL, NULL, NULL, NULL, 4),
(76917, NULL, 'G3DSA:2.40.50.140:FF:000683', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76918, NULL, 'G3DSA:2.30.29.230:FF:000015', NULL, NULL, 'Tbc-16', NULL, NULL, NULL, NULL, NULL, 4),
(76919, NULL, 'G3DSA:2.130.10.10:FF:002239', NULL, NULL, 'Quinoprotein amine dehydrogenase, beta chain-like RIC1-like guanyl-nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(76920, NULL, 'G3DSA:1.20.5.340:FF:000094', NULL, NULL, 'Myosin, heavy chain 11a, smooth muscle', NULL, NULL, NULL, NULL, NULL, 4),
(76921, NULL, 'G3DSA:4.10.280.110:FF:000002', NULL, NULL, 'U4/U6 small nuclear ribonucleoprotein Prp4', NULL, NULL, NULL, NULL, NULL, 4),
(76922, NULL, 'G3DSA:1.10.225.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76923, NULL, 'G3DSA:3.40.50.1820:FF:001002', NULL, NULL, 'Carboxylesterase', NULL, NULL, NULL, NULL, NULL, 4),
(76924, NULL, 'G3DSA:3.60.60.10:FF:000012', NULL, NULL, 'Dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(76925, NULL, 'G3DSA:1.10.1370.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76926, NULL, 'G3DSA:3.40.50.2300:FF:000882', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76927, NULL, 'G3DSA:3.30.450.20:FF:000260', NULL, NULL, 'Putative Sigma factor regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(76928, NULL, 'G3DSA:1.25.10.10:FF:002298', NULL, NULL, 'Apoptosis inhibitory protein 5 (API5)', NULL, NULL, NULL, NULL, NULL, 4),
(76929, NULL, 'G3DSA:3.40.50.300:FF:005179', NULL, NULL, 'Ras-related protein Rab-23', NULL, NULL, NULL, NULL, NULL, 4),
(76930, NULL, 'G3DSA:3.30.160.60:FF:003256', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76931, NULL, 'G3DSA:3.30.1120.30:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76932, NULL, 'G3DSA:1.25.40.90:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76933, NULL, 'G3DSA:1.20.1050.10:FF:000027', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(76934, NULL, 'G3DSA:1.10.287.130:FF:000043', NULL, NULL, 'Two-component sensor histidine kinase KdpD', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(76935, NULL, 'G3DSA:2.60.120.380:FF:000021', NULL, NULL, 'Transmembrane protein-related', NULL, NULL, NULL, NULL, NULL, 4),
(76936, NULL, 'G3DSA:3.40.50.620:FF:000014', NULL, NULL, 'Universal stress protein', NULL, NULL, NULL, NULL, NULL, 4),
(76937, NULL, 'G3DSA:3.40.50.1970:FF:000007', NULL, NULL, 'Pentafunctional AROM polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(76938, NULL, 'G3DSA:1.20.1070.10:FF:000028', NULL, NULL, 'leucine-rich repeat-containing G-protein coupled receptor 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(76939, NULL, 'G3DSA:3.30.160.60:FF:001194', NULL, NULL, 'Zinc finger protein 770', NULL, NULL, NULL, NULL, NULL, 4),
(76940, NULL, 'G3DSA:2.10.110.10:FF:000228', NULL, NULL, 'LIM homeobox 8', NULL, NULL, NULL, NULL, NULL, 4),
(76941, NULL, 'G3DSA:3.30.160.60:FF:000676', NULL, NULL, 'C2H2 transcription factor (Sfp1)', NULL, NULL, NULL, NULL, NULL, 4),
(76942, NULL, 'G3DSA:1.20.58.1120:FF:000022', NULL, NULL, 'DHC7 protein', NULL, NULL, NULL, NULL, NULL, 4),
(76943, NULL, 'G3DSA:3.30.479.20:FF:000016', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(76944, NULL, 'G3DSA:1.50.10.20:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76945, NULL, 'G3DSA:2.30.42.10:FF:000283', NULL, NULL, 'Uncharacterized protein, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(76946, NULL, 'G3DSA:3.40.50.700:FF:000004', NULL, NULL, 'Methyl viologen-reducing hydrogenase, small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(76947, NULL, 'G3DSA:1.25.40.10:FF:003553', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76948, NULL, 'G3DSA:3.30.200.20:FF:000713', NULL, NULL, 'Mitogen-activated protein kinase 1, putative, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(76949, NULL, 'G3DSA:3.30.160.60:FF:005408', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76950, NULL, 'G3DSA:2.60.40.10:FF:001098', NULL, NULL, 'Titin novex-3', NULL, NULL, NULL, NULL, NULL, 4),
(76951, NULL, 'G3DSA:1.20.58.60:FF:000117', NULL, NULL, 'A-kinase anchor protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(76952, NULL, 'G3DSA:3.40.50.10260:FF:000009', NULL, NULL, 'AGAP003131-PA', NULL, NULL, NULL, NULL, NULL, 4),
(76953, NULL, 'G3DSA:1.20.1250.60:FF:000001', NULL, NULL, 'Interferon lambda 1', NULL, NULL, NULL, NULL, NULL, 4),
(76954, NULL, 'G3DSA:3.90.550.10:FF:000655', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76955, NULL, 'G3DSA:1.20.120.80:FF:000015', NULL, NULL, 'Cytochrome oxidase subunit III', NULL, NULL, NULL, NULL, NULL, 4),
(76956, NULL, 'G3DSA:3.40.50.1980:FF:000128', NULL, NULL, 'ABC-type cobalamin/Fe3+ siderophore transport system, periplasmic component', NULL, NULL, NULL, NULL, NULL, 4),
(76957, NULL, 'G3DSA:2.10.25.10:FF:000800', NULL, NULL, 'Crumbs, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(76958, NULL, 'G3DSA:3.30.479.30:FF:000019', NULL, NULL, 'Possible exported conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(76959, NULL, 'G3DSA:2.60.15.10:FF:000011', NULL, NULL, 'ATP synthase epsilon chain', NULL, NULL, NULL, NULL, NULL, 4),
(76960, NULL, 'G3DSA:2.60.40.60:FF:001091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76961, NULL, 'G3DSA:1.25.40.10:FF:002946', NULL, NULL, 'Os12g0114400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(76962, NULL, 'G3DSA:2.20.110.10:FF:000063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76963, NULL, 'G3DSA:2.130.10.10:FF:004482', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76964, NULL, 'G3DSA:3.40.367.20:FF:000035', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(76965, NULL, 'G3DSA:2.160.20.10:FF:000288', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(76966, NULL, 'G3DSA:3.80.10.10:FF:000227', NULL, NULL, 'Immunoglobulin superfamily member 10', NULL, NULL, NULL, NULL, NULL, 4),
(76967, NULL, 'G3DSA:3.40.50.620:FF:000750', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76968, NULL, 'G3DSA:2.60.120.200:FF:000451', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(76969, NULL, 'G3DSA:2.10.109.10:FF:000045', NULL, NULL, 'Inner mitochondrial membrane peptidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(76970, NULL, 'G3DSA:2.60.40.60:FF:001034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76971, NULL, 'G3DSA:3.40.50.300:FF:005651', NULL, NULL, 'Dynein-1-beta heavy chain, flagellar inner arm I1 complex', NULL, NULL, NULL, NULL, NULL, 4),
(76972, NULL, 'G3DSA:2.40.290.30:FF:000009', NULL, NULL, 'Prostate tumor overexpressed gene 1, isoform CRA_d', NULL, NULL, NULL, NULL, NULL, 4),
(76973, NULL, 'G3DSA:2.60.40.10:FF:004824', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76974, NULL, 'G3DSA:1.20.1420.30:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76975, NULL, 'G3DSA:3.30.930.10:FF:000041', NULL, NULL, 'Phenylalanyl-tRNA synthetase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(76976, NULL, 'G3DSA:3.30.479.10:FF:000013', NULL, NULL, '6-carboxy-5,6,7,8-tetrahydropterin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(76977, NULL, 'G3DSA:3.40.50.720:FF:000162', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(76978, NULL, 'G3DSA:2.30.40.10:FF:000059', NULL, NULL, 'Adenine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(76979, NULL, 'G3DSA:3.30.1490.70:FF:000001', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(76980, NULL, 'G3DSA:3.30.2060.10:FF:000007', NULL, NULL, 'Putative penicillin-binding protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(76981, NULL, 'G3DSA:3.40.50.300:FF:007803', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76982, NULL, 'G3DSA:3.60.15.10:FF:000205', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(76983, NULL, 'G3DSA:3.40.50.300:FF:000828', NULL, NULL, 'leucine-rich repeat and guanylate kinase domain-containing protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(76984, NULL, 'G3DSA:3.40.50.1970:FF:000064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76985, NULL, 'G3DSA:2.120.10.30:FF:000385', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76986, NULL, 'G3DSA:3.40.1190.10:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(76987, NULL, 'G3DSA:3.30.420.40:FF:001045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76988, NULL, 'G3DSA:3.40.50.720:FF:002522', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76989, NULL, 'G3DSA:1.20.1740.10:FF:000001', NULL, NULL, 'Amino acid permease', NULL, NULL, NULL, NULL, NULL, 4),
(76990, NULL, 'G3DSA:1.10.472.10:FF:000656', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(76991, NULL, 'G3DSA:1.10.555.10:FF:000107', NULL, NULL, 'Type II inositol-1,4,5-trisphosphate 5-phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(76992, NULL, 'G3DSA:3.40.1190.20:FF:000045', NULL, NULL, 'Ribokinase', NULL, NULL, NULL, NULL, NULL, 4),
(76993, NULL, 'G3DSA:1.25.40.20:FF:001611', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76994, NULL, 'G3DSA:2.70.160.11:FF:000051', NULL, NULL, 'Coactivator-associated arginine methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(76995, NULL, 'G3DSA:2.60.40.10:FF:002790', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76996, NULL, 'G3DSA:3.30.50.10:FF:000018', NULL, NULL, 'GATA transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(76997, NULL, 'G3DSA:3.40.50.1820:FF:001856', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(76998, NULL, 'G3DSA:3.50.30.30:FF:000011', NULL, NULL, 'E3 ubiquitin-protein ligase RNF130', NULL, NULL, NULL, NULL, NULL, 4),
(76999, NULL, 'G3DSA:3.30.1240.10:FF:000021', NULL, NULL, 'HAD family phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(77000, NULL, 'G3DSA:3.40.50.300:FF:003234', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(77001, NULL, 'G3DSA:3.40.50.300:FF:007034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77002, NULL, 'G3DSA:3.30.70.1440:FF:000003', NULL, NULL, 'Multidrug resistance protein MdtB', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(77003, NULL, 'G3DSA:2.40.10.10:FF:000681', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77004, NULL, 'G3DSA:2.70.150.10:FF:000189', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(77005, NULL, 'G3DSA:3.40.50.880:FF:000159', NULL, NULL, '1,3-beta-galactosyl-N-acetylhexosamine phosphorylase Cphy0577', NULL, NULL, NULL, NULL, NULL, 4),
(77006, NULL, 'G3DSA:3.30.70.330:FF:002406', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77007, NULL, 'G3DSA:3.30.70.2750:FF:000002', NULL, NULL, 'V-type ATP synthase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(77008, NULL, 'G3DSA:3.40.1160.10:FF:000006', NULL, NULL, 'Glutamate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(77009, NULL, 'G3DSA:3.30.750.200:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77010, NULL, 'G3DSA:3.30.2130.30:FF:000024', NULL, NULL, 'THUMP domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(77011, NULL, 'G3DSA:1.25.10.10:FF:002798', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77012, NULL, 'G3DSA:1.20.1250.20:FF:001849', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77013, NULL, 'G3DSA:3.40.50.300:FF:005090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77014, NULL, 'G3DSA:2.60.470.10:FF:000024', NULL, NULL, 'Pickpocket 14', NULL, NULL, NULL, NULL, NULL, 4),
(77015, NULL, 'G3DSA:3.40.50.300:FF:003381', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(77016, NULL, 'G3DSA:1.20.58.390:FF:000001', NULL, NULL, 'Neuronal nicotinic acetylcholine receptor subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(77017, NULL, 'G3DSA:3.30.70.2760:FF:000005', NULL, NULL, 'HD domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(77018, NULL, 'G3DSA:3.30.1010.10:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77019, NULL, 'G3DSA:3.30.60.270:FF:000008', NULL, NULL, 'Vacuolar protein sorting/targeting protein PEP1', NULL, NULL, NULL, NULL, NULL, 4),
(77020, NULL, 'G3DSA:1.10.246.90:FF:000003', NULL, NULL, 'Nucleolar protein 58', NULL, NULL, NULL, NULL, NULL, 4),
(77021, NULL, 'G3DSA:3.90.190.10:FF:000380', NULL, NULL, 'Tyrosine protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(77022, NULL, 'G3DSA:3.20.20.330:FF:000021', NULL, NULL, 'Homocysteine S-methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(77023, NULL, 'G3DSA:1.20.1250.20:FF:000455', NULL, NULL, 'Sugar baby, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(77024, NULL, 'G3DSA:1.20.58.60:FF:000617', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77025, NULL, 'G3DSA:3.40.50.10190:FF:000230', NULL, NULL, 'DNA ligase 4-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(77026, NULL, 'G3DSA:1.25.40.10:FF:002890', NULL, NULL, 'Putative pentatricopeptide repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(77027, NULL, 'G3DSA:3.40.30.10:FF:000202', NULL, NULL, 'glutathione S-transferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(77028, NULL, 'G3DSA:3.40.50.300:FF:008259', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77029, NULL, 'G3DSA:3.60.10.10:FF:000363', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77030, NULL, 'G3DSA:3.30.160.60:FF:005701', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77031, NULL, 'G3DSA:3.30.230.70:FF:000095', NULL, NULL, 'Exosome complex component Rrp42', NULL, NULL, NULL, NULL, NULL, 4),
(77032, NULL, 'G3DSA:3.20.20.80:FF:000279', NULL, NULL, 'Glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(77033, NULL, 'G3DSA:1.20.140.40:FF:000027', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(77034, NULL, 'G3DSA:1.25.40.10:FF:003053', NULL, NULL, 'RNA polymerase III transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(77035, NULL, 'G3DSA:3.40.50.12780:FF:000181', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77036, NULL, 'G3DSA:3.40.50.12430:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(77037, NULL, 'G3DSA:3.20.20.190:FF:000052', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(77038, NULL, 'G3DSA:3.30.1330.40:FF:000008', NULL, NULL, 'ribonuclease UK114 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(77039, NULL, 'G3DSA:4.10.280.10:FF:000081', NULL, NULL, 'transcription cofactor HES-6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(77040, NULL, 'G3DSA:3.60.15.10:FF:000262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77041, NULL, 'G3DSA:3.40.50.300:FF:003291', NULL, NULL, 'RAN small monomeric GTPase (Ran)', NULL, NULL, NULL, NULL, NULL, 4),
(77042, NULL, 'G3DSA:3.30.465.10:FF:000072', NULL, NULL, 'Alkylglycerone-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(77043, NULL, 'G3DSA:1.25.10.10:FF:001516', NULL, NULL, 'Formin-B', NULL, NULL, NULL, NULL, NULL, 4),
(77044, NULL, 'G3DSA:3.40.1280.10:FF:000038', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4),
(77045, NULL, 'G3DSA:1.10.287.1060:FF:000013', NULL, NULL, 'ESAT-6 like protein EsxS', NULL, NULL, NULL, NULL, NULL, 4),
(77046, NULL, 'G3DSA:1.20.1510.10:FF:000046', NULL, NULL, 'Cation diffusion facilitator family protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(77047, NULL, 'G3DSA:2.130.10.10:FF:002891', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(77048, NULL, 'G3DSA:2.30.42.10:FF:000075', NULL, NULL, 'Tight junction protein ZO-2 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(77049, NULL, 'G3DSA:1.10.510.10:FF:003781', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77050, NULL, 'G3DSA:1.10.8.270:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77051, NULL, 'G3DSA:1.20.58.60:FF:000527', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77052, NULL, 'G3DSA:2.10.25.10:FF:001256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77053, NULL, 'G3DSA:3.30.200.20:FF:000359', NULL, NULL, 'myosin light chain kinase 2, skeletal/cardiac muscle', NULL, NULL, NULL, NULL, NULL, 4),
(77054, NULL, 'G3DSA:2.60.40.420:FF:000182', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(77055, NULL, 'G3DSA:3.40.309.10:FF:000095', NULL, NULL, 'ALdehyde deHydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(77056, NULL, 'G3DSA:3.30.160.60:FF:001811', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(77057, NULL, 'G3DSA:1.10.10.10:FF:001544', NULL, NULL, 'cGMP binding protein with small GTPase-serine/threonine kinase-dep-rasgef-gram-and two cGMP binding domains', NULL, NULL, NULL, NULL, NULL, 4),
(77058, NULL, 'G3DSA:3.30.50.10:FF:000108', NULL, NULL, 'Nuclear hormone receptor family member odr-7', NULL, NULL, NULL, NULL, NULL, 4),
(77059, NULL, 'G3DSA:1.25.40.10:FF:002738', NULL, NULL, 'Trafficking protein particle complex subunit 12', NULL, NULL, NULL, NULL, NULL, 4),
(77060, NULL, 'G3DSA:3.10.100.10:FF:000336', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77061, NULL, 'G3DSA:1.10.287.1080:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77062, NULL, 'G3DSA:1.20.120.980:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77063, NULL, 'G3DSA:3.80.10.10:FF:000019', NULL, NULL, 'leucine-rich repeat and fibronectin type III domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(77064, NULL, 'G3DSA:3.30.450.20:FF:000613', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77065, NULL, 'G3DSA:3.30.40.10:FF:000080', NULL, NULL, 'Histone-lysine N-methyltransferase 2C', NULL, NULL, NULL, NULL, NULL, 4),
(77066, NULL, 'G3DSA:2.60.120.200:FF:000097', NULL, NULL, 'Pappalysin 1', NULL, NULL, NULL, NULL, NULL, 4),
(77067, NULL, 'G3DSA:3.30.1740.10:FF:000014', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(77068, NULL, 'G3DSA:1.10.357.50:FF:000013', NULL, NULL, 'Exocyst complex component, putative', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(77069, NULL, 'G3DSA:3.90.70.10:FF:000860', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77070, NULL, 'G3DSA:1.10.10.60:FF:000429', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(77071, NULL, 'G3DSA:3.30.200.20:FF:001264', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(77072, NULL, 'G3DSA:1.10.287.70:FF:000350', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77073, NULL, 'G3DSA:1.25.10.10:FF:000499', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77074, NULL, 'G3DSA:3.40.250.10:FF:000222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77075, NULL, 'G3DSA:2.120.10.80:FF:000383', NULL, NULL, 'Tip elongation aberrant protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(77076, NULL, 'G3DSA:2.60.40.10:FF:004588', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77077, NULL, 'G3DSA:3.40.309.10:FF:000038', NULL, NULL, 'Betaine aldehyde dehydrogenase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(77078, NULL, 'G3DSA:6.10.250.3400:FF:000001', NULL, NULL, 'MAM1p Monopolin', NULL, NULL, NULL, NULL, NULL, 4),
(77079, NULL, 'G3DSA:3.40.50.2000:FF:000764', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(77080, NULL, 'G3DSA:3.30.200.20:FF:002192', NULL, NULL, 'Aurora b kinase1', NULL, NULL, NULL, NULL, NULL, 4),
(77081, NULL, 'G3DSA:1.10.10.10:FF:000881', NULL, NULL, 'SAC3/GANP/Nin1/mts3/eIF-3_p25_family /COP9_signalosome_-_subunit_CSN8_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(77082, NULL, 'G3DSA:3.30.160.60:FF:001547', NULL, NULL, 'C2H2 transcription factor RfeC', NULL, NULL, NULL, NULL, NULL, 4),
(77083, NULL, 'G3DSA:2.70.70.10:FF:000060', NULL, NULL, 'Peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(77084, NULL, 'G3DSA:3.90.1150.10:FF:000450', NULL, NULL, 'AGAP006541-PA', NULL, NULL, NULL, NULL, NULL, 4),
(77085, NULL, 'G3DSA:3.40.50.2300:FF:001135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77086, NULL, 'G3DSA:1.20.1160.20:FF:000010', NULL, NULL, 'Regulator of telomere elongation helicase 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(77087, NULL, 'G3DSA:3.30.900.10:FF:000005', NULL, NULL, 'Mitotic spindle checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(77088, NULL, 'G3DSA:3.40.50.720:FF:001033', NULL, NULL, 'Prestalk A differentiation protein A', NULL, NULL, NULL, NULL, NULL, 4),
(77089, NULL, 'G3DSA:1.10.940.10:FF:000014', NULL, NULL, 'Transcription antitermination protein NusB', NULL, NULL, NULL, NULL, NULL, 4),
(77090, NULL, 'G3DSA:3.40.850.10:FF:000015', NULL, NULL, 'Kinesin family member 26A', NULL, NULL, NULL, NULL, NULL, 4),
(77091, NULL, 'G3DSA:3.30.2010.10:FF:000004', NULL, NULL, 'Metalloprotease YcaL', NULL, NULL, NULL, NULL, NULL, 4),
(77092, NULL, 'G3DSA:3.40.50.300:FF:003852', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77093, NULL, 'G3DSA:3.30.1460.20:FF:000006', NULL, NULL, 'Arp2/3 complex 34 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(77094, NULL, 'G3DSA:1.10.150.20:FF:000277', NULL, NULL, 'FA core complex associated protein 24', NULL, NULL, NULL, NULL, NULL, 4),
(77095, NULL, 'G3DSA:4.10.240.10:FF:000016', NULL, NULL, 'C6 transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(77096, NULL, 'G3DSA:1.10.238.10:FF:001113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77097, NULL, 'G3DSA:2.70.150.10:FF:000279', NULL, NULL, 'P-type phospholipid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(77098, NULL, 'G3DSA:3.30.160.60:FF:001901', NULL, NULL, 'Zinc finger protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(77099, NULL, 'G3DSA:3.90.1580.10:FF:000004', NULL, NULL, 'Hercynine oxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(77100, NULL, 'G3DSA:2.60.40.820:FF:000032', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77101, NULL, 'G3DSA:3.30.160.60:FF:004684', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77102, NULL, 'G3DSA:1.10.8.140:FF:000002', NULL, NULL, 'Programmed cell death, putative', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(77103, NULL, 'G3DSA:3.20.20.80:FF:000072', NULL, NULL, 'lysosomal alpha-glucosidase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(77104, NULL, 'G3DSA:1.10.3470.10:FF:000056', NULL, NULL, 'Divalent manganese/zinc ABC transporter, membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(77105, NULL, 'G3DSA:3.40.50.300:FF:001082', NULL, NULL, 'probable ATP-dependent RNA helicase DHX40', NULL, NULL, NULL, NULL, NULL, 4),
(77106, NULL, 'G3DSA:3.10.100.10:FF:000426', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77107, NULL, 'G3DSA:4.10.240.10:FF:000073', NULL, NULL, 'Glucose transport transcription regulator RGT1', NULL, NULL, NULL, NULL, NULL, 4),
(77108, NULL, 'G3DSA:2.60.40.10:FF:001805', NULL, NULL, 'Tyrosine-protein kinase-like otk', NULL, NULL, NULL, NULL, NULL, 4),
(77109, NULL, 'G3DSA:3.30.160.60:FF:002475', NULL, NULL, 'Si:ch73-221f6.3', NULL, NULL, NULL, NULL, NULL, 4),
(77110, NULL, 'G3DSA:3.30.40.10:FF:001827', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77111, NULL, 'G3DSA:3.80.10.10:FF:000637', NULL, NULL, 'Toll receptor 13', NULL, NULL, NULL, NULL, NULL, 4),
(77112, NULL, 'G3DSA:3.80.10.10:FF:003717', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77113, NULL, 'G3DSA:3.20.20.80:FF:000015', NULL, NULL, 'Acidic endochitinase SE2', NULL, NULL, NULL, NULL, NULL, 4),
(77114, NULL, 'G3DSA:1.25.40.10:FF:003143', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g20300, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(77115, NULL, 'G3DSA:1.20.120.610:FF:000016', NULL, NULL, 'V-type proton ATPase proteolipid subunit', NULL, NULL, NULL, NULL, NULL, 4),
(77116, NULL, 'G3DSA:3.40.50.300:FF:001643', NULL, NULL, 'DNA repair protein RAD51 homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(77117, NULL, 'G3DSA:3.10.450.610:FF:000001', NULL, NULL, 'DUF4902 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(77118, NULL, 'G3DSA:3.40.50.1820:FF:000485', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(77119, NULL, 'G3DSA:1.20.1290.10:FF:000011', NULL, NULL, 'Sestrin 2', NULL, NULL, NULL, NULL, NULL, 4),
(77120, NULL, 'G3DSA:3.60.120.10:FF:000023', NULL, NULL, 'Aminodeoxychorismate synthase component I', NULL, NULL, NULL, NULL, NULL, 4),
(77121, NULL, 'G3DSA:1.10.1300.10:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77122, NULL, 'G3DSA:3.40.50.150:FF:000648', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77123, NULL, 'G3DSA:3.90.20.20:FF:000005', NULL, NULL, 'GrpE protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(77124, NULL, 'G3DSA:3.20.20.70:FF:000012', NULL, NULL, 'GMP reductase', NULL, NULL, NULL, NULL, NULL, 4),
(77125, NULL, 'G3DSA:4.10.1000.10:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77126, NULL, 'G3DSA:1.20.1250.20:FF:002046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77127, NULL, 'G3DSA:1.10.510.10:FF:000757', NULL, NULL, 'AGC family serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(77128, NULL, 'G3DSA:3.30.230.10:FF:000184', NULL, NULL, '40S ribosomal protein S16', NULL, NULL, NULL, NULL, NULL, 4),
(77129, NULL, 'G3DSA:3.10.28.10:FF:000029', NULL, NULL, 'Uncharacterized mitochondrial protein RF1', NULL, NULL, NULL, NULL, NULL, 4),
(77130, NULL, 'G3DSA:2.60.40.10:FF:003453', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77131, NULL, 'G3DSA:3.90.176.10:FF:000004', NULL, NULL, 'Type III effector HopU1', NULL, NULL, NULL, NULL, NULL, 4),
(77132, NULL, 'G3DSA:2.60.120.200:FF:000187', NULL, NULL, 'SP2353, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(77133, NULL, 'G3DSA:2.30.29.30:FF:000409', NULL, NULL, 'Insulin receptor substrate 2-B', NULL, NULL, NULL, NULL, NULL, 4),
(77134, NULL, 'G3DSA:2.60.120.330:FF:000231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77135, NULL, 'G3DSA:2.30.39.10:FF:000022', NULL, NULL, 'Os11g0230400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(77136, NULL, 'G3DSA:2.60.60.20:FF:000028', NULL, NULL, 'Triacylglycerol lipase, pancreatic', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(77137, NULL, 'G3DSA:2.130.10.10:FF:003054', NULL, NULL, 'THO complex subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(77138, NULL, 'G3DSA:3.10.330.10:FF:000027', NULL, NULL, 'Vesicular-fusion protein SEC18', NULL, NULL, NULL, NULL, NULL, 4),
(77139, NULL, 'G3DSA:2.60.40.10:FF:005605', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77140, NULL, 'G3DSA:3.40.50.12470:FF:000003', NULL, NULL, '2-oxoglutarate dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(77141, NULL, 'G3DSA:3.30.420.40:FF:000382', NULL, NULL, 'Glucosamine kinase GpsK', NULL, NULL, NULL, NULL, NULL, 4),
(77142, NULL, 'G3DSA:3.30.200.20:FF:000449', NULL, NULL, 'cGMP-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(77143, NULL, 'G3DSA:1.10.238.210:FF:000012', NULL, NULL, 'Glna-1', NULL, NULL, NULL, NULL, NULL, 4),
(77144, NULL, 'G3DSA:1.10.860.10:FF:000013', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(77145, NULL, 'G3DSA:2.30.30.100:FF:000057', NULL, NULL, 'LSM1 homolog, mRNA degradation associated', NULL, NULL, NULL, NULL, NULL, 4),
(77146, NULL, 'G3DSA:3.90.180.10:FF:000143', NULL, NULL, 'Zinc-type alcohol dehydrogenase-like protein C1198.01', NULL, NULL, NULL, NULL, NULL, 4),
(77147, NULL, 'G3DSA:1.25.40.10:FF:005352', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77148, NULL, 'G3DSA:3.30.70.270:FF:000275', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77149, NULL, 'G3DSA:3.20.20.80:FF:000633', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77150, NULL, 'G3DSA:3.60.40.10:FF:000191', NULL, NULL, 'Probable protein phosphatase 2C F42G9.1', NULL, NULL, NULL, NULL, NULL, 4),
(77151, NULL, 'G3DSA:3.30.420.10:FF:000221', NULL, NULL, '3''-5'' exonuclease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(77152, NULL, 'G3DSA:4.10.400.10:FF:000170', NULL, NULL, 'Low density lipoprotein receptor-related protein 2a', NULL, NULL, NULL, NULL, NULL, 4),
(77153, NULL, 'G3DSA:2.60.200.40:FF:000053', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(77154, NULL, 'G3DSA:1.10.510.10:FF:002909', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77155, NULL, 'G3DSA:2.60.40.10:FF:001244', NULL, NULL, 'Interferon gamma receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(77156, NULL, 'G3DSA:3.30.70.360:FF:000004', NULL, NULL, 'Peptidase M20 domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(77157, NULL, 'G3DSA:2.60.120.260:FF:000244', NULL, NULL, 'Alpha-1,3/4-fucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(77158, NULL, 'G3DSA:3.20.20.150:FF:000057', NULL, NULL, 'Probable hexulose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(77159, NULL, 'G3DSA:1.10.510.10:FF:002966', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77160, NULL, 'G3DSA:3.40.50.360:FF:000065', NULL, NULL, 'Flavoprotein MioC', NULL, NULL, NULL, NULL, NULL, 4),
(77161, NULL, 'G3DSA:1.10.472.80:FF:000250', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77162, NULL, 'G3DSA:3.30.30.90:FF:000001', NULL, NULL, 'Polymerase basic protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(77163, NULL, 'G3DSA:1.20.140.140:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77164, NULL, 'G3DSA:3.20.20.70:FF:000630', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77165, NULL, 'G3DSA:3.20.20.140:FF:000054', NULL, NULL, 'Imidazolonepropionase-like amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(77166, NULL, 'G3DSA:3.30.70.600:FF:000008', NULL, NULL, '40S ribosomal protein S20', NULL, NULL, NULL, NULL, NULL, 4),
(77167, NULL, 'G3DSA:1.10.8.1080:FF:000001', NULL, NULL, 'N-acetylmuramic acid 6-phosphate etherase', NULL, NULL, NULL, NULL, NULL, 4),
(77168, NULL, 'G3DSA:3.30.70.270:FF:000218', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77169, NULL, 'G3DSA:3.30.110.10:FF:000001', NULL, NULL, 'Translation initiation factor IF-3', NULL, NULL, NULL, NULL, NULL, 4),
(77170, NULL, 'G3DSA:1.10.287.70:FF:000108', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(77171, NULL, 'G3DSA:2.170.120.12:FF:000019', NULL, NULL, 'RNA Polymerase II (B) subunit', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(77172, NULL, 'G3DSA:1.10.730.20:FF:000012', NULL, NULL, 'Isoleucyl-tRNA synthetase (Mitochondrial)', NULL, NULL, NULL, NULL, NULL, 4),
(77173, NULL, 'G3DSA:3.50.50.60:FF:000178', NULL, NULL, 'All-trans-retinol 13,14-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(77174, NULL, 'G3DSA:3.30.1520.10:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77175, NULL, 'G3DSA:2.130.10.10:FF:005263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77176, NULL, 'G3DSA:2.60.40.10:FF:004678', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77177, NULL, 'G3DSA:1.25.40.180:FF:000255', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77178, NULL, 'G3DSA:1.20.120.230:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77179, NULL, 'G3DSA:3.90.190.10:FF:000262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77180, NULL, 'G3DSA:3.30.200.20:FF:002276', NULL, NULL, 'Calmodulin-binding receptor-like cytoplasmic kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(77181, NULL, 'G3DSA:3.30.160.60:FF:001581', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77182, NULL, 'G3DSA:1.25.40.20:FF:001381', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77183, NULL, 'G3DSA:3.30.70.330:FF:000377', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(77184, NULL, 'G3DSA:1.20.1250.20:FF:000045', NULL, NULL, 'Glycoside-pentoside-hexuronide family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(77185, NULL, 'G3DSA:1.20.1250.10:FF:000042', NULL, NULL, 'Somatolactin alpha', NULL, NULL, NULL, NULL, NULL, 4),
(77186, NULL, 'G3DSA:1.10.10.10:FF:001191', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(77187, NULL, 'G3DSA:3.30.559.10:FF:000076', NULL, NULL, 'Transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(77188, NULL, 'G3DSA:1.10.10.10:FF:000729', NULL, NULL, 'Transcriptional regulator FurA', NULL, NULL, NULL, NULL, NULL, 4),
(77189, NULL, 'G3DSA:3.40.1440.10:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77190, NULL, 'G3DSA:2.10.230.10:FF:000001', NULL, NULL, 'DnaJ subfamily A member 2', NULL, NULL, NULL, NULL, NULL, 4),
(77191, NULL, 'G3DSA:3.10.580.10:FF:000130', NULL, NULL, 'Hemolysin', NULL, NULL, NULL, NULL, NULL, 4),
(77192, NULL, 'G3DSA:3.40.50.460:FF:000005', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(77193, NULL, 'G3DSA:3.10.450.70:FF:000003', NULL, NULL, 'Thiol:disulfide interchange protein', NULL, NULL, NULL, NULL, NULL, 4),
(77194, NULL, 'G3DSA:1.10.8.750:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77195, NULL, 'G3DSA:2.160.20.10:FF:000316', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(77196, NULL, 'G3DSA:2.40.50.140:FF:000239', NULL, NULL, 'Meiosis specific with OB domains', NULL, NULL, NULL, NULL, NULL, 4),
(77197, NULL, 'G3DSA:1.25.40.10:FF:004571', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77198, NULL, 'G3DSA:3.30.565.10:FF:000489', NULL, NULL, 'Protein morc-1', NULL, NULL, NULL, NULL, NULL, 4),
(77199, NULL, 'G3DSA:3.40.50.150:FF:000497', NULL, NULL, 'tRNA wybutosine-synthesizing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(77200, NULL, 'G3DSA:3.30.559.10:FF:000132', NULL, NULL, 'Nonribosomal peptide synthetase fmqA', NULL, NULL, NULL, NULL, NULL, 4),
(77201, NULL, 'G3DSA:1.20.1070.10:FF:002035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77202, NULL, 'G3DSA:2.30.36.70:FF:000011', NULL, NULL, 'Actin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(77203, NULL, 'G3DSA:3.40.630.10:FF:000358', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77204, NULL, 'G3DSA:2.40.50.140:FF:000767', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77205, NULL, 'G3DSA:1.50.40.10:FF:000201', NULL, NULL, 'Solute carrier family 25 member 4', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(77206, NULL, 'G3DSA:1.20.1720.10:FF:000056', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(77207, NULL, 'G3DSA:2.130.10.10:FF:002739', NULL, NULL, 'WD40-repeat-containing domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(77208, NULL, 'G3DSA:1.20.1250.20:FF:001675', NULL, NULL, 'ABC multidrug transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(77209, NULL, 'G3DSA:2.60.120.260:FF:000328', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(77210, NULL, 'G3DSA:1.20.920.20:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77211, NULL, 'G3DSA:2.170.130.10:FF:000063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77212, NULL, 'G3DSA:3.30.160.60:FF:003672', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77213, NULL, 'G3DSA:1.20.1270.60:FF:000007', NULL, NULL, 'Bridging integrator 1, isoform CRA_e', NULL, NULL, NULL, NULL, NULL, 4),
(77214, NULL, 'G3DSA:3.100.10.10:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77215, NULL, 'G3DSA:2.160.20.10:FF:000198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77216, NULL, 'G3DSA:3.80.10.10:FF:000137', NULL, NULL, 'Toll-like receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(77217, NULL, 'G3DSA:3.30.70.330:FF:002468', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77218, NULL, 'G3DSA:3.90.70.10:FF:000388', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 16, putative', NULL, NULL, NULL, NULL, NULL, 4),
(77219, NULL, 'G3DSA:1.10.510.10:FF:000965', NULL, NULL, 'Putative Raf proto-oncogene serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(77220, NULL, 'G3DSA:1.10.510.10:FF:001038', NULL, NULL, 'Serine/threonine-protein kinase AKL1', NULL, NULL, NULL, NULL, NULL, 4),
(77221, NULL, 'G3DSA:3.30.200.20:FF:001820', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77222, NULL, 'G3DSA:2.60.40.10:FF:004908', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77223, NULL, 'G3DSA:3.20.20.80:FF:000515', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77224, NULL, 'G3DSA:1.25.40.180:FF:000165', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77225, NULL, 'G3DSA:3.40.47.10:FF:000179', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77226, NULL, 'G3DSA:1.25.40.10:FF:001428', NULL, NULL, 'Tetratricopeptide repeat protein 19, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(77227, NULL, 'G3DSA:3.20.20.70:FF:000512', NULL, NULL, 'Hydroxymethylglutaryl-CoA lyase', NULL, NULL, NULL, NULL, NULL, 4),
(77228, NULL, 'G3DSA:3.30.750.24:FF:000130', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(77229, NULL, 'G3DSA:1.10.150.20:FF:000069', NULL, NULL, 'Exonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(77230, NULL, 'G3DSA:3.40.50.150:FF:000974', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77231, NULL, 'G3DSA:3.30.160.60:FF:005324', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77232, NULL, 'G3DSA:3.20.20.30:FF:000017', NULL, NULL, 'Possible oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(77233, NULL, 'G3DSA:3.40.50.620:FF:000840', NULL, NULL, 'Bll4756 protein', NULL, NULL, NULL, NULL, NULL, 4),
(77234, NULL, 'G3DSA:3.40.50.2000:FF:000500', NULL, NULL, 'ADP-heptose-lipo oligosaccharide heptosyl transferase II', NULL, NULL, NULL, NULL, NULL, 4),
(77235, NULL, 'G3DSA:1.10.150.910:FF:000013', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77236, NULL, 'G3DSA:3.40.30.10:FF:001068', NULL, NULL, 'Chromosome 12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(77237, NULL, 'G3DSA:1.10.510.10:FF:003129', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77238, NULL, 'G3DSA:3.20.20.20:FF:000014', NULL, NULL, 'Folic acid synthesis protein fol1', NULL, NULL, NULL, NULL, NULL, 4),
(77239, NULL, 'G3DSA:3.40.50.1820:FF:000305', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(77240, NULL, 'G3DSA:2.10.110.10:FF:000318', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(77241, NULL, 'G3DSA:1.20.5.370:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77242, NULL, 'G3DSA:2.20.25.80:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77243, NULL, 'G3DSA:3.10.450.50:FF:000054', NULL, NULL, 'Nuclear RNA export factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(77244, NULL, 'G3DSA:3.40.50.300:FF:002599', NULL, NULL, 'Protein CHROMATIN REMODELING 19 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(77245, NULL, 'G3DSA:1.20.20.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77246, NULL, 'G3DSA:3.10.350.10:FF:000028', NULL, NULL, 'Peptidoglycan-binding protein LysM', NULL, NULL, NULL, NULL, NULL, 4),
(77247, NULL, 'G3DSA:3.40.50.1820:FF:000249', NULL, NULL, 'Polyketide synthase Pks13', NULL, NULL, NULL, NULL, NULL, 4),
(77248, NULL, 'G3DSA:3.40.50.10490:FF:000027', NULL, NULL, 'HTH-type transcriptional regulator rpiR', NULL, NULL, NULL, NULL, NULL, 4),
(77249, NULL, 'G3DSA:1.20.5.350:FF:000012', NULL, NULL, 'Troponin I', NULL, NULL, NULL, NULL, NULL, 4),
(77250, NULL, 'G3DSA:1.10.260.40:FF:000061', NULL, NULL, 'DNA transposition protein (GpB)', NULL, NULL, NULL, NULL, NULL, 4),
(77251, NULL, 'G3DSA:3.30.1240.10:FF:000077', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77252, NULL, 'G3DSA:2.60.40.10:FF:003127', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77253, NULL, 'G3DSA:1.10.510.10:FF:002819', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77254, NULL, 'G3DSA:1.10.8.60:FF:000153', NULL, NULL, 'Peroxisome biogenesis protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(77255, NULL, 'G3DSA:3.20.20.10:FF:000011', NULL, NULL, 'Pyridoxal phosphate homeostasis protein', NULL, NULL, NULL, NULL, NULL, 4),
(77256, NULL, 'G3DSA:2.30.42.10:FF:000513', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77257, NULL, 'G3DSA:3.40.50.11260:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77258, NULL, 'G3DSA:3.40.50.720:FF:002219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77259, NULL, 'G3DSA:1.10.472.10:FF:000595', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77260, NULL, 'G3DSA:2.170.140.10:FF:000035', NULL, NULL, 'GM22243', NULL, NULL, NULL, NULL, NULL, 4),
(77261, NULL, 'G3DSA:2.60.40.10:FF:001513', NULL, NULL, 'Protein PTST, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(77262, NULL, 'G3DSA:1.20.900.10:FF:000015', NULL, NULL, 'son of sevenless homolog 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(77263, NULL, 'G3DSA:2.30.42.10:FF:000193', NULL, NULL, 'Syntrophin gamma 1', NULL, NULL, NULL, NULL, NULL, 4),
(77264, NULL, 'G3DSA:1.20.5.190:FF:000144', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77265, NULL, 'G3DSA:3.40.50.720:FF:000605', NULL, NULL, 'Glyoxylate/hydroxypyruvate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(77266, NULL, 'G3DSA:1.20.58.60:FF:000264', NULL, NULL, 'Microtubule-actin cross-linking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(77267, NULL, 'G3DSA:3.30.70.270:FF:000191', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77268, NULL, 'G3DSA:1.10.238.10:FF:001175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77269, NULL, 'G3DSA:3.40.50.300:FF:006668', NULL, NULL, 'Putative G10 domain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(77270, NULL, 'G3DSA:2.60.120.260:FF:000480', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77271, NULL, 'G3DSA:3.30.750.24:FF:000074', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(77272, NULL, 'G3DSA:3.30.1330.40:FF:000065', NULL, NULL, 'AGL164Wp', NULL, NULL, NULL, NULL, NULL, 4),
(77273, NULL, 'G3DSA:1.10.3500.10:FF:000025', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(77274, NULL, 'G3DSA:1.25.40.1030:FF:000001', NULL, NULL, 'protein transport protein Sec31A isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(77275, NULL, 'G3DSA:1.25.40.1050:FF:000007', NULL, NULL, 'Putative 5''-3'' exonuclease', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(77276, NULL, 'G3DSA:3.30.470.20:FF:000058', NULL, NULL, 'Alpha-aminoadipate--LysW ligase LysX protein', NULL, NULL, NULL, NULL, NULL, 4),
(77277, NULL, 'G3DSA:3.10.110.10:FF:000247', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(77278, NULL, 'G3DSA:3.30.750.44:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77279, NULL, 'G3DSA:1.10.10.160:FF:000040', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(77280, NULL, 'G3DSA:2.10.25.10:FF:001672', NULL, NULL, 'AGAP006732-PA', NULL, NULL, NULL, NULL, NULL, 4),
(77281, NULL, 'G3DSA:3.40.50.450:FF:000002', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(77282, NULL, 'G3DSA:1.10.8.740:FF:000002', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(77283, NULL, 'G3DSA:2.130.10.10:FF:001637', NULL, NULL, 'Dynein, cytoplasmic 1, intermediate chain 2a', NULL, NULL, NULL, NULL, NULL, 4),
(77284, NULL, 'G3DSA:2.60.40.10:FF:001036', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(77285, NULL, 'G3DSA:1.10.1200.10:FF:000013', NULL, NULL, 'Fatty acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(77286, NULL, 'G3DSA:3.30.1330.30:FF:000062', NULL, NULL, 'Putative H/ACA ribonucleoprotein complex subunit 2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(77287, NULL, 'G3DSA:3.30.230.10:FF:000274', NULL, NULL, 'Phosphomevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(77288, NULL, 'G3DSA:1.25.40.1040:FF:000004', NULL, NULL, 'N-alpha-acetyltransferase 25, NatB auxiliary subunit', NULL, NULL, NULL, NULL, NULL, 4),
(77289, NULL, 'G3DSA:2.60.40.420:FF:000125', NULL, NULL, 'Laccase 2', NULL, NULL, NULL, NULL, NULL, 4),
(77290, NULL, 'G3DSA:2.130.10.10:FF:004982', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77291, NULL, 'G3DSA:1.10.1220.10:FF:000020', NULL, NULL, 'Bifunctional antitoxin/transcriptional repressor RelB', NULL, NULL, NULL, NULL, NULL, 4),
(77292, NULL, 'G3DSA:1.10.10.10:FF:001128', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(77293, NULL, 'G3DSA:3.40.366.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77294, NULL, 'G3DSA:1.50.10.20:FF:000056', NULL, NULL, 'Terpene cyclase/mutase family member', NULL, NULL, NULL, NULL, NULL, 4),
(77295, NULL, 'G3DSA:2.30.30.40:FF:000394', NULL, NULL, 'Proline-serine-threonine phosphatase-interacting protein 1b', NULL, NULL, NULL, NULL, NULL, 4),
(77296, NULL, 'G3DSA:3.90.660.10:FF:000130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77297, NULL, 'G3DSA:3.90.650.10:FF:000016', NULL, NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(77298, NULL, 'G3DSA:3.40.390.10:FF:000171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77299, NULL, 'G3DSA:3.30.40.10:FF:000669', NULL, NULL, 'Acyl-CoA N-acyltransferase with RING/FYVE/PHD-type zinc finger domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(77300, NULL, 'G3DSA:2.60.40.10:FF:003604', NULL, NULL, 'Junctional adhesion molecule 2a', NULL, NULL, NULL, NULL, NULL, 4),
(77301, NULL, 'G3DSA:3.30.70.330:FF:000579', NULL, NULL, '30S ribosomal protein 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(77302, NULL, 'G3DSA:2.40.50.140:FF:000565', NULL, NULL, 'Exosome complex exonuclease RRP44, putative', NULL, NULL, NULL, NULL, NULL, 4),
(77303, NULL, 'G3DSA:1.10.2010.10:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77304, NULL, 'G3DSA:3.30.40.10:FF:001597', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(77305, NULL, 'G3DSA:3.30.300.30:FF:000050', NULL, NULL, 'Fatty-acid-CoA ligase FadD34', NULL, NULL, NULL, NULL, NULL, 4),
(77306, NULL, 'G3DSA:1.10.287.920:FF:000009', NULL, NULL, 'Alpha-factor pheromone receptor', NULL, NULL, NULL, NULL, NULL, 4),
(77307, NULL, 'G3DSA:3.30.70.330:FF:002794', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77308, NULL, 'G3DSA:1.20.1740.10:FF:000265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(77309, NULL, 'G3DSA:3.40.50.300:FF:003442', NULL, NULL, 'ESX-4 secretion system protein EccC4', NULL, NULL, NULL, NULL, NULL, 4),
(77310, NULL, 'G3DSA:3.90.78.10:FF:000001', NULL, NULL, 'UDP-N-acetylenolpyruvoylglucosamine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(77311, NULL, 'G3DSA:1.25.40.10:FF:001226', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g03580', NULL, NULL, NULL, NULL, NULL, 4),
(77312, NULL, 'G3DSA:2.20.25.10:FF:000098', NULL, NULL, 'Putative conserved secreted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77313, NULL, 'G3DSA:3.80.10.10:FF:003482', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77314, NULL, 'G3DSA:2.60.40.2320:FF:000002', NULL, NULL, '1,4-alpha-glucan branching enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(77315, NULL, 'G3DSA:1.20.1560.10:FF:000228', NULL, NULL, 'p-GlycoProtein related', NULL, NULL, NULL, NULL, NULL, 4),
(77316, NULL, 'G3DSA:3.40.50.300:FF:008585', NULL, NULL, 'ATPase, AAA superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(77317, NULL, 'G3DSA:1.20.91.20:FF:000008', NULL, NULL, 'Complement component 4', NULL, NULL, NULL, NULL, NULL, 4),
(77318, NULL, 'G3DSA:2.10.50.10:FF:000050', NULL, NULL, 'Cysteine repeat modular protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(77319, NULL, 'G3DSA:1.20.1250.20:FF:000371', NULL, NULL, 'H(+) MyoInositol coTransporter', NULL, NULL, NULL, NULL, NULL, 4),
(77320, NULL, 'G3DSA:2.60.120.260:FF:000654', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(77321, NULL, 'G3DSA:3.40.50.720:FF:001882', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77322, NULL, 'G3DSA:2.10.90.10:FF:000052', NULL, NULL, 'Bone morphogenetic protein', NULL, NULL, NULL, NULL, NULL, 4),
(77323, NULL, 'G3DSA:1.10.340.70:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77324, NULL, 'G3DSA:1.25.10.10:FF:003164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77325, NULL, 'G3DSA:3.30.465.10:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77326, NULL, 'G3DSA:1.25.40.20:FF:001701', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(77327, NULL, 'G3DSA:3.90.70.80:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77328, NULL, 'G3DSA:3.30.470.30:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77329, NULL, 'G3DSA:1.25.10.10:FF:003315', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(77330, NULL, 'G3DSA:1.25.10.10:FF:000584', NULL, NULL, 'V-type proton ATPase subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(77331, NULL, 'G3DSA:3.40.50.2300:FF:000146', NULL, NULL, 'Putative two-component response regulator SSK1p', NULL, NULL, NULL, NULL, NULL, 4),
(77332, NULL, 'G3DSA:3.50.30.30:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77333, NULL, 'G3DSA:1.10.510.10:FF:004383', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77334, NULL, 'G3DSA:1.20.120.20:FF:000020', NULL, NULL, 'Apolipoprotein E', NULL, NULL, NULL, NULL, NULL, 4),
(77335, NULL, 'G3DSA:2.120.10.30:FF:000475', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77336, NULL, 'G3DSA:3.30.572.10:FF:000011', NULL, NULL, 'Bifunctional dihydrofolate reductase-thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(77337, NULL, 'G3DSA:3.80.10.10:FF:000463', NULL, NULL, 'EIN3-binding F-box protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(77338, NULL, 'G3DSA:3.30.160.60:FF:001255', NULL, NULL, 'Zinc finger protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(77339, NULL, 'G3DSA:3.30.70.1450:FF:000040', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77340, NULL, 'G3DSA:3.40.850.10:FF:000251', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(77341, NULL, 'G3DSA:3.90.640.10:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77342, NULL, 'G3DSA:2.40.50.140:FF:000621', NULL, NULL, 'BRCA2, oligonucleotide/oligosaccharide-binding, domain 1 protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(77343, NULL, 'G3DSA:3.30.230.10:FF:000330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77344, NULL, 'G3DSA:3.30.300.70:FF:000005', NULL, NULL, 'Ribosome maturation factor RimP', NULL, NULL, NULL, NULL, NULL, 4),
(77345, NULL, 'G3DSA:1.20.5.170:FF:000082', NULL, NULL, 'Cell death specification', NULL, NULL, NULL, NULL, NULL, 4),
(77346, NULL, 'G3DSA:3.80.10.10:FF:002554', NULL, NULL, 'Nuclear export factor 3, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(77347, NULL, 'G3DSA:3.40.50.300:FF:006022', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77348, NULL, 'G3DSA:1.20.1280.290:FF:000069', NULL, NULL, 'Sugar transporter SWEET1', NULL, NULL, NULL, NULL, NULL, 4),
(77349, NULL, 'G3DSA:2.60.220.50:FF:000142', NULL, NULL, 'G-protein coupled receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(77350, NULL, 'G3DSA:3.30.470.10:FF:000022', NULL, NULL, 'Branched-chain amino acid aminotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(77351, NULL, 'G3DSA:3.90.25.10:FF:000053', NULL, NULL, 'NAD(P)-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(77352, NULL, 'G3DSA:3.40.50.200:FF:000034', NULL, NULL, 'Proline rich membrane-anchored mycosin', NULL, NULL, NULL, NULL, NULL, 4),
(77353, NULL, 'G3DSA:3.30.420.10:FF:000018', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(77354, NULL, 'G3DSA:3.40.50.300:FF:001817', NULL, NULL, 'Primosome assembly protein PriA', NULL, NULL, NULL, NULL, NULL, 4),
(77355, NULL, 'G3DSA:1.10.1520.10:FF:000032', NULL, NULL, 'Dicer-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(77356, NULL, 'G3DSA:3.40.50.80:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77357, NULL, 'G3DSA:1.10.167.10:FF:000020', NULL, NULL, 'Regulator of G protein signaling 22', NULL, NULL, NULL, NULL, NULL, 4),
(77358, NULL, 'G3DSA:2.130.10.30:FF:000070', NULL, NULL, 'SD05384p', NULL, NULL, NULL, NULL, NULL, 4),
(77359, NULL, 'G3DSA:3.40.50.300:FF:005089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77360, NULL, 'G3DSA:1.25.40.20:FF:000122', NULL, NULL, 'ankyrin repeat domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(77361, NULL, 'G3DSA:1.10.10.10:FF:001600', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77362, NULL, 'G3DSA:3.10.129.10:FF:000037', NULL, NULL, 'acyl-acyl carrier protein thioesterase ATL3, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(77363, NULL, 'G3DSA:3.30.160.60:FF:003200', NULL, NULL, 'GM26321', NULL, NULL, NULL, NULL, NULL, 4),
(77364, NULL, 'G3DSA:3.30.930.10:FF:000102', NULL, NULL, 'Bifunctional ligase/repressor BirA', NULL, NULL, NULL, NULL, NULL, 4),
(77365, NULL, 'G3DSA:1.20.1070.10:FF:000270', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(77366, NULL, 'G3DSA:3.40.50.720:FF:002371', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77367, NULL, 'G3DSA:3.10.20.90:FF:000659', NULL, NULL, 'Ubiquitin fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(77368, NULL, 'G3DSA:3.40.50.150:FF:001340', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77369, NULL, 'G3DSA:3.40.50.300:FF:007124', NULL, NULL, 'Guanylate kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(77370, NULL, 'G3DSA:3.40.50.12780:FF:000001', NULL, NULL, 'Acetyl-coenzyme A synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(77371, NULL, 'G3DSA:1.10.1520.10:FF:000060', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77372, NULL, 'G3DSA:1.20.1070.10:FF:000646', NULL, NULL, 'Olfactory receptor 887', NULL, NULL, NULL, NULL, NULL, 4),
(77373, NULL, 'G3DSA:3.30.160.60:FF:003346', NULL, NULL, 'Zinc finger protein 846', NULL, NULL, NULL, NULL, NULL, 4),
(77374, NULL, 'G3DSA:3.20.20.80:FF:000341', NULL, NULL, 'Maltooligosyl trehalose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(77375, NULL, 'G3DSA:1.20.5.190:FF:000088', NULL, NULL, 'Myosin', NULL, NULL, NULL, NULL, NULL, 4),
(77376, NULL, 'G3DSA:2.20.100.10:FF:000208', NULL, NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif, 6', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(77377, NULL, 'G3DSA:2.60.40.150:FF:000786', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77378, NULL, 'G3DSA:3.10.50.10:FF:000070', NULL, NULL, 'CHItinase-Like', NULL, NULL, NULL, NULL, NULL, 4),
(77379, NULL, 'G3DSA:3.30.2090.10:FF:000014', NULL, NULL, 'Putative multidrug resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(77380, NULL, 'G3DSA:3.60.110.10:FF:000022', NULL, NULL, 'Formamidase', NULL, NULL, NULL, NULL, NULL, 4),
(77381, NULL, 'G3DSA:3.40.50.11610:FF:000010', NULL, NULL, 'Oxoglutarate dehydrogenase (Succinyl-transferring), E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(77382, NULL, 'G3DSA:3.30.70.330:FF:002524', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77383, NULL, 'G3DSA:1.25.40.10:FF:004447', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77384, NULL, 'G3DSA:1.10.510.10:FF:003601', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77385, NULL, 'G3DSA:2.60.40.10:FF:005370', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77386, NULL, 'G3DSA:3.30.1050.10:FF:000012', NULL, NULL, 'Eucalyptus, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(77387, NULL, 'G3DSA:3.30.710.10:FF:000114', NULL, NULL, 'potassium channel regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(77388, NULL, 'G3DSA:1.10.510.10:FF:003281', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77389, NULL, 'G3DSA:3.40.50.300:FF:002829', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77390, NULL, 'G3DSA:3.40.50.2000:FF:000382', NULL, NULL, 'Protein CBR-BUS-8', NULL, NULL, NULL, NULL, NULL, 4),
(77391, NULL, 'G3DSA:3.30.160.60:FF:004976', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77392, NULL, 'G3DSA:2.10.310.10:FF:000002', NULL, NULL, 'Serin peptidase inhibitor, clade A (Alpha-1 antiproteinase, antitrypsin)-like', NULL, NULL, NULL, NULL, NULL, 4),
(77393, NULL, 'G3DSA:2.30.29.30:FF:000174', NULL, NULL, 'epidermal growth factor receptor kinase substrate 8', NULL, NULL, NULL, NULL, NULL, 4),
(77394, NULL, 'G3DSA:3.40.640.10:FF:000179', NULL, NULL, 'Aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(77395, NULL, 'G3DSA:3.40.50.1820:FF:000631', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(77396, NULL, 'G3DSA:3.40.50.2000:FF:000702', NULL, NULL, 'DUF3492 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(77397, NULL, 'G3DSA:2.60.120.260:FF:000098', NULL, NULL, 'Netrin-A, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(77398, NULL, 'G3DSA:3.30.428.10:FF:000047', NULL, NULL, 'Probable HIT family protein', NULL, NULL, NULL, NULL, NULL, 4),
(77399, NULL, 'G3DSA:1.25.40.20:FF:001229', NULL, NULL, 'Ankyrin repeat and KH domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(77400, NULL, 'G3DSA:2.40.50.140:FF:000065', NULL, NULL, 'Single-stranded DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(77401, NULL, 'G3DSA:3.30.160.60:FF:002885', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77402, NULL, 'G3DSA:3.60.10.10:FF:000273', NULL, NULL, 'Inositol 5-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(77403, NULL, 'G3DSA:3.30.70.1730:FF:000056', NULL, NULL, '60S acidic ribosomal protein P0', NULL, NULL, NULL, NULL, NULL, 4),
(77404, NULL, 'G3DSA:2.40.30.170:FF:000036', NULL, NULL, 'Resistance-Nodulation-Cell Division (RND) multidrug efflux membrane fusion protein MexC', NULL, NULL, NULL, NULL, NULL, 4),
(77405, NULL, 'G3DSA:3.10.10.10:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77406, NULL, 'G3DSA:1.20.1560.10:FF:000318', NULL, NULL, 'Multidrug ABC transporter ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(77407, NULL, 'G3DSA:3.30.200.20:FF:000836', NULL, NULL, 'NEK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(77408, NULL, 'G3DSA:2.40.50.140:FF:000593', NULL, NULL, 'Protein OSB1 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(77409, NULL, 'G3DSA:3.50.50.60:FF:000678', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(77410, NULL, 'G3DSA:3.30.230.10:FF:000335', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(77411, NULL, 'G3DSA:3.30.40.10:FF:000523', NULL, NULL, 'RING finger protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(77412, NULL, 'G3DSA:3.40.910.10:FF:000020', NULL, NULL, 'Probable deoxyhypusine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(77413, NULL, 'G3DSA:4.10.60.10:FF:000057', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(77414, NULL, 'G3DSA:1.10.510.10:FF:001454', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(77415, NULL, 'G3DSA:3.80.10.10:FF:002352', NULL, NULL, 'Receptor like protein 28', NULL, NULL, NULL, NULL, NULL, 4),
(77416, NULL, 'G3DSA:3.40.850.10:FF:000397', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(77417, NULL, 'G3DSA:1.25.10.10:FF:003169', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77418, NULL, 'G3DSA:1.20.1250.20:FF:000747', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(77419, NULL, 'G3DSA:1.25.10.10:FF:002854', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77420, NULL, 'G3DSA:2.130.10.10:FF:004712', NULL, NULL, 'Inner dynein arm I1 intermediate chain IC138', NULL, NULL, NULL, NULL, NULL, 4),
(77421, NULL, 'G3DSA:3.90.199.10:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77422, NULL, 'G3DSA:3.40.50.11060:FF:000002', NULL, NULL, 'GTP binding protein 6 (putative)', NULL, NULL, NULL, NULL, NULL, 4),
(77423, NULL, 'G3DSA:1.20.1560.10:FF:000026', NULL, NULL, 'Multidrug resistance-associated protein lethal(2)03659', NULL, NULL, NULL, NULL, NULL, 4),
(77424, NULL, 'G3DSA:3.30.450.20:FF:000321', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(77425, NULL, 'G3DSA:3.50.50.60:FF:000734', NULL, NULL, 'FAD-dependent pyridine nucleotide-disulphide oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(77426, NULL, 'G3DSA:1.25.10.10:FF:003225', NULL, NULL, 'Protein SERAC1', NULL, NULL, NULL, NULL, NULL, 4),
(77427, NULL, 'G3DSA:2.40.50.140:FF:000711', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77428, NULL, 'G3DSA:2.30.29.30:FF:000264', NULL, NULL, 'Potential exocyst complex component Exo84', NULL, NULL, NULL, NULL, NULL, 4),
(77429, NULL, 'G3DSA:3.80.10.10:FF:002880', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77430, NULL, 'G3DSA:3.30.40.10:FF:001799', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77431, NULL, 'G3DSA:1.25.40.710:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77432, NULL, 'G3DSA:1.25.40.10:FF:002356', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(77433, NULL, 'G3DSA:3.40.220.10:FF:000041', NULL, NULL, 'Transcription factor bHLH140', NULL, NULL, NULL, NULL, NULL, 4),
(77434, NULL, 'G3DSA:3.90.980.10:FF:000002', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(77435, NULL, 'G3DSA:1.20.1560.10:FF:000521', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(77436, NULL, 'G3DSA:1.10.3810.10:FF:000009', NULL, NULL, 'Penicillin-binding protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(77437, NULL, 'G3DSA:2.130.10.10:FF:004656', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77438, NULL, 'G3DSA:3.50.50.60:FF:000881', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77439, NULL, 'G3DSA:3.80.10.10:FF:002700', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77440, NULL, 'G3DSA:3.30.70.20:FF:000028', NULL, NULL, 'Electron transport protein hydN', NULL, NULL, NULL, NULL, NULL, 4),
(77441, NULL, 'G3DSA:1.10.238.10:FF:000388', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(77442, NULL, 'G3DSA:2.130.10.10:FF:004892', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77443, NULL, 'G3DSA:1.10.1530.10:FF:000004', NULL, NULL, 'Ureidoglycolate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(77444, NULL, 'G3DSA:3.30.710.10:FF:000086', NULL, NULL, 'Ankyrin repeat and FYVE domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(77445, NULL, 'G3DSA:1.25.40.20:FF:000892', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77446, NULL, 'G3DSA:1.20.1070.10:FF:001579', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77447, NULL, 'G3DSA:3.40.50.10190:FF:000027', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(77448, NULL, 'G3DSA:1.20.1270.60:FF:000002', NULL, NULL, 'Formin-binding protein 1-like isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(77449, NULL, 'G3DSA:2.60.120.10:FF:000206', NULL, NULL, 'Blood vessel epicardial substance', NULL, NULL, NULL, NULL, NULL, 4),
(77450, NULL, 'G3DSA:1.10.238.10:FF:001085', NULL, NULL, 'Fimbrin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(77451, NULL, 'G3DSA:3.60.21.70:FF:000001', NULL, NULL, 'Alkaline phosphatase D', NULL, NULL, NULL, NULL, NULL, 4),
(77452, NULL, 'G3DSA:1.25.10.10:FF:001224', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(77453, NULL, 'G3DSA:1.10.150.50:FF:000145', NULL, NULL, 'GH09064p', NULL, NULL, NULL, NULL, NULL, 4),
(77454, NULL, 'G3DSA:3.40.50.1820:FF:000721', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(77455, NULL, 'G3DSA:2.20.100.10:FF:000181', NULL, NULL, 'Protein CBR-MIG-6', NULL, NULL, NULL, NULL, NULL, 4),
(77456, NULL, 'G3DSA:2.130.10.10:FF:004364', NULL, NULL, 'UV-damaged DNA binding complex subunit 2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(77457, NULL, 'G3DSA:2.30.40.10:FF:000003', NULL, NULL, 'Guanine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(77458, NULL, 'G3DSA:2.60.40.2020:FF:000002', NULL, NULL, 'Inhibitor of cysteine proteases', NULL, NULL, NULL, NULL, NULL, 4),
(77459, NULL, 'G3DSA:4.10.240.10:FF:000224', NULL, NULL, 'Uncharacterized transcriptional regulatory protein C1F7.11c', NULL, NULL, NULL, NULL, NULL, 4),
(77460, NULL, 'G3DSA:1.50.10.10:FF:000143', NULL, NULL, 'Glycogen debranching enzyme-related protein (4-alpha-glucanotransferase)', NULL, NULL, NULL, NULL, NULL, 4),
(77461, NULL, 'G3DSA:1.10.640.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77462, NULL, 'G3DSA:3.30.70.920:FF:000043', NULL, NULL, 'Leucine-responsive regulatory protein [Lrp]', NULL, NULL, NULL, NULL, NULL, 4),
(77463, NULL, 'G3DSA:3.40.50.2300:FF:000674', NULL, NULL, 'Putative Metabotropic glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(77464, NULL, 'G3DSA:2.130.10.10:FF:003262', NULL, NULL, 'Periodic tryptophan protein 2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(77465, NULL, 'G3DSA:3.30.780.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77466, NULL, 'G3DSA:1.20.1070.10:FF:000118', NULL, NULL, 'Adhesion G protein-coupled receptor A3', NULL, NULL, NULL, NULL, NULL, 4),
(77467, NULL, 'G3DSA:2.40.30.70:FF:000008', NULL, NULL, 'tRNA (N6-threonylcarbamoyladenosine(37)-N6)-methyltransferase TrmO', NULL, NULL, NULL, NULL, NULL, 4),
(77468, NULL, 'G3DSA:3.30.230.130:FF:000039', NULL, NULL, 'Os03g0786800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(77469, NULL, 'G3DSA:3.40.190.10:FF:000548', NULL, NULL, 'AGAP010411-PA', NULL, NULL, NULL, NULL, NULL, 4),
(77470, NULL, 'G3DSA:2.60.40.10:FF:000024', NULL, NULL, 'Tenascin-X', NULL, NULL, NULL, NULL, NULL, 4),
(77471, NULL, 'G3DSA:2.20.100.10:FF:000118', NULL, NULL, 'No long nerve cord, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(77472, NULL, 'G3DSA:2.60.40.150:FF:000696', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77473, NULL, 'G3DSA:1.25.40.280:FF:000021', NULL, NULL, 'pH-response regulator protein palA/rim20', NULL, NULL, NULL, NULL, NULL, 4),
(77474, NULL, 'G3DSA:3.90.1170.50:FF:000002', NULL, NULL, 'Xanthine dehydrogenase/oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(77475, NULL, 'G3DSA:2.60.40.60:FF:001118', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77476, NULL, 'G3DSA:3.40.50.2300:FF:000348', NULL, NULL, 'Response regulator receiver domain protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(77477, NULL, 'G3DSA:1.20.1440.100:FF:000010', NULL, NULL, 'Phosphoserine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(77478, NULL, 'G3DSA:3.40.50.150:FF:001430', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77479, NULL, 'G3DSA:3.90.640.10:FF:000246', NULL, NULL, 'AGR099Cp', NULL, NULL, NULL, NULL, NULL, 4),
(77480, NULL, 'G3DSA:3.40.50.1220:FF:000018', NULL, NULL, 'Pyruvate decarboxylase isozyme', NULL, NULL, NULL, NULL, NULL, 4),
(77481, NULL, 'G3DSA:3.90.380.10:FF:000001', NULL, NULL, '3-phenylpropionate/cinnamic acid dioxygenase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(77482, NULL, 'G3DSA:3.40.640.10:FF:000269', NULL, NULL, 'Capreomycidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(77483, NULL, 'G3DSA:2.60.120.430:FF:000025', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(77484, NULL, 'G3DSA:3.40.50.1820:FF:000075', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(77485, NULL, 'G3DSA:1.25.10.10:FF:001371', NULL, NULL, 'WGS project CABT00000000 data, contig 2.9', NULL, NULL, NULL, NULL, NULL, 4),
(77486, NULL, 'G3DSA:3.90.70.10:FF:000298', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 13', NULL, NULL, NULL, NULL, NULL, 4),
(77487, NULL, 'G3DSA:1.20.1560.10:FF:000700', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77488, NULL, 'G3DSA:3.40.50.2000:FF:000028', NULL, NULL, 'Glycogen [starch] synthase', NULL, NULL, NULL, NULL, NULL, 4),
(77489, NULL, 'G3DSA:2.40.50.730:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77490, NULL, 'G3DSA:2.130.10.10:FF:004566', NULL, NULL, 'ACR190Cp', NULL, NULL, NULL, NULL, NULL, 4),
(77491, NULL, 'G3DSA:2.40.70.10:FF:000454', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77492, NULL, 'G3DSA:3.90.1150.10:FF:000449', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77493, NULL, 'G3DSA:1.10.630.10:FF:000092', NULL, NULL, 'Cytochrome P450 CYP727A4', NULL, NULL, NULL, NULL, NULL, 4),
(77494, NULL, 'G3DSA:1.20.58.1480:FF:000023', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(77495, NULL, 'G3DSA:3.20.20.300:FF:000063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77496, NULL, 'G3DSA:3.40.1010.20:FF:000004', NULL, NULL, '4-hydroxy-3-methylbut-2-enyl diphosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(77497, NULL, 'G3DSA:3.40.50.1000:FF:000211', NULL, NULL, 'Plasma membrane ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(77498, NULL, 'G3DSA:1.20.120.850:FF:000037', NULL, NULL, 'DNA-dependent ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(77499, NULL, 'G3DSA:3.30.160.60:FF:003902', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77500, NULL, 'G3DSA:3.30.420.40:FF:000825', NULL, NULL, 'ADL253Cp', NULL, NULL, NULL, NULL, NULL, 4),
(77501, NULL, 'G3DSA:1.25.40.80:FF:000005', NULL, NULL, 'Deoxyribodipyrimidine photo-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(77502, NULL, 'G3DSA:1.20.120.1200:FF:000026', NULL, NULL, 'NADH dehydrogenase subunit J', NULL, NULL, NULL, NULL, NULL, 4),
(77503, NULL, 'G3DSA:1.10.760.10:FF:000039', NULL, NULL, 'Thiosulfate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(77504, NULL, 'G3DSA:2.60.450.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77505, NULL, 'G3DSA:1.25.40.70:FF:000002', NULL, NULL, 'Phosphatidylinositol 4-kinase, catalytic, alpha', NULL, NULL, NULL, NULL, NULL, 4),
(77506, NULL, 'G3DSA:3.40.50.1820:FF:000103', NULL, NULL, 'Abhydrolase domain-containing 15', NULL, NULL, NULL, NULL, NULL, 4),
(77507, NULL, 'G3DSA:3.30.200.20:FF:002074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77508, NULL, 'G3DSA:3.50.50.60:FF:001044', NULL, NULL, 'Guanosine nucleotide diphosphate dissociation inhibitor 2', NULL, NULL, NULL, NULL, NULL, 4),
(77509, NULL, 'G3DSA:3.40.50.2000:FF:000646', NULL, NULL, 'UDP-glycosyltransferase 85A7', NULL, NULL, NULL, NULL, NULL, 4),
(77510, NULL, 'G3DSA:3.30.40.230:FF:000004', NULL, NULL, 'Glycine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(77511, NULL, 'G3DSA:1.10.20.10:FF:000376', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77512, NULL, 'G3DSA:1.10.510.10:FF:001364', NULL, NULL, 'Meiosis-specific serine/threonine protein kinase MEK1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(77513, NULL, 'G3DSA:2.130.10.10:FF:005055', NULL, NULL, 'CDT (S. pombe CDC10 Dependent Transcript) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(77514, NULL, 'G3DSA:1.25.40.20:FF:001757', NULL, NULL, 'YALI0E32791p', NULL, NULL, NULL, NULL, NULL, 4),
(77515, NULL, 'G3DSA:3.40.50.1010:FF:000214', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77516, NULL, 'G3DSA:3.30.60.90:FF:000003', NULL, NULL, 'E1A binding protein p300', NULL, NULL, NULL, NULL, NULL, 4),
(77517, NULL, 'G3DSA:3.40.50.300:FF:001492', NULL, NULL, 'ABC transporter ATP-binding protein/permease', NULL, NULL, NULL, NULL, NULL, 4),
(77518, NULL, 'G3DSA:3.50.50.60:FF:000408', NULL, NULL, 'Guanosine nucleotide diphosphate dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(77519, NULL, 'G3DSA:1.10.287.70:FF:000226', NULL, NULL, 'pH-gated potassium channel KcsA', NULL, NULL, NULL, NULL, NULL, 4),
(77520, NULL, 'G3DSA:1.20.1250.20:FF:001349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77521, NULL, 'G3DSA:1.10.1660.10:FF:000008', NULL, NULL, 'Heat shock transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(77522, NULL, 'G3DSA:3.30.200.20:FF:001146', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(77523, NULL, 'G3DSA:1.20.1560.10:FF:000644', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77524, NULL, 'G3DSA:2.160.20.10:FF:000226', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77525, NULL, 'G3DSA:3.30.200.20:FF:002422', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77526, NULL, 'G3DSA:2.60.40.420:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77527, NULL, 'G3DSA:3.30.160.60:FF:001429', NULL, NULL, 'neurotrophin receptor-interacting factor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(77528, NULL, 'G3DSA:3.30.1010.10:FF:000094', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', NULL, NULL, NULL, NULL, NULL, 4),
(77529, NULL, 'G3DSA:1.10.150.20:FF:000159', NULL, NULL, 'DNA polymerase lambda subunit', NULL, NULL, NULL, NULL, NULL, 4),
(77530, NULL, 'G3DSA:1.10.510.10:FF:001128', NULL, NULL, 'CRE-SEK-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(77531, NULL, 'G3DSA:1.25.10.10:FF:000909', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(77532, NULL, 'G3DSA:1.20.1510.10:FF:000080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77533, NULL, 'G3DSA:2.60.40.10:FF:001126', NULL, NULL, 'Anti-myosin immunoglobulin heavy chain variable region', NULL, NULL, NULL, NULL, NULL, 4),
(77534, NULL, 'G3DSA:1.10.238.10:FF:001231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77535, NULL, 'G3DSA:2.30.30.100:FF:000091', NULL, NULL, 'Enhancer of mRNA-decapping protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(77536, NULL, 'G3DSA:3.40.50.80:FF:000207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77537, NULL, 'G3DSA:1.10.10.60:FF:000839', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77538, NULL, 'G3DSA:3.30.160.60:FF:004835', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77539, NULL, 'G3DSA:1.25.40.180:FF:000137', NULL, NULL, 'MIF4G domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(77540, NULL, 'G3DSA:3.40.850.10:FF:000425', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77541, NULL, 'G3DSA:2.30.30.140:FF:000170', NULL, NULL, 'DNA (cytosine-5-)-methyltransferase 3 beta, duplicate a', NULL, NULL, NULL, NULL, NULL, 4),
(77542, NULL, 'G3DSA:1.10.150.810:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77543, NULL, 'G3DSA:1.25.40.10:FF:002682', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(77544, NULL, 'G3DSA:3.30.160.20:FF:000248', NULL, NULL, 'Double-stranded RNA-specific editase Adar-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(77545, NULL, 'G3DSA:1.20.1250.20:FF:000663', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(77546, NULL, 'G3DSA:3.80.10.10:FF:002026', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77547, NULL, 'G3DSA:1.10.3060.10:FF:000013', NULL, NULL, 'Protein translocase subunit SecA 2', NULL, NULL, NULL, NULL, NULL, 4),
(77548, NULL, 'G3DSA:4.10.1060.10:FF:000050', NULL, NULL, 'RAN binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(77549, NULL, 'G3DSA:3.40.50.720:FF:000426', NULL, NULL, 'Aldehyde reductase 2', NULL, NULL, NULL, NULL, NULL, 4),
(77550, NULL, 'G3DSA:3.40.50.720:FF:001909', NULL, NULL, 'UDP-galactopyranose mutase', NULL, NULL, NULL, NULL, NULL, 4),
(77551, NULL, 'G3DSA:2.60.40.150:FF:000814', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77552, NULL, 'G3DSA:2.60.120.290:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77553, NULL, 'G3DSA:2.30.140.10:FF:000012', NULL, NULL, 'Spermidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(77554, NULL, 'G3DSA:1.25.40.90:FF:000070', NULL, NULL, 'Putative mrna cleavage and polyadenylation factor i/ii complex subunit pcf11', NULL, NULL, NULL, NULL, NULL, 4),
(77555, NULL, 'G3DSA:2.20.100.10:FF:000034', NULL, NULL, 'Spondin-1', NULL, NULL, NULL, NULL, NULL, 4),
(77556, NULL, 'G3DSA:3.30.420.230:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77557, NULL, 'G3DSA:2.10.60.10:FF:000022', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(77558, NULL, 'G3DSA:2.60.40.2310:FF:000004', NULL, NULL, 'Subtilisin-like protease SBT3', NULL, NULL, NULL, NULL, NULL, 4),
(77559, NULL, 'G3DSA:3.30.1370.10:FF:000143', NULL, NULL, 'Partner of Nob1', NULL, NULL, NULL, NULL, NULL, 4),
(77560, NULL, 'G3DSA:1.25.10.10:FF:001308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77561, NULL, 'G3DSA:3.40.640.10:FF:000325', NULL, NULL, 'Alanine aminotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(77562, NULL, 'G3DSA:4.10.1000.10:FF:000007', NULL, NULL, 'Zinc finger CCCH domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(77563, NULL, 'G3DSA:2.60.40.10:FF:000873', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(77564, NULL, 'G3DSA:3.40.50.1820:FF:001379', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77565, NULL, 'G3DSA:3.30.2350.10:FF:000057', NULL, NULL, 'RNA pseudouridine synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(77566, NULL, 'G3DSA:3.10.180.10:FF:000049', NULL, NULL, 'Catechol 2,3-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(77567, NULL, 'G3DSA:3.10.450.40:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77568, NULL, 'G3DSA:2.10.25.10:FF:000093', NULL, NULL, 'Very low-density lipoprotein receptor', NULL, NULL, NULL, NULL, NULL, 4),
(77569, NULL, 'G3DSA:3.40.47.10:FF:000235', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77570, NULL, 'G3DSA:3.40.50.170:FF:000042', NULL, NULL, 'Os08g0501132 protein', NULL, NULL, NULL, NULL, NULL, 4),
(77571, NULL, 'G3DSA:3.40.50.150:FF:001514', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77572, NULL, 'G3DSA:1.20.58.60:FF:000820', NULL, NULL, 'Beta-spectrin', NULL, NULL, NULL, NULL, NULL, 4),
(77573, NULL, 'G3DSA:2.30.42.10:FF:000311', NULL, NULL, 'Protein MET1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(77574, NULL, 'G3DSA:2.60.40.10:FF:002587', NULL, NULL, 'AGAP005471-PA', NULL, NULL, NULL, NULL, NULL, 4),
(77575, NULL, 'G3DSA:1.10.1580.10:FF:000007', NULL, NULL, 'Mitochondrial GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(77576, NULL, 'G3DSA:3.40.50.80:FF:000117', NULL, NULL, 'Ferric reductase like transmembrane component-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(77577, NULL, 'G3DSA:3.30.70.330:FF:002378', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(77578, NULL, 'G3DSA:3.40.50.300:FF:001525', NULL, NULL, 'Rho-related GTP-binding protein RhoV', NULL, NULL, NULL, NULL, NULL, 4),
(77579, NULL, 'G3DSA:1.10.287.110:FF:000357', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77580, NULL, 'G3DSA:3.10.350.10:FF:000091', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77581, NULL, 'G3DSA:3.40.850.10:FF:000515', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77582, NULL, 'G3DSA:3.40.190.10:FF:000874', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77583, NULL, 'G3DSA:1.25.40.10:FF:001052', NULL, NULL, 'Anaphase-promoting complex subunit CDC27', NULL, NULL, NULL, NULL, NULL, 4),
(77584, NULL, 'G3DSA:2.30.29.30:FF:000320', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(77585, NULL, 'G3DSA:1.10.238.10:FF:000865', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77586, NULL, 'G3DSA:3.30.160.60:FF:005145', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77587, NULL, 'G3DSA:1.10.30.20:FF:000003', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(77588, NULL, 'G3DSA:6.10.140.2220:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77589, NULL, 'G3DSA:1.25.10.10:FF:000876', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(77590, NULL, 'G3DSA:3.40.50.1360:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77591, NULL, 'G3DSA:3.40.50.300:FF:005235', NULL, NULL, 'SD05444p2', NULL, NULL, NULL, NULL, NULL, 4),
(77592, NULL, 'G3DSA:2.20.28.30:FF:000003', NULL, NULL, 'DNA-directed RNA polymerases I, II, and III subunit RPABC4', NULL, NULL, NULL, NULL, NULL, 4),
(77593, NULL, 'G3DSA:1.25.40.20:FF:001055', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(77594, NULL, 'G3DSA:1.20.1420.10:FF:000011', NULL, NULL, 'Rhea, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(77595, NULL, 'G3DSA:1.10.510.10:FF:000875', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(77596, NULL, 'G3DSA:3.50.50.60:FF:000555', NULL, NULL, 'D-amino-acid oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(77597, NULL, 'G3DSA:3.40.630.10:FF:000268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77598, NULL, 'G3DSA:3.30.70.330:FF:000607', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(77599, NULL, 'G3DSA:3.30.450.20:FF:000405', NULL, NULL, 'Sensory box histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(77600, NULL, 'G3DSA:3.20.140.10:FF:000027', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(77601, NULL, 'G3DSA:2.170.140.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77602, NULL, 'G3DSA:3.60.20.10:FF:000184', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77603, NULL, 'G3DSA:2.30.36.70:FF:000016', NULL, NULL, 'SWI/SNF nucleosome remodeling complex component', NULL, NULL, NULL, NULL, NULL, 4),
(77604, NULL, 'G3DSA:1.20.1050.130:FF:000032', NULL, NULL, 'Elongation factor 1-beta', NULL, NULL, NULL, NULL, NULL, 4),
(77605, NULL, 'G3DSA:2.60.120.200:FF:000248', NULL, NULL, 'Chondroitin sulfate proteoglycan 4', NULL, NULL, NULL, NULL, NULL, 4),
(77606, NULL, 'G3DSA:3.40.50.2000:FF:000556', NULL, NULL, 'Related to alpha-1,3-mannosyltransferase alg2', NULL, NULL, NULL, NULL, NULL, 4),
(77607, NULL, 'G3DSA:2.30.29.30:FF:000590', NULL, NULL, 'Protein CBG20227', NULL, NULL, NULL, NULL, NULL, 4),
(77608, NULL, 'G3DSA:3.40.50.300:FF:004746', NULL, NULL, 'Helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(77609, NULL, 'G3DSA:2.70.50.40:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77610, NULL, 'G3DSA:2.70.20.10:FF:000028', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(77611, NULL, 'G3DSA:3.55.50.30:FF:000007', NULL, NULL, 'DUF4974 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(77612, NULL, 'G3DSA:1.10.510.10:FF:001280', NULL, NULL, 'Myosin light chain kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(77613, NULL, 'G3DSA:1.10.10.10:FF:000965', NULL, NULL, 'Transcriptional regulator, LuxR family', NULL, NULL, NULL, NULL, NULL, 4),
(77614, NULL, 'G3DSA:3.30.2410.10:FF:000023', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(77615, NULL, 'G3DSA:3.40.50.150:FF:000789', NULL, NULL, 'CcbJ', NULL, NULL, NULL, NULL, NULL, 4),
(77616, NULL, 'G3DSA:3.40.50.300:FF:003296', NULL, NULL, 'ABC family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(77617, NULL, 'G3DSA:3.40.50.2300:FF:000707', NULL, NULL, 'Os06g0190800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(77618, NULL, 'G3DSA:2.170.200.10:FF:000001', NULL, NULL, 'Regulatory protein E2', NULL, NULL, NULL, NULL, NULL, 4),
(77619, NULL, 'G3DSA:3.30.50.10:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77620, NULL, 'G3DSA:1.10.287.610:FF:000001', NULL, NULL, '30S ribosomal protein S2', NULL, NULL, NULL, NULL, NULL, 4),
(77621, NULL, 'G3DSA:2.60.40.10:FF:004616', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77622, NULL, 'G3DSA:3.30.1330.90:FF:000001', NULL, NULL, 'L-serine ammonia-lyase 1', NULL, NULL, NULL, NULL, NULL, 4),
(77623, NULL, 'G3DSA:2.60.40.420:FF:000266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77624, NULL, 'G3DSA:3.30.505.10:FF:000188', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77625, NULL, 'G3DSA:1.10.10.60:FF:000929', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77626, NULL, 'G3DSA:1.25.40.20:FF:001139', NULL, NULL, 'Serine/threonine-protein kinase NEK', NULL, NULL, NULL, NULL, NULL, 4),
(77627, NULL, 'G3DSA:3.40.50.300:FF:004398', NULL, NULL, 'Primosomal protein DnaI', NULL, NULL, NULL, NULL, NULL, 4),
(77628, NULL, 'G3DSA:3.40.50.720:FF:000752', NULL, NULL, 'L-threonine 3-dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(77629, NULL, 'G3DSA:3.30.450.30:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77630, NULL, 'G3DSA:1.10.630.10:FF:000294', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77631, NULL, 'G3DSA:1.20.120.310:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77632, NULL, 'G3DSA:1.20.140.10:FF:000102', NULL, NULL, 'Acyl-CoA dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(77633, NULL, 'G3DSA:3.30.710.10:FF:000445', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77634, NULL, 'G3DSA:1.20.1080.10:FF:000057', NULL, NULL, 'Aquaporin', NULL, NULL, NULL, NULL, NULL, 4),
(77635, NULL, 'G3DSA:2.40.420.20:FF:000006', NULL, NULL, 'RND family efflux transporter MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(77636, NULL, 'G3DSA:3.30.70.330:FF:000580', NULL, NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(77637, NULL, 'G3DSA:2.30.110.10:FF:000100', NULL, NULL, 'Oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(77638, NULL, 'G3DSA:3.10.20.90:FF:000569', NULL, NULL, 'Putative serine/threonine-protein kinase WNK5', NULL, NULL, NULL, NULL, NULL, 4),
(77639, NULL, 'G3DSA:1.20.1070.10:FF:000562', NULL, NULL, '5-hydroxytryptamine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(77640, NULL, 'G3DSA:1.20.1250.20:FF:002372', NULL, NULL, 'Proton-dependent oligopeptide transport (POT) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(77641, NULL, 'G3DSA:3.80.10.10:FF:003987', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77642, NULL, 'G3DSA:2.10.25.10:FF:001582', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(77643, NULL, 'G3DSA:1.10.10.10:FF:000437', NULL, NULL, 'Penicillinase repressor BlaI', NULL, NULL, NULL, NULL, NULL, 4),
(77644, NULL, 'G3DSA:2.120.10.30:FF:000621', NULL, NULL, 'NHL repeat-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(77645, NULL, 'G3DSA:3.40.228.10:FF:000013', NULL, NULL, 'NADH-quinone oxidoreductase subunit G', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(77646, NULL, 'G3DSA:1.20.58.60:FF:000443', NULL, NULL, 'Spectrin beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(77647, NULL, 'G3DSA:2.60.120.260:FF:000570', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77648, NULL, 'G3DSA:3.80.10.10:FF:001857', NULL, NULL, 'Putative surface antigen protein', NULL, NULL, NULL, NULL, NULL, 4),
(77649, NULL, 'G3DSA:3.15.20.10:FF:000001', NULL, NULL, 'Phospholipid transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(77650, NULL, 'G3DSA:3.30.1330.60:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77651, NULL, 'G3DSA:1.10.10.60:FF:001008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77652, NULL, 'G3DSA:1.25.40.20:FF:001673', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77653, NULL, 'G3DSA:3.40.50.1820:FF:001738', NULL, NULL, 'ABHD14A-ACY1 readthrough', NULL, NULL, NULL, NULL, NULL, 4),
(77654, NULL, 'G3DSA:3.30.200.20:FF:000477', NULL, NULL, 'Cyclin dependent kinase C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(77655, NULL, 'G3DSA:3.10.450.320:FF:000009', NULL, NULL, 'Mitochondrial import inner membrane translocase subunit TIM21', NULL, NULL, NULL, NULL, NULL, 4),
(77656, NULL, 'G3DSA:2.60.120.10:FF:000032', NULL, NULL, 'Mannose-1-phosphate guanylyltransferase/mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(77657, NULL, 'G3DSA:3.30.160.60:FF:005139', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77658, NULL, 'G3DSA:3.30.1370.10:FF:000087', NULL, NULL, 'KH domain containing 3 like, subcortical maternal complex member', NULL, NULL, NULL, NULL, NULL, 4),
(77659, NULL, 'G3DSA:3.90.550.10:FF:000537', NULL, NULL, 'Mannose-1-phosphate guanylyltransferase/mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(77660, NULL, 'G3DSA:3.20.20.100:FF:000065', NULL, NULL, 'Aryl-alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(77661, NULL, 'G3DSA:3.40.50.1820:FF:000159', NULL, NULL, 'Chlorophyllase-2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(77662, NULL, 'G3DSA:3.90.660.10:FF:000129', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77663, NULL, 'G3DSA:1.10.555.10:FF:000225', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77664, NULL, 'G3DSA:1.10.840.10:FF:000012', NULL, NULL, 'Ral guanine nucleotide dissociation stimulator-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(77665, NULL, 'G3DSA:3.10.20.410:FF:000002', NULL, NULL, 'Outer membrane usher protein FimD', NULL, NULL, NULL, NULL, NULL, 4),
(77666, NULL, 'G3DSA:2.60.40.10:FF:005223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77667, NULL, 'G3DSA:1.25.40.10:FF:003227', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(77668, NULL, 'G3DSA:2.130.10.10:FF:003436', NULL, NULL, 'WD repeat-containing protein 66-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(77669, NULL, 'G3DSA:1.20.1090.10:FF:000029', NULL, NULL, 'Iron-containing alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(77670, NULL, 'G3DSA:2.130.10.10:FF:001306', NULL, NULL, 'CCR4-associated factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(77671, NULL, 'G3DSA:3.40.50.2300:FF:000764', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77672, NULL, 'G3DSA:1.25.40.20:FF:001196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77673, NULL, 'G3DSA:1.10.3720.10:FF:000098', NULL, NULL, 'Amino acid ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(77674, NULL, 'G3DSA:2.40.50.770:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77675, NULL, 'G3DSA:3.40.5.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77676, NULL, 'G3DSA:2.30.30.40:FF:000101', NULL, NULL, 'Rho GTPase activating protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(77677, NULL, 'G3DSA:3.40.50.300:FF:002745', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(77678, NULL, 'G3DSA:1.25.40.10:FF:001193', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(77679, NULL, 'G3DSA:3.40.640.10:FF:000095', NULL, NULL, '8-amino-7-oxononanoate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(77680, NULL, 'G3DSA:3.30.160.60:FF:005471', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77681, NULL, 'G3DSA:2.60.110.10:FF:000003', NULL, NULL, 'Thaumatin I', NULL, NULL, NULL, NULL, NULL, 4),
(77682, NULL, 'G3DSA:1.20.1250.20:FF:001967', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77683, NULL, 'G3DSA:1.20.1070.10:FF:001809', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77684, NULL, 'G3DSA:3.90.245.10:FF:000013', NULL, NULL, 'Inosine-adenosine-guanosine-nucleoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(77685, NULL, 'G3DSA:3.30.160.60:FF:005616', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77686, NULL, 'G3DSA:1.25.40.10:FF:001136', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(77687, NULL, 'G3DSA:1.10.10.60:FF:001121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77688, NULL, 'G3DSA:2.40.50.140:FF:000913', NULL, NULL, 'Single-stranded DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(77689, NULL, 'G3DSA:2.60.40.10:FF:001328', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(77690, NULL, 'G3DSA:3.90.190.10:FF:000610', NULL, NULL, 'Protein-tyrosine-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(77691, NULL, 'G3DSA:1.10.238.10:FF:000949', NULL, NULL, 'Ryanodine receptor 44F (inferred by orthology to a D. melanogaster protein)', NULL, NULL, NULL, NULL, NULL, 4),
(77692, NULL, 'G3DSA:1.10.300.10:FF:000011', NULL, NULL, 'Adenylosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(77693, NULL, 'G3DSA:1.20.1250.20:FF:001765', NULL, NULL, 'Monocarboxylate transporter 9-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(77694, NULL, 'G3DSA:2.130.10.10:FF:005201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77695, NULL, 'G3DSA:3.30.710.10:FF:000030', NULL, NULL, 'Ankyrin repeat and BTB/POZ domain-containing protein BTBD11', NULL, NULL, NULL, NULL, NULL, 4),
(77696, NULL, 'G3DSA:3.55.50.10:FF:000001', NULL, NULL, 'Actin cross-linking toxin VgrG1', NULL, NULL, NULL, NULL, NULL, 4),
(77697, NULL, 'G3DSA:1.20.140.10:FF:000046', NULL, NULL, 'Acyl-CoA dehydrogenase FadE16', NULL, NULL, NULL, NULL, NULL, 4),
(77698, NULL, 'G3DSA:3.90.226.10:FF:000267', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77699, NULL, 'G3DSA:2.40.100.10:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77700, NULL, 'G3DSA:3.30.870.10:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77701, NULL, 'G3DSA:3.30.160.60:FF:003582', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77702, NULL, 'G3DSA:1.10.1140.10:FF:000008', NULL, NULL, 'V-type proton ATPase catalytic subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(77703, NULL, 'G3DSA:2.60.40.10:FF:003458', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77704, NULL, 'G3DSA:3.40.50.1820:FF:001851', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77705, NULL, 'G3DSA:3.30.1490.80:FF:000009', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(77706, NULL, 'G3DSA:3.30.720.50:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77707, NULL, 'G3DSA:3.30.1490.70:FF:000006', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(77708, NULL, 'G3DSA:1.10.1060.10:FF:000007', NULL, NULL, 'Dihydropyrimidine dehydrogenase [NADP(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(77709, NULL, 'G3DSA:1.20.1310.20:FF:000011', NULL, NULL, 'Erythrocyte binding antigen-181', NULL, NULL, NULL, NULL, NULL, 4),
(77710, NULL, 'G3DSA:2.30.180.10:FF:000189', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77711, NULL, 'G3DSA:3.40.1440.60:FF:000009', NULL, NULL, 'Primosomal protein N''', NULL, NULL, NULL, NULL, NULL, 4),
(77712, NULL, 'G3DSA:3.40.50.410:FF:000125', NULL, NULL, 'von Willebrand factor, type A', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(77713, NULL, 'G3DSA:3.10.580.10:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77714, NULL, 'G3DSA:2.60.40.10:FF:001660', NULL, NULL, 'Neuromusculin, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(77715, NULL, 'G3DSA:1.10.132.60:FF:000039', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(77716, NULL, 'G3DSA:3.40.50.970:FF:000214', NULL, NULL, 'Protein CBG00293', NULL, NULL, NULL, NULL, NULL, 4),
(77717, NULL, 'G3DSA:3.40.50.2000:FF:000472', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(77718, NULL, 'G3DSA:3.40.50.1010:FF:000220', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77719, NULL, 'G3DSA:1.10.238.10:FF:001028', NULL, NULL, 'Calcium-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(77720, NULL, 'G3DSA:1.10.510.10:FF:001656', NULL, NULL, 'serine/threonine receptor-like kinase NFP', NULL, NULL, NULL, NULL, NULL, 4),
(77721, NULL, 'G3DSA:2.60.40.10:FF:003312', NULL, NULL, 'Neural cell adhesion molecule 3', NULL, NULL, NULL, NULL, NULL, 4),
(77722, NULL, 'G3DSA:3.30.200.20:FF:001202', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77723, NULL, 'G3DSA:1.10.555.10:FF:000023', NULL, NULL, 'Arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(77724, NULL, 'G3DSA:1.25.40.10:FF:002446', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At3g18840', NULL, NULL, NULL, NULL, NULL, 4),
(77725, NULL, 'G3DSA:2.130.10.10:FF:005347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77726, NULL, 'G3DSA:2.40.160.90:FF:000001', NULL, NULL, 'Transferrin-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(77727, NULL, 'G3DSA:3.60.40.10:FF:000218', NULL, NULL, 'Protein phosphatase type 2c', NULL, NULL, NULL, NULL, NULL, 4),
(77728, NULL, 'G3DSA:3.40.50.1010:FF:000040', NULL, NULL, 'DNA repair protein complementing XP-G cells', NULL, NULL, NULL, NULL, NULL, 4),
(77729, NULL, 'G3DSA:1.10.287.70:FF:000642', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77730, NULL, 'G3DSA:3.30.200.20:FF:002366', NULL, NULL, 'Os10g0129466 protein', NULL, NULL, NULL, NULL, NULL, 4),
(77731, NULL, 'G3DSA:3.30.70.330:FF:000523', NULL, NULL, 'Pre-mRNA splicing factor (Prp24), putative', NULL, NULL, NULL, NULL, NULL, 4),
(77732, NULL, 'G3DSA:3.50.50.60:FF:000824', NULL, NULL, '1-hydroxycarotenoid 3,4-desaturase', NULL, NULL, NULL, NULL, NULL, 4),
(77733, NULL, 'G3DSA:1.20.1250.20:FF:000129', NULL, NULL, 'Major Facilitator Superfamily (MFS)', NULL, NULL, NULL, NULL, NULL, 4),
(77734, NULL, 'G3DSA:1.10.10.60:FF:000194', NULL, NULL, 'Zinc fingers and homeoboxes protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(77735, NULL, 'G3DSA:2.30.29.30:FF:000825', NULL, NULL, 'SH2B adapter protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(77736, NULL, 'G3DSA:3.90.550.50:FF:000178', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(77737, NULL, 'G3DSA:1.25.40.10:FF:002974', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77738, NULL, 'G3DSA:3.30.160.60:FF:004829', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77739, NULL, 'G3DSA:1.20.1070.10:FF:001866', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77740, NULL, 'G3DSA:3.60.20.10:FF:000043', NULL, NULL, 'Glutamate synthase 1 [NADH] chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(77741, NULL, 'G3DSA:3.40.50.1820:FF:001795', NULL, NULL, '1-acylglycerol-3-phosphate O-acyltransferase ABHD5-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(77742, NULL, 'G3DSA:3.30.70.141:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77743, NULL, 'G3DSA:1.20.58.1880:FF:000019', NULL, NULL, 'Uncharacterized protein, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(77744, NULL, 'G3DSA:3.40.50.80:FF:000090', NULL, NULL, 'Methionine synthase reductase', NULL, NULL, NULL, NULL, NULL, 4),
(77745, NULL, 'G3DSA:1.10.150.20:FF:000215', NULL, NULL, 'Fanconi anemia core complex-associated protein 24', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(77746, NULL, 'G3DSA:3.30.980.10:FF:000015', NULL, NULL, 'Threonine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(77747, NULL, 'G3DSA:2.60.40.10:FF:005931', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77748, NULL, 'G3DSA:3.40.50.80:FF:000033', NULL, NULL, 'Sulfite reductase (NADPH) flavoprotein alpha-component', NULL, NULL, NULL, NULL, NULL, 4),
(77749, NULL, 'G3DSA:1.20.920.10:FF:000201', NULL, NULL, 'Bromo and FHA domain-containing protein DDB_G0267958', NULL, NULL, NULL, NULL, NULL, 4),
(77750, NULL, 'G3DSA:1.20.1290.10:FF:000016', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77751, NULL, 'G3DSA:1.10.510.10:FF:001600', NULL, NULL, 'Uncharacterized protein OSJNBa0042F15.6', NULL, NULL, NULL, NULL, NULL, 4),
(77752, NULL, 'G3DSA:1.10.10.60:FF:001065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77753, NULL, 'G3DSA:2.40.50.1020:FF:000004', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(77754, NULL, 'G3DSA:3.40.50.2300:FF:000820', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77755, NULL, 'G3DSA:1.20.120.1240:FF:000015', NULL, NULL, 'Dynamin-2A', NULL, NULL, NULL, NULL, NULL, 4),
(77756, NULL, 'G3DSA:3.40.350.10:FF:000084', NULL, NULL, 'X-Pro aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(77757, NULL, 'G3DSA:1.20.80.10:FF:000008', NULL, NULL, 'FERM domain containing 4A', NULL, NULL, NULL, NULL, NULL, 4),
(77758, NULL, 'G3DSA:3.40.33.10:FF:000001', NULL, NULL, 'Cysteine-rich secretory protein LCCL domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(77759, NULL, 'G3DSA:2.40.70.10:FF:000538', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77760, NULL, 'G3DSA:3.30.559.70:FF:000009', NULL, NULL, 'Carnitine O-palmitoyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(77761, NULL, 'G3DSA:1.25.10.10:FF:001601', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77762, NULL, 'G3DSA:1.10.575.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77763, NULL, 'G3DSA:1.20.1050.10:FF:000235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77764, NULL, 'G3DSA:1.10.8.60:FF:000243', NULL, NULL, 'ATPase AAA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(77765, NULL, 'G3DSA:1.10.1670.10:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77766, NULL, 'G3DSA:3.40.1410.10:FF:000015', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(77767, NULL, 'G3DSA:3.40.50.720:FF:002135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77768, NULL, 'G3DSA:2.130.10.10:FF:001076', NULL, NULL, 'Syntaxin-binding protein 5 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(77769, NULL, 'G3DSA:3.30.160.60:FF:000558', NULL, NULL, 'zinc finger protein 513 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(77770, NULL, 'G3DSA:2.130.10.10:FF:001019', NULL, NULL, 'NACHT and WD repeat domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(77771, NULL, 'G3DSA:3.30.70.330:FF:003103', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77772, NULL, 'G3DSA:2.40.160.50:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77773, NULL, 'G3DSA:1.25.40.10:FF:000883', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(77774, NULL, 'G3DSA:2.130.10.30:FF:000160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77775, NULL, 'G3DSA:3.40.190.10:FF:000458', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(77776, NULL, 'G3DSA:1.25.40.10:FF:004099', NULL, NULL, 'Os01g0301500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(77777, NULL, 'G3DSA:2.40.50.140:FF:001262', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77778, NULL, 'G3DSA:3.30.40.10:FF:002294', NULL, NULL, 'Protein CBG19351', NULL, NULL, NULL, NULL, NULL, 4),
(77779, NULL, 'G3DSA:1.20.1250.20:FF:000186', NULL, NULL, 'monocarboxylate transporter 14 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(77780, NULL, 'G3DSA:3.40.50.2300:FF:001130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(77781, NULL, 'G3DSA:3.40.50.11610:FF:000009', NULL, NULL, '2-oxoglutarate dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(77782, NULL, 'G3DSA:3.30.200.20:FF:002309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77783, NULL, 'G3DSA:3.10.430.100:FF:000018', NULL, NULL, 'Ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(77784, NULL, 'G3DSA:3.40.390.10:FF:000204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77785, NULL, 'G3DSA:1.10.510.10:FF:000673', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(77786, NULL, 'G3DSA:2.30.42.10:FF:000603', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77787, NULL, 'G3DSA:3.40.50.720:FF:000044', NULL, NULL, 'UDP-glucuronic acid decarboxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(77788, NULL, 'G3DSA:3.30.70.330:FF:002176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77789, NULL, 'G3DSA:2.60.20.10:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77790, NULL, 'G3DSA:3.30.200.20:FF:000275', NULL, NULL, 'Apoptosis associated tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(77791, NULL, 'G3DSA:3.10.129.10:FF:000273', NULL, NULL, 'Mesaconyl-C(4)-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(77792, NULL, 'G3DSA:3.30.930.10:FF:000012', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(77793, NULL, 'G3DSA:3.40.47.10:FF:000089', NULL, NULL, 'Putative polyketide beta-ketoacyl synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(77794, NULL, 'G3DSA:3.50.50.60:FF:000263', NULL, NULL, 'Zeaxanthin epoxidase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(77795, NULL, 'G3DSA:3.40.50.150:FF:000210', NULL, NULL, 'tRNA (guanine(37)-N1)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(77796, NULL, 'G3DSA:1.20.1270.10:FF:000072', NULL, NULL, 'Protein CBG00051', NULL, NULL, NULL, NULL, NULL, 4),
(77797, NULL, 'G3DSA:1.25.40.10:FF:002917', NULL, NULL, 'Protein O-mannosyl-transferase TMTC1', NULL, NULL, NULL, NULL, NULL, 4),
(77798, NULL, 'G3DSA:3.40.50.20:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77799, NULL, 'G3DSA:3.40.850.10:FF:000341', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(77800, NULL, 'G3DSA:3.90.1150.10:FF:000455', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(77801, NULL, 'G3DSA:3.30.160.60:FF:001165', NULL, NULL, 'telomere zinc finger-associated protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(77802, NULL, 'G3DSA:3.40.50.300:FF:001109', NULL, NULL, 'ATP-dependent RNA helicase suv3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(77803, NULL, 'G3DSA:3.30.750.24:FF:000158', NULL, NULL, 'AGR213Cp', NULL, NULL, NULL, NULL, NULL, 4),
(77804, NULL, 'G3DSA:3.40.50.300:FF:001166', NULL, NULL, 'ADP-ribosylation factor D', NULL, NULL, NULL, NULL, NULL, 4),
(77805, NULL, 'G3DSA:1.10.132.30:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77806, NULL, 'G3DSA:3.30.70.330:FF:003013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77807, NULL, 'G3DSA:1.10.287.470:FF:000032', NULL, NULL, 'Cation efflux system protein', NULL, NULL, NULL, NULL, NULL, 4),
(77808, NULL, 'G3DSA:1.10.510.10:FF:001510', NULL, NULL, 'Receptor-type guanylate cyclase daf-11', NULL, NULL, NULL, NULL, NULL, 4),
(77809, NULL, 'G3DSA:3.30.160.60:FF:001873', NULL, NULL, 'Zinc finger and BTB domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(77810, NULL, 'G3DSA:1.20.1250.10:FF:000126', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77811, NULL, 'G3DSA:3.40.190.10:FF:000835', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77812, NULL, 'G3DSA:1.20.1070.10:FF:002119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77813, NULL, 'G3DSA:1.20.120.160:FF:000044', NULL, NULL, 'Receptor-like histidine kinase BpdS', NULL, NULL, NULL, NULL, NULL, 4),
(77814, NULL, 'G3DSA:1.25.40.20:FF:000886', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(77815, NULL, 'G3DSA:3.20.20.100:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77816, NULL, 'G3DSA:1.10.472.10:FF:000454', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77817, NULL, 'G3DSA:2.60.40.10:FF:004386', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77818, NULL, 'G3DSA:1.10.10.10:FF:001421', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(77819, NULL, 'G3DSA:3.30.70.850:FF:000027', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77820, NULL, 'G3DSA:3.40.50.1000:FF:000537', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77821, NULL, 'G3DSA:3.30.70.330:FF:002940', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77822, NULL, 'G3DSA:1.20.1250.20:FF:000219', NULL, NULL, 'major facilitator superfamily domain-containing protein 12 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(77823, NULL, 'G3DSA:2.130.10.10:FF:002565', NULL, NULL, 'Signal transducer', NULL, NULL, NULL, NULL, NULL, 4),
(77824, NULL, 'G3DSA:3.60.60.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77825, NULL, 'G3DSA:3.30.300.30:FF:000134', NULL, NULL, 'Nonribosomal peptide synthase nlsA', NULL, NULL, NULL, NULL, NULL, 4),
(77826, NULL, 'G3DSA:3.40.50.300:FF:007511', NULL, NULL, 'Putative type III restriction-modification system, R subunit', NULL, NULL, NULL, NULL, NULL, 4),
(77827, NULL, 'G3DSA:1.20.58.90:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77828, NULL, 'G3DSA:1.25.40.10:FF:001900', NULL, NULL, 'protein NRDE2 homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(77829, NULL, 'G3DSA:1.10.490.10:FF:000029', NULL, NULL, 'Adenylate cyclase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(77830, NULL, 'G3DSA:1.10.287.70:FF:000024', NULL, NULL, 'Inositol 1,4,5-trisphosphate receptor type 3', NULL, NULL, NULL, NULL, NULL, 4),
(77831, NULL, 'G3DSA:1.20.5.170:FF:000166', NULL, NULL, 'Activating transcription factor-2', NULL, NULL, NULL, NULL, NULL, 4),
(77832, NULL, 'G3DSA:1.10.287.80:FF:000027', NULL, NULL, 'Lysine-specific histone demethylase 1A isoform b', NULL, NULL, NULL, NULL, NULL, 4),
(77833, NULL, 'G3DSA:1.20.142.10:FF:000028', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(77834, NULL, 'G3DSA:3.40.50.970:FF:000068', NULL, NULL, '2-succinyl-5-enolpyruvyl-6-hydroxy-3-cyclohexene-1-carboxylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(77835, NULL, 'G3DSA:3.30.160.60:FF:002559', NULL, NULL, 'Zinc finger protein 175', NULL, NULL, NULL, NULL, NULL, 4),
(77836, NULL, 'G3DSA:2.120.10.30:FF:000149', NULL, NULL, 'NHL repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(77837, NULL, 'G3DSA:1.10.730.10:FF:000094', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(77838, NULL, 'G3DSA:1.10.10.10:FF:001218', NULL, NULL, 'Two-component response regulator YvcP', NULL, NULL, NULL, NULL, NULL, 4),
(77839, NULL, 'G3DSA:2.30.230.10:FF:000042', NULL, NULL, 'Vitellogenin 1', NULL, NULL, NULL, NULL, NULL, 4),
(77840, NULL, 'G3DSA:2.30.29.30:FF:000735', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77841, NULL, 'G3DSA:3.20.20.140:FF:000380', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77842, NULL, 'G3DSA:2.130.10.10:FF:000002', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(77843, NULL, 'G3DSA:1.20.1280.290:FF:000041', NULL, NULL, 'Uncharacterized protein, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(77844, NULL, 'G3DSA:2.60.40.10:FF:003930', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77845, NULL, 'G3DSA:1.10.630.10:FF:000327', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(77846, NULL, 'G3DSA:1.10.287.920:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77847, NULL, 'G3DSA:3.40.50.670:FF:000006', NULL, NULL, 'DNA topoisomerase (ATP-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(77848, NULL, 'G3DSA:1.10.287.380:FF:000005', NULL, NULL, 'ABC transporter ATP-binding protein uup', NULL, NULL, NULL, NULL, NULL, 4),
(77849, NULL, 'G3DSA:2.60.120.200:FF:000535', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77850, NULL, 'G3DSA:1.10.287.370:FF:000002', NULL, NULL, 'Prefoldin subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(77851, NULL, 'G3DSA:3.30.40.10:FF:000815', NULL, NULL, 'Histone H3-K36 demethylase', NULL, NULL, NULL, NULL, NULL, 4),
(77852, NULL, 'G3DSA:1.20.120.1750:FF:000168', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(77853, NULL, 'G3DSA:1.25.10.10:FF:002618', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77854, NULL, 'G3DSA:3.90.228.20:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77855, NULL, 'G3DSA:3.30.70.960:FF:000004', NULL, NULL, 'Transmembrane serine protease 6', NULL, NULL, NULL, NULL, NULL, 4),
(77856, NULL, 'G3DSA:1.25.10.10:FF:002860', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77857, NULL, 'G3DSA:2.30.30.190:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77858, NULL, 'G3DSA:3.40.190.80:FF:000018', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(77859, NULL, 'G3DSA:1.10.287.70:FF:000171', NULL, NULL, 'Ionotropic receptor 21a', NULL, NULL, NULL, NULL, NULL, 4),
(77860, NULL, 'G3DSA:2.10.110.10:FF:000144', NULL, NULL, 'Protein CBR-ZYX-1', NULL, NULL, NULL, NULL, NULL, 4),
(77861, NULL, 'G3DSA:1.10.287.70:FF:000081', NULL, NULL, 'inward rectifier potassium channel 13 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(77862, NULL, 'G3DSA:3.30.760.10:FF:000033', NULL, NULL, 'Eukaryotic initiation factor 4E family protein', NULL, NULL, NULL, NULL, NULL, 4),
(77863, NULL, 'G3DSA:3.30.230.10:FF:000004', NULL, NULL, '40S ribosomal protein S2', NULL, NULL, NULL, NULL, NULL, 4),
(77864, NULL, 'G3DSA:3.40.50.300:FF:001727', NULL, NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily A containing DEAD/H box', NULL, NULL, NULL, NULL, NULL, 4),
(77865, NULL, 'G3DSA:2.30.42.10:FF:000367', NULL, NULL, 'Glutamate receptor-interacting protein 2a', NULL, NULL, NULL, NULL, NULL, 4),
(77866, NULL, 'G3DSA:3.20.20.80:FF:000251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77867, NULL, 'G3DSA:3.30.70.330:FF:001304', NULL, NULL, 'Os06g0248200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(77868, NULL, 'G3DSA:1.50.10.10:FF:000227', NULL, NULL, 'Glycogen debranching enzyme-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(77869, NULL, 'G3DSA:2.130.10.30:FF:000008', NULL, NULL, 'regulator of chromosome condensation isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(77870, NULL, 'G3DSA:3.80.10.10:FF:000553', NULL, NULL, 'Platelet glycoprotein IX', NULL, NULL, NULL, NULL, NULL, 4),
(77871, NULL, 'G3DSA:1.20.5.170:FF:000109', NULL, NULL, 'ATF (cAMP-dependent transcription factor) family', NULL, NULL, NULL, NULL, NULL, 4),
(77872, NULL, 'G3DSA:1.20.1050.10:FF:000055', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(77873, NULL, 'G3DSA:3.40.50.150:FF:001284', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77874, NULL, 'G3DSA:1.25.10.10:FF:002528', NULL, NULL, 'WAPL (Wings apart-like protein regulation of heterochromatin) protein', NULL, NULL, NULL, NULL, NULL, 4),
(77875, NULL, 'G3DSA:3.40.50.720:FF:002045', NULL, NULL, 'UBA/THIF-type NAD/FAD binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(77876, NULL, 'G3DSA:3.90.180.10:FF:000020', NULL, NULL, 'Crotonyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(77877, NULL, 'G3DSA:3.30.1370.50:FF:000014', NULL, NULL, 'Poly(A)-specific ribonuclease PARN', NULL, NULL, NULL, NULL, NULL, 4),
(77878, NULL, 'G3DSA:2.30.110.10:FF:000010', NULL, NULL, 'Pyridoxine phosphate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(77879, NULL, 'G3DSA:3.30.540.30:FF:000005', NULL, NULL, 'Nudix hydrolase 3', NULL, NULL, NULL, NULL, NULL, 4),
(77880, NULL, 'G3DSA:1.25.40.20:FF:001903', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(77881, NULL, 'G3DSA:1.20.58.60:FF:000819', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77882, NULL, 'G3DSA:1.10.10.750:FF:000008', NULL, NULL, 'TBC1 domain family member 9', NULL, NULL, NULL, NULL, NULL, 4),
(77883, NULL, 'G3DSA:2.60.120.780:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77884, NULL, 'G3DSA:1.20.1530.20:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77885, NULL, 'G3DSA:3.40.50.300:FF:003526', NULL, NULL, 'GTPase Der', NULL, NULL, NULL, NULL, NULL, 4),
(77886, NULL, 'G3DSA:3.30.70.2150:FF:000002', NULL, NULL, 'Chitin-binding protein CbpD', NULL, NULL, NULL, NULL, NULL, 4),
(77887, NULL, 'G3DSA:1.10.510.10:FF:002584', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77888, NULL, 'G3DSA:2.40.50.140:FF:000391', NULL, NULL, 'Single-stranded DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(77889, NULL, 'G3DSA:1.20.990.10:FF:000003', NULL, NULL, 'NADPH--cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(77890, NULL, 'G3DSA:3.80.10.10:FF:004206', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77891, NULL, 'G3DSA:3.30.497.10:FF:000027', NULL, NULL, 'Putative serpin-Z6A', NULL, NULL, NULL, NULL, NULL, 4),
(77892, NULL, 'G3DSA:3.90.190.10:FF:000464', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77893, NULL, 'G3DSA:1.20.1740.10:FF:000271', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77894, NULL, 'G3DSA:3.30.40.10:FF:000725', NULL, NULL, 'E3 ubiquitin-protein ligase ATL41', NULL, NULL, NULL, NULL, NULL, 4),
(77895, NULL, 'G3DSA:1.10.287.130:FF:000222', NULL, NULL, 'Hybrid signal transduction histidine kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(77896, NULL, 'G3DSA:1.10.287.2620:FF:000009', NULL, NULL, 'Dynein Heavy Chain', NULL, NULL, NULL, NULL, NULL, 4),
(77897, NULL, 'G3DSA:1.25.40.660:FF:000011', NULL, NULL, 'Vacuolar protein sorting-associated protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(77898, NULL, 'G3DSA:2.120.10.30:FF:000059', NULL, NULL, 'E3 ubiquitin-protein ligase NHLRC1', NULL, NULL, NULL, NULL, NULL, 4),
(77899, NULL, 'G3DSA:2.60.120.620:FF:000110', NULL, NULL, 'Procollagen-lysine, 2-oxoglutarate 5-dioxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(77900, NULL, 'G3DSA:3.40.50.1440:FF:000085', NULL, NULL, 'Tubulin gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(77901, NULL, 'G3DSA:1.10.287.2610:FF:000006', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77902, NULL, 'G3DSA:2.40.50.140:FF:000149', NULL, NULL, 'Replication protein A 32 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(77903, NULL, 'G3DSA:1.25.10.10:FF:003170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77904, NULL, 'G3DSA:3.30.70.330:FF:002850', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77905, NULL, 'G3DSA:3.30.450.20:FF:000175', NULL, NULL, 'Hypoxia-inducible factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(77906, NULL, 'G3DSA:3.20.70.20:FF:000023', NULL, NULL, 'Ribonucleoside-triphosphate reductase, adenosylcobalamin-dependent', NULL, NULL, NULL, NULL, NULL, 4),
(77907, NULL, 'G3DSA:1.10.565.10:FF:000052', NULL, NULL, 'Ultraspiracle nuclear receptor', NULL, NULL, NULL, NULL, NULL, 4),
(77908, NULL, 'G3DSA:2.70.98.90:FF:000012', NULL, NULL, 'Membrane protein insertase YidC', NULL, NULL, NULL, NULL, NULL, 4),
(77909, NULL, 'G3DSA:3.30.70.560:FF:000007', NULL, NULL, '2-amino-4-hydroxy-6-hydroxymethyldihydropteridine pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(77910, NULL, 'G3DSA:3.40.50.150:FF:001845', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77911, NULL, 'G3DSA:2.60.120.650:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77912, NULL, 'G3DSA:3.40.50.300:FF:006399', NULL, NULL, 'Midasin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(77913, NULL, 'G3DSA:3.30.70.330:FF:002322', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77914, NULL, 'G3DSA:3.90.70.10:FF:000011', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(77915, NULL, 'G3DSA:1.25.40.10:FF:004773', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77916, NULL, 'G3DSA:3.90.640.10:FF:000044', NULL, NULL, 'Actin-related protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(77917, NULL, 'G3DSA:1.10.730.10:FF:000184', NULL, NULL, 'AER043Cp', NULL, NULL, NULL, NULL, NULL, 4),
(77918, NULL, 'G3DSA:3.30.710.10:FF:000406', NULL, NULL, 'Rho related BTB domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(77919, NULL, 'G3DSA:2.60.120.200:FF:000720', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77920, NULL, 'G3DSA:2.60.40.10:FF:001480', NULL, NULL, 'Erythrocyte membrane protein band 4.2', NULL, NULL, NULL, NULL, NULL, 4),
(77921, NULL, 'G3DSA:1.20.1070.10:FF:000505', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(77922, NULL, 'G3DSA:3.40.50.300:FF:003616', NULL, NULL, 'Signal recognition particle receptor', NULL, NULL, NULL, NULL, NULL, 4),
(77923, NULL, 'G3DSA:1.10.472.80:FF:000014', NULL, NULL, 'GTPase-activating protein gyp7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(77924, NULL, 'G3DSA:2.170.140.10:FF:000029', NULL, NULL, 'Probable endochitinase', NULL, NULL, NULL, NULL, NULL, 4),
(77925, NULL, 'G3DSA:3.60.10.10:FF:000071', NULL, NULL, 'type I inositol polyphosphate 5-phosphatase 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(77926, NULL, 'G3DSA:1.25.40.530:FF:000023', NULL, NULL, 'Unconventional myosin heavy chain 6', NULL, NULL, NULL, NULL, NULL, 4),
(77927, NULL, 'G3DSA:1.25.40.540:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77928, NULL, 'G3DSA:3.30.160.60:FF:006398', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77929, NULL, 'G3DSA:1.10.150.60:FF:000002', NULL, NULL, 'AT-rich interactive domain-containing protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(77930, NULL, 'G3DSA:2.60.40.3440:FF:000006', NULL, NULL, 'SbsB protein', NULL, NULL, NULL, NULL, NULL, 4),
(77931, NULL, 'G3DSA:3.20.20.100:FF:000008', NULL, NULL, 'Aldo/keto reductase family oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(77932, NULL, 'G3DSA:3.80.10.10:FF:003369', NULL, NULL, 'Tubulin folding COfactor E-Like protein', NULL, NULL, NULL, NULL, NULL, 4),
(77933, NULL, 'G3DSA:2.60.40.420:FF:000209', NULL, NULL, 'ceruloplasmin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(77934, NULL, 'G3DSA:3.20.20.80:FF:000195', NULL, NULL, 'Glycoside hydrolase family 25', NULL, NULL, NULL, NULL, NULL, 4),
(77935, NULL, 'G3DSA:2.60.40.10:FF:002817', NULL, NULL, 'Hemicentin-2', NULL, NULL, NULL, NULL, NULL, 4),
(77936, NULL, 'G3DSA:2.10.80.10:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(77937, NULL, 'G3DSA:3.40.1780.10:FF:000003', NULL, NULL, 'S-adenosylmethionine:tRNA ribosyltransferase-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(77938, NULL, 'G3DSA:1.10.437.10:FF:000030', NULL, NULL, 'ORF 16', NULL, NULL, NULL, NULL, NULL, 4),
(77939, NULL, 'G3DSA:3.40.50.620:FF:000216', NULL, NULL, 'Leucine--tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(77940, NULL, 'G3DSA:3.30.160.60:FF:003054', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(77941, NULL, 'G3DSA:3.40.630.30:FF:000280', NULL, NULL, 'Diamine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(77942, NULL, 'G3DSA:2.60.40.10:FF:002907', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77943, NULL, 'G3DSA:2.40.50.960:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77944, NULL, 'G3DSA:3.40.50.150:FF:001194', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77945, NULL, 'G3DSA:1.20.1050.10:FF:000089', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(77946, NULL, 'G3DSA:1.25.40.10:FF:004155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77947, NULL, 'G3DSA:1.25.40.10:FF:000445', NULL, NULL, 'tetratricopeptide repeat protein 21B isoform X2', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(77948, NULL, 'G3DSA:1.10.238.10:FF:000011', NULL, NULL, 'Mitochondrial Rho GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(77949, NULL, 'G3DSA:1.10.600.10:FF:000090', NULL, NULL, 'Farnesyl-diphosphate farnesyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(77950, NULL, 'G3DSA:3.30.310.40:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77951, NULL, 'G3DSA:1.50.40.10:FF:000055', NULL, NULL, 'mitochondrial ornithine transporter 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(77952, NULL, 'G3DSA:1.10.510.10:FF:000021', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(77953, NULL, 'G3DSA:1.20.90.10:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77954, NULL, 'G3DSA:1.20.120.520:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77955, NULL, 'G3DSA:2.140.10.10:FF:000007', NULL, NULL, 'Glucose/quinate/shikimate family membrane-bound PQQ-dependent dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(77956, NULL, 'G3DSA:3.30.40.10:FF:000782', NULL, NULL, 'COP1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(77957, NULL, 'G3DSA:1.20.1070.10:FF:000472', NULL, NULL, 'Protein CBG21053', NULL, NULL, NULL, NULL, NULL, 4),
(77958, NULL, 'G3DSA:3.30.40.10:FF:000164', NULL, NULL, 'PHD finger protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(77959, NULL, 'G3DSA:1.20.1250.20:FF:000332', NULL, NULL, 'Putative transporter AraJ', NULL, NULL, NULL, NULL, NULL, 4),
(77960, NULL, 'G3DSA:1.10.510.10:FF:003455', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77961, NULL, 'G3DSA:3.40.50.620:FF:000306', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(77962, NULL, 'G3DSA:1.20.58.60:FF:000590', NULL, NULL, 'Myosin light chain kinase, smooth muscle', NULL, NULL, NULL, NULL, NULL, 4),
(77963, NULL, 'G3DSA:1.10.238.20:FF:000014', NULL, NULL, 'Odorant-binding protein 19c', NULL, NULL, NULL, NULL, NULL, 4),
(77964, NULL, 'G3DSA:1.10.238.10:FF:000101', NULL, NULL, 'SPARC/osteonectin, cwcv and kazal-like domains proteoglycan 2', NULL, NULL, NULL, NULL, NULL, 4),
(77965, NULL, 'G3DSA:3.90.1410.10:FF:000077', NULL, NULL, 'MIP03820p', NULL, NULL, NULL, NULL, NULL, 4),
(77966, NULL, 'G3DSA:2.30.42.10:FF:000457', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77967, NULL, 'G3DSA:3.30.70.330:FF:000995', NULL, NULL, 'Putative RNA binding ribonucleoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(77968, NULL, 'G3DSA:1.25.40.420:FF:000046', NULL, NULL, 'Protein maternal effect lethal 26', NULL, NULL, NULL, NULL, NULL, 4),
(77969, NULL, 'G3DSA:2.20.70.10:FF:000146', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(77970, NULL, 'G3DSA:3.20.20.380:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77971, NULL, 'G3DSA:1.20.58.940:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77972, NULL, 'G3DSA:3.40.30.10:FF:000848', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(77973, NULL, 'G3DSA:1.25.10.10:FF:003080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77974, NULL, 'G3DSA:1.25.10.10:FF:003023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77975, NULL, 'G3DSA:3.40.50.150:FF:001137', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77976, NULL, 'G3DSA:2.60.120.650:FF:000029', NULL, NULL, 'lysine-specific demethylase JMJ30', NULL, NULL, NULL, NULL, NULL, 4),
(77977, NULL, 'G3DSA:1.20.1730.10:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77978, NULL, 'G3DSA:3.40.50.300:FF:007326', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77979, NULL, 'G3DSA:3.80.10.10:FF:004353', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(77980, NULL, 'G3DSA:3.40.50.1820:FF:000923', NULL, NULL, 'Family with sequence similarity 135 member B', NULL, NULL, NULL, NULL, NULL, 4),
(77981, NULL, 'G3DSA:2.60.40.1170:FF:000067', NULL, NULL, 'AP-1 adaptor complex mu subunit Apm1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(77982, NULL, 'G3DSA:3.40.710.10:FF:000123', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(77983, NULL, 'G3DSA:3.40.50.720:FF:001679', NULL, NULL, 'Short-chain dehydrogenase/reductase SDR', NULL, NULL, NULL, NULL, NULL, 4),
(77984, NULL, 'G3DSA:1.20.1740.10:FF:000181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77985, NULL, 'G3DSA:1.10.8.1190:FF:000006', NULL, NULL, 'Polyprotein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(77986, NULL, 'G3DSA:2.130.10.10:FF:005999', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77987, NULL, 'G3DSA:2.60.40.10:FF:005167', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77988, NULL, 'G3DSA:3.40.850.10:FF:000195', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(77989, NULL, 'G3DSA:1.20.5.420:FF:000022', NULL, NULL, 'Small glutamine-rich tetratricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(77990, NULL, 'G3DSA:3.40.1120.10:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(77991, NULL, 'G3DSA:3.30.70.330:FF:000287', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(77992, NULL, 'G3DSA:3.40.850.10:FF:000138', NULL, NULL, 'Myosin F, putative', NULL, NULL, NULL, NULL, NULL, 4),
(77993, NULL, 'G3DSA:3.40.1090.10:FF:000063', NULL, NULL, 'Uncharacterized NTE family protein M110.7', NULL, NULL, NULL, NULL, NULL, 4),
(77994, NULL, 'G3DSA:3.40.390.10:FF:000058', NULL, NULL, 'Metalloendoproteinase 5-MMP', NULL, NULL, NULL, NULL, NULL, 4),
(77995, NULL, 'G3DSA:1.25.40.10:FF:004863', NULL, NULL, 'Vacuolar protein sorting-associated protein 41', NULL, NULL, NULL, NULL, NULL, 4),
(77996, NULL, 'G3DSA:1.25.40.10:FF:004806', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(77997, NULL, 'G3DSA:3.30.230.10:FF:000217', NULL, NULL, 'Protein CBG03843', NULL, NULL, NULL, NULL, NULL, 4),
(77998, NULL, 'G3DSA:3.30.40.10:FF:000405', NULL, NULL, 'E3 ubiquitin-protein ligase CCNB1IP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(77999, NULL, 'G3DSA:3.40.50.12780:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78000, NULL, 'G3DSA:3.30.1370.120:FF:000003', NULL, NULL, 'General secretion pathway protein D', NULL, NULL, NULL, NULL, NULL, 4),
(78001, NULL, 'G3DSA:3.40.33.10:FF:000006', NULL, NULL, 'Putative pathogenesis-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(78002, NULL, 'G3DSA:2.60.40.10:FF:004268', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78003, NULL, 'G3DSA:3.90.360.10:FF:000005', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(78004, NULL, 'G3DSA:3.40.50.300:FF:006781', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78005, NULL, 'G3DSA:3.80.10.10:FF:004358', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78006, NULL, 'G3DSA:3.30.1490.480:FF:000008', NULL, NULL, 'Endolytic murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(78007, NULL, 'G3DSA:3.90.1150.10:FF:000534', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78008, NULL, 'G3DSA:3.90.190.10:FF:000256', NULL, NULL, 'mRNA capping enzyme, C-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(78009, NULL, 'G3DSA:3.40.309.10:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78010, NULL, 'G3DSA:3.30.160.60:FF:002677', NULL, NULL, 'Zinc finger protein 1028', NULL, NULL, NULL, NULL, NULL, 4),
(78011, NULL, 'G3DSA:3.40.1110.10:FF:000144', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(78012, NULL, 'G3DSA:1.20.58.390:FF:000299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78013, NULL, 'G3DSA:2.60.120.1020:FF:000005', NULL, NULL, 'PAW domain-containing protein Y50D4B.3', NULL, NULL, NULL, NULL, NULL, 4),
(78014, NULL, 'G3DSA:3.50.50.60:FF:000268', NULL, NULL, 'spermine oxidase isoform X2', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(78015, NULL, 'G3DSA:1.25.40.20:FF:001437', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78016, NULL, 'G3DSA:3.40.50.1820:FF:000362', NULL, NULL, 'Family of serine hydrolases', NULL, NULL, NULL, NULL, NULL, 4),
(78017, NULL, 'G3DSA:3.30.70.260:FF:000182', NULL, NULL, 'p-protein (PheA)', NULL, NULL, NULL, NULL, NULL, 4),
(78018, NULL, 'G3DSA:3.80.10.10:FF:002172', NULL, NULL, 'Sog2p', NULL, NULL, NULL, NULL, NULL, 4),
(78019, NULL, 'G3DSA:1.20.1310.10:FF:000093', NULL, NULL, 'Cullin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(78020, NULL, 'G3DSA:2.60.120.260:FF:000367', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(78021, NULL, 'G3DSA:3.40.190.10:FF:000335', NULL, NULL, 'Putative amino acid ABC transporter, periplasmic amino acid-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(78022, NULL, 'G3DSA:3.100.10.10:FF:000062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78023, NULL, 'G3DSA:2.10.250.10:FF:000002', NULL, NULL, 'Calreticulin', NULL, NULL, NULL, NULL, NULL, 4),
(78024, NULL, 'G3DSA:3.10.400.20:FF:000002', NULL, NULL, 'Eukaryotic translation initiation factor 2D', NULL, NULL, NULL, NULL, NULL, 4),
(78025, NULL, 'G3DSA:1.25.10.10:FF:001932', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78026, NULL, 'G3DSA:1.10.238.10:FF:001118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78027, NULL, 'G3DSA:1.25.40.10:FF:001434', NULL, NULL, 'MAU2 chromatid cohesion factor', NULL, NULL, NULL, NULL, NULL, 4),
(78028, NULL, 'G3DSA:1.10.4160.10:FF:000010', NULL, NULL, 'Hydroxymethylpyrimidine transporter CytX', NULL, NULL, NULL, NULL, NULL, 4),
(78029, NULL, 'G3DSA:3.30.70.330:FF:002530', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78030, NULL, 'G3DSA:2.60.120.200:FF:000361', NULL, NULL, 'Laminin, alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(78031, NULL, 'G3DSA:1.20.1740.10:FF:000057', NULL, NULL, 'Cystine/glutamate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(78032, NULL, 'G3DSA:1.10.940.10:FF:000019', NULL, NULL, 'Transcription antitermination protein NusB', NULL, NULL, NULL, NULL, NULL, 4),
(78033, NULL, 'G3DSA:1.20.1250.60:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78034, NULL, 'G3DSA:2.60.40.10:FF:001042', NULL, NULL, 'Protein-glutamine gamma-glutamyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(78035, NULL, 'G3DSA:3.30.750.24:FF:000068', NULL, NULL, 'SULfate Permease family', NULL, NULL, NULL, NULL, NULL, 4),
(78036, NULL, 'G3DSA:3.30.450.40:FF:000294', NULL, NULL, 'PAS sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(78037, NULL, 'G3DSA:1.10.510.10:FF:003814', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78038, NULL, 'G3DSA:3.40.720.10:FF:000005', NULL, NULL, 'Phosphopentomutase', NULL, NULL, NULL, NULL, NULL, 4),
(78039, NULL, 'G3DSA:3.10.129.10:FF:000245', NULL, NULL, 'Acyl-CoA thioester hydrolase, YbgC/YbaW family in fatty acid biosynthesis locus', NULL, NULL, NULL, NULL, NULL, 4),
(78040, NULL, 'G3DSA:3.80.10.10:FF:000143', NULL, NULL, 'PH domain leucine-rich repeat-containing protein phosphatase 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(78041, NULL, 'G3DSA:2.60.40.60:FF:000539', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78042, NULL, 'G3DSA:2.40.30.170:FF:000042', NULL, NULL, 'RND family efflux transporter, MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(78043, NULL, 'G3DSA:2.60.9.10:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78044, NULL, 'G3DSA:3.80.10.10:FF:004263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78045, NULL, 'G3DSA:2.30.30.40:FF:000186', NULL, NULL, 'Nitric oxide synthase trafficking', NULL, NULL, NULL, NULL, NULL, 4),
(78046, NULL, 'G3DSA:1.20.1250.20:FF:000039', NULL, NULL, 'Multidrug resistance protein MdtH', NULL, NULL, NULL, NULL, NULL, 4),
(78047, NULL, 'G3DSA:3.40.50.2300:FF:000466', NULL, NULL, 'Receptor-type adenylate cyclase GRESAG 4, putative', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(78048, NULL, 'G3DSA:3.30.200.20:FF:002282', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(78049, NULL, 'G3DSA:1.25.40.20:FF:001342', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78050, NULL, 'G3DSA:1.20.1070.10:FF:002029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78051, NULL, 'G3DSA:2.20.110.10:FF:000035', NULL, NULL, 'MORN repeat-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(78052, NULL, 'G3DSA:3.30.1050.10:FF:000006', NULL, NULL, 'Non-specific lipid-transfer protein-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(78053, NULL, 'G3DSA:1.25.10.10:FF:000943', NULL, NULL, 'AP-3 complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(78054, NULL, 'G3DSA:3.80.10.10:FF:002234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78055, NULL, 'G3DSA:3.30.70.270:FF:000185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78056, NULL, 'G3DSA:1.20.5.170:FF:000290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78057, NULL, 'G3DSA:1.10.3500.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78058, NULL, 'G3DSA:3.30.1680.10:FF:000037', NULL, NULL, 'Plexin b2a', NULL, NULL, NULL, NULL, NULL, 4),
(78059, NULL, 'G3DSA:3.30.1370.10:FF:000227', NULL, NULL, 'Far upstream element-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(78060, NULL, 'G3DSA:3.30.540.10:FF:000078', NULL, NULL, 'Monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(78061, NULL, 'G3DSA:1.10.600.10:FF:000028', NULL, NULL, 'Dehydrosqualene synthase', NULL, NULL, NULL, NULL, NULL, 4),
(78062, NULL, 'G3DSA:2.60.40.10:FF:005257', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78063, NULL, 'G3DSA:3.40.50.300:FF:007770', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78064, NULL, 'G3DSA:3.30.40.10:FF:000456', NULL, NULL, 'RING-H2 finger protein ATL16', NULL, NULL, NULL, NULL, NULL, 4),
(78065, NULL, 'G3DSA:3.20.20.80:FF:000077', NULL, NULL, 'Arabinogalactan endo-beta-1,4-galactanase', NULL, NULL, NULL, NULL, NULL, 4),
(78066, NULL, 'G3DSA:1.10.510.10:FF:003073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78067, NULL, 'G3DSA:1.10.10.60:FF:000750', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(78068, NULL, 'G3DSA:3.30.420.40:FF:000466', NULL, NULL, 'Actin-Related Proteins', NULL, NULL, NULL, NULL, NULL, 4),
(78069, NULL, 'G3DSA:3.50.50.60:FF:000173', NULL, NULL, 'Putative thioredoxin reductase', NULL, NULL, NULL, NULL, NULL, 4),
(78070, NULL, 'G3DSA:3.60.10.10:FF:000211', NULL, NULL, 'Type II inositol polyphosphate 5-phosphatase 15', NULL, NULL, NULL, NULL, NULL, 4),
(78071, NULL, 'G3DSA:3.40.640.10:FF:000185', NULL, NULL, 'Ornithine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(78072, NULL, 'G3DSA:1.10.510.10:FF:001095', NULL, NULL, 'SRPK3 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(78073, NULL, 'G3DSA:1.25.40.10:FF:000771', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(78074, NULL, 'G3DSA:1.10.437.10:FF:000024', NULL, NULL, 'BCL-WAV', NULL, NULL, NULL, NULL, NULL, 4),
(78075, NULL, 'G3DSA:1.10.418.10:FF:000278', NULL, NULL, 'Plastin 1', NULL, NULL, NULL, NULL, NULL, 4),
(78076, NULL, 'G3DSA:1.20.1070.10:FF:000264', NULL, NULL, '5-hydroxytryptamine receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(78077, NULL, 'G3DSA:2.60.40.10:FF:003071', NULL, NULL, 'Protein sax-3', NULL, NULL, NULL, NULL, NULL, 4),
(78078, NULL, 'G3DSA:3.40.50.2000:FF:001051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78079, NULL, 'G3DSA:3.60.40.10:FF:000185', NULL, NULL, 'TGF-beta-activated kinase 1 and MAP3K7-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(78080, NULL, 'G3DSA:3.30.70.270:FF:000134', NULL, NULL, 'DNA polymerase kappa', NULL, NULL, NULL, NULL, NULL, 4),
(78081, NULL, 'G3DSA:3.30.460.20:FF:000029', NULL, NULL, 'CorA family magnesium ion transporter', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(78082, NULL, 'G3DSA:3.30.70.260:FF:000131', NULL, NULL, 'Chorismate mutase/prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(78083, NULL, 'G3DSA:3.20.20.70:FF:000074', NULL, NULL, 'Ribulose-phosphate 3-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(78084, NULL, 'G3DSA:1.20.1270.60:FF:000120', NULL, NULL, 'YPR115W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(78085, NULL, 'G3DSA:3.90.190.10:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78086, NULL, 'G3DSA:3.40.50.800:FF:000118', NULL, NULL, 'Histidyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78087, NULL, 'G3DSA:3.30.465.10:FF:000015', NULL, NULL, 'Quinone-dependent D-lactate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(78088, NULL, 'G3DSA:3.40.50.150:FF:001750', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78089, NULL, 'G3DSA:2.40.70.10:FF:000095', NULL, NULL, 'Aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(78090, NULL, 'G3DSA:2.30.30.550:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78091, NULL, 'G3DSA:3.20.20.20:FF:000020', NULL, NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(78092, NULL, 'G3DSA:1.25.40.20:FF:000240', NULL, NULL, 'Water witch, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(78093, NULL, 'G3DSA:3.40.710.10:FF:000033', NULL, NULL, 'Beta-lactamase', NULL, NULL, NULL, NULL, NULL, 4),
(78094, NULL, 'G3DSA:2.60.40.770:FF:000028', NULL, NULL, 'Salivary lipid interacting protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78095, NULL, 'G3DSA:2.60.40.60:FF:001096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78096, NULL, 'G3DSA:1.10.510.10:FF:000959', NULL, NULL, 'Cyclin-dependent kinase F-1', NULL, NULL, NULL, NULL, NULL, 4),
(78097, NULL, 'G3DSA:3.40.50.720:FF:002163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78098, NULL, 'G3DSA:3.30.300.30:FF:000139', NULL, NULL, 'HC-toxin synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(78099, NULL, 'G3DSA:3.30.260.10:FF:000096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78100, NULL, 'G3DSA:3.40.190.290:FF:000063', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(78101, NULL, 'G3DSA:1.10.630.10:FF:000209', NULL, NULL, 'Os07g0491800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(78102, NULL, 'G3DSA:1.25.40.10:FF:002862', NULL, NULL, 'At3g09490', NULL, NULL, NULL, NULL, NULL, 4),
(78103, NULL, 'G3DSA:1.20.1280.290:FF:000075', NULL, NULL, 'YALI0D02046p', NULL, NULL, NULL, NULL, NULL, 4),
(78104, NULL, 'G3DSA:1.25.40.10:FF:004986', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78105, NULL, 'G3DSA:2.60.120.650:FF:000035', NULL, NULL, 'PHD transcription factor Rum1', NULL, NULL, NULL, NULL, NULL, 4),
(78106, NULL, 'G3DSA:1.20.120.1080:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78107, NULL, 'G3DSA:3.30.160.60:FF:004768', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78108, NULL, 'G3DSA:4.10.240.10:FF:000106', NULL, NULL, 'YLL054C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(78109, NULL, 'G3DSA:1.20.80.10:FF:000036', NULL, NULL, 'FERM domain (Protein4.1-ezrin-radixin-moesin) family', NULL, NULL, NULL, NULL, NULL, 4),
(78110, NULL, 'G3DSA:3.20.20.30:FF:000023', NULL, NULL, 'LLM class flavin-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(78111, NULL, 'G3DSA:1.25.40.20:FF:000774', NULL, NULL, 'Os11g0108600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(78112, NULL, 'G3DSA:1.10.275.40:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78113, NULL, 'G3DSA:3.80.10.10:FF:003695', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(78114, NULL, 'G3DSA:1.20.1720.10:FF:000062', NULL, NULL, 'L-Proline/Glycine betaine transporter ProP', NULL, NULL, NULL, NULL, NULL, 4),
(78115, NULL, 'G3DSA:1.10.10.60:FF:000845', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78116, NULL, 'G3DSA:3.90.1110.10:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(78117, NULL, 'G3DSA:1.20.58.60:FF:000207', NULL, NULL, 'Dystrophin', NULL, NULL, NULL, NULL, NULL, 4),
(78118, NULL, 'G3DSA:3.40.47.10:FF:000027', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(78119, NULL, 'G3DSA:3.40.50.300:FF:004538', NULL, NULL, 'Java no jive', NULL, NULL, NULL, NULL, NULL, 4),
(78120, NULL, 'G3DSA:1.10.287.580:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78121, NULL, 'G3DSA:2.115.10.20:FF:000018', NULL, NULL, 'Arylsulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(78122, NULL, 'G3DSA:3.30.200.20:FF:000718', NULL, NULL, 'CMGC/CLK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(78123, NULL, 'G3DSA:2.60.120.1030:FF:000008', NULL, NULL, 'mRNA cleavage and polyadenylation factor CLP1', NULL, NULL, NULL, NULL, NULL, 4),
(78124, NULL, 'G3DSA:2.130.10.10:FF:004925', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78125, NULL, 'G3DSA:1.20.5.1150:FF:000003', NULL, NULL, 'Putative ribosomal protein S21', NULL, NULL, NULL, NULL, NULL, 4),
(78126, NULL, 'G3DSA:1.10.287.70:FF:000406', NULL, NULL, 'TWiK family of potassium channels protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(78127, NULL, 'G3DSA:1.20.1560.10:FF:000234', NULL, NULL, 'ABC transporter putative', NULL, NULL, NULL, NULL, NULL, 4),
(78128, NULL, 'G3DSA:3.40.710.10:FF:000128', NULL, NULL, 'Penicillin-binding protein 4B', NULL, NULL, NULL, NULL, NULL, 4),
(78129, NULL, 'G3DSA:3.40.50.1220:FF:000070', NULL, NULL, 'Transcriptional regulator, Sir2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(78130, NULL, 'G3DSA:3.30.70.2850:FF:000004', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(78131, NULL, 'G3DSA:3.50.50.60:FF:000594', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(78132, NULL, 'G3DSA:1.10.472.10:FF:000336', NULL, NULL, 'Cyclin domain-containing protein, variant 2', NULL, NULL, NULL, NULL, NULL, 4),
(78133, NULL, 'G3DSA:2.60.40.10:FF:001772', NULL, NULL, 'filamin-A isoform X9', NULL, NULL, NULL, NULL, NULL, 4),
(78134, NULL, 'G3DSA:1.10.455.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78135, NULL, 'G3DSA:3.60.10.10:FF:000306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78136, NULL, 'G3DSA:2.60.40.10:FF:005162', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78137, NULL, 'G3DSA:3.40.50.1760:FF:000006', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(78138, NULL, 'G3DSA:3.40.50.1000:FF:000863', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78139, NULL, 'G3DSA:1.20.1250.20:FF:000253', NULL, NULL, 'Transporter, major facilitator family', NULL, NULL, NULL, NULL, NULL, 4),
(78140, NULL, 'G3DSA:3.30.300.30:FF:000044', NULL, NULL, 'Long-chain-fatty-acid--[acyl-carrier-protein] ligase AEE15, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(78141, NULL, 'G3DSA:3.30.70.2840:FF:000001', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(78142, NULL, 'G3DSA:3.40.630.10:FF:000471', NULL, NULL, 'Aspartoacylase', NULL, NULL, NULL, NULL, NULL, 4),
(78143, NULL, 'G3DSA:3.20.20.300:FF:000029', NULL, NULL, 'Auxin-induced beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(78144, NULL, 'G3DSA:3.80.10.10:FF:002560', NULL, NULL, 'Flagellar Member 5', NULL, NULL, NULL, NULL, NULL, 4),
(78145, NULL, 'G3DSA:3.30.9.100:FF:000002', NULL, NULL, 'Tryptophan 2-halogenase', NULL, NULL, NULL, NULL, NULL, 4),
(78146, NULL, 'G3DSA:2.130.10.10:FF:002885', NULL, NULL, 'LLGL scribble cell polarity complex component 1', NULL, NULL, NULL, NULL, NULL, 4),
(78147, NULL, 'G3DSA:2.20.70.10:FF:000258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78148, NULL, 'G3DSA:1.20.5.170:FF:000076', NULL, NULL, 'Lamin B2', NULL, NULL, NULL, NULL, NULL, 4),
(78149, NULL, 'G3DSA:1.25.10.10:FF:000617', NULL, NULL, 'PUF1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78150, NULL, 'G3DSA:1.10.340.30:FF:000053', NULL, NULL, 'DNA-(Apurinic or apyrimidinic site) lyase (Endonuclease III, PaNth)', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(78151, NULL, 'G3DSA:1.25.10.10:FF:003282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78152, NULL, 'G3DSA:3.30.70.1450:FF:000034', NULL, NULL, 'Trk system potassium uptake protein TrkA', NULL, NULL, NULL, NULL, NULL, 4),
(78153, NULL, 'G3DSA:3.90.228.10:FF:000024', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(78154, NULL, 'G3DSA:3.40.50.150:FF:000289', NULL, NULL, 'Chemotaxis protein methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(78155, NULL, 'G3DSA:1.25.40.710:FF:000009', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(78156, NULL, 'G3DSA:2.40.50.140:FF:000559', NULL, NULL, 'Ribonuclease E/G', NULL, NULL, NULL, NULL, NULL, 4),
(78157, NULL, 'G3DSA:2.30.42.10:FF:000570', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78158, NULL, 'G3DSA:3.30.559.10:FF:000284', NULL, NULL, 'Carnitine acyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78159, NULL, 'G3DSA:2.60.40.10:FF:004594', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78160, NULL, 'G3DSA:1.10.275.20:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78161, NULL, 'G3DSA:1.20.920.10:FF:000016', NULL, NULL, 'bromodomain-containing protein 8 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(78162, NULL, 'G3DSA:1.20.1250.20:FF:002344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78163, NULL, 'G3DSA:3.40.50.11320:FF:000007', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(78164, NULL, 'G3DSA:3.30.420.10:FF:000305', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(78165, NULL, 'G3DSA:3.30.160.60:FF:005532', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78166, NULL, 'G3DSA:1.25.10.10:FF:002293', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78167, NULL, 'G3DSA:3.10.20.230:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78168, NULL, 'G3DSA:1.10.10.10:FF:001134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78169, NULL, 'G3DSA:2.130.10.10:FF:004572', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78170, NULL, 'G3DSA:2.130.10.10:FF:002947', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78171, NULL, 'G3DSA:1.10.12.70:FF:000004', NULL, NULL, 'Serine/threonine-protein kinase 26', NULL, NULL, NULL, NULL, NULL, 4),
(78172, NULL, 'G3DSA:2.130.10.10:FF:004976', NULL, NULL, 'DDB1- and CUL4-associated factor 11', NULL, NULL, NULL, NULL, NULL, 4),
(78173, NULL, 'G3DSA:3.30.300.20:FF:000041', NULL, NULL, 'Probable transcription termination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(78174, NULL, 'G3DSA:1.20.5.1160:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78175, NULL, 'G3DSA:3.80.10.10:FF:000194', NULL, NULL, 'Si:dkey-16p6.1', NULL, NULL, NULL, NULL, NULL, 4),
(78176, NULL, 'G3DSA:3.30.70.1730:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78177, NULL, 'G3DSA:1.25.10.10:FF:001606', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78178, NULL, 'G3DSA:3.10.50.10:FF:000064', NULL, NULL, 'Glutamate carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78179, NULL, 'G3DSA:3.40.50.360:FF:000121', NULL, NULL, 'Methionine synthase reductase, mitochondrial-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(78180, NULL, 'G3DSA:3.30.160.60:FF:002891', NULL, NULL, 'zinc finger protein 75A-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(78181, NULL, 'G3DSA:2.30.29.30:FF:001101', NULL, NULL, 'RanBP1 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(78182, NULL, 'G3DSA:3.30.260.10:FF:000045', NULL, NULL, 'T-complex protein 1 subunit zeta', NULL, NULL, NULL, NULL, NULL, 4),
(78183, NULL, 'G3DSA:1.10.287.130:FF:000166', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(78184, NULL, 'G3DSA:1.10.260.100:FF:000008', NULL, NULL, 'Protein TIC 40, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(78185, NULL, 'G3DSA:3.30.1370.50:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78186, NULL, 'G3DSA:2.130.10.10:FF:001750', NULL, NULL, 'WGS project CABT00000000 data, contig 2.18', NULL, NULL, NULL, NULL, NULL, 4),
(78187, NULL, 'G3DSA:1.20.120.350:FF:000011', NULL, NULL, 'Voltage-dependent N-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(78188, NULL, 'G3DSA:3.40.50.10880:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78189, NULL, 'G3DSA:2.130.10.10:FF:005061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78190, NULL, 'G3DSA:3.40.50.2000:FF:000820', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78191, NULL, 'G3DSA:1.10.12.10:FF:000014', NULL, NULL, 'Enoyl-CoA hydratase/carnithine racemase', NULL, NULL, NULL, NULL, NULL, 4),
(78192, NULL, 'G3DSA:2.30.42.10:FF:000631', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78193, NULL, 'G3DSA:3.40.50.11260:FF:000028', NULL, NULL, 'Putative heat shock protein HSP 90-alpha A4', NULL, NULL, NULL, NULL, NULL, 4),
(78194, NULL, 'G3DSA:1.10.8.10:FF:000037', NULL, NULL, 'E3 ubiquitin-protein ligase CBL-B isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(78195, NULL, 'G3DSA:3.90.25.10:FF:000047', NULL, NULL, 'NmrA-like family protein', NULL, NULL, NULL, NULL, NULL, 4),
(78196, NULL, 'G3DSA:3.40.50.10890:FF:000018', NULL, NULL, 'Cleavage and polyadenylation specificity factor 73-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(78197, NULL, 'G3DSA:1.25.40.10:FF:001108', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(78198, NULL, 'G3DSA:1.20.920.20:FF:000019', NULL, NULL, 'Excreted/secreted protein 31', NULL, NULL, NULL, NULL, NULL, 4),
(78199, NULL, 'G3DSA:3.40.50.1240:FF:000137', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78200, NULL, 'G3DSA:1.10.287.70:FF:000518', NULL, NULL, 'Polycystic kidney disease and receptor for egg jelly-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(78201, NULL, 'G3DSA:3.40.50.150:FF:000968', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78202, NULL, 'G3DSA:3.40.1800.20:FF:000003', NULL, NULL, 'D19B', NULL, NULL, NULL, NULL, NULL, 4),
(78203, NULL, 'G3DSA:3.30.230.10:FF:000268', NULL, NULL, 'GHMP kinase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(78204, NULL, 'G3DSA:2.70.160.11:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78205, NULL, 'G3DSA:1.20.1560.10:FF:000285', NULL, NULL, 'Cadmium ion transporter', NULL, NULL, NULL, NULL, NULL, 4),
(78206, NULL, 'G3DSA:2.60.40.10:FF:000957', NULL, NULL, 'Interferon gamma receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(78207, NULL, 'G3DSA:3.30.1780.10:FF:000022', NULL, NULL, 'Ornithine cyclodeaminase related protein (Ocd-like2)', NULL, NULL, NULL, NULL, NULL, 4),
(78208, NULL, 'G3DSA:3.30.200.20:FF:000769', NULL, NULL, 'Mitogen-activated protein kinase 14', NULL, NULL, NULL, NULL, NULL, 4),
(78209, NULL, 'G3DSA:2.60.40.10:FF:001721', NULL, NULL, 'KETtiN (Drosophila actin-binding) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(78210, NULL, 'G3DSA:2.170.300.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78211, NULL, 'G3DSA:1.10.472.10:FF:000387', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78212, NULL, 'G3DSA:3.40.50.620:FF:000508', NULL, NULL, 'Deoxyribodipyrimidine photolyase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78213, NULL, 'G3DSA:1.10.110.10:FF:000007', NULL, NULL, '19 kDa globulin', NULL, NULL, NULL, NULL, NULL, 4),
(78214, NULL, 'G3DSA:3.40.50.1460:FF:000118', NULL, NULL, 'GPI-anchor transamidase', NULL, NULL, NULL, NULL, NULL, 4),
(78215, NULL, 'G3DSA:1.20.1070.10:FF:000152', NULL, NULL, 'uracil nucleotide/cysteinyl leukotriene receptor', NULL, NULL, NULL, NULL, NULL, 4),
(78216, NULL, 'G3DSA:2.10.110.10:FF:000138', NULL, NULL, 'Signal transducer', NULL, NULL, NULL, NULL, NULL, 4),
(78217, NULL, 'G3DSA:3.30.465.10:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(78218, NULL, 'G3DSA:1.10.510.10:FF:003135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78219, NULL, 'G3DSA:3.40.50.1220:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78220, NULL, 'G3DSA:3.40.50.300:FF:006876', NULL, NULL, 'GPN-loop GTPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(78221, NULL, 'G3DSA:1.50.10.130:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78222, NULL, 'G3DSA:2.60.120.290:FF:000056', NULL, NULL, 'C-type LECtin', NULL, NULL, NULL, NULL, NULL, 4),
(78223, NULL, 'G3DSA:1.10.630.10:FF:000535', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78224, NULL, 'G3DSA:3.10.20.370:FF:000001', NULL, NULL, 'Retrovirus-related Pol polyprotein from transposon 17.6-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(78225, NULL, 'G3DSA:3.30.50.10:FF:000075', NULL, NULL, 'Gat3p', NULL, NULL, NULL, NULL, NULL, 4),
(78226, NULL, 'G3DSA:3.30.1740.10:FF:000008', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(78227, NULL, 'G3DSA:3.10.129.10:FF:000183', NULL, NULL, 'Acyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(78228, NULL, 'G3DSA:2.70.40.10:FF:000024', NULL, NULL, 'Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(78229, NULL, 'G3DSA:3.40.50.800:FF:000006', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(78230, NULL, 'G3DSA:3.90.10.10:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78231, NULL, 'G3DSA:3.50.50.60:FF:000914', NULL, NULL, 'Amine oxidase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(78232, NULL, 'G3DSA:3.30.160.60:FF:005583', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78233, NULL, 'G3DSA:3.40.50.300:FF:005527', NULL, NULL, 'ABC transporter I family member 21', NULL, NULL, NULL, NULL, NULL, 4),
(78234, NULL, 'G3DSA:3.30.70.330:FF:000490', NULL, NULL, 'heterogeneous nuclear ribonucleoprotein R isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(78235, NULL, 'G3DSA:1.10.40.90:FF:000002', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(78236, NULL, 'G3DSA:3.60.40.10:FF:000308', NULL, NULL, 'Protein phosphatase 2C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78237, NULL, 'G3DSA:1.25.10.10:FF:001511', NULL, NULL, 'Chromosome 9 SCAF14991, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(78238, NULL, 'G3DSA:1.25.10.10:FF:002388', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78239, NULL, 'G3DSA:3.30.465.10:FF:000066', NULL, NULL, 'FAD-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(78240, NULL, 'G3DSA:3.40.50.720:FF:000813', NULL, NULL, 'Probable short-chain dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(78241, NULL, 'G3DSA:1.20.5.2950:FF:000003', NULL, NULL, 'V-type proton ATPase subunit G', NULL, NULL, NULL, NULL, NULL, 4),
(78242, NULL, 'G3DSA:3.40.50.1010:FF:000006', NULL, NULL, 'rRNA-processing protein UTP23 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(78243, NULL, 'G3DSA:2.60.120.590:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78244, NULL, 'G3DSA:2.60.40.10:FF:003812', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78245, NULL, 'G3DSA:2.60.40.10:FF:004998', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78246, NULL, 'G3DSA:2.60.120.200:FF:000209', NULL, NULL, 'Laminin subunit alpha 5', NULL, NULL, NULL, NULL, NULL, 4),
(78247, NULL, 'G3DSA:2.40.50.140:FF:000773', NULL, NULL, 'Meiosis specific with OB domains', NULL, NULL, NULL, NULL, NULL, 4),
(78248, NULL, 'G3DSA:1.10.287.70:FF:000311', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(78249, NULL, 'G3DSA:1.25.10.10:FF:001191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78250, NULL, 'G3DSA:1.10.3370.10:FF:000031', NULL, NULL, 'Preprotein translocase secY subunit', NULL, NULL, NULL, NULL, NULL, 4),
(78251, NULL, 'G3DSA:2.30.30.100:FF:000231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78252, NULL, 'G3DSA:3.90.550.60:FF:000001', NULL, NULL, 'UDP-galactofuranosyl transferase GlfT2', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(78253, NULL, 'G3DSA:3.30.70.330:FF:002581', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78254, NULL, 'G3DSA:1.25.40.10:FF:002569', NULL, NULL, 'NPG1', NULL, NULL, NULL, NULL, NULL, 4),
(78255, NULL, 'G3DSA:1.10.150.20:FF:000333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78256, NULL, 'G3DSA:3.40.50.1000:FF:000003', NULL, NULL, 'HAD-IIB family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(78257, NULL, 'G3DSA:1.10.510.10:FF:001044', NULL, NULL, 'Probable serine/threonine-protein kinase fhkB', NULL, NULL, NULL, NULL, NULL, 4),
(78258, NULL, 'G3DSA:2.10.25.10:FF:000452', NULL, NULL, 'thyroid peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(78259, NULL, 'G3DSA:1.10.260.40:FF:000055', NULL, NULL, 'XRE family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(78260, NULL, 'G3DSA:2.40.30.10:FF:000098', NULL, NULL, 'FAD binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(78261, NULL, 'G3DSA:3.30.2080.10:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78262, NULL, 'G3DSA:3.10.20.10:FF:000006', NULL, NULL, 'DNA fragmentation factor subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(78263, NULL, 'G3DSA:3.40.50.300:FF:006955', NULL, NULL, 'Probable lipoprotein releasing system, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(78264, NULL, 'G3DSA:3.30.450.20:FF:000315', NULL, NULL, 'Sensor histidine kinase HpkA', NULL, NULL, NULL, NULL, NULL, 4),
(78265, NULL, 'G3DSA:1.20.950.20:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78266, NULL, 'G3DSA:1.25.10.10:FF:001039', NULL, NULL, 'Transcription enhancer protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78267, NULL, 'G3DSA:1.10.8.10:FF:000312', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78268, NULL, 'G3DSA:2.60.34.10:FF:000044', NULL, NULL, 'Heat shock protein 70, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78269, NULL, 'G3DSA:3.30.420.40:FF:000819', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(78270, NULL, 'G3DSA:3.30.40.10:FF:000517', NULL, NULL, 'anaphase-promoting complex subunit 11', NULL, NULL, NULL, NULL, NULL, 4),
(78271, NULL, 'G3DSA:3.30.200.20:FF:002394', NULL, NULL, 'Probable serine/threonine-protein kinase DDB_G0288147', NULL, NULL, NULL, NULL, NULL, 4),
(78272, NULL, 'G3DSA:2.60.40.10:FF:001800', NULL, NULL, 'Basal cell adhesion molecule', NULL, NULL, NULL, NULL, NULL, 4),
(78273, NULL, 'G3DSA:1.10.510.10:FF:001218', NULL, NULL, 'Related to calmodulin-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(78274, NULL, 'G3DSA:1.10.150.50:FF:000151', NULL, NULL, 'Putative ets proteinous factor', NULL, NULL, NULL, NULL, NULL, 4),
(78275, NULL, 'G3DSA:3.30.1520.10:FF:000144', NULL, NULL, 'Sorting nexin C1711.11', NULL, NULL, NULL, NULL, NULL, 4),
(78276, NULL, 'G3DSA:1.20.58.60:FF:000084', NULL, NULL, 'microtubule-actin cross-linking factor 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(78277, NULL, 'G3DSA:3.40.50.720:FF:000864', NULL, NULL, 'SUMO-activating enzyme subunit', NULL, NULL, NULL, NULL, NULL, 4),
(78278, NULL, 'G3DSA:1.10.30.10:FF:000079', NULL, NULL, 'IXR1p Transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(78279, NULL, 'G3DSA:3.40.50.720:FF:001674', NULL, NULL, '2-hydroxyacid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(78280, NULL, 'G3DSA:3.30.40.10:FF:002081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78281, NULL, 'G3DSA:1.10.510.10:FF:001448', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(78282, NULL, 'G3DSA:2.40.70.10:FF:000448', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78283, NULL, 'G3DSA:3.30.70.330:FF:002642', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78284, NULL, 'G3DSA:3.30.70.600:FF:000003', NULL, NULL, '30S ribosomal protein S10', NULL, NULL, NULL, NULL, NULL, 4),
(78285, NULL, 'G3DSA:2.60.40.790:FF:000186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78286, NULL, 'G3DSA:1.10.238.10:FF:000859', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(78287, NULL, 'G3DSA:3.30.70.330:FF:000613', NULL, NULL, 'Nuclear pore complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(78288, NULL, 'G3DSA:2.130.10.10:FF:003902', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78289, NULL, 'G3DSA:3.40.50.300:FF:001930', NULL, NULL, 'ABC ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(78290, NULL, 'G3DSA:3.30.565.10:FF:000276', NULL, NULL, 'Sensor kinase, EraS', NULL, NULL, NULL, NULL, NULL, 4),
(78291, NULL, 'G3DSA:3.90.70.70:FF:000001', NULL, NULL, 'Replicase polyprotein 1ab', NULL, NULL, NULL, NULL, NULL, 4),
(78292, NULL, 'G3DSA:3.40.50.300:FF:001087', NULL, NULL, 'ZGRF1 isoform 9', NULL, NULL, NULL, NULL, NULL, 4),
(78293, NULL, 'G3DSA:3.30.70.260:FF:000070', NULL, NULL, 'Acetolactate synthase, small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(78294, NULL, 'G3DSA:3.30.50.10:FF:000024', NULL, NULL, 'Androgen receptor', NULL, NULL, NULL, NULL, NULL, 4),
(78295, NULL, 'G3DSA:1.10.1600.10:FF:000027', NULL, NULL, 'ATP-dependent DNA helicase II subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(78296, NULL, 'G3DSA:2.20.28.120:FF:000006', NULL, NULL, '50S ribosomal protein L33', NULL, NULL, NULL, NULL, NULL, 4),
(78297, NULL, 'G3DSA:3.60.130.10:FF:000057', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(78298, NULL, 'G3DSA:3.30.70.330:FF:000843', NULL, NULL, 'Nucleic acid-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(78299, NULL, 'G3DSA:1.10.287.770:FF:000004', NULL, NULL, 'TYRO protein tyrosine kinase-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(78300, NULL, 'G3DSA:2.30.29.30:FF:000612', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(78301, NULL, 'G3DSA:3.30.2010.10:FF:000009', NULL, NULL, 'metalloendopeptidase OMA1, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(78302, NULL, 'G3DSA:3.30.70.560:FF:000002', NULL, NULL, '2-amino-4-hydroxy-6-hydroxymethyldihydropteridine diphosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(78303, NULL, 'G3DSA:3.90.70.80:FF:000004', NULL, NULL, 'deubiquitinating protein VCIP135 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(78304, NULL, 'G3DSA:3.90.550.20:FF:000017', NULL, NULL, 'Glycosyl transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78305, NULL, 'G3DSA:1.20.1560.10:FF:000560', NULL, NULL, 'ABC transporter B family member 19', NULL, NULL, NULL, NULL, NULL, 4),
(78306, NULL, 'G3DSA:1.10.510.10:FF:002679', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78307, NULL, 'G3DSA:1.20.1250.20:FF:002018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78308, NULL, 'G3DSA:2.60.40.10:FF:001446', NULL, NULL, 'Down syndrome cell adhesion molecule-like protein Dscam2', NULL, NULL, NULL, NULL, NULL, 4),
(78309, NULL, 'G3DSA:2.20.100.10:FF:000124', NULL, NULL, 'Spondin-1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(78310, NULL, 'G3DSA:3.80.10.10:FF:004151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78311, NULL, 'G3DSA:1.20.58.1480:FF:000017', NULL, NULL, 'Lon protease homolog, mitochondrial 1', NULL, NULL, NULL, NULL, NULL, 4),
(78312, NULL, 'G3DSA:2.20.25.20:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78313, NULL, 'G3DSA:3.80.10.10:FF:002346', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78314, NULL, 'G3DSA:3.30.160.60:FF:004689', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78315, NULL, 'G3DSA:3.40.50.720:FF:001966', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(78316, NULL, 'G3DSA:3.30.200.20:FF:001112', NULL, NULL, 'Elongation factor 2 kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78317, NULL, 'G3DSA:1.25.40.180:FF:000103', NULL, NULL, 'nuclear cap-binding protein subunit 1-A-like', NULL, NULL, NULL, NULL, NULL, 4),
(78318, NULL, 'G3DSA:3.30.70.270:FF:000073', NULL, NULL, 'Diguanylate cyclase (GGDEF) domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(78319, NULL, 'G3DSA:3.40.50.150:FF:001424', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78320, NULL, 'G3DSA:2.130.10.10:FF:000856', NULL, NULL, 'ER membrane protein complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(78321, NULL, 'G3DSA:3.30.740.10:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78322, NULL, 'G3DSA:3.30.70.1130:FF:000005', NULL, NULL, 'Putative elongation initiation factor 2 alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(78323, NULL, 'G3DSA:3.40.50.1820:FF:000423', NULL, NULL, 'YGR015C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(78324, NULL, 'G3DSA:1.10.1300.10:FF:000049', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(78325, NULL, 'G3DSA:2.170.8.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78326, NULL, 'G3DSA:1.25.40.10:FF:003025', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(78327, NULL, 'G3DSA:1.10.246.140:FF:000003', NULL, NULL, 'Transcription and mRNA export factor SUS1', NULL, NULL, NULL, NULL, NULL, 4),
(78328, NULL, 'G3DSA:2.60.40.420:FF:000007', NULL, NULL, 'Cell division protein FtsP', NULL, NULL, NULL, NULL, NULL, 4),
(78329, NULL, 'G3DSA:3.30.450.20:FF:000136', NULL, NULL, 'Sensor histidine kinase/response regulator Fos-1', NULL, NULL, NULL, NULL, NULL, 4),
(78330, NULL, 'G3DSA:3.90.180.10:FF:000019', NULL, NULL, 'Prostaglandin reductase 2', NULL, NULL, NULL, NULL, NULL, 4),
(78331, NULL, 'G3DSA:3.30.200.20:FF:000657', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(78332, NULL, 'G3DSA:3.30.230.10:FF:000156', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(78333, NULL, 'G3DSA:2.60.40.10:FF:003245', NULL, NULL, 'Secreted protein BARF1', NULL, NULL, NULL, NULL, NULL, 4),
(78334, NULL, 'G3DSA:3.40.50.150:FF:000856', NULL, NULL, 'Spermidine synthase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(78335, NULL, 'G3DSA:3.90.1310.10:FF:000018', NULL, NULL, 'Cell division protein FtsI (Penicillin-binding protein 3)', NULL, NULL, NULL, NULL, NULL, 4),
(78336, NULL, 'G3DSA:3.40.50.2300:FF:000354', NULL, NULL, 'Transcriptional regulator, LuxR family', NULL, NULL, NULL, NULL, NULL, 4),
(78337, NULL, 'G3DSA:3.30.40.10:FF:000282', NULL, NULL, 'General transcription factor IIH subunit', NULL, NULL, NULL, NULL, NULL, 4),
(78338, NULL, 'G3DSA:1.10.510.10:FF:003247', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78339, NULL, 'G3DSA:3.40.50.200:FF:000040', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(78340, NULL, 'G3DSA:3.30.160.60:FF:001042', NULL, NULL, 'zinc finger protein 385B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(78341, NULL, 'G3DSA:3.40.50.1820:FF:000715', NULL, NULL, 'Triacylglycerol lipase', NULL, NULL, NULL, NULL, NULL, 4),
(78342, NULL, 'G3DSA:3.40.367.20:FF:000030', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(78343, NULL, 'G3DSA:3.40.50.1000:FF:000296', NULL, NULL, 'Trehalose-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(78344, NULL, 'G3DSA:3.40.50.720:FF:000246', NULL, NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 9, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(78345, NULL, 'G3DSA:1.10.1520.10:FF:000026', NULL, NULL, 'Dicer-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(78346, NULL, 'G3DSA:3.40.50.360:FF:000060', NULL, NULL, 'NAD(P)H-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(78347, NULL, 'G3DSA:3.40.50.300:FF:005802', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78348, NULL, 'G3DSA:3.30.930.10:FF:000164', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(78349, NULL, 'G3DSA:3.40.50.12780:FF:000153', NULL, NULL, 'Putative pantothenate kinase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(78350, NULL, 'G3DSA:3.30.70.330:FF:002288', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78351, NULL, 'G3DSA:3.30.160.60:FF:006393', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78352, NULL, 'G3DSA:2.30.29.30:FF:000207', NULL, NULL, 'Protein CBR-LIN-10, isoform a', NULL, NULL, NULL, NULL, NULL, 4),
(78353, NULL, 'G3DSA:3.40.50.620:FF:000660', NULL, NULL, 'DNA photolyase, putative', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(78354, NULL, 'G3DSA:1.25.40.10:FF:000945', NULL, NULL, 'Transcription factor tau 131 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(78355, NULL, 'G3DSA:3.40.50.150:FF:001132', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78356, NULL, 'G3DSA:2.160.20.10:FF:000283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78357, NULL, 'G3DSA:2.60.40.10:FF:002677', NULL, NULL, 'Periplasmic beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(78358, NULL, 'G3DSA:1.20.59.10:FF:000021', NULL, NULL, 'Chorismate mutase and prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(78359, NULL, 'G3DSA:3.40.50.2300:FF:000966', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78360, NULL, 'G3DSA:1.20.1070.10:FF:000438', NULL, NULL, 'NeuroPeptide Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(78361, NULL, 'G3DSA:2.40.340.10:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78362, NULL, 'G3DSA:1.25.40.10:FF:003351', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(78363, NULL, 'G3DSA:3.40.50.80:FF:000123', NULL, NULL, 'Related to ferric reductase', NULL, NULL, NULL, NULL, NULL, 4),
(78364, NULL, 'G3DSA:2.60.120.10:FF:000212', NULL, NULL, 'Listeriolysin regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(78365, NULL, 'G3DSA:2.10.25.10:FF:000710', NULL, NULL, 'Blast:Protein eyes shut', NULL, NULL, NULL, NULL, NULL, 4),
(78366, NULL, 'G3DSA:1.10.238.10:FF:000629', NULL, NULL, 'Parvalbumin beta 2', NULL, NULL, NULL, NULL, NULL, 4),
(78367, NULL, 'G3DSA:1.20.120.20:FF:000014', NULL, NULL, 'Apolipoprotein A-I', NULL, NULL, NULL, NULL, NULL, 4),
(78368, NULL, 'G3DSA:1.20.5.340:FF:000088', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(78369, NULL, 'G3DSA:2.60.210.10:FF:000039', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(78370, NULL, 'G3DSA:1.20.1250.20:FF:000753', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78371, NULL, 'G3DSA:3.80.30.20:FF:000029', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(78372, NULL, 'G3DSA:1.20.1510.10:FF:000074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78373, NULL, 'G3DSA:2.60.40.3180:FF:000001', NULL, NULL, 'transcription factor COE1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(78374, NULL, 'G3DSA:1.20.1070.10:FF:002181', NULL, NULL, 'C1A receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78375, NULL, 'G3DSA:1.10.630.10:FF:000035', NULL, NULL, 'CYtochrome P450 family', NULL, NULL, NULL, NULL, NULL, 4),
(78376, NULL, 'G3DSA:3.40.50.300:FF:007118', NULL, NULL, 'Rab-type small GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(78377, NULL, 'G3DSA:3.10.350.10:FF:000085', NULL, NULL, 'Cell wall endopeptidase family M23/M37', NULL, NULL, NULL, NULL, NULL, 4),
(78378, NULL, 'G3DSA:1.25.10.10:FF:003231', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(78379, NULL, 'G3DSA:3.90.110.10:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78380, NULL, 'G3DSA:3.90.550.10:FF:000739', NULL, NULL, 'Probable dolichyl-phosphate mannose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(78381, NULL, 'G3DSA:3.40.50.80:FF:000027', NULL, NULL, 'FAD binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(78382, NULL, 'G3DSA:2.40.50.140:FF:000885', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78383, NULL, 'G3DSA:3.30.590.50:FF:000014', NULL, NULL, 'Glutamate-cysteine ligase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(78384, NULL, 'G3DSA:3.80.10.10:FF:003869', NULL, NULL, 'Endonuclease/Exonuclease/phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(78385, NULL, 'G3DSA:3.30.160.60:FF:003166', NULL, NULL, 'Zinc finger protein 1152', NULL, NULL, NULL, NULL, NULL, 4),
(78386, NULL, 'G3DSA:1.20.1560.10:FF:000408', NULL, NULL, 'MRP-like ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(78387, NULL, 'G3DSA:1.20.58.60:FF:000730', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78388, NULL, 'G3DSA:2.60.40.10:FF:002969', NULL, NULL, 'T-cell surface glycoprotein CD4', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(78389, NULL, 'G3DSA:2.130.10.10:FF:001132', NULL, NULL, 'Plexin A', NULL, NULL, NULL, NULL, NULL, 4),
(78390, NULL, 'G3DSA:3.40.1170.10:FF:000041', NULL, NULL, 'Mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(78391, NULL, 'G3DSA:1.25.40.10:FF:004918', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78392, NULL, 'G3DSA:2.60.40.420:FF:000058', NULL, NULL, 'L-ascorbate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(78393, NULL, 'G3DSA:1.10.10.10:FF:000937', NULL, NULL, 'Telomere repeat-binding factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(78394, NULL, 'G3DSA:2.40.50.140:FF:000447', NULL, NULL, 'Translation initiation factor 5A', NULL, NULL, NULL, NULL, NULL, 4),
(78395, NULL, 'G3DSA:3.40.50.10140:FF:000035', NULL, NULL, 'Sterile alpha and TIR motif containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(78396, NULL, 'G3DSA:3.40.50.300:FF:001312', NULL, NULL, 'Ras-related protein Rab-18', NULL, NULL, NULL, NULL, NULL, 4),
(78397, NULL, 'G3DSA:3.50.50.60:FF:001050', NULL, NULL, 'FAD-dependent oxidoreductase domain-containing protein 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(78398, NULL, 'G3DSA:2.60.40.10:FF:000906', NULL, NULL, 'Junctional adhesion molecule A', NULL, NULL, NULL, NULL, NULL, 4),
(78399, NULL, 'G3DSA:3.40.850.10:FF:000077', NULL, NULL, 'Putative Unc104-like kinesin', NULL, NULL, NULL, NULL, NULL, 4),
(78400, NULL, 'G3DSA:1.10.287.70:FF:000232', NULL, NULL, 'GLutamate Receptor family (AMPA)', NULL, NULL, NULL, NULL, NULL, 4),
(78401, NULL, 'G3DSA:3.30.200.20:FF:002068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78402, NULL, 'G3DSA:3.30.70.2500:FF:000001', NULL, NULL, 'Sulfite reductase, dissimilatory-type alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(78403, NULL, 'G3DSA:2.130.10.10:FF:003341', NULL, NULL, 'AGAP010418-PA', NULL, NULL, NULL, NULL, NULL, 4),
(78404, NULL, 'G3DSA:1.10.10.10:FF:001213', NULL, NULL, 'Disease resistance protein RPM1', NULL, NULL, NULL, NULL, NULL, 4),
(78405, NULL, 'G3DSA:2.130.10.10:FF:002773', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 16', NULL, NULL, NULL, NULL, NULL, 4),
(78406, NULL, 'G3DSA:3.30.70.330:FF:000517', NULL, NULL, 'U2 snRNP auxiliary factor large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(78407, NULL, 'G3DSA:3.30.200.20:FF:001500', NULL, NULL, 'Probable serine/threonine-protein kinase fhkD', NULL, NULL, NULL, NULL, NULL, 4),
(78408, NULL, 'G3DSA:1.20.120.1750:FF:000163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78409, NULL, 'G3DSA:3.30.920.10:FF:000012', NULL, NULL, 'Frataxin, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78410, NULL, 'G3DSA:1.25.40.20:FF:001763', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78411, NULL, 'G3DSA:1.10.510.10:FF:001370', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(78412, NULL, 'G3DSA:3.40.50.10130:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78413, NULL, 'G3DSA:1.20.1250.20:FF:000427', NULL, NULL, 'Battenin', NULL, NULL, NULL, NULL, NULL, 4),
(78414, NULL, 'G3DSA:3.30.70.330:FF:001799', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78415, NULL, 'G3DSA:3.40.1280.10:FF:000077', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4),
(78416, NULL, 'G3DSA:1.25.40.470:FF:000016', NULL, NULL, 'Coatomer subunit beta''', NULL, NULL, NULL, NULL, NULL, 4),
(78417, NULL, 'G3DSA:1.20.1740.10:FF:000006', NULL, NULL, 'General amino acid permease', NULL, NULL, NULL, NULL, NULL, 4),
(78418, NULL, 'G3DSA:1.20.58.60:FF:000112', NULL, NULL, 'nesprin-1 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(78419, NULL, 'G3DSA:1.25.40.20:FF:001049', NULL, NULL, 'Ankyrin repeat, PH and SEC7 domain containing protein secG', NULL, NULL, NULL, NULL, NULL, 4),
(78420, NULL, 'G3DSA:3.50.50.60:FF:000791', NULL, NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(78421, NULL, 'G3DSA:1.20.1250.20:FF:001888', NULL, NULL, 'Prop transport protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(78422, NULL, 'G3DSA:1.10.510.10:FF:000881', NULL, NULL, 'PTI1-like tyrosine-protein kinase 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(78423, NULL, 'G3DSA:3.40.50.300:FF:005241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78424, NULL, 'G3DSA:3.10.580.10:FF:000017', NULL, NULL, 'CBS domain-containing protein CBSX3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(78425, NULL, 'G3DSA:1.20.1260.10:FF:000043', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(78426, NULL, 'G3DSA:3.30.160.60:FF:005706', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78427, NULL, 'G3DSA:3.80.10.10:FF:002913', NULL, NULL, 'Insulin-like growth factor-binding protein acid labile subunit', NULL, NULL, NULL, NULL, NULL, 4),
(78428, NULL, 'G3DSA:3.10.660.10:FF:000018', NULL, NULL, 'Chaperone protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78429, NULL, 'G3DSA:1.20.1720.10:FF:000123', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78430, NULL, 'G3DSA:3.60.20.10:FF:000190', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78431, NULL, 'G3DSA:3.60.20.10:FF:000217', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78432, NULL, 'G3DSA:2.10.10.100:FF:000001', NULL, NULL, 'UDP-N-acetylhexosamine pyrophosphorylase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(78433, NULL, 'G3DSA:1.25.40.10:FF:004711', NULL, NULL, 'SEL-1', NULL, NULL, NULL, NULL, NULL, 4),
(78434, NULL, 'G3DSA:2.60.98.20:FF:000003', NULL, NULL, 'Flagellar hook protein FlgE', NULL, NULL, NULL, NULL, NULL, 4),
(78435, NULL, 'G3DSA:3.40.50.300:FF:008579', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(78436, NULL, 'G3DSA:1.20.210.10:FF:000018', NULL, NULL, 'Cytochrome c oxidase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(78437, NULL, 'G3DSA:1.10.10.10:FF:001426', NULL, NULL, 'Transcriptional regulator, SARP family', NULL, NULL, NULL, NULL, NULL, 4),
(78438, NULL, 'G3DSA:3.40.50.300:FF:003728', NULL, NULL, 'DEAQ box RNA-dependent ATPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(78439, NULL, 'G3DSA:3.30.450.20:FF:000411', NULL, NULL, 'PAS domain-containing hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(78440, NULL, 'G3DSA:2.60.40.10:FF:003571', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78441, NULL, 'G3DSA:2.60.40.10:FF:005111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78442, NULL, 'G3DSA:1.10.238.10:FF:000955', NULL, NULL, 'Calcium-binding mitochondrial carrier protein SCaMC-1', NULL, NULL, NULL, NULL, NULL, 4),
(78443, NULL, 'G3DSA:2.120.10.80:FF:000265', NULL, NULL, 'DNA-binding transcriptional activator of the SARP family', NULL, NULL, NULL, NULL, NULL, 4),
(78444, NULL, 'G3DSA:3.40.50.300:FF:006904', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78445, NULL, 'G3DSA:1.50.10.20:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78446, NULL, 'G3DSA:2.60.40.1230:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78447, NULL, 'G3DSA:2.60.40.150:FF:000808', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78448, NULL, 'G3DSA:3.40.50.2300:FF:000528', NULL, NULL, 'Amino acid/amide ABC transporter substrate-binding protein, HAAT family', NULL, NULL, NULL, NULL, NULL, 4),
(78449, NULL, 'G3DSA:3.80.10.10:FF:000761', NULL, NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(78450, NULL, 'G3DSA:1.10.287.70:FF:000283', NULL, NULL, 'Ionotropic receptor 40a', NULL, NULL, NULL, NULL, NULL, 4),
(78451, NULL, 'G3DSA:3.30.70.3490:FF:000067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78452, NULL, 'G3DSA:3.40.50.2300:FF:000680', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78453, NULL, 'G3DSA:3.40.50.300:FF:007444', NULL, NULL, 'ATP-dependent DEAD/H RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78454, NULL, 'G3DSA:1.10.3720.10:FF:000188', NULL, NULL, 'ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(78455, NULL, 'G3DSA:3.20.20.140:FF:000172', NULL, NULL, 'Related to guanine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(78456, NULL, 'G3DSA:2.60.40.10:FF:000783', NULL, NULL, 'Tenascin N', NULL, NULL, NULL, NULL, NULL, 4),
(78457, NULL, 'G3DSA:3.40.309.10:FF:000033', NULL, NULL, 'NAD-dependent phenylacetaldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(78458, NULL, 'G3DSA:2.60.120.200:FF:000035', NULL, NULL, 'FAT atypical cadherin 3', NULL, NULL, NULL, NULL, NULL, 4),
(78459, NULL, 'G3DSA:2.10.60.10:FF:000016', NULL, NULL, 'LY6/PLAUR domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(78460, NULL, 'G3DSA:3.40.720.10:FF:000073', NULL, NULL, 'Cofactor-independent phosphoglycerate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(78461, NULL, 'G3DSA:3.30.160.20:FF:000035', NULL, NULL, 'RNA polymerase II C-terminal domain phosphatase-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(78462, NULL, 'G3DSA:2.30.42.10:FF:000305', NULL, NULL, 'Golgi re-assembly stacking protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(78463, NULL, 'G3DSA:1.25.40.280:FF:000015', NULL, NULL, 'Enhancer of Glp-One (Glp-1)', NULL, NULL, NULL, NULL, NULL, 4),
(78464, NULL, 'G3DSA:3.90.1560.10:FF:000003', NULL, NULL, 'Probable 2-phosphosulfolactate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(78465, NULL, 'G3DSA:3.40.190.10:FF:000661', NULL, NULL, 'Xyloglucan ABC transport system, sugar-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(78466, NULL, 'G3DSA:2.60.120.650:FF:000147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78467, NULL, 'G3DSA:1.20.1310.10:FF:000188', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78468, NULL, 'G3DSA:1.10.630.10:FF:000086', NULL, NULL, 'cytochrome P450 90A1-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(78469, NULL, 'G3DSA:3.40.20.10:FF:000027', NULL, NULL, 'Villin 1', NULL, NULL, NULL, NULL, NULL, 4),
(78470, NULL, 'G3DSA:3.30.160.60:FF:003520', NULL, NULL, 'Zinc finger protein 234-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(78471, NULL, 'G3DSA:1.10.285.10:FF:000013', NULL, NULL, 'Glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(78472, NULL, 'G3DSA:1.20.1250.20:FF:002170', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(78473, NULL, 'G3DSA:2.60.40.60:FF:000865', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78474, NULL, 'G3DSA:1.10.472.10:FF:000628', NULL, NULL, 'G1/S-specific cyclin e2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(78475, NULL, 'G3DSA:1.10.510.10:FF:003573', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78476, NULL, 'G3DSA:3.40.50.10090:FF:000031', NULL, NULL, 'Uroporphyrinogen-III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(78477, NULL, 'G3DSA:1.10.10.10:FF:000196', NULL, NULL, 'UPF0502 protein YceH', NULL, NULL, NULL, NULL, NULL, 4),
(78478, NULL, 'G3DSA:1.25.40.10:FF:001760', NULL, NULL, 'tetratricopeptide repeat protein 28', NULL, NULL, NULL, NULL, NULL, 4),
(78479, NULL, 'G3DSA:1.20.58.60:FF:000319', NULL, NULL, 'Protein CBG15811', NULL, NULL, NULL, NULL, NULL, 4),
(78480, NULL, 'G3DSA:3.40.50.620:FF:000334', NULL, NULL, 'Tryptophan--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(78481, NULL, 'G3DSA:3.30.40.10:FF:001979', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78482, NULL, 'G3DSA:1.25.40.120:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78483, NULL, 'G3DSA:2.130.10.10:FF:003015', NULL, NULL, 'Putative wd40 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(78484, NULL, 'G3DSA:3.30.497.10:FF:000179', NULL, NULL, 'Serpin peptidase inhibitor 6', NULL, NULL, NULL, NULL, NULL, 4),
(78485, NULL, 'G3DSA:1.10.555.10:FF:000231', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78486, NULL, 'G3DSA:3.80.10.10:FF:001896', NULL, NULL, 'Calpain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78487, NULL, 'G3DSA:2.130.10.10:FF:005139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78488, NULL, 'G3DSA:4.10.60.10:FF:000169', NULL, NULL, 'YALI0D12056p', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(78489, NULL, 'G3DSA:1.10.10.10:FF:000971', NULL, NULL, 'ESCRT-II complex subunit VPS22', NULL, NULL, NULL, NULL, NULL, 4),
(78490, NULL, 'G3DSA:2.10.50.30:FF:000022', NULL, NULL, 'Vomeronasal 2, receptor 42', NULL, NULL, NULL, NULL, NULL, 4),
(78491, NULL, 'G3DSA:1.25.40.20:FF:001145', NULL, NULL, 'AGAP003151-PA', NULL, NULL, NULL, NULL, NULL, 4),
(78492, NULL, 'G3DSA:1.25.10.10:FF:002742', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78493, NULL, 'G3DSA:1.25.40.10:FF:004368', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78494, NULL, 'G3DSA:2.160.10.10:FF:000046', NULL, NULL, 'Translation initiation factor eIF-2B subunit epsilon, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78495, NULL, 'G3DSA:3.30.470.20:FF:000148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78496, NULL, 'G3DSA:1.10.340.70:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78497, NULL, 'G3DSA:2.10.25.10:FF:000008', NULL, NULL, 'Signal peptide, CUB domain, EGF-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(78498, NULL, 'G3DSA:3.40.228.10:FF:000007', NULL, NULL, 'Oxidoreductase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(78499, NULL, 'G3DSA:3.30.40.10:FF:002255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78500, NULL, 'G3DSA:3.40.718.10:FF:000028', NULL, NULL, '3-isopropylmalate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(78501, NULL, 'G3DSA:3.20.20.140:FF:000121', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(78502, NULL, 'G3DSA:2.30.30.790:FF:000005', NULL, NULL, 'Mitochondrial ribosomal protein L19', NULL, NULL, NULL, NULL, NULL, 4),
(78503, NULL, 'G3DSA:3.50.50.60:FF:000622', NULL, NULL, 'FADH2-dependent halogenase PltA', NULL, NULL, NULL, NULL, NULL, 4),
(78504, NULL, 'G3DSA:3.40.50.720:FF:002404', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78505, NULL, 'G3DSA:2.120.10.30:FF:000615', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78506, NULL, 'G3DSA:3.30.70.330:FF:000725', NULL, NULL, 'Ribonucleoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(78507, NULL, 'G3DSA:2.60.40.10:FF:003520', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78508, NULL, 'G3DSA:2.60.120.200:FF:000653', NULL, NULL, 'Laminin subunit alpha 5', NULL, NULL, NULL, NULL, NULL, 4),
(78509, NULL, 'G3DSA:3.80.10.10:FF:004066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78510, NULL, 'G3DSA:6.10.140.2220:FF:000046', NULL, NULL, 'GD10841', NULL, NULL, NULL, NULL, NULL, 4),
(78511, NULL, 'G3DSA:2.30.30.100:FF:000113', NULL, NULL, 'Lsm7 u6 small nuclear rna associated', NULL, NULL, NULL, NULL, NULL, 4),
(78512, NULL, 'G3DSA:2.40.70.10:FF:000336', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78513, NULL, 'G3DSA:2.10.50.10:FF:000111', NULL, NULL, 'Fas cell surface death receptor', NULL, NULL, NULL, NULL, NULL, 4),
(78514, NULL, 'G3DSA:3.90.180.10:FF:000104', NULL, NULL, 'Zinc-binding dehydrogenase family oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(78515, NULL, 'G3DSA:3.40.570.10:FF:000027', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(78516, NULL, 'G3DSA:2.30.39.10:FF:000112', NULL, NULL, 'AGAP006910-PA', NULL, NULL, NULL, NULL, NULL, 4),
(78517, NULL, 'G3DSA:1.10.238.10:FF:000747', NULL, NULL, 'Follistatin-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(78518, NULL, 'G3DSA:2.40.100.10:FF:000159', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(78519, NULL, 'G3DSA:3.30.450.20:FF:000580', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78520, NULL, 'G3DSA:2.40.420.20:FF:000012', NULL, NULL, 'HlyD family secretion protein', NULL, NULL, NULL, NULL, NULL, 4),
(78521, NULL, 'G3DSA:2.70.70.10:FF:000059', NULL, NULL, 'Peptidase M23', NULL, NULL, NULL, NULL, NULL, 4),
(78522, NULL, 'G3DSA:1.10.10.60:FF:000396', NULL, NULL, 'NOBOX oogenesis homeobox', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(78523, NULL, 'G3DSA:2.60.40.420:FF:000272', NULL, NULL, 'Cytochrome c oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(78524, NULL, 'G3DSA:3.30.70.960:FF:000009', NULL, NULL, 'Interphotoreceptor matrix proteoglycan 1', NULL, NULL, NULL, NULL, NULL, 4),
(78525, NULL, 'G3DSA:3.30.720.50:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78526, NULL, 'G3DSA:3.90.1150.10:FF:000242', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(78527, NULL, 'G3DSA:3.30.160.60:FF:002918', NULL, NULL, 'Zinc finger protein 41', NULL, NULL, NULL, NULL, NULL, 4),
(78528, NULL, 'G3DSA:2.60.40.10:FF:001334', NULL, NULL, 'tyrosine-protein phosphatase 10D isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(78529, NULL, 'G3DSA:1.25.40.10:FF:001142', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(78530, NULL, 'G3DSA:4.10.860.10:FF:000018', NULL, NULL, 'UvrB/UvrC protein', NULL, NULL, NULL, NULL, NULL, 4),
(78531, NULL, 'G3DSA:3.40.50.300:FF:007039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78532, NULL, 'G3DSA:3.40.50.300:FF:000598', NULL, NULL, 'Dynein cytoplasmic 2 heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(78533, NULL, 'G3DSA:2.170.220.10:FF:000002', NULL, NULL, 'Methionine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(78534, NULL, 'G3DSA:1.25.10.10:FF:003310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78535, NULL, 'G3DSA:1.20.1250.20:FF:000192', NULL, NULL, 'Major facilitator superfamily domain-containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(78536, NULL, 'G3DSA:3.80.10.10:FF:000429', NULL, NULL, 'Leucine-rich repeat and WD repeat-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(78537, NULL, 'G3DSA:1.25.10.10:FF:000589', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78538, NULL, 'G3DSA:3.40.640.10:FF:000089', NULL, NULL, 'Aminotransferase, DegT/DnrJ/EryC1/StrS family', NULL, NULL, NULL, NULL, NULL, 4),
(78539, NULL, 'G3DSA:2.30.40.10:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78540, NULL, 'G3DSA:3.90.530.10:FF:000002', NULL, NULL, 'zinc transporter 9 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(78541, NULL, 'G3DSA:3.30.710.10:FF:000024', NULL, NULL, 'Leucine-zipper-like transcriptional regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(78542, NULL, 'G3DSA:3.30.200.20:FF:001000', NULL, NULL, 'Myosin light chain kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78543, NULL, 'G3DSA:3.30.450.20:FF:000203', NULL, NULL, 'Histidine kinase response regulator hybrid protein', NULL, NULL, NULL, NULL, NULL, 4),
(78544, NULL, 'G3DSA:3.40.1280.10:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78545, NULL, 'G3DSA:3.30.40.10:FF:002204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78546, NULL, 'G3DSA:1.20.1410.10:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78547, NULL, 'G3DSA:1.10.510.10:FF:000667', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(78548, NULL, 'G3DSA:1.25.40.20:FF:001050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78549, NULL, 'G3DSA:3.30.420.60:FF:000016', NULL, NULL, 'Eukaryotic release factor 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78550, NULL, 'G3DSA:3.90.70.10:FF:000736', NULL, NULL, 'Cysteine proteinases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(78551, NULL, 'G3DSA:3.40.50.300:FF:002739', NULL, NULL, 'Small GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(78552, NULL, 'G3DSA:1.10.238.10:FF:000860', NULL, NULL, 'Acidocalcisomal pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(78553, NULL, 'G3DSA:3.30.200.20:FF:000483', NULL, NULL, 'Putative receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(78554, NULL, 'G3DSA:3.80.10.10:FF:000755', NULL, NULL, 'Si:ch211-213a13.2', NULL, NULL, NULL, NULL, NULL, 4),
(78555, NULL, 'G3DSA:3.20.180.20:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(78556, NULL, 'G3DSA:1.20.1050.10:FF:000229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78557, NULL, 'G3DSA:1.10.510.10:FF:002797', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78558, NULL, 'G3DSA:1.50.10.10:FF:000025', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(78559, NULL, 'G3DSA:3.30.420.40:FF:000758', NULL, NULL, 'Actin-like 6B', NULL, NULL, NULL, NULL, NULL, 4),
(78560, NULL, 'G3DSA:2.60.120.260:FF:000188', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 7', NULL, NULL, NULL, NULL, NULL, 4),
(78561, NULL, 'G3DSA:2.40.50.90:FF:000139', NULL, NULL, 'Tapas, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(78562, NULL, 'G3DSA:2.70.220.10:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78563, NULL, 'G3DSA:3.40.50.1820:FF:000541', NULL, NULL, 'Acyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(78564, NULL, 'G3DSA:2.10.110.10:FF:000026', NULL, NULL, 'PDZ and LIM domain protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(78565, NULL, 'G3DSA:1.10.3120.10:FF:000013', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(78566, NULL, 'G3DSA:3.30.160.60:FF:004476', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78567, NULL, 'G3DSA:3.90.180.10:FF:000087', NULL, NULL, 'Alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(78568, NULL, 'G3DSA:1.20.58.1970:FF:000007', NULL, NULL, 'Conserved oligomeric Golgi complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(78569, NULL, 'G3DSA:1.50.10.20:FF:000028', NULL, NULL, 'Geranylgeranyl transferase type-2 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(78570, NULL, 'G3DSA:3.40.225.10:FF:000029', NULL, NULL, 'Rhamnulose-1-phosphate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(78571, NULL, 'G3DSA:2.30.29.30:FF:000730', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78572, NULL, 'G3DSA:3.60.150.10:FF:000002', NULL, NULL, 'Chorismate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(78573, NULL, 'G3DSA:3.40.50.150:FF:000738', NULL, NULL, 'Acetylserotonin O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(78574, NULL, 'G3DSA:3.30.1610.10:FF:000010', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(78575, NULL, 'G3DSA:2.120.10.30:FF:000565', NULL, NULL, 'Senescence marker protein-30, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78576, NULL, 'G3DSA:3.90.660.50:FF:000001', NULL, NULL, 'Prolycopene isomerase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(78577, NULL, 'G3DSA:3.90.1150.10:FF:000129', NULL, NULL, 'DegT/DnrJ/EryC1/StrS aminotransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(78578, NULL, 'G3DSA:1.10.510.10:FF:002758', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78579, NULL, 'G3DSA:3.40.850.10:FF:000190', NULL, NULL, 'Kinesin motor domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(78580, NULL, 'G3DSA:1.10.486.10:FF:000036', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(78581, NULL, 'G3DSA:3.30.710.10:FF:000119', NULL, NULL, 'potassium voltage-gated channel subfamily A member 4', NULL, NULL, NULL, NULL, NULL, 4),
(78582, NULL, 'G3DSA:2.60.120.920:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78583, NULL, 'G3DSA:1.20.1070.10:FF:000556', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78584, NULL, 'G3DSA:4.10.240.10:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78585, NULL, 'G3DSA:1.20.5.650:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78586, NULL, 'G3DSA:4.10.800.10:FF:000009', NULL, NULL, 'Insulin-like growth factor binding protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(78587, NULL, 'G3DSA:4.10.520.10:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78588, NULL, 'G3DSA:3.90.650.10:FF:000011', NULL, NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(78589, NULL, 'G3DSA:2.60.40.10:FF:004886', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78590, NULL, 'G3DSA:3.40.50.620:FF:000222', NULL, NULL, 'Glutamate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(78591, NULL, 'G3DSA:1.25.10.10:FF:003405', NULL, NULL, 'Protein Mo25', NULL, NULL, NULL, NULL, NULL, 4),
(78592, NULL, 'G3DSA:3.40.50.10190:FF:000117', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(78593, NULL, 'G3DSA:1.10.150.530:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78594, NULL, 'G3DSA:3.30.200.20:FF:001320', NULL, NULL, 'Kinase like protein', NULL, NULL, NULL, NULL, NULL, 4),
(78595, NULL, 'G3DSA:1.20.1250.20:FF:000135', NULL, NULL, 'MFS family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(78596, NULL, 'G3DSA:1.10.472.10:FF:000448', NULL, NULL, 'G1/S-specific cyclin-E1', NULL, NULL, NULL, NULL, NULL, 4),
(78597, NULL, 'G3DSA:2.60.40.10:FF:002582', NULL, NULL, 'Stretchin-Mlck, isoform V', NULL, NULL, NULL, NULL, NULL, 4),
(78598, NULL, 'G3DSA:1.20.1250.10:FF:000132', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78599, NULL, 'G3DSA:3.30.559.10:FF:000166', NULL, NULL, 'Enniatin synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(78600, NULL, 'G3DSA:3.40.50.2300:FF:000915', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78601, NULL, 'G3DSA:1.10.8.60:FF:000030', NULL, NULL, 'replication factor C subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(78602, NULL, 'G3DSA:3.40.50.300:FF:001604', NULL, NULL, 'DNA repair protein XRCC3', NULL, NULL, NULL, NULL, NULL, 4),
(78603, NULL, 'G3DSA:3.40.50.10050:FF:000008', NULL, NULL, 'Translation initiation factor IF-2', NULL, NULL, NULL, NULL, NULL, 4),
(78604, NULL, 'G3DSA:3.10.180.10:FF:000088', NULL, NULL, '4-hydroxymandelate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(78605, NULL, 'G3DSA:3.30.160.60:FF:001603', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(78606, NULL, 'G3DSA:3.40.50.300:FF:001380', NULL, NULL, 'Iron ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(78607, NULL, 'G3DSA:2.130.10.10:FF:003223', NULL, NULL, 'YALI0C00913p', NULL, NULL, NULL, NULL, NULL, 4),
(78608, NULL, 'G3DSA:1.10.8.10:FF:000104', NULL, NULL, 'Ubiquitin domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(78609, NULL, 'G3DSA:2.120.10.80:FF:000259', NULL, NULL, 'F-box protein AFR', NULL, NULL, NULL, NULL, NULL, 4),
(78610, NULL, 'G3DSA:3.30.70.330:FF:000405', NULL, NULL, 'polyadenylate-binding protein RBP45', NULL, NULL, NULL, NULL, NULL, 4),
(78611, NULL, 'G3DSA:1.50.10.20:FF:000141', NULL, NULL, 'Dammarenediol II synthase', NULL, NULL, NULL, NULL, NULL, 4),
(78612, NULL, 'G3DSA:2.130.10.10:FF:004690', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78613, NULL, 'G3DSA:3.30.160.60:FF:003907', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78614, NULL, 'G3DSA:1.10.10.10:FF:000763', NULL, NULL, 'Heat shock transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(78615, NULL, 'G3DSA:1.20.5.2650:FF:000003', NULL, NULL, '40S ribosomal protein S6', NULL, NULL, NULL, NULL, NULL, 4),
(78616, NULL, 'G3DSA:2.40.70.10:FF:000544', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78617, NULL, 'G3DSA:3.30.900.10:FF:000044', NULL, NULL, 'Autophagy-related protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(78618, NULL, 'G3DSA:3.30.40.10:FF:000810', NULL, NULL, 'Structure-specific endonuclease subunit SLX1', NULL, NULL, NULL, NULL, NULL, 4),
(78619, NULL, 'G3DSA:3.80.10.10:FF:000109', NULL, NULL, 'nischarin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(78620, NULL, 'G3DSA:3.30.830.10:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78621, NULL, 'G3DSA:2.130.10.10:FF:004858', NULL, NULL, 'WD repeat-containing protein 74', NULL, NULL, NULL, NULL, NULL, 4),
(78622, NULL, 'G3DSA:3.30.160.60:FF:003812', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78623, NULL, 'G3DSA:1.10.287.380:FF:000033', NULL, NULL, 'Valyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(78624, NULL, 'G3DSA:3.30.160.60:FF:003700', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78625, NULL, 'G3DSA:3.40.190.10:FF:000953', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(78626, NULL, 'G3DSA:3.40.50.300:FF:002947', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(78627, NULL, 'G3DSA:3.40.50.1260:FF:000002', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(78628, NULL, 'G3DSA:1.20.1250.20:FF:002226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78629, NULL, 'G3DSA:3.40.50.1440:FF:000079', NULL, NULL, 'Tubulin, alpha 4-like', NULL, NULL, NULL, NULL, NULL, 4),
(78630, NULL, 'G3DSA:1.20.58.860:FF:000018', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(78631, NULL, 'G3DSA:3.40.50.300:FF:001587', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(78632, NULL, 'G3DSA:1.20.58.60:FF:000825', NULL, NULL, 'Dystonin', NULL, NULL, NULL, NULL, NULL, 4),
(78633, NULL, 'G3DSA:3.30.830.10:FF:000297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78634, NULL, 'G3DSA:3.40.50.300:FF:008467', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78635, NULL, 'G3DSA:1.25.40.770:FF:000005', NULL, NULL, 'TATA-binding protein-associated-factor', NULL, NULL, NULL, NULL, NULL, 4),
(78636, NULL, 'G3DSA:3.40.640.10:FF:000297', NULL, NULL, 'Probable glycine dehydrogenase (decarboxylating) subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(78637, NULL, 'G3DSA:3.10.105.10:FF:000010', NULL, NULL, 'ABC transporter substrate-binding protein component', NULL, NULL, NULL, NULL, NULL, 4),
(78638, NULL, 'G3DSA:1.25.40.10:FF:002570', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g19720', NULL, NULL, NULL, NULL, NULL, 4),
(78639, NULL, 'G3DSA:3.40.20.10:FF:000140', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(78640, NULL, 'G3DSA:3.30.710.10:FF:000232', NULL, NULL, 'GM20065', NULL, NULL, NULL, NULL, NULL, 4),
(78641, NULL, 'G3DSA:1.20.1560.10:FF:000352', NULL, NULL, 'Multidrug resistance protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(78642, NULL, 'G3DSA:2.40.50.140:FF:000155', NULL, NULL, 'rRNA biogenesis protein RRP5', NULL, NULL, NULL, NULL, NULL, 4),
(78643, NULL, 'G3DSA:2.130.10.10:FF:002767', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78644, NULL, 'G3DSA:3.40.1350.10:FF:000021', NULL, NULL, 'Holliday junction resolvase RecU', NULL, NULL, NULL, NULL, NULL, 4),
(78645, NULL, 'G3DSA:3.30.160.60:FF:001721', NULL, NULL, 'Zinc finger protein 366', NULL, NULL, NULL, NULL, NULL, 4),
(78646, NULL, 'G3DSA:1.25.40.180:FF:000311', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78647, NULL, 'G3DSA:1.10.555.10:FF:000017', NULL, NULL, 'Rho GTPase activating protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(78648, NULL, 'G3DSA:3.40.50.720:FF:000538', NULL, NULL, 'NADH-ubiquinone oxidoreductase complex I subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78649, NULL, 'G3DSA:1.10.510.10:FF:001662', NULL, NULL, 'Protein CBG16200', NULL, NULL, NULL, NULL, NULL, 4),
(78650, NULL, 'G3DSA:3.30.200.20:FF:000269', NULL, NULL, 'serine/threonine-protein kinase mph1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(78651, NULL, 'G3DSA:1.10.510.10:FF:001605', NULL, NULL, 'Probably inactive receptor-like protein kinase At2g46850', NULL, NULL, NULL, NULL, NULL, 4),
(78652, NULL, 'G3DSA:3.40.50.12780:FF:000147', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(78653, NULL, 'G3DSA:3.40.50.720:FF:000038', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(78654, NULL, 'G3DSA:1.25.10.10:FF:001106', NULL, NULL, 'Dynein, axonemal, assembly factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(78655, NULL, 'G3DSA:1.20.1090.10:FF:000035', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(78656, NULL, 'G3DSA:3.30.559.10:FF:000071', NULL, NULL, 'Nonribosomal peptide synthetase 8', NULL, NULL, NULL, NULL, NULL, 4),
(78657, NULL, 'G3DSA:1.20.5.1160:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78658, NULL, 'G3DSA:3.40.50.2300:FF:000758', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(78659, NULL, 'G3DSA:3.40.50.10190:FF:000022', NULL, NULL, 'DNA topoisomerase II binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(78660, NULL, 'G3DSA:3.90.550.10:FF:000745', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(78661, NULL, 'G3DSA:3.30.910.20:FF:000008', NULL, NULL, 'Outer membrane chaperone Skp (OmpH)', NULL, NULL, NULL, NULL, NULL, 4),
(78662, NULL, 'G3DSA:3.80.10.10:FF:002621', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78663, NULL, 'G3DSA:3.50.50.60:FF:001403', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78664, NULL, 'G3DSA:2.130.10.10:FF:004358', NULL, NULL, 'Mitochondrial inner membrane protease ATP23', NULL, NULL, NULL, NULL, NULL, 4),
(78665, NULL, 'G3DSA:2.30.29.30:FF:000387', NULL, NULL, 'Serine/threonine-protein kinase D2', NULL, NULL, NULL, NULL, NULL, 4),
(78666, NULL, 'G3DSA:1.50.10.10:FF:000233', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(78667, NULL, 'G3DSA:1.10.10.10:FF:001752', NULL, NULL, 'Spo11/DNA topoisomerase VI subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(78668, NULL, 'G3DSA:3.30.9.10:FF:000260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78669, NULL, 'G3DSA:3.30.160.60:FF:001660', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78670, NULL, 'G3DSA:2.60.40.10:FF:002789', NULL, NULL, 'Ig-like and fibronectin type-III domain-containing protein C25G4.10', NULL, NULL, NULL, NULL, NULL, 4),
(78671, NULL, 'G3DSA:3.40.1110.10:FF:000211', NULL, NULL, 'Heavy-metal transporting P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(78672, NULL, 'G3DSA:2.30.40.10:FF:000183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78673, NULL, 'G3DSA:1.10.510.10:FF:003253', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78674, NULL, 'G3DSA:2.40.440.10:FF:000010', NULL, NULL, 'L,D-transpeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(78675, NULL, 'G3DSA:2.60.40.1530:FF:000012', NULL, NULL, 'Integrin, alpha 8', NULL, NULL, NULL, NULL, NULL, 4),
(78676, NULL, 'G3DSA:1.10.287.370:FF:000030', NULL, NULL, 'Probable prefoldin subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(78677, NULL, 'G3DSA:2.30.30.100:FF:000170', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm2', NULL, NULL, NULL, NULL, NULL, 4),
(78678, NULL, 'G3DSA:3.40.50.150:FF:001396', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78679, NULL, 'G3DSA:2.10.25.10:FF:001795', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78680, NULL, 'G3DSA:1.20.5.170:FF:000172', NULL, NULL, 'BZIP transcription factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(78681, NULL, 'G3DSA:3.40.50.300:FF:007152', NULL, NULL, 'ARF-like small GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(78682, NULL, 'G3DSA:3.40.50.720:FF:002129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78683, NULL, 'G3DSA:1.20.1070.10:FF:000764', NULL, NULL, 'Muscarinic acetylcholine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(78684, NULL, 'G3DSA:3.30.70.3310:FF:000002', NULL, NULL, 'Neurogenic locus notch homolog protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(78685, NULL, 'G3DSA:1.20.58.1220:FF:000018', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(78686, NULL, 'G3DSA:3.80.20.20:FF:000091', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(78687, NULL, 'G3DSA:3.40.50.2300:FF:000972', NULL, NULL, 'Receptor-type guanylate cyclase gcy-5', NULL, NULL, NULL, NULL, NULL, 4),
(78688, NULL, 'G3DSA:1.20.58.70:FF:000087', NULL, NULL, 'Syntaxin-12', NULL, NULL, NULL, NULL, NULL, 4),
(78689, NULL, 'G3DSA:1.10.10.10:FF:000488', NULL, NULL, 'Ferric uptake regulator family protein', NULL, NULL, NULL, NULL, NULL, 4),
(78690, NULL, 'G3DSA:1.25.10.10:FF:002000', NULL, NULL, 'YALI0D22440p', NULL, NULL, NULL, NULL, NULL, 4),
(78691, NULL, 'G3DSA:3.40.50.300:FF:008349', NULL, NULL, 'Phospholipid-lipopolysaccharide ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(78692, NULL, 'G3DSA:3.40.50.1820:FF:001789', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(78693, NULL, 'G3DSA:1.20.58.1210:FF:000015', NULL, NULL, 'Chromosome 12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(78694, NULL, 'G3DSA:3.40.630.40:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78695, NULL, 'G3DSA:1.20.1250.20:FF:000040', NULL, NULL, 'Solute carrier family 2, facilitated glucose transporter member 1', NULL, NULL, NULL, NULL, NULL, 4),
(78696, NULL, 'G3DSA:3.40.630.30:FF:000021', NULL, NULL, 'Serotonin N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(78697, NULL, 'G3DSA:3.30.479.30:FF:000047', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(78698, NULL, 'G3DSA:3.40.50.2300:FF:000079', NULL, NULL, 'ABC transporter periplasmic-binding protein ytfQ', NULL, NULL, NULL, NULL, NULL, 4),
(78699, NULL, 'G3DSA:3.40.50.1000:FF:000796', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78700, NULL, 'G3DSA:3.30.70.360:FF:000043', NULL, NULL, 'ACY1L2 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78701, NULL, 'G3DSA:1.25.40.10:FF:001552', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(78702, NULL, 'G3DSA:2.60.40.1530:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78703, NULL, 'G3DSA:3.40.50.150:FF:001519', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78704, NULL, 'G3DSA:3.30.40.10:FF:000809', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(78705, NULL, 'G3DSA:1.20.930.10:FF:000022', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 26', NULL, NULL, NULL, NULL, NULL, 4),
(78706, NULL, 'G3DSA:2.60.40.420:FF:000092', NULL, NULL, 'Cytochrome C oxidase subunit II', NULL, NULL, NULL, NULL, NULL, 4),
(78707, NULL, 'G3DSA:1.10.510.10:FF:001162', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(78708, NULL, 'G3DSA:3.80.10.10:FF:002060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78709, NULL, 'G3DSA:1.25.10.10:FF:001045', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(78710, NULL, 'G3DSA:1.10.8.270:FF:000069', NULL, NULL, 'TBC/Rab GTPase activating domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(78711, NULL, 'G3DSA:3.90.1150.10:FF:000360', NULL, NULL, 'Blr5429 protein', NULL, NULL, NULL, NULL, NULL, 4),
(78712, NULL, 'G3DSA:3.40.50.11600:FF:000001', NULL, NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(78713, NULL, 'G3DSA:3.30.2350.10:FF:000052', NULL, NULL, 'RNA pseudouridine synthase 6, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(78714, NULL, 'G3DSA:2.60.120.200:FF:000541', NULL, NULL, 'Neurexin I isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(78715, NULL, 'G3DSA:1.25.40.20:FF:001257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78716, NULL, 'G3DSA:3.40.190.10:FF:000453', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(78717, NULL, 'G3DSA:1.10.8.100:FF:000007', NULL, NULL, 'Mitochondrial transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(78718, NULL, 'G3DSA:1.25.40.20:FF:001555', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78719, NULL, 'G3DSA:3.40.50.300:FF:003178', NULL, NULL, 'arf-GAP with GTPase, ANK repeat and PH domain-containing protein 1 isoform X7', NULL, NULL, NULL, NULL, NULL, 4),
(78720, NULL, 'G3DSA:3.30.70.2240:FF:000001', NULL, NULL, 'Krev interaction trapped protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(78721, NULL, 'G3DSA:3.30.519.10:FF:000006', NULL, NULL, 'Rab GDP dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(78722, NULL, 'G3DSA:3.40.1190.20:FF:000101', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(78723, NULL, 'G3DSA:3.40.1390.30:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78724, NULL, 'G3DSA:1.10.10.60:FF:000519', NULL, NULL, 'Homeobox transcription factor', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(78725, NULL, 'G3DSA:1.20.1560.10:FF:000852', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78726, NULL, 'G3DSA:1.10.287.70:FF:000018', NULL, NULL, 'Voltage-dependent T-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(78727, NULL, 'G3DSA:2.60.40.1120:FF:000075', NULL, NULL, 'Putative outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(78728, NULL, 'G3DSA:2.40.320.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78729, NULL, 'G3DSA:3.60.40.10:FF:000213', NULL, NULL, 'Protein phosphatase 2C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78730, NULL, 'G3DSA:2.60.40.10:FF:001154', NULL, NULL, 'Sallimus, isoform Q', NULL, NULL, NULL, NULL, NULL, 4),
(78731, NULL, 'G3DSA:2.40.240.10:FF:000023', NULL, NULL, 'Glutamine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(78732, NULL, 'G3DSA:3.30.450.190:FF:000022', NULL, NULL, 'Gtr1/RagA G protein conserved region-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(78733, NULL, 'G3DSA:3.40.50.720:FF:002281', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(78734, NULL, 'G3DSA:3.30.2350.20:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78735, NULL, 'G3DSA:2.40.170.20:FF:000088', NULL, NULL, 'SusC homolog', NULL, NULL, NULL, NULL, NULL, 4),
(78736, NULL, 'G3DSA:3.40.50.300:FF:001379', NULL, NULL, 'Nitrogenase iron protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(78737, NULL, 'G3DSA:1.25.40.770:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78738, NULL, 'G3DSA:2.60.40.10:FF:006100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78739, NULL, 'G3DSA:3.80.10.10:FF:000317', NULL, NULL, 'Inactive leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(78740, NULL, 'G3DSA:3.30.160.60:FF:002795', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78741, NULL, 'G3DSA:3.90.190.10:FF:000138', NULL, NULL, 'Unplaced genomic scaffold supercont1.18, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(78742, NULL, 'G3DSA:3.30.1370.10:FF:000199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78743, NULL, 'G3DSA:2.40.10.10:FF:000439', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78744, NULL, 'G3DSA:4.10.1060.10:FF:000011', NULL, NULL, 'ubiquitin thioesterase ZRANB1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(78745, NULL, 'G3DSA:3.30.70.330:FF:002934', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78746, NULL, 'G3DSA:3.90.660.10:FF:000017', NULL, NULL, 'Lysine-specific histone demethylase Aof2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78747, NULL, 'G3DSA:3.30.70.330:FF:000905', NULL, NULL, 'RNA-binding family protein', NULL, NULL, NULL, NULL, NULL, 4),
(78748, NULL, 'G3DSA:3.40.30.10:FF:000090', NULL, NULL, 'Glutaredoxin-3', NULL, NULL, NULL, NULL, NULL, 4),
(78749, NULL, 'G3DSA:3.30.420.40:FF:000769', NULL, NULL, 'YALI0E31551p', NULL, NULL, NULL, NULL, NULL, 4),
(78750, NULL, 'G3DSA:1.20.1540.10:FF:000025', NULL, NULL, 'Putative rhomboid family', NULL, NULL, NULL, NULL, NULL, 4),
(78751, NULL, 'G3DSA:3.40.570.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78752, NULL, 'G3DSA:2.130.10.10:FF:002559', NULL, NULL, 'Os02g0136933 protein', NULL, NULL, NULL, NULL, NULL, 4),
(78753, NULL, 'G3DSA:3.40.50.300:FF:007562', NULL, NULL, 'Putative ATP-binding cassette protein subfamily H,member 3', NULL, NULL, NULL, NULL, NULL, 4),
(78754, NULL, 'G3DSA:2.60.40.10:FF:000991', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(78755, NULL, 'G3DSA:3.30.470.20:FF:000137', NULL, NULL, '30S ribosomal protein S6 modification protein RimK', NULL, NULL, NULL, NULL, NULL, 4),
(78756, NULL, 'G3DSA:3.30.200.20:FF:000505', NULL, NULL, 'ephrin type-A receptor 10', NULL, NULL, NULL, NULL, NULL, 4),
(78757, NULL, 'G3DSA:3.40.50.1460:FF:000006', NULL, NULL, 'Legumain', NULL, NULL, NULL, NULL, NULL, 4),
(78758, NULL, 'G3DSA:3.30.9.10:FF:000052', NULL, NULL, 'Putative glycine oxidase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(78759, NULL, 'G3DSA:2.40.37.10:FF:000068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78760, NULL, 'G3DSA:1.20.1070.10:FF:000146', NULL, NULL, 'putative P2Y purinoceptor 10 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(78761, NULL, 'G3DSA:1.20.1420.10:FF:000016', NULL, NULL, 'Cyclin-D1-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(78762, NULL, 'G3DSA:3.50.50.60:FF:000347', NULL, NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(78763, NULL, 'G3DSA:2.120.10.80:FF:000198', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(78764, NULL, 'G3DSA:2.10.110.10:FF:000346', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78765, NULL, 'G3DSA:3.40.190.80:FF:000024', NULL, NULL, 'Inositol monophosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(78766, NULL, 'G3DSA:3.40.50.2000:FF:000707', NULL, NULL, 'Glycosyltransferase WbpZ', NULL, NULL, NULL, NULL, NULL, 4),
(78767, NULL, 'G3DSA:2.40.50.140:FF:000508', NULL, NULL, 'ATP-dependent DNA helicase RecG', NULL, NULL, NULL, NULL, NULL, 4),
(78768, NULL, 'G3DSA:3.10.110.10:FF:000365', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(78769, NULL, 'G3DSA:3.30.390.50:FF:000033', NULL, NULL, 'AGAP006221-PA', NULL, NULL, NULL, NULL, NULL, 4),
(78770, NULL, 'G3DSA:1.20.1050.10:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78771, NULL, 'G3DSA:3.10.129.10:FF:000071', NULL, NULL, 'Thioesterase-like family protein', NULL, NULL, NULL, NULL, NULL, 4),
(78772, NULL, 'G3DSA:3.40.50.300:FF:007332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78773, NULL, 'G3DSA:2.60.40.640:FF:000068', NULL, NULL, 'Aspergillus niger contig An11c0110, genomic contig', NULL, NULL, NULL, NULL, NULL, 4),
(78774, NULL, 'G3DSA:2.60.40.10:FF:005083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78775, NULL, 'G3DSA:3.30.70.270:FF:000308', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78776, NULL, 'G3DSA:3.30.70.330:FF:000164', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(78777, NULL, 'G3DSA:1.10.287.280:FF:000003', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(78778, NULL, 'G3DSA:3.40.50.300:FF:000587', NULL, NULL, 'von Willebrand factor A domain containing 8', NULL, NULL, NULL, NULL, NULL, 4),
(78779, NULL, 'G3DSA:3.40.50.1470:FF:000009', NULL, NULL, 'Peptidyl-tRNA hydrolase 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(78780, NULL, 'G3DSA:2.130.10.10:FF:001424', NULL, NULL, 'Damaged DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(78781, NULL, 'G3DSA:3.40.50.10490:FF:000117', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78782, NULL, 'G3DSA:3.90.1530.30:FF:000007', NULL, NULL, 'DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(78783, NULL, 'G3DSA:2.60.40.60:FF:000657', NULL, NULL, 'Cadherin 16', NULL, NULL, NULL, NULL, NULL, 4),
(78784, NULL, 'G3DSA:3.30.457.50:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78785, NULL, 'G3DSA:1.10.510.10:FF:003461', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78786, NULL, 'G3DSA:1.20.90.10:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78787, NULL, 'G3DSA:3.30.160.60:FF:004594', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78788, NULL, 'G3DSA:2.60.40.10:FF:000878', NULL, NULL, 'T cell receptor alpha variable 38-1', NULL, NULL, NULL, NULL, NULL, 4),
(78789, NULL, 'G3DSA:1.25.10.10:FF:003074', NULL, NULL, 'Nuclear pre-mRNA splicing factor, component of splicing factor 3b', NULL, NULL, NULL, NULL, NULL, 4),
(78790, NULL, 'G3DSA:1.25.10.10:FF:000668', NULL, NULL, 'Protein DOA1', NULL, NULL, NULL, NULL, NULL, 4),
(78791, NULL, 'G3DSA:1.20.900.10:FF:000133', NULL, NULL, 'Probable serine/threonine-protein kinase roco5', NULL, NULL, NULL, NULL, NULL, 4),
(78792, NULL, 'G3DSA:3.40.50.11610:FF:000004', NULL, NULL, '2-oxoglutarate dehydrogenase, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(78793, NULL, 'G3DSA:3.40.50.720:FF:002337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78794, NULL, 'G3DSA:1.10.720.30:FF:000020', NULL, NULL, 'Cell division cycle and apoptosis regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(78795, NULL, 'G3DSA:3.30.428.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78796, NULL, 'G3DSA:2.30.30.140:FF:000052', NULL, NULL, 'SAGA-associated factor 29 isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(78797, NULL, 'G3DSA:3.40.50.300:FF:001104', NULL, NULL, 'DNA polymerase clamp loader subunit', NULL, NULL, NULL, NULL, NULL, 4),
(78798, NULL, 'G3DSA:3.30.160.60:FF:005257', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78799, NULL, 'G3DSA:3.40.390.10:FF:000316', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78800, NULL, 'G3DSA:1.10.10.10:FF:000696', NULL, NULL, 'DNA-directed RNA polymerase III subunit rpc3', NULL, NULL, NULL, NULL, NULL, 4),
(78801, NULL, 'G3DSA:3.75.10.10:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78802, NULL, 'G3DSA:1.25.40.860:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78803, NULL, 'G3DSA:3.40.250.10:FF:000109', NULL, NULL, 'Thiosulfate sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(78804, NULL, 'G3DSA:3.30.70.330:FF:002316', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78805, NULL, 'G3DSA:3.40.50.1450:FF:000003', NULL, NULL, 'Hydrogenase 3 maturation endopeptidase HyCI', NULL, NULL, NULL, NULL, NULL, 4),
(78806, NULL, 'G3DSA:1.25.40.570:FF:000046', NULL, NULL, 'YALI0F16874p', NULL, NULL, NULL, NULL, NULL, 4),
(78807, NULL, 'G3DSA:1.20.120.1630:FF:000008', NULL, NULL, 'C-14 sterol reductase', NULL, NULL, NULL, NULL, NULL, 4),
(78808, NULL, 'G3DSA:3.80.10.10:FF:000261', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase ERECTA', NULL, NULL, NULL, NULL, NULL, 4),
(78809, NULL, 'G3DSA:3.40.50.1000:FF:000588', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78810, NULL, 'G3DSA:1.25.40.10:FF:002777', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78811, NULL, 'G3DSA:1.20.1280.50:FF:000123', NULL, NULL, 'WGS project CABT00000000 data, contig 2.25', NULL, NULL, NULL, NULL, NULL, 4),
(78812, NULL, 'G3DSA:3.80.10.10:FF:002380', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78813, NULL, 'G3DSA:3.30.40.10:FF:002047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78814, NULL, 'G3DSA:3.50.50.60:FF:001162', NULL, NULL, 'FAD/NAD(P)-binding oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(78815, NULL, 'G3DSA:3.40.50.10490:FF:000106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78816, NULL, 'G3DSA:2.70.98.90:FF:000006', NULL, NULL, 'Membrane protein insertase YidC', NULL, NULL, NULL, NULL, NULL, 4),
(78817, NULL, 'G3DSA:3.40.850.10:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78818, NULL, 'G3DSA:2.130.10.10:FF:000761', NULL, NULL, 'Putative nucleolar preribosomal assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(78819, NULL, 'G3DSA:2.40.50.140:FF:000385', NULL, NULL, 'rRNA biogenesis protein RRP5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78820, NULL, 'G3DSA:3.90.190.10:FF:000470', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(78821, NULL, 'G3DSA:3.50.50.60:FF:000886', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78822, NULL, 'G3DSA:1.10.405.20:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78823, NULL, 'G3DSA:3.30.40.10:FF:000731', NULL, NULL, 'E3 ubiquitin-protein ligase RMA1', NULL, NULL, NULL, NULL, NULL, 4),
(78824, NULL, 'G3DSA:1.25.10.10:FF:003017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78825, NULL, 'G3DSA:2.60.40.10:FF:005044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78826, NULL, 'G3DSA:1.25.40.10:FF:000496', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(78827, NULL, 'G3DSA:2.30.29.30:FF:000112', NULL, NULL, 'active breakpoint cluster region-related protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(78828, NULL, 'G3DSA:2.10.25.10:FF:000160', NULL, NULL, 'latent-transforming growth factor beta-binding protein 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(78829, NULL, 'G3DSA:3.20.20.100:FF:000188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78830, NULL, 'G3DSA:1.10.287.2620:FF:000015', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78831, NULL, 'G3DSA:1.25.40.710:FF:000015', NULL, NULL, 'Tripeptidyl-peptidase 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(78832, NULL, 'G3DSA:1.10.3720.10:FF:000093', NULL, NULL, 'Iron(III) ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(78833, NULL, 'G3DSA:1.10.8.1220:FF:000004', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(78834, NULL, 'G3DSA:2.30.29.30:FF:000651', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(78835, NULL, 'G3DSA:3.30.70.330:FF:000782', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(78836, NULL, 'G3DSA:1.20.1410.10:FF:000021', NULL, NULL, 'Putative transmembrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(78837, NULL, 'G3DSA:1.20.120.560:FF:000006', NULL, NULL, 'Vacuolar-sorting protein BRO1', NULL, NULL, NULL, NULL, NULL, 4),
(78838, NULL, 'G3DSA:1.25.40.10:FF:005262', NULL, NULL, 'TPR-repeat-containing chaperone protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78839, NULL, 'G3DSA:3.30.420.10:FF:000131', NULL, NULL, 'Protein CBG26278', NULL, NULL, NULL, NULL, NULL, 4),
(78840, NULL, 'G3DSA:2.130.10.10:FF:005353', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78841, NULL, 'G3DSA:2.60.40.10:FF:004768', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78842, NULL, 'G3DSA:3.30.420.10:FF:000311', NULL, NULL, 'Ribonuclease H-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(78843, NULL, 'G3DSA:1.10.287.3990:FF:000004', NULL, NULL, '26S proteasome regulatory subunit N10', NULL, NULL, NULL, NULL, NULL, 4),
(78844, NULL, 'G3DSA:3.30.360.10:FF:000098', NULL, NULL, 'Homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(78845, NULL, 'G3DSA:3.30.450.20:FF:000523', NULL, NULL, 'Hybrid signal transduction histidine kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(78846, NULL, 'G3DSA:2.60.120.200:FF:000153', NULL, NULL, 'neurexin-1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(78847, NULL, 'G3DSA:3.30.70.330:FF:001220', NULL, NULL, 'NTF2 and RRM domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(78848, NULL, 'G3DSA:2.170.300.10:FF:000003', NULL, NULL, 'tyrosine-protein kinase receptor Tie-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(78849, NULL, 'G3DSA:3.40.50.150:FF:001632', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78850, NULL, 'G3DSA:1.20.1560.10:FF:000313', NULL, NULL, 'ABC transporter ATP-binding protein/permease', NULL, NULL, NULL, NULL, NULL, 4),
(78851, NULL, 'G3DSA:1.10.8.1210:FF:000001', NULL, NULL, 'Glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(78852, NULL, 'G3DSA:1.20.1070.10:FF:001574', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78853, NULL, 'G3DSA:1.20.1540.10:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78854, NULL, 'G3DSA:2.60.40.10:FF:003363', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78855, NULL, 'G3DSA:1.50.40.10:FF:000061', NULL, NULL, 'ADP/ATP transporter on adenylate translocase', NULL, NULL, NULL, NULL, NULL, 4),
(78856, NULL, 'G3DSA:1.10.287.3980:FF:000001', NULL, NULL, 'Mitochondrial ribosomal protein L34', NULL, NULL, NULL, NULL, NULL, 4),
(78857, NULL, 'G3DSA:3.90.1530.10:FF:000001', NULL, NULL, 'Sulfiredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(78858, NULL, 'G3DSA:2.60.40.10:FF:003306', NULL, NULL, 'Leukemia inhibitory factor receptor alpha b', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(78859, NULL, 'G3DSA:3.30.1330.90:FF:000006', NULL, NULL, 'L-serine ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(78860, NULL, 'G3DSA:1.10.472.10:FF:000095', NULL, NULL, 'Cyclin Ccl1, putative (AFU_orthologue AFUA_5G07030)', NULL, NULL, NULL, NULL, NULL, 4),
(78861, NULL, 'G3DSA:3.20.20.300:FF:000068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78862, NULL, 'G3DSA:3.90.190.10:FF:000413', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(78863, NULL, 'G3DSA:3.10.180.10:FF:000077', NULL, NULL, 'Glyoxalase/bleomycin resistance protein/dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(78864, NULL, 'G3DSA:3.30.40.10:FF:000170', NULL, NULL, 'E3 ubiquitin-protein ligase SHPRH isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(78865, NULL, 'G3DSA:3.60.15.10:FF:000172', NULL, NULL, 'Integrator complex subunit 11 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(78866, NULL, 'G3DSA:2.30.29.30:FF:000319', NULL, NULL, 'Dynamin 1', NULL, NULL, NULL, NULL, NULL, 4),
(78867, NULL, 'G3DSA:3.40.50.12780:FF:000091', NULL, NULL, 'Putative long-chain-fatty-acid--CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(78868, NULL, 'G3DSA:3.30.1010.10:FF:000009', NULL, NULL, 'Phosphatidylinositol 4-kinase, catalytic, alpha', NULL, NULL, NULL, NULL, NULL, 4),
(78869, NULL, 'G3DSA:3.40.640.10:FF:000477', NULL, NULL, 'Alanine aminotransferase 2 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(78870, NULL, 'G3DSA:1.25.40.10:FF:003233', NULL, NULL, 'TPR repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78871, NULL, 'G3DSA:3.40.630.40:FF:000013', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(78872, NULL, 'G3DSA:2.130.10.10:FF:000968', NULL, NULL, 'Hermansky-Pudlak syndrome 5 protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(78873, NULL, 'G3DSA:3.40.50.11060:FF:000007', NULL, NULL, 'GTPase HflX', NULL, NULL, NULL, NULL, NULL, 4),
(78874, NULL, 'G3DSA:2.60.40.420:FF:000215', NULL, NULL, 'Hephaestin-like 1a', NULL, NULL, NULL, NULL, NULL, 4),
(78875, NULL, 'G3DSA:4.10.280.10:FF:000103', NULL, NULL, 'Transcription factor bHLH162', NULL, NULL, NULL, NULL, NULL, 4),
(78876, NULL, 'G3DSA:3.30.505.10:FF:000103', NULL, NULL, 'Si:ch73-109i22.2', NULL, NULL, NULL, NULL, NULL, 4),
(78877, NULL, 'G3DSA:3.40.630.30:FF:000010', NULL, NULL, 'Putative N-alpha-acetyltransferase 30', NULL, NULL, NULL, NULL, NULL, 4),
(78878, NULL, 'G3DSA:1.10.472.170:FF:000016', NULL, NULL, 'Cyclin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(78879, NULL, 'G3DSA:3.90.70.10:FF:000528', NULL, NULL, 'YALI0F01903p', NULL, NULL, NULL, NULL, NULL, 4),
(78880, NULL, 'G3DSA:1.10.8.60:FF:000041', NULL, NULL, 'DNA polymerase III subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(78881, NULL, 'G3DSA:2.70.50.40:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78882, NULL, 'G3DSA:2.60.40.10:FF:002469', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(78883, NULL, 'G3DSA:3.40.50.300:FF:005353', NULL, NULL, 'Replication factor C subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(78884, NULL, 'G3DSA:3.40.50.300:FF:004870', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(78885, NULL, 'G3DSA:3.30.40.10:FF:002322', NULL, NULL, 'Lid2 complex component snt2', NULL, NULL, NULL, NULL, NULL, 4),
(78886, NULL, 'G3DSA:1.10.238.10:FF:001287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78887, NULL, 'G3DSA:2.60.120.10:FF:000324', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(78888, NULL, 'G3DSA:3.30.230.10:FF:000094', NULL, NULL, 'DNA mismatch repair protein PMS1', NULL, NULL, NULL, NULL, NULL, 4),
(78889, NULL, 'G3DSA:1.10.238.10:FF:001023', NULL, NULL, 'Calcium-binding EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(78890, NULL, 'G3DSA:1.25.40.10:FF:000439', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(78891, NULL, 'G3DSA:3.30.160.60:FF:003402', NULL, NULL, 'YALI0D05041p', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(78892, NULL, 'G3DSA:3.40.50.720:FF:002051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78893, NULL, 'G3DSA:3.30.160.60:FF:004717', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78894, NULL, 'G3DSA:1.20.1070.10:FF:000326', NULL, NULL, 'Free fatty acid receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(78895, NULL, 'G3DSA:2.40.50.770:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78896, NULL, 'G3DSA:3.90.1010.10:FF:000024', NULL, NULL, 'IscU', NULL, NULL, NULL, NULL, NULL, 4),
(78897, NULL, 'G3DSA:1.25.10.10:FF:001483', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(78898, NULL, 'G3DSA:1.10.10.60:FF:000957', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78899, NULL, 'G3DSA:1.10.1170.10:FF:000049', NULL, NULL, 'baculoviral IAP repeat-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(78900, NULL, 'G3DSA:1.10.630.10:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78901, NULL, 'G3DSA:3.80.10.10:FF:000547', NULL, NULL, 'Si:dkeyp-100h4.1', NULL, NULL, NULL, NULL, NULL, 4),
(78902, NULL, 'G3DSA:3.40.366.10:FF:000002', NULL, NULL, 'Probable polyketide synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(78903, NULL, 'G3DSA:3.80.10.10:FF:003807', NULL, NULL, 'SCF E3 ubiquitin ligase complex F-box protein pof2', NULL, NULL, NULL, NULL, NULL, 4),
(78904, NULL, 'G3DSA:1.20.1250.20:FF:000545', NULL, NULL, 'Alpha-ketoglutarate permease', NULL, NULL, NULL, NULL, NULL, 4),
(78905, NULL, 'G3DSA:3.60.40.10:FF:000134', NULL, NULL, 'Stage II sporulation protein E', NULL, NULL, NULL, NULL, NULL, 4),
(78906, NULL, 'G3DSA:1.20.1250.20:FF:001905', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78907, NULL, 'G3DSA:3.40.50.300:FF:008580', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78908, NULL, 'G3DSA:3.40.50.1820:FF:000311', NULL, NULL, 'Prolyl endopeptidase like', NULL, NULL, NULL, NULL, NULL, 4),
(78909, NULL, 'G3DSA:3.30.160.60:FF:005611', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78910, NULL, 'G3DSA:3.30.1010.10:FF:000066', NULL, NULL, 'AGAP003967-PA', NULL, NULL, NULL, NULL, NULL, 4),
(78911, NULL, 'G3DSA:1.20.1270.60:FF:000300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78912, NULL, 'G3DSA:3.90.226.10:FF:000155', NULL, NULL, 'Enoyl-CoA hydratase/isomerase family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(78913, NULL, 'G3DSA:2.10.25.10:FF:001784', NULL, NULL, 'NIDogen (Basement membrane protein)', NULL, NULL, NULL, NULL, NULL, 4),
(78914, NULL, 'G3DSA:3.40.50.80:FF:000235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78915, NULL, 'G3DSA:3.30.70.660:FF:000032', NULL, NULL, 'U2 snRNA/tRNA pseudouridine synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78916, NULL, 'G3DSA:3.40.50.2000:FF:000444', NULL, NULL, 'Alpha-1,2-mannosyltransferase (Alg2), putative', NULL, NULL, NULL, NULL, NULL, 4),
(78917, NULL, 'G3DSA:2.60.40.60:FF:001039', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(78918, NULL, 'G3DSA:3.40.50.150:FF:001637', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78919, NULL, 'G3DSA:2.60.40.10:FF:003806', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78920, NULL, 'G3DSA:3.40.50.12780:FF:000208', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(78921, NULL, 'G3DSA:3.80.10.10:FF:002228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78922, NULL, 'G3DSA:3.40.50.300:FF:003116', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(78923, NULL, 'G3DSA:3.30.160.20:FF:000102', NULL, NULL, 'DExH-box ATP-dependent RNA helicase DExH7 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(78924, NULL, 'G3DSA:3.40.50.970:FF:000192', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(78925, NULL, 'G3DSA:3.90.1170.40:FF:000004', NULL, NULL, 'Molybdopterin biosynthesis protein MoeE', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(78926, NULL, 'G3DSA:2.40.10.10:FF:000557', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78927, NULL, 'G3DSA:1.20.1720.10:FF:000112', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78928, NULL, 'G3DSA:3.30.1490.180:FF:000031', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(78929, NULL, 'G3DSA:2.30.42.10:FF:000362', NULL, NULL, 'Periplasmic serine endoprotease DegP-like', NULL, NULL, NULL, NULL, NULL, 4),
(78930, NULL, 'G3DSA:1.20.1250.20:FF:000540', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78931, NULL, 'G3DSA:3.90.550.10:FF:000189', NULL, NULL, 'Abequosyltransferase RfbV', NULL, NULL, NULL, NULL, NULL, 4),
(78932, NULL, 'G3DSA:3.80.10.10:FF:004420', NULL, NULL, 'Receptor-like protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(78933, NULL, 'G3DSA:3.30.160.60:FF:005375', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(78934, NULL, 'G3DSA:1.20.1740.10:FF:000063', NULL, NULL, 'Inner membrane transporter YjeM', NULL, NULL, NULL, NULL, NULL, 4),
(78935, NULL, 'G3DSA:3.40.20.10:FF:000145', NULL, NULL, 'Villidin', NULL, NULL, NULL, NULL, NULL, 4),
(78936, NULL, 'G3DSA:3.60.10.10:FF:000149', NULL, NULL, 'Endonuclease/exonuclease/phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78937, NULL, 'G3DSA:2.130.10.10:FF:004919', NULL, NULL, 'Os01g0607600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(78938, NULL, 'G3DSA:1.10.8.270:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78939, NULL, 'G3DSA:3.40.50.300:FF:001941', NULL, NULL, 'Mov10 RISC complex RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(78940, NULL, 'G3DSA:3.40.50.20:FF:000032', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(78941, NULL, 'G3DSA:3.10.580.10:FF:000225', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(78942, NULL, 'G3DSA:1.10.10.60:FF:000688', NULL, NULL, 'Homeobox transcription factor (RfeB)', NULL, NULL, NULL, NULL, NULL, 4),
(78943, NULL, 'G3DSA:1.20.120.1240:FF:000010', NULL, NULL, 'Dynamin-related protein 5A', NULL, NULL, NULL, NULL, NULL, 4),
(78944, NULL, 'G3DSA:3.30.590.10:FF:000025', NULL, NULL, 'Glutamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(78945, NULL, 'G3DSA:3.40.50.800:FF:000124', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(78946, NULL, 'G3DSA:3.50.50.60:FF:000908', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(78947, NULL, 'G3DSA:1.20.58.60:FF:000320', NULL, NULL, 'VAB-10A protein', NULL, NULL, NULL, NULL, NULL, 4),
(78948, NULL, 'G3DSA:3.40.30.10:FF:001219', NULL, NULL, '2-hydroxychromene-2-carboxylate isomerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78949, NULL, 'G3DSA:3.30.160.60:FF:002683', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(78950, NULL, 'G3DSA:1.20.1110.10:FF:000032', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(78951, NULL, 'G3DSA:1.20.80.10:FF:000042', NULL, NULL, 'diazepam-binding inhibitor-like 5', NULL, NULL, NULL, NULL, NULL, 4),
(78952, NULL, 'G3DSA:3.30.70.270:FF:000128', NULL, NULL, 'Transcriptional regulator CdgA', NULL, NULL, NULL, NULL, NULL, 4),
(78953, NULL, 'G3DSA:2.30.29.30:FF:000269', NULL, NULL, 'Synaptosomal-associated protein 47', NULL, NULL, NULL, NULL, NULL, 4),
(78954, NULL, 'G3DSA:3.40.50.1460:FF:000124', NULL, NULL, 'Caspase-4', NULL, NULL, NULL, NULL, NULL, 4),
(78955, NULL, 'G3DSA:3.40.50.300:FF:007450', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78956, NULL, 'G3DSA:4.10.400.10:FF:000310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78957, NULL, 'G3DSA:1.20.5.170:FF:000233', NULL, NULL, 'Probable basic-leucine zipper transcription factor G', NULL, NULL, NULL, NULL, NULL, 4),
(78958, NULL, 'G3DSA:2.60.40.180:FF:000008', NULL, NULL, '5-hydroxyisourate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(78959, NULL, 'G3DSA:2.60.40.10:FF:000996', NULL, NULL, 'ICOS ligand isoform X2', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(78960, NULL, 'G3DSA:3.40.50.2300:FF:000472', NULL, NULL, 'Vomeronasal 2, receptor 120', NULL, NULL, NULL, NULL, NULL, 4),
(78961, NULL, 'G3DSA:3.80.10.10:FF:001565', NULL, NULL, 'AGAP001807-PA', NULL, NULL, NULL, NULL, NULL, 4),
(78962, NULL, 'G3DSA:3.20.20.80:FF:000127', NULL, NULL, 'Glycosyl hydrolases family 18 protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(78963, NULL, 'G3DSA:2.130.10.10:FF:000974', NULL, NULL, 'WD repeat domain 90', NULL, NULL, NULL, NULL, NULL, 4),
(78964, NULL, 'G3DSA:3.30.420.140:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78965, NULL, 'G3DSA:1.10.8.10:FF:000043', NULL, NULL, 'Fas-associated factor family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(78966, NULL, 'G3DSA:1.20.1560.10:FF:000021', NULL, NULL, 'ABC transporter B family member 6', NULL, NULL, NULL, NULL, NULL, 4),
(78967, NULL, 'G3DSA:1.20.1270.60:FF:000070', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(78968, NULL, 'G3DSA:3.90.199.10:FF:000012', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(78969, NULL, 'G3DSA:3.40.50.970:FF:000147', NULL, NULL, 'Pyruvate dehydrogenase E1 component subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(78970, NULL, 'G3DSA:2.60.40.60:FF:001146', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(78971, NULL, 'G3DSA:3.40.50.2000:FF:000551', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(78972, NULL, 'G3DSA:3.40.50.620:FF:000396', NULL, NULL, 'Nuclear transcription factor Y subunit A-8', NULL, NULL, NULL, NULL, NULL, 4),
(78973, NULL, 'G3DSA:3.30.70.330:FF:000282', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(78974, NULL, 'G3DSA:1.20.1560.10:FF:000291', NULL, NULL, 'ABC multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(78975, NULL, 'G3DSA:3.10.129.10:FF:000239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78976, NULL, 'G3DSA:3.40.350.10:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78977, NULL, 'G3DSA:2.60.40.60:FF:000871', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78978, NULL, 'G3DSA:1.25.40.720:FF:000018', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(78979, NULL, 'G3DSA:1.20.920.10:FF:000022', NULL, NULL, 'Putative bromodomain-containing protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(78980, NULL, 'G3DSA:3.40.50.620:FF:000514', NULL, NULL, 'Glutamyl-tRNA synthetase (AFU_orthologue AFUA_2G16280)', NULL, NULL, NULL, NULL, NULL, 4),
(78981, NULL, 'G3DSA:1.20.1260.10:FF:000032', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(78982, NULL, 'G3DSA:1.25.40.10:FF:002912', NULL, NULL, 'YALI0F27753p', NULL, NULL, NULL, NULL, NULL, 4),
(78983, NULL, 'G3DSA:1.10.3520.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78984, NULL, 'G3DSA:1.20.1720.10:FF:000005', NULL, NULL, 'Bcr/CflA family efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(78985, NULL, 'G3DSA:2.120.10.30:FF:000380', NULL, NULL, 'Low-density lipoprotein RecePtor related', NULL, NULL, NULL, NULL, NULL, 4),
(78986, NULL, 'G3DSA:1.20.120.1380:FF:000012', NULL, NULL, 'Flagellar biosynthesis protein FlhF', NULL, NULL, NULL, NULL, NULL, 4),
(78987, NULL, 'G3DSA:3.90.70.80:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78988, NULL, 'G3DSA:2.60.120.10:FF:000330', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(78989, NULL, 'G3DSA:1.20.5.170:FF:000284', NULL, NULL, 'Hepatic leukemia factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(78990, NULL, 'G3DSA:3.90.1200.10:FF:000010', NULL, NULL, 'Maltokinase', NULL, NULL, NULL, NULL, NULL, 4),
(78991, NULL, 'G3DSA:2.20.110.10:FF:000029', NULL, NULL, 'Protein ACCUMULATION AND REPLICATION OF CHLOROPLASTS 3', NULL, NULL, NULL, NULL, NULL, 4),
(78992, NULL, 'G3DSA:4.10.60.30:FF:000001', NULL, NULL, 'nanos homolog 3', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(78993, NULL, 'G3DSA:2.30.29.30:FF:000325', NULL, NULL, 'Pleckstrin homology domain-containing family N member 1', NULL, NULL, NULL, NULL, NULL, 4),
(78994, NULL, 'G3DSA:3.30.260.10:FF:000039', NULL, NULL, '60 kDa chaperonin 2', NULL, NULL, NULL, NULL, NULL, 4),
(78995, NULL, 'G3DSA:3.40.50.150:FF:001014', NULL, NULL, 'Recombination and DNA repair', NULL, NULL, NULL, NULL, NULL, 4),
(78996, NULL, 'G3DSA:2.120.10.30:FF:000273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(78997, NULL, 'G3DSA:3.40.720.10:FF:000011', NULL, NULL, 'Non-specific phospholipase C1', NULL, NULL, NULL, NULL, NULL, 4),
(78998, NULL, 'G3DSA:3.30.160.60:FF:001160', NULL, NULL, 'Zinc finger and BTB domain containing 41', NULL, NULL, NULL, NULL, NULL, 4),
(78999, NULL, 'G3DSA:3.30.200.20:FF:000775', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79000, NULL, 'G3DSA:3.60.15.10:FF:000138', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(79001, NULL, 'G3DSA:3.40.630.30:FF:000521', NULL, NULL, 'Polyketide synthase/nonribosomal peptide synthetase hybrid RzxA', NULL, NULL, NULL, NULL, NULL, 4),
(79002, NULL, 'G3DSA:1.10.2040.10:FF:000001', NULL, NULL, 'Outer capsid protein mu-1', NULL, NULL, NULL, NULL, NULL, 4),
(79003, NULL, 'G3DSA:3.40.50.1000:FF:000857', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79004, NULL, 'G3DSA:1.50.10.10:FF:000020', NULL, NULL, 'Endoglucanase', NULL, NULL, NULL, NULL, NULL, 4),
(79005, NULL, 'G3DSA:2.10.25.10:FF:000446', NULL, NULL, 'neurogenic locus notch homolog protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(79006, NULL, 'G3DSA:1.10.287.70:FF:000524', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(79007, NULL, 'G3DSA:2.60.40.10:FF:005100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79008, NULL, 'G3DSA:2.160.20.80:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79009, NULL, 'G3DSA:3.90.1150.10:FF:000247', NULL, NULL, 'Sphingosine phosphate lyase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79010, NULL, 'G3DSA:1.10.287.130:FF:000048', NULL, NULL, 'Sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(79011, NULL, 'G3DSA:3.30.420.10:FF:000081', NULL, NULL, 'Exonuclease DPD1 chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(79012, NULL, 'G3DSA:1.10.260.100:FF:000014', NULL, NULL, 'Hsc70-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(79013, NULL, 'G3DSA:3.40.50.11990:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79014, NULL, 'G3DSA:3.30.420.10:FF:000193', NULL, NULL, 'Ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(79015, NULL, 'G3DSA:1.10.287.130:FF:000104', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(79016, NULL, 'G3DSA:3.40.50.360:FF:000003', NULL, NULL, 'Nitric oxide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(79017, NULL, 'G3DSA:2.60.40.2860:FF:000017', NULL, NULL, 'Membrane protein PF12', NULL, NULL, NULL, NULL, NULL, 4),
(79018, NULL, 'G3DSA:3.10.660.10:FF:000007', NULL, NULL, 'Diphthamide biosynthesis protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(79019, NULL, 'G3DSA:1.25.10.10:FF:001724', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79020, NULL, 'G3DSA:3.40.50.300:FF:005533', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79021, NULL, 'G3DSA:2.30.42.10:FF:000069', NULL, NULL, 'Nitric oxide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(79022, NULL, 'G3DSA:1.10.12.70:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79023, NULL, 'G3DSA:1.20.1250.20:FF:002338', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79024, NULL, 'G3DSA:3.40.50.720:FF:000252', NULL, NULL, 'UDP-sulfoquinovose synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(79025, NULL, 'G3DSA:3.30.565.10:FF:000287', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(79026, NULL, 'G3DSA:2.40.320.10:FF:000029', NULL, NULL, 'THTPA isoform 6', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(79027, NULL, 'G3DSA:3.30.565.10:FF:000068', NULL, NULL, 'Sensor-type histidine kinase prrB', NULL, NULL, NULL, NULL, NULL, 4),
(79028, NULL, 'G3DSA:3.30.460.10:FF:000083', NULL, NULL, 'DNA polymerase sigma subunit', NULL, NULL, NULL, NULL, NULL, 4),
(79029, NULL, 'G3DSA:1.10.10.950:FF:000001', NULL, NULL, 'Protein Rep68', NULL, NULL, NULL, NULL, NULL, 4),
(79030, NULL, 'G3DSA:3.30.559.10:FF:000278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79031, NULL, 'G3DSA:1.25.40.10:FF:002856', NULL, NULL, 'Os08g0511000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(79032, NULL, 'G3DSA:2.130.10.10:FF:000699', NULL, NULL, 'POC1 centriolar protein homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(79033, NULL, 'G3DSA:3.40.50.10140:FF:000029', NULL, NULL, 'TOLl (Drosophila) family', NULL, NULL, NULL, NULL, NULL, 4),
(79034, NULL, 'G3DSA:3.20.20.140:FF:000110', NULL, NULL, 'Dihydroorotase', NULL, NULL, NULL, NULL, NULL, 4),
(79035, NULL, 'G3DSA:1.20.1250.20:FF:000247', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(79036, NULL, 'G3DSA:1.10.630.10:FF:000322', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79037, NULL, 'G3DSA:3.40.190.290:FF:000057', NULL, NULL, 'Putative Nitrogen assimilation regulatory protein Nac', NULL, NULL, NULL, NULL, NULL, 4),
(79038, NULL, 'G3DSA:3.30.540.10:FF:000084', NULL, NULL, 'Inositol monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(79039, NULL, 'G3DSA:3.30.200.20:FF:000831', NULL, NULL, 'Homoserine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(79040, NULL, 'G3DSA:3.30.450.40:FF:000086', NULL, NULL, 'Phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(79041, NULL, 'G3DSA:2.130.10.30:FF:000132', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79042, NULL, 'G3DSA:3.40.50.300:FF:001722', NULL, NULL, 'ADP-ribosylation factor-like protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(79043, NULL, 'G3DSA:1.10.287.70:FF:000294', NULL, NULL, 'TOK potassium channel', NULL, NULL, NULL, NULL, NULL, 4),
(79044, NULL, 'G3DSA:3.30.160.60:FF:000766', NULL, NULL, 'Zinc finger and BTB domain-containing 14', NULL, NULL, NULL, NULL, NULL, 4),
(79045, NULL, 'G3DSA:3.30.200.20:FF:000887', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79046, NULL, 'G3DSA:3.40.390.10:FF:000322', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79047, NULL, 'G3DSA:2.40.10.190:FF:000004', NULL, NULL, 'LSU ribosomal protein L35AE', NULL, NULL, NULL, NULL, NULL, 4),
(79048, NULL, 'G3DSA:1.25.40.20:FF:000768', NULL, NULL, 'Protein 21.1', NULL, NULL, NULL, NULL, NULL, 4),
(79049, NULL, 'G3DSA:2.130.10.10:FF:001542', NULL, NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', NULL, NULL, NULL, NULL, NULL, 4),
(79050, NULL, 'G3DSA:1.25.40.10:FF:000765', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79051, NULL, 'G3DSA:2.40.10.350:FF:000018', NULL, NULL, 'Rod shape-determining protein MreC', NULL, NULL, NULL, NULL, NULL, 4),
(79052, NULL, 'G3DSA:3.40.50.10810:FF:000197', NULL, NULL, 'Adenosinetriphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(79053, NULL, 'G3DSA:3.30.40.10:FF:000462', NULL, NULL, 'Ring finger domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(79054, NULL, 'G3DSA:2.130.10.10:FF:000648', NULL, NULL, 'Autophagy-related 16, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(79055, NULL, 'G3DSA:3.30.465.10:FF:000009', NULL, NULL, 'K(+)/H(+) antiporter NhaP2', NULL, NULL, NULL, NULL, NULL, 4),
(79056, NULL, 'G3DSA:3.50.50.60:FF:000381', NULL, NULL, 'AGAP002616-PA', NULL, NULL, NULL, NULL, NULL, 4),
(79057, NULL, 'G3DSA:3.40.50.300:FF:005033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79058, NULL, 'G3DSA:3.30.70.260:FF:000013', NULL, NULL, 'TyrR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(79059, NULL, 'G3DSA:3.30.310.80:FF:000020', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(79060, NULL, 'G3DSA:2.40.30.270:FF:000038', NULL, NULL, 'DNA-binding protein Smubp-2, putative', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(79061, NULL, 'G3DSA:3.40.50.300:FF:006994', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79062, NULL, 'G3DSA:3.40.50.2300:FF:000702', NULL, NULL, 'Low molecular weight protein-tyrosine-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(79063, NULL, 'G3DSA:3.30.1780.10:FF:000016', NULL, NULL, 'Ornithine cyclodeaminase', NULL, NULL, NULL, NULL, NULL, 4),
(79064, NULL, 'G3DSA:1.20.1270.60:FF:000182', NULL, NULL, 'Autophagy-related protein 24', NULL, NULL, NULL, NULL, NULL, 4),
(79065, NULL, 'G3DSA:3.30.559.10:FF:000227', NULL, NULL, 'Protein CBG17205', NULL, NULL, NULL, NULL, NULL, 4),
(79066, NULL, 'G3DSA:2.60.120.10:FF:000004', NULL, NULL, 'Fumarate/nitrate reduction transcriptional regulator Fnr', NULL, NULL, NULL, NULL, NULL, 4),
(79067, NULL, 'G3DSA:3.40.1820.10:FF:000001', NULL, NULL, 'DNA-directed DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(79068, NULL, 'G3DSA:6.20.10.30:FF:000015', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(79069, NULL, 'G3DSA:2.170.300.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79070, NULL, 'G3DSA:1.20.58.340:FF:000014', NULL, NULL, 'CorA family metal ion transporter', NULL, NULL, NULL, NULL, NULL, 4),
(79071, NULL, 'G3DSA:3.80.10.10:FF:002503', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(79072, NULL, 'G3DSA:1.10.472.80:FF:000019', NULL, NULL, 'USP6 N-terminal like', NULL, NULL, NULL, NULL, NULL, 4),
(79073, NULL, 'G3DSA:1.20.1050.10:FF:000263', NULL, NULL, 'Glutathione S-transferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(79074, NULL, 'G3DSA:4.10.410.10:FF:000024', NULL, NULL, 'Protein CBR-MEC-1', NULL, NULL, NULL, NULL, NULL, 4),
(79075, NULL, 'G3DSA:3.40.50.620:FF:000626', NULL, NULL, 'Glutamine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(79076, NULL, 'G3DSA:3.80.10.10:FF:003689', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79077, NULL, 'G3DSA:3.30.2070.10:FF:000007', NULL, NULL, 'Dimethyl sulfoxide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(79078, NULL, 'G3DSA:1.10.640.10:FF:000036', NULL, NULL, 'AGAP013304-PA', NULL, NULL, NULL, NULL, NULL, 4),
(79079, NULL, 'G3DSA:3.30.70.250:FF:000010', NULL, NULL, 'Sterigmatocystin biosynthesis polyketide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(79080, NULL, 'G3DSA:2.10.90.10:FF:000001', NULL, NULL, 'Bone morphogenetic protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(79081, NULL, 'G3DSA:3.40.50.720:FF:000656', NULL, NULL, 'Glucose-6-phosphate 1-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(79082, NULL, 'G3DSA:2.60.120.20:FF:000007', NULL, NULL, 'Capsid polyprotein VP90', NULL, NULL, NULL, NULL, NULL, 4),
(79083, NULL, 'G3DSA:1.10.510.10:FF:004478', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79084, NULL, 'G3DSA:1.10.510.10:FF:002792', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79085, NULL, 'G3DSA:1.10.10.60:FF:000637', NULL, NULL, 'Bric-a-brac', NULL, NULL, NULL, NULL, NULL, 4),
(79086, NULL, 'G3DSA:2.60.120.650:FF:000097', NULL, NULL, 'Unplaced genomic scaffold supercont2.18, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(79087, NULL, 'G3DSA:1.10.10.750:FF:000003', NULL, NULL, 'GTPase activating protein (Evi5)', NULL, NULL, NULL, NULL, NULL, 4),
(79088, NULL, 'G3DSA:1.10.510.10:FF:001780', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79089, NULL, 'G3DSA:3.90.1150.10:FF:000298', NULL, NULL, 'alanine--glyoxylate aminotransferase 2, mitochondrial isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(79090, NULL, 'G3DSA:1.10.132.30:FF:000002', NULL, NULL, 'DNA-directed RNA polymerase subunit beta''''', NULL, NULL, NULL, NULL, NULL, 4),
(79091, NULL, 'G3DSA:3.40.1690.20:FF:000004', NULL, NULL, 'ATP-dependent zinc metalloprotease FTSH 10 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(79092, NULL, 'G3DSA:1.10.443.10:FF:000022', NULL, NULL, 'Prophage integrase IntE', NULL, NULL, NULL, NULL, NULL, 4),
(79093, NULL, 'G3DSA:1.10.1060.10:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(79094, NULL, 'G3DSA:3.20.20.70:FF:000310', NULL, NULL, 'Dihydrodipicolinate synthase DapA', NULL, NULL, NULL, NULL, NULL, 4),
(79095, NULL, 'G3DSA:3.30.160.20:FF:000046', NULL, NULL, 'Peptidyl-tRNA hydrolase ICT1', NULL, NULL, NULL, NULL, NULL, 4),
(79096, NULL, 'G3DSA:2.60.120.290:FF:000174', NULL, NULL, 'Cubilin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(79097, NULL, 'G3DSA:3.30.1370.50:FF:000019', NULL, NULL, 'R3H-associated N-terminal domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79098, NULL, 'G3DSA:1.10.840.10:FF:000017', NULL, NULL, 'Blast:Ral guanine nucleotide dissociation stimulator-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(79099, NULL, 'G3DSA:3.40.50.1220:FF:000013', NULL, NULL, 'Pyruvate dehydrogenase [ubiquinone]', NULL, NULL, NULL, NULL, NULL, 4),
(79100, NULL, 'G3DSA:3.40.50.300:FF:006663', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79101, NULL, 'G3DSA:3.20.20.80:FF:000313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79102, NULL, 'G3DSA:3.40.1110.10:FF:000150', NULL, NULL, 'ATP7, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(79103, NULL, 'G3DSA:1.10.40.30:FF:000006', NULL, NULL, 'Adenylosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(79104, NULL, 'G3DSA:3.90.640.10:FF:000123', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(79105, NULL, 'G3DSA:3.20.180.20:FF:000033', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(79106, NULL, 'G3DSA:3.30.160.60:FF:003407', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79107, NULL, 'G3DSA:3.40.1170.10:FF:000035', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(79108, NULL, 'G3DSA:2.40.10.340:FF:000010', NULL, NULL, 'Cell shape-determining protein MreC', NULL, NULL, NULL, NULL, NULL, 4),
(79109, NULL, 'G3DSA:3.40.50.720:FF:000870', NULL, NULL, 'Steroid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(79110, NULL, 'G3DSA:2.40.10.350:FF:000013', NULL, NULL, 'Cell shape-determining protein MreC', NULL, NULL, NULL, NULL, NULL, 4),
(79111, NULL, 'G3DSA:2.60.40.10:FF:001452', NULL, NULL, 'Uncharacterized protein, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(79112, NULL, 'G3DSA:3.30.60.30:FF:000002', NULL, NULL, 'tomoregulin-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(79113, NULL, 'G3DSA:3.50.50.60:FF:000504', NULL, NULL, 'Phytoene desaturase', NULL, NULL, NULL, NULL, NULL, 4),
(79114, NULL, 'G3DSA:1.10.1670.10:FF:000065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79115, NULL, 'G3DSA:4.10.1080.10:FF:000012', NULL, NULL, 'Cartilage oligomeric matrix protein', NULL, NULL, NULL, NULL, NULL, 4),
(79116, NULL, 'G3DSA:1.20.1640.10:FF:000078', NULL, NULL, 'Protein CBG18375', NULL, NULL, NULL, NULL, NULL, 4),
(79117, NULL, 'G3DSA:3.30.70.270:FF:000067', NULL, NULL, 'DNA polymerase iota, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79118, NULL, 'G3DSA:3.30.470.10:FF:000027', NULL, NULL, 'Putative secreted protein', NULL, NULL, NULL, NULL, NULL, 4),
(79119, NULL, 'G3DSA:1.10.1200.10:FF:000081', NULL, NULL, 'Acyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(79120, NULL, 'G3DSA:3.30.2080.10:FF:000014', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(79121, NULL, 'G3DSA:2.130.10.10:FF:001761', NULL, NULL, 'Chromatin assembly factor 1 subunit b-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(79122, NULL, 'G3DSA:1.20.910.10:FF:000015', NULL, NULL, 'PET18p protein', NULL, NULL, NULL, NULL, NULL, 4),
(79123, NULL, 'G3DSA:3.40.190.10:FF:000397', NULL, NULL, 'Glutamate receptor ionotropic, NMDA 2D', NULL, NULL, NULL, NULL, NULL, 4),
(79124, NULL, 'G3DSA:1.10.1450.10:FF:000088', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(79125, NULL, 'G3DSA:3.30.420.40:FF:000477', NULL, NULL, 'Glycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(79126, NULL, 'G3DSA:3.30.750.24:FF:000006', NULL, NULL, 'Solute carrier family 26 member 6', NULL, NULL, NULL, NULL, NULL, 4),
(79127, NULL, 'G3DSA:1.20.1070.10:FF:000500', NULL, NULL, 'Chemokine (C-X-C motif) receptor 1', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(79128, NULL, 'G3DSA:3.40.50.1220:FF:000069', NULL, NULL, 'Putative acetolactate synthase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(79129, NULL, 'G3DSA:1.10.4020.10:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79130, NULL, 'G3DSA:1.25.10.10:FF:001101', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(79131, NULL, 'G3DSA:2.40.340.10:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79132, NULL, 'G3DSA:3.30.70.100:FF:000044', NULL, NULL, 'Copper-transporting ATPase PAA2 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(79133, NULL, 'G3DSA:3.30.56.10:FF:000026', NULL, NULL, 'Phenylalanyl-tRNA synthetase beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(79134, NULL, 'G3DSA:3.30.559.10:FF:000008', NULL, NULL, 'Tryptamine hydroxycinnamoyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(79135, NULL, 'G3DSA:2.40.50.140:FF:000891', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79136, NULL, 'G3DSA:3.30.70.270:FF:000123', NULL, NULL, 'Deoxycytidyl transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79137, NULL, 'G3DSA:2.60.40.10:FF:005723', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79138, NULL, 'G3DSA:3.80.10.10:FF:004201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79139, NULL, 'G3DSA:3.80.10.10:FF:003982', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79140, NULL, 'G3DSA:3.30.70.270:FF:000016', NULL, NULL, 'POL polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(79141, NULL, 'G3DSA:2.30.29.30:FF:001112', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(79142, NULL, 'G3DSA:3.40.50.410:FF:000221', NULL, NULL, 'Collagen, type VI, alpha 4a', NULL, NULL, NULL, NULL, NULL, 4),
(79143, NULL, 'G3DSA:3.40.50.1010:FF:000012', NULL, NULL, 'SWT1, RNA endoribonuclease homolog', NULL, NULL, NULL, NULL, NULL, 4),
(79144, NULL, 'G3DSA:2.130.10.10:FF:003610', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79145, NULL, 'G3DSA:3.30.70.330:FF:002294', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79146, NULL, 'G3DSA:2.60.120.650:FF:000153', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(79147, NULL, 'G3DSA:3.40.33.10:FF:000124', NULL, NULL, 'Protein CBG01204', NULL, NULL, NULL, NULL, NULL, 4),
(79148, NULL, 'G3DSA:2.60.40.10:FF:003251', NULL, NULL, 'Mannosidase, beta A, lysosomal', NULL, NULL, NULL, NULL, NULL, 4),
(79149, NULL, 'G3DSA:3.30.70.260:FF:000120', NULL, NULL, 'Bifunctional uridylyltransferase/uridylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(79150, NULL, 'G3DSA:3.40.50.300:FF:001048', NULL, NULL, 'ABC transporter C family member 4', NULL, NULL, NULL, NULL, NULL, 4),
(79151, NULL, 'G3DSA:1.25.40.10:FF:001221', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(79152, NULL, 'G3DSA:3.40.50.10130:FF:000021', NULL, NULL, 'DNA repair endonuclease xp-f, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79153, NULL, 'G3DSA:1.25.40.10:FF:000939', NULL, NULL, 'Pentatricopeptide repeat-containing protein ELI1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(79154, NULL, 'G3DSA:3.30.160.60:FF:003458', NULL, NULL, 'Zinc finger and BTB domain containing 40', NULL, NULL, NULL, NULL, NULL, 4),
(79155, NULL, 'G3DSA:1.25.40.10:FF:000653', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(79156, NULL, 'G3DSA:3.40.1110.10:FF:000155', NULL, NULL, 'Calcium-translocating P-type ATPase, PMCA-type', NULL, NULL, NULL, NULL, NULL, 4),
(79157, NULL, 'G3DSA:3.30.160.20:FF:000041', NULL, NULL, 'tRNA-dihydrouridine(20) synthase [NAD(P)+]-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(79158, NULL, 'G3DSA:3.30.1520.10:FF:000183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79159, NULL, 'G3DSA:2.40.50.140:FF:001110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79160, NULL, 'G3DSA:1.20.1730.10:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(79161, NULL, 'G3DSA:3.40.50.1820:FF:000373', NULL, NULL, 'Neural stem cell-derived dendrite regulator', NULL, NULL, NULL, NULL, NULL, 4),
(79162, NULL, 'G3DSA:2.60.40.10:FF:005375', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79163, NULL, 'G3DSA:2.30.130.40:FF:000026', NULL, NULL, 'AGAP005299-PA', NULL, NULL, NULL, NULL, NULL, 4),
(79164, NULL, 'G3DSA:1.10.510.10:FF:000549', NULL, NULL, 'Protein serine/threonine kinase (Ran1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(79165, NULL, 'G3DSA:3.40.850.10:FF:000346', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(79166, NULL, 'G3DSA:3.40.390.10:FF:000266', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79167, NULL, 'G3DSA:1.20.1560.10:FF:000077', NULL, NULL, 'ABC transporter ATP-binding protein/permease', NULL, NULL, NULL, NULL, NULL, 4),
(79168, NULL, 'G3DSA:1.10.1760.20:FF:000013', NULL, NULL, 'Diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(79169, NULL, 'G3DSA:1.10.600.10:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79170, NULL, 'G3DSA:3.30.1330.10:FF:000045', NULL, NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(79171, NULL, 'G3DSA:3.30.420.40:FF:000584', NULL, NULL, 'Actin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79172, NULL, 'G3DSA:3.90.1150.190:FF:000002', NULL, NULL, 'Scm-like with four MBT domains protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(79173, NULL, 'G3DSA:3.40.50.10140:FF:000024', NULL, NULL, 'TIR domain-containing adapter molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(79174, NULL, 'G3DSA:1.25.40.10:FF:003345', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79175, NULL, 'G3DSA:3.80.10.10:FF:004145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79176, NULL, 'G3DSA:3.30.1120.30:FF:000046', NULL, NULL, 'Probable serine/threonine-protein kinase CCRP1', NULL, NULL, NULL, NULL, NULL, 4),
(79177, NULL, 'G3DSA:2.60.40.10:FF:005105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79178, NULL, 'G3DSA:3.40.50.620:FF:000340', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(79179, NULL, 'G3DSA:3.30.70.1050:FF:000015', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(79180, NULL, 'G3DSA:3.30.450.30:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79181, NULL, 'G3DSA:3.30.40.10:FF:000574', NULL, NULL, 'E3 ubiquitin-protein ligase Hakai', NULL, NULL, NULL, NULL, NULL, 4),
(79182, NULL, 'G3DSA:3.60.10.10:FF:000037', NULL, NULL, 'Glucose-repressible alcohol dehydrogenase transcriptional effector', NULL, NULL, NULL, NULL, NULL, 4),
(79183, NULL, 'G3DSA:2.70.170.10:FF:000286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79184, NULL, 'G3DSA:2.40.155.10:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79185, NULL, 'G3DSA:2.30.30.100:FF:000169', NULL, NULL, 'LSM domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(79186, NULL, 'G3DSA:3.40.50.1910:FF:000006', NULL, NULL, 'Vacuolar protein sorting-associated protein 33A', NULL, NULL, NULL, NULL, NULL, 4),
(79187, NULL, 'G3DSA:1.20.58.60:FF:000325', NULL, NULL, 'SMAll', NULL, NULL, NULL, NULL, NULL, 4),
(79188, NULL, 'G3DSA:3.30.450.20:FF:000080', NULL, NULL, 'protein TWIN LOV 1', NULL, NULL, NULL, NULL, NULL, 4),
(79189, NULL, 'G3DSA:3.80.10.10:FF:003577', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79190, NULL, 'G3DSA:3.40.50.300:FF:005319', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79191, NULL, 'G3DSA:3.20.20.100:FF:000126', NULL, NULL, 'Aldo-keto reductase family 1, member C20', NULL, NULL, NULL, NULL, NULL, 4),
(79192, NULL, 'G3DSA:1.25.40.10:FF:004868', NULL, NULL, 'Diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(79193, NULL, 'G3DSA:2.10.25.10:FF:000660', NULL, NULL, 'Eyes shut, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(79194, NULL, 'G3DSA:3.30.40.10:FF:000169', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(79195, NULL, 'G3DSA:1.25.10.10:FF:000825', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79196, NULL, 'G3DSA:1.20.58.70:FF:000093', NULL, NULL, 'Syntaxin-1A', NULL, NULL, NULL, NULL, NULL, 4),
(79197, NULL, 'G3DSA:1.20.120.350:FF:000005', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(79198, NULL, 'G3DSA:1.20.58.60:FF:000090', NULL, NULL, 'microtubule-actin cross-linking factor 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(79199, NULL, 'G3DSA:2.60.15.10:FF:000016', NULL, NULL, 'Mitochondrial F1F0 ATP synthase, delta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(79200, NULL, 'G3DSA:2.60.120.260:FF:000356', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79201, NULL, 'G3DSA:3.80.10.10:FF:003919', NULL, NULL, 'Receptor-like protein EIX2', NULL, NULL, NULL, NULL, NULL, 4),
(79202, NULL, 'G3DSA:3.55.40.10:FF:000001', NULL, NULL, 'Type 4 fimbrial biogenesis protein FimU', NULL, NULL, NULL, NULL, NULL, 4),
(79203, NULL, 'G3DSA:1.20.144.10:FF:000128', NULL, NULL, 'PAP2 superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(79204, NULL, 'G3DSA:3.40.50.620:FF:000901', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79205, NULL, 'G3DSA:3.30.160.340:FF:000001', NULL, NULL, '2-isopropylmalate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(79206, NULL, 'G3DSA:1.25.40.10:FF:005144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79207, NULL, 'G3DSA:3.40.50.1820:FF:000480', NULL, NULL, 'Dimodular nonribosomal peptide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(79208, NULL, 'G3DSA:2.60.40.10:FF:004829', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79209, NULL, 'G3DSA:1.10.510.10:FF:004259', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79210, NULL, 'G3DSA:3.50.50.60:FF:000386', NULL, NULL, 'FAD/NAD(P)-binding oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(79211, NULL, 'G3DSA:3.30.70.260:FF:000064', NULL, NULL, 'GTP pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(79212, NULL, 'G3DSA:3.30.460.10:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79213, NULL, 'G3DSA:2.130.10.10:FF:003554', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79214, NULL, 'G3DSA:2.60.120.260:FF:000249', NULL, NULL, 'Probable beta-glucosidase K', NULL, NULL, NULL, NULL, NULL, 4),
(79215, NULL, 'G3DSA:3.40.970.10:FF:000001', NULL, NULL, 'Ribonuclease H1', NULL, NULL, NULL, NULL, NULL, 4),
(79216, NULL, 'G3DSA:3.40.50.1820:FF:000154', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(79217, NULL, 'G3DSA:3.40.30.10:FF:000207', NULL, NULL, 'thioredoxin domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(79218, NULL, 'G3DSA:3.30.470.20:FF:000182', NULL, NULL, 'Succinyl-CoA synthetase beta subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79219, NULL, 'G3DSA:3.10.100.10:FF:000196', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79220, NULL, 'G3DSA:1.20.120.660:FF:000003', NULL, NULL, 'Cag pathogenicity island protein', NULL, NULL, NULL, NULL, NULL, 4),
(79221, NULL, 'G3DSA:3.40.250.10:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79222, NULL, 'G3DSA:2.10.25.10:FF:000042', NULL, NULL, 'Integrin subunit beta-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(79223, NULL, 'G3DSA:3.80.10.10:FF:000704', NULL, NULL, 'Leucine-rich repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(79224, NULL, 'G3DSA:3.30.70.330:FF:000349', NULL, NULL, 'Protein MEI2-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(79225, NULL, 'G3DSA:3.40.50.300:FF:004010', NULL, NULL, 'Type III restriction-modification enzyme helicase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(79226, NULL, 'G3DSA:4.10.240.10:FF:000140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79227, NULL, 'G3DSA:1.10.510.10:FF:002466', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79228, NULL, 'G3DSA:3.20.20.80:FF:000190', NULL, NULL, 'Sucrose phosphorylase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(79229, NULL, 'G3DSA:1.20.5.170:FF:000014', NULL, NULL, 'Spectrin alpha chain, non-erythrocytic 1', NULL, NULL, NULL, NULL, NULL, 4),
(79230, NULL, 'G3DSA:3.40.50.300:FF:002104', NULL, NULL, 'ATP-dependent RNA helicase ROK1', NULL, NULL, NULL, NULL, NULL, 4),
(79231, NULL, 'G3DSA:3.50.50.60:FF:000903', NULL, NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', NULL, NULL, NULL, NULL, NULL, 4),
(79232, NULL, 'G3DSA:1.20.1050.90:FF:000011', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(79233, NULL, 'G3DSA:1.10.8.10:FF:000048', NULL, NULL, 'activated CDC42 kinase 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(79234, NULL, 'G3DSA:2.10.10.10:FF:000013', NULL, NULL, 'Insulin like growth factor 2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(79235, NULL, 'G3DSA:3.30.365.10:FF:000013', NULL, NULL, 'Aldehyde oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(79236, NULL, 'G3DSA:2.20.70.10:FF:000264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79237, NULL, 'G3DSA:2.60.120.260:FF:000575', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79238, NULL, 'G3DSA:3.80.10.10:FF:004471', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79239, NULL, 'G3DSA:1.20.920.10:FF:000027', NULL, NULL, 'Cat eye syndrome critical region protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(79240, NULL, 'G3DSA:3.30.920.10:FF:000006', NULL, NULL, 'FXN isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(79241, NULL, 'G3DSA:1.25.40.10:FF:004924', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(79242, NULL, 'G3DSA:3.30.710.10:FF:000182', NULL, NULL, 'Rhogtpase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79243, NULL, 'G3DSA:1.25.40.120:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79244, NULL, 'G3DSA:3.10.310.20:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79245, NULL, 'G3DSA:3.100.10.10:FF:000005', NULL, NULL, '50S ribosomal protein L15', NULL, NULL, NULL, NULL, NULL, 4),
(79246, NULL, 'G3DSA:1.25.40.20:FF:001550', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79247, NULL, 'G3DSA:3.30.420.40:FF:000876', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79248, NULL, 'G3DSA:1.10.10.10:FF:000757', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(79249, NULL, 'G3DSA:2.40.50.140:FF:000267', NULL, NULL, 'Protein BREAST CANCER SUSCEPTIBILITY 2 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(79250, NULL, 'G3DSA:3.10.310.10:FF:000026', NULL, NULL, 'Uncharacterized isomerase YHI9', NULL, NULL, NULL, NULL, NULL, 4),
(79251, NULL, 'G3DSA:3.90.660.10:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79252, NULL, 'G3DSA:1.20.58.60:FF:000651', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79253, NULL, 'G3DSA:2.30.42.10:FF:000581', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79254, NULL, 'G3DSA:1.10.287.130:FF:000155', NULL, NULL, 'Histidine kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79255, NULL, 'G3DSA:2.30.30.100:FF:000118', NULL, NULL, 'Probable small nuclear ribonucleoprotein F', NULL, NULL, NULL, NULL, NULL, 4),
(79256, NULL, 'G3DSA:3.30.420.10:FF:000316', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79257, NULL, 'G3DSA:2.60.120.200:FF:000041', NULL, NULL, 'thrombospondin-1', NULL, NULL, NULL, NULL, NULL, 4),
(79258, NULL, 'G3DSA:1.20.1250.20:FF:002164', NULL, NULL, 'Biopterin transporter BT1', NULL, NULL, NULL, NULL, NULL, 4),
(79259, NULL, 'G3DSA:1.10.1820.10:FF:000009', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(79260, NULL, 'G3DSA:1.25.40.10:FF:005200', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(79261, NULL, 'G3DSA:2.30.29.30:FF:000095', NULL, NULL, 'WD repeat and FYVE domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(79262, NULL, 'G3DSA:2.130.10.10:FF:002498', NULL, NULL, 'Sensor histidine kinase TodS', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(79263, NULL, 'G3DSA:3.40.50.10490:FF:000151', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79264, NULL, 'G3DSA:3.30.420.40:FF:000258', NULL, NULL, 'Actin-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(79265, NULL, 'G3DSA:1.10.2000.10:FF:000004', NULL, NULL, 'Frizzled class receptor 8a', NULL, NULL, NULL, NULL, NULL, 4),
(79266, NULL, 'G3DSA:3.30.160.60:FF:003172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79267, NULL, 'G3DSA:2.60.40.10:FF:005049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79268, NULL, 'G3DSA:3.30.310.280:FF:000001', NULL, NULL, 'Aerobactin siderophore biosynthesis protein IucC', NULL, NULL, NULL, NULL, NULL, 4),
(79269, NULL, 'G3DSA:3.90.640.10:FF:000016', NULL, NULL, 'ARP5 actin-related protein 5 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(79270, NULL, 'G3DSA:2.40.160.10:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79271, NULL, 'G3DSA:1.25.40.10:FF:004649', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79272, NULL, 'G3DSA:3.40.50.300:FF:002897', NULL, NULL, 'Small GTP binding protein Rab7 putative', NULL, NULL, NULL, NULL, NULL, 4),
(79273, NULL, 'G3DSA:2.30.30.40:FF:000629', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79274, NULL, 'G3DSA:2.60.120.780:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79275, NULL, 'G3DSA:3.40.50.150:FF:001019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79276, NULL, 'G3DSA:2.60.120.200:FF:000092', NULL, NULL, 'Laminin subunit alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(79277, NULL, 'G3DSA:1.20.58.60:FF:000376', NULL, NULL, 'Protein CBG15811', NULL, NULL, NULL, NULL, NULL, 4),
(79278, NULL, 'G3DSA:2.10.25.10:FF:000441', NULL, NULL, 'Laminin subunit gamma 2', NULL, NULL, NULL, NULL, NULL, 4),
(79279, NULL, 'G3DSA:2.70.170.10:FF:000067', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(79280, NULL, 'G3DSA:3.30.870.10:FF:000182', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(79281, NULL, 'G3DSA:1.10.357.50:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79282, NULL, 'G3DSA:1.20.1070.10:FF:000444', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(79283, NULL, 'G3DSA:3.40.50.300:FF:003734', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(79284, NULL, 'G3DSA:2.30.30.30:FF:000065', NULL, NULL, '60S ribosomal protein L14, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79285, NULL, 'G3DSA:3.40.50.300:FF:003521', NULL, NULL, 'Mitochondrial Rho GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(79286, NULL, 'G3DSA:3.30.1740.10:FF:000019', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(79287, NULL, 'G3DSA:3.90.180.10:FF:000025', NULL, NULL, 'Zinc-type alcohol dehydrogenase YahK', NULL, NULL, NULL, NULL, NULL, 4),
(79288, NULL, 'G3DSA:3.40.50.620:FF:000391', NULL, NULL, 'Tryptophan--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(79289, NULL, 'G3DSA:1.25.40.10:FF:003019', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g66520', NULL, NULL, NULL, NULL, NULL, 4),
(79290, NULL, 'G3DSA:2.30.42.10:FF:000518', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79291, NULL, 'G3DSA:3.30.70.100:FF:000100', NULL, NULL, 'Mechanosensitive ion channel family protein', NULL, NULL, NULL, NULL, NULL, 4),
(79292, NULL, 'G3DSA:1.20.1260.10:FF:000037', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(79293, NULL, 'G3DSA:3.10.20.90:FF:000890', NULL, NULL, 'Protein CBG11828', NULL, NULL, NULL, NULL, NULL, 4),
(79294, NULL, 'G3DSA:1.20.1560.10:FF:000296', NULL, NULL, 'ABC multidrug transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(79295, NULL, 'G3DSA:3.40.50.1110:FF:000036', NULL, NULL, 'Thermolabile hemolysin', NULL, NULL, NULL, NULL, NULL, 4),
(79296, NULL, 'G3DSA:2.130.10.10:FF:002447', NULL, NULL, 'Transducin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(79297, NULL, 'G3DSA:3.40.50.1700:FF:000005', NULL, NULL, 'Beta-glucosidase H', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(79298, NULL, 'G3DSA:1.10.510.10:FF:001336', NULL, NULL, 'Serine/threonine-protein kinase spe-6', NULL, NULL, NULL, NULL, NULL, 4),
(79299, NULL, 'G3DSA:4.10.830.40:FF:000003', NULL, NULL, 'Tripartite motif containing 29', NULL, NULL, NULL, NULL, NULL, 4),
(79300, NULL, 'G3DSA:2.30.42.10:FF:000070', NULL, NULL, 'Multiple PDZ domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(79301, NULL, 'G3DSA:2.10.110.10:FF:000077', NULL, NULL, 'LIM domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(79302, NULL, 'G3DSA:3.50.50.60:FF:000616', NULL, NULL, 'Salicylate hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(79303, NULL, 'G3DSA:4.10.60.10:FF:000175', NULL, NULL, 'mRNA-binding translational activator', NULL, NULL, NULL, NULL, NULL, 4),
(79304, NULL, 'G3DSA:1.20.1270.60:FF:000305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79305, NULL, 'G3DSA:3.30.70.330:FF:002816', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79306, NULL, 'G3DSA:1.25.10.10:FF:001157', NULL, NULL, 'APUM18', NULL, NULL, NULL, NULL, NULL, 4),
(79307, NULL, 'G3DSA:3.40.50.300:FF:003408', NULL, NULL, 'p60 katanin/ AAA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(79308, NULL, 'G3DSA:3.10.50.40:FF:000112', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(79309, NULL, 'G3DSA:2.60.220.50:FF:000147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79310, NULL, 'G3DSA:2.120.10.30:FF:000559', NULL, NULL, 'Adipocyte plasma membrane-associated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79311, NULL, 'G3DSA:3.90.1310.10:FF:000013', NULL, NULL, 'Dihydropteridine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(79312, NULL, 'G3DSA:1.25.10.10:FF:002736', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79313, NULL, 'G3DSA:3.30.160.60:FF:002969', NULL, NULL, 'Zinc finger protein 142', NULL, NULL, NULL, NULL, NULL, 4),
(79314, NULL, 'G3DSA:3.30.420.10:FF:000642', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79315, NULL, 'G3DSA:3.40.50.620:FF:000065', NULL, NULL, 'Universal stress protein', NULL, NULL, NULL, NULL, NULL, 4),
(79316, NULL, 'G3DSA:3.40.50.2000:FF:000152', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(79317, NULL, 'G3DSA:3.40.630.40:FF:000018', NULL, NULL, 'Putative N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(79318, NULL, 'G3DSA:3.40.120.10:FF:000100', NULL, NULL, 'Phosphoacetylglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(79319, NULL, 'G3DSA:2.60.40.10:FF:005611', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79320, NULL, 'G3DSA:1.20.1250.20:FF:000871', NULL, NULL, 'YALI0A17149p', NULL, NULL, NULL, NULL, NULL, 4),
(79321, NULL, 'G3DSA:3.40.50.300:FF:000070', NULL, NULL, 'Putative ABC transporter ATP-binding component', NULL, NULL, NULL, NULL, NULL, 4),
(79322, NULL, 'G3DSA:2.60.40.10:FF:001272', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(79323, NULL, 'G3DSA:3.10.250.10:FF:000021', NULL, NULL, 'Transmembrane serine protease 13', NULL, NULL, NULL, NULL, NULL, 4),
(79324, NULL, 'G3DSA:2.30.40.10:FF:000008', NULL, NULL, 'Dihydroorotase', NULL, NULL, NULL, NULL, NULL, 4),
(79325, NULL, 'G3DSA:3.40.570.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79326, NULL, 'G3DSA:2.30.40.10:FF:000065', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(79327, NULL, 'G3DSA:3.90.550.20:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79328, NULL, 'G3DSA:2.30.30.100:FF:000063', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm3', NULL, NULL, NULL, NULL, NULL, 4),
(79329, NULL, 'G3DSA:3.40.630.30:FF:000072', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(79330, NULL, 'G3DSA:3.40.718.10:FF:000034', NULL, NULL, 'Isocitrate dehydrogenase [NAD] subunit alpha, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(79331, NULL, 'G3DSA:3.10.20.90:FF:000041', NULL, NULL, 'large proline-rich protein BAG6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(79332, NULL, 'G3DSA:3.40.50.11370:FF:000005', NULL, NULL, 'Inositol-tetrakisphosphate 1-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(79333, NULL, 'G3DSA:3.30.70.330:FF:000731', NULL, NULL, 'Single-strand telomeric DNA-binding protein GBP2', NULL, NULL, NULL, NULL, NULL, 4),
(79334, NULL, 'G3DSA:3.40.50.80:FF:000241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79335, NULL, 'G3DSA:1.20.1070.10:FF:000713', NULL, NULL, 'Relaxin family peptide receptor 3.3b', NULL, NULL, NULL, NULL, NULL, 4),
(79336, NULL, 'G3DSA:1.10.150.530:FF:000017', NULL, NULL, 'Dual-specificity RNA methyltransferase RlmN', NULL, NULL, NULL, NULL, NULL, 4),
(79337, NULL, 'G3DSA:3.40.50.720:FF:002455', NULL, NULL, 'Autophagy related 7', NULL, NULL, NULL, NULL, NULL, 4),
(79338, NULL, 'G3DSA:3.30.420.40:FF:000707', NULL, NULL, 'YALI0F10923p', NULL, NULL, NULL, NULL, NULL, 4),
(79339, NULL, 'G3DSA:1.10.150.510:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79340, NULL, 'G3DSA:3.40.220.10:FF:000046', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(79341, NULL, 'G3DSA:3.30.43.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79342, NULL, 'G3DSA:3.40.50.410:FF:000333', NULL, NULL, 'AGAP001871-PA', NULL, NULL, NULL, NULL, NULL, 4),
(79343, NULL, 'G3DSA:3.40.50.1820:FF:001210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79344, NULL, 'G3DSA:1.10.510.10:FF:003522', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79345, NULL, 'G3DSA:3.40.30.10:FF:000314', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(79346, NULL, 'G3DSA:3.30.70.330:FF:002822', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79347, NULL, 'G3DSA:3.40.50.12480:FF:000001', NULL, NULL, 'Chitin binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(79348, NULL, 'G3DSA:2.170.120.12:FF:000014', NULL, NULL, 'DNA-directed RNA polymerase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(79349, NULL, 'G3DSA:2.20.100.10:FF:000186', NULL, NULL, 'spondin-1-like', NULL, NULL, NULL, NULL, NULL, 4),
(79350, NULL, 'G3DSA:3.10.105.10:FF:000004', NULL, NULL, 'Peptide ABC transporter substrate-binding protein SapA', NULL, NULL, NULL, NULL, NULL, 4),
(79351, NULL, 'G3DSA:3.40.50.150:FF:001306', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79352, NULL, 'G3DSA:3.30.760.10:FF:000061', NULL, NULL, 'Eukaryotic translation initiation factor 4E family protein', NULL, NULL, NULL, NULL, NULL, 4),
(79353, NULL, 'G3DSA:3.30.200.20:FF:001051', NULL, NULL, 'Os08g0343000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(79354, NULL, 'G3DSA:3.30.160.60:FF:000878', NULL, NULL, 'Zinc finger protein 544', NULL, NULL, NULL, NULL, NULL, 4),
(79355, NULL, 'G3DSA:1.10.1170.10:FF:000044', NULL, NULL, 'Chromosomal passenger complex protein bir-1', NULL, NULL, NULL, NULL, NULL, 4),
(79356, NULL, 'G3DSA:3.30.780.10:FF:000062', NULL, NULL, 'Translation machinery-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(79357, NULL, 'G3DSA:2.130.10.10:FF:001250', NULL, NULL, 'Eukaryotic translation initiation factor 2A', NULL, NULL, NULL, NULL, NULL, 4),
(79358, NULL, 'G3DSA:3.40.50.850:FF:000004', NULL, NULL, 'Peroxyureidoacrylate/ureidoacrylate amidohydrolase RutB', NULL, NULL, NULL, NULL, NULL, 4),
(79359, NULL, 'G3DSA:1.20.58.60:FF:000612', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(79360, NULL, 'G3DSA:1.25.40.180:FF:000261', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79361, NULL, 'G3DSA:2.30.30.40:FF:000635', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79362, NULL, 'G3DSA:3.30.70.3270:FF:000012', NULL, NULL, 'NADH-quinone oxidoreductase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(79363, NULL, 'G3DSA:3.60.120.10:FF:000017', NULL, NULL, 'Isochorismate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(79364, NULL, 'G3DSA:3.40.720.10:FF:000303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79365, NULL, 'G3DSA:1.10.3120.10:FF:000007', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(79366, NULL, 'G3DSA:3.40.525.10:FF:000018', NULL, NULL, 'Phosphatidylinositol transfer protein SFH5', NULL, NULL, NULL, NULL, NULL, 4),
(79367, NULL, 'G3DSA:3.30.450.20:FF:000254', NULL, NULL, 'Sensory box sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(79368, NULL, 'G3DSA:4.10.1060.10:FF:000016', NULL, NULL, 'Calpain 15', NULL, NULL, NULL, NULL, NULL, 4),
(79369, NULL, 'G3DSA:3.80.10.10:FF:000435', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79370, NULL, 'G3DSA:3.30.200.20:FF:002517', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(79371, NULL, 'G3DSA:2.60.40.10:FF:002795', NULL, NULL, 'Stretchin-Mlck, isoform S', NULL, NULL, NULL, NULL, NULL, 4),
(79372, NULL, 'G3DSA:2.70.160.11:FF:000056', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(79373, NULL, 'G3DSA:2.60.40.10:FF:000665', NULL, NULL, 'obscurin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(79374, NULL, 'G3DSA:3.40.50.620:FF:000008', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(79375, NULL, 'G3DSA:3.30.710.10:FF:000350', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79376, NULL, 'G3DSA:2.30.40.10:FF:000121', NULL, NULL, 'Dihydroorotase', NULL, NULL, NULL, NULL, NULL, 4),
(79377, NULL, 'G3DSA:3.30.460.20:FF:000030', NULL, NULL, 'Cation transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79378, NULL, 'G3DSA:2.20.100.10:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79379, NULL, 'G3DSA:3.40.50.2300:FF:000028', NULL, NULL, 'Glutamate receptor ionotropic, NMDA 2B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79380, NULL, 'G3DSA:3.40.50.300:FF:001317', NULL, NULL, 'Putative ADP-ribosylation factor', NULL, NULL, NULL, NULL, NULL, 4),
(79381, NULL, 'G3DSA:1.20.58.900:FF:000008', NULL, NULL, 'DENN domain containing 5B', NULL, NULL, NULL, NULL, NULL, 4),
(79382, NULL, 'G3DSA:1.10.287.3990:FF:000010', NULL, NULL, 'F-box and WD domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(79383, NULL, 'G3DSA:3.90.1030.10:FF:000025', NULL, NULL, 'Ribosomal protein L17', NULL, NULL, NULL, NULL, NULL, 4),
(79384, NULL, 'G3DSA:2.70.70.10:FF:000065', NULL, NULL, 'Lysostaphin', NULL, NULL, NULL, NULL, NULL, 4),
(79385, NULL, 'G3DSA:3.40.1190.20:FF:000040', NULL, NULL, 'Thiamine biosynthetic bifunctional enzyme TH1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(79386, NULL, 'G3DSA:1.10.510.10:FF:002915', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79387, NULL, 'G3DSA:2.60.40.10:FF:004936', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79388, NULL, 'G3DSA:3.40.190.10:FF:000627', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(79389, NULL, 'G3DSA:2.20.100.10:FF:000203', NULL, NULL, 'Complement factor properdin', NULL, NULL, NULL, NULL, NULL, 4),
(79390, NULL, 'G3DSA:3.40.390.10:FF:000092', NULL, NULL, 'Stall, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(79391, NULL, 'G3DSA:2.30.39.10:FF:000106', NULL, NULL, 'Serpin peptidase inhibitor 4', NULL, NULL, NULL, NULL, NULL, 4),
(79392, NULL, 'G3DSA:3.40.50.720:FF:001887', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79393, NULL, 'G3DSA:3.30.70.890:FF:000022', NULL, NULL, 'Diphosphomevalonate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(79394, NULL, 'G3DSA:2.10.25.10:FF:000098', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(79395, NULL, 'G3DSA:3.40.50.150:FF:001345', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79396, NULL, 'G3DSA:2.60.120.200:FF:000602', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(79397, NULL, 'G3DSA:1.25.40.10:FF:004694', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79398, NULL, 'G3DSA:3.30.160.60:FF:005083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79399, NULL, 'G3DSA:3.40.190.10:FF:000666', NULL, NULL, 'Glutamate receptor, ionotropic, AMPA 2a', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(79400, NULL, 'G3DSA:2.40.37.10:FF:000017', NULL, NULL, 'Putative diaminopimelate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(79401, NULL, 'G3DSA:3.40.50.10190:FF:000235', NULL, NULL, 'ECT2 (Mammalian Rho GEF) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(79402, NULL, 'G3DSA:1.10.287.3240:FF:000021', NULL, NULL, 'Vacuolar ATP synthase subunit D, putative (AFU_orthologue AFUA_5G11920)', NULL, NULL, NULL, NULL, NULL, 4),
(79403, NULL, 'G3DSA:3.40.850.10:FF:000127', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(79404, NULL, 'G3DSA:2.60.40.150:FF:000573', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79405, NULL, 'G3DSA:3.80.10.10:FF:003358', NULL, NULL, 'Leucine-rich repeat transmembrane protein FLRT2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(79406, NULL, 'G3DSA:3.60.10.10:FF:000150', NULL, NULL, 'Tdpt-1', NULL, NULL, NULL, NULL, NULL, 4),
(79407, NULL, 'G3DSA:2.130.10.10:FF:004920', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(79408, NULL, 'G3DSA:2.40.50.140:FF:000273', NULL, NULL, 'Ribonuclease R', NULL, NULL, NULL, NULL, NULL, 4),
(79409, NULL, 'G3DSA:1.10.10.10:FF:000645', NULL, NULL, 'Transcriptional regulator, AsnC family', NULL, NULL, NULL, NULL, NULL, 4),
(79410, NULL, 'G3DSA:2.10.25.10:FF:000334', NULL, NULL, 'protein delta homolog 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(79411, NULL, 'G3DSA:3.30.450.20:FF:000473', NULL, NULL, 'Putative regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(79412, NULL, 'G3DSA:3.30.450.40:FF:000299', NULL, NULL, 'PAS sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(79413, NULL, 'G3DSA:3.40.50.720:FF:000600', NULL, NULL, '17-beta-hydroxysteroid dehydrogenase 14', NULL, NULL, NULL, NULL, NULL, 4),
(79414, NULL, 'G3DSA:3.40.390.10:FF:000047', NULL, NULL, 'Matrix metallopeptidase 21', NULL, NULL, NULL, NULL, NULL, 4),
(79415, NULL, 'G3DSA:3.80.10.10:FF:002672', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(79416, NULL, 'G3DSA:3.40.50.300:FF:001374', NULL, NULL, 'Pleiotropic drug resistance protein ABC superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(79417, NULL, 'G3DSA:3.40.50.1000:FF:000745', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79418, NULL, 'G3DSA:3.40.190.10:FF:000902', NULL, NULL, 'Probable sensor/response regulator hybrid', NULL, NULL, NULL, NULL, NULL, 4),
(79419, NULL, 'G3DSA:1.20.5.2210:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79420, NULL, 'G3DSA:3.30.1960.10:FF:000002', NULL, NULL, 'tRNA wybutosine-synthesizing protein 2/3/4', NULL, NULL, NULL, NULL, NULL, 4),
(79421, NULL, 'G3DSA:3.30.70.330:FF:002081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79422, NULL, 'G3DSA:3.40.50.300:FF:002953', NULL, NULL, 'Origin recognition complex subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(79423, NULL, 'G3DSA:3.40.50.300:FF:005645', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79424, NULL, 'G3DSA:3.10.330.10:FF:000022', NULL, NULL, 'Cell division cycle protein', NULL, NULL, NULL, NULL, NULL, 4),
(79425, NULL, 'G3DSA:3.30.710.10:FF:000294', NULL, NULL, 'Rho-related protein racA', NULL, NULL, NULL, NULL, NULL, 4),
(79426, NULL, 'G3DSA:2.60.120.200:FF:000546', NULL, NULL, 'Calreticulin 4', NULL, NULL, NULL, NULL, NULL, 4),
(79427, NULL, 'G3DSA:1.10.10.10:FF:001252', NULL, NULL, 'Cullin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(79428, NULL, 'G3DSA:2.60.120.200:FF:000327', NULL, NULL, 'Kon-tiki, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(79429, NULL, 'G3DSA:1.20.1070.10:FF:000770', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(79430, NULL, 'G3DSA:2.170.130.10:FF:000029', NULL, NULL, 'Outer membrane cobalamin receptor protein', NULL, NULL, NULL, NULL, NULL, 4),
(79431, NULL, 'G3DSA:3.30.420.10:FF:000423', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79432, NULL, 'G3DSA:3.40.50.620:FF:000845', NULL, NULL, 'AGAP003832-PA', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(79433, NULL, 'G3DSA:1.25.40.10:FF:005150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79434, NULL, 'G3DSA:3.40.80.10:FF:000031', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(79435, NULL, 'G3DSA:3.40.50.10490:FF:000112', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79436, NULL, 'G3DSA:2.30.29.30:FF:000943', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79437, NULL, 'G3DSA:2.40.70.10:FF:000387', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79438, NULL, 'G3DSA:1.50.40.10:FF:000589', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79439, NULL, 'G3DSA:3.40.50.300:FF:002211', NULL, NULL, 'DNA mismatch repair protein Msh2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79440, NULL, 'G3DSA:3.30.160.60:FF:000030', NULL, NULL, 'Zinc finger protein 628', NULL, NULL, NULL, NULL, NULL, 4),
(79441, NULL, 'G3DSA:3.30.200.20:FF:000157', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(79442, NULL, 'G3DSA:2.10.25.10:FF:000115', NULL, NULL, 'latent-transforming growth factor beta-binding protein 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(79443, NULL, 'G3DSA:3.40.718.10:FF:000073', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(79444, NULL, 'G3DSA:3.90.70.10:FF:000854', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(79445, NULL, 'G3DSA:4.10.240.10:FF:000101', NULL, NULL, 'Transcription factor with zinc cluster DNA-binding motif, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79446, NULL, 'G3DSA:3.90.70.30:FF:000006', NULL, NULL, 'Putative methyltransferase PMT23', NULL, NULL, NULL, NULL, NULL, 4),
(79447, NULL, 'G3DSA:1.25.10.10:FF:002793', NULL, NULL, 'AER448Wp', NULL, NULL, NULL, NULL, NULL, 4),
(79448, NULL, 'G3DSA:3.40.50.620:FF:000284', NULL, NULL, 'Isoleucyl-tRNA synthetase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(79449, NULL, 'G3DSA:3.40.50.1910:FF:000012', NULL, NULL, 'Protein SLY1', NULL, NULL, NULL, NULL, NULL, 4),
(79450, NULL, 'G3DSA:2.40.50.140:FF:000834', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79451, NULL, 'G3DSA:2.20.25.20:FF:000016', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(79452, NULL, 'G3DSA:3.90.550.50:FF:000173', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(79453, NULL, 'G3DSA:3.10.20.90:FF:000783', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79454, NULL, 'G3DSA:2.40.160.210:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79455, NULL, 'G3DSA:3.30.830.10:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79456, NULL, 'G3DSA:3.30.230.10:FF:000212', NULL, NULL, 'Galactokinase', NULL, NULL, NULL, NULL, NULL, 4),
(79457, NULL, 'G3DSA:1.25.40.10:FF:004475', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(79458, NULL, 'G3DSA:3.40.50.1820:FF:000603', NULL, NULL, 'Alpha/beta hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(79459, NULL, 'G3DSA:1.20.58.60:FF:000269', NULL, NULL, 'Microtubule-actin cross-linking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(79460, NULL, 'G3DSA:3.40.605.10:FF:000114', NULL, NULL, 'Transcription regulator', NULL, NULL, NULL, NULL, NULL, 4),
(79461, NULL, 'G3DSA:3.40.50.300:FF:007270', NULL, NULL, 'ATPase family AAA domain-containing protein 3A', NULL, NULL, NULL, NULL, NULL, 4),
(79462, NULL, 'G3DSA:2.20.25.30:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79463, NULL, 'G3DSA:2.60.40.60:FF:000022', NULL, NULL, 'Cadherin 2', NULL, NULL, NULL, NULL, NULL, 4),
(79464, NULL, 'G3DSA:2.130.10.10:FF:003228', NULL, NULL, 'WD-repeat membrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79465, NULL, 'G3DSA:1.20.920.10:FF:000134', NULL, NULL, 'Protein polybromo-1-like Protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(79466, NULL, 'G3DSA:1.10.10.60:FF:000289', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(79467, NULL, 'G3DSA:1.10.150.240:FF:000088', NULL, NULL, 'Haloacid dehalogenase superfamily, subfamily IA, variant 1 with third motif having Dx(3-4)D or Dx(3-4)E', NULL, NULL, NULL, NULL, NULL, 4),
(79468, NULL, 'G3DSA:3.80.10.10:FF:003690', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79469, NULL, 'G3DSA:2.130.10.10:FF:001137', NULL, NULL, 'Unplaced genomic scaffold supercont1.141, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(79470, NULL, 'G3DSA:1.25.40.320:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(79471, NULL, 'G3DSA:3.30.70.330:FF:001512', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79472, NULL, 'G3DSA:3.60.21.10:FF:000467', NULL, NULL, 'Serine/threonine protein phosphatase PP1', NULL, NULL, NULL, NULL, NULL, 4),
(79473, NULL, 'G3DSA:1.10.10.60:FF:001183', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79474, NULL, 'G3DSA:1.50.10.10:FF:000019', NULL, NULL, 'LanC-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(79475, NULL, 'G3DSA:1.25.40.180:FF:000081', NULL, NULL, 'Nonsense-mediated mRNA decay protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(79476, NULL, 'G3DSA:3.40.50.80:FF:000185', NULL, NULL, 'Putative metalloreductase', NULL, NULL, NULL, NULL, NULL, 4),
(79477, NULL, 'G3DSA:1.10.510.10:FF:000032', NULL, NULL, 'Serine/threonine-protein kinase PBS1', NULL, NULL, NULL, NULL, NULL, 4),
(79478, NULL, 'G3DSA:3.30.60.270:FF:000014', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(79479, NULL, 'G3DSA:2.40.30.160:FF:000005', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(79480, NULL, 'G3DSA:3.30.70.330:FF:000675', NULL, NULL, 'Nuclear RNA export factor 7', NULL, NULL, NULL, NULL, NULL, 4),
(79481, NULL, 'G3DSA:2.10.25.10:FF:001677', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79482, NULL, 'G3DSA:2.40.50.40:FF:000080', NULL, NULL, 'Chemokine (C-C motif) ligand 25a', NULL, NULL, NULL, NULL, NULL, 4),
(79483, NULL, 'G3DSA:1.20.5.110:FF:000311', NULL, NULL, 'Syntaxin 17', NULL, NULL, NULL, NULL, NULL, 4),
(79484, NULL, 'G3DSA:2.130.10.10:FF:001194', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(79485, NULL, 'G3DSA:3.40.50.300:FF:003560', NULL, NULL, 'ADP-ribosylation factor-like protein 5-like', NULL, NULL, NULL, NULL, NULL, 4),
(79486, NULL, 'G3DSA:1.10.10.60:FF:001126', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79487, NULL, 'G3DSA:1.20.1730.10:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79488, NULL, 'G3DSA:1.10.8.10:FF:000155', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(79489, NULL, 'G3DSA:2.60.120.470:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79490, NULL, 'G3DSA:3.10.450.80:FF:000001', NULL, NULL, '60S ribosomal protein L44', NULL, NULL, NULL, NULL, NULL, 4),
(79491, NULL, 'G3DSA:3.60.15.10:FF:000065', NULL, NULL, 'Ribonuclease Z', NULL, NULL, NULL, NULL, NULL, 4),
(79492, NULL, 'G3DSA:2.30.29.30:FF:001399', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79493, NULL, 'G3DSA:2.10.110.10:FF:000352', NULL, NULL, 'LIM homeobox 3', NULL, NULL, NULL, NULL, NULL, 4),
(79494, NULL, 'G3DSA:3.40.630.30:FF:000302', NULL, NULL, 'RNA cytidine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(79495, NULL, 'G3DSA:3.30.40.10:FF:000793', NULL, NULL, 'E3 ubiquitin-protein ligase SGR9 amyloplastic', NULL, NULL, NULL, NULL, NULL, 4),
(79496, NULL, 'G3DSA:3.10.350.10:FF:000023', NULL, NULL, 'Stage VI sporulation protein D', NULL, NULL, NULL, NULL, NULL, 4),
(79497, NULL, 'G3DSA:1.25.10.10:FF:001376', NULL, NULL, 'Armadillo-type protein', NULL, NULL, NULL, NULL, NULL, 4),
(79498, NULL, 'G3DSA:2.20.25.10:FF:000013', NULL, NULL, 'DNA topoisomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(79499, NULL, 'G3DSA:2.40.37.10:FF:000074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(79500, NULL, 'G3DSA:3.90.190.10:FF:000200', NULL, NULL, 'Protein-tyrosine phosphatase, putative (AFU_orthologue AFUA_2G02760)', NULL, NULL, NULL, NULL, NULL, 4),
(79501, NULL, 'G3DSA:3.40.1190.20:FF:000039', NULL, NULL, 'Putative sugar kinase', NULL, NULL, NULL, NULL, NULL, 4),
(79502, NULL, 'G3DSA:1.25.40.20:FF:001605', NULL, NULL, 'Ankyrin repeat domain 27 (VPS9 domain)', NULL, NULL, NULL, NULL, NULL, 4),
(79503, NULL, 'G3DSA:2.130.10.10:FF:005027', NULL, NULL, 'Uncharacterized RWD, RING finger and WD repeat-containing protein C11E3.05', NULL, NULL, NULL, NULL, NULL, 4),
(79504, NULL, 'G3DSA:1.25.40.10:FF:001260', NULL, NULL, 'Unplaced genomic scaffold supercont2.20, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(79505, NULL, 'G3DSA:1.25.40.20:FF:001549', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79506, NULL, 'G3DSA:1.20.272.10:FF:000066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79507, NULL, 'G3DSA:3.40.50.300:FF:003228', NULL, NULL, 'ATP binding cassette subfamily C member 8', NULL, NULL, NULL, NULL, NULL, 4),
(79508, NULL, 'G3DSA:3.90.190.10:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79509, NULL, 'G3DSA:3.80.10.10:FF:001778', NULL, NULL, 'F-box protein', NULL, NULL, NULL, NULL, NULL, 4),
(79510, NULL, 'G3DSA:3.40.50.620:FF:000227', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(79511, NULL, 'G3DSA:3.30.30.10:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79512, NULL, 'G3DSA:2.70.98.30:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79513, NULL, 'G3DSA:3.30.1370.10:FF:000148', NULL, NULL, 'Protein CBG01583', NULL, NULL, NULL, NULL, NULL, 4),
(79514, NULL, 'G3DSA:3.80.10.10:FF:002054', NULL, NULL, 'F10A5.16', NULL, NULL, NULL, NULL, NULL, 4),
(79515, NULL, 'G3DSA:3.10.580.10:FF:000012', NULL, NULL, 'DUF21 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(79516, NULL, 'G3DSA:1.20.1540.10:FF:000019', NULL, NULL, 'RHOMBOID-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(79517, NULL, 'G3DSA:3.20.20.140:FF:000003', NULL, NULL, 'AMP deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(79518, NULL, 'G3DSA:3.60.20.10:FF:000212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79519, NULL, 'G3DSA:3.50.30.20:FF:000002', NULL, NULL, 'Carbamoyl-phosphate synthase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(79520, NULL, 'G3DSA:1.10.150.20:FF:000007', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(79521, NULL, 'G3DSA:3.10.450.40:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79522, NULL, 'G3DSA:2.10.25.10:FF:001458', NULL, NULL, 'Neurogenic locus notch-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(79523, NULL, 'G3DSA:3.30.160.60:FF:005263', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79524, NULL, 'G3DSA:3.40.50.2000:FF:000258', NULL, NULL, 'Starch synthase 3', NULL, NULL, NULL, NULL, NULL, 4),
(79525, NULL, 'G3DSA:2.130.10.10:FF:004807', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79526, NULL, 'G3DSA:3.80.10.10:FF:000255', NULL, NULL, 'NLR family CARD domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(79527, NULL, 'G3DSA:3.60.20.10:FF:000251', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79528, NULL, 'G3DSA:2.10.109.10:FF:000051', NULL, NULL, 'Uncharacterized protein At2g31140', NULL, NULL, NULL, NULL, NULL, 4),
(79529, NULL, 'G3DSA:3.30.450.190:FF:000016', NULL, NULL, 'Putative ras-like small GTPases', NULL, NULL, NULL, NULL, NULL, 4),
(79530, NULL, 'G3DSA:2.60.40.10:FF:001160', NULL, NULL, 'Macrophage colony-stimulating factor 1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(79531, NULL, 'G3DSA:3.40.50.300:FF:004864', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(79532, NULL, 'G3DSA:3.30.70.1230:FF:000024', NULL, NULL, 'ACXA, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(79533, NULL, 'G3DSA:1.10.1670.10:FF:000071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(79534, NULL, 'G3DSA:2.70.98.40:FF:000014', NULL, NULL, 'Six-hairpin glycosidase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(79535, NULL, 'G3DSA:2.30.30.40:FF:000399', NULL, NULL, 'Bridging integrator 2b', NULL, NULL, NULL, NULL, NULL, 4),
(79536, NULL, 'G3DSA:1.10.8.270:FF:000075', NULL, NULL, 'RaB GAP related', NULL, NULL, NULL, NULL, NULL, 4),
(79537, NULL, 'G3DSA:3.10.450.50:FF:000059', NULL, NULL, 'Related to ntf2-related export protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(79538, NULL, 'G3DSA:1.10.8.50:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79539, NULL, 'G3DSA:1.20.120.1630:FF:000014', NULL, NULL, 'Steroid 5-alpha reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79540, NULL, 'G3DSA:1.10.220.150:FF:000072', NULL, NULL, 'Centaurin, alpha 1, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(79541, NULL, 'G3DSA:2.60.40.10:FF:005431', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79542, NULL, 'G3DSA:3.30.260.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79543, NULL, 'G3DSA:3.50.30.30:FF:000005', NULL, NULL, 'subtilisin-like protease SBT1.5', NULL, NULL, NULL, NULL, NULL, 4),
(79544, NULL, 'G3DSA:3.30.1910.20:FF:000002', NULL, NULL, 'Asparaginyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(79545, NULL, 'G3DSA:1.10.720.30:FF:000071', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(79546, NULL, 'G3DSA:3.20.20.150:FF:000006', NULL, NULL, 'L-rhamnose isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(79547, NULL, 'G3DSA:1.10.8.60:FF:000035', NULL, NULL, 'Lon protease', NULL, NULL, NULL, NULL, NULL, 4),
(79548, NULL, 'G3DSA:3.40.50.720:FF:002343', NULL, NULL, 'Glucose-6-phosphate 1-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(79549, NULL, 'G3DSA:3.30.40.10:FF:002316', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(79550, NULL, 'G3DSA:1.10.238.10:FF:001236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79551, NULL, 'G3DSA:3.80.20.20:FF:000085', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(79552, NULL, 'G3DSA:3.30.40.10:FF:002373', NULL, NULL, 'Inhibitor of growth protein', NULL, NULL, NULL, NULL, NULL, 4),
(79553, NULL, 'G3DSA:3.30.160.60:FF:001334', NULL, NULL, 'zinc finger protein 133 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(79554, NULL, 'G3DSA:3.40.50.300:FF:003285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79555, NULL, 'G3DSA:3.40.50.300:FF:000879', NULL, NULL, 'Guanylate kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(79556, NULL, 'G3DSA:3.40.50.300:FF:005027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79557, NULL, 'G3DSA:3.30.310.80:FF:000014', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(79558, NULL, 'G3DSA:3.40.50.170:FF:000008', NULL, NULL, 'Phosphoribosylglycinamide formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(79559, NULL, 'G3DSA:3.20.20.70:FF:000304', NULL, NULL, 'Ketose-bisphosphate aldolase class-II family protein', NULL, NULL, NULL, NULL, NULL, 4),
(79560, NULL, 'G3DSA:3.40.50.2300:FF:000646', NULL, NULL, 'RNA polymerase II subunit A Cterminal domain phosphatase SSU72', NULL, NULL, NULL, NULL, NULL, 4),
(79561, NULL, 'G3DSA:2.130.10.10:FF:001430', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(79562, NULL, 'G3DSA:3.10.129.10:FF:000065', NULL, NULL, 'Acyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(79563, NULL, 'G3DSA:3.50.50.60:FF:000055', NULL, NULL, 'Thioredoxin reductase 1, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(79564, NULL, 'G3DSA:3.10.110.10:FF:000371', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79565, NULL, 'G3DSA:2.10.25.10:FF:001790', NULL, NULL, 'AGAP003506-PA', NULL, NULL, NULL, NULL, NULL, 4),
(79566, NULL, 'G3DSA:3.90.226.10:FF:000149', NULL, NULL, 'Enoyl-CoA delta isomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(79567, NULL, 'G3DSA:1.25.40.10:FF:003401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(79568, NULL, 'G3DSA:1.10.40.30:FF:000012', NULL, NULL, 'Adenylosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(79569, NULL, 'G3DSA:2.30.30.140:FF:000102', NULL, NULL, 'Protein MRG1', NULL, NULL, NULL, NULL, NULL, 4),
(79570, NULL, 'G3DSA:2.70.150.10:FF:000285', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(79571, NULL, 'G3DSA:3.30.70.1350:FF:000004', NULL, NULL, 'Cation diffusion facilitator 10', NULL, NULL, NULL, NULL, NULL, 4),
(79572, NULL, 'G3DSA:3.10.450.40:FF:000017', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(79573, NULL, 'G3DSA:3.30.710.10:FF:000237', NULL, NULL, 'kelch-like protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(79574, NULL, 'G3DSA:1.25.10.10:FF:000376', NULL, NULL, 'beta-catenin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(79575, NULL, 'G3DSA:3.20.20.80:FF:000307', NULL, NULL, 'Glycogen debranching enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(79576, NULL, 'G3DSA:3.30.470.20:FF:000143', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(79577, NULL, 'G3DSA:3.30.930.10:FF:000220', NULL, NULL, 'Protein CBG23664', NULL, NULL, NULL, NULL, NULL, 4),
(79578, NULL, 'G3DSA:3.40.47.10:FF:000297', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79579, NULL, 'G3DSA:2.60.40.60:FF:001040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79580, NULL, 'G3DSA:3.40.630.10:FF:000476', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79581, NULL, 'G3DSA:2.130.10.10:FF:005140', NULL, NULL, 'WD-repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(79582, NULL, 'G3DSA:3.30.70.330:FF:002586', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79583, NULL, 'G3DSA:2.60.470.10:FF:000030', NULL, NULL, 'Eukaryotic translation initiation factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(79584, NULL, 'G3DSA:1.10.10.10:FF:001196', NULL, NULL, 'DDRGK domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79585, NULL, 'G3DSA:3.40.50.720:FF:000544', NULL, NULL, 'YMR315W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(79586, NULL, 'G3DSA:3.90.180.10:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79587, NULL, 'G3DSA:2.160.20.10:FF:000108', NULL, NULL, 'PKHD1, fibrocystin/polyductin', NULL, NULL, NULL, NULL, NULL, 4),
(79588, NULL, 'G3DSA:3.40.50.150:FF:000002', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase H', NULL, NULL, NULL, NULL, NULL, 4),
(79589, NULL, 'G3DSA:3.90.79.10:FF:000048', NULL, NULL, 'NADH pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(79590, NULL, 'G3DSA:3.20.20.330:FF:000015', NULL, NULL, 'Protein CBG15622', NULL, NULL, NULL, NULL, NULL, 4),
(79591, NULL, 'G3DSA:3.40.50.300:FF:005084', NULL, NULL, 'Chromosome undetermined SCAF6183, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(79592, NULL, 'G3DSA:3.40.50.880:FF:000165', NULL, NULL, 'Gamma-glutamyl peptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(79593, NULL, 'G3DSA:1.10.510.10:FF:001156', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(79594, NULL, 'G3DSA:3.40.50.460:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79595, NULL, 'G3DSA:3.10.20.800:FF:000001', NULL, NULL, 'Hypothetical Exported Protein', NULL, NULL, NULL, NULL, NULL, 4),
(79596, NULL, 'G3DSA:2.40.50.140:FF:001054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79597, NULL, 'G3DSA:2.60.40.1120:FF:000069', NULL, NULL, 'SD07707p', NULL, NULL, NULL, NULL, NULL, 4),
(79598, NULL, 'G3DSA:1.10.472.10:FF:000662', NULL, NULL, 'Cyclin B1', NULL, NULL, NULL, NULL, NULL, 4),
(79599, NULL, 'G3DSA:2.80.10.50:FF:000022', NULL, NULL, 'Ryanodine receptor, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(79600, NULL, 'G3DSA:3.30.70.330:FF:000456', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein A1', NULL, NULL, NULL, NULL, NULL, 4),
(79601, NULL, 'G3DSA:1.20.120.560:FF:000012', NULL, NULL, 'pH-response regulator protein palA/RIM20', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(79602, NULL, 'G3DSA:2.60.60.20:FF:000034', NULL, NULL, 'Pkd1l2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79603, NULL, 'G3DSA:3.40.850.10:FF:000307', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(79604, NULL, 'G3DSA:3.30.565.10:FF:000517', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79605, NULL, 'G3DSA:1.25.40.20:FF:001263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79606, NULL, 'G3DSA:3.40.1110.10:FF:000262', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79607, NULL, 'G3DSA:3.40.50.2000:FF:000590', NULL, NULL, 'D-inositol-3-phosphate glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(79608, NULL, 'G3DSA:3.30.200.20:FF:001270', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79609, NULL, 'G3DSA:3.40.50.300:FF:001430', NULL, NULL, 'Small GTPase EhRabM3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79610, NULL, 'G3DSA:1.20.58.160:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79611, NULL, 'G3DSA:2.10.25.10:FF:000154', NULL, NULL, 'FAT atypical cadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(79612, NULL, 'G3DSA:1.20.58.760:FF:000039', NULL, NULL, 'ATP-dependent zinc metallopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79613, NULL, 'G3DSA:3.30.40.10:FF:001479', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79614, NULL, 'G3DSA:2.120.10.80:FF:000147', NULL, NULL, 'Distracted, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(79615, NULL, 'G3DSA:1.20.1250.20:FF:000197', NULL, NULL, 'Siderophore iron transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(79616, NULL, 'G3DSA:3.60.15.30:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79617, NULL, 'G3DSA:3.40.50.2300:FF:001141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79618, NULL, 'G3DSA:1.20.1560.10:FF:000526', NULL, NULL, 'ATP binding cassette subfamily C member 1', NULL, NULL, NULL, NULL, NULL, 4),
(79619, NULL, 'G3DSA:1.10.1370.10:FF:000031', NULL, NULL, 'Thimet oligopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(79620, NULL, 'G3DSA:2.130.10.10:FF:004864', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79621, NULL, 'G3DSA:2.170.130.10:FF:000068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79622, NULL, 'G3DSA:1.10.630.10:FF:000030', NULL, NULL, 'vitamin D 25-hydroxylase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(79623, NULL, 'G3DSA:2.60.40.420:FF:000002', NULL, NULL, 'Hephaestin like 1', NULL, NULL, NULL, NULL, NULL, 4),
(79624, NULL, 'G3DSA:3.40.50.2000:FF:000770', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(79625, NULL, 'G3DSA:3.30.200.20:FF:001612', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(79626, NULL, 'G3DSA:1.25.40.180:FF:000042', NULL, NULL, 'Eukaryotic translation initiation factor 4 gamma', NULL, NULL, NULL, NULL, NULL, 4),
(79627, NULL, 'G3DSA:1.25.40.10:FF:002564', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(79628, NULL, 'G3DSA:1.25.10.10:FF:000994', NULL, NULL, 'HEAT repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(79629, NULL, 'G3DSA:1.20.5.650:FF:000006', NULL, NULL, 'Related to BRF1-TFIIIB subunit, 70 kD', NULL, NULL, NULL, NULL, NULL, 4),
(79630, NULL, 'G3DSA:3.30.479.20:FF:000011', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(79631, NULL, 'G3DSA:1.20.5.1300:FF:000008', NULL, NULL, 'Histidinol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(79632, NULL, 'G3DSA:3.30.70.330:FF:002529', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79633, NULL, 'G3DSA:3.30.160.60:FF:005824', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79634, NULL, 'G3DSA:1.20.1250.20:FF:000539', NULL, NULL, 'Protein unc-93 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(79635, NULL, 'G3DSA:1.10.10.60:FF:000963', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79636, NULL, 'G3DSA:1.10.238.10:FF:001293', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(79637, NULL, 'G3DSA:1.10.357.90:FF:000002', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(79638, NULL, 'G3DSA:1.20.1070.10:FF:001787', NULL, NULL, 'Dopamine receptor D7', NULL, NULL, NULL, NULL, NULL, 4),
(79639, NULL, 'G3DSA:3.20.20.150:FF:000063', NULL, NULL, 'Protein arginine N-methyltransferase 1.5', NULL, NULL, NULL, NULL, NULL, 4),
(79640, NULL, 'G3DSA:3.20.20.140:FF:000060', NULL, NULL, 'Hydrolase, TatD family', NULL, NULL, NULL, NULL, NULL, 4),
(79641, NULL, 'G3DSA:2.130.10.10:FF:004684', NULL, NULL, 'Retinoblastoma-binding-like protein E', NULL, NULL, NULL, NULL, NULL, 4),
(79642, NULL, 'G3DSA:3.20.20.140:FF:000402', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79643, NULL, 'G3DSA:1.20.1080.10:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79644, NULL, 'G3DSA:1.10.287.10:FF:000023', NULL, NULL, 'Ataxin 3 variant ref', NULL, NULL, NULL, NULL, NULL, 4),
(79645, NULL, 'G3DSA:3.30.70.3290:FF:000018', NULL, NULL, 'PKS-NRPS hybrid synthetase psoA', NULL, NULL, NULL, NULL, NULL, 4),
(79646, NULL, 'G3DSA:3.80.10.10:FF:001891', NULL, NULL, 'Leucine-rich repeat-containing G protein-coupled receptor 8', NULL, NULL, NULL, NULL, NULL, 4),
(79647, NULL, 'G3DSA:3.40.50.720:FF:000364', NULL, NULL, 'Dehydrogenase/reductase SDR family member 13', NULL, NULL, NULL, NULL, NULL, 4),
(79648, NULL, 'G3DSA:3.50.50.60:FF:000673', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(79649, NULL, 'G3DSA:1.10.287.310:FF:000001', NULL, NULL, '50S ribosomal protein L29', NULL, NULL, NULL, NULL, NULL, 4),
(79650, NULL, 'G3DSA:2.60.40.2700:FF:000003', NULL, NULL, '187-kDa microtubule-associated protein AIR9 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(79651, NULL, 'G3DSA:1.25.40.20:FF:001881', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(79652, NULL, 'G3DSA:3.10.20.90:FF:000889', NULL, NULL, 'A-Raf proto-oncogene, serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(79653, NULL, 'G3DSA:2.60.120.290:FF:000230', NULL, NULL, 'Zinc metalloproteinase', NULL, NULL, NULL, NULL, NULL, 4),
(79654, NULL, 'G3DSA:1.25.10.10:FF:001432', NULL, NULL, 'Cell death abnormality protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(79655, NULL, 'G3DSA:1.20.1250.20:FF:002052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79656, NULL, 'G3DSA:1.20.1070.10:FF:002063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79657, NULL, 'G3DSA:1.10.10.650:FF:000012', NULL, NULL, 'Transcription elongation factor Spt6', NULL, NULL, NULL, NULL, NULL, 4),
(79658, NULL, 'G3DSA:3.50.50.60:FF:001111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79659, NULL, 'G3DSA:1.10.418.10:FF:000166', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(79660, NULL, 'G3DSA:3.30.160.20:FF:000153', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(79661, NULL, 'G3DSA:2.30.30.140:FF:000046', NULL, NULL, 'tudor domain-containing protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(79662, NULL, 'G3DSA:1.20.1540.10:FF:000076', NULL, NULL, 'Rhomboid-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(79663, NULL, 'G3DSA:4.10.860.10:FF:000013', NULL, NULL, 'AGAP002107-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(79664, NULL, 'G3DSA:3.20.20.190:FF:000046', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(79665, NULL, 'G3DSA:3.90.70.10:FF:000798', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79666, NULL, 'G3DSA:3.40.50.1820:FF:001497', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79667, NULL, 'G3DSA:1.10.2020.20:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79668, NULL, 'G3DSA:3.30.1740.10:FF:000020', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(79669, NULL, 'G3DSA:3.30.160.60:FF:005206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(79670, NULL, 'G3DSA:2.60.40.60:FF:000983', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79671, NULL, 'G3DSA:2.130.10.10:FF:005701', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79672, NULL, 'G3DSA:1.10.510.10:FF:000993', NULL, NULL, 'Cyclin-dependent kinase 17', NULL, NULL, NULL, NULL, NULL, 4),
(79673, NULL, 'G3DSA:1.10.472.10:FF:000443', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79674, NULL, 'G3DSA:3.20.20.80:FF:000021', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(79675, NULL, 'G3DSA:1.10.238.10:FF:000798', NULL, NULL, 'EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(79676, NULL, 'G3DSA:3.30.200.20:FF:000595', NULL, NULL, 'STE/STE20/FRAY protein kinase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(79677, NULL, 'G3DSA:3.90.79.10:FF:000267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79678, NULL, 'G3DSA:3.75.10.10:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79679, NULL, 'G3DSA:3.40.50.300:FF:005207', NULL, NULL, 'Thymidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(79680, NULL, 'G3DSA:1.20.58.860:FF:000013', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(79681, NULL, 'G3DSA:1.10.1300.10:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79682, NULL, 'G3DSA:4.10.1000.10:FF:000131', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(79683, NULL, 'G3DSA:3.40.190.10:FF:000846', NULL, NULL, 'Putative periplasmic amino acid-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(79684, NULL, 'G3DSA:3.30.160.60:FF:006100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79685, NULL, 'G3DSA:3.30.450.60:FF:000018', NULL, NULL, 'AP-4 complex subunit mu-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(79686, NULL, 'G3DSA:1.10.486.10:FF:000042', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(79687, NULL, 'G3DSA:3.90.550.10:FF:000296', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(79688, NULL, 'G3DSA:3.30.565.10:FF:000394', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(79689, NULL, 'G3DSA:1.20.1250.20:FF:001557', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79690, NULL, 'G3DSA:3.20.20.80:FF:000420', NULL, NULL, 'Os03g0828300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(79691, NULL, 'G3DSA:1.25.10.10:FF:000937', NULL, NULL, 'Unplaced genomic scaffold supercont1.136, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(79692, NULL, 'G3DSA:3.80.10.10:FF:000199', NULL, NULL, 'centrosomal protein of 97 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(79693, NULL, 'G3DSA:3.30.930.10:FF:000400', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(79694, NULL, 'G3DSA:3.30.70.330:FF:003081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79695, NULL, 'G3DSA:1.10.150.20:FF:000283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79696, NULL, 'G3DSA:1.10.150.20:FF:000226', NULL, NULL, 'Protein CBR-XPG-1', NULL, NULL, NULL, NULL, NULL, 4),
(79697, NULL, 'G3DSA:3.50.7.10:FF:000065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79698, NULL, 'G3DSA:1.10.1870.10:FF:000013', NULL, NULL, 'Alpha-aminoadipic semialdehyde synthase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(79699, NULL, 'G3DSA:3.80.10.10:FF:001559', NULL, NULL, 'AGAP009688-PA', NULL, NULL, NULL, NULL, NULL, 4),
(79700, NULL, 'G3DSA:3.30.450.50:FF:000015', NULL, NULL, 'Synaptobrevin 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(79701, NULL, 'G3DSA:3.90.1170.50:FF:000007', NULL, NULL, 'Aldehyde oxidase1', NULL, NULL, NULL, NULL, NULL, 4),
(79702, NULL, 'G3DSA:3.10.110.10:FF:000039', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 C', NULL, NULL, NULL, NULL, NULL, 4),
(79703, NULL, 'G3DSA:3.30.160.60:FF:001553', NULL, NULL, 'Zinc finger and BTB domain containing 11', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(79704, NULL, 'G3DSA:1.10.1820.10:FF:000010', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(79705, NULL, 'G3DSA:3.40.50.300:FF:001514', NULL, NULL, 'Atlastin, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(79706, NULL, 'G3DSA:1.10.287.70:FF:000204', NULL, NULL, 'TWiK family of potassium channels', NULL, NULL, NULL, NULL, NULL, 4),
(79707, NULL, 'G3DSA:3.40.50.460:FF:000011', NULL, NULL, 'Diphosphate-fructose-6-phosphate 1-phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(79708, NULL, 'G3DSA:3.90.380.10:FF:000012', NULL, NULL, 'Protein TIC 55, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(79709, NULL, 'G3DSA:2.60.40.10:FF:005408', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79710, NULL, 'G3DSA:2.130.10.30:FF:000031', NULL, NULL, 'PH, RCC1 and FYVE domains-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(79711, NULL, 'G3DSA:3.40.30.10:FF:000123', NULL, NULL, 'Glutathione transferase o1', NULL, NULL, NULL, NULL, NULL, 4),
(79712, NULL, 'G3DSA:3.40.50.300:FF:005246', NULL, NULL, 'ADP-ribosylation factor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(79713, NULL, 'G3DSA:1.20.1270.10:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79714, NULL, 'G3DSA:2.130.10.10:FF:003251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79715, NULL, 'G3DSA:3.40.640.10:FF:000292', NULL, NULL, 'Transcriptional regulator, GntR family', NULL, NULL, NULL, NULL, NULL, 4),
(79716, NULL, 'G3DSA:3.30.420.40:FF:000359', NULL, NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(79717, NULL, 'G3DSA:3.90.320.10:FF:000003', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(79718, NULL, 'G3DSA:3.40.50.150:FF:001643', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79719, NULL, 'G3DSA:3.30.559.10:FF:000082', NULL, NULL, 'Probable non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(79720, NULL, 'G3DSA:1.10.238.270:FF:000002', NULL, NULL, 'Odorant-binding protein 50c', NULL, NULL, NULL, NULL, NULL, 4),
(79721, NULL, 'G3DSA:1.25.40.1040:FF:000010', NULL, NULL, 'Phagocyte signaling-impaired protein', NULL, NULL, NULL, NULL, NULL, 4),
(79722, NULL, 'G3DSA:3.40.50.1820:FF:000934', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79723, NULL, 'G3DSA:2.130.10.10:FF:002099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79724, NULL, 'G3DSA:1.20.920.20:FF:000064', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(79725, NULL, 'G3DSA:3.60.10.10:FF:000060', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(79726, NULL, 'G3DSA:3.30.590.10:FF:000019', NULL, NULL, 'Protein-arginine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(79727, NULL, 'G3DSA:1.20.1270.50:FF:000010', NULL, NULL, 'Lysosomal alpha-mannosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79728, NULL, 'G3DSA:1.20.920.10:FF:000061', NULL, NULL, 'Bromodomain protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(79729, NULL, 'G3DSA:3.40.50.1220:FF:000007', NULL, NULL, 'NAD-dependent histone deacetylase sirtuin-1', NULL, NULL, NULL, NULL, NULL, 4),
(79730, NULL, 'G3DSA:3.30.920.10:FF:000017', NULL, NULL, 'Iron-sulfur cluster assembly protein CyaY', NULL, NULL, NULL, NULL, NULL, 4),
(79731, NULL, 'G3DSA:3.30.565.10:FF:000495', NULL, NULL, 'Gll4098 protein', NULL, NULL, NULL, NULL, NULL, 4),
(79732, NULL, 'G3DSA:3.30.70.330:FF:002518', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79733, NULL, 'G3DSA:3.30.420.10:FF:000350', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79734, NULL, 'G3DSA:1.20.1270.60:FF:000013', NULL, NULL, 'Amphiphysin isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(79735, NULL, 'G3DSA:2.10.25.10:FF:000250', NULL, NULL, 'Laminin subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(79736, NULL, 'G3DSA:3.40.47.10:FF:000229', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79737, NULL, 'G3DSA:1.20.1070.10:FF:001894', NULL, NULL, 'Cephalotocin receptor 1', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(79738, NULL, 'G3DSA:3.30.710.10:FF:000097', NULL, NULL, 'B-cell CLL/lymphoma 6 member B protein', NULL, NULL, NULL, NULL, NULL, 4),
(79739, NULL, 'G3DSA:3.40.50.12230:FF:000016', NULL, NULL, 'Methionyl-tRNA formyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79740, NULL, 'G3DSA:3.30.54.20:FF:000002', NULL, NULL, 'Threonine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(79741, NULL, 'G3DSA:2.130.10.10:FF:004869', NULL, NULL, 'LD47540p', NULL, NULL, NULL, NULL, NULL, 4),
(79742, NULL, 'G3DSA:1.10.10.10:FF:001241', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(79743, NULL, 'G3DSA:1.10.246.190:FF:000001', NULL, NULL, 'Autophagy related 5', NULL, NULL, NULL, NULL, NULL, 4),
(79744, NULL, 'G3DSA:3.50.50.60:FF:000375', NULL, NULL, 'Pyridine nucleotide-disulphide oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(79745, NULL, 'G3DSA:3.30.70.260:FF:000075', NULL, NULL, 'GTP pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(79746, NULL, 'G3DSA:1.20.1050.10:FF:000257', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(79747, NULL, 'G3DSA:2.60.40.10:FF:002767', NULL, NULL, 'Zwei Ig domain protein zig-6', NULL, NULL, NULL, NULL, NULL, 4),
(79748, NULL, 'G3DSA:3.40.50.10190:FF:000050', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(79749, NULL, 'G3DSA:2.70.98.30:FF:000022', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(79750, NULL, 'G3DSA:3.30.200.20:FF:000825', NULL, NULL, 'CAMK/CDPK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(79751, NULL, 'G3DSA:3.40.50.11850:FF:000003', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(79752, NULL, 'G3DSA:1.20.1250.20:FF:001040', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79753, NULL, 'G3DSA:3.30.70.270:FF:000078', NULL, NULL, 'Diguanylate cyclase response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(79754, NULL, 'G3DSA:2.60.120.290:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79755, NULL, 'G3DSA:1.25.40.420:FF:000041', NULL, NULL, 'Kelch-like 13', NULL, NULL, NULL, NULL, NULL, 4),
(79756, NULL, 'G3DSA:2.60.40.10:FF:003273', NULL, NULL, 'Tyrosine-protein kinase receptor TYRO3', NULL, NULL, NULL, NULL, NULL, 4),
(79757, NULL, 'G3DSA:1.20.1560.10:FF:000341', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(79758, NULL, 'G3DSA:3.40.50.1460:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79759, NULL, 'G3DSA:4.10.240.10:FF:000213', NULL, NULL, 'Regulatory protein alcR', NULL, NULL, NULL, NULL, NULL, 4),
(79760, NULL, 'G3DSA:3.40.50.410:FF:000136', NULL, NULL, 'C-type LECtin', NULL, NULL, NULL, NULL, NULL, 4),
(79761, NULL, 'G3DSA:3.30.342.10:FF:000022', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(79762, NULL, 'G3DSA:3.40.350.10:FF:000089', NULL, NULL, 'Xaa-pro aminopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79763, NULL, 'G3DSA:3.10.100.10:FF:000269', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79764, NULL, 'G3DSA:3.30.420.10:FF:000024', NULL, NULL, 'DNA polymerase zeta catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(79765, NULL, 'G3DSA:3.80.10.10:FF:002711', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(79766, NULL, 'G3DSA:3.30.2280.10:FF:000001', NULL, NULL, 'Clustered mitochondria (CluA/CLU1) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(79767, NULL, 'G3DSA:2.40.240.10:FF:000034', NULL, NULL, 'probable glutamine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(79768, NULL, 'G3DSA:1.20.58.60:FF:000314', NULL, NULL, 'VAB-10B protein', NULL, NULL, NULL, NULL, NULL, 4),
(79769, NULL, 'G3DSA:2.60.120.200:FF:000563', NULL, NULL, 'Novel protein similar to human EGF LAG seven-pass G-type receptor 1 cadherin (CELSR1)', NULL, NULL, NULL, NULL, NULL, 4),
(79770, NULL, 'G3DSA:1.20.120.810:FF:000008', NULL, NULL, 'Vinculin, isoform B', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(79771, NULL, 'G3DSA:1.20.272.40:FF:000013', NULL, NULL, 'AaceriAGL240Wp', NULL, NULL, NULL, NULL, NULL, 4),
(79772, NULL, 'G3DSA:2.60.120.10:FF:000010', NULL, NULL, 'neuropathy target esterase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(79773, NULL, 'G3DSA:3.40.390.10:FF:000209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79774, NULL, 'G3DSA:1.10.150.20:FF:000182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79775, NULL, 'G3DSA:3.40.50.720:FF:000448', NULL, NULL, 'Trk system potassium transporter TrkA', NULL, NULL, NULL, NULL, NULL, 4),
(79776, NULL, 'G3DSA:1.25.40.20:FF:001914', NULL, NULL, 'Ankyrin-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79777, NULL, 'G3DSA:3.30.1370.210:FF:000002', NULL, NULL, 'Muscleblind-like 1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(79778, NULL, 'G3DSA:3.40.50.300:FF:002020', NULL, NULL, 'Ras-related protein Rab-37', NULL, NULL, NULL, NULL, NULL, 4),
(79779, NULL, 'G3DSA:3.30.720.90:FF:000003', NULL, NULL, '60S ribosomal protein L38', NULL, NULL, NULL, NULL, NULL, 4),
(79780, NULL, 'G3DSA:1.20.920.30:FF:000067', NULL, NULL, 'Cytoplasmic dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79781, NULL, 'G3DSA:2.20.100.10:FF:000214', NULL, NULL, 'Thrombospondin type-1 domain-containing protein 7B', NULL, NULL, NULL, NULL, NULL, 4),
(79782, NULL, 'G3DSA:1.10.510.10:FF:002769', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79783, NULL, 'G3DSA:3.20.20.300:FF:000074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79784, NULL, 'G3DSA:1.10.3430.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79785, NULL, 'G3DSA:4.10.280.10:FF:000013', NULL, NULL, 'Circadian locomoter output cycles protein kaput', NULL, NULL, NULL, NULL, NULL, 4),
(79786, NULL, 'G3DSA:2.40.50.140:FF:000924', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79787, NULL, 'G3DSA:1.10.490.10:FF:000018', NULL, NULL, 'GLoBin related', NULL, NULL, NULL, NULL, NULL, 4),
(79788, NULL, 'G3DSA:3.30.160.60:FF:006269', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79789, NULL, 'G3DSA:3.40.50.1820:FF:000608', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(79790, NULL, 'G3DSA:3.30.497.10:FF:000095', NULL, NULL, 'Serpin peptidase inhibitor 1', NULL, NULL, NULL, NULL, NULL, 4),
(79791, NULL, 'G3DSA:1.25.40.20:FF:001235', NULL, NULL, 'KN motif and ankyrin repeat domains 3', NULL, NULL, NULL, NULL, NULL, 4),
(79792, NULL, 'G3DSA:3.30.1360.40:FF:000050', NULL, NULL, 'DNA topoisomerase IIB', NULL, NULL, NULL, NULL, NULL, 4),
(79793, NULL, 'G3DSA:1.10.260.100:FF:000020', NULL, NULL, 'Heat shock protein 70 (HSP70)-interacting protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79794, NULL, 'G3DSA:3.30.240.40:FF:000002', NULL, NULL, 'Protein E6', NULL, NULL, NULL, NULL, NULL, 4),
(79795, NULL, 'G3DSA:1.10.1580.10:FF:000030', NULL, NULL, 'Nucleolar GTP-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(79796, NULL, 'G3DSA:3.80.10.10:FF:004156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79797, NULL, 'G3DSA:1.25.40.10:FF:001232', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g52850, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(79798, NULL, 'G3DSA:3.90.660.10:FF:000124', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79799, NULL, 'G3DSA:3.40.50.720:FF:001876', NULL, NULL, 'Pyrroline-5-carboxylate reductase-like 2, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(79800, NULL, 'G3DSA:3.40.50.150:FF:001317', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79801, NULL, 'G3DSA:2.60.40.10:FF:002458', NULL, NULL, 'Uncharacterized protein, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(79802, NULL, 'G3DSA:3.30.70.330:FF:000057', NULL, NULL, 'U2 snRNP auxiliary factor large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(79803, NULL, 'G3DSA:3.40.390.10:FF:000165', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(79804, NULL, 'G3DSA:3.30.160.60:FF:003043', NULL, NULL, 'Myc-associated zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(79805, NULL, 'G3DSA:3.30.565.10:FF:000169', NULL, NULL, 'Sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(79806, NULL, 'G3DSA:2.60.120.650:FF:000142', NULL, NULL, 'YALI0B14443p', NULL, NULL, NULL, NULL, NULL, 4),
(79807, NULL, 'G3DSA:1.10.1060.10:FF:000018', NULL, NULL, 'Putative selenate reductase, YgfK subunit', NULL, NULL, NULL, NULL, NULL, 4),
(79808, NULL, 'G3DSA:3.40.50.300:FF:001840', NULL, NULL, 'DEAD-box ATP-dependent RNA helicase 3B, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(79809, NULL, 'G3DSA:1.10.287.70:FF:000530', NULL, NULL, 'Potassium calcium-activated channel subfamily N member 3', NULL, NULL, NULL, NULL, NULL, 4),
(79810, NULL, 'G3DSA:3.40.250.10:FF:000216', NULL, NULL, 'Uncharacterized protein UNK4.09', NULL, NULL, NULL, NULL, NULL, 4),
(79811, NULL, 'G3DSA:2.30.30.40:FF:000388', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79812, NULL, 'G3DSA:3.30.160.60:FF:002879', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79813, NULL, 'G3DSA:3.40.1120.10:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79814, NULL, 'G3DSA:2.30.30.490:FF:000050', NULL, NULL, 'Protein polybromo-1', NULL, NULL, NULL, NULL, NULL, 4),
(79815, NULL, 'G3DSA:3.80.10.10:FF:000250', NULL, NULL, 'vasorin', NULL, NULL, NULL, NULL, NULL, 4),
(79816, NULL, 'G3DSA:3.30.710.10:FF:000108', NULL, NULL, 'gigaxonin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(79817, NULL, 'G3DSA:3.90.180.10:FF:000014', NULL, NULL, 'Cinnamyl alcohol dehydrogenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(79818, NULL, 'G3DSA:3.10.20.90:FF:000974', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79819, NULL, 'G3DSA:3.10.450.700:FF:000005', NULL, NULL, 'purine-rich element-binding protein gamma isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(79820, NULL, 'G3DSA:3.30.160.60:FF:001261', NULL, NULL, 'Zinc finger protein 75a', NULL, NULL, NULL, NULL, NULL, 4),
(79821, NULL, 'G3DSA:2.60.40.820:FF:000009', NULL, NULL, 'MAX gene-associated protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(79822, NULL, 'G3DSA:1.20.1080.10:FF:000068', NULL, NULL, 'Aquaporin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(79823, NULL, 'G3DSA:2.30.29.30:FF:000168', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(79824, NULL, 'G3DSA:1.25.10.10:FF:001067', NULL, NULL, 'WGS project CABT00000000 data, contig 2.21', NULL, NULL, NULL, NULL, NULL, 4),
(79825, NULL, 'G3DSA:1.20.5.110:FF:000221', NULL, NULL, 'SNARE domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(79826, NULL, 'G3DSA:2.60.40.60:FF:000758', NULL, NULL, 'Hedgehog protein', NULL, NULL, NULL, NULL, NULL, 4),
(79827, NULL, 'G3DSA:1.10.10.10:FF:000398', NULL, NULL, 'RNA polymerase factor sigma-70', NULL, NULL, NULL, NULL, NULL, 4),
(79828, NULL, 'G3DSA:3.90.550.10:FF:000397', NULL, NULL, 'Glycosyl transferase CpsJ(V)', NULL, NULL, NULL, NULL, NULL, 4),
(79829, NULL, 'G3DSA:1.10.10.160:FF:000034', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(79830, NULL, 'G3DSA:1.20.58.1480:FF:000012', NULL, NULL, 'Lon protease homolog', NULL, NULL, NULL, NULL, NULL, 4),
(79831, NULL, 'G3DSA:1.10.238.10:FF:001225', NULL, NULL, 'Calcium-binding protein F-like', NULL, NULL, NULL, NULL, NULL, 4),
(79832, NULL, 'G3DSA:4.10.400.10:FF:000102', NULL, NULL, 'Low-density lipoprotein receptor-related protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(79833, NULL, 'G3DSA:3.40.50.300:FF:001194', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79834, NULL, 'G3DSA:3.30.710.10:FF:000417', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(79835, NULL, 'G3DSA:2.60.260.20:FF:000169', NULL, NULL, 'Chaperone protein', NULL, NULL, NULL, NULL, NULL, 4),
(79836, NULL, 'G3DSA:3.40.50.150:FF:001008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79837, NULL, 'G3DSA:1.20.1700.10:FF:000004', NULL, NULL, 'RE73673p', NULL, NULL, NULL, NULL, NULL, 4),
(79838, NULL, 'G3DSA:3.40.225.10:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(79839, NULL, 'G3DSA:3.40.630.30:FF:000111', NULL, NULL, 'Aminoglycoside N(6'')-acetyltransferase type 1', NULL, NULL, NULL, NULL, NULL, 4),
(79840, NULL, 'G3DSA:3.30.70.330:FF:000720', NULL, NULL, 'RBM44 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(79841, NULL, 'G3DSA:2.10.25.10:FF:001559', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(79842, NULL, 'G3DSA:1.25.40.120:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79843, NULL, 'G3DSA:1.20.1250.20:FF:001995', NULL, NULL, 'AGAP012344-PA', NULL, NULL, NULL, NULL, NULL, 4),
(79844, NULL, 'G3DSA:3.90.1150.10:FF:000427', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79845, NULL, 'G3DSA:2.130.10.10:FF:005712', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79846, NULL, 'G3DSA:3.50.50.60:FF:000049', NULL, NULL, 'Protein FLOWERING LOCUS D like', NULL, NULL, NULL, NULL, NULL, 4),
(79847, NULL, 'G3DSA:3.40.50.10810:FF:000079', NULL, NULL, 'SWF/SNF family helicase', NULL, NULL, NULL, NULL, NULL, 4),
(79848, NULL, 'G3DSA:3.40.630.30:FF:000420', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79849, NULL, 'G3DSA:3.90.950.10:FF:000034', NULL, NULL, 'Inosine/xanthosine triphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(79850, NULL, 'G3DSA:3.30.40.10:FF:002266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79851, NULL, 'G3DSA:1.10.287.610:FF:000012', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(79852, NULL, 'G3DSA:3.40.50.300:FF:007500', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79853, NULL, 'G3DSA:2.30.42.10:FF:000507', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79854, NULL, 'G3DSA:1.20.58.60:FF:000640', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79855, NULL, 'G3DSA:1.20.120.900:FF:000002', NULL, NULL, 'Peroxisome biogenesis protein 19-2', NULL, NULL, NULL, NULL, NULL, 4),
(79856, NULL, 'G3DSA:3.30.780.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79857, NULL, 'G3DSA:1.25.40.10:FF:000759', NULL, NULL, 'Pentatricopeptide repeat-containing protein PNM1 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(79858, NULL, 'G3DSA:1.25.10.10:FF:000578', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(79859, NULL, 'G3DSA:2.60.120.200:FF:000237', NULL, NULL, 'Mannose/glucose-specific lectin', NULL, NULL, NULL, NULL, NULL, 4),
(79860, NULL, 'G3DSA:3.40.50.300:FF:001205', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(79861, NULL, 'G3DSA:3.30.70.330:FF:002827', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79862, NULL, 'G3DSA:1.10.340.70:FF:000008', NULL, NULL, 'Transposon Tf2-6 polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(79863, NULL, 'G3DSA:2.70.20.10:FF:000017', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(79864, NULL, 'G3DSA:3.90.190.10:FF:000149', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase V', NULL, NULL, NULL, NULL, NULL, 4),
(79865, NULL, 'G3DSA:3.30.160.60:FF:003722', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79866, NULL, 'G3DSA:3.40.190.10:FF:000863', NULL, NULL, 'Transferrin-a', NULL, NULL, NULL, NULL, NULL, 4),
(79867, NULL, 'G3DSA:1.25.10.10:FF:003321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79868, NULL, 'G3DSA:1.25.10.10:FF:003012', NULL, NULL, 'Tubulin-specific chaperone D-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(79869, NULL, 'G3DSA:3.40.50.300:FF:007337', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(79870, NULL, 'G3DSA:2.60.490.10:FF:000003', NULL, NULL, 'P2X purinoceptor', NULL, NULL, NULL, NULL, NULL, 4),
(79871, NULL, 'G3DSA:3.40.50.800:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79872, NULL, 'G3DSA:3.30.70.1400:FF:000019', NULL, NULL, 'N,N-dimethylglycine oxidase, putative (AFU_orthologue AFUA_8G06470)', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(79873, NULL, 'G3DSA:3.60.40.10:FF:000241', NULL, NULL, 'TGF-beta-activated kinase 1/MAP3K7-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(79874, NULL, 'G3DSA:1.25.10.10:FF:000887', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(79875, NULL, 'G3DSA:3.30.460.10:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79876, NULL, 'G3DSA:3.90.1390.10:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79877, NULL, 'G3DSA:3.10.580.10:FF:000124', NULL, NULL, 'Metal transporter cnnm-4', NULL, NULL, NULL, NULL, NULL, 4),
(79878, NULL, 'G3DSA:1.25.40.10:FF:000389', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(79879, NULL, 'G3DSA:2.120.10.30:FF:000481', NULL, NULL, 'Putative lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(79880, NULL, 'G3DSA:1.20.1740.10:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79881, NULL, 'G3DSA:1.20.5.170:FF:000115', NULL, NULL, 'Peptide chain release factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(79882, NULL, 'G3DSA:2.30.29.30:FF:000640', NULL, NULL, 'Atypical/BCR protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(79883, NULL, 'G3DSA:3.40.50.170:FF:000031', NULL, NULL, 'Phosphoribosylglycinamide formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(79884, NULL, 'G3DSA:3.20.20.20:FF:000008', NULL, NULL, 'Dihydropteroate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(79885, NULL, 'G3DSA:1.20.120.910:FF:000005', NULL, NULL, 'RNA polymerase-binding transcription factor DksA', NULL, NULL, NULL, NULL, NULL, 4),
(79886, NULL, 'G3DSA:1.20.1250.20:FF:000904', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79887, NULL, 'G3DSA:3.40.190.10:FF:000554', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(79888, NULL, 'G3DSA:1.20.1560.10:FF:000015', NULL, NULL, 'multidrug resistance-associated protein 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(79889, NULL, 'G3DSA:3.10.129.10:FF:000059', NULL, NULL, 'Acyl-coenzyme A thioesterase 13', NULL, NULL, NULL, NULL, NULL, 4),
(79890, NULL, 'G3DSA:1.20.1070.10:FF:000803', NULL, NULL, 'Neuropeptide FF receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(79891, NULL, 'G3DSA:3.20.180.20:FF:000027', NULL, NULL, 'YALI0E32857p', NULL, NULL, NULL, NULL, NULL, 4),
(79892, NULL, 'G3DSA:3.30.70.330:FF:001063', NULL, NULL, 'SD14970p', NULL, NULL, NULL, NULL, NULL, 4),
(79893, NULL, 'G3DSA:4.10.240.10:FF:000230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79894, NULL, 'G3DSA:3.30.420.40:FF:001039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79895, NULL, 'G3DSA:1.20.1310.20:FF:000022', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(79896, NULL, 'G3DSA:3.40.50.850:FF:000021', NULL, NULL, 'Pyrazinamidase/nicotinamidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79897, NULL, 'G3DSA:3.10.100.10:FF:000286', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79898, NULL, 'G3DSA:3.20.20.80:FF:000212', NULL, NULL, 'Exo-1,3-beta-glucanase', NULL, NULL, NULL, NULL, NULL, 4),
(79899, NULL, 'G3DSA:3.90.950.10:FF:000017', NULL, NULL, 'Protein PRRC1-B', NULL, NULL, NULL, NULL, NULL, 4),
(79900, NULL, 'G3DSA:3.40.190.10:FF:000880', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79901, NULL, 'G3DSA:3.40.50.720:FF:000920', NULL, NULL, 'BDH2 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(79902, NULL, 'G3DSA:2.130.10.10:FF:005988', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79903, NULL, 'G3DSA:3.40.50.300:FF:007028', NULL, NULL, 'Ras-related protein RabX', NULL, NULL, NULL, NULL, NULL, 4),
(79904, NULL, 'G3DSA:1.20.210.10:FF:000007', NULL, NULL, 'Cytochrome c oxidase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(79905, NULL, 'G3DSA:3.40.50.10190:FF:000033', NULL, NULL, 'DNA topoisomerase II binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(79906, NULL, 'G3DSA:1.20.5.170:FF:000071', NULL, NULL, 'Neural retina-specific leucine zipper protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(79907, NULL, 'G3DSA:3.40.190.170:FF:000015', NULL, NULL, 'TRAP dicarboxylate transporter, DctP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(79908, NULL, 'G3DSA:1.20.1070.10:FF:000450', NULL, NULL, 'DOPamine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(79909, NULL, 'G3DSA:2.130.10.10:FF:003560', NULL, NULL, 'WD repeat domain 62, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(79910, NULL, 'G3DSA:2.40.37.10:FF:000080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79911, NULL, 'G3DSA:2.130.10.10:FF:002762', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79912, NULL, 'G3DSA:3.30.160.60:FF:005313', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79913, NULL, 'G3DSA:3.30.559.10:FF:000109', NULL, NULL, 'Transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(79914, NULL, 'G3DSA:1.10.238.10:FF:000736', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79915, NULL, 'G3DSA:2.60.120.200:FF:000580', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79916, NULL, 'G3DSA:2.120.10.10:FF:000014', NULL, NULL, 'Tail spike protein', NULL, NULL, NULL, NULL, NULL, 4),
(79917, NULL, 'G3DSA:2.40.50.320:FF:000001', NULL, NULL, 'Cation efflux system protein CusF', NULL, NULL, NULL, NULL, NULL, 4),
(79918, NULL, 'G3DSA:2.60.40.10:FF:004919', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79919, NULL, 'G3DSA:3.50.50.60:FF:000684', NULL, NULL, '2,6-dihydroxypyridine 3-hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(79920, NULL, 'G3DSA:2.40.50.140:FF:000941', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79921, NULL, 'G3DSA:3.20.20.300:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79922, NULL, 'G3DSA:3.40.50.300:FF:003431', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(79923, NULL, 'G3DSA:3.40.50.1820:FF:001699', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79924, NULL, 'G3DSA:3.40.50.20:FF:000009', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(79925, NULL, 'G3DSA:3.30.750.24:FF:000107', NULL, NULL, 'Anti sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(79926, NULL, 'G3DSA:3.10.20.340:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79927, NULL, 'G3DSA:1.10.3430.10:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79928, NULL, 'G3DSA:2.60.40.420:FF:000277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79929, NULL, 'G3DSA:3.40.50.1970:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79930, NULL, 'G3DSA:3.40.50.620:FF:000418', NULL, NULL, 'tRNA-methyl transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(79931, NULL, 'G3DSA:2.60.40.10:FF:005055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79932, NULL, 'G3DSA:4.10.410.10:FF:000030', NULL, NULL, 'CBN-MEC-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(79933, NULL, 'G3DSA:2.60.40.10:FF:003301', NULL, NULL, 'Leukemia inhibitory factor receptor alpha b', NULL, NULL, NULL, NULL, NULL, 4),
(79934, NULL, 'G3DSA:3.90.550.50:FF:000167', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(79935, NULL, 'G3DSA:3.60.10.10:FF:000043', NULL, NULL, 'Endonuclease/Exonuclease/phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(79936, NULL, 'G3DSA:3.40.50.300:FF:001531', NULL, NULL, 'Endonuclease MutS2', NULL, NULL, NULL, NULL, NULL, 4),
(79937, NULL, 'G3DSA:3.40.50.1820:FF:000625', NULL, NULL, 'Lipase-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(79938, NULL, 'G3DSA:1.10.10.60:FF:000952', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79939, NULL, 'G3DSA:2.30.30.770:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79940, NULL, 'G3DSA:3.30.559.10:FF:000065', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(79941, NULL, 'G3DSA:2.60.40.150:FF:000792', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79942, NULL, 'G3DSA:3.40.50.1820:FF:000081', NULL, NULL, 'phospholipase A1 member A isoform X1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(79943, NULL, 'G3DSA:2.30.30.790:FF:000016', NULL, NULL, 'Translation protein SH3-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(79944, NULL, 'G3DSA:1.25.40.20:FF:001370', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79945, NULL, 'G3DSA:3.40.50.300:FF:005229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79946, NULL, 'G3DSA:3.40.50.150:FF:001334', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79947, NULL, 'G3DSA:3.30.390.80:FF:000002', NULL, NULL, 'RAD52 motif containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(79948, NULL, 'G3DSA:3.80.10.10:FF:002239', NULL, NULL, 'Leucine-rich repeat (LRR) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(79949, NULL, 'G3DSA:3.30.730.10:FF:000008', NULL, NULL, 'AP2 domain-containing protein RAP2.8', NULL, NULL, NULL, NULL, NULL, 4),
(79950, NULL, 'G3DSA:3.10.20.320:FF:000003', NULL, NULL, 'LPXTG cell wall anchor domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(79951, NULL, 'G3DSA:1.10.640.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79952, NULL, 'G3DSA:2.10.70.20:FF:000003', NULL, NULL, 'General secretion pathway protein J', NULL, NULL, NULL, NULL, NULL, 4),
(79953, NULL, 'G3DSA:3.40.50.80:FF:000230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79954, NULL, 'G3DSA:3.30.70.330:FF:002491', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79955, NULL, 'G3DSA:1.10.730.10:FF:000189', NULL, NULL, 'Glycine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(79956, NULL, 'G3DSA:1.10.238.10:FF:001079', NULL, NULL, 'EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(79957, NULL, 'G3DSA:3.30.1360.40:FF:000033', NULL, NULL, 'DNA topoisomerase 4 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(79958, NULL, 'G3DSA:2.30.30.30:FF:000059', NULL, NULL, 'Transcription elongation factor SPT5', NULL, NULL, NULL, NULL, NULL, 4),
(79959, NULL, 'G3DSA:1.20.920.20:FF:000047', NULL, NULL, 'YALI0E32857p', NULL, NULL, NULL, NULL, NULL, 4),
(79960, NULL, 'G3DSA:3.40.50.1820:FF:001727', NULL, NULL, 'Rop guanine nucleotide exchange factor 7', NULL, NULL, NULL, NULL, NULL, 4),
(79961, NULL, 'G3DSA:2.130.10.10:FF:004886', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79962, NULL, 'G3DSA:2.60.40.10:FF:001356', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(79963, NULL, 'G3DSA:1.20.1250.20:FF:001978', NULL, NULL, 'Tetracycline resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(79964, NULL, 'G3DSA:1.20.1560.10:FF:000650', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79965, NULL, 'G3DSA:1.10.260.40:FF:000050', NULL, NULL, 'HTH-type transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(79966, NULL, 'G3DSA:3.40.50.720:FF:002365', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(79967, NULL, 'G3DSA:2.30.29.30:FF:000314', NULL, NULL, 'Beta-1-syntrophin isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(79968, NULL, 'G3DSA:3.40.33.10:FF:000130', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(79969, NULL, 'G3DSA:3.30.160.60:FF:003059', NULL, NULL, 'Zinc finger protein 335', NULL, NULL, NULL, NULL, NULL, 4),
(79970, NULL, 'G3DSA:1.20.920.10:FF:000044', NULL, NULL, 'Bromodomain and WD repeat domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(79971, NULL, 'G3DSA:1.10.10.160:FF:000051', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(79972, NULL, 'G3DSA:3.90.190.10:FF:000621', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79973, NULL, 'G3DSA:1.25.40.90:FF:000047', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(79974, NULL, 'G3DSA:2.60.40.10:FF:005201', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79975, NULL, 'G3DSA:4.10.1000.10:FF:000030', NULL, NULL, 'CCCH type zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(79976, NULL, 'G3DSA:1.25.10.10:FF:001730', NULL, NULL, 'Splicing factor3B subunit 1, putative', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(79977, NULL, 'G3DSA:2.10.25.10:FF:000603', NULL, NULL, 'Stabilin 1', NULL, NULL, NULL, NULL, NULL, 4),
(79978, NULL, 'G3DSA:3.30.420.10:FF:000333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79979, NULL, 'G3DSA:3.30.1520.10:FF:000037', NULL, NULL, 'Sorting nexin mvp-1', NULL, NULL, NULL, NULL, NULL, 4),
(79980, NULL, 'G3DSA:2.130.10.10:FF:000963', NULL, NULL, 'AGAP001362-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(79981, NULL, 'G3DSA:3.20.20.30:FF:000028', NULL, NULL, 'Alkanesulfonate monooxygenase SsuD/methylene tetrahydromethanopterin reductase-like flavin-dependent oxidoreductase (Luciferase family)', NULL, NULL, NULL, NULL, NULL, 4),
(79982, NULL, 'G3DSA:1.10.357.10:FF:000029', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(79983, NULL, 'G3DSA:1.10.287.520:FF:000002', NULL, NULL, 'Noggin', NULL, NULL, NULL, NULL, NULL, 4),
(79984, NULL, 'G3DSA:2.130.10.10:FF:000637', NULL, NULL, 'WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(79985, NULL, 'G3DSA:3.30.1010.10:FF:000088', NULL, NULL, 'DNA-dependent protein kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(79986, NULL, 'G3DSA:1.20.1230.10:FF:000013', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(79987, NULL, 'G3DSA:3.40.50.1820:FF:000390', NULL, NULL, 'BnaC04g55880D protein', NULL, NULL, NULL, NULL, NULL, 4),
(79988, NULL, 'G3DSA:3.40.50.620:FF:000553', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79989, NULL, 'G3DSA:3.20.20.20:FF:000025', NULL, NULL, 'Corrinoid/iron-sulfur protein large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(79990, NULL, 'G3DSA:3.40.366.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79991, NULL, 'G3DSA:1.20.58.60:FF:000286', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(79992, NULL, 'G3DSA:2.10.110.10:FF:000341', NULL, NULL, 'LIM and SH3 protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(79993, NULL, 'G3DSA:3.40.50.300:FF:001486', NULL, NULL, 'Molybdopterin-guanine dinucleotide biosynthesis protein B', NULL, NULL, NULL, NULL, NULL, 4),
(79994, NULL, 'G3DSA:1.10.510.10:FF:003921', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(79995, NULL, 'G3DSA:3.30.540.10:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(79996, NULL, 'G3DSA:1.10.101.10:FF:000020', NULL, NULL, 'Lytic murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(79997, NULL, 'G3DSA:2.60.120.200:FF:000254', NULL, NULL, 'MAM and LDL-receptor class A domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(79998, NULL, 'G3DSA:1.10.287.540:FF:000008', NULL, NULL, '23S rRNA (guanine(2535)-N(1))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(79999, NULL, 'G3DSA:3.60.40.10:FF:000106', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(80000, NULL, 'G3DSA:2.130.10.30:FF:000047', NULL, NULL, 'Regulator of chromosome condensation (RCC1) repeat', NULL, NULL, NULL, NULL, NULL, 4),
(80001, NULL, 'G3DSA:3.40.50.2300:FF:000461', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(80002, NULL, 'G3DSA:1.10.238.10:FF:001208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80003, NULL, 'G3DSA:2.20.28.200:FF:000002', NULL, NULL, 'NAD-dependent deacetylase sirtuin-7', NULL, NULL, NULL, NULL, NULL, 4),
(80004, NULL, 'G3DSA:3.30.420.10:FF:000007', NULL, NULL, 'Interferon-stimulated exonuclease gene 20', NULL, NULL, NULL, NULL, NULL, 4),
(80005, NULL, 'G3DSA:3.20.20.140:FF:000211', NULL, NULL, 'dihydropyrimidinase-related protein 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(80006, NULL, 'G3DSA:3.40.50.410:FF:000119', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(80007, NULL, 'G3DSA:1.20.140.150:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80008, NULL, 'G3DSA:3.30.160.60:FF:004796', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(80009, NULL, 'G3DSA:2.60.120.260:FF:000648', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80010, NULL, 'G3DSA:3.40.50.300:FF:003740', NULL, NULL, 'AAA family ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80011, NULL, 'G3DSA:1.50.40.10:FF:000212', NULL, NULL, 'Putative dicarboxylic acid transmembrane transporter', NULL, NULL, NULL, NULL, NULL, 4),
(80012, NULL, 'G3DSA:3.30.710.10:FF:000125', NULL, NULL, 'Calicin', NULL, NULL, NULL, NULL, NULL, 4),
(80013, NULL, 'G3DSA:3.40.50.300:FF:007354', NULL, NULL, 'AGAP012289-PA', NULL, NULL, NULL, NULL, NULL, 4),
(80014, NULL, 'G3DSA:2.10.50.10:FF:000100', NULL, NULL, 'Zgc:163064 protein', NULL, NULL, NULL, NULL, NULL, 4),
(80015, NULL, 'G3DSA:2.60.120.260:FF:000339', NULL, NULL, 'Glycosyltransferase-like protein LARGE1', NULL, NULL, NULL, NULL, NULL, 4),
(80016, NULL, 'G3DSA:3.40.50.720:FF:002382', NULL, NULL, 'Gll3017 protein', NULL, NULL, NULL, NULL, NULL, 4),
(80017, NULL, 'G3DSA:2.60.40.10:FF:001339', NULL, NULL, 'NPHS1, nephrin', NULL, NULL, NULL, NULL, NULL, 4),
(80018, NULL, 'G3DSA:2.60.40.10:FF:003610', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80019, NULL, 'G3DSA:1.20.1260.110:FF:000005', NULL, NULL, 'DNA integrity scanning protein DisA', NULL, NULL, NULL, NULL, NULL, 4),
(80020, NULL, 'G3DSA:2.170.300.10:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80021, NULL, 'G3DSA:3.40.50.300:FF:002588', NULL, NULL, 'ATPase, AAA family', NULL, NULL, NULL, NULL, NULL, 4),
(80022, NULL, 'G3DSA:3.40.50.2000:FF:000343', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(80023, NULL, 'G3DSA:1.20.58.540:FF:000001', NULL, NULL, 'Botulinum neurotoxin type A', NULL, NULL, NULL, NULL, NULL, 4),
(80024, NULL, 'G3DSA:1.10.510.10:FF:001151', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(80025, NULL, 'G3DSA:3.40.50.300:FF:000997', NULL, NULL, 'Multidrug resistance-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(80026, NULL, 'G3DSA:3.20.20.80:FF:000419', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80027, NULL, 'G3DSA:3.30.470.20:FF:000255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80028, NULL, 'G3DSA:1.20.1270.60:FF:000322', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80029, NULL, 'G3DSA:3.30.70.1180:FF:000003', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(80030, NULL, 'G3DSA:3.40.390.10:FF:000182', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80031, NULL, 'G3DSA:1.10.8.590:FF:000002', NULL, NULL, 'Putative tRNA/rRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(80032, NULL, 'G3DSA:3.30.160.60:FF:002896', NULL, NULL, 'Zinc finger protein 260', NULL, NULL, NULL, NULL, NULL, 4),
(80033, NULL, 'G3DSA:2.60.40.10:FF:005381', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80034, NULL, 'G3DSA:3.40.50.300:FF:003329', NULL, NULL, 'Small GTPase EhRabX27, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80035, NULL, 'G3DSA:1.10.287.70:FF:000193', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(80036, NULL, 'G3DSA:1.10.1060.10:FF:000002', NULL, NULL, 'Succinate dehydrogenase iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4),
(80037, NULL, 'G3DSA:3.40.50.150:FF:001660', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80038, NULL, 'G3DSA:1.20.120.1630:FF:000003', NULL, NULL, 'C-24(28) sterol reductase', NULL, NULL, NULL, NULL, NULL, 4),
(80039, NULL, 'G3DSA:3.90.660.10:FF:000141', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80040, NULL, 'G3DSA:1.25.10.10:FF:001404', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(80041, NULL, 'G3DSA:2.30.29.30:FF:000185', NULL, NULL, 'TBC1 domain family member 8B', NULL, NULL, NULL, NULL, NULL, 4),
(80042, NULL, 'G3DSA:3.40.50.300:FF:008456', NULL, NULL, 'ATP-binding cassette, sub-family F, member 3', NULL, NULL, NULL, NULL, NULL, 4),
(80043, NULL, 'G3DSA:1.10.10.60:FF:000626', NULL, NULL, 'Transcription factor LAF1-like', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(80044, NULL, 'G3DSA:3.30.450.20:FF:000501', NULL, NULL, 'Sensor histidine kinase, PAS, PAS, PAS and PAS domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(80045, NULL, 'G3DSA:3.40.50.300:FF:001177', NULL, NULL, 'Plastid replication-repair enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(80046, NULL, 'G3DSA:1.10.510.10:FF:003612', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80047, NULL, 'G3DSA:4.10.80.30:FF:000002', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(80048, NULL, 'G3DSA:3.30.60.190:FF:000007', NULL, NULL, 'Box C/D snoRNA', NULL, NULL, NULL, NULL, NULL, 4),
(80049, NULL, 'G3DSA:3.40.630.10:FF:000364', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80050, NULL, 'G3DSA:3.90.79.10:FF:000149', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(80051, NULL, 'G3DSA:1.20.58.2140:FF:000002', NULL, NULL, 'Haloacid dehalogenase', NULL, NULL, NULL, NULL, NULL, 4),
(80052, NULL, 'G3DSA:2.40.50.90:FF:000055', NULL, NULL, 'Tudor domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(80053, NULL, 'G3DSA:3.30.710.10:FF:000434', NULL, NULL, 'Ankyrin repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(80054, NULL, 'G3DSA:4.10.80.40:FF:000005', NULL, NULL, 'Succinate dehydrogenase flavoprotein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(80055, NULL, 'G3DSA:1.20.930.20:FF:000020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80056, NULL, 'G3DSA:3.40.1110.10:FF:000200', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(80057, NULL, 'G3DSA:3.30.160.100:FF:000019', NULL, NULL, 'Plastid-specific ribosomal protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(80058, NULL, 'G3DSA:2.30.30.140:FF:000203', NULL, NULL, 'Uncharacterized protein R102.4-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(80059, NULL, 'G3DSA:3.90.70.200:FF:000027', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80060, NULL, 'G3DSA:1.10.10.440:FF:000011', NULL, NULL, 'pre-mRNA-processing factor 40 homolog A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(80061, NULL, 'G3DSA:1.20.1250.20:FF:000360', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(80062, NULL, 'G3DSA:3.30.160.60:FF:001126', NULL, NULL, 'zinc finger protein 684 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(80063, NULL, 'G3DSA:1.25.40.10:FF:002985', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(80064, NULL, 'G3DSA:1.10.510.10:FF:001460', NULL, NULL, 'CTD kinase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(80065, NULL, 'G3DSA:3.40.50.300:FF:000688', NULL, NULL, 'ATP-binding cassette sub-family F member 3', NULL, NULL, NULL, NULL, NULL, 4),
(80066, NULL, 'G3DSA:3.30.930.10:FF:000080', NULL, NULL, 'phenylalanine--tRNA ligase, chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(80067, NULL, 'G3DSA:2.30.29.30:FF:000494', NULL, NULL, 'Probable pleckstrin homology domain-containing family N member 1', NULL, NULL, NULL, NULL, NULL, 4),
(80068, NULL, 'G3DSA:3.40.640.10:FF:000499', NULL, NULL, 'Kynureninase', NULL, NULL, NULL, NULL, NULL, 4),
(80069, NULL, 'G3DSA:3.40.50.20:FF:000026', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(80070, NULL, 'G3DSA:3.30.70.330:FF:002165', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80071, NULL, 'G3DSA:1.20.1090.10:FF:000024', NULL, NULL, 'Iron-containing alcohol dehydrogenase RfbM', NULL, NULL, NULL, NULL, NULL, 4),
(80072, NULL, 'G3DSA:1.10.8.100:FF:000018', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(80073, NULL, 'G3DSA:3.40.850.10:FF:000419', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80074, NULL, 'G3DSA:2.60.40.10:FF:005072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80075, NULL, 'G3DSA:3.90.1310.10:FF:000007', NULL, NULL, 'Penicillin-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(80076, NULL, 'G3DSA:2.60.220.50:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(80077, NULL, 'G3DSA:3.20.20.140:FF:000065', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(80078, NULL, 'G3DSA:1.10.10.350:FF:000001', NULL, NULL, 'Glutamate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(80079, NULL, 'G3DSA:3.60.15.10:FF:000273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80080, NULL, 'G3DSA:3.80.10.10:FF:000912', NULL, NULL, 'NLR family pyrin domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(80081, NULL, 'G3DSA:3.20.20.150:FF:000068', NULL, NULL, 'Xylose isomerase domain protein TIM barrel', NULL, NULL, NULL, NULL, NULL, 4),
(80082, NULL, 'G3DSA:3.30.428.10:FF:000019', NULL, NULL, 'Galactose-1-phosphate uridylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(80083, NULL, 'G3DSA:1.10.287.130:FF:000082', NULL, NULL, 'Sensor histidine kinase YvrG', NULL, NULL, NULL, NULL, NULL, 4),
(80084, NULL, 'G3DSA:1.25.40.10:FF:004913', NULL, NULL, 'Pre-mRNA-splicing factor SYF1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(80085, NULL, 'G3DSA:3.90.70.10:FF:000629', NULL, NULL, 'Protein CBG24565', NULL, NULL, NULL, NULL, NULL, 4),
(80086, NULL, 'G3DSA:1.25.10.10:FF:003304', NULL, NULL, 'Probable cytochrome c', NULL, NULL, NULL, NULL, NULL, 4),
(80087, NULL, 'G3DSA:3.40.50.300:FF:005022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80088, NULL, 'G3DSA:3.40.50.1700:FF:000011', NULL, NULL, 'Exported beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(80089, NULL, 'G3DSA:1.20.1070.10:FF:000141', NULL, NULL, 'atypical chemokine receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(80090, NULL, 'G3DSA:1.20.144.10:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80091, NULL, 'G3DSA:3.40.50.300:FF:006539', NULL, NULL, 'ADP ribosylation factor like GTPase 13B', NULL, NULL, NULL, NULL, NULL, 4),
(80092, NULL, 'G3DSA:3.50.50.60:FF:000566', NULL, NULL, 'Paromamine 6''-oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(80093, NULL, 'G3DSA:1.10.287.10:FF:000001', NULL, NULL, 'Non-structural protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(80094, NULL, 'G3DSA:1.10.340.70:FF:000025', NULL, NULL, 'Transposon Ty3-G Gag-Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(80095, NULL, 'G3DSA:3.30.70.330:FF:002283', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80096, NULL, 'G3DSA:1.20.58.60:FF:000494', NULL, NULL, 'AGAP004440-PA', NULL, NULL, NULL, NULL, NULL, 4),
(80097, NULL, 'G3DSA:1.10.3660.10:FF:000014', NULL, NULL, 'Chorismate mutase/prephenate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(80098, NULL, 'G3DSA:2.60.40.10:FF:001373', NULL, NULL, 'Immunoglobulin superfamily member 10', NULL, NULL, NULL, NULL, NULL, 4),
(80099, NULL, 'G3DSA:3.40.50.720:FF:002348', NULL, NULL, 'Oxidoreductase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(80100, NULL, 'G3DSA:3.30.70.330:FF:002182', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80101, NULL, 'G3DSA:2.120.10.30:FF:000464', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80102, NULL, 'G3DSA:3.20.20.100:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80103, NULL, 'G3DSA:3.80.10.10:FF:003993', NULL, NULL, 'Protein CBR-HAF-3', NULL, NULL, NULL, NULL, NULL, 4),
(80104, NULL, 'G3DSA:3.30.70.330:FF:000574', NULL, NULL, 'HIV Tat-specific factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(80105, NULL, 'G3DSA:1.20.1070.10:FF:001759', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80106, NULL, 'G3DSA:2.20.70.10:FF:000253', NULL, NULL, 'Membrane associated guanylate kinase, WW and PDZ domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(80107, NULL, 'G3DSA:3.40.50.300:FF:005538', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80108, NULL, 'G3DSA:3.30.40.10:FF:002311', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80109, NULL, 'G3DSA:3.90.1300.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80110, NULL, 'G3DSA:1.10.10.10:FF:001106', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(80111, NULL, 'G3DSA:3.30.710.10:FF:000451', NULL, NULL, 'Cytokinesis defective protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(80112, NULL, 'G3DSA:2.10.10.20:FF:000011', NULL, NULL, 'Chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(80113, NULL, 'G3DSA:3.40.50.620:FF:000109', NULL, NULL, 'Methionine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(80114, NULL, 'G3DSA:3.90.190.10:FF:000604', NULL, NULL, 'Protein tyrosine phosphatase, receptor type S', NULL, NULL, NULL, NULL, NULL, 4),
(80115, NULL, 'G3DSA:1.10.510.10:FF:001342', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80116, NULL, 'G3DSA:2.60.120.200:FF:000119', NULL, NULL, 'Laminin subunit alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(80117, NULL, 'G3DSA:1.10.510.10:FF:001813', NULL, NULL, 'Wall-associated serine/threonine kinase-like', NULL, NULL, NULL, NULL, NULL, 4),
(80118, NULL, 'G3DSA:3.55.40.20:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80119, NULL, 'G3DSA:3.40.50.300:FF:002796', NULL, NULL, 'Protein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(80120, NULL, 'G3DSA:3.30.1240.10:FF:000010', NULL, NULL, '5-amino-6-(5-phospho-D-ribitylamino)uracil phosphatase YbjI', NULL, NULL, NULL, NULL, NULL, 4),
(80121, NULL, 'G3DSA:3.40.50.2300:FF:000135', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(80122, NULL, 'G3DSA:3.40.50.1000:FF:000852', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80123, NULL, 'G3DSA:3.30.40.10:FF:000703', NULL, NULL, 'ERAD-associated E3 ubiquitin-protein ligase HRD1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80124, NULL, 'G3DSA:2.40.70.10:FF:000179', NULL, NULL, 'ASpartyl Protease', NULL, NULL, NULL, NULL, NULL, 4),
(80125, NULL, 'G3DSA:3.40.30.10:FF:000899', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(80126, NULL, 'G3DSA:1.10.287.770:FF:000009', NULL, NULL, 'NKG2-C type II integral membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(80127, NULL, 'G3DSA:2.70.160.11:FF:000062', NULL, NULL, 'Ribosomal protein L11 methyltransferase (PrmA)', NULL, NULL, NULL, NULL, NULL, 4),
(80128, NULL, 'G3DSA:3.10.129.10:FF:000060', NULL, NULL, 'Os07g0463500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(80129, NULL, 'G3DSA:1.20.58.60:FF:000505', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80130, NULL, 'G3DSA:3.30.50.10:FF:000086', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(80131, NULL, 'G3DSA:1.50.40.10:FF:000004', NULL, NULL, 'Calcium-binding mitochondrial carrier protein Aralar1', NULL, NULL, NULL, NULL, NULL, 4),
(80132, NULL, 'G3DSA:1.10.246.90:FF:000014', NULL, NULL, 'Putative nucleolar protein 5-1', NULL, NULL, NULL, NULL, NULL, 4),
(80133, NULL, 'G3DSA:1.25.40.10:FF:002659', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80134, NULL, 'G3DSA:3.90.1280.20:FF:000001', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(80135, NULL, 'G3DSA:3.40.50.150:FF:001452', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80136, NULL, 'G3DSA:1.10.8.60:FF:000501', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80137, NULL, 'G3DSA:3.80.10.10:FF:002565', NULL, NULL, 'Adhesion G protein-coupled receptor A2', NULL, NULL, NULL, NULL, NULL, 4),
(80138, NULL, 'G3DSA:2.60.40.10:FF:005173', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80139, NULL, 'G3DSA:1.25.10.20:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80140, NULL, 'G3DSA:2.170.140.10:FF:000007', NULL, NULL, 'Acidic mammalian chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(80141, NULL, 'G3DSA:3.30.160.60:FF:003060', NULL, NULL, 'Zinc finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80142, NULL, 'G3DSA:3.30.470.20:FF:000047', NULL, NULL, 'Inositol-tetrakisphosphate 1-kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(80143, NULL, 'G3DSA:3.20.140.10:FF:000033', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(80144, NULL, 'G3DSA:3.30.470.10:FF:000044', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(80145, NULL, 'G3DSA:3.40.50.300:FF:003313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80146, NULL, 'G3DSA:1.25.40.10:FF:004812', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80147, NULL, 'G3DSA:1.20.1280.290:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80148, NULL, 'G3DSA:3.30.460.10:FF:000116', NULL, NULL, 'Poly(A) polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(80149, NULL, 'G3DSA:3.40.366.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80150, NULL, 'G3DSA:1.20.58.390:FF:000012', NULL, NULL, 'Acetylcholine receptor subunit alpha-like', NULL, NULL, NULL, NULL, NULL, 4),
(80151, NULL, 'G3DSA:3.40.250.10:FF:000233', NULL, NULL, 'Sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(80152, NULL, 'G3DSA:3.30.160.60:FF:001822', NULL, NULL, 'Zinc finger protein 648', NULL, NULL, NULL, NULL, NULL, 4),
(80153, NULL, 'G3DSA:1.10.287.470:FF:000026', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(80154, NULL, 'G3DSA:1.10.166.10:FF:000001', NULL, NULL, '2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-succinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(80155, NULL, 'G3DSA:3.40.50.150:FF:001188', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80156, NULL, 'G3DSA:1.10.12.10:FF:000003', NULL, NULL, '1,4-dihydroxy-2-naphthoyl-CoA synthase', NULL, NULL, NULL, NULL, NULL, 4),
(80157, NULL, 'G3DSA:3.90.190.10:FF:000503', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80158, NULL, 'G3DSA:3.30.420.40:FF:000814', NULL, NULL, 'SWI/SNF and RSC complexes subunit arp9', NULL, NULL, NULL, NULL, NULL, 4),
(80159, NULL, 'G3DSA:3.30.497.10:FF:000078', NULL, NULL, 'Serpin 100A', NULL, NULL, NULL, NULL, NULL, 4),
(80160, NULL, 'G3DSA:4.10.1060.10:FF:000022', NULL, NULL, 'Cabeza, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(80161, NULL, 'G3DSA:3.40.50.720:FF:000903', NULL, NULL, 'UDP-N-acetylmuramoylalanine--D-glutamate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(80162, NULL, 'G3DSA:3.40.1380.20:FF:000003', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(80163, NULL, 'G3DSA:3.30.465.10:FF:000004', NULL, NULL, 'Xanthine dehydrogenase/oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(80164, NULL, 'G3DSA:2.130.10.10:FF:002880', NULL, NULL, 'UTP15, small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4),
(80165, NULL, 'G3DSA:3.40.1350.100:FF:000006', NULL, NULL, 'Protein TIC 22-like chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(80166, NULL, 'G3DSA:1.10.630.10:FF:000024', NULL, NULL, 'Allene oxide synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(80167, NULL, 'G3DSA:1.10.10.60:FF:000497', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(80168, NULL, 'G3DSA:1.25.10.10:FF:003192', NULL, NULL, 'Protein ARABIDILLO 1', NULL, NULL, NULL, NULL, NULL, 4),
(80169, NULL, 'G3DSA:2.130.10.10:FF:001025', NULL, NULL, 'WD repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(80170, NULL, 'G3DSA:1.10.10.60:FF:001014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80171, NULL, 'G3DSA:3.40.50.80:FF:000084', NULL, NULL, 'Oxidoreductase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(80172, NULL, 'G3DSA:1.10.1520.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80173, NULL, 'G3DSA:2.70.150.10:FF:000268', NULL, NULL, 'Plasma membrane ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(80174, NULL, 'G3DSA:3.40.850.10:FF:000083', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(80175, NULL, 'G3DSA:1.10.10.10:FF:000959', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(80176, NULL, 'G3DSA:2.60.40.10:FF:000867', NULL, NULL, 'Titin a', NULL, NULL, NULL, NULL, NULL, 4),
(80177, NULL, 'G3DSA:3.30.40.10:FF:001586', NULL, NULL, 'E3 ubiquitin-protein ligase RING1', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(80178, NULL, 'G3DSA:3.50.30.30:FF:000022', NULL, NULL, 'RING finger protein 215', NULL, NULL, NULL, NULL, NULL, 4),
(80179, NULL, 'G3DSA:2.130.10.10:FF:002969', NULL, NULL, 'Inner dynein arm I1 intermediate chain IC140', NULL, NULL, NULL, NULL, NULL, 4),
(80180, NULL, 'G3DSA:1.20.1250.10:FF:000014', NULL, NULL, 'Interleukin-4', NULL, NULL, NULL, NULL, NULL, 4),
(80181, NULL, 'G3DSA:1.10.630.10:FF:000451', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80182, NULL, 'G3DSA:2.130.10.10:FF:001452', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80183, NULL, 'G3DSA:3.40.1280.10:FF:000049', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4),
(80184, NULL, 'G3DSA:3.30.40.10:FF:000158', NULL, NULL, 'Lysine (K)-specific demethylase 5A', NULL, NULL, NULL, NULL, NULL, 4),
(80185, NULL, 'G3DSA:2.70.170.10:FF:000168', NULL, NULL, 'Protein CBR-ACR-8', NULL, NULL, NULL, NULL, NULL, 4),
(80186, NULL, 'G3DSA:3.30.450.20:FF:000147', NULL, NULL, 'Antitoxin of toxin-antitoxin system', NULL, NULL, NULL, NULL, NULL, 4),
(80187, NULL, 'G3DSA:2.40.50.730:FF:000017', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(80188, NULL, 'G3DSA:3.90.640.10:FF:000241', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80189, NULL, 'G3DSA:1.10.510.10:FF:001134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80190, NULL, 'G3DSA:3.20.20.70:FF:000001', NULL, NULL, 'Pyridoxine biosynthesis protein PDX1', NULL, NULL, NULL, NULL, NULL, 4),
(80191, NULL, 'G3DSA:1.10.510.10:FF:003258', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80192, NULL, 'G3DSA:1.20.1250.20:FF:000017', NULL, NULL, 'Dipeptide and tripeptide permease A', NULL, NULL, NULL, NULL, NULL, 4),
(80193, NULL, 'G3DSA:3.30.230.10:FF:000195', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(80194, NULL, 'G3DSA:3.30.230.10:FF:000307', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80195, NULL, 'G3DSA:2.60.40.60:FF:001129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80196, NULL, 'G3DSA:1.20.1070.10:FF:002057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80197, NULL, 'G3DSA:1.25.40.10:FF:003132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80198, NULL, 'G3DSA:3.30.70.270:FF:000095', NULL, NULL, 'Bifunctional diguanylate cyclase/phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(80199, NULL, 'G3DSA:3.30.230.70:FF:000174', NULL, NULL, 'Exosome component 6', NULL, NULL, NULL, NULL, NULL, 4),
(80200, NULL, 'G3DSA:2.60.40.1510:FF:000057', NULL, NULL, 'Integrin, beta 5', NULL, NULL, NULL, NULL, NULL, 4),
(80201, NULL, 'G3DSA:1.25.10.10:FF:000932', NULL, NULL, 'Nipped-B protein', NULL, NULL, NULL, NULL, NULL, 4),
(80202, NULL, 'G3DSA:1.10.150.910:FF:000002', NULL, NULL, 'Splicing factor 3B subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(80203, NULL, 'G3DSA:3.30.160.60:FF:003161', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80204, NULL, 'G3DSA:2.130.10.10:FF:004914', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80205, NULL, 'G3DSA:2.60.34.10:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80206, NULL, 'G3DSA:3.40.1410.10:FF:000021', NULL, NULL, 'Phosphonate metabolism transcriptional regulator PhnF', NULL, NULL, NULL, NULL, NULL, 4),
(80207, NULL, 'G3DSA:3.20.20.80:FF:000004', NULL, NULL, 'Beta-glucosidase 6-phospho-beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(80208, NULL, 'G3DSA:1.20.1560.10:FF:000532', NULL, NULL, 'Related to multidrug resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(80209, NULL, 'G3DSA:1.10.3370.10:FF:000003', NULL, NULL, 'Preprotein translocase subunit SECY, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(80210, NULL, 'G3DSA:2.60.40.150:FF:000449', NULL, NULL, 'Synaptotagmin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80211, NULL, 'G3DSA:3.50.50.60:FF:000358', NULL, NULL, 'Irc15p', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(80212, NULL, 'G3DSA:1.10.418.10:FF:000273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80213, NULL, 'G3DSA:3.30.40.10:FF:001895', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80214, NULL, 'G3DSA:1.25.40.10:FF:000198', NULL, NULL, 'E3 ubiquitin-protein ligase CHIP isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(80215, NULL, 'G3DSA:1.25.10.10:FF:002478', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80216, NULL, 'G3DSA:3.30.960.10:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80217, NULL, 'G3DSA:3.80.10.10:FF:003785', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80218, NULL, 'G3DSA:3.10.129.10:FF:000161', NULL, NULL, 'Acyl-CoA thioesterase FadM', NULL, NULL, NULL, NULL, NULL, 4),
(80219, NULL, 'G3DSA:1.10.565.10:FF:000102', NULL, NULL, 'Nuclear receptor subfamily 5, group A, member 1b', NULL, NULL, NULL, NULL, NULL, 4),
(80220, NULL, 'G3DSA:1.20.1070.10:FF:000921', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80221, NULL, 'G3DSA:1.10.150.20:FF:000209', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(80222, NULL, 'G3DSA:4.10.110.20:FF:000004', NULL, NULL, 'Variant surface glycoprotein (VSG, atypical), putative', NULL, NULL, NULL, NULL, NULL, 4),
(80223, NULL, 'G3DSA:1.25.40.10:FF:000861', NULL, NULL, 'BnaA05g13750D protein', NULL, NULL, NULL, NULL, NULL, 4),
(80224, NULL, 'G3DSA:3.80.10.10:FF:000132', NULL, NULL, 'Leiomodin 2', NULL, NULL, NULL, NULL, NULL, 4),
(80225, NULL, 'G3DSA:1.10.8.100:FF:000035', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(80226, NULL, 'G3DSA:1.25.40.10:FF:002968', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80227, NULL, 'G3DSA:3.40.309.10:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80228, NULL, 'G3DSA:2.40.50.140:FF:000907', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80229, NULL, 'G3DSA:1.20.120.1080:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80230, NULL, 'G3DSA:3.30.200.60:FF:000017', NULL, NULL, 'Os08g0537800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(80231, NULL, 'G3DSA:3.30.710.10:FF:000081', NULL, NULL, 'zinc finger and BTB domain-containing protein 38', NULL, NULL, NULL, NULL, NULL, 4),
(80232, NULL, 'G3DSA:3.30.160.60:FF:001570', NULL, NULL, 'zinc finger protein 566 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(80233, NULL, 'G3DSA:3.40.1800.20:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80234, NULL, 'G3DSA:3.40.50.720:FF:002247', NULL, NULL, 'Dihydropteridine reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80235, NULL, 'G3DSA:1.10.2000.10:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80236, NULL, 'G3DSA:3.100.10.10:FF:000067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80237, NULL, 'G3DSA:3.30.160.190:FF:000006', NULL, NULL, 'NADH dehydrogenase [ubiquinone] iron-sulfur protein 4, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(80238, NULL, 'G3DSA:3.80.10.10:FF:000441', NULL, NULL, 'Platelet glycoprotein Ib beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(80239, NULL, 'G3DSA:3.40.50.300:FF:003105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80240, NULL, 'G3DSA:3.40.605.10:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80241, NULL, 'G3DSA:3.30.200.40:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80242, NULL, 'G3DSA:3.80.10.10:FF:000811', NULL, NULL, 'Si:ch211-196h24.1', NULL, NULL, NULL, NULL, NULL, 4),
(80243, NULL, 'G3DSA:3.50.50.60:FF:000257', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(80244, NULL, 'G3DSA:1.10.287.1700:FF:000003', NULL, NULL, 'Trichohyalin', NULL, NULL, NULL, NULL, NULL, 4),
(80245, NULL, 'G3DSA:2.120.10.80:FF:000254', NULL, NULL, 'Kel1p', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(80246, NULL, 'G3DSA:3.30.40.10:FF:000366', NULL, NULL, 'E3 ubiquitin-protein ligase ATL4', NULL, NULL, NULL, NULL, NULL, 4),
(80247, NULL, 'G3DSA:3.40.50.1820:FF:000417', NULL, NULL, 'Epoxide hydrolase B', NULL, NULL, NULL, NULL, NULL, 4),
(80248, NULL, 'G3DSA:3.40.50.300:FF:006966', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80249, NULL, 'G3DSA:1.10.150.20:FF:000198', NULL, NULL, 'DNA polymerase nu', NULL, NULL, NULL, NULL, NULL, 4),
(80250, NULL, 'G3DSA:2.170.120.12:FF:000008', NULL, NULL, 'DNA-directed RNA polymerase II subunit RPB3', NULL, NULL, NULL, NULL, NULL, 4),
(80251, NULL, 'G3DSA:3.40.50.150:FF:000946', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80252, NULL, 'G3DSA:2.60.120.20:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80253, NULL, 'G3DSA:2.60.40.10:FF:004667', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80254, NULL, 'G3DSA:3.30.70.270:FF:000196', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80255, NULL, 'G3DSA:2.30.29.30:FF:000522', NULL, NULL, 'GTPase-activating protein pac-1', NULL, NULL, NULL, NULL, NULL, 4),
(80256, NULL, 'G3DSA:1.20.140.150:FF:000079', NULL, NULL, 'Amastin surface glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(80257, NULL, 'G3DSA:3.40.350.10:FF:000090', NULL, NULL, 'Aminopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80258, NULL, 'G3DSA:3.40.30.10:FF:001096', NULL, NULL, 'Phospholipase A2', NULL, NULL, NULL, NULL, NULL, 4),
(80259, NULL, 'G3DSA:2.60.200.40:FF:000042', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(80260, NULL, 'G3DSA:1.20.1260.10:FF:000048', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(80261, NULL, 'G3DSA:3.30.2050.10:FF:000001', NULL, NULL, 'Oxygen-evolving enhancer protein 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(80262, NULL, 'G3DSA:3.60.140.10:FF:000018', NULL, NULL, 'laccase domain-containing protein 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(80263, NULL, 'G3DSA:3.30.465.10:FF:000105', NULL, NULL, 'Glycolate oxidase glcE subunit. (GlcE)', NULL, NULL, NULL, NULL, NULL, 4),
(80264, NULL, 'G3DSA:3.30.160.60:FF:004695', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80265, NULL, 'G3DSA:1.10.300.10:FF:000005', NULL, NULL, 'Adenylosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(80266, NULL, 'G3DSA:1.10.1200.80:FF:000006', NULL, NULL, 'tRNA-dihydrouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(80267, NULL, 'G3DSA:1.20.1720.10:FF:000067', NULL, NULL, 'Major facilitator superfamily MFS_1', NULL, NULL, NULL, NULL, NULL, 4),
(80268, NULL, 'G3DSA:3.60.40.10:FF:000123', NULL, NULL, 'Protein phosphatase 2C homolog 7, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(80269, NULL, 'G3DSA:3.30.70.270:FF:000207', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80270, NULL, 'G3DSA:3.30.40.10:FF:000057', NULL, NULL, '1-phosphatidylinositol 3-phosphate 5-kinase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(80271, NULL, 'G3DSA:3.90.550.10:FF:000588', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80272, NULL, 'G3DSA:3.30.160.60:FF:005622', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80273, NULL, 'G3DSA:1.10.287.70:FF:000119', NULL, NULL, 'Potassium channel subfamily K member', NULL, NULL, NULL, NULL, NULL, 4),
(80274, NULL, 'G3DSA:3.40.850.10:FF:000554', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80275, NULL, 'G3DSA:3.40.50.300:FF:003414', NULL, NULL, 'Armitage, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(80276, NULL, 'G3DSA:1.10.1170.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80277, NULL, 'G3DSA:3.40.50.300:FF:006848', NULL, NULL, 'Uncharacterized MCM-type protein MJECL13', NULL, NULL, NULL, NULL, NULL, 4),
(80278, NULL, 'G3DSA:3.30.420.10:FF:000541', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80279, NULL, 'G3DSA:4.10.1000.10:FF:000046', NULL, NULL, 'Pre-mRNA-splicing factor CWC24', NULL, NULL, NULL, NULL, NULL, 4),
(80280, NULL, 'G3DSA:2.60.120.230:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(80281, NULL, 'G3DSA:3.30.70.330:FF:002389', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80282, NULL, 'G3DSA:2.60.40.150:FF:000657', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80283, NULL, 'G3DSA:2.60.40.10:FF:003582', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80284, NULL, 'G3DSA:3.40.50.620:FF:000519', NULL, NULL, 'Valine--tRNA ligase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(80285, NULL, 'G3DSA:3.40.50.300:FF:008557', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80286, NULL, 'G3DSA:3.30.200.20:FF:002388', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80287, NULL, 'G3DSA:2.60.98.20:FF:000008', NULL, NULL, 'Flagellar hook protein FlgE', NULL, NULL, NULL, NULL, NULL, 4),
(80288, NULL, 'G3DSA:3.40.50.10490:FF:000016', NULL, NULL, 'Glucose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(80289, NULL, 'G3DSA:1.20.1250.20:FF:000225', NULL, NULL, 'Solute carrier family 19 member 1', NULL, NULL, NULL, NULL, NULL, 4),
(80290, NULL, 'G3DSA:3.40.190.10:FF:000099', NULL, NULL, 'DNA-binding transcriptional regulator DsdC', NULL, NULL, NULL, NULL, NULL, 4),
(80291, NULL, 'G3DSA:3.40.50.720:FF:000139', NULL, NULL, 'UDP-N-acetyl-D-mannosamine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(80292, NULL, 'G3DSA:1.10.1390.10:FF:000004', NULL, NULL, 'Glucose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(80293, NULL, 'G3DSA:3.40.50.2300:FF:000197', NULL, NULL, 'Branched-chain amino acid ABC transporter, substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(80294, NULL, 'G3DSA:1.25.40.10:FF:000760', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g27460', NULL, NULL, NULL, NULL, NULL, 4),
(80295, NULL, 'G3DSA:3.40.1120.10:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80296, NULL, 'G3DSA:3.40.50.720:FF:000095', NULL, NULL, 'NADP-dependent malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(80297, NULL, 'G3DSA:1.25.40.20:FF:001027', NULL, NULL, 'Putative ankyrin repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(80298, NULL, 'G3DSA:2.60.98.10:FF:000005', NULL, NULL, 'Envelope glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(80299, NULL, 'G3DSA:3.60.60.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80300, NULL, 'G3DSA:3.40.50.10480:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80301, NULL, 'G3DSA:1.25.40.10:FF:001024', NULL, NULL, 'Hypothetical alanine rich protein', NULL, NULL, NULL, NULL, NULL, 4),
(80302, NULL, 'G3DSA:3.30.160.60:FF:001227', NULL, NULL, 'Zinc finger and BTB domain containing 41', NULL, NULL, NULL, NULL, NULL, 4),
(80303, NULL, 'G3DSA:2.130.10.10:FF:005033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80304, NULL, 'G3DSA:1.20.5.1160:FF:000017', NULL, NULL, 'SYNM isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(80305, NULL, 'G3DSA:3.30.40.10:FF:000821', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(80306, NULL, 'G3DSA:3.40.1620.60:FF:000012', NULL, NULL, 'Stall, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(80307, NULL, 'G3DSA:3.30.40.10:FF:000467', NULL, NULL, 'C-terminal zinc-finger', NULL, NULL, NULL, NULL, NULL, 4),
(80308, NULL, 'G3DSA:3.90.190.10:FF:000150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80309, NULL, 'G3DSA:2.30.230.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80310, NULL, 'G3DSA:1.20.1560.10:FF:000324', NULL, NULL, 'ATP-binding cassette protein subfamily D, member 1', NULL, NULL, NULL, NULL, NULL, 4),
(80311, NULL, 'G3DSA:3.30.565.10:FF:000377', NULL, NULL, 'Sensor histidine kinase, GAF domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(80312, NULL, 'G3DSA:2.130.10.10:FF:003133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80313, NULL, 'G3DSA:2.10.110.10:FF:000195', NULL, NULL, 'Paxillin homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(80314, NULL, 'G3DSA:1.20.900.10:FF:000043', NULL, NULL, 'ALS2 C-terminal like', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(80315, NULL, 'G3DSA:1.10.418.40:FF:000023', NULL, NULL, 'Beclin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(80316, NULL, 'G3DSA:3.90.1150.10:FF:000118', NULL, NULL, 'Serine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(80317, NULL, 'G3DSA:1.10.2000.10:FF:000009', NULL, NULL, 'Muscle, skeletal, receptor tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(80318, NULL, 'G3DSA:3.30.70.3490:FF:000062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80319, NULL, 'G3DSA:3.30.160.60:FF:002907', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80320, NULL, 'G3DSA:3.30.70.330:FF:000692', NULL, NULL, 'RNA binding motif protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(80321, NULL, 'G3DSA:1.10.510.10:FF:002786', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80322, NULL, 'G3DSA:3.80.10.10:FF:004302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80323, NULL, 'G3DSA:1.20.1250.20:FF:002125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80324, NULL, 'G3DSA:3.40.50.11500:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80325, NULL, 'G3DSA:3.40.50.300:FF:006657', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80326, NULL, 'G3DSA:3.30.450.60:FF:000035', NULL, NULL, 'Signal recognition particle (SRP) subunit', NULL, NULL, NULL, NULL, NULL, 4),
(80327, NULL, 'G3DSA:3.10.20.90:FF:001019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80328, NULL, 'G3DSA:3.30.420.240:FF:000003', NULL, NULL, 'Terminase, large subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80329, NULL, 'G3DSA:1.10.10.750:FF:000014', NULL, NULL, 'Growth hormone-regulated TBC protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(80330, NULL, 'G3DSA:3.90.1150.10:FF:000461', NULL, NULL, 'Aminotransferase, class I', NULL, NULL, NULL, NULL, NULL, 4),
(80331, NULL, 'G3DSA:3.40.50.410:FF:000018', NULL, NULL, 'Matrilin 1', NULL, NULL, NULL, NULL, NULL, 4),
(80332, NULL, 'G3DSA:3.40.50.720:FF:002039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80333, NULL, 'G3DSA:1.10.490.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80334, NULL, 'G3DSA:3.10.350.10:FF:000006', NULL, NULL, 'YgeR family lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(80335, NULL, 'G3DSA:3.90.226.10:FF:000099', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(80336, NULL, 'G3DSA:3.40.50.1820:FF:000047', NULL, NULL, 'protein NDRG3 isoform X8', NULL, NULL, NULL, NULL, NULL, 4),
(80337, NULL, 'G3DSA:3.30.300.30:FF:000072', NULL, NULL, 'Nonribosomal peptide synthase SidD', NULL, NULL, NULL, NULL, NULL, 4),
(80338, NULL, 'G3DSA:3.90.1150.10:FF:000219', NULL, NULL, 'Ornithine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(80339, NULL, 'G3DSA:3.90.1520.10:FF:000017', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80340, NULL, 'G3DSA:1.10.760.10:FF:000028', NULL, NULL, 'Cytochrome c-550 PedF', NULL, NULL, NULL, NULL, NULL, 4),
(80341, NULL, 'G3DSA:3.30.200.20:FF:001505', NULL, NULL, 'Calcium-dependent protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(80342, NULL, 'G3DSA:1.10.10.10:FF:000752', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(80343, NULL, 'G3DSA:3.80.20.20:FF:000079', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(80344, NULL, 'G3DSA:3.30.980.10:FF:000010', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(80345, NULL, 'G3DSA:1.10.287.70:FF:000221', NULL, NULL, 'Potassium voltage-gated channel subfamily Q member 5', NULL, NULL, NULL, NULL, NULL, 4),
(80346, NULL, 'G3DSA:2.130.10.10:FF:003234', NULL, NULL, 'Protein CFT1', NULL, NULL, NULL, NULL, NULL, 4),
(80347, NULL, 'G3DSA:3.30.420.40:FF:000668', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80348, NULL, 'G3DSA:3.40.50.12780:FF:000203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80349, NULL, 'G3DSA:3.30.70.2110:FF:000002', NULL, NULL, 'Penicillin-binding protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(80350, NULL, 'G3DSA:2.130.10.10:FF:001334', NULL, NULL, 'Restriction of telomere capping protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(80351, NULL, 'G3DSA:2.40.50.140:FF:000806', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80352, NULL, 'G3DSA:1.10.287.70:FF:000075', NULL, NULL, 'Cytochrome c oxidase subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(80353, NULL, 'G3DSA:3.90.930.12:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80354, NULL, 'G3DSA:1.10.630.10:FF:000333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80355, NULL, 'G3DSA:3.40.50.2000:FF:000135', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(80356, NULL, 'G3DSA:3.50.30.30:FF:000140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80357, NULL, 'G3DSA:3.30.230.10:FF:000206', NULL, NULL, 'Archaeal serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(80358, NULL, 'G3DSA:3.30.750.24:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80359, NULL, 'G3DSA:2.70.70.10:FF:000037', NULL, NULL, 'M23 peptidase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(80360, NULL, 'G3DSA:3.80.10.10:FF:001885', NULL, NULL, 'Si:ch211-11p18.6', NULL, NULL, NULL, NULL, NULL, 4),
(80361, NULL, 'G3DSA:3.50.50.60:FF:000919', NULL, NULL, 'NADPH-Fe(3+) oxidoreductase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(80362, NULL, 'G3DSA:3.40.30.10:FF:001208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80363, NULL, 'G3DSA:3.30.430.20:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80364, NULL, 'G3DSA:3.30.565.10:FF:000478', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(80365, NULL, 'G3DSA:3.20.10.10:FF:000050', NULL, NULL, 'Aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(80366, NULL, 'G3DSA:2.60.120.20:FF:000030', NULL, NULL, 'RNA2 polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(80367, NULL, 'G3DSA:3.80.10.10:FF:003684', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80368, NULL, 'G3DSA:2.60.40.2170:FF:000007', NULL, NULL, 'Tyrosine-protein kinase RYK', NULL, NULL, NULL, NULL, NULL, 4),
(80369, NULL, 'G3DSA:1.10.1080.10:FF:000003', NULL, NULL, 'Glutathione synthetase, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(80370, NULL, 'G3DSA:1.10.510.10:FF:003404', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80371, NULL, 'G3DSA:6.20.10.30:FF:000009', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(80372, NULL, 'G3DSA:2.30.30.100:FF:000080', NULL, NULL, 'Small nuclear ribonucleoprotein Sm-F, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80373, NULL, 'G3DSA:3.40.50.150:FF:001761', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80374, NULL, 'G3DSA:3.60.20.10:FF:000015', NULL, NULL, 'Proteasome subunit alpha type-5', NULL, NULL, NULL, NULL, NULL, 4),
(80375, NULL, 'G3DSA:3.40.30.10:FF:000331', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(80376, NULL, 'G3DSA:1.25.10.10:FF:002169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80377, NULL, 'G3DSA:3.40.850.10:FF:000453', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80378, NULL, 'G3DSA:3.10.129.10:FF:000267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80379, NULL, 'G3DSA:1.20.1250.20:FF:000326', NULL, NULL, 'Solute carrier family 16 member 6', NULL, NULL, NULL, NULL, NULL, 4),
(80380, NULL, 'G3DSA:3.90.640.10:FF:000050', NULL, NULL, 'Actin, cytoskeletal 3', NULL, NULL, NULL, NULL, NULL, 4),
(80381, NULL, 'G3DSA:2.60.40.1400:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80382, NULL, 'G3DSA:3.30.200.20:FF:000679', NULL, NULL, 'CMGC/MAPK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(80383, NULL, 'G3DSA:1.25.40.280:FF:000010', NULL, NULL, 'Programmed cell death 6-interacting protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80384, NULL, 'G3DSA:1.10.510.10:FF:000987', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(80385, NULL, 'G3DSA:2.60.40.2160:FF:000004', NULL, NULL, 'Interleukin 17 receptor A2', NULL, NULL, NULL, NULL, NULL, 4),
(80386, NULL, 'G3DSA:1.20.1560.10:FF:000223', NULL, NULL, 'ATP-dependent bile acid transporter, variant', NULL, NULL, NULL, NULL, NULL, 4),
(80387, NULL, 'G3DSA:1.10.10.10:FF:001224', NULL, NULL, 'Replication protein A, subunit RPA32', NULL, NULL, NULL, NULL, NULL, 4),
(80388, NULL, 'G3DSA:3.40.50.300:FF:004858', NULL, NULL, 'Helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80389, NULL, 'G3DSA:1.20.58.1880:FF:000025', NULL, NULL, 'REST corepressor 3', NULL, NULL, NULL, NULL, NULL, 4),
(80390, NULL, 'G3DSA:3.30.160.20:FF:000080', NULL, NULL, '30s ribosomal protein s5', NULL, NULL, NULL, NULL, NULL, 4),
(80391, NULL, 'G3DSA:3.80.10.10:FF:004038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80392, NULL, 'G3DSA:3.40.50.720:FF:001994', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80393, NULL, 'G3DSA:1.25.40.10:FF:002558', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(80394, NULL, 'G3DSA:3.40.50.2300:FF:000343', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80395, NULL, 'G3DSA:1.20.1540.10:FF:000115', NULL, NULL, 'Uncharacterized rhomboid protein P4H10.10, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(80396, NULL, 'G3DSA:1.10.10.1210:FF:000001', NULL, NULL, 'melanoma-associated antigen D1', NULL, NULL, NULL, NULL, NULL, 4),
(80397, NULL, 'G3DSA:1.20.58.1040:FF:000009', NULL, NULL, 'Glucan endo-1,3-beta-glucosidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(80398, NULL, 'G3DSA:3.30.70.2850:FF:000010', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(80399, NULL, 'G3DSA:3.30.450.20:FF:000181', NULL, NULL, 'Probable diguanylate cyclase DgcE', NULL, NULL, NULL, NULL, NULL, 4),
(80400, NULL, 'G3DSA:3.30.160.60:FF:005830', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80401, NULL, 'G3DSA:3.30.160.60:FF:003267', NULL, NULL, 'PR/SET domain 14', NULL, NULL, NULL, NULL, NULL, 4),
(80402, NULL, 'G3DSA:2.30.42.10:FF:000154', NULL, NULL, 'T cell lymphoma invasion and metastasis 1', NULL, NULL, NULL, NULL, NULL, 4),
(80403, NULL, 'G3DSA:1.20.58.1030:FF:000006', NULL, NULL, 'DNA replication complex GINS protein SLD5', NULL, NULL, NULL, NULL, NULL, 4),
(80404, NULL, 'G3DSA:2.30.29.30:FF:000286', NULL, NULL, 'PH-protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(80405, NULL, 'G3DSA:2.40.37.10:FF:000079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80406, NULL, 'G3DSA:3.30.780.10:FF:000045', NULL, NULL, 'Putative translation initiation factor SUI1', NULL, NULL, NULL, NULL, NULL, 4),
(80407, NULL, 'G3DSA:3.30.1520.10:FF:000172', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(80408, NULL, 'G3DSA:3.30.200.20:FF:000472', NULL, NULL, 'NIMA related kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(80409, NULL, 'G3DSA:1.25.40.10:FF:004458', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80410, NULL, 'G3DSA:1.10.238.10:FF:000837', NULL, NULL, 'Calcium uptake protein 1 homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(80411, NULL, 'G3DSA:1.20.950.20:FF:000004', NULL, NULL, 'Thiosulfate reductase cytochrome B subunit', NULL, NULL, NULL, NULL, NULL, 4),
(80412, NULL, 'G3DSA:1.20.58.1020:FF:000003', NULL, NULL, 'DNA replication complex GINS protein PSF2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80413, NULL, 'G3DSA:1.25.40.10:FF:001114', NULL, NULL, 'TPR repeat-containing protein associated with Hsp90', NULL, NULL, NULL, NULL, NULL, 4),
(80414, NULL, 'G3DSA:3.40.50.10190:FF:000241', NULL, NULL, 'nibrin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(80415, NULL, 'G3DSA:3.40.50.720:FF:000550', NULL, NULL, 'AmphB polyketide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(80416, NULL, 'G3DSA:1.10.150.20:FF:000097', NULL, NULL, 'Meiotic recombinase Dmc1', NULL, NULL, NULL, NULL, NULL, 4),
(80417, NULL, 'G3DSA:1.20.58.200:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(80418, NULL, 'G3DSA:3.30.450.40:FF:000187', NULL, NULL, 'GAF sensor signal transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(80419, NULL, 'G3DSA:3.30.1370.50:FF:000008', NULL, NULL, 'Protein similar to JAG protein', NULL, NULL, NULL, NULL, NULL, 4),
(80420, NULL, 'G3DSA:3.30.160.60:FF:005167', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80421, NULL, 'G3DSA:2.60.40.10:FF:000968', NULL, NULL, 'MHC class II H2-M beta 2 chain', NULL, NULL, NULL, NULL, NULL, 4),
(80422, NULL, 'G3DSA:3.80.10.10:FF:002150', NULL, NULL, 'Fasciated ear3', NULL, NULL, NULL, NULL, NULL, 4),
(80423, NULL, 'G3DSA:2.40.128.130:FF:000001', NULL, NULL, 'Antigen 43 AG43', NULL, NULL, NULL, NULL, NULL, 4),
(80424, NULL, 'G3DSA:2.60.40.60:FF:001023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80425, NULL, 'G3DSA:3.40.50.300:FF:001059', NULL, NULL, 'ATP-dependent RNA helicase DDX24', NULL, NULL, NULL, NULL, NULL, 4),
(80426, NULL, 'G3DSA:3.30.70.330:FF:000944', NULL, NULL, 'Os04g0682400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(80427, NULL, 'G3DSA:3.40.50.720:FF:000241', NULL, NULL, 'ketimine reductase mu-crystallin', NULL, NULL, NULL, NULL, NULL, 4),
(80428, NULL, 'G3DSA:3.50.50.60:FF:000712', NULL, NULL, 'Related to dimethylaniline monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(80429, NULL, 'G3DSA:1.20.1050.130:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80430, NULL, 'G3DSA:1.20.58.860:FF:000007', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase BAP1', NULL, NULL, NULL, NULL, NULL, 4),
(80431, NULL, 'G3DSA:3.30.160.60:FF:005521', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80432, NULL, 'G3DSA:4.10.400.10:FF:000203', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(80433, NULL, 'G3DSA:3.60.40.10:FF:000224', NULL, NULL, 'Sll1365 protein', NULL, NULL, NULL, NULL, NULL, 4),
(80434, NULL, 'G3DSA:2.10.230.10:FF:000012', NULL, NULL, 'Chaperone protein dnaJ 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(80435, NULL, 'G3DSA:3.30.200.20:FF:000781', NULL, NULL, 'Protein CBG18552', NULL, NULL, NULL, NULL, NULL, 4),
(80436, NULL, 'G3DSA:3.30.1680.30:FF:000003', NULL, NULL, 'Variant surface glycoprotein (VSG), putative', NULL, NULL, NULL, NULL, NULL, 4),
(80437, NULL, 'G3DSA:1.10.3080.10:FF:000020', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(80438, NULL, 'G3DSA:1.20.58.60:FF:000185', NULL, NULL, 'Dystonin', NULL, NULL, NULL, NULL, NULL, 4),
(80439, NULL, 'G3DSA:2.40.10.10:FF:000658', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80440, NULL, 'G3DSA:3.90.1170.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80441, NULL, 'G3DSA:2.60.40.10:FF:002559', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(80442, NULL, 'G3DSA:1.10.565.10:FF:000001', NULL, NULL, 'Retinoic acid receptor beta isoform', NULL, NULL, NULL, NULL, NULL, 4),
(80443, NULL, 'G3DSA:3.90.930.40:FF:000002', NULL, NULL, 'Ribosomal oxygenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(80444, NULL, 'G3DSA:1.20.1070.10:FF:000820', NULL, NULL, 'C-C chemokine receptor type 10', NULL, NULL, NULL, NULL, NULL, 4),
(80445, NULL, 'G3DSA:1.25.10.10:FF:001084', NULL, NULL, 'Putative APC1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(80446, NULL, 'G3DSA:2.40.50.140:FF:001060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80447, NULL, 'G3DSA:3.30.2350.10:FF:000029', NULL, NULL, 'TruB pseudouridine synthase family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(80448, NULL, 'G3DSA:1.10.150.50:FF:000050', NULL, NULL, 'SAM pointed domain containing ETS transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(80449, NULL, 'G3DSA:1.25.40.20:FF:001336', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80450, NULL, 'G3DSA:1.10.555.10:FF:000130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80451, NULL, 'G3DSA:1.10.510.10:FF:001033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80452, NULL, 'G3DSA:1.10.238.20:FF:000008', NULL, NULL, 'D7-related 4 protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(80453, NULL, 'G3DSA:2.20.100.10:FF:000006', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 1', NULL, NULL, NULL, NULL, NULL, 4),
(80454, NULL, 'G3DSA:3.40.50.1000:FF:000498', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(80455, NULL, 'G3DSA:3.80.10.10:FF:004257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80456, NULL, 'G3DSA:1.25.40.10:FF:002867', NULL, NULL, 'Signal recognition particle subunit SRP72', NULL, NULL, NULL, NULL, NULL, 4),
(80457, NULL, 'G3DSA:3.40.50.2300:FF:000652', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(80458, NULL, 'G3DSA:3.80.10.10:FF:002357', NULL, NULL, 'Podocan-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(80459, NULL, 'G3DSA:3.30.450.20:FF:000490', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(80460, NULL, 'G3DSA:1.10.150.60:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80461, NULL, 'G3DSA:3.30.310.80:FF:000008', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(80462, NULL, 'G3DSA:3.30.1360.180:FF:000002', NULL, NULL, 'Alkaline-phosphatase-like family protein', NULL, NULL, NULL, NULL, NULL, 4),
(80463, NULL, 'G3DSA:1.20.5.110:FF:000204', NULL, NULL, 'EhSyntaxin 16', NULL, NULL, NULL, NULL, NULL, 4),
(80464, NULL, 'G3DSA:4.10.860.10:FF:000007', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4),
(80465, NULL, 'G3DSA:1.10.287.130:FF:000273', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(80466, NULL, 'G3DSA:3.40.50.410:FF:000120', NULL, NULL, 'Complement factor B', NULL, NULL, NULL, NULL, NULL, 4),
(80467, NULL, 'G3DSA:2.40.50.90:FF:000173', NULL, NULL, 'Tudor domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(80468, NULL, 'G3DSA:1.10.238.10:FF:001080', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(80469, NULL, 'G3DSA:3.90.70.80:FF:000032', NULL, NULL, 'Deubiquitylating with USP/UBP and OTU domains', NULL, NULL, NULL, NULL, NULL, 4),
(80470, NULL, 'G3DSA:1.20.1080.10:FF:000085', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80471, NULL, 'G3DSA:3.40.20.10:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80472, NULL, 'G3DSA:2.130.10.10:FF:004987', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80473, NULL, 'G3DSA:3.30.40.10:FF:001794', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80474, NULL, 'G3DSA:1.25.10.10:FF:003293', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(80475, NULL, 'G3DSA:2.10.25.10:FF:000811', NULL, NULL, 'Vacuolar-sorting receptor 6', NULL, NULL, NULL, NULL, NULL, 4),
(80476, NULL, 'G3DSA:1.25.40.10:FF:004767', NULL, NULL, 'Anaphase-promoting complex subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(80477, NULL, 'G3DSA:3.30.260.10:FF:000034', NULL, NULL, 'T-complex protein 1 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(80478, NULL, 'G3DSA:1.20.1420.30:FF:000045', NULL, NULL, 'Solute carrier family 24 member 4', NULL, NULL, NULL, NULL, NULL, 4),
(80479, NULL, 'G3DSA:3.80.10.10:FF:002048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80480, NULL, 'G3DSA:3.20.20.100:FF:000014', NULL, NULL, 'NAD(P)-linked oxidoreductase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(80481, NULL, 'G3DSA:3.40.50.10090:FF:000003', NULL, NULL, 'uroporphyrinogen-III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(80482, NULL, 'G3DSA:3.40.50.620:FF:000761', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80483, NULL, 'G3DSA:3.30.70.330:FF:002844', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80484, NULL, 'G3DSA:3.30.70.330:FF:002592', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80485, NULL, 'G3DSA:2.70.98.10:FF:000067', NULL, NULL, 'Putative alpha-1,2-mannosidase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(80486, NULL, 'G3DSA:2.60.120.200:FF:000771', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80487, NULL, 'G3DSA:2.130.10.10:FF:004678', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80488, NULL, 'G3DSA:3.40.50.970:FF:000074', NULL, NULL, '2-oxoglutarate dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(80489, NULL, 'G3DSA:3.40.50.720:FF:000802', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(80490, NULL, 'G3DSA:3.30.70.330:FF:000383', NULL, NULL, 'Sex lethal, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(80491, NULL, 'G3DSA:3.40.50.12780:FF:000158', NULL, NULL, 'Nonribosomal peptide synthase nlsA', NULL, NULL, NULL, NULL, NULL, 4),
(80492, NULL, 'G3DSA:1.25.40.10:FF:001333', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(80493, NULL, 'G3DSA:2.60.40.10:FF:000659', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(80494, NULL, 'G3DSA:2.10.70.10:FF:000101', NULL, NULL, 'uncharacterized protein LOC108094628 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(80495, NULL, 'G3DSA:3.30.40.10:FF:000512', NULL, NULL, 'RING finger domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(80496, NULL, 'G3DSA:3.90.340.10:FF:000004', NULL, NULL, 'Nitric oxide synthase, inducible', NULL, NULL, NULL, NULL, NULL, 4),
(80497, NULL, 'G3DSA:3.40.50.10190:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80498, NULL, 'G3DSA:1.20.1250.10:FF:000104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80499, NULL, 'G3DSA:2.30.42.10:FF:000406', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80500, NULL, 'G3DSA:3.40.50.720:FF:002590', NULL, NULL, 'Malate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(80501, NULL, 'G3DSA:1.20.1070.10:FF:000365', NULL, NULL, 'Muscarinic acetylcholine receptor gar-2', NULL, NULL, NULL, NULL, NULL, 4),
(80502, NULL, 'G3DSA:3.10.20.90:FF:000766', NULL, NULL, 'Tyrosine-protein phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(80503, NULL, 'G3DSA:2.170.8.10:FF:000006', NULL, NULL, 'Phosphoenolpyruvate carboxykinase, cytosolic [GTP]', NULL, NULL, NULL, NULL, NULL, 4),
(80504, NULL, 'G3DSA:2.60.40.1130:FF:000010', NULL, NULL, 'AGAP009724-PA', NULL, NULL, NULL, NULL, NULL, 4),
(80505, NULL, 'G3DSA:3.40.50.620:FF:000289', NULL, NULL, 'Valyl-tRNA synthetase, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(80506, NULL, 'G3DSA:1.25.40.370:FF:000003', NULL, NULL, 'Leucine-rich repeat and WD repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(80507, NULL, 'G3DSA:2.20.110.10:FF:000041', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80508, NULL, 'G3DSA:3.30.160.60:FF:003251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80509, NULL, 'G3DSA:1.20.120.560:FF:000001', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type 23', NULL, NULL, NULL, NULL, NULL, 4),
(80510, NULL, 'G3DSA:1.20.1280.290:FF:000018', NULL, NULL, 'Cystinosin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(80511, NULL, 'G3DSA:3.40.50.720:FF:000549', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(80512, NULL, 'G3DSA:2.40.50.140:FF:000823', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80513, NULL, 'G3DSA:1.10.1070.11:FF:000088', NULL, NULL, 'DNA-dependent protein kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(80514, NULL, 'G3DSA:1.10.1740.10:FF:000020', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(80515, NULL, 'G3DSA:1.10.510.10:FF:002668', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80516, NULL, 'G3DSA:1.25.40.10:FF:004666', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(80517, NULL, 'G3DSA:2.60.120.200:FF:000462', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80518, NULL, 'G3DSA:1.10.8.60:FF:000046', NULL, NULL, 'Lon protease homolog 2, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(80519, NULL, 'G3DSA:1.10.10.60:FF:001205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80520, NULL, 'G3DSA:3.40.50.1360:FF:000015', NULL, NULL, 'Hexose-6-phosphate dehydrogenase/glucose 1-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(80521, NULL, 'G3DSA:1.25.40.10:FF:001007', NULL, NULL, 'RNA splicing factor', NULL, NULL, NULL, NULL, NULL, 4),
(80522, NULL, 'G3DSA:3.30.710.10:FF:000209', NULL, NULL, 'AGAP005746-PA', NULL, NULL, NULL, NULL, NULL, 4),
(80523, NULL, 'G3DSA:1.10.630.10:FF:000215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80524, NULL, 'G3DSA:3.60.20.10:FF:000133', NULL, NULL, 'SIS domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(80525, NULL, 'G3DSA:1.10.472.10:FF:000544', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80526, NULL, 'G3DSA:1.20.1250.10:FF:000093', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80527, NULL, 'G3DSA:3.40.50.1010:FF:000124', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80528, NULL, 'G3DSA:3.40.50.1370:FF:000018', NULL, NULL, 'Acetylornithine carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(80529, NULL, 'G3DSA:3.30.200.20:FF:000680', NULL, NULL, 'CMGC/CDK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(80530, NULL, 'G3DSA:1.10.1300.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80531, NULL, 'G3DSA:2.60.40.420:FF:000069', NULL, NULL, 'Early nodulin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(80532, NULL, 'G3DSA:1.20.1270.60:FF:000114', NULL, NULL, 'Formin-binding protein 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(80533, NULL, 'G3DSA:3.40.190.10:FF:000329', NULL, NULL, 'Glycine/betaine ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(80534, NULL, 'G3DSA:4.10.240.10:FF:000112', NULL, NULL, 'ARCA protein', NULL, NULL, NULL, NULL, NULL, 4),
(80535, NULL, 'G3DSA:3.40.50.1820:FF:000833', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80536, NULL, 'G3DSA:3.60.110.10:FF:000073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80537, NULL, 'G3DSA:2.10.25.10:FF:000339', NULL, NULL, 'Crumbs cell polarity complex component 2', NULL, NULL, NULL, NULL, NULL, 4),
(80538, NULL, 'G3DSA:3.60.130.10:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80539, NULL, 'G3DSA:2.60.40.10:FF:005307', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80540, NULL, 'G3DSA:3.20.20.70:FF:000080', NULL, NULL, 'Nicotinamide phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(80541, NULL, 'G3DSA:3.60.10.10:FF:000161', NULL, NULL, 'Endonuclease exonuclease phosphatase domain contain', NULL, NULL, NULL, NULL, NULL, 4),
(80542, NULL, 'G3DSA:3.30.110.10:FF:000006', NULL, NULL, 'Probable translation initiation factor, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(80543, NULL, 'G3DSA:2.60.120.200:FF:000029', NULL, NULL, 'Calsyntenin 2', NULL, NULL, NULL, NULL, NULL, 4),
(80544, NULL, 'G3DSA:1.20.1540.10:FF:000014', NULL, NULL, 'RHOMBOID-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(80545, NULL, 'G3DSA:3.30.559.10:FF:000183', NULL, NULL, 'Putrescine hydroxycinnamoyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(80546, NULL, 'G3DSA:3.90.550.50:FF:000049', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(80547, NULL, 'G3DSA:3.80.10.10:FF:001767', NULL, NULL, 'NACHT, LRR and PYD domains-containing protein 12 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(80548, NULL, 'G3DSA:3.40.50.300:FF:003223', NULL, NULL, 'Eukaryotic elongation factor, selenocysteine-tRNA specific', NULL, NULL, NULL, NULL, NULL, 4),
(80549, NULL, 'G3DSA:3.40.50.2300:FF:001040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80550, NULL, 'G3DSA:3.20.20.80:FF:000083', NULL, NULL, 'Glycogen debranching enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(80551, NULL, 'G3DSA:1.10.1370.10:FF:000020', NULL, NULL, 'Oligopeptidase A', NULL, NULL, NULL, NULL, NULL, 4),
(80552, NULL, 'G3DSA:3.30.110.20:FF:000009', NULL, NULL, 'DNA/RNA-binding protein Alba 2, putative', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(80553, NULL, 'G3DSA:3.30.160.60:FF:003144', NULL, NULL, 'Zinc finger protein 789', NULL, NULL, NULL, NULL, NULL, 4),
(80554, NULL, 'G3DSA:3.30.160.60:FF:005268', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80555, NULL, 'G3DSA:2.130.10.10:FF:003352', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(80556, NULL, 'G3DSA:1.20.1520.10:FF:000007', NULL, NULL, 'Cilia- and flagella-associated protein 36', NULL, NULL, NULL, NULL, NULL, 4),
(80557, NULL, 'G3DSA:3.30.1360.120:FF:000001', NULL, NULL, 'tRNA modification GTPase MnmE', NULL, NULL, NULL, NULL, NULL, 4),
(80558, NULL, 'G3DSA:3.30.70.1730:FF:000005', NULL, NULL, 'Ribosome assembly factor mrt4', NULL, NULL, NULL, NULL, NULL, 4),
(80559, NULL, 'G3DSA:3.30.450.20:FF:000282', NULL, NULL, 'Neuronal PAS domain protein 4a', NULL, NULL, NULL, NULL, NULL, 4),
(80560, NULL, 'G3DSA:1.20.1070.10:FF:001995', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80561, NULL, 'G3DSA:3.30.160.60:FF:004925', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80562, NULL, 'G3DSA:3.30.2130.30:FF:000013', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase K/L', NULL, NULL, NULL, NULL, NULL, 4),
(80563, NULL, 'G3DSA:3.30.70.330:FF:000484', NULL, NULL, 'Multiple RNA-binding domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(80564, NULL, 'G3DSA:3.40.50.2000:FF:000921', NULL, NULL, 'ADP-heptose--lipopolysaccharide heptosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80565, NULL, 'G3DSA:2.60.40.10:FF:003711', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80566, NULL, 'G3DSA:3.40.390.10:FF:000064', NULL, NULL, 'Matrix metalloproteinase-C', NULL, NULL, NULL, NULL, NULL, 4),
(80567, NULL, 'G3DSA:3.30.40.10:FF:002384', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80568, NULL, 'G3DSA:1.20.1740.10:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80569, NULL, 'G3DSA:3.40.50.12780:FF:000057', NULL, NULL, 'Possible long-chain acyl-CoA synthase', NULL, NULL, NULL, NULL, NULL, 4),
(80570, NULL, 'G3DSA:1.20.1730.10:FF:000040', NULL, NULL, 'Sodium/glucose cotransporter slc5a1,2,4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80571, NULL, 'G3DSA:3.50.50.60:FF:000920', NULL, NULL, 'NADPH-Fe(3+) oxidoreductase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(80572, NULL, 'G3DSA:3.40.30.10:FF:000022', NULL, NULL, 'NADH dehydrogenase flavoprotein 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(80573, NULL, 'G3DSA:1.25.10.10:FF:000786', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(80574, NULL, 'G3DSA:1.20.1250.20:FF:002243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80575, NULL, 'G3DSA:1.10.472.10:FF:000651', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80576, NULL, 'G3DSA:1.25.10.10:FF:003113', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80577, NULL, 'G3DSA:3.40.50.300:FF:001076', NULL, NULL, 'ATP-dependent DNA helicase MER3', NULL, NULL, NULL, NULL, NULL, 4),
(80578, NULL, 'G3DSA:3.40.50.300:FF:007236', NULL, NULL, 'GTP-binding nuclear protein Ran', NULL, NULL, NULL, NULL, NULL, 4),
(80579, NULL, 'G3DSA:2.40.50.40:FF:000046', NULL, NULL, 'Chemokine (C-C motif) ligand 39, duplicate 3', NULL, NULL, NULL, NULL, NULL, 4),
(80580, NULL, 'G3DSA:3.20.20.100:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80581, NULL, 'G3DSA:1.20.1070.10:FF:002142', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80582, NULL, 'G3DSA:1.20.1070.10:FF:000904', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80583, NULL, 'G3DSA:1.10.3930.10:FF:000007', NULL, NULL, 'Arginine deiminase', NULL, NULL, NULL, NULL, NULL, 4),
(80584, NULL, 'G3DSA:3.30.450.40:FF:000288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80585, NULL, 'G3DSA:3.40.630.10:FF:000465', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(80586, NULL, 'G3DSA:3.30.160.60:FF:003621', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(80587, NULL, 'G3DSA:3.30.479.30:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80588, NULL, 'G3DSA:1.10.510.10:FF:003713', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80589, NULL, 'G3DSA:3.30.70.1820:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80590, NULL, 'G3DSA:3.30.1360.140:FF:000007', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(80591, NULL, 'G3DSA:1.10.510.10:FF:003820', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80592, NULL, 'G3DSA:1.10.510.10:FF:003034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80593, NULL, 'G3DSA:3.30.160.60:FF:002997', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80594, NULL, 'G3DSA:3.40.20.10:FF:000050', NULL, NULL, 'Villin like', NULL, NULL, NULL, NULL, NULL, 4),
(80595, NULL, 'G3DSA:1.20.1250.20:FF:002350', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80596, NULL, 'G3DSA:3.30.200.20:FF:002169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80597, NULL, 'G3DSA:1.25.10.10:FF:003220', NULL, NULL, 'Putative phosphatidylinositol 3-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(80598, NULL, 'G3DSA:3.30.70.330:FF:002373', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80599, NULL, 'G3DSA:1.10.132.30:FF:000007', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(80600, NULL, 'G3DSA:3.10.580.10:FF:000023', NULL, NULL, 'Acetoin utilization protein AcuB', NULL, NULL, NULL, NULL, NULL, 4),
(80601, NULL, 'G3DSA:1.10.600.10:FF:000067', NULL, NULL, 'Terpentetriene synthase', NULL, NULL, NULL, NULL, NULL, 4),
(80602, NULL, 'G3DSA:4.10.1000.10:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80603, NULL, 'G3DSA:3.30.200.20:FF:002478', NULL, NULL, 'Nerve growth factor receptor TRKA, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80604, NULL, 'G3DSA:3.40.50.10730:FF:000004', NULL, NULL, 'Urocanate hydratase 1', NULL, NULL, NULL, NULL, NULL, 4),
(80605, NULL, 'G3DSA:3.40.50.1820:FF:000726', NULL, NULL, 'Alpha/beta superfamily hydrolase, putative (AFU_orthologue AFUA_2G16580)', NULL, NULL, NULL, NULL, NULL, 4),
(80606, NULL, 'G3DSA:1.20.1270.60:FF:000221', NULL, NULL, 'SH3 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(80607, NULL, 'G3DSA:3.30.420.40:FF:001073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80608, NULL, 'G3DSA:3.40.1740.10:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80609, NULL, 'G3DSA:3.40.50.12430:FF:000003', NULL, NULL, 'GM14826', NULL, NULL, NULL, NULL, NULL, 4),
(80610, NULL, 'G3DSA:2.60.40.10:FF:004476', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80611, NULL, 'G3DSA:2.130.10.10:FF:003043', NULL, NULL, 'Eukaryotic translation initiation factor 2A', NULL, NULL, NULL, NULL, NULL, 4),
(80612, NULL, 'G3DSA:3.40.50.2300:FF:000567', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80613, NULL, 'G3DSA:3.90.190.10:FF:000520', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80614, NULL, 'G3DSA:3.30.40.10:FF:000613', NULL, NULL, 'lysine-specific demethylase 5A', NULL, NULL, NULL, NULL, NULL, 4),
(80615, NULL, 'G3DSA:1.25.40.20:FF:001813', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80616, NULL, 'G3DSA:3.40.50.1820:FF:001598', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80617, NULL, 'G3DSA:3.40.50.1980:FF:000095', NULL, NULL, 'Histidinol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(80618, NULL, 'G3DSA:3.50.7.10:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80619, NULL, 'G3DSA:3.10.10.10:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80620, NULL, 'G3DSA:1.10.10.2030:FF:000005', NULL, NULL, 'Kin17 DNA and RNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(80621, NULL, 'G3DSA:2.30.30.100:FF:000186', NULL, NULL, 'Small nuclear ribonucleoprotein Lsm8, putative (AFU_orthologue AFUA_1G11670)', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(80622, NULL, 'G3DSA:2.60.120.590:FF:000062', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80623, NULL, 'G3DSA:2.60.470.10:FF:000002', NULL, NULL, 'Amiloride-sensitive sodium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(80624, NULL, 'G3DSA:1.10.10.10:FF:000297', NULL, NULL, 'DNA-binding transcriptional activator SdiA', NULL, NULL, NULL, NULL, NULL, 4),
(80625, NULL, 'G3DSA:1.10.510.10:FF:003511', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80626, NULL, 'G3DSA:1.20.5.110:FF:000120', NULL, NULL, 'Vam3p', NULL, NULL, NULL, NULL, NULL, 4),
(80627, NULL, 'G3DSA:3.90.550.20:FF:000040', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80628, NULL, 'G3DSA:1.10.150.20:FF:000327', NULL, NULL, 'Xp-G/rad2 DNA repair endonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80629, NULL, 'G3DSA:1.20.1250.20:FF:002041', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80630, NULL, 'G3DSA:3.30.160.60:FF:003930', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80631, NULL, 'G3DSA:4.10.240.10:FF:000005', NULL, NULL, 'Quinic acid utilization activator', NULL, NULL, NULL, NULL, NULL, 4),
(80632, NULL, 'G3DSA:1.10.510.10:FF:002887', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80633, NULL, 'G3DSA:3.40.50.1220:FF:000108', NULL, NULL, 'Transcriptional regulator, Sir2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(80634, NULL, 'G3DSA:3.30.450.20:FF:000591', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(80635, NULL, 'G3DSA:3.30.1240.10:FF:000026', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(80636, NULL, 'G3DSA:1.25.40.10:FF:004357', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80637, NULL, 'G3DSA:1.25.40.10:FF:004992', NULL, NULL, 'Pentatricopeptide repeat protein PPR868-14', NULL, NULL, NULL, NULL, NULL, 4),
(80638, NULL, 'G3DSA:1.10.220.150:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80639, NULL, 'G3DSA:3.40.50.1000:FF:000397', NULL, NULL, 'GD12369', NULL, NULL, NULL, NULL, NULL, 4),
(80640, NULL, 'G3DSA:1.20.81.30:FF:000005', NULL, NULL, 'Protein transport protein HofC homolog', NULL, NULL, NULL, NULL, NULL, 4),
(80641, NULL, 'G3DSA:3.30.40.10:FF:000248', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM68', NULL, NULL, NULL, NULL, NULL, 4),
(80642, NULL, 'G3DSA:3.30.70.330:FF:000809', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(80643, NULL, 'G3DSA:3.30.160.60:FF:001906', NULL, NULL, 'zinc finger protein 425', NULL, NULL, NULL, NULL, NULL, 4),
(80644, NULL, 'G3DSA:3.40.390.10:FF:000283', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80645, NULL, 'G3DSA:3.30.760.10:FF:000027', NULL, NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(80646, NULL, 'G3DSA:1.20.1050.10:FF:000139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80647, NULL, 'G3DSA:3.50.50.60:FF:001100', NULL, NULL, 'Squalene monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80648, NULL, 'G3DSA:3.50.50.60:FF:000611', NULL, NULL, 'FAD/NAD(P)-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(80649, NULL, 'G3DSA:3.60.20.10:FF:000240', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80650, NULL, 'G3DSA:2.60.40.10:FF:005616', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80651, NULL, 'G3DSA:2.30.42.10:FF:000625', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80652, NULL, 'G3DSA:3.80.10.10:FF:002133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80653, NULL, 'G3DSA:2.40.50.140:FF:000346', NULL, NULL, 'DNA replication licensing factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80654, NULL, 'G3DSA:3.40.50.1820:FF:000507', NULL, NULL, 'Lysophospholipase L2', NULL, NULL, NULL, NULL, NULL, 4),
(80655, NULL, 'G3DSA:1.10.10.10:FF:000836', NULL, NULL, 'O-methyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(80656, NULL, 'G3DSA:3.40.718.10:FF:000039', NULL, NULL, 'NADP-dependent isocitrate dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80657, NULL, 'G3DSA:1.20.1250.20:FF:000096', NULL, NULL, 'Major facilitator family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(80658, NULL, 'G3DSA:3.30.1520.10:FF:000071', NULL, NULL, 'Phox domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(80659, NULL, 'G3DSA:3.30.40.10:FF:000618', NULL, NULL, 'RING zinc finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80660, NULL, 'G3DSA:3.10.200.10:FF:000012', NULL, NULL, 'Carbonic anhydrase 15', NULL, NULL, NULL, NULL, NULL, 4),
(80661, NULL, 'G3DSA:2.30.42.10:FF:000255', NULL, NULL, 'Multiple PDZ domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(80662, NULL, 'G3DSA:3.40.250.10:FF:000115', NULL, NULL, 'Rhodanese-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(80663, NULL, 'G3DSA:3.80.10.10:FF:000351', NULL, NULL, 'malignant fibrous histiocytoma-amplified sequence 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(80664, NULL, 'G3DSA:1.10.510.10:FF:001257', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80665, NULL, 'G3DSA:3.40.190.10:FF:000436', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(80666, NULL, 'G3DSA:1.10.357.140:FF:000023', NULL, NULL, 'Cytochrome c oxidase assembly factor heme A:farnesyltransferase COX10', NULL, NULL, NULL, NULL, NULL, 4),
(80667, NULL, 'G3DSA:1.10.1240.100:FF:000002', NULL, NULL, 'Polyketide synthase RzxD', NULL, NULL, NULL, NULL, NULL, 4),
(80668, NULL, 'G3DSA:1.10.10.650:FF:000001', NULL, NULL, 'S1 RNA-binding domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(80669, NULL, 'G3DSA:3.30.420.10:FF:000232', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(80670, NULL, 'G3DSA:3.80.10.10:FF:003914', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80671, NULL, 'G3DSA:1.25.40.20:FF:000032', NULL, NULL, 'BCL-6 corepressor isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(80672, NULL, 'G3DSA:3.40.50.410:FF:000344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80673, NULL, 'G3DSA:1.10.510.10:FF:002977', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80674, NULL, 'G3DSA:2.60.120.200:FF:000664', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80675, NULL, 'G3DSA:2.40.50.120:FF:000031', NULL, NULL, 'Netrin-A, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(80676, NULL, 'G3DSA:1.10.630.10:FF:000108', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(80677, NULL, 'G3DSA:3.40.50.1820:FF:001828', NULL, NULL, 'Os11g0468300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(80678, NULL, 'G3DSA:3.90.180.10:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80679, NULL, 'G3DSA:3.10.110.10:FF:000359', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80680, NULL, 'G3DSA:1.10.1040.10:FF:000034', NULL, NULL, 'Mannitol-1-phosphate 5-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(80681, NULL, 'G3DSA:3.40.50.720:FF:002157', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80682, NULL, 'G3DSA:1.20.1070.10:FF:001776', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80683, NULL, 'G3DSA:2.60.120.200:FF:000355', NULL, NULL, 'Sex hormone-binding globulin', NULL, NULL, NULL, NULL, NULL, 4),
(80684, NULL, 'G3DSA:2.130.10.10:FF:001109', NULL, NULL, 'Cytoplasmic dynein 1 intermediate chain', NULL, NULL, NULL, NULL, NULL, 4),
(80685, NULL, 'G3DSA:2.60.40.10:FF:001564', NULL, NULL, 'tyrosine-protein phosphatase Lar isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(80686, NULL, 'G3DSA:1.20.1250.20:FF:001877', NULL, NULL, 'Feline leukemia virus subgroup C cellular receptor family, member 2a', NULL, NULL, NULL, NULL, NULL, 4),
(80687, NULL, 'G3DSA:2.60.40.10:FF:001255', NULL, NULL, 'usherin', NULL, NULL, NULL, NULL, NULL, 4),
(80688, NULL, 'G3DSA:3.30.900.10:FF:000016', NULL, NULL, 'Autophagy-related protein 13', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(80689, NULL, 'G3DSA:1.10.860.10:FF:000024', NULL, NULL, 'Replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(80690, NULL, 'G3DSA:3.90.176.10:FF:000015', NULL, NULL, 'NAD(P)(+)--arginine ADP-ribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(80691, NULL, 'G3DSA:1.25.40.10:FF:003250', NULL, NULL, 'Pre-mRNA-splicing factor CLF1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80692, NULL, 'G3DSA:1.10.486.10:FF:000031', NULL, NULL, 'ATP-dependent DNA helicase Rep', NULL, NULL, NULL, NULL, NULL, 4),
(80693, NULL, 'G3DSA:2.40.50.140:FF:000716', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80694, NULL, 'G3DSA:3.40.50.410:FF:000035', NULL, NULL, 'collagen alpha-3(VI) chain isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(80695, NULL, 'G3DSA:1.10.472.80:FF:000143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80696, NULL, 'G3DSA:3.40.50.300:FF:000311', NULL, NULL, 'GTP-binding protein RAD', NULL, NULL, NULL, NULL, NULL, 4),
(80697, NULL, 'G3DSA:3.30.160.60:FF:003470', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80698, NULL, 'G3DSA:3.30.200.20:FF:000926', NULL, NULL, 'Mitogen-activated protein kinase 10', NULL, NULL, NULL, NULL, NULL, 4),
(80699, NULL, 'G3DSA:2.60.40.150:FF:000758', NULL, NULL, 'Otoferlin b', NULL, NULL, NULL, NULL, NULL, 4),
(80700, NULL, 'G3DSA:2.40.70.10:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80701, NULL, 'G3DSA:1.20.900.10:FF:000060', NULL, NULL, 'Rho guanine nucleotide exchange factor osg-1', NULL, NULL, NULL, NULL, NULL, 4),
(80702, NULL, 'G3DSA:1.10.10.10:FF:001016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80703, NULL, 'G3DSA:3.30.230.10:FF:000386', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(80704, NULL, 'G3DSA:1.25.40.20:FF:000982', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80705, NULL, 'G3DSA:2.60.40.1730:FF:000100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80706, NULL, 'G3DSA:1.10.10.10:FF:000853', NULL, NULL, 'ETS-Like transcription Factor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(80707, NULL, 'G3DSA:1.10.150.50:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80708, NULL, 'G3DSA:3.30.40.10:FF:002075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80709, NULL, 'G3DSA:1.50.10.20:FF:000051', NULL, NULL, 'Putative squalene-hopene cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(80710, NULL, 'G3DSA:1.10.150.670:FF:000020', NULL, NULL, 'Nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(80711, NULL, 'G3DSA:3.30.70.330:FF:000265', NULL, NULL, 'nucleolin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(80712, NULL, 'G3DSA:3.30.930.10:FF:000063', NULL, NULL, 'Octanoyltransferase LIP2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(80713, NULL, 'G3DSA:3.40.50.12780:FF:000052', NULL, NULL, 'YOR093C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(80714, NULL, 'G3DSA:3.30.230.10:FF:000279', NULL, NULL, 'Elongation factor Tu GTP binding domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(80715, NULL, 'G3DSA:3.30.200.20:FF:001062', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase PEPR1', NULL, NULL, NULL, NULL, NULL, 4),
(80716, NULL, 'G3DSA:2.10.22.10:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80717, NULL, 'G3DSA:3.30.420.60:FF:000005', NULL, NULL, 'Protein pelota homolog', NULL, NULL, NULL, NULL, NULL, 4),
(80718, NULL, 'G3DSA:2.120.10.80:FF:000355', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80719, NULL, 'G3DSA:2.40.70.10:FF:000398', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80720, NULL, 'G3DSA:3.40.50.2300:FF:000551', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(80721, NULL, 'G3DSA:1.20.5.110:FF:000013', NULL, NULL, 'Vesicle-associated membrane protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(80722, NULL, 'G3DSA:2.130.10.30:FF:000137', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(80723, NULL, 'G3DSA:3.60.120.10:FF:000028', NULL, NULL, 'Isochorismate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(80724, NULL, 'G3DSA:3.10.180.10:FF:000072', NULL, NULL, 'Anthracycline biosynthesis protein DnrV', NULL, NULL, NULL, NULL, NULL, 4),
(80725, NULL, 'G3DSA:3.40.50.2000:FF:000904', NULL, NULL, 'Glycosyl transferase group 1', NULL, NULL, NULL, NULL, NULL, 4),
(80726, NULL, 'G3DSA:3.60.40.10:FF:000016', NULL, NULL, 'Protein phosphatase 2C', NULL, NULL, NULL, NULL, NULL, 4),
(80727, NULL, 'G3DSA:1.25.10.10:FF:001275', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(80728, NULL, 'G3DSA:3.30.160.60:FF:004886', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80729, NULL, 'G3DSA:3.40.250.10:FF:000008', NULL, NULL, 'Sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(80730, NULL, 'G3DSA:3.30.200.20:FF:001404', NULL, NULL, 'Uncharacterized protein CaJ7.0258', NULL, NULL, NULL, NULL, NULL, 4),
(80731, NULL, 'G3DSA:3.40.190.10:FF:000745', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80732, NULL, 'G3DSA:1.20.1250.20:FF:002260', NULL, NULL, 'Solute carrier family 2, facilitated glucose transporter member 3', NULL, NULL, NULL, NULL, NULL, 4),
(80733, NULL, 'G3DSA:3.80.10.10:FF:003875', NULL, NULL, 'Leucine rich repeat containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(80734, NULL, 'G3DSA:1.10.357.140:FF:000028', NULL, NULL, 'UbiA prenyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(80735, NULL, 'G3DSA:3.40.50.720:FF:002466', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80736, NULL, 'G3DSA:1.25.10.10:FF:002949', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80737, NULL, 'G3DSA:2.60.260.20:FF:000085', NULL, NULL, 'Chaperone protein DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(80738, NULL, 'G3DSA:1.25.40.180:FF:000053', NULL, NULL, 'Eukaryotic translation initiation factor 4 gamma 2', NULL, NULL, NULL, NULL, NULL, 4),
(80739, NULL, 'G3DSA:2.160.20.10:FF:000193', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(80740, NULL, 'G3DSA:2.60.120.200:FF:000338', NULL, NULL, 'uncharacterized protein LOC100181198 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(80741, NULL, 'G3DSA:1.25.10.10:FF:000477', NULL, NULL, 'ATR serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(80742, NULL, 'G3DSA:2.60.34.10:FF:000038', NULL, NULL, 'Major heat shock 70 kDa protein Ab-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(80743, NULL, 'G3DSA:3.60.20.10:FF:000094', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(80744, NULL, 'G3DSA:1.10.8.140:FF:000007', NULL, NULL, 'DNA-binding TFAR19-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(80745, NULL, 'G3DSA:3.30.200.20:FF:002506', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80746, NULL, 'G3DSA:3.40.630.10:FF:000139', NULL, NULL, 'Putative zinc carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(80747, NULL, 'G3DSA:2.60.40.10:FF:004583', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80748, NULL, 'G3DSA:3.80.10.10:FF:001969', NULL, NULL, 'Insulin like growth factor binding protein acid labile subunit', NULL, NULL, NULL, NULL, NULL, 4),
(80749, NULL, 'G3DSA:3.30.70.330:FF:000793', NULL, NULL, 'RNA annealing protein YRA2', NULL, NULL, NULL, NULL, NULL, 4),
(80750, NULL, 'G3DSA:1.10.486.10:FF:000014', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(80751, NULL, 'G3DSA:3.90.650.10:FF:000067', NULL, NULL, 'AIR synthase-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(80752, NULL, 'G3DSA:3.30.160.60:FF:001362', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM13', NULL, NULL, NULL, NULL, NULL, 4),
(80753, NULL, 'G3DSA:3.30.160.60:FF:001704', NULL, NULL, 'C2H2 transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80754, NULL, 'G3DSA:3.40.50.620:FF:000328', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(80755, NULL, 'G3DSA:2.120.10.30:FF:000256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(80756, NULL, 'G3DSA:3.40.50.150:FF:001082', NULL, NULL, 'Ubiquinone biosynthesis O-methyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(80757, NULL, 'G3DSA:2.130.10.10:FF:002986', NULL, NULL, 'WD domain', NULL, NULL, NULL, NULL, NULL, 4),
(80758, NULL, 'G3DSA:3.40.50.970:FF:000175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80759, NULL, 'G3DSA:2.10.109.10:FF:000039', NULL, NULL, 'Inner Mitochondrial Membrane Protease', NULL, NULL, NULL, NULL, NULL, 4),
(80760, NULL, 'G3DSA:3.30.40.10:FF:000276', NULL, NULL, 'Receptor homology region transmembrane domain-and RING domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(80761, NULL, 'G3DSA:1.10.400.10:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80762, NULL, 'G3DSA:3.40.190.10:FF:000638', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80763, NULL, 'G3DSA:2.60.120.10:FF:000116', NULL, NULL, 'Cyclic nucleotide-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(80764, NULL, 'G3DSA:3.90.550.10:FF:000020', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(80765, NULL, 'G3DSA:1.25.40.10:FF:003031', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g62890', NULL, NULL, NULL, NULL, NULL, 4),
(80766, NULL, 'G3DSA:1.10.150.20:FF:000288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80767, NULL, 'G3DSA:1.25.40.10:FF:005155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80768, NULL, 'G3DSA:3.30.160.60:FF:001036', NULL, NULL, 'zinc finger protein 606 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(80769, NULL, 'G3DSA:1.25.40.10:FF:002749', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80770, NULL, 'G3DSA:1.20.80.10:FF:000014', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type', NULL, NULL, NULL, NULL, NULL, 4),
(80771, NULL, 'G3DSA:3.80.10.10:FF:002149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80772, NULL, 'G3DSA:3.90.550.20:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80773, NULL, 'G3DSA:1.20.1070.10:FF:000702', NULL, NULL, 'Neuropeptide receptor 22', NULL, NULL, NULL, NULL, NULL, 4),
(80774, NULL, 'G3DSA:1.25.40.470:FF:000033', NULL, NULL, 'Outer segment 5', NULL, NULL, NULL, NULL, NULL, 4),
(80775, NULL, 'G3DSA:1.20.120.1240:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80776, NULL, 'G3DSA:3.30.160.60:FF:005414', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80777, NULL, 'G3DSA:3.40.50.300:FF:004965', NULL, NULL, 'Membrane-associated sulfotransferase kil1', NULL, NULL, NULL, NULL, NULL, 4),
(80778, NULL, 'G3DSA:3.30.1510.10:FF:000019', NULL, NULL, 'C-1-tetrahydrofolate synthase, cytoplasmic-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(80779, NULL, 'G3DSA:2.60.40.60:FF:000949', NULL, NULL, 'AGAP002828-PA', NULL, NULL, NULL, NULL, NULL, 4),
(80780, NULL, 'G3DSA:3.30.70.20:FF:000079', NULL, NULL, 'Pyruvate formate-lyase 3 activating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(80781, NULL, 'G3DSA:1.20.1070.10:FF:000360', NULL, NULL, 'Tyramine receptor Ser-2', NULL, NULL, NULL, NULL, NULL, 4),
(80782, NULL, 'G3DSA:1.20.5.110:FF:000103', NULL, NULL, 'Syntaxin, Qa-SNARE family', NULL, NULL, NULL, NULL, NULL, 4),
(80783, NULL, 'G3DSA:3.20.20.100:FF:000087', NULL, NULL, 'Aldo-keto reductase family 1 member D1', NULL, NULL, NULL, NULL, NULL, 4),
(80784, NULL, 'G3DSA:3.40.50.300:FF:007371', NULL, NULL, 'CoA synthase', NULL, NULL, NULL, NULL, NULL, 4),
(80785, NULL, 'G3DSA:3.30.160.60:FF:004779', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80786, NULL, 'G3DSA:3.40.50.300:FF:005454', NULL, NULL, 'Heme ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(80787, NULL, 'G3DSA:2.60.15.10:FF:000005', NULL, NULL, 'ATP synthase delta', NULL, NULL, NULL, NULL, NULL, 4),
(80788, NULL, 'G3DSA:1.10.287.1770:FF:000007', NULL, NULL, 'Ferrous iron transport protein B', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(80789, NULL, 'G3DSA:1.10.238.220:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80790, NULL, 'G3DSA:3.30.40.10:FF:002182', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(80791, NULL, 'G3DSA:3.30.200.20:FF:000590', NULL, NULL, 'PH-protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(80792, NULL, 'G3DSA:3.50.50.60:FF:001302', NULL, NULL, 'FAD-dependent pyridine nucleotide-disulphide oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(80793, NULL, 'G3DSA:3.40.50.300:FF:007129', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80794, NULL, 'G3DSA:3.30.70.330:FF:002743', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80795, NULL, 'G3DSA:1.10.287.130:FF:000172', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(80796, NULL, 'G3DSA:3.50.50.80:FF:000004', NULL, NULL, 'Ubiquitin-activating enzyme E1-like', NULL, NULL, NULL, NULL, NULL, 4),
(80797, NULL, 'G3DSA:2.60.40.10:FF:001710', NULL, NULL, 'immunoglobulin superfamily member 22', NULL, NULL, NULL, NULL, NULL, 4),
(80798, NULL, 'G3DSA:3.30.450.20:FF:000063', NULL, NULL, 'White collar 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(80799, NULL, 'G3DSA:2.20.100.10:FF:000085', NULL, NULL, 'ADAMTS like 4', NULL, NULL, NULL, NULL, NULL, 4),
(80800, NULL, 'G3DSA:3.30.160.60:FF:005049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80801, NULL, 'G3DSA:1.20.1560.10:FF:000116', NULL, NULL, 'Multidrug ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(80802, NULL, 'G3DSA:3.40.50.2000:FF:000814', NULL, NULL, 'Trehalose-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(80803, NULL, 'G3DSA:3.30.1490.80:FF:000032', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(80804, NULL, 'G3DSA:3.30.160.60:FF:001671', NULL, NULL, 'Zinc finger protein 94', NULL, NULL, NULL, NULL, NULL, 4),
(80805, NULL, 'G3DSA:3.30.450.30:FF:000066', NULL, NULL, 'Roadblock/LC7 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(80806, NULL, 'G3DSA:6.20.10.30:FF:000010', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(80807, NULL, 'G3DSA:2.30.40.10:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80808, NULL, 'G3DSA:3.30.460.10:FF:000015', NULL, NULL, 'Ribosomal silencing factor RsfS', NULL, NULL, NULL, NULL, NULL, 4),
(80809, NULL, 'G3DSA:3.30.160.60:FF:000873', NULL, NULL, 'Zinc finger protein 841', NULL, NULL, NULL, NULL, NULL, 4),
(80810, NULL, 'G3DSA:3.40.190.10:FF:000419', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(80811, NULL, 'G3DSA:1.10.510.10:FF:001712', NULL, NULL, 'Testis associated actin remodelling kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(80812, NULL, 'G3DSA:1.25.40.10:FF:002098', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(80813, NULL, 'G3DSA:3.20.20.100:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80814, NULL, 'G3DSA:3.40.50.1760:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80815, NULL, 'G3DSA:3.40.190.10:FF:000655', NULL, NULL, 'Oligopeptide transport system binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(80816, NULL, 'G3DSA:3.40.50.10140:FF:000041', NULL, NULL, 'Toll-like receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(80817, NULL, 'G3DSA:3.40.50.150:FF:000929', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80818, NULL, 'G3DSA:3.40.33.10:FF:000040', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80819, NULL, 'G3DSA:1.20.1070.10:FF:001978', NULL, NULL, 'Olfactory receptor 51J1', NULL, NULL, NULL, NULL, NULL, 4),
(80820, NULL, 'G3DSA:3.50.50.60:FF:000830', NULL, NULL, 'Putative thioredoxin reductase', NULL, NULL, NULL, NULL, NULL, 4),
(80821, NULL, 'G3DSA:3.80.10.10:FF:000356', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(80822, NULL, 'G3DSA:2.60.40.60:FF:000859', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(80823, NULL, 'G3DSA:3.30.160.60:FF:000041', NULL, NULL, 'Zinc finger protein ZIC 1', NULL, NULL, NULL, NULL, NULL, 4),
(80824, NULL, 'G3DSA:2.60.40.10:FF:004892', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80825, NULL, 'G3DSA:3.40.190.10:FF:000964', NULL, NULL, 'Oligopeptide ABC transporter, solute-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(80826, NULL, 'G3DSA:3.75.10.10:FF:000015', NULL, NULL, '2-nitroimidazole nitrohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(80827, NULL, 'G3DSA:2.130.10.10:FF:001126', NULL, NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', NULL, NULL, NULL, NULL, NULL, 4),
(80828, NULL, 'G3DSA:3.90.1150.10:FF:000326', NULL, NULL, 'Aromatic-amino-acid aminotransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(80829, NULL, 'G3DSA:1.25.40.10:FF:004576', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80830, NULL, 'G3DSA:1.25.40.10:FF:004885', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(80831, NULL, 'G3DSA:3.40.50.1820:FF:000502', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80832, NULL, 'G3DSA:3.30.450.20:FF:000372', NULL, NULL, 'Protein single-minded-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(80833, NULL, 'G3DSA:1.10.275.20:FF:000004', NULL, NULL, 'Yat2p', NULL, NULL, NULL, NULL, NULL, 4),
(80834, NULL, 'G3DSA:3.40.50.300:FF:001306', NULL, NULL, 'Clamp-binding protein CrfC', NULL, NULL, NULL, NULL, NULL, 4),
(80835, NULL, 'G3DSA:1.20.1560.10:FF:000425', NULL, NULL, 'ATP-dependent permease, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80836, NULL, 'G3DSA:3.40.50.300:FF:003077', NULL, NULL, 'Rab family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(80837, NULL, 'G3DSA:2.130.10.10:FF:001435', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(80838, NULL, 'G3DSA:3.10.580.10:FF:000040', NULL, NULL, 'Chloride channel 6', NULL, NULL, NULL, NULL, NULL, 4),
(80839, NULL, 'G3DSA:3.30.46.10:FF:000008', NULL, NULL, 'Glycine N-methyltransferase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(80840, NULL, 'G3DSA:1.10.150.20:FF:000108', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(80841, NULL, 'G3DSA:3.30.40.10:FF:002165', NULL, NULL, 'Structure-specific endonuclease subunit SLX1', NULL, NULL, NULL, NULL, NULL, 4),
(80842, NULL, 'G3DSA:1.25.40.180:FF:000160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80843, NULL, 'G3DSA:2.130.10.10:FF:000946', NULL, NULL, 'WD repeat and HMG-box DNA-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(80844, NULL, 'G3DSA:3.30.460.20:FF:000018', NULL, NULL, 'Magnesium transport protein CorA', NULL, NULL, NULL, NULL, NULL, 4),
(80845, NULL, 'G3DSA:1.10.275.30:FF:000007', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(80846, NULL, 'G3DSA:1.10.630.10:FF:000434', NULL, NULL, 'Cytochrome P450 76A2', NULL, NULL, NULL, NULL, NULL, 4),
(80847, NULL, 'G3DSA:3.40.50.2300:FF:000770', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80848, NULL, 'G3DSA:2.60.40.10:FF:003481', NULL, NULL, 'Titin, tandem duplicate 2', NULL, NULL, NULL, NULL, NULL, 4),
(80849, NULL, 'G3DSA:3.40.50.300:FF:001615', NULL, NULL, 'Replication factor C subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(80850, NULL, 'G3DSA:2.120.10.80:FF:000338', NULL, NULL, 'Flagellar outer dynein arm heavy chain alpha', NULL, NULL, NULL, NULL, NULL, 4),
(80851, NULL, 'G3DSA:3.40.1110.10:FF:000071', NULL, NULL, 'Copper-transporting ATPase PAA1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(80852, NULL, 'G3DSA:3.90.190.20:FF:000046', NULL, NULL, 'Dihydrofolate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(80853, NULL, 'G3DSA:3.30.200.20:FF:000909', NULL, NULL, 'Mitogen-activated protein kinase kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80854, NULL, 'G3DSA:3.90.190.10:FF:000043', NULL, NULL, 'Protein tyrosine phosphatase, receptor type T', NULL, NULL, NULL, NULL, NULL, 4),
(80855, NULL, 'G3DSA:1.25.40.370:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(80856, NULL, 'G3DSA:3.50.50.60:FF:000459', NULL, NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(80857, NULL, 'G3DSA:2.60.120.680:FF:000010', NULL, NULL, 'Myosin protein', NULL, NULL, NULL, NULL, NULL, 4),
(80858, NULL, 'G3DSA:1.25.40.20:FF:001706', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80859, NULL, 'G3DSA:1.10.287.1150:FF:000001', NULL, NULL, '2-oxoglutarate dehydrogenase, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(80860, NULL, 'G3DSA:1.10.150.670:FF:000003', NULL, NULL, 'Crossover junction endonuclease MUS81', NULL, NULL, NULL, NULL, NULL, 4),
(80861, NULL, 'G3DSA:3.40.50.1220:FF:000081', NULL, NULL, 'Formyltransferase/hydrolase complex Fhc subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(80862, NULL, 'G3DSA:1.10.20.140:FF:000013', NULL, NULL, 'tRNA dimethylallyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(80863, NULL, 'G3DSA:2.40.70.10:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80864, NULL, 'G3DSA:1.10.532.10:FF:000004', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(80865, NULL, 'G3DSA:2.130.10.10:FF:001216', NULL, NULL, 'Type II inositol polyphosphate 5-phosphatase 15', NULL, NULL, NULL, NULL, NULL, 4),
(80866, NULL, 'G3DSA:2.60.120.290:FF:000106', NULL, NULL, 'SOL-2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(80867, NULL, 'G3DSA:1.10.10.60:FF:001115', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80868, NULL, 'G3DSA:2.40.37.10:FF:000006', NULL, NULL, 'Alanine racemase', NULL, NULL, NULL, NULL, NULL, 4),
(80869, NULL, 'G3DSA:3.30.70.1130:FF:000011', NULL, NULL, 'Eukaryotic translation initiation factor 2 alpha subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(80870, NULL, 'G3DSA:1.10.630.10:FF:000125', NULL, NULL, 'Probable cytochrome P450 CYP36A1', NULL, NULL, NULL, NULL, NULL, 4),
(80871, NULL, 'G3DSA:3.30.190.20:FF:000025', NULL, NULL, 'FI17503p1', NULL, NULL, NULL, NULL, NULL, 4),
(80872, NULL, 'G3DSA:2.60.40.60:FF:001141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80873, NULL, 'G3DSA:3.60.20.10:FF:000223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80874, NULL, 'G3DSA:3.40.309.10:FF:000090', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80875, NULL, 'G3DSA:3.30.70.360:FF:000032', NULL, NULL, 'Peptidase M20/M25/M40 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(80876, NULL, 'G3DSA:3.40.50.300:FF:005331', NULL, NULL, 'origin recognition complex subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(80877, NULL, 'G3DSA:4.10.1030.10:FF:000003', NULL, NULL, 'Cullin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(80878, NULL, 'G3DSA:1.20.5.110:FF:000322', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80879, NULL, 'G3DSA:3.30.200.20:FF:002473', NULL, NULL, 'RAC-beta serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(80880, NULL, 'G3DSA:3.30.70.370:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80881, NULL, 'G3DSA:2.40.340.10:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80882, NULL, 'G3DSA:2.60.260.20:FF:000068', NULL, NULL, 'Chaperone protein dnaJ 3', NULL, NULL, NULL, NULL, NULL, 4),
(80883, NULL, 'G3DSA:1.25.40.180:FF:000070', NULL, NULL, 'Nuclear cap-binding protein complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(80884, NULL, 'G3DSA:2.40.37.20:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80885, NULL, 'G3DSA:2.60.40.10:FF:003172', NULL, NULL, 'AGAP003656-PC', NULL, NULL, NULL, NULL, NULL, 4),
(80886, NULL, 'G3DSA:3.30.465.10:FF:000077', NULL, NULL, 'delta(24)-sterol reductase', NULL, NULL, NULL, NULL, NULL, 4),
(80887, NULL, 'G3DSA:3.80.10.10:FF:002610', NULL, NULL, 'PH domain leucine-rich repeat protein phosphatase, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(80888, NULL, 'G3DSA:1.20.1070.10:FF:002158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80889, NULL, 'G3DSA:1.20.58.390:FF:000288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(80890, NULL, 'G3DSA:3.80.10.10:FF:001986', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80891, NULL, 'G3DSA:2.30.30.100:FF:000181', NULL, NULL, 'Gem-associated protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(80892, NULL, 'G3DSA:3.40.1800.20:FF:000014', NULL, NULL, 'GM08392p', NULL, NULL, NULL, NULL, NULL, 4),
(80893, NULL, 'G3DSA:4.10.280.10:FF:000221', NULL, NULL, 'Uncharacterized protein ASH2', NULL, NULL, NULL, NULL, NULL, 4),
(80894, NULL, 'G3DSA:1.10.1300.10:FF:000055', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(80895, NULL, 'G3DSA:2.120.10.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80896, NULL, 'G3DSA:1.20.1070.10:FF:001669', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80897, NULL, 'G3DSA:3.40.50.12280:FF:000008', NULL, NULL, 'Membrane bound oxidoreductase, MbxJ subunit (MbxJ)', NULL, NULL, NULL, NULL, NULL, 4),
(80898, NULL, 'G3DSA:2.60.40.200:FF:000003', NULL, NULL, 'Superoxide dismutase [Cu-Zn], chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(80899, NULL, 'G3DSA:3.80.10.10:FF:002464', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80900, NULL, 'G3DSA:2.60.40.10:FF:001912', NULL, NULL, 'CD274 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(80901, NULL, 'G3DSA:2.30.30.40:FF:000478', NULL, NULL, 'Purine-binding chemotaxis protein CheW', NULL, NULL, NULL, NULL, NULL, 4),
(80902, NULL, 'G3DSA:1.10.3200.20:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80903, NULL, 'G3DSA:1.20.1560.10:FF:000206', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(80904, NULL, 'G3DSA:1.10.287.310:FF:000012', NULL, NULL, '50S ribosomal protein L29', NULL, NULL, NULL, NULL, NULL, 4),
(80905, NULL, 'G3DSA:2.130.10.10:FF:001351', NULL, NULL, 'SNARE-dependent exocytosis protein (Sro7), putative', NULL, NULL, NULL, NULL, NULL, 4),
(80906, NULL, 'G3DSA:2.40.50.140:FF:000481', NULL, NULL, 'Exosome component CSL4', NULL, NULL, NULL, NULL, NULL, 4),
(80907, NULL, 'G3DSA:3.30.310.80:FF:000003', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(80908, NULL, 'G3DSA:3.40.605.10:FF:000013', NULL, NULL, 'NADP-dependent glyceraldehyde-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(80909, NULL, 'G3DSA:2.70.170.10:FF:000275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80910, NULL, 'G3DSA:1.20.1540.10:FF:000087', NULL, NULL, 'Rhomboid like 1', NULL, NULL, NULL, NULL, NULL, 4),
(80911, NULL, 'G3DSA:3.20.20.80:FF:000318', NULL, NULL, 'Xyloglucan-specific endo-beta-1,4-glucanase BoGH5A', NULL, NULL, NULL, NULL, NULL, 4),
(80912, NULL, 'G3DSA:3.30.40.10:FF:001687', NULL, NULL, 'Putative E3 ubiquitin-protein ligase XBAT35', NULL, NULL, NULL, NULL, NULL, 4),
(80913, NULL, 'G3DSA:2.60.40.10:FF:000766', NULL, NULL, 'junctional adhesion molecule C', NULL, NULL, NULL, NULL, NULL, 4),
(80914, NULL, 'G3DSA:1.20.1050.130:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80915, NULL, 'G3DSA:1.10.60.30:FF:000002', NULL, NULL, 'UPF0307 protein YjgA', NULL, NULL, NULL, NULL, NULL, 4),
(80916, NULL, 'G3DSA:3.30.70.260:FF:000002', NULL, NULL, 'UPF0250 protein YbeD', NULL, NULL, NULL, NULL, NULL, 4),
(80917, NULL, 'G3DSA:3.30.420.10:FF:000215', NULL, NULL, 'Polyprotein of viral origin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80918, NULL, 'G3DSA:3.60.40.10:FF:000331', NULL, NULL, 'Protein phosphatase 2C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80919, NULL, 'G3DSA:3.30.70.270:FF:000005', NULL, NULL, 'DNA repair protein REV1', NULL, NULL, NULL, NULL, NULL, 4),
(80920, NULL, 'G3DSA:1.10.1040.10:FF:000012', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(80921, NULL, 'G3DSA:3.40.50.300:FF:001750', NULL, NULL, 'ATP-binding cassette transporter', NULL, NULL, NULL, NULL, NULL, 4),
(80922, NULL, 'G3DSA:2.30.42.10:FF:000586', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(80923, NULL, 'G3DSA:3.40.390.10:FF:000311', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80924, NULL, 'G3DSA:3.20.20.70:FF:000315', NULL, NULL, 'Probable RNA methyltransferase PA14_40730', NULL, NULL, NULL, NULL, NULL, 4),
(80925, NULL, 'G3DSA:1.10.630.10:FF:000350', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(80926, NULL, 'G3DSA:1.20.58.240:FF:000001', NULL, NULL, 'O-GlcNAcase like', NULL, NULL, NULL, NULL, NULL, 4),
(80927, NULL, 'G3DSA:3.50.30.30:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80928, NULL, 'G3DSA:1.10.418.30:FF:000003', NULL, NULL, 'Related to kinetochore associated 2 (HEC)', NULL, NULL, NULL, NULL, NULL, 4),
(80929, NULL, 'G3DSA:2.40.50.90:FF:000145', NULL, NULL, 'YALI0B03960p', NULL, NULL, NULL, NULL, NULL, 4),
(80930, NULL, 'G3DSA:1.20.1250.20:FF:000770', NULL, NULL, 'Major facilitator superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(80931, NULL, 'G3DSA:1.25.10.10:FF:001640', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80932, NULL, 'G3DSA:2.60.490.10:FF:000020', NULL, NULL, 'P2X purinoceptor', NULL, NULL, NULL, NULL, NULL, 4),
(80933, NULL, 'G3DSA:2.30.29.30:FF:000623', NULL, NULL, 'Nucleoporin nup61', NULL, NULL, NULL, NULL, NULL, 4),
(80934, NULL, 'G3DSA:3.40.50.300:FF:007146', NULL, NULL, 'DNA repair protein rdl1', NULL, NULL, NULL, NULL, NULL, 4),
(80935, NULL, 'G3DSA:1.20.120.1080:FF:000001', NULL, NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(80936, NULL, 'G3DSA:3.30.465.10:FF:000094', NULL, NULL, 'xanthine dehydrogenase/oxidase-like', NULL, NULL, NULL, NULL, NULL, 4),
(80937, NULL, 'G3DSA:1.10.10.900:FF:000003', NULL, NULL, 'Shwachman-Bodian-Diamond syndrome protein', NULL, NULL, NULL, NULL, NULL, 4),
(80938, NULL, 'G3DSA:2.30.30.100:FF:000107', NULL, NULL, 'Small nuclear ribonucleoprotein G', NULL, NULL, NULL, NULL, NULL, 4),
(80939, NULL, 'G3DSA:3.40.50.300:FF:005437', NULL, NULL, 'ABC transporter G family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(80940, NULL, 'G3DSA:3.40.1160.10:FF:000001', NULL, NULL, 'Uridylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(80941, NULL, 'G3DSA:3.90.190.20:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80942, NULL, 'G3DSA:3.40.50.2000:FF:000253', NULL, NULL, 'Glycosyltransferase 1 domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(80943, NULL, 'G3DSA:1.25.40.570:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80944, NULL, 'G3DSA:3.90.190.10:FF:000065', NULL, NULL, 'Dual specificity protein phosphatase 3', NULL, NULL, NULL, NULL, NULL, 4),
(80945, NULL, 'G3DSA:2.30.29.30:FF:000084', NULL, NULL, 'G protein-coupled receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(80946, NULL, 'G3DSA:1.20.1070.10:FF:000034', NULL, NULL, 'G-protein coupled receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(80947, NULL, 'G3DSA:2.30.30.100:FF:000214', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm3', NULL, NULL, NULL, NULL, NULL, 4),
(80948, NULL, 'G3DSA:1.10.10.60:FF:000935', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80949, NULL, 'G3DSA:1.50.10.10:FF:000031', NULL, NULL, 'Unsaturated glucuronyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(80950, NULL, 'G3DSA:3.30.160.60:FF:004577', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80951, NULL, 'G3DSA:1.10.390.10:FF:000050', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(80952, NULL, 'G3DSA:1.10.510.10:FF:001235', NULL, NULL, 'Kinase, CMGC CDK', NULL, NULL, NULL, NULL, NULL, 4),
(80953, NULL, 'G3DSA:3.30.200.20:FF:001421', NULL, NULL, 'Kinase', NULL, NULL, NULL, NULL, NULL, 4),
(80954, NULL, 'G3DSA:3.30.160.60:FF:001452', NULL, NULL, 'Odd skipped, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80955, NULL, 'G3DSA:3.40.850.10:FF:000228', NULL, NULL, 'Kinesin motor family protein', NULL, NULL, NULL, NULL, NULL, 4),
(80956, NULL, 'G3DSA:1.20.1560.10:FF:000195', NULL, NULL, 'AGAP006273-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(80957, NULL, 'G3DSA:3.40.190.10:FF:000094', NULL, NULL, 'Glutathione ABC transporter substrate-binding protein GsiB', NULL, NULL, NULL, NULL, NULL, 4),
(80958, NULL, 'G3DSA:1.25.40.20:FF:001252', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(80959, NULL, 'G3DSA:3.30.70.330:FF:002721', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80960, NULL, 'G3DSA:3.30.1520.10:FF:000155', NULL, NULL, 'Protein CBG07900', NULL, NULL, NULL, NULL, NULL, 4),
(80961, NULL, 'G3DSA:3.80.10.10:FF:004173', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80962, NULL, 'G3DSA:3.30.1370.10:FF:000137', NULL, NULL, 'KRR1 small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4),
(80963, NULL, 'G3DSA:1.20.5.1160:FF:000034', NULL, NULL, 'CRE-LET-75 protein', NULL, NULL, NULL, NULL, NULL, 4),
(80964, NULL, 'G3DSA:3.50.50.60:FF:000465', NULL, NULL, 'NADH oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(80965, NULL, 'G3DSA:3.40.50.1820:FF:000491', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(80966, NULL, 'G3DSA:1.10.510.10:FF:000869', NULL, NULL, 'Nek protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(80967, NULL, 'G3DSA:1.50.10.20:FF:000034', NULL, NULL, 'CAAX geranylgeranyltransferase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(80968, NULL, 'G3DSA:2.30.42.10:FF:000171', NULL, NULL, 'PDZ domain containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(80969, NULL, 'G3DSA:1.25.10.10:FF:001314', NULL, NULL, 'STAG domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80970, NULL, 'G3DSA:2.60.40.2860:FF:000012', NULL, NULL, 'Transmission-blocking target antigen S230', NULL, NULL, NULL, NULL, NULL, 4),
(80971, NULL, 'G3DSA:2.60.120.260:FF:000238', NULL, NULL, 'Calx-beta domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(80972, NULL, 'G3DSA:1.10.510.10:FF:003365', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80973, NULL, 'G3DSA:1.20.1070.10:FF:002164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80974, NULL, 'G3DSA:3.90.1150.10:FF:000343', NULL, NULL, 'Cystathionase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80975, NULL, 'G3DSA:3.40.50.80:FF:000229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80976, NULL, 'G3DSA:3.40.50.300:FF:002689', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80977, NULL, 'G3DSA:3.60.15.10:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80978, NULL, 'G3DSA:3.30.40.10:FF:000692', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(80979, NULL, 'G3DSA:1.10.472.10:FF:000089', NULL, NULL, 'Cyclin, N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(80980, NULL, 'G3DSA:2.60.40.550:FF:000001', NULL, NULL, 'Ecotin', NULL, NULL, NULL, NULL, NULL, 4),
(80981, NULL, 'G3DSA:2.60.40.150:FF:000674', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80982, NULL, 'G3DSA:3.90.1150.10:FF:000236', NULL, NULL, 'DegT/DnrJ/EryC1/StrS family aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(80983, NULL, 'G3DSA:2.60.40.10:FF:005510', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80984, NULL, 'G3DSA:3.30.390.30:FF:000010', NULL, NULL, '3-phenylpropionate/cinnamic acid dioxygenase ferredoxin--NAD(+) reductase component', NULL, NULL, NULL, NULL, NULL, 4),
(80985, NULL, 'G3DSA:1.10.40.30:FF:000001', NULL, NULL, 'Argininosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(80986, NULL, 'G3DSA:1.10.150.670:FF:000019', NULL, NULL, 'Crossover junction endonuclease MUS81', NULL, NULL, NULL, NULL, NULL, 4),
(80987, NULL, 'G3DSA:3.30.450.60:FF:000052', NULL, NULL, 'AP-2 complex subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(80988, NULL, 'G3DSA:3.10.50.10:FF:000047', NULL, NULL, 'Di-N-acetylchitobiase', NULL, NULL, NULL, NULL, NULL, 4),
(80989, NULL, 'G3DSA:1.10.418.40:FF:000006', NULL, NULL, 'Chromosome 12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(80990, NULL, 'G3DSA:3.40.1180.10:FF:000002', NULL, NULL, 'Alkyl transferase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(80991, NULL, 'G3DSA:1.25.10.10:FF:002585', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80992, NULL, 'G3DSA:3.40.462.10:FF:000001', NULL, NULL, 'Cytokinin dehydrogenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(80993, NULL, 'G3DSA:3.40.50.150:FF:000845', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(80994, NULL, 'G3DSA:2.60.40.1760:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80995, NULL, 'G3DSA:2.60.40.60:FF:000298', NULL, NULL, 'DE-cadherin', NULL, NULL, NULL, NULL, NULL, 4),
(80996, NULL, 'G3DSA:3.30.160.60:FF:005723', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(80997, NULL, 'G3DSA:2.160.20.10:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(80998, NULL, 'G3DSA:3.30.70.330:FF:000719', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(80999, NULL, 'G3DSA:3.30.160.60:FF:001345', NULL, NULL, 'zinc finger protein 646', NULL, NULL, NULL, NULL, NULL, 4),
(81000, NULL, 'G3DSA:1.20.120.720:FF:000055', NULL, NULL, 'Myosin-G heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(81001, NULL, 'G3DSA:1.25.40.10:FF:001029', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(81002, NULL, 'G3DSA:2.130.10.10:FF:005151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81003, NULL, 'G3DSA:3.30.70.330:FF:002597', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81004, NULL, 'G3DSA:3.40.30.10:FF:001197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81005, NULL, 'G3DSA:1.10.287.380:FF:000027', NULL, NULL, 'AGAP010420-PA', NULL, NULL, NULL, NULL, NULL, 4),
(81006, NULL, 'G3DSA:3.30.470.20:FF:000154', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(81007, NULL, 'G3DSA:2.40.50.140:FF:000677', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81008, NULL, 'G3DSA:3.40.1110.10:FF:000054', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(81009, NULL, 'G3DSA:3.40.50.2000:FF:000360', NULL, NULL, 'Os09g0119600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(81010, NULL, 'G3DSA:3.40.50.620:FF:000435', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(81011, NULL, 'G3DSA:1.20.1070.10:FF:000449', NULL, NULL, 'GoNadotropin-Releasing hormone Receptor (GnRHR) related', NULL, NULL, NULL, NULL, NULL, 4),
(81012, NULL, 'G3DSA:2.60.120.330:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81013, NULL, 'G3DSA:3.40.850.10:FF:000009', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(81014, NULL, 'G3DSA:3.30.200.20:FF:000696', NULL, NULL, 'Calcium-dependent protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(81015, NULL, 'G3DSA:2.60.40.1730:FF:000010', NULL, NULL, 'Putative aminopeptidase N', NULL, NULL, NULL, NULL, NULL, 4),
(81016, NULL, 'G3DSA:1.10.10.10:FF:001331', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(81017, NULL, 'G3DSA:3.40.50.410:FF:000013', NULL, NULL, 'inter-alpha-trypsin inhibitor heavy chain H2', NULL, NULL, NULL, NULL, NULL, 4),
(81018, NULL, 'G3DSA:1.25.10.10:FF:002950', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81019, NULL, 'G3DSA:1.20.1270.10:FF:000015', NULL, NULL, 'Luminal-binding protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(81020, NULL, 'G3DSA:2.60.40.10:FF:003256', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81021, NULL, 'G3DSA:3.40.50.970:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81022, NULL, 'G3DSA:3.40.50.1820:FF:000378', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(81023, NULL, 'G3DSA:3.30.70.330:FF:000467', NULL, NULL, 'Cell wall integrity protein scw1', NULL, NULL, NULL, NULL, NULL, 4),
(81024, NULL, 'G3DSA:2.40.180.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81025, NULL, 'G3DSA:3.30.230.10:FF:000077', NULL, NULL, 'Putative tetQ family GTPase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(81026, NULL, 'G3DSA:1.20.1070.10:FF:000343', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81027, NULL, 'G3DSA:1.10.3820.10:FF:000004', NULL, NULL, 'C-type cytochrome protein NrfH', NULL, NULL, NULL, NULL, NULL, 4),
(81028, NULL, 'G3DSA:1.25.40.970:FF:000003', NULL, NULL, 'Histone-lysine N-methyltransferase SMYD3', NULL, NULL, NULL, NULL, NULL, 4),
(81029, NULL, 'G3DSA:3.40.50.12780:FF:000074', NULL, NULL, 'Acyl-CoA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(81030, NULL, 'G3DSA:3.30.300.30:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81031, NULL, 'G3DSA:1.20.5.5160:FF:000003', NULL, NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', NULL, NULL, NULL, NULL, NULL, 4),
(81032, NULL, 'G3DSA:3.30.160.60:FF:000979', NULL, NULL, 'Zinc finger protein 775', NULL, NULL, NULL, NULL, NULL, 4),
(81033, NULL, 'G3DSA:2.130.10.10:FF:005403', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(81034, NULL, 'G3DSA:2.60.40.10:FF:004818', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81035, NULL, 'G3DSA:2.130.10.10:FF:004785', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81036, NULL, 'G3DSA:1.20.80.10:FF:000031', NULL, NULL, 'FERM domain (Protein4.1-ezrin-radixin-moesin) family', NULL, NULL, NULL, NULL, NULL, 4),
(81037, NULL, 'G3DSA:2.10.109.10:FF:000017', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(81038, NULL, 'G3DSA:2.30.29.30:FF:000404', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(81039, NULL, 'G3DSA:1.25.40.10:FF:000299', NULL, NULL, 'Sel1 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(81040, NULL, 'G3DSA:1.25.10.10:FF:001421', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(81041, NULL, 'G3DSA:1.20.1280.290:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81042, NULL, 'G3DSA:3.30.479.30:FF:000025', NULL, NULL, 'Mechanosensory protein 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(81043, NULL, 'G3DSA:3.10.310.10:FF:000015', NULL, NULL, 'Proline racemase', NULL, NULL, NULL, NULL, NULL, 4),
(81044, NULL, 'G3DSA:3.40.50.720:FF:000465', NULL, NULL, 'Quinone oxidoreductase 2', NULL, NULL, NULL, NULL, NULL, 4),
(81045, NULL, 'G3DSA:1.25.10.10:FF:003203', NULL, NULL, 'PIKK family atypical protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(81046, NULL, 'G3DSA:3.30.50.10:FF:000193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81047, NULL, 'G3DSA:1.10.10.10:FF:001095', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(81048, NULL, 'G3DSA:1.25.10.10:FF:000696', NULL, NULL, 'Formin 3, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(81049, NULL, 'G3DSA:2.170.150.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81050, NULL, 'G3DSA:3.90.470.10:FF:000008', NULL, NULL, '50S ribosomal protein L22', NULL, NULL, NULL, NULL, NULL, 4),
(81051, NULL, 'G3DSA:1.50.40.10:FF:000111', NULL, NULL, 'Uncoupling protein 2, like', NULL, NULL, NULL, NULL, NULL, 4),
(81052, NULL, 'G3DSA:2.40.50.90:FF:000038', NULL, NULL, 'Tudor staphylococcal nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(81053, NULL, 'G3DSA:3.20.20.80:FF:000431', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81054, NULL, 'G3DSA:2.60.40.10:FF:005280', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81055, NULL, 'G3DSA:3.20.20.80:FF:000122', NULL, NULL, 'Glycoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(81056, NULL, 'G3DSA:3.30.479.20:FF:000022', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(81057, NULL, 'G3DSA:3.40.50.620:FF:000744', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(81058, NULL, 'G3DSA:4.10.900.10:FF:000011', NULL, NULL, 'Pangolin, isoform Q', NULL, NULL, NULL, NULL, NULL, 4),
(81059, NULL, 'G3DSA:3.30.160.60:FF:001143', NULL, NULL, 'zinc finger and BTB domain-containing protein 40', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(81060, NULL, 'G3DSA:1.10.890.20:FF:000001', NULL, NULL, 'Fatty-acid-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(81061, NULL, 'G3DSA:2.60.40.60:FF:001028', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(81062, NULL, 'G3DSA:1.20.950.20:FF:000009', NULL, NULL, 'Cytochrome b', NULL, NULL, NULL, NULL, NULL, 4),
(81063, NULL, 'G3DSA:3.40.50.300:FF:004021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81064, NULL, 'G3DSA:3.30.430.20:FF:000045', NULL, NULL, 'Os07g0628900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(81065, NULL, 'G3DSA:3.40.50.970:FF:000181', NULL, NULL, '2-oxoglutarate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(81066, NULL, 'G3DSA:2.10.110.10:FF:000234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81067, NULL, 'G3DSA:3.30.70.330:FF:000248', NULL, NULL, '50S ribosomal protein L23', NULL, NULL, NULL, NULL, NULL, 4),
(81068, NULL, 'G3DSA:3.30.450.30:FF:000049', NULL, NULL, 'Profilin', NULL, NULL, NULL, NULL, NULL, 4),
(81069, NULL, 'G3DSA:3.30.450.20:FF:000046', NULL, NULL, 'Aerotaxis sensor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(81070, NULL, 'G3DSA:2.130.10.10:FF:001660', NULL, NULL, 'WD_domain_-_G-beta_repeat /Utp13_specific_WD40_associated_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(81071, NULL, 'G3DSA:3.30.720.210:FF:000017', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH 3', NULL, NULL, NULL, NULL, NULL, 4),
(81072, NULL, 'G3DSA:2.60.220.50:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81073, NULL, 'G3DSA:3.30.559.70:FF:000066', NULL, NULL, 'Novel protein similar to vertebrate carnitine acetyltransferase (CRAT)', NULL, NULL, NULL, NULL, NULL, 4),
(81074, NULL, 'G3DSA:2.40.50.140:FF:000368', NULL, NULL, 'Mcm10p', NULL, NULL, NULL, NULL, NULL, 4),
(81075, NULL, 'G3DSA:3.40.50.2000:FF:000449', NULL, NULL, 'Glycosyl transferase group 1', NULL, NULL, NULL, NULL, NULL, 4),
(81076, NULL, 'G3DSA:3.30.160.60:FF:005184', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81077, NULL, 'G3DSA:2.60.120.260:FF:000351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81078, NULL, 'G3DSA:2.60.40.10:FF:001603', NULL, NULL, 'Roundabout 2', NULL, NULL, NULL, NULL, NULL, 4),
(81079, NULL, 'G3DSA:1.20.1160.11:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81080, NULL, 'G3DSA:3.40.50.10090:FF:000020', NULL, NULL, 'Uroporphyrinogen-III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(81081, NULL, 'G3DSA:3.10.390.10:FF:000008', NULL, NULL, 'Abnormal DAuer Formation DAF-5, a Ski oncogene homolog involved in a neuronal TGF beta pathway (71.0 kD) (Daf-5)', NULL, NULL, NULL, NULL, NULL, 4),
(81082, NULL, 'G3DSA:3.40.640.10:FF:000527', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81083, NULL, 'G3DSA:2.60.40.10:FF:003037', NULL, NULL, 'Zwei Ig domain protein zig-5', NULL, NULL, NULL, NULL, NULL, 4),
(81084, NULL, 'G3DSA:3.40.250.10:FF:000025', NULL, NULL, 'Molybdopterin biosynthesis MoeZ', NULL, NULL, NULL, NULL, NULL, 4),
(81085, NULL, 'G3DSA:1.20.58.60:FF:000404', NULL, NULL, 'Spectrin repeat containing nuclear envelope protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(81086, NULL, 'G3DSA:1.25.40.20:FF:001780', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(81087, NULL, 'G3DSA:2.30.29.30:FF:001011', NULL, NULL, 'Band 4.1-like protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(81088, NULL, 'G3DSA:3.40.50.300:FF:000002', NULL, NULL, 'ATP synthase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(81089, NULL, 'G3DSA:3.40.50.2300:FF:000236', NULL, NULL, 'Two component transcriptional regulator NrrA', NULL, NULL, NULL, NULL, NULL, 4),
(81090, NULL, 'G3DSA:2.60.410.10:FF:000004', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase DacA', NULL, NULL, NULL, NULL, NULL, 4),
(81091, NULL, 'G3DSA:1.10.8.1220:FF:000021', NULL, NULL, 'Dynein axonemal heavy chain 6', NULL, NULL, NULL, NULL, NULL, 4),
(81092, NULL, 'G3DSA:1.10.357.140:FF:000045', NULL, NULL, '1,4-dihydroxy-2-naphthoate octaprenyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(81093, NULL, 'G3DSA:1.10.10.750:FF:000031', NULL, NULL, 'Rab GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81094, NULL, 'G3DSA:3.40.1610.10:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81095, NULL, 'G3DSA:3.75.10.10:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81096, NULL, 'G3DSA:1.10.1450.10:FF:000077', NULL, NULL, 'GM10990', NULL, NULL, NULL, NULL, NULL, 4),
(81097, NULL, 'G3DSA:1.10.238.10:FF:001315', NULL, NULL, 'Probable calcium-binding mitochondrial carrier F17E5.2', NULL, NULL, NULL, NULL, NULL, 4),
(81098, NULL, 'G3DSA:3.10.20.870:FF:000005', NULL, NULL, 'Polyubiquitin binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81099, NULL, 'G3DSA:3.30.160.60:FF:005504', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81100, NULL, 'G3DSA:2.60.40.10:FF:004785', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81101, NULL, 'G3DSA:3.60.130.10:FF:000001', NULL, NULL, 'Trimethyllysine dioxygenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(81102, NULL, 'G3DSA:1.10.1370.10:FF:000019', NULL, NULL, 'Peptidyl-dipeptidase dcp', NULL, NULL, NULL, NULL, NULL, 4),
(81103, NULL, 'G3DSA:1.20.1410.10:FF:000004', NULL, NULL, 'Cytoskeleton assembly control protein Sla2', NULL, NULL, NULL, NULL, NULL, 4),
(81104, NULL, 'G3DSA:1.20.58.60:FF:000387', NULL, NULL, 'Spectrin repeat containing nuclear envelope protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(81105, NULL, 'G3DSA:2.130.10.10:FF:004763', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81106, NULL, 'G3DSA:3.90.180.10:FF:000093', NULL, NULL, 'Alcohol dehydrogenase 5 (class III), chi polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(81107, NULL, 'G3DSA:1.25.40.180:FF:000305', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81108, NULL, 'G3DSA:3.80.10.10:FF:002155', NULL, NULL, 'F-box/LRR-repeat protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(81109, NULL, 'G3DSA:1.10.600.10:FF:000051', NULL, NULL, 'Geranylgeranyl diphosphate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(81110, NULL, 'G3DSA:2.60.40.420:FF:000070', NULL, NULL, 'Potential multicopper ferro-O2-oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(81111, NULL, 'G3DSA:1.25.40.20:FF:001471', NULL, NULL, 'Os07g0492966 protein', NULL, NULL, NULL, NULL, NULL, 4),
(81112, NULL, 'G3DSA:3.40.50.300:FF:003094', NULL, NULL, 'ADP ribosylation factor family gtpase', NULL, NULL, NULL, NULL, NULL, 4),
(81113, NULL, 'G3DSA:3.40.50.300:FF:003184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81114, NULL, 'G3DSA:1.20.140.40:FF:000078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81115, NULL, 'G3DSA:1.10.510.10:FF:003056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81116, NULL, 'G3DSA:1.20.58.100:FF:000010', NULL, NULL, 'L-aspartate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(81117, NULL, 'G3DSA:2.60.40.10:FF:003402', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81118, NULL, 'G3DSA:3.40.50.620:FF:000183', NULL, NULL, 'Glutaminyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(81119, NULL, 'G3DSA:3.30.450.20:FF:000265', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(81120, NULL, 'G3DSA:3.40.50.300:FF:005128', NULL, NULL, 'ABC-type cobalt transport system, ATPase component', NULL, NULL, NULL, NULL, NULL, 4),
(81121, NULL, 'G3DSA:2.60.40.10:FF:002784', NULL, NULL, 'Myotactin form A', NULL, NULL, NULL, NULL, NULL, 4),
(81122, NULL, 'G3DSA:2.60.120.10:FF:000009', NULL, NULL, 'Potassium voltage-gated channel subfamily H member 1', NULL, NULL, NULL, NULL, NULL, 4),
(81123, NULL, 'G3DSA:3.40.390.10:FF:000081', NULL, NULL, 'Serpentine receptor class gamma', NULL, NULL, NULL, NULL, NULL, 4),
(81124, NULL, 'G3DSA:2.60.40.10:FF:005190', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81125, NULL, 'G3DSA:2.30.42.10:FF:000480', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81126, NULL, 'G3DSA:1.20.58.60:FF:000078', NULL, NULL, 'Spectrin alpha chain, non-erythrocytic 1', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(81127, NULL, 'G3DSA:3.40.50.1820:FF:000182', NULL, NULL, 'Lipase EstA', NULL, NULL, NULL, NULL, NULL, 4),
(81128, NULL, 'G3DSA:3.40.50.150:FF:001227', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81129, NULL, 'G3DSA:6.10.250.3310:FF:000002', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(81130, NULL, 'G3DSA:1.20.58.60:FF:000623', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81131, NULL, 'G3DSA:1.20.1730.10:FF:000023', NULL, NULL, 'Sodium transporter', NULL, NULL, NULL, NULL, NULL, 4),
(81132, NULL, 'G3DSA:3.40.720.10:FF:000314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81133, NULL, 'G3DSA:1.25.40.10:FF:002884', NULL, NULL, 'Signal recognition particle subunit SRP72', NULL, NULL, NULL, NULL, NULL, 4),
(81134, NULL, 'G3DSA:3.30.2130.30:FF:000030', NULL, NULL, 'Probable tRNA sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(81135, NULL, 'G3DSA:3.30.420.40:FF:000775', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81136, NULL, 'G3DSA:1.20.1250.20:FF:000461', NULL, NULL, 'Monosaccharide-sensing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(81137, NULL, 'G3DSA:3.20.100.10:FF:000008', NULL, NULL, 'RNA triphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(81138, NULL, 'G3DSA:1.25.40.10:FF:003502', NULL, NULL, 'YALI0F21362p', NULL, NULL, NULL, NULL, NULL, 4),
(81139, NULL, 'G3DSA:3.30.450.20:FF:000607', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(81140, NULL, 'G3DSA:1.10.238.10:FF:001006', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(81141, NULL, 'G3DSA:2.130.10.10:FF:003711', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81142, NULL, 'G3DSA:3.40.50.1820:FF:000524', NULL, NULL, 'Surfactin synthase thioesterase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(81143, NULL, 'G3DSA:1.20.1420.30:FF:000062', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(81144, NULL, 'G3DSA:3.30.160.190:FF:000001', NULL, NULL, 'NADH-ubiquinone oxidoreductase 21 kDa subunit mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(81145, NULL, 'G3DSA:1.20.5.170:FF:000222', NULL, NULL, 'Paramyosin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81146, NULL, 'G3DSA:2.60.120.260:FF:000547', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81147, NULL, 'G3DSA:3.30.70.660:FF:000015', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(81148, NULL, 'G3DSA:2.160.20.10:FF:000086', NULL, NULL, 'Probable GLUCAN ENDO-1, 3-BETA-GLUCOSIDASE BGN13.1', NULL, NULL, NULL, NULL, NULL, 4),
(81149, NULL, 'G3DSA:3.80.10.10:FF:000025', NULL, NULL, 'Leucine rich repeat and fibronectin type III domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(81150, NULL, 'G3DSA:3.40.630.30:FF:000004', NULL, NULL, 'Histone acetyltransferase KAT2A', NULL, NULL, NULL, NULL, NULL, 4),
(81151, NULL, 'G3DSA:1.25.40.10:FF:005301', NULL, NULL, 'SET domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(81152, NULL, 'G3DSA:3.90.1720.30:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81153, NULL, 'G3DSA:2.40.50.140:FF:000790', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81154, NULL, 'G3DSA:3.40.50.300:FF:007455', NULL, NULL, 'ABC transporter protein', NULL, NULL, NULL, NULL, NULL, 4),
(81155, NULL, 'G3DSA:1.50.40.10:FF:000420', NULL, NULL, 'Solute carrier family 25 (mitochondrial carrier; peroxisomal membrane protein), member 17', NULL, NULL, NULL, NULL, NULL, 4),
(81156, NULL, 'G3DSA:1.20.58.120:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81157, NULL, 'G3DSA:1.10.357.30:FF:000001', NULL, NULL, 'Exocyst complex component', NULL, NULL, NULL, NULL, NULL, 4),
(81158, NULL, 'G3DSA:2.40.160.50:FF:000017', NULL, NULL, 'Outer membrane protein assembly factor BamA', NULL, NULL, NULL, NULL, NULL, 4),
(81159, NULL, 'G3DSA:2.20.100.10:FF:000231', NULL, NULL, 'plasminogen-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(81160, NULL, 'G3DSA:1.10.1040.10:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81161, NULL, 'G3DSA:3.80.10.10:FF:004482', NULL, NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase At5g06940', NULL, NULL, NULL, NULL, NULL, 4),
(81162, NULL, 'G3DSA:1.10.357.50:FF:000007', NULL, NULL, 'BAI1 associated protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(81163, NULL, 'G3DSA:1.25.10.10:FF:003422', NULL, NULL, 'Ecm29p', NULL, NULL, NULL, NULL, NULL, 4),
(81164, NULL, 'G3DSA:1.20.1250.20:FF:002349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81165, NULL, 'G3DSA:1.25.40.20:FF:001561', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81166, NULL, 'G3DSA:3.40.50.11660:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81167, NULL, 'G3DSA:4.10.1000.10:FF:000029', NULL, NULL, 'tRNA-dihydrouridine(47) synthase [NAD(P)(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(81168, NULL, 'G3DSA:1.10.238.220:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81169, NULL, 'G3DSA:3.40.630.40:FF:000007', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(81170, NULL, 'G3DSA:3.30.200.20:FF:000365', NULL, NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(81171, NULL, 'G3DSA:1.10.357.40:FF:000004', NULL, NULL, 'Infection Response protein', NULL, NULL, NULL, NULL, NULL, 4),
(81172, NULL, 'G3DSA:2.30.42.10:FF:000277', NULL, NULL, 'sorting nexin-27 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(81173, NULL, 'G3DSA:3.40.50.300:FF:002003', NULL, NULL, 'GPN-loop GTPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(81174, NULL, 'G3DSA:3.60.15.10:FF:000256', NULL, NULL, 'RNA-metabolising metallo-beta-lactamase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(81175, NULL, 'G3DSA:3.60.10.10:FF:000413', NULL, NULL, 'Nuclear GTPase, germinal center-associated, tandem duplicate 1', NULL, NULL, NULL, NULL, NULL, 4),
(81176, NULL, 'G3DSA:3.40.30.10:FF:000106', NULL, NULL, 'DnaJ homolog subfamily C member 10', NULL, NULL, NULL, NULL, NULL, 4),
(81177, NULL, 'G3DSA:2.40.50.140:FF:000262', NULL, NULL, 'Protein BREAST CANCER SUSCEPTIBILITY 2 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(81178, NULL, 'G3DSA:3.30.200.20:FF:000707', NULL, NULL, 'Cyclin dependent kinase 19', NULL, NULL, NULL, NULL, NULL, 4),
(81179, NULL, 'G3DSA:1.25.10.10:FF:001168', NULL, NULL, 'Binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(81180, NULL, 'G3DSA:3.40.50.10190:FF:000134', NULL, NULL, 'BRCT domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(81181, NULL, 'G3DSA:3.30.70.330:FF:000158', NULL, NULL, 'heterogeneous nuclear ribonucleoprotein A3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(81182, NULL, 'G3DSA:1.10.287.70:FF:000423', NULL, NULL, 'Voltage-gated Ca2+ channel, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(81183, NULL, 'G3DSA:3.20.20.80:FF:000009', NULL, NULL, 'O-GlcNAcase BT_4395', NULL, NULL, NULL, NULL, NULL, 4),
(81184, NULL, 'G3DSA:3.40.50.720:FF:001859', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81185, NULL, 'G3DSA:3.40.50.10490:FF:000123', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81186, NULL, 'G3DSA:2.30.30.490:FF:000033', NULL, NULL, 'Agenet and bromo-adjacent homology (BAH) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(81187, NULL, 'G3DSA:1.10.472.10:FF:000179', NULL, NULL, 'Cyclin Q', NULL, NULL, NULL, NULL, NULL, 4),
(81188, NULL, 'G3DSA:3.40.367.20:FF:000029', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(81189, NULL, 'G3DSA:2.10.25.10:FF:000233', NULL, NULL, 'tomoregulin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(81190, NULL, 'G3DSA:3.40.850.10:FF:000318', NULL, NULL, 'Kinesin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81191, NULL, 'G3DSA:1.20.120.610:FF:000022', NULL, NULL, 'ATP synthase subunit C family protein', NULL, NULL, NULL, NULL, NULL, 4),
(81192, NULL, 'G3DSA:3.10.20.90:FF:000991', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(81193, NULL, 'G3DSA:2.60.40.10:FF:000985', NULL, NULL, 'Cardiomyopathy associated 5', NULL, NULL, NULL, NULL, NULL, 4),
(81194, NULL, 'G3DSA:3.40.50.300:FF:006764', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81195, NULL, 'G3DSA:2.30.29.30:FF:000393', NULL, NULL, 'centaurin-gamma-1A isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(81196, NULL, 'G3DSA:3.40.80.10:FF:000042', NULL, NULL, 'Peptidoglycan-recognition protein LF-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(81197, NULL, 'G3DSA:2.40.320.10:FF:000018', NULL, NULL, 'Triphosphate tunnel metalloenzyme 3', NULL, NULL, NULL, NULL, NULL, 4),
(81198, NULL, 'G3DSA:3.40.50.720:FF:001769', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81199, NULL, 'G3DSA:2.60.120.200:FF:000445', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81200, NULL, 'G3DSA:3.40.570.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81201, NULL, 'G3DSA:1.25.40.10:FF:004683', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81202, NULL, 'G3DSA:3.40.50.2000:FF:000359', NULL, NULL, 'Glycoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(81203, NULL, 'G3DSA:3.30.70.330:FF:002266', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81204, NULL, 'G3DSA:2.30.30.30:FF:000166', NULL, NULL, 'p53-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(81205, NULL, 'G3DSA:1.20.1250.20:FF:000803', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(81206, NULL, 'G3DSA:3.30.70.330:FF:002608', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81207, NULL, 'G3DSA:1.10.10.60:FF:000699', NULL, NULL, 'MYB transcription factor 84', NULL, NULL, NULL, NULL, NULL, 4),
(81208, NULL, 'G3DSA:3.30.710.10:FF:000226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81209, NULL, 'G3DSA:3.40.1190.20:FF:000051', NULL, NULL, 'Pyridoxal kinase', NULL, NULL, NULL, NULL, NULL, 4),
(81210, NULL, 'G3DSA:1.10.340.70:FF:000020', NULL, NULL, 'Polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(81211, NULL, 'G3DSA:3.40.50.300:FF:001385', NULL, NULL, 'STH1 (YIL126W)', NULL, NULL, NULL, NULL, NULL, 4),
(81212, NULL, 'G3DSA:1.25.40.770:FF:000022', NULL, NULL, 'TAF6-like RNA polymerase II, p300/CBP-associated factor (PCAF)-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(81213, NULL, 'G3DSA:3.30.1330.30:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81214, NULL, 'G3DSA:3.40.50.300:FF:007040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81215, NULL, 'G3DSA:3.30.420.40:FF:001051', NULL, NULL, 'HSP70-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(81216, NULL, 'G3DSA:1.25.10.10:FF:003309', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(81217, NULL, 'G3DSA:3.20.20.70:FF:000006', NULL, NULL, 'Imidazole glycerol phosphate synthase subunit HisF', NULL, NULL, NULL, NULL, NULL, 4),
(81218, NULL, 'G3DSA:2.60.120.200:FF:000136', NULL, NULL, 'Collagen type V alpha 3 chain', NULL, NULL, NULL, NULL, NULL, 4),
(81219, NULL, 'G3DSA:1.20.58.60:FF:000168', NULL, NULL, 'nesprin-1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(81220, NULL, 'G3DSA:3.10.100.10:FF:000078', NULL, NULL, 'C-type LECtin', NULL, NULL, NULL, NULL, NULL, 4),
(81221, NULL, 'G3DSA:2.60.40.10:FF:003150', NULL, NULL, 'Tyrosine-protein phosphatase 4', NULL, NULL, NULL, NULL, NULL, 4),
(81222, NULL, 'G3DSA:1.10.472.10:FF:000398', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81223, NULL, 'G3DSA:3.40.50.150:FF:000699', NULL, NULL, 'tRNA 5-methylaminomethyl-2-thiouridine biosynthesis bifunctional protein MnmC', NULL, NULL, NULL, NULL, NULL, 4),
(81224, NULL, 'G3DSA:3.30.40.10:FF:000383', NULL, NULL, 'RING/U-box superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(81225, NULL, 'G3DSA:2.60.40.420:FF:000176', NULL, NULL, 'Multicopper oxidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(81226, NULL, 'G3DSA:3.40.50.300:FF:006983', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(81227, NULL, 'G3DSA:2.60.220.50:FF:000181', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(81228, NULL, 'G3DSA:2.40.128.20:FF:000001', NULL, NULL, 'Fatty acid-binding protein, adipocyte', NULL, NULL, NULL, NULL, NULL, 4),
(81229, NULL, 'G3DSA:3.30.470.20:FF:000064', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(81230, NULL, 'G3DSA:1.20.1440.170:FF:000003', NULL, NULL, 'Unplaced genomic scaffold supercont2.9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(81231, NULL, 'G3DSA:3.40.190.80:FF:000041', NULL, NULL, 'Carbohydrate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(81232, NULL, 'G3DSA:3.40.850.10:FF:000537', NULL, NULL, 'Kinesin family member 5B, a', NULL, NULL, NULL, NULL, NULL, 4),
(81233, NULL, 'G3DSA:3.40.50.300:FF:003330', NULL, NULL, 'Bifunctional adenosylcobinamide kinase/adenosylcobinamide-phosphate guanylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(81234, NULL, 'G3DSA:3.50.30.80:FF:000003', NULL, NULL, 'Dihydroxy-acid dehydratase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81235, NULL, 'G3DSA:3.30.420.40:FF:000685', NULL, NULL, 'Kanosamine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(81236, NULL, 'G3DSA:2.20.25.20:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81237, NULL, 'G3DSA:3.90.1580.10:FF:000010', NULL, NULL, 'Gliding motility lipoprotein GldK', NULL, NULL, NULL, NULL, NULL, 4),
(81238, NULL, 'G3DSA:1.10.287.70:FF:000114', NULL, NULL, 'Cytochrome c oxidase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(81239, NULL, 'G3DSA:3.10.129.10:FF:000144', NULL, NULL, '4-hydroxybenzoyl-CoA thioesterase protein', NULL, NULL, NULL, NULL, NULL, 4),
(81240, NULL, 'G3DSA:3.20.20.80:FF:000228', NULL, NULL, 'Chitinase A', NULL, NULL, NULL, NULL, NULL, 4),
(81241, NULL, 'G3DSA:2.70.70.10:FF:000054', NULL, NULL, 'Cell wall endopeptidase family M23/M37', NULL, NULL, NULL, NULL, NULL, 4),
(81242, NULL, 'G3DSA:1.20.58.60:FF:000533', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81243, NULL, 'G3DSA:2.60.40.10:FF:001457', NULL, NULL, 'MPL proto-oncogene, thrombopoietin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(81244, NULL, 'G3DSA:1.10.1670.10:FF:000060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81245, NULL, 'G3DSA:2.10.25.10:FF:001778', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81246, NULL, 'G3DSA:1.20.1250.20:FF:000551', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(81247, NULL, 'G3DSA:2.60.120.340:FF:000021', NULL, NULL, 'Histone deacetylase-related / HD-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(81248, NULL, 'G3DSA:3.40.50.1010:FF:000017', NULL, NULL, 'protein SMG5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(81249, NULL, 'G3DSA:3.30.70.270:FF:000224', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81250, NULL, 'G3DSA:2.40.50.120:FF:000014', NULL, NULL, 'Secreted frizzled-related protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(81251, NULL, 'G3DSA:3.30.230.10:FF:000280', NULL, NULL, 'GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(81252, NULL, 'G3DSA:3.40.50.300:FF:001295', NULL, NULL, 'Probable RNA helicase SDE3', NULL, NULL, NULL, NULL, NULL, 4),
(81253, NULL, 'G3DSA:3.30.450.270:FF:000006', NULL, NULL, 'Phytochrome-like protein cph1', NULL, NULL, NULL, NULL, NULL, 4),
(81254, NULL, 'G3DSA:1.10.510.10:FF:003730', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81255, NULL, 'G3DSA:1.10.940.10:FF:000008', NULL, NULL, 'Transcription antitermination protein NusB', NULL, NULL, NULL, NULL, NULL, 4),
(81256, NULL, 'G3DSA:2.60.40.10:FF:001238', NULL, NULL, 'Sallimus, isoform P', NULL, NULL, NULL, NULL, NULL, 4),
(81257, NULL, 'G3DSA:3.30.1060.10:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81258, NULL, 'G3DSA:3.10.250.10:FF:000032', NULL, NULL, 'Si:dkey-14d8.20', NULL, NULL, NULL, NULL, NULL, 4),
(81259, NULL, 'G3DSA:3.40.30.10:FF:001091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81260, NULL, 'G3DSA:3.30.870.10:FF:000058', NULL, NULL, 'Putative cardiolipin synthetase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(81261, NULL, 'G3DSA:2.130.10.10:FF:002655', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81262, NULL, 'G3DSA:2.60.40.10:FF:002874', NULL, NULL, 'Tapasin long form', NULL, NULL, NULL, NULL, NULL, 4),
(81263, NULL, 'G3DSA:2.40.50.140:FF:000571', NULL, NULL, 'tRNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(81264, NULL, 'G3DSA:2.10.110.10:FF:000088', NULL, NULL, 'Filamin binding LIM protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(81265, NULL, 'G3DSA:3.30.1330.40:FF:000014', NULL, NULL, 'Chorismate mutase AroH', NULL, NULL, NULL, NULL, NULL, 4),
(81266, NULL, 'G3DSA:3.30.160.60:FF:003615', NULL, NULL, 'C2H2 type zinc finger domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(81267, NULL, 'G3DSA:3.30.559.10:FF:000216', NULL, NULL, 'Ferrichrome siderophore peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(81268, NULL, 'G3DSA:3.40.50.300:FF:007601', NULL, NULL, 'Ras family protein', NULL, NULL, NULL, NULL, NULL, 4),
(81269, NULL, 'G3DSA:3.40.50.1700:FF:000016', NULL, NULL, 'Periplasmic beta-glucosidase, xylosidase/arabinosidase', NULL, NULL, NULL, NULL, NULL, 4),
(81270, NULL, 'G3DSA:2.120.10.30:FF:000587', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81271, NULL, 'G3DSA:3.40.50.360:FF:000071', NULL, NULL, 'FMN-dependent NADH-azoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(81272, NULL, 'G3DSA:3.40.50.150:FF:001536', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81273, NULL, 'G3DSA:3.30.470.30:FF:000067', NULL, NULL, 'DNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81274, NULL, 'G3DSA:3.40.50.10490:FF:000033', NULL, NULL, 'Glucokinase regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(81275, NULL, 'G3DSA:3.40.309.10:FF:000089', NULL, NULL, 'Succinate-semialdehyde dehydrogenase mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(81276, NULL, 'G3DSA:3.30.230.70:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81277, NULL, 'G3DSA:3.30.1330.30:FF:000011', NULL, NULL, '40S ribosomal protein S12', NULL, NULL, NULL, NULL, NULL, 4),
(81278, NULL, 'G3DSA:3.80.10.10:FF:003459', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81279, NULL, 'G3DSA:2.40.30.10:FF:000289', NULL, NULL, 'Protein CBG03843', NULL, NULL, NULL, NULL, NULL, 4),
(81280, NULL, 'G3DSA:3.30.160.60:FF:002778', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81281, NULL, 'G3DSA:1.10.10.10:FF:001460', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81282, NULL, 'G3DSA:3.90.660.10:FF:000023', NULL, NULL, 'Putative polyamine oxidase 5', NULL, NULL, NULL, NULL, NULL, 4),
(81283, NULL, 'G3DSA:3.10.100.10:FF:000387', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81284, NULL, 'G3DSA:3.30.230.10:FF:000190', NULL, NULL, 'DNA repair protein RadA', NULL, NULL, NULL, NULL, NULL, 4),
(81285, NULL, 'G3DSA:3.90.640.10:FF:000134', NULL, NULL, 'Heat shock cognate 71 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(81286, NULL, 'G3DSA:3.40.50.720:FF:002573', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase 2 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(81287, NULL, 'G3DSA:1.20.1250.20:FF:000242', NULL, NULL, 'Solute carrier family 16 member 5', NULL, NULL, NULL, NULL, NULL, 4),
(81288, NULL, 'G3DSA:3.30.200.20:FF:002495', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81289, NULL, 'G3DSA:2.130.10.10:FF:003150', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', NULL, NULL, NULL, NULL, NULL, 4),
(81290, NULL, 'G3DSA:3.30.40.10:FF:001310', NULL, NULL, 'RING finger domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81291, NULL, 'G3DSA:1.10.287.3240:FF:000010', NULL, NULL, 'ATPase H+ transporting V1 subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(81292, NULL, 'G3DSA:3.40.50.300:FF:007910', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(81293, NULL, 'G3DSA:1.25.10.10:FF:002495', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(81294, NULL, 'G3DSA:1.10.10.10:FF:001550', NULL, NULL, 'Putative serine/threonine-protein kinase pats1', NULL, NULL, NULL, NULL, NULL, 4),
(81295, NULL, 'G3DSA:2.130.10.10:FF:002964', NULL, NULL, 'Cac2p', NULL, NULL, NULL, NULL, NULL, 4),
(81296, NULL, 'G3DSA:3.30.710.10:FF:000316', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81297, NULL, 'G3DSA:3.40.50.360:FF:000104', NULL, NULL, 'FMN-dependent NADH-azoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(81298, NULL, 'G3DSA:2.30.29.30:FF:001388', NULL, NULL, 'AGAP002982-PA', NULL, NULL, NULL, NULL, NULL, 4),
(81299, NULL, 'G3DSA:3.30.420.10:FF:000434', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81300, NULL, 'G3DSA:1.20.920.10:FF:000145', NULL, NULL, 'AaceriAEL291Cp', NULL, NULL, NULL, NULL, NULL, 4),
(81301, NULL, 'G3DSA:3.30.70.270:FF:000314', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81302, NULL, 'G3DSA:3.40.50.720:FF:002264', NULL, NULL, 'NADPH-dependent pterin aldehyde reductase', NULL, NULL, NULL, NULL, NULL, 4),
(81303, NULL, 'G3DSA:3.30.160.60:FF:003705', NULL, NULL, 'Zinc finger protein 142', NULL, NULL, NULL, NULL, NULL, 4),
(81304, NULL, 'G3DSA:3.80.10.10:FF:003768', NULL, NULL, 'SCF E3 ubiquitin ligase complex F-box protein GRR1', NULL, NULL, NULL, NULL, NULL, 4),
(81305, NULL, 'G3DSA:3.30.1460.20:FF:000012', NULL, NULL, 'Arp2/3 complex 34 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(81306, NULL, 'G3DSA:3.30.1360.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81307, NULL, 'G3DSA:4.10.240.10:FF:000022', NULL, NULL, 'Upc2p', NULL, NULL, NULL, NULL, NULL, 4),
(81308, NULL, 'G3DSA:3.30.160.60:FF:006488', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81309, NULL, 'G3DSA:1.10.10.60:FF:001194', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81310, NULL, 'G3DSA:3.30.190.20:FF:000003', NULL, NULL, 'UvrABC system protein A', NULL, NULL, NULL, NULL, NULL, 4),
(81311, NULL, 'G3DSA:3.55.40.20:FF:000009', NULL, NULL, 'Mitochondrial ribosomal small subunit component', NULL, NULL, NULL, NULL, NULL, 4),
(81312, NULL, 'G3DSA:1.10.132.110:FF:000001', NULL, NULL, 'Serum amyloid A protein', NULL, NULL, NULL, NULL, NULL, 4),
(81313, NULL, 'G3DSA:3.80.10.10:FF:000334', NULL, NULL, 'Leucine rich repeat containing 15', NULL, NULL, NULL, NULL, NULL, 4),
(81314, NULL, 'G3DSA:2.60.40.10:FF:001148', NULL, NULL, 'oncostatin-M-specific receptor subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(81315, NULL, 'G3DSA:4.10.60.10:FF:000164', NULL, NULL, 'Zinc knuckle nucleic acid binding protein, putative (AFU_orthologue AFUA_7G02190)', NULL, NULL, NULL, NULL, NULL, 4),
(81316, NULL, 'G3DSA:3.40.50.1910:FF:000001', NULL, NULL, 'syntaxin-binding protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(81317, NULL, 'G3DSA:1.20.1270.60:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81318, NULL, 'G3DSA:3.30.420.10:FF:000125', NULL, NULL, 'DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(81319, NULL, 'G3DSA:2.60.120.260:FF:000457', NULL, NULL, 'Laminin gamma 1 chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81320, NULL, 'G3DSA:3.30.40.10:FF:001001', NULL, NULL, 'RING-H2 finger protein 2B', NULL, NULL, NULL, NULL, NULL, 4),
(81321, NULL, 'G3DSA:3.30.710.10:FF:000007', NULL, NULL, 'Potassium voltage-gated channel subfamily A member 2', NULL, NULL, NULL, NULL, NULL, 4),
(81322, NULL, 'G3DSA:3.30.420.40:FF:000994', NULL, NULL, 'Heat shock cognate 70-kd protein, tandem duplicate 1', NULL, NULL, NULL, NULL, NULL, 4),
(81323, NULL, 'G3DSA:1.20.910.10:FF:000010', NULL, NULL, 'Aminopyrimidine aminohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(81324, NULL, 'G3DSA:3.40.50.1820:FF:000272', NULL, NULL, 'Aminopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81325, NULL, 'G3DSA:1.25.40.10:FF:000844', NULL, NULL, 'Tetratricopeptide repeat/TPR repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81326, NULL, 'G3DSA:2.30.42.10:FF:000390', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81327, NULL, 'G3DSA:1.20.120.1750:FF:000039', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(81328, NULL, 'G3DSA:2.60.120.200:FF:000810', NULL, NULL, 'Putative L-type lectin-domain containing receptor kinase S.5', NULL, NULL, NULL, NULL, NULL, 4),
(81329, NULL, 'G3DSA:1.25.40.10:FF:003042', NULL, NULL, 'Pentatricopeptide repeat-containing protein ATP4, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(81330, NULL, 'G3DSA:3.40.50.1820:FF:000406', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81331, NULL, 'G3DSA:1.10.1300.10:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81332, NULL, 'G3DSA:2.10.25.10:FF:000238', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(81333, NULL, 'G3DSA:1.10.8.10:FF:000200', NULL, NULL, 'Protein CBG01857', NULL, NULL, NULL, NULL, NULL, 4),
(81334, NULL, 'G3DSA:2.20.100.10:FF:000107', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(81335, NULL, 'G3DSA:2.40.50.140:FF:000817', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81336, NULL, 'G3DSA:3.30.450.20:FF:000383', NULL, NULL, 'Phytochrome', NULL, NULL, NULL, NULL, NULL, 4),
(81337, NULL, 'G3DSA:3.40.1470.10:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81338, NULL, 'G3DSA:3.40.50.10490:FF:000140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81339, NULL, 'G3DSA:3.40.50.12780:FF:000170', NULL, NULL, 'SA protein', NULL, NULL, NULL, NULL, NULL, 4),
(81340, NULL, 'G3DSA:1.20.1070.10:FF:000910', NULL, NULL, 'Si:dkey-7c18.10 protein', NULL, NULL, NULL, NULL, NULL, 4),
(81341, NULL, 'G3DSA:3.40.630.30:FF:000313', NULL, NULL, 'Probable N-acetyltransferase camello', NULL, NULL, NULL, NULL, NULL, 4),
(81342, NULL, 'G3DSA:3.30.230.10:FF:000173', NULL, NULL, 'DNA repair protein RadA', NULL, NULL, NULL, NULL, NULL, 4),
(81343, NULL, 'G3DSA:4.10.280.10:FF:000120', NULL, NULL, 'Spermatogenesis and oogenesis specific basic helix-loop-helix 1', NULL, NULL, NULL, NULL, NULL, 4),
(81344, NULL, 'G3DSA:2.40.160.40:FF:000003', NULL, NULL, 'Outer membrane porin G', NULL, NULL, NULL, NULL, NULL, 4),
(81345, NULL, 'G3DSA:3.80.20.20:FF:000074', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(81346, NULL, 'G3DSA:3.30.420.40:FF:000887', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81347, NULL, 'G3DSA:2.60.40.10:FF:005420', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81348, NULL, 'G3DSA:3.40.50.150:FF:001115', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81349, NULL, 'G3DSA:3.90.176.10:FF:000009', NULL, NULL, 'NAD(P)(+)--arginine ADP-ribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(81350, NULL, 'G3DSA:3.30.200.20:FF:001180', NULL, NULL, 'Cyclin-dependent kinase 7', NULL, NULL, NULL, NULL, NULL, 4),
(81351, NULL, 'G3DSA:2.60.40.10:FF:001137', NULL, NULL, 'Receptor protein-tyrosine phosphatase 10d', NULL, NULL, NULL, NULL, NULL, 4),
(81352, NULL, 'G3DSA:3.40.50.170:FF:000019', NULL, NULL, 'Methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(81353, NULL, 'G3DSA:3.40.367.20:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81354, NULL, 'G3DSA:2.160.20.10:FF:000299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81355, NULL, 'G3DSA:2.40.40.20:FF:000011', NULL, NULL, 'Formate dehydrogenase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(81356, NULL, 'G3DSA:2.60.40.1400:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81357, NULL, 'G3DSA:2.60.40.10:FF:003166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81358, NULL, 'G3DSA:1.25.40.10:FF:004565', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(81359, NULL, 'G3DSA:2.40.160.50:FF:000006', NULL, NULL, 'Outer envelope protein 80, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(81360, NULL, 'G3DSA:3.30.420.40:FF:000792', NULL, NULL, 'YALI0E13255p', NULL, NULL, NULL, NULL, NULL, 4),
(81361, NULL, 'G3DSA:1.20.900.10:FF:000054', NULL, NULL, 'CDC-42 Guanine nucleotide Exchange Factor', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(81362, NULL, 'G3DSA:3.40.190.10:FF:000756', NULL, NULL, 'Transferrin', NULL, NULL, NULL, NULL, NULL, 4),
(81363, NULL, 'G3DSA:3.40.50.720:FF:000460', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] reductase FabG1', NULL, NULL, NULL, NULL, NULL, 4),
(81364, NULL, 'G3DSA:3.40.50.300:FF:003650', NULL, NULL, 'Hypothetical alanine and arginine rich protein', NULL, NULL, NULL, NULL, NULL, 4),
(81365, NULL, 'G3DSA:3.90.1580.10:FF:000015', NULL, NULL, 'Chaperone protein LppX', NULL, NULL, NULL, NULL, NULL, 4),
(81366, NULL, 'G3DSA:2.130.10.10:FF:001115', NULL, NULL, 'Intraflagellar transport 80 homolog (Chlamydomonas)', NULL, NULL, NULL, NULL, NULL, 4),
(81367, NULL, 'G3DSA:3.80.10.10:FF:000564', NULL, NULL, 'P53-induced death domain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(81368, NULL, 'G3DSA:2.20.100.10:FF:000012', NULL, NULL, 'Adhesion G protein-coupled receptor B2', NULL, NULL, NULL, NULL, NULL, 4),
(81369, NULL, 'G3DSA:3.30.160.60:FF:000974', NULL, NULL, 'zinc finger protein 582 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(81370, NULL, 'G3DSA:1.20.58.1120:FF:000011', NULL, NULL, 'Dynein, axonemal, heavy chain 6', NULL, NULL, NULL, NULL, NULL, 4),
(81371, NULL, 'G3DSA:3.90.226.10:FF:000138', NULL, NULL, 'Putative 3-hydroxybutyryl-CoA dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(81372, NULL, 'G3DSA:1.10.510.10:FF:001139', NULL, NULL, 'Protein kinase domain containing, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(81373, NULL, 'G3DSA:1.10.630.10:FF:000114', NULL, NULL, 'Os06g0642500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(81374, NULL, 'G3DSA:3.30.160.60:FF:005274', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81375, NULL, 'G3DSA:1.25.40.10:FF:003137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81376, NULL, 'G3DSA:1.10.287.70:FF:000086', NULL, NULL, 'Polycystic kidney disease 2', NULL, NULL, NULL, NULL, NULL, 4),
(81377, NULL, 'G3DSA:3.40.50.80:FF:000106', NULL, NULL, 'Ferric reductase transmembrane component', NULL, NULL, NULL, NULL, NULL, 4),
(81378, NULL, 'G3DSA:3.30.1520.10:FF:000065', NULL, NULL, 'PX domain protein (AFU_orthologue AFUA_2G07450)', NULL, NULL, NULL, NULL, NULL, 4),
(81379, NULL, 'G3DSA:2.40.30.300:FF:000002', NULL, NULL, 'superkiller viralicidic activity 2-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(81380, NULL, 'G3DSA:2.30.280.10:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81381, NULL, 'G3DSA:1.10.8.100:FF:000030', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(81382, NULL, 'G3DSA:1.20.1560.10:FF:000329', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(81383, NULL, 'G3DSA:1.10.555.10:FF:000040', NULL, NULL, 'Family with sequence similarity 13 member A', NULL, NULL, NULL, NULL, NULL, 4),
(81384, NULL, 'G3DSA:3.40.850.10:FF:000094', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(81385, NULL, 'G3DSA:1.25.40.10:FF:004239', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(81386, NULL, 'G3DSA:1.20.1730.10:FF:000034', NULL, NULL, 'Sodium:solute symporter', NULL, NULL, NULL, NULL, NULL, 4),
(81387, NULL, 'G3DSA:2.60.40.420:FF:000075', NULL, NULL, 'hephaestin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(81388, NULL, 'G3DSA:3.10.20.90:FF:000867', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81389, NULL, 'G3DSA:3.40.50.300:FF:001407', NULL, NULL, 'ZGRF1 isoform 9', NULL, NULL, NULL, NULL, NULL, 4),
(81390, NULL, 'G3DSA:1.20.1250.10:FF:000003', NULL, NULL, 'Prolactin', NULL, NULL, NULL, NULL, NULL, 4),
(81391, NULL, 'G3DSA:3.30.40.10:FF:000826', NULL, NULL, 'Peroxisome biogenesis factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(81392, NULL, 'G3DSA:3.30.56.10:FF:000037', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(81393, NULL, 'G3DSA:3.40.50.80:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81394, NULL, 'G3DSA:1.25.40.180:FF:000171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(81395, NULL, 'G3DSA:1.10.10.10:FF:000628', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(81396, NULL, 'G3DSA:1.10.1370.10:FF:000014', NULL, NULL, 'Thimet oligopeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(81397, NULL, 'G3DSA:3.10.450.50:FF:000048', NULL, NULL, 'Anthranilate 1,2-dioxygenase small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(81398, NULL, 'G3DSA:1.10.10.60:FF:001093', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81399, NULL, 'G3DSA:3.40.50.300:FF:005095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81400, NULL, 'G3DSA:3.30.70.330:FF:002625', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81401, NULL, 'G3DSA:3.30.70.330:FF:001102', NULL, NULL, 'Cleavage and Polyadenylation Factor', NULL, NULL, NULL, NULL, NULL, 4),
(81402, NULL, 'G3DSA:2.10.109.10:FF:000040', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(81403, NULL, 'G3DSA:3.30.40.10:FF:002064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81404, NULL, 'G3DSA:1.10.510.10:FF:001465', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81405, NULL, 'G3DSA:3.40.50.720:FF:000555', NULL, NULL, 'Probable 2-ketogluconate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(81406, NULL, 'G3DSA:2.60.40.1120:FF:000058', NULL, NULL, 'Gram-negative bacterial tonB protein', NULL, NULL, NULL, NULL, NULL, 4),
(81407, NULL, 'G3DSA:3.40.50.150:FF:000013', NULL, NULL, 'Spermidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(81408, NULL, 'G3DSA:3.40.50.300:FF:004847', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(81409, NULL, 'G3DSA:3.30.710.10:FF:000215', NULL, NULL, 'CRE-KVS-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(81410, NULL, 'G3DSA:3.30.70.3290:FF:000007', NULL, NULL, 'Putative polyketide synthase MbtD', NULL, NULL, NULL, NULL, NULL, 4),
(81411, NULL, 'G3DSA:3.30.160.60:FF:001249', NULL, NULL, 'CTCF', NULL, NULL, NULL, NULL, NULL, 4),
(81412, NULL, 'G3DSA:1.10.150.20:FF:000075', NULL, NULL, 'Meiotic recombination protein DMC1', NULL, NULL, NULL, NULL, NULL, 4),
(81413, NULL, 'G3DSA:2.10.70.10:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81414, NULL, 'G3DSA:3.40.50.1480:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81415, NULL, 'G3DSA:2.170.130.10:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81416, NULL, 'G3DSA:3.30.160.60:FF:001800', NULL, NULL, 'Zinc finger protein 467', NULL, NULL, NULL, NULL, NULL, 4),
(81417, NULL, 'G3DSA:1.10.8.430:FF:000010', NULL, NULL, 'Transmembrane receptors / ATP binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(81418, NULL, 'G3DSA:1.10.238.10:FF:000938', NULL, NULL, 'Putative calcium-binding protein CML47', NULL, NULL, NULL, NULL, NULL, 4),
(81419, NULL, 'G3DSA:2.60.98.60:FF:000003', NULL, NULL, 'EFF-1A', NULL, NULL, NULL, NULL, NULL, 4),
(81420, NULL, 'G3DSA:3.30.70.360:FF:000009', NULL, NULL, 'aminoacylase-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(81421, NULL, 'G3DSA:3.30.70.3270:FF:000001', NULL, NULL, 'NADH-quinone oxidoreductase subunit I 1', NULL, NULL, NULL, NULL, NULL, 4),
(81422, NULL, 'G3DSA:1.20.1560.10:FF:000543', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81423, NULL, 'G3DSA:2.130.10.10:FF:002638', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(81424, NULL, 'G3DSA:2.60.40.10:FF:001463', NULL, NULL, 'Probable beta-D-xylosidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(81425, NULL, 'G3DSA:3.30.70.330:FF:000922', NULL, NULL, 'RNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(81426, NULL, 'G3DSA:3.30.200.20:FF:000348', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(81427, NULL, 'G3DSA:2.60.120.200:FF:000456', NULL, NULL, 'AGRin (Synaptic protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(81428, NULL, 'G3DSA:3.10.450.40:FF:000045', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(81429, NULL, 'G3DSA:3.40.50.720:FF:001983', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(81430, NULL, 'G3DSA:3.40.50.150:FF:001441', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81431, NULL, 'G3DSA:2.40.50.140:FF:000138', NULL, NULL, 'Protection of telomeres 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(81432, NULL, 'G3DSA:4.10.260.10:FF:000006', NULL, NULL, 'Guanine nucleotide-binding protein subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(81433, NULL, 'G3DSA:3.40.50.300:FF:003436', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(81434, NULL, 'G3DSA:1.10.287.370:FF:000007', NULL, NULL, 'UXT isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(81435, NULL, 'G3DSA:1.10.630.10:FF:000440', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81436, NULL, 'G3DSA:2.60.40.10:FF:003380', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81437, NULL, 'G3DSA:2.130.10.10:FF:001441', NULL, NULL, 'Protein TRANSPARENT TESTA GLABRA, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81438, NULL, 'G3DSA:3.20.20.190:FF:000063', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(81439, NULL, 'G3DSA:3.40.50.11660:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81440, NULL, 'G3DSA:3.40.50.1980:FF:000089', NULL, NULL, 'Periplasmic solute binding family protein', NULL, NULL, NULL, NULL, NULL, 4),
(81441, NULL, 'G3DSA:3.30.70.1040:FF:000001', NULL, NULL, 'Dystroglycan 1', NULL, NULL, NULL, NULL, NULL, 4),
(81442, NULL, 'G3DSA:3.40.50.1460:FF:000023', NULL, NULL, 'Lys-gingipain W83', NULL, NULL, NULL, NULL, NULL, 4),
(81443, NULL, 'G3DSA:3.40.50.410:FF:000243', NULL, NULL, 'VWA domain containing CoxE-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(81444, NULL, 'G3DSA:2.30.30.40:FF:000618', NULL, NULL, 'Discs, large homolog 4a (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(81445, NULL, 'G3DSA:1.20.1050.60:FF:000008', NULL, NULL, 'Alpha-1,2-mannosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81446, NULL, 'G3DSA:3.40.50.300:FF:003324', NULL, NULL, 'Rab family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(81447, NULL, 'G3DSA:3.30.2350.10:FF:000018', NULL, NULL, 'tRNA pseudouridine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(81448, NULL, 'G3DSA:1.20.120.610:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81449, NULL, 'G3DSA:2.60.120.260:FF:000660', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(81450, NULL, 'G3DSA:3.30.40.10:FF:000147', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 16', NULL, NULL, NULL, NULL, NULL, 4),
(81451, NULL, 'G3DSA:4.10.60.10:FF:000265', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(81452, NULL, 'G3DSA:3.40.640.10:FF:000494', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81453, NULL, 'G3DSA:1.10.510.10:FF:000864', NULL, NULL, 'Vps15 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(81454, NULL, 'G3DSA:3.30.1330.40:FF:000003', NULL, NULL, 'Putative aminoacrylate peracid reductase RutC', NULL, NULL, NULL, NULL, NULL, 4),
(81455, NULL, 'G3DSA:1.20.1270.60:FF:000215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81456, NULL, 'G3DSA:3.40.50.720:FF:000229', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(81457, NULL, 'G3DSA:1.10.1080.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81458, NULL, 'G3DSA:3.40.1110.10:FF:000402', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81459, NULL, 'G3DSA:1.10.10.60:FF:001104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81460, NULL, 'G3DSA:3.40.366.10:FF:000070', NULL, NULL, 'Acyl transferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(81461, NULL, 'G3DSA:3.30.1330.50:FF:000006', NULL, NULL, '2-C-methyl-D-erythritol 2,4-cyclodiphosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(81462, NULL, 'G3DSA:3.40.850.10:FF:000431', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(81463, NULL, 'G3DSA:1.20.58.60:FF:000516', NULL, NULL, 'Spectrin repeat containing, nuclear envelope 1a', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(81464, NULL, 'G3DSA:3.80.10.10:FF:001880', NULL, NULL, 'Leucine-rich transmembrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81465, NULL, 'G3DSA:1.20.1050.40:FF:000002', NULL, NULL, 'Oligopeptidase A', NULL, NULL, NULL, NULL, NULL, 4),
(81466, NULL, 'G3DSA:2.30.29.30:FF:000180', NULL, NULL, 'Exocyst complex component 8', NULL, NULL, NULL, NULL, NULL, 4),
(81467, NULL, 'G3DSA:3.50.7.10:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81468, NULL, 'G3DSA:1.20.1070.10:FF:000573', NULL, NULL, 'SERotonin/octopamine receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(81469, NULL, 'G3DSA:3.30.70.330:FF:000585', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein Q', NULL, NULL, NULL, NULL, NULL, 4),
(81470, NULL, 'G3DSA:1.20.1080.10:FF:000080', NULL, NULL, 'VM23, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81471, NULL, 'G3DSA:1.10.287.1150:FF:000012', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(81472, NULL, 'G3DSA:1.10.287.10:FF:000012', NULL, NULL, 'Ataxin-3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(81473, NULL, 'G3DSA:3.90.70.10:FF:000596', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81474, NULL, 'G3DSA:1.10.472.10:FF:000645', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81475, NULL, 'G3DSA:3.30.160.60:FF:003503', NULL, NULL, 'Zinc finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81476, NULL, 'G3DSA:3.30.70.1050:FF:000004', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(81477, NULL, 'G3DSA:1.10.3660.10:FF:000003', NULL, NULL, 'Prephenate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(81478, NULL, 'G3DSA:3.40.50.620:FF:000093', NULL, NULL, 'Glutamyl-Q tRNA(Asp) synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(81479, NULL, 'G3DSA:3.40.50.1580:FF:000059', NULL, NULL, 'Probable purine-nucleoside phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(81480, NULL, 'G3DSA:3.30.40.10:FF:002176', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(81481, NULL, 'G3DSA:3.40.50.300:FF:000795', NULL, NULL, 'Tetratricopeptide repeat protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(81482, NULL, 'G3DSA:1.10.418.30:FF:000008', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(81483, NULL, 'G3DSA:2.60.40.10:FF:004689', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81484, NULL, 'G3DSA:2.40.50.140:FF:000464', NULL, NULL, 'Translation initiation factor 5A', NULL, NULL, NULL, NULL, NULL, 4),
(81485, NULL, 'G3DSA:1.10.287.130:FF:000071', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(81486, NULL, 'G3DSA:3.20.20.80:FF:000335', NULL, NULL, 'Beta-1,3-xylanase TXYA', NULL, NULL, NULL, NULL, NULL, 4),
(81487, NULL, 'G3DSA:3.30.110.10:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81488, NULL, 'G3DSA:1.10.10.10:FF:000954', NULL, NULL, 'Transcriptional regulator, MarR family', NULL, NULL, NULL, NULL, NULL, 4),
(81489, NULL, 'G3DSA:2.130.10.10:FF:005156', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(81490, NULL, 'G3DSA:3.40.50.2000:FF:000915', NULL, NULL, 'Mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(81491, NULL, 'G3DSA:3.30.40.10:FF:000714', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(81492, NULL, 'G3DSA:2.130.10.10:FF:003470', NULL, NULL, 'Putative surface layer protein, with cytochrome c domain', NULL, NULL, NULL, NULL, NULL, 4),
(81493, NULL, 'G3DSA:3.40.50.10330:FF:000120', NULL, NULL, 'Ceramide kinase-like isoform 7', NULL, NULL, NULL, NULL, NULL, 4),
(81494, NULL, 'G3DSA:1.20.1050.130:FF:000043', NULL, NULL, 'Uncharacterized protein DpGSTS3', NULL, NULL, NULL, NULL, NULL, 4),
(81495, NULL, 'G3DSA:2.130.10.10:FF:004881', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81496, NULL, 'G3DSA:3.40.718.10:FF:000045', NULL, NULL, 'NAD (H)-specific isocitrate dehydrogenase gamma subunit', NULL, NULL, NULL, NULL, NULL, 4),
(81497, NULL, 'G3DSA:3.50.50.60:FF:000605', NULL, NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(81498, NULL, 'G3DSA:4.10.240.10:FF:000011', NULL, NULL, 'Transcriptional activator of proteases prtT', NULL, NULL, NULL, NULL, NULL, 4),
(81499, NULL, 'G3DSA:3.30.1680.40:FF:000001', NULL, NULL, 'Variant surface glycoprotein (VSG, atypical), putative', NULL, NULL, NULL, NULL, NULL, 4),
(81500, NULL, 'G3DSA:3.40.50.720:FF:000134', NULL, NULL, 'K(+) efflux antiporter 2 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(81501, NULL, 'G3DSA:1.10.10.10:FF:001229', NULL, NULL, 'RNA polymerase III subunit C3', NULL, NULL, NULL, NULL, NULL, 4),
(81502, NULL, 'G3DSA:2.60.40.10:FF:003503', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81503, NULL, 'G3DSA:3.30.110.20:FF:000015', NULL, NULL, 'AGAP002362-PA', NULL, NULL, NULL, NULL, NULL, 4),
(81504, NULL, 'G3DSA:1.10.510.10:FF:001353', NULL, NULL, 'Predicted gene 6176', NULL, NULL, NULL, NULL, NULL, 4),
(81505, NULL, 'G3DSA:2.10.25.10:FF:000143', NULL, NULL, 'Protein crumbs 1', NULL, NULL, NULL, NULL, NULL, 4),
(81506, NULL, 'G3DSA:1.20.1420.30:FF:000056', NULL, NULL, 'Uncharacterized protein, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(81507, NULL, 'G3DSA:3.40.800.10:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81508, NULL, 'G3DSA:2.10.25.10:FF:001649', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81509, NULL, 'G3DSA:1.20.5.120:FF:000005', NULL, NULL, 'Proteasome activator subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(81510, NULL, 'G3DSA:2.40.50.90:FF:000162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81511, NULL, 'G3DSA:1.20.5.110:FF:000002', NULL, NULL, 'Vesicle transport through interaction with t-SNAREsB', NULL, NULL, NULL, NULL, NULL, 4),
(81512, NULL, 'G3DSA:1.25.10.10:FF:001202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81513, NULL, 'G3DSA:3.60.20.10:FF:000234', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81514, NULL, 'G3DSA:2.130.10.10:FF:004667', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81515, NULL, 'G3DSA:2.30.30.140:FF:000310', NULL, NULL, 'Tudor domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(81516, NULL, 'G3DSA:3.40.50.1820:FF:000069', NULL, NULL, 'monoacylglycerol lipase ABHD12', NULL, NULL, NULL, NULL, NULL, 4),
(81517, NULL, 'G3DSA:3.30.160.60:FF:001912', NULL, NULL, 'Hamlet, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(81518, NULL, 'G3DSA:3.80.10.10:FF:001975', NULL, NULL, 'Leucine-rich repeat protein lrrA', NULL, NULL, NULL, NULL, NULL, 4),
(81519, NULL, 'G3DSA:1.25.10.10:FF:002697', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81520, NULL, 'G3DSA:3.20.20.140:FF:000413', NULL, NULL, 'Dihydropyrimidinase', NULL, NULL, NULL, NULL, NULL, 4),
(81521, NULL, 'G3DSA:1.10.10.10:FF:001443', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(81522, NULL, 'G3DSA:2.30.30.940:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(81523, NULL, 'G3DSA:3.40.50.620:FF:000188', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(81524, NULL, 'G3DSA:3.90.79.10:FF:000256', NULL, NULL, 'MutT/nudix family protein', NULL, NULL, NULL, NULL, NULL, 4),
(81525, NULL, 'G3DSA:1.25.40.10:FF:002199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81526, NULL, 'G3DSA:2.60.40.10:FF:001351', NULL, NULL, 'Myomesin 3', NULL, NULL, NULL, NULL, NULL, 4),
(81527, NULL, 'G3DSA:3.40.50.2000:FF:000236', NULL, NULL, 'Putative dolichyl-P-Man:GDP-Man1GlcNAc2-PP-dolichyl alpha-1,3-mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(81528, NULL, 'G3DSA:1.20.1250.20:FF:002035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81529, NULL, 'G3DSA:2.60.40.1490:FF:000005', NULL, NULL, 'Anti-silencing protein ASF 1 like protein', NULL, NULL, NULL, NULL, NULL, 4),
(81530, NULL, 'G3DSA:2.60.260.20:FF:000079', NULL, NULL, 'Chaperone protein DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(81531, NULL, 'G3DSA:1.10.510.10:FF:003505', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(81532, NULL, 'G3DSA:3.30.40.10:FF:002390', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(81533, NULL, 'G3DSA:3.40.1190.20:FF:000056', NULL, NULL, 'Ribokinase', NULL, NULL, NULL, NULL, NULL, 4),
(81534, NULL, 'G3DSA:3.40.50.150:FF:000598', NULL, NULL, 'Tetracenpmycin polyketide synthesis 8-o-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(81535, NULL, 'G3DSA:3.30.70.330:FF:002951', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81536, NULL, 'G3DSA:1.25.40.10:FF:001013', NULL, NULL, 'Probable UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SPINDLY', NULL, NULL, NULL, NULL, NULL, 4),
(81537, NULL, 'G3DSA:1.20.1540.10:FF:000008', NULL, NULL, 'RHOMBOID-like protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(81538, NULL, 'G3DSA:3.20.20.80:FF:000094', NULL, NULL, 'Endo-1,4-beta-xylanase', NULL, NULL, NULL, NULL, NULL, 4),
(81539, NULL, 'G3DSA:3.30.200.20:FF:000786', NULL, NULL, 'Protein kinase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(81540, NULL, 'G3DSA:3.40.50.2000:FF:000562', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(81541, NULL, 'G3DSA:3.30.230.10:FF:000285', NULL, NULL, 'Elongation factor G 2', NULL, NULL, NULL, NULL, NULL, 4),
(81542, NULL, 'G3DSA:2.10.25.10:FF:000126', NULL, NULL, 'Matrilin 3', NULL, NULL, NULL, NULL, NULL, 4),
(81543, NULL, 'G3DSA:3.40.1800.20:FF:000020', NULL, NULL, 'LD21421p', NULL, NULL, NULL, NULL, NULL, 4),
(81544, NULL, 'G3DSA:1.10.472.80:FF:000042', NULL, NULL, 'carabin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(81545, NULL, 'G3DSA:1.50.10.20:FF:000045', NULL, NULL, 'Prenyltransferase and squalene oxidase repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(81546, NULL, 'G3DSA:3.30.170.10:FF:000004', NULL, NULL, 'Cyclin-dependent kinases regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(81547, NULL, 'G3DSA:3.80.10.10:FF:000452', NULL, NULL, 'Probable LRR receptor-like serine/threonine-protein kinase RFK1', NULL, NULL, NULL, NULL, NULL, 4),
(81548, NULL, 'G3DSA:1.25.40.10:FF:005054', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g20090', NULL, NULL, NULL, NULL, NULL, 4),
(81549, NULL, 'G3DSA:1.10.2000.10:FF:000021', NULL, NULL, 'Blast:Protein smoothened', NULL, NULL, NULL, NULL, NULL, 4),
(81550, NULL, 'G3DSA:1.10.437.10:FF:000041', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(81551, NULL, 'G3DSA:2.40.50.140:FF:000705', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81552, NULL, 'G3DSA:2.60.40.10:FF:001249', NULL, NULL, 'Tenascin R', NULL, NULL, NULL, NULL, NULL, 4),
(81553, NULL, 'G3DSA:3.40.50.300:FF:007461', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81554, NULL, 'G3DSA:1.50.10.10:FF:000042', NULL, NULL, 'Unsaturated chondroitin disaccharide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(81555, NULL, 'G3DSA:3.40.50.10810:FF:000186', NULL, NULL, 'SWF/SNF family helicase', NULL, NULL, NULL, NULL, NULL, 4),
(81556, NULL, 'G3DSA:1.10.150.220:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81557, NULL, 'G3DSA:3.30.160.20:FF:000164', NULL, NULL, 'Nkrf protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81558, NULL, 'G3DSA:1.10.510.10:FF:001802', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(81559, NULL, 'G3DSA:3.30.70.330:FF:000259', NULL, NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(81560, NULL, 'G3DSA:3.30.710.10:FF:000092', NULL, NULL, 'Germ cell-less, spermatogenesis associated 1', NULL, NULL, NULL, NULL, NULL, 4),
(81561, NULL, 'G3DSA:1.10.150.20:FF:000092', NULL, NULL, 'DNA excision repair protein Rad2', NULL, NULL, NULL, NULL, NULL, 4),
(81562, NULL, 'G3DSA:3.30.70.370:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81563, NULL, 'G3DSA:3.30.70.330:FF:002737', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81564, NULL, 'G3DSA:3.40.50.720:FF:000572', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(81565, NULL, 'G3DSA:3.40.1180.10:FF:000013', NULL, NULL, 'Alkyl transferase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(81566, NULL, 'G3DSA:1.20.120.1240:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81567, NULL, 'G3DSA:2.60.40.60:FF:000848', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81568, NULL, 'G3DSA:3.40.190.10:FF:000644', NULL, NULL, 'Extracellular solute-binding protein family 1', NULL, NULL, NULL, NULL, NULL, 4),
(81569, NULL, 'G3DSA:1.20.1450.10:FF:000001', NULL, NULL, 'Particulate methane monooxygenase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(81570, NULL, 'G3DSA:2.60.450.10:FF:000017', NULL, NULL, 'Lipopolysaccharide export system protein LptC', NULL, NULL, NULL, NULL, NULL, 4),
(81571, NULL, 'G3DSA:3.40.250.10:FF:000014', NULL, NULL, 'Adenylyltransferase and sulfurtransferase MOCS3', NULL, NULL, NULL, NULL, NULL, 4),
(81572, NULL, 'G3DSA:1.25.40.20:FF:001358', NULL, NULL, 'Similar to ankyrin homolog [precursor]', NULL, NULL, NULL, NULL, NULL, 4),
(81573, NULL, 'G3DSA:1.10.2020.20:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81574, NULL, 'G3DSA:3.30.70.360:FF:000026', NULL, NULL, 'Putative peptidase M20/M25/M40', NULL, NULL, NULL, NULL, NULL, 4),
(81575, NULL, 'G3DSA:3.90.640.10:FF:000252', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(81576, NULL, 'G3DSA:3.30.470.20:FF:000171', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(81577, NULL, 'G3DSA:2.60.40.60:FF:001124', NULL, NULL, 'Dachsous cadherin-related 2', NULL, NULL, NULL, NULL, NULL, 4),
(81578, NULL, 'G3DSA:1.20.1160.11:FF:000008', NULL, NULL, 'Paired amphipathic helix protein Sin3', NULL, NULL, NULL, NULL, NULL, 4),
(81579, NULL, 'G3DSA:3.10.100.10:FF:000179', NULL, NULL, 'Surfactant protein A', NULL, NULL, NULL, NULL, NULL, 4),
(81580, NULL, 'G3DSA:2.40.128.20:FF:000012', NULL, NULL, 'Alpha-1-acid glycoprotein 2', NULL, NULL, NULL, NULL, NULL, 4),
(81581, NULL, 'G3DSA:3.30.230.70:FF:000067', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(81582, NULL, 'G3DSA:3.30.60.90:FF:000014', NULL, NULL, 'E3 ubiquitin-protein ligase PRT1', NULL, NULL, NULL, NULL, NULL, 4),
(81583, NULL, 'G3DSA:2.130.10.10:FF:003032', NULL, NULL, 'WD repeat-containing protein GTS1', NULL, NULL, NULL, NULL, NULL, 4),
(81584, NULL, 'G3DSA:1.20.1250.20:FF:000348', NULL, NULL, '1-acyl-sn-glycerol-3-phosphate acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(81585, NULL, 'G3DSA:1.25.10.10:FF:000100', NULL, NULL, 'phosphoinositide 3-kinase regulatory subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(81586, NULL, 'G3DSA:3.40.50.300:FF:003419', NULL, NULL, 'DNA helicase 2', NULL, NULL, NULL, NULL, NULL, 4),
(81587, NULL, 'G3DSA:3.80.10.10:FF:004049', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(81588, NULL, 'G3DSA:3.90.190.10:FF:000273', NULL, NULL, 'Receptor protein-tyrosine phosphatase 10D, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81589, NULL, 'G3DSA:1.25.40.10:FF:000849', NULL, NULL, 'Pre-mRNA-splicing factor SYF1', NULL, NULL, NULL, NULL, NULL, 4),
(81590, NULL, 'G3DSA:3.80.10.10:FF:002481', NULL, NULL, 'Peroxidasin like', NULL, NULL, NULL, NULL, NULL, 4),
(81591, NULL, 'G3DSA:2.130.10.110:FF:000015', NULL, NULL, 'Clathrin heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(81592, NULL, 'G3DSA:3.30.420.10:FF:000226', NULL, NULL, 'Exodeoxyribonuclease I', NULL, NULL, NULL, NULL, NULL, 4),
(81593, NULL, 'G3DSA:2.40.10.10:FF:000198', NULL, NULL, 'Glandular kallikrein-10', NULL, NULL, NULL, NULL, NULL, 4),
(81594, NULL, 'G3DSA:1.25.40.20:FF:001128', NULL, NULL, 'VPS9 domain protein, putative (AFU_orthologue AFUA_1G09870)', NULL, NULL, NULL, NULL, NULL, 4),
(81595, NULL, 'G3DSA:3.40.30.10:FF:001186', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(81596, NULL, 'G3DSA:4.10.240.10:FF:000123', NULL, NULL, 'Weak acid response element-binding transcriptional factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81597, NULL, 'G3DSA:2.60.40.10:FF:005403', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81598, NULL, 'G3DSA:3.30.870.10:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(81599, NULL, 'G3DSA:3.30.780.10:FF:000040', NULL, NULL, 'Eukaryotic translation initiation factor 2D', NULL, NULL, NULL, NULL, NULL, 4),
(81600, NULL, 'G3DSA:2.30.42.10:FF:000047', NULL, NULL, 'MAGUK p55 subfamily member 6', NULL, NULL, NULL, NULL, NULL, 4),
(81601, NULL, 'G3DSA:3.40.50.170:FF:000036', NULL, NULL, 'Phosphoribosylglycinamide formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(81602, NULL, 'G3DSA:2.60.40.10:FF:004577', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81603, NULL, 'G3DSA:2.30.29.220:FF:000001', NULL, NULL, 'FACT complex subunit SSRP1', NULL, NULL, NULL, NULL, NULL, 4),
(81604, NULL, 'G3DSA:1.10.287.70:FF:000209', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(81605, NULL, 'G3DSA:3.30.420.370:FF:000002', NULL, NULL, 'Type II secretion system protein L', NULL, NULL, NULL, NULL, NULL, 4),
(81606, NULL, 'G3DSA:3.40.50.300:FF:007702', NULL, NULL, 'Uncharacterized protein YddE', NULL, NULL, NULL, NULL, NULL, 4),
(81607, NULL, 'G3DSA:3.40.50.1110:FF:000053', NULL, NULL, 'Spore gernimation protein', NULL, NULL, NULL, NULL, NULL, 4),
(81608, NULL, 'G3DSA:2.60.120.200:FF:000670', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81609, NULL, 'G3DSA:3.40.140.70:FF:000001', NULL, NULL, 'Ubiquitin-like modifier-activating enzyme atg7', NULL, NULL, NULL, NULL, NULL, 4),
(81610, NULL, 'G3DSA:3.40.33.10:FF:000023', NULL, NULL, 'Pathogenesis-related protein-1-like', NULL, NULL, NULL, NULL, NULL, 4),
(81611, NULL, 'G3DSA:2.160.20.10:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81612, NULL, 'G3DSA:3.30.70.270:FF:000213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81613, NULL, 'G3DSA:1.25.10.10:FF:001623', NULL, NULL, 'Pumilio-like 24 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(81614, NULL, 'G3DSA:1.10.1450.10:FF:000178', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(81615, NULL, 'G3DSA:2.60.40.10:FF:003149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81616, NULL, 'G3DSA:1.10.10.10:FF:001117', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(81617, NULL, 'G3DSA:1.10.8.140:FF:000013', NULL, NULL, 'DNA-binding protein A3L02_08620', NULL, NULL, NULL, NULL, NULL, 4),
(81618, NULL, 'G3DSA:2.130.10.10:FF:005510', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81619, NULL, 'G3DSA:3.30.160.60:FF:002986', NULL, NULL, 'Zinc finger protein 208', NULL, NULL, NULL, NULL, NULL, 4),
(81620, NULL, 'G3DSA:3.30.420.380:FF:000005', NULL, NULL, 'Type II secretion system protein L', NULL, NULL, NULL, NULL, NULL, 4),
(81621, NULL, 'G3DSA:2.60.120.340:FF:000032', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(81622, NULL, 'G3DSA:3.80.10.10:FF:000126', NULL, NULL, 'F-box/LRR-repeat protein 7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(81623, NULL, 'G3DSA:2.130.10.10:FF:004779', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81624, NULL, 'G3DSA:3.50.50.60:FF:000482', NULL, NULL, 'Succinate dehydrogenase complex, subunit A, flavoprotein (Fp)', NULL, NULL, NULL, NULL, NULL, 4),
(81625, NULL, 'G3DSA:3.40.50.620:FF:000076', NULL, NULL, 'Universal stress protein G', NULL, NULL, NULL, NULL, NULL, 4),
(81626, NULL, 'G3DSA:3.40.50.10090:FF:000008', NULL, NULL, 'Transcriptional regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81627, NULL, 'G3DSA:1.20.58.900:FF:000036', NULL, NULL, 'Small G protein signaling modulator 3', NULL, NULL, NULL, NULL, NULL, 4),
(81628, NULL, 'G3DSA:1.20.1250.20:FF:002147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81629, NULL, 'G3DSA:3.40.50.720:FF:002472', NULL, NULL, 'Lovastatin nonaketide synthase, polyketide synthase component', NULL, NULL, NULL, NULL, NULL, 4),
(81630, NULL, 'G3DSA:3.30.160.60:FF:003262', NULL, NULL, 'Zinc finger protein 263', NULL, NULL, NULL, NULL, NULL, 4),
(81631, NULL, 'G3DSA:1.25.40.10:FF:001125', NULL, NULL, 'Translation regulator (Cya5), putative', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(81632, NULL, 'G3DSA:2.40.50.40:FF:000057', NULL, NULL, 'Kismet, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(81633, NULL, 'G3DSA:3.30.460.10:FF:000105', NULL, NULL, 'Putative tRNA nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(81634, NULL, 'G3DSA:1.25.40.10:FF:002553', NULL, NULL, 'Pentatricopeptide repeat-containing protein ATP4, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(81635, NULL, 'G3DSA:3.30.420.390:FF:000008', NULL, NULL, 'DNA polymerase family A', NULL, NULL, NULL, NULL, NULL, 4),
(81636, NULL, 'G3DSA:1.20.1580.10:FF:000005', NULL, NULL, 'UvrABC system protein A', NULL, NULL, NULL, NULL, NULL, 4),
(81637, NULL, 'G3DSA:3.40.830.10:FF:000008', NULL, NULL, 'MEMO1 family protein C4H3.04c', NULL, NULL, NULL, NULL, NULL, 4),
(81638, NULL, 'G3DSA:2.70.160.11:FF:000073', NULL, NULL, 'Protein arginine N-methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81639, NULL, 'G3DSA:3.10.200.10:FF:000001', NULL, NULL, 'Carbonic anhydrase 2', NULL, NULL, NULL, NULL, NULL, 4),
(81640, NULL, 'G3DSA:4.10.1060.10:FF:000027', NULL, NULL, 'Zinc finger Ran-binding domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(81641, NULL, 'G3DSA:2.120.10.30:FF:000469', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81642, NULL, 'G3DSA:1.20.1070.10:FF:001984', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81643, NULL, 'G3DSA:3.80.10.10:FF:002604', NULL, NULL, 'G-protein coupled receptor GRL101-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(81644, NULL, 'G3DSA:3.40.30.60:FF:000003', NULL, NULL, 'Flagellar biosynthesis protein FlhA', NULL, NULL, NULL, NULL, NULL, 4),
(81645, NULL, 'G3DSA:2.60.40.10:FF:001704', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81646, NULL, 'G3DSA:3.30.450.20:FF:000057', NULL, NULL, 'Voltage-dependent calcium channel subunit alpha-2/delta-4', NULL, NULL, NULL, NULL, NULL, 4),
(81647, NULL, 'G3DSA:3.40.50.2000:FF:000466', NULL, NULL, '3-deoxy-D-manno-octulosonic acid transferase', NULL, NULL, NULL, NULL, NULL, 4),
(81648, NULL, 'G3DSA:1.20.120.900:FF:000007', NULL, NULL, 'PEX19 chaperone-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(81649, NULL, 'G3DSA:3.40.50.2300:FF:000219', NULL, NULL, 'Glutamate metabotropic receptor 5', NULL, NULL, NULL, NULL, NULL, 4),
(81650, NULL, 'G3DSA:3.40.50.1820:FF:000732', NULL, NULL, 'Lipase', NULL, NULL, NULL, NULL, NULL, 4),
(81651, NULL, 'G3DSA:3.30.760.10:FF:000038', NULL, NULL, 'Eukaryotic translation initiation factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(81652, NULL, 'G3DSA:3.40.50.12280:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81653, NULL, 'G3DSA:3.40.718.10:FF:000062', NULL, NULL, 'Isocitrate dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81654, NULL, 'G3DSA:1.10.510.10:FF:003270', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81655, NULL, 'G3DSA:1.10.510.10:FF:002988', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81656, NULL, 'G3DSA:3.40.50.300:FF:000210', NULL, NULL, 'Si:dkey-16p6.1', NULL, NULL, NULL, NULL, NULL, 4),
(81657, NULL, 'G3DSA:1.10.132.20:FF:000010', NULL, NULL, 'Ribosomal recycling factor, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81658, NULL, 'G3DSA:3.30.40.10:FF:000259', NULL, NULL, 'E3 ubiquitin protein ligase RIN2', NULL, NULL, NULL, NULL, NULL, 4),
(81659, NULL, 'G3DSA:1.10.510.10:FF:002781', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81660, NULL, 'G3DSA:1.25.40.10:FF:004891', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81661, NULL, 'G3DSA:3.20.20.100:FF:000093', NULL, NULL, 'Aldose reductase', NULL, NULL, NULL, NULL, NULL, 4),
(81662, NULL, 'G3DSA:3.40.50.720:FF:000117', NULL, NULL, 'N-acetyl-gamma-glutamyl-phosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(81663, NULL, 'G3DSA:1.20.970.10:FF:000002', NULL, NULL, 'Pyrimidine-nucleoside phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(81664, NULL, 'G3DSA:3.40.50.300:FF:006859', NULL, NULL, 'Branched-chain amino acid ABC transporter, ATP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(81665, NULL, 'G3DSA:1.20.58.60:FF:000421', NULL, NULL, 'Nesprin-1', NULL, NULL, NULL, NULL, NULL, 4),
(81666, NULL, 'G3DSA:3.40.50.300:FF:007135', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(81667, NULL, 'G3DSA:3.40.50.720:FF:002146', NULL, NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(81668, NULL, 'G3DSA:1.25.10.10:FF:003214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81669, NULL, 'G3DSA:1.10.132.30:FF:000013', NULL, NULL, 'DNA-directed RNA polymerase I largest subunit', NULL, NULL, NULL, NULL, NULL, 4),
(81670, NULL, 'G3DSA:1.20.58.60:FF:000628', NULL, NULL, 'Spectrin repeat-containing, nuclear envelope 1b', NULL, NULL, NULL, NULL, NULL, 4),
(81671, NULL, 'G3DSA:3.60.60.10:FF:000001', NULL, NULL, 'Secernin 1', NULL, NULL, NULL, NULL, NULL, 4),
(81672, NULL, 'G3DSA:3.30.465.10:FF:000083', NULL, NULL, 'HlyC/CorC family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(81673, NULL, 'G3DSA:3.30.420.40:FF:000915', NULL, NULL, 'Actin-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(81674, NULL, 'G3DSA:2.10.25.10:FF:001666', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81675, NULL, 'G3DSA:1.20.58.900:FF:000019', NULL, NULL, 'Pinstripe, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(81676, NULL, 'G3DSA:3.40.50.300:FF:001519', NULL, NULL, 'ORC1-type DNA replication protein', NULL, NULL, NULL, NULL, NULL, 4),
(81677, NULL, 'G3DSA:3.40.225.10:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81678, NULL, 'G3DSA:1.10.3370.10:FF:000014', NULL, NULL, 'SecY protein transport family protein', NULL, NULL, NULL, NULL, NULL, 4),
(81679, NULL, 'G3DSA:2.60.40.10:FF:002986', NULL, NULL, 'GD23248', NULL, NULL, NULL, NULL, NULL, 4),
(81680, NULL, 'G3DSA:3.10.450.40:FF:000028', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(81681, NULL, 'G3DSA:3.40.50.2300:FF:000096', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(81682, NULL, 'G3DSA:1.10.10.350:FF:000012', NULL, NULL, 'Glutamyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(81683, NULL, 'G3DSA:1.25.40.10:FF:001451', NULL, NULL, 'Interferon-induced protein with tetratricopeptide repeats 3', NULL, NULL, NULL, NULL, NULL, 4),
(81684, NULL, 'G3DSA:3.40.50.300:FF:003083', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(81685, NULL, 'G3DSA:1.10.287.70:FF:000535', NULL, NULL, 'Two-pore potassium channel 4', NULL, NULL, NULL, NULL, NULL, 4),
(81686, NULL, 'G3DSA:3.50.30.30:FF:000016', NULL, NULL, 'Ring finger protein 150', NULL, NULL, NULL, NULL, NULL, 4),
(81687, NULL, 'G3DSA:1.25.40.20:FF:001454', NULL, NULL, 'Palmitoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(81688, NULL, 'G3DSA:1.20.1250.10:FF:000115', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81689, NULL, 'G3DSA:1.10.472.10:FF:000319', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81690, NULL, 'G3DSA:3.30.200.20:FF:002377', NULL, NULL, 'ADR379Cp', NULL, NULL, NULL, NULL, NULL, 4),
(81691, NULL, 'G3DSA:1.25.10.10:FF:002725', NULL, NULL, 'Importin-beta N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(81692, NULL, 'G3DSA:3.30.70.330:FF:002513', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81693, NULL, 'G3DSA:3.40.30.10:FF:000230', NULL, NULL, 'Monothiol glutaredoxin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81694, NULL, 'G3DSA:3.30.200.20:FF:000915', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(81695, NULL, 'G3DSA:1.10.3860.10:FF:000001', NULL, NULL, 'C4-dicarboxylate transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(81696, NULL, 'G3DSA:3.40.50.300:FF:001621', NULL, NULL, 'Dermatan sulfate epimerase-like', NULL, NULL, NULL, NULL, NULL, 4),
(81697, NULL, 'G3DSA:1.10.1080.10:FF:000008', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(81698, NULL, 'G3DSA:1.10.1200.10:FF:000114', NULL, NULL, 'Acyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(81699, NULL, 'G3DSA:1.20.80.60:FF:000006', NULL, NULL, 'Myosin regulatory light chain-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(81700, NULL, 'G3DSA:3.40.50.1460:FF:000040', NULL, NULL, 'CASP8 and FADD like apoptosis regulator', NULL, NULL, NULL, NULL, NULL, 4),
(81701, NULL, 'G3DSA:3.30.230.10:FF:000414', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(81702, NULL, 'G3DSA:1.20.20.10:FF:000027', NULL, NULL, 'ATP synthase subunit 9, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(81703, NULL, 'G3DSA:3.60.15.10:FF:000054', NULL, NULL, 'Metallo-beta-lactamase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(81704, NULL, 'G3DSA:3.40.50.1000:FF:000728', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81705, NULL, 'G3DSA:3.30.70.270:FF:000090', NULL, NULL, 'Diguanylate cyclase TpbB', NULL, NULL, NULL, NULL, NULL, 4),
(81706, NULL, 'G3DSA:1.10.150.910:FF:000007', NULL, NULL, 'CPSF (Cleavage and polyadenylation specific factor), subunit A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81707, NULL, 'G3DSA:2.30.29.30:FF:000533', NULL, NULL, 'Pleckstrin homology domain-containing family G member 6', NULL, NULL, NULL, NULL, NULL, 4),
(81708, NULL, 'G3DSA:2.60.120.200:FF:000344', NULL, NULL, 'Apical endosomal glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(81709, NULL, 'G3DSA:2.60.40.810:FF:000001', NULL, NULL, 'Protective antigen', NULL, NULL, NULL, NULL, NULL, 4),
(81710, NULL, 'G3DSA:1.20.5.170:FF:000104', NULL, NULL, 'Probable SNF2-component of SWI/SNF global transcription activator complex', NULL, NULL, NULL, NULL, NULL, 4),
(81711, NULL, 'G3DSA:1.10.287.630:FF:000007', NULL, NULL, 'Cyclic Nucleotide Gated channel', NULL, NULL, NULL, NULL, NULL, 4),
(81712, NULL, 'G3DSA:2.40.30.170:FF:000025', NULL, NULL, 'Efflux transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(81713, NULL, 'G3DSA:3.30.900.10:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81714, NULL, 'G3DSA:2.40.70.10:FF:000527', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81715, NULL, 'G3DSA:3.40.50.300:FF:004959', NULL, NULL, 'ABC transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(81716, NULL, 'G3DSA:1.20.1560.10:FF:000431', NULL, NULL, 'ABC transporter B family member 5', NULL, NULL, NULL, NULL, NULL, 4),
(81717, NULL, 'G3DSA:3.80.10.10:FF:003892', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RCH1', NULL, NULL, NULL, NULL, NULL, 4),
(81718, NULL, 'G3DSA:2.30.110.10:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81719, NULL, 'G3DSA:3.10.129.10:FF:000262', NULL, NULL, 'Acyl-[acyl-carrier-protein] hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(81720, NULL, 'G3DSA:3.90.180.10:FF:000121', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(81721, NULL, 'G3DSA:1.20.1080.10:FF:000063', NULL, NULL, 'Putative aquaporin PIP-type 7a', NULL, NULL, NULL, NULL, NULL, 4),
(81722, NULL, 'G3DSA:3.40.190.10:FF:000970', NULL, NULL, 'Putative solute-binding lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(81723, NULL, 'G3DSA:1.20.120.220:FF:000017', NULL, NULL, 'ATP synthase subunit a', NULL, NULL, NULL, NULL, NULL, 4),
(81724, NULL, 'G3DSA:2.130.10.10:FF:003239', NULL, NULL, 'Pre-mRNA-splicing factor RSE1', NULL, NULL, NULL, NULL, NULL, 4),
(81725, NULL, 'G3DSA:1.20.1050.10:FF:000252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81726, NULL, 'G3DSA:1.10.10.60:FF:000278', NULL, NULL, 'HTH-type transcriptional regulator GadW', NULL, NULL, NULL, NULL, NULL, 4),
(81727, NULL, 'G3DSA:2.30.42.10:FF:000614', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81728, NULL, 'G3DSA:1.25.50.20:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81729, NULL, 'G3DSA:3.40.50.620:FF:000430', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81730, NULL, 'G3DSA:3.30.428.10:FF:000008', NULL, NULL, 'CWF19-like 2, cell cycle control', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(81731, NULL, 'G3DSA:2.30.30.100:FF:000085', NULL, NULL, 'Small nuclear ribonucleoprotein F', NULL, NULL, NULL, NULL, NULL, 4),
(81732, NULL, 'G3DSA:6.20.10.30:FF:000004', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(81733, NULL, 'G3DSA:3.30.160.60:FF:005291', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81734, NULL, 'G3DSA:2.20.110.10:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81735, NULL, 'G3DSA:2.130.10.10:FF:000289', NULL, NULL, 'WD40 repeat-containing protein SMU1', NULL, NULL, NULL, NULL, NULL, 4),
(81736, NULL, 'G3DSA:1.20.1250.20:FF:000118', NULL, NULL, 'D-xylose-proton symporter-like 3, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(81737, NULL, 'G3DSA:1.10.472.10:FF:000196', NULL, NULL, 'PHO85 cyclin CLG1', NULL, NULL, NULL, NULL, NULL, 4),
(81738, NULL, 'G3DSA:2.40.10.480:FF:000001', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(81739, NULL, 'G3DSA:1.20.1540.10:FF:000093', NULL, NULL, 'Rhomboid family protein', NULL, NULL, NULL, NULL, NULL, 4),
(81740, NULL, 'G3DSA:3.40.50.1820:FF:000070', NULL, NULL, 'Carboxylesterase', NULL, NULL, NULL, NULL, NULL, 4),
(81741, NULL, 'G3DSA:3.40.50.150:FF:000839', NULL, NULL, 'Methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(81742, NULL, 'G3DSA:3.80.10.10:FF:000340', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(81743, NULL, 'G3DSA:3.40.50.620:FF:000637', NULL, NULL, 'tRNA-specific 2-thiouridylase MnmA 1', NULL, NULL, NULL, NULL, NULL, 4),
(81744, NULL, 'G3DSA:3.30.160.60:FF:003475', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81745, NULL, 'G3DSA:2.130.10.10:FF:000839', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(81746, NULL, 'G3DSA:3.40.50.2000:FF:000674', NULL, NULL, 'UDP-glycosyltransferase 73C3', NULL, NULL, NULL, NULL, NULL, 4),
(81747, NULL, 'G3DSA:3.30.40.10:FF:000585', NULL, NULL, 'ubiquitin carboxyl-terminal hydrolase 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(81748, NULL, 'G3DSA:3.10.129.10:FF:000048', NULL, NULL, '14-dihydroxy-2-naphthoyl-CoA thioesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(81749, NULL, 'G3DSA:3.40.50.2300:FF:000663', NULL, NULL, 'Response regulator receiver', NULL, NULL, NULL, NULL, NULL, 4),
(81750, NULL, 'G3DSA:1.10.287.70:FF:000440', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(81751, NULL, 'G3DSA:3.90.660.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81752, NULL, 'G3DSA:1.20.1070.10:FF:000135', NULL, NULL, 'galanin receptor type 1', NULL, NULL, NULL, NULL, NULL, 4),
(81753, NULL, 'G3DSA:3.30.160.60:FF:001351', NULL, NULL, 'zinc finger protein 197 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(81754, NULL, 'G3DSA:2.60.120.10:FF:000133', NULL, NULL, 'Camp-dependent protein kinase type i regulatory subunit-like', NULL, NULL, NULL, NULL, NULL, 4),
(81755, NULL, 'G3DSA:2.30.29.30:FF:000078', NULL, NULL, 'Guanine nucleotide exchange factor DBS', NULL, NULL, NULL, NULL, NULL, 4),
(81756, NULL, 'G3DSA:1.10.1040.50:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81757, NULL, 'G3DSA:3.40.850.10:FF:000335', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(81758, NULL, 'G3DSA:1.10.340.30:FF:000019', NULL, NULL, 'Base excision DNA repair protein, HhH-GPD family', NULL, NULL, NULL, NULL, NULL, 4),
(81759, NULL, 'G3DSA:1.10.287.770:FF:000021', NULL, NULL, 'Pickpocket 20, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(81760, NULL, 'G3DSA:3.40.50.620:FF:000643', NULL, NULL, 'Valyl tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(81761, NULL, 'G3DSA:3.40.50.300:FF:001172', NULL, NULL, 'Cystic fibrosis transmembrane conductance regulator', NULL, NULL, NULL, NULL, NULL, 4),
(81762, NULL, 'G3DSA:1.20.1250.20:FF:001872', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81763, NULL, 'G3DSA:1.25.40.10:FF:002766', NULL, NULL, 'Os01g0812500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(81764, NULL, 'G3DSA:2.130.10.10:FF:001345', NULL, NULL, 'WD40 repeat-like protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(81765, NULL, 'G3DSA:2.70.170.10:FF:000269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81766, NULL, 'G3DSA:1.10.287.130:FF:000200', NULL, NULL, 'Probable two-component sensor histidine kinase VicK', NULL, NULL, NULL, NULL, NULL, 4),
(81767, NULL, 'G3DSA:2.60.490.10:FF:000008', NULL, NULL, 'P2X purinoceptor', NULL, NULL, NULL, NULL, NULL, 4),
(81768, NULL, 'G3DSA:1.10.274.30:FF:000039', NULL, NULL, 'Protein CBG14008', NULL, NULL, NULL, NULL, NULL, 4),
(81769, NULL, 'G3DSA:3.40.50.1820:FF:001694', NULL, NULL, 'Methylesterase 3', NULL, NULL, NULL, NULL, NULL, 4),
(81770, NULL, 'G3DSA:2.60.470.10:FF:000013', NULL, NULL, 'Pickpocket 5, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(81771, NULL, 'G3DSA:2.120.10.10:FF:000025', NULL, NULL, 'Probable sialidase', NULL, NULL, NULL, NULL, NULL, 4),
(81772, NULL, 'G3DSA:2.60.120.260:FF:000659', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(81773, NULL, 'G3DSA:3.30.2460.20:FF:000012', NULL, NULL, 'Protein Wnt', NULL, NULL, NULL, NULL, NULL, 4),
(81774, NULL, 'G3DSA:3.30.40.10:FF:000602', NULL, NULL, 'General transcription factor IIH subunit', NULL, NULL, NULL, NULL, NULL, 4),
(81775, NULL, 'G3DSA:1.10.1060.10:FF:000013', NULL, NULL, 'NAD-dependent dihydropyrimidine dehydrogenase subunit PreT', NULL, NULL, NULL, NULL, NULL, 4),
(81776, NULL, 'G3DSA:1.20.1510.10:FF:000057', NULL, NULL, 'Metal-ion transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81777, NULL, 'G3DSA:3.30.70.20:FF:000096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81778, NULL, 'G3DSA:3.20.20.80:FF:000223', NULL, NULL, 'Glycoprotein endo-alpha-1,2-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(81779, NULL, 'G3DSA:2.30.42.10:FF:000165', NULL, NULL, 'Cytohesin-interacting protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(81780, NULL, 'G3DSA:3.80.10.10:FF:003566', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81781, NULL, 'G3DSA:3.40.50.2300:FF:000562', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81782, NULL, 'G3DSA:3.30.420.10:FF:000108', NULL, NULL, 'DNA helicase, phage-associated', NULL, NULL, NULL, NULL, NULL, 4),
(81783, NULL, 'G3DSA:3.10.20.870:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81784, NULL, 'G3DSA:1.25.40.20:FF:001246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81785, NULL, 'G3DSA:1.20.58.60:FF:000393', NULL, NULL, 'VAB-10B protein', NULL, NULL, NULL, NULL, NULL, 4),
(81786, NULL, 'G3DSA:1.25.40.20:FF:001566', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81787, NULL, 'G3DSA:2.40.50.140:FF:000576', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(81788, NULL, 'G3DSA:3.40.50.2020:FF:000101', NULL, NULL, 'Ribose-phosphate pyrophosphokinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81789, NULL, 'G3DSA:2.60.40.1730:FF:000111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81790, NULL, 'G3DSA:2.10.25.10:FF:001099', NULL, NULL, 'LDL receptor related protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(81791, NULL, 'G3DSA:1.20.120.960:FF:000003', NULL, NULL, 'Sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(81792, NULL, 'G3DSA:2.60.40.150:FF:000668', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81793, NULL, 'G3DSA:1.10.287.70:FF:000541', NULL, NULL, 'Potassium channel, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81794, NULL, 'G3DSA:3.40.50.1760:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81795, NULL, 'G3DSA:1.20.1560.10:FF:000105', NULL, NULL, 'ABC transporter B family member 25', NULL, NULL, NULL, NULL, NULL, 4),
(81796, NULL, 'G3DSA:3.10.129.10:FF:000149', NULL, NULL, 'Putative thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(81797, NULL, 'G3DSA:2.130.10.30:FF:000154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81798, NULL, 'G3DSA:2.130.10.10:FF:005044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81799, NULL, 'G3DSA:2.60.40.10:FF:004459', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(81800, NULL, 'G3DSA:3.30.160.60:FF:003380', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81801, NULL, 'G3DSA:3.30.450.20:FF:000624', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81802, NULL, 'G3DSA:1.25.40.10:FF:001243', NULL, NULL, 'Nuclear autoantigenic sperm protein (histone-binding)', NULL, NULL, NULL, NULL, NULL, 4),
(81803, NULL, 'G3DSA:3.90.660.10:FF:000135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81804, NULL, 'G3DSA:1.20.1250.20:FF:000444', NULL, NULL, 'Integral membrane efflux protein', NULL, NULL, NULL, NULL, NULL, 4),
(81805, NULL, 'G3DSA:3.30.160.60:FF:003048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81806, NULL, 'G3DSA:3.30.300.30:FF:000061', NULL, NULL, 'Fatty acid-CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(81807, NULL, 'G3DSA:3.30.1520.10:FF:000161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81808, NULL, 'G3DSA:3.40.50.800:FF:000040', NULL, NULL, 'DNA polymerase gamma 35kD', NULL, NULL, NULL, NULL, NULL, 4),
(81809, NULL, 'G3DSA:1.20.5.170:FF:000110', NULL, NULL, 'BZIP-type transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(81810, NULL, 'G3DSA:3.20.20.70:FF:000220', NULL, NULL, 'Glucan 1,4-alpha-glucosidase SusB', NULL, NULL, NULL, NULL, NULL, 4),
(81811, NULL, 'G3DSA:3.30.70.600:FF:000020', NULL, NULL, '30S ribosomal protein S10', NULL, NULL, NULL, NULL, NULL, 4),
(81812, NULL, 'G3DSA:2.60.120.290:FF:000090', NULL, NULL, 'Seizure 6-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(81813, NULL, 'G3DSA:1.10.510.10:FF:001241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81814, NULL, 'G3DSA:2.60.40.10:FF:003615', NULL, NULL, 'Kinase insert domain receptor like', NULL, NULL, NULL, NULL, NULL, 4),
(81815, NULL, 'G3DSA:1.20.5.170:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81816, NULL, 'G3DSA:3.30.70.330:FF:002384', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81817, NULL, 'G3DSA:2.160.20.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81818, NULL, 'G3DSA:3.80.10.10:FF:000008', NULL, NULL, 'CCR4-NOT transcription complex subunit 6 like', NULL, NULL, NULL, NULL, NULL, 4),
(81819, NULL, 'G3DSA:2.40.50.1020:FF:000010', NULL, NULL, 'Response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(81820, NULL, 'G3DSA:3.40.350.10:FF:000078', NULL, NULL, 'Intermediate cleaving peptidase 55', NULL, NULL, NULL, NULL, NULL, 4),
(81821, NULL, 'G3DSA:3.30.200.210:FF:000001', NULL, NULL, 'Periplasmic nitrate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(81822, NULL, 'G3DSA:2.60.120.200:FF:000232', NULL, NULL, 'MAM and LDL receptor class A domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(81823, NULL, 'G3DSA:2.30.30.100:FF:000208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81824, NULL, 'G3DSA:3.60.20.10:FF:000004', NULL, NULL, 'Proteasome subunit alpha type-4', NULL, NULL, NULL, NULL, NULL, 4),
(81825, NULL, 'G3DSA:3.30.70.330:FF:000826', NULL, NULL, 'Translation initiation factor eIF4B', NULL, NULL, NULL, NULL, NULL, 4),
(81826, NULL, 'G3DSA:1.10.10.2770:FF:000002', NULL, NULL, 'Selenocysteine-specific translation elongation factor', NULL, NULL, NULL, NULL, NULL, 4),
(81827, NULL, 'G3DSA:3.10.10.10:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81828, NULL, 'G3DSA:1.10.238.10:FF:001214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81829, NULL, 'G3DSA:3.40.50.1780:FF:000029', NULL, NULL, 'Putative iron-dependent hydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(81830, NULL, 'G3DSA:1.20.1440.170:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81831, NULL, 'G3DSA:3.40.50.620:FF:000542', NULL, NULL, 'FAD synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(81832, NULL, 'G3DSA:3.30.200.20:FF:000814', NULL, NULL, 'Fibroblast growth factor receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(81833, NULL, 'G3DSA:1.20.1560.10:FF:000088', NULL, NULL, 'Thiol reductant ABC exporter subunit CydD', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(81834, NULL, 'G3DSA:2.60.40.150:FF:000781', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81835, NULL, 'G3DSA:1.25.10.10:FF:003085', NULL, NULL, 'AGAP004782-PA', NULL, NULL, NULL, NULL, NULL, 4),
(81836, NULL, 'G3DSA:1.10.287.70:FF:000327', NULL, NULL, 'Voltage-gated Ion Channel (VIC) Superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(81837, NULL, 'G3DSA:3.20.20.70:FF:000799', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81838, NULL, 'G3DSA:3.30.420.10:FF:000013', NULL, NULL, 'protein argonaute 10-like', NULL, NULL, NULL, NULL, NULL, 4),
(81839, NULL, 'G3DSA:1.10.220.150:FF:000055', NULL, NULL, 'uncharacterized protein LOC778851 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(81840, NULL, 'G3DSA:3.40.50.300:FF:005123', NULL, NULL, 'Nucleotide binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81841, NULL, 'G3DSA:3.20.20.150:FF:000080', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(81842, NULL, 'G3DSA:1.20.120.1770:FF:000011', NULL, NULL, 'Protein CBG08803', NULL, NULL, NULL, NULL, NULL, 4),
(81843, NULL, 'G3DSA:3.40.50.300:FF:001851', NULL, NULL, 'ATP-dependent helicase/nuclease subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(81844, NULL, 'G3DSA:3.40.50.150:FF:001553', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81845, NULL, 'G3DSA:3.10.129.110:FF:000013', NULL, NULL, '6-deoxyerythronolide-B synthase EryA2, modules 3 and 4', NULL, NULL, NULL, NULL, NULL, 4),
(81846, NULL, 'G3DSA:3.30.1520.10:FF:000048', NULL, NULL, 'sorting nexin-16 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(81847, NULL, 'G3DSA:1.10.418.10:FF:000149', NULL, NULL, 'Smoothelin-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(81848, NULL, 'G3DSA:3.30.559.10:FF:000104', NULL, NULL, 'Nonribosomal peptide synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81849, NULL, 'G3DSA:3.40.50.2000:FF:000354', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(81850, NULL, 'G3DSA:3.30.300.30:FF:000162', NULL, NULL, 'Flagellar M-Ring Protein', NULL, NULL, NULL, NULL, NULL, 4),
(81851, NULL, 'G3DSA:1.20.1070.10:FF:000455', NULL, NULL, 'Transmembrane receptor', NULL, NULL, NULL, NULL, NULL, 4),
(81852, NULL, 'G3DSA:1.10.510.10:FF:000976', NULL, NULL, 'Associated kinase of Tb14-3-3', NULL, NULL, NULL, NULL, NULL, 4),
(81853, NULL, 'G3DSA:3.40.50.300:FF:005224', NULL, NULL, 'Rab_C43 protein', NULL, NULL, NULL, NULL, NULL, 4),
(81854, NULL, 'G3DSA:3.40.1090.10:FF:000147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81855, NULL, 'G3DSA:3.30.1370.10:FF:000244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81856, NULL, 'G3DSA:3.30.200.20:FF:000578', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(81857, NULL, 'G3DSA:3.30.60.190:FF:000018', NULL, NULL, 'YALI0F07953p', NULL, NULL, NULL, NULL, NULL, 4),
(81858, NULL, 'G3DSA:3.30.160.60:FF:001019', NULL, NULL, 'Zinc finger and BTB domain-containing protein 41', NULL, NULL, NULL, NULL, NULL, 4),
(81859, NULL, 'G3DSA:2.40.50.90:FF:000044', NULL, NULL, 'Tapas, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(81860, NULL, 'G3DSA:2.30.30.30:FF:000149', NULL, NULL, '60S ribosomal protein L6', NULL, NULL, NULL, NULL, NULL, 4),
(81861, NULL, 'G3DSA:3.40.50.10090:FF:000014', NULL, NULL, 'Uroporphyrinogen III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(81862, NULL, 'G3DSA:1.10.1240.20:FF:000002', NULL, NULL, 'Soluble lytic murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(81863, NULL, 'G3DSA:1.25.40.120:FF:000063', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(81864, NULL, 'G3DSA:3.40.630.10:FF:000448', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81865, NULL, 'G3DSA:3.20.20.300:FF:000052', NULL, NULL, 'ERG9, Phytoenesqualene synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(81866, NULL, 'G3DSA:2.30.39.10:FF:000011', NULL, NULL, 'Antithrombin-III', NULL, NULL, NULL, NULL, NULL, 4),
(81867, NULL, 'G3DSA:1.10.532.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(81868, NULL, 'G3DSA:3.30.70.270:FF:000331', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81869, NULL, 'G3DSA:2.40.10.10:FF:000647', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81870, NULL, 'G3DSA:1.10.10.60:FF:000828', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81871, NULL, 'G3DSA:2.130.10.30:FF:000036', NULL, NULL, 'Guanidine nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(81872, NULL, 'G3DSA:3.40.1450.10:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81873, NULL, 'G3DSA:1.10.10.60:FF:000727', NULL, NULL, 'C. Elegans Homeobox', NULL, NULL, NULL, NULL, NULL, 4),
(81874, NULL, 'G3DSA:1.25.10.10:FF:000797', NULL, NULL, 'Armadillo repeat-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(81875, NULL, 'G3DSA:3.30.160.60:FF:004785', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81876, NULL, 'G3DSA:3.40.720.10:FF:000101', NULL, NULL, 'Secreted sulfatase ydeN', NULL, NULL, NULL, NULL, NULL, 4),
(81877, NULL, 'G3DSA:2.60.40.10:FF:000980', NULL, NULL, 'Titin b', NULL, NULL, NULL, NULL, NULL, 4),
(81878, NULL, 'G3DSA:2.130.10.10:FF:000738', NULL, NULL, 'Autophagy-specific protein', NULL, NULL, NULL, NULL, NULL, 4),
(81879, NULL, 'G3DSA:2.60.40.10:FF:004791', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81880, NULL, 'G3DSA:3.60.40.10:FF:000005', NULL, NULL, 'Serine/threonine protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(81881, NULL, 'G3DSA:1.10.520.20:FF:000002', NULL, NULL, 'ATP synthase subunit O, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(81882, NULL, 'G3DSA:1.25.40.10:FF:000737', NULL, NULL, 'SGT1 homolog, MIS12 kinetochore complex assembly cochaperone', NULL, NULL, NULL, NULL, NULL, 4),
(81883, NULL, 'G3DSA:2.30.42.10:FF:000373', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81884, NULL, 'G3DSA:3.30.499.10:FF:000020', NULL, NULL, 'Aconitate hydratase A', NULL, NULL, NULL, NULL, NULL, 4),
(81885, NULL, 'G3DSA:3.80.10.10:FF:002251', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(81886, NULL, 'G3DSA:3.30.40.10:FF:000490', NULL, NULL, 'Ring finger protein 214', NULL, NULL, NULL, NULL, NULL, 4),
(81887, NULL, 'G3DSA:3.50.50.60:FF:000139', NULL, NULL, 'All-trans-retinol 13,14-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(81888, NULL, 'G3DSA:3.40.50.1820:FF:000165', NULL, NULL, 'Serine peptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81889, NULL, 'G3DSA:1.20.1250.20:FF:001973', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81890, NULL, 'G3DSA:3.40.50.10190:FF:000140', NULL, NULL, 'Related to FCP1-TFIIF interacting component of CTD phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(81891, NULL, 'G3DSA:1.10.510.10:FF:003039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81892, NULL, 'G3DSA:3.40.50.970:FF:000063', NULL, NULL, '2-oxoglutarate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(81893, NULL, 'G3DSA:3.40.50.10140:FF:000052', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(81894, NULL, 'G3DSA:3.40.50.300:FF:001071', NULL, NULL, 'Thiamine import ATP-binding protein ThiQ', NULL, NULL, NULL, NULL, NULL, 4),
(81895, NULL, 'G3DSA:3.30.390.30:FF:000004', NULL, NULL, 'Thioredoxin reductase 1, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(81896, NULL, 'G3DSA:3.60.20.10:FF:000116', NULL, NULL, 'Proteasome endopeptidase complex', NULL, NULL, NULL, NULL, NULL, 4),
(81897, NULL, 'G3DSA:2.70.98.10:FF:000056', NULL, NULL, 'Photosynthetic NDH subunit of subcomplex B 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(81898, NULL, 'G3DSA:3.80.10.10:FF:004403', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(81899, NULL, 'G3DSA:1.20.1250.20:FF:000556', NULL, NULL, 'MFS transporter, putative (AFU_orthologue AFUA_1G17530)', NULL, NULL, NULL, NULL, NULL, 4),
(81900, NULL, 'G3DSA:3.30.450.20:FF:000512', NULL, NULL, 'PAS/PAC sensor hybrid histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(81901, NULL, 'G3DSA:1.25.40.420:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(81902, NULL, 'G3DSA:2.60.200.20:FF:000087', NULL, NULL, 'TRAF-interacting protein with FHA domain-containing protein A', NULL, NULL, NULL, NULL, NULL, 4),
(81903, NULL, 'G3DSA:3.30.1010.10:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81904, NULL, 'G3DSA:3.30.70.330:FF:000372', NULL, NULL, 'RNA-binding motif protein 12B', NULL, NULL, NULL, NULL, NULL, 4),
(81905, NULL, 'G3DSA:3.80.10.10:FF:002037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81906, NULL, 'G3DSA:2.130.10.10:FF:002981', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81907, NULL, 'G3DSA:1.20.120.1320:FF:000011', NULL, NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(81908, NULL, 'G3DSA:3.30.2420.10:FF:000001', NULL, NULL, 'Protein TonB', NULL, NULL, NULL, NULL, NULL, 4),
(81909, NULL, 'G3DSA:3.90.1150.10:FF:000337', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(81910, NULL, 'G3DSA:1.20.1250.20:FF:001759', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(81911, NULL, 'G3DSA:1.10.238.10:FF:001091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81912, NULL, 'G3DSA:1.20.1740.10:FF:000074', NULL, NULL, 'Histidine permease', NULL, NULL, NULL, NULL, NULL, 4),
(81913, NULL, 'G3DSA:3.90.15.10:FF:000007', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(81914, NULL, 'G3DSA:3.50.50.60:FF:000690', NULL, NULL, 'Phytoene dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(81915, NULL, 'G3DSA:3.30.160.60:FF:001137', NULL, NULL, 'Combgap, isoform L', NULL, NULL, NULL, NULL, NULL, 4),
(81916, NULL, 'G3DSA:2.60.120.260:FF:000564', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(81917, NULL, 'G3DSA:1.10.10.60:FF:001222', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81918, NULL, 'G3DSA:3.40.50.2300:FF:000449', NULL, NULL, 'Low molecular weight phosphotyrosine protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(81919, NULL, 'G3DSA:1.25.10.10:FF:001415', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(81920, NULL, 'G3DSA:1.20.272.40:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81921, NULL, 'G3DSA:1.10.630.10:FF:000232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81922, NULL, 'G3DSA:3.40.50.410:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81923, NULL, 'G3DSA:3.50.50.60:FF:000818', NULL, NULL, 'Flavoprotein monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81924, NULL, 'G3DSA:3.90.70.80:FF:000021', NULL, NULL, 'Ubiquitin thioesterase OTU1', NULL, NULL, NULL, NULL, NULL, 4),
(81925, NULL, 'G3DSA:3.40.50.150:FF:001087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81926, NULL, 'G3DSA:3.90.190.10:FF:000402', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81927, NULL, 'G3DSA:2.60.120.620:FF:000003', NULL, NULL, 'Prolyl 3-hydroxylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(81928, NULL, 'G3DSA:1.25.40.10:FF:003154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81929, NULL, 'G3DSA:3.30.70.330:FF:001996', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81930, NULL, 'G3DSA:3.10.100.10:FF:000185', NULL, NULL, 'Mannose receptor, C type 1b', NULL, NULL, NULL, NULL, NULL, 4),
(81931, NULL, 'G3DSA:3.40.50.2300:FF:001500', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81932, NULL, 'G3DSA:3.30.160.20:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81933, NULL, 'G3DSA:1.20.1070.10:FF:000247', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(81934, NULL, 'G3DSA:1.25.40.180:FF:000300', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81935, NULL, 'G3DSA:3.20.140.10:FF:000022', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(81936, NULL, 'G3DSA:3.40.50.1000:FF:000829', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(81937, NULL, 'G3DSA:2.60.40.10:FF:002778', NULL, NULL, 'Unc-40 protein', NULL, NULL, NULL, NULL, NULL, 4),
(81938, NULL, 'G3DSA:3.40.640.10:FF:000168', NULL, NULL, 'Putative ornithine aminotransferase RocD1', NULL, NULL, NULL, NULL, NULL, 4),
(81939, NULL, 'G3DSA:3.40.50.1820:FF:000518', NULL, NULL, 'Hydrolase, alpha/beta fold family domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(81940, NULL, 'G3DSA:3.10.105.10:FF:000021', NULL, NULL, 'Peptide ABC transporter, periplasmic peptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(81941, NULL, 'G3DSA:3.20.20.30:FF:000006', NULL, NULL, 'LLM class flavin-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(81942, NULL, 'G3DSA:3.40.50.20:FF:000015', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(81943, NULL, 'G3DSA:3.40.710.10:FF:000050', NULL, NULL, 'Putative D-alanyl-D-alanine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(81944, NULL, 'G3DSA:3.40.190.120:FF:000006', NULL, NULL, 'Osmoprotectant transport system substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(81945, NULL, 'G3DSA:3.60.15.10:FF:000149', NULL, NULL, 'Cleavage and polyadenylation specific factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(81946, NULL, 'G3DSA:1.10.150.670:FF:000014', NULL, NULL, 'YALI0C14960p', NULL, NULL, NULL, NULL, NULL, 4),
(81947, NULL, 'G3DSA:3.30.450.20:FF:000271', NULL, NULL, 'Sensor histidine kinase RcsC', NULL, NULL, NULL, NULL, NULL, 4),
(81948, NULL, 'G3DSA:3.40.50.300:FF:003532', NULL, NULL, 'GPN-loop GTPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(81949, NULL, 'G3DSA:3.30.160.740:FF:000003', NULL, NULL, '2-isopropylmalate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(81950, NULL, 'G3DSA:3.40.50.620:FF:000531', NULL, NULL, 'Valine--tRNA ligase mitochondrial 1', NULL, NULL, NULL, NULL, NULL, 4),
(81951, NULL, 'G3DSA:1.10.1510.10:FF:000003', NULL, NULL, 'Uncharacterized protein C22F3.15', NULL, NULL, NULL, NULL, NULL, 4),
(81952, NULL, 'G3DSA:3.90.640.10:FF:000151', NULL, NULL, 'Actin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81953, NULL, 'G3DSA:3.20.20.20:FF:000003', NULL, NULL, '4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase (flavodoxin)', NULL, NULL, NULL, NULL, NULL, 4),
(81954, NULL, 'G3DSA:3.40.640.10:FF:000398', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81955, NULL, 'G3DSA:3.30.710.10:FF:000333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81956, NULL, 'G3DSA:2.20.100.10:FF:000225', NULL, NULL, 'spondin-1-like', NULL, NULL, NULL, NULL, NULL, 4),
(81957, NULL, 'G3DSA:3.10.20.710:FF:000002', NULL, NULL, 'Defective proventriculus, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(81958, NULL, 'G3DSA:1.20.1070.10:FF:002147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81959, NULL, 'G3DSA:2.60.40.10:FF:003054', NULL, NULL, 'Myomesin 2', NULL, NULL, NULL, NULL, NULL, 4),
(81960, NULL, 'G3DSA:1.10.1040.10:FF:000124', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(81961, NULL, 'G3DSA:3.30.460.10:FF:000010', NULL, NULL, 'Zinc finger RNA-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(81962, NULL, 'G3DSA:3.30.160.60:FF:003711', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81963, NULL, 'G3DSA:3.30.190.20:FF:000020', NULL, NULL, 'Related to 50S ribosomal protein L1', NULL, NULL, NULL, NULL, NULL, 4),
(81964, NULL, 'G3DSA:3.90.55.10:FF:000004', NULL, NULL, 'Trimethylamine-N-oxide reductase TorA', NULL, NULL, NULL, NULL, NULL, 4),
(81965, NULL, 'G3DSA:3.10.20.870:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81966, NULL, 'G3DSA:3.90.550.10:FF:000599', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81967, NULL, 'G3DSA:3.50.50.60:FF:000931', NULL, NULL, 'Putidaredoxin reductase CamA', NULL, NULL, NULL, NULL, NULL, 4),
(81968, NULL, 'G3DSA:3.30.460.20:FF:000013', NULL, NULL, 'Magnesium and cobalt transport protein CorA, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81969, NULL, 'G3DSA:1.20.120.260:FF:000001', NULL, NULL, 'Outer membrane virulence protein YopE', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(81970, NULL, 'G3DSA:2.20.70.10:FF:000129', NULL, NULL, 'Transcription factor TFIIE alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(81971, NULL, 'G3DSA:1.20.120.1080:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81972, NULL, 'G3DSA:2.60.40.10:FF:000749', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(81973, NULL, 'G3DSA:3.30.160.60:FF:005740', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(81974, NULL, 'G3DSA:2.30.30.100:FF:000102', NULL, NULL, 'N-alpha-acetyltransferase 38, NatC auxiliary subunit', NULL, NULL, NULL, NULL, NULL, 4),
(81975, NULL, 'G3DSA:3.40.50.300:FF:006758', NULL, NULL, 'GTP-binding ADP-ribosylation factor ARF1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(81976, NULL, 'G3DSA:3.30.2460.20:FF:000001', NULL, NULL, 'Wnt homolog', NULL, NULL, NULL, NULL, NULL, 4),
(81977, NULL, 'G3DSA:3.90.1600.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81978, NULL, 'G3DSA:1.25.40.10:FF:004677', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g21170', NULL, NULL, NULL, NULL, NULL, 4),
(81979, NULL, 'G3DSA:1.25.40.10:FF:002648', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81980, NULL, 'G3DSA:3.40.390.10:FF:000075', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(81981, NULL, 'G3DSA:3.40.50.1370:FF:000013', NULL, NULL, 'N-acetylornithine carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(81982, NULL, 'G3DSA:3.10.20.90:FF:000985', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(81983, NULL, 'G3DSA:3.20.20.70:FF:000102', NULL, NULL, 'Putative N-methylproline demethylase', NULL, NULL, NULL, NULL, NULL, 4),
(81984, NULL, 'G3DSA:3.40.50.12180:FF:000001', NULL, NULL, 'Phosphoethanolamine MethylTransferase', NULL, NULL, NULL, NULL, NULL, 4),
(81985, NULL, 'G3DSA:2.10.110.10:FF:000094', NULL, NULL, 'LIM domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(81986, NULL, 'G3DSA:3.40.50.300:FF:001733', NULL, NULL, 'Export ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(81987, NULL, 'G3DSA:3.40.605.10:FF:000030', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(81988, NULL, 'G3DSA:1.25.40.90:FF:000036', NULL, NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(81989, NULL, 'G3DSA:2.40.50.140:FF:000256', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(81990, NULL, 'G3DSA:3.30.200.20:FF:002489', NULL, NULL, 'Tyramine beta-hydroxylase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(81991, NULL, 'G3DSA:3.40.50.410:FF:000030', NULL, NULL, 'Protein ViaA', NULL, NULL, NULL, NULL, NULL, 4),
(81992, NULL, 'G3DSA:3.40.50.12230:FF:000027', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(81993, NULL, 'G3DSA:3.40.50.1360:FF:000010', NULL, NULL, 'Transcriptional regulator, DeoR family', NULL, NULL, NULL, NULL, NULL, 4),
(81994, NULL, 'G3DSA:2.60.220.50:FF:000164', NULL, NULL, 'Cadherin, EGF LAG seven-pass G-type receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(81995, NULL, 'G3DSA:2.20.28.200:FF:000007', NULL, NULL, 'DHS-like NAD/FAD-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(81996, NULL, 'G3DSA:1.10.1200.10:FF:000002', NULL, NULL, '10-formyltetrahydrofolate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(81997, NULL, 'G3DSA:1.10.238.260:FF:000010', NULL, NULL, 'Homocitrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(81998, NULL, 'G3DSA:3.40.47.10:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(81999, NULL, 'G3DSA:1.10.1040.50:FF:000001', NULL, NULL, 'Fatty acid oxidation complex subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(82000, NULL, 'G3DSA:2.60.40.420:FF:000193', NULL, NULL, 'Early nodulin-like protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(82001, NULL, 'G3DSA:2.10.25.10:FF:000031', NULL, NULL, 'neurogenic locus notch homolog protein 3', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(82002, NULL, 'G3DSA:3.40.50.450:FF:000013', NULL, NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase LOG8', NULL, NULL, NULL, NULL, NULL, 4),
(82003, NULL, 'G3DSA:2.60.40.10:FF:001025', NULL, NULL, 'Immunoglobulin heavy variable V1-74', NULL, NULL, NULL, NULL, NULL, 4),
(82004, NULL, 'G3DSA:3.30.750.24:FF:000085', NULL, NULL, 'Sulfate permease', NULL, NULL, NULL, NULL, NULL, 4),
(82005, NULL, 'G3DSA:1.20.5.510:FF:000009', NULL, NULL, 'EPH receptor A2', NULL, NULL, NULL, NULL, NULL, 4),
(82006, NULL, 'G3DSA:1.10.510.10:FF:002876', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82007, NULL, 'G3DSA:3.40.1410.10:FF:000009', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(82008, NULL, 'G3DSA:1.10.238.20:FF:000020', NULL, NULL, 'Odorant-binding protein 69a', NULL, NULL, NULL, NULL, NULL, 4),
(82009, NULL, 'G3DSA:3.40.50.300:FF:001278', NULL, NULL, 'Iron-sulfur cluster carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(82010, NULL, 'G3DSA:3.20.20.240:FF:000005', NULL, NULL, 'Methylmalonyl-CoA mutase C-terminal domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(82011, NULL, 'G3DSA:2.40.128.270:FF:000003', NULL, NULL, 'META domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(82012, NULL, 'G3DSA:3.30.420.10:FF:000440', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82013, NULL, 'G3DSA:3.40.350.10:FF:000067', NULL, NULL, 'AGAP000476-PA', NULL, NULL, NULL, NULL, NULL, 4),
(82014, NULL, 'G3DSA:3.90.190.10:FF:000048', NULL, NULL, 'dual specificity protein phosphatase 22 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(82015, NULL, 'G3DSA:2.30.40.10:FF:000082', NULL, NULL, 'Putative hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(82016, NULL, 'G3DSA:3.40.20.10:FF:000061', NULL, NULL, 'Quail, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(82017, NULL, 'G3DSA:3.30.420.10:FF:000002', NULL, NULL, 'Crossover junction endodeoxyribonuclease RuvC', NULL, NULL, NULL, NULL, NULL, 4),
(82018, NULL, 'G3DSA:2.60.120.200:FF:000243', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(82019, NULL, 'G3DSA:3.30.70.660:FF:000009', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(82020, NULL, 'G3DSA:1.25.40.10:FF:002980', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g62890', NULL, NULL, NULL, NULL, NULL, 4),
(82021, NULL, 'G3DSA:1.20.120.1380:FF:000001', NULL, NULL, 'Flagellar biosynthesis regulator FlhF', NULL, NULL, NULL, NULL, NULL, 4),
(82022, NULL, 'G3DSA:1.20.1070.10:FF:002046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82023, NULL, 'G3DSA:1.10.472.10:FF:000527', NULL, NULL, 'Cyclin, N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(82024, NULL, 'G3DSA:2.60.40.10:FF:002891', NULL, NULL, 'Alpha-1-B glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(82025, NULL, 'G3DSA:3.80.10.10:FF:001874', NULL, NULL, 'Hypothetical leucine-rich repeat protein 1 (LRRP1)', NULL, NULL, NULL, NULL, NULL, 4),
(82026, NULL, 'G3DSA:1.20.5.110:FF:000114', NULL, NULL, 'Syntaxin-7', NULL, NULL, NULL, NULL, NULL, 4),
(82027, NULL, 'G3DSA:2.30.29.30:FF:000741', NULL, NULL, 'Serine/threonine-protein kinase CLA4', NULL, NULL, NULL, NULL, NULL, 4),
(82028, NULL, 'G3DSA:3.30.1240.10:FF:000009', NULL, NULL, 'Haloacid dehalogenase-like hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(82029, NULL, 'G3DSA:3.60.10.10:FF:000065', NULL, NULL, 'Sphingomyelin phosphodiesterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(82030, NULL, 'G3DSA:3.20.20.80:FF:000105', NULL, NULL, 'Glucan 1,3-beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(82031, NULL, 'G3DSA:3.80.10.10:FF:000901', NULL, NULL, 'CLV1 receptor kinase-like', NULL, NULL, NULL, NULL, NULL, 4),
(82032, NULL, 'G3DSA:1.20.5.170:FF:000216', NULL, NULL, 'Nuclear pore complex protein Nup54', NULL, NULL, NULL, NULL, NULL, 4),
(82033, NULL, 'G3DSA:3.40.50.1820:FF:000850', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(82034, NULL, 'G3DSA:3.30.559.10:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(82035, NULL, 'G3DSA:3.10.100.10:FF:000393', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82036, NULL, 'G3DSA:3.80.10.10:FF:004280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82037, NULL, 'G3DSA:3.30.980.10:FF:000021', NULL, NULL, 'Alanyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(82038, NULL, 'G3DSA:2.30.29.30:FF:000421', NULL, NULL, 'Arf-GAP with GTPase, ANK repeat and PH domain-containing protein 1 isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(82039, NULL, 'G3DSA:1.10.730.10:FF:000178', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(82040, NULL, 'G3DSA:3.30.420.40:FF:000679', NULL, NULL, 'O-sialoglycoprotein endopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(82041, NULL, 'G3DSA:3.30.40.10:FF:002277', NULL, NULL, 'Lysine demethylase 4B', NULL, NULL, NULL, NULL, NULL, 4),
(82042, NULL, 'G3DSA:3.90.70.10:FF:000837', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82043, NULL, 'G3DSA:3.40.50.1460:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82044, NULL, 'G3DSA:2.10.110.10:FF:000217', NULL, NULL, 'LIM domain family', NULL, NULL, NULL, NULL, NULL, 4),
(82045, NULL, 'G3DSA:3.40.50.150:FF:001323', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82046, NULL, 'G3DSA:3.40.50.970:FF:000164', NULL, NULL, 'Thiamine pyrophosphate-dependent dehydrogenase E1 component subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(82047, NULL, 'G3DSA:3.30.430.20:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82048, NULL, 'G3DSA:1.10.510.10:FF:003382', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82049, NULL, 'G3DSA:3.80.10.10:FF:004050', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(82050, NULL, 'G3DSA:1.20.920.10:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82051, NULL, 'G3DSA:3.40.50.1820:FF:000620', NULL, NULL, 'Phospholipase YtpA', NULL, NULL, NULL, NULL, NULL, 4),
(82052, NULL, 'G3DSA:3.40.190.10:FF:000189', NULL, NULL, 'Glutamate receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(82053, NULL, 'G3DSA:3.40.50.300:FF:006747', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82054, NULL, 'G3DSA:2.130.10.10:FF:001553', NULL, NULL, 'WD40 repeat-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(82055, NULL, 'G3DSA:3.90.70.10:FF:000495', NULL, NULL, 'Ubiquitin-specific protease, putative (AFU_orthologue AFUA_1G07555)', NULL, NULL, NULL, NULL, NULL, 4),
(82056, NULL, 'G3DSA:3.40.50.300:FF:007253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82057, NULL, 'G3DSA:3.30.70.1450:FF:000017', NULL, NULL, 'SLC13 family permease', NULL, NULL, NULL, NULL, NULL, 4),
(82058, NULL, 'G3DSA:3.90.1150.10:FF:000438', NULL, NULL, 'Serine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(82059, NULL, 'G3DSA:3.20.16.10:FF:000001', NULL, NULL, 'Capsid scaffolding protein', NULL, NULL, NULL, NULL, NULL, 4),
(82060, NULL, 'G3DSA:3.40.50.720:FF:002258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82061, NULL, 'G3DSA:1.25.10.10:FF:003326', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82062, NULL, 'G3DSA:1.10.1060.10:FF:000024', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] iron-sulfur subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(82063, NULL, 'G3DSA:1.25.40.70:FF:000030', NULL, NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(82064, NULL, 'G3DSA:3.60.130.10:FF:000091', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(82065, NULL, 'G3DSA:3.40.850.10:FF:000543', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82066, NULL, 'G3DSA:3.40.50.20:FF:000004', NULL, NULL, 'Probable alpha-L-glutamate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(82067, NULL, 'G3DSA:3.40.50.300:FF:007023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82068, NULL, 'G3DSA:3.30.70.1440:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(82069, NULL, 'G3DSA:2.130.10.10:FF:002970', NULL, NULL, 'WD-40 repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(82070, NULL, 'G3DSA:1.10.340.70:FF:000003', NULL, NULL, 'Protein CBG25708', NULL, NULL, NULL, NULL, NULL, 4),
(82071, NULL, 'G3DSA:1.10.510.10:FF:003152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82072, NULL, 'G3DSA:3.30.160.60:FF:005509', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82073, NULL, 'G3DSA:3.55.40.20:FF:000015', NULL, NULL, 'Superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(82074, NULL, 'G3DSA:3.20.20.80:FF:000543', NULL, NULL, 'Chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(82075, NULL, 'G3DSA:3.40.50.460:FF:000016', NULL, NULL, '6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(82076, NULL, 'G3DSA:3.40.50.720:FF:002028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82077, NULL, 'G3DSA:2.40.30.110:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82078, NULL, 'G3DSA:3.40.50.12780:FF:000068', NULL, NULL, 'Nonribosomal peptide synthase GliP', NULL, NULL, NULL, NULL, NULL, 4),
(82079, NULL, 'G3DSA:3.40.50.11850:FF:000014', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(82080, NULL, 'G3DSA:3.30.1360.40:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82081, NULL, 'G3DSA:1.10.1240.10:FF:000010', NULL, NULL, '5-methyltetrahydrofolate S-homocysteine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(82082, NULL, 'G3DSA:3.30.70.2800:FF:000001', NULL, NULL, 'Diedel 2', NULL, NULL, NULL, NULL, NULL, 4),
(82083, NULL, 'G3DSA:2.30.29.30:FF:000628', NULL, NULL, 'Nuclear pore complex protein Nup50', NULL, NULL, NULL, NULL, NULL, 4),
(82084, NULL, 'G3DSA:1.25.40.420:FF:000052', NULL, NULL, 'Protein CBR-TAG-30', NULL, NULL, NULL, NULL, NULL, 4),
(82085, NULL, 'G3DSA:1.10.8.10:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82086, NULL, 'G3DSA:3.80.10.10:FF:002138', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(82087, NULL, 'G3DSA:2.60.40.60:FF:000747', NULL, NULL, 'Cadherin-4', NULL, NULL, NULL, NULL, NULL, 4),
(82088, NULL, 'G3DSA:3.40.50.620:FF:000429', NULL, NULL, 'Riboflavin biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(82089, NULL, 'G3DSA:1.10.260.40:FF:000072', NULL, NULL, 'Helix-turn-helix transcriptional regulator, XRE family', NULL, NULL, NULL, NULL, NULL, 4),
(82090, NULL, 'G3DSA:3.40.50.1000:FF:000020', NULL, NULL, 'Probable cation-transporting P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(82091, NULL, 'G3DSA:3.30.70.330:FF:000473', NULL, NULL, 'RNA binding fox-1 homolog 3', NULL, NULL, NULL, NULL, NULL, 4),
(82092, NULL, 'G3DSA:3.40.50.11840:FF:000011', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(82093, NULL, 'G3DSA:3.80.10.10:FF:003774', NULL, NULL, 'Leucine-rich repeat protein soc-2 homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(82094, NULL, 'G3DSA:3.30.70.1430:FF:000011', NULL, NULL, 'RND multidrug efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(82095, NULL, 'G3DSA:4.10.1000.10:FF:000035', NULL, NULL, 'CCCH zinc finger protein, variant', NULL, NULL, NULL, NULL, NULL, 4),
(82096, NULL, 'G3DSA:3.90.640.10:FF:000140', NULL, NULL, 'Related to glucose regulated stress protein, HSP70-like', NULL, NULL, NULL, NULL, NULL, 4),
(82097, NULL, 'G3DSA:3.30.200.20:FF:002259', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(82098, NULL, 'G3DSA:3.50.50.60:FF:000577', NULL, NULL, 'Styrene monooxygenase StyA', NULL, NULL, NULL, NULL, NULL, 4),
(82099, NULL, 'G3DSA:1.20.1250.20:FF:000236', NULL, NULL, 'Proline/betaine transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(82100, NULL, 'G3DSA:3.30.160.60:FF:001250', NULL, NULL, 'putative transcription factor ovo-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(82101, NULL, 'G3DSA:2.30.30.40:FF:000495', NULL, NULL, 'Rho GTPase-activating protein gacJJ', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(82102, NULL, 'G3DSA:3.90.190.10:FF:000161', NULL, NULL, 'Probable dual specificity protein phosphatase DDB_G0269404', NULL, NULL, NULL, NULL, NULL, 4),
(82103, NULL, 'G3DSA:1.10.287.4070:FF:000012', NULL, NULL, 'Nucleolar protein NOP5', NULL, NULL, NULL, NULL, NULL, 4),
(82104, NULL, 'G3DSA:2.130.10.10:FF:003144', NULL, NULL, 'WD repeat-containing protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(82105, NULL, 'G3DSA:2.30.29.30:FF:000067', NULL, NULL, 'Putative DCC-interacting protein 13-beta isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(82106, NULL, 'G3DSA:3.40.50.150:FF:001542', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82107, NULL, 'G3DSA:3.40.630.30:FF:000100', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(82108, NULL, 'G3DSA:1.25.10.10:FF:001174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82109, NULL, 'G3DSA:1.10.287.3240:FF:000004', NULL, NULL, 'V-type ATP synthase subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(82110, NULL, 'G3DSA:3.40.30.10:FF:000112', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(82111, NULL, 'G3DSA:2.40.50.140:FF:000694', NULL, NULL, 'GD18443', NULL, NULL, NULL, NULL, NULL, 4),
(82112, NULL, 'G3DSA:3.40.50.1010:FF:000023', NULL, NULL, 'DNA repair protein complementing XP-G cells', NULL, NULL, NULL, NULL, NULL, 4),
(82113, NULL, 'G3DSA:3.40.1280.10:FF:000061', NULL, NULL, 'rRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(82114, NULL, 'G3DSA:1.20.5.170:FF:000093', NULL, NULL, 'BZIP transcription factor (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(82115, NULL, 'G3DSA:2.60.40.10:FF:005515', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82116, NULL, 'G3DSA:1.25.10.10:FF:000691', NULL, NULL, 'Condensin-2 complex subunit D3', NULL, NULL, NULL, NULL, NULL, 4),
(82117, NULL, 'G3DSA:3.90.1150.10:FF:000096', NULL, NULL, 'ATP-binding cassette sub-family A member 3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(82118, NULL, 'G3DSA:1.20.1070.10:FF:001883', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82119, NULL, 'G3DSA:2.130.10.10:FF:002868', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One component system)', NULL, NULL, NULL, NULL, NULL, 4),
(82120, NULL, 'G3DSA:3.30.70.330:FF:001310', NULL, NULL, 'Dietary Restriction Response (WT but not eat-2 lifespan increased)', NULL, NULL, NULL, NULL, NULL, 4),
(82121, NULL, 'G3DSA:2.40.50.120:FF:000020', NULL, NULL, 'Netrin 5', NULL, NULL, NULL, NULL, NULL, 4),
(82122, NULL, 'G3DSA:1.10.3380.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82123, NULL, 'G3DSA:3.30.200.20:FF:000691', NULL, NULL, 'Cyclin-dependent kinase G-1', NULL, NULL, NULL, NULL, NULL, 4),
(82124, NULL, 'G3DSA:1.25.10.10:FF:000898', NULL, NULL, 'Formin BNI1', NULL, NULL, NULL, NULL, NULL, 4),
(82125, NULL, 'G3DSA:3.30.160.60:FF:002874', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82126, NULL, 'G3DSA:3.90.640.10:FF:000038', NULL, NULL, 'Actin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(82127, NULL, 'G3DSA:1.10.287.920:FF:000004', NULL, NULL, 'Pheromone receptor PREB', NULL, NULL, NULL, NULL, NULL, 4),
(82128, NULL, 'G3DSA:1.10.150.280:FF:000004', NULL, NULL, 'Transcription elongation factor, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(82129, NULL, 'G3DSA:2.10.109.10:FF:000034', NULL, NULL, 'LexA repressor', NULL, NULL, NULL, NULL, NULL, 4),
(82130, NULL, 'G3DSA:3.40.190.160:FF:000001', NULL, NULL, 'Probable arabinosyltransferase C', NULL, NULL, NULL, NULL, NULL, 4),
(82131, NULL, 'G3DSA:3.30.160.60:FF:005302', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82132, NULL, 'G3DSA:3.40.50.300:FF:005662', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(82133, NULL, 'G3DSA:1.20.5.190:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82134, NULL, 'G3DSA:3.40.190.10:FF:000543', NULL, NULL, 'Ionotropic receptor 87a', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(82135, NULL, 'G3DSA:1.10.10.10:FF:001005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82136, NULL, 'G3DSA:2.60.120.20:FF:000018', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(82137, NULL, 'G3DSA:1.10.510.10:FF:004467', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82138, NULL, 'G3DSA:3.40.190.170:FF:000004', NULL, NULL, 'Trap dicarboxylate transporter, dctp subunit', NULL, NULL, NULL, NULL, NULL, 4),
(82139, NULL, 'G3DSA:3.80.10.10:FF:000238', NULL, NULL, 'Leucine rich repeats and guanylate kinase domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(82140, NULL, 'G3DSA:3.30.70.1230:FF:000041', NULL, NULL, 'Adenylate cyclase 1', NULL, NULL, NULL, NULL, NULL, 4),
(82141, NULL, 'G3DSA:2.40.50.180:FF:000009', NULL, NULL, 'Chemotaxis protein CheW', NULL, NULL, NULL, NULL, NULL, 4),
(82142, NULL, 'G3DSA:3.30.40.10:FF:000377', NULL, NULL, 'Putative jumonji family transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(82143, NULL, 'G3DSA:3.40.50.2300:FF:000904', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82144, NULL, 'G3DSA:3.30.160.60:FF:001457', NULL, NULL, 'Zinc finger protein 275', NULL, NULL, NULL, NULL, NULL, 4),
(82145, NULL, 'G3DSA:1.10.260.100:FF:000025', NULL, NULL, 'Hsc/Hsp70-interacting protein related, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(82146, NULL, 'G3DSA:3.30.930.10:FF:000304', NULL, NULL, 'Os07g0165000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(82147, NULL, 'G3DSA:3.50.50.60:FF:000370', NULL, NULL, 'Sarcosine oxidase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(82148, NULL, 'G3DSA:1.10.287.910:FF:000001', NULL, NULL, 'Hg(II) uptake system permease component MerT family', NULL, NULL, NULL, NULL, NULL, 4),
(82149, NULL, 'G3DSA:1.10.150.20:FF:000187', NULL, NULL, 'Protein CBR-ERCC-1', NULL, NULL, NULL, NULL, NULL, 4),
(82150, NULL, 'G3DSA:3.40.250.10:FF:000132', NULL, NULL, 'MAP kinase phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(82151, NULL, 'G3DSA:2.30.280.10:FF:000005', NULL, NULL, 'E3 ubiquitin-protein ligase UHRF1', NULL, NULL, NULL, NULL, NULL, 4),
(82152, NULL, 'G3DSA:1.25.40.10:FF:000748', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(82153, NULL, 'G3DSA:3.90.25.10:FF:000064', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(82154, NULL, 'G3DSA:2.60.120.10:FF:000015', NULL, NULL, 'Rap guanine nucleotide exchange factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(82155, NULL, 'G3DSA:3.30.110.130:FF:000001', NULL, NULL, 'Hemolysin', NULL, NULL, NULL, NULL, NULL, 4),
(82156, NULL, 'G3DSA:3.40.50.720:FF:002360', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82157, NULL, 'G3DSA:1.20.1070.10:FF:000017', NULL, NULL, 'lysophosphatidic acid receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(82158, NULL, 'G3DSA:3.40.50.170:FF:000025', NULL, NULL, 'Phosphoribosylglycinamide formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(82159, NULL, 'G3DSA:3.40.50.10490:FF:000134', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82160, NULL, 'G3DSA:2.60.40.10:FF:002666', NULL, NULL, 'Probable beta-glucosidase E', NULL, NULL, NULL, NULL, NULL, 4),
(82161, NULL, 'G3DSA:2.130.10.10:FF:001121', NULL, NULL, 'Rabconnectin-3B, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(82162, NULL, 'G3DSA:3.30.479.20:FF:000027', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(82163, NULL, 'G3DSA:1.10.630.10:FF:000120', NULL, NULL, 'Lanosterol 14-alpha demethylase', NULL, NULL, NULL, NULL, NULL, 4),
(82164, NULL, 'G3DSA:3.90.550.10:FF:000728', NULL, NULL, 'Glycogenin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(82165, NULL, 'G3DSA:2.60.120.380:FF:000010', NULL, NULL, 'Calpain 10', NULL, NULL, NULL, NULL, NULL, 4),
(82166, NULL, 'G3DSA:2.60.40.10:FF:005414', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82167, NULL, 'G3DSA:1.25.40.10:FF:003036', NULL, NULL, 'Tetratricopeptide repeat protein 37', NULL, NULL, NULL, NULL, NULL, 4),
(82168, NULL, 'G3DSA:2.60.40.1400:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(82169, NULL, 'G3DSA:3.40.50.300:FF:001520', NULL, NULL, 'ATP-dependent Clp protease, ATP-binding subunit ClpX', NULL, NULL, NULL, NULL, NULL, 4),
(82170, NULL, 'G3DSA:1.10.287.70:FF:000092', NULL, NULL, 'Voltage-gated potassium channel', NULL, NULL, NULL, NULL, NULL, 4),
(82171, NULL, 'G3DSA:3.30.710.10:FF:000221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82172, NULL, 'G3DSA:2.20.100.10:FF:000113', NULL, NULL, 'TRAP-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(82173, NULL, 'G3DSA:1.20.58.60:FF:000741', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82174, NULL, 'G3DSA:4.10.280.10:FF:000114', NULL, NULL, 'N-acetyl-gamma-glutamyl-phosphate partial', NULL, NULL, NULL, NULL, NULL, 4),
(82175, NULL, 'G3DSA:3.40.50.300:FF:003644', NULL, NULL, 'Type VI secretion protein', NULL, NULL, NULL, NULL, NULL, 4),
(82176, NULL, 'G3DSA:3.40.50.1000:FF:000599', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82177, NULL, 'G3DSA:2.60.40.60:FF:000966', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82178, NULL, 'G3DSA:1.25.40.610:FF:000013', NULL, NULL, 'Adhesion G protein-coupled receptor L2', NULL, NULL, NULL, NULL, NULL, 4),
(82179, NULL, 'G3DSA:2.130.10.10:FF:003245', NULL, NULL, 'Protein CBG02611', NULL, NULL, NULL, NULL, NULL, 4),
(82180, NULL, 'G3DSA:3.40.640.10:FF:000286', NULL, NULL, 'Probable acetylornithine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(82181, NULL, 'G3DSA:3.40.50.300:FF:006298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82182, NULL, 'G3DSA:2.60.60.20:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82183, NULL, 'G3DSA:3.30.110.20:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82184, NULL, 'G3DSA:3.10.450.40:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82185, NULL, 'G3DSA:3.20.70.20:FF:000051', NULL, NULL, 'Glr3745 protein', NULL, NULL, NULL, NULL, NULL, 4),
(82186, NULL, 'G3DSA:1.25.40.10:FF:000288', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g02750', NULL, NULL, NULL, NULL, NULL, 4),
(82187, NULL, 'G3DSA:3.40.50.880:FF:000148', NULL, NULL, 'Imidazole glycerol phosphate synthase subunit HisH', NULL, NULL, NULL, NULL, NULL, 4),
(82188, NULL, 'G3DSA:3.40.50.150:FF:001109', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82189, NULL, 'G3DSA:3.40.50.720:FF:000561', NULL, NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(82190, NULL, 'G3DSA:3.30.70.330:FF:002619', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82191, NULL, 'G3DSA:2.130.10.10:FF:004780', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82192, NULL, 'G3DSA:3.80.10.10:FF:002812', NULL, NULL, 'Slit protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(82193, NULL, 'G3DSA:1.10.287.4070:FF:000017', NULL, NULL, 'YALI0B13706p', NULL, NULL, NULL, NULL, NULL, 4),
(82194, NULL, 'G3DSA:2.40.50.1070:FF:000002', NULL, NULL, '23S rRNA (uracil(747)-C(5))-methyltransferase RlmC', NULL, NULL, NULL, NULL, NULL, 4),
(82195, NULL, 'G3DSA:3.40.50.150:FF:001216', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82196, NULL, 'G3DSA:1.25.40.470:FF:000050', NULL, NULL, 'Conserved WD40 and TPR repeat-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(82197, NULL, 'G3DSA:2.10.25.10:FF:001767', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(82198, NULL, 'G3DSA:3.30.160.60:FF:003823', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82199, NULL, 'G3DSA:3.40.50.300:FF:001413', NULL, NULL, 'Helicase with zinc finger domain 2', NULL, NULL, NULL, NULL, NULL, 4),
(82200, NULL, 'G3DSA:1.10.287.70:FF:000103', NULL, NULL, 'Cyclic nucleotide-gated cation channel alpha-4', NULL, NULL, NULL, NULL, NULL, 4),
(82201, NULL, 'G3DSA:3.30.1400.10:FF:000005', NULL, NULL, 'Cell division protein ZipA', NULL, NULL, NULL, NULL, NULL, 4),
(82202, NULL, 'G3DSA:1.25.10.10:FF:002933', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(82203, NULL, 'G3DSA:1.20.5.1700:FF:000005', NULL, NULL, 'homer protein homolog 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(82204, NULL, 'G3DSA:3.40.50.300:FF:003537', NULL, NULL, 'RAS-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(82205, NULL, 'G3DSA:2.30.30.940:FF:000005', NULL, NULL, 'ATP-dependent RecD-like DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(82206, NULL, 'G3DSA:1.25.40.10:FF:000967', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(82207, NULL, 'G3DSA:3.30.200.20:FF:000573', NULL, NULL, 'Serine/threonine-protein kinase OXI1', NULL, NULL, NULL, NULL, NULL, 4),
(82208, NULL, 'G3DSA:3.30.230.10:FF:000072', NULL, NULL, 'Diphosphomevalonate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(82209, NULL, 'G3DSA:3.80.10.10:FF:002705', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(82210, NULL, 'G3DSA:2.10.25.10:FF:000137', NULL, NULL, 'neurexin-2-beta isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(82211, NULL, 'G3DSA:3.30.40.10:FF:002058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82212, NULL, 'G3DSA:3.30.1520.10:FF:000059', NULL, NULL, 'Sorting nexin 2B', NULL, NULL, NULL, NULL, NULL, 4),
(82213, NULL, 'G3DSA:3.40.50.300:FF:000789', NULL, NULL, 'DNA replication ATP-dependent helicase/nuclease DNA2', NULL, NULL, NULL, NULL, NULL, 4),
(82214, NULL, 'G3DSA:2.130.10.10:FF:001014', NULL, NULL, 'Pre-mRNA splicing factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(82215, NULL, 'G3DSA:3.20.20.330:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82216, NULL, 'G3DSA:1.10.10.10:FF:001342', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit K', NULL, NULL, NULL, NULL, NULL, 4),
(82217, NULL, 'G3DSA:3.30.70.330:FF:002945', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82218, NULL, 'G3DSA:1.20.1250.20:FF:002136', NULL, NULL, 'Solute carrier, putative', NULL, NULL, NULL, NULL, NULL, 4),
(82219, NULL, 'G3DSA:3.90.1100.10:FF:000059', NULL, NULL, 'Leucine aminopeptidase 2 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(82220, NULL, 'G3DSA:2.10.25.10:FF:000351', NULL, NULL, 'Neurogenic locus notch homolog protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(82221, NULL, 'G3DSA:3.60.20.10:FF:000228', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82222, NULL, 'G3DSA:1.10.2000.10:FF:000032', NULL, NULL, 'Secreted frizzled-related protein precusor', NULL, NULL, NULL, NULL, NULL, 4),
(82223, NULL, 'G3DSA:3.40.1190.20:FF:000062', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(82224, NULL, 'G3DSA:2.130.10.10:FF:004768', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82225, NULL, 'G3DSA:1.25.40.180:FF:000058', NULL, NULL, 'Cell cycle control protein', NULL, NULL, NULL, NULL, NULL, 4),
(82226, NULL, 'G3DSA:1.10.630.10:FF:000013', NULL, NULL, 'Trans-cinnamate 4-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(82227, NULL, 'G3DSA:3.90.226.10:FF:000239', NULL, NULL, 'Probable enoyl-CoA hydratase/isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(82228, NULL, 'G3DSA:3.40.50.620:FF:000194', NULL, NULL, 'Diphthine--ammonia ligase', NULL, NULL, NULL, NULL, NULL, 4),
(82229, NULL, 'G3DSA:1.10.1670.10:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82230, NULL, 'G3DSA:2.60.210.10:FF:000028', NULL, NULL, 'Speckle-type POZ protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(82231, NULL, 'G3DSA:1.25.10.10:FF:001292', NULL, NULL, 'Small subunit processome component 20 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(82232, NULL, 'G3DSA:2.30.240.10:FF:000003', NULL, NULL, 'AT4g02370 protein', NULL, NULL, NULL, NULL, NULL, 4),
(82233, NULL, 'G3DSA:3.30.450.20:FF:000400', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82234, NULL, 'G3DSA:3.40.190.10:FF:000762', NULL, NULL, 'Transferrin', NULL, NULL, NULL, NULL, NULL, 4),
(82235, NULL, 'G3DSA:3.20.20.140:FF:000312', NULL, NULL, 'Guanine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(82236, NULL, 'G3DSA:1.25.10.10:FF:002596', NULL, NULL, 'Protein HGH1 homolog', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(82237, NULL, 'G3DSA:2.60.270.50:FF:000004', NULL, NULL, 'Uncharacterized protein DDB_G0272682', NULL, NULL, NULL, NULL, NULL, 4),
(82238, NULL, 'G3DSA:3.30.420.40:FF:000893', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82239, NULL, 'G3DSA:3.30.1550.10:FF:000005', NULL, NULL, '50S ribosomal protein L11', NULL, NULL, NULL, NULL, NULL, 4),
(82240, NULL, 'G3DSA:1.10.10.60:FF:001110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82241, NULL, 'G3DSA:1.10.1200.10:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82242, NULL, 'G3DSA:1.25.10.10:FF:001410', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82243, NULL, 'G3DSA:3.50.50.60:FF:000813', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82244, NULL, 'G3DSA:1.10.150.220:FF:000003', NULL, NULL, 'protein phosphatase 1 regulatory subunit 14D', NULL, NULL, NULL, NULL, NULL, 4),
(82245, NULL, 'G3DSA:2.60.40.10:FF:001143', NULL, NULL, 'Protein-glutamine gamma-glutamyltransferase K', NULL, NULL, NULL, NULL, NULL, 4),
(82246, NULL, 'G3DSA:3.90.950.10:FF:000028', NULL, NULL, 'Nucleoside triphosphate pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(82247, NULL, 'G3DSA:3.20.20.140:FF:000205', NULL, NULL, 'Guanine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(82248, NULL, 'G3DSA:3.50.50.60:FF:000706', NULL, NULL, 'Squalene epoxidase a', NULL, NULL, NULL, NULL, NULL, 4),
(82249, NULL, 'G3DSA:1.25.40.10:FF:004559', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82250, NULL, 'G3DSA:1.25.10.10:FF:000679', NULL, NULL, 'BnaA09g42810D protein', NULL, NULL, NULL, NULL, NULL, 4),
(82251, NULL, 'G3DSA:2.130.10.10:FF:003138', NULL, NULL, 'Syntaxin binding protein 5 like', NULL, NULL, NULL, NULL, NULL, 4),
(82252, NULL, 'G3DSA:3.40.1110.10:FF:000301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82253, NULL, 'G3DSA:2.130.10.10:FF:000497', NULL, NULL, 'DDB1 and CUL4-associated factor 12-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(82254, NULL, 'G3DSA:3.30.497.10:FF:000089', NULL, NULL, 'Serpin 42Db, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(82255, NULL, 'G3DSA:3.40.50.720:FF:000128', NULL, NULL, 'Quinone oxidoreductase YhdH', NULL, NULL, NULL, NULL, NULL, 4),
(82256, NULL, 'G3DSA:2.10.25.10:FF:000244', NULL, NULL, 'Fibrillin-1', NULL, NULL, NULL, NULL, NULL, 4),
(82257, NULL, 'G3DSA:1.20.58.60:FF:000634', NULL, NULL, 'Spectrin repeat-containing, nuclear envelope 1b', NULL, NULL, NULL, NULL, NULL, 4),
(82258, NULL, 'G3DSA:2.60.40.10:FF:005521', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82259, NULL, 'G3DSA:3.80.20.20:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82260, NULL, 'G3DSA:1.25.10.10:FF:001303', NULL, NULL, 'Ctnnb1', NULL, NULL, NULL, NULL, NULL, 4),
(82261, NULL, 'G3DSA:3.30.420.40:FF:000786', NULL, NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(82262, NULL, 'G3DSA:3.40.50.300:FF:000896', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(82263, NULL, 'G3DSA:1.10.10.60:FF:000486', NULL, NULL, 'Divergent paired-related homeobox', NULL, NULL, NULL, NULL, NULL, 4),
(82264, NULL, 'G3DSA:3.30.1520.10:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82265, NULL, 'G3DSA:3.90.190.10:FF:000060', NULL, NULL, 'Phosphatidylglycerophosphatase and protein-tyrosine phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(82266, NULL, 'G3DSA:2.30.30.490:FF:000044', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(82267, NULL, 'G3DSA:3.50.50.60:FF:000476', NULL, NULL, 'Sarcosine oxidase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(82268, NULL, 'G3DSA:2.60.40.2150:FF:000001', NULL, NULL, 'Interleukin 17 receptor B', NULL, NULL, NULL, NULL, NULL, 4),
(82269, NULL, 'G3DSA:1.10.510.10:FF:001252', NULL, NULL, 'IKS protein kinase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(82270, NULL, 'G3DSA:2.40.10.10:FF:000299', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(82271, NULL, 'G3DSA:3.30.310.20:FF:000002', NULL, NULL, 'DNA-3-methyladenine glycosylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(82272, NULL, 'G3DSA:4.10.1060.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82273, NULL, 'G3DSA:3.40.50.150:FF:001435', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82274, NULL, 'G3DSA:1.25.10.10:FF:001073', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(82275, NULL, 'G3DSA:3.90.1720.10:FF:000010', NULL, NULL, 'Peptidoglycan endopeptidase RipA', NULL, NULL, NULL, NULL, NULL, 4),
(82276, NULL, 'G3DSA:3.30.40.10:FF:000153', NULL, NULL, 'Histone-lysine N-methyltransferase NSD2', NULL, NULL, NULL, NULL, NULL, 4),
(82277, NULL, 'G3DSA:1.20.1250.20:FF:002029', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(82278, NULL, 'G3DSA:3.90.180.10:FF:000008', NULL, NULL, 'Sorbitol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(82279, NULL, 'G3DSA:1.10.418.80:FF:000001', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 3', NULL, NULL, NULL, NULL, NULL, 4),
(82280, NULL, 'G3DSA:1.20.58.900:FF:000025', NULL, NULL, 'RUN and FYVE domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(82281, NULL, 'G3DSA:2.60.40.10:FF:003374', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(82282, NULL, 'G3DSA:2.40.50.90:FF:000156', NULL, NULL, 'Thermonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(82283, NULL, 'G3DSA:3.55.40.20:FF:000021', NULL, NULL, 'Superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(82284, NULL, 'G3DSA:1.10.555.10:FF:000141', NULL, NULL, 'Rho GTPase-activating protein (RhoGAP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(82285, NULL, 'G3DSA:3.90.190.20:FF:000063', NULL, NULL, 'Folylpolyglutamate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(82286, NULL, 'G3DSA:1.10.400.10:FF:000069', NULL, NULL, 'Guanine nucleotide-binding protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(82287, NULL, 'G3DSA:3.30.200.20:FF:000466', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(82288, NULL, 'G3DSA:1.10.10.60:FF:001003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82289, NULL, 'G3DSA:3.30.70.370:FF:000018', NULL, NULL, 'DNA polymerase gamma 1', NULL, NULL, NULL, NULL, NULL, 4),
(82290, NULL, 'G3DSA:2.10.25.10:FF:000570', NULL, NULL, 'Notch homolog 4, [Drosophila]', NULL, NULL, NULL, NULL, NULL, 4),
(82291, NULL, 'G3DSA:2.30.39.10:FF:000123', NULL, NULL, 'Secreted salivary gland peptide, putative', NULL, NULL, NULL, NULL, NULL, 4),
(82292, NULL, 'G3DSA:3.30.160.60:FF:005061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82293, NULL, 'G3DSA:3.30.200.20:FF:002490', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82294, NULL, 'G3DSA:4.10.260.10:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82295, NULL, 'G3DSA:3.40.50.300:FF:004948', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82296, NULL, 'G3DSA:3.40.720.10:FF:000213', NULL, NULL, 'Iduronate-2-sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(82297, NULL, 'G3DSA:3.40.630.30:FF:000212', NULL, NULL, 'Putative diamine N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(82298, NULL, 'G3DSA:3.90.120.10:FF:000016', NULL, NULL, 'tRNA (cytosine(38)-C(5))-methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(82299, NULL, 'G3DSA:3.40.50.720:FF:000780', NULL, NULL, 'Putative quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(82300, NULL, 'G3DSA:1.10.510.10:FF:000858', NULL, NULL, 'AGC protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(82301, NULL, 'G3DSA:1.10.510.10:FF:002882', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82302, NULL, 'G3DSA:3.40.50.720:FF:001758', NULL, NULL, 'CurH', NULL, NULL, NULL, NULL, NULL, 4),
(82303, NULL, 'G3DSA:1.25.10.10:FF:002826', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82304, NULL, 'G3DSA:2.130.10.10:FF:004549', NULL, NULL, 'Ribosome biogenesis protein WDR12 homolog', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(82305, NULL, 'G3DSA:3.30.160.60:FF:005066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82306, NULL, 'G3DSA:3.40.50.620:FF:000205', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(82307, NULL, 'G3DSA:1.10.10.10:FF:000960', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82308, NULL, 'G3DSA:3.80.10.10:FF:003998', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82309, NULL, 'G3DSA:1.10.490.10:FF:000024', NULL, NULL, 'GM10846', NULL, NULL, NULL, NULL, NULL, 4),
(82310, NULL, 'G3DSA:2.60.220.50:FF:000170', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(82311, NULL, 'G3DSA:1.25.40.20:FF:001134', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(82312, NULL, 'G3DSA:2.10.25.10:FF:000025', NULL, NULL, 'Thrombospondin 3', NULL, NULL, NULL, NULL, NULL, 4),
(82313, NULL, 'G3DSA:3.40.50.720:FF:001977', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82314, NULL, 'G3DSA:1.10.238.10:FF:000944', NULL, NULL, 'Calcium-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(82315, NULL, 'G3DSA:1.20.1730.10:FF:000028', NULL, NULL, 'Sodium/solute symporter', NULL, NULL, NULL, NULL, NULL, 4),
(82316, NULL, 'G3DSA:1.25.40.10:FF:001131', NULL, NULL, 'Os03g0308800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(82317, NULL, 'G3DSA:3.40.640.10:FF:000393', NULL, NULL, 'Sphingosine-1-phosphate lyase 1', NULL, NULL, NULL, NULL, NULL, 4),
(82318, NULL, 'G3DSA:1.10.510.10:FF:001471', NULL, NULL, 'Calcium-dependent kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(82319, NULL, 'G3DSA:3.40.50.1580:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82320, NULL, 'G3DSA:3.30.450.20:FF:000170', NULL, NULL, 'Oxygen sensor protein DosP', NULL, NULL, NULL, NULL, NULL, 4),
(82321, NULL, 'G3DSA:1.25.50.20:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82322, NULL, 'G3DSA:1.10.10.60:FF:000946', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82323, NULL, 'G3DSA:2.40.50.140:FF:000470', NULL, NULL, 'Related to RRP5-processing of pre-ribosomal RNA', NULL, NULL, NULL, NULL, NULL, 4),
(82324, NULL, 'G3DSA:2.60.40.10:FF:002885', NULL, NULL, 'Leptin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(82325, NULL, 'G3DSA:1.20.140.40:FF:000089', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82326, NULL, 'G3DSA:3.30.450.70:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82327, NULL, 'G3DSA:3.30.70.360:FF:000015', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(82328, NULL, 'G3DSA:3.30.70.330:FF:000714', NULL, NULL, 'Glycine-rich RNA-binding protein 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(82329, NULL, 'G3DSA:1.25.40.10:FF:002761', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82330, NULL, 'G3DSA:3.90.1580.10:FF:000021', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(82331, NULL, 'G3DSA:3.40.50.80:FF:000224', NULL, NULL, 'NADH-cytochrome b5 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(82332, NULL, 'G3DSA:3.30.160.60:FF:005280', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82333, NULL, 'G3DSA:3.30.365.10:FF:000030', NULL, NULL, 'Aldehyde oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(82334, NULL, 'G3DSA:3.20.20.140:FF:000200', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(82335, NULL, 'G3DSA:2.60.40.10:FF:005740', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82336, NULL, 'G3DSA:1.20.1080.10:FF:000074', NULL, NULL, 'AQuaPorin or aquaglyceroporin related', NULL, NULL, NULL, NULL, NULL, 4),
(82337, NULL, 'G3DSA:3.40.190.10:FF:000981', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(82338, NULL, 'G3DSA:1.10.287.10:FF:000006', NULL, NULL, 'Bifunctional glutamate/proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(82339, NULL, 'G3DSA:3.30.56.10:FF:000043', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(82340, NULL, 'G3DSA:1.20.1560.10:FF:000442', NULL, NULL, 'Protein CBG25498', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(82341, NULL, 'G3DSA:1.10.238.10:FF:001219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82342, NULL, 'G3DSA:3.40.50.720:FF:000347', NULL, NULL, 'UDP-N-acetylglucosamine 4-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(82343, NULL, 'G3DSA:3.40.462.20:FF:000009', NULL, NULL, 'FAD-linked oxidoreductase afoF', NULL, NULL, NULL, NULL, NULL, 4),
(82344, NULL, 'G3DSA:1.10.472.10:FF:000639', NULL, NULL, 'Protein CBG15501', NULL, NULL, NULL, NULL, NULL, 4),
(82345, NULL, 'G3DSA:3.30.160.60:FF:006477', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82346, NULL, 'G3DSA:1.10.238.20:FF:000025', NULL, NULL, 'Odorant-binding protein 8a', NULL, NULL, NULL, NULL, NULL, 4),
(82347, NULL, 'G3DSA:1.20.58.60:FF:000522', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82348, NULL, 'G3DSA:3.30.70.330:FF:001203', NULL, NULL, 'Nucleolin', NULL, NULL, NULL, NULL, NULL, 4),
(82349, NULL, 'G3DSA:2.60.120.290:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82350, NULL, 'G3DSA:3.30.310.40:FF:000008', NULL, NULL, 'N-glycosylase/DNA lyase', NULL, NULL, NULL, NULL, NULL, 4),
(82351, NULL, 'G3DSA:3.40.190.10:FF:000650', NULL, NULL, 'Hydroxymethylbilane synthase', NULL, NULL, NULL, NULL, NULL, 4),
(82352, NULL, 'G3DSA:3.40.50.300:FF:003318', NULL, NULL, 'Nuclear GTP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(82353, NULL, 'G3DSA:3.10.50.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82354, NULL, 'G3DSA:3.30.420.40:FF:000674', NULL, NULL, 'Heat shock protein 70F', NULL, NULL, NULL, NULL, NULL, 4),
(82355, NULL, 'G3DSA:3.40.30.10:FF:000005', NULL, NULL, 'Glutaredoxin 5', NULL, NULL, NULL, NULL, NULL, 4),
(82356, NULL, 'G3DSA:1.20.1090.10:FF:000018', NULL, NULL, 'Pentafunctional AROM polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(82357, NULL, 'G3DSA:2.30.30.40:FF:000596', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(82358, NULL, 'G3DSA:2.130.10.10:FF:000957', NULL, NULL, 'Intraflagellar transport protein 172', NULL, NULL, NULL, NULL, NULL, 4),
(82359, NULL, 'G3DSA:3.40.250.10:FF:000020', NULL, NULL, 'Dual specificity protein phosphatase 8', NULL, NULL, NULL, NULL, NULL, 4),
(82360, NULL, 'G3DSA:1.20.1050.10:FF:000246', NULL, NULL, 'Glutathione S-transferase, theta 3', NULL, NULL, NULL, NULL, NULL, 4),
(82361, NULL, 'G3DSA:1.10.357.140:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82362, NULL, 'G3DSA:3.80.10.10:FF:000800', NULL, NULL, 'Receptor like protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(82363, NULL, 'G3DSA:3.40.50.300:FF:001632', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(82364, NULL, 'G3DSA:2.130.10.10:FF:001233', NULL, NULL, 'regulatory-associated protein of mTOR isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(82365, NULL, 'G3DSA:3.40.850.10:FF:000223', NULL, NULL, 'AT27178p', NULL, NULL, NULL, NULL, NULL, 4),
(82366, NULL, 'G3DSA:3.20.20.80:FF:000436', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(82367, NULL, 'G3DSA:3.30.190.20:FF:000008', NULL, NULL, '50S ribosomal protein L1', NULL, NULL, NULL, NULL, NULL, 4),
(82368, NULL, 'G3DSA:4.10.400.10:FF:000001', NULL, NULL, 'Low-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(82369, NULL, 'G3DSA:1.10.10.160:FF:000045', NULL, NULL, 'DNA helicase II', NULL, NULL, NULL, NULL, NULL, 4),
(82370, NULL, 'G3DSA:3.40.50.10490:FF:000022', NULL, NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', NULL, NULL, NULL, NULL, NULL, 4),
(82371, NULL, 'G3DSA:1.10.287.70:FF:000322', NULL, NULL, 'Possible transmembrane cation transporter', NULL, NULL, NULL, NULL, NULL, 4),
(82372, NULL, 'G3DSA:1.25.10.20:FF:000002', NULL, NULL, 'Vitellogenin 7', NULL, NULL, NULL, NULL, NULL, 4),
(82373, NULL, 'G3DSA:3.40.50.720:FF:000342', NULL, NULL, 'NAD dependent epimerase/dehydratase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(82374, NULL, 'G3DSA:1.25.40.10:FF:004778', NULL, NULL, 'Tetratricopeptide repeat protein 1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(82375, NULL, 'G3DSA:3.30.460.10:FF:000111', NULL, NULL, '2''-5''-oligoadenylate synthase 3-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(82376, NULL, 'G3DSA:3.40.50.300:FF:005561', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(82377, NULL, 'G3DSA:1.10.10.10:FF:000499', NULL, NULL, 'Heteromeric transposase endonuclease subunit TnsA', NULL, NULL, NULL, NULL, NULL, 4),
(82378, NULL, 'G3DSA:2.130.10.10:FF:005504', NULL, NULL, 'Transducin beta-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(82379, NULL, 'G3DSA:3.30.460.20:FF:000007', NULL, NULL, 'Magnesium transport protein CorA', NULL, NULL, NULL, NULL, NULL, 4),
(82380, NULL, 'G3DSA:2.120.10.30:FF:000582', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82381, NULL, 'G3DSA:2.130.10.10:FF:002863', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One component system)', NULL, NULL, NULL, NULL, NULL, 4),
(82382, NULL, 'G3DSA:3.40.1280.10:FF:000066', NULL, NULL, 'tRNA (cytidine/uridine-2''-O-)-methyltransferase TrmJ', NULL, NULL, NULL, NULL, NULL, 4),
(82383, NULL, 'G3DSA:2.40.50.40:FF:000063', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(82384, NULL, 'G3DSA:3.30.420.390:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82385, NULL, 'G3DSA:1.50.10.10:FF:000036', NULL, NULL, 'Glucanase', NULL, NULL, NULL, NULL, NULL, 4),
(82386, NULL, 'G3DSA:3.30.900.10:FF:000033', NULL, NULL, 'YALI0E10791p', NULL, NULL, NULL, NULL, NULL, 4),
(82387, NULL, 'G3DSA:3.40.50.10330:FF:000002', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(82388, NULL, 'G3DSA:3.30.70.330:FF:002507', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82389, NULL, 'G3DSA:3.30.160.60:FF:003604', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82390, NULL, 'G3DSA:3.30.230.10:FF:000291', NULL, NULL, 'DNA mismatch repair protein domain', NULL, NULL, NULL, NULL, NULL, 4),
(82391, NULL, 'G3DSA:1.20.920.20:FF:000053', NULL, NULL, 'Flagellar attachment zone protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(82392, NULL, 'G3DSA:3.40.50.150:FF:001328', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82393, NULL, 'G3DSA:1.50.10.20:FF:000039', NULL, NULL, 'Fructose-bisphosphate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(82394, NULL, 'G3DSA:2.60.40.420:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82395, NULL, 'G3DSA:2.60.40.10:FF:003155', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(82396, NULL, 'G3DSA:3.30.200.20:FF:000792', NULL, NULL, 'Glycogen synthase kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(82397, NULL, 'G3DSA:3.30.710.10:FF:000440', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82398, NULL, 'G3DSA:1.20.920.10:FF:000050', NULL, NULL, 'Transcription factor GTE4', NULL, NULL, NULL, NULL, NULL, 4),
(82399, NULL, 'G3DSA:3.40.50.300:FF:001290', NULL, NULL, 'Zinc finger helicase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(82400, NULL, 'G3DSA:3.90.180.10:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82401, NULL, 'G3DSA:3.90.550.10:FF:000498', NULL, NULL, 'Glycosyltransferase 8 domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(82402, NULL, 'G3DSA:2.30.29.30:FF:000308', NULL, NULL, 'Rho-associated protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(82403, NULL, 'G3DSA:2.40.50.140:FF:000363', NULL, NULL, 'Ribonuclease R', NULL, NULL, NULL, NULL, NULL, 4),
(82404, NULL, 'G3DSA:1.20.1250.10:FF:000121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82405, NULL, 'G3DSA:2.60.120.330:FF:000023', NULL, NULL, 'Feruloyl CoA ortho-hydroxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(82406, NULL, 'G3DSA:3.80.10.10:FF:004055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82407, NULL, 'G3DSA:3.40.640.10:FF:000409', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82408, NULL, 'G3DSA:3.40.50.2300:FF:000444', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(82409, NULL, 'G3DSA:3.30.470.20:FF:000165', NULL, NULL, 'Ribosomal modification protein rimK-like family member A', NULL, NULL, NULL, NULL, NULL, 4),
(82410, NULL, 'G3DSA:1.20.1250.20:FF:000124', NULL, NULL, 'Solute carrier family 2, facilitated glucose transporter member 12', NULL, NULL, NULL, NULL, NULL, 4),
(82411, NULL, 'G3DSA:3.40.50.620:FF:000424', NULL, NULL, 'GD12953', NULL, NULL, NULL, NULL, NULL, 4),
(82412, NULL, 'G3DSA:1.10.8.10:FF:000071', NULL, NULL, 'E3 ubiquitin-protein ligase RNF31', NULL, NULL, NULL, NULL, NULL, 4),
(82413, NULL, 'G3DSA:3.40.50.1820:FF:000277', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(82414, NULL, 'G3DSA:2.130.10.10:FF:005162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82415, NULL, 'G3DSA:2.130.10.10:FF:002756', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82416, NULL, 'G3DSA:1.20.1740.10:FF:000080', NULL, NULL, 'Tyrosine-specific transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(82417, NULL, 'G3DSA:1.10.287.130:FF:000065', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(82418, NULL, 'G3DSA:3.30.559.10:FF:000211', NULL, NULL, 'Siderophore peptide synthetase fer3', NULL, NULL, NULL, NULL, NULL, 4),
(82419, NULL, 'G3DSA:2.60.120.200:FF:000350', NULL, NULL, 'protein kinase C-binding protein NELL2 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(82420, NULL, 'G3DSA:2.40.50.120:FF:000019', NULL, NULL, 'Procollagen C-endopeptidase enhancer 1', NULL, NULL, NULL, NULL, NULL, 4),
(82421, NULL, 'G3DSA:1.20.920.30:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82422, NULL, 'G3DSA:3.30.40.10:FF:000372', NULL, NULL, 'E3 ubiquitin-protein ligase NHLRC1', NULL, NULL, NULL, NULL, NULL, 4),
(82423, NULL, 'G3DSA:3.30.70.330:FF:000933', NULL, NULL, 'polyadenylate-binding protein 1-like isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(82424, NULL, 'G3DSA:3.90.640.10:FF:000139', NULL, NULL, 'Chaperone protein dnaK', NULL, NULL, NULL, NULL, NULL, 4),
(82425, NULL, 'G3DSA:3.80.10.10:FF:000339', NULL, NULL, 'F-box/LRR-repeat protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(82426, NULL, 'G3DSA:1.20.1160.11:FF:000014', NULL, NULL, 'Os02g0635950 protein', NULL, NULL, NULL, NULL, NULL, 4),
(82427, NULL, 'G3DSA:2.170.130.10:FF:000046', NULL, NULL, 'Colicin I receptor', NULL, NULL, NULL, NULL, NULL, 4),
(82428, NULL, 'G3DSA:3.60.40.10:FF:000342', NULL, NULL, 'Integrin-linked kinase-associated serine/threonine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(82429, NULL, 'G3DSA:1.20.120.1080:FF:000012', NULL, NULL, 'putative ATP-dependent RNA helicase TDRD9', NULL, NULL, NULL, NULL, NULL, 4),
(82430, NULL, 'G3DSA:1.20.1260.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82431, NULL, 'G3DSA:2.60.120.260:FF:000452', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82432, NULL, 'G3DSA:3.30.70.330:FF:000591', NULL, NULL, 'RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(82433, NULL, 'G3DSA:1.25.10.30:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82434, NULL, 'G3DSA:4.10.400.20:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82435, NULL, 'G3DSA:1.10.150.20:FF:000086', NULL, NULL, 'Translocation protein SEC63', NULL, NULL, NULL, NULL, NULL, 4),
(82436, NULL, 'G3DSA:1.10.3460.10:FF:000027', NULL, NULL, 'Fucoxanthin chlorophyll a/c protein-LI818 clade', NULL, NULL, NULL, NULL, NULL, 4),
(82437, NULL, 'G3DSA:3.40.50.300:FF:007360', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(82438, NULL, 'G3DSA:2.60.410.10:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82439, NULL, 'G3DSA:3.30.40.10:FF:000720', NULL, NULL, 'PHD finger transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(82440, NULL, 'G3DSA:2.60.120.1560:FF:000010', NULL, NULL, 'PKHD1, fibrocystin/polyductin', NULL, NULL, NULL, NULL, NULL, 4),
(82441, NULL, 'G3DSA:2.40.270.10:FF:000002', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(82442, NULL, 'G3DSA:3.30.760.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82443, NULL, 'G3DSA:3.10.450.50:FF:000037', NULL, NULL, 'Calcium/calmodulin-dependent protein kinase type II', NULL, NULL, NULL, NULL, NULL, 4),
(82444, NULL, 'G3DSA:3.30.160.60:FF:005403', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82445, NULL, 'G3DSA:2.30.42.10:FF:000272', NULL, NULL, 'Partitioning defective protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(82446, NULL, 'G3DSA:2.30.42.10:FF:000608', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82447, NULL, 'G3DSA:3.30.420.40:FF:000567', NULL, NULL, 'Actin', NULL, NULL, NULL, NULL, NULL, 4),
(82448, NULL, 'G3DSA:3.30.40.10:FF:000265', NULL, NULL, 'E3 ubiquitin-protein ligase RING1', NULL, NULL, NULL, NULL, NULL, 4),
(82449, NULL, 'G3DSA:4.10.60.10:FF:000259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82450, NULL, 'G3DSA:1.20.120.220:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82451, NULL, 'G3DSA:3.40.50.300:FF:006865', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(82452, NULL, 'G3DSA:3.80.10.10:FF:002256', NULL, NULL, 'Leucine rich repeatcontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(82453, NULL, 'G3DSA:1.10.510.10:FF:003264', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82454, NULL, 'G3DSA:2.170.300.10:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82455, NULL, 'G3DSA:3.20.20.70:FF:000107', NULL, NULL, 'Tryptophan synthase alpha chain, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(82456, NULL, 'G3DSA:3.80.10.10:FF:004162', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(82457, NULL, 'G3DSA:3.30.420.40:FF:000909', NULL, NULL, 'Actin like 6B', NULL, NULL, NULL, NULL, NULL, 4),
(82458, NULL, 'G3DSA:1.25.40.10:FF:000962', NULL, NULL, 'CS_domain/TPR_repeat/Tetratricopeptide_repeat', NULL, NULL, NULL, NULL, NULL, 4),
(82459, NULL, 'G3DSA:3.30.160.60:FF:004908', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82460, NULL, 'G3DSA:1.10.640.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82461, NULL, 'G3DSA:1.10.510.10:FF:003606', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82462, NULL, 'G3DSA:2.60.40.10:FF:001362', NULL, NULL, 'Sidekick, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(82463, NULL, 'G3DSA:3.90.1140.10:FF:000056', NULL, NULL, 'Uncharacterized protein C15D4.13c', NULL, NULL, NULL, NULL, NULL, 4),
(82464, NULL, 'G3DSA:3.40.50.300:FF:007141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82465, NULL, 'G3DSA:1.10.238.10:FF:001096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82466, NULL, 'G3DSA:3.40.630.30:FF:000105', NULL, NULL, 'Glucosamine 6-phosphate N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(82467, NULL, 'G3DSA:1.10.510.10:FF:002775', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82468, NULL, 'G3DSA:2.20.110.10:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82469, NULL, 'G3DSA:4.10.240.10:FF:000117', NULL, NULL, 'C2H2 transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(82470, NULL, 'G3DSA:3.30.342.10:FF:000011', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(82471, NULL, 'G3DSA:3.90.226.10:FF:000346', NULL, NULL, 'Enoyl CoA hydratase domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(82472, NULL, 'G3DSA:2.20.100.10:FF:000220', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(82473, NULL, 'G3DSA:3.30.70.330:FF:003002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82474, NULL, 'G3DSA:1.10.510.10:FF:002994', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82475, NULL, 'G3DSA:1.10.287.470:FF:000043', NULL, NULL, 'RND family efflux transporter, MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(82476, NULL, 'G3DSA:3.40.720.10:FF:000106', NULL, NULL, 'Arylsulfatase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(82477, NULL, 'G3DSA:3.80.10.10:FF:004510', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82478, NULL, 'G3DSA:1.20.1250.20:FF:000450', NULL, NULL, 'MFS transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(82479, NULL, 'G3DSA:2.30.29.30:FF:000527', NULL, NULL, 'Signal transducing adaptor family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(82480, NULL, 'G3DSA:2.130.10.110:FF:000009', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(82481, NULL, 'G3DSA:2.60.40.10:FF:001581', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(82482, NULL, 'G3DSA:3.40.710.10:FF:000151', NULL, NULL, 'Peptidoglycan D,D-transpeptidase FtsI', NULL, NULL, NULL, NULL, NULL, 4),
(82483, NULL, 'G3DSA:1.25.10.10:FF:002938', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82484, NULL, 'G3DSA:1.10.1040.10:FF:000017', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(82485, NULL, 'G3DSA:1.10.510.10:FF:003051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82486, NULL, 'G3DSA:2.40.50.90:FF:000049', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(82487, NULL, 'G3DSA:2.30.42.10:FF:000485', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82488, NULL, 'G3DSA:3.30.1520.10:FF:000054', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(82489, NULL, 'G3DSA:1.20.1270.10:FF:000004', NULL, NULL, 'Molecular chaperone DnaK', NULL, NULL, NULL, NULL, NULL, 4),
(82490, NULL, 'G3DSA:3.30.70.330:FF:002726', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82491, NULL, 'G3DSA:1.25.40.20:FF:000965', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(82492, NULL, 'G3DSA:1.10.1220.10:FF:000003', NULL, NULL, 'Arc family DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(82493, NULL, 'G3DSA:3.80.10.10:FF:003886', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82494, NULL, 'G3DSA:3.30.160.60:FF:003149', NULL, NULL, 'ZNF649 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(82495, NULL, 'G3DSA:2.60.120.340:FF:000026', NULL, NULL, 'Nucleophosmin/nucleoplasmin, 2a', NULL, NULL, NULL, NULL, NULL, 4),
(82496, NULL, 'G3DSA:2.10.110.10:FF:000335', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82497, NULL, 'G3DSA:1.20.1270.20:FF:000007', NULL, NULL, 'Hybrid-cluster protein', NULL, NULL, NULL, NULL, NULL, 4),
(82498, NULL, 'G3DSA:3.40.50.620:FF:000082', NULL, NULL, 'MSW1p Mitochondrial tryptophanyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(82499, NULL, 'G3DSA:2.60.40.10:FF:005291', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82500, NULL, 'G3DSA:2.130.10.10:FF:003026', NULL, NULL, 'Chromatin assembly complex 1 subunit B/CAC2', NULL, NULL, NULL, NULL, NULL, 4),
(82501, NULL, 'G3DSA:3.40.50.300:FF:003425', NULL, NULL, 'Selenocysteine-specific elongation factor selB', NULL, NULL, NULL, NULL, NULL, 4),
(82502, NULL, 'G3DSA:2.60.120.920:FF:000110', NULL, NULL, 'SPRY domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(82503, NULL, 'G3DSA:2.40.50.140:FF:000918', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82504, NULL, 'G3DSA:3.30.230.10:FF:000408', NULL, NULL, 'RT5, ribosomal protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(82505, NULL, 'G3DSA:3.40.50.1980:FF:000078', NULL, NULL, 'Fe(3+) dicitrate-binding periplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(82506, NULL, 'G3DSA:1.10.600.10:FF:000062', NULL, NULL, 'Phytoene synthase', NULL, NULL, NULL, NULL, NULL, 4),
(82507, NULL, 'G3DSA:3.60.15.10:FF:000048', NULL, NULL, 'Zn-dependent hydrolase/oxidoreductase family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(82508, NULL, 'G3DSA:1.20.1070.10:FF:000348', NULL, NULL, 'G protein-coupled receptor 150', NULL, NULL, NULL, NULL, NULL, 4),
(82509, NULL, 'G3DSA:4.10.1000.10:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82510, NULL, 'G3DSA:2.60.120.650:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(82511, NULL, 'G3DSA:2.60.40.420:FF:000081', NULL, NULL, 'Spore coat protein A', NULL, NULL, NULL, NULL, NULL, 4),
(82512, NULL, 'G3DSA:1.25.40.20:FF:001460', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82513, NULL, 'G3DSA:2.60.120.260:FF:000671', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82514, NULL, 'G3DSA:3.30.420.40:FF:001056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82515, NULL, 'G3DSA:1.20.58.1420:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82516, NULL, 'G3DSA:3.80.10.10:FF:004381', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82517, NULL, 'G3DSA:1.20.58.60:FF:000067', NULL, NULL, 'Short stop, isoform K', NULL, NULL, NULL, NULL, NULL, 4),
(82518, NULL, 'G3DSA:3.40.390.10:FF:000176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82519, NULL, 'G3DSA:3.10.10.10:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82520, NULL, 'G3DSA:1.25.10.10:FF:002719', NULL, NULL, 'Cullin-associated NEDD8-dissociated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(82521, NULL, 'G3DSA:2.40.128.20:FF:000006', NULL, NULL, 'Fatty acid-binding protein, liver', NULL, NULL, NULL, NULL, NULL, 4),
(82522, NULL, 'G3DSA:1.25.10.10:FF:003208', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(82523, NULL, 'G3DSA:3.40.1410.10:FF:000004', NULL, NULL, 'Histidine utilization repressor', NULL, NULL, NULL, NULL, NULL, 4),
(82524, NULL, 'G3DSA:1.10.3370.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82525, NULL, 'G3DSA:1.25.10.10:FF:002377', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82526, NULL, 'G3DSA:1.20.58.60:FF:000415', NULL, NULL, 'Microtubule-actin crosslinking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(82527, NULL, 'G3DSA:3.60.110.10:FF:000090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82528, NULL, 'G3DSA:3.30.160.60:FF:002992', NULL, NULL, 'transcription factor grauzone', NULL, NULL, NULL, NULL, NULL, 4),
(82529, NULL, 'G3DSA:3.40.50.300:FF:002936', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(82530, NULL, 'G3DSA:1.10.10.10:FF:001123', NULL, NULL, 'CRE-CUL-5 protein', NULL, NULL, NULL, NULL, NULL, 4),
(82531, NULL, 'G3DSA:3.60.10.10:FF:000166', NULL, NULL, 'DNAse I family protein DHP2', NULL, NULL, NULL, NULL, NULL, 4),
(82532, NULL, 'G3DSA:2.60.40.10:FF:002992', NULL, NULL, 'Chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(82533, NULL, 'G3DSA:3.30.40.10:FF:000046', NULL, NULL, 'RUN and FYVE domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(82534, NULL, 'G3DSA:2.60.220.50:FF:000063', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1b', NULL, NULL, NULL, NULL, NULL, 4),
(82535, NULL, 'G3DSA:1.10.150.220:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82536, NULL, 'G3DSA:2.10.25.10:FF:000132', NULL, NULL, 'Teneurin transmembrane protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(82537, NULL, 'G3DSA:3.40.1490.10:FF:000003', NULL, NULL, 'Peptidyl-tRNA hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(82538, NULL, 'G3DSA:3.30.1440.10:FF:000002', NULL, NULL, '60S ribosomal protein L11', NULL, NULL, NULL, NULL, NULL, 4),
(82539, NULL, 'G3DSA:3.40.718.10:FF:000056', NULL, NULL, 'Isocitrate dehydrogenase [NAD] subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(82540, NULL, 'G3DSA:3.40.50.1010:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82541, NULL, 'G3DSA:1.10.8.60:FF:000400', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(82542, NULL, 'G3DSA:2.60.120.290:FF:000101', NULL, NULL, 'Complement component 1, s subcomponent', NULL, NULL, NULL, NULL, NULL, 4),
(82543, NULL, 'G3DSA:1.25.40.10:FF:000636', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(82544, NULL, 'G3DSA:2.60.40.150:FF:000769', NULL, NULL, 'Inositol polyphosphate-4-phosphatase type II B', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(82545, NULL, 'G3DSA:3.10.100.10:FF:000398', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82546, NULL, 'G3DSA:2.60.40.150:FF:000775', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82547, NULL, 'G3DSA:2.130.10.10:FF:000845', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(82548, NULL, 'G3DSA:3.60.10.10:FF:000402', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(82549, NULL, 'G3DSA:2.60.40.10:FF:005066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82550, NULL, 'G3DSA:2.30.130.40:FF:000009', NULL, NULL, 'ATP-dependent protease La domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(82551, NULL, 'G3DSA:1.20.1560.10:FF:000094', NULL, NULL, 'ABC transporter B family member 28', NULL, NULL, NULL, NULL, NULL, 4),
(82552, NULL, 'G3DSA:3.40.50.2000:FF:000680', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(82553, NULL, 'G3DSA:3.30.40.10:FF:000591', NULL, NULL, 'RING-H2 finger protein ATL65', NULL, NULL, NULL, NULL, NULL, 4),
(82554, NULL, 'G3DSA:3.40.850.10:FF:000329', NULL, NULL, 'Kinesin family member heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(82555, NULL, 'G3DSA:2.40.50.140:FF:000469', NULL, NULL, 'Protein lin-28', NULL, NULL, NULL, NULL, NULL, 4),
(82556, NULL, 'G3DSA:2.30.130.30:FF:000006', NULL, NULL, 'Putative_zinc_finger_motif_-_C2HC5-type /ASCH_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(82557, NULL, 'G3DSA:3.30.160.60:FF:003481', NULL, NULL, 'Serendipity beta', NULL, NULL, NULL, NULL, NULL, 4),
(82558, NULL, 'G3DSA:1.20.120.1770:FF:000005', NULL, NULL, 'Probable transmembrane ascorbate ferrireductase 3', NULL, NULL, NULL, NULL, NULL, 4),
(82559, NULL, 'G3DSA:1.10.3660.10:FF:000008', NULL, NULL, 'Prephenate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(82560, NULL, 'G3DSA:1.20.1050.10:FF:000134', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(82561, NULL, 'G3DSA:1.20.120.1780:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82562, NULL, 'G3DSA:2.10.60.10:FF:000033', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(82563, NULL, 'G3DSA:3.90.70.80:FF:000015', NULL, NULL, 'Putative bifunctional UDP-N-acetylglucosamine transferase and deubiquitinase ALG13', NULL, NULL, NULL, NULL, NULL, 4),
(82564, NULL, 'G3DSA:1.10.1520.10:FF:000043', NULL, NULL, 'Dicer-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(82565, NULL, 'G3DSA:1.10.287.70:FF:000434', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(82566, NULL, 'G3DSA:3.10.10.10:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82567, NULL, 'G3DSA:3.30.1390.40:FF:000001', NULL, NULL, 'Glucosidase YgjK', NULL, NULL, NULL, NULL, NULL, 4),
(82568, NULL, 'G3DSA:1.10.510.10:FF:001920', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(82569, NULL, 'G3DSA:3.90.15.10:FF:000013', NULL, NULL, 'DNA topoisomerase I, gene 2', NULL, NULL, NULL, NULL, NULL, 4),
(82570, NULL, 'G3DSA:2.40.50.180:FF:000015', NULL, NULL, 'Chemotaxis protein CheW', NULL, NULL, NULL, NULL, NULL, 4),
(82571, NULL, 'G3DSA:3.30.260.10:FF:000017', NULL, NULL, 'T-complex protein 1 subunit zeta', NULL, NULL, NULL, NULL, NULL, 4),
(82572, NULL, 'G3DSA:2.120.10.10:FF:000019', NULL, NULL, 'Sialidase (Neuraminidase)', NULL, NULL, NULL, NULL, NULL, 4),
(82573, NULL, 'G3DSA:3.20.20.80:FF:000330', NULL, NULL, 'Alpha-amylase MalA', NULL, NULL, NULL, NULL, NULL, 4),
(82574, NULL, 'G3DSA:2.40.340.10:FF:000008', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(82575, NULL, 'G3DSA:3.20.20.100:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82576, NULL, 'G3DSA:2.60.40.3980:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82577, NULL, 'G3DSA:1.10.1080.10:FF:000020', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(82578, NULL, 'G3DSA:3.30.1010.10:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(82579, NULL, 'G3DSA:3.90.640.10:FF:000033', NULL, NULL, 'Heat shock 70 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(82580, NULL, 'G3DSA:3.40.50.970:FF:000057', NULL, NULL, '2-oxoisovalerate dehydrogenase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(82581, NULL, 'G3DSA:2.60.120.590:FF:000073', NULL, NULL, 'Predicted gene, 27027', NULL, NULL, NULL, NULL, NULL, 4),
(82582, NULL, 'G3DSA:3.30.300.210:FF:000001', NULL, NULL, 'Ger(X)C family spore germination protein', NULL, NULL, NULL, NULL, NULL, 4),
(82583, NULL, 'G3DSA:2.130.10.10:FF:002975', NULL, NULL, 'Component of the chromatin assembly complex (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(82584, NULL, 'G3DSA:3.60.15.10:FF:000267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82585, NULL, 'G3DSA:3.20.20.100:FF:000216', NULL, NULL, 'Aldo-keto-reductase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(82586, NULL, 'G3DSA:3.40.50.1820:FF:001587', NULL, NULL, 'Si:ch211-93f2.1', NULL, NULL, NULL, NULL, NULL, 4),
(82587, NULL, 'G3DSA:1.10.150.20:FF:000316', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(82588, NULL, 'G3DSA:1.20.1250.20:FF:000343', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(82589, NULL, 'G3DSA:3.80.10.10:FF:002363', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82590, NULL, 'G3DSA:3.30.420.40:FF:001062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82591, NULL, 'G3DSA:2.60.40.10:FF:001811', NULL, NULL, 'Obscurin like 1', NULL, NULL, NULL, NULL, NULL, 4),
(82592, NULL, 'G3DSA:2.30.42.10:FF:000491', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82593, NULL, 'G3DSA:3.40.50.1820:FF:000171', NULL, NULL, 'Neuroligin-4, Y-linked', NULL, NULL, NULL, NULL, NULL, 4),
(82594, NULL, 'G3DSA:2.30.29.30:FF:000179', NULL, NULL, 'Nuclear pore complex protein Nup50', NULL, NULL, NULL, NULL, NULL, 4),
(82595, NULL, 'G3DSA:3.30.200.40:FF:000005', NULL, NULL, 'Scavenger mRNA decapping enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(82596, NULL, 'G3DSA:2.40.50.140:FF:001200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82597, NULL, 'G3DSA:2.40.50.140:FF:000582', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(82598, NULL, 'G3DSA:3.30.70.330:FF:001080', NULL, NULL, 'non-POU domain-containing octamer-binding protein isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(82599, NULL, 'G3DSA:1.10.246.90:FF:000008', NULL, NULL, 'Trans-splicing factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(82600, NULL, 'G3DSA:3.40.50.300:FF:004499', NULL, NULL, 'Molybdate transport system ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(82601, NULL, 'G3DSA:3.80.10.10:FF:000233', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase TDR', NULL, NULL, NULL, NULL, NULL, 4),
(82602, NULL, 'G3DSA:2.60.120.200:FF:000125', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(82603, NULL, 'G3DSA:3.40.50.300:FF:003195', NULL, NULL, 'MutS homolog 3 (E. coli)', NULL, NULL, NULL, NULL, NULL, 4),
(82604, NULL, 'G3DSA:1.10.510.10:FF:003045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82605, NULL, 'G3DSA:1.10.101.10:FF:000003', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase AmiD', NULL, NULL, NULL, NULL, NULL, 4),
(82606, NULL, 'G3DSA:1.10.10.60:FF:000834', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82607, NULL, 'G3DSA:2.60.120.260:FF:000558', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(82608, NULL, 'G3DSA:3.30.40.10:FF:001102', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(82609, NULL, 'G3DSA:1.10.260.100:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82610, NULL, 'G3DSA:1.25.40.20:FF:001572', NULL, NULL, 'S-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(82611, NULL, 'G3DSA:2.130.10.10:FF:003700', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82612, NULL, 'G3DSA:1.10.532.10:FF:000009', NULL, NULL, 'Signal transducer and activator of transcription 5A', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(82613, NULL, 'G3DSA:3.40.50.1220:FF:000086', NULL, NULL, 'Sulfoacetaldehyde acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(82614, NULL, 'G3DSA:2.60.450.10:FF:000012', NULL, NULL, 'Lipopolysaccharide export system protein LptC', NULL, NULL, NULL, NULL, NULL, 4),
(82615, NULL, 'G3DSA:3.60.40.10:FF:000011', NULL, NULL, 'probable protein phosphatase 2C 59', NULL, NULL, NULL, NULL, NULL, 4),
(82616, NULL, 'G3DSA:2.60.120.260:FF:000665', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82617, NULL, 'G3DSA:2.40.290.20:FF:000001', NULL, NULL, 'Chromo domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(82618, NULL, 'G3DSA:1.25.40.10:FF:004907', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82619, NULL, 'G3DSA:3.30.70.270:FF:000106', NULL, NULL, 'GGDEF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(82620, NULL, 'G3DSA:2.40.50.90:FF:000050', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(82621, NULL, 'G3DSA:1.10.565.10:FF:000203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82622, NULL, 'G3DSA:3.30.1370.50:FF:000003', NULL, NULL, 'Transcriptional repressor NF-X1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(82623, NULL, 'G3DSA:2.60.450.20:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82624, NULL, 'G3DSA:2.30.30.380:FF:000011', NULL, NULL, 'Zinc finger RANBP2-type containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(82625, NULL, 'G3DSA:2.60.40.790:FF:000169', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82626, NULL, 'G3DSA:3.30.200.20:FF:000921', NULL, NULL, 'Os02g0156000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(82627, NULL, 'G3DSA:2.30.42.10:FF:000502', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82628, NULL, 'G3DSA:3.30.70.260:FF:000103', NULL, NULL, 'Methionine import ATP-binding protein MetN', NULL, NULL, NULL, NULL, NULL, 4),
(82629, NULL, 'G3DSA:2.60.200.20:FF:000188', NULL, NULL, 'FHA domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(82630, NULL, 'G3DSA:1.20.1230.10:FF:000007', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(82631, NULL, 'G3DSA:3.40.50.1820:FF:000064', NULL, NULL, 'Sn1-specific diacylglycerol lipase beta', NULL, NULL, NULL, NULL, NULL, 4),
(82632, NULL, 'G3DSA:2.40.290.30:FF:000004', NULL, NULL, 'PTOV1 isoform 17', NULL, NULL, NULL, NULL, NULL, 4),
(82633, NULL, 'G3DSA:3.40.50.2300:FF:000337', NULL, NULL, 'Metabotropic glutamate receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(82634, NULL, 'G3DSA:3.80.10.10:FF:004504', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(82635, NULL, 'G3DSA:3.40.50.300:FF:001065', NULL, NULL, 'DNA repair protein RAD50 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(82636, NULL, 'G3DSA:1.25.40.10:FF:002873', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(82637, NULL, 'G3DSA:3.40.50.300:FF:003206', NULL, NULL, 'Iron-sulfur cluster carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(82638, NULL, 'G3DSA:3.40.50.10140:FF:000046', NULL, NULL, 'Putative phosphoinositide 3-kinase adapter protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(82639, NULL, 'G3DSA:3.40.50.2000:FF:000348', NULL, NULL, 'UDP-glycosyltransferase 83A1', NULL, NULL, NULL, NULL, NULL, 4),
(82640, NULL, 'G3DSA:3.30.70.330:FF:002277', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82641, NULL, 'G3DSA:1.20.1070.10:FF:000129', NULL, NULL, 'Prostaglandin F2-alpha receptor', NULL, NULL, NULL, NULL, NULL, 4),
(82642, NULL, 'G3DSA:2.20.70.10:FF:000247', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-36 specific', NULL, NULL, NULL, NULL, NULL, 4),
(82643, NULL, 'G3DSA:2.30.29.230:FF:000009', NULL, NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', NULL, NULL, NULL, NULL, NULL, 4),
(82644, NULL, 'G3DSA:3.10.450.40:FF:000040', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(82645, NULL, 'G3DSA:3.40.50.620:FF:000317', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(82646, NULL, 'G3DSA:3.30.160.60:FF:003155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82647, NULL, 'G3DSA:1.20.1070.10:FF:001990', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82648, NULL, 'G3DSA:3.80.10.10:FF:004274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82649, NULL, 'G3DSA:2.30.29.220:FF:000006', NULL, NULL, 'FACT complex subunit SSRP1', NULL, NULL, NULL, NULL, NULL, 4),
(82650, NULL, 'G3DSA:1.25.10.10:FF:001409', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82651, NULL, 'G3DSA:2.60.120.200:FF:000018', NULL, NULL, 'Calreticulin 1b', NULL, NULL, NULL, NULL, NULL, 4),
(82652, NULL, 'G3DSA:2.10.110.10:FF:000329', NULL, NULL, 'LIM protein', NULL, NULL, NULL, NULL, NULL, 4),
(82653, NULL, 'G3DSA:2.60.40.10:FF:003722', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82654, NULL, 'G3DSA:3.30.70.1430:FF:000005', NULL, NULL, 'Multidrug resistance protein MdtB', NULL, NULL, NULL, NULL, NULL, 4),
(82655, NULL, 'G3DSA:3.30.230.70:FF:000168', NULL, NULL, 'Exosome component 6', NULL, NULL, NULL, NULL, NULL, 4),
(82656, NULL, 'G3DSA:1.25.40.20:FF:001353', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82657, NULL, 'G3DSA:3.30.200.20:FF:000808', NULL, NULL, 'Protein Kinase N (PKN) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(82658, NULL, 'G3DSA:3.10.129.110:FF:000007', NULL, NULL, 'Phthiocerol synthesis polyketide synthase type I PpsC', NULL, NULL, NULL, NULL, NULL, 4),
(82659, NULL, 'G3DSA:4.10.530.10:FF:000005', NULL, NULL, 'Fibrinogen-like protein 1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(82660, NULL, 'G3DSA:1.20.1270.60:FF:000103', NULL, NULL, 'Hof1p', NULL, NULL, NULL, NULL, NULL, 4),
(82661, NULL, 'G3DSA:3.40.50.300:FF:005336', NULL, NULL, 'Heparan-sulfate 6-O-sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(82662, NULL, 'G3DSA:2.120.10.30:FF:000357', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(82663, NULL, 'G3DSA:2.30.42.10:FF:000378', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82664, NULL, 'G3DSA:3.40.50.150:FF:001093', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82665, NULL, 'G3DSA:3.30.160.60:FF:002767', NULL, NULL, 'Zinc finger protein 955A', NULL, NULL, NULL, NULL, NULL, 4),
(82666, NULL, 'G3DSA:1.10.20.140:FF:000002', NULL, NULL, 'tRNA dimethylallyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(82667, NULL, 'G3DSA:3.30.342.10:FF:000005', NULL, NULL, 'DNA polymerase epsilon catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(82668, NULL, 'G3DSA:1.20.1250.10:FF:000008', NULL, NULL, 'Leptin', NULL, NULL, NULL, NULL, NULL, 4),
(82669, NULL, 'G3DSA:3.40.50.2030:FF:000003', NULL, NULL, 'Carbon monoxide dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(82670, NULL, 'G3DSA:3.40.50.720:FF:002034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82671, NULL, 'G3DSA:3.40.50.11000:FF:000001', NULL, NULL, 'Fe-S cluster assembly protein DRE2', NULL, NULL, NULL, NULL, NULL, 4),
(82672, NULL, 'G3DSA:3.30.70.1440:FF:000008', NULL, NULL, 'RND multidrug efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(82673, NULL, 'G3DSA:3.30.70.270:FF:000325', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82674, NULL, 'G3DSA:1.20.120.1240:FF:000077', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(82675, NULL, 'G3DSA:2.60.120.650:FF:000018', NULL, NULL, 'HSPB1-associated protein 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(82676, NULL, 'G3DSA:3.40.630.10:FF:000347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82677, NULL, 'G3DSA:1.25.10.10:FF:000808', NULL, NULL, 'Adaptor related protein complex 3 subunit delta 1', NULL, NULL, NULL, NULL, NULL, 4),
(82678, NULL, 'G3DSA:1.20.58.60:FF:000180', NULL, NULL, 'Spectrin repeat containing nuclear envelope protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(82679, NULL, 'G3DSA:1.20.58.60:FF:000292', NULL, NULL, 'Microtubule-actin cross-linking factor 1, isoforms 1/2/3/5', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(82680, NULL, 'G3DSA:3.40.367.20:FF:000041', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(82681, NULL, 'G3DSA:1.25.10.10:FF:003102', NULL, NULL, 'Integrator complex subunit 4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(82682, NULL, 'G3DSA:3.40.50.300:FF:007247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82683, NULL, 'G3DSA:1.25.40.10:FF:003710', NULL, NULL, 'Os09g0411600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(82684, NULL, 'G3DSA:1.20.1280.290:FF:000007', NULL, NULL, 'Bidirectional sugar transporter SWEET7', NULL, NULL, NULL, NULL, NULL, 4),
(82685, NULL, 'G3DSA:1.20.1250.20:FF:000562', NULL, NULL, 'Minor myo-inositol transporter iolF', NULL, NULL, NULL, NULL, NULL, 4),
(82686, NULL, 'G3DSA:1.20.1070.10:FF:000461', NULL, NULL, 'D(5)-like dopamine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(82687, NULL, 'G3DSA:3.80.10.10:FF:003667', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82688, NULL, 'G3DSA:1.25.10.10:FF:003091', NULL, NULL, 'Exportin-T', NULL, NULL, NULL, NULL, NULL, 4),
(82689, NULL, 'G3DSA:1.20.1260.10:FF:000054', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(82690, NULL, 'G3DSA:1.10.1280.10:FF:000001', NULL, NULL, '5,6-dihydroxyindole-2-carboxylic acid oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(82691, NULL, 'G3DSA:3.40.850.10:FF:000436', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(82692, NULL, 'G3DSA:2.160.20.10:FF:000294', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82693, NULL, 'G3DSA:2.30.29.30:FF:000292', NULL, NULL, 'sesquipedalian-2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(82694, NULL, 'G3DSA:3.40.50.1220:FF:000103', NULL, NULL, 'ACR211Wp', NULL, NULL, NULL, NULL, NULL, 4),
(82695, NULL, 'G3DSA:1.10.10.60:FF:001216', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82696, NULL, 'G3DSA:2.60.120.10:FF:000240', NULL, NULL, 'Cyclic nucleotide-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(82697, NULL, 'G3DSA:3.30.70.330:FF:002390', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82698, NULL, 'G3DSA:1.20.1070.10:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82699, NULL, 'G3DSA:3.60.40.10:FF:000117', NULL, NULL, 'Protein phosphatase 2C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(82700, NULL, 'G3DSA:1.10.238.10:FF:001220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82701, NULL, 'G3DSA:1.25.40.10:FF:001350', NULL, NULL, 'Penicillin-binding protein activator LpoA', NULL, NULL, NULL, NULL, NULL, 4),
(82702, NULL, 'G3DSA:1.20.1740.10:FF:000203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82703, NULL, 'G3DSA:1.20.58.1120:FF:000016', NULL, NULL, 'Axonemal dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(82704, NULL, 'G3DSA:1.10.510.10:FF:003157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82705, NULL, 'G3DSA:1.10.472.10:FF:000297', NULL, NULL, 'Cyclin, N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(82706, NULL, 'G3DSA:3.40.50.1820:FF:000283', NULL, NULL, 'Alpha/beta fold hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(82707, NULL, 'G3DSA:3.20.20.80:FF:000217', NULL, NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(82708, NULL, 'G3DSA:3.30.470.20:FF:000053', NULL, NULL, 'Acetyl-/propionyl-coenzyme A carboxylase alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(82709, NULL, 'G3DSA:1.25.40.10:FF:000855', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(82710, NULL, 'G3DSA:1.20.1440.180:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82711, NULL, 'G3DSA:3.40.366.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82712, NULL, 'G3DSA:3.20.20.70:FF:000214', NULL, NULL, 'Deoxyribose-phosphate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(82713, NULL, 'G3DSA:3.40.50.12780:FF:000175', NULL, NULL, 'Long-chain-fatty-acid-coA ligase protein,putative', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(82714, NULL, 'G3DSA:3.30.470.10:FF:000050', NULL, NULL, 'Uncharacterized protein HI_1169', NULL, NULL, NULL, NULL, NULL, 4),
(82715, NULL, 'G3DSA:1.20.1440.170:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82716, NULL, 'G3DSA:1.10.287.70:FF:000215', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(82717, NULL, 'G3DSA:2.60.40.10:FF:003161', NULL, NULL, 'Titin, tandem duplicate 1', NULL, NULL, NULL, NULL, NULL, 4),
(82718, NULL, 'G3DSA:1.20.1280.270:FF:000001', NULL, NULL, 'Bifunctional arginine demethylase and lysyl-hydroxylase JMJD6', NULL, NULL, NULL, NULL, NULL, 4),
(82719, NULL, 'G3DSA:2.130.10.30:FF:000042', NULL, NULL, 'Guanidine nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(82720, NULL, 'G3DSA:3.30.1590.10:FF:000002', NULL, NULL, 'Malto-oligosyltrehalose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(82721, NULL, 'G3DSA:3.30.70.330:FF:000366', NULL, NULL, 'Lupus La protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(82722, NULL, 'G3DSA:3.30.70.330:FF:002058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82723, NULL, 'G3DSA:3.40.50.620:FF:000536', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(82724, NULL, 'G3DSA:3.80.10.10:FF:003779', NULL, NULL, 'Putative leucine-rich repeat-containing protein DDB_G0281931', NULL, NULL, NULL, NULL, NULL, 4),
(82725, NULL, 'G3DSA:3.60.60.10:FF:000006', NULL, NULL, 'N-acylethanolamine-hydrolyzing acid amidase', NULL, NULL, NULL, NULL, NULL, 4),
(82726, NULL, 'G3DSA:3.40.50.2000:FF:000567', NULL, NULL, 'UDP glucuronosyltransferase 2 family, polypeptide A4', NULL, NULL, NULL, NULL, NULL, 4),
(82727, NULL, 'G3DSA:3.30.160.60:FF:004791', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82728, NULL, 'G3DSA:3.30.460.10:FF:000004', NULL, NULL, 'Ribosomal silencing factor RsfS', NULL, NULL, NULL, NULL, NULL, 4),
(82729, NULL, 'G3DSA:1.10.10.10:FF:001230', NULL, NULL, 'Vacuolar protein sorting 36, putative', NULL, NULL, NULL, NULL, NULL, 4),
(82730, NULL, 'G3DSA:3.30.470.30:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82731, NULL, 'G3DSA:1.25.40.20:FF:000858', NULL, NULL, 'Nek-like kinase protein', NULL, NULL, NULL, NULL, NULL, 4),
(82732, NULL, 'G3DSA:3.30.110.60:FF:000004', NULL, NULL, 'RNA-binding CRS1 / YhbY (CRM) domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(82733, NULL, 'G3DSA:2.160.20.10:FF:000075', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(82734, NULL, 'G3DSA:3.30.40.10:FF:000484', NULL, NULL, 'Histone-lysine N-methyltransferase ATX4', NULL, NULL, NULL, NULL, NULL, 4),
(82735, NULL, 'G3DSA:2.170.130.10:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82736, NULL, 'G3DSA:1.20.1250.20:FF:002248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82737, NULL, 'G3DSA:3.40.50.300:FF:006972', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(82738, NULL, 'G3DSA:2.60.120.260:FF:000446', NULL, NULL, 'Nuclear receptor 2C2-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(82739, NULL, 'G3DSA:3.30.1460.20:FF:000001', NULL, NULL, 'Actin-related protein 2/3 complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(82740, NULL, 'G3DSA:3.40.390.10:FF:000069', NULL, NULL, 'Oligopeptidase A', NULL, NULL, NULL, NULL, NULL, 4),
(82741, NULL, 'G3DSA:3.40.30.10:FF:001192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82742, NULL, 'G3DSA:1.20.1070.10:FF:001658', NULL, NULL, 'Atypical chemokine receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(82743, NULL, 'G3DSA:2.30.42.10:FF:000159', NULL, NULL, 'amyloid beta A4 precursor protein-binding family A member 3', NULL, NULL, NULL, NULL, NULL, 4),
(82744, NULL, 'G3DSA:1.10.8.100:FF:000029', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(82745, NULL, 'G3DSA:3.30.710.10:FF:000327', NULL, NULL, 'Ci-BCL6-like C2H2 Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(82746, NULL, 'G3DSA:3.30.70.330:FF:000927', NULL, NULL, 'Putative RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(82747, NULL, 'G3DSA:1.20.5.170:FF:000211', NULL, NULL, 'Tropomyosin', NULL, NULL, NULL, NULL, NULL, 4),
(82748, NULL, 'G3DSA:1.10.10.2320:FF:000002', NULL, NULL, 'Phenylalanyl-tRNA synthetase alpha chain B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(82749, NULL, 'G3DSA:3.40.50.720:FF:002253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82750, NULL, 'G3DSA:3.30.420.10:FF:000114', NULL, NULL, 'Werner Syndrome-like exonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(82751, NULL, 'G3DSA:3.10.129.10:FF:000155', NULL, NULL, 'CurJ', NULL, NULL, NULL, NULL, NULL, 4),
(82752, NULL, 'G3DSA:3.10.100.10:FF:000409', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82753, NULL, 'G3DSA:3.90.660.10:FF:000034', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(82754, NULL, 'G3DSA:3.30.70.3220:FF:000003', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(82755, NULL, 'G3DSA:3.30.190.20:FF:000014', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(82756, NULL, 'G3DSA:1.10.10.1210:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82757, NULL, 'G3DSA:1.20.120.520:FF:000006', NULL, NULL, 'Zinc finger protein BRUTUS', NULL, NULL, NULL, NULL, NULL, 4),
(82758, NULL, 'G3DSA:3.40.50.800:FF:000034', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(82759, NULL, 'G3DSA:1.10.10.60:FF:000598', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(82760, NULL, 'G3DSA:3.30.1460.30:FF:000004', NULL, NULL, 'DNA transformation protein TfoX1', NULL, NULL, NULL, NULL, NULL, 4),
(82761, NULL, 'G3DSA:2.40.50.140:FF:000812', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82762, NULL, 'G3DSA:2.30.29.210:FF:000003', NULL, NULL, 'Metallopeptidase family M24 containing protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(82763, NULL, 'G3DSA:1.20.1310.10:FF:000177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82764, NULL, 'G3DSA:3.30.160.60:FF:003374', NULL, NULL, 'GD10244', NULL, NULL, NULL, NULL, NULL, 4),
(82765, NULL, 'G3DSA:1.10.10.2330:FF:000005', NULL, NULL, 'phenylalanine--tRNA ligase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(82766, NULL, 'G3DSA:3.60.15.10:FF:000155', NULL, NULL, 'Metallo-hydrolase/oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(82767, NULL, 'G3DSA:3.40.50.2300:FF:000775', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82768, NULL, 'G3DSA:3.40.710.10:FF:000044', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(82769, NULL, 'G3DSA:2.20.100.10:FF:000219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82770, NULL, 'G3DSA:3.60.20.10:FF:000009', NULL, NULL, 'Proteasome subunit alpha type-3', NULL, NULL, NULL, NULL, NULL, 4),
(82771, NULL, 'G3DSA:2.40.250.10:FF:000001', NULL, NULL, 'Core-binding factor subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(82772, NULL, 'G3DSA:3.30.559.10:FF:000194', NULL, NULL, 'Putative diacylglycerol O-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(82773, NULL, 'G3DSA:3.30.160.60:FF:001463', NULL, NULL, 'zinc finger protein 524', NULL, NULL, NULL, NULL, NULL, 4),
(82774, NULL, 'G3DSA:3.40.850.10:FF:000217', NULL, NULL, 'Kinesin eg-5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(82775, NULL, 'G3DSA:3.20.140.10:FF:000016', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(82776, NULL, 'G3DSA:3.40.50.300:FF:001284', NULL, NULL, 'P-loop NTPase domain-containing protein LPA1', NULL, NULL, NULL, NULL, NULL, 4),
(82777, NULL, 'G3DSA:1.25.40.10:FF:002654', NULL, NULL, 'Protein CBG23745', NULL, NULL, NULL, NULL, NULL, 4),
(82778, NULL, 'G3DSA:2.60.40.60:FF:000854', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82779, NULL, 'G3DSA:3.40.350.10:FF:000073', NULL, NULL, 'Transporter', NULL, NULL, NULL, NULL, NULL, 4),
(82780, NULL, 'G3DSA:1.10.275.30:FF:000002', NULL, NULL, 'DNA excision repair protein ERCC-2', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(82781, NULL, 'G3DSA:3.30.160.60:FF:001805', NULL, NULL, 'zinc finger protein 385A isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(82782, NULL, 'G3DSA:1.25.40.10:FF:005060', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g62670, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(82783, NULL, 'G3DSA:2.60.40.10:FF:003048', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(82784, NULL, 'G3DSA:1.25.40.10:FF:004784', NULL, NULL, 'Superkiller protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(82785, NULL, 'G3DSA:1.10.150.20:FF:000193', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(82786, NULL, 'G3DSA:1.10.630.10:FF:000226', NULL, NULL, 'Cytochrome P-450 monooxygenase DoxA', NULL, NULL, NULL, NULL, NULL, 4),
(82787, NULL, 'G3DSA:3.30.930.10:FF:000310', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(82788, NULL, 'G3DSA:3.30.1240.10:FF:000015', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(82789, NULL, 'G3DSA:1.10.3720.10:FF:000177', NULL, NULL, 'ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(82790, NULL, 'G3DSA:3.40.1160.10:FF:000012', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(82791, NULL, 'G3DSA:2.60.120.290:FF:000207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82792, NULL, 'G3DSA:3.40.50.720:FF:000673', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(82793, NULL, 'G3DSA:3.10.20.870:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82794, NULL, 'G3DSA:2.60.40.10:FF:004684', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82795, NULL, 'G3DSA:2.60.120.10:FF:000021', NULL, NULL, 'Quercetin 2,3-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(82796, NULL, 'G3DSA:1.10.510.10:FF:001027', NULL, NULL, 'Putative serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(82797, NULL, 'G3DSA:1.10.510.10:FF:001701', NULL, NULL, 'Phosphorylase kinase catalytic subunit gamma 2', NULL, NULL, NULL, NULL, NULL, 4),
(82798, NULL, 'G3DSA:2.130.10.10:FF:001227', NULL, NULL, 'WD repeat domain 93', NULL, NULL, NULL, NULL, NULL, 4),
(82799, NULL, 'G3DSA:3.40.50.300:FF:001626', NULL, NULL, 'ATP-dependent helicase/nuclease subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(82800, NULL, 'G3DSA:3.40.50.2000:FF:000461', NULL, NULL, 'Beta-1,4-mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(82801, NULL, 'G3DSA:2.60.120.20:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82802, NULL, 'G3DSA:3.40.50.2300:FF:001051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82803, NULL, 'G3DSA:3.40.50.80:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82804, NULL, 'G3DSA:3.30.450.20:FF:000164', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(82805, NULL, 'G3DSA:3.80.10.10:FF:001649', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82806, NULL, 'G3DSA:3.30.200.20:FF:001303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82807, NULL, 'G3DSA:1.20.58.60:FF:000179', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(82808, NULL, 'G3DSA:3.30.450.70:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82809, NULL, 'G3DSA:3.30.200.20:FF:002265', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(82810, NULL, 'G3DSA:1.10.840.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82811, NULL, 'G3DSA:3.40.50.1370:FF:000007', NULL, NULL, 'Aspartate carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(82812, NULL, 'G3DSA:3.30.450.20:FF:000506', NULL, NULL, 'IcfG protein', NULL, NULL, NULL, NULL, NULL, 4),
(82813, NULL, 'G3DSA:4.10.1000.10:FF:000041', NULL, NULL, 'Pre-mRNA-splicing factor CWC24', NULL, NULL, NULL, NULL, NULL, 4),
(82814, NULL, 'G3DSA:3.40.50.2000:FF:000803', NULL, NULL, 'Glycosyl transferase, family 9', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(82815, NULL, 'G3DSA:2.30.29.30:FF:000073', NULL, NULL, 'Pleckstrin homology domain-containing family B member 2', NULL, NULL, NULL, NULL, NULL, 4),
(82816, NULL, 'G3DSA:3.30.1490.80:FF:000037', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(82817, NULL, 'G3DSA:2.40.70.10:FF:000297', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82818, NULL, 'G3DSA:2.130.10.10:FF:004993', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82819, NULL, 'G3DSA:3.30.70.330:FF:003114', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82820, NULL, 'G3DSA:3.30.200.20:FF:001989', NULL, NULL, 'CMGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(82821, NULL, 'G3DSA:3.30.160.60:FF:005392', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82822, NULL, 'G3DSA:3.90.176.10:FF:000010', NULL, NULL, 'NAD(P)(+)--arginine ADP-ribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(82823, NULL, 'G3DSA:3.40.50.1360:FF:000004', NULL, NULL, 'Glucosamine-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(82824, NULL, 'G3DSA:1.20.1250.20:FF:002361', NULL, NULL, 'LL-diaminopimelate aminotransferase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(82825, NULL, 'G3DSA:3.30.70.330:FF:000708', NULL, NULL, 'Polyadenylate-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(82826, NULL, 'G3DSA:2.30.29.30:FF:000634', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(82827, NULL, 'G3DSA:2.130.10.10:FF:004555', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82828, NULL, 'G3DSA:1.10.150.670:FF:000008', NULL, NULL, 'Crossover junction endonuclease MUS81', NULL, NULL, NULL, NULL, NULL, 4),
(82829, NULL, 'G3DSA:3.80.10.10:FF:001981', NULL, NULL, 'Receptor kinase-like protein Xa21', NULL, NULL, NULL, NULL, NULL, 4),
(82830, NULL, 'G3DSA:1.25.40.10:FF:001018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82831, NULL, 'G3DSA:3.40.50.300:FF:000103', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(82832, NULL, 'G3DSA:3.60.20.10:FF:000122', NULL, NULL, 'Proteasome subunit beta type-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(82833, NULL, 'G3DSA:1.20.1560.10:FF:000330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82834, NULL, 'G3DSA:1.10.10.60:FF:000379', NULL, NULL, 'Hex homeobox', NULL, NULL, NULL, NULL, NULL, 4),
(82835, NULL, 'G3DSA:3.40.50.720:FF:000235', NULL, NULL, 'UDP-N-acetyl-D-mannosamine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(82836, NULL, 'G3DSA:1.10.510.10:FF:003500', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82837, NULL, 'G3DSA:3.40.50.300:FF:005230', NULL, NULL, 'Thymidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(82838, NULL, 'G3DSA:1.20.1050.130:FF:000037', NULL, NULL, 'tRNA-aminoacylation cofactor arc1', NULL, NULL, NULL, NULL, NULL, 4),
(82839, NULL, 'G3DSA:1.20.1070.10:FF:002153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82840, NULL, 'G3DSA:3.40.50.300:FF:004954', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(82841, NULL, 'G3DSA:3.30.450.60:FF:000041', NULL, NULL, 'Putative coatomer zeta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(82842, NULL, 'G3DSA:1.20.1070.10:FF:001877', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82843, NULL, 'G3DSA:1.10.418.40:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82844, NULL, 'G3DSA:3.10.350.10:FF:000096', NULL, NULL, 'Lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(82845, NULL, 'G3DSA:3.30.230.10:FF:000178', NULL, NULL, 'MUTL-2', NULL, NULL, NULL, NULL, NULL, 4),
(82846, NULL, 'G3DSA:1.10.238.10:FF:001107', NULL, NULL, 'N-terminal EF-hand calcium binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(82847, NULL, 'G3DSA:2.30.30.40:FF:000489', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(82848, NULL, 'G3DSA:1.10.287.770:FF:000026', NULL, NULL, 'T-cell surface glycoprotein CD3 delta chain', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(82849, NULL, 'G3DSA:3.40.30.10:FF:001079', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(82850, NULL, 'G3DSA:3.30.160.60:FF:000749', NULL, NULL, 'Transcriptional regulator Kaiso', NULL, NULL, NULL, NULL, NULL, 4),
(82851, NULL, 'G3DSA:1.10.260.40:FF:000066', NULL, NULL, 'Homeobox protein cut-like', NULL, NULL, NULL, NULL, NULL, 4),
(82852, NULL, 'G3DSA:3.50.50.60:FF:000364', NULL, NULL, 'Possible oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(82853, NULL, 'G3DSA:1.10.510.10:FF:001246', NULL, NULL, 'Protein CBG15711', NULL, NULL, NULL, NULL, NULL, 4),
(82854, NULL, 'G3DSA:3.30.1370.10:FF:000238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82855, NULL, 'G3DSA:3.40.190.10:FF:000195', NULL, NULL, 'Glutamate receptor 2.7', NULL, NULL, NULL, NULL, NULL, 4),
(82856, NULL, 'G3DSA:3.80.10.10:FF:002144', NULL, NULL, 'Receptor like protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(82857, NULL, 'G3DSA:3.30.40.10:FF:002283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82858, NULL, 'G3DSA:1.20.58.1180:FF:000006', NULL, NULL, '54S ribosomal protein L35, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(82859, NULL, 'G3DSA:2.60.40.10:FF:000974', NULL, NULL, 'Collagen alpha-1(XX) chain', NULL, NULL, NULL, NULL, NULL, 4),
(82860, NULL, 'G3DSA:2.60.40.60:FF:001017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82861, NULL, 'G3DSA:2.60.40.60:FF:000399', NULL, NULL, 'Dachsous, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(82862, NULL, 'G3DSA:2.60.40.10:FF:001250', NULL, NULL, 'ADAMTS like 3', NULL, NULL, NULL, NULL, NULL, 4),
(82863, NULL, 'G3DSA:1.10.486.10:FF:000019', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(82864, NULL, 'G3DSA:6.10.250.3370:FF:000003', NULL, NULL, 'Petrobactin biosynthesis protein AsbB', NULL, NULL, NULL, NULL, NULL, 4),
(82865, NULL, 'G3DSA:1.10.287.380:FF:000016', NULL, NULL, 'ABC transporter ATP-binding protein uup', NULL, NULL, NULL, NULL, NULL, 4),
(82866, NULL, 'G3DSA:3.30.780.10:FF:000039', NULL, NULL, 'Translation initiation factor 1, prokaryotic', NULL, NULL, NULL, NULL, NULL, 4),
(82867, NULL, 'G3DSA:3.30.1420.10:FF:000001', NULL, NULL, 'Sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(82868, NULL, 'G3DSA:3.80.10.10:FF:001868', NULL, NULL, 'At1g04210', NULL, NULL, NULL, NULL, NULL, 4),
(82869, NULL, 'G3DSA:1.20.1540.10:FF:000109', NULL, NULL, 'Rhomboid, veinlet-like 2 (Drosophila) (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(82870, NULL, 'G3DSA:3.30.430.20:FF:000056', NULL, NULL, 'Cysteine-rich repeat secretory protein 38', NULL, NULL, NULL, NULL, NULL, 4),
(82871, NULL, 'G3DSA:1.10.287.370:FF:000013', NULL, NULL, 'Prefoldin subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(82872, NULL, 'G3DSA:3.30.750.24:FF:000079', NULL, NULL, 'Os01g0593700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(82873, NULL, 'G3DSA:3.60.110.10:FF:000101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82874, NULL, 'G3DSA:3.10.110.10:FF:000348', NULL, NULL, 'Ubiquitin-conjugating enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(82875, NULL, 'G3DSA:1.20.1160.20:FF:000004', NULL, NULL, 'Cerebral cavernous malformation 2', NULL, NULL, NULL, NULL, NULL, 4),
(82876, NULL, 'G3DSA:1.10.630.10:FF:000007', NULL, NULL, 'Cytochrome P450 76C4', NULL, NULL, NULL, NULL, NULL, 4),
(82877, NULL, 'G3DSA:3.30.1510.10:FF:000008', NULL, NULL, 'Protein CBG27847', NULL, NULL, NULL, NULL, NULL, 4),
(82878, NULL, 'G3DSA:1.20.5.500:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82879, NULL, 'G3DSA:3.30.160.60:FF:004897', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82880, NULL, 'G3DSA:3.30.160.60:FF:004678', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82881, NULL, 'G3DSA:1.25.10.10:FF:000685', NULL, NULL, 'ARM repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(82882, NULL, 'G3DSA:1.50.40.10:FF:000100', NULL, NULL, 'Mitochondrial glycine transporter', NULL, NULL, NULL, NULL, NULL, 4),
(82883, NULL, 'G3DSA:2.130.10.10:FF:001008', NULL, NULL, 'Small nucleolar ribonucleo protein complex subunit', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(82884, NULL, 'G3DSA:3.30.70.600:FF:000014', NULL, NULL, '40S ribosomal protein S20-1', NULL, NULL, NULL, NULL, NULL, 4),
(82885, NULL, 'G3DSA:1.20.80.10:FF:000019', NULL, NULL, 'E3 ubiquitin-protein ligase MYLIP', NULL, NULL, NULL, NULL, NULL, 4),
(82886, NULL, 'G3DSA:1.10.400.10:FF:000075', NULL, NULL, 'Guanine nucleotide-binding protein alpha-1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(82887, NULL, 'G3DSA:2.30.29.30:FF:000415', NULL, NULL, 'Cell 12A endoglucanase', NULL, NULL, NULL, NULL, NULL, 4),
(82888, NULL, 'G3DSA:3.30.565.10:FF:000484', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82889, NULL, 'G3DSA:3.90.70.10:FF:000489', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82890, NULL, 'G3DSA:1.20.5.1190:FF:000003', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(82891, NULL, 'G3DSA:3.30.160.60:FF:005173', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82892, NULL, 'G3DSA:1.10.10.600:FF:000003', NULL, NULL, 'FeS assembly protein IscX', NULL, NULL, NULL, NULL, NULL, 4),
(82893, NULL, 'G3DSA:3.10.580.10:FF:000141', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(82894, NULL, 'G3DSA:2.10.25.10:FF:001548', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(82895, NULL, 'G3DSA:1.20.1270.10:FF:000116', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(82896, NULL, 'G3DSA:2.130.10.10:FF:001901', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(82897, NULL, 'G3DSA:3.90.930.12:FF:000018', NULL, NULL, 'Plastid ribosomal protein L6', NULL, NULL, NULL, NULL, NULL, 4),
(82898, NULL, 'G3DSA:1.10.238.270:FF:000007', NULL, NULL, 'Odorant-binding protein 50a, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(82899, NULL, 'G3DSA:3.40.190.10:FF:000537', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(82900, NULL, 'G3DSA:3.30.160.20:FF:000063', NULL, NULL, 'Dicer-like 103', NULL, NULL, NULL, NULL, NULL, 4),
(82901, NULL, 'G3DSA:3.30.40.10:FF:001788', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(82902, NULL, 'G3DSA:1.20.58.1880:FF:000008', NULL, NULL, 'TSL-kinase interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(82903, NULL, 'G3DSA:1.10.238.10:FF:000489', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(82904, NULL, 'G3DSA:3.30.200.20:FF:000685', NULL, NULL, 'Calcium and calcium/calmodulin-dependent serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(82905, NULL, 'G3DSA:1.20.1560.10:FF:000217', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(82906, NULL, 'G3DSA:1.10.1070.11:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82907, NULL, 'G3DSA:3.40.50.410:FF:000024', NULL, NULL, 'Anthrax toxin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(82908, NULL, 'G3DSA:2.130.10.10:FF:001340', NULL, NULL, 'ASTRA-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(82909, NULL, 'G3DSA:3.30.160.60:FF:000968', NULL, NULL, 'zinc finger protein 628', NULL, NULL, NULL, NULL, NULL, 4),
(82910, NULL, 'G3DSA:3.40.50.2300:FF:000556', NULL, NULL, 'Response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(82911, NULL, 'G3DSA:3.40.50.1760:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82912, NULL, 'G3DSA:3.10.20.90:FF:000979', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82913, NULL, 'G3DSA:3.40.50.300:FF:005117', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(82914, NULL, 'G3DSA:1.10.1240.10:FF:000004', NULL, NULL, 'Monomethylamine methyltransferase corrinoid protein', NULL, NULL, NULL, NULL, NULL, 4),
(82915, NULL, 'G3DSA:1.20.1290.10:FF:000005', NULL, NULL, 'Possible 4-carboxymuconolactone decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(82916, NULL, 'G3DSA:2.10.25.10:FF:000463', NULL, NULL, 'hyaluronan-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(82917, NULL, 'G3DSA:3.40.1350.100:FF:000001', NULL, NULL, 'Protein TIC 22, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(82918, NULL, 'G3DSA:2.130.10.10:FF:005611', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(82919, NULL, 'G3DSA:1.10.10.750:FF:000020', NULL, NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', NULL, NULL, NULL, NULL, NULL, 4),
(82920, NULL, 'G3DSA:3.30.160.60:FF:001244', NULL, NULL, 'Zinc finger protein 37 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(82921, NULL, 'G3DSA:1.10.220.150:FF:000049', NULL, NULL, 'ADP-ribosylation factor GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(82922, NULL, 'G3DSA:2.60.260.20:FF:000186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82923, NULL, 'G3DSA:3.50.50.60:FF:001201', NULL, NULL, 'Monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(82924, NULL, 'G3DSA:2.130.10.10:FF:005050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82925, NULL, 'G3DSA:3.30.1370.10:FF:000019', NULL, NULL, 'RNA-binding protein Nova-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(82926, NULL, 'G3DSA:1.25.40.90:FF:000042', NULL, NULL, 'Pre-mRNA cleavage complex 2 protein Pcf11', NULL, NULL, NULL, NULL, NULL, 4),
(82927, NULL, 'G3DSA:3.30.70.330:FF:000821', NULL, NULL, 'Sex determination protein fox-1', NULL, NULL, NULL, NULL, NULL, 4),
(82928, NULL, 'G3DSA:1.25.10.10:FF:001180', NULL, NULL, 'GM16622', NULL, NULL, NULL, NULL, NULL, 4),
(82929, NULL, 'G3DSA:3.50.50.60:FF:000583', NULL, NULL, 'FAD-dependent oxidoreductase domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(82930, NULL, 'G3DSA:3.40.50.720:FF:000454', NULL, NULL, 'NADPH-protochlorophyllide oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(82931, NULL, 'G3DSA:3.30.300.20:FF:000052', NULL, NULL, 'GTPase Era, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(82932, NULL, 'G3DSA:1.25.10.10:FF:001522', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(82933, NULL, 'G3DSA:1.10.1370.10:FF:000008', NULL, NULL, 'Oligopeptidase A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(82934, NULL, 'G3DSA:3.40.140.10:FF:000259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82935, NULL, 'G3DSA:1.20.5.1000:FF:000003', NULL, NULL, 'Viral A-type inclusion protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(82936, NULL, 'G3DSA:2.130.10.10:FF:004774', NULL, NULL, 'WD repeat domain 82', NULL, NULL, NULL, NULL, NULL, 4),
(82937, NULL, 'G3DSA:3.50.50.60:FF:000925', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82938, NULL, 'G3DSA:3.30.70.330:FF:002496', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82939, NULL, 'G3DSA:3.30.50.10:FF:000092', NULL, NULL, 'Steroid hormone receptor ERR1', NULL, NULL, NULL, NULL, NULL, 4),
(82940, NULL, 'G3DSA:1.10.238.10:FF:001326', NULL, NULL, 'Calpain 11', NULL, NULL, NULL, NULL, NULL, 4),
(82941, NULL, 'G3DSA:2.60.40.10:FF:005302', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82942, NULL, 'G3DSA:3.40.850.10:FF:000330', NULL, NULL, 'Kinesin family member 26Bb', NULL, NULL, NULL, NULL, NULL, 4),
(82943, NULL, 'G3DSA:3.40.50.2000:FF:000129', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(82944, NULL, 'G3DSA:1.20.1250.20:FF:002142', NULL, NULL, 'Battenin', NULL, NULL, NULL, NULL, NULL, 4),
(82945, NULL, 'G3DSA:2.60.470.10:FF:000007', NULL, NULL, 'Sodium channel epithelial 1 delta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(82946, NULL, 'G3DSA:1.10.555.10:FF:000034', NULL, NULL, 'Rac GTPase-activating protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(82947, NULL, 'G3DSA:1.20.1250.20:FF:001866', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82948, NULL, 'G3DSA:3.30.300.30:FF:000055', NULL, NULL, 'Bifunctional fatty acid transporter/acyl-CoA synthetase (FAT1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(82949, NULL, 'G3DSA:1.10.2000.10:FF:000026', NULL, NULL, 'Tyrosine-protein kinase receptor cam-1', NULL, NULL, NULL, NULL, NULL, 4),
(82950, NULL, 'G3DSA:2.40.128.80:FF:000002', NULL, NULL, 'Dipeptidyl aminopeptidase 1', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(82951, NULL, 'G3DSA:3.40.50.970:FF:000170', NULL, NULL, 'Alpha-ketoacid dehydrogenase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(82952, NULL, 'G3DSA:1.10.8.10:FF:000301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82953, NULL, 'G3DSA:3.90.1150.10:FF:000444', NULL, NULL, 'Kynureninase', NULL, NULL, NULL, NULL, NULL, 4),
(82954, NULL, 'G3DSA:3.60.40.10:FF:000230', NULL, NULL, 'Stage II sporulation E family protein', NULL, NULL, NULL, NULL, NULL, 4),
(82955, NULL, 'G3DSA:3.30.160.60:FF:005515', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82956, NULL, 'G3DSA:1.25.40.10:FF:001237', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(82957, NULL, 'G3DSA:2.40.30.20:FF:000027', NULL, NULL, 'Riboflavin synthase alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(82958, NULL, 'G3DSA:3.90.1180.10:FF:000030', NULL, NULL, '39S ribosomal protein L13, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(82959, NULL, 'G3DSA:3.40.50.300:FF:004206', NULL, NULL, 'RAB1B, member RAS oncogene family b', NULL, NULL, NULL, NULL, NULL, 4),
(82960, NULL, 'G3DSA:2.60.120.1000:FF:000005', NULL, NULL, 'Contactin associated protein-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(82961, NULL, 'G3DSA:4.10.1240.10:FF:000036', NULL, NULL, 'Adhesion G protein-coupled receptor A2', NULL, NULL, NULL, NULL, NULL, 4),
(82962, NULL, 'G3DSA:3.40.50.1370:FF:000024', NULL, NULL, 'Ornithine carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(82963, NULL, 'G3DSA:3.40.47.10:FF:000134', NULL, NULL, 'Acetyl-CoA C-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(82964, NULL, 'G3DSA:1.10.287.810:FF:000016', NULL, NULL, 'Mitochondrial import inner membrane translocase subunit Tim10B-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(82965, NULL, 'G3DSA:2.60.120.370:FF:000001', NULL, NULL, 'YhcH/YjgK/YiaL family protein', NULL, NULL, NULL, NULL, NULL, 4),
(82966, NULL, 'G3DSA:3.30.479.30:FF:000036', NULL, NULL, 'Stomatin-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(82967, NULL, 'G3DSA:1.20.80.30:FF:000003', NULL, NULL, 'Pyruvate, phosphate dikinase', NULL, NULL, NULL, NULL, NULL, 4),
(82968, NULL, 'G3DSA:3.90.70.10:FF:000343', NULL, NULL, 'Probable ubiquitin carboxyl-terminal hydrolase K02C4.3', NULL, NULL, NULL, NULL, NULL, 4),
(82969, NULL, 'G3DSA:3.90.550.10:FF:000672', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82970, NULL, 'G3DSA:2.60.60.20:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82971, NULL, 'G3DSA:3.40.1090.10:FF:000107', NULL, NULL, 'Patatin-like phospholipase domain-containing protein SPAC1786.01c', NULL, NULL, NULL, NULL, NULL, 4),
(82972, NULL, 'G3DSA:3.30.1540.20:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82973, NULL, 'G3DSA:4.10.860.120:FF:000007', NULL, NULL, 'DNA-directed RNA polymerase subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(82974, NULL, 'G3DSA:1.10.530.10:FF:000011', NULL, NULL, 'Soluble lytic murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(82975, NULL, 'G3DSA:3.30.160.60:FF:005864', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82976, NULL, 'G3DSA:3.60.20.10:FF:000083', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(82977, NULL, 'G3DSA:3.80.10.10:FF:002806', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82978, NULL, 'G3DSA:1.10.8.10:FF:000144', NULL, NULL, 'Tyrosyl-DNA phosphodiesterase 2', NULL, NULL, NULL, NULL, NULL, 4),
(82979, NULL, 'G3DSA:1.10.357.120:FF:000011', NULL, NULL, 'RNA polymerase I largest subunit', NULL, NULL, NULL, NULL, NULL, 4),
(82980, NULL, 'G3DSA:3.30.70.330:FF:002569', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82981, NULL, 'G3DSA:3.20.20.80:FF:000616', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82982, NULL, 'G3DSA:2.60.40.10:FF:004807', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(82983, NULL, 'G3DSA:3.90.1200.10:FF:000055', NULL, NULL, 'Spore coat protein YsxE', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(82984, NULL, 'G3DSA:2.60.40.1180:FF:000025', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(82985, NULL, 'G3DSA:3.30.200.20:FF:000084', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(82986, NULL, 'G3DSA:2.70.130.10:FF:000025', NULL, NULL, 'Protein OS-9 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(82987, NULL, 'G3DSA:3.20.20.10:FF:000056', NULL, NULL, 'Pyridoxal phosphate homeostasis protein', NULL, NULL, NULL, NULL, NULL, 4),
(82988, NULL, 'G3DSA:3.80.10.10:FF:004370', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82989, NULL, 'G3DSA:1.25.10.10:FF:000836', NULL, NULL, 'Importin subunit alpha-3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(82990, NULL, 'G3DSA:3.40.50.10380:FF:000034', NULL, NULL, 'NADP malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(82991, NULL, 'G3DSA:4.10.400.10:FF:000299', NULL, NULL, 'sortilin-related receptor-like', NULL, NULL, NULL, NULL, NULL, 4),
(82992, NULL, 'G3DSA:1.10.950.10:FF:000003', NULL, NULL, 'supervillin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(82993, NULL, 'G3DSA:2.30.30.380:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(82994, NULL, 'G3DSA:1.20.140.150:FF:000062', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(82995, NULL, 'G3DSA:3.30.1370.100:FF:000003', NULL, NULL, 'DNA mismatch repair protein Mlh3', NULL, NULL, NULL, NULL, NULL, 4),
(82996, NULL, 'G3DSA:1.10.510.10:FF:002718', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(82997, NULL, 'G3DSA:2.130.10.10:FF:004291', NULL, NULL, 'WD repeatcontaining protein 92, putative', NULL, NULL, NULL, NULL, NULL, 4),
(82998, NULL, 'G3DSA:3.40.430.10:FF:000039', NULL, NULL, 'Dihydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(82999, NULL, 'G3DSA:1.20.1250.20:FF:002237', NULL, NULL, 'Putative uncharacterized transporter YOL163W', NULL, NULL, NULL, NULL, NULL, 4),
(83000, NULL, 'G3DSA:3.40.50.10490:FF:000128', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83001, NULL, 'G3DSA:1.10.510.10:FF:003707', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83002, NULL, 'G3DSA:1.20.5.340:FF:000110', NULL, NULL, 'Kinesin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83003, NULL, 'G3DSA:2.10.109.10:FF:000028', NULL, NULL, 'Type I signal peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(83004, NULL, 'G3DSA:2.60.40.3460:FF:000001', NULL, NULL, 'SbsB protein', NULL, NULL, NULL, NULL, NULL, 4),
(83005, NULL, 'G3DSA:3.80.10.10:FF:000036', NULL, NULL, 'protein scribble homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(83006, NULL, 'G3DSA:3.40.50.300:FF:001891', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH 3', NULL, NULL, NULL, NULL, NULL, 4),
(83007, NULL, 'G3DSA:2.170.270.10:FF:000174', NULL, NULL, 'PR domain containing 1c', NULL, NULL, NULL, NULL, NULL, 4),
(83008, NULL, 'G3DSA:3.40.50.300:FF:000463', NULL, NULL, 'GTP-binding protein TypA', NULL, NULL, NULL, NULL, NULL, 4),
(83009, NULL, 'G3DSA:1.10.357.140:FF:000017', NULL, NULL, 'Decaprenyl-phosphate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(83010, NULL, 'G3DSA:3.20.20.60:FF:000077', NULL, NULL, 'Citrate lyase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(83011, NULL, 'G3DSA:4.10.49.10:FF:000002', NULL, NULL, 'Unplaced genomic scaffold supercont1.178, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(83012, NULL, 'G3DSA:3.40.50.1000:FF:000756', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83013, NULL, 'G3DSA:3.30.1130.10:FF:000001', NULL, NULL, 'GTP cyclohydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(83014, NULL, 'G3DSA:2.30.30.40:FF:000293', NULL, NULL, 'PhnA domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(83015, NULL, 'G3DSA:3.30.160.60:FF:001682', NULL, NULL, 'protein Wiz isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(83016, NULL, 'G3DSA:1.10.1740.100:FF:000003', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(83017, NULL, 'G3DSA:3.20.80.10:FF:000032', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(83018, NULL, 'G3DSA:3.40.50.300:FF:008540', NULL, NULL, 'Putative DNA mismatch repair protein Msh6-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(83019, NULL, 'G3DSA:3.40.50.300:FF:003217', NULL, NULL, 'RAB41, member RAS oncogene family, transcript variant X1', NULL, NULL, NULL, NULL, NULL, 4),
(83020, NULL, 'G3DSA:3.40.50.1820:FF:001339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83021, NULL, 'G3DSA:2.40.30.10:FF:000137', NULL, NULL, 'Elongation factor Tu, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83022, NULL, 'G3DSA:3.80.10.10:FF:001817', NULL, NULL, 'DNA repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83023, NULL, 'G3DSA:3.30.160.60:FF:001210', NULL, NULL, 'zinc finger protein 777', NULL, NULL, NULL, NULL, NULL, 4),
(83024, NULL, 'G3DSA:1.10.540.10:FF:000129', NULL, NULL, 'Acyl-CoA dehydrogenase medium chain', NULL, NULL, NULL, NULL, NULL, 4),
(83025, NULL, 'G3DSA:3.40.50.300:FF:003689', NULL, NULL, 'Transmembrane receptors / ATP binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(83026, NULL, 'G3DSA:1.20.1070.10:FF:001034', NULL, NULL, 'Odorant receptor B1', NULL, NULL, NULL, NULL, NULL, 4),
(83027, NULL, 'G3DSA:1.10.10.10:FF:001292', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(83028, NULL, 'G3DSA:3.40.850.10:FF:000150', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(83029, NULL, 'G3DSA:2.10.220.10:FF:000074', NULL, NULL, 'High cysteine membrane protein TMK-like', NULL, NULL, NULL, NULL, NULL, 4),
(83030, NULL, 'G3DSA:3.40.1110.10:FF:000251', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83031, NULL, 'G3DSA:3.40.50.12660:FF:000010', NULL, NULL, 'Metacaspase-9', NULL, NULL, NULL, NULL, NULL, 4),
(83032, NULL, 'G3DSA:2.20.20.110:FF:000004', NULL, NULL, 'Rad4 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(83033, NULL, 'G3DSA:1.25.40.20:FF:001010', NULL, NULL, 'Protein ACCELERATED CELL DEATH 6', NULL, NULL, NULL, NULL, NULL, 4),
(83034, NULL, 'G3DSA:3.30.70.330:FF:000332', NULL, NULL, 'flowering time control protein FCA isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(83035, NULL, 'G3DSA:1.10.10.60:FF:000738', NULL, NULL, 'MYB-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(83036, NULL, 'G3DSA:1.25.40.10:FF:002581', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83037, NULL, 'G3DSA:1.20.890.10:FF:000007', NULL, NULL, 'receptor tyrosine-protein kinase erbB-3', NULL, NULL, NULL, NULL, NULL, 4),
(83038, NULL, 'G3DSA:1.10.510.10:FF:001729', NULL, NULL, 'BcDNA.LD22679', NULL, NULL, NULL, NULL, NULL, 4),
(83039, NULL, 'G3DSA:2.40.20.10:FF:000052', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(83040, NULL, 'G3DSA:3.40.50.300:FF:004645', NULL, NULL, 'EG:33C11.2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(83041, NULL, 'G3DSA:2.60.40.1130:FF:000004', NULL, NULL, 'GM10787', NULL, NULL, NULL, NULL, NULL, 4),
(83042, NULL, 'G3DSA:2.10.25.10:FF:000671', NULL, NULL, 'Protein Z, vitamin K-dependent plasma glycoprotein a', NULL, NULL, NULL, NULL, NULL, 4),
(83043, NULL, 'G3DSA:1.50.40.10:FF:000572', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83044, NULL, 'G3DSA:2.60.40.10:FF:000625', NULL, NULL, 'Vascular cell adhesion molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(83045, NULL, 'G3DSA:3.30.200.20:FF:001865', NULL, NULL, 'Os04g0123750 protein', NULL, NULL, NULL, NULL, NULL, 4),
(83046, NULL, 'G3DSA:2.40.10.10:FF:000607', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83047, NULL, 'G3DSA:2.70.170.10:FF:000090', NULL, NULL, 'gamma-aminobutyric acid receptor subunit rho-1-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(83048, NULL, 'G3DSA:1.20.58.60:FF:000691', NULL, NULL, 'Microtubule-actin crosslinking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(83049, NULL, 'G3DSA:3.40.50.11890:FF:000003', NULL, NULL, '(R)-2-hydroxyglutaryl-CoA dehydratase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(83050, NULL, 'G3DSA:2.130.10.10:FF:006056', NULL, NULL, 'F-box/WD repeat-containing protein pof1', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(83051, NULL, 'G3DSA:3.40.190.10:FF:000442', NULL, NULL, 'Twin-arginine translocation pathway signal protein', NULL, NULL, NULL, NULL, NULL, 4),
(83052, NULL, 'G3DSA:1.25.40.20:FF:000493', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 19', NULL, NULL, NULL, NULL, NULL, 4),
(83053, NULL, 'G3DSA:2.130.10.10:FF:004139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83054, NULL, 'G3DSA:3.20.20.80:FF:000296', NULL, NULL, 'Exo-1,3-beta-glucanase', NULL, NULL, NULL, NULL, NULL, 4),
(83055, NULL, 'G3DSA:3.30.420.510:FF:000011', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(83056, NULL, 'G3DSA:3.30.60.20:FF:000157', NULL, NULL, 'Protein vav-1', NULL, NULL, NULL, NULL, NULL, 4),
(83057, NULL, 'G3DSA:3.40.630.40:FF:000002', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase AmiA', NULL, NULL, NULL, NULL, NULL, 4),
(83058, NULL, 'G3DSA:3.30.200.20:FF:000404', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(83059, NULL, 'G3DSA:2.10.25.10:FF:001008', NULL, NULL, 'Fcgbp protein', NULL, NULL, NULL, NULL, NULL, 4),
(83060, NULL, 'G3DSA:3.40.50.150:FF:000749', NULL, NULL, 'O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(83061, NULL, 'G3DSA:2.60.40.10:FF:003498', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83062, NULL, 'G3DSA:3.40.50.300:FF:007551', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(83063, NULL, 'G3DSA:2.30.42.10:FF:000558', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83064, NULL, 'G3DSA:3.30.40.10:FF:002215', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83065, NULL, 'G3DSA:2.160.10.10:FF:000006', NULL, NULL, 'Glucose-1-phosphate adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(83066, NULL, 'G3DSA:1.20.1110.10:FF:000133', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83067, NULL, 'G3DSA:3.40.190.10:FF:000003', NULL, NULL, 'Glutamate receptor, ionotropic, AMPA 2', NULL, NULL, NULL, NULL, NULL, 4),
(83068, NULL, 'G3DSA:3.30.160.60:FF:003447', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83069, NULL, 'G3DSA:1.25.40.10:FF:001592', NULL, NULL, 'NASP (Human Nuclear Autoantigenic Sperm Protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(83070, NULL, 'G3DSA:1.10.533.10:FF:000164', NULL, NULL, 'Cyclin T-dependent kinase CDK9, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83071, NULL, 'G3DSA:2.60.40.60:FF:000207', NULL, NULL, 'FAT atypical cadherin 2', NULL, NULL, NULL, NULL, NULL, 4),
(83072, NULL, 'G3DSA:3.30.2350.20:FF:000015', NULL, NULL, 'Unplaced genomic scaffold supercont1.8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(83073, NULL, 'G3DSA:2.30.40.10:FF:000104', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(83074, NULL, 'G3DSA:1.20.5.1930:FF:000012', NULL, NULL, 'Putative methanol utilization control sensor protein moxY', NULL, NULL, NULL, NULL, NULL, 4),
(83075, NULL, 'G3DSA:3.30.70.370:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83076, NULL, 'G3DSA:3.40.570.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83077, NULL, 'G3DSA:1.20.5.780:FF:000006', NULL, NULL, 'FXYD domain-containing ion transport regulator', NULL, NULL, NULL, NULL, NULL, 4),
(83078, NULL, 'G3DSA:3.30.160.60:FF:004083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83079, NULL, 'G3DSA:1.10.150.240:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83080, NULL, 'G3DSA:2.130.10.10:FF:001385', NULL, NULL, 'Probable cleavage and polyadenylation specificity factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(83081, NULL, 'G3DSA:1.25.40.10:FF:000664', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(83082, NULL, 'G3DSA:3.30.160.60:FF:002519', NULL, NULL, 'zinc finger protein 252-like', NULL, NULL, NULL, NULL, NULL, 4),
(83083, NULL, 'G3DSA:3.30.70.330:FF:001760', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83084, NULL, 'G3DSA:1.20.120.330:FF:000011', NULL, NULL, 'Type III secretion system needle tip complex protein SipB', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(83085, NULL, 'G3DSA:3.30.70.270:FF:000292', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83086, NULL, 'G3DSA:3.80.10.10:FF:001025', NULL, NULL, 'Protein zyg-11 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(83087, NULL, 'G3DSA:2.60.40.10:FF:000272', NULL, NULL, 'Immunoglobulin superfamily member 9B', NULL, NULL, NULL, NULL, NULL, 4),
(83088, NULL, 'G3DSA:1.25.40.10:FF:005335', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83089, NULL, 'G3DSA:3.40.50.720:FF:000353', NULL, NULL, 'WW domain-containing oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(83090, NULL, 'G3DSA:1.10.486.10:FF:000025', NULL, NULL, 'ATP-dependent DNA helicase UvrD2', NULL, NULL, NULL, NULL, NULL, 4),
(83091, NULL, 'G3DSA:3.40.710.10:FF:000140', NULL, NULL, 'Glutaminase', NULL, NULL, NULL, NULL, NULL, 4),
(83092, NULL, 'G3DSA:2.60.120.200:FF:000788', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(83093, NULL, 'G3DSA:1.20.1270.280:FF:000081', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(83094, NULL, 'G3DSA:3.40.50.300:FF:002880', NULL, NULL, 'Cobyric acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(83095, NULL, 'G3DSA:2.130.10.10:FF:004611', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83096, NULL, 'G3DSA:2.30.30.30:FF:000025', NULL, NULL, '39S ribosomal protein L2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(83097, NULL, 'G3DSA:2.130.10.10:FF:005600', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83098, NULL, 'G3DSA:3.60.21.10:FF:000135', NULL, NULL, 'Os06g0222800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(83099, NULL, 'G3DSA:1.10.238.10:FF:000820', NULL, NULL, 'Calmodulin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(83100, NULL, 'G3DSA:2.10.25.10:FF:000019', NULL, NULL, 'latent-transforming growth factor beta-binding protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(83101, NULL, 'G3DSA:3.40.50.2300:FF:001675', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83102, NULL, 'G3DSA:3.80.10.10:FF:003381', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(83103, NULL, 'G3DSA:3.20.20.70:FF:000759', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83104, NULL, 'G3DSA:3.30.1360.70:FF:000008', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(83105, NULL, 'G3DSA:1.25.40.10:FF:001653', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83106, NULL, 'G3DSA:3.40.50.150:FF:001738', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83107, NULL, 'G3DSA:2.120.10.90:FF:000015', NULL, NULL, 'DNA topoisomerase 4 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(83108, NULL, 'G3DSA:3.30.70.340:FF:000009', NULL, NULL, 'GD10919', NULL, NULL, NULL, NULL, NULL, 4),
(83109, NULL, 'G3DSA:3.30.160.60:FF:002458', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83110, NULL, 'G3DSA:1.10.1200.10:FF:000058', NULL, NULL, 'Nonribosomal peptide synthase GliP', NULL, NULL, NULL, NULL, NULL, 4),
(83111, NULL, 'G3DSA:1.10.3260.10:FF:000034', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(83112, NULL, 'G3DSA:2.130.10.10:FF:005128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83113, NULL, 'G3DSA:1.10.472.10:FF:000055', NULL, NULL, 'Cyclin F', NULL, NULL, NULL, NULL, NULL, 4),
(83114, NULL, 'G3DSA:1.10.510.10:FF:002365', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83115, NULL, 'G3DSA:2.10.25.10:FF:000519', NULL, NULL, 'Nidogen 2', NULL, NULL, NULL, NULL, NULL, 4),
(83116, NULL, 'G3DSA:1.20.920.30:FF:000016', NULL, NULL, 'Axonemal dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(83117, NULL, 'G3DSA:3.50.50.60:FF:000015', NULL, NULL, 'Thioredoxin reductase', NULL, NULL, NULL, NULL, NULL, 4),
(83118, NULL, 'G3DSA:2.130.10.10:FF:000396', NULL, NULL, 'phosphoinositide 3-kinase regulatory subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(83119, NULL, 'G3DSA:3.30.70.100:FF:000168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83120, NULL, 'G3DSA:3.30.1360.10:FF:000069', NULL, NULL, 'Serine/threonine-protein kinase CG17528-like Protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(83121, NULL, 'G3DSA:2.40.100.10:FF:000092', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(83122, NULL, 'G3DSA:2.40.70.10:FF:000263', NULL, NULL, 'Aspartic proteinase nepenthesin-1', NULL, NULL, NULL, NULL, NULL, 4),
(83123, NULL, 'G3DSA:3.40.30.10:FF:000983', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83124, NULL, 'G3DSA:1.20.1070.10:FF:001473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83125, NULL, 'G3DSA:3.30.40.10:FF:001726', NULL, NULL, 'PHD finger protein EHD3 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(83126, NULL, 'G3DSA:3.10.100.10:FF:000061', NULL, NULL, 'CD248 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(83127, NULL, 'G3DSA:1.20.120.1910:FF:000014', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(83128, NULL, 'G3DSA:2.140.10.30:FF:000002', NULL, NULL, 'Dipeptidyl peptidase 8-like isoform', NULL, NULL, NULL, NULL, NULL, 4),
(83129, NULL, 'G3DSA:3.30.410.10:FF:000001', NULL, NULL, 'Cellobiose dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(83130, NULL, 'G3DSA:3.30.360.20:FF:000005', NULL, NULL, 'RNA re-capping enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(83131, NULL, 'G3DSA:3.40.250.10:FF:000121', NULL, NULL, 'Hydroxyacylglutathione hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(83132, NULL, 'G3DSA:3.30.565.10:FF:000444', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(83133, NULL, 'G3DSA:1.10.8.60:FF:000198', NULL, NULL, 'Cell cycle checkpoint protein RAD17', NULL, NULL, NULL, NULL, NULL, 4),
(83134, NULL, 'G3DSA:1.10.10.60:FF:000385', NULL, NULL, 'Putative homeobox-leucine zipper protein ATHB-51', NULL, NULL, NULL, NULL, NULL, 4),
(83135, NULL, 'G3DSA:1.10.150.20:FF:000294', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(83136, NULL, 'G3DSA:2.60.120.10:FF:000577', NULL, NULL, 'Sll1924 protein', NULL, NULL, NULL, NULL, NULL, 4),
(83137, NULL, 'G3DSA:3.30.70.330:FF:001260', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(83138, NULL, 'G3DSA:3.40.50.300:FF:008068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83139, NULL, 'G3DSA:3.40.630.30:FF:000206', NULL, NULL, 'GNAT family N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(83140, NULL, 'G3DSA:3.90.550.10:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83141, NULL, 'G3DSA:3.10.110.10:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83142, NULL, 'G3DSA:3.40.350.10:FF:000005', NULL, NULL, 'SPT16 homolog, facilitates chromatin-remodeling subunit', NULL, NULL, NULL, NULL, NULL, 4),
(83143, NULL, 'G3DSA:3.50.30.30:FF:000056', NULL, NULL, 'Glutamate carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(83144, NULL, 'G3DSA:3.30.160.60:FF:000221', NULL, NULL, 'Zinc finger protein 410', NULL, NULL, NULL, NULL, NULL, 4),
(83145, NULL, 'G3DSA:2.40.150.20:FF:000013', NULL, NULL, '60S ribosomal protein L23', NULL, NULL, NULL, NULL, NULL, 4),
(83146, NULL, 'G3DSA:3.30.210.10:FF:000020', NULL, NULL, 'DNA-directed DNA/RNA polymerase mu', NULL, NULL, NULL, NULL, NULL, 4),
(83147, NULL, 'G3DSA:4.10.1000.10:FF:000142', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(83148, NULL, 'G3DSA:1.25.40.70:FF:000075', NULL, NULL, 'VPS34-like PI-3-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(83149, NULL, 'G3DSA:1.10.238.10:FF:001276', NULL, NULL, 'Calmodulin', NULL, NULL, NULL, NULL, NULL, 4),
(83150, NULL, 'G3DSA:3.40.50.620:FF:000469', NULL, NULL, 'GM10510', NULL, NULL, NULL, NULL, NULL, 4),
(83151, NULL, 'G3DSA:2.30.30.40:FF:000646', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(83152, NULL, 'G3DSA:3.40.140.100:FF:000007', NULL, NULL, 'Ubiquitin-like modifier-activating enzyme atg7', NULL, NULL, NULL, NULL, NULL, 4),
(83153, NULL, 'G3DSA:3.40.50.300:FF:002380', NULL, NULL, 'SWI/SNF family DNA-dependent ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(83154, NULL, 'G3DSA:3.30.930.10:FF:000057', NULL, NULL, 'DNA polymerase subunit gamma-2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(83155, NULL, 'G3DSA:2.130.10.30:FF:000143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83156, NULL, 'G3DSA:2.60.40.10:FF:005004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83157, NULL, 'G3DSA:2.60.40.10:FF:002542', NULL, NULL, 'Immunoglobulin heavy variable 1-4', NULL, NULL, NULL, NULL, NULL, 4),
(83158, NULL, 'G3DSA:1.10.8.60:FF:000518', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83159, NULL, 'G3DSA:2.10.110.10:FF:000245', NULL, NULL, 'Chromosome 21, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(83160, NULL, 'G3DSA:3.60.15.10:FF:000161', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(83161, NULL, 'G3DSA:3.30.1370.210:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83162, NULL, 'G3DSA:2.40.50.140:FF:001155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83163, NULL, 'G3DSA:3.40.50.10090:FF:000071', NULL, NULL, 'Putative uroporphyrinogen III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(83164, NULL, 'G3DSA:1.25.70.10:FF:000020', NULL, NULL, 'Mitochondrial transcription termination factor family protein', NULL, NULL, NULL, NULL, NULL, 4),
(83165, NULL, 'G3DSA:1.10.3380.10:FF:000009', NULL, NULL, 'DEAD/DEAH box helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83166, NULL, 'G3DSA:1.10.10.10:FF:001645', NULL, NULL, 'Csn-4', NULL, NULL, NULL, NULL, NULL, 4),
(83167, NULL, 'G3DSA:3.30.10.20:FF:000007', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(83168, NULL, 'G3DSA:3.80.10.10:FF:000980', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(83169, NULL, 'G3DSA:1.25.10.10:FF:001764', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83170, NULL, 'G3DSA:3.80.10.10:FF:003442', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83171, NULL, 'G3DSA:1.10.1000.11:FF:000027', NULL, NULL, 'YALI0D23463p', NULL, NULL, NULL, NULL, NULL, 4),
(83172, NULL, 'G3DSA:1.10.1220.170:FF:000002', NULL, NULL, 'Antitoxin', NULL, NULL, NULL, NULL, NULL, 4),
(83173, NULL, 'G3DSA:2.130.10.10:FF:003655', NULL, NULL, 'Copper resistance D domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(83174, NULL, 'G3DSA:3.30.450.60:FF:000029', NULL, NULL, 'AP-2 complex subunit mu', NULL, NULL, NULL, NULL, NULL, 4),
(83175, NULL, 'G3DSA:1.25.40.10:FF:002901', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g11630, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(83176, NULL, 'G3DSA:1.50.10.20:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83177, NULL, 'G3DSA:3.40.30.10:FF:000191', NULL, NULL, 'Protein disulfide isomerase like, testis expressed', NULL, NULL, NULL, NULL, NULL, 4),
(83178, NULL, 'G3DSA:1.25.40.20:FF:000521', NULL, NULL, 'Ankyrin repeat domain 23', NULL, NULL, NULL, NULL, NULL, 4),
(83179, NULL, 'G3DSA:1.20.1250.20:FF:001309', NULL, NULL, 'Major facilitator superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(83180, NULL, 'G3DSA:1.10.287.130:FF:000059', NULL, NULL, 'PAS domain-containing sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(83181, NULL, 'G3DSA:1.25.40.10:FF:000164', NULL, NULL, 'Vacuolar protein sorting-associated protein 11 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(83182, NULL, 'G3DSA:1.10.10.10:FF:000364', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(83183, NULL, 'G3DSA:3.90.740.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83184, NULL, 'G3DSA:3.40.50.1820:FF:000822', NULL, NULL, 'Protein CBG13010', NULL, NULL, NULL, NULL, NULL, 4),
(83185, NULL, 'G3DSA:1.10.287.110:FF:000020', NULL, NULL, 'DnaJ subfamily B member 13', NULL, NULL, NULL, NULL, NULL, 4),
(83186, NULL, 'G3DSA:3.30.360.10:FF:000087', NULL, NULL, 'Aspartate-semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(83187, NULL, 'G3DSA:2.40.50.770:FF:000001', NULL, NULL, 'Tudor domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(83188, NULL, 'G3DSA:3.20.20.140:FF:000245', NULL, NULL, 'Adenine deaminase 1', NULL, NULL, NULL, NULL, NULL, 4),
(83189, NULL, 'G3DSA:3.30.565.10:FF:000383', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(83190, NULL, 'G3DSA:3.40.50.300:FF:003717', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(83191, NULL, 'G3DSA:3.50.50.60:FF:001443', NULL, NULL, 'Amino acid oxidase fmpA', NULL, NULL, NULL, NULL, NULL, 4),
(83192, NULL, 'G3DSA:2.60.40.10:FF:002250', NULL, NULL, 'Mesocentin', NULL, NULL, NULL, NULL, NULL, 4),
(83193, NULL, 'G3DSA:2.30.110.10:FF:000055', NULL, NULL, 'GM10976', NULL, NULL, NULL, NULL, NULL, 4),
(83194, NULL, 'G3DSA:1.20.59.10:FF:000009', NULL, NULL, 'Intracellular chorismate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(83195, NULL, 'G3DSA:3.40.50.10050:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83196, NULL, 'G3DSA:2.60.120.200:FF:000288', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(83197, NULL, 'G3DSA:3.40.1390.20:FF:000009', NULL, NULL, 'Cobalt-dependent inorganic pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(83198, NULL, 'G3DSA:2.30.29.130:FF:000002', NULL, NULL, 'Glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(83199, NULL, 'G3DSA:1.10.510.10:FF:000892', NULL, NULL, 'Ser/Thr kinase', NULL, NULL, NULL, NULL, NULL, 4),
(83200, NULL, 'G3DSA:4.10.60.10:FF:000012', NULL, NULL, 'Cellular nucleic acid-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(83201, NULL, 'G3DSA:3.40.30.10:FF:000483', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(83202, NULL, 'G3DSA:2.60.40.10:FF:004307', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83203, NULL, 'G3DSA:3.10.20.540:FF:000002', NULL, NULL, 'ORF1a polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(83204, NULL, 'G3DSA:1.10.167.10:FF:000060', NULL, NULL, 'Regulator of G protein-signaling 14a', NULL, NULL, NULL, NULL, NULL, 4),
(83205, NULL, 'G3DSA:2.60.40.10:FF:004487', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83206, NULL, 'G3DSA:2.40.50.150:FF:000023', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(83207, NULL, 'G3DSA:3.30.40.10:FF:001226', NULL, NULL, 'E3 ubiquitin-protein ligase parkin', NULL, NULL, NULL, NULL, NULL, 4),
(83208, NULL, 'G3DSA:3.30.60.30:FF:000047', NULL, NULL, 'Complement component C6', NULL, NULL, NULL, NULL, NULL, 4),
(83209, NULL, 'G3DSA:3.40.50.300:FF:000963', NULL, NULL, 'Guanine nucleotide-binding protein-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(83210, NULL, 'G3DSA:2.130.10.10:FF:002666', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83211, NULL, 'G3DSA:3.30.1330.80:FF:000009', NULL, NULL, 'AT-hook motif nuclear-localized protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(83212, NULL, 'G3DSA:3.40.50.2020:FF:000141', NULL, NULL, 'Ribose-phosphate pyrophosphokinase 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83213, NULL, 'G3DSA:1.20.120.290:FF:000010', NULL, NULL, 'Sll1638 protein', NULL, NULL, NULL, NULL, NULL, 4),
(83214, NULL, 'G3DSA:3.30.1360.120:FF:000097', NULL, NULL, 'Sarcosine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(83215, NULL, 'G3DSA:2.60.120.920:FF:000178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83216, NULL, 'G3DSA:2.160.20.10:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83217, NULL, 'G3DSA:2.120.10.30:FF:000576', NULL, NULL, 'Adipocyte plasma membrane-associated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83218, NULL, 'G3DSA:3.90.190.10:FF:000037', NULL, NULL, 'dual specificity protein phosphatase 26', NULL, NULL, NULL, NULL, NULL, 4),
(83219, NULL, 'G3DSA:2.60.40.10:FF:004779', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83220, NULL, 'G3DSA:3.10.290.10:FF:000102', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(83221, NULL, 'G3DSA:3.30.160.60:FF:005072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83222, NULL, 'G3DSA:3.40.50.300:FF:006562', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83223, NULL, 'G3DSA:1.10.472.10:FF:000555', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83224, NULL, 'G3DSA:3.60.15.10:FF:000014', NULL, NULL, 'Zinc phosphodiesterase ELAC protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(83225, NULL, 'G3DSA:2.60.260.20:FF:000091', NULL, NULL, 'DnaJ domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(83226, NULL, 'G3DSA:2.120.10.30:FF:000604', NULL, NULL, 'Dipeptidyl Peptidase Four (IV) family', NULL, NULL, NULL, NULL, NULL, 4),
(83227, NULL, 'G3DSA:2.60.40.10:FF:003970', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83228, NULL, 'G3DSA:1.10.510.10:FF:003646', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83229, NULL, 'G3DSA:1.20.120.1750:FF:000123', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(83230, NULL, 'G3DSA:3.20.20.60:FF:000138', NULL, NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(83231, NULL, 'G3DSA:3.30.160.60:FF:005364', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83232, NULL, 'G3DSA:2.110.10.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83233, NULL, 'G3DSA:3.30.1330.60:FF:000003', NULL, NULL, 'Flagellar motor protein MotB', NULL, NULL, NULL, NULL, NULL, 4),
(83234, NULL, 'G3DSA:1.10.238.10:FF:000287', NULL, NULL, 'Probable GTP diphosphokinase CRSH, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(83235, NULL, 'G3DSA:1.25.10.10:FF:000483', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(83236, NULL, 'G3DSA:1.20.1070.10:FF:000837', NULL, NULL, 'Purinergic receptor P2Y, G-protein-coupled, 11', NULL, NULL, NULL, NULL, NULL, 4),
(83237, NULL, 'G3DSA:1.10.150.20:FF:000114', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(83238, NULL, 'G3DSA:3.30.1490.140:FF:000002', NULL, NULL, 'beta-amyloid-like protein isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(83239, NULL, 'G3DSA:1.10.132.130:FF:000001', NULL, NULL, 'Vacuolar-processing enzyme beta-isozyme', NULL, NULL, NULL, NULL, NULL, 4),
(83240, NULL, 'G3DSA:1.10.287.110:FF:000312', NULL, NULL, 'Chaperone protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83241, NULL, 'G3DSA:1.25.40.10:FF:004054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83242, NULL, 'G3DSA:3.40.50.300:FF:006270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83243, NULL, 'G3DSA:3.40.30.10:FF:000011', NULL, NULL, 'Peroxiredoxin PRX1', NULL, NULL, NULL, NULL, NULL, 4),
(83244, NULL, 'G3DSA:3.40.50.300:FF:007079', NULL, NULL, 'Small GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83245, NULL, 'G3DSA:3.30.70.330:FF:000271', NULL, NULL, 'squamous cell carcinoma antigen recognized by T-cells 3', NULL, NULL, NULL, NULL, NULL, 4),
(83246, NULL, 'G3DSA:3.40.390.10:FF:000131', NULL, NULL, 'GD21387', NULL, NULL, NULL, NULL, NULL, 4),
(83247, NULL, 'G3DSA:3.30.420.40:FF:000281', NULL, NULL, 'Actin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83248, NULL, 'G3DSA:1.25.40.10:FF:004879', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g29230', NULL, NULL, NULL, NULL, NULL, 4),
(83249, NULL, 'G3DSA:1.10.555.10:FF:000242', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83250, NULL, 'G3DSA:1.10.510.10:FF:003354', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83251, NULL, 'G3DSA:1.25.40.820:FF:000003', NULL, NULL, 'Putative RNA polymerase II subunit B1 CTD phosphatase RPAP2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(83252, NULL, 'G3DSA:1.20.1070.10:FF:000045', NULL, NULL, 'D(1A) dopamine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(83253, NULL, 'G3DSA:3.20.20.70:FF:000467', NULL, NULL, 'Hydroxymethylglutaryl-CoA lyase, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(83254, NULL, 'G3DSA:3.80.10.10:FF:000828', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM1', NULL, NULL, NULL, NULL, NULL, 4),
(83255, NULL, 'G3DSA:3.10.20.90:FF:000906', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(83256, NULL, 'G3DSA:3.30.70.330:FF:002069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83257, NULL, 'G3DSA:3.40.50.150:FF:001385', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83258, NULL, 'G3DSA:2.60.40.150:FF:000741', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83259, NULL, 'G3DSA:3.40.50.200:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83260, NULL, 'G3DSA:3.40.50.1820:FF:000030', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(83261, NULL, 'G3DSA:3.40.630.30:FF:000645', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83262, NULL, 'G3DSA:3.10.20.90:FF:000614', NULL, NULL, 'mitogen-activated protein kinase kinase kinase 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(83263, NULL, 'G3DSA:3.30.200.20:FF:000876', NULL, NULL, 'AGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(83264, NULL, 'G3DSA:1.50.10.20:FF:000129', NULL, NULL, 'Protein farnesyltransferase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(83265, NULL, 'G3DSA:1.20.1050.10:FF:000162', NULL, NULL, 'Sui m 8 allergen', NULL, NULL, NULL, NULL, NULL, 4),
(83266, NULL, 'G3DSA:3.30.160.60:FF:000693', NULL, NULL, 'Snail family zinc finger 1a', NULL, NULL, NULL, NULL, NULL, 4),
(83267, NULL, 'G3DSA:3.40.30.10:FF:000039', NULL, NULL, 'Glutathione S-transferase domain', NULL, NULL, NULL, NULL, NULL, 4),
(83268, NULL, 'G3DSA:3.40.50.2300:FF:000747', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83269, NULL, 'G3DSA:3.40.50.150:FF:000457', NULL, NULL, 'Ribosomal RNA-processing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(83270, NULL, 'G3DSA:2.130.10.10:FF:005780', NULL, NULL, 'Damage-specific DNA binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(83271, NULL, 'G3DSA:2.60.120.1560:FF:000004', NULL, NULL, 'PKHD1-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(83272, NULL, 'G3DSA:3.30.420.40:FF:000573', NULL, NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(83273, NULL, 'G3DSA:2.60.40.60:FF:001135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83274, NULL, 'G3DSA:2.30.42.10:FF:000266', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(83275, NULL, 'G3DSA:1.20.1250.20:FF:001720', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(83276, NULL, 'G3DSA:1.10.540.10:FF:000068', NULL, NULL, 'Acyl-CoA dehydrogenase FadE22', NULL, NULL, NULL, NULL, NULL, 4),
(83277, NULL, 'G3DSA:3.30.230.10:FF:000375', NULL, NULL, '40S ribosomal protein S16', NULL, NULL, NULL, NULL, NULL, 4),
(83278, NULL, 'G3DSA:3.30.450.30:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83279, NULL, 'G3DSA:1.20.1270.60:FF:000047', NULL, NULL, 'protein FAM92A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(83280, NULL, 'G3DSA:2.60.120.330:FF:000068', NULL, NULL, 'S-norcoclaurine synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(83281, NULL, 'G3DSA:2.60.40.60:FF:000646', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83282, NULL, 'G3DSA:1.25.40.10:FF:004346', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83283, NULL, 'G3DSA:1.25.40.840:FF:000009', NULL, NULL, 'NTL-1a', NULL, NULL, NULL, NULL, NULL, 4),
(83284, NULL, 'G3DSA:3.40.50.2300:FF:001383', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83285, NULL, 'G3DSA:2.40.10.10:FF:000107', NULL, NULL, 'TISP43 isoform 6', NULL, NULL, NULL, NULL, NULL, 4),
(83286, NULL, 'G3DSA:1.20.1250.10:FF:000082', NULL, NULL, 'Interleukin-22', NULL, NULL, NULL, NULL, NULL, 4),
(83287, NULL, 'G3DSA:3.40.50.1220:FF:000058', NULL, NULL, 'Deacetylase SIR2', NULL, NULL, NULL, NULL, NULL, 4),
(83288, NULL, 'G3DSA:3.30.710.10:FF:000485', NULL, NULL, 'SKP1-like protein 6', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(83289, NULL, 'G3DSA:1.10.246.140:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83290, NULL, 'G3DSA:3.20.20.80:FF:000116', NULL, NULL, 'Beta-galactosidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(83291, NULL, 'G3DSA:2.10.70.10:FF:000034', NULL, NULL, 'BMP-binding endothelial regulator protein', NULL, NULL, NULL, NULL, NULL, 4),
(83292, NULL, 'G3DSA:1.10.510.10:FF:000920', NULL, NULL, 'Receptor-like protein kinase ANXUR2', NULL, NULL, NULL, NULL, NULL, 4),
(83293, NULL, 'G3DSA:3.30.70.1230:FF:000193', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(83294, NULL, 'G3DSA:1.20.58.70:FF:000076', NULL, NULL, 'QA-SNARE protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(83295, NULL, 'G3DSA:3.60.21.10:FF:000427', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(83296, NULL, 'G3DSA:1.10.246.60:FF:000005', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit J', NULL, NULL, NULL, NULL, NULL, 4),
(83297, NULL, 'G3DSA:3.90.940.10:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83298, NULL, 'G3DSA:4.10.950.10:FF:000003', NULL, NULL, '50S ribosomal protein L2', NULL, NULL, NULL, NULL, NULL, 4),
(83299, NULL, 'G3DSA:2.10.25.10:FF:001447', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83300, NULL, 'G3DSA:3.30.70.1360:FF:000001', NULL, NULL, 'Global nitrogen regulator NrpR', NULL, NULL, NULL, NULL, NULL, 4),
(83301, NULL, 'G3DSA:3.10.290.70:FF:000013', NULL, NULL, '40S ribosomal protein S8', NULL, NULL, NULL, NULL, NULL, 4),
(83302, NULL, 'G3DSA:3.40.50.300:FF:005634', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83303, NULL, 'G3DSA:2.40.30.330:FF:000005', NULL, NULL, 'mRNA cleavage and polyadenylation factor CLP1', NULL, NULL, NULL, NULL, NULL, 4),
(83304, NULL, 'G3DSA:3.90.1420.10:FF:000066', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(83305, NULL, 'G3DSA:3.40.50.720:FF:000645', NULL, NULL, 'Anthocyanidin reductase ((2S)-flavan-3-ol-forming)', NULL, NULL, NULL, NULL, NULL, 4),
(83306, NULL, 'G3DSA:1.20.5.1200:FF:000001', NULL, NULL, 'Clavesin 2', NULL, NULL, NULL, NULL, NULL, 4),
(83307, NULL, 'G3DSA:2.60.40.10:FF:000564', NULL, NULL, 'Ciliary neurotrophic factor receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(83308, NULL, 'G3DSA:1.20.5.190:FF:000043', NULL, NULL, 'unconventional myosin-Ia isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(83309, NULL, 'G3DSA:3.40.50.2300:FF:001236', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83310, NULL, 'G3DSA:3.40.50.1100:FF:000168', NULL, NULL, 'Pyridoxal-phosphate dependent eynzyme', NULL, NULL, NULL, NULL, NULL, 4),
(83311, NULL, 'G3DSA:3.40.367.20:FF:000018', NULL, NULL, 'hexokinase-2 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(83312, NULL, 'G3DSA:1.25.40.10:FF:003418', NULL, NULL, 'PPR repeat family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83313, NULL, 'G3DSA:3.10.170.20:FF:000012', NULL, NULL, 'Leishmanolysin-like peptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(83314, NULL, 'G3DSA:3.30.559.10:FF:000031', NULL, NULL, 'Nonribosomal peptide synthase Pes1', NULL, NULL, NULL, NULL, NULL, 4),
(83315, NULL, 'G3DSA:3.80.10.10:FF:001464', NULL, NULL, 'Leucine_rich_repeat/Leucine_Rich_Repeat_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(83316, NULL, 'G3DSA:1.10.287.690:FF:000025', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(83317, NULL, 'G3DSA:2.130.10.10:FF:002374', NULL, NULL, 'Guanine nucleotide-binding beta subunit-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(83318, NULL, 'G3DSA:2.40.50.140:FF:000666', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83319, NULL, 'G3DSA:1.10.8.710:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83320, NULL, 'G3DSA:1.10.10.10:FF:001792', NULL, NULL, 'Putative MarR-family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(83321, NULL, 'G3DSA:2.130.10.10:FF:001738', NULL, NULL, 'Anaphase-promoting complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(83322, NULL, 'G3DSA:3.30.420.10:FF:000058', NULL, NULL, 'PARN like, ribonuclease domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(83323, NULL, 'G3DSA:3.30.160.60:FF:004436', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83324, NULL, 'G3DSA:2.40.10.10:FF:000254', NULL, NULL, 'Trypsin precursor', NULL, NULL, NULL, NULL, NULL, 4),
(83325, NULL, 'G3DSA:3.30.470.20:FF:000159', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(83326, NULL, 'G3DSA:3.30.160.60:FF:001710', NULL, NULL, 'Zinc finger protein 407 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(83327, NULL, 'G3DSA:3.30.420.40:FF:000134', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(83328, NULL, 'G3DSA:3.40.50.300:FF:006123', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(83329, NULL, 'G3DSA:3.30.559.30:FF:000037', NULL, NULL, 'BcNRPS3, nonribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(83330, NULL, 'G3DSA:2.60.120.10:FF:000605', NULL, NULL, 'Mannose-6-phosphate isomerase, class I family protein', NULL, NULL, NULL, NULL, NULL, 4),
(83331, NULL, 'G3DSA:1.20.1250.40:FF:000006', NULL, NULL, 'DNA-directed RNA polymerase II 16 kDa subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83332, NULL, 'G3DSA:3.40.50.1000:FF:000256', NULL, NULL, 'Phosphomannomutase', NULL, NULL, NULL, NULL, NULL, 4),
(83333, NULL, 'G3DSA:3.40.50.10420:FF:000035', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(83334, NULL, 'G3DSA:3.30.200.20:FF:001365', NULL, NULL, 'V-mos Moloney murine sarcoma viral oncogene homolog', NULL, NULL, NULL, NULL, NULL, 4),
(83335, NULL, 'G3DSA:3.40.50.720:FF:001281', NULL, NULL, 'Chorismate mutase/prephenate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(83336, NULL, 'G3DSA:3.30.830.10:FF:000140', NULL, NULL, 'Cytochrome b-c1 complex subunit 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(83337, NULL, 'G3DSA:3.30.160.60:FF:003947', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83338, NULL, 'G3DSA:3.50.50.60:FF:000807', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83339, NULL, 'G3DSA:4.10.410.10:FF:000064', NULL, NULL, 'Serine peptidase inhibitor, Kunitz type, 2', NULL, NULL, NULL, NULL, NULL, 4),
(83340, NULL, 'G3DSA:1.10.579.10:FF:000005', NULL, NULL, 'Deoxyribodipyrimidine photo-lyase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83341, NULL, 'G3DSA:1.10.1040.10:FF:000023', NULL, NULL, 'lambda-crystallin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(83342, NULL, 'G3DSA:3.90.1150.10:FF:000202', NULL, NULL, 'Cysteine desulfurase', NULL, NULL, NULL, NULL, NULL, 4),
(83343, NULL, 'G3DSA:1.10.510.10:FF:004282', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83344, NULL, 'G3DSA:1.20.1250.20:FF:000972', NULL, NULL, 'Enterobactin transporter', NULL, NULL, NULL, NULL, NULL, 4),
(83345, NULL, 'G3DSA:1.10.12.10:FF:000054', NULL, NULL, 'Enoyl-CoA hydratase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83346, NULL, 'G3DSA:1.10.630.10:FF:000428', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83347, NULL, 'G3DSA:2.70.150.10:FF:000060', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(83348, NULL, 'G3DSA:2.10.90.10:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83349, NULL, 'G3DSA:2.70.150.10:FF:000088', NULL, NULL, 'Cation transporting ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83350, NULL, 'G3DSA:3.30.420.10:FF:000619', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83351, NULL, 'G3DSA:2.60.40.1930:FF:000031', NULL, NULL, 'Thiolester containing protein I', NULL, NULL, NULL, NULL, NULL, 4),
(83352, NULL, 'G3DSA:2.40.160.60:FF:000003', NULL, NULL, 'Outer membrane transport family protein', NULL, NULL, NULL, NULL, NULL, 4),
(83353, NULL, 'G3DSA:1.25.40.10:FF:003570', NULL, NULL, 'SARP family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(83354, NULL, 'G3DSA:3.80.10.10:FF:001317', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase isoform A', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(83355, NULL, 'G3DSA:1.25.40.20:FF:001802', NULL, NULL, 'BRCA1-associated RING domain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(83356, NULL, 'G3DSA:3.60.40.10:FF:000319', NULL, NULL, 'Putative protein phosphatase 2C 53', NULL, NULL, NULL, NULL, NULL, 4),
(83357, NULL, 'G3DSA:3.30.870.10:FF:000086', NULL, NULL, 'Cardiolipin synthase YbhO', NULL, NULL, NULL, NULL, NULL, 4),
(83358, NULL, 'G3DSA:1.20.1560.10:FF:000392', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(83359, NULL, 'G3DSA:1.10.8.60:FF:000226', NULL, NULL, 'Chromosomal replication initiator DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(83360, NULL, 'G3DSA:3.40.33.10:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83361, NULL, 'G3DSA:1.20.5.1180:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83362, NULL, 'G3DSA:3.40.50.300:FF:002228', NULL, NULL, 'Amino acid/amide ABC transporter ATP-binding protein 1, HAAT family', NULL, NULL, NULL, NULL, NULL, 4),
(83363, NULL, 'G3DSA:1.25.10.10:FF:000044', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(83364, NULL, 'G3DSA:2.10.50.10:FF:000151', NULL, NULL, 'Si:ch211-112c15.8', NULL, NULL, NULL, NULL, NULL, 4),
(83365, NULL, 'G3DSA:3.90.470.20:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83366, NULL, 'G3DSA:3.30.1150.10:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83367, NULL, 'G3DSA:2.70.20.50:FF:000001', NULL, NULL, 'Matrix protein', NULL, NULL, NULL, NULL, NULL, 4),
(83368, NULL, 'G3DSA:2.40.10.10:FF:000315', NULL, NULL, 'AGAP013254-PA', NULL, NULL, NULL, NULL, NULL, 4),
(83369, NULL, 'G3DSA:3.40.50.10810:FF:000062', NULL, NULL, 'DNA repair protein rhp16', NULL, NULL, NULL, NULL, NULL, 4),
(83370, NULL, 'G3DSA:3.50.30.30:FF:000117', NULL, NULL, 'Ring finger protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(83371, NULL, 'G3DSA:3.90.650.10:FF:000056', NULL, NULL, 'Hydrogenase expression/formation protein HypE', NULL, NULL, NULL, NULL, NULL, 4),
(83372, NULL, 'G3DSA:1.20.120.30:FF:000006', NULL, NULL, 'Methyl-accepting chemotaxis protein IV', NULL, NULL, NULL, NULL, NULL, 4),
(83373, NULL, 'G3DSA:2.60.40.3500:FF:000002', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase amiB', NULL, NULL, NULL, NULL, NULL, 4),
(83374, NULL, 'G3DSA:3.40.50.670:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83375, NULL, 'G3DSA:1.10.3730.20:FF:000028', NULL, NULL, 'Probable 4-amino-4-deoxy-L-arabinose-phosphoundecaprenol flippase subunit ArnF', NULL, NULL, NULL, NULL, NULL, 4),
(83376, NULL, 'G3DSA:3.20.20.80:FF:000324', NULL, NULL, 'Glucosidase, beta, acid 3 (gene/pseudogene)', NULL, NULL, NULL, NULL, NULL, 4),
(83377, NULL, 'G3DSA:1.10.150.20:FF:000322', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83378, NULL, 'G3DSA:3.40.50.1820:FF:000058', NULL, NULL, 'Alpha/beta hydrolase domain-containing protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(83379, NULL, 'G3DSA:4.10.400.10:FF:000119', NULL, NULL, 'Suppressor of tumorigenicity 14 protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(83380, NULL, 'G3DSA:2.30.30.140:FF:000063', NULL, NULL, 'PWWP domain-containing DNA repair factor 3A', NULL, NULL, NULL, NULL, NULL, 4),
(83381, NULL, 'G3DSA:3.80.10.10:FF:000328', NULL, NULL, '187-kDa microtubule-associated protein AIR9', NULL, NULL, NULL, NULL, NULL, 4),
(83382, NULL, 'G3DSA:2.30.30.140:FF:000119', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 34', NULL, NULL, NULL, NULL, NULL, 4),
(83383, NULL, 'G3DSA:2.30.29.30:FF:001180', NULL, NULL, 'Beige protein homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(83384, NULL, 'G3DSA:3.40.50.720:FF:001842', NULL, NULL, 'Alcohol dehydrogenase, putative (AFU_orthologue AFUA_2G04590)', NULL, NULL, NULL, NULL, NULL, 4),
(83385, NULL, 'G3DSA:2.60.120.430:FF:000008', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(83386, NULL, 'G3DSA:2.60.40.10:FF:001906', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(83387, NULL, 'G3DSA:2.30.29.170:FF:000019', NULL, NULL, 'EF-hand domain (C-terminal) containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(83388, NULL, 'G3DSA:3.75.10.10:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83389, NULL, 'G3DSA:1.20.1270.60:FF:000255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83390, NULL, 'G3DSA:3.30.160.60:FF:005717', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83391, NULL, 'G3DSA:4.10.870.10:FF:000002', NULL, NULL, 'Family 48 cellulase', NULL, NULL, NULL, NULL, NULL, 4),
(83392, NULL, 'G3DSA:1.20.1070.10:FF:002170', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(83393, NULL, 'G3DSA:1.25.40.10:FF:003918', NULL, NULL, 'ACL089Wp', NULL, NULL, NULL, NULL, NULL, 4),
(83394, NULL, 'G3DSA:2.30.29.30:FF:001236', NULL, NULL, 'Guanine exchange factor for Rac 30', NULL, NULL, NULL, NULL, NULL, 4),
(83395, NULL, 'G3DSA:2.130.10.10:FF:005628', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83396, NULL, 'G3DSA:2.130.10.10:FF:005100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83397, NULL, 'G3DSA:3.90.79.10:FF:000216', NULL, NULL, 'Nudix hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(83398, NULL, 'G3DSA:2.60.450.10:FF:000006', NULL, NULL, 'Lipopolysaccharide export system protein LptA', NULL, NULL, NULL, NULL, NULL, 4),
(83399, NULL, 'G3DSA:1.10.238.10:FF:000848', NULL, NULL, 'GM15808', NULL, NULL, NULL, NULL, NULL, 4),
(83400, NULL, 'G3DSA:1.10.1410.10:FF:000012', NULL, NULL, 'Nucleolar protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(83401, NULL, 'G3DSA:3.20.20.80:FF:000796', NULL, NULL, 'Glycosyl hydrolase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(83402, NULL, 'G3DSA:3.30.160.60:FF:002930', NULL, NULL, 'Zinc finger protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(83403, NULL, 'G3DSA:2.10.90.10:FF:000125', NULL, NULL, 'Activin B', NULL, NULL, NULL, NULL, NULL, 4),
(83404, NULL, 'G3DSA:2.130.10.10:FF:001885', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83405, NULL, 'G3DSA:1.25.40.10:FF:001092', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(83406, NULL, 'G3DSA:1.10.533.10:FF:000225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83407, NULL, 'G3DSA:3.40.50.11500:FF:000016', NULL, NULL, 'DENN domain containing protein 2D', NULL, NULL, NULL, NULL, NULL, 4),
(83408, NULL, 'G3DSA:3.30.70.330:FF:000624', NULL, NULL, 'Oligouridylate-binding protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(83409, NULL, 'G3DSA:2.60.40.10:FF:000772', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(83410, NULL, 'G3DSA:2.130.10.10:FF:000249', NULL, NULL, 'nucleoporin Nup43', NULL, NULL, NULL, NULL, NULL, 4),
(83411, NULL, 'G3DSA:1.20.910.10:FF:000004', NULL, NULL, 'Aminopyrimidine aminohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(83412, NULL, 'G3DSA:2.30.180.10:FF:000088', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83413, NULL, 'G3DSA:2.60.40.10:FF:001761', NULL, NULL, 'Interleukin 18 receptor accessory protein', NULL, NULL, NULL, NULL, NULL, 4),
(83414, NULL, 'G3DSA:3.30.70.330:FF:000040', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein A2/B1', NULL, NULL, NULL, NULL, NULL, 4),
(83415, NULL, 'G3DSA:3.30.390.10:FF:000004', NULL, NULL, 'Glucarate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(83416, NULL, 'G3DSA:1.25.40.20:FF:001302', NULL, NULL, 'Ankrd15 protein', NULL, NULL, NULL, NULL, NULL, 4),
(83417, NULL, 'G3DSA:3.30.160.60:FF:001502', NULL, NULL, 'ZFP28 zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(83418, NULL, 'G3DSA:3.30.200.20:FF:001101', NULL, NULL, 'Inka box actin regulator 1b', NULL, NULL, NULL, NULL, NULL, 4),
(83419, NULL, 'G3DSA:1.20.1280.50:FF:000224', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(83420, NULL, 'G3DSA:3.40.50.300:FF:003509', NULL, NULL, 'Putative ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(83421, NULL, 'G3DSA:3.40.1110.10:FF:000279', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(83422, NULL, 'G3DSA:1.20.950.20:FF:000015', NULL, NULL, 'Hydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(83423, NULL, 'G3DSA:2.60.120.380:FF:000089', NULL, NULL, 'Calpain 9', NULL, NULL, NULL, NULL, NULL, 4),
(83424, NULL, 'G3DSA:1.10.230.10:FF:000027', NULL, NULL, 'Bll6374 protein', NULL, NULL, NULL, NULL, NULL, 4),
(83425, NULL, 'G3DSA:1.20.210.10:FF:000030', NULL, NULL, 'Cytochrome c oxidase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(83426, NULL, 'G3DSA:1.10.150.50:FF:000218', NULL, NULL, 'Sphingomyelin synthase-related 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(83427, NULL, 'G3DSA:3.40.50.1820:FF:001047', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(83428, NULL, 'G3DSA:3.50.4.10:FF:000036', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase SD1-1 isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(83429, NULL, 'G3DSA:2.40.10.350:FF:000002', NULL, NULL, 'Cell shape-determining protein MreC', NULL, NULL, NULL, NULL, NULL, 4),
(83430, NULL, 'G3DSA:1.25.10.10:FF:000544', NULL, NULL, 'AP-1 complex subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(83431, NULL, 'G3DSA:2.60.120.920:FF:000150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83432, NULL, 'G3DSA:1.25.40.570:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83433, NULL, 'G3DSA:1.10.510.10:FF:004135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83434, NULL, 'G3DSA:3.30.2320.10:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83435, NULL, 'G3DSA:3.40.50.1820:FF:001311', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83436, NULL, 'G3DSA:1.20.120.140:FF:000044', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(83437, NULL, 'G3DSA:3.30.450.80:FF:000007', NULL, NULL, 'LuxR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(83438, NULL, 'G3DSA:1.20.120.350:FF:000022', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(83439, NULL, 'G3DSA:3.30.450.20:FF:000304', NULL, NULL, 'Probable serine/threonine-protein kinase DDB_G0280133', NULL, NULL, NULL, NULL, NULL, 4),
(83440, NULL, 'G3DSA:1.20.1250.20:FF:000500', NULL, NULL, 'Metabolite/drug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83441, NULL, 'G3DSA:3.40.50.300:FF:008568', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83442, NULL, 'G3DSA:1.10.357.10:FF:000012', NULL, NULL, 'Transcriptional regulator, TetR family', NULL, NULL, NULL, NULL, NULL, 4),
(83443, NULL, 'G3DSA:1.20.5.170:FF:000149', NULL, NULL, 'LD42070p', NULL, NULL, NULL, NULL, NULL, 4),
(83444, NULL, 'G3DSA:1.20.1250.20:FF:000764', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(83445, NULL, 'G3DSA:3.30.160.60:FF:001974', NULL, NULL, 'zinc finger protein 329', NULL, NULL, NULL, NULL, NULL, 4),
(83446, NULL, 'G3DSA:3.30.200.20:FF:001573', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83447, NULL, 'G3DSA:3.40.50.10180:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83448, NULL, 'G3DSA:3.40.50.1000:FF:000464', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83449, NULL, 'G3DSA:2.30.30.100:FF:000158', NULL, NULL, 'LSM11, U7 small nuclear RNA associated', NULL, NULL, NULL, NULL, NULL, 4),
(83450, NULL, 'G3DSA:3.40.50.11030:FF:000004', NULL, NULL, 'Threonylcarbamoyl-AMP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(83451, NULL, 'G3DSA:1.10.8.60:FF:000018', NULL, NULL, '26S protease regulatory subunit 6B', NULL, NULL, NULL, NULL, NULL, 4),
(83452, NULL, 'G3DSA:2.40.340.10:FF:000014', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(83453, NULL, 'G3DSA:3.40.190.290:FF:000102', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(83454, NULL, 'G3DSA:1.20.200.10:FF:000001', NULL, NULL, 'Fumarate hydratase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(83455, NULL, 'G3DSA:1.20.5.110:FF:000238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(83456, NULL, 'G3DSA:1.10.287.70:FF:000007', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(83457, NULL, 'G3DSA:3.40.850.10:FF:000442', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83458, NULL, 'G3DSA:3.30.160.60:FF:001238', NULL, NULL, 'Zinc finger protein 648', NULL, NULL, NULL, NULL, NULL, 4),
(83459, NULL, 'G3DSA:3.30.160.60:FF:004583', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83460, NULL, 'G3DSA:1.25.10.10:FF:001264', NULL, NULL, 'PIKK family atypical protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(83461, NULL, 'G3DSA:3.90.230.10:FF:000064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83462, NULL, 'G3DSA:3.30.40.10:FF:000478', NULL, NULL, 'Ring finger protein 207', NULL, NULL, NULL, NULL, NULL, 4),
(83463, NULL, 'G3DSA:1.20.1070.10:FF:001326', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83464, NULL, 'G3DSA:2.40.30.10:FF:000429', NULL, NULL, 'Eukaryotic release factor 3 GTPase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(83465, NULL, 'G3DSA:3.50.50.60:FF:000987', NULL, NULL, 'Fmo1p', NULL, NULL, NULL, NULL, NULL, 4),
(83466, NULL, 'G3DSA:2.40.50.90:FF:000089', NULL, NULL, 'Endonuclease YncB, thermonuclease family', NULL, NULL, NULL, NULL, NULL, 4),
(83467, NULL, 'G3DSA:3.40.50.300:FF:004353', NULL, NULL, 'ABC transporter, ATP binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(83468, NULL, 'G3DSA:3.50.50.100:FF:000058', NULL, NULL, 'Type-II NADH dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(83469, NULL, 'G3DSA:1.25.40.540:FF:000009', NULL, NULL, 'Similar to TOR signalling pathway regulator (TapA)', NULL, NULL, NULL, NULL, NULL, 4),
(83470, NULL, 'G3DSA:1.10.357.30:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83471, NULL, 'G3DSA:1.25.40.10:FF:000956', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(83472, NULL, 'G3DSA:1.10.437.10:FF:000013', NULL, NULL, 'Protein F1', NULL, NULL, NULL, NULL, NULL, 4),
(83473, NULL, 'G3DSA:3.30.230.10:FF:000083', NULL, NULL, 'Ribonuclease P protein component', NULL, NULL, NULL, NULL, NULL, 4),
(83474, NULL, 'G3DSA:3.90.550.10:FF:000700', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83475, NULL, 'G3DSA:3.30.1490.120:FF:000024', NULL, NULL, 'Probable DNA-directed RNA polymerase I subunit RPA43', NULL, NULL, NULL, NULL, NULL, 4),
(83476, NULL, 'G3DSA:3.30.1520.10:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83477, NULL, 'G3DSA:3.40.630.30:FF:000353', NULL, NULL, 'AGAP002287-PA', NULL, NULL, NULL, NULL, NULL, 4),
(83478, NULL, 'G3DSA:1.25.40.180:FF:000210', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83479, NULL, 'G3DSA:1.25.10.10:FF:001972', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(83480, NULL, 'G3DSA:3.30.160.60:FF:000985', NULL, NULL, 'Zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(83481, NULL, 'G3DSA:1.10.510.10:FF:000392', NULL, NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 152', NULL, NULL, NULL, NULL, NULL, 4),
(83482, NULL, 'G3DSA:3.40.50.10190:FF:000067', NULL, NULL, 'Pescadillo homolog', NULL, NULL, NULL, NULL, NULL, 4),
(83483, NULL, 'G3DSA:3.40.50.1820:FF:000322', NULL, NULL, 'Integral membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(83484, NULL, 'G3DSA:3.40.50.12780:FF:000080', NULL, NULL, 'Nonribosomal peptide synthase SidE', NULL, NULL, NULL, NULL, NULL, 4),
(83485, NULL, 'G3DSA:3.65.10.20:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83486, NULL, 'G3DSA:3.90.226.10:FF:000166', NULL, NULL, 'Membrane-bound serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(83487, NULL, 'G3DSA:3.40.50.620:FF:000441', NULL, NULL, 'Tryptophan--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(83488, NULL, 'G3DSA:3.40.640.10:FF:000432', NULL, NULL, 'Serine--pyruvate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(83489, NULL, 'G3DSA:3.80.10.10:FF:000536', NULL, NULL, 'Leucine-rich repeat-containing protein 30', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(83490, NULL, 'G3DSA:3.40.50.1460:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83491, NULL, 'G3DSA:2.60.40.10:FF:000125', NULL, NULL, 'filamin-B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(83492, NULL, 'G3DSA:2.30.30.140:FF:000271', NULL, NULL, 'Fragile X mental retardation syndrome-related protein 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(83493, NULL, 'G3DSA:3.40.50.80:FF:000134', NULL, NULL, 'Ferric reductase like transmembrane component-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(83494, NULL, 'G3DSA:3.40.50.150:FF:001677', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83495, NULL, 'G3DSA:2.130.10.10:FF:003863', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83496, NULL, 'G3DSA:1.20.90.10:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83497, NULL, 'G3DSA:1.20.82.10:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83498, NULL, 'G3DSA:1.20.120.710:FF:000001', NULL, NULL, 'N-acylneuraminate-9-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(83499, NULL, 'G3DSA:3.10.110.10:FF:000207', NULL, NULL, 'UBC26', NULL, NULL, NULL, NULL, NULL, 4),
(83500, NULL, 'G3DSA:4.10.400.10:FF:000271', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83501, NULL, 'G3DSA:1.50.40.10:FF:000280', NULL, NULL, 'Mitochondrial carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83502, NULL, 'G3DSA:1.10.30.10:FF:000186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83503, NULL, 'G3DSA:3.30.70.270:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83504, NULL, 'G3DSA:3.30.160.60:FF:004728', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83505, NULL, 'G3DSA:1.10.150.80:FF:000025', NULL, NULL, 'HRDC domain./PIF1 helicase', NULL, NULL, NULL, NULL, NULL, 4),
(83506, NULL, 'G3DSA:3.30.420.10:FF:000266', NULL, NULL, '3''-5'' exoribonuclease parn-1', NULL, NULL, NULL, NULL, NULL, 4),
(83507, NULL, 'G3DSA:1.10.10.2330:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83508, NULL, 'G3DSA:2.70.150.10:FF:000116', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(83509, NULL, 'G3DSA:2.130.10.10:FF:004791', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83510, NULL, 'G3DSA:3.10.20.90:FF:000322', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(83511, NULL, 'G3DSA:1.25.40.1030:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83512, NULL, 'G3DSA:1.20.120.730:FF:000007', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(83513, NULL, 'G3DSA:3.40.50.300:FF:003189', NULL, NULL, 'GTPase HflX', NULL, NULL, NULL, NULL, NULL, 4),
(83514, NULL, 'G3DSA:1.10.10.60:FF:000238', NULL, NULL, 'Aspartate/glutamate/uridylate kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(83515, NULL, 'G3DSA:1.25.40.10:FF:002081', NULL, NULL, 'C-term of Hsp70-iNteracting protein (CHIP family)', NULL, NULL, NULL, NULL, NULL, 4),
(83516, NULL, 'G3DSA:2.60.40.1120:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83517, NULL, 'G3DSA:1.25.40.20:FF:001038', NULL, NULL, 'Ankyrin repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(83518, NULL, 'G3DSA:2.60.40.10:FF:002481', NULL, NULL, 'AGAP003656-PA', NULL, NULL, NULL, NULL, NULL, 4),
(83519, NULL, 'G3DSA:3.40.1090.10:FF:000046', NULL, NULL, 'NTE family protein', NULL, NULL, NULL, NULL, NULL, 4),
(83520, NULL, 'G3DSA:2.60.40.10:FF:005504', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83521, NULL, 'G3DSA:1.20.1110.10:FF:000072', NULL, NULL, 'ATPase 11, plasma membrane-type-like', NULL, NULL, NULL, NULL, NULL, 4),
(83522, NULL, 'G3DSA:1.25.10.10:FF:000336', NULL, NULL, 'Catenin delta-2', NULL, NULL, NULL, NULL, NULL, 4),
(83523, NULL, 'G3DSA:3.40.850.10:FF:000178', NULL, NULL, 'Kinesin-related protein3', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(83524, NULL, 'G3DSA:2.40.50.140:FF:000374', NULL, NULL, 'Nodulation efficiency protein D', NULL, NULL, NULL, NULL, NULL, 4),
(83525, NULL, 'G3DSA:2.60.120.200:FF:000760', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83526, NULL, 'G3DSA:3.10.20.10:FF:000017', NULL, NULL, 'LPXTG-motif cell wall anchor domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(83527, NULL, 'G3DSA:2.120.10.30:FF:000076', NULL, NULL, 'Acylamino-acid-releasing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(83528, NULL, 'G3DSA:2.20.100.10:FF:000074', NULL, NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 12', NULL, NULL, NULL, NULL, NULL, 4),
(83529, NULL, 'G3DSA:3.40.50.300:FF:003397', NULL, NULL, 'Eng_C97 protein', NULL, NULL, NULL, NULL, NULL, 4),
(83530, NULL, 'G3DSA:3.30.70.330:FF:001288', NULL, NULL, 'Protein CBG15138', NULL, NULL, NULL, NULL, NULL, 4),
(83531, NULL, 'G3DSA:1.25.40.20:FF:001774', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83532, NULL, 'G3DSA:2.60.40.10:FF:004515', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83533, NULL, 'G3DSA:2.130.10.10:FF:002082', NULL, NULL, 'WD40 repeat-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(83534, NULL, 'G3DSA:2.60.40.10:FF:003559', NULL, NULL, 'Interleukin 10 receptor, alpha', NULL, NULL, NULL, NULL, NULL, 4),
(83535, NULL, 'G3DSA:2.10.25.10:FF:001155', NULL, NULL, 'Brevican', NULL, NULL, NULL, NULL, NULL, 4),
(83536, NULL, 'G3DSA:1.10.150.720:FF:000001', NULL, NULL, 'Haloacid dehalogenase-like hydrolase domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(83537, NULL, 'G3DSA:1.20.1740.10:FF:000046', NULL, NULL, 'Amino-acid permease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83538, NULL, 'G3DSA:3.30.450.20:FF:000568', NULL, NULL, 'Putative methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(83539, NULL, 'G3DSA:1.25.10.10:FF:001472', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83540, NULL, 'G3DSA:1.25.40.10:FF:003862', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83541, NULL, 'G3DSA:3.30.360.10:FF:000120', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase GAPA1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(83542, NULL, 'G3DSA:1.20.1250.20:FF:001692', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83543, NULL, 'G3DSA:1.10.560.10:FF:000131', NULL, NULL, 'T-complex protein 1 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(83544, NULL, 'G3DSA:1.10.8.270:FF:000058', NULL, NULL, 'Related to MDR1-Mac1p interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(83545, NULL, 'G3DSA:3.60.21.10:FF:000282', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(83546, NULL, 'G3DSA:3.40.50.300:FF:005342', NULL, NULL, 'ATPase involved in chromosome partitioning-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(83547, NULL, 'G3DSA:3.20.20.70:FF:000698', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83548, NULL, 'G3DSA:3.80.10.10:FF:002745', NULL, NULL, 'Putative F-box/FBD/LRR-repeat protein At4g00315', NULL, NULL, NULL, NULL, NULL, 4),
(83549, NULL, 'G3DSA:3.30.60.30:FF:000194', NULL, NULL, 'Serine protease inhibitor kazal-like protein, minor form', NULL, NULL, NULL, NULL, NULL, 4),
(83550, NULL, 'G3DSA:2.60.120.560:FF:000019', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(83551, NULL, 'G3DSA:2.60.40.10:FF:005768', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83552, NULL, 'G3DSA:1.25.40.20:FF:001510', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(83553, NULL, 'G3DSA:1.10.510.10:FF:001229', NULL, NULL, 'Rho-associated protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(83554, NULL, 'G3DSA:1.20.1070.10:FF:000337', NULL, NULL, 'Adrenoceptor alpha 2C', NULL, NULL, NULL, NULL, NULL, 4),
(83555, NULL, 'G3DSA:3.30.160.60:FF:003655', NULL, NULL, 'IP01015p', NULL, NULL, NULL, NULL, NULL, 4),
(83556, NULL, 'G3DSA:1.10.530.10:FF:000039', NULL, NULL, 'Possible peptidase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(83557, NULL, 'G3DSA:3.90.70.10:FF:000051', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(83558, NULL, 'G3DSA:3.90.640.10:FF:000027', NULL, NULL, 'Actin like 8', NULL, NULL, NULL, NULL, NULL, 4),
(83559, NULL, 'G3DSA:3.90.930.12:FF:000001', NULL, NULL, '50S ribosomal protein L6', NULL, NULL, NULL, NULL, NULL, 4),
(83560, NULL, 'G3DSA:3.40.309.10:FF:000022', NULL, NULL, 'NADP-dependent glyceraldehyde-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(83561, NULL, 'G3DSA:3.30.260.10:FF:000023', NULL, NULL, 'T-complex protein 1 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(83562, NULL, 'G3DSA:1.10.760.10:FF:000112', NULL, NULL, 'Cytochrome c', NULL, NULL, NULL, NULL, NULL, 4),
(83563, NULL, 'G3DSA:2.60.120.200:FF:000024', NULL, NULL, 'FAT atypical cadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(83564, NULL, 'G3DSA:2.20.28.10:FF:000003', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(83565, NULL, 'G3DSA:1.10.3120.10:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83566, NULL, 'G3DSA:1.20.58.110:FF:000007', NULL, NULL, '30S ribosomal protein S20', NULL, NULL, NULL, NULL, NULL, 4),
(83567, NULL, 'G3DSA:2.60.40.10:FF:002834', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(83568, NULL, 'G3DSA:3.30.230.130:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83569, NULL, 'G3DSA:2.40.33.10:FF:000031', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(83570, NULL, 'G3DSA:3.40.50.150:FF:000957', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83571, NULL, 'G3DSA:1.20.990.10:FF:000043', NULL, NULL, 'Oxidoreductase-protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83572, NULL, 'G3DSA:3.40.50.200:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83573, NULL, 'G3DSA:3.40.50.2300:FF:000539', NULL, NULL, 'LacI family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(83574, NULL, 'G3DSA:3.40.50.10190:FF:000275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83575, NULL, 'G3DSA:2.60.120.260:FF:000199', NULL, NULL, 'CRE-UNC-84 protein', NULL, NULL, NULL, NULL, NULL, 4),
(83576, NULL, 'G3DSA:3.40.640.10:FF:000224', NULL, NULL, 'Probable glycine dehydrogenase (decarboxylating) subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(83577, NULL, 'G3DSA:3.40.950.10:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83578, NULL, 'G3DSA:3.30.160.60:FF:000721', NULL, NULL, 'Zinc finger protein 407', NULL, NULL, NULL, NULL, NULL, 4),
(83579, NULL, 'G3DSA:2.30.180.10:FF:000149', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83580, NULL, 'G3DSA:2.30.18.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83581, NULL, 'G3DSA:3.30.420.10:FF:000530', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83582, NULL, 'G3DSA:3.40.50.300:FF:005134', NULL, NULL, 'DEAD box helicase involved in nonsense mediated decay, putative (AFU_orthologue AFUA_5G09090)', NULL, NULL, NULL, NULL, NULL, 4),
(83583, NULL, 'G3DSA:3.40.630.30:FF:000145', NULL, NULL, 'Acetyltransferase Atu2258', NULL, NULL, NULL, NULL, NULL, 4),
(83584, NULL, 'G3DSA:3.30.2290.10:FF:000007', NULL, NULL, 'Metalloprotease TldD', NULL, NULL, NULL, NULL, NULL, 4),
(83585, NULL, 'G3DSA:3.40.50.300:FF:002672', NULL, NULL, 'Elongation factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83586, NULL, 'G3DSA:1.50.40.10:FF:000072', NULL, NULL, 'solute carrier family 25 member 47', NULL, NULL, NULL, NULL, NULL, 4),
(83587, NULL, 'G3DSA:2.30.30.490:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83588, NULL, 'G3DSA:1.10.510.10:FF:000712', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83589, NULL, 'G3DSA:2.30.30.40:FF:000062', NULL, NULL, 'caskin-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(83590, NULL, 'G3DSA:1.25.40.20:FF:000993', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(83591, NULL, 'G3DSA:3.40.50.620:FF:000177', NULL, NULL, 'probable receptor-like serine/threonine-protein kinase At5g57670', NULL, NULL, NULL, NULL, NULL, 4),
(83592, NULL, 'G3DSA:3.60.40.10:FF:000258', NULL, NULL, 'Protein phosphatase 1H', NULL, NULL, NULL, NULL, NULL, 4),
(83593, NULL, 'G3DSA:3.30.930.10:FF:000349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83594, NULL, 'G3DSA:1.20.1070.10:FF:001826', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83595, NULL, 'G3DSA:3.30.230.70:FF:000022', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase 2 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(83596, NULL, 'G3DSA:1.20.120.430:FF:000007', NULL, NULL, 'tRNA modification GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(83597, NULL, 'G3DSA:1.10.510.10:FF:003062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83598, NULL, 'G3DSA:3.40.50.300:FF:002728', NULL, NULL, 'ATPase family AAA domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(83599, NULL, 'G3DSA:1.50.40.10:FF:000128', NULL, NULL, 'Solute carrier family 25 member 48', NULL, NULL, NULL, NULL, NULL, 4),
(83600, NULL, 'G3DSA:3.40.30.10:FF:000775', NULL, NULL, 'Hydroperoxy fatty acid reductase gpx2', NULL, NULL, NULL, NULL, NULL, 4),
(83601, NULL, 'G3DSA:1.10.287.470:FF:000015', NULL, NULL, 'Multidrug efflux RND membrane fusion protein MexE', NULL, NULL, NULL, NULL, NULL, 4),
(83602, NULL, 'G3DSA:3.40.50.1820:FF:001811', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(83603, NULL, 'G3DSA:2.40.30.170:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83604, NULL, 'G3DSA:3.10.20.90:FF:000114', NULL, NULL, '40S ribosomal protein S30', NULL, NULL, NULL, NULL, NULL, 4),
(83605, NULL, 'G3DSA:1.20.58.2220:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83606, NULL, 'G3DSA:3.30.160.60:FF:004936', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83607, NULL, 'G3DSA:1.10.510.10:FF:001881', NULL, NULL, 'ephrin type-A receptor 6-like', NULL, NULL, NULL, NULL, NULL, 4),
(83608, NULL, 'G3DSA:1.20.140.10:FF:000063', NULL, NULL, 'FMNH2-dependent monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(83609, NULL, 'G3DSA:2.60.120.650:FF:000046', NULL, NULL, 'JmjC domain-containing protein D', NULL, NULL, NULL, NULL, NULL, 4),
(83610, NULL, 'G3DSA:1.20.1250.20:FF:001220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83611, NULL, 'G3DSA:2.60.40.10:FF:000064', NULL, NULL, 'Contactin 1', NULL, NULL, NULL, NULL, NULL, 4),
(83612, NULL, 'G3DSA:3.30.565.10:FF:000091', NULL, NULL, 'Sensor histidine kinase/response regulator EvgS', NULL, NULL, NULL, NULL, NULL, 4),
(83613, NULL, 'G3DSA:2.60.120.620:FF:000150', NULL, NULL, 'Prolyl 4-hydroxylase alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83614, NULL, 'G3DSA:3.40.50.300:FF:003897', NULL, NULL, 'Endonuclease MutS2', NULL, NULL, NULL, NULL, NULL, 4),
(83615, NULL, 'G3DSA:3.30.460.10:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83616, NULL, 'G3DSA:4.10.280.10:FF:000238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83617, NULL, 'G3DSA:3.40.50.150:FF:001177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83618, NULL, 'G3DSA:1.10.510.10:FF:003938', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83619, NULL, 'G3DSA:1.10.210.20:FF:000001', NULL, NULL, '1H-3-hydroxy-4-oxoquinaldine 2,4-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(83620, NULL, 'G3DSA:1.10.20.120:FF:000013', NULL, NULL, 'Ribonuclease H2, subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(83621, NULL, 'G3DSA:1.25.10.10:FF:001000', NULL, NULL, 'Armadillo repeat containing 8', NULL, NULL, NULL, NULL, NULL, 4),
(83622, NULL, 'G3DSA:3.80.10.10:FF:001256', NULL, NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(83623, NULL, 'G3DSA:3.30.530.20:FF:000069', NULL, NULL, 'Protein CBG22145', NULL, NULL, NULL, NULL, NULL, 4),
(83624, NULL, 'G3DSA:1.20.1250.20:FF:001017', NULL, NULL, 'Os08g0527700 protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(83625, NULL, 'G3DSA:1.25.40.10:FF:003098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83626, NULL, 'G3DSA:3.10.450.580:FF:000020', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(83627, NULL, 'G3DSA:3.40.50.2300:FF:001444', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83628, NULL, 'G3DSA:1.20.1260.60:FF:000018', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(83629, NULL, 'G3DSA:3.80.10.10:FF:002161', NULL, NULL, 'immunoglobulin superfamily member 10-like', NULL, NULL, NULL, NULL, NULL, 4),
(83630, NULL, 'G3DSA:3.40.50.2000:FF:000455', NULL, NULL, 'LPS 1,2-N-acetylglucosaminetransferase', NULL, NULL, NULL, NULL, NULL, 4),
(83631, NULL, 'G3DSA:2.60.40.10:FF:004015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83632, NULL, 'G3DSA:3.30.2160.10:FF:000003', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(83633, NULL, 'G3DSA:3.40.50.11660:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83634, NULL, 'G3DSA:1.25.40.10:FF:004115', NULL, NULL, 'U3 small nucleolar RNA-associated protein 6 homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(83635, NULL, 'G3DSA:2.130.10.10:FF:004903', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83636, NULL, 'G3DSA:2.120.10.30:FF:000284', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM71', NULL, NULL, NULL, NULL, NULL, 4),
(83637, NULL, 'G3DSA:3.40.50.300:FF:007904', NULL, NULL, 'Teg12', NULL, NULL, NULL, NULL, NULL, 4),
(83638, NULL, 'G3DSA:2.40.180.10:FF:000012', NULL, NULL, 'Lipoxygenase homology domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(83639, NULL, 'G3DSA:1.25.10.10:FF:002753', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83640, NULL, 'G3DSA:2.40.50.140:FF:000166', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(83641, NULL, 'G3DSA:1.10.510.10:FF:004490', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83642, NULL, 'G3DSA:3.40.50.10190:FF:000128', NULL, NULL, 'Mutagen-sensitive 101', NULL, NULL, NULL, NULL, NULL, 4),
(83643, NULL, 'G3DSA:3.30.310.270:FF:000004', NULL, NULL, 'Defective in germ line development protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(83644, NULL, 'G3DSA:1.10.565.10:FF:000035', NULL, NULL, 'Nuclear hormone receptor HR96', NULL, NULL, NULL, NULL, NULL, 4),
(83645, NULL, 'G3DSA:1.10.10.10:FF:000948', NULL, NULL, 'COP9 signalosome complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(83646, NULL, 'G3DSA:3.30.40.10:FF:001518', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(83647, NULL, 'G3DSA:3.30.1010.10:FF:000021', NULL, NULL, 'Phosphatidylinositol 4-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(83648, NULL, 'G3DSA:1.10.10.60:FF:000177', NULL, NULL, 'Homeobox protein DBX1', NULL, NULL, NULL, NULL, NULL, 4),
(83649, NULL, 'G3DSA:2.60.40.150:FF:000269', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(83650, NULL, 'G3DSA:2.40.170.20:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83651, NULL, 'G3DSA:3.30.70.330:FF:002305', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83652, NULL, 'G3DSA:2.130.10.10:FF:000188', NULL, NULL, 'striatin-3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(83653, NULL, 'G3DSA:3.30.160.60:FF:002019', NULL, NULL, 'zinc finger protein 263-like', NULL, NULL, NULL, NULL, NULL, 4),
(83654, NULL, 'G3DSA:3.30.70.330:FF:001788', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83655, NULL, 'G3DSA:3.10.20.90:FF:000586', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83656, NULL, 'G3DSA:3.30.365.10:FF:000024', NULL, NULL, 'Xanthine dehydrogenase, molybdenum binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(83657, NULL, 'G3DSA:2.20.70.10:FF:000073', NULL, NULL, 'Rho GTPase activating protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(83658, NULL, 'G3DSA:2.60.40.790:FF:000141', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(83659, NULL, 'G3DSA:3.60.21.10:FF:000074', NULL, NULL, 'UDP-2,3-diacylglucosamine hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(83660, NULL, 'G3DSA:1.20.1070.10:FF:000545', NULL, NULL, 'Serpentine Receptor, class O (Opsin)', NULL, NULL, NULL, NULL, NULL, 4),
(83661, NULL, 'G3DSA:2.10.25.10:FF:001508', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83662, NULL, 'G3DSA:2.130.10.10:FF:002958', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1', NULL, NULL, NULL, NULL, NULL, 4),
(83663, NULL, 'G3DSA:3.30.70.1060:FF:000001', NULL, NULL, 'YciI family protein', NULL, NULL, NULL, NULL, NULL, 4),
(83664, NULL, 'G3DSA:3.30.70.1230:FF:000221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83665, NULL, 'G3DSA:3.40.50.1820:FF:000530', NULL, NULL, 'Probable acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(83666, NULL, 'G3DSA:2.40.50.120:FF:000008', NULL, NULL, 'agrin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(83667, NULL, 'G3DSA:1.20.80.10:FF:000025', NULL, NULL, 'pleckstrin homology domain-containing family H member 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(83668, NULL, 'G3DSA:2.170.150.80:FF:000023', NULL, NULL, 'NAC (No Apical Meristem) domain transcriptional regulator superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(83669, NULL, 'G3DSA:1.25.40.10:FF:004790', NULL, NULL, 'Superkiller protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(83670, NULL, 'G3DSA:2.40.50.100:FF:000002', NULL, NULL, 'Efflux transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(83671, NULL, 'G3DSA:3.30.1230.20:FF:000006', NULL, NULL, '40S ribosomal protein S21', NULL, NULL, NULL, NULL, NULL, 4),
(83672, NULL, 'G3DSA:1.10.10.10:FF:001853', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(83673, NULL, 'G3DSA:2.130.10.10:FF:001677', NULL, NULL, 'WD repeat-containing protein 16, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83674, NULL, 'G3DSA:1.10.8.10:FF:000352', NULL, NULL, 'Uncharacterized protein C06E1.9', NULL, NULL, NULL, NULL, NULL, 4),
(83675, NULL, 'G3DSA:3.30.450.200:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83676, NULL, 'G3DSA:3.10.110.10:FF:000354', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83677, NULL, 'G3DSA:2.60.120.920:FF:000211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83678, NULL, 'G3DSA:3.30.200.20:FF:000292', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM1', NULL, NULL, NULL, NULL, NULL, 4),
(83679, NULL, 'G3DSA:1.10.510.10:FF:000448', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(83680, NULL, 'G3DSA:1.10.150.240:FF:000071', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(83681, NULL, 'G3DSA:2.30.29.30:FF:001028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83682, NULL, 'G3DSA:1.20.58.670:FF:000006', NULL, NULL, 'RINT1-like protein MAG2', NULL, NULL, NULL, NULL, NULL, 4),
(83683, NULL, 'G3DSA:2.130.10.10:FF:000749', NULL, NULL, 'Nucleoporin 43', NULL, NULL, NULL, NULL, NULL, 4),
(83684, NULL, 'G3DSA:3.40.50.300:FF:001952', NULL, NULL, 'ATP-dependent RNA helicase RHLE', NULL, NULL, NULL, NULL, NULL, 4),
(83685, NULL, 'G3DSA:3.40.50.720:FF:000061', NULL, NULL, 'Formate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(83686, NULL, 'G3DSA:3.40.50.300:FF:004414', NULL, NULL, 'Nonstructural protein', NULL, NULL, NULL, NULL, NULL, 4),
(83687, NULL, 'G3DSA:1.50.10.10:FF:000244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83688, NULL, 'G3DSA:1.10.238.10:FF:000348', NULL, NULL, 'EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(83689, NULL, 'G3DSA:3.20.20.80:FF:000588', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83690, NULL, 'G3DSA:3.50.50.60:FF:001504', NULL, NULL, 'Lysine (K)-specific demethylase 1a', NULL, NULL, NULL, NULL, NULL, 4),
(83691, NULL, 'G3DSA:1.20.1070.10:FF:001265', NULL, NULL, 'Pepsin-like aspartic protease A1', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(83692, NULL, 'G3DSA:3.40.1010.10:FF:000007', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase I', NULL, NULL, NULL, NULL, NULL, 4),
(83693, NULL, 'G3DSA:1.10.8.20:FF:000001', NULL, NULL, 'Alpha-tocopherol transfer protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(83694, NULL, 'G3DSA:2.40.160.210:FF:000011', NULL, NULL, 'Acyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(83695, NULL, 'G3DSA:2.60.120.200:FF:000496', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83696, NULL, 'G3DSA:1.25.10.10:FF:001825', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(83697, NULL, 'G3DSA:3.30.710.10:FF:000013', NULL, NULL, 'BTB/POZ domain-containing adapter for CUL3-mediated RhoA degradation protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(83698, NULL, 'G3DSA:3.40.50.720:FF:001342', NULL, NULL, '3-ketoacyl-ACP reductase', NULL, NULL, NULL, NULL, NULL, 4),
(83699, NULL, 'G3DSA:1.20.58.60:FF:000011', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(83700, NULL, 'G3DSA:3.30.1370.50:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83701, NULL, 'G3DSA:1.10.10.10:FF:002073', NULL, NULL, 'Transcriptional regulator MexT', NULL, NULL, NULL, NULL, NULL, 4),
(83702, NULL, 'G3DSA:3.20.20.140:FF:000453', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(83703, NULL, 'G3DSA:2.60.40.2860:FF:000006', NULL, NULL, '6-cysteine protein', NULL, NULL, NULL, NULL, NULL, 4),
(83704, NULL, 'G3DSA:3.90.70.10:FF:000404', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(83705, NULL, 'G3DSA:2.60.120.10:FF:000105', NULL, NULL, 'CAMKK/CAMKK-META protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(83706, NULL, 'G3DSA:3.30.505.10:FF:000227', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83707, NULL, 'G3DSA:3.30.60.290:FF:000003', NULL, NULL, 'DNA repair protein RAD4', NULL, NULL, NULL, NULL, NULL, 4),
(83708, NULL, 'G3DSA:1.25.40.10:FF:000372', NULL, NULL, 'Tetratricopeptide repeat domain 26', NULL, NULL, NULL, NULL, NULL, 4),
(83709, NULL, 'G3DSA:3.40.50.720:FF:002270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83710, NULL, 'G3DSA:3.40.50.1820:FF:000794', NULL, NULL, 'Putative hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(83711, NULL, 'G3DSA:3.90.1150.10:FF:000141', NULL, NULL, 'Kynurenine--oxoglutarate transaminase 1', NULL, NULL, NULL, NULL, NULL, 4),
(83712, NULL, 'G3DSA:3.40.50.360:FF:000110', NULL, NULL, 'NAD(P)H dehydrogenase (Quinone) FQR1', NULL, NULL, NULL, NULL, NULL, 4),
(83713, NULL, 'G3DSA:1.25.40.20:FF:000021', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(83714, NULL, 'G3DSA:2.20.25.10:FF:000030', NULL, NULL, 'DNA-directed RNA polymerase II subunit RPB9', NULL, NULL, NULL, NULL, NULL, 4),
(83715, NULL, 'G3DSA:1.10.418.10:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83716, NULL, 'G3DSA:1.10.287.1490:FF:000069', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(83717, NULL, 'G3DSA:3.30.420.40:FF:000634', NULL, NULL, 'Putative heat shock 70 kDa protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(83718, NULL, 'G3DSA:2.10.25.10:FF:000227', NULL, NULL, 'Matrilin 4', NULL, NULL, NULL, NULL, NULL, 4),
(83719, NULL, 'G3DSA:1.10.418.10:FF:000093', NULL, NULL, 'GAS2-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(83720, NULL, 'G3DSA:3.40.630.10:FF:000459', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(83721, NULL, 'G3DSA:1.10.10.750:FF:000048', NULL, NULL, 'Ecotropic viral integration site 5-like', NULL, NULL, NULL, NULL, NULL, 4),
(83722, NULL, 'G3DSA:1.10.3210.10:FF:000115', NULL, NULL, 'AGAP012646-PA', NULL, NULL, NULL, NULL, NULL, 4),
(83723, NULL, 'G3DSA:3.40.50.300:FF:006623', NULL, NULL, 'Uncharacterized protein, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(83724, NULL, 'G3DSA:1.10.533.10:FF:000017', NULL, NULL, 'caspase-8 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(83725, NULL, 'G3DSA:1.10.472.10:FF:000347', NULL, NULL, 'Os02g0800500 protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(83726, NULL, 'G3DSA:3.90.190.20:FF:000074', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(83727, NULL, 'G3DSA:1.10.287.70:FF:000507', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83728, NULL, 'G3DSA:3.40.50.300:FF:001391', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(83729, NULL, 'G3DSA:3.30.470.30:FF:000016', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(83730, NULL, 'G3DSA:2.40.50.140:FF:001094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83731, NULL, 'G3DSA:1.10.1420.10:FF:000041', NULL, NULL, 'Msh2p', NULL, NULL, NULL, NULL, NULL, 4),
(83732, NULL, 'G3DSA:3.90.190.10:FF:000537', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83733, NULL, 'G3DSA:3.40.50.150:FF:000396', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(83734, NULL, 'G3DSA:1.20.272.10:FF:000049', NULL, NULL, 'Replication factor C subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(83735, NULL, 'G3DSA:2.60.40.10:FF:004279', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83736, NULL, 'G3DSA:3.40.50.300:FF:006770', NULL, NULL, 'Exopolysaccharide biosynthesis domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(83737, NULL, 'G3DSA:2.40.50.1000:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83738, NULL, 'G3DSA:3.20.20.140:FF:000306', NULL, NULL, 'Sodium/hydrogen exchanger 2', NULL, NULL, NULL, NULL, NULL, 4),
(83739, NULL, 'G3DSA:2.60.40.60:FF:000062', NULL, NULL, 'Calsyntenin 3', NULL, NULL, NULL, NULL, NULL, 4),
(83740, NULL, 'G3DSA:1.10.630.10:FF:000367', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83741, NULL, 'G3DSA:1.25.40.10:FF:005043', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(83742, NULL, 'G3DSA:2.60.40.10:FF:001553', NULL, NULL, 'Fas apoptotic inhibitory molecule 3', NULL, NULL, NULL, NULL, NULL, 4),
(83743, NULL, 'G3DSA:3.60.130.10:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83744, NULL, 'G3DSA:3.40.630.170:FF:000004', NULL, NULL, 'Glycylpeptide N-tetradecanoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(83745, NULL, 'G3DSA:3.30.160.60:FF:002166', NULL, NULL, 'Histone H4 transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(83746, NULL, 'G3DSA:2.60.40.10:FF:004987', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83747, NULL, 'G3DSA:2.60.40.60:FF:000438', NULL, NULL, 'Dachsous, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(83748, NULL, 'G3DSA:3.40.50.1010:FF:000113', NULL, NULL, 'DNA repair protein RAD2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83749, NULL, 'G3DSA:3.40.30.10:FF:000511', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(83750, NULL, 'G3DSA:2.60.40.2300:FF:000007', NULL, NULL, 'Neutral ceramidase B', NULL, NULL, NULL, NULL, NULL, 4),
(83751, NULL, 'G3DSA:3.40.50.150:FF:000249', NULL, NULL, 'tRNA (Cytosine-5-)-methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83752, NULL, 'G3DSA:1.25.10.10:FF:002192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83753, NULL, 'G3DSA:2.130.10.10:FF:005572', NULL, NULL, 'Intraflagellar transport 140 homolog (Chlamydomonas)', NULL, NULL, NULL, NULL, NULL, 4),
(83754, NULL, 'G3DSA:1.20.144.10:FF:000027', NULL, NULL, 'Inositol phosphorylceramide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(83755, NULL, 'G3DSA:3.30.710.10:FF:000277', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(83756, NULL, 'G3DSA:1.10.238.10:FF:000495', NULL, NULL, 'Protein CBR-CEX-1', NULL, NULL, NULL, NULL, NULL, 4),
(83757, NULL, 'G3DSA:2.60.120.590:FF:000067', NULL, NULL, 'Os03g0816500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(83758, NULL, 'G3DSA:2.40.70.10:FF:000555', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83759, NULL, 'G3DSA:3.30.160.20:FF:000057', NULL, NULL, 'Double-stranded RNA-binding protein Staufen homolog 2', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(83760, NULL, 'G3DSA:3.30.40.10:FF:001670', NULL, NULL, 'E3 ubiquitin-protein ligase PRT1', NULL, NULL, NULL, NULL, NULL, 4),
(83761, NULL, 'G3DSA:3.30.160.60:FF:004375', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83762, NULL, 'G3DSA:4.10.400.10:FF:000327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83763, NULL, 'G3DSA:1.10.510.10:FF:004343', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83764, NULL, 'G3DSA:3.40.395.10:FF:000035', NULL, NULL, 'Putative ankyrin repeat domain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(83765, NULL, 'G3DSA:3.40.140.10:FF:000231', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(83766, NULL, 'G3DSA:1.20.1510.10:FF:000001', NULL, NULL, 'Ferrous-iron efflux pump FieF', NULL, NULL, NULL, NULL, NULL, 4),
(83767, NULL, 'G3DSA:2.30.230.10:FF:000002', NULL, NULL, 'Vitellogenin 7', NULL, NULL, NULL, NULL, NULL, 4),
(83768, NULL, 'G3DSA:2.30.310.10:FF:000003', NULL, NULL, 'Zinc knuckle domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(83769, NULL, 'G3DSA:3.40.1410.10:FF:000032', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(83770, NULL, 'G3DSA:1.25.40.20:FF:000285', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(83771, NULL, 'G3DSA:2.30.29.30:FF:000960', NULL, NULL, 'Drosophila SOS homolog', NULL, NULL, NULL, NULL, NULL, 4),
(83772, NULL, 'G3DSA:3.30.40.10:FF:002070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83773, NULL, 'G3DSA:2.60.40.150:FF:000680', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(83774, NULL, 'G3DSA:3.40.190.10:FF:000234', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(83775, NULL, 'G3DSA:2.60.200.20:FF:000204', NULL, NULL, 'Serine/threonine protein kinase-43', NULL, NULL, NULL, NULL, NULL, 4),
(83776, NULL, 'G3DSA:3.30.420.40:FF:000073', NULL, NULL, 'Rhamnulokinase', NULL, NULL, NULL, NULL, NULL, 4),
(83777, NULL, 'G3DSA:3.30.1510.10:FF:000014', NULL, NULL, 'Formate-dihydrofolate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(83778, NULL, 'G3DSA:3.40.605.10:FF:000007', NULL, NULL, 'NAD/NADP-dependent betaine aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(83779, NULL, 'G3DSA:3.30.160.60:FF:006061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83780, NULL, 'G3DSA:3.40.30.10:FF:001028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83781, NULL, 'G3DSA:1.10.1200.270:FF:000017', NULL, NULL, 'Os06g0243801 protein', NULL, NULL, NULL, NULL, NULL, 4),
(83782, NULL, 'G3DSA:3.40.1380.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83783, NULL, 'G3DSA:3.40.50.300:FF:006062', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(83784, NULL, 'G3DSA:3.30.230.10:FF:000167', NULL, NULL, 'Galactokinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(83785, NULL, 'G3DSA:2.60.270.20:FF:000001', NULL, NULL, 'DELTA-actitoxin-Afr1a', NULL, NULL, NULL, NULL, NULL, 4),
(83786, NULL, 'G3DSA:3.40.50.150:FF:001121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83787, NULL, 'G3DSA:3.10.20.90:FF:000822', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83788, NULL, 'G3DSA:1.10.510.10:FF:002134', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(83789, NULL, 'G3DSA:2.40.10.10:FF:000023', NULL, NULL, 'Hepatocyte growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(83790, NULL, 'G3DSA:1.20.58.1120:FF:000005', NULL, NULL, 'Dynein, axonemal, heavy chain 12', NULL, NULL, NULL, NULL, NULL, 4),
(83791, NULL, 'G3DSA:3.90.550.50:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83792, NULL, 'G3DSA:1.25.40.10:FF:004138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83793, NULL, 'G3DSA:3.30.1490.180:FF:000019', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(83794, NULL, 'G3DSA:3.60.10.10:FF:000054', NULL, NULL, 'Exodeoxyribonuclease III', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(83795, NULL, 'G3DSA:3.40.50.12780:FF:000164', NULL, NULL, 'Long-chain fatty acid transport protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(83796, NULL, 'G3DSA:3.30.420.610:FF:000007', NULL, NULL, 'Tudor domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(83797, NULL, 'G3DSA:1.10.630.10:FF:000636', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83798, NULL, 'G3DSA:2.110.10.10:FF:000031', NULL, NULL, 'matrix metalloproteinase-21-like', NULL, NULL, NULL, NULL, NULL, 4),
(83799, NULL, 'G3DSA:2.60.40.10:FF:000480', NULL, NULL, 'Collagen, type XII, alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(83800, NULL, 'G3DSA:3.40.50.300:FF:001508', NULL, NULL, 'Small GTP-binding protein Rab28, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83801, NULL, 'G3DSA:1.10.10.60:FF:000154', NULL, NULL, 'Transcription factor SRM1', NULL, NULL, NULL, NULL, NULL, 4),
(83802, NULL, 'G3DSA:1.10.287.70:FF:000682', NULL, NULL, 'Hypothetical membrane protein, conserved', NULL, NULL, NULL, NULL, NULL, 4),
(83803, NULL, 'G3DSA:3.90.1170.30:FF:000007', NULL, NULL, 'Thymidine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(83804, NULL, 'G3DSA:1.10.10.60:FF:000210', NULL, NULL, 'homeobox protein goosecoid', NULL, NULL, NULL, NULL, NULL, 4),
(83805, NULL, 'G3DSA:3.30.160.60:FF:002727', NULL, NULL, 'Unplaced genomic scaffold supercont1.56, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(83806, NULL, 'G3DSA:1.10.418.10:FF:000177', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(83807, NULL, 'G3DSA:1.20.58.60:FF:000308', NULL, NULL, 'microtubule-actin cross-linking factor 1 isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(83808, NULL, 'G3DSA:3.90.180.10:FF:000183', NULL, NULL, 'Protein CBG23238', NULL, NULL, NULL, NULL, NULL, 4),
(83809, NULL, 'G3DSA:3.30.70.330:FF:000916', NULL, NULL, 'Rna15p', NULL, NULL, NULL, NULL, NULL, 4),
(83810, NULL, 'G3DSA:3.40.50.720:FF:002062', NULL, NULL, '3beta-hydroxysteroid-dehydrogenase/decarboxylase isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(83811, NULL, 'G3DSA:2.130.10.10:FF:004403', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83812, NULL, 'G3DSA:4.10.640.40:FF:000005', NULL, NULL, 'Cytoplasmic polyadenylation element-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(83813, NULL, 'G3DSA:3.10.110.10:FF:000090', NULL, NULL, 'Ubiquitin-conjugating enzyme E2-17 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(83814, NULL, 'G3DSA:1.10.287.70:FF:000187', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(83815, NULL, 'G3DSA:1.20.58.60:FF:000836', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83816, NULL, 'G3DSA:1.25.10.10:FF:003006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83817, NULL, 'G3DSA:2.40.70.10:FF:000471', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83818, NULL, 'G3DSA:1.25.10.10:FF:002545', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83819, NULL, 'G3DSA:3.30.160.60:FF:004291', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83820, NULL, 'G3DSA:3.80.10.10:FF:002661', NULL, NULL, 'Receptor-like protein kinase HSL1', NULL, NULL, NULL, NULL, NULL, 4),
(83821, NULL, 'G3DSA:3.40.50.300:FF:007343', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83822, NULL, 'G3DSA:2.10.70.10:FF:000303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83823, NULL, 'G3DSA:1.10.238.10:FF:000612', NULL, NULL, 'Sodium/calcium exchanger NCL', NULL, NULL, NULL, NULL, NULL, 4),
(83824, NULL, 'G3DSA:2.60.40.10:FF:000041', NULL, NULL, 'ephrin type-A receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(83825, NULL, 'G3DSA:1.25.10.10:FF:002017', NULL, NULL, 'Armadillo repeat-containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(83826, NULL, 'G3DSA:3.30.40.10:FF:001018', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(83827, NULL, 'G3DSA:1.25.40.10:FF:003626', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g63130, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(83828, NULL, 'G3DSA:2.60.40.10:FF:004695', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83829, NULL, 'G3DSA:2.60.40.60:FF:001051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83830, NULL, 'G3DSA:1.20.1250.20:FF:000528', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(83831, NULL, 'G3DSA:3.40.50.2000:FF:000539', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83832, NULL, 'G3DSA:3.30.200.20:FF:001281', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83833, NULL, 'G3DSA:2.60.40.150:FF:000533', NULL, NULL, 'Protein unc-13 homolog 4B', NULL, NULL, NULL, NULL, NULL, 4),
(83834, NULL, 'G3DSA:3.80.10.10:FF:003173', NULL, NULL, 'LD20162p', NULL, NULL, NULL, NULL, NULL, 4),
(83835, NULL, 'G3DSA:3.40.50.150:FF:001593', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83836, NULL, 'G3DSA:3.30.40.10:FF:000506', NULL, NULL, 'Acyl-CoA N-acyltransferase with RING/FYVE/PHD-type zinc finger domain', NULL, NULL, NULL, NULL, NULL, 4),
(83837, NULL, 'G3DSA:3.30.450.20:FF:000012', NULL, NULL, 'Calcium channel, voltage-dependent, alpha2/delta subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(83838, NULL, 'G3DSA:3.40.1810.10:FF:000017', NULL, NULL, 'PISTILLATA-like MADS-box transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(83839, NULL, 'G3DSA:1.10.3370.10:FF:000008', NULL, NULL, 'Preprotein translocase subunit SCY2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(83840, NULL, 'G3DSA:2.60.120.380:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83841, NULL, 'G3DSA:3.30.1490.100:FF:000013', NULL, NULL, 'DNApol-iota, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(83842, NULL, 'G3DSA:2.130.10.10:FF:000660', NULL, NULL, 'U3 snoRNP protein', NULL, NULL, NULL, NULL, NULL, 4),
(83843, NULL, 'G3DSA:3.30.9.10:FF:000176', NULL, NULL, 'L-2-hydroxyglutarate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(83844, NULL, 'G3DSA:2.130.10.10:FF:002582', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(83845, NULL, 'G3DSA:1.20.1250.20:FF:001192', NULL, NULL, 'Putative integral membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(83846, NULL, 'G3DSA:2.40.30.10:FF:000081', NULL, NULL, 'Oxidoreductase with FAD/NAD(P)-binding domain', NULL, NULL, NULL, NULL, NULL, 4),
(83847, NULL, 'G3DSA:3.40.50.880:FF:000204', NULL, NULL, 'Isonitrile hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(83848, NULL, 'G3DSA:3.30.70.330:FF:001052', NULL, NULL, 'Ribonucleoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(83849, NULL, 'G3DSA:1.10.533.10:FF:000309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83850, NULL, 'G3DSA:1.10.10.10:FF:000572', NULL, NULL, 'Transcriptional regulator, Crp/Fnr family', NULL, NULL, NULL, NULL, NULL, 4),
(83851, NULL, 'G3DSA:3.40.50.12550:FF:000005', NULL, NULL, 'Putative ubiquitin-activating enzyme e1', NULL, NULL, NULL, NULL, NULL, 4),
(83852, NULL, 'G3DSA:3.30.450.40:FF:000018', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(83853, NULL, 'G3DSA:1.20.1560.10:FF:000009', NULL, NULL, 'ABC transporter B family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(83854, NULL, 'G3DSA:1.10.1170.10:FF:000004', NULL, NULL, 'Baculoviral IAP repeat-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(83855, NULL, 'G3DSA:3.30.70.270:FF:000084', NULL, NULL, 'REV1, polymerase (DNA directed)', NULL, NULL, NULL, NULL, NULL, 4),
(83856, NULL, 'G3DSA:3.40.50.1440:FF:000068', NULL, NULL, 'Tubulin gamma-2 chain', NULL, NULL, NULL, NULL, NULL, 4),
(83857, NULL, 'G3DSA:1.10.510.10:FF:001145', NULL, NULL, 'Protein kinase KNS1', NULL, NULL, NULL, NULL, NULL, 4),
(83858, NULL, 'G3DSA:3.40.50.300:FF:004061', NULL, NULL, 'Probable ATP-dependent RNA helicase spindle-E', NULL, NULL, NULL, NULL, NULL, 4),
(83859, NULL, 'G3DSA:3.40.50.1240:FF:000013', NULL, NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(83860, NULL, 'G3DSA:3.10.129.10:FF:000200', NULL, NULL, 'Thioesterase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(83861, NULL, 'G3DSA:1.20.58.1470:FF:000003', NULL, NULL, 'Fat mass and obesity-associated', NULL, NULL, NULL, NULL, NULL, 4),
(83862, NULL, 'G3DSA:3.30.70.2280:FF:000002', NULL, NULL, 'Nucleolar RNA helicase 2', NULL, NULL, NULL, NULL, NULL, 4),
(83863, NULL, 'G3DSA:2.60.40.2030:FF:000022', NULL, NULL, 'Adhesion G-protein coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(83864, NULL, 'G3DSA:3.90.1170.10:FF:000001', NULL, NULL, '50S ribosomal protein L16', NULL, NULL, NULL, NULL, NULL, 4),
(83865, NULL, 'G3DSA:1.20.58.1880:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83866, NULL, 'G3DSA:2.70.170.10:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83867, NULL, 'G3DSA:1.10.10.10:FF:000095', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(83868, NULL, 'G3DSA:3.30.70.330:FF:001905', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83869, NULL, 'G3DSA:1.25.10.10:FF:002489', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(83870, NULL, 'G3DSA:2.130.10.10:FF:004875', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83871, NULL, 'G3DSA:1.10.510.10:FF:004074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83872, NULL, 'G3DSA:2.60.120.260:FF:000171', NULL, NULL, 'Beta-galactosidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(83873, NULL, 'G3DSA:3.30.70.1230:FF:000249', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(83874, NULL, 'G3DSA:1.10.630.10:FF:000159', NULL, NULL, 'Isotrichodermin C-15 hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(83875, NULL, 'G3DSA:3.30.200.20:FF:001129', NULL, NULL, 'Cell division control protein 2 like', NULL, NULL, NULL, NULL, NULL, 4),
(83876, NULL, 'G3DSA:2.40.50.140:FF:000874', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83877, NULL, 'G3DSA:2.60.120.10:FF:000369', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(83878, NULL, 'G3DSA:2.10.110.10:FF:000037', NULL, NULL, 'LIM domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(83879, NULL, 'G3DSA:3.10.50.40:FF:000152', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(83880, NULL, 'G3DSA:3.40.50.1820:FF:001250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83881, NULL, 'G3DSA:3.80.10.10:FF:000300', NULL, NULL, 'Relaxin family peptide receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(83882, NULL, 'G3DSA:3.40.50.300:FF:000199', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(83883, NULL, 'G3DSA:3.30.530.20:FF:000013', NULL, NULL, 'Abscisic acid receptor PYL9', NULL, NULL, NULL, NULL, NULL, 4),
(83884, NULL, 'G3DSA:2.60.40.10:FF:004751', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83885, NULL, 'G3DSA:3.40.50.300:FF:008276', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(83886, NULL, 'G3DSA:4.10.240.10:FF:000056', NULL, NULL, 'Transcription factor PDR1', NULL, NULL, NULL, NULL, NULL, 4),
(83887, NULL, 'G3DSA:2.60.200.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83888, NULL, 'G3DSA:3.40.50.1260:FF:000019', NULL, NULL, 'Phosphoglycerate kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(83889, NULL, 'G3DSA:1.10.472.80:FF:000031', NULL, NULL, 'TBC1 domain family, member 32', NULL, NULL, NULL, NULL, NULL, 4),
(83890, NULL, 'G3DSA:1.10.246.20:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83891, NULL, 'G3DSA:3.30.780.10:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83892, NULL, 'G3DSA:3.30.160.60:FF:000013', NULL, NULL, 'Putative zinc finger E-box-binding homeobox 2', NULL, NULL, NULL, NULL, NULL, 4),
(83893, NULL, 'G3DSA:3.40.640.10:FF:000488', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83894, NULL, 'G3DSA:2.10.110.10:FF:000161', NULL, NULL, 'MIT domain containing protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(83895, NULL, 'G3DSA:3.90.70.10:FF:000551', NULL, NULL, 'Cysteine protease 1', NULL, NULL, NULL, NULL, NULL, 4),
(83896, NULL, 'G3DSA:1.25.70.10:FF:000048', NULL, NULL, 'Os11g0206300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(83897, NULL, 'G3DSA:3.40.190.80:FF:000035', NULL, NULL, 'Inositol monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(83898, NULL, 'G3DSA:3.30.1740.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83899, NULL, 'G3DSA:3.30.2310.10:FF:000004', NULL, NULL, 'Nef-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(83900, NULL, 'G3DSA:1.25.40.90:FF:000053', NULL, NULL, 'CTD kinase subunit gamma, variant', NULL, NULL, NULL, NULL, NULL, 4),
(83901, NULL, 'G3DSA:1.25.40.10:FF:003362', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At3g16890, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(83902, NULL, 'G3DSA:2.40.330.10:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83903, NULL, 'G3DSA:2.30.180.10:FF:000065', NULL, NULL, 'Transforming growth factor-beta-induced protein Ig-H3', NULL, NULL, NULL, NULL, NULL, 4),
(83904, NULL, 'G3DSA:3.40.50.300:FF:005398', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(83905, NULL, 'G3DSA:3.40.50.1820:FF:000558', NULL, NULL, 'Monoglyceride lipase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83906, NULL, 'G3DSA:3.80.10.10:FF:000772', NULL, NULL, 'Extracellular matrix protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(83907, NULL, 'G3DSA:3.40.50.300:FF:004853', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83908, NULL, 'G3DSA:1.10.30.10:FF:000039', NULL, NULL, 'protein CRABS CLAW isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(83909, NULL, 'G3DSA:3.30.505.10:FF:000204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83910, NULL, 'G3DSA:2.70.160.11:FF:000067', NULL, NULL, 'Protein arginine N-methyltransferase 7', NULL, NULL, NULL, NULL, NULL, 4),
(83911, NULL, 'G3DSA:2.130.10.10:FF:000221', NULL, NULL, 'gem-associated protein 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(83912, NULL, 'G3DSA:2.10.220.10:FF:000219', NULL, NULL, 'Furin2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83913, NULL, 'G3DSA:2.20.28.60:FF:000001', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(83914, NULL, 'G3DSA:2.60.40.10:FF:001289', NULL, NULL, 'Oncostatin-M-specific receptor subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(83915, NULL, 'G3DSA:1.10.10.10:FF:001437', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(83916, NULL, 'G3DSA:1.10.418.20:FF:000034', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(83917, NULL, 'G3DSA:1.10.510.10:FF:003438', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83918, NULL, 'G3DSA:1.10.287.2250:FF:000011', NULL, NULL, 'Papain family cysteine protease subfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(83919, NULL, 'G3DSA:3.30.160.60:FF:006145', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83920, NULL, 'G3DSA:1.25.40.10:FF:004290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83921, NULL, 'G3DSA:2.40.50.140:FF:000930', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83922, NULL, 'G3DSA:3.30.460.80:FF:000008', NULL, NULL, 'NADH:ubiquinone oxidoreductase ND9 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(83923, NULL, 'G3DSA:1.10.510.10:FF:002926', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83924, NULL, 'G3DSA:3.40.190.10:FF:000711', NULL, NULL, 'ABC transporter, periplasmic substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(83925, NULL, 'G3DSA:1.20.140.10:FF:000086', NULL, NULL, 'Acyl CoA DeHydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(83926, NULL, 'G3DSA:3.30.830.10:FF:000224', NULL, NULL, 'Pitrilysin metallepetidase 1 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(83927, NULL, 'G3DSA:2.70.70.10:FF:000048', NULL, NULL, 'PTS system, IIa component', NULL, NULL, NULL, NULL, NULL, 4),
(83928, NULL, 'G3DSA:2.60.40.790:FF:000202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(83929, NULL, 'G3DSA:4.10.60.10:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83930, NULL, 'G3DSA:3.90.79.10:FF:000132', NULL, NULL, 'DNA mismatch repair protein MutT', NULL, NULL, NULL, NULL, NULL, 4),
(83931, NULL, 'G3DSA:2.70.170.10:FF:000235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83932, NULL, 'G3DSA:3.40.720.10:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83933, NULL, 'G3DSA:3.30.300.90:FF:000005', NULL, NULL, 'BolA family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(83934, NULL, 'G3DSA:3.30.70.330:FF:001849', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83935, NULL, 'G3DSA:2.60.34.10:FF:000004', NULL, NULL, 'Heat shock protein SSB1', NULL, NULL, NULL, NULL, NULL, 4),
(83936, NULL, 'G3DSA:3.40.250.10:FF:000149', NULL, NULL, 'MBL fold metallo-hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(83937, NULL, 'G3DSA:1.10.287.1480:FF:000004', NULL, NULL, 'Ribosomal protein S14, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83938, NULL, 'G3DSA:3.40.30.10:FF:000275', NULL, NULL, 'Protein disulfide-isomerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83939, NULL, 'G3DSA:3.30.70.240:FF:000013', NULL, NULL, 'Translation elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(83940, NULL, 'G3DSA:1.10.150.420:FF:000001', NULL, NULL, 'Replicase polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(83941, NULL, 'G3DSA:3.30.1370.10:FF:000103', NULL, NULL, 'Pbp2p', NULL, NULL, NULL, NULL, NULL, 4),
(83942, NULL, 'G3DSA:3.30.1360.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83943, NULL, 'G3DSA:1.25.40.270:FF:000001', NULL, NULL, 'vacuolar protein sorting-associated protein VTA1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(83944, NULL, 'G3DSA:3.30.30.30:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83945, NULL, 'G3DSA:3.40.50.300:FF:002172', NULL, NULL, 'Primosomal protein N''', NULL, NULL, NULL, NULL, NULL, 4),
(83946, NULL, 'G3DSA:3.20.20.80:FF:000408', NULL, NULL, 'Alpha-L-fucosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83947, NULL, 'G3DSA:3.30.70.330:FF:000124', NULL, NULL, 'RNA-binding protein 26 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(83948, NULL, 'G3DSA:3.30.2410.10:FF:000040', NULL, NULL, 'Ubiquitin protein ligase E3 component n-recognin 5', NULL, NULL, NULL, NULL, NULL, 4),
(83949, NULL, 'G3DSA:3.30.200.20:FF:001657', NULL, NULL, 'RE65159p', NULL, NULL, NULL, NULL, NULL, 4),
(83950, NULL, 'G3DSA:1.10.510.10:FF:001201', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(83951, NULL, 'G3DSA:3.30.497.10:FF:000162', NULL, NULL, 'Serpin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83952, NULL, 'G3DSA:1.25.40.20:FF:001538', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83953, NULL, 'G3DSA:2.130.10.10:FF:003094', NULL, NULL, 'Os02g0539900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(83954, NULL, 'G3DSA:3.30.200.20:FF:002057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83955, NULL, 'G3DSA:1.20.1560.10:FF:000537', NULL, NULL, 'ABC transporter, multidrug resistance associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(83956, NULL, 'G3DSA:3.90.190.10:FF:000481', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83957, NULL, 'G3DSA:3.90.950.10:FF:000040', NULL, NULL, 'Ham1 family pyrophosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83958, NULL, 'G3DSA:1.10.238.10:FF:000079', NULL, NULL, 'Calcium and integrin-binding family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(83959, NULL, 'G3DSA:3.30.40.10:FF:000978', NULL, NULL, 'Ring-box 1, E3 ubiquitin protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(83960, NULL, 'G3DSA:3.30.160.380:FF:000007', NULL, NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(83961, NULL, 'G3DSA:1.10.10.10:FF:001876', NULL, NULL, 'SPO11, initiator of meiotic double stranded breaks', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(83962, NULL, 'G3DSA:2.30.30.40:FF:000085', NULL, NULL, 'E3 ubiquitin-protein ligase HECTD1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(83963, NULL, 'G3DSA:3.40.50.2300:FF:001152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83964, NULL, 'G3DSA:3.30.70.330:FF:002833', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83965, NULL, 'G3DSA:3.15.10.10:FF:000012', NULL, NULL, 'BPI fold containing family C, like', NULL, NULL, NULL, NULL, NULL, 4),
(83966, NULL, 'G3DSA:3.90.930.12:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83967, NULL, 'G3DSA:2.130.10.10:FF:002458', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83968, NULL, 'G3DSA:3.80.10.10:FF:004459', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83969, NULL, 'G3DSA:2.30.29.30:FF:000483', NULL, NULL, 'Ran-specific GTPase-activating protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(83970, NULL, 'G3DSA:3.30.40.210:FF:000009', NULL, NULL, 'Spt4/RpoE2 zinc finger containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83971, NULL, 'G3DSA:3.30.870.10:FF:000114', NULL, NULL, 'Phospholipase D A', NULL, NULL, NULL, NULL, NULL, 4),
(83972, NULL, 'G3DSA:3.40.228.10:FF:000030', NULL, NULL, 'NADH-quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(83973, NULL, 'G3DSA:2.30.30.100:FF:000074', NULL, NULL, 'LSM2 homolog, U6 small nuclear RNA and mRNA degradation associated', NULL, NULL, NULL, NULL, NULL, 4),
(83974, NULL, 'G3DSA:3.40.50.720:FF:001426', NULL, NULL, 'ActC', NULL, NULL, NULL, NULL, NULL, 4),
(83975, NULL, 'G3DSA:3.30.160.360:FF:000001', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(83976, NULL, 'G3DSA:1.10.287.110:FF:000104', NULL, NULL, 'Membrane associated DnaJ chaperone, putative', NULL, NULL, NULL, NULL, NULL, 4),
(83977, NULL, 'G3DSA:2.20.70.10:FF:000281', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(83978, NULL, 'G3DSA:1.10.510.10:FF:003562', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(83979, NULL, 'G3DSA:3.90.1480.20:FF:000016', NULL, NULL, 'Sialyltransferase-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(83980, NULL, 'G3DSA:1.25.40.120:FF:000035', NULL, NULL, 'Geranylgeranyl transferase type-2 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(83981, NULL, 'G3DSA:1.20.58.60:FF:000483', NULL, NULL, 'Spectrin repeat containing nuclear envelope protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(83982, NULL, 'G3DSA:3.90.70.10:FF:000079', NULL, NULL, 'Cathepsin O', NULL, NULL, NULL, NULL, NULL, 4),
(83983, NULL, 'G3DSA:3.20.20.140:FF:000161', NULL, NULL, 'Amidohydrolase, imidazolonepropionase', NULL, NULL, NULL, NULL, NULL, 4),
(83984, NULL, 'G3DSA:1.10.287.3550:FF:000002', NULL, NULL, 'Stromal interaction molecule homolog', NULL, NULL, NULL, NULL, NULL, 4),
(83985, NULL, 'G3DSA:2.60.40.10:FF:002334', NULL, NULL, 'Kek6, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(83986, NULL, 'G3DSA:3.40.30.10:FF:001231', NULL, NULL, 'Protein disulfide-isomerase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(83987, NULL, 'G3DSA:3.30.450.190:FF:000005', NULL, NULL, 'Gtr1 g domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(83988, NULL, 'G3DSA:3.30.920.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83989, NULL, 'G3DSA:3.30.420.110:FF:000043', NULL, NULL, 'Putative DNA mismatch repair protein Msh4', NULL, NULL, NULL, NULL, NULL, 4),
(83990, NULL, 'G3DSA:2.60.40.150:FF:000477', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83991, NULL, 'G3DSA:1.25.40.480:FF:000002', NULL, NULL, 'Fanconi anemia, complementation group E', NULL, NULL, NULL, NULL, NULL, 4),
(83992, NULL, 'G3DSA:3.20.20.210:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83993, NULL, 'G3DSA:1.10.510.10:FF:000217', NULL, NULL, 'Wee1-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(83994, NULL, 'G3DSA:1.25.40.10:FF:004262', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(83995, NULL, 'G3DSA:3.20.20.70:FF:000175', NULL, NULL, '2-dehydro-3-deoxy-6-phosphogalactonate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(83996, NULL, 'G3DSA:2.60.40.60:FF:000915', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(83997, NULL, 'G3DSA:3.20.20.80:FF:000032', NULL, NULL, '1,3-beta-glucanosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(83998, NULL, 'G3DSA:2.10.60.10:FF:000005', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(83999, NULL, 'G3DSA:3.90.132.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84000, NULL, 'G3DSA:3.90.730.10:FF:000034', NULL, NULL, 'Ribonuclease t2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84001, NULL, 'G3DSA:3.80.10.10:FF:001548', NULL, NULL, 'Si:ch211-213a13.2', NULL, NULL, NULL, NULL, NULL, 4),
(84002, NULL, 'G3DSA:3.40.50.300:FF:002200', NULL, NULL, 'Type VII secretion protein EccC', NULL, NULL, NULL, NULL, NULL, 4),
(84003, NULL, 'G3DSA:3.30.9.10:FF:000237', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(84004, NULL, 'G3DSA:1.10.287.130:FF:000262', NULL, NULL, 'Histidine kinase sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(84005, NULL, 'G3DSA:3.40.50.1460:FF:000107', NULL, NULL, 'GPI-anchor transamidase', NULL, NULL, NULL, NULL, NULL, 4),
(84006, NULL, 'G3DSA:2.60.40.60:FF:000123', NULL, NULL, 'Protocadherin beta 4', NULL, NULL, NULL, NULL, NULL, 4),
(84007, NULL, 'G3DSA:3.40.50.150:FF:000721', NULL, NULL, 'DNA methylase N-4/N-6 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(84008, NULL, 'G3DSA:1.20.1300.10:FF:000047', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(84009, NULL, 'G3DSA:2.30.42.10:FF:000002', NULL, NULL, 'Disks large homolog 4 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(84010, NULL, 'G3DSA:1.10.510.10:FF:000656', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(84011, NULL, 'G3DSA:1.10.8.60:FF:000462', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84012, NULL, 'G3DSA:3.30.40.10:FF:002131', NULL, NULL, 'Transcription factor bye1', NULL, NULL, NULL, NULL, NULL, 4),
(84013, NULL, 'G3DSA:2.10.25.10:FF:001216', NULL, NULL, 'Laminin subunit beta-1', NULL, NULL, NULL, NULL, NULL, 4),
(84014, NULL, 'G3DSA:2.130.10.10:FF:003419', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(84015, NULL, 'G3DSA:2.170.120.20:FF:000020', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(84016, NULL, 'G3DSA:2.60.120.620:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84017, NULL, 'G3DSA:1.20.920.10:FF:000038', NULL, NULL, 'Brahma1', NULL, NULL, NULL, NULL, NULL, 4),
(84018, NULL, 'G3DSA:3.30.420.10:FF:000327', NULL, NULL, 'Ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(84019, NULL, 'G3DSA:1.20.1250.20:FF:001984', NULL, NULL, 'AGAP012761-PA', NULL, NULL, NULL, NULL, NULL, 4),
(84020, NULL, 'G3DSA:1.10.2000.10:FF:000015', NULL, NULL, 'membrane frizzled-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(84021, NULL, 'G3DSA:4.10.280.10:FF:000002', NULL, NULL, 'Basic helix-loop-helix transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(84022, NULL, 'G3DSA:2.60.40.10:FF:002306', NULL, NULL, 'Cysteine protease', NULL, NULL, NULL, NULL, NULL, 4),
(84023, NULL, 'G3DSA:3.30.1460.40:FF:000001', NULL, NULL, 'Hydrogenase-2 operon protein hybE', NULL, NULL, NULL, NULL, NULL, 4),
(84024, NULL, 'G3DSA:3.40.50.1440:FF:000101', NULL, NULL, 'Misato 1, mitochondrial distribution and morphology regulator', NULL, NULL, NULL, NULL, NULL, 4),
(84025, NULL, 'G3DSA:3.30.230.10:FF:000111', NULL, NULL, 'Ribosomal protein S9/S16', NULL, NULL, NULL, NULL, NULL, 4),
(84026, NULL, 'G3DSA:3.10.20.90:FF:000878', NULL, NULL, 'Protein tyrosine phosphatase, non-receptor type 3', NULL, NULL, NULL, NULL, NULL, 4),
(84027, NULL, 'G3DSA:2.10.110.10:FF:000009', NULL, NULL, 'Paxillin isoform 1', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(84028, NULL, 'G3DSA:3.40.30.10:FF:000303', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(84029, NULL, 'G3DSA:2.40.50.100:FF:000210', NULL, NULL, 'RND superfamily efflux pump MFP component', NULL, NULL, NULL, NULL, NULL, 4),
(84030, NULL, 'G3DSA:3.40.50.300:FF:002144', NULL, NULL, 'CCR4-associated factor 16, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84031, NULL, 'G3DSA:3.50.4.10:FF:000013', NULL, NULL, 'Apical membrane antigen 1', NULL, NULL, NULL, NULL, NULL, 4),
(84032, NULL, 'G3DSA:3.40.33.10:FF:000080', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(84033, NULL, 'G3DSA:2.30.42.10:FF:000530', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84034, NULL, 'G3DSA:3.20.20.70:FF:000203', NULL, NULL, 'Mycofactocin system heme/flavin oxidoreductase MftD', NULL, NULL, NULL, NULL, NULL, 4),
(84035, NULL, 'G3DSA:1.10.880.10:FF:000003', NULL, NULL, 'Nuclear factor, erythroid 2 like 3', NULL, NULL, NULL, NULL, NULL, 4),
(84036, NULL, 'G3DSA:2.10.25.10:FF:001363', NULL, NULL, 'Wall-associated receptor kinase-like 9', NULL, NULL, NULL, NULL, NULL, 4),
(84037, NULL, 'G3DSA:2.80.10.50:FF:000270', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(84038, NULL, 'G3DSA:1.10.510.10:FF:003590', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84039, NULL, 'G3DSA:3.40.50.300:FF:006415', NULL, NULL, 'tRNA threonylcarbamoyladenosine biosynthesis protein TsaE', NULL, NULL, NULL, NULL, NULL, 4),
(84040, NULL, 'G3DSA:1.10.238.10:FF:001192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84041, NULL, 'G3DSA:3.30.70.1660:FF:000024', NULL, NULL, 'peptide chain release factor 1-like, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(84042, NULL, 'G3DSA:1.10.238.10:FF:001012', NULL, NULL, 'UBA domain-containing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(84043, NULL, 'G3DSA:3.30.450.40:FF:000170', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(84044, NULL, 'G3DSA:1.20.5.110:FF:000154', NULL, NULL, 'Protein CBR-SYN-16', NULL, NULL, NULL, NULL, NULL, 4),
(84045, NULL, 'G3DSA:3.20.10.10:FF:000022', NULL, NULL, '4-amino-4-deoxychorismate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(84046, NULL, 'G3DSA:3.20.20.70:FF:000731', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84047, NULL, 'G3DSA:1.10.730.10:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84048, NULL, 'G3DSA:1.20.1250.20:FF:001456', NULL, NULL, 'Putative transporter', NULL, NULL, NULL, NULL, NULL, 4),
(84049, NULL, 'G3DSA:3.40.50.720:FF:001134', NULL, NULL, 'Theronine dehydrogenase-like Zn-dependent dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(84050, NULL, 'G3DSA:2.40.100.10:FF:000148', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(84051, NULL, 'G3DSA:1.10.8.270:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84052, NULL, 'G3DSA:3.30.160.60:FF:001890', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84053, NULL, 'G3DSA:1.25.10.10:FF:000191', NULL, NULL, 'RHO family interacting cell polarization regulator 2', NULL, NULL, NULL, NULL, NULL, 4),
(84054, NULL, 'G3DSA:3.30.70.330:FF:001844', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84055, NULL, 'G3DSA:1.25.10.10:FF:001617', NULL, NULL, 'Transportin2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(84056, NULL, 'G3DSA:3.50.30.50:FF:000011', NULL, NULL, 'Slr2121 protein', NULL, NULL, NULL, NULL, NULL, 4),
(84057, NULL, 'G3DSA:1.10.150.530:FF:000006', NULL, NULL, 'Probable dual-specificity RNA methyltransferase RlmN', NULL, NULL, NULL, NULL, NULL, 4),
(84058, NULL, 'G3DSA:3.40.50.150:FF:000188', NULL, NULL, 'Protein-lysine methyltransferase METTL21C', NULL, NULL, NULL, NULL, NULL, 4),
(84059, NULL, 'G3DSA:3.90.70.10:FF:000612', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84060, NULL, 'G3DSA:2.130.10.10:FF:001469', NULL, NULL, 'WD repeat domain 34', NULL, NULL, NULL, NULL, NULL, 4),
(84061, NULL, 'G3DSA:3.90.105.10:FF:000020', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(84062, NULL, 'G3DSA:1.10.600.10:FF:000011', NULL, NULL, 'Decaprenyl diphosphate synthase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(84063, NULL, 'G3DSA:3.20.20.80:FF:000088', NULL, NULL, 'Alpha-glucosidase yihQ', NULL, NULL, NULL, NULL, NULL, 4),
(84064, NULL, 'G3DSA:3.20.20.120:FF:000003', NULL, NULL, 'Glucarate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(84065, NULL, 'G3DSA:1.10.472.80:FF:000087', NULL, NULL, 'Chromosome 12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(84066, NULL, 'G3DSA:2.60.40.10:FF:003767', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84067, NULL, 'G3DSA:2.40.70.10:FF:000055', NULL, NULL, 'Probable aspartyl protease At4g16563', NULL, NULL, NULL, NULL, NULL, 4),
(84068, NULL, 'G3DSA:1.10.390.10:FF:000067', NULL, NULL, 'Aminopeptidase N', NULL, NULL, NULL, NULL, NULL, 4),
(84069, NULL, 'G3DSA:3.40.50.2020:FF:000169', NULL, NULL, 'Ribose-phosphate pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(84070, NULL, 'G3DSA:3.30.40.10:FF:001170', NULL, NULL, 'GD13307', NULL, NULL, NULL, NULL, NULL, 4),
(84071, NULL, 'G3DSA:3.55.50.30:FF:000024', NULL, NULL, 'Putative anti-sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(84072, NULL, 'G3DSA:3.90.550.50:FF:000217', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(84073, NULL, 'G3DSA:2.130.10.10:FF:001654', NULL, NULL, 'BPH1p Protein', NULL, NULL, NULL, NULL, NULL, 4),
(84074, NULL, 'G3DSA:3.30.420.40:FF:000426', NULL, NULL, 'Actin-like protein ARP9', NULL, NULL, NULL, NULL, NULL, 4),
(84075, NULL, 'G3DSA:3.90.190.10:FF:000329', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84076, NULL, 'G3DSA:3.80.10.10:FF:002245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84077, NULL, 'G3DSA:1.25.40.10:FF:001737', NULL, NULL, 'SMG6 protein', NULL, NULL, NULL, NULL, NULL, 4),
(84078, NULL, 'G3DSA:3.30.200.20:FF:002113', NULL, NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 68', NULL, NULL, NULL, NULL, NULL, 4),
(84079, NULL, 'G3DSA:2.40.30.10:FF:000053', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(84080, NULL, 'G3DSA:2.60.120.590:FF:000011', NULL, NULL, 'Alpha-ketoglutarate-dependent dioxygenase AlkB', NULL, NULL, NULL, NULL, NULL, 4),
(84081, NULL, 'G3DSA:3.90.190.10:FF:000301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84082, NULL, 'G3DSA:3.40.33.10:FF:000017', NULL, NULL, 'GLIPR1 like 2', NULL, NULL, NULL, NULL, NULL, 4),
(84083, NULL, 'G3DSA:2.60.40.150:FF:000472', NULL, NULL, 'Activating signal cointegrator 1 complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(84084, NULL, 'G3DSA:3.30.200.20:FF:002293', NULL, NULL, 'Gll3938 protein', NULL, NULL, NULL, NULL, NULL, 4),
(84085, NULL, 'G3DSA:1.10.510.10:FF:002449', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84086, NULL, 'G3DSA:3.30.70.2190:FF:000003', NULL, NULL, 'Glycolate oxidase, subunit GlcD', NULL, NULL, NULL, NULL, NULL, 4),
(84087, NULL, 'G3DSA:3.30.559.70:FF:000026', NULL, NULL, 'choline acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(84088, NULL, 'G3DSA:2.130.10.10:FF:005364', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84089, NULL, 'G3DSA:3.30.70.260:FF:000171', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(84090, NULL, 'G3DSA:2.60.40.10:FF:001345', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(84091, NULL, 'G3DSA:2.30.30.100:FF:000130', NULL, NULL, 'LSM domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84092, NULL, 'G3DSA:3.90.810.10:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84093, NULL, 'G3DSA:1.25.10.10:FF:000128', NULL, NULL, 'Vacuolar protein-like protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(84094, NULL, 'G3DSA:1.25.40.10:FF:005251', NULL, NULL, 'Uncharacterized RNA-binding protein C1861.04c', NULL, NULL, NULL, NULL, NULL, 4),
(84095, NULL, 'G3DSA:3.30.565.10:FF:000528', NULL, NULL, 'Sensory box sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(84096, NULL, 'G3DSA:2.30.30.140:FF:000294', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84097, NULL, 'G3DSA:1.10.287.940:FF:000004', NULL, NULL, 'Purinergic receptor P2X 7', NULL, NULL, NULL, NULL, NULL, 4),
(84098, NULL, 'G3DSA:2.40.30.10:FF:000401', NULL, NULL, 'Elongation factor G, domain IV family protein', NULL, NULL, NULL, NULL, NULL, 4),
(84099, NULL, 'G3DSA:1.10.510.10:FF:002634', NULL, NULL, 'Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(84100, NULL, 'G3DSA:1.10.10.60:FF:001082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84101, NULL, 'G3DSA:2.120.10.30:FF:000312', NULL, NULL, 'YALI0F07931p', NULL, NULL, NULL, NULL, NULL, 4),
(84102, NULL, 'G3DSA:3.30.160.60:FF:002666', NULL, NULL, 'Zgc:174623 protein', NULL, NULL, NULL, NULL, NULL, 4),
(84103, NULL, 'G3DSA:1.25.40.10:FF:001445', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(84104, NULL, 'G3DSA:3.30.1140.32:FF:000027', NULL, NULL, 'Ribosomal protein S3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84105, NULL, 'G3DSA:1.20.1600.10:FF:000036', NULL, NULL, 'Outer membrane channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(84106, NULL, 'G3DSA:3.40.30.10:FF:001236', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(84107, NULL, 'G3DSA:2.130.10.10:FF:001093', NULL, NULL, 'Unplaced genomic scaffold supercont2.10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(84108, NULL, 'G3DSA:1.20.1270.60:FF:000316', NULL, NULL, 'DDEFL1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(84109, NULL, 'G3DSA:3.30.565.10:FF:000236', NULL, NULL, 'Phytochrome', NULL, NULL, NULL, NULL, NULL, 4),
(84110, NULL, 'G3DSA:3.30.420.40:FF:000050', NULL, NULL, 'Actin, alpha skeletal muscle', NULL, NULL, NULL, NULL, NULL, 4),
(84111, NULL, 'G3DSA:3.40.50.2000:FF:000163', NULL, NULL, 'Sterol 3-beta-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(84112, NULL, 'G3DSA:1.25.10.10:FF:001680', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84113, NULL, 'G3DSA:3.90.70.10:FF:000899', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84114, NULL, 'G3DSA:3.30.230.70:FF:000106', NULL, NULL, 'Acyl-CoA-binding domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(84115, NULL, 'G3DSA:2.60.40.150:FF:000505', NULL, NULL, 'Copine Vb', NULL, NULL, NULL, NULL, NULL, 4),
(84116, NULL, 'G3DSA:3.40.50.300:FF:000694', NULL, NULL, 'Preprotein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(84117, NULL, 'G3DSA:2.60.40.10:FF:003262', NULL, NULL, 'Basigin', NULL, NULL, NULL, NULL, NULL, 4),
(84118, NULL, 'G3DSA:3.20.20.105:FF:000008', NULL, NULL, 'Queuine tRNA-ribosyltransferase accessory subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(84119, NULL, 'G3DSA:3.30.800.10:FF:000020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(84120, NULL, 'G3DSA:3.40.50.2300:FF:000983', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84121, NULL, 'G3DSA:3.30.160.60:FF:000018', NULL, NULL, 'Krueppel-like factor 15', NULL, NULL, NULL, NULL, NULL, 4),
(84122, NULL, 'G3DSA:3.40.1030.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84123, NULL, 'G3DSA:3.40.50.1450:FF:000014', NULL, NULL, 'Ni,Fe-hydrogenase maturation factor', NULL, NULL, NULL, NULL, NULL, 4),
(84124, NULL, 'G3DSA:1.25.40.10:FF:001884', NULL, NULL, 'Zinc finger, C3H1-type-containing', NULL, NULL, NULL, NULL, NULL, 4),
(84125, NULL, 'G3DSA:1.20.140.90:FF:000008', NULL, NULL, 'Malonyl-CoA decarboxylase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(84126, NULL, 'G3DSA:3.30.70.1400:FF:000002', NULL, NULL, 'tRNA-modifying protein YgfZ', NULL, NULL, NULL, NULL, NULL, 4),
(84127, NULL, 'G3DSA:4.10.900.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84128, NULL, 'G3DSA:2.60.20.10:FF:000006', NULL, NULL, 'Very large A-kinase anchor protein', NULL, NULL, NULL, NULL, NULL, 4),
(84129, NULL, 'G3DSA:2.30.30.140:FF:000327', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(84130, NULL, 'G3DSA:3.40.50.300:FF:007348', NULL, NULL, 'Superfamily I DNA and RNA helicase and helicase subunits-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(84131, NULL, 'G3DSA:3.30.300.130:FF:000011', NULL, NULL, 'Metal-sulfur cluster biosynthetic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(84132, NULL, 'G3DSA:3.10.129.10:FF:000256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84133, NULL, 'G3DSA:1.10.10.790:FF:000009', NULL, NULL, 'splicing factor, suppressor of white-apricot homolog', NULL, NULL, NULL, NULL, NULL, 4),
(84134, NULL, 'G3DSA:3.90.780.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84135, NULL, 'G3DSA:3.40.50.2300:FF:000039', NULL, NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(84136, NULL, 'G3DSA:1.20.1560.10:FF:000953', NULL, NULL, 'Os03g0181750 protein', NULL, NULL, NULL, NULL, NULL, 4),
(84137, NULL, 'G3DSA:3.40.50.300:FF:000255', NULL, NULL, 'Elongation factor 1-alpha', NULL, NULL, NULL, NULL, NULL, 4),
(84138, NULL, 'G3DSA:2.60.40.10:FF:002278', NULL, NULL, 'receptor-type tyrosine-protein phosphatase beta isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(84139, NULL, 'G3DSA:2.40.50.90:FF:000061', NULL, NULL, 'Ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(84140, NULL, 'G3DSA:1.20.140.70:FF:000002', NULL, NULL, 'Oligoendopeptidase F homolog', NULL, NULL, NULL, NULL, NULL, 4),
(84141, NULL, 'G3DSA:3.30.200.20:FF:000168', NULL, NULL, 'L-type lectin-domain containing receptor kinase IX.1', NULL, NULL, NULL, NULL, NULL, 4),
(84142, NULL, 'G3DSA:2.40.50.40:FF:000012', NULL, NULL, 'C-C motif chemokine', NULL, NULL, NULL, NULL, NULL, 4),
(84143, NULL, 'G3DSA:1.10.3500.10:FF:000042', NULL, NULL, 'SUPT6H,-like protein to suppressor of ty 6', NULL, NULL, NULL, NULL, NULL, 4),
(84144, NULL, 'G3DSA:3.40.1810.10:FF:000080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84145, NULL, 'G3DSA:2.60.40.790:FF:000197', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84146, NULL, 'G3DSA:2.40.170.20:FF:000104', NULL, NULL, 'TonB-dependent siderophore receptor', NULL, NULL, NULL, NULL, NULL, 4),
(84147, NULL, 'G3DSA:3.20.20.80:FF:000824', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84148, NULL, 'G3DSA:3.40.50.300:FF:001183', NULL, NULL, 'Terminase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(84149, NULL, 'G3DSA:2.30.29.30:FF:000191', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(84150, NULL, 'G3DSA:3.30.160.60:FF:002722', NULL, NULL, 'Blast:Zinc finger protein 175', NULL, NULL, NULL, NULL, NULL, 4),
(84151, NULL, 'G3DSA:2.130.10.10:FF:003571', NULL, NULL, 'Angio-associated, migratory cell protein', NULL, NULL, NULL, NULL, NULL, 4),
(84152, NULL, 'G3DSA:3.30.1680.10:FF:000060', NULL, NULL, 'Sema domain, transmembrane domain (TM), and cytoplasmic domain, (semaphorin) 6B', NULL, NULL, NULL, NULL, NULL, 4),
(84153, NULL, 'G3DSA:1.20.5.1160:FF:000028', NULL, NULL, 'Nestin', NULL, NULL, NULL, NULL, NULL, 4),
(84154, NULL, 'G3DSA:3.90.550.10:FF:000756', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84155, NULL, 'G3DSA:3.90.850.10:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84156, NULL, 'G3DSA:3.40.50.880:FF:000232', NULL, NULL, 'Exo-beta-D-glucosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(84157, NULL, 'G3DSA:2.40.50.140:FF:000402', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(84158, NULL, 'G3DSA:1.10.1450.10:FF:000133', NULL, NULL, 'CD151 antigen, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84159, NULL, 'G3DSA:2.30.29.30:FF:000011', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(84160, NULL, 'G3DSA:3.40.640.10:FF:000016', NULL, NULL, 'Glutamate decarboxylase like 1', NULL, NULL, NULL, NULL, NULL, 4),
(84161, NULL, 'G3DSA:1.25.40.10:FF:001389', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g14330', NULL, NULL, NULL, NULL, NULL, 4),
(84162, NULL, 'G3DSA:1.20.58.870:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(84163, NULL, 'G3DSA:1.10.287.110:FF:000048', NULL, NULL, 'DnaJ family protein', NULL, NULL, NULL, NULL, NULL, 4),
(84164, NULL, 'G3DSA:3.40.50.300:FF:008332', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(84165, NULL, 'G3DSA:3.40.50.970:FF:000231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84166, NULL, 'G3DSA:1.25.40.10:FF:005099', NULL, NULL, 'GM14040p', NULL, NULL, NULL, NULL, NULL, 4),
(84167, NULL, 'G3DSA:3.40.50.10190:FF:000336', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(84168, NULL, 'G3DSA:2.130.10.10:FF:002110', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1', NULL, NULL, NULL, NULL, NULL, 4),
(84169, NULL, 'G3DSA:1.25.40.10:FF:002373', NULL, NULL, 'PPR repeat/Pentatricopeptide repeat domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84170, NULL, 'G3DSA:3.30.160.60:FF:001738', NULL, NULL, 'ZFP3 zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(84171, NULL, 'G3DSA:3.10.50.40:FF:000157', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(84172, NULL, 'G3DSA:2.10.70.80:FF:000010', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(84173, NULL, 'G3DSA:3.40.50.1820:FF:001255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84174, NULL, 'G3DSA:1.25.10.10:FF:001056', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(84175, NULL, 'G3DSA:3.40.640.10:FF:000201', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(84176, NULL, 'G3DSA:3.40.50.150:FF:000160', NULL, NULL, 'EEF1A lysine methyltransferase 3', NULL, NULL, NULL, NULL, NULL, 4),
(84177, NULL, 'G3DSA:2.60.40.1180:FF:000233', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(84178, NULL, 'G3DSA:1.10.1040.30:FF:000001', NULL, NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily A member', NULL, NULL, NULL, NULL, NULL, 4),
(84179, NULL, 'G3DSA:2.60.40.10:FF:004223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84180, NULL, 'G3DSA:1.10.510.10:FF:002073', NULL, NULL, 'Protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(84181, NULL, 'G3DSA:3.40.50.2000:FF:000955', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84182, NULL, 'G3DSA:1.10.3330.10:FF:000006', NULL, NULL, 'Probable allantoinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(84183, NULL, 'G3DSA:3.40.50.10730:FF:000009', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(84184, NULL, 'G3DSA:3.10.580.10:FF:000113', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(84185, NULL, 'G3DSA:1.10.555.10:FF:000006', NULL, NULL, 'Rho GTPase activating protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(84186, NULL, 'G3DSA:3.40.1080.10:FF:000017', NULL, NULL, 'Butyrate--acetoacetate CoA-transferase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(84187, NULL, 'G3DSA:3.30.70.330:FF:002777', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84188, NULL, 'G3DSA:1.20.1740.10:FF:000102', NULL, NULL, 'FI04531p', NULL, NULL, NULL, NULL, NULL, 4),
(84189, NULL, 'G3DSA:3.90.76.10:FF:000002', NULL, NULL, 'Dipeptide ABC transporter, substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(84190, NULL, 'G3DSA:3.40.50.10130:FF:000009', NULL, NULL, 'UV endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(84191, NULL, 'G3DSA:1.10.510.10:FF:001673', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(84192, NULL, 'G3DSA:1.20.58.390:FF:000164', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(84193, NULL, 'G3DSA:1.10.510.10:FF:000509', NULL, NULL, 'Uncharacterized protein, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(84194, NULL, 'G3DSA:3.30.565.10:FF:000152', NULL, NULL, 'Sensor histidine kinase AgrC', NULL, NULL, NULL, NULL, NULL, 4),
(84195, NULL, 'G3DSA:1.25.10.10:FF:003001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84196, NULL, 'G3DSA:1.20.58.190:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(84197, NULL, 'G3DSA:3.10.20.30:FF:000091', NULL, NULL, 'Nicotinate dehydrogenase small FeS subunit', NULL, NULL, NULL, NULL, NULL, 4),
(84198, NULL, 'G3DSA:3.30.70.330:FF:000540', NULL, NULL, 'RNA-binding protein Rsf1', NULL, NULL, NULL, NULL, NULL, 4),
(84199, NULL, 'G3DSA:2.60.40.10:FF:003823', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84200, NULL, 'G3DSA:3.40.50.2000:FF:000247', NULL, NULL, 'Glycogen [starch] synthase', NULL, NULL, NULL, NULL, NULL, 4),
(84201, NULL, 'G3DSA:3.40.50.220:FF:000001', NULL, NULL, 'Ornithine decarboxylase SpeF', NULL, NULL, NULL, NULL, NULL, 4),
(84202, NULL, 'G3DSA:1.25.40.10:FF:001209', NULL, NULL, 'Os07g0213300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(84203, NULL, 'G3DSA:3.40.50.300:FF:004437', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84204, NULL, 'G3DSA:2.130.10.10:FF:000165', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 16', NULL, NULL, NULL, NULL, NULL, 4),
(84205, NULL, 'G3DSA:2.60.120.200:FF:000557', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84206, NULL, 'G3DSA:2.60.200.20:FF:000143', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(84207, NULL, 'G3DSA:3.30.160.60:FF:006409', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84208, NULL, 'G3DSA:3.40.1160.10:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84209, NULL, 'G3DSA:1.25.10.10:FF:000752', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84210, NULL, 'G3DSA:3.30.70.1230:FF:000013', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(84211, NULL, 'G3DSA:3.10.50.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84212, NULL, 'G3DSA:3.90.1570.40:FF:000001', NULL, NULL, 'Pre-mRNA-processing-splicing factor 8', NULL, NULL, NULL, NULL, NULL, 4),
(84213, NULL, 'G3DSA:1.25.10.10:FF:003478', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84214, NULL, 'G3DSA:1.20.1000.10:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84215, NULL, 'G3DSA:2.160.20.10:FF:000007', NULL, NULL, 'F-box only protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(84216, NULL, 'G3DSA:2.60.40.10:FF:000417', NULL, NULL, 'Fibronectin 1', NULL, NULL, NULL, NULL, NULL, 4),
(84217, NULL, 'G3DSA:1.10.238.10:FF:000556', NULL, NULL, 'Probable CDC31-spindle pole body component, centrin', NULL, NULL, NULL, NULL, NULL, 4),
(84218, NULL, 'G3DSA:3.30.160.60:FF:001002', NULL, NULL, 'zinc finger protein 32 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(84219, NULL, 'G3DSA:3.40.50.300:FF:000019', NULL, NULL, 'Translation initiation factor IF-2', NULL, NULL, NULL, NULL, NULL, 4),
(84220, NULL, 'G3DSA:1.20.1280.170:FF:000016', NULL, NULL, 'Eukaryotic aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(84221, NULL, 'G3DSA:4.10.280.10:FF:000182', NULL, NULL, 'Basic helix-loop-helix', NULL, NULL, NULL, NULL, NULL, 4),
(84222, NULL, 'G3DSA:3.10.20.90:FF:000086', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(84223, NULL, 'G3DSA:2.130.10.10:FF:004347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84224, NULL, 'G3DSA:3.10.20.90:FF:000794', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84225, NULL, 'G3DSA:2.130.10.10:FF:003947', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84226, NULL, 'G3DSA:3.30.830.10:FF:000168', NULL, NULL, 'Mitochondrial-processing peptidase subunit alpha-1', NULL, NULL, NULL, NULL, NULL, 4),
(84227, NULL, 'G3DSA:3.30.450.40:FF:000254', NULL, NULL, 'GAF domain phosphoenolpyruvate--protein phosphotransferase PtsP', NULL, NULL, NULL, NULL, NULL, 4),
(84228, NULL, 'G3DSA:3.40.50.80:FF:000050', NULL, NULL, 'Ferric reduction oxidase 6', NULL, NULL, NULL, NULL, NULL, 4),
(84229, NULL, 'G3DSA:2.60.40.60:FF:000090', NULL, NULL, 'FAT atypical cadherin 3', NULL, NULL, NULL, NULL, NULL, 4),
(84230, NULL, 'G3DSA:1.25.70.10:FF:000104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(84231, NULL, 'G3DSA:2.60.220.50:FF:000102', NULL, NULL, 'Putative adhesion G protein-coupled receptor E4P', NULL, NULL, NULL, NULL, NULL, 4),
(84232, NULL, 'G3DSA:1.20.58.340:FF:000082', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(84233, NULL, 'G3DSA:1.10.20.10:FF:000157', NULL, NULL, 'Histone H3-like centromeric protein A', NULL, NULL, NULL, NULL, NULL, 4),
(84234, NULL, 'G3DSA:3.90.640.80:FF:000003', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(84235, NULL, 'G3DSA:2.60.40.4310:FF:000003', NULL, NULL, 'Structural polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(84236, NULL, 'G3DSA:3.30.1780.10:FF:000005', NULL, NULL, 'WGS project CABT00000000 data, contig 2.10', NULL, NULL, NULL, NULL, NULL, 4),
(84237, NULL, 'G3DSA:3.40.720.10:FF:000202', NULL, NULL, 'N-acetylgalactosamine 6-sulfate sulfatase (GALNS)', NULL, NULL, NULL, NULL, NULL, 4),
(84238, NULL, 'G3DSA:1.10.150.240:FF:000043', NULL, NULL, 'HAD family phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(84239, NULL, 'G3DSA:3.30.160.60:FF:000777', NULL, NULL, 'zinc finger and BTB domain-containing protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(84240, NULL, 'G3DSA:3.40.50.300:FF:007635', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84241, NULL, 'G3DSA:2.60.40.1670:FF:000020', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(84242, NULL, 'G3DSA:3.80.10.10:FF:003026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84243, NULL, 'G3DSA:1.10.533.10:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84244, NULL, 'G3DSA:3.20.20.190:FF:000035', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(84245, NULL, 'G3DSA:3.30.160.60:FF:000305', NULL, NULL, 'Vascular endothelial zinc finger 1', NULL, NULL, NULL, NULL, NULL, 4),
(84246, NULL, 'G3DSA:2.60.40.150:FF:000241', NULL, NULL, 'Antiviral helicase SLH1', NULL, NULL, NULL, NULL, NULL, 4),
(84247, NULL, 'G3DSA:3.40.50.720:FF:002354', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase 2 (Gapdh)(Nad(P)-dependent glyceraldehyde-3-phosphate dehydrogenase)', NULL, NULL, NULL, NULL, NULL, 4),
(84248, NULL, 'G3DSA:3.20.20.70:FF:000259', NULL, NULL, 'Dihydroorotate dehydrogenase (quinone)', NULL, NULL, NULL, NULL, NULL, 4),
(84249, NULL, 'G3DSA:2.130.10.10:FF:004111', NULL, NULL, 'AGAP003804-PA', NULL, NULL, NULL, NULL, NULL, 4),
(84250, NULL, 'G3DSA:1.25.40.20:FF:000105', NULL, NULL, 'protein phosphatase 1 regulatory inhibitor subunit 16B', NULL, NULL, NULL, NULL, NULL, 4),
(84251, NULL, 'G3DSA:3.10.110.10:FF:000382', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(84252, NULL, 'G3DSA:1.25.50.20:FF:000078', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(84253, NULL, 'G3DSA:3.30.465.10:FF:000111', NULL, NULL, 'D-2-hydroxyglutarate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(84254, NULL, 'G3DSA:2.130.10.10:FF:004055', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(84255, NULL, 'G3DSA:1.10.3210.10:FF:000031', NULL, NULL, 'RELA/SPOT homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(84256, NULL, 'G3DSA:1.25.10.10:FF:002309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84257, NULL, 'G3DSA:1.25.40.20:FF:000577', NULL, NULL, 'Rab GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84258, NULL, 'G3DSA:3.30.420.80:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84259, NULL, 'G3DSA:3.30.160.60:FF:000249', NULL, NULL, 'Zinc finger protein 154', NULL, NULL, NULL, NULL, NULL, 4),
(84260, NULL, 'G3DSA:3.40.50.360:FF:000138', NULL, NULL, 'Putative NAD(P)H oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(84261, NULL, 'G3DSA:2.60.40.150:FF:000185', NULL, NULL, 'DEAD/DEAH box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(84262, NULL, 'G3DSA:2.10.70.10:FF:000118', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(84263, NULL, 'G3DSA:3.40.50.11380:FF:000002', NULL, NULL, 'probable UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SEC', NULL, NULL, NULL, NULL, NULL, 4),
(84264, NULL, 'G3DSA:3.40.50.300:FF:000171', NULL, NULL, 'Dynamin-like 120 kDa protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(84265, NULL, 'G3DSA:2.30.39.10:FF:000062', NULL, NULL, 'Serpin peptidase inhibitor 4', NULL, NULL, NULL, NULL, NULL, 4),
(84266, NULL, 'G3DSA:2.60.40.10:FF:005712', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84267, NULL, 'G3DSA:2.170.290.10:FF:000001', NULL, NULL, 'Baseplate wedge protein gp8', NULL, NULL, NULL, NULL, NULL, 4),
(84268, NULL, 'G3DSA:2.130.10.10:FF:004583', NULL, NULL, 'WD repeat-containing protein GTS1', NULL, NULL, NULL, NULL, NULL, 4),
(84269, NULL, 'G3DSA:2.60.40.10:FF:003998', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84270, NULL, 'G3DSA:3.20.20.150:FF:000074', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(84271, NULL, 'G3DSA:4.10.400.10:FF:000063', NULL, NULL, 'low-density lipoprotein receptor-related protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(84272, NULL, 'G3DSA:1.10.3720.10:FF:000109', NULL, NULL, 'sn-glycerol-3-phosphate transport system permease protein UgpE', NULL, NULL, NULL, NULL, NULL, 4),
(84273, NULL, 'G3DSA:2.60.40.10:FF:000333', NULL, NULL, 'Down syndrome cell adhesion molecule', NULL, NULL, NULL, NULL, NULL, 4),
(84274, NULL, 'G3DSA:3.40.50.1240:FF:000160', NULL, NULL, 'Nitric oxide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(84275, NULL, 'G3DSA:1.10.238.10:FF:000320', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(84276, NULL, 'G3DSA:1.25.10.10:FF:002837', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84277, NULL, 'G3DSA:1.25.40.20:FF:000049', NULL, NULL, 'Ankyrin repeat domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(84278, NULL, 'G3DSA:1.10.510.10:FF:000184', NULL, NULL, 'cyclin-dependent kinase 5 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(84279, NULL, 'G3DSA:2.130.10.10:FF:002874', NULL, NULL, 'WD repeat-containing protein 90', NULL, NULL, NULL, NULL, NULL, 4),
(84280, NULL, 'G3DSA:2.30.42.10:FF:000058', NULL, NULL, 'multiple PDZ domain protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(84281, NULL, 'G3DSA:2.10.25.10:FF:000963', NULL, NULL, 'Fibrillin-1', NULL, NULL, NULL, NULL, NULL, 4),
(84282, NULL, 'G3DSA:2.70.70.10:FF:000020', NULL, NULL, 'Peptidase, M23/M37 family', NULL, NULL, NULL, NULL, NULL, 4),
(84283, NULL, 'G3DSA:3.10.100.10:FF:000353', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84284, NULL, 'G3DSA:1.10.287.70:FF:000479', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84285, NULL, 'G3DSA:3.50.50.60:FF:000515', NULL, NULL, 'D-amino acid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(84286, NULL, 'G3DSA:1.10.287.70:FF:000390', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(84287, NULL, 'G3DSA:1.10.220.160:FF:000007', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(84288, NULL, 'G3DSA:3.30.70.940:FF:000009', NULL, NULL, 'Transcription termination/antitermination protein NusG', NULL, NULL, NULL, NULL, NULL, 4),
(84289, NULL, 'G3DSA:1.10.720.40:FF:000006', NULL, NULL, 'Thymopoietin a', NULL, NULL, NULL, NULL, NULL, 4),
(84290, NULL, 'G3DSA:1.10.10.60:FF:000446', NULL, NULL, 'Egg-laying defective protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(84291, NULL, 'G3DSA:1.20.1070.10:FF:001181', NULL, NULL, 'Histamine H2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(84292, NULL, 'G3DSA:3.30.470.20:FF:000098', NULL, NULL, 'Succinyl-CoA synthetase subunit alpha, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84293, NULL, 'G3DSA:3.40.605.10:FF:000070', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(84294, NULL, 'G3DSA:1.10.510.10:FF:001437', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84295, NULL, 'G3DSA:2.120.10.80:FF:000102', NULL, NULL, 'Nitrile-specifier protein 5', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(84296, NULL, 'G3DSA:3.40.50.980:FF:000060', NULL, NULL, 'Acyl-CoA ligase easD', NULL, NULL, NULL, NULL, NULL, 4),
(84297, NULL, 'G3DSA:1.10.150.50:FF:000162', NULL, NULL, 'Serine/threonine-protein kinase STE11', NULL, NULL, NULL, NULL, NULL, 4),
(84298, NULL, 'G3DSA:3.60.21.60:FF:000009', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(84299, NULL, 'G3DSA:1.10.10.10:FF:000600', NULL, NULL, 'DEAD/DEAH box helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84300, NULL, 'G3DSA:1.25.40.10:FF:002137', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g42920, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(84301, NULL, 'G3DSA:3.40.1370.10:FF:000028', NULL, NULL, 'Rpl4', NULL, NULL, NULL, NULL, NULL, 4),
(84302, NULL, 'G3DSA:1.10.10.10:FF:001584', NULL, NULL, 'RNA polymerase sigma factor sigE, chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(84303, NULL, 'G3DSA:1.20.930.20:FF:000008', NULL, NULL, 'Os08g0343000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(84304, NULL, 'G3DSA:1.50.40.10:FF:000600', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84305, NULL, 'G3DSA:3.30.420.210:FF:000011', NULL, NULL, 'SEP_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(84306, NULL, 'G3DSA:3.30.40.10:FF:001198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84307, NULL, 'G3DSA:3.40.190.10:FF:000150', NULL, NULL, 'Glutamate receptor 2.7', NULL, NULL, NULL, NULL, NULL, 4),
(84308, NULL, 'G3DSA:3.30.1340.10:FF:000006', NULL, NULL, 'PTS-dependent dihydroxyacetone kinase, DhaM subunit', NULL, NULL, NULL, NULL, NULL, 4),
(84309, NULL, 'G3DSA:3.30.310.50:FF:000045', NULL, NULL, 'Phosphoglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(84310, NULL, 'G3DSA:3.40.50.300:FF:000547', NULL, NULL, 'Cell division control protein', NULL, NULL, NULL, NULL, NULL, 4),
(84311, NULL, 'G3DSA:1.10.260.170:FF:000001', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', NULL, NULL, NULL, NULL, NULL, 4),
(84312, NULL, 'G3DSA:1.20.5.190:FF:000104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84313, NULL, 'G3DSA:3.40.50.410:FF:000232', NULL, NULL, 'Putative 60 kd ribonucleoprotein ssa/ro60 kd ribonucleoprotein ssa/ro', NULL, NULL, NULL, NULL, NULL, 4),
(84314, NULL, 'G3DSA:3.40.50.300:FF:003892', NULL, NULL, 'Iron compound ABC transporter, ATP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84315, NULL, 'G3DSA:3.10.250.10:FF:000009', NULL, NULL, 'WC1', NULL, NULL, NULL, NULL, NULL, 4),
(84316, NULL, 'G3DSA:2.130.10.10:FF:002930', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84317, NULL, 'G3DSA:1.10.287.110:FF:000284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84318, NULL, 'G3DSA:3.80.10.10:FF:002953', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84319, NULL, 'G3DSA:3.40.50.150:FF:000952', NULL, NULL, 'Probable methyltransferase tdiE', NULL, NULL, NULL, NULL, NULL, 4),
(84320, NULL, 'G3DSA:1.10.10.10:FF:000280', NULL, NULL, 'Transcriptional regulator gntR family', NULL, NULL, NULL, NULL, NULL, 4),
(84321, NULL, 'G3DSA:3.40.50.1820:FF:001542', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84322, NULL, 'G3DSA:3.40.50.720:FF:002298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84323, NULL, 'G3DSA:4.10.1000.40:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84324, NULL, 'G3DSA:1.10.287.770:FF:000015', NULL, NULL, 'Pickpocket 9, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(84325, NULL, 'G3DSA:2.50.20.20:FF:000004', NULL, NULL, 'Lipoarabinomannan carrier protein LprG', NULL, NULL, NULL, NULL, NULL, 4),
(84326, NULL, 'G3DSA:3.90.550.10:FF:000380', NULL, NULL, 'Posttranslational modification protein', NULL, NULL, NULL, NULL, NULL, 4),
(84327, NULL, 'G3DSA:3.40.50.880:FF:000176', NULL, NULL, 'DJ-1/PfpI family protein', NULL, NULL, NULL, NULL, NULL, 4),
(84328, NULL, 'G3DSA:3.40.50.300:FF:005550', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(84329, NULL, 'G3DSA:1.20.120.1750:FF:000062', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(84330, NULL, 'G3DSA:3.30.300.10:FF:000055', NULL, NULL, 'S-adenosylmethionine synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(84331, NULL, 'G3DSA:3.30.1640.30:FF:000001', NULL, NULL, 'Serine protease 7', NULL, NULL, NULL, NULL, NULL, 4),
(84332, NULL, 'G3DSA:3.30.1360.120:FF:000041', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(84333, NULL, 'G3DSA:2.40.10.10:FF:000170', NULL, NULL, 'Serine protease 3', NULL, NULL, NULL, NULL, NULL, 4),
(84334, NULL, 'G3DSA:3.20.20.330:FF:000004', NULL, NULL, 'Bifunctional homocysteine S-methyltransferase/methylenetetrahydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(84335, NULL, 'G3DSA:3.30.160.60:FF:005780', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84336, NULL, 'G3DSA:1.20.120.1760:FF:000008', NULL, NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(84337, NULL, 'G3DSA:3.30.160.60:FF:002435', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84338, NULL, 'G3DSA:3.10.100.10:FF:000297', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84339, NULL, 'G3DSA:1.20.1070.10:FF:001557', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84340, NULL, 'G3DSA:3.30.200.20:FF:000584', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(84341, NULL, 'G3DSA:3.40.395.10:FF:000030', NULL, NULL, 'Membrane thiol protease', NULL, NULL, NULL, NULL, NULL, 4),
(84342, NULL, 'G3DSA:1.10.8.710:FF:000004', NULL, NULL, 'Dynein axonemal heavy chain 6', NULL, NULL, NULL, NULL, NULL, 4),
(84343, NULL, 'G3DSA:3.40.640.10:FF:000308', NULL, NULL, 'Aminotransferase class I and II', NULL, NULL, NULL, NULL, NULL, 4),
(84344, NULL, 'G3DSA:1.10.8.10:FF:000060', NULL, NULL, 'DCN1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(84345, NULL, 'G3DSA:3.40.190.10:FF:000239', NULL, NULL, 'Glutamate receptor ionotropic, delta-2', NULL, NULL, NULL, NULL, NULL, 4),
(84346, NULL, 'G3DSA:1.20.120.350:FF:000253', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84347, NULL, 'G3DSA:1.20.120.1200:FF:000009', NULL, NULL, 'NADH-quinone oxidoreductase subunit J', NULL, NULL, NULL, NULL, NULL, 4),
(84348, NULL, 'G3DSA:3.40.50.2300:FF:000455', NULL, NULL, 'Protein CBG01593', NULL, NULL, NULL, NULL, NULL, 4),
(84349, NULL, 'G3DSA:3.40.50.2300:FF:000511', NULL, NULL, 'Two-component system sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(84350, NULL, 'G3DSA:1.25.10.10:FF:000275', NULL, NULL, 'protein SINE1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(84351, NULL, 'G3DSA:1.20.120.350:FF:000197', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84352, NULL, 'G3DSA:3.40.50.1820:FF:001486', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84353, NULL, 'G3DSA:2.40.50.140:FF:001239', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84354, NULL, 'G3DSA:2.130.10.10:FF:005836', NULL, NULL, 'Nucleoporin nup132', NULL, NULL, NULL, NULL, NULL, 4),
(84355, NULL, 'G3DSA:2.30.29.240:FF:000012', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(84356, NULL, 'G3DSA:1.20.1510.10:FF:000006', NULL, NULL, 'Divalent cation efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(84357, NULL, 'G3DSA:1.20.1250.20:FF:002153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84358, NULL, 'G3DSA:3.80.10.10:FF:001172', NULL, NULL, 'Os11g0108932 protein', NULL, NULL, NULL, NULL, NULL, 4),
(84359, NULL, 'G3DSA:2.70.160.11:FF:000011', NULL, NULL, 'Protein arginine N-methyltransferase 9', NULL, NULL, NULL, NULL, NULL, 4),
(84360, NULL, 'G3DSA:1.10.510.10:FF:002218', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84361, NULL, 'G3DSA:2.170.270.10:FF:000202', NULL, NULL, 'Whsc1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(84362, NULL, 'G3DSA:2.60.40.1180:FF:000002', NULL, NULL, '1,4-alpha-glucan branching enzyme GlgB', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(84363, NULL, 'G3DSA:2.70.130.10:FF:000109', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84364, NULL, 'G3DSA:3.40.50.300:FF:006331', NULL, NULL, 'Zgc:153294', NULL, NULL, NULL, NULL, NULL, 4),
(84365, NULL, 'G3DSA:2.40.128.300:FF:000001', NULL, NULL, 'Copper homeostasis/adhesion lipoprotein NlpE', NULL, NULL, NULL, NULL, NULL, 4),
(84366, NULL, 'G3DSA:3.30.40.10:FF:001962', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84367, NULL, 'G3DSA:3.30.710.10:FF:000193', NULL, NULL, 'BTB/POZ and TAZ domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(84368, NULL, 'G3DSA:3.30.1550.10:FF:000016', NULL, NULL, '60S ribosomal protein L12', NULL, NULL, NULL, NULL, NULL, 4),
(84369, NULL, 'G3DSA:2.60.120.10:FF:000341', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(84370, NULL, 'G3DSA:2.30.29.30:FF:000516', NULL, NULL, 'Dos, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(84371, NULL, 'G3DSA:3.90.550.10:FF:000228', NULL, NULL, 'Galactinol synthase', NULL, NULL, NULL, NULL, NULL, 4),
(84372, NULL, 'G3DSA:1.10.220.150:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84373, NULL, 'G3DSA:3.30.70.330:FF:000832', NULL, NULL, 'Small subunit rRNA processing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84374, NULL, 'G3DSA:3.40.50.720:FF:001050', NULL, NULL, 'Calcium-activated potassium channel subunit alpha-1', NULL, NULL, NULL, NULL, NULL, 4),
(84375, NULL, 'G3DSA:1.20.870.10:FF:000040', NULL, NULL, 'RIKEN cDNA 4930474N05 gene', NULL, NULL, NULL, NULL, NULL, 4),
(84376, NULL, 'G3DSA:2.40.10.10:FF:000546', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84377, NULL, 'G3DSA:3.30.70.100:FF:000145', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84378, NULL, 'G3DSA:1.10.630.10:FF:000075', NULL, NULL, 'Cytochrome P450 monooxygenase helB1', NULL, NULL, NULL, NULL, NULL, 4),
(84379, NULL, 'G3DSA:2.60.40.60:FF:000882', NULL, NULL, 'Cadherin 23', NULL, NULL, NULL, NULL, NULL, 4),
(84380, NULL, 'G3DSA:1.25.40.610:FF:000002', NULL, NULL, 'Adhesion G protein-coupled receptor B2', NULL, NULL, NULL, NULL, NULL, 4),
(84381, NULL, 'G3DSA:3.40.50.300:FF:005926', NULL, NULL, 'Multidrug resistance-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(84382, NULL, 'G3DSA:3.40.50.10190:FF:000191', NULL, NULL, 'Transcription coactivator', NULL, NULL, NULL, NULL, NULL, 4),
(84383, NULL, 'G3DSA:3.40.50.300:FF:005218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84384, NULL, 'G3DSA:2.60.120.10:FF:000521', NULL, NULL, 'ATP-binding subunit of ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(84385, NULL, 'G3DSA:3.40.1110.10:FF:000487', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84386, NULL, 'G3DSA:3.30.160.60:FF:005925', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84387, NULL, 'G3DSA:1.25.40.10:FF:000900', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(84388, NULL, 'G3DSA:3.40.50.720:FF:001573', NULL, NULL, 'very-long-chain 3-oxoacyl-CoA reductase 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(84389, NULL, 'G3DSA:2.130.10.10:FF:000457', NULL, NULL, 'rRNA processing protein Pwp1', NULL, NULL, NULL, NULL, NULL, 4),
(84390, NULL, 'G3DSA:3.40.50.300:FF:004706', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84391, NULL, 'G3DSA:2.60.40.60:FF:000354', NULL, NULL, 'FAT atypical cadherin 3', NULL, NULL, NULL, NULL, NULL, 4),
(84392, NULL, 'G3DSA:3.40.5.120:FF:000005', NULL, NULL, 'Kismet, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(84393, NULL, 'G3DSA:3.30.200.20:FF:001096', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(84394, NULL, 'G3DSA:3.40.800.20:FF:000032', NULL, NULL, 'Acetylpolyamine amidohydrolase 2', NULL, NULL, NULL, NULL, NULL, 4),
(84395, NULL, 'G3DSA:3.60.20.10:FF:000167', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84396, NULL, 'G3DSA:3.90.190.10:FF:000245', NULL, NULL, 'Phosphoinositide phosphatase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(84397, NULL, 'G3DSA:3.60.15.10:FF:000222', NULL, NULL, 'Os09g0439000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(84398, NULL, 'G3DSA:3.40.50.1390:FF:000007', NULL, NULL, 'Serine recombinase', NULL, NULL, NULL, NULL, NULL, 4),
(84399, NULL, 'G3DSA:3.50.50.60:FF:001027', NULL, NULL, 'Dihydropyrimidine dehydrogenase [NADP(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(84400, NULL, 'G3DSA:3.40.50.2300:FF:001528', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84401, NULL, 'G3DSA:3.90.920.10:FF:000009', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(84402, NULL, 'G3DSA:2.170.140.10:FF:000013', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(84403, NULL, 'G3DSA:3.40.50.300:FF:001475', NULL, NULL, 'Ferrous iron transport protein B', NULL, NULL, NULL, NULL, NULL, 4),
(84404, NULL, 'G3DSA:1.10.510.10:FF:003910', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84405, NULL, 'G3DSA:3.40.1190.20:FF:000028', NULL, NULL, 'ATP-dependent (S)-NAD(P)H-hydrate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(84406, NULL, 'G3DSA:1.25.40.10:FF:004610', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84407, NULL, 'G3DSA:2.120.10.80:FF:000158', NULL, NULL, 'Multiple epidermal growth factor domains protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(84408, NULL, 'G3DSA:2.130.10.10:FF:002402', NULL, NULL, 'Protein CBG08973', NULL, NULL, NULL, NULL, NULL, 4),
(84409, NULL, 'G3DSA:1.25.10.10:FF:003186', NULL, NULL, 'Phosphoinositide 3-kinase regulatory subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84410, NULL, 'G3DSA:3.10.450.10:FF:000053', NULL, NULL, 'Cysteine proteinase inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(84411, NULL, 'G3DSA:3.40.50.300:FF:008040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84412, NULL, 'G3DSA:3.30.70.920:FF:000003', NULL, NULL, 'AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(84413, NULL, 'G3DSA:3.80.10.10:FF:001733', NULL, NULL, 'Protein C21orf2 homolog, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84414, NULL, 'G3DSA:1.10.246.120:FF:000003', NULL, NULL, 'Vacuolar protein sorting-associated protein 9A', NULL, NULL, NULL, NULL, NULL, 4),
(84415, NULL, 'G3DSA:1.10.630.10:FF:000783', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84416, NULL, 'G3DSA:3.40.50.2000:FF:001091', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(84417, NULL, 'G3DSA:3.40.630.10:FF:000375', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84418, NULL, 'G3DSA:2.10.25.10:FF:000199', NULL, NULL, 'signal peptide, CUB and EGF-like domain-containing protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(84419, NULL, 'G3DSA:1.25.10.10:FF:001909', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(84420, NULL, 'G3DSA:3.30.70.330:FF:002485', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84421, NULL, 'G3DSA:1.20.1560.10:FF:000684', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84422, NULL, 'G3DSA:3.40.50.720:FF:000589', NULL, NULL, 'Alpha-aminoadipic semialdehyde synthase', NULL, NULL, NULL, NULL, NULL, 4),
(84423, NULL, 'G3DSA:2.10.10.10:FF:000002', NULL, NULL, '72 kDa type IV collagenase', NULL, NULL, NULL, NULL, NULL, 4),
(84424, NULL, 'G3DSA:3.10.580.10:FF:000057', NULL, NULL, 'DUF21 domain-containing protein At5g52790', NULL, NULL, NULL, NULL, NULL, 4),
(84425, NULL, 'G3DSA:1.20.5.500:FF:000001', NULL, NULL, 'Type II keratin 23', NULL, NULL, NULL, NULL, NULL, 4),
(84426, NULL, 'G3DSA:2.40.40.20:FF:000028', NULL, NULL, 'Vesicle-fusing ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(84427, NULL, 'G3DSA:2.20.28.10:FF:000008', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(84428, NULL, 'G3DSA:3.30.160.270:FF:000002', NULL, NULL, '2-isopropylmalate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(84429, NULL, 'G3DSA:3.30.160.60:FF:004852', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84430, NULL, 'G3DSA:2.60.40.10:FF:000709', NULL, NULL, 'basement membrane-specific heparan sulfate proteoglycan core protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(84431, NULL, 'G3DSA:3.40.50.300:FF:007579', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(84432, NULL, 'G3DSA:3.30.160.60:FF:006292', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84433, NULL, 'G3DSA:3.40.220.10:FF:000001', NULL, NULL, 'Probable cytosol aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(84434, NULL, 'G3DSA:3.30.560.10:FF:000012', NULL, NULL, 'Choline dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84435, NULL, 'G3DSA:1.10.238.10:FF:000264', NULL, NULL, 'Calmodulin like 6', NULL, NULL, NULL, NULL, NULL, 4),
(84436, NULL, 'G3DSA:1.20.1250.20:FF:000495', NULL, NULL, 'Glycoside-Pentoside-Hexuronide (GPH):Cation Symporter Family', NULL, NULL, NULL, NULL, NULL, 4),
(84437, NULL, 'G3DSA:1.10.510.10:FF:001965', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84438, NULL, 'G3DSA:3.40.50.300:FF:004145', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(84439, NULL, 'G3DSA:1.25.40.10:FF:002665', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84440, NULL, 'G3DSA:3.90.260.10:FF:000037', NULL, NULL, 'AGAP003342-PA', NULL, NULL, NULL, NULL, NULL, 4),
(84441, NULL, 'G3DSA:2.170.130.10:FF:000080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84442, NULL, 'G3DSA:3.30.160.60:FF:004144', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84443, NULL, 'G3DSA:2.30.30.40:FF:000410', NULL, NULL, 'Chemotaxis protein CheW', NULL, NULL, NULL, NULL, NULL, 4),
(84444, NULL, 'G3DSA:1.10.510.10:FF:000364', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(84445, NULL, 'G3DSA:2.80.10.50:FF:000067', NULL, NULL, 'BnaC05g19630D protein', NULL, NULL, NULL, NULL, NULL, 4),
(84446, NULL, 'G3DSA:1.25.40.20:FF:001033', NULL, NULL, 'Espin', NULL, NULL, NULL, NULL, NULL, 4),
(84447, NULL, 'G3DSA:3.30.40.10:FF:000473', NULL, NULL, 'E3 ubiquitin-protein ligase RHF2A', NULL, NULL, NULL, NULL, NULL, 4),
(84448, NULL, 'G3DSA:3.40.50.150:FF:000665', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84449, NULL, 'G3DSA:3.40.50.300:FF:008563', NULL, NULL, 'Blr8088 protein', NULL, NULL, NULL, NULL, NULL, 4),
(84450, NULL, 'G3DSA:2.130.10.10:FF:003127', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(84451, NULL, 'G3DSA:1.10.510.10:FF:000420', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(84452, NULL, 'G3DSA:2.20.25.10:FF:000058', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(84453, NULL, 'G3DSA:2.20.25.10:FF:000114', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(84454, NULL, 'G3DSA:1.20.1070.10:FF:000253', NULL, NULL, 'prostaglandin E2 receptor EP1 subtype', NULL, NULL, NULL, NULL, NULL, 4),
(84455, NULL, 'G3DSA:3.30.160.60:FF:003363', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84456, NULL, 'G3DSA:2.60.120.260:FF:000019', NULL, NULL, 'Anaphase-promoting complex subunit 10', NULL, NULL, NULL, NULL, NULL, 4),
(84457, NULL, 'G3DSA:3.40.630.10:FF:000431', NULL, NULL, 'Cpb1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(84458, NULL, 'G3DSA:1.10.1070.11:FF:000032', NULL, NULL, 'Protein kinase rad3', NULL, NULL, NULL, NULL, NULL, 4),
(84459, NULL, 'G3DSA:1.20.120.1080:FF:000107', NULL, NULL, 'DEAH-box RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(84460, NULL, 'G3DSA:2.80.10.50:FF:000123', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(84461, NULL, 'G3DSA:3.40.50.300:FF:006707', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(84462, NULL, 'G3DSA:1.10.418.10:FF:000121', NULL, NULL, 'Calponin domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(84463, NULL, 'G3DSA:1.20.5.1500:FF:000001', NULL, NULL, 'Nucleosome assembly protein 1-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(84464, NULL, 'G3DSA:2.60.40.10:FF:005476', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84465, NULL, 'G3DSA:2.30.40.10:FF:000076', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(84466, NULL, 'G3DSA:1.20.1070.10:FF:000781', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84467, NULL, 'G3DSA:3.30.160.60:FF:003891', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84468, NULL, 'G3DSA:1.10.8.270:FF:000030', NULL, NULL, 'Ypt/Rab-GAP domain of gyp1p superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(84469, NULL, 'G3DSA:3.30.428.70:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84470, NULL, 'G3DSA:3.40.50.1780:FF:000001', NULL, NULL, 'Nuclear prelamin A recognition factor', NULL, NULL, NULL, NULL, NULL, 4),
(84471, NULL, 'G3DSA:1.10.10.10:FF:000128', NULL, NULL, 'DNA-binding protein RFX5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(84472, NULL, 'G3DSA:3.40.50.1000:FF:000048', NULL, NULL, 'Phosphoserine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(84473, NULL, 'G3DSA:2.40.30.10:FF:000345', NULL, NULL, 'Elongation factor EF-2', NULL, NULL, NULL, NULL, NULL, 4),
(84474, NULL, 'G3DSA:1.20.5.2440:FF:000013', NULL, NULL, 'rab11 family-interacting protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(84475, NULL, 'G3DSA:2.70.170.10:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84476, NULL, 'G3DSA:3.30.1330.40:FF:000048', NULL, NULL, 'YALI0F14553p', NULL, NULL, NULL, NULL, NULL, 4),
(84477, NULL, 'G3DSA:1.10.510.10:FF:004107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84478, NULL, 'G3DSA:1.10.10.10:FF:000656', NULL, NULL, 'Regulatory protein RecX', NULL, NULL, NULL, NULL, NULL, 4),
(84479, NULL, 'G3DSA:3.80.10.10:FF:003678', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84480, NULL, 'G3DSA:3.40.50.620:FF:000525', NULL, NULL, 'ATP sulfurylase 1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(84481, NULL, 'G3DSA:3.40.50.920:FF:000025', NULL, NULL, '1-deoxy-D-xylulose-5-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(84482, NULL, 'G3DSA:2.60.40.10:FF:001261', NULL, NULL, 'immunoglobulin superfamily member 5', NULL, NULL, NULL, NULL, NULL, 4),
(84483, NULL, 'G3DSA:3.30.70.3040:FF:000005', NULL, NULL, 'Cell division protein FtsX', NULL, NULL, NULL, NULL, NULL, 4),
(84484, NULL, 'G3DSA:3.30.200.20:FF:001601', NULL, NULL, 'Serine/threonine protein kinase, putative (AFU_orthologue AFUA_5G07950)', NULL, NULL, NULL, NULL, NULL, 4),
(84485, NULL, 'G3DSA:2.10.220.10:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84486, NULL, 'G3DSA:1.25.40.20:FF:000757', NULL, NULL, 'Mechanosensory transduction channel NOMPC', NULL, NULL, NULL, NULL, NULL, 4),
(84487, NULL, 'G3DSA:3.40.50.10310:FF:000002', NULL, NULL, 'Putative mycofactocin system creatinine amidohydrolase family protein MftE', NULL, NULL, NULL, NULL, NULL, 4),
(84488, NULL, 'G3DSA:3.40.50.10490:FF:000067', NULL, NULL, 'Glucose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(84489, NULL, 'G3DSA:3.30.500.10:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84490, NULL, 'G3DSA:3.30.420.40:FF:000342', NULL, NULL, 'Actin-related protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(84491, NULL, 'G3DSA:2.160.20.80:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84492, NULL, 'G3DSA:1.10.540.10:FF:000045', NULL, NULL, 'Acyl-CoA dehydrogenase FadE2', NULL, NULL, NULL, NULL, NULL, 4),
(84493, NULL, 'G3DSA:3.30.1330.20:FF:000042', NULL, NULL, 'Tubulin alpha-2 chain', NULL, NULL, NULL, NULL, NULL, 4),
(84494, NULL, 'G3DSA:3.80.10.10:FF:002189', NULL, NULL, 'Toll-like receptor 22', NULL, NULL, NULL, NULL, NULL, 4),
(84495, NULL, 'G3DSA:2.40.70.10:FF:000319', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84496, NULL, 'G3DSA:1.10.540.10:FF:000101', NULL, NULL, 'Acyl-CoA dehydrogenase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(84497, NULL, 'G3DSA:1.25.40.990:FF:000071', NULL, NULL, 'Putative peptidase C48 domain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(84498, NULL, 'G3DSA:3.30.70.330:FF:000068', NULL, NULL, 'ATP-dependent RNA helicase DeaD', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(84499, NULL, 'G3DSA:3.90.70.10:FF:000320', NULL, NULL, 'Uncharacterized protein F31E3.4', NULL, NULL, NULL, NULL, NULL, 4),
(84500, NULL, 'G3DSA:2.130.10.10:FF:001946', NULL, NULL, 'WD40 repeat-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(84501, NULL, 'G3DSA:3.30.420.40:FF:000718', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(84502, NULL, 'G3DSA:3.40.50.460:FF:000022', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(84503, NULL, 'G3DSA:2.60.200.20:FF:000199', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(84504, NULL, 'G3DSA:3.60.21.10:FF:000219', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(84505, NULL, 'G3DSA:2.130.10.10:FF:005656', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(84506, NULL, 'G3DSA:1.10.287.1270:FF:000003', NULL, NULL, 'G protein-coupled receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(84507, NULL, 'G3DSA:1.20.900.10:FF:000094', NULL, NULL, 'Dynamin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(84508, NULL, 'G3DSA:3.30.70.580:FF:000002', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(84509, NULL, 'G3DSA:3.30.460.10:FF:000212', NULL, NULL, 'RNA editing 3'' terminal uridylyl transferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(84510, NULL, 'G3DSA:3.50.50.100:FF:000030', NULL, NULL, 'External alternative NAD(P)H-ubiquinone oxidoreductase B4, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(84511, NULL, 'G3DSA:1.20.5.110:FF:000210', NULL, NULL, 'Syntaxin-16', NULL, NULL, NULL, NULL, NULL, 4),
(84512, NULL, 'G3DSA:2.30.30.30:FF:000109', NULL, NULL, '50S ribosomal protein L24', NULL, NULL, NULL, NULL, NULL, 4),
(84513, NULL, 'G3DSA:1.10.8.720:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84514, NULL, 'G3DSA:2.70.150.10:FF:000296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84515, NULL, 'G3DSA:2.60.120.970:FF:000029', NULL, NULL, 'Bone morphogenetic protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(84516, NULL, 'G3DSA:1.25.40.10:FF:003593', NULL, NULL, 'Clustered mitochondria protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(84517, NULL, 'G3DSA:3.30.260.10:FF:000028', NULL, NULL, 'T-complex protein 1 subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(84518, NULL, 'G3DSA:1.20.1250.20:FF:001512', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84519, NULL, 'G3DSA:4.10.400.10:FF:000243', NULL, NULL, 'SCO-spondin', NULL, NULL, NULL, NULL, NULL, 4),
(84520, NULL, 'G3DSA:3.40.50.10470:FF:000061', NULL, NULL, 'Methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(84521, NULL, 'G3DSA:1.25.10.10:FF:002461', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84522, NULL, 'G3DSA:3.90.70.80:FF:000083', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(84523, NULL, 'G3DSA:2.60.40.10:FF:001637', NULL, NULL, 'Down syndrome cell adhesion molecule 3, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(84524, NULL, 'G3DSA:1.20.1050.80:FF:000014', NULL, NULL, 'Muk1p', NULL, NULL, NULL, NULL, NULL, 4),
(84525, NULL, 'G3DSA:2.60.40.10:FF:003003', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(84526, NULL, 'G3DSA:2.30.30.40:FF:000354', NULL, NULL, 'Guanine nucleotide exchange factor UNC-73A', NULL, NULL, NULL, NULL, NULL, 4),
(84527, NULL, 'G3DSA:1.25.40.20:FF:000813', NULL, NULL, 'Ankyrin repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(84528, NULL, 'G3DSA:2.40.50.140:FF:000458', NULL, NULL, '23S rRNA (uracil(1939)-C(5))-methyltransferase RlmD', NULL, NULL, NULL, NULL, NULL, 4),
(84529, NULL, 'G3DSA:3.80.10.10:FF:003734', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84530, NULL, 'G3DSA:3.40.50.10480:FF:000007', NULL, NULL, 'Ribosome production factor 1, putative', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(84531, NULL, 'G3DSA:3.40.250.10:FF:000205', NULL, NULL, 'Dual specificity phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(84532, NULL, 'G3DSA:1.20.1070.10:FF:001742', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(84533, NULL, 'G3DSA:1.20.5.340:FF:000077', NULL, NULL, 'Serine/threonine-protein kinase Genghis Khan-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(84534, NULL, 'G3DSA:3.40.50.300:FF:002436', NULL, NULL, 'Protein RecA', NULL, NULL, NULL, NULL, NULL, 4),
(84535, NULL, 'G3DSA:3.40.50.800:FF:000079', NULL, NULL, 'Putative proline--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(84536, NULL, 'G3DSA:3.30.450.20:FF:000299', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(84537, NULL, 'G3DSA:2.30.180.10:FF:000121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84538, NULL, 'G3DSA:3.40.50.200:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84539, NULL, 'G3DSA:3.30.200.20:FF:000640', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84540, NULL, 'G3DSA:3.40.50.10180:FF:000002', NULL, NULL, 'glycerate kinase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(84541, NULL, 'G3DSA:3.10.105.10:FF:000049', NULL, NULL, 'Peptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(84542, NULL, 'G3DSA:3.40.50.1820:FF:000614', NULL, NULL, 'CG14717 protein', NULL, NULL, NULL, NULL, NULL, 4),
(84543, NULL, 'G3DSA:3.40.50.10870:FF:000001', NULL, NULL, 'Beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(84544, NULL, 'G3DSA:2.30.130.40:FF:000037', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(84545, NULL, 'G3DSA:3.60.10.10:FF:000138', NULL, NULL, 'Carbon catabolite repressor protein 4 homolog 6', NULL, NULL, NULL, NULL, NULL, 4),
(84546, NULL, 'G3DSA:3.30.70.330:FF:001557', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84547, NULL, 'G3DSA:2.60.120.10:FF:000285', NULL, NULL, '1,2-dihydroxy-3-keto-5-methylthiopentene dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(84548, NULL, 'G3DSA:3.40.50.1980:FF:000145', NULL, NULL, 'Periplasmic binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(84549, NULL, 'G3DSA:3.30.200.20:FF:000112', NULL, NULL, 'Lectin-domain containing receptor kinase A4.3', NULL, NULL, NULL, NULL, NULL, 4),
(84550, NULL, 'G3DSA:1.20.1070.10:FF:000629', NULL, NULL, 'G protein-coupled receptor 171', NULL, NULL, NULL, NULL, NULL, 4),
(84551, NULL, 'G3DSA:3.30.1370.150:FF:000001', NULL, NULL, 'YibL family ribosome-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(84552, NULL, 'G3DSA:3.30.160.60:FF:003739', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84553, NULL, 'G3DSA:1.20.1310.10:FF:000109', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84554, NULL, 'G3DSA:2.60.40.10:FF:002750', NULL, NULL, 'Seminal vesicle antigen-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(84555, NULL, 'G3DSA:1.20.1090.10:FF:000052', NULL, NULL, 'Bifunctional shikimate kinase/3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(84556, NULL, 'G3DSA:3.40.532.10:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84557, NULL, 'G3DSA:3.40.50.800:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84558, NULL, 'G3DSA:3.30.160.60:FF:006089', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84559, NULL, 'G3DSA:1.10.274.30:FF:000011', NULL, NULL, 'Dosage compensation regulatory complex protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84560, NULL, 'G3DSA:1.10.510.10:FF:002893', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84561, NULL, 'G3DSA:3.40.50.12760:FF:000006', NULL, NULL, 'Methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84562, NULL, 'G3DSA:1.25.40.10:FF:000720', NULL, NULL, 'Pre-mRNA-splicing factor SYF1', NULL, NULL, NULL, NULL, NULL, 4),
(84563, NULL, 'G3DSA:3.40.50.1220:FF:000002', NULL, NULL, 'NAD(P) transhydrogenase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(84564, NULL, 'G3DSA:3.40.30.10:FF:000691', NULL, NULL, 'Monothiol glutaredoxin-S17', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(84565, NULL, 'G3DSA:3.40.50.300:FF:003925', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84566, NULL, 'G3DSA:3.10.20.90:FF:000030', NULL, NULL, 'Apoptosis-stimulating of p53 protein 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(84567, NULL, 'G3DSA:1.10.400.10:FF:000030', NULL, NULL, 'Guanine nucleotide-binding protein alpha-8 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(84568, NULL, 'G3DSA:2.60.40.10:FF:002042', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(84569, NULL, 'G3DSA:3.30.200.20:FF:000820', NULL, NULL, 'Cyclin-dependent kinase-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(84570, NULL, 'G3DSA:3.90.70.10:FF:000135', NULL, NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit pan2', NULL, NULL, NULL, NULL, NULL, 4),
(84571, NULL, 'G3DSA:3.30.160.60:FF:003924', NULL, NULL, 'REgulator of Fusion', NULL, NULL, NULL, NULL, NULL, 4),
(84572, NULL, 'G3DSA:3.30.420.10:FF:000558', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84573, NULL, 'G3DSA:3.30.1380.20:FF:000045', NULL, NULL, 'Uncharacterized protein C13G6.05c', NULL, NULL, NULL, NULL, NULL, 4),
(84574, NULL, 'G3DSA:2.30.110.10:FF:000078', NULL, NULL, 'Flavin reductase', NULL, NULL, NULL, NULL, NULL, 4),
(84575, NULL, 'G3DSA:3.30.70.890:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84576, NULL, 'G3DSA:3.30.470.10:FF:000038', NULL, NULL, 'Slr0887 protein', NULL, NULL, NULL, NULL, NULL, 4),
(84577, NULL, 'G3DSA:1.10.150.190:FF:000005', NULL, NULL, 'Eukaryotic translation initiation factor 2 subunit alpha, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84578, NULL, 'G3DSA:2.60.40.3110:FF:000003', NULL, NULL, 'Outer membrane usher protein FasD', NULL, NULL, NULL, NULL, NULL, 4),
(84579, NULL, 'G3DSA:1.10.720.30:FF:000060', NULL, NULL, 'Poly [ADP-ribose] polymerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(84580, NULL, 'G3DSA:3.60.21.10:FF:000366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84581, NULL, 'G3DSA:3.30.70.330:FF:001613', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84582, NULL, 'G3DSA:1.50.10.10:FF:000008', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(84583, NULL, 'G3DSA:2.130.10.10:FF:002166', NULL, NULL, 'Damage-specific DNA binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(84584, NULL, 'G3DSA:3.30.160.60:FF:004200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84585, NULL, 'G3DSA:2.40.50.140:FF:000082', NULL, NULL, 'DNA helicase MCM8 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(84586, NULL, 'G3DSA:3.40.630.30:FF:000061', NULL, NULL, 'N(alpha)-acetyltransferase 80, NatH catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(84587, NULL, 'G3DSA:1.10.1420.10:FF:000069', NULL, NULL, 'Mismatch repair protein MSH3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84588, NULL, 'G3DSA:4.10.410.10:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84589, NULL, 'G3DSA:2.60.40.3800:FF:000002', NULL, NULL, 'Lys-gingipain W83', NULL, NULL, NULL, NULL, NULL, 4),
(84590, NULL, 'G3DSA:3.30.70.330:FF:002541', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84591, NULL, 'G3DSA:3.90.550.50:FF:000072', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(84592, NULL, 'G3DSA:3.40.50.1110:FF:000025', NULL, NULL, 'Lipolytic enzyme G-D-S-L family', NULL, NULL, NULL, NULL, NULL, 4),
(84593, NULL, 'G3DSA:1.20.1270.60:FF:000171', NULL, NULL, 'Rho GTPase-activating protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(84594, NULL, 'G3DSA:1.20.1250.20:FF:000023', NULL, NULL, 'Solute carrier family 22 member 6', NULL, NULL, NULL, NULL, NULL, 4),
(84595, NULL, 'G3DSA:3.30.450.20:FF:000484', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(84596, NULL, 'G3DSA:3.30.70.330:FF:002013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84597, NULL, 'G3DSA:3.90.70.10:FF:000843', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84598, NULL, 'G3DSA:1.10.238.10:FF:000843', NULL, NULL, 'Penta-EF-hand domain containing 1', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(84599, NULL, 'G3DSA:1.10.10.980:FF:000004', NULL, NULL, 'CST complex subunit STN1', NULL, NULL, NULL, NULL, NULL, 4),
(84600, NULL, 'G3DSA:2.60.220.50:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84601, NULL, 'G3DSA:3.80.10.10:FF:000244', NULL, NULL, 'Monocyte differentiation antigen CD14', NULL, NULL, NULL, NULL, NULL, 4),
(84602, NULL, 'G3DSA:1.20.120.1900:FF:000073', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(84603, NULL, 'G3DSA:3.30.40.10:FF:001434', NULL, NULL, 'SWI/SNF family DNA-dependent ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84604, NULL, 'G3DSA:3.80.30.20:FF:000012', NULL, NULL, 'Coproporphyrinogen-III oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(84605, NULL, 'G3DSA:2.60.40.10:FF:002565', NULL, NULL, 'CD4', NULL, NULL, NULL, NULL, NULL, 4),
(84606, NULL, 'G3DSA:2.130.10.130:FF:000009', NULL, NULL, 'Alpha L integrin', NULL, NULL, NULL, NULL, NULL, 4),
(84607, NULL, 'G3DSA:3.40.630.30:FF:000622', NULL, NULL, 'Uncharacterized N-acetyltransferase C18E5.08', NULL, NULL, NULL, NULL, NULL, 4),
(84608, NULL, 'G3DSA:1.20.272.10:FF:000021', NULL, NULL, 'Replication factor C subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(84609, NULL, 'G3DSA:2.40.50.1060:FF:000005', NULL, NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(84610, NULL, 'G3DSA:3.10.490.10:FF:000027', NULL, NULL, 'Gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(84611, NULL, 'G3DSA:2.120.10.30:FF:000368', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84612, NULL, 'G3DSA:3.30.9.10:FF:000092', NULL, NULL, 'Aklavinone 12-hydroxylase RdmE', NULL, NULL, NULL, NULL, NULL, 4),
(84613, NULL, 'G3DSA:1.25.40.10:FF:004407', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84614, NULL, 'G3DSA:3.50.50.60:FF:001499', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84615, NULL, 'G3DSA:3.40.30.10:FF:001000', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84616, NULL, 'G3DSA:3.30.2350.20:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84617, NULL, 'G3DSA:1.10.510.10:FF:003854', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84618, NULL, 'G3DSA:3.30.70.1020:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84619, NULL, 'G3DSA:3.40.630.150:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84620, NULL, 'G3DSA:6.10.140.2220:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84621, NULL, 'G3DSA:3.40.50.410:FF:000288', NULL, NULL, 'Inverted repeat-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(84622, NULL, 'G3DSA:1.50.40.10:FF:000364', NULL, NULL, 'Related to folate transporter/carrier (Mitochondrial)', NULL, NULL, NULL, NULL, NULL, 4),
(84623, NULL, 'G3DSA:1.10.10.830:FF:000010', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(84624, NULL, 'G3DSA:3.30.420.10:FF:000182', NULL, NULL, 'YDR514C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(84625, NULL, 'G3DSA:3.10.350.10:FF:000012', NULL, NULL, 'Membrane-bound lytic murein transglycosylase D', NULL, NULL, NULL, NULL, NULL, 4),
(84626, NULL, 'G3DSA:1.10.150.240:FF:000099', NULL, NULL, 'Putative pseudouridine-5''-monophosphatase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(84627, NULL, 'G3DSA:1.10.1060.10:FF:000030', NULL, NULL, 'Heterodisulfide oxidoreductase, iron-sulfur cluster-binding subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(84628, NULL, 'G3DSA:3.40.80.10:FF:000019', NULL, NULL, 'GD14168', NULL, NULL, NULL, NULL, NULL, 4),
(84629, NULL, 'G3DSA:3.40.720.10:FF:000258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84630, NULL, 'G3DSA:3.40.50.300:FF:002964', NULL, NULL, 'ATP-dependent helicase SGS1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84631, NULL, 'G3DSA:3.90.1750.10:FF:000023', NULL, NULL, 'probable E3 ubiquitin-protein ligase HECTD2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(84632, NULL, 'G3DSA:3.10.20.90:FF:000406', NULL, NULL, 'Putative conserved membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(84633, NULL, 'G3DSA:1.20.58.60:FF:000191', NULL, NULL, 'Spectrin, beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(84634, NULL, 'G3DSA:2.30.29.30:FF:000988', NULL, NULL, 'Rho GTPase-activating protein 20', NULL, NULL, NULL, NULL, NULL, 4),
(84635, NULL, 'G3DSA:2.60.40.10:FF:005999', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84636, NULL, 'G3DSA:3.40.50.11840:FF:000005', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(84637, NULL, 'G3DSA:1.10.506.10:FF:000022', NULL, NULL, 'neurofibromin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(84638, NULL, 'G3DSA:3.30.1330.30:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84639, NULL, 'G3DSA:1.10.287.130:FF:000003', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(84640, NULL, 'G3DSA:3.30.1010.10:FF:000105', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(84641, NULL, 'G3DSA:3.40.50.1000:FF:000195', NULL, NULL, 'SDT1p Pyrimidine nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(84642, NULL, 'G3DSA:3.30.70.1450:FF:000023', NULL, NULL, 'Trk system potassium uptake protein TrkA', NULL, NULL, NULL, NULL, NULL, 4),
(84643, NULL, 'G3DSA:1.10.565.10:FF:000119', NULL, NULL, 'Nuclear hormone receptor family member nhr-121', NULL, NULL, NULL, NULL, NULL, 4),
(84644, NULL, 'G3DSA:1.10.246.90:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84645, NULL, 'G3DSA:2.30.29.30:FF:001264', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(84646, NULL, 'G3DSA:3.40.50.1100:FF:000112', NULL, NULL, '1-aminocyclopropane-1-carboxylate deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(84647, NULL, 'G3DSA:3.40.50.1000:FF:000380', NULL, NULL, 'CTD small phosphatase-like protein isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(84648, NULL, 'G3DSA:1.10.510.10:FF:003146', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84649, NULL, 'G3DSA:3.40.30.10:FF:000539', NULL, NULL, 'GH08893p', NULL, NULL, NULL, NULL, NULL, 4),
(84650, NULL, 'G3DSA:3.40.630.30:FF:000437', NULL, NULL, 'Acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(84651, NULL, 'G3DSA:3.30.930.10:FF:000265', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(84652, NULL, 'G3DSA:2.60.40.60:FF:000410', NULL, NULL, 'Cadherin-4', NULL, NULL, NULL, NULL, NULL, 4),
(84653, NULL, 'G3DSA:1.20.1280.50:FF:000039', NULL, NULL, 'F-box and WD repeat domain containing 10', NULL, NULL, NULL, NULL, NULL, 4),
(84654, NULL, 'G3DSA:3.90.1100.10:FF:000014', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(84655, NULL, 'G3DSA:3.90.1170.50:FF:000013', NULL, NULL, 'Nicotinate dehydrogenase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(84656, NULL, 'G3DSA:1.10.510.10:FF:000476', NULL, NULL, 'PAS domain-containing protein tyrosine kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(84657, NULL, 'G3DSA:3.40.50.1820:FF:000878', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84658, NULL, 'G3DSA:3.30.160.60:FF:005369', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84659, NULL, 'G3DSA:3.90.340.10:FF:000010', NULL, NULL, 'Inducible nitric oxide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(84660, NULL, 'G3DSA:1.20.1730.10:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84661, NULL, 'G3DSA:2.30.310.10:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84662, NULL, 'G3DSA:3.10.110.10:FF:000202', NULL, NULL, 'YALI0E29601p', NULL, NULL, NULL, NULL, NULL, 4),
(84663, NULL, 'G3DSA:1.10.150.20:FF:000119', NULL, NULL, 'GM24241', NULL, NULL, NULL, NULL, NULL, 4),
(84664, NULL, 'G3DSA:3.40.50.300:FF:004701', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84665, NULL, 'G3DSA:3.90.1520.10:FF:000006', NULL, NULL, 'guanylate cyclase soluble subunit beta-2-like', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(84666, NULL, 'G3DSA:3.90.70.10:FF:000287', NULL, NULL, 'Ubiquitin specific peptidase 37', NULL, NULL, NULL, NULL, NULL, 4),
(84667, NULL, 'G3DSA:1.25.40.10:FF:004082', NULL, NULL, 'Hepatocellular carcinoma-associated antigen, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84668, NULL, 'G3DSA:3.30.160.20:FF:000052', NULL, NULL, 'Peptide chain release factor H', NULL, NULL, NULL, NULL, NULL, 4),
(84669, NULL, 'G3DSA:3.60.40.10:FF:000090', NULL, NULL, 'Protein phosphatase 2C', NULL, NULL, NULL, NULL, NULL, 4),
(84670, NULL, 'G3DSA:1.20.1250.20:FF:001725', NULL, NULL, 'Chromosome 23, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(84671, NULL, 'G3DSA:1.10.246.10:FF:000007', NULL, NULL, 'Vitamin D-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(84672, NULL, 'G3DSA:2.60.40.10:FF:001558', NULL, NULL, 'Immunoglobulin superfamily member 22', NULL, NULL, NULL, NULL, NULL, 4),
(84673, NULL, 'G3DSA:3.90.840.10:FF:000003', NULL, NULL, 'Thiol-activated cytolysin', NULL, NULL, NULL, NULL, NULL, 4),
(84674, NULL, 'G3DSA:2.60.40.10:FF:005892', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84675, NULL, 'G3DSA:1.10.246.170:FF:000001', NULL, NULL, 'Mrpl8p', NULL, NULL, NULL, NULL, NULL, 4),
(84676, NULL, 'G3DSA:1.10.3460.10:FF:000038', NULL, NULL, 'Early light-inducible protein', NULL, NULL, NULL, NULL, NULL, 4),
(84677, NULL, 'G3DSA:1.10.1660.10:FF:000019', NULL, NULL, 'Transcriptional regulator MerR family', NULL, NULL, NULL, NULL, NULL, 4),
(84678, NULL, 'G3DSA:4.10.280.10:FF:000215', NULL, NULL, 'HER-2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(84679, NULL, 'G3DSA:3.20.20.70:FF:000462', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(84680, NULL, 'G3DSA:3.30.565.10:FF:000500', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84681, NULL, 'G3DSA:3.30.160.60:FF:001154', NULL, NULL, 'zinc finger and BTB domain-containing protein 40', NULL, NULL, NULL, NULL, NULL, 4),
(84682, NULL, 'G3DSA:4.10.1130.20:FF:000008', NULL, NULL, 'CHORD, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84683, NULL, 'G3DSA:3.40.140.10:FF:000287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84684, NULL, 'G3DSA:3.30.930.10:FF:000001', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(84685, NULL, 'G3DSA:2.40.50.140:FF:000722', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84686, NULL, 'G3DSA:3.30.1490.190:FF:000028', NULL, NULL, 'Ferric uptake regulation protein', NULL, NULL, NULL, NULL, NULL, 4),
(84687, NULL, 'G3DSA:3.40.50.1000:FF:000228', NULL, NULL, 'NIF domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(84688, NULL, 'G3DSA:3.40.50.800:FF:000074', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(84689, NULL, 'G3DSA:3.30.565.10:FF:000388', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84690, NULL, 'G3DSA:3.40.50.300:FF:008012', NULL, NULL, 'DNA polymerase theta', NULL, NULL, NULL, NULL, NULL, 4),
(84691, NULL, 'G3DSA:1.20.58.390:FF:000248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84692, NULL, 'G3DSA:3.30.230.120:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84693, NULL, 'G3DSA:1.20.1310.10:FF:000137', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84694, NULL, 'G3DSA:3.90.760.10:FF:000002', NULL, NULL, 'NADPH-dependent 2,4-dienoyl-CoA reductase, sulfur reductase', NULL, NULL, NULL, NULL, NULL, 4),
(84695, NULL, 'G3DSA:1.20.1640.10:FF:000010', NULL, NULL, 'NPC intracellular cholesterol transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(84696, NULL, 'G3DSA:3.60.20.40:FF:000035', NULL, NULL, 'Os01g0151500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(84697, NULL, 'G3DSA:1.25.40.20:FF:000869', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84698, NULL, 'G3DSA:1.10.20.10:FF:000073', NULL, NULL, 'Histone H4', NULL, NULL, NULL, NULL, NULL, 4),
(84699, NULL, 'G3DSA:2.70.98.20:FF:000025', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(84700, NULL, 'G3DSA:3.30.160.60:FF:004931', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(84701, NULL, 'G3DSA:1.10.1420.10:FF:000125', NULL, NULL, 'DNA mismatch repair protein mutS', NULL, NULL, NULL, NULL, NULL, 4),
(84702, NULL, 'G3DSA:2.40.50.140:FF:001178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84703, NULL, 'G3DSA:3.40.50.1460:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84704, NULL, 'G3DSA:1.10.287.660:FF:000038', NULL, NULL, 'Vacuolar protein sorting-associated protein 37B-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(84705, NULL, 'G3DSA:1.10.10.10:FF:001668', NULL, NULL, 'DDRGK domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84706, NULL, 'G3DSA:3.30.70.1170:FF:000006', NULL, NULL, 'NOL1/NOP2/Sun domain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(84707, NULL, 'G3DSA:1.10.560.10:FF:000136', NULL, NULL, 'T-complex protein 1 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(84708, NULL, 'G3DSA:1.10.3860.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84709, NULL, 'G3DSA:3.90.1600.10:FF:000007', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(84710, NULL, 'G3DSA:1.10.274.20:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84711, NULL, 'G3DSA:2.130.10.10:FF:003678', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84712, NULL, 'G3DSA:3.10.100.10:FF:000325', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84713, NULL, 'G3DSA:2.130.10.10:FF:000013', NULL, NULL, 'semaphorin-6D isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(84714, NULL, 'G3DSA:3.40.50.2300:FF:001360', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84715, NULL, 'G3DSA:2.40.170.20:FF:000071', NULL, NULL, 'SusC homolog', NULL, NULL, NULL, NULL, NULL, 4),
(84716, NULL, 'G3DSA:3.90.550.10:FF:000195', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase like 6', NULL, NULL, NULL, NULL, NULL, 4),
(84717, NULL, 'G3DSA:2.60.40.10:FF:002126', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(84718, NULL, 'G3DSA:3.30.70.20:FF:000011', NULL, NULL, 'Ferredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(84719, NULL, 'G3DSA:4.10.400.10:FF:000304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84720, NULL, 'G3DSA:1.20.144.10:FF:000004', NULL, NULL, 'Undecaprenyl pyrophosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(84721, NULL, 'G3DSA:1.20.1110.10:FF:000077', NULL, NULL, 'ECA1 (ER-TYPE CA2+-ATPASE 1)', NULL, NULL, NULL, NULL, NULL, 4),
(84722, NULL, 'G3DSA:3.40.50.720:FF:001218', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(84723, NULL, 'G3DSA:3.40.50.1010:FF:000118', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(84724, NULL, 'G3DSA:1.20.1270.10:FF:000049', NULL, NULL, 'Heat shock protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84725, NULL, 'G3DSA:1.10.3720.10:FF:000137', NULL, NULL, 'sn-glycerol-3-phosphate transport system permease protein UgpE', NULL, NULL, NULL, NULL, NULL, 4),
(84726, NULL, 'G3DSA:1.25.40.10:FF:005279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84727, NULL, 'G3DSA:2.60.40.10:FF:004431', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84728, NULL, 'G3DSA:2.30.29.30:FF:000275', NULL, NULL, 'Docking protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(84729, NULL, 'G3DSA:3.40.50.2300:FF:000803', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84730, NULL, 'G3DSA:1.25.40.10:FF:001968', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(84731, NULL, 'G3DSA:3.30.420.10:FF:000294', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84732, NULL, 'G3DSA:3.40.50.2000:FF:000871', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84733, NULL, 'G3DSA:3.40.50.720:FF:001606', NULL, NULL, 'YALI0E28182p', NULL, NULL, NULL, NULL, NULL, 4),
(84734, NULL, 'G3DSA:1.10.510.10:FF:000425', NULL, NULL, 'Serine/threonine-protein kinase SRPK', NULL, NULL, NULL, NULL, NULL, 4),
(84735, NULL, 'G3DSA:1.25.40.10:FF:004470', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At5g40405', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(84736, NULL, 'G3DSA:1.25.10.10:FF:001769', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84737, NULL, 'G3DSA:2.160.20.10:FF:000215', NULL, NULL, 'Nitrous oxide maturation protein NosD', NULL, NULL, NULL, NULL, NULL, 4),
(84738, NULL, 'G3DSA:2.130.10.30:FF:000019', NULL, NULL, 'alsin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(84739, NULL, 'G3DSA:2.60.120.10:FF:000280', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(84740, NULL, 'G3DSA:3.40.50.10860:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84741, NULL, 'G3DSA:1.10.3180.10:FF:000005', NULL, NULL, 'Os07g0223600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(84742, NULL, 'G3DSA:2.60.40.10:FF:002918', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84743, NULL, 'G3DSA:3.40.50.150:FF:000401', NULL, NULL, 'Fatty acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(84744, NULL, 'G3DSA:3.40.50.620:FF:000497', NULL, NULL, 'Probable valine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(84745, NULL, 'G3DSA:3.10.28.10:FF:000018', NULL, NULL, 'Intron-encoded DNA endonuclease I-AniI', NULL, NULL, NULL, NULL, NULL, 4),
(84746, NULL, 'G3DSA:2.130.10.10:FF:000805', NULL, NULL, 'Myosin C', NULL, NULL, NULL, NULL, NULL, 4),
(84747, NULL, 'G3DSA:2.60.40.150:FF:000685', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(84748, NULL, 'G3DSA:1.20.1280.50:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84749, NULL, 'G3DSA:2.60.40.60:FF:000702', NULL, NULL, 'Cdh-4', NULL, NULL, NULL, NULL, NULL, 4),
(84750, NULL, 'G3DSA:1.20.1070.10:FF:000101', NULL, NULL, 'Prostaglandin E2 receptor EP4 subtype', NULL, NULL, NULL, NULL, NULL, 4),
(84751, NULL, 'G3DSA:3.30.200.20:FF:000932', NULL, NULL, 'Serine/threonine-protein kinase RIO1', NULL, NULL, NULL, NULL, NULL, 4),
(84752, NULL, 'G3DSA:2.40.10.10:FF:000670', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84753, NULL, 'G3DSA:2.120.10.30:FF:000109', NULL, NULL, 'Dipeptidyl-peptidase 5', NULL, NULL, NULL, NULL, NULL, 4),
(84754, NULL, 'G3DSA:2.60.40.10:FF:004482', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84755, NULL, 'G3DSA:3.40.50.300:FF:006146', NULL, NULL, 'RAB42, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(84756, NULL, 'G3DSA:4.10.1000.10:FF:000018', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(84757, NULL, 'G3DSA:1.25.40.10:FF:001097', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g22760', NULL, NULL, NULL, NULL, NULL, 4),
(84758, NULL, 'G3DSA:2.10.220.10:FF:000130', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(84759, NULL, 'G3DSA:3.20.20.100:FF:000076', NULL, NULL, 'Galactose dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(84760, NULL, 'G3DSA:3.30.70.330:FF:001636', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84761, NULL, 'G3DSA:3.80.10.10:FF:003706', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84762, NULL, 'G3DSA:3.40.50.1820:FF:001834', NULL, NULL, 'Os11g0468300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(84763, NULL, 'G3DSA:3.90.1440.10:FF:000005', NULL, NULL, 'Protein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(84764, NULL, 'G3DSA:1.10.10.1940:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84765, NULL, 'G3DSA:2.60.40.10:FF:000148', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(84766, NULL, 'G3DSA:3.60.21.10:FF:000130', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(84767, NULL, 'G3DSA:1.20.1720.10:FF:000011', NULL, NULL, 'Transporter, major facilitator family', NULL, NULL, NULL, NULL, NULL, 4),
(84768, NULL, 'G3DSA:2.60.40.820:FF:000021', NULL, NULL, 'T-box transcription factor Ci-Tbx15/18/22', NULL, NULL, NULL, NULL, NULL, 4),
(84769, NULL, 'G3DSA:1.10.565.10:FF:000063', NULL, NULL, 'Hormone receptor 83', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(84770, NULL, 'G3DSA:2.60.120.430:FF:000036', NULL, NULL, 'Putative receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(84771, NULL, 'G3DSA:3.30.420.210:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84772, NULL, 'G3DSA:1.20.1420.30:FF:000005', NULL, NULL, 'sodium/potassium/calcium exchanger 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(84773, NULL, 'G3DSA:3.10.290.70:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84774, NULL, 'G3DSA:1.25.10.10:FF:002337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84775, NULL, 'G3DSA:3.30.160.60:FF:006325', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84776, NULL, 'G3DSA:1.25.40.10:FF:004823', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84777, NULL, 'G3DSA:1.10.1580.10:FF:000018', NULL, NULL, 'Guanine nucleotide-binding protein-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(84778, NULL, 'G3DSA:2.30.30.140:FF:000147', NULL, NULL, 'Transcription elongation factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(84779, NULL, 'G3DSA:2.130.10.10:FF:004116', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(84780, NULL, 'G3DSA:3.30.420.40:FF:000578', NULL, NULL, 'Actin', NULL, NULL, NULL, NULL, NULL, 4),
(84781, NULL, 'G3DSA:3.30.70.330:FF:000276', NULL, NULL, 'Splicing factor, CC1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(84782, NULL, 'G3DSA:3.30.450.30:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84783, NULL, 'G3DSA:3.40.50.2020:FF:000085', NULL, NULL, 'Related to ribose-phosphate pyrophosphokinase II', NULL, NULL, NULL, NULL, NULL, 4),
(84784, NULL, 'G3DSA:3.80.10.10:FF:002397', NULL, NULL, 'F-box/LRR-repeat protein 20', NULL, NULL, NULL, NULL, NULL, 4),
(84785, NULL, 'G3DSA:3.90.420.10:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(84786, NULL, 'G3DSA:1.10.3260.10:FF:000006', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(84787, NULL, 'G3DSA:2.120.10.30:FF:000048', NULL, NULL, 'Protein strictosidine synthase-like 10', NULL, NULL, NULL, NULL, NULL, 4),
(84788, NULL, 'G3DSA:4.10.950.10:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84789, NULL, 'G3DSA:2.130.10.10:FF:002430', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84790, NULL, 'G3DSA:1.25.40.10:FF:002053', NULL, NULL, 'tonsoku-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(84791, NULL, 'G3DSA:3.40.50.150:FF:000452', NULL, NULL, 'tRNA m5C-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(84792, NULL, 'G3DSA:3.40.50.150:FF:001862', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84793, NULL, 'G3DSA:3.30.40.10:FF:001350', NULL, NULL, 'Vacuolar segregation protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84794, NULL, 'G3DSA:1.25.40.10:FF:004874', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84795, NULL, 'G3DSA:3.30.420.510:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84796, NULL, 'G3DSA:3.30.420.270:FF:000006', NULL, NULL, 'Biopolymer transporter ExbD', NULL, NULL, NULL, NULL, NULL, 4),
(84797, NULL, 'G3DSA:3.30.460.10:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84798, NULL, 'G3DSA:3.10.100.10:FF:000437', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84799, NULL, 'G3DSA:3.20.20.330:FF:000009', NULL, NULL, 'Bifunctional homocysteine S-methyltransferase/5,10-methylenetetrahydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(84800, NULL, 'G3DSA:3.20.20.100:FF:000025', NULL, NULL, 'NADP(+)-dependent glycerol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(84801, NULL, 'G3DSA:1.10.472.10:FF:000550', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84802, NULL, 'G3DSA:1.10.287.1490:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84803, NULL, 'G3DSA:2.40.170.20:FF:000020', NULL, NULL, 'TonB-dependent receptor', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(84804, NULL, 'G3DSA:1.20.140.10:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84805, NULL, 'G3DSA:2.40.128.600:FF:000001', NULL, NULL, 'Penicillin-binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(84806, NULL, 'G3DSA:1.25.40.180:FF:000266', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84807, NULL, 'G3DSA:1.20.5.690:FF:000007', NULL, NULL, 'Importin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(84808, NULL, 'G3DSA:1.10.3720.10:FF:000025', NULL, NULL, 'Dipeptide ABC transporter permease DppB', NULL, NULL, NULL, NULL, NULL, 4),
(84809, NULL, 'G3DSA:2.60.120.330:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84810, NULL, 'G3DSA:3.40.850.10:FF:000526', NULL, NULL, 'Kinesin like protein KLP-13', NULL, NULL, NULL, NULL, NULL, 4),
(84811, NULL, 'G3DSA:3.40.50.880:FF:000092', NULL, NULL, 'Putative carbamoyl-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(84812, NULL, 'G3DSA:3.20.20.80:FF:000740', NULL, NULL, 'Iduronidase alpha-L-', NULL, NULL, NULL, NULL, NULL, 4),
(84813, NULL, 'G3DSA:4.10.830.40:FF:000008', NULL, NULL, 'Probable E3 ubiquitin-protein ligase TRIM8', NULL, NULL, NULL, NULL, NULL, 4),
(84814, NULL, 'G3DSA:3.90.230.10:FF:000069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84815, NULL, 'G3DSA:1.20.1250.10:FF:000087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84816, NULL, 'G3DSA:3.40.50.300:FF:003745', NULL, NULL, 'ATP-binding cassette transporter, subfamily B, member 19, group MDR/PGP protein PpABCB19', NULL, NULL, NULL, NULL, NULL, 4),
(84817, NULL, 'G3DSA:2.130.10.10:FF:003627', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84818, NULL, 'G3DSA:3.30.505.10:FF:000171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84819, NULL, 'G3DSA:2.60.40.10:FF:004543', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84820, NULL, 'G3DSA:3.40.640.10:FF:000460', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84821, NULL, 'G3DSA:2.160.20.80:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84822, NULL, 'G3DSA:2.40.128.620:FF:000007', NULL, NULL, 'Uncharacterized protein LGR3', NULL, NULL, NULL, NULL, NULL, 4),
(84823, NULL, 'G3DSA:2.170.270.10:FF:000230', NULL, NULL, 'SET and MYND domain containing, arthropod-specific, member 4, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(84824, NULL, 'G3DSA:1.10.3080.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84825, NULL, 'G3DSA:2.40.10.350:FF:000007', NULL, NULL, 'Rod shape-determining protein MreC', NULL, NULL, NULL, NULL, NULL, 4),
(84826, NULL, 'G3DSA:1.25.10.10:FF:001269', NULL, NULL, 'Exportin 5', NULL, NULL, NULL, NULL, NULL, 4),
(84827, NULL, 'G3DSA:1.20.920.30:FF:000011', NULL, NULL, 'Dynein beta chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84828, NULL, 'G3DSA:2.130.10.10:FF:004167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84829, NULL, 'G3DSA:1.10.260.40:FF:000038', NULL, NULL, 'HTH-type transcriptional regulator hipB', NULL, NULL, NULL, NULL, NULL, 4),
(84830, NULL, 'G3DSA:3.10.110.10:FF:000270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84831, NULL, 'G3DSA:3.30.1460.50:FF:000010', NULL, NULL, 'Hemolysin', NULL, NULL, NULL, NULL, NULL, 4),
(84832, NULL, 'G3DSA:2.10.110.10:FF:000301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84833, NULL, 'G3DSA:3.40.930.10:FF:000027', NULL, NULL, 'Anion exchange protein', NULL, NULL, NULL, NULL, NULL, 4),
(84834, NULL, 'G3DSA:1.25.40.10:FF:002406', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g28690, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(84835, NULL, 'G3DSA:3.30.40.10:FF:000001', NULL, NULL, 'chromodomain-helicase-DNA-binding protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(84836, NULL, 'G3DSA:1.20.970.10:FF:000036', NULL, NULL, 'Anthranilate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(84837, NULL, 'G3DSA:3.40.50.1820:FF:000474', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(84838, NULL, 'G3DSA:4.10.1080.10:FF:000006', NULL, NULL, 'Thrombospondin 3', NULL, NULL, NULL, NULL, NULL, 4),
(84839, NULL, 'G3DSA:3.30.70.270:FF:000117', NULL, NULL, 'GGDEF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(84840, NULL, 'G3DSA:3.40.50.1820:FF:001334', NULL, NULL, 'Probable endo-1,4-beta-xylanase Z [precursor]', NULL, NULL, NULL, NULL, NULL, 4),
(84841, NULL, 'G3DSA:3.40.50.1820:FF:000766', NULL, NULL, 'Acylglycerol lipase', NULL, NULL, NULL, NULL, NULL, 4),
(84842, NULL, 'G3DSA:1.10.418.60:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84843, NULL, 'G3DSA:1.20.1070.10:FF:001057', NULL, NULL, 'Putative glycoprotein hormone G-protein coupled receptor', NULL, NULL, NULL, NULL, NULL, 4),
(84844, NULL, 'G3DSA:3.40.50.2300:FF:000011', NULL, NULL, 'Cell cycle response regulator CtrA', NULL, NULL, NULL, NULL, NULL, 4),
(84845, NULL, 'G3DSA:2.60.40.1510:FF:000017', NULL, NULL, 'Integrin subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(84846, NULL, 'G3DSA:1.25.40.730:FF:000004', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(84847, NULL, 'G3DSA:1.10.10.10:FF:001589', NULL, NULL, 'Hydroxyindole O-methyltransferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(84848, NULL, 'G3DSA:3.40.630.30:FF:000201', NULL, NULL, 'NAA30 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(84849, NULL, 'G3DSA:3.30.930.10:FF:000405', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84850, NULL, 'G3DSA:2.60.40.10:FF:004931', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84851, NULL, 'G3DSA:3.40.50.300:FF:004622', NULL, NULL, 'Ciliary dynein heavy chain 11', NULL, NULL, NULL, NULL, NULL, 4),
(84852, NULL, 'G3DSA:1.25.40.20:FF:000026', NULL, NULL, 'ankyrin repeat domain-containing protein 17 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(84853, NULL, 'G3DSA:1.10.238.10:FF:000343', NULL, NULL, 'RHBDL3 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(84854, NULL, 'G3DSA:1.10.1760.10:FF:000004', NULL, NULL, 'ARP2/3 complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(84855, NULL, 'G3DSA:3.30.160.60:FF:005448', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84856, NULL, 'G3DSA:3.50.50.60:FF:000510', NULL, NULL, 'Dihydropyrimidine dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84857, NULL, 'G3DSA:3.10.250.10:FF:000133', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84858, NULL, 'G3DSA:2.60.40.10:FF:002065', NULL, NULL, 'Neural cell adhesion molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(84859, NULL, 'G3DSA:4.10.520.10:FF:000010', NULL, NULL, 'Integration host factor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(84860, NULL, 'G3DSA:2.40.50.140:FF:001099', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84861, NULL, 'G3DSA:3.10.290.10:FF:000097', NULL, NULL, 'Uncharacterized RNA pseudouridine synthase MG209', NULL, NULL, NULL, NULL, NULL, 4),
(84862, NULL, 'G3DSA:2.60.120.260:FF:000255', NULL, NULL, 'Extracellular serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(84863, NULL, 'G3DSA:1.25.10.10:FF:000831', NULL, NULL, 'Importin subunit alpha-7, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84864, NULL, 'G3DSA:3.30.70.270:FF:000297', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84865, NULL, 'G3DSA:2.120.10.80:FF:000361', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84866, NULL, 'G3DSA:2.10.110.10:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84867, NULL, 'G3DSA:2.40.155.10:FF:000004', NULL, NULL, 'Green fluorescent protein', NULL, NULL, NULL, NULL, NULL, 4),
(84868, NULL, 'G3DSA:1.10.510.10:FF:002393', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84869, NULL, 'G3DSA:1.10.10.60:FF:000862', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84870, NULL, 'G3DSA:2.30.30.40:FF:000298', NULL, NULL, 'Rho GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(84871, NULL, 'G3DSA:3.30.450.20:FF:000692', NULL, NULL, 'Putative two-component system sensor kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(84872, NULL, 'G3DSA:1.20.1070.10:FF:000489', NULL, NULL, 'Dopamine receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(84873, NULL, 'G3DSA:1.20.58.410:FF:000002', NULL, NULL, 'Peptide chain release factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(84874, NULL, 'G3DSA:1.10.405.10:FF:000018', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(84875, NULL, 'G3DSA:3.30.470.10:FF:000033', NULL, NULL, 'D-amino-acid transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(84876, NULL, 'G3DSA:3.30.230.80:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84877, NULL, 'G3DSA:1.10.510.10:FF:003298', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84878, NULL, 'G3DSA:1.20.120.420:FF:000010', NULL, NULL, 'Methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(84879, NULL, 'G3DSA:3.40.50.300:FF:004089', NULL, NULL, 'SNF2 domain-containing protein / helicase domain-containing protein / HNH endonuclease domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(84880, NULL, 'G3DSA:3.40.50.10140:FF:000018', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(84881, NULL, 'G3DSA:3.40.850.10:FF:000026', NULL, NULL, 'Centromere-associated protein E', NULL, NULL, NULL, NULL, NULL, 4),
(84882, NULL, 'G3DSA:1.10.1420.10:FF:000193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84883, NULL, 'G3DSA:3.30.1040.20:FF:000003', NULL, NULL, 'Thiol-activated cytolysin', NULL, NULL, NULL, NULL, NULL, 4),
(84884, NULL, 'G3DSA:1.10.472.10:FF:000499', NULL, NULL, 'Cyclin, cyclin d, cell cycle control', NULL, NULL, NULL, NULL, NULL, 4),
(84885, NULL, 'G3DSA:3.30.160.60:FF:001654', NULL, NULL, 'Tripartite motif-containing protein 72', NULL, NULL, NULL, NULL, NULL, 4),
(84886, NULL, 'G3DSA:1.25.40.10:FF:002457', NULL, NULL, 'Superkiller', NULL, NULL, NULL, NULL, NULL, 4),
(84887, NULL, 'G3DSA:3.30.505.10:FF:000019', NULL, NULL, 'Chimaerin', NULL, NULL, NULL, NULL, NULL, 4),
(84888, NULL, 'G3DSA:1.20.1070.10:FF:001006', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(84889, NULL, 'G3DSA:3.40.50.300:FF:003341', NULL, NULL, 'ADP-ribosylation factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84890, NULL, 'G3DSA:2.40.30.130:FF:000041', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(84891, NULL, 'G3DSA:3.30.390.30:FF:000038', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(84892, NULL, 'G3DSA:3.30.160.60:FF:001558', NULL, NULL, 'Zinc finger protein 569', NULL, NULL, NULL, NULL, NULL, 4),
(84893, NULL, 'G3DSA:3.30.40.10:FF:000894', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(84894, NULL, 'G3DSA:3.10.290.20:FF:000015', NULL, NULL, 'Ubiquitin-activating enzyme E1-like', NULL, NULL, NULL, NULL, NULL, 4),
(84895, NULL, 'G3DSA:3.30.70.970:FF:000001', NULL, NULL, 'Regulator of ribonuclease activity B', NULL, NULL, NULL, NULL, NULL, 4),
(84896, NULL, 'G3DSA:1.10.510.10:FF:003702', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84897, NULL, 'G3DSA:2.30.30.30:FF:000020', NULL, NULL, '60S ribosomal protein L6', NULL, NULL, NULL, NULL, NULL, 4),
(84898, NULL, 'G3DSA:2.130.10.10:FF:005595', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84899, NULL, 'G3DSA:3.80.10.10:FF:003257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84900, NULL, 'G3DSA:3.30.160.60:FF:004060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84901, NULL, 'G3DSA:3.30.40.10:FF:001462', NULL, NULL, 'RING/U-box superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(84902, NULL, 'G3DSA:3.30.200.20:FF:001837', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84903, NULL, 'G3DSA:3.90.1170.10:FF:000029', NULL, NULL, '60S ribosomal protein L16, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(84904, NULL, 'G3DSA:3.30.2000.40:FF:000001', NULL, NULL, 'Tail sheath stabilizer and completion', NULL, NULL, NULL, NULL, NULL, 4),
(84905, NULL, 'G3DSA:3.80.10.10:FF:001941', NULL, NULL, 'Os01g0170300 protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(84906, NULL, 'G3DSA:3.30.70.2740:FF:000005', NULL, NULL, 'FAD-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(84907, NULL, 'G3DSA:3.30.1370.100:FF:000008', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(84908, NULL, 'G3DSA:1.25.40.20:FF:000077', NULL, NULL, 'Serine/threonine-protein kinase TNNI3K', NULL, NULL, NULL, NULL, NULL, 4),
(84909, NULL, 'G3DSA:3.40.800.10:FF:000023', NULL, NULL, 'Arginase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(84910, NULL, 'G3DSA:3.40.50.720:FF:000729', NULL, NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(84911, NULL, 'G3DSA:1.10.510.10:FF:001853', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84912, NULL, 'G3DSA:3.90.1150.10:FF:000197', NULL, NULL, '4-aminobutyrate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(84913, NULL, 'G3DSA:3.20.20.140:FF:000301', NULL, NULL, 'PHP domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(84914, NULL, 'G3DSA:2.60.120.650:FF:000198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84915, NULL, 'G3DSA:3.30.420.40:FF:000078', NULL, NULL, 'Ribulokinase', NULL, NULL, NULL, NULL, NULL, 4),
(84916, NULL, 'G3DSA:1.10.630.10:FF:000131', NULL, NULL, 'Cytochrome P450 family 722 subfamily A polypeptide 1', NULL, NULL, NULL, NULL, NULL, 4),
(84917, NULL, 'G3DSA:1.10.238.200:FF:000015', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(84918, NULL, 'G3DSA:3.40.850.10:FF:000122', NULL, NULL, 'Kinesin-like protein, KLP38B', NULL, NULL, NULL, NULL, NULL, 4),
(84919, NULL, 'G3DSA:3.30.70.330:FF:002693', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84920, NULL, 'G3DSA:2.10.25.10:FF:001071', NULL, NULL, 'GM24707', NULL, NULL, NULL, NULL, NULL, 4),
(84921, NULL, 'G3DSA:3.30.200.20:FF:001449', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(84922, NULL, 'G3DSA:2.60.11.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84923, NULL, 'G3DSA:2.30.42.10:FF:000182', NULL, NULL, 'whirlin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(84924, NULL, 'G3DSA:1.20.1560.10:FF:000689', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84925, NULL, 'G3DSA:1.20.890.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84926, NULL, 'G3DSA:1.10.287.1490:FF:000013', NULL, NULL, 'ELKS/RAB6-interacting/CAST family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(84927, NULL, 'G3DSA:1.20.120.230:FF:000043', NULL, NULL, 'Talin 2', NULL, NULL, NULL, NULL, NULL, 4),
(84928, NULL, 'G3DSA:3.60.40.10:FF:000022', NULL, NULL, 'probable protein phosphatase 2C 12', NULL, NULL, NULL, NULL, NULL, 4),
(84929, NULL, 'G3DSA:1.20.58.1930:FF:000006', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(84930, NULL, 'G3DSA:1.10.506.10:FF:000045', NULL, NULL, 'Receptor-mediated endocytosis protein 6 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(84931, NULL, 'G3DSA:3.60.10.10:FF:000262', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(84932, NULL, 'G3DSA:3.30.40.10:FF:002159', NULL, NULL, 'Structure-specific endonuclease subunit SLX1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(84933, NULL, 'G3DSA:3.40.50.620:FF:000385', NULL, NULL, 'Nicotinamide-nucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(84934, NULL, 'G3DSA:3.40.50.150:FF:000805', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84935, NULL, 'G3DSA:3.40.630.30:FF:000589', NULL, NULL, 'Putative N-acetyltransferase san-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(84936, NULL, 'G3DSA:3.40.710.10:FF:000196', NULL, NULL, 'Penicillin binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(84937, NULL, 'G3DSA:2.60.40.10:FF:002626', NULL, NULL, 'T cell receptor gamma variable 2', NULL, NULL, NULL, NULL, NULL, 4),
(84938, NULL, 'G3DSA:3.30.1490.80:FF:000026', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(84939, NULL, 'G3DSA:1.10.510.10:FF:002342', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84940, NULL, 'G3DSA:2.130.10.10:FF:000873', NULL, NULL, 'Microtubule-associated protein ytm1 homologue, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84941, NULL, 'G3DSA:3.40.50.300:FF:001828', NULL, NULL, 'ras-related protein Rap-1b-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(84942, NULL, 'G3DSA:4.10.1240.10:FF:000064', NULL, NULL, 'Adhesion G protein-coupled receptor L2', NULL, NULL, NULL, NULL, NULL, 4),
(84943, NULL, 'G3DSA:1.10.1520.10:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84944, NULL, 'G3DSA:2.30.29.30:FF:000224', NULL, NULL, 'arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(84945, NULL, 'G3DSA:3.20.80.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84946, NULL, 'G3DSA:3.40.50.300:FF:008063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84947, NULL, 'G3DSA:2.60.40.150:FF:000393', NULL, NULL, 'Os01g0819200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(84948, NULL, 'G3DSA:3.40.50.300:FF:007495', NULL, NULL, 'DNA mismatch repair protein MutS type 2', NULL, NULL, NULL, NULL, NULL, 4),
(84949, NULL, 'G3DSA:3.40.50.800:FF:000023', NULL, NULL, 'Threonyl-tRNA synthetase mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(84950, NULL, 'G3DSA:1.20.1420.30:FF:000073', NULL, NULL, 'Vacuolar H+\/Ca2+ exchanger', NULL, NULL, NULL, NULL, NULL, 4),
(84951, NULL, 'G3DSA:1.10.287.990:FF:000002', NULL, NULL, 'Superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(84952, NULL, 'G3DSA:3.30.160.60:FF:003571', NULL, NULL, 'Blast:Zinc finger protein 235', NULL, NULL, NULL, NULL, NULL, 4),
(84953, NULL, 'G3DSA:3.90.70.80:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84954, NULL, 'G3DSA:2.40.10.120:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84955, NULL, 'G3DSA:3.40.50.1220:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84956, NULL, 'G3DSA:3.40.50.80:FF:000078', NULL, NULL, 'NAD(P)H oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(84957, NULL, 'G3DSA:1.25.10.10:FF:002629', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84958, NULL, 'G3DSA:1.10.287.4270:FF:000004', NULL, NULL, 'Serine/threonine-protein kinase 3/4', NULL, NULL, NULL, NULL, NULL, 4),
(84959, NULL, 'G3DSA:2.130.10.10:FF:004908', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84960, NULL, 'G3DSA:3.30.30.170:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84961, NULL, 'G3DSA:1.20.120.1760:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84962, NULL, 'G3DSA:3.40.190.290:FF:000046', NULL, NULL, 'Malonate utilization transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(84963, NULL, 'G3DSA:1.25.40.10:FF:004531', NULL, NULL, 'Signal recognition particle subunit SRP72', NULL, NULL, NULL, NULL, NULL, 4),
(84964, NULL, 'G3DSA:3.50.30.30:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84965, NULL, 'G3DSA:1.20.5.110:FF:000070', NULL, NULL, 'SNARE protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84966, NULL, 'G3DSA:3.80.10.10:FF:001992', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84967, NULL, 'G3DSA:3.40.50.1000:FF:000751', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84968, NULL, 'G3DSA:3.10.20.90:FF:000558', NULL, NULL, 'AGAP006402-PA', NULL, NULL, NULL, NULL, NULL, 4),
(84969, NULL, 'G3DSA:3.90.1200.10:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84970, NULL, 'G3DSA:1.10.555.10:FF:000186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84971, NULL, 'G3DSA:1.20.1270.60:FF:000283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84972, NULL, 'G3DSA:3.30.1360.120:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(84973, NULL, 'G3DSA:3.40.50.300:FF:003392', NULL, NULL, 'Regulator of nonsense transcripts, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84974, NULL, 'G3DSA:1.20.120.850:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84975, NULL, 'G3DSA:3.30.70.141:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84976, NULL, 'G3DSA:3.40.50.10330:FF:000036', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(84977, NULL, 'G3DSA:3.30.160.60:FF:005420', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84978, NULL, 'G3DSA:2.60.40.10:FF:004190', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84979, NULL, 'G3DSA:1.20.1560.10:FF:000768', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84980, NULL, 'G3DSA:1.10.10.1050:FF:000003', NULL, NULL, 'Decapping enzyme Dcp2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84981, NULL, 'G3DSA:2.60.40.10:FF:003475', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(84982, NULL, 'G3DSA:1.10.630.10:FF:000491', NULL, NULL, 'Cytochrome P450 2C31-like', NULL, NULL, NULL, NULL, NULL, 4),
(84983, NULL, 'G3DSA:3.60.20.10:FF:000088', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(84984, NULL, 'G3DSA:1.25.40.20:FF:000818', NULL, NULL, 'Diego, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(84985, NULL, 'G3DSA:3.80.10.10:FF:002689', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(84986, NULL, 'G3DSA:3.10.120.10:FF:000028', NULL, NULL, 'Nitrate reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84987, NULL, 'G3DSA:1.20.930.10:FF:000039', NULL, NULL, 'Transcription elongation factor S-II, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84988, NULL, 'G3DSA:1.20.1250.20:FF:001276', NULL, NULL, 'Sodium:melibiose symporter', NULL, NULL, NULL, NULL, NULL, 4),
(84989, NULL, 'G3DSA:1.10.720.60:FF:000012', NULL, NULL, 'Haloacid_dehalogenase-like_hydrolase_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(84990, NULL, 'G3DSA:3.40.50.10480:FF:000002', NULL, NULL, 'Ribosome production factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(84991, NULL, 'G3DSA:3.40.47.10:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(84992, NULL, 'G3DSA:2.20.20.160:FF:000002', NULL, NULL, 'Doublesex cognate 73A', NULL, NULL, NULL, NULL, NULL, 4),
(84993, NULL, 'G3DSA:2.120.10.80:FF:000310', NULL, NULL, 'Multiple epidermal growth factor-like domains protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(84994, NULL, 'G3DSA:3.40.50.720:FF:000881', NULL, NULL, '2,4-dienoyl-coa reductase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(84995, NULL, 'G3DSA:2.130.10.10:FF:002722', NULL, NULL, 'GD22827', NULL, NULL, NULL, NULL, NULL, 4),
(84996, NULL, 'G3DSA:1.10.238.10:FF:000904', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(84997, NULL, 'G3DSA:1.10.10.10:FF:000420', NULL, NULL, 'RNA polymerase III subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(84998, NULL, 'G3DSA:3.60.21.10:FF:000051', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(84999, NULL, 'G3DSA:2.60.40.10:FF:004835', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85000, NULL, 'G3DSA:3.40.50.1010:FF:000169', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85001, NULL, 'G3DSA:3.40.50.1240:FF:000221', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85002, NULL, 'G3DSA:3.50.50.60:FF:000431', NULL, NULL, 'AMine oXidase family', NULL, NULL, NULL, NULL, NULL, 4),
(85003, NULL, 'G3DSA:1.25.40.10:FF:004582', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85004, NULL, 'G3DSA:1.20.120.1080:FF:000046', NULL, NULL, 'ATP-dependent RNA helicase DHX37', NULL, NULL, NULL, NULL, NULL, 4),
(85005, NULL, 'G3DSA:4.10.400.10:FF:000355', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85006, NULL, 'G3DSA:2.40.10.170:FF:000009', NULL, NULL, 'CarD-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(85007, NULL, 'G3DSA:2.130.10.10:FF:005544', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(85008, NULL, 'G3DSA:2.60.40.10:FF:002014', NULL, NULL, 'Ig kappa chain C region, A allele', NULL, NULL, NULL, NULL, NULL, 4),
(85009, NULL, 'G3DSA:3.40.47.10:FF:000139', NULL, NULL, 'Polyketide beta-ketoacyl:acyl carrier proteinsynthase', NULL, NULL, NULL, NULL, NULL, 4),
(85010, NULL, 'G3DSA:1.20.144.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85011, NULL, 'G3DSA:2.40.10.10:FF:000602', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85012, NULL, 'G3DSA:3.40.50.11540:FF:000005', NULL, NULL, 'Hydrogenase subunit HymB, putative', NULL, NULL, NULL, NULL, NULL, 4),
(85013, NULL, 'G3DSA:3.30.70.1290:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85014, NULL, 'G3DSA:3.30.300.20:FF:000024', NULL, NULL, 'Probable transcription termination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(85015, NULL, 'G3DSA:1.20.1250.20:FF:001372', NULL, NULL, 'MFS transporter, putative (AFU_orthologue AFUA_2G17270)', NULL, NULL, NULL, NULL, NULL, 4),
(85016, NULL, 'G3DSA:3.40.50.1980:FF:000117', NULL, NULL, 'ABC-type transport system periplasmic substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(85017, NULL, 'G3DSA:3.30.50.10:FF:000007', NULL, NULL, 'Nitrogen regulatory AreA, N-terminal', NULL, NULL, NULL, NULL, NULL, 4),
(85018, NULL, 'G3DSA:2.80.10.50:FF:000191', NULL, NULL, 'Putative serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(85019, NULL, 'G3DSA:2.30.40.10:FF:000020', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(85020, NULL, 'G3DSA:3.40.50.1000:FF:000700', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85021, NULL, 'G3DSA:3.30.70.1320:FF:000012', NULL, NULL, 'Multidrug resistance protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(85022, NULL, 'G3DSA:3.30.200.20:FF:000140', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(85023, NULL, 'G3DSA:1.20.58.2230:FF:000001', NULL, NULL, 'Dsl1p', NULL, NULL, NULL, NULL, NULL, 4),
(85024, NULL, 'G3DSA:2.130.10.10:FF:000513', NULL, NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(85025, NULL, 'G3DSA:3.20.20.70:FF:000815', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85026, NULL, 'G3DSA:1.10.533.10:FF:000169', NULL, NULL, 'Guanylate-binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(85027, NULL, 'G3DSA:1.10.40.50:FF:000001', NULL, NULL, 'Small ribosomal subunit biogenesis GTPase RsgA', NULL, NULL, NULL, NULL, NULL, 4),
(85028, NULL, 'G3DSA:2.30.330.10:FF:000010', NULL, NULL, 'Type III secretion system protein', NULL, NULL, NULL, NULL, NULL, 4),
(85029, NULL, 'G3DSA:3.40.50.300:FF:001216', NULL, NULL, 'Protein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(85030, NULL, 'G3DSA:1.20.1070.10:FF:001950', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85031, NULL, 'G3DSA:3.40.50.1820:FF:001042', NULL, NULL, 'Os04g0669700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(85032, NULL, 'G3DSA:1.10.10.60:FF:000502', NULL, NULL, 'myb protein', NULL, NULL, NULL, NULL, NULL, 4),
(85033, NULL, 'G3DSA:1.10.10.10:FF:001297', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(85034, NULL, 'G3DSA:2.130.10.10:FF:006033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85035, NULL, 'G3DSA:3.40.1360.10:FF:000027', NULL, NULL, 'Putative type IIB DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(85036, NULL, 'G3DSA:3.40.50.850:FF:000009', NULL, NULL, 'Nicotinamidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(85037, NULL, 'G3DSA:3.30.70.330:FF:000568', NULL, NULL, 'U2 snRNP auxiliary factor large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(85038, NULL, 'G3DSA:1.20.1270.60:FF:000311', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85039, NULL, 'G3DSA:3.40.50.1820:FF:000586', NULL, NULL, 'Thymus-specific serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(85040, NULL, 'G3DSA:2.40.10.10:FF:000259', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(85041, NULL, 'G3DSA:1.10.510.10:FF:000768', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(85042, NULL, 'G3DSA:3.90.1410.10:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85043, NULL, 'G3DSA:3.30.530.20:FF:000193', NULL, NULL, 'Coenzyme Q10A', NULL, NULL, NULL, NULL, NULL, 4),
(85044, NULL, 'G3DSA:2.70.50.30:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85045, NULL, 'G3DSA:1.10.390.10:FF:000044', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(85046, NULL, 'G3DSA:1.20.1420.10:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85047, NULL, 'G3DSA:3.30.160.60:FF:003003', NULL, NULL, 'Blast:Transcription factor grauzone', NULL, NULL, NULL, NULL, NULL, 4),
(85048, NULL, 'G3DSA:1.20.1110.10:FF:000217', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85049, NULL, 'G3DSA:1.25.40.10:FF:001676', NULL, NULL, 'Os06g0216400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(85050, NULL, 'G3DSA:3.30.60.20:FF:000073', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(85051, NULL, 'G3DSA:2.60.120.10:FF:000572', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85052, NULL, 'G3DSA:1.20.1440.90:FF:000007', NULL, NULL, 'Os01g0110700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(85053, NULL, 'G3DSA:1.20.5.730:FF:000008', NULL, NULL, 'Rabaptin, RAB GTPase binding effector protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(85054, NULL, 'G3DSA:1.10.357.50:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85055, NULL, 'G3DSA:3.40.50.720:FF:001786', NULL, NULL, '3-hydroxyisobutyrate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(85056, NULL, 'G3DSA:1.20.1250.20:FF:002001', NULL, NULL, 'Predicted permease, major facilitator superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(85057, NULL, 'G3DSA:3.50.7.10:FF:000014', NULL, NULL, 'Thermosome subunit', NULL, NULL, NULL, NULL, NULL, 4),
(85058, NULL, 'G3DSA:1.50.10.130:FF:000005', NULL, NULL, 'S-(+)-linalool synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(85059, NULL, 'G3DSA:2.20.28.10:FF:000059', NULL, NULL, 'AGAP002581-PA', NULL, NULL, NULL, NULL, NULL, 4),
(85060, NULL, 'G3DSA:2.40.30.10:FF:000322', NULL, NULL, 'Selenocysteine-specific elongation factor', NULL, NULL, NULL, NULL, NULL, 4),
(85061, NULL, 'G3DSA:3.40.50.2020:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85062, NULL, 'G3DSA:3.90.120.10:FF:000027', NULL, NULL, 'Lambda phage type II restriction modification system cytosine-5 DNA methyltransferase Dcm', NULL, NULL, NULL, NULL, NULL, 4),
(85063, NULL, 'G3DSA:3.40.50.620:FF:000121', NULL, NULL, 'Universal stress protein', NULL, NULL, NULL, NULL, NULL, 4),
(85064, NULL, 'G3DSA:1.20.58.1080:FF:000004', NULL, NULL, 'SUV3p ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(85065, NULL, 'G3DSA:3.90.175.10:FF:000002', NULL, NULL, 'Diphtheria toxin', NULL, NULL, NULL, NULL, NULL, 4),
(85066, NULL, 'G3DSA:1.20.1270.60:FF:000199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85067, NULL, 'G3DSA:2.60.40.1930:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85068, NULL, 'G3DSA:3.80.10.10:FF:001380', NULL, NULL, 'Os05g0256100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(85069, NULL, 'G3DSA:1.25.70.10:FF:000076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85070, NULL, 'G3DSA:1.20.1080.10:FF:000107', NULL, NULL, 'Aquaporin TIP3.1', NULL, NULL, NULL, NULL, NULL, 4),
(85071, NULL, 'G3DSA:3.30.420.10:FF:000586', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85072, NULL, 'G3DSA:1.20.5.710:FF:000002', NULL, NULL, '50S ribosomal protein L7/L12', NULL, NULL, NULL, NULL, NULL, 4),
(85073, NULL, 'G3DSA:3.10.20.90:FF:000619', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(85074, NULL, 'G3DSA:3.40.140.10:FF:000107', NULL, NULL, 'dCMP deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(85075, NULL, 'G3DSA:1.20.58.80:FF:000022', NULL, NULL, 'Vacuolar protein sorting-associated protein 4', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(85076, NULL, 'G3DSA:1.10.238.10:FF:001309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85077, NULL, 'G3DSA:3.40.50.150:FF:000901', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85078, NULL, 'G3DSA:1.10.287.1060:FF:000002', NULL, NULL, 'Conserved oligomeric Golgi complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(85079, NULL, 'G3DSA:1.25.10.10:FF:000600', NULL, NULL, 'Exportin-4', NULL, NULL, NULL, NULL, NULL, 4),
(85080, NULL, 'G3DSA:1.10.10.10:FF:002045', NULL, NULL, 'Gll1095 protein', NULL, NULL, NULL, NULL, NULL, 4),
(85081, NULL, 'G3DSA:3.40.50.300:FF:001267', NULL, NULL, 'Multidrug resistance-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(85082, NULL, 'G3DSA:3.20.20.70:FF:000754', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85083, NULL, 'G3DSA:2.60.120.260:FF:000143', NULL, NULL, 'Beta-galactosidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(85084, NULL, 'G3DSA:3.30.1490.20:FF:000087', NULL, NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(85085, NULL, 'G3DSA:2.160.10.10:FF:000001', NULL, NULL, 'UTP--glucose-1-phosphate uridylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(85086, NULL, 'G3DSA:2.40.170.20:FF:000099', NULL, NULL, 'Transporter, outer membrane receptor (OMR) family', NULL, NULL, NULL, NULL, NULL, 4),
(85087, NULL, 'G3DSA:2.10.25.10:FF:000435', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(85088, NULL, 'G3DSA:1.10.510.10:FF:002281', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85089, NULL, 'G3DSA:2.130.10.10:FF:003386', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85090, NULL, 'G3DSA:3.60.40.10:FF:000382', NULL, NULL, 'Putative protein phosphatase 2C-like protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(85091, NULL, 'G3DSA:3.30.160.60:FF:006229', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85092, NULL, 'G3DSA:3.40.50.300:FF:004297', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(85093, NULL, 'G3DSA:1.10.510.10:FF:002921', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85094, NULL, 'G3DSA:3.40.50.2300:FF:001652', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85095, NULL, 'G3DSA:3.80.10.10:FF:002458', NULL, NULL, 'Si:ch211-278p9.2', NULL, NULL, NULL, NULL, NULL, 4),
(85096, NULL, 'G3DSA:1.25.40.10:FF:000580', NULL, NULL, 'Pre-mRNA-splicing factor SYF1', NULL, NULL, NULL, NULL, NULL, 4),
(85097, NULL, 'G3DSA:3.40.50.1000:FF:000520', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85098, NULL, 'G3DSA:1.10.274.100:FF:000002', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(85099, NULL, 'G3DSA:3.40.50.410:FF:000176', NULL, NULL, 'Copine-7', NULL, NULL, NULL, NULL, NULL, 4),
(85100, NULL, 'G3DSA:2.40.50.140:FF:000110', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(85101, NULL, 'G3DSA:2.40.160.210:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85102, NULL, 'G3DSA:1.10.287.90:FF:000013', NULL, NULL, 'Cytochrome c oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(85103, NULL, 'G3DSA:2.60.120.920:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85104, NULL, 'G3DSA:2.40.50.140:FF:000430', NULL, NULL, 'Asparagine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(85105, NULL, 'G3DSA:3.30.160.60:FF:002290', NULL, NULL, 'Weckle, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(85106, NULL, 'G3DSA:3.30.60.30:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85107, NULL, 'G3DSA:1.10.287.1080:FF:000008', NULL, NULL, 'Histidine biosynthesis bifunctional protein (HISIE)', NULL, NULL, NULL, NULL, NULL, 4),
(85108, NULL, 'G3DSA:3.40.50.720:FF:000701', NULL, NULL, 'Hydroxysteroid dehydrogenase like 2', NULL, NULL, NULL, NULL, NULL, 4),
(85109, NULL, 'G3DSA:1.20.930.10:FF:000011', NULL, NULL, 'Transcription elongation factor A protein 1', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(85110, NULL, 'G3DSA:3.40.50.2000:FF:000775', NULL, NULL, 'Glycosyltransferase family 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(85111, NULL, 'G3DSA:3.30.50.10:FF:000187', NULL, NULL, 'Transcription factor stalky', NULL, NULL, NULL, NULL, NULL, 4),
(85112, NULL, 'G3DSA:2.10.25.10:FF:001003', NULL, NULL, 'von Willebrand factor D and EGF domains', NULL, NULL, NULL, NULL, NULL, 4),
(85113, NULL, 'G3DSA:3.30.710.10:FF:000069', NULL, NULL, 'Rho related BTB domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(85114, NULL, 'G3DSA:2.30.40.10:FF:000071', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(85115, NULL, 'G3DSA:3.40.50.300:FF:005639', NULL, NULL, 'ABC multidrug transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(85116, NULL, 'G3DSA:1.10.510.10:FF:000133', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(85117, NULL, 'G3DSA:1.20.5.110:FF:000182', NULL, NULL, 'Longin-type vesicle-associated membrane protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(85118, NULL, 'G3DSA:3.40.50.300:FF:008304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85119, NULL, 'G3DSA:3.40.50.620:FF:000738', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85120, NULL, 'G3DSA:1.10.220.10:FF:000049', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(85121, NULL, 'G3DSA:3.40.50.1260:FF:000047', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(85122, NULL, 'G3DSA:1.25.10.10:FF:003394', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85123, NULL, 'G3DSA:1.25.40.10:FF:000248', NULL, NULL, 'Tetratricopeptide repeat domain 28', NULL, NULL, NULL, NULL, NULL, 4),
(85124, NULL, 'G3DSA:1.10.510.10:FF:004366', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85125, NULL, 'G3DSA:3.40.50.10090:FF:000076', NULL, NULL, 'Putative uroporphyrinogen III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(85126, NULL, 'G3DSA:3.30.420.10:FF:000322', NULL, NULL, '3''-5'' exonuclease eri-1', NULL, NULL, NULL, NULL, NULL, 4),
(85127, NULL, 'G3DSA:1.20.920.10:FF:000033', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(85128, NULL, 'G3DSA:3.40.50.300:FF:002852', NULL, NULL, 'Mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(85129, NULL, 'G3DSA:3.30.428.10:FF:000031', NULL, NULL, 'HIT family protein', NULL, NULL, NULL, NULL, NULL, 4),
(85130, NULL, 'G3DSA:1.20.1250.20:FF:001484', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85131, NULL, 'G3DSA:2.130.10.10:FF:003099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85132, NULL, 'G3DSA:2.60.120.200:FF:000552', NULL, NULL, 'Lectin', NULL, NULL, NULL, NULL, NULL, 4),
(85133, NULL, 'G3DSA:3.90.400.10:FF:000009', NULL, NULL, 'Alpha-amylase', NULL, NULL, NULL, NULL, NULL, 4),
(85134, NULL, 'G3DSA:3.90.1290.10:FF:000027', NULL, NULL, 'VAB-10A protein', NULL, NULL, NULL, NULL, NULL, 4),
(85135, NULL, 'G3DSA:1.20.1070.10:FF:000040', NULL, NULL, 'Coagulation factor 2 (thrombin) receptor', NULL, NULL, NULL, NULL, NULL, 4),
(85136, NULL, 'G3DSA:3.20.20.140:FF:000397', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85137, NULL, 'G3DSA:3.30.572.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85138, NULL, 'G3DSA:3.30.40.10:FF:001693', NULL, NULL, 'Vacuolar protein sorting-associated protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(85139, NULL, 'G3DSA:3.90.1750.10:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85140, NULL, 'G3DSA:3.20.20.80:FF:000852', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85141, NULL, 'G3DSA:3.40.50.1480:FF:000001', NULL, NULL, 'Adenosylhomocysteinase', NULL, NULL, NULL, NULL, NULL, 4),
(85142, NULL, 'G3DSA:2.30.29.30:FF:000567', NULL, NULL, 'PH domain-containing endocytic-trafficking adaptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(85143, NULL, 'G3DSA:2.10.110.10:FF:000240', NULL, NULL, 'LIM domain protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(85144, NULL, 'G3DSA:3.40.50.300:FF:005870', NULL, NULL, 'AAA domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(85145, NULL, 'G3DSA:3.40.50.300:FF:002205', NULL, NULL, 'ABC transporter, (TAP family), putative', NULL, NULL, NULL, NULL, NULL, 4),
(85146, NULL, 'G3DSA:1.10.10.10:FF:001089', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(85147, NULL, 'G3DSA:3.40.50.300:FF:006590', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85148, NULL, 'G3DSA:1.10.20.10:FF:000134', NULL, NULL, 'CCAAT-box DNA binding protein subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(85149, NULL, 'G3DSA:1.20.5.350:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85150, NULL, 'G3DSA:1.20.1160.11:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85151, NULL, 'G3DSA:3.40.720.10:FF:000253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85152, NULL, 'G3DSA:3.30.2350.10:FF:000041', NULL, NULL, 'tRNA pseudouridine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(85153, NULL, 'G3DSA:1.20.58.830:FF:000021', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(85154, NULL, 'G3DSA:2.130.10.10:FF:000305', NULL, NULL, 'F-box/WD repeat-containing protein 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(85155, NULL, 'G3DSA:1.10.10.10:FF:000651', NULL, NULL, 'Regulatory protein RecX', NULL, NULL, NULL, NULL, NULL, 4),
(85156, NULL, 'G3DSA:3.40.640.10:FF:000252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85157, NULL, 'G3DSA:1.10.238.210:FF:000001', NULL, NULL, 'Glutaminase kidney isoform, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(85158, NULL, 'G3DSA:3.40.50.12660:FF:000015', NULL, NULL, 'ICE-like protease p20 domain containing protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(85159, NULL, 'G3DSA:1.10.8.720:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85160, NULL, 'G3DSA:2.60.40.770:FF:000011', NULL, NULL, 'Protein CBR-HEH-1', NULL, NULL, NULL, NULL, NULL, 4),
(85161, NULL, 'G3DSA:2.40.180.10:FF:000035', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85162, NULL, 'G3DSA:1.10.510.10:FF:000504', NULL, NULL, 'Serine/threonine-protein kinase Nek5', NULL, NULL, NULL, NULL, NULL, 4),
(85163, NULL, 'G3DSA:1.10.8.60:FF:000546', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85164, NULL, 'G3DSA:1.25.40.10:FF:002614', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(85165, NULL, 'G3DSA:1.20.1270.10:FF:000021', NULL, NULL, 'Heat shock protein 70', NULL, NULL, NULL, NULL, NULL, 4),
(85166, NULL, 'G3DSA:2.130.10.10:FF:000581', NULL, NULL, 'LLGL scribble cell polarity complex component 2', NULL, NULL, NULL, NULL, NULL, 4),
(85167, NULL, 'G3DSA:2.60.40.10:FF:006016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85168, NULL, 'G3DSA:3.80.10.10:FF:000660', NULL, NULL, 'Leucine rich repeats and IQ motif containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(85169, NULL, 'G3DSA:1.10.8.60:FF:000142', NULL, NULL, 'Katanin p60 ATPase-containing subunit A1', NULL, NULL, NULL, NULL, NULL, 4),
(85170, NULL, 'G3DSA:1.25.40.790:FF:000011', NULL, NULL, 'CCR4-not transcription complex, putative', NULL, NULL, NULL, NULL, NULL, 4),
(85171, NULL, 'G3DSA:2.60.120.290:FF:000247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85172, NULL, 'G3DSA:2.70.170.10:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85173, NULL, 'G3DSA:3.10.350.10:FF:000017', NULL, NULL, 'Peptidase, M23 family', NULL, NULL, NULL, NULL, NULL, 4),
(85174, NULL, 'G3DSA:3.40.630.30:FF:000297', NULL, NULL, 'AGAP006788-PA', NULL, NULL, NULL, NULL, NULL, 4),
(85175, NULL, 'G3DSA:3.40.350.10:FF:000033', NULL, NULL, 'Xaa-pro aminopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(85176, NULL, 'G3DSA:3.40.1110.10:FF:000048', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(85177, NULL, 'G3DSA:2.40.37.10:FF:000023', NULL, NULL, 'Diaminopimelate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(85178, NULL, 'G3DSA:1.50.40.10:FF:000595', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85179, NULL, 'G3DSA:1.50.10.10:FF:000188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85180, NULL, 'G3DSA:2.20.100.10:FF:000079', NULL, NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 17', NULL, NULL, NULL, NULL, NULL, 4),
(85181, NULL, 'G3DSA:3.80.10.10:FF:003818', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85182, NULL, 'G3DSA:1.25.40.180:FF:000154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85183, NULL, 'G3DSA:1.10.8.270:FF:000182', NULL, NULL, 'TBC domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(85184, NULL, 'G3DSA:2.30.30.40:FF:000270', NULL, NULL, 'Blast:Tyrosine-protein kinase Src-1', NULL, NULL, NULL, NULL, NULL, 4),
(85185, NULL, 'G3DSA:3.40.710.10:FF:000016', NULL, NULL, 'serine beta-lactamase-like protein LACTB, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(85186, NULL, 'G3DSA:1.10.472.10:FF:000050', NULL, NULL, 'Transcription initiation factor TFIIB', NULL, NULL, NULL, NULL, NULL, 4),
(85187, NULL, 'G3DSA:2.60.120.330:FF:000012', NULL, NULL, 'Gibberellin 20 oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(85188, NULL, 'G3DSA:3.40.50.150:FF:000513', NULL, NULL, 'S-adenosylmethionine-dependent methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(85189, NULL, 'G3DSA:3.30.9.10:FF:000097', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(85190, NULL, 'G3DSA:3.90.1200.10:FF:000027', NULL, NULL, 'Fructosamine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(85191, NULL, 'G3DSA:1.10.10.10:FF:001325', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(85192, NULL, 'G3DSA:2.10.25.10:FF:001683', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85193, NULL, 'G3DSA:1.20.1560.10:FF:000476', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(85194, NULL, 'G3DSA:2.60.40.1180:FF:000053', NULL, NULL, 'Alpha-L-arabinofuranosidase A', NULL, NULL, NULL, NULL, NULL, 4),
(85195, NULL, 'G3DSA:3.30.40.10:FF:000922', NULL, NULL, 'RING finger protein 38', NULL, NULL, NULL, NULL, NULL, 4),
(85196, NULL, 'G3DSA:1.20.1070.10:FF:001506', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85197, NULL, 'G3DSA:1.25.40.10:FF:001940', NULL, NULL, 'Os03g0635000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(85198, NULL, 'G3DSA:1.10.8.10:FF:000149', NULL, NULL, 'CUE2p protein', NULL, NULL, NULL, NULL, NULL, 4),
(85199, NULL, 'G3DSA:2.60.60.20:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85200, NULL, 'G3DSA:3.80.10.10:FF:001048', NULL, NULL, 'F-box and leucine rich repeat protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(85201, NULL, 'G3DSA:2.60.40.790:FF:000017', NULL, NULL, 'Cysteine and histidine-rich domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(85202, NULL, 'G3DSA:3.10.20.90:FF:000142', NULL, NULL, 'E3 ubiquitin-protein ligase parkin', NULL, NULL, NULL, NULL, NULL, 4),
(85203, NULL, 'G3DSA:1.10.555.10:FF:000118', NULL, NULL, 'Rho GTPase activating protein 28', NULL, NULL, NULL, NULL, NULL, 4),
(85204, NULL, 'G3DSA:3.90.1110.10:FF:000020', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(85205, NULL, 'G3DSA:1.20.1250.20:FF:001664', NULL, NULL, 'AaceriACL172Cp', NULL, NULL, NULL, NULL, NULL, 4),
(85206, NULL, 'G3DSA:1.10.150.50:FF:000038', NULL, NULL, 'Putative sam and sh3 domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(85207, NULL, 'G3DSA:3.30.160.60:FF:004431', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85208, NULL, 'G3DSA:1.25.40.470:FF:000084', NULL, NULL, 'Elongator complex protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(85209, NULL, 'G3DSA:2.60.220.50:FF:000046', NULL, NULL, 'Adhesion G protein-coupled receptor D2', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(85210, NULL, 'G3DSA:3.30.70.330:FF:002125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85211, NULL, 'G3DSA:3.30.450.40:FF:000198', NULL, NULL, 'PAS sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(85212, NULL, 'G3DSA:2.30.30.40:FF:000641', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85213, NULL, 'G3DSA:3.40.50.450:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85214, NULL, 'G3DSA:3.40.630.30:FF:000173', NULL, NULL, 'Acyl-homoserine-lactone synthase', NULL, NULL, NULL, NULL, NULL, 4),
(85215, NULL, 'G3DSA:3.90.180.10:FF:000188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85216, NULL, 'G3DSA:2.40.70.10:FF:000499', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85217, NULL, 'G3DSA:1.20.120.1220:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85218, NULL, 'G3DSA:1.25.10.10:FF:001848', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85219, NULL, 'G3DSA:3.30.60.10:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85220, NULL, 'G3DSA:1.25.10.10:FF:001320', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85221, NULL, 'G3DSA:3.90.1030.10:FF:000019', NULL, NULL, 'Mitochondrial 54S ribosomal protein YmL8', NULL, NULL, NULL, NULL, NULL, 4),
(85222, NULL, 'G3DSA:3.50.50.60:FF:000723', NULL, NULL, 'Dihydrolipoamide dehydrogenase, point mutation', NULL, NULL, NULL, NULL, NULL, 4),
(85223, NULL, 'G3DSA:3.30.60.30:FF:000019', NULL, NULL, 'NtA agrin', NULL, NULL, NULL, NULL, NULL, 4),
(85224, NULL, 'G3DSA:3.40.50.2300:FF:000242', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(85225, NULL, 'G3DSA:3.40.50.1000:FF:000672', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85226, NULL, 'G3DSA:1.10.510.10:FF:004079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85227, NULL, 'G3DSA:3.90.70.40:FF:000003', NULL, NULL, 'josephin-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(85228, NULL, 'G3DSA:3.40.950.10:FF:000011', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', NULL, NULL, NULL, NULL, NULL, 4),
(85229, NULL, 'G3DSA:2.30.29.30:FF:001005', NULL, NULL, 'Dynamin-1', NULL, NULL, NULL, NULL, NULL, 4),
(85230, NULL, 'G3DSA:1.25.40.20:FF:000526', NULL, NULL, 'NACHT and Ankyrin domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(85231, NULL, 'G3DSA:1.25.10.10:FF:000488', NULL, NULL, 'Serine/threonine-protein kinase mTOR', NULL, NULL, NULL, NULL, NULL, 4),
(85232, NULL, 'G3DSA:3.30.160.60:FF:001446', NULL, NULL, 'Zinc finger protein 532', NULL, NULL, NULL, NULL, NULL, 4),
(85233, NULL, 'G3DSA:1.10.1740.150:FF:000001', NULL, NULL, 'Endoribonuclease Dicer', NULL, NULL, NULL, NULL, NULL, 4),
(85234, NULL, 'G3DSA:3.40.30.10:FF:000308', NULL, NULL, 'Heat shock protein DnaJ homologue Pfj2', NULL, NULL, NULL, NULL, NULL, 4),
(85235, NULL, 'G3DSA:3.30.70.330:FF:001136', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(85236, NULL, 'G3DSA:1.10.472.130:FF:000015', NULL, NULL, 'Dynein heavy chain 7', NULL, NULL, NULL, NULL, NULL, 4),
(85237, NULL, 'G3DSA:1.20.1560.10:FF:000189', NULL, NULL, 'Multidrug transporter', NULL, NULL, NULL, NULL, NULL, 4),
(85238, NULL, 'G3DSA:3.30.200.20:FF:002405', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(85239, NULL, 'G3DSA:3.30.200.20:FF:001781', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85240, NULL, 'G3DSA:3.30.200.20:FF:001045', NULL, NULL, 'Microtubule-associated serine/threonine kinase 1a', NULL, NULL, NULL, NULL, NULL, 4),
(85241, NULL, 'G3DSA:1.20.58.390:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85242, NULL, 'G3DSA:3.40.630.10:FF:000015', NULL, NULL, 'Aminoacyl-histidine dipeptidase PepD', NULL, NULL, NULL, NULL, NULL, 4),
(85243, NULL, 'G3DSA:4.10.900.10:FF:000005', NULL, NULL, 'Desmocollin 2', NULL, NULL, NULL, NULL, NULL, 4),
(85244, NULL, 'G3DSA:1.10.472.10:FF:000611', NULL, NULL, 'G2/mitotic-specific cyclin B, copy E-like protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(85245, NULL, 'G3DSA:3.30.497.10:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85246, NULL, 'G3DSA:3.90.70.10:FF:000848', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85247, NULL, 'G3DSA:3.30.200.20:FF:001629', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85248, NULL, 'G3DSA:3.10.170.20:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85249, NULL, 'G3DSA:2.60.40.10:FF:001497', NULL, NULL, 'MHC class I antigen', NULL, NULL, NULL, NULL, NULL, 4),
(85250, NULL, 'G3DSA:2.40.50.140:FF:000222', NULL, NULL, 'Programmed cell death 11', NULL, NULL, NULL, NULL, NULL, 4),
(85251, NULL, 'G3DSA:3.40.50.1100:FF:000084', NULL, NULL, 'Threonine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(85252, NULL, 'G3DSA:1.10.10.60:FF:000570', NULL, NULL, 'Transcriptional adaptor ADA2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(85253, NULL, 'G3DSA:3.20.70.20:FF:000040', NULL, NULL, 'Vitamin B12-dependent ribonucleotide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(85254, NULL, 'G3DSA:3.30.1060.10:FF:000001', NULL, NULL, 'Peptide methionine sulfoxide reductase MsrA', NULL, NULL, NULL, NULL, NULL, 4),
(85255, NULL, 'G3DSA:3.40.50.300:FF:004173', NULL, NULL, 'Phosphomevalonate kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(85256, NULL, 'G3DSA:3.40.50.300:FF:008512', NULL, NULL, 'Transitional endoplasmic reticulum ATPase TER94-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(85257, NULL, 'G3DSA:1.10.730.10:FF:000144', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(85258, NULL, 'G3DSA:3.30.720.200:FF:000008', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(85259, NULL, 'G3DSA:2.130.10.10:FF:005252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85260, NULL, 'G3DSA:3.40.50.300:FF:003841', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85261, NULL, 'G3DSA:1.25.40.10:FF:005363', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85262, NULL, 'G3DSA:1.10.238.10:FF:000051', NULL, NULL, 'Ras guanyl-releasing protein 3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(85263, NULL, 'G3DSA:3.20.20.80:FF:000644', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85264, NULL, 'G3DSA:1.20.58.80:FF:000090', NULL, NULL, 'Ubiquitin specific peptidase 8', NULL, NULL, NULL, NULL, NULL, 4),
(85265, NULL, 'G3DSA:1.10.8.280:FF:000004', NULL, NULL, 'UvrABC system protein A', NULL, NULL, NULL, NULL, NULL, 4),
(85266, NULL, 'G3DSA:3.10.250.10:FF:000072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85267, NULL, 'G3DSA:3.10.330.20:FF:000019', NULL, NULL, 'tRNA methyltransferase complex GCD14 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(85268, NULL, 'G3DSA:3.20.20.140:FF:000189', NULL, NULL, 'Metallo-dependent hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(85269, NULL, 'G3DSA:3.40.30.10:FF:000955', NULL, NULL, 'Monothiol glutaredoxin-3', NULL, NULL, NULL, NULL, NULL, 4),
(85270, NULL, 'G3DSA:1.25.40.10:FF:000428', NULL, NULL, 'Leucine-rich PPR motif-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(85271, NULL, 'G3DSA:3.80.10.10:FF:004246', NULL, NULL, 'Leucine Rich Repeat family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(85272, NULL, 'G3DSA:3.40.1110.10:FF:000335', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85273, NULL, 'G3DSA:3.40.190.10:FF:000739', NULL, NULL, 'Hydrogen peroxide-inducible genes activator', NULL, NULL, NULL, NULL, NULL, 4),
(85274, NULL, 'G3DSA:3.30.70.330:FF:000888', NULL, NULL, 'Related to splicing factor HCC1', NULL, NULL, NULL, NULL, NULL, 4),
(85275, NULL, 'G3DSA:2.130.10.10:FF:001941', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85276, NULL, 'G3DSA:3.90.470.10:FF:000014', NULL, NULL, '50S ribosomal protein L22, apicoplast', NULL, NULL, NULL, NULL, NULL, 4),
(85277, NULL, 'G3DSA:2.30.42.10:FF:000474', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85278, NULL, 'G3DSA:3.30.60.20:FF:000005', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(85279, NULL, 'G3DSA:3.40.1110.10:FF:000256', NULL, NULL, 'Probable cation-transporting P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(85280, NULL, 'G3DSA:3.40.50.620:FF:000233', NULL, NULL, 'Leucine--tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(85281, NULL, 'G3DSA:3.30.160.60:FF:003071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85282, NULL, 'G3DSA:3.30.160.60:FF:000665', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(85283, NULL, 'G3DSA:3.40.50.300:FF:005078', NULL, NULL, 'AFG1-like ATPase a', NULL, NULL, NULL, NULL, NULL, 4),
(85284, NULL, 'G3DSA:3.40.50.150:FF:001233', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85285, NULL, 'G3DSA:2.60.40.10:FF:004200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85286, NULL, 'G3DSA:3.10.310.50:FF:000004', NULL, NULL, 'POSSIBLE CONSERVED TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, NULL, NULL, 4),
(85287, NULL, 'G3DSA:2.60.40.60:FF:000359', NULL, NULL, 'LOW QUALITY PROTEIN: protocadherin-23', NULL, NULL, NULL, NULL, NULL, 4),
(85288, NULL, 'G3DSA:3.30.40.10:FF:000181', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(85289, NULL, 'G3DSA:3.30.40.10:FF:002367', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(85290, NULL, 'G3DSA:1.20.1110.10:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85291, NULL, 'G3DSA:1.20.140.160:FF:000003', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(85292, NULL, 'G3DSA:3.40.190.10:FF:000155', NULL, NULL, 'Glutamate receptor ionotropic, NMDA 2B', NULL, NULL, NULL, NULL, NULL, 4),
(85293, NULL, 'G3DSA:1.20.1730.10:FF:000017', NULL, NULL, 'Solute:sodium symporter family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(85294, NULL, 'G3DSA:1.25.40.10:FF:002114', NULL, NULL, 'Transcription Factor ThreeC subunit (GTF3C homolog)', NULL, NULL, NULL, NULL, NULL, 4),
(85295, NULL, 'G3DSA:3.30.1490.20:FF:000019', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(85296, NULL, 'G3DSA:1.10.196.10:FF:000014', NULL, NULL, 'Axin 2 (conductin, axil)', NULL, NULL, NULL, NULL, NULL, 4),
(85297, NULL, 'G3DSA:3.40.50.1100:FF:000163', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85298, NULL, 'G3DSA:2.60.40.10:FF:000592', NULL, NULL, 'Fc receptor like 1', NULL, NULL, NULL, NULL, NULL, 4),
(85299, NULL, 'G3DSA:3.40.50.880:FF:000171', NULL, NULL, 'Class I glutamine amidotransferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(85300, NULL, 'G3DSA:3.10.450.50:FF:000065', NULL, NULL, 'Putative dioxygenase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(85301, NULL, 'G3DSA:1.10.220.150:FF:000066', NULL, NULL, 'ArfGAP', NULL, NULL, NULL, NULL, NULL, 4),
(85302, NULL, 'G3DSA:3.40.630.30:FF:000089', NULL, NULL, 'Mycothiol acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(85303, NULL, 'G3DSA:2.130.10.10:FF:000429', NULL, NULL, 'RIC1 homolog, RAB6A GEF complex partner 1', NULL, NULL, NULL, NULL, NULL, 4),
(85304, NULL, 'G3DSA:2.60.40.10:FF:005824', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85305, NULL, 'G3DSA:3.40.50.720:FF:000437', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(85306, NULL, 'G3DSA:1.10.150.130:FF:000010', NULL, NULL, 'Centromere binding factor CBF3 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(85307, NULL, 'G3DSA:2.70.130.10:FF:000002', NULL, NULL, 'protein OS-9 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(85308, NULL, 'G3DSA:3.40.50.300:FF:008124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85309, NULL, 'G3DSA:3.30.420.10:FF:000474', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85310, NULL, 'G3DSA:1.20.920.10:FF:000185', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85311, NULL, 'G3DSA:3.40.430.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85312, NULL, 'G3DSA:2.40.50.140:FF:000610', NULL, NULL, 'EXOSome (Multiexonuclease complex) component', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(85313, NULL, 'G3DSA:3.40.140.10:FF:000175', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(85314, NULL, 'G3DSA:3.40.50.1580:FF:000025', NULL, NULL, 'Purine nucleoside phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(85315, NULL, 'G3DSA:1.25.40.20:FF:000318', NULL, NULL, 'Ankyrin repeat domain 16', NULL, NULL, NULL, NULL, NULL, 4),
(85316, NULL, 'G3DSA:1.20.1070.10:FF:000601', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85317, NULL, 'G3DSA:2.30.30.40:FF:000118', NULL, NULL, 'Putative E3 ubiquitin-protein ligase SH3RF1', NULL, NULL, NULL, NULL, NULL, 4),
(85318, NULL, 'G3DSA:3.20.20.80:FF:000291', NULL, NULL, 'Amylo-alpha-1, 6-glucosidase, 4-alpha-glucanotransferase a', NULL, NULL, NULL, NULL, NULL, 4),
(85319, NULL, 'G3DSA:1.20.58.390:FF:000136', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(85320, NULL, 'G3DSA:1.25.40.10:FF:003738', NULL, NULL, 'Signal recognition particle subunit SRP72', NULL, NULL, NULL, NULL, NULL, 4),
(85321, NULL, 'G3DSA:3.40.50.300:FF:000486', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM23', NULL, NULL, NULL, NULL, NULL, 4),
(85322, NULL, 'G3DSA:1.25.40.10:FF:001597', NULL, NULL, 'Pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(85323, NULL, 'G3DSA:1.20.5.430:FF:000008', NULL, NULL, 'Nuclear receptor corepressor 2', NULL, NULL, NULL, NULL, NULL, 4),
(85324, NULL, 'G3DSA:1.20.1250.20:FF:000944', NULL, NULL, 'Solute carrier family 16, member 4', NULL, NULL, NULL, NULL, NULL, 4),
(85325, NULL, 'G3DSA:3.40.50.1820:FF:001626', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(85326, NULL, 'G3DSA:1.20.58.1770:FF:000003', NULL, NULL, 'RILP-like protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(85327, NULL, 'G3DSA:2.10.25.10:FF:000547', NULL, NULL, 'Crumbs 2, cell polarity complex component', NULL, NULL, NULL, NULL, NULL, 4),
(85328, NULL, 'G3DSA:3.80.10.10:FF:001784', NULL, NULL, 'Protein CBG17991', NULL, NULL, NULL, NULL, NULL, 4),
(85329, NULL, 'G3DSA:3.40.50.720:FF:002567', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85330, NULL, 'G3DSA:1.20.1310.10:FF:000025', NULL, NULL, 'Cullin-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(85331, NULL, 'G3DSA:1.20.1270.60:FF:000075', NULL, NULL, 'Related to IVY1-phospholipid-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(85332, NULL, 'G3DSA:3.30.1390.20:FF:000023', NULL, NULL, '60S ribosomal protein L7', NULL, NULL, NULL, NULL, NULL, 4),
(85333, NULL, 'G3DSA:2.60.40.10:FF:003683', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85334, NULL, 'G3DSA:3.30.160.60:FF:002222', NULL, NULL, 'zinc finger protein 142', NULL, NULL, NULL, NULL, NULL, 4),
(85335, NULL, 'G3DSA:1.10.630.10:FF:000423', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85336, NULL, 'G3DSA:1.10.3730.20:FF:000023', NULL, NULL, 'Drug/Metabolite Transporter (DMT) Superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(85337, NULL, 'G3DSA:3.30.60.30:FF:000103', NULL, NULL, 'GEO07179p1', NULL, NULL, NULL, NULL, NULL, 4),
(85338, NULL, 'G3DSA:3.40.50.410:FF:000108', NULL, NULL, 'Sfb3p', NULL, NULL, NULL, NULL, NULL, 4),
(85339, NULL, 'G3DSA:3.40.50.1110:FF:000109', NULL, NULL, 'Phospholipase B1', NULL, NULL, NULL, NULL, NULL, 4),
(85340, NULL, 'G3DSA:1.20.1560.10:FF:000397', NULL, NULL, 'P-glycoprotein 5', NULL, NULL, NULL, NULL, NULL, 4),
(85341, NULL, 'G3DSA:3.30.1360.120:FF:000069', NULL, NULL, 'Protein CBG14872', NULL, NULL, NULL, NULL, NULL, 4),
(85342, NULL, 'G3DSA:3.40.50.980:FF:000032', NULL, NULL, 'Linear gramicidin synthase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(85343, NULL, 'G3DSA:1.10.287.70:FF:000131', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(85344, NULL, 'G3DSA:3.30.1490.100:FF:000041', NULL, NULL, 'YALI0C01573p', NULL, NULL, NULL, NULL, NULL, 4),
(85345, NULL, 'G3DSA:3.30.50.10:FF:000119', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(85346, NULL, 'G3DSA:2.60.120.920:FF:000026', NULL, NULL, 'tripartite motif-containing protein 46 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(85347, NULL, 'G3DSA:3.40.50.300:FF:007848', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85348, NULL, 'G3DSA:3.40.50.10810:FF:000085', NULL, NULL, 'Transcription regulatory protein SNF2', NULL, NULL, NULL, NULL, NULL, 4),
(85349, NULL, 'G3DSA:3.40.33.10:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85350, NULL, 'G3DSA:3.90.850.10:FF:000009', NULL, NULL, 'Fumarylacetoacetase', NULL, NULL, NULL, NULL, NULL, 4),
(85351, NULL, 'G3DSA:1.20.1250.20:FF:001164', NULL, NULL, 'MFS allantoate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(85352, NULL, 'G3DSA:3.40.50.1010:FF:000057', NULL, NULL, 'Unplaced genomic scaffold supercont1.23, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(85353, NULL, 'G3DSA:1.10.510.10:FF:001561', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85354, NULL, 'G3DSA:1.25.10.10:FF:003473', NULL, NULL, 'Protein ILITYHIA', NULL, NULL, NULL, NULL, NULL, 4),
(85355, NULL, 'G3DSA:2.30.110.10:FF:000027', NULL, NULL, 'Deazaflavin-dependent nitroreductase ddn', NULL, NULL, NULL, NULL, NULL, 4),
(85356, NULL, 'G3DSA:1.10.287.70:FF:000395', NULL, NULL, 'Putative calcium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(85357, NULL, 'G3DSA:3.60.40.10:FF:000314', NULL, NULL, 'Protein CBG02976', NULL, NULL, NULL, NULL, NULL, 4),
(85358, NULL, 'G3DSA:3.30.40.10:FF:001142', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(85359, NULL, 'G3DSA:3.80.10.10:FF:001109', NULL, NULL, 'Tubulin folding cofactor E-like b', NULL, NULL, NULL, NULL, NULL, 4),
(85360, NULL, 'G3DSA:3.30.830.10:FF:000308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85361, NULL, 'G3DSA:3.40.50.10910:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85362, NULL, 'G3DSA:1.20.1070.10:FF:001450', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(85363, NULL, 'G3DSA:2.30.30.750:FF:000004', NULL, NULL, '5''-3'' exoribonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(85364, NULL, 'G3DSA:3.30.420.80:FF:000011', NULL, NULL, '37S ribosomal protein S18, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(85365, NULL, 'G3DSA:1.10.10.60:FF:000418', NULL, NULL, 'Homeobox protein engrailed-like', NULL, NULL, NULL, NULL, NULL, 4),
(85366, NULL, 'G3DSA:3.40.50.11980:FF:000002', NULL, NULL, 'Proteinaceous RNase P 2', NULL, NULL, NULL, NULL, NULL, 4),
(85367, NULL, 'G3DSA:3.30.360.10:FF:000143', NULL, NULL, 'Lysine-ketoglutarate reductase/saccharopine dehydrogenase bifunctional enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(85368, NULL, 'G3DSA:2.60.40.1090:FF:000026', NULL, NULL, 'Fimbrial subunit ElfA', NULL, NULL, NULL, NULL, NULL, 4),
(85369, NULL, 'G3DSA:3.40.50.2300:FF:001591', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85370, NULL, 'G3DSA:3.10.390.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85371, NULL, 'G3DSA:1.20.58.60:FF:000275', NULL, NULL, 'Kakapo', NULL, NULL, NULL, NULL, NULL, 4),
(85372, NULL, 'G3DSA:1.10.287.550:FF:000005', NULL, NULL, 'Steryl-sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(85373, NULL, 'G3DSA:3.40.50.300:FF:003633', NULL, NULL, 'Cobalt ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(85374, NULL, 'G3DSA:3.90.70.10:FF:000348', NULL, NULL, 'Cysteine proteinase', NULL, NULL, NULL, NULL, NULL, 4),
(85375, NULL, 'G3DSA:3.20.20.140:FF:000273', NULL, NULL, 'Sll0549 protein', NULL, NULL, NULL, NULL, NULL, 4),
(85376, NULL, 'G3DSA:3.30.70.1230:FF:000018', NULL, NULL, 'Adenylate cyclase AcyA', NULL, NULL, NULL, NULL, NULL, 4),
(85377, NULL, 'G3DSA:3.30.160.60:FF:001946', NULL, NULL, 'Zinc finger protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(85378, NULL, 'G3DSA:2.130.10.10:FF:004459', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85379, NULL, 'G3DSA:2.130.10.10:FF:003739', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(85380, NULL, 'G3DSA:4.10.800.20:FF:000001', NULL, NULL, 'AMP deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(85381, NULL, 'G3DSA:3.90.800.10:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85382, NULL, 'G3DSA:2.130.10.10:FF:005752', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85383, NULL, 'G3DSA:3.30.479.10:FF:000002', NULL, NULL, '6-carboxytetrahydropterin synthase QueD', NULL, NULL, NULL, NULL, NULL, 4),
(85384, NULL, 'G3DSA:3.50.50.60:FF:001448', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85385, NULL, 'G3DSA:3.90.770.10:FF:000008', NULL, NULL, '3-hydroxy-3-methylglutaryl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(85386, NULL, 'G3DSA:1.10.1070.11:FF:000116', NULL, NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(85387, NULL, 'G3DSA:2.60.120.10:FF:000780', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85388, NULL, 'G3DSA:2.60.120.10:FF:000049', NULL, NULL, 'Potassium/sodium hyperpolarization-activated cyclic nucleotide-gated channel', NULL, NULL, NULL, NULL, NULL, 4),
(85389, NULL, 'G3DSA:3.40.50.1820:FF:000266', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(85390, NULL, 'G3DSA:2.60.40.60:FF:000770', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85391, NULL, 'G3DSA:3.40.50.300:FF:001424', NULL, NULL, 'Elongation factor 1-alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(85392, NULL, 'G3DSA:3.30.379.10:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85393, NULL, 'G3DSA:1.20.1280.50:FF:000247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85394, NULL, 'G3DSA:1.20.58.160:FF:000005', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(85395, NULL, 'G3DSA:2.40.50.140:FF:001127', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85396, NULL, 'G3DSA:3.60.10.10:FF:000374', NULL, NULL, 'Sphingomyelin phosphodiesterase 5', NULL, NULL, NULL, NULL, NULL, 4),
(85397, NULL, 'G3DSA:1.10.287.130:FF:000054', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(85398, NULL, 'G3DSA:2.60.40.10:FF:002514', NULL, NULL, 'Uncharacterized protein, isoform J', NULL, NULL, NULL, NULL, NULL, 4),
(85399, NULL, 'G3DSA:3.90.550.10:FF:000644', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85400, NULL, 'G3DSA:3.40.630.20:FF:000029', NULL, NULL, 'Pyroglutamyl-peptidase I-like', NULL, NULL, NULL, NULL, NULL, 4),
(85401, NULL, 'G3DSA:3.30.70.1660:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85402, NULL, 'G3DSA:2.10.220.10:FF:000051', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(85403, NULL, 'G3DSA:3.90.550.10:FF:000520', NULL, NULL, 'Glycoside transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(85404, NULL, 'G3DSA:2.20.25.90:FF:000003', NULL, NULL, 'NADH-quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(85405, NULL, 'G3DSA:3.20.20.70:FF:000411', NULL, NULL, 'Indole-3-glycerol phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(85406, NULL, 'G3DSA:3.40.50.10420:FF:000012', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(85407, NULL, 'G3DSA:3.10.100.10:FF:000084', NULL, NULL, 'C-type lectin domain family 14 member A', NULL, NULL, NULL, NULL, NULL, 4),
(85408, NULL, 'G3DSA:3.40.50.2300:FF:000871', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85409, NULL, 'G3DSA:3.30.470.20:FF:000070', NULL, NULL, 'Alpha-glucan water dikinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(85410, NULL, 'G3DSA:1.10.287.70:FF:000474', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85411, NULL, 'G3DSA:1.25.10.10:FF:002045', NULL, NULL, 'Importin subunit alpha-5', NULL, NULL, NULL, NULL, NULL, 4),
(85412, NULL, 'G3DSA:1.20.1050.10:FF:000038', NULL, NULL, 'Glutathione S-transferase omega-like 2', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(85413, NULL, 'G3DSA:3.30.40.10:FF:001703', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(85414, NULL, 'G3DSA:3.30.70.330:FF:002193', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85415, NULL, 'G3DSA:3.30.200.20:FF:001388', NULL, NULL, 'Putative receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(85416, NULL, 'G3DSA:2.60.40.790:FF:000085', NULL, NULL, '23.6 kDa heat shock protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(85417, NULL, 'G3DSA:3.30.10.20:FF:000002', NULL, NULL, 'Serine/threonine protein kinase PrkC', NULL, NULL, NULL, NULL, NULL, 4),
(85418, NULL, 'G3DSA:4.10.970.10:FF:000010', NULL, NULL, 'Caenorhabditis KU', NULL, NULL, NULL, NULL, NULL, 4),
(85419, NULL, 'G3DSA:3.30.160.60:FF:006437', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85420, NULL, 'G3DSA:2.60.120.260:FF:000463', NULL, NULL, 'Acetylxylan esterase / glucomannan deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(85421, NULL, 'G3DSA:3.90.920.10:FF:000004', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(85422, NULL, 'G3DSA:3.40.50.720:FF:001157', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(85423, NULL, 'G3DSA:1.25.10.10:FF:002225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85424, NULL, 'G3DSA:2.10.50.10:FF:000027', NULL, NULL, 'tumor necrosis factor receptor superfamily member 16', NULL, NULL, NULL, NULL, NULL, 4),
(85425, NULL, 'G3DSA:3.40.50.300:FF:000143', NULL, NULL, 'septin-9 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(85426, NULL, 'G3DSA:2.130.10.10:FF:003919', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85427, NULL, 'G3DSA:2.60.40.10:FF:004723', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85428, NULL, 'G3DSA:3.30.70.330:FF:001344', NULL, NULL, 'RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(85429, NULL, 'G3DSA:2.102.10.10:FF:000060', NULL, NULL, 'Benzene 1,2-dioxygenase, ferredoxin protein', NULL, NULL, NULL, NULL, NULL, 4),
(85430, NULL, 'G3DSA:1.10.3380.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85431, NULL, 'G3DSA:1.10.238.10:FF:000404', NULL, NULL, 'Mdr1p', NULL, NULL, NULL, NULL, NULL, 4),
(85432, NULL, 'G3DSA:2.30.29.30:FF:001213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85433, NULL, 'G3DSA:3.80.10.10:FF:002801', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85434, NULL, 'G3DSA:2.40.30.10:FF:000261', NULL, NULL, 'tRNA-specific 2-thiouridylase MnmA', NULL, NULL, NULL, NULL, NULL, 4),
(85435, NULL, 'G3DSA:3.30.450.60:FF:000024', NULL, NULL, 'signal recognition particle receptor subunit alpha isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(85436, NULL, 'G3DSA:2.20.20.110:FF:000009', NULL, NULL, 'DNA repair protein Rad4 homologue, putative', NULL, NULL, NULL, NULL, NULL, 4),
(85437, NULL, 'G3DSA:3.40.50.2300:FF:001259', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85438, NULL, 'G3DSA:3.40.190.10:FF:000498', NULL, NULL, 'GD12707', NULL, NULL, NULL, NULL, NULL, 4),
(85439, NULL, 'G3DSA:3.10.50.40:FF:000005', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(85440, NULL, 'G3DSA:2.130.10.10:FF:001862', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(85441, NULL, 'G3DSA:2.120.10.80:FF:000153', NULL, NULL, 'Kelch-like 11 (Drosophila), isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(85442, NULL, 'G3DSA:3.30.1050.30:FF:000001', NULL, NULL, 'Mycinamicin VI 2''''-O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(85443, NULL, 'G3DSA:2.60.40.4060:FF:000001', NULL, NULL, 'Reelin', NULL, NULL, NULL, NULL, NULL, 4),
(85444, NULL, 'G3DSA:3.40.50.300:FF:006438', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85445, NULL, 'G3DSA:3.30.160.60:FF:001766', NULL, NULL, 'Zinc finger protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(85446, NULL, 'G3DSA:3.30.450.20:FF:000248', NULL, NULL, 'Phosphoserine phosphatase RsbP', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(85447, NULL, 'G3DSA:1.10.510.10:FF:003359', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85448, NULL, 'G3DSA:1.20.1280.130:FF:000004', NULL, NULL, 'Vps-54', NULL, NULL, NULL, NULL, NULL, 4),
(85449, NULL, 'G3DSA:3.40.50.300:FF:001767', NULL, NULL, 'Rab family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(85450, NULL, 'G3DSA:3.80.10.10:FF:001441', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85451, NULL, 'G3DSA:3.40.50.1820:FF:001103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85452, NULL, 'G3DSA:2.130.10.10:FF:003178', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85453, NULL, 'G3DSA:3.40.50.10190:FF:000308', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85454, NULL, 'G3DSA:3.40.50.1820:FF:000827', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(85455, NULL, 'G3DSA:1.20.1070.10:FF:001118', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85456, NULL, 'G3DSA:3.30.420.10:FF:000086', NULL, NULL, 'Ribonuclease H', NULL, NULL, NULL, NULL, NULL, 4),
(85457, NULL, 'G3DSA:3.30.40.10:FF:000686', NULL, NULL, 'E3 ubiquitin-protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(85458, NULL, 'G3DSA:3.30.830.10:FF:000229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85459, NULL, 'G3DSA:3.80.10.10:FF:000031', NULL, NULL, 'leucine-rich repeat protein SHOC-2', NULL, NULL, NULL, NULL, NULL, 4),
(85460, NULL, 'G3DSA:1.10.225.10:FF:000021', NULL, NULL, 'Saposin-related', NULL, NULL, NULL, NULL, NULL, 4),
(85461, NULL, 'G3DSA:1.10.275.10:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85462, NULL, 'G3DSA:2.60.40.1730:FF:000027', NULL, NULL, 'TAF2p TFIID subunit (150 kDa)', NULL, NULL, NULL, NULL, NULL, 4),
(85463, NULL, 'G3DSA:3.30.930.10:FF:000052', NULL, NULL, 'Phenylalanyl-tRNA synthetase, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(85464, NULL, 'G3DSA:3.10.20.360:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85465, NULL, 'G3DSA:2.100.10.20:FF:000001', NULL, NULL, 'Vitelline membrane outer layer 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(85466, NULL, 'G3DSA:3.90.550.50:FF:000009', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(85467, NULL, 'G3DSA:3.10.20.90:FF:000058', NULL, NULL, 'Octicosapeptide/phox/Bem1p domain kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(85468, NULL, 'G3DSA:1.20.1070.10:FF:001793', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85469, NULL, 'G3DSA:1.10.10.250:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85470, NULL, 'G3DSA:3.20.10.10:FF:000027', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(85471, NULL, 'G3DSA:3.60.110.10:FF:000005', NULL, NULL, 'nitrilase homolog 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(85472, NULL, 'G3DSA:1.25.40.10:FF:002957', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g39680', NULL, NULL, NULL, NULL, NULL, 4),
(85473, NULL, 'G3DSA:3.90.470.20:FF:000028', NULL, NULL, '4''-phosphopantetheinyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(85474, NULL, 'G3DSA:1.20.1000.10:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85475, NULL, 'G3DSA:3.80.10.10:FF:003465', NULL, NULL, 'F-box domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(85476, NULL, 'G3DSA:3.40.50.12650:FF:000001', NULL, NULL, 'DNA cross-link repair 1A', NULL, NULL, NULL, NULL, NULL, 4),
(85477, NULL, 'G3DSA:3.30.200.20:FF:001949', NULL, NULL, 'Probable serine/threonine-protein kinase mkcD', NULL, NULL, NULL, NULL, NULL, 4),
(85478, NULL, 'G3DSA:3.30.559.10:FF:000003', NULL, NULL, 'Acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(85479, NULL, 'G3DSA:3.40.1090.10:FF:000102', NULL, NULL, 'Patatin-like phospholipase domain-containing 7b', NULL, NULL, NULL, NULL, NULL, 4),
(85480, NULL, 'G3DSA:2.160.20.10:FF:000035', NULL, NULL, 'F-box only protein 11', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(85481, NULL, 'G3DSA:1.10.510.10:FF:002842', NULL, NULL, 'Receptor tyrosine kinase-like orphan receptor', NULL, NULL, NULL, NULL, NULL, 4),
(85482, NULL, 'G3DSA:3.30.1330.40:FF:000020', NULL, NULL, 'RutC family protein C23G10.2', NULL, NULL, NULL, NULL, NULL, 4),
(85483, NULL, 'G3DSA:2.60.40.1180:FF:000109', NULL, NULL, 'Alpha-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(85484, NULL, 'G3DSA:2.130.10.10:FF:002661', NULL, NULL, 'Uncharacterized WD repeat-containing protein C27B12.05', NULL, NULL, NULL, NULL, NULL, 4),
(85485, NULL, 'G3DSA:1.10.10.10:FF:002106', NULL, NULL, 'RIO family atypical protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(85486, NULL, 'G3DSA:3.30.70.1590:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85487, NULL, 'G3DSA:3.90.1420.10:FF:000010', NULL, NULL, 'Protein SET DOMAIN GROUP 40', NULL, NULL, NULL, NULL, NULL, 4),
(85488, NULL, 'G3DSA:1.10.10.60:FF:001290', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85489, NULL, 'G3DSA:3.90.76.10:FF:000058', NULL, NULL, 'ABC-type dipeptide transport system periplasmic component-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(85490, NULL, 'G3DSA:2.10.90.10:FF:000069', NULL, NULL, 'noggin', NULL, NULL, NULL, NULL, NULL, 4),
(85491, NULL, 'G3DSA:1.10.510.10:FF:004158', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85492, NULL, 'G3DSA:2.60.40.10:FF:003762', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85493, NULL, 'G3DSA:3.40.50.300:FF:007287', NULL, NULL, 'RAS like family 12', NULL, NULL, NULL, NULL, NULL, 4),
(85494, NULL, 'G3DSA:3.10.20.310:FF:000023', NULL, NULL, 'Outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(85495, NULL, 'G3DSA:1.20.120.80:FF:000004', NULL, NULL, 'Cytochrome c oxidase, subunit III', NULL, NULL, NULL, NULL, NULL, 4),
(85496, NULL, 'G3DSA:3.40.850.10:FF:000234', NULL, NULL, 'Iar1 InvA related Kinesin', NULL, NULL, NULL, NULL, NULL, 4),
(85497, NULL, 'G3DSA:3.40.50.2000:FF:000983', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85498, NULL, 'G3DSA:3.40.50.720:FF:001718', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(85499, NULL, 'G3DSA:2.60.40.10:FF:005263', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85500, NULL, 'G3DSA:2.30.29.30:FF:000775', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85501, NULL, 'G3DSA:3.30.530.20:FF:000125', NULL, NULL, 'Major allergen Pru ar 1', NULL, NULL, NULL, NULL, NULL, 4),
(85502, NULL, 'G3DSA:3.10.650.10:FF:000001', NULL, NULL, 'Maltose ABC transporter permease MalF', NULL, NULL, NULL, NULL, NULL, 4),
(85503, NULL, 'G3DSA:3.40.710.10:FF:000084', NULL, NULL, 'Peptidoglycan D,D-transpeptidase FtsI', NULL, NULL, NULL, NULL, NULL, 4),
(85504, NULL, 'G3DSA:3.30.1330.60:FF:000026', NULL, NULL, 'OmpA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(85505, NULL, 'G3DSA:3.20.20.60:FF:000133', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85506, NULL, 'G3DSA:1.10.540.10:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85507, NULL, 'G3DSA:3.40.50.12670:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85508, NULL, 'G3DSA:3.30.565.10:FF:000124', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(85509, NULL, 'G3DSA:1.20.1600.10:FF:000013', NULL, NULL, 'Outer membrane channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(85510, NULL, 'G3DSA:3.40.50.300:FF:003976', NULL, NULL, 'Guanine nucleotide-binding protein alpha-1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(85511, NULL, 'G3DSA:3.40.630.10:FF:000083', NULL, NULL, 'aminoacylase-1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(85512, NULL, 'G3DSA:3.30.160.60:FF:003975', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85513, NULL, 'G3DSA:4.10.60.10:FF:000068', NULL, NULL, 'cellular nucleic acid-binding protein isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(85514, NULL, 'G3DSA:3.50.50.60:FF:000274', NULL, NULL, 'Selenide water dikinase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(85515, NULL, 'G3DSA:2.40.30.10:FF:000030', NULL, NULL, 'cytochrome b-245 heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(85516, NULL, 'G3DSA:3.30.70.260:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85517, NULL, 'G3DSA:1.10.10.10:FF:001825', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85518, NULL, 'G3DSA:3.30.1520.10:FF:000020', NULL, NULL, 'nischarin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(85519, NULL, 'G3DSA:3.30.160.60:FF:000541', NULL, NULL, 'Zinc finger protein 462', NULL, NULL, NULL, NULL, NULL, 4),
(85520, NULL, 'G3DSA:3.40.50.1380:FF:000033', NULL, NULL, 'ATIC', NULL, NULL, NULL, NULL, NULL, 4),
(85521, NULL, 'G3DSA:2.130.10.10:FF:002161', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(85522, NULL, 'G3DSA:1.25.40.10:FF:001384', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(85523, NULL, 'G3DSA:1.20.920.20:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85524, NULL, 'G3DSA:1.25.40.10:FF:001440', NULL, NULL, 'Sel1 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(85525, NULL, 'G3DSA:3.30.160.60:FF:003239', NULL, NULL, 'Zinc finger protein 1144', NULL, NULL, NULL, NULL, NULL, 4),
(85526, NULL, 'G3DSA:3.30.200.20:FF:000668', NULL, NULL, 'Serine/threonine-protein kinase Nek6', NULL, NULL, NULL, NULL, NULL, 4),
(85527, NULL, 'G3DSA:3.30.420.40:FF:000421', NULL, NULL, 'N-acetylglucosamine repressor', NULL, NULL, NULL, NULL, NULL, 4),
(85528, NULL, 'G3DSA:1.20.140.150:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85529, NULL, 'G3DSA:2.40.30.30:FF:000036', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85530, NULL, 'G3DSA:3.40.50.300:FF:002560', NULL, NULL, 'Axonemal dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(85531, NULL, 'G3DSA:1.25.40.10:FF:000872', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(85532, NULL, 'G3DSA:1.20.1250.20:FF:001141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85533, NULL, 'G3DSA:3.30.230.70:FF:000078', NULL, NULL, 'RNase PH family, RRP42 subunit protein', NULL, NULL, NULL, NULL, NULL, 4),
(85534, NULL, 'G3DSA:2.130.10.10:FF:001593', NULL, NULL, 'protein lethal(2)denticleless', NULL, NULL, NULL, NULL, NULL, 4),
(85535, NULL, 'G3DSA:3.30.230.70:FF:000134', NULL, NULL, '3'' exoribonuclease family, domain 1 containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(85536, NULL, 'G3DSA:3.30.420.40:FF:000365', NULL, NULL, 'Conserved hypothetical proline and threonine rich protein', NULL, NULL, NULL, NULL, NULL, 4),
(85537, NULL, 'G3DSA:1.20.1560.10:FF:000925', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(85538, NULL, 'G3DSA:2.40.50.90:FF:000010', NULL, NULL, 'Ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(85539, NULL, 'G3DSA:3.10.580.10:FF:000118', NULL, NULL, 'Domain_of_uncharacterized_function_DUF21 /CBS_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(85540, NULL, 'G3DSA:2.40.20.10:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85541, NULL, 'G3DSA:2.30.29.30:FF:001000', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85542, NULL, 'G3DSA:2.10.25.10:FF:000727', NULL, NULL, 'Stabilin 1', NULL, NULL, NULL, NULL, NULL, 4),
(85543, NULL, 'G3DSA:3.90.780.10:FF:000009', NULL, NULL, 'Ser/Thr protein phosphatase family', NULL, NULL, NULL, NULL, NULL, 4),
(85544, NULL, 'G3DSA:3.30.750.24:FF:000118', NULL, NULL, 'Sulfate/bicarbonate/oxalate exchanger SAT-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(85545, NULL, 'G3DSA:1.25.10.10:FF:001505', NULL, NULL, 'Exportin-T', NULL, NULL, NULL, NULL, NULL, 4),
(85546, NULL, 'G3DSA:2.60.40.150:FF:000005', NULL, NULL, 'Synaptotagmin 6', NULL, NULL, NULL, NULL, NULL, 4),
(85547, NULL, 'G3DSA:3.60.21.10:FF:000343', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(85548, NULL, 'G3DSA:2.40.30.110:FF:000018', NULL, NULL, 'Glycine cleavage system aminomethyltransferase T', NULL, NULL, NULL, NULL, NULL, 4),
(85549, NULL, 'G3DSA:3.30.40.10:FF:001934', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85550, NULL, 'G3DSA:3.20.20.300:FF:000080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85551, NULL, 'G3DSA:1.10.4160.10:FF:000004', NULL, NULL, 'Putative allantoin permease', NULL, NULL, NULL, NULL, NULL, 4),
(85552, NULL, 'G3DSA:2.10.25.10:FF:001340', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85553, NULL, 'G3DSA:3.40.50.2300:FF:001028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85554, NULL, 'G3DSA:3.30.160.570:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85555, NULL, 'G3DSA:3.30.750.24:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85556, NULL, 'G3DSA:2.10.25.10:FF:001239', NULL, NULL, 'Coagulation factor VII', NULL, NULL, NULL, NULL, NULL, 4),
(85557, NULL, 'G3DSA:3.80.10.10:FF:001672', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85558, NULL, 'G3DSA:3.30.160.60:FF:000485', NULL, NULL, 'Zinc finger protein 90 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(85559, NULL, 'G3DSA:3.30.160.100:FF:000002', NULL, NULL, 'Ribosome-associated translation inhibitor RaiA', NULL, NULL, NULL, NULL, NULL, 4),
(85560, NULL, 'G3DSA:3.40.50.720:FF:001550', NULL, NULL, 'YALI0A19536p', NULL, NULL, NULL, NULL, NULL, 4),
(85561, NULL, 'G3DSA:3.40.630.10:FF:000370', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85562, NULL, 'G3DSA:3.30.70.330:FF:001001', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(85563, NULL, 'G3DSA:2.60.120.650:FF:000041', NULL, NULL, 'lysine-specific demethylase 5C isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(85564, NULL, 'G3DSA:3.40.33.10:FF:000012', NULL, NULL, 'Secreted protein PRY1', NULL, NULL, NULL, NULL, NULL, 4),
(85565, NULL, 'G3DSA:3.10.20.90:FF:000327', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(85566, NULL, 'G3DSA:2.130.10.10:FF:005920', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85567, NULL, 'G3DSA:3.40.50.720:FF:000033', NULL, NULL, 'Adenylyltransferase and sulfurtransferase MOCS3', NULL, NULL, NULL, NULL, NULL, 4),
(85568, NULL, 'G3DSA:1.10.238.10:FF:001124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85569, NULL, 'G3DSA:1.10.540.10:FF:000040', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(85570, NULL, 'G3DSA:3.40.50.300:FF:006831', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85571, NULL, 'G3DSA:3.40.630.30:FF:000358', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85572, NULL, 'G3DSA:1.10.437.10:FF:000018', NULL, NULL, 'BCL2 like 15', NULL, NULL, NULL, NULL, NULL, 4),
(85573, NULL, 'G3DSA:3.30.500.10:FF:000031', NULL, NULL, 'T-cell surface glycoprotein CD1A1 antigen', NULL, NULL, NULL, NULL, NULL, 4),
(85574, NULL, 'G3DSA:1.20.1280.290:FF:000030', NULL, NULL, 'Bidirectional sugar transporter SWEET3b', NULL, NULL, NULL, NULL, NULL, 4),
(85575, NULL, 'G3DSA:1.10.520.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85576, NULL, 'G3DSA:3.40.309.10:FF:000078', NULL, NULL, 'Succinate-semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(85577, NULL, 'G3DSA:3.30.1490.480:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85578, NULL, 'G3DSA:1.10.4080.10:FF:000003', NULL, NULL, 'ADP-ribosyl-[dinitrogen reductase] glycohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(85579, NULL, 'G3DSA:1.25.10.10:FF:000196', NULL, NULL, 'Sperm associated antigen 6', NULL, NULL, NULL, NULL, NULL, 4),
(85580, NULL, 'G3DSA:3.30.1600.10:FF:000021', NULL, NULL, 'NAD-dependent histone deacetylase Sir2', NULL, NULL, NULL, NULL, NULL, 4),
(85581, NULL, 'G3DSA:2.120.10.80:FF:000130', NULL, NULL, 'Kelch repeat-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(85582, NULL, 'G3DSA:1.25.10.10:FF:000252', NULL, NULL, 'pumilio homolog 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(85583, NULL, 'G3DSA:3.50.50.60:FF:000223', NULL, NULL, '6-hydroxynicotinate 3-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(85584, NULL, 'G3DSA:3.40.50.1440:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85585, NULL, 'G3DSA:3.30.230.70:FF:000027', NULL, NULL, 'Exosome complex component RRP46', NULL, NULL, NULL, NULL, NULL, 4),
(85586, NULL, 'G3DSA:3.30.1640.10:FF:000023', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(85587, NULL, 'G3DSA:3.40.309.10:FF:000027', NULL, NULL, 'Phenylacetaldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(85588, NULL, 'G3DSA:3.40.50.970:FF:000203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85589, NULL, 'G3DSA:3.40.50.300:FF:006882', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85590, NULL, 'G3DSA:1.20.58.400:FF:000010', NULL, NULL, 'VTI (Vesicle Transport through t-SNARE Interaction) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(85591, NULL, 'G3DSA:1.10.1070.11:FF:000037', NULL, NULL, 'Phosphatidylinositol kinase (PIK-L3)', NULL, NULL, NULL, NULL, NULL, 4),
(85592, NULL, 'G3DSA:3.20.20.140:FF:000458', NULL, NULL, 'Guanine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(85593, NULL, 'G3DSA:3.90.1750.10:FF:000046', NULL, NULL, 'Hyperplastic disks-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(85594, NULL, 'G3DSA:3.40.640.10:FF:000191', NULL, NULL, 'Serine-pyruvate aminotransferase (AgxT)', NULL, NULL, NULL, NULL, NULL, 4),
(85595, NULL, 'G3DSA:3.40.50.720:FF:001449', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85596, NULL, 'G3DSA:2.40.50.100:FF:000177', NULL, NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(85597, NULL, 'G3DSA:2.40.50.100:FF:000233', NULL, NULL, 'Molybdenum import ATP-binding protein ModC', NULL, NULL, NULL, NULL, NULL, 4),
(85598, NULL, 'G3DSA:2.70.98.10:FF:000016', NULL, NULL, 'Glucose-6-phosphate 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(85599, NULL, 'G3DSA:3.50.50.60:FF:000959', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85600, NULL, 'G3DSA:1.25.10.10:FF:001556', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85601, NULL, 'G3DSA:3.60.21.10:FF:000394', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(85602, NULL, 'G3DSA:1.25.10.10:FF:000988', NULL, NULL, 'Crescerin-like protein che-12', NULL, NULL, NULL, NULL, NULL, 4),
(85603, NULL, 'G3DSA:2.30.29.30:FF:000432', NULL, NULL, 'Calcium-dependent protein kinase 7', NULL, NULL, NULL, NULL, NULL, 4),
(85604, NULL, 'G3DSA:2.10.70.10:FF:000298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85605, NULL, 'G3DSA:1.10.510.10:FF:002573', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85606, NULL, 'G3DSA:2.60.40.60:FF:000590', NULL, NULL, 'Si:ch73-74h11.1', NULL, NULL, NULL, NULL, NULL, 4),
(85607, NULL, 'G3DSA:3.30.70.1450:FF:000028', NULL, NULL, 'Potassium transporter peripheral membrane component', NULL, NULL, NULL, NULL, NULL, 4),
(85608, NULL, 'G3DSA:1.20.120.980:FF:000037', NULL, NULL, 'Serine carboxypeptidase S28 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(85609, NULL, 'G3DSA:3.30.300.30:FF:000089', NULL, NULL, 'NonRibosomal Peptide Synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(85610, NULL, 'G3DSA:3.40.50.300:FF:006775', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85611, NULL, 'G3DSA:3.40.50.620:FF:000677', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85612, NULL, 'G3DSA:1.10.238.10:FF:001068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85613, NULL, 'G3DSA:2.60.40.10:FF:000092', NULL, NULL, 'Filamin-B isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(85614, NULL, 'G3DSA:3.30.40.10:FF:000681', NULL, NULL, 'BnaA09g51130D protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(85615, NULL, 'G3DSA:4.10.400.10:FF:000147', NULL, NULL, 'Low-density lipoprotein receptor-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(85616, NULL, 'G3DSA:3.90.226.10:FF:000082', NULL, NULL, 'Putative enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(85617, NULL, 'G3DSA:3.60.21.10:FF:000287', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(85618, NULL, 'G3DSA:2.120.10.80:FF:000074', NULL, NULL, 'Kelch domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(85619, NULL, 'G3DSA:3.90.660.20:FF:000003', NULL, NULL, 'Prenylcysteine oxidase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(85620, NULL, 'G3DSA:3.40.50.360:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85621, NULL, 'G3DSA:3.40.50.1000:FF:000172', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(85622, NULL, 'G3DSA:1.10.10.2010:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85623, NULL, 'G3DSA:3.40.630.30:FF:000414', NULL, NULL, 'Chromodomain-helicase-DNA-binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(85624, NULL, 'G3DSA:1.10.510.10:FF:003859', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85625, NULL, 'G3DSA:2.10.25.10:FF:001391', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85626, NULL, 'G3DSA:1.20.1560.10:FF:000184', NULL, NULL, 'Multidrug ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(85627, NULL, 'G3DSA:1.20.5.170:FF:000177', NULL, NULL, 'Laminin subunit alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(85628, NULL, 'G3DSA:3.30.910.20:FF:000003', NULL, NULL, 'Outer membrane protein ompH', NULL, NULL, NULL, NULL, NULL, 4),
(85629, NULL, 'G3DSA:2.60.40.10:FF:005156', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85630, NULL, 'G3DSA:3.30.200.20:FF:001606', NULL, NULL, 'Protein kinase, catalytic domain', NULL, NULL, NULL, NULL, NULL, 4),
(85631, NULL, 'G3DSA:3.40.50.2300:FF:001091', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85632, NULL, 'G3DSA:1.25.40.20:FF:000549', NULL, NULL, 'AGAP006384-PA', NULL, NULL, NULL, NULL, NULL, 4),
(85633, NULL, 'G3DSA:3.30.40.100:FF:000004', NULL, NULL, 'MORC family CW-type zinc finger 1', NULL, NULL, NULL, NULL, NULL, 4),
(85634, NULL, 'G3DSA:3.40.50.10810:FF:000146', NULL, NULL, 'RAD54L isoform 5', NULL, NULL, NULL, NULL, NULL, 4),
(85635, NULL, 'G3DSA:3.40.525.10:FF:000001', NULL, NULL, 'BCL2/adenovirus E1B protein-interacting protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(85636, NULL, 'G3DSA:3.40.50.300:FF:004358', NULL, NULL, 'Putative anion ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(85637, NULL, 'G3DSA:3.30.70.2190:FF:000008', NULL, NULL, 'Actin interacting protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(85638, NULL, 'G3DSA:3.30.40.10:FF:001193', NULL, NULL, 'GD24108', NULL, NULL, NULL, NULL, NULL, 4),
(85639, NULL, 'G3DSA:1.20.190.20:FF:000007', NULL, NULL, '14-3-3 protein beta/alpha', NULL, NULL, NULL, NULL, NULL, 4),
(85640, NULL, 'G3DSA:3.40.50.10190:FF:000359', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85641, NULL, 'G3DSA:3.40.50.1820:FF:000210', NULL, NULL, 'Possible long-chain acyl-CoA synthase', NULL, NULL, NULL, NULL, NULL, 4),
(85642, NULL, 'G3DSA:3.40.50.11340:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85643, NULL, 'G3DSA:3.30.70.980:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85644, NULL, 'G3DSA:3.20.20.190:FF:000119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85645, NULL, 'G3DSA:3.40.640.10:FF:000084', NULL, NULL, 'IscS-like cysteine desulfurase', NULL, NULL, NULL, NULL, NULL, 4),
(85646, NULL, 'G3DSA:3.10.450.700:FF:000011', NULL, NULL, 'Ci-PUR-alpha/beta/gamma protein', NULL, NULL, NULL, NULL, NULL, 4),
(85647, NULL, 'G3DSA:3.40.30.10:FF:000770', NULL, NULL, 'Peroxiredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(85648, NULL, 'G3DSA:1.25.40.570:FF:000052', NULL, NULL, 'COP9 signalosome complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(85649, NULL, 'G3DSA:1.10.472.80:FF:000082', NULL, NULL, 'Unplaced genomic scaffold supercont1.67, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(85650, NULL, 'G3DSA:1.10.510.10:FF:000156', NULL, NULL, 'Serine/threonine-protein kinase SIK3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(85651, NULL, 'G3DSA:1.20.120.1900:FF:000005', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(85652, NULL, 'G3DSA:3.40.50.10810:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85653, NULL, 'G3DSA:3.80.10.10:FF:002958', NULL, NULL, 'Uncharacterized protein AT4g09430', NULL, NULL, NULL, NULL, NULL, 4),
(85654, NULL, 'G3DSA:2.60.120.820:FF:000007', NULL, NULL, 'Macaca fascicularis brain cDNA clone: QmoA-10892, similar to human BTB (POZ) domain containing 1 (BTBD1), mRNA, RefSeq: NM_025238.1', NULL, NULL, NULL, NULL, NULL, 4),
(85655, NULL, 'G3DSA:3.40.390.10:FF:000159', NULL, NULL, 'Neutral protease 2', NULL, NULL, NULL, NULL, NULL, 4),
(85656, NULL, 'G3DSA:3.30.160.60:FF:005656', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85657, NULL, 'G3DSA:3.30.160.60:FF:005712', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85658, NULL, 'G3DSA:3.30.200.20:FF:002118', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85659, NULL, 'G3DSA:2.70.150.10:FF:000228', NULL, NULL, 'Plasma membrane calcium-transporting ATPase putative', NULL, NULL, NULL, NULL, NULL, 4),
(85660, NULL, 'G3DSA:3.30.160.60:FF:002790', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85661, NULL, 'G3DSA:3.40.228.10:FF:000002', NULL, NULL, 'Formate dehydrogenase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(85662, NULL, 'G3DSA:3.30.300.30:FF:000038', NULL, NULL, 'Nonribosomal siderophore peptide synthase SidC', NULL, NULL, NULL, NULL, NULL, 4),
(85663, NULL, 'G3DSA:1.25.40.10:FF:000080', NULL, NULL, 'hsc70-interacting protein-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(85664, NULL, 'G3DSA:2.60.120.200:FF:000260', NULL, NULL, 'CAlSYntenin/Alcadein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(85665, NULL, 'G3DSA:3.30.70.1070:FF:000010', NULL, NULL, 'Sporulation related domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(85666, NULL, 'G3DSA:2.60.40.10:FF:004700', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85667, NULL, 'G3DSA:2.130.10.10:FF:005813', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85668, NULL, 'G3DSA:1.10.510.10:FF:000268', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(85669, NULL, 'G3DSA:1.10.510.10:FF:004427', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85670, NULL, 'G3DSA:2.130.10.10:FF:002902', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85671, NULL, 'G3DSA:2.20.70.10:FF:000157', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(85672, NULL, 'G3DSA:3.90.550.10:FF:000464', NULL, NULL, '2-C-methyl-D-erythritol 4-phosphate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(85673, NULL, 'G3DSA:1.25.40.20:FF:001662', NULL, NULL, 'RE06111p', NULL, NULL, NULL, NULL, NULL, 4),
(85674, NULL, 'G3DSA:3.90.550.10:FF:000352', NULL, NULL, 'Cellulose synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(85675, NULL, 'G3DSA:3.90.70.10:FF:000112', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(85676, NULL, 'G3DSA:1.10.340.30:FF:000047', NULL, NULL, 'DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(85677, NULL, 'G3DSA:1.10.274.100:FF:000007', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(85678, NULL, 'G3DSA:3.30.30.30:FF:000051', NULL, NULL, 'Putative heat shock 70 kDa protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(85679, NULL, 'G3DSA:2.60.120.800:FF:000001', NULL, NULL, 'Outer capsid glycoprotein VP7', NULL, NULL, NULL, NULL, NULL, 4),
(85680, NULL, 'G3DSA:3.40.50.150:FF:000165', NULL, NULL, 'probable methyltransferase PMT13', NULL, NULL, NULL, NULL, NULL, 4),
(85681, NULL, 'G3DSA:1.10.3210.10:FF:000003', NULL, NULL, 'Ribonuclease Y', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(85682, NULL, 'G3DSA:1.10.8.60:FF:000485', NULL, NULL, 'Adenosinetriphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(85683, NULL, 'G3DSA:2.60.40.10:FF:001845', NULL, NULL, 'Bent, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(85684, NULL, 'G3DSA:1.20.1050.80:FF:000019', NULL, NULL, 'RIN (Ras/Rab INteractor) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(85685, NULL, 'G3DSA:1.20.1560.10:FF:000133', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(85686, NULL, 'G3DSA:3.30.1490.20:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85687, NULL, 'G3DSA:1.25.40.570:FF:000001', NULL, NULL, 'Putative cop9 signalosome complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(85688, NULL, 'G3DSA:1.10.357.70:FF:000007', NULL, NULL, 'Unplaced genomic scaffold supercont1.138, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(85689, NULL, 'G3DSA:3.30.420.40:FF:000314', NULL, NULL, 'Actin-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(85690, NULL, 'G3DSA:2.60.120.970:FF:000024', NULL, NULL, 'Left-right determination factor', NULL, NULL, NULL, NULL, NULL, 4),
(85691, NULL, 'G3DSA:3.10.580.10:FF:000181', NULL, NULL, 'Chloride channel, voltage-sensitive 1a', NULL, NULL, NULL, NULL, NULL, 4),
(85692, NULL, 'G3DSA:3.80.10.10:FF:001609', NULL, NULL, 'Pollen receptor-like kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(85693, NULL, 'G3DSA:1.20.1740.10:FF:000170', NULL, NULL, 'High affinity cationic amino acid transporter 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(85694, NULL, 'G3DSA:3.40.50.720:FF:000937', NULL, NULL, 'Short-chain dehydrogenase/reductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(85695, NULL, 'G3DSA:2.40.10.10:FF:000338', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85696, NULL, 'G3DSA:3.30.200.20:FF:002181', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85697, NULL, 'G3DSA:3.40.50.2000:FF:000663', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(85698, NULL, 'G3DSA:1.20.5.420:FF:000011', NULL, NULL, 'Vacuolar protein sorting-associated protein VTA1', NULL, NULL, NULL, NULL, NULL, 4),
(85699, NULL, 'G3DSA:3.30.300.10:FF:000032', NULL, NULL, 'S-adenosylmethionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(85700, NULL, 'G3DSA:3.50.50.60:FF:000167', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(85701, NULL, 'G3DSA:3.40.800.20:FF:000060', NULL, NULL, 'Histone deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(85702, NULL, 'G3DSA:1.10.8.970:FF:000003', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(85703, NULL, 'G3DSA:2.60.40.10:FF:000833', NULL, NULL, 'Titin b', NULL, NULL, NULL, NULL, NULL, 4),
(85704, NULL, 'G3DSA:3.40.190.80:FF:000030', NULL, NULL, 'Myo-inositol-1(Or 4)-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(85705, NULL, 'G3DSA:1.10.10.10:FF:001140', NULL, NULL, 'DNA-binding transcriptional regulator, Lrp family', NULL, NULL, NULL, NULL, NULL, 4),
(85706, NULL, 'G3DSA:1.10.10.440:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85707, NULL, 'G3DSA:1.25.40.90:FF:000002', NULL, NULL, 'epsin-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(85708, NULL, 'G3DSA:3.30.413.10:FF:000002', NULL, NULL, '4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase (flavodoxin)', NULL, NULL, NULL, NULL, NULL, 4),
(85709, NULL, 'G3DSA:1.10.601.10:FF:000007', NULL, NULL, 'RNA polymerase sigma factor sigB', NULL, NULL, NULL, NULL, NULL, 4),
(85710, NULL, 'G3DSA:3.40.20.10:FF:000038', NULL, NULL, 'Villin-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(85711, NULL, 'G3DSA:3.40.50.300:FF:003009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85712, NULL, 'G3DSA:3.40.50.720:FF:000201', NULL, NULL, 'UDP-D-apiose/UDP-D-xylose synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(85713, NULL, 'G3DSA:3.30.160.60:FF:006168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85714, NULL, 'G3DSA:1.10.565.10:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(85715, NULL, 'G3DSA:1.10.101.10:FF:000037', NULL, NULL, 'Anhydro-N-acetylmuramyl-tripeptide amidase', NULL, NULL, NULL, NULL, NULL, 4),
(85716, NULL, 'G3DSA:3.10.20.90:FF:000378', NULL, NULL, 'FERM domain (Protein4.1-ezrin-radixin-moesin) family', NULL, NULL, NULL, NULL, NULL, 4),
(85717, NULL, 'G3DSA:4.10.400.10:FF:000035', NULL, NULL, 'prolow-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(85718, NULL, 'G3DSA:2.10.110.40:FF:000001', NULL, NULL, 'E1A binding protein p300', NULL, NULL, NULL, NULL, NULL, 4),
(85719, NULL, 'G3DSA:1.10.420.10:FF:000042', NULL, NULL, 'Ascorbate peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(85720, NULL, 'G3DSA:3.20.20.380:FF:000002', NULL, NULL, 'copper homeostasis protein cutC homolog', NULL, NULL, NULL, NULL, NULL, 4),
(85721, NULL, 'G3DSA:3.40.980.10:FF:000007', NULL, NULL, 'FAD synthase', NULL, NULL, NULL, NULL, NULL, 4),
(85722, NULL, 'G3DSA:3.30.565.10:FF:000231', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(85723, NULL, 'G3DSA:3.30.160.60:FF:005156', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85724, NULL, 'G3DSA:3.90.1750.10:FF:000091', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85725, NULL, 'G3DSA:3.30.70.330:FF:000063', NULL, NULL, 'MEI2-like protein 5 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(85726, NULL, 'G3DSA:3.40.50.1820:FF:001547', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85727, NULL, 'G3DSA:1.25.40.420:FF:000035', NULL, NULL, 'CBN-EOR-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(85728, NULL, 'G3DSA:2.130.10.10:FF:005864', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(85729, NULL, 'G3DSA:2.10.80.10:FF:000012', NULL, NULL, 'Dkk3-like 2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(85730, NULL, 'G3DSA:2.70.150.10:FF:000291', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(85731, NULL, 'G3DSA:1.10.3210.10:FF:000059', NULL, NULL, 'Metal-dependent phosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(85732, NULL, 'G3DSA:2.60.120.920:FF:000071', NULL, NULL, 'Compass component bre2', NULL, NULL, NULL, NULL, NULL, 4),
(85733, NULL, 'G3DSA:3.30.497.10:FF:000111', NULL, NULL, 'Serine protease inhibitor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(85734, NULL, 'G3DSA:3.30.1490.20:FF:000031', NULL, NULL, 'Synapsin III', NULL, NULL, NULL, NULL, NULL, 4),
(85735, NULL, 'G3DSA:3.40.50.150:FF:001469', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85736, NULL, 'G3DSA:3.30.70.330:FF:001349', NULL, NULL, 'CiMsi', NULL, NULL, NULL, NULL, NULL, 4),
(85737, NULL, 'G3DSA:1.10.630.10:FF:000760', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(85738, NULL, 'G3DSA:3.40.190.10:FF:000211', NULL, NULL, 'Phosphate-binding protein PstS', NULL, NULL, NULL, NULL, NULL, 4),
(85739, NULL, 'G3DSA:1.10.533.10:FF:000012', NULL, NULL, 'baculoviral IAP repeat-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(85740, NULL, 'G3DSA:2.30.29.30:FF:001056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85741, NULL, 'G3DSA:3.90.1490.10:FF:000008', NULL, NULL, 'ATP-binding domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(85742, NULL, 'G3DSA:3.30.200.20:FF:000264', NULL, NULL, 'Protein-ribulosamine 3-kinase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(85743, NULL, 'G3DSA:1.10.533.10:FF:000248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85744, NULL, 'G3DSA:1.10.10.720:FF:000005', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(85745, NULL, 'G3DSA:3.30.200.20:FF:000320', NULL, NULL, 'probable L-type lectin-domain containing receptor kinase S.5', NULL, NULL, NULL, NULL, NULL, 4),
(85746, NULL, 'G3DSA:1.10.533.10:FF:000304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85747, NULL, 'G3DSA:3.30.200.20:FF:000612', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(85748, NULL, 'G3DSA:1.10.400.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(85749, NULL, 'G3DSA:3.30.1370.10:FF:000098', NULL, NULL, 'Pbp2p', NULL, NULL, NULL, NULL, NULL, 4),
(85750, NULL, 'G3DSA:3.60.21.60:FF:000004', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(85751, NULL, 'G3DSA:3.30.70.330:FF:001405', NULL, NULL, 'YALI0B00616p', NULL, NULL, NULL, NULL, NULL, 4),
(85752, NULL, 'G3DSA:1.20.5.190:FF:000127', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85753, NULL, 'G3DSA:4.10.960.10:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85754, NULL, 'G3DSA:2.30.29.30:FF:000488', NULL, NULL, 'Ran-binding protein 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(85755, NULL, 'G3DSA:2.60.40.60:FF:000415', NULL, NULL, 'cadherin-89D', NULL, NULL, NULL, NULL, NULL, 4),
(85756, NULL, 'G3DSA:3.30.160.60:FF:000081', NULL, NULL, 'Zinc finger homeobox protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(85757, NULL, 'G3DSA:3.30.342.10:FF:000039', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(85758, NULL, 'G3DSA:2.30.38.10:FF:000020', NULL, NULL, 'Non-ribosomal peptide synthetase OfaA', NULL, NULL, NULL, NULL, NULL, 4),
(85759, NULL, 'G3DSA:1.20.120.1630:FF:000020', NULL, NULL, 'Phosphatidylethanolamine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(85760, NULL, 'G3DSA:2.60.40.150:FF:000409', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85761, NULL, 'G3DSA:1.10.720.30:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85762, NULL, 'G3DSA:2.170.140.10:FF:000018', NULL, NULL, 'MIP27520p', NULL, NULL, NULL, NULL, NULL, 4),
(85763, NULL, 'G3DSA:1.20.5.170:FF:000121', NULL, NULL, 'Transcription factor jun-1', NULL, NULL, NULL, NULL, NULL, 4),
(85764, NULL, 'G3DSA:1.10.1410.10:FF:000035', NULL, NULL, 'Mitochondrial editosome-like complex associated TUTase', NULL, NULL, NULL, NULL, NULL, 4),
(85765, NULL, 'G3DSA:2.60.40.150:FF:000117', NULL, NULL, 'copine-5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(85766, NULL, 'G3DSA:3.60.130.10:FF:000012', NULL, NULL, 'Pyoverdine/dityrosine biosynthesis protein, putative (AFU_orthologue AFUA_5G02660)', NULL, NULL, NULL, NULL, NULL, 4),
(85767, NULL, 'G3DSA:1.10.10.60:FF:000233', NULL, NULL, 'Distal-less, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(85768, NULL, 'G3DSA:2.30.29.30:FF:000836', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85769, NULL, 'G3DSA:1.10.3130.10:FF:000002', NULL, NULL, 'Serine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(85770, NULL, 'G3DSA:4.10.400.10:FF:000086', NULL, NULL, 'Terribly reduced optic lobes, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(85771, NULL, 'G3DSA:1.20.58.60:FF:000432', NULL, NULL, 'AGAP009554-PA', NULL, NULL, NULL, NULL, NULL, 4),
(85772, NULL, 'G3DSA:3.30.160.60:FF:004700', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85773, NULL, 'G3DSA:2.102.10.10:FF:000015', NULL, NULL, 'Naphthalene 1,2-dioxygenase ferredoxin component', NULL, NULL, NULL, NULL, NULL, 4),
(85774, NULL, 'G3DSA:3.30.160.60:FF:002806', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(85775, NULL, 'G3DSA:3.40.20.10:FF:000033', NULL, NULL, 'Villin-4', NULL, NULL, NULL, NULL, NULL, 4),
(85776, NULL, 'G3DSA:1.10.3210.10:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85777, NULL, 'G3DSA:1.20.58.80:FF:000045', NULL, NULL, 'Spartin a', NULL, NULL, NULL, NULL, NULL, 4),
(85778, NULL, 'G3DSA:3.40.50.10810:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85779, NULL, 'G3DSA:3.40.50.300:FF:005718', NULL, NULL, 'Putative serine/threonine-protein kinase pats1', NULL, NULL, NULL, NULL, NULL, 4),
(85780, NULL, 'G3DSA:3.90.79.10:FF:000104', NULL, NULL, 'ADP-ribose pyrophosphatase YjhB, NUDIX family', NULL, NULL, NULL, NULL, NULL, 4),
(85781, NULL, 'G3DSA:1.20.58.150:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85782, NULL, 'G3DSA:2.60.40.10:FF:001789', NULL, NULL, 'Terribly reduced optic lobes, isoform AQ', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(85783, NULL, 'G3DSA:1.10.238.10:FF:000635', NULL, NULL, 'Calpain a', NULL, NULL, NULL, NULL, NULL, 4),
(85784, NULL, 'G3DSA:3.30.160.60:FF:006117', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85785, NULL, 'G3DSA:3.40.50.300:FF:004914', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85786, NULL, 'G3DSA:3.10.129.10:FF:000172', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(85787, NULL, 'G3DSA:3.40.50.300:FF:000643', NULL, NULL, 'Small monomeric GTPase (Gtr2)', NULL, NULL, NULL, NULL, NULL, 4),
(85788, NULL, 'G3DSA:1.10.287.130:FF:000211', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(85789, NULL, 'G3DSA:1.10.520.10:FF:000038', NULL, NULL, 'L-ascorbate peroxidase 2 cytosolic', NULL, NULL, NULL, NULL, NULL, 4),
(85790, NULL, 'G3DSA:3.40.605.10:FF:000002', NULL, NULL, 'Gamma-glutamyl phosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(85791, NULL, 'G3DSA:3.20.20.70:FF:000198', NULL, NULL, 'Deoxyribose-phosphate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(85792, NULL, 'G3DSA:3.40.50.10490:FF:000095', NULL, NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', NULL, NULL, NULL, NULL, NULL, 4),
(85793, NULL, 'G3DSA:3.30.60.20:FF:000050', NULL, NULL, 'Rho guanine nucleotide exchange factor 28', NULL, NULL, NULL, NULL, NULL, 4),
(85794, NULL, 'G3DSA:2.60.40.150:FF:000180', NULL, NULL, 'synaptotagmin-5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(85795, NULL, 'G3DSA:1.20.1250.20:FF:000028', NULL, NULL, 'Sugar phosphate exchanger 3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(85796, NULL, 'G3DSA:3.40.1110.10:FF:000099', NULL, NULL, 'Copper-translocating P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(85797, NULL, 'G3DSA:2.130.10.10:FF:000244', NULL, NULL, 'Carboxy-cis,cis-muconate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(85798, NULL, 'G3DSA:3.90.79.10:FF:000155', NULL, NULL, 'ADP-ribose diphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(85799, NULL, 'G3DSA:3.30.870.10:FF:000119', NULL, NULL, 'Phosphatidylcholine-hydrolyzing phospholipase D (PLD) family', NULL, NULL, NULL, NULL, NULL, 4),
(85800, NULL, 'G3DSA:2.60.40.10:FF:002357', NULL, NULL, 'Basigin, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(85801, NULL, 'G3DSA:2.40.30.70:FF:000020', NULL, NULL, 'tRNA (adenine(37)-N6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(85802, NULL, 'G3DSA:1.20.1070.10:FF:001681', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85803, NULL, 'G3DSA:3.40.630.60:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85804, NULL, 'G3DSA:3.30.559.10:FF:000059', NULL, NULL, 'Transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(85805, NULL, 'G3DSA:3.30.60.270:FF:000020', NULL, NULL, 'Si:dkey-159a18.1', NULL, NULL, NULL, NULL, NULL, 4),
(85806, NULL, 'G3DSA:3.90.79.10:FF:000211', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(85807, NULL, 'G3DSA:3.30.559.10:FF:000115', NULL, NULL, 'Putative alcohol O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(85808, NULL, 'G3DSA:3.30.70.60:FF:000040', NULL, NULL, 'Intersectin-2', NULL, NULL, NULL, NULL, NULL, 4),
(85809, NULL, 'G3DSA:3.90.70.10:FF:000163', NULL, NULL, 'Dipeptidyl-peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(85810, NULL, 'G3DSA:2.60.120.10:FF:000493', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85811, NULL, 'G3DSA:1.10.3210.10:FF:000054', NULL, NULL, 'Metal-dependent phosphohydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(85812, NULL, 'G3DSA:3.30.70.80:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85813, NULL, 'G3DSA:3.60.130.10:FF:000063', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85814, NULL, 'G3DSA:3.10.490.10:FF:000022', NULL, NULL, 'Protein AIG2 B', NULL, NULL, NULL, NULL, NULL, 4),
(85815, NULL, 'G3DSA:3.40.50.300:FF:003953', NULL, NULL, 'tRNA (Adenosine(37)-N6)-threonylcarbamoyltransferase complex ATPase subunit type 1 TsaE', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(85816, NULL, 'G3DSA:3.40.50.300:FF:002048', NULL, NULL, 'Septin 6', NULL, NULL, NULL, NULL, NULL, 4),
(85817, NULL, 'G3DSA:3.20.20.80:FF:000532', NULL, NULL, 'Glucan 13-beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(85818, NULL, 'G3DSA:3.40.1380.20:FF:000071', NULL, NULL, 'Diadenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(85819, NULL, 'G3DSA:1.25.40.10:FF:003750', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g31850, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(85820, NULL, 'G3DSA:3.30.750.24:FF:000113', NULL, NULL, 'K-3-type glutaminase', NULL, NULL, NULL, NULL, NULL, 4),
(85821, NULL, 'G3DSA:2.60.40.2030:FF:000050', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(85822, NULL, 'G3DSA:3.30.160.60:FF:004352', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85823, NULL, 'G3DSA:2.40.70.10:FF:000550', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85824, NULL, 'G3DSA:2.130.10.110:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85825, NULL, 'G3DSA:2.170.150.30:FF:000002', NULL, NULL, 'Interferon-induced with helicase C domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(85826, NULL, 'G3DSA:3.20.20.30:FF:000034', NULL, NULL, 'LLM class flavin-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(85827, NULL, 'G3DSA:2.40.10.10:FF:000490', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85828, NULL, 'G3DSA:2.60.120.10:FF:000785', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85829, NULL, 'G3DSA:2.60.40.1820:FF:000003', NULL, NULL, 'Desiccation protectant protein Lea14 isogeny', NULL, NULL, NULL, NULL, NULL, 4),
(85830, NULL, 'G3DSA:1.20.1280.290:FF:000086', NULL, NULL, 'L-cystine transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(85831, NULL, 'G3DSA:3.10.100.10:FF:000201', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85832, NULL, 'G3DSA:3.10.20.10:FF:000012', NULL, NULL, '60S ribosomal protein L18a', NULL, NULL, NULL, NULL, NULL, 4),
(85833, NULL, 'G3DSA:2.60.200.20:FF:000227', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(85834, NULL, 'G3DSA:3.50.50.60:FF:000162', NULL, NULL, 'Nitrite reductase [NAD(P)H], large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(85835, NULL, 'G3DSA:1.25.10.10:FF:003181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85836, NULL, 'G3DSA:1.10.8.10:FF:000228', NULL, NULL, 'DNA (cytosine-5)-methyltransferase DRM2', NULL, NULL, NULL, NULL, NULL, 4),
(85837, NULL, 'G3DSA:3.30.70.920:FF:000026', NULL, NULL, 'AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(85838, NULL, 'G3DSA:2.80.10.50:FF:000039', NULL, NULL, 'Secretory phospholipase A2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(85839, NULL, 'G3DSA:3.40.50.300:FF:007787', NULL, NULL, 'Putative uridine kinase C227.14', NULL, NULL, NULL, NULL, NULL, 4),
(85840, NULL, 'G3DSA:3.30.9.10:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85841, NULL, 'G3DSA:3.40.50.300:FF:007843', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(85842, NULL, 'G3DSA:1.50.10.10:FF:000132', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(85843, NULL, 'G3DSA:2.130.10.10:FF:003335', NULL, NULL, 'Pre-mRNA processing factor 4 (PRP4) like/WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(85844, NULL, 'G3DSA:1.10.601.10:FF:000002', NULL, NULL, 'RNA polymerase sigma factor RpoD', NULL, NULL, NULL, NULL, NULL, 4),
(85845, NULL, 'G3DSA:1.10.510.10:FF:000212', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(85846, NULL, 'G3DSA:1.10.3430.10:FF:000042', NULL, NULL, 'Ammonium transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(85847, NULL, 'G3DSA:3.80.10.10:FF:003178', NULL, NULL, 'Os03g0187500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(85848, NULL, 'G3DSA:4.10.1220.10:FF:000001', NULL, NULL, 'Prolow-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(85849, NULL, 'G3DSA:3.40.50.10190:FF:000123', NULL, NULL, 'DNA repair protein Rtt107', NULL, NULL, NULL, NULL, NULL, 4),
(85850, NULL, 'G3DSA:3.40.640.10:FF:000196', NULL, NULL, 'Aromatic amino acid aminotransferase I', NULL, NULL, NULL, NULL, NULL, 4),
(85851, NULL, 'G3DSA:1.10.10.2480:FF:000005', NULL, NULL, 'POSSIBLE RIBONUCLEASE E RNE', NULL, NULL, NULL, NULL, NULL, 4),
(85852, NULL, 'G3DSA:3.10.290.60:FF:000004', NULL, NULL, 'Ubiquitin-activating enzyme E1', NULL, NULL, NULL, NULL, NULL, 4),
(85853, NULL, 'G3DSA:1.20.58.60:FF:000775', NULL, NULL, 'Microtubule-actin crosslinking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(85854, NULL, 'G3DSA:3.20.20.80:FF:000476', NULL, NULL, 'Glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(85855, NULL, 'G3DSA:1.25.40.20:FF:000257', NULL, NULL, 'E3 ubiquitin-protein ligase MIB1', NULL, NULL, NULL, NULL, NULL, 4),
(85856, NULL, 'G3DSA:1.10.357.10:FF:000035', NULL, NULL, 'Transcriptional repressor PhlF', NULL, NULL, NULL, NULL, NULL, 4),
(85857, NULL, 'G3DSA:3.90.660.10:FF:000118', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85858, NULL, 'G3DSA:3.40.630.30:FF:000465', NULL, NULL, 'GCN5-related N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(85859, NULL, 'G3DSA:3.30.70.330:FF:001928', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85860, NULL, 'G3DSA:3.90.1290.10:FF:000004', NULL, NULL, 'microtubule-actin cross-linking factor 1 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(85861, NULL, 'G3DSA:1.10.287.3550:FF:000007', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85862, NULL, 'G3DSA:1.10.600.10:FF:000039', NULL, NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(85863, NULL, 'G3DSA:3.40.50.300:FF:006090', NULL, NULL, 'Bromodomain protein', NULL, NULL, NULL, NULL, NULL, 4),
(85864, NULL, 'G3DSA:3.30.30.30:FF:000006', NULL, NULL, 'Heat shock 70 kDa protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(85865, NULL, 'G3DSA:1.20.58.70:FF:000109', NULL, NULL, 'Qa-SNARE protein, Sed5/Syntaxin5-family', NULL, NULL, NULL, NULL, NULL, 4),
(85866, NULL, 'G3DSA:3.30.70.330:FF:002417', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85867, NULL, 'G3DSA:3.30.160.60:FF:001789', NULL, NULL, 'zinc finger protein 467', NULL, NULL, NULL, NULL, NULL, 4),
(85868, NULL, 'G3DSA:1.25.40.10:FF:003238', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g04840', NULL, NULL, NULL, NULL, NULL, 4),
(85869, NULL, 'G3DSA:3.40.390.10:FF:000215', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85870, NULL, 'G3DSA:3.30.40.10:FF:000973', NULL, NULL, 'G protein-coupled receptor', NULL, NULL, NULL, NULL, NULL, 4),
(85871, NULL, 'G3DSA:1.10.510.10:FF:004315', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85872, NULL, 'G3DSA:1.10.10.10:FF:001033', NULL, NULL, 'DNA-binding response OmpR family regulator', NULL, NULL, NULL, NULL, NULL, 4),
(85873, NULL, 'G3DSA:3.30.310.50:FF:000022', NULL, NULL, 'Phosphoglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(85874, NULL, 'G3DSA:2.170.210.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85875, NULL, 'G3DSA:1.20.1070.10:FF:001618', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85876, NULL, 'G3DSA:3.40.50.2000:FF:001096', NULL, NULL, '2-hydroxyacylsphingosine 1-beta-galactosyltransferase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(85877, NULL, 'G3DSA:3.30.420.10:FF:000030', NULL, NULL, 'IS3, transposase orfB', NULL, NULL, NULL, NULL, NULL, 4),
(85878, NULL, 'G3DSA:3.40.50.620:FF:000733', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85879, NULL, 'G3DSA:2.60.40.10:FF:000777', NULL, NULL, 'Neogenin 1', NULL, NULL, NULL, NULL, NULL, 4),
(85880, NULL, 'G3DSA:1.20.120.1750:FF:000090', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(85881, NULL, 'G3DSA:3.10.20.90:FF:000434', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(85882, NULL, 'G3DSA:2.115.10.20:FF:000001', NULL, NULL, 'Beta-fructofuranosidase, insoluble isoenzyme CWINV1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(85883, NULL, 'G3DSA:2.60.40.10:FF:001053', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(85884, NULL, 'G3DSA:3.40.50.1440:FF:000129', NULL, NULL, 'Cell division protein FtsZ homolog 1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(85885, NULL, 'G3DSA:3.40.50.1820:FF:001603', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85886, NULL, 'G3DSA:3.40.50.10700:FF:000001', NULL, NULL, 'D-aminoacyl-tRNA deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(85887, NULL, 'G3DSA:1.10.510.10:FF:003915', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85888, NULL, 'G3DSA:1.50.10.10:FF:000183', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(85889, NULL, 'G3DSA:1.10.340.30:FF:000042', NULL, NULL, 'Methyl-CpG-binding domain protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(85890, NULL, 'G3DSA:3.10.100.10:FF:000145', NULL, NULL, 'collectin-46-like', NULL, NULL, NULL, NULL, NULL, 4),
(85891, NULL, 'G3DSA:3.30.160.60:FF:000480', NULL, NULL, 'PR domain zinc finger protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(85892, NULL, 'G3DSA:3.90.70.10:FF:000904', NULL, NULL, 'Probable ubiquitin carboxyl-terminal hydrolase 7', NULL, NULL, NULL, NULL, NULL, 4),
(85893, NULL, 'G3DSA:1.25.10.10:FF:002961', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85894, NULL, 'G3DSA:3.30.2140.20:FF:000005', NULL, NULL, 'N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(85895, NULL, 'G3DSA:3.20.20.70:FF:000254', NULL, NULL, '2-dehydro-3-deoxyphosphooctonate aldolase 2', NULL, NULL, NULL, NULL, NULL, 4),
(85896, NULL, 'G3DSA:1.10.10.10:FF:001432', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(85897, NULL, 'G3DSA:3.40.50.150:FF:001418', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85898, NULL, 'G3DSA:1.20.200.10:FF:000006', NULL, NULL, 'Argininosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(85899, NULL, 'G3DSA:3.40.50.12500:FF:000007', NULL, NULL, 'Dcg1p', NULL, NULL, NULL, NULL, NULL, 4),
(85900, NULL, 'G3DSA:3.30.40.10:FF:000630', NULL, NULL, 'E3 ubiquitin-protein ligase RMA3', NULL, NULL, NULL, NULL, NULL, 4),
(85901, NULL, 'G3DSA:1.20.58.60:FF:000724', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85902, NULL, 'G3DSA:1.20.930.80:FF:000015', NULL, NULL, 'DNA primase large subunit-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(85903, NULL, 'G3DSA:1.25.10.10:FF:002068', NULL, NULL, 'Tuberin-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(85904, NULL, 'G3DSA:2.20.100.10:FF:000130', NULL, NULL, 'No long nerve cord, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(85905, NULL, 'G3DSA:3.40.30.10:FF:001152', NULL, NULL, 'Glutathione S-transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(85906, NULL, 'G3DSA:1.20.1080.10:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85907, NULL, 'G3DSA:3.90.640.10:FF:000286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85908, NULL, 'G3DSA:1.10.1670.40:FF:000012', NULL, NULL, 'HhH-GPD family protein', NULL, NULL, NULL, NULL, NULL, 4),
(85909, NULL, 'G3DSA:3.40.30.10:FF:000663', NULL, NULL, 'Glutathione peroxidase 4', NULL, NULL, NULL, NULL, NULL, 4),
(85910, NULL, 'G3DSA:1.10.510.10:FF:002685', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85911, NULL, 'G3DSA:3.30.450.200:FF:000014', NULL, NULL, 'DENN domain-containing protein 1A isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(85912, NULL, 'G3DSA:1.20.58.1290:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85913, NULL, 'G3DSA:3.40.50.1100:FF:000140', NULL, NULL, 'Bifunctional D-cysteine desulfhydrase/1-aminocyclopropane-1-carboxylate deaminase mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(85914, NULL, 'G3DSA:2.40.50.140:FF:000054', NULL, NULL, 'Nuclease-sensitive element-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(85915, NULL, 'G3DSA:2.20.70.10:FF:000213', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(85916, NULL, 'G3DSA:1.10.10.10:FF:001084', NULL, NULL, 'Transcriptional regulator, MarR family', NULL, NULL, NULL, NULL, NULL, 4),
(85917, NULL, 'G3DSA:2.170.130.10:FF:000012', NULL, NULL, 'TonB-dependent siderophore receptor', NULL, NULL, NULL, NULL, NULL, 4),
(85918, NULL, 'G3DSA:3.40.50.720:FF:001494', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(85919, NULL, 'G3DSA:3.80.10.10:FF:004538', NULL, NULL, 'F-box protein SKIP19', NULL, NULL, NULL, NULL, NULL, 4),
(85920, NULL, 'G3DSA:2.60.120.290:FF:000067', NULL, NULL, 'inactive serine protease PAMR1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(85921, NULL, 'G3DSA:1.10.10.10:FF:000072', NULL, NULL, 'Transcriptional regulatory protein RcsB', NULL, NULL, NULL, NULL, NULL, 4),
(85922, NULL, 'G3DSA:3.30.160.60:FF:002227', NULL, NULL, 'Zinc finger protein 302', NULL, NULL, NULL, NULL, NULL, 4),
(85923, NULL, 'G3DSA:2.120.10.30:FF:000492', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85924, NULL, 'G3DSA:3.80.10.10:FF:003526', NULL, NULL, 'Si:ch211-11p18.6', NULL, NULL, NULL, NULL, NULL, 4),
(85925, NULL, 'G3DSA:3.40.50.20:FF:000083', NULL, NULL, 'Ribosomal protein S6 modification protein (RimK)', NULL, NULL, NULL, NULL, NULL, 4),
(85926, NULL, 'G3DSA:3.30.465.10:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85927, NULL, 'G3DSA:3.40.630.10:FF:000307', NULL, NULL, 'Peptide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(85928, NULL, 'G3DSA:3.10.450.60:FF:000006', NULL, NULL, 'Arachidonate 12-lipoxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(85929, NULL, 'G3DSA:3.30.70.330:FF:001057', NULL, NULL, 'Polyadenylate-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(85930, NULL, 'G3DSA:1.25.40.20:FF:000605', NULL, NULL, 'cortactin-binding protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(85931, NULL, 'G3DSA:2.60.40.10:FF:005448', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85932, NULL, 'G3DSA:1.10.287.70:FF:000631', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85933, NULL, 'G3DSA:2.30.30.40:FF:000562', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85934, NULL, 'G3DSA:3.90.1450.10:FF:000006', NULL, NULL, 'Si:ch211-220m17.4', NULL, NULL, NULL, NULL, NULL, 4),
(85935, NULL, 'G3DSA:1.20.5.170:FF:000065', NULL, NULL, 'Keratin, type II cytoskeletal 80', NULL, NULL, NULL, NULL, NULL, 4),
(85936, NULL, 'G3DSA:4.10.800.10:FF:000015', NULL, NULL, 'Epithelial cell adhesion molecule', NULL, NULL, NULL, NULL, NULL, 4),
(85937, NULL, 'G3DSA:3.30.1370.10:FF:000042', NULL, NULL, 'Vigilin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(85938, NULL, 'G3DSA:1.10.10.790:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85939, NULL, 'G3DSA:1.10.555.10:FF:000181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85940, NULL, 'G3DSA:2.60.40.10:FF:003470', NULL, NULL, 'Putative tyrosine-protein kinase Wsck', NULL, NULL, NULL, NULL, NULL, 4),
(85941, NULL, 'G3DSA:2.30.30.190:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85942, NULL, 'G3DSA:1.10.10.10:FF:002101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85943, NULL, 'G3DSA:2.30.30.50:FF:000003', NULL, NULL, 'Ferredoxin-thioredoxin reductase, variable chain', NULL, NULL, NULL, NULL, NULL, 4),
(85944, NULL, 'G3DSA:3.30.200.20:FF:000432', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase EFR', NULL, NULL, NULL, NULL, NULL, 4),
(85945, NULL, 'G3DSA:2.10.110.10:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85946, NULL, 'G3DSA:3.30.60.30:FF:000126', NULL, NULL, 'AGAP005450-PA', NULL, NULL, NULL, NULL, NULL, 4),
(85947, NULL, 'G3DSA:2.30.180.10:FF:000037', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(85948, NULL, 'G3DSA:1.25.10.10:FF:001213', NULL, NULL, 'Serine/threonine-protein kinase D1044.8', NULL, NULL, NULL, NULL, NULL, 4),
(85949, NULL, 'G3DSA:3.30.710.10:FF:000018', NULL, NULL, 'S-phase kinase-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(85950, NULL, 'G3DSA:1.20.1530.20:FF:000073', NULL, NULL, 'K(+) efflux antiporter 3 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(85951, NULL, 'G3DSA:1.10.290.10:FF:000003', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(85952, NULL, 'G3DSA:3.30.200.20:FF:000376', NULL, NULL, 'Serine/threonine-protein kinase PBS1', NULL, NULL, NULL, NULL, NULL, 4),
(85953, NULL, 'G3DSA:2.60.220.50:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85954, NULL, 'G3DSA:2.60.40.1180:FF:000210', NULL, NULL, 'Alpha-amylase', NULL, NULL, NULL, NULL, NULL, 4),
(85955, NULL, 'G3DSA:3.40.50.12710:FF:000008', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7', NULL, NULL, NULL, NULL, NULL, 4),
(85956, NULL, 'G3DSA:1.25.10.10:FF:000595', NULL, NULL, 'HEAT repeat-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(85957, NULL, 'G3DSA:3.90.570.10:FF:000004', NULL, NULL, 'Amyloid protein', NULL, NULL, NULL, NULL, NULL, 4),
(85958, NULL, 'G3DSA:3.30.420.100:FF:000006', NULL, NULL, '50S ribosomal protein L18-like', NULL, NULL, NULL, NULL, NULL, 4),
(85959, NULL, 'G3DSA:4.10.60.10:FF:000225', NULL, NULL, 'Zinc finger CCHC-type containing 13', NULL, NULL, NULL, NULL, NULL, 4),
(85960, NULL, 'G3DSA:3.40.50.1400:FF:000016', NULL, NULL, 'Ferrochelatase Che1', NULL, NULL, NULL, NULL, NULL, 4),
(85961, NULL, 'G3DSA:4.10.800.20:FF:000006', NULL, NULL, 'AMP deaminase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(85962, NULL, 'G3DSA:3.90.25.10:FF:000036', NULL, NULL, 'ADP-L-glycero-D-manno-heptose-6-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(85963, NULL, 'G3DSA:1.25.40.80:FF:000016', NULL, NULL, 'Deoxyribodipyrimidine photolyase', NULL, NULL, NULL, NULL, NULL, 4),
(85964, NULL, 'G3DSA:3.30.720.50:FF:000008', NULL, NULL, 'TCDD-inducible poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(85965, NULL, 'G3DSA:3.40.50.300:FF:006483', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(85966, NULL, 'G3DSA:3.40.630.20:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85967, NULL, 'G3DSA:3.30.160.60:FF:005100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85968, NULL, 'G3DSA:3.30.40.10:FF:001642', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85969, NULL, 'G3DSA:3.30.70.960:FF:000015', NULL, NULL, 'Interphotoreceptor matrix proteoglycan 2', NULL, NULL, NULL, NULL, NULL, 4),
(85970, NULL, 'G3DSA:3.10.290.10:FF:000074', NULL, NULL, '30S ribosomal protein S4', NULL, NULL, NULL, NULL, NULL, 4),
(85971, NULL, 'G3DSA:1.20.140.20:FF:000004', NULL, NULL, 'pyruvate dehydrogenase kinase, isozyme 2', NULL, NULL, NULL, NULL, NULL, 4),
(85972, NULL, 'G3DSA:3.30.70.660:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85973, NULL, 'G3DSA:2.30.29.30:FF:000724', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85974, NULL, 'G3DSA:1.10.730.20:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85975, NULL, 'G3DSA:3.40.720.10:FF:000197', NULL, NULL, 'Alkaline phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(85976, NULL, 'G3DSA:1.20.120.620:FF:000002', NULL, NULL, 'Sensor histidine kinase KdpD', NULL, NULL, NULL, NULL, NULL, 4),
(85977, NULL, 'G3DSA:3.40.50.1820:FF:001098', NULL, NULL, 'Venom carboxylesterase-6-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(85978, NULL, 'G3DSA:2.60.260.20:FF:000096', NULL, NULL, 'Chaperone protein DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(85979, NULL, 'G3DSA:1.20.120.330:FF:000016', NULL, NULL, 'GIT ArfGAP 1', NULL, NULL, NULL, NULL, NULL, 4),
(85980, NULL, 'G3DSA:2.60.40.60:FF:000146', NULL, NULL, 'cadherin-23 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(85981, NULL, 'G3DSA:1.20.1250.20:FF:001433', NULL, NULL, 'Transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(85982, NULL, 'G3DSA:2.40.110.10:FF:000093', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(85983, NULL, 'G3DSA:2.30.140.10:FF:000023', NULL, NULL, 'Polyamine aminopropyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(85984, NULL, 'G3DSA:1.10.8.1220:FF:000009', NULL, NULL, 'Dynein heavy chain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(85985, NULL, 'G3DSA:3.40.30.10:FF:000371', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(85986, NULL, 'G3DSA:2.60.40.420:FF:000165', NULL, NULL, 'Coagulation factor VIII, procoagulant component', NULL, NULL, NULL, NULL, NULL, 4),
(85987, NULL, 'G3DSA:3.90.70.10:FF:000635', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(85988, NULL, 'G3DSA:1.10.287.80:FF:000016', NULL, NULL, 'ATP synthase gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(85989, NULL, 'G3DSA:3.40.50.300:FF:000811', NULL, NULL, 'probable ATP-dependent RNA helicase YTHDC2', NULL, NULL, NULL, NULL, NULL, 4),
(85990, NULL, 'G3DSA:1.10.510.10:FF:000717', NULL, NULL, 'Casein kinase I-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(85991, NULL, 'G3DSA:2.60.120.620:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85992, NULL, 'G3DSA:1.10.390.10:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85993, NULL, 'G3DSA:2.120.10.80:FF:000366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(85994, NULL, 'G3DSA:3.30.160.60:FF:000934', NULL, NULL, 'zinc finger protein 90 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(85995, NULL, 'G3DSA:3.30.420.40:FF:000022', NULL, NULL, 'Actin-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(85996, NULL, 'G3DSA:3.50.50.60:FF:001235', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(85997, NULL, 'G3DSA:1.20.58.90:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(85998, NULL, 'G3DSA:1.20.5.100:FF:000033', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(85999, NULL, 'G3DSA:1.25.40.70:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86000, NULL, 'G3DSA:2.80.10.50:FF:000146', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(86001, NULL, 'G3DSA:1.10.10.470:FF:000003', NULL, NULL, 'Maltooligosyltrehalose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(86002, NULL, 'G3DSA:2.40.30.10:FF:000373', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86003, NULL, 'G3DSA:3.30.420.110:FF:000048', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(86004, NULL, 'G3DSA:3.20.20.120:FF:000008', NULL, NULL, 'D-galactonate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(86005, NULL, 'G3DSA:3.20.20.100:FF:000020', NULL, NULL, 'L-glyceraldehyde 3-phosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(86006, NULL, 'G3DSA:3.30.160.60:FF:002278', NULL, NULL, 'Zinc finger protein 320', NULL, NULL, NULL, NULL, NULL, 4),
(86007, NULL, 'G3DSA:2.60.40.10:FF:005499', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86008, NULL, 'G3DSA:2.30.180.10:FF:000144', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86009, NULL, 'G3DSA:2.120.10.80:FF:000422', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86010, NULL, 'G3DSA:2.40.70.10:FF:000443', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86011, NULL, 'G3DSA:2.60.260.20:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86012, NULL, 'G3DSA:3.20.20.70:FF:000703', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86013, NULL, 'G3DSA:1.20.900.10:FF:000026', NULL, NULL, 'Alsin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(86014, NULL, 'G3DSA:1.20.120.180:FF:000005', NULL, NULL, 'Proteasome activator protein PA26', NULL, NULL, NULL, NULL, NULL, 4),
(86015, NULL, 'G3DSA:1.10.1040.10:FF:000107', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(86016, NULL, 'G3DSA:1.10.340.70:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86017, NULL, 'G3DSA:3.90.76.10:FF:000007', NULL, NULL, 'Dipeptide ABC transporter periplasmic dipeptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(86018, NULL, 'G3DSA:3.30.40.10:FF:002210', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(86019, NULL, 'G3DSA:2.130.10.10:FF:002610', NULL, NULL, 'Vacuolar protein sorting-associated protein 11 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(86020, NULL, 'G3DSA:2.60.120.780:FF:000006', NULL, NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(86021, NULL, 'G3DSA:3.40.50.300:FF:007051', NULL, NULL, 'Nucleolar protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(86022, NULL, 'G3DSA:3.50.80.10:FF:000002', NULL, NULL, 'D-aminoacyl-tRNA deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(86023, NULL, 'G3DSA:3.80.10.10:FF:003414', NULL, NULL, 'Os11g0108932 protein', NULL, NULL, NULL, NULL, NULL, 4),
(86024, NULL, 'G3DSA:3.30.70.3490:FF:000022', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(86025, NULL, 'G3DSA:3.30.930.10:FF:000288', NULL, NULL, 'Serine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(86026, NULL, 'G3DSA:1.20.58.60:FF:000488', NULL, NULL, 'Microtubule actin crosslinking factor 1a', NULL, NULL, NULL, NULL, NULL, 4),
(86027, NULL, 'G3DSA:3.50.30.30:FF:000168', NULL, NULL, 'Surface-associated serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(86028, NULL, 'G3DSA:3.20.20.140:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86029, NULL, 'G3DSA:2.60.40.420:FF:000221', NULL, NULL, 'Coagulation factor VIII, procoagulant component', NULL, NULL, NULL, NULL, NULL, 4),
(86030, NULL, 'G3DSA:1.10.20.10:FF:000365', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86031, NULL, 'G3DSA:2.60.40.60:FF:000202', NULL, NULL, 'cadherin-8 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(86032, NULL, 'G3DSA:1.25.40.60:FF:000010', NULL, NULL, 'CRE-UNC-18 protein', NULL, NULL, NULL, NULL, NULL, 4),
(86033, NULL, 'G3DSA:3.90.640.10:FF:000235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86034, NULL, 'G3DSA:1.10.10.10:FF:000920', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(86035, NULL, 'G3DSA:2.60.40.10:FF:003138', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86036, NULL, 'G3DSA:2.30.29.30:FF:001287', NULL, NULL, 'Dip13 beta, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86037, NULL, 'G3DSA:3.30.160.60:FF:003863', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86038, NULL, 'G3DSA:3.80.10.10:FF:003234', NULL, NULL, 'FBD / Leucine Rich Repeat domains containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(86039, NULL, 'G3DSA:1.10.510.10:FF:002050', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(86040, NULL, 'G3DSA:4.10.280.10:FF:000210', NULL, NULL, 'Protein CBG18500', NULL, NULL, NULL, NULL, NULL, 4),
(86041, NULL, 'G3DSA:1.10.1420.10:FF:000148', NULL, NULL, 'MutS domain III family protein', NULL, NULL, NULL, NULL, NULL, 4),
(86042, NULL, 'G3DSA:3.40.50.300:FF:004122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86043, NULL, 'G3DSA:1.25.40.20:FF:000313', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(86044, NULL, 'G3DSA:1.20.58.60:FF:000831', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86045, NULL, 'G3DSA:2.30.30.550:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86046, NULL, 'G3DSA:3.30.479.20:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86047, NULL, 'G3DSA:2.20.100.10:FF:000023', NULL, NULL, 'Thrombospondin type-1 domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(86048, NULL, 'G3DSA:2.60.40.10:FF:002806', NULL, NULL, 'Si:ch73-215d9.1', NULL, NULL, NULL, NULL, NULL, 4),
(86049, NULL, 'G3DSA:2.40.50.140:FF:000161', NULL, NULL, 'Ribonuclease R', NULL, NULL, NULL, NULL, NULL, 4),
(86050, NULL, 'G3DSA:3.40.50.720:FF:002562', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86051, NULL, 'G3DSA:3.10.20.90:FF:000726', NULL, NULL, 'Nuclear protein localization protein 4-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(86052, NULL, 'G3DSA:3.40.1160.10:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(86053, NULL, 'G3DSA:3.30.420.10:FF:000479', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86054, NULL, 'G3DSA:1.25.40.780:FF:000002', NULL, NULL, 'TIR-domain containing adaptor inducing IFN-beta', NULL, NULL, NULL, NULL, NULL, 4),
(86055, NULL, 'G3DSA:3.40.1550.20:FF:000011', NULL, NULL, 'Transcriptional regulator MraZ', NULL, NULL, NULL, NULL, NULL, 4),
(86056, NULL, 'G3DSA:3.90.70.200:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86057, NULL, 'G3DSA:1.25.40.20:FF:000369', NULL, NULL, 'Ankyrin repeat domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(86058, NULL, 'G3DSA:3.40.50.300:FF:003684', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(86059, NULL, 'G3DSA:2.60.200.30:FF:000033', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(86060, NULL, 'G3DSA:3.20.20.70:FF:000523', NULL, NULL, 'Alkaline alpha galactosidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(86061, NULL, 'G3DSA:2.60.40.10:FF:005268', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86062, NULL, 'G3DSA:3.30.160.60:FF:003683', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86063, NULL, 'G3DSA:2.60.120.320:FF:000003', NULL, NULL, 'Thiamine pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(86064, NULL, 'G3DSA:1.25.40.10:FF:003126', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(86065, NULL, 'G3DSA:2.60.120.260:FF:000412', NULL, NULL, 'Six-hairpin glycosidase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(86066, NULL, 'G3DSA:1.10.730.10:FF:000195', NULL, NULL, 'Leucyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(86067, NULL, 'G3DSA:3.65.10.10:FF:000015', NULL, NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(86068, NULL, 'G3DSA:2.60.40.1170:FF:000056', NULL, NULL, 'Putative adaptor complex AP-1 medium subunit', NULL, NULL, NULL, NULL, NULL, 4),
(86069, NULL, 'G3DSA:3.90.1150.70:FF:000001', NULL, NULL, 'UPF0425 pyridoxal phosphate-dependent protein MJ0158', NULL, NULL, NULL, NULL, NULL, 4),
(86070, NULL, 'G3DSA:3.30.930.10:FF:000344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86071, NULL, 'G3DSA:3.30.70.1230:FF:000081', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86072, NULL, 'G3DSA:1.25.10.10:FF:002517', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86073, NULL, 'G3DSA:2.20.70.10:FF:000045', NULL, NULL, 'E3 ubiquitin-protein ligase NEDD4-like', NULL, NULL, NULL, NULL, NULL, 4),
(86074, NULL, 'G3DSA:1.20.1610.10:FF:000014', NULL, NULL, 'Alpha-1,2-mannosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86075, NULL, 'G3DSA:1.25.40.990:FF:000003', NULL, NULL, 'germinal-center associated nuclear protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(86076, NULL, 'G3DSA:3.30.420.10:FF:000535', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86077, NULL, 'G3DSA:1.25.40.10:FF:002401', NULL, NULL, 'pentatricopeptide repeat-containing protein At5g04780, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(86078, NULL, 'G3DSA:3.40.50.300:FF:006207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86079, NULL, 'G3DSA:3.40.50.261:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86080, NULL, 'G3DSA:3.20.20.70:FF:000647', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86081, NULL, 'G3DSA:3.40.50.10900:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86082, NULL, 'G3DSA:1.10.238.10:FF:000112', NULL, NULL, 'EF-hand domain family, member D2', NULL, NULL, NULL, NULL, NULL, 4),
(86083, NULL, 'G3DSA:1.10.10.10:FF:001376', NULL, NULL, 'Regulatory protein RecX', NULL, NULL, NULL, NULL, NULL, 4),
(86084, NULL, 'G3DSA:3.30.40.10:FF:001411', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86085, NULL, 'G3DSA:1.10.730.10:FF:000083', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(86086, NULL, 'G3DSA:3.40.1810.10:FF:000012', NULL, NULL, 'MADS-box protein SOC1', NULL, NULL, NULL, NULL, NULL, 4),
(86087, NULL, 'G3DSA:3.30.40.10:FF:000006', NULL, NULL, 'CCR4-NOT transcription complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(86088, NULL, 'G3DSA:3.90.640.10:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86089, NULL, 'G3DSA:3.40.50.300:FF:008355', NULL, NULL, 'Os06g0561800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(86090, NULL, 'G3DSA:1.10.10.10:FF:000864', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(86091, NULL, 'G3DSA:3.90.1410.10:FF:000009', NULL, NULL, 'Histone-lysine N-methyltransferase setd3', NULL, NULL, NULL, NULL, NULL, 4),
(86092, NULL, 'G3DSA:3.10.100.10:FF:000033', NULL, NULL, 'Mannose receptor C type 2', NULL, NULL, NULL, NULL, NULL, 4),
(86093, NULL, 'G3DSA:1.10.287.70:FF:000182', NULL, NULL, 'Outward-rectifier potassium channel TOK1', NULL, NULL, NULL, NULL, NULL, 4),
(86094, NULL, 'G3DSA:3.30.160.60:FF:001497', NULL, NULL, 'Zinc finger protein 275', NULL, NULL, NULL, NULL, NULL, 4),
(86095, NULL, 'G3DSA:1.10.630.10:FF:000659', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86096, NULL, 'G3DSA:1.25.70.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86097, NULL, 'G3DSA:3.50.50.60:FF:001179', NULL, NULL, 'Cindoxin reductase', NULL, NULL, NULL, NULL, NULL, 4),
(86098, NULL, 'G3DSA:1.20.58.670:FF:000001', NULL, NULL, 'Exocyst complex component', NULL, NULL, NULL, NULL, NULL, 4),
(86099, NULL, 'G3DSA:2.60.120.330:FF:000063', NULL, NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(86100, NULL, 'G3DSA:2.60.40.10:FF:004195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86101, NULL, 'G3DSA:2.130.10.10:FF:002554', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86102, NULL, 'G3DSA:2.70.170.10:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86103, NULL, 'G3DSA:3.30.920.30:FF:000001', NULL, NULL, 'Probable mRNA interferase HicA', NULL, NULL, NULL, NULL, NULL, 4),
(86104, NULL, 'G3DSA:1.20.120.350:FF:000230', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86105, NULL, 'G3DSA:3.30.450.90:FF:000016', NULL, NULL, 'ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(86106, NULL, 'G3DSA:3.40.50.10190:FF:000016', NULL, NULL, 'protein ECT2 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(86107, NULL, 'G3DSA:1.10.357.20:FF:000021', NULL, NULL, 'Solute carrier family 41 member 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(86108, NULL, 'G3DSA:3.30.420.40:FF:000926', NULL, NULL, 'Actin-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(86109, NULL, 'G3DSA:3.90.550.10:FF:000751', NULL, NULL, 'Putative mannan synthase 7', NULL, NULL, NULL, NULL, NULL, 4),
(86110, NULL, 'G3DSA:1.25.40.10:FF:001041', NULL, NULL, 'Transmembrane and tetratricopeptide repeat containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(86111, NULL, 'G3DSA:1.25.40.530:FF:000012', NULL, NULL, 'Heavy chain, Unconventional Myosin', NULL, NULL, NULL, NULL, NULL, 4),
(86112, NULL, 'G3DSA:1.20.1250.20:FF:000652', NULL, NULL, 'Os02g0574500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(86113, NULL, 'G3DSA:3.40.50.300:FF:000699', NULL, NULL, 'ATPase family AAA domain-containing protein 2B', NULL, NULL, NULL, NULL, NULL, 4),
(86114, NULL, 'G3DSA:3.20.20.80:FF:000583', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86115, NULL, 'G3DSA:3.40.1190.20:FF:000152', NULL, NULL, 'PfkB family kinase', NULL, NULL, NULL, NULL, NULL, 4),
(86116, NULL, 'G3DSA:3.30.530.20:FF:000018', NULL, NULL, 'Activator of 90 kDa heat shock protein ATPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(86117, NULL, 'G3DSA:3.10.310.20:FF:000012', NULL, NULL, 'Putative acidocalcisomal exopolyphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(86118, NULL, 'G3DSA:1.10.30.10:FF:000011', NULL, NULL, 'Putative SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily E member 1', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(86119, NULL, 'G3DSA:2.60.40.10:FF:005555', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86120, NULL, 'G3DSA:3.10.490.20:FF:000019', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86121, NULL, 'G3DSA:2.40.50.140:FF:000958', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86122, NULL, 'G3DSA:2.60.40.10:FF:000485', NULL, NULL, 'Sidekick cell adhesion molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(86123, NULL, 'G3DSA:3.90.770.10:FF:000003', NULL, NULL, '3-hydroxy-3-methylglutaryl-coenzyme A reductase 2', NULL, NULL, NULL, NULL, NULL, 4),
(86124, NULL, 'G3DSA:3.40.50.150:FF:001126', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86125, NULL, 'G3DSA:1.10.510.10:FF:003466', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86126, NULL, 'G3DSA:3.40.930.10:FF:000004', NULL, NULL, 'Anion exchange protein', NULL, NULL, NULL, NULL, NULL, 4),
(86127, NULL, 'G3DSA:2.120.10.30:FF:000609', NULL, NULL, 'DPP6 N-terminal domain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(86128, NULL, 'G3DSA:2.60.120.340:FF:000009', NULL, NULL, 'Nucleolar RNA-binding protein, truncated', NULL, NULL, NULL, NULL, NULL, 4),
(86129, NULL, 'G3DSA:3.10.100.10:FF:000089', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(86130, NULL, 'G3DSA:1.20.1070.10:FF:001349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86131, NULL, 'G3DSA:3.30.450.70:FF:000010', NULL, NULL, 'TRAPP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(86132, NULL, 'G3DSA:3.50.50.60:FF:000779', NULL, NULL, 'Adenylylsulfate reductase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(86133, NULL, 'G3DSA:1.20.1280.50:FF:000016', NULL, NULL, 'E3 ubiquitin ligase complex SCF subunit sconB', NULL, NULL, NULL, NULL, NULL, 4),
(86134, NULL, 'G3DSA:3.30.70.330:FF:002709', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86135, NULL, 'G3DSA:2.160.20.10:FF:000327', NULL, NULL, 'Cell surface glycoprotein (S-layer protein)', NULL, NULL, NULL, NULL, NULL, 4),
(86136, NULL, 'G3DSA:1.20.5.880:FF:000002', NULL, NULL, 'Photosystem II reaction center protein H', NULL, NULL, NULL, NULL, NULL, 4),
(86137, NULL, 'G3DSA:3.40.50.150:FF:001525', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86138, NULL, 'G3DSA:1.10.10.10:FF:001937', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86139, NULL, 'G3DSA:3.40.50.2300:FF:000303', NULL, NULL, 'Glutamate receptor ionotropic, kainate', NULL, NULL, NULL, NULL, NULL, 4),
(86140, NULL, 'G3DSA:3.40.190.10:FF:000447', NULL, NULL, 'ATP phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(86141, NULL, 'G3DSA:1.10.287.370:FF:000047', NULL, NULL, 'URI (Unconventional prefoldin RPB5 Interactor) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(86142, NULL, 'G3DSA:1.10.10.1810:FF:000001', NULL, NULL, 'RNA-editing ligase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(86143, NULL, 'G3DSA:2.60.210.10:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86144, NULL, 'G3DSA:3.30.2350.10:FF:000046', NULL, NULL, 'tRNA pseudouridine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(86145, NULL, 'G3DSA:3.60.20.10:FF:000195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86146, NULL, 'G3DSA:1.10.287.110:FF:000109', NULL, NULL, 'J-type co-chaperone JAC1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(86147, NULL, 'G3DSA:3.90.1150.10:FF:000410', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86148, NULL, 'G3DSA:1.20.58.390:FF:000187', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(86149, NULL, 'G3DSA:1.20.1600.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86150, NULL, 'G3DSA:3.90.470.10:FF:000019', NULL, NULL, 'Ribosomal protein L22p/L17e', NULL, NULL, NULL, NULL, NULL, 4),
(86151, NULL, 'G3DSA:3.40.50.300:FF:000250', NULL, NULL, 'Obg-like ATPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(86152, NULL, 'G3DSA:3.40.190.10:FF:000503', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(86153, NULL, 'G3DSA:1.10.287.370:FF:000103', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86154, NULL, 'G3DSA:3.40.50.300:FF:000194', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(86155, NULL, 'G3DSA:2.40.30.270:FF:000021', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(86156, NULL, 'G3DSA:2.60.40.790:FF:000192', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86157, NULL, 'G3DSA:3.40.50.1820:FF:001278', NULL, NULL, 'Protein phosphatase methylesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(86158, NULL, 'G3DSA:3.90.70.10:FF:000455', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(86159, NULL, 'G3DSA:3.80.10.10:FF:001492', NULL, NULL, 'Phytosulfokine receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(86160, NULL, 'G3DSA:3.20.20.105:FF:000003', NULL, NULL, 'Queuine tRNA-ribosyltransferase accessory subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(86161, NULL, 'G3DSA:1.10.510.10:FF:003410', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86162, NULL, 'G3DSA:2.40.160.100:FF:000001', NULL, NULL, 'Alginate production protein AlgE', NULL, NULL, NULL, NULL, NULL, 4),
(86163, NULL, 'G3DSA:2.130.10.10:FF:000137', NULL, NULL, 'Regulatory-associated protein of mTOR isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(86164, NULL, 'G3DSA:2.40.170.20:FF:000094', NULL, NULL, 'Outer membrane receptor for ferric iron uptake', NULL, NULL, NULL, NULL, NULL, 4),
(86165, NULL, 'G3DSA:2.60.120.200:FF:000765', NULL, NULL, 'Calnexin', NULL, NULL, NULL, NULL, NULL, 4),
(86166, NULL, 'G3DSA:1.10.1450.10:FF:000138', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(86167, NULL, 'G3DSA:3.30.160.60:FF:005605', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86168, NULL, 'G3DSA:3.40.50.300:FF:005426', NULL, NULL, 'Si:ch1073-181h11.2', NULL, NULL, NULL, NULL, NULL, 4),
(86169, NULL, 'G3DSA:3.90.1150.10:FF:000354', NULL, NULL, '3-amino-5-hydroxybenzoic acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(86170, NULL, 'G3DSA:3.40.50.720:FF:000145', NULL, NULL, 'Retinol dehydrogenase 12', NULL, NULL, NULL, NULL, NULL, 4),
(86171, NULL, 'G3DSA:3.30.160.60:FF:002514', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86172, NULL, 'G3DSA:1.10.150.240:FF:000020', NULL, NULL, 'N-acetylmuramic acid 6-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(86173, NULL, 'G3DSA:1.10.560.10:FF:000159', NULL, NULL, 'T-complex protein 1 subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(86174, NULL, 'G3DSA:3.30.830.10:FF:000016', NULL, NULL, 'Cytochrome b-c1 complex subunit 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(86175, NULL, 'G3DSA:3.40.50.2300:FF:000247', NULL, NULL, 'Autoinducer 2 ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(86176, NULL, 'G3DSA:3.30.160.60:FF:000373', NULL, NULL, 'Putative transcriptional repressor ctcf', NULL, NULL, NULL, NULL, NULL, 4),
(86177, NULL, 'G3DSA:3.30.40.10:FF:001754', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(86178, NULL, 'G3DSA:3.30.2160.10:FF:000054', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86179, NULL, 'G3DSA:1.20.1560.10:FF:000745', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86180, NULL, 'G3DSA:3.30.70.330:FF:000512', NULL, NULL, 'Ribosomal RNA-processing 7 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(86181, NULL, 'G3DSA:2.60.40.10:FF:000884', NULL, NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein', NULL, NULL, NULL, NULL, NULL, 4),
(86182, NULL, 'G3DSA:1.25.40.10:FF:001889', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(86183, NULL, 'G3DSA:1.10.150.60:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86184, NULL, 'G3DSA:2.40.10.10:FF:000046', NULL, NULL, 'Complement factor b,-like', NULL, NULL, NULL, NULL, NULL, 4),
(86185, NULL, 'G3DSA:1.10.472.10:FF:000263', NULL, NULL, 'Transcription factor IIIB 70 kDa subunit BRF', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(86186, NULL, 'G3DSA:2.40.50.140:FF:000778', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86187, NULL, 'G3DSA:1.10.20.10:FF:000241', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86188, NULL, 'G3DSA:3.40.50.720:FF:001781', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(86189, NULL, 'G3DSA:1.20.1110.10:FF:000156', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86190, NULL, 'G3DSA:3.70.10.10:FF:000121', NULL, NULL, 'DNA damage checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(86191, NULL, 'G3DSA:2.130.10.10:FF:000536', NULL, NULL, 'WD repeat domain 62', NULL, NULL, NULL, NULL, NULL, 4),
(86192, NULL, 'G3DSA:2.60.40.10:FF:001901', NULL, NULL, 'Complement C5', NULL, NULL, NULL, NULL, NULL, 4),
(86193, NULL, 'G3DSA:3.30.70.330:FF:002985', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86194, NULL, 'G3DSA:2.40.10.10:FF:000102', NULL, NULL, 'Dipeptidyl-peptidase 7', NULL, NULL, NULL, NULL, NULL, 4),
(86195, NULL, 'G3DSA:3.40.50.300:FF:001211', NULL, NULL, 'Torsin family 3 member A', NULL, NULL, NULL, NULL, NULL, 4),
(86196, NULL, 'G3DSA:2.10.70.10:FF:000242', NULL, NULL, 'Complement factor B', NULL, NULL, NULL, NULL, NULL, 4),
(86197, NULL, 'G3DSA:1.25.40.10:FF:002165', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g21065', NULL, NULL, NULL, NULL, NULL, 4),
(86198, NULL, 'G3DSA:1.20.1110.10:FF:000212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86199, NULL, 'G3DSA:1.10.150.120:FF:000001', NULL, NULL, 'Aldehyde oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(86200, NULL, 'G3DSA:3.90.1100.10:FF:000019', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(86201, NULL, 'G3DSA:3.90.1150.220:FF:000006', NULL, NULL, 'DNA repair protein Nse1', NULL, NULL, NULL, NULL, NULL, 4),
(86202, NULL, 'G3DSA:3.30.700.10:FF:000012', NULL, NULL, 'General secretion family protein', NULL, NULL, NULL, NULL, NULL, 4),
(86203, NULL, 'G3DSA:3.90.1420.10:FF:000061', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86204, NULL, 'G3DSA:3.40.50.880:FF:000108', NULL, NULL, 'Putative glutamine amidotransferase-like protein C13C5.04', NULL, NULL, NULL, NULL, NULL, 4),
(86205, NULL, 'G3DSA:2.60.40.60:FF:000707', NULL, NULL, 'Hedgehog protein', NULL, NULL, NULL, NULL, NULL, 4),
(86206, NULL, 'G3DSA:3.30.160.60:FF:004644', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86207, NULL, 'G3DSA:3.40.50.300:FF:007556', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86208, NULL, 'G3DSA:3.60.40.10:FF:000207', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(86209, NULL, 'G3DSA:3.30.200.20:FF:001157', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86210, NULL, 'G3DSA:1.20.1250.20:FF:000995', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(86211, NULL, 'G3DSA:4.10.280.10:FF:000098', NULL, NULL, 'Sterol regulatory element-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(86212, NULL, 'G3DSA:3.10.110.10:FF:000258', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(86213, NULL, 'G3DSA:3.90.70.10:FF:000056', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(86214, NULL, 'G3DSA:1.25.40.10:FF:005094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86215, NULL, 'G3DSA:2.20.70.10:FF:000101', NULL, NULL, 'Pre-mRNA-processing factor 40', NULL, NULL, NULL, NULL, NULL, 4),
(86216, NULL, 'G3DSA:3.30.540.30:FF:000016', NULL, NULL, 'Dipeptidyl peptidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(86217, NULL, 'G3DSA:3.30.300.20:FF:000029', NULL, NULL, 'Ribosome-binding factor A', NULL, NULL, NULL, NULL, NULL, 4),
(86218, NULL, 'G3DSA:2.60.40.10:FF:001502', NULL, NULL, 'Matrix remodeling associated 5', NULL, NULL, NULL, NULL, NULL, 4),
(86219, NULL, 'G3DSA:2.60.40.10:FF:000209', NULL, NULL, 'Sidekick cell adhesion molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(86220, NULL, 'G3DSA:3.10.250.10:FF:000077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(86221, NULL, 'G3DSA:3.20.20.80:FF:000240', NULL, NULL, 'Chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(86222, NULL, 'G3DSA:3.90.245.10:FF:000002', NULL, NULL, 'Non-specific ribonucleoside hydrolase RihC', NULL, NULL, NULL, NULL, NULL, 4),
(86223, NULL, 'G3DSA:1.20.58.200:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86224, NULL, 'G3DSA:3.40.50.300:FF:000935', NULL, NULL, 'Mitochondrial Rho GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(86225, NULL, 'G3DSA:1.10.10.60:FF:000525', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(86226, NULL, 'G3DSA:3.30.160.810:FF:000007', NULL, NULL, '50S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(86227, NULL, 'G3DSA:1.10.287.70:FF:000743', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86228, NULL, 'G3DSA:3.40.50.720:FF:000089', NULL, NULL, 'UDP-glucose 6-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(86229, NULL, 'G3DSA:2.130.10.10:FF:003447', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(86230, NULL, 'G3DSA:3.40.50.300:FF:001716', NULL, NULL, 'Peroxisome biogenesis protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(86231, NULL, 'G3DSA:1.10.238.10:FF:000056', NULL, NULL, 'Myosin light chain 1 skeletal', NULL, NULL, NULL, NULL, NULL, 4),
(86232, NULL, 'G3DSA:2.10.25.10:FF:000278', NULL, NULL, 'Stabilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(86233, NULL, 'G3DSA:3.40.50.300:FF:004066', NULL, NULL, 'Benign gonial cell neoplasm protein', NULL, NULL, NULL, NULL, NULL, 4),
(86234, NULL, 'G3DSA:3.40.50.620:FF:000789', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86235, NULL, 'G3DSA:1.20.58.1880:FF:000031', NULL, NULL, 'Os01g0193900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(86236, NULL, 'G3DSA:1.10.8.60:FF:000378', NULL, NULL, 'Katanin p60 ATPase-containing subunit A-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(86237, NULL, 'G3DSA:3.90.730.10:FF:000006', NULL, NULL, 'Ribonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86238, NULL, 'G3DSA:3.90.420.10:FF:000016', NULL, NULL, 'Nitrate reductase [NADH]', NULL, NULL, NULL, NULL, NULL, 4),
(86239, NULL, 'G3DSA:2.60.120.290:FF:000011', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(86240, NULL, 'G3DSA:3.40.640.10:FF:000140', NULL, NULL, 'Acetylornithine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(86241, NULL, 'G3DSA:1.10.8.60:FF:000434', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86242, NULL, 'G3DSA:1.10.630.10:FF:000316', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86243, NULL, 'G3DSA:1.10.10.60:FF:000002', NULL, NULL, 'Myb family transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(86244, NULL, 'G3DSA:1.20.58.1040:FF:000015', NULL, NULL, '1,3-beta-glucanosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(86245, NULL, 'G3DSA:4.10.280.10:FF:000154', NULL, NULL, 'Protein CBR-HLH-12', NULL, NULL, NULL, NULL, NULL, 4),
(86246, NULL, 'G3DSA:3.40.1160.10:FF:000046', NULL, NULL, 'N-acetylglutamate kinase / N-acetylglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(86247, NULL, 'G3DSA:1.25.10.10:FF:001612', NULL, NULL, 'Junction plakoglobin 1b', NULL, NULL, NULL, NULL, NULL, 4),
(86248, NULL, 'G3DSA:2.60.40.10:FF:005212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86249, NULL, 'G3DSA:3.40.50.10810:FF:000034', NULL, NULL, 'Protein CHROMATIN REMODELING 8', NULL, NULL, NULL, NULL, NULL, 4),
(86250, NULL, 'G3DSA:3.40.390.10:FF:000103', NULL, NULL, 'Matrix metallopeptidase 21', NULL, NULL, NULL, NULL, NULL, 4),
(86251, NULL, 'G3DSA:3.10.450.10:FF:000076', NULL, NULL, 'Cystatin', NULL, NULL, NULL, NULL, NULL, 4),
(86252, NULL, 'G3DSA:3.40.50.2000:FF:000039', NULL, NULL, 'alpha,alpha-trehalose-phosphate synthase [UDP-forming] 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(86253, NULL, 'G3DSA:2.10.25.10:FF:001571', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86254, NULL, 'G3DSA:3.30.2170.10:FF:000004', NULL, NULL, 'Endonuclease V, putative', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(86255, NULL, 'G3DSA:1.20.1250.20:FF:001776', NULL, NULL, 'ADL185Wp', NULL, NULL, NULL, NULL, NULL, 4),
(86256, NULL, 'G3DSA:2.30.30.100:FF:000006', NULL, NULL, 'Protein LSM14 homolog A isoform b', NULL, NULL, NULL, NULL, NULL, 4),
(86257, NULL, 'G3DSA:1.10.8.530:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86258, NULL, 'G3DSA:2.170.150.20:FF:000016', NULL, NULL, 'Peptide-methionine (R)-S-oxide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(86259, NULL, 'G3DSA:3.30.2090.10:FF:000003', NULL, NULL, 'Multidrug resistance protein MdtB', NULL, NULL, NULL, NULL, NULL, 4),
(86260, NULL, 'G3DSA:2.60.40.10:FF:000541', NULL, NULL, 'striated muscle preferentially expressed protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(86261, NULL, 'G3DSA:3.30.1070.10:FF:000002', NULL, NULL, 'Cell division topological specificity factor-like, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(86262, NULL, 'G3DSA:3.30.70.240:FF:000018', NULL, NULL, 'GTP-binding translation elongation factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86263, NULL, 'G3DSA:3.30.565.10:FF:000175', NULL, NULL, 'PAS domain S-box-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(86264, NULL, 'G3DSA:1.10.8.60:FF:000254', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(86265, NULL, 'G3DSA:3.40.190.290:FF:000107', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(86266, NULL, 'G3DSA:3.30.450.40:FF:000193', NULL, NULL, 'GAF domain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(86267, NULL, 'G3DSA:3.30.980.10:FF:000004', NULL, NULL, 'Alanine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(86268, NULL, 'G3DSA:3.30.70.2020:FF:000003', NULL, NULL, 'Phosphoserine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(86269, NULL, 'G3DSA:3.10.400.20:FF:000019', NULL, NULL, 'Translation machinery-associated protein 20', NULL, NULL, NULL, NULL, NULL, 4),
(86270, NULL, 'G3DSA:3.40.50.970:FF:000023', NULL, NULL, 'Pyruvate dehydrogenase E1 component subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(86271, NULL, 'G3DSA:3.30.300.30:FF:000145', NULL, NULL, 'Acyl-CoA synthetase medium chain family member 2A', NULL, NULL, NULL, NULL, NULL, 4),
(86272, NULL, 'G3DSA:2.10.250.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86273, NULL, 'G3DSA:1.10.10.60:FF:000126', NULL, NULL, 'dorsal root ganglia homeobox protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(86274, NULL, 'G3DSA:2.40.50.770:FF:000006', NULL, NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(86275, NULL, 'G3DSA:1.10.287.130:FF:000267', NULL, NULL, 'Periplasmic substrate-binding histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(86276, NULL, 'G3DSA:1.25.40.10:FF:002906', NULL, NULL, 'Uncharacterized protein YbeQ', NULL, NULL, NULL, NULL, NULL, 4),
(86277, NULL, 'G3DSA:1.20.1730.10:FF:000068', NULL, NULL, 'Acetate permease ActP', NULL, NULL, NULL, NULL, NULL, 4),
(86278, NULL, 'G3DSA:2.40.160.110:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86279, NULL, 'G3DSA:2.40.420.20:FF:000017', NULL, NULL, 'Putative multidrug resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(86280, NULL, 'G3DSA:3.90.950.10:FF:000045', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86281, NULL, 'G3DSA:3.10.20.30:FF:000063', NULL, NULL, 'Succinate dehydrogenase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(86282, NULL, 'G3DSA:3.30.160.60:FF:005948', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86283, NULL, 'G3DSA:1.20.1560.10:FF:000240', NULL, NULL, 'ATP-binding cassette transporter', NULL, NULL, NULL, NULL, NULL, 4),
(86284, NULL, 'G3DSA:2.60.40.10:FF:004251', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86285, NULL, 'G3DSA:1.20.1300.10:FF:000024', NULL, NULL, 'GM26134', NULL, NULL, NULL, NULL, NULL, 4),
(86286, NULL, 'G3DSA:1.10.287.70:FF:000687', NULL, NULL, 'Voltage-dependent calcium channel alpha13 subunit', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(86287, NULL, 'G3DSA:3.30.200.20:FF:001337', NULL, NULL, 'Os11g0609500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(86288, NULL, 'G3DSA:2.70.170.10:FF:000230', NULL, NULL, 'Protein CBR-EXP-1', NULL, NULL, NULL, NULL, NULL, 4),
(86289, NULL, 'G3DSA:1.25.40.10:FF:002221', NULL, NULL, 'Alginate biosynthesis protein AlgK', NULL, NULL, NULL, NULL, NULL, 4),
(86290, NULL, 'G3DSA:1.10.630.10:FF:000715', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86291, NULL, 'G3DSA:1.25.40.10:FF:002345', NULL, NULL, 'Cyclophilin-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(86292, NULL, 'G3DSA:2.120.10.30:FF:000104', NULL, NULL, 'NHL repeat containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(86293, NULL, 'G3DSA:2.60.40.10:FF:004375', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86294, NULL, 'G3DSA:3.40.1110.10:FF:000043', NULL, NULL, 'Putative cadmium/zinc-transporting ATPase 3', NULL, NULL, NULL, NULL, NULL, 4),
(86295, NULL, 'G3DSA:3.40.50.2300:FF:001208', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86296, NULL, 'G3DSA:1.10.575.10:FF:000013', NULL, NULL, 'Class i nuclease-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(86297, NULL, 'G3DSA:2.70.50.40:FF:000005', NULL, NULL, 'Protein unc-119', NULL, NULL, NULL, NULL, NULL, 4),
(86298, NULL, 'G3DSA:3.80.10.10:FF:002453', NULL, NULL, 'AGAP012123-PA', NULL, NULL, NULL, NULL, NULL, 4),
(86299, NULL, 'G3DSA:3.40.50.2000:FF:000371', NULL, NULL, 'RfbG protein', NULL, NULL, NULL, NULL, NULL, 4),
(86300, NULL, 'G3DSA:1.25.40.10:FF:001945', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(86301, NULL, 'G3DSA:3.40.50.150:FF:000744', NULL, NULL, 'Poly A polymerase regulatory subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86302, NULL, 'G3DSA:1.10.238.10:FF:001017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86303, NULL, 'G3DSA:1.10.238.10:FF:000399', NULL, NULL, 'Reticulocalbin 2', NULL, NULL, NULL, NULL, NULL, 4),
(86304, NULL, 'G3DSA:1.10.150.670:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86305, NULL, 'G3DSA:3.30.160.60:FF:004588', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86306, NULL, 'G3DSA:2.60.40.10:FF:003975', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86307, NULL, 'G3DSA:2.10.25.10:FF:000839', NULL, NULL, 'Latent transforming growth factor beta binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(86308, NULL, 'G3DSA:3.40.50.300:FF:000755', NULL, NULL, 'Probable ATP-dependent DNA helicase CHR12', NULL, NULL, NULL, NULL, NULL, 4),
(86309, NULL, 'G3DSA:1.10.20.10:FF:000185', NULL, NULL, 'DNA-binding protein HMf-2', NULL, NULL, NULL, NULL, NULL, 4),
(86310, NULL, 'G3DSA:3.30.830.10:FF:000292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86311, NULL, 'G3DSA:2.130.10.10:FF:004408', NULL, NULL, 'DNA excision repair protein ckn1', NULL, NULL, NULL, NULL, NULL, 4),
(86312, NULL, 'G3DSA:1.20.120.350:FF:000174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86313, NULL, 'G3DSA:3.90.650.10:FF:000005', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(86314, NULL, 'G3DSA:3.40.50.1820:FF:001839', NULL, NULL, '1-alkyl-2-acetylglycerophosphocholine esterase', NULL, NULL, NULL, NULL, NULL, 4),
(86315, NULL, 'G3DSA:3.30.428.10:FF:000036', NULL, NULL, 'Histidine triad nucleotide-binding 4', NULL, NULL, NULL, NULL, NULL, 4),
(86316, NULL, 'G3DSA:2.70.130.10:FF:000053', NULL, NULL, 'Putative mannose-6-phosphate/insulin receptor type ii', NULL, NULL, NULL, NULL, NULL, 4),
(86317, NULL, 'G3DSA:3.90.70.10:FF:000399', NULL, NULL, 'ABC transporter HlyB/MsbA family', NULL, NULL, NULL, NULL, NULL, 4),
(86318, NULL, 'G3DSA:3.40.50.80:FF:000022', NULL, NULL, 'Siderophore-interacting family protein', NULL, NULL, NULL, NULL, NULL, 4),
(86319, NULL, 'G3DSA:3.90.1170.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86320, NULL, 'G3DSA:3.30.160.60:FF:000193', NULL, NULL, 'Zinc finger protein 300', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(86321, NULL, 'G3DSA:1.20.120.1230:FF:000001', NULL, NULL, 'Sucrose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(86322, NULL, 'G3DSA:2.10.70.10:FF:000186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86323, NULL, 'G3DSA:2.10.70.10:FF:000062', NULL, NULL, 'CUB and Sushi multiple domains 3', NULL, NULL, NULL, NULL, NULL, 4),
(86324, NULL, 'G3DSA:2.70.130.10:FF:000177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86325, NULL, 'G3DSA:3.40.50.720:FF:001106', NULL, NULL, 'Unplaced genomic scaffold supercont1.27, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(86326, NULL, 'G3DSA:3.30.160.60:FF:004987', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86327, NULL, 'G3DSA:3.90.550.10:FF:000172', NULL, NULL, 'Hpnb', NULL, NULL, NULL, NULL, NULL, 4),
(86328, NULL, 'G3DSA:3.40.50.300:FF:004465', NULL, NULL, 'DNA repair protein rad8', NULL, NULL, NULL, NULL, NULL, 4),
(86329, NULL, 'G3DSA:3.40.250.10:FF:000093', NULL, NULL, 'Dual specificity protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(86330, NULL, 'G3DSA:3.40.50.150:FF:000221', NULL, NULL, 'Methyltransferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(86331, NULL, 'G3DSA:2.60.120.620:FF:000099', NULL, NULL, 'Prolyl 4-hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(86332, NULL, 'G3DSA:3.70.10.10:FF:000065', NULL, NULL, 'DNA polymerase processivity factor', NULL, NULL, NULL, NULL, NULL, 4),
(86333, NULL, 'G3DSA:3.40.50.300:FF:007899', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86334, NULL, 'G3DSA:3.30.40.10:FF:001698', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86335, NULL, 'G3DSA:1.25.40.10:FF:005256', NULL, NULL, 'Protein kinase rad3', NULL, NULL, NULL, NULL, NULL, 4),
(86336, NULL, 'G3DSA:3.30.230.130:FF:000022', NULL, NULL, 'Anaphase-promoting complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(86337, NULL, 'G3DSA:1.10.8.60:FF:000586', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86338, NULL, 'G3DSA:3.50.50.60:FF:001364', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(86339, NULL, 'G3DSA:1.10.287.110:FF:000380', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86340, NULL, 'G3DSA:3.40.50.10190:FF:000207', NULL, NULL, 'DNA-directed DNA/RNA polymerase mu', NULL, NULL, NULL, NULL, NULL, 4),
(86341, NULL, 'G3DSA:1.10.20.10:FF:000180', NULL, NULL, 'Centromere protein W', NULL, NULL, NULL, NULL, NULL, 4),
(86342, NULL, 'G3DSA:3.30.40.10:FF:000349', NULL, NULL, 'BRCA1 associated RING domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(86343, NULL, 'G3DSA:3.40.640.10:FF:000336', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86344, NULL, 'G3DSA:3.30.160.60:FF:006432', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86345, NULL, 'G3DSA:2.30.36.70:FF:000005', NULL, NULL, 'Actin-like protein 6B', NULL, NULL, NULL, NULL, NULL, 4),
(86346, NULL, 'G3DSA:3.30.70.100:FF:000117', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86347, NULL, 'G3DSA:1.20.5.170:FF:000278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86348, NULL, 'G3DSA:3.90.1140.10:FF:000016', NULL, NULL, 'WGS project CABT00000000 data, contig 2.10', NULL, NULL, NULL, NULL, NULL, 4),
(86349, NULL, 'G3DSA:1.20.120.230:FF:000048', NULL, NULL, 'TaLiN', NULL, NULL, NULL, NULL, NULL, 4),
(86350, NULL, 'G3DSA:3.30.200.20:FF:001814', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(86351, NULL, 'G3DSA:1.20.1250.20:FF:001669', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86352, NULL, 'G3DSA:3.40.630.30:FF:000257', NULL, NULL, 'Putative N-acetyltransferase YhdJ', NULL, NULL, NULL, NULL, NULL, 4),
(86353, NULL, 'G3DSA:1.10.510.10:FF:003758', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86354, NULL, 'G3DSA:1.20.120.850:FF:000026', NULL, NULL, 'Helicase swr-1', NULL, NULL, NULL, NULL, NULL, 4),
(86355, NULL, 'G3DSA:1.20.1250.20:FF:000051', NULL, NULL, 'Proline/glycine betaine transporter', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(86356, NULL, 'G3DSA:2.60.40.10:FF:005364', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86357, NULL, 'G3DSA:1.10.486.10:FF:000076', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(86358, NULL, 'G3DSA:2.60.260.20:FF:000023', NULL, NULL, 'Molecular chaperone DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(86359, NULL, 'G3DSA:1.25.40.20:FF:001870', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86360, NULL, 'G3DSA:3.65.10.10:FF:000038', NULL, NULL, 'Pentafunctional AROM polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(86361, NULL, 'G3DSA:3.40.50.1820:FF:000890', NULL, NULL, 'Abhydrolase domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(86362, NULL, 'G3DSA:1.20.120.1080:FF:000074', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86363, NULL, 'G3DSA:3.10.20.90:FF:000226', NULL, NULL, 'Ubiquitin-like protein nedd8 homologue, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86364, NULL, 'G3DSA:2.30.29.30:FF:000331', NULL, NULL, 'sharpin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(86365, NULL, 'G3DSA:1.25.10.10:FF:000415', NULL, NULL, 'Importin 5', NULL, NULL, NULL, NULL, NULL, 4),
(86366, NULL, 'G3DSA:2.130.10.10:FF:000980', NULL, NULL, 'Nucleolar protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(86367, NULL, 'G3DSA:3.30.160.60:FF:004824', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86368, NULL, 'G3DSA:3.30.2350.20:FF:000066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86369, NULL, 'G3DSA:3.20.20.140:FF:000357', NULL, NULL, 'Dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(86370, NULL, 'G3DSA:3.50.50.60:FF:000858', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86371, NULL, 'G3DSA:3.60.20.10:FF:000032', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(86372, NULL, 'G3DSA:3.90.1640.10:FF:000009', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86373, NULL, 'G3DSA:3.60.40.10:FF:000078', NULL, NULL, 'Protein phosphatase 2C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86374, NULL, 'G3DSA:3.60.15.10:FF:000082', NULL, NULL, 'DNA repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86375, NULL, 'G3DSA:2.10.220.10:FF:000023', NULL, NULL, 'Furin, paired basic amino acid cleaving enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(86376, NULL, 'G3DSA:3.40.1160.10:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86377, NULL, 'G3DSA:3.30.160.60:FF:002250', NULL, NULL, 'zinc finger protein 596 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(86378, NULL, 'G3DSA:3.40.50.720:FF:001713', NULL, NULL, 'Sll0096 protein', NULL, NULL, NULL, NULL, NULL, 4),
(86379, NULL, 'G3DSA:2.130.10.10:FF:002262', NULL, NULL, 'General transcription factor 3C polypeptide 2', NULL, NULL, NULL, NULL, NULL, 4),
(86380, NULL, 'G3DSA:3.40.50.300:FF:007972', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(86381, NULL, 'G3DSA:3.40.50.300:FF:002649', NULL, NULL, 'ADP-ribosylation factor-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(86382, NULL, 'G3DSA:3.40.50.10190:FF:000196', NULL, NULL, 'Protein CBR-MUS-101', NULL, NULL, NULL, NULL, NULL, 4),
(86383, NULL, 'G3DSA:1.25.40.10:FF:001541', NULL, NULL, 'Pentatricopeptide repeat (PPR) superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(86384, NULL, 'G3DSA:1.10.287.160:FF:000006', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(86385, NULL, 'G3DSA:1.25.40.10:FF:003469', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g20770', NULL, NULL, NULL, NULL, NULL, 4),
(86386, NULL, 'G3DSA:1.10.1140.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86387, NULL, 'G3DSA:3.80.10.10:FF:002857', NULL, NULL, 'F-box/LRR-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86388, NULL, 'G3DSA:3.30.230.10:FF:000324', NULL, NULL, 'AAL093Cp', NULL, NULL, NULL, NULL, NULL, 4),
(86389, NULL, 'G3DSA:3.30.160.60:FF:005004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86390, NULL, 'G3DSA:3.30.200.20:FF:002433', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(86391, NULL, 'G3DSA:1.10.3060.10:FF:000002', NULL, NULL, 'Preprotein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(86392, NULL, 'G3DSA:3.40.33.10:FF:000113', NULL, NULL, 'Protein CBR-TAG-254', NULL, NULL, NULL, NULL, NULL, 4),
(86393, NULL, 'G3DSA:3.40.50.1010:FF:000225', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86394, NULL, 'G3DSA:2.40.70.10:FF:000151', NULL, NULL, 'Gag polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(86395, NULL, 'G3DSA:3.10.320.10:FF:000004', NULL, NULL, 'MHC class II H2-M beta 2 chain', NULL, NULL, NULL, NULL, NULL, 4),
(86396, NULL, 'G3DSA:2.60.40.10:FF:001665', NULL, NULL, 'Muscle M-line assembly protein unc-89-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(86397, NULL, 'G3DSA:1.10.287.370:FF:000070', NULL, NULL, 'Prefoldin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(86398, NULL, 'G3DSA:3.40.50.150:FF:000980', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86399, NULL, 'G3DSA:3.40.50.200:FF:000158', NULL, NULL, 'Peptidase subtilase family', NULL, NULL, NULL, NULL, NULL, 4),
(86400, NULL, 'G3DSA:2.10.109.10:FF:000079', NULL, NULL, 'Mitochondrial inner membrane protease subunit', NULL, NULL, NULL, NULL, NULL, 4),
(86401, NULL, 'G3DSA:2.10.25.10:FF:000087', NULL, NULL, 'Fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(86402, NULL, 'G3DSA:2.60.40.10:FF:002621', NULL, NULL, 'Microfibril associated protein 3 like', NULL, NULL, NULL, NULL, NULL, 4),
(86403, NULL, 'G3DSA:3.40.50.720:FF:002539', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86404, NULL, 'G3DSA:3.30.40.10:FF:001294', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86405, NULL, 'G3DSA:3.30.70.270:FF:000241', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86406, NULL, 'G3DSA:1.20.5.340:FF:000009', NULL, NULL, 'myosin-11 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(86407, NULL, 'G3DSA:1.20.920.10:FF:000218', NULL, NULL, 'Bromodomain protein', NULL, NULL, NULL, NULL, NULL, 4),
(86408, NULL, 'G3DSA:1.10.10.60:FF:001306', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86409, NULL, 'G3DSA:1.20.1270.60:FF:000159', NULL, NULL, 'Zgc:158689', NULL, NULL, NULL, NULL, NULL, 4),
(86410, NULL, 'G3DSA:3.30.420.10:FF:000507', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86411, NULL, 'G3DSA:4.10.280.10:FF:000159', NULL, NULL, 'Basic helix-loop-helix (BHLH) DNA-binding superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(86412, NULL, 'G3DSA:1.20.1560.10:FF:000824', NULL, NULL, 'p-glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(86413, NULL, 'G3DSA:1.25.40.20:FF:000881', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86414, NULL, 'G3DSA:3.80.10.10:FF:000087', NULL, NULL, 'F-box/LRR-repeat protein 16 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(86415, NULL, 'G3DSA:2.70.130.10:FF:000076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86416, NULL, 'G3DSA:2.60.120.10:FF:000173', NULL, NULL, 'Vicilin-like antimicrobial peptides 2-3', NULL, NULL, NULL, NULL, NULL, 4),
(86417, NULL, 'G3DSA:1.10.10.520:FF:000013', NULL, NULL, 'SUMO-activating enzyme subunit', NULL, NULL, NULL, NULL, NULL, 4),
(86418, NULL, 'G3DSA:3.40.630.10:FF:000408', NULL, NULL, 'Peptidase M20 domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(86419, NULL, 'G3DSA:1.10.510.10:FF:001960', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86420, NULL, 'G3DSA:1.20.1200.10:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86421, NULL, 'G3DSA:1.10.287.480:FF:000001', NULL, NULL, '33 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(86422, NULL, 'G3DSA:2.130.10.10:FF:001317', NULL, NULL, 'DDB1-and CUL4-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(86423, NULL, 'G3DSA:3.30.70.330:FF:001372', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86424, NULL, 'G3DSA:1.10.472.10:FF:000004', NULL, NULL, 'Cyclin T2', NULL, NULL, NULL, NULL, NULL, 4),
(86425, NULL, 'G3DSA:3.90.550.10:FF:000088', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(86426, NULL, 'G3DSA:1.20.58.390:FF:000304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86427, NULL, 'G3DSA:3.30.497.10:FF:000139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86428, NULL, 'G3DSA:3.10.580.10:FF:000080', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(86429, NULL, 'G3DSA:3.90.70.10:FF:000764', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86430, NULL, 'G3DSA:3.10.120.10:FF:000023', NULL, NULL, 'Probable conserved membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(86431, NULL, 'G3DSA:3.40.250.10:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86432, NULL, 'G3DSA:2.60.40.640:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86433, NULL, 'G3DSA:3.10.100.10:FF:000010', NULL, NULL, 'C-type lectin domain family 3 member A', NULL, NULL, NULL, NULL, NULL, 4),
(86434, NULL, 'G3DSA:1.25.40.10:FF:000552', NULL, NULL, 'UDP-N-acetylglucosaminyltransferase (AFU_orthologue AFUA_1G03380)', NULL, NULL, NULL, NULL, NULL, 4),
(86435, NULL, 'G3DSA:3.10.20.70:FF:000007', NULL, NULL, 'LOW QUALITY PROTEIN: lengsin', NULL, NULL, NULL, NULL, NULL, 4),
(86436, NULL, 'G3DSA:3.40.50.970:FF:000102', NULL, NULL, 'Protein PHYLLO, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(86437, NULL, 'G3DSA:3.30.160.60:FF:003559', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86438, NULL, 'G3DSA:3.30.1330.30:FF:000056', NULL, NULL, 'MRM1p Ribose methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(86439, NULL, 'G3DSA:3.40.50.10260:FF:000032', NULL, NULL, 'ADP-dependent (S)-NAD(P)H-hydrate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(86440, NULL, 'G3DSA:3.30.530.20:FF:000165', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(86441, NULL, 'G3DSA:3.90.550.50:FF:000004', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(86442, NULL, 'G3DSA:3.30.420.10:FF:000187', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(86443, NULL, 'G3DSA:3.30.1360.10:FF:000018', NULL, NULL, 'DNA-directed RNA polymerase I/III subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86444, NULL, 'G3DSA:2.60.120.10:FF:000217', NULL, NULL, 'DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(86445, NULL, 'G3DSA:3.40.50.1100:FF:000117', NULL, NULL, 'Threonine dehydratase lateral transfer candidate', NULL, NULL, NULL, NULL, NULL, 4),
(86446, NULL, 'G3DSA:3.40.50.300:FF:008591', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86447, NULL, 'G3DSA:3.40.50.920:FF:000020', NULL, NULL, 'Putative 2-oxoisovalerate dehydrogenase beta subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(86448, NULL, 'G3DSA:3.30.60.30:FF:000098', NULL, NULL, 'Serine protease HTRA4', NULL, NULL, NULL, NULL, NULL, 4),
(86449, NULL, 'G3DSA:1.10.287.130:FF:000110', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(86450, NULL, 'G3DSA:3.40.30.10:FF:000399', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(86451, NULL, 'G3DSA:2.10.90.10:FF:000029', NULL, NULL, 'glycoprotein hormone beta-5', NULL, NULL, NULL, NULL, NULL, 4),
(86452, NULL, 'G3DSA:2.60.40.10:FF:002019', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(86453, NULL, 'G3DSA:3.30.200.20:FF:002080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86454, NULL, 'G3DSA:3.40.50.1000:FF:000335', NULL, NULL, 'Copper-transporting P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(86455, NULL, 'G3DSA:3.40.630.10:FF:000038', NULL, NULL, 'Alkaline phosphatase isozyme conversion', NULL, NULL, NULL, NULL, NULL, 4),
(86456, NULL, 'G3DSA:3.40.50.300:FF:002296', NULL, NULL, 'GTPase Era, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86457, NULL, 'G3DSA:3.30.470.20:FF:000238', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(86458, NULL, 'G3DSA:2.130.10.130:FF:000032', NULL, NULL, 'Phosphatidylinositol-glycan-specific phospholipase D', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(86459, NULL, 'G3DSA:3.10.250.10:FF:000105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86460, NULL, 'G3DSA:2.30.29.30:FF:001320', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(86461, NULL, 'G3DSA:2.10.70.10:FF:000146', NULL, NULL, 'Furrowed, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(86462, NULL, 'G3DSA:1.20.58.70:FF:000008', NULL, NULL, 'Syntaxin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(86463, NULL, 'G3DSA:1.10.10.60:FF:000789', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86464, NULL, 'G3DSA:2.30.30.30:FF:000076', NULL, NULL, 'Transcription elongation factor SPT5', NULL, NULL, NULL, NULL, NULL, 4),
(86465, NULL, 'G3DSA:2.30.130.10:FF:000034', NULL, NULL, 'PUA domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(86466, NULL, 'G3DSA:1.20.1440.90:FF:000002', NULL, NULL, 'Phosphoenolpyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(86467, NULL, 'G3DSA:1.10.225.10:FF:000009', NULL, NULL, 'Acyloxyacyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(86468, NULL, 'G3DSA:1.20.1250.20:FF:000843', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86469, NULL, 'G3DSA:1.50.40.10:FF:000504', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86470, NULL, 'G3DSA:2.60.120.10:FF:000526', NULL, NULL, 'Calcium/calmodulin dependent protein kinase kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(86471, NULL, 'G3DSA:2.130.10.10:FF:000345', NULL, NULL, 'intraflagellar transport protein 172 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(86472, NULL, 'G3DSA:3.30.420.40:FF:000522', NULL, NULL, 'Heat shock protein 70, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86473, NULL, 'G3DSA:1.20.1050.10:FF:000050', NULL, NULL, 'Elongation factor 1-gamma, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86474, NULL, 'G3DSA:1.10.8.70:FF:000004', NULL, NULL, 'Glutamate--tRNA ligase 2', NULL, NULL, NULL, NULL, NULL, 4),
(86475, NULL, 'G3DSA:2.30.29.30:FF:001096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86476, NULL, 'G3DSA:1.10.510.10:FF:000369', NULL, NULL, 'Serine/threonine kinase 17a', NULL, NULL, NULL, NULL, NULL, 4),
(86477, NULL, 'G3DSA:3.30.160.60:FF:005813', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86478, NULL, 'G3DSA:1.20.5.320:FF:000003', NULL, NULL, 'Collagen, type XVII, alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(86479, NULL, 'G3DSA:2.60.40.10:FF:000676', NULL, NULL, 'motile sperm domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(86480, NULL, 'G3DSA:3.90.190.10:FF:000458', NULL, NULL, 'Protein tyrosine phosphatase non-receptor type 6', NULL, NULL, NULL, NULL, NULL, 4),
(86481, NULL, 'G3DSA:3.20.20.80:FF:000184', NULL, NULL, 'Beta-amylase', NULL, NULL, NULL, NULL, NULL, 4),
(86482, NULL, 'G3DSA:3.40.1280.30:FF:000027', NULL, NULL, 'Putative tRNA m1G methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(86483, NULL, 'G3DSA:3.40.50.12090:FF:000002', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(86484, NULL, 'G3DSA:3.30.450.30:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86485, NULL, 'G3DSA:1.20.58.1610:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86486, NULL, 'G3DSA:3.40.50.10860:FF:000015', NULL, NULL, 'Pentafunctional AROM polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(86487, NULL, 'G3DSA:3.30.60.20:FF:000106', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(86488, NULL, 'G3DSA:3.40.50.1010:FF:000181', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86489, NULL, 'G3DSA:2.160.10.10:FF:000057', NULL, NULL, 'Sugar 1-phosphate guanyl transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86490, NULL, 'G3DSA:2.40.30.10:FF:000249', NULL, NULL, 'Eukaryotic translation initiation factor 5B, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(86491, NULL, 'G3DSA:3.90.400.10:FF:000004', NULL, NULL, 'Oligo-1,6-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(86492, NULL, 'G3DSA:3.40.50.1240:FF:000165', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(86493, NULL, 'G3DSA:2.40.50.100:FF:000053', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(86494, NULL, 'G3DSA:3.90.190.20:FF:000006', NULL, NULL, 'UDP-N-acetylmuramoyl-L-alanyl-D-glutamate--2,6-diaminopimelate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(86495, NULL, 'G3DSA:1.10.287.70:FF:000367', NULL, NULL, 'Cyclic nucleotide-gated cation channel', NULL, NULL, NULL, NULL, NULL, 4),
(86496, NULL, 'G3DSA:2.40.50.140:FF:001234', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86497, NULL, 'G3DSA:3.80.10.10:FF:003021', NULL, NULL, 'LOC100145161 protein', NULL, NULL, NULL, NULL, NULL, 4),
(86498, NULL, 'G3DSA:1.10.274.100:FF:000030', NULL, NULL, 'RNA polymerase I largest subunit', NULL, NULL, NULL, NULL, NULL, 4),
(86499, NULL, 'G3DSA:3.40.50.970:FF:000091', NULL, NULL, 'Xylulose-5-phosphate/fructose-6-phosphate phosphoketolase', NULL, NULL, NULL, NULL, NULL, 4),
(86500, NULL, 'G3DSA:3.40.50.200:FF:000028', NULL, NULL, 'Microbial collagenase', NULL, NULL, NULL, NULL, NULL, 4),
(86501, NULL, 'G3DSA:3.30.9.10:FF:000024', NULL, NULL, 'Putative sarcosine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(86502, NULL, 'G3DSA:3.50.50.60:FF:001055', NULL, NULL, 'Guanosine nucleotide diphosphate dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(86503, NULL, 'G3DSA:3.30.70.1350:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86504, NULL, 'G3DSA:1.10.10.10:FF:001724', NULL, NULL, 'Probable metalloprotease ARX1', NULL, NULL, NULL, NULL, NULL, 4),
(86505, NULL, 'G3DSA:2.60.40.10:FF:004419', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86506, NULL, 'G3DSA:2.10.25.10:FF:001059', NULL, NULL, 'GD23952', NULL, NULL, NULL, NULL, NULL, 4),
(86507, NULL, 'G3DSA:1.20.5.110:FF:000058', NULL, NULL, 'VAM7p Vacuolar SNARE protein', NULL, NULL, NULL, NULL, NULL, 4),
(86508, NULL, 'G3DSA:2.120.10.30:FF:000172', NULL, NULL, 'Low-density lipoprotein RecePtor related', NULL, NULL, NULL, NULL, NULL, 4),
(86509, NULL, 'G3DSA:2.170.140.10:FF:000041', NULL, NULL, 'GD12214', NULL, NULL, NULL, NULL, NULL, 4),
(86510, NULL, 'G3DSA:2.130.10.10:FF:004240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86511, NULL, 'G3DSA:4.10.970.10:FF:000015', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86512, NULL, 'G3DSA:3.30.160.60:FF:003868', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86513, NULL, 'G3DSA:2.130.10.10:FF:005651', NULL, NULL, 'Myosin heavy chain kinase B', NULL, NULL, NULL, NULL, NULL, 4),
(86514, NULL, 'G3DSA:3.40.50.150:FF:000328', NULL, NULL, 'FkbM family methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(86515, NULL, 'G3DSA:3.30.830.10:FF:000061', NULL, NULL, 'Stromal-processing peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(86516, NULL, 'G3DSA:3.60.40.10:FF:000387', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86517, NULL, 'G3DSA:3.40.1110.10:FF:000363', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(86518, NULL, 'G3DSA:3.90.105.20:FF:000017', NULL, NULL, 'Ribosome assembly factor mrt4', NULL, NULL, NULL, NULL, NULL, 4),
(86519, NULL, 'G3DSA:3.30.160.60:FF:000772', NULL, NULL, 'tripartite motif-containing protein 59', NULL, NULL, NULL, NULL, NULL, 4),
(86520, NULL, 'G3DSA:3.20.20.70:FF:000708', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86521, NULL, 'G3DSA:1.20.1420.10:FF:000022', NULL, NULL, 'TaLiN', NULL, NULL, NULL, NULL, NULL, 4),
(86522, NULL, 'G3DSA:3.30.450.20:FF:000664', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86523, NULL, 'G3DSA:3.30.750.44:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86524, NULL, 'G3DSA:2.40.50.120:FF:000059', NULL, NULL, 'Protein CBR-AGR-1', NULL, NULL, NULL, NULL, NULL, 4),
(86525, NULL, 'G3DSA:3.30.70.20:FF:000034', NULL, NULL, 'Ferredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(86526, NULL, 'G3DSA:3.30.70.330:FF:000220', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein D-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(86527, NULL, 'G3DSA:3.30.200.20:FF:000033', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(86528, NULL, 'G3DSA:2.90.10.10:FF:000061', NULL, NULL, 'Comitin', NULL, NULL, NULL, NULL, NULL, 4),
(86529, NULL, 'G3DSA:2.10.25.10:FF:000879', NULL, NULL, 'Disintegrin and metalloproteinase domain-containing protein unc-71', NULL, NULL, NULL, NULL, NULL, 4),
(86530, NULL, 'G3DSA:3.60.21.10:FF:000495', NULL, NULL, 'Trifunctional nucleotide phosphoesterase protein YfkN', NULL, NULL, NULL, NULL, NULL, 4),
(86531, NULL, 'G3DSA:3.30.572.10:FF:000005', NULL, NULL, 'Thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(86532, NULL, 'G3DSA:3.90.1150.10:FF:000270', NULL, NULL, 'Pyridoxal phosphate-dependent aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(86533, NULL, 'G3DSA:1.25.10.10:FF:003158', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86534, NULL, 'G3DSA:3.40.710.10:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86535, NULL, 'G3DSA:1.20.91.20:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86536, NULL, 'G3DSA:3.90.226.10:FF:000262', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(86537, NULL, 'G3DSA:3.30.160.60:FF:001098', NULL, NULL, 'Ras responsive element binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(86538, NULL, 'G3DSA:1.20.1070.10:FF:000949', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86539, NULL, 'G3DSA:1.10.1040.10:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86540, NULL, 'G3DSA:1.25.40.20:FF:000925', NULL, NULL, 'ankyrin repeat and zinc finger domain-containing protein 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(86541, NULL, 'G3DSA:3.30.420.270:FF:000034', NULL, NULL, 'Tol-Pal system protein TolR', NULL, NULL, NULL, NULL, NULL, 4),
(86542, NULL, 'G3DSA:2.30.40.10:FF:000155', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(86543, NULL, 'G3DSA:2.30.39.10:FF:000090', NULL, NULL, 'Serpin peptidase inhibitor, clade G (C1 inhibitor), member 1', NULL, NULL, NULL, NULL, NULL, 4),
(86544, NULL, 'G3DSA:1.25.40.10:FF:003339', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(86545, NULL, 'G3DSA:3.30.470.30:FF:000084', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(86546, NULL, 'G3DSA:1.10.287.70:FF:000030', NULL, NULL, 'Cyclic nucleotide-gated channel alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(86547, NULL, 'G3DSA:1.20.1740.10:FF:000259', NULL, NULL, 'SD09342p', NULL, NULL, NULL, NULL, NULL, 4),
(86548, NULL, 'G3DSA:1.25.40.10:FF:000243', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(86549, NULL, 'G3DSA:3.40.50.410:FF:000092', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(86550, NULL, 'G3DSA:1.20.1560.10:FF:000032', NULL, NULL, 'ATP-binding cassette sub-family C member 6', NULL, NULL, NULL, NULL, NULL, 4),
(86551, NULL, 'G3DSA:2.60.40.10:FF:001974', NULL, NULL, 'Piezo-type mechanosensitive ion channel component 2', NULL, NULL, NULL, NULL, NULL, 4),
(86552, NULL, 'G3DSA:1.10.275.10:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86553, NULL, 'G3DSA:3.30.40.10:FF:001277', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(86554, NULL, 'G3DSA:2.60.34.10:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86555, NULL, 'G3DSA:1.20.120.350:FF:000101', NULL, NULL, 'Voltage-gated Ion Channel (VIC) Superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(86556, NULL, 'G3DSA:2.60.40.10:FF:004728', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86557, NULL, 'G3DSA:2.60.120.290:FF:000163', NULL, NULL, 'Multiple epidermal growth factor-like domains protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(86558, NULL, 'G3DSA:3.40.50.300:FF:004566', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(86559, NULL, 'G3DSA:1.10.1300.10:FF:000010', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(86560, NULL, 'G3DSA:3.30.160.60:FF:005021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(86561, NULL, 'G3DSA:1.10.150.50:FF:000139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86562, NULL, 'G3DSA:1.20.120.1900:FF:000045', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(86563, NULL, 'G3DSA:3.40.1170.10:FF:000029', NULL, NULL, 'DNA mismatch repair protein MSH3', NULL, NULL, NULL, NULL, NULL, 4),
(86564, NULL, 'G3DSA:3.10.110.10:FF:000067', NULL, NULL, 'ubiquitin-conjugating enzyme E2 U isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(86565, NULL, 'G3DSA:3.40.50.10240:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86566, NULL, 'G3DSA:1.10.20.10:FF:000050', NULL, NULL, 'centromere protein T isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(86567, NULL, 'G3DSA:1.10.506.10:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86568, NULL, 'G3DSA:2.130.10.10:FF:002323', NULL, NULL, 'U3 small nucleolar RNA-associated protein 15-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(86569, NULL, 'G3DSA:1.10.245.10:FF:000011', NULL, NULL, 'SWI/SNF complex component SNF12 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(86570, NULL, 'G3DSA:3.40.525.10:FF:000041', NULL, NULL, 'CRAL/TRIO, N-terminus family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(86571, NULL, 'G3DSA:1.10.238.10:FF:000871', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86572, NULL, 'G3DSA:3.40.605.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86573, NULL, 'G3DSA:1.20.1070.10:FF:000966', NULL, NULL, '5-HT4 receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86574, NULL, 'G3DSA:1.20.1070.10:FF:001585', NULL, NULL, 'Endothelin receptor A', NULL, NULL, NULL, NULL, NULL, 4),
(86575, NULL, 'G3DSA:1.10.10.60:FF:000334', NULL, NULL, 'Paired mesoderm homeobox protein 2B', NULL, NULL, NULL, NULL, NULL, 4),
(86576, NULL, 'G3DSA:3.30.1450.10:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86577, NULL, 'G3DSA:1.10.30.10:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86578, NULL, 'G3DSA:2.60.40.10:FF:000221', NULL, NULL, 'neural cell adhesion molecule 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(86579, NULL, 'G3DSA:3.30.160.60:FF:006302', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86580, NULL, 'G3DSA:3.30.160.60:FF:004515', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86581, NULL, 'G3DSA:3.30.200.20:FF:001944', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86582, NULL, 'G3DSA:1.10.1040.10:FF:000074', NULL, NULL, 'Altronate oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(86583, NULL, 'G3DSA:1.20.1270.60:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86584, NULL, 'G3DSA:2.60.120.200:FF:000400', NULL, NULL, 'Laminin, alpha 5', NULL, NULL, NULL, NULL, NULL, 4),
(86585, NULL, 'G3DSA:2.60.120.650:FF:000203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86586, NULL, 'G3DSA:3.40.47.10:FF:000055', NULL, NULL, '3-oxoacyl-ACP synthase III', NULL, NULL, NULL, NULL, NULL, 4),
(86587, NULL, 'G3DSA:1.25.10.10:FF:002332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86588, NULL, 'G3DSA:3.40.50.300:FF:008017', NULL, NULL, 'Autophagy-related protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(86589, NULL, 'G3DSA:4.10.400.10:FF:000187', NULL, NULL, 'Tequila, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(86590, NULL, 'G3DSA:1.20.58.60:FF:000331', NULL, NULL, 'VAB-10B protein', NULL, NULL, NULL, NULL, NULL, 4),
(86591, NULL, 'G3DSA:2.60.120.430:FF:000031', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86592, NULL, 'G3DSA:2.130.10.10:FF:002806', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86593, NULL, 'G3DSA:3.80.10.10:FF:002874', NULL, NULL, 'Leucine-rich receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(86594, NULL, 'G3DSA:3.40.50.150:FF:001817', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(86595, NULL, 'G3DSA:2.20.25.530:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86596, NULL, 'G3DSA:1.10.287.110:FF:000363', NULL, NULL, 'Chaperone protein dnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(86597, NULL, 'G3DSA:3.20.20.80:FF:000728', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86598, NULL, 'G3DSA:3.30.810.10:FF:000009', NULL, NULL, 'Phosphatidylinositol 4-phosphate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(86599, NULL, 'G3DSA:3.20.70.20:FF:000028', NULL, NULL, 'Vitamin B12-dependent ribonucleotide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(86600, NULL, 'G3DSA:2.60.40.10:FF:002593', NULL, NULL, 'Muscle M-line assembly protein unc-89-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(86601, NULL, 'G3DSA:3.60.20.40:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86602, NULL, 'G3DSA:3.80.10.10:FF:000879', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(86603, NULL, 'G3DSA:1.25.40.20:FF:001398', NULL, NULL, 'Ankyrin repeat and SOCS box containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(86604, NULL, 'G3DSA:3.30.300.160:FF:000019', NULL, NULL, 'Type II secretion system ATPase PulE', NULL, NULL, NULL, NULL, NULL, 4),
(86605, NULL, 'G3DSA:1.10.8.60:FF:000569', NULL, NULL, 'Acetoin catabolism regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(86606, NULL, 'G3DSA:2.10.110.10:FF:000296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86607, NULL, 'G3DSA:1.20.1250.10:FF:000031', NULL, NULL, 'Oncostatin M', NULL, NULL, NULL, NULL, NULL, 4),
(86608, NULL, 'G3DSA:3.30.70.330:FF:002018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86609, NULL, 'G3DSA:3.20.20.70:FF:000490', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86610, NULL, 'G3DSA:3.90.870.10:FF:000016', NULL, NULL, 'Sua5/YciO/YrdC/YwlC family protein', NULL, NULL, NULL, NULL, NULL, 4),
(86611, NULL, 'G3DSA:2.60.40.10:FF:005717', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86612, NULL, 'G3DSA:2.10.90.10:FF:000046', NULL, NULL, 'Interleukin 17C', NULL, NULL, NULL, NULL, NULL, 4),
(86613, NULL, 'G3DSA:1.25.10.10:FF:001893', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(86614, NULL, 'G3DSA:3.40.710.10:FF:000089', NULL, NULL, 'Peptidoglycan D,D-transpeptidase MrdA', NULL, NULL, NULL, NULL, NULL, 4),
(86615, NULL, 'G3DSA:2.30.130.40:FF:000032', NULL, NULL, 'protein cereblon isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(86616, NULL, 'G3DSA:3.60.15.10:FF:000110', NULL, NULL, 'cAMP-specific phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(86617, NULL, 'G3DSA:3.90.180.10:FF:000031', NULL, NULL, '(R,R)-butanediol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(86618, NULL, 'G3DSA:3.40.50.720:FF:000302', NULL, NULL, 'Alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(86619, NULL, 'G3DSA:3.10.196.10:FF:000001', NULL, NULL, 'Methionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(86620, NULL, 'G3DSA:3.40.1640.10:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86621, NULL, 'G3DSA:3.40.50.261:FF:000019', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(86622, NULL, 'G3DSA:3.40.50.11210:FF:000002', NULL, NULL, 'Signal-induced proliferation-associated 1-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(86623, NULL, 'G3DSA:1.25.40.10:FF:000113', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(86624, NULL, 'G3DSA:3.30.40.10:FF:001810', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86625, NULL, 'G3DSA:2.130.10.10:FF:004370', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86626, NULL, 'G3DSA:3.90.740.10:FF:000012', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(86627, NULL, 'G3DSA:3.30.70.330:FF:001681', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86628, NULL, 'G3DSA:3.30.70.1620:FF:000017', NULL, NULL, 'Structural maintenance of chromosomes protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(86629, NULL, 'G3DSA:3.90.550.10:FF:000312', NULL, NULL, 'hyaluronan synthase 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(86630, NULL, 'G3DSA:1.20.930.40:FF:000031', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86631, NULL, 'G3DSA:3.40.470.10:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86632, NULL, 'G3DSA:1.25.40.20:FF:001853', NULL, NULL, 'BTB/POZ domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(86633, NULL, 'G3DSA:3.30.160.60:FF:003998', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86634, NULL, 'G3DSA:3.20.20.450:FF:000023', NULL, NULL, 'Sensory box/GGDEF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(86635, NULL, 'G3DSA:3.10.600.10:FF:000003', NULL, NULL, 'Pyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(86636, NULL, 'G3DSA:3.90.226.10:FF:000306', NULL, NULL, 'Enoyl-CoA delta isomerase 2 peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(86637, NULL, 'G3DSA:3.90.1420.10:FF:000015', NULL, NULL, 'Cytoplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(86638, NULL, 'G3DSA:3.40.50.10810:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86639, NULL, 'G3DSA:3.30.70.330:FF:000883', NULL, NULL, 'Polypyrimidine tract-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(86640, NULL, 'G3DSA:3.30.565.10:FF:000332', NULL, NULL, 'Two-component sensor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(86641, NULL, 'G3DSA:2.40.100.10:FF:000041', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(86642, NULL, 'G3DSA:2.60.40.150:FF:000820', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86643, NULL, 'G3DSA:1.25.40.10:FF:003778', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86644, NULL, 'G3DSA:1.25.40.990:FF:000043', NULL, NULL, 'SAC3/GANP family protein', NULL, NULL, NULL, NULL, NULL, 4),
(86645, NULL, 'G3DSA:3.30.160.60:FF:004487', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86646, NULL, 'G3DSA:3.50.50.60:FF:000066', NULL, NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(86647, NULL, 'G3DSA:3.30.160.60:FF:000333', NULL, NULL, 'Zinc finger and BTB domain-containing protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(86648, NULL, 'G3DSA:3.80.10.10:FF:000396', NULL, NULL, 'Leucine-rich repeat-containing protein 45', NULL, NULL, NULL, NULL, NULL, 4),
(86649, NULL, 'G3DSA:3.30.160.60:FF:001761', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86650, NULL, 'G3DSA:2.60.40.10:FF:000693', NULL, NULL, 'IgG receptor FcRn large subunit p51', NULL, NULL, NULL, NULL, NULL, 4),
(86651, NULL, 'G3DSA:4.10.830.10:FF:000005', NULL, NULL, 'Ribosomal protein S29A', NULL, NULL, NULL, NULL, NULL, 4),
(86652, NULL, 'G3DSA:1.20.1000.10:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86653, NULL, 'G3DSA:2.60.120.200:FF:000737', NULL, NULL, 'Uncharacterized protein AN7484', NULL, NULL, NULL, NULL, NULL, 4),
(86654, NULL, 'G3DSA:3.50.50.60:FF:001494', NULL, NULL, 'Amino acid oxidase fmpA', NULL, NULL, NULL, NULL, NULL, 4),
(86655, NULL, 'G3DSA:1.10.3520.10:FF:000021', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86656, NULL, 'G3DSA:3.40.50.12160:FF:000034', NULL, NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(86657, NULL, 'G3DSA:3.30.420.40:FF:000185', NULL, NULL, 'Actin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(86658, NULL, 'G3DSA:6.10.140.2220:FF:000018', NULL, NULL, 'Histone-lysine N-methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86659, NULL, 'G3DSA:3.40.50.1580:FF:000020', NULL, NULL, 'S-methyl-5''-thioadenosine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(86660, NULL, 'G3DSA:3.40.50.12780:FF:000012', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(86661, NULL, 'G3DSA:3.30.160.60:FF:002587', NULL, NULL, 'Ras responsive element binding protein 1', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(86662, NULL, 'G3DSA:3.40.50.2020:FF:000062', NULL, NULL, 'Ribose-phosphate pyrophosphokinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86663, NULL, 'G3DSA:4.10.410.10:FF:000013', NULL, NULL, 'Tissue factor pathway inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(86664, NULL, 'G3DSA:1.10.10.10:FF:001741', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(86665, NULL, 'G3DSA:2.40.50.100:FF:000070', NULL, NULL, 'Mitochondrial ribosomal protein L27,putative', NULL, NULL, NULL, NULL, NULL, 4),
(86666, NULL, 'G3DSA:3.30.200.20:FF:000516', NULL, NULL, 'Protein kinase PK4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86667, NULL, 'G3DSA:2.40.50.140:FF:001251', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86668, NULL, 'G3DSA:1.25.40.10:FF:002030', NULL, NULL, 'Pentatricopeptide repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(86669, NULL, 'G3DSA:1.25.40.20:FF:001061', NULL, NULL, 'Double zinc ribbon and ankyrin repeat domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(86670, NULL, 'G3DSA:1.25.40.10:FF:001524', NULL, NULL, 'AGAP008509-PA', NULL, NULL, NULL, NULL, NULL, 4),
(86671, NULL, 'G3DSA:3.30.70.1560:FF:000005', NULL, NULL, 'RNA pseudouridylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(86672, NULL, 'G3DSA:3.30.230.10:FF:000015', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(86673, NULL, 'G3DSA:1.10.460.10:FF:000016', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(86674, NULL, 'G3DSA:2.120.10.30:FF:000525', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86675, NULL, 'G3DSA:2.40.70.10:FF:000134', NULL, NULL, 'YALI0D22957p', NULL, NULL, NULL, NULL, NULL, 4),
(86676, NULL, 'G3DSA:3.30.1300.10:FF:000009', NULL, NULL, 'Pantothenate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(86677, NULL, 'G3DSA:3.40.50.300:FF:007663', NULL, NULL, 'GPN-loop GTPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(86678, NULL, 'G3DSA:2.60.40.420:FF:000114', NULL, NULL, 'GD15660', NULL, NULL, NULL, NULL, NULL, 4),
(86679, NULL, 'G3DSA:3.70.10.10:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86680, NULL, 'G3DSA:3.30.360.10:FF:000036', NULL, NULL, 'YMR315W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(86681, NULL, 'G3DSA:2.40.50.140:FF:000615', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(86682, NULL, 'G3DSA:3.40.50.300:FF:000042', NULL, NULL, 'Maltose/maltodextrin ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(86683, NULL, 'G3DSA:3.90.1150.10:FF:000253', NULL, NULL, 'Isopenicillin N epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(86684, NULL, 'G3DSA:1.10.10.820:FF:000013', NULL, NULL, 'Unconventional myosin-XVI', NULL, NULL, NULL, NULL, NULL, 4),
(86685, NULL, 'G3DSA:1.25.40.180:FF:000098', NULL, NULL, 'MA3 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(86686, NULL, 'G3DSA:3.40.50.720:FF:001230', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(86687, NULL, 'G3DSA:3.60.21.10:FF:000478', NULL, NULL, 'Alkaline phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(86688, NULL, 'G3DSA:3.40.50.1000:FF:000205', NULL, NULL, 'ATPase 2 plasma membrane-type', NULL, NULL, NULL, NULL, NULL, 4),
(86689, NULL, 'G3DSA:3.80.10.10:FF:003493', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86690, NULL, 'G3DSA:6.10.140.2220:FF:000035', NULL, NULL, 'SET domain-containing protein SmydA-8, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(86691, NULL, 'G3DSA:1.25.70.10:FF:000071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86692, NULL, 'G3DSA:3.30.60.20:FF:000078', NULL, NULL, 'Protein CBG14248', NULL, NULL, NULL, NULL, NULL, 4),
(86693, NULL, 'G3DSA:1.25.40.20:FF:000133', NULL, NULL, 'protein fem-1 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(86694, NULL, 'G3DSA:3.30.519.10:FF:000017', NULL, NULL, 'Guanosine nucleotide diphosphate dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(86695, NULL, 'G3DSA:2.10.25.10:FF:000750', NULL, NULL, 'Putative adhesion G protein-coupled receptor E4P', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(86696, NULL, 'G3DSA:1.25.40.20:FF:000572', NULL, NULL, '85/88 kDa calcium-independent phospholipase A2', NULL, NULL, NULL, NULL, NULL, 4),
(86697, NULL, 'G3DSA:1.25.40.990:FF:000026', NULL, NULL, 'SAC3/GANP family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86698, NULL, 'G3DSA:3.40.50.2300:FF:001332', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86699, NULL, 'G3DSA:1.10.150.130:FF:000015', NULL, NULL, 'Site-specific recombinase, phage integrase family', NULL, NULL, NULL, NULL, NULL, 4),
(86700, NULL, 'G3DSA:2.40.50.140:FF:000306', NULL, NULL, 'Nucleic acid binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86701, NULL, 'G3DSA:1.25.10.10:FF:001713', NULL, NULL, 'Hsp70 nucleotide exchange factor FES1', NULL, NULL, NULL, NULL, NULL, 4),
(86702, NULL, 'G3DSA:1.10.150.50:FF:000241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86703, NULL, 'G3DSA:3.40.50.1820:FF:001418', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86704, NULL, 'G3DSA:1.20.120.550:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86705, NULL, 'G3DSA:2.60.120.10:FF:000656', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86706, NULL, 'G3DSA:3.80.10.10:FF:004139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86707, NULL, 'G3DSA:1.10.1580.10:FF:000013', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(86708, NULL, 'G3DSA:3.50.50.60:FF:001347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86709, NULL, 'G3DSA:1.20.1070.10:FF:000096', NULL, NULL, 'Odorant receptor 131-2', NULL, NULL, NULL, NULL, NULL, 4),
(86710, NULL, 'G3DSA:3.30.420.150:FF:000009', NULL, NULL, 'Guanosine-diphosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86711, NULL, 'G3DSA:3.40.390.10:FF:000002', NULL, NULL, 'Disintegrin and metalloproteinase domain-containing protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(86712, NULL, 'G3DSA:1.25.40.20:FF:000442', NULL, NULL, 'Calmodulin-binding transcription activator 2', NULL, NULL, NULL, NULL, NULL, 4),
(86713, NULL, 'G3DSA:1.25.40.10:FF:000905', NULL, NULL, 'Outer envelope protein 61', NULL, NULL, NULL, NULL, NULL, 4),
(86714, NULL, 'G3DSA:3.40.50.720:FF:001893', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(86715, NULL, 'G3DSA:1.20.1250.20:FF:000388', NULL, NULL, 'MFS sugar transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86716, NULL, 'G3DSA:3.20.20.80:FF:000167', NULL, NULL, 'Heparanase', NULL, NULL, NULL, NULL, NULL, 4),
(86717, NULL, 'G3DSA:3.90.320.10:FF:000020', NULL, NULL, 'DNA replication helicase/nuclease 2', NULL, NULL, NULL, NULL, NULL, 4),
(86718, NULL, 'G3DSA:1.20.58.400:FF:000038', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86719, NULL, 'G3DSA:3.40.50.2000:FF:000859', NULL, NULL, 'Chromosome 23, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(86720, NULL, 'G3DSA:3.30.500.10:FF:000008', NULL, NULL, 'Endothelial protein C receptor', NULL, NULL, NULL, NULL, NULL, 4),
(86721, NULL, 'G3DSA:3.30.40.10:FF:000658', NULL, NULL, 'E3 ubiquitin-protein ligase APD2', NULL, NULL, NULL, NULL, NULL, 4),
(86722, NULL, 'G3DSA:2.130.10.10:FF:005196', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(86723, NULL, 'G3DSA:1.10.3500.10:FF:000019', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(86724, NULL, 'G3DSA:2.30.42.10:FF:000215', NULL, NULL, 'uncharacterized protein KIAA1614 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(86725, NULL, 'G3DSA:3.20.20.100:FF:000132', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86726, NULL, 'G3DSA:1.10.510.10:FF:003303', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86727, NULL, 'G3DSA:3.90.290.10:FF:000022', NULL, NULL, 'Latent transforming growth factor beta binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(86728, NULL, 'G3DSA:1.25.40.10:FF:004930', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(86729, NULL, 'G3DSA:3.40.50.300:FF:000379', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(86730, NULL, 'G3DSA:3.40.630.10:FF:000055', NULL, NULL, 'Cytosolic carboxypeptidase-like protein 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(86731, NULL, 'G3DSA:3.30.200.20:FF:001461', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(86732, NULL, 'G3DSA:1.20.120.530:FF:000020', NULL, NULL, 'Probable D-xylose utilization operon transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(86733, NULL, 'G3DSA:3.40.920.10:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86734, NULL, 'G3DSA:3.10.20.70:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86735, NULL, 'G3DSA:1.20.1250.20:FF:002288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86736, NULL, 'G3DSA:2.60.260.20:FF:000040', NULL, NULL, 'DnaJ-class molecular chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(86737, NULL, 'G3DSA:2.170.270.10:FF:000123', NULL, NULL, 'PR domain-containing 1b, with ZNF domain', NULL, NULL, NULL, NULL, NULL, 4),
(86738, NULL, 'G3DSA:1.10.10.10:FF:000235', NULL, NULL, 'AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(86739, NULL, 'G3DSA:2.60.120.10:FF:000509', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86740, NULL, 'G3DSA:1.20.1270.280:FF:000013', NULL, NULL, 'Dynein, axonemal, heavy chain 14', NULL, NULL, NULL, NULL, NULL, 4),
(86741, NULL, 'G3DSA:1.10.510.10:FF:003697', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86742, NULL, 'G3DSA:3.30.40.10:FF:001147', NULL, NULL, 'GM24368', NULL, NULL, NULL, NULL, NULL, 4),
(86743, NULL, 'G3DSA:1.20.1070.10:FF:000657', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86744, NULL, 'G3DSA:2.30.30.30:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86745, NULL, 'G3DSA:2.130.10.10:FF:000328', NULL, NULL, 'Bromodomain and WD repeat domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(86746, NULL, 'G3DSA:3.40.50.150:FF:000406', NULL, NULL, 'tRNA (Adenine-N(1)-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(86747, NULL, 'G3DSA:1.10.287.40:FF:000032', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86748, NULL, 'G3DSA:1.20.140.150:FF:000011', NULL, NULL, 'lens fiber membrane intrinsic protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(86749, NULL, 'G3DSA:1.25.40.10:FF:002160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86750, NULL, 'G3DSA:1.20.140.80:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86751, NULL, 'G3DSA:2.60.40.150:FF:000157', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(86752, NULL, 'G3DSA:2.130.10.10:FF:002014', NULL, NULL, 'Putative pre-rrna-processing protein ipi3', NULL, NULL, NULL, NULL, NULL, 4),
(86753, NULL, 'G3DSA:3.30.70.3030:FF:000019', NULL, NULL, 'Nucleolar protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(86754, NULL, 'G3DSA:1.25.40.190:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86755, NULL, 'G3DSA:1.10.167.10:FF:000037', NULL, NULL, 'G protein-coupled receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(86756, NULL, 'G3DSA:1.10.10.60:FF:000317', NULL, NULL, 'homeobox protein abdominal-A', NULL, NULL, NULL, NULL, NULL, 4),
(86757, NULL, 'G3DSA:3.30.200.20:FF:001152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86758, NULL, 'G3DSA:2.70.40.10:FF:000035', NULL, NULL, 'Probable dUTP pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(86759, NULL, 'G3DSA:2.30.30.490:FF:000016', NULL, NULL, 'RSC complex member', NULL, NULL, NULL, NULL, NULL, 4),
(86760, NULL, 'G3DSA:2.170.260.10:FF:000016', NULL, NULL, 'RNA interference and gene silencing protein (Qde2), putative (AFU_orthologue AFUA_8G05280)', NULL, NULL, NULL, NULL, NULL, 4),
(86761, NULL, 'G3DSA:3.90.1410.10:FF:000060', NULL, NULL, 'Protein N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(86762, NULL, 'G3DSA:2.130.10.10:FF:002453', NULL, NULL, 'Transducin beta like 3', NULL, NULL, NULL, NULL, NULL, 4),
(86763, NULL, 'G3DSA:3.10.129.10:FF:000104', NULL, NULL, 'Thioesterase family protein (AFU_orthologue AFUA_2G16350)', NULL, NULL, NULL, NULL, NULL, 4),
(86764, NULL, 'G3DSA:3.30.930.10:FF:000237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86765, NULL, 'G3DSA:1.10.10.10:FF:000443', NULL, NULL, 'Transcriptional regulator, MarR family', NULL, NULL, NULL, NULL, NULL, 4),
(86766, NULL, 'G3DSA:2.60.120.40:FF:000041', NULL, NULL, 'CD40 ligand', NULL, NULL, NULL, NULL, NULL, 4),
(86767, NULL, 'G3DSA:3.40.30.10:FF:000854', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(86768, NULL, 'G3DSA:1.25.40.10:FF:001732', NULL, NULL, 'Os11g0587100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(86769, NULL, 'G3DSA:2.130.10.10:FF:003543', NULL, NULL, 'QUInine non-avoider', NULL, NULL, NULL, NULL, NULL, 4),
(86770, NULL, 'G3DSA:3.30.60.30:FF:000070', NULL, NULL, 'C3 and PZP-like alpha-2-macroglobulin domain-containing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(86771, NULL, 'G3DSA:3.30.2410.10:FF:000017', NULL, NULL, 'E3 ubiquitin-protein ligase UPL7', NULL, NULL, NULL, NULL, NULL, 4),
(86772, NULL, 'G3DSA:1.10.510.10:FF:000824', NULL, NULL, 'TBC domain-containing protein kinase-like protein isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(86773, NULL, 'G3DSA:1.25.40.10:FF:002822', NULL, NULL, 'RNA polymerase III transcription factor TFIIIC subunit (Tfc4), putative (AFU_orthologue AFUA_1G04980)', NULL, NULL, NULL, NULL, NULL, 4),
(86774, NULL, 'G3DSA:3.90.190.10:FF:000560', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86775, NULL, 'G3DSA:1.10.10.10:FF:001533', NULL, NULL, 'SARP family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(86776, NULL, 'G3DSA:2.100.10.50:FF:000004', NULL, NULL, 'Ubiquitin-specific protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86777, NULL, 'G3DSA:1.10.510.10:FF:001858', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(86778, NULL, 'G3DSA:3.90.550.20:FF:000006', NULL, NULL, 'Alpha-1,6-mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(86779, NULL, 'G3DSA:3.40.50.300:FF:005977', NULL, NULL, 'CRISPR-associated helicase/endonuclease Cas3', NULL, NULL, NULL, NULL, NULL, 4),
(86780, NULL, 'G3DSA:1.10.220.150:FF:000010', NULL, NULL, 'Stromal membrane-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(86781, NULL, 'G3DSA:2.40.100.10:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86782, NULL, 'G3DSA:3.30.1360.40:FF:000016', NULL, NULL, 'Ribosome-recycling factor', NULL, NULL, NULL, NULL, NULL, 4),
(86783, NULL, 'G3DSA:3.10.20.90:FF:000035', NULL, NULL, 'Fermitin family homolog 2 (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(86784, NULL, 'G3DSA:1.10.630.10:FF:000288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86785, NULL, 'G3DSA:1.10.287.110:FF:000233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86786, NULL, 'G3DSA:3.20.20.70:FF:000855', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86787, NULL, 'G3DSA:1.20.1310.10:FF:000002', NULL, NULL, 'cullin-3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(86788, NULL, 'G3DSA:2.130.10.10:FF:001289', NULL, NULL, 'RNA polymerase II Elongator subunit', NULL, NULL, NULL, NULL, NULL, 4),
(86789, NULL, 'G3DSA:3.40.30.10:FF:000270', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(86790, NULL, 'G3DSA:3.40.630.30:FF:000066', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(86791, NULL, 'G3DSA:1.10.3290.10:FF:000002', NULL, NULL, 'Protein adenylyltransferase NmFic', NULL, NULL, NULL, NULL, NULL, 4),
(86792, NULL, 'G3DSA:1.20.120.1760:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86793, NULL, 'G3DSA:3.40.50.150:FF:001289', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86794, NULL, 'G3DSA:3.70.10.10:FF:000048', NULL, NULL, 'DNA polymerase III beta subunit', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(86795, NULL, 'G3DSA:3.30.460.10:FF:000072', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(86796, NULL, 'G3DSA:3.30.565.10:FF:000315', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(86797, NULL, 'G3DSA:1.20.5.420:FF:000016', NULL, NULL, 'Dot/Icm secretion system protein IcmQ', NULL, NULL, NULL, NULL, NULL, 4),
(86798, NULL, 'G3DSA:3.40.50.720:FF:001258', NULL, NULL, 'CIP1 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86799, NULL, 'G3DSA:1.10.510.10:FF:004523', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86800, NULL, 'G3DSA:2.60.40.10:FF:003891', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86801, NULL, 'G3DSA:3.40.50.410:FF:000283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86802, NULL, 'G3DSA:2.60.120.260:FF:000620', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86803, NULL, 'G3DSA:3.30.160.60:FF:000350', NULL, NULL, 'Zinc finger protein 699', NULL, NULL, NULL, NULL, NULL, 4),
(86804, NULL, 'G3DSA:1.10.10.10:FF:000544', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(86805, NULL, 'G3DSA:1.25.40.10:FF:004958', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86806, NULL, 'G3DSA:1.20.1560.10:FF:000633', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86807, NULL, 'G3DSA:1.10.510.10:FF:000780', NULL, NULL, 'Receptor-like serine/threonine-protein kinase At4g25390', NULL, NULL, NULL, NULL, NULL, 4),
(86808, NULL, 'G3DSA:3.40.710.10:FF:000117', NULL, NULL, 'Penicillin-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86809, NULL, 'G3DSA:1.20.58.390:FF:000113', NULL, NULL, 'Ionotropic GABA receptor subunit UNC-49Cshort', NULL, NULL, NULL, NULL, NULL, 4),
(86810, NULL, 'G3DSA:3.40.50.300:FF:008147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86811, NULL, 'G3DSA:1.25.10.10:FF:002202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86812, NULL, 'G3DSA:3.30.70.80:FF:000006', NULL, NULL, 'Autophagic serine protease Alp2', NULL, NULL, NULL, NULL, NULL, 4),
(86813, NULL, 'G3DSA:3.40.50.1110:FF:000137', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86814, NULL, 'G3DSA:2.60.40.1510:FF:000012', NULL, NULL, 'Integrin subunit alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(86815, NULL, 'G3DSA:3.40.50.720:FF:002511', NULL, NULL, 'Bone marrow stromal cell antigen 1', NULL, NULL, NULL, NULL, NULL, 4),
(86816, NULL, 'G3DSA:1.50.40.10:FF:000049', NULL, NULL, 'Solute carrier family 25 member 45', NULL, NULL, NULL, NULL, NULL, 4),
(86817, NULL, 'G3DSA:3.30.200.20:FF:000533', NULL, NULL, 'probable protein kinase At2g41970', NULL, NULL, NULL, NULL, NULL, 4),
(86818, NULL, 'G3DSA:3.40.50.2300:FF:001124', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86819, NULL, 'G3DSA:3.90.1480.20:FF:000011', NULL, NULL, 'ST6 N-acetylgalactosaminide alpha-2,6-sialyltransferase 5', NULL, NULL, NULL, NULL, NULL, 4),
(86820, NULL, 'G3DSA:3.30.160.20:FF:000237', NULL, NULL, 'Ribosomal protein S2', NULL, NULL, NULL, NULL, NULL, 4),
(86821, NULL, 'G3DSA:3.30.530.20:FF:000148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86822, NULL, 'G3DSA:1.10.510.10:FF:002477', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86823, NULL, 'G3DSA:2.120.10.30:FF:000508', NULL, NULL, 'Peptidyl-glycine alpha-amidating monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86824, NULL, 'G3DSA:3.40.50.2300:FF:000034', NULL, NULL, 'DNA-binding response OmpR family regulator', NULL, NULL, NULL, NULL, NULL, 4),
(86825, NULL, 'G3DSA:3.40.50.300:FF:003829', NULL, NULL, 'Ras-related GTP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(86826, NULL, 'G3DSA:1.20.1280.180:FF:000002', NULL, NULL, 'Carnitine palmitoyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(86827, NULL, 'G3DSA:1.25.40.10:FF:004267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86828, NULL, 'G3DSA:2.60.40.10:FF:004083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(86829, NULL, 'G3DSA:1.10.510.10:FF:003567', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86830, NULL, 'G3DSA:1.10.3720.10:FF:000002', NULL, NULL, 'D-methionine ABC transporter permease MetI', NULL, NULL, NULL, NULL, NULL, 4),
(86831, NULL, 'G3DSA:1.10.238.10:FF:000219', NULL, NULL, 'EF-hand calcium-binding domain-containing protein 4A', NULL, NULL, NULL, NULL, NULL, 4),
(86832, NULL, 'G3DSA:1.10.10.10:FF:000105', NULL, NULL, 'HTH-type transcriptional repressor NsrR', NULL, NULL, NULL, NULL, NULL, 4),
(86833, NULL, 'G3DSA:3.30.40.10:FF:001838', NULL, NULL, 'Protein CBG12045', NULL, NULL, NULL, NULL, NULL, 4),
(86834, NULL, 'G3DSA:1.10.287.130:FF:000239', NULL, NULL, 'Two component signal transduction system histidine kinase with CHASE and PAS sensory domains', NULL, NULL, NULL, NULL, NULL, 4),
(86835, NULL, 'G3DSA:4.10.60.10:FF:000080', NULL, NULL, 'RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86836, NULL, 'G3DSA:3.30.70.1220:FF:000004', NULL, NULL, 'RNA polymerase II transcription factor B subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(86837, NULL, 'G3DSA:3.30.60.30:FF:000227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86838, NULL, 'G3DSA:3.90.550.10:FF:000543', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86839, NULL, 'G3DSA:3.40.50.300:FF:008248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86840, NULL, 'G3DSA:1.10.287.470:FF:000083', NULL, NULL, 'HlyD family secretion protein', NULL, NULL, NULL, NULL, NULL, 4),
(86841, NULL, 'G3DSA:3.30.160.60:FF:005993', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86842, NULL, 'G3DSA:1.20.120.1900:FF:000028', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(86843, NULL, 'G3DSA:3.40.50.300:FF:004549', NULL, NULL, 'Atlastin GTPase 3', NULL, NULL, NULL, NULL, NULL, 4),
(86844, NULL, 'G3DSA:1.20.58.60:FF:000595', NULL, NULL, 'Plectin', NULL, NULL, NULL, NULL, NULL, 4),
(86845, NULL, 'G3DSA:3.80.10.10:FF:003521', NULL, NULL, 'Tehao', NULL, NULL, NULL, NULL, NULL, 4),
(86846, NULL, 'G3DSA:1.20.58.70:FF:000025', NULL, NULL, 'Syntaxin-12', NULL, NULL, NULL, NULL, NULL, 4),
(86847, NULL, 'G3DSA:3.40.140.10:FF:000208', NULL, NULL, 'Myb-like protein H', NULL, NULL, NULL, NULL, NULL, 4),
(86848, NULL, 'G3DSA:1.10.1600.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86849, NULL, 'G3DSA:3.30.70.330:FF:001400', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(86850, NULL, 'G3DSA:3.100.10.10:FF:000022', NULL, NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(86851, NULL, 'G3DSA:2.10.25.10:FF:001576', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86852, NULL, 'G3DSA:1.10.8.60:FF:000338', NULL, NULL, 'Cell division cycle protein', NULL, NULL, NULL, NULL, NULL, 4),
(86853, NULL, 'G3DSA:1.20.1070.10:FF:001130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86854, NULL, 'G3DSA:2.40.160.50:FF:000034', NULL, NULL, 'YALI0C06974p', NULL, NULL, NULL, NULL, NULL, 4),
(86855, NULL, 'G3DSA:3.40.140.10:FF:000051', NULL, NULL, 'Nucleoside deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(86856, NULL, 'G3DSA:3.40.50.2000:FF:000298', NULL, NULL, 'Protein CBR-BUS-8', NULL, NULL, NULL, NULL, NULL, 4),
(86857, NULL, 'G3DSA:2.40.10.10:FF:000703', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86858, NULL, 'G3DSA:3.40.720.10:FF:000146', NULL, NULL, 'N-acetyl-galactosamine-6-sulfatase (GALNS)', NULL, NULL, NULL, NULL, NULL, 4),
(86859, NULL, 'G3DSA:3.40.50.150:FF:001025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86860, NULL, 'G3DSA:3.40.47.10:FF:000038', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(86861, NULL, 'G3DSA:3.30.470.160:FF:000011', NULL, NULL, 'Kinase', NULL, NULL, NULL, NULL, NULL, 4),
(86862, NULL, 'G3DSA:2.60.120.310:FF:000006', NULL, NULL, 'Monooxygenase, DBH-like 2, pseudogene', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(86863, NULL, 'G3DSA:1.20.144.10:FF:000050', NULL, NULL, 'Lipid phosphate phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86864, NULL, 'G3DSA:1.25.10.10:FF:001904', NULL, NULL, 'Armadillo repeat-containing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(86865, NULL, 'G3DSA:1.20.120.350:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86866, NULL, 'G3DSA:2.130.10.10:FF:002823', NULL, NULL, 'YALI0D12705p', NULL, NULL, NULL, NULL, NULL, 4),
(86867, NULL, 'G3DSA:3.40.50.300:FF:000704', NULL, NULL, 'fe-S cluster assembly factor HCF101, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(86868, NULL, 'G3DSA:3.30.70.870:FF:000016', NULL, NULL, 'Translation elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(86869, NULL, 'G3DSA:3.20.130.10:FF:000004', NULL, NULL, 'Fumarate hydratase class I', NULL, NULL, NULL, NULL, NULL, 4),
(86870, NULL, 'G3DSA:1.10.10.1760:FF:000008', NULL, NULL, '60S ribosomal protein L36', NULL, NULL, NULL, NULL, NULL, 4),
(86871, NULL, 'G3DSA:1.10.287.1490:FF:000148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86872, NULL, 'G3DSA:3.20.20.150:FF:000023', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(86873, NULL, 'G3DSA:3.40.50.1100:FF:000039', NULL, NULL, 'Threonine synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(86874, NULL, 'G3DSA:3.30.70.920:FF:000054', NULL, NULL, 'Transcriptional regulator, AsnC family', NULL, NULL, NULL, NULL, NULL, 4),
(86875, NULL, 'G3DSA:1.25.10.10:FF:001584', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86876, NULL, 'G3DSA:3.30.505.10:FF:000194', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86877, NULL, 'G3DSA:3.50.50.60:FF:000667', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86878, NULL, 'G3DSA:3.30.565.10:FF:000101', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(86879, NULL, 'G3DSA:3.30.519.10:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86880, NULL, 'G3DSA:1.20.1330.10:FF:000015', NULL, NULL, 'Flagellin', NULL, NULL, NULL, NULL, NULL, 4),
(86881, NULL, 'G3DSA:3.30.420.40:FF:000505', NULL, NULL, 'Actin-related protein 3, putative arp3', NULL, NULL, NULL, NULL, NULL, 4),
(86882, NULL, 'G3DSA:3.30.420.40:FF:000393', NULL, NULL, 'Pantothenate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(86883, NULL, 'G3DSA:3.40.50.150:FF:000637', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(86884, NULL, 'G3DSA:3.30.1140.40:FF:000005', NULL, NULL, 'Topoisomerase I damage affected protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(86885, NULL, 'G3DSA:2.130.10.10:FF:001609', NULL, NULL, 'Chromatin assembly factor 1 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(86886, NULL, 'G3DSA:1.10.630.10:FF:000608', NULL, NULL, 'Os10g0511200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(86887, NULL, 'G3DSA:1.10.510.10:FF:002578', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(86888, NULL, 'G3DSA:3.40.50.2000:FF:001040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86889, NULL, 'G3DSA:2.60.200.10:FF:000027', NULL, NULL, 'IRF6 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(86890, NULL, 'G3DSA:3.20.20.220:FF:000067', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(86891, NULL, 'G3DSA:2.130.10.10:FF:001497', NULL, NULL, 'Chromatin assembly factor 1, p105 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(86892, NULL, 'G3DSA:3.40.50.300:FF:006691', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86893, NULL, 'G3DSA:3.40.50.720:FF:002202', NULL, NULL, 'Carnitine acetyl transferase (AFU_orthologue AFUA_2G12530)', NULL, NULL, NULL, NULL, NULL, 4),
(86894, NULL, 'G3DSA:3.40.50.1980:FF:000033', NULL, NULL, 'Nitrogenase MoFe cofactor biosynthesis protein NifE', NULL, NULL, NULL, NULL, NULL, 4),
(86895, NULL, 'G3DSA:3.40.50.300:FF:004196', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(86896, NULL, 'G3DSA:3.30.160.60:FF:004307', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86897, NULL, 'G3DSA:2.60.40.60:FF:000567', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86898, NULL, 'G3DSA:3.90.226.10:FF:000054', NULL, NULL, 'probable enoyl-CoA hydratase 1, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(86899, NULL, 'G3DSA:2.130.10.10:FF:002115', NULL, NULL, 'Transducin beta-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(86900, NULL, 'G3DSA:3.80.10.10:FF:000648', NULL, NULL, 'F-box/LRR-repeat protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(86901, NULL, 'G3DSA:1.10.246.10:FF:000002', NULL, NULL, 'Serum albumin', NULL, NULL, NULL, NULL, NULL, 4),
(86902, NULL, 'G3DSA:3.30.1490.100:FF:000018', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(86903, NULL, 'G3DSA:2.60.120.200:FF:000428', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86904, NULL, 'G3DSA:3.40.50.12390:FF:000002', NULL, NULL, '5''-3'' exoribonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(86905, NULL, 'G3DSA:4.10.240.10:FF:000084', NULL, NULL, 'Uncharacterized transcriptional regulatory protein C1327.01c', NULL, NULL, NULL, NULL, NULL, 4),
(86906, NULL, 'G3DSA:1.10.630.10:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86907, NULL, 'G3DSA:1.10.238.10:FF:000427', NULL, NULL, 'Probable calcium-binding protein CML27', NULL, NULL, NULL, NULL, NULL, 4),
(86908, NULL, 'G3DSA:1.10.620.20:FF:000010', NULL, NULL, 'Ribonucleotide reductase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(86909, NULL, 'G3DSA:3.30.1120.10:FF:000046', NULL, NULL, 'N-acetylgalactosamine-6-sulfatase (GALNS)', NULL, NULL, NULL, NULL, NULL, 4),
(86910, NULL, 'G3DSA:2.30.42.10:FF:000007', NULL, NULL, 'Amyloid beta A4 protein-binding family A member', NULL, NULL, NULL, NULL, NULL, 4),
(86911, NULL, 'G3DSA:1.25.40.10:FF:003441', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(86912, NULL, 'G3DSA:1.20.1250.10:FF:000059', NULL, NULL, 'Growth hormone d13', NULL, NULL, NULL, NULL, NULL, 4),
(86913, NULL, 'G3DSA:2.20.25.10:FF:000007', NULL, NULL, 'Transcription initiation factor IIB', NULL, NULL, NULL, NULL, NULL, 4),
(86914, NULL, 'G3DSA:1.10.10.60:FF:001278', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86915, NULL, 'G3DSA:1.10.630.10:FF:000496', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86916, NULL, 'G3DSA:1.20.1310.10:FF:000210', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86917, NULL, 'G3DSA:3.40.1190.10:FF:000031', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(86918, NULL, 'G3DSA:3.40.50.300:FF:007528', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86919, NULL, 'G3DSA:1.10.510.10:FF:004422', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86920, NULL, 'G3DSA:3.40.190.10:FF:000363', NULL, NULL, 'Oligopeptide ABC transporter (Binding lipoprotein)', NULL, NULL, NULL, NULL, NULL, 4),
(86921, NULL, 'G3DSA:3.30.420.40:FF:000977', NULL, NULL, 'Heat shock protein 70 putative', NULL, NULL, NULL, NULL, NULL, 4),
(86922, NULL, 'G3DSA:2.30.29.30:FF:000831', NULL, NULL, 'DCC-interacting protein 13-alpha-like', NULL, NULL, NULL, NULL, NULL, 4),
(86923, NULL, 'G3DSA:1.20.5.190:FF:000155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86924, NULL, 'G3DSA:1.10.472.170:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86925, NULL, 'G3DSA:3.30.160.20:FF:000136', NULL, NULL, 'Staufen 1', NULL, NULL, NULL, NULL, NULL, 4),
(86926, NULL, 'G3DSA:3.40.50.1000:FF:000644', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86927, NULL, 'G3DSA:1.20.1560.10:FF:000841', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86928, NULL, 'G3DSA:3.80.10.10:FF:001576', NULL, NULL, 'Leucine rich repeat and phosphatase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(86929, NULL, 'G3DSA:3.30.420.40:FF:001011', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(86930, NULL, 'G3DSA:1.25.40.20:FF:000364', NULL, NULL, 'AF4/FMR2 family member 4 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(86931, NULL, 'G3DSA:2.130.10.10:FF:004268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86932, NULL, 'G3DSA:2.30.30.420:FF:000001', NULL, NULL, 'Inactive glucansucrase', NULL, NULL, NULL, NULL, NULL, 4),
(86933, NULL, 'G3DSA:3.30.497.10:FF:000010', NULL, NULL, 'glia-derived nexin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(86934, NULL, 'G3DSA:3.80.10.10:FF:000957', NULL, NULL, 'Leucine rich repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(86935, NULL, 'G3DSA:3.30.1680.10:FF:000065', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(86936, NULL, 'G3DSA:3.40.50.300:FF:006702', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86937, NULL, 'G3DSA:3.30.950.10:FF:000019', NULL, NULL, 'Trifunctional enzyme subunit', NULL, NULL, NULL, NULL, NULL, 4),
(86938, NULL, 'G3DSA:3.30.160.60:FF:003104', NULL, NULL, 'Protein CBG08513', NULL, NULL, NULL, NULL, NULL, 4),
(86939, NULL, 'G3DSA:1.10.472.10:FF:000151', NULL, NULL, 'Cyclin-H, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86940, NULL, 'G3DSA:2.30.30.40:FF:000303', NULL, NULL, 'ZO-1 (Zonula Occludens tight junctional protein) Ortholog', NULL, NULL, NULL, NULL, NULL, 4),
(86941, NULL, 'G3DSA:1.10.510.10:FF:002269', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86942, NULL, 'G3DSA:3.30.40.10:FF:002002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86943, NULL, 'G3DSA:2.60.40.150:FF:000612', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86944, NULL, 'G3DSA:1.20.810.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86945, NULL, 'G3DSA:3.80.10.10:FF:001121', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(86946, NULL, 'G3DSA:3.40.50.300:FF:001323', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86947, NULL, 'G3DSA:4.10.640.10:FF:000030', NULL, NULL, 'Mitochondrial 37S ribosomal protein RSM18', NULL, NULL, NULL, NULL, NULL, 4),
(86948, NULL, 'G3DSA:3.30.160.60:FF:001070', NULL, NULL, 'zinc finger protein 133 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(86949, NULL, 'G3DSA:2.70.70.10:FF:000071', NULL, NULL, 'Morphogenesis protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(86950, NULL, 'G3DSA:3.40.525.10:FF:000024', NULL, NULL, 'Sec14p-like phosphatidylinositol transfer family protein', NULL, NULL, NULL, NULL, NULL, 4),
(86951, NULL, 'G3DSA:3.30.540.30:FF:000011', NULL, NULL, 'Nudix hydrolase 3', NULL, NULL, NULL, NULL, NULL, 4),
(86952, NULL, 'G3DSA:3.30.1490.70:FF:000012', NULL, NULL, 'Multifunctional non-homologous end joining protein LigD', NULL, NULL, NULL, NULL, NULL, 4),
(86953, NULL, 'G3DSA:2.60.40.10:FF:005925', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86954, NULL, 'G3DSA:2.40.30.240:FF:000001', NULL, NULL, 'Coat protein', NULL, NULL, NULL, NULL, NULL, 4),
(86955, NULL, 'G3DSA:3.80.10.10:FF:002902', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86956, NULL, 'G3DSA:3.30.710.10:FF:000142', NULL, NULL, 'Regulatory protein ral2, variant', NULL, NULL, NULL, NULL, NULL, 4),
(86957, NULL, 'G3DSA:2.130.10.10:FF:003751', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86958, NULL, 'G3DSA:3.90.370.10:FF:000006', NULL, NULL, 'TIMP metallopeptidase inhibitor 4, tandem duplicate 2', NULL, NULL, NULL, NULL, NULL, 4),
(86959, NULL, 'G3DSA:3.40.50.300:FF:004757', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86960, NULL, 'G3DSA:1.20.1070.10:FF:000888', NULL, NULL, 'Parathyroid hormone 2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(86961, NULL, 'G3DSA:1.20.58.1930:FF:000001', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(86962, NULL, 'G3DSA:3.30.9.30:FF:000002', NULL, NULL, 'Salicylate hydroxylase, putative (AFU_orthologue AFUA_7G00590)', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(86963, NULL, 'G3DSA:1.10.3720.10:FF:000210', NULL, NULL, 'Oligopeptide transport system permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(86964, NULL, 'G3DSA:1.25.40.10:FF:003986', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86965, NULL, 'G3DSA:2.60.40.10:FF:002149', NULL, NULL, 'Pili assembly chaperone, N-terminal', NULL, NULL, NULL, NULL, NULL, 4),
(86966, NULL, 'G3DSA:3.10.20.30:FF:000023', NULL, NULL, '3-ketosteroid-9-alpha-hydroxylase reductase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(86967, NULL, 'G3DSA:3.40.47.10:FF:000246', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86968, NULL, 'G3DSA:2.10.70.10:FF:000293', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86969, NULL, 'G3DSA:3.20.20.140:FF:000374', NULL, NULL, 'Adenosine deaminase-like', NULL, NULL, NULL, NULL, NULL, 4),
(86970, NULL, 'G3DSA:3.40.50.1360:FF:000055', NULL, NULL, '6-phosphogluconolactonase', NULL, NULL, NULL, NULL, NULL, 4),
(86971, NULL, 'G3DSA:3.50.50.60:FF:000875', NULL, NULL, 'Monooxygenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(86972, NULL, 'G3DSA:3.30.420.40:FF:000713', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86973, NULL, 'G3DSA:1.20.1280.50:FF:000112', NULL, NULL, 'F-box protein PP2-B1', NULL, NULL, NULL, NULL, NULL, 4),
(86974, NULL, 'G3DSA:1.10.220.20:FF:000007', NULL, NULL, 'GDP/GTP exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(86975, NULL, 'G3DSA:2.130.10.10:FF:003442', NULL, NULL, 'AaceriADR216Wp', NULL, NULL, NULL, NULL, NULL, 4),
(86976, NULL, 'G3DSA:2.70.98.40:FF:000008', NULL, NULL, 'Trehalose-6-phosphate phosphatase OtsB1', NULL, NULL, NULL, NULL, NULL, 4),
(86977, NULL, 'G3DSA:1.10.8.1310:FF:000020', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(86978, NULL, 'G3DSA:2.60.120.330:FF:000208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86979, NULL, 'G3DSA:1.25.40.10:FF:000804', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(86980, NULL, 'G3DSA:3.90.80.10:FF:000012', NULL, NULL, 'Acidocalcisomal pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(86981, NULL, 'G3DSA:3.40.50.1000:FF:000543', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86982, NULL, 'G3DSA:3.30.1370.10:FF:000154', NULL, NULL, 'RNA-binding KH domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(86983, NULL, 'G3DSA:1.10.10.60:FF:000761', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(86984, NULL, 'G3DSA:2.70.150.10:FF:000200', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(86985, NULL, 'G3DSA:1.20.1050.10:FF:000302', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(86986, NULL, 'G3DSA:3.90.79.10:FF:000284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86987, NULL, 'G3DSA:3.40.50.300:FF:002088', NULL, NULL, 'Putative AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(86988, NULL, 'G3DSA:2.60.40.10:FF:003110', NULL, NULL, 'Transcription factor unc-3', NULL, NULL, NULL, NULL, NULL, 4),
(86989, NULL, 'G3DSA:2.40.50.140:FF:000407', NULL, NULL, 'rRNA biogenesis protein RRP5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86990, NULL, 'G3DSA:2.60.40.10:FF:000704', NULL, NULL, 'collagen alpha-1(XII) chain isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(86991, NULL, 'G3DSA:2.60.40.10:FF:001210', NULL, NULL, 'Obscurin like 1', NULL, NULL, NULL, NULL, NULL, 4),
(86992, NULL, 'G3DSA:1.20.58.60:FF:000140', NULL, NULL, 'dystrophin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(86993, NULL, 'G3DSA:2.70.98.20:FF:000002', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(86994, NULL, 'G3DSA:3.90.640.10:FF:000095', NULL, NULL, 'Actin-related protein 3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(86995, NULL, 'G3DSA:2.60.120.10:FF:000448', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(86996, NULL, 'G3DSA:1.10.150.20:FF:000243', NULL, NULL, 'Translocation protein SEC63-like protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(86997, NULL, 'G3DSA:1.25.40.700:FF:000001', NULL, NULL, 'Nuclear pore complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(86998, NULL, 'G3DSA:1.10.1410.10:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(86999, NULL, 'G3DSA:1.25.40.10:FF:004503', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g28050', NULL, NULL, NULL, NULL, NULL, 4),
(87000, NULL, 'G3DSA:1.25.40.10:FF:001069', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g53700, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(87001, NULL, 'G3DSA:3.40.5.10:FF:000010', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(87002, NULL, 'G3DSA:1.20.1070.10:FF:002102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87003, NULL, 'G3DSA:3.30.160.60:FF:005212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87004, NULL, 'G3DSA:2.70.130.10:FF:000093', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87005, NULL, 'G3DSA:3.40.630.10:FF:000482', NULL, NULL, 'Putative glutaminyl cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(87006, NULL, 'G3DSA:2.30.30.140:FF:000142', NULL, NULL, 'Ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(87007, NULL, 'G3DSA:1.10.730.10:FF:000088', NULL, NULL, 'Leucine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(87008, NULL, 'G3DSA:2.130.10.10:FF:004471', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87009, NULL, 'G3DSA:3.40.109.10:FF:000046', NULL, NULL, 'Nitroreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(87010, NULL, 'G3DSA:3.90.215.10:FF:000017', NULL, NULL, 'Intelectin 1', NULL, NULL, NULL, NULL, NULL, 4),
(87011, NULL, 'G3DSA:1.25.10.10:FF:000724', NULL, NULL, 'Cyclosome subunit-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(87012, NULL, 'G3DSA:3.50.50.60:FF:000403', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(87013, NULL, 'G3DSA:3.10.20.90:FF:000457', NULL, NULL, 'Rad60, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(87014, NULL, 'G3DSA:1.10.287.160:FF:000023', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(87015, NULL, 'G3DSA:3.30.160.60:FF:004296', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87016, NULL, 'G3DSA:3.30.800.10:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87017, NULL, 'G3DSA:1.25.40.10:FF:005239', NULL, NULL, 'Putative S-locus receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(87018, NULL, 'G3DSA:1.10.287.3240:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87019, NULL, 'G3DSA:2.130.10.10:FF:005696', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(87020, NULL, 'G3DSA:2.170.270.10:FF:000062', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-36 specific', NULL, NULL, NULL, NULL, NULL, 4),
(87021, NULL, 'G3DSA:1.10.540.10:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87022, NULL, 'G3DSA:3.90.70.10:FF:000747', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87023, NULL, 'G3DSA:3.10.580.10:FF:000006', NULL, NULL, 'DUF21 and CBS domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(87024, NULL, 'G3DSA:2.60.40.1270:FF:000001', NULL, NULL, 'Putative DD-carboxypeptidase TP_0574', NULL, NULL, NULL, NULL, NULL, 4),
(87025, NULL, 'G3DSA:2.70.98.10:FF:000112', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(87026, NULL, 'G3DSA:2.60.40.1660:FF:000006', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(87027, NULL, 'G3DSA:3.80.10.10:FF:003285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87028, NULL, 'G3DSA:1.10.1420.10:FF:000165', NULL, NULL, 'MutS protein homolog 5', NULL, NULL, NULL, NULL, NULL, 4),
(87029, NULL, 'G3DSA:3.30.200.20:FF:001253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87030, NULL, 'G3DSA:1.10.3080.10:FF:000065', NULL, NULL, 'Chloride channel, putative', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(87031, NULL, 'G3DSA:3.30.200.20:FF:000163', NULL, NULL, 'SRSF protein kinase 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(87032, NULL, 'G3DSA:1.20.1170.10:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87033, NULL, 'G3DSA:3.40.630.30:FF:000488', NULL, NULL, 'UPF0039 protein sll0451', NULL, NULL, NULL, NULL, NULL, 4),
(87034, NULL, 'G3DSA:3.40.50.300:FF:006039', NULL, NULL, 'DEAH-box helicase 15', NULL, NULL, NULL, NULL, NULL, 4),
(87035, NULL, 'G3DSA:2.40.10.170:FF:000004', NULL, NULL, 'ATP synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(87036, NULL, 'G3DSA:3.30.1490.180:FF:000014', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(87037, NULL, 'G3DSA:3.40.50.720:FF:000196', NULL, NULL, 'Leucine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(87038, NULL, 'G3DSA:3.40.50.300:FF:001823', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(87039, NULL, 'G3DSA:1.25.40.20:FF:000650', NULL, NULL, 'KRIT 1 (Krev interaction trapped/cerebral cavernous malformation 1) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(87040, NULL, 'G3DSA:1.10.510.10:FF:003197', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87041, NULL, 'G3DSA:2.70.170.10:FF:000100', NULL, NULL, 'Protein CBR-LGC-28', NULL, NULL, NULL, NULL, NULL, 4),
(87042, NULL, 'G3DSA:1.10.150.240:FF:000048', NULL, NULL, 'Haloacid dehalogenase-like hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(87043, NULL, 'G3DSA:2.160.20.20:FF:000004', NULL, NULL, 'Outer membrane autotransporter barrel domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(87044, NULL, 'G3DSA:1.10.510.10:FF:000471', NULL, NULL, 'OBP3-responsive gene 1', NULL, NULL, NULL, NULL, NULL, 4),
(87045, NULL, 'G3DSA:3.40.1000.10:FF:000001', NULL, NULL, 'Repulsive guidance molecule BMP co-receptor a', NULL, NULL, NULL, NULL, NULL, 4),
(87046, NULL, 'G3DSA:1.10.472.80:FF:000227', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87047, NULL, 'G3DSA:3.80.10.10:FF:004347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87048, NULL, 'G3DSA:3.30.70.330:FF:003154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87049, NULL, 'G3DSA:3.40.30.10:FF:000640', NULL, NULL, 'Peroxiredoxin type II', NULL, NULL, NULL, NULL, NULL, 4),
(87050, NULL, 'G3DSA:3.90.1150.10:FF:000062', NULL, NULL, 'Aspartate aminotransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(87051, NULL, 'G3DSA:2.30.29.30:FF:000595', NULL, NULL, 'Putative rac serine-threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(87052, NULL, 'G3DSA:3.40.50.2300:FF:000298', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(87053, NULL, 'G3DSA:3.30.40.10:FF:000866', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(87054, NULL, 'G3DSA:2.130.10.10:FF:005549', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87055, NULL, 'G3DSA:2.60.40.60:FF:000803', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87056, NULL, 'G3DSA:1.10.8.50:FF:000026', NULL, NULL, '30S ribosomal protein S13', NULL, NULL, NULL, NULL, NULL, 4),
(87057, NULL, 'G3DSA:2.130.10.10:FF:001598', NULL, NULL, 'Meiosis-specific APC/C activator protein AMA1', NULL, NULL, NULL, NULL, NULL, 4),
(87058, NULL, 'G3DSA:2.20.20.10:FF:000002', NULL, NULL, 'Big defensin', NULL, NULL, NULL, NULL, NULL, 4),
(87059, NULL, 'G3DSA:1.20.120.350:FF:000090', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(87060, NULL, 'G3DSA:1.10.418.10:FF:000172', NULL, NULL, 'Plectin', NULL, NULL, NULL, NULL, NULL, 4),
(87061, NULL, 'G3DSA:2.60.120.290:FF:000062', NULL, NULL, 'Cubilin', NULL, NULL, NULL, NULL, NULL, 4),
(87062, NULL, 'G3DSA:1.20.272.10:FF:000072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87063, NULL, 'G3DSA:2.30.140.30:FF:000001', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase DacB', NULL, NULL, NULL, NULL, NULL, 4),
(87064, NULL, 'G3DSA:1.10.8.270:FF:000081', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(87065, NULL, 'G3DSA:2.30.30.40:FF:000450', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87066, NULL, 'G3DSA:3.30.160.60:FF:004032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87067, NULL, 'G3DSA:3.90.79.10:FF:000183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87068, NULL, 'G3DSA:2.40.70.10:FF:000212', NULL, NULL, 'Os09g0556100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(87069, NULL, 'G3DSA:3.80.10.10:FF:002402', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(87070, NULL, 'G3DSA:3.80.10.10:FF:003830', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87071, NULL, 'G3DSA:2.40.290.10:FF:000037', NULL, NULL, 'ATP-dependent DNA helicase II subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(87072, NULL, 'G3DSA:1.10.630.10:FF:000390', NULL, NULL, 'Taxane 13-alpha-hydroxylase isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(87073, NULL, 'G3DSA:3.40.50.300:FF:006803', NULL, NULL, 'ATP-dependent transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(87074, NULL, 'G3DSA:3.40.50.2300:FF:000859', NULL, NULL, 'Guanylate cyclase 2G', NULL, NULL, NULL, NULL, NULL, 4),
(87075, NULL, 'G3DSA:3.40.50.1820:FF:001070', NULL, NULL, 'Prolyl oligopeptidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(87076, NULL, 'G3DSA:3.30.160.60:FF:000917', NULL, NULL, 'Zinc finger and BTB domain containing 40', NULL, NULL, NULL, NULL, NULL, 4),
(87077, NULL, 'G3DSA:3.80.10.10:FF:002666', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(87078, NULL, 'G3DSA:3.40.50.410:FF:000075', NULL, NULL, 'Sporozoite surface protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(87079, NULL, 'G3DSA:3.40.50.150:FF:001609', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87080, NULL, 'G3DSA:3.40.50.1440:FF:000091', NULL, NULL, 'Protein DML1', NULL, NULL, NULL, NULL, NULL, 4),
(87081, NULL, 'G3DSA:3.30.200.20:FF:000988', NULL, NULL, 'Serine/threonine-protein kinase VHS1', NULL, NULL, NULL, NULL, NULL, 4),
(87082, NULL, 'G3DSA:3.30.2360.10:FF:000002', NULL, NULL, 'Probable myo-inositol 1-phosphate synthase (MIPS)', NULL, NULL, NULL, NULL, NULL, 4),
(87083, NULL, 'G3DSA:1.20.5.110:FF:000159', NULL, NULL, 'EhSyntaxin G, putative', NULL, NULL, NULL, NULL, NULL, 4),
(87084, NULL, 'G3DSA:2.160.10.10:FF:000074', NULL, NULL, 'Putative DEAD-box ATP-dependent RNA helicase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(87085, NULL, 'G3DSA:3.40.50.300:FF:003268', NULL, NULL, 'ABC transporter, class H', NULL, NULL, NULL, NULL, NULL, 4),
(87086, NULL, 'G3DSA:1.10.510.10:FF:000324', NULL, NULL, 'N-terminal kinase-like protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(87087, NULL, 'G3DSA:3.30.1600.10:FF:000026', NULL, NULL, 'NAD-dependent protein deacetylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(87088, NULL, 'G3DSA:3.30.40.10:FF:001485', NULL, NULL, 'E3 ubiquitin-protein ligase RNF115', NULL, NULL, NULL, NULL, NULL, 4),
(87089, NULL, 'G3DSA:1.20.1060.20:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87090, NULL, 'G3DSA:1.20.140.40:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87091, NULL, 'G3DSA:2.60.34.10:FF:000072', NULL, NULL, 'Heat shock protein 4a', NULL, NULL, NULL, NULL, NULL, 4),
(87092, NULL, 'G3DSA:1.25.40.10:FF:001996', NULL, NULL, 'Protein O-mannosyl-transferase TMTC2', NULL, NULL, NULL, NULL, NULL, 4),
(87093, NULL, 'G3DSA:1.25.10.10:FF:002101', NULL, NULL, 'Zyg-11 family member A, cell cycle regulator', NULL, NULL, NULL, NULL, NULL, 4),
(87094, NULL, 'G3DSA:3.30.590.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87095, NULL, 'G3DSA:3.30.40.10:FF:002103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87096, NULL, 'G3DSA:3.10.100.10:FF:000140', NULL, NULL, 'Protein-tyrosine-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(87097, NULL, 'G3DSA:3.40.50.620:FF:000609', NULL, NULL, 'Rars-1', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(87098, NULL, 'G3DSA:3.30.9.10:FF:000041', NULL, NULL, 'Fructosyl amino acid oxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(87099, NULL, 'G3DSA:2.40.320.10:FF:000035', NULL, NULL, 'Inorganic triphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(87100, NULL, 'G3DSA:1.10.238.10:FF:000528', NULL, NULL, 'Supercoiling factor', NULL, NULL, NULL, NULL, NULL, 4),
(87101, NULL, 'G3DSA:3.40.50.720:FF:000757', NULL, NULL, 'NADPH-dependent aldehyde reductase 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(87102, NULL, 'G3DSA:1.20.5.340:FF:000026', NULL, NULL, 'myotonin-protein kinase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(87103, NULL, 'G3DSA:1.10.10.10:FF:001269', NULL, NULL, 'Ferric uptake regulator family protein', NULL, NULL, NULL, NULL, NULL, 4),
(87104, NULL, 'G3DSA:2.60.40.10:FF:005572', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87105, NULL, 'G3DSA:1.20.120.420:FF:000015', NULL, NULL, 'Methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(87106, NULL, 'G3DSA:1.25.10.10:FF:002410', NULL, NULL, 'RPTOR-independent companion of MTOR, complex 2 a', NULL, NULL, NULL, NULL, NULL, 4),
(87107, NULL, 'G3DSA:3.40.50.2060:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87108, NULL, 'G3DSA:2.160.20.70:FF:000002', NULL, NULL, 'Probable septum site-determining protein MinC', NULL, NULL, NULL, NULL, NULL, 4),
(87109, NULL, 'G3DSA:2.60.40.1180:FF:000076', NULL, NULL, 'Glucosidase II', NULL, NULL, NULL, NULL, NULL, 4),
(87110, NULL, 'G3DSA:3.10.110.10:FF:000275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87111, NULL, 'G3DSA:2.60.260.20:FF:000101', NULL, NULL, 'Mitochondrial protein import protein mas5', NULL, NULL, NULL, NULL, NULL, 4),
(87112, NULL, 'G3DSA:3.30.750.24:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87113, NULL, 'G3DSA:1.20.1270.10:FF:000077', NULL, NULL, 'Hsp70_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(87114, NULL, 'G3DSA:2.130.10.10:FF:004723', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(87115, NULL, 'G3DSA:3.40.50.720:FF:001685', NULL, NULL, 'C-terminal-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(87116, NULL, 'G3DSA:1.20.1080.10:FF:000130', NULL, NULL, 'AQuaPorin or aquaglyceroporin related', NULL, NULL, NULL, NULL, NULL, 4),
(87117, NULL, 'G3DSA:3.40.50.300:FF:001368', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(87118, NULL, 'G3DSA:3.30.720.150:FF:000010', NULL, NULL, 'O-linked GlcNAc transferase', NULL, NULL, NULL, NULL, NULL, 4),
(87119, NULL, 'G3DSA:3.20.20.70:FF:000046', NULL, NULL, '4-hydroxy-tetrahydrodipicolinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(87120, NULL, 'G3DSA:1.20.58.390:FF:000321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87121, NULL, 'G3DSA:3.40.50.150:FF:001497', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87122, NULL, 'G3DSA:3.40.50.620:FF:000918', NULL, NULL, 'Probable cysteine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(87123, NULL, 'G3DSA:1.10.510.10:FF:003803', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87124, NULL, 'G3DSA:1.10.287.370:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87125, NULL, 'G3DSA:2.60.420.10:FF:000010', NULL, NULL, 'Cellobionic acid phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(87126, NULL, 'G3DSA:2.30.40.10:FF:000172', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(87127, NULL, 'G3DSA:3.40.640.10:FF:000353', NULL, NULL, 'Lipopolysaccharide biosynthesis protein RfbH', NULL, NULL, NULL, NULL, NULL, 4),
(87128, NULL, 'G3DSA:3.30.200.20:FF:002225', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(87129, NULL, 'G3DSA:2.40.30.230:FF:000009', NULL, NULL, 'UPF1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(87130, NULL, 'G3DSA:4.10.1240.10:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87131, NULL, 'G3DSA:3.30.1330.30:FF:000039', NULL, NULL, '40S ribosomal protein S12', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(87132, NULL, 'G3DSA:3.40.50.300:FF:003577', NULL, NULL, 'Probable uridine-cytidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(87133, NULL, 'G3DSA:3.30.1490.110:FF:000010', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(87134, NULL, 'G3DSA:3.40.1170.60:FF:000022', NULL, NULL, 'DNA repair protein REV1', NULL, NULL, NULL, NULL, NULL, 4),
(87135, NULL, 'G3DSA:2.80.10.50:FF:000016', NULL, NULL, 'Ryanodine receptor 2 (Cardiac)', NULL, NULL, NULL, NULL, NULL, 4),
(87136, NULL, 'G3DSA:2.60.40.1910:FF:000025', NULL, NULL, 'Protein CBG08739', NULL, NULL, NULL, NULL, NULL, 4),
(87137, NULL, 'G3DSA:3.30.70.330:FF:002226', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87138, NULL, 'G3DSA:3.30.565.10:FF:000523', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(87139, NULL, 'G3DSA:3.40.50.300:FF:000851', NULL, NULL, 'Ras-related small GTP-binding family protein', NULL, NULL, NULL, NULL, NULL, 4),
(87140, NULL, 'G3DSA:1.10.287.2900:FF:000009', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(87141, NULL, 'G3DSA:3.30.1490.40:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87142, NULL, 'G3DSA:1.25.40.70:FF:000007', NULL, NULL, 'phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(87143, NULL, 'G3DSA:1.10.510.10:FF:001297', NULL, NULL, 'Receptor-like protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(87144, NULL, 'G3DSA:3.40.630.30:FF:000274', NULL, NULL, 'GNAT family N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(87145, NULL, 'G3DSA:2.30.30.30:FF:000093', NULL, NULL, 'LSU ribosomal protein L14E', NULL, NULL, NULL, NULL, NULL, 4),
(87146, NULL, 'G3DSA:3.30.50.10:FF:000131', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(87147, NULL, 'G3DSA:3.40.50.10330:FF:000064', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(87148, NULL, 'G3DSA:3.10.20.90:FF:000243', NULL, NULL, 'Nuclear protein localization protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(87149, NULL, 'G3DSA:6.10.250.3270:FF:000001', NULL, NULL, 'Putative proline dehydrogenase (Monofunctional)', NULL, NULL, NULL, NULL, NULL, 4),
(87150, NULL, 'G3DSA:3.30.160.60:FF:005785', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87151, NULL, 'G3DSA:2.40.160.180:FF:000007', NULL, NULL, 'Slr1163 protein', NULL, NULL, NULL, NULL, NULL, 4),
(87152, NULL, 'G3DSA:2.130.10.10:FF:004162', NULL, NULL, 'Pre-mRNA-processing factor 19 homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(87153, NULL, 'G3DSA:3.80.10.10:FF:000295', NULL, NULL, 'Tubulin-specific chaperone cofactor E-like', NULL, NULL, NULL, NULL, NULL, 4),
(87154, NULL, 'G3DSA:3.40.50.300:FF:002751', NULL, NULL, 'Cell division transport system ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(87155, NULL, 'G3DSA:3.30.420.10:FF:000395', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87156, NULL, 'G3DSA:1.50.40.10:FF:000151', NULL, NULL, 'LEU5p Mitochondrial carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(87157, NULL, 'G3DSA:1.20.5.320:FF:000020', NULL, NULL, 'Decoration protein gp12', NULL, NULL, NULL, NULL, NULL, 4),
(87158, NULL, 'G3DSA:3.30.160.60:FF:002042', NULL, NULL, 'Zinc finger and SCAN domain-containing protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(87159, NULL, 'G3DSA:1.25.40.10:FF:002249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87160, NULL, 'G3DSA:3.90.228.10:FF:000013', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(87161, NULL, 'G3DSA:3.30.1890.10:FF:000002', NULL, NULL, 'O-antigen chain length determinant protein', NULL, NULL, NULL, NULL, NULL, 4),
(87162, NULL, 'G3DSA:3.90.1640.10:FF:000026', NULL, NULL, 'ABL083Wp', NULL, NULL, NULL, NULL, NULL, 4),
(87163, NULL, 'G3DSA:3.50.50.60:FF:001286', NULL, NULL, 'Apoptosis-inducing factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(87164, NULL, 'G3DSA:3.40.720.10:FF:000045', NULL, NULL, 'GPI ethanolamine phosphate transferase 2', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(87165, NULL, 'G3DSA:3.40.50.10900:FF:000033', NULL, NULL, 'Proteasome assembly chaperone 2', NULL, NULL, NULL, NULL, NULL, 4),
(87166, NULL, 'G3DSA:3.30.160.60:FF:005476', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87167, NULL, 'G3DSA:2.60.120.200:FF:000529', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(87168, NULL, 'G3DSA:3.90.199.10:FF:000006', NULL, NULL, 'DNA topoisomerase (ATP-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4),
(87169, NULL, 'G3DSA:1.20.1070.10:FF:000202', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor', NULL, NULL, NULL, NULL, NULL, 4),
(87170, NULL, 'G3DSA:1.10.510.10:FF:001549', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(87171, NULL, 'G3DSA:3.90.70.10:FF:000186', NULL, NULL, 'Unplaced genomic scaffold supercont1.125, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(87172, NULL, 'G3DSA:2.120.10.80:FF:000181', NULL, NULL, 'Galactose oxidase/kelch repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(87173, NULL, 'G3DSA:2.120.10.30:FF:000317', NULL, NULL, 'Glucose dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(87174, NULL, 'G3DSA:3.40.50.300:FF:007871', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87175, NULL, 'G3DSA:1.10.472.130:FF:000038', NULL, NULL, 'Putative dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(87176, NULL, 'G3DSA:1.10.1070.11:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87177, NULL, 'G3DSA:1.10.10.60:FF:000098', NULL, NULL, 'Transcription factor LBX1', NULL, NULL, NULL, NULL, NULL, 4),
(87178, NULL, 'G3DSA:3.40.50.150:FF:000553', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87179, NULL, 'G3DSA:3.40.50.1010:FF:000080', NULL, NULL, 'rRNA processing Fcf1 Family Protein', NULL, NULL, NULL, NULL, NULL, 4),
(87180, NULL, 'G3DSA:1.10.150.50:FF:000033', NULL, NULL, 'Protein vts1, variant', NULL, NULL, NULL, NULL, NULL, 4),
(87181, NULL, 'G3DSA:3.30.200.20:FF:000724', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(87182, NULL, 'G3DSA:3.30.230.10:FF:000223', NULL, NULL, 'DNA repair protein RadA', NULL, NULL, NULL, NULL, NULL, 4),
(87183, NULL, 'G3DSA:3.90.1150.210:FF:000014', NULL, NULL, 'F-actin-capping protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(87184, NULL, 'G3DSA:2.40.50.140:FF:001279', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87185, NULL, 'G3DSA:3.40.50.12780:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87186, NULL, 'G3DSA:1.10.3430.10:FF:000014', NULL, NULL, 'Urea transporter DVU1160', NULL, NULL, NULL, NULL, NULL, 4),
(87187, NULL, 'G3DSA:1.10.580.10:FF:000042', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(87188, NULL, 'G3DSA:2.30.29.30:FF:000915', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87189, NULL, 'G3DSA:2.30.29.30:FF:000376', NULL, NULL, 'Exocyst complex component 8', NULL, NULL, NULL, NULL, NULL, 4),
(87190, NULL, 'G3DSA:1.25.10.10:FF:003057', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(87191, NULL, 'G3DSA:3.90.550.50:FF:000212', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(87192, NULL, 'G3DSA:3.30.160.60:FF:001053', NULL, NULL, 'zinc finger protein 382 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(87193, NULL, 'G3DSA:3.40.50.300:FF:008383', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(87194, NULL, 'G3DSA:2.60.40.10:FF:004274', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87195, NULL, 'G3DSA:3.10.450.220:FF:000002', NULL, NULL, '60S ribosome subunit biogenesis protein NIP7 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(87196, NULL, 'G3DSA:3.30.450.20:FF:000439', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87197, NULL, 'G3DSA:1.20.1250.20:FF:000635', NULL, NULL, 'Integral membrane transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(87198, NULL, 'G3DSA:1.10.1650.10:FF:000002', NULL, NULL, 'LSU ribosomal protein L19E', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(87199, NULL, 'G3DSA:3.30.200.20:FF:001236', NULL, NULL, 'AGC/RSK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(87200, NULL, 'G3DSA:3.40.630.10:FF:000263', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(87201, NULL, 'G3DSA:3.90.850.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87202, NULL, 'G3DSA:3.40.50.10090:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87203, NULL, 'G3DSA:2.130.10.10:FF:000114', NULL, NULL, 'zinc finger protein 106 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(87204, NULL, 'G3DSA:2.60.200.30:FF:000005', NULL, NULL, 'NAD+ kinase Utr1', NULL, NULL, NULL, NULL, NULL, 4),
(87205, NULL, 'G3DSA:1.10.10.540:FF:000007', NULL, NULL, 'RAD23 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(87206, NULL, 'G3DSA:2.60.120.10:FF:000425', NULL, NULL, 'At1g07750/F24B9_13', NULL, NULL, NULL, NULL, NULL, 4),
(87207, NULL, 'G3DSA:4.10.280.110:FF:000007', NULL, NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(87208, NULL, 'G3DSA:1.20.1250.20:FF:001568', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87209, NULL, 'G3DSA:1.25.40.20:FF:000780', NULL, NULL, 'BRCA1-associated RING domain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(87210, NULL, 'G3DSA:3.30.1120.10:FF:000023', NULL, NULL, 'Arylsulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(87211, NULL, 'G3DSA:2.10.25.10:FF:000778', NULL, NULL, 'Protein S', NULL, NULL, NULL, NULL, NULL, 4),
(87212, NULL, 'G3DSA:3.30.1120.30:FF:000029', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(87213, NULL, 'G3DSA:2.60.40.60:FF:000011', NULL, NULL, 'Cadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(87214, NULL, 'G3DSA:1.20.5.110:FF:000266', NULL, NULL, 'Qb+c-SNARE protein, SNAP25-family', NULL, NULL, NULL, NULL, NULL, 4),
(87215, NULL, 'G3DSA:3.40.50.720:FF:000988', NULL, NULL, 'Possible oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(87216, NULL, 'G3DSA:3.30.230.130:FF:000067', NULL, NULL, 'Ubiquitin-protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(87217, NULL, 'G3DSA:3.10.110.10:FF:000303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87218, NULL, 'G3DSA:2.130.10.10:FF:003779', NULL, NULL, 'WD repeat domain phosphoinositide-interacting protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(87219, NULL, 'G3DSA:2.60.120.10:FF:000318', NULL, NULL, 'Cyclic nucleotide-binding protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(87220, NULL, 'G3DSA:2.60.40.420:FF:000030', NULL, NULL, 'ephrin-A3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(87221, NULL, 'G3DSA:3.30.9.10:FF:000125', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(87222, NULL, 'G3DSA:3.30.70.330:FF:001956', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87223, NULL, 'G3DSA:1.25.40.20:FF:000341', NULL, NULL, 'Bromodomain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(87224, NULL, 'G3DSA:1.10.155.10:FF:000004', NULL, NULL, 'Chemotaxis protein methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(87225, NULL, 'G3DSA:2.60.120.1040:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87226, NULL, 'G3DSA:1.20.120.1240:FF:000049', NULL, NULL, 'Putative vacuolar sorting protein vps1 dynamin', NULL, NULL, NULL, NULL, NULL, 4),
(87227, NULL, 'G3DSA:3.30.200.20:FF:001713', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87228, NULL, 'G3DSA:3.40.50.300:FF:004802', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87229, NULL, 'G3DSA:1.25.40.10:FF:000451', NULL, NULL, 'mRNA splicing protein (Prp39), putative', NULL, NULL, NULL, NULL, NULL, 4),
(87230, NULL, 'G3DSA:1.10.630.10:FF:000743', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87231, NULL, 'G3DSA:3.40.50.12780:FF:000113', NULL, NULL, 'Beta-alanine-activating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(87232, NULL, 'G3DSA:3.40.50.300:FF:001929', NULL, NULL, 'Ras-related protein Rab-1A', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(87233, NULL, 'G3DSA:1.10.287.70:FF:000619', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87234, NULL, 'G3DSA:3.40.50.300:FF:003021', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(87235, NULL, 'G3DSA:1.20.1250.20:FF:000152', NULL, NULL, 'Plastidic glucose transporter 4', NULL, NULL, NULL, NULL, NULL, 4),
(87236, NULL, 'G3DSA:3.40.640.10:FF:000437', NULL, NULL, 'Aminoadipate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(87237, NULL, 'G3DSA:2.40.10.10:FF:000130', NULL, NULL, 'Chymotrypsinogen A', NULL, NULL, NULL, NULL, NULL, 4),
(87238, NULL, 'G3DSA:3.90.190.10:FF:000357', NULL, NULL, 'PTP/DSP-like', NULL, NULL, NULL, NULL, NULL, 4),
(87239, NULL, 'G3DSA:3.60.40.10:FF:000179', NULL, NULL, 'Probable two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(87240, NULL, 'G3DSA:2.60.40.10:FF:004167', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87241, NULL, 'G3DSA:3.30.70.890:FF:000011', NULL, NULL, 'Phosphomevalonate kinase, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(87242, NULL, 'G3DSA:3.50.50.60:FF:001263', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(87243, NULL, 'G3DSA:3.40.50.300:FF:001559', NULL, NULL, 'U3 small nucleolar RNA-associated protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(87244, NULL, 'G3DSA:3.30.1490.20:FF:000014', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(87245, NULL, 'G3DSA:2.40.30.10:FF:000457', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87246, NULL, 'G3DSA:1.10.510.10:FF:001089', NULL, NULL, 'Protein CBG12477', NULL, NULL, NULL, NULL, NULL, 4),
(87247, NULL, 'G3DSA:2.60.120.10:FF:000757', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87248, NULL, 'G3DSA:3.40.50.10990:FF:000003', NULL, NULL, 'GTP cyclohydrolase II', NULL, NULL, NULL, NULL, NULL, 4),
(87249, NULL, 'G3DSA:1.25.40.10:FF:004722', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87250, NULL, 'G3DSA:2.60.40.150:FF:000056', NULL, NULL, 'Protein kinase C epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(87251, NULL, 'G3DSA:3.40.50.1000:FF:000560', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87252, NULL, 'G3DSA:1.20.58.1120:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87253, NULL, 'G3DSA:3.40.720.10:FF:000281', NULL, NULL, 'GPI ethanolamine phosphate transferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(87254, NULL, 'G3DSA:3.90.79.10:FF:000076', NULL, NULL, 'Ap4A hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(87255, NULL, 'G3DSA:2.60.40.10:FF:005791', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87256, NULL, 'G3DSA:1.10.10.10:FF:002005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87257, NULL, 'G3DSA:3.10.20.310:FF:000028', NULL, NULL, 'Outer membrane protein assembly factor BamA', NULL, NULL, NULL, NULL, NULL, 4),
(87258, NULL, 'G3DSA:1.20.1740.10:FF:000158', NULL, NULL, 'General amino-acid permease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(87259, NULL, 'G3DSA:2.60.40.10:FF:005948', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87260, NULL, 'G3DSA:1.50.40.10:FF:000252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87261, NULL, 'G3DSA:1.10.4040.10:FF:000001', NULL, NULL, 'BlaI/MecI/CopY family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(87262, NULL, 'G3DSA:1.20.140.10:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87263, NULL, 'G3DSA:3.30.70.100:FF:000016', NULL, NULL, '(4S)-4-hydroxy-5-phosphonooxypentane-2,3-dione isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(87264, NULL, 'G3DSA:2.10.270.10:FF:000009', NULL, NULL, 'Dextransucrase', NULL, NULL, NULL, NULL, NULL, 4),
(87265, NULL, 'G3DSA:1.10.510.10:FF:000105', NULL, NULL, 'SRSF protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(87266, NULL, 'G3DSA:1.10.150.20:FF:000018', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(87267, NULL, 'G3DSA:1.20.58.2010:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87268, NULL, 'G3DSA:3.30.497.10:FF:000050', NULL, NULL, 'Putative non-inhibitory serpin-Z11', NULL, NULL, NULL, NULL, NULL, 4),
(87269, NULL, 'G3DSA:3.30.70.330:FF:002092', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87270, NULL, 'G3DSA:3.20.20.70:FF:000607', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87271, NULL, 'G3DSA:3.60.90.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87272, NULL, 'G3DSA:2.20.28.10:FF:000031', NULL, NULL, 'DNA replication licensing factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(87273, NULL, 'G3DSA:1.10.472.10:FF:000342', NULL, NULL, 'Cyclin D2, a', NULL, NULL, NULL, NULL, NULL, 4),
(87274, NULL, 'G3DSA:3.90.76.10:FF:000053', NULL, NULL, 'Oligopeptide ABC transporter, solute-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(87275, NULL, 'G3DSA:1.10.3380.30:FF:000010', NULL, NULL, 'DExH-box ATP-dependent RNA helicase DExH11', NULL, NULL, NULL, NULL, NULL, 4),
(87276, NULL, 'G3DSA:3.40.190.10:FF:000127', NULL, NULL, 'Thiamine ABC transporter, periplasmic binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(87277, NULL, 'G3DSA:3.30.40.10:FF:000557', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(87278, NULL, 'G3DSA:1.10.1050.10:FF:000001', NULL, NULL, '30S ribosomal protein S4', NULL, NULL, NULL, NULL, NULL, 4),
(87279, NULL, 'G3DSA:3.30.70.330:FF:000175', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein Q', NULL, NULL, NULL, NULL, NULL, 4),
(87280, NULL, 'G3DSA:2.60.40.10:FF:001896', NULL, NULL, 'Twitchin', NULL, NULL, NULL, NULL, NULL, 4),
(87281, NULL, 'G3DSA:1.20.1050.140:FF:000001', NULL, NULL, 'Heterodisulfide oxidoreductase, CCG domain pair-containing subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(87282, NULL, 'G3DSA:1.25.40.530:FF:000017', NULL, NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(87283, NULL, 'G3DSA:1.20.1460.10:FF:000013', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(87284, NULL, 'G3DSA:2.60.200.20:FF:000148', NULL, NULL, 'WGS project CABT00000000 data, contig 2.1', NULL, NULL, NULL, NULL, NULL, 4),
(87285, NULL, 'G3DSA:3.60.21.60:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87286, NULL, 'G3DSA:1.10.533.10:FF:000040', NULL, NULL, 'tumor necrosis factor receptor superfamily member 25', NULL, NULL, NULL, NULL, NULL, 4),
(87287, NULL, 'G3DSA:1.25.40.10:FF:002266', NULL, NULL, 'Uncharacterized protein B11O8.010', NULL, NULL, NULL, NULL, NULL, 4),
(87288, NULL, 'G3DSA:3.70.10.10:FF:000020', NULL, NULL, 'Checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(87289, NULL, 'G3DSA:1.20.1110.10:FF:000257', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87290, NULL, 'G3DSA:1.20.140.40:FF:000038', NULL, NULL, 'Plant invertase/pectin methylesterase inhibitor superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(87291, NULL, 'G3DSA:1.25.40.20:FF:000673', NULL, NULL, 'Protein ACCELERATED CELL DEATH 6', NULL, NULL, NULL, NULL, NULL, 4),
(87292, NULL, 'G3DSA:1.20.5.30:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87293, NULL, 'G3DSA:1.10.565.10:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87294, NULL, 'G3DSA:3.30.70.980:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87295, NULL, 'G3DSA:3.80.10.10:FF:003594', NULL, NULL, 'Protein CBG03304', NULL, NULL, NULL, NULL, NULL, 4),
(87296, NULL, 'G3DSA:3.30.1010.10:FF:000150', NULL, NULL, 'Acyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(87297, NULL, 'G3DSA:3.40.50.300:FF:001132', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(87298, NULL, 'G3DSA:1.10.510.10:FF:003983', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87299, NULL, 'G3DSA:2.60.40.1910:FF:000008', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(87300, NULL, 'G3DSA:3.90.70.10:FF:000663', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(87301, NULL, 'G3DSA:3.40.50.300:FF:000620', NULL, NULL, 'NEDD4-binding protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(87302, NULL, 'G3DSA:1.10.238.10:FF:000663', NULL, NULL, 'Probable calcium-binding protein CML25', NULL, NULL, NULL, NULL, NULL, 4),
(87303, NULL, 'G3DSA:3.30.60.30:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87304, NULL, 'G3DSA:1.20.1560.10:FF:000588', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87305, NULL, 'G3DSA:3.30.40.10:FF:001069', NULL, NULL, 'E4 SUMO-protein ligase PIAL1', NULL, NULL, NULL, NULL, NULL, 4),
(87306, NULL, 'G3DSA:2.60.260.20:FF:000124', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(87307, NULL, 'G3DSA:3.30.160.60:FF:004616', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87308, NULL, 'G3DSA:4.10.320.10:FF:000006', NULL, NULL, 'Acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(87309, NULL, 'G3DSA:1.25.10.10:FF:000623', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(87310, NULL, 'G3DSA:3.30.160.60:FF:006201', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87311, NULL, 'G3DSA:1.20.1070.10:FF:001686', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87312, NULL, 'G3DSA:1.20.1530.20:FF:000078', NULL, NULL, 'K transporter', NULL, NULL, NULL, NULL, NULL, 4),
(87313, NULL, 'G3DSA:3.30.450.40:FF:000125', NULL, NULL, 'Transcriptional regulator, IclR family', NULL, NULL, NULL, NULL, NULL, 4),
(87314, NULL, 'G3DSA:3.30.710.10:FF:000518', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(87315, NULL, 'G3DSA:3.30.9.10:FF:000232', NULL, NULL, 'FAD-dependent oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(87316, NULL, 'G3DSA:3.40.50.300:FF:000148', NULL, NULL, 'Nucleolar GTP-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(87317, NULL, 'G3DSA:1.20.1080.10:FF:000023', NULL, NULL, 'Prip, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(87318, NULL, 'G3DSA:3.30.160.60:FF:002834', NULL, NULL, 'Histone-lysine N-methyltransferase PRDM16', NULL, NULL, NULL, NULL, NULL, 4),
(87319, NULL, 'G3DSA:1.10.287.110:FF:000155', NULL, NULL, 'Apj1p', NULL, NULL, NULL, NULL, NULL, 4),
(87320, NULL, 'G3DSA:3.40.140.10:FF:000091', NULL, NULL, 'tRNA-specific adenosine deaminase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(87321, NULL, 'G3DSA:3.40.720.10:FF:000062', NULL, NULL, 'Probable sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(87322, NULL, 'G3DSA:3.30.160.60:FF:005105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87323, NULL, 'G3DSA:1.10.720.30:FF:000037', NULL, NULL, 'ATP-dependent DNA helicase II subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(87324, NULL, 'G3DSA:3.40.640.10:FF:000128', NULL, NULL, 'Serine hydroxymethyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(87325, NULL, 'G3DSA:3.30.70.1070:FF:000015', NULL, NULL, 'Sporulation-specific N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(87326, NULL, 'G3DSA:2.60.40.10:FF:002385', NULL, NULL, 'AGAP005471-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(87327, NULL, 'G3DSA:1.10.8.60:FF:000355', NULL, NULL, 'ATPase, AAA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(87328, NULL, 'G3DSA:2.10.70.80:FF:000015', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(87329, NULL, 'G3DSA:3.40.50.1400:FF:000011', NULL, NULL, 'Sirohydrochlorin cobaltochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(87330, NULL, 'G3DSA:3.80.10.10:FF:003605', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87331, NULL, 'G3DSA:3.30.1320.10:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87332, NULL, 'G3DSA:1.10.8.500:FF:000003', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(87333, NULL, 'G3DSA:1.20.120.340:FF:000008', NULL, NULL, 'Flagellar secretion chaperone FliS', NULL, NULL, NULL, NULL, NULL, 4),
(87334, NULL, 'G3DSA:3.40.50.150:FF:000300', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(87335, NULL, 'G3DSA:1.25.40.20:FF:001162', NULL, NULL, 'Zinc finger CCCH domain-containing protein 66', NULL, NULL, NULL, NULL, NULL, 4),
(87336, NULL, 'G3DSA:3.30.200.20:FF:000617', NULL, NULL, 'NIMA related kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(87337, NULL, 'G3DSA:4.10.800.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87338, NULL, 'G3DSA:3.30.230.10:FF:000116', NULL, NULL, 'Phosphomevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(87339, NULL, 'G3DSA:2.30.180.10:FF:000014', NULL, NULL, 'Stabilin 1', NULL, NULL, NULL, NULL, NULL, 4),
(87340, NULL, 'G3DSA:2.60.120.330:FF:000091', NULL, NULL, 'Oxidoreductase, 2og-fe(Ii) oxygenase family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(87341, NULL, 'G3DSA:1.10.510.10:FF:002241', NULL, NULL, 'Probable protein kinase DDB_G0291133', NULL, NULL, NULL, NULL, NULL, 4),
(87342, NULL, 'G3DSA:3.20.20.470:FF:000001', NULL, NULL, 'Inactive glucansucrase', NULL, NULL, NULL, NULL, NULL, 4),
(87343, NULL, 'G3DSA:2.130.10.10:FF:001418', NULL, NULL, 'Kinesin protein KIF21B', NULL, NULL, NULL, NULL, NULL, 4),
(87344, NULL, 'G3DSA:2.60.34.10:FF:000055', NULL, NULL, 'Heat shock protein 70 mitochondrial putative', NULL, NULL, NULL, NULL, NULL, 4),
(87345, NULL, 'G3DSA:2.60.40.10:FF:001873', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(87346, NULL, 'G3DSA:3.40.50.300:FF:003493', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(87347, NULL, 'G3DSA:2.120.10.30:FF:000424', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87348, NULL, 'G3DSA:2.40.50.140:FF:000986', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87349, NULL, 'G3DSA:3.30.70.330:FF:001164', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(87350, NULL, 'G3DSA:3.40.50.300:FF:007764', NULL, NULL, 'ABC Transporter family', NULL, NULL, NULL, NULL, NULL, 4),
(87351, NULL, 'G3DSA:1.20.58.1030:FF:000023', NULL, NULL, 'Probable DNA replication complex GINS protein PSF1', NULL, NULL, NULL, NULL, NULL, 4),
(87352, NULL, 'G3DSA:3.90.280.10:FF:000016', NULL, NULL, 'Protease inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(87353, NULL, 'G3DSA:3.40.50.450:FF:000053', NULL, NULL, 'Probable ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(87354, NULL, 'G3DSA:1.10.10.10:FF:000460', NULL, NULL, 'Two component transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(87355, NULL, 'G3DSA:3.30.260.10:FF:000051', NULL, NULL, 'T-complex protein 1 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(87356, NULL, 'G3DSA:2.60.40.10:FF:003655', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87357, NULL, 'G3DSA:3.30.30.30:FF:000023', NULL, NULL, 'LD21269p', NULL, NULL, NULL, NULL, NULL, 4),
(87358, NULL, 'G3DSA:3.40.30.10:FF:000831', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87359, NULL, 'G3DSA:3.40.50.300:FF:002857', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(87360, NULL, 'G3DSA:1.50.10.10:FF:000115', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(87361, NULL, 'G3DSA:3.20.20.80:FF:000829', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87362, NULL, 'G3DSA:3.40.50.11340:FF:000018', NULL, NULL, 'uncharacterized protein LOC100183376', NULL, NULL, NULL, NULL, NULL, 4),
(87363, NULL, 'G3DSA:3.30.160.60:FF:000434', NULL, NULL, 'zinc finger protein 30 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(87364, NULL, 'G3DSA:3.80.10.10:FF:000188', NULL, NULL, 'F-box protein SKP2B', NULL, NULL, NULL, NULL, NULL, 4),
(87365, NULL, 'G3DSA:3.30.70.270:FF:000140', NULL, NULL, 'Diguanylate cyclase-related enzyme', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(87366, NULL, 'G3DSA:3.50.40.10:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87367, NULL, 'G3DSA:3.40.50.360:FF:000054', NULL, NULL, 'NAD(P)H dehydrogenase, quinone 1', NULL, NULL, NULL, NULL, NULL, 4),
(87368, NULL, 'G3DSA:3.30.2010.10:FF:000015', NULL, NULL, 'M48 family peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(87369, NULL, 'G3DSA:1.20.940.10:FF:000017', NULL, NULL, 'Prp18 domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(87370, NULL, 'G3DSA:2.30.30.1020:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(87371, NULL, 'G3DSA:1.10.1820.10:FF:000021', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(87372, NULL, 'G3DSA:1.25.40.10:FF:003677', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87373, NULL, 'G3DSA:2.60.40.1180:FF:000177', NULL, NULL, 'Pullulanase 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(87374, NULL, 'G3DSA:3.40.390.10:FF:000108', NULL, NULL, 'A disintegrin and metallopeptidase domain 6', NULL, NULL, NULL, NULL, NULL, 4),
(87375, NULL, 'G3DSA:3.30.160.60:FF:006196', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87376, NULL, 'G3DSA:3.30.930.10:FF:000372', NULL, NULL, 'Polymerase (DNA directed), gamma 2, accessory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(87377, NULL, 'G3DSA:1.25.40.20:FF:000217', NULL, NULL, 'Ankyrin repeat-containing protein ITN1', NULL, NULL, NULL, NULL, NULL, 4),
(87378, NULL, 'G3DSA:3.30.70.330:FF:001473', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87379, NULL, 'G3DSA:1.10.940.10:FF:000025', NULL, NULL, 'Transcription antitermination protein NusB', NULL, NULL, NULL, NULL, NULL, 4),
(87380, NULL, 'G3DSA:3.40.50.300:FF:008164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87381, NULL, 'G3DSA:1.20.120.790:FF:000002', NULL, NULL, 'Molecular chaperone HtpG', NULL, NULL, NULL, NULL, NULL, 4),
(87382, NULL, 'G3DSA:3.30.40.10:FF:001602', NULL, NULL, 'Nitric oxide synthase-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(87383, NULL, 'G3DSA:1.10.3720.10:FF:000238', NULL, NULL, 'Sugar ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(87384, NULL, 'G3DSA:2.60.120.260:FF:000603', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(87385, NULL, 'G3DSA:3.10.100.10:FF:000224', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87386, NULL, 'G3DSA:3.40.50.720:FF:002438', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87387, NULL, 'G3DSA:2.10.50.30:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87388, NULL, 'G3DSA:3.30.70.80:FF:000023', NULL, NULL, 'Cerevisin', NULL, NULL, NULL, NULL, NULL, 4),
(87389, NULL, 'G3DSA:3.40.50.300:FF:002548', NULL, NULL, 'DNA kinase/phosphatase Pnk1', NULL, NULL, NULL, NULL, NULL, 4),
(87390, NULL, 'G3DSA:3.40.50.2300:FF:001579', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87391, NULL, 'G3DSA:1.10.418.10:FF:000065', NULL, NULL, 'p-loop nucleoside triphosphate hydrolase superfamily protein with CH (Calponin Homology) domain', NULL, NULL, NULL, NULL, NULL, 4),
(87392, NULL, 'G3DSA:2.130.10.10:FF:001525', NULL, NULL, 'WD domain, G-beta repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(87393, NULL, 'G3DSA:3.20.20.190:FF:000147', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87394, NULL, 'G3DSA:2.40.50.140:FF:000879', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87395, NULL, 'G3DSA:2.70.98.10:FF:000011', NULL, NULL, 'Putative glucose-6-phosphate 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(87396, NULL, 'G3DSA:3.40.50.2000:FF:000612', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(87397, NULL, 'G3DSA:1.10.510.10:FF:002022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87398, NULL, 'G3DSA:2.40.50.100:FF:000098', NULL, NULL, 'Rrp40p', NULL, NULL, NULL, NULL, NULL, 4),
(87399, NULL, 'G3DSA:3.40.50.2000:FF:001124', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(87400, NULL, 'G3DSA:3.40.50.300:FF:003476', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(87401, NULL, 'G3DSA:3.40.50.2000:FF:000270', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(87402, NULL, 'G3DSA:2.60.40.10:FF:003874', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87403, NULL, 'G3DSA:1.10.630.10:FF:000524', NULL, NULL, 'AGAP001443-PA', NULL, NULL, NULL, NULL, NULL, 4),
(87404, NULL, 'G3DSA:3.40.50.410:FF:000209', NULL, NULL, 'Ku70-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(87405, NULL, 'G3DSA:3.80.10.10:FF:002296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87406, NULL, 'G3DSA:3.30.160.60:FF:002615', NULL, NULL, 'Zinc finger protein 347', NULL, NULL, NULL, NULL, NULL, 4),
(87407, NULL, 'G3DSA:2.30.30.1190:FF:000012', NULL, NULL, 'Zinc finger CCCH domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(87408, NULL, 'G3DSA:3.10.290.10:FF:000006', NULL, NULL, 'U3 small nucleolar ribonucleoprotein IMP3', NULL, NULL, NULL, NULL, NULL, 4),
(87409, NULL, 'G3DSA:2.130.10.10:FF:005460', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87410, NULL, 'G3DSA:2.60.200.40:FF:000025', NULL, NULL, 'Diacylglycerol kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(87411, NULL, 'G3DSA:3.20.20.70:FF:000147', NULL, NULL, 'Phospho-2-dehydro-3-deoxyheptonate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(87412, NULL, 'G3DSA:1.10.10.2100:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87413, NULL, 'G3DSA:2.10.25.10:FF:000648', NULL, NULL, 'Crumbs, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(87414, NULL, 'G3DSA:3.30.40.10:FF:001855', NULL, NULL, 'E3 ubiquitin-protein ligase Os06g0535400', NULL, NULL, NULL, NULL, NULL, 4),
(87415, NULL, 'G3DSA:1.20.140.150:FF:000039', NULL, NULL, 'Neuronal SYmmetry', NULL, NULL, NULL, NULL, NULL, 4),
(87416, NULL, 'G3DSA:3.90.550.10:FF:000413', NULL, NULL, 'Zgc:172049 protein', NULL, NULL, NULL, NULL, NULL, 4),
(87417, NULL, 'G3DSA:3.20.20.100:FF:000177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87418, NULL, 'G3DSA:3.40.50.880:FF:000209', NULL, NULL, 'Glutamine amidotransferase class-I family protein', NULL, NULL, NULL, NULL, NULL, 4),
(87419, NULL, 'G3DSA:3.30.70.330:FF:002120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87420, NULL, 'G3DSA:1.25.10.10:FF:003130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87421, NULL, 'G3DSA:3.90.550.10:FF:000649', NULL, NULL, 'Si:ch211-135f11.5', NULL, NULL, NULL, NULL, NULL, 4),
(87422, NULL, 'G3DSA:3.40.50.720:FF:000858', NULL, NULL, 'Phthiocerol synthesis polyketide synthase type I PpsA', NULL, NULL, NULL, NULL, NULL, 4),
(87423, NULL, 'G3DSA:1.10.10.60:FF:001031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87424, NULL, 'G3DSA:3.40.50.300:FF:007219', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(87425, NULL, 'G3DSA:2.60.120.10:FF:000734', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87426, NULL, 'G3DSA:1.10.510.10:FF:002505', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87427, NULL, 'G3DSA:1.20.1280.290:FF:000035', NULL, NULL, 'Solute carrier family 50 member 1', NULL, NULL, NULL, NULL, NULL, 4),
(87428, NULL, 'G3DSA:2.130.10.10:FF:001042', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(87429, NULL, 'G3DSA:3.40.120.10:FF:000061', NULL, NULL, 'Putative phosphoglucomutase cytoplasmic 1', NULL, NULL, NULL, NULL, NULL, 4),
(87430, NULL, 'G3DSA:3.30.160.20:FF:000029', NULL, NULL, 'Peptidyl-tRNA hydrolase YaeJ', NULL, NULL, NULL, NULL, NULL, 4),
(87431, NULL, 'G3DSA:3.40.50.300:FF:007747', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87432, NULL, 'G3DSA:3.90.1180.10:FF:000007', NULL, NULL, '50S ribosomal protein L13', NULL, NULL, NULL, NULL, NULL, 4),
(87433, NULL, 'G3DSA:2.10.25.10:FF:001470', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(87434, NULL, 'G3DSA:3.30.160.60:FF:003784', NULL, NULL, 'Zinc finger and BTB domain-containing protein 40', NULL, NULL, NULL, NULL, NULL, 4),
(87435, NULL, 'G3DSA:3.20.20.80:FF:000392', NULL, NULL, 'Protein CBG22612', NULL, NULL, NULL, NULL, NULL, 4),
(87436, NULL, 'G3DSA:1.20.120.1110:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87437, NULL, 'G3DSA:1.10.20.10:FF:000286', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87438, NULL, 'G3DSA:4.10.280.10:FF:000053', NULL, NULL, 'BHLH transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(87439, NULL, 'G3DSA:3.40.50.720:FF:001477', NULL, NULL, 'Pyrroline-5-carboxylate reductase 3', NULL, NULL, NULL, NULL, NULL, 4),
(87440, NULL, 'G3DSA:3.90.1310.10:FF:000024', NULL, NULL, 'Penicillin-binding protein 4B', NULL, NULL, NULL, NULL, NULL, 4),
(87441, NULL, 'G3DSA:3.10.100.10:FF:000241', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87442, NULL, 'G3DSA:3.30.160.60:FF:000564', NULL, NULL, 'zinc finger protein 699', NULL, NULL, NULL, NULL, NULL, 4),
(87443, NULL, 'G3DSA:2.130.10.10:FF:000906', NULL, NULL, 'Autophagy-related protein 18b isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(87444, NULL, 'G3DSA:3.80.10.10:FF:001593', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(87445, NULL, 'G3DSA:1.20.1560.10:FF:000369', NULL, NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 8', NULL, NULL, NULL, NULL, NULL, 4),
(87446, NULL, 'G3DSA:3.40.50.150:FF:000536', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87447, NULL, 'G3DSA:2.40.50.140:FF:001026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87448, NULL, 'G3DSA:1.10.8.530:FF:000001', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(87449, NULL, 'G3DSA:1.10.472.10:FF:000235', NULL, NULL, 'Cyclin J, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(87450, NULL, 'G3DSA:1.10.3210.10:FF:000008', NULL, NULL, '3''-5'' exoribonuclease YhaM', NULL, NULL, NULL, NULL, NULL, 4),
(87451, NULL, 'G3DSA:3.40.50.300:FF:006910', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87452, NULL, 'G3DSA:1.10.472.130:FF:000055', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(87453, NULL, 'G3DSA:1.25.40.10:FF:002013', NULL, NULL, 'Pentatricopeptide repeat protein PPR868-14', NULL, NULL, NULL, NULL, NULL, 4),
(87454, NULL, 'G3DSA:3.40.50.300:FF:002543', NULL, NULL, 'DEAD boX helicase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(87455, NULL, 'G3DSA:3.10.20.90:FF:000827', NULL, NULL, 'Ubiquitin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(87456, NULL, 'G3DSA:2.10.25.10:FF:001267', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(87457, NULL, 'G3DSA:3.30.1370.110:FF:000017', NULL, NULL, 'Protein CBG07223', NULL, NULL, NULL, NULL, NULL, 4),
(87458, NULL, 'G3DSA:3.40.50.1380:FF:000038', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(87459, NULL, 'G3DSA:3.40.50.300:FF:007894', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87460, NULL, 'G3DSA:2.130.10.10:FF:003998', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87461, NULL, 'G3DSA:3.40.50.2300:FF:000404', NULL, NULL, 'Argonaut-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(87462, NULL, 'G3DSA:3.40.630.30:FF:000482', NULL, NULL, 'Slr1340 protein', NULL, NULL, NULL, NULL, NULL, 4),
(87463, NULL, 'G3DSA:1.25.40.10:FF:002805', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87464, NULL, 'G3DSA:2.30.29.30:FF:001404', NULL, NULL, 'Rho GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(87465, NULL, 'G3DSA:3.40.630.10:FF:000291', NULL, NULL, 'N-acetylated alpha-linked acidic dipeptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(87466, NULL, 'G3DSA:3.30.300.180:FF:000014', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(87467, NULL, 'G3DSA:1.20.1050.120:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(87468, NULL, 'G3DSA:3.30.50.10:FF:000030', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(87469, NULL, 'G3DSA:3.10.20.90:FF:000266', NULL, NULL, 'Ubiquilin-1', NULL, NULL, NULL, NULL, NULL, 4),
(87470, NULL, 'G3DSA:1.10.2000.10:FF:000088', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87471, NULL, 'G3DSA:3.30.160.60:FF:005577', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87472, NULL, 'G3DSA:3.10.20.90:FF:000451', NULL, NULL, 'ESX-3 secretion system protein EccD3', NULL, NULL, NULL, NULL, NULL, 4),
(87473, NULL, 'G3DSA:3.50.50.60:FF:000774', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(87474, NULL, 'G3DSA:3.40.225.10:FF:000012', NULL, NULL, 'L-fuculose-1-phosphate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(87475, NULL, 'G3DSA:1.10.150.110:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87476, NULL, 'G3DSA:3.40.50.720:FF:001005', NULL, NULL, 'Molybdopterin and thiamine biosynthesis dinucleotide-utilizing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(87477, NULL, 'G3DSA:3.40.50.300:FF:007399', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87478, NULL, 'G3DSA:3.30.1230.20:FF:000001', NULL, NULL, '40S ribosomal protein S21', NULL, NULL, NULL, NULL, NULL, 4),
(87479, NULL, 'G3DSA:3.10.20.230:FF:000010', NULL, NULL, 'Retinitis pigmentosa 1-like 1a', NULL, NULL, NULL, NULL, NULL, 4),
(87480, NULL, 'G3DSA:3.40.50.720:FF:001819', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87481, NULL, 'G3DSA:3.40.50.1820:FF:001435', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(87482, NULL, 'G3DSA:3.40.1110.10:FF:000447', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87483, NULL, 'G3DSA:2.130.10.10:FF:005887', NULL, NULL, 'AGAP013266-PA', NULL, NULL, NULL, NULL, NULL, 4),
(87484, NULL, 'G3DSA:3.10.450.10:FF:000008', NULL, NULL, 'Kininogen 1', NULL, NULL, NULL, NULL, NULL, 4),
(87485, NULL, 'G3DSA:3.30.1120.90:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87486, NULL, 'G3DSA:3.40.50.2300:FF:001107', NULL, NULL, 'Metabotropic glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(87487, NULL, 'G3DSA:2.80.10.50:FF:000207', NULL, NULL, 'Kunitz-type elastase inhibitor BrEI', NULL, NULL, NULL, NULL, NULL, 4),
(87488, NULL, 'G3DSA:3.40.190.10:FF:000346', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(87489, NULL, 'G3DSA:1.25.40.10:FF:004975', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87490, NULL, 'G3DSA:3.30.930.10:FF:000153', NULL, NULL, 'Glycine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(87491, NULL, 'G3DSA:3.30.1640.10:FF:000046', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(87492, NULL, 'G3DSA:1.10.10.1740:FF:000002', NULL, NULL, 'Transmembrane protein 14C', NULL, NULL, NULL, NULL, NULL, 4),
(87493, NULL, 'G3DSA:3.90.550.50:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87494, NULL, 'G3DSA:3.30.70.260:FF:000148', NULL, NULL, 'Threonine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(87495, NULL, 'G3DSA:3.40.1110.10:FF:000228', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87496, NULL, 'G3DSA:1.20.1280.50:FF:000011', NULL, NULL, 'F-box DNA helicase 1', NULL, NULL, NULL, NULL, NULL, 4),
(87497, NULL, 'G3DSA:1.10.800.10:FF:000015', NULL, NULL, 'Tyrosine/tryptophan monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(87498, NULL, 'G3DSA:1.25.10.10:FF:001005', NULL, NULL, 'Putative adaptin', NULL, NULL, NULL, NULL, NULL, 4),
(87499, NULL, 'G3DSA:3.40.50.300:FF:000750', NULL, NULL, 'Putative ATP-dependent RNA helicase DHX33', NULL, NULL, NULL, NULL, NULL, 4),
(87500, NULL, 'G3DSA:1.10.510.10:FF:004186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87501, NULL, 'G3DSA:3.30.300.10:FF:000015', NULL, NULL, 'S-adenosylmethionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(87502, NULL, 'G3DSA:1.20.1250.20:FF:000949', NULL, NULL, 'High-affinity nicotinic acid transporter', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(87503, NULL, 'G3DSA:3.90.190.10:FF:000352', NULL, NULL, 'Protein tyrosine phosphatase-like protein egg-3', NULL, NULL, NULL, NULL, NULL, 4),
(87504, NULL, 'G3DSA:3.40.190.10:FF:000599', NULL, NULL, 'Glutamate [NMDA] receptor subunit 3A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(87505, NULL, 'G3DSA:3.40.50.1820:FF:001654', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87506, NULL, 'G3DSA:3.40.50.2300:FF:001023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87507, NULL, 'G3DSA:3.30.230.130:FF:000062', NULL, NULL, 'Cullin 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(87508, NULL, 'G3DSA:2.60.40.10:FF:000912', NULL, NULL, 'Myeloid cell surface antigen CD33', NULL, NULL, NULL, NULL, NULL, 4),
(87509, NULL, 'G3DSA:3.80.10.10:FF:001340', NULL, NULL, 'Si:ch211-213a13.2', NULL, NULL, NULL, NULL, NULL, 4),
(87510, NULL, 'G3DSA:3.30.70.330:FF:003053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87511, NULL, 'G3DSA:2.60.210.10:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87512, NULL, 'G3DSA:3.90.79.10:FF:000059', NULL, NULL, 'Nucleoside diphosphate-linked moiety X motif 13', NULL, NULL, NULL, NULL, NULL, 4),
(87513, NULL, 'G3DSA:3.90.70.10:FF:000180', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(87514, NULL, 'G3DSA:3.40.20.10:FF:000117', NULL, NULL, 'GMF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(87515, NULL, 'G3DSA:1.20.120.720:FF:000015', NULL, NULL, 'Myosin I', NULL, NULL, NULL, NULL, NULL, 4),
(87516, NULL, 'G3DSA:1.10.3520.10:FF:000004', NULL, NULL, 'Glycolipid transfer protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(87517, NULL, 'G3DSA:3.30.70.20:FF:000135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87518, NULL, 'G3DSA:1.10.510.10:FF:002814', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87519, NULL, 'G3DSA:3.30.70.330:FF:001501', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87520, NULL, 'G3DSA:3.40.50.10810:FF:000225', NULL, NULL, 'DNA repair protein RAD5A', NULL, NULL, NULL, NULL, NULL, 4),
(87521, NULL, 'G3DSA:1.10.238.10:FF:000180', NULL, NULL, 'Calcium-dependent protein kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(87522, NULL, 'G3DSA:2.90.10.10:FF:000021', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(87523, NULL, 'G3DSA:2.30.30.140:FF:000350', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87524, NULL, 'G3DSA:1.10.510.10:FF:004495', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87525, NULL, 'G3DSA:2.160.20.70:FF:000025', NULL, NULL, 'Adenylyl cyclase-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(87526, NULL, 'G3DSA:3.30.830.10:FF:000117', NULL, NULL, 'Mitochondrial Processing Peptidase Alpha', NULL, NULL, NULL, NULL, NULL, 4),
(87527, NULL, 'G3DSA:1.20.1250.20:FF:001933', NULL, NULL, 'Putative drug resistence protein', NULL, NULL, NULL, NULL, NULL, 4),
(87528, NULL, 'G3DSA:2.60.40.10:FF:003790', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87529, NULL, 'G3DSA:3.90.180.10:FF:000076', NULL, NULL, 'Unplaced genomic scaffold supercont1.219, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(87530, NULL, 'G3DSA:3.40.50.970:FF:000208', NULL, NULL, 'Putative 2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(87531, NULL, 'G3DSA:1.10.420.10:FF:000025', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(87532, NULL, 'G3DSA:1.10.150.20:FF:000035', NULL, NULL, 'DNA polymerase gamma, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(87533, NULL, 'G3DSA:2.40.128.20:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87534, NULL, 'G3DSA:3.10.20.30:FF:000040', NULL, NULL, 'Putative GTP diphosphokinase RSH3, chloroplastic isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(87535, NULL, 'G3DSA:3.40.50.12710:FF:000036', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7', NULL, NULL, NULL, NULL, NULL, 4),
(87536, NULL, 'G3DSA:2.60.40.60:FF:000466', NULL, NULL, 'cadherin-89D', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(87537, NULL, 'G3DSA:1.25.10.10:FF:000168', NULL, NULL, 'LPS responsive beige-like anchor protein', NULL, NULL, NULL, NULL, NULL, 4),
(87538, NULL, 'G3DSA:3.40.50.620:FF:000598', NULL, NULL, 'Tryptophan--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(87539, NULL, 'G3DSA:3.30.200.20:FF:001489', NULL, NULL, 'Protein kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(87540, NULL, 'G3DSA:2.10.110.10:FF:000032', NULL, NULL, 'LIM/homeobox protein Lhx3', NULL, NULL, NULL, NULL, NULL, 4),
(87541, NULL, 'G3DSA:4.10.860.120:FF:000030', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(87542, NULL, 'G3DSA:3.20.180.20:FF:000044', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(87543, NULL, 'G3DSA:3.80.10.10:FF:001677', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87544, NULL, 'G3DSA:3.80.10.10:FF:002301', NULL, NULL, 'Centrosomal protein of 78 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(87545, NULL, 'G3DSA:3.40.50.150:FF:000772', NULL, NULL, 'O-methyltransferase tpcA', NULL, NULL, NULL, NULL, NULL, 4),
(87546, NULL, 'G3DSA:1.20.1110.10:FF:000004', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(87547, NULL, 'G3DSA:3.90.1210.10:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87548, NULL, 'G3DSA:3.30.530.20:FF:000064', NULL, NULL, 'Lachrymatory-factor synthase', NULL, NULL, NULL, NULL, NULL, 4),
(87549, NULL, 'G3DSA:1.10.10.60:FF:000103', NULL, NULL, 'Homeobox protein BarH-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(87550, NULL, 'G3DSA:3.40.395.10:FF:000007', NULL, NULL, 'sentrin-specific protease 5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(87551, NULL, 'G3DSA:2.30.29.30:FF:000932', NULL, NULL, 'Wiscott-Aldrich syndrome protein', NULL, NULL, NULL, NULL, NULL, 4),
(87552, NULL, 'G3DSA:2.130.10.10:FF:004931', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87553, NULL, 'G3DSA:2.60.40.10:FF:001401', NULL, NULL, 'immunoglobulin-like and fibronectin type III domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(87554, NULL, 'G3DSA:2.60.40.10:FF:003239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87555, NULL, 'G3DSA:3.40.120.10:FF:000089', NULL, NULL, 'Phosphomannomutase', NULL, NULL, NULL, NULL, NULL, 4),
(87556, NULL, 'G3DSA:3.30.60.90:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87557, NULL, 'G3DSA:1.10.8.60:FF:000439', NULL, NULL, 'YALI0C05038p', NULL, NULL, NULL, NULL, NULL, 4),
(87558, NULL, 'G3DSA:3.20.20.300:FF:000012', NULL, NULL, 'Exported beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(87559, NULL, 'G3DSA:3.30.1360.200:FF:000003', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(87560, NULL, 'G3DSA:2.130.10.10:FF:001834', NULL, NULL, 'WD repeat containing protein 48', NULL, NULL, NULL, NULL, NULL, 4),
(87561, NULL, 'G3DSA:3.30.420.40:FF:000606', NULL, NULL, 'Heat shock protein 70 putative', NULL, NULL, NULL, NULL, NULL, 4),
(87562, NULL, 'G3DSA:1.50.10.150:FF:000016', NULL, NULL, 'C4-dicarboxylate transporter/malic acid transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(87563, NULL, 'G3DSA:2.70.150.10:FF:000223', NULL, NULL, 'Ca2+ transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(87564, NULL, 'G3DSA:3.30.160.60:FF:002014', NULL, NULL, 'Zinc finger protein 835', NULL, NULL, NULL, NULL, NULL, 4),
(87565, NULL, 'G3DSA:3.40.190.10:FF:000262', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(87566, NULL, 'G3DSA:1.20.1730.10:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87567, NULL, 'G3DSA:3.40.50.300:FF:000603', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(87568, NULL, 'G3DSA:1.10.20.10:FF:000033', NULL, NULL, 'Transcription initiation factor TFIID complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(87569, NULL, 'G3DSA:3.80.10.10:FF:003622', NULL, NULL, 'Leucine-rich repeat-containing G-protein coupled receptor, lgr, putative', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(87570, NULL, 'G3DSA:2.40.160.110:FF:000015', NULL, NULL, 'uncharacterized protein LOC100185667', NULL, NULL, NULL, NULL, NULL, 4),
(87571, NULL, 'G3DSA:2.40.30.10:FF:000452', NULL, NULL, 'Eukaryotic translation initiation factor 2 gamma subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(87572, NULL, 'G3DSA:2.20.28.120:FF:000012', NULL, NULL, '50S ribosomal protein L33', NULL, NULL, NULL, NULL, NULL, 4),
(87573, NULL, 'G3DSA:1.20.1080.10:FF:000006', NULL, NULL, 'Formate transporter FocA', NULL, NULL, NULL, NULL, NULL, 4),
(87574, NULL, 'G3DSA:4.10.240.10:FF:000168', NULL, NULL, 'Zinc cluster DNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(87575, NULL, 'G3DSA:4.10.1110.10:FF:000004', NULL, NULL, 'AN1-type zinc finger protein 2B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(87576, NULL, 'G3DSA:3.40.140.10:FF:000074', NULL, NULL, 'Unplaced genomic scaffold supercont1.13, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(87577, NULL, 'G3DSA:1.10.238.10:FF:001141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87578, NULL, 'G3DSA:3.40.366.10:FF:000030', NULL, NULL, 'Putative polyketide synthase MbtD', NULL, NULL, NULL, NULL, NULL, 4),
(87579, NULL, 'G3DSA:1.20.1250.20:FF:001585', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(87580, NULL, 'G3DSA:1.20.5.110:FF:000283', NULL, NULL, 'Vesicle-associated membrane protein 723', NULL, NULL, NULL, NULL, NULL, 4),
(87581, NULL, 'G3DSA:2.30.30.1150:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87582, NULL, 'G3DSA:2.10.70.10:FF:000247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87583, NULL, 'G3DSA:3.20.20.70:FF:000602', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87584, NULL, 'G3DSA:1.10.555.10:FF:000219', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87585, NULL, 'G3DSA:2.70.150.10:FF:000184', NULL, NULL, 'Plasma membrane calcium-transporting ATPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(87586, NULL, 'G3DSA:3.40.50.300:FF:001924', NULL, NULL, 'GTP-binding protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(87587, NULL, 'G3DSA:3.40.50.2300:FF:000399', NULL, NULL, 'Taste 1 receptor member 1', NULL, NULL, NULL, NULL, NULL, 4),
(87588, NULL, 'G3DSA:3.30.230.70:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87589, NULL, 'G3DSA:3.90.70.10:FF:000556', NULL, NULL, 'Protein CBR-DUO-3', NULL, NULL, NULL, NULL, NULL, 4),
(87590, NULL, 'G3DSA:1.20.920.20:FF:000002', NULL, NULL, 'Cytoplasmic dynein 1 heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(87591, NULL, 'G3DSA:2.10.50.10:FF:000055', NULL, NULL, 'Cysteine repeat modular protein 2 PbCRM2', NULL, NULL, NULL, NULL, NULL, 4),
(87592, NULL, 'G3DSA:1.20.1250.20:FF:000079', NULL, NULL, 'Probable sugar efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(87593, NULL, 'G3DSA:1.50.10.10:FF:000087', NULL, NULL, 'WGS project CABT00000000 data, contig 2.13', NULL, NULL, NULL, NULL, NULL, 4),
(87594, NULL, 'G3DSA:3.90.1310.10:FF:000041', NULL, NULL, 'Penicillin-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(87595, NULL, 'G3DSA:3.30.1370.10:FF:000047', NULL, NULL, 'splicing factor-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(87596, NULL, 'G3DSA:2.170.16.10:FF:000036', NULL, NULL, 'ATP-dependent DNA helicase Hel308', NULL, NULL, NULL, NULL, NULL, 4),
(87597, NULL, 'G3DSA:3.30.63.20:FF:000006', NULL, NULL, '30S ribosomal protein S25e', NULL, NULL, NULL, NULL, NULL, 4),
(87598, NULL, 'G3DSA:1.20.140.40:FF:000010', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(87599, NULL, 'G3DSA:1.10.8.250:FF:000001', NULL, NULL, 'DNA polymerase III, gamma subunit-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(87600, NULL, 'G3DSA:3.40.50.980:FF:000015', NULL, NULL, 'Luciferin 4-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(87601, NULL, 'G3DSA:3.30.70.330:FF:000091', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(87602, NULL, 'G3DSA:1.10.357.10:FF:000063', NULL, NULL, 'Transcriptional regulator, TetR family', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(87603, NULL, 'G3DSA:3.40.449.10:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87604, NULL, 'G3DSA:1.10.510.10:FF:000240', NULL, NULL, 'Lectin-domain containing receptor kinase A4.3', NULL, NULL, NULL, NULL, NULL, 4),
(87605, NULL, 'G3DSA:3.40.50.720:FF:002410', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87606, NULL, 'G3DSA:3.30.70.1350:FF:000015', NULL, NULL, 'Cation diffusion facilitator family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(87607, NULL, 'G3DSA:2.40.50.140:FF:001043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87608, NULL, 'G3DSA:3.30.43.10:FF:000002', NULL, NULL, 'D-2-hydroxyglutarate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(87609, NULL, 'G3DSA:2.170.240.10:FF:000009', NULL, NULL, 'Collagen, type IV, alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(87610, NULL, 'G3DSA:2.30.42.10:FF:000114', NULL, NULL, 'protein scribble homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(87611, NULL, 'G3DSA:3.40.30.10:FF:000415', NULL, NULL, 'AhpC/TSA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(87612, NULL, 'G3DSA:2.60.40.640:FF:000107', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(87613, NULL, 'G3DSA:3.30.300.30:FF:000010', NULL, NULL, 'Enterobactin synthetase component F', NULL, NULL, NULL, NULL, NULL, 4),
(87614, NULL, 'G3DSA:1.25.40.20:FF:001089', NULL, NULL, 'VPS9 domain protein, putative (AFU_orthologue AFUA_1G09870)', NULL, NULL, NULL, NULL, NULL, 4),
(87615, NULL, 'G3DSA:2.30.30.40:FF:000534', NULL, NULL, 'Brain-specific angiogenesis inhibitor 1-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(87616, NULL, 'G3DSA:3.30.450.40:FF:000203', NULL, NULL, 'Adenylyl cyclase class-3/4/guanylyl cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(87617, NULL, 'G3DSA:3.30.70.20:FF:000051', NULL, NULL, 'Periplasmic [Fe] hydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(87618, NULL, 'G3DSA:3.30.830.10:FF:000084', NULL, NULL, 'Cym1p', NULL, NULL, NULL, NULL, NULL, 4),
(87619, NULL, 'G3DSA:1.25.40.10:FF:002244', NULL, NULL, 'Pentatricopeptide (PPR) repeat protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(87620, NULL, 'G3DSA:3.40.50.300:FF:002312', NULL, NULL, 'GPN-loop GTPase 3', NULL, NULL, NULL, NULL, NULL, 4),
(87621, NULL, 'G3DSA:4.10.860.10:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87622, NULL, 'G3DSA:3.40.50.300:FF:005494', NULL, NULL, 'ATP-dependent DEAD/H RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(87623, NULL, 'G3DSA:1.20.58.90:FF:000019', NULL, NULL, 'TSNARE that affects a late Golgi compartment', NULL, NULL, NULL, NULL, NULL, 4),
(87624, NULL, 'G3DSA:1.20.5.190:FF:000048', NULL, NULL, 'IQ motif containing B1', NULL, NULL, NULL, NULL, NULL, 4),
(87625, NULL, 'G3DSA:1.10.240.10:FF:000005', NULL, NULL, 'Tryptophan--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(87626, NULL, 'G3DSA:2.60.120.260:FF:000042', NULL, NULL, 'Reelin', NULL, NULL, NULL, NULL, NULL, 4),
(87627, NULL, 'G3DSA:1.20.1560.10:FF:000740', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87628, NULL, 'G3DSA:1.50.40.10:FF:000488', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87629, NULL, 'G3DSA:3.20.20.450:FF:000006', NULL, NULL, 'Cyclic diguanylate phosphodiesterase (EAL) domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(87630, NULL, 'G3DSA:3.30.420.10:FF:000743', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87631, NULL, 'G3DSA:1.20.1250.20:FF:001332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87632, NULL, 'G3DSA:3.30.420.110:FF:000003', NULL, NULL, 'mutS protein homolog 4', NULL, NULL, NULL, NULL, NULL, 4),
(87633, NULL, 'G3DSA:2.10.25.10:FF:000542', NULL, NULL, 'Laminin-like protein epi-1', NULL, NULL, NULL, NULL, NULL, 4),
(87634, NULL, 'G3DSA:3.80.10.10:FF:002897', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87635, NULL, 'G3DSA:3.30.470.20:FF:000210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(87636, NULL, 'G3DSA:2.130.10.10:FF:005095', NULL, NULL, 'WD repeat-containing protein 48 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(87637, NULL, 'G3DSA:2.130.10.10:FF:004476', NULL, NULL, 'Striatin', NULL, NULL, NULL, NULL, NULL, 4),
(87638, NULL, 'G3DSA:3.30.930.10:FF:000136', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(87639, NULL, 'G3DSA:1.25.10.10:FF:001112', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(87640, NULL, 'G3DSA:3.40.850.10:FF:000285', NULL, NULL, 'Si:dkey-26i13.8', NULL, NULL, NULL, NULL, NULL, 4),
(87641, NULL, 'G3DSA:2.80.10.50:FF:000247', NULL, NULL, 'Putative polypeptide N-acetylgalactosaminyltransferase 11', NULL, NULL, NULL, NULL, NULL, 4),
(87642, NULL, 'G3DSA:3.90.150.10:FF:000012', NULL, NULL, 'Serum resistance associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(87643, NULL, 'G3DSA:3.40.50.1000:FF:000413', NULL, NULL, 'Cytosolic IMP-GMP specific 5''-nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(87644, NULL, 'G3DSA:1.10.8.270:FF:000007', NULL, NULL, 'TBC1 domain family member 10A', NULL, NULL, NULL, NULL, NULL, 4),
(87645, NULL, 'G3DSA:3.80.10.10:FF:001368', NULL, NULL, 'Leucine-rich repeat receptor-like protein CLAVATA2', NULL, NULL, NULL, NULL, NULL, 4),
(87646, NULL, 'G3DSA:3.50.50.60:FF:000083', NULL, NULL, 'Geranylgeranyl diphosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(87647, NULL, 'G3DSA:3.30.160.60:FF:001289', NULL, NULL, 'Zinc finger protein 574', NULL, NULL, NULL, NULL, NULL, 4),
(87648, NULL, 'G3DSA:3.40.190.10:FF:000571', NULL, NULL, 'Oligopeptide ABC transporter, periplasmic oligopeptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(87649, NULL, 'G3DSA:1.10.8.20:FF:000006', NULL, NULL, 'Phosphatidylinositol/phosphatidylcholine transfer protein SFH3', NULL, NULL, NULL, NULL, NULL, 4),
(87650, NULL, 'G3DSA:3.30.160.60:FF:002379', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87651, NULL, 'G3DSA:1.25.40.10:FF:002721', NULL, NULL, 'Pentatricopeptide repeat domain 3', NULL, NULL, NULL, NULL, NULL, 4),
(87652, NULL, 'G3DSA:3.40.50.1820:FF:000687', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(87653, NULL, 'G3DSA:2.130.10.10:FF:002346', NULL, NULL, 'Transcriptional activator SPT8', NULL, NULL, NULL, NULL, NULL, 4),
(87654, NULL, 'G3DSA:1.20.58.1210:FF:000009', NULL, NULL, 'Exocyst complex component EXO84', NULL, NULL, NULL, NULL, NULL, 4),
(87655, NULL, 'G3DSA:1.10.3380.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87656, NULL, 'G3DSA:2.120.10.80:FF:000046', NULL, NULL, 'F-box/kelch-repeat protein At5g15710', NULL, NULL, NULL, NULL, NULL, 4),
(87657, NULL, 'G3DSA:3.40.50.620:FF:000020', NULL, NULL, 'Valine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(87658, NULL, 'G3DSA:2.40.10.10:FF:000366', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87659, NULL, 'G3DSA:3.40.50.2020:FF:000045', NULL, NULL, 'Phosphoribosyl pyrophosphate synthetase 2', NULL, NULL, NULL, NULL, NULL, 4),
(87660, NULL, 'G3DSA:1.10.630.10:FF:000507', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87661, NULL, 'G3DSA:3.40.50.10260:FF:000015', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(87662, NULL, 'G3DSA:1.10.1070.11:FF:000009', NULL, NULL, 'Putative serine/threonine-protein kinase ATR', NULL, NULL, NULL, NULL, NULL, 4),
(87663, NULL, 'G3DSA:3.30.1330.30:FF:000079', NULL, NULL, 'tRNA/rRNA metyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(87664, NULL, 'G3DSA:1.10.10.10:FF:001640', NULL, NULL, 'RNA polymerase sigma70 factor', NULL, NULL, NULL, NULL, NULL, 4),
(87665, NULL, 'G3DSA:1.20.5.620:FF:000003', NULL, NULL, 'ATP synthase subunit b', NULL, NULL, NULL, NULL, NULL, 4),
(87666, NULL, 'G3DSA:2.130.10.10:FF:000800', NULL, NULL, 'Related to S. pombe beta-transducin', NULL, NULL, NULL, NULL, NULL, 4),
(87667, NULL, 'G3DSA:3.40.50.620:FF:000492', NULL, NULL, 'Blr2135 protein', NULL, NULL, NULL, NULL, NULL, 4),
(87668, NULL, 'G3DSA:3.10.350.10:FF:000068', NULL, NULL, 'Cell wall glycyl-glycine endopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(87669, NULL, 'G3DSA:3.40.50.300:FF:004982', NULL, NULL, 'Deoxythymidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(87670, NULL, 'G3DSA:3.30.70.2460:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87671, NULL, 'G3DSA:1.20.1070.10:FF:000758', NULL, NULL, 'cadherin EGF LAG seven-pass G-type receptor 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(87672, NULL, 'G3DSA:3.10.20.90:FF:000373', NULL, NULL, 'Splicing factor 3A subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(87673, NULL, 'G3DSA:1.25.40.450:FF:000010', NULL, NULL, 'LOW QUALITY PROTEIN: nuclear pore complex protein Nup155', NULL, NULL, NULL, NULL, NULL, 4),
(87674, NULL, 'G3DSA:2.80.10.50:FF:000090', NULL, NULL, 'Kunitz-type inhibitor B', NULL, NULL, NULL, NULL, NULL, 4),
(87675, NULL, 'G3DSA:1.20.1060.20:FF:000008', NULL, NULL, 'Structural maintenance of chromosomes protein', NULL, NULL, NULL, NULL, NULL, 4),
(87676, NULL, 'G3DSA:3.30.710.10:FF:000389', NULL, NULL, 'Transcription factor Ken 2', NULL, NULL, NULL, NULL, NULL, 4),
(87677, NULL, 'G3DSA:3.90.640.10:FF:000078', NULL, NULL, 'Conserved hypothetical proline and threonine rich protein', NULL, NULL, NULL, NULL, NULL, 4),
(87678, NULL, 'G3DSA:1.10.30.10:FF:000112', NULL, NULL, 'Transcription factor 7-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(87679, NULL, 'G3DSA:3.40.50.10810:FF:000011', NULL, NULL, 'Transcriptional regulator ATRX homolog', NULL, NULL, NULL, NULL, NULL, 4),
(87680, NULL, 'G3DSA:2.60.40.60:FF:000775', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87681, NULL, 'G3DSA:2.160.20.10:FF:000119', NULL, NULL, 'Polygalacturonase', NULL, NULL, NULL, NULL, NULL, 4),
(87682, NULL, 'G3DSA:3.40.190.10:FF:000947', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87683, NULL, 'G3DSA:2.170.270.10:FF:000146', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(87684, NULL, 'G3DSA:1.20.144.10:FF:000139', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(87685, NULL, 'G3DSA:3.90.980.20:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87686, NULL, 'G3DSA:3.30.830.10:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87687, NULL, 'G3DSA:1.20.120.80:FF:000009', NULL, NULL, 'Cytochrome c oxidase, subunit III', NULL, NULL, NULL, NULL, NULL, 4),
(87688, NULL, 'G3DSA:3.20.20.80:FF:000375', NULL, NULL, 'Glycoside hydrolase family 5', NULL, NULL, NULL, NULL, NULL, 4),
(87689, NULL, 'G3DSA:2.10.70.10:FF:000163', NULL, NULL, 'C-type LECtin', NULL, NULL, NULL, NULL, NULL, 4),
(87690, NULL, 'G3DSA:3.30.70.60:FF:000012', NULL, NULL, 'Translation elongation factor EF1B/ribosomal protein S6 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(87691, NULL, 'G3DSA:3.90.80.10:FF:000017', NULL, NULL, 'Inorganic pyrophosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(87692, NULL, 'G3DSA:1.25.40.10:FF:004374', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g47530', NULL, NULL, NULL, NULL, NULL, 4),
(87693, NULL, 'G3DSA:1.20.140.100:FF:000013', NULL, NULL, 'Dynein heavy chain 10, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(87694, NULL, 'G3DSA:3.30.70.330:FF:002917', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87695, NULL, 'G3DSA:2.30.29.30:FF:000140', NULL, NULL, 'CDC42 binding protein kinase beta', NULL, NULL, NULL, NULL, NULL, 4),
(87696, NULL, 'G3DSA:1.20.5.4130:FF:000003', NULL, NULL, 'Pi-ta protein', NULL, NULL, NULL, NULL, NULL, 4),
(87697, NULL, 'G3DSA:2.160.20.10:FF:000030', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(87698, NULL, 'G3DSA:3.40.1260.10:FF:000003', NULL, NULL, 'DsrE/DsrF-like family protein', NULL, NULL, NULL, NULL, NULL, 4),
(87699, NULL, 'G3DSA:3.30.470.30:FF:000011', NULL, NULL, 'mRNA-capping enzyme subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(87700, NULL, 'G3DSA:3.30.70.330:FF:000776', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase E', NULL, NULL, NULL, NULL, NULL, 4),
(87701, NULL, 'G3DSA:1.10.238.10:FF:000899', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(87702, NULL, 'G3DSA:3.80.10.10:FF:001913', NULL, NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(87703, NULL, 'G3DSA:1.10.3730.20:FF:000040', NULL, NULL, 'Putative integral membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(87704, NULL, 'G3DSA:3.70.10.10:FF:000042', NULL, NULL, 'DNA polymerase processivity factor BMRF1', NULL, NULL, NULL, NULL, NULL, 4),
(87705, NULL, 'G3DSA:2.60.40.640:FF:000096', NULL, NULL, 'YALI0E29381p', NULL, NULL, NULL, NULL, NULL, 4),
(87706, NULL, 'G3DSA:1.10.1370.30:FF:000031', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(87707, NULL, 'G3DSA:2.60.40.10:FF:002694', NULL, NULL, 'Obscurin', NULL, NULL, NULL, NULL, NULL, 4),
(87708, NULL, 'G3DSA:3.30.1120.30:FF:000001', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(87709, NULL, 'G3DSA:1.10.20.10:FF:000264', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87710, NULL, 'G3DSA:1.10.287.110:FF:000464', NULL, NULL, 'AGAP006577-PA', NULL, NULL, NULL, NULL, NULL, 4),
(87711, NULL, 'G3DSA:1.10.533.10:FF:000276', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(87712, NULL, 'G3DSA:2.60.120.620:FF:000054', NULL, NULL, 'Prolyl 4-hydroxylase subunit alpha-1', NULL, NULL, NULL, NULL, NULL, 4),
(87713, NULL, 'G3DSA:3.30.160.60:FF:000581', NULL, NULL, 'zinc finger protein 346 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(87714, NULL, 'G3DSA:3.10.105.10:FF:000105', NULL, NULL, 'Putative ABC transporter solute binding lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(87715, NULL, 'G3DSA:1.25.10.10:FF:000387', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(87716, NULL, 'G3DSA:1.20.1110.10:FF:000021', NULL, NULL, 'Plasma membrane ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(87717, NULL, 'G3DSA:1.10.287.70:FF:000058', NULL, NULL, 'Potassium sodium-activated channel subfamily T member 2', NULL, NULL, NULL, NULL, NULL, 4),
(87718, NULL, 'G3DSA:3.30.200.20:FF:000056', NULL, NULL, 'Fibrillarin like 1', NULL, NULL, NULL, NULL, NULL, 4),
(87719, NULL, 'G3DSA:1.10.510.10:FF:001544', NULL, NULL, 'Protein CBG12075', NULL, NULL, NULL, NULL, NULL, 4),
(87720, NULL, 'G3DSA:3.40.50.2300:FF:001551', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87721, NULL, 'G3DSA:2.40.40.20:FF:000051', NULL, NULL, 'Probable oxidoreductase YyaE', NULL, NULL, NULL, NULL, NULL, 4),
(87722, NULL, 'G3DSA:2.10.90.10:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87723, NULL, 'G3DSA:2.40.30.10:FF:000002', NULL, NULL, 'Elongation factor Tu', NULL, NULL, NULL, NULL, NULL, 4),
(87724, NULL, 'G3DSA:3.40.20.10:FF:000134', NULL, NULL, 'TWF1 isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(87725, NULL, 'G3DSA:1.20.1070.10:FF:001377', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87726, NULL, 'G3DSA:1.20.900.10:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87727, NULL, 'G3DSA:3.40.50.300:FF:005746', NULL, NULL, 'Dynein-1-beta heavy chain, flagellar inner arm I1 complex', NULL, NULL, NULL, NULL, NULL, 4),
(87728, NULL, 'G3DSA:1.10.510.10:FF:003798', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87729, NULL, 'G3DSA:3.90.1150.10:FF:000489', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(87730, NULL, 'G3DSA:3.30.450.40:FF:000310', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(87731, NULL, 'G3DSA:4.10.240.10:FF:000185', NULL, NULL, 'YALI0F13321p', NULL, NULL, NULL, NULL, NULL, 4),
(87732, NULL, 'G3DSA:3.90.1150.10:FF:000034', NULL, NULL, 'Cysteine desulfurase', NULL, NULL, NULL, NULL, NULL, 4),
(87733, NULL, 'G3DSA:3.30.750.24:FF:000034', NULL, NULL, 'Sulfate anion transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(87734, NULL, 'G3DSA:3.30.70.330:FF:000411', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(87735, NULL, 'G3DSA:3.80.10.10:FF:001149', NULL, NULL, 'Relaxin family peptide receptor 1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(87736, NULL, 'G3DSA:1.20.120.350:FF:000073', NULL, NULL, 'Two pore segment channel 2', NULL, NULL, NULL, NULL, NULL, 4),
(87737, NULL, 'G3DSA:3.90.1290.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87738, NULL, 'G3DSA:3.30.200.20:FF:001258', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87739, NULL, 'G3DSA:1.10.287.110:FF:000340', NULL, NULL, 'DnaJ-like protein subfamily C member 28', NULL, NULL, NULL, NULL, NULL, 4),
(87740, NULL, 'G3DSA:3.10.180.10:FF:000105', NULL, NULL, '4-hydroxyphenylpyruvate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(87741, NULL, 'G3DSA:1.20.920.10:FF:000089', NULL, NULL, 'WD40 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(87742, NULL, 'G3DSA:1.10.400.10:FF:000007', NULL, NULL, 'Guanine nucleotide-binding protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(87743, NULL, 'G3DSA:3.40.50.300:FF:001907', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87744, NULL, 'G3DSA:2.70.98.10:FF:000084', NULL, NULL, 'Rhamnogalacturonate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(87745, NULL, 'G3DSA:3.30.565.10:FF:000107', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(87746, NULL, 'G3DSA:2.40.160.120:FF:000035', NULL, NULL, 'Oxysterol binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(87747, NULL, 'G3DSA:2.20.80.10:FF:000006', NULL, NULL, 'Apolipophorins', NULL, NULL, NULL, NULL, NULL, 4),
(87748, NULL, 'G3DSA:3.40.50.300:FF:002060', NULL, NULL, 'Rho family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(87749, NULL, 'G3DSA:3.40.50.720:FF:001027', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(87750, NULL, 'G3DSA:3.30.830.10:FF:000336', NULL, NULL, 'Os01g0779100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(87751, NULL, 'G3DSA:1.10.510.10:FF:003202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87752, NULL, 'G3DSA:3.30.40.10:FF:001939', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(87753, NULL, 'G3DSA:3.40.1550.10:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87754, NULL, 'G3DSA:3.80.10.10:FF:000749', NULL, NULL, 'F-box and leucine rich repeat protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(87755, NULL, 'G3DSA:3.30.530.20:FF:000142', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(87756, NULL, 'G3DSA:1.20.1250.20:FF:001113', NULL, NULL, 'Major facilitator superfamily permease', NULL, NULL, NULL, NULL, NULL, 4),
(87757, NULL, 'G3DSA:3.40.50.150:FF:001250', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87758, NULL, 'G3DSA:1.25.40.10:FF:001625', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(87759, NULL, 'G3DSA:1.20.120.1510:FF:000006', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(87760, NULL, 'G3DSA:1.10.135.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87761, NULL, 'G3DSA:1.10.490.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87762, NULL, 'G3DSA:3.30.230.130:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87763, NULL, 'G3DSA:1.10.3090.10:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87764, NULL, 'G3DSA:1.25.10.10:FF:002641', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87765, NULL, 'G3DSA:2.40.30.10:FF:000221', NULL, NULL, '50S ribosome-binding GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(87766, NULL, 'G3DSA:1.20.120.880:FF:000001', NULL, NULL, 'PAS domain-containing sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(87767, NULL, 'G3DSA:1.10.510.10:FF:000925', NULL, NULL, 'PEK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(87768, NULL, 'G3DSA:3.30.1520.10:FF:000099', NULL, NULL, 'Differentiation inhibitory kinase', NULL, NULL, NULL, NULL, NULL, 4),
(87769, NULL, 'G3DSA:3.40.50.300:FF:005185', NULL, NULL, 'Protein CBR-XBX-1', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(87770, NULL, 'G3DSA:3.30.420.10:FF:000378', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87771, NULL, 'G3DSA:3.30.565.10:FF:000096', NULL, NULL, 'Anti-sigma regulatory factor', NULL, NULL, NULL, NULL, NULL, 4),
(87772, NULL, 'G3DSA:3.40.50.1820:FF:001199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87773, NULL, 'G3DSA:2.10.25.10:FF:001812', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87774, NULL, 'G3DSA:3.40.50.2000:FF:000303', NULL, NULL, 'GDP-mannose-dependent alpha-mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(87775, NULL, 'G3DSA:2.60.120.290:FF:000146', NULL, NULL, 'GD12774', NULL, NULL, NULL, NULL, NULL, 4),
(87776, NULL, 'G3DSA:3.40.50.1820:FF:001519', NULL, NULL, 'Senescence-associated carboxylesterase 101', NULL, NULL, NULL, NULL, NULL, 4),
(87777, NULL, 'G3DSA:3.30.590.10:FF:000036', NULL, NULL, 'Type-3 glutamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(87778, NULL, 'G3DSA:2.60.120.970:FF:000052', NULL, NULL, 'Inhibin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(87779, NULL, 'G3DSA:3.30.160.60:FF:004268', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87780, NULL, 'G3DSA:3.30.40.10:FF:001254', NULL, NULL, 'Apoptosis inhibitor IAP, putative', NULL, NULL, NULL, NULL, NULL, 4),
(87781, NULL, 'G3DSA:3.30.450.50:FF:000004', NULL, NULL, 'vesicle-trafficking protein SEC22b', NULL, NULL, NULL, NULL, NULL, 4),
(87782, NULL, 'G3DSA:3.30.70.330:FF:003070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87783, NULL, 'G3DSA:1.20.58.60:FF:000696', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(87784, NULL, 'G3DSA:1.25.40.400:FF:000001', NULL, NULL, 'DNA-binding helix-turn-helix protein', NULL, NULL, NULL, NULL, NULL, 4),
(87785, NULL, 'G3DSA:1.10.8.50:FF:000021', NULL, NULL, 'Endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(87786, NULL, 'G3DSA:3.30.565.10:FF:000416', NULL, NULL, 'Hybrid signal transduction histidine kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(87787, NULL, 'G3DSA:1.10.1410.20:FF:000009', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(87788, NULL, 'G3DSA:2.102.10.10:FF:000043', NULL, NULL, 'Ferredoxin component', NULL, NULL, NULL, NULL, NULL, 4),
(87789, NULL, 'G3DSA:4.10.280.10:FF:000075', NULL, NULL, 'Transcription factor bHLH113 family', NULL, NULL, NULL, NULL, NULL, 4),
(87790, NULL, 'G3DSA:1.10.3810.10:FF:000015', NULL, NULL, 'Probable transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(87791, NULL, 'G3DSA:1.25.40.1040:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87792, NULL, 'G3DSA:3.40.50.880:FF:000064', NULL, NULL, 'Imidazole glycerol phosphate synthase subunit HisH', NULL, NULL, NULL, NULL, NULL, 4),
(87793, NULL, 'G3DSA:1.10.287.110:FF:000008', NULL, NULL, 'Co-chaperone protein HscB', NULL, NULL, NULL, NULL, NULL, 4),
(87794, NULL, 'G3DSA:3.30.160.60:FF:005892', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87795, NULL, 'G3DSA:3.30.70.270:FF:000168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87796, NULL, 'G3DSA:1.10.10.10:FF:000004', NULL, NULL, 'RNA polymerase sigma factor SigA', NULL, NULL, NULL, NULL, NULL, 4),
(87797, NULL, 'G3DSA:3.90.550.10:FF:000104', NULL, NULL, 'procollagen-lysine,2-oxoglutarate 5-dioxygenase 2 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(87798, NULL, 'G3DSA:3.40.50.2000:FF:000051', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(87799, NULL, 'G3DSA:3.30.450.20:FF:000355', NULL, NULL, 'Two-component sensor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(87800, NULL, 'G3DSA:1.10.520.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87801, NULL, 'G3DSA:2.60.40.10:FF:003346', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase C', NULL, NULL, NULL, NULL, NULL, 4),
(87802, NULL, 'G3DSA:1.10.238.10:FF:000972', NULL, NULL, 'Calcium-dependent protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(87803, NULL, 'G3DSA:2.60.40.420:FF:000013', NULL, NULL, 'basic blue protein-like', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(87804, NULL, 'G3DSA:3.90.480.20:FF:000006', NULL, NULL, 'Sulfite reductase (Ferredoxin)', NULL, NULL, NULL, NULL, NULL, 4),
(87805, NULL, 'G3DSA:2.40.50.90:FF:000201', NULL, NULL, 'Transcriptional coactivator-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(87806, NULL, 'G3DSA:3.30.40.10:FF:001378', NULL, NULL, 'BcDNA.GH10646', NULL, NULL, NULL, NULL, NULL, 4),
(87807, NULL, 'G3DSA:3.30.160.60:FF:000125', NULL, NULL, 'Putative zinc finger protein 143', NULL, NULL, NULL, NULL, NULL, 4),
(87808, NULL, 'G3DSA:1.25.40.10:FF:003446', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(87809, NULL, 'G3DSA:1.20.1070.10:FF:000197', NULL, NULL, 'Teleost multiple tissue opsin 2b', NULL, NULL, NULL, NULL, NULL, 4),
(87810, NULL, 'G3DSA:3.30.505.10:FF:000064', NULL, NULL, 'src-like-adapter 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(87811, NULL, 'G3DSA:3.10.20.90:FF:000934', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87812, NULL, 'G3DSA:3.40.1390.10:FF:000012', NULL, NULL, 'UDP-3-O-acylglucosamine N-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(87813, NULL, 'G3DSA:3.30.70.330:FF:002884', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87814, NULL, 'G3DSA:3.40.1390.30:FF:000018', NULL, NULL, 'Nif3-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(87815, NULL, 'G3DSA:3.40.50.300:FF:003240', NULL, NULL, 'Dicer-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(87816, NULL, 'G3DSA:3.30.450.80:FF:000002', NULL, NULL, 'DNA-binding transcriptional activator SdiA', NULL, NULL, NULL, NULL, NULL, 4),
(87817, NULL, 'G3DSA:3.90.550.10:FF:000560', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(87818, NULL, 'G3DSA:3.40.50.300:FF:000834', NULL, NULL, 'Multidrug ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(87819, NULL, 'G3DSA:3.30.160.60:FF:002273', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(87820, NULL, 'G3DSA:1.10.510.10:FF:002494', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87821, NULL, 'G3DSA:1.10.287.460:FF:000006', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase Mip', NULL, NULL, NULL, NULL, NULL, 4),
(87822, NULL, 'G3DSA:2.60.40.1120:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87823, NULL, 'G3DSA:1.20.58.830:FF:000026', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(87824, NULL, 'G3DSA:1.10.8.10:FF:000256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87825, NULL, 'G3DSA:2.130.10.10:FF:002907', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87826, NULL, 'G3DSA:3.30.70.120:FF:000011', NULL, NULL, 'CutA divalent cation tolerance homolog-like', NULL, NULL, NULL, NULL, NULL, 4),
(87827, NULL, 'G3DSA:3.80.10.10:FF:004010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87828, NULL, 'G3DSA:3.40.1810.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87829, NULL, 'G3DSA:3.30.160.60:FF:001997', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87830, NULL, 'G3DSA:3.30.70.330:FF:002209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87831, NULL, 'G3DSA:1.10.620.20:FF:000015', NULL, NULL, 'Ribonucleotide reductase M2 b', NULL, NULL, NULL, NULL, NULL, 4),
(87832, NULL, 'G3DSA:2.120.10.30:FF:000391', NULL, NULL, 'Low-density lipoprotein RecePtor related', NULL, NULL, NULL, NULL, NULL, 4),
(87833, NULL, 'G3DSA:3.80.10.10:FF:001604', NULL, NULL, 'Serine-threonine protein kinase plant-type', NULL, NULL, NULL, NULL, NULL, 4),
(87834, NULL, 'G3DSA:1.10.3720.10:FF:000132', NULL, NULL, 'ABC transporter permease subunit', NULL, NULL, NULL, NULL, NULL, 4),
(87835, NULL, 'G3DSA:1.10.10.10:FF:000313', NULL, NULL, 'double-stranded RNA-specific adenosine deaminase isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(87836, NULL, 'G3DSA:3.90.226.10:FF:000161', NULL, NULL, '3-methylcrotonoyl-CoA carboxylase beta subunit, putative', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(87837, NULL, 'G3DSA:3.30.1380.10:FF:000003', NULL, NULL, 'D-alanyl-D-alanine dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(87838, NULL, 'G3DSA:3.10.580.10:FF:000186', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(87839, NULL, 'G3DSA:2.40.50.140:FF:000059', NULL, NULL, 'S1 RNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(87840, NULL, 'G3DSA:1.10.10.10:FF:002022', NULL, NULL, 'Heat shock transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(87841, NULL, 'G3DSA:2.40.480.10:FF:000001', NULL, NULL, 'Allene oxide cyclase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(87842, NULL, 'G3DSA:2.10.25.10:FF:000851', NULL, NULL, 'Slit homolog 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(87843, NULL, 'G3DSA:1.20.58.60:FF:000567', NULL, NULL, 'AGAP007562-PA', NULL, NULL, NULL, NULL, NULL, 4),
(87844, NULL, 'G3DSA:3.80.10.10:FF:002773', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87845, NULL, 'G3DSA:3.30.200.20:FF:000308', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(87846, NULL, 'G3DSA:1.10.8.1310:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87847, NULL, 'G3DSA:1.25.40.10:FF:001316', NULL, NULL, 'Transmembrane and tetratricopeptide repeat containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(87848, NULL, 'G3DSA:3.90.470.10:FF:000031', NULL, NULL, '60S ribosomal protein L17-2', NULL, NULL, NULL, NULL, NULL, 4),
(87849, NULL, 'G3DSA:3.40.1380.20:FF:000043', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(87850, NULL, 'G3DSA:2.30.30.40:FF:000225', NULL, NULL, 'Phosphonoacetate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(87851, NULL, 'G3DSA:3.20.20.70:FF:000624', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87852, NULL, 'G3DSA:1.20.120.1910:FF:000042', NULL, NULL, 'Cysteinyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(87853, NULL, 'G3DSA:1.10.555.10:FF:000113', NULL, NULL, 'Glucosamine 6-phosphate N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(87854, NULL, 'G3DSA:3.90.45.10:FF:000026', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(87855, NULL, 'G3DSA:2.40.50.100:FF:000109', NULL, NULL, 'DNA-directed RNA polymerase subunit beta''', NULL, NULL, NULL, NULL, NULL, 4),
(87856, NULL, 'G3DSA:4.10.1000.10:FF:000119', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(87857, NULL, 'G3DSA:2.60.40.10:FF:002727', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(87858, NULL, 'G3DSA:3.40.50.150:FF:001626', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87859, NULL, 'G3DSA:3.40.50.10190:FF:000224', NULL, NULL, 'DNA repair protein, BRCT domain', NULL, NULL, NULL, NULL, NULL, 4),
(87860, NULL, 'G3DSA:1.20.1310.10:FF:000132', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87861, NULL, 'G3DSA:2.30.42.10:FF:000423', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87862, NULL, 'G3DSA:1.20.1070.10:FF:001158', NULL, NULL, 'G-protein coupled receptor moody', NULL, NULL, NULL, NULL, NULL, 4),
(87863, NULL, 'G3DSA:2.60.40.4100:FF:000002', NULL, NULL, 'Zona pellucida sperm-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(87864, NULL, 'G3DSA:3.40.50.1980:FF:000016', NULL, NULL, 'Fe(3+)-hydroxamate ABC transporter substrate-binding protein FhuD', NULL, NULL, NULL, NULL, NULL, 4),
(87865, NULL, 'G3DSA:2.130.10.10:FF:003526', NULL, NULL, 'Echinoderm microtubule associated protein like 6', NULL, NULL, NULL, NULL, NULL, 4),
(87866, NULL, 'G3DSA:3.40.630.10:FF:000302', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(87867, NULL, 'G3DSA:3.40.30.10:FF:000871', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(87868, NULL, 'G3DSA:3.40.50.2300:FF:001096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87869, NULL, 'G3DSA:3.10.105.10:FF:000072', NULL, NULL, 'Extracellular solute-binding protein family 5', NULL, NULL, NULL, NULL, NULL, 4),
(87870, NULL, 'G3DSA:2.40.10.230:FF:000005', NULL, NULL, 'H/ACA ribonucleoprotein complex subunit', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(87871, NULL, 'G3DSA:2.60.200.20:FF:000255', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(87872, NULL, 'G3DSA:3.40.1280.10:FF:000021', NULL, NULL, '23S rRNA (guanosine-2''-O-)-methyltransferase RlmB', NULL, NULL, NULL, NULL, NULL, 4),
(87873, NULL, 'G3DSA:2.60.40.10:FF:005347', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87874, NULL, 'G3DSA:2.60.40.60:FF:000230', NULL, NULL, 'Si:dkey-22o22.2', NULL, NULL, NULL, NULL, NULL, 4),
(87875, NULL, 'G3DSA:2.60.220.30:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87876, NULL, 'G3DSA:3.10.340.11:FF:000001', NULL, NULL, 'Methenyltetrahydromethanopterin cyclohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(87877, NULL, 'G3DSA:3.20.20.140:FF:000138', NULL, NULL, 'YALI0E14817p', NULL, NULL, NULL, NULL, NULL, 4),
(87878, NULL, 'G3DSA:1.10.565.10:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87879, NULL, 'G3DSA:1.20.1550.10:FF:000003', NULL, NULL, 'Probable disulfide formation protein', NULL, NULL, NULL, NULL, NULL, 4),
(87880, NULL, 'G3DSA:1.10.510.10:FF:003674', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87881, NULL, 'G3DSA:1.20.1280.20:FF:000013', NULL, NULL, 'Co-chaperone Hsc20', NULL, NULL, NULL, NULL, NULL, 4),
(87882, NULL, 'G3DSA:1.20.58.1780:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87883, NULL, 'G3DSA:3.40.50.1000:FF:000104', NULL, NULL, 'Trehalose 6-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(87884, NULL, 'G3DSA:1.25.10.10:FF:003366', NULL, NULL, 'Protein Mo25', NULL, NULL, NULL, NULL, NULL, 4),
(87885, NULL, 'G3DSA:1.20.1070.10:FF:000652', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87886, NULL, 'G3DSA:2.40.10.10:FF:000675', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87887, NULL, 'G3DSA:2.60.40.1180:FF:000093', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(87888, NULL, 'G3DSA:1.10.238.10:FF:000444', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 6/32', NULL, NULL, NULL, NULL, NULL, 4),
(87889, NULL, 'G3DSA:3.20.20.70:FF:000838', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87890, NULL, 'G3DSA:3.30.70.1230:FF:000125', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(87891, NULL, 'G3DSA:1.25.10.10:FF:000640', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(87892, NULL, 'G3DSA:3.30.559.30:FF:000121', NULL, NULL, 'Hydroxamate-type ferrichrome siderophore peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(87893, NULL, 'G3DSA:3.90.1600.10:FF:000035', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(87894, NULL, 'G3DSA:2.130.10.10:FF:002037', NULL, NULL, 'Os02g0539900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(87895, NULL, 'G3DSA:3.40.50.620:FF:000126', NULL, NULL, 'Valine--tRNA ligase chloroplastic/mitochondrial 2', NULL, NULL, NULL, NULL, NULL, 4),
(87896, NULL, 'G3DSA:3.50.50.60:FF:001156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87897, NULL, 'G3DSA:2.60.40.150:FF:000365', NULL, NULL, 'Pre-mRNA-splicing helicase BRR2', NULL, NULL, NULL, NULL, NULL, 4),
(87898, NULL, 'G3DSA:3.30.40.10:FF:000905', NULL, NULL, 'Protein CBR-NHL-2', NULL, NULL, NULL, NULL, NULL, 4),
(87899, NULL, 'G3DSA:2.130.10.10:FF:002222', NULL, NULL, 'Conserved WD40 and TPR repeat-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(87900, NULL, 'G3DSA:2.170.270.10:FF:000022', NULL, NULL, 'PR domain zinc finger protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(87901, NULL, 'G3DSA:3.40.50.300:FF:002621', NULL, NULL, 'Dethiobiotin synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(87902, NULL, 'G3DSA:3.60.110.10:FF:000056', NULL, NULL, 'Nitrilase-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(87903, NULL, 'G3DSA:2.60.40.10:FF:002930', NULL, NULL, 'Sensory AXon guidance', NULL, NULL, NULL, NULL, NULL, 4),
(87904, NULL, 'G3DSA:3.20.20.70:FF:000063', NULL, NULL, 'peroxisomal (S)-2-hydroxy-acid oxidase GLO1', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(87905, NULL, 'G3DSA:2.60.220.50:FF:000029', NULL, NULL, 'Polycystic kidney disease protein 1-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(87906, NULL, 'G3DSA:3.10.20.70:FF:000001', NULL, NULL, 'Glutamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(87907, NULL, 'G3DSA:4.10.1000.10:FF:000086', NULL, NULL, 'Zinc finger CCCH domain-containing protein 64', NULL, NULL, NULL, NULL, NULL, 4),
(87908, NULL, 'G3DSA:3.10.20.90:FF:000682', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87909, NULL, 'G3DSA:1.25.40.10:FF:003194', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(87910, NULL, 'G3DSA:2.60.120.920:FF:000043', NULL, NULL, 'Protein TRAUCO', NULL, NULL, NULL, NULL, NULL, 4),
(87911, NULL, 'G3DSA:2.170.120.12:FF:000025', NULL, NULL, 'DNA-directed RNA polymerase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(87912, NULL, 'G3DSA:1.10.1410.40:FF:000004', NULL, NULL, 'Interleukin enhancer-binding factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(87913, NULL, 'G3DSA:2.60.40.1730:FF:000078', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(87914, NULL, 'G3DSA:3.90.1770.10:FF:000002', NULL, NULL, 'Biotin carboxylase subunit of acetyl CoA carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(87915, NULL, 'G3DSA:2.40.30.10:FF:000474', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87916, NULL, 'G3DSA:3.40.630.10:FF:000032', NULL, NULL, 'Murein peptide amidase A', NULL, NULL, NULL, NULL, NULL, 4),
(87917, NULL, 'G3DSA:3.40.50.11530:FF:000008', NULL, NULL, 'Interleukin cytokine receptor-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(87918, NULL, 'G3DSA:1.25.10.10:FF:001477', NULL, NULL, 'Crescerin-like protein che-12', NULL, NULL, NULL, NULL, NULL, 4),
(87919, NULL, 'G3DSA:1.20.1250.20:FF:002097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87920, NULL, 'G3DSA:1.10.10.140:FF:000011', NULL, NULL, 'Cytochrome c oxidase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(87921, NULL, 'G3DSA:2.60.40.150:FF:000617', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(87922, NULL, 'G3DSA:2.60.120.200:FF:000501', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87923, NULL, 'G3DSA:1.20.1250.20:FF:000860', NULL, NULL, 'Major facilitator superfamily domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(87924, NULL, 'G3DSA:2.60.40.10:FF:005908', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87925, NULL, 'G3DSA:1.20.1070.10:FF:001922', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87926, NULL, 'G3DSA:3.30.70.330:FF:001029', NULL, NULL, 'Os06g0724600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(87927, NULL, 'G3DSA:3.40.630.30:FF:000038', NULL, NULL, 'PanD regulatory factor', NULL, NULL, NULL, NULL, NULL, 4),
(87928, NULL, 'G3DSA:1.10.730.10:FF:000127', NULL, NULL, 'Methionine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(87929, NULL, 'G3DSA:2.60.40.820:FF:000026', NULL, NULL, 'GD16690', NULL, NULL, NULL, NULL, NULL, 4),
(87930, NULL, 'G3DSA:2.30.30.380:FF:000056', NULL, NULL, 'Uncharacterized protein C4.03c', NULL, NULL, NULL, NULL, NULL, 4),
(87931, NULL, 'G3DSA:3.30.1650.10:FF:000001', NULL, NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit beta 2', NULL, NULL, NULL, NULL, NULL, 4),
(87932, NULL, 'G3DSA:1.10.730.20:FF:000006', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(87933, NULL, 'G3DSA:1.10.220.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87934, NULL, 'G3DSA:2.60.40.10:FF:002166', NULL, NULL, 'Protein borderless', NULL, NULL, NULL, NULL, NULL, 4),
(87935, NULL, 'G3DSA:3.30.70.940:FF:000032', NULL, NULL, 'Transcription termination/antitermination protein NusG', NULL, NULL, NULL, NULL, NULL, 4),
(87936, NULL, 'G3DSA:3.30.70.330:FF:001737', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87937, NULL, 'G3DSA:3.90.960.10:FF:000006', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(87938, NULL, 'G3DSA:3.30.160.60:FF:004723', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87939, NULL, 'G3DSA:3.60.21.10:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87940, NULL, 'G3DSA:1.25.40.20:FF:000234', NULL, NULL, 'ankyrin repeat domain-containing protein 37 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(87941, NULL, 'G3DSA:2.40.160.10:FF:000073', NULL, NULL, 'Outer membrane porin', NULL, NULL, NULL, NULL, NULL, 4),
(87942, NULL, 'G3DSA:1.20.1250.40:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87943, NULL, 'G3DSA:3.80.10.10:FF:000952', NULL, NULL, 'Leucine-rich repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(87944, NULL, 'G3DSA:1.20.1070.10:FF:001613', NULL, NULL, 'D(1B) dopamine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(87945, NULL, 'G3DSA:1.20.120.1910:FF:000019', NULL, NULL, 'Cysteinyl-tRNA synthetase, mitochondrial, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(87946, NULL, 'G3DSA:3.10.20.90:FF:000007', NULL, NULL, 'Serine/threonine-protein kinase WNK1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(87947, NULL, 'G3DSA:1.10.1200.10:FF:000053', NULL, NULL, 'PKS-NRPS hybrid synthetase psoA', NULL, NULL, NULL, NULL, NULL, 4),
(87948, NULL, 'G3DSA:3.90.190.10:FF:000588', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(87949, NULL, 'G3DSA:1.20.90.10:FF:000003', NULL, NULL, 'Group XIIB secretory phospholipase A2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(87950, NULL, 'G3DSA:3.40.30.10:FF:000163', NULL, NULL, 'UBX domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(87951, NULL, 'G3DSA:3.10.50.40:FF:000101', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(87952, NULL, 'G3DSA:3.60.21.10:FF:000023', NULL, NULL, 'Metallophosphoesterase mpped2', NULL, NULL, NULL, NULL, NULL, 4),
(87953, NULL, 'G3DSA:1.20.58.60:FF:000224', NULL, NULL, 'Spectrin beta chain, non-erythrocytic', NULL, NULL, NULL, NULL, NULL, 4),
(87954, NULL, 'G3DSA:3.10.330.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87955, NULL, 'G3DSA:3.30.365.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87956, NULL, 'G3DSA:3.30.200.20:FF:002186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87957, NULL, 'G3DSA:1.10.10.10:FF:000999', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(87958, NULL, 'G3DSA:3.40.50.300:FF:004201', NULL, NULL, 'Guanine nucleotide-binding protein-like alpha-10 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(87959, NULL, 'G3DSA:1.10.1170.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87960, NULL, 'G3DSA:2.60.40.10:FF:001766', NULL, NULL, 'Pre-IgM VH-region (AA-18 to 120)', NULL, NULL, NULL, NULL, NULL, 4),
(87961, NULL, 'G3DSA:3.30.1330.40:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87962, NULL, 'G3DSA:3.20.20.10:FF:000051', NULL, NULL, 'Arginine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(87963, NULL, 'G3DSA:3.20.20.70:FF:000282', NULL, NULL, 'Thiamine-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(87964, NULL, 'G3DSA:3.80.10.10:FF:000643', NULL, NULL, 'Receptor-like protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(87965, NULL, 'G3DSA:1.20.1280.50:FF:000084', NULL, NULL, 'EIN3-binding F-box protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(87966, NULL, 'G3DSA:2.40.50.140:FF:000514', NULL, NULL, 'Single-strand DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(87967, NULL, 'G3DSA:2.60.40.10:FF:006061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87968, NULL, 'G3DSA:3.90.550.50:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87969, NULL, 'G3DSA:1.10.287.820:FF:000002', NULL, NULL, 'Pickpocket 31', NULL, NULL, NULL, NULL, NULL, 4),
(87970, NULL, 'G3DSA:3.30.1540.10:FF:000010', NULL, NULL, 'Acyl-CoA transferase/carnitine dehydratase-like protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(87971, NULL, 'G3DSA:2.60.40.150:FF:000584', NULL, NULL, 'C2 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(87972, NULL, 'G3DSA:1.25.10.10:FF:002096', NULL, NULL, 'UvrB/uvrC motif family protein', NULL, NULL, NULL, NULL, NULL, 4),
(87973, NULL, 'G3DSA:1.25.40.10:FF:004031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87974, NULL, 'G3DSA:3.40.50.300:FF:006674', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(87975, NULL, 'G3DSA:3.40.50.1820:FF:000581', NULL, NULL, 'Os11g0431400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(87976, NULL, 'G3DSA:3.30.420.40:FF:000286', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(87977, NULL, 'G3DSA:3.30.360.10:FF:000013', NULL, NULL, 'Glucose-6-phosphate 1-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(87978, NULL, 'G3DSA:3.30.40.10:FF:000074', NULL, NULL, 'Ring finger protein 121', NULL, NULL, NULL, NULL, NULL, 4),
(87979, NULL, 'G3DSA:1.10.10.10:FF:001308', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(87980, NULL, 'G3DSA:2.60.120.260:FF:000148', NULL, NULL, 'Beta-galactosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(87981, NULL, 'G3DSA:2.20.25.10:FF:000081', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(87982, NULL, 'G3DSA:2.30.42.10:FF:000081', NULL, NULL, 'Ligand of Numb protein X 2', NULL, NULL, NULL, NULL, NULL, 4),
(87983, NULL, 'G3DSA:1.25.10.10:FF:002438', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87984, NULL, 'G3DSA:2.10.55.10:FF:000004', NULL, NULL, 'Cell surface protease gp63, putative', NULL, NULL, NULL, NULL, NULL, 4),
(87985, NULL, 'G3DSA:1.25.40.10:FF:000012', NULL, NULL, 'PEX5-related protein isoform 5', NULL, NULL, NULL, NULL, NULL, 4),
(87986, NULL, 'G3DSA:1.10.10.160:FF:000017', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(87987, NULL, 'G3DSA:2.70.170.10:FF:000095', NULL, NULL, 'Proton-gated ion channel', NULL, NULL, NULL, NULL, NULL, 4),
(87988, NULL, 'G3DSA:3.30.70.330:FF:001580', NULL, NULL, 'YALI0A02981p', NULL, NULL, NULL, NULL, NULL, 4),
(87989, NULL, 'G3DSA:1.20.120.1150:FF:000011', NULL, NULL, 'Serine/threonine-protein phosphatase 2A activator', NULL, NULL, NULL, NULL, NULL, 4),
(87990, NULL, 'G3DSA:3.30.160.60:FF:003762', NULL, NULL, 'Zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(87991, NULL, 'G3DSA:1.10.405.20:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87992, NULL, 'G3DSA:3.40.30.10:FF:000724', NULL, NULL, 'Glutathione S-Transferase, Omega class', NULL, NULL, NULL, NULL, NULL, 4),
(87993, NULL, 'G3DSA:1.50.40.10:FF:000179', NULL, NULL, 'S-adenosylmethionine carrier 1, chloroplastic/mitochondrial isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(87994, NULL, 'G3DSA:1.10.510.10:FF:004506', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87995, NULL, 'G3DSA:2.40.50.690:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(87996, NULL, 'G3DSA:3.30.40.10:FF:001833', NULL, NULL, 'RNA binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(87997, NULL, 'G3DSA:2.20.130.20:FF:000005', NULL, NULL, 'Complement 4B (Chido blood group)', NULL, NULL, NULL, NULL, NULL, 4),
(87998, NULL, 'G3DSA:2.40.70.10:FF:000342', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(87999, NULL, 'G3DSA:1.25.40.10:FF:000136', NULL, NULL, 'Tetratricopeptide repeat domain 26', NULL, NULL, NULL, NULL, NULL, 4),
(88000, NULL, 'G3DSA:3.40.50.1260:FF:000042', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(88001, NULL, 'G3DSA:3.40.50.360:FF:000161', NULL, NULL, 'NADPH--cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(88002, NULL, 'G3DSA:3.40.50.790:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88003, NULL, 'G3DSA:1.25.40.10:FF:000321', NULL, NULL, 'pentatricopeptide repeat-containing protein 1, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(88004, NULL, 'G3DSA:3.20.20.70:FF:000591', NULL, NULL, 'Acyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(88005, NULL, 'G3DSA:1.25.40.10:FF:003755', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88006, NULL, 'G3DSA:2.30.29.30:FF:001079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88007, NULL, 'G3DSA:3.40.30.10:FF:001124', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(88008, NULL, 'G3DSA:3.30.70.330:FF:001395', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(88009, NULL, 'G3DSA:4.10.410.10:FF:000092', NULL, NULL, 'Kunitz-type serine protease inhibitor Bt-KTI', NULL, NULL, NULL, NULL, NULL, 4),
(88010, NULL, 'G3DSA:3.40.50.1820:FF:000215', NULL, NULL, 'Lysosomal thioesterase PPT2-B', NULL, NULL, NULL, NULL, NULL, 4),
(88011, NULL, 'G3DSA:3.40.50.10490:FF:000090', NULL, NULL, 'Transcriptional regulator, RpiR family', NULL, NULL, NULL, NULL, NULL, 4),
(88012, NULL, 'G3DSA:1.10.10.10:FF:001617', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88013, NULL, 'G3DSA:3.65.10.20:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88014, NULL, 'G3DSA:3.40.605.10:FF:000103', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(88015, NULL, 'G3DSA:1.20.58.760:FF:000005', NULL, NULL, 'ATP-dependent zinc metalloprotease FTSH 10, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(88016, NULL, 'G3DSA:1.20.1170.10:FF:000002', NULL, NULL, 'Non-hemolytic enterotoxin A', NULL, NULL, NULL, NULL, NULL, 4),
(88017, NULL, 'G3DSA:2.130.10.10:FF:003195', NULL, NULL, 'Ribosome biogenesis protein WDR12 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(88018, NULL, 'G3DSA:1.25.40.10:FF:002474', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g22150, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(88019, NULL, 'G3DSA:3.30.160.60:FF:005920', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88020, NULL, 'G3DSA:3.30.200.20:FF:002326', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88021, NULL, 'G3DSA:3.90.70.10:FF:000871', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88022, NULL, 'G3DSA:2.20.25.10:FF:000002', NULL, NULL, 'UPF0434 protein YcaR', NULL, NULL, NULL, NULL, NULL, 4),
(88023, NULL, 'G3DSA:2.10.25.10:FF:000194', NULL, NULL, 'Latent transforming growth factor beta binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(88024, NULL, 'G3DSA:3.40.30.10:FF:000067', NULL, NULL, 'Protein disulfide-isomerase A4', NULL, NULL, NULL, NULL, NULL, 4),
(88025, NULL, 'G3DSA:3.80.10.10:FF:003274', NULL, NULL, 'Toll-like receptor22', NULL, NULL, NULL, NULL, NULL, 4),
(88026, NULL, 'G3DSA:1.50.10.10:FF:000216', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(88027, NULL, 'G3DSA:3.40.1400.10:FF:000003', NULL, NULL, 'Ribose 5-phosphate isomerase B', NULL, NULL, NULL, NULL, NULL, 4),
(88028, NULL, 'G3DSA:2.40.50.140:FF:000301', NULL, NULL, 'Replication protein A', NULL, NULL, NULL, NULL, NULL, 4),
(88029, NULL, 'G3DSA:3.10.105.10:FF:000089', NULL, NULL, 'Xyloglucan ABC transport system, sugar-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(88030, NULL, 'G3DSA:3.40.50.2300:FF:000371', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(88031, NULL, 'G3DSA:1.10.1420.10:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88032, NULL, 'G3DSA:1.25.40.10:FF:005228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88033, NULL, 'G3DSA:1.25.40.1030:FF:000046', NULL, NULL, 'Im:7147241 protein', NULL, NULL, NULL, NULL, NULL, 4),
(88034, NULL, 'G3DSA:1.10.8.720:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88035, NULL, 'G3DSA:2.80.10.50:FF:000011', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(88036, NULL, 'G3DSA:3.40.50.1000:FF:000649', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88037, NULL, 'G3DSA:3.80.10.10:FF:001132', NULL, NULL, 'Probable inactive leucine-rich repeat receptor-like protein kinase At1g66830', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(88038, NULL, 'G3DSA:3.90.470.20:FF:000051', NULL, NULL, 'Phosphopantetheinyl transferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(88039, NULL, 'G3DSA:1.10.510.10:FF:000004', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(88040, NULL, 'G3DSA:3.30.40.10:FF:000877', NULL, NULL, 'RING-H2 finger protein ATL52', NULL, NULL, NULL, NULL, NULL, 4),
(88041, NULL, 'G3DSA:3.40.390.10:FF:000007', NULL, NULL, 'Collagenase 3', NULL, NULL, NULL, NULL, NULL, 4),
(88042, NULL, 'G3DSA:3.40.50.1000:FF:000071', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(88043, NULL, 'G3DSA:3.30.160.60:FF:001637', NULL, NULL, 'zinc finger and BTB domain-containing protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(88044, NULL, 'G3DSA:3.30.160.60:FF:002143', NULL, NULL, 'zinc finger protein 623', NULL, NULL, NULL, NULL, NULL, 4),
(88045, NULL, 'G3DSA:3.30.70.3400:FF:000012', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(88046, NULL, 'G3DSA:1.10.287.110:FF:000368', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88047, NULL, 'G3DSA:3.40.1000.10:FF:000006', NULL, NULL, 'PsbP domain-containing protein 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(88048, NULL, 'G3DSA:3.30.830.10:FF:000325', NULL, NULL, 'Protein CBG17023', NULL, NULL, NULL, NULL, NULL, 4),
(88049, NULL, 'G3DSA:1.20.1070.10:FF:001366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88050, NULL, 'G3DSA:2.130.10.10:FF:002801', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit TRM82', NULL, NULL, NULL, NULL, NULL, 4),
(88051, NULL, 'G3DSA:1.10.510.10:FF:004175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88052, NULL, 'G3DSA:2.70.130.10:FF:000070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88053, NULL, 'G3DSA:2.60.40.10:FF:000569', NULL, NULL, 'obscurin-like protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(88054, NULL, 'G3DSA:1.20.58.60:FF:000679', NULL, NULL, 'Beta-H spectrin', NULL, NULL, NULL, NULL, NULL, 4),
(88055, NULL, 'G3DSA:3.30.160.60:FF:002582', NULL, NULL, 'CCCTC-binding factor (zinc finger protein)', NULL, NULL, NULL, NULL, NULL, 4),
(88056, NULL, 'G3DSA:2.70.170.10:FF:000078', NULL, NULL, 'Gamma-aminobutyric acid receptor subunit alpha-4', NULL, NULL, NULL, NULL, NULL, 4),
(88057, NULL, 'G3DSA:2.40.128.180:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88058, NULL, 'G3DSA:3.30.1450.10:FF:000003', NULL, NULL, 'Outer membrane protein assembly factor BamE', NULL, NULL, NULL, NULL, NULL, 4),
(88059, NULL, 'G3DSA:1.25.10.10:FF:000308', NULL, NULL, 'U-box domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(88060, NULL, 'G3DSA:3.40.720.10:FF:000382', NULL, NULL, 'Secreted ectonucleotide pyrophosphatase/phosphodiesterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88061, NULL, 'G3DSA:3.30.40.10:FF:002108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88062, NULL, 'G3DSA:3.40.50.300:FF:005741', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(88063, NULL, 'G3DSA:3.90.1070.20:FF:000002', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(88064, NULL, 'G3DSA:3.40.850.10:FF:000043', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(88065, NULL, 'G3DSA:1.10.472.10:FF:000111', NULL, NULL, 'Unplaced genomic scaffold supercont1.6, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(88066, NULL, 'G3DSA:1.10.150.50:FF:000134', NULL, NULL, 'ets protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(88067, NULL, 'G3DSA:2.60.40.10:FF:001997', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(88068, NULL, 'G3DSA:3.40.50.1100:FF:000224', NULL, NULL, 'Threonine dehydratase biosynthetic, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(88069, NULL, 'G3DSA:1.20.5.190:FF:000150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88070, NULL, 'G3DSA:3.20.20.220:FF:000078', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(88071, NULL, 'G3DSA:3.40.525.10:FF:000046', NULL, NULL, 'CRAL/TRIO domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88072, NULL, 'G3DSA:4.10.1240.10:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88073, NULL, 'G3DSA:3.30.160.20:FF:000001', NULL, NULL, '30S ribosomal protein S5', NULL, NULL, NULL, NULL, NULL, 4),
(88074, NULL, 'G3DSA:1.10.510.10:FF:002033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88075, NULL, 'G3DSA:2.60.40.150:FF:000376', NULL, NULL, 'Protein CBR-SNT-6', NULL, NULL, NULL, NULL, NULL, 4),
(88076, NULL, 'G3DSA:1.20.1070.10:FF:000961', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(88077, NULL, 'G3DSA:4.10.75.10:FF:000001', NULL, NULL, 'Anosmin 1', NULL, NULL, NULL, NULL, NULL, 4),
(88078, NULL, 'G3DSA:3.30.160.40:FF:000007', NULL, NULL, 'Porphobilinogen deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(88079, NULL, 'G3DSA:3.30.410.40:FF:000004', NULL, NULL, 'Oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88080, NULL, 'G3DSA:3.40.605.10:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88081, NULL, 'G3DSA:1.10.533.10:FF:000271', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 10b', NULL, NULL, NULL, NULL, NULL, 4),
(88082, NULL, 'G3DSA:3.90.1640.10:FF:000021', NULL, NULL, 'Exopolyphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(88083, NULL, 'G3DSA:3.40.980.10:FF:000030', NULL, NULL, 'Molybdenum cofactor synthesis domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(88084, NULL, 'G3DSA:3.65.10.10:FF:000032', NULL, NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(88085, NULL, 'G3DSA:3.40.50.300:FF:007186', NULL, NULL, 'Rac3A protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88086, NULL, 'G3DSA:3.40.225.10:FF:000001', NULL, NULL, 'L-ribulose-5-phosphate 4-epimerase UlaF', NULL, NULL, NULL, NULL, NULL, 4),
(88087, NULL, 'G3DSA:1.25.10.10:FF:002646', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(88088, NULL, 'G3DSA:3.40.50.620:FF:000834', NULL, NULL, 'Valyl tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88089, NULL, 'G3DSA:1.20.58.60:FF:000584', NULL, NULL, 'Plectin', NULL, NULL, NULL, NULL, NULL, 4),
(88090, NULL, 'G3DSA:3.40.30.10:FF:001023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(88091, NULL, 'G3DSA:2.60.40.10:FF:005471', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88092, NULL, 'G3DSA:3.30.750.24:FF:000017', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(88093, NULL, 'G3DSA:3.40.430.10:FF:000051', NULL, NULL, 'Riboflavin biosynthesis protein RibD', NULL, NULL, NULL, NULL, NULL, 4),
(88094, NULL, 'G3DSA:1.25.40.20:FF:000009', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(88095, NULL, 'G3DSA:1.10.510.10:FF:003770', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88096, NULL, 'G3DSA:3.30.420.10:FF:000614', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88097, NULL, 'G3DSA:1.10.167.10:FF:000014', NULL, NULL, 'RGS domain protein Rax1', NULL, NULL, NULL, NULL, NULL, 4),
(88098, NULL, 'G3DSA:2.70.150.10:FF:000083', NULL, NULL, 'Plasma membrane ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(88099, NULL, 'G3DSA:3.30.70.120:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88100, NULL, 'G3DSA:3.40.50.300:FF:006455', NULL, NULL, 'DNA polymerase III, delta prime subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88101, NULL, 'G3DSA:1.10.1200.10:FF:000070', NULL, NULL, 'Probable non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(88102, NULL, 'G3DSA:1.10.10.10:FF:001185', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC6', NULL, NULL, NULL, NULL, NULL, 4),
(88103, NULL, 'G3DSA:2.170.300.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88104, NULL, 'G3DSA:3.40.50.300:FF:000839', NULL, NULL, 'ABC transporter G family member 32', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(88105, NULL, 'G3DSA:3.10.100.10:FF:000016', NULL, NULL, 'macrophage mannose receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(88106, NULL, 'G3DSA:2.60.120.920:FF:000155', NULL, NULL, 'Si:dkey-61p9.9', NULL, NULL, NULL, NULL, NULL, 4),
(88107, NULL, 'G3DSA:1.10.510.10:FF:001302', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(88108, NULL, 'G3DSA:1.10.630.10:FF:000844', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88109, NULL, 'G3DSA:2.60.40.10:FF:003554', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88110, NULL, 'G3DSA:3.40.50.300:FF:006016', NULL, NULL, 'Ras-related small GTP-binding family protein', NULL, NULL, NULL, NULL, NULL, 4),
(88111, NULL, 'G3DSA:3.40.50.300:FF:001784', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(88112, NULL, 'G3DSA:2.10.25.10:FF:001132', NULL, NULL, 'Serine protease inhibitor 1', NULL, NULL, NULL, NULL, NULL, 4),
(88113, NULL, 'G3DSA:3.40.50.150:FF:000873', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88114, NULL, 'G3DSA:3.90.190.20:FF:000001', NULL, NULL, 'UDP-N-acetylmuramate--L-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(88115, NULL, 'G3DSA:3.40.50.150:FF:000761', NULL, NULL, 'tRNA (adenine(58)-N(1))-methyltransferase non-catalytic subunit TRM6', NULL, NULL, NULL, NULL, NULL, 4),
(88116, NULL, 'G3DSA:3.30.450.60:FF:000092', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(88117, NULL, 'G3DSA:3.80.10.10:FF:001924', NULL, NULL, 'Malignant fibrous histiocytoma-amplified sequence 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(88118, NULL, 'G3DSA:3.40.50.1110:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88119, NULL, 'G3DSA:2.40.30.10:FF:000244', NULL, NULL, 'Ferredoxin reductase component of carbazole', NULL, NULL, NULL, NULL, NULL, 4),
(88120, NULL, 'G3DSA:1.10.1520.10:FF:000009', NULL, NULL, 'Ribonuclease III domain-containing protein RNC1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(88121, NULL, 'G3DSA:3.30.420.40:FF:000157', NULL, NULL, 'Putative Hsp70 chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(88122, NULL, 'G3DSA:1.20.5.110:FF:000053', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(88123, NULL, 'G3DSA:3.30.830.10:FF:000100', NULL, NULL, 'Peptidase insulinase family', NULL, NULL, NULL, NULL, NULL, 4),
(88124, NULL, 'G3DSA:1.25.40.10:FF:004514', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88125, NULL, 'G3DSA:1.20.58.90:FF:000008', NULL, NULL, 'Tubulin-specific chaperone A', NULL, NULL, NULL, NULL, NULL, 4),
(88126, NULL, 'G3DSA:3.30.870.10:FF:000081', NULL, NULL, 'Tyrosyl-DNA phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(88127, NULL, 'G3DSA:1.10.3730.20:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88128, NULL, 'G3DSA:1.25.10.10:FF:003377', NULL, NULL, 'Exportin 5', NULL, NULL, NULL, NULL, NULL, 4),
(88129, NULL, 'G3DSA:1.10.510.10:FF:002825', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88130, NULL, 'G3DSA:2.10.90.10:FF:000153', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(88131, NULL, 'G3DSA:3.30.160.60:FF:003992', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88132, NULL, 'G3DSA:2.130.10.10:FF:003987', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88133, NULL, 'G3DSA:3.30.70.2740:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88134, NULL, 'G3DSA:1.10.287.460:FF:000001', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(88135, NULL, 'G3DSA:3.40.630.10:FF:000162', NULL, NULL, 'Aminoacyl-histidine dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(88136, NULL, 'G3DSA:3.80.10.10:FF:002981', NULL, NULL, 'Immunoglobulin domain and leucine-rich repeat-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(88137, NULL, 'G3DSA:1.25.40.10:FF:000119', NULL, NULL, 'synaptonemal complex protein SC65', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(88138, NULL, 'G3DSA:2.60.40.10:FF:001188', NULL, NULL, 'Immunoglobulin superfamily member 10', NULL, NULL, NULL, NULL, NULL, 4),
(88139, NULL, 'G3DSA:2.130.10.10:FF:002790', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit trm82', NULL, NULL, NULL, NULL, NULL, 4),
(88140, NULL, 'G3DSA:3.90.1150.10:FF:000146', NULL, NULL, '8-amino-7-oxononanoate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(88141, NULL, 'G3DSA:2.30.29.30:FF:000696', NULL, NULL, 'pleckstrin homology domain-containing family A member 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(88142, NULL, 'G3DSA:1.20.1250.20:FF:001355', NULL, NULL, 'Transporter protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88143, NULL, 'G3DSA:3.30.70.330:FF:002676', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88144, NULL, 'G3DSA:3.30.420.150:FF:000004', NULL, NULL, 'Ectonucleoside triphosphate diphosphohydrolase 5', NULL, NULL, NULL, NULL, NULL, 4),
(88145, NULL, 'G3DSA:1.25.40.570:FF:000029', NULL, NULL, 'Cop9 signalosome complex subunit 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88146, NULL, 'G3DSA:1.10.260.50:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88147, NULL, 'G3DSA:1.10.3580.10:FF:000002', NULL, NULL, 'Protein ATP12, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(88148, NULL, 'G3DSA:2.60.40.1220:FF:000003', NULL, NULL, 'Copper transport protein YcnJ', NULL, NULL, NULL, NULL, NULL, 4),
(88149, NULL, 'G3DSA:2.60.40.60:FF:000331', NULL, NULL, 'Fat-like cadherin-related tumor suppressor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(88150, NULL, 'G3DSA:2.60.40.10:FF:003907', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88151, NULL, 'G3DSA:3.20.20.70:FF:000832', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88152, NULL, 'G3DSA:2.60.120.1680:FF:000001', NULL, NULL, 'Orf1a polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(88153, NULL, 'G3DSA:2.40.10.10:FF:000361', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88154, NULL, 'G3DSA:2.30.30.140:FF:000035', NULL, NULL, 'Methyl-CpG binding domain protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(88155, NULL, 'G3DSA:1.25.40.10:FF:003093', NULL, NULL, 'Os06g0235800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(88156, NULL, 'G3DSA:2.120.10.80:FF:000282', NULL, NULL, 'tRNA wybutosine-synthesizing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(88157, NULL, 'G3DSA:1.10.1300.10:FF:000015', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(88158, NULL, 'G3DSA:1.10.150.50:FF:000246', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(88159, NULL, 'G3DSA:3.30.40.10:FF:000310', NULL, NULL, 'Breast cancer associated RING 1', NULL, NULL, NULL, NULL, NULL, 4),
(88160, NULL, 'G3DSA:3.80.10.10:FF:001357', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(88161, NULL, 'G3DSA:3.40.1110.10:FF:000239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88162, NULL, 'G3DSA:2.30.30.1040:FF:000001', NULL, NULL, 'Auxin response factor', NULL, NULL, NULL, NULL, NULL, 4),
(88163, NULL, 'G3DSA:1.10.8.10:FF:000251', NULL, NULL, 'Probable E3 ubiquitin-protein ligase HERC2', NULL, NULL, NULL, NULL, NULL, 4),
(88164, NULL, 'G3DSA:1.25.40.10:FF:001529', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(88165, NULL, 'G3DSA:1.25.10.10:FF:001348', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(88166, NULL, 'G3DSA:3.40.50.12710:FF:000025', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7', NULL, NULL, NULL, NULL, NULL, 4),
(88167, NULL, 'G3DSA:3.40.50.150:FF:001492', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88168, NULL, 'G3DSA:1.10.8.270:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88169, NULL, 'G3DSA:2.60.40.150:FF:000264', NULL, NULL, 'Coiled-coil and C2 domain containing 1B', NULL, NULL, NULL, NULL, NULL, 4),
(88170, NULL, 'G3DSA:3.50.30.30:FF:000084', NULL, NULL, 'Subtilisin-like protease SBT1.9', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(88171, NULL, 'G3DSA:1.20.5.490:FF:000003', NULL, NULL, 'nucleoporin p54 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(88172, NULL, 'G3DSA:4.10.410.10:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88173, NULL, 'G3DSA:1.20.990.10:FF:000048', NULL, NULL, 'Sulfite reductase', NULL, NULL, NULL, NULL, NULL, 4),
(88174, NULL, 'G3DSA:3.10.280.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88175, NULL, 'G3DSA:3.40.50.2300:FF:000854', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88176, NULL, 'G3DSA:3.90.226.10:FF:000290', NULL, NULL, 'ATP-dependent Clp protease proteolytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(88177, NULL, 'G3DSA:3.40.50.300:FF:006567', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88178, NULL, 'G3DSA:2.70.150.10:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88179, NULL, 'G3DSA:3.40.30.10:FF:000404', NULL, NULL, 'WGS project CABT00000000 data, contig 2.14', NULL, NULL, NULL, NULL, NULL, 4),
(88180, NULL, 'G3DSA:3.30.70.580:FF:000025', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(88181, NULL, 'G3DSA:2.60.40.10:FF:004852', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88182, NULL, 'G3DSA:3.90.226.10:FF:000301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88183, NULL, 'G3DSA:2.60.40.10:FF:005583', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88184, NULL, 'G3DSA:3.50.50.100:FF:000053', NULL, NULL, 'Cilia- and flagella-associated protein 61', NULL, NULL, NULL, NULL, NULL, 4),
(88185, NULL, 'G3DSA:2.10.50.10:FF:000044', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 5', NULL, NULL, NULL, NULL, NULL, 4),
(88186, NULL, 'G3DSA:1.50.40.10:FF:000499', NULL, NULL, 'Mitochondrial carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88187, NULL, 'G3DSA:1.20.1070.10:FF:001719', NULL, NULL, 'Corazonin receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88188, NULL, 'G3DSA:2.30.29.30:FF:000707', NULL, NULL, 'Vacuolar protein sorting protein 36 Vps36/EAP30/Vps36 family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88189, NULL, 'G3DSA:3.40.50.300:FF:004330', NULL, NULL, 'TraB protein', NULL, NULL, NULL, NULL, NULL, 4),
(88190, NULL, 'G3DSA:1.20.210.10:FF:000035', NULL, NULL, 'Heme-copper respiratory oxidase family', NULL, NULL, NULL, NULL, NULL, 4),
(88191, NULL, 'G3DSA:1.20.1730.10:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88192, NULL, 'G3DSA:2.180.10.10:FF:000011', NULL, NULL, 'Tenascin accessory, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(88193, NULL, 'G3DSA:2.10.25.10:FF:001503', NULL, NULL, 'Transmembrane matrix receptor MUP-4', NULL, NULL, NULL, NULL, NULL, 4),
(88194, NULL, 'G3DSA:1.20.58.70:FF:000002', NULL, NULL, 'syntaxin-16 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(88195, NULL, 'G3DSA:1.50.40.10:FF:000044', NULL, NULL, 'Peroxisomal adenine nucleotide carrier 1', NULL, NULL, NULL, NULL, NULL, 4),
(88196, NULL, 'G3DSA:3.30.420.10:FF:000726', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88197, NULL, 'G3DSA:3.30.200.20:FF:000983', NULL, NULL, 'Serine/threonine-protein kinase STN7, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(88198, NULL, 'G3DSA:3.30.250.20:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88199, NULL, 'G3DSA:1.20.120.350:FF:000106', NULL, NULL, 'Potassium voltage-gated channel, Shab-related subfamily, member 2', NULL, NULL, NULL, NULL, NULL, 4),
(88200, NULL, 'G3DSA:2.130.10.10:FF:001845', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(88201, NULL, 'G3DSA:1.20.1250.20:FF:000399', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(88202, NULL, 'G3DSA:2.40.70.10:FF:000139', NULL, NULL, 'S5', NULL, NULL, NULL, NULL, NULL, 4),
(88203, NULL, 'G3DSA:3.40.30.10:FF:000859', NULL, NULL, 'Protein disulfide isomerase-like, testis-expressed', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(88204, NULL, 'G3DSA:3.40.50.2300:FF:001343', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88205, NULL, 'G3DSA:2.70.98.20:FF:000008', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(88206, NULL, 'G3DSA:3.20.20.70:FF:000383', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88207, NULL, 'G3DSA:3.60.21.10:FF:000028', NULL, NULL, 'Putative metallophosphoesterase', NULL, NULL, NULL, NULL, NULL, 4),
(88208, NULL, 'G3DSA:3.40.630.30:FF:000381', NULL, NULL, 'Acetyltransferase CD1211', NULL, NULL, NULL, NULL, NULL, 4),
(88209, NULL, 'G3DSA:2.20.100.10:FF:000175', NULL, NULL, 'GD10852', NULL, NULL, NULL, NULL, NULL, 4),
(88210, NULL, 'G3DSA:3.90.320.10:FF:000059', NULL, NULL, 'Blr8088 protein', NULL, NULL, NULL, NULL, NULL, 4),
(88211, NULL, 'G3DSA:1.10.1420.10:FF:000064', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(88212, NULL, 'G3DSA:2.130.10.30:FF:000087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88213, NULL, 'G3DSA:1.10.630.10:FF:000182', NULL, NULL, 'Cytochrome P450 3A4', NULL, NULL, NULL, NULL, NULL, 4),
(88214, NULL, 'G3DSA:2.60.120.200:FF:000052', NULL, NULL, 'Laminin subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(88215, NULL, 'G3DSA:3.40.50.1010:FF:000186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88216, NULL, 'G3DSA:3.80.10.10:FF:001020', NULL, NULL, 'Leucine rich repeat receptor protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(88217, NULL, 'G3DSA:1.25.10.10:FF:001820', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88218, NULL, 'G3DSA:3.40.50.150:FF:000081', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(88219, NULL, 'G3DSA:3.30.160.60:FF:002031', NULL, NULL, 'Zinc finger protein 655', NULL, NULL, NULL, NULL, NULL, 4),
(88220, NULL, 'G3DSA:3.30.465.10:FF:000032', NULL, NULL, 'Delta(24)-sterol reductase', NULL, NULL, NULL, NULL, NULL, 4),
(88221, NULL, 'G3DSA:1.10.287.1490:FF:000064', NULL, NULL, 'Viral A-type inclusion protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88222, NULL, 'G3DSA:3.30.160.60:FF:006297', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88223, NULL, 'G3DSA:1.20.5.390:FF:000007', NULL, NULL, 'Optineurin', NULL, NULL, NULL, NULL, NULL, 4),
(88224, NULL, 'G3DSA:2.60.40.790:FF:000101', NULL, NULL, 'Wos2 protein (P21), putative', NULL, NULL, NULL, NULL, NULL, 4),
(88225, NULL, 'G3DSA:3.40.50.300:FF:003824', NULL, NULL, 'SWF/SNF family helicase', NULL, NULL, NULL, NULL, NULL, 4),
(88226, NULL, 'G3DSA:1.10.10.10:FF:001168', NULL, NULL, 'Iron dicitrate transport regulator FecR', NULL, NULL, NULL, NULL, NULL, 4),
(88227, NULL, 'G3DSA:3.30.710.10:FF:000378', NULL, NULL, 'Kelch-like protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(88228, NULL, 'G3DSA:2.60.40.10:FF:000457', NULL, NULL, 'Immunoglobulin like domain containing receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(88229, NULL, 'G3DSA:1.10.240.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88230, NULL, 'G3DSA:2.60.120.10:FF:000549', NULL, NULL, 'Germin-like protein subfamily 2 member 1', NULL, NULL, NULL, NULL, NULL, 4),
(88231, NULL, 'G3DSA:2.160.20.10:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88232, NULL, 'G3DSA:2.60.40.1250:FF:000001', NULL, NULL, 'Thiol:disulfide interchange protein DsbD', NULL, NULL, NULL, NULL, NULL, 4),
(88233, NULL, 'G3DSA:3.40.50.620:FF:000817', NULL, NULL, 'Nicotinate/nicotinamide mononucleotide adenyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(88234, NULL, 'G3DSA:1.20.58.2050:FF:000003', NULL, NULL, 'GINS complex subunit 3 isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(88235, NULL, 'G3DSA:3.10.20.90:FF:000350', NULL, NULL, 'Ataxin-3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88236, NULL, 'G3DSA:3.40.50.10090:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88237, NULL, 'G3DSA:1.20.1530.20:FF:000005', NULL, NULL, 'Transporter, bile acid/Na+ symporter family', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(88238, NULL, 'G3DSA:1.10.287.470:FF:000088', NULL, NULL, 'Multidrug resistance protein A', NULL, NULL, NULL, NULL, NULL, 4),
(88239, NULL, 'G3DSA:1.25.40.10:FF:000557', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(88240, NULL, 'G3DSA:3.20.170.30:FF:000001', NULL, NULL, 'RNA 2''-phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(88241, NULL, 'G3DSA:3.30.420.10:FF:000631', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88242, NULL, 'G3DSA:3.40.50.300:FF:005499', NULL, NULL, 'DEAD-box ATP-dependent RNA helicase CshB', NULL, NULL, NULL, NULL, NULL, 4),
(88243, NULL, 'G3DSA:3.40.50.300:FF:006808', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88244, NULL, 'G3DSA:1.20.1070.10:FF:001933', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88245, NULL, 'G3DSA:2.60.120.180:FF:000006', NULL, NULL, 'Glycoside hydrolase family 12', NULL, NULL, NULL, NULL, NULL, 4),
(88246, NULL, 'G3DSA:3.30.40.10:FF:001619', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(88247, NULL, 'G3DSA:1.20.5.370:FF:000001', NULL, NULL, 'Myosin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(88248, NULL, 'G3DSA:1.20.1110.10:FF:000240', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88249, NULL, 'G3DSA:3.40.50.740:FF:000044', NULL, NULL, 'NADH dehydrogenase I, G subunit', NULL, NULL, NULL, NULL, NULL, 4),
(88250, NULL, 'G3DSA:6.20.50.170:FF:000001', NULL, NULL, 'Nucleoporin NUP145', NULL, NULL, NULL, NULL, NULL, 4),
(88251, NULL, 'G3DSA:3.30.70.330:FF:002221', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88252, NULL, 'G3DSA:1.50.10.20:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88253, NULL, 'G3DSA:3.40.50.2000:FF:000511', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88254, NULL, 'G3DSA:3.40.190.10:FF:000026', NULL, NULL, 'Glutamate ionotropic receptor NMDA type subunit 2A', NULL, NULL, NULL, NULL, NULL, 4),
(88255, NULL, 'G3DSA:3.30.70.3460:FF:000002', NULL, NULL, 'Heme d1 biosynthesis protein NirH', NULL, NULL, NULL, NULL, NULL, 4),
(88256, NULL, 'G3DSA:2.90.10.10:FF:000049', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(88257, NULL, 'G3DSA:2.60.260.20:FF:000028', NULL, NULL, 'DnaJ family protein', NULL, NULL, NULL, NULL, NULL, 4),
(88258, NULL, 'G3DSA:3.50.50.60:FF:001387', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88259, NULL, 'G3DSA:2.30.30.40:FF:000539', NULL, NULL, 'SH3 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(88260, NULL, 'G3DSA:3.30.1640.10:FF:000063', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(88261, NULL, 'G3DSA:2.60.40.10:FF:004043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88262, NULL, 'G3DSA:3.20.80.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88263, NULL, 'G3DSA:1.10.390.10:FF:000027', NULL, NULL, 'M4 family peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(88264, NULL, 'G3DSA:1.10.510.10:FF:000785', NULL, NULL, 'CMGC/CDK/CDK8 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(88265, NULL, 'G3DSA:2.130.10.10:FF:000564', NULL, NULL, 'WD repeat domain 41', NULL, NULL, NULL, NULL, NULL, 4),
(88266, NULL, 'G3DSA:3.40.50.1000:FF:000880', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88267, NULL, 'G3DSA:1.10.287.70:FF:000715', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(88268, NULL, 'G3DSA:3.30.70.330:FF:001945', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88269, NULL, 'G3DSA:1.25.40.20:FF:001746', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88270, NULL, 'G3DSA:2.60.40.1930:FF:000019', NULL, NULL, 'C3 and PZP-like alpha-2-macroglobulin domain-containing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(88271, NULL, 'G3DSA:3.30.60.30:FF:000093', NULL, NULL, 'GH09510p', NULL, NULL, NULL, NULL, NULL, 4),
(88272, NULL, 'G3DSA:3.30.160.60:FF:003554', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(88273, NULL, 'G3DSA:2.130.10.10:FF:004616', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88274, NULL, 'G3DSA:2.60.120.40:FF:000064', NULL, NULL, 'TNF superfamily member 11', NULL, NULL, NULL, NULL, NULL, 4),
(88275, NULL, 'G3DSA:1.20.1560.10:FF:000717', NULL, NULL, 'Os08g0153000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(88276, NULL, 'G3DSA:3.30.160.60:FF:000906', NULL, NULL, 'Zinc finger protein 521', NULL, NULL, NULL, NULL, NULL, 4),
(88277, NULL, 'G3DSA:2.20.70.10:FF:000180', NULL, NULL, 'Pre-mRNA-processing factor 40', NULL, NULL, NULL, NULL, NULL, 4),
(88278, NULL, 'G3DSA:3.40.1260.10:FF:000014', NULL, NULL, 'Sulfur relay protein TusB/DsrH', NULL, NULL, NULL, NULL, NULL, 4),
(88279, NULL, 'G3DSA:2.130.10.10:FF:000081', NULL, NULL, 'DNA damage-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(88280, NULL, 'G3DSA:1.10.530.10:FF:000016', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(88281, NULL, 'G3DSA:1.25.40.10:FF:004402', NULL, NULL, 'Os12g0490100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(88282, NULL, 'G3DSA:3.10.20.90:FF:000479', NULL, NULL, 'AT10981p', NULL, NULL, NULL, NULL, NULL, 4),
(88283, NULL, 'G3DSA:3.30.710.10:FF:000041', NULL, NULL, 'Zinc finger protein 131', NULL, NULL, NULL, NULL, NULL, 4),
(88284, NULL, 'G3DSA:3.80.10.10:FF:003841', NULL, NULL, 'PH domain and leucine rich repeat protein phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(88285, NULL, 'G3DSA:3.40.50.300:FF:004673', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88286, NULL, 'G3DSA:1.10.510.10:FF:000116', NULL, NULL, 'inactive tyrosine-protein kinase transmembrane receptor ROR1', NULL, NULL, NULL, NULL, NULL, 4),
(88287, NULL, 'G3DSA:2.60.40.1390:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88288, NULL, 'G3DSA:1.20.1250.20:FF:001708', NULL, NULL, 'Solute carrier organic anion transporter family, member 2B1', NULL, NULL, NULL, NULL, NULL, 4),
(88289, NULL, 'G3DSA:1.25.40.20:FF:000920', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(88290, NULL, 'G3DSA:3.40.1000.10:FF:000023', NULL, NULL, 'PsbP domain-containing protein 5, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(88291, NULL, 'G3DSA:3.30.457.60:FF:000011', NULL, NULL, 'MAD (Yeast Mitosis arrest DeFicient) related', NULL, NULL, NULL, NULL, NULL, 4),
(88292, NULL, 'G3DSA:1.20.1250.20:FF:001804', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88293, NULL, 'G3DSA:1.10.10.60:FF:000070', NULL, NULL, 'DNA-binding protein SATB', NULL, NULL, NULL, NULL, NULL, 4),
(88294, NULL, 'G3DSA:3.30.200.20:FF:001680', NULL, NULL, 'Myosin light chain kinase, smooth muscle', NULL, NULL, NULL, NULL, NULL, 4),
(88295, NULL, 'G3DSA:1.50.40.10:FF:000156', NULL, NULL, 'Mitochondrial 2-oxoglutarate malate carrier', NULL, NULL, NULL, NULL, NULL, 4),
(88296, NULL, 'G3DSA:3.40.525.10:FF:000029', NULL, NULL, 'alpha-tocopherol transfer protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(88297, NULL, 'G3DSA:1.25.40.10:FF:000220', NULL, NULL, 'Pre-mRNA-splicing factor SYF1', NULL, NULL, NULL, NULL, NULL, 4),
(88298, NULL, 'G3DSA:3.90.1800.10:FF:000005', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(88299, NULL, 'G3DSA:3.40.50.300:FF:002756', NULL, NULL, 'Dephospho-CoA kinase', NULL, NULL, NULL, NULL, NULL, 4),
(88300, NULL, 'G3DSA:1.20.1070.10:FF:000410', NULL, NULL, 'Olfactory receptor 1348', NULL, NULL, NULL, NULL, NULL, 4),
(88301, NULL, 'G3DSA:2.10.70.10:FF:000270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88302, NULL, 'G3DSA:3.40.50.300:FF:008372', NULL, NULL, 'Adenylate kinase 9', NULL, NULL, NULL, NULL, NULL, 4),
(88303, NULL, 'G3DSA:1.10.287.370:FF:000075', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(88304, NULL, 'G3DSA:3.40.630.150:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88305, NULL, 'G3DSA:1.10.110.10:FF:000024', NULL, NULL, 'Metal-dependent protein hydrolase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(88306, NULL, 'G3DSA:3.30.160.60:FF:003211', NULL, NULL, 'Hypermethylated in cancer 1', NULL, NULL, NULL, NULL, NULL, 4),
(88307, NULL, 'G3DSA:3.40.50.300:FF:003032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88308, NULL, 'G3DSA:1.20.1390.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88309, NULL, 'G3DSA:3.40.50.1460:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88310, NULL, 'G3DSA:3.30.40.230:FF:000010', NULL, NULL, 'Glycine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(88311, NULL, 'G3DSA:3.30.1370.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88312, NULL, 'G3DSA:1.25.10.10:FF:000729', NULL, NULL, 'Unplaced genomic scaffold supercont2.16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(88313, NULL, 'G3DSA:1.25.10.10:FF:001365', NULL, NULL, 'CBF/Mak21 family-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(88314, NULL, 'G3DSA:1.25.40.10:FF:001176', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g35030, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(88315, NULL, 'G3DSA:3.40.47.10:FF:000162', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88316, NULL, 'G3DSA:1.20.1280.40:FF:000002', NULL, NULL, 'OriC-binding nucleoid-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(88317, NULL, 'G3DSA:3.80.10.10:FF:001812', NULL, NULL, 'Leucine-rich repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(88318, NULL, 'G3DSA:3.40.50.300:FF:004190', NULL, NULL, 'AIG1 family protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(88319, NULL, 'G3DSA:2.130.10.10:FF:005235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88320, NULL, 'G3DSA:2.60.40.60:FF:001079', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(88321, NULL, 'G3DSA:1.20.870.10:FF:000017', NULL, NULL, 'Rap guanine nucleotide exchange factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(88322, NULL, 'G3DSA:3.40.50.150:FF:001733', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88323, NULL, 'G3DSA:3.40.50.620:FF:000025', NULL, NULL, 'Bifunctional glutamate/proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(88324, NULL, 'G3DSA:1.25.40.20:FF:001403', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88325, NULL, 'G3DSA:1.20.120.1530:FF:000001', NULL, NULL, 'Two-component osmosensing histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(88326, NULL, 'G3DSA:1.10.730.10:FF:000015', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(88327, NULL, 'G3DSA:1.10.8.50:FF:000004', NULL, NULL, 'Integration host factor', NULL, NULL, NULL, NULL, NULL, 4),
(88328, NULL, 'G3DSA:2.30.29.30:FF:000584', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(88329, NULL, 'G3DSA:3.60.40.10:FF:000073', NULL, NULL, 'Putative phosphatase 2C', NULL, NULL, NULL, NULL, NULL, 4),
(88330, NULL, 'G3DSA:1.10.10.60:FF:000553', NULL, NULL, 'Homeobox protein ceh-5', NULL, NULL, NULL, NULL, NULL, 4),
(88331, NULL, 'G3DSA:3.40.630.10:FF:000274', NULL, NULL, 'Aminopeptidase, family M28, containing PA domain', NULL, NULL, NULL, NULL, NULL, 4),
(88332, NULL, 'G3DSA:1.10.287.1490:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88333, NULL, 'G3DSA:2.20.110.10:FF:000001', NULL, NULL, 'Junctophilin', NULL, NULL, NULL, NULL, NULL, 4),
(88334, NULL, 'G3DSA:2.60.120.330:FF:000203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88335, NULL, 'G3DSA:2.30.33.40:FF:000012', NULL, NULL, '20 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(88336, NULL, 'G3DSA:3.40.50.720:FF:002197', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(88337, NULL, 'G3DSA:1.20.5.340:FF:000003', NULL, NULL, 'Myosin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(88338, NULL, 'G3DSA:2.60.120.590:FF:000039', NULL, NULL, 'Fat mass and obesity associated', NULL, NULL, NULL, NULL, NULL, 4),
(88339, NULL, 'G3DSA:2.10.25.10:FF:001020', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(88340, NULL, 'G3DSA:2.40.30.20:FF:000022', NULL, NULL, 'Riboflavin synthase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(88341, NULL, 'G3DSA:2.60.120.200:FF:000395', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(88342, NULL, 'G3DSA:3.10.20.90:FF:000249', NULL, NULL, 'Ubiquitin D', NULL, NULL, NULL, NULL, NULL, 4),
(88343, NULL, 'G3DSA:1.10.472.10:FF:000471', NULL, NULL, 'Transcription factor IIIB 50 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(88344, NULL, 'G3DSA:3.40.640.10:FF:000331', NULL, NULL, 'ATP-binding cassette sub-family A member 3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(88345, NULL, 'G3DSA:2.40.280.10:FF:000003', NULL, NULL, 'SsrA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(88346, NULL, 'G3DSA:2.60.120.330:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88347, NULL, 'G3DSA:3.30.70.330:FF:000304', NULL, NULL, 'RNA-binding protein 6 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(88348, NULL, 'G3DSA:1.10.510.10:FF:000908', NULL, NULL, 'Slowpoke binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88349, NULL, 'G3DSA:2.60.40.10:FF:004060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88350, NULL, 'G3DSA:1.20.1250.20:FF:001225', NULL, NULL, 'MFS transporter, putative (AFU_orthologue AFUA_2G00110)', NULL, NULL, NULL, NULL, NULL, 4),
(88351, NULL, 'G3DSA:1.10.1200.10:FF:000165', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(88352, NULL, 'G3DSA:3.30.70.980:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88353, NULL, 'G3DSA:1.20.1250.20:FF:000736', NULL, NULL, 'Sugar efflux transporter B', NULL, NULL, NULL, NULL, NULL, 4),
(88354, NULL, 'G3DSA:1.10.510.10:FF:001061', NULL, NULL, 'eIF-2-alpha kinase GCN2', NULL, NULL, NULL, NULL, NULL, 4),
(88355, NULL, 'G3DSA:3.10.20.90:FF:000119', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 14', NULL, NULL, NULL, NULL, NULL, 4),
(88356, NULL, 'G3DSA:3.40.50.300:FF:004313', NULL, NULL, 'Os11g0177400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(88357, NULL, 'G3DSA:2.40.50.140:FF:000290', NULL, NULL, 'Probable RPT1-26S proteasome regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(88358, NULL, 'G3DSA:3.40.50.1820:FF:000457', NULL, NULL, 'Putative esterase', NULL, NULL, NULL, NULL, NULL, 4),
(88359, NULL, 'G3DSA:2.60.40.10:FF:000018', NULL, NULL, 'collagen alpha-1(XII) chain isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(88360, NULL, 'G3DSA:3.40.1000.30:FF:000001', NULL, NULL, 'F-box only protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(88361, NULL, 'G3DSA:3.40.50.300:FF:002413', NULL, NULL, 'Gluconokinase', NULL, NULL, NULL, NULL, NULL, 4),
(88362, NULL, 'G3DSA:3.30.70.330:FF:000208', NULL, NULL, 'RNA-binding protein 27 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(88363, NULL, 'G3DSA:3.30.450.30:FF:000009', NULL, NULL, 'Dynein light chain roadblock', NULL, NULL, NULL, NULL, NULL, 4),
(88364, NULL, 'G3DSA:3.90.1200.10:FF:000050', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(88365, NULL, 'G3DSA:2.20.100.10:FF:000158', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(88366, NULL, 'G3DSA:2.30.30.490:FF:000089', NULL, NULL, 'Cytosine-specific methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(88367, NULL, 'G3DSA:2.60.40.10:FF:002935', NULL, NULL, 'Sialic acid-binding Ig-like lectin 15', NULL, NULL, NULL, NULL, NULL, 4),
(88368, NULL, 'G3DSA:2.30.29.90:FF:000006', NULL, NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(88369, NULL, 'G3DSA:3.90.190.10:FF:000565', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88370, NULL, 'G3DSA:3.30.1380.10:FF:000008', NULL, NULL, 'Hedgehog protein', NULL, NULL, NULL, NULL, NULL, 4),
(88371, NULL, 'G3DSA:3.40.640.10:FF:000229', NULL, NULL, 'Aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(88372, NULL, 'G3DSA:3.30.70.1730:FF:000045', NULL, NULL, '60S acidic ribosomal protein P0', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(88373, NULL, 'G3DSA:1.10.238.10:FF:001169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88374, NULL, 'G3DSA:3.20.20.80:FF:000509', NULL, NULL, 'Chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88375, NULL, 'G3DSA:3.40.50.300:FF:001003', NULL, NULL, 'Vacuolar protein sorting-associated protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(88376, NULL, 'G3DSA:1.10.10.1420:FF:000002', NULL, NULL, 'CDT1-like protein a chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(88377, NULL, 'G3DSA:2.30.38.10:FF:000003', NULL, NULL, 'Vibriobactin-specific 2,3-dihydroxybenzoate-AMP ligase', NULL, NULL, NULL, NULL, NULL, 4),
(88378, NULL, 'G3DSA:3.30.760.10:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88379, NULL, 'G3DSA:1.20.272.10:FF:000077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88380, NULL, 'G3DSA:3.40.1000.50:FF:000007', NULL, NULL, 'Related to MAF1-negative regulator of RNA polymerase III', NULL, NULL, NULL, NULL, NULL, 4),
(88381, NULL, 'G3DSA:1.10.533.10:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88382, NULL, 'G3DSA:1.20.1250.20:FF:001012', NULL, NULL, 'Si:dkey-246g23.4', NULL, NULL, NULL, NULL, NULL, 4),
(88383, NULL, 'G3DSA:1.20.120.1750:FF:000067', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(88384, NULL, 'G3DSA:3.30.70.1450:FF:000051', NULL, NULL, 'Transporter, sodium/sulfate symporter family', NULL, NULL, NULL, NULL, NULL, 4),
(88385, NULL, 'G3DSA:2.130.10.10:FF:002138', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(88386, NULL, 'G3DSA:3.40.250.10:FF:000065', NULL, NULL, 'YOR286W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(88387, NULL, 'G3DSA:1.25.10.10:FF:003265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88388, NULL, 'G3DSA:1.10.10.10:FF:000780', NULL, NULL, 'ORC1-type DNA replication protein', NULL, NULL, NULL, NULL, NULL, 4),
(88389, NULL, 'G3DSA:1.10.840.10:FF:000006', NULL, NULL, 'son of sevenless homolog 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(88390, NULL, 'G3DSA:3.80.10.10:FF:000401', NULL, NULL, 'TOLL-like receptor 11', NULL, NULL, NULL, NULL, NULL, 4),
(88391, NULL, 'G3DSA:3.20.20.140:FF:000481', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88392, NULL, 'G3DSA:1.10.220.20:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88393, NULL, 'G3DSA:2.60.40.1180:FF:000070', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(88394, NULL, 'G3DSA:3.30.160.60:FF:000114', NULL, NULL, 'Zinc finger and BTB domain-containing protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(88395, NULL, 'G3DSA:1.25.40.10:FF:003997', NULL, NULL, 'Protein EBS1', NULL, NULL, NULL, NULL, NULL, 4),
(88396, NULL, 'G3DSA:2.30.40.10:FF:000048', NULL, NULL, 'Related to guanine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(88397, NULL, 'G3DSA:3.30.1410.10:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88398, NULL, 'G3DSA:3.30.160.60:FF:002935', NULL, NULL, 'GD15791', NULL, NULL, NULL, NULL, NULL, 4),
(88399, NULL, 'G3DSA:2.60.120.260:FF:000272', NULL, NULL, 'Putative wall-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(88400, NULL, 'G3DSA:1.20.1060.20:FF:000002', NULL, NULL, 'Structural maintenance of chromosomes 3', NULL, NULL, NULL, NULL, NULL, 4),
(88401, NULL, 'G3DSA:1.20.58.390:FF:000327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88402, NULL, 'G3DSA:1.10.510.10:FF:003882', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88403, NULL, 'G3DSA:2.130.10.10:FF:004959', NULL, NULL, 'WD repeat domain 18', NULL, NULL, NULL, NULL, NULL, 4),
(88404, NULL, 'G3DSA:2.70.170.10:FF:000106', NULL, NULL, 'Si:ch211-39a7.1', NULL, NULL, NULL, NULL, NULL, 4),
(88405, NULL, 'G3DSA:3.30.1370.100:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88406, NULL, 'G3DSA:1.10.238.10:FF:000652', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(88407, NULL, 'G3DSA:3.40.50.720:FF:000297', NULL, NULL, 'UDP-glucose 6-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(88408, NULL, 'G3DSA:3.30.70.330:FF:001153', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(88409, NULL, 'G3DSA:3.80.10.10:FF:002329', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(88410, NULL, 'G3DSA:2.30.30.140:FF:000018', NULL, NULL, 'Serine/threonine-protein kinase 31', NULL, NULL, NULL, NULL, NULL, 4),
(88411, NULL, 'G3DSA:3.40.50.300:FF:000727', NULL, NULL, 'Protein SEY1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(88412, NULL, 'G3DSA:3.40.91.90:FF:000001', NULL, NULL, 'Polymerase acidic protein', NULL, NULL, NULL, NULL, NULL, 4),
(88413, NULL, 'G3DSA:3.40.630.10:FF:000403', NULL, NULL, 'Peptidase M20', NULL, NULL, NULL, NULL, NULL, 4),
(88414, NULL, 'G3DSA:3.30.160.60:FF:001867', NULL, NULL, 'Zinc finger protein 430', NULL, NULL, NULL, NULL, NULL, 4),
(88415, NULL, 'G3DSA:3.30.70.980:FF:000021', NULL, NULL, 'Probable transcriptional regulatory protein Chy400_1141', NULL, NULL, NULL, NULL, NULL, 4),
(88416, NULL, 'G3DSA:1.10.8.60:FF:000350', NULL, NULL, 'N-ethylmaleimide sensitive factor, vesicle fusing ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(88417, NULL, 'G3DSA:3.30.160.60:FF:004043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88418, NULL, 'G3DSA:3.30.200.20:FF:001472', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88419, NULL, 'G3DSA:3.40.630.30:FF:000605', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88420, NULL, 'G3DSA:1.10.150.850:FF:000012', NULL, NULL, 'SH2 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(88421, NULL, 'G3DSA:3.40.640.10:FF:000100', NULL, NULL, 'Putative acetylornithine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(88422, NULL, 'G3DSA:3.80.10.10:FF:000856', NULL, NULL, 'Leucine-rich repeat-containing protein 30', NULL, NULL, NULL, NULL, NULL, 4),
(88423, NULL, 'G3DSA:3.40.50.300:FF:001688', NULL, NULL, 'TetQ family GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88424, NULL, 'G3DSA:3.90.110.10:FF:000010', NULL, NULL, '6-phospho-alpha-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(88425, NULL, 'G3DSA:1.25.40.10:FF:003334', NULL, NULL, 'PPR repeat family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88426, NULL, 'G3DSA:3.30.450.40:FF:000097', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(88427, NULL, 'G3DSA:2.170.300.10:FF:000048', NULL, NULL, 'scavenger receptor class F member 1 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(88428, NULL, 'G3DSA:3.30.1360.120:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88429, NULL, 'G3DSA:3.30.70.330:FF:001720', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88430, NULL, 'G3DSA:3.20.20.80:FF:000268', NULL, NULL, 'Glucan endo-1,3-alpha-glucosidase agn2', NULL, NULL, NULL, NULL, NULL, 4),
(88431, NULL, 'G3DSA:3.40.50.150:FF:000305', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(88432, NULL, 'G3DSA:3.40.33.10:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88433, NULL, 'G3DSA:3.30.160.60:FF:006185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88434, NULL, 'G3DSA:2.130.10.10:FF:005673', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88435, NULL, 'G3DSA:3.90.226.10:FF:000273', NULL, NULL, 'Putative periplasmic protease', NULL, NULL, NULL, NULL, NULL, 4),
(88436, NULL, 'G3DSA:2.30.110.10:FF:000050', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(88437, NULL, 'G3DSA:3.60.40.10:FF:000281', NULL, NULL, 'Protein phosphatase 2C family protein', NULL, NULL, NULL, NULL, NULL, 4),
(88438, NULL, 'G3DSA:3.90.550.10:FF:000436', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88439, NULL, 'G3DSA:3.40.5.10:FF:000021', NULL, NULL, 'Mitochondrial 54S ribosomal protein MRPL50', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(88440, NULL, 'G3DSA:2.40.30.260:FF:000001', NULL, NULL, 'protein MTO1 homolog, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(88441, NULL, 'G3DSA:1.25.40.20:FF:000094', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(88442, NULL, 'G3DSA:2.180.10.10:FF:000028', NULL, NULL, 'Teneurin-1', NULL, NULL, NULL, NULL, NULL, 4),
(88443, NULL, 'G3DSA:3.30.70.20:FF:000039', NULL, NULL, 'Chaperone protein DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(88444, NULL, 'G3DSA:3.10.180.10:FF:000004', NULL, NULL, 'Lactoylglutathione lyase', NULL, NULL, NULL, NULL, NULL, 4),
(88445, NULL, 'G3DSA:3.40.1360.10:FF:000044', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(88446, NULL, 'G3DSA:3.40.1280.30:FF:000004', NULL, NULL, 'tRNA (guanine(9)-N1)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(88447, NULL, 'G3DSA:3.40.50.11350:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88448, NULL, 'G3DSA:3.90.1750.20:FF:000009', NULL, NULL, 'DNA recombinase', NULL, NULL, NULL, NULL, NULL, 4),
(88449, NULL, 'G3DSA:3.30.40.10:FF:000214', NULL, NULL, 'E3 ubiquitin-protein ligase PDZRN3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(88450, NULL, 'G3DSA:3.30.450.330:FF:000002', NULL, NULL, 'Cell division protein', NULL, NULL, NULL, NULL, NULL, 4),
(88451, NULL, 'G3DSA:3.40.50.10810:FF:000118', NULL, NULL, 'Defense against restriction protein B', NULL, NULL, NULL, NULL, NULL, 4),
(88452, NULL, 'G3DSA:3.30.300.10:FF:000004', NULL, NULL, 'S-adenosylmethionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(88453, NULL, 'G3DSA:3.30.420.10:FF:000165', NULL, NULL, 'Ribonuclease D, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88454, NULL, 'G3DSA:1.20.1420.30:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88455, NULL, 'G3DSA:3.40.50.720:FF:001365', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(88456, NULL, 'G3DSA:3.40.50.720:FF:000746', NULL, NULL, '3-hydroxyisobutyrate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(88457, NULL, 'G3DSA:1.10.760.10:FF:000056', NULL, NULL, '40-residue YVTN family beta-propeller', NULL, NULL, NULL, NULL, NULL, 4),
(88458, NULL, 'G3DSA:2.60.40.10:FF:004622', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88459, NULL, 'G3DSA:2.60.40.10:FF:000226', NULL, NULL, 'protein turtle homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(88460, NULL, 'G3DSA:1.25.40.40:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88461, NULL, 'G3DSA:1.20.960.30:FF:000002', NULL, NULL, 'Platelet-activating factor acetylhydrolase ib', NULL, NULL, NULL, NULL, NULL, 4),
(88462, NULL, 'G3DSA:3.30.420.40:FF:000174', NULL, NULL, 'Heat shock 70 kDa protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(88463, NULL, 'G3DSA:1.10.510.10:FF:000347', NULL, NULL, 'Apoptosis associated tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(88464, NULL, 'G3DSA:3.40.50.10810:FF:000017', NULL, NULL, 'ATP-dependent helicase BRM', NULL, NULL, NULL, NULL, NULL, 4),
(88465, NULL, 'G3DSA:3.20.20.70:FF:000170', NULL, NULL, 'Fatty acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(88466, NULL, 'G3DSA:1.20.1740.10:FF:000254', NULL, NULL, 'Protein CBG15341', NULL, NULL, NULL, NULL, NULL, 4),
(88467, NULL, 'G3DSA:1.10.340.30:FF:000070', NULL, NULL, 'Endonuclease III-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(88468, NULL, 'G3DSA:3.30.2320.20:FF:000002', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(88469, NULL, 'G3DSA:3.90.660.10:FF:000085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88470, NULL, 'G3DSA:3.40.50.970:FF:000107', NULL, NULL, 'Sulfoacetaldehyde acetyltransferase Xsc', NULL, NULL, NULL, NULL, NULL, 4),
(88471, NULL, 'G3DSA:1.10.260.30:FF:000018', NULL, NULL, 'Signal recognition particle 54 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(88472, NULL, 'G3DSA:1.20.120.740:FF:000004', NULL, NULL, 'UPF0149 protein VC_2476', NULL, NULL, NULL, NULL, NULL, 4),
(88473, NULL, 'G3DSA:3.60.21.10:FF:000259', NULL, NULL, '3'',5''-cyclic adenosine monophosphate phosphodiesterase CpdA', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(88474, NULL, 'G3DSA:3.40.1190.10:FF:000019', NULL, NULL, 'Mur ligase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(88475, NULL, 'G3DSA:3.40.250.10:FF:000177', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(88476, NULL, 'G3DSA:2.60.120.200:FF:000748', NULL, NULL, 'Pentaxin', NULL, NULL, NULL, NULL, NULL, 4),
(88477, NULL, 'G3DSA:3.40.50.1980:FF:000140', NULL, NULL, 'Metal binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88478, NULL, 'G3DSA:3.30.160.60:FF:006084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88479, NULL, 'G3DSA:2.60.40.150:FF:000134', NULL, NULL, 'BAI1-associated protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(88480, NULL, 'G3DSA:3.40.50.300:FF:001115', NULL, NULL, 'DNA mismatch repair protein MSH2', NULL, NULL, NULL, NULL, NULL, 4),
(88481, NULL, 'G3DSA:2.130.10.10:FF:003970', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(88482, NULL, 'G3DSA:2.10.50.10:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88483, NULL, 'G3DSA:3.10.250.10:FF:000116', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88484, NULL, 'G3DSA:1.10.10.10:FF:001729', NULL, NULL, 'Response regulator receiver domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(88485, NULL, 'G3DSA:1.10.472.10:FF:000139', NULL, NULL, 'Cyclin E1', NULL, NULL, NULL, NULL, NULL, 4),
(88486, NULL, 'G3DSA:3.40.50.11900:FF:000001', NULL, NULL, 'Putative 2-hydroxyglutaryl-CoA dehydratase, D-component', NULL, NULL, NULL, NULL, NULL, 4),
(88487, NULL, 'G3DSA:3.10.20.70:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88488, NULL, 'G3DSA:3.10.28.10:FF:000041', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(88489, NULL, 'G3DSA:1.10.472.80:FF:000216', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88490, NULL, 'G3DSA:1.10.390.30:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88491, NULL, 'G3DSA:2.40.50.140:FF:001150', NULL, NULL, 'DNA repair protein RecO', NULL, NULL, NULL, NULL, NULL, 4),
(88492, NULL, 'G3DSA:3.40.630.30:FF:000510', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88493, NULL, 'G3DSA:1.10.510.10:FF:001757', NULL, NULL, 'Aurora kinase', NULL, NULL, NULL, NULL, NULL, 4),
(88494, NULL, 'G3DSA:1.20.1640.10:FF:000089', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(88495, NULL, 'G3DSA:2.130.10.10:FF:001733', NULL, NULL, 'Os01g0183100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(88496, NULL, 'G3DSA:3.40.50.300:FF:001896', NULL, NULL, 'Ferrous iron transport protein B', NULL, NULL, NULL, NULL, NULL, 4),
(88497, NULL, 'G3DSA:3.30.470.20:FF:000002', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(88498, NULL, 'G3DSA:3.50.50.60:FF:000190', NULL, NULL, 'Thioredoxin reductase', NULL, NULL, NULL, NULL, NULL, 4),
(88499, NULL, 'G3DSA:3.90.1180.10:FF:000002', NULL, NULL, '60S ribosomal protein L16', NULL, NULL, NULL, NULL, NULL, 4),
(88500, NULL, 'G3DSA:3.30.2160.10:FF:000026', NULL, NULL, 'Ubiquitin protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88501, NULL, 'G3DSA:1.10.10.520:FF:000018', NULL, NULL, 'SUMO-activating enzyme subunit', NULL, NULL, NULL, NULL, NULL, 4),
(88502, NULL, 'G3DSA:1.10.630.10:FF:000732', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88503, NULL, 'G3DSA:3.90.550.10:FF:000099', NULL, NULL, 'Bactoprenol glucosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(88504, NULL, 'G3DSA:1.25.10.10:FF:002888', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88505, NULL, 'G3DSA:3.30.420.40:FF:000269', NULL, NULL, 'Carbohydrate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(88506, NULL, 'G3DSA:1.10.238.10:FF:000551', NULL, NULL, 'Mutated in colorectal cancer isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(88507, NULL, 'G3DSA:3.30.160.60:FF:004740', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88508, NULL, 'G3DSA:2.60.260.40:FF:000006', NULL, NULL, 'NADH dehydrogenase [ubiquinone] iron-sulfur protein 6, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(88509, NULL, 'G3DSA:3.30.160.60:FF:000457', NULL, NULL, 'B-cell lymphoma 6 protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(88510, NULL, 'G3DSA:2.130.10.10:FF:004263', NULL, NULL, 'WD repeat-containing planar cell polarity effector', NULL, NULL, NULL, NULL, NULL, 4),
(88511, NULL, 'G3DSA:3.90.70.10:FF:000303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88512, NULL, 'G3DSA:3.40.309.10:FF:000050', NULL, NULL, 'Phenylacetic acid degradation protein PaaN', NULL, NULL, NULL, NULL, NULL, 4),
(88513, NULL, 'G3DSA:3.50.50.60:FF:000414', NULL, NULL, 'POSSIBLE FLAVOPROTEIN', NULL, NULL, NULL, NULL, NULL, 4),
(88514, NULL, 'G3DSA:2.60.220.50:FF:000001', NULL, NULL, 'Adhesion G protein-coupled receptor L2', NULL, NULL, NULL, NULL, NULL, 4),
(88515, NULL, 'G3DSA:1.20.1260.20:FF:000001', NULL, NULL, 'PPE family protein PPE41', NULL, NULL, NULL, NULL, NULL, 4),
(88516, NULL, 'G3DSA:2.10.25.10:FF:000856', NULL, NULL, 'Crumbs', NULL, NULL, NULL, NULL, NULL, 4),
(88517, NULL, 'G3DSA:1.10.3080.10:FF:000088', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(88518, NULL, 'G3DSA:3.40.50.720:FF:000960', NULL, NULL, 'Acyl-CoA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88519, NULL, 'G3DSA:3.50.50.60:FF:000302', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(88520, NULL, 'G3DSA:3.20.70.20:FF:000017', NULL, NULL, 'Vitamin B12-dependent ribonucleotide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(88521, NULL, 'G3DSA:3.30.70.330:FF:002434', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88522, NULL, 'G3DSA:3.40.50.2000:FF:001028', NULL, NULL, 'UDP-N-acetylglucosamine transferase subunit ALG14 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(88523, NULL, 'G3DSA:2.10.70.10:FF:000169', NULL, NULL, 'Mannan-binding lectin serine peptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(88524, NULL, 'G3DSA:2.60.120.1380:FF:000001', NULL, NULL, 'Alginate biosynthesis protein AlgX', NULL, NULL, NULL, NULL, NULL, 4),
(88525, NULL, 'G3DSA:1.10.510.10:FF:002713', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88526, NULL, 'G3DSA:1.10.1140.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88527, NULL, 'G3DSA:2.10.25.10:FF:000755', NULL, NULL, 'Blast:Protein slit', NULL, NULL, NULL, NULL, NULL, 4),
(88528, NULL, 'G3DSA:3.40.50.1820:FF:000906', NULL, NULL, 'Neuroligin 1', NULL, NULL, NULL, NULL, NULL, 4),
(88529, NULL, 'G3DSA:1.10.420.10:FF:000014', NULL, NULL, 'Catalase-peroxidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(88530, NULL, 'G3DSA:3.30.40.10:FF:001850', NULL, NULL, 'SR-related CTD-associated factor 11', NULL, NULL, NULL, NULL, NULL, 4),
(88531, NULL, 'G3DSA:3.90.70.10:FF:000427', NULL, NULL, 'Cathepsin C', NULL, NULL, NULL, NULL, NULL, 4),
(88532, NULL, 'G3DSA:1.20.1060.10:FF:000011', NULL, NULL, 'DNA polymerase theta', NULL, NULL, NULL, NULL, NULL, 4),
(88533, NULL, 'G3DSA:1.20.1270.10:FF:000066', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(88534, NULL, 'G3DSA:3.10.580.10:FF:000214', NULL, NULL, 'Protein CBR-CLH-6', NULL, NULL, NULL, NULL, NULL, 4),
(88535, NULL, 'G3DSA:2.60.40.10:FF:002273', NULL, NULL, 'Disorganized muscle protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(88536, NULL, 'G3DSA:1.20.5.1230:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88537, NULL, 'G3DSA:3.20.20.60:FF:000054', NULL, NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(88538, NULL, 'G3DSA:3.40.1170.10:FF:000024', NULL, NULL, 'Muts domain V-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(88539, NULL, 'G3DSA:2.60.60.20:FF:000017', NULL, NULL, 'Polycystin 1 like 1, transient receptor potential channel interacting', NULL, NULL, NULL, NULL, NULL, 4),
(88540, NULL, 'G3DSA:3.40.50.300:FF:000278', NULL, NULL, 'Structural maintenance of chromosomes 2', NULL, NULL, NULL, NULL, NULL, 4),
(88541, NULL, 'G3DSA:2.60.40.10:FF:001654', NULL, NULL, 'Cytokine receptor common subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(88542, NULL, 'G3DSA:3.30.160.60:FF:002486', NULL, NULL, 'Zinc finger protein 549', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(88543, NULL, 'G3DSA:3.50.50.60:FF:000291', NULL, NULL, 'Peroxisomal N(1)-acetyl-spermine/spermidine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(88544, NULL, 'G3DSA:2.40.10.120:FF:000006', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(88545, NULL, 'G3DSA:2.60.120.10:FF:000178', NULL, NULL, 'Mannose-6-phosphate isomerase, class I', NULL, NULL, NULL, NULL, NULL, 4),
(88546, NULL, 'G3DSA:3.60.10.10:FF:000245', NULL, NULL, 'DNAse I-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(88547, NULL, 'G3DSA:3.40.50.300:FF:003133', NULL, NULL, 'Regulator of nonsense transcripts 1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(88548, NULL, 'G3DSA:1.20.1560.10:FF:000509', NULL, NULL, 'ABC transporter, MRP family', NULL, NULL, NULL, NULL, NULL, 4),
(88549, NULL, 'G3DSA:2.60.40.10:FF:004291', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88550, NULL, 'G3DSA:3.90.550.50:FF:000077', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(88551, NULL, 'G3DSA:1.10.472.10:FF:000027', NULL, NULL, 'G2/mitotic-specific cyclin-B1', NULL, NULL, NULL, NULL, NULL, 4),
(88552, NULL, 'G3DSA:2.10.60.10:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88553, NULL, 'G3DSA:3.30.230.10:FF:000240', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(88554, NULL, 'G3DSA:3.40.50.1820:FF:000895', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88555, NULL, 'G3DSA:2.40.110.10:FF:000025', NULL, NULL, 'Acyl-CoA dehydrogenase, C-terminal domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(88556, NULL, 'G3DSA:3.30.70.1230:FF:000120', NULL, NULL, 'Olfactory guanylyl cyclase GC-D', NULL, NULL, NULL, NULL, NULL, 4),
(88557, NULL, 'G3DSA:1.20.120.350:FF:000096', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(88558, NULL, 'G3DSA:1.50.40.10:FF:000257', NULL, NULL, 'Carnitine/acyl carnitine carrier', NULL, NULL, NULL, NULL, NULL, 4),
(88559, NULL, 'G3DSA:2.60.40.10:FF:003897', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88560, NULL, 'G3DSA:3.40.1380.20:FF:000048', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(88561, NULL, 'G3DSA:1.20.120.1240:FF:000021', NULL, NULL, 'Dynamin-related protein 4C', NULL, NULL, NULL, NULL, NULL, 4),
(88562, NULL, 'G3DSA:2.40.70.10:FF:000111', NULL, NULL, 'Plasmepsin IX', NULL, NULL, NULL, NULL, NULL, 4),
(88563, NULL, 'G3DSA:1.10.630.10:FF:000631', NULL, NULL, 'Cytochrome P450, family 2, subfamily R, polypeptide 1', NULL, NULL, NULL, NULL, NULL, 4),
(88564, NULL, 'G3DSA:1.10.8.60:FF:000119', NULL, NULL, 'Lon protease', NULL, NULL, NULL, NULL, NULL, 4),
(88565, NULL, 'G3DSA:1.20.58.1780:FF:000017', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(88566, NULL, 'G3DSA:1.20.120.980:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88567, NULL, 'G3DSA:1.10.10.60:FF:001059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88568, NULL, 'G3DSA:1.20.120.1760:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88569, NULL, 'G3DSA:3.30.870.10:FF:000193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88570, NULL, 'G3DSA:3.90.1600.10:FF:000030', NULL, NULL, 'DNA polymerase II', NULL, NULL, NULL, NULL, NULL, 4),
(88571, NULL, 'G3DSA:3.30.160.60:FF:005465', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88572, NULL, 'G3DSA:3.40.50.1000:FF:000088', NULL, NULL, 'Probable bifunctional methylthioribulose-1-phosphate dehydratase/enolase-phosphatase E1', NULL, NULL, NULL, NULL, NULL, 4),
(88573, NULL, 'G3DSA:1.20.1270.280:FF:000002', NULL, NULL, 'Dynein heavy chain 5, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(88574, NULL, 'G3DSA:2.120.10.30:FF:000520', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88575, NULL, 'G3DSA:3.40.30.10:FF:000646', NULL, NULL, 'Disulphide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(88576, NULL, 'G3DSA:1.20.1250.20:FF:001916', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(88577, NULL, 'G3DSA:2.60.200.20:FF:000250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88578, NULL, 'G3DSA:3.10.20.90:FF:000687', NULL, NULL, 'ISG15 ubiquitin-like modifier', NULL, NULL, NULL, NULL, NULL, 4),
(88579, NULL, 'G3DSA:3.40.50.300:FF:004881', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88580, NULL, 'G3DSA:2.40.160.10:FF:000056', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(88581, NULL, 'G3DSA:1.10.3470.10:FF:000011', NULL, NULL, 'Fe(3+)-hydroxamate ABC transporter permease FhuB', NULL, NULL, NULL, NULL, NULL, 4),
(88582, NULL, 'G3DSA:3.10.110.10:FF:000174', NULL, NULL, 'Ubiquitin-conjugating enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(88583, NULL, 'G3DSA:1.20.58.60:FF:000707', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(88584, NULL, 'G3DSA:3.80.20.20:FF:000006', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(88585, NULL, 'G3DSA:2.40.70.10:FF:000235', NULL, NULL, 'GD19153', NULL, NULL, NULL, NULL, NULL, 4),
(88586, NULL, 'G3DSA:2.40.100.10:FF:000064', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase CPR4', NULL, NULL, NULL, NULL, NULL, 4),
(88587, NULL, 'G3DSA:1.20.1270.60:FF:000154', NULL, NULL, 'Sorting nexin-2', NULL, NULL, NULL, NULL, NULL, 4),
(88588, NULL, 'G3DSA:2.60.40.10:FF:001749', NULL, NULL, 'Neural/ectodermal development factor IMP-L2', NULL, NULL, NULL, NULL, NULL, 4),
(88589, NULL, 'G3DSA:2.40.50.140:FF:000531', NULL, NULL, 'mRNA capping enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88590, NULL, 'G3DSA:3.30.50.10:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88591, NULL, 'G3DSA:1.20.120.350:FF:000202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88592, NULL, 'G3DSA:3.40.50.10330:FF:000053', NULL, NULL, 'NAD kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(88593, NULL, 'G3DSA:2.60.40.2030:FF:000027', NULL, NULL, 'Adhesion G protein-coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(88594, NULL, 'G3DSA:3.30.40.10:FF:001271', NULL, NULL, 'Uncharacterized ATP-dependent helicase C17A2.12', NULL, NULL, NULL, NULL, NULL, 4),
(88595, NULL, 'G3DSA:3.30.40.10:FF:001041', NULL, NULL, 'HL01030p', NULL, NULL, NULL, NULL, NULL, 4),
(88596, NULL, 'G3DSA:2.60.40.1730:FF:000050', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(88597, NULL, 'G3DSA:3.40.1350.10:FF:000010', NULL, NULL, 'Heteromeric transposase endonuclease subunit TnsA', NULL, NULL, NULL, NULL, NULL, 4),
(88598, NULL, 'G3DSA:1.20.1560.10:FF:000268', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(88599, NULL, 'G3DSA:1.25.40.20:FF:000465', NULL, NULL, 'Os09g0343200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(88600, NULL, 'G3DSA:1.20.58.370:FF:000001', NULL, NULL, 'Maltose ABC transporter permease MalF', NULL, NULL, NULL, NULL, NULL, 4),
(88601, NULL, 'G3DSA:1.10.510.10:FF:002258', NULL, NULL, 'CMGC/SRPK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(88602, NULL, 'G3DSA:3.40.50.300:FF:008271', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88603, NULL, 'G3DSA:3.40.50.1820:FF:000002', NULL, NULL, 'S-formylglutathione hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(88604, NULL, 'G3DSA:3.80.10.10:FF:003386', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(88605, NULL, 'G3DSA:3.40.50.200:FF:000135', NULL, NULL, 'Tripeptidyl peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(88606, NULL, 'G3DSA:2.60.40.2070:FF:000011', NULL, NULL, 'Outer membrane usher protein FasD', NULL, NULL, NULL, NULL, NULL, 4),
(88607, NULL, 'G3DSA:3.30.565.10:FF:000079', NULL, NULL, 'DNA mismatch repair protein MLH', NULL, NULL, NULL, NULL, NULL, 4),
(88608, NULL, 'G3DSA:2.70.160.11:FF:000039', NULL, NULL, 'Related to HMT1-hnRNP arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(88609, NULL, 'G3DSA:3.30.750.44:FF:000012', NULL, NULL, 'Peptidase, S41 family', NULL, NULL, NULL, NULL, NULL, 4),
(88610, NULL, 'G3DSA:1.10.287.160:FF:000029', NULL, NULL, 'Protein kinase N1', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(88611, NULL, 'G3DSA:3.30.40.10:FF:000765', NULL, NULL, 'Transcription initiation factor TFIIE alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88612, NULL, 'G3DSA:1.20.120.140:FF:000021', NULL, NULL, 'Signal recognition particle receptor FtsY', NULL, NULL, NULL, NULL, NULL, 4),
(88613, NULL, 'G3DSA:3.80.10.10:FF:000160', NULL, NULL, 'Protein zer-1 homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(88614, NULL, 'G3DSA:3.40.50.10190:FF:000331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88615, NULL, 'G3DSA:2.60.40.150:FF:000713', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88616, NULL, 'G3DSA:3.30.70.590:FF:000011', NULL, NULL, 'WGS project CABT00000000 data, contig 2.5', NULL, NULL, NULL, NULL, NULL, 4),
(88617, NULL, 'G3DSA:3.30.200.20:FF:002214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88618, NULL, 'G3DSA:3.30.2300.10:FF:000015', NULL, NULL, 'THUMP domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(88619, NULL, 'G3DSA:1.25.40.180:FF:000002', NULL, NULL, 'Eukaryotic translation initiation factor 4 gamma, 3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88620, NULL, 'G3DSA:3.30.559.30:FF:000014', NULL, NULL, 'Nonribosomal siderophore peptide synthase SidC', NULL, NULL, NULL, NULL, NULL, 4),
(88621, NULL, 'G3DSA:3.30.830.10:FF:000196', NULL, NULL, 'Metalloprotease, insulinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(88622, NULL, 'G3DSA:1.10.10.10:FF:000549', NULL, NULL, 'Transcriptional regulator, MarR family', NULL, NULL, NULL, NULL, NULL, 4),
(88623, NULL, 'G3DSA:1.20.960.10:FF:000007', NULL, NULL, 'Mitochondrial import receptor subunit TOM20-like protein B', NULL, NULL, NULL, NULL, NULL, 4),
(88624, NULL, 'G3DSA:1.10.150.20:FF:000142', NULL, NULL, 'Exonuclease I, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88625, NULL, 'G3DSA:3.90.70.10:FF:000219', NULL, NULL, 'CaLPain Related', NULL, NULL, NULL, NULL, NULL, 4),
(88626, NULL, 'G3DSA:3.70.10.10:FF:000025', NULL, NULL, 'AGAP002522-PA', NULL, NULL, NULL, NULL, NULL, 4),
(88627, NULL, 'G3DSA:1.20.1250.20:FF:002310', NULL, NULL, 'MFS drug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88628, NULL, 'G3DSA:1.25.40.10:FF:001985', NULL, NULL, 'Os09g0520300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(88629, NULL, 'G3DSA:3.30.230.10:FF:000010', NULL, NULL, 'Lon protease', NULL, NULL, NULL, NULL, NULL, 4),
(88630, NULL, 'G3DSA:3.40.50.2000:FF:000854', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(88631, NULL, 'G3DSA:3.40.50.150:FF:001278', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88632, NULL, 'G3DSA:3.50.7.10:FF:000082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88633, NULL, 'G3DSA:1.25.40.10:FF:004391', NULL, NULL, 'Tetratricopeptide repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88634, NULL, 'G3DSA:2.60.40.1170:FF:000084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88635, NULL, 'G3DSA:1.10.260.70:FF:000002', NULL, NULL, 'DNA-binding protein SATB', NULL, NULL, NULL, NULL, NULL, 4),
(88636, NULL, 'G3DSA:1.20.120.160:FF:000027', NULL, NULL, 'Sensory box sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(88637, NULL, 'G3DSA:3.30.160.60:FF:004408', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88638, NULL, 'G3DSA:2.40.40.20:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88639, NULL, 'G3DSA:3.30.260.10:FF:000079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88640, NULL, 'G3DSA:3.30.70.260:FF:000159', NULL, NULL, 'Bifunctional chorismate mutase/prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(88641, NULL, 'G3DSA:2.10.220.10:FF:000028', NULL, NULL, 'Fraser extracellular matrix complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(88642, NULL, 'G3DSA:3.30.40.10:FF:000422', NULL, NULL, 'RING/FYVE/PHD zinc finger superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(88643, NULL, 'G3DSA:2.60.40.10:FF:006089', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(88644, NULL, 'G3DSA:2.20.80.10:FF:000023', NULL, NULL, 'Apolipophorins-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(88645, NULL, 'G3DSA:3.80.10.10:FF:002537', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88646, NULL, 'G3DSA:1.20.1050.10:FF:000061', NULL, NULL, 'Glutathione S-transferase 3', NULL, NULL, NULL, NULL, NULL, 4),
(88647, NULL, 'G3DSA:1.25.40.180:FF:000345', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88648, NULL, 'G3DSA:3.90.1410.10:FF:000083', NULL, NULL, 'Ribosomal lysine N-methyltransferase 4', NULL, NULL, NULL, NULL, NULL, 4),
(88649, NULL, 'G3DSA:3.40.50.300:FF:007652', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88650, NULL, 'G3DSA:3.30.160.60:FF:003312', NULL, NULL, 'Zinc finger protein 438', NULL, NULL, NULL, NULL, NULL, 4),
(88651, NULL, 'G3DSA:3.30.200.20:FF:000977', NULL, NULL, 'S-receptor kinase-like', NULL, NULL, NULL, NULL, NULL, 4),
(88652, NULL, 'G3DSA:3.30.160.60:FF:002694', NULL, NULL, 'Zinc finger protein 729', NULL, NULL, NULL, NULL, NULL, 4),
(88653, NULL, 'G3DSA:3.40.1110.10:FF:000127', NULL, NULL, 'Probable cation-transporting ATPase exp7', NULL, NULL, NULL, NULL, NULL, 4),
(88654, NULL, 'G3DSA:3.30.1330.30:FF:000051', NULL, NULL, 'Protein pelota homolog', NULL, NULL, NULL, NULL, NULL, 4),
(88655, NULL, 'G3DSA:1.10.510.10:FF:004287', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88656, NULL, 'G3DSA:1.10.10.580:FF:000008', NULL, NULL, 'OJ991113_30.15 protein', NULL, NULL, NULL, NULL, NULL, 4),
(88657, NULL, 'G3DSA:3.40.1160.10:FF:000063', NULL, NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(88658, NULL, 'G3DSA:2.40.50.140:FF:001256', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88659, NULL, 'G3DSA:1.25.40.10:FF:002261', NULL, NULL, 'Sel1 repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(88660, NULL, 'G3DSA:1.25.40.10:FF:004161', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(88661, NULL, 'G3DSA:3.40.50.300:FF:004229', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(88662, NULL, 'G3DSA:3.40.390.30:FF:000002', NULL, NULL, 'Holo-[acyl-carrier-protein] synthase', NULL, NULL, NULL, NULL, NULL, 4),
(88663, NULL, 'G3DSA:1.20.920.10:FF:000229', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(88664, NULL, 'G3DSA:2.60.40.420:FF:000249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88665, NULL, 'G3DSA:3.40.50.1000:FF:000200', NULL, NULL, 'NLI interacting factor-like phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88666, NULL, 'G3DSA:2.60.120.560:FF:000042', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(88667, NULL, 'G3DSA:3.30.420.110:FF:000020', NULL, NULL, 'Msh1p', NULL, NULL, NULL, NULL, NULL, 4),
(88668, NULL, 'G3DSA:1.20.1070.10:FF:000865', NULL, NULL, 'LOW QUALITY PROTEIN: uncharacterized protein LOC108100164', NULL, NULL, NULL, NULL, NULL, 4),
(88669, NULL, 'G3DSA:2.60.40.10:FF:003099', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(88670, NULL, 'G3DSA:1.20.5.170:FF:000273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88671, NULL, 'G3DSA:1.10.3450.30:FF:000004', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(88672, NULL, 'G3DSA:1.10.10.60:FF:001267', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88673, NULL, 'G3DSA:3.30.160.60:FF:006308', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88674, NULL, 'G3DSA:1.25.40.10:FF:003885', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88675, NULL, 'G3DSA:3.30.1240.10:FF:000066', NULL, NULL, 'Hydrolase (HAD superfamily)', NULL, NULL, NULL, NULL, NULL, 4),
(88676, NULL, 'G3DSA:3.30.420.10:FF:000518', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88677, NULL, 'G3DSA:2.130.10.10:FF:001278', NULL, NULL, 'Compass component swd1', NULL, NULL, NULL, NULL, NULL, 4),
(88678, NULL, 'G3DSA:1.20.5.30:FF:000003', NULL, NULL, 'cartilage matrix protein-like', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(88679, NULL, 'G3DSA:3.30.70.660:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88680, NULL, 'G3DSA:1.10.460.10:FF:000011', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(88681, NULL, 'G3DSA:3.40.50.300:FF:006224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88682, NULL, 'G3DSA:1.20.1250.20:FF:001793', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88683, NULL, 'G3DSA:1.10.510.10:FF:000813', NULL, NULL, 'Aurora-like kinase', NULL, NULL, NULL, NULL, NULL, 4),
(88684, NULL, 'G3DSA:1.20.1070.10:FF:001141', NULL, NULL, 'G-protein coupled receptor 126', NULL, NULL, NULL, NULL, NULL, 4),
(88685, NULL, 'G3DSA:3.10.196.10:FF:000012', NULL, NULL, 'Methionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(88686, NULL, 'G3DSA:3.40.50.300:FF:006359', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88687, NULL, 'G3DSA:3.10.20.30:FF:000046', NULL, NULL, 'Obg-like ATPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(88688, NULL, 'G3DSA:3.40.50.880:FF:000069', NULL, NULL, 'CTP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(88689, NULL, 'G3DSA:3.30.43.10:FF:000007', NULL, NULL, 'UDP-N-acetylenolpyruvoylglucosamine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(88690, NULL, 'G3DSA:2.40.70.10:FF:000027', NULL, NULL, 'Aspartic proteinase Asp1 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(88691, NULL, 'G3DSA:3.40.50.150:FF:000429', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase G', NULL, NULL, NULL, NULL, NULL, 4),
(88692, NULL, 'G3DSA:3.40.50.1820:FF:001755', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88693, NULL, 'G3DSA:2.40.30.10:FF:000114', NULL, NULL, '5-methyltetrahydrofolate-homocysteine methyltransferase reductase', NULL, NULL, NULL, NULL, NULL, 4),
(88694, NULL, 'G3DSA:1.10.472.80:FF:000008', NULL, NULL, 'TBC1 domain family member 10A', NULL, NULL, NULL, NULL, NULL, 4),
(88695, NULL, 'G3DSA:3.30.160.60:FF:002351', NULL, NULL, 'Unplaced genomic scaffold supercont1.68, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(88696, NULL, 'G3DSA:3.40.50.150:FF:001839', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88697, NULL, 'G3DSA:3.40.47.10:FF:000050', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(88698, NULL, 'G3DSA:2.30.42.10:FF:000210', NULL, NULL, 'Patj, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(88699, NULL, 'G3DSA:3.30.930.10:FF:000029', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(88700, NULL, 'G3DSA:1.10.287.950:FF:000041', NULL, NULL, 'Methyl-accepting chemotaxis sensory transducer', NULL, NULL, NULL, NULL, NULL, 4),
(88701, NULL, 'G3DSA:1.10.10.10:FF:001977', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(88702, NULL, 'G3DSA:3.30.497.10:FF:000033', NULL, NULL, 'serpin B3', NULL, NULL, NULL, NULL, NULL, 4),
(88703, NULL, 'G3DSA:3.30.70.330:FF:001265', NULL, NULL, 'Unplaced genomic scaffold supercont1.20, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(88704, NULL, 'G3DSA:3.40.50.1820:FF:001412', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88705, NULL, 'G3DSA:4.10.60.10:FF:000091', NULL, NULL, 'Zinc finger CCHC-type-containing 9', NULL, NULL, NULL, NULL, NULL, 4),
(88706, NULL, 'G3DSA:1.20.140.150:FF:000034', NULL, NULL, 'Germ cell associated 1', NULL, NULL, NULL, NULL, NULL, 4),
(88707, NULL, 'G3DSA:3.30.300.160:FF:000008', NULL, NULL, 'Type IV pilus assembly protein PilB', NULL, NULL, NULL, NULL, NULL, 4),
(88708, NULL, 'G3DSA:3.30.210.10:FF:000008', NULL, NULL, 'DNA polymerase beta', NULL, NULL, NULL, NULL, NULL, 4),
(88709, NULL, 'G3DSA:3.10.50.40:FF:000096', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(88710, NULL, 'G3DSA:2.70.170.10:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88711, NULL, 'G3DSA:2.60.120.480:FF:000006', NULL, NULL, 'Ureidoglycolate hydrolase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(88712, NULL, 'G3DSA:3.40.50.2300:FF:000163', NULL, NULL, 'LacI family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(88713, NULL, 'G3DSA:3.30.200.20:FF:002534', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88714, NULL, 'G3DSA:1.25.40.20:FF:001645', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88715, NULL, 'G3DSA:1.10.560.10:FF:000075', NULL, NULL, 'Bardet-Biedl syndrome 10', NULL, NULL, NULL, NULL, NULL, 4),
(88716, NULL, 'G3DSA:3.40.50.300:FF:001790', NULL, NULL, 'Protein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(88717, NULL, 'G3DSA:3.40.50.720:FF:001466', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(88718, NULL, 'G3DSA:2.30.30.40:FF:000438', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(88719, NULL, 'G3DSA:1.10.10.60:FF:000441', NULL, NULL, 'Homeotic protein bicoid', NULL, NULL, NULL, NULL, NULL, 4),
(88720, NULL, 'G3DSA:3.30.70.330:FF:000989', NULL, NULL, 'RNA Binding Motif protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(88721, NULL, 'G3DSA:3.30.70.870:FF:000005', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(88722, NULL, 'G3DSA:1.10.555.10:FF:000085', NULL, NULL, 'Rho GTPase-activating protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(88723, NULL, 'G3DSA:1.25.40.10:FF:000349', NULL, NULL, 'Putative Pre-mRNA-splicing factor syf1', NULL, NULL, NULL, NULL, NULL, 4),
(88724, NULL, 'G3DSA:1.10.8.270:FF:000114', NULL, NULL, 'GTPase-activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88725, NULL, 'G3DSA:2.130.10.10:FF:003886', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88726, NULL, 'G3DSA:2.30.29.30:FF:000808', NULL, NULL, 'Eps8 like 1b', NULL, NULL, NULL, NULL, NULL, 4),
(88727, NULL, 'G3DSA:2.60.40.60:FF:000461', NULL, NULL, 'Protein CBG15736', NULL, NULL, NULL, NULL, NULL, 4),
(88728, NULL, 'G3DSA:3.20.20.80:FF:000723', NULL, NULL, 'Putative chitinase 3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(88729, NULL, 'G3DSA:3.30.70.330:FF:000759', NULL, NULL, 'RNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(88730, NULL, 'G3DSA:1.25.40.10:FF:001288', NULL, NULL, 'Os01g0280400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(88731, NULL, 'G3DSA:1.20.1070.10:FF:000989', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(88732, NULL, 'G3DSA:3.40.50.300:FF:007539', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88733, NULL, 'G3DSA:3.40.1190.20:FF:000135', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(88734, NULL, 'G3DSA:1.20.58.340:FF:000003', NULL, NULL, 'Zinc transport protein ZntB', NULL, NULL, NULL, NULL, NULL, 4),
(88735, NULL, 'G3DSA:2.160.20.10:FF:000344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88736, NULL, 'G3DSA:2.60.40.10:FF:004414', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88737, NULL, 'G3DSA:3.30.70.100:FF:000033', NULL, NULL, 'Copper-transporting ATPase HMA5', NULL, NULL, NULL, NULL, NULL, 4),
(88738, NULL, 'G3DSA:3.50.50.60:FF:001139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88739, NULL, 'G3DSA:3.20.20.10:FF:000079', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(88740, NULL, 'G3DSA:1.10.1040.10:FF:000079', NULL, NULL, 'NAD binding domain of 6-phosphogluconate dehydrogenase/NAD-binding of NADP-dependent 3-hydroxyisobutyrate dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88741, NULL, 'G3DSA:4.10.400.10:FF:000294', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88742, NULL, 'G3DSA:2.60.120.10:FF:000633', NULL, NULL, '5-nitrosalicylic acid 1,2-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(88743, NULL, 'G3DSA:3.40.50.1820:FF:001194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88744, NULL, 'G3DSA:3.30.310.10:FF:000061', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(88745, NULL, 'G3DSA:1.20.5.470:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88746, NULL, 'G3DSA:2.40.30.10:FF:000238', NULL, NULL, 'Elongation factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88747, NULL, 'G3DSA:3.30.70.330:FF:000416', NULL, NULL, 'CCR4-NOT transcription complex subunit 4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88748, NULL, 'G3DSA:3.30.200.20:FF:001697', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88749, NULL, 'G3DSA:3.20.20.190:FF:000142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88750, NULL, 'G3DSA:1.10.287.110:FF:000025', NULL, NULL, 'dnaJ homolog subfamily A member 3, mitochondrial isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(88751, NULL, 'G3DSA:3.30.9.10:FF:000029', NULL, NULL, 'N,N-dimethylglycine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(88752, NULL, 'G3DSA:1.20.5.190:FF:000020', NULL, NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(88753, NULL, 'G3DSA:1.10.3890.10:FF:000003', NULL, NULL, 'High frequency lysogenization protein HflD homolog', NULL, NULL, NULL, NULL, NULL, 4),
(88754, NULL, 'G3DSA:3.40.50.300:FF:004105', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(88755, NULL, 'G3DSA:3.30.470.20:FF:000103', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(88756, NULL, 'G3DSA:3.60.21.50:FF:000012', NULL, NULL, 'DNA polymerase delta subunit 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88757, NULL, 'G3DSA:2.60.120.620:FF:000071', NULL, NULL, '2-oxoglutarate and iron-dependent oxygenase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(88758, NULL, 'G3DSA:3.10.100.10:FF:000117', NULL, NULL, 'Mannose receptor, C type 1b', NULL, NULL, NULL, NULL, NULL, 4),
(88759, NULL, 'G3DSA:1.25.40.10:FF:004059', NULL, NULL, 'Glr1376 protein', NULL, NULL, NULL, NULL, NULL, 4),
(88760, NULL, 'G3DSA:2.130.10.10:FF:000452', NULL, NULL, 'TBC1 domain family member 31 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(88761, NULL, 'G3DSA:3.30.70.1620:FF:000012', NULL, NULL, 'Structural maintenance of chromosomes protein', NULL, NULL, NULL, NULL, NULL, 4),
(88762, NULL, 'G3DSA:3.40.850.10:FF:000498', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88763, NULL, 'G3DSA:1.20.1560.10:FF:000829', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(88764, NULL, 'G3DSA:1.20.120.1900:FF:000022', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(88765, NULL, 'G3DSA:1.10.20.10:FF:000281', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88766, NULL, 'G3DSA:3.40.50.2000:FF:000399', NULL, NULL, 'UDP-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(88767, NULL, 'G3DSA:2.10.25.140:FF:000001', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(88768, NULL, 'G3DSA:3.40.50.2300:FF:001568', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88769, NULL, 'G3DSA:2.10.25.10:FF:001475', NULL, NULL, 'Neurogenic locus protein delta', NULL, NULL, NULL, NULL, NULL, 4),
(88770, NULL, 'G3DSA:3.30.559.10:FF:000267', NULL, NULL, 'Vinorine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(88771, NULL, 'G3DSA:2.130.10.10:FF:004504', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88772, NULL, 'G3DSA:3.30.930.10:FF:000361', NULL, NULL, 'Phenylalanyl-tRNA synthetase, alpha subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(88773, NULL, 'G3DSA:3.30.30.30:FF:000034', NULL, NULL, 'Related to SSZ1-regulator protein involved in pleiotropic drug resistance', NULL, NULL, NULL, NULL, NULL, 4),
(88774, NULL, 'G3DSA:3.40.50.300:FF:004561', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(88775, NULL, 'G3DSA:2.60.40.790:FF:000118', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88776, NULL, 'G3DSA:1.25.10.10:FF:001792', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88777, NULL, 'G3DSA:2.60.40.3710:FF:000003', NULL, NULL, 'L,D-transpeptidase 5', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(88778, NULL, 'G3DSA:1.25.40.850:FF:000006', NULL, NULL, 'Vacuolar protein sorting-associated protein 33B', NULL, NULL, NULL, NULL, NULL, 4),
(88779, NULL, 'G3DSA:3.90.550.10:FF:000335', NULL, NULL, 'CMP-N-acetlyneuraminic acid synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(88780, NULL, 'G3DSA:1.25.40.10:FF:003542', NULL, NULL, 'Putative two-component system sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(88781, NULL, 'G3DSA:1.20.58.1210:FF:000004', NULL, NULL, 'Exocyst complex component EXO84C', NULL, NULL, NULL, NULL, NULL, 4),
(88782, NULL, 'G3DSA:1.25.40.990:FF:000020', NULL, NULL, 'Unplaced genomic scaffold supercont2.13, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(88783, NULL, 'G3DSA:2.60.120.290:FF:000039', NULL, NULL, 'LDL receptor related protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(88784, NULL, 'G3DSA:2.60.40.640:FF:000091', NULL, NULL, 'Arrestin domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(88785, NULL, 'G3DSA:1.25.40.540:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88786, NULL, 'G3DSA:3.40.50.261:FF:000014', NULL, NULL, 'Acyl-CoA synthetase FdrA', NULL, NULL, NULL, NULL, NULL, 4),
(88787, NULL, 'G3DSA:3.50.50.60:FF:001471', NULL, NULL, 'Succinate dehydrogenase1', NULL, NULL, NULL, NULL, NULL, 4),
(88788, NULL, 'G3DSA:3.30.160.60:FF:000356', NULL, NULL, 'E3 ubiquitin-protein ligase ZFP91', NULL, NULL, NULL, NULL, NULL, 4),
(88789, NULL, 'G3DSA:3.40.50.1100:FF:000016', NULL, NULL, 'Cysteine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(88790, NULL, 'G3DSA:2.60.200.20:FF:000019', NULL, NULL, 'Nuclear inhibitor of protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(88791, NULL, 'G3DSA:2.60.120.10:FF:000072', NULL, NULL, 'cGMP-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(88792, NULL, 'G3DSA:2.130.10.10:FF:003762', NULL, NULL, 'FG-GAP repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88793, NULL, 'G3DSA:2.10.25.160:FF:000007', NULL, NULL, 'Granulin b', NULL, NULL, NULL, NULL, NULL, 4),
(88794, NULL, 'G3DSA:3.40.50.300:FF:007995', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88795, NULL, 'G3DSA:2.40.50.100:FF:000093', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(88796, NULL, 'G3DSA:3.40.50.1000:FF:000099', NULL, NULL, 'Trehalose 6-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(88797, NULL, 'G3DSA:3.40.50.720:FF:002303', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(88798, NULL, 'G3DSA:1.20.120.1810:FF:000006', NULL, NULL, 'RNA polymerase sigma factor RpoH', NULL, NULL, NULL, NULL, NULL, 4),
(88799, NULL, 'G3DSA:1.10.472.130:FF:000032', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(88800, NULL, 'G3DSA:3.40.50.1000:FF:000655', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88801, NULL, 'G3DSA:1.10.530.40:FF:000008', NULL, NULL, 'Lambda phage lysozyme R', NULL, NULL, NULL, NULL, NULL, 4),
(88802, NULL, 'G3DSA:3.30.160.60:FF:004279', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88803, NULL, 'G3DSA:3.40.50.300:FF:003588', NULL, NULL, 'GM04779p', NULL, NULL, NULL, NULL, NULL, 4),
(88804, NULL, 'G3DSA:2.130.10.10:FF:000553', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(88805, NULL, 'G3DSA:3.40.50.10190:FF:000095', NULL, NULL, 'Mutator 2, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(88806, NULL, 'G3DSA:3.60.10.10:FF:000110', NULL, NULL, 'Putative carbon catabolite repressor protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(88807, NULL, 'G3DSA:1.10.730.10:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88808, NULL, 'G3DSA:1.25.40.10:FF:000344', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(88809, NULL, 'G3DSA:3.30.830.10:FF:000331', NULL, NULL, 'Presequence protease', NULL, NULL, NULL, NULL, NULL, 4),
(88810, NULL, 'G3DSA:3.30.40.10:FF:002007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(88811, NULL, 'G3DSA:2.40.110.10:FF:000002', NULL, NULL, 'Acyl-CoA dehydrogenase fadE12', NULL, NULL, NULL, NULL, NULL, 4),
(88812, NULL, 'G3DSA:3.40.50.720:FF:000510', NULL, NULL, 'Putative oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(88813, NULL, 'G3DSA:3.30.70.2370:FF:000001', NULL, NULL, 'Subtilisin-like protease 2', NULL, NULL, NULL, NULL, NULL, 4),
(88814, NULL, 'G3DSA:3.10.105.10:FF:000095', NULL, NULL, 'ABC-type transport system periplasmic substrate-binding protein (Probable substrate dipeptide/oligopeptide)', NULL, NULL, NULL, NULL, NULL, 4),
(88815, NULL, 'G3DSA:4.10.280.10:FF:000058', NULL, NULL, 'transcription factor BEE 3-like', NULL, NULL, NULL, NULL, NULL, 4),
(88816, NULL, 'G3DSA:3.90.470.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88817, NULL, 'G3DSA:3.80.10.10:FF:001126', NULL, NULL, 'Receptor-like protein kinase HSL1 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(88818, NULL, 'G3DSA:2.40.40.20:FF:000056', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(88819, NULL, 'G3DSA:2.60.220.30:FF:000012', NULL, NULL, 'Metastasis-associated in colon cancer 1', NULL, NULL, NULL, NULL, NULL, 4),
(88820, NULL, 'G3DSA:1.25.40.10:FF:004615', NULL, NULL, 'Pre-mRNA-splicing factor prp1', NULL, NULL, NULL, NULL, NULL, 4),
(88821, NULL, 'G3DSA:1.25.40.1040:FF:000055', NULL, NULL, 'N(alpha)-acetyltransferase 15, NatA auxiliary subunit', NULL, NULL, NULL, NULL, NULL, 4),
(88822, NULL, 'G3DSA:2.40.10.10:FF:000462', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88823, NULL, 'G3DSA:3.40.50.300:FF:002065', NULL, NULL, 'ABC transporter C family member 13', NULL, NULL, NULL, NULL, NULL, 4),
(88824, NULL, 'G3DSA:2.60.40.10:FF:000468', NULL, NULL, 'Glycogen debranching enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(88825, NULL, 'G3DSA:1.25.40.10:FF:005234', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(88826, NULL, 'G3DSA:3.90.1150.10:FF:000045', NULL, NULL, '5-aminolevulinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(88827, NULL, 'G3DSA:1.10.150.20:FF:000030', NULL, NULL, 'Flap endonuclease GEN-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(88828, NULL, 'G3DSA:3.40.50.720:FF:001022', NULL, NULL, 'Predicted gene 15294', NULL, NULL, NULL, NULL, NULL, 4),
(88829, NULL, 'G3DSA:3.80.10.10:FF:001233', NULL, NULL, 'Leucine-rich repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(88830, NULL, 'G3DSA:1.25.40.10:FF:005127', NULL, NULL, 'Pentatricopeptide repeat-containing protein ELI1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(88831, NULL, 'G3DSA:2.10.25.10:FF:000300', NULL, NULL, 'Pro-epidermal growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(88832, NULL, 'G3DSA:3.40.50.2300:FF:000955', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88833, NULL, 'G3DSA:1.20.1730.10:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88834, NULL, 'G3DSA:3.30.420.40:FF:000842', NULL, NULL, 'Luminal-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(88835, NULL, 'G3DSA:3.40.50.2300:FF:001467', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88836, NULL, 'G3DSA:1.10.8.10:FF:000245', NULL, NULL, 'DExH-box helicase 57', NULL, NULL, NULL, NULL, NULL, 4),
(88837, NULL, 'G3DSA:2.40.160.120:FF:000012', NULL, NULL, 'Oxysterol-binding protein-related protein 2A', NULL, NULL, NULL, NULL, NULL, 4),
(88838, NULL, 'G3DSA:3.30.60.30:FF:000199', NULL, NULL, 'Secreted protein, acidic, cysteine-rich (osteonectin)', NULL, NULL, NULL, NULL, NULL, 4),
(88839, NULL, 'G3DSA:2.60.40.60:FF:000106', NULL, NULL, 'FAT atypical cadherin 4', NULL, NULL, NULL, NULL, NULL, 4),
(88840, NULL, 'G3DSA:3.90.320.10:FF:000048', NULL, NULL, 'Exodeoxyribonuclease V subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(88841, NULL, 'G3DSA:2.30.30.140:FF:000248', NULL, NULL, 'Metal-response element-binding transcription factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(88842, NULL, 'G3DSA:3.40.50.2300:FF:000270', NULL, NULL, 'Two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(88843, NULL, 'G3DSA:1.10.400.10:FF:000018', NULL, NULL, 'Guanine nucleotide-binding protein alpha-12 subunit', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(88844, NULL, 'G3DSA:3.40.30.10:FF:000168', NULL, NULL, 'Glutathione S-transferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(88845, NULL, 'G3DSA:2.60.120.920:FF:000054', NULL, NULL, 'Histone-lysine N-methyltransferase (Bre2), putative', NULL, NULL, NULL, NULL, NULL, 4),
(88846, NULL, 'G3DSA:3.30.40.10:FF:002114', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(88847, NULL, 'G3DSA:1.25.40.10:FF:001861', NULL, NULL, 'GG10246', NULL, NULL, NULL, NULL, NULL, 4),
(88848, NULL, 'G3DSA:3.30.160.60:FF:000120', NULL, NULL, 'Zinc finger protein 430', NULL, NULL, NULL, NULL, NULL, 4),
(88849, NULL, 'G3DSA:1.20.1560.10:FF:000493', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(88850, NULL, 'G3DSA:3.40.50.150:FF:000660', NULL, NULL, 'Hercynine oxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(88851, NULL, 'G3DSA:2.60.40.3710:FF:000008', NULL, NULL, 'Glr0971 protein', NULL, NULL, NULL, NULL, NULL, 4),
(88852, NULL, 'G3DSA:1.20.58.830:FF:000049', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(88853, NULL, 'G3DSA:3.40.50.300:FF:005842', NULL, NULL, 'ABC-type transporter, ATPase component and permease component', NULL, NULL, NULL, NULL, NULL, 4),
(88854, NULL, 'G3DSA:2.130.10.10:FF:005443', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(88855, NULL, 'G3DSA:3.40.50.620:FF:000250', NULL, NULL, 'Electron transfer flavoprotein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(88856, NULL, 'G3DSA:2.30.30.100:FF:000023', NULL, NULL, 'Small nuclear ribonucleoprotein G', NULL, NULL, NULL, NULL, NULL, 4),
(88857, NULL, 'G3DSA:3.40.50.2000:FF:000056', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(88858, NULL, 'G3DSA:3.30.40.10:FF:000990', NULL, NULL, 'E3 ubiquitin-protein ligase MIR1', NULL, NULL, NULL, NULL, NULL, 4),
(88859, NULL, 'G3DSA:1.10.287.110:FF:000469', NULL, NULL, 'J-type co-chaperone jac1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(88860, NULL, 'G3DSA:1.10.3090.10:FF:000026', NULL, NULL, 'tRNA nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(88861, NULL, 'G3DSA:3.20.20.105:FF:000020', NULL, NULL, 'Queuine tRNA-ribosyltransferase accessory subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(88862, NULL, 'G3DSA:1.20.1070.10:FF:001372', NULL, NULL, 'Purinergic receptor P2Y13', NULL, NULL, NULL, NULL, NULL, 4),
(88863, NULL, 'G3DSA:3.20.90.10:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88864, NULL, 'G3DSA:3.30.70.330:FF:002889', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88865, NULL, 'G3DSA:2.40.100.10:FF:000069', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(88866, NULL, 'G3DSA:1.20.120.350:FF:000207', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88867, NULL, 'G3DSA:2.130.10.10:FF:005336', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88868, NULL, 'G3DSA:3.40.50.300:FF:005735', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(88869, NULL, 'G3DSA:2.40.10.230:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88870, NULL, 'G3DSA:3.40.50.300:FF:000519', NULL, NULL, 'ISWI chromatin-remodeling complex ATPase CHR11', NULL, NULL, NULL, NULL, NULL, 4),
(88871, NULL, 'G3DSA:1.10.10.60:FF:000109', NULL, NULL, 'Homeobox protein MOX-2', NULL, NULL, NULL, NULL, NULL, 4),
(88872, NULL, 'G3DSA:3.30.160.60:FF:003767', NULL, NULL, 'Zinc finger protein 233', NULL, NULL, NULL, NULL, NULL, 4),
(88873, NULL, 'G3DSA:1.10.287.1660:FF:000002', NULL, NULL, 'Erythrocyte binding antigen 140', NULL, NULL, NULL, NULL, NULL, 4),
(88874, NULL, 'G3DSA:2.130.10.10:FF:005229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88875, NULL, 'G3DSA:1.20.1250.20:FF:001580', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88876, NULL, 'G3DSA:3.90.870.10:FF:000027', NULL, NULL, 'Threonylcarbamoyl-AMP synthase YrdC', NULL, NULL, NULL, NULL, NULL, 4),
(88877, NULL, 'G3DSA:3.30.430.20:FF:000005', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(88878, NULL, 'G3DSA:1.10.3470.10:FF:000016', NULL, NULL, 'Metal ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(88879, NULL, 'G3DSA:3.10.105.10:FF:000100', NULL, NULL, 'ABC-type transport system periplasmic substrate-binding protein (Probable substrate dipeptide/oligopeptide)', NULL, NULL, NULL, NULL, NULL, 4),
(88880, NULL, 'G3DSA:4.10.280.10:FF:000070', NULL, NULL, 'transcription factor bHLH30', NULL, NULL, NULL, NULL, NULL, 4),
(88881, NULL, 'G3DSA:3.40.80.10:FF:000014', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(88882, NULL, 'G3DSA:1.10.20.10:FF:000269', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88883, NULL, 'G3DSA:4.10.60.10:FF:000085', NULL, NULL, 'Zinc knuckle nucleic acid binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88884, NULL, 'G3DSA:3.10.25.10:FF:000017', NULL, NULL, 'Methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(88885, NULL, 'G3DSA:3.40.50.300:FF:000626', NULL, NULL, 'probable ATP-dependent RNA helicase DDX47', NULL, NULL, NULL, NULL, NULL, 4),
(88886, NULL, 'G3DSA:1.10.390.10:FF:000016', NULL, NULL, 'Glutamyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(88887, NULL, 'G3DSA:2.30.39.10:FF:000067', NULL, NULL, 'GM17927', NULL, NULL, NULL, NULL, NULL, 4),
(88888, NULL, 'G3DSA:2.30.30.700:FF:000001', NULL, NULL, 'Actin cytoskeleton-regulatory complex protein SLA1', NULL, NULL, NULL, NULL, NULL, 4),
(88889, NULL, 'G3DSA:1.20.1070.10:FF:001135', NULL, NULL, 'G protein-coupled receptor 17', NULL, NULL, NULL, NULL, NULL, 4),
(88890, NULL, 'G3DSA:3.40.50.2300:FF:000051', NULL, NULL, 'Two-component response regulator yehT', NULL, NULL, NULL, NULL, NULL, 4),
(88891, NULL, 'G3DSA:2.60.120.260:FF:000047', NULL, NULL, 'Reelin', NULL, NULL, NULL, NULL, NULL, 4),
(88892, NULL, 'G3DSA:3.40.50.1110:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88893, NULL, 'G3DSA:3.30.160.60:FF:000805', NULL, NULL, 'RE1-silencing transcription factor B', NULL, NULL, NULL, NULL, NULL, 4),
(88894, NULL, 'G3DSA:3.80.10.10:FF:001918', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88895, NULL, 'G3DSA:1.20.58.90:FF:000014', NULL, NULL, 'Type III secretion apparatus needle protein YscF', NULL, NULL, NULL, NULL, NULL, 4),
(88896, NULL, 'G3DSA:3.40.140.10:FF:000079', NULL, NULL, 'DNA dC->dU-editing enzyme APOBEC-3', NULL, NULL, NULL, NULL, NULL, 4),
(88897, NULL, 'G3DSA:2.100.10.30:FF:000015', NULL, NULL, 'Griffithsin', NULL, NULL, NULL, NULL, NULL, 4),
(88898, NULL, 'G3DSA:3.30.160.60:FF:002481', NULL, NULL, 'Zinc finger protein 572', NULL, NULL, NULL, NULL, NULL, 4),
(88899, NULL, 'G3DSA:1.10.760.10:FF:000051', NULL, NULL, 'Cytochrome c, mono- and diheme variants', NULL, NULL, NULL, NULL, NULL, 4),
(88900, NULL, 'G3DSA:2.60.40.1910:FF:000002', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(88901, NULL, 'G3DSA:3.40.50.1100:FF:000011', NULL, NULL, 'Cysteine synthase (o-acetylserine)', NULL, NULL, NULL, NULL, NULL, 4),
(88902, NULL, 'G3DSA:3.20.20.120:FF:000031', NULL, NULL, 'L-Ala-D/L-Glu epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(88903, NULL, 'G3DSA:3.30.70.60:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88904, NULL, 'G3DSA:3.10.20.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88905, NULL, 'G3DSA:2.130.10.10:FF:001969', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(88906, NULL, 'G3DSA:3.40.120.10:FF:000084', NULL, NULL, 'Slr1334 protein', NULL, NULL, NULL, NULL, NULL, 4),
(88907, NULL, 'G3DSA:3.30.70.80:FF:000029', NULL, NULL, 'Peptidase S8', NULL, NULL, NULL, NULL, NULL, 4),
(88908, NULL, 'G3DSA:3.40.30.10:FF:000410', NULL, NULL, 'Mitochondrial ribosomal protein L53', NULL, NULL, NULL, NULL, NULL, 4),
(88909, NULL, 'G3DSA:1.25.10.10:FF:000735', NULL, NULL, 'E3 ubiquitin-protein ligase TRIP12', NULL, NULL, NULL, NULL, NULL, 4),
(88910, NULL, 'G3DSA:3.90.220.20:FF:000004', NULL, NULL, 'Type I restriction-modification system, S subunit', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(88911, NULL, 'G3DSA:1.20.58.60:FF:000359', NULL, NULL, 'Spectrin repeat containing, nuclear envelope 1a', NULL, NULL, NULL, NULL, NULL, 4),
(88912, NULL, 'G3DSA:1.20.1060.10:FF:000016', NULL, NULL, 'DNA polymerase nu', NULL, NULL, NULL, NULL, NULL, 4),
(88913, NULL, 'G3DSA:3.10.290.10:FF:000001', NULL, NULL, '30S ribosomal protein S4', NULL, NULL, NULL, NULL, NULL, 4),
(88914, NULL, 'G3DSA:1.10.1450.10:FF:000110', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(88915, NULL, 'G3DSA:1.25.40.10:FF:004508', NULL, NULL, 'Signal recognition particle subunit SRP72', NULL, NULL, NULL, NULL, NULL, 4),
(88916, NULL, 'G3DSA:2.30.29.30:FF:000123', NULL, NULL, 'cerebral cavernous malformations 2 protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(88917, NULL, 'G3DSA:3.30.420.80:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88918, NULL, 'G3DSA:3.20.110.10:FF:000014', NULL, NULL, 'Alpha-mannosidase F', NULL, NULL, NULL, NULL, NULL, 4),
(88919, NULL, 'G3DSA:3.20.20.140:FF:000037', NULL, NULL, 'Dihydropyrimidinase', NULL, NULL, NULL, NULL, NULL, 4),
(88920, NULL, 'G3DSA:2.10.25.10:FF:001031', NULL, NULL, 'Eater', NULL, NULL, NULL, NULL, NULL, 4),
(88921, NULL, 'G3DSA:3.40.50.1820:FF:000682', NULL, NULL, '2-(acetamidomethylene)succinate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(88922, NULL, 'G3DSA:2.60.40.10:FF:000249', NULL, NULL, 'myosin-binding protein C, slow-type isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(88923, NULL, 'G3DSA:3.90.70.10:FF:000539', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 2', NULL, NULL, NULL, NULL, NULL, 4),
(88924, NULL, 'G3DSA:3.40.1360.10:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88925, NULL, 'G3DSA:2.60.40.10:FF:005577', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88926, NULL, 'G3DSA:3.40.50.1000:FF:000436', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88927, NULL, 'G3DSA:1.10.510.10:FF:001196', NULL, NULL, 'Unplaced genomic scaffold supercont1.15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(88928, NULL, 'G3DSA:3.40.50.1000:FF:000548', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88929, NULL, 'G3DSA:3.40.30.10:FF:000298', NULL, NULL, 'Thioredoxin-related transmembrane protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(88930, NULL, 'G3DSA:1.10.10.60:FF:000542', NULL, NULL, 'Terminase small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(88931, NULL, 'G3DSA:2.30.30.40:FF:000545', NULL, NULL, 'AGAP000255-PE', NULL, NULL, NULL, NULL, NULL, 4),
(88932, NULL, 'G3DSA:3.80.10.10:FF:002649', NULL, NULL, 'Transforming growth factor beta activator LRRC33', NULL, NULL, NULL, NULL, NULL, 4),
(88933, NULL, 'G3DSA:3.80.10.10:FF:001363', NULL, NULL, 'Slit homolog 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(88934, NULL, 'G3DSA:2.130.10.10:FF:000772', NULL, NULL, 'WD repeat domain 90', NULL, NULL, NULL, NULL, NULL, 4),
(88935, NULL, 'G3DSA:3.90.1800.10:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(88936, NULL, 'G3DSA:3.30.160.60:FF:000794', NULL, NULL, 'zinc finger protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(88937, NULL, 'G3DSA:2.60.40.10:FF:000805', NULL, NULL, 'Uncharacterized protein, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(88938, NULL, 'G3DSA:3.40.50.2300:FF:000848', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88939, NULL, 'G3DSA:1.10.510.10:FF:000577', NULL, NULL, 'SH3 domain binding kinase family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(88940, NULL, 'G3DSA:3.80.10.10:FF:003049', NULL, NULL, 'Protein CBG14615', NULL, NULL, NULL, NULL, NULL, 4),
(88941, NULL, 'G3DSA:3.30.230.20:FF:000001', NULL, NULL, 'UDP-3-O-acyl-N-acetylglucosamine deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(88942, NULL, 'G3DSA:3.50.50.60:FF:001151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88943, NULL, 'G3DSA:3.30.505.10:FF:000199', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88944, NULL, 'G3DSA:3.30.830.10:FF:000089', NULL, NULL, 'Zinc protease, insulinase family', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(88945, NULL, 'G3DSA:2.70.150.10:FF:000301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88946, NULL, 'G3DSA:1.10.510.10:FF:002027', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(88947, NULL, 'G3DSA:1.10.730.20:FF:000001', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(88948, NULL, 'G3DSA:3.60.10.10:FF:000003', NULL, NULL, 'Synaptojanin-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(88949, NULL, 'G3DSA:3.40.366.10:FF:000013', NULL, NULL, 'Malonyl CoA-acyl carrier protein transacylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88950, NULL, 'G3DSA:3.40.50.300:FF:005954', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(88951, NULL, 'G3DSA:3.40.50.720:FF:001921', NULL, NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(88952, NULL, 'G3DSA:3.90.260.10:FF:000009', NULL, NULL, 'Hemocyte protein-glutamine gamma-glutamyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(88953, NULL, 'G3DSA:3.40.390.10:FF:000232', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88954, NULL, 'G3DSA:3.40.50.300:FF:006354', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88955, NULL, 'G3DSA:3.10.20.90:FF:000018', NULL, NULL, 'Plexin A2', NULL, NULL, NULL, NULL, NULL, 4),
(88956, NULL, 'G3DSA:3.40.50.12710:FF:000031', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7 homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(88957, NULL, 'G3DSA:2.10.25.10:FF:000295', NULL, NULL, 'Wnt inhibitory factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(88958, NULL, 'G3DSA:3.30.497.10:FF:000038', NULL, NULL, 'Serpin peptidase inhibitor, clade B (ovalbumin), member 4', NULL, NULL, NULL, NULL, NULL, 4),
(88959, NULL, 'G3DSA:3.40.630.30:FF:000049', NULL, NULL, 'Amino-acid acetyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(88960, NULL, 'G3DSA:3.30.565.10:FF:000192', NULL, NULL, 'Two-component sensor histidine kinase VicK', NULL, NULL, NULL, NULL, NULL, 4),
(88961, NULL, 'G3DSA:2.10.25.10:FF:001716', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(88962, NULL, 'G3DSA:3.40.50.720:FF:001241', NULL, NULL, 'Type I glyceraldehyde-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(88963, NULL, 'G3DSA:2.130.10.10:FF:004824', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88964, NULL, 'G3DSA:1.25.50.20:FF:000050', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(88965, NULL, 'G3DSA:2.60.120.200:FF:000636', NULL, NULL, 'Heparan sulfate proteoglycan 2', NULL, NULL, NULL, NULL, NULL, 4),
(88966, NULL, 'G3DSA:3.90.230.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88967, NULL, 'G3DSA:1.10.10.10:FF:002028', NULL, NULL, 'Forkhead box N2', NULL, NULL, NULL, NULL, NULL, 4),
(88968, NULL, 'G3DSA:1.10.510.10:FF:001752', NULL, NULL, 'Serine/threonine-protein kinase PknB', NULL, NULL, NULL, NULL, NULL, 4),
(88969, NULL, 'G3DSA:3.40.1260.10:FF:000008', NULL, NULL, 'DsrE family protein', NULL, NULL, NULL, NULL, NULL, 4),
(88970, NULL, 'G3DSA:1.10.730.10:FF:000116', NULL, NULL, 'Methionine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(88971, NULL, 'G3DSA:2.130.10.10:FF:003993', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(88972, NULL, 'G3DSA:3.30.160.660:FF:000001', NULL, NULL, 'Ribosomal protein S12 methylthiotransferase accessory factor YcaO', NULL, NULL, NULL, NULL, NULL, 4),
(88973, NULL, 'G3DSA:3.30.230.40:FF:000007', NULL, NULL, 'Imidazoleglycerol-phosphate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(88974, NULL, 'G3DSA:1.10.10.10:FF:000100', NULL, NULL, 'E2F transcription factor 8', NULL, NULL, NULL, NULL, NULL, 4),
(88975, NULL, 'G3DSA:1.10.510.10:FF:004051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88976, NULL, 'G3DSA:3.30.710.10:FF:000384', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(88977, NULL, 'G3DSA:3.90.1410.10:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88978, NULL, 'G3DSA:1.25.40.10:FF:002480', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(88979, NULL, 'G3DSA:1.10.1450.10:FF:000116', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(88980, NULL, 'G3DSA:2.60.40.1230:FF:000012', NULL, NULL, 'AP-1 complex subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(88981, NULL, 'G3DSA:3.40.50.410:FF:000316', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(88982, NULL, 'G3DSA:1.20.140.100:FF:000036', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(88983, NULL, 'G3DSA:1.20.1070.10:FF:000860', NULL, NULL, 'Chemokine (C-X-C motif) receptor 3, tandem duplicate 1', NULL, NULL, NULL, NULL, NULL, 4),
(88984, NULL, 'G3DSA:3.40.1000.50:FF:000018', NULL, NULL, 'Repressor of RNA polymerase III transcription MAF1', NULL, NULL, NULL, NULL, NULL, 4),
(88985, NULL, 'G3DSA:3.30.2410.10:FF:000012', NULL, NULL, 'Ubiquitin-protein ligase E3B', NULL, NULL, NULL, NULL, NULL, 4),
(88986, NULL, 'G3DSA:2.60.40.60:FF:000910', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88987, NULL, 'G3DSA:3.80.10.10:FF:000744', NULL, NULL, 'Protein phosphatase 1 regulatory subunit pprA', NULL, NULL, NULL, NULL, NULL, 4),
(88988, NULL, 'G3DSA:3.40.50.12350:FF:000001', NULL, NULL, 'Eyes absent homolog', NULL, NULL, NULL, NULL, NULL, 4),
(88989, NULL, 'G3DSA:3.80.10.10:FF:003150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(88990, NULL, 'G3DSA:3.40.50.1240:FF:000036', NULL, NULL, '6-phosphofructo-2-kinase/fructose-2, 6-bisphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(88991, NULL, 'G3DSA:3.40.220.10:FF:000029', NULL, NULL, 'H2A histone family member Y2', NULL, NULL, NULL, NULL, NULL, 4),
(88992, NULL, 'G3DSA:1.25.10.10:FF:000179', NULL, NULL, 'Serine/threonine-protein phosphatase 4 regulatory subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(88993, NULL, 'G3DSA:3.40.50.1010:FF:000192', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(88994, NULL, 'G3DSA:3.40.50.300:FF:001576', NULL, NULL, 'tRNA-splicing endonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88995, NULL, 'G3DSA:2.60.120.380:FF:000066', NULL, NULL, 'Cysteine peptidase, Clan CA, family C2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(88996, NULL, 'G3DSA:3.60.21.10:FF:000034', NULL, NULL, 'Fe(3+)-Zn(2+) purple acid phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(88997, NULL, 'G3DSA:3.40.1370.10:FF:000005', NULL, NULL, '39S ribosomal protein L4, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(88998, NULL, 'G3DSA:1.25.10.10:FF:002085', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(88999, NULL, 'G3DSA:3.30.200.20:FF:001596', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89000, NULL, 'G3DSA:1.20.120.1760:FF:000076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89001, NULL, 'G3DSA:1.10.220.30:FF:000027', NULL, NULL, 'Flagellar motor switch protein G', NULL, NULL, NULL, NULL, NULL, 4),
(89002, NULL, 'G3DSA:3.30.380.10:FF:000003', NULL, NULL, 'Coat protein', NULL, NULL, NULL, NULL, NULL, 4),
(89003, NULL, 'G3DSA:1.10.287.70:FF:000266', NULL, NULL, 'Transient receptor potential cation channel subfamily c member 1', NULL, NULL, NULL, NULL, NULL, 4),
(89004, NULL, 'G3DSA:3.40.440.10:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89005, NULL, 'G3DSA:4.10.240.10:FF:000180', NULL, NULL, 'Zcf5p', NULL, NULL, NULL, NULL, NULL, 4),
(89006, NULL, 'G3DSA:3.40.50.12370:FF:000007', NULL, NULL, 'Os12g0180500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(89007, NULL, 'G3DSA:1.10.10.10:FF:000555', NULL, NULL, 'Histone H1', NULL, NULL, NULL, NULL, NULL, 4),
(89008, NULL, 'G3DSA:2.60.120.10:FF:000313', NULL, NULL, 'Protein phosphatase 2C and cyclic nucleotide-binding/kinase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(89009, NULL, 'G3DSA:3.30.420.110:FF:000026', NULL, NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(89010, NULL, 'G3DSA:1.10.220.10:FF:000021', NULL, NULL, 'annexin D4', NULL, NULL, NULL, NULL, NULL, 4),
(89011, NULL, 'G3DSA:1.10.510.10:FF:004500', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89012, NULL, 'G3DSA:1.10.630.10:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89013, NULL, 'G3DSA:2.180.10.10:FF:000005', NULL, NULL, 'Teneurin transmembrane protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(89014, NULL, 'G3DSA:2.130.10.10:FF:001177', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit TRM82', NULL, NULL, NULL, NULL, NULL, 4),
(89015, NULL, 'G3DSA:1.25.10.10:FF:002433', NULL, NULL, 'Leukotriene A-4 hydrolase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(89016, NULL, 'G3DSA:1.20.1420.30:FF:000106', NULL, NULL, 'Sodium/calcium exchanger membrane region', NULL, NULL, NULL, NULL, NULL, 4),
(89017, NULL, 'G3DSA:3.40.50.720:FF:000965', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(89018, NULL, 'G3DSA:1.10.287.70:FF:000614', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89019, NULL, 'G3DSA:3.40.50.1220:FF:000030', NULL, NULL, 'Transcriptional regulatory protein sir2b', NULL, NULL, NULL, NULL, NULL, 4),
(89020, NULL, 'G3DSA:2.130.10.10:FF:002470', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89021, NULL, 'G3DSA:3.30.160.60:FF:000912', NULL, NULL, 'Zinc finger protein 660', NULL, NULL, NULL, NULL, NULL, 4),
(89022, NULL, 'G3DSA:1.50.40.10:FF:000605', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(89023, NULL, 'G3DSA:2.30.30.140:FF:000243', NULL, NULL, 'Histone-lysine N-methyltransferase SETDB1-A', NULL, NULL, NULL, NULL, NULL, 4),
(89024, NULL, 'G3DSA:3.40.50.300:FF:002195', NULL, NULL, 'Axonemal dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(89025, NULL, 'G3DSA:2.60.40.60:FF:000562', NULL, NULL, 'Cadherin 5', NULL, NULL, NULL, NULL, NULL, 4),
(89026, NULL, 'G3DSA:1.20.120.1080:FF:000063', NULL, NULL, 'ATP-dependent RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89027, NULL, 'G3DSA:1.10.8.10:FF:000357', NULL, NULL, 'GH10884p', NULL, NULL, NULL, NULL, NULL, 4),
(89028, NULL, 'G3DSA:1.25.40.420:FF:000018', NULL, NULL, 'Kelch-like family member 22', NULL, NULL, NULL, NULL, NULL, 4),
(89029, NULL, 'G3DSA:3.40.50.1820:FF:001171', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(89030, NULL, 'G3DSA:2.40.30.10:FF:000013', NULL, NULL, 'eukaryotic translation initiation factor 5B', NULL, NULL, NULL, NULL, NULL, 4),
(89031, NULL, 'G3DSA:3.10.100.10:FF:000229', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89032, NULL, 'G3DSA:3.40.50.620:FF:000368', NULL, NULL, 'Some similarities with, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89033, NULL, 'G3DSA:1.10.3730.20:FF:000051', NULL, NULL, 'DMT superfamily drug/metabolite transporter', NULL, NULL, NULL, NULL, NULL, 4),
(89034, NULL, 'G3DSA:3.30.40.10:FF:000102', NULL, NULL, 'protrudin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(89035, NULL, 'G3DSA:3.10.180.10:FF:000009', NULL, NULL, '4-hydroxyphenylpyruvate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(89036, NULL, 'G3DSA:3.40.50.300:FF:003369', NULL, NULL, 'Protein CBG16740', NULL, NULL, NULL, NULL, NULL, 4),
(89037, NULL, 'G3DSA:3.30.70.100:FF:000140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89038, NULL, 'G3DSA:3.10.50.40:FF:000073', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(89039, NULL, 'G3DSA:3.30.70.330:FF:001951', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89040, NULL, 'G3DSA:1.20.1110.10:FF:000234', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89041, NULL, 'G3DSA:3.40.50.150:FF:001598', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89042, NULL, 'G3DSA:3.30.160.60:FF:002374', NULL, NULL, 'Blast:Transcription factor Sp4', NULL, NULL, NULL, NULL, NULL, 4),
(89043, NULL, 'G3DSA:1.20.1050.10:FF:000297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(89044, NULL, 'G3DSA:1.10.510.10:FF:002157', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(89045, NULL, 'G3DSA:2.30.30.190:FF:000016', NULL, NULL, 'Tubulin-folding cofactor E', NULL, NULL, NULL, NULL, NULL, 4),
(89046, NULL, 'G3DSA:1.10.560.10:FF:000052', NULL, NULL, '60 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(89047, NULL, 'G3DSA:1.25.40.10:FF:003199', NULL, NULL, 'TPR repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89048, NULL, 'G3DSA:2.40.160.180:FF:000002', NULL, NULL, 'Porin', NULL, NULL, NULL, NULL, NULL, 4),
(89049, NULL, 'G3DSA:1.10.510.10:FF:000791', NULL, NULL, 'cyclin-dependent kinase 20', NULL, NULL, NULL, NULL, NULL, 4),
(89050, NULL, 'G3DSA:2.40.30.30:FF:000019', NULL, NULL, 'Riboflavin biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(89051, NULL, 'G3DSA:2.60.40.10:FF:002941', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89052, NULL, 'G3DSA:3.40.50.150:FF:001042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89053, NULL, 'G3DSA:3.80.10.10:FF:000851', NULL, NULL, 'Probable leucine-rich repeat receptor-like protein kinase At1g35710', NULL, NULL, NULL, NULL, NULL, 4),
(89054, NULL, 'G3DSA:3.30.250.20:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89055, NULL, 'G3DSA:1.10.10.10:FF:001516', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89056, NULL, 'G3DSA:2.130.10.10:FF:000558', NULL, NULL, 'Topless-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(89057, NULL, 'G3DSA:2.30.30.40:FF:000197', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(89058, NULL, 'G3DSA:1.25.50.20:FF:000055', NULL, NULL, 'Glutamyl aminopeptidase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(89059, NULL, 'G3DSA:1.10.357.10:FF:000052', NULL, NULL, 'Transcriptional regulator CmeR', NULL, NULL, NULL, NULL, NULL, 4),
(89060, NULL, 'G3DSA:3.30.450.20:FF:000456', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89061, NULL, 'G3DSA:4.10.60.10:FF:000208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89062, NULL, 'G3DSA:3.30.930.10:FF:000260', NULL, NULL, 'Class II aaRS and biotin synthetases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(89063, NULL, 'G3DSA:1.10.287.850:FF:000005', NULL, NULL, 'PE family immunomodulator PE35', NULL, NULL, NULL, NULL, NULL, 4),
(89064, NULL, 'G3DSA:1.10.287.470:FF:000094', NULL, NULL, 'Putative transporter', NULL, NULL, NULL, NULL, NULL, 4),
(89065, NULL, 'G3DSA:2.40.50.140:FF:000981', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89066, NULL, 'G3DSA:2.160.20.60:FF:000005', NULL, NULL, 'Glutamate synthase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(89067, NULL, 'G3DSA:2.60.40.10:FF:000120', NULL, NULL, 'Down syndrome cell adhesion molecule like 1', NULL, NULL, NULL, NULL, NULL, 4),
(89068, NULL, 'G3DSA:3.40.1000.50:FF:000013', NULL, NULL, 'Repressor of RNA polymerase III transcription MAF1', NULL, NULL, NULL, NULL, NULL, 4),
(89069, NULL, 'G3DSA:3.40.50.300:FF:006466', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89070, NULL, 'G3DSA:3.40.1190.20:FF:000236', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89071, NULL, 'G3DSA:1.10.3720.10:FF:000233', NULL, NULL, 'Opine/polyamine ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(89072, NULL, 'G3DSA:3.30.70.330:FF:001496', NULL, NULL, 'Protein CBR-RBM-28', NULL, NULL, NULL, NULL, NULL, 4),
(89073, NULL, 'G3DSA:3.40.720.10:FF:000157', NULL, NULL, 'Iduronate-2-sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(89074, NULL, 'G3DSA:3.30.40.10:FF:001625', NULL, NULL, 'Ret finger protein-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(89075, NULL, 'G3DSA:1.20.1070.10:FF:001927', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(89076, NULL, 'G3DSA:2.60.40.780:FF:000003', NULL, NULL, 'Protein Vhl', NULL, NULL, NULL, NULL, NULL, 4),
(89077, NULL, 'G3DSA:3.40.50.1440:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(89078, NULL, 'G3DSA:1.10.268.10:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89079, NULL, 'G3DSA:3.90.1480.20:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89080, NULL, 'G3DSA:1.10.730.10:FF:000228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89081, NULL, 'G3DSA:3.30.1370.110:FF:000028', NULL, NULL, 'Smr domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(89082, NULL, 'G3DSA:3.30.460.10:FF:000055', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(89083, NULL, 'G3DSA:3.90.180.10:FF:000059', NULL, NULL, 'YML131W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(89084, NULL, 'G3DSA:3.40.50.800:FF:000107', NULL, NULL, 'DNA polymerase subunit gamma-2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(89085, NULL, 'G3DSA:3.10.310.10:FF:000043', NULL, NULL, '3-methylitaconate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(89086, NULL, 'G3DSA:2.40.70.10:FF:000347', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89087, NULL, 'G3DSA:3.30.160.60:FF:004167', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89088, NULL, 'G3DSA:2.10.25.10:FF:000418', NULL, NULL, 'EGF-containing fibulin-like extracellular matrix protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(89089, NULL, 'G3DSA:1.20.58.390:FF:000080', NULL, NULL, '5-hydroxytryptamine (serotonin) receptor 3C, ionotropic', NULL, NULL, NULL, NULL, NULL, 4),
(89090, NULL, 'G3DSA:1.20.58.60:FF:000808', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89091, NULL, 'G3DSA:1.10.530.40:FF:000003', NULL, NULL, 'Baseplate hub subunit and tail lysozyme', NULL, NULL, NULL, NULL, NULL, 4),
(89092, NULL, 'G3DSA:3.30.420.10:FF:000390', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89093, NULL, 'G3DSA:2.60.40.1930:FF:000008', NULL, NULL, 'Complement C3', NULL, NULL, NULL, NULL, NULL, 4),
(89094, NULL, 'G3DSA:1.10.10.10:FF:001409', NULL, NULL, 'Rrf2 family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(89095, NULL, 'G3DSA:3.40.50.720:FF:001926', NULL, NULL, 'Crystallin mu', NULL, NULL, NULL, NULL, NULL, 4),
(89096, NULL, 'G3DSA:1.10.135.10:FF:000014', NULL, NULL, 'Creatine kinase S-type, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(89097, NULL, 'G3DSA:3.30.160.60:FF:005684', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89098, NULL, 'G3DSA:1.25.40.10:FF:003547', NULL, NULL, 'Zinc finger CCCH type containing 7 A', NULL, NULL, NULL, NULL, NULL, 4),
(89099, NULL, 'G3DSA:2.10.25.10:FF:001711', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(89100, NULL, 'G3DSA:3.30.40.10:FF:000321', NULL, NULL, 'E3 ubiquitin-protein ligase SINAT5', NULL, NULL, NULL, NULL, NULL, 4),
(89101, NULL, 'G3DSA:2.40.70.10:FF:000004', NULL, NULL, 'Pepsin A', NULL, NULL, NULL, NULL, NULL, 4),
(89102, NULL, 'G3DSA:3.20.20.140:FF:000149', NULL, NULL, 'Dihydropyrimidinase', NULL, NULL, NULL, NULL, NULL, 4),
(89103, NULL, 'G3DSA:2.120.10.30:FF:000183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89104, NULL, 'G3DSA:3.30.1680.10:FF:000048', NULL, NULL, 'Semaphorin-5A', NULL, NULL, NULL, NULL, NULL, 4),
(89105, NULL, 'G3DSA:2.30.30.40:FF:000326', NULL, NULL, 'Alkylphosphonate utilization operon protein PhnA', NULL, NULL, NULL, NULL, NULL, 4),
(89106, NULL, 'G3DSA:2.40.10.10:FF:000467', NULL, NULL, 'AGAP005196-PA', NULL, NULL, NULL, NULL, NULL, 4),
(89107, NULL, 'G3DSA:2.60.40.10:FF:006084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89108, NULL, 'G3DSA:3.40.50.1970:FF:000024', NULL, NULL, 'Hydroxyacid-oxoacid transhydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(89109, NULL, 'G3DSA:1.20.1740.10:FF:000153', NULL, NULL, 'Amino acid transporter, partial (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(89110, NULL, 'G3DSA:3.40.50.300:FF:005286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89111, NULL, 'G3DSA:3.40.50.300:FF:003026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(89112, NULL, 'G3DSA:2.60.40.10:FF:005684', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89113, NULL, 'G3DSA:1.10.260.40:FF:000010', NULL, NULL, 'Cut-like homeobox 1a', NULL, NULL, NULL, NULL, NULL, 4),
(89114, NULL, 'G3DSA:1.25.40.20:FF:000785', NULL, NULL, 'Ankyrin repeat-containing protein At2g01680', NULL, NULL, NULL, NULL, NULL, 4),
(89115, NULL, 'G3DSA:1.10.8.1310:FF:000008', NULL, NULL, 'Rab GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89116, NULL, 'G3DSA:3.60.70.12:FF:000009', NULL, NULL, 'Peptidase S58 DmpA', NULL, NULL, NULL, NULL, NULL, 4),
(89117, NULL, 'G3DSA:1.10.1410.20:FF:000004', NULL, NULL, '2''-5''-oligoadenylate synthase 3-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(89118, NULL, 'G3DSA:1.10.520.10:FF:000061', NULL, NULL, 'Catalase/peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(89119, NULL, 'G3DSA:3.40.980.10:FF:000047', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(89120, NULL, 'G3DSA:1.10.10.10:FF:000448', NULL, NULL, 'FEV (ETS oncogene family)', NULL, NULL, NULL, NULL, NULL, 4),
(89121, NULL, 'G3DSA:2.60.40.150:FF:000033', NULL, NULL, 'dysferlin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(89122, NULL, 'G3DSA:3.30.70.590:FF:000016', NULL, NULL, 'PolyA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(89123, NULL, 'G3DSA:3.10.350.10:FF:000040', NULL, NULL, 'Membrane-bound lytic murein transglycosylase D', NULL, NULL, NULL, NULL, NULL, 4),
(89124, NULL, 'G3DSA:1.20.140.10:FF:000035', NULL, NULL, 'Acyl-CoA dehydrogenase FadE4', NULL, NULL, NULL, NULL, NULL, 4),
(89125, NULL, 'G3DSA:1.10.150.80:FF:000002', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(89126, NULL, 'G3DSA:1.10.10.60:FF:001166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89127, NULL, 'G3DSA:1.10.10.2150:FF:000002', NULL, NULL, 'Ribosomal RNA-processing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(89128, NULL, 'G3DSA:3.30.1140.60:FF:000005', NULL, NULL, 'F-actin-capping protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(89129, NULL, 'G3DSA:3.40.50.2000:FF:001135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89130, NULL, 'G3DSA:3.40.1110.10:FF:000464', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89131, NULL, 'G3DSA:1.25.10.10:FF:002652', NULL, NULL, 'AP-3 complex subunit delta-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89132, NULL, 'G3DSA:3.40.850.10:FF:000386', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89133, NULL, 'G3DSA:3.20.20.70:FF:000158', NULL, NULL, 'Biotin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(89134, NULL, 'G3DSA:1.10.510.10:FF:000572', NULL, NULL, 'Serine/threonine-protein kinase/endoribonuclease IRE1', NULL, NULL, NULL, NULL, NULL, 4),
(89135, NULL, 'G3DSA:2.80.10.50:FF:000224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89136, NULL, 'G3DSA:2.30.30.40:FF:000202', NULL, NULL, 'Tight junction protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(89137, NULL, 'G3DSA:1.25.10.10:FF:000516', NULL, NULL, 'mRNA binding PUM-HD domain protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(89138, NULL, 'G3DSA:1.20.58.1380:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89139, NULL, 'G3DSA:1.20.1310.10:FF:000233', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89140, NULL, 'G3DSA:2.60.40.150:FF:000718', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(89141, NULL, 'G3DSA:3.30.70.330:FF:000192', NULL, NULL, 'Serine/arginine-rich splicing factor SC35', NULL, NULL, NULL, NULL, NULL, 4),
(89142, NULL, 'G3DSA:3.60.40.10:FF:000286', NULL, NULL, 'Probable protein phosphatase 2C 62', NULL, NULL, NULL, NULL, NULL, 4),
(89143, NULL, 'G3DSA:2.10.50.30:FF:000033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(89144, NULL, 'G3DSA:3.30.760.10:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89145, NULL, 'G3DSA:3.30.200.20:FF:000303', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(89146, NULL, 'G3DSA:3.30.420.140:FF:000012', NULL, NULL, 'Putative pre-16S rRNA nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(89147, NULL, 'G3DSA:3.40.50.300:FF:001795', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(89148, NULL, 'G3DSA:2.60.120.620:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89149, NULL, 'G3DSA:1.10.533.10:FF:000265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89150, NULL, 'G3DSA:3.30.70.980:FF:000044', NULL, NULL, 'Probable transcriptional regulatory protein RBSWK_05502', NULL, NULL, NULL, NULL, NULL, 4),
(89151, NULL, 'G3DSA:3.30.60.30:FF:000087', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(89152, NULL, 'G3DSA:3.30.70.120:FF:000016', NULL, NULL, 'CutA, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89153, NULL, 'G3DSA:2.30.30.870:FF:000006', NULL, NULL, 'Pelota, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89154, NULL, 'G3DSA:3.30.160.60:FF:003548', NULL, NULL, 'AGAP004651-PA', NULL, NULL, NULL, NULL, NULL, 4),
(89155, NULL, 'G3DSA:3.30.1520.10:FF:000003', NULL, NULL, 'sorting nexin-27 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(89156, NULL, 'G3DSA:3.60.40.10:FF:000067', NULL, NULL, 'Protein phosphatase PPM6, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89157, NULL, 'G3DSA:1.20.1070.10:FF:001242', NULL, NULL, 'Adhesion G protein-coupled receptor G4b', NULL, NULL, NULL, NULL, NULL, 4),
(89158, NULL, 'G3DSA:1.20.120.1810:FF:000001', NULL, NULL, 'RNA polymerase sigma factor RpoH', NULL, NULL, NULL, NULL, NULL, 4),
(89159, NULL, 'G3DSA:1.10.565.10:FF:000147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89160, NULL, 'G3DSA:4.10.60.10:FF:000192', NULL, NULL, 'Protein CBG28058', NULL, NULL, NULL, NULL, NULL, 4),
(89161, NULL, 'G3DSA:1.25.40.20:FF:000914', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89162, NULL, 'G3DSA:2.60.40.10:FF:005139', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89163, NULL, 'G3DSA:3.40.50.10190:FF:000090', NULL, NULL, 'BRCA1 C Terminus domain containing protein expressed', NULL, NULL, NULL, NULL, NULL, 4),
(89164, NULL, 'G3DSA:3.10.20.90:FF:000581', NULL, NULL, 'Auxin-responsive protein IAA29', NULL, NULL, NULL, NULL, NULL, 4),
(89165, NULL, 'G3DSA:3.30.1010.10:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89166, NULL, 'G3DSA:3.30.420.10:FF:000406', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89167, NULL, 'G3DSA:3.10.250.10:FF:000004', NULL, NULL, 'Scavenger receptor cysteine-rich type 1 protein M130', NULL, NULL, NULL, NULL, NULL, 4),
(89168, NULL, 'G3DSA:1.20.920.10:FF:000117', NULL, NULL, 'Sp110 nuclear body protein', NULL, NULL, NULL, NULL, NULL, 4),
(89169, NULL, 'G3DSA:3.40.50.300:FF:005847', NULL, NULL, 'Protein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(89170, NULL, 'G3DSA:3.40.50.300:FF:006247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89171, NULL, 'G3DSA:3.30.70.1230:FF:000226', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(89172, NULL, 'G3DSA:3.20.190.10:FF:000002', NULL, NULL, 'Endonuclease 8', NULL, NULL, NULL, NULL, NULL, 4),
(89173, NULL, 'G3DSA:2.20.70.10:FF:000174', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(89174, NULL, 'G3DSA:3.80.10.10:FF:003835', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(89175, NULL, 'G3DSA:3.40.50.1820:FF:001750', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(89176, NULL, 'G3DSA:1.10.30.10:FF:000118', NULL, NULL, 'High mobility group protein homolog TDP-1', NULL, NULL, NULL, NULL, NULL, 4),
(89177, NULL, 'G3DSA:3.90.980.20:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89178, NULL, 'G3DSA:1.20.1070.10:FF:000753', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89179, NULL, 'G3DSA:3.30.450.20:FF:000675', NULL, NULL, 'Putative DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(89180, NULL, 'G3DSA:3.10.129.10:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(89181, NULL, 'G3DSA:1.25.10.10:FF:002989', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(89182, NULL, 'G3DSA:1.10.10.10:FF:001393', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(89183, NULL, 'G3DSA:2.130.10.10:FF:005448', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89184, NULL, 'G3DSA:2.102.10.10:FF:000032', NULL, NULL, 'Rieske_[2Fe-2S]_domain/Rieske-like_[2Fe-2S ]_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(89185, NULL, 'G3DSA:2.60.40.10:FF:002722', NULL, NULL, 'Putative trypsin', NULL, NULL, NULL, NULL, NULL, 4),
(89186, NULL, 'G3DSA:3.40.1190.10:FF:000014', NULL, NULL, 'UDP-N-acetylmuramoyl-L-alanyl-D-glutamate--2, 6-diaminopimelate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(89187, NULL, 'G3DSA:2.60.40.1730:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89188, NULL, 'G3DSA:3.40.1280.10:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89189, NULL, 'G3DSA:2.60.40.10:FF:003211', NULL, NULL, 'Cytochrome c oxidase accessory protein CcoG', NULL, NULL, NULL, NULL, NULL, 4),
(89190, NULL, 'G3DSA:1.25.40.10:FF:000563', NULL, NULL, 'U3 small nucleolar RNA-associated protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(89191, NULL, 'G3DSA:2.60.40.10:FF:001429', NULL, NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(89192, NULL, 'G3DSA:3.30.70.270:FF:000033', NULL, NULL, 'Probable diguanylate cyclase YeaP', NULL, NULL, NULL, NULL, NULL, 4),
(89193, NULL, 'G3DSA:1.20.900.10:FF:000099', NULL, NULL, 'Rho1 guanine nucleotide exchange factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(89194, NULL, 'G3DSA:3.80.10.10:FF:004111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89195, NULL, 'G3DSA:1.25.10.10:FF:000067', NULL, NULL, 'V-type proton ATPase subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(89196, NULL, 'G3DSA:2.60.40.10:FF:002380', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(89197, NULL, 'G3DSA:3.15.10.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89198, NULL, 'G3DSA:3.40.50.1240:FF:000148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89199, NULL, 'G3DSA:2.60.40.1660:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89200, NULL, 'G3DSA:2.60.40.150:FF:000825', NULL, NULL, 'C2 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(89201, NULL, 'G3DSA:3.30.200.20:FF:001466', NULL, NULL, 'Serine/threonine protein kinase PpkA', NULL, NULL, NULL, NULL, NULL, 4),
(89202, NULL, 'G3DSA:3.40.50.200:FF:000023', NULL, NULL, 'Subtilisin-like protease 1', NULL, NULL, NULL, NULL, NULL, 4),
(89203, NULL, 'G3DSA:2.60.120.10:FF:000077', NULL, NULL, '3-hydroxyanthranilate 3,4-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(89204, NULL, 'G3DSA:2.60.40.1960:FF:000006', NULL, NULL, 'Lysosomal aspartic protease-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(89205, NULL, 'G3DSA:3.60.10.10:FF:000346', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(89206, NULL, 'G3DSA:2.60.40.10:FF:002374', NULL, NULL, 'AGAP007237-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(89207, NULL, 'G3DSA:2.20.25.210:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89208, NULL, 'G3DSA:3.30.70.330:FF:000203', NULL, NULL, 'insulin-like growth factor 2 mRNA-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(89209, NULL, 'G3DSA:1.20.1070.10:FF:001714', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89210, NULL, 'G3DSA:3.40.50.620:FF:000593', NULL, NULL, 'Cysteinyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89211, NULL, 'G3DSA:1.10.357.70:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89212, NULL, 'G3DSA:3.40.50.1820:FF:000114', NULL, NULL, 'Arylacetamide deacetylase-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(89213, NULL, 'G3DSA:1.25.10.10:FF:002197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(89214, NULL, 'G3DSA:3.40.50.2300:FF:001231', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89215, NULL, 'G3DSA:3.40.190.80:FF:000007', NULL, NULL, 'Blast:Putative inositol monophosphatase 3', NULL, NULL, NULL, NULL, NULL, 4),
(89216, NULL, 'G3DSA:1.25.10.10:FF:001685', NULL, NULL, 'RRP12-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(89217, NULL, 'G3DSA:1.10.287.70:FF:000378', NULL, NULL, 'KCNN (Potassium K ChaNNel, calcium activated)-Like', NULL, NULL, NULL, NULL, NULL, 4),
(89218, NULL, 'G3DSA:2.30.30.1020:FF:000012', NULL, NULL, 'CCR4-NOT transcriptional complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(89219, NULL, 'G3DSA:3.30.70.20:FF:000146', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89220, NULL, 'G3DSA:2.60.200.20:FF:000244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89221, NULL, 'G3DSA:1.10.287.110:FF:000132', NULL, NULL, 'Zuo1p', NULL, NULL, NULL, NULL, NULL, 4),
(89222, NULL, 'G3DSA:3.40.1380.20:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89223, NULL, 'G3DSA:3.30.1380.20:FF:000017', NULL, NULL, 'Hydrocarbon binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(89224, NULL, 'G3DSA:2.60.40.60:FF:000674', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(89225, NULL, 'G3DSA:2.90.10.10:FF:000044', NULL, NULL, 'PAN domain-containing protein At5g03700', NULL, NULL, NULL, NULL, NULL, 4),
(89226, NULL, 'G3DSA:3.40.50.300:FF:006011', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(89227, NULL, 'G3DSA:3.30.70.330:FF:001714', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89228, NULL, 'G3DSA:3.40.50.360:FF:000037', NULL, NULL, 'NAD(P)H dehydrogenase (Quinone)', NULL, NULL, NULL, NULL, NULL, 4),
(89229, NULL, 'G3DSA:1.10.472.80:FF:000222', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89230, NULL, 'G3DSA:3.60.21.10:FF:000158', NULL, NULL, 'Trifunctional nucleotide phosphoesterase protein YfkN', NULL, NULL, NULL, NULL, NULL, 4),
(89231, NULL, 'G3DSA:3.30.70.1660:FF:000001', NULL, NULL, 'Peptide chain release factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(89232, NULL, 'G3DSA:3.30.70.330:FF:001821', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89233, NULL, 'G3DSA:3.30.30.30:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89234, NULL, 'G3DSA:3.40.50.11610:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89235, NULL, 'G3DSA:1.20.5.170:FF:000048', NULL, NULL, 'ABSCISIC ACID-INSENSITIVE 5-like protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(89236, NULL, 'G3DSA:3.60.21.60:FF:000021', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(89237, NULL, 'G3DSA:1.10.630.10:FF:000395', NULL, NULL, 'Beta-amyrin 28-oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(89238, NULL, 'G3DSA:2.10.220.10:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89239, NULL, 'G3DSA:1.10.3720.10:FF:000008', NULL, NULL, 'Oligopeptide ABC transporter permease OppC', NULL, NULL, NULL, NULL, NULL, 4),
(89240, NULL, 'G3DSA:2.30.30.40:FF:000433', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(89241, NULL, 'G3DSA:3.30.450.20:FF:000669', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89242, NULL, 'G3DSA:3.30.450.40:FF:000102', NULL, NULL, 'Phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(89243, NULL, 'G3DSA:1.20.58.60:FF:000016', NULL, NULL, 'Microtubule-actin cross-linking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(89244, NULL, 'G3DSA:3.30.70.330:FF:002333', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89245, NULL, 'G3DSA:1.20.5.4130:FF:000009', NULL, NULL, 'Disease resistance protein RGA4', NULL, NULL, NULL, NULL, NULL, 4),
(89246, NULL, 'G3DSA:3.30.420.40:FF:000494', NULL, NULL, 'Hexokinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(89247, NULL, 'G3DSA:2.20.28.10:FF:000020', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(89248, NULL, 'G3DSA:1.25.40.20:FF:000678', NULL, NULL, 'Ankyrin repeats (3 copies), putative', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(89249, NULL, 'G3DSA:1.20.1070.10:FF:001821', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89250, NULL, 'G3DSA:1.20.1540.10:FF:000042', NULL, NULL, 'Rbd2p', NULL, NULL, NULL, NULL, NULL, 4),
(89251, NULL, 'G3DSA:1.10.720.30:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89252, NULL, 'G3DSA:3.90.190.10:FF:000453', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89253, NULL, 'G3DSA:2.30.29.30:FF:001073', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(89254, NULL, 'G3DSA:3.40.50.720:FF:000853', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(89255, NULL, 'G3DSA:1.10.640.10:FF:000002', NULL, NULL, 'Prostaglandin G/H synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(89256, NULL, 'G3DSA:3.30.505.10:FF:000087', NULL, NULL, 'protein sprint isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(89257, NULL, 'G3DSA:3.40.630.10:FF:000167', NULL, NULL, 'Carboxypeptidase G2', NULL, NULL, NULL, NULL, NULL, 4),
(89258, NULL, 'G3DSA:3.30.40.10:FF:001046', NULL, NULL, 'Chromatin modification-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(89259, NULL, 'G3DSA:3.80.10.10:FF:001469', NULL, NULL, 'Leucine-rich repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(89260, NULL, 'G3DSA:3.10.450.350:FF:000018', NULL, NULL, 'Subfamily M23B unassigned peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(89261, NULL, 'G3DSA:1.10.10.10:FF:001960', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89262, NULL, 'G3DSA:3.30.360.10:FF:000019', NULL, NULL, 'Bifunctional acetylglutamate kinase/N-acetyl-gamma-glutamyl-phosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(89263, NULL, 'G3DSA:3.40.190.10:FF:000470', NULL, NULL, 'Oligopeptide ABC transporter, periplasmic oligopeptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(89264, NULL, 'G3DSA:3.30.565.10:FF:000208', NULL, NULL, 'Sensory box sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(89265, NULL, 'G3DSA:3.10.620.30:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89266, NULL, 'G3DSA:1.10.287.1490:FF:000041', NULL, NULL, 'Kinesin, variant', NULL, NULL, NULL, NULL, NULL, 4),
(89267, NULL, 'G3DSA:3.30.70.240:FF:000041', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(89268, NULL, 'G3DSA:1.10.287.70:FF:000491', NULL, NULL, 'Ionotropic receptor 7b', NULL, NULL, NULL, NULL, NULL, 4),
(89269, NULL, 'G3DSA:2.140.10.30:FF:000007', NULL, NULL, 'DAP2p Dipeptidyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(89270, NULL, 'G3DSA:3.90.920.10:FF:000021', NULL, NULL, 'DNA primase small subunit PriS', NULL, NULL, NULL, NULL, NULL, 4),
(89271, NULL, 'G3DSA:2.130.10.10:FF:003650', NULL, NULL, 'WD repeat-containing protein 48 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(89272, NULL, 'G3DSA:3.40.50.2000:FF:001129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89273, NULL, 'G3DSA:3.30.160.60:FF:002823', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(89274, NULL, 'G3DSA:2.60.120.650:FF:000063', NULL, NULL, 'JmjC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(89275, NULL, 'G3DSA:3.40.50.300:FF:005393', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89276, NULL, 'G3DSA:2.40.30.170:FF:000070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89277, NULL, 'G3DSA:3.30.1360.10:FF:000013', NULL, NULL, 'RNA polymerase I and III subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(89278, NULL, 'G3DSA:3.80.10.10:FF:004454', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89279, NULL, 'G3DSA:1.25.10.10:FF:002208', NULL, NULL, 'Os01g0973300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(89280, NULL, 'G3DSA:3.40.50.300:FF:008141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89281, NULL, 'G3DSA:2.40.240.10:FF:000006', NULL, NULL, 'Putative glutamine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(89282, NULL, 'G3DSA:1.10.287.180:FF:000001', NULL, NULL, 'Transcription elongation factor GreA', NULL, NULL, NULL, NULL, NULL, 4),
(89283, NULL, 'G3DSA:1.20.58.1780:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89284, NULL, 'G3DSA:3.40.1360.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89285, NULL, 'G3DSA:3.10.110.10:FF:000062', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 B', NULL, NULL, NULL, NULL, NULL, 4),
(89286, NULL, 'G3DSA:1.50.40.10:FF:000387', NULL, NULL, 'Mitochondrial substrate carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(89287, NULL, 'G3DSA:3.30.450.30:FF:000004', NULL, NULL, 'ragulator complex protein LAMTOR2', NULL, NULL, NULL, NULL, NULL, 4),
(89288, NULL, 'G3DSA:2.60.120.10:FF:000184', NULL, NULL, 'XRE family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(89289, NULL, 'G3DSA:3.40.30.10:FF:000516', NULL, NULL, 'Thioredoxin_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(89290, NULL, 'G3DSA:3.40.1280.10:FF:000010', NULL, NULL, 'probable methyltransferase TARBP1', NULL, NULL, NULL, NULL, NULL, 4),
(89291, NULL, 'G3DSA:2.60.40.10:FF:000917', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', NULL, NULL, NULL, NULL, NULL, 4),
(89292, NULL, 'G3DSA:3.60.10.10:FF:000239', NULL, NULL, 'DNA-(apurinic or apyrimidinic site) lyase', NULL, NULL, NULL, NULL, NULL, 4),
(89293, NULL, 'G3DSA:3.30.160.60:FF:006191', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89294, NULL, 'G3DSA:2.60.120.650:FF:000170', NULL, NULL, 'HR, lysine demethylase and nuclear receptor corepressor', NULL, NULL, NULL, NULL, NULL, 4),
(89295, NULL, 'G3DSA:3.60.21.10:FF:000490', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89296, NULL, 'G3DSA:1.20.1310.10:FF:000008', NULL, NULL, 'Cullin 4B', NULL, NULL, NULL, NULL, NULL, 4),
(89297, NULL, 'G3DSA:2.120.10.30:FF:000177', NULL, NULL, 'Major royal jelly protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(89298, NULL, 'G3DSA:3.40.50.1820:FF:000007', NULL, NULL, 'UPF0227 protein YcfP', NULL, NULL, NULL, NULL, NULL, 4),
(89299, NULL, 'G3DSA:1.10.3210.10:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89300, NULL, 'G3DSA:1.20.1250.20:FF:000287', NULL, NULL, 'acetyl-coenzyme A transporter 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(89301, NULL, 'G3DSA:3.40.30.10:FF:000747', NULL, NULL, '2-hydroxychromene-2-carboxylate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(89302, NULL, 'G3DSA:3.30.1300.40:FF:000001', NULL, NULL, 'Fluorescent protein Dronpa', NULL, NULL, NULL, NULL, NULL, 4),
(89303, NULL, 'G3DSA:1.25.40.430:FF:000004', NULL, NULL, 'Mitotic spindle checkpoint protein BUBR1', NULL, NULL, NULL, NULL, NULL, 4),
(89304, NULL, 'G3DSA:3.40.50.10130:FF:000004', NULL, NULL, 'Fanconi anemia, complementation group M', NULL, NULL, NULL, NULL, NULL, 4),
(89305, NULL, 'G3DSA:3.30.420.10:FF:000749', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89306, NULL, 'G3DSA:3.30.1360.200:FF:000008', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(89307, NULL, 'G3DSA:2.130.10.10:FF:002245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89308, NULL, 'G3DSA:3.30.1010.10:FF:000026', NULL, NULL, 'Serine/threonine-protein kinase smg-1', NULL, NULL, NULL, NULL, NULL, 4),
(89309, NULL, 'G3DSA:1.25.40.10:FF:004166', NULL, NULL, 'Mitochondrial outer membrane 72K protein', NULL, NULL, NULL, NULL, NULL, 4),
(89310, NULL, 'G3DSA:2.30.42.10:FF:000322', NULL, NULL, 'MAGI family member, X-linked a', NULL, NULL, NULL, NULL, NULL, 4),
(89311, NULL, 'G3DSA:2.10.25.10:FF:001368', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89312, NULL, 'G3DSA:3.30.200.20:FF:000180', NULL, NULL, 'serine/threonine-protein kinase STY46-like', NULL, NULL, NULL, NULL, NULL, 4),
(89313, NULL, 'G3DSA:3.30.540.10:FF:000005', NULL, NULL, 'Fructose-1,6-bisphosphatase isozyme 2', NULL, NULL, NULL, NULL, NULL, 4),
(89314, NULL, 'G3DSA:3.30.160.60:FF:003099', NULL, NULL, 'C2H2 zinc finger protein Zas1A', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(89315, NULL, 'G3DSA:3.30.565.10:FF:000540', NULL, NULL, 'DNA topoisomerase 6 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(89316, NULL, 'G3DSA:3.40.30.10:FF:001135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89317, NULL, 'G3DSA:1.25.40.10:FF:003654', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89318, NULL, 'G3DSA:1.10.287.410:FF:000008', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(89319, NULL, 'G3DSA:3.30.530.20:FF:000041', NULL, NULL, 'Toxin MT0934', NULL, NULL, NULL, NULL, NULL, 4),
(89320, NULL, 'G3DSA:3.40.50.300:FF:006915', NULL, NULL, 'ATPase, AAA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(89321, NULL, 'G3DSA:3.40.50.300:FF:002520', NULL, NULL, 'DNA polymerase III subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(89322, NULL, 'G3DSA:3.90.1600.10:FF:000024', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(89323, NULL, 'G3DSA:1.10.238.10:FF:001040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89324, NULL, 'G3DSA:3.40.30.10:FF:000623', NULL, NULL, 'Protein disulfide isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(89325, NULL, 'G3DSA:2.10.25.10:FF:000643', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(89326, NULL, 'G3DSA:1.10.287.550:FF:000022', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(89327, NULL, 'G3DSA:2.60.40.10:FF:002143', NULL, NULL, 'B- and T-lymphocyte attenuator', NULL, NULL, NULL, NULL, NULL, 4),
(89328, NULL, 'G3DSA:3.40.50.720:FF:001578', NULL, NULL, 'Short chain dehydrogenase/reductase, putative (AFU_orthologue AFUA_6G02990)', NULL, NULL, NULL, NULL, NULL, 4),
(89329, NULL, 'G3DSA:3.40.850.10:FF:000493', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89330, NULL, 'G3DSA:2.60.40.60:FF:000455', NULL, NULL, 'GG11701', NULL, NULL, NULL, NULL, NULL, 4),
(89331, NULL, 'G3DSA:3.20.200.10:FF:000004', NULL, NULL, 'Alpha-protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(89332, NULL, 'G3DSA:1.20.1110.10:FF:000009', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(89333, NULL, 'G3DSA:1.20.58.60:FF:000123', NULL, NULL, 'Desmoplakin a', NULL, NULL, NULL, NULL, NULL, 4),
(89334, NULL, 'G3DSA:2.60.40.10:FF:003902', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89335, NULL, 'G3DSA:3.40.50.300:FF:007427', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89336, NULL, 'G3DSA:1.10.10.10:FF:000336', NULL, NULL, 'lupus La protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(89337, NULL, 'G3DSA:3.80.10.10:FF:002088', NULL, NULL, 'Serine/threonine kinase 11-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(89338, NULL, 'G3DSA:3.40.50.20:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89339, NULL, 'G3DSA:3.40.190.10:FF:000251', NULL, NULL, 'Peptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(89340, NULL, 'G3DSA:2.60.40.150:FF:000140', NULL, NULL, 'synaptotagmin-7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(89341, NULL, 'G3DSA:3.40.1000.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89342, NULL, 'G3DSA:3.40.50.200:FF:000130', NULL, NULL, 'Clan SB, family S8, subtilisin-like serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(89343, NULL, 'G3DSA:3.40.50.1010:FF:000085', NULL, NULL, 'Exonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(89344, NULL, 'G3DSA:3.60.40.10:FF:000174', NULL, NULL, 'Serine/threonine protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(89345, NULL, 'G3DSA:3.30.70.260:FF:000047', NULL, NULL, 'Phosphoserine phosphatase SerB', NULL, NULL, NULL, NULL, NULL, 4),
(89346, NULL, 'G3DSA:1.10.3430.10:FF:000019', NULL, NULL, 'Urea transporter', NULL, NULL, NULL, NULL, NULL, 4),
(89347, NULL, 'G3DSA:3.30.310.80:FF:000048', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(89348, NULL, 'G3DSA:3.40.33.10:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(89349, NULL, 'G3DSA:2.130.10.10:FF:003318', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89350, NULL, 'G3DSA:2.110.10.10:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89351, NULL, 'G3DSA:3.30.200.20:FF:002085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89352, NULL, 'G3DSA:1.10.510.10:FF:000341', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(89353, NULL, 'G3DSA:3.40.50.2300:FF:000612', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89354, NULL, 'G3DSA:3.40.630.10:FF:000510', NULL, NULL, 'Os08g0511900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(89355, NULL, 'G3DSA:3.40.50.1980:FF:000010', NULL, NULL, 'Histidinol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(89356, NULL, 'G3DSA:3.30.200.20:FF:000741', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(89357, NULL, 'G3DSA:2.30.29.30:FF:000359', NULL, NULL, 'Protein ENHANCED DISEASE RESISTANCE 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(89358, NULL, 'G3DSA:1.20.120.720:FF:000010', NULL, NULL, 'Unconventional myosin-Ie', NULL, NULL, NULL, NULL, NULL, 4),
(89359, NULL, 'G3DSA:3.40.50.1000:FF:000312', NULL, NULL, 'Cation-transporting P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(89360, NULL, 'G3DSA:3.40.1090.10:FF:000074', NULL, NULL, 'Patatin', NULL, NULL, NULL, NULL, NULL, 4),
(89361, NULL, 'G3DSA:2.130.10.130:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89362, NULL, 'G3DSA:2.40.10.10:FF:000574', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89363, NULL, 'G3DSA:1.20.140.10:FF:000147', NULL, NULL, 'Acyl-CoA dehydrogenase very long chain', NULL, NULL, NULL, NULL, NULL, 4),
(89364, NULL, 'G3DSA:3.90.1750.20:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89365, NULL, 'G3DSA:1.10.600.10:FF:000112', NULL, NULL, 'Ent-pimara-9(11),15-diene synthase', NULL, NULL, NULL, NULL, NULL, 4),
(89366, NULL, 'G3DSA:1.10.472.80:FF:000115', NULL, NULL, 'E3 ubiquitin-protein ligase RNF8', NULL, NULL, NULL, NULL, NULL, 4),
(89367, NULL, 'G3DSA:1.10.420.10:FF:000020', NULL, NULL, 'Os01g0293900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(89368, NULL, 'G3DSA:3.40.30.10:FF:000062', NULL, NULL, 'Nucleoredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(89369, NULL, 'G3DSA:1.10.510.10:FF:003775', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89370, NULL, 'G3DSA:2.170.270.10:FF:000045', NULL, NULL, 'Putative zinc finger protein ZFPM2', NULL, NULL, NULL, NULL, NULL, 4),
(89371, NULL, 'G3DSA:2.60.40.10:FF:001070', NULL, NULL, 'Prostaglandin F2 receptor inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(89372, NULL, 'G3DSA:3.30.300.10:FF:000010', NULL, NULL, 'S-adenosylmethionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(89373, NULL, 'G3DSA:1.10.238.10:FF:000421', NULL, NULL, 'Polcalcin Jun o 2', NULL, NULL, NULL, NULL, NULL, 4),
(89374, NULL, 'G3DSA:1.20.1720.10:FF:000039', NULL, NULL, 'Drug resistance transporter, EmrB/QacA family', NULL, NULL, NULL, NULL, NULL, 4),
(89375, NULL, 'G3DSA:3.30.70.330:FF:000984', NULL, NULL, 'Hsh49p', NULL, NULL, NULL, NULL, NULL, 4),
(89376, NULL, 'G3DSA:1.25.40.10:FF:000001', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(89377, NULL, 'G3DSA:2.130.10.10:FF:000901', NULL, NULL, 'WD repeat-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(89378, NULL, 'G3DSA:3.10.580.10:FF:000085', NULL, NULL, 'Membrane protein, TerC family/CBS domain/transporter associated domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(89379, NULL, 'G3DSA:3.30.300.130:FF:000016', NULL, NULL, 'Iron-sulfur cluster carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(89380, NULL, 'G3DSA:3.40.50.300:FF:002644', NULL, NULL, 'Cobalt ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(89381, NULL, 'G3DSA:3.10.20.90:FF:000474', NULL, NULL, 'Autophagy-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(89382, NULL, 'G3DSA:1.10.285.10:FF:000002', NULL, NULL, 'Glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(89383, NULL, 'G3DSA:1.10.287.130:FF:000138', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(89384, NULL, 'G3DSA:3.80.10.10:FF:001705', NULL, NULL, 'Leucine-rich repeat receptor protein kinase EMS1', NULL, NULL, NULL, NULL, NULL, 4),
(89385, NULL, 'G3DSA:3.40.50.150:FF:001834', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89386, NULL, 'G3DSA:3.40.50.800:FF:000091', NULL, NULL, 'threonine--tRNA ligase, mitochondrial isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(89387, NULL, 'G3DSA:2.60.40.1500:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89388, NULL, 'G3DSA:3.40.50.1100:FF:000247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89389, NULL, 'G3DSA:3.90.740.10:FF:000035', NULL, NULL, 'Isoleucyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(89390, NULL, 'G3DSA:3.20.20.70:FF:000271', NULL, NULL, 'Lipoyl synthase', NULL, NULL, NULL, NULL, NULL, 4),
(89391, NULL, 'G3DSA:3.90.79.10:FF:000071', NULL, NULL, 'Hydrolase, NUDIX family', NULL, NULL, NULL, NULL, NULL, 4),
(89392, NULL, 'G3DSA:3.20.20.300:FF:000001', NULL, NULL, 'Beta-hexosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(89393, NULL, 'G3DSA:1.10.10.570:FF:000011', NULL, NULL, 'ESCRT-II subunit protein', NULL, NULL, NULL, NULL, NULL, 4),
(89394, NULL, 'G3DSA:3.80.10.10:FF:003942', NULL, NULL, 'Ribonuclease inhibitor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(89395, NULL, 'G3DSA:2.130.10.10:FF:005679', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(89396, NULL, 'G3DSA:3.40.50.1820:FF:001643', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89397, NULL, 'G3DSA:1.25.40.190:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89398, NULL, 'G3DSA:2.60.120.970:FF:000041', NULL, NULL, 'Bone morphogenetic protein 7a', NULL, NULL, NULL, NULL, NULL, 4),
(89399, NULL, 'G3DSA:1.10.1320.10:FF:000005', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(89400, NULL, 'G3DSA:3.40.1170.60:FF:000005', NULL, NULL, 'DNA repair protein REV1', NULL, NULL, NULL, NULL, NULL, 4),
(89401, NULL, 'G3DSA:3.10.28.10:FF:000046', NULL, NULL, 'Probable cell division protein WhiA', NULL, NULL, NULL, NULL, NULL, 4),
(89402, NULL, 'G3DSA:1.10.20.10:FF:000056', NULL, NULL, 'Transcription initiation factor TFIID subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(89403, NULL, 'G3DSA:3.40.720.10:FF:000270', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(89404, NULL, 'G3DSA:1.10.472.10:FF:000134', NULL, NULL, 'Os02g0800500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(89405, NULL, 'G3DSA:3.30.70.2760:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89406, NULL, 'G3DSA:3.10.180.10:FF:000116', NULL, NULL, '4-hydroxyphenylpyruvate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(89407, NULL, 'G3DSA:3.40.50.300:FF:001340', NULL, NULL, 'Probable inactive shikimate kinase like 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(89408, NULL, 'G3DSA:1.10.3380.30:FF:000015', NULL, NULL, 'SKI2 homolog, superkiller viralicidic activity 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(89409, NULL, 'G3DSA:1.10.10.60:FF:000997', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89410, NULL, 'G3DSA:3.40.50.2300:FF:001337', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89411, NULL, 'G3DSA:3.30.70.330:FF:000309', NULL, NULL, 'RNA-binding protein 42', NULL, NULL, NULL, NULL, NULL, 4),
(89412, NULL, 'G3DSA:2.60.40.10:FF:002486', NULL, NULL, 'Immunoglobulin heavy variable 6-1', NULL, NULL, NULL, NULL, NULL, 4),
(89413, NULL, 'G3DSA:1.20.1240.10:FF:000002', NULL, NULL, 'Photosystem I reaction center subunit XI', NULL, NULL, NULL, NULL, NULL, 4),
(89414, NULL, 'G3DSA:1.20.5.4820:FF:000008', NULL, NULL, 'Putative myosin F', NULL, NULL, NULL, NULL, NULL, 4),
(89415, NULL, 'G3DSA:2.60.260.20:FF:000129', NULL, NULL, 'CG7387 protein', NULL, NULL, NULL, NULL, NULL, 4),
(89416, NULL, 'G3DSA:3.30.200.20:FF:001702', NULL, NULL, 'Putative serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(89417, NULL, 'G3DSA:1.25.40.10:FF:000456', NULL, NULL, 'transmembrane and TPR repeat-containing protein 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(89418, NULL, 'G3DSA:2.30.29.30:FF:000691', NULL, NULL, 'Src kinase associated phosphoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(89419, NULL, 'G3DSA:2.60.200.20:FF:000120', NULL, NULL, 'FHA domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(89420, NULL, 'G3DSA:1.10.225.10:FF:000004', NULL, NULL, 'prosaposin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(89421, NULL, 'G3DSA:2.30.29.30:FF:000016', NULL, NULL, 'dedicator of cytokinesis protein 9 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(89422, NULL, 'G3DSA:1.10.3520.10:FF:000009', NULL, NULL, 'Putative glycolipid transfer protein (GLTP) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(89423, NULL, 'G3DSA:2.40.20.10:FF:000075', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(89424, NULL, 'G3DSA:3.90.550.10:FF:000548', NULL, NULL, 'UDP-N-acetylglucosamine-pyrophosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(89425, NULL, 'G3DSA:3.40.50.300:FF:006230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89426, NULL, 'G3DSA:2.60.40.10:FF:000356', NULL, NULL, 'Low affinity immunoglobulin gamma Fc region receptor III-A', NULL, NULL, NULL, NULL, NULL, 4),
(89427, NULL, 'G3DSA:3.30.830.10:FF:000201', NULL, NULL, 'Insulin degrading enzyme-like zinc peptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89428, NULL, 'G3DSA:1.25.40.10:FF:002710', NULL, NULL, 'Tetratricopeptide repeat protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(89429, NULL, 'G3DSA:3.40.50.720:FF:001235', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(89430, NULL, 'G3DSA:1.10.287.110:FF:000256', NULL, NULL, 'Os05g0397800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(89431, NULL, 'G3DSA:1.10.510.10:FF:002606', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89432, NULL, 'G3DSA:1.20.1070.10:FF:002097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89433, NULL, 'G3DSA:2.120.10.80:FF:000057', NULL, NULL, 'Kelch-like family member 14', NULL, NULL, NULL, NULL, NULL, 4),
(89434, NULL, 'G3DSA:3.40.50.300:FF:000047', NULL, NULL, '6-phosphofructo-2-kinase/fructose-2, 6-bisphosphatase 3 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(89435, NULL, 'G3DSA:1.20.1070.10:FF:001478', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89436, NULL, 'G3DSA:1.25.40.180:FF:000238', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89437, NULL, 'G3DSA:3.90.780.10:FF:000032', NULL, NULL, 'Ser/Thr protein phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(89438, NULL, 'G3DSA:3.40.50.300:FF:004336', NULL, NULL, 'Packaging enzyme P4', NULL, NULL, NULL, NULL, NULL, 4),
(89439, NULL, 'G3DSA:1.10.630.10:FF:000283', NULL, NULL, 'Cytochrome P450 family 2 subfamily G member 1, pseudogene', NULL, NULL, NULL, NULL, NULL, 4),
(89440, NULL, 'G3DSA:2.130.10.10:FF:000665', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(89441, NULL, 'G3DSA:1.10.10.60:FF:001273', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89442, NULL, 'G3DSA:1.20.1530.20:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89443, NULL, 'G3DSA:3.30.420.40:FF:000730', NULL, NULL, 'Actin family', NULL, NULL, NULL, NULL, NULL, 4),
(89444, NULL, 'G3DSA:2.130.10.10:FF:001284', NULL, NULL, 'Maintenance of killer', NULL, NULL, NULL, NULL, NULL, 4),
(89445, NULL, 'G3DSA:1.25.10.10:FF:001921', NULL, NULL, 'Unc-45 myosin chaperone B', NULL, NULL, NULL, NULL, NULL, 4),
(89446, NULL, 'G3DSA:2.130.10.10:FF:001626', NULL, NULL, 'Dynein intermediate chain', NULL, NULL, NULL, NULL, NULL, 4),
(89447, NULL, 'G3DSA:2.130.10.10:FF:004032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89448, NULL, 'G3DSA:3.40.50.300:FF:002301', NULL, NULL, 'Afg1p', NULL, NULL, NULL, NULL, NULL, 4),
(89449, NULL, 'G3DSA:3.40.50.11350:FF:000033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(89450, NULL, 'G3DSA:3.40.50.300:FF:001683', NULL, NULL, 'ABC transporter B family member 20', NULL, NULL, NULL, NULL, NULL, 4),
(89451, NULL, 'G3DSA:1.20.1250.20:FF:001124', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89452, NULL, 'G3DSA:1.10.555.10:FF:000214', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89453, NULL, 'G3DSA:2.170.16.10:FF:000047', NULL, NULL, 'ATP-dependent DNA helicase Hel308', NULL, NULL, NULL, NULL, NULL, 4),
(89454, NULL, 'G3DSA:3.90.170.10:FF:000002', NULL, NULL, 'Adenylosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(89455, NULL, 'G3DSA:3.50.50.60:FF:000307', NULL, NULL, 'Monodehydroascorbate reductase 6', NULL, NULL, NULL, NULL, NULL, 4),
(89456, NULL, 'G3DSA:2.60.40.10:FF:004627', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89457, NULL, 'G3DSA:1.10.1070.11:FF:000133', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(89458, NULL, 'G3DSA:3.40.50.2000:FF:000747', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89459, NULL, 'G3DSA:1.10.8.60:FF:000563', NULL, NULL, 'ORC1-type DNA replication protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(89460, NULL, 'G3DSA:2.130.10.10:FF:003756', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89461, NULL, 'G3DSA:2.40.37.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89462, NULL, 'G3DSA:2.60.200.10:FF:000022', NULL, NULL, 'Dwarfin sma', NULL, NULL, NULL, NULL, NULL, 4),
(89463, NULL, 'G3DSA:1.10.287.890:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89464, NULL, 'G3DSA:2.10.220.10:FF:000034', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(89465, NULL, 'G3DSA:3.30.70.330:FF:003058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89466, NULL, 'G3DSA:2.10.70.10:FF:000039', NULL, NULL, 'seizure 6-like protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(89467, NULL, 'G3DSA:1.25.40.10:FF:001417', NULL, NULL, 'FI17138p1', NULL, NULL, NULL, NULL, NULL, 4),
(89468, NULL, 'G3DSA:3.40.640.10:FF:000117', NULL, NULL, 'Acetylornithine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(89469, NULL, 'G3DSA:1.25.40.10:FF:000799', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g07590, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(89470, NULL, 'G3DSA:1.20.140.40:FF:000033', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(89471, NULL, 'G3DSA:2.60.40.10:FF:003447', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89472, NULL, 'G3DSA:3.10.20.90:FF:000693', NULL, NULL, 'Ubiquitin-specific protease', NULL, NULL, NULL, NULL, NULL, 4),
(89473, NULL, 'G3DSA:3.30.200.20:FF:000409', NULL, NULL, 'serine/threonine-protein kinase haspin', NULL, NULL, NULL, NULL, NULL, 4),
(89474, NULL, 'G3DSA:3.30.160.60:FF:000226', NULL, NULL, 'Zinc finger protein 236 variant', NULL, NULL, NULL, NULL, NULL, 4),
(89475, NULL, 'G3DSA:1.10.3500.10:FF:000014', NULL, NULL, 'Putative transcription modulator/accessory protein', NULL, NULL, NULL, NULL, NULL, 4),
(89476, NULL, 'G3DSA:3.30.70.1230:FF:000114', NULL, NULL, 'Adenylate cyclase 8 (brain)', NULL, NULL, NULL, NULL, NULL, 4),
(89477, NULL, 'G3DSA:1.10.510.10:FF:004394', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89478, NULL, 'G3DSA:2.40.100.10:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89479, NULL, 'G3DSA:2.10.25.10:FF:001604', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89480, NULL, 'G3DSA:3.30.450.20:FF:000563', NULL, NULL, 'Histidine kinase sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(89481, NULL, 'G3DSA:1.10.238.10:FF:000764', NULL, NULL, 'I/6 autoantigen', NULL, NULL, NULL, NULL, NULL, 4),
(89482, NULL, 'G3DSA:1.10.510.10:FF:001988', NULL, NULL, 'Ste20-like kinase, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(89483, NULL, 'G3DSA:3.40.50.1820:FF:001862', NULL, NULL, 'Triacylglycerol lipase, putative', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(89484, NULL, 'G3DSA:1.10.10.10:FF:000212', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit K', NULL, NULL, NULL, NULL, NULL, 4),
(89485, NULL, 'G3DSA:3.40.1190.20:FF:000129', NULL, NULL, 'Adenosine kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89486, NULL, 'G3DSA:3.30.2230.10:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89487, NULL, 'G3DSA:1.10.8.60:FF:000125', NULL, NULL, 'Peroxisome biogenesis protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(89488, NULL, 'G3DSA:1.10.510.10:FF:002264', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89489, NULL, 'G3DSA:1.25.10.10:FF:000960', NULL, NULL, 'Protein phosphatase PP2A regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(89490, NULL, 'G3DSA:3.30.200.20:FF:001360', NULL, NULL, 'GD10379', NULL, NULL, NULL, NULL, NULL, 4),
(89491, NULL, 'G3DSA:2.70.170.10:FF:000207', NULL, NULL, 'Gaba-gated chloride channel, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89492, NULL, 'G3DSA:2.120.10.80:FF:000170', NULL, NULL, 'Multiple EGF-like-domains 8', NULL, NULL, NULL, NULL, NULL, 4),
(89493, NULL, 'G3DSA:3.40.190.290:FF:000074', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(89494, NULL, 'G3DSA:3.40.50.300:FF:001008', NULL, NULL, 'Mitochondrial GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(89495, NULL, 'G3DSA:3.30.70.330:FF:000641', NULL, NULL, 'ELAV-Type RNA binding-protein family', NULL, NULL, NULL, NULL, NULL, 4),
(89496, NULL, 'G3DSA:1.10.510.10:FF:000009', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(89497, NULL, 'G3DSA:3.40.50.720:FF:001814', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89498, NULL, 'G3DSA:2.60.40.10:FF:003666', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89499, NULL, 'G3DSA:3.90.190.10:FF:000110', NULL, NULL, 'PPS1p Protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(89500, NULL, 'G3DSA:3.30.559.70:FF:000021', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(89501, NULL, 'G3DSA:2.60.40.10:FF:004408', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89502, NULL, 'G3DSA:3.40.50.261:FF:000008', NULL, NULL, 'ATP-citrate synthase alpha chain protein', NULL, NULL, NULL, NULL, NULL, 4),
(89503, NULL, 'G3DSA:3.30.1640.10:FF:000040', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(89504, NULL, 'G3DSA:1.10.510.10:FF:000684', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(89505, NULL, 'G3DSA:2.60.120.330:FF:000192', NULL, NULL, 'Os05g0149300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(89506, NULL, 'G3DSA:2.40.10.10:FF:000231', NULL, NULL, 'Trypsin domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(89507, NULL, 'G3DSA:2.60.40.10:FF:004066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89508, NULL, 'G3DSA:3.10.20.10:FF:000034', NULL, NULL, 'Large subunit ribosomal protein L18Ae', NULL, NULL, NULL, NULL, NULL, 4),
(89509, NULL, 'G3DSA:1.25.40.20:FF:001297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89510, NULL, 'G3DSA:3.40.50.2020:FF:000068', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(89511, NULL, 'G3DSA:4.10.800.10:FF:000037', NULL, NULL, 'Nidogen 2a (osteonidogen)', NULL, NULL, NULL, NULL, NULL, 4),
(89512, NULL, 'G3DSA:2.40.10.10:FF:000355', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89513, NULL, 'G3DSA:3.30.300.160:FF:000014', NULL, NULL, 'Type IV pilus biogenesis ATPase PilB', NULL, NULL, NULL, NULL, NULL, 4),
(89514, NULL, 'G3DSA:2.120.10.30:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89515, NULL, 'G3DSA:2.60.40.10:FF:000013', NULL, NULL, 'cell adhesion molecule 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(89516, NULL, 'G3DSA:3.30.160.60:FF:000569', NULL, NULL, 'zinc finger protein 26 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(89517, NULL, 'G3DSA:3.30.1320.10:FF:000016', NULL, NULL, '30S ribosomal protein S16', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(89518, NULL, 'G3DSA:2.130.10.10:FF:004375', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89519, NULL, 'G3DSA:2.120.10.30:FF:000413', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89520, NULL, 'G3DSA:3.40.50.720:FF:001472', NULL, NULL, 'Hypothetical pyrroline-5-carboxylate reductase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(89521, NULL, 'G3DSA:3.30.200.20:FF:001028', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(89522, NULL, 'G3DSA:2.60.120.1000:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89523, NULL, 'G3DSA:1.25.40.10:FF:002036', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(89524, NULL, 'G3DSA:3.30.70.270:FF:000269', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89525, NULL, 'G3DSA:3.40.50.300:FF:004774', NULL, NULL, 'GTP-binding ADP-ribosylation factor ARF1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89526, NULL, 'G3DSA:2.60.120.10:FF:000420', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(89527, NULL, 'G3DSA:3.90.550.10:FF:000205', NULL, NULL, 'Peptidase M23B', NULL, NULL, NULL, NULL, NULL, 4),
(89528, NULL, 'G3DSA:2.40.170.20:FF:000127', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89529, NULL, 'G3DSA:2.10.25.10:FF:001262', NULL, NULL, 'Matrilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(89530, NULL, 'G3DSA:2.10.25.10:FF:000862', NULL, NULL, 'EGF-like-domain multiple 7', NULL, NULL, NULL, NULL, NULL, 4),
(89531, NULL, 'G3DSA:3.40.50.880:FF:000075', NULL, NULL, 'Carbamoyl-phosphate synthase small chain', NULL, NULL, NULL, NULL, NULL, 4),
(89532, NULL, 'G3DSA:3.10.196.10:FF:000006', NULL, NULL, 'Methionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(89533, NULL, 'G3DSA:1.10.10.60:FF:000311', NULL, NULL, 'Zinc fingers and homeoboxes 2a', NULL, NULL, NULL, NULL, NULL, 4),
(89534, NULL, 'G3DSA:2.10.90.10:FF:000041', NULL, NULL, 'Platelet-derived growth factor beta polypeptide b', NULL, NULL, NULL, NULL, NULL, 4),
(89535, NULL, 'G3DSA:3.40.50.2300:FF:001574', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89536, NULL, 'G3DSA:2.100.10.50:FF:000009', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(89537, NULL, 'G3DSA:3.40.1110.10:FF:000352', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89538, NULL, 'G3DSA:3.30.200.20:FF:002321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89539, NULL, 'G3DSA:1.10.287.70:FF:000159', NULL, NULL, 'Potassium voltage-gated channel, subfamily H (eag-related), member 6', NULL, NULL, NULL, NULL, NULL, 4),
(89540, NULL, 'G3DSA:2.60.40.10:FF:005920', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89541, NULL, 'G3DSA:1.25.10.10:FF:000628', NULL, NULL, 'tRNA binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89542, NULL, 'G3DSA:1.10.8.50:FF:000009', NULL, NULL, 'Formamidopyrimidine-DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(89543, NULL, 'G3DSA:1.25.40.860:FF:000015', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(89544, NULL, 'G3DSA:2.60.120.560:FF:000036', NULL, NULL, 'Heat shock protein DnaJ domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(89545, NULL, 'G3DSA:1.20.80.10:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89546, NULL, 'G3DSA:3.40.50.2000:FF:001023', NULL, NULL, 'UDP-N-acetylglucosamine transferase subunit alg14', NULL, NULL, NULL, NULL, NULL, 4),
(89547, NULL, 'G3DSA:1.20.1250.20:FF:001248', NULL, NULL, 'Solute carrier family 15 member 1a', NULL, NULL, NULL, NULL, NULL, 4),
(89548, NULL, 'G3DSA:1.25.10.10:FF:002540', NULL, NULL, 'Armadillo repeat-containing zfs1 target protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(89549, NULL, 'G3DSA:4.10.400.10:FF:000164', NULL, NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(89550, NULL, 'G3DSA:2.40.170.20:FF:000003', NULL, NULL, 'Ferrichrome outer membrane transporter/phage receptor', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(89551, NULL, 'G3DSA:1.20.58.480:FF:000011', NULL, NULL, 'Indoleamine 2,3-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(89552, NULL, 'G3DSA:1.10.10.60:FF:000654', NULL, NULL, 'Homeobox transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(89553, NULL, 'G3DSA:3.10.129.10:FF:000099', NULL, NULL, 'UPF0336 protein Rv0635', NULL, NULL, NULL, NULL, NULL, 4),
(89554, NULL, 'G3DSA:2.60.40.1090:FF:000043', NULL, NULL, 'Fimbrial subunit CupC1', NULL, NULL, NULL, NULL, NULL, 4),
(89555, NULL, 'G3DSA:3.30.200.20:FF:001921', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89556, NULL, 'G3DSA:1.20.5.110:FF:000289', NULL, NULL, 'Synaptobrevin-B', NULL, NULL, NULL, NULL, NULL, 4),
(89557, NULL, 'G3DSA:2.130.10.10:FF:000322', NULL, NULL, 'Methylosome protein 50', NULL, NULL, NULL, NULL, NULL, 4),
(89558, NULL, 'G3DSA:3.90.550.10:FF:000329', NULL, NULL, 'Xyloglucan 6-xylosyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(89559, NULL, 'G3DSA:3.30.70.330:FF:000080', NULL, NULL, 'RNA-binding protein 39 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(89560, NULL, 'G3DSA:1.20.1250.20:FF:000848', NULL, NULL, 'Drug resistance transporter, EmrB/QacA family', NULL, NULL, NULL, NULL, NULL, 4),
(89561, NULL, 'G3DSA:3.40.50.2000:FF:000404', NULL, NULL, 'Putative polysaccharide biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(89562, NULL, 'G3DSA:1.25.40.20:FF:001639', NULL, NULL, 'Protein 21.1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89563, NULL, 'G3DSA:1.10.10.1440:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89564, NULL, 'G3DSA:3.90.226.10:FF:000059', NULL, NULL, 'ATP-dependent Clp protease proteolytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(89565, NULL, 'G3DSA:3.30.1370.10:FF:000171', NULL, NULL, 'Exosomal 3''-5'' exoribonuclease complex subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89566, NULL, 'G3DSA:3.20.20.190:FF:000136', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89567, NULL, 'G3DSA:3.40.190.10:FF:000138', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(89568, NULL, 'G3DSA:3.40.1390.20:FF:000004', NULL, NULL, 'HPr kinase/phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(89569, NULL, 'G3DSA:1.25.40.20:FF:001858', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(89570, NULL, 'G3DSA:3.40.47.10:FF:000263', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89571, NULL, 'G3DSA:1.10.3650.10:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89572, NULL, 'G3DSA:1.20.120.430:FF:000024', NULL, NULL, 'tRNA modification GTPase GTPBP3, mitochondrial-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(89573, NULL, 'G3DSA:2.10.25.10:FF:000986', NULL, NULL, 'Megalin, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(89574, NULL, 'G3DSA:3.30.50.10:FF:000035', NULL, NULL, 'Nuclear receptor subfamily 1 group I member 3', NULL, NULL, NULL, NULL, NULL, 4),
(89575, NULL, 'G3DSA:3.30.230.70:FF:000005', NULL, NULL, 'Exosome complex component RRP45', NULL, NULL, NULL, NULL, NULL, 4),
(89576, NULL, 'G3DSA:3.30.160.60:FF:001862', NULL, NULL, 'Zgc:174563 protein', NULL, NULL, NULL, NULL, NULL, 4),
(89577, NULL, 'G3DSA:1.10.150.110:FF:000032', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(89578, NULL, 'G3DSA:3.40.50.150:FF:000530', NULL, NULL, 'Os11g0256900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(89579, NULL, 'G3DSA:2.160.20.10:FF:000131', NULL, NULL, 'Right_handed_beta_helix_region /Periplasmic_copper-binding_protein_(NosD)_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(89580, NULL, 'G3DSA:3.30.450.40:FF:000226', NULL, NULL, 'Serine phosphatase RsbU, regulator of sigma subunit', NULL, NULL, NULL, NULL, NULL, 4),
(89581, NULL, 'G3DSA:3.10.450.50:FF:000082', NULL, NULL, 'Ras GTPase-activating protein-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(89582, NULL, 'G3DSA:4.10.75.10:FF:000006', NULL, NULL, 'Protein CBG06419', NULL, NULL, NULL, NULL, NULL, 4),
(89583, NULL, 'G3DSA:3.90.76.10:FF:000030', NULL, NULL, 'Oligopeptide ABC transporter, oligopeptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(89584, NULL, 'G3DSA:1.20.1250.20:FF:001809', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89585, NULL, 'G3DSA:3.40.50.450:FF:000064', NULL, NULL, 'Phosphofructokinase, platelet b', NULL, NULL, NULL, NULL, NULL, 4),
(89586, NULL, 'G3DSA:2.60.40.10:FF:000232', NULL, NULL, 'Kirre like nephrin family adhesion molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(89587, NULL, 'G3DSA:3.30.70.870:FF:000011', NULL, NULL, 'Elongation factor Tu, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89588, NULL, 'G3DSA:3.40.50.2000:FF:000062', NULL, NULL, 'sulfoquinovosyl transferase SQD2', NULL, NULL, NULL, NULL, NULL, 4),
(89589, NULL, 'G3DSA:1.10.1450.10:FF:000009', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(89590, NULL, 'G3DSA:3.50.50.60:FF:000982', NULL, NULL, 'Fmo1p', NULL, NULL, NULL, NULL, NULL, 4),
(89591, NULL, 'G3DSA:3.90.1420.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89592, NULL, 'G3DSA:1.10.510.10:FF:001645', NULL, NULL, 'Serine/threonine-protein kinase BGLF4', NULL, NULL, NULL, NULL, NULL, 4),
(89593, NULL, 'G3DSA:3.40.50.300:FF:005050', NULL, NULL, 'Adp-ribosylation factor-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(89594, NULL, 'G3DSA:3.30.1050.10:FF:000023', NULL, NULL, 'Metallo-beta-lactamase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(89595, NULL, 'G3DSA:2.60.60.30:FF:000003', NULL, NULL, 'Tellurium resistance protein TerZ', NULL, NULL, NULL, NULL, NULL, 4),
(89596, NULL, 'G3DSA:1.10.10.2660:FF:000031', NULL, NULL, 'Ubiquitin-activating enzyme E1-like (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(89597, NULL, 'G3DSA:1.10.10.60:FF:000093', NULL, NULL, 'ALX homeobox protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(89598, NULL, 'G3DSA:3.10.290.10:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89599, NULL, 'G3DSA:3.30.160.60:FF:005572', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89600, NULL, 'G3DSA:3.30.450.20:FF:000220', NULL, NULL, 'Sensory box/GGDEF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(89601, NULL, 'G3DSA:2.10.25.10:FF:001823', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89602, NULL, 'G3DSA:3.40.50.300:FF:008484', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89603, NULL, 'G3DSA:1.20.1560.10:FF:000616', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89604, NULL, 'G3DSA:1.10.2000.10:FF:000083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89605, NULL, 'G3DSA:1.10.10.570:FF:000016', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(89606, NULL, 'G3DSA:1.10.510.10:FF:001100', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(89607, NULL, 'G3DSA:2.130.10.10:FF:002211', NULL, NULL, 'Elongator complex protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(89608, NULL, 'G3DSA:3.30.40.10:FF:001389', NULL, NULL, 'Lysine-specific demethylase rbr-2', NULL, NULL, NULL, NULL, NULL, 4),
(89609, NULL, 'G3DSA:1.10.8.480:FF:000019', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(89610, NULL, 'G3DSA:2.60.40.10:FF:004324', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89611, NULL, 'G3DSA:3.40.1110.10:FF:000088', NULL, NULL, 'Potassium/sodium efflux P-type ATPase, fungal-type', NULL, NULL, NULL, NULL, NULL, 4),
(89612, NULL, 'G3DSA:1.10.10.10:FF:001775', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(89613, NULL, 'G3DSA:3.30.9.10:FF:000075', NULL, NULL, 'FAD dependent oxidoreductase superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(89614, NULL, 'G3DSA:2.120.10.80:FF:000175', NULL, NULL, 'Nitrile-specifier protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(89615, NULL, 'G3DSA:3.90.830.10:FF:000019', NULL, NULL, 'Vacuolar protein sorting-associated protein 33B', NULL, NULL, NULL, NULL, NULL, 4),
(89616, NULL, 'G3DSA:3.50.50.60:FF:000324', NULL, NULL, 'AMine oXidase family', NULL, NULL, NULL, NULL, NULL, 4),
(89617, NULL, 'G3DSA:1.10.510.40:FF:000007', NULL, NULL, 'Siderophore biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(89618, NULL, 'G3DSA:1.10.565.10:FF:000018', NULL, NULL, 'Bile acid receptor isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(89619, NULL, 'G3DSA:3.40.50.1820:FF:001502', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89620, NULL, 'G3DSA:1.20.58.740:FF:000005', NULL, NULL, 'Guanine nucleotide exchange factor SPIKE 1', NULL, NULL, NULL, NULL, NULL, 4),
(89621, NULL, 'G3DSA:3.50.50.60:FF:001426', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89622, NULL, 'G3DSA:1.25.40.10:FF:001962', NULL, NULL, 'Transcription-coupled DNA repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(89623, NULL, 'G3DSA:3.60.15.10:FF:000031', NULL, NULL, 'integrator complex subunit 11 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(89624, NULL, 'G3DSA:3.30.160.60:FF:006370', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89625, NULL, 'G3DSA:1.25.10.10:FF:000353', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 56 kDa regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(89626, NULL, 'G3DSA:2.10.25.10:FF:001290', NULL, NULL, 'AGAP002157-PA', NULL, NULL, NULL, NULL, NULL, 4),
(89627, NULL, 'G3DSA:1.10.510.10:FF:003663', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89628, NULL, 'G3DSA:2.160.20.10:FF:000260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89629, NULL, 'G3DSA:2.40.50.140:FF:000183', NULL, NULL, '26S protease regulatory subunit 6a, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89630, NULL, 'G3DSA:2.40.170.20:FF:000026', NULL, NULL, 'Putative hydroxamate-type ferrisiderophore receptor', NULL, NULL, NULL, NULL, NULL, 4),
(89631, NULL, 'G3DSA:1.25.10.10:FF:002444', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89632, NULL, 'G3DSA:3.90.76.10:FF:000047', NULL, NULL, 'ABC-type dipeptide transport system periplasmic component', NULL, NULL, NULL, NULL, NULL, 4),
(89633, NULL, 'G3DSA:2.40.70.10:FF:000572', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89634, NULL, 'G3DSA:3.30.160.60:FF:000058', NULL, NULL, 'Zinc finger protein 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(89635, NULL, 'G3DSA:3.80.10.10:FF:003751', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89636, NULL, 'G3DSA:3.40.50.300:FF:007388', NULL, NULL, 'Guanine nucleotide-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89637, NULL, 'G3DSA:1.25.10.10:FF:001455', NULL, NULL, 'VPS15 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(89638, NULL, 'G3DSA:1.10.1600.10:FF:000004', NULL, NULL, 'ATP-dependent DNA helicase II subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(89639, NULL, 'G3DSA:3.10.20.310:FF:000034', NULL, NULL, 'ShlB/FhaC/HecB family hemolysin secretion/activation protein', NULL, NULL, NULL, NULL, NULL, 4),
(89640, NULL, 'G3DSA:1.10.10.10:FF:000201', NULL, NULL, 'Forkhead box E1', NULL, NULL, NULL, NULL, NULL, 4),
(89641, NULL, 'G3DSA:1.20.58.730:FF:000002', NULL, NULL, 'GD16546', NULL, NULL, NULL, NULL, NULL, 4),
(89642, NULL, 'G3DSA:1.10.510.10:FF:004326', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89643, NULL, 'G3DSA:3.80.10.10:FF:002762', NULL, NULL, 'F-box/LRR-repeat protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(89644, NULL, 'G3DSA:3.30.56.70:FF:000004', NULL, NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(89645, NULL, 'G3DSA:2.60.40.150:FF:000106', NULL, NULL, 'extended synaptotagmin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(89646, NULL, 'G3DSA:2.10.70.100:FF:000002', NULL, NULL, 'Two-component oxygen-sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(89647, NULL, 'G3DSA:3.40.50.300:FF:006253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89648, NULL, 'G3DSA:1.20.1070.10:FF:000854', NULL, NULL, 'Protein CBR-SER-1', NULL, NULL, NULL, NULL, NULL, 4),
(89649, NULL, 'G3DSA:3.10.20.90:FF:000277', NULL, NULL, 'Regulator of G-protein signaling loco', NULL, NULL, NULL, NULL, NULL, 4),
(89650, NULL, 'G3DSA:2.130.10.10:FF:004302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(89651, NULL, 'G3DSA:1.20.1560.10:FF:000875', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(89652, NULL, 'G3DSA:2.60.40.1480:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89653, NULL, 'G3DSA:1.10.8.60:FF:000209', NULL, NULL, 'ClpB protein', NULL, NULL, NULL, NULL, NULL, 4),
(89654, NULL, 'G3DSA:2.30.30.40:FF:000337', NULL, NULL, 'Disks large homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(89655, NULL, 'G3DSA:3.30.70.1230:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89656, NULL, 'G3DSA:1.10.287.110:FF:000475', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89657, NULL, 'G3DSA:3.40.50.300:FF:004162', NULL, NULL, 'ATP binding cassette subfamily C member 5', NULL, NULL, NULL, NULL, NULL, 4),
(89658, NULL, 'G3DSA:2.110.10.10:FF:000076', NULL, NULL, 'Matrix metallopeptidase 17b', NULL, NULL, NULL, NULL, NULL, 4),
(89659, NULL, 'G3DSA:2.30.29.30:FF:000909', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89660, NULL, 'G3DSA:3.30.1150.10:FF:000014', NULL, NULL, 'Energy transducer TonB', NULL, NULL, NULL, NULL, NULL, 4),
(89661, NULL, 'G3DSA:1.25.40.20:FF:000830', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(89662, NULL, 'G3DSA:3.90.1290.10:FF:000049', NULL, NULL, 'AGAP011396-PA', NULL, NULL, NULL, NULL, NULL, 4),
(89663, NULL, 'G3DSA:2.60.120.920:FF:000048', NULL, NULL, 'SPRY domain-containing SOCS box protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(89664, NULL, 'G3DSA:1.20.1070.10:FF:001517', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89665, NULL, 'G3DSA:1.20.1250.20:FF:001618', NULL, NULL, 'Polyol transporter 5', NULL, NULL, NULL, NULL, NULL, 4),
(89666, NULL, 'G3DSA:1.10.560.10:FF:000029', NULL, NULL, 'Chaperonin CPN60, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(89667, NULL, 'G3DSA:2.60.40.10:FF:005785', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89668, NULL, 'G3DSA:2.10.25.10:FF:000828', NULL, NULL, 'Thrombospondin-3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(89669, NULL, 'G3DSA:2.40.110.10:FF:000047', NULL, NULL, 'Acyl-CoA dehydrogenase FadE27', NULL, NULL, NULL, NULL, NULL, 4),
(89670, NULL, 'G3DSA:1.25.40.10:FF:000501', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(89671, NULL, 'G3DSA:3.30.1490.120:FF:000007', NULL, NULL, 'RNA polymerase-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89672, NULL, 'G3DSA:2.30.30.40:FF:000663', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89673, NULL, 'G3DSA:2.130.10.10:FF:001694', NULL, NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(89674, NULL, 'G3DSA:3.40.50.2300:FF:001366', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89675, NULL, 'G3DSA:3.10.28.10:FF:000063', NULL, NULL, 'Cytochrome b mRNA maturase bI3', NULL, NULL, NULL, NULL, NULL, 4),
(89676, NULL, 'G3DSA:3.40.640.10:FF:000241', NULL, NULL, 'Glutamate decarboxylase isoform 67', NULL, NULL, NULL, NULL, NULL, 4),
(89677, NULL, 'G3DSA:2.30.180.10:FF:000166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89678, NULL, 'G3DSA:1.20.1280.50:FF:000146', NULL, NULL, 'Dactylin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89679, NULL, 'G3DSA:2.60.40.150:FF:000432', NULL, NULL, 'Synaptotagmin 15b', NULL, NULL, NULL, NULL, NULL, 4),
(89680, NULL, 'G3DSA:1.10.132.70:FF:000019', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(89681, NULL, 'G3DSA:3.40.50.12350:FF:000018', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(89682, NULL, 'G3DSA:1.10.20.10:FF:000319', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89683, NULL, 'G3DSA:1.10.10.1590:FF:000002', NULL, NULL, '[Fe] hydrogenase, HymA subunit', NULL, NULL, NULL, NULL, NULL, 4),
(89684, NULL, 'G3DSA:3.40.50.10090:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(89685, NULL, 'G3DSA:2.130.10.10:FF:005763', NULL, NULL, 'Myosin heavy chain kinase D', NULL, NULL, NULL, NULL, NULL, 4),
(89686, NULL, 'G3DSA:1.25.70.10:FF:000003', NULL, NULL, 'transcription termination factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(89687, NULL, 'G3DSA:3.40.50.150:FF:001694', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89688, NULL, 'G3DSA:3.30.1490.110:FF:000004', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(89689, NULL, 'G3DSA:1.25.40.20:FF:000504', NULL, NULL, 'Mindbomb E3 ubiquitin protein ligase 2', NULL, NULL, NULL, NULL, NULL, 4),
(89690, NULL, 'G3DSA:1.10.8.870:FF:000013', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(89691, NULL, 'G3DSA:3.80.10.10:FF:003425', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(89692, NULL, 'G3DSA:1.10.132.60:FF:000016', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(89693, NULL, 'G3DSA:2.40.30.10:FF:000507', NULL, NULL, 'NADPH oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(89694, NULL, 'G3DSA:1.20.120.1210:FF:000001', NULL, NULL, 'T3SS2 effector VopL nucleation of actin polymerization', NULL, NULL, NULL, NULL, NULL, 4),
(89695, NULL, 'G3DSA:3.40.50.300:FF:006932', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89696, NULL, 'G3DSA:1.25.40.20:FF:000184', NULL, NULL, 'Ankyrin repeat and FYVE domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(89697, NULL, 'G3DSA:1.20.120.1750:FF:000140', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(89698, NULL, 'G3DSA:1.10.510.10:FF:002235', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89699, NULL, 'G3DSA:1.10.420.10:FF:000019', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(89700, NULL, 'G3DSA:2.130.10.10:FF:003785', NULL, NULL, 'Uncharacterized WD repeat-containing protein C824.04', NULL, NULL, NULL, NULL, NULL, 4),
(89701, NULL, 'G3DSA:1.10.220.10:FF:000038', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(89702, NULL, 'G3DSA:3.60.21.10:FF:000444', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(89703, NULL, 'G3DSA:1.10.150.80:FF:000042', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(89704, NULL, 'G3DSA:3.40.190.10:FF:000812', NULL, NULL, 'Transferrin-a', NULL, NULL, NULL, NULL, NULL, 4),
(89705, NULL, 'G3DSA:1.10.10.10:FF:000347', NULL, NULL, 'Ets variant 2', NULL, NULL, NULL, NULL, NULL, 4),
(89706, NULL, 'G3DSA:1.10.238.10:FF:000657', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89707, NULL, 'G3DSA:1.10.238.10:FF:000511', NULL, NULL, 'Actin-bundling protein Sac6', NULL, NULL, NULL, NULL, NULL, 4),
(89708, NULL, 'G3DSA:1.20.5.130:FF:000002', NULL, NULL, 'Bacteriocin carnobacteriocin B2', NULL, NULL, NULL, NULL, NULL, 4),
(89709, NULL, 'G3DSA:1.10.287.110:FF:000003', NULL, NULL, 'Molecular chaperone DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(89710, NULL, 'G3DSA:2.60.40.1460:FF:000002', NULL, NULL, 'Integrin subunit alpha 6', NULL, NULL, NULL, NULL, NULL, 4),
(89711, NULL, 'G3DSA:1.25.40.10:FF:000181', NULL, NULL, 'probable UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SEC', NULL, NULL, NULL, NULL, NULL, 4),
(89712, NULL, 'G3DSA:1.10.10.60:FF:000255', NULL, NULL, 'DnaJ (Hsp40) homolog, subfamily C, member 1', NULL, NULL, NULL, NULL, NULL, 4),
(89713, NULL, 'G3DSA:2.60.40.10:FF:003661', NULL, NULL, 'Fibroblast growth factor receptor homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(89714, NULL, 'G3DSA:2.30.29.30:FF:001045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89715, NULL, 'G3DSA:1.10.268.10:FF:000013', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(89716, NULL, 'G3DSA:2.60.40.10:FF:002233', NULL, NULL, 'Tyrosine protein kinase receptor tie-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89717, NULL, 'G3DSA:3.30.200.20:FF:002219', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89718, NULL, 'G3DSA:2.40.50.140:FF:001285', NULL, NULL, 'Telomere-binding protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(89719, NULL, 'G3DSA:3.30.499.10:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89720, NULL, 'G3DSA:3.30.110.30:FF:000012', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(89721, NULL, 'G3DSA:3.40.50.300:FF:000800', NULL, NULL, 'ATP-binding cassette sub-family D member 1', NULL, NULL, NULL, NULL, NULL, 4),
(89722, NULL, 'G3DSA:3.30.160.60:FF:005908', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89723, NULL, 'G3DSA:1.10.10.580:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89724, NULL, 'G3DSA:3.40.50.1820:FF:000985', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(89725, NULL, 'G3DSA:3.30.450.20:FF:000113', NULL, NULL, 'Taiman, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(89726, NULL, 'G3DSA:3.30.1360.170:FF:000016', NULL, NULL, 'Flavin-dependent thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(89727, NULL, 'G3DSA:3.40.50.980:FF:000043', NULL, NULL, '4-chlorobenzoate--CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(89728, NULL, 'G3DSA:4.10.410.10:FF:000081', NULL, NULL, 'Serine proteinase inhibitor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89729, NULL, 'G3DSA:3.30.70.330:FF:001097', NULL, NULL, 'Splicing factor, arginine/serine-rich, 46kD, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(89730, NULL, 'G3DSA:1.20.58.390:FF:000029', NULL, NULL, 'acetylcholine receptor subunit delta isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(89731, NULL, 'G3DSA:3.40.33.10:FF:000208', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(89732, NULL, 'G3DSA:3.40.50.1240:FF:000114', NULL, NULL, 'Probable 6-phosphofructo-2-kinase C222.13c', NULL, NULL, NULL, NULL, NULL, 4),
(89733, NULL, 'G3DSA:3.40.50.2020:FF:000124', NULL, NULL, 'Uridine cytidine kinase I, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89734, NULL, 'G3DSA:3.40.50.1440:FF:000023', NULL, NULL, 'Cell division protein FtsZ', NULL, NULL, NULL, NULL, NULL, 4),
(89735, NULL, 'G3DSA:3.30.65.10:FF:000013', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(89736, NULL, 'G3DSA:2.130.10.10:FF:002357', NULL, NULL, 'WD repeat-containing protein 78', NULL, NULL, NULL, NULL, NULL, 4),
(89737, NULL, 'G3DSA:3.30.420.40:FF:000151', NULL, NULL, 'Actin-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(89738, NULL, 'G3DSA:1.10.630.10:FF:000384', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89739, NULL, 'G3DSA:3.40.50.1100:FF:000005', NULL, NULL, 'Threonine dehydratase catabolic', NULL, NULL, NULL, NULL, NULL, 4),
(89740, NULL, 'G3DSA:1.20.1300.10:FF:000007', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(89741, NULL, 'G3DSA:3.30.160.60:FF:001839', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89742, NULL, 'G3DSA:3.30.1360.120:FF:000108', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(89743, NULL, 'G3DSA:3.30.50.10:FF:000052', NULL, NULL, 'Retinoid x receptor', NULL, NULL, NULL, NULL, NULL, 4),
(89744, NULL, 'G3DSA:3.40.50.300:FF:008231', NULL, NULL, 'RNA cytidine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(89745, NULL, 'G3DSA:3.90.550.10:FF:000037', NULL, NULL, 'Beta-1,4-galactosyltransferase 6', NULL, NULL, NULL, NULL, NULL, 4),
(89746, NULL, 'G3DSA:3.40.50.10420:FF:000018', NULL, NULL, 'Methenyltetrahydrofolate synthase domain-containing protein-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(89747, NULL, 'G3DSA:3.40.50.1000:FF:000273', NULL, NULL, 'Hydrolase, haloacid dehalogenase-like family', NULL, NULL, NULL, NULL, NULL, 4),
(89748, NULL, 'G3DSA:3.80.10.10:FF:003072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89749, NULL, 'G3DSA:1.10.10.350:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89750, NULL, 'G3DSA:3.40.50.11980:FF:000008', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(89751, NULL, 'G3DSA:2.40.50.150:FF:000040', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(89752, NULL, 'G3DSA:1.20.1250.20:FF:000955', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(89753, NULL, 'G3DSA:2.160.20.70:FF:000019', NULL, NULL, 'Adenylyl cyclase-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(89754, NULL, 'G3DSA:3.30.830.10:FF:000123', NULL, NULL, 'Peptidase, M16 family', NULL, NULL, NULL, NULL, NULL, 4),
(89755, NULL, 'G3DSA:3.30.160.60:FF:004392', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89756, NULL, 'G3DSA:2.90.10.10:FF:000010', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(89757, NULL, 'G3DSA:3.40.50.150:FF:000266', NULL, NULL, 'Alpha/beta fold hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(89758, NULL, 'G3DSA:3.60.21.10:FF:000091', NULL, NULL, 'Sulfur oxidation protein SoxB', NULL, NULL, NULL, NULL, NULL, 4),
(89759, NULL, 'G3DSA:1.10.12.10:FF:000037', NULL, NULL, '2-(1,2-epoxy-1,2-dihydrophenyl)acetyl-CoA isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(89760, NULL, 'G3DSA:3.40.50.300:FF:000093', NULL, NULL, 'Fidgetin-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(89761, NULL, 'G3DSA:3.50.40.10:FF:000005', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(89762, NULL, 'G3DSA:1.10.555.10:FF:000079', NULL, NULL, 'YHR182W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(89763, NULL, 'G3DSA:1.20.1070.10:FF:000528', NULL, NULL, 'SEcretin/class B GPCR', NULL, NULL, NULL, NULL, NULL, 4),
(89764, NULL, 'G3DSA:3.80.10.10:FF:001334', NULL, NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g53420', NULL, NULL, NULL, NULL, NULL, 4),
(89765, NULL, 'G3DSA:1.10.730.10:FF:000122', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(89766, NULL, 'G3DSA:3.40.1380.10:FF:000017', NULL, NULL, 'ATP synthase subunit gamma, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(89767, NULL, 'G3DSA:3.30.1330.30:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89768, NULL, 'G3DSA:2.120.10.30:FF:000121', NULL, NULL, 'Protein CBR-TEN-1', NULL, NULL, NULL, NULL, NULL, 4),
(89769, NULL, 'G3DSA:3.40.33.10:FF:000181', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(89770, NULL, 'G3DSA:3.30.160.60:FF:006044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89771, NULL, 'G3DSA:1.25.10.10:FF:000027', NULL, NULL, 'Importin subunit beta-1', NULL, NULL, NULL, NULL, NULL, 4),
(89772, NULL, 'G3DSA:1.10.1200.270:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89773, NULL, 'G3DSA:1.20.1110.10:FF:000263', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89774, NULL, 'G3DSA:3.40.50.410:FF:000187', NULL, NULL, 'ATP-dependent DNA helicase II subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(89775, NULL, 'G3DSA:3.40.50.10810:FF:000045', NULL, NULL, 'Putative chromatin-remodeling complex ATPase chain', NULL, NULL, NULL, NULL, NULL, 4),
(89776, NULL, 'G3DSA:3.30.230.130:FF:000073', NULL, NULL, 'Cullin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89777, NULL, 'G3DSA:3.40.50.1820:FF:000659', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(89778, NULL, 'G3DSA:1.10.1320.10:FF:000022', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(89779, NULL, 'G3DSA:2.60.40.10:FF:005459', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89780, NULL, 'G3DSA:3.40.50.10190:FF:000258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89781, NULL, 'G3DSA:3.30.420.40:FF:000090', NULL, NULL, 'Anhydro-N-acetylmuramic acid kinase', NULL, NULL, NULL, NULL, NULL, 4),
(89782, NULL, 'G3DSA:2.130.10.10:FF:003200', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1', NULL, NULL, NULL, NULL, NULL, 4),
(89783, NULL, 'G3DSA:1.25.40.10:FF:001283', NULL, NULL, 'Vegetative storage protein', NULL, NULL, NULL, NULL, NULL, 4),
(89784, NULL, 'G3DSA:3.40.50.300:FF:002245', NULL, NULL, 'ATP-dependent RNA helicase MAK5', NULL, NULL, NULL, NULL, NULL, 4),
(89785, NULL, 'G3DSA:1.25.10.10:FF:002118', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(89786, NULL, 'G3DSA:1.10.540.10:FF:000085', NULL, NULL, 'Acyl-CoA dehydrogenase (Acd-7)', NULL, NULL, NULL, NULL, NULL, 4),
(89787, NULL, 'G3DSA:3.40.50.620:FF:000778', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89788, NULL, 'G3DSA:2.60.120.10:FF:000268', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(89789, NULL, 'G3DSA:1.10.3730.20:FF:000045', NULL, NULL, 'DMT family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(89790, NULL, 'G3DSA:3.10.50.40:FF:000051', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(89791, NULL, 'G3DSA:1.20.1070.10:FF:001843', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89792, NULL, 'G3DSA:1.20.58.670:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89793, NULL, 'G3DSA:3.90.1600.10:FF:000001', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(89794, NULL, 'G3DSA:2.60.120.260:FF:000070', NULL, NULL, 'Nuclear receptor 2C2-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(89795, NULL, 'G3DSA:3.40.50.720:FF:001825', NULL, NULL, 'Prephenate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(89796, NULL, 'G3DSA:1.10.510.10:FF:000583', NULL, NULL, 'Inactive leucine-rich repeat receptor-like protein kinase CORYNE', NULL, NULL, NULL, NULL, NULL, 4),
(89797, NULL, 'G3DSA:3.30.530.20:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89798, NULL, 'G3DSA:3.40.1180.10:FF:000036', NULL, NULL, 'Alkyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(89799, NULL, 'G3DSA:3.40.50.300:FF:000154', NULL, NULL, 'Vesicle-fusing ATPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(89800, NULL, 'G3DSA:1.25.10.10:FF:001781', NULL, NULL, 'Nuclear import and export protein Msn5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89801, NULL, 'G3DSA:3.10.250.10:FF:000139', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89802, NULL, 'G3DSA:2.30.29.30:FF:001371', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(89803, NULL, 'G3DSA:1.20.1050.20:FF:000002', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(89804, NULL, 'G3DSA:3.40.50.300:FF:008377', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89805, NULL, 'G3DSA:1.10.720.30:FF:000043', NULL, NULL, 'Scaffold attachment factor B1', NULL, NULL, NULL, NULL, NULL, 4),
(89806, NULL, 'G3DSA:2.130.10.10:FF:005437', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89807, NULL, 'G3DSA:1.10.287.70:FF:000581', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(89808, NULL, 'G3DSA:1.10.10.10:FF:000673', NULL, NULL, 'DtxR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(89809, NULL, 'G3DSA:3.40.50.300:FF:004515', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(89810, NULL, 'G3DSA:3.30.450.40:FF:000119', NULL, NULL, 'Two-component sensor KdpD', NULL, NULL, NULL, NULL, NULL, 4),
(89811, NULL, 'G3DSA:2.60.40.10:FF:000581', NULL, NULL, 'sodium channel subunit beta-1', NULL, NULL, NULL, NULL, NULL, 4),
(89812, NULL, 'G3DSA:1.20.1250.20:FF:001265', NULL, NULL, 'Major facilitator superfamily domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(89813, NULL, 'G3DSA:3.40.50.1010:FF:000276', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89814, NULL, 'G3DSA:3.90.1420.10:FF:000049', NULL, NULL, 'Histone-lysine N-methyltransferase setd3-like', NULL, NULL, NULL, NULL, NULL, 4),
(89815, NULL, 'G3DSA:2.20.25.630:FF:000005', NULL, NULL, 'Poly [ADP-ribose] polymerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(89816, NULL, 'G3DSA:3.40.50.11960:FF:000002', NULL, NULL, 'Increased recombination centers protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(89817, NULL, 'G3DSA:3.30.160.60:FF:002828', NULL, NULL, 'Hamlet, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(89818, NULL, 'G3DSA:1.10.3710.10:FF:000007', NULL, NULL, 'Replication factor C small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(89819, NULL, 'G3DSA:1.20.1070.10:FF:001164', NULL, NULL, 'G-protein coupled receptor GRL101-like protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(89820, NULL, 'G3DSA:3.40.50.300:FF:006606', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89821, NULL, 'G3DSA:3.40.50.1110:FF:000008', NULL, NULL, 'Sialate O-acetylesterase', NULL, NULL, NULL, NULL, NULL, 4),
(89822, NULL, 'G3DSA:3.40.50.150:FF:001368', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89823, NULL, 'G3DSA:3.10.100.10:FF:000370', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89824, NULL, 'G3DSA:3.40.47.10:FF:000004', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 3', NULL, NULL, NULL, NULL, NULL, 4),
(89825, NULL, 'G3DSA:2.10.70.10:FF:000197', NULL, NULL, 'Mannose-binding lectin associated serine protease-3', NULL, NULL, NULL, NULL, NULL, 4),
(89826, NULL, 'G3DSA:2.60.40.10:FF:004150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89827, NULL, 'G3DSA:1.10.287.70:FF:000788', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89828, NULL, 'G3DSA:2.60.40.10:FF:003868', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89829, NULL, 'G3DSA:2.120.10.30:FF:000093', NULL, NULL, 'Calcium homeostasis protein Regucalcin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89830, NULL, 'G3DSA:1.10.20.10:FF:000112', NULL, NULL, 'Transcription initiation factor TFIID subunit 12', NULL, NULL, NULL, NULL, NULL, 4),
(89831, NULL, 'G3DSA:3.50.70.10:FF:000007', NULL, NULL, 'Chalcone-flavonone isomerase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(89832, NULL, 'G3DSA:1.10.472.10:FF:000072', NULL, NULL, 'Cyclin Pch1', NULL, NULL, NULL, NULL, NULL, 4),
(89833, NULL, 'G3DSA:3.90.1260.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89834, NULL, 'G3DSA:1.10.540.10:FF:000146', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(89835, NULL, 'G3DSA:3.40.50.1000:FF:000301', NULL, NULL, 'Potassium-transporting ATPase alpha chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(89836, NULL, 'G3DSA:1.10.287.70:FF:000608', NULL, NULL, 'Potassium channel subfamily K member', NULL, NULL, NULL, NULL, NULL, 4),
(89837, NULL, 'G3DSA:3.30.497.10:FF:000061', NULL, NULL, 'Serpin 2', NULL, NULL, NULL, NULL, NULL, 4),
(89838, NULL, 'G3DSA:1.25.10.10:FF:000527', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(89839, NULL, 'G3DSA:2.60.40.10:FF:001744', NULL, NULL, 'filamin-A isoform X8', NULL, NULL, NULL, NULL, NULL, 4),
(89840, NULL, 'G3DSA:3.40.50.10190:FF:000319', NULL, NULL, 'Nibrin', NULL, NULL, NULL, NULL, NULL, 4),
(89841, NULL, 'G3DSA:3.30.70.100:FF:000185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89842, NULL, 'G3DSA:1.10.510.10:FF:001746', NULL, NULL, 'Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(89843, NULL, 'G3DSA:1.20.58.390:FF:000181', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(89844, NULL, 'G3DSA:3.30.565.10:FF:000135', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(89845, NULL, 'G3DSA:1.10.510.10:FF:004152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89846, NULL, 'G3DSA:3.30.505.10:FF:000126', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(89847, NULL, 'G3DSA:3.40.225.10:FF:000006', NULL, NULL, 'Rhamnulose-1-phosphate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(89848, NULL, 'G3DSA:1.25.40.10:FF:000029', NULL, NULL, 'peptidyl-prolyl cis-trans isomerase D', NULL, NULL, NULL, NULL, NULL, 4),
(89849, NULL, 'G3DSA:3.30.70.330:FF:000315', NULL, NULL, 'RNA-binding motif protein 28', NULL, NULL, NULL, NULL, NULL, 4),
(89850, NULL, 'G3DSA:3.30.1680.10:FF:000014', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(89851, NULL, 'G3DSA:3.30.160.60:FF:004453', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89852, NULL, 'G3DSA:3.40.630.20:FF:000007', NULL, NULL, 'Protein CBG22077', NULL, NULL, NULL, NULL, NULL, 4),
(89853, NULL, 'G3DSA:2.60.40.1770:FF:000005', NULL, NULL, 'Eph receptor tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(89854, NULL, 'G3DSA:1.20.1420.30:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(89855, NULL, 'G3DSA:3.30.40.10:FF:001861', NULL, NULL, 'RING-box protein 1A-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(89856, NULL, 'G3DSA:3.90.550.10:FF:000363', NULL, NULL, 'Meiotically up-regulated gene 136 protein', NULL, NULL, NULL, NULL, NULL, 4),
(89857, NULL, 'G3DSA:1.25.10.10:FF:002270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89858, NULL, 'G3DSA:2.30.30.170:FF:000004', NULL, NULL, 'Mannosyl-glycoprotein endo-beta-N-acetylglucosamidase', NULL, NULL, NULL, NULL, NULL, 4),
(89859, NULL, 'G3DSA:3.30.70.330:FF:002114', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89860, NULL, 'G3DSA:2.60.40.1760:FF:000002', NULL, NULL, 'neutral alpha-glucosidase AB isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(89861, NULL, 'G3DSA:1.50.40.10:FF:000555', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89862, NULL, 'G3DSA:2.60.40.10:FF:000642', NULL, NULL, 'Bent, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(89863, NULL, 'G3DSA:2.30.30.40:FF:000163', NULL, NULL, 'crk-like protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(89864, NULL, 'G3DSA:3.30.830.10:FF:000302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89865, NULL, 'G3DSA:3.40.50.300:FF:003998', NULL, NULL, 'AGL142Cp', NULL, NULL, NULL, NULL, NULL, 4),
(89866, NULL, 'G3DSA:1.10.3720.10:FF:000070', NULL, NULL, 'Inner membrane ABC transporter permease YdcU', NULL, NULL, NULL, NULL, NULL, 4),
(89867, NULL, 'G3DSA:3.40.630.10:FF:000004', NULL, NULL, 'Probable cytosol aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(89868, NULL, 'G3DSA:2.30.30.180:FF:000007', NULL, NULL, 'Ribosome maturation factor RimP', NULL, NULL, NULL, NULL, NULL, 4),
(89869, NULL, 'G3DSA:2.30.30.570:FF:000001', NULL, NULL, 'major vault protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(89870, NULL, 'G3DSA:2.40.30.10:FF:000007', NULL, NULL, 'Translation initiation factor IF-2', NULL, NULL, NULL, NULL, NULL, 4),
(89871, NULL, 'G3DSA:3.10.280.10:FF:000028', NULL, NULL, 'p22 protein', NULL, NULL, NULL, NULL, NULL, 4),
(89872, NULL, 'G3DSA:1.20.120.1760:FF:000082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89873, NULL, 'G3DSA:2.10.50.10:FF:000134', NULL, NULL, 'Tumor necrosis factor receptor superfamily, member 11b', NULL, NULL, NULL, NULL, NULL, 4),
(89874, NULL, 'G3DSA:3.30.460.10:FF:000049', NULL, NULL, 'RELA/SPOT homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(89875, NULL, 'G3DSA:2.60.120.1190:FF:000005', NULL, NULL, 'Epithelial discoidin domain-containing receptor', NULL, NULL, NULL, NULL, NULL, 4),
(89876, NULL, 'G3DSA:3.90.70.10:FF:000034', NULL, NULL, 'ubiquitin carboxyl-terminal hydrolase 15 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(89877, NULL, 'G3DSA:1.10.510.10:FF:000611', NULL, NULL, 'CMGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(89878, NULL, 'G3DSA:3.40.50.150:FF:000766', NULL, NULL, 'tRNA methyltransferase 9B', NULL, NULL, NULL, NULL, NULL, 4),
(89879, NULL, 'G3DSA:3.30.450.40:FF:000271', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(89880, NULL, 'G3DSA:3.80.10.10:FF:000845', NULL, NULL, 'Disease resistance protein (TIR-NBS-LRR class)', NULL, NULL, NULL, NULL, NULL, 4),
(89881, NULL, 'G3DSA:3.20.20.300:FF:000006', NULL, NULL, 'Beta-glucosidase H', NULL, NULL, NULL, NULL, NULL, 4),
(89882, NULL, 'G3DSA:3.30.200.20:FF:001495', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(89883, NULL, 'G3DSA:3.40.630.30:FF:000336', NULL, NULL, 'GNAT family N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(89884, NULL, 'G3DSA:1.10.510.10:FF:002409', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89885, NULL, 'G3DSA:3.40.630.30:FF:000628', NULL, NULL, 'N-hydroxyputrescine-succinyl CoA transferase PubB', NULL, NULL, NULL, NULL, NULL, 4),
(89886, NULL, 'G3DSA:3.40.50.300:FF:008170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89887, NULL, 'G3DSA:3.40.30.10:FF:000348', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(89888, NULL, 'G3DSA:2.130.10.10:FF:004274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(89889, NULL, 'G3DSA:3.40.50.150:FF:001868', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89890, NULL, 'G3DSA:3.30.160.60:FF:005847', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89891, NULL, 'G3DSA:1.10.3210.10:FF:000014', NULL, NULL, 'HD domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(89892, NULL, 'G3DSA:3.30.710.10:FF:000468', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89893, NULL, 'G3DSA:4.10.400.10:FF:000136', NULL, NULL, 'low-density lipoprotein receptor isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(89894, NULL, 'G3DSA:3.30.420.10:FF:000721', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89895, NULL, 'G3DSA:2.30.29.30:FF:001219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89896, NULL, 'G3DSA:4.10.860.120:FF:000024', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(89897, NULL, 'G3DSA:2.40.20.10:FF:000035', NULL, NULL, 'SI:dZ46M7.2 (Novel kinase)', NULL, NULL, NULL, NULL, NULL, 4),
(89898, NULL, 'G3DSA:3.80.10.10:FF:001155', NULL, NULL, 'F-box domain containing protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(89899, NULL, 'G3DSA:1.20.5.440:FF:000005', NULL, NULL, 'ATP synthase epsilon chain', NULL, NULL, NULL, NULL, NULL, 4),
(89900, NULL, 'G3DSA:1.20.1250.20:FF:001591', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89901, NULL, 'G3DSA:3.90.70.10:FF:000326', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 25', NULL, NULL, NULL, NULL, NULL, 4),
(89902, NULL, 'G3DSA:1.25.50.20:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89903, NULL, 'G3DSA:1.10.1900.10:FF:000016', NULL, NULL, 'DEAD-box ATP-dependent RNA helicase 39', NULL, NULL, NULL, NULL, NULL, 4),
(89904, NULL, 'G3DSA:1.25.10.10:FF:002091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89905, NULL, 'G3DSA:2.60.40.10:FF:000255', NULL, NULL, 'receptor-type tyrosine-protein phosphatase gamma isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(89906, NULL, 'G3DSA:2.60.120.40:FF:000018', NULL, NULL, 'Tumor necrosis factor ligand superfamily member 15', NULL, NULL, NULL, NULL, NULL, 4),
(89907, NULL, 'G3DSA:2.60.40.1180:FF:000008', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(89908, NULL, 'G3DSA:2.70.130.10:FF:000008', NULL, NULL, 'Cation-dependent mannose-6-phosphate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(89909, NULL, 'G3DSA:3.90.1200.10:FF:000038', NULL, NULL, 'Spore coat protein, CotS family', NULL, NULL, NULL, NULL, NULL, 4),
(89910, NULL, 'G3DSA:3.40.50.300:FF:005617', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89911, NULL, 'G3DSA:3.10.20.90:FF:000305', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(89912, NULL, 'G3DSA:3.40.630.10:FF:000330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89913, NULL, 'G3DSA:1.20.5.430:FF:000002', NULL, NULL, 'Heat shock factor-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(89914, NULL, 'G3DSA:2.10.160.10:FF:000001', NULL, NULL, 'Vascular endothelial growth factor A', NULL, NULL, NULL, NULL, NULL, 4),
(89915, NULL, 'G3DSA:1.50.40.10:FF:000263', NULL, NULL, 'Carrier protein MRS3/4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89916, NULL, 'G3DSA:3.40.50.1100:FF:000270', NULL, NULL, 'Threonine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(89917, NULL, 'G3DSA:3.40.50.300:FF:000480', NULL, NULL, 'DExH-box ATP-dependent RNA helicase DExH3', NULL, NULL, NULL, NULL, NULL, 4),
(89918, NULL, 'G3DSA:2.130.10.10:FF:005937', NULL, NULL, 'Protein CBR-OSM-1', NULL, NULL, NULL, NULL, NULL, 4),
(89919, NULL, 'G3DSA:2.60.40.10:FF:002407', NULL, NULL, 'Interleukin 22 receptor subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(89920, NULL, 'G3DSA:2.60.40.60:FF:000163', NULL, NULL, 'Cadherin 17', NULL, NULL, NULL, NULL, NULL, 4),
(89921, NULL, 'G3DSA:3.30.830.10:FF:000095', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(89922, NULL, 'G3DSA:2.130.10.10:FF:001868', NULL, NULL, 'WD domain, G-beta repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(89923, NULL, 'G3DSA:3.40.50.720:FF:001179', NULL, NULL, 'Saccharopine dehydrogenase (putative)', NULL, NULL, NULL, NULL, NULL, 4),
(89924, NULL, 'G3DSA:2.130.10.10:FF:004509', NULL, NULL, 'Histone transcription regulator slm9', NULL, NULL, NULL, NULL, NULL, 4),
(89925, NULL, 'G3DSA:1.20.140.150:FF:000045', NULL, NULL, 'Clarin 1', NULL, NULL, NULL, NULL, NULL, 4),
(89926, NULL, 'G3DSA:1.10.10.1290:FF:000002', NULL, NULL, 'Testis intracellular mediator protein', NULL, NULL, NULL, NULL, NULL, 4),
(89927, NULL, 'G3DSA:3.10.110.10:FF:000016', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 H', NULL, NULL, NULL, NULL, NULL, 4),
(89928, NULL, 'G3DSA:3.60.40.10:FF:000157', NULL, NULL, 'Stage II sporulation protein E', NULL, NULL, NULL, NULL, NULL, 4),
(89929, NULL, 'G3DSA:2.60.40.1170:FF:000005', NULL, NULL, 'SH3-containing GRB2-like protein 3-interacting protein 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(89930, NULL, 'G3DSA:3.10.580.10:FF:000158', NULL, NULL, 'Magnesium and cobalt efflux protein', NULL, NULL, NULL, NULL, NULL, 4),
(89931, NULL, 'G3DSA:2.170.270.10:FF:000157', NULL, NULL, 'Protein CBG24432', NULL, NULL, NULL, NULL, NULL, 4),
(89932, NULL, 'G3DSA:4.10.90.10:FF:000002', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(89933, NULL, 'G3DSA:1.20.1740.10:FF:000147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89934, NULL, 'G3DSA:3.40.50.280:FF:000013', NULL, NULL, 'Radical SAM domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(89935, NULL, 'G3DSA:3.30.420.40:FF:000443', NULL, NULL, 'Polyphosphate glucokinase', NULL, NULL, NULL, NULL, NULL, 4),
(89936, NULL, 'G3DSA:3.40.50.2300:FF:001545', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89937, NULL, 'G3DSA:3.40.1190.10:FF:000008', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(89938, NULL, 'G3DSA:3.30.160.60:FF:004127', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89939, NULL, 'G3DSA:1.25.40.10:FF:004216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89940, NULL, 'G3DSA:3.30.40.10:FF:001243', NULL, NULL, 'Regulator Ustilago maydis 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(89941, NULL, 'G3DSA:3.10.360.10:FF:000001', NULL, NULL, 'Beta-defensin 1', NULL, NULL, NULL, NULL, NULL, 4),
(89942, NULL, 'G3DSA:3.40.50.1820:FF:001648', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89943, NULL, 'G3DSA:3.40.50.300:FF:008405', NULL, NULL, 'Si:ch211-229i14.2', NULL, NULL, NULL, NULL, NULL, 4),
(89944, NULL, 'G3DSA:3.40.1370.10:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89945, NULL, 'G3DSA:1.10.520.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89946, NULL, 'G3DSA:1.10.10.60:FF:000901', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89947, NULL, 'G3DSA:3.40.50.300:FF:005943', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89948, NULL, 'G3DSA:3.30.60.20:FF:000027', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(89949, NULL, 'G3DSA:3.30.720.120:FF:000001', NULL, NULL, 'Phenazine antibiotic resistance protein EhpR', NULL, NULL, NULL, NULL, NULL, 4),
(89950, NULL, 'G3DSA:2.10.220.10:FF:000057', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(89951, NULL, 'G3DSA:3.40.1110.10:FF:000234', NULL, NULL, 'Putative copper-transporting ATPase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(89952, NULL, 'G3DSA:2.60.40.10:FF:004178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89953, NULL, 'G3DSA:1.10.10.440:FF:000062', NULL, NULL, 'WW domain-containing protein ZK1098.1', NULL, NULL, NULL, NULL, NULL, 4),
(89954, NULL, 'G3DSA:3.30.70.260:FF:000154', NULL, NULL, 'GTP pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(89955, NULL, 'G3DSA:3.40.980.10:FF:000053', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(89956, NULL, 'G3DSA:2.130.10.10:FF:002065', NULL, NULL, 'Related to CAC2-component of the chromatin assembly complex', NULL, NULL, NULL, NULL, NULL, 4),
(89957, NULL, 'G3DSA:2.40.50.140:FF:000975', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89958, NULL, 'G3DSA:1.20.1270.280:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89959, NULL, 'G3DSA:2.70.40.10:FF:000001', NULL, NULL, 'dCTP deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(89960, NULL, 'G3DSA:2.40.100.10:FF:000075', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(89961, NULL, 'G3DSA:1.10.630.10:FF:000558', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89962, NULL, 'G3DSA:3.30.565.10:FF:000461', NULL, NULL, 'Sensor histidine kinase, copper metabolism, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89963, NULL, 'G3DSA:1.10.580.10:FF:000031', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(89964, NULL, 'G3DSA:3.40.50.1820:FF:001441', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(89965, NULL, 'G3DSA:3.30.1330.60:FF:000020', NULL, NULL, 'Outer membrane protein OmpA', NULL, NULL, NULL, NULL, NULL, 4),
(89966, NULL, 'G3DSA:3.30.2350.20:FF:000032', NULL, NULL, 'tRNA pseudouridine synthase D', NULL, NULL, NULL, NULL, NULL, 4),
(89967, NULL, 'G3DSA:3.30.160.60:FF:000384', NULL, NULL, 'Zinc finger protein 550', NULL, NULL, NULL, NULL, NULL, 4),
(89968, NULL, 'G3DSA:3.40.50.300:FF:000328', NULL, NULL, 'Septin spn3', NULL, NULL, NULL, NULL, NULL, 4),
(89969, NULL, 'G3DSA:3.65.10.20:FF:000007', NULL, NULL, 'RNA 3''-terminal phosphate cyclase-like protein,putative', NULL, NULL, NULL, NULL, NULL, 4),
(89970, NULL, 'G3DSA:3.30.160.60:FF:000204', NULL, NULL, 'Zinc finger protein 331', NULL, NULL, NULL, NULL, NULL, 4),
(89971, NULL, 'G3DSA:1.10.510.10:FF:000257', NULL, NULL, 'Calcium/calmodulin-dependent protein kinase type I', NULL, NULL, NULL, NULL, NULL, 4),
(89972, NULL, 'G3DSA:3.30.230.70:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89973, NULL, 'G3DSA:1.20.1600.10:FF:000019', NULL, NULL, 'Outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(89974, NULL, 'G3DSA:2.70.150.10:FF:000217', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(89975, NULL, 'G3DSA:1.25.40.820:FF:000020', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(89976, NULL, 'G3DSA:1.25.40.20:FF:000476', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89977, NULL, 'G3DSA:3.65.10.10:FF:000004', NULL, NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(89978, NULL, 'G3DSA:3.30.160.60:FF:003638', NULL, NULL, 'Transcriptional regulator TAC1', NULL, NULL, NULL, NULL, NULL, 4),
(89979, NULL, 'G3DSA:2.40.50.740:FF:000003', NULL, NULL, '30S ribosomal protein S4e', NULL, NULL, NULL, NULL, NULL, 4),
(89980, NULL, 'G3DSA:1.10.1450.10:FF:000060', NULL, NULL, 'Protein late bloomer', NULL, NULL, NULL, NULL, NULL, 4),
(89981, NULL, 'G3DSA:1.10.10.1890:FF:000002', NULL, NULL, 'Spindle and kinetochore-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(89982, NULL, 'G3DSA:3.40.50.10190:FF:000084', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(89983, NULL, 'G3DSA:3.30.160.60:FF:002536', NULL, NULL, 'zinc finger protein weckle-like', NULL, NULL, NULL, NULL, NULL, 4),
(89984, NULL, 'G3DSA:1.10.8.60:FF:000535', NULL, NULL, 'Peroxisome biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(89985, NULL, 'G3DSA:3.40.50.300:FF:002537', NULL, NULL, 'Exonuclease SbcC', NULL, NULL, NULL, NULL, NULL, 4),
(89986, NULL, 'G3DSA:3.20.20.190:FF:000018', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(89987, NULL, 'G3DSA:1.25.40.790:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89988, NULL, 'G3DSA:3.40.50.2300:FF:000410', NULL, NULL, 'Sensor histidine kinase/response regulator Fos-1', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(89989, NULL, 'G3DSA:1.25.40.10:FF:001575', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g51320', NULL, NULL, NULL, NULL, NULL, 4),
(89990, NULL, 'G3DSA:3.10.440.10:FF:000002', NULL, NULL, '60S ribosomal protein L31, putative', NULL, NULL, NULL, NULL, NULL, 4),
(89991, NULL, 'G3DSA:1.20.120.350:FF:000152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89992, NULL, 'G3DSA:3.60.10.10:FF:000329', NULL, NULL, 'Exodeoxyribonuclease III', NULL, NULL, NULL, NULL, NULL, 4),
(89993, NULL, 'G3DSA:3.30.1460.50:FF:000021', NULL, NULL, 'Ubiquitin-like-conjugating enzyme ATG10', NULL, NULL, NULL, NULL, NULL, 4),
(89994, NULL, 'G3DSA:3.90.1150.10:FF:000511', NULL, NULL, 'Selenocysteine lyase', NULL, NULL, NULL, NULL, NULL, 4),
(89995, NULL, 'G3DSA:3.80.10.10:FF:004499', NULL, NULL, 'Os06g0557700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(89996, NULL, 'G3DSA:3.40.1090.10:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89997, NULL, 'G3DSA:3.30.1540.20:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(89998, NULL, 'G3DSA:6.10.140.2220:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(89999, NULL, 'G3DSA:3.30.540.10:FF:000022', NULL, NULL, 'Putative PAP-specific phosphatase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(90000, NULL, 'G3DSA:3.90.226.10:FF:000183', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(90001, NULL, 'G3DSA:3.80.10.10:FF:000519', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3', NULL, NULL, NULL, NULL, NULL, 4),
(90002, NULL, 'G3DSA:3.40.1620.80:FF:000001', NULL, NULL, 'Big defensin', NULL, NULL, NULL, NULL, NULL, 4),
(90003, NULL, 'G3DSA:3.40.50.300:FF:001789', NULL, NULL, 'TFIIH basal transcription factor complex helicase XPD subunit', NULL, NULL, NULL, NULL, NULL, 4),
(90004, NULL, 'G3DSA:2.130.10.10:FF:000912', NULL, NULL, 'Ribosome biogenesis protein BOP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(90005, NULL, 'G3DSA:1.25.40.10:FF:003727', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90006, NULL, 'G3DSA:1.20.1310.10:FF:000070', NULL, NULL, 'CBN-CUL-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(90007, NULL, 'G3DSA:2.60.40.2130:FF:000012', NULL, NULL, 'F-spondin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90008, NULL, 'G3DSA:3.90.1180.10:FF:000013', NULL, NULL, 'Mitochondrial ribosomal protein L13', NULL, NULL, NULL, NULL, NULL, 4),
(90009, NULL, 'G3DSA:1.10.238.10:FF:000157', NULL, NULL, 'ATP/GTP-binding protein family', NULL, NULL, NULL, NULL, NULL, 4),
(90010, NULL, 'G3DSA:1.20.1690.10:FF:000002', NULL, NULL, 'V-type proton ATPase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(90011, NULL, 'G3DSA:2.60.40.3690:FF:000002', NULL, NULL, 'Minor fimbrium subunit Mfa1', NULL, NULL, NULL, NULL, NULL, 4),
(90012, NULL, 'G3DSA:3.90.740.10:FF:000046', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(90013, NULL, 'G3DSA:3.40.50.300:FF:003791', NULL, NULL, 'Protein CBG19372', NULL, NULL, NULL, NULL, NULL, 4),
(90014, NULL, 'G3DSA:3.40.50.300:FF:006432', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90015, NULL, 'G3DSA:1.20.1250.20:FF:001411', NULL, NULL, 'Proline/betaine transporter', NULL, NULL, NULL, NULL, NULL, 4),
(90016, NULL, 'G3DSA:3.20.20.80:FF:000779', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90017, NULL, 'G3DSA:2.30.30.30:FF:000008', NULL, NULL, '50S ribosomal protein L2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(90018, NULL, 'G3DSA:3.30.260.10:FF:000101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90019, NULL, 'G3DSA:1.20.120.720:FF:000021', NULL, NULL, 'Unconventional myosin-Va', NULL, NULL, NULL, NULL, NULL, 4),
(90020, NULL, 'G3DSA:1.10.287.3810:FF:000001', NULL, NULL, 'Tryptophan 2,3-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(90021, NULL, 'G3DSA:3.80.10.10:FF:001008', NULL, NULL, 'F-box/LRR-repeat protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(90022, NULL, 'G3DSA:3.10.310.20:FF:000001', NULL, NULL, 'Probable manganese-dependent inorganic pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(90023, NULL, 'G3DSA:1.10.533.10:FF:000208', NULL, NULL, 'CARD- and ANK-containing Inflammasome Adaptor Protein', NULL, NULL, NULL, NULL, NULL, 4),
(90024, NULL, 'G3DSA:3.10.310.30:FF:000004', NULL, NULL, 'Single-stranded-DNA-specific exonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(90025, NULL, 'G3DSA:2.40.70.10:FF:000100', NULL, NULL, 'Cathepsin E-like protease', NULL, NULL, NULL, NULL, NULL, 4),
(90026, NULL, 'G3DSA:1.10.472.130:FF:000061', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(90027, NULL, 'G3DSA:1.10.1070.11:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90028, NULL, 'G3DSA:2.30.30.380:FF:000034', NULL, NULL, 'SHANK-associated RH domain interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(90029, NULL, 'G3DSA:3.90.1410.10:FF:000138', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(90030, NULL, 'G3DSA:3.60.21.10:FF:000118', NULL, NULL, 'Calcineurin-like phosphoesterase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(90031, NULL, 'G3DSA:3.30.70.330:FF:001804', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90032, NULL, 'G3DSA:1.20.5.110:FF:000137', NULL, NULL, 'Qc-SNARE protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90033, NULL, 'G3DSA:3.40.50.720:FF:001590', NULL, NULL, 'Bifunctional sterol desaturase/short chaindehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(90034, NULL, 'G3DSA:1.20.120.730:FF:000024', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(90035, NULL, 'G3DSA:1.10.10.1340:FF:000006', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 31', NULL, NULL, NULL, NULL, NULL, 4),
(90036, NULL, 'G3DSA:3.20.20.70:FF:000776', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90037, NULL, 'G3DSA:3.30.160.60:FF:004745', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90038, NULL, 'G3DSA:1.25.40.10:FF:002007', NULL, NULL, 'Os03g0314400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(90039, NULL, 'G3DSA:1.10.357.70:FF:000024', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(90040, NULL, 'G3DSA:2.130.10.10:FF:002391', NULL, NULL, 'Striatin Pro11', NULL, NULL, NULL, NULL, NULL, 4),
(90041, NULL, 'G3DSA:1.10.472.10:FF:000246', NULL, NULL, 'Mitotic cyclin 6', NULL, NULL, NULL, NULL, NULL, 4),
(90042, NULL, 'G3DSA:3.30.70.330:FF:000141', NULL, NULL, 'Splicing factor 3b subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(90043, NULL, 'G3DSA:2.60.40.10:FF:001862', NULL, NULL, 'C3 and PZP like, alpha-2-macroglobulin domain containing 8', NULL, NULL, NULL, NULL, NULL, 4),
(90044, NULL, 'G3DSA:2.60.40.640:FF:000045', NULL, NULL, 'Vacuolar sorting protein 26, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90045, NULL, 'G3DSA:2.40.50.150:FF:000006', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(90046, NULL, 'G3DSA:3.30.740.10:FF:000003', NULL, NULL, 'Dynein light chain', NULL, NULL, NULL, NULL, NULL, 4),
(90047, NULL, 'G3DSA:2.60.40.1910:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90048, NULL, 'G3DSA:1.25.40.20:FF:001201', NULL, NULL, 'CARD- and ANK-containing Inflammasome Adaptor Protein', NULL, NULL, NULL, NULL, NULL, 4),
(90049, NULL, 'G3DSA:2.30.110.10:FF:000038', NULL, NULL, 'PPOX class F420-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(90050, NULL, 'G3DSA:1.10.510.10:FF:004034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90051, NULL, 'G3DSA:1.10.3260.10:FF:000017', NULL, NULL, 'DNA ligase 4', NULL, NULL, NULL, NULL, NULL, 4),
(90052, NULL, 'G3DSA:1.10.565.10:FF:000198', NULL, NULL, 'Androgen receptor a', NULL, NULL, NULL, NULL, NULL, 4),
(90053, NULL, 'G3DSA:2.60.120.10:FF:000622', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90054, NULL, 'G3DSA:3.40.50.970:FF:000006', NULL, NULL, 'Pyruvate dehydrogenase E1 component subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(90055, NULL, 'G3DSA:3.40.449.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90056, NULL, 'G3DSA:2.40.70.10:FF:000280', NULL, NULL, 'Aspartic peptidase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(90057, NULL, 'G3DSA:3.40.50.300:FF:006106', NULL, NULL, 'Uridine-cytidine kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(90058, NULL, 'G3DSA:3.40.50.1820:FF:001148', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(90059, NULL, 'G3DSA:3.30.930.10:FF:000187', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(90060, NULL, 'G3DSA:1.25.40.10:FF:004424', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90061, NULL, 'G3DSA:2.170.16.10:FF:000042', NULL, NULL, 'Replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(90062, NULL, 'G3DSA:1.20.1250.20:FF:001383', NULL, NULL, 'Major facilitator superfamily MFS_1', NULL, NULL, NULL, NULL, NULL, 4),
(90063, NULL, 'G3DSA:3.30.420.40:FF:000117', NULL, NULL, 'Heat shock protein 70 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(90064, NULL, 'G3DSA:4.10.410.10:FF:000047', NULL, NULL, 'Protein CBG06419', NULL, NULL, NULL, NULL, NULL, 4),
(90065, NULL, 'G3DSA:2.130.10.10:FF:001929', NULL, NULL, 'Protein GAMETE EXPRESSED 3', NULL, NULL, NULL, NULL, NULL, 4),
(90066, NULL, 'G3DSA:3.40.50.960:FF:000003', NULL, NULL, '6,7-dimethyl-8-ribityllumazine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(90067, NULL, 'G3DSA:1.10.1450.10:FF:000026', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(90068, NULL, 'G3DSA:3.50.50.100:FF:000013', NULL, NULL, 'Type II NADH:ubiquinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(90069, NULL, 'G3DSA:2.60.40.60:FF:000724', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90070, NULL, 'G3DSA:1.10.287.110:FF:000183', NULL, NULL, 'Protein CBR-DNJ-24', NULL, NULL, NULL, NULL, NULL, 4),
(90071, NULL, 'G3DSA:3.40.190.290:FF:000091', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(90072, NULL, 'G3DSA:1.25.40.10:FF:003761', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90073, NULL, 'G3DSA:2.60.40.10:FF:003953', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90074, NULL, 'G3DSA:3.30.160.60:FF:004627', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90075, NULL, 'G3DSA:1.10.510.10:FF:002382', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90076, NULL, 'G3DSA:2.40.320.10:FF:000001', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 18', NULL, NULL, NULL, NULL, NULL, 4),
(90077, NULL, 'G3DSA:3.90.70.80:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90078, NULL, 'G3DSA:2.60.40.1080:FF:000012', NULL, NULL, 'S-layer protein A', NULL, NULL, NULL, NULL, NULL, 4),
(90079, NULL, 'G3DSA:1.20.5.730:FF:000002', NULL, NULL, 'Rabaptin, RAB GTPase-binding effector protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(90080, NULL, 'G3DSA:4.10.400.10:FF:000018', NULL, NULL, 'Low-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(90081, NULL, 'G3DSA:1.10.1200.10:FF:000160', NULL, NULL, 'Siderophore peptide synthetase fer3', NULL, NULL, NULL, NULL, NULL, 4),
(90082, NULL, 'G3DSA:3.30.420.10:FF:000693', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90083, NULL, 'G3DSA:1.10.287.130:FF:000189', NULL, NULL, 'Sensory box sensor histidine kinase/response regulator VieS', NULL, NULL, NULL, NULL, NULL, 4),
(90084, NULL, 'G3DSA:2.40.30.10:FF:000272', NULL, NULL, 'Sulfite reductase [NADPH] flavoprotein alpha-component', NULL, NULL, NULL, NULL, NULL, 4),
(90085, NULL, 'G3DSA:2.60.40.1180:FF:000160', NULL, NULL, 'Solute carrier family 3 member 2b', NULL, NULL, NULL, NULL, NULL, 4),
(90086, NULL, 'G3DSA:3.30.70.330:FF:001243', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(90087, NULL, 'G3DSA:4.10.320.10:FF:000017', NULL, NULL, 'Pyruvate dehydrogenase complex protein X component, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(90088, NULL, 'G3DSA:2.30.29.110:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90089, NULL, 'G3DSA:1.10.510.10:FF:000291', NULL, NULL, 'Brassinosteroid LRR receptor kinase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(90090, NULL, 'G3DSA:3.30.565.10:FF:000253', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(90091, NULL, 'G3DSA:1.10.10.10:FF:001954', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90092, NULL, 'G3DSA:3.80.10.10:FF:003133', NULL, NULL, 'leucine-rich repeat-containing protein 59-like', NULL, NULL, NULL, NULL, NULL, 4),
(90093, NULL, 'G3DSA:2.40.30.10:FF:000215', NULL, NULL, 'NADPH--cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(90094, NULL, 'G3DSA:1.10.510.10:FF:000403', NULL, NULL, 'serine/threonine-protein kinase PLK4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(90095, NULL, 'G3DSA:2.30.30.40:FF:000371', NULL, NULL, 'Protein arginine methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(90096, NULL, 'G3DSA:2.60.40.150:FF:000724', NULL, NULL, 'Putative calpain-like cysteine protease A', NULL, NULL, NULL, NULL, NULL, 4),
(90097, NULL, 'G3DSA:2.30.22.10:FF:000012', NULL, NULL, 'GrpE, adenine nucleotide exchange factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90098, NULL, 'G3DSA:3.30.160.60:FF:000412', NULL, NULL, 'zinc finger protein 64 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(90099, NULL, 'G3DSA:1.25.40.10:FF:000473', NULL, NULL, 'Os03g0185200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(90100, NULL, 'G3DSA:1.20.1250.20:FF:000394', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(90101, NULL, 'G3DSA:2.20.25.10:FF:000075', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(90102, NULL, 'G3DSA:3.30.160.60:FF:002328', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90103, NULL, 'G3DSA:2.130.10.10:FF:001986', NULL, NULL, 'Protein CBG20127', NULL, NULL, NULL, NULL, NULL, 4),
(90104, NULL, 'G3DSA:3.90.228.10:FF:000047', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(90105, NULL, 'G3DSA:1.20.1110.10:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90106, NULL, 'G3DSA:2.60.40.10:FF:002525', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90107, NULL, 'G3DSA:3.90.79.10:FF:000115', NULL, NULL, 'NUDIX domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(90108, NULL, 'G3DSA:1.10.418.10:FF:000104', NULL, NULL, 'Filamin 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90109, NULL, 'G3DSA:2.30.29.30:FF:000674', NULL, NULL, 'Serine/threonine protein kinase 3/4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90110, NULL, 'G3DSA:2.60.175.10:FF:000001', NULL, NULL, 'Major capsid protein VP1', NULL, NULL, NULL, NULL, NULL, 4),
(90111, NULL, 'G3DSA:3.30.870.10:FF:000041', NULL, NULL, 'Envelope phospholipase F13', NULL, NULL, NULL, NULL, NULL, 4),
(90112, NULL, 'G3DSA:1.20.1480.30:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90113, NULL, 'G3DSA:3.40.50.1240:FF:000053', NULL, NULL, 'Histidine acid phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90114, NULL, 'G3DSA:3.40.190.10:FF:000897', NULL, NULL, 'Glutamate receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90115, NULL, 'G3DSA:1.20.1390.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90116, NULL, 'G3DSA:3.40.50.150:FF:000148', NULL, NULL, 'Probable methyltransferase PMT25', NULL, NULL, NULL, NULL, NULL, 4),
(90117, NULL, 'G3DSA:1.10.8.270:FF:000013', NULL, NULL, 'Small G protein signaling modulator 3', NULL, NULL, NULL, NULL, NULL, 4),
(90118, NULL, 'G3DSA:2.10.70.10:FF:000017', NULL, NULL, 'Fibronectin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(90119, NULL, 'G3DSA:3.30.830.10:FF:000241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90120, NULL, 'G3DSA:3.90.70.10:FF:000152', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(90121, NULL, 'G3DSA:3.40.50.300:FF:004780', NULL, NULL, 'DNA polymerase III subunit', NULL, NULL, NULL, NULL, NULL, 4),
(90122, NULL, 'G3DSA:3.30.450.40:FF:000153', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(90123, NULL, 'G3DSA:1.25.40.10:FF:005318', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90124, NULL, 'G3DSA:3.40.1810.10:FF:000063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90125, NULL, 'G3DSA:3.40.190.10:FF:000520', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90126, NULL, 'G3DSA:2.30.29.30:FF:001337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90127, NULL, 'G3DSA:1.10.238.10:FF:000803', NULL, NULL, 'Defective in cullin neddylation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(90128, NULL, 'G3DSA:3.40.30.10:FF:000466', NULL, NULL, 'Iodothyronine deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(90129, NULL, 'G3DSA:2.40.50.140:FF:000003', NULL, NULL, '50S ribosomal protein L2', NULL, NULL, NULL, NULL, NULL, 4),
(90130, NULL, 'G3DSA:1.10.10.2360:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90131, NULL, 'G3DSA:2.60.120.290:FF:000197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90132, NULL, 'G3DSA:1.10.30.50:FF:000017', NULL, NULL, 'Putative SNF2/RAD54 related DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(90133, NULL, 'G3DSA:2.10.25.10:FF:001110', NULL, NULL, 'fibropellin-1-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(90134, NULL, 'G3DSA:2.30.42.10:FF:000221', NULL, NULL, 'Tricorn protease homolog', NULL, NULL, NULL, NULL, NULL, 4),
(90135, NULL, 'G3DSA:1.50.40.10:FF:000437', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90136, NULL, 'G3DSA:1.20.58.80:FF:000067', NULL, NULL, 'Sorting nexin 15', NULL, NULL, NULL, NULL, NULL, 4),
(90137, NULL, 'G3DSA:2.130.10.10:FF:002503', NULL, NULL, 'RE12436p1', NULL, NULL, NULL, NULL, NULL, 4),
(90138, NULL, 'G3DSA:1.10.1420.10:FF:000086', NULL, NULL, 'DNA mismatch repair protein Msh4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90139, NULL, 'G3DSA:3.30.40.10:FF:001209', NULL, NULL, 'DWNN domain, a CCHC-type zinc finger', NULL, NULL, NULL, NULL, NULL, 4),
(90140, NULL, 'G3DSA:1.25.40.20:FF:000212', NULL, NULL, 'Protein phosphatase 1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(90141, NULL, 'G3DSA:3.40.50.1820:FF:001356', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90142, NULL, 'G3DSA:1.20.1070.10:FF:001017', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(90143, NULL, 'G3DSA:3.30.379.10:FF:000011', NULL, NULL, 'Beta-hexosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(90144, NULL, 'G3DSA:1.25.40.10:FF:002390', NULL, NULL, 'HCF152', NULL, NULL, NULL, NULL, NULL, 4),
(90145, NULL, 'G3DSA:1.50.10.10:FF:000082', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(90146, NULL, 'G3DSA:1.25.40.10:FF:001928', NULL, NULL, 'Os06g0231400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(90147, NULL, 'G3DSA:1.10.490.10:FF:000001', NULL, NULL, 'Hemoglobin subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(90148, NULL, 'G3DSA:2.60.40.10:FF:005398', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90149, NULL, 'G3DSA:2.40.50.1060:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90150, NULL, 'G3DSA:3.30.160.60:FF:002121', NULL, NULL, 'zinc finger protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(90151, NULL, 'G3DSA:3.30.1360.200:FF:000014', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(90152, NULL, 'G3DSA:3.30.70.3100:FF:000001', NULL, NULL, 'Homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(90153, NULL, 'G3DSA:3.40.50.300:FF:007949', NULL, NULL, 'Rab family protein', NULL, NULL, NULL, NULL, NULL, 4),
(90154, NULL, 'G3DSA:3.30.160.60:FF:004419', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90155, NULL, 'G3DSA:3.40.850.10:FF:000487', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90156, NULL, 'G3DSA:3.30.160.60:FF:000619', NULL, NULL, 'juxtaposed with another zinc finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(90157, NULL, 'G3DSA:3.40.50.300:FF:000980', NULL, NULL, 'Cysteine/glutathione ABC transporter permease/ATP-binding protein CydD', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(90158, NULL, 'G3DSA:2.60.40.10:FF:002172', NULL, NULL, 'Myomesin 1a (skelemin)', NULL, NULL, NULL, NULL, NULL, 4),
(90159, NULL, 'G3DSA:3.40.630.150:FF:000009', NULL, NULL, 'Malonyl-CoA decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(90160, NULL, 'G3DSA:2.60.40.10:FF:000434', NULL, NULL, 'Sidekick cell adhesion molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(90161, NULL, 'G3DSA:1.10.510.10:FF:003629', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90162, NULL, 'G3DSA:2.60.40.150:FF:000078', NULL, NULL, 'Extended synaptotagmin 2', NULL, NULL, NULL, NULL, NULL, 4),
(90163, NULL, 'G3DSA:3.40.50.10470:FF:000044', NULL, NULL, 'Methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(90164, NULL, 'G3DSA:1.10.10.60:FF:000547', NULL, NULL, 'transcription factor AS1-like', NULL, NULL, NULL, NULL, NULL, 4),
(90165, NULL, 'G3DSA:1.20.59.20:FF:000001', NULL, NULL, 'tRNA(Ile)-lysidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(90166, NULL, 'G3DSA:3.90.550.10:FF:000155', NULL, NULL, 'Polysaccharide metabolism', NULL, NULL, NULL, NULL, NULL, 4),
(90167, NULL, 'G3DSA:3.40.50.1010:FF:000158', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90168, NULL, 'G3DSA:1.25.40.10:FF:004071', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g20710, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(90169, NULL, 'G3DSA:3.40.50.880:FF:000013', NULL, NULL, 'GMP synthase [glutamine-hydrolyzing]', NULL, NULL, NULL, NULL, NULL, 4),
(90170, NULL, 'G3DSA:1.10.510.10:FF:000083', NULL, NULL, 'Ephrin type-A receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(90171, NULL, 'G3DSA:3.30.200.20:FF:001848', NULL, NULL, 'Os10g0562500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(90172, NULL, 'G3DSA:3.30.1370.210:FF:000019', NULL, NULL, 'Zinc finger CCCH-type containing 10', NULL, NULL, NULL, NULL, NULL, 4),
(90173, NULL, 'G3DSA:1.10.10.10:FF:000055', NULL, NULL, 'ETS translocation variant 4 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(90174, NULL, 'G3DSA:3.40.630.30:FF:000662', NULL, NULL, 'Glucosamine 6-phosphate N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(90175, NULL, 'G3DSA:3.10.20.90:FF:000423', NULL, NULL, 'Guanine nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(90176, NULL, 'G3DSA:3.90.700.10:FF:000015', NULL, NULL, '3-oxosteroid 1-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(90177, NULL, 'G3DSA:3.40.50.1000:FF:000155', NULL, NULL, 'Putative magnesium dependent phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(90178, NULL, 'G3DSA:2.10.25.10:FF:001317', NULL, NULL, 'Matrilin 4', NULL, NULL, NULL, NULL, NULL, 4),
(90179, NULL, 'G3DSA:1.20.140.40:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90180, NULL, 'G3DSA:3.30.160.60:FF:005347', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90181, NULL, 'G3DSA:3.40.630.30:FF:000454', NULL, NULL, 'N-acetyltransferase 6', NULL, NULL, NULL, NULL, NULL, 4),
(90182, NULL, 'G3DSA:2.60.120.10:FF:000768', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90183, NULL, 'G3DSA:2.40.50.1070:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90184, NULL, 'G3DSA:3.90.1600.10:FF:000029', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(90185, NULL, 'G3DSA:3.40.50.10130:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90186, NULL, 'G3DSA:3.50.14.10:FF:000001', NULL, NULL, 'DNA replication terminus site-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(90187, NULL, 'G3DSA:3.30.1370.110:FF:000023', NULL, NULL, 'Endonuclease MutS2', NULL, NULL, NULL, NULL, NULL, 4),
(90188, NULL, 'G3DSA:1.20.58.60:FF:000882', NULL, NULL, 'Kalirin RhoGEF kinase a', NULL, NULL, NULL, NULL, NULL, 4),
(90189, NULL, 'G3DSA:3.40.30.10:FF:000056', NULL, NULL, 'Thiol peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(90190, NULL, 'G3DSA:3.30.160.60:FF:000530', NULL, NULL, 'zinc finger protein 775', NULL, NULL, NULL, NULL, NULL, 4),
(90191, NULL, 'G3DSA:3.10.105.10:FF:000066', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(90192, NULL, 'G3DSA:2.80.10.50:FF:000084', NULL, NULL, 'Uncharacterized protein Mb1454', NULL, NULL, NULL, NULL, NULL, 4),
(90193, NULL, 'G3DSA:3.40.50.300:FF:002363', NULL, NULL, 'Spliceosome RNA helicase DDX39B', NULL, NULL, NULL, NULL, NULL, 4),
(90194, NULL, 'G3DSA:3.30.559.30:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90195, NULL, 'G3DSA:3.40.50.300:FF:007860', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90196, NULL, 'G3DSA:3.10.20.90:FF:000631', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(90197, NULL, 'G3DSA:1.10.3430.10:FF:000025', NULL, NULL, 'Ammonium transporter, splicing variant', NULL, NULL, NULL, NULL, NULL, 4),
(90198, NULL, 'G3DSA:1.10.4200.10:FF:000008', NULL, NULL, 'CITG protein', NULL, NULL, NULL, NULL, NULL, 4),
(90199, NULL, 'G3DSA:3.20.20.80:FF:000487', NULL, NULL, 'Glucosylceramidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90200, NULL, 'G3DSA:3.40.50.1820:FF:000013', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(90201, NULL, 'G3DSA:4.10.1240.10:FF:000019', NULL, NULL, 'Gastric inhibitory polypeptide receptor', NULL, NULL, NULL, NULL, NULL, 4),
(90202, NULL, 'G3DSA:3.40.50.200:FF:000124', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(90203, NULL, 'G3DSA:1.10.10.540:FF:000002', NULL, NULL, 'UV excision repair protein Rad23', NULL, NULL, NULL, NULL, NULL, 4),
(90204, NULL, 'G3DSA:1.20.930.40:FF:000008', NULL, NULL, 'Tre1p', NULL, NULL, NULL, NULL, NULL, 4),
(90205, NULL, 'G3DSA:2.40.50.140:FF:001138', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90206, NULL, 'G3DSA:1.10.10.10:FF:002000', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90207, NULL, 'G3DSA:2.60.40.10:FF:003189', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90208, NULL, 'G3DSA:3.90.70.10:FF:000360', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90209, NULL, 'G3DSA:1.20.1250.20:FF:001326', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90210, NULL, 'G3DSA:3.30.200.20:FF:000859', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(90211, NULL, 'G3DSA:2.60.40.10:FF:002733', NULL, NULL, 'Natural cytotoxicity triggering receptor 3 ligand 1', NULL, NULL, NULL, NULL, NULL, 4),
(90212, NULL, 'G3DSA:2.70.130.10:FF:000160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90213, NULL, 'G3DSA:3.30.40.10:FF:002024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90214, NULL, 'G3DSA:3.20.20.70:FF:000484', NULL, NULL, 'Homocitrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(90215, NULL, 'G3DSA:3.40.50.300:FF:007742', NULL, NULL, 'RAB34, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(90216, NULL, 'G3DSA:2.60.120.200:FF:000597', NULL, NULL, 'Cadherin, EGF LAG seven-pass G-type receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(90217, NULL, 'G3DSA:2.170.270.10:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90218, NULL, 'G3DSA:3.40.30.10:FF:000674', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(90219, NULL, 'G3DSA:3.40.50.300:FF:005797', NULL, NULL, 'Katanin p60 ATPase-containing subunit A1', NULL, NULL, NULL, NULL, NULL, 4),
(90220, NULL, 'G3DSA:2.40.160.120:FF:000029', NULL, NULL, 'Oxysterol binding protein 5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90221, NULL, 'G3DSA:3.30.160.60:FF:003964', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90222, NULL, 'G3DSA:3.30.70.1230:FF:000176', NULL, NULL, 'Adenylate/guanylate cyclase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(90223, NULL, 'G3DSA:1.20.120.350:FF:000067', NULL, NULL, 'Transmembrane phosphatase with tensin homology', NULL, NULL, NULL, NULL, NULL, 4),
(90224, NULL, 'G3DSA:3.30.342.10:FF:000056', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(90225, NULL, 'G3DSA:4.10.280.10:FF:000047', NULL, NULL, 'mesoderm posterior protein 1', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(90226, NULL, 'G3DSA:3.50.50.60:FF:001460', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90227, NULL, 'G3DSA:3.40.50.200:FF:000181', NULL, NULL, 'Subtilisin-like serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(90228, NULL, 'G3DSA:2.40.10.230:FF:000011', NULL, NULL, 'H/ACA ribonucleoprotein complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(90229, NULL, 'G3DSA:2.40.10.10:FF:000271', NULL, NULL, 'AT07689p', NULL, NULL, NULL, NULL, NULL, 4),
(90230, NULL, 'G3DSA:3.30.390.50:FF:000010', NULL, NULL, 'Lipoate--protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(90231, NULL, 'G3DSA:3.40.50.740:FF:000022', NULL, NULL, 'Anaerobic dimethyl sulfoxide reductase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(90232, NULL, 'G3DSA:3.40.50.720:FF:000628', NULL, NULL, 'Oxidoreductase family, NAD-binding Rossmann fold protein', NULL, NULL, NULL, NULL, NULL, 4),
(90233, NULL, 'G3DSA:1.25.10.10:FF:000645', NULL, NULL, 'HEAT repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(90234, NULL, 'G3DSA:3.30.40.10:FF:001097', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(90235, NULL, 'G3DSA:3.30.40.10:FF:001417', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(90236, NULL, 'G3DSA:3.30.1370.100:FF:000020', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(90237, NULL, 'G3DSA:3.40.50.620:FF:000896', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90238, NULL, 'G3DSA:3.40.50.980:FF:000009', NULL, NULL, 'Blast:Luciferin 4-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(90239, NULL, 'G3DSA:2.40.160.110:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90240, NULL, 'G3DSA:1.50.40.10:FF:000229', NULL, NULL, 'Mitochondrial arginine transporter BAC1 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(90241, NULL, 'G3DSA:4.10.1110.10:FF:000015', NULL, NULL, 'Zinc finger, AN1-type domain 6', NULL, NULL, NULL, NULL, NULL, 4),
(90242, NULL, 'G3DSA:3.30.390.60:FF:000013', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(90243, NULL, 'G3DSA:3.90.1290.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90244, NULL, 'G3DSA:1.20.58.830:FF:000032', NULL, NULL, 'Erythrocyte membrane protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(90245, NULL, 'G3DSA:2.60.40.1820:FF:000009', NULL, NULL, 'Late embryogenesis abundant (LEA) hydroxyproline-rich glycoprotein family', NULL, NULL, NULL, NULL, NULL, 4),
(90246, NULL, 'G3DSA:1.20.1300.10:FF:000041', NULL, NULL, 'Succinate dehydrogenase subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(90247, NULL, 'G3DSA:2.60.40.10:FF:000934', NULL, NULL, 'vascular endothelial growth factor receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(90248, NULL, 'G3DSA:1.25.10.10:FF:000235', NULL, NULL, 'MAP3K epsilon protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(90249, NULL, 'G3DSA:1.10.10.440:FF:000028', NULL, NULL, 'Pre-mRNA-processing protein 40C', NULL, NULL, NULL, NULL, NULL, 4),
(90250, NULL, 'G3DSA:3.30.60.30:FF:000238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90251, NULL, 'G3DSA:1.10.20.10:FF:000292', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90252, NULL, 'G3DSA:4.10.60.10:FF:000113', NULL, NULL, 'Cleavage and Polyadenylation Specificity Factor', NULL, NULL, NULL, NULL, NULL, 4),
(90253, NULL, 'G3DSA:2.170.130.20:FF:000004', NULL, NULL, 'Multidomain scavenger receptor', NULL, NULL, NULL, NULL, NULL, 4),
(90254, NULL, 'G3DSA:3.30.505.10:FF:000070', NULL, NULL, 'GRB2-related adapter protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(90255, NULL, 'G3DSA:1.10.630.10:FF:000822', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90256, NULL, 'G3DSA:2.60.40.2880:FF:000001', NULL, NULL, 'Conserved membrane protein MmpS3', NULL, NULL, NULL, NULL, NULL, 4),
(90257, NULL, 'G3DSA:3.90.480.20:FF:000012', NULL, NULL, 'Sulfite reductase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(90258, NULL, 'G3DSA:3.40.50.2000:FF:001074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(90259, NULL, 'G3DSA:2.60.40.1180:FF:000042', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(90260, NULL, 'G3DSA:3.40.50.300:FF:006371', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90261, NULL, 'G3DSA:3.10.110.10:FF:000308', NULL, NULL, 'Si:ch1073-205c8.3', NULL, NULL, NULL, NULL, NULL, 4),
(90262, NULL, 'G3DSA:3.40.50.300:FF:000772', NULL, NULL, 'ATP-dependent DNA helicase Q4', NULL, NULL, NULL, NULL, NULL, 4),
(90263, NULL, 'G3DSA:3.30.160.60:FF:000176', NULL, NULL, 'zinc finger protein 70', NULL, NULL, NULL, NULL, NULL, 4),
(90264, NULL, 'G3DSA:3.40.50.40:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90265, NULL, 'G3DSA:3.90.226.10:FF:000211', NULL, NULL, 'AUH protein', NULL, NULL, NULL, NULL, NULL, 4),
(90266, NULL, 'G3DSA:3.40.50.450:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90267, NULL, 'G3DSA:3.30.160.60:FF:002621', NULL, NULL, 'zinc finger protein 566 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(90268, NULL, 'G3DSA:2.40.10.310:FF:000001', NULL, NULL, 'NSA2, ribosome biogenesis homolog', NULL, NULL, NULL, NULL, NULL, 4),
(90269, NULL, 'G3DSA:3.80.10.10:FF:002936', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(90270, NULL, 'G3DSA:3.20.20.140:FF:000144', NULL, NULL, 'Dipeptidase gliJ', NULL, NULL, NULL, NULL, NULL, 4),
(90271, NULL, 'G3DSA:2.170.130.10:FF:000001', NULL, NULL, 'Catecholate siderophore TonB-dependent receptor', NULL, NULL, NULL, NULL, NULL, 4),
(90272, NULL, 'G3DSA:3.30.1330.30:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90273, NULL, 'G3DSA:1.10.510.10:FF:003837', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90274, NULL, 'G3DSA:2.60.40.10:FF:005959', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90275, NULL, 'G3DSA:1.10.287.410:FF:000003', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(90276, NULL, 'G3DSA:1.25.10.10:FF:003372', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90277, NULL, 'G3DSA:3.40.50.150:FF:000912', NULL, NULL, 'Putative uncharacterized protein DDB_G0293380', NULL, NULL, NULL, NULL, NULL, 4),
(90278, NULL, 'G3DSA:1.10.630.10:FF:000619', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90279, NULL, 'G3DSA:1.20.58.60:FF:000674', NULL, NULL, 'Nesprin-1', NULL, NULL, NULL, NULL, NULL, 4),
(90280, NULL, 'G3DSA:2.40.10.10:FF:000624', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90281, NULL, 'G3DSA:1.10.238.10:FF:000096', NULL, NULL, 'CDPK-related kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(90282, NULL, 'G3DSA:2.60.260.20:FF:000135', NULL, NULL, 'Chloroplast DnaJ-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(90283, NULL, 'G3DSA:3.30.160.60:FF:005555', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90284, NULL, 'G3DSA:3.30.930.10:FF:000248', NULL, NULL, 'Ferredoxin-fold anticodon-binding domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(90285, NULL, 'G3DSA:3.90.440.10:FF:000001', NULL, NULL, 'Endothelial nitric oxide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(90286, NULL, 'G3DSA:2.60.11.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90287, NULL, 'G3DSA:3.30.200.20:FF:001882', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(90288, NULL, 'G3DSA:1.10.238.10:FF:000450', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(90289, NULL, 'G3DSA:1.10.565.10:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90290, NULL, 'G3DSA:3.40.50.2300:FF:001192', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90291, NULL, 'G3DSA:1.10.238.10:FF:000039', NULL, NULL, 'RalBP1-associated Eps domain-containing protein 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(90292, NULL, 'G3DSA:3.30.1540.10:FF:000004', NULL, NULL, 'Probable alpha-methylacyl-CoA racemase mcr', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(90293, NULL, 'G3DSA:1.10.555.10:FF:000164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90294, NULL, 'G3DSA:1.25.40.20:FF:000330', NULL, NULL, 'Ankyrin repeat domain 28, isoform CRA_c', NULL, NULL, NULL, NULL, NULL, 4),
(90295, NULL, 'G3DSA:3.40.640.10:FF:000123', NULL, NULL, 'DegT/DnrJ/EryC1/StrS family aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(90296, NULL, 'G3DSA:1.20.1250.20:FF:001118', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(90297, NULL, 'G3DSA:1.10.8.60:FF:000417', NULL, NULL, 'Putative replication factor c subunit rfc1 large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(90298, NULL, 'G3DSA:4.10.1240.10:FF:000053', NULL, NULL, 'PDF receptor-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(90299, NULL, 'G3DSA:2.40.10.10:FF:000006', NULL, NULL, 'Serine proteinase stubble', NULL, NULL, NULL, NULL, NULL, 4),
(90300, NULL, 'G3DSA:3.30.1540.20:FF:000007', NULL, NULL, 'DNA mismatch repair protein PMS1', NULL, NULL, NULL, NULL, NULL, 4),
(90301, NULL, 'G3DSA:3.80.10.10:FF:003251', NULL, NULL, 'Toll-like receptor 5', NULL, NULL, NULL, NULL, NULL, 4),
(90302, NULL, 'G3DSA:3.40.50.300:FF:002571', NULL, NULL, 'Peroxisomal ABC transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(90303, NULL, 'G3DSA:3.90.226.10:FF:000065', NULL, NULL, 'Clp protease', NULL, NULL, NULL, NULL, NULL, 4),
(90304, NULL, 'G3DSA:2.20.28.10:FF:000048', NULL, NULL, 'Putative dna replication licensing factor mcm6 component', NULL, NULL, NULL, NULL, NULL, 4),
(90305, NULL, 'G3DSA:1.10.8.60:FF:000327', NULL, NULL, 'DNA-dependent ATPase (MGS1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(90306, NULL, 'G3DSA:1.20.1310.10:FF:000126', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90307, NULL, 'G3DSA:2.30.30.40:FF:000219', NULL, NULL, 'NADPH oxidase organizer 1', NULL, NULL, NULL, NULL, NULL, 4),
(90308, NULL, 'G3DSA:1.20.1530.20:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90309, NULL, 'G3DSA:2.60.120.290:FF:000258', NULL, NULL, 'Cubilin-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(90310, NULL, 'G3DSA:2.60.40.10:FF:002115', NULL, NULL, 'Uncharacterized LOC100216153', NULL, NULL, NULL, NULL, NULL, 4),
(90311, NULL, 'G3DSA:3.30.40.10:FF:002232', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(90312, NULL, 'G3DSA:3.40.50.11350:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90313, NULL, 'G3DSA:3.30.160.60:FF:000266', NULL, NULL, 'zinc finger and BTB domain-containing protein 44 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(90314, NULL, 'G3DSA:1.25.10.10:FF:000853', NULL, NULL, 'Importin subunit beta-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90315, NULL, 'G3DSA:1.10.287.1490:FF:000024', NULL, NULL, 'Cytoplasmic linker protein 190, isoform M', NULL, NULL, NULL, NULL, NULL, 4),
(90316, NULL, 'G3DSA:3.40.50.720:FF:001090', NULL, NULL, 'Oxidoreductase, short chain dehydrogenase/reductase family', NULL, NULL, NULL, NULL, NULL, 4),
(90317, NULL, 'G3DSA:3.10.290.10:FF:000091', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(90318, NULL, 'G3DSA:1.25.40.10:FF:000063', NULL, NULL, 'Pre-mRNA processing factor 39', NULL, NULL, NULL, NULL, NULL, 4),
(90319, NULL, 'G3DSA:1.25.10.10:FF:001573', NULL, NULL, 'Beta-adaptin-like protein C', NULL, NULL, NULL, NULL, NULL, 4),
(90320, NULL, 'G3DSA:3.40.50.300:FF:004723', NULL, NULL, 'GTP-binding protein Rheb', NULL, NULL, NULL, NULL, NULL, 4),
(90321, NULL, 'G3DSA:2.60.40.10:FF:002379', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(90322, NULL, 'G3DSA:3.30.450.20:FF:000670', NULL, NULL, 'PAS sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(90323, NULL, 'G3DSA:3.30.1120.10:FF:000012', NULL, NULL, 'Arylsulfatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90324, NULL, 'G3DSA:3.40.190.80:FF:000081', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(90325, NULL, 'G3DSA:1.10.3720.10:FF:000126', NULL, NULL, 'Amino acid ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(90326, NULL, 'G3DSA:3.60.21.10:FF:000383', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(90327, NULL, 'G3DSA:3.30.420.10:FF:000575', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90328, NULL, 'G3DSA:2.60.40.10:FF:000316', NULL, NULL, 'Neogenin 1', NULL, NULL, NULL, NULL, NULL, 4),
(90329, NULL, 'G3DSA:1.10.10.10:FF:000173', NULL, NULL, 'Heat shock transcription factor Hsf1', NULL, NULL, NULL, NULL, NULL, 4),
(90330, NULL, 'G3DSA:1.25.40.20:FF:000066', NULL, NULL, 'Osteoclast-stimulating factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(90331, NULL, 'G3DSA:3.30.160.60:FF:003756', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90332, NULL, 'G3DSA:3.40.50.300:FF:008169', NULL, NULL, 'tRNA modification GTPase trmE', NULL, NULL, NULL, NULL, NULL, 4),
(90333, NULL, 'G3DSA:3.60.21.10:FF:000326', NULL, NULL, 'Vacuolar protein sorting-associated protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(90334, NULL, 'G3DSA:3.10.20.90:FF:000013', NULL, NULL, 'radixin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(90335, NULL, 'G3DSA:1.25.40.550:FF:000001', NULL, NULL, 'AAR2 splicing factor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(90336, NULL, 'G3DSA:3.40.50.2300:FF:000938', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90337, NULL, 'G3DSA:3.40.50.300:FF:005909', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90338, NULL, 'G3DSA:4.10.410.10:FF:000108', NULL, NULL, 'WAP four-disulfide core domain protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(90339, NULL, 'G3DSA:3.40.50.11340:FF:000024', NULL, NULL, 'Serine carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90340, NULL, 'G3DSA:3.40.47.10:FF:000212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90341, NULL, 'G3DSA:3.50.50.60:FF:001252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90342, NULL, 'G3DSA:3.40.50.720:FF:000836', NULL, NULL, 'Similar to D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(90343, NULL, 'G3DSA:3.50.50.60:FF:000532', NULL, NULL, '2-octaprenyl-6-methoxyphenyl hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(90344, NULL, 'G3DSA:3.40.50.970:FF:000040', NULL, NULL, 'Oxalyl-CoA decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(90345, NULL, 'G3DSA:3.40.630.30:FF:000044', NULL, NULL, 'dTDP-fucosamine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(90346, NULL, 'G3DSA:3.40.50.150:FF:001576', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90347, NULL, 'G3DSA:3.40.50.1000:FF:000773', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90348, NULL, 'G3DSA:2.130.10.10:FF:002183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90349, NULL, 'G3DSA:2.60.40.10:FF:001598', NULL, NULL, 'Defective proboscis extension response', NULL, NULL, NULL, NULL, NULL, 4),
(90350, NULL, 'G3DSA:3.30.160.40:FF:000018', NULL, NULL, 'Probable porphobilinogen deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(90351, NULL, 'G3DSA:1.25.40.800:FF:000008', NULL, NULL, 'Subunit of the CCR4-NOT transcriptional complex, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90352, NULL, 'G3DSA:2.70.98.30:FF:000039', NULL, NULL, 'Putative alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(90353, NULL, 'G3DSA:3.30.70.330:FF:002878', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90354, NULL, 'G3DSA:1.10.560.10:FF:000030', NULL, NULL, '60 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(90355, NULL, 'G3DSA:1.25.40.10:FF:002272', NULL, NULL, 'YALI0D16225p', NULL, NULL, NULL, NULL, NULL, 4),
(90356, NULL, 'G3DSA:1.25.40.150:FF:000004', NULL, NULL, 'V-type proton ATPase subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(90357, NULL, 'G3DSA:3.40.1350.10:FF:000044', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(90358, NULL, 'G3DSA:1.10.630.10:FF:000676', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90359, NULL, 'G3DSA:2.40.50.140:FF:000211', NULL, NULL, 'breast cancer type 2 susceptibility protein', NULL, NULL, NULL, NULL, NULL, 4),
(90360, NULL, 'G3DSA:3.40.50.150:FF:000351', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(90361, NULL, 'G3DSA:3.40.50.2000:FF:000410', NULL, NULL, 'Lipopolysaccharide 1,6-galactosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(90362, NULL, 'G3DSA:3.30.70.920:FF:000020', NULL, NULL, 'AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(90363, NULL, 'G3DSA:1.10.3260.10:FF:000051', NULL, NULL, 'DNA ligase 4-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(90364, NULL, 'G3DSA:2.40.10.10:FF:000063', NULL, NULL, 'Hepatocyte growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(90365, NULL, 'G3DSA:3.40.50.300:FF:008523', NULL, NULL, 'ATP-dependent RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90366, NULL, 'G3DSA:1.10.1410.40:FF:000010', NULL, NULL, 'Interleukin enhancer-binding factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(90367, NULL, 'G3DSA:1.10.246.130:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90368, NULL, 'G3DSA:3.90.70.10:FF:000713', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90369, NULL, 'G3DSA:2.40.70.10:FF:000246', NULL, NULL, 'Pepsin A', NULL, NULL, NULL, NULL, NULL, 4),
(90370, NULL, 'G3DSA:2.70.98.20:FF:000036', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(90371, NULL, 'G3DSA:3.30.40.10:FF:001361', NULL, NULL, 'Ring finger protein 112, gene 1', NULL, NULL, NULL, NULL, NULL, 4),
(90372, NULL, 'G3DSA:2.60.120.970:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90373, NULL, 'G3DSA:2.60.40.630:FF:000008', NULL, NULL, 'signal transducer and activator of transcription 4', NULL, NULL, NULL, NULL, NULL, 4),
(90374, NULL, 'G3DSA:3.90.190.10:FF:000228', NULL, NULL, 'Protein tyrosine phosphatase, receptor type C', NULL, NULL, NULL, NULL, NULL, 4),
(90375, NULL, 'G3DSA:3.30.160.60:FF:004009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90376, NULL, 'G3DSA:1.10.287.90:FF:000002', NULL, NULL, 'Ubiquinol oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(90377, NULL, 'G3DSA:1.20.890.10:FF:000024', NULL, NULL, 'GD14626', NULL, NULL, NULL, NULL, NULL, 4),
(90378, NULL, 'G3DSA:3.30.70.330:FF:001389', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(90379, NULL, 'G3DSA:2.60.120.620:FF:000048', NULL, NULL, 'Verruculogen synthase', NULL, NULL, NULL, NULL, NULL, 4),
(90380, NULL, 'G3DSA:3.60.21.10:FF:000236', NULL, NULL, '2'',3''-cyclic-nucleotide 2''-phosphodiesterase (CpdB)', NULL, NULL, NULL, NULL, NULL, 4),
(90381, NULL, 'G3DSA:1.20.920.30:FF:000033', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(90382, NULL, 'G3DSA:2.70.98.10:FF:000033', NULL, NULL, 'Glucan 1,4-alpha-glucosidase SusB', NULL, NULL, NULL, NULL, NULL, 4),
(90383, NULL, 'G3DSA:3.90.1100.10:FF:000036', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(90384, NULL, 'G3DSA:3.80.10.10:FF:001508', NULL, NULL, 'Leucine Rich repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90385, NULL, 'G3DSA:3.40.140.10:FF:000129', NULL, NULL, 'Nucleoside deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(90386, NULL, 'G3DSA:3.70.10.10:FF:000014', NULL, NULL, 'DNA repair protein Rad1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90387, NULL, 'G3DSA:1.10.287.110:FF:000149', NULL, NULL, 'Related to cell cycle control protein cwf23', NULL, NULL, NULL, NULL, NULL, 4),
(90388, NULL, 'G3DSA:2.10.70.10:FF:000225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90389, NULL, 'G3DSA:3.30.420.40:FF:000325', NULL, NULL, 'Actin-related protein RO7, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90390, NULL, 'G3DSA:3.40.50.300:FF:006314', NULL, NULL, 'CTP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(90391, NULL, 'G3DSA:3.30.60.30:FF:000148', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(90392, NULL, 'G3DSA:2.10.25.10:FF:000593', NULL, NULL, 'SP2353, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(90393, NULL, 'G3DSA:2.60.120.10:FF:000414', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(90394, NULL, 'G3DSA:2.30.30.30:FF:000126', NULL, NULL, 'G patch domain and KOW motifs', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(90395, NULL, 'G3DSA:3.30.160.60:FF:006218', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90396, NULL, 'G3DSA:3.10.20.30:FF:000102', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90397, NULL, 'G3DSA:1.20.1310.10:FF:000036', NULL, NULL, 'SCF ubiquitin ligase subunit CulC, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90398, NULL, 'G3DSA:3.30.1320.10:FF:000022', NULL, NULL, '30S ribosomal protein S16', NULL, NULL, NULL, NULL, NULL, 4),
(90399, NULL, 'G3DSA:2.30.30.40:FF:000129', NULL, NULL, 'MAGUK p55 subfamily member 4', NULL, NULL, NULL, NULL, NULL, 4),
(90400, NULL, 'G3DSA:3.90.940.20:FF:000002', NULL, NULL, 'RNA polymerase, 25-kDa subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90401, NULL, 'G3DSA:1.20.1560.10:FF:000667', NULL, NULL, 'Protein CBG17574', NULL, NULL, NULL, NULL, NULL, 4),
(90402, NULL, 'G3DSA:1.10.510.10:FF:004091', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90403, NULL, 'G3DSA:3.40.980.10:FF:000024', NULL, NULL, 'Probable FAD synthase', NULL, NULL, NULL, NULL, NULL, 4),
(90404, NULL, 'G3DSA:1.20.900.10:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90405, NULL, 'G3DSA:2.130.10.10:FF:005881', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(90406, NULL, 'G3DSA:1.20.120.1510:FF:000001', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(90407, NULL, 'G3DSA:1.25.10.10:FF:000292', NULL, NULL, 'Deoxyhypusine hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(90408, NULL, 'G3DSA:3.40.50.150:FF:000558', NULL, NULL, 'Protein arginine N-methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90409, NULL, 'G3DSA:3.30.860.10:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90410, NULL, 'G3DSA:2.60.40.60:FF:000281', NULL, NULL, 'Cadherin related family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(90411, NULL, 'G3DSA:2.20.130.20:FF:000011', NULL, NULL, 'Blast:CD109 antigen', NULL, NULL, NULL, NULL, NULL, 4),
(90412, NULL, 'G3DSA:3.40.50.790:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90413, NULL, 'G3DSA:2.40.30.10:FF:000480', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90414, NULL, 'G3DSA:3.40.350.10:FF:000022', NULL, NULL, 'FACT complex subunit spt16', NULL, NULL, NULL, NULL, NULL, 4),
(90415, NULL, 'G3DSA:1.25.40.10:FF:000681', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(90416, NULL, 'G3DSA:1.25.40.20:FF:000684', NULL, NULL, 'Dynein_heavy_chain_and_region_D6_of_dynein_motor/ Ankyrin_repeats_(3_copies)/Ankyrin_repeat_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(90417, NULL, 'G3DSA:3.30.160.60:FF:004066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90418, NULL, 'G3DSA:2.130.10.10:FF:005971', NULL, NULL, 'WD repeat domain 19', NULL, NULL, NULL, NULL, NULL, 4),
(90419, NULL, 'G3DSA:3.90.70.10:FF:000770', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90420, NULL, 'G3DSA:3.30.70.330:FF:001743', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90421, NULL, 'G3DSA:1.20.1280.50:FF:000180', NULL, NULL, 'Glucose-induced repressor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90422, NULL, 'G3DSA:1.10.3720.10:FF:000036', NULL, NULL, 'Maltodextrin ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(90423, NULL, 'G3DSA:3.40.50.300:FF:007596', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90424, NULL, 'G3DSA:3.40.50.720:FF:001651', NULL, NULL, 'dTDP-4-dehydrorhamnose reductase', NULL, NULL, NULL, NULL, NULL, 4),
(90425, NULL, 'G3DSA:2.60.40.150:FF:000224', NULL, NULL, 'Double C2-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(90426, NULL, 'G3DSA:2.10.25.10:FF:001610', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90427, NULL, 'G3DSA:1.10.510.10:FF:002443', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90428, NULL, 'G3DSA:2.60.40.150:FF:000314', NULL, NULL, 'Phosphatidylinositol 3-kinase age-1', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(90429, NULL, 'G3DSA:2.130.10.10:FF:001368', NULL, NULL, 'Protein HIRA', NULL, NULL, NULL, NULL, NULL, 4),
(90430, NULL, 'G3DSA:2.20.28.290:FF:000006', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(90431, NULL, 'G3DSA:2.60.120.820:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90432, NULL, 'G3DSA:2.60.40.60:FF:000371', NULL, NULL, 'Cadherin-related hmr-1', NULL, NULL, NULL, NULL, NULL, 4),
(90433, NULL, 'G3DSA:1.10.630.10:FF:000058', NULL, NULL, 'Fatty acid oxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(90434, NULL, 'G3DSA:1.10.287.1040:FF:000002', NULL, NULL, 'Exodeoxyribonuclease 7 small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(90435, NULL, 'G3DSA:2.70.170.10:FF:000134', NULL, NULL, 'Glutamate-gated chloride channel, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90436, NULL, 'G3DSA:3.10.20.30:FF:000012', NULL, NULL, 'Xanthine dehydrogenase/oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(90437, NULL, 'G3DSA:1.10.287.1490:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90438, NULL, 'G3DSA:2.130.10.10:FF:005729', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90439, NULL, 'G3DSA:3.30.505.10:FF:000160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90440, NULL, 'G3DSA:1.10.510.10:FF:000139', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(90441, NULL, 'G3DSA:3.10.580.10:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90442, NULL, 'G3DSA:3.40.30.10:FF:000820', NULL, NULL, 'Glutathione S-transferase theta-1', NULL, NULL, NULL, NULL, NULL, 4),
(90443, NULL, 'G3DSA:1.25.40.10:FF:003609', NULL, NULL, 'Adenylyl cyclase class-3/4/guanylyl cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(90444, NULL, 'G3DSA:3.30.1640.10:FF:000068', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(90445, NULL, 'G3DSA:1.10.10.1050:FF:000009', NULL, NULL, 'MutT/nudix family protein', NULL, NULL, NULL, NULL, NULL, 4),
(90446, NULL, 'G3DSA:1.10.472.10:FF:000038', NULL, NULL, 'Cyclin F', NULL, NULL, NULL, NULL, NULL, 4),
(90447, NULL, 'G3DSA:2.70.70.10:FF:000003', NULL, NULL, 'Murein hydrolase activator EnvC', NULL, NULL, NULL, NULL, NULL, 4),
(90448, NULL, 'G3DSA:2.130.10.10:FF:003577', NULL, NULL, 'Abnormal embryogenesis protein 30', NULL, NULL, NULL, NULL, NULL, 4),
(90449, NULL, 'G3DSA:3.30.70.940:FF:000026', NULL, NULL, 'Transcription termination/antitermination protein NusG', NULL, NULL, NULL, NULL, NULL, 4),
(90450, NULL, 'G3DSA:2.10.220.10:FF:000118', NULL, NULL, 'Putative furin-like protease 2', NULL, NULL, NULL, NULL, NULL, 4),
(90451, NULL, 'G3DSA:2.60.40.60:FF:000129', NULL, NULL, 'protocadherin alpha-C2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(90452, NULL, 'G3DSA:3.20.20.80:FF:000690', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90453, NULL, 'G3DSA:1.10.20.10:FF:000174', NULL, NULL, 'MIP14426p', NULL, NULL, NULL, NULL, NULL, 4),
(90454, NULL, 'G3DSA:1.10.3480.20:FF:000003', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(90455, NULL, 'G3DSA:1.20.272.10:FF:000004', NULL, NULL, 'Replication factor C subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(90456, NULL, 'G3DSA:1.20.1250.20:FF:000101', NULL, NULL, 'feline leukemia virus subgroup C receptor-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(90457, NULL, 'G3DSA:3.30.500.10:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90458, NULL, 'G3DSA:1.10.540.10:FF:000028', NULL, NULL, 'Acyl-CoA dehydrogenase fadE12', NULL, NULL, NULL, NULL, NULL, 4),
(90459, NULL, 'G3DSA:3.90.550.50:FF:000150', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(90460, NULL, 'G3DSA:3.40.50.261:FF:000042', NULL, NULL, 'ATP citrate (Pro-S)-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(90461, NULL, 'G3DSA:3.30.160.60:FF:002093', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90462, NULL, 'G3DSA:1.25.40.20:FF:000919', NULL, NULL, 'Transient receptor potential-gamma protein-like Protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(90463, NULL, 'G3DSA:1.20.1250.20:FF:001147', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(90464, NULL, 'G3DSA:2.40.30.10:FF:000036', NULL, NULL, 'NADPH--cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(90465, NULL, 'G3DSA:3.30.200.20:FF:001764', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(90466, NULL, 'G3DSA:3.30.70.330:FF:002996', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90467, NULL, 'G3DSA:3.10.580.10:FF:000074', NULL, NULL, 'Membrane protein TerC', NULL, NULL, NULL, NULL, NULL, 4),
(90468, NULL, 'G3DSA:1.20.1610.10:FF:000025', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(90469, NULL, 'G3DSA:3.80.10.10:FF:003280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90470, NULL, 'G3DSA:1.10.8.60:FF:000592', NULL, NULL, 'Cell division control protein', NULL, NULL, NULL, NULL, NULL, 4),
(90471, NULL, 'G3DSA:3.30.565.10:FF:000017', NULL, NULL, 'PMS1 homolog 1, mismatch repair system component', NULL, NULL, NULL, NULL, NULL, 4),
(90472, NULL, 'G3DSA:1.10.510.10:FF:000526', NULL, NULL, 'serine/threonine-protein kinase BRI1-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(90473, NULL, 'G3DSA:3.90.810.10:FF:000018', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(90474, NULL, 'G3DSA:3.80.10.10:FF:001716', NULL, NULL, 'Kekkon5, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(90475, NULL, 'G3DSA:2.40.100.10:FF:000018', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(90476, NULL, 'G3DSA:2.40.30.130:FF:000018', NULL, NULL, 'Alanyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90477, NULL, 'G3DSA:3.30.70.1230:FF:000092', NULL, NULL, 'Adenylate cyclase 1', NULL, NULL, NULL, NULL, NULL, 4),
(90478, NULL, 'G3DSA:1.10.30.10:FF:000202', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(90479, NULL, 'G3DSA:1.10.8.60:FF:000097', NULL, NULL, 'spermatogenesis-associated protein 5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(90480, NULL, 'G3DSA:3.30.2130.10:FF:000013', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(90481, NULL, 'G3DSA:3.30.565.10:FF:000545', NULL, NULL, 'Hypothetical regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(90482, NULL, 'G3DSA:1.20.1670.10:FF:000001', NULL, NULL, 'Putative deoxyuridine triphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(90483, NULL, 'G3DSA:3.30.2170.10:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90484, NULL, 'G3DSA:3.40.30.10:FF:000556', NULL, NULL, 'Tumor suppressor candidate 3', NULL, NULL, NULL, NULL, NULL, 4),
(90485, NULL, 'G3DSA:2.60.40.60:FF:000432', NULL, NULL, 'Cadherin-4', NULL, NULL, NULL, NULL, NULL, 4),
(90486, NULL, 'G3DSA:2.130.10.10:FF:004190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90487, NULL, 'G3DSA:3.30.160.60:FF:004184', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90488, NULL, 'G3DSA:4.10.640.10:FF:000002', NULL, NULL, '30S ribosomal protein S18, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(90489, NULL, 'G3DSA:1.10.510.10:FF:002617', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90490, NULL, 'G3DSA:3.10.490.10:FF:000005', NULL, NULL, 'Gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(90491, NULL, 'G3DSA:3.40.50.300:FF:002981', NULL, NULL, 'ABC transporter C family member 5', NULL, NULL, NULL, NULL, NULL, 4),
(90492, NULL, 'G3DSA:1.10.530.10:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90493, NULL, 'G3DSA:1.20.1600.10:FF:000053', NULL, NULL, 'Protein containing Peptidase M56, BlaR1 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(90494, NULL, 'G3DSA:2.30.29.30:FF:000966', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90495, NULL, 'G3DSA:4.10.280.10:FF:000165', NULL, NULL, 'Transcription factor bHLH104', NULL, NULL, NULL, NULL, NULL, 4),
(90496, NULL, 'G3DSA:3.40.50.300:FF:004307', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(90497, NULL, 'G3DSA:3.30.2160.10:FF:000043', NULL, NULL, 'HECT-domain ubiquitin--protein ligase E3', NULL, NULL, NULL, NULL, NULL, 4),
(90498, NULL, 'G3DSA:3.20.180.20:FF:000010', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(90499, NULL, 'G3DSA:3.40.50.300:FF:002453', NULL, NULL, '26S protease regulatory subunit putative', NULL, NULL, NULL, NULL, NULL, 4),
(90500, NULL, 'G3DSA:2.60.40.2580:FF:000001', NULL, NULL, 'Major fimbrium subunit FimA type-2', NULL, NULL, NULL, NULL, NULL, 4),
(90501, NULL, 'G3DSA:2.60.40.1510:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90502, NULL, 'G3DSA:1.10.1300.10:FF:000021', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(90503, NULL, 'G3DSA:3.80.10.10:FF:000727', NULL, NULL, 'Toll-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(90504, NULL, 'G3DSA:1.10.1370.30:FF:000008', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(90505, NULL, 'G3DSA:3.40.50.10140:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90506, NULL, 'G3DSA:1.20.1310.20:FF:000039', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(90507, NULL, 'G3DSA:2.70.150.10:FF:000133', NULL, NULL, 'Probable metal-transporting P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(90508, NULL, 'G3DSA:3.10.110.10:FF:000101', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 D2', NULL, NULL, NULL, NULL, NULL, 4),
(90509, NULL, 'G3DSA:4.10.240.10:FF:000163', NULL, NULL, 'Nucleus protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90510, NULL, 'G3DSA:3.30.200.20:FF:000185', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(90511, NULL, 'G3DSA:1.20.5.2050:FF:000003', NULL, NULL, 'Transcription factor with AP2 domain(S)', NULL, NULL, NULL, NULL, NULL, 4),
(90512, NULL, 'G3DSA:3.90.550.10:FF:000301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90513, NULL, 'G3DSA:1.25.40.10:FF:003519', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90514, NULL, 'G3DSA:1.50.40.10:FF:000145', NULL, NULL, 'Mitochondrial carnitine carrier', NULL, NULL, NULL, NULL, NULL, 4),
(90515, NULL, 'G3DSA:3.40.50.300:FF:002127', NULL, NULL, 'guanine nucleotide-binding protein G(Q) subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(90516, NULL, 'G3DSA:1.25.10.10:FF:002062', NULL, NULL, 'HEAT repeat-containing protein 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(90517, NULL, 'G3DSA:3.20.20.80:FF:000717', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90518, NULL, 'G3DSA:3.20.20.360:FF:000002', NULL, NULL, 'Malate synthase G', NULL, NULL, NULL, NULL, NULL, 4),
(90519, NULL, 'G3DSA:3.30.70.330:FF:001535', NULL, NULL, 'Multiple RNA-binding domain containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(90520, NULL, 'G3DSA:3.40.30.10:FF:000758', NULL, NULL, '28S ribosomal protein S25, mitochondrial-like', NULL, NULL, NULL, NULL, NULL, 4),
(90521, NULL, 'G3DSA:2.60.120.1040:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90522, NULL, 'G3DSA:3.40.30.10:FF:000612', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(90523, NULL, 'G3DSA:2.60.40.790:FF:000034', NULL, NULL, 'Protein SGT1 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(90524, NULL, 'G3DSA:3.30.160.60:FF:003874', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90525, NULL, 'G3DSA:1.10.10.60:FF:001149', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90526, NULL, 'G3DSA:2.40.30.10:FF:000362', NULL, NULL, 'Pyruvate:ferredoxin oxidoreductase/NADPH-cytochrome P450 reductase PNO', NULL, NULL, NULL, NULL, NULL, 4),
(90527, NULL, 'G3DSA:1.20.1250.20:FF:001203', NULL, NULL, 'Permeases of the major facilitator superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(90528, NULL, 'G3DSA:3.20.20.70:FF:000714', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90529, NULL, 'G3DSA:2.130.10.10:FF:003728', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(90530, NULL, 'G3DSA:3.50.30.30:FF:000157', NULL, NULL, 'Alkaline serine protease, subtilase family', NULL, NULL, NULL, NULL, NULL, 4),
(90531, NULL, 'G3DSA:3.40.50.1000:FF:000065', NULL, NULL, 'Putative Phosphatidyl synthase', NULL, NULL, NULL, NULL, NULL, 4),
(90532, NULL, 'G3DSA:1.20.120.1900:FF:000056', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(90533, NULL, 'G3DSA:3.30.40.10:FF:001451', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90534, NULL, 'G3DSA:3.10.450.580:FF:000003', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(90535, NULL, 'G3DSA:3.90.70.10:FF:000444', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90536, NULL, 'G3DSA:3.30.200.20:FF:002130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90537, NULL, 'G3DSA:2.10.110.20:FF:000001', NULL, NULL, 'lysine-specific demethylase 6A isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(90538, NULL, 'G3DSA:3.30.420.40:FF:000409', NULL, NULL, 'Heat shock protein 70, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90539, NULL, 'G3DSA:3.40.50.1010:FF:000068', NULL, NULL, 'Ribonuclease VapC', NULL, NULL, NULL, NULL, NULL, 4),
(90540, NULL, 'G3DSA:1.20.1530.20:FF:000027', NULL, NULL, 'sodium/bile acid cotransporter 7 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(90541, NULL, 'G3DSA:3.30.70.100:FF:000123', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90542, NULL, 'G3DSA:3.30.40.10:FF:000023', NULL, NULL, 'Lysine (K)-specific demethylase 5A', NULL, NULL, NULL, NULL, NULL, 4),
(90543, NULL, 'G3DSA:1.10.20.10:FF:000230', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90544, NULL, 'G3DSA:1.10.510.10:FF:004181', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90545, NULL, 'G3DSA:2.60.40.380:FF:000001', NULL, NULL, 'Fe(3+)-Zn(2+) purple acid phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(90546, NULL, 'G3DSA:2.160.10.10:FF:000080', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(90547, NULL, 'G3DSA:2.130.10.130:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90548, NULL, 'G3DSA:3.10.120.10:FF:000017', NULL, NULL, 'Fatty acid desaturase 1', NULL, NULL, NULL, NULL, NULL, 4),
(90549, NULL, 'G3DSA:1.10.1090.10:FF:000009', NULL, NULL, 'Cytochrome b-c1 complex subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(90550, NULL, 'G3DSA:1.10.720.60:FF:000001', NULL, NULL, 'Probable bifunctional methylthioribulose-1-phosphate dehydratase/enolase-phosphatase E1', NULL, NULL, NULL, NULL, NULL, 4),
(90551, NULL, 'G3DSA:3.10.620.30:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90552, NULL, 'G3DSA:3.30.390.10:FF:000021', NULL, NULL, 'Regulator of nonsense transcripts 1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(90553, NULL, 'G3DSA:1.10.3730.20:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90554, NULL, 'G3DSA:2.120.10.30:FF:000003', NULL, NULL, 'Teneurin transmembrane protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(90555, NULL, 'G3DSA:1.10.10.10:FF:001567', NULL, NULL, 'Endonuclease III family protein', NULL, NULL, NULL, NULL, NULL, 4),
(90556, NULL, 'G3DSA:2.130.10.10:FF:001839', NULL, NULL, 'WD-40 repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(90557, NULL, 'G3DSA:3.30.420.40:FF:000735', NULL, NULL, 'Actin-like protein ARP6', NULL, NULL, NULL, NULL, NULL, 4),
(90558, NULL, 'G3DSA:3.40.50.2300:FF:001309', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90559, NULL, 'G3DSA:1.25.40.10:FF:002210', NULL, NULL, 'Signal recognition particle subunit SRP72', NULL, NULL, NULL, NULL, NULL, 4),
(90560, NULL, 'G3DSA:3.40.850.10:FF:000369', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90561, NULL, 'G3DSA:3.40.605.10:FF:000053', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(90562, NULL, 'G3DSA:1.10.1200.10:FF:000159', NULL, NULL, 'Putative peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(90563, NULL, 'G3DSA:3.30.200.20:FF:001438', NULL, NULL, 'Putative serine/threonine protein kinase IREH1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(90564, NULL, 'G3DSA:3.50.50.60:FF:000116', NULL, NULL, 'Glycine oxidase ThiO', NULL, NULL, NULL, NULL, NULL, 4),
(90565, NULL, 'G3DSA:1.10.510.10:FF:003871', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90566, NULL, 'G3DSA:3.30.200.20:FF:001966', NULL, NULL, 'Protein CBG04906', NULL, NULL, NULL, NULL, NULL, 4),
(90567, NULL, 'G3DSA:2.130.10.10:FF:002003', NULL, NULL, 'Dynein, axonemal, intermediate chain 1, paralog 2', NULL, NULL, NULL, NULL, NULL, 4),
(90568, NULL, 'G3DSA:3.10.20.80:FF:000010', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(90569, NULL, 'G3DSA:1.10.510.10:FF:002292', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90570, NULL, 'G3DSA:2.60.120.260:FF:000598', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(90571, NULL, 'G3DSA:3.40.50.1820:FF:001710', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90572, NULL, 'G3DSA:1.20.120.1750:FF:000022', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(90573, NULL, 'G3DSA:3.40.50.11530:FF:000014', NULL, NULL, 'Interleukin 17 receptor E', NULL, NULL, NULL, NULL, NULL, 4),
(90574, NULL, 'G3DSA:1.10.238.10:FF:000242', NULL, NULL, 'EF-hand calcium binding domain 6', NULL, NULL, NULL, NULL, NULL, 4),
(90575, NULL, 'G3DSA:2.170.270.10:FF:000073', NULL, NULL, 'AGAP013139-PA', NULL, NULL, NULL, NULL, NULL, 4),
(90576, NULL, 'G3DSA:1.20.1250.20:FF:000837', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(90577, NULL, 'G3DSA:2.160.20.10:FF:000052', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(90578, NULL, 'G3DSA:2.60.200.20:FF:000221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90579, NULL, 'G3DSA:3.40.1380.20:FF:000077', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(90580, NULL, 'G3DSA:3.40.50.300:FF:000036', NULL, NULL, 'septin-6 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(90581, NULL, 'G3DSA:3.30.40.10:FF:001653', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(90582, NULL, 'G3DSA:1.25.10.10:FF:002236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90583, NULL, 'G3DSA:1.50.40.10:FF:000347', NULL, NULL, 'Mitochondrial carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90584, NULL, 'G3DSA:2.30.40.10:FF:000149', NULL, NULL, 'Periplasmic amidohydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(90585, NULL, 'G3DSA:3.40.50.300:FF:008113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90586, NULL, 'G3DSA:3.30.420.40:FF:000033', NULL, NULL, 'glycerol kinase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(90587, NULL, 'G3DSA:1.20.58.340:FF:000065', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(90588, NULL, 'G3DSA:3.90.70.10:FF:000242', NULL, NULL, 'Peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(90589, NULL, 'G3DSA:1.10.287.940:FF:000021', NULL, NULL, 'P2X purinoceptor', NULL, NULL, NULL, NULL, NULL, 4),
(90590, NULL, 'G3DSA:3.30.60.20:FF:000112', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(90591, NULL, 'G3DSA:3.30.450.40:FF:000237', NULL, NULL, 'GGDEF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(90592, NULL, 'G3DSA:1.20.1280.50:FF:000264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90593, NULL, 'G3DSA:3.30.930.10:FF:000097', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(90594, NULL, 'G3DSA:1.20.1070.10:FF:001725', NULL, NULL, 'Mu-type opioid receptor', NULL, NULL, NULL, NULL, NULL, 4),
(90595, NULL, 'G3DSA:1.25.40.20:FF:001111', NULL, NULL, 'Fibronectin type III and ankyrin repeat domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(90596, NULL, 'G3DSA:1.10.287.950:FF:000024', NULL, NULL, 'Methyl-accepting chemotaxis sensory transducer, class 40+24H', NULL, NULL, NULL, NULL, NULL, 4),
(90597, NULL, 'G3DSA:1.20.120.1760:FF:000025', NULL, NULL, 'CDP-diacylglycerol--serine o-phosphatidyltransferase PssA', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(90598, NULL, 'G3DSA:2.10.25.10:FF:000885', NULL, NULL, 'Protein S', NULL, NULL, NULL, NULL, NULL, 4),
(90599, NULL, 'G3DSA:1.10.506.10:FF:000005', NULL, NULL, 'Plexin A1', NULL, NULL, NULL, NULL, NULL, 4),
(90600, NULL, 'G3DSA:2.60.40.1180:FF:000126', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(90601, NULL, 'G3DSA:2.30.180.10:FF:000104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90602, NULL, 'G3DSA:2.60.40.10:FF:002615', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90603, NULL, 'G3DSA:3.40.50.150:FF:001486', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90604, NULL, 'G3DSA:1.10.10.60:FF:000047', NULL, NULL, 'Myb transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(90605, NULL, 'G3DSA:3.40.630.30:FF:000572', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90606, NULL, 'G3DSA:3.90.730.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90607, NULL, 'G3DSA:3.40.525.10:FF:000052', NULL, NULL, 'Protein tyrosine phosphatase Meg2, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(90608, NULL, 'G3DSA:3.30.9.10:FF:000018', NULL, NULL, 'D-amino acid oxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90609, NULL, 'G3DSA:2.60.40.150:FF:000640', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90610, NULL, 'G3DSA:3.40.630.30:FF:000544', NULL, NULL, 'L-lysine 2,3-aminomutase, putative/acetyltransferase, GNAT family', NULL, NULL, NULL, NULL, NULL, 4),
(90611, NULL, 'G3DSA:1.25.40.10:FF:003317', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(90612, NULL, 'G3DSA:1.10.533.10:FF:000063', NULL, NULL, 'Mitochondrial antiviral-signaling protein', NULL, NULL, NULL, NULL, NULL, 4),
(90613, NULL, 'G3DSA:2.40.128.20:FF:000052', NULL, NULL, 'LiPocalin-Related protein', NULL, NULL, NULL, NULL, NULL, 4),
(90614, NULL, 'G3DSA:3.40.50.1100:FF:000062', NULL, NULL, '1-aminocyclopropane-1-carboxylate deaminase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90615, NULL, 'G3DSA:1.20.58.60:FF:000792', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90616, NULL, 'G3DSA:2.40.10.10:FF:000708', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90617, NULL, 'G3DSA:3.10.20.90:FF:000541', NULL, NULL, 'GH01724p', NULL, NULL, NULL, NULL, NULL, 4),
(90618, NULL, 'G3DSA:1.10.510.10:FF:003399', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90619, NULL, 'G3DSA:3.40.50.300:FF:006724', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90620, NULL, 'G3DSA:3.40.1360.10:FF:000016', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(90621, NULL, 'G3DSA:3.40.50.200:FF:000006', NULL, NULL, 'Subtilisin-like protease SBT1.5', NULL, NULL, NULL, NULL, NULL, 4),
(90622, NULL, 'G3DSA:2.40.10.10:FF:000332', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90623, NULL, 'G3DSA:3.40.50.10860:FF:000009', NULL, NULL, 'Bifunctional 3-dehydroquinate dehydratase/shikimate dehydrogenase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(90624, NULL, 'G3DSA:1.25.40.10:FF:004301', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(90625, NULL, 'G3DSA:3.90.70.10:FF:000118', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 25', NULL, NULL, NULL, NULL, NULL, 4),
(90626, NULL, 'G3DSA:2.60.40.150:FF:000168', NULL, NULL, 'Protein BONZAI 1', NULL, NULL, NULL, NULL, NULL, 4),
(90627, NULL, 'G3DSA:2.60.40.290:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90628, NULL, 'G3DSA:1.10.10.10:FF:002056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90629, NULL, 'G3DSA:3.60.40.10:FF:000365', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90630, NULL, 'G3DSA:3.40.630.10:FF:000414', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90631, NULL, 'G3DSA:2.60.40.10:FF:002295', NULL, NULL, 'Stretchin-Mlck, isoform V', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(90632, NULL, 'G3DSA:3.40.50.300:FF:003908', NULL, NULL, 'Molybdate ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(90633, NULL, 'G3DSA:1.20.144.10:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90634, NULL, 'G3DSA:1.10.238.10:FF:000303', NULL, NULL, 'Cornulin', NULL, NULL, NULL, NULL, NULL, 4),
(90635, NULL, 'G3DSA:2.130.10.10:FF:005494', NULL, NULL, 'Heterotrimeric G protein beta subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(90636, NULL, 'G3DSA:3.40.50.720:FF:001387', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90637, NULL, 'G3DSA:3.20.20.140:FF:000470', NULL, NULL, 'Adenosine deaminase 2', NULL, NULL, NULL, NULL, NULL, 4),
(90638, NULL, 'G3DSA:3.70.10.10:FF:000076', NULL, NULL, 'Checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(90639, NULL, 'G3DSA:3.40.1280.10:FF:000015', NULL, NULL, 'Putative tRNA/rRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(90640, NULL, 'G3DSA:2.60.40.10:FF:002025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90641, NULL, 'G3DSA:3.40.50.720:FF:001117', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(90642, NULL, 'G3DSA:1.10.3560.10:FF:000001', NULL, NULL, 'Protein PBDC1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(90643, NULL, 'G3DSA:2.130.10.10:FF:000058', NULL, NULL, 'striatin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(90644, NULL, 'G3DSA:2.130.10.10:FF:002149', NULL, NULL, 'Os08g0524100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(90645, NULL, 'G3DSA:2.40.270.10:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90646, NULL, 'G3DSA:1.20.1070.10:FF:001107', NULL, NULL, 'Rhodopsin, GQ-coupled', NULL, NULL, NULL, NULL, NULL, 4),
(90647, NULL, 'G3DSA:1.50.40.10:FF:000471', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90648, NULL, 'G3DSA:3.10.20.90:FF:000513', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90649, NULL, 'G3DSA:2.160.20.10:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90650, NULL, 'G3DSA:3.30.70.330:FF:000433', NULL, NULL, 'RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(90651, NULL, 'G3DSA:2.40.50.140:FF:001077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90652, NULL, 'G3DSA:2.30.130.10:FF:000040', NULL, NULL, 'Dyskeratosis congenita 1, dyskerin', NULL, NULL, NULL, NULL, NULL, 4),
(90653, NULL, 'G3DSA:3.40.50.1820:FF:000777', NULL, NULL, 'Uncharacterized protein CaJ7.0249', NULL, NULL, NULL, NULL, NULL, 4),
(90654, NULL, 'G3DSA:3.10.450.50:FF:000110', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(90655, NULL, 'G3DSA:1.10.287.110:FF:000065', NULL, NULL, 'Chaperone protein dnaJ 49', NULL, NULL, NULL, NULL, NULL, 4),
(90656, NULL, 'G3DSA:2.130.10.10:FF:004217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90657, NULL, 'G3DSA:3.30.40.10:FF:001327', NULL, NULL, 'Ring-H2 finger A3B', NULL, NULL, NULL, NULL, NULL, 4),
(90658, NULL, 'G3DSA:3.40.50.2000:FF:000848', NULL, NULL, 'Glycosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90659, NULL, 'G3DSA:1.20.120.450:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90660, NULL, 'G3DSA:3.90.460.10:FF:000002', NULL, NULL, 'Ferredoxin-thioredoxin reductase, catalytic chain', NULL, NULL, NULL, NULL, NULL, 4),
(90661, NULL, 'G3DSA:3.30.1640.10:FF:000006', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(90662, NULL, 'G3DSA:3.40.50.1110:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90663, NULL, 'G3DSA:1.25.40.10:FF:001844', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(90664, NULL, 'G3DSA:3.10.120.10:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90665, NULL, 'G3DSA:3.40.50.300:FF:006168', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(90666, NULL, 'G3DSA:1.10.238.10:FF:000921', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(90667, NULL, 'G3DSA:1.20.5.190:FF:000121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90668, NULL, 'G3DSA:1.10.630.10:FF:000468', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90669, NULL, 'G3DSA:3.90.920.10:FF:000026', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(90670, NULL, 'G3DSA:3.40.640.10:FF:000510', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90671, NULL, 'G3DSA:3.40.50.300:FF:003818', NULL, NULL, 'Eukaryotic Elongation Factor, SelenoCysteine-tRNA-specific', NULL, NULL, NULL, NULL, NULL, 4),
(90672, NULL, 'G3DSA:3.30.450.40:FF:000035', NULL, NULL, 'PAS sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(90673, NULL, 'G3DSA:3.40.50.970:FF:000124', NULL, NULL, '1-deoxy-D-xylulose-5-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(90674, NULL, 'G3DSA:3.30.450.30:FF:000032', NULL, NULL, 'Dynein light chain 2B, cytoplasmic, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90675, NULL, 'G3DSA:3.40.140.10:FF:000130', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(90676, NULL, 'G3DSA:2.130.10.10:FF:003077', NULL, NULL, 'YALI0A20636p', NULL, NULL, NULL, NULL, NULL, 4),
(90677, NULL, 'G3DSA:2.60.40.10:FF:004442', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90678, NULL, 'G3DSA:2.120.10.30:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90679, NULL, 'G3DSA:3.50.50.60:FF:000206', NULL, NULL, 'Digeranylgeranylglycerophospholipid reductase', NULL, NULL, NULL, NULL, NULL, 4),
(90680, NULL, 'G3DSA:3.30.200.20:FF:001348', NULL, NULL, 'CMGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(90681, NULL, 'G3DSA:3.40.50.10420:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90682, NULL, 'G3DSA:3.40.50.300:FF:008023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90683, NULL, 'G3DSA:1.50.40.10:FF:000319', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90684, NULL, 'G3DSA:1.10.238.10:FF:000573', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(90685, NULL, 'G3DSA:1.20.1070.10:FF:000736', NULL, NULL, 'SIFamide receptor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(90686, NULL, 'G3DSA:3.10.20.90:FF:000395', NULL, NULL, 'Polyubiquitin containing 7 ubiquitin monomers', NULL, NULL, NULL, NULL, NULL, 4),
(90687, NULL, 'G3DSA:3.30.70.1230:FF:000266', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(90688, NULL, 'G3DSA:3.40.50.1480:FF:000012', NULL, NULL, 'Adenosylhomocysteinase', NULL, NULL, NULL, NULL, NULL, 4),
(90689, NULL, 'G3DSA:3.90.550.10:FF:000071', NULL, NULL, 'Mannose-1-phosphate guanyltransferase alpha', NULL, NULL, NULL, NULL, NULL, 4),
(90690, NULL, 'G3DSA:3.40.20.10:FF:000168', NULL, NULL, 'Actin-depolymerizing factor 1, isoforms a/b', NULL, NULL, NULL, NULL, NULL, 4),
(90691, NULL, 'G3DSA:3.30.420.40:FF:000179', NULL, NULL, 'Actin-like 6a isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(90692, NULL, 'G3DSA:3.30.160.60:FF:006252', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90693, NULL, 'G3DSA:1.10.8.960:FF:000006', NULL, NULL, 'Putative gamma-glutamylcysteine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(90694, NULL, 'G3DSA:1.20.960.30:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90695, NULL, 'G3DSA:1.10.3730.10:FF:000008', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(90696, NULL, 'G3DSA:2.130.10.10:FF:006016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90697, NULL, 'G3DSA:1.10.10.1830:FF:000001', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(90698, NULL, 'G3DSA:3.30.1360.120:FF:000024', NULL, NULL, 'Putative transferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(90699, NULL, 'G3DSA:3.30.200.20:FF:002220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90700, NULL, 'G3DSA:3.40.50.1820:FF:001564', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(90701, NULL, 'G3DSA:1.25.40.20:FF:001847', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90702, NULL, 'G3DSA:3.30.70.3400:FF:000001', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(90703, NULL, 'G3DSA:3.90.550.10:FF:000306', NULL, NULL, 'Uncharacterized glycosyltransferase YwdF', NULL, NULL, NULL, NULL, NULL, 4),
(90704, NULL, 'G3DSA:2.130.10.10:FF:000530', NULL, NULL, 'Autophagy-related protein 18a', NULL, NULL, NULL, NULL, NULL, 4),
(90705, NULL, 'G3DSA:1.20.1110.10:FF:000055', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(90706, NULL, 'G3DSA:2.60.40.10:FF:000171', NULL, NULL, 'protein-glutamine gamma-glutamyltransferase 6', NULL, NULL, NULL, NULL, NULL, 4),
(90707, NULL, 'G3DSA:3.30.160.60:FF:002267', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90708, NULL, 'G3DSA:2.70.170.10:FF:000016', NULL, NULL, 'Nicotinic acetylcholine receptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(90709, NULL, 'G3DSA:4.10.240.10:FF:000039', NULL, NULL, 'ARG81-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(90710, NULL, 'G3DSA:1.10.287.40:FF:000009', NULL, NULL, 'Serine-tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90711, NULL, 'G3DSA:2.60.40.680:FF:000001', NULL, NULL, 'O-GlcNAcase NagJ', NULL, NULL, NULL, NULL, NULL, 4),
(90712, NULL, 'G3DSA:2.10.110.10:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90713, NULL, 'G3DSA:1.10.287.70:FF:000373', NULL, NULL, 'Ion_transport_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(90714, NULL, 'G3DSA:1.10.418.10:FF:000194', NULL, NULL, 'Leucine-rich repeats and calponin homology (CH) domain-containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(90715, NULL, 'G3DSA:3.80.10.10:FF:001391', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', NULL, NULL, NULL, NULL, NULL, 4),
(90716, NULL, 'G3DSA:3.40.50.300:FF:006814', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90717, NULL, 'G3DSA:3.90.1140.10:FF:000005', NULL, NULL, 'activating signal cointegrator 1 complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(90718, NULL, 'G3DSA:2.60.40.690:FF:000004', NULL, NULL, 'Complement C3', NULL, NULL, NULL, NULL, NULL, 4),
(90719, NULL, 'G3DSA:3.40.50.1820:FF:001087', NULL, NULL, 'Phospholipid:diacylglycerol acyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(90720, NULL, 'G3DSA:2.60.40.10:FF:003689', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90721, NULL, 'G3DSA:2.60.120.200:FF:000389', NULL, NULL, 'Cell wall organization and biogenesis-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90722, NULL, 'G3DSA:2.60.40.1660:FF:000028', NULL, NULL, 'ATPase Na+/K+ transporting subunit beta 2a', NULL, NULL, NULL, NULL, NULL, 4),
(90723, NULL, 'G3DSA:3.90.70.10:FF:000270', NULL, NULL, 'SUMO-specific isopeptidase USPL1', NULL, NULL, NULL, NULL, NULL, 4),
(90724, NULL, 'G3DSA:3.40.30.10:FF:000584', NULL, NULL, 'Possible thiol:disulfide interchange protein', NULL, NULL, NULL, NULL, NULL, 4),
(90725, NULL, 'G3DSA:2.30.180.10:FF:000048', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(90726, NULL, 'G3DSA:3.40.1060.10:FF:000004', NULL, NULL, 'Aconitase 2', NULL, NULL, NULL, NULL, NULL, 4),
(90727, NULL, 'G3DSA:4.10.400.10:FF:000193', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(90728, NULL, 'G3DSA:3.30.160.60:FF:006162', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90729, NULL, 'G3DSA:1.10.10.790:FF:000026', NULL, NULL, 'Protein SWAP', NULL, NULL, NULL, NULL, NULL, 4),
(90730, NULL, 'G3DSA:3.40.50.300:FF:007798', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90731, NULL, 'G3DSA:1.10.10.60:FF:000137', NULL, NULL, 'MYB DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(90732, NULL, 'G3DSA:1.10.1040.10:FF:000068', NULL, NULL, 'ApbA-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(90733, NULL, 'G3DSA:1.25.10.10:FF:002326', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(90734, NULL, 'G3DSA:3.30.70.360:FF:000066', NULL, NULL, 'AGL325Wp', NULL, NULL, NULL, NULL, NULL, 4),
(90735, NULL, 'G3DSA:3.90.1010.10:FF:000001', NULL, NULL, 'Iron-sulfur cluster assembly scaffold protein IscU', NULL, NULL, NULL, NULL, NULL, 4),
(90736, NULL, 'G3DSA:1.20.1070.10:FF:001635', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90737, NULL, 'G3DSA:3.90.550.10:FF:000447', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90738, NULL, 'G3DSA:3.90.180.10:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90739, NULL, 'G3DSA:3.30.30.30:FF:000057', NULL, NULL, 'Heat shock protein 70 putative', NULL, NULL, NULL, NULL, NULL, 4),
(90740, NULL, 'G3DSA:3.30.450.50:FF:000038', NULL, NULL, 'Synaptobrevin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(90741, NULL, 'G3DSA:3.10.110.10:FF:000073', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 N', NULL, NULL, NULL, NULL, NULL, 4),
(90742, NULL, 'G3DSA:2.10.90.10:FF:000142', NULL, NULL, 'Transforming growth factor beta superfamily signaling ligand', NULL, NULL, NULL, NULL, NULL, 4),
(90743, NULL, 'G3DSA:1.20.120.430:FF:000001', NULL, NULL, 'tRNA modification GTPase MnmE', NULL, NULL, NULL, NULL, NULL, 4),
(90744, NULL, 'G3DSA:1.10.10.60:FF:000340', NULL, NULL, 'Transcriptional adapter', NULL, NULL, NULL, NULL, NULL, 4),
(90745, NULL, 'G3DSA:3.30.160.60:FF:000468', NULL, NULL, 'B-cell lymphoma 6 protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(90746, NULL, 'G3DSA:1.10.510.10:FF:002943', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90747, NULL, 'G3DSA:3.30.500.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90748, NULL, 'G3DSA:3.80.10.10:FF:002644', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase GSO2', NULL, NULL, NULL, NULL, NULL, 4),
(90749, NULL, 'G3DSA:3.40.50.10900:FF:000010', NULL, NULL, 'Proteasome assembly chaperone 2', NULL, NULL, NULL, NULL, NULL, 4),
(90750, NULL, 'G3DSA:3.30.420.610:FF:000024', NULL, NULL, 'Tapas, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(90751, NULL, 'G3DSA:3.80.10.10:FF:003190', NULL, NULL, 'Ribonuclease inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(90752, NULL, 'G3DSA:3.40.50.10190:FF:000174', NULL, NULL, 'DNA ligase 4', NULL, NULL, NULL, NULL, NULL, 4),
(90753, NULL, 'G3DSA:3.40.50.1820:FF:001620', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90754, NULL, 'G3DSA:3.30.230.130:FF:000011', NULL, NULL, 'SCF ubiquitin ligase subunit CulC, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90755, NULL, 'G3DSA:1.25.40.10:FF:003643', NULL, NULL, 'Genomes uncoupled1', NULL, NULL, NULL, NULL, NULL, 4),
(90756, NULL, 'G3DSA:3.40.50.300:FF:000238', NULL, NULL, 'Cell division control 12', NULL, NULL, NULL, NULL, NULL, 4),
(90757, NULL, 'G3DSA:3.40.50.2300:FF:000056', NULL, NULL, 'Gamma-aminobutyric acid type B receptor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(90758, NULL, 'G3DSA:1.20.1250.20:FF:001057', NULL, NULL, 'Permeases of the major facilitator superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(90759, NULL, 'G3DSA:2.60.40.3510:FF:000022', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(90760, NULL, 'G3DSA:1.20.120.350:FF:000275', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90761, NULL, 'G3DSA:3.50.7.10:FF:000003', NULL, NULL, 'T-complex protein 1 subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(90762, NULL, 'G3DSA:1.10.540.10:FF:000023', NULL, NULL, 'Acyl-CoA dehydrogenase FadE25', NULL, NULL, NULL, NULL, NULL, 4),
(90763, NULL, 'G3DSA:1.10.150.50:FF:000235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90764, NULL, 'G3DSA:3.40.50.2020:FF:000186', NULL, NULL, 'Orotate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(90765, NULL, 'G3DSA:2.60.40.640:FF:000129', NULL, NULL, 'Arrestin 3, retinal (X-arrestin)', NULL, NULL, NULL, NULL, NULL, 4),
(90766, NULL, 'G3DSA:1.25.50.20:FF:000038', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(90767, NULL, 'G3DSA:2.130.10.10:FF:000351', NULL, NULL, 'semaphorin-4F isoform X1', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(90768, NULL, 'G3DSA:1.10.472.130:FF:000004', NULL, NULL, 'Dynein axonemal heavy chain 8', NULL, NULL, NULL, NULL, NULL, 4),
(90769, NULL, 'G3DSA:3.30.200.20:FF:001674', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90770, NULL, 'G3DSA:3.40.50.720:FF:000954', NULL, NULL, 'Homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(90771, NULL, 'G3DSA:1.10.20.10:FF:000084', NULL, NULL, 'Histone H2B', NULL, NULL, NULL, NULL, NULL, 4),
(90772, NULL, 'G3DSA:3.30.519.10:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90773, NULL, 'G3DSA:3.30.160.60:FF:001311', NULL, NULL, 'Zinc finger protein 668', NULL, NULL, NULL, NULL, NULL, 4),
(90774, NULL, 'G3DSA:1.10.287.600:FF:000026', NULL, NULL, 'Tubulin alpha-8 chain', NULL, NULL, NULL, NULL, NULL, 4),
(90775, NULL, 'G3DSA:3.80.10.10:FF:001626', NULL, NULL, 'CLL4B clavata1-like receptor S/T protein kinase protein', NULL, NULL, NULL, NULL, NULL, 4),
(90776, NULL, 'G3DSA:1.10.1070.11:FF:000110', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(90777, NULL, 'G3DSA:1.25.40.10:FF:002154', NULL, NULL, 'regulator of microtubule dynamics protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(90778, NULL, 'G3DSA:1.10.390.10:FF:000084', NULL, NULL, 'Aminopeptidase N', NULL, NULL, NULL, NULL, NULL, 4),
(90779, NULL, 'G3DSA:3.30.160.60:FF:002413', NULL, NULL, 'Zinc finger protein 547', NULL, NULL, NULL, NULL, NULL, 4),
(90780, NULL, 'G3DSA:2.60.40.150:FF:000163', NULL, NULL, 'Copine 7', NULL, NULL, NULL, NULL, NULL, 4),
(90781, NULL, 'G3DSA:3.80.10.10:FF:002728', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(90782, NULL, 'G3DSA:3.40.30.10:FF:000702', NULL, NULL, 'AhpC/TSA family thioredoxin peroxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90783, NULL, 'G3DSA:3.40.50.300:FF:000564', NULL, NULL, 'Structural maintenance of chromosomes 1A', NULL, NULL, NULL, NULL, NULL, 4),
(90784, NULL, 'G3DSA:2.60.120.950:FF:000001', NULL, NULL, 'Capsid protein', NULL, NULL, NULL, NULL, NULL, 4),
(90785, NULL, 'G3DSA:3.30.160.60:FF:001957', NULL, NULL, 'Si:dkey-77f5.11', NULL, NULL, NULL, NULL, NULL, 4),
(90786, NULL, 'G3DSA:3.30.70.100:FF:000095', NULL, NULL, 'Disease resistance protein RGA5', NULL, NULL, NULL, NULL, NULL, 4),
(90787, NULL, 'G3DSA:3.30.70.2190:FF:000020', NULL, NULL, 'Glr3436 protein', NULL, NULL, NULL, NULL, NULL, 4),
(90788, NULL, 'G3DSA:1.25.40.10:FF:001698', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(90789, NULL, 'G3DSA:3.30.160.60:FF:000327', NULL, NULL, 'Zinc finger and AT-hook domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(90790, NULL, 'G3DSA:1.10.287.110:FF:000267', NULL, NULL, 'DnaJ domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90791, NULL, 'G3DSA:1.10.3210.10:FF:000071', NULL, NULL, 'Falten, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(90792, NULL, 'G3DSA:3.10.110.10:FF:000106', NULL, NULL, 'Ubiquitin-fold modifier-conjugating enzyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(90793, NULL, 'G3DSA:3.40.140.10:FF:000040', NULL, NULL, '26S proteasome regulatory subunit RPN8', NULL, NULL, NULL, NULL, NULL, 4),
(90794, NULL, 'G3DSA:4.10.1240.50:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90795, NULL, 'G3DSA:1.20.1560.10:FF:000791', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90796, NULL, 'G3DSA:2.60.40.10:FF:000726', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(90797, NULL, 'G3DSA:3.40.50.880:FF:000193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90798, NULL, 'G3DSA:3.80.10.10:FF:002970', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90799, NULL, 'G3DSA:3.40.50.720:FF:001443', NULL, NULL, 'Malate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(90800, NULL, 'G3DSA:3.30.870.10:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(90801, NULL, 'G3DSA:1.20.1410.10:FF:000044', NULL, NULL, 'Uncharacterized protein C22E12.18', NULL, NULL, NULL, NULL, NULL, 4),
(90802, NULL, 'G3DSA:3.40.50.2000:FF:000180', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(90803, NULL, 'G3DSA:3.70.10.10:FF:000132', NULL, NULL, 'Checkpoint protein hus1', NULL, NULL, NULL, NULL, NULL, 4),
(90804, NULL, 'G3DSA:3.30.565.10:FF:000219', NULL, NULL, 'Two-component sensor histidine kinase malate', NULL, NULL, NULL, NULL, NULL, 4),
(90805, NULL, 'G3DSA:3.40.630.30:FF:000600', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90806, NULL, 'G3DSA:3.30.60.300:FF:000001', NULL, NULL, '60S ribosomal protein L10', NULL, NULL, NULL, NULL, NULL, 4),
(90807, NULL, 'G3DSA:3.40.50.300:FF:008293', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90808, NULL, 'G3DSA:3.40.50.620:FF:000694', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90809, NULL, 'G3DSA:3.30.70.330:FF:000231', NULL, NULL, 'Cleavage and polyadenylation specificity factor subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(90810, NULL, 'G3DSA:3.30.160.60:FF:005763', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90811, NULL, 'G3DSA:3.30.420.40:FF:000207', NULL, NULL, 'Type II pantothenate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(90812, NULL, 'G3DSA:1.20.5.110:FF:000047', NULL, NULL, 'Vesicle-associated membrane protein 727', NULL, NULL, NULL, NULL, NULL, 4),
(90813, NULL, 'G3DSA:1.10.472.10:FF:000510', NULL, NULL, 'Putative cyclin-T1-1', NULL, NULL, NULL, NULL, NULL, 4),
(90814, NULL, 'G3DSA:2.40.10.10:FF:000416', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90815, NULL, 'G3DSA:2.60.120.970:FF:000007', NULL, NULL, 'Inhibin beta A chain', NULL, NULL, NULL, NULL, NULL, 4),
(90816, NULL, 'G3DSA:3.40.50.300:FF:004370', NULL, NULL, 'Elongator complex protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(90817, NULL, 'G3DSA:1.20.140.100:FF:000053', NULL, NULL, 'Dynein heavy chain 9', NULL, NULL, NULL, NULL, NULL, 4),
(90818, NULL, 'G3DSA:3.40.50.300:FF:004128', NULL, NULL, 'AAA ATPase central domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(90819, NULL, 'G3DSA:2.40.70.10:FF:000364', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90820, NULL, 'G3DSA:3.30.530.20:FF:000030', NULL, NULL, 'Pathogenesis-related protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(90821, NULL, 'G3DSA:2.60.40.10:FF:005021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90822, NULL, 'G3DSA:3.40.50.10810:FF:000129', NULL, NULL, 'SWF/SNF family helicase', NULL, NULL, NULL, NULL, NULL, 4),
(90823, NULL, 'G3DSA:3.40.50.150:FF:000502', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(90824, NULL, 'G3DSA:3.40.50.2300:FF:001074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90825, NULL, 'G3DSA:2.60.40.10:FF:000108', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(90826, NULL, 'G3DSA:1.10.418.10:FF:000014', NULL, NULL, 'Plastin-3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(90827, NULL, 'G3DSA:1.10.238.10:FF:000247', NULL, NULL, 'Calcium-dependent protein kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(90828, NULL, 'G3DSA:4.10.220.110:FF:000001', NULL, NULL, 'VgrG1', NULL, NULL, NULL, NULL, NULL, 4),
(90829, NULL, 'G3DSA:3.40.50.12160:FF:000028', NULL, NULL, 'tRNA 2-methylthioadenosine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(90830, NULL, 'G3DSA:3.30.2130.30:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90831, NULL, 'G3DSA:3.10.180.10:FF:000021', NULL, NULL, '1,2-dihydroxynaphthalene dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(90832, NULL, 'G3DSA:1.20.1280.50:FF:000062', NULL, NULL, 'F-box/WD repeat-containing protein 9 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(90833, NULL, 'G3DSA:2.10.25.10:FF:001233', NULL, NULL, 'GD23943', NULL, NULL, NULL, NULL, NULL, 4),
(90834, NULL, 'G3DSA:2.10.25.10:FF:001609', NULL, NULL, 'Mucin glycoprotein MUC3', NULL, NULL, NULL, NULL, NULL, 4),
(90835, NULL, 'G3DSA:3.90.79.20:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(90836, NULL, 'G3DSA:3.10.20.90:FF:000485', NULL, NULL, 'GM11949', NULL, NULL, NULL, NULL, NULL, 4),
(90837, NULL, 'G3DSA:3.30.450.140:FF:000001', NULL, NULL, 'Virulence sensor histidine kinase PhoQ', NULL, NULL, NULL, NULL, NULL, 4),
(90838, NULL, 'G3DSA:1.10.418.20:FF:000017', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(90839, NULL, 'G3DSA:2.130.10.10:FF:003638', NULL, NULL, 'WD repeat-containing protein 18-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(90840, NULL, 'G3DSA:2.60.40.10:FF:003599', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90841, NULL, 'G3DSA:3.40.930.10:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90842, NULL, 'G3DSA:2.10.25.10:FF:000744', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(90843, NULL, 'G3DSA:1.10.472.10:FF:000600', NULL, NULL, 'D type cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(90844, NULL, 'G3DSA:2.60.40.60:FF:000808', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90845, NULL, 'G3DSA:2.60.210.10:FF:000005', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 13', NULL, NULL, NULL, NULL, NULL, 4),
(90846, NULL, 'G3DSA:1.10.4080.10:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90847, NULL, 'G3DSA:1.20.120.550:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90848, NULL, 'G3DSA:2.40.40.10:FF:000008', NULL, NULL, 'Expansin', NULL, NULL, NULL, NULL, NULL, 4),
(90849, NULL, 'G3DSA:3.90.79.10:FF:000025', NULL, NULL, 'isopentenyl-diphosphate Delta-isomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(90850, NULL, 'G3DSA:2.130.10.10:FF:000204', NULL, NULL, 'WD repeat domain 11', NULL, NULL, NULL, NULL, NULL, 4),
(90851, NULL, 'G3DSA:1.10.10.60:FF:000463', NULL, NULL, 'RNA polymerase sigma-54 factor', NULL, NULL, NULL, NULL, NULL, 4),
(90852, NULL, 'G3DSA:3.30.70.100:FF:000128', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90853, NULL, 'G3DSA:1.10.10.2750:FF:000002', NULL, NULL, 'TBC1 domain family member 4', NULL, NULL, NULL, NULL, NULL, 4),
(90854, NULL, 'G3DSA:3.40.190.10:FF:000604', NULL, NULL, 'Glutamate ionotropic receptor kainate type subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(90855, NULL, 'G3DSA:1.20.120.1900:FF:000051', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(90856, NULL, 'G3DSA:2.60.40.10:FF:004532', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90857, NULL, 'G3DSA:3.80.10.10:FF:001065', NULL, NULL, 'Reticulon/nogo receptor', NULL, NULL, NULL, NULL, NULL, 4),
(90858, NULL, 'G3DSA:1.20.870.10:FF:000023', NULL, NULL, 'Drosophila SOS homolog', NULL, NULL, NULL, NULL, NULL, 4),
(90859, NULL, 'G3DSA:1.20.1640.10:FF:000027', NULL, NULL, 'Blast:Protein patched', NULL, NULL, NULL, NULL, NULL, 4),
(90860, NULL, 'G3DSA:2.40.10.10:FF:000506', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90861, NULL, 'G3DSA:3.30.450.150:FF:000004', NULL, NULL, 'UPF0303 protein YBR137W', NULL, NULL, NULL, NULL, NULL, 4),
(90862, NULL, 'G3DSA:1.25.40.10:FF:002064', NULL, NULL, 'probable UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SEC', NULL, NULL, NULL, NULL, NULL, 4),
(90863, NULL, 'G3DSA:1.10.8.270:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90864, NULL, 'G3DSA:3.40.50.300:FF:004280', NULL, NULL, 'Guanine nucleotide-binding protein (G protein), alpha-activating activity polypeptide, olfactory type 2', NULL, NULL, NULL, NULL, NULL, 4),
(90865, NULL, 'G3DSA:3.40.50.2020:FF:000039', NULL, NULL, 'Ribose-phosphate pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(90866, NULL, 'G3DSA:3.40.190.10:FF:000689', NULL, NULL, 'Lipoprotein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90867, NULL, 'G3DSA:1.10.472.140:FF:000007', NULL, NULL, 'GM24273', NULL, NULL, NULL, NULL, NULL, 4),
(90868, NULL, 'G3DSA:3.40.20.10:FF:000084', NULL, NULL, 'Drebrin 1', NULL, NULL, NULL, NULL, NULL, 4),
(90869, NULL, 'G3DSA:3.40.50.2300:FF:001635', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(90870, NULL, 'G3DSA:1.25.40.10:FF:001518', NULL, NULL, 'Heat shock protein STI1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90871, NULL, 'G3DSA:3.30.70.890:FF:000045', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(90872, NULL, 'G3DSA:2.130.10.10:FF:000474', NULL, NULL, 'Syntaxin binding protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(90873, NULL, 'G3DSA:2.120.10.30:FF:000531', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90874, NULL, 'G3DSA:3.40.50.720:FF:001533', NULL, NULL, 'Short-chain dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90875, NULL, 'G3DSA:3.30.60.30:FF:000064', NULL, NULL, 'Serine protease inhibitor dipetalogastin', NULL, NULL, NULL, NULL, NULL, 4),
(90876, NULL, 'G3DSA:1.10.510.10:FF:000818', NULL, NULL, 'Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(90877, NULL, 'G3DSA:3.30.300.230:FF:000001', NULL, NULL, 'Putative metallo-beta-lactamase', NULL, NULL, NULL, NULL, NULL, 4),
(90878, NULL, 'G3DSA:3.40.50.300:FF:000710', NULL, NULL, 'Cytoplasmic dynein 2 heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(90879, NULL, 'G3DSA:3.30.700.10:FF:000001', NULL, NULL, 'General secretion pathway protein G', NULL, NULL, NULL, NULL, NULL, 4),
(90880, NULL, 'G3DSA:1.10.760.10:FF:000011', NULL, NULL, 'Cytochrome c1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90881, NULL, 'G3DSA:2.10.25.10:FF:001048', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(90882, NULL, 'G3DSA:3.10.20.70:FF:000035', NULL, NULL, 'Glutamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(90883, NULL, 'G3DSA:3.30.720.10:FF:000002', NULL, NULL, 'signal recognition particle 14 kDa protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(90884, NULL, 'G3DSA:3.50.50.60:FF:001134', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(90885, NULL, 'G3DSA:3.30.160.60:FF:004037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90886, NULL, 'G3DSA:3.40.50.300:FF:000654', NULL, NULL, 'Small g-protein ras2', NULL, NULL, NULL, NULL, NULL, 4),
(90887, NULL, 'G3DSA:2.40.50.100:FF:000042', NULL, NULL, '50S ribosomal protein L27', NULL, NULL, NULL, NULL, NULL, 4),
(90888, NULL, 'G3DSA:3.30.420.270:FF:000023', NULL, NULL, 'TonB system transport protein ExbD', NULL, NULL, NULL, NULL, NULL, 4),
(90889, NULL, 'G3DSA:3.30.700.20:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90890, NULL, 'G3DSA:2.60.300.12:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90891, NULL, 'G3DSA:3.40.50.2020:FF:000096', NULL, NULL, 'Ribose-phosphate pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(90892, NULL, 'G3DSA:2.180.10.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90893, NULL, 'G3DSA:3.50.50.60:FF:000032', NULL, NULL, 'D-amino acid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(90894, NULL, 'G3DSA:2.60.40.10:FF:000816', NULL, NULL, 'collagen alpha-1(XII) chain isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(90895, NULL, 'G3DSA:3.40.30.10:FF:000904', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90896, NULL, 'G3DSA:3.40.720.10:FF:000096', NULL, NULL, 'AGAP004721-PA', NULL, NULL, NULL, NULL, NULL, 4),
(90897, NULL, 'G3DSA:1.25.40.10:FF:002300', NULL, NULL, 'Tetratricopeptide repeat protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(90898, NULL, 'G3DSA:3.30.420.10:FF:000159', NULL, NULL, 'Ribonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90899, NULL, 'G3DSA:3.10.20.30:FF:000074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90900, NULL, 'G3DSA:2.60.120.1540:FF:000009', NULL, NULL, 'Thioester-containing protein 4, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(90901, NULL, 'G3DSA:2.130.10.10:FF:003493', NULL, NULL, 'Intraflagellar transport protein 172', NULL, NULL, NULL, NULL, NULL, 4),
(90902, NULL, 'G3DSA:3.40.50.300:FF:004454', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90903, NULL, 'G3DSA:3.30.40.10:FF:000107', NULL, NULL, 'pygopus homolog 1', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(90904, NULL, 'G3DSA:3.40.50.720:FF:001264', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(90905, NULL, 'G3DSA:3.40.720.10:FF:000152', NULL, NULL, 'Lipid A phosphoethanolamine transferase', NULL, NULL, NULL, NULL, NULL, 4),
(90906, NULL, 'G3DSA:3.30.40.10:FF:001743', NULL, NULL, 'YALI0E30547p', NULL, NULL, NULL, NULL, NULL, 4),
(90907, NULL, 'G3DSA:1.25.40.120:FF:000018', NULL, NULL, 'Protein farnesyltransferase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(90908, NULL, 'G3DSA:2.130.10.10:FF:003964', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit TRM82', NULL, NULL, NULL, NULL, NULL, 4),
(90909, NULL, 'G3DSA:1.10.287.40:FF:000010', NULL, NULL, 'Probable serine-tRNA ligase, cytosolic', NULL, NULL, NULL, NULL, NULL, 4),
(90910, NULL, 'G3DSA:2.60.40.790:FF:000124', NULL, NULL, 'GM15349', NULL, NULL, NULL, NULL, NULL, 4),
(90911, NULL, 'G3DSA:3.60.40.10:FF:000275', NULL, NULL, 'Protein serine/threonine phosphatase PrpC, regulation of stationary phase', NULL, NULL, NULL, NULL, NULL, 4),
(90912, NULL, 'G3DSA:3.30.70.330:FF:002232', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90913, NULL, 'G3DSA:2.10.25.10:FF:001525', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(90914, NULL, 'G3DSA:1.25.10.10:FF:002152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90915, NULL, 'G3DSA:1.25.10.10:FF:001747', NULL, NULL, 'Condensin subunit 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90916, NULL, 'G3DSA:1.20.58.70:FF:000031', NULL, NULL, 'Syntaxin-32', NULL, NULL, NULL, NULL, NULL, 4),
(90917, NULL, 'G3DSA:2.40.420.20:FF:000063', NULL, NULL, 'Acriflavine resistance protein A [Precursor]', NULL, NULL, NULL, NULL, NULL, 4),
(90918, NULL, 'G3DSA:3.30.2020.30:FF:000016', NULL, NULL, 'Trimethyllysine hydroxylase, epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(90919, NULL, 'G3DSA:3.50.30.30:FF:000073', NULL, NULL, 'Zinc finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90920, NULL, 'G3DSA:3.60.21.10:FF:000057', NULL, NULL, 'Acid sphingomyelinase-like phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(90921, NULL, 'G3DSA:3.40.630.10:FF:000066', NULL, NULL, 'M28 family peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(90922, NULL, 'G3DSA:2.10.25.10:FF:001054', NULL, NULL, 'Wall-associated receptor kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(90923, NULL, 'G3DSA:1.10.8.60:FF:000389', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(90924, NULL, 'G3DSA:1.10.1520.10:FF:000088', NULL, NULL, 'Dicer-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(90925, NULL, 'G3DSA:3.90.190.10:FF:000554', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90926, NULL, 'G3DSA:1.25.40.10:FF:003699', NULL, NULL, 'Os05g0534900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(90927, NULL, 'G3DSA:2.30.130.10:FF:000039', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(90928, NULL, 'G3DSA:3.40.120.10:FF:000038', NULL, NULL, 'Phosphoacetylglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(90929, NULL, 'G3DSA:1.25.40.70:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90930, NULL, 'G3DSA:1.10.238.10:FF:001259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90931, NULL, 'G3DSA:3.30.70.980:FF:000015', NULL, NULL, 'Probable transcriptional regulatory protein LEP1GSC115_2457', NULL, NULL, NULL, NULL, NULL, 4),
(90932, NULL, 'G3DSA:2.30.29.30:FF:001135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90933, NULL, 'G3DSA:2.60.120.560:FF:000013', NULL, NULL, 'Levanase', NULL, NULL, NULL, NULL, NULL, 4),
(90934, NULL, 'G3DSA:3.40.33.10:FF:000147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90935, NULL, 'G3DSA:3.30.200.20:FF:000331', NULL, NULL, 'Calcium/calmodulin-dependent protein kinase type 1G', NULL, NULL, NULL, NULL, NULL, 4),
(90936, NULL, 'G3DSA:3.90.950.20:FF:000003', NULL, NULL, 'Os01g0691500 protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(90937, NULL, 'G3DSA:3.10.20.30:FF:000017', NULL, NULL, '39S ribosomal protein L39, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(90938, NULL, 'G3DSA:3.40.50.620:FF:000688', NULL, NULL, 'tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90939, NULL, 'G3DSA:3.30.800.10:FF:000003', NULL, NULL, 'Phosphatidylinositol 4-phosphate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(90940, NULL, 'G3DSA:2.170.120.20:FF:000003', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(90941, NULL, 'G3DSA:3.40.50.150:FF:000412', NULL, NULL, 'mRNA cap guanine-N7 methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(90942, NULL, 'G3DSA:1.20.1250.20:FF:001821', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90943, NULL, 'G3DSA:1.10.220.20:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90944, NULL, 'G3DSA:3.80.10.10:FF:000699', NULL, NULL, 'Leucine rich repeat containing 23', NULL, NULL, NULL, NULL, NULL, 4),
(90945, NULL, 'G3DSA:2.170.120.30:FF:000006', NULL, NULL, 'YbbR-like domain-containing protein YbbR', NULL, NULL, NULL, NULL, NULL, 4),
(90946, NULL, 'G3DSA:3.90.1720.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90947, NULL, 'G3DSA:3.30.160.60:FF:005673', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90948, NULL, 'G3DSA:2.30.30.40:FF:000045', NULL, NULL, 'Short stop, isoform K', NULL, NULL, NULL, NULL, NULL, 4),
(90949, NULL, 'G3DSA:1.10.220.10:FF:000010', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(90950, NULL, 'G3DSA:1.20.1250.20:FF:001534', NULL, NULL, 'Facilitated trehalose transporter Tret1', NULL, NULL, NULL, NULL, NULL, 4),
(90951, NULL, 'G3DSA:1.10.30.10:FF:000056', NULL, NULL, 'Brahma-associated protein 111kD', NULL, NULL, NULL, NULL, NULL, 4),
(90952, NULL, 'G3DSA:3.30.2390.20:FF:000001', NULL, NULL, 'ESX-1 secretion system ATPase EccB1', NULL, NULL, NULL, NULL, NULL, 4),
(90953, NULL, 'G3DSA:3.30.70.330:FF:001866', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90954, NULL, 'G3DSA:1.10.510.10:FF:004416', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90955, NULL, 'G3DSA:2.10.25.10:FF:001380', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90956, NULL, 'G3DSA:2.30.30.30:FF:000042', NULL, NULL, '50S ribosomal protein L24', NULL, NULL, NULL, NULL, NULL, 4),
(90957, NULL, 'G3DSA:3.40.640.10:FF:000038', NULL, NULL, 'Cystathionine gamma-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(90958, NULL, 'G3DSA:3.30.505.10:FF:000244', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90959, NULL, 'G3DSA:3.30.70.80:FF:000057', NULL, NULL, 'Os08g0452100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(90960, NULL, 'G3DSA:2.60.40.10:FF:000081', NULL, NULL, 'Myosin-binding protein C, slow type', NULL, NULL, NULL, NULL, NULL, 4),
(90961, NULL, 'G3DSA:1.10.20.10:FF:000027', NULL, NULL, 'Nuclear transcription factor Y subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(90962, NULL, 'G3DSA:3.40.50.1000:FF:000357', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90963, NULL, 'G3DSA:2.130.10.10:FF:001840', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(90964, NULL, 'G3DSA:3.40.50.450:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90965, NULL, 'G3DSA:2.70.170.10:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90966, NULL, 'G3DSA:3.40.50.1580:FF:000042', NULL, NULL, 'Purine nucleoside phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(90967, NULL, 'G3DSA:3.40.50.300:FF:006640', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90968, NULL, 'G3DSA:2.10.60.10:FF:000078', NULL, NULL, 'Serine/threonine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(90969, NULL, 'G3DSA:1.25.40.850:FF:000001', NULL, NULL, 'vacuolar protein sorting-associated protein 33B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(90970, NULL, 'G3DSA:1.25.40.10:FF:003284', NULL, NULL, 'Probable pre-mRNA splicing factor prp1', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(90971, NULL, 'G3DSA:1.20.58.390:FF:000119', NULL, NULL, 'AcetylCholine Receptor', NULL, NULL, NULL, NULL, NULL, 4),
(90972, NULL, 'G3DSA:1.10.8.60:FF:000445', NULL, NULL, 'Filamentation temperature-sensitive H 2A isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(90973, NULL, 'G3DSA:3.30.420.40:FF:000651', NULL, NULL, 'Actin-related protein Arp5', NULL, NULL, NULL, NULL, NULL, 4),
(90974, NULL, 'G3DSA:1.10.510.10:FF:002527', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90975, NULL, 'G3DSA:1.10.1200.120:FF:000006', NULL, NULL, 'Large-conductance mechanosensitive channel', NULL, NULL, NULL, NULL, NULL, 4),
(90976, NULL, 'G3DSA:3.90.550.10:FF:000273', NULL, NULL, 'Chitin synthase 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90977, NULL, 'G3DSA:1.10.405.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90978, NULL, 'G3DSA:2.60.34.10:FF:000021', NULL, NULL, 'Heat shock cognate protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(90979, NULL, 'G3DSA:3.30.160.60:FF:000294', NULL, NULL, 'Odd-skipped-related transciption factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(90980, NULL, 'G3DSA:1.25.10.10:FF:000437', NULL, NULL, 'Ribosomal RNA processing 12 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(90981, NULL, 'G3DSA:1.10.510.10:FF:002056', NULL, NULL, 'NIMA-related kinase 6', NULL, NULL, NULL, NULL, NULL, 4),
(90982, NULL, 'G3DSA:2.60.120.10:FF:000830', NULL, NULL, 'Nitrogen regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(90983, NULL, 'G3DSA:3.40.50.1440:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90984, NULL, 'G3DSA:3.90.550.50:FF:000234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90985, NULL, 'G3DSA:2.60.40.10:FF:004240', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90986, NULL, 'G3DSA:1.10.1070.11:FF:000054', NULL, NULL, 'serine/threonine-protein kinase ATM', NULL, NULL, NULL, NULL, NULL, 4),
(90987, NULL, 'G3DSA:2.120.10.80:FF:000091', NULL, NULL, 'host cell factor 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(90988, NULL, 'G3DSA:2.60.40.10:FF:004296', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(90989, NULL, 'G3DSA:3.40.50.1100:FF:000185', NULL, NULL, 'Pyridoxal-phosphate dependent enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(90990, NULL, 'G3DSA:3.10.100.10:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90991, NULL, 'G3DSA:3.40.50.410:FF:000069', NULL, NULL, 'von Willebrand factor A domain containing 5A', NULL, NULL, NULL, NULL, NULL, 4),
(90992, NULL, 'G3DSA:1.10.3860.10:FF:000018', NULL, NULL, 'Sodium:dicarboxylate symport protein', NULL, NULL, NULL, NULL, NULL, 4),
(90993, NULL, 'G3DSA:3.40.50.300:FF:001020', NULL, NULL, 'Nickel import ATP-binding protein NikE', NULL, NULL, NULL, NULL, NULL, 4),
(90994, NULL, 'G3DSA:1.20.85.10:FF:000002', NULL, NULL, 'Photosystem II protein D1', NULL, NULL, NULL, NULL, NULL, 4),
(90995, NULL, 'G3DSA:3.40.50.2000:FF:000938', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(90996, NULL, 'G3DSA:3.40.1110.10:FF:000178', NULL, NULL, 'Heavy metal translocatin', NULL, NULL, NULL, NULL, NULL, 4),
(90997, NULL, 'G3DSA:3.30.390.170:FF:000001', NULL, NULL, 'Envelope glycoprotein L', NULL, NULL, NULL, NULL, NULL, 4),
(90998, NULL, 'G3DSA:3.50.50.60:FF:001336', NULL, NULL, 'Protein CBG18665', NULL, NULL, NULL, NULL, NULL, 4),
(90999, NULL, 'G3DSA:2.130.10.10:FF:000148', NULL, NULL, 'probable E3 ubiquitin-protein ligase HERC1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(91000, NULL, 'G3DSA:2.60.200.30:FF:000039', NULL, NULL, 'NAD kinase b', NULL, NULL, NULL, NULL, NULL, 4),
(91001, NULL, 'G3DSA:2.60.260.20:FF:000051', NULL, NULL, 'Mdj1p', NULL, NULL, NULL, NULL, NULL, 4),
(91002, NULL, 'G3DSA:2.40.70.10:FF:000072', NULL, NULL, 'DNA damage-inducible protein', NULL, NULL, NULL, NULL, NULL, 4),
(91003, NULL, 'G3DSA:2.60.40.60:FF:000045', NULL, NULL, 'Cadherin 2', NULL, NULL, NULL, NULL, NULL, 4),
(91004, NULL, 'G3DSA:3.30.160.60:FF:002183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(91005, NULL, 'G3DSA:2.130.10.10:FF:005527', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91006, NULL, 'G3DSA:3.30.200.20:FF:001910', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91007, NULL, 'G3DSA:2.60.40.60:FF:000573', NULL, NULL, 'Cadherin 10', NULL, NULL, NULL, NULL, NULL, 4),
(91008, NULL, 'G3DSA:2.60.120.260:FF:000513', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(91009, NULL, 'G3DSA:2.70.150.10:FF:000043', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(91010, NULL, 'G3DSA:3.40.50.720:FF:001207', NULL, NULL, 'Probable short-chain dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(91011, NULL, 'G3DSA:3.90.470.20:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91012, NULL, 'G3DSA:1.20.58.390:FF:000271', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91013, NULL, 'G3DSA:2.20.70.10:FF:000202', NULL, NULL, 'mRNA cap guanine-N7 methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(91014, NULL, 'G3DSA:3.40.50.620:FF:000868', NULL, NULL, 'Protein CBR-LARS-2', NULL, NULL, NULL, NULL, NULL, 4),
(91015, NULL, 'G3DSA:4.10.1240.50:FF:000008', NULL, NULL, 'REST corepressor 3', NULL, NULL, NULL, NULL, NULL, 4),
(91016, NULL, 'G3DSA:1.20.1270.60:FF:000148', NULL, NULL, 'Unplaced genomic scaffold supercont1.21, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(91017, NULL, 'G3DSA:2.60.40.60:FF:000516', NULL, NULL, 'CaDHerin family', NULL, NULL, NULL, NULL, NULL, 4),
(91018, NULL, 'G3DSA:3.30.160.60:FF:000092', NULL, NULL, 'Early growth response protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(91019, NULL, 'G3DSA:2.10.70.10:FF:000287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91020, NULL, 'G3DSA:3.40.1050.10:FF:000032', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(91021, NULL, 'G3DSA:3.40.50.720:FF:001735', NULL, NULL, 'Zgc:172341', NULL, NULL, NULL, NULL, NULL, 4),
(91022, NULL, 'G3DSA:2.60.200.20:FF:000036', NULL, NULL, 'Ras interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(91023, NULL, 'G3DSA:3.40.140.10:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91024, NULL, 'G3DSA:2.70.130.10:FF:000098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91025, NULL, 'G3DSA:1.20.1560.10:FF:000375', NULL, NULL, 'Os04g0620066 protein', NULL, NULL, NULL, NULL, NULL, 4),
(91026, NULL, 'G3DSA:2.60.200.10:FF:000033', NULL, NULL, 'Interferon regulatory factor like protein', NULL, NULL, NULL, NULL, NULL, 4),
(91027, NULL, 'G3DSA:3.30.9.10:FF:000198', NULL, NULL, 'D-amino acid dehydrogenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(91028, NULL, 'G3DSA:2.10.260.10:FF:000003', NULL, NULL, 'Putative regulator PrlF', NULL, NULL, NULL, NULL, NULL, 4),
(91029, NULL, 'G3DSA:3.40.50.300:FF:000856', NULL, NULL, 'AFG1-like ATPase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(91030, NULL, 'G3DSA:3.30.160.60:FF:003110', NULL, NULL, 'Draculin-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(91031, NULL, 'G3DSA:3.90.1100.10:FF:000031', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(91032, NULL, 'G3DSA:3.40.30.10:FF:001253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91033, NULL, 'G3DSA:3.30.70.330:FF:001451', NULL, NULL, 'Protein CBR-FUST-1', NULL, NULL, NULL, NULL, NULL, 4),
(91034, NULL, 'G3DSA:2.130.10.10:FF:000620', NULL, NULL, 'cilia- and flagella-associated protein 52 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(91035, NULL, 'G3DSA:2.60.120.1000:FF:000022', NULL, NULL, 'Col1a1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(91036, NULL, 'G3DSA:1.10.132.10:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91037, NULL, 'G3DSA:1.10.555.10:FF:000080', NULL, NULL, 'Similar to GTPase-activating protein testicular GAP1', NULL, NULL, NULL, NULL, NULL, 4),
(91038, NULL, 'G3DSA:2.40.30.270:FF:000010', NULL, NULL, 'DNA2-like helicase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(91039, NULL, 'G3DSA:3.80.10.10:FF:001481', NULL, NULL, 'EIN3-binding F-box protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(91040, NULL, 'G3DSA:3.40.640.10:FF:000151', NULL, NULL, 'Adenosylmethionine-8-amino-7-oxononanoate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(91041, NULL, 'G3DSA:3.30.420.40:FF:000180', NULL, NULL, 'D-ribulose kinase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(91042, NULL, 'G3DSA:3.40.50.10190:FF:000168', NULL, NULL, 'BRCA1 C Terminus (BRCT) domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91043, NULL, 'G3DSA:3.90.1140.10:FF:000011', NULL, NULL, 'AKAP7 2''5'' RNA ligase-like domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(91044, NULL, 'G3DSA:3.40.50.2300:FF:001276', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91045, NULL, 'G3DSA:3.40.710.10:FF:000067', NULL, NULL, 'Peptidoglycan D,D-transpeptidase MrdA', NULL, NULL, NULL, NULL, NULL, 4),
(91046, NULL, 'G3DSA:3.40.190.10:FF:000312', NULL, NULL, 'Ionotropic receptor 41a', NULL, NULL, NULL, NULL, NULL, 4),
(91047, NULL, 'G3DSA:1.10.10.820:FF:000018', NULL, NULL, 'Myosin C', NULL, NULL, NULL, NULL, NULL, 4),
(91048, NULL, 'G3DSA:3.40.50.300:FF:007888', NULL, NULL, 'ABC transporter, transmembrane ATP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91049, NULL, 'G3DSA:2.60.40.10:FF:003745', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91050, NULL, 'G3DSA:2.130.10.10:FF:001784', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91051, NULL, 'G3DSA:3.10.10.20:FF:000003', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(91052, NULL, 'G3DSA:1.20.1270.370:FF:000001', NULL, NULL, 'Putative 2-hydroxyglutaryl-CoA dehydratase, D-component', NULL, NULL, NULL, NULL, NULL, 4),
(91053, NULL, 'G3DSA:1.10.167.10:FF:000048', NULL, NULL, 'Regulator of G-protein signaling rgs-3', NULL, NULL, NULL, NULL, NULL, 4),
(91054, NULL, 'G3DSA:2.40.160.120:FF:000001', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(91055, NULL, 'G3DSA:1.10.8.10:FF:000127', NULL, NULL, 'E3 ubiquitin-protein ligase AMFR', NULL, NULL, NULL, NULL, NULL, 4),
(91056, NULL, 'G3DSA:2.30.29.30:FF:000882', NULL, NULL, 'switch-associated protein 70-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(91057, NULL, 'G3DSA:3.30.160.60:FF:002800', NULL, NULL, 'Zinc finger protein 792', NULL, NULL, NULL, NULL, NULL, 4),
(91058, NULL, 'G3DSA:3.20.20.70:FF:000861', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91059, NULL, 'G3DSA:3.40.50.300:FF:002801', NULL, NULL, 'Protein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(91060, NULL, 'G3DSA:2.60.40.60:FF:000606', NULL, NULL, 'Si:dkey-30k22.7', NULL, NULL, NULL, NULL, NULL, 4),
(91061, NULL, 'G3DSA:3.20.20.70:FF:000804', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91062, NULL, 'G3DSA:3.40.50.10380:FF:000017', NULL, NULL, 'Malate dehydrogenase:SUBUNIT=A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91063, NULL, 'G3DSA:1.25.40.10:FF:001991', NULL, NULL, 'TPR domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(91064, NULL, 'G3DSA:3.10.20.90:FF:000193', NULL, NULL, 'Polycomb group RING finger protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(91065, NULL, 'G3DSA:3.30.200.20:FF:000218', NULL, NULL, 'Tyrosine-protein kinase RYK', NULL, NULL, NULL, NULL, NULL, 4),
(91066, NULL, 'G3DSA:3.10.450.10:FF:000031', NULL, NULL, 'Histidine-rich glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(91067, NULL, 'G3DSA:1.20.1560.10:FF:000936', NULL, NULL, 'AFR432Wp', NULL, NULL, NULL, NULL, NULL, 4),
(91068, NULL, 'G3DSA:1.10.287.160:FF:000001', NULL, NULL, 'Putative serine/threonine-protein kinase N2', NULL, NULL, NULL, NULL, NULL, 4),
(91069, NULL, 'G3DSA:2.70.130.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91070, NULL, 'G3DSA:2.60.40.150:FF:000022', NULL, NULL, 'Dedicator of cytokinesis protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(91071, NULL, 'G3DSA:1.10.287.1490:FF:000086', NULL, NULL, 'CENP-meta, isoform D', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(91072, NULL, 'G3DSA:2.60.120.200:FF:000479', NULL, NULL, 'Thrombospondin 4', NULL, NULL, NULL, NULL, NULL, 4),
(91073, NULL, 'G3DSA:3.80.10.10:FF:003515', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91074, NULL, 'G3DSA:3.20.20.140:FF:000228', NULL, NULL, 'Deoxyribonuclease YcfH', NULL, NULL, NULL, NULL, NULL, 4),
(91075, NULL, 'G3DSA:3.20.20.80:FF:000807', NULL, NULL, 'AGAP005337-PA', NULL, NULL, NULL, NULL, NULL, 4),
(91076, NULL, 'G3DSA:2.10.25.10:FF:000918', NULL, NULL, 'Eater', NULL, NULL, NULL, NULL, NULL, 4),
(91077, NULL, 'G3DSA:3.40.50.2300:FF:001219', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91078, NULL, 'G3DSA:3.40.50.300:FF:001874', NULL, NULL, 'GTP binding protein (EngB), putative', NULL, NULL, NULL, NULL, NULL, 4),
(91079, NULL, 'G3DSA:3.40.50.150:FF:000356', NULL, NULL, 'tRNA m5C-methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91080, NULL, 'G3DSA:1.10.510.10:FF:004236', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91081, NULL, 'G3DSA:2.60.40.1180:FF:000216', NULL, NULL, 'Alpha-xylosidase BoGH31A', NULL, NULL, NULL, NULL, NULL, 4),
(91082, NULL, 'G3DSA:3.30.830.10:FF:000246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91083, NULL, 'G3DSA:2.40.10.10:FF:000001', NULL, NULL, 'Periplasmic serine protease DegS', NULL, NULL, NULL, NULL, NULL, 4),
(91084, NULL, 'G3DSA:3.40.50.720:FF:000898', NULL, NULL, 'YDL144Cp protein', NULL, NULL, NULL, NULL, NULL, 4),
(91085, NULL, 'G3DSA:1.10.150.50:FF:000089', NULL, NULL, 'Ankyrin repeat, SAM and basic leucine zipper domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(91086, NULL, 'G3DSA:2.120.10.80:FF:000321', NULL, NULL, 'Lztr-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91087, NULL, 'G3DSA:2.130.10.10:FF:002711', NULL, NULL, 'UTP15 C terminal-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(91088, NULL, 'G3DSA:2.10.230.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91089, NULL, 'G3DSA:3.80.10.10:FF:001424', NULL, NULL, 'Dynein regulatory complex subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(91090, NULL, 'G3DSA:1.10.555.10:FF:000169', NULL, NULL, 'Probable inactive serine/threonine-protein kinase roco10', NULL, NULL, NULL, NULL, NULL, 4),
(91091, NULL, 'G3DSA:1.20.1280.50:FF:000207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91092, NULL, 'G3DSA:3.10.100.10:FF:000044', NULL, NULL, 'CD209 antigen, isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(91093, NULL, 'G3DSA:2.60.120.920:FF:000077', NULL, NULL, 'Tripartite motif containing 75, pseudogene', NULL, NULL, NULL, NULL, NULL, 4),
(91094, NULL, 'G3DSA:3.30.40.10:FF:001035', NULL, NULL, 'Polycomblike, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(91095, NULL, 'G3DSA:3.30.470.30:FF:000033', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(91096, NULL, 'G3DSA:1.10.1170.10:FF:000021', NULL, NULL, 'Bir1p', NULL, NULL, NULL, NULL, NULL, 4),
(91097, NULL, 'G3DSA:3.20.20.70:FF:000097', NULL, NULL, 'Glutamate synthase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(91098, NULL, 'G3DSA:3.40.50.300:FF:002094', NULL, NULL, 'Structural maintenance of chromosomes protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(91099, NULL, 'G3DSA:1.10.10.10:FF:001893', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91100, NULL, 'G3DSA:3.40.605.10:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91101, NULL, 'G3DSA:2.40.70.10:FF:000162', NULL, NULL, 'Aspartic proteinase nepenthesin-1', NULL, NULL, NULL, NULL, NULL, 4),
(91102, NULL, 'G3DSA:3.20.20.70:FF:000153', NULL, NULL, '4-hydroxy-2-oxoglutarate aldolase, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(91103, NULL, 'G3DSA:3.30.310.130:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91104, NULL, 'G3DSA:1.10.472.10:FF:000364', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91105, NULL, 'G3DSA:1.25.40.240:FF:000003', NULL, NULL, 'Endonuclease G inhibitor, isoform A', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(91106, NULL, 'G3DSA:2.60.120.200:FF:000102', NULL, NULL, 'Laminin subunit alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(91107, NULL, 'G3DSA:2.60.120.920:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91108, NULL, 'G3DSA:2.130.10.10:FF:002621', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91109, NULL, 'G3DSA:2.60.120.10:FF:000740', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91110, NULL, 'G3DSA:3.40.30.10:FF:000197', NULL, NULL, 'Glutathione S-transferase U10', NULL, NULL, NULL, NULL, NULL, 4),
(91111, NULL, 'G3DSA:3.30.300.110:FF:000016', NULL, NULL, 'tRNA (Guanine(37)-N(1))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(91112, NULL, 'G3DSA:2.60.120.10:FF:000684', NULL, NULL, 'Predicted gene, 28042', NULL, NULL, NULL, NULL, NULL, 4),
(91113, NULL, 'G3DSA:2.60.40.10:FF:006038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91114, NULL, 'G3DSA:2.170.150.10:FF:000002', NULL, NULL, 'Translationally-controlled tumor protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(91115, NULL, 'G3DSA:1.20.1070.10:FF:001490', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91116, NULL, 'G3DSA:3.30.1360.120:FF:000018', NULL, NULL, 'Aminomethyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(91117, NULL, 'G3DSA:1.25.40.10:FF:004008', NULL, NULL, 'Mitosis inhibitor nif1', NULL, NULL, NULL, NULL, NULL, 4),
(91118, NULL, 'G3DSA:2.60.40.1730:FF:000044', NULL, NULL, 'Peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(91119, NULL, 'G3DSA:1.10.510.10:FF:003545', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91120, NULL, 'G3DSA:2.20.90.10:FF:000001', NULL, NULL, 'Vitellogenin 7', NULL, NULL, NULL, NULL, NULL, 4),
(91121, NULL, 'G3DSA:3.10.330.20:FF:000002', NULL, NULL, 'tRNA (adenine(58)-N(1))-methyltransferase catalytic subunit TRMT61A', NULL, NULL, NULL, NULL, NULL, 4),
(91122, NULL, 'G3DSA:3.40.50.12390:FF:000007', NULL, NULL, 'XRN_5''-3''_exonuclease_N-terminus_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(91123, NULL, 'G3DSA:1.20.58.2220:FF:000015', NULL, NULL, 'Diaphanous, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(91124, NULL, 'G3DSA:1.20.1250.20:FF:000894', NULL, NULL, 'Multidrug MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(91125, NULL, 'G3DSA:1.20.1070.10:FF:001343', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91126, NULL, 'G3DSA:1.25.40.10:FF:000265', NULL, NULL, 'Bardet-Biedl syndrome 4 (Human)', NULL, NULL, NULL, NULL, NULL, 4),
(91127, NULL, 'G3DSA:3.30.590.10:FF:000002', NULL, NULL, 'Creatine kinase S-type, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(91128, NULL, 'G3DSA:2.30.29.30:FF:000792', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(91129, NULL, 'G3DSA:3.20.20.220:FF:000050', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(91130, NULL, 'G3DSA:2.170.150.20:FF:000005', NULL, NULL, 'Blast:Protein cereblon homolog', NULL, NULL, NULL, NULL, NULL, 4),
(91131, NULL, 'G3DSA:2.60.40.10:FF:002351', NULL, NULL, 'Interleukin 13 receptor, alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(91132, NULL, 'G3DSA:3.40.190.10:FF:000402', NULL, NULL, 'ABC transporter, periplasmic substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(91133, NULL, 'G3DSA:2.10.110.10:FF:000054', NULL, NULL, 'Cysteine-rich protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(91134, NULL, 'G3DSA:2.120.10.80:FF:000411', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91135, NULL, 'G3DSA:3.10.50.40:FF:000135', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(91136, NULL, 'G3DSA:3.10.28.10:FF:000001', NULL, NULL, 'Probable cell division protein WhiA', NULL, NULL, NULL, NULL, NULL, 4),
(91137, NULL, 'G3DSA:3.40.50.1820:FF:001233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91138, NULL, 'G3DSA:1.10.287.110:FF:000121', NULL, NULL, 'Homeobox-containing protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(91139, NULL, 'G3DSA:3.40.50.10260:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91140, NULL, 'G3DSA:1.25.40.20:FF:000268', NULL, NULL, 'Espin like', NULL, NULL, NULL, NULL, NULL, 4),
(91141, NULL, 'G3DSA:3.20.20.60:FF:000150', NULL, NULL, 'Os01g0225400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(91142, NULL, 'G3DSA:2.10.70.10:FF:000141', NULL, NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(91143, NULL, 'G3DSA:1.25.40.250:FF:000006', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit K', NULL, NULL, NULL, NULL, NULL, 4),
(91144, NULL, 'G3DSA:3.20.20.70:FF:000568', NULL, NULL, 'Inosine-5''-monophosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(91145, NULL, 'G3DSA:3.80.10.10:FF:000929', NULL, NULL, 'AIR9 protein', NULL, NULL, NULL, NULL, NULL, 4),
(91146, NULL, 'G3DSA:3.30.160.60:FF:000614', NULL, NULL, 'Zinc finger protein 142', NULL, NULL, NULL, NULL, NULL, 4),
(91147, NULL, 'G3DSA:1.25.40.20:FF:000414', NULL, NULL, 'E3 ubiquitin-protein ligase XB3', NULL, NULL, NULL, NULL, NULL, 4),
(91148, NULL, 'G3DSA:2.160.10.10:FF:000023', NULL, NULL, 'Mannose-1-phosphate guanyltransferase alpha (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(91149, NULL, 'G3DSA:3.80.10.10:FF:003335', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(91150, NULL, 'G3DSA:2.20.28.230:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91151, NULL, 'G3DSA:2.60.40.10:FF:006095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91152, NULL, 'G3DSA:3.80.10.10:FF:003279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91153, NULL, 'G3DSA:3.40.50.300:FF:007944', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(91154, NULL, 'G3DSA:3.40.50.2300:FF:000202', NULL, NULL, 'Olfactory receptor family 13 subfamily C member 8', NULL, NULL, NULL, NULL, NULL, 4),
(91155, NULL, 'G3DSA:3.30.70.330:FF:001248', NULL, NULL, 'Musashi RNA-binding protein 2a', NULL, NULL, NULL, NULL, NULL, 4),
(91156, NULL, 'G3DSA:1.10.10.10:FF:001836', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(91157, NULL, 'G3DSA:3.30.40.10:FF:001092', NULL, NULL, 'PHD type transcription factor with transmembrane domain protein (PTM)', NULL, NULL, NULL, NULL, NULL, 4),
(91158, NULL, 'G3DSA:3.80.10.10:FF:004297', NULL, NULL, 'Leucine-rich repeats and immunoglobulin-like domains 3', NULL, NULL, NULL, NULL, NULL, 4),
(91159, NULL, 'G3DSA:3.30.530.20:FF:000176', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(91160, NULL, 'G3DSA:1.25.40.20:FF:000358', NULL, NULL, 'Oxysterol binding protein (Osh1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(91161, NULL, 'G3DSA:3.30.160.60:FF:002126', NULL, NULL, 'Si:dkey-7i4.21', NULL, NULL, NULL, NULL, NULL, 4),
(91162, NULL, 'G3DSA:3.40.50.1820:FF:000867', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91163, NULL, 'G3DSA:1.20.1270.60:FF:000238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91164, NULL, 'G3DSA:3.40.390.10:FF:000024', NULL, NULL, 'Matrix metallopeptidase 23B', NULL, NULL, NULL, NULL, NULL, 4),
(91165, NULL, 'G3DSA:1.25.40.180:FF:000339', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91166, NULL, 'G3DSA:3.30.590.20:FF:000005', NULL, NULL, 'Glutamate--cysteine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(91167, NULL, 'G3DSA:3.30.160.60:FF:002744', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91168, NULL, 'G3DSA:2.130.10.10:FF:004420', NULL, NULL, 'Actin-related protein 2/3 complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(91169, NULL, 'G3DSA:1.25.40.10:FF:003935', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(91170, NULL, 'G3DSA:1.10.8.60:FF:000299', NULL, NULL, '26S protease regulatory subunit 8', NULL, NULL, NULL, NULL, NULL, 4),
(91171, NULL, 'G3DSA:3.40.50.720:FF:000100', NULL, NULL, 'Glutamate dehydrogenase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(91172, NULL, 'G3DSA:2.60.40.1910:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(91173, NULL, 'G3DSA:3.30.70.3490:FF:000011', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(91174, NULL, 'G3DSA:3.30.450.20:FF:000698', NULL, NULL, 'Chemotaxis signal transduction system methyl accepting sensory transducer', NULL, NULL, NULL, NULL, NULL, 4),
(91175, NULL, 'G3DSA:3.30.70.330:FF:001361', NULL, NULL, 'RNA-binding protein rnp24', NULL, NULL, NULL, NULL, NULL, 4),
(91176, NULL, 'G3DSA:1.10.533.10:FF:000057', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 6', NULL, NULL, NULL, NULL, NULL, 4),
(91177, NULL, 'G3DSA:3.90.260.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91178, NULL, 'G3DSA:3.10.620.30:FF:000016', NULL, NULL, 'Putative exported protein', NULL, NULL, NULL, NULL, NULL, 4),
(91179, NULL, 'G3DSA:1.25.40.10:FF:003789', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(91180, NULL, 'G3DSA:1.10.442.10:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91181, NULL, 'G3DSA:3.30.360.10:FF:000047', NULL, NULL, 'Oxidoreductase, NAD-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(91182, NULL, 'G3DSA:3.90.640.10:FF:000100', NULL, NULL, 'Putative actin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(91183, NULL, 'G3DSA:3.40.50.300:FF:003583', NULL, NULL, 'Adenylate kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(91184, NULL, 'G3DSA:1.25.40.10:FF:000355', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(91185, NULL, 'G3DSA:3.30.310.10:FF:000044', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(91186, NULL, 'G3DSA:2.60.40.150:FF:000550', NULL, NULL, 'C2 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(91187, NULL, 'G3DSA:1.10.533.10:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91188, NULL, 'G3DSA:3.30.160.60:FF:006454', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91189, NULL, 'G3DSA:3.30.1360.10:FF:000024', NULL, NULL, 'DNA-directed RNA polymerase II subunit RPB3', NULL, NULL, NULL, NULL, NULL, 4),
(91190, NULL, 'G3DSA:3.30.40.10:FF:001125', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(91191, NULL, 'G3DSA:2.60.40.10:FF:001946', NULL, NULL, 'Antigen WC1.1', NULL, NULL, NULL, NULL, NULL, 4),
(91192, NULL, 'G3DSA:3.80.10.10:FF:002498', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(91193, NULL, 'G3DSA:3.10.20.90:FF:000900', NULL, NULL, 'UBX domain protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(91194, NULL, 'G3DSA:3.40.50.300:FF:003150', NULL, NULL, 'Replication factor C small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(91195, NULL, 'G3DSA:3.30.70.240:FF:000030', NULL, NULL, 'Elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(91196, NULL, 'G3DSA:3.30.505.10:FF:000098', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(91197, NULL, 'G3DSA:3.40.1170.10:FF:000007', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(91198, NULL, 'G3DSA:1.25.10.10:FF:002770', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91199, NULL, 'G3DSA:3.30.9.10:FF:000159', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(91200, NULL, 'G3DSA:2.40.50.140:FF:000857', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91201, NULL, 'G3DSA:3.40.50.1000:FF:000447', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91202, NULL, 'G3DSA:1.10.10.10:FF:001983', NULL, NULL, 'Spi1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(91203, NULL, 'G3DSA:1.25.10.10:FF:003456', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91204, NULL, 'G3DSA:3.30.420.10:FF:000249', NULL, NULL, 'Exonuclease 3''-5'' domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(91205, NULL, 'G3DSA:3.90.1110.10:FF:000003', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(91206, NULL, 'G3DSA:2.60.40.60:FF:000101', NULL, NULL, 'FAT atypical cadherin 4', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(91207, NULL, 'G3DSA:2.30.30.870:FF:000001', NULL, NULL, 'Protein pelota homolog', NULL, NULL, NULL, NULL, NULL, 4),
(91208, NULL, 'G3DSA:3.40.930.10:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91209, NULL, 'G3DSA:3.30.930.10:FF:000389', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91210, NULL, 'G3DSA:2.130.10.10:FF:002475', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(91211, NULL, 'G3DSA:3.40.470.10:FF:000025', NULL, NULL, 'Type-4 uracil-DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(91212, NULL, 'G3DSA:1.20.1070.10:FF:001433', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(91213, NULL, 'G3DSA:2.60.120.10:FF:000594', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91214, NULL, 'G3DSA:1.20.5.170:FF:000256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91215, NULL, 'G3DSA:3.40.720.10:FF:000039', NULL, NULL, 'arylsulfatase K', NULL, NULL, NULL, NULL, NULL, 4),
(91216, NULL, 'G3DSA:3.30.40.10:FF:000872', NULL, NULL, 'Irc20p', NULL, NULL, NULL, NULL, NULL, 4),
(91217, NULL, 'G3DSA:3.40.630.10:FF:000212', NULL, NULL, 'Putative membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(91218, NULL, 'G3DSA:1.25.40.10:FF:003845', NULL, NULL, 'Mitochondrial import receptor subunit tomm-70', NULL, NULL, NULL, NULL, NULL, 4),
(91219, NULL, 'G3DSA:3.30.360.10:FF:000103', NULL, NULL, 'Uncharacterized protein C12C2.04', NULL, NULL, NULL, NULL, NULL, 4),
(91220, NULL, 'G3DSA:1.20.1740.10:FF:000029', NULL, NULL, 'Putative amino acid permease', NULL, NULL, NULL, NULL, NULL, 4),
(91221, NULL, 'G3DSA:1.10.287.3510:FF:000001', NULL, NULL, 'NADH-quinone oxidoreductase subunit K', NULL, NULL, NULL, NULL, NULL, 4),
(91222, NULL, 'G3DSA:2.130.10.10:FF:004510', NULL, NULL, 'Ribosome biogenesis protein WDR12 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(91223, NULL, 'G3DSA:3.30.420.110:FF:000060', NULL, NULL, 'DNA mismatch repair protein MSH2', NULL, NULL, NULL, NULL, NULL, 4),
(91224, NULL, 'G3DSA:1.10.20.10:FF:000320', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91225, NULL, 'G3DSA:3.40.50.300:FF:005999', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91226, NULL, 'G3DSA:1.10.10.10:FF:001275', NULL, NULL, 'O-methyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(91227, NULL, 'G3DSA:3.40.50.300:FF:002037', NULL, NULL, 'Putative DEAD/DEAH box ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(91228, NULL, 'G3DSA:3.30.70.330:FF:001922', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91229, NULL, 'G3DSA:1.20.930.40:FF:000003', NULL, NULL, 'Glutamate carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91230, NULL, 'G3DSA:3.90.1640.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91231, NULL, 'G3DSA:2.60.40.640:FF:000040', NULL, NULL, 'Aly2p', NULL, NULL, NULL, NULL, NULL, 4),
(91232, NULL, 'G3DSA:2.60.40.150:FF:000494', NULL, NULL, 'Protein kinase c conserved region 2', NULL, NULL, NULL, NULL, NULL, 4),
(91233, NULL, 'G3DSA:3.30.1600.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91234, NULL, 'G3DSA:1.25.40.10:FF:000411', NULL, NULL, 'pre-mRNA-splicing factor SYF1', NULL, NULL, NULL, NULL, NULL, 4),
(91235, NULL, 'G3DSA:3.40.630.30:FF:000370', NULL, NULL, 'Acyl-CoA N-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(91236, NULL, 'G3DSA:1.25.70.10:FF:000093', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91237, NULL, 'G3DSA:3.30.70.980:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91238, NULL, 'G3DSA:3.30.200.20:FF:000421', NULL, NULL, 'Serine/threonine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(91239, NULL, 'G3DSA:1.10.510.10:FF:000111', NULL, NULL, 'CDPK-related kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(91240, NULL, 'G3DSA:3.30.160.60:FF:000704', NULL, NULL, 'zinc finger protein 169 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(91241, NULL, 'G3DSA:3.10.20.90:FF:000715', NULL, NULL, 'Ubiquitin domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(91242, NULL, 'G3DSA:3.40.50.300:FF:002655', NULL, NULL, 'Dynein cytoplasmic 1 heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(91243, NULL, 'G3DSA:2.160.10.10:FF:000113', NULL, NULL, 'Protein CBG00512', NULL, NULL, NULL, NULL, NULL, 4),
(91244, NULL, 'G3DSA:2.130.10.10:FF:002508', NULL, NULL, 'Rho guanine nucleotide exchange factor (GEF) 10-like b', NULL, NULL, NULL, NULL, NULL, 4),
(91245, NULL, 'G3DSA:3.20.20.70:FF:000658', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91246, NULL, 'G3DSA:1.10.10.1100:FF:000018', NULL, NULL, 'Glycoprotein 64', NULL, NULL, NULL, NULL, NULL, 4),
(91247, NULL, 'G3DSA:2.60.34.10:FF:000111', NULL, NULL, 'Cytosol-type hsp70', NULL, NULL, NULL, NULL, NULL, 4),
(91248, NULL, 'G3DSA:1.10.730.10:FF:000037', NULL, NULL, 'Methionyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(91249, NULL, 'G3DSA:1.10.3080.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91250, NULL, 'G3DSA:3.40.30.10:FF:000382', NULL, NULL, 'Elongation factor 1-gamma (Ef-1-gamma), putative', NULL, NULL, NULL, NULL, NULL, 4),
(91251, NULL, 'G3DSA:3.40.630.30:FF:000128', NULL, NULL, 'Acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(91252, NULL, 'G3DSA:1.10.10.10:FF:000257', NULL, NULL, 'Transcriptional repressor CcpN', NULL, NULL, NULL, NULL, NULL, 4),
(91253, NULL, 'G3DSA:2.30.30.490:FF:000067', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(91254, NULL, 'G3DSA:3.30.1520.10:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91255, NULL, 'G3DSA:1.10.560.10:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91256, NULL, 'G3DSA:1.10.10.10:FF:001926', NULL, NULL, 'ArsR family transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(91257, NULL, 'G3DSA:2.60.40.640:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91258, NULL, 'G3DSA:1.25.40.990:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91259, NULL, 'G3DSA:1.20.1070.10:FF:000938', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91260, NULL, 'G3DSA:1.10.30.10:FF:000146', NULL, NULL, 'Protein CBG08365', NULL, NULL, NULL, NULL, NULL, 4),
(91261, NULL, 'G3DSA:3.30.420.10:FF:000491', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91262, NULL, 'G3DSA:1.25.40.10:FF:004340', NULL, NULL, 'Putative ERAD-associated E3 ubiquitin-protein ligase component', NULL, NULL, NULL, NULL, NULL, 4),
(91263, NULL, 'G3DSA:3.40.50.300:FF:004600', NULL, NULL, 'Replicase polyprotein 1ab', NULL, NULL, NULL, NULL, NULL, 4),
(91264, NULL, 'G3DSA:2.60.40.10:FF:005875', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91265, NULL, 'G3DSA:2.30.29.30:FF:000679', NULL, NULL, 'Nucleosome binding factor SPN, SPT16 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(91266, NULL, 'G3DSA:1.10.3110.10:FF:000012', NULL, NULL, 'Blr3003 protein', NULL, NULL, NULL, NULL, NULL, 4),
(91267, NULL, 'G3DSA:1.10.287.110:FF:000211', NULL, NULL, 'DnaJ-like-60, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(91268, NULL, 'G3DSA:3.20.20.60:FF:000094', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(91269, NULL, 'G3DSA:2.40.50.100:FF:000132', NULL, NULL, 'Binding-protein-dependent transport system, ATP-binding component', NULL, NULL, NULL, NULL, NULL, 4),
(91270, NULL, 'G3DSA:3.40.630.10:FF:000122', NULL, NULL, 'Membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(91271, NULL, 'G3DSA:2.60.40.10:FF:002441', NULL, NULL, 'Twitchin', NULL, NULL, NULL, NULL, NULL, 4),
(91272, NULL, 'G3DSA:3.90.110.10:FF:000015', NULL, NULL, 'L-lactate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(91273, NULL, 'G3DSA:3.40.1090.10:FF:000006', NULL, NULL, '85/88 kDa calcium-independent phospholipase A2', NULL, NULL, NULL, NULL, NULL, 4),
(91274, NULL, 'G3DSA:3.30.530.20:FF:000086', NULL, NULL, 'Activator of Hsp90 ATPase, N-terminal/Activator of Hsp90 ATPase like protein, putative', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(91275, NULL, 'G3DSA:3.90.1030.20:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91276, NULL, 'G3DSA:3.20.20.60:FF:000037', NULL, NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(91277, NULL, 'G3DSA:1.20.1610.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91278, NULL, 'G3DSA:3.40.50.1100:FF:000275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91279, NULL, 'G3DSA:1.25.40.10:FF:002002', NULL, NULL, 'Crooked neck-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(91280, NULL, 'G3DSA:1.10.418.10:FF:000227', NULL, NULL, 'Rac guanine nucleotide exchange factor B', NULL, NULL, NULL, NULL, NULL, 4),
(91281, NULL, 'G3DSA:1.10.520.10:FF:000027', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(91282, NULL, 'G3DSA:3.30.230.70:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91283, NULL, 'G3DSA:3.30.420.40:FF:000415', NULL, NULL, 'Possible d-xylulose kinase xylB', NULL, NULL, NULL, NULL, NULL, 4),
(91284, NULL, 'G3DSA:3.30.70.3160:FF:000002', NULL, NULL, 'tRNA pseudouridine synthase D TruD', NULL, NULL, NULL, NULL, NULL, 4),
(91285, NULL, 'G3DSA:1.10.10.10:FF:001831', NULL, NULL, 'Type III restriction enzyme, res subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(91286, NULL, 'G3DSA:3.30.70.1230:FF:000086', NULL, NULL, 'Adenylate cyclase type 10-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(91287, NULL, 'G3DSA:1.10.357.120:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91288, NULL, 'G3DSA:1.20.5.220:FF:000001', NULL, NULL, 'Rho GTPase activating protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(91289, NULL, 'G3DSA:3.40.50.1820:FF:001446', NULL, NULL, 'Putative lipase C4A8.10', NULL, NULL, NULL, NULL, NULL, 4),
(91290, NULL, 'G3DSA:3.10.110.10:FF:000140', NULL, NULL, 'AGAP002223-PA', NULL, NULL, NULL, NULL, NULL, 4),
(91291, NULL, 'G3DSA:1.25.40.10:FF:003576', NULL, NULL, 'Receptor-like histidine kinase BpdS', NULL, NULL, NULL, NULL, NULL, 4),
(91292, NULL, 'G3DSA:2.130.10.10:FF:002155', NULL, NULL, 'Type II inositol polyphosphate 5-phosphatase 15', NULL, NULL, NULL, NULL, NULL, 4),
(91293, NULL, 'G3DSA:3.40.50.300:FF:000418', NULL, NULL, 'Iron-sulfur cluster carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(91294, NULL, 'G3DSA:3.40.50.1390:FF:000024', NULL, NULL, 'Recombinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(91295, NULL, 'G3DSA:3.60.21.10:FF:000388', NULL, NULL, 'Serine/threonine protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91296, NULL, 'G3DSA:1.25.10.10:FF:000297', NULL, NULL, 'Transportin-1', NULL, NULL, NULL, NULL, NULL, 4),
(91297, NULL, 'G3DSA:3.10.580.10:FF:000068', NULL, NULL, 'DUF21 domain-containing protein At2g14520-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(91298, NULL, 'G3DSA:3.40.50.300:FF:000356', NULL, NULL, 'DNA repair protein RecN', NULL, NULL, NULL, NULL, NULL, 4),
(91299, NULL, 'G3DSA:3.60.21.10:FF:000293', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(91300, NULL, 'G3DSA:2.60.40.10:FF:002177', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase C', NULL, NULL, NULL, NULL, NULL, 4),
(91301, NULL, 'G3DSA:2.40.20.10:FF:000007', NULL, NULL, 'Hepatocyte growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(91302, NULL, 'G3DSA:3.40.50.300:FF:004690', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91303, NULL, 'G3DSA:3.40.50.150:FF:000064', NULL, NULL, '2-methoxy-6-polyprenyl-1,4-benzoquinol methylase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(91304, NULL, 'G3DSA:1.10.238.10:FF:000455', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91305, NULL, 'G3DSA:3.40.50.720:FF:002112', NULL, NULL, 'Short chain dehydrogenase reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91306, NULL, 'G3DSA:2.130.10.10:FF:000064', NULL, NULL, 'Cleavage stimulation factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(91307, NULL, 'G3DSA:3.10.440.10:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91308, NULL, 'G3DSA:2.10.25.10:FF:000677', NULL, NULL, 'Wing blister, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(91309, NULL, 'G3DSA:3.40.800.20:FF:000009', NULL, NULL, 'Histone deacetylase 11', NULL, NULL, NULL, NULL, NULL, 4),
(91310, NULL, 'G3DSA:3.10.110.10:FF:000191', NULL, NULL, 'Ubiquitin-fold modifier-conjugating enzyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(91311, NULL, 'G3DSA:4.10.400.10:FF:000260', NULL, NULL, 'Complement component C9', NULL, NULL, NULL, NULL, NULL, 4),
(91312, NULL, 'G3DSA:3.30.300.130:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91313, NULL, 'G3DSA:2.130.10.10:FF:003841', NULL, NULL, 'DDB1-and CUL4-associated factor 10 homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(91314, NULL, 'G3DSA:3.80.20.20:FF:000023', NULL, NULL, 'LD35811p', NULL, NULL, NULL, NULL, NULL, 4),
(91315, NULL, 'G3DSA:1.25.40.10:FF:003525', NULL, NULL, 'UTX (Ubiquitously transcribed TPR on X) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(91316, NULL, 'G3DSA:3.40.630.10:FF:000420', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(91317, NULL, 'G3DSA:2.60.40.10:FF:005954', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91318, NULL, 'G3DSA:2.70.130.10:FF:000132', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91319, NULL, 'G3DSA:3.30.200.20:FF:000191', NULL, NULL, '3-phosphoinositide-dependent protein kinase 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(91320, NULL, 'G3DSA:3.30.160.60:FF:000535', NULL, NULL, 'Zinc finger protein 367', NULL, NULL, NULL, NULL, NULL, 4),
(91321, NULL, 'G3DSA:1.20.1250.20:FF:000478', NULL, NULL, 'Molybdate-anion transporter', NULL, NULL, NULL, NULL, NULL, 4),
(91322, NULL, 'G3DSA:1.50.40.10:FF:000139', NULL, NULL, 'Mitochondrial carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(91323, NULL, 'G3DSA:2.40.70.10:FF:000044', NULL, NULL, 'Lysosomal aspartic protease', NULL, NULL, NULL, NULL, NULL, 4),
(91324, NULL, 'G3DSA:3.90.79.10:FF:000031', NULL, NULL, 'Nudix hydrolase 16, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(91325, NULL, 'G3DSA:3.90.550.50:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91326, NULL, 'G3DSA:3.40.800.10:FF:000006', NULL, NULL, 'Agmatinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(91327, NULL, 'G3DSA:3.30.540.10:FF:000027', NULL, NULL, 'Fructose-1,6-bisphosphatase/inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(91328, NULL, 'G3DSA:2.40.50.690:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91329, NULL, 'G3DSA:3.40.50.10140:FF:000086', NULL, NULL, 'Protein tirA', NULL, NULL, NULL, NULL, NULL, 4),
(91330, NULL, 'G3DSA:1.10.580.10:FF:000036', NULL, NULL, 'Os11g0623601 protein', NULL, NULL, NULL, NULL, NULL, 4),
(91331, NULL, 'G3DSA:1.10.10.60:FF:000053', NULL, NULL, 'H6 family homeobox 2', NULL, NULL, NULL, NULL, NULL, 4),
(91332, NULL, 'G3DSA:2.130.10.10:FF:001492', NULL, NULL, 'Prolactin regulatory element-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(91333, NULL, 'G3DSA:1.25.40.10:FF:001485', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At3g05240', NULL, NULL, NULL, NULL, NULL, 4),
(91334, NULL, 'G3DSA:3.40.50.300:FF:002447', NULL, NULL, 'DnaA regulatory inactivator Hda', NULL, NULL, NULL, NULL, NULL, 4),
(91335, NULL, 'G3DSA:3.40.50.300:FF:001879', NULL, NULL, 'Shikimate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(91336, NULL, 'G3DSA:2.40.290.10:FF:000026', NULL, NULL, 'ATP-dependent DNA helicase 2 subunit KU80', NULL, NULL, NULL, NULL, NULL, 4),
(91337, NULL, 'G3DSA:3.40.630.150:FF:000004', NULL, NULL, 'Malonyl-CoA decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(91338, NULL, 'G3DSA:1.20.1640.10:FF:000061', NULL, NULL, 'Protein patched homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(91339, NULL, 'G3DSA:3.90.440.10:FF:000006', NULL, NULL, 'Nitric oxide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(91340, NULL, 'G3DSA:3.40.630.30:FF:000364', NULL, NULL, 'AGAP011742-PA', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(91341, NULL, 'G3DSA:3.30.160.60:FF:000586', NULL, NULL, 'zinc finger protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(91342, NULL, 'G3DSA:1.10.510.10:FF:000055', NULL, NULL, 'Glycogen synthase kinase-3 beta', NULL, NULL, NULL, NULL, NULL, 4),
(91343, NULL, 'G3DSA:2.130.10.10:FF:000390', NULL, NULL, 'THO complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(91344, NULL, 'G3DSA:1.10.287.950:FF:000018', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(91345, NULL, 'G3DSA:1.20.120.350:FF:000062', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(91346, NULL, 'G3DSA:2.60.40.10:FF:003863', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91347, NULL, 'G3DSA:3.30.70.330:FF:001574', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91348, NULL, 'G3DSA:1.20.272.10:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91349, NULL, 'G3DSA:4.10.1110.10:FF:000010', NULL, NULL, 'Zinc finger AN1 domain-containing stress-associated protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(91350, NULL, 'G3DSA:2.130.10.10:FF:005965', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91351, NULL, 'G3DSA:2.130.10.10:FF:000710', NULL, NULL, 'U3 snoRNP protein', NULL, NULL, NULL, NULL, NULL, 4),
(91352, NULL, 'G3DSA:3.30.9.10:FF:000226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91353, NULL, 'G3DSA:2.60.200.20:FF:000103', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91354, NULL, 'G3DSA:3.30.160.60:FF:000209', NULL, NULL, 'Zinc finger protein 711', NULL, NULL, NULL, NULL, NULL, 4),
(91355, NULL, 'G3DSA:1.10.510.10:FF:002179', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91356, NULL, 'G3DSA:1.10.287.1490:FF:000081', NULL, NULL, 'Viral A-type inclusion protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91357, NULL, 'G3DSA:3.30.870.10:FF:000013', NULL, NULL, 'phospholipase D3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(91358, NULL, 'G3DSA:2.60.40.1550:FF:000001', NULL, NULL, 'ORF8', NULL, NULL, NULL, NULL, NULL, 4),
(91359, NULL, 'G3DSA:3.30.1960.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91360, NULL, 'G3DSA:3.10.20.90:FF:000333', NULL, NULL, 'Ubiquitin-like protein ATG12', NULL, NULL, NULL, NULL, NULL, 4),
(91361, NULL, 'G3DSA:1.10.10.10:FF:000145', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(91362, NULL, 'G3DSA:3.40.50.740:FF:000027', NULL, NULL, 'Formate dehydrogenase molybdopterin-binding subunit FdhA', NULL, NULL, NULL, NULL, NULL, 4),
(91363, NULL, 'G3DSA:3.90.230.10:FF:000018', NULL, NULL, 'Methionine aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(91364, NULL, 'G3DSA:2.60.120.200:FF:000310', NULL, NULL, 'Chromosome 16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(91365, NULL, 'G3DSA:3.90.550.10:FF:000565', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(91366, NULL, 'G3DSA:3.30.1330.120:FF:000006', NULL, NULL, '2-methylcitrate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(91367, NULL, 'G3DSA:3.40.50.880:FF:000041', NULL, NULL, 'Glutamine amidotransferase subunit pdxT, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91368, NULL, 'G3DSA:3.40.50.720:FF:001595', NULL, NULL, 'Glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(91369, NULL, 'G3DSA:2.10.25.10:FF:001441', NULL, NULL, 'Putative fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(91370, NULL, 'G3DSA:2.30.30.380:FF:000039', NULL, NULL, 'Translation elongation factor EF1A/initiation factor IF2gamma family protein', NULL, NULL, NULL, NULL, NULL, 4),
(91371, NULL, 'G3DSA:1.10.510.10:FF:002730', NULL, NULL, 'Probable serine/threonine-protein kinase DDB_G0279719', NULL, NULL, NULL, NULL, NULL, 4),
(91372, NULL, 'G3DSA:3.30.310.130:FF:000029', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(91373, NULL, 'G3DSA:1.20.1560.10:FF:000931', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(91374, NULL, 'G3DSA:1.25.10.10:FF:001399', NULL, NULL, 'INTegrator complex Subunit homolog', NULL, NULL, NULL, NULL, NULL, 4),
(91375, NULL, 'G3DSA:3.30.160.60:FF:001103', NULL, NULL, 'Zinc finger protein 639', NULL, NULL, NULL, NULL, NULL, 4),
(91376, NULL, 'G3DSA:3.30.70.330:FF:002142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91377, NULL, 'G3DSA:3.50.70.10:FF:000002', NULL, NULL, 'Chalcone-flavonone isomerase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(91378, NULL, 'G3DSA:2.90.10.10:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91379, NULL, 'G3DSA:1.25.10.10:FF:002500', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91380, NULL, 'G3DSA:2.60.120.820:FF:000013', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(91381, NULL, 'G3DSA:3.30.420.40:FF:000320', NULL, NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(91382, NULL, 'G3DSA:2.120.10.30:FF:000323', NULL, NULL, 'Os10g0443000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(91383, NULL, 'G3DSA:1.10.287.110:FF:000273', NULL, NULL, 'Protein psi1', NULL, NULL, NULL, NULL, NULL, 4),
(91384, NULL, 'G3DSA:3.10.20.90:FF:000721', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91385, NULL, 'G3DSA:3.40.50.150:FF:000390', NULL, NULL, 'Short/branched chain specific acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(91386, NULL, 'G3DSA:3.30.2130.10:FF:000007', NULL, NULL, 'ACT domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(91387, NULL, 'G3DSA:1.20.200.10:FF:000012', NULL, NULL, 'Tyrosine ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(91388, NULL, 'G3DSA:1.10.630.10:FF:000586', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91389, NULL, 'G3DSA:3.30.70.330:FF:000225', NULL, NULL, 'U2 snRNP auxiliary factor large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(91390, NULL, 'G3DSA:1.10.8.60:FF:000384', NULL, NULL, 'ATPase, AAA family', NULL, NULL, NULL, NULL, NULL, 4),
(91391, NULL, 'G3DSA:3.40.50.1000:FF:000503', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91392, NULL, 'G3DSA:1.10.472.80:FF:000076', NULL, NULL, 'Ubiquitin and WLM domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(91393, NULL, 'G3DSA:1.10.357.20:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91394, NULL, 'G3DSA:1.10.20.10:FF:000022', NULL, NULL, 'Histone H2A', NULL, NULL, NULL, NULL, NULL, 4),
(91395, NULL, 'G3DSA:3.30.470.20:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91396, NULL, 'G3DSA:3.30.40.10:FF:001187', NULL, NULL, 'RING/U-box superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(91397, NULL, 'G3DSA:2.130.10.10:FF:002481', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(91398, NULL, 'G3DSA:1.25.10.10:FF:000151', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(91399, NULL, 'G3DSA:2.170.270.10:FF:000067', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(91400, NULL, 'G3DSA:3.40.250.10:FF:000048', NULL, NULL, 'Thiosulfate sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(91401, NULL, 'G3DSA:3.40.50.300:FF:004364', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(91402, NULL, 'G3DSA:1.10.150.240:FF:000121', NULL, NULL, 'Putative phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(91403, NULL, 'G3DSA:1.20.5.4770:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91404, NULL, 'G3DSA:3.40.50.300:FF:003796', NULL, NULL, 'Endoribonuclease dcr-1', NULL, NULL, NULL, NULL, NULL, 4),
(91405, NULL, 'G3DSA:2.10.50.10:FF:000139', NULL, NULL, 'CD40 molecule, TNF receptor superfamily member 5', NULL, NULL, NULL, NULL, NULL, 4),
(91406, NULL, 'G3DSA:3.90.660.10:FF:000068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91407, NULL, 'G3DSA:3.30.70.80:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(91408, NULL, 'G3DSA:3.30.420.40:FF:000741', NULL, NULL, 'Putative actin-28', NULL, NULL, NULL, NULL, NULL, 4),
(91409, NULL, 'G3DSA:1.25.40.800:FF:000003', NULL, NULL, 'CCR4-NOT transcription complex subunit 1,putative', NULL, NULL, NULL, NULL, NULL, 4),
(91410, NULL, 'G3DSA:1.10.10.10:FF:000403', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(91411, NULL, 'G3DSA:1.50.40.10:FF:000353', NULL, NULL, 'Putative tricarboxylate secondary active transmembrane transporter', NULL, NULL, NULL, NULL, NULL, 4),
(91412, NULL, 'G3DSA:3.40.630.10:FF:000206', NULL, NULL, 'AGAP002414-PA', NULL, NULL, NULL, NULL, NULL, 4),
(91413, NULL, 'G3DSA:1.10.510.10:FF:002404', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91414, NULL, 'G3DSA:3.30.1380.20:FF:000028', NULL, NULL, 'Trafficking protein particle complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(91415, NULL, 'G3DSA:1.20.120.1750:FF:000084', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(91416, NULL, 'G3DSA:1.10.150.110:FF:000015', NULL, NULL, 'DNA polymerase X family', NULL, NULL, NULL, NULL, NULL, 4),
(91417, NULL, 'G3DSA:3.20.20.70:FF:000299', NULL, NULL, 'NADPH dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(91418, NULL, 'G3DSA:3.30.565.10:FF:000225', NULL, NULL, 'Signal transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(91419, NULL, 'G3DSA:1.50.40.10:FF:000465', NULL, NULL, 'Carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91420, NULL, 'G3DSA:3.20.20.140:FF:000464', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91421, NULL, 'G3DSA:3.30.70.20:FF:000062', NULL, NULL, '4Fe-4S binding domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(91422, NULL, 'G3DSA:1.50.10.100:FF:000007', NULL, NULL, 'Chondroitin sulfate ABC exolyase', NULL, NULL, NULL, NULL, NULL, 4),
(91423, NULL, 'G3DSA:3.50.50.60:FF:000965', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91424, NULL, 'G3DSA:2.60.40.60:FF:000640', NULL, NULL, 'AGAP002828-PA', NULL, NULL, NULL, NULL, NULL, 4),
(91425, NULL, 'G3DSA:3.30.70.330:FF:001748', NULL, NULL, 'Multiple RNA-binding domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(91426, NULL, 'G3DSA:3.90.1300.10:FF:000012', NULL, NULL, 'Amidase AmiD', NULL, NULL, NULL, NULL, NULL, 4),
(91427, NULL, 'G3DSA:2.60.40.1390:FF:000009', NULL, NULL, 'Myelin regulatory factor like', NULL, NULL, NULL, NULL, NULL, 4),
(91428, NULL, 'G3DSA:3.40.920.10:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91429, NULL, 'G3DSA:3.90.280.10:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91430, NULL, 'G3DSA:3.40.630.70:FF:000005', NULL, NULL, 'Leucyl/phenylalanyl-tRNA--protein transferase', NULL, NULL, NULL, NULL, NULL, 4),
(91431, NULL, 'G3DSA:3.40.718.10:FF:000011', NULL, NULL, 'Isocitrate dehydrogenase [NAD] subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(91432, NULL, 'G3DSA:3.30.160.60:FF:004543', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91433, NULL, 'G3DSA:3.40.50.300:FF:005887', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(91434, NULL, 'G3DSA:1.20.120.1760:FF:000087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91435, NULL, 'G3DSA:1.10.510.10:FF:003865', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91436, NULL, 'G3DSA:1.10.238.10:FF:000781', NULL, NULL, 'AGAP002536-PA', NULL, NULL, NULL, NULL, NULL, 4),
(91437, NULL, 'G3DSA:3.40.630.60:FF:000002', NULL, NULL, 'Ornithine decarboxylase antizyme 3', NULL, NULL, NULL, NULL, NULL, 4),
(91438, NULL, 'G3DSA:1.10.287.1490:FF:000030', NULL, NULL, 'Bruchpilot, isoform L', NULL, NULL, NULL, NULL, NULL, 4),
(91439, NULL, 'G3DSA:1.20.1280.50:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91440, NULL, 'G3DSA:3.40.50.720:FF:001269', NULL, NULL, 'Probable 3-hydroxyisobutyrate dehydrogenase-like 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(91441, NULL, 'G3DSA:3.40.30.10:FF:000764', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(91442, NULL, 'G3DSA:1.10.565.10:FF:000193', NULL, NULL, 'DAX', NULL, NULL, NULL, NULL, NULL, 4),
(91443, NULL, 'G3DSA:3.30.43.10:FF:000024', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(91444, NULL, 'G3DSA:1.10.1420.10:FF:000030', NULL, NULL, 'DNA mismatch repair protein MSH2', NULL, NULL, NULL, NULL, NULL, 4),
(91445, NULL, 'G3DSA:3.40.50.1980:FF:000038', NULL, NULL, 'Iron compound ABC transporter, iron compound-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(91446, NULL, 'G3DSA:3.40.50.300:FF:002335', NULL, NULL, 'SWI/SNF nucleosome remodeling complex component', NULL, NULL, NULL, NULL, NULL, 4),
(91447, NULL, 'G3DSA:3.30.1130.10:FF:000007', NULL, NULL, 'GTP cyclohydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(91448, NULL, 'G3DSA:3.90.70.10:FF:000450', NULL, NULL, 'Calpain-like cysteine peptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91449, NULL, 'G3DSA:1.10.510.10:FF:000313', NULL, NULL, 'Serine/threonine-protein kinase srk1', NULL, NULL, NULL, NULL, NULL, 4),
(91450, NULL, 'G3DSA:1.10.8.60:FF:000333', NULL, NULL, 'Peroxisomal biogenesis factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(91451, NULL, 'G3DSA:1.10.1420.10:FF:000081', NULL, NULL, 'MutS-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(91452, NULL, 'G3DSA:3.40.630.30:FF:000690', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91453, NULL, 'G3DSA:1.10.3730.20:FF:000017', NULL, NULL, 'Cation transporter protein', NULL, NULL, NULL, NULL, NULL, 4),
(91454, NULL, 'G3DSA:2.30.42.10:FF:000131', NULL, NULL, 'membrane-associated guanylate kinase, WW and PDZ domain-containing protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(91455, NULL, 'G3DSA:3.40.33.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91456, NULL, 'G3DSA:3.30.420.10:FF:000665', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91457, NULL, 'G3DSA:1.10.620.20:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91458, NULL, 'G3DSA:2.60.40.1510:FF:000034', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(91459, NULL, 'G3DSA:1.10.1620.20:FF:000014', NULL, NULL, 'F1F0 ATP synthase epsilon subunit', NULL, NULL, NULL, NULL, NULL, 4),
(91460, NULL, 'G3DSA:2.170.270.10:FF:000016', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(91461, NULL, 'G3DSA:1.25.10.10:FF:000090', NULL, NULL, 'eIF-2-alpha kinase activator GCN1', NULL, NULL, NULL, NULL, NULL, 4),
(91462, NULL, 'G3DSA:1.10.8.60:FF:000479', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91463, NULL, 'G3DSA:3.40.50.620:FF:000042', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(91464, NULL, 'G3DSA:2.60.40.2440:FF:000010', NULL, NULL, 'GLC7-interacting protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(91465, NULL, 'G3DSA:3.30.160.60:FF:002952', NULL, NULL, 'Zinc finger protein 710b', NULL, NULL, NULL, NULL, NULL, 4),
(91466, NULL, 'G3DSA:2.60.40.150:FF:000634', NULL, NULL, 'Synaptotagmin Ib', NULL, NULL, NULL, NULL, NULL, 4),
(91467, NULL, 'G3DSA:2.60.40.10:FF:000086', NULL, NULL, 'Neural cell adhesion molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(91468, NULL, 'G3DSA:2.40.128.20:FF:000046', NULL, NULL, 'Epididymal-specific lipocalin-5', NULL, NULL, NULL, NULL, NULL, 4),
(91469, NULL, 'G3DSA:3.40.140.10:FF:000124', NULL, NULL, 'COP9 signalosome complex subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(91470, NULL, 'G3DSA:3.30.70.1230:FF:000148', NULL, NULL, 'Adenylate cyclase type 10', NULL, NULL, NULL, NULL, NULL, 4),
(91471, NULL, 'G3DSA:3.30.450.40:FF:000243', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(91472, NULL, 'G3DSA:2.10.25.10:FF:001492', NULL, NULL, 'Neurogenic locus notch homolog protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(91473, NULL, 'G3DSA:3.30.420.40:FF:000027', NULL, NULL, '78 kDa glucose-regulated', NULL, NULL, NULL, NULL, NULL, 4),
(91474, NULL, 'G3DSA:1.20.58.340:FF:000071', NULL, NULL, 'Magnesium/cobalt transport protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(91475, NULL, 'G3DSA:1.25.10.10:FF:001657', NULL, NULL, 'MO25-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(91476, NULL, 'G3DSA:3.30.1370.240:FF:000005', NULL, NULL, 'Probable FRS2-phenylalanine--tRNA ligase beta chain, cytosolic', NULL, NULL, NULL, NULL, NULL, 4),
(91477, NULL, 'G3DSA:1.10.560.10:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91478, NULL, 'G3DSA:4.10.240.10:FF:000157', NULL, NULL, 'ScfA', NULL, NULL, NULL, NULL, NULL, 4),
(91479, NULL, 'G3DSA:1.25.40.10:FF:001159', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At3g25060, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(91480, NULL, 'G3DSA:1.25.40.10:FF:003929', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91481, NULL, 'G3DSA:2.60.40.1120:FF:000007', NULL, NULL, 'Carboxypeptidase X, M14 family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(91482, NULL, 'G3DSA:2.60.40.10:FF:005903', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91483, NULL, 'G3DSA:3.90.70.10:FF:000236', NULL, NULL, 'Cysteine protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91484, NULL, 'G3DSA:2.70.98.10:FF:000117', NULL, NULL, 'Alpha-glucosidase SusB', NULL, NULL, NULL, NULL, NULL, 4),
(91485, NULL, 'G3DSA:1.10.3730.10:FF:000014', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(91486, NULL, 'G3DSA:3.80.10.10:FF:000935', NULL, NULL, 'Carboxypeptidase N subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(91487, NULL, 'G3DSA:2.60.200.20:FF:000154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91488, NULL, 'G3DSA:3.40.50.880:FF:000103', NULL, NULL, 'PROBABLE TRANSCRIPTIONAL REGULATORY PROTEIN', NULL, NULL, NULL, NULL, NULL, 4),
(91489, NULL, 'G3DSA:3.40.50.300:FF:007618', NULL, NULL, 'Guanylate kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(91490, NULL, 'G3DSA:1.10.579.10:FF:000016', NULL, NULL, 'CPD photolyase type II', NULL, NULL, NULL, NULL, NULL, 4),
(91491, NULL, 'G3DSA:3.30.360.10:FF:000081', NULL, NULL, 'Uncharacterized protein CaJ7.0133', NULL, NULL, NULL, NULL, NULL, 4),
(91492, NULL, 'G3DSA:2.60.40.60:FF:000691', NULL, NULL, 'Fat-like cadherin-related tumor suppressor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(91493, NULL, 'G3DSA:1.25.40.10:FF:001838', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(91494, NULL, 'G3DSA:2.60.40.1110:FF:000004', NULL, NULL, 'Voltage-sensor containing phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(91495, NULL, 'G3DSA:1.10.630.10:FF:000474', NULL, NULL, 'Putative cytochrome P450 superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(91496, NULL, 'G3DSA:3.30.450.30:FF:000026', NULL, NULL, 'Protein SLM4', NULL, NULL, NULL, NULL, NULL, 4),
(91497, NULL, 'G3DSA:3.30.1640.10:FF:000012', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(91498, NULL, 'G3DSA:1.25.40.10:FF:001608', NULL, NULL, 'Ribonucleoprotein p18, mitochondrial,putative', NULL, NULL, NULL, NULL, NULL, 4),
(91499, NULL, 'G3DSA:3.40.50.1820:FF:001272', NULL, NULL, 'Abhydrolase domain-containing protein C57A10.08c', NULL, NULL, NULL, NULL, NULL, 4),
(91500, NULL, 'G3DSA:3.50.30.10:FF:000005', NULL, NULL, 'PTS-dependent dihydroxyacetone kinase, DhaM subunit', NULL, NULL, NULL, NULL, NULL, 4),
(91501, NULL, 'G3DSA:2.40.10.10:FF:000147', NULL, NULL, 'Kallikrein related peptidase 12', NULL, NULL, NULL, NULL, NULL, 4),
(91502, NULL, 'G3DSA:3.90.1720.10:FF:000038', NULL, NULL, 'Protein CBG04856', NULL, NULL, NULL, NULL, NULL, 4),
(91503, NULL, 'G3DSA:1.20.1070.10:FF:001287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91504, NULL, 'G3DSA:2.10.25.10:FF:000598', NULL, NULL, 'Notch receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(91505, NULL, 'G3DSA:1.10.472.10:FF:000420', NULL, NULL, 'D-type cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(91506, NULL, 'G3DSA:3.30.420.40:FF:000527', NULL, NULL, 'Actin like 6B', NULL, NULL, NULL, NULL, NULL, 4),
(91507, NULL, 'G3DSA:2.130.10.10:FF:002267', NULL, NULL, 'Putative U5 snRNP-specific 40 kDa protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(91508, NULL, 'G3DSA:3.40.50.300:FF:002722', NULL, NULL, 'ATP-dependent DNA helicase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(91509, NULL, 'G3DSA:1.10.1200.260:FF:000003', NULL, NULL, 'Potassium voltage-gated channel subfamily H member 1', NULL, NULL, NULL, NULL, NULL, 4),
(91510, NULL, 'G3DSA:3.90.700.10:FF:000010', NULL, NULL, 'L-aspartate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(91511, NULL, 'G3DSA:3.30.365.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91512, NULL, 'G3DSA:2.40.50.100:FF:000160', NULL, NULL, 'AT5G38890 protein', NULL, NULL, NULL, NULL, NULL, 4),
(91513, NULL, 'G3DSA:2.30.39.10:FF:000045', NULL, NULL, 'Blast:Leukocyte elastase inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(91514, NULL, 'G3DSA:3.80.10.10:FF:002638', NULL, NULL, 'Receptor like protein 41', NULL, NULL, NULL, NULL, NULL, 4),
(91515, NULL, 'G3DSA:3.30.1330.30:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91516, NULL, 'G3DSA:2.170.150.20:FF:000011', NULL, NULL, 'Peptide-methionine (R)-S-oxide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(91517, NULL, 'G3DSA:3.40.50.1010:FF:000248', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91518, NULL, 'G3DSA:1.10.238.150:FF:000005', NULL, NULL, 'BNI1p Formin', NULL, NULL, NULL, NULL, NULL, 4),
(91519, NULL, 'G3DSA:3.90.70.10:FF:000511', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91520, NULL, 'G3DSA:1.20.58.80:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91521, NULL, 'G3DSA:1.20.144.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91522, NULL, 'G3DSA:1.20.1250.20:FF:001321', NULL, NULL, 'Solute carrier family 16, member 13 (monocarboxylic acid transporter 13)', NULL, NULL, NULL, NULL, NULL, 4),
(91523, NULL, 'G3DSA:2.130.10.10:FF:000238', NULL, NULL, 'Nuclear pore complex protein Nup133', NULL, NULL, NULL, NULL, NULL, 4),
(91524, NULL, 'G3DSA:1.10.3210.10:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91525, NULL, 'G3DSA:3.60.21.10:FF:000181', NULL, NULL, 'Serine/threonine-protein phosphatase PP-Z, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91526, NULL, 'G3DSA:3.40.50.790:FF:000014', NULL, NULL, 'Mitochondrial Ribosomal Protein, Large', NULL, NULL, NULL, NULL, NULL, 4),
(91527, NULL, 'G3DSA:2.60.40.10:FF:005780', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91528, NULL, 'G3DSA:3.40.50.300:FF:000244', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(91529, NULL, 'G3DSA:3.40.50.150:FF:000238', NULL, NULL, 'protein-L-isoaspartate(D-aspartate) O-methyltransferase isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(91530, NULL, 'G3DSA:3.30.70.1230:FF:000209', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(91531, NULL, 'G3DSA:1.10.10.60:FF:000227', NULL, NULL, 'LIM homeobox transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(91532, NULL, 'G3DSA:4.10.400.10:FF:000372', NULL, NULL, 'EG:BACR25B3.2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(91533, NULL, 'G3DSA:3.30.200.20:FF:001551', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91534, NULL, 'G3DSA:3.90.79.10:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91535, NULL, 'G3DSA:3.40.50.200:FF:000091', NULL, NULL, 'Tripeptidyl peptidase SED3 (AFU_orthologue AFUA_3G08930)', NULL, NULL, NULL, NULL, NULL, 4),
(91536, NULL, 'G3DSA:1.20.1110.10:FF:000094', NULL, NULL, 'Sarcoplasmic endoplasmic reticulum calcium atpase 2 isoform x1', NULL, NULL, NULL, NULL, NULL, 4),
(91537, NULL, 'G3DSA:2.60.40.2030:FF:000044', NULL, NULL, 'Adhesion G protein-coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(91538, NULL, 'G3DSA:3.30.160.60:FF:000709', NULL, NULL, 'GDNF-inducible zinc finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(91539, NULL, 'G3DSA:3.30.200.20:FF:002017', NULL, NULL, 'Protein kinase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(91540, NULL, 'G3DSA:2.40.50.790:FF:000001', NULL, NULL, 'Tudor, isoform B', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(91541, NULL, 'G3DSA:1.20.140.150:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91542, NULL, 'G3DSA:2.60.40.10:FF:004094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91543, NULL, 'G3DSA:1.50.40.10:FF:000027', NULL, NULL, 'mitoferrin-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(91544, NULL, 'G3DSA:3.80.10.10:FF:001503', NULL, NULL, 'Os11g0197000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(91545, NULL, 'G3DSA:1.20.5.340:FF:000037', NULL, NULL, 'Polycystin 2 like 1, transient receptor potential cation channel', NULL, NULL, NULL, NULL, NULL, 4),
(91546, NULL, 'G3DSA:2.60.40.60:FF:000073', NULL, NULL, 'protocadherin-7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(91547, NULL, 'G3DSA:3.30.160.60:FF:004801', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91548, NULL, 'G3DSA:3.30.450.40:FF:000029', NULL, NULL, 'PAS domain S-box', NULL, NULL, NULL, NULL, NULL, 4),
(91549, NULL, 'G3DSA:1.10.30.10:FF:000028', NULL, NULL, 'WD repeat and HMG-box DNA-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(91550, NULL, 'G3DSA:3.40.50.1100:FF:000207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91551, NULL, 'G3DSA:2.60.120.330:FF:000057', NULL, NULL, 'Oxidoreductase, 2OG-Fe(II) oxygenase family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91552, NULL, 'G3DSA:3.30.160.60:FF:002452', NULL, NULL, 'zinc finger protein 142 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(91553, NULL, 'G3DSA:2.60.40.150:FF:000522', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91554, NULL, 'G3DSA:3.40.50.1820:FF:001093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91555, NULL, 'G3DSA:3.90.70.10:FF:000562', NULL, NULL, 'Calpain 3', NULL, NULL, NULL, NULL, NULL, 4),
(91556, NULL, 'G3DSA:1.20.120.350:FF:000236', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91557, NULL, 'G3DSA:3.20.20.70:FF:000248', NULL, NULL, 'Lipoyl synthase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(91558, NULL, 'G3DSA:3.40.710.10:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91559, NULL, 'G3DSA:1.10.510.10:FF:000493', NULL, NULL, 'serine/threonine-protein kinase unc-51 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(91560, NULL, 'G3DSA:2.60.40.1660:FF:000034', NULL, NULL, 'Sodium/potassium-dependent ATPase beta-2 subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91561, NULL, 'G3DSA:3.40.50.300:FF:005269', NULL, NULL, 'ABL048Wp', NULL, NULL, NULL, NULL, NULL, 4),
(91562, NULL, 'G3DSA:3.40.50.720:FF:001623', NULL, NULL, 'Os06g0251000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(91563, NULL, 'G3DSA:2.10.25.10:FF:000177', NULL, NULL, 'Adhesion G protein-coupled receptor E2', NULL, NULL, NULL, NULL, NULL, 4),
(91564, NULL, 'G3DSA:3.30.450.200:FF:000008', NULL, NULL, 'DENN domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(91565, NULL, 'G3DSA:1.20.1050.10:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91566, NULL, 'G3DSA:3.30.530.20:FF:000024', NULL, NULL, 'Abscisic acid receptor PYL4', NULL, NULL, NULL, NULL, NULL, 4),
(91567, NULL, 'G3DSA:1.10.1780.10:FF:000017', NULL, NULL, 'ATP-dependent Clp protease subunit, heat shock protein 100 (HSP100), putative', NULL, NULL, NULL, NULL, NULL, 4),
(91568, NULL, 'G3DSA:2.60.40.1670:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91569, NULL, 'G3DSA:3.10.20.90:FF:000507', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91570, NULL, 'G3DSA:1.20.1410.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91571, NULL, 'G3DSA:2.30.30.140:FF:000344', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(91572, NULL, 'G3DSA:3.40.630.30:FF:000538', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(91573, NULL, 'G3DSA:3.40.30.10:FF:000438', NULL, NULL, 'Grx8p', NULL, NULL, NULL, NULL, NULL, 4),
(91574, NULL, 'G3DSA:1.20.58.1070:FF:000018', NULL, NULL, 'Survival of motor neuron protein-interacting protein yip12', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(91575, NULL, 'G3DSA:3.30.200.20:FF:002343', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91576, NULL, 'G3DSA:3.40.30.10:FF:000825', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91577, NULL, 'G3DSA:3.20.20.80:FF:000482', NULL, NULL, 'Glycoside hydrolase 35 family enzyme,exo-beta D-glucosaminidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91578, NULL, 'G3DSA:2.10.25.10:FF:001615', NULL, NULL, 'Notch 3', NULL, NULL, NULL, NULL, NULL, 4),
(91579, NULL, 'G3DSA:3.40.1830.10:FF:000002', NULL, NULL, 'Aminopeptidase AmpS', NULL, NULL, NULL, NULL, NULL, 4),
(91580, NULL, 'G3DSA:1.10.30.10:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91581, NULL, 'G3DSA:2.102.10.10:FF:000009', NULL, NULL, 'Rieske Fe-S domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(91582, NULL, 'G3DSA:1.20.58.70:FF:000036', NULL, NULL, 'SNARE domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(91583, NULL, 'G3DSA:1.50.40.10:FF:000078', NULL, NULL, 'Mitochondrial DNA replication protein YHM2', NULL, NULL, NULL, NULL, NULL, 4),
(91584, NULL, 'G3DSA:3.90.550.10:FF:000127', NULL, NULL, 'Probable glycosyltransferase 7', NULL, NULL, NULL, NULL, NULL, 4),
(91585, NULL, 'G3DSA:2.10.25.10:FF:000738', NULL, NULL, 'neurogenic locus notch homolog protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(91586, NULL, 'G3DSA:3.40.50.10330:FF:000087', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(91587, NULL, 'G3DSA:1.20.1420.30:FF:000022', NULL, NULL, 'sodium/potassium/calcium exchanger 2 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(91588, NULL, 'G3DSA:1.10.1450.10:FF:000150', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(91589, NULL, 'G3DSA:3.40.1090.10:FF:000040', NULL, NULL, 'Intracelllar PhosphoLipase A family', NULL, NULL, NULL, NULL, NULL, 4),
(91590, NULL, 'G3DSA:3.40.50.880:FF:000215', NULL, NULL, '4-methyl-5(Beta-hydroxyethyl)-thiazole monophosphate synthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(91591, NULL, 'G3DSA:1.20.58.60:FF:000033', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(91592, NULL, 'G3DSA:2.110.10.10:FF:000020', NULL, NULL, 'Hemopexin', NULL, NULL, NULL, NULL, NULL, 4),
(91593, NULL, 'G3DSA:3.40.50.10810:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91594, NULL, 'G3DSA:3.80.10.10:FF:002964', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91595, NULL, 'G3DSA:3.40.50.300:FF:000295', NULL, NULL, 'Ras-related protein Rab7', NULL, NULL, NULL, NULL, NULL, 4),
(91596, NULL, 'G3DSA:3.30.70.330:FF:003047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91597, NULL, 'G3DSA:3.30.160.60:FF:005499', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91598, NULL, 'G3DSA:1.10.287.70:FF:000586', NULL, NULL, 'AGAP004923-PA', NULL, NULL, NULL, NULL, NULL, 4),
(91599, NULL, 'G3DSA:3.40.50.1000:FF:000571', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91600, NULL, 'G3DSA:1.10.472.10:FF:000162', NULL, NULL, 'Cyclin-l1 isoform x1', NULL, NULL, NULL, NULL, NULL, 4),
(91601, NULL, 'G3DSA:3.60.15.10:FF:000003', NULL, NULL, 'Integrator complex subunit 11', NULL, NULL, NULL, NULL, NULL, 4),
(91602, NULL, 'G3DSA:3.40.1500.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91603, NULL, 'G3DSA:3.40.50.300:FF:000570', NULL, NULL, '6-phosphofructo-2-kinase/fructose-2, 6-bisphosphatase-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(91604, NULL, 'G3DSA:2.110.10.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91605, NULL, 'G3DSA:3.40.1810.10:FF:000006', NULL, NULL, 'Agamous-like MADS-box protein AGL62', NULL, NULL, NULL, NULL, NULL, 4),
(91606, NULL, 'G3DSA:1.25.40.10:FF:003076', NULL, NULL, 'Anaphase promoting complex subunit 7, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(91607, NULL, 'G3DSA:3.40.50.300:FF:006084', NULL, NULL, 'Os04g0620066 protein', NULL, NULL, NULL, NULL, NULL, 4),
(91608, NULL, 'G3DSA:1.10.286.20:FF:000007', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(91609, NULL, 'G3DSA:3.10.450.10:FF:000070', NULL, NULL, 'Histidine-rich glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(91610, NULL, 'G3DSA:3.40.50.720:FF:001095', NULL, NULL, 'Saccharopine dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91611, NULL, 'G3DSA:1.25.40.10:FF:002502', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(91612, NULL, 'G3DSA:3.90.520.10:FF:000007', NULL, NULL, 'Mothers against decapentaplegic homolog', NULL, NULL, NULL, NULL, NULL, 4),
(91613, NULL, 'G3DSA:3.90.79.10:FF:000082', NULL, NULL, 'NUDIX hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(91614, NULL, 'G3DSA:1.10.10.2010:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91615, NULL, 'G3DSA:1.10.150.50:FF:000229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91616, NULL, 'G3DSA:3.40.50.10470:FF:000050', NULL, NULL, 'Eukaryotic Initiation Factor', NULL, NULL, NULL, NULL, NULL, 4),
(91617, NULL, 'G3DSA:3.30.70.3490:FF:000016', NULL, NULL, 'Oxysterol binding protein (Osh5)', NULL, NULL, NULL, NULL, NULL, 4),
(91618, NULL, 'G3DSA:2.60.40.10:FF:000440', NULL, NULL, 'Bent, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(91619, NULL, 'G3DSA:2.60.40.60:FF:000814', NULL, NULL, 'Cadherin-89D', NULL, NULL, NULL, NULL, NULL, 4),
(91620, NULL, 'G3DSA:3.30.1020.10:FF:000004', NULL, NULL, 'Thiol-specific antioxidant protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(91621, NULL, 'G3DSA:2.40.50.100:FF:000008', NULL, NULL, 'V-type proton ATPase catalytic subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(91622, NULL, 'G3DSA:2.40.110.10:FF:000042', NULL, NULL, 'Acyl-CoA oxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91623, NULL, 'G3DSA:1.10.510.10:FF:004321', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91624, NULL, 'G3DSA:3.40.50.300:FF:001958', NULL, NULL, 'ATP binding cassette subfamily C member 11', NULL, NULL, NULL, NULL, NULL, 4),
(91625, NULL, 'G3DSA:3.40.1090.10:FF:000091', NULL, NULL, 'Lysophospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(91626, NULL, 'G3DSA:1.10.630.10:FF:000614', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91627, NULL, 'G3DSA:3.40.50.300:FF:005595', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(91628, NULL, 'G3DSA:3.40.190.10:FF:000610', NULL, NULL, 'At1g31410', NULL, NULL, NULL, NULL, NULL, 4),
(91629, NULL, 'G3DSA:1.20.120.1080:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91630, NULL, 'G3DSA:3.40.30.10:FF:000876', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91631, NULL, 'G3DSA:3.40.30.10:FF:000590', NULL, NULL, 'Alkyl hydroperoxide reductase/ Thiol specific antioxidant/ Mal allergen', NULL, NULL, NULL, NULL, NULL, 4),
(91632, NULL, 'G3DSA:2.170.120.40:FF:000009', NULL, NULL, 'Putative secreted protein associated with spyDAC', NULL, NULL, NULL, NULL, NULL, 4),
(91633, NULL, 'G3DSA:2.170.130.20:FF:000009', NULL, NULL, 'Zinc finger CCCH domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(91634, NULL, 'G3DSA:2.60.40.840:FF:000009', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(91635, NULL, 'G3DSA:3.40.630.30:FF:000459', NULL, NULL, 'Acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(91636, NULL, 'G3DSA:1.10.510.10:FF:001836', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(91637, NULL, 'G3DSA:3.30.300.180:FF:000020', NULL, NULL, 'DNA polymerase III subunit gamma/tau', NULL, NULL, NULL, NULL, NULL, 4),
(91638, NULL, 'G3DSA:3.40.50.2300:FF:001197', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91639, NULL, 'G3DSA:2.60.40.10:FF:005454', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91640, NULL, 'G3DSA:1.20.920.10:FF:000084', NULL, NULL, 'Bromodomain_-__putative', NULL, NULL, NULL, NULL, NULL, 4),
(91641, NULL, 'G3DSA:3.40.250.10:FF:000099', NULL, NULL, '3-mercaptopyruvate sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(91642, NULL, 'G3DSA:1.10.510.10:FF:002112', NULL, NULL, 'AGAP004008-PA', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(91643, NULL, 'G3DSA:2.60.40.3780:FF:000001', NULL, NULL, 'L,D-transpeptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(91644, NULL, 'G3DSA:2.170.130.10:FF:000006', NULL, NULL, 'FhuE outer membrane receptor', NULL, NULL, NULL, NULL, NULL, 4),
(91645, NULL, 'G3DSA:3.40.120.10:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91646, NULL, 'G3DSA:2.20.70.10:FF:000207', NULL, NULL, 'YALI0D02827p', NULL, NULL, NULL, NULL, NULL, 4),
(91647, NULL, 'G3DSA:1.10.10.10:FF:000471', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(91648, NULL, 'G3DSA:3.40.395.10:FF:000013', NULL, NULL, 'SUMO specific peptidase 6', NULL, NULL, NULL, NULL, NULL, 4),
(91649, NULL, 'G3DSA:3.40.50.300:FF:002773', NULL, NULL, 'ATP-dependent helicase HRQ1', NULL, NULL, NULL, NULL, NULL, 4),
(91650, NULL, 'G3DSA:3.30.420.10:FF:000373', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91651, NULL, 'G3DSA:3.10.20.90:FF:000272', NULL, NULL, 'Serine/threonine-protein kinase STE11', NULL, NULL, NULL, NULL, NULL, 4),
(91652, NULL, 'G3DSA:3.20.20.120:FF:000020', NULL, NULL, '4-hydroxyproline betaine 2-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(91653, NULL, 'G3DSA:3.30.230.70:FF:000033', NULL, NULL, 'Exosome complex component RRP45', NULL, NULL, NULL, NULL, NULL, 4),
(91654, NULL, 'G3DSA:3.40.50.300:FF:002161', NULL, NULL, 'Septin 1', NULL, NULL, NULL, NULL, NULL, 4),
(91655, NULL, 'G3DSA:1.25.40.20:FF:001488', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91656, NULL, 'G3DSA:3.30.160.60:FF:002626', NULL, NULL, 'Zinc finger protein 850', NULL, NULL, NULL, NULL, NULL, 4),
(91657, NULL, 'G3DSA:2.60.120.920:FF:000138', NULL, NULL, 'Tripartite motif containing 69 protein', NULL, NULL, NULL, NULL, NULL, 4),
(91658, NULL, 'G3DSA:3.40.630.30:FF:000252', NULL, NULL, 'Beta-N-acetylglucosaminidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91659, NULL, 'G3DSA:1.25.40.10:FF:003637', NULL, NULL, 'Tetratricopeptide repeat protein 21B', NULL, NULL, NULL, NULL, NULL, 4),
(91660, NULL, 'G3DSA:2.170.210.10:FF:000007', NULL, NULL, 'DNA repair protein XRCC4', NULL, NULL, NULL, NULL, NULL, 4),
(91661, NULL, 'G3DSA:3.30.890.10:FF:000008', NULL, NULL, 'Methyl-CpG-binding domain-containing protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(91662, NULL, 'G3DSA:3.40.50.2300:FF:000062', NULL, NULL, 'HTH-type transcriptional regulator GntR', NULL, NULL, NULL, NULL, NULL, 4),
(91663, NULL, 'G3DSA:3.40.50.2300:FF:001422', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91664, NULL, 'G3DSA:3.90.70.10:FF:000157', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 38', NULL, NULL, NULL, NULL, NULL, 4),
(91665, NULL, 'G3DSA:3.90.550.10:FF:000453', NULL, NULL, 'Glycosyl transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(91666, NULL, 'G3DSA:3.10.20.90:FF:000221', NULL, NULL, 'Autophagy-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(91667, NULL, 'G3DSA:3.40.1810.10:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91668, NULL, 'G3DSA:1.20.1110.10:FF:000268', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91669, NULL, 'G3DSA:2.40.50.1060:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91670, NULL, 'G3DSA:2.60.40.630:FF:000003', NULL, NULL, 'Signal transducer and transcription activator 6', NULL, NULL, NULL, NULL, NULL, 4),
(91671, NULL, 'G3DSA:3.30.160.60:FF:000474', NULL, NULL, 'zinc finger protein 367', NULL, NULL, NULL, NULL, NULL, 4),
(91672, NULL, 'G3DSA:3.30.160.60:FF:001396', NULL, NULL, 'Zinc finger protein 585A', NULL, NULL, NULL, NULL, NULL, 4),
(91673, NULL, 'G3DSA:1.25.40.550:FF:000006', NULL, NULL, 'A1 cistron-splicing factor AAR2', NULL, NULL, NULL, NULL, NULL, 4),
(91674, NULL, 'G3DSA:2.90.10.10:FF:000015', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(91675, NULL, 'G3DSA:3.10.20.90:FF:000428', NULL, NULL, 'Polyubiquitin-C', NULL, NULL, NULL, NULL, NULL, 4),
(91676, NULL, 'G3DSA:2.130.10.10:FF:004184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(91677, NULL, 'G3DSA:1.20.1510.10:FF:000023', NULL, NULL, 'Metal tolerance protein C1', NULL, NULL, NULL, NULL, NULL, 4),
(91678, NULL, 'G3DSA:2.30.22.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91679, NULL, 'G3DSA:3.50.30.30:FF:000163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91680, NULL, 'G3DSA:2.70.150.10:FF:000127', NULL, NULL, 'Cation transporting P-ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(91681, NULL, 'G3DSA:3.60.20.30:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91682, NULL, 'G3DSA:2.10.90.10:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91683, NULL, 'G3DSA:1.25.40.690:FF:000020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(91684, NULL, 'G3DSA:1.10.150.20:FF:000041', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(91685, NULL, 'G3DSA:3.80.10.10:FF:001278', NULL, NULL, 'Toll-like receptor 13', NULL, NULL, NULL, NULL, NULL, 4),
(91686, NULL, 'G3DSA:2.60.40.10:FF:000165', NULL, NULL, 'MAM domain containing glycosylphosphatidylinositol anchor 2', NULL, NULL, NULL, NULL, NULL, 4),
(91687, NULL, 'G3DSA:2.40.70.10:FF:000370', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91688, NULL, 'G3DSA:3.30.160.60:FF:004190', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91689, NULL, 'G3DSA:3.30.460.10:FF:000139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91690, NULL, 'G3DSA:3.90.105.20:FF:000006', NULL, NULL, 'Ribosome assembly factor mrt4', NULL, NULL, NULL, NULL, NULL, 4),
(91691, NULL, 'G3DSA:2.60.40.150:FF:000342', NULL, NULL, 'Tcb3p', NULL, NULL, NULL, NULL, NULL, 4),
(91692, NULL, 'G3DSA:2.80.10.50:FF:000045', NULL, NULL, 'Fascin', NULL, NULL, NULL, NULL, NULL, 4),
(91693, NULL, 'G3DSA:2.130.10.10:FF:001699', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', NULL, NULL, NULL, NULL, NULL, 4),
(91694, NULL, 'G3DSA:2.60.120.370:FF:000007', NULL, NULL, 'YhcH/YjgK/YiaL family protein', NULL, NULL, NULL, NULL, NULL, 4),
(91695, NULL, 'G3DSA:3.30.9.10:FF:000277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91696, NULL, 'G3DSA:3.30.230.80:FF:000036', NULL, NULL, 'Heat shock protein 90-2', NULL, NULL, NULL, NULL, NULL, 4),
(91697, NULL, 'G3DSA:3.30.565.10:FF:000551', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91698, NULL, 'G3DSA:3.30.870.10:FF:000125', NULL, NULL, 'Tyrosyl-DNA Phosphodiesterase (Tdp1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(91699, NULL, 'G3DSA:3.30.40.10:FF:000231', NULL, NULL, 'RING-H2 finger protein ATL46', NULL, NULL, NULL, NULL, NULL, 4),
(91700, NULL, 'G3DSA:3.60.20.40:FF:000018', NULL, NULL, 'Protein CBG11402', NULL, NULL, NULL, NULL, NULL, 4),
(91701, NULL, 'G3DSA:3.90.105.10:FF:000003', NULL, NULL, 'Amino acid decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(91702, NULL, 'G3DSA:3.30.160.60:FF:006342', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91703, NULL, 'G3DSA:3.10.20.90:FF:000833', NULL, NULL, 'Small ubiquitin-related modifier', NULL, NULL, NULL, NULL, NULL, 4),
(91704, NULL, 'G3DSA:1.10.286.10:FF:000004', NULL, NULL, 'GTP cyclohydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(91705, NULL, 'G3DSA:3.90.1480.20:FF:000005', NULL, NULL, 'ST3 beta-galactoside alpha-2,3-sialyltransferase 4', NULL, NULL, NULL, NULL, NULL, 4),
(91706, NULL, 'G3DSA:1.20.140.50:FF:000007', NULL, NULL, 'Protein CBR-ALX-1, isoform b', NULL, NULL, NULL, NULL, NULL, 4),
(91707, NULL, 'G3DSA:1.20.1270.170:FF:000003', NULL, NULL, 'Stress response kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(91708, NULL, 'G3DSA:1.20.58.390:FF:000057', NULL, NULL, 'Resistance to dieldrin, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(91709, NULL, 'G3DSA:3.30.160.60:FF:002385', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(91710, NULL, 'G3DSA:3.90.190.10:FF:000548', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(91711, NULL, 'G3DSA:2.120.10.30:FF:000031', NULL, NULL, 'B-box type zinc finger protein ncl-1', NULL, NULL, NULL, NULL, NULL, 4),
(91712, NULL, 'G3DSA:3.10.610.10:FF:000004', NULL, NULL, 'Type II secretion system protein J', NULL, NULL, NULL, NULL, NULL, 4),
(91713, NULL, 'G3DSA:2.130.10.10:FF:005089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91714, NULL, 'G3DSA:2.60.300.12:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91715, NULL, 'G3DSA:1.20.1070.10:FF:001219', NULL, NULL, 'GM15262', NULL, NULL, NULL, NULL, NULL, 4),
(91716, NULL, 'G3DSA:3.30.1330.30:FF:000028', NULL, NULL, 'H/ACA ribonucleoprotein complex subunit 2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(91717, NULL, 'G3DSA:2.60.120.920:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91718, NULL, 'G3DSA:3.10.20.30:FF:000068', NULL, NULL, 'Ferredoxin reductase component of carbazole', NULL, NULL, NULL, NULL, NULL, 4),
(91719, NULL, 'G3DSA:3.30.1330.20:FF:000025', NULL, NULL, '50S ribosomal protein L34', NULL, NULL, NULL, NULL, NULL, 4),
(91720, NULL, 'G3DSA:2.30.30.70:FF:000003', NULL, NULL, '60S ribosomal protein L21', NULL, NULL, NULL, NULL, NULL, 4),
(91721, NULL, 'G3DSA:3.40.50.2000:FF:000202', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(91722, NULL, 'G3DSA:3.30.40.10:FF:000113', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(91723, NULL, 'G3DSA:3.40.190.10:FF:000043', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(91724, NULL, 'G3DSA:4.10.800.20:FF:000012', NULL, NULL, 'AMP deaminase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91725, NULL, 'G3DSA:3.50.50.60:FF:001078', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] flavoprotein subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(91726, NULL, 'G3DSA:2.60.40.10:FF:004026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91727, NULL, 'G3DSA:2.60.40.60:FF:000247', NULL, NULL, 'Protocadherin 12', NULL, NULL, NULL, NULL, NULL, 4),
(91728, NULL, 'G3DSA:3.30.1330.10:FF:000022', NULL, NULL, 'Selenide water dikinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91729, NULL, 'G3DSA:3.30.200.20:FF:000426', NULL, NULL, 'Serine/threonine-protein kinase ssn3', NULL, NULL, NULL, NULL, NULL, 4),
(91730, NULL, 'G3DSA:1.20.120.790:FF:000019', NULL, NULL, 'Chaperone protein HtpG', NULL, NULL, NULL, NULL, NULL, 4),
(91731, NULL, 'G3DSA:3.40.50.720:FF:001320', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91732, NULL, 'G3DSA:2.60.40.60:FF:000191', NULL, NULL, 'Cadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(91733, NULL, 'G3DSA:3.30.1360.70:FF:000019', NULL, NULL, 'Arginyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(91734, NULL, 'G3DSA:1.25.40.990:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91735, NULL, 'G3DSA:3.30.160.60:FF:000827', NULL, NULL, 'Zinc finger protein Gfi-1', NULL, NULL, NULL, NULL, NULL, 4),
(91736, NULL, 'G3DSA:3.50.50.60:FF:001128', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(91737, NULL, 'G3DSA:2.130.10.10:FF:004633', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91738, NULL, 'G3DSA:2.60.40.2440:FF:000009', NULL, NULL, 'Protein interacting with gsy2p', NULL, NULL, NULL, NULL, NULL, 4),
(91739, NULL, 'G3DSA:1.10.10.10:FF:001477', NULL, NULL, 'Protein CBG12577', NULL, NULL, NULL, NULL, NULL, 4),
(91740, NULL, 'G3DSA:2.60.40.10:FF:005662', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91741, NULL, 'G3DSA:2.60.40.60:FF:000253', NULL, NULL, 'Cadherin 16, KSP-cadherin', NULL, NULL, NULL, NULL, NULL, 4),
(91742, NULL, 'G3DSA:1.10.533.10:FF:000118', NULL, NULL, 'TUBE', NULL, NULL, NULL, NULL, NULL, 4),
(91743, NULL, 'G3DSA:4.10.365.10:FF:000008', NULL, NULL, 'CKI family (Cyclin-dependent Kinase Inhibitor)', NULL, NULL, NULL, NULL, NULL, 4),
(91744, NULL, 'G3DSA:1.25.10.10:FF:000701', NULL, NULL, 'V-type proton ATPase subunit H', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(91745, NULL, 'G3DSA:3.10.310.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91746, NULL, 'G3DSA:3.40.50.10700:FF:000006', NULL, NULL, 'Os09g0248000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(91747, NULL, 'G3DSA:1.25.40.10:FF:000153', NULL, NULL, 'Transmembrane and tetratricopeptide repeat containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(91748, NULL, 'G3DSA:1.10.10.1080:FF:000001', NULL, NULL, 'Stn1p', NULL, NULL, NULL, NULL, NULL, 4),
(91749, NULL, 'G3DSA:3.30.930.10:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91750, NULL, 'G3DSA:1.20.5.190:FF:000054', NULL, NULL, 'Calmodulin-binding transcription activator 4', NULL, NULL, NULL, NULL, NULL, 4),
(91751, NULL, 'G3DSA:1.20.5.4010:FF:000001', NULL, NULL, 'protein quaking isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(91752, NULL, 'G3DSA:4.10.410.10:FF:000086', NULL, NULL, 'IP13257p', NULL, NULL, NULL, NULL, NULL, 4),
(91753, NULL, 'G3DSA:1.10.3370.10:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91754, NULL, 'G3DSA:3.10.129.10:FF:000003', NULL, NULL, '3-hydroxydecanoyl-[acyl-carrier-protein] dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(91755, NULL, 'G3DSA:3.40.50.300:FF:000648', NULL, NULL, 'Stage IV sporulation protein A', NULL, NULL, NULL, NULL, NULL, 4),
(91756, NULL, 'G3DSA:3.80.10.10:FF:003077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91757, NULL, 'G3DSA:3.40.1710.10:FF:000004', NULL, NULL, 'Multidrug ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(91758, NULL, 'G3DSA:3.30.830.10:FF:000128', NULL, NULL, 'Phosphoglycan beta 1,3 galactosyltransferase 5', NULL, NULL, NULL, NULL, NULL, 4),
(91759, NULL, 'G3DSA:3.30.450.90:FF:000022', NULL, NULL, 'Type 4 pili biogenesis protein (Nuleotide-binding protein)', NULL, NULL, NULL, NULL, NULL, 4),
(91760, NULL, 'G3DSA:1.20.140.40:FF:000004', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(91761, NULL, 'G3DSA:1.25.40.20:FF:000156', NULL, NULL, 'ankyrin repeat and KH domain-containing protein 1-like isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(91762, NULL, 'G3DSA:3.20.20.80:FF:000689', NULL, NULL, 'Chitinase-like protein PB1E7.04c', NULL, NULL, NULL, NULL, NULL, 4),
(91763, NULL, 'G3DSA:1.10.630.10:FF:000827', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91764, NULL, 'G3DSA:3.40.50.150:FF:000682', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase G', NULL, NULL, NULL, NULL, NULL, 4),
(91765, NULL, 'G3DSA:6.10.140.2200:FF:000001', NULL, NULL, 'Cbp/p300-interacting transactivator 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(91766, NULL, 'G3DSA:2.130.10.10:FF:004004', NULL, NULL, 'AGL156Wp', NULL, NULL, NULL, NULL, NULL, 4),
(91767, NULL, 'G3DSA:2.60.40.150:FF:000404', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(91768, NULL, 'G3DSA:1.10.455.10:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91769, NULL, 'G3DSA:2.30.180.10:FF:000138', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91770, NULL, 'G3DSA:2.30.29.30:FF:000033', NULL, NULL, 'Rho-associated protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(91771, NULL, 'G3DSA:3.20.20.70:FF:000366', NULL, NULL, 'Hyaluronidase', NULL, NULL, NULL, NULL, NULL, 4),
(91772, NULL, 'G3DSA:1.10.15.40:FF:000002', NULL, NULL, 'Periplasmic [Fe] hydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(91773, NULL, 'G3DSA:1.25.70.10:FF:000031', NULL, NULL, 'Transcription termination factor MTERF2 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(91774, NULL, 'G3DSA:3.90.1410.10:FF:000015', NULL, NULL, 'Ribosomal lysine N-methyltransferase 4', NULL, NULL, NULL, NULL, NULL, 4),
(91775, NULL, 'G3DSA:1.10.510.10:FF:001387', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', NULL, NULL, NULL, NULL, NULL, 4),
(91776, NULL, 'G3DSA:2.60.120.330:FF:000175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91777, NULL, 'G3DSA:1.10.3380.30:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(91778, NULL, 'G3DSA:3.80.10.10:FF:001003', NULL, NULL, 'Os03g0228800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(91779, NULL, 'G3DSA:2.60.40.10:FF:005549', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91780, NULL, 'G3DSA:1.10.533.10:FF:000175', NULL, NULL, 'Apoptotic protease-activating factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91781, NULL, 'G3DSA:3.60.20.10:FF:000268', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91782, NULL, 'G3DSA:3.20.20.120:FF:000014', NULL, NULL, 'Enolase', NULL, NULL, NULL, NULL, NULL, 4),
(91783, NULL, 'G3DSA:2.40.20.10:FF:000092', NULL, NULL, 'Plasminogen activator, urokinase a', NULL, NULL, NULL, NULL, NULL, 4),
(91784, NULL, 'G3DSA:3.50.4.10:FF:000030', NULL, NULL, 'Protein CBR-NOAH-2', NULL, NULL, NULL, NULL, NULL, 4),
(91785, NULL, 'G3DSA:1.25.40.10:FF:003817', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(91786, NULL, 'G3DSA:2.40.50.90:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91787, NULL, 'G3DSA:3.40.50.300:FF:006163', NULL, NULL, 'Ras family protein', NULL, NULL, NULL, NULL, NULL, 4),
(91788, NULL, 'G3DSA:2.60.200.20:FF:000042', NULL, NULL, 'Kinesin-like protein Klp98A', NULL, NULL, NULL, NULL, NULL, 4),
(91789, NULL, 'G3DSA:3.20.20.70:FF:000653', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91790, NULL, 'G3DSA:3.30.160.60:FF:000148', NULL, NULL, 'zinc finger protein Gfi-1', NULL, NULL, NULL, NULL, NULL, 4),
(91791, NULL, 'G3DSA:2.10.90.10:FF:000024', NULL, NULL, 'Inhibin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(91792, NULL, 'G3DSA:1.10.443.20:FF:000002', NULL, NULL, 'Transposable element-crypton-Cn1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91793, NULL, 'G3DSA:3.30.200.20:FF:001904', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91794, NULL, 'G3DSA:2.30.110.10:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91795, NULL, 'G3DSA:3.40.1110.10:FF:000436', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91796, NULL, 'G3DSA:2.30.30.90:FF:000009', NULL, NULL, 'FeoA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(91797, NULL, 'G3DSA:3.40.50.300:FF:004460', NULL, NULL, 'Small GTP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(91798, NULL, 'G3DSA:3.30.160.60:FF:002008', NULL, NULL, 'Zinc finger protein 684', NULL, NULL, NULL, NULL, NULL, 4),
(91799, NULL, 'G3DSA:1.10.730.10:FF:000032', NULL, NULL, 'Leucine--tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91800, NULL, 'G3DSA:2.80.10.50:FF:000253', NULL, NULL, 'Fascin', NULL, NULL, NULL, NULL, NULL, 4),
(91801, NULL, 'G3DSA:2.60.40.1850:FF:000001', NULL, NULL, 'Heme uptake protein IsdC', NULL, NULL, NULL, NULL, NULL, 4),
(91802, NULL, 'G3DSA:3.40.120.10:FF:000044', NULL, NULL, 'Phosphoglucomutase', NULL, NULL, NULL, NULL, NULL, 4),
(91803, NULL, 'G3DSA:3.90.730.10:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91804, NULL, 'G3DSA:1.10.238.10:FF:000163', NULL, NULL, 'Calmodulin like 6', NULL, NULL, NULL, NULL, NULL, 4),
(91805, NULL, 'G3DSA:2.60.260.20:FF:000045', NULL, NULL, 'DnaJ protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91806, NULL, 'G3DSA:2.40.50.150:FF:000045', NULL, NULL, 'RNA polymerase II second largest subunit (RPB2), putative', NULL, NULL, NULL, NULL, NULL, 4),
(91807, NULL, 'G3DSA:3.30.40.10:FF:001248', NULL, NULL, 'Ring finger protein 180', NULL, NULL, NULL, NULL, NULL, 4),
(91808, NULL, 'G3DSA:3.30.930.10:FF:000338', NULL, NULL, 'Class II aminoacyl-tRNA and biotin synthetases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(91809, NULL, 'G3DSA:2.40.30.10:FF:000159', NULL, NULL, 'Translation elongation factor alpha', NULL, NULL, NULL, NULL, NULL, 4),
(91810, NULL, 'G3DSA:1.50.10.150:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91811, NULL, 'G3DSA:1.10.390.10:FF:000106', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(91812, NULL, 'G3DSA:2.130.10.10:FF:000682', NULL, NULL, 'Actin-related protein 2/3 complex subunit', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(91813, NULL, 'G3DSA:1.20.120.1750:FF:000112', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(91814, NULL, 'G3DSA:1.10.1420.10:FF:000142', NULL, NULL, 'Him-14', NULL, NULL, NULL, NULL, NULL, 4),
(91815, NULL, 'G3DSA:3.40.50.300:FF:004072', NULL, NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', NULL, NULL, NULL, NULL, NULL, 4),
(91816, NULL, 'G3DSA:1.10.1750.10:FF:000009', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(91817, NULL, 'G3DSA:3.10.100.10:FF:000246', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91818, NULL, 'G3DSA:2.20.25.10:FF:000036', NULL, NULL, 'Transcription initiation factor IIB', NULL, NULL, NULL, NULL, NULL, 4),
(91819, NULL, 'G3DSA:3.40.50.2300:FF:001489', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91820, NULL, 'G3DSA:1.10.150.780:FF:000013', NULL, NULL, 'Probable vacuolar protein sorting-associated protein 16 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(91821, NULL, 'G3DSA:3.40.50.300:FF:000862', NULL, NULL, 'Eukaryotic peptide chain release factor GTP-binding subunit ERF3A', NULL, NULL, NULL, NULL, NULL, 4),
(91822, NULL, 'G3DSA:3.30.559.30:FF:000048', NULL, NULL, 'Nonribosomal peptide synthase GliP2', NULL, NULL, NULL, NULL, NULL, 4),
(91823, NULL, 'G3DSA:2.40.160.20:FF:000025', NULL, NULL, 'Omp-1X', NULL, NULL, NULL, NULL, NULL, 4),
(91824, NULL, 'G3DSA:3.40.50.1820:FF:001480', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91825, NULL, 'G3DSA:1.10.510.10:FF:002180', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91826, NULL, 'G3DSA:3.40.720.10:FF:000298', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(91827, NULL, 'G3DSA:3.10.310.20:FF:000006', NULL, NULL, 'Manganese-dependent inorganic pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(91828, NULL, 'G3DSA:2.60.40.10:FF:000614', NULL, NULL, 'Bent, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(91829, NULL, 'G3DSA:2.60.120.1440:FF:000007', NULL, NULL, 'Probable transmembrane sensor', NULL, NULL, NULL, NULL, NULL, 4),
(91830, NULL, 'G3DSA:3.30.750.24:FF:000040', NULL, NULL, 'Anion transporter SULP-4', NULL, NULL, NULL, NULL, NULL, 4),
(91831, NULL, 'G3DSA:3.40.50.300:FF:006258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91832, NULL, 'G3DSA:3.90.1170.20:FF:000015', NULL, NULL, 'Nicotinate-nucleotide pyrophosphorylase [carboxylating]', NULL, NULL, NULL, NULL, NULL, 4),
(91833, NULL, 'G3DSA:3.20.20.10:FF:000034', NULL, NULL, 'Alanine racemase', NULL, NULL, NULL, NULL, NULL, 4),
(91834, NULL, 'G3DSA:2.20.25.110:FF:000001', NULL, NULL, 'Cypemycin methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(91835, NULL, 'G3DSA:2.60.40.150:FF:000016', NULL, NULL, 'Synaptotagmin 1', NULL, NULL, NULL, NULL, NULL, 4),
(91836, NULL, 'G3DSA:2.60.40.1860:FF:000004', NULL, NULL, 'Peptidyl arginine deiminase 6', NULL, NULL, NULL, NULL, NULL, 4),
(91837, NULL, 'G3DSA:4.10.640.10:FF:000007', NULL, NULL, '28S ribosomal protein S18c, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(91838, NULL, 'G3DSA:2.40.160.10:FF:000022', NULL, NULL, 'Porin', NULL, NULL, NULL, NULL, NULL, 4),
(91839, NULL, 'G3DSA:3.40.30.10:FF:001040', NULL, NULL, 'Thyroxine 5''-deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(91840, NULL, 'G3DSA:2.30.29.30:FF:001281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91841, NULL, 'G3DSA:3.20.20.140:FF:000352', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(91842, NULL, 'G3DSA:3.80.10.10:FF:003420', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91843, NULL, 'G3DSA:3.90.980.20:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91844, NULL, 'G3DSA:2.170.120.30:FF:000012', NULL, NULL, 'Putative exported protein', NULL, NULL, NULL, NULL, NULL, 4),
(91845, NULL, 'G3DSA:2.30.30.140:FF:000277', NULL, NULL, 'Protein CBG13704', NULL, NULL, NULL, NULL, NULL, 4),
(91846, NULL, 'G3DSA:3.30.160.60:FF:005886', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(91847, NULL, 'G3DSA:1.10.30.10:FF:000062', NULL, NULL, 'Hmg-1.1', NULL, NULL, NULL, NULL, NULL, 4),
(91848, NULL, 'G3DSA:1.10.510.10:FF:004242', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91849, NULL, 'G3DSA:2.60.120.260:FF:000300', NULL, NULL, 'Trypsin-like serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(91850, NULL, 'G3DSA:1.20.1250.20:FF:002102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91851, NULL, 'G3DSA:3.30.40.10:FF:001541', NULL, NULL, 'Putative e3 ubiquitin-protein ligase ubr7', NULL, NULL, NULL, NULL, NULL, 4),
(91852, NULL, 'G3DSA:1.20.1070.10:FF:002001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91853, NULL, 'G3DSA:2.130.10.10:FF:002216', NULL, NULL, 'Protein HIRA', NULL, NULL, NULL, NULL, NULL, 4),
(91854, NULL, 'G3DSA:3.30.1050.10:FF:000040', NULL, NULL, 'Non-specific lipid-transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(91855, NULL, 'G3DSA:3.40.50.300:FF:003678', NULL, NULL, 'Adenylate/guanylate cyclase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(91856, NULL, 'G3DSA:1.10.530.10:FF:000090', NULL, NULL, 'lysozyme g', NULL, NULL, NULL, NULL, NULL, 4),
(91857, NULL, 'G3DSA:1.10.555.10:FF:000074', NULL, NULL, 'RhoGAP GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91858, NULL, 'G3DSA:3.50.50.60:FF:001342', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91859, NULL, 'G3DSA:1.25.40.10:FF:005088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91860, NULL, 'G3DSA:3.20.20.80:FF:000369', NULL, NULL, 'Zgc:66313', NULL, NULL, NULL, NULL, NULL, 4),
(91861, NULL, 'G3DSA:1.10.510.10:FF:000931', NULL, NULL, 'Ballchen, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(91862, NULL, 'G3DSA:3.30.565.10:FF:000045', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(91863, NULL, 'G3DSA:2.60.40.10:FF:000491', NULL, NULL, 'Immunoglobulin superfamily, member 3', NULL, NULL, NULL, NULL, NULL, 4),
(91864, NULL, 'G3DSA:3.60.21.10:FF:000416', NULL, NULL, 'Uncharacterized protein C23A1.02c', NULL, NULL, NULL, NULL, NULL, 4),
(91865, NULL, 'G3DSA:1.25.40.180:FF:000199', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91866, NULL, 'G3DSA:1.10.10.2660:FF:000014', NULL, NULL, 'Ubiquitin-activating enzyme-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(91867, NULL, 'G3DSA:1.10.10.820:FF:000024', NULL, NULL, 'Unplaced genomic scaffold supercont1.8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(91868, NULL, 'G3DSA:3.80.10.10:FF:001211', NULL, NULL, 'Si:ch211-181d7.1', NULL, NULL, NULL, NULL, NULL, 4),
(91869, NULL, 'G3DSA:3.40.50.300:FF:002481', NULL, NULL, 'MIP14774p', NULL, NULL, NULL, NULL, NULL, 4),
(91870, NULL, 'G3DSA:3.40.50.10190:FF:000286', NULL, NULL, 'DNA ligase 4', NULL, NULL, NULL, NULL, NULL, 4),
(91871, NULL, 'G3DSA:1.20.1250.20:FF:001208', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91872, NULL, 'G3DSA:2.130.10.10:FF:001778', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1', NULL, NULL, NULL, NULL, NULL, 4),
(91873, NULL, 'G3DSA:1.20.58.760:FF:000022', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(91874, NULL, 'G3DSA:1.10.10.60:FF:000019', NULL, NULL, 'Ligand-dependent corepressor isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(91875, NULL, 'G3DSA:3.40.50.300:FF:000805', NULL, NULL, 'ATP-dependent DNA helicase PIF1', NULL, NULL, NULL, NULL, NULL, 4),
(91876, NULL, 'G3DSA:1.25.40.10:FF:001777', NULL, NULL, 'Os01g0959600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(91877, NULL, 'G3DSA:1.10.20.10:FF:000235', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91878, NULL, 'G3DSA:3.20.20.70:FF:000574', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91879, NULL, 'G3DSA:3.30.530.20:FF:000204', NULL, NULL, 'Protein retinal degeneration B-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(91880, NULL, 'G3DSA:1.20.1440.340:FF:000003', NULL, NULL, 'GAL1p Galactokinase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(91881, NULL, 'G3DSA:2.60.40.340:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91882, NULL, 'G3DSA:2.40.10.10:FF:000214', NULL, NULL, 'Protein Z, vitamin K-dependent plasma glycoprotein a', NULL, NULL, NULL, NULL, NULL, 4),
(91883, NULL, 'G3DSA:2.30.29.30:FF:001129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91884, NULL, 'G3DSA:3.65.10.10:FF:000009', NULL, NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(91885, NULL, 'G3DSA:1.10.10.60:FF:000171', NULL, NULL, 'Homeobox transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(91886, NULL, 'G3DSA:2.10.25.10:FF:000385', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(91887, NULL, 'G3DSA:1.20.1280.160:FF:000002', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(91888, NULL, 'G3DSA:1.20.1530.20:FF:000022', NULL, NULL, 'Cation/H(+) antiporter 24', NULL, NULL, NULL, NULL, NULL, 4),
(91889, NULL, 'G3DSA:3.30.70.330:FF:003098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91890, NULL, 'G3DSA:1.10.1450.10:FF:000144', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(91891, NULL, 'G3DSA:2.60.120.1000:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91892, NULL, 'G3DSA:3.40.50.720:FF:001056', NULL, NULL, 'Pyrroline-5-carboxylate reductase 3', NULL, NULL, NULL, NULL, NULL, 4),
(91893, NULL, 'G3DSA:1.25.40.10:FF:004632', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91894, NULL, 'G3DSA:1.20.1610.10:FF:000020', NULL, NULL, 'Chromosome 21, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(91895, NULL, 'G3DSA:2.40.30.10:FF:000502', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91896, NULL, 'G3DSA:3.90.70.10:FF:000449', NULL, NULL, 'HlyB/MsbA family ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(91897, NULL, 'G3DSA:1.10.510.10:FF:003747', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91898, NULL, 'G3DSA:2.170.190.11:FF:000017', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(91899, NULL, 'G3DSA:3.30.70.330:FF:002030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91900, NULL, 'G3DSA:3.10.290.10:FF:000029', NULL, NULL, 'Pseudouridine synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91901, NULL, 'G3DSA:1.20.1070.10:FF:001495', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91902, NULL, 'G3DSA:1.20.58.2220:FF:000009', NULL, NULL, 'Disheveled-associated activator of morphogenesis', NULL, NULL, NULL, NULL, NULL, 4),
(91903, NULL, 'G3DSA:3.30.450.40:FF:000304', NULL, NULL, 'Sensory box/ggdef domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(91904, NULL, 'G3DSA:3.40.50.300:FF:004572', NULL, NULL, 'Similarity to HepA-related protein Harp', NULL, NULL, NULL, NULL, NULL, 4),
(91905, NULL, 'G3DSA:2.60.40.1400:FF:000001', NULL, NULL, 'G protein-activated inward rectifier potassium channel 2', NULL, NULL, NULL, NULL, NULL, 4),
(91906, NULL, 'G3DSA:3.40.50.1000:FF:000245', NULL, NULL, '4-nitrophenyl phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(91907, NULL, 'G3DSA:3.30.1330.30:FF:000085', NULL, NULL, 'GD14076', NULL, NULL, NULL, NULL, NULL, 4),
(91908, NULL, 'G3DSA:2.30.30.140:FF:000338', NULL, NULL, 'RBB1NT (NUC162) domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(91909, NULL, 'G3DSA:4.10.110.10:FF:000007', NULL, NULL, 'Lysosomal alpha-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(91910, NULL, 'G3DSA:3.30.160.60:FF:002177', NULL, NULL, 'Zinc finger protein 404', NULL, NULL, NULL, NULL, NULL, 4),
(91911, NULL, 'G3DSA:2.120.10.30:FF:000211', NULL, NULL, 'Teneurin-1', NULL, NULL, NULL, NULL, NULL, 4),
(91912, NULL, 'G3DSA:3.30.1490.120:FF:000002', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC8', NULL, NULL, NULL, NULL, NULL, 4),
(91913, NULL, 'G3DSA:3.30.70.890:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91914, NULL, 'G3DSA:2.10.25.10:FF:001407', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(91915, NULL, 'G3DSA:1.10.1200.10:FF:000036', NULL, NULL, 'Acyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(91916, NULL, 'G3DSA:3.30.160.60:FF:000086', NULL, NULL, 'transcription factor E4F1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(91917, NULL, 'G3DSA:3.90.79.10:FF:000110', NULL, NULL, 'Putative nudix hydrolase 6', NULL, NULL, NULL, NULL, NULL, 4),
(91918, NULL, 'G3DSA:2.30.180.10:FF:000043', NULL, NULL, 'Fasciclin-like arabinogalactan protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(91919, NULL, 'G3DSA:3.40.140.100:FF:000018', NULL, NULL, 'Ubiquitin activating enzyme e1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(91920, NULL, 'G3DSA:3.40.47.10:FF:000061', NULL, NULL, 'Thiolase, C-terminal domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(91921, NULL, 'G3DSA:3.40.720.10:FF:000365', NULL, NULL, 'Uncharacterized protein HI_0841', NULL, NULL, NULL, NULL, NULL, 4),
(91922, NULL, 'G3DSA:3.40.50.920:FF:000042', NULL, NULL, '2-oxoglutarate ferredoxin oxidoreductase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(91923, NULL, 'G3DSA:1.20.1250.40:FF:000017', NULL, NULL, 'DNA-directed RNA polymerase II subunit RPB4', NULL, NULL, NULL, NULL, NULL, 4),
(91924, NULL, 'G3DSA:2.60.120.10:FF:000392', NULL, NULL, 'AtABP1-like auxin binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(91925, NULL, 'G3DSA:3.90.550.10:FF:000065', NULL, NULL, 'UDP-glucose:glycoprotein glucosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91926, NULL, 'G3DSA:3.90.70.10:FF:000803', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(91927, NULL, 'G3DSA:3.40.50.970:FF:000130', NULL, NULL, 'N(2)-(2-carboxyethyl)arginine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(91928, NULL, 'G3DSA:1.25.40.10:FF:004014', NULL, NULL, 'AFR088Wp', NULL, NULL, NULL, NULL, NULL, 4),
(91929, NULL, 'G3DSA:2.40.70.10:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91930, NULL, 'G3DSA:3.30.70.330:FF:001299', NULL, NULL, 'At3g08000', NULL, NULL, NULL, NULL, NULL, 4),
(91931, NULL, 'G3DSA:3.40.47.10:FF:000302', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91932, NULL, 'G3DSA:3.30.1330.30:FF:000096', NULL, NULL, 'RNA methyltransferase, TrmH family, group 3', NULL, NULL, NULL, NULL, NULL, 4),
(91933, NULL, 'G3DSA:2.130.10.10:FF:002273', NULL, NULL, 'IFT complex A', NULL, NULL, NULL, NULL, NULL, 4),
(91934, NULL, 'G3DSA:2.60.40.10:FF:001688', NULL, NULL, 'GM13016', NULL, NULL, NULL, NULL, NULL, 4),
(91935, NULL, 'G3DSA:3.80.10.10:FF:001486', NULL, NULL, 'DNA repair protein rhp7 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(91936, NULL, 'G3DSA:1.10.455.10:FF:000010', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(91937, NULL, 'G3DSA:2.40.30.10:FF:000148', NULL, NULL, 'Sulfate adenylyltransferase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(91938, NULL, 'G3DSA:3.30.1370.10:FF:000210', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91939, NULL, 'G3DSA:3.90.1030.20:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91940, NULL, 'G3DSA:1.10.472.10:FF:000370', NULL, NULL, 'Cyclin G2', NULL, NULL, NULL, NULL, NULL, 4),
(91941, NULL, 'G3DSA:3.30.420.40:FF:000235', NULL, NULL, 'ROK family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(91942, NULL, 'G3DSA:1.10.510.10:FF:000942', NULL, NULL, 'Serine/threonine-protein kinase KSP1', NULL, NULL, NULL, NULL, NULL, 4),
(91943, NULL, 'G3DSA:1.10.287.110:FF:000059', NULL, NULL, 'dnaJ homolog subfamily C member 17', NULL, NULL, NULL, NULL, NULL, 4),
(91944, NULL, 'G3DSA:1.10.533.10:FF:000006', NULL, NULL, 'Tumor necrosis factor receptor superfamily member EDAR', NULL, NULL, NULL, NULL, NULL, 4),
(91945, NULL, 'G3DSA:3.40.50.2000:FF:000320', NULL, NULL, '3-deoxy-D-manno-octulosonic acid transferase', NULL, NULL, NULL, NULL, NULL, 4),
(91946, NULL, 'G3DSA:1.10.630.10:FF:000766', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(91947, NULL, 'G3DSA:1.20.58.340:FF:000037', NULL, NULL, 'Magnesium transporter MRS2-5 like', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(91948, NULL, 'G3DSA:3.30.70.2820:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91949, NULL, 'G3DSA:3.40.1770.10:FF:000002', NULL, NULL, 'Urocanate hydratase 1', NULL, NULL, NULL, NULL, NULL, 4),
(91950, NULL, 'G3DSA:3.40.120.10:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91951, NULL, 'G3DSA:3.10.250.10:FF:000083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91952, NULL, 'G3DSA:3.20.20.60:FF:000088', NULL, NULL, 'Carboxyvinyl-carboxyphosphonate phosphorylmutase', NULL, NULL, NULL, NULL, NULL, 4),
(91953, NULL, 'G3DSA:3.40.50.300:FF:004813', NULL, NULL, 'ATPase, AAA family', NULL, NULL, NULL, NULL, NULL, 4),
(91954, NULL, 'G3DSA:3.40.140.10:FF:000219', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(91955, NULL, 'G3DSA:3.30.70.80:FF:000001', NULL, NULL, 'Multiple organellar RNA editing factor', NULL, NULL, NULL, NULL, NULL, 4),
(91956, NULL, 'G3DSA:3.80.10.10:FF:004437', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91957, NULL, 'G3DSA:3.40.50.10470:FF:000016', NULL, NULL, 'Methylthioribose-1-phosphate isomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(91958, NULL, 'G3DSA:3.40.50.2300:FF:001490', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91959, NULL, 'G3DSA:1.10.2000.10:FF:000066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91960, NULL, 'G3DSA:3.20.20.10:FF:000045', NULL, NULL, 'Alanine racemase', NULL, NULL, NULL, NULL, NULL, 4),
(91961, NULL, 'G3DSA:1.10.238.10:FF:000281', NULL, NULL, 'Calcium-binding EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(91962, NULL, 'G3DSA:3.40.50.2020:FF:000040', NULL, NULL, 'Phosphoribosyl pyrophosphate synthetase 1', NULL, NULL, NULL, NULL, NULL, 4),
(91963, NULL, 'G3DSA:2.10.25.10:FF:001520', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91964, NULL, 'G3DSA:2.40.10.10:FF:000153', NULL, NULL, 'Venom plasminogen activator TSV-PA', NULL, NULL, NULL, NULL, NULL, 4),
(91965, NULL, 'G3DSA:1.25.40.430:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91966, NULL, 'G3DSA:2.10.25.10:FF:001166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91967, NULL, 'G3DSA:3.20.20.80:FF:000577', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(91968, NULL, 'G3DSA:4.10.1000.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91969, NULL, 'G3DSA:3.30.420.40:FF:000292', NULL, NULL, 'Heat shock cognate 71 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(91970, NULL, 'G3DSA:2.30.30.40:FF:000461', NULL, NULL, 'Hematopoietic cell-specific Lyn substrate 1', NULL, NULL, NULL, NULL, NULL, 4),
(91971, NULL, 'G3DSA:3.40.50.300:FF:001997', NULL, NULL, 'Pre-mRNA splicing factor RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(91972, NULL, 'G3DSA:1.25.40.10:FF:000703', NULL, NULL, 'Unplaced genomic scaffold supercont1.19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(91973, NULL, 'G3DSA:3.30.9.10:FF:000108', NULL, NULL, 'D-aspartate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(91974, NULL, 'G3DSA:1.20.1110.10:FF:000206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91975, NULL, 'G3DSA:3.40.50.2300:FF:001214', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91976, NULL, 'G3DSA:1.25.40.20:FF:000706', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91977, NULL, 'G3DSA:3.80.10.10:FF:003627', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91978, NULL, 'G3DSA:3.40.50.300:FF:004459', NULL, NULL, 'Novel protein similar to guanylate binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(91979, NULL, 'G3DSA:3.40.50.300:FF:002329', NULL, NULL, 'ATP-binding cassette protein subfamily F, member 3', NULL, NULL, NULL, NULL, NULL, 4),
(91980, NULL, 'G3DSA:1.10.8.720:FF:000024', NULL, NULL, 'AGAP010790-PA', NULL, NULL, NULL, NULL, NULL, 4),
(91981, NULL, 'G3DSA:1.10.10.2670:FF:000017', NULL, NULL, 'YALI0B03718p', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(91982, NULL, 'G3DSA:2.10.70.10:FF:000192', NULL, NULL, 'Fraser extracellular matrix complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(91983, NULL, 'G3DSA:1.10.287.110:FF:000391', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91984, NULL, 'G3DSA:3.80.10.10:FF:003009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91985, NULL, 'G3DSA:3.40.50.150:FF:000272', NULL, NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(91986, NULL, 'G3DSA:3.40.50.300:FF:002273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91987, NULL, 'G3DSA:3.40.50.300:FF:007950', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91988, NULL, 'G3DSA:1.25.40.1030:FF:000029', NULL, NULL, 'Protein transport protein sec16', NULL, NULL, NULL, NULL, NULL, 4),
(91989, NULL, 'G3DSA:3.90.110.10:FF:000021', NULL, NULL, 'Malate dehydrogenase 1B, NAD (soluble)', NULL, NULL, NULL, NULL, NULL, 4),
(91990, NULL, 'G3DSA:3.70.10.10:FF:000071', NULL, NULL, 'Beta sliding clamp', NULL, NULL, NULL, NULL, NULL, 4),
(91991, NULL, 'G3DSA:2.60.120.310:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91992, NULL, 'G3DSA:3.40.50.1820:FF:000131', NULL, NULL, 'Monoglyceride lipase', NULL, NULL, NULL, NULL, NULL, 4),
(91993, NULL, 'G3DSA:3.30.160.60:FF:000322', NULL, NULL, 'GDNF-inducible zinc finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(91994, NULL, 'G3DSA:2.70.130.10:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(91995, NULL, 'G3DSA:1.10.3090.10:FF:000015', NULL, NULL, 'tRNA nucleotidyltransferase putative', NULL, NULL, NULL, NULL, NULL, 4),
(91996, NULL, 'G3DSA:2.130.10.10:FF:004072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(91997, NULL, 'G3DSA:2.60.120.1540:FF:000004', NULL, NULL, 'CD109 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(91998, NULL, 'G3DSA:2.70.170.10:FF:000044', NULL, NULL, 'AcetylCholine Receptor', NULL, NULL, NULL, NULL, NULL, 4),
(91999, NULL, 'G3DSA:3.30.930.10:FF:000395', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92000, NULL, 'G3DSA:3.30.450.60:FF:000069', NULL, NULL, 'AP complex subunit sigma', NULL, NULL, NULL, NULL, NULL, 4),
(92001, NULL, 'G3DSA:1.20.120.1080:FF:000147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92002, NULL, 'G3DSA:1.20.5.190:FF:000065', NULL, NULL, 'Calmodulin-binding transcription activator (Camta), drome', NULL, NULL, NULL, NULL, NULL, 4),
(92003, NULL, 'G3DSA:1.20.1270.280:FF:000036', NULL, NULL, 'Putative dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(92004, NULL, 'G3DSA:2.70.150.10:FF:000015', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(92005, NULL, 'G3DSA:1.10.472.10:FF:000712', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92006, NULL, 'G3DSA:2.10.70.10:FF:000135', NULL, NULL, 'Complement factor H', NULL, NULL, NULL, NULL, NULL, 4),
(92007, NULL, 'G3DSA:2.60.120.10:FF:000678', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92008, NULL, 'G3DSA:3.40.50.1820:FF:000665', NULL, NULL, 'Kidney thyroglobulin variant', NULL, NULL, NULL, NULL, NULL, 4),
(92009, NULL, 'G3DSA:2.40.30.270:FF:000015', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(92010, NULL, 'G3DSA:1.25.40.10:FF:002215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92011, NULL, 'G3DSA:3.30.160.60:FF:004537', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92012, NULL, 'G3DSA:2.60.120.260:FF:000064', NULL, NULL, 'Ephrin type-B receptor 6', NULL, NULL, NULL, NULL, NULL, 4),
(92013, NULL, 'G3DSA:1.10.510.10:FF:003539', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92014, NULL, 'G3DSA:3.40.250.10:FF:000166', NULL, NULL, 'Superoxide dismutase, Fe-Mn family', NULL, NULL, NULL, NULL, NULL, 4),
(92015, NULL, 'G3DSA:2.60.120.10:FF:000504', NULL, NULL, 'cGMP-dependent protein kinase 8-2', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(92016, NULL, 'G3DSA:1.10.10.60:FF:000671', NULL, NULL, 'Protein CHROMATIN REMODELING 5', NULL, NULL, NULL, NULL, NULL, 4),
(92017, NULL, 'G3DSA:2.60.40.10:FF:003981', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92018, NULL, 'G3DSA:3.40.30.10:FF:000146', NULL, NULL, 'Thioredoxin domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(92019, NULL, 'G3DSA:3.40.50.150:FF:000614', NULL, NULL, 'NOL1/NOP2/sun family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(92020, NULL, 'G3DSA:2.60.40.60:FF:000039', NULL, NULL, 'FAT atypical cadherin 3', NULL, NULL, NULL, NULL, NULL, 4),
(92021, NULL, 'G3DSA:2.30.30.570:FF:000006', NULL, NULL, 'Major vault protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(92022, NULL, 'G3DSA:3.30.505.50:FF:000003', NULL, NULL, 'ribosome-binding factor PSRP1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(92023, NULL, 'G3DSA:1.10.150.50:FF:000117', NULL, NULL, 'Kinase suppressor of Ras', NULL, NULL, NULL, NULL, NULL, 4),
(92024, NULL, 'G3DSA:3.30.70.250:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92025, NULL, 'G3DSA:3.10.129.10:FF:000014', NULL, NULL, 'Acyl-[acyl-carrier-protein] hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(92026, NULL, 'G3DSA:2.40.50.100:FF:000126', NULL, NULL, 'Putative periplasmic linker protein', NULL, NULL, NULL, NULL, NULL, 4),
(92027, NULL, 'G3DSA:3.50.50.60:FF:000004', NULL, NULL, 'protein-methionine sulfoxide oxidase MICAL2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(92028, NULL, 'G3DSA:3.40.50.1240:FF:000120', NULL, NULL, 'Phosphoglycerate mutase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(92029, NULL, 'G3DSA:2.60.40.10:FF:004644', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92030, NULL, 'G3DSA:3.80.10.10:FF:003066', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92031, NULL, 'G3DSA:3.90.640.10:FF:000185', NULL, NULL, 'Actin related protein', NULL, NULL, NULL, NULL, NULL, 4),
(92032, NULL, 'G3DSA:1.10.1200.10:FF:000047', NULL, NULL, 'Acyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(92033, NULL, 'G3DSA:1.20.1070.10:FF:000944', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92034, NULL, 'G3DSA:3.30.365.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92035, NULL, 'G3DSA:3.30.70.240:FF:000024', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(92036, NULL, 'G3DSA:1.25.40.10:FF:000142', NULL, NULL, 'Serine/threonine-protein kinase ATR', NULL, NULL, NULL, NULL, NULL, 4),
(92037, NULL, 'G3DSA:3.40.50.280:FF:000018', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(92038, NULL, 'G3DSA:3.30.160.60:FF:004251', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92039, NULL, 'G3DSA:1.20.120.1750:FF:000101', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(92040, NULL, 'G3DSA:3.80.10.10:FF:002846', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92041, NULL, 'G3DSA:3.30.70.580:FF:000042', NULL, NULL, 'Pseudouridylate synthase 3', NULL, NULL, NULL, NULL, NULL, 4),
(92042, NULL, 'G3DSA:3.40.50.300:FF:004252', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(92043, NULL, 'G3DSA:2.30.30.560:FF:000003', NULL, NULL, 'Major vault protein', NULL, NULL, NULL, NULL, NULL, 4),
(92044, NULL, 'G3DSA:3.40.50.2300:FF:001079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92045, NULL, 'G3DSA:1.10.20.10:FF:000314', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92046, NULL, 'G3DSA:3.30.300.330:FF:000003', NULL, NULL, 'Alkyldihydroxyacetonephosphate synthase (ADS1)', NULL, NULL, NULL, NULL, NULL, 4),
(92047, NULL, 'G3DSA:3.10.280.10:FF:000023', NULL, NULL, 'Mitochondrial glyco protein', NULL, NULL, NULL, NULL, NULL, 4),
(92048, NULL, 'G3DSA:2.60.40.150:FF:000281', NULL, NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(92049, NULL, 'G3DSA:2.60.120.380:FF:000044', NULL, NULL, 'Calpain-B', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(92050, NULL, 'G3DSA:3.30.70.330:FF:000107', NULL, NULL, 'TAR DNA-binding protein 43', NULL, NULL, NULL, NULL, NULL, 4),
(92051, NULL, 'G3DSA:2.130.10.10:FF:004015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92052, NULL, 'G3DSA:3.30.1360.10:FF:000030', NULL, NULL, 'RNA polymerase I and III subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(92053, NULL, 'G3DSA:1.10.287.110:FF:000334', NULL, NULL, 'Chaperone protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(92054, NULL, 'G3DSA:1.10.540.10:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92055, NULL, 'G3DSA:1.20.1070.10:FF:001220', NULL, NULL, 'Putative G-protein coupled receptor 101', NULL, NULL, NULL, NULL, NULL, 4),
(92056, NULL, 'G3DSA:3.40.50.300:FF:005819', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92057, NULL, 'G3DSA:1.10.10.10:FF:001488', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit K', NULL, NULL, NULL, NULL, NULL, 4),
(92058, NULL, 'G3DSA:3.30.310.10:FF:000038', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(92059, NULL, 'G3DSA:1.10.10.1540:FF:000004', NULL, NULL, 'Protein CBR-TAG-243', NULL, NULL, NULL, NULL, NULL, 4),
(92060, NULL, 'G3DSA:3.30.450.50:FF:000066', NULL, NULL, '25.3 kDa vesicle transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(92061, NULL, 'G3DSA:2.40.40.20:FF:000045', NULL, NULL, 'Arginine N-succinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(92062, NULL, 'G3DSA:3.30.56.10:FF:000003', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(92063, NULL, 'G3DSA:1.20.920.10:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92064, NULL, 'G3DSA:1.50.40.10:FF:000527', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92065, NULL, 'G3DSA:3.30.450.40:FF:000063', NULL, NULL, 'Stage II sporulation protein E', NULL, NULL, NULL, NULL, NULL, 4),
(92066, NULL, 'G3DSA:2.60.40.10:FF:003020', NULL, NULL, 'interferon gamma receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(92067, NULL, 'G3DSA:2.60.40.60:FF:000932', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92068, NULL, 'G3DSA:3.30.160.60:FF:005875', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92069, NULL, 'G3DSA:3.30.160.60:FF:002660', NULL, NULL, 'Zinc finger protein 200', NULL, NULL, NULL, NULL, NULL, 4),
(92070, NULL, 'G3DSA:1.10.510.10:FF:001948', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92071, NULL, 'G3DSA:2.70.170.10:FF:000224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92072, NULL, 'G3DSA:3.40.50.10810:FF:000040', NULL, NULL, 'Switch 2', NULL, NULL, NULL, NULL, NULL, 4),
(92073, NULL, 'G3DSA:1.20.120.350:FF:000180', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92074, NULL, 'G3DSA:3.40.1160.10:FF:000097', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92075, NULL, 'G3DSA:3.40.50.300:FF:002661', NULL, NULL, 'GTP binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(92076, NULL, 'G3DSA:2.130.10.10:FF:005639', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', NULL, NULL, NULL, NULL, NULL, 4),
(92077, NULL, 'G3DSA:3.30.420.10:FF:000485', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92078, NULL, 'G3DSA:2.40.30.10:FF:000423', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92079, NULL, 'G3DSA:2.10.25.10:FF:001109', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92080, NULL, 'G3DSA:1.10.8.710:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92081, NULL, 'G3DSA:3.90.190.10:FF:000195', NULL, NULL, 'Tyrosine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(92082, NULL, 'G3DSA:1.10.510.10:FF:000381', NULL, NULL, 'Putative receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(92083, NULL, 'G3DSA:3.10.20.90:FF:000951', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(92084, NULL, 'G3DSA:3.30.160.60:FF:002508', NULL, NULL, 'Neuroectoderm-expressed 2, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(92085, NULL, 'G3DSA:3.30.559.30:FF:000059', NULL, NULL, 'Nonribosomal peptide synthetase fmqC', NULL, NULL, NULL, NULL, NULL, 4),
(92086, NULL, 'G3DSA:1.10.630.10:FF:000709', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92087, NULL, 'G3DSA:1.20.1250.40:FF:000028', NULL, NULL, 'AaceriAGR317Cp', NULL, NULL, NULL, NULL, NULL, 4),
(92088, NULL, 'G3DSA:2.10.110.10:FF:000060', NULL, NULL, 'Uncharacterized protein, isoform Z', NULL, NULL, NULL, NULL, NULL, 4),
(92089, NULL, 'G3DSA:3.40.30.160:FF:000001', NULL, NULL, 'Microbial collagenase', NULL, NULL, NULL, NULL, NULL, 4),
(92090, NULL, 'G3DSA:1.25.40.20:FF:000594', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92091, NULL, 'G3DSA:3.40.30.10:FF:000376', NULL, NULL, 'Glutathione S-transferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(92092, NULL, 'G3DSA:2.30.180.10:FF:000082', NULL, NULL, 'Fasciclin-like arabinogalactan protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(92093, NULL, 'G3DSA:1.10.10.60:FF:000339', NULL, NULL, 'Transcription factor MYB30', NULL, NULL, NULL, NULL, NULL, 4),
(92094, NULL, 'G3DSA:2.60.40.10:FF:003829', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92095, NULL, 'G3DSA:3.90.226.10:FF:000031', NULL, NULL, 'Interphotoreceptor retinoid binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(92096, NULL, 'G3DSA:2.60.34.10:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92097, NULL, 'G3DSA:2.40.50.360:FF:000007', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(92098, NULL, 'G3DSA:3.30.160.60:FF:000940', NULL, NULL, 'transcription factor Sp7', NULL, NULL, NULL, NULL, NULL, 4),
(92099, NULL, 'G3DSA:2.30.29.150:FF:000002', NULL, NULL, 'FACT complex subunit SPT16', NULL, NULL, NULL, NULL, NULL, 4),
(92100, NULL, 'G3DSA:3.40.140.10:FF:000096', NULL, NULL, 'GG22115', NULL, NULL, NULL, NULL, NULL, 4),
(92101, NULL, 'G3DSA:3.30.870.10:FF:000007', NULL, NULL, 'Polyphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(92102, NULL, 'G3DSA:1.20.1640.10:FF:000055', NULL, NULL, 'Protein-export membrane protein SecF', NULL, NULL, NULL, NULL, NULL, 4),
(92103, NULL, 'G3DSA:1.20.1070.10:FF:002012', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(92104, NULL, 'G3DSA:3.40.390.10:FF:000030', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(92105, NULL, 'G3DSA:3.40.50.150:FF:000890', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', NULL, NULL, NULL, NULL, NULL, 4),
(92106, NULL, 'G3DSA:3.40.190.10:FF:000110', NULL, NULL, 'Survival motor neuron protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(92107, NULL, 'G3DSA:1.20.5.110:FF:000261', NULL, NULL, 'Putative synaptobrevin homolog YKT6', NULL, NULL, NULL, NULL, NULL, 4),
(92108, NULL, 'G3DSA:1.10.8.10:FF:000329', NULL, NULL, 'AGR352Cp', NULL, NULL, NULL, NULL, NULL, 4),
(92109, NULL, 'G3DSA:3.20.20.220:FF:000044', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(92110, NULL, 'G3DSA:3.60.10.10:FF:000099', NULL, NULL, 'EEP domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(92111, NULL, 'G3DSA:1.25.10.10:FF:001949', NULL, NULL, 'Mitogen activated protein kinase kinase kinase 1, MAPKKK1, MEKK1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(92112, NULL, 'G3DSA:3.90.70.10:FF:000680', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92113, NULL, 'G3DSA:3.40.50.300:FF:007686', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92114, NULL, 'G3DSA:2.30.29.30:FF:001051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92115, NULL, 'G3DSA:2.160.10.10:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92116, NULL, 'G3DSA:2.40.33.10:FF:000020', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(92117, NULL, 'G3DSA:3.90.70.10:FF:000062', NULL, NULL, 'Dipeptidyl peptidase 1', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(92118, NULL, 'G3DSA:3.30.750.24:FF:000051', NULL, NULL, 'Sulfate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(92119, NULL, 'G3DSA:1.25.40.70:FF:000064', NULL, NULL, 'Phosphatidylinositol 4-kinase alpha, putative', NULL, NULL, NULL, NULL, NULL, 4),
(92120, NULL, 'G3DSA:1.10.10.60:FF:000132', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(92121, NULL, 'G3DSA:3.30.420.110:FF:000054', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(92122, NULL, 'G3DSA:1.10.220.160:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92123, NULL, 'G3DSA:1.20.120.330:FF:000022', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(92124, NULL, 'G3DSA:1.25.40.10:FF:003851', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92125, NULL, 'G3DSA:1.20.120.350:FF:000028', NULL, NULL, 'Potassium voltage-gated channel subfamily a member', NULL, NULL, NULL, NULL, NULL, 4),
(92126, NULL, 'G3DSA:2.40.10.10:FF:000591', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92127, NULL, 'G3DSA:1.10.10.10:FF:000353', NULL, NULL, 'H1 histone family member X', NULL, NULL, NULL, NULL, NULL, 4),
(92128, NULL, 'G3DSA:2.10.25.10:FF:000626', NULL, NULL, 'Blast:Protein eyes shut', NULL, NULL, NULL, NULL, NULL, 4),
(92129, NULL, 'G3DSA:2.130.10.10:FF:000143', NULL, NULL, 'U3 small nucleolar RNA-interacting protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(92130, NULL, 'G3DSA:3.30.56.30:FF:000009', NULL, NULL, 'Signal recognition particle 19 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(92131, NULL, 'G3DSA:3.40.50.620:FF:000576', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92132, NULL, 'G3DSA:1.20.1560.10:FF:000577', NULL, NULL, 'ATP-binding cassette, sub-family B (MDR/TAP), member 10', NULL, NULL, NULL, NULL, NULL, 4),
(92133, NULL, 'G3DSA:2.60.40.60:FF:000314', NULL, NULL, 'Fat-like cadherin-related tumor suppressor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(92134, NULL, 'G3DSA:3.40.470.10:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92135, NULL, 'G3DSA:2.60.40.10:FF:001952', NULL, NULL, 'Programmed cell death protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(92136, NULL, 'G3DSA:1.10.220.150:FF:000021', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(92137, NULL, 'G3DSA:1.25.40.20:FF:000420', NULL, NULL, 'Squamosa promoter binding protein-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(92138, NULL, 'G3DSA:3.90.930.1:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92139, NULL, 'G3DSA:3.40.50.12390:FF:000013', NULL, NULL, 'Putative exoribonuclease 2', NULL, NULL, NULL, NULL, NULL, 4),
(92140, NULL, 'G3DSA:3.60.15.10:FF:000115', NULL, NULL, 'Cleavage and polyadenylation specificity factor 73 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(92141, NULL, 'G3DSA:3.40.50.300:FF:002043', NULL, NULL, 'Guanine nucleotide-binding 3', NULL, NULL, NULL, NULL, NULL, 4),
(92142, NULL, 'G3DSA:1.10.238.10:FF:000129', NULL, NULL, 'Serine/threonine-protein phosphatase 2A regulatory subunit B'''' subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(92143, NULL, 'G3DSA:2.130.10.10:FF:005078', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92144, NULL, 'G3DSA:1.25.10.10:FF:000325', NULL, NULL, 'Serine/threonine-protein kinase 36', NULL, NULL, NULL, NULL, NULL, 4),
(92145, NULL, 'G3DSA:3.40.50.10810:FF:000247', NULL, NULL, 'DNA repair protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(92146, NULL, 'G3DSA:2.10.220.10:FF:000175', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 4', NULL, NULL, NULL, NULL, NULL, 4),
(92147, NULL, 'G3DSA:3.80.10.10:FF:003341', NULL, NULL, 'Flagellar associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(92148, NULL, 'G3DSA:1.20.1250.20:FF:001085', NULL, NULL, 'Autophagy-related protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(92149, NULL, 'G3DSA:1.10.630.10:FF:000592', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(92150, NULL, 'G3DSA:1.25.40.10:FF:004076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92151, NULL, 'G3DSA:2.40.70.10:FF:000038', NULL, NULL, 'Plasmepsin-2', NULL, NULL, NULL, NULL, NULL, 4),
(92152, NULL, 'G3DSA:3.30.1640.10:FF:000074', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(92153, NULL, 'G3DSA:3.40.50.720:FF:001612', NULL, NULL, '(+)-neomenthol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(92154, NULL, 'G3DSA:1.25.40.10:FF:004132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92155, NULL, 'G3DSA:3.20.20.60:FF:000032', NULL, NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(92156, NULL, 'G3DSA:1.10.640.10:FF:000087', NULL, NULL, 'Peroxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(92157, NULL, 'G3DSA:3.40.50.1100:FF:000269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92158, NULL, 'G3DSA:1.10.560.10:FF:000035', NULL, NULL, 'T-complex protein 1 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(92159, NULL, 'G3DSA:2.70.98.10:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92160, NULL, 'G3DSA:2.60.40.10:FF:004318', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92161, NULL, 'G3DSA:3.30.230.130:FF:000016', NULL, NULL, 'Ubiquitin-protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(92162, NULL, 'G3DSA:2.10.25.10:FF:001284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92163, NULL, 'G3DSA:3.40.50.300:FF:000362', NULL, NULL, 'Dynein, axonemal, heavy chain 6', NULL, NULL, NULL, NULL, NULL, 4),
(92164, NULL, 'G3DSA:3.30.559.70:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92165, NULL, 'G3DSA:2.60.40.10:FF:000047', NULL, NULL, 'Contactin 1', NULL, NULL, NULL, NULL, NULL, 4),
(92166, NULL, 'G3DSA:3.40.50.300:FF:001992', NULL, NULL, 'ATP-dependent RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(92167, NULL, 'G3DSA:2.30.310.10:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92168, NULL, 'G3DSA:1.20.58.1100:FF:000005', NULL, NULL, 'Unc-13 homolog A (C. elegans)', NULL, NULL, NULL, NULL, NULL, 4),
(92169, NULL, 'G3DSA:3.40.50.1000:FF:000127', NULL, NULL, 'Magnesium-dependent phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(92170, NULL, 'G3DSA:2.60.40.10:FF:002227', NULL, NULL, 'Wrapper/Rega-1/Klingon homolog', NULL, NULL, NULL, NULL, NULL, 4),
(92171, NULL, 'G3DSA:3.40.50.300:FF:001025', NULL, NULL, 'ATPase family, AAA domain-containing 2B', NULL, NULL, NULL, NULL, NULL, 4),
(92172, NULL, 'G3DSA:2.60.40.1110:FF:000010', NULL, NULL, 'Cyclin G associated kinase', NULL, NULL, NULL, NULL, NULL, 4),
(92173, NULL, 'G3DSA:3.30.980.40:FF:000002', NULL, NULL, 'Cell division protein FtsK', NULL, NULL, NULL, NULL, NULL, 4),
(92174, NULL, 'G3DSA:1.10.268.10:FF:000007', NULL, NULL, 'DNA topoisomerase (ATP-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4),
(92175, NULL, 'G3DSA:2.60.40.10:FF:000103', NULL, NULL, 'Kirre like nephrin family adhesion molecule 3', NULL, NULL, NULL, NULL, NULL, 4),
(92176, NULL, 'G3DSA:3.40.50.150:FF:000058', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase C', NULL, NULL, NULL, NULL, NULL, 4),
(92177, NULL, 'G3DSA:3.40.1190.20:FF:000219', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92178, NULL, 'G3DSA:2.60.120.10:FF:000274', NULL, NULL, 'Gentisate 1,2-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(92179, NULL, 'G3DSA:3.30.70.330:FF:000967', NULL, NULL, 'AGAP002390-PA', NULL, NULL, NULL, NULL, NULL, 4),
(92180, NULL, 'G3DSA:2.130.10.10:FF:004341', NULL, NULL, 'Subunit of VPS-C complex', NULL, NULL, NULL, NULL, NULL, 4),
(92181, NULL, 'G3DSA:2.60.40.60:FF:000601', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92182, NULL, 'G3DSA:3.30.70.100:FF:000067', NULL, NULL, 'Stable protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(92183, NULL, 'G3DSA:3.30.160.20:FF:000097', NULL, NULL, 'Endoribonuclease dcr-1', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(92184, NULL, 'G3DSA:4.10.400.10:FF:000198', NULL, NULL, 'Low density lipoprotein receptor-related protein 2a', NULL, NULL, NULL, NULL, NULL, 4),
(92185, NULL, 'G3DSA:1.10.510.10:FF:001628', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92186, NULL, 'G3DSA:3.30.2230.10:FF:000009', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 32', NULL, NULL, NULL, NULL, NULL, 4),
(92187, NULL, 'G3DSA:3.60.21.10:FF:000450', NULL, NULL, 'Uncharacterized metallophosphoesterase DR_2345', NULL, NULL, NULL, NULL, NULL, 4),
(92188, NULL, 'G3DSA:1.20.144.10:FF:000010', NULL, NULL, 'Glucose-6-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(92189, NULL, 'G3DSA:1.10.287.70:FF:000575', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92190, NULL, 'G3DSA:1.20.1270.370:FF:000006', NULL, NULL, '(R)-2-hydroxyacyl-CoA dehydratase YjiM', NULL, NULL, NULL, NULL, NULL, 4),
(92191, NULL, 'G3DSA:2.60.40.1120:FF:000013', NULL, NULL, 'DUF1416 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(92192, NULL, 'G3DSA:3.40.1110.10:FF:000094', NULL, NULL, 'Cation-transporting P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(92193, NULL, 'G3DSA:1.10.238.10:FF:000505', NULL, NULL, 'Probable calcium-binding protein CML34', NULL, NULL, NULL, NULL, NULL, 4),
(92194, NULL, 'G3DSA:1.10.1620.20:FF:000008', NULL, NULL, 'ATP synthase subunit epsilon, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(92195, NULL, 'G3DSA:3.50.50.60:FF:000330', NULL, NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(92196, NULL, 'G3DSA:1.10.10.10:FF:001769', NULL, NULL, 'ORC1-type DNA replication protein', NULL, NULL, NULL, NULL, NULL, 4),
(92197, NULL, 'G3DSA:1.10.150.80:FF:000036', NULL, NULL, 'ATP-dependent DNA helicase, RecQ family protein', NULL, NULL, NULL, NULL, NULL, 4),
(92198, NULL, 'G3DSA:1.10.510.10:FF:000049', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(92199, NULL, 'G3DSA:3.40.50.1970:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92200, NULL, 'G3DSA:3.30.160.60:FF:000592', NULL, NULL, 'zinc finger protein 90 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(92201, NULL, 'G3DSA:3.80.10.10:FF:000997', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3', NULL, NULL, NULL, NULL, NULL, 4),
(92202, NULL, 'G3DSA:1.25.40.10:FF:000821', NULL, NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(92203, NULL, 'G3DSA:3.40.50.800:FF:000068', NULL, NULL, 'Threonyl-tRNA synthetase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(92204, NULL, 'G3DSA:3.30.200.20:FF:001343', NULL, NULL, 'Serine/threonine-protein kinase ppk31', NULL, NULL, NULL, NULL, NULL, 4),
(92205, NULL, 'G3DSA:1.20.120.150:FF:000007', NULL, NULL, 'Serine/threonine-protein kinase tor1', NULL, NULL, NULL, NULL, NULL, 4),
(92206, NULL, 'G3DSA:1.25.40.20:FF:000190', NULL, NULL, 'Putative espin', NULL, NULL, NULL, NULL, NULL, 4),
(92207, NULL, 'G3DSA:2.30.30.40:FF:000343', NULL, NULL, 'Cell division cycle-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(92208, NULL, 'G3DSA:1.10.510.10:FF:001679', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(92209, NULL, 'G3DSA:3.30.1010.10:FF:000043', NULL, NULL, 'Phosphatidylinositol 4-kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(92210, NULL, 'G3DSA:2.130.10.10:FF:000704', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(92211, NULL, 'G3DSA:3.40.33.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92212, NULL, 'G3DSA:3.40.50.10810:FF:000253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92213, NULL, 'G3DSA:1.25.40.20:FF:000824', NULL, NULL, 'CARD- and ANK-containing Inflammasome Adaptor Protein', NULL, NULL, NULL, NULL, NULL, 4),
(92214, NULL, 'G3DSA:2.130.10.10:FF:004392', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(92215, NULL, 'G3DSA:2.10.220.10:FF:000124', NULL, NULL, 'Furin-like protease 2', NULL, NULL, NULL, NULL, NULL, 4),
(92216, NULL, 'G3DSA:3.40.50.2000:FF:001107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92217, NULL, 'G3DSA:3.40.1050.10:FF:000004', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(92218, NULL, 'G3DSA:1.25.40.10:FF:001491', NULL, NULL, 'Os05g0572900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(92219, NULL, 'G3DSA:2.10.25.10:FF:001402', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92220, NULL, 'G3DSA:1.10.510.10:FF:000375', NULL, NULL, 'Putative eukaryotic translation initiation factor 2-alpha kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(92221, NULL, 'G3DSA:1.10.10.10:FF:001718', NULL, NULL, 'DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(92222, NULL, 'G3DSA:3.30.1370.240:FF:000011', NULL, NULL, 'Phenylalanyl-tRNA synthetase alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(92223, NULL, 'G3DSA:1.20.120.140:FF:000004', NULL, NULL, 'Signal recognition particle receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(92224, NULL, 'G3DSA:1.10.287.70:FF:000249', NULL, NULL, 'Calcium channel, voltage-dependent, R type, alpha 1E subunit b', NULL, NULL, NULL, NULL, NULL, 4),
(92225, NULL, 'G3DSA:2.130.10.10:FF:005819', NULL, NULL, 'Coatomer subunit beta''-3', NULL, NULL, NULL, NULL, NULL, 4),
(92226, NULL, 'G3DSA:3.90.550.10:FF:000245', NULL, NULL, 'Dolichyl-phosphate mannose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(92227, NULL, 'G3DSA:3.30.565.10:FF:000343', NULL, NULL, 'Sensory histidine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(92228, NULL, 'G3DSA:1.20.58.2220:FF:000043', NULL, NULL, 'Excretory canal abnormal protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(92229, NULL, 'G3DSA:1.10.540.10:FF:000091', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(92230, NULL, 'G3DSA:3.30.70.330:FF:003036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92231, NULL, 'G3DSA:4.10.400.10:FF:000254', NULL, NULL, 'AGAP003656-PB', NULL, NULL, NULL, NULL, NULL, 4),
(92232, NULL, 'G3DSA:2.70.130.10:FF:000126', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92233, NULL, 'G3DSA:3.40.20.10:FF:000089', NULL, NULL, 'Villin-1', NULL, NULL, NULL, NULL, NULL, 4),
(92234, NULL, 'G3DSA:3.40.800.10:FF:000012', NULL, NULL, 'Arginase', NULL, NULL, NULL, NULL, NULL, 4),
(92235, NULL, 'G3DSA:3.30.505.10:FF:000272', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92236, NULL, 'G3DSA:2.60.40.10:FF:000373', NULL, NULL, 'fibronectin type-III domain-containing protein 3A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(92237, NULL, 'G3DSA:1.20.1260.140:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92238, NULL, 'G3DSA:1.10.630.10:FF:000266', NULL, NULL, 'Ent-kaurene oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(92239, NULL, 'G3DSA:3.40.800.20:FF:000015', NULL, NULL, 'Histone deacetylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(92240, NULL, 'G3DSA:1.25.10.10:FF:001449', NULL, NULL, 'Apoptosis inhibitory protein', NULL, NULL, NULL, NULL, NULL, 4),
(92241, NULL, 'G3DSA:1.10.1600.10:FF:000010', NULL, NULL, 'Inverted repeat-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(92242, NULL, 'G3DSA:1.10.40.30:FF:000029', NULL, NULL, 'Argininosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(92243, NULL, 'G3DSA:2.40.33.10:FF:000008', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(92244, NULL, 'G3DSA:3.10.10.10:FF:000005', NULL, NULL, 'Endogenous retrovirus group K member 25 Pol protein', NULL, NULL, NULL, NULL, NULL, 4),
(92245, NULL, 'G3DSA:1.25.10.10:FF:002450', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92246, NULL, 'G3DSA:2.40.50.140:FF:001228', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92247, NULL, 'G3DSA:1.20.1280.50:FF:000185', NULL, NULL, 'F-box only protein 39-like', NULL, NULL, NULL, NULL, NULL, 4),
(92248, NULL, 'G3DSA:3.40.50.1980:FF:000044', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(92249, NULL, 'G3DSA:1.10.8.60:FF:000541', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(92250, NULL, 'G3DSA:3.40.190.290:FF:000113', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(92251, NULL, 'G3DSA:3.40.50.1010:FF:000282', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92252, NULL, 'G3DSA:3.80.10.10:FF:000778', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(92253, NULL, 'G3DSA:1.10.472.10:FF:000212', NULL, NULL, 'Cyclin-T1-2', NULL, NULL, NULL, NULL, NULL, 4),
(92254, NULL, 'G3DSA:3.10.180.10:FF:000026', NULL, NULL, 'Lactoylglutathione lyase', NULL, NULL, NULL, NULL, NULL, 4),
(92255, NULL, 'G3DSA:1.10.1520.10:FF:000083', NULL, NULL, 'Dicer-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(92256, NULL, 'G3DSA:2.60.120.970:FF:000075', NULL, NULL, 'Nodal homolog 2-B', NULL, NULL, NULL, NULL, NULL, 4),
(92257, NULL, 'G3DSA:1.25.10.10:FF:000033', NULL, NULL, 'Diaphanous related formin 2', NULL, NULL, NULL, NULL, NULL, 4),
(92258, NULL, 'G3DSA:3.30.43.10:FF:000030', NULL, NULL, 'Dimethylmenaquinone methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(92259, NULL, 'G3DSA:1.10.472.80:FF:000194', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92260, NULL, 'G3DSA:1.10.1420.10:FF:000024', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(92261, NULL, 'G3DSA:3.30.160.60:FF:001845', NULL, NULL, 'Transcription factor Msn2p', NULL, NULL, NULL, NULL, NULL, 4),
(92262, NULL, 'G3DSA:1.25.10.10:FF:000089', NULL, NULL, 'Rho family-interacting cell polarization regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(92263, NULL, 'G3DSA:1.20.58.60:FF:000887', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92264, NULL, 'G3DSA:3.30.1360.120:FF:000052', NULL, NULL, 'Folate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(92265, NULL, 'G3DSA:1.10.287.110:FF:000093', NULL, NULL, 'DNAJ heat shock N-terminal domain-containing protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(92266, NULL, 'G3DSA:1.25.10.10:FF:000145', NULL, NULL, 'Regulatory-associated protein of TOR 1', NULL, NULL, NULL, NULL, NULL, 4),
(92267, NULL, 'G3DSA:3.30.200.20:FF:002006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92268, NULL, 'G3DSA:1.10.510.10:FF:001898', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92269, NULL, 'G3DSA:3.40.50.1820:FF:000991', NULL, NULL, 'GPI inositol-deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(92270, NULL, 'G3DSA:1.10.3720.10:FF:000031', NULL, NULL, 'Phosphate transport system permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(92271, NULL, 'G3DSA:3.90.1420.10:FF:000055', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92272, NULL, 'G3DSA:1.20.1250.20:FF:001826', NULL, NULL, 'Solute carrier family 45 member 1', NULL, NULL, NULL, NULL, NULL, 4),
(92273, NULL, 'G3DSA:2.60.200.20:FF:000160', NULL, NULL, 'Kinesin motor domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(92274, NULL, 'G3DSA:3.90.1150.10:FF:000303', NULL, NULL, '4-aminobutyrate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(92275, NULL, 'G3DSA:1.20.1560.10:FF:000818', NULL, NULL, 'Sulfonylurea receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(92276, NULL, 'G3DSA:3.40.50.300:FF:008225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92277, NULL, 'G3DSA:1.25.10.10:FF:001663', NULL, NULL, 'AaceriADR292Wp', NULL, NULL, NULL, NULL, NULL, 4),
(92278, NULL, 'G3DSA:2.130.10.10:FF:005589', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(92279, NULL, 'G3DSA:3.30.420.10:FF:000659', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92280, NULL, 'G3DSA:2.60.40.790:FF:000129', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92281, NULL, 'G3DSA:1.25.10.10:FF:001775', NULL, NULL, 'YALI0F01793p', NULL, NULL, NULL, NULL, NULL, 4),
(92282, NULL, 'G3DSA:3.40.50.720:FF:001331', NULL, NULL, 'SDR family oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(92283, NULL, 'G3DSA:1.25.10.10:FF:002124', NULL, NULL, 'Serine/threonine-protein kinase ULK4', NULL, NULL, NULL, NULL, NULL, 4),
(92284, NULL, 'G3DSA:3.30.450.20:FF:000546', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92285, NULL, 'G3DSA:1.10.10.10:FF:000521', NULL, NULL, 'Histone H1', NULL, NULL, NULL, NULL, NULL, 4),
(92286, NULL, 'G3DSA:3.30.300.10:FF:000038', NULL, NULL, 'S-adenosylmethionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(92287, NULL, 'G3DSA:3.80.10.10:FF:002003', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(92288, NULL, 'G3DSA:1.25.40.10:FF:001277', NULL, NULL, 'Intraflagellar transport 88 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(92289, NULL, 'G3DSA:3.20.20.70:FF:000361', NULL, NULL, 'N-(5''-phosphoribosyl)anthranilate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(92290, NULL, 'G3DSA:3.30.70.20:FF:000005', NULL, NULL, 'Respiratory nitrate reductase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(92291, NULL, 'G3DSA:2.70.50.70:FF:000003', NULL, NULL, 'Endo-beta-1,4-glucanase D', NULL, NULL, NULL, NULL, NULL, 4),
(92292, NULL, 'G3DSA:3.30.200.20:FF:001562', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92293, NULL, 'G3DSA:1.20.1050.10:FF:000212', NULL, NULL, 'Glutathione transferase11', NULL, NULL, NULL, NULL, NULL, 4),
(92294, NULL, 'G3DSA:3.40.50.2300:FF:000697', NULL, NULL, 'Glutamate receptor DGluRIIB', NULL, NULL, NULL, NULL, NULL, 4),
(92295, NULL, 'G3DSA:2.60.40.10:FF:002520', NULL, NULL, 'L1 CAM ADhesion molecule homolog', NULL, NULL, NULL, NULL, NULL, 4),
(92296, NULL, 'G3DSA:3.40.50.300:FF:006045', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(92297, NULL, 'G3DSA:3.30.200.20:FF:002051', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92298, NULL, 'G3DSA:3.40.50.200:FF:000057', NULL, NULL, 'Alkaline serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(92299, NULL, 'G3DSA:2.60.120.10:FF:000055', NULL, NULL, 'pirin', NULL, NULL, NULL, NULL, NULL, 4),
(92300, NULL, 'G3DSA:1.10.560.10:FF:000086', NULL, NULL, 'Bardet-Biedl syndrome 12', NULL, NULL, NULL, NULL, NULL, 4),
(92301, NULL, 'G3DSA:3.40.50.1440:FF:000017', NULL, NULL, 'Tubulin epsilon chain', NULL, NULL, NULL, NULL, NULL, 4),
(92302, NULL, 'G3DSA:3.90.1490.10:FF:000003', NULL, NULL, 'Diphthine--ammonia ligase', NULL, NULL, NULL, NULL, NULL, 4),
(92303, NULL, 'G3DSA:3.40.50.1980:FF:000100', NULL, NULL, 'Heme ABC superfamily ATP binding cassette transporter, binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(92304, NULL, 'G3DSA:2.130.10.10:FF:003498', NULL, NULL, 'Inositol polyphosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(92305, NULL, 'G3DSA:3.80.10.10:FF:004089', NULL, NULL, 'NLR family CARD domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(92306, NULL, 'G3DSA:1.10.510.10:FF:000431', NULL, NULL, 'Putative inactive leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(92307, NULL, 'G3DSA:3.40.50.720:FF:001831', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(92308, NULL, 'G3DSA:3.50.50.60:FF:000111', NULL, NULL, 'Zeta-carotene desaturase', NULL, NULL, NULL, NULL, NULL, 4),
(92309, NULL, 'G3DSA:3.40.190.80:FF:000086', NULL, NULL, 'Bisphosphate nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(92310, NULL, 'G3DSA:1.25.10.10:FF:000084', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(92311, NULL, 'G3DSA:1.20.58.1540:FF:000002', NULL, NULL, 'Ring finger protein 207', NULL, NULL, NULL, NULL, NULL, 4),
(92312, NULL, 'G3DSA:3.30.200.20:FF:001287', NULL, NULL, 'Spore coat protein, CotS family', NULL, NULL, NULL, NULL, NULL, 4),
(92313, NULL, 'G3DSA:2.30.30.40:FF:000455', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92314, NULL, 'G3DSA:1.10.510.10:FF:003011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(92315, NULL, 'G3DSA:3.30.40.10:FF:001748', NULL, NULL, 'Zinc finger (C3HC4-type RING finger) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(92316, NULL, 'G3DSA:3.30.160.60:FF:006331', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92317, NULL, 'G3DSA:1.25.40.20:FF:000712', NULL, NULL, 'SH3 and multiple ankyrin repeat domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(92318, NULL, 'G3DSA:2.40.50.100:FF:000047', NULL, NULL, 'Exosome complex component RRP4', NULL, NULL, NULL, NULL, NULL, 4),
(92319, NULL, 'G3DSA:3.80.10.10:FF:003633', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92320, NULL, 'G3DSA:3.90.1750.10:FF:000102', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(92321, NULL, 'G3DSA:1.20.1560.10:FF:000869', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92322, NULL, 'G3DSA:3.40.50.2300:FF:001158', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92323, NULL, 'G3DSA:3.40.33.10:FF:000175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92324, NULL, 'G3DSA:1.10.10.1800:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92325, NULL, 'G3DSA:3.90.190.10:FF:000487', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92326, NULL, 'G3DSA:2.30.110.10:FF:000033', NULL, NULL, 'Nitroreductase family deazaflavin-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(92327, NULL, 'G3DSA:2.10.25.10:FF:000946', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(92328, NULL, 'G3DSA:3.60.20.40:FF:000029', NULL, NULL, 'Gamma-glutamyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(92329, NULL, 'G3DSA:3.30.160.60:FF:006050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92330, NULL, 'G3DSA:2.130.10.10:FF:000182', NULL, NULL, 'DNA damage-binding protein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(92331, NULL, 'G3DSA:3.50.20.20:FF:000007', NULL, NULL, '14 kDa phosphohistidine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(92332, NULL, 'G3DSA:3.40.50.300:FF:000087', NULL, NULL, 'Recombinase RecA', NULL, NULL, NULL, NULL, NULL, 4),
(92333, NULL, 'G3DSA:3.30.800.10:FF:000008', NULL, NULL, 'Putative 1-phosphatidylinositol-3-phosphate 5-kinase FAB1D', NULL, NULL, NULL, NULL, NULL, 4),
(92334, NULL, 'G3DSA:3.30.70.1660:FF:000041', NULL, NULL, 'Mitochondrial translation release factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(92335, NULL, 'G3DSA:1.20.58.190:FF:000003', NULL, NULL, 'Translin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(92336, NULL, 'G3DSA:3.40.920.10:FF:000015', NULL, NULL, 'Putative 2-ketoglutarate ferredoxin oxidoreductase (Alpha)', NULL, NULL, NULL, NULL, NULL, 4),
(92337, NULL, 'G3DSA:3.30.460.90:FF:000005', NULL, NULL, 'Cyclic GMP-AMP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(92338, NULL, 'G3DSA:3.30.460.80:FF:000002', NULL, NULL, 'NADH dehydrogenase iron-sulfur protein 3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(92339, NULL, 'G3DSA:2.60.40.380:FF:000006', NULL, NULL, 'Purple acid phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(92340, NULL, 'G3DSA:3.30.70.20:FF:000056', NULL, NULL, '4Fe-4S dicluster domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(92341, NULL, 'G3DSA:1.10.510.10:FF:002522', NULL, NULL, 'Probable serine/threonine-protein kinase DDB_G0276461', NULL, NULL, NULL, NULL, NULL, 4),
(92342, NULL, 'G3DSA:2.40.20.10:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92343, NULL, 'G3DSA:3.40.50.300:FF:007394', NULL, NULL, 'mRNA cleavage and polyadenylation factor CLP1', NULL, NULL, NULL, NULL, NULL, 4),
(92344, NULL, 'G3DSA:2.60.120.380:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92345, NULL, 'G3DSA:1.10.238.10:FF:000449', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(92346, NULL, 'G3DSA:2.90.10.10:FF:000004', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(92347, NULL, 'G3DSA:2.40.290.10:FF:000032', NULL, NULL, 'Putative RNA-binding protein 15B', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(92348, NULL, 'G3DSA:3.40.640.10:FF:000033', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(92349, NULL, 'G3DSA:1.10.287.130:FF:000099', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(92350, NULL, 'G3DSA:3.10.20.90:FF:001002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92351, NULL, 'G3DSA:1.20.5.3600:FF:000002', NULL, NULL, 'Nucleoporin nup44', NULL, NULL, NULL, NULL, NULL, 4),
(92352, NULL, 'G3DSA:3.40.1810.10:FF:000068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92353, NULL, 'G3DSA:1.10.287.660:FF:000027', NULL, NULL, 'NOP56 ribonucleoprotein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(92354, NULL, 'G3DSA:3.30.530.20:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92355, NULL, 'G3DSA:2.40.10.10:FF:000091', NULL, NULL, 'Kallikrein-4', NULL, NULL, NULL, NULL, NULL, 4),
(92356, NULL, 'G3DSA:2.60.40.10:FF:004206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92357, NULL, 'G3DSA:1.10.720.140:FF:000002', NULL, NULL, 'uncharacterized protein LOC108096637', NULL, NULL, NULL, NULL, NULL, 4),
(92358, NULL, 'G3DSA:3.40.33.10:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92359, NULL, 'G3DSA:3.90.190.10:FF:000436', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92360, NULL, 'G3DSA:3.40.50.1100:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92361, NULL, 'G3DSA:3.40.50.880:FF:000221', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92362, NULL, 'G3DSA:1.20.1740.10:FF:000237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92363, NULL, 'G3DSA:1.25.40.10:FF:001496', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g49710', NULL, NULL, NULL, NULL, NULL, 4),
(92364, NULL, 'G3DSA:3.40.50.1820:FF:001328', NULL, NULL, 'Protein phosphatase methylesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(92365, NULL, 'G3DSA:1.20.1310.10:FF:000031', NULL, NULL, 'Ubiquitin ligase subunit CulD', NULL, NULL, NULL, NULL, NULL, 4),
(92366, NULL, 'G3DSA:3.30.1680.10:FF:000020', NULL, NULL, 'Plexin C1', NULL, NULL, NULL, NULL, NULL, 4),
(92367, NULL, 'G3DSA:3.80.10.10:FF:001542', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92368, NULL, 'G3DSA:1.20.58.390:FF:000237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92369, NULL, 'G3DSA:2.60.40.10:FF:004144', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92370, NULL, 'G3DSA:3.40.630.10:FF:000184', NULL, NULL, 'Nicastrin-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(92371, NULL, 'G3DSA:3.90.260.10:FF:000026', NULL, NULL, 'Protein-glutamine gamma-glutamyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(92372, NULL, 'G3DSA:3.30.2160.10:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92373, NULL, 'G3DSA:3.30.70.1730:FF:000028', NULL, NULL, '50S ribosomal protein L10', NULL, NULL, NULL, NULL, NULL, 4),
(92374, NULL, 'G3DSA:1.25.40.10:FF:004306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92375, NULL, 'G3DSA:2.30.30.40:FF:000124', NULL, NULL, 'obscurin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(92376, NULL, 'G3DSA:3.30.420.40:FF:000533', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92377, NULL, 'G3DSA:3.30.497.10:FF:000055', NULL, NULL, 'Serpin peptidase inhibitor, clade B (ovalbumin), member 1,-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(92378, NULL, 'G3DSA:1.20.1070.10:FF:000495', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92379, NULL, 'G3DSA:2.60.40.10:FF:004088', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92380, NULL, 'G3DSA:3.40.50.1000:FF:000239', NULL, NULL, 'HAD hydrolase, family IIID, variant', NULL, NULL, NULL, NULL, NULL, 4),
(92381, NULL, 'G3DSA:2.60.40.10:FF:001738', NULL, NULL, 'CD226 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(92382, NULL, 'G3DSA:1.10.510.10:FF:004208', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(92383, NULL, 'G3DSA:1.25.40.20:FF:001499', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92384, NULL, 'G3DSA:3.30.200.20:FF:001843', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92385, NULL, 'G3DSA:1.10.10.10:FF:000414', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(92386, NULL, 'G3DSA:3.10.20.90:FF:000215', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 7, variant', NULL, NULL, NULL, NULL, NULL, 4),
(92387, NULL, 'G3DSA:3.30.365.10:FF:000064', NULL, NULL, 'Protein CBG19218', NULL, NULL, NULL, NULL, NULL, 4),
(92388, NULL, 'G3DSA:1.10.510.10:FF:002741', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92389, NULL, 'G3DSA:3.40.630.10:FF:000240', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(92390, NULL, 'G3DSA:1.20.140.10:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92391, NULL, 'G3DSA:3.60.21.10:FF:000231', NULL, NULL, 'Acid sphingomyelinase-like phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(92392, NULL, 'G3DSA:3.40.720.10:FF:000359', NULL, NULL, 'Sulfatase 2', NULL, NULL, NULL, NULL, NULL, 4),
(92393, NULL, 'G3DSA:2.10.70.10:FF:000079', NULL, NULL, 'Complement decay-accelerating factor', NULL, NULL, NULL, NULL, NULL, 4),
(92394, NULL, 'G3DSA:3.90.70.10:FF:000505', NULL, NULL, 'Ubiquitin C-terminal hydrolase, putative (AFU_orthologue AFUA_5G13620)', NULL, NULL, NULL, NULL, NULL, 4),
(92395, NULL, 'G3DSA:3.30.160.60:FF:004751', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92396, NULL, 'G3DSA:2.60.40.10:FF:001396', NULL, NULL, 'Interleukin 13 receptor subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(92397, NULL, 'G3DSA:1.20.1560.10:FF:000695', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(92398, NULL, 'G3DSA:3.10.110.10:FF:000022', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 W', NULL, NULL, NULL, NULL, NULL, 4),
(92399, NULL, 'G3DSA:1.25.40.10:FF:003694', NULL, NULL, 'Tetratricopeptide repeat protein 21 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(92400, NULL, 'G3DSA:2.110.10.10:FF:000014', NULL, NULL, 'Matrix metallopeptidase 28', NULL, NULL, NULL, NULL, NULL, 4),
(92401, NULL, 'G3DSA:3.40.630.30:FF:000246', NULL, NULL, 'RNA cytidine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(92402, NULL, 'G3DSA:2.30.30.30:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92403, NULL, 'G3DSA:3.30.70.3250:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92404, NULL, 'G3DSA:3.30.40.10:FF:001804', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(92405, NULL, 'G3DSA:2.130.10.10:FF:004515', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92406, NULL, 'G3DSA:2.130.10.10:FF:005319', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92407, NULL, 'G3DSA:2.40.30.10:FF:000160', NULL, NULL, '50S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(92408, NULL, 'G3DSA:1.25.10.10:FF:001994', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92409, NULL, 'G3DSA:3.30.70.580:FF:000047', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(92410, NULL, 'G3DSA:1.10.3470.10:FF:000033', NULL, NULL, 'Zinc ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(92411, NULL, 'G3DSA:2.60.120.260:FF:000305', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92412, NULL, 'G3DSA:1.10.10.10:FF:001988', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92413, NULL, 'G3DSA:2.30.30.40:FF:000511', NULL, NULL, 'Small G protein signaling modulator 3', NULL, NULL, NULL, NULL, NULL, 4),
(92414, NULL, 'G3DSA:3.80.10.10:FF:003307', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92415, NULL, 'G3DSA:1.20.1270.420:FF:000005', NULL, NULL, 'Inhibitor of nuclear factor kappa B kinase subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(92416, NULL, 'G3DSA:3.30.70.980:FF:000010', NULL, NULL, 'translational activator of cytochrome c oxidase 1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(92417, NULL, 'G3DSA:3.30.2410.10:FF:000046', NULL, NULL, 'Ubiquitin-protein ligase E3B', NULL, NULL, NULL, NULL, NULL, 4),
(92418, NULL, 'G3DSA:3.30.497.10:FF:000004', NULL, NULL, 'Serpin family B member 1', NULL, NULL, NULL, NULL, NULL, 4),
(92419, NULL, 'G3DSA:1.20.1070.10:FF:000388', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92420, NULL, 'G3DSA:2.60.40.10:FF:005667', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92421, NULL, 'G3DSA:3.40.710.10:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92422, NULL, 'G3DSA:3.30.70.330:FF:002024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92423, NULL, 'G3DSA:2.60.120.10:FF:000386', NULL, NULL, 'Cupin-like_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(92424, NULL, 'G3DSA:3.30.390.10:FF:000026', NULL, NULL, 'o-succinylbenzoate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(92425, NULL, 'G3DSA:3.60.20.30:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92426, NULL, 'G3DSA:3.10.129.10:FF:000121', NULL, NULL, '4-hydroxybenzoyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(92427, NULL, 'G3DSA:3.40.50.300:FF:006612', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92428, NULL, 'G3DSA:3.60.20.40:FF:000024', NULL, NULL, 'Gamma glutamyl transpeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(92429, NULL, 'G3DSA:2.130.10.10:FF:002716', NULL, NULL, 'Sister-chromatid cohesion-and DNA replication-associated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(92430, NULL, 'G3DSA:2.30.29.30:FF:001163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92431, NULL, 'G3DSA:3.30.505.10:FF:000165', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92432, NULL, 'G3DSA:3.40.50.720:FF:001617', NULL, NULL, 'Hydroxysteroid (17-beta) dehydrogenase 14', NULL, NULL, NULL, NULL, NULL, 4),
(92433, NULL, 'G3DSA:3.40.1090.10:FF:000001', NULL, NULL, 'neuropathy target esterase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(92434, NULL, 'G3DSA:1.10.10.10:FF:000465', NULL, NULL, 'Proliferation-associated protein 2g4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(92435, NULL, 'G3DSA:2.30.29.30:FF:000887', NULL, NULL, 'Putative actin binding protein anillin', NULL, NULL, NULL, NULL, NULL, 4),
(92436, NULL, 'G3DSA:3.40.50.1820:FF:000772', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(92437, NULL, 'G3DSA:1.10.287.110:FF:000216', NULL, NULL, 'Chaperone protein dnaJ 49 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(92438, NULL, 'G3DSA:3.40.50.10890:FF:000001', NULL, NULL, 'Cleavage and polyadenylation specificity factor subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(92439, NULL, 'G3DSA:1.25.40.10:FF:000035', NULL, NULL, 'Tetratricopeptide repeat domain 7B', NULL, NULL, NULL, NULL, NULL, 4),
(92440, NULL, 'G3DSA:2.50.20.10:FF:000012', NULL, NULL, 'Outer-membrane lipoprotein carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(92441, NULL, 'G3DSA:1.20.140.10:FF:000018', NULL, NULL, 'Acyl-CoA dehydrogenase family member 10', NULL, NULL, NULL, NULL, NULL, 4),
(92442, NULL, 'G3DSA:2.102.10.10:FF:000066', NULL, NULL, 'Ferredoxin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(92443, NULL, 'G3DSA:2.10.50.10:FF:000128', NULL, NULL, 'Tumor necrosis factor receptor superfamily, member 1a', NULL, NULL, NULL, NULL, NULL, 4),
(92444, NULL, 'G3DSA:3.40.30.10:FF:000882', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92445, NULL, 'G3DSA:2.40.50.140:FF:000216', NULL, NULL, 'Cell division cycle and apoptosis regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(92446, NULL, 'G3DSA:3.30.1380.20:FF:000034', NULL, NULL, 'Trafficking protein particle complex 6b-like', NULL, NULL, NULL, NULL, NULL, 4),
(92447, NULL, 'G3DSA:3.40.30.10:FF:001101', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92448, NULL, 'G3DSA:1.20.5.190:FF:000172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92449, NULL, 'G3DSA:1.20.58.190:FF:000008', NULL, NULL, 'Translin-associated factor TraX, putative', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(92450, NULL, 'G3DSA:3.30.200.20:FF:000213', NULL, NULL, 'TGF-beta receptor type-2', NULL, NULL, NULL, NULL, NULL, 4),
(92451, NULL, 'G3DSA:2.170.260.40:FF:000002', NULL, NULL, '5''-3'' exoribonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(92452, NULL, 'G3DSA:3.40.50.790:FF:000020', NULL, NULL, 'GM12858', NULL, NULL, NULL, NULL, NULL, 4),
(92453, NULL, 'G3DSA:6.10.250.3250:FF:000001', NULL, NULL, '60S ribosomal protein L13a', NULL, NULL, NULL, NULL, NULL, 4),
(92454, NULL, 'G3DSA:2.40.50.140:FF:000323', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(92455, NULL, 'G3DSA:3.40.50.300:FF:001666', NULL, NULL, 'LuxR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(92456, NULL, 'G3DSA:1.10.357.150:FF:000003', NULL, NULL, 'Centromere/kinetochore protein zw10', NULL, NULL, NULL, NULL, NULL, 4),
(92457, NULL, 'G3DSA:1.10.30.10:FF:000141', NULL, NULL, 'YALI0D26972p', NULL, NULL, NULL, NULL, NULL, 4),
(92458, NULL, 'G3DSA:3.10.20.90:FF:000159', NULL, NULL, 'Ras association domain family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(92459, NULL, 'G3DSA:1.20.1070.10:FF:000787', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92460, NULL, 'G3DSA:1.10.167.10:FF:000043', NULL, NULL, 'Sst2p', NULL, NULL, NULL, NULL, NULL, 4),
(92461, NULL, 'G3DSA:2.10.60.10:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92462, NULL, 'G3DSA:1.10.10.10:FF:000813', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(92463, NULL, 'G3DSA:1.25.10.10:FF:000207', NULL, NULL, 'Pumilio RNA-binding family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(92464, NULL, 'G3DSA:2.60.40.10:FF:002290', NULL, NULL, 'Glycerophosphocholine phosphodiesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(92465, NULL, 'G3DSA:3.30.160.60:FF:002065', NULL, NULL, 'Si:ch211-266d19.4', NULL, NULL, NULL, NULL, NULL, 4),
(92466, NULL, 'G3DSA:3.20.20.70:FF:000809', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92467, NULL, 'G3DSA:2.60.120.310:FF:000012', NULL, NULL, 'probable peptidylglycine alpha-hydroxylating monooxygenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(92468, NULL, 'G3DSA:1.20.120.730:FF:000030', NULL, NULL, 'LOC553407 protein', NULL, NULL, NULL, NULL, NULL, 4),
(92469, NULL, 'G3DSA:3.40.1370.10:FF:000039', NULL, NULL, '50S ribosomal protein L4', NULL, NULL, NULL, NULL, NULL, 4),
(92470, NULL, 'G3DSA:3.40.50.12650:FF:000024', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92471, NULL, 'G3DSA:3.40.800.10:FF:000017', NULL, NULL, 'Agmatinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(92472, NULL, 'G3DSA:3.30.9.10:FF:000283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92473, NULL, 'G3DSA:1.10.10.1100:FF:000013', NULL, NULL, 'Sarcosine oxidase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(92474, NULL, 'G3DSA:3.30.160.60:FF:004133', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92475, NULL, 'G3DSA:4.10.1240.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92476, NULL, 'G3DSA:1.20.920.10:FF:000078', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(92477, NULL, 'G3DSA:3.40.50.300:FF:005937', NULL, NULL, 'RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(92478, NULL, 'G3DSA:3.60.21.10:FF:000124', NULL, NULL, 'Metallo phosphoesterase', NULL, NULL, NULL, NULL, NULL, 4),
(92479, NULL, 'G3DSA:3.40.1500.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92480, NULL, 'G3DSA:3.30.160.60:FF:006336', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92481, NULL, 'G3DSA:1.20.1070.10:FF:001551', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92482, NULL, 'G3DSA:2.60.40.10:FF:005993', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92483, NULL, 'G3DSA:3.10.50.10:FF:000002', NULL, NULL, 'Chitinase domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(92484, NULL, 'G3DSA:3.40.109.10:FF:000023', NULL, NULL, 'Nitroreductase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(92485, NULL, 'G3DSA:2.30.30.30:FF:000014', NULL, NULL, '60S ribosomal protein L6', NULL, NULL, NULL, NULL, NULL, 4),
(92486, NULL, 'G3DSA:1.10.8.10:FF:000099', NULL, NULL, 'Ubiquitin-associated domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(92487, NULL, 'G3DSA:3.30.559.30:FF:000060', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(92488, NULL, 'G3DSA:2.30.30.40:FF:000017', NULL, NULL, 'Formin-binding protein 1-like isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(92489, NULL, 'G3DSA:1.25.40.20:FF:000419', NULL, NULL, 'Regulatory protein SWI6', NULL, NULL, NULL, NULL, NULL, 4),
(92490, NULL, 'G3DSA:1.10.472.10:FF:000156', NULL, NULL, 'Cyclin-D2-2', NULL, NULL, NULL, NULL, NULL, 4),
(92491, NULL, 'G3DSA:3.80.10.10:FF:000486', NULL, NULL, 'probable LRR receptor-like serine/threonine-protein kinase At1g12460', NULL, NULL, NULL, NULL, NULL, 4),
(92492, NULL, 'G3DSA:3.90.740.10:FF:000052', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(92493, NULL, 'G3DSA:3.40.50.1100:FF:000264', NULL, NULL, 'Pyridoxal-5''-phosphate-dependent protein beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(92494, NULL, 'G3DSA:3.40.50.300:FF:002099', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(92495, NULL, 'G3DSA:3.30.450.240:FF:000003', NULL, NULL, 'KICSTOR complex protein C12orf66 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(92496, NULL, 'G3DSA:3.40.50.150:FF:001688', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92497, NULL, 'G3DSA:2.60.120.620:FF:000043', NULL, NULL, 'Serine/threonine-protein kinase CTR1', NULL, NULL, NULL, NULL, NULL, 4),
(92498, NULL, 'G3DSA:1.10.510.10:FF:000263', NULL, NULL, 'MAP kinase skh1/pek1', NULL, NULL, NULL, NULL, NULL, 4),
(92499, NULL, 'G3DSA:2.60.40.10:FF:002413', NULL, NULL, 'Extracellular endoglucanase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(92500, NULL, 'G3DSA:2.60.120.1190:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92501, NULL, 'G3DSA:1.10.510.10:FF:000605', NULL, NULL, 'serine/threonine-protein kinase 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(92502, NULL, 'G3DSA:2.130.10.10:FF:001486', NULL, NULL, 'Polyadenylation factor subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(92503, NULL, 'G3DSA:1.25.40.10:FF:003289', NULL, NULL, 'Os07g0172600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(92504, NULL, 'G3DSA:1.25.40.10:FF:004183', NULL, NULL, 'Protein CBR-DDL-3', NULL, NULL, NULL, NULL, NULL, 4),
(92505, NULL, 'G3DSA:2.130.10.10:FF:000300', NULL, NULL, 'THO complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(92506, NULL, 'G3DSA:1.25.50.20:FF:000089', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(92507, NULL, 'G3DSA:3.20.20.360:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92508, NULL, 'G3DSA:1.20.890.10:FF:000029', NULL, NULL, 'Dpy-30 1', NULL, NULL, NULL, NULL, NULL, 4),
(92509, NULL, 'G3DSA:1.10.10.10:FF:000139', NULL, NULL, 'Fur family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(92510, NULL, 'G3DSA:3.30.420.10:FF:000715', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92511, NULL, 'G3DSA:1.25.40.20:FF:000206', NULL, NULL, 'Ankyrin repeat domain-containing protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(92512, NULL, 'G3DSA:2.40.128.150:FF:000001', NULL, NULL, 'N-hydroxyarylamine O-acetyltransferase NhoA', NULL, NULL, NULL, NULL, NULL, 4),
(92513, NULL, 'G3DSA:3.30.70.330:FF:001456', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92514, NULL, 'G3DSA:3.80.10.10:FF:003127', NULL, NULL, 'GM13370p', NULL, NULL, NULL, NULL, NULL, 4),
(92515, NULL, 'G3DSA:2.40.70.10:FF:000313', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92516, NULL, 'G3DSA:1.10.720.60:FF:000006', NULL, NULL, 'enolase-phosphatase E1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(92517, NULL, 'G3DSA:2.60.40.1180:FF:000098', NULL, NULL, 'Neutral alpha-glucosidase AB', NULL, NULL, NULL, NULL, NULL, 4),
(92518, NULL, 'G3DSA:3.40.50.1440:FF:000062', NULL, NULL, 'Tubulin gamma chain', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(92519, NULL, 'G3DSA:3.30.890.10:FF:000014', NULL, NULL, 'Methyl-CpG-binding domain protein 3b', NULL, NULL, NULL, NULL, NULL, 4),
(92520, NULL, 'G3DSA:2.80.10.50:FF:000258', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92521, NULL, 'G3DSA:1.10.540.10:FF:000107', NULL, NULL, 'Acyl-CoA dehydrogenase long chain', NULL, NULL, NULL, NULL, NULL, 4),
(92522, NULL, 'G3DSA:3.10.50.30:FF:000008', NULL, NULL, 'Transcription elongation factor GreA', NULL, NULL, NULL, NULL, NULL, 4),
(92523, NULL, 'G3DSA:3.40.50.1820:FF:001109', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(92524, NULL, 'G3DSA:1.10.238.200:FF:000009', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(92525, NULL, 'G3DSA:1.25.10.10:FF:001668', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92526, NULL, 'G3DSA:2.130.10.10:FF:005757', NULL, NULL, 'Hepatocyte growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(92527, NULL, 'G3DSA:3.30.310.130:FF:000035', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92528, NULL, 'G3DSA:1.25.40.1030:FF:000024', NULL, NULL, 'Protein transport protein sec16', NULL, NULL, NULL, NULL, NULL, 4),
(92529, NULL, 'G3DSA:3.30.70.330:FF:002350', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92530, NULL, 'G3DSA:1.20.140.10:FF:000069', NULL, NULL, 'Cytochrome c-552', NULL, NULL, NULL, NULL, NULL, 4),
(92531, NULL, 'G3DSA:3.30.160.60:FF:004532', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92532, NULL, 'G3DSA:3.60.21.10:FF:000175', NULL, NULL, 'Vacuolar protein sorting 29', NULL, NULL, NULL, NULL, NULL, 4),
(92533, NULL, 'G3DSA:1.25.10.10:FF:002562', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92534, NULL, 'G3DSA:4.10.400.10:FF:000142', NULL, NULL, 'MAM and LDL receptor class A domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(92535, NULL, 'G3DSA:3.30.360.10:FF:000042', NULL, NULL, 'Glucose-6-phosphate 1-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(92536, NULL, 'G3DSA:3.30.420.10:FF:000367', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92537, NULL, 'G3DSA:2.60.120.10:FF:000566', NULL, NULL, 'Pirin', NULL, NULL, NULL, NULL, NULL, 4),
(92538, NULL, 'G3DSA:2.70.98.60:FF:000003', NULL, NULL, 'Adenylyl-sulfate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(92539, NULL, 'G3DSA:3.30.450.260:FF:000009', NULL, NULL, 'Soluble guanylate cyclase gcy-31', NULL, NULL, NULL, NULL, NULL, 4),
(92540, NULL, 'G3DSA:2.60.40.10:FF:000378', NULL, NULL, 'Nectin cell adhesion molecule 3', NULL, NULL, NULL, NULL, NULL, 4),
(92541, NULL, 'G3DSA:3.30.160.60:FF:000822', NULL, NULL, 'Zinc finger protein 234, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(92542, NULL, 'G3DSA:3.30.70.330:FF:001861', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92543, NULL, 'G3DSA:3.40.50.1000:FF:000565', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92544, NULL, 'G3DSA:1.25.10.10:FF:000140', NULL, NULL, 'Serine/threonine-protein kinase mTOR', NULL, NULL, NULL, NULL, NULL, 4),
(92545, NULL, 'G3DSA:2.60.120.330:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92546, NULL, 'G3DSA:3.90.480.10:FF:000014', NULL, NULL, 'Ferredoxin-sulfite reductase', NULL, NULL, NULL, NULL, NULL, 4),
(92547, NULL, 'G3DSA:3.40.30.10:FF:000258', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(92548, NULL, 'G3DSA:3.30.40.140:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92549, NULL, 'G3DSA:3.40.50.1460:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92550, NULL, 'G3DSA:3.90.1480.20:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92551, NULL, 'G3DSA:1.10.560.10:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92552, NULL, 'G3DSA:3.90.190.20:FF:000023', NULL, NULL, 'Bifunctional folylpolyglutamate synthase/dihydrofolate synthase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(92553, NULL, 'G3DSA:3.30.760.10:FF:000010', NULL, NULL, 'Eukaryotic translation initiation factor 4E1', NULL, NULL, NULL, NULL, NULL, 4),
(92554, NULL, 'G3DSA:1.10.510.10:FF:004028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92555, NULL, 'G3DSA:2.60.40.10:FF:004032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92556, NULL, 'G3DSA:2.40.30.10:FF:000266', NULL, NULL, 'Translation initiation factor IF-2', NULL, NULL, NULL, NULL, NULL, 4),
(92557, NULL, 'G3DSA:3.40.50.410:FF:000277', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(92558, NULL, 'G3DSA:3.30.310.10:FF:000033', NULL, NULL, 'TATA box-binding protein-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(92559, NULL, 'G3DSA:3.30.1330.20:FF:000031', NULL, NULL, 'Cell division protein FtsZ', NULL, NULL, NULL, NULL, NULL, 4),
(92560, NULL, 'G3DSA:1.20.1070.10:FF:001169', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(92561, NULL, 'G3DSA:3.30.60.20:FF:000117', NULL, NULL, 'Protein kinase D2', NULL, NULL, NULL, NULL, NULL, 4),
(92562, NULL, 'G3DSA:1.10.10.10:FF:001483', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(92563, NULL, 'G3DSA:1.20.58.390:FF:000063', NULL, NULL, 'AcetylCholine Receptor', NULL, NULL, NULL, NULL, NULL, 4),
(92564, NULL, 'G3DSA:2.60.120.920:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92565, NULL, 'G3DSA:3.10.50.40:FF:000056', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(92566, NULL, 'G3DSA:1.25.40.20:FF:001729', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(92567, NULL, 'G3DSA:3.90.1480.20:FF:000056', NULL, NULL, 'ST3 beta-galactoside alpha-2,3-sialyltransferase 5', NULL, NULL, NULL, NULL, NULL, 4),
(92568, NULL, 'G3DSA:1.20.1070.10:FF:001225', NULL, NULL, 'Alpha-2B adrenergic receptor', NULL, NULL, NULL, NULL, NULL, 4),
(92569, NULL, 'G3DSA:2.60.40.640:FF:000051', NULL, NULL, 'Vacuolar sorting protein 26, putative', NULL, NULL, NULL, NULL, NULL, 4),
(92570, NULL, 'G3DSA:3.30.160.60:FF:003970', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92571, NULL, 'G3DSA:2.60.40.1910:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92572, NULL, 'G3DSA:1.10.533.10:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92573, NULL, 'G3DSA:3.30.70.330:FF:001237', NULL, NULL, 'RNA-binding RNA annealing protein', NULL, NULL, NULL, NULL, NULL, 4),
(92574, NULL, 'G3DSA:3.30.160.60:FF:002391', NULL, NULL, 'Transcription factor IIIA', NULL, NULL, NULL, NULL, NULL, 4),
(92575, NULL, 'G3DSA:1.20.190.50:FF:000005', NULL, NULL, 'Nuclear pore complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(92576, NULL, 'G3DSA:3.30.1330.30:FF:000034', NULL, NULL, 'Os03g0685100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(92577, NULL, 'G3DSA:3.90.1410.10:FF:000054', NULL, NULL, 'Histone-lysine N-methyltransferase setd3', NULL, NULL, NULL, NULL, NULL, 4),
(92578, NULL, 'G3DSA:3.40.1110.10:FF:000386', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92579, NULL, 'G3DSA:1.25.10.10:FF:003248', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92580, NULL, 'G3DSA:3.40.50.300:FF:007101', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92581, NULL, 'G3DSA:2.60.40.150:FF:000286', NULL, NULL, 'C2 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(92582, NULL, 'G3DSA:1.25.10.10:FF:000651', NULL, NULL, 'Unplaced genomic scaffold supercont1.201, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(92583, NULL, 'G3DSA:1.20.120.1750:FF:000106', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(92584, NULL, 'G3DSA:2.130.10.10:FF:000356', NULL, NULL, 'U4/U6 small nuclear ribonucleoprotein Prp4', NULL, NULL, NULL, NULL, NULL, 4),
(92585, NULL, 'G3DSA:2.40.50.740:FF:000008', NULL, NULL, '40S ribosomal protein S4-3', NULL, NULL, NULL, NULL, NULL, 4),
(92586, NULL, 'G3DSA:4.10.1000.40:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(92587, NULL, 'G3DSA:1.20.190.40:FF:000002', NULL, NULL, 'Major DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(92588, NULL, 'G3DSA:3.80.10.10:FF:000379', NULL, NULL, 'Protein NSP-INTERACTING KINASE 2', NULL, NULL, NULL, NULL, NULL, 4),
(92589, NULL, 'G3DSA:3.40.50.150:FF:000800', NULL, NULL, 'Capsuleen, putative', NULL, NULL, NULL, NULL, NULL, 4),
(92590, NULL, 'G3DSA:4.10.60.10:FF:000231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92591, NULL, 'G3DSA:1.25.50.20:FF:000033', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(92592, NULL, 'G3DSA:1.20.1560.10:FF:000583', NULL, NULL, 'ABC transporter B family member 27', NULL, NULL, NULL, NULL, NULL, 4),
(92593, NULL, 'G3DSA:1.50.10.150:FF:000005', NULL, NULL, 'Sulfite efflux pump SSU1', NULL, NULL, NULL, NULL, NULL, 4),
(92594, NULL, 'G3DSA:3.40.140.10:FF:000006', NULL, NULL, 'Cytidine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(92595, NULL, 'G3DSA:2.60.40.640:FF:000006', NULL, NULL, 'Vacuolar protein sorting-associated protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(92596, NULL, 'G3DSA:2.130.10.10:FF:001935', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92597, NULL, 'G3DSA:2.160.10.10:FF:000102', NULL, NULL, 'Eukaryotic translation initiation factor 2B, epsilon subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(92598, NULL, 'G3DSA:3.40.140.10:FF:000045', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(92599, NULL, 'G3DSA:1.25.40.540:FF:000003', NULL, NULL, 'Immunoglobulin (CD79A)-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(92600, NULL, 'G3DSA:2.130.10.10:FF:004010', NULL, NULL, 'LD12356p', NULL, NULL, NULL, NULL, NULL, 4),
(92601, NULL, 'G3DSA:3.90.105.20:FF:000012', NULL, NULL, 'Ribosome assembly factor mrt4', NULL, NULL, NULL, NULL, NULL, 4),
(92602, NULL, 'G3DSA:2.40.10.10:FF:000265', NULL, NULL, 'GM13457', NULL, NULL, NULL, NULL, NULL, 4),
(92603, NULL, 'G3DSA:2.10.90.10:FF:000075', NULL, NULL, 'Follicle stimulating hormone beta', NULL, NULL, NULL, NULL, NULL, 4),
(92604, NULL, 'G3DSA:2.10.90.10:FF:000018', NULL, NULL, 'Spatzle 4', NULL, NULL, NULL, NULL, NULL, 4),
(92605, NULL, 'G3DSA:1.25.40.10:FF:000203', NULL, NULL, 'E3 ubiquitin-protein ligase TTC3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(92606, NULL, 'G3DSA:1.50.10.140:FF:000002', NULL, NULL, 'Cyclic beta-1,2-glucan synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(92607, NULL, 'G3DSA:3.40.950.10:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92608, NULL, 'G3DSA:3.30.230.10:FF:000032', NULL, NULL, 'mismatch repair endonuclease PMS2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(92609, NULL, 'G3DSA:1.10.533.10:FF:000181', NULL, NULL, 'Putative nuclear matrix protein', NULL, NULL, NULL, NULL, NULL, 4),
(92610, NULL, 'G3DSA:1.25.40.20:FF:000532', NULL, NULL, 'CRE-DAPK-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(92611, NULL, 'G3DSA:3.40.50.720:FF:001943', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92612, NULL, 'G3DSA:1.25.40.20:FF:000482', NULL, NULL, 'Ankyrin repeats (3 copies), putative', NULL, NULL, NULL, NULL, NULL, 4),
(92613, NULL, 'G3DSA:2.60.40.10:FF:001957', NULL, NULL, 'TAP binding protein-like variant', NULL, NULL, NULL, NULL, NULL, 4),
(92614, NULL, 'G3DSA:2.60.40.10:FF:002851', NULL, NULL, 'Glycosyl hydrolase family 3 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(92615, NULL, 'G3DSA:1.20.990.10:FF:000026', NULL, NULL, 'NADPH-cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(92616, NULL, 'G3DSA:2.60.40.10:FF:000721', NULL, NULL, 'Immunoglobulin lambda variable 5-45', NULL, NULL, NULL, NULL, NULL, 4),
(92617, NULL, 'G3DSA:3.80.10.10:FF:001273', NULL, NULL, 'Nischarin', NULL, NULL, NULL, NULL, NULL, 4),
(92618, NULL, 'G3DSA:1.20.140.40:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92619, NULL, 'G3DSA:3.40.50.1000:FF:000514', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92620, NULL, 'G3DSA:1.10.8.10:FF:000335', NULL, NULL, 'OTU deubiquitinase 7B', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(92621, NULL, 'G3DSA:3.40.50.10190:FF:000292', NULL, NULL, 'DNA ligase 4', NULL, NULL, NULL, NULL, NULL, 4),
(92622, NULL, 'G3DSA:3.20.20.70:FF:000692', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92623, NULL, 'G3DSA:3.40.30.10:FF:000264', NULL, NULL, 'Glutathione S-transferase mu 1', NULL, NULL, NULL, NULL, NULL, 4),
(92624, NULL, 'G3DSA:2.130.10.10:FF:000412', NULL, NULL, 'WD repeat domain 54', NULL, NULL, NULL, NULL, NULL, 4),
(92625, NULL, 'G3DSA:3.40.50.2300:FF:000180', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(92626, NULL, 'G3DSA:3.40.605.10:FF:000058', NULL, NULL, 'Aldehyde dehydrogenase 3 family, member A2a', NULL, NULL, NULL, NULL, NULL, 4),
(92627, NULL, 'G3DSA:1.20.5.2440:FF:000002', NULL, NULL, 'rab11 family-interacting protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(92628, NULL, 'G3DSA:3.40.1110.10:FF:000329', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92629, NULL, 'G3DSA:1.10.1200.10:FF:000098', NULL, NULL, 'Enniatin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(92630, NULL, 'G3DSA:1.10.530.10:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92631, NULL, 'G3DSA:3.90.1460.10:FF:000001', NULL, NULL, 'general transcription factor II-I isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(92632, NULL, 'G3DSA:3.30.40.10:FF:000748', NULL, NULL, 'PHD finger domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(92633, NULL, 'G3DSA:1.10.1450.10:FF:000032', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(92634, NULL, 'G3DSA:1.25.40.10:FF:003963', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92635, NULL, 'G3DSA:2.60.40.1180:FF:000154', NULL, NULL, 'Starch branching enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(92636, NULL, 'G3DSA:1.10.10.60:FF:000401', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(92637, NULL, 'G3DSA:2.70.150.10:FF:000161', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(92638, NULL, 'G3DSA:1.10.533.10:FF:000068', NULL, NULL, 'NLR family CARD domain containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(92639, NULL, 'G3DSA:2.130.10.10:FF:004740', NULL, NULL, 'Transducin', NULL, NULL, NULL, NULL, NULL, 4),
(92640, NULL, 'G3DSA:3.30.860.10:FF:000006', NULL, NULL, 'Ribosomal protein S19, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(92641, NULL, 'G3DSA:3.20.20.80:FF:000695', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92642, NULL, 'G3DSA:3.30.565.10:FF:000051', NULL, NULL, '[3-methyl-2-oxobutanoate dehydrogenase [lipoamide]] kinase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(92643, NULL, 'G3DSA:1.10.3370.10:FF:000054', NULL, NULL, 'Os12g0627700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(92644, NULL, 'G3DSA:1.10.10.10:FF:002090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92645, NULL, 'G3DSA:2.30.39.10:FF:000163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92646, NULL, 'G3DSA:3.40.50.300:FF:002155', NULL, NULL, 'U5 small nuclear ribonuclear protein', NULL, NULL, NULL, NULL, NULL, 4),
(92647, NULL, 'G3DSA:1.10.510.10:FF:004085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92648, NULL, 'G3DSA:1.20.58.220:FF:000001', NULL, NULL, 'Phosphate-specific transport system accessory protein PhoU', NULL, NULL, NULL, NULL, NULL, 4),
(92649, NULL, 'G3DSA:3.30.1460.50:FF:000015', NULL, NULL, 'ATG10 autophagy-related 10 homolog (S. cerevisiae)', NULL, NULL, NULL, NULL, NULL, 4),
(92650, NULL, 'G3DSA:3.30.160.60:FF:004206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92651, NULL, 'G3DSA:1.10.3730.20:FF:000079', NULL, NULL, 'Putative membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(92652, NULL, 'G3DSA:2.30.30.140:FF:000226', NULL, NULL, 'RE70955p', NULL, NULL, NULL, NULL, NULL, 4),
(92653, NULL, 'G3DSA:3.60.130.30:FF:000001', NULL, NULL, 'Bifunctional helicase and thymine dioxygenase JBP2', NULL, NULL, NULL, NULL, NULL, 4),
(92654, NULL, 'G3DSA:1.20.120.790:FF:000025', NULL, NULL, 'Chaperone protein HtpG', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(92655, NULL, 'G3DSA:3.40.50.300:FF:005589', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92656, NULL, 'G3DSA:3.30.70.330:FF:001187', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(92657, NULL, 'G3DSA:2.60.40.1180:FF:000047', NULL, NULL, '1,4-alpha-glucan branching enzyme GlgB', NULL, NULL, NULL, NULL, NULL, 4),
(92658, NULL, 'G3DSA:3.30.160.60:FF:002115', NULL, NULL, 'Krueppel-like factor 15', NULL, NULL, NULL, NULL, NULL, 4),
(92659, NULL, 'G3DSA:1.10.10.10:FF:002051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92660, NULL, 'G3DSA:1.20.58.530:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92661, NULL, 'G3DSA:1.20.1250.20:FF:001377', NULL, NULL, 'Major facilitator superfamily MFS_1', NULL, NULL, NULL, NULL, NULL, 4),
(92662, NULL, 'G3DSA:1.25.40.10:FF:001783', NULL, NULL, 'Transcription factor EMB1444', NULL, NULL, NULL, NULL, NULL, 4),
(92663, NULL, 'G3DSA:3.40.50.1820:FF:001154', NULL, NULL, 'Carbohydrate esterase MZ0003', NULL, NULL, NULL, NULL, NULL, 4),
(92664, NULL, 'G3DSA:3.40.50.2300:FF:001427', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92665, NULL, 'G3DSA:1.25.40.10:FF:001726', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(92666, NULL, 'G3DSA:3.90.550.50:FF:000116', NULL, NULL, 'Beta-1,3-galactosyltransferase bre-5', NULL, NULL, NULL, NULL, NULL, 4),
(92667, NULL, 'G3DSA:3.40.50.12650:FF:000018', NULL, NULL, 'YALI0E29931p', NULL, NULL, NULL, NULL, NULL, 4),
(92668, NULL, 'G3DSA:3.40.50.10490:FF:000168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92669, NULL, 'G3DSA:3.80.20.20:FF:000028', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(92670, NULL, 'G3DSA:3.40.50.300:FF:007955', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92671, NULL, 'G3DSA:1.20.120.1220:FF:000009', NULL, NULL, 'Type 4 prepilin-like proteins leader peptide-processing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(92672, NULL, 'G3DSA:2.60.120.1440:FF:000013', NULL, NULL, 'FecR family protein', NULL, NULL, NULL, NULL, NULL, 4),
(92673, NULL, 'G3DSA:3.40.50.1000:FF:000621', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92674, NULL, 'G3DSA:2.40.160.20:FF:000031', NULL, NULL, 'Major outer membrane protein OmpA', NULL, NULL, NULL, NULL, NULL, 4),
(92675, NULL, 'G3DSA:3.50.50.60:FF:001398', NULL, NULL, 'Lysine demethylase 1A', NULL, NULL, NULL, NULL, NULL, 4),
(92676, NULL, 'G3DSA:3.40.50.300:FF:008411', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(92677, NULL, 'G3DSA:1.50.10.20:FF:000079', NULL, NULL, 'Protein farnesyltransferase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(92678, NULL, 'G3DSA:1.10.510.10:FF:002174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92679, NULL, 'G3DSA:3.30.40.10:FF:001355', NULL, NULL, 'Tripartite motif-containing 28', NULL, NULL, NULL, NULL, NULL, 4),
(92680, NULL, 'G3DSA:1.10.472.130:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92681, NULL, 'G3DSA:3.40.50.300:FF:007793', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92682, NULL, 'G3DSA:2.120.10.80:FF:000203', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(92683, NULL, 'G3DSA:1.10.8.720:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92684, NULL, 'G3DSA:3.40.50.150:FF:000507', NULL, NULL, 'Possible transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(92685, NULL, 'G3DSA:3.30.40.10:FF:001535', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92686, NULL, 'G3DSA:1.50.10.10:FF:000076', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(92687, NULL, 'G3DSA:3.30.190.20:FF:000048', NULL, NULL, 'Ribosomal protein L1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(92688, NULL, 'G3DSA:3.90.470.20:FF:000011', NULL, NULL, 'Os08g0243100 protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(92689, NULL, 'G3DSA:3.40.395.10:FF:000018', NULL, NULL, 'Related to Ubl-specific protease', NULL, NULL, NULL, NULL, NULL, 4),
(92690, NULL, 'G3DSA:3.10.100.10:FF:000252', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92691, NULL, 'G3DSA:1.25.40.10:FF:000422', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(92692, NULL, 'G3DSA:1.20.1070.10:FF:001512', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92693, NULL, 'G3DSA:3.40.50.300:FF:004302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92694, NULL, 'G3DSA:2.130.10.10:FF:003285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92695, NULL, 'G3DSA:3.40.50.300:FF:005769', NULL, NULL, 'DNA binding protein eukaryotic-like', NULL, NULL, NULL, NULL, NULL, 4),
(92696, NULL, 'G3DSA:1.25.40.20:FF:000425', NULL, NULL, 'Glutaminase 2', NULL, NULL, NULL, NULL, NULL, 4),
(92697, NULL, 'G3DSA:3.30.559.30:FF:000110', NULL, NULL, 'Nonribosomal peptide synthetase easA', NULL, NULL, NULL, NULL, NULL, 4),
(92698, NULL, 'G3DSA:3.40.640.10:FF:000246', NULL, NULL, 'Arginine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(92699, NULL, 'G3DSA:3.40.50.1000:FF:000801', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92700, NULL, 'G3DSA:3.30.559.30:FF:000054', NULL, NULL, 'Peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(92701, NULL, 'G3DSA:1.10.510.10:FF:004360', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92702, NULL, 'G3DSA:3.30.160.60:FF:005768', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92703, NULL, 'G3DSA:1.20.5.340:FF:000071', NULL, NULL, 'Cortexillin-1', NULL, NULL, NULL, NULL, NULL, 4),
(92704, NULL, 'G3DSA:1.20.930.40:FF:000014', NULL, NULL, 'Inactive zinc metalloprotease C354.09c', NULL, NULL, NULL, NULL, NULL, 4),
(92705, NULL, 'G3DSA:3.10.20.600:FF:000003', NULL, NULL, 'NADH-quinone oxidoreductase subunit F', NULL, NULL, NULL, NULL, NULL, 4),
(92706, NULL, 'G3DSA:1.20.1070.10:FF:001282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92707, NULL, 'G3DSA:2.40.20.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92708, NULL, 'G3DSA:3.40.50.300:FF:006376', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92709, NULL, 'G3DSA:1.20.1250.40:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92710, NULL, 'G3DSA:2.20.70.10:FF:000090', NULL, NULL, 'Formin binding protein (FNB3)', NULL, NULL, NULL, NULL, NULL, 4),
(92711, NULL, 'G3DSA:2.70.170.10:FF:000050', NULL, NULL, 'Nicotinic acetylcholine receptor alpha4, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(92712, NULL, 'G3DSA:2.130.10.10:FF:001992', NULL, NULL, 'U4/U6 small nuclear ribonucleoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(92713, NULL, 'G3DSA:2.60.40.10:FF:001103', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', NULL, NULL, NULL, NULL, NULL, 4),
(92714, NULL, 'G3DSA:1.10.510.10:FF:003753', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92715, NULL, 'G3DSA:1.20.272.10:FF:000009', NULL, NULL, 'replication factor C subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(92716, NULL, 'G3DSA:2.170.150.80:FF:000006', NULL, NULL, 'NAC domain-containing protein 100-like', NULL, NULL, NULL, NULL, NULL, 4),
(92717, NULL, 'G3DSA:3.30.70.1560:FF:000011', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(92718, NULL, 'G3DSA:1.10.287.110:FF:000441', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92719, NULL, 'G3DSA:3.50.50.60:FF:001454', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92720, NULL, 'G3DSA:3.80.10.10:FF:002796', NULL, NULL, 'Si:dkey-157e10.6', NULL, NULL, NULL, NULL, NULL, 4),
(92721, NULL, 'G3DSA:3.30.160.60:FF:002059', NULL, NULL, 'transcription factor Ken', NULL, NULL, NULL, NULL, NULL, 4),
(92722, NULL, 'G3DSA:1.10.1750.10:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92723, NULL, 'G3DSA:2.40.10.10:FF:000208', NULL, NULL, 'Serine-peptidase 212', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(92724, NULL, 'G3DSA:2.30.29.30:FF:001343', NULL, NULL, 'Protein vav-1', NULL, NULL, NULL, NULL, NULL, 4),
(92725, NULL, 'G3DSA:1.10.8.60:FF:000597', NULL, NULL, 'Cell division control protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(92726, NULL, 'G3DSA:3.30.450.20:FF:000198', NULL, NULL, 'Two-component system, cell cycle sensor histidine kinase PleC', NULL, NULL, NULL, NULL, NULL, 4),
(92727, NULL, 'G3DSA:3.30.470.20:FF:000199', NULL, NULL, 'Glutathione synthetase ATP-binding domain-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(92728, NULL, 'G3DSA:3.30.160.60:FF:002334', NULL, NULL, 'Tripartite motif containing 15', NULL, NULL, NULL, NULL, NULL, 4),
(92729, NULL, 'G3DSA:3.30.40.10:FF:002030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92730, NULL, 'G3DSA:1.10.8.10:FF:000279', NULL, NULL, 'Putative BOI-related E3 ubiquitin-protein ligase 3', NULL, NULL, NULL, NULL, NULL, 4),
(92731, NULL, 'G3DSA:2.60.40.150:FF:000516', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92732, NULL, 'G3DSA:1.20.140.150:FF:000051', NULL, NULL, 'Germ cell associated 1', NULL, NULL, NULL, NULL, NULL, 4),
(92733, NULL, 'G3DSA:3.40.50.300:FF:007736', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92734, NULL, 'G3DSA:3.40.50.1010:FF:000063', NULL, NULL, 'Ribonuclease VapC', NULL, NULL, NULL, NULL, NULL, 4),
(92735, NULL, 'G3DSA:1.10.510.10:FF:002117', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92736, NULL, 'G3DSA:4.10.60.10:FF:000118', NULL, NULL, 'DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(92737, NULL, 'G3DSA:3.40.50.1100:FF:000090', NULL, NULL, 'Threonine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(92738, NULL, 'G3DSA:3.10.450.240:FF:000019', NULL, NULL, '39S ribosomal protein L45, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(92739, NULL, 'G3DSA:1.10.1670.10:FF:000014', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(92740, NULL, 'G3DSA:3.40.50.1700:FF:000062', NULL, NULL, 'Thermostable beta-glucosidase B', NULL, NULL, NULL, NULL, NULL, 4),
(92741, NULL, 'G3DSA:3.40.720.10:FF:000247', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92742, NULL, 'G3DSA:1.10.1200.10:FF:000154', NULL, NULL, 'Ferrichrome siderophore peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(92743, NULL, 'G3DSA:3.10.170.20:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92744, NULL, 'G3DSA:2.40.50.690:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92745, NULL, 'G3DSA:2.40.10.10:FF:000484', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92746, NULL, 'G3DSA:3.30.1680.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92747, NULL, 'G3DSA:3.10.590.10:FF:000018', NULL, NULL, 'Os08g0485300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(92748, NULL, 'G3DSA:1.25.40.470:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92749, NULL, 'G3DSA:3.20.20.140:FF:000346', NULL, NULL, 'Adenosine deaminase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(92750, NULL, 'G3DSA:1.50.10.160:FF:000008', NULL, NULL, '(E)-nerolidol/(E,E)-geranyl linalool synthase', NULL, NULL, NULL, NULL, NULL, 4),
(92751, NULL, 'G3DSA:3.40.50.1110:FF:000093', NULL, NULL, 'Lipolytic protein G-D-S-L family', NULL, NULL, NULL, NULL, NULL, 4),
(92752, NULL, 'G3DSA:3.40.630.10:FF:000190', NULL, NULL, 'GM13753', NULL, NULL, NULL, NULL, NULL, 4),
(92753, NULL, 'G3DSA:1.20.58.60:FF:000668', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92754, NULL, 'G3DSA:2.30.29.30:FF:000668', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(92755, NULL, 'G3DSA:1.25.40.10:FF:000147', NULL, NULL, 'Mitochondrial fission 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(92756, NULL, 'G3DSA:1.25.10.10:FF:000432', NULL, NULL, 'Pumilio-homology domain family', NULL, NULL, NULL, NULL, NULL, 4),
(92757, NULL, 'G3DSA:3.90.226.10:FF:000205', NULL, NULL, 'Enoyl-CoA hydratase/isomerase family protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(92758, NULL, 'G3DSA:1.25.10.10:FF:003467', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92759, NULL, 'G3DSA:1.20.120.1200:FF:000003', NULL, NULL, 'NADH-ubiquinone oxidoreductase chain 6', NULL, NULL, NULL, NULL, NULL, 4),
(92760, NULL, 'G3DSA:2.30.42.10:FF:000013', NULL, NULL, 'Putative tight junction protein ZO-1', NULL, NULL, NULL, NULL, NULL, 4),
(92761, NULL, 'G3DSA:2.60.40.10:FF:002121', NULL, NULL, 'I-set domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(92762, NULL, 'G3DSA:1.10.455.10:FF:000015', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(92763, NULL, 'G3DSA:2.60.120.10:FF:000673', NULL, NULL, 'Homogentisate 1,2-dioxygenase HmgA', NULL, NULL, NULL, NULL, NULL, 4),
(92764, NULL, 'G3DSA:3.40.50.1000:FF:000060', NULL, NULL, 'Haloacid dehalogenase-like hydrolase domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(92765, NULL, 'G3DSA:2.60.40.10:FF:002519', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(92766, NULL, 'G3DSA:1.10.510.10:FF:002735', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92767, NULL, 'G3DSA:2.40.100.10:FF:000103', NULL, NULL, '26S proteasome regulatory complex ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(92768, NULL, 'G3DSA:3.30.160.60:FF:004425', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92769, NULL, 'G3DSA:1.20.5.190:FF:000060', NULL, NULL, 'Myosin XVA', NULL, NULL, NULL, NULL, NULL, 4),
(92770, NULL, 'G3DSA:1.20.1250.20:FF:000719', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(92771, NULL, 'G3DSA:1.20.5.190:FF:000003', NULL, NULL, 'Calmodulin-binding transcription activator 2', NULL, NULL, NULL, NULL, NULL, 4),
(92772, NULL, 'G3DSA:3.30.60.30:FF:000233', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92773, NULL, 'G3DSA:1.10.287.90:FF:000007', NULL, NULL, 'Cytochrome c oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(92774, NULL, 'G3DSA:2.60.120.10:FF:000616', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92775, NULL, 'G3DSA:3.40.50.720:FF:002399', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92776, NULL, 'G3DSA:3.90.1110.10:FF:000014', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(92777, NULL, 'G3DSA:3.40.190.290:FF:000001', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(92778, NULL, 'G3DSA:2.60.40.10:FF:000940', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(92779, NULL, 'G3DSA:3.40.50.2020:FF:000034', NULL, NULL, 'Ribose-phosphate pyrophosphokinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(92780, NULL, 'G3DSA:2.20.25.10:FF:000070', NULL, NULL, 'Terminal oxygenase component of carbazole', NULL, NULL, NULL, NULL, NULL, 4),
(92781, NULL, 'G3DSA:3.90.1280.20:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92782, NULL, 'G3DSA:3.30.430.20:FF:000022', NULL, NULL, 'Os07g0534300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(92783, NULL, 'G3DSA:1.10.760.10:FF:000073', NULL, NULL, 'Cytochrome b/c1', NULL, NULL, NULL, NULL, NULL, 4),
(92784, NULL, 'G3DSA:3.80.10.10:FF:001834', NULL, NULL, 'EIN3-binding F-box protein 1 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(92785, NULL, 'G3DSA:3.10.450.50:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92786, NULL, 'G3DSA:1.10.510.10:FF:000650', NULL, NULL, 'Serine/threonine-protein kinase ppk16', NULL, NULL, NULL, NULL, NULL, 4),
(92787, NULL, 'G3DSA:2.60.40.840:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92788, NULL, 'G3DSA:3.90.80.10:FF:000006', NULL, NULL, 'Inorganic pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(92789, NULL, 'G3DSA:3.40.50.1100:FF:000157', NULL, NULL, 'Cysteine synthase B protein', NULL, NULL, NULL, NULL, NULL, 4),
(92790, NULL, 'G3DSA:3.40.47.10:FF:000010', NULL, NULL, 'Acetyl-CoA acetyltransferase (Thiolase)', NULL, NULL, NULL, NULL, NULL, 4),
(92791, NULL, 'G3DSA:2.60.40.60:FF:000365', NULL, NULL, 'FlaMIngo (Cadherin plus 7TM domain) homolog', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(92792, NULL, 'G3DSA:2.40.30.10:FF:000210', NULL, NULL, 'Eukaryotic peptide chain release factor GTP-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(92793, NULL, 'G3DSA:2.60.120.560:FF:000002', NULL, NULL, 'Beta-fructofuranosidase, insoluble isoenzyme CWINV1', NULL, NULL, NULL, NULL, NULL, 4),
(92794, NULL, 'G3DSA:2.40.30.10:FF:000154', NULL, NULL, 'Selenocysteine-specific translation elongation factor', NULL, NULL, NULL, NULL, NULL, 4),
(92795, NULL, 'G3DSA:3.30.1370.10:FF:000204', NULL, NULL, 'Vigilin 1', NULL, NULL, NULL, NULL, NULL, 4),
(92796, NULL, 'G3DSA:2.60.120.260:FF:000013', NULL, NULL, 'Neuropilin', NULL, NULL, NULL, NULL, NULL, 4),
(92797, NULL, 'G3DSA:3.40.50.300:FF:008118', NULL, NULL, 'Polynucleotide kinase 3''-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(92798, NULL, 'G3DSA:1.20.120.980:FF:000020', NULL, NULL, 'Serine protease 16', NULL, NULL, NULL, NULL, NULL, 4),
(92799, NULL, 'G3DSA:3.80.10.10:FF:002110', NULL, NULL, 'Protein CBG22694', NULL, NULL, NULL, NULL, NULL, 4),
(92800, NULL, 'G3DSA:1.10.287.660:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92801, NULL, 'G3DSA:1.10.506.10:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92802, NULL, 'G3DSA:1.10.3090.10:FF:000009', NULL, NULL, 'Polynucleotide adenylyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(92803, NULL, 'G3DSA:1.20.1250.20:FF:001271', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92804, NULL, 'G3DSA:1.20.1250.20:FF:001613', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92805, NULL, 'G3DSA:3.40.50.300:FF:004807', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92806, NULL, 'G3DSA:1.20.5.110:FF:000255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92807, NULL, 'G3DSA:3.40.640.10:FF:000027', NULL, NULL, 'Serine--pyruvate aminotransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(92808, NULL, 'G3DSA:3.10.110.10:FF:000314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92809, NULL, 'G3DSA:3.30.160.60:FF:001952', NULL, NULL, 'Zgc:174623 protein', NULL, NULL, NULL, NULL, NULL, 4),
(92810, NULL, 'G3DSA:3.40.50.300:FF:000536', NULL, NULL, 'GTPase IMAP family member 8', NULL, NULL, NULL, NULL, NULL, 4),
(92811, NULL, 'G3DSA:1.10.418.10:FF:000109', NULL, NULL, 'Patronin (microtubule-binding protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(92812, NULL, 'G3DSA:3.40.50.1240:FF:000171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92813, NULL, 'G3DSA:1.10.10.10:FF:001595', NULL, NULL, 'Eugenol O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(92814, NULL, 'G3DSA:3.90.280.10:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92815, NULL, 'G3DSA:3.40.30.10:FF:001045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92816, NULL, 'G3DSA:3.40.50.300:FF:004521', NULL, NULL, 'ATP-dependent RecD-like DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(92817, NULL, 'G3DSA:1.10.400.10:FF:000041', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92818, NULL, 'G3DSA:2.130.10.10:FF:001716', NULL, NULL, 'Inositol requiring 1-1', NULL, NULL, NULL, NULL, NULL, 4),
(92819, NULL, 'G3DSA:3.40.720.10:FF:000028', NULL, NULL, 'Non-specific phospholipase C1', NULL, NULL, NULL, NULL, NULL, 4),
(92820, NULL, 'G3DSA:1.10.230.10:FF:000005', NULL, NULL, 'ATP-citrate synthase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(92821, NULL, 'G3DSA:2.70.150.10:FF:000009', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(92822, NULL, 'G3DSA:3.10.20.30:FF:000006', NULL, NULL, 'Threonine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(92823, NULL, 'G3DSA:3.40.50.2300:FF:001540', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92824, NULL, 'G3DSA:3.30.420.40:FF:000241', NULL, NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(92825, NULL, 'G3DSA:2.60.40.10:FF:004537', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(92826, NULL, 'G3DSA:2.60.40.10:FF:003537', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92827, NULL, 'G3DSA:1.20.870.10:FF:000028', NULL, NULL, 'Ral GDS-Like', NULL, NULL, NULL, NULL, NULL, 4),
(92828, NULL, 'G3DSA:1.20.120.830:FF:000003', NULL, NULL, 'Putative breast cancer anti-estrogen resistance protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(92829, NULL, 'G3DSA:3.80.10.10:FF:003015', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92830, NULL, 'G3DSA:3.40.190.10:FF:000104', NULL, NULL, 'Peptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(92831, NULL, 'G3DSA:2.60.40.60:FF:000308', NULL, NULL, 'Cadherin 74A, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(92832, NULL, 'G3DSA:1.25.40.10:FF:002507', NULL, NULL, 'TPR repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(92833, NULL, 'G3DSA:1.10.10.2660:FF:000008', NULL, NULL, 'Ubiquitin-activating enzyme e1', NULL, NULL, NULL, NULL, NULL, 4),
(92834, NULL, 'G3DSA:3.10.105.10:FF:000128', NULL, NULL, 'ABC-type dipeptide transport system periplasmic component-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(92835, NULL, 'G3DSA:2.130.10.10:FF:004122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92836, NULL, 'G3DSA:1.10.220.150:FF:000015', NULL, NULL, 'arf-GAP with dual PH domain-containing protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(92837, NULL, 'G3DSA:3.40.50.150:FF:000564', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(92838, NULL, 'G3DSA:1.10.472.130:FF:000009', NULL, NULL, 'Dynein heavy chain 5, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(92839, NULL, 'G3DSA:1.10.220.160:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92840, NULL, 'G3DSA:1.20.1250.20:FF:000596', NULL, NULL, 'Vitamin b6 transporter bsu1', NULL, NULL, NULL, NULL, NULL, 4),
(92841, NULL, 'G3DSA:4.10.1110.10:FF:000009', NULL, NULL, 'Probable ubiquitin', NULL, NULL, NULL, NULL, NULL, 4),
(92842, NULL, 'G3DSA:1.20.120.850:FF:000009', NULL, NULL, 'SNF2 family helicase/ATPase (Swr1)', NULL, NULL, NULL, NULL, NULL, 4),
(92843, NULL, 'G3DSA:2.10.25.10:FF:000952', NULL, NULL, 'Putative Fibrillin-1', NULL, NULL, NULL, NULL, NULL, 4),
(92844, NULL, 'G3DSA:2.130.10.10:FF:003846', NULL, NULL, 'ARPC1', NULL, NULL, NULL, NULL, NULL, 4),
(92845, NULL, 'G3DSA:2.40.10.10:FF:000501', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92846, NULL, 'G3DSA:1.20.1050.80:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92847, NULL, 'G3DSA:1.10.8.720:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92848, NULL, 'G3DSA:3.40.50.150:FF:000906', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92849, NULL, 'G3DSA:3.40.50.2020:FF:000091', NULL, NULL, 'Orotate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(92850, NULL, 'G3DSA:3.40.50.720:FF:001325', NULL, NULL, 'Aspergillus niger contig An11c0010, genomic contig', NULL, NULL, NULL, NULL, NULL, 4),
(92851, NULL, 'G3DSA:1.20.120.730:FF:000029', NULL, NULL, 'SD04292p', NULL, NULL, NULL, NULL, NULL, 4),
(92852, NULL, 'G3DSA:2.170.270.10:FF:000011', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(92853, NULL, 'G3DSA:3.40.50.12160:FF:000023', NULL, NULL, 'Protein CBG15101', NULL, NULL, NULL, NULL, NULL, 4),
(92854, NULL, 'G3DSA:2.130.10.10:FF:005645', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92855, NULL, 'G3DSA:2.40.10.10:FF:000540', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92856, NULL, 'G3DSA:1.10.10.10:FF:000027', NULL, NULL, 'Heat shock transcription factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(92857, NULL, 'G3DSA:3.40.50.300:FF:006320', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(92858, NULL, 'G3DSA:3.20.20.10:FF:000039', NULL, NULL, 'Ornithine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(92859, NULL, 'G3DSA:2.30.30.1020:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92860, NULL, 'G3DSA:1.10.8.270:FF:000131', NULL, NULL, 'Rab-GAP domain-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(92861, NULL, 'G3DSA:3.30.160.60:FF:005549', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92862, NULL, 'G3DSA:3.10.105.10:FF:000061', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(92863, NULL, 'G3DSA:3.30.160.60:FF:001896', NULL, NULL, 'insulinoma-associated protein 1b', NULL, NULL, NULL, NULL, NULL, 4),
(92864, NULL, 'G3DSA:3.30.200.20:FF:002450', NULL, NULL, 'Leucine-rich repeat family protein /protein kinase family protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(92865, NULL, 'G3DSA:1.20.5.110:FF:000199', NULL, NULL, 'Syntaxin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(92866, NULL, 'G3DSA:1.10.418.10:FF:000222', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92867, NULL, 'G3DSA:1.10.472.10:FF:000605', NULL, NULL, 'Cyclin A2', NULL, NULL, NULL, NULL, NULL, 4),
(92868, NULL, 'G3DSA:2.30.30.1160:FF:000003', NULL, NULL, 'Antiviral helicase SKI2', NULL, NULL, NULL, NULL, NULL, 4),
(92869, NULL, 'G3DSA:3.80.10.10:FF:001216', NULL, NULL, 'Uncharacterized F-box/LRR-repeat protein C02F5.7', NULL, NULL, NULL, NULL, NULL, 4),
(92870, NULL, 'G3DSA:2.130.10.130:FF:000021', NULL, NULL, 'Integrin alpha ina-1', NULL, NULL, NULL, NULL, NULL, 4),
(92871, NULL, 'G3DSA:3.40.50.720:FF:001382', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(92872, NULL, 'G3DSA:2.60.40.150:FF:000230', NULL, NULL, 'Tcb1p', NULL, NULL, NULL, NULL, NULL, 4),
(92873, NULL, 'G3DSA:3.40.190.10:FF:000161', NULL, NULL, 'Serotransferrin', NULL, NULL, NULL, NULL, NULL, 4),
(92874, NULL, 'G3DSA:3.40.50.2300:FF:001484', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92875, NULL, 'G3DSA:2.10.50.10:FF:000078', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 3', NULL, NULL, NULL, NULL, NULL, 4),
(92876, NULL, 'G3DSA:1.25.10.10:FF:000319', NULL, NULL, 'Condensin-2 complex subunit D3', NULL, NULL, NULL, NULL, NULL, 4),
(92877, NULL, 'G3DSA:1.10.10.10:FF:000701', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(92878, NULL, 'G3DSA:2.60.40.1080:FF:000017', NULL, NULL, 'Major capsid protein', NULL, NULL, NULL, NULL, NULL, 4),
(92879, NULL, 'G3DSA:3.60.15.10:FF:000121', NULL, NULL, 'Cleavage and polyadenylation specificity factor, 73 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(92880, NULL, 'G3DSA:3.30.200.20:FF:001556', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92881, NULL, 'G3DSA:3.30.160.60:FF:004189', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92882, NULL, 'G3DSA:3.30.160.60:FF:004245', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92883, NULL, 'G3DSA:1.10.472.80:FF:000188', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92884, NULL, 'G3DSA:1.10.472.10:FF:000044', NULL, NULL, 'cyclin-H isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(92885, NULL, 'G3DSA:3.40.720.10:FF:000360', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92886, NULL, 'G3DSA:3.30.70.330:FF:000113', NULL, NULL, 'RNA-binding protein 26 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(92887, NULL, 'G3DSA:1.10.472.10:FF:000100', NULL, NULL, 'Cyclin-SDS', NULL, NULL, NULL, NULL, NULL, 4),
(92888, NULL, 'G3DSA:3.40.50.300:FF:004246', NULL, NULL, 'Translation elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(92889, NULL, 'G3DSA:1.20.1690.10:FF:000007', NULL, NULL, 'V-type proton ATPase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(92890, NULL, 'G3DSA:3.40.1350.10:FF:000038', NULL, NULL, 'tRNA-splicing endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(92891, NULL, 'G3DSA:1.10.287.70:FF:000468', NULL, NULL, 'Potassium two pore domain channel subfamily K member 4', NULL, NULL, NULL, NULL, NULL, 4),
(92892, NULL, 'G3DSA:1.10.30.50:FF:000012', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(92893, NULL, 'G3DSA:3.30.200.20:FF:002012', NULL, NULL, 'Serine/threonine-protein kinase haspin homolog hrk1', NULL, NULL, NULL, NULL, NULL, 4),
(92894, NULL, 'G3DSA:3.40.50.10190:FF:000179', NULL, NULL, 'NLI interacting factor-like phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(92895, NULL, 'G3DSA:1.10.1420.10:FF:000204', NULL, NULL, 'Os07g0486000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(92896, NULL, 'G3DSA:3.40.50.2300:FF:001607', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92897, NULL, 'G3DSA:3.40.50.2300:FF:000989', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92898, NULL, 'G3DSA:3.30.56.30:FF:000015', NULL, NULL, 'Signal recognition particle 19 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(92899, NULL, 'G3DSA:3.40.50.300:FF:005825', NULL, NULL, 'Cell division control protein', NULL, NULL, NULL, NULL, NULL, 4),
(92900, NULL, 'G3DSA:1.20.1250.20:FF:001832', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92901, NULL, 'G3DSA:1.20.5.340:FF:000032', NULL, NULL, 'Tropomyosin alpha-1 chain', NULL, NULL, NULL, NULL, NULL, 4),
(92902, NULL, 'G3DSA:1.10.100.10:FF:000001', NULL, NULL, 'insulin-like growth factor I isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(92903, NULL, 'G3DSA:2.40.440.10:FF:000027', NULL, NULL, 'ErfK/YbiS/YcfS/YnhG', NULL, NULL, NULL, NULL, NULL, 4),
(92904, NULL, 'G3DSA:1.25.40.10:FF:002620', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92905, NULL, 'G3DSA:2.60.40.10:FF:004650', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92906, NULL, 'G3DSA:3.40.50.300:FF:008175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92907, NULL, 'G3DSA:3.40.50.150:FF:000345', NULL, NULL, 'S-adenosylmethionine-dependent methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(92908, NULL, 'G3DSA:1.10.510.10:FF:000318', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(92909, NULL, 'G3DSA:3.30.565.10:FF:000337', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(92910, NULL, 'G3DSA:1.10.510.10:FF:001954', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92911, NULL, 'G3DSA:3.40.640.10:FF:000302', NULL, NULL, 'Uncharacterized aminotransferase C27F1.05c', NULL, NULL, NULL, NULL, NULL, 4),
(92912, NULL, 'G3DSA:2.10.220.10:FF:000181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92913, NULL, 'G3DSA:2.60.40.10:FF:000608', NULL, NULL, 'obscurin-like protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(92914, NULL, 'G3DSA:2.60.40.10:FF:000322', NULL, NULL, 'Muscle, skeletal receptor tyrosine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(92915, NULL, 'G3DSA:1.10.275.10:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92916, NULL, 'G3DSA:3.30.160.60:FF:006224', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92917, NULL, 'G3DSA:4.10.70.10:FF:000001', NULL, NULL, 'Disintegrin and metalloproteinase domain-containing protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(92918, NULL, 'G3DSA:3.40.50.1360:FF:000038', NULL, NULL, 'Ribose 5-phosphate isomerase A, variant', NULL, NULL, NULL, NULL, NULL, 4),
(92919, NULL, 'G3DSA:1.10.287.1130:FF:000001', NULL, NULL, 'cytochrome c oxidase copper chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(92920, NULL, 'G3DSA:3.30.160.60:FF:003969', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92921, NULL, 'G3DSA:3.30.70.20:FF:000112', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92922, NULL, 'G3DSA:2.10.25.10:FF:001733', NULL, NULL, 'Adhesion G protein-coupled receptor L4', NULL, NULL, NULL, NULL, NULL, 4),
(92923, NULL, 'G3DSA:3.40.50.720:FF:000488', NULL, NULL, 'N5-(Carboxyethyl)ornithine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(92924, NULL, 'G3DSA:1.10.150.110:FF:000009', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(92925, NULL, 'G3DSA:3.90.175.10:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92926, NULL, 'G3DSA:3.40.50.300:FF:008517', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92927, NULL, 'G3DSA:3.90.550.10:FF:000571', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(92928, NULL, 'G3DSA:3.40.190.10:FF:000048', NULL, NULL, 'sn-glycerol-3-phosphate-binding periplasmic protein ugpB', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(92929, NULL, 'G3DSA:2.120.10.80:FF:000023', NULL, NULL, 'Kelch-like family member 24', NULL, NULL, NULL, NULL, NULL, 4),
(92930, NULL, 'G3DSA:3.40.1190.20:FF:000096', NULL, NULL, 'Phosphomethylpyrimidine kinase (ThiD-2)', NULL, NULL, NULL, NULL, NULL, 4),
(92931, NULL, 'G3DSA:3.30.40.10:FF:001299', NULL, NULL, 'YALI0F02981p', NULL, NULL, NULL, NULL, NULL, 4),
(92932, NULL, 'G3DSA:3.30.200.20:FF:001736', NULL, NULL, 'Calcium-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(92933, NULL, 'G3DSA:3.30.1240.10:FF:000049', NULL, NULL, 'Cof-type HAD-IIB family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(92934, NULL, 'G3DSA:3.90.1150.10:FF:000011', NULL, NULL, 'Pyridoxal phosphate-dependent aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(92935, NULL, 'G3DSA:3.90.230.10:FF:000024', NULL, NULL, 'Probable metalloprotease ARX1', NULL, NULL, NULL, NULL, NULL, 4),
(92936, NULL, 'G3DSA:3.40.50.1820:FF:001772', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(92937, NULL, 'G3DSA:3.30.1490.40:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92938, NULL, 'G3DSA:2.60.120.330:FF:000169', NULL, NULL, '2-oxoglutarate (2OG) and Fe(II)-dependent oxygenase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(92939, NULL, 'G3DSA:1.10.8.60:FF:000092', NULL, NULL, 'IQ motif containing with AAA domain 1 like', NULL, NULL, NULL, NULL, NULL, 4),
(92940, NULL, 'G3DSA:3.90.550.10:FF:000514', NULL, NULL, 'Alpha-1,3-rhamnosyltransferase WapR', NULL, NULL, NULL, NULL, NULL, 4),
(92941, NULL, 'G3DSA:3.30.1120.120:FF:000004', NULL, NULL, 'serine/threonine-protein kinase PLK4-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(92942, NULL, 'G3DSA:1.10.150.50:FF:000168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92943, NULL, 'G3DSA:2.130.10.10:FF:004066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92944, NULL, 'G3DSA:1.10.1070.11:FF:000043', NULL, NULL, 'Serine/threonine-protein kinase Tel1', NULL, NULL, NULL, NULL, NULL, 4),
(92945, NULL, 'G3DSA:2.120.10.80:FF:000080', NULL, NULL, 'Actin-binding protein IPP', NULL, NULL, NULL, NULL, NULL, 4),
(92946, NULL, 'G3DSA:2.20.28.10:FF:000054', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(92947, NULL, 'G3DSA:2.40.33.10:FF:000014', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(92948, NULL, 'G3DSA:1.10.555.10:FF:000248', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92949, NULL, 'G3DSA:2.10.25.10:FF:001115', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(92950, NULL, 'G3DSA:3.40.50.150:FF:000620', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92951, NULL, 'G3DSA:1.10.418.10:FF:000042', NULL, NULL, 'Fimbrin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(92952, NULL, 'G3DSA:3.40.50.200:FF:000096', NULL, NULL, 'Serine protease, subtilase family', NULL, NULL, NULL, NULL, NULL, 4),
(92953, NULL, 'G3DSA:1.10.8.270:FF:000018', NULL, NULL, 'Ypt/Rab-GAP domain of gyp1p superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(92954, NULL, 'G3DSA:3.40.190.10:FF:000380', NULL, NULL, 'Molybdate ABC transporter, periplasmic molybdate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(92955, NULL, 'G3DSA:1.25.10.10:FF:001955', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92956, NULL, 'G3DSA:3.40.50.720:FF:001505', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92957, NULL, 'G3DSA:1.25.10.10:FF:002231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92958, NULL, 'G3DSA:1.10.10.60:FF:000345', NULL, NULL, 'Homeobox protein engrailed-like', NULL, NULL, NULL, NULL, NULL, 4),
(92959, NULL, 'G3DSA:3.30.830.10:FF:000235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92960, NULL, 'G3DSA:3.30.160.60:FF:005881', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92961, NULL, 'G3DSA:3.90.600.10:FF:000002', NULL, NULL, 'Trifunctional purine biosynthetic protein adenosine-3', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(92962, NULL, 'G3DSA:1.20.140.50:FF:000002', NULL, NULL, 'tyrosine-protein phosphatase non-receptor type 23 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(92963, NULL, 'G3DSA:3.40.50.720:FF:000887', NULL, NULL, 'Mannosyl-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(92964, NULL, 'G3DSA:3.80.10.10:FF:002852', NULL, NULL, 'Si:ch211-191d15.2', NULL, NULL, NULL, NULL, NULL, 4),
(92965, NULL, 'G3DSA:3.50.7.10:FF:000008', NULL, NULL, 'T-complex protein 1 subunit theta', NULL, NULL, NULL, NULL, NULL, 4),
(92966, NULL, 'G3DSA:3.70.10.10:FF:000008', NULL, NULL, 'Cell cycle checkpoint control protein', NULL, NULL, NULL, NULL, NULL, 4),
(92967, NULL, 'G3DSA:3.40.1110.10:FF:000442', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92968, NULL, 'G3DSA:2.40.40.20:FF:000039', NULL, NULL, 'Vesicle-fusing ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(92969, NULL, 'G3DSA:3.40.50.300:FF:006101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92970, NULL, 'G3DSA:2.80.10.50:FF:000202', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(92971, NULL, 'G3DSA:1.10.287.110:FF:000385', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92972, NULL, 'G3DSA:3.80.10.10:FF:001093', NULL, NULL, 'NACHT, LRR and PYD domains-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(92973, NULL, 'G3DSA:2.60.40.3510:FF:000027', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(92974, NULL, 'G3DSA:3.40.190.290:FF:000040', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(92975, NULL, 'G3DSA:2.60.40.60:FF:000584', NULL, NULL, 'FAT atypical cadherin 1b', NULL, NULL, NULL, NULL, NULL, 4),
(92976, NULL, 'G3DSA:1.20.890.10:FF:000030', NULL, NULL, 'DPY30 domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(92977, NULL, 'G3DSA:3.40.50.300:FF:001031', NULL, NULL, 'Iron ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(92978, NULL, 'G3DSA:3.90.550.10:FF:000239', NULL, NULL, 'Possible transferase (Possibly glycosyltransferase)', NULL, NULL, NULL, NULL, NULL, 4),
(92979, NULL, 'G3DSA:2.10.25.10:FF:001172', NULL, NULL, 'uromodulin', NULL, NULL, NULL, NULL, NULL, 4),
(92980, NULL, 'G3DSA:3.20.110.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92981, NULL, 'G3DSA:1.10.287.1490:FF:000018', NULL, NULL, 'cytospin-A isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(92982, NULL, 'G3DSA:3.30.450.60:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(92983, NULL, 'G3DSA:2.60.40.150:FF:000011', NULL, NULL, 'Synaptotagmin 6', NULL, NULL, NULL, NULL, NULL, 4),
(92984, NULL, 'G3DSA:2.130.10.10:FF:004009', NULL, NULL, 'Protein CBG07981', NULL, NULL, NULL, NULL, NULL, 4),
(92985, NULL, 'G3DSA:1.10.510.10:FF:002230', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92986, NULL, 'G3DSA:3.40.50.1240:FF:000058', NULL, NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(92987, NULL, 'G3DSA:1.20.1250.20:FF:001091', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(92988, NULL, 'G3DSA:2.40.100.10:FF:000142', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(92989, NULL, 'G3DSA:1.10.246.130:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92990, NULL, 'G3DSA:3.30.1360.70:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92991, NULL, 'G3DSA:3.40.50.261:FF:000036', NULL, NULL, 'Succinate--CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(92992, NULL, 'G3DSA:1.10.20.10:FF:000224', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92993, NULL, 'G3DSA:1.10.3080.10:FF:000048', NULL, NULL, 'Chloride channel protein-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(92994, NULL, 'G3DSA:1.10.510.10:FF:000532', NULL, NULL, 'VRK serine/threonine kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(92995, NULL, 'G3DSA:3.40.50.1000:FF:000705', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(92996, NULL, 'G3DSA:2.30.30.40:FF:000242', NULL, NULL, 'Actin binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(92997, NULL, 'G3DSA:1.20.810.10:FF:000036', NULL, NULL, 'COB-i1 protein, alternatively spliced', NULL, NULL, NULL, NULL, NULL, 4),
(92998, NULL, 'G3DSA:3.30.70.330:FF:002035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(92999, NULL, 'G3DSA:1.10.287.70:FF:000676', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93000, NULL, 'G3DSA:1.25.40.10:FF:001378', NULL, NULL, 'Pre-mRNA-splicing factor SYF1', NULL, NULL, NULL, NULL, NULL, 4),
(93001, NULL, 'G3DSA:3.30.70.890:FF:000056', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(93002, NULL, 'G3DSA:3.40.47.10:FF:000072', NULL, NULL, 'Thiolase', NULL, NULL, NULL, NULL, NULL, 4),
(93003, NULL, 'G3DSA:3.20.20.60:FF:000026', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(93004, NULL, 'G3DSA:1.10.540.10:FF:000034', NULL, NULL, 'Acyl-[acyl-carrier-protein] dehydrogenase MbtN', NULL, NULL, NULL, NULL, NULL, 4),
(93005, NULL, 'G3DSA:3.80.10.10:FF:003330', NULL, NULL, 'leucine-rich repeat transmembrane neuronal protein 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(93006, NULL, 'G3DSA:3.30.2170.10:FF:000009', NULL, NULL, 'Endonuclease V, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93007, NULL, 'G3DSA:2.130.10.10:FF:006005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93008, NULL, 'G3DSA:3.30.160.60:FF:004341', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93009, NULL, 'G3DSA:3.30.160.60:FF:002087', NULL, NULL, 'Zinc finger protein 619', NULL, NULL, NULL, NULL, NULL, 4),
(93010, NULL, 'G3DSA:1.10.238.10:FF:000606', NULL, NULL, 'Calmodulin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93011, NULL, 'G3DSA:2.60.40.10:FF:005847', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93012, NULL, 'G3DSA:2.130.10.10:FF:005858', NULL, NULL, 'Ubiquitin-binding serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(93013, NULL, 'G3DSA:2.40.10.10:FF:000512', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93014, NULL, 'G3DSA:3.40.50.140:FF:000016', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(93015, NULL, 'G3DSA:1.25.40.20:FF:000279', NULL, NULL, 'Calmodulin-binding transcription activator 4', NULL, NULL, NULL, NULL, NULL, 4),
(93016, NULL, 'G3DSA:1.10.8.430:FF:000016', NULL, NULL, 'Apoptotic protease-activating factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93017, NULL, 'G3DSA:1.25.40.930:FF:000002', NULL, NULL, 'Checkpoint serine/threonine-protein kinase BUB1', NULL, NULL, NULL, NULL, NULL, 4),
(93018, NULL, 'G3DSA:3.80.10.10:FF:001076', NULL, NULL, 'Protein phosphatase PP1 regulatory subunit sds22', NULL, NULL, NULL, NULL, NULL, 4),
(93019, NULL, 'G3DSA:1.10.8.270:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93020, NULL, 'G3DSA:3.30.70.580:FF:000070', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(93021, NULL, 'G3DSA:3.40.50.150:FF:000019', NULL, NULL, 'tRNA (adenine(58)-N(1))-methyltransferase TrmI', NULL, NULL, NULL, NULL, NULL, 4),
(93022, NULL, 'G3DSA:1.10.10.10:FF:000252', NULL, NULL, 'Exu regulon transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(93023, NULL, 'G3DSA:2.40.100.10:FF:000024', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(93024, NULL, 'G3DSA:3.30.70.330:FF:001529', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(93025, NULL, 'G3DSA:3.40.1090.10:FF:000012', NULL, NULL, 'calcium-independent phospholipase A2-gamma isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(93026, NULL, 'G3DSA:1.10.10.60:FF:000160', NULL, NULL, 'MYB-like transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(93027, NULL, 'G3DSA:3.90.550.10:FF:000251', NULL, NULL, 'Beta-1,3-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(93028, NULL, 'G3DSA:3.30.70.330:FF:003137', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93029, NULL, 'G3DSA:3.10.20.350:FF:000001', NULL, NULL, 'Orf1a polyprotein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(93030, NULL, 'G3DSA:2.60.40.1120:FF:000052', NULL, NULL, 'Carboxypeptidase M', NULL, NULL, NULL, NULL, NULL, 4),
(93031, NULL, 'G3DSA:3.90.1170.20:FF:000010', NULL, NULL, 'ModD protein', NULL, NULL, NULL, NULL, NULL, 4),
(93032, NULL, 'G3DSA:2.60.40.10:FF:000530', NULL, NULL, 'V-set and transmembrane domain containing 2A', NULL, NULL, NULL, NULL, NULL, 4),
(93033, NULL, 'G3DSA:3.50.4.10:FF:000002', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(93034, NULL, 'G3DSA:3.90.1600.10:FF:000052', NULL, NULL, 'DNA polymerase epsilon, catalytic subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(93035, NULL, 'G3DSA:3.40.1500.10:FF:000011', NULL, NULL, 'Coproporphyrinogen III oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(93036, NULL, 'G3DSA:2.60.40.60:FF:001101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93037, NULL, 'G3DSA:2.40.40.10:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93038, NULL, 'G3DSA:3.40.50.300:FF:006191', NULL, NULL, 'ABC transporter ATP-binding protein uup-2', NULL, NULL, NULL, NULL, NULL, 4),
(93039, NULL, 'G3DSA:3.30.200.20:FF:001770', NULL, NULL, 'High affinity nerve growth factor receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93040, NULL, 'G3DSA:3.90.1170.30:FF:000013', NULL, NULL, 'Pyrimidine-nucleoside phosphorylase (PYNP)', NULL, NULL, NULL, NULL, NULL, 4),
(93041, NULL, 'G3DSA:2.130.10.10:FF:002632', NULL, NULL, 'Protein FAM234A', NULL, NULL, NULL, NULL, NULL, 4),
(93042, NULL, 'G3DSA:4.10.1240.50:FF:000003', NULL, NULL, 'Arginine-glutamic acid dipeptide (RE) repeats a', NULL, NULL, NULL, NULL, NULL, 4),
(93043, NULL, 'G3DSA:1.20.870.10:FF:000045', NULL, NULL, 'Ras guanine nucleotide exchange factor Q', NULL, NULL, NULL, NULL, NULL, 4),
(93044, NULL, 'G3DSA:3.10.20.360:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93045, NULL, 'G3DSA:3.40.50.300:FF:004257', NULL, NULL, 'SNF2 family N-terminal domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(93046, NULL, 'G3DSA:2.120.10.30:FF:000216', NULL, NULL, 'low-density lipoprotein receptor-related protein 6 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(93047, NULL, 'G3DSA:2.60.40.10:FF:006027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93048, NULL, 'G3DSA:2.40.270.10:FF:000019', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(93049, NULL, 'G3DSA:3.90.730.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93050, NULL, 'G3DSA:1.10.530.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93051, NULL, 'G3DSA:2.60.120.330:FF:000147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93052, NULL, 'G3DSA:3.40.50.12550:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93053, NULL, 'G3DSA:3.90.550.10:FF:000621', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93054, NULL, 'G3DSA:1.25.40.10:FF:005077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93055, NULL, 'G3DSA:1.10.1750.10:FF:000004', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(93056, NULL, 'G3DSA:3.30.1640.10:FF:000017', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(93057, NULL, 'G3DSA:2.60.120.970:FF:000018', NULL, NULL, 'Decapentaplegic, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(93058, NULL, 'G3DSA:2.120.10.80:FF:000124', NULL, NULL, 'Kel1p', NULL, NULL, NULL, NULL, NULL, 4),
(93059, NULL, 'G3DSA:4.10.910.10:FF:000006', NULL, NULL, 'Similar to ribosomal protein S18', NULL, NULL, NULL, NULL, NULL, 4),
(93060, NULL, 'G3DSA:1.20.120.350:FF:000264', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93061, NULL, 'G3DSA:2.40.70.10:FF:000521', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93062, NULL, 'G3DSA:3.40.395.10:FF:000041', NULL, NULL, 'SUMO-specific peptidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(93063, NULL, 'G3DSA:3.30.160.60:FF:000642', NULL, NULL, 'Zinc finger with KRAB and SCAN domains 2', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(93064, NULL, 'G3DSA:3.40.50.300:FF:006202', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(93065, NULL, 'G3DSA:3.40.50.720:FF:001393', NULL, NULL, 'YALI0F31427p', NULL, NULL, NULL, NULL, NULL, 4),
(93066, NULL, 'G3DSA:3.10.110.10:FF:000084', NULL, NULL, 'WD repeat domain 59', NULL, NULL, NULL, NULL, NULL, 4),
(93067, NULL, 'G3DSA:3.40.1360.10:FF:000022', NULL, NULL, 'Topoisomerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93068, NULL, 'G3DSA:1.10.510.10:FF:004231', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93069, NULL, 'G3DSA:1.20.245.10:FF:000003', NULL, NULL, 'Arachidonate lipoxygenase 3', NULL, NULL, NULL, NULL, NULL, 4),
(93070, NULL, 'G3DSA:1.25.40.10:FF:003632', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93071, NULL, 'G3DSA:1.25.10.10:FF:001876', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93072, NULL, 'G3DSA:1.10.30.10:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93073, NULL, 'G3DSA:3.40.30.10:FF:000562', NULL, NULL, 'NADH dehydrogenase subunit E', NULL, NULL, NULL, NULL, NULL, 4),
(93074, NULL, 'G3DSA:3.30.890.10:FF:000020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93075, NULL, 'G3DSA:1.20.1250.20:FF:001523', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93076, NULL, 'G3DSA:1.20.1070.10:FF:001422', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93077, NULL, 'G3DSA:3.40.50.300:FF:008326', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93078, NULL, 'G3DSA:1.10.630.10:FF:000479', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93079, NULL, 'G3DSA:1.25.10.10:FF:002023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93080, NULL, 'G3DSA:3.30.565.10:FF:000023', NULL, NULL, 'PAS domain-containing sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(93081, NULL, 'G3DSA:3.20.20.80:FF:000667', NULL, NULL, 'AEL220Cp', NULL, NULL, NULL, NULL, NULL, 4),
(93082, NULL, 'G3DSA:3.40.800.20:FF:000054', NULL, NULL, 'Os11g0201400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(93083, NULL, 'G3DSA:3.10.400.10:FF:000005', NULL, NULL, 'Sulfate adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(93084, NULL, 'G3DSA:3.90.226.10:FF:000132', NULL, NULL, 'Crotonase', NULL, NULL, NULL, NULL, NULL, 4),
(93085, NULL, 'G3DSA:2.20.70.10:FF:000005', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(93086, NULL, 'G3DSA:3.40.50.1000:FF:000026', NULL, NULL, 'NT5DC3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(93087, NULL, 'G3DSA:2.60.120.1440:FF:000002', NULL, NULL, 'Probable transmembrane sensor', NULL, NULL, NULL, NULL, NULL, 4),
(93088, NULL, 'G3DSA:3.40.50.300:FF:001986', NULL, NULL, 'ATP-dependent DNA helicase PIF1', NULL, NULL, NULL, NULL, NULL, 4),
(93089, NULL, 'G3DSA:3.40.50.300:FF:005685', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93090, NULL, 'G3DSA:3.20.20.70:FF:000664', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93091, NULL, 'G3DSA:1.10.510.10:FF:000162', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(93092, NULL, 'G3DSA:3.30.200.20:FF:002124', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93093, NULL, 'G3DSA:1.10.418.20:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93094, NULL, 'G3DSA:3.30.420.40:FF:000213', NULL, NULL, 'Actin related protein T3', NULL, NULL, NULL, NULL, NULL, 4),
(93095, NULL, 'G3DSA:2.30.30.40:FF:000612', NULL, NULL, 'Dynamin binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(93096, NULL, 'G3DSA:3.40.50.150:FF:001789', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93097, NULL, 'G3DSA:3.40.50.1700:FF:000039', NULL, NULL, 'Glycoside hydrolase family 3 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(93098, NULL, 'G3DSA:3.30.1360.120:FF:000046', NULL, NULL, 'Pyruvate dehydrogenase phosphatase regulatory mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(93099, NULL, 'G3DSA:2.30.180.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93100, NULL, 'G3DSA:2.40.10.10:FF:000175', NULL, NULL, 'Serine protease grass', NULL, NULL, NULL, NULL, NULL, 4),
(93101, NULL, 'G3DSA:2.130.10.10:FF:004077', NULL, NULL, 'Protein CBG18869', NULL, NULL, NULL, NULL, NULL, 4),
(93102, NULL, 'G3DSA:1.10.220.160:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93103, NULL, 'G3DSA:3.10.180.10:FF:000032', NULL, NULL, 'Cadmium inducible protein CadI', NULL, NULL, NULL, NULL, NULL, 4),
(93104, NULL, 'G3DSA:1.10.287.2250:FF:000005', NULL, NULL, 'Cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(93105, NULL, 'G3DSA:3.90.640.90:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93106, NULL, 'G3DSA:3.30.160.60:FF:006139', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93107, NULL, 'G3DSA:3.40.50.1820:FF:001244', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93108, NULL, 'G3DSA:3.80.10.10:FF:000896', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(93109, NULL, 'G3DSA:3.40.920.10:FF:000009', NULL, NULL, 'Pyruvate synthase subunit PorD', NULL, NULL, NULL, NULL, NULL, 4),
(93110, NULL, 'G3DSA:3.30.530.20:FF:000209', NULL, NULL, 'WD40 repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(93111, NULL, 'G3DSA:3.40.50.2300:FF:000213', NULL, NULL, 'Grik, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(93112, NULL, 'G3DSA:1.10.1420.10:FF:000018', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(93113, NULL, 'G3DSA:2.40.30.10:FF:000412', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93114, NULL, 'G3DSA:1.25.10.10:FF:002702', NULL, NULL, 'Ppp2r5d protein', NULL, NULL, NULL, NULL, NULL, 4),
(93115, NULL, 'G3DSA:1.10.418.10:FF:000025', NULL, NULL, 'Plastin-3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(93116, NULL, 'G3DSA:2.130.10.10:FF:005179', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93117, NULL, 'G3DSA:3.40.50.1780:FF:000006', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', NULL, NULL, NULL, NULL, NULL, 4),
(93118, NULL, 'G3DSA:1.10.238.10:FF:000236', NULL, NULL, 'Protein S100', NULL, NULL, NULL, NULL, NULL, 4),
(93119, NULL, 'G3DSA:3.30.1390.20:FF:000012', NULL, NULL, '50S ribosomal protein L30', NULL, NULL, NULL, NULL, NULL, 4),
(93120, NULL, 'G3DSA:3.30.200.20:FF:001444', NULL, NULL, 'CDK14 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(93121, NULL, 'G3DSA:1.25.40.10:FF:002204', NULL, NULL, 'Anaphase-promoting complex subunit 5-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(93122, NULL, 'G3DSA:1.20.144.10:FF:000111', NULL, NULL, 'Phospholipid phosphatase 2', NULL, NULL, NULL, NULL, NULL, 4),
(93123, NULL, 'G3DSA:3.10.20.590:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93124, NULL, 'G3DSA:3.10.50.40:FF:000146', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(93125, NULL, 'G3DSA:1.20.58.220:FF:000006', NULL, NULL, 'Phosphate-specific transport system accessory protein PhoU', NULL, NULL, NULL, NULL, NULL, 4),
(93126, NULL, 'G3DSA:3.30.160.60:FF:002407', NULL, NULL, 'Zinc finger and SCAN domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(93127, NULL, 'G3DSA:3.70.10.10:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93128, NULL, 'G3DSA:3.30.360.10:FF:000053', NULL, NULL, 'Aspartate-semialdehyde dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93129, NULL, 'G3DSA:3.90.132.10:FF:000009', NULL, NULL, 'Cell surface protease gp63, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93130, NULL, 'G3DSA:2.60.40.10:FF:002328', NULL, NULL, 'Basal cell adhesion molecule', NULL, NULL, NULL, NULL, NULL, 4),
(93131, NULL, 'G3DSA:2.130.10.10:FF:005488', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93132, NULL, 'G3DSA:3.10.20.90:FF:000535', NULL, NULL, 'Ubiquitin, putative', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(93133, NULL, 'G3DSA:2.60.120.10:FF:000482', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93134, NULL, 'G3DSA:1.10.3210.10:FF:000065', NULL, NULL, 'RelA/SpoT family protein', NULL, NULL, NULL, NULL, NULL, 4),
(93135, NULL, 'G3DSA:3.40.140.10:FF:000034', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit F', NULL, NULL, NULL, NULL, NULL, 4),
(93136, NULL, 'G3DSA:3.40.50.1820:FF:001553', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93137, NULL, 'G3DSA:3.70.10.10:FF:000082', NULL, NULL, 'DNA repair protein Rad9, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93138, NULL, 'G3DSA:2.40.50.140:FF:000132', NULL, NULL, 'Aspartyl-tRNA synthetase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(93139, NULL, 'G3DSA:3.40.50.720:FF:001404', NULL, NULL, 'NAD-dependent epimerase/dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(93140, NULL, 'G3DSA:1.10.10.790:FF:000015', NULL, NULL, 'Splicing factor 3A subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(93141, NULL, 'G3DSA:1.10.10.10:FF:000622', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(93142, NULL, 'G3DSA:3.40.50.12160:FF:000017', NULL, NULL, 'Threonylcarbamoyladenosine tRNA methylthiotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(93143, NULL, 'G3DSA:3.40.630.30:FF:000566', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93144, NULL, 'G3DSA:4.10.900.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93145, NULL, 'G3DSA:3.40.50.300:FF:006511', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93146, NULL, 'G3DSA:3.30.200.20:FF:000342', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(93147, NULL, 'G3DSA:2.60.120.620:FF:000127', NULL, NULL, 'Putative prolyl 4-hydroxylase 3', NULL, NULL, NULL, NULL, NULL, 4),
(93148, NULL, 'G3DSA:1.10.1170.10:FF:000010', NULL, NULL, 'Baculoviral IAP repeat containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(93149, NULL, 'G3DSA:1.20.1280.50:FF:000258', NULL, NULL, 'F-box/WD repeat-containing protein A', NULL, NULL, NULL, NULL, NULL, 4),
(93150, NULL, 'G3DSA:1.25.40.20:FF:000616', NULL, NULL, 'Ankyrin repeats (3 copies)/Ankyrin repeats (Many copies)/Ankyrin repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93151, NULL, 'G3DSA:1.20.5.580:FF:000002', NULL, NULL, 'Complexin, isoform AB', NULL, NULL, NULL, NULL, NULL, 4),
(93152, NULL, 'G3DSA:3.20.20.70:FF:000338', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(93153, NULL, 'G3DSA:1.25.40.10:FF:000613', NULL, NULL, 'Coatomer subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(93154, NULL, 'G3DSA:1.10.287.40:FF:000015', NULL, NULL, 'Serine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(93155, NULL, 'G3DSA:3.30.505.10:FF:000047', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(93156, NULL, 'G3DSA:2.30.29.30:FF:001157', NULL, NULL, 'DEF6 guanine nucleotide exchange factor c', NULL, NULL, NULL, NULL, NULL, 4),
(93157, NULL, 'G3DSA:1.20.120.1760:FF:000031', NULL, NULL, 'Choline/ethanolaminephosphotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93158, NULL, 'G3DSA:3.40.50.300:FF:004920', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93159, NULL, 'G3DSA:3.30.70.1230:FF:000272', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(93160, NULL, 'G3DSA:1.10.60.10:FF:000007', NULL, NULL, 'Manganese transport regulator MntR', NULL, NULL, NULL, NULL, NULL, 4),
(93161, NULL, 'G3DSA:3.40.50.11770:FF:000001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93162, NULL, 'G3DSA:4.10.60.10:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93163, NULL, 'G3DSA:3.30.160.60:FF:005959', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93164, NULL, 'G3DSA:4.10.400.10:FF:000248', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(93165, NULL, 'G3DSA:1.20.58.2220:FF:000037', NULL, NULL, 'Formin 2', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(93166, NULL, 'G3DSA:2.10.220.10:FF:000186', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5a', NULL, NULL, NULL, NULL, NULL, 4),
(93167, NULL, 'G3DSA:2.40.20.10:FF:000114', NULL, NULL, 'Plasminogen activator, urokinase', NULL, NULL, NULL, NULL, NULL, 4),
(93168, NULL, 'G3DSA:3.40.720.10:FF:000337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93169, NULL, 'G3DSA:3.30.1490.20:FF:000076', NULL, NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(93170, NULL, 'G3DSA:2.130.10.10:FF:002306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93171, NULL, 'G3DSA:2.170.270.10:FF:000106', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(93172, NULL, 'G3DSA:3.30.160.60:FF:003498', NULL, NULL, 'zinc finger protein 613 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(93173, NULL, 'G3DSA:3.40.50.2300:FF:001624', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93174, NULL, 'G3DSA:3.40.120.10:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93175, NULL, 'G3DSA:1.20.58.530:FF:000009', NULL, NULL, 'unconventional myosin-IXb isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(93176, NULL, 'G3DSA:1.20.1530.20:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93177, NULL, 'G3DSA:3.40.50.80:FF:000100', NULL, NULL, 'Ferric reduction oxidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(93178, NULL, 'G3DSA:3.60.21.10:FF:000186', NULL, NULL, 'Calcineurin-like metallo-phosphoesterase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(93179, NULL, 'G3DSA:1.20.190.50:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93180, NULL, 'G3DSA:3.40.50.300:FF:005100', NULL, NULL, 'GPN-loop GTPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(93181, NULL, 'G3DSA:3.80.10.10:FF:001385', NULL, NULL, 'Blast:Chaoptin', NULL, NULL, NULL, NULL, NULL, 4),
(93182, NULL, 'G3DSA:3.40.50.1480:FF:000006', NULL, NULL, 'Adenosylhomocysteinase', NULL, NULL, NULL, NULL, NULL, 4),
(93183, NULL, 'G3DSA:3.20.20.70:FF:000029', NULL, NULL, 'L-lactate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(93184, NULL, 'G3DSA:3.30.310.130:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93185, NULL, 'G3DSA:3.30.365.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93186, NULL, 'G3DSA:1.20.1070.10:FF:000579', NULL, NULL, 'EGF-like module-containing mucin-like hormone receptor-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(93187, NULL, 'G3DSA:3.40.50.2300:FF:001315', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93188, NULL, 'G3DSA:3.30.70.870:FF:000050', NULL, NULL, 'Elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(93189, NULL, 'G3DSA:3.40.50.300:FF:002666', NULL, NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(93190, NULL, 'G3DSA:2.60.40.10:FF:004436', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93191, NULL, 'G3DSA:3.30.9.10:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93192, NULL, 'G3DSA:1.20.1070.10:FF:000011', NULL, NULL, 'Adhesion G protein-coupled receptor L2', NULL, NULL, NULL, NULL, NULL, 4),
(93193, NULL, 'G3DSA:1.10.287.950:FF:000013', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(93194, NULL, 'G3DSA:1.10.560.10:FF:000097', NULL, NULL, 'Chaperonin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93195, NULL, 'G3DSA:3.40.50.150:FF:000715', NULL, NULL, 'Site-specific DNA-methyltransferase (adenine-specific)', NULL, NULL, NULL, NULL, NULL, 4),
(93196, NULL, 'G3DSA:3.40.50.300:FF:004274', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93197, NULL, 'G3DSA:1.10.437.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93198, NULL, 'G3DSA:1.10.630.10:FF:000816', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(93199, NULL, 'G3DSA:1.25.40.20:FF:000751', NULL, NULL, 'Ankyrin repeat and SOCS box-containing 2b', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(93200, NULL, 'G3DSA:3.90.190.10:FF:000088', NULL, NULL, 'Receptor protein-tyrosine phosphatase LAR', NULL, NULL, NULL, NULL, NULL, 4),
(93201, NULL, 'G3DSA:3.40.50.300:FF:002150', NULL, NULL, 'Phosphoglycerate mutase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93202, NULL, 'G3DSA:3.30.160.60:FF:005976', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93203, NULL, 'G3DSA:3.20.100.10:FF:000002', NULL, NULL, 'mRNA capping nucleoside-triphosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93204, NULL, 'G3DSA:1.20.920.10:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93205, NULL, 'G3DSA:1.20.1110.10:FF:000049', NULL, NULL, 'Putative P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(93206, NULL, 'G3DSA:3.30.420.10:FF:000480', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93207, NULL, 'G3DSA:2.130.10.10:FF:004223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93208, NULL, 'G3DSA:3.90.730.10:FF:000040', NULL, NULL, 'Ribonuclease 2', NULL, NULL, NULL, NULL, NULL, 4),
(93209, NULL, 'G3DSA:3.40.50.2300:FF:001641', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93210, NULL, 'G3DSA:2.60.120.330:FF:000164', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93211, NULL, 'G3DSA:2.60.200.20:FF:000064', NULL, NULL, 'Putative ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(93212, NULL, 'G3DSA:2.30.29.30:FF:000977', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(93213, NULL, 'G3DSA:2.40.10.10:FF:000203', NULL, NULL, 'GD11897', NULL, NULL, NULL, NULL, NULL, 4),
(93214, NULL, 'G3DSA:1.20.1070.10:FF:001113', NULL, NULL, 'Alpha-1B adrenergic receptor', NULL, NULL, NULL, NULL, NULL, 4),
(93215, NULL, 'G3DSA:2.130.10.10:FF:001817', NULL, NULL, 'ER membrane protein complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(93216, NULL, 'G3DSA:1.10.287.940:FF:000010', NULL, NULL, 'P2X receptor E', NULL, NULL, NULL, NULL, NULL, 4),
(93217, NULL, 'G3DSA:1.20.58.920:FF:000003', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(93218, NULL, 'G3DSA:3.40.50.2300:FF:001287', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93219, NULL, 'G3DSA:3.30.420.110:FF:000065', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(93220, NULL, 'G3DSA:3.10.20.90:FF:000165', NULL, NULL, 'E3 ubiquitin-protein ligase UHRF2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(93221, NULL, 'G3DSA:1.20.1560.10:FF:000807', NULL, NULL, 'Putative multidrug resistance-associated protein lethal(2)03659-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(93222, NULL, 'G3DSA:2.10.25.10:FF:001413', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93223, NULL, 'G3DSA:1.20.1070.10:FF:001405', NULL, NULL, 'Histamine 4 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(93224, NULL, 'G3DSA:2.130.10.10:FF:003717', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93225, NULL, 'G3DSA:1.10.510.10:FF:001943', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93226, NULL, 'G3DSA:2.60.40.1180:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93227, NULL, 'G3DSA:3.10.20.740:FF:000011', NULL, NULL, '4Fe-4S ferredoxin, iron-sulphur binding, conserved site', NULL, NULL, NULL, NULL, NULL, 4),
(93228, NULL, 'G3DSA:2.60.40.60:FF:000612', NULL, NULL, 'Cadherin 26, tandem duplicate 1', NULL, NULL, NULL, NULL, NULL, 4),
(93229, NULL, 'G3DSA:1.10.287.110:FF:000071', NULL, NULL, 'Heat shock protein DNAJ homologue Pfj4', NULL, NULL, NULL, NULL, NULL, 4),
(93230, NULL, 'G3DSA:1.25.40.10:FF:002058', NULL, NULL, 'RING zinc finger-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(93231, NULL, 'G3DSA:2.60.40.10:FF:005538', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93232, NULL, 'G3DSA:3.40.50.300:FF:008309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93233, NULL, 'G3DSA:1.20.58.390:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(93234, NULL, 'G3DSA:1.25.10.10:FF:002040', NULL, NULL, 'Microtubule associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(93235, NULL, 'G3DSA:3.40.630.30:FF:000196', NULL, NULL, 'Potential polyamine N-acetyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(93236, NULL, 'G3DSA:1.10.472.80:FF:000183', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93237, NULL, 'G3DSA:3.30.230.120:FF:000002', NULL, NULL, 'Bifunctional fucokinase/fucose pyrophosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(93238, NULL, 'G3DSA:1.10.8.60:FF:000277', NULL, NULL, 'DNA polymerase epsilon subunit', NULL, NULL, NULL, NULL, NULL, 4),
(93239, NULL, 'G3DSA:1.20.1250.20:FF:000697', NULL, NULL, 'MFS drug efflux pump', NULL, NULL, NULL, NULL, NULL, 4),
(93240, NULL, 'G3DSA:1.10.15.30:FF:000004', NULL, NULL, 'Putative 60S ribosomal protein L7', NULL, NULL, NULL, NULL, NULL, 4),
(93241, NULL, 'G3DSA:1.10.390.10:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93242, NULL, 'G3DSA:1.10.1510.30:FF:000003', NULL, NULL, 'Probable tRNA pseudouridine synthase D', NULL, NULL, NULL, NULL, NULL, 4),
(93243, NULL, 'G3DSA:3.30.70.870:FF:000033', NULL, NULL, 'Elongation factor G-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(93244, NULL, 'G3DSA:3.30.160.60:FF:000951', NULL, NULL, 'Zinc finger protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(93245, NULL, 'G3DSA:3.40.50.300:FF:000351', NULL, NULL, 'Replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(93246, NULL, 'G3DSA:3.40.50.300:FF:005668', NULL, NULL, 'ATP-dependent protease ATPase subunit HslU', NULL, NULL, NULL, NULL, NULL, 4),
(93247, NULL, 'G3DSA:3.40.640.10:FF:000162', NULL, NULL, 'DegT/DnrJ/EryC1/StrS aminotransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(93248, NULL, 'G3DSA:1.20.1640.10:FF:000033', NULL, NULL, 'MMPL family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(93249, NULL, 'G3DSA:3.40.50.300:FF:001969', NULL, NULL, 'Putative magnesium chelatase', NULL, NULL, NULL, NULL, NULL, 4),
(93250, NULL, 'G3DSA:2.130.10.10:FF:000480', NULL, NULL, 'Transducin beta like 3', NULL, NULL, NULL, NULL, NULL, 4),
(93251, NULL, 'G3DSA:2.40.70.10:FF:000049', NULL, NULL, 'Aspartyl protease AED1', NULL, NULL, NULL, NULL, NULL, 4),
(93252, NULL, 'G3DSA:3.40.630.60:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93253, NULL, 'G3DSA:1.50.10.10:FF:000177', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(93254, NULL, 'G3DSA:3.90.70.10:FF:000910', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(93255, NULL, 'G3DSA:3.40.250.10:FF:000155', NULL, NULL, 'Rhodanese domain protein / beta-lactamase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(93256, NULL, 'G3DSA:1.10.12.40:FF:000001', NULL, NULL, 'L-seryl-tRNA(Sec) kinase', NULL, NULL, NULL, NULL, NULL, 4),
(93257, NULL, 'G3DSA:2.70.170.10:FF:000022', NULL, NULL, 'glutamate-gated chloride channel isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(93258, NULL, 'G3DSA:1.10.510.10:FF:000841', NULL, NULL, 'Fructosamine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(93259, NULL, 'G3DSA:3.40.50.300:FF:006409', NULL, NULL, 'Nucleotide binding protein like', NULL, NULL, NULL, NULL, NULL, 4),
(93260, NULL, 'G3DSA:3.30.70.890:FF:000039', NULL, NULL, 'Phosphomevalonate kinase protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93261, NULL, 'G3DSA:2.40.40.20:FF:000034', NULL, NULL, 'Probable oxidoreductase YoaE', NULL, NULL, NULL, NULL, NULL, 4),
(93262, NULL, 'G3DSA:3.30.1360.10:FF:000035', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(93263, NULL, 'G3DSA:3.40.50.300:FF:005994', NULL, NULL, 'DnaA regulatory inactivator Hda', NULL, NULL, NULL, NULL, NULL, 4),
(93264, NULL, 'G3DSA:3.30.310.10:FF:000016', NULL, NULL, 'Ribonuclease HIII', NULL, NULL, NULL, NULL, NULL, 4),
(93265, NULL, 'G3DSA:1.20.1050.10:FF:000111', NULL, NULL, 'Glutathione Stransferase EC 25118', NULL, NULL, NULL, NULL, NULL, 4),
(93266, NULL, 'G3DSA:1.10.533.10:FF:000085', NULL, NULL, 'Baculoviral IAP repeat containing 7', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(93267, NULL, 'G3DSA:3.30.450.150:FF:000010', NULL, NULL, 'Sll1307 protein', NULL, NULL, NULL, NULL, NULL, 4),
(93268, NULL, 'G3DSA:1.10.418.10:FF:000008', NULL, NULL, 'Filamin-B isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(93269, NULL, 'G3DSA:3.80.10.10:FF:001059', NULL, NULL, 'Leucine-rich repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(93270, NULL, 'G3DSA:2.30.30.140:FF:000333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93271, NULL, 'G3DSA:3.40.50.1820:FF:001570', NULL, NULL, 'Lipase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93272, NULL, 'G3DSA:3.90.260.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93273, NULL, 'G3DSA:2.60.120.10:FF:000835', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(93274, NULL, 'G3DSA:3.10.20.90:FF:000209', NULL, NULL, 'Plexin B3', NULL, NULL, NULL, NULL, NULL, 4),
(93275, NULL, 'G3DSA:3.30.160.60:FF:006123', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93276, NULL, 'G3DSA:1.10.100.10:FF:000012', NULL, NULL, 'Insulin-like growth factor II', NULL, NULL, NULL, NULL, NULL, 4),
(93277, NULL, 'G3DSA:2.10.220.10:FF:000006', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(93278, NULL, 'G3DSA:3.40.50.2000:FF:000213', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(93279, NULL, 'G3DSA:3.30.70.330:FF:000118', NULL, NULL, 'msx2-interacting protein-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(93280, NULL, 'G3DSA:2.80.10.50:FF:000264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93281, NULL, 'G3DSA:3.40.50.300:FF:003768', NULL, NULL, 'Peroxisomal biogenesis factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(93282, NULL, 'G3DSA:4.10.170.10:FF:000005', NULL, NULL, 'Cellular tumor antigen p53', NULL, NULL, NULL, NULL, NULL, 4),
(93283, NULL, 'G3DSA:1.20.58.60:FF:000769', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93284, NULL, 'G3DSA:3.30.70.330:FF:001546', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93285, NULL, 'G3DSA:1.20.1110.10:FF:000184', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93286, NULL, 'G3DSA:2.10.70.10:FF:000085', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(93287, NULL, 'G3DSA:3.40.30.10:FF:000932', NULL, NULL, 'Thioredoxin domain-containing protein C13F5.05, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(93288, NULL, 'G3DSA:3.40.50.300:FF:006174', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(93289, NULL, 'G3DSA:3.30.1330.20:FF:000020', NULL, NULL, 'Tubulin gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(93290, NULL, 'G3DSA:1.25.40.20:FF:000263', NULL, NULL, 'Forked, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(93291, NULL, 'G3DSA:1.10.510.10:FF:002286', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93292, NULL, 'G3DSA:3.80.10.10:FF:003184', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93293, NULL, 'G3DSA:1.10.510.10:FF:001488', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93294, NULL, 'G3DSA:3.40.50.1240:FF:000002', NULL, NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(93295, NULL, 'G3DSA:1.20.1600.10:FF:000042', NULL, NULL, 'Channel protein TolC', NULL, NULL, NULL, NULL, NULL, 4),
(93296, NULL, 'G3DSA:2.130.10.30:FF:000177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93297, NULL, 'G3DSA:1.10.630.10:FF:000788', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93298, NULL, 'G3DSA:4.10.640.10:FF:000013', NULL, NULL, '37S ribosomal protein S18', NULL, NULL, NULL, NULL, NULL, 4),
(93299, NULL, 'G3DSA:1.20.58.340:FF:000059', NULL, NULL, 'Putative metal ion transporter YfjQ protein', NULL, NULL, NULL, NULL, NULL, 4),
(93300, NULL, 'G3DSA:1.25.10.10:FF:000095', NULL, NULL, 'Vacuolar protein 8', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(93301, NULL, 'G3DSA:1.10.472.10:FF:000504', NULL, NULL, 'G1/S-specific cyclin-D', NULL, NULL, NULL, NULL, NULL, 4),
(93302, NULL, 'G3DSA:3.90.70.10:FF:000601', NULL, NULL, 'LD22095p', NULL, NULL, NULL, NULL, NULL, 4),
(93303, NULL, 'G3DSA:3.30.830.10:FF:000044', NULL, NULL, 'Mitochondrial-processing peptidase subunit beta, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93304, NULL, 'G3DSA:1.10.510.10:FF:000206', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(93305, NULL, 'G3DSA:1.10.472.130:FF:000010', NULL, NULL, 'Dynein axonemal heavy chain 10', NULL, NULL, NULL, NULL, NULL, 4),
(93306, NULL, 'G3DSA:3.30.160.60:FF:000507', NULL, NULL, 'ras-responsive element-binding protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(93307, NULL, 'G3DSA:3.30.479.30:FF:000002', NULL, NULL, 'band 7 protein AGAP004871', NULL, NULL, NULL, NULL, NULL, 4),
(93308, NULL, 'G3DSA:2.60.120.920:FF:000099', NULL, NULL, 'Tripartite motif family-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(93309, NULL, 'G3DSA:3.30.70.2970:FF:000001', NULL, NULL, 'Oxidative stress defense protein', NULL, NULL, NULL, NULL, NULL, 4),
(93310, NULL, 'G3DSA:3.30.1490.20:FF:000059', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(93311, NULL, 'G3DSA:3.40.140.10:FF:000017', NULL, NULL, 'COP9 signalosome complex subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(93312, NULL, 'G3DSA:3.30.110.110:FF:000001', NULL, NULL, 'Double-strand break repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(93313, NULL, 'G3DSA:2.70.150.10:FF:000037', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(93314, NULL, 'G3DSA:3.40.532.10:FF:000023', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(93315, NULL, 'G3DSA:1.25.40.1010:FF:000012', NULL, NULL, 'NMDA receptor-regulated protein 1-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(93316, NULL, 'G3DSA:3.40.50.1240:FF:000182', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93317, NULL, 'G3DSA:2.10.110.10:FF:000211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93318, NULL, 'G3DSA:3.40.1190.20:FF:000197', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93319, NULL, 'G3DSA:3.20.20.370:FF:000016', NULL, NULL, 'Chitin oligosaccharide deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(93320, NULL, 'G3DSA:2.60.120.10:FF:000347', NULL, NULL, 'Cyclic nucleotide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(93321, NULL, 'G3DSA:1.25.40.630:FF:000002', NULL, NULL, 'Cleavage stimulating factor 64', NULL, NULL, NULL, NULL, NULL, 4),
(93322, NULL, 'G3DSA:3.10.10.10:FF:000011', NULL, NULL, 'Transposon Tf2-2 polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(93323, NULL, 'G3DSA:3.90.470.20:FF:000005', NULL, NULL, 'Fatty acid synthase alpha subunit FasA', NULL, NULL, NULL, NULL, NULL, 4),
(93324, NULL, 'G3DSA:1.10.238.110:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93325, NULL, 'G3DSA:2.60.40.10:FF:000384', NULL, NULL, 'CD166 antigen isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(93326, NULL, 'G3DSA:2.70.170.10:FF:000229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93327, NULL, 'G3DSA:2.80.10.50:FF:000281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93328, NULL, 'G3DSA:2.130.10.10:FF:000171', NULL, NULL, 'denticleless protein homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(93329, NULL, 'G3DSA:1.10.1200.30:FF:000002', NULL, NULL, 'Gag polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(93330, NULL, 'G3DSA:3.40.50.1980:FF:000050', NULL, NULL, 'Histidine biosynthesis trifunctional protein', NULL, NULL, NULL, NULL, NULL, 4),
(93331, NULL, 'G3DSA:3.80.10.10:FF:000002', NULL, NULL, 'Slit guidance ligand 2', NULL, NULL, NULL, NULL, NULL, 4),
(93332, NULL, 'G3DSA:1.20.5.1430:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93333, NULL, 'G3DSA:1.10.510.10:FF:001797', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(93334, NULL, 'G3DSA:3.30.1380.20:FF:000040', NULL, NULL, 'Trafficking protein particle complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(93335, NULL, 'G3DSA:3.40.50.300:FF:002812', NULL, NULL, 'Long-chain fatty acid transporter subunit', NULL, NULL, NULL, NULL, NULL, 4),
(93336, NULL, 'G3DSA:1.10.3090.10:FF:000004', NULL, NULL, 'CCA tRNA nucleotidyltransferase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(93337, NULL, 'G3DSA:1.25.40.10:FF:000260', NULL, NULL, 'tetratricopeptide repeat protein 28 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(93338, NULL, 'G3DSA:3.40.30.10:FF:000915', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93339, NULL, 'G3DSA:1.10.1410.10:FF:000046', NULL, NULL, 'Terminal uridylyltransferase 4', NULL, NULL, NULL, NULL, NULL, 4),
(93340, NULL, 'G3DSA:1.20.1270.60:FF:000098', NULL, NULL, 'FCH and double SH3 domains protein 2 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(93341, NULL, 'G3DSA:3.80.10.10:FF:003004', NULL, NULL, 'AGAP010289-PA', NULL, NULL, NULL, NULL, NULL, 4),
(93342, NULL, 'G3DSA:2.130.10.10:FF:001789', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(93343, NULL, 'G3DSA:3.40.50.1000:FF:000043', NULL, NULL, 'General stress response phosphoprotein phosphatase Psr1/2', NULL, NULL, NULL, NULL, NULL, 4),
(93344, NULL, 'G3DSA:1.25.40.1030:FF:000018', NULL, NULL, 'Protein transport protein sec16', NULL, NULL, NULL, NULL, NULL, 4),
(93345, NULL, 'G3DSA:3.20.20.190:FF:000069', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(93346, NULL, 'G3DSA:2.30.30.210:FF:000011', NULL, NULL, 'Ribonuclease P protein subunit p29', NULL, NULL, NULL, NULL, NULL, 4),
(93347, NULL, 'G3DSA:2.60.40.10:FF:001795', NULL, NULL, 'ephrin type-B receptor 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(93348, NULL, 'G3DSA:2.60.200.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93349, NULL, 'G3DSA:1.20.1250.20:FF:001186', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(93350, NULL, 'G3DSA:1.10.510.10:FF:000515', NULL, NULL, 'serine/threonine-protein kinase SBK2', NULL, NULL, NULL, NULL, NULL, 4),
(93351, NULL, 'G3DSA:1.10.510.10:FF:004129', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93352, NULL, 'G3DSA:2.30.180.10:FF:000054', NULL, NULL, 'Transforming growth factor-beta-induced protein', NULL, NULL, NULL, NULL, NULL, 4),
(93353, NULL, 'G3DSA:3.80.10.10:FF:001413', NULL, NULL, 'leucine-rich repeat-containing protein C10orf11 homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(93354, NULL, 'G3DSA:3.30.230.130:FF:000005', NULL, NULL, 'Cullin-1 like', NULL, NULL, NULL, NULL, NULL, 4),
(93355, NULL, 'G3DSA:1.10.287.70:FF:000659', NULL, NULL, 'Potassium channel, subfamily, member 5 (KCNK5), transcript variant 2', NULL, NULL, NULL, NULL, NULL, 4),
(93356, NULL, 'G3DSA:1.10.10.1940:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93357, NULL, 'G3DSA:3.30.420.40:FF:000230', NULL, NULL, 'D-allose kinase', NULL, NULL, NULL, NULL, NULL, 4),
(93358, NULL, 'G3DSA:1.25.40.10:FF:004003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93359, NULL, 'G3DSA:1.10.630.10:FF:000581', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93360, NULL, 'G3DSA:1.10.10.10:FF:001696', NULL, NULL, 'Rrf2 family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(93361, NULL, 'G3DSA:2.40.10.10:FF:000158', NULL, NULL, 'Thrombin-like enzyme saxthrombin', NULL, NULL, NULL, NULL, NULL, 4),
(93362, NULL, 'G3DSA:1.10.8.10:FF:000195', NULL, NULL, 'UBX domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(93363, NULL, 'G3DSA:1.10.540.10:FF:000017', NULL, NULL, 'long-chain specific acyl-CoA dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(93364, NULL, 'G3DSA:3.40.50.410:FF:000266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93365, NULL, 'G3DSA:1.10.1370.30:FF:000014', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(93366, NULL, 'G3DSA:3.30.70.3550:FF:000001', NULL, NULL, 'Leucyl/phenylalanyl-tRNA--protein transferase', NULL, NULL, NULL, NULL, NULL, 4),
(93367, NULL, 'G3DSA:3.30.2310.20:FF:000018', NULL, NULL, 'Putative killer suppression protein HigA', NULL, NULL, NULL, NULL, NULL, 4),
(93368, NULL, 'G3DSA:2.60.40.10:FF:004127', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93369, NULL, 'G3DSA:2.30.30.140:FF:000288', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(93370, NULL, 'G3DSA:3.90.79.10:FF:000121', NULL, NULL, 'RNA pyrophosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(93371, NULL, 'G3DSA:3.80.10.10:FF:003313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93372, NULL, 'G3DSA:3.40.50.300:FF:004583', NULL, NULL, 'Pentafunctional AROM polypeptide, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93373, NULL, 'G3DSA:3.40.50.150:FF:000154', NULL, NULL, 'Probable tRNA methyltransferase 9B', NULL, NULL, NULL, NULL, NULL, 4),
(93374, NULL, 'G3DSA:3.20.20.60:FF:000009', NULL, NULL, '2-methylisocitrate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(93375, NULL, 'G3DSA:3.40.50.2300:FF:000798', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93376, NULL, 'G3DSA:3.40.50.1780:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93377, NULL, 'G3DSA:1.10.238.10:FF:000253', NULL, NULL, 'Two pore calcium channel protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(93378, NULL, 'G3DSA:2.60.200.20:FF:000047', NULL, NULL, 'Tyrosyl-DNA phosphodiesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(93379, NULL, 'G3DSA:3.40.50.1000:FF:000352', NULL, NULL, 'Trehalose-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(93380, NULL, 'G3DSA:2.110.10.10:FF:000008', NULL, NULL, 'Matrix metallopeptidase 19', NULL, NULL, NULL, NULL, NULL, 4),
(93381, NULL, 'G3DSA:2.130.10.10:FF:003734', NULL, NULL, 'U3 small nucleolar RNA-associated protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(93382, NULL, 'G3DSA:3.30.450.40:FF:000041', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(93383, NULL, 'G3DSA:1.20.58.390:FF:000260', NULL, NULL, 'Glycine receptor alpha 4', NULL, NULL, NULL, NULL, NULL, 4),
(93384, NULL, 'G3DSA:3.30.70.100:FF:000089', NULL, NULL, 'Antibiotic biosynthesis monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(93385, NULL, 'G3DSA:3.60.21.10:FF:000214', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(93386, NULL, 'G3DSA:2.60.120.260:FF:000311', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(93387, NULL, 'G3DSA:3.20.20.140:FF:000296', NULL, NULL, 'TatD related DNase', NULL, NULL, NULL, NULL, NULL, 4),
(93388, NULL, 'G3DSA:1.25.40.10:FF:004312', NULL, NULL, 'Protein CBG21210', NULL, NULL, NULL, NULL, NULL, 4),
(93389, NULL, 'G3DSA:3.20.20.220:FF:000022', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(93390, NULL, 'G3DSA:3.10.20.90:FF:000182', NULL, NULL, 'pleckstrin homology domain-containing family H member 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(93391, NULL, 'G3DSA:1.10.510.10:FF:003388', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93392, NULL, 'G3DSA:1.20.1250.20:FF:000826', NULL, NULL, 'Allantoate permease', NULL, NULL, NULL, NULL, NULL, 4),
(93393, NULL, 'G3DSA:2.60.40.10:FF:000204', NULL, NULL, 'Major histocompatibility complex, class I-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(93394, NULL, 'G3DSA:2.60.40.10:FF:000513', NULL, NULL, 'striated muscle preferentially expressed protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(93395, NULL, 'G3DSA:1.10.10.790:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93396, NULL, 'G3DSA:1.10.390.10:FF:000090', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(93397, NULL, 'G3DSA:2.60.120.260:FF:000002', NULL, NULL, 'Coagulation factor VIII', NULL, NULL, NULL, NULL, NULL, 4),
(93398, NULL, 'G3DSA:3.80.10.10:FF:001104', NULL, NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(93399, NULL, 'G3DSA:3.30.40.10:FF:000967', NULL, NULL, 'CDK-activating kinase assembly factor MAT1', NULL, NULL, NULL, NULL, NULL, 4),
(93400, NULL, 'G3DSA:3.40.1110.10:FF:000285', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93401, NULL, 'G3DSA:3.20.20.40:FF:000003', NULL, NULL, 'Glucanase', NULL, NULL, NULL, NULL, NULL, 4),
(93402, NULL, 'G3DSA:2.130.10.10:FF:004532', NULL, NULL, 'Cilia- and flagella-associated protein 43', NULL, NULL, NULL, NULL, NULL, 4),
(93403, NULL, 'G3DSA:2.40.160.20:FF:000020', NULL, NULL, 'Major surface antigen 4', NULL, NULL, NULL, NULL, NULL, 4),
(93404, NULL, 'G3DSA:3.40.50.2300:FF:001596', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93405, NULL, 'G3DSA:3.40.50.300:FF:000912', NULL, NULL, 'RecBCD enzyme subunit RecD', NULL, NULL, NULL, NULL, NULL, 4),
(93406, NULL, 'G3DSA:1.25.40.10:FF:003278', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(93407, NULL, 'G3DSA:3.40.50.300:FF:000660', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(93408, NULL, 'G3DSA:2.30.110.50:FF:000005', NULL, NULL, 'Type IV secretion protein Rhs', NULL, NULL, NULL, NULL, NULL, 4),
(93409, NULL, 'G3DSA:3.30.1370.70:FF:000003', NULL, NULL, 'Nfu1p', NULL, NULL, NULL, NULL, NULL, 4),
(93410, NULL, 'G3DSA:4.10.1060.10:FF:000067', NULL, NULL, 'Calpain-D-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(93411, NULL, 'G3DSA:2.130.10.10:FF:004105', NULL, NULL, 'Os07g0506700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(93412, NULL, 'G3DSA:1.10.555.10:FF:000175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93413, NULL, 'G3DSA:3.30.160.60:FF:002441', NULL, NULL, 'Zinc finger protein 521', NULL, NULL, NULL, NULL, NULL, 4),
(93414, NULL, 'G3DSA:3.80.10.10:FF:001430', NULL, NULL, 'Toll-like receptor 15', NULL, NULL, NULL, NULL, NULL, 4),
(93415, NULL, 'G3DSA:3.40.630.10:FF:000116', NULL, NULL, 'Peptide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(93416, NULL, 'G3DSA:1.10.8.60:FF:000294', NULL, NULL, 'p60 katanin', NULL, NULL, NULL, NULL, NULL, 4),
(93417, NULL, 'G3DSA:2.60.40.150:FF:000303', NULL, NULL, 'C2 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(93418, NULL, 'G3DSA:3.30.870.10:FF:000136', NULL, NULL, 'Phospholipase D', NULL, NULL, NULL, NULL, NULL, 4),
(93419, NULL, 'G3DSA:1.20.1560.10:FF:000678', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93420, NULL, 'G3DSA:3.40.640.10:FF:000044', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(93421, NULL, 'G3DSA:1.25.40.20:FF:000055', NULL, NULL, 'ankyrin repeat domain-containing protein 17 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(93422, NULL, 'G3DSA:2.60.120.10:FF:000139', NULL, NULL, 'Bacilysin biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(93423, NULL, 'G3DSA:1.20.120.1760:FF:000014', NULL, NULL, 'Choline/ethanolaminephosphotransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(93424, NULL, 'G3DSA:3.30.505.10:FF:000238', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93425, NULL, 'G3DSA:1.20.120.1750:FF:000011', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(93426, NULL, 'G3DSA:2.60.120.650:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93427, NULL, 'G3DSA:3.30.1310.10:FF:000015', NULL, NULL, 'Nucleoid-associated protein DICTH_1981', NULL, NULL, NULL, NULL, NULL, 4),
(93428, NULL, 'G3DSA:1.10.238.10:FF:000270', NULL, NULL, 'calpain-3 isoform X7', NULL, NULL, NULL, NULL, NULL, 4),
(93429, NULL, 'G3DSA:2.10.25.10:FF:001531', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93430, NULL, 'G3DSA:3.30.70.330:FF:001664', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93431, NULL, 'G3DSA:3.30.2020.30:FF:000022', NULL, NULL, 'Gamma-butyrobetaine hydroxylase subfamily, putative (AFU_orthologue AFUA_2G14970)', NULL, NULL, NULL, NULL, NULL, 4),
(93432, NULL, 'G3DSA:1.10.10.1200:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93433, NULL, 'G3DSA:1.25.10.10:FF:003349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(93434, NULL, 'G3DSA:1.20.58.1060:FF:000004', NULL, NULL, 'Desmoplakin a', NULL, NULL, NULL, NULL, NULL, 4),
(93435, NULL, 'G3DSA:2.30.29.30:FF:001242', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93436, NULL, 'G3DSA:3.40.50.300:FF:003886', NULL, NULL, 'Oligopeptide transport system ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(93437, NULL, 'G3DSA:3.30.160.60:FF:006140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93438, NULL, 'G3DSA:2.60.40.790:FF:000062', NULL, NULL, 'Small heat shock protein HSP20', NULL, NULL, NULL, NULL, NULL, 4),
(93439, NULL, 'G3DSA:3.40.50.300:FF:003785', NULL, NULL, 'Ras-related small GTP-binding family protein', NULL, NULL, NULL, NULL, NULL, 4),
(93440, NULL, 'G3DSA:1.25.40.10:FF:000052', NULL, NULL, 'Aryl-hydrocarbon-interacting protein-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(93441, NULL, 'G3DSA:1.20.58.530:FF:000026', NULL, NULL, 'Myosin B', NULL, NULL, NULL, NULL, NULL, 4),
(93442, NULL, 'G3DSA:1.10.510.10:FF:003949', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93443, NULL, 'G3DSA:3.30.1360.70:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93444, NULL, 'G3DSA:1.20.58.340:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93445, NULL, 'G3DSA:1.10.390.10:FF:000089', NULL, NULL, 'AGAP000131-PA', NULL, NULL, NULL, NULL, NULL, 4),
(93446, NULL, 'G3DSA:3.40.50.1240:FF:000210', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93447, NULL, 'G3DSA:3.40.710.10:FF:000174', NULL, NULL, 'ABC1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(93448, NULL, 'G3DSA:1.10.3720.10:FF:000047', NULL, NULL, 'Amino acid ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(93449, NULL, 'G3DSA:4.10.60.10:FF:000124', NULL, NULL, 'Protein CBG13587', NULL, NULL, NULL, NULL, NULL, 4),
(93450, NULL, 'G3DSA:3.40.50.300:FF:007585', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93451, NULL, 'G3DSA:1.10.510.10:FF:000723', NULL, NULL, 'Receptor like protein kinase S.2', NULL, NULL, NULL, NULL, NULL, 4),
(93452, NULL, 'G3DSA:1.10.510.10:FF:002432', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93453, NULL, 'G3DSA:1.10.510.10:FF:002005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93454, NULL, 'G3DSA:1.25.40.10:FF:003177', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(93455, NULL, 'G3DSA:2.60.40.10:FF:004453', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93456, NULL, 'G3DSA:3.30.1660.10:FF:000002', NULL, NULL, 'Hypothetical lipoprotein yjfO', NULL, NULL, NULL, NULL, NULL, 4),
(93457, NULL, 'G3DSA:3.30.2160.10:FF:000071', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(93458, NULL, 'G3DSA:3.90.25.10:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93459, NULL, 'G3DSA:2.130.10.10:FF:004206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93460, NULL, 'G3DSA:1.10.8.60:FF:000395', NULL, NULL, 'Peroxisomal biogenesis factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(93461, NULL, 'G3DSA:3.40.50.1820:FF:001261', NULL, NULL, 'Lipase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93462, NULL, 'G3DSA:2.30.30.40:FF:000051', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(93463, NULL, 'G3DSA:3.90.550.50:FF:000021', NULL, NULL, 'Beta 3-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(93464, NULL, 'G3DSA:3.30.160.60:FF:002542', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93465, NULL, 'G3DSA:3.30.450.40:FF:000248', NULL, NULL, 'Two component signal transduction system histidine kinase with GAF sensory domain', NULL, NULL, NULL, NULL, NULL, 4),
(93466, NULL, 'G3DSA:2.60.200.20:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93467, NULL, 'G3DSA:2.30.29.30:FF:000994', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(93468, NULL, 'G3DSA:1.25.40.10:FF:001833', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g13160, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(93469, NULL, 'G3DSA:3.60.10.10:FF:000189', NULL, NULL, 'YALI0C07436p', NULL, NULL, NULL, NULL, NULL, 4),
(93470, NULL, 'G3DSA:1.10.506.10:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93471, NULL, 'G3DSA:3.30.160.60:FF:006241', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93472, NULL, 'G3DSA:3.30.40.10:FF:000012', NULL, NULL, 'Zinc finger MIZ domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(93473, NULL, 'G3DSA:1.25.10.10:FF:000224', NULL, NULL, 'Microtubule-associated protein TORTIFOLIA1', NULL, NULL, NULL, NULL, NULL, 4),
(93474, NULL, 'G3DSA:3.90.70.10:FF:000472', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93475, NULL, 'G3DSA:3.40.50.300:FF:003459', NULL, NULL, 'MutS family protein', NULL, NULL, NULL, NULL, NULL, 4),
(93476, NULL, 'G3DSA:3.10.50.40:FF:000163', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(93477, NULL, 'G3DSA:3.50.50.60:FF:001185', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93478, NULL, 'G3DSA:3.40.50.150:FF:000362', NULL, NULL, 'Histidine N-alpha-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(93479, NULL, 'G3DSA:3.30.420.210:FF:000005', NULL, NULL, 'Plant UBX domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(93480, NULL, 'G3DSA:1.25.40.20:FF:001836', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(93481, NULL, 'G3DSA:3.90.550.10:FF:000060', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(93482, NULL, 'G3DSA:3.40.50.300:FF:000025', NULL, NULL, 'ATP-dependent Clp protease subunit', NULL, NULL, NULL, NULL, NULL, 4),
(93483, NULL, 'G3DSA:2.10.25.10:FF:001430', NULL, NULL, 'Laminin subunit beta-1', NULL, NULL, NULL, NULL, NULL, 4),
(93484, NULL, 'G3DSA:3.10.20.90:FF:000518', NULL, NULL, 'Ubiquitin C-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(93485, NULL, 'G3DSA:1.25.40.120:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93486, NULL, 'G3DSA:1.10.10.60:FF:000351', NULL, NULL, 'Transcription factor GAMYB', NULL, NULL, NULL, NULL, NULL, 4),
(93487, NULL, 'G3DSA:3.30.200.20:FF:001961', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93488, NULL, 'G3DSA:1.10.150.290:FF:000001', NULL, NULL, 'Trans-aconitate 2-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(93489, NULL, 'G3DSA:3.20.20.70:FF:000810', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93490, NULL, 'G3DSA:3.30.160.60:FF:000187', NULL, NULL, 'zinc finger protein 37 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(93491, NULL, 'G3DSA:1.10.3210.10:FF:000082', NULL, NULL, 'Metal-dependent phosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(93492, NULL, 'G3DSA:1.20.5.170:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93493, NULL, 'G3DSA:1.10.274.30:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93494, NULL, 'G3DSA:1.20.1310.10:FF:000047', NULL, NULL, 'Cullin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93495, NULL, 'G3DSA:3.40.50.300:FF:004403', NULL, NULL, 'Rab family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(93496, NULL, 'G3DSA:3.40.190.10:FF:000200', NULL, NULL, 'Sensor histidine kinase/response regulator EvgS', NULL, NULL, NULL, NULL, NULL, 4),
(93497, NULL, 'G3DSA:2.60.40.150:FF:000191', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(93498, NULL, 'G3DSA:3.40.50.300:FF:000334', NULL, NULL, 'Protein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(93499, NULL, 'G3DSA:2.30.30.360:FF:000005', NULL, NULL, 'Myosin XI B', NULL, NULL, NULL, NULL, NULL, 4),
(93500, NULL, 'G3DSA:3.60.21.10:FF:000006', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(93501, NULL, 'G3DSA:3.40.640.10:FF:000145', NULL, NULL, 'Aminotransferase DegT', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(93502, NULL, 'G3DSA:3.40.630.30:FF:000549', NULL, NULL, 'Acteyltransferase GNAT family', NULL, NULL, NULL, NULL, NULL, 4),
(93503, NULL, 'G3DSA:1.10.472.80:FF:000166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93504, NULL, 'G3DSA:2.60.120.1540:FF:000015', NULL, NULL, 'Complement C3', NULL, NULL, NULL, NULL, NULL, 4),
(93505, NULL, 'G3DSA:3.40.50.300:FF:008091', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(93506, NULL, 'G3DSA:1.25.50.20:FF:000027', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(93507, NULL, 'G3DSA:3.60.20.30:FF:000010', NULL, NULL, 'L-asparaginase-like protein GM15681', NULL, NULL, NULL, NULL, NULL, 4),
(93508, NULL, 'G3DSA:3.40.50.1700:FF:000056', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93509, NULL, 'G3DSA:3.40.50.720:FF:001421', NULL, NULL, 'Putative methylene tetrahydromethanopterin dehydrogenase/methylenetetrahydrofolate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(93510, NULL, 'G3DSA:3.10.110.10:FF:000112', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(93511, NULL, 'G3DSA:2.130.10.10:FF:000362', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(93512, NULL, 'G3DSA:2.40.420.20:FF:000057', NULL, NULL, 'HAE1 family effllux pump MFP component', NULL, NULL, NULL, NULL, NULL, 4),
(93513, NULL, 'G3DSA:1.20.120.530:FF:000003', NULL, NULL, 'Fatty acid metabolism regulator protein', NULL, NULL, NULL, NULL, NULL, 4),
(93514, NULL, 'G3DSA:2.130.10.10:FF:005960', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93515, NULL, 'G3DSA:3.90.190.10:FF:000296', NULL, NULL, 'Protein-tyrosine-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(93516, NULL, 'G3DSA:3.40.50.300:FF:007837', NULL, NULL, 'DNA mismatch repair mutS protein', NULL, NULL, NULL, NULL, NULL, 4),
(93517, NULL, 'G3DSA:2.30.31.10:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93518, NULL, 'G3DSA:3.40.930.10:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93519, NULL, 'G3DSA:1.20.1280.50:FF:000067', NULL, NULL, 'F-box protein GID2', NULL, NULL, NULL, NULL, NULL, 4),
(93520, NULL, 'G3DSA:3.30.160.60:FF:004195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93521, NULL, 'G3DSA:1.10.8.10:FF:000178', NULL, NULL, 'ATP-dependent protease ATPase subunit HslU2', NULL, NULL, NULL, NULL, NULL, 4),
(93522, NULL, 'G3DSA:2.150.10.10:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93523, NULL, 'G3DSA:2.130.10.10:FF:005842', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93524, NULL, 'G3DSA:2.130.10.10:FF:003279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93525, NULL, 'G3DSA:2.120.10.80:FF:000315', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93526, NULL, 'G3DSA:3.40.50.300:FF:002458', NULL, NULL, 'Cytidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(93527, NULL, 'G3DSA:3.60.20.40:FF:000013', NULL, NULL, 'Gamma-glutamyltranspeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(93528, NULL, 'G3DSA:3.40.50.1440:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93529, NULL, 'G3DSA:1.10.10.10:FF:001679', NULL, NULL, 'SirR/DtxR family transcription regulator', NULL, NULL, NULL, NULL, NULL, 4),
(93530, NULL, 'G3DSA:3.30.200.20:FF:000224', NULL, NULL, 'Citron rho-interacting serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(93531, NULL, 'G3DSA:3.90.79.10:FF:000020', NULL, NULL, 'Pre-mRNA cleavage factor Im subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(93532, NULL, 'G3DSA:3.90.550.50:FF:000122', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(93533, NULL, 'G3DSA:3.30.2170.10:FF:000010', NULL, NULL, 'Endonuclease V', NULL, NULL, NULL, NULL, NULL, 4),
(93534, NULL, 'G3DSA:3.80.20.20:FF:000034', NULL, NULL, 'GG16886', NULL, NULL, NULL, NULL, NULL, 4),
(93535, NULL, 'G3DSA:1.25.40.10:FF:003486', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(93536, NULL, 'G3DSA:3.40.395.10:FF:000024', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(93537, NULL, 'G3DSA:3.40.50.720:FF:001522', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93538, NULL, 'G3DSA:1.10.8.710:FF:000010', NULL, NULL, 'Dynein beta chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93539, NULL, 'G3DSA:1.10.580.10:FF:000008', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(93540, NULL, 'G3DSA:3.30.70.330:FF:001872', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93541, NULL, 'G3DSA:3.20.20.210:FF:000002', NULL, NULL, '5-methyltetrahydropteroyltriglutamate--homocysteine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(93542, NULL, 'G3DSA:2.40.30.10:FF:000058', NULL, NULL, 'GTP binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(93543, NULL, 'G3DSA:3.40.50.300:FF:007000', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93544, NULL, 'G3DSA:1.20.1250.20:FF:001540', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93545, NULL, 'G3DSA:3.60.21.10:FF:000315', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(93546, NULL, 'G3DSA:1.10.287.1490:FF:000092', NULL, NULL, 'Viral A-type inclusion protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93547, NULL, 'G3DSA:3.40.50.880:FF:000125', NULL, NULL, 'CTP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(93548, NULL, 'G3DSA:3.40.140.10:FF:000152', NULL, NULL, 'Apolipoprotein B mRNA-editing enzyme, catalytic polypeptide-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(93549, NULL, 'G3DSA:3.40.50.450:FF:000019', NULL, NULL, '2''-deoxynucleoside 5''-phosphate N-hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(93550, NULL, 'G3DSA:1.25.40.10:FF:000304', NULL, NULL, 'Putative Pre-mRNA-splicing factor prp1', NULL, NULL, NULL, NULL, NULL, 4),
(93551, NULL, 'G3DSA:3.40.470.10:FF:000019', NULL, NULL, 'Hypoxanthine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(93552, NULL, 'G3DSA:3.40.50.300:FF:002149', NULL, NULL, 'DNA transposition protein (GpB)', NULL, NULL, NULL, NULL, NULL, 4),
(93553, NULL, 'G3DSA:3.20.20.220:FF:000005', NULL, NULL, 'Methylenetetrahydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(93554, NULL, 'G3DSA:1.10.10.60:FF:000704', NULL, NULL, 'Sigma-54 activator protein ActB', NULL, NULL, NULL, NULL, NULL, 4),
(93555, NULL, 'G3DSA:3.10.120.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93556, NULL, 'G3DSA:3.10.450.10:FF:000025', NULL, NULL, 'Cysteine proteinase inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(93557, NULL, 'G3DSA:1.10.20.10:FF:000078', NULL, NULL, 'Histone H3', NULL, NULL, NULL, NULL, NULL, 4),
(93558, NULL, 'G3DSA:1.25.40.20:FF:000307', NULL, NULL, 'Protein arginine N-methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(93559, NULL, 'G3DSA:3.40.50.1390:FF:000013', NULL, NULL, 'Serine recombinase', NULL, NULL, NULL, NULL, NULL, 4),
(93560, NULL, 'G3DSA:1.10.8.720:FF:000013', NULL, NULL, 'Axonemal dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(93561, NULL, 'G3DSA:3.40.50.720:FF:000595', NULL, NULL, 'CoB--CoM heterodisulfide reductase iron-sulfur subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(93562, NULL, 'G3DSA:3.90.79.20:FF:000023', NULL, NULL, 'Mutt/nudix family protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(93563, NULL, 'G3DSA:1.25.40.10:FF:002513', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93564, NULL, 'G3DSA:3.40.50.150:FF:000053', NULL, NULL, 'Release factor glutamine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(93565, NULL, 'G3DSA:3.30.70.330:FF:001563', NULL, NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(93566, NULL, 'G3DSA:3.80.10.10:FF:003228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93567, NULL, 'G3DSA:3.60.10.10:FF:000397', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93568, NULL, 'G3DSA:3.30.590.20:FF:000011', NULL, NULL, 'Glutathione biosynthesis bifunctional protein GshAB', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(93569, NULL, 'G3DSA:1.20.120.290:FF:000004', NULL, NULL, 'Oxygen-evolving enhancer protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(93570, NULL, 'G3DSA:3.40.50.150:FF:000480', NULL, NULL, 'Trans-aconitate 3-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(93571, NULL, 'G3DSA:3.40.1010.10:FF:000018', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase I', NULL, NULL, NULL, NULL, NULL, 4),
(93572, NULL, 'G3DSA:3.30.420.610:FF:000018', NULL, NULL, 'Emb|CAB71880.1', NULL, NULL, NULL, NULL, NULL, 4),
(93573, NULL, 'G3DSA:2.40.50.590:FF:000003', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(93574, NULL, 'G3DSA:2.130.10.10:FF:003588', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93575, NULL, 'G3DSA:3.90.1100.10:FF:000025', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(93576, NULL, 'G3DSA:2.60.40.60:FF:000292', NULL, NULL, 'Cadherin-related family member 5', NULL, NULL, NULL, NULL, NULL, 4),
(93577, NULL, 'G3DSA:2.60.120.10:FF:000791', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93578, NULL, 'G3DSA:1.10.472.10:FF:000521', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93579, NULL, 'G3DSA:3.40.50.790:FF:000008', NULL, NULL, '50S ribosomal protein L1', NULL, NULL, NULL, NULL, NULL, 4),
(93580, NULL, 'G3DSA:1.10.287.1490:FF:000103', NULL, NULL, 'GRIP and coiled-coil domain-containing protein C27D7.02c', NULL, NULL, NULL, NULL, NULL, 4),
(93581, NULL, 'G3DSA:1.20.58.830:FF:000009', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(93582, NULL, 'G3DSA:1.10.520.40:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93583, NULL, 'G3DSA:1.20.1740.10:FF:000198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93584, NULL, 'G3DSA:2.130.10.10:FF:000406', NULL, NULL, 'Putative acyl-activating enzyme 19', NULL, NULL, NULL, NULL, NULL, 4),
(93585, NULL, 'G3DSA:1.10.287.110:FF:000278', NULL, NULL, 'Co-chaperone Hsc20', NULL, NULL, NULL, NULL, NULL, 4),
(93586, NULL, 'G3DSA:2.60.40.10:FF:005982', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93587, NULL, 'G3DSA:1.10.1420.10:FF:000209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93588, NULL, 'G3DSA:2.60.120.650:FF:000012', NULL, NULL, 'Cupin superfamily protein family', NULL, NULL, NULL, NULL, NULL, 4),
(93589, NULL, 'G3DSA:3.10.20.30:FF:000080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93590, NULL, 'G3DSA:1.10.510.10:FF:000178', NULL, NULL, 'Calcium-dependent protein kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(93591, NULL, 'G3DSA:3.40.50.300:FF:006382', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93592, NULL, 'G3DSA:2.40.100.10:FF:000007', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase CWC27 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(93593, NULL, 'G3DSA:2.130.10.10:FF:000154', NULL, NULL, 'WD repeat domain phosphoinositide-interacting protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(93594, NULL, 'G3DSA:1.10.1740.10:FF:000048', NULL, NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(93595, NULL, 'G3DSA:2.60.40.60:FF:000303', NULL, NULL, 'Cadherin 96Cb, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(93596, NULL, 'G3DSA:2.170.150.20:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93597, NULL, 'G3DSA:3.90.290.10:FF:000005', NULL, NULL, 'Fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(93598, NULL, 'G3DSA:1.10.287.70:FF:000805', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93599, NULL, 'G3DSA:3.30.70.580:FF:000053', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(93600, NULL, 'G3DSA:3.30.70.940:FF:000015', NULL, NULL, 'Transcription initiation factor SPT5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93601, NULL, 'G3DSA:1.10.10.60:FF:000143', NULL, NULL, 'homeobox protein knotted-1-like 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(93602, NULL, 'G3DSA:1.25.40.20:FF:001898', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93603, NULL, 'G3DSA:1.10.1420.10:FF:000120', NULL, NULL, 'YALI0B10197p', NULL, NULL, NULL, NULL, NULL, 4),
(93604, NULL, 'G3DSA:2.60.40.150:FF:000292', NULL, NULL, 'Putative DEAD/DEAH box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(93605, NULL, 'G3DSA:3.60.10.10:FF:000088', NULL, NULL, 'DNA-(apurinic or apyrimidinic site) lyase', NULL, NULL, NULL, NULL, NULL, 4),
(93606, NULL, 'G3DSA:1.10.220.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93607, NULL, 'G3DSA:3.20.20.190:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93608, NULL, 'G3DSA:3.40.50.720:FF:001213', NULL, NULL, 'HesA/MoeB/ThiF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(93609, NULL, 'G3DSA:3.30.200.20:FF:001753', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93610, NULL, 'G3DSA:1.25.40.10:FF:001895', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(93611, NULL, 'G3DSA:1.10.1070.11:FF:000060', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93612, NULL, 'G3DSA:2.130.10.10:FF:002615', NULL, NULL, 'Probable cytosolic iron-sulfur protein assembly protein CIAO1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(93613, NULL, 'G3DSA:1.10.150.20:FF:000052', NULL, NULL, 'DNA polymerase iota', NULL, NULL, NULL, NULL, NULL, 4),
(93614, NULL, 'G3DSA:2.10.25.10:FF:001222', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93615, NULL, 'G3DSA:3.40.50.1820:FF:000873', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(93616, NULL, 'G3DSA:2.40.50.140:FF:001217', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93617, NULL, 'G3DSA:2.30.30.40:FF:000360', NULL, NULL, 'Peripheral plasma membrane protein CASK', NULL, NULL, NULL, NULL, NULL, 4),
(93618, NULL, 'G3DSA:2.60.120.920:FF:000127', NULL, NULL, 'SPRY domain/Ankyrin repeats (3 copies), putative', NULL, NULL, NULL, NULL, NULL, 4),
(93619, NULL, 'G3DSA:3.40.50.300:FF:000542', NULL, NULL, 'Peptide chain release factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(93620, NULL, 'G3DSA:1.10.10.10:FF:001887', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93621, NULL, 'G3DSA:3.40.50.2000:FF:000798', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(93622, NULL, 'G3DSA:1.10.150.50:FF:000095', NULL, NULL, 'uncharacterized protein LOC108099255 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(93623, NULL, 'G3DSA:2.20.25.10:FF:000064', NULL, NULL, 'Peptide-N(4)-(N-acetyl-beta-glucosaminyl)asparagine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(93624, NULL, 'G3DSA:2.40.30.10:FF:000204', NULL, NULL, 'tRNA-specific 2-thiouridylase MnmA', NULL, NULL, NULL, NULL, NULL, 4),
(93625, NULL, 'G3DSA:2.10.110.20:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93626, NULL, 'G3DSA:3.40.50.2020:FF:000028', NULL, NULL, 'Amidophosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(93627, NULL, 'G3DSA:2.60.40.10:FF:006044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93628, NULL, 'G3DSA:2.80.10.50:FF:000073', NULL, NULL, 'Inositol 1,4,5-trisphosphate receptor itr-1', NULL, NULL, NULL, NULL, NULL, 4),
(93629, NULL, 'G3DSA:2.60.40.830:FF:000001', NULL, NULL, 'Cytochrome f', NULL, NULL, NULL, NULL, NULL, 4),
(93630, NULL, 'G3DSA:3.30.870.10:FF:000018', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(93631, NULL, 'G3DSA:3.30.200.20:FF:001298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93632, NULL, 'G3DSA:3.10.100.10:FF:000038', NULL, NULL, 'Secretory phospholipase A2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(93633, NULL, 'G3DSA:2.10.110.10:FF:000003', NULL, NULL, 'actin-binding LIM protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(93634, NULL, 'G3DSA:2.120.10.80:FF:000107', NULL, NULL, 'Transcription factor INI', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(93635, NULL, 'G3DSA:3.30.200.20:FF:001652', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93636, NULL, 'G3DSA:1.10.287.70:FF:000794', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93637, NULL, 'G3DSA:1.10.510.10:FF:002314', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93638, NULL, 'G3DSA:1.20.1560.10:FF:000796', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93639, NULL, 'G3DSA:2.30.29.30:FF:001348', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93640, NULL, 'G3DSA:1.10.10.60:FF:000042', NULL, NULL, 'Transcriptional activator Myb isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(93641, NULL, 'G3DSA:2.60.40.840:FF:000004', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(93642, NULL, 'G3DSA:3.40.50.720:FF:001730', NULL, NULL, 'Aspartate-semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(93643, NULL, 'G3DSA:3.30.860.10:FF:000001', NULL, NULL, '30S ribosomal protein S19', NULL, NULL, NULL, NULL, NULL, 4),
(93644, NULL, 'G3DSA:1.10.510.10:FF:000414', NULL, NULL, 'Interleukin-1 receptor-associated kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(93645, NULL, 'G3DSA:1.10.1200.10:FF:000137', NULL, NULL, '7-keto-8-aminopelargonate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(93646, NULL, 'G3DSA:3.30.830.10:FF:000252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93647, NULL, 'G3DSA:1.25.10.10:FF:001859', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93648, NULL, 'G3DSA:1.10.510.10:FF:004214', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93649, NULL, 'G3DSA:2.30.110.10:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93650, NULL, 'G3DSA:1.20.1600.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93651, NULL, 'G3DSA:2.40.50.690:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93652, NULL, 'G3DSA:3.90.1580.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93653, NULL, 'G3DSA:1.20.1070.10:FF:001540', NULL, NULL, 'Odorant receptor, family F, subfamily 115, member 12', NULL, NULL, NULL, NULL, NULL, 4),
(93654, NULL, 'G3DSA:3.30.60.60:FF:000011', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(93655, NULL, 'G3DSA:2.60.40.60:FF:000713', NULL, NULL, 'Cdh-4', NULL, NULL, NULL, NULL, NULL, 4),
(93656, NULL, 'G3DSA:3.90.79.10:FF:000093', NULL, NULL, 'Unplaced genomic scaffold supercont1.38, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(93657, NULL, 'G3DSA:3.40.630.10:FF:000425', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93658, NULL, 'G3DSA:2.130.10.10:FF:004414', NULL, NULL, 'Plexin D1', NULL, NULL, NULL, NULL, NULL, 4),
(93659, NULL, 'G3DSA:2.70.130.10:FF:000137', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93660, NULL, 'G3DSA:3.40.190.290:FF:000023', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(93661, NULL, 'G3DSA:1.25.40.10:FF:003941', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93662, NULL, 'G3DSA:3.80.10.10:FF:003212', NULL, NULL, 'Protein CBG22555', NULL, NULL, NULL, NULL, NULL, 4),
(93663, NULL, 'G3DSA:1.25.40.10:FF:003587', NULL, NULL, 'Bll5958 protein', NULL, NULL, NULL, NULL, NULL, 4),
(93664, NULL, 'G3DSA:2.60.40.10:FF:001839', NULL, NULL, 'filamin-A isoform X7', NULL, NULL, NULL, NULL, NULL, 4),
(93665, NULL, 'G3DSA:2.60.120.10:FF:000690', NULL, NULL, 'lysine-specific demethylase 8-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(93666, NULL, 'G3DSA:2.130.10.10:FF:000715', NULL, NULL, 'F-box protein MET30', NULL, NULL, NULL, NULL, NULL, 4),
(93667, NULL, 'G3DSA:2.60.40.60:FF:000258', NULL, NULL, 'neural-cadherin isoform X8', NULL, NULL, NULL, NULL, NULL, 4),
(93668, NULL, 'G3DSA:1.20.1250.20:FF:001506', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(93669, NULL, 'G3DSA:2.130.10.10:FF:001997', NULL, NULL, 'Striatin-3', NULL, NULL, NULL, NULL, NULL, 4),
(93670, NULL, 'G3DSA:3.30.160.60:FF:004650', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93671, NULL, 'G3DSA:3.20.80.10:FF:000009', NULL, NULL, 'Testis-expressed sequence 264 protein', NULL, NULL, NULL, NULL, NULL, 4),
(93672, NULL, 'G3DSA:3.10.580.10:FF:000063', NULL, NULL, 'DUF21 domain-containing protein At5g52790', NULL, NULL, NULL, NULL, NULL, 4),
(93673, NULL, 'G3DSA:1.20.1250.20:FF:001394', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(93674, NULL, 'G3DSA:2.60.40.10:FF:004245', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93675, NULL, 'G3DSA:3.30.1640.10:FF:000091', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(93676, NULL, 'G3DSA:1.25.40.10:FF:001939', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g66520 family', NULL, NULL, NULL, NULL, NULL, 4),
(93677, NULL, 'G3DSA:2.40.10.10:FF:000192', NULL, NULL, 'CLIP-domain serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(93678, NULL, 'G3DSA:3.30.1490.250:FF:000001', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(93679, NULL, 'G3DSA:1.10.472.10:FF:000313', NULL, NULL, 'retinoblastoma-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(93680, NULL, 'G3DSA:2.130.10.10:FF:002424', NULL, NULL, 'Periodic tryptophan protein 2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(93681, NULL, 'G3DSA:3.40.190.10:FF:000054', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(93682, NULL, 'G3DSA:3.40.50.300:FF:004139', NULL, NULL, 'Replication related protein', NULL, NULL, NULL, NULL, NULL, 4),
(93683, NULL, 'G3DSA:1.25.40.10:FF:001687', NULL, NULL, 'Suppressor of RPS4-RLD 1', NULL, NULL, NULL, NULL, NULL, 4),
(93684, NULL, 'G3DSA:2.130.10.10:FF:002514', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(93685, NULL, 'G3DSA:3.40.50.1010:FF:000147', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93686, NULL, 'G3DSA:2.40.30.130:FF:000013', NULL, NULL, 'Threonyl and alanyl tRNA synthetase second additional domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(93687, NULL, 'G3DSA:2.60.120.620:FF:000009', NULL, NULL, 'Prolyl 3-hydroxylase OGFOD1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(93688, NULL, 'G3DSA:1.25.10.10:FF:000106', NULL, NULL, 'Symplekin', NULL, NULL, NULL, NULL, NULL, 4),
(93689, NULL, 'G3DSA:1.25.40.10:FF:003839', NULL, NULL, 'FKBP prolyl isomerase-like', NULL, NULL, NULL, NULL, NULL, 4),
(93690, NULL, 'G3DSA:3.40.50.1000:FF:000144', NULL, NULL, 'copper-transporting ATPase 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(93691, NULL, 'G3DSA:2.60.40.10:FF:001587', NULL, NULL, 'Collagen type XX alpha 1 chain', NULL, NULL, NULL, NULL, NULL, 4),
(93692, NULL, 'G3DSA:3.30.500.10:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93693, NULL, 'G3DSA:3.90.550.10:FF:000166', NULL, NULL, 'Probable sugar transferase', NULL, NULL, NULL, NULL, NULL, 4),
(93694, NULL, 'G3DSA:1.20.1070.10:FF:001394', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93695, NULL, 'G3DSA:1.10.3260.10:FF:000028', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(93696, NULL, 'G3DSA:3.90.1140.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93697, NULL, 'G3DSA:3.40.50.360:FF:000099', NULL, NULL, 'NADPH-dependent diflavin oxidoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(93698, NULL, 'G3DSA:3.10.490.10:FF:000033', NULL, NULL, 'Gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(93699, NULL, 'G3DSA:1.25.40.20:FF:000408', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(93700, NULL, 'G3DSA:2.60.40.640:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93701, NULL, 'G3DSA:3.90.190.20:FF:000040', NULL, NULL, 'Dihydrofolate synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93702, NULL, 'G3DSA:2.120.10.70:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(93703, NULL, 'G3DSA:1.25.40.340:FF:000005', NULL, NULL, 'Dihydroxyacetone kinase 1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(93704, NULL, 'G3DSA:3.40.50.1400:FF:000039', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93705, NULL, 'G3DSA:2.60.120.260:FF:000210', NULL, NULL, 'Alpha-L-arabinofuranosidase', NULL, NULL, NULL, NULL, NULL, 4),
(93706, NULL, 'G3DSA:1.25.40.250:FF:000012', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit K', NULL, NULL, NULL, NULL, NULL, 4),
(93707, NULL, 'G3DSA:1.10.510.10:FF:003596', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93708, NULL, 'G3DSA:3.30.450.40:FF:000142', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(93709, NULL, 'G3DSA:3.10.450.490:FF:000004', NULL, NULL, 'Hemagglutinin/proteinase', NULL, NULL, NULL, NULL, NULL, 4),
(93710, NULL, 'G3DSA:1.10.510.10:FF:004113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93711, NULL, 'G3DSA:1.10.730.10:FF:000043', NULL, NULL, 'Methionine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(93712, NULL, 'G3DSA:1.20.1080.10:FF:000040', NULL, NULL, 'AQuaPorin or aquaglyceroporin related', NULL, NULL, NULL, NULL, NULL, 4),
(93713, NULL, 'G3DSA:3.30.160.60:FF:006347', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93714, NULL, 'G3DSA:2.30.130.10:FF:000017', NULL, NULL, 'RNA-binding protein, containing PUA domain', NULL, NULL, NULL, NULL, NULL, 4),
(93715, NULL, 'G3DSA:3.30.40.10:FF:001440', NULL, NULL, 'TNF receptor-associated factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(93716, NULL, 'G3DSA:1.10.8.60:FF:000086', NULL, NULL, '26S protease regulatory subunit 10B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93717, NULL, 'G3DSA:1.25.40.330:FF:000002', NULL, NULL, 'Adenylyl cyclase-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(93718, NULL, 'G3DSA:3.40.30.10:FF:001051', NULL, NULL, 'Iodothyronine deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(93719, NULL, 'G3DSA:1.25.40.10:FF:000405', NULL, NULL, 'Sel1 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(93720, NULL, 'G3DSA:2.120.10.80:FF:000006', NULL, NULL, 'Kelch-like family member 20', NULL, NULL, NULL, NULL, NULL, 4),
(93721, NULL, 'G3DSA:1.25.40.180:FF:000289', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93722, NULL, 'G3DSA:1.20.5.930:FF:000006', NULL, NULL, 'Integrin subunit alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(93723, NULL, 'G3DSA:2.40.160.120:FF:000052', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(93724, NULL, 'G3DSA:1.20.5.110:FF:000249', NULL, NULL, 'Syntaxin 2-2', NULL, NULL, NULL, NULL, NULL, 4),
(93725, NULL, 'G3DSA:2.30.30.140:FF:000187', NULL, NULL, 'Tudor domain-containing 12', NULL, NULL, NULL, NULL, NULL, 4),
(93726, NULL, 'G3DSA:1.10.560.10:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93727, NULL, 'G3DSA:3.30.70.340:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93728, NULL, 'G3DSA:3.40.1190.20:FF:000079', NULL, NULL, 'BUD17p putative pyridoxal kinase', NULL, NULL, NULL, NULL, NULL, 4),
(93729, NULL, 'G3DSA:3.30.70.330:FF:001973', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93730, NULL, 'G3DSA:1.10.1670.10:FF:000020', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(93731, NULL, 'G3DSA:2.120.10.90:FF:000009', NULL, NULL, 'DNA topoisomerase 4 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(93732, NULL, 'G3DSA:3.30.160.60:FF:002396', NULL, NULL, 'Tripartite motif containing 65', NULL, NULL, NULL, NULL, NULL, 4),
(93733, NULL, 'G3DSA:1.10.357.10:FF:000080', NULL, NULL, 'TetR/AcrR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(93734, NULL, 'G3DSA:1.20.272.10:FF:000015', NULL, NULL, 'Replication factor C subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(93735, NULL, 'G3DSA:1.10.8.270:FF:000024', NULL, NULL, 'TBC1 domain family member 13', NULL, NULL, NULL, NULL, NULL, 4),
(93736, NULL, 'G3DSA:2.60.40.10:FF:003739', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93737, NULL, 'G3DSA:4.10.400.10:FF:000350', NULL, NULL, 'GPR insulin like receptor 1', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(93738, NULL, 'G3DSA:1.20.1250.20:FF:000888', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(93739, NULL, 'G3DSA:3.40.50.1100:FF:000073', NULL, NULL, 'Pyridoxal-phosphate dependent enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93740, NULL, 'G3DSA:2.10.25.10:FF:001076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93741, NULL, 'G3DSA:3.90.1410.10:FF:000026', NULL, NULL, 'Actin-histidine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(93742, NULL, 'G3DSA:3.40.720.10:FF:000354', NULL, NULL, 'N-acetylgalactosamine-6-sulfatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93743, NULL, 'G3DSA:3.40.50.1240:FF:000064', NULL, NULL, 'WGS project CABT00000000 data, contig 2.2', NULL, NULL, NULL, NULL, NULL, 4),
(93744, NULL, 'G3DSA:3.80.10.10:FF:003122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93745, NULL, 'G3DSA:1.25.40.10:FF:000714', NULL, NULL, 'RNA polymerase-associated protein CTR9', NULL, NULL, NULL, NULL, NULL, 4),
(93746, NULL, 'G3DSA:3.30.1130.10:FF:000018', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93747, NULL, 'G3DSA:2.30.30.140:FF:000097', NULL, NULL, 'AT-rich interactive domain-containing protein 4B', NULL, NULL, NULL, NULL, NULL, 4),
(93748, NULL, 'G3DSA:3.30.559.30:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93749, NULL, 'G3DSA:3.20.20.80:FF:000358', NULL, NULL, 'Chitinase-like 5', NULL, NULL, NULL, NULL, NULL, 4),
(93750, NULL, 'G3DSA:1.20.120.350:FF:000247', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93751, NULL, 'G3DSA:2.60.120.290:FF:000129', NULL, NULL, 'Complement component 1, s subcomponent', NULL, NULL, NULL, NULL, NULL, 4),
(93752, NULL, 'G3DSA:3.10.110.10:FF:000230', NULL, NULL, 'AT28509p', NULL, NULL, NULL, NULL, NULL, 4),
(93753, NULL, 'G3DSA:2.130.10.10:FF:005297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93754, NULL, 'G3DSA:3.10.20.90:FF:000390', NULL, NULL, 'UBP6p Ubiquitin-specific protease', NULL, NULL, NULL, NULL, NULL, 4),
(93755, NULL, 'G3DSA:2.30.29.30:FF:001258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93756, NULL, 'G3DSA:3.40.50.720:FF:001319', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase GAPC1 cytosolic', NULL, NULL, NULL, NULL, NULL, 4),
(93757, NULL, 'G3DSA:1.25.40.10:FF:004104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93758, NULL, 'G3DSA:2.60.40.1120:FF:000018', NULL, NULL, 'Carboxypeptidase D', NULL, NULL, NULL, NULL, NULL, 4),
(93759, NULL, 'G3DSA:2.60.40.1110:FF:000015', NULL, NULL, 'Phosphatidylinositol 3,4,5-trisphosphate 3-phosphatase cnrN', NULL, NULL, NULL, NULL, NULL, 4),
(93760, NULL, 'G3DSA:3.10.100.10:FF:000302', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93761, NULL, 'G3DSA:1.20.1110.10:FF:000083', NULL, NULL, 'PMCA23 protein', NULL, NULL, NULL, NULL, NULL, 4),
(93762, NULL, 'G3DSA:3.30.40.10:FF:001647', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93763, NULL, 'G3DSA:1.20.1050.80:FF:000008', NULL, NULL, 'Ankyrin repeat domain-containing protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(93764, NULL, 'G3DSA:3.40.50.1110:FF:000076', NULL, NULL, 'Acetylxylan esterase', NULL, NULL, NULL, NULL, NULL, 4),
(93765, NULL, 'G3DSA:3.30.160.60:FF:004902', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93766, NULL, 'G3DSA:2.80.10.50:FF:000163', NULL, NULL, 'Fibroblast growth factor 21', NULL, NULL, NULL, NULL, NULL, 4),
(93767, NULL, 'G3DSA:3.20.20.70:FF:000355', NULL, NULL, 'Putative galactinol--sucrose galactosyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(93768, NULL, 'G3DSA:2.130.10.10:FF:000053', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(93769, NULL, 'G3DSA:3.40.50.720:FF:001628', NULL, NULL, 'Short chain dehydrogenase/reductase family 42E, member 2', NULL, NULL, NULL, NULL, NULL, 4),
(93770, NULL, 'G3DSA:3.30.1330.30:FF:000141', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93771, NULL, 'G3DSA:2.60.40.10:FF:002093', NULL, NULL, 'Inverse autotransporter adhesin-like protein YeeJ', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(93772, NULL, 'G3DSA:1.20.5.990:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93773, NULL, 'G3DSA:2.60.120.260:FF:000120', NULL, NULL, 'Probable allantoicase', NULL, NULL, NULL, NULL, NULL, 4),
(93774, NULL, 'G3DSA:3.40.50.10420:FF:000057', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(93775, NULL, 'G3DSA:3.30.830.10:FF:000162', NULL, NULL, 'Insulin-degrading enzyme-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(93776, NULL, 'G3DSA:1.10.132.20:FF:000016', NULL, NULL, 'Ribosome recycling factor', NULL, NULL, NULL, NULL, NULL, 4),
(93777, NULL, 'G3DSA:2.60.40.60:FF:000404', NULL, NULL, 'Si:ch211-186j3.6', NULL, NULL, NULL, NULL, NULL, 4),
(93778, NULL, 'G3DSA:1.10.10.10:FF:000044', NULL, NULL, 'RNA polymerase sigma factor RpoS', NULL, NULL, NULL, NULL, NULL, 4),
(93779, NULL, 'G3DSA:3.40.1360.10:FF:000005', NULL, NULL, 'DNA primase, Toprim domain', NULL, NULL, NULL, NULL, NULL, 4),
(93780, NULL, 'G3DSA:3.10.490.20:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93781, NULL, 'G3DSA:1.20.1530.20:FF:000033', NULL, NULL, 'Glutathione-regulated potassium-efflux system protein kefB', NULL, NULL, NULL, NULL, NULL, 4),
(93782, NULL, 'G3DSA:2.60.40.790:FF:000028', NULL, NULL, 'Heat shock protein beta-8', NULL, NULL, NULL, NULL, NULL, 4),
(93783, NULL, 'G3DSA:2.60.40.10:FF:005639', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93784, NULL, 'G3DSA:1.20.1070.10:FF:001085', NULL, NULL, 'Neuropeptide FF receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(93785, NULL, 'G3DSA:1.20.140.10:FF:000097', NULL, NULL, 'Nitrite reductase (cytochrome; ammonia-forming)', NULL, NULL, NULL, NULL, NULL, 4),
(93786, NULL, 'G3DSA:3.30.40.10:FF:001338', NULL, NULL, 'SET domain-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93787, NULL, 'G3DSA:1.10.510.10:FF:003860', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93788, NULL, 'G3DSA:2.60.40.10:FF:005881', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93789, NULL, 'G3DSA:1.10.132.10:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93790, NULL, 'G3DSA:2.170.270.10:FF:000005', NULL, NULL, 'Euchromatic histone-lysine N-methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(93791, NULL, 'G3DSA:1.20.1050.60:FF:000002', NULL, NULL, 'Glycosyl hydrolase family 92', NULL, NULL, NULL, NULL, NULL, 4),
(93792, NULL, 'G3DSA:3.10.50.40:FF:000129', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(93793, NULL, 'G3DSA:3.30.70.100:FF:000090', NULL, NULL, 'AGL041Cp', NULL, NULL, NULL, NULL, NULL, 4),
(93794, NULL, 'G3DSA:2.40.490.10:FF:000002', NULL, NULL, 'Fusion glycoprotein F0', NULL, NULL, NULL, NULL, NULL, 4),
(93795, NULL, 'G3DSA:3.40.50.1820:FF:001227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93796, NULL, 'G3DSA:2.130.10.120:FF:000012', NULL, NULL, 'Prolyl oligopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(93797, NULL, 'G3DSA:3.80.10.10:FF:001531', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93798, NULL, 'G3DSA:3.50.50.60:FF:001229', NULL, NULL, 'GidA-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(93799, NULL, 'G3DSA:3.30.160.60:FF:000850', NULL, NULL, 'Zinc finger and SCAN domain containing 25', NULL, NULL, NULL, NULL, NULL, 4),
(93800, NULL, 'G3DSA:1.10.533.10:FF:000293', NULL, NULL, 'NLR family CARD domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(93801, NULL, 'G3DSA:1.20.5.190:FF:000110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93802, NULL, 'G3DSA:3.30.200.20:FF:001859', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93803, NULL, 'G3DSA:2.60.40.640:FF:000034', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(93804, NULL, 'G3DSA:3.30.160.60:FF:000608', NULL, NULL, 'zinc finger protein 286A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(93805, NULL, 'G3DSA:1.50.40.10:FF:000460', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(93806, NULL, 'G3DSA:1.10.472.80:FF:000065', NULL, NULL, 'GTPase-activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93807, NULL, 'G3DSA:1.10.405.10:FF:000029', NULL, NULL, 'Rab escort protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(93808, NULL, 'G3DSA:3.40.50.300:FF:000233', NULL, NULL, 'Methionine import ATP-binding protein MetN', NULL, NULL, NULL, NULL, NULL, 4),
(93809, NULL, 'G3DSA:3.40.50.200:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93810, NULL, 'G3DSA:1.25.10.10:FF:001298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93811, NULL, 'G3DSA:1.10.238.10:FF:000680', NULL, NULL, 'GTPase-activating protein GYP2', NULL, NULL, NULL, NULL, NULL, 4),
(93812, NULL, 'G3DSA:3.30.70.980:FF:000066', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93813, NULL, 'G3DSA:3.40.50.2000:FF:000489', NULL, NULL, 'Glycosyltransferase 9 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(93814, NULL, 'G3DSA:1.10.287.660:FF:000016', NULL, NULL, 'AGAP004056-PA', NULL, NULL, NULL, NULL, NULL, 4),
(93815, NULL, 'G3DSA:2.130.10.130:FF:000015', NULL, NULL, 'integrin alpha-PS3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(93816, NULL, 'G3DSA:3.30.930.10:FF:000428', NULL, NULL, 'Aspartate-tRNA ligase or aspartyl tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(93817, NULL, 'G3DSA:3.30.40.10:FF:001086', NULL, NULL, 'E3 ubiquitin-protein ligase RNF5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93818, NULL, 'G3DSA:2.60.120.970:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93819, NULL, 'G3DSA:3.30.70.890:FF:000073', NULL, NULL, 'Galactokinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(93820, NULL, 'G3DSA:3.40.1230.10:FF:000001', NULL, NULL, 'Adipogenesis-associated, Mth938 domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(93821, NULL, 'G3DSA:3.40.50.12100:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93822, NULL, 'G3DSA:3.90.228.10:FF:000070', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(93823, NULL, 'G3DSA:3.80.30.20:FF:000006', NULL, NULL, 'MiaB-like tRNA modifying enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(93824, NULL, 'G3DSA:3.30.200.20:FF:000016', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(93825, NULL, 'G3DSA:3.40.50.300:FF:005477', NULL, NULL, 'DEAD-box ATP-dependent RNA helicase CshB', NULL, NULL, NULL, NULL, NULL, 4),
(93826, NULL, 'G3DSA:1.10.1450.10:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93827, NULL, 'G3DSA:2.60.120.10:FF:000381', NULL, NULL, 'Cyclic nucleotide-binding domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93828, NULL, 'G3DSA:1.10.238.10:FF:000371', NULL, NULL, 'CDPK-related kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(93829, NULL, 'G3DSA:3.30.160.60:FF:002750', NULL, NULL, 'zinc finger protein 529 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(93830, NULL, 'G3DSA:3.30.450.20:FF:000647', NULL, NULL, 'PAS sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(93831, NULL, 'G3DSA:2.40.30.10:FF:000513', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93832, NULL, 'G3DSA:1.10.287.110:FF:000424', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93833, NULL, 'G3DSA:1.10.10.10:FF:000605', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93834, NULL, 'G3DSA:1.10.287.110:FF:000172', NULL, NULL, 'Pre-mRNA-splicing factor CWC23', NULL, NULL, NULL, NULL, NULL, 4),
(93835, NULL, 'G3DSA:2.60.40.10:FF:000193', NULL, NULL, 'Myelin protein zero-like 1 like', NULL, NULL, NULL, NULL, NULL, 4),
(93836, NULL, 'G3DSA:3.30.200.20:FF:000325', NULL, NULL, 'Putative receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(93837, NULL, 'G3DSA:1.10.10.10:FF:001578', NULL, NULL, 'MurR/RpiR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(93838, NULL, 'G3DSA:3.30.1380.20:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(93839, NULL, 'G3DSA:3.10.290.10:FF:000068', NULL, NULL, '40S ribosomal protein S4-3', NULL, NULL, NULL, NULL, NULL, 4),
(93840, NULL, 'G3DSA:3.40.50.2300:FF:001169', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93841, NULL, 'G3DSA:3.80.10.10:FF:001840', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(93842, NULL, 'G3DSA:3.30.930.10:FF:000119', NULL, NULL, 'Lysine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(93843, NULL, 'G3DSA:2.120.10.30:FF:000008', NULL, NULL, 'Low-density lipoprotein receptor-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(93844, NULL, 'G3DSA:3.40.50.720:FF:001067', NULL, NULL, 'SUMO-activating enzyme subunit aos-1', NULL, NULL, NULL, NULL, NULL, 4),
(93845, NULL, 'G3DSA:1.20.120.980:FF:000014', NULL, NULL, 'GH14278p', NULL, NULL, NULL, NULL, NULL, 4),
(93846, NULL, 'G3DSA:2.120.10.30:FF:000250', NULL, NULL, 'Nidogen 2a (osteonidogen)', NULL, NULL, NULL, NULL, NULL, 4),
(93847, NULL, 'G3DSA:3.90.70.10:FF:000129', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(93848, NULL, 'G3DSA:3.40.50.300:FF:007938', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93849, NULL, 'G3DSA:3.90.226.10:FF:000340', NULL, NULL, 'Putative enoyl-CoA hydratase/Enoyl-CoA isomerase/3-hydroxyacyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(93850, NULL, 'G3DSA:3.90.1720.10:FF:000027', NULL, NULL, 'Probable endopeptidase Cgl2188', NULL, NULL, NULL, NULL, NULL, 4),
(93851, NULL, 'G3DSA:2.40.50.100:FF:000036', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(93852, NULL, 'G3DSA:3.30.160.60:FF:005870', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93853, NULL, 'G3DSA:2.60.120.330:FF:000046', NULL, NULL, 'Os09g0353700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(93854, NULL, 'G3DSA:3.10.20.90:FF:000760', NULL, NULL, 'Ubiquitin-like domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93855, NULL, 'G3DSA:3.30.540.10:FF:000033', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(93856, NULL, 'G3DSA:1.10.8.10:FF:000094', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(93857, NULL, 'G3DSA:1.10.167.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93858, NULL, 'G3DSA:3.40.190.290:FF:000006', NULL, NULL, 'HTH-type transcriptional regulator tdcA', NULL, NULL, NULL, NULL, NULL, 4),
(93859, NULL, 'G3DSA:2.20.70.10:FF:000106', NULL, NULL, 'CUGBP Elav-like family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(93860, NULL, 'G3DSA:2.60.40.1170:FF:000016', NULL, NULL, 'AP-1 complex subunit mu', NULL, NULL, NULL, NULL, NULL, 4),
(93861, NULL, 'G3DSA:2.60.40.10:FF:004330', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93862, NULL, 'G3DSA:1.10.238.10:FF:000028', NULL, NULL, 'Putative calcium-binding mitochondrial carrier protein scamc-2', NULL, NULL, NULL, NULL, NULL, 4),
(93863, NULL, 'G3DSA:3.10.490.10:FF:000050', NULL, NULL, 'Protein CBG21102', NULL, NULL, NULL, NULL, NULL, 4),
(93864, NULL, 'G3DSA:2.130.10.10:FF:005387', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93865, NULL, 'G3DSA:1.10.418.10:FF:000233', NULL, NULL, 'Plectin', NULL, NULL, NULL, NULL, NULL, 4),
(93866, NULL, 'G3DSA:1.20.140.150:FF:000056', NULL, NULL, 'Claudin', NULL, NULL, NULL, NULL, NULL, 4),
(93867, NULL, 'G3DSA:3.40.50.2300:FF:000421', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(93868, NULL, 'G3DSA:2.20.50.20:FF:000007', NULL, NULL, 'von Willebrand factor type D domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(93869, NULL, 'G3DSA:3.30.70.1230:FF:000047', NULL, NULL, 'Adenylate/guanylate cyclase catalytic domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(93870, NULL, 'G3DSA:1.10.20.120:FF:000018', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93871, NULL, 'G3DSA:3.40.50.300:FF:006292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(93872, NULL, 'G3DSA:1.50.40.10:FF:000196', NULL, NULL, 'mitoferrin', NULL, NULL, NULL, NULL, NULL, 4),
(93873, NULL, 'G3DSA:3.30.200.20:FF:000134', NULL, NULL, 'Dual specificity testis-specific protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(93874, NULL, 'G3DSA:1.10.238.10:FF:000461', NULL, NULL, 'Calcium-binding protein SPEC 2D', NULL, NULL, NULL, NULL, NULL, 4),
(93875, NULL, 'G3DSA:3.10.20.90:FF:000283', NULL, NULL, 'Pez, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(93876, NULL, 'G3DSA:2.30.29.30:FF:000859', NULL, NULL, 'Nucleoporin', NULL, NULL, NULL, NULL, NULL, 4),
(93877, NULL, 'G3DSA:2.60.40.1180:FF:000019', NULL, NULL, 'Alpha-mannosidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(93878, NULL, 'G3DSA:1.20.5.340:FF:000060', NULL, NULL, 'Unplaced genomic scaffold supercont1.13, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(93879, NULL, 'G3DSA:2.170.270.10:FF:000224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93880, NULL, 'G3DSA:3.20.20.60:FF:000127', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(93881, NULL, 'G3DSA:3.30.70.330:FF:001428', NULL, NULL, 'RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(93882, NULL, 'G3DSA:1.10.510.10:FF:002078', NULL, NULL, 'Kinase, STE STE11', NULL, NULL, NULL, NULL, NULL, 4),
(93883, NULL, 'G3DSA:3.90.550.10:FF:000722', NULL, NULL, 'Protein CBR-LGE-1', NULL, NULL, NULL, NULL, NULL, 4),
(93884, NULL, 'G3DSA:3.40.50.1820:FF:001452', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93885, NULL, 'G3DSA:2.130.10.10:FF:002205', NULL, NULL, 'Minichromosome loss protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(93886, NULL, 'G3DSA:3.30.1540.20:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93887, NULL, 'G3DSA:1.10.10.10:FF:000151', NULL, NULL, 'DNA-binding transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(93888, NULL, 'G3DSA:2.60.40.10:FF:000619', NULL, NULL, 'Nectin cell adhesion molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(93889, NULL, 'G3DSA:3.40.30.10:FF:000707', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(93890, NULL, 'G3DSA:4.10.400.10:FF:000349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93891, NULL, 'G3DSA:2.70.170.10:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93892, NULL, 'G3DSA:1.10.3930.10:FF:000001', NULL, NULL, 'Arginine deiminase', NULL, NULL, NULL, NULL, NULL, 4),
(93893, NULL, 'G3DSA:3.40.50.300:FF:002604', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NUBP2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(93894, NULL, 'G3DSA:1.10.1130.10:FF:000002', NULL, NULL, 'Cytochrome c-552', NULL, NULL, NULL, NULL, NULL, 4),
(93895, NULL, 'G3DSA:2.30.180.10:FF:000172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93896, NULL, 'G3DSA:3.30.1150.10:FF:000008', NULL, NULL, 'TolA protein', NULL, NULL, NULL, NULL, NULL, 4),
(93897, NULL, 'G3DSA:2.10.25.10:FF:001177', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(93898, NULL, 'G3DSA:3.40.190.10:FF:000172', NULL, NULL, 'SgrR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(93899, NULL, 'G3DSA:3.40.950.10:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93900, NULL, 'G3DSA:3.30.70.330:FF:000012', NULL, NULL, 'RNA-binding motif, single-stranded-interacting protein 3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(93901, NULL, 'G3DSA:2.40.50.140:FF:000340', NULL, NULL, 'Unplaced genomic scaffold supercont1.162, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(93902, NULL, 'G3DSA:3.90.70.10:FF:000500', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93903, NULL, 'G3DSA:3.40.50.2300:FF:001416', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93904, NULL, 'G3DSA:3.30.160.60:FF:006038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93905, NULL, 'G3DSA:2.60.40.10:FF:003857', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93906, NULL, 'G3DSA:3.30.450.290:FF:000001', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(93907, NULL, 'G3DSA:2.60.40.60:FF:000376', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93908, NULL, 'G3DSA:3.40.1350.120:FF:000001', NULL, NULL, 'tRNA nuclease CdiA-2', NULL, NULL, NULL, NULL, NULL, 4),
(93909, NULL, 'G3DSA:1.10.132.60:FF:000022', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93910, NULL, 'G3DSA:3.30.530.20:FF:000120', NULL, NULL, 'YALI0A02563p', NULL, NULL, NULL, NULL, NULL, 4),
(93911, NULL, 'G3DSA:4.10.60.10:FF:000034', NULL, NULL, 'Universal minicircle sequence binding protein (UMSBP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(93912, NULL, 'G3DSA:1.10.510.10:FF:002185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93913, NULL, 'G3DSA:1.10.20.10:FF:000123', NULL, NULL, 'TAF (TBP-associated transcription factor) family', NULL, NULL, NULL, NULL, NULL, 4),
(93914, NULL, 'G3DSA:2.40.10.10:FF:000074', NULL, NULL, 'glyoxysomal processing protease, glyoxysomal-like', NULL, NULL, NULL, NULL, NULL, 4),
(93915, NULL, 'G3DSA:1.25.40.10:FF:002631', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g31850, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(93916, NULL, 'G3DSA:1.50.40.10:FF:000089', NULL, NULL, 'protein MITOFERRINLIKE 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(93917, NULL, 'G3DSA:1.10.132.70:FF:000025', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(93918, NULL, 'G3DSA:3.90.1290.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93919, NULL, 'G3DSA:2.60.40.2840:FF:000017', NULL, NULL, 'Phosphatidylethanolamine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(93920, NULL, 'G3DSA:3.30.200.20:FF:000241', NULL, NULL, 'Serine/threonine-protein kinase Nek6', NULL, NULL, NULL, NULL, NULL, 4),
(93921, NULL, 'G3DSA:2.60.40.150:FF:000112', NULL, NULL, 'centrosomal protein of 120 kDa isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(93922, NULL, 'G3DSA:3.80.10.10:FF:001621', NULL, NULL, 'EIN3-binding F-box protein 1 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(93923, NULL, 'G3DSA:3.40.850.20:FF:000001', NULL, NULL, 'Cik1p', NULL, NULL, NULL, NULL, NULL, 4),
(93924, NULL, 'G3DSA:3.40.50.620:FF:000891', NULL, NULL, 'Leucyl-tRNA synthetase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(93925, NULL, 'G3DSA:2.30.30.40:FF:000141', NULL, NULL, 'SH3 and PX domain-containing protein 2A', NULL, NULL, NULL, NULL, NULL, 4),
(93926, NULL, 'G3DSA:3.40.50.720:FF:001168', NULL, NULL, 'Os04g0581600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(93927, NULL, 'G3DSA:2.60.40.10:FF:002076', NULL, NULL, 'Myotactin form A', NULL, NULL, NULL, NULL, NULL, 4),
(93928, NULL, 'G3DSA:1.20.1250.40:FF:000012', NULL, NULL, 'Unplaced genomic scaffold supercont1.20, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(93929, NULL, 'G3DSA:2.130.10.10:FF:003835', NULL, NULL, 'Methylosome protein 50-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(93930, NULL, 'G3DSA:1.20.142.10:FF:000011', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(93931, NULL, 'G3DSA:3.10.580.10:FF:000169', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(93932, NULL, 'G3DSA:3.40.50.620:FF:000784', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93933, NULL, 'G3DSA:3.10.20.90:FF:000081', NULL, NULL, 'ubiquilin-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(93934, NULL, 'G3DSA:1.10.1000.11:FF:000005', NULL, NULL, 'Brefeldin A-inhibited guanine nucleotide-exchange 1', NULL, NULL, NULL, NULL, NULL, 4),
(93935, NULL, 'G3DSA:2.10.25.10:FF:000834', NULL, NULL, 'Eater', NULL, NULL, NULL, NULL, NULL, 4),
(93936, NULL, 'G3DSA:1.10.287.110:FF:000323', NULL, NULL, 'ARC6-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(93937, NULL, 'G3DSA:1.10.10.10:FF:001932', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93938, NULL, 'G3DSA:3.30.420.10:FF:000564', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93939, NULL, 'G3DSA:3.30.60.30:FF:000160', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(93940, NULL, 'G3DSA:2.60.40.10:FF:002183', NULL, NULL, 'Sallimus, isoform P', NULL, NULL, NULL, NULL, NULL, 4),
(93941, NULL, 'G3DSA:3.40.50.1100:FF:000281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93942, NULL, 'G3DSA:2.60.40.60:FF:000483', NULL, NULL, 'cadherin-89D', NULL, NULL, NULL, NULL, NULL, 4),
(93943, NULL, 'G3DSA:2.40.180.10:FF:000001', NULL, NULL, 'Catalase', NULL, NULL, NULL, NULL, NULL, 4),
(93944, NULL, 'G3DSA:2.70.130.10:FF:000019', NULL, NULL, 'Insulin-like growth factor 2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(93945, NULL, 'G3DSA:3.30.65.10:FF:000007', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(93946, NULL, 'G3DSA:2.60.120.200:FF:000794', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(93947, NULL, 'G3DSA:2.10.25.10:FF:000941', NULL, NULL, 'Crumbs', NULL, NULL, NULL, NULL, NULL, 4),
(93948, NULL, 'G3DSA:3.30.9.10:FF:000069', NULL, NULL, 'p-hydroxybenzoate hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(93949, NULL, 'G3DSA:2.120.10.30:FF:000115', NULL, NULL, 'NIDogen (Basement membrane protein)', NULL, NULL, NULL, NULL, NULL, 4),
(93950, NULL, 'G3DSA:2.60.40.630:FF:000014', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(93951, NULL, 'G3DSA:3.10.50.40:FF:000028', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(93952, NULL, 'G3DSA:3.20.20.70:FF:000237', NULL, NULL, 'Ribulose-phosphate 3-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(93953, NULL, 'G3DSA:3.80.10.10:FF:001514', NULL, NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(93954, NULL, 'G3DSA:1.10.10.930:FF:000001', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(93955, NULL, 'G3DSA:1.25.40.20:FF:000717', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93956, NULL, 'G3DSA:3.40.50.1820:FF:001126', NULL, NULL, 'Protease 2', NULL, NULL, NULL, NULL, NULL, 4),
(93957, NULL, 'G3DSA:1.10.510.10:FF:000280', NULL, NULL, 'Cell division control protein 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(93958, NULL, 'G3DSA:1.10.230.10:FF:000016', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(93959, NULL, 'G3DSA:3.30.505.10:FF:000148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93960, NULL, 'G3DSA:2.60.40.640:FF:000017', NULL, NULL, 'thioredoxin-interacting protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(93961, NULL, 'G3DSA:3.30.2410.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93962, NULL, 'G3DSA:1.20.5.4770:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93963, NULL, 'G3DSA:1.10.10.440:FF:000056', NULL, NULL, 'Transcription elongation regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(93964, NULL, 'G3DSA:3.30.160.60:FF:002525', NULL, NULL, 'Zinc finger protein Y-linked', NULL, NULL, NULL, NULL, NULL, 4),
(93965, NULL, 'G3DSA:2.70.150.10:FF:000240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93966, NULL, 'G3DSA:2.40.50.150:FF:000034', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(93967, NULL, 'G3DSA:1.25.40.10:FF:003368', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(93968, NULL, 'G3DSA:1.10.8.850:FF:000001', NULL, NULL, 'SET-domain containing protein lysine methyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(93969, NULL, 'G3DSA:1.10.555.10:FF:000259', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93970, NULL, 'G3DSA:1.10.10.350:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93971, NULL, 'G3DSA:3.10.280.10:FF:000017', NULL, NULL, 'Mitochondrial_glycoprotein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(93972, NULL, 'G3DSA:2.40.50.140:FF:000031', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(93973, NULL, 'G3DSA:1.20.58.390:FF:000035', NULL, NULL, 'Acetylcholine receptor subunit beta-like 1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(93974, NULL, 'G3DSA:2.60.11.10:FF:000002', NULL, NULL, 'Cytochrome c oxidase subunit Vb', NULL, NULL, NULL, NULL, NULL, 4),
(93975, NULL, 'G3DSA:1.20.1250.20:FF:001950', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93976, NULL, 'G3DSA:1.25.40.20:FF:000487', NULL, NULL, 'Transient receptor potential cation channel subfamily V member 5', NULL, NULL, NULL, NULL, NULL, 4),
(93977, NULL, 'G3DSA:2.130.10.10:FF:003942', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(93978, NULL, 'G3DSA:1.20.1300.20:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93979, NULL, 'G3DSA:3.40.50.980:FF:000037', NULL, NULL, 'AMP-binding enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93980, NULL, 'G3DSA:3.20.20.70:FF:000765', NULL, NULL, 'Putative NADPH dehydrogenase C23G7.10c', NULL, NULL, NULL, NULL, NULL, 4),
(93981, NULL, 'G3DSA:1.10.287.1490:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93982, NULL, 'G3DSA:1.10.150.50:FF:000179', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(93983, NULL, 'G3DSA:2.60.120.40:FF:000007', NULL, NULL, 'Tumor necrosis factor', NULL, NULL, NULL, NULL, NULL, 4),
(93984, NULL, 'G3DSA:1.20.1300.10:FF:000013', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(93985, NULL, 'G3DSA:2.60.200.20:FF:000272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(93986, NULL, 'G3DSA:1.10.287.470:FF:000066', NULL, NULL, 'Efflux transporter, RND family, MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(93987, NULL, 'G3DSA:3.30.310.50:FF:000005', NULL, NULL, 'L antigen family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(93988, NULL, 'G3DSA:3.30.160.60:FF:002295', NULL, NULL, 'ZFP37 zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(93989, NULL, 'G3DSA:2.130.10.10:FF:003509', NULL, NULL, 'Flagellar Member 5', NULL, NULL, NULL, NULL, NULL, 4),
(93990, NULL, 'G3DSA:1.50.40.10:FF:000566', NULL, NULL, 'Mitochondrial carrier protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(93991, NULL, 'G3DSA:2.60.40.10:FF:005746', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93992, NULL, 'G3DSA:2.40.50.430:FF:000011', NULL, NULL, 'DNA polymerase alpha/epsilon subunit B-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(93993, NULL, 'G3DSA:3.30.1600.10:FF:000009', NULL, NULL, 'Nad-dependent deacetylase 1 putative', NULL, NULL, NULL, NULL, NULL, 4),
(93994, NULL, 'G3DSA:3.40.50.300:FF:002711', NULL, NULL, 'Peptide chain release factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(93995, NULL, 'G3DSA:3.30.310.40:FF:000002', NULL, NULL, 'N-glycosylase/DNA lyase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(93996, NULL, 'G3DSA:1.10.1420.10:FF:000119', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(93997, NULL, 'G3DSA:3.30.70.340:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(93998, NULL, 'G3DSA:1.25.10.10:FF:002803', NULL, NULL, 'AGAP005771-PA', NULL, NULL, NULL, NULL, NULL, 4),
(93999, NULL, 'G3DSA:1.10.510.10:FF:000307', NULL, NULL, 'Serine/threonine-protein kinase RIO2', NULL, NULL, NULL, NULL, NULL, 4),
(94000, NULL, 'G3DSA:3.40.50.2300:FF:001186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94001, NULL, 'G3DSA:1.10.287.1130:FF:000006', NULL, NULL, 'Cytochrome c oxidase copper chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(94002, NULL, 'G3DSA:3.40.30.10:FF:000337', NULL, NULL, 'Protein disulfide-isomerase domain', NULL, NULL, NULL, NULL, NULL, 4),
(94003, NULL, 'G3DSA:4.10.410.10:FF:000075', NULL, NULL, 'Tissue factor pathway inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(94004, NULL, 'G3DSA:2.30.29.30:FF:001039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94005, NULL, 'G3DSA:1.10.238.10:FF:000354', NULL, NULL, 'Actin cytoskeleton-regulatory complex protein pan1', NULL, NULL, NULL, NULL, NULL, 4),
(94006, NULL, 'G3DSA:1.10.290.10:FF:000008', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(94007, NULL, 'G3DSA:2.60.120.970:FF:000119', NULL, NULL, 'Myostatin', NULL, NULL, NULL, NULL, NULL, 4),
(94008, NULL, 'G3DSA:2.60.40.10:FF:004021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94009, NULL, 'G3DSA:3.30.160.60:FF:000743', NULL, NULL, 'PR domain zinc finger protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(94010, NULL, 'G3DSA:2.130.10.10:FF:002054', NULL, NULL, 'Putative beta propeller protein', NULL, NULL, NULL, NULL, NULL, 4),
(94011, NULL, 'G3DSA:1.20.120.230:FF:000003', NULL, NULL, 'Talin 2', NULL, NULL, NULL, NULL, NULL, 4),
(94012, NULL, 'G3DSA:2.60.40.10:FF:003964', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94013, NULL, 'G3DSA:2.40.30.10:FF:000311', NULL, NULL, 'Methionine synthase reductase, mitochondrial-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(94014, NULL, 'G3DSA:2.60.40.2440:FF:000004', NULL, NULL, 'protein phosphatase 1 regulatory subunit 3A', NULL, NULL, NULL, NULL, NULL, 4),
(94015, NULL, 'G3DSA:3.80.10.10:FF:003419', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94016, NULL, 'G3DSA:3.90.70.10:FF:000702', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94017, NULL, 'G3DSA:3.40.50.1000:FF:000806', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94018, NULL, 'G3DSA:3.30.70.1170:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94019, NULL, 'G3DSA:3.30.160.60:FF:002306', NULL, NULL, 'Zinc finger protein 433', NULL, NULL, NULL, NULL, NULL, 4),
(94020, NULL, 'G3DSA:2.40.50.100:FF:000019', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(94021, NULL, 'G3DSA:2.10.110.10:FF:000110', NULL, NULL, 'Nebulin related anchoring protein', NULL, NULL, NULL, NULL, NULL, 4),
(94022, NULL, 'G3DSA:2.60.40.1730:FF:000095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94023, NULL, 'G3DSA:1.20.1520.10:FF:000001', NULL, NULL, 'Cilia- and flagella-associated protein 36', NULL, NULL, NULL, NULL, NULL, 4),
(94024, NULL, 'G3DSA:3.80.10.10:FF:002279', NULL, NULL, 'Leucine Rich Repeat domain protein (AFU_orthologue AFUA_1G04960)', NULL, NULL, NULL, NULL, NULL, 4),
(94025, NULL, 'G3DSA:3.30.40.10:FF:001232', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94026, NULL, 'G3DSA:3.30.9.10:FF:000288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94027, NULL, 'G3DSA:3.90.1410.10:FF:000127', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(94028, NULL, 'G3DSA:3.20.20.80:FF:000459', NULL, NULL, 'Beta-glucosidase 40', NULL, NULL, NULL, NULL, NULL, 4),
(94029, NULL, 'G3DSA:2.30.30.30:FF:000019', NULL, NULL, 'Tumor suppressor p53-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(94030, NULL, 'G3DSA:3.30.420.40:FF:000084', NULL, NULL, 'Heat shock protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(94031, NULL, 'G3DSA:3.90.550.10:FF:000503', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94032, NULL, 'G3DSA:2.120.10.90:FF:000021', NULL, NULL, 'DNA topoisomerase (ATP-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4),
(94033, NULL, 'G3DSA:2.60.40.2430:FF:000001', NULL, NULL, 'Agglutinin-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(94034, NULL, 'G3DSA:1.10.510.10:FF:004023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94035, NULL, 'G3DSA:1.10.10.10:FF:000370', NULL, NULL, 'Methionine aminopeptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(94036, NULL, 'G3DSA:3.40.640.10:FF:000061', NULL, NULL, 'Cystathionine gamma-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(94037, NULL, 'G3DSA:3.40.50.300:FF:006073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94038, NULL, 'G3DSA:3.40.50.300:FF:005584', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94039, NULL, 'G3DSA:1.10.3260.10:FF:000012', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(94040, NULL, 'G3DSA:2.80.10.50:FF:000180', NULL, NULL, 'Fascin', NULL, NULL, NULL, NULL, NULL, 4),
(94041, NULL, 'G3DSA:1.10.630.10:FF:000687', NULL, NULL, 'Os01g0543600 protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(94042, NULL, 'G3DSA:2.130.10.10:FF:001688', NULL, NULL, 'Phosphoinositide 3-kinase regulatory subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(94043, NULL, 'G3DSA:3.40.50.1820:FF:001671', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(94044, NULL, 'G3DSA:3.30.40.10:FF:001872', NULL, NULL, 'Peroxisome biogenesis factor 10', NULL, NULL, NULL, NULL, NULL, 4),
(94045, NULL, 'G3DSA:1.10.472.10:FF:000049', NULL, NULL, 'Retinoblastoma-like 2, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(94046, NULL, 'G3DSA:1.20.1070.10:FF:001321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94047, NULL, 'G3DSA:1.20.1250.20:FF:001422', NULL, NULL, 'Blr5939 protein', NULL, NULL, NULL, NULL, NULL, 4),
(94048, NULL, 'G3DSA:1.10.246.130:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94049, NULL, 'G3DSA:3.40.50.300:FF:002239', NULL, NULL, 'Dynein-related AAA-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(94050, NULL, 'G3DSA:1.10.1900.10:FF:000022', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(94051, NULL, 'G3DSA:3.20.20.80:FF:000768', NULL, NULL, 'Chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94052, NULL, 'G3DSA:3.40.50.720:FF:002011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94053, NULL, 'G3DSA:3.40.50.300:FF:000457', NULL, NULL, 'ADP-ribosylation factor-like protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(94054, NULL, 'G3DSA:3.30.2350.20:FF:000021', NULL, NULL, 'tRNA pseudouridine synthase D', NULL, NULL, NULL, NULL, NULL, 4),
(94055, NULL, 'G3DSA:1.10.510.10:FF:004332', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94056, NULL, 'G3DSA:3.40.1380.20:FF:000026', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(94057, NULL, 'G3DSA:3.40.1380.10:FF:000023', NULL, NULL, 'H(+)-transporting ATP synthase, subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(94058, NULL, 'G3DSA:3.30.70.330:FF:001754', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94059, NULL, 'G3DSA:3.40.1090.10:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94060, NULL, 'G3DSA:1.25.40.20:FF:000178', NULL, NULL, 'Ankyrin repeat and sterile alpha motif domain containing 6', NULL, NULL, NULL, NULL, NULL, 4),
(94061, NULL, 'G3DSA:2.40.70.10:FF:000050', NULL, NULL, 'Aspartic proteinase CDR1', NULL, NULL, NULL, NULL, NULL, 4),
(94062, NULL, 'G3DSA:1.20.120.1750:FF:000117', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(94063, NULL, 'G3DSA:3.40.50.300:FF:003869', NULL, NULL, 'Rbj_C92 protein', NULL, NULL, NULL, NULL, NULL, 4),
(94064, NULL, 'G3DSA:1.10.8.870:FF:000007', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(94065, NULL, 'G3DSA:3.30.505.50:FF:000008', NULL, NULL, 'Plastid-specific ribosomal protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(94066, NULL, 'G3DSA:1.10.418.60:FF:000017', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(94067, NULL, 'G3DSA:1.20.120.350:FF:000163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94068, NULL, 'G3DSA:3.90.1180.10:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94069, NULL, 'G3DSA:2.40.110.10:FF:000053', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(94070, NULL, 'G3DSA:2.70.98.20:FF:000031', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(94071, NULL, 'G3DSA:2.30.39.10:FF:000129', NULL, NULL, 'Serpin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94072, NULL, 'G3DSA:3.20.80.10:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94073, NULL, 'G3DSA:3.40.50.300:FF:005893', NULL, NULL, 'HflX family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(94074, NULL, 'G3DSA:3.20.20.70:FF:000456', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94075, NULL, 'G3DSA:2.40.70.10:FF:000420', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94076, NULL, 'G3DSA:3.30.160.60:FF:004240', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(94077, NULL, 'G3DSA:3.30.1350.10:FF:000001', NULL, NULL, 'Hellethionin-D', NULL, NULL, NULL, NULL, NULL, 4),
(94078, NULL, 'G3DSA:3.30.40.10:FF:001563', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94079, NULL, 'G3DSA:1.20.1070.10:FF:001630', NULL, NULL, 'Growth hormone secretagogue receptor a', NULL, NULL, NULL, NULL, NULL, 4),
(94080, NULL, 'G3DSA:1.20.1250.20:FF:001731', NULL, NULL, 'Synaptic vesicle glycoprotein 2', NULL, NULL, NULL, NULL, NULL, 4),
(94081, NULL, 'G3DSA:1.25.40.10:FF:001788', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g25270, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(94082, NULL, 'G3DSA:2.60.40.150:FF:000421', NULL, NULL, 'Sperm vesicle fusion protein fer-1', NULL, NULL, NULL, NULL, NULL, 4),
(94083, NULL, 'G3DSA:2.40.50.100:FF:000154', NULL, NULL, 'Efflux pump, RND family, membrane fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(94084, NULL, 'G3DSA:3.30.70.1470:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94085, NULL, 'G3DSA:2.60.40.10:FF:003638', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94086, NULL, 'G3DSA:3.30.565.10:FF:000129', NULL, NULL, 'Putative sensory histidine kinase in two-component regulatory system', NULL, NULL, NULL, NULL, NULL, 4),
(94087, NULL, 'G3DSA:3.40.50.1820:FF:001036', NULL, NULL, 'Carboxylesterase 2 (intestine, liver)', NULL, NULL, NULL, NULL, NULL, 4),
(94088, NULL, 'G3DSA:2.40.10.10:FF:000383', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94089, NULL, 'G3DSA:1.25.10.10:FF:002910', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94090, NULL, 'G3DSA:1.25.70.10:FF:000014', NULL, NULL, 'Transcription termination factor MTEF18, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(94091, NULL, 'G3DSA:1.10.275.60:FF:000005', NULL, NULL, 'Adenylosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(94092, NULL, 'G3DSA:3.40.50.300:FF:001868', NULL, NULL, 'DNA helicase A', NULL, NULL, NULL, NULL, NULL, 4),
(94093, NULL, 'G3DSA:2.60.40.60:FF:000067', NULL, NULL, 'FAT atypical cadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(94094, NULL, 'G3DSA:3.90.1260.10:FF:000008', NULL, NULL, 'Argininosuccinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(94095, NULL, 'G3DSA:3.30.70.2280:FF:000007', NULL, NULL, 'Nucleolar RNA helicase 2', NULL, NULL, NULL, NULL, NULL, 4),
(94096, NULL, 'G3DSA:1.50.40.10:FF:000561', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(94097, NULL, 'G3DSA:2.60.40.1770:FF:000011', NULL, NULL, 'Ephrin receptor like protein', NULL, NULL, NULL, NULL, NULL, 4),
(94098, NULL, 'G3DSA:3.90.550.10:FF:000357', NULL, NULL, 'Slr2122 protein', NULL, NULL, NULL, NULL, NULL, 4),
(94099, NULL, 'G3DSA:1.25.40.10:FF:002412', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g20300, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(94100, NULL, 'G3DSA:3.40.50.1440:FF:000045', NULL, NULL, 'Tubulin gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(94101, NULL, 'G3DSA:3.40.50.150:FF:000137', NULL, NULL, 'protein N-lysine methyltransferase METTL21A', NULL, NULL, NULL, NULL, NULL, 4),
(94102, NULL, 'G3DSA:3.30.160.60:FF:000417', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(94103, NULL, 'G3DSA:2.60.40.150:FF:000073', NULL, NULL, 'protein fantom isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(94104, NULL, 'G3DSA:3.40.430.10:FF:000028', NULL, NULL, 'Bifunctional dihydrofolate reductase-thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(94105, NULL, 'G3DSA:3.30.40.10:FF:001911', NULL, NULL, 'Ring-box 1', NULL, NULL, NULL, NULL, NULL, 4),
(94106, NULL, 'G3DSA:3.40.50.2300:FF:000005', NULL, NULL, 'Protein argonaute-2', NULL, NULL, NULL, NULL, NULL, 4),
(94107, NULL, 'G3DSA:3.40.190.100:FF:000006', NULL, NULL, 'Glycine/betaine ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(94108, NULL, 'G3DSA:3.80.10.10:FF:001194', NULL, NULL, 'Leucine-rich receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(94109, NULL, 'G3DSA:3.40.50.300:FF:008074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(94110, NULL, 'G3DSA:1.10.1450.10:FF:000037', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(94111, NULL, 'G3DSA:1.25.40.690:FF:000003', NULL, NULL, 'Nucleoporin SONB, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94112, NULL, 'G3DSA:3.30.70.330:FF:001782', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94113, NULL, 'G3DSA:2.120.10.80:FF:000208', NULL, NULL, 'Carboxymethyl transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94114, NULL, 'G3DSA:1.20.58.60:FF:000859', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(94115, NULL, 'G3DSA:2.120.10.30:FF:000441', NULL, NULL, 'Peptidylglycine alpha-amidating monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(94116, NULL, 'G3DSA:1.25.40.790:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94117, NULL, 'G3DSA:1.25.10.10:FF:001770', NULL, NULL, 'Importin-beta N-terminal domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(94118, NULL, 'G3DSA:2.30.39.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94119, NULL, 'G3DSA:3.30.160.60:FF:003599', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94120, NULL, 'G3DSA:1.10.167.10:FF:000054', NULL, NULL, 'YALI0E10329p', NULL, NULL, NULL, NULL, NULL, 4),
(94121, NULL, 'G3DSA:3.30.70.100:FF:000179', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94122, NULL, 'G3DSA:1.10.1000.11:FF:000033', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(94123, NULL, 'G3DSA:3.30.160.60:FF:000069', NULL, NULL, 'Zinc finger protein 572', NULL, NULL, NULL, NULL, NULL, 4),
(94124, NULL, 'G3DSA:1.10.3260.10:FF:000040', NULL, NULL, 'AGAP000623-PA', NULL, NULL, NULL, NULL, NULL, 4),
(94125, NULL, 'G3DSA:1.10.533.10:FF:000186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94126, NULL, 'G3DSA:1.20.120.350:FF:000146', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94127, NULL, 'G3DSA:1.20.1070.10:FF:001293', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(94128, NULL, 'G3DSA:3.60.15.10:FF:000020', NULL, NULL, 'Class B metallo-beta-lactamase', NULL, NULL, NULL, NULL, NULL, 4),
(94129, NULL, 'G3DSA:2.10.60.10:FF:000056', NULL, NULL, 'RoBo-1', NULL, NULL, NULL, NULL, NULL, 4),
(94130, NULL, 'G3DSA:3.30.200.20:FF:002023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94131, NULL, 'G3DSA:2.170.16.10:FF:000019', NULL, NULL, 'Probable translation initiation factor IF-2', NULL, NULL, NULL, NULL, NULL, 4),
(94132, NULL, 'G3DSA:3.40.50.1380:FF:000010', NULL, NULL, 'carbamoyl-phosphate synthase [ammonia], mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(94133, NULL, 'G3DSA:3.30.1330.80:FF:000015', NULL, NULL, 'AT-hook motif nuclear-localized protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(94134, NULL, 'G3DSA:2.60.120.10:FF:000611', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(94135, NULL, 'G3DSA:1.10.287.1040:FF:000007', NULL, NULL, 'Exodeoxyribonuclease 7 small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(94136, NULL, 'G3DSA:2.130.10.10:FF:002200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94137, NULL, 'G3DSA:3.10.450.50:FF:000020', NULL, NULL, 'Nuclear transport factor 2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(94138, NULL, 'G3DSA:3.40.50.2000:FF:000899', NULL, NULL, 'UDP-glucose,sterol transferase', NULL, NULL, NULL, NULL, NULL, 4),
(94139, NULL, 'G3DSA:3.40.50.300:FF:000441', NULL, NULL, 'ADP-ribosylation factor-like protein 8a', NULL, NULL, NULL, NULL, NULL, 4),
(94140, NULL, 'G3DSA:3.20.20.70:FF:000546', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94141, NULL, 'G3DSA:3.65.10.10:FF:000010', NULL, NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(94142, NULL, 'G3DSA:3.10.20.30:FF:000107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94143, NULL, 'G3DSA:2.60.40.10:FF:000294', NULL, NULL, 'Glucans biosynthesis protein G', NULL, NULL, NULL, NULL, NULL, 4),
(94144, NULL, 'G3DSA:2.60.40.1460:FF:000013', NULL, NULL, 'Integrin alpha-PS1', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(94145, NULL, 'G3DSA:1.10.10.10:FF:000706', NULL, NULL, 'Histone H1 linker', NULL, NULL, NULL, NULL, NULL, 4),
(94146, NULL, 'G3DSA:2.10.25.10:FF:001323', NULL, NULL, 'Neurogenic locus protein delta-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(94147, NULL, 'G3DSA:3.30.2130.10:FF:000018', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(94148, NULL, 'G3DSA:1.10.3710.10:FF:000013', NULL, NULL, 'ATPase, AAA family', NULL, NULL, NULL, NULL, NULL, 4),
(94149, NULL, 'G3DSA:3.40.50.720:FF:000679', NULL, NULL, 'UDP-glucose 4-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(94150, NULL, 'G3DSA:1.10.418.10:FF:000250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94151, NULL, 'G3DSA:2.60.40.60:FF:000174', NULL, NULL, 'FAT atypical cadherin 4', NULL, NULL, NULL, NULL, NULL, 4),
(94152, NULL, 'G3DSA:3.40.47.10:FF:000201', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94153, NULL, 'G3DSA:2.60.40.60:FF:000522', NULL, NULL, 'Protocadherin gamma subfamily C, 4', NULL, NULL, NULL, NULL, NULL, 4),
(94154, NULL, 'G3DSA:2.10.25.10:FF:000795', NULL, NULL, 'Slit homolog 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(94155, NULL, 'G3DSA:3.30.110.30:FF:000001', NULL, NULL, 'Bifunctional glutamate/proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(94156, NULL, 'G3DSA:3.40.630.10:FF:000010', NULL, NULL, 'Succinyl-diaminopimelate desuccinylase', NULL, NULL, NULL, NULL, NULL, 4),
(94157, NULL, 'G3DSA:3.40.1690.10:FF:000007', NULL, NULL, 'Type III secretion appartus protein YscU', NULL, NULL, NULL, NULL, NULL, 4),
(94158, NULL, 'G3DSA:3.90.70.10:FF:000028', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(94159, NULL, 'G3DSA:1.10.510.10:FF:003966', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94160, NULL, 'G3DSA:3.15.20.10:FF:000018', NULL, NULL, 'Phospholipid transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(94161, NULL, 'G3DSA:3.30.160.60:FF:002851', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94162, NULL, 'G3DSA:2.30.29.30:FF:000876', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94163, NULL, 'G3DSA:3.40.50.300:FF:004712', NULL, NULL, 'Atlastin-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(94164, NULL, 'G3DSA:3.30.110.40:FF:000004', NULL, NULL, 'SirA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(94165, NULL, 'G3DSA:1.10.30.10:FF:000034', NULL, NULL, 'SWI/SNF-related matrix-associated regulator of chromatin subfamily E member 1-related', NULL, NULL, NULL, NULL, NULL, 4),
(94166, NULL, 'G3DSA:2.60.120.650:FF:000102', NULL, NULL, 'Histone lysine demethylase PHF8', NULL, NULL, NULL, NULL, NULL, 4),
(94167, NULL, 'G3DSA:1.20.120.550:FF:000009', NULL, NULL, 'YALI0E19745p', NULL, NULL, NULL, NULL, NULL, 4),
(94168, NULL, 'G3DSA:2.130.10.10:FF:003689', NULL, NULL, 'SCF ubiquitin ligase complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(94169, NULL, 'G3DSA:3.40.50.150:FF:000244', NULL, NULL, 'protein-L-isoaspartate(D-aspartate) O-methyltransferase isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(94170, NULL, 'G3DSA:3.40.50.10810:FF:000039', NULL, NULL, 'DNA repair protein Rhp26/Rad26', NULL, NULL, NULL, NULL, NULL, 4),
(94171, NULL, 'G3DSA:3.30.200.20:FF:001399', NULL, NULL, 'Unplaced genomic scaffold supercont2.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(94172, NULL, 'G3DSA:1.10.150.80:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94173, NULL, 'G3DSA:3.30.200.20:FF:001545', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94174, NULL, 'G3DSA:3.50.50.60:FF:000009', NULL, NULL, 'Succinate dehydrogenase flavoprotein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(94175, NULL, 'G3DSA:1.10.555.10:FF:000057', NULL, NULL, 'Rho GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(94176, NULL, 'G3DSA:2.40.50.1000:FF:000015', NULL, NULL, 'Similar to ribosomal protein S11', NULL, NULL, NULL, NULL, NULL, 4),
(94177, NULL, 'G3DSA:1.10.10.10:FF:001786', NULL, NULL, 'Neck appendage protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(94178, NULL, 'G3DSA:1.25.40.10:FF:002322', NULL, NULL, 'Tetratricopeptide repeat protein 30B', NULL, NULL, NULL, NULL, NULL, 4),
(94179, NULL, 'G3DSA:1.20.1640.10:FF:000050', NULL, NULL, 'Protein CBR-CHE-14', NULL, NULL, NULL, NULL, NULL, 4),
(94180, NULL, 'G3DSA:3.40.50.300:FF:002234', NULL, NULL, 'Thymidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(94181, NULL, 'G3DSA:1.10.510.10:FF:002106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94182, NULL, 'G3DSA:1.10.286.20:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94183, NULL, 'G3DSA:3.30.530.20:FF:000103', NULL, NULL, 'StAR-related lipid transfer protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(94184, NULL, 'G3DSA:3.40.50.150:FF:000463', NULL, NULL, 'Gibberellic acid methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(94185, NULL, 'G3DSA:3.40.50.1100:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94186, NULL, 'G3DSA:1.10.286.10:FF:000010', NULL, NULL, 'GTP cyclohydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(94187, NULL, 'G3DSA:2.60.40.1860:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94188, NULL, 'G3DSA:3.80.10.10:FF:001284', NULL, NULL, 'Leucine-rich repeat kinase, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(94189, NULL, 'G3DSA:3.40.50.450:FF:000036', NULL, NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase LOG2', NULL, NULL, NULL, NULL, NULL, 4),
(94190, NULL, 'G3DSA:1.10.10.2660:FF:000003', NULL, NULL, 'ubiquitin-like modifier-activating enzyme 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(94191, NULL, 'G3DSA:2.130.10.10:FF:004313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94192, NULL, 'G3DSA:3.10.580.10:FF:000164', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(94193, NULL, 'G3DSA:3.90.226.10:FF:000216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94194, NULL, 'G3DSA:3.30.200.20:FF:001854', NULL, NULL, 'Probable serine/threonine-protein kinase DDB_G0278845', NULL, NULL, NULL, NULL, NULL, 4),
(94195, NULL, 'G3DSA:3.30.40.10:FF:001237', NULL, NULL, 'ORTHRUS-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(94196, NULL, 'G3DSA:1.20.1250.20:FF:001405', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94197, NULL, 'G3DSA:2.60.40.60:FF:000157', NULL, NULL, 'Neural-cadherin', NULL, NULL, NULL, NULL, NULL, 4),
(94198, NULL, 'G3DSA:3.30.160.60:FF:006033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94199, NULL, 'G3DSA:1.20.58.1000:FF:000003', NULL, NULL, 'CopY family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(94200, NULL, 'G3DSA:3.30.160.60:FF:000378', NULL, NULL, 'zinc finger homeobox protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(94201, NULL, 'G3DSA:1.25.40.10:FF:003733', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g31850, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(94202, NULL, 'G3DSA:2.10.220.10:FF:000080', NULL, NULL, 'Fraser extracellular matrix complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(94203, NULL, 'G3DSA:3.90.70.10:FF:000247', NULL, NULL, 'Ubiquitin hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94204, NULL, 'G3DSA:1.25.40.10:FF:005285', NULL, NULL, 'Protein fem-1 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(94205, NULL, 'G3DSA:2.130.10.10:FF:000507', NULL, NULL, 'WD repeat domain 34', NULL, NULL, NULL, NULL, NULL, 4),
(94206, NULL, 'G3DSA:2.60.40.1170:FF:000011', NULL, NULL, 'Coatomer subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(94207, NULL, 'G3DSA:3.40.33.10:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94208, NULL, 'G3DSA:2.60.40.3210:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94209, NULL, 'G3DSA:2.10.25.10:FF:000469', NULL, NULL, 'Latent transforming growth factor beta binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(94210, NULL, 'G3DSA:1.10.357.70:FF:000002', NULL, NULL, 'Exocyst complex component SEC6', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(94211, NULL, 'G3DSA:1.50.40.10:FF:000342', NULL, NULL, 'Calcium-binding mitochondrial carrier protein Aralar1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(94212, NULL, 'G3DSA:2.40.170.20:FF:000065', NULL, NULL, 'Ferrichrome-iron receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(94213, NULL, 'G3DSA:1.10.1420.10:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94214, NULL, 'G3DSA:2.60.40.10:FF:000075', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', NULL, NULL, NULL, NULL, NULL, 4),
(94215, NULL, 'G3DSA:1.10.10.2670:FF:000006', NULL, NULL, 'Ubiquitin-protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94216, NULL, 'G3DSA:3.40.720.10:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94217, NULL, 'G3DSA:3.30.40.10:FF:001546', NULL, NULL, 'E3 ubiquitin-protein ligase RMA2', NULL, NULL, NULL, NULL, NULL, 4),
(94218, NULL, 'G3DSA:3.90.550.10:FF:000048', NULL, NULL, 'Glycosyltransferase 25 family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(94219, NULL, 'G3DSA:3.30.70.1170:FF:000028', NULL, NULL, 'Putative methyltransferase NSUN5C', NULL, NULL, NULL, NULL, NULL, 4),
(94220, NULL, 'G3DSA:3.40.1370.10:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94221, NULL, 'G3DSA:3.40.50.2020:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94222, NULL, 'G3DSA:3.30.65.10:FF:000002', NULL, NULL, 'DNA topoisomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(94223, NULL, 'G3DSA:3.90.228.10:FF:000069', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(94224, NULL, 'G3DSA:2.130.10.10:FF:005943', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94225, NULL, 'G3DSA:3.40.50.1820:FF:001345', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94226, NULL, 'G3DSA:4.10.410.10:FF:000070', NULL, NULL, 'Seminal fluid protein 24Bc', NULL, NULL, NULL, NULL, NULL, 4),
(94227, NULL, 'G3DSA:3.40.50.1820:FF:000979', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94228, NULL, 'G3DSA:2.120.10.30:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94229, NULL, 'G3DSA:3.30.160.60:FF:004094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94230, NULL, 'G3DSA:3.30.40.10:FF:001456', NULL, NULL, 'Uncharacterized RING finger protein C548.05c', NULL, NULL, NULL, NULL, NULL, 4),
(94231, NULL, 'G3DSA:1.10.8.60:FF:000529', NULL, NULL, 'Uncharacterized protein PEX6', NULL, NULL, NULL, NULL, NULL, 4),
(94232, NULL, 'G3DSA:1.25.40.10:FF:005195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94233, NULL, 'G3DSA:2.60.120.40:FF:000024', NULL, NULL, 'erythroferrone isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(94234, NULL, 'G3DSA:1.10.580.10:FF:000025', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(94235, NULL, 'G3DSA:3.30.200.20:FF:001219', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(94236, NULL, 'G3DSA:1.10.150.50:FF:000196', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(94237, NULL, 'G3DSA:3.30.160.60:FF:002632', NULL, NULL, 'Zinc finger protein 646', NULL, NULL, NULL, NULL, NULL, 4),
(94238, NULL, 'G3DSA:3.80.10.10:FF:002695', NULL, NULL, 'Receptor-like protein kinase HSL1', NULL, NULL, NULL, NULL, NULL, 4),
(94239, NULL, 'G3DSA:1.25.40.10:FF:000158', NULL, NULL, 'pentatricopeptide repeat-containing protein At2g33680', NULL, NULL, NULL, NULL, NULL, 4),
(94240, NULL, 'G3DSA:1.20.1250.20:FF:001624', NULL, NULL, 'PTR family peptide transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94241, NULL, 'G3DSA:1.20.1270.280:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94242, NULL, 'G3DSA:2.130.10.10:FF:001891', NULL, NULL, 'DDB1-and CUL4-associated factor 11 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(94243, NULL, 'G3DSA:2.60.40.10:FF:001002', NULL, NULL, 'obscurin-like protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(94244, NULL, 'G3DSA:1.25.10.10:FF:002601', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94245, NULL, 'G3DSA:1.20.120.350:FF:000056', NULL, NULL, 'Two pore segment channel 2', NULL, NULL, NULL, NULL, NULL, 4),
(94246, NULL, 'G3DSA:1.20.5.110:FF:000098', NULL, NULL, 'Vesicle-associated membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(94247, NULL, 'G3DSA:1.20.1250.20:FF:001315', NULL, NULL, 'AGL277Wp', NULL, NULL, NULL, NULL, NULL, 4),
(94248, NULL, 'G3DSA:1.10.510.10:FF:002415', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94249, NULL, 'G3DSA:2.60.40.10:FF:003947', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94250, NULL, 'G3DSA:2.40.20.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94251, NULL, 'G3DSA:1.25.40.10:FF:001479', NULL, NULL, 'Suppressor of RPS4-RLD 1', NULL, NULL, NULL, NULL, NULL, 4),
(94252, NULL, 'G3DSA:2.60.40.790:FF:000146', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94253, NULL, 'G3DSA:3.90.550.10:FF:000705', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94254, NULL, 'G3DSA:3.30.160.60:FF:000726', NULL, NULL, 'Zinc finger protein 214', NULL, NULL, NULL, NULL, NULL, 4),
(94255, NULL, 'G3DSA:3.40.50.880:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94256, NULL, 'G3DSA:1.20.58.1880:FF:000002', NULL, NULL, 'nuclear receptor corepressor 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(94257, NULL, 'G3DSA:1.10.8.60:FF:000187', NULL, NULL, 'Unplaced genomic scaffold supercont1.232, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(94258, NULL, 'G3DSA:3.10.105.10:FF:000027', NULL, NULL, 'Possible conserved lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(94259, NULL, 'G3DSA:1.25.40.10:FF:002103', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g51965, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(94260, NULL, 'G3DSA:1.10.20.10:FF:000342', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94261, NULL, 'G3DSA:3.30.70.330:FF:001900', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94262, NULL, 'G3DSA:3.30.160.60:FF:002323', NULL, NULL, 'Zinc finger protein 322', NULL, NULL, NULL, NULL, NULL, 4),
(94263, NULL, 'G3DSA:3.30.200.20:FF:002040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94264, NULL, 'G3DSA:2.40.10.10:FF:000309', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94265, NULL, 'G3DSA:3.90.190.10:FF:000498', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94266, NULL, 'G3DSA:3.40.30.10:FF:000359', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(94267, NULL, 'G3DSA:2.40.10.170:FF:000021', NULL, NULL, 'H(+)-transporting ATP synthase, subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(94268, NULL, 'G3DSA:3.30.420.40:FF:000123', NULL, NULL, 'Hexokinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(94269, NULL, 'G3DSA:2.10.60.10:FF:000039', NULL, NULL, 'Sperm acrosome-associated 4-like', NULL, NULL, NULL, NULL, NULL, 4),
(94270, NULL, 'G3DSA:3.40.50.10860:FF:000032', NULL, NULL, 'Bifunctional protein FolD', NULL, NULL, NULL, NULL, NULL, 4),
(94271, NULL, 'G3DSA:1.25.40.10:FF:000630', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(94272, NULL, 'G3DSA:3.30.160.60:FF:000833', NULL, NULL, 'PR domain zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(94273, NULL, 'G3DSA:2.30.30.140:FF:000069', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(94274, NULL, 'G3DSA:2.60.40.10:FF:000277', NULL, NULL, 'Phytanoyl-CoA hydroxylase-interacting protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(94275, NULL, 'G3DSA:2.10.25.10:FF:001104', NULL, NULL, 'Latent transforming growth factor beta binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(94276, NULL, 'G3DSA:2.130.10.10:FF:005634', NULL, NULL, 'Apoptotic protease-activating factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94277, NULL, 'G3DSA:3.40.50.300:FF:006056', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(94278, NULL, 'G3DSA:3.40.50.300:FF:002256', NULL, NULL, 'Dynein beta chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94279, NULL, 'G3DSA:3.30.450.50:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94280, NULL, 'G3DSA:3.40.50.720:FF:000696', NULL, NULL, 'GAL80p Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(94281, NULL, 'G3DSA:3.30.450.40:FF:000147', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(94282, NULL, 'G3DSA:3.30.60.90:FF:000037', NULL, NULL, 'Putative N6-adenosine-methyltransferase with ZZ-type zinc-binding domains', NULL, NULL, NULL, NULL, NULL, 4),
(94283, NULL, 'G3DSA:2.70.150.10:FF:000262', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(94284, NULL, 'G3DSA:2.10.90.10:FF:000119', NULL, NULL, 'Artemin', NULL, NULL, NULL, NULL, NULL, 4),
(94285, NULL, 'G3DSA:1.25.40.20:FF:000633', NULL, NULL, 'Squamosa promoter-binding-like protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(94286, NULL, 'G3DSA:1.10.1200.270:FF:000023', NULL, NULL, 'Os11g0260100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(94287, NULL, 'G3DSA:3.40.50.300:FF:004510', NULL, NULL, 'DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(94288, NULL, 'G3DSA:3.10.150.10:FF:000013', NULL, NULL, 'Beta sliding clamp', NULL, NULL, NULL, NULL, NULL, 4),
(94289, NULL, 'G3DSA:2.10.25.10:FF:001632', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94290, NULL, 'G3DSA:3.30.160.60:FF:003958', NULL, NULL, 'zinc finger protein Xfin', NULL, NULL, NULL, NULL, NULL, 4),
(94291, NULL, 'G3DSA:3.90.70.10:FF:000045', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 16', NULL, NULL, NULL, NULL, NULL, 4),
(94292, NULL, 'G3DSA:3.40.50.1440:FF:000028', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(94293, NULL, 'G3DSA:3.30.390.60:FF:000007', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(94294, NULL, 'G3DSA:2.60.40.1090:FF:000009', NULL, NULL, 'Fimbrial family protein', NULL, NULL, NULL, NULL, NULL, 4),
(94295, NULL, 'G3DSA:1.20.1270.280:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94296, NULL, 'G3DSA:2.60.120.260:FF:000081', NULL, NULL, 'Intraflagellar transport protein 25 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(94297, NULL, 'G3DSA:3.90.70.10:FF:000573', NULL, NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', NULL, NULL, NULL, NULL, NULL, 4),
(94298, NULL, 'G3DSA:2.120.10.30:FF:000025', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM71', NULL, NULL, NULL, NULL, NULL, 4),
(94299, NULL, 'G3DSA:2.30.130.40:FF:000003', NULL, NULL, 'Lon protease homolog 2, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(94300, NULL, 'G3DSA:2.60.40.790:FF:000163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94301, NULL, 'G3DSA:3.60.21.10:FF:000096', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(94302, NULL, 'G3DSA:3.90.226.10:FF:000323', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(94303, NULL, 'G3DSA:3.30.160.60:FF:004088', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94304, NULL, 'G3DSA:3.40.50.1820:FF:000648', NULL, NULL, '1-acylglycerol-3-phosphate O-acyltransferase ABHD5-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(94305, NULL, 'G3DSA:3.30.310.130:FF:000007', NULL, NULL, 'polyhomeotic-proximal chromatin protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(94306, NULL, 'G3DSA:3.30.200.20:FF:001528', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94307, NULL, 'G3DSA:2.30.30.90:FF:000015', NULL, NULL, 'Iron/manganese-dependent transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(94308, NULL, 'G3DSA:3.30.1330.20:FF:000019', NULL, NULL, 'Cell division protein FtsZ', NULL, NULL, NULL, NULL, NULL, 4),
(94309, NULL, 'G3DSA:1.25.40.10:FF:004430', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94310, NULL, 'G3DSA:1.25.10.10:FF:000550', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(94311, NULL, 'G3DSA:1.20.1110.10:FF:000167', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94312, NULL, 'G3DSA:3.40.630.30:FF:000656', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94313, NULL, 'G3DSA:1.20.58.390:FF:000158', NULL, NULL, 'Nicotinic acetylcholine receptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(94314, NULL, 'G3DSA:1.20.970.10:FF:000019', NULL, NULL, 'Anthranilate phosphoribosyltransferase like', NULL, NULL, NULL, NULL, NULL, 4),
(94315, NULL, 'G3DSA:3.80.10.10:FF:003083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94316, NULL, 'G3DSA:2.60.40.10:FF:002531', NULL, NULL, 'Defective proboscis extension response', NULL, NULL, NULL, NULL, NULL, 4),
(94317, NULL, 'G3DSA:3.40.50.1000:FF:000470', NULL, NULL, 'NLI_interacting_factor-like_phosphatase_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(94318, NULL, 'G3DSA:1.10.437.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94319, NULL, 'G3DSA:1.20.1280.50:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94320, NULL, 'G3DSA:3.30.60.20:FF:000022', NULL, NULL, 'SH3 and cysteine-rich domain-containing protein 3 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(94321, NULL, 'G3DSA:2.10.25.10:FF:001093', NULL, NULL, 'Stabilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(94322, NULL, 'G3DSA:1.10.357.10:FF:000006', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(94323, NULL, 'G3DSA:3.40.630.30:FF:000460', NULL, NULL, 'Acyl-CoA N-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(94324, NULL, 'G3DSA:1.20.58.60:FF:000876', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(94325, NULL, 'G3DSA:3.40.50.1240:FF:000103', NULL, NULL, 'Multiple inositol polyphosphate phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(94326, NULL, 'G3DSA:1.10.510.10:FF:002331', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94327, NULL, 'G3DSA:3.40.50.1100:FF:000202', NULL, NULL, 'Threonine ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(94328, NULL, 'G3DSA:1.50.40.10:FF:000544', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94329, NULL, 'G3DSA:2.40.10.10:FF:000422', NULL, NULL, 'GD15727', NULL, NULL, NULL, NULL, NULL, 4),
(94330, NULL, 'G3DSA:3.40.50.11040:FF:000013', NULL, NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', NULL, NULL, NULL, NULL, NULL, 4),
(94331, NULL, 'G3DSA:3.30.160.60:FF:001828', NULL, NULL, 'Zinc finger protein-interacting with ribonucleoprotein K', NULL, NULL, NULL, NULL, NULL, 4),
(94332, NULL, 'G3DSA:1.10.8.270:FF:000052', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(94333, NULL, 'G3DSA:1.10.8.60:FF:000193', NULL, NULL, 'AAA ATPase forming ring-shaped complexes', NULL, NULL, NULL, NULL, NULL, 4),
(94334, NULL, 'G3DSA:1.25.40.10:FF:001569', NULL, NULL, 'RNA polymerase-associated protein CTR9', NULL, NULL, NULL, NULL, NULL, 4),
(94335, NULL, 'G3DSA:2.60.40.1080:FF:000006', NULL, NULL, 'Beta-galactosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94336, NULL, 'G3DSA:3.30.830.10:FF:000027', NULL, NULL, 'nardilysin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(94337, NULL, 'G3DSA:3.40.50.880:FF:000226', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(94338, NULL, 'G3DSA:1.10.510.10:FF:000077', NULL, NULL, 'Vascular endothelial growth factor receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(94339, NULL, 'G3DSA:3.40.50.2060:FF:000006', NULL, NULL, 'Syntaxin binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(94340, NULL, 'G3DSA:2.70.130.10:FF:000154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94341, NULL, 'G3DSA:3.60.21.10:FF:000113', NULL, NULL, 'Phosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(94342, NULL, 'G3DSA:2.60.120.10:FF:000717', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(94343, NULL, 'G3DSA:1.20.1250.20:FF:000927', NULL, NULL, 'Drug resistance transporter, EmrB/QacA family', NULL, NULL, NULL, NULL, NULL, 4),
(94344, NULL, 'G3DSA:2.60.120.10:FF:000465', NULL, NULL, 'Cysteine dioxygenase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(94345, NULL, 'G3DSA:3.40.50.720:FF:001314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94346, NULL, 'G3DSA:2.130.10.10:FF:000255', NULL, NULL, 'Periodic tryptophan protein 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(94347, NULL, 'G3DSA:3.10.130.10:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94348, NULL, 'G3DSA:1.10.10.60:FF:000244', NULL, NULL, 'Highly divergent homeobox', NULL, NULL, NULL, NULL, NULL, 4),
(94349, NULL, 'G3DSA:2.60.40.10:FF:002418', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94350, NULL, 'G3DSA:3.30.70.1230:FF:000182', NULL, NULL, 'Adenylyl cyclase class-3/4/guanylyl cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(94351, NULL, 'G3DSA:3.30.830.10:FF:000134', NULL, NULL, 'Putative mitochondrial-processing peptidase subunit alpha-2 chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(94352, NULL, 'G3DSA:3.40.50.10420:FF:000029', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(94353, NULL, 'G3DSA:2.40.100.10:FF:000108', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94354, NULL, 'G3DSA:2.10.220.10:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94355, NULL, 'G3DSA:2.10.25.10:FF:000486', NULL, NULL, 'Protein delta homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(94356, NULL, 'G3DSA:3.40.50.150:FF:001683', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94357, NULL, 'G3DSA:3.10.20.90:FF:000625', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94358, NULL, 'G3DSA:1.10.510.10:FF:000386', NULL, NULL, 'serine/threonine-protein kinase LMTK2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(94359, NULL, 'G3DSA:3.20.20.10:FF:000028', NULL, NULL, 'Putative diaminopimelate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(94360, NULL, 'G3DSA:3.30.9.10:FF:000215', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(94361, NULL, 'G3DSA:3.30.60.30:FF:000025', NULL, NULL, 'Follistatin-related protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(94362, NULL, 'G3DSA:3.90.79.10:FF:000222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94363, NULL, 'G3DSA:1.10.2000.10:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94364, NULL, 'G3DSA:2.60.40.10:FF:005656', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94365, NULL, 'G3DSA:2.10.25.10:FF:000379', NULL, NULL, 'Cubilin', NULL, NULL, NULL, NULL, NULL, 4),
(94366, NULL, 'G3DSA:3.40.980.10:FF:000002', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(94367, NULL, 'G3DSA:2.40.50.140:FF:001189', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94368, NULL, 'G3DSA:3.20.20.140:FF:000447', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94369, NULL, 'G3DSA:3.90.1750.10:FF:000057', NULL, NULL, 'HECT-domain (Ubiquitin-transferase), putative', NULL, NULL, NULL, NULL, NULL, 4),
(94370, NULL, 'G3DSA:1.10.287.110:FF:000177', NULL, NULL, 'DnaJ heat shock protein family (Hsp40) member C19', NULL, NULL, NULL, NULL, NULL, 4),
(94371, NULL, 'G3DSA:1.10.510.10:FF:000616', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94372, NULL, 'G3DSA:3.40.50.12780:FF:000198', NULL, NULL, 'Firefly luciferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94373, NULL, 'G3DSA:2.60.40.10:FF:004352', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94374, NULL, 'G3DSA:3.40.1050.10:FF:000009', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(94375, NULL, 'G3DSA:3.40.640.10:FF:000370', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94376, NULL, 'G3DSA:3.30.200.20:FF:002242', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94377, NULL, 'G3DSA:3.40.50.2300:FF:001495', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94378, NULL, 'G3DSA:2.40.10.10:FF:000057', NULL, NULL, 'Zgc:100868', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(94379, NULL, 'G3DSA:1.10.418.10:FF:000143', NULL, NULL, 'Zygote defective protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(94380, NULL, 'G3DSA:2.40.170.20:FF:000048', NULL, NULL, 'Ferrichrome iron receptor', NULL, NULL, NULL, NULL, NULL, 4),
(94381, NULL, 'G3DSA:3.10.20.90:FF:000844', NULL, NULL, 'UBX domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(94382, NULL, 'G3DSA:1.25.10.10:FF:001966', NULL, NULL, 'Protein CELLULOSE SYNTHASE INTERACTIVE 1', NULL, NULL, NULL, NULL, NULL, 4),
(94383, NULL, 'G3DSA:3.40.50.200:FF:000175', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(94384, NULL, 'G3DSA:2.40.33.10:FF:000003', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(94385, NULL, 'G3DSA:3.40.50.740:FF:000016', NULL, NULL, 'NADH dehydrogenase (Quinone), G subunit', NULL, NULL, NULL, NULL, NULL, 4),
(94386, NULL, 'G3DSA:2.10.25.10:FF:000688', NULL, NULL, 'Neurogenic locus notch homolog protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(94387, NULL, 'G3DSA:1.10.510.10:FF:002640', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94388, NULL, 'G3DSA:1.20.1250.20:FF:001641', NULL, NULL, 'Quinate permease', NULL, NULL, NULL, NULL, NULL, 4),
(94389, NULL, 'G3DSA:1.50.40.10:FF:000235', NULL, NULL, 'Mitochondrial carrier protein (Rim2), putative (AFU_orthologue AFUA_3G06950)', NULL, NULL, NULL, NULL, NULL, 4),
(94390, NULL, 'G3DSA:2.130.10.10:FF:000036', NULL, NULL, 'Neurobeachin isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(94391, NULL, 'G3DSA:3.90.79.10:FF:000109', NULL, NULL, 'MutT/nudix family protein', NULL, NULL, NULL, NULL, NULL, 4),
(94392, NULL, 'G3DSA:2.130.10.10:FF:004330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94393, NULL, 'G3DSA:2.40.30.10:FF:000530', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94394, NULL, 'G3DSA:2.60.40.10:FF:004661', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94395, NULL, 'G3DSA:4.10.1240.10:FF:000047', NULL, NULL, 'Parathyroid hormone receptor like 2', NULL, NULL, NULL, NULL, NULL, 4),
(94396, NULL, 'G3DSA:3.40.50.720:FF:000010', NULL, NULL, 'Malate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(94397, NULL, 'G3DSA:3.10.20.310:FF:000006', NULL, NULL, 'Cell division protein FtsQ', NULL, NULL, NULL, NULL, NULL, 4),
(94398, NULL, 'G3DSA:3.40.50.2300:FF:001506', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94399, NULL, 'G3DSA:1.10.238.230:FF:000001', NULL, NULL, 'Serine/threonine-protein phosphatase 2A regulatory subunit B'''' subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(94400, NULL, 'G3DSA:3.40.50.11030:FF:000010', NULL, NULL, 'Threonylcarbamoyl-AMP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(94401, NULL, 'G3DSA:3.90.70.10:FF:000354', NULL, NULL, 'Protein CBG17829', NULL, NULL, NULL, NULL, NULL, 4),
(94402, NULL, 'G3DSA:2.130.10.10:FF:004307', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94403, NULL, 'G3DSA:3.30.70.340:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94404, NULL, 'G3DSA:3.40.630.10:FF:000009', NULL, NULL, 'N-acetylated-alpha-linked acidic dipeptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(94405, NULL, 'G3DSA:1.10.510.10:FF:001111', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(94406, NULL, 'G3DSA:3.30.420.40:FF:000432', NULL, NULL, 'Heat shock protein 70 putative', NULL, NULL, NULL, NULL, NULL, 4),
(94407, NULL, 'G3DSA:3.40.250.10:FF:000239', NULL, NULL, 'Sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(94408, NULL, 'G3DSA:3.30.160.60:FF:002216', NULL, NULL, 'Zinc finger protein 555', NULL, NULL, NULL, NULL, NULL, 4),
(94409, NULL, 'G3DSA:3.40.50.300:FF:004167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94410, NULL, 'G3DSA:1.10.20.10:FF:000207', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94411, NULL, 'G3DSA:3.30.160.60:FF:000524', NULL, NULL, 'Zinc finger protein 155', NULL, NULL, NULL, NULL, NULL, 4),
(94412, NULL, 'G3DSA:3.80.10.10:FF:000587', NULL, NULL, 'NLR family pyrin domain containing 4', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(94413, NULL, 'G3DSA:3.90.230.10:FF:000013', NULL, NULL, 'DNA-binding protein, 42 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(94414, NULL, 'G3DSA:1.10.472.80:FF:000267', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94415, NULL, 'G3DSA:1.10.10.60:FF:000025', NULL, NULL, 'Mesoderm induction early response 1, transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(94416, NULL, 'G3DSA:2.60.40.10:FF:004329', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94417, NULL, 'G3DSA:3.30.200.20:FF:001635', NULL, NULL, 'STE20-related kinase adapter protein alpha', NULL, NULL, NULL, NULL, NULL, 4),
(94418, NULL, 'G3DSA:2.160.20.70:FF:000042', NULL, NULL, 'AFL149Cp', NULL, NULL, NULL, NULL, NULL, 4),
(94419, NULL, 'G3DSA:3.40.50.300:FF:008416', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94420, NULL, 'G3DSA:3.40.50.300:FF:000435', NULL, NULL, 'Ferrichrome ABC transporter, ATP-binding protein FhuC', NULL, NULL, NULL, NULL, NULL, 4),
(94421, NULL, 'G3DSA:1.10.150.650:FF:000008', NULL, NULL, 'PHP domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(94422, NULL, 'G3DSA:3.30.499.10:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94423, NULL, 'G3DSA:3.30.70.330:FF:000034', NULL, NULL, 'heterogeneous nuclear ribonucleoprotein M isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(94424, NULL, 'G3DSA:1.10.150.80:FF:000047', NULL, NULL, 'AFL159Wp', NULL, NULL, NULL, NULL, NULL, 4),
(94425, NULL, 'G3DSA:3.40.50.10130:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94426, NULL, 'G3DSA:3.10.110.10:FF:000213', NULL, NULL, 'Ubiquitin-conjugating enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(94427, NULL, 'G3DSA:1.25.10.10:FF:000802', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(94428, NULL, 'G3DSA:3.30.420.10:FF:000687', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94429, NULL, 'G3DSA:3.40.50.880:FF:000007', NULL, NULL, 'Peptidase E', NULL, NULL, NULL, NULL, NULL, 4),
(94430, NULL, 'G3DSA:1.25.40.10:FF:003716', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(94431, NULL, 'G3DSA:3.90.70.10:FF:000264', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94432, NULL, 'G3DSA:3.90.550.10:FF:000161', NULL, NULL, 'Probable mannosyltransferase KTR7', NULL, NULL, NULL, NULL, NULL, 4),
(94433, NULL, 'G3DSA:1.20.5.110:FF:000244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94434, NULL, 'G3DSA:2.130.10.10:FF:006022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94435, NULL, 'G3DSA:1.10.10.10:FF:000061', NULL, NULL, 'HTH-type transcriptional regulator ArgP', NULL, NULL, NULL, NULL, NULL, 4),
(94436, NULL, 'G3DSA:3.30.160.60:FF:005398', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94437, NULL, 'G3DSA:1.10.533.10:FF:000219', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(94438, NULL, 'G3DSA:1.10.510.10:FF:002550', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94439, NULL, 'G3DSA:3.40.50.300:FF:006421', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94440, NULL, 'G3DSA:1.20.1250.20:FF:001080', NULL, NULL, 'WGS project CABT00000000 data, contig 2.12', NULL, NULL, NULL, NULL, NULL, 4),
(94441, NULL, 'G3DSA:1.20.5.340:FF:000043', NULL, NULL, 'Transcriptional repressor TUP1', NULL, NULL, NULL, NULL, NULL, 4),
(94442, NULL, 'G3DSA:1.20.1440.130:FF:000002', NULL, NULL, 'vitamin K epoxide reductase complex subunit 1-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(94443, NULL, 'G3DSA:1.10.287.70:FF:000766', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(94444, NULL, 'G3DSA:3.30.810.10:FF:000026', NULL, NULL, 'Phosphatidylinositol-5-phosphate 4-kinase, type II, alpha a', NULL, NULL, NULL, NULL, NULL, 4),
(94445, NULL, 'G3DSA:1.25.40.10:FF:001934', NULL, NULL, 'Unplaced genomic scaffold supercont1.111, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(94446, NULL, 'G3DSA:1.10.10.10:FF:000712', NULL, NULL, 'HTH-type transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(94447, NULL, 'G3DSA:3.10.450.50:FF:000014', NULL, NULL, 'Phenazine biosynthesis protein PhzB 2', NULL, NULL, NULL, NULL, NULL, 4),
(94448, NULL, 'G3DSA:3.40.50.1820:FF:001362', NULL, NULL, 'GPI inositol-deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(94449, NULL, 'G3DSA:2.60.40.10:FF:000620', NULL, NULL, 'Immunoglobulin lambda locus', NULL, NULL, NULL, NULL, NULL, 4),
(94450, NULL, 'G3DSA:3.40.1580.10:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94451, NULL, 'G3DSA:1.10.1410.10:FF:000063', NULL, NULL, 'Terminal uridylyltransferase 3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94452, NULL, 'G3DSA:1.20.1070.10:FF:001068', NULL, NULL, 'Neuropeptide FF receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(94453, NULL, 'G3DSA:2.60.40.10:FF:000058', NULL, NULL, 'roundabout homolog 2 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(94454, NULL, 'G3DSA:3.40.50.300:FF:000126', NULL, NULL, 'Galactose/methyl galactoside import ATP-binding protein MglA', NULL, NULL, NULL, NULL, NULL, 4),
(94455, NULL, 'G3DSA:3.40.50.10470:FF:000038', NULL, NULL, 'Putative methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(94456, NULL, 'G3DSA:1.20.1250.20:FF:001169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94457, NULL, 'G3DSA:3.40.50.410:FF:000159', NULL, NULL, 'Calcium voltage-gated channel auxiliary subunit alpha2delta 2', NULL, NULL, NULL, NULL, NULL, 4),
(94458, NULL, 'G3DSA:1.10.10.10:FF:001707', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(94459, NULL, 'G3DSA:2.30.180.10:FF:000155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94460, NULL, 'G3DSA:2.10.220.10:FF:000079', NULL, NULL, 'Furin-like protease 2', NULL, NULL, NULL, NULL, NULL, 4),
(94461, NULL, 'G3DSA:1.10.132.60:FF:000005', NULL, NULL, 'Putative DNA polymerase zeta catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(94462, NULL, 'G3DSA:3.30.200.20:FF:000550', NULL, NULL, 'Serine/threonine-protein kinase greatwall', NULL, NULL, NULL, NULL, NULL, 4),
(94463, NULL, 'G3DSA:3.40.50.200:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94464, NULL, 'G3DSA:3.40.50.1460:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94465, NULL, 'G3DSA:3.40.50.1000:FF:000251', NULL, NULL, 'Phosphatidylglycerophosphatase GEP4, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(94466, NULL, 'G3DSA:3.80.10.10:FF:002588', NULL, NULL, 'Serine/threonine-protein kinase BRI1-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(94467, NULL, 'G3DSA:3.30.70.330:FF:001119', NULL, NULL, 'Cold sensitive u2 snRNA suppressor', NULL, NULL, NULL, NULL, NULL, 4),
(94468, NULL, 'G3DSA:3.30.930.10:FF:000299', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(94469, NULL, 'G3DSA:3.30.230.130:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94470, NULL, 'G3DSA:1.20.5.190:FF:000071', NULL, NULL, 'Class V myosin', NULL, NULL, NULL, NULL, NULL, 4),
(94471, NULL, 'G3DSA:3.30.60.30:FF:000244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94472, NULL, 'G3DSA:3.90.226.10:FF:000014', NULL, NULL, 'ATP-dependent Clp protease proteolytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(94473, NULL, 'G3DSA:3.80.10.10:FF:000210', NULL, NULL, 'leucine-rich repeat serine/threonine-protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(94474, NULL, 'G3DSA:1.10.132.70:FF:000008', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(94475, NULL, 'G3DSA:3.40.50.10190:FF:000281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94476, NULL, 'G3DSA:1.10.287.1490:FF:000120', NULL, NULL, 'Phosphatidylinositol 3-kinase regulatory subunit alpha-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(94477, NULL, 'G3DSA:2.60.40.10:FF:005965', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(94478, NULL, 'G3DSA:3.20.20.140:FF:000195', NULL, NULL, 'PHP C-terminal domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(94479, NULL, 'G3DSA:1.10.455.10:FF:000004', NULL, NULL, '28S ribosomal protein S7, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(94480, NULL, 'G3DSA:2.60.120.620:FF:000144', NULL, NULL, 'Zgc:174917', NULL, NULL, NULL, NULL, NULL, 4),
(94481, NULL, 'G3DSA:3.30.70.330:FF:001647', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94482, NULL, 'G3DSA:2.40.70.10:FF:000504', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94483, NULL, 'G3DSA:1.25.10.10:FF:000241', NULL, NULL, 'Putative importin subunit beta-4', NULL, NULL, NULL, NULL, NULL, 4),
(94484, NULL, 'G3DSA:2.60.40.150:FF:000218', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(94485, NULL, 'G3DSA:2.10.90.10:FF:000086', NULL, NULL, 'Vascular endothelial growth factor c', NULL, NULL, NULL, NULL, NULL, 4),
(94486, NULL, 'G3DSA:3.10.20.90:FF:000064', NULL, NULL, 'Putative ubiquitin carboxyl-terminal hydrolase 7', NULL, NULL, NULL, NULL, NULL, 4),
(94487, NULL, 'G3DSA:1.20.1070.10:FF:001304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94488, NULL, 'G3DSA:3.20.20.80:FF:000684', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(94489, NULL, 'G3DSA:3.30.565.10:FF:000040', NULL, NULL, 'Sensor histidine kinase DpiB', NULL, NULL, NULL, NULL, NULL, 4),
(94490, NULL, 'G3DSA:1.20.1260.140:FF:000003', NULL, NULL, 'Ubiquinol oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(94491, NULL, 'G3DSA:3.30.2350.20:FF:000004', NULL, NULL, 'pseudouridylate synthase 7 homolog-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(94492, NULL, 'G3DSA:1.10.287.110:FF:000407', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(94493, NULL, 'G3DSA:3.30.530.20:FF:000119', NULL, NULL, 'Kirola', NULL, NULL, NULL, NULL, NULL, 4),
(94494, NULL, 'G3DSA:1.25.40.10:FF:004211', NULL, NULL, 'Putative UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SEC', NULL, NULL, NULL, NULL, NULL, 4),
(94495, NULL, 'G3DSA:1.10.565.10:FF:000086', NULL, NULL, 'Nuclear receptor subfamily 1, group H, member 5', NULL, NULL, NULL, NULL, NULL, 4),
(94496, NULL, 'G3DSA:3.40.720.10:FF:000129', NULL, NULL, 'Protein CBG23355', NULL, NULL, NULL, NULL, NULL, 4),
(94497, NULL, 'G3DSA:3.30.1330.120:FF:000001', NULL, NULL, '2-methylcitrate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(94498, NULL, 'G3DSA:2.170.150.80:FF:000017', NULL, NULL, 'Os05g0415400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(94499, NULL, 'G3DSA:1.10.220.160:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94500, NULL, 'G3DSA:2.60.40.10:FF:002109', NULL, NULL, 'Kekkon-1, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(94501, NULL, 'G3DSA:1.10.238.10:FF:000500', NULL, NULL, 'CALmodulin related genes', NULL, NULL, NULL, NULL, NULL, 4),
(94502, NULL, 'G3DSA:3.40.630.30:FF:000095', NULL, NULL, 'Histone acetyltransferase, ELP3 family', NULL, NULL, NULL, NULL, NULL, 4),
(94503, NULL, 'G3DSA:2.40.110.10:FF:000070', NULL, NULL, 'Blr0119 protein', NULL, NULL, NULL, NULL, NULL, 4),
(94504, NULL, 'G3DSA:3.30.2350.10:FF:000001', NULL, NULL, 'H/ACA ribonucleoprotein complex subunit CBF5', NULL, NULL, NULL, NULL, NULL, 4),
(94505, NULL, 'G3DSA:3.40.50.1440:FF:000051', NULL, NULL, 'Tubulin-like protein CetZ', NULL, NULL, NULL, NULL, NULL, 4),
(94506, NULL, 'G3DSA:3.30.420.10:FF:000581', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94507, NULL, 'G3DSA:2.60.120.310:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94508, NULL, 'G3DSA:3.40.30.10:FF:000668', NULL, NULL, 'DNaJ domain (Prokaryotic heat shock protein)', NULL, NULL, NULL, NULL, NULL, 4),
(94509, NULL, 'G3DSA:3.40.950.10:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94510, NULL, 'G3DSA:1.25.10.10:FF:002129', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(94511, NULL, 'G3DSA:3.20.20.70:FF:000681', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94512, NULL, 'G3DSA:3.40.50.12650:FF:000029', NULL, NULL, 'DNA repair protein, putative (AFU_orthologue AFUA_1G04570)', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(94513, NULL, 'G3DSA:3.40.50.720:FF:001084', NULL, NULL, 'Short-subunit dehydrogenase involved in D-alanine esterification of teichoic acids', NULL, NULL, NULL, NULL, NULL, 4),
(94514, NULL, 'G3DSA:3.30.890.10:FF:000019', NULL, NULL, 'Methyl-CpG-binding domain-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(94515, NULL, 'G3DSA:1.10.533.10:FF:000113', NULL, NULL, 'Baculoviral IAP repeat-containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(94516, NULL, 'G3DSA:3.20.20.70:FF:000439', NULL, NULL, 'Triosephosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(94517, NULL, 'G3DSA:1.20.1250.20:FF:001170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94518, NULL, 'G3DSA:2.60.40.10:FF:002312', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(94519, NULL, 'G3DSA:3.40.190.80:FF:000075', NULL, NULL, 'Protein CBG13639', NULL, NULL, NULL, NULL, NULL, 4),
(94520, NULL, 'G3DSA:1.25.40.20:FF:000942', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94521, NULL, 'G3DSA:3.40.50.2300:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94522, NULL, 'G3DSA:3.90.1410.10:FF:000043', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(94523, NULL, 'G3DSA:3.30.160.60:FF:003020', NULL, NULL, 'Zinc finger protein 674', NULL, NULL, NULL, NULL, NULL, 4),
(94524, NULL, 'G3DSA:3.30.62.10:FF:000001', NULL, NULL, 'Protein Nef', NULL, NULL, NULL, NULL, NULL, 4),
(94525, NULL, 'G3DSA:2.40.10.10:FF:000276', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94526, NULL, 'G3DSA:2.170.180.11:FF:000005', NULL, NULL, 'Methuselah-like 1, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(94527, NULL, 'G3DSA:1.10.533.10:FF:000203', NULL, NULL, 'CARD15', NULL, NULL, NULL, NULL, NULL, 4),
(94528, NULL, 'G3DSA:3.30.160.60:FF:001598', NULL, NULL, 'Zinc finger protein 467', NULL, NULL, NULL, NULL, NULL, 4),
(94529, NULL, 'G3DSA:3.10.50.40:FF:000045', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(94530, NULL, 'G3DSA:3.40.50.1110:FF:000059', NULL, NULL, 'SGNH hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(94531, NULL, 'G3DSA:3.30.559.30:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94532, NULL, 'G3DSA:1.20.120.1050:FF:000003', NULL, NULL, 'Nucleoporin NUP170, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94533, NULL, 'G3DSA:3.40.50.1820:FF:001143', NULL, NULL, 'AGAP011681-PA', NULL, NULL, NULL, NULL, NULL, 4),
(94534, NULL, 'G3DSA:3.90.190.10:FF:000279', NULL, NULL, 'Serine/threonine/tyrosine interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(94535, NULL, 'G3DSA:3.40.50.1100:FF:000056', NULL, NULL, 'Threonine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(94536, NULL, 'G3DSA:3.30.40.10:FF:000130', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM23', NULL, NULL, NULL, NULL, NULL, 4),
(94537, NULL, 'G3DSA:3.80.10.10:FF:001205', NULL, NULL, 'serine/threonine-protein kinase 11-interacting protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(94538, NULL, 'G3DSA:3.30.160.60:FF:000272', NULL, NULL, 'Zinc finger protein 827', NULL, NULL, NULL, NULL, NULL, 4),
(94539, NULL, 'G3DSA:1.10.3420.10:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94540, NULL, 'G3DSA:1.20.120.1070:FF:000009', NULL, NULL, 'Translation initiation factor eIF-2B alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94541, NULL, 'G3DSA:3.60.21.10:FF:000422', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(94542, NULL, 'G3DSA:1.20.58.390:FF:000052', NULL, NULL, 'Cholinergic receptor nicotinic alpha 1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(94543, NULL, 'G3DSA:2.60.120.10:FF:000156', NULL, NULL, 'cAMP-dependent protein kinase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(94544, NULL, 'G3DSA:1.25.40.10:FF:001715', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(94545, NULL, 'G3DSA:3.30.160.60:FF:004324', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(94546, NULL, 'G3DSA:1.10.510.10:FF:003944', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94547, NULL, 'G3DSA:3.20.20.80:FF:000774', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(94548, NULL, 'G3DSA:1.10.730.10:FF:000150', NULL, NULL, 'Valyl tRNA Synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(94549, NULL, 'G3DSA:3.90.1410.10:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94550, NULL, 'G3DSA:2.60.40.1170:FF:000033', NULL, NULL, 'stonin-2 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(94551, NULL, 'G3DSA:3.40.50.1820:FF:000957', NULL, NULL, 'Alpha/beta hydrolase fold protein', NULL, NULL, NULL, NULL, NULL, 4),
(94552, NULL, 'G3DSA:1.10.238.10:FF:000045', NULL, NULL, 'Nucleobindin 2', NULL, NULL, NULL, NULL, NULL, 4),
(94553, NULL, 'G3DSA:1.25.40.10:FF:004121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94554, NULL, 'G3DSA:1.10.8.480:FF:000014', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(94555, NULL, 'G3DSA:2.120.10.30:FF:000334', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94556, NULL, 'G3DSA:2.40.30.170:FF:000002', NULL, NULL, 'p-hydroxybenzoic acid efflux pump subunit AaeA', NULL, NULL, NULL, NULL, NULL, 4),
(94557, NULL, 'G3DSA:3.40.630.10:FF:000341', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94558, NULL, 'G3DSA:3.20.20.70:FF:000771', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94559, NULL, 'G3DSA:3.30.160.60:FF:005869', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94560, NULL, 'G3DSA:3.90.1480.20:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94561, NULL, 'G3DSA:1.20.1630.10:FF:000004', NULL, NULL, 'Polysulphide reductase NrfD', NULL, NULL, NULL, NULL, NULL, 4),
(94562, NULL, 'G3DSA:3.40.30.10:FF:000253', NULL, NULL, 'Peroxiredoxin 2', NULL, NULL, NULL, NULL, NULL, 4),
(94563, NULL, 'G3DSA:3.40.120.10:FF:000016', NULL, NULL, 'Glucose 1,6-bisphosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(94564, NULL, 'G3DSA:4.10.410.10:FF:000069', NULL, NULL, 'Collagen, type VII, alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(94565, NULL, 'G3DSA:1.20.58.570:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94566, NULL, 'G3DSA:2.40.160.210:FF:000005', NULL, NULL, 'Acyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(94567, NULL, 'G3DSA:3.40.50.2000:FF:001068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94568, NULL, 'G3DSA:1.10.238.20:FF:000048', NULL, NULL, 'Odorant-binding protein 47a, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(94569, NULL, 'G3DSA:2.130.10.10:FF:002076', NULL, NULL, 'WGS project CABT00000000 data, contig 2.8', NULL, NULL, NULL, NULL, NULL, 4),
(94570, NULL, 'G3DSA:2.60.40.1180:FF:000036', NULL, NULL, 'Probable alpha-L-arabinofuranosidase A', NULL, NULL, NULL, NULL, NULL, 4),
(94571, NULL, 'G3DSA:3.30.160.60:FF:003397', NULL, NULL, 'GD20620', NULL, NULL, NULL, NULL, NULL, 4),
(94572, NULL, 'G3DSA:1.10.510.10:FF:003489', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94573, NULL, 'G3DSA:2.40.30.180:FF:000005', NULL, NULL, 'Ubiquitin-activating enzyme e1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94574, NULL, 'G3DSA:1.10.10.440:FF:000034', NULL, NULL, 'Formin binding protein (FNB3)', NULL, NULL, NULL, NULL, NULL, 4),
(94575, NULL, 'G3DSA:2.130.10.10:FF:000401', NULL, NULL, 'Cilia- and flagella-associated protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(94576, NULL, 'G3DSA:2.60.40.150:FF:000308', NULL, NULL, 'CRE-SNT-4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(94577, NULL, 'G3DSA:1.10.132.50:FF:000002', NULL, NULL, 'V-type proton ATPase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(94578, NULL, 'G3DSA:1.20.120.230:FF:000020', NULL, NULL, 'Catenin alpha', NULL, NULL, NULL, NULL, NULL, 4),
(94579, NULL, 'G3DSA:1.10.1420.10:FF:000092', NULL, NULL, 'DNA mismatch repair protein MSH2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94580, NULL, 'G3DSA:1.25.10.10:FF:002039', NULL, NULL, 'eIF-2-alpha kinase activator GCN1', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(94581, NULL, 'G3DSA:3.30.60.20:FF:000151', NULL, NULL, 'Ankyrin repeat-containing protein kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(94582, NULL, 'G3DSA:1.20.58.530:FF:000021', NULL, NULL, 'Myosin E, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94583, NULL, 'G3DSA:1.10.418.60:FF:000001', NULL, NULL, 'NDC80 kinetochore complex component NUF2', NULL, NULL, NULL, NULL, NULL, 4),
(94584, NULL, 'G3DSA:4.10.60.10:FF:000017', NULL, NULL, 'zinc finger CCHC domain-containing protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(94585, NULL, 'G3DSA:3.40.50.1010:FF:000164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94586, NULL, 'G3DSA:3.30.2410.10:FF:000057', NULL, NULL, 'Neural precursor cell expressed, developmentally down-regulated 4-like, E3 ubiquitin protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(94587, NULL, 'G3DSA:3.30.60.30:FF:000154', NULL, NULL, 'Serine-type endopeptidase inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(94588, NULL, 'G3DSA:2.60.120.380:FF:000038', NULL, NULL, 'Serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(94589, NULL, 'G3DSA:3.90.1140.10:FF:000050', NULL, NULL, 'U6 snRNA phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(94590, NULL, 'G3DSA:1.20.5.820:FF:000001', NULL, NULL, 'Transport protein Sec61 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(94591, NULL, 'G3DSA:2.60.40.10:FF:002222', NULL, NULL, 'KETtiN (Drosophila actin-binding) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(94592, NULL, 'G3DSA:1.10.1620.20:FF:000003', NULL, NULL, 'Mitochondrial ATP synthase epsilon chain domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(94593, NULL, 'G3DSA:1.20.58.670:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94594, NULL, 'G3DSA:1.10.287.500:FF:000002', NULL, NULL, 'Protein phosphatase CheZ', NULL, NULL, NULL, NULL, NULL, 4),
(94595, NULL, 'G3DSA:3.40.50.1000:FF:000161', NULL, NULL, 'Trehalose 6-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(94596, NULL, 'G3DSA:3.40.630.30:FF:000347', NULL, NULL, 'N-acetyltransferase aca1', NULL, NULL, NULL, NULL, NULL, 4),
(94597, NULL, 'G3DSA:3.40.50.720:FF:002388', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94598, NULL, 'G3DSA:1.10.506.10:FF:000056', NULL, NULL, 'Probable Ras GTPase-activating-like protein ngap', NULL, NULL, NULL, NULL, NULL, 4),
(94599, NULL, 'G3DSA:2.130.10.10:FF:002531', NULL, NULL, 'WD repeat-containing protein 90', NULL, NULL, NULL, NULL, NULL, 4),
(94600, NULL, 'G3DSA:3.40.50.300:FF:002930', NULL, NULL, 'ABC transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(94601, NULL, 'G3DSA:2.30.42.10:FF:000024', NULL, NULL, 'rap guanine nucleotide exchange factor 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(94602, NULL, 'G3DSA:1.20.58.1120:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94603, NULL, 'G3DSA:3.10.20.90:FF:000316', NULL, NULL, 'ubiquitin carboxyl-terminal hydrolase 7', NULL, NULL, NULL, NULL, NULL, 4),
(94604, NULL, 'G3DSA:1.10.8.870:FF:000024', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(94605, NULL, 'G3DSA:2.30.29.30:FF:000769', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94606, NULL, 'G3DSA:1.10.510.10:FF:004130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94607, NULL, 'G3DSA:1.10.730.10:FF:000060', NULL, NULL, 'Leucyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(94608, NULL, 'G3DSA:1.20.1070.10:FF:000596', NULL, NULL, 'Protein CBG18476', NULL, NULL, NULL, NULL, NULL, 4),
(94609, NULL, 'G3DSA:3.40.30.10:FF:000472', NULL, NULL, 'Protein CBG04233', NULL, NULL, NULL, NULL, NULL, 4),
(94610, NULL, 'G3DSA:1.10.287.690:FF:000002', NULL, NULL, 'DNA polymerase zeta', NULL, NULL, NULL, NULL, NULL, 4),
(94611, NULL, 'G3DSA:3.30.565.10:FF:000130', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(94612, NULL, 'G3DSA:2.130.10.10:FF:003925', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94613, NULL, 'G3DSA:3.40.30.10:FF:000814', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(94614, NULL, 'G3DSA:1.20.58.80:FF:000073', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(94615, NULL, 'G3DSA:1.25.10.10:FF:000331', NULL, NULL, 'Phosphoprotein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94616, NULL, 'G3DSA:1.10.3720.10:FF:000042', NULL, NULL, 'sn-glycerol-3-phosphate transport system permease protein UgpE', NULL, NULL, NULL, NULL, NULL, 4),
(94617, NULL, 'G3DSA:1.10.238.10:FF:000135', NULL, NULL, 'RAS guanyl-releasing protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(94618, NULL, 'G3DSA:3.40.50.300:FF:006308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94619, NULL, 'G3DSA:2.40.20.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94620, NULL, 'G3DSA:3.30.420.40:FF:000319', NULL, NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(94621, NULL, 'G3DSA:3.30.505.10:FF:000154', NULL, NULL, 'E3 ubiquitin-protein ligase CBL', NULL, NULL, NULL, NULL, NULL, 4),
(94622, NULL, 'G3DSA:4.10.400.10:FF:000333', NULL, NULL, 'Vitellogenin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(94623, NULL, 'G3DSA:3.40.50.10610:FF:000007', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(94624, NULL, 'G3DSA:3.40.1010.10:FF:000013', NULL, NULL, 'Uroporphyrinogen-III synthase /uroporphyrinogen-III C-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(94625, NULL, 'G3DSA:2.20.70.10:FF:000022', NULL, NULL, 'Rho GTPase activating protein 39', NULL, NULL, NULL, NULL, NULL, 4),
(94626, NULL, 'G3DSA:3.30.40.10:FF:000849', NULL, NULL, 'Pep7p', NULL, NULL, NULL, NULL, NULL, 4),
(94627, NULL, 'G3DSA:2.40.50.150:FF:000028', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(94628, NULL, 'G3DSA:3.30.160.60:FF:004015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94629, NULL, 'G3DSA:2.130.10.10:FF:002840', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94630, NULL, 'G3DSA:2.40.160.20:FF:000019', NULL, NULL, 'Outer membrane porin F', NULL, NULL, NULL, NULL, NULL, 4),
(94631, NULL, 'G3DSA:3.40.50.300:FF:008220', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(94632, NULL, 'G3DSA:3.50.50.60:FF:000010', NULL, NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', NULL, NULL, NULL, NULL, NULL, 4),
(94633, NULL, 'G3DSA:3.60.21.10:FF:000080', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(94634, NULL, 'G3DSA:3.40.50.300:FF:002565', NULL, NULL, 'Cysteine ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(94635, NULL, 'G3DSA:2.40.30.10:FF:000165', NULL, NULL, 'Elongation factor 1 alpha-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(94636, NULL, 'G3DSA:3.40.50.1000:FF:000722', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94637, NULL, 'G3DSA:1.10.357.20:FF:000009', NULL, NULL, 'Magnesium transporter MgtE', NULL, NULL, NULL, NULL, NULL, 4),
(94638, NULL, 'G3DSA:3.40.50.880:FF:000120', NULL, NULL, '4-methyl-5(B-hydroxyethyl)-thiazole monophosphate biosynthesis enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(94639, NULL, 'G3DSA:1.20.1310.20:FF:000045', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(94640, NULL, 'G3DSA:1.25.10.10:FF:000022', NULL, NULL, 'protein EXPORTIN 1A', NULL, NULL, NULL, NULL, NULL, 4),
(94641, NULL, 'G3DSA:3.40.50.300:FF:008310', NULL, NULL, 'Nuclear GTPase, germinal center-associated, tandem duplicate 1', NULL, NULL, NULL, NULL, NULL, 4),
(94642, NULL, 'G3DSA:2.60.200.20:FF:000165', NULL, NULL, 'FHA domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94643, NULL, 'G3DSA:3.10.100.10:FF:000263', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94644, NULL, 'G3DSA:3.90.1750.10:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94645, NULL, 'G3DSA:1.10.560.10:FF:000024', NULL, NULL, 'T-complex protein 1 subunit delta', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(94646, NULL, 'G3DSA:3.30.70.1230:FF:000069', NULL, NULL, 'Adenylyl CYclase', NULL, NULL, NULL, NULL, NULL, 4),
(94647, NULL, 'G3DSA:3.90.190.10:FF:000189', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(94648, NULL, 'G3DSA:3.90.79.10:FF:000003', NULL, NULL, 'M7GpppN-mRNA hydrolase isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(94649, NULL, 'G3DSA:3.50.50.100:FF:000007', NULL, NULL, 'Rotenone-insensitive NADH-ubiquinone oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(94650, NULL, 'G3DSA:2.30.30.30:FF:000132', NULL, NULL, 'Ribosomal protein L2', NULL, NULL, NULL, NULL, NULL, 4),
(94651, NULL, 'G3DSA:3.40.50.300:FF:006275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94652, NULL, 'G3DSA:4.10.60.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94653, NULL, 'G3DSA:2.40.30.10:FF:000075', NULL, NULL, 'Translation initiation factor 2 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(94654, NULL, 'G3DSA:3.30.70.330:FF:001086', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(94655, NULL, 'G3DSA:1.20.58.70:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94656, NULL, 'G3DSA:3.60.21.10:FF:000332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94657, NULL, 'G3DSA:1.25.40.20:FF:000072', NULL, NULL, 'Ankyrin repeat and LEM domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(94658, NULL, 'G3DSA:3.30.360.10:FF:000070', NULL, NULL, 'Oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94659, NULL, 'G3DSA:3.40.50.300:FF:006617', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94660, NULL, 'G3DSA:2.60.40.1860:FF:000009', NULL, NULL, 'Peptidylarginine deiminase type I', NULL, NULL, NULL, NULL, NULL, 4),
(94661, NULL, 'G3DSA:1.20.1270.50:FF:000016', NULL, NULL, 'Lysosomal alpha-mannosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94662, NULL, 'G3DSA:1.20.58.390:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94663, NULL, 'G3DSA:3.30.1120.10:FF:000063', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(94664, NULL, 'G3DSA:1.20.1070.10:FF:001214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94665, NULL, 'G3DSA:3.40.50.1820:FF:000980', NULL, NULL, 'Protein ABHD11', NULL, NULL, NULL, NULL, NULL, 4),
(94666, NULL, 'G3DSA:1.20.1070.10:FF:001523', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94667, NULL, 'G3DSA:2.60.40.4070:FF:000010', NULL, NULL, 'Basal-body rod modification protein FlgD', NULL, NULL, NULL, NULL, NULL, 4),
(94668, NULL, 'G3DSA:2.30.30.40:FF:000135', NULL, NULL, '55 kDa erythrocyte membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(94669, NULL, 'G3DSA:2.60.40.150:FF:000527', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94670, NULL, 'G3DSA:1.10.540.10:FF:000135', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(94671, NULL, 'G3DSA:3.10.129.10:FF:000020', NULL, NULL, 'Acyl-coenzyme A thioesterase 11', NULL, NULL, NULL, NULL, NULL, 4),
(94672, NULL, 'G3DSA:3.40.30.10:FF:000781', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(94673, NULL, 'G3DSA:1.20.1310.10:FF:000042', NULL, NULL, 'Putative cullin-1', NULL, NULL, NULL, NULL, NULL, 4),
(94674, NULL, 'G3DSA:2.40.50.140:FF:000115', NULL, NULL, '28S ribosomal protein S12, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(94675, NULL, 'G3DSA:1.25.40.20:FF:000381', NULL, NULL, 'KiDINs220 (Vertebrate scaffold protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(94676, NULL, 'G3DSA:3.30.70.330:FF:001338', NULL, NULL, 'RNA binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(94677, NULL, 'G3DSA:1.10.510.10:FF:002095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94678, NULL, 'G3DSA:2.120.10.80:FF:000231', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(94679, NULL, 'G3DSA:3.30.160.60:FF:002205', NULL, NULL, 'Zinc finger transcription factor YY1', NULL, NULL, NULL, NULL, NULL, 4),
(94680, NULL, 'G3DSA:3.40.50.300:FF:007927', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94681, NULL, 'G3DSA:3.40.50.12650:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94682, NULL, 'G3DSA:1.10.10.60:FF:000148', NULL, NULL, 'Dek, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(94683, NULL, 'G3DSA:3.30.160.60:FF:004329', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94684, NULL, 'G3DSA:3.30.200.20:FF:001758', NULL, NULL, 'RIKEN cDNA E030030I06 gene', NULL, NULL, NULL, NULL, NULL, 4),
(94685, NULL, 'G3DSA:3.30.40.10:FF:001445', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94686, NULL, 'G3DSA:1.10.510.10:FF:002084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94687, NULL, 'G3DSA:3.20.20.70:FF:000557', NULL, NULL, 'Glycolate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(94688, NULL, 'G3DSA:1.25.40.20:FF:000291', NULL, NULL, 'APSES transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94689, NULL, 'G3DSA:3.80.10.10:FF:003318', NULL, NULL, 'Toll-like receptor 20, tandem duplicate 2', NULL, NULL, NULL, NULL, NULL, 4),
(94690, NULL, 'G3DSA:3.40.50.2300:FF:001517', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94691, NULL, 'G3DSA:3.20.20.210:FF:000024', NULL, NULL, 'Os03g0340001 protein', NULL, NULL, NULL, NULL, NULL, 4),
(94692, NULL, 'G3DSA:1.10.167.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94693, NULL, 'G3DSA:3.40.50.300:FF:008433', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94694, NULL, 'G3DSA:3.30.1120.10:FF:000068', NULL, NULL, 'Arylsulfatase I-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(94695, NULL, 'G3DSA:1.20.1250.20:FF:001630', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94696, NULL, 'G3DSA:3.30.420.610:FF:000013', NULL, NULL, 'Putative endonuclease or glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(94697, NULL, 'G3DSA:3.20.20.220:FF:000027', NULL, NULL, 'Proline dehydrogenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(94698, NULL, 'G3DSA:3.40.30.90:FF:000001', NULL, NULL, 'Eukaryotic translation elongation factor 1 epsilon-1', NULL, NULL, NULL, NULL, NULL, 4),
(94699, NULL, 'G3DSA:1.10.8.10:FF:000088', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(94700, NULL, 'G3DSA:2.70.170.10:FF:000027', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(94701, NULL, 'G3DSA:3.90.550.10:FF:000144', NULL, NULL, 'Glycogenin 1', NULL, NULL, NULL, NULL, NULL, 4),
(94702, NULL, 'G3DSA:1.20.120.350:FF:000157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94703, NULL, 'G3DSA:3.40.50.300:FF:006404', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94704, NULL, 'G3DSA:1.50.40.10:FF:000095', NULL, NULL, 'Mitochondrial carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(94705, NULL, 'G3DSA:2.70.150.10:FF:000032', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(94706, NULL, 'G3DSA:3.30.530.20:FF:000007', NULL, NULL, 'Major pollen allergen Bet v 1-A', NULL, NULL, NULL, NULL, NULL, 4),
(94707, NULL, 'G3DSA:3.80.10.10:FF:001183', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(94708, NULL, 'G3DSA:1.25.40.10:FF:001917', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94709, NULL, 'G3DSA:2.40.30.130:FF:000024', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(94710, NULL, 'G3DSA:3.10.490.10:FF:000044', NULL, NULL, 'Gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(94711, NULL, 'G3DSA:3.40.50.300:FF:002026', NULL, NULL, 'DEAD-box helicase 51', NULL, NULL, NULL, NULL, NULL, 4),
(94712, NULL, 'G3DSA:1.10.510.10:FF:004219', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94713, NULL, 'G3DSA:1.10.238.10:FF:000034', NULL, NULL, 'Calmodulin', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(94714, NULL, 'G3DSA:3.30.160.60:FF:002194', NULL, NULL, 'STP1p Transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(94715, NULL, 'G3DSA:3.40.30.10:FF:000129', NULL, NULL, 'Chloride intracellular channel protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(94716, NULL, 'G3DSA:3.40.50.2000:FF:000011', NULL, NULL, 'Glycogen synthase', NULL, NULL, NULL, NULL, NULL, 4),
(94717, NULL, 'G3DSA:3.90.70.10:FF:000820', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94718, NULL, 'G3DSA:3.40.395.10:FF:000029', NULL, NULL, 'Clan CE, family C48, Ulp1-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(94719, NULL, 'G3DSA:3.40.50.300:FF:004055', NULL, NULL, 'E3 ubiquitin-protein ligase Mdm2', NULL, NULL, NULL, NULL, NULL, 4),
(94720, NULL, 'G3DSA:3.40.50.2300:FF:000320', NULL, NULL, 'Two-component response regulator:antitermination factor NasT', NULL, NULL, NULL, NULL, NULL, 4),
(94721, NULL, 'G3DSA:3.30.60.30:FF:000249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94722, NULL, 'G3DSA:3.50.50.60:FF:001319', NULL, NULL, 'Putatibe oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(94723, NULL, 'G3DSA:2.60.40.60:FF:000056', NULL, NULL, 'protocadherin-15 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(94724, NULL, 'G3DSA:1.20.1090.10:FF:000001', NULL, NULL, 'Aldehyde-alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(94725, NULL, 'G3DSA:2.30.30.140:FF:000198', NULL, NULL, 'RING finger protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(94726, NULL, 'G3DSA:3.30.497.10:FF:000100', NULL, NULL, 'Serpin peptidase inhibitor 4', NULL, NULL, NULL, NULL, NULL, 4),
(94727, NULL, 'G3DSA:3.30.160.60:FF:004234', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94728, NULL, 'G3DSA:1.25.40.20:FF:000386', NULL, NULL, 'Avo2p', NULL, NULL, NULL, NULL, NULL, 4),
(94729, NULL, 'G3DSA:1.25.10.10:FF:001983', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94730, NULL, 'G3DSA:3.40.350.10:FF:000050', NULL, NULL, 'Probable Xaa-Pro aminopeptidase pepP', NULL, NULL, NULL, NULL, NULL, 4),
(94731, NULL, 'G3DSA:3.40.50.10470:FF:000033', NULL, NULL, 'Translation initiation factor eIF-2B subunit alpha, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94732, NULL, 'G3DSA:2.40.50.1060:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(94733, NULL, 'G3DSA:2.20.25.90:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94734, NULL, 'G3DSA:3.40.1110.10:FF:000195', NULL, NULL, 'Metal cation transporter P-type ATPase CtpV', NULL, NULL, NULL, NULL, NULL, 4),
(94735, NULL, 'G3DSA:1.20.140.10:FF:000092', NULL, NULL, 'Acyl CoA DeHydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(94736, NULL, 'G3DSA:3.40.50.10310:FF:000013', NULL, NULL, 'Creatininase', NULL, NULL, NULL, NULL, NULL, 4),
(94737, NULL, 'G3DSA:3.40.50.300:FF:005792', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94738, NULL, 'G3DSA:2.60.40.10:FF:000518', NULL, NULL, 'Myosin-binding protein C, cardiac-type', NULL, NULL, NULL, NULL, NULL, 4),
(94739, NULL, 'G3DSA:2.30.31.10:FF:000016', NULL, NULL, 'Putative RNA polymerase II transcriptional coactivator', NULL, NULL, NULL, NULL, NULL, 4),
(94740, NULL, 'G3DSA:3.90.79.10:FF:000126', NULL, NULL, 'Nucleoside diphosphate-linked moiety X motif 8', NULL, NULL, NULL, NULL, NULL, 4),
(94741, NULL, 'G3DSA:3.40.470.10:FF:000008', NULL, NULL, 'Uracil-DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(94742, NULL, 'G3DSA:3.40.140.10:FF:000236', NULL, NULL, 'Lys-63-specific deubiquitinase BRCC36-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(94743, NULL, 'G3DSA:1.20.58.80:FF:000056', NULL, NULL, 'Spastin', NULL, NULL, NULL, NULL, NULL, 4),
(94744, NULL, 'G3DSA:2.20.70.10:FF:000112', NULL, NULL, 'Yorkie, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(94745, NULL, 'G3DSA:1.20.1070.10:FF:000798', NULL, NULL, 'Zg06', NULL, NULL, NULL, NULL, NULL, 4),
(94746, NULL, 'G3DSA:3.40.50.10330:FF:000019', NULL, NULL, 'NAD kinase 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(94747, NULL, 'G3DSA:2.60.40.10:FF:004801', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(94748, NULL, 'G3DSA:2.20.90.10:FF:000012', NULL, NULL, 'Vitellogenin 3, phosvitinless', NULL, NULL, NULL, NULL, NULL, 4),
(94749, NULL, 'G3DSA:1.20.1070.10:FF:001315', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94750, NULL, 'G3DSA:1.20.1600.10:FF:000047', NULL, NULL, 'Similar to AprF-putative outer membrane efflux protein or secreted alkaline phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(94751, NULL, 'G3DSA:2.170.150.80:FF:000034', NULL, NULL, 'Putative NAC domain transcription factor superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(94752, NULL, 'G3DSA:3.40.50.300:FF:005578', NULL, NULL, 'XPD (Xeroderma Pigmentosum complementation group D) related', NULL, NULL, NULL, NULL, NULL, 4),
(94753, NULL, 'G3DSA:3.40.50.150:FF:000710', NULL, NULL, 'N2,N2-dimethylguanosine tRNA methyltransferase,putative', NULL, NULL, NULL, NULL, NULL, 4),
(94754, NULL, 'G3DSA:3.30.70.670:FF:000001', NULL, NULL, 'Formimidoyltransferase cyclodeaminase', NULL, NULL, NULL, NULL, NULL, 4),
(94755, NULL, 'G3DSA:3.30.200.20:FF:001079', NULL, NULL, 'Serine/threonine protein kinase, STE20 family', NULL, NULL, NULL, NULL, NULL, 4),
(94756, NULL, 'G3DSA:2.130.10.10:FF:000159', NULL, NULL, 'Autophagy-related protein 16-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(94757, NULL, 'G3DSA:2.60.40.10:FF:000732', NULL, NULL, 'Interleukin 31 receptor A', NULL, NULL, NULL, NULL, NULL, 4),
(94758, NULL, 'G3DSA:3.40.50.1000:FF:000812', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94759, NULL, 'G3DSA:3.30.160.60:FF:002531', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(94760, NULL, 'G3DSA:1.10.30.10:FF:000045', NULL, NULL, 'Transcription factor A, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(94761, NULL, 'G3DSA:3.30.40.10:FF:001771', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94762, NULL, 'G3DSA:3.30.559.30:FF:000082', NULL, NULL, 'Bacitracin synthetase 1, BacA', NULL, NULL, NULL, NULL, NULL, 4),
(94763, NULL, 'G3DSA:2.130.10.10:FF:005286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94764, NULL, 'G3DSA:3.30.2170.10:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94765, NULL, 'G3DSA:1.10.510.10:FF:004124', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94766, NULL, 'G3DSA:1.10.555.10:FF:000265', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94767, NULL, 'G3DSA:1.10.150.250:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94768, NULL, 'G3DSA:2.80.10.50:FF:000269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94769, NULL, 'G3DSA:1.10.150.50:FF:000185', NULL, NULL, 'Caskin-1', NULL, NULL, NULL, NULL, NULL, 4),
(94770, NULL, 'G3DSA:2.60.40.10:FF:004122', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94771, NULL, 'G3DSA:1.10.510.10:FF:000734', NULL, NULL, 'Checkpoint protein kinase (SldA), putative', NULL, NULL, NULL, NULL, NULL, 4),
(94772, NULL, 'G3DSA:2.40.30.10:FF:000182', NULL, NULL, 'NADH-cytochrome b5 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(94773, NULL, 'G3DSA:3.30.1370.10:FF:000002', NULL, NULL, 'poly(RC)-binding protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(94774, NULL, 'G3DSA:1.20.58.970:FF:000001', NULL, NULL, 'Mite allergen Blo t 5', NULL, NULL, NULL, NULL, NULL, 4),
(94775, NULL, 'G3DSA:2.60.40.10:FF:003958', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94776, NULL, 'G3DSA:3.30.1370.30:FF:000008', NULL, NULL, 'Unplaced genomic scaffold supercont2.18, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(94777, NULL, 'G3DSA:2.60.40.630:FF:000020', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(94778, NULL, 'G3DSA:1.10.533.10:FF:000220', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(94779, NULL, 'G3DSA:2.160.10.10:FF:000130', NULL, NULL, 'UTP--glucose-1-phosphate uridylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(94780, NULL, 'G3DSA:2.60.120.40:FF:000013', NULL, NULL, 'CD40 ligand', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(94781, NULL, 'G3DSA:3.90.70.10:FF:000141', NULL, NULL, 'ubiquitin carboxyl-terminal hydrolase 32 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(94782, NULL, 'G3DSA:2.40.10.10:FF:000405', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94783, NULL, 'G3DSA:1.10.8.270:FF:000035', NULL, NULL, 'Cell cycle arrest protein BUB2', NULL, NULL, NULL, NULL, NULL, 4),
(94784, NULL, 'G3DSA:3.40.50.1820:FF:001704', NULL, NULL, 'Undecaprenyl pyrophosphate synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94785, NULL, 'G3DSA:3.20.20.80:FF:000791', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94786, NULL, 'G3DSA:3.30.70.330:FF:001327', NULL, NULL, 'Serine/arginine-rich SC35-like splicing factor SCL28', NULL, NULL, NULL, NULL, NULL, 4),
(94787, NULL, 'G3DSA:1.20.1250.20:FF:001293', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94788, NULL, 'G3DSA:1.20.1250.20:FF:000899', NULL, NULL, 'MFS transporter of unkown specificity', NULL, NULL, NULL, NULL, NULL, 4),
(94789, NULL, 'G3DSA:1.10.390.10:FF:000078', NULL, NULL, 'AT07704p', NULL, NULL, NULL, NULL, NULL, 4),
(94790, NULL, 'G3DSA:3.10.20.90:FF:000075', NULL, NULL, 'sorting nexin-27 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(94791, NULL, 'G3DSA:1.20.58.70:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94792, NULL, 'G3DSA:2.60.40.790:FF:000040', NULL, NULL, 'Calcyclin binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(94793, NULL, 'G3DSA:3.40.30.10:FF:000455', NULL, NULL, 'Glutathione S-transferase kappa 1', NULL, NULL, NULL, NULL, NULL, 4),
(94794, NULL, 'G3DSA:1.10.10.60:FF:000362', NULL, NULL, 'Chitin synthase 6', NULL, NULL, NULL, NULL, NULL, 4),
(94795, NULL, 'G3DSA:3.90.1410.10:FF:000150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94796, NULL, 'G3DSA:2.40.100.10:FF:000131', NULL, NULL, 'Peptidylprolyl isomerase (cyclophilin)-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(94797, NULL, 'G3DSA:1.10.287.110:FF:000317', NULL, NULL, 'DnaJ domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94798, NULL, 'G3DSA:3.10.290.10:FF:000063', NULL, NULL, 'Ribosomal protein S9', NULL, NULL, NULL, NULL, NULL, 4),
(94799, NULL, 'G3DSA:2.10.50.10:FF:000095', NULL, NULL, 'Ovarian TNF receptor', NULL, NULL, NULL, NULL, NULL, 4),
(94800, NULL, 'G3DSA:1.25.40.70:FF:000047', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', NULL, NULL, NULL, NULL, NULL, 4),
(94801, NULL, 'G3DSA:3.30.160.60:FF:000277', NULL, NULL, 'Zinc finger protein 48', NULL, NULL, NULL, NULL, NULL, 4),
(94802, NULL, 'G3DSA:3.40.30.10:FF:000808', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94803, NULL, 'G3DSA:1.20.120.1080:FF:000029', NULL, NULL, 'Probable pre-mRNA-splicing factor ATP-dependent RNA helicase DEAH4', NULL, NULL, NULL, NULL, NULL, 4),
(94804, NULL, 'G3DSA:3.60.40.10:FF:000359', NULL, NULL, 'Protein phosphatase, Mg2+/Mn2+-dependent 1J', NULL, NULL, NULL, NULL, NULL, 4),
(94805, NULL, 'G3DSA:2.40.70.10:FF:000302', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94806, NULL, 'G3DSA:1.25.40.10:FF:003834', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(94807, NULL, 'G3DSA:3.30.60.30:FF:000042', NULL, NULL, 'Serine protease inhibitor dipetalogastin', NULL, NULL, NULL, NULL, NULL, 4),
(94808, NULL, 'G3DSA:2.80.10.50:FF:000174', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(94809, NULL, 'G3DSA:2.80.10.50:FF:000062', NULL, NULL, 'Fibroblast growth factor 23', NULL, NULL, NULL, NULL, NULL, 4),
(94810, NULL, 'G3DSA:3.40.50.620:FF:000559', NULL, NULL, 'Putative nicotinamide mononucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(94811, NULL, 'G3DSA:2.60.120.10:FF:000807', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94812, NULL, 'G3DSA:1.25.40.10:FF:000057', NULL, NULL, 'RNA polymerase II associated protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(94813, NULL, 'G3DSA:2.60.40.3500:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(94814, NULL, 'G3DSA:2.30.29.30:FF:000758', NULL, NULL, 'E3 SUMO-protein ligase RanBP2-like', NULL, NULL, NULL, NULL, NULL, 4),
(94815, NULL, 'G3DSA:3.30.2310.20:FF:000013', NULL, NULL, 'Toxin', NULL, NULL, NULL, NULL, NULL, 4),
(94816, NULL, 'G3DSA:1.10.506.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94817, NULL, 'G3DSA:2.60.40.150:FF:000213', NULL, NULL, 'Phosphatidylinositol-4-phosphate 3-kinase catalytic subunit type 2 gamma', NULL, NULL, NULL, NULL, NULL, 4),
(94818, NULL, 'G3DSA:3.40.605.10:FF:000047', NULL, NULL, 'Aldehyde dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94819, NULL, 'G3DSA:1.10.20.10:FF:000117', NULL, NULL, 'Nuclear factor Y, subunit C13', NULL, NULL, NULL, NULL, NULL, 4),
(94820, NULL, 'G3DSA:3.15.20.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94821, NULL, 'G3DSA:3.30.9.10:FF:000294', NULL, NULL, 'D-amino acid oxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94822, NULL, 'G3DSA:2.60.40.150:FF:000325', NULL, NULL, 'synaptotagmin-17 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(94823, NULL, 'G3DSA:2.40.10.170:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94824, NULL, 'G3DSA:1.25.40.10:FF:002423', NULL, NULL, 'Os12g0109800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(94825, NULL, 'G3DSA:3.40.50.1820:FF:001025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94826, NULL, 'G3DSA:2.130.10.10:FF:002060', NULL, NULL, 'Protein CBG03993', NULL, NULL, NULL, NULL, NULL, 4),
(94827, NULL, 'G3DSA:3.10.105.10:FF:000038', NULL, NULL, 'Peptide/nickel transport system substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(94828, NULL, 'G3DSA:3.30.60.20:FF:000134', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(94829, NULL, 'G3DSA:1.10.287.70:FF:000457', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(94830, NULL, 'G3DSA:1.10.533.10:FF:000315', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94831, NULL, 'G3DSA:2.60.40.60:FF:000168', NULL, NULL, 'Cadherin-related family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(94832, NULL, 'G3DSA:2.40.50.100:FF:000025', NULL, NULL, 'UPF0194 membrane protein YbhG', NULL, NULL, NULL, NULL, NULL, 4),
(94833, NULL, 'G3DSA:3.30.160.60:FF:001688', NULL, NULL, 'Zgc:171727', NULL, NULL, NULL, NULL, NULL, 4),
(94834, NULL, 'G3DSA:3.30.60.30:FF:000137', NULL, NULL, 'Reversion-inducing cysteine-rich protein with Kazal motifs', NULL, NULL, NULL, NULL, NULL, 4),
(94835, NULL, 'G3DSA:1.10.290.10:FF:000014', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(94836, NULL, 'G3DSA:1.10.780.10:FF:000001', NULL, NULL, 'Hydroxylamine oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(94837, NULL, 'G3DSA:3.30.70.330:FF:000130', NULL, NULL, 'Differentiation 1 negative regulator', NULL, NULL, NULL, NULL, NULL, 4),
(94838, NULL, 'G3DSA:3.40.50.300:FF:006730', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94839, NULL, 'G3DSA:3.40.950.10:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94840, NULL, 'G3DSA:2.60.40.3510:FF:000016', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(94841, NULL, 'G3DSA:3.30.70.240:FF:000007', NULL, NULL, 'Translation factor GUF1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(94842, NULL, 'G3DSA:1.10.20.10:FF:000331', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94843, NULL, 'G3DSA:2.60.120.260:FF:000204', NULL, NULL, 'UvrB/uvrC motif family protein', NULL, NULL, NULL, NULL, NULL, 4),
(94844, NULL, 'G3DSA:1.20.1070.10:FF:001192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94845, NULL, 'G3DSA:3.90.70.10:FF:000606', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(94846, NULL, 'G3DSA:2.30.30.140:FF:000086', NULL, NULL, 'PHD finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(94847, NULL, 'G3DSA:1.10.510.10:FF:004450', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(94848, NULL, 'G3DSA:2.60.40.60:FF:000382', NULL, NULL, 'Cadherin 23', NULL, NULL, NULL, NULL, NULL, 4),
(94849, NULL, 'G3DSA:3.40.50.300:FF:002705', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(94850, NULL, 'G3DSA:3.40.1160.10:FF:000029', NULL, NULL, 'Glutamate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(94851, NULL, 'G3DSA:2.60.40.10:FF:000311', NULL, NULL, 'Down syndrome cell adhesion molecule, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(94852, NULL, 'G3DSA:3.40.50.1100:FF:000180', NULL, NULL, 'Putative cysteine synthase A CysK2', NULL, NULL, NULL, NULL, NULL, 4),
(94853, NULL, 'G3DSA:3.40.50.720:FF:001174', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(P)+]', NULL, NULL, NULL, NULL, NULL, 4),
(94854, NULL, 'G3DSA:1.25.10.10:FF:002242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94855, NULL, 'G3DSA:2.130.10.10:FF:003936', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94856, NULL, 'G3DSA:3.40.630.10:FF:000111', NULL, NULL, 'Probable M18 family aminopeptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(94857, NULL, 'G3DSA:1.20.920.10:FF:000067', NULL, NULL, 'Transcription initiation factor TFIID subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(94858, NULL, 'G3DSA:3.40.50.300:FF:008107', NULL, NULL, 'Dicer-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94859, NULL, 'G3DSA:2.40.50.140:FF:000008', NULL, NULL, '30S ribosomal protein S12, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(94860, NULL, 'G3DSA:3.30.70.2970:FF:000006', NULL, NULL, 'interleukin-1 receptor-associated kinase 1-binding protein 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(94861, NULL, 'G3DSA:3.30.420.10:FF:000356', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94862, NULL, 'G3DSA:2.40.160.120:FF:000057', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(94863, NULL, 'G3DSA:1.20.1250.20:FF:001304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94864, NULL, 'G3DSA:2.40.10.10:FF:000310', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94865, NULL, 'G3DSA:1.25.10.10:FF:000460', NULL, NULL, 'Armadillo repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(94866, NULL, 'G3DSA:2.60.40.10:FF:002082', NULL, NULL, 'PKHD1, fibrocystin/polyductin', NULL, NULL, NULL, NULL, NULL, 4),
(94867, NULL, 'G3DSA:1.10.238.10:FF:000360', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(94868, NULL, 'G3DSA:3.30.890.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94869, NULL, 'G3DSA:2.60.40.640:FF:000023', NULL, NULL, 'Vacuolar protein sorting-associated protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(94870, NULL, 'G3DSA:2.10.25.10:FF:001183', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(94871, NULL, 'G3DSA:1.10.230.10:FF:000022', NULL, NULL, 'Os11g0623601 protein', NULL, NULL, NULL, NULL, NULL, 4),
(94872, NULL, 'G3DSA:2.60.120.10:FF:000712', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94873, NULL, 'G3DSA:3.30.110.110:FF:000006', NULL, NULL, 'Endo/exonuclease Mre11, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94874, NULL, 'G3DSA:3.40.50.150:FF:000822', NULL, NULL, 'Probable methyltransferase BMT2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(94875, NULL, 'G3DSA:3.30.160.60:FF:000182', NULL, NULL, 'zinc finger protein 366', NULL, NULL, NULL, NULL, NULL, 4),
(94876, NULL, 'G3DSA:2.70.170.10:FF:000241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94877, NULL, 'G3DSA:1.20.58.390:FF:000153', NULL, NULL, 'Acetylcholine receptor subunit alpha-type acr-7', NULL, NULL, NULL, NULL, NULL, 4),
(94878, NULL, 'G3DSA:3.80.10.10:FF:001520', NULL, NULL, 'Leucine-rich repeat-containing 29', NULL, NULL, NULL, NULL, NULL, 4),
(94879, NULL, 'G3DSA:2.60.40.150:FF:000651', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94880, NULL, 'G3DSA:3.40.50.2300:FF:001629', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94881, NULL, 'G3DSA:3.40.50.10140:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(94882, NULL, 'G3DSA:2.40.290.10:FF:000009', NULL, NULL, 'ATP-dependent DNA helicase II subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(94883, NULL, 'G3DSA:1.20.140.40:FF:000072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94884, NULL, 'G3DSA:2.130.10.10:FF:003599', NULL, NULL, 'Related to yeast Vacuolar Protein Sorting factor', NULL, NULL, NULL, NULL, NULL, 4),
(94885, NULL, 'G3DSA:3.40.50.300:FF:008321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94886, NULL, 'G3DSA:3.40.50.10130:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94887, NULL, 'G3DSA:1.10.533.10:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94888, NULL, 'G3DSA:3.30.70.1470:FF:000006', NULL, NULL, 'cell death protein 3-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(94889, NULL, 'G3DSA:3.30.160.60:FF:002317', NULL, NULL, 'Zgc:174696 protein', NULL, NULL, NULL, NULL, NULL, 4),
(94890, NULL, 'G3DSA:3.30.160.60:FF:004217', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94891, NULL, 'G3DSA:1.25.40.10:FF:002070', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(94892, NULL, 'G3DSA:3.80.10.10:FF:003206', NULL, NULL, 'Reticulon 4 receptor like 1', NULL, NULL, NULL, NULL, NULL, 4),
(94893, NULL, 'G3DSA:3.40.50.300:FF:004038', NULL, NULL, 'DNA replication ATP-dependent helicase/nuclease DNA2', NULL, NULL, NULL, NULL, NULL, 4),
(94894, NULL, 'G3DSA:3.40.50.150:FF:000143', NULL, NULL, 'DNA (cytosine-5)-methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(94895, NULL, 'G3DSA:1.10.10.60:FF:000811', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94896, NULL, 'G3DSA:1.25.40.20:FF:001797', NULL, NULL, 'Ankyrin and IPT/TIG repeat-containing protein C26H5.05', NULL, NULL, NULL, NULL, NULL, 4),
(94897, NULL, 'G3DSA:1.25.40.10:FF:001794', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g20230', NULL, NULL, NULL, NULL, NULL, 4),
(94898, NULL, 'G3DSA:3.40.50.2060:FF:000001', NULL, NULL, 'syntaxin-binding protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(94899, NULL, 'G3DSA:3.30.40.10:FF:001333', NULL, NULL, 'HRT1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(94900, NULL, 'G3DSA:3.10.120.10:FF:000051', NULL, NULL, 'Cytochrome b5 reductase 4', NULL, NULL, NULL, NULL, NULL, 4),
(94901, NULL, 'G3DSA:1.10.510.10:FF:004096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94902, NULL, 'G3DSA:1.10.220.10:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94903, NULL, 'G3DSA:3.40.50.300:FF:006516', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(94904, NULL, 'G3DSA:3.40.50.300:FF:000109', NULL, NULL, 'Peroxisomal biogenesis factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(94905, NULL, 'G3DSA:3.40.50.720:FF:001527', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94906, NULL, 'G3DSA:2.60.120.10:FF:000263', NULL, NULL, 'Transcription regulator, CRP family', NULL, NULL, NULL, NULL, NULL, 4),
(94907, NULL, 'G3DSA:2.170.270.10:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94908, NULL, 'G3DSA:1.10.530.10:FF:000067', NULL, NULL, 'Acidic endochitinase WIN6.2B', NULL, NULL, NULL, NULL, NULL, 4),
(94909, NULL, 'G3DSA:3.50.30.30:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94910, NULL, 'G3DSA:1.10.8.1290:FF:000002', NULL, NULL, 'Glutamine--tRNA ligase cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(94911, NULL, 'G3DSA:3.90.1290.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94912, NULL, 'G3DSA:2.70.150.10:FF:000144', NULL, NULL, 'Copper transporter, ATP dependent', NULL, NULL, NULL, NULL, NULL, 4),
(94913, NULL, 'G3DSA:3.40.50.720:FF:001191', NULL, NULL, 'Os01g0828100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(94914, NULL, 'G3DSA:3.30.200.20:FF:000123', NULL, NULL, 'serine/threonine-protein kinase PRP4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(94915, NULL, 'G3DSA:3.50.4.10:FF:000007', NULL, NULL, 'No-mechanoreceptor potential a', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(94916, NULL, 'G3DSA:3.40.1110.10:FF:000318', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94917, NULL, 'G3DSA:1.20.1300.10:FF:000002', NULL, NULL, 'Fumarate reductase subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(94918, NULL, 'G3DSA:2.20.25.420:FF:000004', NULL, NULL, 'Zinc finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94919, NULL, 'G3DSA:3.40.50.150:FF:000373', NULL, NULL, 'Demethylmenaquinone methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(94920, NULL, 'G3DSA:3.40.50.300:FF:002138', NULL, NULL, 'Putative dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(94921, NULL, 'G3DSA:1.10.630.10:FF:000569', NULL, NULL, 'Cytochrome P450 3A12', NULL, NULL, NULL, NULL, NULL, 4),
(94922, NULL, 'G3DSA:3.20.20.370:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94923, NULL, 'G3DSA:3.90.550.50:FF:000127', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(94924, NULL, 'G3DSA:3.80.10.10:FF:001071', NULL, NULL, 'volume-regulated anion channel subunit LRRC8E', NULL, NULL, NULL, NULL, NULL, 4),
(94925, NULL, 'G3DSA:2.40.20.10:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94926, NULL, 'G3DSA:1.10.418.10:FF:000020', NULL, NULL, 'Cytospin-A isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(94927, NULL, 'G3DSA:3.40.50.12550:FF:000016', NULL, NULL, 'ThiF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(94928, NULL, 'G3DSA:3.50.50.100:FF:000002', NULL, NULL, 'External alternative NAD(P)H-ubiquinone oxidoreductase B1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(94929, NULL, 'G3DSA:3.30.2130.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94930, NULL, 'G3DSA:1.10.287.110:FF:000194', NULL, NULL, 'Putative DNAJ domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(94931, NULL, 'G3DSA:1.10.580.10:FF:000019', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(94932, NULL, 'G3DSA:3.10.450.10:FF:000047', NULL, NULL, 'AGAP002879-PA', NULL, NULL, NULL, NULL, NULL, 4),
(94933, NULL, 'G3DSA:3.40.1050.10:FF:000026', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(94934, NULL, 'G3DSA:3.40.50.11720:FF:000003', NULL, NULL, '3-deoxy-D-manno-octulosonic acid transferase', NULL, NULL, NULL, NULL, NULL, 4),
(94935, NULL, 'G3DSA:2.40.30.10:FF:000305', NULL, NULL, 'Mitochondrial 54S ribosomal protein YmL9', NULL, NULL, NULL, NULL, NULL, 4),
(94936, NULL, 'G3DSA:3.40.50.300:FF:006067', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(94937, NULL, 'G3DSA:1.20.5.520:FF:000001', NULL, NULL, 'Thymosin beta', NULL, NULL, NULL, NULL, NULL, 4),
(94938, NULL, 'G3DSA:3.20.20.210:FF:000007', NULL, NULL, 'Uroporphyrinogen decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(94939, NULL, 'G3DSA:3.10.20.30:FF:000085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94940, NULL, 'G3DSA:1.20.5.540:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94941, NULL, 'G3DSA:1.10.260.40:FF:000089', NULL, NULL, 'Homeodomain-containing DNA- binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94942, NULL, 'G3DSA:1.10.340.30:FF:000002', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(94943, NULL, 'G3DSA:1.10.10.10:FF:002062', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(94944, NULL, 'G3DSA:1.20.58.60:FF:000758', NULL, NULL, 'Smyhc1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(94945, NULL, 'G3DSA:2.40.160.20:FF:000008', NULL, NULL, 'Outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(94946, NULL, 'G3DSA:3.40.50.300:FF:008080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94947, NULL, 'G3DSA:3.30.450.40:FF:000164', NULL, NULL, 'GAF sensor signal transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(94948, NULL, 'G3DSA:3.10.580.10:FF:000147', NULL, NULL, 'Inorganic pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(94949, NULL, 'G3DSA:3.40.50.2020:FF:000129', NULL, NULL, 'Hypoxanthine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(94950, NULL, 'G3DSA:3.10.250.10:FF:000049', NULL, NULL, 'Lysyl oxidase homolog 3', NULL, NULL, NULL, NULL, NULL, 4),
(94951, NULL, 'G3DSA:3.30.160.60:FF:006016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94952, NULL, 'G3DSA:3.90.550.10:FF:000711', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94953, NULL, 'G3DSA:2.40.160.10:FF:000005', NULL, NULL, 'mitochondrial import receptor subunit TOM40 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(94954, NULL, 'G3DSA:1.10.340.40:FF:000005', NULL, NULL, 'mRNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(94955, NULL, 'G3DSA:2.60.40.60:FF:000270', NULL, NULL, 'protocadherin-7 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(94956, NULL, 'G3DSA:2.30.29.30:FF:001152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94957, NULL, 'G3DSA:3.40.50.300:FF:003875', NULL, NULL, 'ABC transporter-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(94958, NULL, 'G3DSA:1.10.274.30:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94959, NULL, 'G3DSA:3.10.110.10:FF:000123', NULL, NULL, 'Ubiquitin-conjugating enzyme e2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(94960, NULL, 'G3DSA:1.20.120.1760:FF:000019', NULL, NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(94961, NULL, 'G3DSA:3.30.300.20:FF:000075', NULL, NULL, 'Ribosome-binding factor A', NULL, NULL, NULL, NULL, NULL, 4),
(94962, NULL, 'G3DSA:3.30.70.2280:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94963, NULL, 'G3DSA:2.30.30.40:FF:000247', NULL, NULL, 'Rho-type guanine nucleotide exchange factor, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(94964, NULL, 'G3DSA:2.60.40.10:FF:002194', NULL, NULL, 'Sallimus, isoform P', NULL, NULL, NULL, NULL, NULL, 4),
(94965, NULL, 'G3DSA:2.60.210.10:FF:000011', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 7', NULL, NULL, NULL, NULL, NULL, 4),
(94966, NULL, 'G3DSA:1.10.238.10:FF:000472', NULL, NULL, 'Hypothetical_protein', NULL, NULL, NULL, NULL, NULL, 4),
(94967, NULL, 'G3DSA:3.40.50.800:FF:000057', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(94968, NULL, 'G3DSA:2.60.120.200:FF:000001', NULL, NULL, 'neurexin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(94969, NULL, 'G3DSA:1.25.40.10:FF:003508', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(94970, NULL, 'G3DSA:1.20.120.1750:FF:000016', NULL, NULL, 'E3 ubiquitin-protein ligase RNF216 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(94971, NULL, 'G3DSA:3.40.50.1440:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94972, NULL, 'G3DSA:2.60.40.200:FF:000026', NULL, NULL, 'Copper chaperone for superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(94973, NULL, 'G3DSA:1.20.1310.10:FF:000154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94974, NULL, 'G3DSA:3.80.10.10:FF:001632', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94975, NULL, 'G3DSA:2.130.10.10:FF:003369', NULL, NULL, 'Leucine rich repeat kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(94976, NULL, 'G3DSA:4.10.260.30:FF:000001', NULL, NULL, 'Apolipoprotein C-I', NULL, NULL, NULL, NULL, NULL, 4),
(94977, NULL, 'G3DSA:1.20.58.830:FF:000004', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(94978, NULL, 'G3DSA:1.10.4030.10:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94979, NULL, 'G3DSA:2.60.34.10:FF:000010', NULL, NULL, 'heat shock 70 kDa protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(94980, NULL, 'G3DSA:2.60.40.10:FF:000069', NULL, NULL, 'Alpha-protein kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(94981, NULL, 'G3DSA:2.30.30.40:FF:000040', NULL, NULL, 'kalirin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(94982, NULL, 'G3DSA:2.60.34.20:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94983, NULL, 'G3DSA:1.10.560.10:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(94984, NULL, 'G3DSA:3.30.160.20:FF:000086', NULL, NULL, 'double-stranded RNA-binding protein Staufen homolog 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(94985, NULL, 'G3DSA:3.30.390.10:FF:000015', NULL, NULL, 'Mandelate racemase', NULL, NULL, NULL, NULL, NULL, 4),
(94986, NULL, 'G3DSA:2.130.10.10:FF:002413', NULL, NULL, 'Related to SOF1-involved in 18S pre-rRNA production', NULL, NULL, NULL, NULL, NULL, 4),
(94987, NULL, 'G3DSA:1.10.3710.10:FF:000002', NULL, NULL, 'ATPase WRNIP1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(94988, NULL, 'G3DSA:1.25.10.10:FF:000443', NULL, NULL, 'Armadillo repeat-containing protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(94989, NULL, 'G3DSA:1.20.1250.20:FF:001063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94990, NULL, 'G3DSA:2.10.25.10:FF:001306', NULL, NULL, 'C-type LECtin', NULL, NULL, NULL, NULL, NULL, 4),
(94991, NULL, 'G3DSA:3.40.30.10:FF:000567', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94992, NULL, 'G3DSA:3.40.50.40:FF:000010', NULL, NULL, 'Cytoplasmic l-asparaginase i-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(94993, NULL, 'G3DSA:1.20.272.10:FF:000026', NULL, NULL, 'DNA polymerase III delta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(94994, NULL, 'G3DSA:3.40.190.10:FF:000301', NULL, NULL, 'Sulfate ABC transporter substrate-binding lipoprotein SubI', NULL, NULL, NULL, NULL, NULL, 4),
(94995, NULL, 'G3DSA:2.60.40.4370:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(94996, NULL, 'G3DSA:1.10.760.10:FF:000101', NULL, NULL, 'Cytochrome c-552 Ks_3358', NULL, NULL, NULL, NULL, NULL, 4),
(94997, NULL, 'G3DSA:2.60.120.260:FF:000221', NULL, NULL, 'Laminin-like protein epi-1', NULL, NULL, NULL, NULL, NULL, 4),
(94998, NULL, 'G3DSA:2.130.10.10:FF:003695', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(94999, NULL, 'G3DSA:1.10.20.10:FF:000090', NULL, NULL, 'DNA polymerase epsilon subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(95000, NULL, 'G3DSA:3.30.420.10:FF:000682', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95001, NULL, 'G3DSA:3.40.50.300:FF:002464', NULL, NULL, 'Putative SNF2 family helicase', NULL, NULL, NULL, NULL, NULL, 4),
(95002, NULL, 'G3DSA:3.40.20.10:FF:000078', NULL, NULL, 'Macrophage-capping protein', NULL, NULL, NULL, NULL, NULL, 4),
(95003, NULL, 'G3DSA:1.10.10.10:FF:000162', NULL, NULL, 'Regulator of G-protein signaling 6', NULL, NULL, NULL, NULL, NULL, 4),
(95004, NULL, 'G3DSA:2.60.40.790:FF:000152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95005, NULL, 'G3DSA:3.10.290.10:FF:000046', NULL, NULL, 'RNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(95006, NULL, 'G3DSA:2.60.40.60:FF:000505', NULL, NULL, 'cadherin EGF LAG seven-pass G-type receptor 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(95007, NULL, 'G3DSA:1.10.510.10:FF:002421', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95008, NULL, 'G3DSA:3.30.565.10:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95009, NULL, 'G3DSA:3.30.450.40:FF:000260', NULL, NULL, 'Probable IclR family regulator (Putative secreted protein)', NULL, NULL, NULL, NULL, NULL, 4),
(95010, NULL, 'G3DSA:1.10.510.10:FF:002651', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95011, NULL, 'G3DSA:2.130.10.10:FF:001924', NULL, NULL, 'guanine nucleotide-binding protein G(I)/G(S)/G(T) subunit beta-1-like', NULL, NULL, NULL, NULL, NULL, 4),
(95012, NULL, 'G3DSA:3.20.20.140:FF:000329', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95013, NULL, 'G3DSA:3.30.420.40:FF:000095', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(95014, NULL, 'G3DSA:3.90.70.10:FF:000253', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(95015, NULL, 'G3DSA:3.90.226.10:FF:000222', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(95016, NULL, 'G3DSA:1.25.40.10:FF:003946', NULL, NULL, 'Chitin synthase regulatory factor 1', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(95017, NULL, 'G3DSA:1.10.3720.10:FF:000154', NULL, NULL, 'Phosphate transport system permease protein PstA', NULL, NULL, NULL, NULL, NULL, 4),
(95018, NULL, 'G3DSA:3.40.1380.10:FF:000012', NULL, NULL, 'ATP synthase gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(95019, NULL, 'G3DSA:3.40.50.1100:FF:000303', NULL, NULL, 'Pyridoxal-5''-phosphate-dependent enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(95020, NULL, 'G3DSA:3.30.505.10:FF:000042', NULL, NULL, 'Cytokine-inducible SH2-containing protein b', NULL, NULL, NULL, NULL, NULL, 4),
(95021, NULL, 'G3DSA:1.25.10.10:FF:000230', NULL, NULL, 'Serine/threonine-protein kinase Nek10', NULL, NULL, NULL, NULL, NULL, 4),
(95022, NULL, 'G3DSA:1.10.238.10:FF:000601', NULL, NULL, 'Probable calcium-binding protein CML11', NULL, NULL, NULL, NULL, NULL, 4),
(95023, NULL, 'G3DSA:1.10.3080.10:FF:000043', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(95024, NULL, 'G3DSA:3.30.160.60:FF:000165', NULL, NULL, 'Zinc finger protein 34', NULL, NULL, NULL, NULL, NULL, 4),
(95025, NULL, 'G3DSA:2.30.40.10:FF:000099', NULL, NULL, 'Guanine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(95026, NULL, 'G3DSA:1.10.1280.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95027, NULL, 'G3DSA:3.50.50.60:FF:000122', NULL, NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(95028, NULL, 'G3DSA:1.10.287.110:FF:000290', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95029, NULL, 'G3DSA:3.40.140.10:FF:000253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95030, NULL, 'G3DSA:3.40.930.10:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95031, NULL, 'G3DSA:1.20.1280.50:FF:000056', NULL, NULL, 'F-box/LRR-repeat protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(95032, NULL, 'G3DSA:2.20.25.10:FF:000053', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(95033, NULL, 'G3DSA:2.130.10.10:FF:000822', NULL, NULL, '3-carboxy-cis,cis-muconate lactonizing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(95034, NULL, 'G3DSA:3.30.1680.10:FF:000003', NULL, NULL, 'semaphorin-5B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(95035, NULL, 'G3DSA:1.10.1420.10:FF:000013', NULL, NULL, 'mutS protein homolog 4', NULL, NULL, NULL, NULL, NULL, 4),
(95036, NULL, 'G3DSA:2.120.10.80:FF:000214', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(95037, NULL, 'G3DSA:3.80.10.10:FF:003223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95038, NULL, 'G3DSA:3.30.565.10:FF:000146', NULL, NULL, 'Oxygen sensor histidine kinase response regulator DevS/DosS', NULL, NULL, NULL, NULL, NULL, 4),
(95039, NULL, 'G3DSA:3.30.930.10:FF:000198', NULL, NULL, 'Threonine--tRNA ligase mitochondrial 1', NULL, NULL, NULL, NULL, NULL, 4),
(95040, NULL, 'G3DSA:2.40.100.10:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95041, NULL, 'G3DSA:2.60.40.150:FF:000090', NULL, NULL, 'C2 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(95042, NULL, 'G3DSA:2.40.10.10:FF:000068', NULL, NULL, 'transmembrane protease serine 2', NULL, NULL, NULL, NULL, NULL, 4),
(95043, NULL, 'G3DSA:3.40.50.1820:FF:001351', NULL, NULL, 'GPI inositol-deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(95044, NULL, 'G3DSA:1.10.400.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95045, NULL, 'G3DSA:2.130.10.10:FF:005853', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95046, NULL, 'G3DSA:2.60.40.10:FF:002323', NULL, NULL, 'CD96 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(95047, NULL, 'G3DSA:1.20.1070.10:FF:001641', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95048, NULL, 'G3DSA:1.20.1560.10:FF:000459', NULL, NULL, 'Transporter 2, ATP-binding cassette, sub-family B (MDR/TAP)', NULL, NULL, NULL, NULL, NULL, 4),
(95049, NULL, 'G3DSA:3.30.1330.20:FF:000008', NULL, NULL, 'Cell division protein FtsZ', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(95050, NULL, 'G3DSA:3.90.132.10:FF:000004', NULL, NULL, 'GP63-like', NULL, NULL, NULL, NULL, NULL, 4),
(95051, NULL, 'G3DSA:3.30.1330.10:FF:000005', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(95052, NULL, 'G3DSA:2.120.10.30:FF:000126', NULL, NULL, 'Senescence marker protein-30', NULL, NULL, NULL, NULL, NULL, 4),
(95053, NULL, 'G3DSA:2.60.40.10:FF:005757', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95054, NULL, 'G3DSA:1.10.10.60:FF:000250', NULL, NULL, 'Homeobox protein cut-like', NULL, NULL, NULL, NULL, NULL, 4),
(95055, NULL, 'G3DSA:3.30.70.330:FF:001765', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95056, NULL, 'G3DSA:3.30.365.10:FF:000047', NULL, NULL, 'Nicotinate dehydrogenase medium molybdopterin subunit', NULL, NULL, NULL, NULL, NULL, 4),
(95057, NULL, 'G3DSA:1.25.40.470:FF:000067', NULL, NULL, 'WD repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(95058, NULL, 'G3DSA:1.20.1250.20:FF:000787', NULL, NULL, 'Siderochrome-iron transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(95059, NULL, 'G3DSA:3.10.20.90:FF:001013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95060, NULL, 'G3DSA:1.50.40.10:FF:000336', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95061, NULL, 'G3DSA:1.20.5.340:FF:000054', NULL, NULL, 'Probable TUP1-general transcription repressor', NULL, NULL, NULL, NULL, NULL, 4),
(95062, NULL, 'G3DSA:3.40.190.290:FF:000012', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(95063, NULL, 'G3DSA:3.30.160.60:FF:005757', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95064, NULL, 'G3DSA:1.10.510.10:FF:000167', NULL, NULL, 'Tau tubulin kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(95065, NULL, 'G3DSA:2.170.270.10:FF:000084', NULL, NULL, 'UpSET, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(95066, NULL, 'G3DSA:3.30.200.20:FF:001860', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95067, NULL, 'G3DSA:3.40.50.300:FF:001981', NULL, NULL, 'protein KTI12 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(95068, NULL, 'G3DSA:1.25.40.10:FF:000506', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(95069, NULL, 'G3DSA:2.40.70.10:FF:000061', NULL, NULL, 'Aspartyl protease APCB1', NULL, NULL, NULL, NULL, NULL, 4),
(95070, NULL, 'G3DSA:3.40.50.150:FF:001784', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95071, NULL, 'G3DSA:1.25.40.20:FF:000509', NULL, NULL, 'Ankyrin repeat domain 28, isoform CRA_c', NULL, NULL, NULL, NULL, NULL, 4),
(95072, NULL, 'G3DSA:1.25.70.10:FF:000008', NULL, NULL, 'Transcription termination factor MTERF5 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(95073, NULL, 'G3DSA:3.80.10.10:FF:000789', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase GSO1', NULL, NULL, NULL, NULL, NULL, 4),
(95074, NULL, 'G3DSA:3.30.160.60:FF:006246', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95075, NULL, 'G3DSA:3.40.50.300:FF:004931', NULL, NULL, 'Septin 4', NULL, NULL, NULL, NULL, NULL, 4),
(95076, NULL, 'G3DSA:3.30.70.1230:FF:000283', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95077, NULL, 'G3DSA:3.90.730.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95078, NULL, 'G3DSA:1.10.10.1230:FF:000001', NULL, NULL, 'Penicillin-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(95079, NULL, 'G3DSA:3.60.21.10:FF:000079', NULL, NULL, 'Double-strand break repair protein MRE11', NULL, NULL, NULL, NULL, NULL, 4),
(95080, NULL, 'G3DSA:3.30.505.10:FF:000249', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95081, NULL, 'G3DSA:1.10.3260.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95082, NULL, 'G3DSA:1.20.1110.10:FF:000173', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(95083, NULL, 'G3DSA:1.10.510.10:FF:003961', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95084, NULL, 'G3DSA:3.40.1230.10:FF:000012', NULL, NULL, 'YALI0E11011p', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(95085, NULL, 'G3DSA:1.25.10.10:FF:000117', NULL, NULL, 'TOG array regulator of axonemal microtubules 1', NULL, NULL, NULL, NULL, NULL, 4),
(95086, NULL, 'G3DSA:1.10.238.10:FF:000258', NULL, NULL, 'NADPH oxidase, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(95087, NULL, 'G3DSA:3.40.50.2300:FF:001181', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95088, NULL, 'G3DSA:1.10.760.10:FF:000005', NULL, NULL, 'Menaquinol-cytochrome c reductase cytochrome b/c subunit', NULL, NULL, NULL, NULL, NULL, 4),
(95089, NULL, 'G3DSA:2.60.40.690:FF:000009', NULL, NULL, 'Alpha-2-macroglobulin-like', NULL, NULL, NULL, NULL, NULL, 4),
(95090, NULL, 'G3DSA:1.25.40.10:FF:002182', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(95091, NULL, 'G3DSA:2.130.10.10:FF:003487', NULL, NULL, 'E3 ubiquitin-protein ligase PEP5', NULL, NULL, NULL, NULL, NULL, 4),
(95092, NULL, 'G3DSA:2.130.10.120:FF:000001', NULL, NULL, 'Prolyl endopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(95093, NULL, 'G3DSA:3.40.50.10810:FF:000056', NULL, NULL, 'DNA repair protein RAD5', NULL, NULL, NULL, NULL, NULL, 4),
(95094, NULL, 'G3DSA:1.25.40.20:FF:000627', NULL, NULL, 'Ankyrin repeat and LEM domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(95095, NULL, 'G3DSA:1.10.287.30:FF:000001', NULL, NULL, 'Regulatory protein E2', NULL, NULL, NULL, NULL, NULL, 4),
(95096, NULL, 'G3DSA:3.30.160.60:FF:002429', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(95097, NULL, 'G3DSA:3.70.10.10:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95098, NULL, 'G3DSA:3.40.30.10:FF:000910', NULL, NULL, 'Peroxiredoxin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(95099, NULL, 'G3DSA:2.130.10.10:FF:000261', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(95100, NULL, 'G3DSA:1.10.287.40:FF:000004', NULL, NULL, 'Serine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(95101, NULL, 'G3DSA:1.10.287.130:FF:000088', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(95102, NULL, 'G3DSA:1.10.1040.30:FF:000006', NULL, NULL, 'Putative DNA-dependent ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(95103, NULL, 'G3DSA:3.80.10.10:FF:001418', NULL, NULL, 'Tehao', NULL, NULL, NULL, NULL, NULL, 4),
(95104, NULL, 'G3DSA:2.40.128.20:FF:000029', NULL, NULL, 'Beta-lactoglobulin', NULL, NULL, NULL, NULL, NULL, 4),
(95105, NULL, 'G3DSA:2.40.50.700:FF:000008', NULL, NULL, 'Exosome complex exonuclease RRP44, putative', NULL, NULL, NULL, NULL, NULL, 4),
(95106, NULL, 'G3DSA:1.10.287.110:FF:000082', NULL, NULL, 'Iron-sulfur cluster co-chaperone protein HscB, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(95107, NULL, 'G3DSA:3.40.50.12160:FF:000006', NULL, NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(95108, NULL, 'G3DSA:3.40.532.10:FF:000012', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(95109, NULL, 'G3DSA:3.30.450.50:FF:000055', NULL, NULL, 'Synaptobrevin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(95110, NULL, 'G3DSA:3.70.10.10:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95111, NULL, 'G3DSA:1.10.405.10:FF:000041', NULL, NULL, 'L-amino-acid oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(95112, NULL, 'G3DSA:1.10.418.50:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95113, NULL, 'G3DSA:2.60.40.10:FF:000182', NULL, NULL, 'Gamma intimin', NULL, NULL, NULL, NULL, NULL, 4),
(95114, NULL, 'G3DSA:3.40.50.720:FF:001409', NULL, NULL, 'Tetrapyrrole methylase', NULL, NULL, NULL, NULL, NULL, 4),
(95115, NULL, 'G3DSA:3.70.10.10:FF:000093', NULL, NULL, 'DNA repair exonuclease REC1', NULL, NULL, NULL, NULL, NULL, 4),
(95116, NULL, 'G3DSA:3.30.450.40:FF:000052', NULL, NULL, 'Oxygen sensor histidine kinase response regulator DevS/DosS', NULL, NULL, NULL, NULL, NULL, 4),
(95117, NULL, 'G3DSA:3.30.450.60:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(95118, NULL, 'G3DSA:3.30.1390.20:FF:000001', NULL, NULL, '50S ribosomal protein L30', NULL, NULL, NULL, NULL, NULL, 4),
(95119, NULL, 'G3DSA:2.10.220.10:FF:000208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95120, NULL, 'G3DSA:2.130.10.130:FF:000004', NULL, NULL, 'Integrin subunit alpha 10', NULL, NULL, NULL, NULL, NULL, 4),
(95121, NULL, 'G3DSA:3.40.50.1000:FF:000363', NULL, NULL, 'Nuclear LIM interactor-interacting factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(95122, NULL, 'G3DSA:2.60.40.3210:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95123, NULL, 'G3DSA:3.30.360.10:FF:000064', NULL, NULL, 'Lysine-ketoglutarate reductase/saccharopine dehydrogenase bifunctional enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(95124, NULL, 'G3DSA:1.10.630.10:FF:000457', NULL, NULL, 'Protein CBG01271', NULL, NULL, NULL, NULL, NULL, 4),
(95125, NULL, 'G3DSA:1.10.10.440:FF:000051', NULL, NULL, 'U1 snRNP protein', NULL, NULL, NULL, NULL, NULL, 4),
(95126, NULL, 'G3DSA:3.40.50.150:FF:000261', NULL, NULL, 'U6 small nuclear RNA (adenine-(43)-N(6))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(95127, NULL, 'G3DSA:1.10.472.10:FF:000302', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95128, NULL, 'G3DSA:2.60.40.10:FF:000283', NULL, NULL, 'Immunoglobulin kappa constant', NULL, NULL, NULL, NULL, NULL, 4),
(95129, NULL, 'G3DSA:3.30.505.10:FF:000250', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95130, NULL, 'G3DSA:1.50.40.10:FF:000550', NULL, NULL, 'Mitochondrial glycine transporter', NULL, NULL, NULL, NULL, NULL, 4),
(95131, NULL, 'G3DSA:3.10.130.10:FF:000006', NULL, NULL, 'Ribonuclease homolog', NULL, NULL, NULL, NULL, NULL, 4),
(95132, NULL, 'G3DSA:3.80.10.10:FF:001519', NULL, NULL, 'Highly similar to receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(95133, NULL, 'G3DSA:3.80.10.10:FF:002947', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3', NULL, NULL, NULL, NULL, NULL, 4),
(95134, NULL, 'G3DSA:3.30.420.40:FF:000544', NULL, NULL, 'DnaK-type molecular chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(95135, NULL, 'G3DSA:2.40.50.100:FF:000137', NULL, NULL, 'RND efflux membrane fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(95136, NULL, 'G3DSA:3.40.50.200:FF:000068', NULL, NULL, 'p-domain proprotein convertase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(95137, NULL, 'G3DSA:3.40.50.720:FF:001741', NULL, NULL, 'Adenosylhomocysteinase', NULL, NULL, NULL, NULL, NULL, 4),
(95138, NULL, 'G3DSA:3.30.497.10:FF:000072', NULL, NULL, 'Serine protease inhibitor (serpin) 14', NULL, NULL, NULL, NULL, NULL, 4),
(95139, NULL, 'G3DSA:3.30.160.60:FF:000732', NULL, NULL, 'zinc finger protein 140 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(95140, NULL, 'G3DSA:3.40.50.1010:FF:000271', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95141, NULL, 'G3DSA:3.30.530.20:FF:000092', NULL, NULL, 'Uncharacterized protein 5F3.180', NULL, NULL, NULL, NULL, NULL, 4),
(95142, NULL, 'G3DSA:1.10.472.10:FF:000403', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95143, NULL, 'G3DSA:3.40.50.2300:FF:001282', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95144, NULL, 'G3DSA:3.10.100.10:FF:000403', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95145, NULL, 'G3DSA:1.10.510.10:FF:002325', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95146, NULL, 'G3DSA:3.30.70.380:FF:000004', NULL, NULL, 'Ferredoxin-fold anticodon-binding domain-containing protein 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(95147, NULL, 'G3DSA:3.90.70.10:FF:000039', NULL, NULL, 'Cysteine proteinase 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(95148, NULL, 'G3DSA:1.20.1070.10:FF:001074', NULL, NULL, 'Alpha-1D adrenergic receptor', NULL, NULL, NULL, NULL, NULL, 4),
(95149, NULL, 'G3DSA:3.30.930.10:FF:000086', NULL, NULL, 'Octanoyltransferase LIP2p, chloroplastic isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(95150, NULL, 'G3DSA:1.10.1410.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(95151, NULL, 'G3DSA:3.90.260.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95152, NULL, 'G3DSA:3.40.50.300:FF:007478', NULL, NULL, 'ATP binding cassette subfamily A member 2', NULL, NULL, NULL, NULL, NULL, 4),
(95153, NULL, 'G3DSA:3.40.50.300:FF:004605', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(95154, NULL, 'G3DSA:3.40.50.980:FF:000054', NULL, NULL, 'Peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(95155, NULL, 'G3DSA:3.30.565.10:FF:000354', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(95156, NULL, 'G3DSA:1.10.287.1170:FF:000001', NULL, NULL, 'Endo-1,3-beta-glucanase Engl1', NULL, NULL, NULL, NULL, NULL, 4),
(95157, NULL, 'G3DSA:3.30.1330.30:FF:000129', NULL, NULL, '60S ribosomal protein L7A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(95158, NULL, 'G3DSA:3.30.70.370:FF:000001', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(95159, NULL, 'G3DSA:2.60.40.60:FF:000831', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95160, NULL, 'G3DSA:3.40.50.360:FF:000088', NULL, NULL, 'Pyruvate dehydrogenase [NADP(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(95161, NULL, 'G3DSA:3.40.30.10:FF:000893', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95162, NULL, 'G3DSA:1.10.510.10:FF:003848', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95163, NULL, 'G3DSA:3.30.1240.20:FF:000001', NULL, NULL, 'Phosphomannomutase', NULL, NULL, NULL, NULL, NULL, 4),
(95164, NULL, 'G3DSA:3.40.50.1820:FF:000974', NULL, NULL, 'Alpha/beta hydrolase fold protein', NULL, NULL, NULL, NULL, NULL, 4),
(95165, NULL, 'G3DSA:1.10.10.60:FF:000603', NULL, NULL, 'Putative phage transposase', NULL, NULL, NULL, NULL, NULL, 4),
(95166, NULL, 'G3DSA:3.30.365.10:FF:000053', NULL, NULL, 'Aldehyde oxidase / xanthine dehydrogenase family molybdopterin cytosine dinucleotide-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(95167, NULL, 'G3DSA:1.10.472.80:FF:000273', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95168, NULL, 'G3DSA:1.10.10.370:FF:000001', NULL, NULL, 'Sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(95169, NULL, 'G3DSA:1.10.10.390:FF:000007', NULL, NULL, 'Chl-1', NULL, NULL, NULL, NULL, NULL, 4),
(95170, NULL, 'G3DSA:2.60.40.10:FF:005763', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95171, NULL, 'G3DSA:3.20.20.60:FF:000099', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(95172, NULL, 'G3DSA:3.40.50.2300:FF:001068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95173, NULL, 'G3DSA:2.60.120.10:FF:000824', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95174, NULL, 'G3DSA:2.40.30.10:FF:000070', NULL, NULL, 'Translation elongation factor EF-1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(95175, NULL, 'G3DSA:1.20.58.340:FF:000048', NULL, NULL, 'CorA-like Mg2+ transporter protein', NULL, NULL, NULL, NULL, NULL, 4),
(95176, NULL, 'G3DSA:3.30.420.40:FF:000224', NULL, NULL, 'NuA4 histone acetyltransferase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(95177, NULL, 'G3DSA:1.25.10.10:FF:002354', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95178, NULL, 'G3DSA:1.20.58.2220:FF:000032', NULL, NULL, 'formin-like protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(95179, NULL, 'G3DSA:3.30.505.10:FF:000137', NULL, NULL, 'Phosphoinositide 3-kinase adapter subunit', NULL, NULL, NULL, NULL, NULL, 4),
(95180, NULL, 'G3DSA:1.10.60.10:FF:000002', NULL, NULL, 'Mn-dependent transcriptional regulator MntR', NULL, NULL, NULL, NULL, NULL, 4),
(95181, NULL, 'G3DSA:1.10.1000.11:FF:000016', NULL, NULL, 'Exchange factor for Arf-6', NULL, NULL, NULL, NULL, NULL, 4),
(95182, NULL, 'G3DSA:3.30.70.3250:FF:000006', NULL, NULL, 'Ribonuclease P/MRP protein subunit POP5', NULL, NULL, NULL, NULL, NULL, 4),
(95183, NULL, 'G3DSA:3.30.200.20:FF:002034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95184, NULL, 'G3DSA:1.20.1560.10:FF:000785', NULL, NULL, 'ATP binding cassette subfamily C member 2', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(95185, NULL, 'G3DSA:3.10.20.90:FF:000850', NULL, NULL, 'UBX domain-containing protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(95186, NULL, 'G3DSA:2.40.50.140:FF:001195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95187, NULL, 'G3DSA:1.10.10.10:FF:001909', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95188, NULL, 'G3DSA:3.40.50.300:FF:002582', NULL, NULL, 'Nicotinamide riboside kinase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(95189, NULL, 'G3DSA:1.20.1310.20:FF:000062', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(95190, NULL, 'G3DSA:2.30.29.240:FF:000006', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(95191, NULL, 'G3DSA:4.10.60.10:FF:000023', NULL, NULL, 'Cellular nucleic acid-binding protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(95192, NULL, 'G3DSA:2.60.40.10:FF:004234', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95193, NULL, 'G3DSA:3.40.630.30:FF:000235', NULL, NULL, 'Putative acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(95194, NULL, 'G3DSA:1.20.1250.20:FF:001175', NULL, NULL, 'Sodium-dependent glucose transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(95195, NULL, 'G3DSA:3.30.70.260:FF:000098', NULL, NULL, 'Formyltetrahydrofolate deformylase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(95196, NULL, 'G3DSA:1.25.40.20:FF:000835', NULL, NULL, 'TRPA1(A) isoform', NULL, NULL, NULL, NULL, NULL, 4),
(95197, NULL, 'G3DSA:1.10.510.10:FF:001010', NULL, NULL, 'Serine/threonine-protein kinase Chk2', NULL, NULL, NULL, NULL, NULL, 4),
(95198, NULL, 'G3DSA:3.40.50.720:FF:001640', NULL, NULL, 'SDR family oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(95199, NULL, 'G3DSA:1.25.40.10:FF:001468', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(95200, NULL, 'G3DSA:1.20.1640.10:FF:000044', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(95201, NULL, 'G3DSA:1.10.560.10:FF:000007', NULL, NULL, 'T-complex protein 1 subunit zeta', NULL, NULL, NULL, NULL, NULL, 4),
(95202, NULL, 'G3DSA:3.10.20.90:FF:000187', NULL, NULL, 'Tubulin-folding cofactor E', NULL, NULL, NULL, NULL, NULL, 4),
(95203, NULL, 'G3DSA:2.10.220.10:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95204, NULL, 'G3DSA:3.90.1750.10:FF:000063', NULL, NULL, 'Putative E3 ubiquitin-protein ligase HECTD4', NULL, NULL, NULL, NULL, NULL, 4),
(95205, NULL, 'G3DSA:1.10.510.10:FF:000622', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(95206, NULL, 'G3DSA:2.130.10.10:FF:004425', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95207, NULL, 'G3DSA:1.10.10.10:FF:000274', NULL, NULL, 'Cullin 4B', NULL, NULL, NULL, NULL, NULL, 4),
(95208, NULL, 'G3DSA:1.20.5.1430:FF:000008', NULL, NULL, 'EB1 homolog, putative', NULL, NULL, NULL, NULL, NULL, 4),
(95209, NULL, 'G3DSA:3.10.20.90:FF:000204', NULL, NULL, 'tether containing UBX domain for GLUT4', NULL, NULL, NULL, NULL, NULL, 4),
(95210, NULL, 'G3DSA:1.25.10.10:FF:001539', NULL, NULL, 'Mo25-like family protein', NULL, NULL, NULL, NULL, NULL, 4),
(95211, NULL, 'G3DSA:2.40.170.20:FF:000054', NULL, NULL, 'SusC/RagA family TonB-linked outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(95212, NULL, 'G3DSA:3.30.9.10:FF:000209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95213, NULL, 'G3DSA:3.90.226.10:FF:000110', NULL, NULL, 'Propionyl-CoA carboxylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(95214, NULL, 'G3DSA:3.30.160.60:FF:004330', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95215, NULL, 'G3DSA:1.10.580.10:FF:000020', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(95216, NULL, 'G3DSA:3.40.630.10:FF:000324', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95217, NULL, 'G3DSA:4.10.400.10:FF:000338', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95218, NULL, 'G3DSA:2.70.130.10:FF:000036', NULL, NULL, 'Endoplasmic reticulum lectin 1', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(95219, NULL, 'G3DSA:2.130.10.10:FF:002059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95220, NULL, 'G3DSA:4.10.400.10:FF:000226', NULL, NULL, 'Corin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(95221, NULL, 'G3DSA:2.60.40.10:FF:005858', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95222, NULL, 'G3DSA:3.90.79.10:FF:000008', NULL, NULL, 'cleavage and polyadenylation specificity factor subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(95223, NULL, 'G3DSA:1.20.5.110:FF:000339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95224, NULL, 'G3DSA:2.40.10.10:FF:000523', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95225, NULL, 'G3DSA:2.40.40.10:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95226, NULL, 'G3DSA:1.10.30.10:FF:000163', NULL, NULL, 'Protein maelstrom', NULL, NULL, NULL, NULL, NULL, 4),
(95227, NULL, 'G3DSA:2.10.25.10:FF:001312', NULL, NULL, 'Si:dkey-237h12.3', NULL, NULL, NULL, NULL, NULL, 4),
(95228, NULL, 'G3DSA:3.40.50.300:FF:004151', NULL, NULL, 'DNA repair protein RAD51 homolog 4', NULL, NULL, NULL, NULL, NULL, 4),
(95229, NULL, 'G3DSA:3.40.50.2000:FF:001085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95230, NULL, 'G3DSA:3.40.1090.10:FF:000023', NULL, NULL, 'Phospholipase A2 group IVC', NULL, NULL, NULL, NULL, NULL, 4),
(95231, NULL, 'G3DSA:1.20.58.1100:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95232, NULL, 'G3DSA:2.30.30.40:FF:000152', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(95233, NULL, 'G3DSA:1.10.540.10:FF:000118', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(95234, NULL, 'G3DSA:2.110.10.10:FF:000003', NULL, NULL, 'Matrix metallopeptidase 17', NULL, NULL, NULL, NULL, NULL, 4),
(95235, NULL, 'G3DSA:2.30.30.220:FF:000003', NULL, NULL, 'Stringent starvation protein B', NULL, NULL, NULL, NULL, NULL, 4),
(95236, NULL, 'G3DSA:3.30.230.70:FF:000050', NULL, NULL, 'Unplaced genomic scaffold supercont2.8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(95237, NULL, 'G3DSA:1.10.20.10:FF:000213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95238, NULL, 'G3DSA:1.10.10.10:FF:001691', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95239, NULL, 'G3DSA:2.60.40.2840:FF:000006', NULL, NULL, 'Phosphatidylethanolamine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(95240, NULL, 'G3DSA:1.20.1280.50:FF:000168', NULL, NULL, 'F-box only protein 31-B', NULL, NULL, NULL, NULL, NULL, 4),
(95241, NULL, 'G3DSA:2.130.10.10:FF:003818', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95242, NULL, 'G3DSA:1.10.8.470:FF:000005', NULL, NULL, 'Ribosome-binding ATPase YchF protein', NULL, NULL, NULL, NULL, NULL, 4),
(95243, NULL, 'G3DSA:2.10.220.10:FF:000096', NULL, NULL, 'Furin-like protease 2', NULL, NULL, NULL, NULL, NULL, 4),
(95244, NULL, 'G3DSA:1.25.40.20:FF:000274', NULL, NULL, 'Ankyrin repeat and SOCS box containing 8', NULL, NULL, NULL, NULL, NULL, 4),
(95245, NULL, 'G3DSA:1.25.10.10:FF:001871', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95246, NULL, 'G3DSA:3.30.160.60:FF:000620', NULL, NULL, 'Zinc finger protein 263', NULL, NULL, NULL, NULL, NULL, 4),
(95247, NULL, 'G3DSA:1.10.8.460:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95248, NULL, 'G3DSA:3.80.10.10:FF:003195', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95249, NULL, 'G3DSA:2.60.40.10:FF:002643', NULL, NULL, 'Chaperone CupA5', NULL, NULL, NULL, NULL, NULL, 4),
(95250, NULL, 'G3DSA:1.10.8.480:FF:000008', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(95251, NULL, 'G3DSA:3.40.50.720:FF:001078', NULL, NULL, 'Probable short-chain type dehydrogenase/reductase', NULL, NULL, NULL, NULL, NULL, 4),
(95252, NULL, 'G3DSA:3.40.50.300:FF:000553', NULL, NULL, 'Mitochondrial Rho GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(95253, NULL, 'G3DSA:3.30.450.400:FF:000001', NULL, NULL, 'Putative Bacteriocin', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(95254, NULL, 'G3DSA:1.10.510.10:FF:002213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95255, NULL, 'G3DSA:1.25.40.10:FF:004323', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95256, NULL, 'G3DSA:1.10.510.10:FF:001595', NULL, NULL, 'Os08g0365500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(95257, NULL, 'G3DSA:3.10.110.10:FF:000331', NULL, NULL, 'Ubiquitin protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(95258, NULL, 'G3DSA:1.10.287.110:FF:000413', NULL, NULL, 'J domain-containing protein spf31', NULL, NULL, NULL, NULL, NULL, 4),
(95259, NULL, 'G3DSA:2.40.30.180:FF:000011', NULL, NULL, 'Ubiquitin-activating enzyme E1', NULL, NULL, NULL, NULL, NULL, 4),
(95260, NULL, 'G3DSA:3.30.70.100:FF:000078', NULL, NULL, 'Acylphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(95261, NULL, 'G3DSA:3.40.50.1820:FF:001800', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95262, NULL, 'G3DSA:3.30.40.10:FF:000956', NULL, NULL, 'Ubiquitin C-terminal hydrolase Ubp8, putative', NULL, NULL, NULL, NULL, NULL, 4),
(95263, NULL, 'G3DSA:3.90.550.10:FF:000374', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95264, NULL, 'G3DSA:3.40.50.300:FF:008192', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(95265, NULL, 'G3DSA:1.25.40.10:FF:000271', NULL, NULL, 'Tetratricopeptide repeat domain 26', NULL, NULL, NULL, NULL, NULL, 4),
(95266, NULL, 'G3DSA:3.60.21.10:FF:000107', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(95267, NULL, 'G3DSA:2.70.170.10:FF:000145', NULL, NULL, 'Protein CBR-LGC-31', NULL, NULL, NULL, NULL, NULL, 4),
(95268, NULL, 'G3DSA:1.20.5.990:FF:000007', NULL, NULL, 'TNFAIP3 interacting protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(95269, NULL, 'G3DSA:2.10.25.10:FF:000694', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(95270, NULL, 'G3DSA:1.20.1560.10:FF:000908', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95271, NULL, 'G3DSA:3.40.50.300:FF:003987', NULL, NULL, 'RAD50 homolog uvs-6', NULL, NULL, NULL, NULL, NULL, 4),
(95272, NULL, 'G3DSA:3.30.160.60:FF:000395', NULL, NULL, 'zinc finger protein 513', NULL, NULL, NULL, NULL, NULL, 4),
(95273, NULL, 'G3DSA:3.10.450.580:FF:000008', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(95274, NULL, 'G3DSA:2.40.240.10:FF:000057', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(95275, NULL, 'G3DSA:3.40.50.300:FF:000339', NULL, NULL, 'Uridine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(95276, NULL, 'G3DSA:3.30.830.10:FF:000033', NULL, NULL, 'Stromal processing peptidase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(95277, NULL, 'G3DSA:3.10.110.10:FF:000117', NULL, NULL, 'Putative ubiquitin-conjugating enzyme e2', NULL, NULL, NULL, NULL, NULL, 4),
(95278, NULL, 'G3DSA:3.30.70.330:FF:001445', NULL, NULL, 'Related to RNA-binding protein 8A', NULL, NULL, NULL, NULL, NULL, 4),
(95279, NULL, 'G3DSA:1.10.510.10:FF:001819', NULL, NULL, 'Protein_kinase_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(95280, NULL, 'G3DSA:2.60.40.10:FF:001379', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(95281, NULL, 'G3DSA:3.20.10.10:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95282, NULL, 'G3DSA:3.90.550.50:FF:000240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95283, NULL, 'G3DSA:3.40.50.300:FF:002790', NULL, NULL, 'Dbp45A', NULL, NULL, NULL, NULL, NULL, 4),
(95284, NULL, 'G3DSA:2.130.10.10:FF:005398', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95285, NULL, 'G3DSA:1.25.40.20:FF:000740', NULL, NULL, 'Ankyrin_repeats_(Many_copies)/Ankyrin_repeats_(3_ copies)/Ankyrin_repeat_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(95286, NULL, 'G3DSA:3.30.420.40:FF:000336', NULL, NULL, 'Exopolyphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(95287, NULL, 'G3DSA:1.25.40.500:FF:000003', NULL, NULL, 'Transcription initiation factor TFIID subunit 5', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(95288, NULL, 'G3DSA:3.30.70.100:FF:000196', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95289, NULL, 'G3DSA:3.40.50.300:FF:008203', NULL, NULL, 'Os07g0689300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(95290, NULL, 'G3DSA:1.20.120.1900:FF:000090', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(95291, NULL, 'G3DSA:3.40.190.80:FF:000058', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(95292, NULL, 'G3DSA:3.30.200.20:FF:000005', NULL, NULL, 'cAMP-dependent protein kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(95293, NULL, 'G3DSA:1.25.10.10:FF:002146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95294, NULL, 'G3DSA:1.20.1560.10:FF:000897', NULL, NULL, 'ATP-binding cassette, sub-family B (MDR/TAP), member 9', NULL, NULL, NULL, NULL, NULL, 4),
(95295, NULL, 'G3DSA:1.10.10.10:FF:001898', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95296, NULL, 'G3DSA:3.80.10.10:FF:001312', NULL, NULL, 'Receptor-like protein kinase HSL1', NULL, NULL, NULL, NULL, NULL, 4),
(95297, NULL, 'G3DSA:3.90.226.10:FF:000008', NULL, NULL, 'Acetyl-coenzyme A carboxylase carboxyl transferase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(95298, NULL, 'G3DSA:3.50.50.60:FF:001196', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(95299, NULL, 'G3DSA:3.40.190.80:FF:000069', NULL, NULL, 'Extragenic suppressor', NULL, NULL, NULL, NULL, NULL, 4),
(95300, NULL, 'G3DSA:1.20.1280.50:FF:000157', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95301, NULL, 'G3DSA:1.20.1050.20:FF:000007', NULL, NULL, 'Signal transducer and activator of transcription 1', NULL, NULL, NULL, NULL, NULL, 4),
(95302, NULL, 'G3DSA:3.90.550.50:FF:000032', NULL, NULL, 'Parasite-infected erythrocyte surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(95303, NULL, 'G3DSA:1.20.1050.10:FF:000004', NULL, NULL, 'Glutathione S-transferase F2', NULL, NULL, NULL, NULL, NULL, 4),
(95304, NULL, 'G3DSA:3.40.250.10:FF:000256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95305, NULL, 'G3DSA:3.40.630.30:FF:000443', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95306, NULL, 'G3DSA:2.60.120.620:FF:000138', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95307, NULL, 'G3DSA:1.10.1420.10:FF:000108', NULL, NULL, 'DNA mismatch repair protein MSH3', NULL, NULL, NULL, NULL, NULL, 4),
(95308, NULL, 'G3DSA:3.30.70.1170:FF:000023', NULL, NULL, 'NOL1/NOP2/sun family protein', NULL, NULL, NULL, NULL, NULL, 4),
(95309, NULL, 'G3DSA:1.20.5.100:FF:000016', NULL, NULL, 'Penicillin-binding protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(95310, NULL, 'G3DSA:2.40.50.140:FF:000121', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(95311, NULL, 'G3DSA:1.10.510.10:FF:000072', NULL, NULL, 'AP2 associated kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(95312, NULL, 'G3DSA:3.90.228.10:FF:000058', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95313, NULL, 'G3DSA:3.40.630.30:FF:000673', NULL, NULL, 'Acetyltransferase, GNAT family protein', NULL, NULL, NULL, NULL, NULL, 4),
(95314, NULL, 'G3DSA:2.10.220.10:FF:000085', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 6', NULL, NULL, NULL, NULL, NULL, 4),
(95315, NULL, 'G3DSA:3.20.20.70:FF:000445', NULL, NULL, '1-(5-phosphoribosyl)-5-[(5-phosphoribosylamino)methylideneamino] imidazole-4-carboxamide isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(95316, NULL, 'G3DSA:1.10.8.60:FF:000176', NULL, NULL, 'Replication related protein', NULL, NULL, NULL, NULL, NULL, 4),
(95317, NULL, 'G3DSA:3.30.70.330:FF:000017', NULL, NULL, 'ELAV-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(95318, NULL, 'G3DSA:1.10.472.80:FF:000284', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95319, NULL, 'G3DSA:1.10.510.10:FF:001696', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95320, NULL, 'G3DSA:3.40.30.10:FF:000247', NULL, NULL, '28S ribosomal protein S25, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(95321, NULL, 'G3DSA:3.40.109.10:FF:000001', NULL, NULL, 'Nitroreductase family', NULL, NULL, NULL, NULL, NULL, 4),
(95322, NULL, 'G3DSA:2.130.10.10:FF:000373', NULL, NULL, 'WD repeat domain 78', NULL, NULL, NULL, NULL, NULL, 4),
(95323, NULL, 'G3DSA:3.20.20.80:FF:000678', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95324, NULL, 'G3DSA:3.40.190.290:FF:000124', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(95325, NULL, 'G3DSA:3.20.20.70:FF:000675', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95326, NULL, 'G3DSA:2.30.180.10:FF:000161', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95327, NULL, 'G3DSA:1.25.50.10:FF:000013', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95328, NULL, 'G3DSA:2.60.40.790:FF:000039', NULL, NULL, 'CS domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(95329, NULL, 'G3DSA:3.30.70.1010:FF:000003', NULL, NULL, 'Protein Translation Elongation Factor 1B subunitbeta (EF-1Bb)/1-gamma', NULL, NULL, NULL, NULL, NULL, 4),
(95330, NULL, 'G3DSA:3.10.20.90:FF:000412', NULL, NULL, 'Nuclear protein localization', NULL, NULL, NULL, NULL, NULL, 4),
(95331, NULL, 'G3DSA:2.60.40.10:FF:000406', NULL, NULL, 'angiopoietin-1 receptor isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(95332, NULL, 'G3DSA:1.10.10.10:FF:000263', NULL, NULL, 'Interferon regulatory factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(95333, NULL, 'G3DSA:2.40.70.10:FF:000510', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95334, NULL, 'G3DSA:3.30.160.60:FF:003846', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95335, NULL, 'G3DSA:3.30.70.1020:FF:000006', NULL, NULL, 'Trehalose 6-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(95336, NULL, 'G3DSA:3.30.870.10:FF:000030', NULL, NULL, 'mitochondrial cardiolipin hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(95337, NULL, 'G3DSA:3.30.830.10:FF:000151', NULL, NULL, 'Metalloenzyme, LuxS/M16 peptidase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(95338, NULL, 'G3DSA:3.30.60.30:FF:000250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95339, NULL, 'G3DSA:3.90.550.10:FF:000256', NULL, NULL, 'UDP-glucose glycoprotein:glucosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(95340, NULL, 'G3DSA:3.40.532.10:FF:000001', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(95341, NULL, 'G3DSA:1.10.1130.10:FF:000007', NULL, NULL, 'C-type multiheme cytochrome', NULL, NULL, NULL, NULL, NULL, 4),
(95342, NULL, 'G3DSA:3.40.50.880:FF:000024', NULL, NULL, 'Folate gamma-glutamyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(95343, NULL, 'G3DSA:3.30.160.60:FF:004122', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95344, NULL, 'G3DSA:3.30.70.1230:FF:000165', NULL, NULL, 'adenylate cyclase type 10-like', NULL, NULL, NULL, NULL, NULL, 4),
(95345, NULL, 'G3DSA:3.40.50.10420:FF:000046', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(95346, NULL, 'G3DSA:3.10.20.90:FF:000642', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95347, NULL, 'G3DSA:2.120.10.30:FF:000340', NULL, NULL, 'Peptidase S9 prolyl oligopeptidase active site domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(95348, NULL, 'G3DSA:3.10.20.90:FF:000288', NULL, NULL, 'Autophagy-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(95349, NULL, 'G3DSA:1.10.132.60:FF:000011', NULL, NULL, 'DNA polymerase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(95350, NULL, 'G3DSA:3.40.50.1980:FF:000061', NULL, NULL, 'Iron complex transport system substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(95351, NULL, 'G3DSA:3.90.550.10:FF:000610', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95352, NULL, 'G3DSA:1.10.132.70:FF:000014', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(95353, NULL, 'G3DSA:3.90.1750.10:FF:000074', NULL, NULL, 'Putative ubiquitin-protein ligase e3c', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(95354, NULL, 'G3DSA:3.40.50.1820:FF:001137', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95355, NULL, 'G3DSA:2.30.29.30:FF:001247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95356, NULL, 'G3DSA:3.80.10.10:FF:002835', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95357, NULL, 'G3DSA:3.80.10.10:FF:000694', NULL, NULL, 'Receptor-like protein kinase HSL1', NULL, NULL, NULL, NULL, NULL, 4),
(95358, NULL, 'G3DSA:4.10.400.10:FF:000237', NULL, NULL, 'LDL receptor repeat-containing protein egg-1', NULL, NULL, NULL, NULL, NULL, 4),
(95359, NULL, 'G3DSA:1.25.40.10:FF:005296', NULL, NULL, 'DnaJ domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(95360, NULL, 'G3DSA:1.25.40.10:FF:001709', NULL, NULL, 'Tetratricopeptide repeat domain 21A', NULL, NULL, NULL, NULL, NULL, 4),
(95361, NULL, 'G3DSA:1.10.287.2250:FF:000016', NULL, NULL, 'Cathepsin 12', NULL, NULL, NULL, NULL, NULL, 4),
(95362, NULL, 'G3DSA:3.30.9.10:FF:000086', NULL, NULL, 'Dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(95363, NULL, 'G3DSA:1.10.287.600:FF:000015', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(95364, NULL, 'G3DSA:2.130.10.10:FF:002172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95365, NULL, 'G3DSA:3.30.160.60:FF:002418', NULL, NULL, 'FI01124p', NULL, NULL, NULL, NULL, NULL, 4),
(95366, NULL, 'G3DSA:2.60.40.10:FF:001929', NULL, NULL, 'Down syndrome cell adhesion molecule 3, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(95367, NULL, 'G3DSA:2.130.10.10:FF:001896', NULL, NULL, 'Cytoplasmic dynein 1 intermediate chain', NULL, NULL, NULL, NULL, NULL, 4),
(95368, NULL, 'G3DSA:1.25.40.10:FF:001367', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g30825, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(95369, NULL, 'G3DSA:2.120.10.30:FF:000020', NULL, NULL, 'Prolow-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(95370, NULL, 'G3DSA:2.60.40.10:FF:003397', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95371, NULL, 'G3DSA:1.20.58.520:FF:000001', NULL, NULL, 'Imidazolonepropionase-like amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(95372, NULL, 'G3DSA:2.60.40.10:FF:004335', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95373, NULL, 'G3DSA:3.20.20.140:FF:000088', NULL, NULL, 'Histidinol-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(95374, NULL, 'G3DSA:1.25.40.10:FF:003497', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95375, NULL, 'G3DSA:3.30.420.40:FF:000106', NULL, NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(95376, NULL, 'G3DSA:3.30.540.10:FF:000050', NULL, NULL, 'Fructose-1,6-bisphosphatase class 1', NULL, NULL, NULL, NULL, NULL, 4),
(95377, NULL, 'G3DSA:2.60.40.10:FF:002205', NULL, NULL, 'V-set and immunoglobulin domain containing 10 like', NULL, NULL, NULL, NULL, NULL, 4),
(95378, NULL, 'G3DSA:2.60.40.10:FF:005869', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95379, NULL, 'G3DSA:3.40.50.300:FF:004381', NULL, NULL, 'Zgc:158417', NULL, NULL, NULL, NULL, NULL, 4),
(95380, NULL, 'G3DSA:1.20.120.920:FF:000002', NULL, NULL, 'CRISPR-associated endonuclease Cas1', NULL, NULL, NULL, NULL, NULL, 4),
(95381, NULL, 'G3DSA:2.20.28.230:FF:000005', NULL, NULL, 'Interleukin 15 receptor alpha isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(95382, NULL, 'G3DSA:3.30.565.10:FF:000034', NULL, NULL, 'DNA mismatch repair protein mlh1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(95383, NULL, 'G3DSA:4.10.280.10:FF:000137', NULL, NULL, 'Transcription factor bHLH52', NULL, NULL, NULL, NULL, NULL, 4),
(95384, NULL, 'G3DSA:2.60.40.10:FF:002435', NULL, NULL, 'Fc receptor like 5', NULL, NULL, NULL, NULL, NULL, 4),
(95385, NULL, 'G3DSA:3.30.1490.220:FF:000009', NULL, NULL, 'Inositol-tetrakisphosphate 1-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(95386, NULL, 'G3DSA:1.20.1280.50:FF:000270', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(95387, NULL, 'G3DSA:1.20.58.530:FF:000004', NULL, NULL, 'Unconventional myosin ID', NULL, NULL, NULL, NULL, NULL, 4),
(95388, NULL, 'G3DSA:2.130.10.10:FF:000614', NULL, NULL, 'WD domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(95389, NULL, 'G3DSA:3.90.1410.10:FF:000037', NULL, NULL, 'SET (Trithorax/polycomb) domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(95390, NULL, 'G3DSA:3.40.50.1100:FF:000292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95391, NULL, 'G3DSA:1.10.150.240:FF:000104', NULL, NULL, 'Slr0458 protein', NULL, NULL, NULL, NULL, NULL, 4),
(95392, NULL, 'G3DSA:3.40.50.300:FF:002913', NULL, NULL, 'NO-associated protein 1, chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(95393, NULL, 'G3DSA:1.10.287.110:FF:000205', NULL, NULL, 'DnaJ protein', NULL, NULL, NULL, NULL, NULL, 4),
(95394, NULL, 'G3DSA:2.60.40.10:FF:000305', NULL, NULL, 'neurotrimin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(95395, NULL, 'G3DSA:2.40.20.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95396, NULL, 'G3DSA:1.50.40.10:FF:000448', NULL, NULL, 'Mitochondrial dicarboxylate/tricarboxylate transporter DTC', NULL, NULL, NULL, NULL, NULL, 4),
(95397, NULL, 'G3DSA:2.60.40.1120:FF:000041', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95398, NULL, 'G3DSA:1.10.238.10:FF:000152', NULL, NULL, 'Centrin 3', NULL, NULL, NULL, NULL, NULL, 4),
(95399, NULL, 'G3DSA:3.90.226.10:FF:000121', NULL, NULL, 'Serine protease SPPA, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(95400, NULL, 'G3DSA:2.60.120.10:FF:000358', NULL, NULL, 'Camk protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(95401, NULL, 'G3DSA:3.30.70.330:FF:001653', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95402, NULL, 'G3DSA:1.10.10.10:FF:001359', NULL, NULL, 'Putative ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(95403, NULL, 'G3DSA:3.40.50.720:FF:001286', NULL, NULL, 'Uncharacterized oxidoreductase C162.03', NULL, NULL, NULL, NULL, NULL, 4),
(95404, NULL, 'G3DSA:3.30.200.20:FF:001972', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95405, NULL, 'G3DSA:2.40.30.10:FF:000390', NULL, NULL, 'translation initiation factor IF-2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(95406, NULL, 'G3DSA:3.40.50.300:FF:006281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95407, NULL, 'G3DSA:1.10.533.10:FF:000107', NULL, NULL, 'Nucleotide-binding oligomerization domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(95408, NULL, 'G3DSA:3.40.50.10810:FF:000270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95409, NULL, 'G3DSA:3.30.160.60:FF:002076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95410, NULL, 'G3DSA:1.20.1250.20:FF:001416', NULL, NULL, 'Slc-17.2', NULL, NULL, NULL, NULL, NULL, 4),
(95411, NULL, 'G3DSA:3.60.9.10:FF:000002', NULL, NULL, 'Aldehyde ferredoxin oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(95412, NULL, 'G3DSA:3.40.50.2300:FF:001388', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95413, NULL, 'G3DSA:3.90.640.90:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95414, NULL, 'G3DSA:1.25.40.10:FF:003828', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95415, NULL, 'G3DSA:3.30.160.60:FF:000518', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(95416, NULL, 'G3DSA:2.130.10.10:FF:004324', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95417, NULL, 'G3DSA:3.30.1370.10:FF:000120', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(95418, NULL, 'G3DSA:1.20.58.390:FF:000265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95419, NULL, 'G3DSA:2.10.90.10:FF:000092', NULL, NULL, 'GM13635', NULL, NULL, NULL, NULL, NULL, 4),
(95420, NULL, 'G3DSA:2.160.20.70:FF:000047', NULL, NULL, 'Tubulin folding cofactor C, putative', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(95421, NULL, 'G3DSA:2.60.40.1120:FF:000030', NULL, NULL, 'Silver, isoform N', NULL, NULL, NULL, NULL, NULL, 4),
(95422, NULL, 'G3DSA:2.30.180.10:FF:000059', NULL, NULL, 'Stabilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(95423, NULL, 'G3DSA:3.40.50.150:FF:000581', NULL, NULL, 'Methyltransferase like 1', NULL, NULL, NULL, NULL, NULL, 4),
(95424, NULL, 'G3DSA:3.30.160.60:FF:000631', NULL, NULL, 'zinc finger protein 189 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(95425, NULL, 'G3DSA:1.10.8.10:FF:000296', NULL, NULL, 'Ubiquitin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(95426, NULL, 'G3DSA:3.10.450.50:FF:000031', NULL, NULL, 'Unplaced genomic scaffold supercont2.3, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(95427, NULL, 'G3DSA:3.30.40.10:FF:001119', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(95428, NULL, 'G3DSA:3.30.70.330:FF:002968', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95429, NULL, 'G3DSA:1.10.472.10:FF:000280', NULL, NULL, 'Protein CBG20098', NULL, NULL, NULL, NULL, NULL, 4),
(95430, NULL, 'G3DSA:3.40.50.300:FF:007719', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95431, NULL, 'G3DSA:3.30.160.60:FF:006460', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95432, NULL, 'G3DSA:2.60.40.1510:FF:000051', NULL, NULL, 'Im:7145180 protein', NULL, NULL, NULL, NULL, NULL, 4),
(95433, NULL, 'G3DSA:2.60.40.1180:FF:000132', NULL, NULL, 'Alpha-amylase', NULL, NULL, NULL, NULL, NULL, 4),
(95434, NULL, 'G3DSA:3.80.10.10:FF:001750', NULL, NULL, 'Predicted gene 3259', NULL, NULL, NULL, NULL, NULL, 4),
(95435, NULL, 'G3DSA:3.40.50.300:FF:000452', NULL, NULL, 'DnaA regulatory inactivator Hda', NULL, NULL, NULL, NULL, NULL, 4),
(95436, NULL, 'G3DSA:1.10.10.10:FF:001797', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(95437, NULL, 'G3DSA:1.20.1260.100:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95438, NULL, 'G3DSA:2.130.10.10:FF:005948', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(95439, NULL, 'G3DSA:3.40.50.150:FF:000923', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(95440, NULL, 'G3DSA:2.10.25.10:FF:001418', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95441, NULL, 'G3DSA:3.80.10.10:FF:003650', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95442, NULL, 'G3DSA:3.40.50.300:FF:002352', NULL, NULL, 'ABC transporter B family member 7', NULL, NULL, NULL, NULL, NULL, 4),
(95443, NULL, 'G3DSA:1.10.287.470:FF:000049', NULL, NULL, 'Multidrug resistance protein VceA', NULL, NULL, NULL, NULL, NULL, 4),
(95444, NULL, 'G3DSA:3.40.120.10:FF:000033', NULL, NULL, 'Phosphomannomutase / phosphoglucomutase', NULL, NULL, NULL, NULL, NULL, 4),
(95445, NULL, 'G3DSA:1.10.238.10:FF:000713', NULL, NULL, 'Myosin, essential light chain', NULL, NULL, NULL, NULL, NULL, 4),
(95446, NULL, 'G3DSA:2.10.25.10:FF:000935', NULL, NULL, 'Matrilin 3a', NULL, NULL, NULL, NULL, NULL, 4),
(95447, NULL, 'G3DSA:2.30.39.10:FF:000146', NULL, NULL, 'Serpin peptidase inhibitor 6', NULL, NULL, NULL, NULL, NULL, 4),
(95448, NULL, 'G3DSA:3.40.50.1000:FF:000374', NULL, NULL, 'E1-E2 ATPase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(95449, NULL, 'G3DSA:2.30.30.140:FF:000209', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(95450, NULL, 'G3DSA:3.80.10.10:FF:003431', NULL, NULL, 'EIN3-binding F-box protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(95451, NULL, 'G3DSA:2.60.120.10:FF:000471', NULL, NULL, 'Homogentisate 1,2-dioxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(95452, NULL, 'G3DSA:2.30.42.10:FF:000030', NULL, NULL, 'Partitioning defective 6 homolog beta', NULL, NULL, NULL, NULL, NULL, 4),
(95453, NULL, 'G3DSA:3.90.260.10:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95454, NULL, 'G3DSA:1.10.20.10:FF:000005', NULL, NULL, 'Histone H2A', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(95455, NULL, 'G3DSA:2.60.200.20:FF:000171', NULL, NULL, 'AGAP003213-PA', NULL, NULL, NULL, NULL, NULL, 4),
(95456, NULL, 'G3DSA:3.40.50.300:FF:007377', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(95457, NULL, 'G3DSA:1.10.287.70:FF:000783', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95458, NULL, 'G3DSA:3.40.140.10:FF:000141', NULL, NULL, 'Lys-63-specific deubiquitinase BRCC36', NULL, NULL, NULL, NULL, NULL, 4),
(95459, NULL, 'G3DSA:1.10.472.130:FF:000083', NULL, NULL, 'Dynein heavy chain at 16F', NULL, NULL, NULL, NULL, NULL, 4),
(95460, NULL, 'G3DSA:3.40.50.2020:FF:000017', NULL, NULL, 'Ribose-phosphate pyrophosphokinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(95461, NULL, 'G3DSA:3.30.390.60:FF:000002', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(95462, NULL, 'G3DSA:1.20.120.350:FF:000270', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95463, NULL, 'G3DSA:1.10.560.10:FF:000018', NULL, NULL, 'T-complex protein 1, zeta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(95464, NULL, 'G3DSA:3.10.50.40:FF:000039', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(95465, NULL, 'G3DSA:4.10.860.120:FF:000002', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(95466, NULL, 'G3DSA:1.10.510.10:FF:000633', NULL, NULL, 'AGC/AKT protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(95467, NULL, 'G3DSA:1.25.10.20:FF:000019', NULL, NULL, 'Vtg3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(95468, NULL, 'G3DSA:1.20.5.4770:FF:000004', NULL, NULL, 'OTU deubiquitinase 7A', NULL, NULL, NULL, NULL, NULL, 4),
(95469, NULL, 'G3DSA:1.50.10.10:FF:000059', NULL, NULL, 'YMR196W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(95470, NULL, 'G3DSA:1.10.510.10:FF:002533', NULL, NULL, 'protein O-mannose kinase-like', NULL, NULL, NULL, NULL, NULL, 4),
(95471, NULL, 'G3DSA:3.30.160.60:FF:006128', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95472, NULL, 'G3DSA:3.10.110.10:FF:000011', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 L3', NULL, NULL, NULL, NULL, NULL, 4),
(95473, NULL, 'G3DSA:3.30.230.70:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95474, NULL, 'G3DSA:3.30.200.20:FF:002135', NULL, NULL, 'Stretchin-MLCK', NULL, NULL, NULL, NULL, NULL, 4),
(95475, NULL, 'G3DSA:3.30.1360.120:FF:000035', NULL, NULL, 'IBA57, iron-sulfur cluster assembly', NULL, NULL, NULL, NULL, NULL, 4),
(95476, NULL, 'G3DSA:3.40.50.300:FF:000098', NULL, NULL, 'Probable GTP-binding protein EngB', NULL, NULL, NULL, NULL, NULL, 4),
(95477, NULL, 'G3DSA:3.40.50.300:FF:003667', NULL, NULL, 'Putative ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(95478, NULL, 'G3DSA:1.25.10.10:FF:000016', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 56 kDa regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(95479, NULL, 'G3DSA:3.30.160.60:FF:004560', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95480, NULL, 'G3DSA:2.60.40.60:FF:000623', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95481, NULL, 'G3DSA:1.50.40.10:FF:000218', NULL, NULL, 'GG15457', NULL, NULL, NULL, NULL, NULL, 4),
(95482, NULL, 'G3DSA:2.30.30.40:FF:000039', NULL, NULL, 'Vav guanine nucleotide exchange factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(95483, NULL, 'G3DSA:2.60.120.650:FF:000001', NULL, NULL, 'Putative lysine-specific demethylase 5b', NULL, NULL, NULL, NULL, NULL, 4),
(95484, NULL, 'G3DSA:1.20.1560.10:FF:000886', NULL, NULL, 'ABC protein, subfamily ABCC', NULL, NULL, NULL, NULL, NULL, 4),
(95485, NULL, 'G3DSA:2.10.25.10:FF:001211', NULL, NULL, 'Fibulin 2', NULL, NULL, NULL, NULL, NULL, 4),
(95486, NULL, 'G3DSA:2.70.150.10:FF:000245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95487, NULL, 'G3DSA:3.40.30.10:FF:000685', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(95488, NULL, 'G3DSA:3.40.50.300:FF:004504', NULL, NULL, 'Putative ABC transporter ATP-binding component', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(95489, NULL, 'G3DSA:1.10.3460.10:FF:000004', NULL, NULL, 'Chlorophyll a-b binding protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(95490, NULL, 'G3DSA:3.40.50.300:FF:005786', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95491, NULL, 'G3DSA:3.40.50.620:FF:000885', NULL, NULL, 'Tryptophanyl-trna synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(95492, NULL, 'G3DSA:1.10.1740.10:FF:000037', NULL, NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(95493, NULL, 'G3DSA:3.40.50.1440:FF:000034', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(95494, NULL, 'G3DSA:1.20.1070.10:FF:001427', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95495, NULL, 'G3DSA:2.60.40.10:FF:005971', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95496, NULL, 'G3DSA:3.10.100.10:FF:000050', NULL, NULL, 'Secretory phospholipase A2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(95497, NULL, 'G3DSA:2.40.10.10:FF:000282', NULL, NULL, 'Serine-type enodpeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(95498, NULL, 'G3DSA:1.20.58.1590:FF:000005', NULL, NULL, 'Tethering factor for nuclear proteasome STS1', NULL, NULL, NULL, NULL, NULL, 4),
(95499, NULL, 'G3DSA:1.10.8.870:FF:000018', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(95500, NULL, 'G3DSA:2.60.120.200:FF:000586', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95501, NULL, 'G3DSA:2.30.29.30:FF:001360', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95502, NULL, 'G3DSA:3.30.470.110:FF:000002', NULL, NULL, 'ATP-citrate synthase alpha chain protein', NULL, NULL, NULL, NULL, NULL, 4),
(95503, NULL, 'G3DSA:3.30.2350.20:FF:000010', NULL, NULL, 'Putative pseudouridine synthase YOR243C family', NULL, NULL, NULL, NULL, NULL, 4),
(95504, NULL, 'G3DSA:1.10.437.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95505, NULL, 'G3DSA:3.90.70.10:FF:000371', NULL, NULL, 'Calpain 10', NULL, NULL, NULL, NULL, NULL, 4),
(95506, NULL, 'G3DSA:2.60.120.620:FF:000026', NULL, NULL, 'Procollagen-lysine,2-oxoglutarate 5-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(95507, NULL, 'G3DSA:2.60.120.920:FF:000009', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM9 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(95508, NULL, 'G3DSA:3.40.50.300:FF:004156', NULL, NULL, 'Putative rab40c member ras oncoprotein family', NULL, NULL, NULL, NULL, NULL, 4),
(95509, NULL, 'G3DSA:3.30.70.890:FF:000062', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(95510, NULL, 'G3DSA:3.30.40.10:FF:001439', NULL, NULL, 'TNF receptor-associated factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(95511, NULL, 'G3DSA:1.50.10.10:FF:000166', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(95512, NULL, 'G3DSA:1.25.40.10:FF:000400', NULL, NULL, 'Putative transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(95513, NULL, 'G3DSA:2.40.30.130:FF:000030', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(95514, NULL, 'G3DSA:3.10.100.10:FF:000162', NULL, NULL, 'Polycystic kidney disease 1a', NULL, NULL, NULL, NULL, NULL, 4),
(95515, NULL, 'G3DSA:1.25.40.20:FF:000403', NULL, NULL, 'Kinase D interacting substrate 220', NULL, NULL, NULL, NULL, NULL, 4),
(95516, NULL, 'G3DSA:3.40.50.1000:FF:000711', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95517, NULL, 'G3DSA:1.10.510.10:FF:002090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95518, NULL, 'G3DSA:3.40.50.2300:FF:000899', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95519, NULL, 'G3DSA:3.30.499.10:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95520, NULL, 'G3DSA:3.90.640.10:FF:000269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95521, NULL, 'G3DSA:2.70.130.10:FF:000031', NULL, NULL, 'Yos9p', NULL, NULL, NULL, NULL, NULL, 4),
(95522, NULL, 'G3DSA:1.20.870.10:FF:000051', NULL, NULL, 'Rap guanine nucleotide exchange factor 5', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(95523, NULL, 'G3DSA:1.20.1250.20:FF:000579', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(95524, NULL, 'G3DSA:3.40.50.300:FF:007933', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95525, NULL, 'G3DSA:1.25.40.10:FF:005178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95526, NULL, 'G3DSA:3.20.20.70:FF:000563', NULL, NULL, '2-nitropropane dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(95527, NULL, 'G3DSA:1.10.20.10:FF:000218', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95528, NULL, 'G3DSA:1.10.1450.10:FF:000161', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(95529, NULL, 'G3DSA:3.90.550.10:FF:000150', NULL, NULL, 'Collagen beta(1-O)galactosyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(95530, NULL, 'G3DSA:3.10.450.10:FF:000036', NULL, NULL, 'AGAP002879-PA', NULL, NULL, NULL, NULL, NULL, 4),
(95531, NULL, 'G3DSA:1.10.238.200:FF:000026', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(95532, NULL, 'G3DSA:3.30.70.330:FF:002041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95533, NULL, 'G3DSA:4.10.1240.10:FF:000042', NULL, NULL, 'Parathyroid hormone receptor-like protein bf98C', NULL, NULL, NULL, NULL, NULL, 4),
(95534, NULL, 'G3DSA:3.40.50.10610:FF:000002', NULL, NULL, 'Penicillin-binding protein activator LpoB', NULL, NULL, NULL, NULL, NULL, 4),
(95535, NULL, 'G3DSA:3.40.50.720:FF:001073', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95536, NULL, 'G3DSA:1.10.287.110:FF:000418', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95537, NULL, 'G3DSA:2.60.120.310:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95538, NULL, 'G3DSA:1.10.730.10:FF:000161', NULL, NULL, 'YALI0D03619p', NULL, NULL, NULL, NULL, NULL, 4),
(95539, NULL, 'G3DSA:3.40.50.300:FF:005679', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95540, NULL, 'G3DSA:3.40.140.10:FF:000242', NULL, NULL, 'Os10g0506300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(95541, NULL, 'G3DSA:3.40.50.300:FF:006303', NULL, NULL, 'Regulator of nonsense transcripts 1', NULL, NULL, NULL, NULL, NULL, 4),
(95542, NULL, 'G3DSA:3.20.20.80:FF:000566', NULL, NULL, 'Chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(95543, NULL, 'G3DSA:3.30.160.60:FF:000064', NULL, NULL, 'Early growth response protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(95544, NULL, 'G3DSA:2.130.10.10:FF:006011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95545, NULL, 'G3DSA:1.10.167.10:FF:000059', NULL, NULL, 'Axin-1', NULL, NULL, NULL, NULL, NULL, 4),
(95546, NULL, 'G3DSA:3.30.980.10:FF:000038', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(95547, NULL, 'G3DSA:1.25.40.20:FF:001004', NULL, NULL, 'Ankyrin repeat domain-containing protein M-T5', NULL, NULL, NULL, NULL, NULL, 4),
(95548, NULL, 'G3DSA:3.30.160.60:FF:004335', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95549, NULL, 'G3DSA:3.30.530.20:FF:000108', NULL, NULL, 'Collagen type IV alpha 3 binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(95550, NULL, 'G3DSA:3.40.50.620:FF:000879', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95551, NULL, 'G3DSA:3.10.105.10:FF:000044', NULL, NULL, 'Extracellular solute-binding protein, family 5', NULL, NULL, NULL, NULL, NULL, 4),
(95552, NULL, 'G3DSA:2.20.90.10:FF:000006', NULL, NULL, 'Vitellogenin 5', NULL, NULL, NULL, NULL, NULL, 4),
(95553, NULL, 'G3DSA:1.20.120.350:FF:000258', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95554, NULL, 'G3DSA:3.80.10.10:FF:003324', NULL, NULL, 'Si:ch211-149a19.3', NULL, NULL, NULL, NULL, NULL, 4),
(95555, NULL, 'G3DSA:3.40.50.10190:FF:000157', NULL, NULL, 'HSK1 kinase regulatory subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(95556, NULL, 'G3DSA:1.10.472.10:FF:000061', NULL, NULL, 'cyclin-O', NULL, NULL, NULL, NULL, NULL, 4),
(95557, NULL, 'G3DSA:1.10.150.50:FF:000084', NULL, NULL, 'EPS (Human endocytosis) related', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(95558, NULL, 'G3DSA:3.40.50.1100:FF:000174', NULL, NULL, 'Putative truncated L-serine dehydratase SDL1', NULL, NULL, NULL, NULL, NULL, 4),
(95559, NULL, 'G3DSA:3.30.160.60:FF:004228', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95560, NULL, 'G3DSA:3.80.30.30:FF:000004', NULL, NULL, 'Possible DNA repair photolyase', NULL, NULL, NULL, NULL, NULL, 4),
(95561, NULL, 'G3DSA:3.40.50.10310:FF:000007', NULL, NULL, 'Creatinine amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(95562, NULL, 'G3DSA:3.90.70.10:FF:000814', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95563, NULL, 'G3DSA:1.10.418.10:FF:000126', NULL, NULL, 'Actin binding protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(95564, NULL, 'G3DSA:3.10.100.10:FF:000055', NULL, NULL, 'NKG2-D type II integral membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(95565, NULL, 'G3DSA:2.20.25.10:FF:000047', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(95566, NULL, 'G3DSA:3.40.50.1820:FF:001019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95567, NULL, 'G3DSA:3.40.850.10:FF:000200', NULL, NULL, 'Kinesin-like protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(95568, NULL, 'G3DSA:1.20.5.340:FF:000048', NULL, NULL, 'Rho kinase, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(95569, NULL, 'G3DSA:2.70.170.10:FF:000140', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(95570, NULL, 'G3DSA:2.60.40.150:FF:000426', NULL, NULL, 'RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(95571, NULL, 'G3DSA:4.10.240.30:FF:000005', NULL, NULL, 'A20-S', NULL, NULL, NULL, NULL, NULL, 4),
(95572, NULL, 'G3DSA:3.80.30.20:FF:000001', NULL, NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(95573, NULL, 'G3DSA:2.60.120.10:FF:000813', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95574, NULL, 'G3DSA:2.60.40.60:FF:001000', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95575, NULL, 'G3DSA:2.60.120.10:FF:000476', NULL, NULL, 'Germin-like protein subfamily T member 3', NULL, NULL, NULL, NULL, NULL, 4),
(95576, NULL, 'G3DSA:2.70.150.10:FF:000026', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(95577, NULL, 'G3DSA:3.30.420.10:FF:000457', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95578, NULL, 'G3DSA:3.90.1150.10:FF:000101', NULL, NULL, 'Putative 4-aminobutyrate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(95579, NULL, 'G3DSA:2.10.70.10:FF:000096', NULL, NULL, 'Beta-2-glycoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(95580, NULL, 'G3DSA:2.40.160.120:FF:000063', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(95581, NULL, 'G3DSA:2.30.29.30:FF:001365', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(95582, NULL, 'G3DSA:3.30.930.10:FF:000327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95583, NULL, 'G3DSA:3.80.10.10:FF:001177', NULL, NULL, 'Disease resistance protein RRS1', NULL, NULL, NULL, NULL, NULL, 4),
(95584, NULL, 'G3DSA:1.20.920.10:FF:000168', NULL, NULL, 'Protein polybromo-1', NULL, NULL, NULL, NULL, NULL, 4),
(95585, NULL, 'G3DSA:1.10.1450.10:FF:000054', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(95586, NULL, 'G3DSA:3.30.160.60:FF:005858', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95587, NULL, 'G3DSA:3.40.50.2300:FF:001630', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95588, NULL, 'G3DSA:1.10.8.10:FF:000189', NULL, NULL, 'Prion-like-(Q/N-rich)-domain-bearing protein', NULL, NULL, NULL, NULL, NULL, 4),
(95589, NULL, 'G3DSA:3.40.50.2300:FF:001523', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95590, NULL, 'G3DSA:2.60.120.620:FF:000133', NULL, NULL, 'L-proline trans-4-hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(95591, NULL, 'G3DSA:3.40.930.10:FF:000038', NULL, NULL, 'Anion exchange protein', NULL, NULL, NULL, NULL, NULL, 4),
(95592, NULL, 'G3DSA:3.30.70.380:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(95593, NULL, 'G3DSA:3.30.160.60:FF:005965', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95594, NULL, 'G3DSA:2.130.10.10:FF:002407', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95595, NULL, 'G3DSA:2.70.170.10:FF:000033', NULL, NULL, 'Gamma-aminobutyric acid (GABA-A) receptor, subunit theta', NULL, NULL, NULL, NULL, NULL, 4),
(95596, NULL, 'G3DSA:3.30.160.60:FF:000390', NULL, NULL, 'Transcription factor stea', NULL, NULL, NULL, NULL, NULL, 4),
(95597, NULL, 'G3DSA:3.40.50.300:FF:007826', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95598, NULL, 'G3DSA:2.160.10.10:FF:000124', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95599, NULL, 'G3DSA:2.130.10.10:FF:004083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95600, NULL, 'G3DSA:2.60.40.2140:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95601, NULL, 'G3DSA:3.90.1410.10:FF:000032', NULL, NULL, 'Rubisco LSMT substrate-binding, putative', NULL, NULL, NULL, NULL, NULL, 4),
(95602, NULL, 'G3DSA:1.20.58.390:FF:000147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95603, NULL, 'G3DSA:3.40.50.300:FF:002806', NULL, NULL, 'Msh4p', NULL, NULL, NULL, NULL, NULL, 4),
(95604, NULL, 'G3DSA:1.10.510.10:FF:004118', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95605, NULL, 'G3DSA:3.40.1110.10:FF:000296', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95606, NULL, 'G3DSA:3.10.20.90:FF:000069', NULL, NULL, 'UV excision repair protein RAD23', NULL, NULL, NULL, NULL, NULL, 4),
(95607, NULL, 'G3DSA:2.60.520.10:FF:000001', NULL, NULL, 'Receptor binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(95608, NULL, 'G3DSA:1.10.220.150:FF:000032', NULL, NULL, 'ARF GAP', NULL, NULL, NULL, NULL, NULL, 4),
(95609, NULL, 'G3DSA:1.25.40.20:FF:001589', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95610, NULL, 'G3DSA:1.25.40.10:FF:001816', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(95611, NULL, 'G3DSA:1.10.150.50:FF:000191', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(95612, NULL, 'G3DSA:3.50.50.60:FF:001218', NULL, NULL, 'Thioredoxin reductase 2, tandem duplicate 2', NULL, NULL, NULL, NULL, NULL, 4),
(95613, NULL, 'G3DSA:3.10.130.10:FF:000001', NULL, NULL, 'Ribonuclease pancreatic', NULL, NULL, NULL, NULL, NULL, 4),
(95614, NULL, 'G3DSA:1.20.1250.20:FF:001517', NULL, NULL, 'Battenin', NULL, NULL, NULL, NULL, NULL, 4),
(95615, NULL, 'G3DSA:1.10.1200.270:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95616, NULL, 'G3DSA:1.10.275.10:FF:000007', NULL, NULL, 'Histidine ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(95617, NULL, 'G3DSA:1.10.555.10:FF:000271', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95618, NULL, 'G3DSA:3.40.50.410:FF:000367', NULL, NULL, 'MxaL protein', NULL, NULL, NULL, NULL, NULL, 4),
(95619, NULL, 'G3DSA:3.90.245.10:FF:000036', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95620, NULL, 'G3DSA:2.40.10.10:FF:000181', NULL, NULL, 'Chymotrypsinogen A', NULL, NULL, NULL, NULL, NULL, 4),
(95621, NULL, 'G3DSA:3.40.50.1820:FF:001238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95622, NULL, 'G3DSA:3.40.50.2000:FF:000112', NULL, NULL, 'Sucrose-phosphate synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(95623, NULL, 'G3DSA:2.80.10.50:FF:000275', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95624, NULL, 'G3DSA:1.25.40.10:FF:001586', NULL, NULL, 'RNA polymerase II transcription elongation factor (Ctr9), putative', NULL, NULL, NULL, NULL, NULL, 4),
(95625, NULL, 'G3DSA:3.20.20.70:FF:000670', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95626, NULL, 'G3DSA:3.40.50.1780:FF:000012', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor nar1', NULL, NULL, NULL, NULL, NULL, 4),
(95627, NULL, 'G3DSA:2.60.120.10:FF:000695', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(95628, NULL, 'G3DSA:3.30.160.60:FF:004661', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95629, NULL, 'G3DSA:3.40.50.720:FF:001292', NULL, NULL, 'Alcohol dehydrogenase class-P', NULL, NULL, NULL, NULL, NULL, 4),
(95630, NULL, 'G3DSA:1.10.10.60:FF:000261', NULL, NULL, 'Gastrulation brain homeobox 1', NULL, NULL, NULL, NULL, NULL, 4),
(95631, NULL, 'G3DSA:3.30.200.20:FF:001871', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(95632, NULL, 'G3DSA:2.60.120.10:FF:000583', NULL, NULL, 'Transcriptional regulator, Crp/Fnr family', NULL, NULL, NULL, NULL, NULL, 4),
(95633, NULL, 'G3DSA:2.40.100.10:FF:000125', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(95634, NULL, 'G3DSA:2.130.10.10:FF:000272', NULL, NULL, 'Ribosome biogenesis protein WDR12', NULL, NULL, NULL, NULL, NULL, 4),
(95635, NULL, 'G3DSA:2.30.30.910:FF:000002', NULL, NULL, 'Basal-body rod modification protein FlgD', NULL, NULL, NULL, NULL, NULL, 4),
(95636, NULL, 'G3DSA:1.20.1070.10:FF:000697', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95637, NULL, 'G3DSA:2.60.120.10:FF:000706', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95638, NULL, 'G3DSA:1.25.40.70:FF:000053', NULL, NULL, 'Putative phosphatidylinositol 4-kinase beta', NULL, NULL, NULL, NULL, NULL, 4),
(95639, NULL, 'G3DSA:1.20.1250.20:FF:000798', NULL, NULL, 'MFS transporter of unkown specificity', NULL, NULL, NULL, NULL, NULL, 4),
(95640, NULL, 'G3DSA:1.20.1250.20:FF:000686', NULL, NULL, 'Multidrug efflux pump Tap', NULL, NULL, NULL, NULL, NULL, 4),
(95641, NULL, 'G3DSA:3.90.550.10:FF:000043', NULL, NULL, 'UDP-N-acetylhexosamine pyrophosphorylase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(95642, NULL, 'G3DSA:3.80.10.10:FF:003543', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95643, NULL, 'G3DSA:3.40.50.720:FF:002489', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(95644, NULL, 'G3DSA:1.20.1270.280:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95645, NULL, 'G3DSA:3.40.50.720:FF:001180', NULL, NULL, 'Oxidoreductase, short chain dehydrogenase/reductase family protein, putative (AFU_orthologue AFUA_3G09150)', NULL, NULL, NULL, NULL, NULL, 4),
(95646, NULL, 'G3DSA:3.40.470.10:FF:000014', NULL, NULL, 'Uracil-DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(95647, NULL, 'G3DSA:1.25.40.20:FF:000622', NULL, NULL, 'Protein fem-1 B', NULL, NULL, NULL, NULL, NULL, 4),
(95648, NULL, 'G3DSA:1.25.10.10:FF:000454', NULL, NULL, 'Armadillo repeat containing 12', NULL, NULL, NULL, NULL, NULL, 4),
(95649, NULL, 'G3DSA:3.40.50.300:FF:000671', NULL, NULL, 'DNA helicase MCM9 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(95650, NULL, 'G3DSA:3.40.50.300:FF:004482', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(95651, NULL, 'G3DSA:2.40.10.10:FF:000304', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95652, NULL, 'G3DSA:1.10.10.630:FF:000001', NULL, NULL, 'DNA replication protein dnaD', NULL, NULL, NULL, NULL, NULL, 4),
(95653, NULL, 'G3DSA:3.40.50.2020:FF:000118', NULL, NULL, 'Adenine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(95654, NULL, 'G3DSA:1.10.20.10:FF:000325', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95655, NULL, 'G3DSA:1.25.40.20:FF:000392', NULL, NULL, 'Protein CfxQ-like', NULL, NULL, NULL, NULL, NULL, 4),
(95656, NULL, 'G3DSA:3.50.50.60:FF:000021', NULL, NULL, 'Ubiquinone biosynthesis monooxygenase COQ6', NULL, NULL, NULL, NULL, NULL, 4),
(95657, NULL, 'G3DSA:1.25.40.10:FF:002305', NULL, NULL, 'Tetratricopeptide repeat protein 30 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(95658, NULL, 'G3DSA:2.80.10.50:FF:000056', NULL, NULL, 'Glucan 1,3-beta-glucosidase A', NULL, NULL, NULL, NULL, NULL, 4),
(95659, NULL, 'G3DSA:1.20.1070.10:FF:001186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95660, NULL, 'G3DSA:2.40.128.630:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(95661, NULL, 'G3DSA:1.10.10.2740:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95662, NULL, 'G3DSA:3.40.50.150:FF:000704', NULL, NULL, 'Methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(95663, NULL, 'G3DSA:1.10.10.10:FF:000830', NULL, NULL, 'Pre-rRNA-processing protein FHL1', NULL, NULL, NULL, NULL, NULL, 4),
(95664, NULL, 'G3DSA:3.40.50.300:FF:004263', NULL, NULL, 'ADP-ribosylation factor L', NULL, NULL, NULL, NULL, NULL, 4),
(95665, NULL, 'G3DSA:3.40.50.300:FF:008534', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95666, NULL, 'G3DSA:1.25.40.10:FF:003840', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95667, NULL, 'G3DSA:1.20.58.80:FF:000062', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95668, NULL, 'G3DSA:3.40.1340.10:FF:000009', NULL, NULL, 'RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(95669, NULL, 'G3DSA:3.30.160.60:FF:002430', NULL, NULL, 'testis-specific zinc finger protein topi', NULL, NULL, NULL, NULL, NULL, 4),
(95670, NULL, 'G3DSA:4.10.81.20:FF:000001', NULL, NULL, 'Calcium-activated potassium channel beta 2 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(95671, NULL, 'G3DSA:3.40.50.300:FF:000901', NULL, NULL, 'Chromosome partition protein Smc', NULL, NULL, NULL, NULL, NULL, 4),
(95672, NULL, 'G3DSA:2.60.300.12:FF:000009', NULL, NULL, 'Fe-S cluster assembly protein HesB', NULL, NULL, NULL, NULL, NULL, 4),
(95673, NULL, 'G3DSA:1.10.510.10:FF:001937', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95674, NULL, 'G3DSA:3.30.160.60:FF:004116', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95675, NULL, 'G3DSA:2.130.10.10:FF:000502', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(95676, NULL, 'G3DSA:2.20.70.10:FF:000011', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(95677, NULL, 'G3DSA:3.40.50.10810:FF:000051', NULL, NULL, 'Helicase SWR1', NULL, NULL, NULL, NULL, NULL, 4),
(95678, NULL, 'G3DSA:2.30.29.30:FF:001253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95679, NULL, 'G3DSA:3.30.1120.10:FF:000074', NULL, NULL, 'Arylsulfatase homolog b1498', NULL, NULL, NULL, NULL, NULL, 4),
(95680, NULL, 'G3DSA:2.170.150.80:FF:000028', NULL, NULL, 'At5g18300', NULL, NULL, NULL, NULL, NULL, 4),
(95681, NULL, 'G3DSA:2.60.40.3500:FF:000007', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(95682, NULL, 'G3DSA:2.60.40.10:FF:000524', NULL, NULL, 'Interleukin-6 receptor subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(95683, NULL, 'G3DSA:2.60.40.150:FF:000207', NULL, NULL, 'DExH-box ATP-dependent RNA helicase DExH14', NULL, NULL, NULL, NULL, NULL, 4),
(95684, NULL, 'G3DSA:3.10.290.10:FF:000057', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(95685, NULL, 'G3DSA:3.40.30.10:FF:000461', NULL, NULL, 'viral IAP-associated factor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(95686, NULL, 'G3DSA:1.20.120.330:FF:000033', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(95687, NULL, 'G3DSA:1.10.510.10:FF:000740', NULL, NULL, 'SNF1-related protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(95688, NULL, 'G3DSA:3.40.50.10860:FF:000037', NULL, NULL, 'Methylenetetrahydrofolate dehydrogenase (NADP+ dependent) 1b', NULL, NULL, NULL, NULL, NULL, 4),
(95689, NULL, 'G3DSA:2.60.40.2130:FF:000001', NULL, NULL, 'Spondin 1a', NULL, NULL, NULL, NULL, NULL, 4),
(95690, NULL, 'G3DSA:3.30.160.60:FF:005746', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95691, NULL, 'G3DSA:2.60.40.1180:FF:000031', NULL, NULL, 'Alpha-xylosidase', NULL, NULL, NULL, NULL, NULL, 4),
(95692, NULL, 'G3DSA:1.25.40.1010:FF:000001', NULL, NULL, 'N-alpha-acetyltransferase 15, NatA auxiliary subunit', NULL, NULL, NULL, NULL, NULL, 4),
(95693, NULL, 'G3DSA:2.40.30.10:FF:000406', NULL, NULL, 'Eukaryotic translation initiation factor 2 subunit 3', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(95694, NULL, 'G3DSA:1.10.533.10:FF:000091', NULL, NULL, 'NLR family pyrin domain containing 10', NULL, NULL, NULL, NULL, NULL, 4),
(95695, NULL, 'G3DSA:1.10.150.250:FF:000006', NULL, NULL, 'Succinate dehydrogenase assembly factor 2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(95696, NULL, 'G3DSA:3.40.50.300:FF:004049', NULL, NULL, 'ATP-binding cassette, sub-family B (MDR/TAP), member 11b', NULL, NULL, NULL, NULL, NULL, 4),
(95697, NULL, 'G3DSA:1.10.150.240:FF:000003', NULL, NULL, 'Phosphoglycolate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(95698, NULL, 'G3DSA:2.60.40.10:FF:004116', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95699, NULL, 'G3DSA:2.30.30.140:FF:000299', NULL, NULL, 'Suppressor of fused homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(95700, NULL, 'G3DSA:1.10.472.10:FF:000173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95701, NULL, 'G3DSA:1.20.1270.60:FF:000339', NULL, NULL, 'AFR651Wp', NULL, NULL, NULL, NULL, NULL, 4),
(95702, NULL, 'G3DSA:3.40.140.10:FF:000028', NULL, NULL, 'Cytidine and dCMP deaminase domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(95703, NULL, 'G3DSA:3.30.1600.10:FF:000004', NULL, NULL, 'NAD-dependent deacetylase sir2A', NULL, NULL, NULL, NULL, NULL, 4),
(95704, NULL, 'G3DSA:3.30.70.100:FF:000191', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95705, NULL, 'G3DSA:1.25.40.20:FF:000515', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(95706, NULL, 'G3DSA:3.80.10.10:FF:003436', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95707, NULL, 'G3DSA:1.10.20.10:FF:000106', NULL, NULL, 'Centromeric histone 3', NULL, NULL, NULL, NULL, NULL, 4),
(95708, NULL, 'G3DSA:3.80.10.10:FF:003094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95709, NULL, 'G3DSA:3.30.160.60:FF:001699', NULL, NULL, 'zinc finger protein 527 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(95710, NULL, 'G3DSA:3.90.1290.10:FF:000038', NULL, NULL, 'VAB-10A protein', NULL, NULL, NULL, NULL, NULL, 4),
(95711, NULL, 'G3DSA:1.25.40.180:FF:000188', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95712, NULL, 'G3DSA:3.30.420.40:FF:000005', NULL, NULL, 'heat shock 70 kDa protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(95713, NULL, 'G3DSA:1.20.200.10:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95714, NULL, 'G3DSA:3.30.9.10:FF:000193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95715, NULL, 'G3DSA:1.10.357.20:FF:000004', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(95716, NULL, 'G3DSA:3.40.50.720:FF:001185', NULL, NULL, 'Trk system potassium uptake protein CeoB', NULL, NULL, NULL, NULL, NULL, 4),
(95717, NULL, 'G3DSA:3.40.50.300:FF:004044', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95718, NULL, 'G3DSA:1.25.40.10:FF:000512', NULL, NULL, 'Signal recognition particle subunit SRP72', NULL, NULL, NULL, NULL, NULL, 4),
(95719, NULL, 'G3DSA:3.40.30.10:FF:000680', NULL, NULL, 'Chloride intracellular channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(95720, NULL, 'G3DSA:3.40.50.1000:FF:000481', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95721, NULL, 'G3DSA:2.130.10.10:FF:005499', NULL, NULL, 'WD repeat domain 90', NULL, NULL, NULL, NULL, NULL, 4),
(95722, NULL, 'G3DSA:3.30.890.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95723, NULL, 'G3DSA:3.40.50.300:FF:006180', NULL, NULL, 'tRNA modification GTPase MnmE', NULL, NULL, NULL, NULL, NULL, 4),
(95724, NULL, 'G3DSA:1.20.120.350:FF:000039', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(95725, NULL, 'G3DSA:2.20.70.10:FF:000230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95726, NULL, 'G3DSA:2.30.30.380:FF:000028', NULL, NULL, 'Tamo, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(95727, NULL, 'G3DSA:3.40.1090.10:FF:000130', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(95728, NULL, 'G3DSA:3.30.310.130:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95729, NULL, 'G3DSA:3.30.70.330:FF:001552', NULL, NULL, 'RNA-binding region (RNP1, RRM)-containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(95730, NULL, 'G3DSA:1.10.287.110:FF:000306', NULL, NULL, 'DNaJ domain (Prokaryotic heat shock protein)', NULL, NULL, NULL, NULL, NULL, 4),
(95731, NULL, 'G3DSA:2.60.200.20:FF:000070', NULL, NULL, 'Ovarian-specific serine/threonine-protein kinase Lok', NULL, NULL, NULL, NULL, NULL, 4),
(95732, NULL, 'G3DSA:1.10.274.30:FF:000016', NULL, NULL, 'Uncharacterized protein R102.4-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(95733, NULL, 'G3DSA:3.30.160.60:FF:003953', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95734, NULL, 'G3DSA:2.40.290.10:FF:000015', NULL, NULL, 'Glutamate Receptor Level Decreased', NULL, NULL, NULL, NULL, NULL, 4),
(95735, NULL, 'G3DSA:3.30.60.30:FF:000143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95736, NULL, 'G3DSA:1.10.357.10:FF:000001', NULL, NULL, 'HTH-type transcriptional repressor FabR', NULL, NULL, NULL, NULL, NULL, 4),
(95737, NULL, 'G3DSA:3.30.160.60:FF:004223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95738, NULL, 'G3DSA:2.40.70.10:FF:000403', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95739, NULL, 'G3DSA:1.25.40.120:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95740, NULL, 'G3DSA:3.30.300.20:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95741, NULL, 'G3DSA:2.130.10.10:FF:005847', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95742, NULL, 'G3DSA:3.40.50.620:FF:000767', NULL, NULL, 'Glutamate--tRNA ligase chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(95743, NULL, 'G3DSA:3.30.1330.10:FF:000011', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase subunit PurL', NULL, NULL, NULL, NULL, NULL, 4),
(95744, NULL, 'G3DSA:2.30.180.10:FF:000060', NULL, NULL, 'Protein CBG03800', NULL, NULL, NULL, NULL, NULL, 4),
(95745, NULL, 'G3DSA:6.10.250.3330:FF:000002', NULL, NULL, 'Secreted effector protein EspF(U)', NULL, NULL, NULL, NULL, NULL, 4),
(95746, NULL, 'G3DSA:2.60.40.10:FF:002536', NULL, NULL, 'Limbic system-associated membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(95747, NULL, 'G3DSA:2.80.10.50:FF:000168', NULL, NULL, 'Inositol 1,4,5-trisphosphate receptor, type 3', NULL, NULL, NULL, NULL, NULL, 4),
(95748, NULL, 'G3DSA:1.10.10.10:FF:001808', NULL, NULL, 'Cullin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(95749, NULL, 'G3DSA:3.50.50.60:FF:001095', NULL, NULL, '5-demethoxyubiquinone hydroxylase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(95750, NULL, 'G3DSA:2.130.10.10:FF:001576', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95751, NULL, 'G3DSA:3.90.660.20:FF:000020', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(95752, NULL, 'G3DSA:3.80.10.10:FF:000795', NULL, NULL, 'Antagonist of mitotic exit network', NULL, NULL, NULL, NULL, NULL, 4),
(95753, NULL, 'G3DSA:3.40.50.300:FF:002251', NULL, NULL, 'Glutathione import ATP-binding protein GsiA', NULL, NULL, NULL, NULL, NULL, 4),
(95754, NULL, 'G3DSA:1.25.40.20:FF:000280', NULL, NULL, 'E3 ubiquitin-protein ligase KEG', NULL, NULL, NULL, NULL, NULL, 4),
(95755, NULL, 'G3DSA:2.40.160.20:FF:000014', NULL, NULL, 'Outer membrane protein, MSP2 family', NULL, NULL, NULL, NULL, NULL, 4),
(95756, NULL, 'G3DSA:1.10.630.10:FF:000575', NULL, NULL, 'LOC100127852 protein', NULL, NULL, NULL, NULL, NULL, 4),
(95757, NULL, 'G3DSA:2.120.10.80:FF:000220', NULL, NULL, 'Protein CBG01796', NULL, NULL, NULL, NULL, NULL, 4),
(95758, NULL, 'G3DSA:1.10.1420.10:FF:000007', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(95759, NULL, 'G3DSA:1.10.3080.10:FF:000037', NULL, NULL, 'CIC chloride ion channel family Cl-:H+ antiporter', NULL, NULL, NULL, NULL, NULL, 4),
(95760, NULL, 'G3DSA:1.10.510.10:FF:000521', NULL, NULL, 'Tyrosine-protein kinase pr2', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(95761, NULL, 'G3DSA:2.60.40.420:FF:000199', NULL, NULL, 'Ubiquinol oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(95762, NULL, 'G3DSA:3.10.20.90:FF:000743', NULL, NULL, 'Kinesin-like calmodulin binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(95763, NULL, 'G3DSA:2.40.50.150:FF:000017', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(95764, NULL, 'G3DSA:3.30.505.10:FF:000255', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95765, NULL, 'G3DSA:2.40.50.100:FF:000031', NULL, NULL, '39S ribosomal protein L27, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(95766, NULL, 'G3DSA:3.60.21.10:FF:000085', NULL, NULL, 'Putative ser/thr protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(95767, NULL, 'G3DSA:2.60.40.10:FF:005870', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95768, NULL, 'G3DSA:3.40.50.300:FF:001975', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(95769, NULL, 'G3DSA:1.10.287.70:FF:000665', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95770, NULL, 'G3DSA:3.40.50.300:FF:006522', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95771, NULL, 'G3DSA:3.30.200.20:FF:001197', NULL, NULL, 'Myosin heavy chain kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(95772, NULL, 'G3DSA:1.20.1070.10:FF:001528', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95773, NULL, 'G3DSA:1.10.510.10:FF:000173', NULL, NULL, 'proline-rich receptor-like protein kinase PERK8', NULL, NULL, NULL, NULL, NULL, 4),
(95774, NULL, 'G3DSA:1.10.238.10:FF:000814', NULL, NULL, 'Calcium-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(95775, NULL, 'G3DSA:2.60.40.60:FF:000511', NULL, NULL, 'Cadherin-related hmr-1', NULL, NULL, NULL, NULL, NULL, 4),
(95776, NULL, 'G3DSA:3.30.60.20:FF:000140', NULL, NULL, 'Protein kinase C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(95777, NULL, 'G3DSA:2.60.40.10:FF:000743', NULL, NULL, 'myelin-associated glycoprotein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(95778, NULL, 'G3DSA:3.40.50.2000:FF:000697', NULL, NULL, 'Glycosyl transferase group 1', NULL, NULL, NULL, NULL, NULL, 4),
(95779, NULL, 'G3DSA:2.40.50.140:FF:000014', NULL, NULL, '30S ribosomal protein S17', NULL, NULL, NULL, NULL, NULL, 4),
(95780, NULL, 'G3DSA:2.20.70.10:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95781, NULL, 'G3DSA:2.40.30.10:FF:000283', NULL, NULL, 'Ferric reductase transmembrane component, putative', NULL, NULL, NULL, NULL, NULL, 4),
(95782, NULL, 'G3DSA:1.25.10.10:FF:001758', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95783, NULL, 'G3DSA:3.30.200.20:FF:000117', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(95784, NULL, 'G3DSA:3.40.140.10:FF:000023', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(95785, NULL, 'G3DSA:2.60.40.150:FF:000319', NULL, NULL, 'Coiled-coil and C2 domain-containing protein 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(95786, NULL, 'G3DSA:3.30.70.1230:FF:000064', NULL, NULL, 'Adenylate cyclase type 9', NULL, NULL, NULL, NULL, NULL, 4),
(95787, NULL, 'G3DSA:1.10.510.10:FF:004444', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95788, NULL, 'G3DSA:3.40.50.300:FF:005898', NULL, NULL, 'tRNA modification GTPase gtpbp3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(95789, NULL, 'G3DSA:2.170.270.10:FF:000207', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(95790, NULL, 'G3DSA:1.25.40.420:FF:000069', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95791, NULL, 'G3DSA:2.60.120.200:FF:000687', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95792, NULL, 'G3DSA:1.10.10.10:FF:000504', NULL, NULL, 'Rho guanyl nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(95793, NULL, 'G3DSA:1.20.1740.10:FF:000097', NULL, NULL, 'Amino acid transporter, putative', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(95794, NULL, 'G3DSA:3.20.20.370:FF:000033', NULL, NULL, 'LP01646p', NULL, NULL, NULL, NULL, NULL, 4),
(95795, NULL, 'G3DSA:3.40.30.10:FF:000573', NULL, NULL, 'AGAP003415-PA', NULL, NULL, NULL, NULL, NULL, 4),
(95796, NULL, 'G3DSA:3.40.50.300:FF:008315', NULL, NULL, 'ABC transporter G family member 20', NULL, NULL, NULL, NULL, NULL, 4),
(95797, NULL, 'G3DSA:2.30.30.40:FF:000034', NULL, NULL, 'Rho guanine nucleotide exchange factor (GEF) 7', NULL, NULL, NULL, NULL, NULL, 4),
(95798, NULL, 'G3DSA:4.10.410.10:FF:000058', NULL, NULL, 'Protein CBR-MEC-9', NULL, NULL, NULL, NULL, NULL, 4),
(95799, NULL, 'G3DSA:1.25.10.10:FF:002034', NULL, NULL, 'Armadillo/beta-catenin-like repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(95800, NULL, 'G3DSA:2.130.10.10:FF:001918', NULL, NULL, 'Si:ch211-248g20.5', NULL, NULL, NULL, NULL, NULL, 4),
(95801, NULL, 'G3DSA:1.25.40.20:FF:000173', NULL, NULL, 'Fem-1 homolog c (C.elegans)', NULL, NULL, NULL, NULL, NULL, 4),
(95802, NULL, 'G3DSA:2.10.25.10:FF:000699', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(95803, NULL, 'G3DSA:3.10.290.10:FF:000052', NULL, NULL, 'S4 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(95804, NULL, 'G3DSA:1.25.40.10:FF:000170', NULL, NULL, 'Trafficking protein particle complex subunit 12', NULL, NULL, NULL, NULL, NULL, 4),
(95805, NULL, 'G3DSA:2.30.29.30:FF:000983', NULL, NULL, 'cDNA FLJ54163, highly similar to Centaurin-alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(95806, NULL, 'G3DSA:3.60.21.10:FF:000433', NULL, NULL, '3'',5''-cyclic adenosine monophosphate phosphodiesterase CpdA', NULL, NULL, NULL, NULL, NULL, 4),
(95807, NULL, 'G3DSA:3.50.50.60:FF:001437', NULL, NULL, 'Putative bifunctional amine oxidase DDB_G0291301', NULL, NULL, NULL, NULL, NULL, 4),
(95808, NULL, 'G3DSA:4.10.60.10:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95809, NULL, 'G3DSA:2.40.40.50:FF:000003', NULL, NULL, 'UFD1 isoform 10', NULL, NULL, NULL, NULL, NULL, 4),
(95810, NULL, 'G3DSA:2.30.30.30:FF:000031', NULL, NULL, '40S ribosomal protein S4-3', NULL, NULL, NULL, NULL, NULL, 4),
(95811, NULL, 'G3DSA:3.90.70.40:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95812, NULL, 'G3DSA:3.30.1490.20:FF:000065', NULL, NULL, 'Formate-dependent phosphoribosylglycinamide formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(95813, NULL, 'G3DSA:3.30.1150.10:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95814, NULL, 'G3DSA:3.90.1410.10:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95815, NULL, 'G3DSA:1.10.630.10:FF:000794', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95816, NULL, 'G3DSA:3.30.830.10:FF:000038', NULL, NULL, 'Zinc protease, insulinase family', NULL, NULL, NULL, NULL, NULL, 4),
(95817, NULL, 'G3DSA:3.40.33.10:FF:000158', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95818, NULL, 'G3DSA:3.30.160.60:FF:000513', NULL, NULL, 'POZ-, AT hook-, and zinc finger-containing protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(95819, NULL, 'G3DSA:2.60.40.4370:FF:000004', NULL, NULL, 'Transcription factor tau 55 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(95820, NULL, 'G3DSA:2.130.10.10:FF:001795', NULL, NULL, 'Os07g0224900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(95821, NULL, 'G3DSA:1.25.40.10:FF:003598', NULL, NULL, 'TPR repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(95822, NULL, 'G3DSA:3.40.50.300:FF:002470', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(95823, NULL, 'G3DSA:2.60.40.10:FF:001828', NULL, NULL, 'Thy-1 membrane glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(95824, NULL, 'G3DSA:3.30.60.20:FF:000033', NULL, NULL, 'Rac GTPase-activating protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(95825, NULL, 'G3DSA:1.25.40.20:FF:000841', NULL, NULL, 'Protein CBR-DAPK-1', NULL, NULL, NULL, NULL, NULL, 4),
(95826, NULL, 'G3DSA:3.40.50.300:FF:006741', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(95827, NULL, 'G3DSA:1.10.510.10:FF:004006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95828, NULL, 'G3DSA:3.30.160.60:FF:000171', NULL, NULL, 'Zinc finger protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(95829, NULL, 'G3DSA:3.30.505.10:FF:000036', NULL, NULL, 'Suppressor of cytokine signaling 6', NULL, NULL, NULL, NULL, NULL, 4),
(95830, NULL, 'G3DSA:2.30.29.30:FF:001146', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95831, NULL, 'G3DSA:3.40.800.20:FF:000043', NULL, NULL, 'Histone deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(95832, NULL, 'G3DSA:3.40.1380.10:FF:000006', NULL, NULL, 'ATP synthase gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(95833, NULL, 'G3DSA:1.10.533.10:FF:000214', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95834, NULL, 'G3DSA:2.160.10.10:FF:000012', NULL, NULL, 'Carnitine operon protein CaiE', NULL, NULL, NULL, NULL, NULL, 4),
(95835, NULL, 'G3DSA:3.30.60.30:FF:000036', NULL, NULL, 'Ovomucoid', NULL, NULL, NULL, NULL, NULL, 4),
(95836, NULL, 'G3DSA:3.30.390.10:FF:000009', NULL, NULL, 'Hydrophobic dipeptide epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(95837, NULL, 'G3DSA:1.10.30.10:FF:000051', NULL, NULL, 'Transcription factor Sox-10', NULL, NULL, NULL, NULL, NULL, 4),
(95838, NULL, 'G3DSA:3.20.20.80:FF:000785', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95839, NULL, 'G3DSA:3.10.250.10:FF:000055', NULL, NULL, 'Deleted in malignant brain tumors 1', NULL, NULL, NULL, NULL, NULL, 4),
(95840, NULL, 'G3DSA:3.30.160.60:FF:004442', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95841, NULL, 'G3DSA:3.40.800.10:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95842, NULL, 'G3DSA:2.10.25.10:FF:000817', NULL, NULL, 'Stabilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(95843, NULL, 'G3DSA:1.25.40.250:FF:000001', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit K', NULL, NULL, NULL, NULL, NULL, 4),
(95844, NULL, 'G3DSA:2.60.40.10:FF:002317', NULL, NULL, 'Lymphocyte antigen 6 complex locus protein G6d', NULL, NULL, NULL, NULL, NULL, 4),
(95845, NULL, 'G3DSA:3.20.20.70:FF:000782', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95846, NULL, 'G3DSA:3.40.1380.20:FF:000009', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(95847, NULL, 'G3DSA:1.20.58.2220:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95848, NULL, 'G3DSA:3.40.50.1390:FF:000002', NULL, NULL, 'ORF1 in transposon ISC1904', NULL, NULL, NULL, NULL, NULL, 4),
(95849, NULL, 'G3DSA:2.60.120.10:FF:000818', NULL, NULL, 'Homogentisate 12-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(95850, NULL, 'G3DSA:2.60.40.10:FF:002104', NULL, NULL, 'Fc receptor-like B', NULL, NULL, NULL, NULL, NULL, 4),
(95851, NULL, 'G3DSA:3.40.630.10:FF:000217', NULL, NULL, 'M18 family aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(95852, NULL, 'G3DSA:1.25.40.10:FF:004222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95853, NULL, 'G3DSA:3.90.70.170:FF:000001', NULL, NULL, 'Gifsy-2 prophage protein', NULL, NULL, NULL, NULL, NULL, 4),
(95854, NULL, 'G3DSA:1.10.10.1940:FF:000006', NULL, NULL, 'Matrix metallopeptidase 23bb', NULL, NULL, NULL, NULL, NULL, 4),
(95855, NULL, 'G3DSA:3.20.20.220:FF:000016', NULL, NULL, 'Methylenetetrahydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(95856, NULL, 'G3DSA:2.40.160.10:FF:000011', NULL, NULL, 'mitochondrial import receptor subunit TOM40 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(95857, NULL, 'G3DSA:1.20.1070.10:FF:001309', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95858, NULL, 'G3DSA:1.20.1250.20:FF:000793', NULL, NULL, 'GG12415', NULL, NULL, NULL, NULL, NULL, 4),
(95859, NULL, 'G3DSA:3.30.40.10:FF:001900', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95860, NULL, 'G3DSA:3.40.50.40:FF:000004', NULL, NULL, 'Type II asparaginase', NULL, NULL, NULL, NULL, NULL, 4),
(95861, NULL, 'G3DSA:3.40.50.1820:FF:000856', NULL, NULL, 'Prolylcarboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(95862, NULL, 'G3DSA:3.90.226.10:FF:000003', NULL, NULL, '1,4-dihydroxy-2-naphthoyl-CoA synthase', NULL, NULL, NULL, NULL, NULL, 4),
(95863, NULL, 'G3DSA:3.30.2350.20:FF:000009', NULL, NULL, 'Pseudouridine synthase TruD/Pus7, putative', NULL, NULL, NULL, NULL, NULL, 4),
(95864, NULL, 'G3DSA:3.30.70.380:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95865, NULL, 'G3DSA:3.40.1110.10:FF:000189', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(95866, NULL, 'G3DSA:3.30.1330.20:FF:000014', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(95867, NULL, 'G3DSA:3.40.605.10:FF:000036', NULL, NULL, 'Phenylacetic acid degradation protein MaoC', NULL, NULL, NULL, NULL, NULL, 4),
(95868, NULL, 'G3DSA:3.40.50.10420:FF:000041', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(95869, NULL, 'G3DSA:2.40.100.10:FF:000120', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(95870, NULL, 'G3DSA:1.10.10.440:FF:000039', NULL, NULL, 'Repeat organellar protein', NULL, NULL, NULL, NULL, NULL, 4),
(95871, NULL, 'G3DSA:3.20.20.210:FF:000013', NULL, NULL, 'Methanosarcina family methyltransferase cognate corrinoid protein', NULL, NULL, NULL, NULL, NULL, 4),
(95872, NULL, 'G3DSA:3.80.10.10:FF:003217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95873, NULL, 'G3DSA:2.30.30.210:FF:000005', NULL, NULL, 'Ribonuclease P protein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(95874, NULL, 'G3DSA:3.90.550.50:FF:000133', NULL, NULL, 'Beta-1,3-N-acetylglucosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(95875, NULL, 'G3DSA:1.20.1310.10:FF:000160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95876, NULL, 'G3DSA:3.40.50.1440:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95877, NULL, 'G3DSA:3.40.50.1000:FF:000262', NULL, NULL, 'Hydrolase, haloacid dehalogenase-like family', NULL, NULL, NULL, NULL, NULL, 4),
(95878, NULL, 'G3DSA:1.25.40.10:FF:003385', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g37230', NULL, NULL, NULL, NULL, NULL, 4),
(95879, NULL, 'G3DSA:2.130.10.10:FF:002284', NULL, NULL, 'Anaphase-promoting complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(95880, NULL, 'G3DSA:2.70.170.10:FF:000252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95881, NULL, 'G3DSA:1.10.1280.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95882, NULL, 'G3DSA:1.10.418.70:FF:000009', NULL, NULL, 'Intraflagellar transport protein 81-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(95883, NULL, 'G3DSA:3.30.70.2130:FF:000002', NULL, NULL, 'Bisphosphoglycerate-independent phosphoglycerate mutase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(95884, NULL, 'G3DSA:1.20.1110.10:FF:000178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95885, NULL, 'G3DSA:1.10.418.60:FF:000006', NULL, NULL, 'Related to Myosin-like protein NUF2', NULL, NULL, NULL, NULL, NULL, 4),
(95886, NULL, 'G3DSA:1.10.246.60:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95887, NULL, 'G3DSA:1.10.510.10:FF:004225', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95888, NULL, 'G3DSA:3.40.50.1010:FF:000265', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95889, NULL, 'G3DSA:3.30.1330.30:FF:000017', NULL, NULL, 'RNA methyltransferase TrmH family group 3', NULL, NULL, NULL, NULL, NULL, 4),
(95890, NULL, 'G3DSA:1.25.40.10:FF:001923', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(95891, NULL, 'G3DSA:2.30.30.40:FF:000253', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(95892, NULL, 'G3DSA:1.10.3720.10:FF:000160', NULL, NULL, 'Oligopeptide ABC transporter, permease protein (OppC)', NULL, NULL, NULL, NULL, NULL, 4),
(95893, NULL, 'G3DSA:1.10.1410.10:FF:000052', NULL, NULL, 'GM17772', NULL, NULL, NULL, NULL, NULL, 4),
(95894, NULL, 'G3DSA:3.40.50.10470:FF:000027', NULL, NULL, 'Putative translation initiation factor eif-2b beta subunit', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(95895, NULL, 'G3DSA:3.30.420.10:FF:000676', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95896, NULL, 'G3DSA:1.25.10.10:FF:002253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95897, NULL, 'G3DSA:3.40.50.150:FF:000367', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase B', NULL, NULL, NULL, NULL, NULL, 4),
(95898, NULL, 'G3DSA:3.30.160.60:FF:002188', NULL, NULL, 'RE1-silencing transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(95899, NULL, 'G3DSA:1.10.510.10:FF:003736', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95900, NULL, 'G3DSA:3.40.30.10:FF:000909', NULL, NULL, 'Iodothyronine deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(95901, NULL, 'G3DSA:2.60.120.10:FF:000257', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(95902, NULL, 'G3DSA:1.10.220.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95903, NULL, 'G3DSA:1.10.10.10:FF:000381', NULL, NULL, 'Fur family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(95904, NULL, 'G3DSA:2.40.20.10:FF:000125', NULL, NULL, 'Plasminogen', NULL, NULL, NULL, NULL, NULL, 4),
(95905, NULL, 'G3DSA:3.10.170.20:FF:000006', NULL, NULL, 'Leishmanolysin like peptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(95906, NULL, 'G3DSA:2.60.40.10:FF:006033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95907, NULL, 'G3DSA:3.40.30.10:FF:000354', NULL, NULL, 'Caspar, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(95908, NULL, 'G3DSA:2.130.10.10:FF:002071', NULL, NULL, 'Ribosome biogenesis protein WDR12 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(95909, NULL, 'G3DSA:2.30.30.40:FF:000601', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95910, NULL, 'G3DSA:3.40.50.200:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95911, NULL, 'G3DSA:1.10.510.10:FF:002319', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95912, NULL, 'G3DSA:3.10.170.10:FF:000003', NULL, NULL, 'Peptidase M28', NULL, NULL, NULL, NULL, NULL, 4),
(95913, NULL, 'G3DSA:1.25.10.10:FF:001977', NULL, NULL, 'Phosphatidylinositol 3 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(95914, NULL, 'G3DSA:3.40.50.1000:FF:000604', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95915, NULL, 'G3DSA:1.50.40.10:FF:000549', NULL, NULL, 'Mitochondrial substrate carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(95916, NULL, 'G3DSA:3.60.10.10:FF:000296', NULL, NULL, 'AEL090Cp', NULL, NULL, NULL, NULL, NULL, 4),
(95917, NULL, 'G3DSA:3.40.630.30:FF:000555', NULL, NULL, 'Acetyltransferase (GNAT) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(95918, NULL, 'G3DSA:2.60.40.10:FF:002430', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95919, NULL, 'G3DSA:2.120.10.80:FF:000001', NULL, NULL, 'Kelch-like family member 13', NULL, NULL, NULL, NULL, NULL, 4),
(95920, NULL, 'G3DSA:3.40.50.1240:FF:000204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95921, NULL, 'G3DSA:1.10.1440.10:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95922, NULL, 'G3DSA:1.10.510.10:FF:002426', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95923, NULL, 'G3DSA:1.25.10.10:FF:000123', NULL, NULL, 'Importin 9', NULL, NULL, NULL, NULL, NULL, 4),
(95924, NULL, 'G3DSA:3.40.630.30:FF:000561', NULL, NULL, 'Glycylpeptide N-tetradecanoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(95925, NULL, 'G3DSA:3.10.20.90:FF:000530', NULL, NULL, 'Autophagy-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(95926, NULL, 'G3DSA:1.10.3380.10:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95927, NULL, 'G3DSA:3.30.360.10:FF:000058', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(95928, NULL, 'G3DSA:1.20.1280.50:FF:000275', NULL, NULL, 'Protein aardvark', NULL, NULL, NULL, NULL, NULL, 4),
(95929, NULL, 'G3DSA:1.50.40.10:FF:000443', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(95930, NULL, 'G3DSA:1.10.3720.10:FF:000053', NULL, NULL, 'Amino acid ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(95931, NULL, 'G3DSA:1.25.10.10:FF:002247', NULL, NULL, 'Pumilio/PUF RNA binding protein 4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(95932, NULL, 'G3DSA:3.40.710.10:FF:000168', NULL, NULL, 'Cell division protein FtsI [Peptidoglycan synthetase]', NULL, NULL, NULL, NULL, NULL, 4),
(95933, NULL, 'G3DSA:1.20.1380.10:FF:000001', NULL, NULL, 'Negative modulator of initiation of replication', NULL, NULL, NULL, NULL, NULL, 4),
(95934, NULL, 'G3DSA:1.10.1040.50:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95935, NULL, 'G3DSA:1.20.1280.50:FF:000269', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95936, NULL, 'G3DSA:2.60.40.3210:FF:000022', NULL, NULL, 'Transforming growth factor, beta receptor III', NULL, NULL, NULL, NULL, NULL, 4),
(95937, NULL, 'G3DSA:3.40.50.2300:FF:001175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95938, NULL, 'G3DSA:1.10.8.60:FF:000288', NULL, NULL, 'Putative AAA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(95939, NULL, 'G3DSA:3.40.30.10:FF:000792', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95940, NULL, 'G3DSA:3.10.20.90:FF:000524', NULL, NULL, 'Probable splicing factor 3A subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(95941, NULL, 'G3DSA:1.10.510.10:FF:000302', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(95942, NULL, 'G3DSA:3.40.50.300:FF:008085', NULL, NULL, 'RecQ like helicase 4', NULL, NULL, NULL, NULL, NULL, 4),
(95943, NULL, 'G3DSA:4.10.400.10:FF:000125', NULL, NULL, 'LDL receptor related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(95944, NULL, 'G3DSA:3.30.870.10:FF:000142', NULL, NULL, 'Phospholipase D B', NULL, NULL, NULL, NULL, NULL, 4),
(95945, NULL, 'G3DSA:1.20.1070.10:FF:001080', NULL, NULL, 'Substance-K receptor', NULL, NULL, NULL, NULL, NULL, 4),
(95946, NULL, 'G3DSA:3.30.505.10:FF:000143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95947, NULL, 'G3DSA:3.40.50.720:FF:001415', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(95948, NULL, 'G3DSA:2.60.120.1540:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95949, NULL, 'G3DSA:3.30.200.20:FF:002028', NULL, NULL, 'Protein CBG12846', NULL, NULL, NULL, NULL, NULL, 4),
(95950, NULL, 'G3DSA:3.30.70.1230:FF:000277', NULL, NULL, 'Adenylate cyclase 5-like', NULL, NULL, NULL, NULL, NULL, 4),
(95951, NULL, 'G3DSA:3.30.420.40:FF:000218', NULL, NULL, 'actin, alpha sarcomeric/skeletal-like', NULL, NULL, NULL, NULL, NULL, 4),
(95952, NULL, 'G3DSA:2.130.10.10:FF:005735', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95953, NULL, 'G3DSA:2.60.40.10:FF:004560', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95954, NULL, 'G3DSA:3.30.870.10:FF:000035', NULL, NULL, 'Phospholipase D domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(95955, NULL, 'G3DSA:1.10.565.10:FF:000097', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(95956, NULL, 'G3DSA:3.40.50.300:FF:002357', NULL, NULL, 'Glutathione S-transferase class-mu 26 kDa isozyme', NULL, NULL, NULL, NULL, NULL, 4),
(95957, NULL, 'G3DSA:2.170.270.10:FF:000101', NULL, NULL, 'Putative positive regulatory Domain/B-lymphocyte induced maturation protein 1, version B', NULL, NULL, NULL, NULL, NULL, 4),
(95958, NULL, 'G3DSA:3.30.70.330:FF:001771', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95959, NULL, 'G3DSA:3.60.21.10:FF:000208', NULL, NULL, '3'',5''-cyclic adenosine monophosphate phosphodiesterase CpdA', NULL, NULL, NULL, NULL, NULL, 4),
(95960, NULL, 'G3DSA:1.10.1040.30:FF:000012', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(95961, NULL, 'G3DSA:3.80.10.10:FF:000918', NULL, NULL, 'Slit protein', NULL, NULL, NULL, NULL, NULL, 4),
(95962, NULL, 'G3DSA:2.170.300.10:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(95963, NULL, 'G3DSA:3.90.70.10:FF:000146', NULL, NULL, 'Ubiquitin-specific protease', NULL, NULL, NULL, NULL, NULL, 4),
(95964, NULL, 'G3DSA:3.30.160.60:FF:001929', NULL, NULL, 'paternally-expressed gene 3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(95965, NULL, 'G3DSA:3.40.640.10:FF:000050', NULL, NULL, 'Serine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(95966, NULL, 'G3DSA:2.130.10.10:FF:002290', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(95967, NULL, 'G3DSA:1.10.3790.10:FF:000001', NULL, NULL, 'DLP12 prophage DNA base-flipping protein', NULL, NULL, NULL, NULL, NULL, 4),
(95968, NULL, 'G3DSA:3.90.190.10:FF:000397', NULL, NULL, 'Protein-tyrosine-phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(95969, NULL, 'G3DSA:3.90.132.10:FF:000010', NULL, NULL, 'GP63-like', NULL, NULL, NULL, NULL, NULL, 4),
(95970, NULL, 'G3DSA:1.25.40.10:FF:003379', NULL, NULL, 'Pre-mRNA-splicing factor CLF1', NULL, NULL, NULL, NULL, NULL, 4),
(95971, NULL, 'G3DSA:1.10.472.80:FF:000059', NULL, NULL, 'Ypt/Rab-GAP domain of gyp1p superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(95972, NULL, 'G3DSA:2.40.70.10:FF:000173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95973, NULL, 'G3DSA:2.60.120.970:FF:000108', NULL, NULL, 'Bone morphogenetic protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(95974, NULL, 'G3DSA:1.25.40.20:FF:000734', NULL, NULL, 'Ankyrin repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(95975, NULL, 'G3DSA:3.30.200.20:FF:001427', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95976, NULL, 'G3DSA:3.80.10.10:FF:001525', NULL, NULL, 'Leucine-rich repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(95977, NULL, 'G3DSA:3.40.50.1440:FF:000040', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(95978, NULL, 'G3DSA:3.40.50.150:FF:001778', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95979, NULL, 'G3DSA:1.10.760.10:FF:000106', NULL, NULL, 'Monoheme cytochrome c SoxX', NULL, NULL, NULL, NULL, NULL, 4),
(95980, NULL, 'G3DSA:3.30.200.20:FF:002141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95981, NULL, 'G3DSA:3.30.70.330:FF:000242', NULL, NULL, 'RNA-binding protein FUS isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(95982, NULL, 'G3DSA:3.30.450.30:FF:000043', NULL, NULL, 'GM26652', NULL, NULL, NULL, NULL, NULL, 4),
(95983, NULL, 'G3DSA:3.30.200.20:FF:000011', NULL, NULL, 'Fibroblast growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(95984, NULL, 'G3DSA:1.10.506.10:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95985, NULL, 'G3DSA:1.10.10.440:FF:000045', NULL, NULL, 'U1 snRNP protein', NULL, NULL, NULL, NULL, NULL, 4),
(95986, NULL, 'G3DSA:1.10.238.10:FF:000365', NULL, NULL, 'Calmodulin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(95987, NULL, 'G3DSA:3.40.190.80:FF:000064', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(95988, NULL, 'G3DSA:1.20.1110.10:FF:000066', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(95989, NULL, 'G3DSA:3.40.50.300:FF:008102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95990, NULL, 'G3DSA:1.10.10.10:FF:000049', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(95991, NULL, 'G3DSA:3.30.160.20:FF:000187', NULL, NULL, 'Cdl1p', NULL, NULL, NULL, NULL, NULL, 4),
(95992, NULL, 'G3DSA:3.40.50.300:FF:004830', NULL, NULL, 'Helicase, Snf2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(95993, NULL, 'G3DSA:3.40.532.10:FF:000006', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(95994, NULL, 'G3DSA:3.40.630.10:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(95995, NULL, 'G3DSA:3.40.50.10810:FF:000163', NULL, NULL, 'Putative DNA excision/repair protein SNF2', NULL, NULL, NULL, NULL, NULL, 4),
(95996, NULL, 'G3DSA:3.10.110.10:FF:000005', NULL, NULL, 'NEDD8-conjugating enzyme Ubc12', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(95997, NULL, 'G3DSA:2.60.40.10:FF:005976', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(95998, NULL, 'G3DSA:2.170.270.10:FF:000090', NULL, NULL, 'SET-8', NULL, NULL, NULL, NULL, NULL, 4),
(95999, NULL, 'G3DSA:3.40.50.1000:FF:000037', NULL, NULL, 'D,D-heptose 1,7-bisphosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(96000, NULL, 'G3DSA:2.60.40.150:FF:000084', NULL, NULL, 'Protein KIBRA isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(96001, NULL, 'G3DSA:3.40.50.300:FF:000227', NULL, NULL, 'Sulfate/thiosulfate import ATP-binding protein CysA', NULL, NULL, NULL, NULL, NULL, 4),
(96002, NULL, 'G3DSA:3.40.50.2000:FF:001079', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(96003, NULL, 'G3DSA:3.30.160.60:FF:006134', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96004, NULL, 'G3DSA:2.130.10.10:FF:004431', NULL, NULL, 'Actin-related protein 2/3 complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(96005, NULL, 'G3DSA:3.40.140.70:FF:000018', NULL, NULL, 'Autophagy related 7', NULL, NULL, NULL, NULL, NULL, 4),
(96006, NULL, 'G3DSA:3.40.50.720:FF:000797', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96007, NULL, 'G3DSA:3.40.50.150:FF:000255', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(96008, NULL, 'G3DSA:3.30.450.50:FF:000049', NULL, NULL, '25.3 kDa vesicle transport protein isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(96009, NULL, 'G3DSA:2.60.120.970:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96010, NULL, 'G3DSA:1.10.510.10:FF:003955', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96011, NULL, 'G3DSA:1.20.144.10:FF:000100', NULL, NULL, 'Carbohydrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(96012, NULL, 'G3DSA:2.60.40.10:FF:004228', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96013, NULL, 'G3DSA:1.10.630.10:FF:000682', NULL, NULL, 'Cytochrome P450, family 2, subfamily d, polypeptide 12', NULL, NULL, NULL, NULL, NULL, 4),
(96014, NULL, 'G3DSA:1.10.1900.10:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96015, NULL, 'G3DSA:1.10.418.60:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96016, NULL, 'G3DSA:3.30.450.40:FF:000046', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(96017, NULL, 'G3DSA:3.40.630.30:FF:000229', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(96018, NULL, 'G3DSA:2.40.50.1060:FF:000016', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(96019, NULL, 'G3DSA:2.40.30.10:FF:000064', NULL, NULL, 'Na(+)-translocating NADH-quinone reductase subunit F', NULL, NULL, NULL, NULL, NULL, 4),
(96020, NULL, 'G3DSA:3.40.1090.10:FF:000017', NULL, NULL, 'Patatin-like phospholipase domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(96021, NULL, 'G3DSA:1.10.10.10:FF:001685', NULL, NULL, 'Putative ArsR-family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(96022, NULL, 'G3DSA:2.120.10.30:FF:000233', NULL, NULL, 'Putative peptide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(96023, NULL, 'G3DSA:3.40.47.10:FF:000100', NULL, NULL, 'Beta-ketoacyl synthase, N-terminal domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(96024, NULL, 'G3DSA:3.40.50.150:FF:001559', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96025, NULL, 'G3DSA:3.30.160.60:FF:000625', NULL, NULL, 'Zinc finger protein 536', NULL, NULL, NULL, NULL, NULL, 4),
(96026, NULL, 'G3DSA:2.40.50.1070:FF:000019', NULL, NULL, 'tRNA (Uracil(54)-C(5))-methyltransferase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(96027, NULL, 'G3DSA:3.30.230.70:FF:000044', NULL, NULL, 'Exosome complex exonuclease MTR3-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(96028, NULL, 'G3DSA:2.130.10.10:FF:001683', NULL, NULL, 'WD repeat and FYVE domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(96029, NULL, 'G3DSA:2.130.10.10:FF:005954', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(96030, NULL, 'G3DSA:3.40.50.880:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96031, NULL, 'G3DSA:1.20.20.10:FF:000010', NULL, NULL, 'ATP synthase subunit c', NULL, NULL, NULL, NULL, NULL, 4),
(96032, NULL, 'G3DSA:1.20.1310.20:FF:000056', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(96033, NULL, 'G3DSA:3.60.20.40:FF:000007', NULL, NULL, 'Glutathione hydrolase 1 proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(96034, NULL, 'G3DSA:3.40.50.720:FF:000111', NULL, NULL, 'Glucose-6-phosphate 1-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(96035, NULL, 'G3DSA:2.60.40.10:FF:003846', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96036, NULL, 'G3DSA:3.30.70.330:FF:001439', NULL, NULL, 'CG14718', NULL, NULL, NULL, NULL, NULL, 4),
(96037, NULL, 'G3DSA:3.40.50.720:FF:001634', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96038, NULL, 'G3DSA:2.60.34.10:FF:000122', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(96039, NULL, 'G3DSA:1.20.1640.10:FF:000038', NULL, NULL, 'Blast:Protein patched', NULL, NULL, NULL, NULL, NULL, 4),
(96040, NULL, 'G3DSA:2.40.10.10:FF:000517', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96041, NULL, 'G3DSA:3.10.490.20:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96042, NULL, 'G3DSA:3.30.1150.10:FF:000019', NULL, NULL, 'Energy transducer TonB', NULL, NULL, NULL, NULL, NULL, 4),
(96043, NULL, 'G3DSA:1.10.540.10:FF:000124', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(96044, NULL, 'G3DSA:2.30.29.30:FF:001034', NULL, NULL, 'Homer, putative', NULL, NULL, NULL, NULL, NULL, 4),
(96045, NULL, 'G3DSA:2.40.20.10:FF:000018', NULL, NULL, 'Muscle, skeletal receptor tyrosine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(96046, NULL, 'G3DSA:1.25.40.10:FF:001474', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g59720, chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(96047, NULL, 'G3DSA:1.20.1310.10:FF:000053', NULL, NULL, 'Cullin-3', NULL, NULL, NULL, NULL, NULL, 4),
(96048, NULL, 'G3DSA:2.60.120.10:FF:000364', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(96049, NULL, 'G3DSA:3.40.800.20:FF:000037', NULL, NULL, 'Histone deacetylase 4', NULL, NULL, NULL, NULL, NULL, 4),
(96050, NULL, 'G3DSA:1.10.1000.11:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96051, NULL, 'G3DSA:1.25.10.10:FF:002360', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96052, NULL, 'G3DSA:3.40.50.300:FF:003993', NULL, NULL, 'Ribosome biogenesis ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(96053, NULL, 'G3DSA:4.10.400.10:FF:000344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96054, NULL, 'G3DSA:3.60.20.30:FF:000004', NULL, NULL, 'Putative threonine aspartase isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(96055, NULL, 'G3DSA:1.10.10.10:FF:000156', NULL, NULL, 'DNA-binding transcriptional regulator CsiR', NULL, NULL, NULL, NULL, NULL, 4),
(96056, NULL, 'G3DSA:2.40.100.10:FF:000013', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(96057, NULL, 'G3DSA:3.40.30.10:FF:000803', NULL, NULL, 'Glutathione S-transferase 1-1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(96058, NULL, 'G3DSA:3.80.10.10:FF:004398', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(96059, NULL, 'G3DSA:1.25.10.10:FF:000342', NULL, NULL, 'Serine/threonine-protein kinase VPS15', NULL, NULL, NULL, NULL, NULL, 4),
(96060, NULL, 'G3DSA:3.30.70.330:FF:001990', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96061, NULL, 'G3DSA:2.130.10.10:FF:000160', NULL, NULL, 'Protein phosphatase PP2A regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(96062, NULL, 'G3DSA:3.20.20.60:FF:000116', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(96063, NULL, 'G3DSA:3.40.50.1820:FF:000968', NULL, NULL, 'Aspergillus niger contig An11c0010, genomic contig', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(96064, NULL, 'G3DSA:1.10.560.10:FF:000125', NULL, NULL, 'T-complex protein 1 subunit eta', NULL, NULL, NULL, NULL, NULL, 4),
(96065, NULL, 'G3DSA:1.25.40.10:FF:004110', NULL, NULL, 'Chitin synthase regulatory factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(96066, NULL, 'G3DSA:1.10.10.10:FF:001915', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96067, NULL, 'G3DSA:1.10.560.10:FF:000013', NULL, NULL, 'ruBisCO large subunit-binding protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(96068, NULL, 'G3DSA:3.30.70.1230:FF:000058', NULL, NULL, 'Photoactivated adenylate cyclase subunit beta-like protein FB', NULL, NULL, NULL, NULL, NULL, 4),
(96069, NULL, 'G3DSA:1.20.5.990:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96070, NULL, 'G3DSA:1.20.272.10:FF:000032', NULL, NULL, 'Replication factor c subunit 4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(96071, NULL, 'G3DSA:2.130.10.10:FF:003594', NULL, NULL, 'Protein HIRA', NULL, NULL, NULL, NULL, NULL, 4),
(96072, NULL, 'G3DSA:3.90.226.10:FF:000115', NULL, NULL, 'Probable enoyl-CoA hydratase echA6', NULL, NULL, NULL, NULL, NULL, 4),
(96073, NULL, 'G3DSA:3.40.50.2300:FF:001394', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96074, NULL, 'G3DSA:3.30.160.60:FF:002082', NULL, NULL, 'Zinc finger protein 646', NULL, NULL, NULL, NULL, NULL, 4),
(96075, NULL, 'G3DSA:1.25.10.10:FF:002028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96076, NULL, 'G3DSA:2.40.50.100:FF:000143', NULL, NULL, 'ATP-binding subunit of an ABC-type osmolytetransporter', NULL, NULL, NULL, NULL, NULL, 4),
(96077, NULL, 'G3DSA:2.60.40.10:FF:000176', NULL, NULL, 'Down syndrome cell adhesion molecule a', NULL, NULL, NULL, NULL, NULL, 4),
(96078, NULL, 'G3DSA:3.40.50.12650:FF:000041', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(96079, NULL, 'G3DSA:3.40.630.30:FF:000448', NULL, NULL, 'Acyl-CoA N-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(96080, NULL, 'G3DSA:1.20.1560.10:FF:000779', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96081, NULL, 'G3DSA:1.10.1240.40:FF:000002', NULL, NULL, 'ENT domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(96082, NULL, 'G3DSA:2.60.40.1700:FF:000001', NULL, NULL, 'Protein-arginine deiminase type-2', NULL, NULL, NULL, NULL, NULL, 4),
(96083, NULL, 'G3DSA:3.40.50.1820:FF:000749', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(96084, NULL, 'G3DSA:3.30.559.70:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96085, NULL, 'G3DSA:3.30.1640.10:FF:000001', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(96086, NULL, 'G3DSA:1.25.40.10:FF:002075', NULL, NULL, 'GD11343', NULL, NULL, NULL, NULL, NULL, 4),
(96087, NULL, 'G3DSA:3.30.420.40:FF:000550', NULL, NULL, 'Glucokinase', NULL, NULL, NULL, NULL, NULL, 4),
(96088, NULL, 'G3DSA:3.40.50.150:FF:000474', NULL, NULL, 'Carboxy-S-adenosyl-L-methionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(96089, NULL, 'G3DSA:3.30.720.210:FF:000011', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(96090, NULL, 'G3DSA:1.20.1070.10:FF:000927', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96091, NULL, 'G3DSA:2.30.30.30:FF:000143', NULL, NULL, '5''-3'' exoribonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(96092, NULL, 'G3DSA:3.10.20.90:FF:000417', NULL, NULL, 'GD22628', NULL, NULL, NULL, NULL, NULL, 4),
(96093, NULL, 'G3DSA:3.30.160.60:FF:006353', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96094, NULL, 'G3DSA:3.40.50.300:FF:004611', NULL, NULL, 'ORC1-type DNA replication protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(96095, NULL, 'G3DSA:2.60.40.10:FF:005864', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96096, NULL, 'G3DSA:1.20.1070.10:FF:001534', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96097, NULL, 'G3DSA:2.30.30.40:FF:000146', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(96098, NULL, 'G3DSA:2.60.40.1120:FF:000035', NULL, NULL, 'SusC/RagA family TonB-linked outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(96099, NULL, 'G3DSA:3.40.109.10:FF:000006', NULL, NULL, 'Oxygen-insensitive NADPH nitroreductase', NULL, NULL, NULL, NULL, NULL, 4),
(96100, NULL, 'G3DSA:2.60.60.20:FF:000068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96101, NULL, 'G3DSA:3.40.50.1000:FF:000149', NULL, NULL, 'Related to trehalose-6-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(96102, NULL, 'G3DSA:2.40.180.10:FF:000006', NULL, NULL, 'lipoxygenase homology domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(96103, NULL, 'G3DSA:3.30.2130.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96104, NULL, 'G3DSA:1.10.580.10:FF:000014', NULL, NULL, 'Citrate synthase-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(96105, NULL, 'G3DSA:3.90.79.20:FF:000017', NULL, NULL, 'NADH pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(96106, NULL, 'G3DSA:1.10.30.10:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96107, NULL, 'G3DSA:3.30.160.60:FF:000406', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96108, NULL, 'G3DSA:3.30.160.60:FF:002643', NULL, NULL, 'zinc finger protein 101', NULL, NULL, NULL, NULL, NULL, 4),
(96109, NULL, 'G3DSA:3.40.1210.10:FF:000005', NULL, NULL, 'Acid phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(96110, NULL, 'G3DSA:1.10.1370.40:FF:000006', NULL, NULL, 'Organellar oligopeptidase A, chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(96111, NULL, 'G3DSA:3.30.70.330:FF:001658', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96112, NULL, 'G3DSA:3.60.21.10:FF:000321', NULL, NULL, 'NAD 5''-nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(96113, NULL, 'G3DSA:2.60.40.60:FF:000730', NULL, NULL, 'Fat-like cadherin-related tumor suppressor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(96114, NULL, 'G3DSA:1.25.40.10:FF:004109', NULL, NULL, 'NAC2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(96115, NULL, 'G3DSA:2.70.150.10:FF:000138', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(96116, NULL, 'G3DSA:1.25.40.10:FF:003492', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g12100, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(96117, NULL, 'G3DSA:2.130.10.10:FF:004212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96118, NULL, 'G3DSA:3.90.79.10:FF:000014', NULL, NULL, '8-oxo-dGTP diphosphatase MutT', NULL, NULL, NULL, NULL, NULL, 4),
(96119, NULL, 'G3DSA:3.20.80.10:FF:000015', NULL, NULL, 'Heme-binding protein soul2', NULL, NULL, NULL, NULL, NULL, 4),
(96120, NULL, 'G3DSA:2.130.10.10:FF:000721', NULL, NULL, 'intraflagellar transport protein 122 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(96121, NULL, 'G3DSA:4.10.280.30:FF:000002', NULL, NULL, 'EG:23E12.2, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(96122, NULL, 'G3DSA:3.20.20.70:FF:000669', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96123, NULL, 'G3DSA:1.10.1370.30:FF:000003', NULL, NULL, 'Thermostable carboxypeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(96124, NULL, 'G3DSA:4.10.280.10:FF:000244', NULL, NULL, 'Transcription factor bHLH62', NULL, NULL, NULL, NULL, NULL, 4),
(96125, NULL, 'G3DSA:2.30.30.650:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96126, NULL, 'G3DSA:1.20.1050.10:FF:000010', NULL, NULL, 'Maleylacetoacetate isomerase isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(96127, NULL, 'G3DSA:3.30.70.340:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96128, NULL, 'G3DSA:1.10.472.80:FF:000278', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96129, NULL, 'G3DSA:3.80.10.10:FF:000688', NULL, NULL, 'Transforming growth factor beta activator LRRC33', NULL, NULL, NULL, NULL, NULL, 4),
(96130, NULL, 'G3DSA:3.30.200.20:FF:001646', NULL, NULL, 'Calcium/calmodulin-dependent protein kinase type IV', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(96131, NULL, 'G3DSA:1.25.50.10:FF:000007', NULL, NULL, 'Peptidase M1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(96132, NULL, 'G3DSA:1.20.1280.50:FF:000163', NULL, NULL, 'Protein SUPPRESSOR OF NIM1 1', NULL, NULL, NULL, NULL, NULL, 4),
(96133, NULL, 'G3DSA:3.90.950.10:FF:000011', NULL, NULL, 'Maf-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(96134, NULL, 'G3DSA:3.40.950.10:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96135, NULL, 'G3DSA:2.60.40.290:FF:000002', NULL, NULL, 'Stalk-specific protein B', NULL, NULL, NULL, NULL, NULL, 4),
(96136, NULL, 'G3DSA:3.30.70.1170:FF:000017', NULL, NULL, 'NOL1/NOP2/sun family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(96137, NULL, 'G3DSA:3.80.10.10:FF:001306', NULL, NULL, 'EIN3-binding F-box domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(96138, NULL, 'G3DSA:1.10.1130.10:FF:000013', NULL, NULL, 'Nitrite reductase (cytochrome; ammonia-forming)', NULL, NULL, NULL, NULL, NULL, 4),
(96139, NULL, 'G3DSA:1.20.120.350:FF:000045', NULL, NULL, 'Potassium voltage-gated channel subfamily S member 3', NULL, NULL, NULL, NULL, NULL, 4),
(96140, NULL, 'G3DSA:3.40.630.30:FF:000667', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(96141, NULL, 'G3DSA:3.40.50.880:FF:000018', NULL, NULL, 'Carbamoyl-phosphate synthase small chain', NULL, NULL, NULL, NULL, NULL, 4),
(96142, NULL, 'G3DSA:3.10.20.90:FF:000636', NULL, NULL, 'Ubiquitin domain-containing protein 7SL RNA2', NULL, NULL, NULL, NULL, NULL, 4),
(96143, NULL, 'G3DSA:3.90.550.50:FF:000026', NULL, NULL, 'Glycoprotein-N-acetylgalactosamine 3-beta-galactosyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(96144, NULL, 'G3DSA:2.70.130.10:FF:000143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96145, NULL, 'G3DSA:2.10.220.10:FF:000091', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(96146, NULL, 'G3DSA:1.10.1420.10:FF:000114', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(96147, NULL, 'G3DSA:3.30.420.10:FF:000569', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96148, NULL, 'G3DSA:1.10.10.10:FF:000611', NULL, NULL, 'Transcriptional repressor of nicotinamide riboside utilization NrtR', NULL, NULL, NULL, NULL, NULL, 4),
(96149, NULL, 'G3DSA:3.90.228.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96150, NULL, 'G3DSA:2.60.40.10:FF:000070', NULL, NULL, 'Myosin-binding protein C, slow type', NULL, NULL, NULL, NULL, NULL, 4),
(96151, NULL, 'G3DSA:3.40.190.290:FF:000130', NULL, NULL, 'Transcriptional regulator LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(96152, NULL, 'G3DSA:3.30.420.110:FF:000071', NULL, NULL, 'MutS domain III family protein', NULL, NULL, NULL, NULL, NULL, 4),
(96153, NULL, 'G3DSA:2.30.30.140:FF:000193', NULL, NULL, 'Os11g0545600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(96154, NULL, 'G3DSA:3.30.60.190:FF:000001', NULL, NULL, 'box C/D snoRNA protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(96155, NULL, 'G3DSA:1.10.287.600:FF:000021', NULL, NULL, 'Alpha_tubulin,putative', NULL, NULL, NULL, NULL, NULL, 4),
(96156, NULL, 'G3DSA:2.130.10.10:FF:002520', NULL, NULL, 'GG11023', NULL, NULL, NULL, NULL, NULL, 4),
(96157, NULL, 'G3DSA:1.10.510.10:FF:000408', NULL, NULL, 'Serine/threonine-protein kinase SSN3', NULL, NULL, NULL, NULL, NULL, 4),
(96158, NULL, 'G3DSA:2.70.150.10:FF:000251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96159, NULL, 'G3DSA:1.10.238.10:FF:000146', NULL, NULL, 'guanylyl cyclase-activating protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(96160, NULL, 'G3DSA:2.60.40.10:FF:001935', NULL, NULL, 'Twitchin', NULL, NULL, NULL, NULL, NULL, 4),
(96161, NULL, 'G3DSA:1.10.8.60:FF:000524', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96162, NULL, 'G3DSA:1.10.510.10:FF:002320', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96163, NULL, 'G3DSA:2.60.40.10:FF:004341', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96164, NULL, 'G3DSA:1.25.40.20:FF:001696', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(96165, NULL, 'G3DSA:3.40.50.10190:FF:000269', NULL, NULL, 'Putative dna topoisomerase 2-binding protein 1 isoform x1', NULL, NULL, NULL, NULL, NULL, 4),
(96166, NULL, 'G3DSA:3.30.70.330:FF:000023', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein q isoform', NULL, NULL, NULL, NULL, NULL, 4),
(96167, NULL, 'G3DSA:1.10.287.1490:FF:000108', NULL, NULL, 'Microtubule organizer protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(96168, NULL, 'G3DSA:1.10.510.10:FF:001589', NULL, NULL, 'Probable protein kinase DDB_G0277539', NULL, NULL, NULL, NULL, NULL, 4),
(96169, NULL, 'G3DSA:3.30.565.10:FF:000141', NULL, NULL, 'Sensor histidine kinase/response regulator Fos-1', NULL, NULL, NULL, NULL, NULL, 4),
(96170, NULL, 'G3DSA:2.60.40.640:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96171, NULL, 'G3DSA:2.120.10.30:FF:000014', NULL, NULL, 'Low-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(96172, NULL, 'G3DSA:3.40.50.1240:FF:000081', NULL, NULL, 'Putative phosphoglycerate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(96173, NULL, 'G3DSA:1.10.510.10:FF:002207', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96174, NULL, 'G3DSA:2.60.300.12:FF:000015', NULL, NULL, 'Iron-sulfur cluster assembly accessory protein', NULL, NULL, NULL, NULL, NULL, 4),
(96175, NULL, 'G3DSA:3.80.10.10:FF:003105', NULL, NULL, 'Fbxl18 protein', NULL, NULL, NULL, NULL, NULL, 4),
(96176, NULL, 'G3DSA:3.40.50.10860:FF:000043', NULL, NULL, 'Bifunctional protein FolD', NULL, NULL, NULL, NULL, NULL, 4),
(96177, NULL, 'G3DSA:1.20.1250.20:FF:001068', NULL, NULL, 'Nicotinamide mononucleotide permease, variant', NULL, NULL, NULL, NULL, NULL, 4),
(96178, NULL, 'G3DSA:3.30.160.60:FF:002424', NULL, NULL, 'Zinc finger protein GIS3', NULL, NULL, NULL, NULL, NULL, 4),
(96179, NULL, 'G3DSA:3.40.50.300:FF:004375', NULL, NULL, 'Probable thymidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(96180, NULL, 'G3DSA:1.25.40.10:FF:002311', NULL, NULL, 'Pentatricopeptide repeat-containing protein MRL1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(96181, NULL, 'G3DSA:3.40.50.1000:FF:000150', NULL, NULL, 'bifunctional TH2 protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(96182, NULL, 'G3DSA:3.80.20.20:FF:000051', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(96183, NULL, 'G3DSA:3.30.1310.10:FF:000010', NULL, NULL, 'Nucleoid-associated protein CbuG_1351', NULL, NULL, NULL, NULL, NULL, 4),
(96184, NULL, 'G3DSA:1.10.510.10:FF:004337', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96185, NULL, 'G3DSA:3.40.1110.10:FF:000419', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96186, NULL, 'G3DSA:3.50.7.10:FF:000031', NULL, NULL, 'GD23041', NULL, NULL, NULL, NULL, NULL, 4),
(96187, NULL, 'G3DSA:3.20.10.10:FF:000067', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(96188, NULL, 'G3DSA:3.40.120.10:FF:000027', NULL, NULL, 'Phosphoglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(96189, NULL, 'G3DSA:3.80.10.10:FF:002829', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(96190, NULL, 'G3DSA:1.10.1740.10:FF:000043', NULL, NULL, 'RNA polymerase sigma factor SigW, putative', NULL, NULL, NULL, NULL, NULL, 4),
(96191, NULL, 'G3DSA:3.30.40.10:FF:001664', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96192, NULL, 'G3DSA:3.80.10.10:FF:002487', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96193, NULL, 'G3DSA:3.40.50.1820:FF:001463', NULL, NULL, 'Chromosome 21, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(96194, NULL, 'G3DSA:1.10.10.1680:FF:000001', NULL, NULL, 'Heterocyst differentiation control protein', NULL, NULL, NULL, NULL, NULL, 4),
(96195, NULL, 'G3DSA:2.130.10.10:FF:000266', NULL, NULL, 'WD repeat-containing protein 59 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(96196, NULL, 'G3DSA:1.25.10.10:FF:002141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(96197, NULL, 'G3DSA:1.10.238.100:FF:000002', NULL, NULL, 'AP-1-like transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(96198, NULL, 'G3DSA:3.90.550.10:FF:000262', NULL, NULL, 'Glycosyltransferases', NULL, NULL, NULL, NULL, NULL, 4),
(96199, NULL, 'G3DSA:3.30.70.2580:FF:000002', NULL, NULL, '1-methylguanosine tRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(96200, NULL, 'G3DSA:3.20.20.140:FF:000436', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(96201, NULL, 'G3DSA:3.40.50.300:FF:008208', NULL, NULL, 'Developmentally-regulated GTP-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(96202, NULL, 'G3DSA:3.90.1750.10:FF:000068', NULL, NULL, 'Putative E3 ubiquitin-protein ligase TRIP12-like', NULL, NULL, NULL, NULL, NULL, 4),
(96203, NULL, 'G3DSA:3.40.1190.20:FF:000186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96204, NULL, 'G3DSA:1.20.5.4770:FF:000010', NULL, NULL, 'RAB eXchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(96205, NULL, 'G3DSA:3.10.450.580:FF:000014', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(96206, NULL, 'G3DSA:1.20.1560.10:FF:000892', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96207, NULL, 'G3DSA:3.90.550.10:FF:000604', NULL, NULL, 'Putative glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(96208, NULL, 'G3DSA:2.60.120.260:FF:000103', NULL, NULL, 'Glycosyl hydrolase family 10 protein', NULL, NULL, NULL, NULL, NULL, 4),
(96209, NULL, 'G3DSA:3.90.79.10:FF:000233', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(96210, NULL, 'G3DSA:3.10.20.90:FF:000294', NULL, NULL, 'Nuclear protein localization protein 4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(96211, NULL, 'G3DSA:2.60.40.790:FF:000045', NULL, NULL, 'Hsp20/alpha crystallin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(96212, NULL, 'G3DSA:3.40.50.1820:FF:001805', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(96213, NULL, 'G3DSA:3.40.50.300:FF:000665', NULL, NULL, 'ABC transporter A family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(96214, NULL, 'G3DSA:1.10.20.10:FF:000095', NULL, NULL, 'Histone H2A', NULL, NULL, NULL, NULL, NULL, 4),
(96215, NULL, 'G3DSA:1.10.520.10:FF:000016', NULL, NULL, 'Adenylate/guanylate cyclase catalytic domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(96216, NULL, 'G3DSA:3.30.70.1230:FF:000171', NULL, NULL, 'Blr1670 protein', NULL, NULL, NULL, NULL, NULL, 4),
(96217, NULL, 'G3DSA:3.30.830.10:FF:000145', NULL, NULL, 'Uncharacterized protein CaJ7.0411', NULL, NULL, NULL, NULL, NULL, 4),
(96218, NULL, 'G3DSA:1.10.10.60:FF:000710', NULL, NULL, 'Paired box 7a', NULL, NULL, NULL, NULL, NULL, 4),
(96219, NULL, 'G3DSA:2.60.40.10:FF:000412', NULL, NULL, 'tripartite motif-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(96220, NULL, 'G3DSA:3.30.70.100:FF:000084', NULL, NULL, 'ATPase copper-transporting alpha', NULL, NULL, NULL, NULL, NULL, 4),
(96221, NULL, 'G3DSA:1.10.418.10:FF:000019', NULL, NULL, 'Vav guanine nucleotide exchange factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(96222, NULL, 'G3DSA:2.60.40.10:FF:002087', NULL, NULL, 'AIR9 protein', NULL, NULL, NULL, NULL, NULL, 4),
(96223, NULL, 'G3DSA:1.10.510.10:FF:000066', NULL, NULL, 'Serine/threonine-protein kinase DCLK1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(96224, NULL, 'G3DSA:2.120.10.80:FF:000113', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(96225, NULL, 'G3DSA:1.25.10.10:FF:001865', NULL, NULL, 'Pumilio/PUF RNA binding protein 10, putative', NULL, NULL, NULL, NULL, NULL, 4),
(96226, NULL, 'G3DSA:3.40.1110.10:FF:000077', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(96227, NULL, 'G3DSA:1.20.5.110:FF:000345', NULL, NULL, 'Synaptosomal-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(96228, NULL, 'G3DSA:1.10.287.70:FF:000558', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96229, NULL, 'G3DSA:3.40.50.200:FF:000186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(96230, NULL, 'G3DSA:3.40.190.10:FF:000071', NULL, NULL, 'Glutamate receptor, ionotropic, N-methyl-D-aspartate 3B', NULL, NULL, NULL, NULL, NULL, 4),
(96231, NULL, 'G3DSA:3.50.50.60:FF:000240', NULL, NULL, '3-ketosteroid-delta-1-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(96232, NULL, 'G3DSA:3.30.70.3250:FF:000001', NULL, NULL, 'Ribonuclease P/MRP protein subunit POP5', NULL, NULL, NULL, NULL, NULL, 4),
(96233, NULL, 'G3DSA:1.10.3730.20:FF:000006', NULL, NULL, 'Probable magnesium transporter', NULL, NULL, NULL, NULL, NULL, 4),
(96234, NULL, 'G3DSA:3.30.1390.20:FF:000006', NULL, NULL, '50S ribosomal protein L30', NULL, NULL, NULL, NULL, NULL, 4),
(96235, NULL, 'G3DSA:1.20.1070.10:FF:001079', NULL, NULL, 'G-protein coupled receptor GRL101-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(96236, NULL, 'G3DSA:3.30.1390.30:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96237, NULL, 'G3DSA:2.60.40.10:FF:000850', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(96238, NULL, 'G3DSA:2.130.10.10:FF:002301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96239, NULL, 'G3DSA:3.30.420.40:FF:000331', NULL, NULL, 'Heat shock protein 105 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(96240, NULL, 'G3DSA:2.70.98.30:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96241, NULL, 'G3DSA:1.20.1250.20:FF:001181', NULL, NULL, 'Major facilitator superfamily multidrug transporter mdr3', NULL, NULL, NULL, NULL, NULL, 4),
(96242, NULL, 'G3DSA:3.40.30.40:FF:000003', NULL, NULL, 'Perfringolysin O', NULL, NULL, NULL, NULL, NULL, 4),
(96243, NULL, 'G3DSA:3.30.1390.10:FF:000003', NULL, NULL, 'E3 ubiquitin-protein ligase UBR2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(96244, NULL, 'G3DSA:3.90.1100.10:FF:000042', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(96245, NULL, 'G3DSA:3.40.33.10:FF:000046', NULL, NULL, 'Venom allergen-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(96246, NULL, 'G3DSA:3.30.160.60:FF:000283', NULL, NULL, 'Putative transcriptional repressor ctcf', NULL, NULL, NULL, NULL, NULL, 4),
(96247, NULL, 'G3DSA:1.25.10.10:FF:000561', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(96248, NULL, 'G3DSA:3.40.1050.10:FF:000021', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(96249, NULL, 'G3DSA:3.40.190.10:FF:000413', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(96250, NULL, 'G3DSA:3.90.550.10:FF:000149', NULL, NULL, 'Alpha-1,6-mannosyltransferase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(96251, NULL, 'G3DSA:1.10.3730.10:FF:000003', NULL, NULL, 'Pyrroline-5-carboxylate reductase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(96252, NULL, 'G3DSA:3.90.1150.10:FF:000320', NULL, NULL, 'Serine palmitoyl CoA transferase subunit LCBA', NULL, NULL, NULL, NULL, NULL, 4),
(96253, NULL, 'G3DSA:2.10.25.10:FF:001082', NULL, NULL, 'Signal peptide, CUB domain, EGF-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(96254, NULL, 'G3DSA:3.40.50.1100:FF:000067', NULL, NULL, 'Cysteine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(96255, NULL, 'G3DSA:2.10.70.10:FF:000219', NULL, NULL, 'Protein lev-9', NULL, NULL, NULL, NULL, NULL, 4),
(96256, NULL, 'G3DSA:3.30.310.180:FF:000005', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 20', NULL, NULL, NULL, NULL, NULL, 4),
(96257, NULL, 'G3DSA:3.90.70.10:FF:000365', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 13', NULL, NULL, NULL, NULL, NULL, 4),
(96258, NULL, 'G3DSA:1.20.5.1430:FF:000014', NULL, NULL, 'EB1', NULL, NULL, NULL, NULL, NULL, 4),
(96259, NULL, 'G3DSA:3.40.50.300:FF:002700', NULL, NULL, 'DNA repair helicase putative', NULL, NULL, NULL, NULL, NULL, 4),
(96260, NULL, 'G3DSA:2.40.170.20:FF:000060', NULL, NULL, 'TonB-dependent Receptor Plug Domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(96261, NULL, 'G3DSA:2.10.25.10:FF:000929', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(96262, NULL, 'G3DSA:2.40.30.10:FF:000300', NULL, NULL, 'Elongation factor 1 alpha-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(96263, NULL, 'G3DSA:2.10.25.10:FF:001424', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(96264, NULL, 'G3DSA:3.10.150.10:FF:000002', NULL, NULL, 'Beta sliding clamp', NULL, NULL, NULL, NULL, NULL, 4),
(96265, NULL, 'G3DSA:2.40.10.10:FF:000411', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96266, NULL, 'G3DSA:3.30.565.10:FF:000360', NULL, NULL, 'Mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(96267, NULL, 'G3DSA:1.10.8.60:FF:000069', NULL, NULL, 'spermatogenesis-associated protein 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(96268, NULL, 'G3DSA:3.50.30.30:FF:000039', NULL, NULL, 'Subtilisin-like protease SBT3', NULL, NULL, NULL, NULL, NULL, 4),
(96269, NULL, 'G3DSA:1.10.3210.10:FF:000076', NULL, NULL, 'Diguanylate cyclase and metal dependent phosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(96270, NULL, 'G3DSA:3.30.160.60:FF:001120', NULL, NULL, 'zinc finger protein 618 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(96271, NULL, 'G3DSA:4.10.1240.50:FF:000019', NULL, NULL, 'LD32549p', NULL, NULL, NULL, NULL, NULL, 4),
(96272, NULL, 'G3DSA:1.10.3460.10:FF:000010', NULL, NULL, 'Chlorophyll a-b binding protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(96273, NULL, 'G3DSA:2.10.25.10:FF:001205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96274, NULL, 'G3DSA:3.30.2020.30:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96275, NULL, 'G3DSA:3.30.160.60:FF:004554', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96276, NULL, 'G3DSA:2.60.260.20:FF:000062', NULL, NULL, 'Heat shock protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(96277, NULL, 'G3DSA:2.60.40.60:FF:000617', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96278, NULL, 'G3DSA:3.40.1810.10:FF:000085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96279, NULL, 'G3DSA:3.40.50.1480:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96280, NULL, 'G3DSA:1.10.8.270:FF:000041', NULL, NULL, 'TBC1 domain family member 25', NULL, NULL, NULL, NULL, NULL, 4),
(96281, NULL, 'G3DSA:2.120.10.80:FF:000332', NULL, NULL, 'tRNA wybutosine-synthesizing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(96282, NULL, 'G3DSA:2.60.40.150:FF:000320', NULL, NULL, 'C2 domain-containing protein aex-1', NULL, NULL, NULL, NULL, NULL, 4),
(96283, NULL, 'G3DSA:2.130.10.10:FF:004318', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96284, NULL, 'G3DSA:3.30.420.40:FF:000112', NULL, NULL, 'Heat shock 70 kDa protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(96285, NULL, 'G3DSA:3.90.640.90:FF:000017', NULL, NULL, 'BTG family protein', NULL, NULL, NULL, NULL, NULL, 4),
(96286, NULL, 'G3DSA:1.10.418.10:FF:000132', NULL, NULL, 'Actin binding protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(96287, NULL, 'G3DSA:3.30.1360.120:FF:000029', NULL, NULL, 'Mitochondrial GTPase (Mss1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(96288, NULL, 'G3DSA:1.10.10.2360:FF:000003', NULL, NULL, 'Nucleoporin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(96289, NULL, 'G3DSA:1.25.40.10:FF:001693', NULL, NULL, 'Protein O-mannosyl-transferase TMTC2', NULL, NULL, NULL, NULL, NULL, 4),
(96290, NULL, 'G3DSA:1.10.150.240:FF:000110', NULL, NULL, 'Phosphoglycolate phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(96291, NULL, 'G3DSA:1.10.287.70:FF:000777', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96292, NULL, 'G3DSA:3.40.50.1100:FF:000286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96293, NULL, 'G3DSA:3.60.60.30:FF:000001', NULL, NULL, 'Phospholipase B-like protein G', NULL, NULL, NULL, NULL, NULL, 4),
(96294, NULL, 'G3DSA:3.30.160.60:FF:005971', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96295, NULL, 'G3DSA:1.10.150.50:FF:000078', NULL, NULL, 'Sterile alpha motif (SAM) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(96296, NULL, 'G3DSA:2.40.50.140:FF:001088', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96297, NULL, 'G3DSA:2.60.40.10:FF:000631', NULL, NULL, 'Hyaluronan and proteoglycan link protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(96298, NULL, 'G3DSA:2.60.40.10:FF:004009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96299, NULL, 'G3DSA:1.10.555.10:FF:000158', NULL, NULL, 'YALI0A12111p', NULL, NULL, NULL, NULL, NULL, 4),
(96300, NULL, 'G3DSA:3.40.50.300:FF:006410', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96301, NULL, 'G3DSA:1.10.510.10:FF:000285', NULL, NULL, 'Mitogen-activated protein kinase kinase 6', NULL, NULL, NULL, NULL, NULL, 4),
(96302, NULL, 'G3DSA:1.10.287.110:FF:000076', NULL, NULL, 'Chaperone protein dnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(96303, NULL, 'G3DSA:1.20.58.340:FF:000054', NULL, NULL, 'CorA family metal ion transporter', NULL, NULL, NULL, NULL, NULL, 4),
(96304, NULL, 'G3DSA:1.10.20.120:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96305, NULL, 'G3DSA:3.30.160.60:FF:005639', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96306, NULL, 'G3DSA:1.10.10.10:FF:000050', NULL, NULL, 'Cullin 4B', NULL, NULL, NULL, NULL, NULL, 4),
(96307, NULL, 'G3DSA:3.30.390.10:FF:000010', NULL, NULL, 'Dipeptide epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(96308, NULL, 'G3DSA:2.40.10.10:FF:000630', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96309, NULL, 'G3DSA:2.60.120.200:FF:000799', NULL, NULL, 'Neurexin I isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(96310, NULL, 'G3DSA:2.10.90.10:FF:000108', NULL, NULL, 'DAN domain family, member 5', NULL, NULL, NULL, NULL, NULL, 4),
(96311, NULL, 'G3DSA:3.40.430.10:FF:000017', NULL, NULL, 'Bifunctional dihydrofolate reductase-thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(96312, NULL, 'G3DSA:1.20.1250.20:FF:001742', NULL, NULL, 'Major facilitator superfamily domain containing 4B', NULL, NULL, NULL, NULL, NULL, 4),
(96313, NULL, 'G3DSA:2.10.220.10:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96314, NULL, 'G3DSA:3.90.550.10:FF:000481', NULL, NULL, 'Galactosyl transferase GMA12/MNN10 family-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(96315, NULL, 'G3DSA:3.40.309.10:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96316, NULL, 'G3DSA:3.40.140.10:FF:000135', NULL, NULL, 'Nuclear protein localization protein 4, variant', NULL, NULL, NULL, NULL, NULL, 4),
(96317, NULL, 'G3DSA:2.130.10.10:FF:000047', NULL, NULL, 'Mitotic checkpoint protein bub3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(96318, NULL, 'G3DSA:2.30.29.240:FF:000001', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(96319, NULL, 'G3DSA:1.20.1260.100:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96320, NULL, 'G3DSA:3.40.50.2000:FF:000005', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(96321, NULL, 'G3DSA:1.25.10.10:FF:001646', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(96322, NULL, 'G3DSA:3.10.450.10:FF:000042', NULL, NULL, 'Salivary cystatin-L', NULL, NULL, NULL, NULL, NULL, 4),
(96323, NULL, 'G3DSA:1.20.1050.20:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96324, NULL, 'G3DSA:3.50.50.60:FF:001325', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96325, NULL, 'G3DSA:2.10.25.10:FF:000587', NULL, NULL, 'Slit 2', NULL, NULL, NULL, NULL, NULL, 4),
(96326, NULL, 'G3DSA:1.25.40.10:FF:002530', NULL, NULL, 'Protein sel-1 homolog 1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(96327, NULL, 'G3DSA:2.60.40.60:FF:000275', NULL, NULL, 'Si:dkey-30k22.7', NULL, NULL, NULL, NULL, NULL, 4),
(96328, NULL, 'G3DSA:2.30.31.40:FF:000002', NULL, NULL, 'Guide RNA binding protein gBP25', NULL, NULL, NULL, NULL, NULL, 4),
(96329, NULL, 'G3DSA:3.40.50.150:FF:000036', NULL, NULL, 'DNA (cytosine-5)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(96330, NULL, 'G3DSA:3.30.1130.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96331, NULL, 'G3DSA:1.25.10.10:FF:000229', NULL, NULL, 'TELO2-interacting protein 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(96332, NULL, 'G3DSA:1.10.10.60:FF:000036', NULL, NULL, 'Two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(96333, NULL, 'G3DSA:3.40.50.300:FF:000446', NULL, NULL, 'ATP-dependent RNA helicase SUPV3L1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(96334, NULL, 'G3DSA:1.10.10.10:FF:002067', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(96335, NULL, 'G3DSA:3.30.565.10:FF:000028', NULL, NULL, 'PAS sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(96336, NULL, 'G3DSA:3.10.110.10:FF:000224', NULL, NULL, 'UBE2O', NULL, NULL, NULL, NULL, NULL, 4),
(96337, NULL, 'G3DSA:3.30.750.24:FF:000142', NULL, NULL, 'Glycosyl transferase, WecB/TagA/CpsF family', NULL, NULL, NULL, NULL, NULL, 4),
(96338, NULL, 'G3DSA:3.30.590.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96339, NULL, 'G3DSA:3.30.720.210:FF:000006', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(96340, NULL, 'G3DSA:2.10.230.10:FF:000013', NULL, NULL, 'DnaJ homolog, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(96341, NULL, 'G3DSA:3.10.580.10:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96342, NULL, 'G3DSA:3.30.559.70:FF:000055', NULL, NULL, 'Carnitine acyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(96343, NULL, 'G3DSA:3.40.50.300:FF:005747', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(96344, NULL, 'G3DSA:3.30.450.20:FF:000389', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(96345, NULL, 'G3DSA:1.25.10.10:FF:003030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96346, NULL, 'G3DSA:3.30.200.20:FF:001186', NULL, NULL, 'Receptor-like serine/threonine-protein kinase ALE2', NULL, NULL, NULL, NULL, NULL, 4),
(96347, NULL, 'G3DSA:3.40.630.30:FF:000319', NULL, NULL, 'N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(96348, NULL, 'G3DSA:2.60.40.10:FF:005909', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96349, NULL, 'G3DSA:2.60.40.10:FF:004280', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96350, NULL, 'G3DSA:3.80.10.10:FF:001138', NULL, NULL, 'F-box only protein 39', NULL, NULL, NULL, NULL, NULL, 4),
(96351, NULL, 'G3DSA:1.20.1250.20:FF:000113', NULL, NULL, 'Purine ribonucleoside efflux pump NepI', NULL, NULL, NULL, NULL, NULL, 4),
(96352, NULL, 'G3DSA:3.30.160.60:FF:003740', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96353, NULL, 'G3DSA:2.30.29.30:FF:000865', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96354, NULL, 'G3DSA:3.10.100.10:FF:000174', NULL, NULL, 'Immune-related lectin-like receptor 3 splice variant a', NULL, NULL, NULL, NULL, NULL, 4),
(96355, NULL, 'G3DSA:3.40.30.10:FF:000624', NULL, NULL, 'Protein disulfide isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(96356, NULL, 'G3DSA:2.20.50.20:FF:000013', NULL, NULL, 'Vitellogenin', NULL, NULL, NULL, NULL, NULL, 4),
(96357, NULL, 'G3DSA:1.10.20.10:FF:000242', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96358, NULL, 'G3DSA:3.40.50.300:FF:002993', NULL, NULL, 'ABC transporter, multidrug resistance associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(96359, NULL, 'G3DSA:3.20.10.10:FF:000051', NULL, NULL, 'Probable branched-chain amino acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(96360, NULL, 'G3DSA:2.10.25.10:FF:000312', NULL, NULL, 'neural-cadherin isoform X10', NULL, NULL, NULL, NULL, NULL, 4),
(96361, NULL, 'G3DSA:3.20.20.140:FF:000419', NULL, NULL, 'Imidazolonepropionase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(96362, NULL, 'G3DSA:3.90.190.10:FF:000330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(96363, NULL, 'G3DSA:1.10.630.10:FF:000660', NULL, NULL, 'Cytochrome P450, family 2, subfamily R, polypeptide 1', NULL, NULL, NULL, NULL, NULL, 4),
(96364, NULL, 'G3DSA:2.10.25.10:FF:001301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96365, NULL, 'G3DSA:1.10.1070.11:FF:000061', NULL, NULL, 'Serine/threonine-protein kinase ATR', NULL, NULL, NULL, NULL, NULL, 4),
(96366, NULL, 'G3DSA:3.40.50.1000:FF:000077', NULL, NULL, 'Phosphoserine phosphatase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(96367, NULL, 'G3DSA:3.30.1120.30:FF:000002', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(96368, NULL, 'G3DSA:3.30.565.10:FF:000557', NULL, NULL, 'Protein-histidine kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(96369, NULL, 'G3DSA:2.60.40.60:FF:000500', NULL, NULL, 'Cadherin-2', NULL, NULL, NULL, NULL, NULL, 4),
(96370, NULL, 'G3DSA:1.10.1670.10:FF:000021', NULL, NULL, 'Endonuclease III homolog', NULL, NULL, NULL, NULL, NULL, 4),
(96371, NULL, 'G3DSA:2.60.40.150:FF:000062', NULL, NULL, 'synaptotagmin-14 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(96372, NULL, 'G3DSA:3.30.70.120:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96373, NULL, 'G3DSA:1.10.472.130:FF:000044', NULL, NULL, 'Dynein alpha chain, flagellar outer arm', NULL, NULL, NULL, NULL, NULL, 4),
(96374, NULL, 'G3DSA:1.10.3470.10:FF:000040', NULL, NULL, 'Vitamin B12 ABC transporter, permease component BtuC', NULL, NULL, NULL, NULL, NULL, 4),
(96375, NULL, 'G3DSA:3.90.550.10:FF:000313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96376, NULL, 'G3DSA:3.40.50.880:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96377, NULL, 'G3DSA:2.40.50.140:FF:000779', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96378, NULL, 'G3DSA:3.40.50.620:FF:000262', NULL, NULL, 'Tryptophan--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(96379, NULL, 'G3DSA:1.20.1720.10:FF:000068', NULL, NULL, 'Uncharacterized MFS-type transporter YwoD', NULL, NULL, NULL, NULL, NULL, 4),
(96380, NULL, 'G3DSA:1.25.40.10:FF:000305', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(96381, NULL, 'G3DSA:3.40.50.300:FF:006736', NULL, NULL, 'RAB36, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(96382, NULL, 'G3DSA:3.30.70.330:FF:001873', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96383, NULL, 'G3DSA:1.20.58.60:FF:000332', NULL, NULL, 'VAB-10B protein', NULL, NULL, NULL, NULL, NULL, 4),
(96384, NULL, 'G3DSA:1.10.510.10:FF:002039', NULL, NULL, 'cDNA FLJ50375, highly similar to Serine/threonine-protein kinase RIO3', NULL, NULL, NULL, NULL, NULL, 4),
(96385, NULL, 'G3DSA:2.130.10.10:FF:001026', NULL, NULL, 'Atg18p', NULL, NULL, NULL, NULL, NULL, 4),
(96386, NULL, 'G3DSA:2.70.150.10:FF:000201', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(96387, NULL, 'G3DSA:2.60.120.230:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96388, NULL, 'G3DSA:1.20.1250.20:FF:001541', NULL, NULL, 'ORF', NULL, NULL, NULL, NULL, NULL, 4),
(96389, NULL, 'G3DSA:2.130.10.10:FF:001498', NULL, NULL, 'Rtt10p', NULL, NULL, NULL, NULL, NULL, 4),
(96390, NULL, 'G3DSA:1.20.1640.10:FF:000067', NULL, NULL, 'Transmembrane transport protein mmpL13b', NULL, NULL, NULL, NULL, NULL, 4),
(96391, NULL, 'G3DSA:1.10.287.2900:FF:000015', NULL, NULL, 'Cox19-like CHCH family protein', NULL, NULL, NULL, NULL, NULL, 4),
(96392, NULL, 'G3DSA:3.40.47.10:FF:000247', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase', NULL, NULL, NULL, NULL, NULL, 4),
(96393, NULL, 'G3DSA:4.10.280.10:FF:000031', NULL, NULL, 'Oligodendrocyte transcription factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(96394, NULL, 'G3DSA:1.10.8.60:FF:000491', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96395, NULL, 'G3DSA:1.10.490.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96396, NULL, 'G3DSA:3.40.50.150:FF:001498', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(96397, NULL, 'G3DSA:1.10.10.1770:FF:000001', NULL, NULL, 'Tetrapyrrole-binding protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(96398, NULL, 'G3DSA:3.30.505.10:FF:000109', NULL, NULL, 'CRE-STA-2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(96399, NULL, 'G3DSA:3.30.160.60:FF:002751', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96400, NULL, 'G3DSA:3.40.50.300:FF:004758', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96401, NULL, 'G3DSA:3.40.50.2000:FF:001057', NULL, NULL, 'UDP-N-acetylglucosamine transferase subunit ALG14', NULL, NULL, NULL, NULL, NULL, 4),
(96402, NULL, 'G3DSA:3.30.40.10:FF:001991', NULL, NULL, 'Os02g0611300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(96403, NULL, 'G3DSA:1.10.533.10:FF:000277', NULL, NULL, 'Si:ch211-108d22.2', NULL, NULL, NULL, NULL, NULL, 4),
(96404, NULL, 'G3DSA:1.10.8.10:FF:000257', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(96405, NULL, 'G3DSA:2.10.25.10:FF:001740', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(96406, NULL, 'G3DSA:2.30.30.30:FF:000138', NULL, NULL, '30S ribosomal protein S4e', NULL, NULL, NULL, NULL, NULL, 4),
(96407, NULL, 'G3DSA:2.10.25.10:FF:000784', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96408, NULL, 'G3DSA:3.30.40.10:FF:001839', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96409, NULL, 'G3DSA:3.30.70.1220:FF:000005', NULL, NULL, 'TFIIH basal transcription factor complex TTD-A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(96410, NULL, 'G3DSA:2.60.98.10:FF:000006', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(96411, NULL, 'G3DSA:3.30.160.60:FF:004196', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96412, NULL, 'G3DSA:3.60.21.10:FF:000248', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(96413, NULL, 'G3DSA:4.10.640.10:FF:000014', NULL, NULL, '30S ribosomal protein S18', NULL, NULL, NULL, NULL, NULL, 4),
(96414, NULL, 'G3DSA:3.90.70.10:FF:000017', NULL, NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', NULL, NULL, NULL, NULL, NULL, 4),
(96415, NULL, 'G3DSA:3.40.50.300:FF:002521', NULL, NULL, 'ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(96416, NULL, 'G3DSA:1.25.40.10:FF:004200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96417, NULL, 'G3DSA:3.30.70.330:FF:000445', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(96418, NULL, 'G3DSA:3.40.50.2300:FF:000540', NULL, NULL, 'LacI family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(96419, NULL, 'G3DSA:3.40.50.1110:FF:000138', NULL, NULL, 'Probable platelet-activating factor acetylhydrolase IB gamma subunit', NULL, NULL, NULL, NULL, NULL, 4),
(96420, NULL, 'G3DSA:3.40.920.10:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96421, NULL, 'G3DSA:3.30.420.40:FF:000747', NULL, NULL, 'Actin-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(96422, NULL, 'G3DSA:2.130.10.10:FF:005393', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96423, NULL, 'G3DSA:1.10.10.60:FF:000059', NULL, NULL, 'TGFB-induced factor homeobox 1', NULL, NULL, NULL, NULL, NULL, 4),
(96424, NULL, 'G3DSA:1.50.40.10:FF:000213', NULL, NULL, 'Mitochondrial carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(96425, NULL, 'G3DSA:3.40.50.10330:FF:000126', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(96426, NULL, 'G3DSA:3.30.710.10:FF:000126', NULL, NULL, 'BTB/POZ domain-containing protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(96427, NULL, 'G3DSA:3.90.79.10:FF:000037', NULL, NULL, 'Nudix hydrolase 2', NULL, NULL, NULL, NULL, NULL, 4),
(96428, NULL, 'G3DSA:1.25.10.10:FF:000949', NULL, NULL, 'Protein HASTY 1', NULL, NULL, NULL, NULL, NULL, 4),
(96429, NULL, 'G3DSA:3.30.559.10:FF:000144', NULL, NULL, 'Peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(96430, NULL, 'G3DSA:3.30.497.10:FF:000011', NULL, NULL, 'heparin cofactor 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(96431, NULL, 'G3DSA:3.30.530.20:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96432, NULL, 'G3DSA:1.20.1050.10:FF:000275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96433, NULL, 'G3DSA:3.40.50.720:FF:001894', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96434, NULL, 'G3DSA:1.20.1070.10:FF:002103', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(96435, NULL, 'G3DSA:3.40.50.720:FF:000466', NULL, NULL, 'Probable short-chain type dehydrogenase/reductase', NULL, NULL, NULL, NULL, NULL, 4),
(96436, NULL, 'G3DSA:2.60.40.10:FF:003291', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96437, NULL, 'G3DSA:2.60.120.200:FF:000581', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96438, NULL, 'G3DSA:3.30.1370.10:FF:000008', NULL, NULL, 'far upstream element-binding protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(96439, NULL, 'G3DSA:2.70.70.10:FF:000072', NULL, NULL, 'Gll2330 protein', NULL, NULL, NULL, NULL, NULL, 4),
(96440, NULL, 'G3DSA:3.30.160.60:FF:001323', NULL, NULL, 'zinc finger protein 771', NULL, NULL, NULL, NULL, NULL, 4),
(96441, NULL, 'G3DSA:3.40.630.50:FF:000005', NULL, NULL, 'D-aminoacyl-tRNA deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(96442, NULL, 'G3DSA:1.10.510.10:FF:004395', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96443, NULL, 'G3DSA:2.60.120.10:FF:000718', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96444, NULL, 'G3DSA:3.40.50.300:FF:000104', NULL, NULL, 'ATP-binding cassette sub-family F member 3', NULL, NULL, NULL, NULL, NULL, 4),
(96445, NULL, 'G3DSA:3.90.190.20:FF:000007', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(96446, NULL, 'G3DSA:2.60.300.12:FF:000010', NULL, NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(96447, NULL, 'G3DSA:2.60.120.260:FF:000020', NULL, NULL, 'neuroendocrine convertase 2', NULL, NULL, NULL, NULL, NULL, 4),
(96448, NULL, 'G3DSA:2.60.40.790:FF:000046', NULL, NULL, 'Heat shock protein beta-3', NULL, NULL, NULL, NULL, NULL, 4),
(96449, NULL, 'G3DSA:3.90.260.10:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96450, NULL, 'G3DSA:3.80.10.10:FF:002566', NULL, NULL, 'leucine-rich repeat and guanylate kinase domain-containing protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(96451, NULL, 'G3DSA:3.60.20.10:FF:000196', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96452, NULL, 'G3DSA:3.50.50.60:FF:001056', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(96453, NULL, 'G3DSA:1.10.490.160:FF:000005', NULL, NULL, 'Ryanodine receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(96454, NULL, 'G3DSA:1.10.238.10:FF:000141', NULL, NULL, 'transmembrane prolyl 4-hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(96455, NULL, 'G3DSA:3.30.870.10:FF:000019', NULL, NULL, 'phospholipase D3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(96456, NULL, 'G3DSA:1.25.40.10:FF:003683', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96457, NULL, 'G3DSA:2.60.40.10:FF:006045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96458, NULL, 'G3DSA:3.30.160.60:FF:000834', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96459, NULL, 'G3DSA:1.25.40.10:FF:002694', NULL, NULL, 'G-protein regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(96460, NULL, 'G3DSA:1.10.510.10:FF:003467', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96461, NULL, 'G3DSA:1.20.140.40:FF:000011', NULL, NULL, 'Cell wall / vacuolar inhibitor of fructosidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(96462, NULL, 'G3DSA:3.30.160.60:FF:005185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96463, NULL, 'G3DSA:2.30.39.10:FF:000091', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(96464, NULL, 'G3DSA:3.40.1110.10:FF:000364', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(96465, NULL, 'G3DSA:1.10.1410.10:FF:000064', NULL, NULL, 'U3 small nucleolar RNA-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(96466, NULL, 'G3DSA:1.10.287.440:FF:000001', NULL, NULL, 'Bifunctional purine biosynthesis protein PURH', NULL, NULL, NULL, NULL, NULL, 4),
(96467, NULL, 'G3DSA:3.90.1150.10:FF:000315', NULL, NULL, 'Probable serine--glyoxylate aminotransferase, class V', NULL, NULL, NULL, NULL, NULL, 4),
(96468, NULL, 'G3DSA:1.20.5.490:FF:000009', NULL, NULL, 'Cell shape-determining protein MreC', NULL, NULL, NULL, NULL, NULL, 4),
(96469, NULL, 'G3DSA:1.20.1250.20:FF:000905', NULL, NULL, 'Major facilitator superfamily domain containing 12', NULL, NULL, NULL, NULL, NULL, 4),
(96470, NULL, 'G3DSA:3.40.190.10:FF:000555', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(96471, NULL, 'G3DSA:2.60.40.10:FF:000738', NULL, NULL, 'Leukemia inhibitory factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(96472, NULL, 'G3DSA:3.30.160.60:FF:006174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96473, NULL, 'G3DSA:1.25.10.10:FF:000157', NULL, NULL, 'Hsp70-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(96474, NULL, 'G3DSA:1.10.10.10:FF:000005', NULL, NULL, 'Two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(96475, NULL, 'G3DSA:2.60.40.1940:FF:000001', NULL, NULL, 'Complement component C3', NULL, NULL, NULL, NULL, NULL, 4),
(96476, NULL, 'G3DSA:1.10.10.60:FF:001015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96477, NULL, 'G3DSA:3.90.226.10:FF:000307', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(96478, NULL, 'G3DSA:3.40.120.10:FF:000022', NULL, NULL, 'phosphomannomutase/phosphoglucomutase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(96479, NULL, 'G3DSA:3.30.465.10:FF:000140', NULL, NULL, 'FAD linked oxidase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(96480, NULL, 'G3DSA:3.40.1510.10:FF:000001', NULL, NULL, 'Hut operon positive regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(96481, NULL, 'G3DSA:3.90.70.10:FF:000456', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96482, NULL, 'G3DSA:1.10.2000.10:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96483, NULL, 'G3DSA:1.10.238.10:FF:000580', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96484, NULL, 'G3DSA:2.60.40.10:FF:002363', NULL, NULL, 'Uncharacterized protein, isoform J', NULL, NULL, NULL, NULL, NULL, 4),
(96485, NULL, 'G3DSA:3.10.20.90:FF:000727', NULL, NULL, 'Protein phosphatase 1 regulatory subunit 13B', NULL, NULL, NULL, NULL, NULL, 4),
(96486, NULL, 'G3DSA:3.40.50.720:FF:001455', NULL, NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(96487, NULL, 'G3DSA:1.20.5.170:FF:000150', NULL, NULL, 'AP-1-like transcription factor YAP7', NULL, NULL, NULL, NULL, NULL, 4),
(96488, NULL, 'G3DSA:4.10.860.10:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96489, NULL, 'G3DSA:1.10.510.10:FF:004456', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96490, NULL, 'G3DSA:2.60.40.60:FF:000759', NULL, NULL, 'Hedgehog protein', NULL, NULL, NULL, NULL, NULL, 4),
(96491, NULL, 'G3DSA:3.30.160.60:FF:002312', NULL, NULL, 'Zinc finger protein 658', NULL, NULL, NULL, NULL, NULL, 4),
(96492, NULL, 'G3DSA:2.10.70.10:FF:000208', NULL, NULL, 'Complement regulatory membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(96493, NULL, 'G3DSA:3.30.70.330:FF:000092', NULL, NULL, 'Calcipressin-2 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(96494, NULL, 'G3DSA:1.10.287.110:FF:000133', NULL, NULL, 'Gametocyte erythrocyte cytosolic protein', NULL, NULL, NULL, NULL, NULL, 4),
(96495, NULL, 'G3DSA:1.10.1870.10:FF:000002', NULL, NULL, 'Saccharopine dehydrogenase Lys9', NULL, NULL, NULL, NULL, NULL, 4),
(96496, NULL, 'G3DSA:3.30.160.60:FF:001823', NULL, NULL, 'Zinc finger protein 322', NULL, NULL, NULL, NULL, NULL, 4),
(96497, NULL, 'G3DSA:3.30.160.60:FF:004549', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(96498, NULL, 'G3DSA:2.40.10.10:FF:000367', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96499, NULL, 'G3DSA:2.60.120.10:FF:000218', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(96500, NULL, 'G3DSA:3.80.10.10:FF:004011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96501, NULL, 'G3DSA:3.40.50.20:FF:000044', NULL, NULL, 'Lysine biosynthesis enzyme LysX', NULL, NULL, NULL, NULL, NULL, 4),
(96502, NULL, 'G3DSA:2.130.10.130:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96503, NULL, 'G3DSA:3.10.310.60:FF:000002', NULL, NULL, 'Protein OS-9 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(96504, NULL, 'G3DSA:4.10.400.10:FF:000092', NULL, NULL, 'LDL receptor related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(96505, NULL, 'G3DSA:4.10.60.10:FF:000125', NULL, NULL, 'Putative e3 ubiquitin ligase', NULL, NULL, NULL, NULL, NULL, 4),
(96506, NULL, 'G3DSA:3.40.50.300:FF:003510', NULL, NULL, 'Dynein heavy chain, cytosolic, putative', NULL, NULL, NULL, NULL, NULL, 4),
(96507, NULL, 'G3DSA:1.20.5.110:FF:000059', NULL, NULL, 'Related to syntaxin 12', NULL, NULL, NULL, NULL, NULL, 4),
(96508, NULL, 'G3DSA:3.40.980.10:FF:000036', NULL, NULL, 'Molybdenum cofactor biosynthesis protein MoeA', NULL, NULL, NULL, NULL, NULL, 4),
(96509, NULL, 'G3DSA:1.20.120.340:FF:000014', NULL, NULL, 'Flagellar protein FliS', NULL, NULL, NULL, NULL, NULL, 4),
(96510, NULL, 'G3DSA:3.10.129.10:FF:000105', NULL, NULL, 'uncharacterized protein LOC101841231 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(96511, NULL, 'G3DSA:1.25.10.10:FF:001113', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(96512, NULL, 'G3DSA:3.30.40.10:FF:000530', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(96513, NULL, 'G3DSA:3.30.870.10:FF:000171', NULL, NULL, 'Polyphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(96514, NULL, 'G3DSA:3.30.2160.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96515, NULL, 'G3DSA:3.80.10.10:FF:001577', NULL, NULL, 'Leucine-rich repeat-containing G protein-coupled receptor 4, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(96516, NULL, 'G3DSA:2.10.70.10:FF:000147', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(96517, NULL, 'G3DSA:1.25.10.10:FF:001938', NULL, NULL, 'Telomere repeats-binding bouquet formation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(96518, NULL, 'G3DSA:2.70.130.10:FF:000138', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96519, NULL, 'G3DSA:3.30.70.330:FF:002862', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96520, NULL, 'G3DSA:4.10.1000.30:FF:000002', NULL, NULL, 'Nuclear polyadenylated RNA-binding protein Nab2', NULL, NULL, NULL, NULL, NULL, 4),
(96521, NULL, 'G3DSA:2.130.10.10:FF:000250', NULL, NULL, 'Dynein assembly factor with WDR repeat domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(96522, NULL, 'G3DSA:2.130.10.10:FF:002487', NULL, NULL, 'Histidine kinase/response regulator hybrid protein', NULL, NULL, NULL, NULL, NULL, 4),
(96523, NULL, 'G3DSA:1.25.40.180:FF:000031', NULL, NULL, 'Eukaryotic translation initiation factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(96524, NULL, 'G3DSA:1.20.5.190:FF:000156', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96525, NULL, 'G3DSA:1.10.287.1150:FF:000018', NULL, NULL, 'Oxoglutarate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(96526, NULL, 'G3DSA:2.60.40.790:FF:000107', NULL, NULL, 'Prostaglandin E synthase 3', NULL, NULL, NULL, NULL, NULL, 4),
(96527, NULL, 'G3DSA:2.130.10.10:FF:002807', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96528, NULL, 'G3DSA:3.30.1450.10:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96529, NULL, 'G3DSA:3.40.47.10:FF:000308', NULL, NULL, 'Polyketide synthase/nonribosomal peptide synthetase hybrid RzxA', NULL, NULL, NULL, NULL, NULL, 4),
(96530, NULL, 'G3DSA:1.25.10.10:FF:002866', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(96531, NULL, 'G3DSA:3.80.10.10:FF:002066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96532, NULL, 'G3DSA:1.20.1700.10:FF:000005', NULL, NULL, 'Pantothenate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(96533, NULL, 'G3DSA:3.40.50.970:FF:000136', NULL, NULL, 'Putative inositol polyphosphate phosphatase (Synaptogenin-like) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(96534, NULL, 'G3DSA:3.30.519.10:FF:000018', NULL, NULL, 'Rab GDP dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(96535, NULL, 'G3DSA:1.20.58.60:FF:000865', NULL, NULL, 'Microtubule-actin crosslinking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(96536, NULL, 'G3DSA:3.40.50.2300:FF:001057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96537, NULL, 'G3DSA:3.30.430.20:FF:000034', NULL, NULL, 'Putative DUF26-domain protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(96538, NULL, 'G3DSA:2.30.29.30:FF:001321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96539, NULL, 'G3DSA:3.90.70.10:FF:000809', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96540, NULL, 'G3DSA:2.40.40.20:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96541, NULL, 'G3DSA:3.30.300.30:FF:000090', NULL, NULL, 'Acetate-CoA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(96542, NULL, 'G3DSA:2.60.120.970:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96543, NULL, 'G3DSA:3.40.109.10:FF:000007', NULL, NULL, 'Iodotyrosine deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(96544, NULL, 'G3DSA:1.10.533.10:FF:000310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96545, NULL, 'G3DSA:1.10.1370.30:FF:000015', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(96546, NULL, 'G3DSA:3.40.50.300:FF:000604', NULL, NULL, 'ABC transporter B family member 28', NULL, NULL, NULL, NULL, NULL, 4),
(96547, NULL, 'G3DSA:2.120.10.30:FF:000397', NULL, NULL, 'Gll1931 protein', NULL, NULL, NULL, NULL, NULL, 4),
(96548, NULL, 'G3DSA:1.10.287.740:FF:000001', NULL, NULL, 'Photosystem II reaction center protein Z', NULL, NULL, NULL, NULL, NULL, 4),
(96549, NULL, 'G3DSA:3.30.70.260:FF:000076', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(96550, NULL, 'G3DSA:1.10.30.10:FF:000040', NULL, NULL, 'SRY (sex determining region Y)-box 32', NULL, NULL, NULL, NULL, NULL, 4),
(96551, NULL, 'G3DSA:3.30.160.60:FF:002279', NULL, NULL, 'Histone H4 transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(96552, NULL, 'G3DSA:2.130.10.10:FF:001970', NULL, NULL, 'Eukaryotic translation initiation factor 2A', NULL, NULL, NULL, NULL, NULL, 4),
(96553, NULL, 'G3DSA:3.20.180.20:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96554, NULL, 'G3DSA:3.30.70.330:FF:001081', NULL, NULL, 'RNA-binding protein Musashi homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(96555, NULL, 'G3DSA:1.10.238.10:FF:001097', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(96556, NULL, 'G3DSA:2.60.120.10:FF:000398', NULL, NULL, 'Homogentisate 12-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(96557, NULL, 'G3DSA:1.25.40.20:FF:001623', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(96558, NULL, 'G3DSA:3.30.450.200:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96559, NULL, 'G3DSA:3.30.1010.10:FF:000134', NULL, NULL, 'PIKK family atypical protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(96560, NULL, 'G3DSA:2.30.30.140:FF:000204', NULL, NULL, 'Uncharacterized protein R102.4-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(96561, NULL, 'G3DSA:3.10.20.30:FF:000024', NULL, NULL, 'Na(+)-translocating NADH-quinone reductase subunit F', NULL, NULL, NULL, NULL, NULL, 4),
(96562, NULL, 'G3DSA:1.10.220.150:FF:000027', NULL, NULL, 'Gts1p', NULL, NULL, NULL, NULL, NULL, 4),
(96563, NULL, 'G3DSA:3.30.70.330:FF:001373', NULL, NULL, 'Oligouridylate-binding protein 1 isoform A', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(96564, NULL, 'G3DSA:1.20.58.1120:FF:000034', NULL, NULL, 'Dynein_heavy_chain_-_N-terminal_region_2_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(96565, NULL, 'G3DSA:3.30.70.3490:FF:000023', NULL, NULL, 'Unplaced genomic scaffold supercont1.170, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(96566, NULL, 'G3DSA:1.25.40.10:FF:004167', NULL, NULL, 'Os01g0299150 protein', NULL, NULL, NULL, NULL, NULL, 4),
(96567, NULL, 'G3DSA:1.10.472.10:FF:000668', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96568, NULL, 'G3DSA:2.60.120.560:FF:000020', NULL, NULL, 'N-acetyl-galactosamine-6-sulfatase (GALNS)', NULL, NULL, NULL, NULL, NULL, 4),
(96569, NULL, 'G3DSA:1.25.10.10:FF:001585', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96570, NULL, 'G3DSA:1.10.510.10:FF:001230', NULL, NULL, 'Spindle assembly checkpoint kinase', NULL, NULL, NULL, NULL, NULL, 4),
(96571, NULL, 'G3DSA:3.90.1480.20:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96572, NULL, 'G3DSA:2.120.10.30:FF:000217', NULL, NULL, 'Os10g0543500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(96573, NULL, 'G3DSA:3.40.50.12780:FF:000013', NULL, NULL, 'Long-chain-fatty-acid--AMP ligase FadD32', NULL, NULL, NULL, NULL, NULL, 4),
(96574, NULL, 'G3DSA:3.30.420.40:FF:000394', NULL, NULL, 'Heat shock protein 70 putative', NULL, NULL, NULL, NULL, NULL, 4),
(96575, NULL, 'G3DSA:3.40.50.300:FF:006383', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(96576, NULL, 'G3DSA:1.25.10.20:FF:000014', NULL, NULL, 'Hemelipoglyco-carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(96577, NULL, 'G3DSA:2.60.40.1730:FF:000056', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(96578, NULL, 'G3DSA:1.25.40.540:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96579, NULL, 'G3DSA:2.40.33.20:FF:000001', NULL, NULL, '6-N-hydroxylaminopurine resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(96580, NULL, 'G3DSA:3.90.550.50:FF:000038', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(96581, NULL, 'G3DSA:2.130.10.10:FF:005713', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96582, NULL, 'G3DSA:3.40.50.10860:FF:000049', NULL, NULL, 'Bifunctional protein FolD 3, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(96583, NULL, 'G3DSA:3.40.50.720:FF:002383', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96584, NULL, 'G3DSA:2.10.110.10:FF:000066', NULL, NULL, 'Four and a half LIM domains protein', NULL, NULL, NULL, NULL, NULL, 4),
(96585, NULL, 'G3DSA:4.10.240.10:FF:000085', NULL, NULL, 'Zinc cluster transcription factor CZF1', NULL, NULL, NULL, NULL, NULL, 4),
(96586, NULL, 'G3DSA:1.10.150.290:FF:000002', NULL, NULL, 'Trans-aconitate 2-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(96587, NULL, 'G3DSA:3.30.9.10:FF:000058', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(96588, NULL, 'G3DSA:1.10.510.10:FF:002950', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96589, NULL, 'G3DSA:3.80.10.10:FF:003055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96590, NULL, 'G3DSA:2.180.10.10:FF:000017', NULL, NULL, 'Wall-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(96591, NULL, 'G3DSA:3.10.20.90:FF:000699', NULL, NULL, 'Ubiquitin specific peptidase 32', NULL, NULL, NULL, NULL, NULL, 4),
(96592, NULL, 'G3DSA:1.20.1270.50:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96593, NULL, 'G3DSA:2.170.300.10:FF:000077', NULL, NULL, 'Platelet endothelial aggregation receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(96594, NULL, 'G3DSA:3.40.50.300:FF:002049', NULL, NULL, 'Si:ch73-170d6.2', NULL, NULL, NULL, NULL, NULL, 4),
(96595, NULL, 'G3DSA:1.25.40.20:FF:000134', NULL, NULL, 'inversin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(96596, NULL, 'G3DSA:2.30.30.40:FF:000467', NULL, NULL, 'SH3 domain-containing YSC84-like protein 1', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(96597, NULL, 'G3DSA:2.130.10.10:FF:005421', NULL, NULL, 'Endoplasmic reticulum to nucleus signaling 1', NULL, NULL, NULL, NULL, NULL, 4),
(96598, NULL, 'G3DSA:1.10.3290.10:FF:000003', NULL, NULL, 'Protein adenylyltransferase fic-1', NULL, NULL, NULL, NULL, NULL, 4),
(96599, NULL, 'G3DSA:3.40.50.720:FF:002411', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96600, NULL, 'G3DSA:3.30.200.20:FF:000697', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(96601, NULL, 'G3DSA:2.130.10.10:FF:003476', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96602, NULL, 'G3DSA:3.30.230.10:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96603, NULL, 'G3DSA:1.25.10.10:FF:000096', NULL, NULL, 'eIF-2-alpha kinase activator gcn1', NULL, NULL, NULL, NULL, NULL, 4),
(96604, NULL, 'G3DSA:2.60.40.10:FF:005589', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96605, NULL, 'G3DSA:3.30.160.60:FF:000042', NULL, NULL, 'Zinc finger protein 148', NULL, NULL, NULL, NULL, NULL, 4),
(96606, NULL, 'G3DSA:2.60.40.60:FF:000028', NULL, NULL, 'Protocadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(96607, NULL, 'G3DSA:3.90.1410.10:FF:000061', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(96608, NULL, 'G3DSA:3.80.10.10:FF:000649', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(96609, NULL, 'G3DSA:3.90.1150.10:FF:000023', NULL, NULL, 'Tryptophanase', NULL, NULL, NULL, NULL, NULL, 4),
(96610, NULL, 'G3DSA:3.20.20.140:FF:000066', NULL, NULL, 'Adenosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(96611, NULL, 'G3DSA:3.30.40.10:FF:002328', NULL, NULL, 'LON peptidase N-terminal domain and RING finger protein C14F5.10c', NULL, NULL, NULL, NULL, NULL, 4),
(96612, NULL, 'G3DSA:2.10.220.10:FF:000187', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(96613, NULL, 'G3DSA:2.60.120.380:FF:000090', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(96614, NULL, 'G3DSA:3.40.50.300:FF:004819', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96615, NULL, 'G3DSA:3.10.330.10:FF:000011', NULL, NULL, 'Peroxisome biogenesis protein peroxin 1', NULL, NULL, NULL, NULL, NULL, 4),
(96616, NULL, 'G3DSA:3.60.10.10:FF:000431', NULL, NULL, 'Proteasome subunit beta type-6-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(96617, NULL, 'G3DSA:3.30.70.60:FF:000001', NULL, NULL, 'Elongation factor 1-beta 1 like', NULL, NULL, NULL, NULL, NULL, 4),
(96618, NULL, 'G3DSA:1.20.1250.20:FF:000052', NULL, NULL, 'Protein TsgA', NULL, NULL, NULL, NULL, NULL, 4),
(96619, NULL, 'G3DSA:3.90.550.50:FF:000185', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(96620, NULL, 'G3DSA:1.10.274.100:FF:000031', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(96621, NULL, 'G3DSA:3.20.20.190:FF:000120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96622, NULL, 'G3DSA:3.40.50.1820:FF:000935', NULL, NULL, 'Putative lipase (Putative secreted protein)', NULL, NULL, NULL, NULL, NULL, 4),
(96623, NULL, 'G3DSA:1.20.120.1240:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96624, NULL, 'G3DSA:3.40.190.10:FF:000908', NULL, NULL, 'ABC transporter permease fused to pyrimidine biosynthesis enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(96625, NULL, 'G3DSA:1.20.1250.20:FF:002030', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(96626, NULL, 'G3DSA:3.40.50.1000:FF:000869', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96627, NULL, 'G3DSA:2.60.40.10:FF:006106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96628, NULL, 'G3DSA:3.30.1640.10:FF:000052', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(96629, NULL, 'G3DSA:3.30.70.80:FF:000007', NULL, NULL, 'Organelle RRM domain-containing protein 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(96630, NULL, 'G3DSA:3.40.50.1440:FF:000153', NULL, NULL, 'Putative nucleolar protein 5-1', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(96631, NULL, 'G3DSA:3.30.40.10:FF:002036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96632, NULL, 'G3DSA:3.30.160.60:FF:002812', NULL, NULL, 'Neuroectoderm-expressed 2, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(96633, NULL, 'G3DSA:2.160.10.10:FF:000119', NULL, NULL, 'Eukaryotic Initiation Factor', NULL, NULL, NULL, NULL, NULL, 4),
(96634, NULL, 'G3DSA:2.70.98.10:FF:000045', NULL, NULL, 'Putative aldose 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(96635, NULL, 'G3DSA:2.130.10.10:FF:002015', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(96636, NULL, 'G3DSA:2.130.10.10:FF:001559', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96637, NULL, 'G3DSA:2.40.100.10:FF:000025', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase CYP19-2', NULL, NULL, NULL, NULL, NULL, 4),
(96638, NULL, 'G3DSA:1.20.1280.50:FF:000129', NULL, NULL, 'AGAP008941-PA', NULL, NULL, NULL, NULL, NULL, 4),
(96639, NULL, 'G3DSA:3.30.70.330:FF:001934', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96640, NULL, 'G3DSA:1.20.1540.10:FF:000003', NULL, NULL, 'Rhomboid protease GlpG', NULL, NULL, NULL, NULL, NULL, 4),
(96641, NULL, 'G3DSA:2.10.25.10:FF:001801', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96642, NULL, 'G3DSA:2.20.80.10:FF:000012', NULL, NULL, 'Uncharacterized protein VTG4', NULL, NULL, NULL, NULL, NULL, 4),
(96643, NULL, 'G3DSA:2.60.120.260:FF:000492', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96644, NULL, 'G3DSA:2.60.220.50:FF:000007', NULL, NULL, 'Adhesion G protein-coupled receptor E5', NULL, NULL, NULL, NULL, NULL, 4),
(96645, NULL, 'G3DSA:3.40.50.1820:FF:001132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96646, NULL, 'G3DSA:4.10.60.10:FF:000097', NULL, NULL, 'Universal minicircle sequence binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(96647, NULL, 'G3DSA:2.40.128.630:FF:000005', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(96648, NULL, 'G3DSA:3.40.250.10:FF:000234', NULL, NULL, 'Thiosulfate sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(96649, NULL, 'G3DSA:3.30.565.10:FF:000057', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(96650, NULL, 'G3DSA:2.60.40.10:FF:004128', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96651, NULL, 'G3DSA:1.20.1070.10:FF:001586', NULL, NULL, 'Relaxin family peptide receptor 2,-like', NULL, NULL, NULL, NULL, NULL, 4),
(96652, NULL, 'G3DSA:1.20.58.80:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96653, NULL, 'G3DSA:3.30.160.60:FF:006466', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96654, NULL, 'G3DSA:3.10.50.40:FF:000034', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(96655, NULL, 'G3DSA:1.10.1370.10:FF:000037', NULL, NULL, 'Metallopeptidase MepB', NULL, NULL, NULL, NULL, NULL, 4),
(96656, NULL, 'G3DSA:2.60.40.1180:FF:000138', NULL, NULL, 'Isoamylase 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(96657, NULL, 'G3DSA:3.40.190.10:FF:000263', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(96658, NULL, 'G3DSA:2.60.200.20:FF:000048', NULL, NULL, 'Zeaxanthin epoxidase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(96659, NULL, 'G3DSA:3.40.50.1820:FF:000643', NULL, NULL, 'Protein phosphatase methylesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(96660, NULL, 'G3DSA:3.30.200.20:FF:001978', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96661, NULL, 'G3DSA:2.30.30.360:FF:000006', NULL, NULL, 'Non-muscle MYosin', NULL, NULL, NULL, NULL, NULL, 4),
(96662, NULL, 'G3DSA:3.50.50.60:FF:000600', NULL, NULL, 'Probable oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(96663, NULL, 'G3DSA:3.80.10.10:FF:002858', NULL, NULL, 'AGAP009688-PA', NULL, NULL, NULL, NULL, NULL, 4),
(96664, NULL, 'G3DSA:3.30.450.40:FF:000075', NULL, NULL, 'Bifunctional diguanylate cyclase/phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(96665, NULL, 'G3DSA:1.20.5.620:FF:000004', NULL, NULL, 'V-type proton ATPase subunit G', NULL, NULL, NULL, NULL, NULL, 4),
(96666, NULL, 'G3DSA:1.10.10.440:FF:000012', NULL, NULL, 'pre-mRNA-processing factor 40 homolog A isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(96667, NULL, 'G3DSA:3.60.110.10:FF:000034', NULL, NULL, 'Putative hydrolase NIT3', NULL, NULL, NULL, NULL, NULL, 4),
(96668, NULL, 'G3DSA:1.20.1250.20:FF:000613', NULL, NULL, 'AmpG protein', NULL, NULL, NULL, NULL, NULL, 4),
(96669, NULL, 'G3DSA:3.40.50.300:FF:004258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96670, NULL, 'G3DSA:3.30.1050.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96671, NULL, 'G3DSA:2.130.10.10:FF:003768', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96672, NULL, 'G3DSA:3.30.70.1180:FF:000004', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(96673, NULL, 'G3DSA:3.40.50.2000:FF:000068', NULL, NULL, 'UDP-N-acetylglucosamine 2-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(96674, NULL, 'G3DSA:1.10.565.10:FF:000120', NULL, NULL, 'Nuclear receptor subfamily 5, group A, member 1a', NULL, NULL, NULL, NULL, NULL, 4),
(96675, NULL, 'G3DSA:3.80.10.10:FF:000621', NULL, NULL, 'Si:dkeyp-4c4.2', NULL, NULL, NULL, NULL, NULL, 4),
(96676, NULL, 'G3DSA:3.40.50.12160:FF:000035', NULL, NULL, 'Threonylcarbamoyladenosine tRNA methylthiotransferase MtaB', NULL, NULL, NULL, NULL, NULL, 4),
(96677, NULL, 'G3DSA:3.30.160.60:FF:004257', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96678, NULL, 'G3DSA:2.60.40.2030:FF:000051', NULL, NULL, 'Calx-beta domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(96679, NULL, 'G3DSA:1.20.1070.10:FF:001147', NULL, NULL, 'Putative G-protein coupled receptor 135', NULL, NULL, NULL, NULL, NULL, 4),
(96680, NULL, 'G3DSA:1.20.1070.10:FF:000658', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(96681, NULL, 'G3DSA:1.25.10.10:FF:002074', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(96682, NULL, 'G3DSA:3.40.50.1820:FF:001571', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96683, NULL, 'G3DSA:3.50.7.10:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96684, NULL, 'G3DSA:3.30.160.60:FF:000334', NULL, NULL, 'E3 ubiquitin-protein ligase Midline-1', NULL, NULL, NULL, NULL, NULL, 4),
(96685, NULL, 'G3DSA:3.40.50.150:FF:000250', NULL, NULL, 'Ubiquinone/menaquinone biosynthesis C-methyltransferase UbiE', NULL, NULL, NULL, NULL, NULL, 4),
(96686, NULL, 'G3DSA:3.40.50.150:FF:001026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96687, NULL, 'G3DSA:3.90.640.10:FF:000112', NULL, NULL, 'Actin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(96688, NULL, 'G3DSA:3.30.160.60:FF:005977', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96689, NULL, 'G3DSA:3.50.50.60:FF:000067', NULL, NULL, 'spermine oxidase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(96690, NULL, 'G3DSA:3.40.50.300:FF:002021', NULL, NULL, 'RHOD isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(96691, NULL, 'G3DSA:3.40.1160.10:FF:000075', NULL, NULL, 'Isopentenyl phosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(96692, NULL, 'G3DSA:1.25.40.10:FF:000777', NULL, NULL, 'pentatricopeptide repeat-containing protein At5g39980, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(96693, NULL, 'G3DSA:3.90.1750.10:FF:000052', NULL, NULL, 'Zn-finger_in_Ran_binding_protein_and_others/SPRY_domain/HECT-domain_(Ubiquitin-transferase)', NULL, NULL, NULL, NULL, NULL, 4),
(96694, NULL, 'G3DSA:1.10.8.270:FF:000143', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(96695, NULL, 'G3DSA:2.60.40.10:FF:000385', NULL, NULL, 'Neuroplastin a', NULL, NULL, NULL, NULL, NULL, 4),
(96696, NULL, 'G3DSA:3.40.50.300:FF:007664', NULL, NULL, 'ATP binding cassette subfamily A member 8', NULL, NULL, NULL, NULL, NULL, 4),
(96697, NULL, 'G3DSA:1.10.1450.10:FF:000010', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(96698, NULL, 'G3DSA:3.90.70.10:FF:000164', NULL, NULL, 'Cysteine protease Mir1', NULL, NULL, NULL, NULL, NULL, 4),
(96699, NULL, 'G3DSA:3.40.50.720:FF:001747', NULL, NULL, 'quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(96700, NULL, 'G3DSA:3.20.20.70:FF:000108', NULL, NULL, 'IMP dehydrogenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(96701, NULL, 'G3DSA:3.90.180.10:FF:000032', NULL, NULL, 'Probable polyketide synthase pks1', NULL, NULL, NULL, NULL, NULL, 4),
(96702, NULL, 'G3DSA:3.40.50.1440:FF:000006', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(96703, NULL, 'G3DSA:1.10.1450.10:FF:000038', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(96704, NULL, 'G3DSA:3.20.20.20:FF:000026', NULL, NULL, 'Dihydropteroate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(96705, NULL, 'G3DSA:3.40.50.12780:FF:000193', NULL, NULL, 'AMP dependent CoA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(96706, NULL, 'G3DSA:1.25.40.180:FF:000323', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96707, NULL, 'G3DSA:1.10.510.10:FF:002539', NULL, NULL, 'Kinase-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(96708, NULL, 'G3DSA:3.40.140.10:FF:000113', NULL, NULL, 'Putative deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(96709, NULL, 'G3DSA:3.40.190.10:FF:000116', NULL, NULL, 'Phosphate-binding protein PstS', NULL, NULL, NULL, NULL, NULL, 4),
(96710, NULL, 'G3DSA:2.60.40.150:FF:000562', NULL, NULL, 'Sperm vesicle fusion protein fer-1', NULL, NULL, NULL, NULL, NULL, 4),
(96711, NULL, 'G3DSA:1.10.565.10:FF:000148', NULL, NULL, 'Nuclear hormone receptor family member nhr-23', NULL, NULL, NULL, NULL, NULL, 4),
(96712, NULL, 'G3DSA:2.70.98.30:FF:000023', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(96713, NULL, 'G3DSA:1.20.1560.10:FF:000858', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96714, NULL, 'G3DSA:2.10.25.10:FF:001268', NULL, NULL, 'Drosophila CRumBs homolog', NULL, NULL, NULL, NULL, NULL, 4),
(96715, NULL, 'G3DSA:3.40.850.10:FF:000263', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(96716, NULL, 'G3DSA:1.20.1280.50:FF:000276', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(96717, NULL, 'G3DSA:1.10.510.10:FF:002511', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96718, NULL, 'G3DSA:2.40.170.20:FF:000009', NULL, NULL, 'Fe(3+) dicitrate transport protein FecA', NULL, NULL, NULL, NULL, NULL, 4),
(96719, NULL, 'G3DSA:3.80.10.10:FF:003494', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96720, NULL, 'G3DSA:2.60.220.30:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96721, NULL, 'G3DSA:2.60.40.10:FF:003791', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96722, NULL, 'G3DSA:3.40.50.12350:FF:000002', NULL, NULL, 'Eyes absent homolog', NULL, NULL, NULL, NULL, NULL, 4),
(96723, NULL, 'G3DSA:3.30.2350.20:FF:000067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96724, NULL, 'G3DSA:3.10.129.10:FF:000077', NULL, NULL, 'Thioesterase-like family protein', NULL, NULL, NULL, NULL, NULL, 4),
(96725, NULL, 'G3DSA:3.30.505.10:FF:000256', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96726, NULL, 'G3DSA:1.20.1560.10:FF:000033', NULL, NULL, 'ABC transporter B family member 19', NULL, NULL, NULL, NULL, NULL, 4),
(96727, NULL, 'G3DSA:3.40.1110.10:FF:000072', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(96728, NULL, 'G3DSA:1.50.10.130:FF:000011', NULL, NULL, 'Terpene synthase26', NULL, NULL, NULL, NULL, NULL, 4),
(96729, NULL, 'G3DSA:3.40.50.300:FF:000076', NULL, NULL, 'Replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(96730, NULL, 'G3DSA:2.30.180.10:FF:000150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96731, NULL, 'G3DSA:3.30.200.20:FF:002203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96732, NULL, 'G3DSA:3.30.200.20:FF:000517', NULL, NULL, 'probable LRR receptor-like serine/threonine-protein kinase At1g34110', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(96733, NULL, 'G3DSA:2.10.25.10:FF:001240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96734, NULL, 'G3DSA:3.30.160.60:FF:001795', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96735, NULL, 'G3DSA:1.25.40.20:FF:001062', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(96736, NULL, 'G3DSA:2.160.20.10:FF:000064', NULL, NULL, 'Cell wall surface anchor family protein', NULL, NULL, NULL, NULL, NULL, 4),
(96737, NULL, 'G3DSA:2.60.40.60:FF:000467', NULL, NULL, 'protocadherin-11 X-linked', NULL, NULL, NULL, NULL, NULL, 4),
(96738, NULL, 'G3DSA:3.30.230.10:FF:000016', NULL, NULL, 'Ribonuclease P protein component', NULL, NULL, NULL, NULL, NULL, 4),
(96739, NULL, 'G3DSA:1.10.730.10:FF:000105', NULL, NULL, 'Isoleucyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(96740, NULL, 'G3DSA:2.40.50.140:FF:000307', NULL, NULL, 'Eukaryotic translation initiation factor 5A', NULL, NULL, NULL, NULL, NULL, 4),
(96741, NULL, 'G3DSA:1.25.40.10:FF:002722', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96742, NULL, 'G3DSA:1.20.5.1190:FF:000009', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(96743, NULL, 'G3DSA:1.20.58.80:FF:000051', NULL, NULL, 'AAA family ATPase, p60 katanin', NULL, NULL, NULL, NULL, NULL, 4),
(96744, NULL, 'G3DSA:1.10.220.10:FF:000022', NULL, NULL, 'Annexin A5', NULL, NULL, NULL, NULL, NULL, 4),
(96745, NULL, 'G3DSA:1.25.40.10:FF:003211', NULL, NULL, 'Transcription factor TFIIIC subunit', NULL, NULL, NULL, NULL, NULL, 4),
(96746, NULL, 'G3DSA:3.20.20.80:FF:000729', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96747, NULL, 'G3DSA:3.40.1190.20:FF:000113', NULL, NULL, 'ADP-dependent (S)-NAD(P)H-hydrate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(96748, NULL, 'G3DSA:3.30.70.980:FF:000027', NULL, NULL, 'AGAP001629-PA', NULL, NULL, NULL, NULL, NULL, 4),
(96749, NULL, 'G3DSA:2.40.50.140:FF:000015', NULL, NULL, 'Eukaryotic translation initiation factor 2 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(96750, NULL, 'G3DSA:3.40.50.1580:FF:000054', NULL, NULL, 'S-methyl-5''-thioadenosine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(96751, NULL, 'G3DSA:3.40.1280.10:FF:000022', NULL, NULL, 'Trm3p', NULL, NULL, NULL, NULL, NULL, 4),
(96752, NULL, 'G3DSA:3.30.200.20:FF:001006', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase TDR', NULL, NULL, NULL, NULL, NULL, 4),
(96753, NULL, 'G3DSA:3.30.420.270:FF:000035', NULL, NULL, 'Probable Biopolymer transport exbD protein', NULL, NULL, NULL, NULL, NULL, 4),
(96754, NULL, 'G3DSA:3.40.50.300:FF:008153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96755, NULL, 'G3DSA:3.40.50.1000:FF:000369', NULL, NULL, '5''-nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(96756, NULL, 'G3DSA:1.10.60.10:FF:000008', NULL, NULL, 'Diphtheria toxin repressor', NULL, NULL, NULL, NULL, NULL, 4),
(96757, NULL, 'G3DSA:3.30.200.20:FF:001478', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96758, NULL, 'G3DSA:3.90.1150.10:FF:000254', NULL, NULL, 'Neamine transaminase NeoN', NULL, NULL, NULL, NULL, NULL, 4),
(96759, NULL, 'G3DSA:3.40.50.300:FF:008209', NULL, NULL, '26S protease regulatory subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(96760, NULL, 'G3DSA:3.30.390.50:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96761, NULL, 'G3DSA:1.10.10.10:FF:000977', NULL, NULL, 'Transcriptional regulator, IclR family', NULL, NULL, NULL, NULL, NULL, 4),
(96762, NULL, 'G3DSA:3.30.450.20:FF:000209', NULL, NULL, 'DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(96763, NULL, 'G3DSA:3.40.50.1820:FF:000082', NULL, NULL, 'monoacylglycerol lipase ABHD6', NULL, NULL, NULL, NULL, NULL, 4),
(96764, NULL, 'G3DSA:1.50.40.10:FF:000393', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96765, NULL, 'G3DSA:2.160.10.10:FF:000058', NULL, NULL, 'Transferase, hexapeptide repeat family', NULL, NULL, NULL, NULL, NULL, 4),
(96766, NULL, 'G3DSA:3.30.60.30:FF:000132', NULL, NULL, 'Agrin, putative', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(96767, NULL, 'G3DSA:2.60.40.10:FF:001402', NULL, NULL, 'Matrix remodeling associated 5', NULL, NULL, NULL, NULL, NULL, 4),
(96768, NULL, 'G3DSA:3.30.160.60:FF:006202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96769, NULL, 'G3DSA:3.40.50.920:FF:000054', NULL, NULL, 'Branched chain keto acid dehydrogenase E1 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(96770, NULL, 'G3DSA:3.10.290.60:FF:000005', NULL, NULL, 'Ubiquitin-like modifier-activating enzyme 7', NULL, NULL, NULL, NULL, NULL, 4),
(96771, NULL, 'G3DSA:2.120.10.80:FF:000390', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96772, NULL, 'G3DSA:1.25.40.840:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96773, NULL, 'G3DSA:2.60.40.150:FF:000793', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96774, NULL, 'G3DSA:1.25.10.10:FF:000657', NULL, NULL, 'RPTOR independent companion of MTOR complex 2', NULL, NULL, NULL, NULL, NULL, 4),
(96775, NULL, 'G3DSA:2.60.40.640:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96776, NULL, 'G3DSA:3.40.50.1110:FF:000110', NULL, NULL, 'Phospholipase B1, membrane-associated-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(96777, NULL, 'G3DSA:3.40.50.410:FF:000345', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(96778, NULL, 'G3DSA:3.40.50.300:FF:004466', NULL, NULL, 'Adenylate isopentenyltransferase 5, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(96779, NULL, 'G3DSA:2.130.10.10:FF:003976', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96780, NULL, 'G3DSA:1.20.1250.20:FF:000405', NULL, NULL, 'Solute carrier family 46 member 3', NULL, NULL, NULL, NULL, NULL, 4),
(96781, NULL, 'G3DSA:1.10.510.10:FF:000741', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(96782, NULL, 'G3DSA:2.60.40.10:FF:004572', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96783, NULL, 'G3DSA:3.30.720.170:FF:000005', NULL, NULL, 'Perilipin', NULL, NULL, NULL, NULL, NULL, 4),
(96784, NULL, 'G3DSA:1.10.510.10:FF:002450', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96785, NULL, 'G3DSA:3.40.50.300:FF:001240', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(96786, NULL, 'G3DSA:2.20.28.10:FF:000032', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(96787, NULL, 'G3DSA:3.30.70.330:FF:000153', NULL, NULL, 'U1 small nuclear ribonucleoprotein 70 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(96788, NULL, 'G3DSA:3.30.160.60:FF:004488', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96789, NULL, 'G3DSA:3.40.50.150:FF:000750', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(96790, NULL, 'G3DSA:2.70.20.60:FF:000004', NULL, NULL, 'Matrix protein', NULL, NULL, NULL, NULL, NULL, 4),
(96791, NULL, 'G3DSA:2.60.40.3510:FF:000005', NULL, NULL, 'Delta-like 3 (Drosophila), isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(96792, NULL, 'G3DSA:3.10.25.10:FF:000006', NULL, NULL, 'Methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(96793, NULL, 'G3DSA:3.30.40.10:FF:001811', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96794, NULL, 'G3DSA:2.60.120.290:FF:000208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96795, NULL, 'G3DSA:2.60.40.1730:FF:000117', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96796, NULL, 'G3DSA:3.30.70.330:FF:001581', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96797, NULL, 'G3DSA:2.30.30.30:FF:000110', NULL, NULL, '50S ribosomal protein L24', NULL, NULL, NULL, NULL, NULL, 4),
(96798, NULL, 'G3DSA:1.20.1250.20:FF:001833', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96799, NULL, 'G3DSA:2.130.10.10:FF:005685', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96800, NULL, 'G3DSA:3.40.50.720:FF:001955', NULL, NULL, 'Fat body protein 2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(96801, NULL, 'G3DSA:2.130.10.10:FF:000750', NULL, NULL, 'Microtubule associated katanin, putative', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(96802, NULL, 'G3DSA:3.20.20.80:FF:000229', NULL, NULL, 'Lysozyme', NULL, NULL, NULL, NULL, NULL, 4),
(96803, NULL, 'G3DSA:1.20.1270.280:FF:000014', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(96804, NULL, 'G3DSA:3.90.550.10:FF:000493', NULL, NULL, 'procollagen galactosyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(96805, NULL, 'G3DSA:2.60.200.20:FF:000256', NULL, NULL, 'Transcription factor P14E8.02', NULL, NULL, NULL, NULL, NULL, 4),
(96806, NULL, 'G3DSA:1.25.40.10:FF:000013', NULL, NULL, 'UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase 110 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(96807, NULL, 'G3DSA:2.70.150.10:FF:000229', NULL, NULL, 'Protein CBG19651', NULL, NULL, NULL, NULL, NULL, 4),
(96808, NULL, 'G3DSA:2.30.30.140:FF:000176', NULL, NULL, 'Protein CBG17113', NULL, NULL, NULL, NULL, NULL, 4),
(96809, NULL, 'G3DSA:3.30.530.20:FF:000098', NULL, NULL, 'Coenzyme Q-binding protein COQ10 B, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(96810, NULL, 'G3DSA:1.20.1070.10:FF:002075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96811, NULL, 'G3DSA:1.25.40.90:FF:000082', NULL, NULL, 'ENTH/VHS family protein', NULL, NULL, NULL, NULL, NULL, 4),
(96812, NULL, 'G3DSA:2.30.29.30:FF:000101', NULL, NULL, 'Rho GTPase activating protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(96813, NULL, 'G3DSA:3.40.50.720:FF:000174', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(96814, NULL, 'G3DSA:2.130.10.10:FF:003504', NULL, NULL, 'F-box and WD domain protein (AFU_orthologue AFUA_6G11400)', NULL, NULL, NULL, NULL, NULL, 4),
(96815, NULL, 'G3DSA:2.60.40.420:FF:000278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96816, NULL, 'G3DSA:3.90.1310.10:FF:000025', NULL, NULL, 'Cell division protein', NULL, NULL, NULL, NULL, NULL, 4),
(96817, NULL, 'G3DSA:1.20.1250.20:FF:000877', NULL, NULL, 'Sugar (Glycoside-Pentoside-Hexuronide) transporter', NULL, NULL, NULL, NULL, NULL, 4),
(96818, NULL, 'G3DSA:3.50.50.60:FF:000628', NULL, NULL, 'FAD-dependent pyridine nucleotide-disulphide oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(96819, NULL, 'G3DSA:2.40.420.20:FF:000018', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(96820, NULL, 'G3DSA:3.90.105.20:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96821, NULL, 'G3DSA:1.10.10.2830:FF:000004', NULL, NULL, 'ParB-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(96822, NULL, 'G3DSA:3.30.830.10:FF:000045', NULL, NULL, 'M16 family peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(96823, NULL, 'G3DSA:1.10.10.60:FF:000031', NULL, NULL, 'Homeobox protein', NULL, NULL, NULL, NULL, NULL, 4),
(96824, NULL, 'G3DSA:1.25.40.10:FF:004228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96825, NULL, 'G3DSA:2.40.70.10:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96826, NULL, 'G3DSA:2.130.10.10:FF:001470', NULL, NULL, 'Protein CBR-CHE-2', NULL, NULL, NULL, NULL, NULL, 4),
(96827, NULL, 'G3DSA:2.60.40.10:FF:000885', NULL, NULL, 'Putative GTP-binding protein EsdC', NULL, NULL, NULL, NULL, NULL, 4),
(96828, NULL, 'G3DSA:3.40.50.2300:FF:000568', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(96829, NULL, 'G3DSA:3.20.20.190:FF:000148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96830, NULL, 'G3DSA:2.10.25.10:FF:000020', NULL, NULL, 'Latent-transforming growth factor beta-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(96831, NULL, 'G3DSA:3.30.40.10:FF:000030', NULL, NULL, 'Protein Jade-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(96832, NULL, 'G3DSA:3.30.40.10:FF:000119', NULL, NULL, 'E3 ubiquitin-protein ligase MARCH2', NULL, NULL, NULL, NULL, NULL, 4),
(96833, NULL, 'G3DSA:2.60.120.830:FF:000005', NULL, NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 17', NULL, NULL, NULL, NULL, NULL, 4),
(96834, NULL, 'G3DSA:2.60.40.2700:FF:000004', NULL, NULL, 'Stomatal closure actin-binding-like protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(96835, NULL, 'G3DSA:2.40.70.10:FF:000404', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96836, NULL, 'G3DSA:3.10.450.50:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96837, NULL, 'G3DSA:3.80.10.10:FF:002274', NULL, NULL, 'Leucine-rich repeat-containing protein ODA7', NULL, NULL, NULL, NULL, NULL, 4),
(96838, NULL, 'G3DSA:3.40.50.300:FF:003038', NULL, NULL, 'RAB10, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(96839, NULL, 'G3DSA:2.40.50.140:FF:000279', NULL, NULL, 'rRNA biogenesis protein rrp5', NULL, NULL, NULL, NULL, NULL, 4),
(96840, NULL, 'G3DSA:1.20.1720.10:FF:000040', NULL, NULL, 'Multidrug resistance protein D', NULL, NULL, NULL, NULL, NULL, 4),
(96841, NULL, 'G3DSA:2.40.30.130:FF:000002', NULL, NULL, 'alanine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(96842, NULL, 'G3DSA:3.30.505.50:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96843, NULL, 'G3DSA:3.40.80.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96844, NULL, 'G3DSA:3.40.50.1000:FF:000577', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96845, NULL, 'G3DSA:1.20.85.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96846, NULL, 'G3DSA:2.20.110.10:FF:000013', NULL, NULL, 'Putative Junctophilin-1', NULL, NULL, NULL, NULL, NULL, 4),
(96847, NULL, 'G3DSA:3.30.497.10:FF:000039', NULL, NULL, 'Innexin', NULL, NULL, NULL, NULL, NULL, 4),
(96848, NULL, 'G3DSA:3.40.50.1010:FF:000226', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96849, NULL, 'G3DSA:3.40.50.1000:FF:000105', NULL, NULL, 'Phosphoserine phosphatase ThrH', NULL, NULL, NULL, NULL, NULL, 4),
(96850, NULL, 'G3DSA:3.90.830.10:FF:000003', NULL, NULL, 'Sec1 family domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(96851, NULL, 'G3DSA:1.10.510.10:FF:001022', NULL, NULL, 'Cyclin-dependent kinase C-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(96852, NULL, 'G3DSA:3.30.200.20:FF:001686', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96853, NULL, 'G3DSA:2.130.10.10:FF:004696', NULL, NULL, 'Flagellar/basal body protein', NULL, NULL, NULL, NULL, NULL, 4),
(96854, NULL, 'G3DSA:3.20.20.370:FF:000022', NULL, NULL, 'Feruloyl esterase', NULL, NULL, NULL, NULL, NULL, 4),
(96855, NULL, 'G3DSA:3.90.70.10:FF:000309', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 13', NULL, NULL, NULL, NULL, NULL, 4),
(96856, NULL, 'G3DSA:3.40.50.300:FF:006883', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96857, NULL, 'G3DSA:3.40.50.1100:FF:000253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96858, NULL, 'G3DSA:1.10.150.50:FF:000011', NULL, NULL, 'Polyhomeotic-like protein 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(96859, NULL, 'G3DSA:1.10.510.10:FF:002186', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(96860, NULL, 'G3DSA:2.30.42.10:FF:000290', NULL, NULL, 'Partitioning defective protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(96861, NULL, 'G3DSA:3.40.50.1820:FF:001863', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96862, NULL, 'G3DSA:3.10.320.10:FF:000005', NULL, NULL, 'MHC class II histocompatibility antigen', NULL, NULL, NULL, NULL, NULL, 4),
(96863, NULL, 'G3DSA:2.60.40.10:FF:001666', NULL, NULL, 'Dystroglycan, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(96864, NULL, 'G3DSA:1.10.287.140:FF:000001', NULL, NULL, 'Glutamate dehydrogenase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(96865, NULL, 'G3DSA:3.40.630.10:FF:000191', NULL, NULL, 'Succinyl-diaminopimelate desuccinylase', NULL, NULL, NULL, NULL, NULL, 4),
(96866, NULL, 'G3DSA:1.10.1420.10:FF:000154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96867, NULL, 'G3DSA:1.25.40.10:FF:003503', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96868, NULL, 'G3DSA:2.60.40.420:FF:000014', NULL, NULL, 'Quinol oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(96869, NULL, 'G3DSA:3.30.540.10:FF:000034', NULL, NULL, 'Inositol monophosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(96870, NULL, 'G3DSA:3.30.870.10:FF:000199', NULL, NULL, 'Phopholipase D, putative', NULL, NULL, NULL, NULL, NULL, 4),
(96871, NULL, 'G3DSA:1.10.287.160:FF:000007', NULL, NULL, 'Rhophilin-2', NULL, NULL, NULL, NULL, NULL, 4),
(96872, NULL, 'G3DSA:3.90.1600.10:FF:000036', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(96873, NULL, 'G3DSA:1.25.10.10:FF:001377', NULL, NULL, 'Karyopherin', NULL, NULL, NULL, NULL, NULL, 4),
(96874, NULL, 'G3DSA:3.40.50.12780:FF:000221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96875, NULL, 'G3DSA:3.40.50.150:FF:001470', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96876, NULL, 'G3DSA:2.170.15.10:FF:000001', NULL, NULL, 'Aerolysin', NULL, NULL, NULL, NULL, NULL, 4),
(96877, NULL, 'G3DSA:1.10.287.70:FF:000772', NULL, NULL, 'Voltage-dependent sodium channel, putative', NULL, NULL, NULL, NULL, NULL, 4),
(96878, NULL, 'G3DSA:2.120.10.30:FF:000425', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96879, NULL, 'G3DSA:3.20.20.70:FF:000491', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96880, NULL, 'G3DSA:1.10.580.10:FF:000043', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(96881, NULL, 'G3DSA:1.10.472.10:FF:000640', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96882, NULL, 'G3DSA:1.10.238.10:FF:000080', NULL, NULL, 'Sodium leak channel non-selective protein', NULL, NULL, NULL, NULL, NULL, 4),
(96883, NULL, 'G3DSA:3.40.50.2300:FF:000832', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96884, NULL, 'G3DSA:3.10.490.10:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96885, NULL, 'G3DSA:1.25.40.450:FF:000016', NULL, NULL, 'Nuclear pore complex protein Nup155-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(96886, NULL, 'G3DSA:3.90.550.50:FF:000246', NULL, NULL, 'RFNG O-fucosylpeptide 3-beta-N-acetylglucosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(96887, NULL, 'G3DSA:3.40.50.300:FF:006175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96888, NULL, 'G3DSA:3.40.20.10:FF:000067', NULL, NULL, 'TWF1p Twinfilin', NULL, NULL, NULL, NULL, NULL, 4),
(96889, NULL, 'G3DSA:3.30.559.30:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96890, NULL, 'G3DSA:3.40.50.150:FF:000542', NULL, NULL, 'Class I SAM-dependent methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(96891, NULL, 'G3DSA:3.40.50.10810:FF:000175', NULL, NULL, 'DNA excision repair protein ERCC-6', NULL, NULL, NULL, NULL, NULL, 4),
(96892, NULL, 'G3DSA:1.10.238.20:FF:000026', NULL, NULL, 'Odorant-binding protein 56g', NULL, NULL, NULL, NULL, NULL, 4),
(96893, NULL, 'G3DSA:1.25.40.20:FF:001415', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(96894, NULL, 'G3DSA:3.30.460.10:FF:000033', NULL, NULL, 'Poly A polymerase head domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(96895, NULL, 'G3DSA:1.10.510.10:FF:000033', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(96896, NULL, 'G3DSA:1.25.40.10:FF:000485', NULL, NULL, 'pentatricopeptide repeat-containing protein At4g16390, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(96897, NULL, 'G3DSA:2.30.42.10:FF:000379', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96898, NULL, 'G3DSA:3.40.50.10540:FF:000010', NULL, NULL, 'Probable CoA-transferase Rv1866', NULL, NULL, NULL, NULL, NULL, 4),
(96899, NULL, 'G3DSA:2.70.130.10:FF:000110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96900, NULL, 'G3DSA:3.30.40.10:FF:001108', NULL, NULL, 'Small subunit ribosomal protein 20', NULL, NULL, NULL, NULL, NULL, 4),
(96901, NULL, 'G3DSA:3.90.550.10:FF:000605', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96902, NULL, 'G3DSA:3.40.50.1910:FF:000018', NULL, NULL, 'Carnation, isoform C', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(96903, NULL, 'G3DSA:3.90.1140.10:FF:000017', NULL, NULL, 'U6 snRNA phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(96904, NULL, 'G3DSA:2.30.30.40:FF:000175', NULL, NULL, 'Melanoma-derived growth regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(96905, NULL, 'G3DSA:3.30.420.40:FF:000186', NULL, NULL, 'Actin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(96906, NULL, 'G3DSA:1.20.1070.10:FF:001939', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96907, NULL, 'G3DSA:3.40.1000.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96908, NULL, 'G3DSA:2.60.40.10:FF:000677', NULL, NULL, 'protein sidekick isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(96909, NULL, 'G3DSA:1.25.40.180:FF:000059', NULL, NULL, 'Putative eukaryotic translation initiation factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(96910, NULL, 'G3DSA:3.90.45.10:FF:000004', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(96911, NULL, 'G3DSA:1.10.10.10:FF:001966', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96912, NULL, 'G3DSA:3.30.70.1230:FF:000126', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(96913, NULL, 'G3DSA:1.25.40.20:FF:001915', NULL, NULL, 'Ankyrin-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(96914, NULL, 'G3DSA:3.30.70.1820:FF:000005', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(96915, NULL, 'G3DSA:2.70.150.10:FF:000173', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(96916, NULL, 'G3DSA:1.10.8.60:FF:000311', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96917, NULL, 'G3DSA:1.10.510.10:FF:001994', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(96918, NULL, 'G3DSA:1.25.10.10:FF:001877', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(96919, NULL, 'G3DSA:2.60.40.760:FF:000003', NULL, NULL, 'Expansin-like A2', NULL, NULL, NULL, NULL, NULL, 4),
(96920, NULL, 'G3DSA:3.40.50.2300:FF:001496', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96921, NULL, 'G3DSA:1.10.510.10:FF:001730', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', NULL, NULL, NULL, NULL, NULL, 4),
(96922, NULL, 'G3DSA:2.60.34.10:FF:000033', NULL, NULL, 'Heat shock 70 kDa protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(96923, NULL, 'G3DSA:3.30.9.10:FF:000266', NULL, NULL, 'Fructosyl-amino acid oxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(96924, NULL, 'G3DSA:2.40.10.10:FF:000428', NULL, NULL, 'AGAP005310-PA', NULL, NULL, NULL, NULL, NULL, 4),
(96925, NULL, 'G3DSA:3.30.160.60:FF:000626', NULL, NULL, 'zinc finger protein 384 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(96926, NULL, 'G3DSA:1.10.1240.100:FF:000003', NULL, NULL, 'Polyketide synthase/nonribosomal peptide synthetase hybrid RzxB', NULL, NULL, NULL, NULL, NULL, 4),
(96927, NULL, 'G3DSA:3.20.20.80:FF:000437', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96928, NULL, 'G3DSA:3.40.50.10900:FF:000022', NULL, NULL, 'Proteasome assembly chaperone 2', NULL, NULL, NULL, NULL, NULL, 4),
(96929, NULL, 'G3DSA:2.60.120.260:FF:000048', NULL, NULL, 'netrin-4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(96930, NULL, 'G3DSA:1.25.40.10:FF:002430', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96931, NULL, 'G3DSA:1.25.40.10:FF:005156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96932, NULL, 'G3DSA:2.80.10.50:FF:000152', NULL, NULL, 'Fascin', NULL, NULL, NULL, NULL, NULL, 4),
(96933, NULL, 'G3DSA:3.60.150.10:FF:000008', NULL, NULL, 'Chorismate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(96934, NULL, 'G3DSA:1.10.1060.10:FF:000019', NULL, NULL, 'Oxidoreductase/iron-sulfur cluster-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(96935, NULL, 'G3DSA:2.40.50.100:FF:000054', NULL, NULL, 'Exosome complex exonuclease RRP40', NULL, NULL, NULL, NULL, NULL, 4),
(96936, NULL, 'G3DSA:2.60.40.10:FF:005409', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(96937, NULL, 'G3DSA:3.40.1110.10:FF:000100', NULL, NULL, 'P-type ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(96938, NULL, 'G3DSA:3.40.50.300:FF:007956', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96939, NULL, 'G3DSA:3.30.230.80:FF:000025', NULL, NULL, 'Putative heat shock protein HSP 90-beta 4', NULL, NULL, NULL, NULL, NULL, 4),
(96940, NULL, 'G3DSA:3.40.50.2300:FF:001557', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96941, NULL, 'G3DSA:1.10.20.10:FF:000303', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96942, NULL, 'G3DSA:3.40.1480.10:FF:000003', NULL, NULL, 'D-glycerate 2-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(96943, NULL, 'G3DSA:2.60.120.200:FF:000081', NULL, NULL, 'Crumbs 1, cell polarity complex component', NULL, NULL, NULL, NULL, NULL, 4),
(96944, NULL, 'G3DSA:3.90.1010.10:FF:000013', NULL, NULL, 'Iron-sulfur cluster assembly enzyme ISCU, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(96945, NULL, 'G3DSA:2.60.120.200:FF:000401', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(96946, NULL, 'G3DSA:1.10.30.10:FF:000068', NULL, NULL, 'PolyBRoMo domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(96947, NULL, 'G3DSA:3.40.250.10:FF:000026', NULL, NULL, 'Dual specificity protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(96948, NULL, 'G3DSA:3.40.50.300:FF:000312', NULL, NULL, 'ATP-dependent RNA helicase RhlB', NULL, NULL, NULL, NULL, NULL, 4),
(96949, NULL, 'G3DSA:3.40.50.720:FF:001394', NULL, NULL, 'Erythronate-4-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(96950, NULL, 'G3DSA:3.90.70.10:FF:000517', NULL, NULL, 'Protein CBG00738', NULL, NULL, NULL, NULL, NULL, 4),
(96951, NULL, 'G3DSA:1.10.238.10:FF:000641', NULL, NULL, 'Os02g0253601 protein', NULL, NULL, NULL, NULL, NULL, 4),
(96952, NULL, 'G3DSA:3.90.1430.10:FF:000005', NULL, NULL, 'Elongation Factor TU family', NULL, NULL, NULL, NULL, NULL, 4),
(96953, NULL, 'G3DSA:2.170.150.20:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96954, NULL, 'G3DSA:1.10.1200.240:FF:000003', NULL, NULL, '50S ribosomal protein L19e', NULL, NULL, NULL, NULL, NULL, 4),
(96955, NULL, 'G3DSA:2.30.30.30:FF:000077', NULL, NULL, '5''-3'' exoribonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(96956, NULL, 'G3DSA:3.30.420.40:FF:000539', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96957, NULL, 'G3DSA:2.30.30.100:FF:000007', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm3', NULL, NULL, NULL, NULL, NULL, 4),
(96958, NULL, 'G3DSA:3.40.50.2300:FF:001349', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96959, NULL, 'G3DSA:3.30.40.10:FF:001047', NULL, NULL, 'Zinc finger, SWIM domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(96960, NULL, 'G3DSA:3.30.70.330:FF:002362', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(96961, NULL, 'G3DSA:2.130.10.10:FF:004432', NULL, NULL, 'Ribosome assembly protein rrb1', NULL, NULL, NULL, NULL, NULL, 4),
(96962, NULL, 'G3DSA:1.25.40.10:FF:003711', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96963, NULL, 'G3DSA:2.20.25.10:FF:000082', NULL, NULL, 'Phosphonoacetate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(96964, NULL, 'G3DSA:2.30.30.1150:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96965, NULL, 'G3DSA:1.10.10.60:FF:000531', NULL, NULL, 'Transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(96966, NULL, 'G3DSA:3.40.50.2060:FF:000007', NULL, NULL, 'Vacuolar sorting protein', NULL, NULL, NULL, NULL, NULL, 4),
(96967, NULL, 'G3DSA:3.40.50.300:FF:003538', NULL, NULL, 'Protein SEY1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(96968, NULL, 'G3DSA:3.40.1180.10:FF:000019', NULL, NULL, 'Alkyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(96969, NULL, 'G3DSA:3.40.50.2000:FF:000568', NULL, NULL, 'Glycogen synthase', NULL, NULL, NULL, NULL, NULL, 4),
(96970, NULL, 'G3DSA:1.20.58.60:FF:000101', NULL, NULL, 'Short stop, isoform K', NULL, NULL, NULL, NULL, NULL, 4),
(96971, NULL, 'G3DSA:3.90.960.10:FF:000007', NULL, NULL, 'Prolyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(96972, NULL, 'G3DSA:3.60.21.10:FF:000187', NULL, NULL, 'Ser/thr protein phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(96973, NULL, 'G3DSA:1.10.10.10:FF:001141', NULL, NULL, 'SWI/SNF complex subunit SMARCC1', NULL, NULL, NULL, NULL, NULL, 4),
(96974, NULL, 'G3DSA:3.40.50.300:FF:006675', NULL, NULL, 'Ras homolog, mTORC1-binding', NULL, NULL, NULL, NULL, NULL, 4),
(96975, NULL, 'G3DSA:2.170.140.10:FF:000042', NULL, NULL, 'Mucin 11A', NULL, NULL, NULL, NULL, NULL, 4),
(96976, NULL, 'G3DSA:1.10.565.10:FF:000092', NULL, NULL, 'AGAP001348-PA', NULL, NULL, NULL, NULL, NULL, 4),
(96977, NULL, 'G3DSA:2.20.70.10:FF:000186', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(96978, NULL, 'G3DSA:1.20.5.170:FF:000178', NULL, NULL, 'C-type lectin domain family 4 member F', NULL, NULL, NULL, NULL, NULL, 4),
(96979, NULL, 'G3DSA:3.40.50.1820:FF:001340', NULL, NULL, 'Hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(96980, NULL, 'G3DSA:1.20.5.110:FF:000031', NULL, NULL, 'SNAP25 homologous protein SNAP33', NULL, NULL, NULL, NULL, NULL, 4),
(96981, NULL, 'G3DSA:1.10.10.140:FF:000012', NULL, NULL, 'Cytochrome Oxidase Assembly subunits', NULL, NULL, NULL, NULL, NULL, 4),
(96982, NULL, 'G3DSA:1.20.1070.10:FF:001355', NULL, NULL, 'Histamine receptor H3', NULL, NULL, NULL, NULL, NULL, 4),
(96983, NULL, 'G3DSA:3.20.20.300:FF:000018', NULL, NULL, 'Sugar hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(96984, NULL, 'G3DSA:3.80.10.10:FF:001610', NULL, NULL, 'Probable inactive receptor kinase At2g26730', NULL, NULL, NULL, NULL, NULL, 4),
(96985, NULL, 'G3DSA:2.40.50.100:FF:000115', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(96986, NULL, 'G3DSA:1.10.472.10:FF:000140', NULL, NULL, 'G1/S-specific cyclin-E1', NULL, NULL, NULL, NULL, NULL, 4),
(96987, NULL, 'G3DSA:2.40.50.90:FF:000090', NULL, NULL, 'Endonuclease YncB, thermonuclease family', NULL, NULL, NULL, NULL, NULL, 4),
(96988, NULL, 'G3DSA:3.40.50.790:FF:000026', NULL, NULL, '50S ribosomal protein L1', NULL, NULL, NULL, NULL, NULL, 4),
(96989, NULL, 'G3DSA:1.20.1310.10:FF:000082', NULL, NULL, 'Cullin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(96990, NULL, 'G3DSA:3.30.1680.10:FF:000026', NULL, NULL, 'Sema domain, transmembrane domain (TM), and cytoplasmic domain, (semaphorin) 6D', NULL, NULL, NULL, NULL, NULL, 4),
(96991, NULL, 'G3DSA:1.10.340.30:FF:000008', NULL, NULL, 'DNA-3-methyladenine glycosylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(96992, NULL, 'G3DSA:1.25.10.10:FF:002282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96993, NULL, 'G3DSA:1.20.58.390:FF:000305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96994, NULL, 'G3DSA:1.20.58.390:FF:000193', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(96995, NULL, 'G3DSA:3.60.15.10:FF:000066', NULL, NULL, 'Hydroxyacylglutathione hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(96996, NULL, 'G3DSA:1.10.150.650:FF:000014', NULL, NULL, 'Gll2048 protein', NULL, NULL, NULL, NULL, NULL, 4),
(96997, NULL, 'G3DSA:3.40.630.30:FF:000258', NULL, NULL, 'Glycine-N-acyltransferase-like 2, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(96998, NULL, 'G3DSA:1.10.10.10:FF:001758', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(96999, NULL, 'G3DSA:2.40.50.90:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97000, NULL, 'G3DSA:3.30.499.10:FF:000026', NULL, NULL, 'Aconitate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(97001, NULL, 'G3DSA:1.10.3730.20:FF:000057', NULL, NULL, 'YALI0F04081p', NULL, NULL, NULL, NULL, NULL, 4),
(97002, NULL, 'G3DSA:2.110.10.10:FF:000060', NULL, NULL, 'Matrix metallopeptidase 17b', NULL, NULL, NULL, NULL, NULL, 4),
(97003, NULL, 'G3DSA:2.40.160.120:FF:000013', NULL, NULL, 'Oxysterol binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(97004, NULL, 'G3DSA:2.40.160.200:FF:000003', NULL, NULL, 'Eukaryotic translation initiation factor 2B (eIF-2B) family protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(97005, NULL, 'G3DSA:2.20.25.20:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97006, NULL, 'G3DSA:2.30.140.10:FF:000024', NULL, NULL, 'Putative spermidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(97007, NULL, 'G3DSA:3.50.50.60:FF:001409', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97008, NULL, 'G3DSA:3.90.70.10:FF:000664', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 11', NULL, NULL, NULL, NULL, NULL, 4),
(97009, NULL, 'G3DSA:3.40.50.1240:FF:000149', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97010, NULL, 'G3DSA:1.25.40.10:FF:000277', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(97011, NULL, 'G3DSA:3.30.60.30:FF:000099', NULL, NULL, 'Protein CBG17314', NULL, NULL, NULL, NULL, NULL, 4),
(97012, NULL, 'G3DSA:1.10.45.10:FF:000001', NULL, NULL, 'D-lactate dehydrogenase mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(97013, NULL, 'G3DSA:3.40.720.10:FF:000079', NULL, NULL, 'Non-specific phospholipase C5', NULL, NULL, NULL, NULL, NULL, 4),
(97014, NULL, 'G3DSA:2.60.40.10:FF:004780', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97015, NULL, 'G3DSA:3.40.850.10:FF:000471', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(97016, NULL, 'G3DSA:2.30.29.30:FF:000040', NULL, NULL, 'Kalirin RhoGEF kinase b', NULL, NULL, NULL, NULL, NULL, 4),
(97017, NULL, 'G3DSA:1.25.40.20:FF:000898', NULL, NULL, 'Protein phosphatase 1 regulatory subunit 12A', NULL, NULL, NULL, NULL, NULL, 4),
(97018, NULL, 'G3DSA:3.40.50.300:FF:002785', NULL, NULL, 'Structural maintenance of chromosomes', NULL, NULL, NULL, NULL, NULL, 4),
(97019, NULL, 'G3DSA:3.30.160.60:FF:002520', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97020, NULL, 'G3DSA:3.40.50.300:FF:005247', NULL, NULL, 'Rac_C94 protein', NULL, NULL, NULL, NULL, NULL, 4),
(97021, NULL, 'G3DSA:3.10.20.90:FF:000227', NULL, NULL, 'Plexin A3', NULL, NULL, NULL, NULL, NULL, 4),
(97022, NULL, 'G3DSA:2.60.40.3210:FF:000005', NULL, NULL, 'Deleted in malignant brain tumors 1', NULL, NULL, NULL, NULL, NULL, 4),
(97023, NULL, 'G3DSA:3.30.70.20:FF:000068', NULL, NULL, 'Dihydropyrimidine dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(97024, NULL, 'G3DSA:3.30.230.10:FF:000224', NULL, NULL, 'YALI0E10769p', NULL, NULL, NULL, NULL, NULL, 4),
(97025, NULL, 'G3DSA:1.20.1560.10:FF:000241', NULL, NULL, 'Multidrug resistance-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(97026, NULL, 'G3DSA:1.10.510.10:FF:001522', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(97027, NULL, 'G3DSA:2.60.40.10:FF:000177', NULL, NULL, 'Sidekick cell adhesion molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(97028, NULL, 'G3DSA:3.40.50.720:FF:001247', NULL, NULL, 'Gfo/Idh/MocA family oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(97029, NULL, 'G3DSA:1.10.510.10:FF:000802', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(97030, NULL, 'G3DSA:3.10.129.10:FF:000285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97031, NULL, 'G3DSA:3.30.420.10:FF:000379', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97032, NULL, 'G3DSA:3.30.450.20:FF:000417', NULL, NULL, 'Histidine kinase sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(97033, NULL, 'G3DSA:1.25.40.10:FF:002222', NULL, NULL, 'Est1p', NULL, NULL, NULL, NULL, NULL, 4),
(97034, NULL, 'G3DSA:1.20.5.320:FF:000004', NULL, NULL, '6-phosphogluconate dehydrogenase, decarboxylating', NULL, NULL, NULL, NULL, NULL, 4),
(97035, NULL, 'G3DSA:3.40.30.10:FF:000416', NULL, NULL, 'Maleylacetoacetate isomerase maia', NULL, NULL, NULL, NULL, NULL, 4),
(97036, NULL, 'G3DSA:1.20.120.1900:FF:000006', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(97037, NULL, 'G3DSA:3.30.1360.210:FF:000001', NULL, NULL, '60S ribosomal protein L22 1', NULL, NULL, NULL, NULL, NULL, 4),
(97038, NULL, 'G3DSA:2.40.128.330:FF:000005', NULL, NULL, 'Magnesium transporter MRS2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(97039, NULL, 'G3DSA:1.10.10.1420:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97040, NULL, 'G3DSA:3.40.640.10:FF:000337', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(97041, NULL, 'G3DSA:1.25.40.10:FF:004431', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97042, NULL, 'G3DSA:2.60.40.10:FF:005297', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97043, NULL, 'G3DSA:3.30.450.40:FF:000103', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(97044, NULL, 'G3DSA:3.40.630.10:FF:000252', NULL, NULL, 'Nicalin', NULL, NULL, NULL, NULL, NULL, 4),
(97045, NULL, 'G3DSA:1.20.1260.10:FF:000021', NULL, NULL, 'Ferritin BfrB', NULL, NULL, NULL, NULL, NULL, 4),
(97046, NULL, 'G3DSA:2.60.120.650:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97047, NULL, 'G3DSA:3.20.190.10:FF:000014', NULL, NULL, 'Formamidopyrimidine-DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(97048, NULL, 'G3DSA:3.20.20.140:FF:000358', NULL, NULL, 'Adenosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(97049, NULL, 'G3DSA:2.40.50.140:FF:000515', NULL, NULL, 'DNA-Binding protein G5P', NULL, NULL, NULL, NULL, NULL, 4),
(97050, NULL, 'G3DSA:3.40.50.300:FF:004730', NULL, NULL, 'ABC transporter I family member 21', NULL, NULL, NULL, NULL, NULL, 4),
(97051, NULL, 'G3DSA:3.90.79.10:FF:000268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97052, NULL, 'G3DSA:3.50.50.60:FF:000128', NULL, NULL, 'Pyridine nucleotide-disulfide oxidoreductase YkgC', NULL, NULL, NULL, NULL, NULL, 4),
(97053, NULL, 'G3DSA:1.10.630.10:FF:000160', NULL, NULL, 'Fumitremorgin C synthase', NULL, NULL, NULL, NULL, NULL, 4),
(97054, NULL, 'G3DSA:3.40.50.300:FF:001032', NULL, NULL, 'GTP-binding protein REM 2', NULL, NULL, NULL, NULL, NULL, 4),
(97055, NULL, 'G3DSA:1.10.470.10:FF:000006', NULL, NULL, 'Variant surface glycoprotein (VSG), putative', NULL, NULL, NULL, NULL, NULL, 4),
(97056, NULL, 'G3DSA:3.40.50.300:FF:000576', NULL, NULL, 'Elongation factor Tu', NULL, NULL, NULL, NULL, NULL, 4),
(97057, NULL, 'G3DSA:3.40.50.720:FF:000674', NULL, NULL, 'N(5)-(Carboxyethyl)ornithine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(97058, NULL, 'G3DSA:3.80.10.10:FF:001346', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase EFR', NULL, NULL, NULL, NULL, NULL, 4),
(97059, NULL, 'G3DSA:3.40.50.300:FF:008361', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97060, NULL, 'G3DSA:3.30.470.20:FF:000008', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(97061, NULL, 'G3DSA:2.60.40.10:FF:004072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97062, NULL, 'G3DSA:3.30.160.60:FF:001031', NULL, NULL, 'zinc finger protein 341 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(97063, NULL, 'G3DSA:2.60.200.40:FF:000003', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(97064, NULL, 'G3DSA:3.30.200.20:FF:001214', NULL, NULL, 'Serine/threonine-protein kinase ppk21', NULL, NULL, NULL, NULL, NULL, 4),
(97065, NULL, 'G3DSA:3.90.76.10:FF:000031', NULL, NULL, 'ABC transporter solute binding lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(97066, NULL, 'G3DSA:1.20.1250.20:FF:001069', NULL, NULL, 'Uncharacterized transporter YwbF', NULL, NULL, NULL, NULL, NULL, 4),
(97067, NULL, 'G3DSA:1.10.520.10:FF:000067', NULL, NULL, 'Os01g0294300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(97068, NULL, 'G3DSA:1.10.10.60:FF:001195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97069, NULL, 'G3DSA:3.80.10.10:FF:004483', NULL, NULL, 'Probable inactive leucine-rich repeat receptor-like protein kinase At3g03770', NULL, NULL, NULL, NULL, NULL, 4),
(97070, NULL, 'G3DSA:3.30.342.10:FF:000040', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(97071, NULL, 'G3DSA:1.25.40.10:FF:003975', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97072, NULL, 'G3DSA:2.60.40.10:FF:001082', NULL, NULL, 'Titin novex-3', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(97073, NULL, 'G3DSA:4.10.400.10:FF:000120', NULL, NULL, 'Terribly reduced optic lobes, isoform AI', NULL, NULL, NULL, NULL, NULL, 4),
(97074, NULL, 'G3DSA:2.120.10.30:FF:000189', NULL, NULL, 'Acylaminoacyl-peptide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(97075, NULL, 'G3DSA:2.30.29.30:FF:000601', NULL, NULL, 'Vacuolar protein sorting-associated protein 36', NULL, NULL, NULL, NULL, NULL, 4),
(97076, NULL, 'G3DSA:3.20.20.70:FF:000844', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97077, NULL, 'G3DSA:1.20.58.70:FF:000014', NULL, NULL, 't-SNARE domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(97078, NULL, 'G3DSA:3.30.200.20:FF:002142', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(97079, NULL, 'G3DSA:1.20.1740.10:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97080, NULL, 'G3DSA:3.40.50.11130:FF:000001', NULL, NULL, 'Outer capsid glycoprotein VP7', NULL, NULL, NULL, NULL, NULL, 4),
(97081, NULL, 'G3DSA:2.30.29.170:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97082, NULL, 'G3DSA:1.25.10.10:FF:000449', NULL, NULL, 'Cohesin subunit SA-3', NULL, NULL, NULL, NULL, NULL, 4),
(97083, NULL, 'G3DSA:1.50.40.10:FF:000185', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(97084, NULL, 'G3DSA:1.10.510.10:FF:004248', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97085, NULL, 'G3DSA:1.10.3380.30:FF:000016', NULL, NULL, 'Superkiller viralicidic activity 2-like (S. cerevisiae)', NULL, NULL, NULL, NULL, NULL, 4),
(97086, NULL, 'G3DSA:3.30.70.3270:FF:000013', NULL, NULL, 'NADH-quinone oxidoreductase subunit I protein', NULL, NULL, NULL, NULL, NULL, 4),
(97087, NULL, 'G3DSA:2.60.40.60:FF:000528', NULL, NULL, 'Dachsous cadherin-related 1a', NULL, NULL, NULL, NULL, NULL, 4),
(97088, NULL, 'G3DSA:3.90.226.10:FF:000015', NULL, NULL, 'Periplasmic tail-specific protease', NULL, NULL, NULL, NULL, NULL, 4),
(97089, NULL, 'G3DSA:3.60.40.10:FF:000348', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97090, NULL, 'G3DSA:3.50.30.30:FF:000169', NULL, NULL, 'Glutamate carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(97091, NULL, 'G3DSA:3.30.230.70:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97092, NULL, 'G3DSA:1.25.40.20:FF:000634', NULL, NULL, 'Death-associated protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(97093, NULL, 'G3DSA:3.30.40.10:FF:001311', NULL, NULL, 'AT07234p', NULL, NULL, NULL, NULL, NULL, 4),
(97094, NULL, 'G3DSA:3.30.70.330:FF:002098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97095, NULL, 'G3DSA:3.40.190.10:FF:000324', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(97096, NULL, 'G3DSA:2.60.200.20:FF:000109', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(97097, NULL, 'G3DSA:2.30.42.10:FF:000643', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97098, NULL, 'G3DSA:1.25.10.10:FF:000596', NULL, NULL, 'cullin-associated NEDD8-dissociated protein 2 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(97099, NULL, 'G3DSA:3.30.160.60:FF:003240', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97100, NULL, 'G3DSA:3.10.20.90:FF:000935', NULL, NULL, 'E3 ubiquitin-protein ligase parkin', NULL, NULL, NULL, NULL, NULL, 4),
(97101, NULL, 'G3DSA:3.80.10.10:FF:003555', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(97102, NULL, 'G3DSA:2.40.30.10:FF:000430', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97103, NULL, 'G3DSA:1.25.40.10:FF:001766', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(97104, NULL, 'G3DSA:3.30.420.40:FF:001091', NULL, NULL, 'Ectonucleoside triphosphate diphosphohydrolase 6', NULL, NULL, NULL, NULL, NULL, 4),
(97105, NULL, 'G3DSA:1.10.600.10:FF:000068', NULL, NULL, 'Conserved hypthetical protein', NULL, NULL, NULL, NULL, NULL, 4),
(97106, NULL, 'G3DSA:3.30.300.130:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(97107, NULL, 'G3DSA:1.10.150.20:FF:000227', NULL, NULL, 'DNA repair protein complementing XP-G cells-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(97108, NULL, 'G3DSA:2.70.40.10:FF:000013', NULL, NULL, 'Deoxyuridine 5''-triphosphate nucleotidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(97109, NULL, 'G3DSA:1.10.510.10:FF:000241', NULL, NULL, 'Putative serine/threonine-protein kinase ULK3', NULL, NULL, NULL, NULL, NULL, 4),
(97110, NULL, 'G3DSA:3.30.300.20:FF:000053', NULL, NULL, 'Probable transcription termination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(97111, NULL, 'G3DSA:3.50.50.60:FF:000275', NULL, NULL, 'Putative selenate reductase subunit YgfK', NULL, NULL, NULL, NULL, NULL, 4),
(97112, NULL, 'G3DSA:3.40.50.300:FF:001857', NULL, NULL, 'Elongation factor 1-alpha', NULL, NULL, NULL, NULL, NULL, 4),
(97113, NULL, 'G3DSA:3.40.50.300:FF:007080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97114, NULL, 'G3DSA:1.20.870.10:FF:000029', NULL, NULL, 'ral guanine nucleotide dissociation stimulator-like 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(97115, NULL, 'G3DSA:3.40.390.10:FF:000244', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97116, NULL, 'G3DSA:1.20.120.830:FF:000004', NULL, NULL, 'Neural precursor cell-expressed, developmentally down-regulated 9', NULL, NULL, NULL, NULL, NULL, 4),
(97117, NULL, 'G3DSA:1.20.1050.10:FF:000011', NULL, NULL, 'Predicted glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(97118, NULL, 'G3DSA:2.40.30.10:FF:000019', NULL, NULL, 'Respiratory burst oxidase homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(97119, NULL, 'G3DSA:2.60.120.40:FF:000002', NULL, NULL, 'Cerebellin 4', NULL, NULL, NULL, NULL, NULL, 4),
(97120, NULL, 'G3DSA:3.40.50.2020:FF:000107', NULL, NULL, 'Guanine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(97121, NULL, 'G3DSA:2.10.25.10:FF:000992', NULL, NULL, 'Fibulin-1', NULL, NULL, NULL, NULL, NULL, 4),
(97122, NULL, 'G3DSA:3.40.50.1820:FF:001099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97123, NULL, 'G3DSA:2.10.50.30:FF:000011', NULL, NULL, 'Vomeronasal 2, receptor 73', NULL, NULL, NULL, NULL, NULL, 4),
(97124, NULL, 'G3DSA:3.40.50.300:FF:003802', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(97125, NULL, 'G3DSA:3.40.50.2300:FF:000068', NULL, NULL, 'Glutamate receptor, ionotropic, delta 1b', NULL, NULL, NULL, NULL, NULL, 4),
(97126, NULL, 'G3DSA:3.40.50.1820:FF:000435', NULL, NULL, 'Ppe family protein ppe63', NULL, NULL, NULL, NULL, NULL, 4),
(97127, NULL, 'G3DSA:1.20.120.1080:FF:000075', NULL, NULL, 'DEAH (Asp-Glu-Ala-His) box helicase 30', NULL, NULL, NULL, NULL, NULL, 4),
(97128, NULL, 'G3DSA:1.20.920.30:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97129, NULL, 'G3DSA:1.10.1300.10:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97130, NULL, 'G3DSA:2.60.120.290:FF:000096', NULL, NULL, 'SOL-2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(97131, NULL, 'G3DSA:1.10.3380.10:FF:000010', NULL, NULL, 'DExH-box ATP-dependent RNA helicase DExH12', NULL, NULL, NULL, NULL, NULL, 4),
(97132, NULL, 'G3DSA:2.130.10.10:FF:003004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97133, NULL, 'G3DSA:3.80.10.10:FF:000121', NULL, NULL, 'Protein zyg-11 B isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(97134, NULL, 'G3DSA:3.10.110.10:FF:000259', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(97135, NULL, 'G3DSA:2.60.120.1060:FF:000001', NULL, NULL, 'Blood-group-substance endo-1,4-beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(97136, NULL, 'G3DSA:3.90.226.10:FF:000279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97137, NULL, 'G3DSA:2.130.10.10:FF:000542', NULL, NULL, 'semaphorin-4F isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(97138, NULL, 'G3DSA:3.90.1100.10:FF:000043', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(97139, NULL, 'G3DSA:2.60.40.10:FF:004628', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97140, NULL, 'G3DSA:3.40.50.1470:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97141, NULL, 'G3DSA:3.30.70.330:FF:001434', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97142, NULL, 'G3DSA:1.10.420.10:FF:000003', NULL, NULL, 'L-ascorbate peroxidase, cytosolic', NULL, NULL, NULL, NULL, NULL, 4),
(97143, NULL, 'G3DSA:1.10.3080.10:FF:000049', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(97144, NULL, 'G3DSA:2.130.10.10:FF:005213', NULL, NULL, 'WD repeat-containing protein 38', NULL, NULL, NULL, NULL, NULL, 4),
(97145, NULL, 'G3DSA:3.90.190.10:FF:000594', NULL, NULL, 'Phosphatase and tensin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(97146, NULL, 'G3DSA:2.20.100.10:FF:000187', NULL, NULL, 'Lonely heart, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(97147, NULL, 'G3DSA:3.30.1330.80:FF:000010', NULL, NULL, 'AT-hook motif nuclear-localized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97148, NULL, 'G3DSA:1.10.287.70:FF:000300', NULL, NULL, 'Voltage-gated Ca2+ channel, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(97149, NULL, 'G3DSA:1.20.120.1070:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97150, NULL, 'G3DSA:2.170.130.10:FF:000069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97151, NULL, 'G3DSA:1.20.144.10:FF:000084', NULL, NULL, 'Phospholipid phosphatase 5', NULL, NULL, NULL, NULL, NULL, 4),
(97152, NULL, 'G3DSA:3.40.50.300:FF:004319', NULL, NULL, 'Cell division inhibitor SulA', NULL, NULL, NULL, NULL, NULL, 4),
(97153, NULL, 'G3DSA:2.170.120.12:FF:000026', NULL, NULL, 'Polymerase (RNA) II (DNA directed) polypeptide C, 33kDa', NULL, NULL, NULL, NULL, NULL, 4),
(97154, NULL, 'G3DSA:3.40.50.300:FF:006528', NULL, NULL, 'Si:ch211-113e8.6', NULL, NULL, NULL, NULL, NULL, 4),
(97155, NULL, 'G3DSA:3.30.70.3290:FF:000019', NULL, NULL, 'Polyketide synthase, putative (JCVI)', NULL, NULL, NULL, NULL, NULL, 4),
(97156, NULL, 'G3DSA:3.30.365.10:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97157, NULL, 'G3DSA:1.10.10.10:FF:000477', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(97158, NULL, 'G3DSA:1.10.1170.10:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97159, NULL, 'G3DSA:2.130.10.10:FF:005921', NULL, NULL, 'Protein CBR-TOM-1', NULL, NULL, NULL, NULL, NULL, 4),
(97160, NULL, 'G3DSA:3.40.50.360:FF:000015', NULL, NULL, 'NADPH-dependent diflavin oxidoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(97161, NULL, 'G3DSA:3.90.380.10:FF:000013', NULL, NULL, 'Possible dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(97162, NULL, 'G3DSA:1.10.8.530:FF:000007', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(97163, NULL, 'G3DSA:3.30.200.20:FF:000197', NULL, NULL, 'dual specificity mitogen-activated protein kinase kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(97164, NULL, 'G3DSA:1.10.357.10:FF:000064', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(97165, NULL, 'G3DSA:1.20.1070.10:FF:000922', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97166, NULL, 'G3DSA:1.25.10.10:FF:000860', NULL, NULL, 'Pumilio homolog 3', NULL, NULL, NULL, NULL, NULL, 4),
(97167, NULL, 'G3DSA:3.80.10.10:FF:000060', NULL, NULL, 'F-box/LRR-repeat protein 20 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(97168, NULL, 'G3DSA:1.25.40.340:FF:000006', NULL, NULL, 'Conserved hypothetical alanine rich protein', NULL, NULL, NULL, NULL, NULL, 4),
(97169, NULL, 'G3DSA:3.20.200.10:FF:000005', NULL, NULL, 'Alpha-protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(97170, NULL, 'G3DSA:2.60.40.10:FF:001110', NULL, NULL, 'phosphatidylinositol phosphatase PTPRQ isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(97171, NULL, 'G3DSA:1.10.472.170:FF:000005', NULL, NULL, 'Transcription initiation factor IIB', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(97172, NULL, 'G3DSA:2.60.40.10:FF:002094', NULL, NULL, 'Alpha-2-macroglobulin like 1', NULL, NULL, NULL, NULL, NULL, 4),
(97173, NULL, 'G3DSA:1.10.3460.10:FF:000011', NULL, NULL, 'Fucoxanthin chlorophyll a/c protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(97174, NULL, 'G3DSA:3.50.50.60:FF:000336', NULL, NULL, 'Cellobiose dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(97175, NULL, 'G3DSA:2.120.10.80:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97176, NULL, 'G3DSA:1.20.1170.10:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97177, NULL, 'G3DSA:6.10.250.3440:FF:000002', NULL, NULL, '54S ribosomal protein L28, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(97178, NULL, 'G3DSA:1.10.10.10:FF:001197', NULL, NULL, 'Transcriptional regulator, MarR family', NULL, NULL, NULL, NULL, NULL, 4),
(97179, NULL, 'G3DSA:1.20.1280.50:FF:000045', NULL, NULL, 'F-box protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(97180, NULL, 'G3DSA:2.60.40.1450:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(97181, NULL, 'G3DSA:2.60.40.10:FF:005797', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97182, NULL, 'G3DSA:2.60.120.200:FF:000373', NULL, NULL, 'Apical endosomal glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(97183, NULL, 'G3DSA:2.60.40.10:FF:005853', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97184, NULL, 'G3DSA:3.80.20.20:FF:000035', NULL, NULL, 'Insulin-like receptor', NULL, NULL, NULL, NULL, NULL, 4),
(97185, NULL, 'G3DSA:3.30.40.10:FF:000794', NULL, NULL, 'CG13732 protein', NULL, NULL, NULL, NULL, NULL, 4),
(97186, NULL, 'G3DSA:3.40.50.300:FF:005163', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(97187, NULL, 'G3DSA:3.40.50.1820:FF:001363', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97188, NULL, 'G3DSA:3.90.1600.10:FF:000013', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(97189, NULL, 'G3DSA:1.25.40.10:FF:001974', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(97190, NULL, 'G3DSA:1.10.3520.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97191, NULL, 'G3DSA:1.10.1300.10:FF:000090', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(97192, NULL, 'G3DSA:2.130.10.10:FF:005449', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97193, NULL, 'G3DSA:3.40.1110.10:FF:000156', NULL, NULL, 'Copper-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(97194, NULL, 'G3DSA:1.20.58.190:FF:000009', NULL, NULL, 'Unplaced genomic scaffold supercont2.8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(97195, NULL, 'G3DSA:3.30.200.20:FF:002350', NULL, NULL, 'Probable ribosome biogenesis protein WBGene00106114', NULL, NULL, NULL, NULL, NULL, 4),
(97196, NULL, 'G3DSA:1.20.1070.10:FF:001378', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97197, NULL, 'G3DSA:2.40.290.10:FF:000038', NULL, NULL, 'ATP-dependent DNA helicase II subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(97198, NULL, 'G3DSA:3.40.190.10:FF:000347', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(97199, NULL, 'G3DSA:3.40.50.1820:FF:000851', NULL, NULL, 'Serine carboxypeptidase S28 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(97200, NULL, 'G3DSA:1.10.510.10:FF:002686', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97201, NULL, 'G3DSA:1.10.472.90:FF:000001', NULL, NULL, 'Pyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(97202, NULL, 'G3DSA:2.70.130.10:FF:000082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97203, NULL, 'G3DSA:2.10.25.10:FF:001829', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97204, NULL, 'G3DSA:1.10.1600.10:FF:000016', NULL, NULL, 'ATP-dependent DNA helicase 2 subunit KU80', NULL, NULL, NULL, NULL, NULL, 4),
(97205, NULL, 'G3DSA:3.40.50.1010:FF:000142', NULL, NULL, 'GH28353p', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(97206, NULL, 'G3DSA:2.30.30.40:FF:000675', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97207, NULL, 'G3DSA:1.20.1560.10:FF:000297', NULL, NULL, 'ABC a-pheromone efflux pump AtrD', NULL, NULL, NULL, NULL, NULL, 4),
(97208, NULL, 'G3DSA:1.20.1070.10:FF:000866', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97209, NULL, 'G3DSA:1.10.8.60:FF:000547', NULL, NULL, 'C4-dicarboxylate transport transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(97210, NULL, 'G3DSA:2.60.200.20:FF:000020', NULL, NULL, 'Kinesin family member 14', NULL, NULL, NULL, NULL, NULL, 4),
(97211, NULL, 'G3DSA:3.30.160.60:FF:000126', NULL, NULL, 'Mds1 and evi1 complex locus protein', NULL, NULL, NULL, NULL, NULL, 4),
(97212, NULL, 'G3DSA:2.40.30.10:FF:000519', NULL, NULL, 'Putative tetracycline resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(97213, NULL, 'G3DSA:3.90.1150.10:FF:000107', NULL, NULL, 'Putative cysteine desulfurase', NULL, NULL, NULL, NULL, NULL, 4),
(97214, NULL, 'G3DSA:1.10.510.10:FF:003675', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97215, NULL, 'G3DSA:3.30.160.60:FF:006382', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97216, NULL, 'G3DSA:1.25.10.10:FF:000365', NULL, NULL, 'Armadillo repeat-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(97217, NULL, 'G3DSA:3.30.70.330:FF:003087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97218, NULL, 'G3DSA:3.40.50.720:FF:001663', NULL, NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase NAD-binding', NULL, NULL, NULL, NULL, NULL, 4),
(97219, NULL, 'G3DSA:3.90.290.10:FF:000006', NULL, NULL, 'Fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(97220, NULL, 'G3DSA:3.40.50.2300:FF:000276', NULL, NULL, 'LacI family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(97221, NULL, 'G3DSA:1.10.287.1880:FF:000001', NULL, NULL, 'Protein zwilch homolog', NULL, NULL, NULL, NULL, NULL, 4),
(97222, NULL, 'G3DSA:2.60.120.650:FF:000103', NULL, NULL, 'JmjC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(97223, NULL, 'G3DSA:1.10.287.110:FF:000341', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(97224, NULL, 'G3DSA:3.40.50.300:FF:007456', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(97225, NULL, 'G3DSA:1.20.58.1520:FF:000002', NULL, NULL, '65-kDa microtubule-associated protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(97226, NULL, 'G3DSA:2.60.40.1510:FF:000046', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(97227, NULL, 'G3DSA:1.10.10.10:FF:001202', NULL, NULL, 'Transcriptional regulator, GntR family', NULL, NULL, NULL, NULL, NULL, 4),
(97228, NULL, 'G3DSA:2.60.40.10:FF:002571', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(97229, NULL, 'G3DSA:1.10.238.10:FF:000372', NULL, NULL, 'Centrin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(97230, NULL, 'G3DSA:3.90.400.10:FF:000010', NULL, NULL, '4-alpha-glucanotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(97231, NULL, 'G3DSA:2.40.110.10:FF:000059', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(97232, NULL, 'G3DSA:3.40.525.10:FF:000058', NULL, NULL, 'Sec14p-like phosphatidylinositol transfer family protein', NULL, NULL, NULL, NULL, NULL, 4),
(97233, NULL, 'G3DSA:3.40.50.11860:FF:000012', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(97234, NULL, 'G3DSA:3.30.160.60:FF:002048', NULL, NULL, 'Crooked legs, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(97235, NULL, 'G3DSA:3.30.710.10:FF:000070', NULL, NULL, 'zinc finger and BTB domain-containing protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(97236, NULL, 'G3DSA:3.40.50.10810:FF:000259', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(97237, NULL, 'G3DSA:1.10.4190.10:FF:000001', NULL, NULL, 'Urease accessory protein F', NULL, NULL, NULL, NULL, NULL, 4),
(97238, NULL, 'G3DSA:3.30.1370.240:FF:000017', NULL, NULL, 'Phenylalanyl-tRNA synthetase alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(97239, NULL, 'G3DSA:1.10.150.20:FF:000143', NULL, NULL, 'DNA excision repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(97240, NULL, 'G3DSA:3.40.1090.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97241, NULL, 'G3DSA:1.25.40.10:FF:000985', NULL, NULL, 'Signal recognition particle subunit SRP72', NULL, NULL, NULL, NULL, NULL, 4),
(97242, NULL, 'G3DSA:1.10.506.10:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97243, NULL, 'G3DSA:1.20.120.530:FF:000004', NULL, NULL, 'Galactonate operon transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(97244, NULL, 'G3DSA:1.10.260.40:FF:000067', NULL, NULL, 'Shikimate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(97245, NULL, 'G3DSA:3.90.550.10:FF:000049', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(97246, NULL, 'G3DSA:3.80.10.10:FF:001785', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97247, NULL, 'G3DSA:3.40.50.2000:FF:000832', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97248, NULL, 'G3DSA:1.20.1560.10:FF:000774', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97249, NULL, 'G3DSA:3.30.40.10:FF:000322', NULL, NULL, 'PHD transcription factor (Rum1)', NULL, NULL, NULL, NULL, NULL, 4),
(97250, NULL, 'G3DSA:2.60.40.10:FF:005325', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97251, NULL, 'G3DSA:1.20.1730.10:FF:000097', NULL, NULL, 'High affinity choline transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(97252, NULL, 'G3DSA:1.10.1380.10:FF:000010', NULL, NULL, 'Gone early, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(97253, NULL, 'G3DSA:1.10.10.820:FF:000002', NULL, NULL, 'Myosin heavy chain 10', NULL, NULL, NULL, NULL, NULL, 4),
(97254, NULL, 'G3DSA:2.30.29.30:FF:001113', NULL, NULL, 'Target of rapamycin complex 2 subunit MAPKAP1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(97255, NULL, 'G3DSA:3.40.50.720:FF:001186', NULL, NULL, 'Trk system potassium uptake protein TrkA', NULL, NULL, NULL, NULL, NULL, 4),
(97256, NULL, 'G3DSA:2.60.40.1120:FF:000019', NULL, NULL, 'Carboxypeptidase D', NULL, NULL, NULL, NULL, NULL, 4),
(97257, NULL, 'G3DSA:3.90.470.10:FF:000048', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(97258, NULL, 'G3DSA:3.30.70.2330:FF:000001', NULL, NULL, 'helicase-like transcription factor isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(97259, NULL, 'G3DSA:3.30.70.270:FF:000202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97260, NULL, 'G3DSA:1.10.287.70:FF:000800', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97261, NULL, 'G3DSA:3.30.1520.10:FF:000133', NULL, NULL, 'UPF0507 protein YALI0E18612g', NULL, NULL, NULL, NULL, NULL, 4),
(97262, NULL, 'G3DSA:1.25.40.10:FF:002930', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(97263, NULL, 'G3DSA:2.130.10.10:FF:002695', NULL, NULL, 'Protein CBG22664', NULL, NULL, NULL, NULL, NULL, 4),
(97264, NULL, 'G3DSA:3.20.140.10:FF:000011', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(97265, NULL, 'G3DSA:1.25.40.690:FF:000004', NULL, NULL, 'Nucleoporin 98-96', NULL, NULL, NULL, NULL, NULL, 4),
(97266, NULL, 'G3DSA:1.20.1110.10:FF:000038', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(97267, NULL, 'G3DSA:1.25.40.10:FF:001502', NULL, NULL, 'Methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(97268, NULL, 'G3DSA:3.30.200.20:FF:000309', NULL, NULL, 'Leucine-rich repeat receptor protein kinase MSP1', NULL, NULL, NULL, NULL, NULL, 4),
(97269, NULL, 'G3DSA:3.10.620.30:FF:000028', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(97270, NULL, 'G3DSA:3.40.605.10:FF:000059', NULL, NULL, 'Succinate-semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(97271, NULL, 'G3DSA:3.40.30.10:FF:000832', NULL, NULL, 'Protein disulfide isomerase1-2', NULL, NULL, NULL, NULL, NULL, 4),
(97272, NULL, 'G3DSA:3.40.50.1000:FF:000341', NULL, NULL, 'Haloacid dehalogenase family hydrolase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(97273, NULL, 'G3DSA:3.30.60.20:FF:000039', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(97274, NULL, 'G3DSA:3.40.50.720:FF:000730', NULL, NULL, 'Glycerate-and formate-dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(97275, NULL, 'G3DSA:2.130.10.10:FF:004640', NULL, NULL, 'U3 small nucleolar RNA-associated protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(97276, NULL, 'G3DSA:2.10.25.10:FF:000048', NULL, NULL, 'Netrin 3', NULL, NULL, NULL, NULL, NULL, 4),
(97277, NULL, 'G3DSA:3.40.190.290:FF:000131', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(97278, NULL, 'G3DSA:1.25.40.990:FF:000032', NULL, NULL, 'COP9 signalosome complex subunit 8', NULL, NULL, NULL, NULL, NULL, 4),
(97279, NULL, 'G3DSA:2.70.250.10:FF:000001', NULL, NULL, 'Adsorption protein P2', NULL, NULL, NULL, NULL, NULL, 4),
(97280, NULL, 'G3DSA:3.80.10.10:FF:001402', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(97281, NULL, 'G3DSA:1.10.555.10:FF:000147', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97282, NULL, 'G3DSA:1.10.630.10:FF:000452', NULL, NULL, 'Cytochrome P450, family 2, subfamily d, polypeptide 22', NULL, NULL, NULL, NULL, NULL, 4),
(97283, NULL, 'G3DSA:3.40.30.10:FF:000888', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(97284, NULL, 'G3DSA:3.40.50.300:FF:001324', NULL, NULL, 'GTPase Era', NULL, NULL, NULL, NULL, NULL, 4),
(97285, NULL, 'G3DSA:3.30.40.10:FF:001255', NULL, NULL, 'E3 ubiquitin-protein ligase SINA-like 10', NULL, NULL, NULL, NULL, NULL, 4),
(97286, NULL, 'G3DSA:2.60.120.260:FF:000109', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(97287, NULL, 'G3DSA:3.10.290.10:FF:000007', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(97288, NULL, 'G3DSA:3.90.1720.10:FF:000016', NULL, NULL, 'Possible Inv protein', NULL, NULL, NULL, NULL, NULL, 4),
(97289, NULL, 'G3DSA:1.10.730.10:FF:000021', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(97290, NULL, 'G3DSA:3.30.160.60:FF:002487', NULL, NULL, 'Zinc finger protein 700', NULL, NULL, NULL, NULL, NULL, 4),
(97291, NULL, 'G3DSA:1.20.58.670:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97292, NULL, 'G3DSA:3.30.9.10:FF:000289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97293, NULL, 'G3DSA:2.40.50.180:FF:000004', NULL, NULL, 'Chemotaxis protein CheV', NULL, NULL, NULL, NULL, NULL, 4),
(97294, NULL, 'G3DSA:3.40.50.300:FF:000812', NULL, NULL, 'multidrug resistance-associated protein 1 isoform X15', NULL, NULL, NULL, NULL, NULL, 4),
(97295, NULL, 'G3DSA:1.25.10.10:FF:002310', NULL, NULL, 'Cullin-associated NEDD8-dissociated protein 1, N-terminal part', NULL, NULL, NULL, NULL, NULL, 4),
(97296, NULL, 'G3DSA:2.10.25.10:FF:000576', NULL, NULL, 'Coagulation factor XII', NULL, NULL, NULL, NULL, NULL, 4),
(97297, NULL, 'G3DSA:3.30.43.10:FF:000036', NULL, NULL, 'xanthine dehydrogenase/oxidase-like', NULL, NULL, NULL, NULL, NULL, 4),
(97298, NULL, 'G3DSA:3.40.50.2000:FF:000304', NULL, NULL, 'UDP-N-acetylglucosamine transferase subunit ALG14, putative', NULL, NULL, NULL, NULL, NULL, 4),
(97299, NULL, 'G3DSA:2.60.40.640:FF:000052', NULL, NULL, 'Arrestin domain-containing protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(97300, NULL, 'G3DSA:3.10.20.90:FF:000019', NULL, NULL, 'FERM domain containing 4A', NULL, NULL, NULL, NULL, NULL, 4),
(97301, NULL, 'G3DSA:2.130.10.10:FF:001762', NULL, NULL, 'RBBP4 isoform 18', NULL, NULL, NULL, NULL, NULL, 4),
(97302, NULL, 'G3DSA:3.40.50.620:FF:000470', NULL, NULL, '7-cyano-7-deazaguanine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(97303, NULL, 'G3DSA:3.90.226.10:FF:000195', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(97304, NULL, 'G3DSA:2.30.110.10:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97305, NULL, 'G3DSA:3.80.10.10:FF:000913', NULL, NULL, 'Transforming growth factor beta activator LRRC33', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(97306, NULL, 'G3DSA:2.60.40.10:FF:003875', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97307, NULL, 'G3DSA:3.10.20.90:FF:001008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97308, NULL, 'G3DSA:1.10.472.80:FF:000144', NULL, NULL, 'TBC1 domain family member 20/GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(97309, NULL, 'G3DSA:2.40.50.140:FF:000987', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97310, NULL, 'G3DSA:3.30.50.10:FF:000120', NULL, NULL, 'Nuclear receptor subfamily 2 group E member 3', NULL, NULL, NULL, NULL, NULL, 4),
(97311, NULL, 'G3DSA:3.90.920.10:FF:000010', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(97312, NULL, 'G3DSA:2.60.40.200:FF:000004', NULL, NULL, 'Copper chaperone for superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(97313, NULL, 'G3DSA:3.30.200.20:FF:000961', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(97314, NULL, 'G3DSA:1.25.40.10:FF:002806', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97315, NULL, 'G3DSA:2.60.40.10:FF:002947', NULL, NULL, 'Neuronal cell adhesion molecule, putative', NULL, NULL, NULL, NULL, NULL, 4),
(97316, NULL, 'G3DSA:1.20.1560.10:FF:000302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97317, NULL, 'G3DSA:2.70.50.50:FF:000003', NULL, NULL, 'Secreted cellulose binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(97318, NULL, 'G3DSA:3.30.40.10:FF:001608', NULL, NULL, 'Putative RING finger domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(97319, NULL, 'G3DSA:2.130.10.10:FF:000834', NULL, NULL, 'Transducin beta-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(97320, NULL, 'G3DSA:4.10.1000.10:FF:000047', NULL, NULL, 'Makorin ring finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(97321, NULL, 'G3DSA:3.30.2010.10:FF:000016', NULL, NULL, 'CAAX prenyl protease', NULL, NULL, NULL, NULL, NULL, 4),
(97322, NULL, 'G3DSA:3.40.50.720:FF:000202', NULL, NULL, 'Short-chain dehydrogenase/reductase family 16C member 6', NULL, NULL, NULL, NULL, NULL, 4),
(97323, NULL, 'G3DSA:2.60.40.150:FF:000293', NULL, NULL, 'Guanine nucleotide exchange factor SPIKE 1', NULL, NULL, NULL, NULL, NULL, 4),
(97324, NULL, 'G3DSA:3.90.550.10:FF:000105', NULL, NULL, 'translation initiation factor eIF-2B subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(97325, NULL, 'G3DSA:2.60.40.60:FF:000731', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(97326, NULL, 'G3DSA:1.20.120.1750:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97327, NULL, 'G3DSA:3.90.170.10:FF:000003', NULL, NULL, 'Adenylosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(97328, NULL, 'G3DSA:1.20.1440.130:FF:000003', NULL, NULL, 'Probable conserved integral membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(97329, NULL, 'G3DSA:1.20.120.230:FF:000009', NULL, NULL, 'Talin 2', NULL, NULL, NULL, NULL, NULL, 4),
(97330, NULL, 'G3DSA:1.20.120.350:FF:000074', NULL, NULL, 'SHaW family of potassium channels', NULL, NULL, NULL, NULL, NULL, 4),
(97331, NULL, 'G3DSA:3.40.50.150:FF:000334', NULL, NULL, 'Methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(97332, NULL, 'G3DSA:1.25.40.20:FF:000398', NULL, NULL, 'ankyrin repeat and KH domain-containing protein 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(97333, NULL, 'G3DSA:1.20.1270.60:FF:000132', NULL, NULL, 'Rho GTPase Activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(97334, NULL, 'G3DSA:3.90.1750.10:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97335, NULL, 'G3DSA:1.10.167.10:FF:000026', NULL, NULL, 'Developmental regulator FlbA', NULL, NULL, NULL, NULL, NULL, 4),
(97336, NULL, 'G3DSA:2.60.120.290:FF:000124', NULL, NULL, 'GM24707', NULL, NULL, NULL, NULL, NULL, 4),
(97337, NULL, 'G3DSA:1.10.510.10:FF:002742', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97338, NULL, 'G3DSA:2.40.50.40:FF:000120', NULL, NULL, 'Signal recognition particle 43 kDa protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(97339, NULL, 'G3DSA:3.30.1370.60:FF:000001', NULL, NULL, '2,3-diketo-L-gulonate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(97340, NULL, 'G3DSA:1.20.930.40:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97341, NULL, 'G3DSA:1.20.120.1110:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(97342, NULL, 'G3DSA:3.30.70.330:FF:001665', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97343, NULL, 'G3DSA:2.30.170.40:FF:000012', NULL, NULL, 'Ribosomal L28 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(97344, NULL, 'G3DSA:2.160.10.10:FF:000035', NULL, NULL, 'Gamma carbonic anhydrase-like 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(97345, NULL, 'G3DSA:2.130.10.10:FF:005505', NULL, NULL, 'Protein CBG01041', NULL, NULL, NULL, NULL, NULL, 4),
(97346, NULL, 'G3DSA:1.20.1090.10:FF:000013', NULL, NULL, 'NDMA-dependent methanol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(97347, NULL, 'G3DSA:1.20.140.40:FF:000039', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(97348, NULL, 'G3DSA:1.25.40.10:FF:001497', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(97349, NULL, 'G3DSA:3.40.640.10:FF:000253', NULL, NULL, 'Nucleotide sugar transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(97350, NULL, 'G3DSA:3.40.366.10:FF:000019', NULL, NULL, 'Sterigmatocystin biosynthesis polyketide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(97351, NULL, 'G3DSA:3.30.40.10:FF:001783', NULL, NULL, 'Acyl-CoA N-acyltransferase with RING/FYVE/PHD-type zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(97352, NULL, 'G3DSA:3.40.50.2300:FF:000332', NULL, NULL, 'DNA-binding response OmpR family regulator', NULL, NULL, NULL, NULL, NULL, 4),
(97353, NULL, 'G3DSA:1.20.1250.20:FF:001333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97354, NULL, 'G3DSA:3.90.1800.10:FF:000017', NULL, NULL, 'DNA-directed RNA polymerase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(97355, NULL, 'G3DSA:3.80.10.10:FF:004275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97356, NULL, 'G3DSA:2.10.25.10:FF:000520', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(97357, NULL, 'G3DSA:1.10.533.10:FF:000069', NULL, NULL, 'NACHT, LRR and PYD domains-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(97358, NULL, 'G3DSA:3.30.160.60:FF:000250', NULL, NULL, 'zinc finger protein 197 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(97359, NULL, 'G3DSA:2.60.40.60:FF:000175', NULL, NULL, 'cadherin-23 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(97360, NULL, 'G3DSA:3.40.50.720:FF:000258', NULL, NULL, 'Hydroxyacyl-coenzyme A dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(97361, NULL, 'G3DSA:3.40.630.10:FF:000044', NULL, NULL, 'Allantoate amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(97362, NULL, 'G3DSA:2.60.40.420:FF:000194', NULL, NULL, 'Cytochrome c oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(97363, NULL, 'G3DSA:3.30.70.330:FF:002154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97364, NULL, 'G3DSA:2.40.37.10:FF:000024', NULL, NULL, 'Putative diaminopimelate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(97365, NULL, 'G3DSA:3.30.420.40:FF:000955', NULL, NULL, 'ARP1 actin related protein 1 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(97366, NULL, 'G3DSA:3.10.110.10:FF:000028', NULL, NULL, 'Probable ubiquitin-conjugating enzyme E2 23', NULL, NULL, NULL, NULL, NULL, 4),
(97367, NULL, 'G3DSA:3.30.200.20:FF:001422', NULL, NULL, 'Si:dkeyp-67e1.6', NULL, NULL, NULL, NULL, NULL, 4),
(97368, NULL, 'G3DSA:3.30.420.10:FF:000143', NULL, NULL, 'Oligoribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(97369, NULL, 'G3DSA:1.10.540.10:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97370, NULL, 'G3DSA:1.10.3720.10:FF:000082', NULL, NULL, 'Phosphate transport system permease protein PstA', NULL, NULL, NULL, NULL, NULL, 4),
(97371, NULL, 'G3DSA:1.10.287.90:FF:000014', NULL, NULL, 'Cytochrome c oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(97372, NULL, 'G3DSA:1.25.40.10:FF:004728', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g21170', NULL, NULL, NULL, NULL, NULL, 4),
(97373, NULL, 'G3DSA:1.10.510.10:FF:000797', NULL, NULL, 'CMGC/SRPK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(97374, NULL, 'G3DSA:1.20.120.1200:FF:000010', NULL, NULL, 'NADH-quinone oxidoreductase subunit J', NULL, NULL, NULL, NULL, NULL, 4),
(97375, NULL, 'G3DSA:3.90.1490.10:FF:000009', NULL, NULL, 'ATP binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(97376, NULL, 'G3DSA:1.10.30.50:FF:000001', NULL, NULL, 'HNH endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(97377, NULL, 'G3DSA:3.10.20.70:FF:000013', NULL, NULL, 'Glutamine synthetase bacteria', NULL, NULL, NULL, NULL, NULL, 4),
(97378, NULL, 'G3DSA:3.40.710.10:FF:000045', NULL, NULL, 'Glutaminase', NULL, NULL, NULL, NULL, NULL, 4),
(97379, NULL, 'G3DSA:3.40.50.300:FF:006944', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97380, NULL, 'G3DSA:3.40.50.620:FF:000846', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(97381, NULL, 'G3DSA:2.10.109.10:FF:000052', NULL, NULL, 'LexA repressor', NULL, NULL, NULL, NULL, NULL, 4),
(97382, NULL, 'G3DSA:3.30.160.60:FF:004521', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97383, NULL, 'G3DSA:3.30.450.40:FF:000311', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(97384, NULL, 'G3DSA:3.40.350.10:FF:000062', NULL, NULL, 'AGAP001037-PA', NULL, NULL, NULL, NULL, NULL, 4),
(97385, NULL, 'G3DSA:3.40.50.300:FF:000492', NULL, NULL, 'Hydrogenase nickel incorporation protein HypB', NULL, NULL, NULL, NULL, NULL, 4),
(97386, NULL, 'G3DSA:2.60.40.1180:FF:000110', NULL, NULL, '1,4-alpha-glucan branching enzyme GlgB', NULL, NULL, NULL, NULL, NULL, 4),
(97387, NULL, 'G3DSA:2.60.40.10:FF:000654', NULL, NULL, 'MAM domain containing glycosylphosphatidylinositol anchor 2', NULL, NULL, NULL, NULL, NULL, 4),
(97388, NULL, 'G3DSA:3.20.70.20:FF:000001', NULL, NULL, 'Ribonucleoside-diphosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(97389, NULL, 'G3DSA:3.30.70.2030:FF:000001', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(97390, NULL, 'G3DSA:2.60.40.10:FF:000946', NULL, NULL, 'Roundabout guidance receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(97391, NULL, 'G3DSA:2.10.70.10:FF:000091', NULL, NULL, 'Beta-2-glycoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(97392, NULL, 'G3DSA:3.40.50.300:FF:006091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97393, NULL, 'G3DSA:2.40.128.680:FF:000003', NULL, NULL, 'Uncharacterized protein C12B10.15c', NULL, NULL, NULL, NULL, NULL, 4),
(97394, NULL, 'G3DSA:1.10.472.10:FF:000376', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97395, NULL, 'G3DSA:3.20.20.80:FF:000701', NULL, NULL, 'Os03g0320100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(97396, NULL, 'G3DSA:3.40.930.10:FF:000033', NULL, NULL, 'Sodium bicarbonate cotransporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(97397, NULL, 'G3DSA:3.40.190.80:FF:000087', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(97398, NULL, 'G3DSA:3.20.20.80:FF:000645', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97399, NULL, 'G3DSA:3.40.47.10:FF:000016', NULL, NULL, 'Non-specific lipid-transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(97400, NULL, 'G3DSA:3.30.160.60:FF:005269', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97401, NULL, 'G3DSA:1.20.1250.20:FF:001277', NULL, NULL, 'Solute carrier family 2, facilitated glucose transporter member 6', NULL, NULL, NULL, NULL, NULL, 4),
(97402, NULL, 'G3DSA:1.10.510.10:FF:001758', NULL, NULL, 'Serine/threonine protein kinase ppk15, putative', NULL, NULL, NULL, NULL, NULL, 4),
(97403, NULL, 'G3DSA:2.120.10.30:FF:000509', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97404, NULL, 'G3DSA:3.30.200.20:FF:001894', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(97405, NULL, 'G3DSA:1.25.10.10:FF:001293', NULL, NULL, 'Protein CBG02946', NULL, NULL, NULL, NULL, NULL, 4),
(97406, NULL, 'G3DSA:1.10.150.20:FF:000199', NULL, NULL, 'DNA-directed RNA polymerase subunit alpha, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(97407, NULL, 'G3DSA:1.10.132.10:FF:000002', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(97408, NULL, 'G3DSA:3.50.50.60:FF:001264', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(97409, NULL, 'G3DSA:3.10.28.10:FF:000070', NULL, NULL, 'DNA helicase, SNF2/RAD54 family', NULL, NULL, NULL, NULL, NULL, 4),
(97410, NULL, 'G3DSA:1.10.472.10:FF:000432', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97411, NULL, 'G3DSA:3.80.10.10:FF:003347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97412, NULL, 'G3DSA:3.40.50.150:FF:001767', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97413, NULL, 'G3DSA:3.40.50.1000:FF:000605', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97414, NULL, 'G3DSA:1.10.132.30:FF:000008', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(97415, NULL, 'G3DSA:3.30.70.330:FF:000176', NULL, NULL, 'Inner nuclear membrane protein Man1', NULL, NULL, NULL, NULL, NULL, 4),
(97416, NULL, 'G3DSA:3.40.50.300:FF:000840', NULL, NULL, 'Immune-associated nucleotide-binding protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(97417, NULL, 'G3DSA:3.30.930.10:FF:000081', NULL, NULL, 'Ferredoxin-fold anticodon binding domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(97418, NULL, 'G3DSA:3.40.50.10240:FF:000010', NULL, NULL, 'Thiamin pyrophosphokinase, vitamin B1 binding domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(97419, NULL, 'G3DSA:3.90.1410.10:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97420, NULL, 'G3DSA:2.130.10.30:FF:000048', NULL, NULL, 'YLR077W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(97421, NULL, 'G3DSA:3.30.1370.100:FF:000032', NULL, NULL, 'YALI0C07260p', NULL, NULL, NULL, NULL, NULL, 4),
(97422, NULL, 'G3DSA:3.40.1280.30:FF:000005', NULL, NULL, 'tRNA methyltransferase 10 A', NULL, NULL, NULL, NULL, NULL, 4),
(97423, NULL, 'G3DSA:1.10.1740.10:FF:000049', NULL, NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(97424, NULL, 'G3DSA:3.40.47.10:FF:000163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97425, NULL, 'G3DSA:3.30.160.60:FF:001054', NULL, NULL, 'Regulatory protein brlA', NULL, NULL, NULL, NULL, NULL, 4),
(97426, NULL, 'G3DSA:1.25.40.20:FF:000426', NULL, NULL, 'receptor-interacting serine/threonine-protein kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(97427, NULL, 'G3DSA:3.40.50.300:FF:007580', NULL, NULL, 'DEAD_2 protein domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(97428, NULL, 'G3DSA:3.40.50.12710:FF:000037', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7', NULL, NULL, NULL, NULL, NULL, 4),
(97429, NULL, 'G3DSA:3.80.10.10:FF:001369', NULL, NULL, 'F-box domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(97430, NULL, 'G3DSA:3.30.930.10:FF:000373', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97431, NULL, 'G3DSA:2.30.29.30:FF:000129', NULL, NULL, 'Insulin receptor substrate 1', NULL, NULL, NULL, NULL, NULL, 4),
(97432, NULL, 'G3DSA:2.130.10.10:FF:003999', NULL, NULL, 'Glutamate-rich WD repeat-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(97433, NULL, 'G3DSA:2.60.40.10:FF:000469', NULL, NULL, 'Mast/stem cell growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(97434, NULL, 'G3DSA:3.30.200.20:FF:000433', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(97435, NULL, 'G3DSA:3.40.190.270:FF:000001', NULL, NULL, 'Putative monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(97436, NULL, 'G3DSA:3.40.1440.10:FF:000001', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4),
(97437, NULL, 'G3DSA:1.25.10.10:FF:001669', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(97438, NULL, 'G3DSA:3.90.110.10:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97439, NULL, 'G3DSA:3.90.1200.10:FF:000084', NULL, NULL, 'Spore coat protein I', NULL, NULL, NULL, NULL, NULL, 4),
(97440, NULL, 'G3DSA:2.60.40.420:FF:000250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97441, NULL, 'G3DSA:2.130.10.10:FF:002723', NULL, NULL, 'Protein CBG19744', NULL, NULL, NULL, NULL, NULL, 4),
(97442, NULL, 'G3DSA:3.30.200.20:FF:001950', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97443, NULL, 'G3DSA:3.30.70.960:FF:000016', NULL, NULL, 'Suppressor of tumorigenicity 14 protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(97444, NULL, 'G3DSA:2.40.10.10:FF:000636', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97445, NULL, 'G3DSA:1.10.10.10:FF:000269', NULL, NULL, 'Pleckstrin', NULL, NULL, NULL, NULL, NULL, 4),
(97446, NULL, 'G3DSA:3.40.50.300:FF:001801', NULL, NULL, 'Putative arsenical pump-driving ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(97447, NULL, 'G3DSA:3.50.50.60:FF:001320', NULL, NULL, 'FAD-dependent catabolic D-arginine dehydrogenase DauA', NULL, NULL, NULL, NULL, NULL, 4),
(97448, NULL, 'G3DSA:1.20.120.620:FF:000003', NULL, NULL, 'Osmosensitive K+ channel histidine kinase KdpD', NULL, NULL, NULL, NULL, NULL, 4),
(97449, NULL, 'G3DSA:2.60.120.10:FF:000134', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(97450, NULL, 'G3DSA:1.20.5.390:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97451, NULL, 'G3DSA:2.10.109.10:FF:000057', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(97452, NULL, 'G3DSA:3.30.160.60:FF:001615', NULL, NULL, 'Zinc finger and SCAN domain containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(97453, NULL, 'G3DSA:3.40.50.300:FF:004527', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97454, NULL, 'G3DSA:1.20.1070.10:FF:001411', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97455, NULL, 'G3DSA:2.60.40.10:FF:004836', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97456, NULL, 'G3DSA:1.20.5.170:FF:000234', NULL, NULL, 'Cyclic AMP-responsive element-binding protein 3-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(97457, NULL, 'G3DSA:1.10.3080.10:FF:000026', NULL, NULL, 'Chloride channel protein EriC', NULL, NULL, NULL, NULL, NULL, 4),
(97458, NULL, 'G3DSA:2.40.10.10:FF:000159', NULL, NULL, 'Complement C1r subcomponent like', NULL, NULL, NULL, NULL, NULL, 4),
(97459, NULL, 'G3DSA:1.10.10.60:FF:000767', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97460, NULL, 'G3DSA:1.10.287.1490:FF:000070', NULL, NULL, 'Protein NETWORKED 1D isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(97461, NULL, 'G3DSA:2.130.10.10:FF:000042', NULL, NULL, 'echinoderm microtubule-associated protein-like 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(97462, NULL, 'G3DSA:2.170.120.12:FF:000003', NULL, NULL, 'Dna-directed rna polymerases i and iii subunit', NULL, NULL, NULL, NULL, NULL, 4),
(97463, NULL, 'G3DSA:3.50.50.60:FF:001348', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(97464, NULL, 'G3DSA:2.60.40.1180:FF:000054', NULL, NULL, 'Trehalose synthase/amylase TreS', NULL, NULL, NULL, NULL, NULL, 4),
(97465, NULL, 'G3DSA:3.40.50.300:FF:005539', NULL, NULL, 'Septin 7', NULL, NULL, NULL, NULL, NULL, 4),
(97466, NULL, 'G3DSA:3.30.70.940:FF:000010', NULL, NULL, 'Protein RNA-directed DNA methylation 3', NULL, NULL, NULL, NULL, NULL, 4),
(97467, NULL, 'G3DSA:3.40.50.2300:FF:001260', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97468, NULL, 'G3DSA:1.25.40.20:FF:001359', NULL, NULL, 'Ankyrin repeat and KH domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(97469, NULL, 'G3DSA:2.130.10.10:FF:000778', NULL, NULL, 'WD repeat domain 33', NULL, NULL, NULL, NULL, NULL, 4),
(97470, NULL, 'G3DSA:1.20.58.60:FF:000601', NULL, NULL, 'Plectin', NULL, NULL, NULL, NULL, NULL, 4),
(97471, NULL, 'G3DSA:1.25.10.10:FF:002782', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(97472, NULL, 'G3DSA:1.20.58.1310:FF:000001', NULL, NULL, 'Rop guanine nucleotide exchange factor 9', NULL, NULL, NULL, NULL, NULL, 4),
(97473, NULL, 'G3DSA:3.40.50.970:FF:000052', NULL, NULL, 'Sulfite reductase [NADPH] flavoprotein component', NULL, NULL, NULL, NULL, NULL, 4),
(97474, NULL, 'G3DSA:3.30.70.2330:FF:000006', NULL, NULL, 'Fanconi-associated nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(97475, NULL, 'G3DSA:2.60.120.1440:FF:000019', NULL, NULL, 'Probable transmembrane sensor', NULL, NULL, NULL, NULL, NULL, 4),
(97476, NULL, 'G3DSA:1.25.10.10:FF:002602', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97477, NULL, 'G3DSA:3.30.160.60:FF:001559', NULL, NULL, 'Zinc finger and BTB domain-containing protein 39', NULL, NULL, NULL, NULL, NULL, 4),
(97478, NULL, 'G3DSA:2.60.120.260:FF:000312', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97479, NULL, 'G3DSA:2.60.120.10:FF:000662', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97480, NULL, 'G3DSA:2.60.120.40:FF:000025', NULL, NULL, 'tumor necrosis factor ligand superfamily member 4', NULL, NULL, NULL, NULL, NULL, 4),
(97481, NULL, 'G3DSA:1.10.3720.10:FF:000110', NULL, NULL, 'Amino acid ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(97482, NULL, 'G3DSA:1.10.630.10:FF:000396', NULL, NULL, 'Cytochrome P450, family 2, subfamily k, polypeptide 20', NULL, NULL, NULL, NULL, NULL, 4),
(97483, NULL, 'G3DSA:3.30.70.60:FF:000029', NULL, NULL, 'Ribosomal protein S6', NULL, NULL, NULL, NULL, NULL, 4),
(97484, NULL, 'G3DSA:1.10.10.10:FF:000241', NULL, NULL, 'UPF0502 protein YceH', NULL, NULL, NULL, NULL, NULL, 4),
(97485, NULL, 'G3DSA:2.60.120.10:FF:000426', NULL, NULL, 'Vicilin-like seed storage protein At2g28490', NULL, NULL, NULL, NULL, NULL, 4),
(97486, NULL, 'G3DSA:2.40.10.10:FF:000075', NULL, NULL, 'Structural polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(97487, NULL, 'G3DSA:1.25.10.10:FF:001854', NULL, NULL, 'HEAT repeat-containing protein 5B-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(97488, NULL, 'G3DSA:1.20.58.2190:FF:000001', NULL, NULL, 'peptide-N(4)-(N-acetyl-beta- glucosaminyl)asparagine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(97489, NULL, 'G3DSA:3.40.50.2000:FF:000776', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(97490, NULL, 'G3DSA:3.40.50.300:FF:006467', NULL, NULL, 'Si:ch1073-181h11.2', NULL, NULL, NULL, NULL, NULL, 4),
(97491, NULL, 'G3DSA:2.120.10.30:FF:000133', NULL, NULL, 'Protein CBG19478', NULL, NULL, NULL, NULL, NULL, 4),
(97492, NULL, 'G3DSA:4.10.70.10:FF:000007', NULL, NULL, 'Disintegrin and metalloproteinase domain-containing protein B', NULL, NULL, NULL, NULL, NULL, 4),
(97493, NULL, 'G3DSA:3.30.70.850:FF:000011', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 7', NULL, NULL, NULL, NULL, NULL, 4),
(97494, NULL, 'G3DSA:3.30.450.240:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97495, NULL, 'G3DSA:3.40.50.150:FF:000773', NULL, NULL, 'O-methyltransferase GliM-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(97496, NULL, 'G3DSA:1.20.890.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97497, NULL, 'G3DSA:3.30.160.780:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97498, NULL, 'G3DSA:3.30.160.60:FF:002543', NULL, NULL, 'LOC567465 protein', NULL, NULL, NULL, NULL, NULL, 4),
(97499, NULL, 'G3DSA:2.30.29.30:FF:001057', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(97500, NULL, 'G3DSA:3.30.1610.10:FF:000016', NULL, NULL, 'Nucleoporin autopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(97501, NULL, 'G3DSA:4.10.60.10:FF:000209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97502, NULL, 'G3DSA:3.30.70.330:FF:000361', NULL, NULL, '28 kDa ribonucleoprotein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(97503, NULL, 'G3DSA:2.60.200.40:FF:000059', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(97504, NULL, 'G3DSA:3.30.930.10:FF:000406', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(97505, NULL, 'G3DSA:3.30.1960.10:FF:000008', NULL, NULL, 'Methyltransferase TYW3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(97506, NULL, 'G3DSA:3.20.20.40:FF:000004', NULL, NULL, 'Glucanase', NULL, NULL, NULL, NULL, NULL, 4),
(97507, NULL, 'G3DSA:3.40.33.10:FF:000069', NULL, NULL, 'GM10902', NULL, NULL, NULL, NULL, NULL, 4),
(97508, NULL, 'G3DSA:2.70.20.10:FF:000006', NULL, NULL, 'DNA topoisomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(97509, NULL, 'G3DSA:2.60.40.10:FF:001958', NULL, NULL, 'Frazzled, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(97510, NULL, 'G3DSA:3.40.50.300:FF:007400', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97511, NULL, 'G3DSA:3.40.30.10:FF:000540', NULL, NULL, 'Protein disulfide isomerase PDI2', NULL, NULL, NULL, NULL, NULL, 4),
(97512, NULL, 'G3DSA:2.20.70.10:FF:000214', NULL, NULL, 'YALI0D02827p', NULL, NULL, NULL, NULL, NULL, 4),
(97513, NULL, 'G3DSA:2.60.120.920:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97514, NULL, 'G3DSA:3.40.850.10:FF:000027', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(97515, NULL, 'G3DSA:1.25.40.10:FF:002986', NULL, NULL, 'Pre-mRNA-splicing factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(97516, NULL, 'G3DSA:3.40.470.10:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97517, NULL, 'G3DSA:3.30.70.870:FF:000017', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(97518, NULL, 'G3DSA:3.40.50.300:FF:006652', NULL, NULL, 'ATP-dependent RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(97519, NULL, 'G3DSA:1.10.3380.10:FF:000066', NULL, NULL, 'Activating signal cointegrator 1 complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(97520, NULL, 'G3DSA:2.130.10.10:FF:005977', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97521, NULL, 'G3DSA:1.10.8.10:FF:000049', NULL, NULL, 'ancient ubiquitous protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(97522, NULL, 'G3DSA:1.10.8.60:FF:000283', NULL, NULL, 'Sigma-54 dependent transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(97523, NULL, 'G3DSA:2.30.30.40:FF:000203', NULL, NULL, 'Cdc42-interacting protein 4, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(97524, NULL, 'G3DSA:3.40.390.10:FF:000036', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(97525, NULL, 'G3DSA:3.30.710.10:FF:000042', NULL, NULL, 'BTB/POZ domain-containing protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(97526, NULL, 'G3DSA:1.25.40.10:FF:000513', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97527, NULL, 'G3DSA:3.40.50.150:FF:001262', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97528, NULL, 'G3DSA:1.25.40.20:FF:000050', NULL, NULL, 'integrin-linked protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(97529, NULL, 'G3DSA:3.40.1090.10:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97530, NULL, 'G3DSA:3.30.60.20:FF:000034', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(97531, NULL, 'G3DSA:3.30.420.40:FF:000478', NULL, NULL, 'Carbohydrate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(97532, NULL, 'G3DSA:1.20.1280.20:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97533, NULL, 'G3DSA:3.30.160.60:FF:003032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97534, NULL, 'G3DSA:1.25.40.10:FF:003239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97535, NULL, 'G3DSA:1.20.1310.20:FF:000023', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(97536, NULL, 'G3DSA:1.20.1310.10:FF:000110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97537, NULL, 'G3DSA:1.10.357.50:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97538, NULL, 'G3DSA:3.30.450.20:FF:000625', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(97539, NULL, 'G3DSA:4.10.1240.10:FF:000065', NULL, NULL, 'Adhesion G protein-coupled receptor L3', NULL, NULL, NULL, NULL, NULL, 4),
(97540, NULL, 'G3DSA:3.30.530.20:FF:000154', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(97541, NULL, 'G3DSA:2.30.30.210:FF:000012', NULL, NULL, 'Ribonuclease P protein subunit p29', NULL, NULL, NULL, NULL, NULL, 4),
(97542, NULL, 'G3DSA:3.90.190.10:FF:000566', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97543, NULL, 'G3DSA:3.30.420.40:FF:000663', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97544, NULL, 'G3DSA:1.25.40.20:FF:001887', NULL, NULL, 'Os11g0435300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(97545, NULL, 'G3DSA:1.10.630.10:FF:000744', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97546, NULL, 'G3DSA:2.60.510.10:FF:000001', NULL, NULL, 'Matrix protein VP40', NULL, NULL, NULL, NULL, NULL, 4),
(97547, NULL, 'G3DSA:3.40.50.140:FF:000005', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(97548, NULL, 'G3DSA:1.10.3380.30:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97549, NULL, 'G3DSA:3.30.70.330:FF:000209', NULL, NULL, 'U2 small nuclear ribonucleoprotein auxiliary factor 35 kDa subunit-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(97550, NULL, 'G3DSA:3.40.50.300:FF:001796', NULL, NULL, 'ATP-dependent DNA helicase PIF1', NULL, NULL, NULL, NULL, NULL, 4),
(97551, NULL, 'G3DSA:3.30.50.10:FF:000064', NULL, NULL, 'GATA transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(97552, NULL, 'G3DSA:2.130.10.10:FF:002690', NULL, NULL, 'Putative WD-repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(97553, NULL, 'G3DSA:3.30.470.30:FF:000045', NULL, NULL, 'mRNA-capping enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(97554, NULL, 'G3DSA:1.10.1420.10:FF:000070', NULL, NULL, 'DNA mismatch repair protein mutS, putative', NULL, NULL, NULL, NULL, NULL, 4),
(97555, NULL, 'G3DSA:3.20.20.70:FF:000783', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97556, NULL, 'G3DSA:3.40.50.410:FF:000053', NULL, NULL, 'von Willebrand factor', NULL, NULL, NULL, NULL, NULL, 4),
(97557, NULL, 'G3DSA:3.40.50.150:FF:000278', NULL, NULL, 'Coactivator-associated arginine methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(97558, NULL, 'G3DSA:3.90.550.10:FF:000577', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(97559, NULL, 'G3DSA:3.60.40.10:FF:000287', NULL, NULL, 'Stage II sporulation E family protein', NULL, NULL, NULL, NULL, NULL, 4),
(97560, NULL, 'G3DSA:2.10.25.10:FF:000868', NULL, NULL, 'Transmembrane matrix receptor MUP-4', NULL, NULL, NULL, NULL, NULL, 4),
(97561, NULL, 'G3DSA:3.90.1410.10:FF:000145', NULL, NULL, 'N-lysine methyltransferase SETD6', NULL, NULL, NULL, NULL, NULL, 4),
(97562, NULL, 'G3DSA:3.80.10.10:FF:002482', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97563, NULL, 'G3DSA:3.40.50.300:FF:000784', NULL, NULL, 'ATP-dependent RNA helicase DDX54', NULL, NULL, NULL, NULL, NULL, 4),
(97564, NULL, 'G3DSA:3.40.50.11350:FF:000039', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(97565, NULL, 'G3DSA:1.20.1050.10:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97566, NULL, 'G3DSA:2.60.40.10:FF:001582', NULL, NULL, 'Receptor tyrosine kinase Flt1b', NULL, NULL, NULL, NULL, NULL, 4),
(97567, NULL, 'G3DSA:3.30.160.60:FF:000598', NULL, NULL, 'zinc finger protein 692 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(97568, NULL, 'G3DSA:1.20.1530.20:FF:000011', NULL, NULL, 'K(+) efflux antiporter 3, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(97569, NULL, 'G3DSA:3.40.50.300:FF:005983', NULL, NULL, '26S protease regulatory subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(97570, NULL, 'G3DSA:1.10.10.10:FF:000505', NULL, NULL, 'Forkhead box R1', NULL, NULL, NULL, NULL, NULL, 4),
(97571, NULL, 'G3DSA:3.40.640.10:FF:000106', NULL, NULL, 'Cysteine desulfurase IscS', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(97572, NULL, 'G3DSA:3.30.1330.10:FF:000034', NULL, NULL, 'AGAP011375-PA', NULL, NULL, NULL, NULL, NULL, 4),
(97573, NULL, 'G3DSA:3.20.20.100:FF:000133', NULL, NULL, 'LOC100127714 protein', NULL, NULL, NULL, NULL, NULL, 4),
(97574, NULL, 'G3DSA:3.50.50.60:FF:000044', NULL, NULL, 'N-methyl-L-tryptophan oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(97575, NULL, 'G3DSA:2.130.10.10:FF:000273', NULL, NULL, 'WD repeat domain-containing protein 83', NULL, NULL, NULL, NULL, NULL, 4),
(97576, NULL, 'G3DSA:2.120.10.80:FF:000007', NULL, NULL, 'F-box/kelch-repeat protein SKIP11', NULL, NULL, NULL, NULL, NULL, 4),
(97577, NULL, 'G3DSA:4.10.830.40:FF:000009', NULL, NULL, 'Tripartite motif-containing 25', NULL, NULL, NULL, NULL, NULL, 4),
(97578, NULL, 'G3DSA:3.90.79.10:FF:000184', NULL, NULL, 'NUDIX family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(97579, NULL, 'G3DSA:3.40.30.10:FF:000916', NULL, NULL, 'Peroxiredoxin-2', NULL, NULL, NULL, NULL, NULL, 4),
(97580, NULL, 'G3DSA:2.70.50.30:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97581, NULL, 'G3DSA:3.30.160.60:FF:004049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97582, NULL, 'G3DSA:3.30.740.10:FF:000015', NULL, NULL, 'Dynein light chain', NULL, NULL, NULL, NULL, NULL, 4),
(97583, NULL, 'G3DSA:1.20.5.730:FF:000014', NULL, NULL, 'Rabaptin, RAB GTPase binding effector protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(97584, NULL, 'G3DSA:3.50.50.60:FF:000100', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(97585, NULL, 'G3DSA:1.10.287.470:FF:000044', NULL, NULL, 'Probable RND efflux membrane fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(97586, NULL, 'G3DSA:1.20.1080.10:FF:000131', NULL, NULL, 'Aquaporin PIP1-6', NULL, NULL, NULL, NULL, NULL, 4),
(97587, NULL, 'G3DSA:1.25.40.10:FF:002194', NULL, NULL, 'HTH-type transcriptional regulator MalT', NULL, NULL, NULL, NULL, NULL, 4),
(97588, NULL, 'G3DSA:2.30.30.770:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97589, NULL, 'G3DSA:2.120.10.60:FF:000001', NULL, NULL, 'Tricorn protease homolog', NULL, NULL, NULL, NULL, NULL, 4),
(97590, NULL, 'G3DSA:1.25.40.10:FF:001682', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g42310, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(97591, NULL, 'G3DSA:2.60.40.10:FF:001874', NULL, NULL, '1,4-alpha-glucan-branching enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(97592, NULL, 'G3DSA:3.30.420.10:FF:000648', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97593, NULL, 'G3DSA:3.30.310.50:FF:000006', NULL, NULL, 'Phosphoglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(97594, NULL, 'G3DSA:3.40.50.300:FF:005455', NULL, NULL, 'ATPase involved in DNA repair', NULL, NULL, NULL, NULL, NULL, 4),
(97595, NULL, 'G3DSA:3.30.450.20:FF:000592', NULL, NULL, 'PHOTB3 phototropin blue light photoreceptor', NULL, NULL, NULL, NULL, NULL, 4),
(97596, NULL, 'G3DSA:1.10.443.10:FF:000011', NULL, NULL, 'Site-specific integrase', NULL, NULL, NULL, NULL, NULL, 4),
(97597, NULL, 'G3DSA:1.20.1070.10:FF:000630', NULL, NULL, 'NeuroPeptide Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(97598, NULL, 'G3DSA:1.25.40.10:FF:001210', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(97599, NULL, 'G3DSA:1.10.510.10:FF:003383', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97600, NULL, 'G3DSA:1.10.3730.20:FF:000052', NULL, NULL, 'DMT family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(97601, NULL, 'G3DSA:3.40.50.80:FF:000247', NULL, NULL, 'NADPH oxidase 4', NULL, NULL, NULL, NULL, NULL, 4),
(97602, NULL, 'G3DSA:1.20.1250.20:FF:000260', NULL, NULL, 'Major facilitator superfamily domain containing 2B', NULL, NULL, NULL, NULL, NULL, 4),
(97603, NULL, 'G3DSA:2.30.29.30:FF:000096', NULL, NULL, 'IQ motif and SEC7 domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(97604, NULL, 'G3DSA:3.70.10.10:FF:000054', NULL, NULL, 'DNA polymerase processivity factor', NULL, NULL, NULL, NULL, NULL, 4),
(97605, NULL, 'G3DSA:1.25.40.10:FF:004931', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(97606, NULL, 'G3DSA:3.30.160.60:FF:006090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97607, NULL, 'G3DSA:1.50.40.10:FF:000449', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97608, NULL, 'G3DSA:1.10.357.70:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97609, NULL, 'G3DSA:2.160.20.70:FF:000003', NULL, NULL, 'Probable septum site-determining protein MinC', NULL, NULL, NULL, NULL, NULL, 4),
(97610, NULL, 'G3DSA:1.50.40.10:FF:000505', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97611, NULL, 'G3DSA:1.20.1410.10:FF:000022', NULL, NULL, 'transmembrane protein 98', NULL, NULL, NULL, NULL, NULL, 4),
(97612, NULL, 'G3DSA:1.10.10.790:FF:000010', NULL, NULL, 'SURP and G-patch domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(97613, NULL, 'G3DSA:3.40.1360.10:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97614, NULL, 'G3DSA:3.40.50.1240:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97615, NULL, 'G3DSA:3.40.1110.10:FF:000448', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97616, NULL, 'G3DSA:3.30.300.20:FF:000058', NULL, NULL, 'Probable transcription termination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(97617, NULL, 'G3DSA:1.10.287.610:FF:000013', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(97618, NULL, 'G3DSA:3.40.1810.10:FF:000069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97619, NULL, 'G3DSA:2.60.40.10:FF:001930', NULL, NULL, 'FiLamiN (Actin binding protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(97620, NULL, 'G3DSA:3.30.450.40:FF:000159', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(97621, NULL, 'G3DSA:1.10.565.10:FF:000209', NULL, NULL, 'Retinoic acid receptor alpha protein', NULL, NULL, NULL, NULL, NULL, 4),
(97622, NULL, 'G3DSA:3.90.190.10:FF:000622', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97623, NULL, 'G3DSA:3.40.50.2020:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97624, NULL, 'G3DSA:1.10.8.210:FF:000001', NULL, NULL, 'Siroheme synthase', NULL, NULL, NULL, NULL, NULL, 4),
(97625, NULL, 'G3DSA:3.10.20.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97626, NULL, 'G3DSA:3.50.30.30:FF:000085', NULL, NULL, 'Subtilisin-like protease SBT4.1', NULL, NULL, NULL, NULL, NULL, 4),
(97627, NULL, 'G3DSA:3.10.120.10:FF:000001', NULL, NULL, 'Cytochrome b5 reductase 4', NULL, NULL, NULL, NULL, NULL, 4),
(97628, NULL, 'G3DSA:3.30.50.10:FF:000148', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(97629, NULL, 'G3DSA:3.40.190.10:FF:000055', NULL, NULL, 'Phosphate ABC transporter, phosphate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(97630, NULL, 'G3DSA:2.80.10.50:FF:000208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97631, NULL, 'G3DSA:1.20.5.190:FF:000009', NULL, NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(97632, NULL, 'G3DSA:2.40.440.10:FF:000016', NULL, NULL, 'Murein L,D-transpeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(97633, NULL, 'G3DSA:1.20.1110.10:FF:000185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97634, NULL, 'G3DSA:3.30.160.60:FF:006197', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97635, NULL, 'G3DSA:2.30.110.10:FF:000112', NULL, NULL, 'Putative reductase', NULL, NULL, NULL, NULL, NULL, 4),
(97636, NULL, 'G3DSA:3.60.40.10:FF:000343', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97637, NULL, 'G3DSA:2.30.140.30:FF:000002', NULL, NULL, 'Serine-type D-Ala-D-Ala carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(97638, NULL, 'G3DSA:3.30.160.60:FF:003976', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97639, NULL, 'G3DSA:2.60.40.2150:FF:000002', NULL, NULL, 'Interleukin 17 receptor A', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(97640, NULL, 'G3DSA:3.90.640.90:FF:000006', NULL, NULL, 'Protein BTG1', NULL, NULL, NULL, NULL, NULL, 4),
(97641, NULL, 'G3DSA:1.10.860.10:FF:000025', NULL, NULL, 'Replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(97642, NULL, 'G3DSA:1.10.150.240:FF:000004', NULL, NULL, '2-deoxyglucose-6-phosphate phosphatase YniC', NULL, NULL, NULL, NULL, NULL, 4),
(97643, NULL, 'G3DSA:3.20.20.70:FF:000816', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97644, NULL, 'G3DSA:1.10.238.10:FF:000169', NULL, NULL, 'Calcium-dependent protein kinase 28', NULL, NULL, NULL, NULL, NULL, 4),
(97645, NULL, 'G3DSA:3.40.605.10:FF:000031', NULL, NULL, 'Phenylacetic acid degradation protein PaaN', NULL, NULL, NULL, NULL, NULL, 4),
(97646, NULL, 'G3DSA:3.30.70.1230:FF:000250', NULL, NULL, 'Blr6052 protein', NULL, NULL, NULL, NULL, NULL, 4),
(97647, NULL, 'G3DSA:3.20.140.10:FF:000039', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(97648, NULL, 'G3DSA:3.30.160.60:FF:005741', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97649, NULL, 'G3DSA:3.10.20.90:FF:000643', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(97650, NULL, 'G3DSA:3.40.50.720:FF:001371', NULL, NULL, 'UDP-galactopyranose mutase Glf', NULL, NULL, NULL, NULL, NULL, 4),
(97651, NULL, 'G3DSA:1.20.120.1070:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97652, NULL, 'G3DSA:3.40.50.300:FF:007164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97653, NULL, 'G3DSA:3.30.1370.10:FF:000155', NULL, NULL, 'RNA-binding KH domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(97654, NULL, 'G3DSA:3.40.50.2300:FF:001288', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97655, NULL, 'G3DSA:1.10.287.130:FF:000111', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(97656, NULL, 'G3DSA:2.60.40.10:FF:003583', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97657, NULL, 'G3DSA:3.30.200.20:FF:000017', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(97658, NULL, 'G3DSA:3.40.630.30:FF:000674', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97659, NULL, 'G3DSA:2.130.10.10:FF:004488', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97660, NULL, 'G3DSA:3.30.1390.10:FF:000010', NULL, NULL, 'E3 ubiquitin-protein ligase ubr-1', NULL, NULL, NULL, NULL, NULL, 4),
(97661, NULL, 'G3DSA:2.60.40.10:FF:000238', NULL, NULL, 'Neuronal cell adhesion molecule', NULL, NULL, NULL, NULL, NULL, 4),
(97662, NULL, 'G3DSA:1.25.40.180:FF:000267', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97663, NULL, 'G3DSA:1.25.40.20:FF:001270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97664, NULL, 'G3DSA:3.30.1360.120:FF:000002', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(97665, NULL, 'G3DSA:3.80.10.10:FF:004191', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(97666, NULL, 'G3DSA:3.30.310.80:FF:000021', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(97667, NULL, 'G3DSA:2.10.25.10:FF:001537', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(97668, NULL, 'G3DSA:1.20.1280.50:FF:000192', NULL, NULL, 'LOC100145161 protein', NULL, NULL, NULL, NULL, NULL, 4),
(97669, NULL, 'G3DSA:1.20.1560.10:FF:000589', NULL, NULL, 'p-glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(97670, NULL, 'G3DSA:2.60.40.10:FF:005617', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97671, NULL, 'G3DSA:1.20.1250.20:FF:002058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97672, NULL, 'G3DSA:3.40.50.200:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97673, NULL, 'G3DSA:1.20.58.60:FF:000129', NULL, NULL, 'Dystrophin', NULL, NULL, NULL, NULL, NULL, 4),
(97674, NULL, 'G3DSA:1.10.287.1490:FF:000098', NULL, NULL, 'Viral A-type inclusion protein, putative', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(97675, NULL, 'G3DSA:2.60.40.60:FF:000259', NULL, NULL, 'cadherin-86C isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(97676, NULL, 'G3DSA:2.170.270.10:FF:000107', NULL, NULL, 'N-lysine methyltransferase KMT5A-B', NULL, NULL, NULL, NULL, NULL, 4),
(97677, NULL, 'G3DSA:2.40.30.220:FF:000001', NULL, NULL, 'Photosystem II reaction center Psb28 protein', NULL, NULL, NULL, NULL, NULL, 4),
(97678, NULL, 'G3DSA:1.20.58.60:FF:000040', NULL, NULL, 'Short stop, isoform N', NULL, NULL, NULL, NULL, NULL, 4),
(97679, NULL, 'G3DSA:3.10.100.10:FF:000258', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97680, NULL, 'G3DSA:1.10.10.60:FF:000262', NULL, NULL, 'Zinc fingers and homeoboxes 1', NULL, NULL, NULL, NULL, NULL, 4),
(97681, NULL, 'G3DSA:3.40.50.2000:FF:000540', NULL, NULL, 'Gll1176 protein', NULL, NULL, NULL, NULL, NULL, 4),
(97682, NULL, 'G3DSA:1.10.287.70:FF:000295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97683, NULL, 'G3DSA:1.10.2020.20:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97684, NULL, 'G3DSA:1.10.8.270:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97685, NULL, 'G3DSA:3.90.79.10:FF:000240', NULL, NULL, 'Gll3262 protein', NULL, NULL, NULL, NULL, NULL, 4),
(97686, NULL, 'G3DSA:2.60.120.260:FF:000256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97687, NULL, 'G3DSA:2.40.50.140:FF:001004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97688, NULL, 'G3DSA:3.30.230.80:FF:000020', NULL, NULL, 'Heat shock protein 90-2', NULL, NULL, NULL, NULL, NULL, 4),
(97689, NULL, 'G3DSA:3.10.10.10:FF:000012', NULL, NULL, 'YALI0E34980p', NULL, NULL, NULL, NULL, NULL, 4),
(97690, NULL, 'G3DSA:3.30.70.330:FF:000737', NULL, NULL, 'polyadenylate-binding protein RBP47 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(97691, NULL, 'G3DSA:3.40.720.10:FF:000107', NULL, NULL, 'Phosphatidylglycerol specific phospholipase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(97692, NULL, 'G3DSA:3.40.50.300:FF:002813', NULL, NULL, 'Cytochrome biosyntheisis ABC transporter ATP-binding protein/permease CydD', NULL, NULL, NULL, NULL, NULL, 4),
(97693, NULL, 'G3DSA:2.60.40.1530:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97694, NULL, 'G3DSA:1.10.287.1130:FF:000007', NULL, NULL, 'Cytochrome c oxidase copper chaperone COX17', NULL, NULL, NULL, NULL, NULL, 4),
(97695, NULL, 'G3DSA:1.20.120.1760:FF:000065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97696, NULL, 'G3DSA:1.20.1280.140:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97697, NULL, 'G3DSA:3.90.1750.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97698, NULL, 'G3DSA:3.30.40.210:FF:000010', NULL, NULL, 'Transcription elongation factor SPT4', NULL, NULL, NULL, NULL, NULL, 4),
(97699, NULL, 'G3DSA:1.20.920.30:FF:000045', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(97700, NULL, 'G3DSA:3.60.15.10:FF:000127', NULL, NULL, 'Beta-lactamase superfamily domain/DNA repair metallo-beta-lactamase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(97701, NULL, 'G3DSA:1.10.940.10:FF:000026', NULL, NULL, 'Transcription antitermination protein NusB', NULL, NULL, NULL, NULL, NULL, 4),
(97702, NULL, 'G3DSA:3.40.50.720:FF:000966', NULL, NULL, 'Probable shikimate 5-dehydrogenase AroE (5-dehydroshikimate reductase)', NULL, NULL, NULL, NULL, NULL, 4),
(97703, NULL, 'G3DSA:1.10.150.50:FF:000067', NULL, NULL, 'SAM and HD domain-containing deoxynucleoside triphosphate triphosphohydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(97704, NULL, 'G3DSA:1.10.246.10:FF:000008', NULL, NULL, 'Vitamin D-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(97705, NULL, 'G3DSA:3.80.10.10:FF:001638', NULL, NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase At2g25790', NULL, NULL, NULL, NULL, NULL, 4),
(97706, NULL, 'G3DSA:1.10.630.10:FF:000688', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97707, NULL, 'G3DSA:2.160.20.10:FF:000300', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(97708, NULL, 'G3DSA:2.40.50.140:FF:000223', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(97709, NULL, 'G3DSA:3.40.50.410:FF:000137', NULL, NULL, 'Integrator complex subunit 14', NULL, NULL, NULL, NULL, NULL, 4),
(97710, NULL, 'G3DSA:3.20.80.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97711, NULL, 'G3DSA:1.10.287.1490:FF:000154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97712, NULL, 'G3DSA:2.130.10.10:FF:002307', NULL, NULL, 'WD repeat protein ybl104c homologue, putative', NULL, NULL, NULL, NULL, NULL, 4),
(97713, NULL, 'G3DSA:3.40.50.150:FF:000481', NULL, NULL, 'Os02g0158500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(97714, NULL, 'G3DSA:1.20.1050.10:FF:000303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97715, NULL, 'G3DSA:3.40.50.300:FF:000868', NULL, NULL, 'DEAD/DEAH box helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(97716, NULL, 'G3DSA:1.25.10.10:FF:002366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97717, NULL, 'G3DSA:1.10.287.1110:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97718, NULL, 'G3DSA:2.60.40.10:FF:006022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97719, NULL, 'G3DSA:1.20.120.1900:FF:000034', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(97720, NULL, 'G3DSA:1.25.40.20:FF:000903', NULL, NULL, 'Predicted ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(97721, NULL, 'G3DSA:3.30.56.10:FF:000015', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(97722, NULL, 'G3DSA:2.40.50.140:FF:000751', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97723, NULL, 'G3DSA:3.40.1000.50:FF:000019', NULL, NULL, 'Repressor of RNA polymerase III transcription', NULL, NULL, NULL, NULL, NULL, 4),
(97724, NULL, 'G3DSA:3.30.1680.10:FF:000021', NULL, NULL, 'Semaphorin 4C', NULL, NULL, NULL, NULL, NULL, 4),
(97725, NULL, 'G3DSA:3.10.100.10:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97726, NULL, 'G3DSA:1.10.10.10:FF:000185', NULL, NULL, 'Transcriptional adapter', NULL, NULL, NULL, NULL, NULL, 4),
(97727, NULL, 'G3DSA:2.60.40.10:FF:000093', NULL, NULL, 'Down syndrome cell adhesion molecule, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(97728, NULL, 'G3DSA:3.40.30.10:FF:000124', NULL, NULL, 'Thioredoxin domain-containing 17', NULL, NULL, NULL, NULL, NULL, 4),
(97729, NULL, 'G3DSA:1.25.40.10:FF:004083', NULL, NULL, 'Alpha-soluble NSF attachment protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(97730, NULL, 'G3DSA:1.25.40.10:FF:002458', NULL, NULL, 'Intraflagellar transport protein 139', NULL, NULL, NULL, NULL, NULL, 4),
(97731, NULL, 'G3DSA:3.30.110.110:FF:000007', NULL, NULL, 'Double-strand break repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(97732, NULL, 'G3DSA:2.60.40.10:FF:004364', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97733, NULL, 'G3DSA:2.10.110.10:FF:000358', NULL, NULL, 'LIM domain-binding protein 3-like', NULL, NULL, NULL, NULL, NULL, 4),
(97734, NULL, 'G3DSA:3.40.850.10:FF:000555', NULL, NULL, 'Myosin-K heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(97735, NULL, 'G3DSA:3.40.525.10:FF:000030', NULL, NULL, 'CRAL/TRIO_-_N-terminal_domain/CRAL /TRIO_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(97736, NULL, 'G3DSA:1.10.540.10:FF:000006', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(97737, NULL, 'G3DSA:2.60.210.10:FF:000017', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(97738, NULL, 'G3DSA:3.50.40.10:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97739, NULL, 'G3DSA:3.40.50.2000:FF:000484', NULL, NULL, 'Glycosyl transferase family 1', NULL, NULL, NULL, NULL, NULL, 4),
(97740, NULL, 'G3DSA:3.40.50.720:FF:001219', NULL, NULL, 'NADP oxidoreductase coenzyme F420-dependent, putative', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(97741, NULL, 'G3DSA:2.30.30.380:FF:000017', NULL, NULL, 'Nei like DNA glycosylase 3', NULL, NULL, NULL, NULL, NULL, 4),
(97742, NULL, 'G3DSA:3.40.30.10:FF:001052', NULL, NULL, 'At1g07080/F10K1_15', NULL, NULL, NULL, NULL, NULL, 4),
(97743, NULL, 'G3DSA:3.30.70.580:FF:000054', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(97744, NULL, 'G3DSA:3.30.70.890:FF:000028', NULL, NULL, 'MeValonate Kinase', NULL, NULL, NULL, NULL, NULL, 4),
(97745, NULL, 'G3DSA:2.40.160.10:FF:000034', NULL, NULL, 'Voltage-dependent anion-selective channel, putative', NULL, NULL, NULL, NULL, NULL, 4),
(97746, NULL, 'G3DSA:1.20.5.580:FF:000003', NULL, NULL, 'Protein CBR-CPX-2', NULL, NULL, NULL, NULL, NULL, 4),
(97747, NULL, 'G3DSA:3.30.160.60:FF:002251', NULL, NULL, 'Zinc finger protein 407 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(97748, NULL, 'G3DSA:2.40.30.10:FF:000014', NULL, NULL, 'Probable GTP-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(97749, NULL, 'G3DSA:3.90.1150.10:FF:000523', NULL, NULL, 'Kynurenine aminotransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(97750, NULL, 'G3DSA:3.30.200.20:FF:000489', NULL, NULL, 'Inactive receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(97751, NULL, 'G3DSA:3.40.1350.10:FF:000027', NULL, NULL, 'tRNA-splicing endonuclease subunit Sen34', NULL, NULL, NULL, NULL, NULL, 4),
(97752, NULL, 'G3DSA:3.30.160.60:FF:005685', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97753, NULL, 'G3DSA:2.130.10.10:FF:005893', NULL, NULL, 'BEACH domain-containing protein lvsE', NULL, NULL, NULL, NULL, NULL, 4),
(97754, NULL, 'G3DSA:2.60.15.10:FF:000017', NULL, NULL, 'ATP synthase epsilon chain', NULL, NULL, NULL, NULL, NULL, 4),
(97755, NULL, 'G3DSA:2.60.98.60:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97756, NULL, 'G3DSA:3.10.110.10:FF:000175', NULL, NULL, 'Ubiquitin-conjugating enzyme E2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(97757, NULL, 'G3DSA:1.10.238.200:FF:000021', NULL, NULL, 'Defective in cullin neddylation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(97758, NULL, 'G3DSA:1.25.40.10:FF:004700', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97759, NULL, 'G3DSA:1.10.246.130:FF:000006', NULL, NULL, 'Gamma-glutamyltranspeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(97760, NULL, 'G3DSA:1.20.120.1630:FF:000021', NULL, NULL, 'Polyprenol reductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(97761, NULL, 'G3DSA:3.80.10.10:FF:003263', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(97762, NULL, 'G3DSA:3.40.1000.30:FF:000013', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(97763, NULL, 'G3DSA:3.30.565.10:FF:000473', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(97764, NULL, 'G3DSA:2.60.40.150:FF:000146', NULL, NULL, 'E3 ubiquitin-protein ligase NEDD4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(97765, NULL, 'G3DSA:2.60.40.10:FF:003111', NULL, NULL, 'Beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(97766, NULL, 'G3DSA:3.30.230.130:FF:000023', NULL, NULL, 'Protein CBR-CUL-2', NULL, NULL, NULL, NULL, NULL, 4),
(97767, NULL, 'G3DSA:2.40.50.140:FF:000190', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(97768, NULL, 'G3DSA:3.30.70.260:FF:000020', NULL, NULL, 'Aspartokinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(97769, NULL, 'G3DSA:1.20.1200.10:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97770, NULL, 'G3DSA:3.90.550.10:FF:000285', NULL, NULL, 'Hypothetical glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(97771, NULL, 'G3DSA:1.10.287.110:FF:000189', NULL, NULL, 'Chaperone protein dnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(97772, NULL, 'G3DSA:3.40.50.720:FF:002203', NULL, NULL, 'Putative oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(97773, NULL, 'G3DSA:1.10.760.10:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97774, NULL, 'G3DSA:2.130.10.10:FF:001998', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(97775, NULL, 'G3DSA:3.40.5.10:FF:000027', NULL, NULL, 'Probable 54S ribosomal protein L9, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(97776, NULL, 'G3DSA:1.20.1070.10:FF:000102', NULL, NULL, 'neuropeptides B/W receptor type 1', NULL, NULL, NULL, NULL, NULL, 4),
(97777, NULL, 'G3DSA:3.30.200.20:FF:002434', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(97778, NULL, 'G3DSA:2.10.110.10:FF:000302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97779, NULL, 'G3DSA:3.30.160.60:FF:003324', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97780, NULL, 'G3DSA:3.30.470.20:FF:000003', NULL, NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(97781, NULL, 'G3DSA:1.25.40.10:FF:000805', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(97782, NULL, 'G3DSA:2.30.29.30:FF:001349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97783, NULL, 'G3DSA:3.40.50.300:FF:006236', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(97784, NULL, 'G3DSA:3.30.1320.10:FF:000005', NULL, NULL, '30S ribosomal protein S16', NULL, NULL, NULL, NULL, NULL, 4),
(97785, NULL, 'G3DSA:3.30.830.10:FF:000314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97786, NULL, 'G3DSA:1.10.274.20:FF:000003', NULL, NULL, 'Phenylalanine aminomutase (L-beta-phenylalanine forming)', NULL, NULL, NULL, NULL, NULL, 4),
(97787, NULL, 'G3DSA:1.25.40.20:FF:000342', NULL, NULL, 'Acyl-CoA binding domain containing 6', NULL, NULL, NULL, NULL, NULL, 4),
(97788, NULL, 'G3DSA:2.30.42.10:FF:000351', NULL, NULL, 'ALP/Enigma encoding', NULL, NULL, NULL, NULL, NULL, 4),
(97789, NULL, 'G3DSA:3.40.50.720:FF:002591', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97790, NULL, 'G3DSA:2.30.29.30:FF:000949', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(97791, NULL, 'G3DSA:3.90.1440.10:FF:000006', NULL, NULL, 'Protein translocase subunit SecA 2', NULL, NULL, NULL, NULL, NULL, 4),
(97792, NULL, 'G3DSA:3.30.1120.10:FF:000024', NULL, NULL, 'Arylsulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(97793, NULL, 'G3DSA:2.60.40.10:FF:001166', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(97794, NULL, 'G3DSA:2.60.40.180:FF:000009', NULL, NULL, '5-hydroxyisourate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(97795, NULL, 'G3DSA:3.30.413.10:FF:000031', NULL, NULL, 'Nitrite and sulphite reductase 4Fe-4S region', NULL, NULL, NULL, NULL, NULL, 4),
(97796, NULL, 'G3DSA:1.10.533.10:FF:000041', NULL, NULL, 'Caspase 9', NULL, NULL, NULL, NULL, NULL, 4),
(97797, NULL, 'G3DSA:1.10.10.60:FF:001279', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97798, NULL, 'G3DSA:3.20.20.70:FF:000552', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97799, NULL, 'G3DSA:1.10.1280.10:FF:000007', NULL, NULL, 'Polyphenol oxidase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(97800, NULL, 'G3DSA:3.30.505.10:FF:000025', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(97801, NULL, 'G3DSA:2.70.170.10:FF:000056', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(97802, NULL, 'G3DSA:3.30.420.40:FF:000247', NULL, NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(97803, NULL, 'G3DSA:2.60.40.10:FF:000710', NULL, NULL, 'ADAMTS-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(97804, NULL, 'G3DSA:1.10.10.60:FF:000823', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97805, NULL, 'G3DSA:3.30.310.200:FF:000001', NULL, NULL, 'Probable serine/threonine-protein kinase pats1', NULL, NULL, NULL, NULL, NULL, 4),
(97806, NULL, 'G3DSA:1.10.287.70:FF:000328', NULL, NULL, 'Calcium-gated potassium channel protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(97807, NULL, 'G3DSA:3.40.50.1010:FF:000198', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(97808, NULL, 'G3DSA:1.10.238.10:FF:000877', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(97809, NULL, 'G3DSA:3.30.70.330:FF:001850', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97810, NULL, 'G3DSA:3.30.70.100:FF:000197', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97811, NULL, 'G3DSA:1.10.238.10:FF:000933', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97812, NULL, 'G3DSA:3.30.160.60:FF:004960', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97813, NULL, 'G3DSA:3.40.50.300:FF:000020', NULL, NULL, 'Amino acid ABC transporter ATP-binding component', NULL, NULL, NULL, NULL, NULL, 4),
(97814, NULL, 'G3DSA:3.30.200.20:FF:001130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97815, NULL, 'G3DSA:1.10.238.10:FF:000405', NULL, NULL, 'Polycystin 2 like 1, transient receptor potential cation channel', NULL, NULL, NULL, NULL, NULL, 4),
(97816, NULL, 'G3DSA:1.20.1070.10:FF:001850', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(97817, NULL, 'G3DSA:2.40.320.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97818, NULL, 'G3DSA:1.10.238.10:FF:001153', NULL, NULL, 'Chromosome 13 SCAF14769, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(97819, NULL, 'G3DSA:3.30.565.10:FF:000288', NULL, NULL, 'Nitrogen regulation protein NR (II)', NULL, NULL, NULL, NULL, NULL, 4),
(97820, NULL, 'G3DSA:1.20.1070.10:FF:001794', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97821, NULL, 'G3DSA:3.40.50.10810:FF:000203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97822, NULL, 'G3DSA:2.20.25.90:FF:000004', NULL, NULL, 'Dimethyl sulfoxide reductase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(97823, NULL, 'G3DSA:1.10.510.10:FF:004164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97824, NULL, 'G3DSA:1.20.58.390:FF:000013', NULL, NULL, 'Putative acetylcholine receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(97825, NULL, 'G3DSA:1.50.40.10:FF:000269', NULL, NULL, 'Mitochondrial carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(97826, NULL, 'G3DSA:2.40.110.10:FF:000031', NULL, NULL, 'Acyl-CoA dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(97827, NULL, 'G3DSA:2.40.10.10:FF:000400', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97828, NULL, 'G3DSA:3.30.160.60:FF:003796', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97829, NULL, 'G3DSA:3.30.70.330:FF:002070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97830, NULL, 'G3DSA:1.25.40.20:FF:000718', NULL, NULL, 'LOW QUALITY PROTEIN: SH3 and multiple ankyrin repeat domains protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(97831, NULL, 'G3DSA:3.40.50.10320:FF:000005', NULL, NULL, 'N-acetylglucosaminylphosphatidylinositol deacetylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(97832, NULL, 'G3DSA:3.80.10.10:FF:003639', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(97833, NULL, 'G3DSA:1.20.1070.10:FF:001647', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97834, NULL, 'G3DSA:3.60.10.10:FF:000375', NULL, NULL, 'Phosphate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(97835, NULL, 'G3DSA:3.30.70.360:FF:000044', NULL, NULL, 'Putative amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(97836, NULL, 'G3DSA:3.60.20.30:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97837, NULL, 'G3DSA:1.10.1200.10:FF:000087', NULL, NULL, 'Nonribosomal peptide synthase SidC', NULL, NULL, NULL, NULL, NULL, 4),
(97838, NULL, 'G3DSA:3.30.160.60:FF:003268', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97839, NULL, 'G3DSA:2.40.240.10:FF:000035', NULL, NULL, 'Glutaminyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(97840, NULL, 'G3DSA:3.40.1380.20:FF:000004', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(97841, NULL, 'G3DSA:3.30.30.30:FF:000035', NULL, NULL, 'Heat shock protein 70, putative', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(97842, NULL, 'G3DSA:3.90.25.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97843, NULL, 'G3DSA:4.10.400.10:FF:000148', NULL, NULL, 'low-density lipoprotein receptor-related protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(97844, NULL, 'G3DSA:3.40.50.1820:FF:000143', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(97845, NULL, 'G3DSA:1.10.220.10:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97846, NULL, 'G3DSA:1.20.58.60:FF:000096', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(97847, NULL, 'G3DSA:2.60.40.10:FF:002127', NULL, NULL, 'tyrosine-protein kinase-like otk', NULL, NULL, NULL, NULL, NULL, 4),
(97848, NULL, 'G3DSA:2.60.40.150:FF:000798', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97849, NULL, 'G3DSA:2.60.40.10:FF:002599', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(97850, NULL, 'G3DSA:1.10.510.10:FF:000269', NULL, NULL, 'Serine/threonine-protein kinase 40', NULL, NULL, NULL, NULL, NULL, 4),
(97851, NULL, 'G3DSA:3.90.70.10:FF:000372', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97852, NULL, 'G3DSA:3.20.20.10:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97853, NULL, 'G3DSA:3.40.50.620:FF:000054', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(97854, NULL, 'G3DSA:1.20.1070.10:FF:001703', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97855, NULL, 'G3DSA:3.80.10.10:FF:001077', NULL, NULL, 'Tsukushin', NULL, NULL, NULL, NULL, NULL, 4),
(97856, NULL, 'G3DSA:3.40.50.1400:FF:000045', NULL, NULL, 'Ferrochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(97857, NULL, 'G3DSA:1.25.40.10:FF:000569', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g15510, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(97858, NULL, 'G3DSA:2.30.42.10:FF:000295', NULL, NULL, 'Alpha-1-syntrophin', NULL, NULL, NULL, NULL, NULL, 4),
(97859, NULL, 'G3DSA:1.10.418.10:FF:000026', NULL, NULL, 'protein-methionine sulfoxide oxidase MICAL3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(97860, NULL, 'G3DSA:3.40.30.10:FF:000068', NULL, NULL, 'ArsC family reductase', NULL, NULL, NULL, NULL, NULL, 4),
(97861, NULL, 'G3DSA:1.20.1070.10:FF:000158', NULL, NULL, 'Neuropeptide Y receptor type 2', NULL, NULL, NULL, NULL, NULL, 4),
(97862, NULL, 'G3DSA:3.40.50.300:FF:004235', NULL, NULL, 'Probable ATP-dependent helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(97863, NULL, 'G3DSA:1.25.10.10:FF:003327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97864, NULL, 'G3DSA:1.10.510.10:FF:000325', NULL, NULL, 'Casein kinase I isoform delta-like', NULL, NULL, NULL, NULL, NULL, 4),
(97865, NULL, 'G3DSA:3.40.50.10190:FF:000096', NULL, NULL, 'DNA repair protein REV1', NULL, NULL, NULL, NULL, NULL, 4),
(97866, NULL, 'G3DSA:2.40.100.10:FF:000002', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(97867, NULL, 'G3DSA:1.20.1250.20:FF:000821', NULL, NULL, 'facilitated trehalose transporter Tret1', NULL, NULL, NULL, NULL, NULL, 4),
(97868, NULL, 'G3DSA:3.40.50.1370:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97869, NULL, 'G3DSA:3.40.50.300:FF:004382', NULL, NULL, 'Signal recognition particle receptor FtsY', NULL, NULL, NULL, NULL, NULL, 4),
(97870, NULL, 'G3DSA:3.30.565.10:FF:000001', NULL, NULL, 'Heat shock protein HSP 90-alpha', NULL, NULL, NULL, NULL, NULL, 4),
(97871, NULL, 'G3DSA:2.60.120.1190:FF:000017', NULL, NULL, 'Discoidin domain receptor, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(97872, NULL, 'G3DSA:2.40.160.180:FF:000008', NULL, NULL, 'Carbohydrate porin', NULL, NULL, NULL, NULL, NULL, 4),
(97873, NULL, 'G3DSA:3.30.160.60:FF:004757', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97874, NULL, 'G3DSA:1.25.40.10:FF:002514', NULL, NULL, 'Major Facilitator Superfamily (MFS)', NULL, NULL, NULL, NULL, NULL, 4),
(97875, NULL, 'G3DSA:3.30.70.330:FF:001518', NULL, NULL, 'Myelin expression factor 2', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(97876, NULL, 'G3DSA:3.40.190.10:FF:000616', NULL, NULL, 'ATP phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(97877, NULL, 'G3DSA:2.10.25.10:FF:001032', NULL, NULL, 'AGAP003873-PA', NULL, NULL, NULL, NULL, NULL, 4),
(97878, NULL, 'G3DSA:3.40.850.10:FF:000499', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97879, NULL, 'G3DSA:3.10.180.10:FF:000033', NULL, NULL, 'Putative lyase', NULL, NULL, NULL, NULL, NULL, 4),
(97880, NULL, 'G3DSA:1.10.132.60:FF:000023', NULL, NULL, 'Putative DNA polymerase zeta catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(97881, NULL, 'G3DSA:2.30.180.10:FF:000173', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97882, NULL, 'G3DSA:3.30.200.20:FF:000725', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(97883, NULL, 'G3DSA:3.40.50.300:FF:007872', NULL, NULL, 'Bll5958 protein', NULL, NULL, NULL, NULL, NULL, 4),
(97884, NULL, 'G3DSA:1.10.10.60:FF:000970', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97885, NULL, 'G3DSA:2.130.10.10:FF:000981', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(97886, NULL, 'G3DSA:1.10.10.2660:FF:000015', NULL, NULL, 'Ubiquitin-conjugating enzyme E1', NULL, NULL, NULL, NULL, NULL, 4),
(97887, NULL, 'G3DSA:3.40.367.20:FF:000047', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(97888, NULL, 'G3DSA:2.60.120.200:FF:000406', NULL, NULL, 'AGRin (Synaptic protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(97889, NULL, 'G3DSA:3.30.710.10:FF:000098', NULL, NULL, 'Kelch-like family member 31', NULL, NULL, NULL, NULL, NULL, 4),
(97890, NULL, 'G3DSA:1.20.120.1810:FF:000007', NULL, NULL, 'RNA polymerase sigma factor SigF', NULL, NULL, NULL, NULL, NULL, 4),
(97891, NULL, 'G3DSA:3.30.200.20:FF:001506', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(97892, NULL, 'G3DSA:3.40.50.300:FF:002493', NULL, NULL, 'Sulfate/thiosulfate import ATP-binding protein CysA', NULL, NULL, NULL, NULL, NULL, 4),
(97893, NULL, 'G3DSA:1.20.810.10:FF:000025', NULL, NULL, 'Cytochrome b', NULL, NULL, NULL, NULL, NULL, 4),
(97894, NULL, 'G3DSA:1.10.1070.11:FF:000122', NULL, NULL, 'mDNApk3'', putative', NULL, NULL, NULL, NULL, NULL, 4),
(97895, NULL, 'G3DSA:2.30.29.30:FF:000332', NULL, NULL, 'arf-GAP with GTPase, ANK repeat and PH domain-containing protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(97896, NULL, 'G3DSA:1.20.1640.10:FF:000011', NULL, NULL, 'Dispatched RND transporter family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(97897, NULL, 'G3DSA:4.10.400.10:FF:000204', NULL, NULL, 'Putative low-density lipoprotein receptor', NULL, NULL, NULL, NULL, NULL, 4),
(97898, NULL, 'G3DSA:3.10.20.770:FF:000015', NULL, NULL, 'phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit beta isoform-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(97899, NULL, 'G3DSA:1.10.510.10:FF:004220', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97900, NULL, 'G3DSA:1.10.510.10:FF:001814', NULL, NULL, 'Serine/threonine-protein kinase sel-5', NULL, NULL, NULL, NULL, NULL, 4),
(97901, NULL, 'G3DSA:1.25.40.20:FF:000870', NULL, NULL, 'Ankyrin repeat domain-containing protein 50', NULL, NULL, NULL, NULL, NULL, 4),
(97902, NULL, 'G3DSA:1.20.1720.10:FF:000012', NULL, NULL, 'MFS toxin efflux pump (AflT)', NULL, NULL, NULL, NULL, NULL, 4),
(97903, NULL, 'G3DSA:1.10.287.110:FF:000369', NULL, NULL, 'YALI0E17303p', NULL, NULL, NULL, NULL, NULL, 4),
(97904, NULL, 'G3DSA:3.40.50.2000:FF:000012', NULL, NULL, 'UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase 110 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(97905, NULL, 'G3DSA:3.40.630.10:FF:000483', NULL, NULL, 'Aminoacyl-histidine dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(97906, NULL, 'G3DSA:3.90.760.10:FF:000003', NULL, NULL, 'Putative oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(97907, NULL, 'G3DSA:3.40.630.30:FF:000527', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97908, NULL, 'G3DSA:3.40.970.10:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(97909, NULL, 'G3DSA:3.40.50.1100:FF:000017', NULL, NULL, 'D-cysteine desulfhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(97910, NULL, 'G3DSA:3.40.50.1000:FF:000285', NULL, NULL, 'Tpp1p', NULL, NULL, NULL, NULL, NULL, 4),
(97911, NULL, 'G3DSA:3.40.50.300:FF:008125', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(97912, NULL, 'G3DSA:1.20.1560.10:FF:000010', NULL, NULL, 'Multidrug resistance-associated ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(97913, NULL, 'G3DSA:1.10.510.10:FF:003759', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97914, NULL, 'G3DSA:3.20.20.140:FF:000010', NULL, NULL, 'Membrane dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(97915, NULL, 'G3DSA:3.30.70.1010:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97916, NULL, 'G3DSA:1.10.510.10:FF:000510', NULL, NULL, 'Inactive tyrosine-protein kinase PRAG1', NULL, NULL, NULL, NULL, NULL, 4),
(97917, NULL, 'G3DSA:3.40.50.620:FF:000762', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97918, NULL, 'G3DSA:2.60.450.20:FF:000004', NULL, NULL, 'Centromere protein J', NULL, NULL, NULL, NULL, NULL, 4),
(97919, NULL, 'G3DSA:2.10.25.10:FF:000104', NULL, NULL, 'Fibulin-1', NULL, NULL, NULL, NULL, NULL, 4),
(97920, NULL, 'G3DSA:1.25.40.20:FF:001123', NULL, NULL, 'Protein CBR-MIB-1', NULL, NULL, NULL, NULL, NULL, 4),
(97921, NULL, 'G3DSA:2.130.10.10:FF:002779', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97922, NULL, 'G3DSA:2.70.98.50:FF:000006', NULL, NULL, 'Glycoside hydrolase family 95', NULL, NULL, NULL, NULL, NULL, 4),
(97923, NULL, 'G3DSA:3.40.50.880:FF:000025', NULL, NULL, 'Bifunctional pyrimidine biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(97924, NULL, 'G3DSA:2.40.50.140:FF:000695', NULL, NULL, 'Asparagine--tRNA ligase, cytoplasmic 3', NULL, NULL, NULL, NULL, NULL, 4),
(97925, NULL, 'G3DSA:3.40.50.10330:FF:000065', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(97926, NULL, 'G3DSA:3.50.50.60:FF:000623', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97927, NULL, 'G3DSA:2.40.70.10:FF:000376', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97928, NULL, 'G3DSA:3.90.1290.10:FF:000033', NULL, NULL, 'VAB-10A protein', NULL, NULL, NULL, NULL, NULL, 4),
(97929, NULL, 'G3DSA:1.10.540.10:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97930, NULL, 'G3DSA:1.10.3720.10:FF:000166', NULL, NULL, 'ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(97931, NULL, 'G3DSA:3.90.180.10:FF:000088', NULL, NULL, 'Probable quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(97932, NULL, 'G3DSA:2.20.28.200:FF:000008', NULL, NULL, 'NAD-dependent protein deacetylase sirtuin-6', NULL, NULL, NULL, NULL, NULL, 4),
(97933, NULL, 'G3DSA:3.30.420.10:FF:000087', NULL, NULL, 'Exonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(97934, NULL, 'G3DSA:3.40.50.10190:FF:000152', NULL, NULL, 'DNA ligase 3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(97935, NULL, 'G3DSA:3.40.630.10:FF:000336', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(97936, NULL, 'G3DSA:1.10.8.870:FF:000019', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(97937, NULL, 'G3DSA:3.40.50.300:FF:003982', NULL, NULL, 'Guanylate kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(97938, NULL, 'G3DSA:3.30.160.60:FF:000542', NULL, NULL, 'Zinc finger and BTB domain-containing protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(97939, NULL, 'G3DSA:1.20.1250.20:FF:001602', NULL, NULL, 'MFS toxin efflux pump, putative', NULL, NULL, NULL, NULL, NULL, 4),
(97940, NULL, 'G3DSA:3.20.20.70:FF:000496', NULL, NULL, 'Dihydroorotate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(97941, NULL, 'G3DSA:3.30.70.920:FF:000055', NULL, NULL, 'Transcriptional regulator, AsnC family', NULL, NULL, NULL, NULL, NULL, 4),
(97942, NULL, 'G3DSA:1.10.3210.10:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97943, NULL, 'G3DSA:3.10.350.10:FF:000102', NULL, NULL, 'Gll1142 protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(97944, NULL, 'G3DSA:3.40.140.10:FF:000052', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(97945, NULL, 'G3DSA:1.25.40.20:FF:001831', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97946, NULL, 'G3DSA:1.25.10.10:FF:003294', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(97947, NULL, 'G3DSA:3.80.10.10:FF:001841', NULL, NULL, 'GM24816', NULL, NULL, NULL, NULL, NULL, 4),
(97948, NULL, 'G3DSA:2.10.25.10:FF:000812', NULL, NULL, 'adhesion G protein-coupled receptor E1', NULL, NULL, NULL, NULL, NULL, 4),
(97949, NULL, 'G3DSA:3.30.40.10:FF:001491', NULL, NULL, 'YALI0A19514p', NULL, NULL, NULL, NULL, NULL, 4),
(97950, NULL, 'G3DSA:3.30.9.10:FF:000182', NULL, NULL, 'Putatibe oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(97951, NULL, 'G3DSA:3.40.50.2300:FF:000040', NULL, NULL, 'DNA-binding transcriptional activator UhpA', NULL, NULL, NULL, NULL, NULL, 4),
(97952, NULL, 'G3DSA:3.40.50.300:FF:008092', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(97953, NULL, 'G3DSA:1.10.287.110:FF:000425', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97954, NULL, 'G3DSA:2.130.10.10:FF:000306', NULL, NULL, '3-carboxymuconate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(97955, NULL, 'G3DSA:3.75.10.10:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97956, NULL, 'G3DSA:2.30.180.10:FF:000026', NULL, NULL, 'Stabilin 1', NULL, NULL, NULL, NULL, NULL, 4),
(97957, NULL, 'G3DSA:3.90.550.10:FF:000521', NULL, NULL, 'Nucleotide-diphospho-sugar transferase', NULL, NULL, NULL, NULL, NULL, 4),
(97958, NULL, 'G3DSA:2.10.50.30:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97959, NULL, 'G3DSA:2.30.30.40:FF:000259', NULL, NULL, 'Protein BOI2', NULL, NULL, NULL, NULL, NULL, 4),
(97960, NULL, 'G3DSA:3.20.20.210:FF:000019', NULL, NULL, 'Methylcobalamin:coenzyme M methyltransferase, methylamine-specific', NULL, NULL, NULL, NULL, NULL, 4),
(97961, NULL, 'G3DSA:3.10.110.10:FF:000231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97962, NULL, 'G3DSA:3.10.20.90:FF:000463', NULL, NULL, 'Autophagy protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(97963, NULL, 'G3DSA:1.20.1270.60:FF:000076', NULL, NULL, 'Rho GTPase activating protein 42', NULL, NULL, NULL, NULL, NULL, 4),
(97964, NULL, 'G3DSA:2.60.40.10:FF:002655', NULL, NULL, 'Roundabout-like protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(97965, NULL, 'G3DSA:1.25.40.10:FF:000193', NULL, NULL, 'protein sel-1 homolog 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(97966, NULL, 'G3DSA:3.50.30.30:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97967, NULL, 'G3DSA:3.30.160.60:FF:005213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97968, NULL, 'G3DSA:3.80.10.10:FF:000857', NULL, NULL, 'Leucine rich repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(97969, NULL, 'G3DSA:2.130.10.10:FF:004016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97970, NULL, 'G3DSA:3.40.50.1820:FF:001071', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(97971, NULL, 'G3DSA:1.20.1310.10:FF:000166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97972, NULL, 'G3DSA:3.30.160.60:FF:004813', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97973, NULL, 'G3DSA:3.40.120.10:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97974, NULL, 'G3DSA:3.40.50.170:FF:000020', NULL, NULL, 'Methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(97975, NULL, 'G3DSA:3.30.460.10:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97976, NULL, 'G3DSA:2.60.40.1660:FF:000012', NULL, NULL, 'Na+/K+ ATPase, Beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(97977, NULL, 'G3DSA:2.30.30.550:FF:000001', NULL, NULL, 'major vault protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(97978, NULL, 'G3DSA:1.20.870.10:FF:000001', NULL, NULL, 'rap guanine nucleotide exchange factor 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(97979, NULL, 'G3DSA:1.25.10.10:FF:000421', NULL, NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(97980, NULL, 'G3DSA:1.20.1250.20:FF:001041', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(97981, NULL, 'G3DSA:2.60.40.1250:FF:000007', NULL, NULL, 'Thiol:disulfide interchange protein DsbD 1', NULL, NULL, NULL, NULL, NULL, 4),
(97982, NULL, 'G3DSA:3.40.30.10:FF:000596', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(97983, NULL, 'G3DSA:3.30.1370.10:FF:000211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97984, NULL, 'G3DSA:2.130.10.10:FF:004201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97985, NULL, 'G3DSA:1.10.472.80:FF:000228', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97986, NULL, 'G3DSA:3.90.1170.50:FF:000014', NULL, NULL, 'Aldehyde oxidase and xanthine dehydrogenase, a/b hammerhead domain', NULL, NULL, NULL, NULL, NULL, 4),
(97987, NULL, 'G3DSA:3.30.160.60:FF:003829', NULL, NULL, 'Crooked legs, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(97988, NULL, 'G3DSA:3.40.50.1820:FF:001632', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(97989, NULL, 'G3DSA:1.20.58.2050:FF:000009', NULL, NULL, 'GINS complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(97990, NULL, 'G3DSA:2.60.40.10:FF:004600', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(97991, NULL, 'G3DSA:1.20.1070.10:FF:001086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97992, NULL, 'G3DSA:3.30.40.10:FF:001339', NULL, NULL, 'ATP-dependent chromatin assembly factor large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(97993, NULL, 'G3DSA:2.40.50.1070:FF:000008', NULL, NULL, '23S rRNA (uracil(747)-C(5))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(97994, NULL, 'G3DSA:3.90.70.10:FF:000748', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(97995, NULL, 'G3DSA:3.90.226.10:FF:000251', NULL, NULL, 'Enoyl-CoA hydratase/carnithine racemase', NULL, NULL, NULL, NULL, NULL, 4),
(97996, NULL, 'G3DSA:3.80.10.10:FF:000149', NULL, NULL, 'NLR family member X1', NULL, NULL, NULL, NULL, NULL, 4),
(97997, NULL, 'G3DSA:2.170.130.10:FF:000041', NULL, NULL, 'Hemin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(97998, NULL, 'G3DSA:3.90.70.10:FF:000225', NULL, NULL, 'Cysteine protease 15', NULL, NULL, NULL, NULL, NULL, 4),
(97999, NULL, 'G3DSA:3.30.70.330:FF:002446', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98000, NULL, 'G3DSA:3.30.160.60:FF:000918', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(98001, NULL, 'G3DSA:3.40.630.30:FF:000494', NULL, NULL, 'Diamine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(98002, NULL, 'G3DSA:2.30.30.570:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98003, NULL, 'G3DSA:2.60.120.330:FF:000209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98004, NULL, 'G3DSA:2.130.10.10:FF:004724', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98005, NULL, 'G3DSA:1.10.10.10:FF:001674', NULL, NULL, 'Metal-dependent transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(98006, NULL, 'G3DSA:3.60.21.10:FF:000456', NULL, NULL, 'Putative 5''-nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(98007, NULL, 'G3DSA:3.40.50.12780:FF:000069', NULL, NULL, 'YOR093C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(98008, NULL, 'G3DSA:1.10.238.10:FF:000225', NULL, NULL, 'Calpain-12', NULL, NULL, NULL, NULL, NULL, 4),
(98009, NULL, 'G3DSA:3.40.50.1820:FF:000087', NULL, NULL, 'Gibberellin receptor GID1', NULL, NULL, NULL, NULL, NULL, 4),
(98010, NULL, 'G3DSA:3.40.50.1240:FF:000065', NULL, NULL, 'Similar to histidine acid phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(98011, NULL, 'G3DSA:1.10.10.10:FF:001489', NULL, NULL, 'Transcription factor E2F/dimerisation partner (TDP) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(98012, NULL, 'G3DSA:2.40.160.10:FF:000006', NULL, NULL, 'Translocase of outer mitochondrial membrane 40 like', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(98013, NULL, 'G3DSA:1.20.1720.10:FF:000124', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98014, NULL, 'G3DSA:3.30.200.20:FF:000202', NULL, NULL, 'Serine/threonine-protein kinase 32B', NULL, NULL, NULL, NULL, NULL, 4),
(98015, NULL, 'G3DSA:3.30.230.130:FF:000028', NULL, NULL, 'Cullin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(98016, NULL, 'G3DSA:3.40.50.720:FF:000994', NULL, NULL, 'Dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(98017, NULL, 'G3DSA:3.40.50.450:FF:000014', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(98018, NULL, 'G3DSA:3.90.1150.10:FF:000490', NULL, NULL, 'Alanine aminotransferase 2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(98019, NULL, 'G3DSA:3.40.20.10:FF:000062', NULL, NULL, 'Quail, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(98020, NULL, 'G3DSA:1.20.120.1240:FF:000022', NULL, NULL, 'Dynamin-like GTPase Dnm1', NULL, NULL, NULL, NULL, NULL, 4),
(98021, NULL, 'G3DSA:1.20.1250.20:FF:000057', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(98022, NULL, 'G3DSA:3.30.559.10:FF:000088', NULL, NULL, 'Acyltransferase, WS/DGAT/MGAT', NULL, NULL, NULL, NULL, NULL, 4),
(98023, NULL, 'G3DSA:3.30.160.20:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98024, NULL, 'G3DSA:3.90.1150.210:FF:000026', NULL, NULL, 'F-actin-capping protein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(98025, NULL, 'G3DSA:3.40.800.10:FF:000024', NULL, NULL, 'Formimidoylglutamase', NULL, NULL, NULL, NULL, NULL, 4),
(98026, NULL, 'G3DSA:3.40.50.1000:FF:000133', NULL, NULL, '5''(3'')-deoxyribonucleotidase, cytosolic type', NULL, NULL, NULL, NULL, NULL, 4),
(98027, NULL, 'G3DSA:3.40.50.2300:FF:001001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98028, NULL, 'G3DSA:3.80.10.10:FF:002190', NULL, NULL, 'Toll-like receptor 22', NULL, NULL, NULL, NULL, NULL, 4),
(98029, NULL, 'G3DSA:3.40.309.10:FF:000051', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(98030, NULL, 'G3DSA:1.10.238.10:FF:001041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98031, NULL, 'G3DSA:3.10.20.340:FF:000004', NULL, NULL, 'Arginine biosynthesis bifunctional protein ArgJ, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(98032, NULL, 'G3DSA:3.90.550.50:FF:000162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98033, NULL, 'G3DSA:1.25.40.10:FF:004144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98034, NULL, 'G3DSA:1.10.510.10:FF:001578', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(98035, NULL, 'G3DSA:1.10.238.10:FF:000517', NULL, NULL, 'Sodium/calcium exchanger family protein / calcium-binding EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(98036, NULL, 'G3DSA:3.30.160.60:FF:004252', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98037, NULL, 'G3DSA:1.10.10.1420:FF:000003', NULL, NULL, 'CDT1-like protein a chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(98038, NULL, 'G3DSA:3.40.30.10:FF:001136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98039, NULL, 'G3DSA:3.40.50.2000:FF:000512', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98040, NULL, 'G3DSA:3.30.1050.10:FF:000024', NULL, NULL, 'Metallo-beta-lactamase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(98041, NULL, 'G3DSA:2.30.29.30:FF:000388', NULL, NULL, 'von Willebrand RING finger domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(98042, NULL, 'G3DSA:3.40.50.800:FF:000136', NULL, NULL, 'Prolyl Amino-acyl tRNA Synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(98043, NULL, 'G3DSA:1.10.8.270:FF:000148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98044, NULL, 'G3DSA:3.30.565.10:FF:000029', NULL, NULL, 'Sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(98045, NULL, 'G3DSA:3.40.50.10070:FF:000003', NULL, NULL, 'Tol-Pal system protein TolB', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(98046, NULL, 'G3DSA:1.10.287.110:FF:000009', NULL, NULL, 'Auxilin-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(98047, NULL, 'G3DSA:3.80.10.10:FF:001633', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98048, NULL, 'G3DSA:3.40.190.10:FF:000240', NULL, NULL, 'Glutamate receptor ionotropic, kainate 2', NULL, NULL, NULL, NULL, NULL, 4),
(98049, NULL, 'G3DSA:3.40.30.10:FF:000568', NULL, NULL, 'GM26257', NULL, NULL, NULL, NULL, NULL, 4),
(98050, NULL, 'G3DSA:2.30.42.10:FF:000323', NULL, NULL, 'Leucine-rich repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(98051, NULL, 'G3DSA:2.10.25.10:FF:001296', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(98052, NULL, 'G3DSA:3.30.420.40:FF:000371', NULL, NULL, 'Ribosomal-protein-alanine acetyltransferase rimI', NULL, NULL, NULL, NULL, NULL, 4),
(98053, NULL, 'G3DSA:3.10.180.10:FF:000089', NULL, NULL, '4-hydroxyphenylpyruvate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(98054, NULL, 'G3DSA:1.10.287.550:FF:000006', NULL, NULL, 'Steroid sulfatase (microsomal), isozyme S', NULL, NULL, NULL, NULL, NULL, 4),
(98055, NULL, 'G3DSA:3.40.50.150:FF:000126', NULL, NULL, 'Polyamine aminopropyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(98056, NULL, 'G3DSA:2.60.120.10:FF:000393', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(98057, NULL, 'G3DSA:2.60.40.1460:FF:000008', NULL, NULL, 'Integrin subunit alpha 10', NULL, NULL, NULL, NULL, NULL, 4),
(98058, NULL, 'G3DSA:3.80.10.10:FF:000205', NULL, NULL, 'Podocan', NULL, NULL, NULL, NULL, NULL, 4),
(98059, NULL, 'G3DSA:3.40.50.10090:FF:000009', NULL, NULL, 'Uroporphyrinogen-III synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(98060, NULL, 'G3DSA:3.30.200.20:FF:001681', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98061, NULL, 'G3DSA:1.50.40.10:FF:000157', NULL, NULL, 'ADP/ATP carrier', NULL, NULL, NULL, NULL, NULL, 4),
(98062, NULL, 'G3DSA:3.40.1190.20:FF:000169', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(98063, NULL, 'G3DSA:3.10.580.10:FF:000086', NULL, NULL, 'Protein MAM3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98064, NULL, 'G3DSA:1.20.1740.10:FF:000075', NULL, NULL, 'Amino acid permease', NULL, NULL, NULL, NULL, NULL, 4),
(98065, NULL, 'G3DSA:2.60.40.10:FF:002239', NULL, NULL, 'Adhesion G protein-coupled receptor F5', NULL, NULL, NULL, NULL, NULL, 4),
(98066, NULL, 'G3DSA:3.40.50.450:FF:000065', NULL, NULL, 'Phosphofructokinase, platelet', NULL, NULL, NULL, NULL, NULL, 4),
(98067, NULL, 'G3DSA:3.30.70.1130:FF:000006', NULL, NULL, 'Eukaryotic translation initiation factor 2 alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98068, NULL, 'G3DSA:1.20.1250.20:FF:001097', NULL, NULL, 'GM15184', NULL, NULL, NULL, NULL, NULL, 4),
(98069, NULL, 'G3DSA:2.60.40.10:FF:003667', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98070, NULL, 'G3DSA:3.80.10.10:FF:000677', NULL, NULL, 'Si:dkey-205i10.1', NULL, NULL, NULL, NULL, NULL, 4),
(98071, NULL, 'G3DSA:3.30.230.130:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98072, NULL, 'G3DSA:1.20.80.10:FF:000054', NULL, NULL, 'Acyl-CoA-binding domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(98073, NULL, 'G3DSA:3.10.20.90:FF:000351', NULL, NULL, 'Cell division control protein 24', NULL, NULL, NULL, NULL, NULL, 4),
(98074, NULL, 'G3DSA:3.30.160.20:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98075, NULL, 'G3DSA:1.25.70.10:FF:000009', NULL, NULL, 'BnaA09g42960D protein', NULL, NULL, NULL, NULL, NULL, 4),
(98076, NULL, 'G3DSA:2.60.40.10:FF:000441', NULL, NULL, 'TEK receptor tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(98077, NULL, 'G3DSA:3.90.70.10:FF:000192', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(98078, NULL, 'G3DSA:3.20.20.190:FF:000176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98079, NULL, 'G3DSA:3.40.630.10:FF:000224', NULL, NULL, 'Clan MH, family M18, aspartyl aminopeptidase-like metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(98080, NULL, 'G3DSA:3.40.50.11840:FF:000006', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(98081, NULL, 'G3DSA:3.30.870.10:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98082, NULL, 'G3DSA:1.20.1250.20:FF:001046', NULL, NULL, 'Peptide transporter family 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(98083, NULL, 'G3DSA:2.70.98.30:FF:000028', NULL, NULL, 'Lysosomal alpha-mannosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98084, NULL, 'G3DSA:2.70.98.10:FF:000040', NULL, NULL, 'Aldose 1-epimerase (Mutarotase)', NULL, NULL, NULL, NULL, NULL, 4),
(98085, NULL, 'G3DSA:3.40.50.300:FF:001037', NULL, NULL, 'DNA repair protein RAD50', NULL, NULL, NULL, NULL, NULL, 4),
(98086, NULL, 'G3DSA:3.40.50.300:FF:002465', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(98087, NULL, 'G3DSA:3.50.50.60:FF:000191', NULL, NULL, 'Monooxygenase ethA', NULL, NULL, NULL, NULL, NULL, 4),
(98088, NULL, 'G3DSA:2.40.70.10:FF:000432', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98089, NULL, 'G3DSA:1.10.287.70:FF:000587', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98090, NULL, 'G3DSA:1.20.1050.20:FF:000008', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(98091, NULL, 'G3DSA:1.25.40.10:FF:001289', NULL, NULL, 'Putative pentatricopeptide (PPR) repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(98092, NULL, 'G3DSA:3.30.70.1180:FF:000009', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(98093, NULL, 'G3DSA:3.30.160.60:FF:003212', NULL, NULL, 'Zinc finger protein 367', NULL, NULL, NULL, NULL, NULL, 4),
(98094, NULL, 'G3DSA:1.20.1070.10:FF:000282', NULL, NULL, 'Dopamine receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(98095, NULL, 'G3DSA:3.30.160.60:FF:002695', NULL, NULL, 'AGAP001987-PA', NULL, NULL, NULL, NULL, NULL, 4),
(98096, NULL, 'G3DSA:2.10.25.10:FF:001245', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(98097, NULL, 'G3DSA:3.30.200.20:FF:001630', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98098, NULL, 'G3DSA:1.10.510.10:FF:003091', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98099, NULL, 'G3DSA:3.40.50.300:FF:004022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98100, NULL, 'G3DSA:2.120.10.30:FF:000341', NULL, NULL, 'Peptidase S9 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(98101, NULL, 'G3DSA:2.30.30.40:FF:000411', NULL, NULL, 'Cell death abnormality protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(98102, NULL, 'G3DSA:1.10.510.10:FF:002534', NULL, NULL, 'Putative serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(98103, NULL, 'G3DSA:3.30.830.10:FF:000230', NULL, NULL, 'Insulin degrading enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(98104, NULL, 'G3DSA:2.60.40.60:FF:000444', NULL, NULL, 'Cadherin-99C', NULL, NULL, NULL, NULL, NULL, 4),
(98105, NULL, 'G3DSA:3.80.10.10:FF:003819', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98106, NULL, 'G3DSA:1.20.200.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98107, NULL, 'G3DSA:3.40.630.30:FF:000382', NULL, NULL, 'Protein CBG11814', NULL, NULL, NULL, NULL, NULL, 4),
(98108, NULL, 'G3DSA:2.10.60.10:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98109, NULL, 'G3DSA:1.10.10.10:FF:001882', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98110, NULL, 'G3DSA:1.10.437.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98111, NULL, 'G3DSA:1.10.3380.20:FF:000007', NULL, NULL, 'HELicase Q homolog', NULL, NULL, NULL, NULL, NULL, 4),
(98112, NULL, 'G3DSA:1.25.10.10:FF:002130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98113, NULL, 'G3DSA:1.25.10.10:FF:000213', NULL, NULL, 'Rotatin', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(98114, NULL, 'G3DSA:3.90.226.10:FF:000043', NULL, NULL, 'carboxyl-terminal-processing peptidase 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(98115, NULL, 'G3DSA:1.10.287.130:FF:000116', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(98116, NULL, 'G3DSA:3.30.40.10:FF:001075', NULL, NULL, 'GM25045', NULL, NULL, NULL, NULL, NULL, 4),
(98117, NULL, 'G3DSA:3.40.250.10:FF:000178', NULL, NULL, 'Sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(98118, NULL, 'G3DSA:2.160.20.10:FF:000120', NULL, NULL, 'Os07g0208100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(98119, NULL, 'G3DSA:2.40.50.140:FF:000043', NULL, NULL, 'DNA-directed RNA polymerase II subunit RPB7', NULL, NULL, NULL, NULL, NULL, 4),
(98120, NULL, 'G3DSA:3.40.50.300:FF:008597', NULL, NULL, '26S protease regulatory subunit 6A homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(98121, NULL, 'G3DSA:1.25.40.20:FF:001067', NULL, NULL, 'Nudix (Nucleoside diphosphate linked moiety X)-type motif 12 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(98122, NULL, 'G3DSA:3.30.420.40:FF:000219', NULL, NULL, 'Actin-related protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(98123, NULL, 'G3DSA:3.30.70.920:FF:000032', NULL, NULL, 'AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(98124, NULL, 'G3DSA:2.60.120.290:FF:000091', NULL, NULL, 'Cubilin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(98125, NULL, 'G3DSA:3.30.70.240:FF:000042', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(98126, NULL, 'G3DSA:3.80.10.10:FF:003078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98127, NULL, 'G3DSA:1.10.10.10:FF:000533', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(98128, NULL, 'G3DSA:1.10.510.10:FF:004451', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98129, NULL, 'G3DSA:3.40.50.300:FF:008237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98130, NULL, 'G3DSA:2.70.150.10:FF:000196', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98131, NULL, 'G3DSA:3.30.160.60:FF:000339', NULL, NULL, 'zinc finger protein 300', NULL, NULL, NULL, NULL, NULL, 4),
(98132, NULL, 'G3DSA:3.30.200.20:FF:002086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98133, NULL, 'G3DSA:3.30.870.10:FF:000143', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(98134, NULL, 'G3DSA:1.10.340.30:FF:000003', NULL, NULL, 'A/G-specific adenine glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(98135, NULL, 'G3DSA:3.50.30.40:FF:000003', NULL, NULL, '4-hydroxy-4-methyl-2-oxoglutarate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(98136, NULL, 'G3DSA:3.80.10.10:FF:003971', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98137, NULL, 'G3DSA:2.60.120.200:FF:000053', NULL, NULL, 'Laminin subunit alpha 4', NULL, NULL, NULL, NULL, NULL, 4),
(98138, NULL, 'G3DSA:3.40.50.1440:FF:000029', NULL, NULL, 'Cell division protein FtsZ', NULL, NULL, NULL, NULL, NULL, 4),
(98139, NULL, 'G3DSA:2.30.30.40:FF:000462', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98140, NULL, 'G3DSA:3.40.50.970:FF:000108', NULL, NULL, '2-oxoisovalerate dehydrogenase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(98141, NULL, 'G3DSA:3.10.180.10:FF:000038', NULL, NULL, '3,4-dihydroxyphenylacetate 2,3-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(98142, NULL, 'G3DSA:1.10.720.30:FF:000049', NULL, NULL, 'Zinc finger CCCH domain-containing protein 62', NULL, NULL, NULL, NULL, NULL, 4),
(98143, NULL, 'G3DSA:3.90.180.10:FF:000037', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(98144, NULL, 'G3DSA:2.60.490.10:FF:000009', NULL, NULL, 'P2X purinoceptor', NULL, NULL, NULL, NULL, NULL, 4),
(98145, NULL, 'G3DSA:3.10.100.10:FF:000438', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98146, NULL, 'G3DSA:2.60.120.260:FF:000076', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(98147, NULL, 'G3DSA:2.130.10.10:FF:003471', NULL, NULL, 'Apoptotic protease-activating factor 1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(98148, NULL, 'G3DSA:3.50.50.60:FF:001180', NULL, NULL, 'NADPH:adrenodoxin oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98149, NULL, 'G3DSA:3.40.50.10810:FF:000170', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98150, NULL, 'G3DSA:1.25.40.10:FF:004195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98151, NULL, 'G3DSA:3.30.505.10:FF:000172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98152, NULL, 'G3DSA:3.30.40.10:FF:000586', NULL, NULL, 'Traf3, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(98153, NULL, 'G3DSA:2.130.10.10:FF:005769', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98154, NULL, 'G3DSA:3.30.70.20:FF:000124', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98155, NULL, 'G3DSA:3.90.70.10:FF:000580', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(98156, NULL, 'G3DSA:3.80.10.10:FF:003550', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98157, NULL, 'G3DSA:2.130.10.10:FF:004460', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98158, NULL, 'G3DSA:3.40.109.10:FF:000035', NULL, NULL, 'Nitroreductase', NULL, NULL, NULL, NULL, NULL, 4),
(98159, NULL, 'G3DSA:3.40.50.300:FF:005371', NULL, NULL, 'Primosomal protein N''', NULL, NULL, NULL, NULL, NULL, 4),
(98160, NULL, 'G3DSA:3.80.10.10:FF:003027', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98161, NULL, 'G3DSA:1.10.510.10:FF:003995', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98162, NULL, 'G3DSA:3.30.890.10:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98163, NULL, 'G3DSA:1.10.510.10:FF:001966', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98164, NULL, 'G3DSA:2.180.10.10:FF:000012', NULL, NULL, 'Teneurin transmembrane protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(98165, NULL, 'G3DSA:3.60.15.10:FF:000251', NULL, NULL, 'Ribonuclease Z', NULL, NULL, NULL, NULL, NULL, 4),
(98166, NULL, 'G3DSA:1.20.120.1770:FF:000006', NULL, NULL, 'Blast:Putative ferric-chelate reductase 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(98167, NULL, 'G3DSA:2.40.160.10:FF:000057', NULL, NULL, 'Putative mitochondrial outer membrane protein porin 5', NULL, NULL, NULL, NULL, NULL, 4),
(98168, NULL, 'G3DSA:3.40.50.300:FF:004882', NULL, NULL, 'DEAH-box helicase 35', NULL, NULL, NULL, NULL, NULL, 4),
(98169, NULL, 'G3DSA:3.40.50.620:FF:000138', NULL, NULL, 'Tryptophan--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(98170, NULL, 'G3DSA:3.30.40.10:FF:000086', NULL, NULL, 'PHD finger protein 14 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(98171, NULL, 'G3DSA:1.10.287.130:FF:000167', NULL, NULL, 'Sensor histide kinase', NULL, NULL, NULL, NULL, NULL, 4),
(98172, NULL, 'G3DSA:2.70.150.10:FF:000145', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(98173, NULL, 'G3DSA:1.25.40.120:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98174, NULL, 'G3DSA:3.90.70.10:FF:000080', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 15', NULL, NULL, NULL, NULL, NULL, 4),
(98175, NULL, 'G3DSA:2.130.10.10:FF:005657', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98176, NULL, 'G3DSA:1.10.260.30:FF:000002', NULL, NULL, 'Signal recognition particle 54 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(98177, NULL, 'G3DSA:2.10.60.10:FF:000034', NULL, NULL, 'Sperm acrosome associated 4', NULL, NULL, NULL, NULL, NULL, 4),
(98178, NULL, 'G3DSA:1.10.565.10:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98179, NULL, 'G3DSA:1.25.40.10:FF:005100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98180, NULL, 'G3DSA:1.25.40.10:FF:000833', NULL, NULL, 'Tetratricopeptide repeat (TPR)-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(98181, NULL, 'G3DSA:3.40.640.10:FF:000101', NULL, NULL, 'Serine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(98182, NULL, 'G3DSA:3.40.50.2300:FF:000484', NULL, NULL, 'Transcriptional regulator, LuxR family', NULL, NULL, NULL, NULL, NULL, 4),
(98183, NULL, 'G3DSA:1.20.1420.10:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98184, NULL, 'G3DSA:1.10.530.10:FF:000068', NULL, NULL, 'Acidic endochitinase WIN6.2B', NULL, NULL, NULL, NULL, NULL, 4),
(98185, NULL, 'G3DSA:2.60.40.150:FF:000826', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98186, NULL, 'G3DSA:3.40.50.1820:FF:000115', NULL, NULL, 'Poly depolymerase', NULL, NULL, NULL, NULL, NULL, 4),
(98187, NULL, 'G3DSA:2.120.10.30:FF:000453', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98188, NULL, 'G3DSA:3.40.1050.10:FF:000010', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(98189, NULL, 'G3DSA:2.30.29.30:FF:000337', NULL, NULL, 'Protein still life, isoform SIF type', NULL, NULL, NULL, NULL, NULL, 4),
(98190, NULL, 'G3DSA:2.130.10.10:FF:004308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98191, NULL, 'G3DSA:1.10.510.10:FF:004080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98192, NULL, 'G3DSA:1.10.260.50:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98193, NULL, 'G3DSA:1.20.5.170:FF:000026', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(98194, NULL, 'G3DSA:2.170.16.10:FF:000020', NULL, NULL, 'Probable translation initiation factor IF-2', NULL, NULL, NULL, NULL, NULL, 4),
(98195, NULL, 'G3DSA:1.10.10.10:FF:000033', NULL, NULL, 'DNA-binding response regulator MtrA', NULL, NULL, NULL, NULL, NULL, 4),
(98196, NULL, 'G3DSA:3.30.230.70:FF:000051', NULL, NULL, 'Exosome complex exonuclease RRP42, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98197, NULL, 'G3DSA:3.30.60.90:FF:000015', NULL, NULL, 'Transcriptional coactivator ADA2', NULL, NULL, NULL, NULL, NULL, 4),
(98198, NULL, 'G3DSA:2.120.10.30:FF:000392', NULL, NULL, 'Low-density lipoprotein RecePtor related', NULL, NULL, NULL, NULL, NULL, 4),
(98199, NULL, 'G3DSA:1.10.455.10:FF:000022', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(98200, NULL, 'G3DSA:2.30.30.40:FF:000523', NULL, NULL, 'BAR domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(98201, NULL, 'G3DSA:3.40.50.300:FF:007248', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98202, NULL, 'G3DSA:2.60.120.10:FF:000342', NULL, NULL, 'Plant cysteine oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(98203, NULL, 'G3DSA:1.10.287.110:FF:000161', NULL, NULL, 'Small t antigen', NULL, NULL, NULL, NULL, NULL, 4),
(98204, NULL, 'G3DSA:3.90.190.10:FF:000274', NULL, NULL, 'Uncharacterized protein MJ0215', NULL, NULL, NULL, NULL, NULL, 4),
(98205, NULL, 'G3DSA:2.130.10.10:FF:005718', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98206, NULL, 'G3DSA:2.130.10.10:FF:000986', NULL, NULL, 'COMPASS component SWD2', NULL, NULL, NULL, NULL, NULL, 4),
(98207, NULL, 'G3DSA:2.60.120.970:FF:000081', NULL, NULL, 'Transforming growth factor beta, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98208, NULL, 'G3DSA:1.10.287.370:FF:000008', NULL, NULL, 'unconventional prefoldin RPB5 interactor 1', NULL, NULL, NULL, NULL, NULL, 4),
(98209, NULL, 'G3DSA:3.80.10.10:FF:004488', NULL, NULL, 'Putative leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(98210, NULL, 'G3DSA:3.30.160.60:FF:000278', NULL, NULL, 'zinc finger and BTB domain-containing protein 44 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(98211, NULL, 'G3DSA:3.30.2320.20:FF:000003', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98212, NULL, 'G3DSA:1.25.10.10:FF:000101', NULL, NULL, 'TATA-binding protein-associated factor 172 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(98213, NULL, 'G3DSA:1.10.10.60:FF:000975', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98214, NULL, 'G3DSA:2.60.40.1730:FF:000112', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98215, NULL, 'G3DSA:2.60.40.60:FF:000883', NULL, NULL, 'Cadherin 23', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(98216, NULL, 'G3DSA:1.25.40.20:FF:001567', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(98217, NULL, 'G3DSA:3.90.550.10:FF:000257', NULL, NULL, 'Alpha-1,6-mannosyl-glycoprotein 2-beta-N-acetylglucosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(98218, NULL, 'G3DSA:3.40.50.150:FF:000918', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98219, NULL, 'G3DSA:1.20.120.1920:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98220, NULL, 'G3DSA:3.40.50.300:FF:000548', NULL, NULL, 'ADP-ribosylation factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(98221, NULL, 'G3DSA:2.60.40.10:FF:003588', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98222, NULL, 'G3DSA:2.130.10.10:FF:003920', NULL, NULL, 'WD repeat domain 74', NULL, NULL, NULL, NULL, NULL, 4),
(98223, NULL, 'G3DSA:2.40.100.10:FF:000109', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(98224, NULL, 'G3DSA:3.40.50.720:FF:001450', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98225, NULL, 'G3DSA:1.20.5.190:FF:000133', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98226, NULL, 'G3DSA:2.10.90.10:FF:000154', NULL, NULL, 'Nodal-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(98227, NULL, 'G3DSA:3.40.50.720:FF:000882', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98228, NULL, 'G3DSA:1.20.120.430:FF:000013', NULL, NULL, 'GTPase mss1/trme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98229, NULL, 'G3DSA:2.10.70.10:FF:000203', NULL, NULL, 'sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(98230, NULL, 'G3DSA:3.80.10.10:FF:001554', NULL, NULL, 'Flagellar_Member_5', NULL, NULL, NULL, NULL, NULL, 4),
(98231, NULL, 'G3DSA:3.30.420.40:FF:000303', NULL, NULL, 'Heat shock protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98232, NULL, 'G3DSA:2.60.120.10:FF:000746', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98233, NULL, 'G3DSA:1.20.58.830:FF:000038', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(98234, NULL, 'G3DSA:3.40.50.300:FF:006731', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98235, NULL, 'G3DSA:3.30.40.10:FF:001103', NULL, NULL, 'Homeodomain protein', NULL, NULL, NULL, NULL, NULL, 4),
(98236, NULL, 'G3DSA:1.10.132.20:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98237, NULL, 'G3DSA:1.20.58.60:FF:000629', NULL, NULL, 'Spectrin repeat-containing, nuclear envelope 1b', NULL, NULL, NULL, NULL, NULL, 4),
(98238, NULL, 'G3DSA:1.10.510.10:FF:002034', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(98239, NULL, 'G3DSA:1.10.287.660:FF:000039', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98240, NULL, 'G3DSA:3.40.30.10:FF:001057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98241, NULL, 'G3DSA:1.25.40.10:FF:003655', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98242, NULL, 'G3DSA:1.10.287.410:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98243, NULL, 'G3DSA:1.10.10.60:FF:001043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98244, NULL, 'G3DSA:3.10.580.10:FF:000018', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(98245, NULL, 'G3DSA:3.40.50.2300:FF:001552', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98246, NULL, 'G3DSA:3.90.190.10:FF:000206', NULL, NULL, 'Leucine rich repeat and phosphatase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(98247, NULL, 'G3DSA:2.60.40.150:FF:000377', NULL, NULL, 'Synaptotagmin Ib', NULL, NULL, NULL, NULL, NULL, 4),
(98248, NULL, 'G3DSA:3.30.70.120:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98249, NULL, 'G3DSA:3.40.630.10:FF:000196', NULL, NULL, 'glutaminyl-peptide cyclotransferase isoform X1', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(98250, NULL, 'G3DSA:1.10.10.10:FF:001961', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98251, NULL, 'G3DSA:3.10.129.10:FF:000133', NULL, NULL, 'PaaI family thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(98252, NULL, 'G3DSA:3.40.1190.20:FF:000057', NULL, NULL, 'Aminoimidazole riboside kinase', NULL, NULL, NULL, NULL, NULL, 4),
(98253, NULL, 'G3DSA:1.10.730.10:FF:000049', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(98254, NULL, 'G3DSA:1.20.120.980:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98255, NULL, 'G3DSA:3.30.450.20:FF:000333', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(98256, NULL, 'G3DSA:2.60.40.60:FF:000091', NULL, NULL, 'Desmocollin 1', NULL, NULL, NULL, NULL, NULL, 4),
(98257, NULL, 'G3DSA:1.20.58.420:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98258, NULL, 'G3DSA:3.30.70.580:FF:000059', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(98259, NULL, 'G3DSA:1.25.10.10:FF:003086', NULL, NULL, 'Plakophilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(98260, NULL, 'G3DSA:3.40.50.1100:FF:000225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98261, NULL, 'G3DSA:2.40.10.10:FF:000395', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98262, NULL, 'G3DSA:1.10.8.270:FF:000087', NULL, NULL, 'GTPase activator-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(98263, NULL, 'G3DSA:2.10.25.10:FF:001184', NULL, NULL, 'Neurogenic locus notch homolog protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(98264, NULL, 'G3DSA:1.10.1670.10:FF:000026', NULL, NULL, 'Endonuclease III homolog', NULL, NULL, NULL, NULL, NULL, 4),
(98265, NULL, 'G3DSA:2.60.120.200:FF:000114', NULL, NULL, 'Probable endo-1,3(4)-beta-glucanase NFIA_089530', NULL, NULL, NULL, NULL, NULL, 4),
(98266, NULL, 'G3DSA:3.30.750.24:FF:000018', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(98267, NULL, 'G3DSA:2.20.90.10:FF:000013', NULL, NULL, 'Uncharacterized LOC495702', NULL, NULL, NULL, NULL, NULL, 4),
(98268, NULL, 'G3DSA:1.25.40.10:FF:000041', NULL, NULL, 'Co-chaperone YbbN', NULL, NULL, NULL, NULL, NULL, 4),
(98269, NULL, 'G3DSA:3.10.580.10:FF:000198', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98270, NULL, 'G3DSA:2.130.10.10:FF:005269', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98271, NULL, 'G3DSA:1.20.1080.10:FF:000007', NULL, NULL, 'Aquaporin Z', NULL, NULL, NULL, NULL, NULL, 4),
(98272, NULL, 'G3DSA:3.30.200.20:FF:002170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98273, NULL, 'G3DSA:2.60.40.150:FF:000085', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(98274, NULL, 'G3DSA:1.10.3210.10:FF:000060', NULL, NULL, 'Metal dependent phosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(98275, NULL, 'G3DSA:3.80.10.10:FF:002122', NULL, NULL, 'X-ray radiation resistance-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(98276, NULL, 'G3DSA:3.40.1770.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98277, NULL, 'G3DSA:1.10.510.10:FF:002455', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98278, NULL, 'G3DSA:3.30.160.60:FF:002756', NULL, NULL, 'Zinc finger protein 1159', NULL, NULL, NULL, NULL, NULL, 4),
(98279, NULL, 'G3DSA:2.120.10.30:FF:000402', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98280, NULL, 'G3DSA:2.130.10.10:FF:003971', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98281, NULL, 'G3DSA:1.20.1740.10:FF:000187', NULL, NULL, 'Os12g0613100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(98282, NULL, 'G3DSA:1.20.1250.20:FF:001917', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98283, NULL, 'G3DSA:2.60.40.60:FF:000995', NULL, NULL, 'Protein CBR-CDH-12', NULL, NULL, NULL, NULL, NULL, 4),
(98284, NULL, 'G3DSA:3.30.1370.110:FF:000029', NULL, NULL, 'Smr/MutS family protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(98285, NULL, 'G3DSA:3.40.630.30:FF:000022', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(98286, NULL, 'G3DSA:3.90.550.10:FF:000757', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98287, NULL, 'G3DSA:3.40.50.2000:FF:001001', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(98288, NULL, 'G3DSA:2.40.50.100:FF:000059', NULL, NULL, 'Biotin/lipoyl attachment domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(98289, NULL, 'G3DSA:2.60.40.150:FF:000034', NULL, NULL, 'otoferlin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(98290, NULL, 'G3DSA:3.20.20.70:FF:000024', NULL, NULL, 'Indole-3-glycerol phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(98291, NULL, 'G3DSA:2.30.30.40:FF:000023', NULL, NULL, 'RIMS-binding protein 2 isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(98292, NULL, 'G3DSA:1.10.630.10:FF:000665', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98293, NULL, 'G3DSA:3.10.110.10:FF:000383', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98294, NULL, 'G3DSA:2.130.10.10:FF:001054', NULL, NULL, 'Transducin (beta)-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(98295, NULL, 'G3DSA:3.30.1250.10:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98296, NULL, 'G3DSA:3.90.79.10:FF:000161', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(98297, NULL, 'G3DSA:1.25.40.10:FF:000333', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(98298, NULL, 'G3DSA:1.20.58.1030:FF:000035', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98299, NULL, 'G3DSA:1.10.20.10:FF:000247', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98300, NULL, 'G3DSA:2.130.10.10:FF:001150', NULL, NULL, 'WD repeat-containing protein 37', NULL, NULL, NULL, NULL, NULL, 4),
(98301, NULL, 'G3DSA:1.20.5.710:FF:000003', NULL, NULL, '50S ribosomal protein L7/L12', NULL, NULL, NULL, NULL, NULL, 4),
(98302, NULL, 'G3DSA:2.30.42.10:FF:000435', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98303, NULL, 'G3DSA:1.25.40.10:FF:003998', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98304, NULL, 'G3DSA:3.40.50.10130:FF:000033', NULL, NULL, 'Crossover junction endonuclease EME1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(98305, NULL, 'G3DSA:3.30.160.60:FF:000778', NULL, NULL, 'PR/SET domain 6', NULL, NULL, NULL, NULL, NULL, 4),
(98306, NULL, 'G3DSA:3.90.79.10:FF:000009', NULL, NULL, 'Isopentenyl-diphosphate Delta-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(98307, NULL, 'G3DSA:2.60.40.60:FF:000383', NULL, NULL, 'Protocadherin Fat', NULL, NULL, NULL, NULL, NULL, 4),
(98308, NULL, 'G3DSA:2.10.25.10:FF:001796', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98309, NULL, 'G3DSA:3.30.70.1230:FF:000278', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98310, NULL, 'G3DSA:1.10.150.380:FF:000001', NULL, NULL, 'Aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(98311, NULL, 'G3DSA:2.40.160.120:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98312, NULL, 'G3DSA:1.20.1070.10:FF:000214', NULL, NULL, 'Neuromedin U receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(98313, NULL, 'G3DSA:3.90.1530.10:FF:000013', NULL, NULL, 'Sulfiredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(98314, NULL, 'G3DSA:3.30.160.60:FF:004605', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98315, NULL, 'G3DSA:1.10.3470.10:FF:000045', NULL, NULL, 'ABC transporter, permease protein, FecCD family', NULL, NULL, NULL, NULL, NULL, 4),
(98316, NULL, 'G3DSA:3.30.450.40:FF:000131', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(98317, NULL, 'G3DSA:3.40.190.10:FF:000791', NULL, NULL, 'Oligopeptide transport system binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(98318, NULL, 'G3DSA:2.60.40.10:FF:005112', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(98319, NULL, 'G3DSA:1.25.40.10:FF:001890', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(98320, NULL, 'G3DSA:3.30.160.60:FF:004313', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98321, NULL, 'G3DSA:1.20.1250.20:FF:000557', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(98322, NULL, 'G3DSA:1.10.510.10:FF:000909', NULL, NULL, 'Calmodulin-dependent protein kinase I, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98323, NULL, 'G3DSA:2.30.30.1040:FF:000002', NULL, NULL, 'Auxin response factor', NULL, NULL, NULL, NULL, NULL, 4),
(98324, NULL, 'G3DSA:1.25.10.10:FF:003035', NULL, NULL, 'Nuclear pre-mRNA splicing factor, component of splicing factor 3b', NULL, NULL, NULL, NULL, NULL, 4),
(98325, NULL, 'G3DSA:1.10.1670.10:FF:000077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98326, NULL, 'G3DSA:3.30.40.10:FF:000827', NULL, NULL, 'probable E3 ubiquitin-protein ligase TRIM8', NULL, NULL, NULL, NULL, NULL, 4),
(98327, NULL, 'G3DSA:1.10.520.10:FF:000062', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(98328, NULL, 'G3DSA:3.90.70.40:FF:000004', NULL, NULL, 'ataxin-3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(98329, NULL, 'G3DSA:1.20.120.1510:FF:000007', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(98330, NULL, 'G3DSA:3.40.50.2300:FF:000984', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98331, NULL, 'G3DSA:1.10.238.10:FF:000017', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(98332, NULL, 'G3DSA:3.50.50.60:FF:000123', NULL, NULL, '2-octaprenyl-6-methoxyphenyl hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(98333, NULL, 'G3DSA:3.30.40.10:FF:000535', NULL, NULL, 'Chromatin modification-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(98334, NULL, 'G3DSA:3.40.50.2300:FF:000888', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98335, NULL, 'G3DSA:3.30.70.330:FF:002334', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98336, NULL, 'G3DSA:1.10.357.10:FF:000041', NULL, NULL, 'TetR/AcrR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(98337, NULL, 'G3DSA:2.40.10.10:FF:000344', NULL, NULL, 'Plasminogen activator, urokinase', NULL, NULL, NULL, NULL, NULL, 4),
(98338, NULL, 'G3DSA:3.90.190.10:FF:000386', NULL, NULL, 'Protein-tyrosine-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(98339, NULL, 'G3DSA:2.60.40.10:FF:004605', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98340, NULL, 'G3DSA:3.40.50.620:FF:000638', NULL, NULL, 'tRNA 5-methylaminomethyl-2-thiouridylate methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(98341, NULL, 'G3DSA:2.70.130.10:FF:000115', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98342, NULL, 'G3DSA:3.40.50.300:FF:008529', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98343, NULL, 'G3DSA:1.10.510.10:FF:003883', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98344, NULL, 'G3DSA:2.120.10.80:FF:000035', NULL, NULL, 'Muskelin 1', NULL, NULL, NULL, NULL, NULL, 4),
(98345, NULL, 'G3DSA:3.40.50.1440:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98346, NULL, 'G3DSA:1.10.10.10:FF:000421', NULL, NULL, 'Embryo defective 1379', NULL, NULL, NULL, NULL, NULL, 4),
(98347, NULL, 'G3DSA:3.40.640.10:FF:000022', NULL, NULL, 'Glutamate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(98348, NULL, 'G3DSA:3.40.50.980:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98349, NULL, 'G3DSA:1.20.1070.10:FF:001642', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(98350, NULL, 'G3DSA:1.50.10.10:FF:000088', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(98351, NULL, 'G3DSA:3.40.1280.10:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98352, NULL, 'G3DSA:3.40.50.2000:FF:001052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(98353, NULL, 'G3DSA:2.20.70.10:FF:000181', NULL, NULL, 'Reticulocyte-binding protein 2-like protein a', NULL, NULL, NULL, NULL, NULL, 4),
(98354, NULL, 'G3DSA:3.20.20.140:FF:000482', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98355, NULL, 'G3DSA:3.30.750.24:FF:000170', NULL, NULL, 'Probable sulfate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(98356, NULL, 'G3DSA:2.30.29.30:FF:001405', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98357, NULL, 'G3DSA:3.30.70.1450:FF:000052', NULL, NULL, 'Membrane protein, TrkA-C domain pair-containing', NULL, NULL, NULL, NULL, NULL, 4),
(98358, NULL, 'G3DSA:3.30.70.330:FF:000001', NULL, NULL, '50S ribosomal protein L23', NULL, NULL, NULL, NULL, NULL, 4),
(98359, NULL, 'G3DSA:1.20.1250.20:FF:001838', NULL, NULL, 'Sodium-dependent glucose transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98360, NULL, 'G3DSA:1.25.40.530:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98361, NULL, 'G3DSA:2.130.10.130:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98362, NULL, 'G3DSA:3.40.140.10:FF:000288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98363, NULL, 'G3DSA:2.60.40.790:FF:000102', NULL, NULL, 'Inactive protein RESTRICTED TEV MOVEMENT 2', NULL, NULL, NULL, NULL, NULL, 4),
(98364, NULL, 'G3DSA:3.40.50.1000:FF:000521', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98365, NULL, 'G3DSA:1.10.472.10:FF:000112', NULL, NULL, 'D1-type cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(98366, NULL, 'G3DSA:3.40.1160.10:FF:000108', NULL, NULL, 'Aspartate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(98367, NULL, 'G3DSA:1.10.287.2900:FF:000010', NULL, NULL, 'Protein CBG19950', NULL, NULL, NULL, NULL, NULL, 4),
(98368, NULL, 'G3DSA:3.20.20.140:FF:000122', NULL, NULL, 'Probable allantoinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(98369, NULL, 'G3DSA:3.30.200.20:FF:002198', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98370, NULL, 'G3DSA:1.20.1530.20:FF:000039', NULL, NULL, 'Transporter, CPA2 family', NULL, NULL, NULL, NULL, NULL, 4),
(98371, NULL, 'G3DSA:3.40.50.150:FF:000065', NULL, NULL, 'Phenylethanolamine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(98372, NULL, 'G3DSA:3.90.1580.10:FF:000016', NULL, NULL, 'Sulfatase-modifying factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(98373, NULL, 'G3DSA:3.30.1330.10:FF:000006', NULL, NULL, 'Selenide water dikinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(98374, NULL, 'G3DSA:2.60.40.10:FF:005292', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98375, NULL, 'G3DSA:2.60.120.200:FF:000165', NULL, NULL, 'Calpain-type cysteine protease DEK1', NULL, NULL, NULL, NULL, NULL, 4),
(98376, NULL, 'G3DSA:1.20.1250.20:FF:002114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98377, NULL, 'G3DSA:2.40.40.50:FF:000004', NULL, NULL, 'Ubiquitin fusion degradation protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98378, NULL, 'G3DSA:3.40.50.300:FF:003858', NULL, NULL, 'ABC transporter, eXtended', NULL, NULL, NULL, NULL, NULL, 4),
(98379, NULL, 'G3DSA:3.30.930.10:FF:000294', NULL, NULL, 'tRNA synthetases class II-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(98380, NULL, 'G3DSA:3.40.50.720:FF:001399', NULL, NULL, 'IMP dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(98381, NULL, 'G3DSA:2.60.200.20:FF:000233', NULL, NULL, 'Aprataxin', NULL, NULL, NULL, NULL, NULL, 4),
(98382, NULL, 'G3DSA:2.130.10.10:FF:005365', NULL, NULL, 'chromatin assembly factor 1 subunit B-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(98383, NULL, 'G3DSA:3.20.10.10:FF:000056', NULL, NULL, 'Branched-chain amino acid aminotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98384, NULL, 'G3DSA:3.10.450.10:FF:000014', NULL, NULL, 'Retinoic acid receptor responder 2', NULL, NULL, NULL, NULL, NULL, 4),
(98385, NULL, 'G3DSA:3.30.720.210:FF:000001', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(98386, NULL, 'G3DSA:2.60.40.10:FF:004656', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(98387, NULL, 'G3DSA:3.30.559.70:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98388, NULL, 'G3DSA:1.10.1200.10:FF:000115', NULL, NULL, 'Probable acyl carrier protein PigG', NULL, NULL, NULL, NULL, NULL, 4),
(98389, NULL, 'G3DSA:2.40.50.100:FF:000138', NULL, NULL, 'Efflux transporter, RND family, MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(98390, NULL, 'G3DSA:1.25.40.20:FF:000611', NULL, NULL, 'Related to transcription factor MBP1', NULL, NULL, NULL, NULL, NULL, 4),
(98391, NULL, 'G3DSA:1.20.80.40:FF:000001', NULL, NULL, 'Pre-mRNA-processing-splicing factor 8', NULL, NULL, NULL, NULL, NULL, 4),
(98392, NULL, 'G3DSA:1.10.287.70:FF:000536', NULL, NULL, 'Two-pore potassium channel 1', NULL, NULL, NULL, NULL, NULL, 4),
(98393, NULL, 'G3DSA:1.25.40.10:FF:001789', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(98394, NULL, 'G3DSA:1.10.510.10:FF:004372', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98395, NULL, 'G3DSA:3.60.21.10:FF:000304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98396, NULL, 'G3DSA:3.40.50.1260:FF:000020', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(98397, NULL, 'G3DSA:3.40.50.720:FF:000090', NULL, NULL, 'NADP-dependent mannitol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(98398, NULL, 'G3DSA:1.50.10.10:FF:000037', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(98399, NULL, 'G3DSA:1.25.40.10:FF:002227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98400, NULL, 'G3DSA:3.40.720.10:FF:000023', NULL, NULL, 'Arylsulfatase A', NULL, NULL, NULL, NULL, NULL, 4),
(98401, NULL, 'G3DSA:3.40.50.150:FF:000014', NULL, NULL, 'Ubiquinone/menaquinone biosynthesis C-methyltransferase UbiE', NULL, NULL, NULL, NULL, NULL, 4),
(98402, NULL, 'G3DSA:2.60.40.10:FF:000733', NULL, NULL, 'Turtle, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(98403, NULL, 'G3DSA:2.20.25.10:FF:000087', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(98404, NULL, 'G3DSA:3.10.660.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98405, NULL, 'G3DSA:2.60.120.330:FF:000237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98406, NULL, 'G3DSA:4.10.1060.10:FF:000028', NULL, NULL, 'E3 ubiquitin-protein ligase RNF31', NULL, NULL, NULL, NULL, NULL, 4),
(98407, NULL, 'G3DSA:2.10.230.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98408, NULL, 'G3DSA:3.30.559.30:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98409, NULL, 'G3DSA:3.40.50.300:FF:003033', NULL, NULL, 'P-type conjugative transfer ATPase TrbB', NULL, NULL, NULL, NULL, NULL, 4),
(98410, NULL, 'G3DSA:1.20.1110.10:FF:000218', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98411, NULL, 'G3DSA:3.40.50.150:FF:000986', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(98412, NULL, 'G3DSA:3.40.50.150:FF:000626', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98413, NULL, 'G3DSA:3.90.70.10:FF:000872', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98414, NULL, 'G3DSA:3.30.565.10:FF:000529', NULL, NULL, 'Histidine kinase sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(98415, NULL, 'G3DSA:3.80.10.10:FF:000273', NULL, NULL, 'Leucine Rich Repeat domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(98416, NULL, 'G3DSA:3.30.200.20:FF:000169', NULL, NULL, 'kalirin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(98417, NULL, 'G3DSA:1.10.510.10:FF:000117', NULL, NULL, 'dual specificity tyrosine-phosphorylation-regulated kinase 1A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(98418, NULL, 'G3DSA:3.40.228.10:FF:000019', NULL, NULL, 'Anaerobic dehydrogenase typically selenocysteine-containing', NULL, NULL, NULL, NULL, NULL, 4),
(98419, NULL, 'G3DSA:3.30.40.10:FF:000878', NULL, NULL, 'RING-H2 finger protein ATL52', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(98420, NULL, 'G3DSA:3.30.70.1660:FF:000030', NULL, NULL, 'Peptide chain release factor 1-like, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(98421, NULL, 'G3DSA:1.25.40.10:FF:004223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98422, NULL, 'G3DSA:1.10.8.1310:FF:000009', NULL, NULL, 'TBC domain protein, putative (AFU_orthologue AFUA_1G04010)', NULL, NULL, NULL, NULL, NULL, 4),
(98423, NULL, 'G3DSA:3.40.50.1820:FF:001508', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98424, NULL, 'G3DSA:1.25.40.10:FF:003947', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98425, NULL, 'G3DSA:1.20.58.1380:FF:000005', NULL, NULL, 'Nuclear pore complex protein NUP133', NULL, NULL, NULL, NULL, NULL, 4),
(98426, NULL, 'G3DSA:3.10.400.20:FF:000020', NULL, NULL, 'Eukaryotic translation initiation factor 2D', NULL, NULL, NULL, NULL, NULL, 4),
(98427, NULL, 'G3DSA:1.10.10.480:FF:000001', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(98428, NULL, 'G3DSA:3.40.50.12650:FF:000030', NULL, NULL, 'DNA repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(98429, NULL, 'G3DSA:1.25.40.20:FF:000662', NULL, NULL, 'Ankyrin repeat domain 17', NULL, NULL, NULL, NULL, NULL, 4),
(98430, NULL, 'G3DSA:3.30.200.20:FF:002018', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(98431, NULL, 'G3DSA:1.10.8.140:FF:000008', NULL, NULL, 'YMR074C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(98432, NULL, 'G3DSA:2.160.20.70:FF:000031', NULL, NULL, 'Tubulin cofactor C domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(98433, NULL, 'G3DSA:3.30.160.60:FF:002195', NULL, NULL, 'C2H2 finger domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98434, NULL, 'G3DSA:3.40.630.10:FF:000275', NULL, NULL, 'Peptidase, M20/M25/M40 family', NULL, NULL, NULL, NULL, NULL, 4),
(98435, NULL, 'G3DSA:3.40.50.300:FF:000599', NULL, NULL, 'Deoxycytidine kinase isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(98436, NULL, 'G3DSA:2.40.100.10:FF:000177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98437, NULL, 'G3DSA:2.60.220.50:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98438, NULL, 'G3DSA:3.40.50.1000:FF:000425', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98439, NULL, 'G3DSA:2.30.30.100:FF:000131', NULL, NULL, 'RNA-binding protein Hfq', NULL, NULL, NULL, NULL, NULL, 4),
(98440, NULL, 'G3DSA:3.90.1480.20:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98441, NULL, 'G3DSA:3.30.160.60:FF:001407', NULL, NULL, 'zinc finger and SCAN domain-containing protein 20 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(98442, NULL, 'G3DSA:3.40.50.720:FF:002416', NULL, NULL, 'dTDP-4-dehydrorhamnose reductase', NULL, NULL, NULL, NULL, NULL, 4),
(98443, NULL, 'G3DSA:3.90.70.10:FF:000641', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(98444, NULL, 'G3DSA:3.40.50.1820:FF:001216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98445, NULL, 'G3DSA:3.30.310.10:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98446, NULL, 'G3DSA:3.90.1150.10:FF:000310', NULL, NULL, 'Serine--pyruvate aminotransferase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(98447, NULL, 'G3DSA:2.170.16.10:FF:000048', NULL, NULL, 'DNA replication licensing factor, MCM2/3/5 family', NULL, NULL, NULL, NULL, NULL, 4),
(98448, NULL, 'G3DSA:3.40.50.980:FF:000021', NULL, NULL, 'Vibriobactin-specific 2,3-dihydroxybenzoate-AMP ligase', NULL, NULL, NULL, NULL, NULL, 4),
(98449, NULL, 'G3DSA:3.40.50.410:FF:000289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98450, NULL, 'G3DSA:2.30.42.10:FF:000082', NULL, NULL, 'LIM domain kinase 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(98451, NULL, 'G3DSA:3.10.250.10:FF:000033', NULL, NULL, 'Scavenger receptor family member expressed on T cells 1', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(98452, NULL, 'G3DSA:1.20.1070.10:FF:000574', NULL, NULL, 'Pigment-dispersing factor receptor, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(98453, NULL, 'G3DSA:1.20.58.390:FF:000069', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(98454, NULL, 'G3DSA:3.80.10.10:FF:001925', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98455, NULL, 'G3DSA:3.20.20.80:FF:000757', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98456, NULL, 'G3DSA:3.90.226.10:FF:000335', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98457, NULL, 'G3DSA:1.20.1250.20:FF:001389', NULL, NULL, 'monocarboxylate transporter 5-like', NULL, NULL, NULL, NULL, NULL, 4),
(98458, NULL, 'G3DSA:1.20.5.490:FF:000004', NULL, NULL, 'Transcription factor HY5', NULL, NULL, NULL, NULL, NULL, 4),
(98459, NULL, 'G3DSA:1.25.40.10:FF:001738', NULL, NULL, 'CRE-LET-716 protein', NULL, NULL, NULL, NULL, NULL, 4),
(98460, NULL, 'G3DSA:2.60.40.10:FF:001290', NULL, NULL, 'Matrix remodeling associated 5', NULL, NULL, NULL, NULL, NULL, 4),
(98461, NULL, 'G3DSA:3.30.60.30:FF:000076', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(98462, NULL, 'G3DSA:1.20.140.40:FF:000016', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(98463, NULL, 'G3DSA:3.40.50.300:FF:002757', NULL, NULL, 'Mitochondrial GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(98464, NULL, 'G3DSA:3.40.140.10:FF:000057', NULL, NULL, 'Cytidine deaminase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98465, NULL, 'G3DSA:1.25.10.10:FF:003299', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(98466, NULL, 'G3DSA:1.25.40.10:FF:003767', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98467, NULL, 'G3DSA:2.130.10.10:FF:001846', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(98468, NULL, 'G3DSA:3.30.40.10:FF:002160', NULL, NULL, 'GIY-YIG domain-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98469, NULL, 'G3DSA:1.25.40.10:FF:005004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98470, NULL, 'G3DSA:2.130.10.10:FF:005157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98471, NULL, 'G3DSA:3.30.420.10:FF:000227', NULL, NULL, 'ERI1 exoribonuclease family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(98472, NULL, 'G3DSA:1.10.472.10:FF:000163', NULL, NULL, 'Unplaced genomic scaffold supercont2.13, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(98473, NULL, 'G3DSA:2.60.40.790:FF:000074', NULL, NULL, 'Ubiquitin-specific peptidase 19', NULL, NULL, NULL, NULL, NULL, 4),
(98474, NULL, 'G3DSA:3.10.129.10:FF:000021', NULL, NULL, 'Acyl-coenzyme A thioesterase 13', NULL, NULL, NULL, NULL, NULL, 4),
(98475, NULL, 'G3DSA:1.25.10.10:FF:001169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98476, NULL, 'G3DSA:1.10.10.60:FF:000407', NULL, NULL, 'MYB transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(98477, NULL, 'G3DSA:3.30.420.40:FF:000719', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(98478, NULL, 'G3DSA:2.80.10.50:FF:000096', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(98479, NULL, 'G3DSA:3.80.10.10:FF:002010', NULL, NULL, 'Leucine-rich repeat (LRR) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(98480, NULL, 'G3DSA:3.30.200.110:FF:000005', NULL, NULL, 'Inositol-pentakisphosphate 2-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(98481, NULL, 'G3DSA:2.170.300.10:FF:000021', NULL, NULL, 'Platelet endothelial aggregation receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(98482, NULL, 'G3DSA:2.60.40.10:FF:006073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98483, NULL, 'G3DSA:2.130.10.10:FF:000418', NULL, NULL, 'Protein HIRA', NULL, NULL, NULL, NULL, NULL, 4),
(98484, NULL, 'G3DSA:3.40.50.300:FF:004994', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(98485, NULL, 'G3DSA:2.60.120.260:FF:000104', NULL, NULL, 'DNA repair protein XRCC1', NULL, NULL, NULL, NULL, NULL, 4),
(98486, NULL, 'G3DSA:2.60.40.10:FF:004044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98487, NULL, 'G3DSA:2.60.120.200:FF:000665', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98488, NULL, 'G3DSA:3.40.50.300:FF:001329', NULL, NULL, 'Small GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98489, NULL, 'G3DSA:2.60.120.10:FF:000685', NULL, NULL, 'Acireductone dioxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98490, NULL, 'G3DSA:3.40.50.2300:FF:000192', NULL, NULL, 'Ethylene receptor', NULL, NULL, NULL, NULL, NULL, 4),
(98491, NULL, 'G3DSA:3.40.50.2000:FF:000063', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(98492, NULL, 'G3DSA:1.20.1270.60:FF:000216', NULL, NULL, 'Fcho-1', NULL, NULL, NULL, NULL, NULL, 4),
(98493, NULL, 'G3DSA:3.40.50.150:FF:000418', NULL, NULL, 'Probable methyltransferase PMT11', NULL, NULL, NULL, NULL, NULL, 4),
(98494, NULL, 'G3DSA:1.10.10.10:FF:001438', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(98495, NULL, 'G3DSA:1.10.418.10:FF:000054', NULL, NULL, 'Dixin isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(98496, NULL, 'G3DSA:1.10.287.1150:FF:000013', NULL, NULL, '2-oxoglutarate dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(98497, NULL, 'G3DSA:2.40.50.40:FF:000092', NULL, NULL, 'C-C motif chemokine', NULL, NULL, NULL, NULL, NULL, 4),
(98498, NULL, 'G3DSA:3.30.70.20:FF:000012', NULL, NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(98499, NULL, 'G3DSA:1.10.510.10:FF:002826', NULL, NULL, 'Ubiquitin-binding serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(98500, NULL, 'G3DSA:3.20.20.120:FF:000032', NULL, NULL, 'L-Ala-D/L-amino acid epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(98501, NULL, 'G3DSA:3.30.760.10:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98502, NULL, 'G3DSA:2.40.30.10:FF:000227', NULL, NULL, 'Translation elongation factor EF1A/initiation factor IF2gamma family protein', NULL, NULL, NULL, NULL, NULL, 4),
(98503, NULL, 'G3DSA:3.40.50.620:FF:000026', NULL, NULL, 'Methionine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(98504, NULL, 'G3DSA:1.10.220.20:FF:000019', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(98505, NULL, 'G3DSA:3.30.9.10:FF:000002', NULL, NULL, 'D-amino acid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(98506, NULL, 'G3DSA:1.20.5.1190:FF:000004', NULL, NULL, 'ISWI chromatin-remodeling complex ATPase CHR11', NULL, NULL, NULL, NULL, NULL, 4),
(98507, NULL, 'G3DSA:3.20.20.80:FF:000140', NULL, NULL, 'Glucan 1,3-beta-glucosidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(98508, NULL, 'G3DSA:3.30.450.260:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98509, NULL, 'G3DSA:3.40.630.30:FF:000090', NULL, NULL, 'Glycine N-acyltransferase-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(98510, NULL, 'G3DSA:1.20.5.190:FF:000072', NULL, NULL, 'Class V myosin', NULL, NULL, NULL, NULL, NULL, 4),
(98511, NULL, 'G3DSA:2.60.40.1250:FF:000002', NULL, NULL, 'Thiol:disulfide interchange protein DsbD', NULL, NULL, NULL, NULL, NULL, 4),
(98512, NULL, 'G3DSA:3.40.50.1820:FF:000227', NULL, NULL, 'Yolk protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(98513, NULL, 'G3DSA:3.30.2350.20:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98514, NULL, 'G3DSA:2.170.120.20:FF:000021', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(98515, NULL, 'G3DSA:2.60.40.60:FF:000152', NULL, NULL, 'Cadherin 17', NULL, NULL, NULL, NULL, NULL, 4),
(98516, NULL, 'G3DSA:3.30.1200.10:FF:000002', NULL, NULL, 'Uncharacterized ACR, YggU family COG1872, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98517, NULL, 'G3DSA:1.10.510.10:FF:000685', NULL, NULL, 'Serine/threonine-protein kinase dyf-5', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(98518, NULL, 'G3DSA:1.20.120.1080:FF:000108', NULL, NULL, 'Pre-mRNA splicing factor ATP-dependent RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98519, NULL, 'G3DSA:3.30.2350.10:FF:000002', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(98520, NULL, 'G3DSA:1.25.40.20:FF:001679', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(98521, NULL, 'G3DSA:1.10.486.10:FF:000054', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(98522, NULL, 'G3DSA:2.60.40.640:FF:000057', NULL, NULL, 'Vacuolar sorting protein 26 putative', NULL, NULL, NULL, NULL, NULL, 4),
(98523, NULL, 'G3DSA:1.10.150.20:FF:000171', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4),
(98524, NULL, 'G3DSA:3.40.50.1700:FF:000017', NULL, NULL, 'Glycosyl hydrolase family 3 C terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(98525, NULL, 'G3DSA:3.30.200.20:FF:001922', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98526, NULL, 'G3DSA:2.10.50.30:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98527, NULL, 'G3DSA:3.80.10.10:FF:000773', NULL, NULL, 'EIN3-binding F-box protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(98528, NULL, 'G3DSA:2.60.40.820:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98529, NULL, 'G3DSA:3.30.160.60:FF:004544', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98530, NULL, 'G3DSA:1.25.50.20:FF:000084', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(98531, NULL, 'G3DSA:2.60.40.630:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98532, NULL, 'G3DSA:3.80.10.10:FF:002914', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98533, NULL, 'G3DSA:3.30.1360.170:FF:000005', NULL, NULL, 'Flavin-dependent thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(98534, NULL, 'G3DSA:3.40.50.300:FF:006231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98535, NULL, 'G3DSA:1.10.468.10:FF:000001', NULL, NULL, 'Photosynthetic reaction center cytochrome c subunit', NULL, NULL, NULL, NULL, NULL, 4),
(98536, NULL, 'G3DSA:3.40.50.150:FF:000806', NULL, NULL, 'Methyltransferase-like 22', NULL, NULL, NULL, NULL, NULL, 4),
(98537, NULL, 'G3DSA:1.10.8.10:FF:000285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98538, NULL, 'G3DSA:1.20.58.2050:FF:000004', NULL, NULL, 'GINS complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(98539, NULL, 'G3DSA:3.30.160.60:FF:005954', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98540, NULL, 'G3DSA:3.30.1120.30:FF:000007', NULL, NULL, 'Polo like kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(98541, NULL, 'G3DSA:1.10.167.10:FF:000049', NULL, NULL, 'Bud site selection protein rax1 homologue, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98542, NULL, 'G3DSA:1.10.246.130:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98543, NULL, 'G3DSA:3.30.160.60:FF:002127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98544, NULL, 'G3DSA:1.10.1660.10:FF:000020', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(98545, NULL, 'G3DSA:2.60.40.10:FF:003324', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98546, NULL, 'G3DSA:3.40.50.300:FF:008417', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98547, NULL, 'G3DSA:3.30.420.110:FF:000072', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(98548, NULL, 'G3DSA:1.10.10.60:FF:001251', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98549, NULL, 'G3DSA:1.20.58.150:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98550, NULL, 'G3DSA:1.10.287.70:FF:000244', NULL, NULL, 'Ionotropic receptor 41a', NULL, NULL, NULL, NULL, NULL, 4),
(98551, NULL, 'G3DSA:1.10.287.4070:FF:000001', NULL, NULL, 'Probable Nucleolar protein 58', NULL, NULL, NULL, NULL, NULL, 4),
(98552, NULL, 'G3DSA:2.20.25.420:FF:000005', NULL, NULL, 'Putative zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(98553, NULL, 'G3DSA:2.10.25.10:FF:001745', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98554, NULL, 'G3DSA:1.10.10.10:FF:000713', NULL, NULL, 'CopY/TcrY family copper transport repressor', NULL, NULL, NULL, NULL, NULL, 4),
(98555, NULL, 'G3DSA:3.30.70.330:FF:001878', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98556, NULL, 'G3DSA:3.40.50.300:FF:005775', NULL, NULL, 'Mitochondrial F1F0 ATP synthase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(98557, NULL, 'G3DSA:3.10.20.90:FF:000694', NULL, NULL, 'ubiquitin thioesterase OTU1', NULL, NULL, NULL, NULL, NULL, 4),
(98558, NULL, 'G3DSA:1.10.510.10:FF:000038', NULL, NULL, 'serine/threonine-protein kinase N2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(98559, NULL, 'G3DSA:1.10.1420.10:FF:000210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98560, NULL, 'G3DSA:3.30.2270.10:FF:000001', NULL, NULL, 'Sarcosine oxidase, delta subunit protein', NULL, NULL, NULL, NULL, NULL, 4),
(98561, NULL, 'G3DSA:1.25.10.10:FF:000505', NULL, NULL, 'HEAT repeat-containing protein 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(98562, NULL, 'G3DSA:1.20.1250.20:FF:001125', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(98563, NULL, 'G3DSA:1.10.510.10:FF:002242', NULL, NULL, 'Probable serine/threonine-protein kinase glkA', NULL, NULL, NULL, NULL, NULL, 4),
(98564, NULL, 'G3DSA:3.10.450.10:FF:000082', NULL, NULL, 'Fetuin B', NULL, NULL, NULL, NULL, NULL, 4),
(98565, NULL, 'G3DSA:3.40.50.1000:FF:000813', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98566, NULL, 'G3DSA:3.40.50.200:FF:000187', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98567, NULL, 'G3DSA:4.10.260.30:FF:000002', NULL, NULL, 'Apolipoprotein C-I', NULL, NULL, NULL, NULL, NULL, 4),
(98568, NULL, 'G3DSA:3.10.120.10:FF:000052', NULL, NULL, 'Sphingolipid 10-desaturase', NULL, NULL, NULL, NULL, NULL, 4),
(98569, NULL, 'G3DSA:3.40.50.300:FF:003746', NULL, NULL, 'Guanylate-binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(98570, NULL, 'G3DSA:2.60.40.10:FF:002650', NULL, NULL, 'Frazzled', NULL, NULL, NULL, NULL, NULL, 4),
(98571, NULL, 'G3DSA:3.40.190.290:FF:000007', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(98572, NULL, 'G3DSA:1.20.1250.20:FF:002182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98573, NULL, 'G3DSA:3.90.850.10:FF:000010', NULL, NULL, 'FAA hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(98574, NULL, 'G3DSA:3.30.950.30:FF:000003', NULL, NULL, 'Schlafen family member 9', NULL, NULL, NULL, NULL, NULL, 4),
(98575, NULL, 'G3DSA:1.25.40.10:FF:005280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98576, NULL, 'G3DSA:3.20.20.140:FF:000414', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98577, NULL, 'G3DSA:3.20.20.140:FF:000190', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(98578, NULL, 'G3DSA:3.30.40.10:FF:000799', NULL, NULL, 'E3 ubiquitin-protein ligase HEL2', NULL, NULL, NULL, NULL, NULL, 4),
(98579, NULL, 'G3DSA:3.10.20.90:FF:000912', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98580, NULL, 'G3DSA:2.60.40.420:FF:000019', NULL, NULL, 'Putative ephrin-B3', NULL, NULL, NULL, NULL, NULL, 4),
(98581, NULL, 'G3DSA:2.40.10.230:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98582, NULL, 'G3DSA:3.30.450.20:FF:000541', NULL, NULL, 'Two-component sensor PprA', NULL, NULL, NULL, NULL, NULL, 4),
(98583, NULL, 'G3DSA:1.10.3430.10:FF:000003', NULL, NULL, 'Ammonium transporter', NULL, NULL, NULL, NULL, NULL, 4),
(98584, NULL, 'G3DSA:2.60.120.200:FF:000457', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98585, NULL, 'G3DSA:3.30.70.2760:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98586, NULL, 'G3DSA:3.30.70.3490:FF:000028', NULL, NULL, 'Oxysterol binding protein (Osh3), putative (AFU_orthologue AFUA_3G05880)', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(98587, NULL, 'G3DSA:3.30.1490.20:FF:000048', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(98588, NULL, 'G3DSA:2.30.40.10:FF:000133', NULL, NULL, 'D-phenylhydantoinase protein', NULL, NULL, NULL, NULL, NULL, 4),
(98589, NULL, 'G3DSA:3.60.20.40:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98590, NULL, 'G3DSA:3.40.1370.10:FF:000034', NULL, NULL, '50S ribosomal protein L4', NULL, NULL, NULL, NULL, NULL, 4),
(98591, NULL, 'G3DSA:2.70.170.10:FF:000180', NULL, NULL, 'Protein CBG10414', NULL, NULL, NULL, NULL, NULL, 4),
(98592, NULL, 'G3DSA:3.40.1000.10:FF:000007', NULL, NULL, 'RGM domain family member B', NULL, NULL, NULL, NULL, NULL, 4),
(98593, NULL, 'G3DSA:3.40.720.10:FF:000315', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98594, NULL, 'G3DSA:1.20.58.530:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98595, NULL, 'G3DSA:1.25.40.10:FF:000221', NULL, NULL, 'Mitochondrial import receptor subunit TOM34', NULL, NULL, NULL, NULL, NULL, 4),
(98596, NULL, 'G3DSA:2.130.10.10:FF:001262', NULL, NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(98597, NULL, 'G3DSA:2.60.40.3180:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98598, NULL, 'G3DSA:1.20.1070.10:FF:001563', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98599, NULL, 'G3DSA:3.40.50.2000:FF:000271', NULL, NULL, 'Lipopolysaccharide heptosyltransferase II', NULL, NULL, NULL, NULL, NULL, 4),
(98600, NULL, 'G3DSA:1.10.418.10:FF:000178', NULL, NULL, 'PLaSTin (Actin bundling protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(98601, NULL, 'G3DSA:3.10.50.10:FF:000014', NULL, NULL, 'Class V chitinase Chi100', NULL, NULL, NULL, NULL, NULL, 4),
(98602, NULL, 'G3DSA:3.30.1370.110:FF:000001', NULL, NULL, 'DNA endonuclease SmrA', NULL, NULL, NULL, NULL, NULL, 4),
(98603, NULL, 'G3DSA:2.70.170.10:FF:000028', NULL, NULL, 'AcetylCholine Receptor', NULL, NULL, NULL, NULL, NULL, 4),
(98604, NULL, 'G3DSA:3.10.20.90:FF:000171', NULL, NULL, 'Small ubiquitin-related modifier', NULL, NULL, NULL, NULL, NULL, 4),
(98605, NULL, 'G3DSA:1.25.10.10:FF:000713', NULL, NULL, 'Beta-catenin-like protein hmp-2', NULL, NULL, NULL, NULL, NULL, 4),
(98606, NULL, 'G3DSA:3.40.50.300:FF:002577', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(98607, NULL, 'G3DSA:1.10.287.850:FF:000006', NULL, NULL, 'PE family protein PE22', NULL, NULL, NULL, NULL, NULL, 4),
(98608, NULL, 'G3DSA:3.90.470.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98609, NULL, 'G3DSA:3.40.50.1820:FF:000379', NULL, NULL, 'Neuroligin 1', NULL, NULL, NULL, NULL, NULL, 4),
(98610, NULL, 'G3DSA:3.40.50.1100:FF:000276', NULL, NULL, 'Cysteine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(98611, NULL, 'G3DSA:3.30.70.1430:FF:000006', NULL, NULL, 'Putative cation efflux system protein CusA', NULL, NULL, NULL, NULL, NULL, 4),
(98612, NULL, 'G3DSA:3.30.450.20:FF:000384', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(98613, NULL, 'G3DSA:3.40.1110.10:FF:000392', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98614, NULL, 'G3DSA:3.30.70.60:FF:000024', NULL, NULL, 'EF-1 guanine nucleotide exchange domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(98615, NULL, 'G3DSA:2.40.110.10:FF:000003', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(98616, NULL, 'G3DSA:1.20.58.390:FF:000249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98617, NULL, 'G3DSA:3.30.565.10:FF:000113', NULL, NULL, 'Histidine phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(98618, NULL, 'G3DSA:2.40.10.10:FF:000552', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98619, NULL, 'G3DSA:3.60.15.10:FF:000190', NULL, NULL, 'Putative metallo-beta-lactamase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(98620, NULL, 'G3DSA:2.10.25.10:FF:001588', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(98621, NULL, 'G3DSA:1.20.5.110:FF:000087', NULL, NULL, 'SNARE protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98622, NULL, 'G3DSA:3.40.1810.10:FF:000018', NULL, NULL, 'agamous-like MADS-box protein AGL80', NULL, NULL, NULL, NULL, NULL, 4),
(98623, NULL, 'G3DSA:3.40.50.80:FF:000039', NULL, NULL, 'Ferric reduction oxidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(98624, NULL, 'G3DSA:3.30.70.330:FF:000529', NULL, NULL, 'UBP1-associated protein 2C isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(98625, NULL, 'G3DSA:1.20.1560.10:FF:000538', NULL, NULL, 'ATP-binding cassette subfamily C member 6', NULL, NULL, NULL, NULL, NULL, 4),
(98626, NULL, 'G3DSA:3.40.50.2300:FF:000271', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(98627, NULL, 'G3DSA:3.30.470.20:FF:000216', NULL, NULL, 'Alpha-L-glutamate ligases, RimK family', NULL, NULL, NULL, NULL, NULL, 4),
(98628, NULL, 'G3DSA:3.10.105.10:FF:000073', NULL, NULL, 'Dipeptide-binding lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(98629, NULL, 'G3DSA:2.60.40.10:FF:004948', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98630, NULL, 'G3DSA:1.20.1020.10:FF:000003', NULL, NULL, 'Histone acetyltransferase HAC1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(98631, NULL, 'G3DSA:3.90.470.20:FF:000017', NULL, NULL, 'Phosphopantetheine-protein transferase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(98632, NULL, 'G3DSA:3.40.50.150:FF:000694', NULL, NULL, 'Methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(98633, NULL, 'G3DSA:3.40.50.10860:FF:000044', NULL, NULL, 'Pentafunctional AROM polypeptide, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98634, NULL, 'G3DSA:1.20.120.330:FF:000040', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(98635, NULL, 'G3DSA:1.25.40.10:FF:002519', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(98636, NULL, 'G3DSA:3.80.10.10:FF:003999', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98637, NULL, 'G3DSA:1.25.10.10:FF:002861', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98638, NULL, 'G3DSA:3.10.50.40:FF:000118', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(98639, NULL, 'G3DSA:3.90.550.20:FF:000018', NULL, NULL, 'Glycoside transferase family 32', NULL, NULL, NULL, NULL, NULL, 4),
(98640, NULL, 'G3DSA:1.10.510.10:FF:000409', NULL, NULL, 'CMGC/SRPK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(98641, NULL, 'G3DSA:3.80.10.10:FF:000565', NULL, NULL, 'Leucine-rich repeat receptor-like kinase protein FLORAL ORGAN NUMBER1', NULL, NULL, NULL, NULL, NULL, 4),
(98642, NULL, 'G3DSA:3.90.190.20:FF:000035', NULL, NULL, 'Bifunctional folylpolyglutamate synthase/dihydrofolate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(98643, NULL, 'G3DSA:3.40.640.10:FF:000314', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(98644, NULL, 'G3DSA:3.40.50.300:FF:007809', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98645, NULL, 'G3DSA:1.10.10.980:FF:000005', NULL, NULL, 'CST complex subunit STN1', NULL, NULL, NULL, NULL, NULL, 4),
(98646, NULL, 'G3DSA:1.20.58.900:FF:000003', NULL, NULL, 'DENN domain containing 5A', NULL, NULL, NULL, NULL, NULL, 4),
(98647, NULL, 'G3DSA:3.40.910.10:FF:000026', NULL, NULL, 'Deoxyhypusine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(98648, NULL, 'G3DSA:1.10.287.70:FF:000036', NULL, NULL, 'ATP-sensitive inward rectifier potassium channel 1', NULL, NULL, NULL, NULL, NULL, 4),
(98649, NULL, 'G3DSA:3.40.980.10:FF:000031', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98650, NULL, 'G3DSA:1.20.1560.10:FF:000038', NULL, NULL, 'ABC transporter B family member 19', NULL, NULL, NULL, NULL, NULL, 4),
(98651, NULL, 'G3DSA:2.130.10.10:FF:002043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98652, NULL, 'G3DSA:3.30.497.10:FF:000067', NULL, NULL, 'Serpin family B member 10', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(98653, NULL, 'G3DSA:1.25.10.10:FF:002922', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98654, NULL, 'G3DSA:2.40.100.10:FF:000053', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(98655, NULL, 'G3DSA:3.90.80.10:FF:000018', NULL, NULL, 'Inorganic pyrophosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98656, NULL, 'G3DSA:3.40.50.1000:FF:000313', NULL, NULL, 'Phospholipid-transporting ATPase IH-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(98657, NULL, 'G3DSA:1.20.1310.20:FF:000028', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(98658, NULL, 'G3DSA:2.130.10.10:FF:001767', NULL, NULL, 'Putative WD40 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(98659, NULL, 'G3DSA:3.40.50.1010:FF:000018', NULL, NULL, 'RNA-binding protein NOB1', NULL, NULL, NULL, NULL, NULL, 4),
(98660, NULL, 'G3DSA:2.30.30.30:FF:000133', NULL, NULL, 'Translation elongation factor P', NULL, NULL, NULL, NULL, NULL, 4),
(98661, NULL, 'G3DSA:1.20.120.1630:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98662, NULL, 'G3DSA:3.40.140.10:FF:000136', NULL, NULL, 'COP9 signalosome complex subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(98663, NULL, 'G3DSA:3.40.50.2000:FF:000624', NULL, NULL, 'Putative TPR repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(98664, NULL, 'G3DSA:2.60.260.20:FF:000052', NULL, NULL, 'Chaperone DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(98665, NULL, 'G3DSA:3.30.450.20:FF:000041', NULL, NULL, 'Adagio protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(98666, NULL, 'G3DSA:1.10.760.10:FF:000085', NULL, NULL, 'Probable cytochrome-c peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(98667, NULL, 'G3DSA:3.60.21.10:FF:000243', NULL, NULL, 'Protein CBG11338', NULL, NULL, NULL, NULL, NULL, 4),
(98668, NULL, 'G3DSA:1.10.510.10:FF:001466', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98669, NULL, 'G3DSA:1.25.10.10:FF:003378', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98670, NULL, 'G3DSA:1.10.10.60:FF:000475', NULL, NULL, 'Transcription factor MYB36', NULL, NULL, NULL, NULL, NULL, 4),
(98671, NULL, 'G3DSA:3.40.50.1110:FF:000166', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98672, NULL, 'G3DSA:2.60.40.10:FF:001458', NULL, NULL, 'EBF transcription factor 3b', NULL, NULL, NULL, NULL, NULL, 4),
(98673, NULL, 'G3DSA:2.60.40.10:FF:004448', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98674, NULL, 'G3DSA:3.30.428.10:FF:000060', NULL, NULL, 'M7GpppX diphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(98675, NULL, 'G3DSA:2.60.34.10:FF:000056', NULL, NULL, 'Protein CBG18239', NULL, NULL, NULL, NULL, NULL, 4),
(98676, NULL, 'G3DSA:1.10.533.10:FF:000254', NULL, NULL, 'CASP8 and FADD-like apoptosis regulator a', NULL, NULL, NULL, NULL, NULL, 4),
(98677, NULL, 'G3DSA:2.130.10.10:FF:004376', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98678, NULL, 'G3DSA:2.60.40.10:FF:005741', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98679, NULL, 'G3DSA:3.30.200.20:FF:002462', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98680, NULL, 'G3DSA:3.30.40.10:FF:001816', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98681, NULL, 'G3DSA:3.30.70.260:FF:000132', NULL, NULL, 'Lysine-sensitive aspartokinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(98682, NULL, 'G3DSA:1.10.510.10:FF:002747', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98683, NULL, 'G3DSA:1.25.10.10:FF:000152', NULL, NULL, 'Ectoderm-expressed 4, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(98684, NULL, 'G3DSA:3.30.450.40:FF:000047', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(98685, NULL, 'G3DSA:3.90.260.10:FF:000038', NULL, NULL, 'Putative transglutaminase/protease-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(98686, NULL, 'G3DSA:3.40.50.200:FF:000052', NULL, NULL, 'Serine protease, putative', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(98687, NULL, 'G3DSA:3.40.50.150:FF:001150', NULL, NULL, 'Herbicide safener binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(98688, NULL, 'G3DSA:1.10.510.10:FF:000561', NULL, NULL, 'AKT serine/threonine kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(98689, NULL, 'G3DSA:1.10.1410.10:FF:000041', NULL, NULL, 'Tailor, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(98690, NULL, 'G3DSA:2.60.40.10:FF:000233', NULL, NULL, 'Myomesin 1', NULL, NULL, NULL, NULL, NULL, 4),
(98691, NULL, 'G3DSA:4.10.40.20:FF:000008', NULL, NULL, 'Crimpy, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(98692, NULL, 'G3DSA:1.25.10.10:FF:000781', NULL, NULL, 'HEAT repeat domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(98693, NULL, 'G3DSA:3.40.50.1220:FF:000087', NULL, NULL, 'ADR254Wp', NULL, NULL, NULL, NULL, NULL, 4),
(98694, NULL, 'G3DSA:1.10.238.10:FF:000585', NULL, NULL, 'Calcium-dependent protein kinase-a', NULL, NULL, NULL, NULL, NULL, 4),
(98695, NULL, 'G3DSA:2.60.120.650:FF:000215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98696, NULL, 'G3DSA:3.30.60.30:FF:000008', NULL, NULL, 'Transmembrane agrin', NULL, NULL, NULL, NULL, NULL, 4),
(98697, NULL, 'G3DSA:1.10.10.1320:FF:000012', NULL, NULL, 'Anti-ECFsigma factor ChrR', NULL, NULL, NULL, NULL, NULL, 4),
(98698, NULL, 'G3DSA:1.10.530.10:FF:000040', NULL, NULL, 'Lysin A', NULL, NULL, NULL, NULL, NULL, 4),
(98699, NULL, 'G3DSA:3.30.70.560:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98700, NULL, 'G3DSA:3.40.50.1000:FF:000072', NULL, NULL, 'Phosphonoacetaldehyde hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(98701, NULL, 'G3DSA:3.30.710.10:FF:000250', NULL, NULL, 'Myoneurin', NULL, NULL, NULL, NULL, NULL, 4),
(98702, NULL, 'G3DSA:3.40.1280.30:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98703, NULL, 'G3DSA:3.60.10.10:FF:000279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98704, NULL, 'G3DSA:2.10.25.10:FF:001824', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98705, NULL, 'G3DSA:1.25.40.10:FF:004936', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98706, NULL, 'G3DSA:1.50.10.10:FF:000149', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(98707, NULL, 'G3DSA:3.30.40.10:FF:000294', NULL, NULL, 'Nuclear autoantigen Sp-100', NULL, NULL, NULL, NULL, NULL, 4),
(98708, NULL, 'G3DSA:1.20.1110.10:FF:000162', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98709, NULL, 'G3DSA:3.40.50.880:FF:000076', NULL, NULL, 'CTP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(98710, NULL, 'G3DSA:1.20.1270.10:FF:000050', NULL, NULL, 'Chaperone protein HscA homolog', NULL, NULL, NULL, NULL, NULL, 4),
(98711, NULL, 'G3DSA:3.80.10.10:FF:002982', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98712, NULL, 'G3DSA:1.20.1640.10:FF:000039', NULL, NULL, 'Protein-export membrane protein SecF', NULL, NULL, NULL, NULL, NULL, 4),
(98713, NULL, 'G3DSA:1.20.58.1610:FF:000001', NULL, NULL, 'NAD(P)H-quinone oxidoreductase subunit 3, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(98714, NULL, 'G3DSA:2.30.42.10:FF:000587', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98715, NULL, 'G3DSA:3.30.40.10:FF:002008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98716, NULL, 'G3DSA:2.60.120.620:FF:000055', NULL, NULL, 'egl nine homolog 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(98717, NULL, 'G3DSA:3.40.50.620:FF:000346', NULL, NULL, 'Nicotinamide-nucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(98718, NULL, 'G3DSA:3.30.160.60:FF:003184', NULL, NULL, 'Uncharacterized protein, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(98719, NULL, 'G3DSA:3.20.20.70:FF:000316', NULL, NULL, 'Dihydrodipicolinate synthetase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(98720, NULL, 'G3DSA:3.40.190.10:FF:000471', NULL, NULL, 'Peptide ABC transporter permease protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(98721, NULL, 'G3DSA:2.20.28.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98722, NULL, 'G3DSA:3.30.70.330:FF:000861', NULL, NULL, 'Rim4p', NULL, NULL, NULL, NULL, NULL, 4),
(98723, NULL, 'G3DSA:1.25.40.180:FF:000115', NULL, NULL, 'Protein CBR-SMG-3', NULL, NULL, NULL, NULL, NULL, 4),
(98724, NULL, 'G3DSA:2.60.120.330:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98725, NULL, 'G3DSA:3.40.630.30:FF:000314', NULL, NULL, 'Alpha-tubulin N-acetyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(98726, NULL, 'G3DSA:1.20.58.60:FF:000388', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98727, NULL, 'G3DSA:3.30.420.40:FF:000871', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98728, NULL, 'G3DSA:3.30.70.330:FF:003115', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98729, NULL, 'G3DSA:3.30.530.20:FF:000042', NULL, NULL, 'StAR-related lipid transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(98730, NULL, 'G3DSA:2.120.10.30:FF:000110', NULL, NULL, 'Probable cytochrome c', NULL, NULL, NULL, NULL, NULL, 4),
(98731, NULL, 'G3DSA:2.10.25.10:FF:000464', NULL, NULL, 'Adhesion G protein-coupled receptor E1', NULL, NULL, NULL, NULL, NULL, 4),
(98732, NULL, 'G3DSA:1.25.40.10:FF:005212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98733, NULL, 'G3DSA:1.25.40.10:FF:002019', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(98734, NULL, 'G3DSA:1.10.287.110:FF:000077', NULL, NULL, 'Translocation protein SEC63', NULL, NULL, NULL, NULL, NULL, 4),
(98735, NULL, 'G3DSA:2.130.10.10:FF:000486', NULL, NULL, 'DDB1- and CUL4-associated factor 12-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(98736, NULL, 'G3DSA:1.10.238.10:FF:000309', NULL, NULL, 'Chromosome 21, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(98737, NULL, 'G3DSA:2.40.10.10:FF:000052', NULL, NULL, 'Neutrophil elastase', NULL, NULL, NULL, NULL, NULL, 4),
(98738, NULL, 'G3DSA:3.90.1170.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98739, NULL, 'G3DSA:1.25.40.10:FF:000721', NULL, NULL, 'Empty pericarp7', NULL, NULL, NULL, NULL, NULL, 4),
(98740, NULL, 'G3DSA:3.40.50.300:FF:004090', NULL, NULL, 'RNase L inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(98741, NULL, 'G3DSA:1.10.510.10:FF:003023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98742, NULL, 'G3DSA:3.40.50.11660:FF:000008', NULL, NULL, 'Alpha-(1,3)-fucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(98743, NULL, 'G3DSA:1.20.58.1040:FF:000021', NULL, NULL, '1,3-beta-glucanosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(98744, NULL, 'G3DSA:1.20.1250.20:FF:000849', NULL, NULL, 'Multidrug transporter', NULL, NULL, NULL, NULL, NULL, 4),
(98745, NULL, 'G3DSA:1.10.472.10:FF:000516', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98746, NULL, 'G3DSA:1.20.272.40:FF:000002', NULL, NULL, 'ATP-dependent RNA helicase SUV3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(98747, NULL, 'G3DSA:2.40.170.20:FF:000004', NULL, NULL, 'FhuE outer membrane receptor', NULL, NULL, NULL, NULL, NULL, 4),
(98748, NULL, 'G3DSA:3.70.10.10:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98749, NULL, 'G3DSA:2.60.40.10:FF:001790', NULL, NULL, 'Terribly reduced optic lobes, isoform AM', NULL, NULL, NULL, NULL, NULL, 4),
(98750, NULL, 'G3DSA:3.40.50.11610:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98751, NULL, 'G3DSA:1.10.510.10:FF:000617', NULL, NULL, 'Serine/threonine-protein kinase UCNL', NULL, NULL, NULL, NULL, NULL, 4),
(98752, NULL, 'G3DSA:1.20.58.480:FF:000012', NULL, NULL, 'Indoleamine 2,3-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(98753, NULL, 'G3DSA:2.40.30.10:FF:000166', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(98754, NULL, 'G3DSA:2.60.120.260:FF:000025', NULL, NULL, 'DNA repair protein XRCC1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(98755, NULL, 'G3DSA:2.60.40.60:FF:000675', NULL, NULL, 'Cadherin-related hmr-1', NULL, NULL, NULL, NULL, NULL, 4),
(98756, NULL, 'G3DSA:3.30.160.60:FF:006230', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98757, NULL, 'G3DSA:3.90.550.10:FF:000369', NULL, NULL, 'Galactosylgalactosylxylosylprotein 3-beta-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(98758, NULL, 'G3DSA:1.25.10.10:FF:000629', NULL, NULL, 'Unc-45', NULL, NULL, NULL, NULL, NULL, 4),
(98759, NULL, 'G3DSA:1.20.1070.10:FF:000506', NULL, NULL, 'Adrenoceptor alpha 1Ab', NULL, NULL, NULL, NULL, NULL, 4),
(98760, NULL, 'G3DSA:2.60.40.1730:FF:000084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98761, NULL, 'G3DSA:1.10.357.150:FF:000015', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(98762, NULL, 'G3DSA:1.25.40.10:FF:001238', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g22690', NULL, NULL, NULL, NULL, NULL, 4),
(98763, NULL, 'G3DSA:3.40.50.1820:FF:001008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98764, NULL, 'G3DSA:1.20.1070.10:FF:000782', NULL, NULL, 'Parietopsin', NULL, NULL, NULL, NULL, NULL, 4),
(98765, NULL, 'G3DSA:1.25.40.430:FF:000005', NULL, NULL, 'Mad3/BUB1 homology region 1', NULL, NULL, NULL, NULL, NULL, 4),
(98766, NULL, 'G3DSA:1.10.555.10:FF:000035', NULL, NULL, 'Phosphatidylinositol 3-kinase regulatory subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(98767, NULL, 'G3DSA:3.40.190.10:FF:000139', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(98768, NULL, 'G3DSA:2.130.10.10:FF:001503', NULL, NULL, 'DDB1-and CUL4-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(98769, NULL, 'G3DSA:3.40.50.1000:FF:000633', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98770, NULL, 'G3DSA:1.10.1040.10:FF:000052', NULL, NULL, 'Mitochondrial translational activator', NULL, NULL, NULL, NULL, NULL, 4),
(98771, NULL, 'G3DSA:2.60.40.150:FF:000585', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98772, NULL, 'G3DSA:3.40.50.2000:FF:000888', NULL, NULL, 'Lipid-A-disaccharide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(98773, NULL, 'G3DSA:3.90.1150.10:FF:000046', NULL, NULL, 'Acetylornithine aminotransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(98774, NULL, 'G3DSA:3.40.30.10:FF:000944', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98775, NULL, 'G3DSA:3.30.420.40:FF:000950', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(98776, NULL, 'G3DSA:2.40.50.140:FF:000335', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98777, NULL, 'G3DSA:3.30.559.10:FF:000060', NULL, NULL, 'Diacylglycerol O-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(98778, NULL, 'G3DSA:3.40.50.300:FF:002841', NULL, NULL, 'Ras-related protein Rab-33', NULL, NULL, NULL, NULL, NULL, 4),
(98779, NULL, 'G3DSA:3.30.160.60:FF:006410', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98780, NULL, 'G3DSA:3.40.50.300:FF:003241', NULL, NULL, 'Dicer-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(98781, NULL, 'G3DSA:3.60.20.10:FF:000229', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98782, NULL, 'G3DSA:2.20.70.10:FF:000219', NULL, NULL, 'Zygote-specific protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(98783, NULL, 'G3DSA:1.20.1280.50:FF:000040', NULL, NULL, 'protein UNUSUAL FLORAL ORGANS', NULL, NULL, NULL, NULL, NULL, 4),
(98784, NULL, 'G3DSA:3.40.50.2300:FF:001613', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98785, NULL, 'G3DSA:1.10.1900.10:FF:000005', NULL, NULL, 'Poly(A) binding protein cytoplasmic 1 like', NULL, NULL, NULL, NULL, NULL, 4),
(98786, NULL, 'G3DSA:1.25.40.10:FF:004375', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98787, NULL, 'G3DSA:2.130.10.10:FF:005477', NULL, NULL, 'WD-40 repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(98788, NULL, 'G3DSA:3.10.350.10:FF:000097', NULL, NULL, 'Intracellular hyphae protein 1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(98789, NULL, 'G3DSA:3.40.50.300:FF:006152', NULL, NULL, 'Os03g0181750 protein', NULL, NULL, NULL, NULL, NULL, 4),
(98790, NULL, 'G3DSA:3.90.1150.220:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98791, NULL, 'G3DSA:3.40.190.290:FF:000075', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(98792, NULL, 'G3DSA:3.30.1010.10:FF:000111', NULL, NULL, 'Serine/threonine-protein kinase Tel1', NULL, NULL, NULL, NULL, NULL, 4),
(98793, NULL, 'G3DSA:3.40.50.300:FF:001560', NULL, NULL, 'Rab family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(98794, NULL, 'G3DSA:3.10.100.10:FF:000207', NULL, NULL, 'Lymphocyte antigen 75', NULL, NULL, NULL, NULL, NULL, 4),
(98795, NULL, 'G3DSA:4.10.410.10:FF:000093', NULL, NULL, 'Serine protease inhibitor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98796, NULL, 'G3DSA:3.20.20.100:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98797, NULL, 'G3DSA:3.40.50.10190:FF:000365', NULL, NULL, 'BRCT domain protein (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(98798, NULL, 'G3DSA:3.30.420.10:FF:000435', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(98799, NULL, 'G3DSA:3.40.850.10:FF:000139', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(98800, NULL, 'G3DSA:1.10.10.440:FF:000017', NULL, NULL, 'Rho GTPase activating protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(98801, NULL, 'G3DSA:1.10.1370.30:FF:000043', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(98802, NULL, 'G3DSA:1.20.920.10:FF:000146', NULL, NULL, 'YALI0E32307p', NULL, NULL, NULL, NULL, NULL, 4),
(98803, NULL, 'G3DSA:2.70.20.10:FF:000029', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(98804, NULL, 'G3DSA:3.40.50.300:FF:002965', NULL, NULL, 'Cell division control protein', NULL, NULL, NULL, NULL, NULL, 4),
(98805, NULL, 'G3DSA:1.50.40.10:FF:000365', NULL, NULL, 'Mitochondrial carrier protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(98806, NULL, 'G3DSA:2.60.40.10:FF:000098', NULL, NULL, 'receptor-type tyrosine-protein phosphatase F isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(98807, NULL, 'G3DSA:2.60.40.10:FF:004105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98808, NULL, 'G3DSA:2.60.40.10:FF:002419', NULL, NULL, 'T cell receptor delta constant', NULL, NULL, NULL, NULL, NULL, 4),
(98809, NULL, 'G3DSA:3.30.1460.50:FF:000027', NULL, NULL, 'Autophagy-related protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(98810, NULL, 'G3DSA:3.40.630.10:FF:000432', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98811, NULL, 'G3DSA:3.30.70.3400:FF:000013', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(98812, NULL, 'G3DSA:3.40.50.720:FF:001899', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98813, NULL, 'G3DSA:3.40.1260.20:FF:000001', NULL, NULL, 'Ribonuclease G Rng', NULL, NULL, NULL, NULL, NULL, 4),
(98814, NULL, 'G3DSA:2.30.30.380:FF:000012', NULL, NULL, 'Protein transport protein Sec24A', NULL, NULL, NULL, NULL, NULL, 4),
(98815, NULL, 'G3DSA:1.10.20.10:FF:000039', NULL, NULL, 'Nuclear transcription Y subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(98816, NULL, 'G3DSA:3.40.50.300:FF:000609', NULL, NULL, 'PrkA family serine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(98817, NULL, 'G3DSA:2.40.50.140:FF:001184', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98818, NULL, 'G3DSA:2.40.10.10:FF:000631', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98819, NULL, 'G3DSA:1.25.40.10:FF:000541', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(98820, NULL, 'G3DSA:1.10.287.70:FF:000379', NULL, NULL, 'TOK potassium channel', NULL, NULL, NULL, NULL, NULL, 4),
(98821, NULL, 'G3DSA:3.30.1380.20:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98822, NULL, 'G3DSA:3.90.70.10:FF:000012', NULL, NULL, 'ubiquitin carboxyl-terminal hydrolase 19 isoform X2', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(98823, NULL, 'G3DSA:2.60.120.1000:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98824, NULL, 'G3DSA:1.10.1450.10:FF:000162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98825, NULL, 'G3DSA:3.40.50.720:FF:001511', NULL, NULL, 'Malate dehydrogenase 1Aa, NAD (soluble)', NULL, NULL, NULL, NULL, NULL, 4),
(98826, NULL, 'G3DSA:2.30.30.40:FF:000231', NULL, NULL, 'Rho GTPase activating protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(98827, NULL, 'G3DSA:3.40.50.1970:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98828, NULL, 'G3DSA:3.30.200.20:FF:001181', NULL, NULL, 'CMGC/CDK/CDK7 protein kinase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(98829, NULL, 'G3DSA:3.30.230.10:FF:000044', NULL, NULL, 'elongation factor-like GTPase 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(98830, NULL, 'G3DSA:3.40.50.12780:FF:000041', NULL, NULL, 'very long-chain-fatty-acid--CoA ligase bubblegum', NULL, NULL, NULL, NULL, NULL, 4),
(98831, NULL, 'G3DSA:2.30.130.40:FF:000038', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(98832, NULL, 'G3DSA:3.90.550.10:FF:000549', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98833, NULL, 'G3DSA:1.25.40.10:FF:002750', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98834, NULL, 'G3DSA:3.40.50.10990:FF:000009', NULL, NULL, '3,4-dihydroxy-2-butanone-4-phosphate synthase/GTP cyclohydrolase II', NULL, NULL, NULL, NULL, NULL, 4),
(98835, NULL, 'G3DSA:2.60.40.60:FF:000495', NULL, NULL, 'AGAP006731-PA', NULL, NULL, NULL, NULL, NULL, 4),
(98836, NULL, 'G3DSA:2.130.10.10:FF:004937', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98837, NULL, 'G3DSA:1.10.220.10:FF:000050', NULL, NULL, 'Nex-1', NULL, NULL, NULL, NULL, NULL, 4),
(98838, NULL, 'G3DSA:2.160.10.10:FF:000114', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98839, NULL, 'G3DSA:3.30.830.10:FF:000022', NULL, NULL, 'mitochondrial-processing peptidase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(98840, NULL, 'G3DSA:3.30.200.20:FF:001742', NULL, NULL, 'Fructosamine-3-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(98841, NULL, 'G3DSA:3.30.2020.30:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98842, NULL, 'G3DSA:1.10.357.70:FF:000031', NULL, NULL, 'Si:dkey-196h17.9', NULL, NULL, NULL, NULL, NULL, 4),
(98843, NULL, 'G3DSA:1.25.40.20:FF:001859', NULL, NULL, 'No mechanoreceptor potential C, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(98844, NULL, 'G3DSA:3.40.630.30:FF:000590', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98845, NULL, 'G3DSA:1.20.58.60:FF:000045', NULL, NULL, 'Short stop, isoform K', NULL, NULL, NULL, NULL, NULL, 4),
(98846, NULL, 'G3DSA:3.40.190.10:FF:000291', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(98847, NULL, 'G3DSA:3.10.180.10:FF:000117', NULL, NULL, '4-hydroxyphenylpyruvate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(98848, NULL, 'G3DSA:2.60.120.260:FF:000368', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98849, NULL, 'G3DSA:3.30.160.60:FF:004201', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98850, NULL, 'G3DSA:3.10.10.10:FF:000017', NULL, NULL, 'Os04g0191000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(98851, NULL, 'G3DSA:3.40.50.300:FF:000048', NULL, NULL, 'Transitional endoplasmic reticulum ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(98852, NULL, 'G3DSA:3.40.50.2300:FF:000776', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98853, NULL, 'G3DSA:1.20.1070.10:FF:001299', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98854, NULL, 'G3DSA:3.40.50.300:FF:008029', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98855, NULL, 'G3DSA:1.20.1250.20:FF:000669', NULL, NULL, 'MonoCarboxylate Transporter family', NULL, NULL, NULL, NULL, NULL, 4),
(98856, NULL, 'G3DSA:3.90.550.10:FF:000026', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(98857, NULL, 'G3DSA:3.30.160.60:FF:000047', NULL, NULL, 'zinc finger protein OZF', NULL, NULL, NULL, NULL, NULL, 4),
(98858, NULL, 'G3DSA:3.10.330.10:FF:000034', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98859, NULL, 'G3DSA:1.20.1250.40:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98860, NULL, 'G3DSA:2.60.40.1180:FF:000166', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(98861, NULL, 'G3DSA:3.40.50.1820:FF:001284', NULL, NULL, 'UPF0613 protein PB24D3.06c', NULL, NULL, NULL, NULL, NULL, 4),
(98862, NULL, 'G3DSA:3.30.1370.120:FF:000015', NULL, NULL, 'Type II secretion system protein D', NULL, NULL, NULL, NULL, NULL, 4),
(98863, NULL, 'G3DSA:3.30.420.110:FF:000004', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(98864, NULL, 'G3DSA:3.30.1330.20:FF:000043', NULL, NULL, 'Cell division protein FtsZ', NULL, NULL, NULL, NULL, NULL, 4),
(98865, NULL, 'G3DSA:3.40.50.2300:FF:001052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98866, NULL, 'G3DSA:1.10.472.80:FF:000200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98867, NULL, 'G3DSA:2.30.29.30:FF:001118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98868, NULL, 'G3DSA:3.30.565.10:FF:000181', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(98869, NULL, 'G3DSA:2.100.10.30:FF:000004', NULL, NULL, 'Zymogen granule protein 16B', NULL, NULL, NULL, NULL, NULL, 4),
(98870, NULL, 'G3DSA:3.30.70.330:FF:001249', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98871, NULL, 'G3DSA:3.40.50.720:FF:002175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98872, NULL, 'G3DSA:3.30.559.30:FF:000066', NULL, NULL, 'NonRibosomal Peptide Synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(98873, NULL, 'G3DSA:1.10.268.10:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98874, NULL, 'G3DSA:3.30.70.330:FF:002542', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98875, NULL, 'G3DSA:2.160.20.10:FF:000272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98876, NULL, 'G3DSA:2.30.30.40:FF:000198', NULL, NULL, 'Guanine nucleotide exchange factor DBS', NULL, NULL, NULL, NULL, NULL, 4),
(98877, NULL, 'G3DSA:3.30.160.60:FF:000547', NULL, NULL, 'PR domain zinc finger protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(98878, NULL, 'G3DSA:3.90.1100.10:FF:000020', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(98879, NULL, 'G3DSA:2.130.10.10:FF:002167', NULL, NULL, 'WD repeat and FYVE domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(98880, NULL, 'G3DSA:3.30.160.60:FF:004836', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98881, NULL, 'G3DSA:3.30.70.100:FF:000129', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98882, NULL, 'G3DSA:3.10.490.20:FF:000020', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98883, NULL, 'G3DSA:4.10.400.10:FF:000272', NULL, NULL, 'neurotrypsin-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(98884, NULL, 'G3DSA:4.10.240.10:FF:000118', NULL, NULL, 'Filamentous growth regulator 27', NULL, NULL, NULL, NULL, NULL, 4),
(98885, NULL, 'G3DSA:1.25.40.10:FF:002014', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(98886, NULL, 'G3DSA:1.10.418.10:FF:000239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98887, NULL, 'G3DSA:3.20.20.60:FF:000038', NULL, NULL, 'Citrate lyase subunit beta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(98888, NULL, 'G3DSA:3.40.50.300:FF:000424', NULL, NULL, 'Structural maintenance of chromosomes 3', NULL, NULL, NULL, NULL, NULL, 4),
(98889, NULL, 'G3DSA:1.10.3480.10:FF:000006', NULL, NULL, 'Putative nitrate reductase delta chain NarJ2', NULL, NULL, NULL, NULL, NULL, 4),
(98890, NULL, 'G3DSA:3.30.160.60:FF:001059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(98891, NULL, 'G3DSA:3.40.50.720:FF:002124', NULL, NULL, 'NADP-dependent malic enzyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(98892, NULL, 'G3DSA:3.40.50.12780:FF:000226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98893, NULL, 'G3DSA:2.60.40.10:FF:004336', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98894, NULL, 'G3DSA:2.30.30.40:FF:000254', NULL, NULL, 'Myosin I MyoA/Myo5', NULL, NULL, NULL, NULL, NULL, 4),
(98895, NULL, 'G3DSA:3.80.10.10:FF:003763', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98896, NULL, 'G3DSA:3.60.40.10:FF:000051', NULL, NULL, 'Protein phosphatase 2C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(98897, NULL, 'G3DSA:2.40.70.10:FF:000056', NULL, NULL, 'Eukaryotic aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(98898, NULL, 'G3DSA:1.10.1740.10:FF:000026', NULL, NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(98899, NULL, 'G3DSA:3.30.160.60:FF:000603', NULL, NULL, 'PR domain zinc finger protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(98900, NULL, 'G3DSA:3.30.160.60:FF:001115', NULL, NULL, 'Zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(98901, NULL, 'G3DSA:1.25.40.20:FF:000842', NULL, NULL, '60 kDa lysophospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(98902, NULL, 'G3DSA:3.80.10.10:FF:002302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98903, NULL, 'G3DSA:3.40.50.300:FF:007405', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98904, NULL, 'G3DSA:3.90.1600.10:FF:000064', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(98905, NULL, 'G3DSA:3.30.230.10:FF:000229', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(98906, NULL, 'G3DSA:3.30.540.10:FF:000039', NULL, NULL, 'SAL1 phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98907, NULL, 'G3DSA:2.10.220.10:FF:000035', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(98908, NULL, 'G3DSA:1.20.5.110:FF:000328', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98909, NULL, 'G3DSA:3.60.20.10:FF:000044', NULL, NULL, 'Probable proteasome subunit alpha type-7', NULL, NULL, NULL, NULL, NULL, 4),
(98910, NULL, 'G3DSA:1.10.472.10:FF:000455', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98911, NULL, 'G3DSA:1.10.620.20:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98912, NULL, 'G3DSA:3.30.950.10:FF:000020', NULL, NULL, 'Uroporphyrin-III methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(98913, NULL, 'G3DSA:1.10.540.10:FF:000102', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(98914, NULL, 'G3DSA:1.50.10.20:FF:000130', NULL, NULL, 'Protein farnesyltransferase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(98915, NULL, 'G3DSA:4.10.860.120:FF:000031', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(98916, NULL, 'G3DSA:2.30.36.70:FF:000017', NULL, NULL, 'Actin-87E-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(98917, NULL, 'G3DSA:3.40.30.10:FF:000040', NULL, NULL, 'Thiol:disulfide interchange protein DsbE', NULL, NULL, NULL, NULL, NULL, 4),
(98918, NULL, 'G3DSA:3.40.50.200:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98919, NULL, 'G3DSA:2.130.10.10:FF:002223', NULL, NULL, 'Cleavage and polyadenylation specific factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(98920, NULL, 'G3DSA:1.10.150.80:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98921, NULL, 'G3DSA:3.40.190.100:FF:000001', NULL, NULL, 'Glycine betaine transporter periplasmic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(98922, NULL, 'G3DSA:3.30.70.1230:FF:000154', NULL, NULL, 'Soluble guanylyl cyclase beta1', NULL, NULL, NULL, NULL, NULL, 4),
(98923, NULL, 'G3DSA:1.10.10.10:FF:000213', NULL, NULL, 'Coniferyl alcohol 9-O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(98924, NULL, 'G3DSA:3.40.1010.20:FF:000005', NULL, NULL, 'mRNA, clone: RTFL01-07-F02', NULL, NULL, NULL, NULL, NULL, 4),
(98925, NULL, 'G3DSA:2.60.40.2540:FF:000001', NULL, NULL, 'Sodium-type flagellar protein MotY', NULL, NULL, NULL, NULL, NULL, 4),
(98926, NULL, 'G3DSA:2.60.120.340:FF:000010', NULL, NULL, 'Os01g0909500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(98927, NULL, 'G3DSA:3.40.50.720:FF:002231', NULL, NULL, 'Glyoxylate reductase/hydroxypyruvate reductase b', NULL, NULL, NULL, NULL, NULL, 4),
(98928, NULL, 'G3DSA:3.30.1680.10:FF:000049', NULL, NULL, 'Sema domain, immunoglobulin domain (Ig), transmembrane domain (TM) and short cytoplasmic domain, (semaphorin) 4Ab', NULL, NULL, NULL, NULL, NULL, 4),
(98929, NULL, 'G3DSA:3.10.110.10:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98930, NULL, 'G3DSA:1.25.40.10:FF:003475', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(98931, NULL, 'G3DSA:2.60.34.10:FF:000117', NULL, NULL, 'AGAP007682-PA', NULL, NULL, NULL, NULL, NULL, 4),
(98932, NULL, 'G3DSA:1.20.1070.10:FF:001855', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98933, NULL, 'G3DSA:3.40.47.10:FF:000191', NULL, NULL, 'Hydroxymethylglutaryl-CoA synthase', NULL, NULL, NULL, NULL, NULL, 4),
(98934, NULL, 'G3DSA:4.10.240.10:FF:000169', NULL, NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(98935, NULL, 'G3DSA:3.10.20.90:FF:000671', NULL, NULL, 'Ubiquitin family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98936, NULL, 'G3DSA:3.90.70.10:FF:000248', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(98937, NULL, 'G3DSA:1.25.10.10:FF:002361', NULL, NULL, 'Armadillo repeat-containing protein 6 homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(98938, NULL, 'G3DSA:3.30.260.10:FF:000113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98939, NULL, 'G3DSA:3.30.160.60:FF:005393', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98940, NULL, 'G3DSA:3.40.50.300:FF:004606', NULL, NULL, 'Leucine-rich repeat serine/threonine-protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(98941, NULL, 'G3DSA:3.40.50.1820:FF:001784', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98942, NULL, 'G3DSA:3.40.50.880:FF:000002', NULL, NULL, 'CTP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(98943, NULL, 'G3DSA:3.40.50.1820:FF:001840', NULL, NULL, 'Gastric triacylglycerol lipase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98944, NULL, 'G3DSA:3.40.50.1010:FF:000193', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98945, NULL, 'G3DSA:3.20.20.80:FF:000201', NULL, NULL, 'Alpha-L-fucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(98946, NULL, 'G3DSA:4.10.270.10:FF:000002', NULL, NULL, 'unconventional myosin-XVIIIa isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(98947, NULL, 'G3DSA:2.170.270.10:FF:000079', NULL, NULL, 'GM24661', NULL, NULL, NULL, NULL, NULL, 4),
(98948, NULL, 'G3DSA:2.60.40.10:FF:003824', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98949, NULL, 'G3DSA:2.40.70.10:FF:000112', NULL, NULL, 'Plasmepsin IX', NULL, NULL, NULL, NULL, NULL, 4),
(98950, NULL, 'G3DSA:3.30.505.10:FF:000020', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(98951, NULL, 'G3DSA:3.30.1140.40:FF:000006', NULL, NULL, 'Dynein light chain', NULL, NULL, NULL, NULL, NULL, 4),
(98952, NULL, 'G3DSA:1.10.1280.10:FF:000002', NULL, NULL, 'L-dopachrome tautomerase', NULL, NULL, NULL, NULL, NULL, 4),
(98953, NULL, 'G3DSA:1.10.1420.10:FF:000093', NULL, NULL, 'DNA mismatch repair protein MSH2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98954, NULL, 'G3DSA:2.40.10.10:FF:000575', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98955, NULL, 'G3DSA:3.40.50.150:FF:001711', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98956, NULL, 'G3DSA:3.30.260.10:FF:000057', NULL, NULL, '60 kDa chaperonin GroEL', NULL, NULL, NULL, NULL, NULL, 4),
(98957, NULL, 'G3DSA:3.30.70.330:FF:001642', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(98958, NULL, 'G3DSA:2.60.40.2310:FF:000005', NULL, NULL, 'Subtilisin-like protease SBT2.1', NULL, NULL, NULL, NULL, NULL, 4),
(98959, NULL, 'G3DSA:3.30.160.60:FF:004729', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98960, NULL, 'G3DSA:1.20.1070.10:FF:001799', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98961, NULL, 'G3DSA:1.10.510.10:FF:000393', NULL, NULL, 'C-type lectin receptor-like tyrosine-protein kinase At1g52310', NULL, NULL, NULL, NULL, NULL, 4),
(98962, NULL, 'G3DSA:3.30.420.40:FF:000039', NULL, NULL, 'Hypoxia up-regulated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(98963, NULL, 'G3DSA:3.10.330.10:FF:000039', NULL, NULL, 'cDNA FLJ54349, highly similar to Vesicle-fusing ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(98964, NULL, 'G3DSA:2.60.40.150:FF:000646', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98965, NULL, 'G3DSA:1.20.1310.10:FF:000161', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98966, NULL, 'G3DSA:1.20.1510.10:FF:000035', NULL, NULL, 'Zinc transporter 5', NULL, NULL, NULL, NULL, NULL, 4),
(98967, NULL, 'G3DSA:2.130.10.10:FF:004196', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(98968, NULL, 'G3DSA:1.10.510.10:FF:002303', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98969, NULL, 'G3DSA:1.50.40.10:FF:000421', NULL, NULL, 'Mitochondrial brown fat uncoupling protein 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(98970, NULL, 'G3DSA:2.60.120.260:FF:000604', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98971, NULL, 'G3DSA:2.160.20.20:FF:000005', NULL, NULL, 'AIDA-I family autotransporter YfaL', NULL, NULL, NULL, NULL, NULL, 4),
(98972, NULL, 'G3DSA:1.20.120.350:FF:000023', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(98973, NULL, 'G3DSA:1.10.630.10:FF:000328', NULL, NULL, 'Cytochrome P-450 IIC5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98974, NULL, 'G3DSA:1.20.120.1760:FF:000060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98975, NULL, 'G3DSA:3.40.50.300:FF:005899', NULL, NULL, 'tRNA modification GTPase mss1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(98976, NULL, 'G3DSA:3.40.50.300:FF:005955', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(98977, NULL, 'G3DSA:1.10.510.10:FF:002298', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98978, NULL, 'G3DSA:1.25.40.10:FF:004779', NULL, NULL, 'Os06g0705300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(98979, NULL, 'G3DSA:1.10.510.10:FF:001786', NULL, NULL, 'Ser/thr kinase', NULL, NULL, NULL, NULL, NULL, 4),
(98980, NULL, 'G3DSA:3.30.470.30:FF:000040', NULL, NULL, 'mRNA-capping enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(98981, NULL, 'G3DSA:1.10.287.10:FF:000041', NULL, NULL, 'CTD phosphatase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(98982, NULL, 'G3DSA:3.30.70.1350:FF:000016', NULL, NULL, 'Co/Zn/Cd cation transporter', NULL, NULL, NULL, NULL, NULL, 4),
(98983, NULL, 'G3DSA:3.30.565.10:FF:000349', NULL, NULL, 'Histidine kinase osmosensor and regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(98984, NULL, 'G3DSA:3.90.640.90:FF:000001', NULL, NULL, 'TOB1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(98985, NULL, 'G3DSA:1.10.1820.10:FF:000027', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(98986, NULL, 'G3DSA:1.10.10.750:FF:000009', NULL, NULL, 'TBC1 domain family member 22A', NULL, NULL, NULL, NULL, NULL, 4),
(98987, NULL, 'G3DSA:2.60.120.10:FF:000185', NULL, NULL, 'Predicted transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(98988, NULL, 'G3DSA:2.70.50.30:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98989, NULL, 'G3DSA:2.170.270.10:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98990, NULL, 'G3DSA:3.30.160.60:FF:003476', NULL, NULL, 'Zinc finger protein 607', NULL, NULL, NULL, NULL, NULL, 4),
(98991, NULL, 'G3DSA:2.60.40.10:FF:004387', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98992, NULL, 'G3DSA:2.170.270.10:FF:000023', NULL, NULL, 'putative histone-lysine N-methyltransferase PRDM6', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(98993, NULL, 'G3DSA:3.30.50.10:FF:000143', NULL, NULL, 'Thyroid hormone receptor alpha', NULL, NULL, NULL, NULL, NULL, 4),
(98994, NULL, 'G3DSA:1.20.1440.100:FF:000016', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(98995, NULL, 'G3DSA:3.30.70.330:FF:001693', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(98996, NULL, 'G3DSA:2.120.10.30:FF:000610', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(98997, NULL, 'G3DSA:3.40.50.300:FF:000317', NULL, NULL, 'Amino acid ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(98998, NULL, 'G3DSA:3.40.50.2300:FF:000208', NULL, NULL, 'Branched-chain amino acid ABC transporter, substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(98999, NULL, 'G3DSA:1.10.10.2320:FF:000003', NULL, NULL, 'Phenylalanyl-tRNA synthetase alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99000, NULL, 'G3DSA:3.40.1280.10:FF:000050', NULL, NULL, 'tRNA (guanine-N(1)-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(99001, NULL, 'G3DSA:2.60.40.150:FF:000702', NULL, NULL, 'C2 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(99002, NULL, 'G3DSA:3.30.2340.10:FF:000001', NULL, NULL, 'tRNA pseudouridine synthase D', NULL, NULL, NULL, NULL, NULL, 4),
(99003, NULL, 'G3DSA:1.10.510.10:FF:002247', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99004, NULL, 'G3DSA:1.50.40.10:FF:000477', NULL, NULL, 'Mitochondrial substrate carrier', NULL, NULL, NULL, NULL, NULL, 4),
(99005, NULL, 'G3DSA:3.40.50.150:FF:000357', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(99006, NULL, 'G3DSA:1.20.1050.130:FF:000021', NULL, NULL, 'General transcription factor ii, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99007, NULL, 'G3DSA:3.40.50.150:FF:000306', NULL, NULL, 'Arsenite methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(99008, NULL, 'G3DSA:3.40.47.10:FF:000039', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(99009, NULL, 'G3DSA:4.10.240.10:FF:000225', NULL, NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(99010, NULL, 'G3DSA:2.60.40.150:FF:000242', NULL, NULL, 'Calcium-dependent lipid-binding (CaLB domain) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(99011, NULL, 'G3DSA:1.20.1070.10:FF:001911', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99012, NULL, 'G3DSA:3.30.160.60:FF:004881', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99013, NULL, 'G3DSA:3.30.70.100:FF:000174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99014, NULL, 'G3DSA:3.30.2420.10:FF:000002', NULL, NULL, 'TonB-like periplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(99015, NULL, 'G3DSA:2.10.25.10:FF:001532', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99016, NULL, 'G3DSA:3.20.20.60:FF:000083', NULL, NULL, 'N-Acetyl-D-Glucosamine phosphotransferase system transporter', NULL, NULL, NULL, NULL, NULL, 4),
(99017, NULL, 'G3DSA:3.10.450.580:FF:000009', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(99018, NULL, 'G3DSA:3.90.70.10:FF:000304', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(99019, NULL, 'G3DSA:3.30.310.80:FF:000026', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(99020, NULL, 'G3DSA:3.40.50.300:FF:005039', NULL, NULL, 'Protein CBG21674', NULL, NULL, NULL, NULL, NULL, 4),
(99021, NULL, 'G3DSA:1.20.1070.10:FF:000006', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(99022, NULL, 'G3DSA:1.10.10.60:FF:000762', NULL, NULL, 'Homeobox protein Hox-B8', NULL, NULL, NULL, NULL, NULL, 4),
(99023, NULL, 'G3DSA:3.30.70.270:FF:000197', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99024, NULL, 'G3DSA:1.20.58.60:FF:000124', NULL, NULL, 'SEC14 domain and spectrin repeat-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(99025, NULL, 'G3DSA:1.10.287.310:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99026, NULL, 'G3DSA:2.80.10.50:FF:000091', NULL, NULL, 'Protein CBR-ITR-1, isoform b', NULL, NULL, NULL, NULL, NULL, 4),
(99027, NULL, 'G3DSA:1.20.120.670:FF:000001', NULL, NULL, 'N-acetyl-alpha-glucosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(99028, NULL, 'G3DSA:2.130.10.10:FF:003684', NULL, NULL, 'Coatomer, alpha chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99029, NULL, 'G3DSA:2.60.40.10:FF:000154', NULL, NULL, 'filamin-B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(99030, NULL, 'G3DSA:3.30.60.30:FF:000020', NULL, NULL, 'tomoregulin-2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(99031, NULL, 'G3DSA:1.10.472.10:FF:000404', NULL, NULL, 'Cyclin domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(99032, NULL, 'G3DSA:1.10.238.10:FF:000293', NULL, NULL, 'Calcium-binding protein CML42', NULL, NULL, NULL, NULL, NULL, 4),
(99033, NULL, 'G3DSA:2.30.30.140:FF:000064', NULL, NULL, 'Tudor domain containing 6', NULL, NULL, NULL, NULL, NULL, 4),
(99034, NULL, 'G3DSA:3.40.50.1820:FF:000727', NULL, NULL, 'CocE/NonD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(99035, NULL, 'G3DSA:3.30.230.10:FF:000336', NULL, NULL, 'Lon protease homolog 2 peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(99036, NULL, 'G3DSA:2.130.10.10:FF:000773', NULL, NULL, 'Guanine nucleotide-binding protein subunit beta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(99037, NULL, 'G3DSA:1.10.510.10:FF:003203', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99038, NULL, 'G3DSA:1.20.1250.20:FF:000321', NULL, NULL, 'Solute carrier family 45 member 2', NULL, NULL, NULL, NULL, NULL, 4),
(99039, NULL, 'G3DSA:3.30.160.60:FF:003420', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99040, NULL, 'G3DSA:1.20.1420.30:FF:000034', NULL, NULL, 'YDL206W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(99041, NULL, 'G3DSA:1.10.560.10:FF:000160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99042, NULL, 'G3DSA:3.40.50.10810:FF:000208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99043, NULL, 'G3DSA:3.40.50.300:FF:000368', NULL, NULL, 'U5 small nuclear ribonucleoprotein 200 kDa helicase', NULL, NULL, NULL, NULL, NULL, 4),
(99044, NULL, 'G3DSA:3.20.20.80:FF:000089', NULL, NULL, 'Periplasmic alpha-amylase', NULL, NULL, NULL, NULL, NULL, 4),
(99045, NULL, 'G3DSA:1.25.40.20:FF:000893', NULL, NULL, 'Molting protein MLT-4', NULL, NULL, NULL, NULL, NULL, 4),
(99046, NULL, 'G3DSA:1.20.120.20:FF:000026', NULL, NULL, 'Apolipoprotein E', NULL, NULL, NULL, NULL, NULL, 4),
(99047, NULL, 'G3DSA:3.60.10.10:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99048, NULL, 'G3DSA:3.30.450.20:FF:000597', NULL, NULL, 'BfiS', NULL, NULL, NULL, NULL, NULL, 4),
(99049, NULL, 'G3DSA:2.60.34.10:FF:000005', NULL, NULL, 'Chaperone protein HscA homolog', NULL, NULL, NULL, NULL, NULL, 4),
(99050, NULL, 'G3DSA:3.30.9.10:FF:000238', NULL, NULL, 'GH19226p', NULL, NULL, NULL, NULL, NULL, 4),
(99051, NULL, 'G3DSA:3.30.40.10:FF:001659', NULL, NULL, 'UDP-sugar-dependent glycosyltransferase 52', NULL, NULL, NULL, NULL, NULL, 4),
(99052, NULL, 'G3DSA:1.10.10.10:FF:000157', NULL, NULL, 'Response regulator receiver', NULL, NULL, NULL, NULL, NULL, 4),
(99053, NULL, 'G3DSA:2.130.10.10:FF:004084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99054, NULL, 'G3DSA:2.10.110.10:FF:000206', NULL, NULL, 'Thyroid hormone receptor interactor 6', NULL, NULL, NULL, NULL, NULL, 4),
(99055, NULL, 'G3DSA:3.70.10.10:FF:000026', NULL, NULL, 'Checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(99056, NULL, 'G3DSA:2.40.50.140:FF:000627', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(99057, NULL, 'G3DSA:1.10.287.1490:FF:000093', NULL, NULL, 'At1g64330', NULL, NULL, NULL, NULL, NULL, 4),
(99058, NULL, 'G3DSA:3.30.460.10:FF:000089', NULL, NULL, 'Poly(U) Polymerase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(99059, NULL, 'G3DSA:2.30.29.30:FF:000124', NULL, NULL, 'carboxyl-terminal PDZ ligand of neuronal nitric oxide synthase protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(99060, NULL, 'G3DSA:2.130.10.10:FF:002279', NULL, NULL, 'Embryo sac development arrest protein', NULL, NULL, NULL, NULL, NULL, 4),
(99061, NULL, 'G3DSA:3.30.260.10:FF:000052', NULL, NULL, 'T-complex protein 1 subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(99062, NULL, 'G3DSA:1.25.40.10:FF:001558', NULL, NULL, 'Os01g0818200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(99063, NULL, 'G3DSA:3.30.160.60:FF:001003', NULL, NULL, 'Zinc finger protein 444', NULL, NULL, NULL, NULL, NULL, 4),
(99064, NULL, 'G3DSA:1.20.272.10:FF:000078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99065, NULL, 'G3DSA:1.10.1600.10:FF:000039', NULL, NULL, 'Putative KU70 protein', NULL, NULL, NULL, NULL, NULL, 4),
(99066, NULL, 'G3DSA:3.40.50.1000:FF:000257', NULL, NULL, 'Haloacid dehalogenase-like hydrolase (HAD) superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(99067, NULL, 'G3DSA:3.90.226.10:FF:000223', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(99068, NULL, 'G3DSA:3.30.450.290:FF:000002', NULL, NULL, 'Sensor protein, DUF3365, HAMP and PAS domain-containing, heme-binding', NULL, NULL, NULL, NULL, NULL, 4),
(99069, NULL, 'G3DSA:2.40.70.10:FF:000168', NULL, NULL, 'Eukaryotic aspartyl protease family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(99070, NULL, 'G3DSA:1.10.510.10:FF:002803', NULL, NULL, 'CAMKK/CAMKK-META protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(99071, NULL, 'G3DSA:1.25.10.10:FF:000736', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(99072, NULL, 'G3DSA:3.10.450.350:FF:000002', NULL, NULL, 'Murein DD-endopeptidase MepM', NULL, NULL, NULL, NULL, NULL, 4),
(99073, NULL, 'G3DSA:1.10.510.10:FF:003607', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99074, NULL, 'G3DSA:1.25.40.10:FF:001906', NULL, NULL, 'ATPase expression protein', NULL, NULL, NULL, NULL, NULL, 4),
(99075, NULL, 'G3DSA:2.40.70.10:FF:000224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99076, NULL, 'G3DSA:3.30.360.10:FF:000093', NULL, NULL, 'NAD(P)-dependent dyhydrogenase, Gfo/Idh/MocA family', NULL, NULL, NULL, NULL, NULL, 4),
(99077, NULL, 'G3DSA:2.130.10.10:FF:002627', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99078, NULL, 'G3DSA:1.20.58.90:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99079, NULL, 'G3DSA:3.40.50.2000:FF:000040', NULL, NULL, 'UDP-glycosyltransferase 76C1', NULL, NULL, NULL, NULL, NULL, 4),
(99080, NULL, 'G3DSA:1.10.1820.10:FF:000022', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(99081, NULL, 'G3DSA:1.25.40.20:FF:001275', NULL, NULL, 'Chromosome condensation complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(99082, NULL, 'G3DSA:2.60.40.1510:FF:000041', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(99083, NULL, 'G3DSA:3.30.70.330:FF:002946', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99084, NULL, 'G3DSA:1.25.40.20:FF:001331', NULL, NULL, 'Ankyrin repeat-containing protein P16F5.05c', NULL, NULL, NULL, NULL, NULL, 4),
(99085, NULL, 'G3DSA:3.90.226.10:FF:000167', NULL, NULL, 'ClpP/crotonase-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(99086, NULL, 'G3DSA:3.20.20.330:FF:000033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(99087, NULL, 'G3DSA:1.10.260.40:FF:000011', NULL, NULL, 'homeobox-containing protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(99088, NULL, 'G3DSA:3.30.2230.10:FF:000004', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 32', NULL, NULL, NULL, NULL, NULL, 4),
(99089, NULL, 'G3DSA:1.20.1440.180:FF:000001', NULL, NULL, 'Serine/threonine-protein kinase/endoribonuclease IRE1', NULL, NULL, NULL, NULL, NULL, 4),
(99090, NULL, 'G3DSA:3.40.30.10:FF:000444', NULL, NULL, 'Cytochrome C biogenesis protein DipZ', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(99091, NULL, 'G3DSA:3.30.428.10:FF:000048', NULL, NULL, 'Galactose-1-phosphate uridylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(99092, NULL, 'G3DSA:3.10.250.10:FF:000089', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99093, NULL, 'G3DSA:1.10.506.10:FF:000051', NULL, NULL, 'Receptor-mediated endocytosis protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(99094, NULL, 'G3DSA:1.25.10.10:FF:000388', NULL, NULL, 'Huntingtin', NULL, NULL, NULL, NULL, NULL, 4),
(99095, NULL, 'G3DSA:3.30.1380.10:FF:000009', NULL, NULL, 'Desert hedgehog, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99096, NULL, 'G3DSA:2.40.30.10:FF:000222', NULL, NULL, 'tRNA-specific 2-thiouridylase', NULL, NULL, NULL, NULL, NULL, 4),
(99097, NULL, 'G3DSA:3.10.25.10:FF:000001', NULL, NULL, 'Methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(99098, NULL, 'G3DSA:3.50.50.60:FF:000415', NULL, NULL, 'AT3g04650/F7O18_13', NULL, NULL, NULL, NULL, NULL, 4),
(99099, NULL, 'G3DSA:1.10.510.10:FF:003259', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99100, NULL, 'G3DSA:3.80.10.10:FF:001846', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(99101, NULL, 'G3DSA:6.10.30.50:FF:000001', NULL, NULL, 'Cytokinesis sepA protein', NULL, NULL, NULL, NULL, NULL, 4),
(99102, NULL, 'G3DSA:3.30.2350.10:FF:000058', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(99103, NULL, 'G3DSA:3.30.2310.10:FF:000005', NULL, NULL, 'Methyltransferase, YaeB/AF_0241 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(99104, NULL, 'G3DSA:3.40.30.10:FF:000837', NULL, NULL, 'Protein disulfide isomerase1-1', NULL, NULL, NULL, NULL, NULL, 4),
(99105, NULL, 'G3DSA:3.30.70.330:FF:002598', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99106, NULL, 'G3DSA:2.60.120.260:FF:000609', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99107, NULL, 'G3DSA:1.10.1300.10:FF:000095', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(99108, NULL, 'G3DSA:3.40.1360.10:FF:000051', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(99109, NULL, 'G3DSA:1.10.3080.10:FF:000077', NULL, NULL, 'Chloride channel protein 1,2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99110, NULL, 'G3DSA:2.30.29.70:FF:000001', NULL, NULL, 'Proteasomal ubiquitin receptor ADRM1', NULL, NULL, NULL, NULL, NULL, 4),
(99111, NULL, 'G3DSA:3.40.50.300:FF:002341', NULL, NULL, 'tRNA (Adenosine(37)-N6)-threonylcarbamoyltransferase complex ATPase subunit type 1 TsaE', NULL, NULL, NULL, NULL, NULL, 4),
(99112, NULL, 'G3DSA:1.20.1250.20:FF:001625', NULL, NULL, 'Major facilitator superfamily domain-containing 4B5', NULL, NULL, NULL, NULL, NULL, 4),
(99113, NULL, 'G3DSA:3.90.470.20:FF:000080', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(99114, NULL, 'G3DSA:3.40.50.2020:FF:000102', NULL, NULL, 'Hypoxanthine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(99115, NULL, 'G3DSA:3.30.160.60:FF:005893', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99116, NULL, 'G3DSA:3.10.20.90:FF:000519', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(99117, NULL, 'G3DSA:2.130.10.10:FF:004140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99118, NULL, 'G3DSA:3.40.50.10330:FF:000093', NULL, NULL, 'NAD kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(99119, NULL, 'G3DSA:1.10.150.20:FF:000019', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(99120, NULL, 'G3DSA:3.40.50.300:FF:003246', NULL, NULL, 'RAS related 2', NULL, NULL, NULL, NULL, NULL, 4),
(99121, NULL, 'G3DSA:3.10.450.240:FF:000025', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(99122, NULL, 'G3DSA:1.10.8.60:FF:000103', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(99123, NULL, 'G3DSA:1.10.1520.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99124, NULL, 'G3DSA:2.30.42.10:FF:000143', NULL, NULL, 'Membrane associated guanylate kinase, WW and PDZ domain containing 2', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(99125, NULL, 'G3DSA:1.10.1740.10:FF:000021', NULL, NULL, 'ECF RNA polymerase sigma factor SigK', NULL, NULL, NULL, NULL, NULL, 4),
(99126, NULL, 'G3DSA:3.70.10.10:FF:000077', NULL, NULL, 'Checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(99127, NULL, 'G3DSA:1.10.238.10:FF:001310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99128, NULL, 'G3DSA:3.40.30.10:FF:000096', NULL, NULL, 'Glutathione S-transferase kappa', NULL, NULL, NULL, NULL, NULL, 4),
(99129, NULL, 'G3DSA:1.10.10.540:FF:000008', NULL, NULL, 'XPC-binding_domain/UBA/TS-N_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(99130, NULL, 'G3DSA:1.20.1250.10:FF:000043', NULL, NULL, 'Growth hormone d5', NULL, NULL, NULL, NULL, NULL, 4),
(99131, NULL, 'G3DSA:1.20.5.110:FF:000323', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(99132, NULL, 'G3DSA:3.30.160.60:FF:002464', NULL, NULL, 'Zinc finger protein 668', NULL, NULL, NULL, NULL, NULL, 4),
(99133, NULL, 'G3DSA:3.40.5.10:FF:000022', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(99134, NULL, 'G3DSA:1.10.287.110:FF:000397', NULL, NULL, 'Chaperone protein dnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(99135, NULL, 'G3DSA:3.40.50.1820:FF:001239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99136, NULL, 'G3DSA:1.50.40.10:FF:000426', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99137, NULL, 'G3DSA:1.10.470.10:FF:000001', NULL, NULL, 'Variant surface glycoprotein (VSG), putative', NULL, NULL, NULL, NULL, NULL, 4),
(99138, NULL, 'G3DSA:3.10.105.10:FF:000078', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(99139, NULL, 'G3DSA:3.30.470.30:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99140, NULL, 'G3DSA:1.10.8.710:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99141, NULL, 'G3DSA:3.40.50.1000:FF:000656', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99142, NULL, 'G3DSA:1.10.8.60:FF:000047', NULL, NULL, 'DNA-binding transcriptional regulator TyrR', NULL, NULL, NULL, NULL, NULL, 4),
(99143, NULL, 'G3DSA:3.10.250.10:FF:000038', NULL, NULL, 'Scavenger receptor family member expressed on T cells 1', NULL, NULL, NULL, NULL, NULL, 4),
(99144, NULL, 'G3DSA:3.80.10.10:FF:001902', NULL, NULL, 'Uncharacterized protein AT4g34280', NULL, NULL, NULL, NULL, NULL, 4),
(99145, NULL, 'G3DSA:3.10.100.10:FF:000382', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99146, NULL, 'G3DSA:1.10.405.10:FF:000024', NULL, NULL, 'Rab geranylgeranyl transferase component A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99147, NULL, 'G3DSA:1.10.10.520:FF:000002', NULL, NULL, 'SUMO-activating enzyme subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(99148, NULL, 'G3DSA:3.30.2020.30:FF:000005', NULL, NULL, 'Unplaced genomic scaffold supercont2.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(99149, NULL, 'G3DSA:1.10.238.10:FF:000248', NULL, NULL, 'Calcium-dependent protein kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(99150, NULL, 'G3DSA:2.20.25.530:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99151, NULL, 'G3DSA:3.30.470.20:FF:000211', NULL, NULL, 'Gll0508 protein', NULL, NULL, NULL, NULL, NULL, 4),
(99152, NULL, 'G3DSA:3.10.490.20:FF:000025', NULL, NULL, 'GG12117', NULL, NULL, NULL, NULL, NULL, 4),
(99153, NULL, 'G3DSA:1.20.1070.10:FF:001063', NULL, NULL, 'Putative dopamine type 2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(99154, NULL, 'G3DSA:3.40.30.10:FF:000388', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(99155, NULL, 'G3DSA:1.25.10.10:FF:000444', NULL, NULL, 'Coatomer subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(99156, NULL, 'G3DSA:1.20.5.110:FF:000267', NULL, NULL, 'Synaptosomal-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(99157, NULL, 'G3DSA:3.30.70.330:FF:002042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99158, NULL, 'G3DSA:3.30.1370.120:FF:000010', NULL, NULL, 'Type IV pilus secretin PilQ', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(99159, NULL, 'G3DSA:3.40.366.10:FF:000014', NULL, NULL, 'Malonyl CoA-acyl carrier protein transacylase', NULL, NULL, NULL, NULL, NULL, 4),
(99160, NULL, 'G3DSA:2.60.40.1400:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99161, NULL, 'G3DSA:3.30.160.60:FF:001907', NULL, NULL, 'AZF1 (YOR113W)', NULL, NULL, NULL, NULL, NULL, 4),
(99162, NULL, 'G3DSA:3.30.70.330:FF:000125', NULL, NULL, 'Putative ribonucleoprotein PTB-binding 1', NULL, NULL, NULL, NULL, NULL, 4),
(99163, NULL, 'G3DSA:2.40.50.1070:FF:000003', NULL, NULL, '23S rRNA (Uracil-5-)-methyltransferase RumA', NULL, NULL, NULL, NULL, NULL, 4),
(99164, NULL, 'G3DSA:2.10.25.10:FF:000571', NULL, NULL, 'Hyaluronan-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(99165, NULL, 'G3DSA:2.60.40.1120:FF:000087', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(99166, NULL, 'G3DSA:3.90.226.10:FF:000274', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(99167, NULL, 'G3DSA:3.30.160.60:FF:003824', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99168, NULL, 'G3DSA:3.30.479.20:FF:000028', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(99169, NULL, 'G3DSA:1.20.910.10:FF:000033', NULL, NULL, 'Pyrroloquinoline-quinone synthase', NULL, NULL, NULL, NULL, NULL, 4),
(99170, NULL, 'G3DSA:3.60.21.10:FF:000479', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99171, NULL, 'G3DSA:3.40.1190.10:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99172, NULL, 'G3DSA:3.40.50.10860:FF:000021', NULL, NULL, 'Quinate repressor protein', NULL, NULL, NULL, NULL, NULL, 4),
(99173, NULL, 'G3DSA:1.10.150.60:FF:000008', NULL, NULL, 'Putative AT-rich interactive domain-containing protein 3B', NULL, NULL, NULL, NULL, NULL, 4),
(99174, NULL, 'G3DSA:1.20.1250.20:FF:001569', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99175, NULL, 'G3DSA:2.130.10.10:FF:005101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99176, NULL, 'G3DSA:1.10.510.10:FF:003208', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99177, NULL, 'G3DSA:1.10.540.10:FF:000158', NULL, NULL, 'Putative medium-chain specific acyl-CoA dehydrogenase, mitochondrial-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(99178, NULL, 'G3DSA:3.30.1370.10:FF:000216', NULL, NULL, 'Vigilin 1', NULL, NULL, NULL, NULL, NULL, 4),
(99179, NULL, 'G3DSA:3.20.20.220:FF:000056', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(99180, NULL, 'G3DSA:3.40.50.300:FF:003302', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(99181, NULL, 'G3DSA:2.40.128.20:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99182, NULL, 'G3DSA:3.30.70.330:FF:002654', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99183, NULL, 'G3DSA:1.10.246.60:FF:000006', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit J', NULL, NULL, NULL, NULL, NULL, 4),
(99184, NULL, 'G3DSA:3.30.160.60:FF:005218', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99185, NULL, 'G3DSA:3.10.20.90:FF:000620', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99186, NULL, 'G3DSA:1.25.40.10:FF:001002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99187, NULL, 'G3DSA:2.40.50.360:FF:000002', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(99188, NULL, 'G3DSA:2.130.10.10:FF:004932', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99189, NULL, 'G3DSA:1.10.287.690:FF:000031', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(99190, NULL, 'G3DSA:2.40.128.20:FF:000007', NULL, NULL, 'Alpha-1-microglobulin/bikunin precursor', NULL, NULL, NULL, NULL, NULL, 4),
(99191, NULL, 'G3DSA:3.30.710.10:FF:000311', NULL, NULL, 'Si:dkey-6b12.5', NULL, NULL, NULL, NULL, NULL, 4),
(99192, NULL, 'G3DSA:3.40.50.10710:FF:000004', NULL, NULL, 'Ribonuclease J', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(99193, NULL, 'G3DSA:2.60.40.10:FF:003032', NULL, NULL, 'Lymphocyte activating 3', NULL, NULL, NULL, NULL, NULL, 4),
(99194, NULL, 'G3DSA:3.90.550.10:FF:000526', NULL, NULL, '3-deoxy-manno-octulosonate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(99195, NULL, 'G3DSA:1.10.10.160:FF:000046', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(99196, NULL, 'G3DSA:3.40.50.1240:FF:000126', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99197, NULL, 'G3DSA:3.30.40.10:FF:001367', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99198, NULL, 'G3DSA:1.10.20.10:FF:000034', NULL, NULL, 'STAGA complex 65 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(99199, NULL, 'G3DSA:3.90.550.50:FF:000010', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(99200, NULL, 'G3DSA:2.130.10.10:FF:004752', NULL, NULL, 'AGAP000479-PA', NULL, NULL, NULL, NULL, NULL, 4),
(99201, NULL, 'G3DSA:2.30.30.140:FF:000120', NULL, NULL, 'PWWP domain-containing protein2', NULL, NULL, NULL, NULL, NULL, 4),
(99202, NULL, 'G3DSA:1.10.3280.10:FF:000002', NULL, NULL, 'Siroheme biosynthesis protein met8', NULL, NULL, NULL, NULL, NULL, 4),
(99203, NULL, 'G3DSA:3.40.630.30:FF:000651', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99204, NULL, 'G3DSA:1.10.1420.10:FF:000098', NULL, NULL, 'Msh2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(99205, NULL, 'G3DSA:1.20.58.1780:FF:000001', NULL, NULL, 'nuclear pore complex protein Nup155', NULL, NULL, NULL, NULL, NULL, 4),
(99206, NULL, 'G3DSA:1.25.40.10:FF:004487', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99207, NULL, 'G3DSA:2.20.28.20:FF:000001', NULL, NULL, 'Methionine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(99208, NULL, 'G3DSA:3.30.70.330:FF:001586', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99209, NULL, 'G3DSA:3.30.40.10:FF:002115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99210, NULL, 'G3DSA:2.170.270.10:FF:000028', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(99211, NULL, 'G3DSA:2.30.230.10:FF:000031', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(99212, NULL, 'G3DSA:3.30.160.60:FF:003768', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99213, NULL, 'G3DSA:3.30.1360.120:FF:000070', NULL, NULL, 'Dimethylglycine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(99214, NULL, 'G3DSA:2.30.29.30:FF:001293', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99215, NULL, 'G3DSA:3.40.50.2300:FF:000720', NULL, NULL, 'Sensory box sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(99216, NULL, 'G3DSA:1.20.1250.20:FF:000265', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(99217, NULL, 'G3DSA:2.60.40.60:FF:000107', NULL, NULL, 'FAT atypical cadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(99218, NULL, 'G3DSA:1.25.40.10:FF:000564', NULL, NULL, 'UTP6, small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4),
(99219, NULL, 'G3DSA:2.120.10.80:FF:000215', NULL, NULL, 'leucine-zipper-like transcriptional regulator 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(99220, NULL, 'G3DSA:3.90.1300.10:FF:000024', NULL, NULL, '1-carboxybiuret hydrolase subunit AtzE', NULL, NULL, NULL, NULL, NULL, 4),
(99221, NULL, 'G3DSA:1.10.3720.10:FF:000161', NULL, NULL, 'Probable permease of ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(99222, NULL, 'G3DSA:2.60.120.620:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99223, NULL, 'G3DSA:1.10.472.80:FF:000256', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99224, NULL, 'G3DSA:1.10.287.110:FF:000402', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99225, NULL, 'G3DSA:3.30.1490.140:FF:000003', NULL, NULL, 'CRE-APL-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(99226, NULL, 'G3DSA:2.70.40.10:FF:000036', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(99227, NULL, 'G3DSA:3.90.1570.40:FF:000002', NULL, NULL, 'Spliceosomal protein PrP8, U6-snRNA interacting domain', NULL, NULL, NULL, NULL, NULL, 4),
(99228, NULL, 'G3DSA:3.30.200.20:FF:000045', NULL, NULL, 'Serine/threonine-protein kinase SRK2E', NULL, NULL, NULL, NULL, NULL, 4),
(99229, NULL, 'G3DSA:1.25.40.10:FF:001053', NULL, NULL, 'Anaphase-promoting complex subunit CDC27', NULL, NULL, NULL, NULL, NULL, 4),
(99230, NULL, 'G3DSA:2.60.40.10:FF:003083', NULL, NULL, 'GM25779', NULL, NULL, NULL, NULL, NULL, 4),
(99231, NULL, 'G3DSA:1.10.10.60:FF:000470', NULL, NULL, 'Trihelix transcription factor ASR3', NULL, NULL, NULL, NULL, NULL, 4),
(99232, NULL, 'G3DSA:3.60.10.10:FF:000167', NULL, NULL, 'Endonuclease/exonuclease/phosphatase family metal-dependent hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(99233, NULL, 'G3DSA:2.60.210.10:FF:000012', NULL, NULL, 'BTB/POZ and MATH domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(99234, NULL, 'G3DSA:1.10.287.110:FF:000453', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99235, NULL, 'G3DSA:2.10.25.10:FF:000964', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99236, NULL, 'G3DSA:3.40.50.300:FF:002285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99237, NULL, 'G3DSA:1.25.40.10:FF:000165', NULL, NULL, 'Transmembrane and tetratricopeptide repeat containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(99238, NULL, 'G3DSA:2.30.42.10:FF:000087', NULL, NULL, 'Whirlin a', NULL, NULL, NULL, NULL, NULL, 4),
(99239, NULL, 'G3DSA:3.80.10.10:FF:001285', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(99240, NULL, 'G3DSA:1.20.1510.10:FF:000030', NULL, NULL, 'zinc transporter 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(99241, NULL, 'G3DSA:3.30.70.330:FF:002603', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99242, NULL, 'G3DSA:1.20.58.390:FF:000018', NULL, NULL, 'Glycine receptor subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(99243, NULL, 'G3DSA:2.130.10.10:FF:002228', NULL, NULL, 'WD repeat domain 62, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(99244, NULL, 'G3DSA:3.10.350.10:FF:000041', NULL, NULL, 'Putative invasin', NULL, NULL, NULL, NULL, NULL, 4),
(99245, NULL, 'G3DSA:3.20.20.450:FF:000007', NULL, NULL, 'Predicted diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(99246, NULL, 'G3DSA:3.40.50.300:FF:003297', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(99247, NULL, 'G3DSA:3.30.70.270:FF:000253', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99248, NULL, 'G3DSA:3.60.21.10:FF:000428', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99249, NULL, 'G3DSA:2.90.10.10:FF:000022', NULL, NULL, 'Receptor-like protein kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(99250, NULL, 'G3DSA:1.10.238.10:FF:000872', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99251, NULL, 'G3DSA:3.40.50.11350:FF:000011', NULL, NULL, 'O-fucosyltransferase 28', NULL, NULL, NULL, NULL, NULL, 4),
(99252, NULL, 'G3DSA:3.40.630.10:FF:000488', NULL, NULL, 'Glutaminylpeptide cyclotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99253, NULL, 'G3DSA:3.10.110.10:FF:000107', NULL, NULL, 'Ubiquitin conjugating enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99254, NULL, 'G3DSA:3.30.160.60:FF:004044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99255, NULL, 'G3DSA:3.30.2130.10:FF:000019', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(99256, NULL, 'G3DSA:3.40.50.300:FF:004590', NULL, NULL, 'GPI inositol-deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(99257, NULL, 'G3DSA:2.60.40.10:FF:003431', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99258, NULL, 'G3DSA:1.25.40.10:FF:004436', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g09220, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(99259, NULL, 'G3DSA:2.40.50.140:FF:000919', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(99260, NULL, 'G3DSA:4.10.400.10:FF:000209', NULL, NULL, 'Low-density lipoprotein receptor-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(99261, NULL, 'G3DSA:3.50.30.30:FF:000017', NULL, NULL, 'Protease-associated domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(99262, NULL, 'G3DSA:3.30.360.10:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99263, NULL, 'G3DSA:2.30.30.870:FF:000007', NULL, NULL, 'Pelo/ eRF1 domain 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(99264, NULL, 'G3DSA:3.30.70.1230:FF:000098', NULL, NULL, 'Adenylate/guanylate cyclase catalytic domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(99265, NULL, 'G3DSA:2.130.10.10:FF:004191', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(99266, NULL, 'G3DSA:1.25.40.20:FF:000786', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99267, NULL, 'G3DSA:1.10.510.10:FF:001410', NULL, NULL, 'Serine/threonine-protein kinase ppk27', NULL, NULL, NULL, NULL, NULL, 4),
(99268, NULL, 'G3DSA:1.10.418.10:FF:000234', NULL, NULL, 'Spectrin, beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(99269, NULL, 'G3DSA:3.40.50.1110:FF:000054', NULL, NULL, 'Maternal effect protein oskar', NULL, NULL, NULL, NULL, NULL, 4),
(99270, NULL, 'G3DSA:3.30.810.10:FF:000015', NULL, NULL, 'Putative 1-phosphatidylinositol-3-phosphate 5-kinase FAB1D', NULL, NULL, NULL, NULL, NULL, 4),
(99271, NULL, 'G3DSA:1.10.40.30:FF:000024', NULL, NULL, 'Argininosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(99272, NULL, 'G3DSA:3.50.80.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99273, NULL, 'G3DSA:2.60.40.10:FF:002594', NULL, NULL, 'Muscle M-line assembly protein unc-89-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(99274, NULL, 'G3DSA:2.60.40.60:FF:000652', NULL, NULL, 'Cadherin-89D', NULL, NULL, NULL, NULL, NULL, 4),
(99275, NULL, 'G3DSA:3.30.2300.10:FF:000004', NULL, NULL, 'THUMP domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(99276, NULL, 'G3DSA:3.30.2350.10:FF:000007', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(99277, NULL, 'G3DSA:2.20.20.110:FF:000010', NULL, NULL, 'YALI0D08756p', NULL, NULL, NULL, NULL, NULL, 4),
(99278, NULL, 'G3DSA:2.60.40.10:FF:002071', NULL, NULL, 'Interference hedgehog', NULL, NULL, NULL, NULL, NULL, 4),
(99279, NULL, 'G3DSA:2.30.30.140:FF:000171', NULL, NULL, 'PHD finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(99280, NULL, 'G3DSA:2.130.10.10:FF:000481', NULL, NULL, 'Leucine-rich repeat serine/threonine-protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(99281, NULL, 'G3DSA:3.40.50.880:FF:000053', NULL, NULL, 'GMP synthase (glutamine-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4),
(99282, NULL, 'G3DSA:3.30.1360.120:FF:000007', NULL, NULL, 'tRNA modification GTPase GTPBP3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(99283, NULL, 'G3DSA:2.40.10.240:FF:000003', NULL, NULL, 'S-adenosylmethionine:tRNA ribosyltransferase-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(99284, NULL, 'G3DSA:3.80.10.10:FF:000885', NULL, NULL, 'Adhesion G protein-coupled receptor A2', NULL, NULL, NULL, NULL, NULL, 4),
(99285, NULL, 'G3DSA:3.50.30.10:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99286, NULL, 'G3DSA:3.40.50.1220:FF:000031', NULL, NULL, 'Alpha-keto acid decarboxylase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(99287, NULL, 'G3DSA:2.60.40.1360:FF:000012', NULL, NULL, 'Alpha-mannosidase B', NULL, NULL, NULL, NULL, NULL, 4),
(99288, NULL, 'G3DSA:2.30.30.850:FF:000001', NULL, NULL, 'Gag-Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(99289, NULL, 'G3DSA:3.30.450.330:FF:000003', NULL, NULL, 'Cell division protein FtsI', NULL, NULL, NULL, NULL, NULL, 4),
(99290, NULL, 'G3DSA:3.40.1690.20:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99291, NULL, 'G3DSA:3.30.457.50:FF:000003', NULL, NULL, 'Spc25p', NULL, NULL, NULL, NULL, NULL, 4),
(99292, NULL, 'G3DSA:3.40.50.2020:FF:000046', NULL, NULL, 'Hypoxanthine-guanine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(99293, NULL, 'G3DSA:3.30.565.10:FF:000405', NULL, NULL, 'Two-component sensor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(99294, NULL, 'G3DSA:1.10.8.810:FF:000001', NULL, NULL, 'Death domain-associated protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(99295, NULL, 'G3DSA:2.60.120.40:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99296, NULL, 'G3DSA:3.30.43.10:FF:000008', NULL, NULL, 'Xanthine dehydrogenase, FAD binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(99297, NULL, 'G3DSA:3.40.50.300:FF:000716', NULL, NULL, 'ATP-dependent RNA helicase DDX1', NULL, NULL, NULL, NULL, NULL, 4),
(99298, NULL, 'G3DSA:3.90.1410.10:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99299, NULL, 'G3DSA:1.10.418.10:FF:000003', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(99300, NULL, 'G3DSA:1.25.10.10:FF:002754', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99301, NULL, 'G3DSA:2.30.180.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99302, NULL, 'G3DSA:2.60.120.10:FF:000578', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(99303, NULL, 'G3DSA:3.30.760.10:FF:000022', NULL, NULL, 'Putative eukaryotic translation initiation factor eIF-4E', NULL, NULL, NULL, NULL, NULL, 4),
(99304, NULL, 'G3DSA:2.60.120.10:FF:000634', NULL, NULL, 'Crp family transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(99305, NULL, 'G3DSA:3.40.50.1100:FF:000045', NULL, NULL, 'Threonine ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(99306, NULL, 'G3DSA:1.25.40.10:FF:002306', NULL, NULL, 'Putative pentatricopeptide repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(99307, NULL, 'G3DSA:1.20.1440.130:FF:000008', NULL, NULL, 'Vitamin-K epoxide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(99308, NULL, 'G3DSA:2.130.10.10:FF:002459', NULL, NULL, 'Os03g0735100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(99309, NULL, 'G3DSA:3.30.200.20:FF:001973', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99310, NULL, 'G3DSA:2.30.39.10:FF:000124', NULL, NULL, 'Protein CBG06349', NULL, NULL, NULL, NULL, NULL, 4),
(99311, NULL, 'G3DSA:2.130.10.10:FF:002515', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99312, NULL, 'G3DSA:3.30.70.660:FF:000044', NULL, NULL, 'Pseudouridine synthase 3', NULL, NULL, NULL, NULL, NULL, 4),
(99313, NULL, 'G3DSA:4.10.800.10:FF:000021', NULL, NULL, 'Magu, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(99314, NULL, 'G3DSA:3.30.160.60:FF:001790', NULL, NULL, 'BCL6A, transcription repressor a', NULL, NULL, NULL, NULL, NULL, 4),
(99315, NULL, 'G3DSA:2.60.120.920:FF:000212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99316, NULL, 'G3DSA:1.25.40.540:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99317, NULL, 'G3DSA:2.40.70.10:FF:000348', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99318, NULL, 'G3DSA:2.40.10.10:FF:000283', NULL, NULL, 'Cortical granule serine protease 1; Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99319, NULL, 'G3DSA:1.10.3290.10:FF:000008', NULL, NULL, 'Cell filamentation protein Fic', NULL, NULL, NULL, NULL, NULL, 4),
(99320, NULL, 'G3DSA:3.40.30.10:FF:000332', NULL, NULL, 'Blast:Protein disulfide-isomerase TMX3', NULL, NULL, NULL, NULL, NULL, 4),
(99321, NULL, 'G3DSA:2.60.40.10:FF:002863', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99322, NULL, 'G3DSA:1.10.10.2740:FF:000005', NULL, NULL, 'Transcription elongation factor spt6, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99323, NULL, 'G3DSA:1.50.10.150:FF:000017', NULL, NULL, 'S-type anion channel SLAH1', NULL, NULL, NULL, NULL, NULL, 4),
(99324, NULL, 'G3DSA:1.20.5.420:FF:000028', NULL, NULL, 'Small glutamine-rich tetratricopeptide repeat-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(99325, NULL, 'G3DSA:3.40.50.10190:FF:000360', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(99326, NULL, 'G3DSA:3.30.160.390:FF:000005', NULL, NULL, 'Prophage integrase IntF', NULL, NULL, NULL, NULL, NULL, 4),
(99327, NULL, 'G3DSA:1.25.10.10:FF:002810', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99328, NULL, 'G3DSA:1.25.40.20:FF:000494', NULL, NULL, 'Death-associated protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(99329, NULL, 'G3DSA:1.10.238.10:FF:000809', NULL, NULL, 'Superoxide-generating NADPH oxidase heavy chain subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(99330, NULL, 'G3DSA:2.60.440.10:FF:000001', NULL, NULL, 'Cell division protein ZapD', NULL, NULL, NULL, NULL, NULL, 4),
(99331, NULL, 'G3DSA:3.30.160.60:FF:000839', NULL, NULL, 'Zinc finger protein 691', NULL, NULL, NULL, NULL, NULL, 4),
(99332, NULL, 'G3DSA:3.10.290.10:FF:000035', NULL, NULL, 'Ribosomal small subunit pseudouridylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(99333, NULL, 'G3DSA:2.130.10.10:FF:004645', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99334, NULL, 'G3DSA:4.10.800.20:FF:000018', NULL, NULL, 'AMP deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(99335, NULL, 'G3DSA:2.60.40.200:FF:000009', NULL, NULL, 'Superoxide dismutase 1 copper chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(99336, NULL, 'G3DSA:2.10.110.10:FF:000038', NULL, NULL, 'LIM domain kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(99337, NULL, 'G3DSA:3.90.950.10:FF:000006', NULL, NULL, 'PRRC1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(99338, NULL, 'G3DSA:2.60.40.150:FF:000354', NULL, NULL, 'Synaptotagmin 2', NULL, NULL, NULL, NULL, NULL, 4),
(99339, NULL, 'G3DSA:1.10.730.10:FF:000100', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(99340, NULL, 'G3DSA:1.10.455.10:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99341, NULL, 'G3DSA:1.20.1530.20:FF:000034', NULL, NULL, 'Sodium bile acid symporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(99342, NULL, 'G3DSA:1.10.555.10:FF:000086', NULL, NULL, 'Heavy chain, Unconventional Myosin', NULL, NULL, NULL, NULL, NULL, 4),
(99343, NULL, 'G3DSA:3.40.50.300:FF:007748', NULL, NULL, 'DNA repair protein RAD51 homolog 4', NULL, NULL, NULL, NULL, NULL, 4),
(99344, NULL, 'G3DSA:3.40.50.300:FF:002173', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(99345, NULL, 'G3DSA:3.30.40.10:FF:001316', NULL, NULL, 'Putative transcription factor 20', NULL, NULL, NULL, NULL, NULL, 4),
(99346, NULL, 'G3DSA:4.10.410.10:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99347, NULL, 'G3DSA:2.30.180.10:FF:000094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99348, NULL, 'G3DSA:1.10.555.10:FF:000142', NULL, NULL, 'YALI0A17578p', NULL, NULL, NULL, NULL, NULL, 4),
(99349, NULL, 'G3DSA:3.80.10.10:FF:001341', NULL, NULL, 'Leucine Rich repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99350, NULL, 'G3DSA:3.40.50.300:FF:006444', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(99351, NULL, 'G3DSA:2.60.40.150:FF:000298', NULL, NULL, 'DEAD/DEAH box helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99352, NULL, 'G3DSA:2.60.40.1180:FF:000115', NULL, NULL, 'Alpha-L-fucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(99353, NULL, 'G3DSA:1.10.510.10:FF:000792', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(99354, NULL, 'G3DSA:1.10.287.90:FF:000019', NULL, NULL, 'Cytochrome C oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(99355, NULL, 'G3DSA:3.40.390.10:FF:000160', NULL, NULL, 'Matrix metalloproteinase-28-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(99356, NULL, 'G3DSA:3.40.50.300:FF:008592', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(99357, NULL, 'G3DSA:3.30.70.330:FF:001294', NULL, NULL, 'SUPPRESSOR OF ABI3-5', NULL, NULL, NULL, NULL, NULL, 4),
(99358, NULL, 'G3DSA:1.20.120.920:FF:000003', NULL, NULL, 'CRISPR-associated endonuclease Cas1', NULL, NULL, NULL, NULL, NULL, 4),
(99359, NULL, 'G3DSA:2.130.10.10:FF:000430', NULL, NULL, 'WD repeat domain 63', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(99360, NULL, 'G3DSA:3.90.1480.20:FF:000017', NULL, NULL, 'ST6 N-acetylgalactosaminide alpha-2,6-sialyltransferase 3', NULL, NULL, NULL, NULL, NULL, 4),
(99361, NULL, 'G3DSA:3.30.1370.10:FF:000003', NULL, NULL, 'poly(RC)-binding protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(99362, NULL, 'G3DSA:3.30.200.20:FF:000337', NULL, NULL, 'Wall-associated receptor kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(99363, NULL, 'G3DSA:1.20.1070.10:FF:002131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99364, NULL, 'G3DSA:2.60.40.790:FF:000023', NULL, NULL, 'NudC domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(99365, NULL, 'G3DSA:3.90.550.10:FF:000021', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(99366, NULL, 'G3DSA:1.10.1200.10:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99367, NULL, 'G3DSA:3.80.10.10:FF:003471', NULL, NULL, 'Proteophosphoglycan ppg1', NULL, NULL, NULL, NULL, NULL, 4),
(99368, NULL, 'G3DSA:3.30.930.10:FF:000249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99369, NULL, 'G3DSA:3.30.160.60:FF:005005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99370, NULL, 'G3DSA:3.10.105.10:FF:000022', NULL, NULL, 'Peptide transport system secreted peptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(99371, NULL, 'G3DSA:3.40.50.300:FF:004314', NULL, NULL, 'ID624', NULL, NULL, NULL, NULL, NULL, 4),
(99372, NULL, 'G3DSA:3.30.160.60:FF:004437', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99373, NULL, 'G3DSA:3.30.420.110:FF:000009', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(99374, NULL, 'G3DSA:2.60.40.2070:FF:000012', NULL, NULL, 'Fimbrial biogenesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(99375, NULL, 'G3DSA:3.30.160.60:FF:000098', NULL, NULL, 'Zinc finger protein 614', NULL, NULL, NULL, NULL, NULL, 4),
(99376, NULL, 'G3DSA:3.30.40.10:FF:001547', NULL, NULL, 'E3 ubiquitin-protein ligase PEP5', NULL, NULL, NULL, NULL, NULL, 4),
(99377, NULL, 'G3DSA:1.25.40.20:FF:000550', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(99378, NULL, 'G3DSA:2.60.260.20:FF:000113', NULL, NULL, 'DNAJB1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(99379, NULL, 'G3DSA:1.10.1200.10:FF:000059', NULL, NULL, 'Aspergillus niger contig An11c0010, genomic contig', NULL, NULL, NULL, NULL, NULL, 4),
(99380, NULL, 'G3DSA:3.10.20.90:FF:000963', NULL, NULL, 'Rap guanine nucleotide exchange factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(99381, NULL, 'G3DSA:3.15.20.10:FF:000007', NULL, NULL, 'BPI fold-containing family B member 1', NULL, NULL, NULL, NULL, NULL, 4),
(99382, NULL, 'G3DSA:3.40.1190.20:FF:000001', NULL, NULL, 'Phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(99383, NULL, 'G3DSA:1.25.10.10:FF:001118', NULL, NULL, 'Proline-, glutamic acid- and leucine-rich protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(99384, NULL, 'G3DSA:2.10.110.10:FF:000190', NULL, NULL, 'LIM domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(99385, NULL, 'G3DSA:3.90.1410.10:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99386, NULL, 'G3DSA:2.60.40.10:FF:004100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99387, NULL, 'G3DSA:1.20.1070.10:FF:001294', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99388, NULL, 'G3DSA:3.40.50.10190:FF:000028', NULL, NULL, 'DNA topoisomerase 2-binding protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(99389, NULL, 'G3DSA:2.170.260.10:FF:000022', NULL, NULL, 'Endoribonuclease dcr-1', NULL, NULL, NULL, NULL, NULL, 4),
(99390, NULL, 'G3DSA:3.40.50.300:FF:000992', NULL, NULL, 'probable ATP-dependent RNA helicase DDX20', NULL, NULL, NULL, NULL, NULL, 4),
(99391, NULL, 'G3DSA:1.20.1250.20:FF:001338', NULL, NULL, 'Myo-inositol/proton symporter (MIT)', NULL, NULL, NULL, NULL, NULL, 4),
(99392, NULL, 'G3DSA:1.10.20.10:FF:000326', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(99393, NULL, 'G3DSA:3.20.20.70:FF:000760', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99394, NULL, 'G3DSA:1.25.40.10:FF:003924', NULL, NULL, 'Prp39p', NULL, NULL, NULL, NULL, NULL, 4),
(99395, NULL, 'G3DSA:2.130.10.10:FF:004701', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99396, NULL, 'G3DSA:3.40.50.2000:FF:000220', NULL, NULL, 'Glycogen synthase', NULL, NULL, NULL, NULL, NULL, 4),
(99397, NULL, 'G3DSA:3.40.1170.60:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99398, NULL, 'G3DSA:2.40.160.120:FF:000064', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(99399, NULL, 'G3DSA:2.40.180.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99400, NULL, 'G3DSA:2.130.10.10:FF:001211', NULL, NULL, 'CBN-PRP-4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(99401, NULL, 'G3DSA:2.60.40.10:FF:000626', NULL, NULL, 'Ephrin type-A receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(99402, NULL, 'G3DSA:3.30.1600.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99403, NULL, 'G3DSA:2.60.40.60:FF:000944', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99404, NULL, 'G3DSA:1.25.40.10:FF:000272', NULL, NULL, 'DUF410 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(99405, NULL, 'G3DSA:1.10.10.10:FF:000769', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(99406, NULL, 'G3DSA:3.40.50.10990:FF:000004', NULL, NULL, 'GTP cyclohydrolase II', NULL, NULL, NULL, NULL, NULL, 4),
(99407, NULL, 'G3DSA:2.120.10.80:FF:000327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99408, NULL, 'G3DSA:2.40.40.20:FF:000057', NULL, NULL, 'AAA family ATPase, CDC48 subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(99409, NULL, 'G3DSA:1.10.3060.10:FF:000019', NULL, NULL, 'Protein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(99410, NULL, 'G3DSA:2.40.20.10:FF:000053', NULL, NULL, 'Lipoprotein(a)', NULL, NULL, NULL, NULL, NULL, 4),
(99411, NULL, 'G3DSA:1.10.287.70:FF:000648', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(99412, NULL, 'G3DSA:3.40.50.720:FF:000382', NULL, NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(99413, NULL, 'G3DSA:1.10.720.180:FF:000003', NULL, NULL, 'Extracellular respiratory system surface decaheme cytochrome c component MtrF', NULL, NULL, NULL, NULL, NULL, 4),
(99414, NULL, 'G3DSA:1.10.150.20:FF:000120', NULL, NULL, 'DNA-directed RNA polymerase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(99415, NULL, 'G3DSA:3.90.470.10:FF:000020', NULL, NULL, '50S ribosomal protein L22', NULL, NULL, NULL, NULL, NULL, 4),
(99416, NULL, 'G3DSA:1.20.1070.10:FF:000894', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(99417, NULL, 'G3DSA:3.30.830.10:FF:000253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99418, NULL, 'G3DSA:1.10.530.10:FF:000045', NULL, NULL, 'Peptidoglycan hydrolase gp181', NULL, NULL, NULL, NULL, NULL, 4),
(99419, NULL, 'G3DSA:1.20.120.350:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99420, NULL, 'G3DSA:2.40.70.10:FF:000455', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99421, NULL, 'G3DSA:2.60.40.10:FF:000502', NULL, NULL, 'obscurin-like protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(99422, NULL, 'G3DSA:1.10.30.10:FF:000192', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(99423, NULL, 'G3DSA:1.25.10.10:FF:000337', NULL, NULL, 'dnaJ homolog subfamily C member 13-like isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(99424, NULL, 'G3DSA:1.10.510.10:FF:003591', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99425, NULL, 'G3DSA:3.10.450.10:FF:000037', NULL, NULL, 'Fetuin-B', NULL, NULL, NULL, NULL, NULL, 4),
(99426, NULL, 'G3DSA:3.20.20.80:FF:000488', NULL, NULL, 'Solute carrier family 3 member 2b', NULL, NULL, NULL, NULL, NULL, 4),
(99427, NULL, 'G3DSA:3.30.70.340:FF:000010', NULL, NULL, 'GD23628', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(99428, NULL, 'G3DSA:2.40.110.10:FF:000054', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(99429, NULL, 'G3DSA:3.40.50.2300:FF:001501', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99430, NULL, 'G3DSA:1.20.1070.10:FF:002024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99431, NULL, 'G3DSA:2.60.260.20:FF:000057', NULL, NULL, 'Heat shock protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(99432, NULL, 'G3DSA:1.25.40.10:FF:002582', NULL, NULL, 'Pentatricopeptide repeat-containing protein ATP4 homolog, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(99433, NULL, 'G3DSA:3.30.499.10:FF:000021', NULL, NULL, 'BnaC08g47120D protein', NULL, NULL, NULL, NULL, NULL, 4),
(99434, NULL, 'G3DSA:3.40.50.300:FF:006388', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99435, NULL, 'G3DSA:3.40.50.300:FF:003589', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99436, NULL, 'G3DSA:1.10.3370.10:FF:000009', NULL, NULL, 'Pretranslocation protein, alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99437, NULL, 'G3DSA:3.40.50.300:FF:007804', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(99438, NULL, 'G3DSA:3.30.160.60:FF:003588', NULL, NULL, 'Zinc finger protein 227', NULL, NULL, NULL, NULL, NULL, 4),
(99439, NULL, 'G3DSA:1.10.287.70:FF:000031', NULL, NULL, 'Potassium/sodium hyperpolarization-activated cyclic nucleotide-gated channel 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99440, NULL, 'G3DSA:2.60.120.620:FF:000004', NULL, NULL, 'Procollagen-lysine,2-oxoglutarate 5-dioxygenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(99441, NULL, 'G3DSA:3.40.190.10:FF:000740', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(99442, NULL, 'G3DSA:2.170.190.11:FF:000023', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(99443, NULL, 'G3DSA:3.10.100.10:FF:000090', NULL, NULL, 'Proteoglycan 2, bone marrow', NULL, NULL, NULL, NULL, NULL, 4),
(99444, NULL, 'G3DSA:1.20.1070.10:FF:001350', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99445, NULL, 'G3DSA:1.10.533.10:FF:000193', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(99446, NULL, 'G3DSA:2.10.25.10:FF:000172', NULL, NULL, 'FAT atypical cadherin 3', NULL, NULL, NULL, NULL, NULL, 4),
(99447, NULL, 'G3DSA:3.30.40.10:FF:001603', NULL, NULL, 'Ring finger protein 32, isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(99448, NULL, 'G3DSA:3.90.70.10:FF:000692', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 11', NULL, NULL, NULL, NULL, NULL, 4),
(99449, NULL, 'G3DSA:2.130.10.30:FF:000020', NULL, NULL, 'serine/threonine-protein kinase Nek8', NULL, NULL, NULL, NULL, NULL, 4),
(99450, NULL, 'G3DSA:3.30.70.330:FF:002093', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99451, NULL, 'G3DSA:2.40.10.10:FF:000007', NULL, NULL, 'Transmembrane serine protease 7', NULL, NULL, NULL, NULL, NULL, 4),
(99452, NULL, 'G3DSA:1.10.3120.10:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99453, NULL, 'G3DSA:2.40.50.140:FF:000066', NULL, NULL, 'Ribonuclease E', NULL, NULL, NULL, NULL, NULL, 4),
(99454, NULL, 'G3DSA:1.25.40.20:FF:000218', NULL, NULL, 'Fibronectin type 3 and ankyrin repeat domains protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(99455, NULL, 'G3DSA:1.20.5.190:FF:000184', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99456, NULL, 'G3DSA:3.40.50.720:FF:002467', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(99457, NULL, 'G3DSA:3.80.10.10:FF:003139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99458, NULL, 'G3DSA:4.10.280.10:FF:000115', NULL, NULL, 'Transcription factor bHLH113', NULL, NULL, NULL, NULL, NULL, 4),
(99459, NULL, 'G3DSA:1.25.40.180:FF:000003', NULL, NULL, 'Putative eukaryotic translation initiation factor 4 gamma 1', NULL, NULL, NULL, NULL, NULL, 4),
(99460, NULL, 'G3DSA:3.90.290.10:FF:000034', NULL, NULL, 'Follistatin', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(99461, NULL, 'G3DSA:3.30.710.10:FF:000362', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99462, NULL, 'G3DSA:3.40.50.300:FF:004027', NULL, NULL, 'ATP-binding cassette subfamily A, member 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99463, NULL, 'G3DSA:2.40.30.130:FF:000025', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(99464, NULL, 'G3DSA:1.20.140.40:FF:000067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99465, NULL, 'G3DSA:2.70.160.11:FF:000068', NULL, NULL, 'protein arginine N-methyltransferase 9', NULL, NULL, NULL, NULL, NULL, 4),
(99466, NULL, 'G3DSA:3.30.497.10:FF:000016', NULL, NULL, 'Serpin family B member 11', NULL, NULL, NULL, NULL, NULL, 4),
(99467, NULL, 'G3DSA:1.10.287.70:FF:000087', NULL, NULL, 'glutamate receptor ionotropic, NMDA 1 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(99468, NULL, 'G3DSA:2.40.50.140:FF:000228', NULL, NULL, 'ATP-dependent DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(99469, NULL, 'G3DSA:2.60.220.50:FF:000002', NULL, NULL, 'Adhesion G protein-coupled receptor B2', NULL, NULL, NULL, NULL, NULL, 4),
(99470, NULL, 'G3DSA:3.30.160.60:FF:000154', NULL, NULL, 'Tripartite motif-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(99471, NULL, 'G3DSA:3.30.1120.10:FF:000052', NULL, NULL, 'N-acetylgalactosamine-4-sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(99472, NULL, 'G3DSA:2.60.260.20:FF:000001', NULL, NULL, 'Molecular chaperone DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(99473, NULL, 'G3DSA:2.70.70.10:FF:000077', NULL, NULL, 'Lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(99474, NULL, 'G3DSA:3.20.20.70:FF:000428', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(99475, NULL, 'G3DSA:1.25.40.20:FF:000370', NULL, NULL, 'Ankyrin repeat domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(99476, NULL, 'G3DSA:1.10.1410.10:FF:000092', NULL, NULL, 'Trf4 poly(A) polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(99477, NULL, 'G3DSA:2.110.10.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99478, NULL, 'G3DSA:2.60.120.200:FF:000614', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99479, NULL, 'G3DSA:1.20.1440.340:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99480, NULL, 'G3DSA:2.60.40.10:FF:003375', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99481, NULL, 'G3DSA:1.10.10.10:FF:002006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99482, NULL, 'G3DSA:3.40.50.1820:FF:001391', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99483, NULL, 'G3DSA:2.40.50.120:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99484, NULL, 'G3DSA:3.90.550.10:FF:000133', NULL, NULL, 'Cellulose synthase A catalytic subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(99485, NULL, 'G3DSA:3.30.200.20:FF:000225', NULL, NULL, 'cold-responsive protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(99486, NULL, 'G3DSA:3.40.30.10:FF:001113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99487, NULL, 'G3DSA:3.30.390.110:FF:000012', NULL, NULL, '60S ribosomal protein L28', NULL, NULL, NULL, NULL, NULL, 4),
(99488, NULL, 'G3DSA:3.40.1090.10:FF:000052', NULL, NULL, 'Patatin', NULL, NULL, NULL, NULL, NULL, 4),
(99489, NULL, 'G3DSA:2.60.40.1180:FF:000059', NULL, NULL, 'Alpha-amylase', NULL, NULL, NULL, NULL, NULL, 4),
(99490, NULL, 'G3DSA:1.10.418.30:FF:000009', NULL, NULL, 'Kinetochore and Eb1-associated basic protein', NULL, NULL, NULL, NULL, NULL, 4),
(99491, NULL, 'G3DSA:2.30.30.40:FF:000647', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99492, NULL, 'G3DSA:1.10.225.10:FF:000038', NULL, NULL, 'Protein CBR-TWK-44', NULL, NULL, NULL, NULL, NULL, 4),
(99493, NULL, 'G3DSA:3.90.1180.10:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99494, NULL, 'G3DSA:3.10.20.90:FF:000851', NULL, NULL, 'DNA repair protein rad60', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(99495, NULL, 'G3DSA:3.90.105.10:FF:000021', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(99496, NULL, 'G3DSA:3.40.30.10:FF:000276', NULL, NULL, 'Glutaredoxin 3', NULL, NULL, NULL, NULL, NULL, 4),
(99497, NULL, 'G3DSA:1.10.287.110:FF:000346', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99498, NULL, 'G3DSA:2.40.30.10:FF:000278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99499, NULL, 'G3DSA:3.80.10.10:FF:001054', NULL, NULL, 'AGAP007467-PA', NULL, NULL, NULL, NULL, NULL, 4),
(99500, NULL, 'G3DSA:1.50.10.10:FF:000144', NULL, NULL, 'Non-lysosomal glucosylceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(99501, NULL, 'G3DSA:3.40.190.10:FF:000408', NULL, NULL, 'Amino acid ABC transporter, periplasmic amino acid-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99502, NULL, 'G3DSA:1.20.58.60:FF:000337', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(99503, NULL, 'G3DSA:3.40.50.2000:FF:000332', NULL, NULL, 'Glycosyltransferase, MGT', NULL, NULL, NULL, NULL, NULL, 4),
(99504, NULL, 'G3DSA:2.160.10.10:FF:000007', NULL, NULL, 'Serine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(99505, NULL, 'G3DSA:1.25.10.10:FF:002630', NULL, NULL, 'Transportin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99506, NULL, 'G3DSA:3.40.50.300:FF:001116', NULL, NULL, 'Type IV pili twitching motility protein PilT', NULL, NULL, NULL, NULL, NULL, 4),
(99507, NULL, 'G3DSA:2.60.40.10:FF:004156', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99508, NULL, 'G3DSA:2.60.290.11:FF:000001', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(99509, NULL, 'G3DSA:1.10.510.10:FF:001174', NULL, NULL, 'CMGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(99510, NULL, 'G3DSA:3.30.450.30:FF:000038', NULL, NULL, 'Profilin', NULL, NULL, NULL, NULL, NULL, 4),
(99511, NULL, 'G3DSA:3.40.50.1000:FF:000021', NULL, NULL, 'NT5C2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(99512, NULL, 'G3DSA:3.40.630.30:FF:000207', NULL, NULL, 'GCN5-related N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(99513, NULL, 'G3DSA:3.30.1490.20:FF:000043', NULL, NULL, 'Synapsin', NULL, NULL, NULL, NULL, NULL, 4),
(99514, NULL, 'G3DSA:2.30.30.100:FF:000187', NULL, NULL, 'Small nuclear ribonucleoprotein F', NULL, NULL, NULL, NULL, NULL, 4),
(99515, NULL, 'G3DSA:1.20.58.1480:FF:000029', NULL, NULL, 'Lon protease homolog 2, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(99516, NULL, 'G3DSA:1.25.10.10:FF:002574', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99517, NULL, 'G3DSA:2.60.120.650:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99518, NULL, 'G3DSA:3.30.40.10:FF:000243', NULL, NULL, 'Tripartite motif-containing 46, isoform CRA_c', NULL, NULL, NULL, NULL, NULL, 4),
(99519, NULL, 'G3DSA:3.80.10.10:FF:002358', NULL, NULL, 'Os08g0203300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(99520, NULL, 'G3DSA:2.60.40.10:FF:003936', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99521, NULL, 'G3DSA:3.40.50.300:FF:003010', NULL, NULL, 'Teichoic acids export ATP-binding protein TagH', NULL, NULL, NULL, NULL, NULL, 4),
(99522, NULL, 'G3DSA:3.90.550.10:FF:000077', NULL, NULL, 'Probable chitin synthase D', NULL, NULL, NULL, NULL, NULL, 4),
(99523, NULL, 'G3DSA:1.20.58.70:FF:000110', NULL, NULL, 'Qa-SNARE protein, Tlg2/Syntaxin16-family', NULL, NULL, NULL, NULL, NULL, 4),
(99524, NULL, 'G3DSA:3.30.60.20:FF:000011', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(99525, NULL, 'G3DSA:3.80.10.10:FF:002414', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99526, NULL, 'G3DSA:1.10.10.60:FF:000183', NULL, NULL, 'Transcriptional regulator, TetR family', NULL, NULL, NULL, NULL, NULL, 4),
(99527, NULL, 'G3DSA:3.40.50.1480:FF:000018', NULL, NULL, 'S-adenosyl-L-homocysteine hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(99528, NULL, 'G3DSA:1.20.1270.280:FF:000042', NULL, NULL, 'Dynein, axonemal, heavy polypeptide 9-like', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(99529, NULL, 'G3DSA:3.30.160.60:FF:002571', NULL, NULL, 'Protein odd-skipped-related 2', NULL, NULL, NULL, NULL, NULL, 4),
(99530, NULL, 'G3DSA:2.40.160.110:FF:000004', NULL, NULL, 'Lysosomal associated membrane protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(99531, NULL, 'G3DSA:3.20.20.190:FF:000064', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(99532, NULL, 'G3DSA:3.90.550.50:FF:000241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99533, NULL, 'G3DSA:3.90.70.50:FF:000001', NULL, NULL, 'Streptopain', NULL, NULL, NULL, NULL, NULL, 4),
(99534, NULL, 'G3DSA:3.40.50.300:FF:002734', NULL, NULL, 'Chromatin associated protein KTI12', NULL, NULL, NULL, NULL, NULL, 4),
(99535, NULL, 'G3DSA:3.30.70.600:FF:000009', NULL, NULL, '30S ribosomal protein S10', NULL, NULL, NULL, NULL, NULL, 4),
(99536, NULL, 'G3DSA:3.40.630.10:FF:000201', NULL, NULL, 'Putative zinc metalloprotease', NULL, NULL, NULL, NULL, NULL, 4),
(99537, NULL, 'G3DSA:3.40.50.150:FF:000981', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99538, NULL, 'G3DSA:2.130.10.10:FF:000194', NULL, NULL, 'Macrophage-stimulating 1 receptor a', NULL, NULL, NULL, NULL, NULL, 4),
(99539, NULL, 'G3DSA:3.40.50.720:FF:001742', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99540, NULL, 'G3DSA:3.30.70.1230:FF:000042', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(99541, NULL, 'G3DSA:1.10.630.10:FF:000772', NULL, NULL, 'Cytochrome P450 monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99542, NULL, 'G3DSA:3.90.320.10:FF:000032', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(99543, NULL, 'G3DSA:2.20.70.10:FF:000006', NULL, NULL, 'E3 ubiquitin-protein ligase NEDD4-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(99544, NULL, 'G3DSA:2.130.10.10:FF:002335', NULL, NULL, 'Pre-rRNA-processing protein pro-1', NULL, NULL, NULL, NULL, NULL, 4),
(99545, NULL, 'G3DSA:3.40.50.2000:FF:000276', NULL, NULL, 'Phosphatidylinositol N-acetylglucosaminyltransferase GPI3 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(99546, NULL, 'G3DSA:3.30.200.20:FF:002355', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99547, NULL, 'G3DSA:1.10.3090.10:FF:000027', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(99548, NULL, 'G3DSA:3.30.70.330:FF:002710', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99549, NULL, 'G3DSA:1.25.40.10:FF:003363', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(99550, NULL, 'G3DSA:1.10.10.60:FF:001200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99551, NULL, 'G3DSA:3.80.10.10:FF:001397', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', NULL, NULL, NULL, NULL, NULL, 4),
(99552, NULL, 'G3DSA:1.10.8.60:FF:000339', NULL, NULL, 'Replication factor C subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(99553, NULL, 'G3DSA:3.30.160.60:FF:002172', NULL, NULL, 'Zinc finger protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(99554, NULL, 'G3DSA:2.60.40.10:FF:005792', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99555, NULL, 'G3DSA:3.30.160.60:FF:006461', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99556, NULL, 'G3DSA:4.10.280.10:FF:000059', NULL, NULL, 'transcription factor UNE10 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(99557, NULL, 'G3DSA:1.10.472.80:FF:000149', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(99558, NULL, 'G3DSA:3.40.50.720:FF:001343', NULL, NULL, 'Related to cholesterol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(99559, NULL, 'G3DSA:3.80.10.10:FF:002015', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(99560, NULL, 'G3DSA:3.30.70.1390:FF:000005', NULL, NULL, 'Probable serine/threonine-protein kinase roco4', NULL, NULL, NULL, NULL, NULL, 4),
(99561, NULL, 'G3DSA:3.30.420.10:FF:000727', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99562, NULL, 'G3DSA:2.10.25.10:FF:001476', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(99563, NULL, 'G3DSA:1.10.10.440:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99564, NULL, 'G3DSA:2.40.30.10:FF:000514', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99565, NULL, 'G3DSA:3.40.640.10:FF:000045', NULL, NULL, 'Valine--pyruvate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(99566, NULL, 'G3DSA:3.30.70.870:FF:000045', NULL, NULL, 'Translation elongation factor G, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99567, NULL, 'G3DSA:1.10.274.70:FF:000001', NULL, NULL, 'Major ampullate spidroin 1', NULL, NULL, NULL, NULL, NULL, 4),
(99568, NULL, 'G3DSA:3.30.1520.10:FF:000105', NULL, NULL, 'YALI0B01056p', NULL, NULL, NULL, NULL, NULL, 4),
(99569, NULL, 'G3DSA:2.60.120.260:FF:000317', NULL, NULL, 'Endo-1,4-beta-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(99570, NULL, 'G3DSA:3.30.70.270:FF:000141', NULL, NULL, 'DNA polymerase eta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(99571, NULL, 'G3DSA:3.30.70.330:FF:000417', NULL, NULL, 'RNA recognition motif-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(99572, NULL, 'G3DSA:3.30.505.10:FF:000233', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99573, NULL, 'G3DSA:1.20.1050.10:FF:000062', NULL, NULL, 'S-crystallin 4', NULL, NULL, NULL, NULL, NULL, 4),
(99574, NULL, 'G3DSA:1.10.510.10:FF:003315', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99575, NULL, 'G3DSA:3.30.60.30:FF:000071', NULL, NULL, 'Magu, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(99576, NULL, 'G3DSA:3.30.300.10:FF:000044', NULL, NULL, 'GMP synthase [glutamine-hydrolyzing] subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(99577, NULL, 'G3DSA:2.40.30.10:FF:000458', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99578, NULL, 'G3DSA:2.80.10.50:FF:000040', NULL, NULL, 'lymphocyte antigen 75 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(99579, NULL, 'G3DSA:1.20.1260.10:FF:000049', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(99580, NULL, 'G3DSA:3.40.630.170:FF:000005', NULL, NULL, 'Glycylpeptide N-tetradecanoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(99581, NULL, 'G3DSA:3.80.10.10:FF:002690', NULL, NULL, 'Receptor-like protein kinase HSL1', NULL, NULL, NULL, NULL, NULL, 4),
(99582, NULL, 'G3DSA:3.40.1110.10:FF:000280', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99583, NULL, 'G3DSA:3.30.160.60:FF:003532', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99584, NULL, 'G3DSA:3.40.50.300:FF:000099', NULL, NULL, 'Shikimate kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(99585, NULL, 'G3DSA:2.60.120.10:FF:000454', NULL, NULL, 'Potassium voltage-gated channel protein eag', NULL, NULL, NULL, NULL, NULL, 4),
(99586, NULL, 'G3DSA:1.10.420.10:FF:000054', NULL, NULL, 'Os07g0626700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(99587, NULL, 'G3DSA:3.30.40.10:FF:000642', NULL, NULL, 'Vacuolar protein sorting-associated protein 11 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(99588, NULL, 'G3DSA:3.30.310.50:FF:000034', NULL, NULL, 'Phosphoglucomutase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99589, NULL, 'G3DSA:1.20.1560.10:FF:000145', NULL, NULL, 'ABC transporter B family member 7', NULL, NULL, NULL, NULL, NULL, 4),
(99590, NULL, 'G3DSA:2.70.170.10:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99591, NULL, 'G3DSA:3.60.10.10:FF:000111', NULL, NULL, 'Endonuclease/Exonuclease/phosphatase family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99592, NULL, 'G3DSA:1.20.120.230:FF:000004', NULL, NULL, 'Talin 2', NULL, NULL, NULL, NULL, NULL, 4),
(99593, NULL, 'G3DSA:1.50.40.10:FF:000533', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99594, NULL, 'G3DSA:2.70.150.10:FF:000122', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(99595, NULL, 'G3DSA:3.40.630.30:FF:000606', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(99596, NULL, 'G3DSA:3.40.50.1000:FF:000364', NULL, NULL, 'LP01149p', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(99597, NULL, 'G3DSA:3.30.200.20:FF:002411', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99598, NULL, 'G3DSA:1.10.472.10:FF:000168', NULL, NULL, 'BRF1, RNA polymerase III transcription initiation factor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(99599, NULL, 'G3DSA:2.60.120.590:FF:000068', NULL, NULL, 'RNA replication polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(99600, NULL, 'G3DSA:1.25.40.10:FF:004723', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99601, NULL, 'G3DSA:1.20.1270.240:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99602, NULL, 'G3DSA:1.10.220.30:FF:000005', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(99603, NULL, 'G3DSA:3.30.1330.60:FF:000032', NULL, NULL, 'OmpA/MotB domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(99604, NULL, 'G3DSA:3.40.50.300:FF:005663', NULL, NULL, 'DNA binding protein eukaryotic-like', NULL, NULL, NULL, NULL, NULL, 4),
(99605, NULL, 'G3DSA:3.30.200.20:FF:001394', NULL, NULL, 'Serine/threonine-protein kinase BUR1', NULL, NULL, NULL, NULL, NULL, 4),
(99606, NULL, 'G3DSA:3.30.70.330:FF:000237', NULL, NULL, 'CUGBP Elav-like family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(99607, NULL, 'G3DSA:1.10.10.10:FF:000825', NULL, NULL, 'ECF sigma factor FoxI', NULL, NULL, NULL, NULL, NULL, 4),
(99608, NULL, 'G3DSA:3.40.50.2300:FF:001265', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99609, NULL, 'G3DSA:3.40.50.10130:FF:000038', NULL, NULL, 'crossover junction endonuclease MUS81', NULL, NULL, NULL, NULL, NULL, 4),
(99610, NULL, 'G3DSA:3.40.50.150:FF:000649', NULL, NULL, 'Methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99611, NULL, 'G3DSA:1.10.3380.10:FF:000061', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(99612, NULL, 'G3DSA:1.10.472.10:FF:000224', NULL, NULL, 'Cyclin-D2-1', NULL, NULL, NULL, NULL, NULL, 4),
(99613, NULL, 'G3DSA:3.30.379.10:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99614, NULL, 'G3DSA:2.30.29.30:FF:001181', NULL, NULL, 'Neurobeachin/beige protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99615, NULL, 'G3DSA:1.20.120.350:FF:000079', NULL, NULL, 'Calcium channel subunit Cch1', NULL, NULL, NULL, NULL, NULL, 4),
(99616, NULL, 'G3DSA:2.120.10.10:FF:000003', NULL, NULL, 'Neuraminidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(99617, NULL, 'G3DSA:2.60.40.1170:FF:000017', NULL, NULL, 'stonin-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(99618, NULL, 'G3DSA:2.60.40.10:FF:000446', NULL, NULL, 'cell adhesion molecule 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(99619, NULL, 'G3DSA:1.20.58.2220:FF:000061', NULL, NULL, 'Formin-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(99620, NULL, 'G3DSA:1.20.1280.50:FF:000253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99621, NULL, 'G3DSA:3.30.450.40:FF:000098', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(99622, NULL, 'G3DSA:1.10.1420.10:FF:000042', NULL, NULL, 'DNA mismatch repair protein Msh1', NULL, NULL, NULL, NULL, NULL, 4),
(99623, NULL, 'G3DSA:1.10.510.10:FF:002478', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(99624, NULL, 'G3DSA:1.20.5.2480:FF:000003', NULL, NULL, 'Reticulon', NULL, NULL, NULL, NULL, NULL, 4),
(99625, NULL, 'G3DSA:3.30.830.10:FF:000073', NULL, NULL, 'Mitochondrial processing peptidase, beta subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99626, NULL, 'G3DSA:3.40.33.10:FF:000193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99627, NULL, 'G3DSA:3.20.20.70:FF:000608', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99628, NULL, 'G3DSA:3.40.50.150:FF:001762', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99629, NULL, 'G3DSA:1.20.1510.10:FF:000086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99630, NULL, 'G3DSA:3.50.50.60:FF:001472', NULL, NULL, 'Type-II NADH dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(99631, NULL, 'G3DSA:3.40.50.10240:FF:000015', NULL, NULL, 'Thiamin diphosphokinase1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(99632, NULL, 'G3DSA:2.60.40.420:FF:000126', NULL, NULL, 'AGAP006185-PA', NULL, NULL, NULL, NULL, NULL, 4),
(99633, NULL, 'G3DSA:3.30.830.10:FF:000197', NULL, NULL, 'Peptidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(99634, NULL, 'G3DSA:3.30.450.260:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99635, NULL, 'G3DSA:3.30.160.60:FF:006062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99636, NULL, 'G3DSA:3.30.365.10:FF:000025', NULL, NULL, 'Aldehyde oxidase 4', NULL, NULL, NULL, NULL, NULL, 4),
(99637, NULL, 'G3DSA:2.130.10.10:FF:004988', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99638, NULL, 'G3DSA:3.50.50.60:FF:001292', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(99639, NULL, 'G3DSA:1.10.472.10:FF:000348', NULL, NULL, 'Cdk activating kinase (CAK)/RNA polymerase II transcription initiation/nucleotide excision repair factor TFIIH/TFIIK, cyclin H subunit', NULL, NULL, NULL, NULL, NULL, 4),
(99640, NULL, 'G3DSA:3.30.70.980:FF:000022', NULL, NULL, 'YGR021W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(99641, NULL, 'G3DSA:3.20.20.80:FF:000145', NULL, NULL, 'Class III chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99642, NULL, 'G3DSA:2.20.20.10:FF:000003', NULL, NULL, 'Defensin-like peptide 2/4', NULL, NULL, NULL, NULL, NULL, 4),
(99643, NULL, 'G3DSA:1.10.260.100:FF:000026', NULL, NULL, 'Heat shock 70kD protein binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(99644, NULL, 'G3DSA:2.60.200.40:FF:000054', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(99645, NULL, 'G3DSA:2.120.10.30:FF:000009', NULL, NULL, 'Putative low-density lipoprotein receptor-related protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(99646, NULL, 'G3DSA:1.20.58.1590:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99647, NULL, 'G3DSA:1.25.10.10:FF:001793', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99648, NULL, 'G3DSA:2.130.10.10:FF:005949', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99649, NULL, 'G3DSA:1.20.920.20:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99650, NULL, 'G3DSA:2.40.10.170:FF:000010', NULL, NULL, 'ATP synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(99651, NULL, 'G3DSA:3.40.50.300:FF:006500', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99652, NULL, 'G3DSA:3.40.50.300:FF:006624', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99653, NULL, 'G3DSA:1.10.10.10:FF:000264', NULL, NULL, 'Transcription factor E', NULL, NULL, NULL, NULL, NULL, 4),
(99654, NULL, 'G3DSA:2.130.10.10:FF:005825', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99655, NULL, 'G3DSA:2.30.42.10:FF:000031', NULL, NULL, 'Glutamate receptor interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(99656, NULL, 'G3DSA:2.60.40.10:FF:001407', NULL, NULL, 'Plexin A, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(99657, NULL, 'G3DSA:2.60.40.10:FF:005117', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99658, NULL, 'G3DSA:1.25.40.10:FF:003762', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99659, NULL, 'G3DSA:1.10.730.10:FF:000044', NULL, NULL, 'Methionine--tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99660, NULL, 'G3DSA:3.40.390.10:FF:000008', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 3', NULL, NULL, NULL, NULL, NULL, 4),
(99661, NULL, 'G3DSA:1.20.1560.10:FF:000089', NULL, NULL, 'ABC transporter B family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(99662, NULL, 'G3DSA:2.130.10.10:FF:001554', NULL, NULL, 'DNA damage-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(99663, NULL, 'G3DSA:3.30.420.40:FF:000326', NULL, NULL, 'Pantothenate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(99664, NULL, 'G3DSA:3.80.10.10:FF:003319', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(99665, NULL, 'G3DSA:3.30.1230.20:FF:000007', NULL, NULL, '40S ribosomal protein S21', NULL, NULL, NULL, NULL, NULL, 4),
(99666, NULL, 'G3DSA:3.30.420.580:FF:000004', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(99667, NULL, 'G3DSA:3.20.20.140:FF:000307', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99668, NULL, 'G3DSA:3.40.50.10810:FF:000091', NULL, NULL, 'DNA helicase, SNF2/RAD54 family', NULL, NULL, NULL, NULL, NULL, 4),
(99669, NULL, 'G3DSA:3.80.10.10:FF:002919', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99670, NULL, 'G3DSA:2.60.40.150:FF:000410', NULL, NULL, 'Tandem C2 domains nuclear protein', NULL, NULL, NULL, NULL, NULL, 4),
(99671, NULL, 'G3DSA:3.40.50.720:FF:002523', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99672, NULL, 'G3DSA:1.10.600.10:FF:000040', NULL, NULL, 'Phytoene synthase', NULL, NULL, NULL, NULL, NULL, 4),
(99673, NULL, 'G3DSA:1.10.8.60:FF:000159', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(99674, NULL, 'G3DSA:3.40.50.1460:FF:000136', NULL, NULL, 'CASP8 and FADD-like apoptosis regulator a', NULL, NULL, NULL, NULL, NULL, 4),
(99675, NULL, 'G3DSA:3.30.70.20:FF:000017', NULL, NULL, 'Epoxyqueuosine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(99676, NULL, 'G3DSA:4.10.49.10:FF:000003', NULL, NULL, 'Cytochrome OXidase assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(99677, NULL, 'G3DSA:1.10.3080.10:FF:000021', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(99678, NULL, 'G3DSA:3.40.50.1820:FF:000222', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(99679, NULL, 'G3DSA:3.40.50.720:FF:001163', NULL, NULL, 'ADP-ribosyl cyclase/cyclic ADP-ribose hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(99680, NULL, 'G3DSA:2.60.200.20:FF:000172', NULL, NULL, 'Two-component signal transduction', NULL, NULL, NULL, NULL, NULL, 4),
(99681, NULL, 'G3DSA:2.20.25.10:FF:000031', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(99682, NULL, 'G3DSA:3.20.16.10:FF:000002', NULL, NULL, 'Capsid scaffolding protein', NULL, NULL, NULL, NULL, NULL, 4),
(99683, NULL, 'G3DSA:3.30.160.60:FF:002419', NULL, NULL, 'C2H2 finger domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(99684, NULL, 'G3DSA:2.60.40.150:FF:000534', NULL, NULL, 'phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit beta isoform-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(99685, NULL, 'G3DSA:3.30.210.10:FF:000009', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(99686, NULL, 'G3DSA:3.30.530.20:FF:000093', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(99687, NULL, 'G3DSA:2.120.10.30:FF:000161', NULL, NULL, 'NHL domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(99688, NULL, 'G3DSA:2.40.50.40:FF:000041', NULL, NULL, 'Rhino', NULL, NULL, NULL, NULL, NULL, 4),
(99689, NULL, 'G3DSA:3.30.1360.40:FF:000045', NULL, NULL, 'Putative ribosomal recycling factor, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(99690, NULL, 'G3DSA:3.90.1150.10:FF:000259', NULL, NULL, 'Serine palmitoyltransferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(99691, NULL, 'G3DSA:3.40.50.720:FF:001686', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99692, NULL, 'G3DSA:3.50.4.10:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99693, NULL, 'G3DSA:2.60.40.10:FF:001806', NULL, NULL, 'Blast:Twitchin', NULL, NULL, NULL, NULL, NULL, 4),
(99694, NULL, 'G3DSA:3.40.50.1440:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99695, NULL, 'G3DSA:2.30.29.30:FF:000629', NULL, NULL, 'Adaptin ear-binding coat-associated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99696, NULL, 'G3DSA:3.30.450.20:FF:000092', NULL, NULL, 'Related to white collar 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(99697, NULL, 'G3DSA:1.10.8.10:FF:000173', NULL, NULL, 'ToLlIp homolog', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(99698, NULL, 'G3DSA:1.20.1740.10:FF:000131', NULL, NULL, 'General amino-acid permease GAP1', NULL, NULL, NULL, NULL, NULL, 4),
(99699, NULL, 'G3DSA:1.25.40.10:FF:000356', NULL, NULL, 'U3 small nucleolar RNA-associated protein 6 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(99700, NULL, 'G3DSA:1.25.10.10:FF:002462', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99701, NULL, 'G3DSA:4.10.280.10:FF:000082', NULL, NULL, 'Transcription factor ILI6', NULL, NULL, NULL, NULL, NULL, 4),
(99702, NULL, 'G3DSA:1.20.1640.10:FF:000016', NULL, NULL, 'Patched domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(99703, NULL, 'G3DSA:1.20.1250.20:FF:001592', NULL, NULL, 'Related to HOL1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(99704, NULL, 'G3DSA:3.90.470.20:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99705, NULL, 'G3DSA:3.90.70.10:FF:000877', NULL, NULL, 'Protein CBG17827', NULL, NULL, NULL, NULL, NULL, 4),
(99706, NULL, 'G3DSA:3.30.160.60:FF:005926', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99707, NULL, 'G3DSA:1.10.287.70:FF:000160', NULL, NULL, 'Potassium calcium-activated channel subfamily N member 4', NULL, NULL, NULL, NULL, NULL, 4),
(99708, NULL, 'G3DSA:3.30.70.260:FF:000188', NULL, NULL, 'Homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(99709, NULL, 'G3DSA:3.30.1140.60:FF:000012', NULL, NULL, 'F-actin-capping protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(99710, NULL, 'G3DSA:2.40.30.10:FF:000042', NULL, NULL, 'NAD(P)H-flavin reductase', NULL, NULL, NULL, NULL, NULL, 4),
(99711, NULL, 'G3DSA:2.60.40.10:FF:003240', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99712, NULL, 'G3DSA:3.30.70.3400:FF:000018', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(99713, NULL, 'G3DSA:1.25.40.10:FF:004088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99714, NULL, 'G3DSA:2.10.250.10:FF:000008', NULL, NULL, 'Calreticulin-3', NULL, NULL, NULL, NULL, NULL, 4),
(99715, NULL, 'G3DSA:2.30.30.140:FF:000272', NULL, NULL, 'Retinoblastoma-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(99716, NULL, 'G3DSA:3.40.50.300:FF:000964', NULL, NULL, 'Multidrug ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(99717, NULL, 'G3DSA:1.20.120.350:FF:000231', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99718, NULL, 'G3DSA:3.30.9.10:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99719, NULL, 'G3DSA:2.40.50.960:FF:000002', NULL, NULL, 'LOC100145507 protein', NULL, NULL, NULL, NULL, NULL, 4),
(99720, NULL, 'G3DSA:2.30.42.10:FF:000430', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99721, NULL, 'G3DSA:3.30.70.330:FF:002002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99722, NULL, 'G3DSA:1.10.3430.10:FF:000026', NULL, NULL, 'Ammonium transporter 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99723, NULL, 'G3DSA:3.60.21.10:FF:000299', NULL, NULL, 'Serine/threonine-protein phosphatase 5', NULL, NULL, NULL, NULL, NULL, 4),
(99724, NULL, 'G3DSA:3.30.1360.200:FF:000015', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(99725, NULL, 'G3DSA:3.40.50.300:FF:002572', NULL, NULL, 'Peroxin 6, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(99726, NULL, 'G3DSA:2.60.200.30:FF:000017', NULL, NULL, 'NAD kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99727, NULL, 'G3DSA:3.40.50.720:FF:001034', NULL, NULL, 'GDP-L-fucose synthase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(99728, NULL, 'G3DSA:3.30.70.330:FF:001485', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99729, NULL, 'G3DSA:3.30.200.20:FF:002193', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99730, NULL, 'G3DSA:2.40.50.100:FF:000183', NULL, NULL, 'RND family efflux transporter MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(99731, NULL, 'G3DSA:2.70.150.10:FF:000089', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(99732, NULL, 'G3DSA:2.120.10.30:FF:000329', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99733, NULL, 'G3DSA:3.40.50.12780:FF:000125', NULL, NULL, 'PKS-NRPS hybrid synthetase psoA', NULL, NULL, NULL, NULL, NULL, 4),
(99734, NULL, 'G3DSA:4.10.1110.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99735, NULL, 'G3DSA:2.40.160.110:FF:000027', NULL, NULL, 'Lysosomal-associated membrane protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(99736, NULL, 'G3DSA:3.20.20.70:FF:000631', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99737, NULL, 'G3DSA:1.25.10.100:FF:000001', NULL, NULL, 'She4p', NULL, NULL, NULL, NULL, NULL, 4),
(99738, NULL, 'G3DSA:2.60.120.200:FF:000530', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99739, NULL, 'G3DSA:1.20.140.150:FF:000124', NULL, NULL, 'Epithelial membrane protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(99740, NULL, 'G3DSA:3.30.160.60:FF:003791', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99741, NULL, 'G3DSA:3.40.30.10:FF:000675', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99742, NULL, 'G3DSA:2.130.10.10:FF:000458', NULL, NULL, 'Intraflagellar transport 80 homolog (Chlamydomonas)', NULL, NULL, NULL, NULL, NULL, 4),
(99743, NULL, 'G3DSA:3.40.1800.20:FF:000009', NULL, NULL, 'AGAP005348-PA', NULL, NULL, NULL, NULL, NULL, 4),
(99744, NULL, 'G3DSA:1.10.472.10:FF:000117', NULL, NULL, 'Mediator complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(99745, NULL, 'G3DSA:3.30.70.330:FF:002441', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99746, NULL, 'G3DSA:3.30.559.70:FF:000004', NULL, NULL, 'Choline O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(99747, NULL, 'G3DSA:3.50.50.60:FF:000179', NULL, NULL, 'Phytoene dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(99748, NULL, 'G3DSA:3.40.50.150:FF:000458', NULL, NULL, 'O-methyltransferase B', NULL, NULL, NULL, NULL, NULL, 4),
(99749, NULL, 'G3DSA:2.130.10.10:FF:005781', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99750, NULL, 'G3DSA:2.60.40.10:FF:002251', NULL, NULL, 'Basement membrane proteoglycan', NULL, NULL, NULL, NULL, NULL, 4),
(99751, NULL, 'G3DSA:1.25.40.10:FF:003099', NULL, NULL, 'GM14979', NULL, NULL, NULL, NULL, NULL, 4),
(99752, NULL, 'G3DSA:1.20.1740.10:FF:000182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99753, NULL, 'G3DSA:4.10.75.10:FF:000007', NULL, NULL, 'KALlmann syndrome homolog', NULL, NULL, NULL, NULL, NULL, 4),
(99754, NULL, 'G3DSA:3.30.230.70:FF:000039', NULL, NULL, 'Exosome complex component RRP42', NULL, NULL, NULL, NULL, NULL, 4),
(99755, NULL, 'G3DSA:2.60.40.10:FF:004179', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99756, NULL, 'G3DSA:3.40.50.300:FF:007776', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99757, NULL, 'G3DSA:1.10.1450.10:FF:000122', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(99758, NULL, 'G3DSA:3.30.60.290:FF:000004', NULL, NULL, 'DNA repair protein Rad4 homologue, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99759, NULL, 'G3DSA:3.10.580.10:FF:000193', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(99760, NULL, 'G3DSA:2.40.50.90:FF:000022', NULL, NULL, 'Tudor domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(99761, NULL, 'G3DSA:1.20.120.1100:FF:000002', NULL, NULL, 'Fatty-acid and retinol-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(99762, NULL, 'G3DSA:3.10.100.10:FF:000123', NULL, NULL, 'C-type lectin 37Da', NULL, NULL, NULL, NULL, NULL, 4),
(99763, NULL, 'G3DSA:2.60.40.60:FF:000551', NULL, NULL, 'Cadherin-related hmr-1', NULL, NULL, NULL, NULL, NULL, 4),
(99764, NULL, 'G3DSA:3.40.50.1820:FF:001520', NULL, NULL, 'Alpha/beta-Hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(99765, NULL, 'G3DSA:3.40.120.10:FF:000090', NULL, NULL, 'Phosphohexomutase (Phosphoglucomutase / phosphomannomutase)', NULL, NULL, NULL, NULL, NULL, 4),
(99766, NULL, 'G3DSA:3.10.110.10:FF:000051', NULL, NULL, 'ubiquitin-conjugating enzyme E2 R2-like', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(99767, NULL, 'G3DSA:1.20.1250.20:FF:000973', NULL, NULL, 'Major facilitator superfamily MFS_1', NULL, NULL, NULL, NULL, NULL, 4),
(99768, NULL, 'G3DSA:2.10.90.10:FF:000159', NULL, NULL, 'Glycoprotein hormone beta 5', NULL, NULL, NULL, NULL, NULL, 4),
(99769, NULL, 'G3DSA:3.60.15.10:FF:000206', NULL, NULL, 'DNA cross-link repair 1C', NULL, NULL, NULL, NULL, NULL, 4),
(99770, NULL, 'G3DSA:3.40.30.10:FF:000192', NULL, NULL, 'Iodothyronine deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(99771, NULL, 'G3DSA:3.40.50.2300:FF:001580', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99772, NULL, 'G3DSA:3.30.70.270:FF:000045', NULL, NULL, 'Transposon Tf2-7 polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(99773, NULL, 'G3DSA:1.10.287.70:FF:000643', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(99774, NULL, 'G3DSA:3.40.50.20:FF:000095', NULL, NULL, 'Cycloserine biosynthesis protein DcsG', NULL, NULL, NULL, NULL, NULL, 4),
(99775, NULL, 'G3DSA:1.20.140.40:FF:000062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99776, NULL, 'G3DSA:1.10.135.10:FF:000003', NULL, NULL, 'Three-domain arginine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(99777, NULL, 'G3DSA:3.90.280.10:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99778, NULL, 'G3DSA:2.60.200.10:FF:000011', NULL, NULL, 'interferon regulatory factor 4-like', NULL, NULL, NULL, NULL, NULL, 4),
(99779, NULL, 'G3DSA:2.40.50.690:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99780, NULL, 'G3DSA:2.10.25.10:FF:001352', NULL, NULL, 'Delta-like 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(99781, NULL, 'G3DSA:3.90.550.50:FF:000117', NULL, NULL, 'Beta-1,3-N-acetylglucosaminyltransferase radical fringe, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99782, NULL, 'G3DSA:2.60.40.10:FF:002734', NULL, NULL, 'Cysteine protease', NULL, NULL, NULL, NULL, NULL, 4),
(99783, NULL, 'G3DSA:2.10.70.10:FF:000259', NULL, NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(99784, NULL, 'G3DSA:1.25.40.10:FF:002290', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(99785, NULL, 'G3DSA:3.40.1170.60:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99786, NULL, 'G3DSA:1.20.5.1200:FF:000002', NULL, NULL, 'clavesin-1', NULL, NULL, NULL, NULL, NULL, 4),
(99787, NULL, 'G3DSA:3.40.50.300:FF:003398', NULL, NULL, 'Mot1 helicase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(99788, NULL, 'G3DSA:3.30.70.3040:FF:000006', NULL, NULL, 'Cell division protein FtsX', NULL, NULL, NULL, NULL, NULL, 4),
(99789, NULL, 'G3DSA:1.10.418.10:FF:000094', NULL, NULL, 'Hook domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(99790, NULL, 'G3DSA:3.30.230.10:FF:000128', NULL, NULL, 'DNA mismatch repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99791, NULL, 'G3DSA:2.130.10.10:FF:004836', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99792, NULL, 'G3DSA:2.60.120.620:FF:000083', NULL, NULL, 'AGAP013377-PA', NULL, NULL, NULL, NULL, NULL, 4),
(99793, NULL, 'G3DSA:3.10.110.10:FF:000208', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 I', NULL, NULL, NULL, NULL, NULL, 4),
(99794, NULL, 'G3DSA:1.20.1250.20:FF:001153', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(99795, NULL, 'G3DSA:6.10.140.2150:FF:000003', NULL, NULL, 'Sphingosine-1-phosphate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(99796, NULL, 'G3DSA:3.30.200.20:FF:000629', NULL, NULL, 'Focal adhesion kinase, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(99797, NULL, 'G3DSA:3.30.1490.120:FF:000025', NULL, NULL, 'RNA polymerase Rpb7, N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(99798, NULL, 'G3DSA:1.25.40.20:FF:000685', NULL, NULL, 'CAMTA (CAlModulin-binding Transcriptional activator)', NULL, NULL, NULL, NULL, NULL, 4),
(99799, NULL, 'G3DSA:1.10.730.20:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(99800, NULL, 'G3DSA:3.30.70.330:FF:001822', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99801, NULL, 'G3DSA:2.60.40.1500:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99802, NULL, 'G3DSA:3.40.50.11340:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99803, NULL, 'G3DSA:1.10.10.10:FF:000365', NULL, NULL, 'ETS domain-containing protein Elk-1 isoform a', NULL, NULL, NULL, NULL, NULL, 4),
(99804, NULL, 'G3DSA:1.25.40.20:FF:000555', NULL, NULL, 'Putative ankyrin repeat and KH domain-containing protein 1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(99805, NULL, 'G3DSA:2.60.40.60:FF:000708', NULL, NULL, 'Cadherin-4', NULL, NULL, NULL, NULL, NULL, 4),
(99806, NULL, 'G3DSA:2.40.100.10:FF:000093', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(99807, NULL, 'G3DSA:1.25.70.10:FF:000054', NULL, NULL, 'Transcription termination factor 4, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(99808, NULL, 'G3DSA:3.40.50.720:FF:001826', NULL, NULL, 'Pentafunctional AROM polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(99809, NULL, 'G3DSA:1.20.1540.10:FF:000071', NULL, NULL, 'Conserved protein, with rhomboid family domain', NULL, NULL, NULL, NULL, NULL, 4),
(99810, NULL, 'G3DSA:1.10.3210.10:FF:000032', NULL, NULL, 'HD domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(99811, NULL, 'G3DSA:3.40.50.300:FF:008069', NULL, NULL, 'Protein CBR-PRX-1', NULL, NULL, NULL, NULL, NULL, 4),
(99812, NULL, 'G3DSA:1.10.287.130:FF:000240', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(99813, NULL, 'G3DSA:3.40.50.1000:FF:000465', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99814, NULL, 'G3DSA:1.10.340.30:FF:000059', NULL, NULL, 'Endonuclease III homolog', NULL, NULL, NULL, NULL, NULL, 4),
(99815, NULL, 'G3DSA:3.90.740.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99816, NULL, 'G3DSA:2.60.40.10:FF:001778', NULL, NULL, 'Protein tyrosine phosphatase, receptor type B', NULL, NULL, NULL, NULL, NULL, 4),
(99817, NULL, 'G3DSA:3.20.110.10:FF:000026', NULL, NULL, 'Lysosomal alpha-mannosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99818, NULL, 'G3DSA:3.30.160.60:FF:001874', NULL, NULL, 'sal-like protein 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(99819, NULL, 'G3DSA:3.40.50.1820:FF:000694', NULL, NULL, 'Neuroligin-4, Y-linked', NULL, NULL, NULL, NULL, NULL, 4),
(99820, NULL, 'G3DSA:3.30.160.60:FF:005134', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99821, NULL, 'G3DSA:3.30.200.20:FF:001574', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99822, NULL, 'G3DSA:1.10.20.10:FF:000293', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99823, NULL, 'G3DSA:3.30.160.60:FF:005589', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99824, NULL, 'G3DSA:1.20.200.10:FF:000018', NULL, NULL, 'Argininosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(99825, NULL, 'G3DSA:2.30.180.10:FF:000021', NULL, NULL, 'Stabilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(99826, NULL, 'G3DSA:3.30.450.40:FF:000024', NULL, NULL, 'Formate hydrogenlyase transcriptional activator', NULL, NULL, NULL, NULL, NULL, 4),
(99827, NULL, 'G3DSA:3.90.260.10:FF:000015', NULL, NULL, 'Xeroderma pigmentosum, complementation group C', NULL, NULL, NULL, NULL, NULL, 4),
(99828, NULL, 'G3DSA:2.60.40.790:FF:000097', NULL, NULL, 'SHQ1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(99829, NULL, 'G3DSA:1.10.472.10:FF:000247', NULL, NULL, 'Retinoblastoma family protein', NULL, NULL, NULL, NULL, NULL, 4),
(99830, NULL, 'G3DSA:3.30.160.60:FF:002363', NULL, NULL, 'Putative endonuclease or glycosyl hydrolase with C2H2-type zinc finger domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(99831, NULL, 'G3DSA:3.50.70.10:FF:000008', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(99832, NULL, 'G3DSA:2.10.25.10:FF:001509', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99833, NULL, 'G3DSA:3.40.50.11960:FF:000003', NULL, NULL, 'Increased recombination centers protein 6', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(99834, NULL, 'G3DSA:3.50.50.100:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99835, NULL, 'G3DSA:3.40.50.300:FF:001144', NULL, NULL, 'RAB1A, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(99836, NULL, 'G3DSA:3.40.50.1100:FF:000040', NULL, NULL, 'L-serine dehydratase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99837, NULL, 'G3DSA:2.40.33.10:FF:000032', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(99838, NULL, 'G3DSA:3.30.2080.10:FF:000003', NULL, NULL, 'Glycoside hydrolase family 92 protein', NULL, NULL, NULL, NULL, NULL, 4),
(99839, NULL, 'G3DSA:2.60.40.10:FF:004549', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99840, NULL, 'G3DSA:1.25.40.10:FF:001654', NULL, NULL, 'Bardet-Biedl syndrome 4 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99841, NULL, 'G3DSA:1.25.40.20:FF:001191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99842, NULL, 'G3DSA:2.60.40.1910:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99843, NULL, 'G3DSA:3.40.50.300:FF:000655', NULL, NULL, 'Protein PHOTOPERIOD-INDEPENDENT EARLY FLOWERING 1', NULL, NULL, NULL, NULL, NULL, 4),
(99844, NULL, 'G3DSA:1.10.8.10:FF:000369', NULL, NULL, 'Rad23 like protein', NULL, NULL, NULL, NULL, NULL, 4),
(99845, NULL, 'G3DSA:2.40.240.20:FF:000004', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4),
(99846, NULL, 'G3DSA:2.70.70.10:FF:000021', NULL, NULL, 'Peptidase, M23 family', NULL, NULL, NULL, NULL, NULL, 4),
(99847, NULL, 'G3DSA:2.60.120.10:FF:000769', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99848, NULL, 'G3DSA:2.60.40.10:FF:001323', NULL, NULL, 'immunoglobulin superfamily member 10', NULL, NULL, NULL, NULL, NULL, 4),
(99849, NULL, 'G3DSA:3.40.50.300:FF:000525', NULL, NULL, 'rab-like protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(99850, NULL, 'G3DSA:3.30.60.30:FF:000109', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(99851, NULL, 'G3DSA:1.25.40.10:FF:000709', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g21090', NULL, NULL, NULL, NULL, NULL, 4),
(99852, NULL, 'G3DSA:1.25.40.20:FF:000246', NULL, NULL, 'Ankyrin repeat and SOCS box containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(99853, NULL, 'G3DSA:1.20.1250.20:FF:001945', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99854, NULL, 'G3DSA:3.40.50.300:FF:008602', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99855, NULL, 'G3DSA:2.60.260.20:FF:000153', NULL, NULL, 'DNAJ heat shock N-terminal domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(99856, NULL, 'G3DSA:2.30.30.30:FF:000026', NULL, NULL, '60S ribosomal protein L14-1', NULL, NULL, NULL, NULL, NULL, 4),
(99857, NULL, 'G3DSA:3.30.470.20:FF:000031', NULL, NULL, 'Phosphoribosylamine--glycine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(99858, NULL, 'G3DSA:1.50.40.10:FF:000264', NULL, NULL, 'SLC (SoLute Carrier) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(99859, NULL, 'G3DSA:1.10.565.10:FF:000069', NULL, NULL, 'Protein CBR-NHR-85', NULL, NULL, NULL, NULL, NULL, 4),
(99860, NULL, 'G3DSA:3.40.50.720:FF:000415', NULL, NULL, 'Related to GAL10-UDP-glucose 4-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(99861, NULL, 'G3DSA:1.20.1250.20:FF:000164', NULL, NULL, 'solute carrier family 2, facilitated glucose transporter member 10', NULL, NULL, NULL, NULL, NULL, 4),
(99862, NULL, 'G3DSA:2.60.40.10:FF:004049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99863, NULL, 'G3DSA:2.20.70.10:FF:000074', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(99864, NULL, 'G3DSA:3.40.50.300:FF:000155', NULL, NULL, 'AAA ATPase forming ring-shaped complexes', NULL, NULL, NULL, NULL, NULL, 4),
(99865, NULL, 'G3DSA:3.40.1380.20:FF:000055', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(99866, NULL, 'G3DSA:3.40.50.300:FF:004550', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(99867, NULL, 'G3DSA:2.40.70.10:FF:000264', NULL, NULL, 'Pepsin A', NULL, NULL, NULL, NULL, NULL, 4),
(99868, NULL, 'G3DSA:3.30.40.10:FF:001631', NULL, NULL, 'E3 ubiquitin-protein ligase NEURL3', NULL, NULL, NULL, NULL, NULL, 4),
(99869, NULL, 'G3DSA:4.10.40.20:FF:000003', NULL, NULL, 'cysteine-rich motor neuron 1 protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(99870, NULL, 'G3DSA:3.30.800.10:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99871, NULL, 'G3DSA:3.80.10.10:FF:002987', NULL, NULL, 'Immunoglobulin domain and leucine-rich repeat-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(99872, NULL, 'G3DSA:1.20.58.1030:FF:000030', NULL, NULL, 'DNA replication complex GINS protein SLD5', NULL, NULL, NULL, NULL, NULL, 4),
(99873, NULL, 'G3DSA:1.25.10.10:FF:000528', NULL, NULL, 'Polyubiquitin binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99874, NULL, 'G3DSA:2.130.10.10:FF:001610', NULL, NULL, 'Probable cytosolic iron-sulfur protein assembly protein CIAO1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(99875, NULL, 'G3DSA:1.10.1070.11:FF:000010', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit gamma isoform', NULL, NULL, NULL, NULL, NULL, 4),
(99876, NULL, 'G3DSA:3.40.630.10:FF:000168', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(99877, NULL, 'G3DSA:3.40.190.10:FF:000504', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(99878, NULL, 'G3DSA:3.30.1010.10:FF:000055', NULL, NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(99879, NULL, 'G3DSA:1.10.1410.10:FF:000013', NULL, NULL, 'PAP/OAS1 substrate-binding domain superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(99880, NULL, 'G3DSA:1.20.5.760:FF:000001', NULL, NULL, 'Gag polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(99881, NULL, 'G3DSA:3.40.50.300:FF:004707', NULL, NULL, 'ATP-binding cassette subfamily F member 2', NULL, NULL, NULL, NULL, NULL, 4),
(99882, NULL, 'G3DSA:3.30.40.10:FF:001940', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99883, NULL, 'G3DSA:3.40.1110.10:FF:000004', NULL, NULL, 'Plasma membrane ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(99884, NULL, 'G3DSA:3.90.980.20:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99885, NULL, 'G3DSA:1.10.4020.10:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99886, NULL, 'G3DSA:3.90.1410.10:FF:000010', NULL, NULL, 'Protein PLASTID TRANSCRIPTIONALLY ACTIVE 14', NULL, NULL, NULL, NULL, NULL, 4),
(99887, NULL, 'G3DSA:3.50.7.10:FF:000094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99888, NULL, 'G3DSA:3.80.10.10:FF:001498', NULL, NULL, 'Leucine Rich repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99889, NULL, 'G3DSA:3.30.160.60:FF:000385', NULL, NULL, 'Zinc finger protein 236 variant', NULL, NULL, NULL, NULL, NULL, 4),
(99890, NULL, 'G3DSA:3.30.70.590:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(99891, NULL, 'G3DSA:2.30.30.40:FF:000416', NULL, NULL, 'Neutrophil cytosolic factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(99892, NULL, 'G3DSA:3.40.50.2300:FF:000309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99893, NULL, 'G3DSA:3.40.630.30:FF:000387', NULL, NULL, 'Spermidine/spermine N1-acetyltransferase 1a, duplicate 1', NULL, NULL, NULL, NULL, NULL, 4),
(99894, NULL, 'G3DSA:2.40.30.270:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99895, NULL, 'G3DSA:1.10.630.10:FF:000300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99896, NULL, 'G3DSA:3.40.190.10:FF:000167', NULL, NULL, 'Eye-enriched kainate receptor, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(99897, NULL, 'G3DSA:3.90.780.10:FF:000038', NULL, NULL, 'Putative secreted 5''-nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(99898, NULL, 'G3DSA:3.10.100.10:FF:000106', NULL, NULL, 'Lectin29Ca', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(99899, NULL, 'G3DSA:3.90.79.10:FF:000116', NULL, NULL, 'MutT/nudix family protein', NULL, NULL, NULL, NULL, NULL, 4),
(99900, NULL, 'G3DSA:3.40.50.2000:FF:001136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99901, NULL, 'G3DSA:3.40.50.1100:FF:000169', NULL, NULL, '2-amino-4-ketopentanoate thiolase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(99902, NULL, 'G3DSA:1.10.3130.10:FF:000014', NULL, NULL, 'Serine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(99903, NULL, 'G3DSA:2.130.10.10:FF:003864', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99904, NULL, 'G3DSA:2.130.10.10:FF:000149', NULL, NULL, 'Eukaryotic translation initiation factor 2A', NULL, NULL, NULL, NULL, NULL, 4),
(99905, NULL, 'G3DSA:3.40.30.10:FF:000736', NULL, NULL, 'Thioredoxin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99906, NULL, 'G3DSA:3.30.420.110:FF:000032', NULL, NULL, 'MutS protein homolog him-14', NULL, NULL, NULL, NULL, NULL, 4),
(99907, NULL, 'G3DSA:2.80.10.50:FF:000129', NULL, NULL, 'Fibroblast growth factor 10', NULL, NULL, NULL, NULL, NULL, 4),
(99908, NULL, 'G3DSA:3.60.15.10:FF:000223', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(99909, NULL, 'G3DSA:3.40.50.10190:FF:000337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99910, NULL, 'G3DSA:1.20.1250.20:FF:001462', NULL, NULL, 'Glucose transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99911, NULL, 'G3DSA:3.10.20.90:FF:000356', NULL, NULL, 'UBX domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(99912, NULL, 'G3DSA:3.90.480.10:FF:000009', NULL, NULL, 'NADPH-dependent assimilatory sulfite reductase hemoprotein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(99913, NULL, 'G3DSA:1.20.1250.20:FF:000956', NULL, NULL, 'Probable multidrug-efflux transporter MT1670', NULL, NULL, NULL, NULL, NULL, 4),
(99914, NULL, 'G3DSA:3.30.1130.10:FF:000002', NULL, NULL, '7,8-dihydroneopterin aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(99915, NULL, 'G3DSA:1.20.1250.20:FF:000181', NULL, NULL, 'Major facilitator superfamily domain-containing protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(99916, NULL, 'G3DSA:3.30.1360.10:FF:000002', NULL, NULL, 'DNA-directed RNA polymerase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(99917, NULL, 'G3DSA:2.30.29.30:FF:000461', NULL, NULL, 'Coactivator associated arginine methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(99918, NULL, 'G3DSA:2.30.29.30:FF:001080', NULL, NULL, 'Zgc:110468 protein', NULL, NULL, NULL, NULL, NULL, 4),
(99919, NULL, 'G3DSA:3.40.640.10:FF:000466', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99920, NULL, 'G3DSA:3.40.50.2000:FF:000989', NULL, NULL, 'Os02g0207100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(99921, NULL, 'G3DSA:3.30.1050.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99922, NULL, 'G3DSA:3.30.200.190:FF:000001', NULL, NULL, 'Distal tail protein', NULL, NULL, NULL, NULL, NULL, 4),
(99923, NULL, 'G3DSA:2.160.20.10:FF:000013', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(99924, NULL, 'G3DSA:2.130.10.10:FF:004483', NULL, NULL, 'GH20665p', NULL, NULL, NULL, NULL, NULL, 4),
(99925, NULL, 'G3DSA:3.40.109.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99926, NULL, 'G3DSA:2.10.70.10:FF:000198', NULL, NULL, 'Complement factor b,-like', NULL, NULL, NULL, NULL, NULL, 4),
(99927, NULL, 'G3DSA:1.10.10.60:FF:000110', NULL, NULL, 'Transcriptional adapter', NULL, NULL, NULL, NULL, NULL, 4),
(99928, NULL, 'G3DSA:3.10.50.40:FF:000085', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(99929, NULL, 'G3DSA:1.10.1740.100:FF:000004', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(99930, NULL, 'G3DSA:3.50.50.60:FF:000988', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(99931, NULL, 'G3DSA:2.130.10.10:FF:005472', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(99932, NULL, 'G3DSA:3.30.565.10:FF:000445', NULL, NULL, 'Putative two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(99933, NULL, 'G3DSA:3.40.50.2020:FF:000175', NULL, NULL, 'Phosphoribosyl transferase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(99934, NULL, 'G3DSA:1.20.1280.50:FF:000225', NULL, NULL, 'Putative F-box/LRR-repeat protein At3g42770', NULL, NULL, NULL, NULL, NULL, 4),
(99935, NULL, 'G3DSA:3.30.420.40:FF:000298', NULL, NULL, 'Rhamnulokinase', NULL, NULL, NULL, NULL, NULL, 4),
(99936, NULL, 'G3DSA:3.30.70.1400:FF:000003', NULL, NULL, 'Pyruvate dehydrogenase phosphatase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(99937, NULL, 'G3DSA:3.20.20.10:FF:000057', NULL, NULL, 'Diaminopimelate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(99938, NULL, 'G3DSA:1.20.140.150:FF:000063', NULL, NULL, 'Voltage-dependent calcium channel gamma-5 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(99939, NULL, 'G3DSA:1.10.20.10:FF:000163', NULL, NULL, 'Histone H3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99940, NULL, 'G3DSA:3.90.550.50:FF:000089', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(99941, NULL, 'G3DSA:3.30.1360.30:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99942, NULL, 'G3DSA:2.60.40.1180:FF:000189', NULL, NULL, 'Glucosylceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(99943, NULL, 'G3DSA:2.60.40.1130:FF:000005', NULL, NULL, 'RAB geranylgeranyl transferase alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99944, NULL, 'G3DSA:2.60.40.10:FF:000817', NULL, NULL, 'Vascular cell adhesion molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(99945, NULL, 'G3DSA:3.30.160.60:FF:005617', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99946, NULL, 'G3DSA:3.40.50.1820:FF:001183', NULL, NULL, 'AGAP003641-PA', NULL, NULL, NULL, NULL, NULL, 4),
(99947, NULL, 'G3DSA:3.30.70.980:FF:000050', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(99948, NULL, 'G3DSA:1.10.238.10:FF:000220', NULL, NULL, 'Centrin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99949, NULL, 'G3DSA:1.10.4160.10:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99950, NULL, 'G3DSA:2.30.30.140:FF:000255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99951, NULL, 'G3DSA:3.30.9.10:FF:000154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99952, NULL, 'G3DSA:3.40.50.300:FF:001453', NULL, NULL, 'Adenylate kinase 9', NULL, NULL, NULL, NULL, NULL, 4),
(99953, NULL, 'G3DSA:1.20.900.10:FF:000111', NULL, NULL, 'Protein CBG05206', NULL, NULL, NULL, NULL, NULL, 4),
(99954, NULL, 'G3DSA:3.90.1150.210:FF:000021', NULL, NULL, 'F-actin-capping protein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(99955, NULL, 'G3DSA:1.10.630.10:FF:000429', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99956, NULL, 'G3DSA:3.30.70.330:FF:001030', NULL, NULL, 'Polyadenylate-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(99957, NULL, 'G3DSA:2.130.10.10:FF:002919', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(99958, NULL, 'G3DSA:1.20.120.1910:FF:000048', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(99959, NULL, 'G3DSA:3.80.10.10:FF:002807', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(99960, NULL, 'G3DSA:3.10.50.40:FF:000113', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(99961, NULL, 'G3DSA:1.20.1480.20:FF:000001', NULL, NULL, 'microtubule-associated serine/threonine-protein kinase 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(99962, NULL, 'G3DSA:3.40.50.1820:FF:001211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99963, NULL, 'G3DSA:3.90.70.10:FF:000085', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 36', NULL, NULL, NULL, NULL, NULL, 4),
(99964, NULL, 'G3DSA:3.30.200.20:FF:002546', NULL, NULL, 'AGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(99965, NULL, 'G3DSA:2.70.50.40:FF:000017', NULL, NULL, 'Unc-119-like protein 2', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(99966, NULL, 'G3DSA:3.40.50.300:FF:004207', NULL, NULL, 'Ras GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(99967, NULL, 'G3DSA:1.10.565.10:FF:000199', NULL, NULL, 'Coup transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99968, NULL, 'G3DSA:1.10.357.120:FF:000012', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(99969, NULL, 'G3DSA:1.10.30.10:FF:000091', NULL, NULL, 'HMG (High mobility group) box domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(99970, NULL, 'G3DSA:3.20.110.10:FF:000043', NULL, NULL, 'NADPH--cytochrome P450 reductase 2', NULL, NULL, NULL, NULL, NULL, 4),
(99971, NULL, 'G3DSA:3.30.70.3000:FF:000005', NULL, NULL, 'tRNA(His) guanylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(99972, NULL, 'G3DSA:1.20.1280.290:FF:000047', NULL, NULL, 'Bidirectional sugar transporter SWEET17', NULL, NULL, NULL, NULL, NULL, 4),
(99973, NULL, 'G3DSA:1.10.10.60:FF:000447', NULL, NULL, 'ISWI chromatin-remodeling complex ATPase ISW2', NULL, NULL, NULL, NULL, NULL, 4),
(99974, NULL, 'G3DSA:3.40.350.10:FF:000039', NULL, NULL, 'Cytoplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(99975, NULL, 'G3DSA:3.40.50.720:FF:001051', NULL, NULL, 'Lysine-ketoglutarate reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(99976, NULL, 'G3DSA:3.30.160.60:FF:006415', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99977, NULL, 'G3DSA:2.170.270.10:FF:000175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99978, NULL, 'G3DSA:1.25.10.10:FF:003142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99979, NULL, 'G3DSA:3.40.120.10:FF:000101', NULL, NULL, 'Phosphoglucomutase/phosphomannomutase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(99980, NULL, 'G3DSA:3.40.50.970:FF:000232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99981, NULL, 'G3DSA:3.20.20.80:FF:000297', NULL, NULL, 'Galactose-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(99982, NULL, 'G3DSA:3.40.50.10810:FF:000046', NULL, NULL, 'Putative SNF2 family helicase/ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(99983, NULL, 'G3DSA:3.20.20.70:FF:000159', NULL, NULL, 'tRNA-dihydrouridine synthase 4', NULL, NULL, NULL, NULL, NULL, 4),
(99984, NULL, 'G3DSA:3.90.550.10:FF:000234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99985, NULL, 'G3DSA:2.60.40.60:FF:000490', NULL, NULL, 'Cadherin 17, LI cadherin (liver-intestine)', NULL, NULL, NULL, NULL, NULL, 4),
(99986, NULL, 'G3DSA:2.60.120.10:FF:000639', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99987, NULL, 'G3DSA:1.25.40.10:FF:004751', NULL, NULL, 'Os08g0494350 protein', NULL, NULL, NULL, NULL, NULL, 4),
(99988, NULL, 'G3DSA:3.60.15.10:FF:000195', NULL, NULL, 'Flavo-diiron protein FprA2', NULL, NULL, NULL, NULL, NULL, 4),
(99989, NULL, 'G3DSA:1.10.510.10:FF:004405', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99990, NULL, 'G3DSA:1.10.510.10:FF:002719', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99991, NULL, 'G3DSA:1.10.720.30:FF:000077', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(99992, NULL, 'G3DSA:2.130.10.10:FF:002375', NULL, NULL, 'STXBP5L isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(99993, NULL, 'G3DSA:3.40.50.12780:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(99994, NULL, 'G3DSA:1.20.1250.20:FF:000664', NULL, NULL, 'MonoCarboxylate Transporter family', NULL, NULL, NULL, NULL, NULL, 4),
(99995, NULL, 'G3DSA:2.60.120.200:FF:000513', NULL, NULL, 'Calnexin', NULL, NULL, NULL, NULL, NULL, 4),
(99996, NULL, 'G3DSA:2.60.40.1170:FF:000101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(99997, NULL, 'G3DSA:3.30.200.20:FF:000085', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase', NULL, NULL, NULL, NULL, NULL, 4),
(99998, NULL, 'G3DSA:1.20.5.4130:FF:000010', NULL, NULL, 'Disease resistance protein RPM1', NULL, NULL, NULL, NULL, NULL, 4),
(99999, NULL, 'G3DSA:2.60.120.10:FF:000786', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(100000, NULL, 'G3DSA:3.30.1490.10:FF:000006', NULL, NULL, '30S ribosomal protein S8', NULL, NULL, NULL, NULL, NULL, 4),
(100001, NULL, 'G3DSA:3.40.50.720:FF:002332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100002, NULL, 'G3DSA:3.40.50.10180:FF:000008', NULL, NULL, 'Glycerate kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100003, NULL, 'G3DSA:3.40.50.300:FF:000172', NULL, NULL, 'Dynamin-1-like protein isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(100004, NULL, 'G3DSA:2.170.300.10:FF:000026', NULL, NULL, 'laminin subunit alpha-2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(100005, NULL, 'G3DSA:3.40.50.300:FF:000508', NULL, NULL, 'ABC transporter C family member 5', NULL, NULL, NULL, NULL, NULL, 4),
(100006, NULL, 'G3DSA:2.60.40.150:FF:000511', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(100007, NULL, 'G3DSA:3.90.550.10:FF:000364', NULL, NULL, 'Glycosyltransferase domain-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100008, NULL, 'G3DSA:3.30.1010.10:FF:000038', NULL, NULL, 'Phosphatidylinositol 4-kinase beta 1', NULL, NULL, NULL, NULL, NULL, 4),
(100009, NULL, 'G3DSA:1.20.5.1160:FF:000001', NULL, NULL, 'Keratin type II', NULL, NULL, NULL, NULL, NULL, 4),
(100010, NULL, 'G3DSA:2.10.25.10:FF:001291', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(100011, NULL, 'G3DSA:3.30.40.10:FF:000451', NULL, NULL, 'E3 ubiquitin-protein ligase rnf12-A', NULL, NULL, NULL, NULL, NULL, 4),
(100012, NULL, 'G3DSA:2.60.40.10:FF:001306', NULL, NULL, 'Matrix remodeling associated 5', NULL, NULL, NULL, NULL, NULL, 4),
(100013, NULL, 'G3DSA:3.40.1190.20:FF:000164', NULL, NULL, 'ATP-dependent (S)-NAD(P)H-hydrate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(100014, NULL, 'G3DSA:3.80.10.10:FF:002206', NULL, NULL, 'Si:ch211-191a16.5', NULL, NULL, NULL, NULL, NULL, 4),
(100015, NULL, 'G3DSA:3.10.20.30:FF:000075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100016, NULL, 'G3DSA:1.20.58.60:FF:000253', NULL, NULL, 'Spectrin beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(100017, NULL, 'G3DSA:3.40.50.300:FF:002072', NULL, NULL, 'U3 small nucleolar RNA-associated protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(100018, NULL, 'G3DSA:1.10.168.20:FF:000003', NULL, NULL, '40S ribosomal protein S8', NULL, NULL, NULL, NULL, NULL, 4),
(100019, NULL, 'G3DSA:2.170.280.10:FF:000001', NULL, NULL, 'Flagellin', NULL, NULL, NULL, NULL, NULL, 4),
(100020, NULL, 'G3DSA:3.50.50.60:FF:001168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100021, NULL, 'G3DSA:1.10.10.60:FF:000008', NULL, NULL, 'Pre-B-cell leukemia transcription factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(100022, NULL, 'G3DSA:1.10.220.60:FF:000008', NULL, NULL, 'GRIP domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(100023, NULL, 'G3DSA:1.10.238.10:FF:001046', NULL, NULL, 'Calmodulin 5', NULL, NULL, NULL, NULL, NULL, 4),
(100024, NULL, 'G3DSA:1.10.10.60:FF:000138', NULL, NULL, 'Homeobox protein prophet of Pit-1', NULL, NULL, NULL, NULL, NULL, 4),
(100025, NULL, 'G3DSA:3.30.200.20:FF:002563', NULL, NULL, 'Serine/threonine-protein kinase SSN3', NULL, NULL, NULL, NULL, NULL, 4),
(100026, NULL, 'G3DSA:3.30.160.60:FF:004280', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100027, NULL, 'G3DSA:3.30.1520.10:FF:000004', NULL, NULL, 'Sorting nexin', NULL, NULL, NULL, NULL, NULL, 4),
(100028, NULL, 'G3DSA:2.60.40.10:FF:000025', NULL, NULL, 'receptor-type tyrosine-protein phosphatase U isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(100029, NULL, 'G3DSA:3.30.160.60:FF:006106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100030, NULL, 'G3DSA:1.25.10.10:FF:001489', NULL, NULL, 'AEL006Wp', NULL, NULL, NULL, NULL, NULL, 4),
(100031, NULL, 'G3DSA:3.40.30.10:FF:000175', NULL, NULL, '54S ribosomal protein L51, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(100032, NULL, 'G3DSA:1.10.510.40:FF:000008', NULL, NULL, 'NTP-dependent putrebactin synthetase PubC', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(100033, NULL, 'G3DSA:3.90.70.10:FF:000905', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(100034, NULL, 'G3DSA:3.30.870.10:FF:000087', NULL, NULL, 'Cardiolipin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(100035, NULL, 'G3DSA:1.20.1000.10:FF:000013', NULL, NULL, 'Guanylate binding protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(100036, NULL, 'G3DSA:2.120.10.80:FF:000400', NULL, NULL, 'Kelch domain-containing 10', NULL, NULL, NULL, NULL, NULL, 4),
(100037, NULL, 'G3DSA:3.40.910.10:FF:000021', NULL, NULL, 'Deoxyhypusine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(100038, NULL, 'G3DSA:3.40.1090.10:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100039, NULL, 'G3DSA:3.30.565.10:FF:000006', NULL, NULL, 'Sensor histidine kinase WalK', NULL, NULL, NULL, NULL, NULL, 4),
(100040, NULL, 'G3DSA:3.30.930.10:FF:000058', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(100041, NULL, 'G3DSA:2.130.10.10:FF:004044', NULL, NULL, 'Zgc:86896', NULL, NULL, NULL, NULL, NULL, 4),
(100042, NULL, 'G3DSA:2.130.10.10:FF:001739', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100043, NULL, 'G3DSA:3.40.390.10:FF:000132', NULL, NULL, 'GG12482', NULL, NULL, NULL, NULL, NULL, 4),
(100044, NULL, 'G3DSA:3.90.1150.10:FF:000203', NULL, NULL, 'Kynureninase', NULL, NULL, NULL, NULL, NULL, 4),
(100045, NULL, 'G3DSA:3.40.1110.10:FF:000021', NULL, NULL, 'calcium-transporting ATPase, endoplasmic reticulum-type', NULL, NULL, NULL, NULL, NULL, 4),
(100046, NULL, 'G3DSA:1.25.40.90:FF:000014', NULL, NULL, 'Hepatocyte growth factor-regulated tyrosine kinase substrate', NULL, NULL, NULL, NULL, NULL, 4),
(100047, NULL, 'G3DSA:3.30.200.160:FF:000003', NULL, NULL, 'Putative general transcription factor 3C polypeptide 5', NULL, NULL, NULL, NULL, NULL, 4),
(100048, NULL, 'G3DSA:3.40.50.300:FF:007304', NULL, NULL, 'ABC transporter A family member 7', NULL, NULL, NULL, NULL, NULL, 4),
(100049, NULL, 'G3DSA:1.25.40.10:FF:004190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100050, NULL, 'G3DSA:1.25.40.10:FF:003571', NULL, NULL, 'Squamous cell carcinoma antigen recognized by T-cells 3', NULL, NULL, NULL, NULL, NULL, 4),
(100051, NULL, 'G3DSA:3.20.19.10:FF:000003', NULL, NULL, '3-isopropylmalate dehydratase small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(100052, NULL, 'G3DSA:2.130.10.10:FF:000121', NULL, NULL, 'U3 small nucleolar RNA-associated protein 18 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(100053, NULL, 'G3DSA:3.40.50.300:FF:006815', NULL, NULL, 'RE52190p', NULL, NULL, NULL, NULL, NULL, 4),
(100054, NULL, 'G3DSA:2.80.10.50:FF:000231', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(100055, NULL, 'G3DSA:3.50.50.60:FF:001477', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100056, NULL, 'G3DSA:1.20.120.720:FF:000022', NULL, NULL, 'Chitin synthase ChsE', NULL, NULL, NULL, NULL, NULL, 4),
(100057, NULL, 'G3DSA:1.10.3450.40:FF:000002', NULL, NULL, 'Signal recognition particle subunit SRP68', NULL, NULL, NULL, NULL, NULL, 4),
(100058, NULL, 'G3DSA:2.70.98.10:FF:000096', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(100059, NULL, 'G3DSA:3.90.550.10:FF:000673', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100060, NULL, 'G3DSA:3.40.50.920:FF:000003', NULL, NULL, 'Transketolase', NULL, NULL, NULL, NULL, NULL, 4),
(100061, NULL, 'G3DSA:3.90.1150.10:FF:000383', NULL, NULL, 'PLP-dependent aminotransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(100062, NULL, 'G3DSA:1.10.510.10:FF:000353', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(100063, NULL, 'G3DSA:2.170.150.30:FF:000003', NULL, NULL, 'Probable ATP-dependent RNA helicase DHX58', NULL, NULL, NULL, NULL, NULL, 4),
(100064, NULL, 'G3DSA:1.10.287.70:FF:000143', NULL, NULL, 'Probable glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(100065, NULL, 'G3DSA:3.40.50.720:FF:001843', NULL, NULL, 'Putative malate dehydrogenase 1B', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(100066, NULL, 'G3DSA:3.30.30.30:FF:000063', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(100067, NULL, 'G3DSA:2.60.40.10:FF:003695', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100068, NULL, 'G3DSA:3.10.20.690:FF:000002', NULL, NULL, 'DNA gyrase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(100069, NULL, 'G3DSA:3.30.160.60:FF:000946', NULL, NULL, 'Zinc finger protein 438', NULL, NULL, NULL, NULL, NULL, 4),
(100070, NULL, 'G3DSA:1.20.1540.10:FF:000054', NULL, NULL, 'Putative membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(100071, NULL, 'G3DSA:1.20.1310.10:FF:000014', NULL, NULL, 'Cullin 5', NULL, NULL, NULL, NULL, NULL, 4),
(100072, NULL, 'G3DSA:2.30.30.40:FF:000107', NULL, NULL, 'FCH and double SH3 domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(100073, NULL, 'G3DSA:3.40.50.300:FF:002633', NULL, NULL, 'mRNA cleavage and polyadenylation factor CLP1', NULL, NULL, NULL, NULL, NULL, 4),
(100074, NULL, 'G3DSA:3.40.50.1440:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100075, NULL, 'G3DSA:1.20.1250.20:FF:002081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100076, NULL, 'G3DSA:3.40.50.450:FF:000093', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(100077, NULL, 'G3DSA:3.30.497.10:FF:000062', NULL, NULL, 'AGAP007691-PA', NULL, NULL, NULL, NULL, NULL, 4),
(100078, NULL, 'G3DSA:3.50.50.60:FF:000679', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100079, NULL, 'G3DSA:3.30.720.10:FF:000003', NULL, NULL, 'Signal recognition particle 14', NULL, NULL, NULL, NULL, NULL, 4),
(100080, NULL, 'G3DSA:4.10.60.10:FF:000193', NULL, NULL, 'RNA binding motif protein 4.2', NULL, NULL, NULL, NULL, NULL, 4),
(100081, NULL, 'G3DSA:3.40.50.150:FF:001610', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100082, NULL, 'G3DSA:1.10.3430.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100083, NULL, 'G3DSA:2.130.10.10:FF:000019', NULL, NULL, 'echinoderm microtubule-associated protein-like 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(100084, NULL, 'G3DSA:3.30.160.60:FF:001891', NULL, NULL, 'Zinc finger protein 527', NULL, NULL, NULL, NULL, NULL, 4),
(100085, NULL, 'G3DSA:3.30.560.10:FF:000001', NULL, NULL, 'Oxygen-dependent choline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(100086, NULL, 'G3DSA:3.20.20.190:FF:000171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100087, NULL, 'G3DSA:1.10.287.110:FF:000054', NULL, NULL, 'dnaJ homolog subfamily B member 9', NULL, NULL, NULL, NULL, NULL, 4),
(100088, NULL, 'G3DSA:3.90.1150.10:FF:000074', NULL, NULL, 'Putative aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(100089, NULL, 'G3DSA:1.25.40.10:FF:002626', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100090, NULL, 'G3DSA:3.30.40.10:FF:002379', NULL, NULL, 'Tnf receptor associated factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100091, NULL, 'G3DSA:3.40.190.10:FF:000476', NULL, NULL, 'Oligopeptide ABC transporter, periplasmic oligopeptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(100092, NULL, 'G3DSA:1.25.40.20:FF:001674', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100093, NULL, 'G3DSA:1.10.950.10:FF:000004', NULL, NULL, 'Villin-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(100094, NULL, 'G3DSA:2.60.40.4100:FF:000014', NULL, NULL, 'Uromodulin-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(100095, NULL, 'G3DSA:3.30.200.20:FF:001927', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase EFR', NULL, NULL, NULL, NULL, NULL, 4),
(100096, NULL, 'G3DSA:3.30.559.10:FF:000032', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(100097, NULL, 'G3DSA:3.30.200.20:FF:001618', NULL, NULL, 'Kinase-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(100098, NULL, 'G3DSA:1.10.100.10:FF:000007', NULL, NULL, 'Insulin like 5', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(100099, NULL, 'G3DSA:3.40.640.10:FF:000449', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100100, NULL, 'G3DSA:1.10.10.1890:FF:000003', NULL, NULL, 'Spindle and kinetochore-associated protein 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(100101, NULL, 'G3DSA:3.30.160.60:FF:000694', NULL, NULL, 'zinc finger protein 516', NULL, NULL, NULL, NULL, NULL, 4),
(100102, NULL, 'G3DSA:3.40.50.1970:FF:000025', NULL, NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(100103, NULL, 'G3DSA:3.30.70.860:FF:000008', NULL, NULL, 'UPF0381 protein HI_0400', NULL, NULL, NULL, NULL, NULL, 4),
(100104, NULL, 'G3DSA:1.20.1560.10:FF:000954', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100105, NULL, 'G3DSA:1.10.510.10:FF:001101', NULL, NULL, 'serine/threonine-protein kinase Nek10', NULL, NULL, NULL, NULL, NULL, 4),
(100106, NULL, 'G3DSA:1.20.5.110:FF:000290', NULL, NULL, 'Syntaxin 8-1', NULL, NULL, NULL, NULL, NULL, 4),
(100107, NULL, 'G3DSA:3.30.160.60:FF:002380', NULL, NULL, 'Zinc finger protein 662', NULL, NULL, NULL, NULL, NULL, 4),
(100108, NULL, 'G3DSA:3.50.50.60:FF:000651', NULL, NULL, 'Amino acid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(100109, NULL, 'G3DSA:2.30.30.180:FF:000008', NULL, NULL, 'Ribosome maturation factor RimP', NULL, NULL, NULL, NULL, NULL, 4),
(100110, NULL, 'G3DSA:3.40.50.300:FF:006607', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100111, NULL, 'G3DSA:3.40.50.720:FF:001798', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(100112, NULL, 'G3DSA:3.30.300.30:FF:000022', NULL, NULL, 'Putative acyl-activating enzyme 19', NULL, NULL, NULL, NULL, NULL, 4),
(100113, NULL, 'G3DSA:3.30.160.60:FF:003009', NULL, NULL, 'Ras-responsive element binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100114, NULL, 'G3DSA:3.30.200.20:FF:000438', NULL, NULL, 'Serine/threonine-protein kinase WAG2', NULL, NULL, NULL, NULL, NULL, 4),
(100115, NULL, 'G3DSA:2.60.40.1180:FF:000222', NULL, NULL, 'Glycosyl hydrolase, family 13', NULL, NULL, NULL, NULL, NULL, 4),
(100116, NULL, 'G3DSA:3.40.250.10:FF:000094', NULL, NULL, 'Tyrosine-protein phosphatase vhp-1', NULL, NULL, NULL, NULL, NULL, 4),
(100117, NULL, 'G3DSA:2.40.50.140:FF:001055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100118, NULL, 'G3DSA:3.40.50.2300:FF:001237', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100119, NULL, 'G3DSA:3.40.720.10:FF:000158', NULL, NULL, 'Arylsulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(100120, NULL, 'G3DSA:1.10.565.10:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100121, NULL, 'G3DSA:2.60.120.260:FF:000632', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(100122, NULL, 'G3DSA:3.40.33.10:FF:000198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100123, NULL, 'G3DSA:2.30.30.30:FF:000009', NULL, NULL, '60S ribosomal protein L26', NULL, NULL, NULL, NULL, NULL, 4),
(100124, NULL, 'G3DSA:2.30.30.190:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100125, NULL, 'G3DSA:1.20.1560.10:FF:000645', NULL, NULL, 'ATP-binding cassette subfamily B member 5', NULL, NULL, NULL, NULL, NULL, 4),
(100126, NULL, 'G3DSA:1.20.58.390:FF:000125', NULL, NULL, 'Acetylcholine-gated ion channel acc-4', NULL, NULL, NULL, NULL, NULL, 4),
(100127, NULL, 'G3DSA:3.30.720.10:FF:000020', NULL, NULL, 'Signal recognition particle subunit srp14', NULL, NULL, NULL, NULL, NULL, 4),
(100128, NULL, 'G3DSA:3.30.1360.120:FF:000098', NULL, NULL, 'Putative transferase caf17, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(100129, NULL, 'G3DSA:1.25.10.10:FF:002214', NULL, NULL, 'Tape measure protein', NULL, NULL, NULL, NULL, NULL, 4),
(100130, NULL, 'G3DSA:1.20.1250.20:FF:002007', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(100131, NULL, 'G3DSA:1.10.3720.10:FF:000115', NULL, NULL, 'Sugar-transport integral membrane protein ABC transporter sugB', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(100132, NULL, 'G3DSA:3.80.10.10:FF:004140', NULL, NULL, 'RXFP2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(100133, NULL, 'G3DSA:3.40.50.1980:FF:000146', NULL, NULL, 'Putative ferrichrome-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(100134, NULL, 'G3DSA:3.30.230.20:FF:000002', NULL, NULL, 'Probable UDP-3-O-acyl-N-acetylglucosamine deacetylase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(100135, NULL, 'G3DSA:2.40.30.230:FF:000010', NULL, NULL, 'YALI0D23881p', NULL, NULL, NULL, NULL, NULL, 4),
(100136, NULL, 'G3DSA:3.30.420.40:FF:000618', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100137, NULL, 'G3DSA:2.30.30.10:FF:000003', NULL, NULL, 'Gag-Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(100138, NULL, 'G3DSA:3.30.565.10:FF:000214', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(100139, NULL, 'G3DSA:1.20.120.330:FF:000028', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(100140, NULL, 'G3DSA:3.30.70.330:FF:001305', NULL, NULL, 'U1 small nuclear ribonucleoprotein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100141, NULL, 'G3DSA:3.10.20.800:FF:000002', NULL, NULL, 'L,D-transpeptidase catalytic domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(100142, NULL, 'G3DSA:1.10.240.10:FF:000017', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(100143, NULL, 'G3DSA:1.20.1070.10:FF:001243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100144, NULL, 'G3DSA:1.10.260.130:FF:000001', NULL, NULL, 'Lipase 2', NULL, NULL, NULL, NULL, NULL, 4),
(100145, NULL, 'G3DSA:3.40.33.10:FF:000209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100146, NULL, 'G3DSA:3.30.505.10:FF:000099', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(100147, NULL, 'G3DSA:1.20.1560.10:FF:000162', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(100148, NULL, 'G3DSA:3.30.60.80:FF:000001', NULL, NULL, 'Recombination protein RecR', NULL, NULL, NULL, NULL, NULL, 4),
(100149, NULL, 'G3DSA:1.10.555.10:FF:000243', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100150, NULL, 'G3DSA:2.130.10.10:FF:002358', NULL, NULL, 'Unplaced genomic scaffold supercont2.10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(100151, NULL, 'G3DSA:2.60.40.60:FF:000096', NULL, NULL, 'Desmocollin 2', NULL, NULL, NULL, NULL, NULL, 4),
(100152, NULL, 'G3DSA:1.10.3170.10:FF:000005', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(100153, NULL, 'G3DSA:3.30.310.50:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100154, NULL, 'G3DSA:1.10.287.470:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100155, NULL, 'G3DSA:1.25.10.10:FF:001809', NULL, NULL, 'Phospholipase A-2-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(100156, NULL, 'G3DSA:1.25.10.10:FF:001697', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100157, NULL, 'G3DSA:3.20.20.80:FF:000858', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100158, NULL, 'G3DSA:1.10.510.10:FF:004052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100159, NULL, 'G3DSA:3.90.20.20:FF:000023', NULL, NULL, 'Protein GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(100160, NULL, 'G3DSA:3.40.50.300:FF:006495', NULL, NULL, 'Autophagy-related protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(100161, NULL, 'G3DSA:2.130.10.10:FF:002936', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100162, NULL, 'G3DSA:3.40.30.10:FF:000967', NULL, NULL, 'Iodothyronine deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(100163, NULL, 'G3DSA:2.40.100.10:FF:000076', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(100164, NULL, 'G3DSA:3.30.200.20:FF:001057', NULL, NULL, 'Probable receptor-like protein kinase At1g33260', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(100165, NULL, 'G3DSA:2.30.30.100:FF:000030', NULL, NULL, 'Bifunctional ligase/repressor BirA', NULL, NULL, NULL, NULL, NULL, 4),
(100166, NULL, 'G3DSA:1.10.510.10:FF:003916', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100167, NULL, 'G3DSA:3.90.1150.10:FF:000411', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100168, NULL, 'G3DSA:2.60.40.10:FF:004960', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100169, NULL, 'G3DSA:2.40.50.140:FF:000436', NULL, NULL, 'DNA-directed RNA polymerases I, II, and III subunit RPABC3', NULL, NULL, NULL, NULL, NULL, 4),
(100170, NULL, 'G3DSA:3.10.20.90:FF:001003', NULL, NULL, 'FERM domain-containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(100171, NULL, 'G3DSA:1.10.10.10:FF:000348', NULL, NULL, 'Transcriptional regulator BlaI', NULL, NULL, NULL, NULL, NULL, 4),
(100172, NULL, 'G3DSA:3.30.70.330:FF:000541', NULL, NULL, 'Nuclear cap-binding protein subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(100173, NULL, 'G3DSA:2.60.210.10:FF:000068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100174, NULL, 'G3DSA:3.30.830.10:FF:000202', NULL, NULL, 'Metalloenzyme, LuxS/M16 peptidase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(100175, NULL, 'G3DSA:3.80.10.10:FF:003634', NULL, NULL, 'Slit guidance ligand 3', NULL, NULL, NULL, NULL, NULL, 4),
(100176, NULL, 'G3DSA:3.30.70.240:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100177, NULL, 'G3DSA:3.40.850.10:FF:000151', NULL, NULL, 'Kinesin-like protein costa', NULL, NULL, NULL, NULL, NULL, 4),
(100178, NULL, 'G3DSA:3.10.100.10:FF:000045', NULL, NULL, 'Pulmonary surfactant-associated protein D', NULL, NULL, NULL, NULL, NULL, 4),
(100179, NULL, 'G3DSA:3.30.40.10:FF:001070', NULL, NULL, 'GM16934', NULL, NULL, NULL, NULL, NULL, 4),
(100180, NULL, 'G3DSA:1.10.340.30:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100181, NULL, 'G3DSA:1.10.400.10:FF:000019', NULL, NULL, 'Unplaced genomic scaffold supercont1.208, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(100182, NULL, 'G3DSA:3.10.129.10:FF:000217', NULL, NULL, '1,4-dihydroxy-2-naphthoyl-CoA thioesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(100183, NULL, 'G3DSA:3.30.450.20:FF:000485', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(100184, NULL, 'G3DSA:1.25.10.10:FF:002315', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100185, NULL, 'G3DSA:3.40.50.300:FF:003370', NULL, NULL, 'Putative ATP-dependent RNA helicase CG14443', NULL, NULL, NULL, NULL, NULL, 4),
(100186, NULL, 'G3DSA:3.40.50.620:FF:000503', NULL, NULL, 'Tryptophan--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(100187, NULL, 'G3DSA:3.10.20.90:FF:000148', NULL, NULL, 'Ubiquitin-like protein ATG12', NULL, NULL, NULL, NULL, NULL, 4),
(100188, NULL, 'G3DSA:1.20.58.80:FF:000028', NULL, NULL, 'Putative ubiquitin C-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(100189, NULL, 'G3DSA:1.20.1560.10:FF:000746', NULL, NULL, 'Multidrug resistance protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100190, NULL, 'G3DSA:1.20.58.390:FF:000226', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(100191, NULL, 'G3DSA:1.10.472.10:FF:000264', NULL, NULL, 'RNA polymerase II holoenzyme cyclin-like subunit', NULL, NULL, NULL, NULL, NULL, 4),
(100192, NULL, 'G3DSA:3.40.630.30:FF:000179', NULL, NULL, 'RNA cytidine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(100193, NULL, 'G3DSA:3.40.1390.30:FF:000002', NULL, NULL, 'Nif3-like dinuclear metal center protein', NULL, NULL, NULL, NULL, NULL, 4),
(100194, NULL, 'G3DSA:2.10.25.10:FF:001060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100195, NULL, 'G3DSA:1.10.510.10:FF:000937', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(100196, NULL, 'G3DSA:3.30.200.20:FF:001282', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100197, NULL, 'G3DSA:2.20.25.90:FF:000009', NULL, NULL, 'DMSO reductase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(100198, NULL, 'G3DSA:2.60.40.790:FF:000130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100199, NULL, 'G3DSA:3.30.160.60:FF:000255', NULL, NULL, 'Zinc finger and AT-hook domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(100200, NULL, 'G3DSA:3.90.70.10:FF:000113', NULL, NULL, 'Putative cysteine protease', NULL, NULL, NULL, NULL, NULL, 4),
(100201, NULL, 'G3DSA:3.30.465.10:FF:000061', NULL, NULL, 'Aspergillus niger contig An11c0010, genomic contig', NULL, NULL, NULL, NULL, NULL, 4),
(100202, NULL, 'G3DSA:1.10.8.50:FF:000033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(100203, NULL, 'G3DSA:2.130.10.10:FF:004061', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(100204, NULL, 'G3DSA:3.30.565.10:FF:000428', NULL, NULL, 'Hybrid signal transduction histidine kinase M', NULL, NULL, NULL, NULL, NULL, 4),
(100205, NULL, 'G3DSA:1.25.40.10:FF:001637', NULL, NULL, 'General transcription factor 3C polypeptide 3', NULL, NULL, NULL, NULL, NULL, 4),
(100206, NULL, 'G3DSA:2.30.30.40:FF:000546', NULL, NULL, 'Calcium channel, voltage-dependent, beta 3 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(100207, NULL, 'G3DSA:3.30.1380.20:FF:000023', NULL, NULL, 'Transport protein particle component bet3 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(100208, NULL, 'G3DSA:1.20.1110.10:FF:000134', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100209, NULL, 'G3DSA:2.30.110.10:FF:000056', NULL, NULL, 'Heme oxygenase HugZ', NULL, NULL, NULL, NULL, NULL, 4),
(100210, NULL, 'G3DSA:3.90.70.10:FF:000540', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(100211, NULL, 'G3DSA:4.10.60.10:FF:000237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100212, NULL, 'G3DSA:3.40.50.300:FF:005404', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100213, NULL, 'G3DSA:3.30.1740.20:FF:000006', NULL, NULL, '40S ribosomal protein S26', NULL, NULL, NULL, NULL, NULL, 4),
(100214, NULL, 'G3DSA:3.40.850.10:FF:000403', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(100215, NULL, 'G3DSA:2.30.30.40:FF:000208', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(100216, NULL, 'G3DSA:3.40.50.300:FF:007321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100217, NULL, 'G3DSA:2.60.40.820:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100218, NULL, 'G3DSA:1.10.590.10:FF:000004', NULL, NULL, 'Chorismate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(100219, NULL, 'G3DSA:1.10.246.20:FF:000005', NULL, NULL, 'Protein sepa-1', NULL, NULL, NULL, NULL, NULL, 4),
(100220, NULL, 'G3DSA:2.60.120.320:FF:000009', NULL, NULL, 'Thiamine pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(100221, NULL, 'G3DSA:3.30.410.10:FF:000002', NULL, NULL, 'GMC-type oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(100222, NULL, 'G3DSA:3.50.50.60:FF:000196', NULL, NULL, 'L-amino acid oxidase LaoA', NULL, NULL, NULL, NULL, NULL, 4),
(100223, NULL, 'G3DSA:1.10.287.110:FF:000476', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(100224, NULL, 'G3DSA:3.30.160.60:FF:005898', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100225, NULL, 'G3DSA:2.60.120.260:FF:000380', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100226, NULL, 'G3DSA:3.90.180.10:FF:000161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100227, NULL, 'G3DSA:3.30.160.60:FF:001211', NULL, NULL, 'Zinc finger and AT-hook domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(100228, NULL, 'G3DSA:2.115.10.20:FF:000007', NULL, NULL, 'Levansucrase LscB', NULL, NULL, NULL, NULL, NULL, 4),
(100229, NULL, 'G3DSA:1.10.10.430:FF:000003', NULL, NULL, 'probable protein phosphatase 1N isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(100230, NULL, 'G3DSA:3.30.160.60:FF:000593', NULL, NULL, 'PR domain zinc finger protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(100231, NULL, 'G3DSA:3.50.50.60:FF:000308', NULL, NULL, 'Mycothione reductase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(100232, NULL, 'G3DSA:1.10.238.10:FF:000118', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(100233, NULL, 'G3DSA:2.40.70.10:FF:000016', NULL, NULL, 'Probable aspartic protease At2g35615', NULL, NULL, NULL, NULL, NULL, 4),
(100234, NULL, 'G3DSA:3.30.750.24:FF:000046', NULL, NULL, 'Solute carrier family 26 (Sodium-independent sulfate anion transporter), member 11', NULL, NULL, NULL, NULL, NULL, 4),
(100235, NULL, 'G3DSA:2.70.170.10:FF:000005', NULL, NULL, 'Neuronal nicotinic acetylcholine receptor alpha4 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(100236, NULL, 'G3DSA:1.10.472.10:FF:000056', NULL, NULL, 'Cyclin G2', NULL, NULL, NULL, NULL, NULL, 4),
(100237, NULL, 'G3DSA:2.80.10.70:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100238, NULL, 'G3DSA:3.30.160.60:FF:003689', NULL, NULL, 'Si:ch73-347e22.4', NULL, NULL, NULL, NULL, NULL, 4),
(100239, NULL, 'G3DSA:2.40.10.10:FF:000390', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100240, NULL, 'G3DSA:3.40.850.10:FF:000504', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(100241, NULL, 'G3DSA:1.25.40.10:FF:005268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100242, NULL, 'G3DSA:3.90.980.20:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100243, NULL, 'G3DSA:3.80.10.10:FF:000200', NULL, NULL, 'Outer arm dynein light chain 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(100244, NULL, 'G3DSA:3.30.420.40:FF:001023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100245, NULL, 'G3DSA:3.30.1540.20:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100246, NULL, 'G3DSA:2.60.60.20:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100247, NULL, 'G3DSA:3.40.50.150:FF:000121', NULL, NULL, 'Sterol 24-C-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(100248, NULL, 'G3DSA:3.40.30.10:FF:001164', NULL, NULL, 'Glutathione S-transferase Gst', NULL, NULL, NULL, NULL, NULL, 4),
(100249, NULL, 'G3DSA:1.10.135.10:FF:000020', NULL, NULL, 'Creatine kinase, brain b', NULL, NULL, NULL, NULL, NULL, 4),
(100250, NULL, 'G3DSA:2.60.40.4100:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100251, NULL, 'G3DSA:3.40.50.1980:FF:000045', NULL, NULL, 'Ferric hydroxamate receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(100252, NULL, 'G3DSA:2.130.10.10:FF:004275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100253, NULL, 'G3DSA:3.40.50.300:FF:002650', NULL, NULL, 'MAK5p nucleolar protein', NULL, NULL, NULL, NULL, NULL, 4),
(100254, NULL, 'G3DSA:1.10.472.30:FF:000011', NULL, NULL, 'WGS project CABT00000000 data, contig 2.29', NULL, NULL, NULL, NULL, NULL, 4),
(100255, NULL, 'G3DSA:1.10.510.10:FF:000584', NULL, NULL, 'NIMA related kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(100256, NULL, 'G3DSA:1.10.3470.10:FF:000017', NULL, NULL, 'Iron compound ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(100257, NULL, 'G3DSA:2.120.10.30:FF:000301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100258, NULL, 'G3DSA:1.20.5.1500:FF:000002', NULL, NULL, 'breast cancer metastasis-suppressor 1-like protein-A', NULL, NULL, NULL, NULL, NULL, 4),
(100259, NULL, 'G3DSA:2.60.40.10:FF:001115', NULL, NULL, 'Titin b', NULL, NULL, NULL, NULL, NULL, 4),
(100260, NULL, 'G3DSA:2.130.10.10:FF:003656', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(100261, NULL, 'G3DSA:2.40.150.20:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100262, NULL, 'G3DSA:3.90.730.10:FF:000018', NULL, NULL, 'T2 family ribonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100263, NULL, 'G3DSA:2.130.10.10:FF:003347', NULL, NULL, 'Autophagy-related protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(100264, NULL, 'G3DSA:2.60.120.260:FF:000424', NULL, NULL, 'Alpha-L-arabinofuranosidase 1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(100265, NULL, 'G3DSA:3.30.230.10:FF:000145', NULL, NULL, 'Galactokinase putative', NULL, NULL, NULL, NULL, NULL, 4),
(100266, NULL, 'G3DSA:3.80.10.10:FF:003735', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100267, NULL, 'G3DSA:2.130.10.10:FF:001638', NULL, NULL, 'Os07g0589400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(100268, NULL, 'G3DSA:3.30.70.330:FF:001513', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100269, NULL, 'G3DSA:1.20.1280.50:FF:000017', NULL, NULL, 'F-box only protein 32', NULL, NULL, NULL, NULL, NULL, 4),
(100270, NULL, 'G3DSA:1.10.510.10:FF:002062', NULL, NULL, 'Serine/threonine kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100271, NULL, 'G3DSA:3.90.1200.10:FF:000039', NULL, NULL, 'Methylthioribose kinase', NULL, NULL, NULL, NULL, NULL, 4),
(100272, NULL, 'G3DSA:3.90.226.10:FF:000083', NULL, NULL, 'Enoyl-CoA hydratase EchA13', NULL, NULL, NULL, NULL, NULL, 4),
(100273, NULL, 'G3DSA:3.20.20.140:FF:000279', NULL, NULL, 'Deoxyribonuclease, TatD family', NULL, NULL, NULL, NULL, NULL, 4),
(100274, NULL, 'G3DSA:3.30.230.130:FF:000074', NULL, NULL, 'Anaphase promoting complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(100275, NULL, 'G3DSA:3.10.28.10:FF:000047', NULL, NULL, 'DNA endonuclease I-CreI', NULL, NULL, NULL, NULL, NULL, 4),
(100276, NULL, 'G3DSA:3.30.200.20:FF:000068', NULL, NULL, 'G protein-coupled receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(100277, NULL, 'G3DSA:3.40.50.150:FF:000430', NULL, NULL, 'Arginine N-methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(100278, NULL, 'G3DSA:2.160.20.10:FF:000143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100279, NULL, 'G3DSA:2.60.40.10:FF:005932', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100280, NULL, 'G3DSA:1.10.10.10:FF:000556', NULL, NULL, 'ELK1, member of ETS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(100281, NULL, 'G3DSA:1.25.40.10:FF:002143', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(100282, NULL, 'G3DSA:2.10.70.10:FF:000304', NULL, NULL, 'Pregnancy-associated plasma protein A, pappalysin 1b', NULL, NULL, NULL, NULL, NULL, 4),
(100283, NULL, 'G3DSA:2.30.29.30:FF:000736', NULL, NULL, 'Dip13 beta, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100284, NULL, 'G3DSA:3.30.420.10:FF:000755', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100285, NULL, 'G3DSA:2.40.70.10:FF:000117', NULL, NULL, 'Os01g0937500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(100286, NULL, 'G3DSA:3.50.50.60:FF:000207', NULL, NULL, 'Glutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(100287, NULL, 'G3DSA:2.10.25.10:FF:000672', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(100288, NULL, 'G3DSA:3.40.50.300:FF:002864', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(100289, NULL, 'G3DSA:3.40.50.300:FF:006596', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100290, NULL, 'G3DSA:3.30.420.40:FF:000404', NULL, NULL, 'Major actin', NULL, NULL, NULL, NULL, NULL, 4),
(100291, NULL, 'G3DSA:1.10.630.10:FF:000637', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100292, NULL, 'G3DSA:3.40.50.300:FF:006916', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100293, NULL, 'G3DSA:2.10.109.10:FF:000080', NULL, NULL, 'Inner mitochondrial membrane peptidase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(100294, NULL, 'G3DSA:3.30.160.60:FF:004645', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100295, NULL, 'G3DSA:1.10.3450.20:FF:000007', NULL, NULL, 'Nuclear pore complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(100296, NULL, 'G3DSA:3.30.1520.10:FF:000021', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(100297, NULL, 'G3DSA:1.20.810.10:FF:000020', NULL, NULL, 'Cytochrome b', NULL, NULL, NULL, NULL, NULL, 4),
(100298, NULL, 'G3DSA:1.10.150.20:FF:000148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100299, NULL, 'G3DSA:3.80.10.10:FF:003426', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(100300, NULL, 'G3DSA:3.30.70.330:FF:002339', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100301, NULL, 'G3DSA:3.30.420.100:FF:000012', NULL, NULL, 'Apicoplast ribosomal protein L18', NULL, NULL, NULL, NULL, NULL, 4),
(100302, NULL, 'G3DSA:2.60.40.150:FF:000641', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100303, NULL, 'G3DSA:1.50.10.20:FF:000001', NULL, NULL, 'CD109 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(100304, NULL, 'G3DSA:2.40.160.50:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100305, NULL, 'G3DSA:1.10.510.10:FF:002618', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100306, NULL, 'G3DSA:2.60.40.60:FF:000360', NULL, NULL, 'Protocadherin 19', NULL, NULL, NULL, NULL, NULL, 4),
(100307, NULL, 'G3DSA:3.40.50.300:FF:006023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100308, NULL, 'G3DSA:1.10.560.10:FF:000064', NULL, NULL, 'Probable T-complex protein 1 subunit theta', NULL, NULL, NULL, NULL, NULL, 4),
(100309, NULL, 'G3DSA:3.30.365.10:FF:000008', NULL, NULL, 'Aldehyde oxidase1', NULL, NULL, NULL, NULL, NULL, 4),
(100310, NULL, 'G3DSA:3.60.40.10:FF:000219', NULL, NULL, 'Probable protein phosphatase 2C 54', NULL, NULL, NULL, NULL, NULL, 4),
(100311, NULL, 'G3DSA:1.10.220.160:FF:000013', NULL, NULL, 'SET domain-containing protein SmydA-8, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(100312, NULL, 'G3DSA:2.130.10.10:FF:003908', NULL, NULL, 'PRP4 pre-mRNA-processing factor 4 homolog (yeast)', NULL, NULL, NULL, NULL, NULL, 4),
(100313, NULL, 'G3DSA:3.30.1370.10:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100314, NULL, 'G3DSA:1.20.1060.10:FF:000017', NULL, NULL, 'DNA polymerase theta', NULL, NULL, NULL, NULL, NULL, 4),
(100315, NULL, 'G3DSA:3.10.129.10:FF:000009', NULL, NULL, 'Cytosolic acyl coenzyme A thioester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(100316, NULL, 'G3DSA:1.20.120.620:FF:000008', NULL, NULL, 'Sensor histidine kinase KdpD', NULL, NULL, NULL, NULL, NULL, 4),
(100317, NULL, 'G3DSA:3.40.50.410:FF:000188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100318, NULL, 'G3DSA:2.130.10.10:FF:003072', NULL, NULL, 'WD repeat-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(100319, NULL, 'G3DSA:3.40.630.30:FF:000078', NULL, NULL, 'N-alpha-acetyltransferase 50', NULL, NULL, NULL, NULL, NULL, 4),
(100320, NULL, 'G3DSA:1.10.510.10:FF:000370', NULL, NULL, 'cyclin-dependent kinase-like 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(100321, NULL, 'G3DSA:2.20.100.10:FF:000052', NULL, NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 6', NULL, NULL, NULL, NULL, NULL, 4),
(100322, NULL, 'G3DSA:3.10.20.90:FF:000047', NULL, NULL, 'Auxin response factor', NULL, NULL, NULL, NULL, NULL, 4),
(100323, NULL, 'G3DSA:1.25.10.10:FF:002523', NULL, NULL, 'Condensin complex subunit 3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(100324, NULL, 'G3DSA:3.40.50.300:FF:008041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100325, NULL, 'G3DSA:2.60.40.60:FF:000916', NULL, NULL, 'Protocadherin 12', NULL, NULL, NULL, NULL, NULL, 4),
(100326, NULL, 'G3DSA:3.30.470.10:FF:000039', NULL, NULL, 'Probable amino acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(100327, NULL, 'G3DSA:3.30.40.10:FF:000007', NULL, NULL, 'Bromodomain containing 1, isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(100328, NULL, 'G3DSA:1.20.920.30:FF:000017', NULL, NULL, 'Dynein axonemal heavy chain 14', NULL, NULL, NULL, NULL, NULL, 4),
(100329, NULL, 'G3DSA:3.80.10.10:FF:003943', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100330, NULL, 'G3DSA:2.60.120.290:FF:000175', NULL, NULL, 'Mannose-binding lectin associated serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(100331, NULL, 'G3DSA:3.90.550.10:FF:000572', NULL, NULL, 'UTP--glucose-1-phosphate uridylyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(100332, NULL, 'G3DSA:3.40.190.10:FF:000712', NULL, NULL, 'Blr6048 protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(100333, NULL, 'G3DSA:1.10.10.470:FF:000004', NULL, NULL, 'Probable glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(100334, NULL, 'G3DSA:3.10.110.10:FF:000282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100335, NULL, 'G3DSA:1.10.10.10:FF:000909', NULL, NULL, 'RNA polymerase sigma factor SigB', NULL, NULL, NULL, NULL, NULL, 4),
(100336, NULL, 'G3DSA:2.10.25.10:FF:000863', NULL, NULL, 'Multiple epidermal growth factor-like domains protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(100337, NULL, 'G3DSA:3.40.50.300:FF:002442', NULL, NULL, 'GTPase Era', NULL, NULL, NULL, NULL, NULL, 4),
(100338, NULL, 'G3DSA:2.130.10.10:FF:002830', NULL, NULL, 'AT07549p', NULL, NULL, NULL, NULL, NULL, 4),
(100339, NULL, 'G3DSA:2.60.120.920:FF:000083', NULL, NULL, 'Zn-finger in Ran binding protein and others/SPRY domain/HECT-domain (Ubiquitin-transferase), putative', NULL, NULL, NULL, NULL, NULL, 4),
(100340, NULL, 'G3DSA:1.10.287.110:FF:000262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100341, NULL, 'G3DSA:2.60.34.10:FF:000112', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(100342, NULL, 'G3DSA:3.30.70.330:FF:001614', NULL, NULL, 'RNA-binding protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(100343, NULL, 'G3DSA:2.60.40.10:FF:004651', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100344, NULL, 'G3DSA:3.30.70.330:FF:000996', NULL, NULL, 'U4/U6 snRNP-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(100345, NULL, 'G3DSA:1.20.58.830:FF:000050', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(100346, NULL, 'G3DSA:3.80.10.10:FF:001026', NULL, NULL, 'Putative leucine-rich repeat receptor-like serine/threonine-protein kinase isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(100347, NULL, 'G3DSA:3.40.50.10800:FF:000009', NULL, NULL, 'Quinolinate synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(100348, NULL, 'G3DSA:2.60.40.10:FF:002604', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100349, NULL, 'G3DSA:2.60.40.10:FF:001986', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(100350, NULL, 'G3DSA:2.10.110.10:FF:000307', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100351, NULL, 'G3DSA:2.70.170.10:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100352, NULL, 'G3DSA:3.40.50.720:FF:002540', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100353, NULL, 'G3DSA:3.10.100.10:FF:000253', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100354, NULL, 'G3DSA:1.20.120.420:FF:000022', NULL, NULL, 'Probable translation initiation factor eIF-2B subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(100355, NULL, 'G3DSA:3.40.1090.10:FF:000007', NULL, NULL, 'Lysophospholipase NTE1', NULL, NULL, NULL, NULL, NULL, 4),
(100356, NULL, 'G3DSA:3.40.30.10:FF:000545', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(100357, NULL, 'G3DSA:3.30.50.10:FF:000036', NULL, NULL, 'Endothelial transcription factor GATA-2', NULL, NULL, NULL, NULL, NULL, 4),
(100358, NULL, 'G3DSA:3.30.930.10:FF:000266', NULL, NULL, 'Class II aaRS and biotin synthetases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(100359, NULL, 'G3DSA:3.30.710.10:FF:000047', NULL, NULL, 'Zinc finger and BTB domain-containing protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(100360, NULL, 'G3DSA:2.60.120.620:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100361, NULL, 'G3DSA:1.10.8.720:FF:000070', NULL, NULL, 'Dynein axonemal heavy chain 3', NULL, NULL, NULL, NULL, NULL, 4),
(100362, NULL, 'G3DSA:1.10.472.10:FF:000617', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100363, NULL, 'G3DSA:2.120.10.80:FF:000322', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100364, NULL, 'G3DSA:2.60.200.20:FF:000132', NULL, NULL, 'Cell-cycle checkpoint serine-threonine kinase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(100365, NULL, 'G3DSA:2.130.10.10:FF:000930', NULL, NULL, 'Dmx like 1', NULL, NULL, NULL, NULL, NULL, 4),
(100366, NULL, 'G3DSA:3.30.450.40:FF:000232', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(100367, NULL, 'G3DSA:3.30.60.30:FF:000211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100368, NULL, 'G3DSA:1.25.40.10:FF:003470', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(100369, NULL, 'G3DSA:1.10.510.10:FF:002270', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100370, NULL, 'G3DSA:2.60.40.10:FF:002751', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100371, NULL, 'G3DSA:1.10.418.10:FF:000077', NULL, NULL, 'Related to alpha-actinin', NULL, NULL, NULL, NULL, NULL, 4),
(100372, NULL, 'G3DSA:3.90.550.10:FF:000425', NULL, NULL, 'polypeptide N-acetylgalactosaminyltransferase 10 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(100373, NULL, 'G3DSA:1.10.10.10:FF:002034', NULL, NULL, 'Cell division control protein', NULL, NULL, NULL, NULL, NULL, 4),
(100374, NULL, 'G3DSA:1.20.920.10:FF:000011', NULL, NULL, 'Protein polybromo-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(100375, NULL, 'G3DSA:3.30.420.10:FF:000300', NULL, NULL, 'Poly(A)-specific_ribonuclease_PARN_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(100376, NULL, 'G3DSA:1.10.30.10:FF:000147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100377, NULL, 'G3DSA:3.10.110.10:FF:000079', NULL, NULL, 'ubiquitin-conjugating enzyme E2 H isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(100378, NULL, 'G3DSA:3.40.50.300:FF:005051', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(100379, NULL, 'G3DSA:1.10.20.10:FF:000062', NULL, NULL, 'Nuclear transcription factor Y subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(100380, NULL, 'G3DSA:3.100.10.10:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100381, NULL, 'G3DSA:3.10.120.10:FF:000006', NULL, NULL, 'Membrane steroid-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(100382, NULL, 'G3DSA:3.40.50.620:FF:000150', NULL, NULL, 'Integral membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(100383, NULL, 'G3DSA:3.20.20.140:FF:000487', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100384, NULL, 'G3DSA:3.40.395.10:FF:000019', NULL, NULL, 'Similar to Ulp1 peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(100385, NULL, 'G3DSA:1.10.10.60:FF:000874', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100386, NULL, 'G3DSA:1.10.238.10:FF:000984', NULL, NULL, 'Probable mitochondrial Rho GTPase gemA', NULL, NULL, NULL, NULL, NULL, 4),
(100387, NULL, 'G3DSA:3.30.160.100:FF:000003', NULL, NULL, 'Ribosome hibernation promoting factor', NULL, NULL, NULL, NULL, NULL, 4),
(100388, NULL, 'G3DSA:3.30.200.20:FF:002119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100389, NULL, 'G3DSA:3.90.70.200:FF:000011', NULL, NULL, 'Rtfo-1', NULL, NULL, NULL, NULL, NULL, 4),
(100390, NULL, 'G3DSA:3.30.1330.200:FF:000003', NULL, NULL, 'Probable chemoreceptor glutamine deamidase CheD 1', NULL, NULL, NULL, NULL, NULL, 4),
(100391, NULL, 'G3DSA:4.10.410.10:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100392, NULL, 'G3DSA:3.30.160.60:FF:001110', NULL, NULL, 'Krueppel factor 13', NULL, NULL, NULL, NULL, NULL, 4),
(100393, NULL, 'G3DSA:2.30.29.30:FF:000944', NULL, NULL, 'Phospholipase D B', NULL, NULL, NULL, NULL, NULL, 4),
(100394, NULL, 'G3DSA:3.60.140.10:FF:000002', NULL, NULL, 'Laccase (multicopper oxidoreductase) domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(100395, NULL, 'G3DSA:2.30.30.100:FF:000136', NULL, NULL, 'YALI0D14102p', NULL, NULL, NULL, NULL, NULL, 4),
(100396, NULL, 'G3DSA:3.40.50.10810:FF:000107', NULL, NULL, 'SNF2 domain-containing protein / helicase domain-containing protein / zinc finger protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(100397, NULL, 'G3DSA:2.40.70.10:FF:000472', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(100398, NULL, 'G3DSA:3.40.800.10:FF:000001', NULL, NULL, 'Agmatinase', NULL, NULL, NULL, NULL, NULL, 4),
(100399, NULL, 'G3DSA:3.40.140.10:FF:000001', NULL, NULL, '26S proteasome non-ATPase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(100400, NULL, 'G3DSA:3.30.870.10:FF:000120', NULL, NULL, 'Cardiolipin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(100401, NULL, 'G3DSA:2.60.40.10:FF:003223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100402, NULL, 'G3DSA:1.25.10.10:FF:002006', NULL, NULL, 'mRNA-binding U2 snRNP complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(100403, NULL, 'G3DSA:3.90.1150.10:FF:000175', NULL, NULL, 'Unplaced genomic scaffold supercont1.163, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(100404, NULL, 'G3DSA:1.20.1050.10:FF:000207', NULL, NULL, 'Methionine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(100405, NULL, 'G3DSA:4.10.520.10:FF:000016', NULL, NULL, 'DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(100406, NULL, 'G3DSA:2.60.120.370:FF:000002', NULL, NULL, 'YhcH/YjgK/YiaL family protein', NULL, NULL, NULL, NULL, NULL, 4),
(100407, NULL, 'G3DSA:3.30.1370.10:FF:000059', NULL, NULL, 'Tudor and KH domain containing, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(100408, NULL, 'G3DSA:2.40.30.10:FF:000351', NULL, NULL, 'Ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(100409, NULL, 'G3DSA:3.40.50.300:FF:004342', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(100410, NULL, 'G3DSA:3.90.1290.10:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100411, NULL, 'G3DSA:1.10.150.20:FF:000047', NULL, NULL, 'DNA-directed RNA polymerase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(100412, NULL, 'G3DSA:1.10.510.10:FF:002371', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100413, NULL, 'G3DSA:1.20.1070.10:FF:002007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100414, NULL, 'G3DSA:3.10.100.10:FF:000354', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100415, NULL, 'G3DSA:1.25.40.10:FF:004296', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(100416, NULL, 'G3DSA:2.60.40.10:FF:000497', NULL, NULL, 'Striated muscle preferentially expressed protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(100417, NULL, 'G3DSA:2.60.120.200:FF:000058', NULL, NULL, 'Laminin subunit alpha 4', NULL, NULL, NULL, NULL, NULL, 4),
(100418, NULL, 'G3DSA:3.40.309.10:FF:000056', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(100419, NULL, 'G3DSA:3.30.40.10:FF:000350', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(100420, NULL, 'G3DSA:2.60.120.260:FF:000071', NULL, NULL, 'Ephrin type-B receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(100421, NULL, 'G3DSA:2.60.200.30:FF:000034', NULL, NULL, 'Inorganic polyphosphate/ATP-NAD kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100422, NULL, 'G3DSA:3.40.50.300:FF:001936', NULL, NULL, 'tRNA dimethylallyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(100423, NULL, 'G3DSA:3.40.50.150:FF:001402', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100424, NULL, 'G3DSA:2.40.10.10:FF:000451', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100425, NULL, 'G3DSA:1.25.40.10:FF:000917', NULL, NULL, 'Signal recognition particle subunit SRP72', NULL, NULL, NULL, NULL, NULL, 4),
(100426, NULL, 'G3DSA:2.60.40.10:FF:004196', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100427, NULL, 'G3DSA:3.80.10.10:FF:001689', NULL, NULL, 'Leucine Rich Repeat domain protein (AFU_orthologue AFUA_7G02000)', NULL, NULL, NULL, NULL, NULL, 4),
(100428, NULL, 'G3DSA:3.10.580.10:FF:000119', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(100429, NULL, 'G3DSA:3.40.20.10:FF:000146', NULL, NULL, 'Villidin', NULL, NULL, NULL, NULL, NULL, 4),
(100430, NULL, 'G3DSA:3.90.105.10:FF:000026', NULL, NULL, 'Molybdenum cofactor biosynthesis protein (MoaA)', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(100431, NULL, 'G3DSA:1.25.40.20:FF:001174', NULL, NULL, 'Transient receptor potential cation channel subfamily A member 1', NULL, NULL, NULL, NULL, NULL, 4),
(100432, NULL, 'G3DSA:2.90.10.10:FF:000027', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(100433, NULL, 'G3DSA:1.10.287.130:FF:000268', NULL, NULL, 'Sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(100434, NULL, 'G3DSA:2.60.260.20:FF:000006', NULL, NULL, 'DnaJ subfamily B member 13', NULL, NULL, NULL, NULL, NULL, 4),
(100435, NULL, 'G3DSA:1.10.10.10:FF:000134', NULL, NULL, 'Regulatory protein RecX', NULL, NULL, NULL, NULL, NULL, 4),
(100436, NULL, 'G3DSA:2.60.40.1670:FF:000009', NULL, NULL, 'Sfb3p', NULL, NULL, NULL, NULL, NULL, 4),
(100437, NULL, 'G3DSA:2.60.40.150:FF:000141', NULL, NULL, 'Coiled-coil and C2 domain-containing protein 2A', NULL, NULL, NULL, NULL, NULL, 4),
(100438, NULL, 'G3DSA:3.40.640.10:FF:000258', NULL, NULL, 'Cystathionine gamma-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(100439, NULL, 'G3DSA:1.25.40.10:FF:002042', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(100440, NULL, 'G3DSA:2.60.40.10:FF:000918', NULL, NULL, 'Heparan sulfate proteoglycan 2', NULL, NULL, NULL, NULL, NULL, 4),
(100441, NULL, 'G3DSA:2.60.120.740:FF:000001', NULL, NULL, 'Adhesion G protein-coupled receptor L2', NULL, NULL, NULL, NULL, NULL, 4),
(100442, NULL, 'G3DSA:1.25.40.90:FF:000115', NULL, NULL, 'Clathrin interactor 1', NULL, NULL, NULL, NULL, NULL, 4),
(100443, NULL, 'G3DSA:1.20.1110.10:FF:000033', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(100444, NULL, 'G3DSA:1.20.1310.10:FF:000115', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100445, NULL, 'G3DSA:1.20.1270.60:FF:000289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100446, NULL, 'G3DSA:3.30.160.20:FF:000030', NULL, NULL, 'NFKB repressing factor', NULL, NULL, NULL, NULL, NULL, 4),
(100447, NULL, 'G3DSA:3.40.630.150:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100448, NULL, 'G3DSA:1.20.1070.10:FF:000107', NULL, NULL, '5-hydroxytryptamine (Serotonin) receptor 1A', NULL, NULL, NULL, NULL, NULL, 4),
(100449, NULL, 'G3DSA:1.20.1070.10:FF:001698', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100450, NULL, 'G3DSA:2.130.10.10:FF:000885', NULL, NULL, 'BEACH-DOMAIN HOMOLOG A1', NULL, NULL, NULL, NULL, NULL, 4),
(100451, NULL, 'G3DSA:1.20.1080.10:FF:000035', NULL, NULL, 'AQuaPorin or aquaglyceroporin related', NULL, NULL, NULL, NULL, NULL, 4),
(100452, NULL, 'G3DSA:3.30.70.1660:FF:000002', NULL, NULL, 'Peptide chain release factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(100453, NULL, 'G3DSA:1.10.510.10:FF:001090', NULL, NULL, 'Serine threonine protein kinase putative', NULL, NULL, NULL, NULL, NULL, 4),
(100454, NULL, 'G3DSA:1.10.510.10:FF:001865', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100455, NULL, 'G3DSA:3.40.50.300:FF:000756', NULL, NULL, 'Rho-related GTP-binding protein RhoH', NULL, NULL, NULL, NULL, NULL, 4),
(100456, NULL, 'G3DSA:1.10.510.10:FF:004327', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100457, NULL, 'G3DSA:3.30.450.20:FF:000440', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100458, NULL, 'G3DSA:3.20.20.80:FF:000196', NULL, NULL, 'Class III chitinase ChiA2', NULL, NULL, NULL, NULL, NULL, 4),
(100459, NULL, 'G3DSA:3.40.50.2020:FF:000074', NULL, NULL, 'Ribose-phosphate pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(100460, NULL, 'G3DSA:3.90.950.10:FF:000001', NULL, NULL, 'dITP/XTP pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(100461, NULL, 'G3DSA:2.10.80.10:FF:000024', NULL, NULL, 'Prokineticin 1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(100462, NULL, 'G3DSA:3.30.70.1230:FF:000255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100463, NULL, 'G3DSA:3.30.160.60:FF:003217', NULL, NULL, 'Zinc finger protein unc-98', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(100464, NULL, 'G3DSA:1.20.1590.10:FF:000001', NULL, NULL, 'DUF416 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(100465, NULL, 'G3DSA:1.10.150.190:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100466, NULL, 'G3DSA:2.60.120.780:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100467, NULL, 'G3DSA:1.20.1070.10:FF:001035', NULL, NULL, 'Putative olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(100468, NULL, 'G3DSA:2.40.10.10:FF:000496', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100469, NULL, 'G3DSA:2.40.70.10:FF:000163', NULL, NULL, 'cDNA FLJ60006, highly similar to Pepsin A', NULL, NULL, NULL, NULL, NULL, 4),
(100470, NULL, 'G3DSA:3.30.70.120:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100471, NULL, 'G3DSA:2.60.40.150:FF:000039', NULL, NULL, 'Synaptotagmin 11', NULL, NULL, NULL, NULL, NULL, 4),
(100472, NULL, 'G3DSA:2.60.40.10:FF:005477', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100473, NULL, 'G3DSA:3.30.460.10:FF:000168', NULL, NULL, 'Protein CBG04590', NULL, NULL, NULL, NULL, NULL, 4),
(100474, NULL, 'G3DSA:1.10.1320.10:FF:000006', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(100475, NULL, 'G3DSA:3.90.79.10:FF:000088', NULL, NULL, 'Mitochondrial ribosomal protein L17', NULL, NULL, NULL, NULL, NULL, 4),
(100476, NULL, 'G3DSA:1.10.506.10:FF:000023', NULL, NULL, 'Neurofibromin isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(100477, NULL, 'G3DSA:2.60.40.10:FF:006096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100478, NULL, 'G3DSA:3.55.50.30:FF:000002', NULL, NULL, 'Probable TonB-dependent receptor', NULL, NULL, NULL, NULL, NULL, 4),
(100479, NULL, 'G3DSA:3.40.50.300:FF:001009', NULL, NULL, 'RING finger protein 112', NULL, NULL, NULL, NULL, NULL, 4),
(100480, NULL, 'G3DSA:2.70.150.10:FF:000105', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(100481, NULL, 'G3DSA:1.25.40.10:FF:002351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100482, NULL, 'G3DSA:2.60.120.200:FF:000322', NULL, NULL, 'Binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(100483, NULL, 'G3DSA:3.30.230.70:FF:000011', NULL, NULL, 'exosome complex component RRP43', NULL, NULL, NULL, NULL, NULL, 4),
(100484, NULL, 'G3DSA:1.20.140.10:FF:000047', NULL, NULL, 'Putative acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(100485, NULL, 'G3DSA:3.40.50.300:FF:005876', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(100486, NULL, 'G3DSA:1.20.5.350:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100487, NULL, 'G3DSA:2.60.40.770:FF:000017', NULL, NULL, 'Putative phosphatidylglycerol/phosphatidylinositol transfer protein DDB_G0282179', NULL, NULL, NULL, NULL, NULL, 4),
(100488, NULL, 'G3DSA:2.60.40.10:FF:005168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100489, NULL, 'G3DSA:3.40.50.300:FF:003061', NULL, NULL, 'Small GTP-binding protein domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(100490, NULL, 'G3DSA:2.130.10.10:FF:002728', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100491, NULL, 'G3DSA:2.40.10.10:FF:000608', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100492, NULL, 'G3DSA:3.30.360.10:FF:000048', NULL, NULL, 'GAL80p Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(100493, NULL, 'G3DSA:3.40.1440.10:FF:000006', NULL, NULL, 'Structure-specific endonuclease subunit SLX1', NULL, NULL, NULL, NULL, NULL, 4),
(100494, NULL, 'G3DSA:3.30.160.60:FF:002964', NULL, NULL, 'PEG3 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(100495, NULL, 'G3DSA:3.30.160.60:FF:003583', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100496, NULL, 'G3DSA:3.30.160.60:FF:000446', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(100497, NULL, 'G3DSA:3.40.50.10480:FF:000008', NULL, NULL, 'U3 small nuclear ribonucleoprotein (SnRNP),putative', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(100498, NULL, 'G3DSA:1.20.1070.10:FF:001743', NULL, NULL, 'Peropsin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100499, NULL, 'G3DSA:3.30.40.10:FF:001176', NULL, NULL, 'RING finger protein 121', NULL, NULL, NULL, NULL, NULL, 4),
(100500, NULL, 'G3DSA:1.20.140.100:FF:000025', NULL, NULL, 'Dynein beta chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100501, NULL, 'G3DSA:3.30.710.10:FF:000502', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100502, NULL, 'G3DSA:3.30.420.510:FF:000028', NULL, NULL, 'Pantothenate kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(100503, NULL, 'G3DSA:3.80.10.10:FF:002307', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100504, NULL, 'G3DSA:3.40.50.1000:FF:000234', NULL, NULL, 'Haloacid dehalogenase-like hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(100505, NULL, 'G3DSA:3.30.70.890:FF:000023', NULL, NULL, 'Phosphomevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(100506, NULL, 'G3DSA:2.30.40.10:FF:000077', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(100507, NULL, 'G3DSA:2.60.40.10:FF:000609', NULL, NULL, 'Tenascin R', NULL, NULL, NULL, NULL, NULL, 4),
(100508, NULL, 'G3DSA:2.30.30.40:FF:000355', NULL, NULL, 'Unplaced genomic scaffold supercont2.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(100509, NULL, 'G3DSA:3.10.20.90:FF:000811', NULL, NULL, 'Ubiquitin-like protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(100510, NULL, 'G3DSA:2.120.10.80:FF:000058', NULL, NULL, 'Kelch protein K13', NULL, NULL, NULL, NULL, NULL, 4),
(100511, NULL, 'G3DSA:1.10.530.10:FF:000028', NULL, NULL, 'Lytic murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(100512, NULL, 'G3DSA:3.40.33.10:FF:000097', NULL, NULL, 'Copper expressed protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(100513, NULL, 'G3DSA:1.10.10.10:FF:001062', NULL, NULL, 'Cullin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(100514, NULL, 'G3DSA:4.10.240.10:FF:000197', NULL, NULL, 'Putative transcription factor with C2H2 and Zn(2)-Cys(6) DNA binding domain (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(100515, NULL, 'G3DSA:3.40.50.10890:FF:000013', NULL, NULL, 'Subunit of mRNA cleavage and polyadenylation specificity factor', NULL, NULL, NULL, NULL, NULL, 4),
(100516, NULL, 'G3DSA:1.10.20.10:FF:000371', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100517, NULL, 'G3DSA:1.25.10.10:FF:001034', NULL, NULL, 'Related to BLM10-proteasome activator subunit', NULL, NULL, NULL, NULL, NULL, 4),
(100518, NULL, 'G3DSA:3.40.50.1000:FF:000448', NULL, NULL, 'AGL041Cp', NULL, NULL, NULL, NULL, NULL, 4),
(100519, NULL, 'G3DSA:1.10.3520.10:FF:000033', NULL, NULL, 'Ceramide-1-phosphate transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(100520, NULL, 'G3DSA:2.60.40.10:FF:002043', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(100521, NULL, 'G3DSA:2.10.25.10:FF:000200', NULL, NULL, 'netrin-4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(100522, NULL, 'G3DSA:3.20.20.140:FF:000178', NULL, NULL, 'WGS project CABT00000000 data, contig 2.98', NULL, NULL, NULL, NULL, NULL, 4),
(100523, NULL, 'G3DSA:3.40.50.620:FF:000402', NULL, NULL, '7-cyano-7-deazaguanine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(100524, NULL, 'G3DSA:3.30.70.330:FF:002233', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100525, NULL, 'G3DSA:3.20.20.70:FF:000659', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100526, NULL, 'G3DSA:3.30.70.330:FF:003059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100527, NULL, 'G3DSA:1.10.260.170:FF:000002', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', NULL, NULL, NULL, NULL, NULL, 4),
(100528, NULL, 'G3DSA:1.25.40.10:FF:004408', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100529, NULL, 'G3DSA:1.10.238.10:FF:000012', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(100530, NULL, 'G3DSA:3.30.70.330:FF:000333', NULL, NULL, 'Nucleolin', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(100531, NULL, 'G3DSA:2.60.40.10:FF:005729', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100532, NULL, 'G3DSA:3.40.50.10810:FF:000254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100533, NULL, 'G3DSA:3.30.160.60:FF:005117', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100534, NULL, 'G3DSA:2.60.40.10:FF:004504', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100535, NULL, 'G3DSA:4.10.400.10:FF:000199', NULL, NULL, 'Terribly reduced optic lobes, isoform AU', NULL, NULL, NULL, NULL, NULL, 4),
(100536, NULL, 'G3DSA:2.30.29.30:FF:000017', NULL, NULL, 'FACT complex subunit SPT16', NULL, NULL, NULL, NULL, NULL, 4),
(100537, NULL, 'G3DSA:2.60.120.10:FF:000538', NULL, NULL, 'cGMP-dependent protein kinase 7-1', NULL, NULL, NULL, NULL, NULL, 4),
(100538, NULL, 'G3DSA:1.10.510.10:FF:003708', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100539, NULL, 'G3DSA:3.40.50.11660:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100540, NULL, 'G3DSA:3.40.50.300:FF:007113', NULL, NULL, 'Rho-related protein racI', NULL, NULL, NULL, NULL, NULL, 4),
(100541, NULL, 'G3DSA:3.30.1490.40:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100542, NULL, 'G3DSA:2.40.160.110:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100543, NULL, 'G3DSA:1.10.238.10:FF:000321', NULL, NULL, 'Solute carrier family 25 member 12', NULL, NULL, NULL, NULL, NULL, 4),
(100544, NULL, 'G3DSA:3.30.500.10:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100545, NULL, 'G3DSA:2.40.50.140:FF:000083', NULL, NULL, 'Holliday junction ATP-dependent DNA helicase RuvA', NULL, NULL, NULL, NULL, NULL, 4),
(100546, NULL, 'G3DSA:3.40.50.620:FF:000711', NULL, NULL, 'Probable tRNA(Ile)-lysidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(100547, NULL, 'G3DSA:3.40.50.970:FF:000024', NULL, NULL, 'Pyruvate decarboxylase isozyme', NULL, NULL, NULL, NULL, NULL, 4),
(100548, NULL, 'G3DSA:2.130.10.10:FF:004628', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100549, NULL, 'G3DSA:2.130.10.10:FF:000666', NULL, NULL, 'WD repeat-containing protein 37 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(100550, NULL, 'G3DSA:3.90.1640.10:FF:000033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(100551, NULL, 'G3DSA:3.30.160.60:FF:002700', NULL, NULL, 'zinc finger protein 407', NULL, NULL, NULL, NULL, NULL, 4),
(100552, NULL, 'G3DSA:3.60.10.10:FF:000116', NULL, NULL, 'Endonuclease-exonuclease-phosphatase family', NULL, NULL, NULL, NULL, NULL, 4),
(100553, NULL, 'G3DSA:3.40.50.720:FF:001618', NULL, NULL, '(+)-neomenthol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(100554, NULL, 'G3DSA:1.10.472.10:FF:000016', NULL, NULL, 'cyclin-L1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(100555, NULL, 'G3DSA:3.40.50.1010:FF:000086', NULL, NULL, 'YKR096W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(100556, NULL, 'G3DSA:3.40.350.10:FF:000011', NULL, NULL, 'Aminopeptidase P family protein', NULL, NULL, NULL, NULL, NULL, 4),
(100557, NULL, 'G3DSA:3.40.50.300:FF:000380', NULL, NULL, 'Guanine nucleotide-binding protein G(Olf) subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(100558, NULL, 'G3DSA:1.10.10.60:FF:000655', NULL, NULL, 'Myb family DNA-binding domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(100559, NULL, 'G3DSA:3.40.47.10:FF:000140', NULL, NULL, 'Acetyl-CoA acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(100560, NULL, 'G3DSA:3.30.1060.10:FF:000002', NULL, NULL, 'Peptide methionine sulfoxide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(100561, NULL, 'G3DSA:3.30.300.130:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100562, NULL, 'G3DSA:2.10.109.10:FF:000001', NULL, NULL, 'LexA repressor', NULL, NULL, NULL, NULL, NULL, 4),
(100563, NULL, 'G3DSA:2.130.10.10:FF:005926', NULL, NULL, 'Apaf-1 related killer DARK', NULL, NULL, NULL, NULL, NULL, 4),
(100564, NULL, 'G3DSA:3.10.450.40:FF:000006', NULL, NULL, 'Putative baseplate wedge subunit', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(100565, NULL, 'G3DSA:1.20.1250.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100566, NULL, 'G3DSA:1.50.10.10:FF:000228', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(100567, NULL, 'G3DSA:2.60.40.10:FF:002150', NULL, NULL, 'Protein tyrosine kinase 7a', NULL, NULL, NULL, NULL, NULL, 4),
(100568, NULL, 'G3DSA:3.40.50.2300:FF:000383', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(100569, NULL, 'G3DSA:3.30.1490.190:FF:000001', NULL, NULL, 'Ferric uptake regulation protein', NULL, NULL, NULL, NULL, NULL, 4),
(100570, NULL, 'G3DSA:1.10.287.110:FF:000392', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100571, NULL, 'G3DSA:2.130.10.10:FF:001655', NULL, NULL, 'Vacuolar protein sorting-associated protein 11 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(100572, NULL, 'G3DSA:3.30.420.40:FF:000427', NULL, NULL, 'Chaperone protein HscA homolog', NULL, NULL, NULL, NULL, NULL, 4),
(100573, NULL, 'G3DSA:2.40.110.10:FF:000008', NULL, NULL, 'Glutaryl-CoA dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(100574, NULL, 'G3DSA:3.60.21.10:FF:000405', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(100575, NULL, 'G3DSA:1.10.510.10:FF:002635', NULL, NULL, 'Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(100576, NULL, 'G3DSA:1.10.730.10:FF:000229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100577, NULL, 'G3DSA:3.30.160.60:FF:005342', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100578, NULL, 'G3DSA:4.10.60.10:FF:000001', NULL, NULL, 'Gag polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(100579, NULL, 'G3DSA:2.40.30.70:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100580, NULL, 'G3DSA:1.20.1070.10:FF:001962', NULL, NULL, 'Retinal G protein coupled receptor', NULL, NULL, NULL, NULL, NULL, 4),
(100581, NULL, 'G3DSA:3.80.10.10:FF:004331', NULL, NULL, 'NLR family CARD domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(100582, NULL, 'G3DSA:2.40.50.40:FF:000013', NULL, NULL, 'Two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(100583, NULL, 'G3DSA:1.20.1260.80:FF:000002', NULL, NULL, 'Haptoglobin-hemoglobin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(100584, NULL, 'G3DSA:1.10.3500.10:FF:000043', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(100585, NULL, 'G3DSA:3.30.70.270:FF:000146', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100586, NULL, 'G3DSA:1.10.287.70:FF:000744', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(100587, NULL, 'G3DSA:3.40.50.2000:FF:000411', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(100588, NULL, 'G3DSA:1.25.40.20:FF:001410', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100589, NULL, 'G3DSA:2.20.25.30:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100590, NULL, 'G3DSA:2.10.25.10:FF:001408', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(100591, NULL, 'G3DSA:3.40.50.300:FF:004123', NULL, NULL, 'ATP-binding cassette protein subfamily C, member 8', NULL, NULL, NULL, NULL, NULL, 4),
(100592, NULL, 'G3DSA:3.30.160.40:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100593, NULL, 'G3DSA:1.10.287.950:FF:000042', NULL, NULL, 'rRNA (Adenosine-2''-O-)-methyltransferase,putative', NULL, NULL, NULL, NULL, NULL, 4),
(100594, NULL, 'G3DSA:3.30.160.60:FF:002594', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100595, NULL, 'G3DSA:3.80.10.10:FF:001734', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100596, NULL, 'G3DSA:1.25.40.10:FF:000934', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(100597, NULL, 'G3DSA:3.40.50.300:FF:004651', NULL, NULL, 'ATP-dependent rRNA helicase SPB4', NULL, NULL, NULL, NULL, NULL, 4),
(100598, NULL, 'G3DSA:2.110.10.10:FF:000037', NULL, NULL, 'Protein CBG05638', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(100599, NULL, 'G3DSA:1.20.120.850:FF:000038', NULL, NULL, 'YALI0E24431p', NULL, NULL, NULL, NULL, NULL, 4),
(100600, NULL, 'G3DSA:1.20.120.350:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100601, NULL, 'G3DSA:1.25.40.10:FF:001446', NULL, NULL, 'Tetratricopeptide repeat protein 30 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(100602, NULL, 'G3DSA:1.10.20.10:FF:000085', NULL, NULL, 'Histone H3.2', NULL, NULL, NULL, NULL, NULL, 4),
(100603, NULL, 'G3DSA:2.130.10.10:FF:004252', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(100604, NULL, 'G3DSA:1.10.287.130:FF:000015', NULL, NULL, 'Histidine kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(100605, NULL, 'G3DSA:1.20.59.20:FF:000002', NULL, NULL, 'tRNA(Ile)-lysidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(100606, NULL, 'G3DSA:3.30.70.2240:FF:000002', NULL, NULL, 'krev interaction trapped protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(100607, NULL, 'G3DSA:2.60.40.10:FF:001531', NULL, NULL, 'Fc fragment of IgA and IgM receptor', NULL, NULL, NULL, NULL, NULL, 4),
(100608, NULL, 'G3DSA:1.20.140.150:FF:000023', NULL, NULL, 'Epithelial membrane protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(100609, NULL, 'G3DSA:1.10.287.3440:FF:000003', NULL, NULL, 'Biosynthetic arginine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(100610, NULL, 'G3DSA:1.10.225.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100611, NULL, 'G3DSA:3.40.50.12650:FF:000007', NULL, NULL, 'DNA cross-link repair 1A protein, variant', NULL, NULL, NULL, NULL, NULL, 4),
(100612, NULL, 'G3DSA:3.30.160.20:FF:000013', NULL, NULL, 'double-stranded RNA-binding protein Staufen homolog 2 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(100613, NULL, 'G3DSA:4.10.280.10:FF:000183', NULL, NULL, 'Transcription factor protein', NULL, NULL, NULL, NULL, NULL, 4),
(100614, NULL, 'G3DSA:1.25.40.20:FF:000454', NULL, NULL, 'ankyrin repeat and KH domain-containing protein 1 isoform X7', NULL, NULL, NULL, NULL, NULL, 4),
(100615, NULL, 'G3DSA:1.25.40.10:FF:002065', NULL, NULL, 'Tetratricopeptide repeat protein 21B', NULL, NULL, NULL, NULL, NULL, 4),
(100616, NULL, 'G3DSA:1.20.1250.20:FF:001693', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100617, NULL, 'G3DSA:1.10.10.720:FF:000006', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(100618, NULL, 'G3DSA:2.60.40.10:FF:005269', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100619, NULL, 'G3DSA:3.30.420.40:FF:000270', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(100620, NULL, 'G3DSA:2.60.40.60:FF:000607', NULL, NULL, 'Si:dkey-1m11.5', NULL, NULL, NULL, NULL, NULL, 4),
(100621, NULL, 'G3DSA:3.30.160.60:FF:006337', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100622, NULL, 'G3DSA:3.90.199.10:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100623, NULL, 'G3DSA:3.90.226.10:FF:000200', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(100624, NULL, 'G3DSA:3.40.50.720:FF:000623', NULL, NULL, 'Ubiquitin activating enzyme (E1) subunit Aos1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100625, NULL, 'G3DSA:3.40.1110.10:FF:000049', NULL, NULL, 'Copper-exporting P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(100626, NULL, 'G3DSA:2.130.10.10:FF:004409', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100627, NULL, 'G3DSA:3.30.70.330:FF:002103', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100628, NULL, 'G3DSA:2.30.29.30:FF:001006', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(100629, NULL, 'G3DSA:3.10.350.10:FF:000046', NULL, NULL, 'Chitin elicitor-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(100630, NULL, 'G3DSA:2.170.130.10:FF:000018', NULL, NULL, 'TonB-dependent siderophore receptor', NULL, NULL, NULL, NULL, NULL, 4),
(100631, NULL, 'G3DSA:1.25.40.20:FF:001775', NULL, NULL, 'Poly [ADP-ribose] polymerase tankyrase', NULL, NULL, NULL, NULL, NULL, 4),
(100632, NULL, 'G3DSA:3.30.565.10:FF:000080', NULL, NULL, 'Molecular chaperone HtpG', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(100633, NULL, 'G3DSA:3.90.1150.10:FF:000158', NULL, NULL, 'Phosphoserine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(100634, NULL, 'G3DSA:3.40.190.10:FF:000403', NULL, NULL, 'Putative ABC transporter (Substrate binding protein)', NULL, NULL, NULL, NULL, NULL, 4),
(100635, NULL, 'G3DSA:6.10.20.180:FF:000001', NULL, NULL, 'Import receptor subunit tom20, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100636, NULL, 'G3DSA:2.40.170.20:FF:000032', NULL, NULL, 'SusC/RagA family TonB-linked outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(100637, NULL, 'G3DSA:3.30.9.90:FF:000003', NULL, NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(100638, NULL, 'G3DSA:2.120.10.30:FF:000184', NULL, NULL, 'Alanyl dipeptidyl peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(100639, NULL, 'G3DSA:3.30.1330.30:FF:000080', NULL, NULL, 'Putative rRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(100640, NULL, 'G3DSA:1.25.40.10:FF:004043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100641, NULL, 'G3DSA:3.30.519.10:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100642, NULL, 'G3DSA:1.25.40.20:FF:001882', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(100643, NULL, 'G3DSA:1.10.760.10:FF:000057', NULL, NULL, 'Nicotinate dehydrogenase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(100644, NULL, 'G3DSA:3.30.810.10:FF:000010', NULL, NULL, 'Phosphatidylinositol 5-phosphate 4-kinase, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(100645, NULL, 'G3DSA:3.30.160.60:FF:000710', NULL, NULL, 'Zinc finger protein 768', NULL, NULL, NULL, NULL, NULL, 4),
(100646, NULL, 'G3DSA:3.30.572.10:FF:000017', NULL, NULL, 'GM18183', NULL, NULL, NULL, NULL, NULL, 4),
(100647, NULL, 'G3DSA:3.30.559.30:FF:000043', NULL, NULL, 'Nonribosomal peptide synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100648, NULL, 'G3DSA:2.60.40.10:FF:003931', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100649, NULL, 'G3DSA:1.20.1280.50:FF:000096', NULL, NULL, 'F-box domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(100650, NULL, 'G3DSA:3.50.50.60:FF:000443', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(100651, NULL, 'G3DSA:3.30.40.10:FF:000215', NULL, NULL, 'E3 ubiquitin-protein ligase RNF25', NULL, NULL, NULL, NULL, NULL, 4),
(100652, NULL, 'G3DSA:1.25.40.10:FF:001070', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g11630, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(100653, NULL, 'G3DSA:1.10.150.20:FF:000250', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(100654, NULL, 'G3DSA:1.25.40.570:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100655, NULL, 'G3DSA:3.90.660.20:FF:000009', NULL, NULL, 'Amine oxidase, variant 2', NULL, NULL, NULL, NULL, NULL, 4),
(100656, NULL, 'G3DSA:2.60.120.650:FF:000210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100657, NULL, 'G3DSA:3.30.40.10:FF:001199', NULL, NULL, 'Ring finger domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(100658, NULL, 'G3DSA:3.30.160.60:FF:005718', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100659, NULL, 'G3DSA:1.10.287.1490:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100660, NULL, 'G3DSA:3.40.50.720:FF:001242', NULL, NULL, 'Oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100661, NULL, 'G3DSA:1.10.238.10:FF:000793', NULL, NULL, 'Solute carrier family 25 member 24,-like', NULL, NULL, NULL, NULL, NULL, 4),
(100662, NULL, 'G3DSA:3.40.50.1100:FF:000129', NULL, NULL, 'Cysteate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(100663, NULL, 'G3DSA:2.60.40.10:FF:002526', NULL, NULL, 'Immunolglobulin kappa light chain variable region L22', NULL, NULL, NULL, NULL, NULL, 4),
(100664, NULL, 'G3DSA:3.20.20.120:FF:000037', NULL, NULL, 'o-succinylbenzoate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(100665, NULL, 'G3DSA:1.25.40.10:FF:000148', NULL, NULL, 'Coatomer subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(100666, NULL, 'G3DSA:2.120.10.30:FF:000077', NULL, NULL, 'SMP-30/gluconolactonase/LRE family protein', NULL, NULL, NULL, NULL, NULL, 4),
(100667, NULL, 'G3DSA:2.130.10.10:FF:004145', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(100668, NULL, 'G3DSA:2.40.50.100:FF:000082', NULL, NULL, 'Exosome complex component Rrp4', NULL, NULL, NULL, NULL, NULL, 4),
(100669, NULL, 'G3DSA:3.90.1150.190:FF:000003', NULL, NULL, 'Scm polycomb group protein-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(100670, NULL, 'G3DSA:3.40.30.10:FF:000776', NULL, NULL, 'Polyglutamine-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(100671, NULL, 'G3DSA:3.30.420.10:FF:000199', NULL, NULL, 'Putative CCR4-associated factor 1 homolog 11', NULL, NULL, NULL, NULL, NULL, 4),
(100672, NULL, 'G3DSA:1.20.1250.20:FF:000748', NULL, NULL, 'Arabinose-proton symporter', NULL, NULL, NULL, NULL, NULL, 4),
(100673, NULL, 'G3DSA:3.40.605.10:FF:000115', NULL, NULL, '10-formyltetrahydrofolate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(100674, NULL, 'G3DSA:1.20.1270.60:FF:000183', NULL, NULL, 'Sorting nexin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100675, NULL, 'G3DSA:3.60.120.10:FF:000012', NULL, NULL, 'Menaquinone-specific isochorismate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(100676, NULL, 'G3DSA:1.10.10.10:FF:001629', NULL, NULL, 'Spleen focus forming virus (SFFV) proviral integration oncogene spi1 like', NULL, NULL, NULL, NULL, NULL, 4),
(100677, NULL, 'G3DSA:3.30.420.40:FF:000534', NULL, NULL, 'Actin, epsilon 1', NULL, NULL, NULL, NULL, NULL, 4),
(100678, NULL, 'G3DSA:3.40.718.10:FF:000023', NULL, NULL, 'Isocitrate dehydrogenase [NADP]', NULL, NULL, NULL, NULL, NULL, 4),
(100679, NULL, 'G3DSA:3.40.50.300:FF:002673', NULL, NULL, 'Multispecific organic anion transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100680, NULL, 'G3DSA:3.30.450.30:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100681, NULL, 'G3DSA:3.80.10.10:FF:004224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100682, NULL, 'G3DSA:3.30.160.60:FF:001975', NULL, NULL, 'zinc finger protein 181 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(100683, NULL, 'G3DSA:1.25.40.840:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100684, NULL, 'G3DSA:1.25.50.20:FF:000056', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(100685, NULL, 'G3DSA:2.10.25.10:FF:001397', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(100686, NULL, 'G3DSA:1.20.1560.10:FF:000729', NULL, NULL, 'ATP-binding cassette transporter, subfamily B, member 10, group ATM protein PpABCB10', NULL, NULL, NULL, NULL, NULL, 4),
(100687, NULL, 'G3DSA:2.60.40.10:FF:002835', NULL, NULL, 'Type II inositol-1,4,5-trisphosphate 5-phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100688, NULL, 'G3DSA:2.60.40.4310:FF:000004', NULL, NULL, 'Structural polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(100689, NULL, 'G3DSA:3.80.10.10:FF:000964', NULL, NULL, 'Nucleotide excision NEF4 component', NULL, NULL, NULL, NULL, NULL, 4),
(100690, NULL, 'G3DSA:3.40.50.10830:FF:000001', NULL, NULL, 'F420-dependent methylenetetrahydromethanopterin dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(100691, NULL, 'G3DSA:3.10.250.10:FF:000117', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100692, NULL, 'G3DSA:3.40.570.10:FF:000022', NULL, NULL, 'GM12732', NULL, NULL, NULL, NULL, NULL, 4),
(100693, NULL, 'G3DSA:3.40.50.11980:FF:000014', NULL, NULL, 'Cytochrome Oxidase Assembly subunits', NULL, NULL, NULL, NULL, NULL, 4),
(100694, NULL, 'G3DSA:3.30.360.10:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100695, NULL, 'G3DSA:3.30.200.20:FF:001473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100696, NULL, 'G3DSA:1.25.40.20:FF:001303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100697, NULL, 'G3DSA:1.20.58.60:FF:000489', NULL, NULL, 'Microtubule actin crosslinking factor 1a', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(100698, NULL, 'G3DSA:3.30.565.10:FF:000237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100699, NULL, 'G3DSA:2.60.220.50:FF:000030', NULL, NULL, 'Polycystin 1 like 3, transient receptor potential channel interacting', NULL, NULL, NULL, NULL, NULL, 4),
(100700, NULL, 'G3DSA:3.80.10.10:FF:001953', NULL, NULL, 'Protein STRUBBELIG-RECEPTOR FAMILY 1', NULL, NULL, NULL, NULL, NULL, 4),
(100701, NULL, 'G3DSA:3.40.950.10:FF:000012', NULL, NULL, 'Putative iron-dependent hydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(100702, NULL, 'G3DSA:1.20.1090.10:FF:000064', NULL, NULL, 'NADH-dependent butanol dehydrogenase a', NULL, NULL, NULL, NULL, NULL, 4),
(100703, NULL, 'G3DSA:3.90.190.10:FF:000010', NULL, NULL, 'tensin-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(100704, NULL, 'G3DSA:1.10.510.10:FF:003782', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100705, NULL, 'G3DSA:3.40.50.12470:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100706, NULL, 'G3DSA:1.20.144.10:FF:000140', NULL, NULL, 'Uncharacterized loc100135382', NULL, NULL, NULL, NULL, NULL, 4),
(100707, NULL, 'G3DSA:3.40.50.970:FF:000007', NULL, NULL, 'Acetolactate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(100708, NULL, 'G3DSA:1.10.238.10:FF:000804', NULL, NULL, 'Defective in cullin neddylation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(100709, NULL, 'G3DSA:2.60.40.10:FF:003015', NULL, NULL, 'Interferon (alpha, beta and omega) receptor 2, gene 1', NULL, NULL, NULL, NULL, NULL, 4),
(100710, NULL, 'G3DSA:1.25.40.10:FF:000457', NULL, NULL, 'Pentatricopeptide repeat domain-containing protein 3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(100711, NULL, 'G3DSA:3.15.20.10:FF:000002', NULL, NULL, 'Cholesteryl ester transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(100712, NULL, 'G3DSA:3.30.420.10:FF:000519', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100713, NULL, 'G3DSA:2.130.10.10:FF:002274', NULL, NULL, 'Translation initiation factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100714, NULL, 'G3DSA:3.40.50.300:FF:007984', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(100715, NULL, 'G3DSA:2.60.120.10:FF:000555', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100716, NULL, 'G3DSA:1.25.10.10:FF:000314', NULL, NULL, 'Exportin 6', NULL, NULL, NULL, NULL, NULL, 4),
(100717, NULL, 'G3DSA:1.20.58.1780:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100718, NULL, 'G3DSA:3.60.15.10:FF:000094', NULL, NULL, 'Probable metallo-hydrolase MT2357', NULL, NULL, NULL, NULL, NULL, 4),
(100719, NULL, 'G3DSA:2.130.10.10:FF:001874', NULL, NULL, 'Two-component system sensor histidine kinase/response', NULL, NULL, NULL, NULL, NULL, 4),
(100720, NULL, 'G3DSA:3.40.1370.10:FF:000006', NULL, NULL, '50S ribosomal protein L4', NULL, NULL, NULL, NULL, NULL, 4),
(100721, NULL, 'G3DSA:1.25.10.10:FF:001725', NULL, NULL, 'Sister chromatid cohesion protein', NULL, NULL, NULL, NULL, NULL, 4),
(100722, NULL, 'G3DSA:2.40.50.1020:FF:000005', NULL, NULL, 'Accessory gene regulator A', NULL, NULL, NULL, NULL, NULL, 4),
(100723, NULL, 'G3DSA:3.40.50.10810:FF:000147', NULL, NULL, 'RAD54 like', NULL, NULL, NULL, NULL, NULL, 4),
(100724, NULL, 'G3DSA:1.10.287.110:FF:000285', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(100725, NULL, 'G3DSA:1.20.5.190:FF:000032', NULL, NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(100726, NULL, 'G3DSA:3.30.1360.120:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100727, NULL, 'G3DSA:1.20.140.10:FF:000148', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(100728, NULL, 'G3DSA:3.40.30.10:FF:000091', NULL, NULL, 'Glutathione S-transferase L2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(100729, NULL, 'G3DSA:1.20.1070.10:FF:000181', NULL, NULL, 'Thyrotropin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(100730, NULL, 'G3DSA:3.40.50.2000:FF:000883', NULL, NULL, 'Glycogen synthase ADP-glucose transglucosylase GlgA', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(100731, NULL, 'G3DSA:2.60.40.640:FF:000080', NULL, NULL, 'Beta-arrestin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100732, NULL, 'G3DSA:3.30.1360.70:FF:000014', NULL, NULL, 'Arginyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100733, NULL, 'G3DSA:1.20.58.2220:FF:000066', NULL, NULL, 'Erythrocyte membrane-associated giant protein antigen 332 containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(100734, NULL, 'G3DSA:3.30.2350.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100735, NULL, 'G3DSA:2.30.29.30:FF:001225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100736, NULL, 'G3DSA:3.40.33.10:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100737, NULL, 'G3DSA:2.60.120.920:FF:000184', NULL, NULL, 'Tripartite motif-containing protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(100738, NULL, 'G3DSA:3.30.160.60:FF:001290', NULL, NULL, 'Zinc finger 45-like', NULL, NULL, NULL, NULL, NULL, 4),
(100739, NULL, 'G3DSA:4.10.400.10:FF:000316', NULL, NULL, 'glycoprotein 330-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(100740, NULL, 'G3DSA:2.60.40.2240:FF:000006', NULL, NULL, 'Acyl-CoA thioesterase 20', NULL, NULL, NULL, NULL, NULL, 4),
(100741, NULL, 'G3DSA:3.40.50.300:FF:002178', NULL, NULL, 'Similar to cation ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(100742, NULL, 'G3DSA:3.40.50.300:FF:001689', NULL, NULL, 'Ras-related protein Rab-11B', NULL, NULL, NULL, NULL, NULL, 4),
(100743, NULL, 'G3DSA:1.20.1250.20:FF:000872', NULL, NULL, 'Solute carrier family 16, member 9a', NULL, NULL, NULL, NULL, NULL, 4),
(100744, NULL, 'G3DSA:3.40.190.10:FF:000931', NULL, NULL, 'Dipeptide binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(100745, NULL, 'G3DSA:2.60.40.1170:FF:000085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100746, NULL, 'G3DSA:3.30.160.60:FF:001183', NULL, NULL, 'Zinc finger protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(100747, NULL, 'G3DSA:3.30.457.60:FF:000023', NULL, NULL, 'Mitotic arrest deficient 1 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(100748, NULL, 'G3DSA:2.130.10.30:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100749, NULL, 'G3DSA:3.90.79.10:FF:000296', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(100750, NULL, 'G3DSA:3.40.50.1000:FF:000549', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100751, NULL, 'G3DSA:3.30.200.20:FF:001366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100752, NULL, 'G3DSA:3.40.50.10800:FF:000003', NULL, NULL, 'Quinolinate synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(100753, NULL, 'G3DSA:2.130.10.10:FF:000093', NULL, NULL, 'DmX-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(100754, NULL, 'G3DSA:2.170.270.10:FF:000074', NULL, NULL, 'PR domain 14', NULL, NULL, NULL, NULL, NULL, 4),
(100755, NULL, 'G3DSA:1.10.150.50:FF:000163', NULL, NULL, 'Kinase suppressor of ras 1', NULL, NULL, NULL, NULL, NULL, 4),
(100756, NULL, 'G3DSA:3.30.420.10:FF:000536', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100757, NULL, 'G3DSA:1.20.120.1880:FF:000011', NULL, NULL, 'Nuclear pore complex protein NUP155', NULL, NULL, NULL, NULL, NULL, 4),
(100758, NULL, 'G3DSA:2.60.40.10:FF:000598', NULL, NULL, 'Fibronectin type 3 and ankyrin repeat domains protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(100759, NULL, 'G3DSA:3.30.505.10:FF:000076', NULL, NULL, 'Signal transducing adaptor family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(100760, NULL, 'G3DSA:3.40.50.740:FF:000056', NULL, NULL, 'Gll2176 protein', NULL, NULL, NULL, NULL, NULL, 4),
(100761, NULL, 'G3DSA:1.25.40.20:FF:001758', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(100762, NULL, 'G3DSA:3.40.50.300:FF:004578', NULL, NULL, 'Stage V sporulation protein K', NULL, NULL, NULL, NULL, NULL, 4),
(100763, NULL, 'G3DSA:1.25.10.10:FF:001242', NULL, NULL, 'Putative U-box domain-containing protein 47', NULL, NULL, NULL, NULL, NULL, 4),
(100764, NULL, 'G3DSA:3.30.450.20:FF:000569', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(100765, NULL, 'G3DSA:3.40.50.1980:FF:000123', NULL, NULL, 'Iron-siderophore ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(100766, NULL, 'G3DSA:2.60.40.150:FF:000725', NULL, NULL, 'Uncharacterized protein C11E3.02c', NULL, NULL, NULL, NULL, NULL, 4),
(100767, NULL, 'G3DSA:3.90.1420.10:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100768, NULL, 'G3DSA:1.10.510.10:FF:003124', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100769, NULL, 'G3DSA:3.90.1150.160:FF:000005', NULL, NULL, 'Glutamate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(100770, NULL, 'G3DSA:1.25.40.10:FF:002374', NULL, NULL, 'Os01g0754700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(100771, NULL, 'G3DSA:2.40.10.10:FF:000507', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100772, NULL, 'G3DSA:3.40.50.720:FF:000207', NULL, NULL, 'Glycerate dehydrogenase HPR, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(100773, NULL, 'G3DSA:3.40.1110.10:FF:000268', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100774, NULL, 'G3DSA:3.40.50.720:FF:001927', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100775, NULL, 'G3DSA:1.10.287.70:FF:000749', NULL, NULL, 'Calcium-gated potassium channel MthK', NULL, NULL, NULL, NULL, NULL, 4),
(100776, NULL, 'G3DSA:3.30.160.60:FF:005797', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100777, NULL, 'G3DSA:2.60.40.10:FF:001222', NULL, NULL, 'Sallimus, isoform P', NULL, NULL, NULL, NULL, NULL, 4),
(100778, NULL, 'G3DSA:1.10.10.10:FF:000325', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(100779, NULL, 'G3DSA:3.30.160.60:FF:001666', NULL, NULL, 'MDS1 and EVI1 complex locus', NULL, NULL, NULL, NULL, NULL, 4),
(100780, NULL, 'G3DSA:2.70.98.20:FF:000014', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(100781, NULL, 'G3DSA:3.90.76.10:FF:000036', NULL, NULL, 'Peptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(100782, NULL, 'G3DSA:1.20.1640.10:FF:000090', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(100783, NULL, 'G3DSA:4.10.1000.40:FF:000011', NULL, NULL, 'Nuclear polyadenylated RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100784, NULL, 'G3DSA:3.90.70.80:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100785, NULL, 'G3DSA:3.40.50.11210:FF:000014', NULL, NULL, 'Ral GTPase-activating protein subunit beta-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(100786, NULL, 'G3DSA:3.30.70.330:FF:001721', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100787, NULL, 'G3DSA:2.130.10.10:FF:002144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100788, NULL, 'G3DSA:3.10.110.10:FF:000091', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 N', NULL, NULL, NULL, NULL, NULL, 4),
(100789, NULL, 'G3DSA:3.10.20.90:FF:000603', NULL, NULL, 'Guanine nucleotide exchange factor Cdc24 homologue, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100790, NULL, 'G3DSA:3.30.1490.100:FF:000047', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(100791, NULL, 'G3DSA:3.40.30.10:FF:000883', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100792, NULL, 'G3DSA:1.10.286.10:FF:000005', NULL, NULL, 'GTP cyclohydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(100793, NULL, 'G3DSA:3.40.47.10:FF:000067', NULL, NULL, 'Hydroxyacyl-CoA dehydrogenase trifunctional multienzyme complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(100794, NULL, 'G3DSA:3.20.20.80:FF:000752', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100795, NULL, 'G3DSA:1.10.246.140:FF:000015', NULL, NULL, 'Transcription/mRNA export factor', NULL, NULL, NULL, NULL, NULL, 4),
(100796, NULL, 'G3DSA:2.130.10.10:FF:001402', NULL, NULL, 'Enhancer of mRNA-decapping protein', NULL, NULL, NULL, NULL, NULL, 4),
(100797, NULL, 'G3DSA:3.40.50.2020:FF:000097', NULL, NULL, 'phosphoribosyl pyrophosphate synthase-associated protein 2 isoform X4', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(100798, NULL, 'G3DSA:3.40.630.30:FF:000634', NULL, NULL, 'Ribosomal protein N-acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100799, NULL, 'G3DSA:3.40.640.10:FF:000365', NULL, NULL, 'Aminotransferase class I/II-fold pyridoxal phosphate-dependent enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(100800, NULL, 'G3DSA:3.30.530.20:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100801, NULL, 'G3DSA:1.20.58.760:FF:000034', NULL, NULL, 'paraplegin-like', NULL, NULL, NULL, NULL, NULL, 4),
(100802, NULL, 'G3DSA:1.10.510.10:FF:002854', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100803, NULL, 'G3DSA:2.30.30.380:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100804, NULL, 'G3DSA:3.30.2350.10:FF:000070', NULL, NULL, 'RNA pseudouridine synthase 2, chloroplastic isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(100805, NULL, 'G3DSA:1.25.10.10:FF:002237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100806, NULL, 'G3DSA:3.40.50.1100:FF:000124', NULL, NULL, '1-aminocyclopropane-1-carboxylate deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(100807, NULL, 'G3DSA:2.10.110.10:FF:000162', NULL, NULL, 'LD14485p', NULL, NULL, NULL, NULL, NULL, 4),
(100808, NULL, 'G3DSA:2.60.40.10:FF:001907', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(100809, NULL, 'G3DSA:1.10.10.10:FF:000820', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(100810, NULL, 'G3DSA:3.20.20.150:FF:000052', NULL, NULL, 'Xylose isomerase domain protein TIM barrel', NULL, NULL, NULL, NULL, NULL, 4),
(100811, NULL, 'G3DSA:1.20.58.60:FF:000236', NULL, NULL, 'microtubule-actin cross-linking factor 1 isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(100812, NULL, 'G3DSA:2.60.40.10:FF:004313', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100813, NULL, 'G3DSA:1.10.472.10:FF:000033', NULL, NULL, 'retinoblastoma-associated protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(100814, NULL, 'G3DSA:3.30.70.330:FF:000232', NULL, NULL, 'RNA-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(100815, NULL, 'G3DSA:3.90.1640.10:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100816, NULL, 'G3DSA:3.90.190.10:FF:000482', NULL, NULL, 'Putative phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(100817, NULL, 'G3DSA:3.30.450.380:FF:000001', NULL, NULL, 'Secretion protein', NULL, NULL, NULL, NULL, NULL, 4),
(100818, NULL, 'G3DSA:2.40.50.140:FF:000330', NULL, NULL, 'Protein OSB2 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(100819, NULL, 'G3DSA:3.60.20.10:FF:000061', NULL, NULL, 'Heat stress transcription factor A-6b', NULL, NULL, NULL, NULL, NULL, 4),
(100820, NULL, 'G3DSA:1.25.40.10:FF:003554', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100821, NULL, 'G3DSA:3.80.10.10:FF:003403', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(100822, NULL, 'G3DSA:3.30.420.10:FF:000194', NULL, NULL, 'Ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(100823, NULL, 'G3DSA:3.90.1800.10:FF:000012', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(100824, NULL, 'G3DSA:2.30.30.490:FF:000101', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(100825, NULL, 'G3DSA:1.25.40.180:FF:000008', NULL, NULL, 'Programmed cell death protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(100826, NULL, 'G3DSA:2.40.30.10:FF:000273', NULL, NULL, 'Putative cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(100827, NULL, 'G3DSA:3.30.1360.10:FF:000042', NULL, NULL, 'DNA-directed RNA polymerases I and III 16 kDa polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(100828, NULL, 'G3DSA:3.40.50.300:FF:006832', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(100829, NULL, 'G3DSA:1.10.630.10:FF:000401', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(100830, NULL, 'G3DSA:3.40.50.1820:FF:000014', NULL, NULL, 'lysosomal Pro-X carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(100831, NULL, 'G3DSA:1.20.1270.60:FF:000188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100832, NULL, 'G3DSA:3.30.420.40:FF:000843', NULL, NULL, 'Actin-related protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(100833, NULL, 'G3DSA:1.10.357.150:FF:000010', NULL, NULL, 'YALI0A07689p', NULL, NULL, NULL, NULL, NULL, 4),
(100834, NULL, 'G3DSA:1.25.10.10:FF:002546', NULL, NULL, 'Condensin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100835, NULL, 'G3DSA:1.20.1070.10:FF:001934', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100836, NULL, 'G3DSA:1.20.120.850:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100837, NULL, 'G3DSA:2.60.40.10:FF:000042', NULL, NULL, 'Filamin-B isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(100838, NULL, 'G3DSA:3.40.50.1240:FF:000177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100839, NULL, 'G3DSA:3.40.605.10:FF:000087', NULL, NULL, 'Os07g0689150 protein', NULL, NULL, NULL, NULL, NULL, 4),
(100840, NULL, 'G3DSA:1.10.287.70:FF:000188', NULL, NULL, 'SLOwpoke potassium channel family', NULL, NULL, NULL, NULL, NULL, 4),
(100841, NULL, 'G3DSA:3.90.70.80:FF:000061', NULL, NULL, 'AaceriABR233Wp', NULL, NULL, NULL, NULL, NULL, 4),
(100842, NULL, 'G3DSA:3.40.50.1360:FF:000067', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(100843, NULL, 'G3DSA:2.60.40.10:FF:000570', NULL, NULL, 'Lipolysis stimulated lipoprotein receptor', NULL, NULL, NULL, NULL, NULL, 4),
(100844, NULL, 'G3DSA:3.40.630.30:FF:000415', NULL, NULL, 'N-acetyltransferase, GNAT family', NULL, NULL, NULL, NULL, NULL, 4),
(100845, NULL, 'G3DSA:3.30.420.40:FF:000051', NULL, NULL, 'N-acetyl-D-glucosamine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(100846, NULL, 'G3DSA:2.10.90.10:FF:000070', NULL, NULL, 'CRE-UNC-129 protein', NULL, NULL, NULL, NULL, NULL, 4),
(100847, NULL, 'G3DSA:1.25.40.440:FF:000002', NULL, NULL, 'Nuclear pore complex protein NUP155', NULL, NULL, NULL, NULL, NULL, 4),
(100848, NULL, 'G3DSA:3.80.10.10:FF:002881', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100849, NULL, 'G3DSA:1.25.10.10:FF:002422', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100850, NULL, 'G3DSA:3.10.100.10:FF:000022', NULL, NULL, 'Mannose receptor C-type 1', NULL, NULL, NULL, NULL, NULL, 4),
(100851, NULL, 'G3DSA:4.10.1000.10:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100852, NULL, 'G3DSA:3.30.70.330:FF:002210', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100853, NULL, 'G3DSA:3.30.70.330:FF:000788', NULL, NULL, 'Rbp1-like, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(100854, NULL, 'G3DSA:1.50.40.10:FF:000409', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100855, NULL, 'G3DSA:1.10.10.60:FF:000683', NULL, NULL, 'Muscle wasted, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(100856, NULL, 'G3DSA:1.20.120.1750:FF:000107', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(100857, NULL, 'G3DSA:1.25.10.10:FF:002198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100858, NULL, 'G3DSA:2.160.20.80:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100859, NULL, 'G3DSA:3.60.21.10:FF:000035', NULL, NULL, 'Lariat debranching enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(100860, NULL, 'G3DSA:3.20.20.70:FF:000732', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100861, NULL, 'G3DSA:3.20.20.70:FF:000423', NULL, NULL, 'NADH:quinone reductase', NULL, NULL, NULL, NULL, NULL, 4),
(100862, NULL, 'G3DSA:3.80.10.10:FF:003370', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(100863, NULL, 'G3DSA:2.60.200.10:FF:000051', NULL, NULL, 'Interferon regulatory factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(100864, NULL, 'G3DSA:1.20.90.10:FF:000015', NULL, NULL, 'Phospholipase A(2)', NULL, NULL, NULL, NULL, NULL, 4),
(100865, NULL, 'G3DSA:1.10.510.10:FF:001674', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(100866, NULL, 'G3DSA:3.30.60.30:FF:000003', NULL, NULL, 'SPARC/osteonectin, cwcv and kazal-like domains proteoglycan 3', NULL, NULL, NULL, NULL, NULL, 4),
(100867, NULL, 'G3DSA:2.40.10.10:FF:000260', NULL, NULL, 'GM14069', NULL, NULL, NULL, NULL, NULL, 4),
(100868, NULL, 'G3DSA:3.40.850.10:FF:000050', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(100869, NULL, 'G3DSA:1.25.10.10:FF:001798', NULL, NULL, 'AGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(100870, NULL, 'G3DSA:3.80.10.10:FF:003712', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100871, NULL, 'G3DSA:2.30.30.60:FF:000001', NULL, NULL, 'MscS Mechanosensitive ion channel', NULL, NULL, NULL, NULL, NULL, 4),
(100872, NULL, 'G3DSA:3.30.420.150:FF:000016', NULL, NULL, 'Probable apyrase 7', NULL, NULL, NULL, NULL, NULL, 4),
(100873, NULL, 'G3DSA:3.40.50.300:FF:006040', NULL, NULL, 'Ras-related protein RABA1d', NULL, NULL, NULL, NULL, NULL, 4),
(100874, NULL, 'G3DSA:3.30.470.20:FF:000132', NULL, NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(100875, NULL, 'G3DSA:3.30.450.40:FF:000255', NULL, NULL, 'Sensor histidine kinase, GAF domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(100876, NULL, 'G3DSA:2.170.270.10:FF:000158', NULL, NULL, 'PR domain containing 15', NULL, NULL, NULL, NULL, NULL, 4),
(100877, NULL, 'G3DSA:1.20.1250.20:FF:000400', NULL, NULL, 'Blast:Monocarboxylate transporter 12', NULL, NULL, NULL, NULL, NULL, 4),
(100878, NULL, 'G3DSA:3.40.50.300:FF:002780', NULL, NULL, 'DEAD box ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(100879, NULL, 'G3DSA:3.40.50.150:FF:000227', NULL, NULL, 'tRNA (adenine(58)-N(1))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(100880, NULL, 'G3DSA:3.40.50.80:FF:000051', NULL, NULL, 'Ferredoxin--NADP reductase, apicoplast', NULL, NULL, NULL, NULL, NULL, 4),
(100881, NULL, 'G3DSA:2.30.42.10:FF:000222', NULL, NULL, 'Golgi re-assembly stacking protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(100882, NULL, 'G3DSA:1.10.150.240:FF:000077', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(100883, NULL, 'G3DSA:3.20.20.70:FF:000384', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(100884, NULL, 'G3DSA:2.70.170.10:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100885, NULL, 'G3DSA:2.60.120.10:FF:000078', NULL, NULL, 'Cyclic nucleotide-gated channel', NULL, NULL, NULL, NULL, NULL, 4),
(100886, NULL, 'G3DSA:3.30.310.280:FF:000002', NULL, NULL, 'Siderophore biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(100887, NULL, 'G3DSA:3.30.450.20:FF:000676', NULL, NULL, 'Nuclear receptor coactivator 3', NULL, NULL, NULL, NULL, NULL, 4),
(100888, NULL, 'G3DSA:2.60.40.10:FF:000603', NULL, NULL, 'Fibronectin type III domain containing 3B', NULL, NULL, NULL, NULL, NULL, 4),
(100889, NULL, 'G3DSA:3.40.710.10:FF:000101', NULL, NULL, 'Penicillin-binding protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(100890, NULL, 'G3DSA:3.60.21.10:FF:000400', NULL, NULL, 'Ser/Thr protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100891, NULL, 'G3DSA:1.20.1070.10:FF:000973', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100892, NULL, 'G3DSA:2.60.120.290:FF:000068', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(100893, NULL, 'G3DSA:3.40.50.2000:FF:000091', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(100894, NULL, 'G3DSA:3.30.160.20:FF:000249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100895, NULL, 'G3DSA:1.50.40.10:FF:000180', NULL, NULL, 'Mitochondrial carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100896, NULL, 'G3DSA:3.90.170.10:FF:000008', NULL, NULL, 'Adenylosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(100897, NULL, 'G3DSA:3.40.50.300:FF:004095', NULL, NULL, 'Dynein beta chain, flagellar outer arm', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(100898, NULL, 'G3DSA:2.60.40.10:FF:004095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100899, NULL, 'G3DSA:1.10.150.20:FF:000255', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(100900, NULL, 'G3DSA:2.60.120.260:FF:000525', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(100901, NULL, 'G3DSA:3.40.50.720:FF:001135', NULL, NULL, 'NADP-dependent alcohol dehydrogenase C', NULL, NULL, NULL, NULL, NULL, 4),
(100902, NULL, 'G3DSA:2.120.10.80:FF:000428', NULL, NULL, 'Serine/threonine-protein phosphatase BSL1', NULL, NULL, NULL, NULL, NULL, 4),
(100903, NULL, 'G3DSA:2.130.10.10:FF:000694', NULL, NULL, 'Apoptotic protease-activating factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(100904, NULL, 'G3DSA:2.60.40.10:FF:002942', NULL, NULL, 'Sensory AXon guidance', NULL, NULL, NULL, NULL, NULL, 4),
(100905, NULL, 'G3DSA:3.40.50.1450:FF:000015', NULL, NULL, 'Hydrogenase-specific maturation endopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(100906, NULL, 'G3DSA:3.40.50.10490:FF:000101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100907, NULL, 'G3DSA:3.80.10.10:FF:003842', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(100908, NULL, 'G3DSA:3.10.360.10:FF:000002', NULL, NULL, 'Beta-defensin 106A', NULL, NULL, NULL, NULL, NULL, 4),
(100909, NULL, 'G3DSA:3.40.50.670:FF:000024', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(100910, NULL, 'G3DSA:3.40.50.11610:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100911, NULL, 'G3DSA:3.10.100.10:FF:000331', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100912, NULL, 'G3DSA:3.40.718.10:FF:000006', NULL, NULL, '3-isopropylmalate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(100913, NULL, 'G3DSA:3.30.930.10:FF:000030', NULL, NULL, 'Aspartate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(100914, NULL, 'G3DSA:1.20.58.60:FF:000017', NULL, NULL, 'Spectrin alpha chain, non-erythrocytic 1', NULL, NULL, NULL, NULL, NULL, 4),
(100915, NULL, 'G3DSA:3.30.1360.210:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100916, NULL, 'G3DSA:1.10.3060.10:FF:000014', NULL, NULL, 'Protein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(100917, NULL, 'G3DSA:3.30.428.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100918, NULL, 'G3DSA:1.25.10.10:FF:002107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100919, NULL, 'G3DSA:1.25.40.10:FF:002935', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g61870, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(100920, NULL, 'G3DSA:1.10.287.1490:FF:000047', NULL, NULL, 'RAD50 homolog, double strand break repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(100921, NULL, 'G3DSA:2.10.25.10:FF:001144', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(100922, NULL, 'G3DSA:3.30.450.40:FF:000108', NULL, NULL, 'GAF domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(100923, NULL, 'G3DSA:1.20.58.480:FF:000017', NULL, NULL, 'Nematode resistance protein-like HSPRO2', NULL, NULL, NULL, NULL, NULL, 4),
(100924, NULL, 'G3DSA:2.40.160.120:FF:000018', NULL, NULL, 'Oxysterol-binding protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(100925, NULL, 'G3DSA:2.60.40.10:FF:000261', NULL, NULL, 'Sidekick cell adhesion molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(100926, NULL, 'G3DSA:2.170.240.10:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100927, NULL, 'G3DSA:1.25.10.10:FF:001618', NULL, NULL, 'CSE1 chromosome segregation 1-like (yeast)', NULL, NULL, NULL, NULL, NULL, 4),
(100928, NULL, 'G3DSA:1.10.472.10:FF:000472', NULL, NULL, 'Plant-specific TFIIB-related protein PTF2', NULL, NULL, NULL, NULL, NULL, 4),
(100929, NULL, 'G3DSA:3.40.50.150:FF:001638', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100930, NULL, 'G3DSA:2.40.10.10:FF:000687', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100931, NULL, 'G3DSA:2.40.30.10:FF:000143', NULL, NULL, 'Elongation factor Tu, putative', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(100932, NULL, 'G3DSA:3.40.33.10:FF:000018', NULL, NULL, 'SCP-like extracellular protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100933, NULL, 'G3DSA:3.30.70.330:FF:000760', NULL, NULL, '33 kDa ribonucleoprotein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(100934, NULL, 'G3DSA:2.160.20.10:FF:000160', NULL, NULL, 'Polygalacturonase', NULL, NULL, NULL, NULL, NULL, 4),
(100935, NULL, 'G3DSA:4.10.1000.10:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100936, NULL, 'G3DSA:3.90.650.10:FF:000034', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(100937, NULL, 'G3DSA:1.25.40.10:FF:000120', NULL, NULL, 'Tetratricopeptide repeat domain 8', NULL, NULL, NULL, NULL, NULL, 4),
(100938, NULL, 'G3DSA:2.30.140.10:FF:000029', NULL, NULL, 'Polyamine aminopropyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(100939, NULL, 'G3DSA:2.60.40.10:FF:000834', NULL, NULL, 'Proto-oncogene tyrosine-protein kinase MER', NULL, NULL, NULL, NULL, NULL, 4),
(100940, NULL, 'G3DSA:3.90.230.10:FF:000070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100941, NULL, 'G3DSA:3.30.40.10:FF:001159', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(100942, NULL, 'G3DSA:3.40.50.300:FF:006601', NULL, NULL, 'GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100943, NULL, 'G3DSA:1.10.150.20:FF:000272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100944, NULL, 'G3DSA:3.40.50.300:FF:003853', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(100945, NULL, 'G3DSA:3.40.1260.20:FF:000006', NULL, NULL, 'Ribonuclease E', NULL, NULL, NULL, NULL, NULL, 4),
(100946, NULL, 'G3DSA:1.25.40.10:FF:001098', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(100947, NULL, 'G3DSA:2.130.10.10:FF:004600', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100948, NULL, 'G3DSA:3.30.1300.10:FF:000010', NULL, NULL, 'Pantothenate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(100949, NULL, 'G3DSA:3.40.1260.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100950, NULL, 'G3DSA:3.40.50.300:FF:004887', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(100951, NULL, 'G3DSA:1.10.10.10:FF:000449', NULL, NULL, '30S ribosomal protein S19e', NULL, NULL, NULL, NULL, NULL, 4),
(100952, NULL, 'G3DSA:3.20.20.150:FF:000035', NULL, NULL, 'AP endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(100953, NULL, 'G3DSA:3.30.2410.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100954, NULL, 'G3DSA:1.20.58.60:FF:000461', NULL, NULL, 'Dystonin', NULL, NULL, NULL, NULL, NULL, 4),
(100955, NULL, 'G3DSA:2.60.40.1940:FF:000006', NULL, NULL, 'Thioester-containing protein 4, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(100956, NULL, 'G3DSA:3.40.50.2000:FF:000208', NULL, NULL, 'Alpha,alpha-trehalose-phosphate synthase subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100957, NULL, 'G3DSA:3.30.70.330:FF:002250', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100958, NULL, 'G3DSA:2.30.30.760:FF:000002', NULL, NULL, 'Flagella basal body P-ring formation protein FlgA', NULL, NULL, NULL, NULL, NULL, 4),
(100959, NULL, 'G3DSA:1.20.58.1390:FF:000002', NULL, NULL, 'O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(100960, NULL, 'G3DSA:1.10.472.10:FF:000691', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100961, NULL, 'G3DSA:1.25.40.10:FF:000592', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(100962, NULL, 'G3DSA:2.30.30.30:FF:000003', NULL, NULL, 'Elongation factor P', NULL, NULL, NULL, NULL, NULL, 4),
(100963, NULL, 'G3DSA:3.40.50.2300:FF:000725', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100964, NULL, 'G3DSA:3.30.160.60:FF:002936', NULL, NULL, 'Zinc finger and SCAN domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(100965, NULL, 'G3DSA:3.30.505.10:FF:000205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100966, NULL, 'G3DSA:2.40.70.10:FF:000247', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100967, NULL, 'G3DSA:2.10.70.10:FF:000068', NULL, NULL, 'Pappalysin 1', NULL, NULL, NULL, NULL, NULL, 4),
(100968, NULL, 'G3DSA:2.80.10.50:FF:000259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100969, NULL, 'G3DSA:4.10.60.10:FF:000092', NULL, NULL, 'Universal minicircle sequence binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(100970, NULL, 'G3DSA:3.80.10.10:FF:003527', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100971, NULL, 'G3DSA:2.30.29.30:FF:000152', NULL, NULL, 'ras-specific guanine nucleotide-releasing factor RalGPS1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(100972, NULL, 'G3DSA:1.10.510.10:FF:002293', NULL, NULL, 'Protein kinase, putative (AFU_orthologue AFUA_7G00740)', NULL, NULL, NULL, NULL, NULL, 4),
(100973, NULL, 'G3DSA:1.25.40.60:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(100974, NULL, 'G3DSA:1.10.30.10:FF:000017', NULL, NULL, 'high mobility group protein B3', NULL, NULL, NULL, NULL, NULL, 4),
(100975, NULL, 'G3DSA:4.10.1000.10:FF:000120', NULL, NULL, 'Zinc finger CCCH domain-containing protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(100976, NULL, 'G3DSA:3.40.630.10:FF:000084', NULL, NULL, 'Carboxypeptidase B2', NULL, NULL, NULL, NULL, NULL, 4),
(100977, NULL, 'G3DSA:1.20.1070.10:FF:001142', NULL, NULL, 'Beta-2 adrenergic receptor', NULL, NULL, NULL, NULL, NULL, 4),
(100978, NULL, 'G3DSA:1.25.40.10:FF:004279', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(100979, NULL, 'G3DSA:3.40.366.10:FF:000042', NULL, NULL, 'Fatty acid synthase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(100980, NULL, 'G3DSA:3.30.497.10:FF:000140', NULL, NULL, 'Angiotensinogen', NULL, NULL, NULL, NULL, NULL, 4),
(100981, NULL, 'G3DSA:2.40.50.100:FF:000003', NULL, NULL, 'Acetyl-CoA carboxylase biotin carboxyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(100982, NULL, 'G3DSA:3.90.550.10:FF:000009', NULL, NULL, 'Cellulose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(100983, NULL, 'G3DSA:1.10.510.10:FF:001781', NULL, NULL, 'Forkhead-associated domain-containing protein / FHA domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(100984, NULL, 'G3DSA:2.30.29.30:FF:000045', NULL, NULL, 'Ankyrin repeat and sterile alpha motif domain-containing protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(100985, NULL, 'G3DSA:3.40.50.1820:FF:001756', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(100986, NULL, 'G3DSA:3.10.20.30:FF:000029', NULL, NULL, 'Obg-like ATPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(100987, NULL, 'G3DSA:3.30.830.10:FF:000096', NULL, NULL, 'Zinc protease, insulinase family', NULL, NULL, NULL, NULL, NULL, 4),
(100988, NULL, 'G3DSA:1.10.10.10:FF:001545', NULL, NULL, 'CurA', NULL, NULL, NULL, NULL, NULL, 4),
(100989, NULL, 'G3DSA:3.30.870.10:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100990, NULL, 'G3DSA:1.10.220.150:FF:000022', NULL, NULL, 'ADP-ribosylation factor GTPase-activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100991, NULL, 'G3DSA:3.40.50.1820:FF:000031', NULL, NULL, 'Lipoprotein lipase', NULL, NULL, NULL, NULL, NULL, 4),
(100992, NULL, 'G3DSA:1.20.1070.10:FF:001827', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100993, NULL, 'G3DSA:2.70.170.10:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(100994, NULL, 'G3DSA:2.30.29.70:FF:000006', NULL, NULL, '26S proteasome regulatory subunit RPN13, putative', NULL, NULL, NULL, NULL, NULL, 4),
(100995, NULL, 'G3DSA:3.10.580.20:FF:000004', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(100996, NULL, 'G3DSA:2.60.120.10:FF:000533', NULL, NULL, 'Lysophospholipase NTE1', NULL, NULL, NULL, NULL, NULL, 4),
(100997, NULL, 'G3DSA:2.60.110.10:FF:000021', NULL, NULL, 'Receptor Serine/Threonine kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(100998, NULL, 'G3DSA:3.40.50.1100:FF:000146', NULL, NULL, 'Cysteine synthase/cystathionine beta-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(100999, NULL, 'G3DSA:1.20.210.10:FF:000036', NULL, NULL, 'Cytochrome c oxidase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(101000, NULL, 'G3DSA:3.40.30.10:FF:000961', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101001, NULL, 'G3DSA:1.20.58.670:FF:000007', NULL, NULL, 'Exocyst complex component SEC15', NULL, NULL, NULL, NULL, NULL, 4),
(101002, NULL, 'G3DSA:2.30.30.40:FF:000439', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101003, NULL, 'G3DSA:3.60.90.10:FF:000003', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(101004, NULL, 'G3DSA:1.10.579.10:FF:000011', NULL, NULL, 'Deoxyribodipyrimidine photolyase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(101005, NULL, 'G3DSA:1.25.10.10:FF:002653', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101006, NULL, 'G3DSA:1.10.287.110:FF:000245', NULL, NULL, 'DnaJ domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(101007, NULL, 'G3DSA:2.40.30.10:FF:000379', NULL, NULL, 'Elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(101008, NULL, 'G3DSA:2.60.40.10:FF:005724', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101009, NULL, 'G3DSA:3.30.1010.10:FF:000139', NULL, NULL, 'Phosphoinositide-3-kinase, catalytic, alpha polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(101010, NULL, 'G3DSA:3.60.21.50:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101011, NULL, 'G3DSA:3.90.550.10:FF:000341', NULL, NULL, '4930431L04Rik protein', NULL, NULL, NULL, NULL, NULL, 4),
(101012, NULL, 'G3DSA:3.40.50.1000:FF:000318', NULL, NULL, '5''-deoxynucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(101013, NULL, 'G3DSA:1.20.5.110:FF:000188', NULL, NULL, 'Syntaxin, epimorphin family', NULL, NULL, NULL, NULL, NULL, 4),
(101014, NULL, 'G3DSA:2.60.120.560:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101015, NULL, 'G3DSA:3.30.160.60:FF:004381', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101016, NULL, 'G3DSA:3.40.50.720:FF:002315', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101017, NULL, 'G3DSA:2.60.40.2610:FF:000005', NULL, NULL, 'Outer membrane usher protein PefC', NULL, NULL, NULL, NULL, NULL, 4),
(101018, NULL, 'G3DSA:3.40.228.10:FF:000031', NULL, NULL, 'Gll2176 protein', NULL, NULL, NULL, NULL, NULL, 4),
(101019, NULL, 'G3DSA:3.30.160.60:FF:000362', NULL, NULL, 'Zinc finger protein 606', NULL, NULL, NULL, NULL, NULL, 4),
(101020, NULL, 'G3DSA:3.80.10.10:FF:000880', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(101021, NULL, 'G3DSA:2.10.25.10:FF:000447', NULL, NULL, 'EGF-like repeat and discoidin I-like domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(101022, NULL, 'G3DSA:3.40.50.150:FF:000913', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101023, NULL, 'G3DSA:3.30.460.10:FF:000084', NULL, NULL, 'GTP pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(101024, NULL, 'G3DSA:2.60.40.10:FF:004420', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101025, NULL, 'G3DSA:1.20.1050.10:FF:000090', NULL, NULL, 'Maleylacetoacetate isomerase/glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(101026, NULL, 'G3DSA:3.80.10.10:FF:003151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101027, NULL, 'G3DSA:3.30.420.40:FF:000612', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(101028, NULL, 'G3DSA:1.20.120.420:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101029, NULL, 'G3DSA:1.10.3720.10:FF:000222', NULL, NULL, 'Sugar ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(101030, NULL, 'G3DSA:3.40.50.300:FF:006124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(101031, NULL, 'G3DSA:1.50.10.20:FF:000102', NULL, NULL, 'Protein farnesyltransferase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(101032, NULL, 'G3DSA:1.25.10.10:FF:000764', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(101033, NULL, 'G3DSA:1.20.1250.20:FF:001018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101034, NULL, 'G3DSA:1.20.140.10:FF:000064', NULL, NULL, 'Dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(101035, NULL, 'G3DSA:3.40.50.720:FF:000281', NULL, NULL, 'Uncharacterized oxidoreductase YIR035C', NULL, NULL, NULL, NULL, NULL, 4),
(101036, NULL, 'G3DSA:3.30.470.20:FF:000115', NULL, NULL, 'LD38689p', NULL, NULL, NULL, NULL, NULL, 4),
(101037, NULL, 'G3DSA:1.20.5.340:FF:000038', NULL, NULL, 'Myosin heavy chain muscle', NULL, NULL, NULL, NULL, NULL, 4),
(101038, NULL, 'G3DSA:2.30.29.30:FF:000837', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101039, NULL, 'G3DSA:3.40.50.1580:FF:000003', NULL, NULL, 'Uridine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(101040, NULL, 'G3DSA:2.60.40.150:FF:000742', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101041, NULL, 'G3DSA:2.10.220.10:FF:000063', NULL, NULL, 'Furin 2, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(101042, NULL, 'G3DSA:2.30.42.10:FF:000328', NULL, NULL, 'FERM domain (Protein4.1-ezrin-radixin-moesin) family', NULL, NULL, NULL, NULL, NULL, 4),
(101043, NULL, 'G3DSA:3.40.50.720:FF:002568', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101044, NULL, 'G3DSA:1.20.58.60:FF:000837', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101045, NULL, 'G3DSA:3.90.550.10:FF:000650', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101046, NULL, 'G3DSA:3.40.50.150:FF:001155', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101047, NULL, 'G3DSA:2.130.10.10:FF:002127', NULL, NULL, 'Transducin beta protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(101048, NULL, 'G3DSA:1.20.1250.10:FF:000088', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101049, NULL, 'G3DSA:2.160.20.10:FF:000244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101050, NULL, 'G3DSA:3.30.530.20:FF:000047', NULL, NULL, 'Hsp90 co-chaperone AHA1', NULL, NULL, NULL, NULL, NULL, 4),
(101051, NULL, 'G3DSA:1.10.1450.10:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101052, NULL, 'G3DSA:2.10.70.10:FF:000299', NULL, NULL, 'Limulus clotting factor C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(101053, NULL, 'G3DSA:3.40.50.300:FF:002526', NULL, NULL, 'Protein CLP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(101054, NULL, 'G3DSA:3.20.20.70:FF:000529', NULL, NULL, 'Radical S-adenosyl methionine domain-containing protein 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(101055, NULL, 'G3DSA:1.25.10.10:FF:001017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101056, NULL, 'G3DSA:3.80.10.10:FF:002678', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase EFR', NULL, NULL, NULL, NULL, NULL, 4),
(101057, NULL, 'G3DSA:3.60.15.10:FF:000015', NULL, NULL, 'probable hydrolase PNKD isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(101058, NULL, 'G3DSA:1.10.601.10:FF:000008', NULL, NULL, 'RNA polymerase sigma factor sigE, chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(101059, NULL, 'G3DSA:1.50.40.10:FF:000073', NULL, NULL, 'folate transporter 1, chloroplastic isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(101060, NULL, 'G3DSA:2.30.40.10:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101061, NULL, 'G3DSA:1.10.510.10:FF:003815', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101062, NULL, 'G3DSA:1.20.1250.20:FF:001237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101063, NULL, 'G3DSA:3.10.450.70:FF:000004', NULL, NULL, 'Thiol:disulfide interchange protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(101064, NULL, 'G3DSA:1.20.1510.10:FF:000018', NULL, NULL, 'transmembrane protein 163', NULL, NULL, NULL, NULL, NULL, 4),
(101065, NULL, 'G3DSA:3.30.70.330:FF:000316', NULL, NULL, 'RNA-binding family protein isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(101066, NULL, 'G3DSA:3.30.890.10:FF:000003', NULL, NULL, 'methyl-CpG-binding domain protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(101067, NULL, 'G3DSA:2.130.10.10:FF:002835', NULL, NULL, 'Angio-associated migratory cell protein', NULL, NULL, NULL, NULL, NULL, 4),
(101068, NULL, 'G3DSA:1.10.10.10:FF:000218', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC3', NULL, NULL, NULL, NULL, NULL, 4),
(101069, NULL, 'G3DSA:3.30.60.30:FF:000239', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101070, NULL, 'G3DSA:3.50.50.60:FF:001404', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101071, NULL, 'G3DSA:2.10.25.10:FF:001161', NULL, NULL, 'Netrin-G2', NULL, NULL, NULL, NULL, NULL, 4),
(101072, NULL, 'G3DSA:2.120.10.80:FF:000283', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101073, NULL, 'G3DSA:2.40.50.90:FF:000106', NULL, NULL, 'Transcription factor (Snd1/p100), putative', NULL, NULL, NULL, NULL, NULL, 4),
(101074, NULL, 'G3DSA:1.10.150.60:FF:000020', NULL, NULL, 'Ecm5p', NULL, NULL, NULL, NULL, NULL, 4),
(101075, NULL, 'G3DSA:2.10.70.10:FF:000175', NULL, NULL, 'Mannan-binding lectin associated serine protease 2', NULL, NULL, NULL, NULL, NULL, 4),
(101076, NULL, 'G3DSA:2.40.10.10:FF:000491', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101077, NULL, 'G3DSA:3.40.30.10:FF:000652', NULL, NULL, '2-hydroxychromene-2-carboxylate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(101078, NULL, 'G3DSA:2.30.42.10:FF:000019', NULL, NULL, 'LIM domain binding 3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(101079, NULL, 'G3DSA:3.30.479.10:FF:000014', NULL, NULL, 'Queuosine biosynthesis QueD, PTPS-I / Folate biosynthesis protein PTPS-III', NULL, NULL, NULL, NULL, NULL, 4),
(101080, NULL, 'G3DSA:3.40.50.300:FF:007905', NULL, NULL, 'Probable ATP-dependent RNA helicase spindle-E', NULL, NULL, NULL, NULL, NULL, 4),
(101081, NULL, 'G3DSA:1.10.1740.150:FF:000002', NULL, NULL, 'Endoribonuclease Dicer-like', NULL, NULL, NULL, NULL, NULL, 4),
(101082, NULL, 'G3DSA:2.130.10.10:FF:004853', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101083, NULL, 'G3DSA:3.90.70.10:FF:000804', NULL, NULL, 'BMA-CPL-6, isoform c', NULL, NULL, NULL, NULL, NULL, 4),
(101084, NULL, 'G3DSA:1.20.1070.10:FF:000523', NULL, NULL, '5-hydroxytryptamine receptor 2B', NULL, NULL, NULL, NULL, NULL, 4),
(101085, NULL, 'G3DSA:1.25.40.10:FF:002481', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At1g77010, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(101086, NULL, 'G3DSA:2.40.30.10:FF:000126', NULL, NULL, 'Mitochondrial translation initiation factor', NULL, NULL, NULL, NULL, NULL, 4),
(101087, NULL, 'G3DSA:3.30.920.10:FF:000001', NULL, NULL, 'Iron-sulfur cluster assembly protein CyaY', NULL, NULL, NULL, NULL, NULL, 4),
(101088, NULL, 'G3DSA:1.20.5.340:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101089, NULL, 'G3DSA:2.40.10.120:FF:000012', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(101090, NULL, 'G3DSA:1.20.1740.10:FF:000266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101091, NULL, 'G3DSA:3.40.50.2000:FF:000517', NULL, NULL, 'UDP-N-acetylglucosamine transferase subunit ALG13', NULL, NULL, NULL, NULL, NULL, 4),
(101092, NULL, 'G3DSA:1.10.10.60:FF:000790', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101093, NULL, 'G3DSA:3.40.50.300:FF:007220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101094, NULL, 'G3DSA:3.40.50.720:FF:001803', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101095, NULL, 'G3DSA:1.10.10.10:FF:000926', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(101096, NULL, 'G3DSA:2.80.10.50:FF:000028', NULL, NULL, 'Inositol 1,4,5-trisphosphate receptor type 3', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(101097, NULL, 'G3DSA:3.20.20.60:FF:000055', NULL, NULL, '2,4-dihydroxyhept-2-ene-1,7-dioic acid aldolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(101098, NULL, 'G3DSA:3.40.50.300:FF:002217', NULL, NULL, 'ATP-binding cassette sub-family G member 1', NULL, NULL, NULL, NULL, NULL, 4),
(101099, NULL, 'G3DSA:3.40.190.10:FF:000959', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101100, NULL, 'G3DSA:1.10.530.50:FF:000001', NULL, NULL, 'Membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(101101, NULL, 'G3DSA:3.30.40.10:FF:000434', NULL, NULL, 'von Willebrand and RING finger domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(101102, NULL, 'G3DSA:1.10.1420.10:FF:000177', NULL, NULL, 'Chromosome 23, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(101103, NULL, 'G3DSA:3.80.10.10:FF:002223', NULL, NULL, 'Leucine-rich repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(101104, NULL, 'G3DSA:3.40.50.2300:FF:001344', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101105, NULL, 'G3DSA:1.10.510.10:FF:001073', NULL, NULL, 'Long-flagella protein kinase, CMGC RCK', NULL, NULL, NULL, NULL, NULL, 4),
(101106, NULL, 'G3DSA:3.50.50.60:FF:001393', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101107, NULL, 'G3DSA:3.40.190.10:FF:000583', NULL, NULL, 'ABC transporter, substrate-binding protein, family 5', NULL, NULL, NULL, NULL, NULL, 4),
(101108, NULL, 'G3DSA:2.130.10.10:FF:005106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101109, NULL, 'G3DSA:1.10.10.60:FF:000082', NULL, NULL, 'Putative zinc finger homeobox protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(101110, NULL, 'G3DSA:3.40.1400.10:FF:000004', NULL, NULL, 'Ribose 5-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(101111, NULL, 'G3DSA:1.10.10.60:FF:000239', NULL, NULL, 'Highly divergent homeobox', NULL, NULL, NULL, NULL, NULL, 4),
(101112, NULL, 'G3DSA:3.40.50.300:FF:005399', NULL, NULL, 'ATP-binding cassette transporter, subfamily G, member 26, group PDR protein PpABCG26', NULL, NULL, NULL, NULL, NULL, 4),
(101113, NULL, 'G3DSA:2.130.10.10:FF:002583', NULL, NULL, 'DNA damage-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(101114, NULL, 'G3DSA:3.30.450.40:FF:000215', NULL, NULL, 'PleD gene product', NULL, NULL, NULL, NULL, NULL, 4),
(101115, NULL, 'G3DSA:3.30.200.20:FF:002310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101116, NULL, 'G3DSA:3.50.50.60:FF:001371', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(101117, NULL, 'G3DSA:2.60.40.10:FF:002711', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(101118, NULL, 'G3DSA:3.60.10.10:FF:000010', NULL, NULL, 'protein angel homolog 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(101119, NULL, 'G3DSA:1.10.510.10:FF:003107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101120, NULL, 'G3DSA:3.40.140.10:FF:000181', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit F', NULL, NULL, NULL, NULL, NULL, 4),
(101121, NULL, 'G3DSA:3.30.70.330:FF:000102', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(101122, NULL, 'G3DSA:2.20.25.530:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101123, NULL, 'G3DSA:2.60.40.60:FF:000787', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101124, NULL, 'G3DSA:3.40.50.10810:FF:000023', NULL, NULL, 'helicase-like transcription factor isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(101125, NULL, 'G3DSA:2.10.25.10:FF:001375', NULL, NULL, 'Vitamin K-dependent protein S', NULL, NULL, NULL, NULL, NULL, 4),
(101126, NULL, 'G3DSA:3.30.70.20:FF:000063', NULL, NULL, 'Iron-sulfur cluster-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(101127, NULL, 'G3DSA:1.20.120.1240:FF:000050', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101128, NULL, 'G3DSA:3.30.9.10:FF:000053', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(101129, NULL, 'G3DSA:1.20.58.60:FF:000152', NULL, NULL, 'Spectrin, beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(101130, NULL, 'G3DSA:3.90.1030.10:FF:000020', NULL, NULL, '50S ribosomal protein L17', NULL, NULL, NULL, NULL, NULL, 4),
(101131, NULL, 'G3DSA:3.30.200.20:FF:001849', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(101132, NULL, 'G3DSA:4.10.400.10:FF:000277', NULL, NULL, 'Transmembrane cell adhesion receptor mua-3', NULL, NULL, NULL, NULL, NULL, 4),
(101133, NULL, 'G3DSA:3.40.50.300:FF:004781', NULL, NULL, 'Bromodomain protein', NULL, NULL, NULL, NULL, NULL, 4),
(101134, NULL, 'G3DSA:3.40.50.150:FF:000205', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(101135, NULL, 'G3DSA:3.80.10.10:FF:001262', NULL, NULL, 'Leucine-rich repeat protein SHOC-2', NULL, NULL, NULL, NULL, NULL, 4),
(101136, NULL, 'G3DSA:3.80.10.10:FF:000514', NULL, NULL, 'Si:dkey-159n16.2', NULL, NULL, NULL, NULL, NULL, 4),
(101137, NULL, 'G3DSA:3.90.79.10:FF:000060', NULL, NULL, 'Nudix hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(101138, NULL, 'G3DSA:2.170.130.20:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101139, NULL, 'G3DSA:2.10.25.10:FF:001717', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101140, NULL, 'G3DSA:2.130.10.10:FF:000435', NULL, NULL, 'SEC12-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(101141, NULL, 'G3DSA:3.40.50.1220:FF:000036', NULL, NULL, 'NAD-dependent protein deacetylase HST2', NULL, NULL, NULL, NULL, NULL, 4),
(101142, NULL, 'G3DSA:3.30.750.44:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101143, NULL, 'G3DSA:2.170.150.10:FF:000020', NULL, NULL, 'Translationally-controlled tumor protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(101144, NULL, 'G3DSA:1.25.40.20:FF:000471', NULL, NULL, 'GM20065', NULL, NULL, NULL, NULL, NULL, 4),
(101145, NULL, 'G3DSA:3.90.740.10:FF:000024', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(101146, NULL, 'G3DSA:3.20.20.100:FF:000189', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101147, NULL, 'G3DSA:2.30.230.10:FF:000003', NULL, NULL, 'Apolipoprotein B', NULL, NULL, NULL, NULL, NULL, 4),
(101148, NULL, 'G3DSA:3.30.565.10:FF:000344', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(101149, NULL, 'G3DSA:3.30.50.10:FF:000171', NULL, NULL, 'Estrogen receptor', NULL, NULL, NULL, NULL, NULL, 4),
(101150, NULL, 'G3DSA:1.25.40.10:FF:004987', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g36980, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(101151, NULL, 'G3DSA:1.10.472.80:FF:000251', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101152, NULL, 'G3DSA:3.40.50.720:FF:000062', NULL, NULL, 'Homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(101153, NULL, 'G3DSA:1.20.1310.10:FF:000037', NULL, NULL, 'Related to cullin 4A', NULL, NULL, NULL, NULL, NULL, 4),
(101154, NULL, 'G3DSA:2.60.40.10:FF:000126', NULL, NULL, 'filamin-C isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(101155, NULL, 'G3DSA:3.40.50.1820:FF:000828', NULL, NULL, 'Alpha/Beta hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(101156, NULL, 'G3DSA:1.10.1740.110:FF:000001', NULL, NULL, 'Homoserine O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(101157, NULL, 'G3DSA:3.80.10.10:FF:000986', NULL, NULL, 'Dia2p', NULL, NULL, NULL, NULL, NULL, 4),
(101158, NULL, 'G3DSA:1.10.238.10:FF:000349', NULL, NULL, 'Actin cytoskeleton-regulatory complex protein PAN1', NULL, NULL, NULL, NULL, NULL, 4),
(101159, NULL, 'G3DSA:3.30.1330.30:FF:000063', NULL, NULL, 'RNA methyltransferase, TrmH family, group 3', NULL, NULL, NULL, NULL, NULL, 4),
(101160, NULL, 'G3DSA:2.60.40.2030:FF:000056', NULL, NULL, 'Fras1-like extracellular matrix protein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(101161, NULL, 'G3DSA:3.40.30.10:FF:001248', NULL, NULL, 'Hydrogenosomal NADH dehydrogenase 24 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(101162, NULL, 'G3DSA:3.40.50.300:FF:003959', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(101163, NULL, 'G3DSA:3.90.550.10:FF:000318', NULL, NULL, 'Glycosyltransferase family 2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(101164, NULL, 'G3DSA:1.25.40.10:FF:001862', NULL, NULL, 'Tetratricopeptide repeat domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(101165, NULL, 'G3DSA:2.60.40.640:FF:000001', NULL, NULL, 'Vacuolar protein sorting-associated protein 26A', NULL, NULL, NULL, NULL, NULL, 4),
(101166, NULL, 'G3DSA:3.30.1490.30:FF:000001', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(101167, NULL, 'G3DSA:3.40.50.1000:FF:000009', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(101168, NULL, 'G3DSA:3.30.1380.20:FF:000006', NULL, NULL, 'Trafficking protein particle complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(101169, NULL, 'G3DSA:3.40.190.80:FF:000036', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(101170, NULL, 'G3DSA:3.60.130.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101171, NULL, 'G3DSA:3.40.50.1820:FF:000486', NULL, NULL, 'ABHydrolase Domain containing homolog', NULL, NULL, NULL, NULL, NULL, 4),
(101172, NULL, 'G3DSA:3.10.129.10:FF:000234', NULL, NULL, 'Thioesterase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(101173, NULL, 'G3DSA:2.60.40.60:FF:000135', NULL, NULL, 'cadherin-23 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(101174, NULL, 'G3DSA:3.30.710.10:FF:000154', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(101175, NULL, 'G3DSA:1.25.40.10:FF:000226', NULL, NULL, 'Tetratricopeptide repeat protein 30A', NULL, NULL, NULL, NULL, NULL, 4),
(101176, NULL, 'G3DSA:3.90.770.10:FF:000009', NULL, NULL, '3-hydroxy-3-methylglutaryl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(101177, NULL, 'G3DSA:1.20.144.10:FF:000033', NULL, NULL, 'Dolichylpyrophosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(101178, NULL, 'G3DSA:3.30.1490.80:FF:000010', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(101179, NULL, 'G3DSA:1.20.1250.20:FF:000080', NULL, NULL, 'Muropeptide transporter AmpG', NULL, NULL, NULL, NULL, NULL, 4),
(101180, NULL, 'G3DSA:3.40.47.10:FF:000270', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101181, NULL, 'G3DSA:3.30.70.3030:FF:000020', NULL, NULL, 'U3 small nucleolar RNA-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(101182, NULL, 'G3DSA:3.30.200.20:FF:000854', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101183, NULL, 'G3DSA:3.10.196.10:FF:000013', NULL, NULL, 'Methionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(101184, NULL, 'G3DSA:3.40.50.300:FF:002869', NULL, NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily A containing DEAD/H box 1', NULL, NULL, NULL, NULL, NULL, 4),
(101185, NULL, 'G3DSA:3.40.50.300:FF:008524', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101186, NULL, 'G3DSA:3.30.559.30:FF:000026', NULL, NULL, 'Acyltransferase, WS/DGAT/MGAT', NULL, NULL, NULL, NULL, NULL, 4),
(101187, NULL, 'G3DSA:3.30.160.60:FF:004072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101188, NULL, 'G3DSA:3.30.70.330:FF:001266', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(101189, NULL, 'G3DSA:1.20.1310.10:FF:000222', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101190, NULL, 'G3DSA:3.90.1180.10:FF:000019', NULL, NULL, 'Leukotriene A(4) hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(101191, NULL, 'G3DSA:3.40.605.10:FF:000008', NULL, NULL, 'Aldehyde-alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(101192, NULL, 'G3DSA:3.10.20.90:FF:000839', NULL, NULL, 'Gamma-aminobutyric acid receptor associated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(101193, NULL, 'G3DSA:1.10.555.10:FF:000018', NULL, NULL, 'Rho GTPase activating protein 28', NULL, NULL, NULL, NULL, NULL, 4),
(101194, NULL, 'G3DSA:2.30.30.40:FF:000315', NULL, NULL, 'Calcium channel, voltage-dependent, beta 2b', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(101195, NULL, 'G3DSA:3.40.250.10:FF:000077', NULL, NULL, 'Ubiquitin-specific protease', NULL, NULL, NULL, NULL, NULL, 4),
(101196, NULL, 'G3DSA:3.90.550.10:FF:000465', NULL, NULL, 'CMP-N,N''-diacetyllegionaminic acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(101197, NULL, 'G3DSA:3.30.70.330:FF:002811', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101198, NULL, 'G3DSA:2.20.25.10:FF:000019', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(101199, NULL, 'G3DSA:2.60.120.590:FF:000023', NULL, NULL, 'Alkylated DNA repair protein alkB homolog 8', NULL, NULL, NULL, NULL, NULL, 4),
(101200, NULL, 'G3DSA:3.90.70.10:FF:000568', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101201, NULL, 'G3DSA:1.25.40.10:FF:000373', NULL, NULL, 'MAU2 chromatid cohesion factor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(101202, NULL, 'G3DSA:1.10.3630.10:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101203, NULL, 'G3DSA:3.30.310.10:FF:000062', NULL, NULL, 'Beta subunit of clathrin adaptor complex AP2', NULL, NULL, NULL, NULL, NULL, 4),
(101204, NULL, 'G3DSA:3.40.50.360:FF:000066', NULL, NULL, 'RFS1p protein', NULL, NULL, NULL, NULL, NULL, 4),
(101205, NULL, 'G3DSA:1.10.510.10:FF:001415', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101206, NULL, 'G3DSA:3.40.20.10:FF:000039', NULL, NULL, 'Villin-4', NULL, NULL, NULL, NULL, NULL, 4),
(101207, NULL, 'G3DSA:3.40.50.300:FF:003145', NULL, NULL, 'rho-related BTB domain-containing protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(101208, NULL, 'G3DSA:1.10.510.10:FF:003888', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101209, NULL, 'G3DSA:3.50.50.60:FF:000752', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(101210, NULL, 'G3DSA:1.20.120.350:FF:000214', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101211, NULL, 'G3DSA:3.30.70.1450:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101212, NULL, 'G3DSA:3.40.50.300:FF:000739', NULL, NULL, 'Putative ATP-dependent RNA helicase DHX36', NULL, NULL, NULL, NULL, NULL, 4),
(101213, NULL, 'G3DSA:1.10.10.10:FF:001854', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(101214, NULL, 'G3DSA:3.30.56.70:FF:000005', NULL, NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(101215, NULL, 'G3DSA:3.30.160.60:FF:005033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101216, NULL, 'G3DSA:3.30.1540.20:FF:000008', NULL, NULL, 'DNA mismatch repair protein PMS1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(101217, NULL, 'G3DSA:3.50.30.30:FF:000118', NULL, NULL, 'Peptidase M28', NULL, NULL, NULL, NULL, NULL, 4),
(101218, NULL, 'G3DSA:3.90.190.20:FF:000030', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(101219, NULL, 'G3DSA:3.90.70.10:FF:000771', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101220, NULL, 'G3DSA:2.60.120.330:FF:000232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101221, NULL, 'G3DSA:3.40.120.10:FF:000073', NULL, NULL, 'Phosphomannomutase', NULL, NULL, NULL, NULL, NULL, 4),
(101222, NULL, 'G3DSA:3.30.40.10:FF:002143', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(101223, NULL, 'G3DSA:1.20.1250.20:FF:001384', NULL, NULL, 'Major facilitator superfamily MFS_1', NULL, NULL, NULL, NULL, NULL, 4),
(101224, NULL, 'G3DSA:4.10.640.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101225, NULL, 'G3DSA:1.10.418.10:FF:000211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101226, NULL, 'G3DSA:1.25.40.10:FF:004644', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101227, NULL, 'G3DSA:1.10.3720.10:FF:000037', NULL, NULL, 'Inner membrane ABC transporter permease ycjP', NULL, NULL, NULL, NULL, NULL, 4),
(101228, NULL, 'G3DSA:3.10.50.40:FF:000006', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(101229, NULL, 'G3DSA:1.10.510.10:FF:002399', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101230, NULL, 'G3DSA:3.40.50.1820:FF:001104', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101231, NULL, 'G3DSA:3.40.50.1000:FF:000684', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101232, NULL, 'G3DSA:3.30.780.10:FF:000012', NULL, NULL, 'Translation initiation factor SUI1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(101233, NULL, 'G3DSA:1.20.1070.10:FF:001518', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101234, NULL, 'G3DSA:4.10.320.10:FF:000018', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(101235, NULL, 'G3DSA:3.40.570.10:FF:000005', NULL, NULL, 'ectonucleotide pyrophosphatase/phosphodiesterase family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(101236, NULL, 'G3DSA:1.20.5.110:FF:000082', NULL, NULL, 't-SNARE (ER)', NULL, NULL, NULL, NULL, NULL, 4),
(101237, NULL, 'G3DSA:2.60.40.790:FF:000091', NULL, NULL, 'GL22442', NULL, NULL, NULL, NULL, NULL, 4),
(101238, NULL, 'G3DSA:1.20.120.1530:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101239, NULL, 'G3DSA:2.130.10.10:FF:004292', NULL, NULL, 'Syntaxin-binding protein 5a (tomosyn)', NULL, NULL, NULL, NULL, NULL, 4),
(101240, NULL, 'G3DSA:2.40.50.140:FF:000419', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(101241, NULL, 'G3DSA:3.80.10.10:FF:000172', NULL, NULL, 'Nyctalopin', NULL, NULL, NULL, NULL, NULL, 4),
(101242, NULL, 'G3DSA:3.30.160.60:FF:000671', NULL, NULL, 'Zinc finger protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(101243, NULL, 'G3DSA:3.30.40.10:FF:001867', NULL, NULL, 'Nuclear transcription factor, X-box-binding-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(101244, NULL, 'G3DSA:2.10.25.10:FF:000756', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(101245, NULL, 'G3DSA:3.30.160.60:FF:000486', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM41 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(101246, NULL, 'G3DSA:2.60.120.460:FF:000001', NULL, NULL, 'UPF0047 protein MT2633', NULL, NULL, NULL, NULL, NULL, 4),
(101247, NULL, 'G3DSA:1.20.140.150:FF:000040', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(101248, NULL, 'G3DSA:2.60.120.310:FF:000018', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101249, NULL, 'G3DSA:1.20.120.80:FF:000010', NULL, NULL, 'Cytochrome c oxidase subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(101250, NULL, 'G3DSA:3.30.430.20:FF:000006', NULL, NULL, 'Receptor-like serine-threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(101251, NULL, 'G3DSA:3.30.160.60:FF:004628', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101252, NULL, 'G3DSA:2.60.40.790:FF:000214', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101253, NULL, 'G3DSA:3.40.50.300:FF:006579', NULL, NULL, 'Bifunctional coenzyme A synthase', NULL, NULL, NULL, NULL, NULL, 4),
(101254, NULL, 'G3DSA:2.130.10.30:FF:000121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101255, NULL, 'G3DSA:1.10.510.10:FF:000454', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101256, NULL, 'G3DSA:3.40.50.261:FF:000020', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(101257, NULL, 'G3DSA:3.40.50.10190:FF:000129', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(101258, NULL, 'G3DSA:1.10.10.1050:FF:000015', NULL, NULL, 'mRNA-decapping enzyme 2', NULL, NULL, NULL, NULL, NULL, 4),
(101259, NULL, 'G3DSA:2.60.120.200:FF:000749', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101260, NULL, 'G3DSA:1.20.1250.20:FF:001726', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101261, NULL, 'G3DSA:3.40.30.10:FF:000629', NULL, NULL, 'Thioredoxin-like protein 4B', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(101262, NULL, 'G3DSA:1.10.560.10:FF:000081', NULL, NULL, '60 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(101263, NULL, 'G3DSA:1.10.238.10:FF:000192', NULL, NULL, 'Protein S100', NULL, NULL, NULL, NULL, NULL, 4),
(101264, NULL, 'G3DSA:2.60.20.10:FF:000018', NULL, NULL, 'Calcium-dependent cell adhesion molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(101265, NULL, 'G3DSA:1.10.510.10:FF:003579', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101266, NULL, 'G3DSA:3.30.70.270:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101267, NULL, 'G3DSA:1.10.8.60:FF:000570', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NUBP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(101268, NULL, 'G3DSA:3.40.30.10:FF:001029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101269, NULL, 'G3DSA:3.30.465.10:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101270, NULL, 'G3DSA:1.10.150.80:FF:000031', NULL, NULL, 'Ribonuclease D', NULL, NULL, NULL, NULL, NULL, 4),
(101271, NULL, 'G3DSA:1.20.1250.20:FF:002002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101272, NULL, 'G3DSA:3.80.10.10:FF:001818', NULL, NULL, 'YALI0D21208p', NULL, NULL, NULL, NULL, NULL, 4),
(101273, NULL, 'G3DSA:2.130.10.10:FF:003763', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101274, NULL, 'G3DSA:2.10.270.10:FF:000010', NULL, NULL, 'Dextransucrase', NULL, NULL, NULL, NULL, NULL, 4),
(101275, NULL, 'G3DSA:3.40.50.620:FF:000397', NULL, NULL, 'Isoleucine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(101276, NULL, 'G3DSA:2.60.120.920:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101277, NULL, 'G3DSA:1.20.58.390:FF:000209', NULL, NULL, 'Cholinergic receptor nicotinic alpha 10 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(101278, NULL, 'G3DSA:3.30.40.10:FF:000687', NULL, NULL, 'Rco1p', NULL, NULL, NULL, NULL, NULL, 4),
(101279, NULL, 'G3DSA:3.40.50.2300:FF:000416', NULL, NULL, 'DNA-binding response regulator KdpE', NULL, NULL, NULL, NULL, NULL, 4),
(101280, NULL, 'G3DSA:1.10.533.10:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101281, NULL, 'G3DSA:3.40.50.720:FF:000314', NULL, NULL, 'Quinone oxidoreductase PIG3', NULL, NULL, NULL, NULL, NULL, 4),
(101282, NULL, 'G3DSA:1.10.510.10:FF:000145', NULL, NULL, 'Dual specificity protein kinase CLK2', NULL, NULL, NULL, NULL, NULL, 4),
(101283, NULL, 'G3DSA:3.50.7.10:FF:000015', NULL, NULL, 'Chaperonin HSP60, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(101284, NULL, 'G3DSA:3.40.50.880:FF:000210', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(101285, NULL, 'G3DSA:3.90.79.10:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101286, NULL, 'G3DSA:3.10.20.90:FF:000587', NULL, NULL, 'Ubiquitin family protein 5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(101287, NULL, 'G3DSA:2.60.120.380:FF:000095', NULL, NULL, 'Putative calpain-like cysteine protease A', NULL, NULL, NULL, NULL, NULL, 4),
(101288, NULL, 'G3DSA:3.40.50.10420:FF:000013', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(101289, NULL, 'G3DSA:4.10.400.10:FF:000171', NULL, NULL, 'Low-density lipoprotein receptor-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(101290, NULL, 'G3DSA:3.80.10.10:FF:001133', NULL, NULL, 'Transmembrane protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(101291, NULL, 'G3DSA:3.90.870.10:FF:000028', NULL, NULL, 'Sua5/YciO/YrdC/YwlC family protein', NULL, NULL, NULL, NULL, NULL, 4),
(101292, NULL, 'G3DSA:3.90.470.20:FF:000034', NULL, NULL, 'Enterobactin synthase component D', NULL, NULL, NULL, NULL, NULL, 4),
(101293, NULL, 'G3DSA:3.80.10.10:FF:001509', NULL, NULL, '2mit, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(101294, NULL, 'G3DSA:2.40.70.10:FF:000033', NULL, NULL, 'Aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(101295, NULL, 'G3DSA:1.20.1250.20:FF:000765', NULL, NULL, 'Riboflavin transporter', NULL, NULL, NULL, NULL, NULL, 4),
(101296, NULL, 'G3DSA:3.30.200.20:FF:000545', NULL, NULL, 'CMGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(101297, NULL, 'G3DSA:1.25.40.10:FF:001553', NULL, NULL, 'Pentatricopeptide (PPR) repeat-containing protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(101298, NULL, 'G3DSA:1.25.40.20:FF:001090', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(101299, NULL, 'G3DSA:1.25.10.10:FF:000545', NULL, NULL, 'VPS15 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(101300, NULL, 'G3DSA:2.10.25.10:FF:000071', NULL, NULL, 'Fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(101301, NULL, 'G3DSA:3.40.50.2300:FF:000164', NULL, NULL, 'LacI family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(101302, NULL, 'G3DSA:3.40.50.300:FF:004814', NULL, NULL, 'Protein CBG17965', NULL, NULL, NULL, NULL, NULL, 4),
(101303, NULL, 'G3DSA:2.60.40.60:FF:000591', NULL, NULL, 'Protocadherin gamma subfamily B, 7', NULL, NULL, NULL, NULL, NULL, 4),
(101304, NULL, 'G3DSA:3.30.300.20:FF:000002', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(101305, NULL, 'G3DSA:1.10.565.10:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101306, NULL, 'G3DSA:3.40.1190.10:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101307, NULL, 'G3DSA:3.30.160.60:FF:004414', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101308, NULL, 'G3DSA:1.10.287.70:FF:000727', NULL, NULL, 'Protein CBR-TWK-44', NULL, NULL, NULL, NULL, NULL, 4),
(101309, NULL, 'G3DSA:3.90.226.10:FF:000066', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(101310, NULL, 'G3DSA:3.40.50.1820:FF:001447', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101311, NULL, 'G3DSA:3.40.50.620:FF:000739', NULL, NULL, 'Uncharacterized protein C1F12.08', NULL, NULL, NULL, NULL, NULL, 4),
(101312, NULL, 'G3DSA:3.30.40.10:FF:001524', NULL, NULL, 'RING/U-box superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(101313, NULL, 'G3DSA:2.40.50.140:FF:001280', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101314, NULL, 'G3DSA:3.40.47.10:FF:000303', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101315, NULL, 'G3DSA:3.50.50.60:FF:000224', NULL, NULL, 'Putative oxidoreductase C1F5.03c', NULL, NULL, NULL, NULL, NULL, 4),
(101316, NULL, 'G3DSA:3.10.180.20:FF:000002', NULL, NULL, 'Alpha-1,3-mannosyl-glycoprotein 2-beta-N-acetylglucosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(101317, NULL, 'G3DSA:3.40.50.1820:FF:000795', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101318, NULL, 'G3DSA:3.40.50.300:FF:004106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101319, NULL, 'G3DSA:2.130.10.10:FF:005000', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101320, NULL, 'G3DSA:1.20.1070.10:FF:001271', NULL, NULL, 'low-density lipoprotein receptor-related protein 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(101321, NULL, 'G3DSA:3.10.20.90:FF:000278', NULL, NULL, 'serine-rich adhesin for platelets', NULL, NULL, NULL, NULL, NULL, 4),
(101322, NULL, 'G3DSA:1.25.40.20:FF:000139', NULL, NULL, 'caskin-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(101323, NULL, 'G3DSA:2.60.260.20:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101324, NULL, 'G3DSA:1.20.1070.10:FF:000995', NULL, NULL, 'Adrenoceptor alpha 1D', NULL, NULL, NULL, NULL, NULL, 4),
(101325, NULL, 'G3DSA:1.10.260.40:FF:000016', NULL, NULL, 'HTH-type transcriptional regulator PuuR', NULL, NULL, NULL, NULL, NULL, 4),
(101326, NULL, 'G3DSA:1.10.340.30:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101327, NULL, 'G3DSA:2.130.10.10:FF:000705', NULL, NULL, 'Probable cytosolic iron-sulfur protein assembly protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(101328, NULL, 'G3DSA:3.30.200.20:FF:000293', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(101329, NULL, 'G3DSA:3.100.10.10:FF:000034', NULL, NULL, 'Ribosomal protein L18e/L15', NULL, NULL, NULL, NULL, NULL, 4),
(101330, NULL, 'G3DSA:1.25.40.10:FF:005263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101331, NULL, 'G3DSA:1.20.120.1750:FF:000096', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(101332, NULL, 'G3DSA:2.70.130.10:FF:000003', NULL, NULL, 'Endoplasmic reticulum lectin 1', NULL, NULL, NULL, NULL, NULL, 4),
(101333, NULL, 'G3DSA:3.30.450.90:FF:000005', NULL, NULL, 'Protein VirB11', NULL, NULL, NULL, NULL, NULL, 4),
(101334, NULL, 'G3DSA:2.80.10.70:FF:000001', NULL, NULL, 'Spindlin 1', NULL, NULL, NULL, NULL, NULL, 4),
(101335, NULL, 'G3DSA:3.20.20.220:FF:000079', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(101336, NULL, 'G3DSA:2.60.40.10:FF:000492', NULL, NULL, 'Mucosa-associated lymphoid tissue lymphoma translocation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(101337, NULL, 'G3DSA:1.25.40.10:FF:000350', NULL, NULL, 'Vacuolar protein sorting-associated protein 41 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(101338, NULL, 'G3DSA:3.30.300.180:FF:000021', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(101339, NULL, 'G3DSA:2.10.70.10:FF:000271', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101340, NULL, 'G3DSA:2.130.10.10:FF:001071', NULL, NULL, 'Protein HIRA', NULL, NULL, NULL, NULL, NULL, 4),
(101341, NULL, 'G3DSA:1.10.530.10:FF:000017', NULL, NULL, 'Lytic murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(101342, NULL, 'G3DSA:3.80.10.10:FF:001150', NULL, NULL, 'Outer arm dynein light chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(101343, NULL, 'G3DSA:1.10.10.830:FF:000011', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(101344, NULL, 'G3DSA:1.10.630.10:FF:000648', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101345, NULL, 'G3DSA:1.10.510.10:FF:001106', NULL, NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g29720', NULL, NULL, NULL, NULL, NULL, 4),
(101346, NULL, 'G3DSA:1.25.40.10:FF:003104', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase, rhodopsin-specific isozyme-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(101347, NULL, 'G3DSA:1.10.150.20:FF:000042', NULL, NULL, '5''-3'' exonuclease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(101348, NULL, 'G3DSA:1.10.20.10:FF:000186', NULL, NULL, 'CCAAT-binding factor complex subunit Php3', NULL, NULL, NULL, NULL, NULL, 4),
(101349, NULL, 'G3DSA:3.30.710.10:FF:000171', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(101350, NULL, 'G3DSA:2.130.10.10:FF:000565', NULL, NULL, 'Putative snoRNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(101351, NULL, 'G3DSA:3.40.50.2300:FF:001473', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101352, NULL, 'G3DSA:1.10.510.10:FF:002146', NULL, NULL, 'inactive tyrosine-protein kinase transmembrane receptor ROR1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(101353, NULL, 'G3DSA:3.90.70.10:FF:000349', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(101354, NULL, 'G3DSA:1.10.1420.10:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101355, NULL, 'G3DSA:2.102.10.10:FF:000044', NULL, NULL, 'Methylxanthine N1-demethylase NdmA', NULL, NULL, NULL, NULL, NULL, 4),
(101356, NULL, 'G3DSA:2.40.10.10:FF:000035', NULL, NULL, 'Complement C1r subcomponent', NULL, NULL, NULL, NULL, NULL, 4),
(101357, NULL, 'G3DSA:2.60.40.150:FF:000489', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101358, NULL, 'G3DSA:1.10.3470.10:FF:000028', NULL, NULL, 'Iron ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(101359, NULL, 'G3DSA:3.30.420.40:FF:000854', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101360, NULL, 'G3DSA:3.90.550.10:FF:000678', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(101361, NULL, 'G3DSA:3.20.20.70:FF:000524', NULL, NULL, 'PelA', NULL, NULL, NULL, NULL, NULL, 4),
(101362, NULL, 'G3DSA:3.30.200.20:FF:000641', NULL, NULL, 'Protein kinase 7', NULL, NULL, NULL, NULL, NULL, 4),
(101363, NULL, 'G3DSA:3.40.50.2300:FF:000967', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101364, NULL, 'G3DSA:3.40.50.2000:FF:000984', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101365, NULL, 'G3DSA:3.30.40.10:FF:000895', NULL, NULL, 'AGAP005461-PA', NULL, NULL, NULL, NULL, NULL, 4),
(101366, NULL, 'G3DSA:2.60.40.420:FF:000042', NULL, NULL, 'Cytochrome c oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(101367, NULL, 'G3DSA:3.10.100.10:FF:000230', NULL, NULL, 'C-type lectin domain-containing 14A', NULL, NULL, NULL, NULL, NULL, 4),
(101368, NULL, 'G3DSA:2.130.10.10:FF:000126', NULL, NULL, 'Plexin B1', NULL, NULL, NULL, NULL, NULL, 4),
(101369, NULL, 'G3DSA:3.60.20.10:FF:000089', NULL, NULL, 'Proteasome endopeptidase complex', NULL, NULL, NULL, NULL, NULL, 4),
(101370, NULL, 'G3DSA:3.30.160.60:FF:003684', NULL, NULL, 'Zinc finger protein 462', NULL, NULL, NULL, NULL, NULL, 4),
(101371, NULL, 'G3DSA:1.25.40.10:FF:004627', NULL, NULL, 'Prolyl 4-hydroxylase subunit alpha-2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(101372, NULL, 'G3DSA:2.40.70.10:FF:000483', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101373, NULL, 'G3DSA:1.20.1560.10:FF:000510', NULL, NULL, 'ABC transporter, multidrug resistance associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(101374, NULL, 'G3DSA:3.80.10.10:FF:002673', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101375, NULL, 'G3DSA:1.25.40.10:FF:001873', NULL, NULL, 'GM18509', NULL, NULL, NULL, NULL, NULL, 4),
(101376, NULL, 'G3DSA:1.20.1560.10:FF:000398', NULL, NULL, 'Multidrug resistance-associated protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(101377, NULL, 'G3DSA:3.30.230.10:FF:000140', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(101378, NULL, 'G3DSA:1.10.10.60:FF:000115', NULL, NULL, 'Transcriptional adapter 2', NULL, NULL, NULL, NULL, NULL, 4),
(101379, NULL, 'G3DSA:2.60.40.60:FF:000023', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(101380, NULL, 'G3DSA:1.25.10.10:FF:002990', NULL, NULL, 'Protein CBG04073', NULL, NULL, NULL, NULL, NULL, 4),
(101381, NULL, 'G3DSA:3.60.20.10:FF:000201', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101382, NULL, 'G3DSA:3.90.1030.10:FF:000003', NULL, NULL, '50S ribosomal protein L17', NULL, NULL, NULL, NULL, NULL, 4),
(101383, NULL, 'G3DSA:3.40.50.300:FF:006360', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101384, NULL, 'G3DSA:3.30.40.10:FF:001507', NULL, NULL, 'RING finger protein 145', NULL, NULL, NULL, NULL, NULL, 4),
(101385, NULL, 'G3DSA:1.20.120.350:FF:000219', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101386, NULL, 'G3DSA:3.40.50.150:FF:000565', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101387, NULL, 'G3DSA:3.10.20.90:FF:000834', NULL, NULL, 'Autophagy-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(101388, NULL, 'G3DSA:1.10.10.10:FF:001298', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(101389, NULL, 'G3DSA:3.30.1370.10:FF:000183', NULL, NULL, 'YALI0C05324p', NULL, NULL, NULL, NULL, NULL, 4),
(101390, NULL, 'G3DSA:3.10.100.10:FF:000129', NULL, NULL, 'Thrombomodulin', NULL, NULL, NULL, NULL, NULL, 4),
(101391, NULL, 'G3DSA:2.170.140.10:FF:000047', NULL, NULL, 'Mucin 68E', NULL, NULL, NULL, NULL, NULL, 4),
(101392, NULL, 'G3DSA:2.40.150.20:FF:000019', NULL, NULL, 'Ribosomal protein L23', NULL, NULL, NULL, NULL, NULL, 4),
(101393, NULL, 'G3DSA:3.40.50.720:FF:000522', NULL, NULL, 'L-carnitine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(101394, NULL, 'G3DSA:1.20.58.60:FF:000697', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101395, NULL, 'G3DSA:2.70.170.10:FF:000096', NULL, NULL, 'Gamma-aminobutyric acid receptor subunit beta', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(101396, NULL, 'G3DSA:3.30.70.330:FF:001378', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101397, NULL, 'G3DSA:2.60.120.260:FF:000385', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101398, NULL, 'G3DSA:3.60.10.10:FF:000015', NULL, NULL, 'sphingomyelin phosphodiesterase 3', NULL, NULL, NULL, NULL, NULL, 4),
(101399, NULL, 'G3DSA:3.40.50.720:FF:001719', NULL, NULL, 'Possible 2-hydroxyacid-family dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(101400, NULL, 'G3DSA:3.10.110.10:FF:000315', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101401, NULL, 'G3DSA:1.10.510.10:FF:000589', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(101402, NULL, 'G3DSA:1.25.10.10:FF:003395', NULL, NULL, 'Armadillo repeat-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(101403, NULL, 'G3DSA:2.60.120.10:FF:000763', NULL, NULL, 'Cyclic nucleotide-activated ion channel', NULL, NULL, NULL, NULL, NULL, 4),
(101404, NULL, 'G3DSA:2.20.25.10:FF:000115', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(101405, NULL, 'G3DSA:3.30.559.10:FF:000037', NULL, NULL, 'Nonribosomal peptide synthase Pes1', NULL, NULL, NULL, NULL, NULL, 4),
(101406, NULL, 'G3DSA:1.10.10.10:FF:000112', NULL, NULL, 'HTH-type transcriptional regulator lrhA', NULL, NULL, NULL, NULL, NULL, 4),
(101407, NULL, 'G3DSA:3.80.10.10:FF:001245', NULL, NULL, 'Reduced ocelli, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(101408, NULL, 'G3DSA:3.40.50.300:FF:002077', NULL, NULL, 'Damage-inducible mutagenesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(101409, NULL, 'G3DSA:2.30.30.40:FF:000091', NULL, NULL, 'Putative E3 ubiquitin-protein ligase SH3RF1', NULL, NULL, NULL, NULL, NULL, 4),
(101410, NULL, 'G3DSA:3.90.980.20:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101411, NULL, 'G3DSA:1.20.1070.10:FF:000765', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101412, NULL, 'G3DSA:1.10.510.10:FF:003574', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101413, NULL, 'G3DSA:2.60.220.30:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101414, NULL, 'G3DSA:3.30.200.20:FF:002439', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101415, NULL, 'G3DSA:2.60.40.10:FF:002627', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101416, NULL, 'G3DSA:3.40.1550.10:FF:000003', NULL, NULL, 'Flagellar motor switch phosphatase FliY', NULL, NULL, NULL, NULL, NULL, 4),
(101417, NULL, 'G3DSA:2.130.10.10:FF:003903', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101418, NULL, 'G3DSA:2.130.10.10:FF:004729', NULL, NULL, 'Eukaryotic translation initiation factor 2A', NULL, NULL, NULL, NULL, NULL, 4),
(101419, NULL, 'G3DSA:2.30.38.10:FF:000004', NULL, NULL, 'Acyl-CoA synthetase family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(101420, NULL, 'G3DSA:2.60.40.60:FF:000927', NULL, NULL, 'cDNA FLJ11853 fis, clone HEMBA1006758, highly similar to Homo sapiens protocadherin beta 13 (PCDH-beta13) mRNA', NULL, NULL, NULL, NULL, NULL, 4),
(101421, NULL, 'G3DSA:2.60.40.150:FF:000394', NULL, NULL, 'Copine family protein', NULL, NULL, NULL, NULL, NULL, 4),
(101422, NULL, 'G3DSA:3.40.50.80:FF:000062', NULL, NULL, 'NADPH-dependent diflavin oxidoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(101423, NULL, 'G3DSA:1.10.10.60:FF:000554', NULL, NULL, 'POU domain, class 5, transcription factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(101424, NULL, 'G3DSA:1.10.510.10:FF:002051', NULL, NULL, 'Protein CBG06004', NULL, NULL, NULL, NULL, NULL, 4),
(101425, NULL, 'G3DSA:1.10.238.10:FF:000085', NULL, NULL, 'CDPK-related kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(101426, NULL, 'G3DSA:1.10.100.10:FF:000002', NULL, NULL, 'Insulin-like growth factor II preproprotein', NULL, NULL, NULL, NULL, NULL, 4),
(101427, NULL, 'G3DSA:1.10.10.60:FF:001060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101428, NULL, 'G3DSA:1.25.10.10:FF:000522', NULL, NULL, 'AP-3 complex subunit beta, putative', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(101429, NULL, 'G3DSA:1.20.1730.10:FF:000001', NULL, NULL, 'Cation/acetate symporter ActP', NULL, NULL, NULL, NULL, NULL, 4),
(101430, NULL, 'G3DSA:2.30.29.30:FF:001326', NULL, NULL, 'Beta 1 syntrophin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(101431, NULL, 'G3DSA:1.10.1670.10:FF:000009', NULL, NULL, 'DNA-3-methyladenine glycosylase 2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(101432, NULL, 'G3DSA:4.10.60.10:FF:000102', NULL, NULL, 'Cellular nucleic acid binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(101433, NULL, 'G3DSA:3.20.20.140:FF:000173', NULL, NULL, 'Protein unc-33', NULL, NULL, NULL, NULL, NULL, 4),
(101434, NULL, 'G3DSA:3.40.50.300:FF:006259', NULL, NULL, 'Zinc finger RANBP2-type containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(101435, NULL, 'G3DSA:1.10.238.10:FF:000568', NULL, NULL, 'Hypothetical_protein', NULL, NULL, NULL, NULL, NULL, 4),
(101436, NULL, 'G3DSA:2.130.10.10:FF:001975', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101437, NULL, 'G3DSA:2.40.160.110:FF:000021', NULL, NULL, 'uncharacterized protein LOC101242403 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(101438, NULL, 'G3DSA:2.10.25.10:FF:000205', NULL, NULL, 'latent-transforming growth factor beta-binding protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(101439, NULL, 'G3DSA:3.30.70.120:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101440, NULL, 'G3DSA:3.30.40.10:FF:001412', NULL, NULL, 'U-box domain-containing protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(101441, NULL, 'G3DSA:1.10.472.10:FF:000612', NULL, NULL, 'T-type cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(101442, NULL, 'G3DSA:3.40.30.10:FF:000989', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101443, NULL, 'G3DSA:2.60.40.3330:FF:000002', NULL, NULL, 'TransThyretin-Related family domain', NULL, NULL, NULL, NULL, NULL, 4),
(101444, NULL, 'G3DSA:3.40.190.10:FF:000723', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(101445, NULL, 'G3DSA:1.10.730.10:FF:000128', NULL, NULL, 'Methionine-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(101446, NULL, 'G3DSA:1.20.5.340:FF:000116', NULL, NULL, 'Membrane protein related to metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(101447, NULL, 'G3DSA:1.10.950.10:FF:000009', NULL, NULL, 'Unc-115 protein', NULL, NULL, NULL, NULL, NULL, 4),
(101448, NULL, 'G3DSA:2.130.10.10:FF:003892', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101449, NULL, 'G3DSA:3.30.70.330:FF:000552', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(101450, NULL, 'G3DSA:1.10.246.130:FF:000001', NULL, NULL, 'Gamma-glutamyltransferase 5 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(101451, NULL, 'G3DSA:2.40.40.20:FF:000080', NULL, NULL, 'AGAP012684-PA', NULL, NULL, NULL, NULL, NULL, 4),
(101452, NULL, 'G3DSA:3.40.20.10:FF:000011', NULL, NULL, 'Drebrin-like protein B', NULL, NULL, NULL, NULL, NULL, 4),
(101453, NULL, 'G3DSA:1.10.3430.10:FF:000020', NULL, NULL, 'Ammonium transporter', NULL, NULL, NULL, NULL, NULL, 4),
(101454, NULL, 'G3DSA:3.30.750.24:FF:000035', NULL, NULL, 'STAS domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(101455, NULL, 'G3DSA:1.25.40.20:FF:000027', NULL, NULL, 'Arf-GAP with GTPase, ANK repeat and PH domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(101456, NULL, 'G3DSA:3.30.160.60:FF:000699', NULL, NULL, 'Zinc finger protein 33B', NULL, NULL, NULL, NULL, NULL, 4),
(101457, NULL, 'G3DSA:3.40.50.2300:FF:000175', NULL, NULL, 'Propionate catabolism operon regulatory protein PrpR', NULL, NULL, NULL, NULL, NULL, 4),
(101458, NULL, 'G3DSA:2.30.30.40:FF:000102', NULL, NULL, 'Desmoplakin a', NULL, NULL, NULL, NULL, NULL, 4),
(101459, NULL, 'G3DSA:1.10.1410.40:FF:000016', NULL, NULL, 'Smith-Magenis syndrome chromosome region, candidate 7', NULL, NULL, NULL, NULL, NULL, 4),
(101460, NULL, 'G3DSA:1.25.10.10:FF:000652', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(101461, NULL, 'G3DSA:2.10.110.10:FF:000173', NULL, NULL, 'XLIM-Kinases2', NULL, NULL, NULL, NULL, NULL, 4),
(101462, NULL, 'G3DSA:1.10.510.10:FF:002955', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101463, NULL, 'G3DSA:1.10.390.10:FF:000028', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(101464, NULL, 'G3DSA:1.10.10.10:FF:000893', NULL, NULL, 'Regulatory protein RecX', NULL, NULL, NULL, NULL, NULL, 4),
(101465, NULL, 'G3DSA:4.10.400.10:FF:000064', NULL, NULL, 'low-density lipoprotein receptor-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(101466, NULL, 'G3DSA:2.60.120.760:FF:000001', NULL, NULL, 'Fucose-binding lectin II', NULL, NULL, NULL, NULL, NULL, 4),
(101467, NULL, 'G3DSA:3.40.50.300:FF:007669', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101468, NULL, 'G3DSA:3.30.930.10:FF:000277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101469, NULL, 'G3DSA:1.20.1110.10:FF:000139', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101470, NULL, 'G3DSA:3.40.1810.10:FF:000041', NULL, NULL, 'Agamous-like MADS-box protein AGL80', NULL, NULL, NULL, NULL, NULL, 4),
(101471, NULL, 'G3DSA:3.30.160.60:FF:000811', NULL, NULL, 'Zinc finger protein 521', NULL, NULL, NULL, NULL, NULL, 4),
(101472, NULL, 'G3DSA:3.40.50.300:FF:007557', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101473, NULL, 'G3DSA:3.40.50.2000:FF:000080', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(101474, NULL, 'G3DSA:2.80.10.50:FF:000124', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(101475, NULL, 'G3DSA:3.40.50.300:FF:005062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101476, NULL, 'G3DSA:3.40.50.720:FF:001950', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101477, NULL, 'G3DSA:2.60.40.1970:FF:000004', NULL, NULL, 'YEATS domain-containing protein 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(101478, NULL, 'G3DSA:2.60.40.10:FF:004544', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101479, NULL, 'G3DSA:3.20.19.10:FF:000008', NULL, NULL, 'Aconitate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(101480, NULL, 'G3DSA:3.10.20.30:FF:000052', NULL, NULL, 'Ubiquitin-related modifier 1', NULL, NULL, NULL, NULL, NULL, 4),
(101481, NULL, 'G3DSA:3.30.505.10:FF:000216', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101482, NULL, 'G3DSA:1.10.510.10:FF:000926', NULL, NULL, 'Serine/threonine protein kinase VPS15', NULL, NULL, NULL, NULL, NULL, 4),
(101483, NULL, 'G3DSA:3.40.220.10:FF:000030', NULL, NULL, 'ADP-ribose glycohydrolase AF_1521', NULL, NULL, NULL, NULL, NULL, 4),
(101484, NULL, 'G3DSA:3.40.50.300:FF:004331', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(101485, NULL, 'G3DSA:2.130.10.10:FF:003420', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(101486, NULL, 'G3DSA:3.40.640.10:FF:000461', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101487, NULL, 'G3DSA:4.10.320.10:FF:000012', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(101488, NULL, 'G3DSA:1.20.58.1210:FF:000016', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101489, NULL, 'G3DSA:1.10.8.500:FF:000010', NULL, NULL, 'Methyl-accepting chemotaxis protein CtpH', NULL, NULL, NULL, NULL, NULL, 4),
(101490, NULL, 'G3DSA:3.40.50.1860:FF:000003', NULL, NULL, 'Aspartate racemase', NULL, NULL, NULL, NULL, NULL, 4),
(101491, NULL, 'G3DSA:1.25.40.10:FF:000249', NULL, NULL, 'N-lysine methyltransferase SMYD2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(101492, NULL, 'G3DSA:1.20.5.5270:FF:000003', NULL, NULL, 'Lon protease homolog 2, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(101493, NULL, 'G3DSA:2.60.40.1910:FF:000014', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(101494, NULL, 'G3DSA:2.30.39.10:FF:000096', NULL, NULL, 'serine protease inhibitor isoform X1', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(101495, NULL, 'G3DSA:2.60.40.10:FF:005584', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101496, NULL, 'G3DSA:2.60.40.1180:FF:000183', NULL, NULL, 'Alpha-glucosidase, family 31 of glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(101497, NULL, 'G3DSA:1.10.30.10:FF:000012', NULL, NULL, 'axial regulator YABBY 5-like', NULL, NULL, NULL, NULL, NULL, 4),
(101498, NULL, 'G3DSA:2.40.50.140:FF:000094', NULL, NULL, 'cold shock domain-containing protein E1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(101499, NULL, 'G3DSA:1.20.5.350:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101500, NULL, 'G3DSA:3.30.420.40:FF:000062', NULL, NULL, 'N-acetylmannosamine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(101501, NULL, 'G3DSA:1.10.510.10:FF:004400', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101502, NULL, 'G3DSA:2.60.40.1850:FF:000002', NULL, NULL, 'Internalin', NULL, NULL, NULL, NULL, NULL, 4),
(101503, NULL, 'G3DSA:1.20.5.1230:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101504, NULL, 'G3DSA:3.40.50.960:FF:000010', NULL, NULL, '6,7-dimethyl-8-ribityllumazine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(101505, NULL, 'G3DSA:3.10.20.230:FF:000022', NULL, NULL, 'Double-cortin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(101506, NULL, 'G3DSA:1.10.472.10:FF:000241', NULL, NULL, 'Cyclin domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(101507, NULL, 'G3DSA:2.160.20.60:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101508, NULL, 'G3DSA:2.60.120.320:FF:000004', NULL, NULL, 'Thiamine pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(101509, NULL, 'G3DSA:2.130.10.10:FF:002931', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101510, NULL, 'G3DSA:2.130.10.10:FF:004617', NULL, NULL, 'AFR634Wp', NULL, NULL, NULL, NULL, NULL, 4),
(101511, NULL, 'G3DSA:3.30.450.20:FF:000024', NULL, NULL, 'VWFA and cache domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(101512, NULL, 'G3DSA:1.20.1250.20:FF:001485', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(101513, NULL, 'G3DSA:3.60.21.10:FF:000260', NULL, NULL, 'Ser/Thr protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(101514, NULL, 'G3DSA:3.40.50.300:FF:008288', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101515, NULL, 'G3DSA:3.40.50.10140:FF:000002', NULL, NULL, 'Interleukin 1 receptor accessory protein', NULL, NULL, NULL, NULL, NULL, 4),
(101516, NULL, 'G3DSA:2.60.260.20:FF:000029', NULL, NULL, 'Molecular chaperone DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(101517, NULL, 'G3DSA:3.30.930.10:FF:000165', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(101518, NULL, 'G3DSA:1.25.10.10:FF:001141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101519, NULL, 'G3DSA:3.40.50.300:FF:002886', NULL, NULL, 'Rho family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(101520, NULL, 'G3DSA:3.30.40.10:FF:002031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101521, NULL, 'G3DSA:2.40.30.10:FF:000374', NULL, NULL, 'NADH-dependent ferredoxin:NADP+ oxidoreductase, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(101522, NULL, 'G3DSA:1.20.1440.90:FF:000008', NULL, NULL, 'Phosphoenolpyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(101523, NULL, 'G3DSA:3.80.10.10:FF:003611', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101524, NULL, 'G3DSA:2.130.10.10:FF:005348', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101525, NULL, 'G3DSA:3.80.10.10:FF:003387', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101526, NULL, 'G3DSA:3.50.50.60:FF:000544', NULL, NULL, 'Flavin-containing monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(101527, NULL, 'G3DSA:2.70.160.11:FF:000040', NULL, NULL, 'Protein arginine N-methyltransferase-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(101528, NULL, 'G3DSA:3.30.830.10:FF:000129', NULL, NULL, 'Protease, insulinase family/protease, insulinase family', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(101529, NULL, 'G3DSA:1.10.1630.10:FF:000001', NULL, NULL, 'histone acetyltransferase p300', NULL, NULL, NULL, NULL, NULL, 4),
(101530, NULL, 'G3DSA:3.40.50.300:FF:001700', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(101531, NULL, 'G3DSA:1.20.5.110:FF:000183', NULL, NULL, 't-SNARE protein aex-4', NULL, NULL, NULL, NULL, NULL, 4),
(101532, NULL, 'G3DSA:1.20.5.320:FF:000009', NULL, NULL, 'Collagen alpha-1(XVII) chain', NULL, NULL, NULL, NULL, NULL, 4),
(101533, NULL, 'G3DSA:2.40.480.10:FF:000002', NULL, NULL, 'Dirigent protein', NULL, NULL, NULL, NULL, NULL, 4),
(101534, NULL, 'G3DSA:2.30.29.30:FF:000028', NULL, NULL, 'Talin 2', NULL, NULL, NULL, NULL, NULL, 4),
(101535, NULL, 'G3DSA:3.40.850.10:FF:000156', NULL, NULL, 'Myosin heavy chain subunit', NULL, NULL, NULL, NULL, NULL, 4),
(101536, NULL, 'G3DSA:3.40.50.150:FF:001503', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101537, NULL, 'G3DSA:2.60.120.430:FF:000037', NULL, NULL, 'NADH:ubiquinone oxidoreductase complex assembly factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(101538, NULL, 'G3DSA:1.20.120.1760:FF:000088', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101539, NULL, 'G3DSA:1.25.10.10:FF:002338', NULL, NULL, 'Armadillo repeat-containing protein LFR', NULL, NULL, NULL, NULL, NULL, 4),
(101540, NULL, 'G3DSA:2.60.40.10:FF:004173', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101541, NULL, 'G3DSA:2.60.120.650:FF:000070', NULL, NULL, '40S ribosomal protein S4-3', NULL, NULL, NULL, NULL, NULL, 4),
(101542, NULL, 'G3DSA:1.20.120.140:FF:000033', NULL, NULL, 'Signal recognition particle receptor FtsY', NULL, NULL, NULL, NULL, NULL, 4),
(101543, NULL, 'G3DSA:3.10.20.90:FF:000704', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101544, NULL, 'G3DSA:2.30.33.40:FF:000013', NULL, NULL, '20 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(101545, NULL, 'G3DSA:3.40.50.450:FF:000082', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(101546, NULL, 'G3DSA:1.10.510.10:FF:000134', NULL, NULL, 'Casein kinase I isoform delta-like', NULL, NULL, NULL, NULL, NULL, 4),
(101547, NULL, 'G3DSA:1.20.5.350:FF:000007', NULL, NULL, 'Troponin I2, fast skeletal type', NULL, NULL, NULL, NULL, NULL, 4),
(101548, NULL, 'G3DSA:2.130.10.10:FF:000677', NULL, NULL, 'Type I inositol polyphosphate 5-phosphatase 13', NULL, NULL, NULL, NULL, NULL, 4),
(101549, NULL, 'G3DSA:3.40.50.300:FF:005871', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(101550, NULL, 'G3DSA:1.10.418.10:FF:000071', NULL, NULL, 'plastin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(101551, NULL, 'G3DSA:2.60.40.10:FF:003116', NULL, NULL, 'Putative neuronal cell adhesion molecule', NULL, NULL, NULL, NULL, NULL, 4),
(101552, NULL, 'G3DSA:2.30.29.30:FF:000697', NULL, NULL, 'GM16509', NULL, NULL, NULL, NULL, NULL, 4),
(101553, NULL, 'G3DSA:1.25.40.10:FF:000480', NULL, NULL, 'WGS project CABT00000000 data, contig 2.13', NULL, NULL, NULL, NULL, NULL, 4),
(101554, NULL, 'G3DSA:1.20.120.160:FF:000039', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(101555, NULL, 'G3DSA:2.70.150.10:FF:000206', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(101556, NULL, 'G3DSA:3.90.70.80:FF:000089', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101557, NULL, 'G3DSA:1.10.460.10:FF:000023', NULL, NULL, 'DNA topoisomerase 3', NULL, NULL, NULL, NULL, NULL, 4),
(101558, NULL, 'G3DSA:3.40.50.300:FF:002448', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(101559, NULL, 'G3DSA:1.25.40.10:FF:004515', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101560, NULL, 'G3DSA:3.40.140.10:FF:000080', NULL, NULL, 'NPL4-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(101561, NULL, 'G3DSA:2.60.120.260:FF:000508', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(101562, NULL, 'G3DSA:1.10.20.10:FF:000298', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101563, NULL, 'G3DSA:1.20.140.100:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101564, NULL, 'G3DSA:3.30.160.60:FF:004173', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101565, NULL, 'G3DSA:3.30.420.40:FF:000742', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101566, NULL, 'G3DSA:3.40.50.10090:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101567, NULL, 'G3DSA:3.40.50.1260:FF:000048', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(101568, NULL, 'G3DSA:1.10.510.10:FF:004063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101569, NULL, 'G3DSA:1.20.5.1500:FF:000013', NULL, NULL, 'GM16360', NULL, NULL, NULL, NULL, NULL, 4),
(101570, NULL, 'G3DSA:1.20.58.390:FF:000092', NULL, NULL, 'Nicotinic acetylcholine receptor subunit alpha10', NULL, NULL, NULL, NULL, NULL, 4),
(101571, NULL, 'G3DSA:1.10.3720.10:FF:000138', NULL, NULL, 'ABC transporter permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(101572, NULL, 'G3DSA:3.40.50.1820:FF:001868', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101573, NULL, 'G3DSA:3.30.420.10:FF:000295', NULL, NULL, 'Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(101574, NULL, 'G3DSA:3.30.830.10:FF:000213', NULL, NULL, 'Mitochondrial presequence protease', NULL, NULL, NULL, NULL, NULL, 4),
(101575, NULL, 'G3DSA:1.25.40.20:FF:000819', NULL, NULL, 'Protein ACCELERATED CELL DEATH 6', NULL, NULL, NULL, NULL, NULL, 4),
(101576, NULL, 'G3DSA:3.30.200.20:FF:000753', NULL, NULL, 'Serine/Threonine Kinase', NULL, NULL, NULL, NULL, NULL, 4),
(101577, NULL, 'G3DSA:3.40.50.1820:FF:001525', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101578, NULL, 'G3DSA:3.30.230.10:FF:000252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101579, NULL, 'G3DSA:3.40.50.1820:FF:000250', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(101580, NULL, 'G3DSA:1.25.40.10:FF:001761', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g41720', NULL, NULL, NULL, NULL, NULL, 4),
(101581, NULL, 'G3DSA:2.40.70.10:FF:000371', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101582, NULL, 'G3DSA:3.80.10.10:FF:000756', NULL, NULL, 'Rab geranylgeranyl transferase like protein', NULL, NULL, NULL, NULL, NULL, 4),
(101583, NULL, 'G3DSA:3.40.50.11540:FF:000006', NULL, NULL, 'RE33648p', NULL, NULL, NULL, NULL, NULL, 4),
(101584, NULL, 'G3DSA:3.30.450.70:FF:000011', NULL, NULL, 'Trafficking protein particle complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(101585, NULL, 'G3DSA:2.70.70.10:FF:000009', NULL, NULL, 'N-acetyl glucosamine specific PTS system component IIABC', NULL, NULL, NULL, NULL, NULL, 4),
(101586, NULL, 'G3DSA:2.60.40.820:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101587, NULL, 'G3DSA:3.80.10.10:FF:004016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101588, NULL, 'G3DSA:2.30.30.100:FF:000052', NULL, NULL, 'Small nuclear ribonucleoprotein Sm D2', NULL, NULL, NULL, NULL, NULL, 4),
(101589, NULL, 'G3DSA:3.40.1110.10:FF:000471', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101590, NULL, 'G3DSA:1.20.900.10:FF:000004', NULL, NULL, 'Rho guanine nucleotide exchange factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(101591, NULL, 'G3DSA:3.40.50.150:FF:000677', NULL, NULL, 'Methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(101592, NULL, 'G3DSA:3.30.1370.10:FF:000071', NULL, NULL, 'KH domain containing 1 like', NULL, NULL, NULL, NULL, NULL, 4),
(101593, NULL, 'G3DSA:1.25.40.120:FF:000047', NULL, NULL, 'YALI0B16126p', NULL, NULL, NULL, NULL, NULL, 4),
(101594, NULL, 'G3DSA:3.40.50.1000:FF:000212', NULL, NULL, 'Probable phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(101595, NULL, 'G3DSA:4.10.240.10:FF:000192', NULL, NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(101596, NULL, 'G3DSA:2.20.70.10:FF:000079', NULL, NULL, 'FCA gamma protein', NULL, NULL, NULL, NULL, NULL, 4),
(101597, NULL, 'G3DSA:1.10.10.10:FF:000472', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(101598, NULL, 'G3DSA:1.10.8.60:FF:000367', NULL, NULL, 'Spermatogenesis-associated protein 5-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(101599, NULL, 'G3DSA:1.25.40.10:FF:001659', NULL, NULL, 'Activator of G protein Signalling', NULL, NULL, NULL, NULL, NULL, 4),
(101600, NULL, 'G3DSA:2.160.20.80:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101601, NULL, 'G3DSA:2.60.120.290:FF:000040', NULL, NULL, 'Transmembrane serine protease 7', NULL, NULL, NULL, NULL, NULL, 4),
(101602, NULL, 'G3DSA:2.10.250.10:FF:000003', NULL, NULL, 'Calreticulin 3', NULL, NULL, NULL, NULL, NULL, 4),
(101603, NULL, 'G3DSA:2.60.40.10:FF:001559', NULL, NULL, 'Roundabout 1, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(101604, NULL, 'G3DSA:3.40.50.300:FF:006490', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101605, NULL, 'G3DSA:3.30.760.10:FF:000005', NULL, NULL, 'UPF0696 protein C11orf68 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(101606, NULL, 'G3DSA:3.30.160.60:FF:002144', NULL, NULL, 'Zinc finger protein 343', NULL, NULL, NULL, NULL, NULL, 4),
(101607, NULL, 'G3DSA:3.90.230.10:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101608, NULL, 'G3DSA:3.40.50.300:FF:002105', NULL, NULL, 'tRNA dimethylallyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(101609, NULL, 'G3DSA:3.30.70.330:FF:001749', NULL, NULL, 'SC35-like splicing factor 33', NULL, NULL, NULL, NULL, NULL, 4),
(101610, NULL, 'G3DSA:3.40.50.1000:FF:000442', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(101611, NULL, 'G3DSA:3.40.50.2300:FF:001456', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101612, NULL, 'G3DSA:3.30.40.10:FF:001384', NULL, NULL, 'E3 ubiquitin-protein ligase rnf146', NULL, NULL, NULL, NULL, NULL, 4),
(101613, NULL, 'G3DSA:4.10.280.10:FF:000087', NULL, NULL, 'Transcription factor hes-1', NULL, NULL, NULL, NULL, NULL, 4),
(101614, NULL, 'G3DSA:3.40.1110.10:FF:000369', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101615, NULL, 'G3DSA:3.40.50.300:FF:001829', NULL, NULL, 'Nickel import system ATP-binding protein NikE', NULL, NULL, NULL, NULL, NULL, 4),
(101616, NULL, 'G3DSA:3.80.10.10:FF:001942', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase ERECTA', NULL, NULL, NULL, NULL, NULL, 4),
(101617, NULL, 'G3DSA:3.40.50.1820:FF:000587', NULL, NULL, 'Serine carboxypeptidase-like 33', NULL, NULL, NULL, NULL, NULL, 4),
(101618, NULL, 'G3DSA:3.40.50.150:FF:000194', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(101619, NULL, 'G3DSA:3.40.50.11660:FF:000025', NULL, NULL, 'Alpha-(1,3)-fucosyltransferase fut-3', NULL, NULL, NULL, NULL, NULL, 4),
(101620, NULL, 'G3DSA:3.20.20.70:FF:000636', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101621, NULL, 'G3DSA:1.10.510.10:FF:001657', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(101622, NULL, 'G3DSA:1.25.10.10:FF:001933', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(101623, NULL, 'G3DSA:2.40.30.10:FF:000486', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101624, NULL, 'G3DSA:3.30.160.60:FF:002627', NULL, NULL, 'Zinc finger and BTB domain-containing 41', NULL, NULL, NULL, NULL, NULL, 4),
(101625, NULL, 'G3DSA:3.30.565.10:FF:000097', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(101626, NULL, 'G3DSA:2.30.30.140:FF:000148', NULL, NULL, 'Hydrogenase expression/formation protein HupF', NULL, NULL, NULL, NULL, NULL, 4),
(101627, NULL, 'G3DSA:3.90.228.10:FF:000025', NULL, NULL, 'UBA/TS-N domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(101628, NULL, 'G3DSA:3.30.160.60:FF:002705', NULL, NULL, 'Zinc finger protein 732', NULL, NULL, NULL, NULL, NULL, 4),
(101629, NULL, 'G3DSA:3.40.449.10:FF:000010', NULL, NULL, 'Phosphoenolpyruvate carboxykinase [GTP]', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(101630, NULL, 'G3DSA:3.40.1350.10:FF:000022', NULL, NULL, 'Sen15p', NULL, NULL, NULL, NULL, NULL, 4),
(101631, NULL, 'G3DSA:1.10.287.70:FF:000519', NULL, NULL, 'Phosphomevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(101632, NULL, 'G3DSA:3.40.50.1240:FF:000042', NULL, NULL, 'Acid phosphatase aph, 3-phytase phyB', NULL, NULL, NULL, NULL, NULL, 4),
(101633, NULL, 'G3DSA:1.20.1740.10:FF:000058', NULL, NULL, 'Amino Acid Transporter', NULL, NULL, NULL, NULL, NULL, 4),
(101634, NULL, 'G3DSA:1.20.1270.60:FF:000284', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101635, NULL, 'G3DSA:2.70.98.10:FF:000101', NULL, NULL, 'Aldose 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(101636, NULL, 'G3DSA:3.40.50.2000:FF:001029', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101637, NULL, 'G3DSA:1.10.238.10:FF:000113', NULL, NULL, 'Actinin alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(101638, NULL, 'G3DSA:2.60.40.10:FF:005937', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101639, NULL, 'G3DSA:3.40.50.300:FF:000391', NULL, NULL, 'ATP-dependent DNA helicase RecG', NULL, NULL, NULL, NULL, NULL, 4),
(101640, NULL, 'G3DSA:3.40.630.30:FF:000073', NULL, NULL, 'PHD finger family protein', NULL, NULL, NULL, NULL, NULL, 4),
(101641, NULL, 'G3DSA:3.30.160.60:FF:004752', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101642, NULL, 'G3DSA:3.30.70.100:FF:000045', NULL, NULL, 'Rhodanese-like domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(101643, NULL, 'G3DSA:3.40.720.10:FF:000074', NULL, NULL, 'GPI ethanolamine phosphate transferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(101644, NULL, 'G3DSA:1.10.418.10:FF:000099', NULL, NULL, 'Nuclear anchorage protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(101645, NULL, 'G3DSA:3.40.50.1820:FF:001076', NULL, NULL, '2-succinyl-6-hydroxy-2, 4-cyclohexadiene-1-carboxylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(101646, NULL, 'G3DSA:3.40.50.2300:FF:000063', NULL, NULL, 'Gamma-aminobutyric acid type B receptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(101647, NULL, 'G3DSA:1.10.238.10:FF:000905', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 32-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(101648, NULL, 'G3DSA:3.40.50.620:FF:000155', NULL, NULL, 'Glutamine-dependent NAD(+) synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(101649, NULL, 'G3DSA:3.40.50.720:FF:001478', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(101650, NULL, 'G3DSA:3.10.110.10:FF:000074', NULL, NULL, 'ubiquitin-conjugating enzyme E2 D1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(101651, NULL, 'G3DSA:3.30.565.10:FF:000552', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101652, NULL, 'G3DSA:3.90.70.10:FF:000433', NULL, NULL, 'Cysteine protease XCP1', NULL, NULL, NULL, NULL, NULL, 4),
(101653, NULL, 'G3DSA:1.25.40.10:FF:002278', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g40240, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(101654, NULL, 'G3DSA:1.20.1110.10:FF:000269', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101655, NULL, 'G3DSA:3.10.20.90:FF:000042', NULL, NULL, 'Ral guanine nucleotide dissociation stimulator isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(101656, NULL, 'G3DSA:2.60.260.20:FF:000130', NULL, NULL, 'Chaperone protein DNAj, putative', NULL, NULL, NULL, NULL, NULL, 4),
(101657, NULL, 'G3DSA:3.40.1350.60:FF:000008', NULL, NULL, 'Sugar fermentation stimulation protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(101658, NULL, 'G3DSA:2.60.40.1230:FF:000024', NULL, NULL, 'Probable ADP-ribosylation factor-binding protein C25H2.16c', NULL, NULL, NULL, NULL, NULL, 4),
(101659, NULL, 'G3DSA:3.30.160.60:FF:004622', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101660, NULL, 'G3DSA:3.40.50.720:FF:001039', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(101661, NULL, 'G3DSA:3.30.559.70:FF:000027', NULL, NULL, 'carnitine O-palmitoyltransferase 1, liver isoform', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(101662, NULL, 'G3DSA:4.10.60.10:FF:000232', NULL, NULL, 'CCHC-type zinc finger nucleic acid-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(101663, NULL, 'G3DSA:3.20.20.70:FF:000075', NULL, NULL, 'Tryptophan biosynthesis protein TRP1', NULL, NULL, NULL, NULL, NULL, 4),
(101664, NULL, 'G3DSA:2.10.60.10:FF:000017', NULL, NULL, 'Ly6/PLAUR domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(101665, NULL, 'G3DSA:3.30.70.330:FF:001406', NULL, NULL, 'AT27578p', NULL, NULL, NULL, NULL, NULL, 4),
(101666, NULL, 'G3DSA:3.40.50.300:FF:004443', NULL, NULL, 'ATPase YjeE, predicted to have essential role in cell wall biosynthesis', NULL, NULL, NULL, NULL, NULL, 4),
(101667, NULL, 'G3DSA:3.90.226.10:FF:000060', NULL, NULL, 'Propionyl-CoA carboxylase subunit beta 6', NULL, NULL, NULL, NULL, NULL, 4),
(101668, NULL, 'G3DSA:2.60.40.10:FF:005241', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101669, NULL, 'G3DSA:3.30.70.330:FF:002025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101670, NULL, 'G3DSA:3.30.1890.10:FF:000008', NULL, NULL, 'O-antigen chain length regulator', NULL, NULL, NULL, NULL, NULL, 4),
(101671, NULL, 'G3DSA:3.40.1280.10:FF:000027', NULL, NULL, 'Putative tRNA/rRNA methyltransferase YsgA', NULL, NULL, NULL, NULL, NULL, 4),
(101672, NULL, 'G3DSA:2.60.40.10:FF:004965', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101673, NULL, 'G3DSA:2.40.50.140:FF:000886', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101674, NULL, 'G3DSA:3.30.870.10:FF:000126', NULL, NULL, 'YALI0D07590p', NULL, NULL, NULL, NULL, NULL, 4),
(101675, NULL, 'G3DSA:2.120.10.80:FF:000395', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101676, NULL, 'G3DSA:2.60.40.1820:FF:000004', NULL, NULL, 'Harpin-induced protein', NULL, NULL, NULL, NULL, NULL, 4),
(101677, NULL, 'G3DSA:1.25.40.10:FF:003790', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101678, NULL, 'G3DSA:1.20.1070.10:FF:001951', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101679, NULL, 'G3DSA:3.10.120.10:FF:000029', NULL, NULL, 'AGAP011823-PA', NULL, NULL, NULL, NULL, NULL, 4),
(101680, NULL, 'G3DSA:1.10.150.60:FF:000025', NULL, NULL, 'Arid/bright DNA binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(101681, NULL, 'G3DSA:3.30.1490.190:FF:000012', NULL, NULL, 'Ferric uptake regulator family protein', NULL, NULL, NULL, NULL, NULL, 4),
(101682, NULL, 'G3DSA:1.20.58.390:FF:000120', NULL, NULL, '5-hydroxytryptamine receptor 3A', NULL, NULL, NULL, NULL, NULL, 4),
(101683, NULL, 'G3DSA:1.10.730.20:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101684, NULL, 'G3DSA:3.40.50.300:FF:000520', NULL, NULL, 'probable ATP-dependent RNA helicase DDX23', NULL, NULL, NULL, NULL, NULL, 4),
(101685, NULL, 'G3DSA:3.10.110.10:FF:000287', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 G1', NULL, NULL, NULL, NULL, NULL, 4),
(101686, NULL, 'G3DSA:1.10.10.10:FF:001865', NULL, NULL, 'Mu phage transposase OrfA TnpA_MuSo2', NULL, NULL, NULL, NULL, NULL, 4),
(101687, NULL, 'G3DSA:3.90.190.10:FF:000257', NULL, NULL, 'Map kinase phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(101688, NULL, 'G3DSA:1.10.8.10:FF:000364', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101689, NULL, 'G3DSA:2.30.230.10:FF:000008', NULL, NULL, 'Vitellogenin-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(101690, NULL, 'G3DSA:1.10.8.10:FF:000021', NULL, NULL, 'DCN1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(101691, NULL, 'G3DSA:1.10.30.10:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101692, NULL, 'G3DSA:3.40.50.2000:FF:000203', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(101693, NULL, 'G3DSA:1.20.920.20:FF:000003', NULL, NULL, 'Dynein axonemal heavy chain 17', NULL, NULL, NULL, NULL, NULL, 4),
(101694, NULL, 'G3DSA:3.80.10.10:FF:004359', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101695, NULL, 'G3DSA:3.30.60.30:FF:000216', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(101696, NULL, 'G3DSA:2.60.40.60:FF:000815', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(101697, NULL, 'G3DSA:3.30.300.30:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101698, NULL, 'G3DSA:3.40.50.1010:FF:000119', NULL, NULL, 'Family with sequence similarity 120B', NULL, NULL, NULL, NULL, NULL, 4),
(101699, NULL, 'G3DSA:3.40.50.300:FF:005854', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101700, NULL, 'G3DSA:2.10.25.10:FF:001616', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101701, NULL, 'G3DSA:3.40.50.11260:FF:000012', NULL, NULL, 'Heat shock protein 90, putative', NULL, NULL, NULL, NULL, NULL, 4),
(101702, NULL, 'G3DSA:1.20.1310.10:FF:000138', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101703, NULL, 'G3DSA:3.40.50.880:FF:000216', NULL, NULL, 'Glutamine amidotransferase class-I', NULL, NULL, NULL, NULL, NULL, 4),
(101704, NULL, 'G3DSA:1.25.40.10:FF:004532', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101705, NULL, 'G3DSA:3.40.50.300:FF:003954', NULL, NULL, 'Protein serine/threonine kinase PrkA', NULL, NULL, NULL, NULL, NULL, 4),
(101706, NULL, 'G3DSA:1.20.144.10:FF:000056', NULL, NULL, 'AGAP001941-PA', NULL, NULL, NULL, NULL, NULL, 4),
(101707, NULL, 'G3DSA:3.30.160.60:FF:000570', NULL, NULL, 'Spalt like transcription factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(101708, NULL, 'G3DSA:1.10.510.10:FF:000477', NULL, NULL, 'Receptor protein kinase CRINKLY4', NULL, NULL, NULL, NULL, NULL, 4),
(101709, NULL, 'G3DSA:3.30.505.10:FF:000093', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(101710, NULL, 'G3DSA:3.30.200.20:FF:002327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101711, NULL, 'G3DSA:1.20.58.630:FF:000001', NULL, NULL, 'Diaphanous related formin 1', NULL, NULL, NULL, NULL, NULL, 4),
(101712, NULL, 'G3DSA:3.40.30.10:FF:001153', NULL, NULL, 'Glutathione S-transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(101713, NULL, 'G3DSA:3.30.160.60:FF:004965', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101714, NULL, 'G3DSA:3.40.1170.10:FF:000036', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(101715, NULL, 'G3DSA:1.25.40.450:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101716, NULL, 'G3DSA:4.10.400.10:FF:000305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101717, NULL, 'G3DSA:1.10.510.10:FF:002163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101718, NULL, 'G3DSA:3.30.70.330:FF:001619', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101719, NULL, 'G3DSA:1.20.1070.10:FF:002108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101720, NULL, 'G3DSA:2.40.155.10:FF:000005', NULL, NULL, 'NIDogen (Basement membrane protein)', NULL, NULL, NULL, NULL, NULL, 4),
(101721, NULL, 'G3DSA:3.30.1360.120:FF:000103', NULL, NULL, 'Glr1472 protein', NULL, NULL, NULL, NULL, NULL, 4),
(101722, NULL, 'G3DSA:1.25.40.10:FF:005021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101723, NULL, 'G3DSA:1.10.510.10:FF:001887', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101724, NULL, 'G3DSA:1.10.600.10:FF:000012', NULL, NULL, 'Squalene synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(101725, NULL, 'G3DSA:2.60.40.1170:FF:000096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101726, NULL, 'G3DSA:3.40.30.10:FF:000208', NULL, NULL, 'glutathione S-transferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(101727, NULL, 'G3DSA:3.10.100.10:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101728, NULL, 'G3DSA:2.30.39.10:FF:000079', NULL, NULL, 'Serine protease inhibitor 27A', NULL, NULL, NULL, NULL, NULL, 4),
(101729, NULL, 'G3DSA:3.90.280.10:FF:000005', NULL, NULL, 'Phage kinase inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(101730, NULL, 'G3DSA:1.20.1060.10:FF:000028', NULL, NULL, 'DNA polymerase theta-like Protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(101731, NULL, 'G3DSA:1.10.441.10:FF:000001', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(101732, NULL, 'G3DSA:2.130.10.10:FF:002594', NULL, NULL, 'F-box/WD repeat-containing protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(101733, NULL, 'G3DSA:1.10.510.10:FF:000701', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(101734, NULL, 'G3DSA:1.10.287.370:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101735, NULL, 'G3DSA:2.30.30.100:FF:000035', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm8', NULL, NULL, NULL, NULL, NULL, 4),
(101736, NULL, 'G3DSA:3.40.120.10:FF:000096', NULL, NULL, 'Phosphoacetylglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(101737, NULL, 'G3DSA:3.30.160.60:FF:005241', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101738, NULL, 'G3DSA:3.30.70.20:FF:000141', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101739, NULL, 'G3DSA:3.10.100.10:FF:000359', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101740, NULL, 'G3DSA:2.40.10.10:FF:000474', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101741, NULL, 'G3DSA:4.10.520.10:FF:000011', NULL, NULL, 'Bacterial histone-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(101742, NULL, 'G3DSA:3.40.190.10:FF:000611', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(101743, NULL, 'G3DSA:3.90.440.10:FF:000007', NULL, NULL, 'Nitric oxide synthase oxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(101744, NULL, 'G3DSA:3.40.50.1000:FF:000572', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101745, NULL, 'G3DSA:2.60.40.10:FF:006090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101746, NULL, 'G3DSA:3.40.50.720:FF:000859', NULL, NULL, 'Calcium-activated potassium channel subunit alpha-1', NULL, NULL, NULL, NULL, NULL, 4),
(101747, NULL, 'G3DSA:2.115.10.20:FF:000002', NULL, NULL, 'Invertase 2', NULL, NULL, NULL, NULL, NULL, 4),
(101748, NULL, 'G3DSA:3.90.70.10:FF:000563', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101749, NULL, 'G3DSA:3.30.750.24:FF:000147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101750, NULL, 'G3DSA:3.30.720.10:FF:000008', NULL, NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(101751, NULL, 'G3DSA:2.60.40.10:FF:003004', NULL, NULL, 'AGAP003656-PC', NULL, NULL, NULL, NULL, NULL, 4),
(101752, NULL, 'G3DSA:3.40.50.300:FF:002318', NULL, NULL, 'ADP-ribosylation factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(101753, NULL, 'G3DSA:3.30.1780.10:FF:000017', NULL, NULL, 'YALI0C02343p', NULL, NULL, NULL, NULL, NULL, 4),
(101754, NULL, 'G3DSA:1.25.40.20:FF:001207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101755, NULL, 'G3DSA:3.30.420.40:FF:000079', NULL, NULL, 'ROK family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(101756, NULL, 'G3DSA:3.90.550.10:FF:000448', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101757, NULL, 'G3DSA:2.60.120.650:FF:000182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101758, NULL, 'G3DSA:3.30.30.30:FF:000052', NULL, NULL, 'Heat shock 70 kDa protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(101759, NULL, 'G3DSA:3.60.10.10:FF:000358', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101760, NULL, 'G3DSA:1.20.1070.10:FF:001720', NULL, NULL, 'Melanin-concentrating hormone receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(101761, NULL, 'G3DSA:2.60.120.590:FF:000040', NULL, NULL, 'Alpha-ketoglutarate-dependent dioxygenase alkB', NULL, NULL, NULL, NULL, NULL, 4),
(101762, NULL, 'G3DSA:3.30.70.330:FF:000097', NULL, NULL, 'U2 snRNP auxiliary factor large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(101763, NULL, 'G3DSA:2.60.40.10:FF:002386', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(101764, NULL, 'G3DSA:3.30.700.10:FF:000013', NULL, NULL, 'MSHA minor pilin protein MshB', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(101765, NULL, 'G3DSA:3.40.50.10110:FF:000004', NULL, NULL, 'DNA polymerase III, chi subunit', NULL, NULL, NULL, NULL, NULL, 4),
(101766, NULL, 'G3DSA:3.30.160.60:FF:001879', NULL, NULL, 'General transcription factor IIIA', NULL, NULL, NULL, NULL, NULL, 4),
(101767, NULL, 'G3DSA:3.30.830.10:FF:000101', NULL, NULL, 'Zn-dependent peptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(101768, NULL, 'G3DSA:3.40.50.300:FF:005511', NULL, NULL, 'U3 small nucleolar RNA-associated protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(101769, NULL, 'G3DSA:3.10.180.20:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101770, NULL, 'G3DSA:3.20.20.70:FF:000283', NULL, NULL, 'Isopentenyl-diphosphate delta-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(101771, NULL, 'G3DSA:2.40.50.140:FF:000543', NULL, NULL, 'Replication factor A', NULL, NULL, NULL, NULL, NULL, 4),
(101772, NULL, 'G3DSA:3.30.160.60:FF:005584', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101773, NULL, 'G3DSA:3.40.50.620:FF:000610', NULL, NULL, 'Glutaminyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(101774, NULL, 'G3DSA:3.90.1420.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101775, NULL, 'G3DSA:1.25.10.10:FF:000073', NULL, NULL, 'Splicing factor 3b, subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(101776, NULL, 'G3DSA:3.30.300.10:FF:000016', NULL, NULL, 'S-adenosylmethionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(101777, NULL, 'G3DSA:1.10.1410.10:FF:000018', NULL, NULL, 'Terminal uridylyltransferase cid1', NULL, NULL, NULL, NULL, NULL, 4),
(101778, NULL, 'G3DSA:3.50.50.60:FF:000999', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101779, NULL, 'G3DSA:3.30.70.1730:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101780, NULL, 'G3DSA:3.30.360.10:FF:000025', NULL, NULL, 'Glucose-fructose oxidoreductase domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(101781, NULL, 'G3DSA:2.40.50.100:FF:000110', NULL, NULL, 'Putative multidrug resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(101782, NULL, 'G3DSA:3.40.50.300:FF:000177', NULL, NULL, 'Rho-related BTB domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(101783, NULL, 'G3DSA:3.80.10.10:FF:003050', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101784, NULL, 'G3DSA:1.10.220.100:FF:000001', NULL, NULL, 'Enhancer of mRNA-decapping protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(101785, NULL, 'G3DSA:3.30.70.1660:FF:000013', NULL, NULL, 'Peptide chain release factor 1-like, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(101786, NULL, 'G3DSA:2.30.29.30:FF:001085', NULL, NULL, 'NeCAP (NECAP) endocytosis associated protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(101787, NULL, 'G3DSA:2.30.30.40:FF:000540', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(101788, NULL, 'G3DSA:3.90.190.10:FF:000465', NULL, NULL, 'Phosphatidylinositol 3,4,5-trisphosphate 3-phosphatase ptn1', NULL, NULL, NULL, NULL, NULL, 4),
(101789, NULL, 'G3DSA:1.25.40.10:FF:002250', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(101790, NULL, 'G3DSA:2.60.40.10:FF:005033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101791, NULL, 'G3DSA:3.90.660.20:FF:000004', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(101792, NULL, 'G3DSA:2.120.10.30:FF:000532', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101793, NULL, 'G3DSA:3.30.1360.10:FF:000025', NULL, NULL, 'Probable DNA-directed RNA polymerases I and III subunit RPAC2', NULL, NULL, NULL, NULL, NULL, 4),
(101794, NULL, 'G3DSA:2.130.10.10:FF:003448', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101795, NULL, 'G3DSA:3.90.180.10:FF:000060', NULL, NULL, 'Crystallin zeta like 1', NULL, NULL, NULL, NULL, NULL, 4),
(101796, NULL, 'G3DSA:3.90.226.10:FF:000291', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(101797, NULL, 'G3DSA:3.40.630.30:FF:000623', NULL, NULL, 'Acetyltransferase, GNAT family protein', NULL, NULL, NULL, NULL, NULL, 4),
(101798, NULL, 'G3DSA:3.80.10.10:FF:000301', NULL, NULL, 'leucine-rich repeat neuronal protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(101799, NULL, 'G3DSA:3.10.20.90:FF:000480', NULL, NULL, 'Tubulin-binding cofactor B', NULL, NULL, NULL, NULL, NULL, 4),
(101800, NULL, 'G3DSA:3.55.50.30:FF:000025', NULL, NULL, 'Fec operon regulator FecR', NULL, NULL, NULL, NULL, NULL, 4),
(101801, NULL, 'G3DSA:2.60.200.20:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101802, NULL, 'G3DSA:2.30.30.1020:FF:000024', NULL, NULL, 'GM25089', NULL, NULL, NULL, NULL, NULL, 4),
(101803, NULL, 'G3DSA:2.130.10.10:FF:004067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101804, NULL, 'G3DSA:3.40.50.10440:FF:000002', NULL, NULL, 'Dihydroxyacetone kinase', NULL, NULL, NULL, NULL, NULL, 4),
(101805, NULL, 'G3DSA:1.10.1520.10:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101806, NULL, 'G3DSA:3.40.50.10260:FF:000021', NULL, NULL, 'Bifunctional NAD(P)H-hydrate repair enzyme Nnr', NULL, NULL, NULL, NULL, NULL, 4),
(101807, NULL, 'G3DSA:1.10.238.10:FF:000664', NULL, NULL, 'Calmodulin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(101808, NULL, 'G3DSA:3.40.50.300:FF:001133', NULL, NULL, 'UMP-CMP kinase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(101809, NULL, 'G3DSA:1.10.1580.10:FF:000019', NULL, NULL, 'Nucleolar GTP-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(101810, NULL, 'G3DSA:1.10.840.10:FF:000018', NULL, NULL, 'Rap guanine nucleotide exchange factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(101811, NULL, 'G3DSA:3.90.70.10:FF:000220', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase cyk-3', NULL, NULL, NULL, NULL, NULL, 4),
(101812, NULL, 'G3DSA:3.40.50.300:FF:006708', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101813, NULL, 'G3DSA:2.60.120.970:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101814, NULL, 'G3DSA:2.120.10.80:FF:000052', NULL, NULL, 'Multiple epidermal growth factor-like domains 8', NULL, NULL, NULL, NULL, NULL, 4),
(101815, NULL, 'G3DSA:3.30.40.10:FF:000226', NULL, NULL, 'E3 ubiquitin ligase BIG BROTHER', NULL, NULL, NULL, NULL, NULL, 4),
(101816, NULL, 'G3DSA:3.50.50.60:FF:000095', NULL, NULL, 'apoptosis-inducing factor 1, mitochondrial isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(101817, NULL, 'G3DSA:2.170.150.10:FF:000003', NULL, NULL, 'Translationally-controlled tumor protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(101818, NULL, 'G3DSA:3.40.50.150:FF:000222', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(101819, NULL, 'G3DSA:1.20.1060.20:FF:000014', NULL, NULL, 'Structural maintenance of chromosomes protein', NULL, NULL, NULL, NULL, NULL, 4),
(101820, NULL, 'G3DSA:1.10.3130.10:FF:000003', NULL, NULL, 'Serine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(101821, NULL, 'G3DSA:3.40.50.1000:FF:000004', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(101822, NULL, 'G3DSA:1.20.960.40:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101823, NULL, 'G3DSA:3.40.50.720:FF:000865', NULL, NULL, 'NEDD8-activating enzyme E1 catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(101824, NULL, 'G3DSA:1.10.8.60:FF:000463', NULL, NULL, 'Replication-associated recombination protein A', NULL, NULL, NULL, NULL, NULL, 4),
(101825, NULL, 'G3DSA:2.40.30.270:FF:000022', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(101826, NULL, 'G3DSA:3.90.740.10:FF:000041', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(101827, NULL, 'G3DSA:3.30.70.1990:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101828, NULL, 'G3DSA:2.170.270.10:FF:000051', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-9 specific SUVH6', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(101829, NULL, 'G3DSA:3.40.50.1820:FF:001317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101830, NULL, 'G3DSA:3.80.10.10:FF:001493', NULL, NULL, 'Phytosulfokine receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(101831, NULL, 'G3DSA:3.40.50.280:FF:000002', NULL, NULL, 'Methylmalonyl-CoA mutase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(101832, NULL, 'G3DSA:3.80.10.10:FF:002431', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101833, NULL, 'G3DSA:1.10.220.160:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101834, NULL, 'G3DSA:2.130.10.10:FF:004168', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101835, NULL, 'G3DSA:3.80.10.10:FF:000969', NULL, NULL, 'Leucine-rich repeat protein soc-2', NULL, NULL, NULL, NULL, NULL, 4),
(101836, NULL, 'G3DSA:3.60.40.10:FF:000186', NULL, NULL, 'Protein Phosphatase, Mg2+/Mn2+ dependent', NULL, NULL, NULL, NULL, NULL, 4),
(101837, NULL, 'G3DSA:1.25.40.10:FF:003447', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(101838, NULL, 'G3DSA:2.60.120.200:FF:000766', NULL, NULL, 'Perlecan', NULL, NULL, NULL, NULL, NULL, 4),
(101839, NULL, 'G3DSA:2.60.40.2030:FF:000039', NULL, NULL, 'Adhesion G protein-coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(101840, NULL, 'G3DSA:3.40.30.10:FF:001265', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101841, NULL, 'G3DSA:3.80.10.10:FF:003954', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101842, NULL, 'G3DSA:1.10.1070.11:FF:000015', NULL, NULL, 'Serine/threonine-protein kinase ATM', NULL, NULL, NULL, NULL, NULL, 4),
(101843, NULL, 'G3DSA:3.30.870.10:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101844, NULL, 'G3DSA:1.10.472.10:FF:000584', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101845, NULL, 'G3DSA:3.40.50.10810:FF:000231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101846, NULL, 'G3DSA:1.10.287.110:FF:000138', NULL, NULL, 'DNAJ heat shock family protein', NULL, NULL, NULL, NULL, NULL, 4),
(101847, NULL, 'G3DSA:1.10.620.20:FF:000016', NULL, NULL, 'Phenol hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(101848, NULL, 'G3DSA:2.130.10.10:FF:005578', NULL, NULL, 'Vacuolar protein sorting/targeting protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(101849, NULL, 'G3DSA:4.10.400.10:FF:000176', NULL, NULL, 'CG32637-PA protein', NULL, NULL, NULL, NULL, NULL, 4),
(101850, NULL, 'G3DSA:3.40.50.150:FF:001846', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101851, NULL, 'G3DSA:2.40.10.10:FF:000131', NULL, NULL, 'Protease Do-like 9', NULL, NULL, NULL, NULL, NULL, 4),
(101852, NULL, 'G3DSA:3.30.890.10:FF:000009', NULL, NULL, 'Methyl-CpG binding domain protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(101853, NULL, 'G3DSA:1.10.510.10:FF:001202', NULL, NULL, 'Kinase suppressor of ras 1', NULL, NULL, NULL, NULL, NULL, 4),
(101854, NULL, 'G3DSA:1.10.420.10:FF:000026', NULL, NULL, 'Catalase/peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(101855, NULL, 'G3DSA:1.20.1110.10:FF:000241', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101856, NULL, 'G3DSA:1.25.40.10:FF:002727', NULL, NULL, 'Coatomer subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(101857, NULL, 'G3DSA:3.30.70.330:FF:000310', NULL, NULL, 'RNA recognition water-stress protein1', NULL, NULL, NULL, NULL, NULL, 4),
(101858, NULL, 'G3DSA:2.60.40.10:FF:004527', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101859, NULL, 'G3DSA:2.30.42.10:FF:000452', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101860, NULL, 'G3DSA:2.60.40.10:FF:003796', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101861, NULL, 'G3DSA:3.30.160.60:FF:003116', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101862, NULL, 'G3DSA:1.10.565.10:FF:000064', NULL, NULL, 'Coup-like 2 transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(101863, NULL, 'G3DSA:3.30.1010.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(101864, NULL, 'G3DSA:1.20.940.10:FF:000001', NULL, NULL, 'Protein transport protein Sec31A isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(101865, NULL, 'G3DSA:1.10.3210.10:FF:000043', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(101866, NULL, 'G3DSA:2.130.10.10:FF:005005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101867, NULL, 'G3DSA:3.10.250.10:FF:000134', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101868, NULL, 'G3DSA:1.10.287.110:FF:000470', NULL, NULL, 'DNaJ domain (Prokaryotic heat shock protein)', NULL, NULL, NULL, NULL, NULL, 4),
(101869, NULL, 'G3DSA:1.10.437.10:FF:000019', NULL, NULL, 'Apoptosis facilitator Bcl-2-like protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(101870, NULL, 'G3DSA:3.30.160.60:FF:000469', NULL, NULL, 'Zinc finger protein 423', NULL, NULL, NULL, NULL, NULL, 4),
(101871, NULL, 'G3DSA:2.30.30.40:FF:000332', NULL, NULL, 'Caspase recruitment domain family, member 11', NULL, NULL, NULL, NULL, NULL, 4),
(101872, NULL, 'G3DSA:2.60.40.10:FF:002178', NULL, NULL, 'Mesocentin', NULL, NULL, NULL, NULL, NULL, 4),
(101873, NULL, 'G3DSA:3.30.200.20:FF:001821', NULL, NULL, 'AGAP006872-PA', NULL, NULL, NULL, NULL, NULL, 4),
(101874, NULL, 'G3DSA:3.40.50.300:FF:003162', NULL, NULL, 'EMB1135', NULL, NULL, NULL, NULL, NULL, 4),
(101875, NULL, 'G3DSA:1.10.10.60:FF:000211', NULL, NULL, 'Homeobox and leucine zipper protein Homez', NULL, NULL, NULL, NULL, NULL, 4),
(101876, NULL, 'G3DSA:1.20.1070.10:FF:000310', NULL, NULL, '5-hydroxytryptamine receptor 2B', NULL, NULL, NULL, NULL, NULL, 4),
(101877, NULL, 'G3DSA:3.30.1560.10:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101878, NULL, 'G3DSA:1.25.10.10:FF:000281', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(101879, NULL, 'G3DSA:2.60.40.60:FF:000366', NULL, NULL, 'Proto-oncogene tyrosine-protein kinase receptor Ret', NULL, NULL, NULL, NULL, NULL, 4),
(101880, NULL, 'G3DSA:3.30.160.270:FF:000003', NULL, NULL, '2-isopropylmalate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(101881, NULL, 'G3DSA:2.130.10.10:FF:002251', NULL, NULL, 'Nuclear pore complex protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(101882, NULL, 'G3DSA:3.40.50.300:FF:003050', NULL, NULL, 'AAA protein', NULL, NULL, NULL, NULL, NULL, 4),
(101883, NULL, 'G3DSA:1.10.400.10:FF:000013', NULL, NULL, 'Extra-large guanine nucleotide-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(101884, NULL, 'G3DSA:2.130.10.130:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101885, NULL, 'G3DSA:3.40.190.10:FF:000162', NULL, NULL, 'Amino acid ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(101886, NULL, 'G3DSA:1.20.1250.20:FF:001597', NULL, NULL, 'YALI0A07447p', NULL, NULL, NULL, NULL, NULL, 4),
(101887, NULL, 'G3DSA:1.10.472.10:FF:000483', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101888, NULL, 'G3DSA:2.40.50.140:FF:001263', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101889, NULL, 'G3DSA:3.90.480.10:FF:000004', NULL, NULL, 'Sulfite reductase hemoprotein beta component (CysI)', NULL, NULL, NULL, NULL, NULL, 4),
(101890, NULL, 'G3DSA:3.80.10.10:FF:001711', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', NULL, NULL, NULL, NULL, NULL, 4),
(101891, NULL, 'G3DSA:1.20.142.10:FF:000006', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(101892, NULL, 'G3DSA:2.60.40.10:FF:003690', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101893, NULL, 'G3DSA:3.40.50.720:FF:000067', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(101894, NULL, 'G3DSA:3.30.1680.10:FF:000072', NULL, NULL, 'Plexin C1', NULL, NULL, NULL, NULL, NULL, 4),
(101895, NULL, 'G3DSA:2.40.37.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101896, NULL, 'G3DSA:3.30.230.70:FF:000112', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101897, NULL, 'G3DSA:3.30.565.10:FF:000422', NULL, NULL, 'Histidine kinase sensor protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(101898, NULL, 'G3DSA:3.40.50.2300:FF:000304', NULL, NULL, 'Two-component system response regulator MprA', NULL, NULL, NULL, NULL, NULL, 4),
(101899, NULL, 'G3DSA:2.40.50.40:FF:000024', NULL, NULL, 'C-C motif chemokine 21', NULL, NULL, NULL, NULL, NULL, 4),
(101900, NULL, 'G3DSA:3.90.79.10:FF:000077', NULL, NULL, 'ADP-ribose pyrophosphatase, NudF', NULL, NULL, NULL, NULL, NULL, 4),
(101901, NULL, 'G3DSA:3.30.540.10:FF:000011', NULL, NULL, 'Bisphosphate nucleotidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(101902, NULL, 'G3DSA:2.130.10.10:FF:003875', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101903, NULL, 'G3DSA:2.40.70.10:FF:000140', NULL, NULL, 'Os01g0696800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(101904, NULL, 'G3DSA:3.40.50.300:FF:004674', NULL, NULL, 'GD13761', NULL, NULL, NULL, NULL, NULL, 4),
(101905, NULL, 'G3DSA:1.10.579.10:FF:000017', NULL, NULL, 'CPD photolyase type II', NULL, NULL, NULL, NULL, NULL, 4),
(101906, NULL, 'G3DSA:3.20.110.10:FF:000021', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(101907, NULL, 'G3DSA:2.60.40.150:FF:000517', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101908, NULL, 'G3DSA:3.40.50.300:FF:004786', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(101909, NULL, 'G3DSA:1.10.20.10:FF:000270', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101910, NULL, 'G3DSA:2.130.10.10:FF:000222', NULL, NULL, 'Bromodomain and WD repeat domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(101911, NULL, 'G3DSA:3.30.70.100:FF:000146', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101912, NULL, 'G3DSA:3.30.1960.10:FF:000003', NULL, NULL, 'tRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(101913, NULL, 'G3DSA:2.60.40.10:FF:002739', NULL, NULL, 'Filamin 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(101914, NULL, 'G3DSA:2.60.210.10:FF:000080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101915, NULL, 'G3DSA:3.90.70.10:FF:000332', NULL, NULL, 'Cathepsin L1', NULL, NULL, NULL, NULL, NULL, 4),
(101916, NULL, 'G3DSA:1.10.8.60:FF:000575', NULL, NULL, 'ATPase, AAA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(101917, NULL, 'G3DSA:1.25.40.420:FF:000013', NULL, NULL, 'germ cell-less protein-like 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(101918, NULL, 'G3DSA:3.40.47.10:FF:000275', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101919, NULL, 'G3DSA:3.60.15.10:FF:000228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101920, NULL, 'G3DSA:1.20.1280.50:FF:000236', NULL, NULL, 'F-box/LRR-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(101921, NULL, 'G3DSA:3.30.540.30:FF:000017', NULL, NULL, 'Dipeptidyl peptidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(101922, NULL, 'G3DSA:1.20.1250.20:FF:001709', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101923, NULL, 'G3DSA:3.40.50.720:FF:002107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101924, NULL, 'G3DSA:1.10.1520.10:FF:000010', NULL, NULL, '39S ribosomal protein L44, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(101925, NULL, 'G3DSA:3.20.20.80:FF:000061', NULL, NULL, '4F2 cell-surface antigen heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(101926, NULL, 'G3DSA:1.10.510.10:FF:004304', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101927, NULL, 'G3DSA:3.40.630.30:FF:000522', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101928, NULL, 'G3DSA:3.40.50.300:FF:008384', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101929, NULL, 'G3DSA:3.60.21.10:FF:000164', NULL, NULL, 'Acid sphingomyelin phosphodiesterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(101930, NULL, 'G3DSA:3.40.640.10:FF:000005', NULL, NULL, 'Glycine dehydrogenase (decarboxylating), mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(101931, NULL, 'G3DSA:1.20.58.70:FF:000037', NULL, NULL, 'Putative QA-SNARE protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(101932, NULL, 'G3DSA:1.10.10.60:FF:000666', NULL, NULL, 'HD-ZIP IV family of homeobox-leucine zipper protein with lipid-binding START domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(101933, NULL, 'G3DSA:3.50.50.60:FF:000331', NULL, NULL, 'FAD/NAD(P)-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(101934, NULL, 'G3DSA:2.60.200.10:FF:000034', NULL, NULL, 'Interferon regulatory factor like protein', NULL, NULL, NULL, NULL, NULL, 4),
(101935, NULL, 'G3DSA:1.10.510.10:FF:002394', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101936, NULL, 'G3DSA:3.30.450.20:FF:000120', NULL, NULL, 'PAS domain S-box protein', NULL, NULL, NULL, NULL, NULL, 4),
(101937, NULL, 'G3DSA:3.40.50.1240:FF:000172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101938, NULL, 'G3DSA:3.60.21.60:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101939, NULL, 'G3DSA:1.50.40.10:FF:000286', NULL, NULL, 'AT13149p', NULL, NULL, NULL, NULL, NULL, 4),
(101940, NULL, 'G3DSA:2.60.40.10:FF:003908', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101941, NULL, 'G3DSA:2.10.220.10:FF:000164', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5a', NULL, NULL, NULL, NULL, NULL, 4),
(101942, NULL, 'G3DSA:2.60.120.330:FF:000092', NULL, NULL, 'Os02g0320800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(101943, NULL, 'G3DSA:1.20.5.370:FF:000002', NULL, NULL, 'Myosin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(101944, NULL, 'G3DSA:3.30.160.60:FF:002711', NULL, NULL, 'Zinc finger protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(101945, NULL, 'G3DSA:1.10.510.10:FF:003231', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101946, NULL, 'G3DSA:1.10.8.720:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101947, NULL, 'G3DSA:1.20.1420.30:FF:000006', NULL, NULL, 'sodium/potassium/calcium exchanger 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(101948, NULL, 'G3DSA:1.10.720.30:FF:000072', NULL, NULL, 'ATP-dependent DNA helicase II subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(101949, NULL, 'G3DSA:3.30.830.10:FF:000090', NULL, NULL, 'Probable zinc protease PqqL', NULL, NULL, NULL, NULL, NULL, 4),
(101950, NULL, 'G3DSA:1.10.510.10:FF:004428', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101951, NULL, 'G3DSA:3.30.1120.30:FF:000030', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(101952, NULL, 'G3DSA:1.10.10.10:FF:000680', NULL, NULL, 'Rrf2 family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(101953, NULL, 'G3DSA:1.10.238.10:FF:000456', NULL, NULL, 'Calcium-binding mitochondrial carrier protein SCaMC-2 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(101954, NULL, 'G3DSA:1.10.10.10:FF:000342', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(101955, NULL, 'G3DSA:3.40.800.10:FF:000007', NULL, NULL, 'Arginase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(101956, NULL, 'G3DSA:3.30.160.60:FF:002835', NULL, NULL, 'zinc finger protein 384 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(101957, NULL, 'G3DSA:2.130.10.10:FF:003780', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101958, NULL, 'G3DSA:3.90.780.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101959, NULL, 'G3DSA:3.40.50.10190:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101960, NULL, 'G3DSA:1.20.120.1910:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101961, NULL, 'G3DSA:3.30.200.20:FF:000062', NULL, NULL, 'PHO system negative regulator', NULL, NULL, NULL, NULL, NULL, 4),
(101962, NULL, 'G3DSA:3.30.260.10:FF:000080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(101963, NULL, 'G3DSA:1.25.40.10:FF:003346', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g16860', NULL, NULL, NULL, NULL, NULL, 4),
(101964, NULL, 'G3DSA:1.20.1080.10:FF:000024', NULL, NULL, 'MIP aquaporin (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(101965, NULL, 'G3DSA:1.10.1760.10:FF:000005', NULL, NULL, 'Actin-related protein 2/3 complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(101966, NULL, 'G3DSA:3.40.50.300:FF:008260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101967, NULL, 'G3DSA:3.30.450.20:FF:000693', NULL, NULL, 'Diguanylate cyclase with PAS sensory domain', NULL, NULL, NULL, NULL, NULL, 4),
(101968, NULL, 'G3DSA:3.30.40.10:FF:001755', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(101969, NULL, 'G3DSA:1.25.40.570:FF:000030', NULL, NULL, 'COP9 signalosome complex subunit 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(101970, NULL, 'G3DSA:3.40.50.1440:FF:000113', NULL, NULL, 'FtsZ', NULL, NULL, NULL, NULL, NULL, 4),
(101971, NULL, 'G3DSA:3.40.50.720:FF:000410', NULL, NULL, 'Peroxisomal multifunctional beta-oxidation protein', NULL, NULL, NULL, NULL, NULL, 4),
(101972, NULL, 'G3DSA:2.60.120.380:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101973, NULL, 'G3DSA:2.70.98.10:FF:000017', NULL, NULL, 'Glycoside hydrolase family 2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(101974, NULL, 'G3DSA:2.70.170.10:FF:000219', NULL, NULL, 'Protein CBR-PBO-6', NULL, NULL, NULL, NULL, NULL, 4),
(101975, NULL, 'G3DSA:1.25.40.20:FF:000235', NULL, NULL, 'E3 ubiquitin-protein ligase MIB1 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(101976, NULL, 'G3DSA:2.30.22.10:FF:000001', NULL, NULL, 'Protein GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(101977, NULL, 'G3DSA:1.20.120.350:FF:000107', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(101978, NULL, 'G3DSA:3.40.50.12350:FF:000007', NULL, NULL, 'Eyes absent homolog', NULL, NULL, NULL, NULL, NULL, 4),
(101979, NULL, 'G3DSA:2.130.10.10:FF:004960', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101980, NULL, 'G3DSA:3.30.1650.10:FF:000002', NULL, NULL, 'Carbon monoxide dehydrogenase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(101981, NULL, 'G3DSA:1.10.630.10:FF:000536', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101982, NULL, 'G3DSA:2.60.40.10:FF:002262', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(101983, NULL, 'G3DSA:2.30.42.10:FF:000014', NULL, NULL, 'Segment polarity protein dishevelled homolog DVL-3', NULL, NULL, NULL, NULL, NULL, 4),
(101984, NULL, 'G3DSA:1.10.510.10:FF:000376', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(101985, NULL, 'G3DSA:2.40.50.100:FF:000216', NULL, NULL, 'Glr1290 protein', NULL, NULL, NULL, NULL, NULL, 4),
(101986, NULL, 'G3DSA:2.60.120.260:FF:000172', NULL, NULL, 'neurexin-4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(101987, NULL, 'G3DSA:3.40.50.1460:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101988, NULL, 'G3DSA:2.60.40.340:FF:000006', NULL, NULL, 'Dorsal isoform 1-B', NULL, NULL, NULL, NULL, NULL, 4),
(101989, NULL, 'G3DSA:3.40.720.10:FF:000282', NULL, NULL, 'Putative phosphoethanolamine transferase HI_1005', NULL, NULL, NULL, NULL, NULL, 4),
(101990, NULL, 'G3DSA:3.40.50.300:FF:007765', NULL, NULL, 'Si:ch211-247i17.1', NULL, NULL, NULL, NULL, NULL, 4),
(101991, NULL, 'G3DSA:2.60.40.60:FF:001080', NULL, NULL, 'DE cadherin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(101992, NULL, 'G3DSA:2.60.40.60:FF:000574', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(101993, NULL, 'G3DSA:1.10.510.10:FF:000718', NULL, NULL, 'casein kinase I', NULL, NULL, NULL, NULL, NULL, 4),
(101994, NULL, 'G3DSA:1.50.10.20:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(101995, NULL, 'G3DSA:3.30.450.40:FF:000002', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(101996, NULL, 'G3DSA:1.25.40.10:FF:002621', NULL, NULL, 'Slr2048 protein', NULL, NULL, NULL, NULL, NULL, 4),
(101997, NULL, 'G3DSA:1.10.8.80:FF:000002', NULL, NULL, 'Methanol dehydrogenase transcriptional regulator MoxR2', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(101998, NULL, 'G3DSA:2.40.50.40:FF:000125', NULL, NULL, 'Chromodomain protein, Y-like', NULL, NULL, NULL, NULL, NULL, 4),
(101999, NULL, 'G3DSA:2.120.10.80:FF:000423', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(102000, NULL, 'G3DSA:3.30.200.20:FF:001613', NULL, NULL, 'Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(102001, NULL, 'G3DSA:2.30.90.10:FF:000001', NULL, NULL, 'Pleiotrophin', NULL, NULL, NULL, NULL, NULL, 4),
(102002, NULL, 'G3DSA:1.20.1070.10:FF:001254', NULL, NULL, 'AGAP013324-PA', NULL, NULL, NULL, NULL, NULL, 4),
(102003, NULL, 'G3DSA:1.10.10.60:FF:000003', NULL, NULL, 'Iroquois-class homeobox protein IRX', NULL, NULL, NULL, NULL, NULL, 4),
(102004, NULL, 'G3DSA:3.40.50.2300:FF:000512', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102005, NULL, 'G3DSA:3.40.225.10:FF:000018', NULL, NULL, 'Class II aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(102006, NULL, 'G3DSA:1.25.10.10:FF:002097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102007, NULL, 'G3DSA:1.10.10.10:FF:000921', NULL, NULL, 'DNA-binding response regulator VicR', NULL, NULL, NULL, NULL, NULL, 4),
(102008, NULL, 'G3DSA:2.30.39.10:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102009, NULL, 'G3DSA:3.30.230.10:FF:000353', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(102010, NULL, 'G3DSA:2.160.10.10:FF:000081', NULL, NULL, 'AGAP000082-PA', NULL, NULL, NULL, NULL, NULL, 4),
(102011, NULL, 'G3DSA:2.30.180.10:FF:000122', NULL, NULL, 'Vacuolar membrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102012, NULL, 'G3DSA:1.10.472.130:FF:000067', NULL, NULL, 'Cytoplasmic dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102013, NULL, 'G3DSA:3.40.50.1980:FF:000022', NULL, NULL, 'Heme ABC transporter substrate-binding protein IsdE', NULL, NULL, NULL, NULL, NULL, 4),
(102014, NULL, 'G3DSA:1.25.10.10:FF:001478', NULL, NULL, 'Armadillo/beta-catenin-like repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102015, NULL, 'G3DSA:1.25.40.60:FF:000011', NULL, NULL, 'Vacuolar sorting protein', NULL, NULL, NULL, NULL, NULL, 4),
(102016, NULL, 'G3DSA:1.20.1070.10:FF:000978', NULL, NULL, 'Vasopressin v1a recpetor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102017, NULL, 'G3DSA:3.30.230.130:FF:000051', NULL, NULL, 'Anaphase-promoting complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(102018, NULL, 'G3DSA:3.30.70.330:FF:002463', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102019, NULL, 'G3DSA:1.20.1050.10:FF:000308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102020, NULL, 'G3DSA:3.40.1440.60:FF:000004', NULL, NULL, 'Primosomal protein N''', NULL, NULL, NULL, NULL, NULL, 4),
(102021, NULL, 'G3DSA:3.40.50.300:FF:000975', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(102022, NULL, 'G3DSA:3.50.50.60:FF:001157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102023, NULL, 'G3DSA:1.10.287.110:FF:000032', NULL, NULL, 'Translocation protein SEC63 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(102024, NULL, 'G3DSA:1.20.1250.20:FF:001698', NULL, NULL, 'Sucrose transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102025, NULL, 'G3DSA:3.60.21.10:FF:000288', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(102026, NULL, 'G3DSA:3.30.360.20:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102027, NULL, 'G3DSA:1.25.40.480:FF:000003', NULL, NULL, 'Fanconi anemia, complementation group E', NULL, NULL, NULL, NULL, NULL, 4),
(102028, NULL, 'G3DSA:1.20.120.790:FF:000008', NULL, NULL, 'Chaperone protein HtpG', NULL, NULL, NULL, NULL, NULL, 4),
(102029, NULL, 'G3DSA:1.20.120.1750:FF:000079', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(102030, NULL, 'G3DSA:3.40.190.10:FF:000370', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(102031, NULL, 'G3DSA:1.10.630.10:FF:000295', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(102032, NULL, 'G3DSA:3.30.160.60:FF:004853', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102033, NULL, 'G3DSA:1.10.260.100:FF:000009', NULL, NULL, 'FAM10 family protein At4g22670-like', NULL, NULL, NULL, NULL, NULL, 4),
(102034, NULL, 'G3DSA:1.10.533.10:FF:000153', NULL, NULL, 'Caspase-8', NULL, NULL, NULL, NULL, NULL, 4),
(102035, NULL, 'G3DSA:2.30.42.10:FF:000115', NULL, NULL, 'Regulator of G-protein signaling 12', NULL, NULL, NULL, NULL, NULL, 4),
(102036, NULL, 'G3DSA:3.40.50.300:FF:008176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102037, NULL, 'G3DSA:1.10.238.10:FF:000540', NULL, NULL, 'Serine/threonine-protein phosphatase with EF-hands', NULL, NULL, NULL, NULL, NULL, 4),
(102038, NULL, 'G3DSA:1.10.287.2610:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102039, NULL, 'G3DSA:3.30.497.10:FF:000168', NULL, NULL, 'Serpin peptidase inhibitor 26', NULL, NULL, NULL, NULL, NULL, 4),
(102040, NULL, 'G3DSA:3.30.300.130:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102041, NULL, 'G3DSA:2.130.10.10:FF:005909', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102042, NULL, 'G3DSA:3.60.21.10:FF:000372', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102043, NULL, 'G3DSA:2.130.10.10:FF:000014', NULL, NULL, 'Putative F-box-like/WD repeat-containing protein TBL1XR1', NULL, NULL, NULL, NULL, NULL, 4),
(102044, NULL, 'G3DSA:1.25.40.20:FF:000578', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(102045, NULL, 'G3DSA:3.30.160.60:FF:001430', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102046, NULL, 'G3DSA:2.60.40.60:FF:000231', NULL, NULL, 'Cadherin related family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(102047, NULL, 'G3DSA:2.60.40.150:FF:000618', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102048, NULL, 'G3DSA:3.80.10.10:FF:000065', NULL, NULL, 'F-box only protein 38 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(102049, NULL, 'G3DSA:1.10.510.10:FF:004512', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102050, NULL, 'G3DSA:3.40.190.10:FF:000268', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(102051, NULL, 'G3DSA:2.60.120.260:FF:000413', NULL, NULL, 'Similar to calmodulin-like protein-putative secreted, membrane associated or paryphoplasmic Ca(2+)-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(102052, NULL, 'G3DSA:3.30.300.30:FF:000011', NULL, NULL, 'Crotonobetaine/carnitine--CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(102053, NULL, 'G3DSA:3.30.1520.10:FF:000009', NULL, NULL, 'rho GTPase-activating protein 32 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(102054, NULL, 'G3DSA:3.30.70.80:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102055, NULL, 'G3DSA:2.130.10.30:FF:000104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102056, NULL, 'G3DSA:2.60.40.1180:FF:000211', NULL, NULL, 'Cyclodextrin glucanotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(102057, NULL, 'G3DSA:3.30.2410.10:FF:000024', NULL, NULL, 'E3 ubiquitin-protein ligase hecw-1', NULL, NULL, NULL, NULL, NULL, 4),
(102058, NULL, 'G3DSA:1.10.510.10:FF:002612', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102059, NULL, 'G3DSA:1.20.1250.20:FF:002215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102060, NULL, 'G3DSA:3.40.630.10:FF:000067', NULL, NULL, 'Beta-Ala-Xaa dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(102061, NULL, 'G3DSA:1.10.220.10:FF:000027', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(102062, NULL, 'G3DSA:3.80.10.10:FF:003499', NULL, NULL, 'UV-damaged DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(102063, NULL, 'G3DSA:1.20.120.330:FF:000017', NULL, NULL, 'Polarisome protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102064, NULL, 'G3DSA:1.10.150.80:FF:000014', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(102065, NULL, 'G3DSA:2.40.10.10:FF:000266', NULL, NULL, 'MIP04821p', NULL, NULL, NULL, NULL, NULL, 4),
(102066, NULL, 'G3DSA:1.20.5.110:FF:000295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102067, NULL, 'G3DSA:2.40.20.10:FF:000081', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(102068, NULL, 'G3DSA:1.20.120.310:FF:000011', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(102069, NULL, 'G3DSA:3.40.50.920:FF:000026', NULL, NULL, 'Pyruvate-flavodoxin oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(102070, NULL, 'G3DSA:2.60.40.10:FF:000362', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase eta', NULL, NULL, NULL, NULL, NULL, 4),
(102071, NULL, 'G3DSA:3.40.50.300:FF:000071', NULL, NULL, 'Cytoplasmic dynein heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(102072, NULL, 'G3DSA:1.10.600.10:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102073, NULL, 'G3DSA:2.40.30.10:FF:000031', NULL, NULL, 'Sulfate adenylyltransferase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(102074, NULL, 'G3DSA:3.30.40.10:FF:001963', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102075, NULL, 'G3DSA:2.60.120.10:FF:000319', NULL, NULL, 'Cyclic nucleotide-binding domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102076, NULL, 'G3DSA:3.10.20.70:FF:000036', NULL, NULL, 'Glutamate--ammonia ligase', NULL, NULL, NULL, NULL, NULL, 4),
(102077, NULL, 'G3DSA:3.30.200.20:FF:001158', NULL, NULL, 'Os01g0296000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(102078, NULL, 'G3DSA:1.10.4080.10:FF:000010', NULL, NULL, 'Adprhl2 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102079, NULL, 'G3DSA:3.40.50.2000:FF:000192', NULL, NULL, 'Protein RfbU', NULL, NULL, NULL, NULL, NULL, 4),
(102080, NULL, 'G3DSA:3.90.70.10:FF:000321', NULL, NULL, 'Ananain', NULL, NULL, NULL, NULL, NULL, 4),
(102081, NULL, 'G3DSA:3.30.420.10:FF:000744', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102082, NULL, 'G3DSA:3.90.1070.20:FF:000003', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(102083, NULL, 'G3DSA:3.40.50.2300:FF:001029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102084, NULL, 'G3DSA:3.40.50.12780:FF:000018', NULL, NULL, 'Fatty acyl CoA synthetase 2', NULL, NULL, NULL, NULL, NULL, 4),
(102085, NULL, 'G3DSA:1.20.1050.130:FF:000004', NULL, NULL, 'Bifunctional glutamate/proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(102086, NULL, 'G3DSA:1.10.10.60:FF:000907', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102087, NULL, 'G3DSA:1.20.5.190:FF:000049', NULL, NULL, 'Igloo, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(102088, NULL, 'G3DSA:3.30.420.40:FF:000287', NULL, NULL, 'Actin-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(102089, NULL, 'G3DSA:1.25.40.10:FF:002166', NULL, NULL, 'Pentatricopeptide (PPR) repeat-containing protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(102090, NULL, 'G3DSA:3.30.160.60:FF:004864', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102091, NULL, 'G3DSA:3.30.70.100:FF:000157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102092, NULL, 'G3DSA:2.10.70.10:FF:000063', NULL, NULL, 'Sushi domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(102093, NULL, 'G3DSA:3.40.50.720:FF:001820', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(102094, NULL, 'G3DSA:3.90.25.10:FF:000014', NULL, NULL, 'Bifunctional pinoresinol-lariciresinol reductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(102095, NULL, 'G3DSA:3.30.420.40:FF:000163', NULL, NULL, 'Heat shock protein (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(102096, NULL, 'G3DSA:2.40.50.90:FF:000123', NULL, NULL, 'Succinoglycan biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(102097, NULL, 'G3DSA:3.30.160.60:FF:002599', NULL, NULL, 'Zinc finger protein 827', NULL, NULL, NULL, NULL, NULL, 4),
(102098, NULL, 'G3DSA:2.130.10.10:FF:005786', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(102099, NULL, 'G3DSA:3.30.70.330:FF:003082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102100, NULL, 'G3DSA:1.20.120.720:FF:000027', NULL, NULL, 'Myosin F, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102101, NULL, 'G3DSA:3.30.160.60:FF:003892', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102102, NULL, 'G3DSA:1.10.1450.10:FF:000015', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(102103, NULL, 'G3DSA:3.40.50.300:FF:005303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102104, NULL, 'G3DSA:1.10.10.10:FF:002023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102105, NULL, 'G3DSA:2.30.30.140:FF:000047', NULL, NULL, 'Staphylococcal nuclease domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(102106, NULL, 'G3DSA:2.130.10.10:FF:000357', NULL, NULL, 'Cilia and flagella associated protein 57', NULL, NULL, NULL, NULL, NULL, 4),
(102107, NULL, 'G3DSA:2.60.40.2240:FF:000001', NULL, NULL, 'acyl-coenzyme A thioesterase 4', NULL, NULL, NULL, NULL, NULL, 4),
(102108, NULL, 'G3DSA:3.40.50.300:FF:002656', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102109, NULL, 'G3DSA:2.60.40.1670:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102110, NULL, 'G3DSA:2.60.40.10:FF:005696', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102111, NULL, 'G3DSA:3.30.1540.10:FF:000011', NULL, NULL, 'Solute carrier family 45 member 2', NULL, NULL, NULL, NULL, NULL, 4),
(102112, NULL, 'G3DSA:3.30.450.30:FF:000010', NULL, NULL, 'Profilin', NULL, NULL, NULL, NULL, NULL, 4),
(102113, NULL, 'G3DSA:3.30.70.260:FF:000177', NULL, NULL, 'Os02g0478525 protein', NULL, NULL, NULL, NULL, NULL, 4),
(102114, NULL, 'G3DSA:3.10.105.10:FF:000005', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(102115, NULL, 'G3DSA:3.30.470.20:FF:000020', NULL, NULL, 'Probable multifunctional protein ADE2', NULL, NULL, NULL, NULL, NULL, 4),
(102116, NULL, 'G3DSA:2.120.10.30:FF:000324', NULL, NULL, 'Glucose/sorbosone dehydrogenase-like lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(102117, NULL, 'G3DSA:1.20.1250.20:FF:000978', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(102118, NULL, 'G3DSA:1.10.510.10:FF:003332', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102119, NULL, 'G3DSA:1.20.5.170:FF:000043', NULL, NULL, 'Basic leucine zipper transcriptional factor ATF-like', NULL, NULL, NULL, NULL, NULL, 4),
(102120, NULL, 'G3DSA:3.40.50.410:FF:000210', NULL, NULL, 'ATP-dependent DNA helicase II subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(102121, NULL, 'G3DSA:3.80.10.10:FF:001037', NULL, NULL, 'Leucine_Rich_repeat /CHAT_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(102122, NULL, 'G3DSA:3.40.50.720:FF:002208', NULL, NULL, 'Putative ketoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(102123, NULL, 'G3DSA:2.10.25.10:FF:001392', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102124, NULL, 'G3DSA:3.60.130.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102125, NULL, 'G3DSA:2.60.40.10:FF:000941', NULL, NULL, 'Terribly reduced optic lobes, isoform AN', NULL, NULL, NULL, NULL, NULL, 4),
(102126, NULL, 'G3DSA:3.30.450.50:FF:000016', NULL, NULL, 'Vesicle transporter Sec22', NULL, NULL, NULL, NULL, NULL, 4),
(102127, NULL, 'G3DSA:3.30.56.10:FF:000010', NULL, NULL, 'Phenylalanyl-tRNA synthetase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(102128, NULL, 'G3DSA:2.40.50.140:FF:000644', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102129, NULL, 'G3DSA:3.80.10.10:FF:002330', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(102130, NULL, 'G3DSA:3.40.50.300:FF:000632', NULL, NULL, 'Bifunctional adenosylcobalamin biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(102131, NULL, 'G3DSA:3.30.160.60:FF:006101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102132, NULL, 'G3DSA:3.20.20.100:FF:000161', NULL, NULL, 'Potassium voltage-gated channel, shaker-related subfamily, beta member 2 b', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(102133, NULL, 'G3DSA:3.30.70.330:FF:001957', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102134, NULL, 'G3DSA:3.30.70.2630:FF:000006', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(102135, NULL, 'G3DSA:1.20.5.650:FF:000007', NULL, NULL, 'transcription factor IIIB 90 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(102136, NULL, 'G3DSA:3.30.160.60:FF:005825', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102137, NULL, 'G3DSA:3.30.160.60:FF:002256', NULL, NULL, 'Zinc finger protein 670', NULL, NULL, NULL, NULL, NULL, 4),
(102138, NULL, 'G3DSA:1.10.8.60:FF:000255', NULL, NULL, 'Lon protease', NULL, NULL, NULL, NULL, NULL, 4),
(102139, NULL, 'G3DSA:3.90.1750.10:FF:000024', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(102140, NULL, 'G3DSA:2.60.40.10:FF:001767', NULL, NULL, 'Erythropoietin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(102141, NULL, 'G3DSA:3.30.70.330:FF:001833', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102142, NULL, 'G3DSA:1.10.238.10:FF:001170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102143, NULL, 'G3DSA:1.10.10.60:FF:000346', NULL, NULL, 'HTH-type transcriptional regulator ydeO', NULL, NULL, NULL, NULL, NULL, 4),
(102144, NULL, 'G3DSA:2.160.20.10:FF:000249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102145, NULL, 'G3DSA:1.20.1560.10:FF:000061', NULL, NULL, 'ATP-binding cassette transporter YOR1', NULL, NULL, NULL, NULL, NULL, 4),
(102146, NULL, 'G3DSA:2.10.110.10:FF:000274', NULL, NULL, 'LIM domain-containing protein B', NULL, NULL, NULL, NULL, NULL, 4),
(102147, NULL, 'G3DSA:3.40.50.1820:FF:000699', NULL, NULL, 'Peptidase S10', NULL, NULL, NULL, NULL, NULL, 4),
(102148, NULL, 'G3DSA:3.40.50.300:FF:006129', NULL, NULL, 'Protein Wnt', NULL, NULL, NULL, NULL, NULL, 4),
(102149, NULL, 'G3DSA:3.30.740.10:FF:000010', NULL, NULL, 'Dynein light chain', NULL, NULL, NULL, NULL, NULL, 4),
(102150, NULL, 'G3DSA:1.10.510.40:FF:000002', NULL, NULL, 'IucA/IucC family siderophore biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(102151, NULL, 'G3DSA:3.40.190.290:FF:000108', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(102152, NULL, 'G3DSA:1.20.1250.20:FF:001254', NULL, NULL, 'Minor myo-inositol transporter IolF', NULL, NULL, NULL, NULL, NULL, 4),
(102153, NULL, 'G3DSA:3.40.30.10:FF:000759', NULL, NULL, 'Ribosomal protein mRpS25, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102154, NULL, 'G3DSA:2.130.10.10:FF:000918', NULL, NULL, 'Nucleolar protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(102155, NULL, 'G3DSA:3.40.640.10:FF:000360', NULL, NULL, 'Methionine gamma-lyase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102156, NULL, 'G3DSA:3.10.310.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102157, NULL, 'G3DSA:3.30.410.40:FF:000005', NULL, NULL, '5-(hydroxymethyl)furfural oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(102158, NULL, 'G3DSA:1.10.8.270:FF:000019', NULL, NULL, 'TBC1 domain family member 13', NULL, NULL, NULL, NULL, NULL, 4),
(102159, NULL, 'G3DSA:3.30.2040.10:FF:000001', NULL, NULL, 'D-glutamate cyclase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(102160, NULL, 'G3DSA:3.30.200.20:FF:001490', NULL, NULL, 'Putative serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(102161, NULL, 'G3DSA:2.90.10.10:FF:000050', NULL, NULL, 'Putative receptor protein kinase ZmPK1', NULL, NULL, NULL, NULL, NULL, 4),
(102162, NULL, 'G3DSA:1.25.40.10:FF:004066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102163, NULL, 'G3DSA:3.40.50.2300:FF:001361', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102164, NULL, 'G3DSA:3.30.1640.10:FF:000075', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(102165, NULL, 'G3DSA:2.170.270.10:FF:000152', NULL, NULL, 'Protein CBG24719', NULL, NULL, NULL, NULL, NULL, 4),
(102166, NULL, 'G3DSA:3.20.20.190:FF:000047', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(102167, NULL, 'G3DSA:1.25.10.10:FF:002658', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102168, NULL, 'G3DSA:1.25.10.10:FF:000197', NULL, NULL, 'Ecm29 proteasome adaptor and scaffold', NULL, NULL, NULL, NULL, NULL, 4),
(102169, NULL, 'G3DSA:1.20.1070.10:FF:000074', NULL, NULL, 'probable G-protein coupled receptor 173', NULL, NULL, NULL, NULL, NULL, 4),
(102170, NULL, 'G3DSA:3.30.1120.120:FF:000005', NULL, NULL, 'Serine/threonine-protein kinase PLK4', NULL, NULL, NULL, NULL, NULL, 4),
(102171, NULL, 'G3DSA:3.30.40.10:FF:001620', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(102172, NULL, 'G3DSA:3.40.190.80:FF:000019', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(102173, NULL, 'G3DSA:2.130.10.10:FF:002352', NULL, NULL, 'K7_Rpn14p', NULL, NULL, NULL, NULL, NULL, 4),
(102174, NULL, 'G3DSA:1.20.5.630:FF:000001', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(102175, NULL, 'G3DSA:3.60.15.10:FF:000122', NULL, NULL, 'Metallo-beta-lactamase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(102176, NULL, 'G3DSA:1.20.5.4820:FF:000014', NULL, NULL, 'Class V myosin', NULL, NULL, NULL, NULL, NULL, 4),
(102177, NULL, 'G3DSA:3.30.40.10:FF:000327', NULL, NULL, 'tripartite motif-containing protein 45', NULL, NULL, NULL, NULL, NULL, 4),
(102178, NULL, 'G3DSA:3.40.50.10190:FF:000101', NULL, NULL, 'Microcephalin, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(102179, NULL, 'G3DSA:3.80.10.10:FF:003156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102180, NULL, 'G3DSA:2.40.160.10:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102181, NULL, 'G3DSA:3.30.160.60:FF:002155', NULL, NULL, 'Zinc finger protein ZIC 3', NULL, NULL, NULL, NULL, NULL, 4),
(102182, NULL, 'G3DSA:2.40.50.140:FF:000195', NULL, NULL, 'Breast cancer type 2 susceptibility protein', NULL, NULL, NULL, NULL, NULL, 4),
(102183, NULL, 'G3DSA:1.10.150.50:FF:000039', NULL, NULL, 'GA-binding protein alpha chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102184, NULL, 'G3DSA:1.10.530.10:FF:000023', NULL, NULL, 'Invertebrate-type lysozyme', NULL, NULL, NULL, NULL, NULL, 4),
(102185, NULL, 'G3DSA:1.25.40.180:FF:000132', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(102186, NULL, 'G3DSA:3.40.50.300:FF:007877', NULL, NULL, 'DNA helicase RecQ4', NULL, NULL, NULL, NULL, NULL, 4),
(102187, NULL, 'G3DSA:1.25.40.20:FF:000347', NULL, NULL, 'Transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102188, NULL, 'G3DSA:3.90.850.10:FF:000038', NULL, NULL, 'Hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(102189, NULL, 'G3DSA:3.40.50.300:FF:008389', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102190, NULL, 'G3DSA:1.20.1250.20:FF:002210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102191, NULL, 'G3DSA:2.70.150.10:FF:000100', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(102192, NULL, 'G3DSA:2.120.10.80:FF:000187', NULL, NULL, 'Leucine-zipper-like transcriptional regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(102193, NULL, 'G3DSA:2.40.10.10:FF:000029', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(102194, NULL, 'G3DSA:1.10.10.10:FF:000685', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(102195, NULL, 'G3DSA:3.10.20.90:FF:000250', NULL, NULL, 'Protein kinase activator Bem1', NULL, NULL, NULL, NULL, NULL, 4),
(102196, NULL, 'G3DSA:1.25.40.10:FF:002486', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g18940, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(102197, NULL, 'G3DSA:3.40.190.10:FF:000824', NULL, NULL, 'Excitatory amino acid transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102198, NULL, 'G3DSA:1.20.1070.10:FF:002002', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(102199, NULL, 'G3DSA:2.60.40.10:FF:000486', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(102200, NULL, 'G3DSA:3.50.50.60:FF:001376', NULL, NULL, 'Squalene monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(102201, NULL, 'G3DSA:3.20.20.140:FF:000274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102202, NULL, 'G3DSA:1.20.58.760:FF:000017', NULL, NULL, 'Putative ATP-dependent zinc metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(102203, NULL, 'G3DSA:3.40.630.30:FF:000281', NULL, NULL, 'Acyl-CoA N-acyltransferases (NAT) superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(102204, NULL, 'G3DSA:3.90.550.50:FF:000218', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(102205, NULL, 'G3DSA:3.10.20.90:FF:000828', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102206, NULL, 'G3DSA:1.20.5.340:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102207, NULL, 'G3DSA:3.40.50.1000:FF:000673', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102208, NULL, 'G3DSA:1.25.40.10:FF:003110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102209, NULL, 'G3DSA:3.40.850.10:FF:000055', NULL, NULL, 'Chitin synthase ChsE', NULL, NULL, NULL, NULL, NULL, 4),
(102210, NULL, 'G3DSA:2.60.120.330:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102211, NULL, 'G3DSA:3.40.50.300:FF:003611', NULL, NULL, 'ADP-ribosylation factor family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102212, NULL, 'G3DSA:3.40.390.10:FF:000031', NULL, NULL, 'Pappalysin 2', NULL, NULL, NULL, NULL, NULL, 4),
(102213, NULL, 'G3DSA:2.80.10.50:FF:000023', NULL, NULL, 'Stromal cell-derived factor 2-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(102214, NULL, 'G3DSA:3.90.550.10:FF:000094', NULL, NULL, 'Alpha-1,6-mannosyl-glycoprotein 2-beta-N-acetylglucosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(102215, NULL, 'G3DSA:1.20.1260.60:FF:000002', NULL, NULL, 'Vacuolar protein sorting-associated protein IST1', NULL, NULL, NULL, NULL, NULL, 4),
(102216, NULL, 'G3DSA:1.20.1730.10:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102217, NULL, 'G3DSA:2.60.40.10:FF:004757', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102218, NULL, 'G3DSA:3.30.930.10:FF:000378', NULL, NULL, 'Protein CBR-PARS-2', NULL, NULL, NULL, NULL, NULL, 4),
(102219, NULL, 'G3DSA:3.40.50.300:FF:000863', NULL, NULL, 'DNA excision repair protein ERCC-6', NULL, NULL, NULL, NULL, NULL, 4),
(102220, NULL, 'G3DSA:1.10.510.10:FF:004187', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102221, NULL, 'G3DSA:2.60.120.260:FF:000284', NULL, NULL, 'Si:dkey-147f3.8', NULL, NULL, NULL, NULL, NULL, 4),
(102222, NULL, 'G3DSA:2.60.40.10:FF:004864', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102223, NULL, 'G3DSA:3.30.160.60:FF:000019', NULL, NULL, 'GLI family zinc finger 3', NULL, NULL, NULL, NULL, NULL, 4),
(102224, NULL, 'G3DSA:1.20.890.10:FF:000013', NULL, NULL, 'cAMP-dependent protein kinase type I regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(102225, NULL, 'G3DSA:3.40.50.80:FF:000056', NULL, NULL, 'Probable ferredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(102226, NULL, 'G3DSA:3.90.76.10:FF:000059', NULL, NULL, 'Oligopeptide-binding protein OppA', NULL, NULL, NULL, NULL, NULL, 4),
(102227, NULL, 'G3DSA:3.30.1120.90:FF:000014', NULL, NULL, 'Putative nucleosome assembly protein C36B7.08c', NULL, NULL, NULL, NULL, NULL, 4),
(102228, NULL, 'G3DSA:3.40.50.10490:FF:000096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102229, NULL, 'G3DSA:1.20.870.10:FF:000006', NULL, NULL, 'ras-specific guanine nucleotide-releasing factor 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(102230, NULL, 'G3DSA:2.20.25.10:FF:000014', NULL, NULL, 'Transcription factor IIIB 50 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(102231, NULL, 'G3DSA:3.40.50.300:FF:008501', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102232, NULL, 'G3DSA:3.50.50.60:FF:001269', NULL, NULL, 'At5g24155', NULL, NULL, NULL, NULL, NULL, 4),
(102233, NULL, 'G3DSA:1.10.8.10:FF:000156', NULL, NULL, 'Protein CBG03251', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(102234, NULL, 'G3DSA:2.10.25.10:FF:000099', NULL, NULL, 'Slit guidance ligand 2', NULL, NULL, NULL, NULL, NULL, 4),
(102235, NULL, 'G3DSA:3.10.105.10:FF:000106', NULL, NULL, 'Diguanylate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(102236, NULL, 'G3DSA:3.30.559.30:FF:000049', NULL, NULL, 'L-aminoadipate-semialdehyde dehydrogenase large subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102237, NULL, 'G3DSA:2.60.40.10:FF:005376', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102238, NULL, 'G3DSA:2.10.70.10:FF:000170', NULL, NULL, 'Kielin/chordin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(102239, NULL, 'G3DSA:1.25.40.10:FF:004740', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102240, NULL, 'G3DSA:2.60.40.10:FF:000593', NULL, NULL, 'Fibroblast growth factor receptor-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(102241, NULL, 'G3DSA:1.25.40.10:FF:002379', NULL, NULL, 'Os12g0557800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(102242, NULL, 'G3DSA:1.10.630.10:FF:000749', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102243, NULL, 'G3DSA:3.40.50.300:FF:005646', NULL, NULL, 'ABC-type transporter, ATPase component, fused to acetyltransferase domain', NULL, NULL, NULL, NULL, NULL, 4),
(102244, NULL, 'G3DSA:2.40.50.140:FF:000088', NULL, NULL, 'cold shock domain-containing protein E1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(102245, NULL, 'G3DSA:2.120.10.80:FF:000294', NULL, NULL, 'Mei4-dependent protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(102246, NULL, 'G3DSA:1.25.40.480:FF:000008', NULL, NULL, 'Fanconi anemia, complementation group E', NULL, NULL, NULL, NULL, NULL, 4),
(102247, NULL, 'G3DSA:2.130.10.10:FF:003212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102248, NULL, 'G3DSA:2.130.10.10:FF:002588', NULL, NULL, 'Minichromosome loss protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(102249, NULL, 'G3DSA:1.25.10.10:FF:000753', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(102250, NULL, 'G3DSA:2.60.120.260:FF:000391', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(102251, NULL, 'G3DSA:1.50.40.10:FF:000056', NULL, NULL, 'mitochondrial 2-oxodicarboxylate carrier isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(102252, NULL, 'G3DSA:3.20.20.80:FF:000628', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102253, NULL, 'G3DSA:3.40.1550.20:FF:000012', NULL, NULL, 'Transcriptional regulator MraZ', NULL, NULL, NULL, NULL, NULL, 4),
(102254, NULL, 'G3DSA:1.10.405.10:FF:000007', NULL, NULL, 'Lysine-specific histone demethylase', NULL, NULL, NULL, NULL, NULL, 4),
(102255, NULL, 'G3DSA:2.40.50.140:FF:000206', NULL, NULL, 'ATP-dependent DNA helicase RecG', NULL, NULL, NULL, NULL, NULL, 4),
(102256, NULL, 'G3DSA:3.40.50.300:FF:008496', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102257, NULL, 'G3DSA:1.25.40.1030:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102258, NULL, 'G3DSA:1.10.8.720:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102259, NULL, 'G3DSA:3.30.40.10:FF:002132', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(102260, NULL, 'G3DSA:3.30.200.20:FF:000540', NULL, NULL, 'Receptor-like protein kinase HAIKU2', NULL, NULL, NULL, NULL, NULL, 4),
(102261, NULL, 'G3DSA:3.30.1120.10:FF:000029', NULL, NULL, 'Arylsulfatase A', NULL, NULL, NULL, NULL, NULL, 4),
(102262, NULL, 'G3DSA:3.30.200.20:FF:001826', NULL, NULL, 'Ankyrin repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(102263, NULL, 'G3DSA:1.10.10.60:FF:000216', NULL, NULL, 'MYB proto-oncogene like 2', NULL, NULL, NULL, NULL, NULL, 4),
(102264, NULL, 'G3DSA:3.30.420.150:FF:000010', NULL, NULL, 'Adenosine-diphosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102265, NULL, 'G3DSA:2.60.40.60:FF:000124', NULL, NULL, 'Cadherin-related family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(102266, NULL, 'G3DSA:3.40.50.1000:FF:000780', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(102267, NULL, 'G3DSA:3.80.10.10:FF:003286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102268, NULL, 'G3DSA:2.130.10.10:FF:000227', NULL, NULL, 'Dynein assembly factor with WDR repeat domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(102269, NULL, 'G3DSA:1.20.90.10:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102270, NULL, 'G3DSA:2.60.40.420:FF:000143', NULL, NULL, 'Cupredoxin superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(102271, NULL, 'G3DSA:3.30.200.20:FF:001719', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102272, NULL, 'G3DSA:1.10.8.60:FF:000598', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102273, NULL, 'G3DSA:3.80.10.10:FF:003179', NULL, NULL, 'RNI-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(102274, NULL, 'G3DSA:1.25.40.10:FF:003003', NULL, NULL, 'Os06g0694300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(102275, NULL, 'G3DSA:3.40.50.1820:FF:000800', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(102276, NULL, 'G3DSA:2.60.120.920:FF:000072', NULL, NULL, 'Tripartite motif containing 38', NULL, NULL, NULL, NULL, NULL, 4),
(102277, NULL, 'G3DSA:3.40.1000.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102278, NULL, 'G3DSA:2.60.120.330:FF:000097', NULL, NULL, '1-aminocyclopropane-1-carboxylate oxidase-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(102279, NULL, 'G3DSA:1.10.10.10:FF:000792', NULL, NULL, 'Vacuolar protein-sorting-associated protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(102280, NULL, 'G3DSA:2.130.10.10:FF:004516', NULL, NULL, 'Denticleless protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(102281, NULL, 'G3DSA:2.60.120.10:FF:000550', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102282, NULL, 'G3DSA:2.10.110.10:FF:000167', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(102283, NULL, 'G3DSA:2.20.28.10:FF:000037', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(102284, NULL, 'G3DSA:1.20.120.790:FF:000003', NULL, NULL, 'Heat shock protein 90', NULL, NULL, NULL, NULL, NULL, 4),
(102285, NULL, 'G3DSA:1.10.8.970:FF:000004', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(102286, NULL, 'G3DSA:4.10.410.10:FF:000025', NULL, NULL, 'Papilin-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(102287, NULL, 'G3DSA:1.25.10.10:FF:002670', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102288, NULL, 'G3DSA:3.90.70.10:FF:000669', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102289, NULL, 'G3DSA:1.25.40.90:FF:000003', NULL, NULL, 'TOM1-like protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(102290, NULL, 'G3DSA:3.40.225.10:FF:000013', NULL, NULL, 'Class II aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(102291, NULL, 'G3DSA:1.10.287.160:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102292, NULL, 'G3DSA:3.30.530.20:FF:000177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102293, NULL, 'G3DSA:1.10.238.10:FF:000669', NULL, NULL, 'Voltage-dependent N-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(102294, NULL, 'G3DSA:2.60.40.1180:FF:000082', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(102295, NULL, 'G3DSA:3.40.50.150:FF:001397', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102296, NULL, 'G3DSA:3.30.530.20:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102297, NULL, 'G3DSA:2.60.40.150:FF:000169', NULL, NULL, 'Protein translocation complex component (Npl1)', NULL, NULL, NULL, NULL, NULL, 4),
(102298, NULL, 'G3DSA:3.30.200.20:FF:000298', NULL, NULL, 'Protein-associating with the carboxyl-terminal domain of ezrin', NULL, NULL, NULL, NULL, NULL, 4),
(102299, NULL, 'G3DSA:3.30.200.20:FF:000410', NULL, NULL, 'Serine/threonine-protein kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(102300, NULL, 'G3DSA:2.30.29.30:FF:000489', NULL, NULL, 'Inositol-3,4-bisphosphate 4-phosphatase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(102301, NULL, 'G3DSA:3.80.10.10:FF:003393', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102302, NULL, 'G3DSA:2.60.40.10:FF:004971', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102303, NULL, 'G3DSA:2.60.40.340:FF:000001', NULL, NULL, 'Nuclear factor of activated T-cells, cytoplasmic, calcineurin-dependent 2', NULL, NULL, NULL, NULL, NULL, 4),
(102304, NULL, 'G3DSA:3.40.850.10:FF:000162', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(102305, NULL, 'G3DSA:3.20.20.140:FF:000167', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(102306, NULL, 'G3DSA:1.10.400.10:FF:000036', NULL, NULL, 'Guanine nucleotide-binding protein G(Olf) subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(102307, NULL, 'G3DSA:3.40.190.10:FF:000717', NULL, NULL, 'Polar amino acid/opine ABC transporter, periplasmic amino acid-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(102308, NULL, 'G3DSA:3.30.70.330:FF:001165', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-4 specific', NULL, NULL, NULL, NULL, NULL, 4),
(102309, NULL, 'G3DSA:3.40.50.150:FF:000885', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102310, NULL, 'G3DSA:2.30.30.1020:FF:000029', NULL, NULL, 'CCR4-NOT core subunit', NULL, NULL, NULL, NULL, NULL, 4),
(102311, NULL, 'G3DSA:1.25.40.10:FF:004307', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(102312, NULL, 'G3DSA:1.10.510.10:FF:003568', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102313, NULL, 'G3DSA:3.90.79.10:FF:000189', NULL, NULL, 'NUDIX hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(102314, NULL, 'G3DSA:2.160.10.10:FF:000086', NULL, NULL, 'AGL094Wp', NULL, NULL, NULL, NULL, NULL, 4),
(102315, NULL, 'G3DSA:3.40.190.10:FF:000032', NULL, NULL, 'Maltose/maltodextrin-binding periplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(102316, NULL, 'G3DSA:1.10.599.10:FF:000001', NULL, NULL, 'Aldehyde:ferredoxin oxidoreductase, tungsten-containing', NULL, NULL, NULL, NULL, NULL, 4),
(102317, NULL, 'G3DSA:3.40.50.2300:FF:000169', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(102318, NULL, 'G3DSA:3.30.497.10:FF:000163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102319, NULL, 'G3DSA:3.40.50.80:FF:000163', NULL, NULL, 'Ferric reductase-like transmembrane component with cytochrome b-245 motif', NULL, NULL, NULL, NULL, NULL, 4),
(102320, NULL, 'G3DSA:1.25.40.10:FF:003907', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102321, NULL, 'G3DSA:2.130.10.10:FF:005680', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102322, NULL, 'G3DSA:3.40.930.10:FF:000005', NULL, NULL, 'Ascorbate-specific phosphotransferase enzyme IIA component', NULL, NULL, NULL, NULL, NULL, 4),
(102323, NULL, 'G3DSA:3.30.70.580:FF:000031', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(102324, NULL, 'G3DSA:3.90.190.10:FF:000122', NULL, NULL, 'myotubularin-related protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(102325, NULL, 'G3DSA:3.30.750.24:FF:000041', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(102326, NULL, 'G3DSA:3.40.50.2300:FF:001248', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102327, NULL, 'G3DSA:3.30.450.20:FF:000018', NULL, NULL, 'Sensor histidine kinase DcuS', NULL, NULL, NULL, NULL, NULL, 4),
(102328, NULL, 'G3DSA:2.60.40.150:FF:000270', NULL, NULL, 'Elicitor-responsive protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(102329, NULL, 'G3DSA:3.40.630.30:FF:000174', NULL, NULL, 'Acetyltransferase, GNAT family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102330, NULL, 'G3DSA:1.20.1390.10:FF:000002', NULL, NULL, 'Serine/arginine repetitive matrix 1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(102331, NULL, 'G3DSA:1.10.510.10:FF:001207', NULL, NULL, 'probable receptor-like protein kinase At1g49730', NULL, NULL, NULL, NULL, NULL, 4),
(102332, NULL, 'G3DSA:1.25.40.10:FF:004852', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(102333, NULL, 'G3DSA:3.20.20.140:FF:000381', NULL, NULL, 'Ampd2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(102334, NULL, 'G3DSA:2.30.33.40:FF:000024', NULL, NULL, '10 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(102335, NULL, 'G3DSA:2.40.50.140:FF:000200', NULL, NULL, 'Programmed cell death 11', NULL, NULL, NULL, NULL, NULL, 4),
(102336, NULL, 'G3DSA:3.90.1150.10:FF:000063', NULL, NULL, 'Probable cystathionine gamma-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(102337, NULL, 'G3DSA:1.25.40.10:FF:001867', NULL, NULL, 'Cleavage stimulation factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102338, NULL, 'G3DSA:1.20.1550.10:FF:000004', NULL, NULL, 'Disulfide bond formation protein B', NULL, NULL, NULL, NULL, NULL, 4),
(102339, NULL, 'G3DSA:3.40.50.300:FF:002313', NULL, NULL, 'Phosphate import ATP-binding protein PstB', NULL, NULL, NULL, NULL, NULL, 4),
(102340, NULL, 'G3DSA:3.20.20.100:FF:000054', NULL, NULL, 'L-fucose dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(102341, NULL, 'G3DSA:3.40.50.2000:FF:000759', NULL, NULL, 'Alpha-1,6-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(102342, NULL, 'G3DSA:3.80.10.10:FF:001829', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase PXC2', NULL, NULL, NULL, NULL, NULL, 4),
(102343, NULL, 'G3DSA:1.25.40.10:FF:000125', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(102344, NULL, 'G3DSA:3.30.559.10:FF:000043', NULL, NULL, 'Peptide synthetase mbtE', NULL, NULL, NULL, NULL, NULL, 4),
(102345, NULL, 'G3DSA:3.30.70.330:FF:000653', NULL, NULL, 'AGAP002654-PB', NULL, NULL, NULL, NULL, NULL, 4),
(102346, NULL, 'G3DSA:3.30.1610.10:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(102347, NULL, 'G3DSA:1.20.58.390:FF:000221', NULL, NULL, 'AcetylCholine Receptor', NULL, NULL, NULL, NULL, NULL, 4),
(102348, NULL, 'G3DSA:3.40.50.150:FF:000666', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(102349, NULL, 'G3DSA:3.30.450.380:FF:000006', NULL, NULL, 'Type II/IV secretion system protein, TadA subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(102350, NULL, 'G3DSA:3.30.160.60:FF:003111', NULL, NULL, 'Zinc finger protein 557', NULL, NULL, NULL, NULL, NULL, 4),
(102351, NULL, 'G3DSA:3.40.50.1820:FF:001312', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102352, NULL, 'G3DSA:3.90.180.10:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102353, NULL, 'G3DSA:2.10.90.10:FF:000058', NULL, NULL, 'Maverick', NULL, NULL, NULL, NULL, NULL, 4),
(102354, NULL, 'G3DSA:2.40.30.10:FF:000250', NULL, NULL, 'AGAP011314-PA', NULL, NULL, NULL, NULL, NULL, 4),
(102355, NULL, 'G3DSA:3.30.160.60:FF:004297', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102356, NULL, 'G3DSA:2.40.70.10:FF:000477', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102357, NULL, 'G3DSA:1.20.1250.20:FF:001361', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102358, NULL, 'G3DSA:3.80.10.10:FF:002774', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102359, NULL, 'G3DSA:2.60.40.60:FF:000236', NULL, NULL, 'Dachsous, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(102360, NULL, 'G3DSA:2.40.10.10:FF:000243', NULL, NULL, 'KLK4 isoform 6', NULL, NULL, NULL, NULL, NULL, 4),
(102361, NULL, 'G3DSA:3.30.200.20:FF:001607', NULL, NULL, 'PTO-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(102362, NULL, 'G3DSA:3.20.20.70:FF:000737', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102363, NULL, 'G3DSA:1.20.5.340:FF:000015', NULL, NULL, 'Mitochondrial calcium uniporter regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(102364, NULL, 'G3DSA:3.30.160.60:FF:003897', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102365, NULL, 'G3DSA:3.30.160.60:FF:006207', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102366, NULL, 'G3DSA:3.10.20.90:FF:000143', NULL, NULL, 'E3 ubiquitin-protein ligase UHRF1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(102367, NULL, 'G3DSA:1.10.510.10:FF:000932', NULL, NULL, 'Protein CBG09188', NULL, NULL, NULL, NULL, NULL, 4),
(102368, NULL, 'G3DSA:3.30.200.20:FF:002338', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102369, NULL, 'G3DSA:1.25.40.10:FF:000581', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(102370, NULL, 'G3DSA:2.60.120.200:FF:000305', NULL, NULL, 'CoLlagen with Endostatin domain', NULL, NULL, NULL, NULL, NULL, 4),
(102371, NULL, 'G3DSA:3.30.40.10:FF:002244', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(102372, NULL, 'G3DSA:1.20.890.10:FF:000019', NULL, NULL, 'Dpy-30_motif_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(102373, NULL, 'G3DSA:2.10.25.10:FF:001037', NULL, NULL, 'C-type LECtin', NULL, NULL, NULL, NULL, NULL, 4),
(102374, NULL, 'G3DSA:3.40.640.10:FF:000129', NULL, NULL, 'Alanine aminotransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(102375, NULL, 'G3DSA:3.40.50.300:FF:008277', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(102376, NULL, 'G3DSA:1.20.120.1750:FF:000091', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(102377, NULL, 'G3DSA:1.20.1250.20:FF:001810', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102378, NULL, 'G3DSA:3.30.450.60:FF:000002', NULL, NULL, 'AP-2 complex subunit mu, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102379, NULL, 'G3DSA:1.25.10.10:FF:000972', NULL, NULL, 'GM26729', NULL, NULL, NULL, NULL, NULL, 4),
(102380, NULL, 'G3DSA:1.20.5.340:FF:000010', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(102381, NULL, 'G3DSA:3.40.50.300:FF:001352', NULL, NULL, 'DNA repair helicase', NULL, NULL, NULL, NULL, NULL, 4),
(102382, NULL, 'G3DSA:2.170.130.10:FF:000013', NULL, NULL, 'Carboxypeptidase regulatory-like domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(102383, NULL, 'G3DSA:1.20.58.1220:FF:000002', NULL, NULL, 'Exocyst complex component 8', NULL, NULL, NULL, NULL, NULL, 4),
(102384, NULL, 'G3DSA:2.60.40.10:FF:002498', NULL, NULL, 'Protease', NULL, NULL, NULL, NULL, NULL, 4),
(102385, NULL, 'G3DSA:1.20.1070.10:FF:000990', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102386, NULL, 'G3DSA:1.10.510.10:FF:000140', NULL, NULL, 'Platelet-derived growth factor receptor beta', NULL, NULL, NULL, NULL, NULL, 4),
(102387, NULL, 'G3DSA:3.20.20.70:FF:000395', NULL, NULL, 'Probable tRNA-dihydrouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(102388, NULL, 'G3DSA:3.10.28.10:FF:000058', NULL, NULL, 'Gll3966 protein', NULL, NULL, NULL, NULL, NULL, 4),
(102389, NULL, 'G3DSA:1.10.1320.10:FF:000017', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(102390, NULL, 'G3DSA:3.40.50.1000:FF:000785', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102391, NULL, 'G3DSA:3.30.70.270:FF:000270', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102392, NULL, 'G3DSA:2.160.20.10:FF:000148', NULL, NULL, 'ZFP family member', NULL, NULL, NULL, NULL, NULL, 4),
(102393, NULL, 'G3DSA:2.30.250.10:FF:000010', NULL, NULL, 'Clan MH, family M18, aspartyl aminopeptidase-like metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(102394, NULL, 'G3DSA:1.20.5.1500:FF:000007', NULL, NULL, 'Testis-specific Y-encoded protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(102395, NULL, 'G3DSA:3.30.450.80:FF:000008', NULL, NULL, 'Transcriptional activator protein VanR', NULL, NULL, NULL, NULL, NULL, 4),
(102396, NULL, 'G3DSA:1.10.287.110:FF:000268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102397, NULL, 'G3DSA:3.40.50.1820:FF:000244', NULL, NULL, 'Cutinase', NULL, NULL, NULL, NULL, NULL, 4),
(102398, NULL, 'G3DSA:1.20.1510.10:FF:000007', NULL, NULL, 'Zinc transporter 7', NULL, NULL, NULL, NULL, NULL, 4),
(102399, NULL, 'G3DSA:3.90.1750.10:FF:000029', NULL, NULL, 'Circadian trip, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(102400, NULL, 'G3DSA:3.90.1290.10:FF:000005', NULL, NULL, 'microtubule-actin cross-linking factor 1 isoform X7', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(102401, NULL, 'G3DSA:1.10.287.130:FF:000032', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(102402, NULL, 'G3DSA:3.40.390.10:FF:000143', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(102403, NULL, 'G3DSA:1.10.1300.10:FF:000022', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(102404, NULL, 'G3DSA:1.20.1550.10:FF:000009', NULL, NULL, 'Putative protein-disulfide oxidoreductase DsbI', NULL, NULL, NULL, NULL, NULL, 4),
(102405, NULL, 'G3DSA:3.20.20.140:FF:000386', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(102406, NULL, 'G3DSA:1.20.1070.10:FF:000315', NULL, NULL, 'G protein-coupled receptor 32', NULL, NULL, NULL, NULL, NULL, 4),
(102407, NULL, 'G3DSA:3.50.50.60:FF:001399', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(102408, NULL, 'G3DSA:2.30.30.40:FF:000563', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102409, NULL, 'G3DSA:3.30.160.60:FF:001531', NULL, NULL, 'Zinc finger protein 649', NULL, NULL, NULL, NULL, NULL, 4),
(102410, NULL, 'G3DSA:3.40.50.360:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102411, NULL, 'G3DSA:3.30.43.10:FF:000031', NULL, NULL, 'Protein CBG02865', NULL, NULL, NULL, NULL, NULL, 4),
(102412, NULL, 'G3DSA:2.60.40.10:FF:004752', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102413, NULL, 'G3DSA:3.40.630.10:FF:000308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102414, NULL, 'G3DSA:3.30.40.10:FF:001283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102415, NULL, 'G3DSA:3.30.160.270:FF:000008', NULL, NULL, '2-isopropylmalate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(102416, NULL, 'G3DSA:3.30.160.60:FF:000238', NULL, NULL, 'Zinc finger protein 485', NULL, NULL, NULL, NULL, NULL, 4),
(102417, NULL, 'G3DSA:3.30.465.10:FF:000044', NULL, NULL, 'DUF21 domain-containing protein At1g55930, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(102418, NULL, 'G3DSA:1.25.40.90:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102419, NULL, 'G3DSA:1.10.510.10:FF:003787', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102420, NULL, 'G3DSA:3.30.420.10:FF:000643', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102421, NULL, 'G3DSA:3.40.50.970:FF:000001', NULL, NULL, 'Pyruvate dehydrogenase E1 beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(102422, NULL, 'G3DSA:3.40.50.300:FF:006484', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(102423, NULL, 'G3DSA:2.60.40.10:FF:002503', NULL, NULL, 'Synaptogenesis protein syg-2', NULL, NULL, NULL, NULL, NULL, 4),
(102424, NULL, 'G3DSA:2.60.40.10:FF:001879', NULL, NULL, 'Protein tyrosine phosphatase, receptor type Q', NULL, NULL, NULL, NULL, NULL, 4),
(102425, NULL, 'G3DSA:3.40.50.300:FF:000733', NULL, NULL, 'Guanine nucleotide-binding protein alpha-1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(102426, NULL, 'G3DSA:2.10.90.10:FF:000053', NULL, NULL, 'PDGF-and VEGF-related factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(102427, NULL, 'G3DSA:2.130.10.10:FF:004623', NULL, NULL, 'Cytoplasmic dynein intermediate chain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(102428, NULL, 'G3DSA:1.50.10.20:FF:000006', NULL, NULL, 'Mannan endo-1,6-alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(102429, NULL, 'G3DSA:3.50.50.60:FF:000319', NULL, NULL, 'Rubredoxin-NAD(+) reductase', NULL, NULL, NULL, NULL, NULL, 4),
(102430, NULL, 'G3DSA:3.90.79.10:FF:000301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102431, NULL, 'G3DSA:1.25.40.10:FF:003902', NULL, NULL, 'rRNA processing protein Utp6, putative (AFU_orthologue AFUA_3G09750)', NULL, NULL, NULL, NULL, NULL, 4),
(102432, NULL, 'G3DSA:3.40.50.1400:FF:000017', NULL, NULL, 'Ferrochelatase che1', NULL, NULL, NULL, NULL, NULL, 4),
(102433, NULL, 'G3DSA:2.40.440.10:FF:000011', NULL, NULL, 'L,D-transpeptidase catalytic domain', NULL, NULL, NULL, NULL, NULL, 4),
(102434, NULL, 'G3DSA:2.30.29.30:FF:000360', NULL, NULL, 'Alpha-1-syntrophin', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(102435, NULL, 'G3DSA:2.60.40.10:FF:002155', NULL, NULL, 'Cell adhesion molecule L1-like b', NULL, NULL, NULL, NULL, NULL, 4),
(102436, NULL, 'G3DSA:3.30.160.60:FF:002150', NULL, NULL, 'Zinc finger protein 140', NULL, NULL, NULL, NULL, NULL, 4),
(102437, NULL, 'G3DSA:2.130.10.10:FF:000334', NULL, NULL, 'C-Jun-amino-terminal kinase-interacting protein 3 isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(102438, NULL, 'G3DSA:3.60.21.10:FF:000052', NULL, NULL, 'Endonuclease YhcR', NULL, NULL, NULL, NULL, NULL, 4),
(102439, NULL, 'G3DSA:3.30.450.20:FF:000232', NULL, NULL, 'Diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(102440, NULL, 'G3DSA:1.25.40.10:FF:005364', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(102441, NULL, 'G3DSA:2.60.40.10:FF:003807', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102442, NULL, 'G3DSA:1.20.58.390:FF:000333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102443, NULL, 'G3DSA:2.30.110.10:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102444, NULL, 'G3DSA:1.20.1250.20:FF:001142', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(102445, NULL, 'G3DSA:4.10.60.10:FF:000226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102446, NULL, 'G3DSA:2.60.40.790:FF:000006', NULL, NULL, 'calcyclin-binding protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(102447, NULL, 'G3DSA:3.40.50.300:FF:003729', NULL, NULL, 'Putative ATP-dependent DEAD/H RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(102448, NULL, 'G3DSA:3.30.1320.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102449, NULL, 'G3DSA:1.10.8.500:FF:000004', NULL, NULL, 'PAS domain-containing sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(102450, NULL, 'G3DSA:3.30.40.10:FF:001732', NULL, NULL, 'Lysine-specific demethylase rbr-2', NULL, NULL, NULL, NULL, NULL, 4),
(102451, NULL, 'G3DSA:3.40.50.1820:FF:001424', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102452, NULL, 'G3DSA:3.80.10.10:FF:001717', NULL, NULL, 'Os02g0317300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(102453, NULL, 'G3DSA:2.160.20.70:FF:000008', NULL, NULL, 'Adenylyl cyclase-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(102454, NULL, 'G3DSA:3.90.1640.10:FF:000038', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(102455, NULL, 'G3DSA:3.30.200.20:FF:002333', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102456, NULL, 'G3DSA:3.30.70.1350:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102457, NULL, 'G3DSA:3.30.60.20:FF:000118', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(102458, NULL, 'G3DSA:2.40.10.10:FF:000024', NULL, NULL, 'Serine protease 53', NULL, NULL, NULL, NULL, NULL, 4),
(102459, NULL, 'G3DSA:3.80.10.10:FF:002779', NULL, NULL, 'FBD-associated F-box protein At3g49020', NULL, NULL, NULL, NULL, NULL, 4),
(102460, NULL, 'G3DSA:3.40.50.300:FF:006028', NULL, NULL, 'Helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102461, NULL, 'G3DSA:1.20.1070.10:FF:001838', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102462, NULL, 'G3DSA:3.40.970.10:FF:000002', NULL, NULL, 'Ribonuclease H', NULL, NULL, NULL, NULL, NULL, 4),
(102463, NULL, 'G3DSA:3.40.630.30:FF:000286', NULL, NULL, 'AGAP004528-PA', NULL, NULL, NULL, NULL, NULL, 4),
(102464, NULL, 'G3DSA:4.10.280.110:FF:000008', NULL, NULL, 'U4/U6 small nuclear ribonucleoprotein PRP4', NULL, NULL, NULL, NULL, NULL, 4),
(102465, NULL, 'G3DSA:3.10.20.90:FF:000255', NULL, NULL, 'probable serine/threonine-protein kinase WNK9', NULL, NULL, NULL, NULL, NULL, 4),
(102466, NULL, 'G3DSA:3.40.50.1820:FF:001531', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102467, NULL, 'G3DSA:2.40.330.10:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102468, NULL, 'G3DSA:3.60.21.60:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(102469, NULL, 'G3DSA:3.30.450.40:FF:000238', NULL, NULL, 'PleD', NULL, NULL, NULL, NULL, NULL, 4),
(102470, NULL, 'G3DSA:3.40.47.10:FF:000056', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 3', NULL, NULL, NULL, NULL, NULL, 4),
(102471, NULL, 'G3DSA:3.90.70.10:FF:000557', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102472, NULL, 'G3DSA:1.10.10.10:FF:001859', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102473, NULL, 'G3DSA:1.20.140.150:FF:000046', NULL, NULL, 'Transmembrane protein 114', NULL, NULL, NULL, NULL, NULL, 4),
(102474, NULL, 'G3DSA:1.10.287.950:FF:000047', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(102475, NULL, 'G3DSA:3.40.50.300:FF:004915', NULL, NULL, 'ADP-ribosylation factor D1B', NULL, NULL, NULL, NULL, NULL, 4),
(102476, NULL, 'G3DSA:3.30.40.10:FF:001862', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102477, NULL, 'G3DSA:2.40.50.90:FF:000011', NULL, NULL, 'Ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(102478, NULL, 'G3DSA:3.80.10.10:FF:000306', NULL, NULL, 'Toll-like receptor 5', NULL, NULL, NULL, NULL, NULL, 4),
(102479, NULL, 'G3DSA:3.60.21.10:FF:000395', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(102480, NULL, 'G3DSA:1.10.533.10:FF:000176', NULL, NULL, 'Baculoviral IAP repeat-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(102481, NULL, 'G3DSA:3.90.1160.10:FF:000001', NULL, NULL, 'Baseplate wedge completion tail pin', NULL, NULL, NULL, NULL, NULL, 4),
(102482, NULL, 'G3DSA:2.60.200.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102483, NULL, 'G3DSA:3.80.10.10:FF:001470', NULL, NULL, 'Connectin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(102484, NULL, 'G3DSA:3.90.1150.10:FF:000170', NULL, NULL, 'Orn/Arg/Lys decarboxylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102485, NULL, 'G3DSA:3.40.630.30:FF:000067', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(102486, NULL, 'G3DSA:1.10.238.10:FF:000557', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102487, NULL, 'G3DSA:1.20.5.170:FF:000285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102488, NULL, 'G3DSA:1.10.510.10:FF:001314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102489, NULL, 'G3DSA:3.90.1180.10:FF:000014', NULL, NULL, 'Ribosomal protein L13, variant', NULL, NULL, NULL, NULL, NULL, 4),
(102490, NULL, 'G3DSA:3.30.70.330:FF:001277', NULL, NULL, 'Nucleolin', NULL, NULL, NULL, NULL, NULL, 4),
(102491, NULL, 'G3DSA:2.10.25.10:FF:000655', NULL, NULL, 'Complement component C1q receptor', NULL, NULL, NULL, NULL, NULL, 4),
(102492, NULL, 'G3DSA:3.20.20.60:FF:000066', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(102493, NULL, 'G3DSA:1.10.10.10:FF:001989', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102494, NULL, 'G3DSA:1.10.533.10:FF:000046', NULL, NULL, 'Si:ch211-196f19.1', NULL, NULL, NULL, NULL, NULL, 4),
(102495, NULL, 'G3DSA:3.40.50.2000:FF:000416', NULL, NULL, 'Protein CBG10769', NULL, NULL, NULL, NULL, NULL, 4),
(102496, NULL, 'G3DSA:1.10.1200.10:FF:000082', NULL, NULL, 'Transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(102497, NULL, 'G3DSA:2.30.180.10:FF:000127', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102498, NULL, 'G3DSA:3.30.70.330:FF:002570', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102499, NULL, 'G3DSA:1.25.40.10:FF:000018', NULL, NULL, 'Cell division cycle protein 27 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(102500, NULL, 'G3DSA:2.60.40.60:FF:000343', NULL, NULL, 'Fat-like cadherin-related tumor suppressor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(102501, NULL, 'G3DSA:3.30.70.60:FF:000041', NULL, NULL, '30S ribosomal protein S6', NULL, NULL, NULL, NULL, NULL, 4),
(102502, NULL, 'G3DSA:3.30.40.10:FF:001390', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(102503, NULL, 'G3DSA:2.130.10.10:FF:000790', NULL, NULL, 'Chromosome segregation protein (SepB)', NULL, NULL, NULL, NULL, NULL, 4),
(102504, NULL, 'G3DSA:1.10.540.10:FF:000074', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(102505, NULL, 'G3DSA:1.10.10.60:FF:000323', NULL, NULL, 'jerky protein homolog-like', NULL, NULL, NULL, NULL, NULL, 4),
(102506, NULL, 'G3DSA:3.40.50.300:FF:004567', NULL, NULL, 'DNA helicase HCS1', NULL, NULL, NULL, NULL, NULL, 4),
(102507, NULL, 'G3DSA:3.30.1300.10:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102508, NULL, 'G3DSA:1.25.40.10:FF:004060', NULL, NULL, 'Protein STIP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(102509, NULL, 'G3DSA:3.40.50.1100:FF:000141', NULL, NULL, 'Cysteine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(102510, NULL, 'G3DSA:3.40.50.2300:FF:000411', NULL, NULL, 'PROBABLE RESPONSE REGULATOR', NULL, NULL, NULL, NULL, NULL, 4),
(102511, NULL, 'G3DSA:3.40.630.10:FF:000061', NULL, NULL, 'Aminobenzoyl-glutamate utilization protein B', NULL, NULL, NULL, NULL, NULL, 4),
(102512, NULL, 'G3DSA:3.30.450.20:FF:000013', NULL, NULL, 'Period circadian protein homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(102513, NULL, 'G3DSA:2.10.50.10:FF:000056', NULL, NULL, 'Cysteine repeat modular protein 2 PbCRM2', NULL, NULL, NULL, NULL, NULL, 4),
(102514, NULL, 'G3DSA:1.10.357.110:FF:000003', NULL, NULL, 'Putative GARP complex subunit Vps53', NULL, NULL, NULL, NULL, NULL, 4),
(102515, NULL, 'G3DSA:3.30.70.330:FF:001058', NULL, NULL, 'Mip6p', NULL, NULL, NULL, NULL, NULL, 4),
(102516, NULL, 'G3DSA:3.10.20.70:FF:000030', NULL, NULL, 'Glutamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(102517, NULL, 'G3DSA:2.40.50.140:FF:001156', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102518, NULL, 'G3DSA:3.40.366.10:FF:000031', NULL, NULL, 'Malonyl CoA-acyl carrier protein transacylase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(102519, NULL, 'G3DSA:3.30.1330.30:FF:000068', NULL, NULL, 'Protein pelota homolog', NULL, NULL, NULL, NULL, NULL, 4),
(102520, NULL, 'G3DSA:2.60.40.10:FF:003459', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102521, NULL, 'G3DSA:3.30.750.44:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102522, NULL, 'G3DSA:3.50.50.60:FF:000090', NULL, NULL, 'Rab GDP dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(102523, NULL, 'G3DSA:2.30.29.30:FF:000141', NULL, NULL, 'Pleckstrin homology domain-containing family G member 5', NULL, NULL, NULL, NULL, NULL, 4),
(102524, NULL, 'G3DSA:2.60.120.260:FF:000177', NULL, NULL, 'Hemolectin', NULL, NULL, NULL, NULL, NULL, 4),
(102525, NULL, 'G3DSA:3.90.550.10:FF:000217', NULL, NULL, 'Glycosyl transferase, group 2', NULL, NULL, NULL, NULL, NULL, 4),
(102526, NULL, 'G3DSA:3.20.20.70:FF:000288', NULL, NULL, 'Oxidoreductase, 2-nitropropane dioxygenase family, putative (AFU_orthologue AFUA_7G03850)', NULL, NULL, NULL, NULL, NULL, 4),
(102527, NULL, 'G3DSA:2.70.98.50:FF:000001', NULL, NULL, 'Glucosidase YgjK', NULL, NULL, NULL, NULL, NULL, 4),
(102528, NULL, 'G3DSA:1.10.238.10:FF:000776', NULL, NULL, 'Mechanosensitive ion channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(102529, NULL, 'G3DSA:1.25.40.20:FF:001308', NULL, NULL, 'Os09g0294901 protein', NULL, NULL, NULL, NULL, NULL, 4),
(102530, NULL, 'G3DSA:1.20.58.60:FF:000596', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(102531, NULL, 'G3DSA:3.40.720.10:FF:000287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102532, NULL, 'G3DSA:3.90.226.10:FF:000190', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(102533, NULL, 'G3DSA:1.10.150.50:FF:000146', NULL, NULL, 'Phosphatidylinositol 3-kinase regulatory subunit alpha-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(102534, NULL, 'G3DSA:3.40.30.10:FF:000753', NULL, NULL, 'Glutaredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(102535, NULL, 'G3DSA:1.10.3500.10:FF:000026', NULL, NULL, 'SH2 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(102536, NULL, 'G3DSA:2.120.10.80:FF:000182', NULL, NULL, 'Kelch_motif/Galactose_oxidase_-_central_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(102537, NULL, 'G3DSA:3.30.160.40:FF:000013', NULL, NULL, 'Porphobilinogen deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(102538, NULL, 'G3DSA:1.25.40.730:FF:000005', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(102539, NULL, 'G3DSA:3.10.450.40:FF:000001', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(102540, NULL, 'G3DSA:1.10.10.10:FF:001646', NULL, NULL, 'YALI0D25146p', NULL, NULL, NULL, NULL, NULL, 4),
(102541, NULL, 'G3DSA:3.90.70.10:FF:000776', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(102542, NULL, 'G3DSA:3.30.70.660:FF:000061', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(102543, NULL, 'G3DSA:2.40.70.10:FF:000584', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102544, NULL, 'G3DSA:1.20.120.350:FF:000006', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(102545, NULL, 'G3DSA:1.10.287.3490:FF:000001', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 11', NULL, NULL, NULL, NULL, NULL, 4),
(102546, NULL, 'G3DSA:1.25.40.10:FF:003784', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102547, NULL, 'G3DSA:2.40.70.10:FF:000039', NULL, NULL, 'Cathepsin D preproprotein', NULL, NULL, NULL, NULL, NULL, 4),
(102548, NULL, 'G3DSA:1.20.58.390:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102549, NULL, 'G3DSA:3.40.630.10:FF:000179', NULL, NULL, 'uncharacterized protein LOC100177071', NULL, NULL, NULL, NULL, NULL, 4),
(102550, NULL, 'G3DSA:1.10.3720.10:FF:000014', NULL, NULL, 'Microcin C ABC transporter permease YejB', NULL, NULL, NULL, NULL, NULL, 4),
(102551, NULL, 'G3DSA:3.80.10.10:FF:000981', NULL, NULL, 'Serine-threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102552, NULL, 'G3DSA:3.10.20.90:FF:000036', NULL, NULL, 'Unconventional myosin-VIIa', NULL, NULL, NULL, NULL, NULL, 4),
(102553, NULL, 'G3DSA:3.30.200.20:FF:001714', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102554, NULL, 'G3DSA:1.10.150.60:FF:000031', NULL, NULL, 'Lysine-specific demethylase rbr-2 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(102555, NULL, 'G3DSA:3.40.50.300:FF:004230', NULL, NULL, 'Ferrous iron transport protein B', NULL, NULL, NULL, NULL, NULL, 4),
(102556, NULL, 'G3DSA:1.10.1070.11:FF:000145', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102557, NULL, 'G3DSA:1.20.1050.10:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102558, NULL, 'G3DSA:3.30.160.60:FF:003459', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102559, NULL, 'G3DSA:1.10.510.10:FF:000825', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(102560, NULL, 'G3DSA:2.20.70.10:FF:000085', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(102561, NULL, 'G3DSA:3.20.70.20:FF:000029', NULL, NULL, 'Vitamin B12-dependent ribonucleotide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(102562, NULL, 'G3DSA:3.30.1740.20:FF:000001', NULL, NULL, '40S ribosomal protein S26', NULL, NULL, NULL, NULL, NULL, 4),
(102563, NULL, 'G3DSA:3.30.40.10:FF:002351', NULL, NULL, 'RING finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(102564, NULL, 'G3DSA:1.10.1070.11:FF:000021', NULL, NULL, 'Serine/threonine-protein kinase ATR, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102565, NULL, 'G3DSA:1.25.40.20:FF:000477', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(102566, NULL, 'G3DSA:3.60.21.10:FF:000271', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(102567, NULL, 'G3DSA:3.30.50.10:FF:000160', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(102568, NULL, 'G3DSA:1.20.1070.10:FF:001619', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102569, NULL, 'G3DSA:3.20.20.10:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102570, NULL, 'G3DSA:3.80.10.10:FF:003398', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102571, NULL, 'G3DSA:1.10.555.10:FF:000226', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102572, NULL, 'G3DSA:1.10.150.80:FF:000037', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(102573, NULL, 'G3DSA:3.30.70.330:FF:002019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102574, NULL, 'G3DSA:1.25.40.10:FF:001429', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(102575, NULL, 'G3DSA:3.20.20.450:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102576, NULL, 'G3DSA:1.20.1070.10:FF:001726', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102577, NULL, 'G3DSA:3.30.2410.10:FF:000029', NULL, NULL, 'Ubiquitin protein ligase E3A', NULL, NULL, NULL, NULL, NULL, 4),
(102578, NULL, 'G3DSA:1.20.1250.20:FF:001934', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102579, NULL, 'G3DSA:3.30.70.80:FF:000030', NULL, NULL, 'Subtilisin-like protease SBT2.1', NULL, NULL, NULL, NULL, NULL, 4),
(102580, NULL, 'G3DSA:3.30.360.80:FF:000001', NULL, NULL, 'RNA polymerase-associated protein RapA', NULL, NULL, NULL, NULL, NULL, 4),
(102581, NULL, 'G3DSA:2.160.20.10:FF:000036', NULL, NULL, 'Pectate lyase A', NULL, NULL, NULL, NULL, NULL, 4),
(102582, NULL, 'G3DSA:1.10.357.10:FF:000069', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(102583, NULL, 'G3DSA:3.90.110.10:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102584, NULL, 'G3DSA:3.10.20.90:FF:000486', NULL, NULL, 'MAPKKK cascade protein kinase regulator Ste50 (AFU_orthologue AFUA_2G17130)', NULL, NULL, NULL, NULL, NULL, 4),
(102585, NULL, 'G3DSA:1.10.287.70:FF:000396', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102586, NULL, 'G3DSA:3.30.1380.20:FF:000029', NULL, NULL, 'Trafficking protein particle complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(102587, NULL, 'G3DSA:1.10.790.10:FF:000002', NULL, NULL, 'Prion-like protein doppel', NULL, NULL, NULL, NULL, NULL, 4),
(102588, NULL, 'G3DSA:3.30.200.20:FF:002102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102589, NULL, 'G3DSA:1.10.8.60:FF:000362', NULL, NULL, '26S protease regulatory subunit 6B', NULL, NULL, NULL, NULL, NULL, 4),
(102590, NULL, 'G3DSA:2.60.40.1970:FF:000009', NULL, NULL, 'Gas41 homologue, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102591, NULL, 'G3DSA:2.60.120.10:FF:000089', NULL, NULL, 'cGMP-dependent protein kinase 5-1', NULL, NULL, NULL, NULL, NULL, 4),
(102592, NULL, 'G3DSA:3.40.50.10810:FF:000124', NULL, NULL, 'RAD54 like', NULL, NULL, NULL, NULL, NULL, 4),
(102593, NULL, 'G3DSA:2.60.40.1660:FF:000035', NULL, NULL, 'Sodium/potassium-dependent ATPase beta-2 subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102594, NULL, 'G3DSA:3.30.70.330:FF:001726', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102595, NULL, 'G3DSA:1.25.40.10:FF:004291', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102596, NULL, 'G3DSA:3.40.50.1240:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102597, NULL, 'G3DSA:3.40.50.720:FF:000758', NULL, NULL, 'Short-chain dehydrogenase/reductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(102598, NULL, 'G3DSA:1.25.40.10:FF:000704', NULL, NULL, 'Cdc16p', NULL, NULL, NULL, NULL, NULL, 4),
(102599, NULL, 'G3DSA:3.90.660.10:FF:000102', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102600, NULL, 'G3DSA:1.10.510.10:FF:000246', NULL, NULL, 'Putative Serine-threonine kinase SepH', NULL, NULL, NULL, NULL, NULL, 4),
(102601, NULL, 'G3DSA:1.20.58.60:FF:000028', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(102602, NULL, 'G3DSA:3.40.1380.20:FF:000072', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(102603, NULL, 'G3DSA:3.40.50.1820:FF:001655', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(102604, NULL, 'G3DSA:2.60.40.10:FF:005140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102605, NULL, 'G3DSA:1.10.10.60:FF:000891', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102606, NULL, 'G3DSA:2.60.40.10:FF:004521', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102607, NULL, 'G3DSA:2.130.10.10:FF:003555', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102608, NULL, 'G3DSA:1.20.58.1930:FF:000007', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(102609, NULL, 'G3DSA:3.30.160.60:FF:004061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102610, NULL, 'G3DSA:2.40.70.10:FF:000241', NULL, NULL, 'Acid protease', NULL, NULL, NULL, NULL, NULL, 4),
(102611, NULL, 'G3DSA:3.30.870.10:FF:000103', NULL, NULL, 'Phosphatidylcholine-hydrolyzing phospholipase D (PLD) family', NULL, NULL, NULL, NULL, NULL, 4),
(102612, NULL, 'G3DSA:3.30.360.10:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102613, NULL, 'G3DSA:1.10.3210.10:FF:000037', NULL, NULL, 'Metal-dependent phosphohydrolase, HD superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(102614, NULL, 'G3DSA:3.30.40.100:FF:000005', NULL, NULL, 'uncharacterized protein LOC106759733 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(102615, NULL, 'G3DSA:2.60.40.10:FF:001773', NULL, NULL, 'Interference hedgehog', NULL, NULL, NULL, NULL, NULL, 4),
(102616, NULL, 'G3DSA:1.20.1250.20:FF:001940', NULL, NULL, 'Autophagy-related protein 22-1', NULL, NULL, NULL, NULL, NULL, 4),
(102617, NULL, 'G3DSA:2.60.40.1670:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102618, NULL, 'G3DSA:1.10.506.10:FF:000028', NULL, NULL, 'RAS p21 protein activator 3', NULL, NULL, NULL, NULL, NULL, 4),
(102619, NULL, 'G3DSA:3.20.20.70:FF:000176', NULL, NULL, 'N-(5''-phosphoribosyl)anthranilate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(102620, NULL, 'G3DSA:3.40.50.2300:FF:000624', NULL, NULL, 'Glutamate receptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(102621, NULL, 'G3DSA:3.30.40.10:FF:001171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102622, NULL, 'G3DSA:3.40.50.1440:FF:000001', NULL, NULL, 'Cell division protein FtsZ', NULL, NULL, NULL, NULL, NULL, 4),
(102623, NULL, 'G3DSA:2.30.29.90:FF:000012', NULL, NULL, 'GTP-Rho binding exocyst subunit', NULL, NULL, NULL, NULL, NULL, 4),
(102624, NULL, 'G3DSA:2.30.30.750:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102625, NULL, 'G3DSA:3.40.30.10:FF:000860', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102626, NULL, 'G3DSA:3.40.50.960:FF:000015', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(102627, NULL, 'G3DSA:1.10.285.10:FF:000014', NULL, NULL, 'Glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(102628, NULL, 'G3DSA:2.60.40.1510:FF:000018', NULL, NULL, 'Alpha L integrin', NULL, NULL, NULL, NULL, NULL, 4),
(102629, NULL, 'G3DSA:3.90.79.10:FF:000083', NULL, NULL, '7,8-dihydro-8-oxoguanine triphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(102630, NULL, 'G3DSA:2.40.100.10:FF:000070', NULL, NULL, 'BnaA05g33830D protein', NULL, NULL, NULL, NULL, NULL, 4),
(102631, NULL, 'G3DSA:1.10.10.1050:FF:000004', NULL, NULL, 'mRNA-decapping enzyme 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102632, NULL, 'G3DSA:2.10.25.10:FF:000880', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(102633, NULL, 'G3DSA:1.20.1080.10:FF:000030', NULL, NULL, 'Aquaporin Z', NULL, NULL, NULL, NULL, NULL, 4),
(102634, NULL, 'G3DSA:3.40.50.2000:FF:000309', NULL, NULL, 'Glycogen synthase', NULL, NULL, NULL, NULL, NULL, 4),
(102635, NULL, 'G3DSA:3.40.50.2300:FF:001136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102636, NULL, 'G3DSA:3.30.565.10:FF:000321', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(102637, NULL, 'G3DSA:1.10.510.10:FF:001882', NULL, NULL, 'Putative dual specificity protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(102638, NULL, 'G3DSA:3.30.70.330:FF:000108', NULL, NULL, 'Heterogeneous nuclear ribonucleoproteins A2/B1', NULL, NULL, NULL, NULL, NULL, 4),
(102639, NULL, 'G3DSA:3.90.228.20:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102640, NULL, 'G3DSA:3.10.20.90:FF:000379', NULL, NULL, 'Ubiquitin/ribosomal protein CEP52', NULL, NULL, NULL, NULL, NULL, 4),
(102641, NULL, 'G3DSA:3.40.50.300:FF:002425', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(102642, NULL, 'G3DSA:3.30.70.1230:FF:000238', NULL, NULL, 'Adenylate cyclase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102643, NULL, 'G3DSA:3.40.710.10:FF:000129', NULL, NULL, 'Penicillin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(102644, NULL, 'G3DSA:3.90.740.10:FF:000047', NULL, NULL, 'Leucine--tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102645, NULL, 'G3DSA:3.90.260.10:FF:000010', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(102646, NULL, 'G3DSA:3.20.20.300:FF:000013', NULL, NULL, 'Probable exo-1,4-beta-xylosidase xlnD', NULL, NULL, NULL, NULL, NULL, 4),
(102647, NULL, 'G3DSA:1.10.760.10:FF:000068', NULL, NULL, 'C-type cytochrome', NULL, NULL, NULL, NULL, NULL, 4),
(102648, NULL, 'G3DSA:3.60.70.12:FF:000010', NULL, NULL, 'Arginine biosynthesis bifunctional protein ArgJ 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(102649, NULL, 'G3DSA:2.60.120.740:FF:000006', NULL, NULL, 'Protein eva-1 C', NULL, NULL, NULL, NULL, NULL, 4),
(102650, NULL, 'G3DSA:2.130.10.10:FF:000806', NULL, NULL, 'WD repeat-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(102651, NULL, 'G3DSA:3.30.70.330:FF:002238', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102652, NULL, 'G3DSA:1.25.40.20:FF:000802', NULL, NULL, 'M-T5', NULL, NULL, NULL, NULL, NULL, 4),
(102653, NULL, 'G3DSA:1.10.560.10:FF:000087', NULL, NULL, 'Bardet-Biedl syndrome 12', NULL, NULL, NULL, NULL, NULL, 4),
(102654, NULL, 'G3DSA:2.130.10.10:FF:000913', NULL, NULL, 'WD repeat domain phosphoinositide-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(102655, NULL, 'G3DSA:2.60.200.20:FF:000149', NULL, NULL, 'CAMK/RAD53 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(102656, NULL, 'G3DSA:2.10.25.10:FF:001167', NULL, NULL, 'Drosophila CRumBs homolog', NULL, NULL, NULL, NULL, NULL, 4),
(102657, NULL, 'G3DSA:3.50.50.60:FF:000432', NULL, NULL, 'L-ornithine N(5)-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(102658, NULL, 'G3DSA:1.10.720.30:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102659, NULL, 'G3DSA:2.60.40.10:FF:002048', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(102660, NULL, 'G3DSA:2.60.40.60:FF:000579', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102661, NULL, 'G3DSA:2.60.120.200:FF:000182', NULL, NULL, 'MAM and LDL-receptor class A domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(102662, NULL, 'G3DSA:1.10.238.10:FF:000326', NULL, NULL, 'IRS4p EH domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(102663, NULL, 'G3DSA:1.25.40.10:FF:002834', NULL, NULL, 'Tetratricopeptide repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102664, NULL, 'G3DSA:4.10.410.20:FF:000011', NULL, NULL, 'Poly(U)-specific endoribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(102665, NULL, 'G3DSA:3.30.450.40:FF:000007', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(102666, NULL, 'G3DSA:2.30.230.10:FF:000014', NULL, NULL, 'Vitellogenin 7', NULL, NULL, NULL, NULL, NULL, 4),
(102667, NULL, 'G3DSA:3.30.60.270:FF:000009', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(102668, NULL, 'G3DSA:2.40.50.140:FF:000650', NULL, NULL, 'Single-stranded DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(102669, NULL, 'G3DSA:1.10.10.60:FF:000902', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(102670, NULL, 'G3DSA:1.20.59.10:FF:000010', NULL, NULL, 'Chorismate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(102671, NULL, 'G3DSA:1.25.40.10:FF:000693', NULL, NULL, 'Tetratricopeptide repeat domain 30A', NULL, NULL, NULL, NULL, NULL, 4),
(102672, NULL, 'G3DSA:1.10.238.10:FF:000433', NULL, NULL, 'Flagellar calcium-binding protein TB-24', NULL, NULL, NULL, NULL, NULL, 4),
(102673, NULL, 'G3DSA:1.20.58.60:FF:000360', NULL, NULL, 'VAB-10B protein', NULL, NULL, NULL, NULL, NULL, 4),
(102674, NULL, 'G3DSA:3.50.50.60:FF:000201', NULL, NULL, 'Salicylate hydroxylase protein', NULL, NULL, NULL, NULL, NULL, 4),
(102675, NULL, 'G3DSA:2.60.40.10:FF:002279', NULL, NULL, 'Cilia- and flagella-associated protein 74', NULL, NULL, NULL, NULL, NULL, 4),
(102676, NULL, 'G3DSA:3.30.559.10:FF:000279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102677, NULL, 'G3DSA:4.10.400.10:FF:000069', NULL, NULL, 'complement component C8 beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(102678, NULL, 'G3DSA:1.10.472.80:FF:000127', NULL, NULL, 'Rab GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102679, NULL, 'G3DSA:2.60.40.10:FF:003010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102680, NULL, 'G3DSA:3.40.50.880:FF:000093', NULL, NULL, 'Cyclin 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102681, NULL, 'G3DSA:3.30.160.60:FF:000463', NULL, NULL, 'Krueppel-like factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(102682, NULL, 'G3DSA:3.10.580.10:FF:000226', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(102683, NULL, 'G3DSA:2.60.34.10:FF:000084', NULL, NULL, 'Heat shock 70-related protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(102684, NULL, 'G3DSA:3.40.47.10:FF:000062', NULL, NULL, 'Acetyl-CoA acetyltransferase FadA2', NULL, NULL, NULL, NULL, NULL, 4),
(102685, NULL, 'G3DSA:3.30.200.20:FF:000192', NULL, NULL, 'Serine/threonine-protein kinase cot-1', NULL, NULL, NULL, NULL, NULL, 4),
(102686, NULL, 'G3DSA:3.30.2160.10:FF:000032', NULL, NULL, 'HECT, UBA and WWE domain containing 1, E3 ubiquitin protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(102687, NULL, 'G3DSA:2.30.30.40:FF:000338', NULL, NULL, 'Transport and Golgi organization protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(102688, NULL, 'G3DSA:3.40.50.1000:FF:000217', NULL, NULL, 'P-type ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102689, NULL, 'G3DSA:3.30.420.40:FF:000399', NULL, NULL, 'Probable apyrase 7', NULL, NULL, NULL, NULL, NULL, 4),
(102690, NULL, 'G3DSA:3.40.50.1970:FF:000036', NULL, NULL, 'Glycerol-1-phosphate dehydrogenase [NAD(P)+]', NULL, NULL, NULL, NULL, NULL, 4),
(102691, NULL, 'G3DSA:2.40.170.20:FF:000021', NULL, NULL, 'Vitamin B12 transporter BtuB', NULL, NULL, NULL, NULL, NULL, 4),
(102692, NULL, 'G3DSA:1.10.287.950:FF:000053', NULL, NULL, 'Chemotaxis signal transduction system methyl accepting sensory transducer', NULL, NULL, NULL, NULL, NULL, 4),
(102693, NULL, 'G3DSA:3.30.70.2630:FF:000001', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(102694, NULL, 'G3DSA:3.40.50.300:FF:004573', NULL, NULL, 'Tornado 1', NULL, NULL, NULL, NULL, NULL, 4),
(102695, NULL, 'G3DSA:2.30.18.10:FF:000014', NULL, NULL, 'Transcription initiation factor IIA large subunit isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(102696, NULL, 'G3DSA:1.10.418.10:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102697, NULL, 'G3DSA:3.40.50.2300:FF:000517', NULL, NULL, 'Vomeronasal 2, receptor 96', NULL, NULL, NULL, NULL, NULL, 4),
(102698, NULL, 'G3DSA:3.40.630.10:FF:000415', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(102699, NULL, 'G3DSA:1.20.1560.10:FF:000853', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102700, NULL, 'G3DSA:3.40.50.1820:FF:001548', NULL, NULL, 'Abhydrolase domain-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102701, NULL, 'G3DSA:1.10.287.110:FF:000037', NULL, NULL, 'Chaperone protein dnaJ A6 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(102702, NULL, 'G3DSA:1.25.40.20:FF:000926', NULL, NULL, 'KN motif and ankyrin repeat domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(102703, NULL, 'G3DSA:1.10.472.10:FF:000371', NULL, NULL, 'G2/mitotic-specific cyclin A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102704, NULL, 'G3DSA:3.80.10.10:FF:003847', NULL, NULL, 'Protein phosphatase 2C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102705, NULL, 'G3DSA:1.25.10.10:FF:000180', NULL, NULL, 'DnaJ homolog subfamily C GRV2', NULL, NULL, NULL, NULL, NULL, 4),
(102706, NULL, 'G3DSA:3.40.50.150:FF:001739', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102707, NULL, 'G3DSA:3.40.190.10:FF:000375', NULL, NULL, 'Alkaline phosphatase L', NULL, NULL, NULL, NULL, NULL, 4),
(102708, NULL, 'G3DSA:1.20.1280.290:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102709, NULL, 'G3DSA:1.10.1140.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102710, NULL, 'G3DSA:1.20.58.340:FF:000015', NULL, NULL, 'magnesium transporter MRS2-4', NULL, NULL, NULL, NULL, NULL, 4),
(102711, NULL, 'G3DSA:2.40.50.100:FF:000211', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(102712, NULL, 'G3DSA:2.10.50.10:FF:000168', NULL, NULL, 'Nerve growth factor receptor a (TNFR superfamily, member 16)', NULL, NULL, NULL, NULL, NULL, 4),
(102713, NULL, 'G3DSA:1.10.640.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102714, NULL, 'G3DSA:3.40.50.300:FF:002549', NULL, NULL, 'Tetracycline resistance protein, GTP-binding elongation family', NULL, NULL, NULL, NULL, NULL, 4),
(102715, NULL, 'G3DSA:3.30.160.60:FF:004858', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102716, NULL, 'G3DSA:3.30.420.140:FF:000024', NULL, NULL, 'Transcription accessory protein (S1 RNA-binding domain)', NULL, NULL, NULL, NULL, NULL, 4),
(102717, NULL, 'G3DSA:3.40.50.1820:FF:000351', NULL, NULL, 'POSSIBLE HYDROLASE', NULL, NULL, NULL, NULL, NULL, 4),
(102718, NULL, 'G3DSA:1.10.10.10:FF:001753', NULL, NULL, 'AGAP010898-PA', NULL, NULL, NULL, NULL, NULL, 4),
(102719, NULL, 'G3DSA:2.102.10.10:FF:000049', NULL, NULL, 'Nitrite reductase [NAD(P)H] small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(102720, NULL, 'G3DSA:3.40.630.10:FF:000292', NULL, NULL, 'Glutamate carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102721, NULL, 'G3DSA:3.30.70.330:FF:000889', NULL, NULL, 'Poly(A) binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(102722, NULL, 'G3DSA:1.10.460.10:FF:000028', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(102723, NULL, 'G3DSA:3.30.200.20:FF:000646', NULL, NULL, 'Cyclin dependent kinase 10', NULL, NULL, NULL, NULL, NULL, 4),
(102724, NULL, 'G3DSA:2.30.42.10:FF:000227', NULL, NULL, 'PDZ domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(102725, NULL, 'G3DSA:3.40.350.10:FF:000034', NULL, NULL, 'Ectoine hydrolase DoeA', NULL, NULL, NULL, NULL, NULL, 4),
(102726, NULL, 'G3DSA:1.20.120.730:FF:000013', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(102727, NULL, 'G3DSA:2.40.30.30:FF:000020', NULL, NULL, 'Riboflavin kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102728, NULL, 'G3DSA:1.20.1250.20:FF:001703', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(102729, NULL, 'G3DSA:2.70.98.20:FF:000003', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(102730, NULL, 'G3DSA:3.40.190.10:FF:000156', NULL, NULL, 'Phosphate ABC transporter, phosphate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(102731, NULL, 'G3DSA:3.40.50.300:FF:008046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102732, NULL, 'G3DSA:1.25.10.10:FF:000865', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 56 kDa regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(102733, NULL, 'G3DSA:2.60.120.650:FF:000075', NULL, NULL, 'Uncharacterized protein B13D15.230', NULL, NULL, NULL, NULL, NULL, 4),
(102734, NULL, 'G3DSA:3.40.50.1820:FF:000019', NULL, NULL, '1-acylglycerol-3-phosphate O-acyltransferase ABHD5', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(102735, NULL, 'G3DSA:3.40.50.620:FF:000498', NULL, NULL, 'Phosphoadenosine-phosphosulphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(102736, NULL, 'G3DSA:1.25.40.10:FF:003559', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(102737, NULL, 'G3DSA:3.90.1100.10:FF:000003', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(102738, NULL, 'G3DSA:2.60.40.770:FF:000012', NULL, NULL, 'GG17324', NULL, NULL, NULL, NULL, NULL, 4),
(102739, NULL, 'G3DSA:3.40.50.2000:FF:000641', NULL, NULL, 'ADP-heptose:LPS heptosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(102740, NULL, 'G3DSA:3.40.850.10:FF:000398', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102741, NULL, 'G3DSA:1.25.40.10:FF:002615', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(102742, NULL, 'G3DSA:3.40.30.10:FF:000528', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(102743, NULL, 'G3DSA:3.30.1140.60:FF:000017', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(102744, NULL, 'G3DSA:2.40.50.690:FF:000005', NULL, NULL, 'Exosome complex exonuclease dis3', NULL, NULL, NULL, NULL, NULL, 4),
(102745, NULL, 'G3DSA:3.40.50.720:FF:000073', NULL, NULL, 'UDP-glucuronic acid decarboxylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(102746, NULL, 'G3DSA:2.10.25.10:FF:000548', NULL, NULL, 'Multimerin 1', NULL, NULL, NULL, NULL, NULL, 4),
(102747, NULL, 'G3DSA:3.30.40.10:FF:001968', NULL, NULL, 'RING/U-box superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(102748, NULL, 'G3DSA:3.30.1540.20:FF:000002', NULL, NULL, 'Putative mismatch repair endonuclease PMS2', NULL, NULL, NULL, NULL, NULL, 4),
(102749, NULL, 'G3DSA:3.30.70.330:FF:002126', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102750, NULL, 'G3DSA:3.40.50.200:FF:000035', NULL, NULL, 'Tripeptidyl peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(102751, NULL, 'G3DSA:1.10.10.580:FF:000014', NULL, NULL, 'Kleisin alpha', NULL, NULL, NULL, NULL, NULL, 4),
(102752, NULL, 'G3DSA:3.40.50.970:FF:000131', NULL, NULL, '2-oxoisovalerate dehydrogenase, E1 component, alpha and beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(102753, NULL, 'G3DSA:3.30.70.330:FF:000440', NULL, NULL, 'Putative RNA-binding protein ARP1', NULL, NULL, NULL, NULL, NULL, 4),
(102754, NULL, 'G3DSA:2.70.98.10:FF:000124', NULL, NULL, 'Aldose 1-epimerase family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102755, NULL, 'G3DSA:2.60.40.10:FF:000250', NULL, NULL, '1,4-alpha-glucan-branching enzyme, chloroplastic/amyloplastic', NULL, NULL, NULL, NULL, NULL, 4),
(102756, NULL, 'G3DSA:1.10.10.820:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102757, NULL, 'G3DSA:1.10.1380.10:FF:000015', NULL, NULL, 'Neprilysin-4', NULL, NULL, NULL, NULL, NULL, 4),
(102758, NULL, 'G3DSA:3.30.460.10:FF:000185', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(102759, NULL, 'G3DSA:3.40.50.300:FF:007771', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102760, NULL, 'G3DSA:3.10.180.10:FF:000010', NULL, NULL, 'Glyoxalase domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(102761, NULL, 'G3DSA:2.60.40.10:FF:003684', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102762, NULL, 'G3DSA:3.90.550.10:FF:000442', NULL, NULL, 'Putative mannan synthase 7', NULL, NULL, NULL, NULL, NULL, 4),
(102763, NULL, 'G3DSA:1.10.555.10:FF:000119', NULL, NULL, 'Rho GTPase-activating protein 33', NULL, NULL, NULL, NULL, NULL, 4),
(102764, NULL, 'G3DSA:3.40.50.150:FF:000435', NULL, NULL, 'Proliferating-cell nucleolar antigen p120', NULL, NULL, NULL, NULL, NULL, 4),
(102765, NULL, 'G3DSA:3.40.1370.10:FF:000017', NULL, NULL, '50S ribosomal protein L4', NULL, NULL, NULL, NULL, NULL, 4),
(102766, NULL, 'G3DSA:1.20.140.100:FF:000042', NULL, NULL, 'YALI0E32857p', NULL, NULL, NULL, NULL, NULL, 4),
(102767, NULL, 'G3DSA:3.40.50.300:FF:002206', NULL, NULL, 'ATP-dependent Clp protease, putative', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(102768, NULL, 'G3DSA:2.130.10.10:FF:001189', NULL, NULL, 'Periodic tryptophan protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(102769, NULL, 'G3DSA:3.40.50.300:FF:001588', NULL, NULL, 'Small GTPase rab5', NULL, NULL, NULL, NULL, NULL, 4),
(102770, NULL, 'G3DSA:1.25.10.10:FF:001826', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102771, NULL, 'G3DSA:3.40.30.10:FF:001260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102772, NULL, 'G3DSA:3.30.572.10:FF:000012', NULL, NULL, 'Thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(102773, NULL, 'G3DSA:3.40.390.10:FF:000137', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(102774, NULL, 'G3DSA:1.20.5.370:FF:000007', NULL, NULL, 'Myosin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(102775, NULL, 'G3DSA:1.10.600.10:FF:000017', NULL, NULL, 'Solanesyl-diphosphate synthase 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(102776, NULL, 'G3DSA:2.120.10.80:FF:000075', NULL, NULL, 'Multiple EGF like domains 8', NULL, NULL, NULL, NULL, NULL, 4),
(102777, NULL, 'G3DSA:3.90.640.10:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102778, NULL, 'G3DSA:3.40.50.1440:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102779, NULL, 'G3DSA:2.40.10.120:FF:000001', NULL, NULL, 'Periplasmic serine endoprotease DegP-like', NULL, NULL, NULL, NULL, NULL, 4),
(102780, NULL, 'G3DSA:3.10.20.90:FF:000598', NULL, NULL, 'IkB kinase', NULL, NULL, NULL, NULL, NULL, 4),
(102781, NULL, 'G3DSA:1.10.10.10:FF:000573', NULL, NULL, 'HTH-type transcriptional regulator ArcR', NULL, NULL, NULL, NULL, NULL, 4),
(102782, NULL, 'G3DSA:2.60.120.260:FF:000520', NULL, NULL, 'Beta-galactosidase 14', NULL, NULL, NULL, NULL, NULL, 4),
(102783, NULL, 'G3DSA:3.30.160.60:FF:006314', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102784, NULL, 'G3DSA:3.40.50.300:FF:002881', NULL, NULL, 'Putative snf2 family helicase atpase protein', NULL, NULL, NULL, NULL, NULL, 4),
(102785, NULL, 'G3DSA:1.20.1250.20:FF:002322', NULL, NULL, 'Inhibitor of growth family protein 2like, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102786, NULL, 'G3DSA:3.40.640.10:FF:000230', NULL, NULL, 'Neamine transaminase NeoN', NULL, NULL, NULL, NULL, NULL, 4),
(102787, NULL, 'G3DSA:3.30.160.60:FF:003908', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102788, NULL, 'G3DSA:1.25.40.20:FF:000241', NULL, NULL, 'No mechanoreceptor potential C, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(102789, NULL, 'G3DSA:3.80.10.10:FF:003162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102790, NULL, 'G3DSA:1.20.920.20:FF:000008', NULL, NULL, 'Dynein heavy chain 10, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(102791, NULL, 'G3DSA:1.10.1070.11:FF:000038', NULL, NULL, 'Serine/threonine-protein kinase Tel1', NULL, NULL, NULL, NULL, NULL, 4),
(102792, NULL, 'G3DSA:1.10.630.10:FF:000188', NULL, NULL, 'Cytochrome P450, putative (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(102793, NULL, 'G3DSA:1.20.1250.20:FF:001029', NULL, NULL, 'AGAP000718-PA', NULL, NULL, NULL, NULL, NULL, 4),
(102794, NULL, 'G3DSA:1.50.40.10:FF:000281', NULL, NULL, 'GD20812', NULL, NULL, NULL, NULL, NULL, 4),
(102795, NULL, 'G3DSA:3.50.50.60:FF:000887', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102796, NULL, 'G3DSA:2.30.42.10:FF:000008', NULL, NULL, 'microtubule-associated serine/threonine-protein kinase 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(102797, NULL, 'G3DSA:3.40.30.10:FF:000309', NULL, NULL, 'Formate dehydrogenase, gamma subunit', NULL, NULL, NULL, NULL, NULL, 4),
(102798, NULL, 'G3DSA:3.40.30.10:FF:000984', NULL, NULL, 'Anterior gradient 1', NULL, NULL, NULL, NULL, NULL, 4),
(102799, NULL, 'G3DSA:3.50.50.60:FF:001505', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102800, NULL, 'G3DSA:1.25.10.10:FF:002102', NULL, NULL, 'Sister chromatid cohesion protein', NULL, NULL, NULL, NULL, NULL, 4),
(102801, NULL, 'G3DSA:1.25.10.10:FF:001484', NULL, NULL, 'HEAT repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(102802, NULL, 'G3DSA:2.40.50.140:FF:000431', NULL, NULL, 'Probable DPS1-aspartyl-tRNA synthetase, cytosolic', NULL, NULL, NULL, NULL, NULL, 4),
(102803, NULL, 'G3DSA:3.40.50.1820:FF:001767', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(102804, NULL, 'G3DSA:1.10.510.10:FF:004299', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102805, NULL, 'G3DSA:3.40.50.12650:FF:000002', NULL, NULL, 'DNA cross-link repair 1C', NULL, NULL, NULL, NULL, NULL, 4),
(102806, NULL, 'G3DSA:3.80.10.10:FF:003504', NULL, NULL, 'Fgr28p', NULL, NULL, NULL, NULL, NULL, 4),
(102807, NULL, 'G3DSA:3.80.20.20:FF:000012', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(102808, NULL, 'G3DSA:2.130.10.10:FF:003100', NULL, NULL, 'Mono-functional DNA-alkylating methyl methanesulfonate N-term-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(102809, NULL, 'G3DSA:2.170.150.10:FF:000008', NULL, NULL, 'D-threonine aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(102810, NULL, 'G3DSA:3.30.200.20:FF:000989', NULL, NULL, 'NEK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(102811, NULL, 'G3DSA:2.60.200.20:FF:000025', NULL, NULL, 'Forkhead box protein K2', NULL, NULL, NULL, NULL, NULL, 4),
(102812, NULL, 'G3DSA:3.40.30.160:FF:000002', NULL, NULL, 'Microbial collagenase', NULL, NULL, NULL, NULL, NULL, 4),
(102813, NULL, 'G3DSA:1.25.40.10:FF:001997', NULL, NULL, 'TPR domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(102814, NULL, 'G3DSA:3.40.1810.10:FF:000046', NULL, NULL, 'Agamous-like MADS-box protein AGL92', NULL, NULL, NULL, NULL, NULL, 4),
(102815, NULL, 'G3DSA:3.30.160.60:FF:001767', NULL, NULL, 'Zinc finger protein 629', NULL, NULL, NULL, NULL, NULL, 4),
(102816, NULL, 'G3DSA:1.25.40.70:FF:000008', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(102817, NULL, 'G3DSA:3.60.10.10:FF:000240', NULL, NULL, 'Endonuclease/exonuclease/phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(102818, NULL, 'G3DSA:2.10.50.30:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102819, NULL, 'G3DSA:1.25.40.10:FF:003891', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102820, NULL, 'G3DSA:2.60.40.1110:FF:000005', NULL, NULL, 'Phosphatase and tensin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(102821, NULL, 'G3DSA:4.10.280.10:FF:000188', NULL, NULL, 'Transcription factor bHLH66', NULL, NULL, NULL, NULL, NULL, 4),
(102822, NULL, 'G3DSA:2.130.10.10:FF:005230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102823, NULL, 'G3DSA:1.25.40.10:FF:002273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102824, NULL, 'G3DSA:3.30.200.20:FF:001265', NULL, NULL, 'MOK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(102825, NULL, 'G3DSA:1.20.120.1900:FF:000057', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(102826, NULL, 'G3DSA:3.40.525.10:FF:000053', NULL, NULL, 'Protein tyrosine phosphatase, non-receptor type 9', NULL, NULL, NULL, NULL, NULL, 4),
(102827, NULL, 'G3DSA:3.30.160.60:FF:001424', NULL, NULL, 'Zinc finger and BTB domain-containing protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(102828, NULL, 'G3DSA:3.30.160.60:FF:002043', NULL, NULL, 'Zinc finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102829, NULL, 'G3DSA:3.80.10.10:FF:000413', NULL, NULL, 'Inactive leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(102830, NULL, 'G3DSA:3.40.367.20:FF:000002', NULL, NULL, 'Glucokinase', NULL, NULL, NULL, NULL, NULL, 4),
(102831, NULL, 'G3DSA:3.30.450.20:FF:000468', NULL, NULL, 'Hif-1', NULL, NULL, NULL, NULL, NULL, 4),
(102832, NULL, 'G3DSA:3.30.420.40:FF:000056', NULL, NULL, 'Molecular chaperone DnaK', NULL, NULL, NULL, NULL, NULL, 4),
(102833, NULL, 'G3DSA:2.160.20.10:FF:000255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102834, NULL, 'G3DSA:1.20.142.10:FF:000001', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(102835, NULL, 'G3DSA:3.40.720.10:FF:000175', NULL, NULL, 'Alkaline-phosphatase-like family protein', NULL, NULL, NULL, NULL, NULL, 4),
(102836, NULL, 'G3DSA:3.40.50.150:FF:001054', NULL, NULL, 'Methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(102837, NULL, 'G3DSA:3.30.300.90:FF:000006', NULL, NULL, 'Protein BOLA2', NULL, NULL, NULL, NULL, NULL, 4),
(102838, NULL, 'G3DSA:1.20.1270.10:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102839, NULL, 'G3DSA:3.30.160.60:FF:001082', NULL, NULL, 'zinc finger and BTB domain-containing protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(102840, NULL, 'G3DSA:1.10.730.20:FF:000013', NULL, NULL, 'tRNA synthetases class I-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(102841, NULL, 'G3DSA:2.40.50.140:FF:001268', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102842, NULL, 'G3DSA:2.60.40.10:FF:000811', NULL, NULL, 'Titin a', NULL, NULL, NULL, NULL, NULL, 4),
(102843, NULL, 'G3DSA:3.30.1490.490:FF:000001', NULL, NULL, 'cell growth-regulating nucleolar protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(102844, NULL, 'G3DSA:1.10.472.10:FF:000039', NULL, NULL, 'RB transcriptional corepressor 1', NULL, NULL, NULL, NULL, NULL, 4),
(102845, NULL, 'G3DSA:3.40.50.11980:FF:000003', NULL, NULL, 'Mitochondrial ribonuclease P catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(102846, NULL, 'G3DSA:1.10.1420.10:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102847, NULL, 'G3DSA:1.25.70.10:FF:000077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102848, NULL, 'G3DSA:3.20.20.80:FF:000510', NULL, NULL, 'Klotho', NULL, NULL, NULL, NULL, NULL, 4),
(102849, NULL, 'G3DSA:1.25.40.820:FF:000032', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(102850, NULL, 'G3DSA:1.25.40.20:FF:001202', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(102851, NULL, 'G3DSA:1.10.150.240:FF:000072', NULL, NULL, 'AT29272p', NULL, NULL, NULL, NULL, NULL, 4),
(102852, NULL, 'G3DSA:3.40.50.410:FF:000328', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(102853, NULL, 'G3DSA:1.20.1280.50:FF:000124', NULL, NULL, 'Zgc:171857', NULL, NULL, NULL, NULL, NULL, 4),
(102854, NULL, 'G3DSA:3.80.10.10:FF:004123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102855, NULL, 'G3DSA:1.10.238.10:FF:001288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102856, NULL, 'G3DSA:2.30.30.40:FF:000670', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102857, NULL, 'G3DSA:3.40.50.720:FF:002091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102858, NULL, 'G3DSA:3.40.50.150:FF:000778', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(102859, NULL, 'G3DSA:2.130.10.10:FF:002482', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(102860, NULL, 'G3DSA:3.40.50.300:FF:006135', NULL, NULL, 'ATP-binding cassette, sub-family G (WHITE), member 2c', NULL, NULL, NULL, NULL, NULL, 4),
(102861, NULL, 'G3DSA:3.80.10.10:FF:002886', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102862, NULL, 'G3DSA:3.30.9.10:FF:000261', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102863, NULL, 'G3DSA:2.10.220.10:FF:000052', NULL, NULL, 'proprotein convertase subtilisin/kexin type 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(102864, NULL, 'G3DSA:3.30.160.60:FF:002947', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102865, NULL, 'G3DSA:3.30.830.10:FF:000106', NULL, NULL, 'Pitrilysin-like metalloprotease', NULL, NULL, NULL, NULL, NULL, 4),
(102866, NULL, 'G3DSA:3.10.129.10:FF:000004', NULL, NULL, 'Tol-pal system-associated acyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(102867, NULL, 'G3DSA:2.40.10.10:FF:000479', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102868, NULL, 'G3DSA:3.50.50.60:FF:001163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(102869, NULL, 'G3DSA:3.30.780.10:FF:000001', NULL, NULL, 'Eukaryotic translation initiation factor SUI1', NULL, NULL, NULL, NULL, NULL, 4),
(102870, NULL, 'G3DSA:2.40.50.40:FF:000018', NULL, NULL, 'Chromodomain Y like 2', NULL, NULL, NULL, NULL, NULL, 4),
(102871, NULL, 'G3DSA:1.10.10.60:FF:001178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102872, NULL, 'G3DSA:3.40.1710.10:FF:000005', NULL, NULL, 'ESAT-6 secretion accessory factor EsaA', NULL, NULL, NULL, NULL, NULL, 4),
(102873, NULL, 'G3DSA:3.20.10.10:FF:000028', NULL, NULL, 'Branched-chain-amino-acid transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(102874, NULL, 'G3DSA:3.60.40.10:FF:000079', NULL, NULL, 'Probable protein phosphatase 2C 74', NULL, NULL, NULL, NULL, NULL, 4),
(102875, NULL, 'G3DSA:3.40.50.300:FF:005859', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(102876, NULL, 'G3DSA:3.30.70.20:FF:000040', NULL, NULL, 'Electron transporter YccM', NULL, NULL, NULL, NULL, NULL, 4),
(102877, NULL, 'G3DSA:1.10.167.10:FF:000021', NULL, NULL, 'A-kinase anchor protein 10, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(102878, NULL, 'G3DSA:3.30.1680.10:FF:000066', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(102879, NULL, 'G3DSA:1.10.4080.10:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102880, NULL, 'G3DSA:1.10.472.10:FF:000477', NULL, NULL, 'L-ascorbate peroxidase 2 cytosolic', NULL, NULL, NULL, NULL, NULL, 4),
(102881, NULL, 'G3DSA:1.50.10.20:FF:000113', NULL, NULL, 'Transcobalamin II', NULL, NULL, NULL, NULL, NULL, 4),
(102882, NULL, 'G3DSA:3.30.200.20:FF:002226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102883, NULL, 'G3DSA:1.20.5.780:FF:000012', NULL, NULL, 'FXYD domain-containing ion transport regulator', NULL, NULL, NULL, NULL, NULL, 4),
(102884, NULL, 'G3DSA:3.90.1200.10:FF:000056', NULL, NULL, 'RE28849p', NULL, NULL, NULL, NULL, NULL, 4),
(102885, NULL, 'G3DSA:3.30.1370.10:FF:000076', NULL, NULL, 'KH domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(102886, NULL, 'G3DSA:1.20.1280.20:FF:000020', NULL, NULL, 'AGR164Cp', NULL, NULL, NULL, NULL, NULL, 4),
(102887, NULL, 'G3DSA:2.70.70.10:FF:000004', NULL, NULL, 'NlpD family lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(102888, NULL, 'G3DSA:3.20.20.80:FF:000853', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(102889, NULL, 'G3DSA:3.40.50.1580:FF:000026', NULL, NULL, 'Aminodeoxyfutalosine nucleosidase', NULL, NULL, NULL, NULL, NULL, 4),
(102890, NULL, 'G3DSA:1.20.5.190:FF:000055', NULL, NULL, 'Putative microtubule-associated protein futsch', NULL, NULL, NULL, NULL, NULL, 4),
(102891, NULL, 'G3DSA:3.30.470.10:FF:000011', NULL, NULL, '4-amino-4-deoxychorismate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(102892, NULL, 'G3DSA:1.10.510.10:FF:002843', NULL, NULL, 'eIF-2-alpha kinase GCN2', NULL, NULL, NULL, NULL, NULL, 4),
(102893, NULL, 'G3DSA:3.90.1480.20:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102894, NULL, 'G3DSA:3.30.450.20:FF:000125', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(102895, NULL, 'G3DSA:3.90.1150.10:FF:000282', NULL, NULL, 'Serine-palmitoyl-CoA transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102896, NULL, 'G3DSA:3.30.1490.100:FF:000042', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(102897, NULL, 'G3DSA:3.40.50.300:FF:000284', NULL, NULL, 'probable ATP-dependent RNA helicase YTHDC2', NULL, NULL, NULL, NULL, NULL, 4),
(102898, NULL, 'G3DSA:3.30.360.50:FF:000003', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(102899, NULL, 'G3DSA:1.20.58.60:FF:000141', NULL, NULL, 'Microtubule-actin cross-linking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(102900, NULL, 'G3DSA:2.60.220.50:FF:000131', NULL, NULL, 'Adhesion G protein-coupled receptor E17', NULL, NULL, NULL, NULL, NULL, 4),
(102901, NULL, 'G3DSA:3.40.50.720:FF:001938', NULL, NULL, 'Sll6053 protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(102902, NULL, 'G3DSA:3.40.47.10:FF:000168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102903, NULL, 'G3DSA:1.20.1070.10:FF:000422', NULL, NULL, 'Protein CBG07754', NULL, NULL, NULL, NULL, NULL, 4),
(102904, NULL, 'G3DSA:3.90.25.10:FF:000020', NULL, NULL, 'Udp-sulfoquinovose synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(102905, NULL, 'G3DSA:3.90.1860.10:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102906, NULL, 'G3DSA:2.60.210.10:FF:000085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102907, NULL, 'G3DSA:1.20.58.80:FF:000023', NULL, NULL, 'Chitin synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(102908, NULL, 'G3DSA:3.90.190.10:FF:000358', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102909, NULL, 'G3DSA:3.30.420.40:FF:000293', NULL, NULL, 'Actin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102910, NULL, 'G3DSA:3.30.519.10:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102911, NULL, 'G3DSA:3.40.50.300:FF:004679', NULL, NULL, 'MSH (MutS Homolog) family', NULL, NULL, NULL, NULL, NULL, 4),
(102912, NULL, 'G3DSA:3.40.50.300:FF:005298', NULL, NULL, 'Protein-tyrosine sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(102913, NULL, 'G3DSA:1.10.10.10:FF:000117', NULL, NULL, 'Two-component system response regulator BaeR', NULL, NULL, NULL, NULL, NULL, 4),
(102914, NULL, 'G3DSA:6.10.140.2220:FF:000047', NULL, NULL, 'Zinc finger MYND domain-containing protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(102915, NULL, 'G3DSA:2.30.29.30:FF:000253', NULL, NULL, 'F-actin-uncapping protein LRRC16A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(102916, NULL, 'G3DSA:2.60.40.10:FF:000137', NULL, NULL, 'neural cell adhesion molecule 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(102917, NULL, 'G3DSA:3.30.505.10:FF:000104', NULL, NULL, 'Phosphoinositide 3-kinase adapter subunit', NULL, NULL, NULL, NULL, NULL, 4),
(102918, NULL, 'G3DSA:1.20.1050.10:FF:000191', NULL, NULL, 'Glutathione S-transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(102919, NULL, 'G3DSA:2.120.10.30:FF:000537', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102920, NULL, 'G3DSA:3.30.70.1230:FF:000019', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(102921, NULL, 'G3DSA:3.30.420.40:FF:000511', NULL, NULL, 'N-acetyl-D-glucosamine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(102922, NULL, 'G3DSA:2.30.38.10:FF:000009', NULL, NULL, 'Nonribosomal peptide synthase inpB', NULL, NULL, NULL, NULL, NULL, 4),
(102923, NULL, 'G3DSA:3.30.470.30:FF:000017', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(102924, NULL, 'G3DSA:2.80.10.50:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102925, NULL, 'G3DSA:2.10.110.10:FF:000061', NULL, NULL, 'Testin', NULL, NULL, NULL, NULL, NULL, 4),
(102926, NULL, 'G3DSA:3.40.1110.10:FF:000476', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102927, NULL, 'G3DSA:3.30.160.60:FF:005477', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102928, NULL, 'G3DSA:3.30.70.330:FF:000546', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(102929, NULL, 'G3DSA:2.10.25.10:FF:001728', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102930, NULL, 'G3DSA:2.30.29.30:FF:000596', NULL, NULL, 'Downstream of kinase', NULL, NULL, NULL, NULL, NULL, 4),
(102931, NULL, 'G3DSA:3.30.1370.100:FF:000037', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(102932, NULL, 'G3DSA:2.10.70.10:FF:000276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102933, NULL, 'G3DSA:3.30.160.60:FF:002386', NULL, NULL, 'Zinc finger protein 556', NULL, NULL, NULL, NULL, NULL, 4),
(102934, NULL, 'G3DSA:2.40.30.10:FF:000149', NULL, NULL, 'Translation initiation factor IF-2', NULL, NULL, NULL, NULL, NULL, 4),
(102935, NULL, 'G3DSA:3.40.50.300:FF:006591', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(102936, NULL, 'G3DSA:1.10.10.10:FF:001410', NULL, NULL, 'Os06g0130800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(102937, NULL, 'G3DSA:1.20.1270.280:FF:000019', NULL, NULL, 'Dynein axonemal heavy chain 14', NULL, NULL, NULL, NULL, NULL, 4),
(102938, NULL, 'G3DSA:3.30.420.10:FF:000750', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102939, NULL, 'G3DSA:2.60.40.10:FF:001430', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(102940, NULL, 'G3DSA:3.30.160.60:FF:001986', NULL, NULL, 'zinc finger and SCAN domain-containing protein 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(102941, NULL, 'G3DSA:3.30.1890.10:FF:000003', NULL, NULL, 'Ferric enterobactin transport protein fepE', NULL, NULL, NULL, NULL, NULL, 4),
(102942, NULL, 'G3DSA:1.25.50.20:FF:000067', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(102943, NULL, 'G3DSA:1.20.120.20:FF:000043', NULL, NULL, 'Apolipoprotein A-I', NULL, NULL, NULL, NULL, NULL, 4),
(102944, NULL, 'G3DSA:2.130.10.10:FF:005792', NULL, NULL, 'WD repeat and HMG-box DNA binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(102945, NULL, 'G3DSA:3.30.60.30:FF:000104', NULL, NULL, 'GEO08910p1', NULL, NULL, NULL, NULL, NULL, 4),
(102946, NULL, 'G3DSA:1.25.40.990:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102947, NULL, 'G3DSA:3.90.190.10:FF:000015', NULL, NULL, 'Dual specificity phosphatase 4', NULL, NULL, NULL, NULL, NULL, 4),
(102948, NULL, 'G3DSA:1.10.3380.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102949, NULL, 'G3DSA:1.50.40.10:FF:000404', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102950, NULL, 'G3DSA:1.20.1110.10:FF:000246', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102951, NULL, 'G3DSA:3.90.1030.20:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102952, NULL, 'G3DSA:3.40.50.300:FF:000969', NULL, NULL, 'Ferrous iron transporter B', NULL, NULL, NULL, NULL, NULL, 4),
(102953, NULL, 'G3DSA:1.25.10.10:FF:002445', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102954, NULL, 'G3DSA:2.130.10.10:FF:005573', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102955, NULL, 'G3DSA:1.10.10.180:FF:000001', NULL, NULL, 'Matrix protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(102956, NULL, 'G3DSA:2.170.220.10:FF:000003', NULL, NULL, 'Methionine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(102957, NULL, 'G3DSA:2.60.40.2660:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102958, NULL, 'G3DSA:1.20.1000.10:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102959, NULL, 'G3DSA:2.60.120.10:FF:000325', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(102960, NULL, 'G3DSA:3.30.230.80:FF:000008', NULL, NULL, 'Molecular chaperone HtpG', NULL, NULL, NULL, NULL, NULL, 4),
(102961, NULL, 'G3DSA:1.10.510.10:FF:002169', NULL, NULL, 'Mitogen-activated protein kinase sma-5', NULL, NULL, NULL, NULL, NULL, 4),
(102962, NULL, 'G3DSA:2.40.30.20:FF:000028', NULL, NULL, 'Riboflavin synthase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(102963, NULL, 'G3DSA:2.120.10.30:FF:000318', NULL, NULL, 'Blr3643 protein', NULL, NULL, NULL, NULL, NULL, 4),
(102964, NULL, 'G3DSA:3.40.1110.10:FF:000257', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102965, NULL, 'G3DSA:2.60.60.20:FF:000029', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(102966, NULL, 'G3DSA:3.30.360.10:FF:000020', NULL, NULL, 'Biliverdin reductase A', NULL, NULL, NULL, NULL, NULL, 4),
(102967, NULL, 'G3DSA:3.30.40.10:FF:000114', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(102968, NULL, 'G3DSA:3.40.80.10:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102969, NULL, 'G3DSA:3.40.50.300:FF:001245', NULL, NULL, 'ATP-dependent RNA helicase DbpA', NULL, NULL, NULL, NULL, NULL, 4),
(102970, NULL, 'G3DSA:2.130.10.10:FF:001863', NULL, NULL, 'Peptidase S41', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(102971, NULL, 'G3DSA:3.30.160.60:FF:002728', NULL, NULL, 'metal regulatory transcription factor 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(102972, NULL, 'G3DSA:3.30.420.40:FF:000635', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(102973, NULL, 'G3DSA:2.130.10.10:FF:002700', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102974, NULL, 'G3DSA:1.20.120.1190:FF:000001', NULL, NULL, 'Nucleolar GTP-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(102975, NULL, 'G3DSA:2.60.40.10:FF:006101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102976, NULL, 'G3DSA:3.40.50.800:FF:000119', NULL, NULL, 'Threonine--tRNA ligase editing subunit', NULL, NULL, NULL, NULL, NULL, 4),
(102977, NULL, 'G3DSA:3.30.70.141:FF:000024', NULL, NULL, 'Nucleoside diphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(102978, NULL, 'G3DSA:1.10.10.60:FF:000559', NULL, NULL, 'Unplaced genomic scaffold supercont1.71, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(102979, NULL, 'G3DSA:2.20.130.20:FF:000012', NULL, NULL, 'pregnancy zone protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(102980, NULL, 'G3DSA:2.60.40.10:FF:005825', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102981, NULL, 'G3DSA:2.40.30.10:FF:000481', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(102982, NULL, 'G3DSA:2.30.29.30:FF:001214', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(102983, NULL, 'G3DSA:3.30.160.60:FF:003004', NULL, NULL, 'Zinc finger protein 560', NULL, NULL, NULL, NULL, NULL, 4),
(102984, NULL, 'G3DSA:3.30.160.60:FF:002604', NULL, NULL, 'Zinc finger protein 715', NULL, NULL, NULL, NULL, NULL, 4),
(102985, NULL, 'G3DSA:3.30.160.60:FF:006438', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(102986, NULL, 'G3DSA:3.80.10.10:FF:002667', NULL, NULL, 'Leucine-rich repeat transmembrane protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(102987, NULL, 'G3DSA:1.10.1410.40:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102988, NULL, 'G3DSA:2.40.10.10:FF:000136', NULL, NULL, 'Kallikrein related-peptidase 12', NULL, NULL, NULL, NULL, NULL, 4),
(102989, NULL, 'G3DSA:3.40.50.150:FF:000093', NULL, NULL, 'mRNA cap guanine-N7 methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(102990, NULL, 'G3DSA:1.10.8.60:FF:000468', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(102991, NULL, 'G3DSA:2.110.10.10:FF:000043', NULL, NULL, 'Zmp-1', NULL, NULL, NULL, NULL, NULL, 4),
(102992, NULL, 'G3DSA:2.20.25.10:FF:000008', NULL, NULL, 'DNA-directed RNA polymerase II subunit RPB9', NULL, NULL, NULL, NULL, NULL, 4),
(102993, NULL, 'G3DSA:3.40.630.30:FF:000275', NULL, NULL, '[Ribosomal protein S18]-alanine N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(102994, NULL, 'G3DSA:3.30.200.20:FF:000208', NULL, NULL, 'Ribosomal protein S6 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(102995, NULL, 'G3DSA:3.40.47.10:FF:000090', NULL, NULL, 'Lipid transfer protein or keto acyl-CoA thiolase Ltp2', NULL, NULL, NULL, NULL, NULL, 4),
(102996, NULL, 'G3DSA:1.25.40.20:FF:000297', NULL, NULL, 'Asparaginase homolog (S. cerevisiae)', NULL, NULL, NULL, NULL, NULL, 4),
(102997, NULL, 'G3DSA:1.25.10.10:FF:001894', NULL, NULL, 'AaceriACL132Cp', NULL, NULL, NULL, NULL, NULL, 4),
(102998, NULL, 'G3DSA:3.80.10.10:FF:001094', NULL, NULL, 'Relaxin/insulin-like family peptide receptor 2 splice variant 1', NULL, NULL, NULL, NULL, NULL, 4),
(102999, NULL, 'G3DSA:3.30.160.60:FF:000497', NULL, NULL, 'Endolytic murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(103000, NULL, 'G3DSA:1.10.30.10:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103001, NULL, 'G3DSA:1.20.1310.10:FF:000211', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103002, NULL, 'G3DSA:1.10.8.270:FF:000160', NULL, NULL, 'TBC1 domain family, member 15', NULL, NULL, NULL, NULL, NULL, 4),
(103003, NULL, 'G3DSA:1.25.40.10:FF:001396', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g33170', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(103004, NULL, 'G3DSA:3.30.70.890:FF:000074', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103005, NULL, 'G3DSA:1.20.1070.10:FF:001956', NULL, NULL, 'Muscarinic acetylcholine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(103006, NULL, 'G3DSA:3.90.1140.10:FF:000034', NULL, NULL, 'U6 snRNA phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(103007, NULL, 'G3DSA:1.10.10.10:FF:001303', NULL, NULL, 'Cell division protein FtsK', NULL, NULL, NULL, NULL, NULL, 4),
(103008, NULL, 'G3DSA:2.130.10.80:FF:000001', NULL, NULL, 'Aldehyde oxidase GLOX', NULL, NULL, NULL, NULL, NULL, 4),
(103009, NULL, 'G3DSA:3.30.420.40:FF:000910', NULL, NULL, 'Actin-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(103010, NULL, 'G3DSA:3.30.1010.10:FF:000004', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(103011, NULL, 'G3DSA:3.10.20.90:FF:000244', NULL, NULL, '3-oxo-5-alpha-steroid 4-dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103012, NULL, 'G3DSA:3.30.40.10:FF:000900', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(103013, NULL, 'G3DSA:1.10.3090.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103014, NULL, 'G3DSA:2.70.150.10:FF:000038', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(103015, NULL, 'G3DSA:3.30.160.60:FF:002149', NULL, NULL, 'Zinc finger protein 256', NULL, NULL, NULL, NULL, NULL, 4),
(103016, NULL, 'G3DSA:1.25.40.10:FF:000294', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g09900', NULL, NULL, NULL, NULL, NULL, 4),
(103017, NULL, 'G3DSA:4.10.240.10:FF:000068', NULL, NULL, 'C6 transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103018, NULL, 'G3DSA:2.60.40.10:FF:004763', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103019, NULL, 'G3DSA:2.60.40.150:FF:000545', NULL, NULL, 'Phospholipase A2', NULL, NULL, NULL, NULL, NULL, 4),
(103020, NULL, 'G3DSA:2.130.10.10:FF:005876', NULL, NULL, 'Apoptotic protease-activating factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(103021, NULL, 'G3DSA:3.40.50.2300:FF:001479', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103022, NULL, 'G3DSA:2.60.40.10:FF:003774', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103023, NULL, 'G3DSA:1.10.472.10:FF:000505', NULL, NULL, 'Uncharacterized cyclin-L1-like protein C1296.05c', NULL, NULL, NULL, NULL, NULL, 4),
(103024, NULL, 'G3DSA:3.30.500.10:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103025, NULL, 'G3DSA:3.40.30.10:FF:001130', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103026, NULL, 'G3DSA:1.10.287.70:FF:000694', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103027, NULL, 'G3DSA:3.90.1150.10:FF:000006', NULL, NULL, 'Phosphoserine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(103028, NULL, 'G3DSA:2.40.50.1060:FF:000017', NULL, NULL, 'DNA-directed RNA polymerase I subunit RPA43', NULL, NULL, NULL, NULL, NULL, 4),
(103029, NULL, 'G3DSA:3.40.50.300:FF:000913', NULL, NULL, 'ABC multidrug transporter SitT', NULL, NULL, NULL, NULL, NULL, 4),
(103030, NULL, 'G3DSA:3.30.230.130:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103031, NULL, 'G3DSA:3.30.40.10:FF:001356', NULL, NULL, 'Structure-specific endonuclease subunit SLX1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(103032, NULL, 'G3DSA:1.10.3080.10:FF:000066', NULL, NULL, 'Chloride channel protein CLC-b', NULL, NULL, NULL, NULL, NULL, 4),
(103033, NULL, 'G3DSA:2.130.10.10:FF:002650', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103034, NULL, 'G3DSA:1.25.40.10:FF:002385', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103035, NULL, 'G3DSA:3.40.1090.10:FF:000030', NULL, NULL, 'Lysophospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(103036, NULL, 'G3DSA:2.40.10.10:FF:000530', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103037, NULL, 'G3DSA:1.20.120.1900:FF:000080', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(103038, NULL, 'G3DSA:1.10.8.720:FF:000047', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(103039, NULL, 'G3DSA:1.25.40.10:FF:004037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103040, NULL, 'G3DSA:1.10.10.10:FF:000640', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(103041, NULL, 'G3DSA:2.60.40.1120:FF:000070', NULL, NULL, 'SusC homolog', NULL, NULL, NULL, NULL, NULL, 4),
(103042, NULL, 'G3DSA:3.40.640.10:FF:000354', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103043, NULL, 'G3DSA:3.20.20.140:FF:000375', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103044, NULL, 'G3DSA:3.40.50.10050:FF:000003', NULL, NULL, 'translation initiation factor IF-2, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(103045, NULL, 'G3DSA:3.40.50.970:FF:000153', NULL, NULL, 'Indolepyruvate oxidoreductase subunit IorA', NULL, NULL, NULL, NULL, NULL, 4),
(103046, NULL, 'G3DSA:2.60.40.1730:FF:000039', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(103047, NULL, 'G3DSA:1.10.3810.10:FF:000010', NULL, NULL, 'Penicillin-binding protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(103048, NULL, 'G3DSA:2.40.160.10:FF:000051', NULL, NULL, 'Voltage-dependent anion-selective channel protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(103049, NULL, 'G3DSA:3.40.50.720:FF:000949', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(103050, NULL, 'G3DSA:3.40.50.300:FF:008344', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(103051, NULL, 'G3DSA:3.30.420.40:FF:000264', NULL, NULL, 'Adenosine-diphosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103052, NULL, 'G3DSA:1.10.630.10:FF:000497', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103053, NULL, 'G3DSA:3.40.50.1440:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103054, NULL, 'G3DSA:3.90.76.10:FF:000014', NULL, NULL, 'Extracellular solute-binding protein family 5', NULL, NULL, NULL, NULL, NULL, 4),
(103055, NULL, 'G3DSA:3.30.160.60:FF:001014', NULL, NULL, 'Zinc finger protein 597', NULL, NULL, NULL, NULL, NULL, 4),
(103056, NULL, 'G3DSA:3.30.1640.10:FF:000035', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(103057, NULL, 'G3DSA:2.60.40.10:FF:001211', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(103058, NULL, 'G3DSA:1.10.1070.11:FF:000105', NULL, NULL, 'Protein kinase, DNA-activated, catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(103059, NULL, 'G3DSA:1.25.10.10:FF:002557', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103060, NULL, 'G3DSA:3.30.200.20:FF:001669', NULL, NULL, 'Serine/threonine kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103061, NULL, 'G3DSA:2.120.10.80:FF:000142', NULL, NULL, 'tRNA wybutosine-synthesizing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(103062, NULL, 'G3DSA:1.10.3720.10:FF:000211', NULL, NULL, 'Dipeptide transport system permease protein DppC', NULL, NULL, NULL, NULL, NULL, 4),
(103063, NULL, 'G3DSA:2.60.120.970:FF:000036', NULL, NULL, 'Bone morphogenetic protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(103064, NULL, 'G3DSA:3.10.20.10:FF:000001', NULL, NULL, '60S ribosomal protein L18a', NULL, NULL, NULL, NULL, NULL, 4),
(103065, NULL, 'G3DSA:3.40.50.300:FF:000267', NULL, NULL, 'ATP-binding cassette, sub-family G (WHITE), member 1', NULL, NULL, NULL, NULL, NULL, 4),
(103066, NULL, 'G3DSA:1.20.1540.10:FF:000020', NULL, NULL, 'Rhomboid family intramembrane serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(103067, NULL, 'G3DSA:1.10.540.10:FF:000052', NULL, NULL, 'Acyl-CoA dehydrogenase FadE34', NULL, NULL, NULL, NULL, NULL, 4),
(103068, NULL, 'G3DSA:3.30.160.60:FF:006483', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103069, NULL, 'G3DSA:1.25.10.10:FF:000466', NULL, NULL, 'Beta-catenin-like protein 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103070, NULL, 'G3DSA:3.40.50.880:FF:000098', NULL, NULL, 'Hydrogenobyrinate a,c-diamide synthase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(103071, NULL, 'G3DSA:2.40.37.20:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103072, NULL, 'G3DSA:2.20.25.30:FF:000020', NULL, NULL, 'Ribosomal protein L37', NULL, NULL, NULL, NULL, NULL, 4),
(103073, NULL, 'G3DSA:1.25.40.10:FF:002059', NULL, NULL, 'Clustered mitochondria protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(103074, NULL, 'G3DSA:2.60.260.20:FF:000074', NULL, NULL, 'Putative heat shock protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(103075, NULL, 'G3DSA:3.30.70.330:FF:002053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103076, NULL, 'G3DSA:2.60.40.10:FF:005898', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103077, NULL, 'G3DSA:1.10.510.10:FF:000550', NULL, NULL, 'Serine/threonine kinase 16', NULL, NULL, NULL, NULL, NULL, 4),
(103078, NULL, 'G3DSA:3.30.2310.20:FF:000019', NULL, NULL, 'Gsr3132 protein', NULL, NULL, NULL, NULL, NULL, 4),
(103079, NULL, 'G3DSA:1.25.40.1010:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103080, NULL, 'G3DSA:3.10.20.30:FF:000007', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] iron-sulfur subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(103081, NULL, 'G3DSA:3.90.226.10:FF:000150', NULL, NULL, 'ECHDC1 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(103082, NULL, 'G3DSA:2.60.120.560:FF:000003', NULL, NULL, 'Extracellular exo-inulinase inuE', NULL, NULL, NULL, NULL, NULL, 4),
(103083, NULL, 'G3DSA:3.40.50.300:FF:004275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103084, NULL, 'G3DSA:1.10.8.710:FF:000011', NULL, NULL, 'Axonemal dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(103085, NULL, 'G3DSA:1.10.220.150:FF:000044', NULL, NULL, 'ADP-ribosylation factor GTPase-activating protein 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(103086, NULL, 'G3DSA:3.10.28.10:FF:000030', NULL, NULL, 'Uncharacterized mitochondrial protein RF1', NULL, NULL, NULL, NULL, NULL, 4),
(103087, NULL, 'G3DSA:1.10.510.10:FF:001213', NULL, NULL, 'serine/threonine-protein kinase Nek10', NULL, NULL, NULL, NULL, NULL, 4),
(103088, NULL, 'G3DSA:2.30.33.40:FF:000018', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103089, NULL, 'G3DSA:3.20.20.70:FF:000682', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103090, NULL, 'G3DSA:3.80.10.10:FF:000958', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(103091, NULL, 'G3DSA:3.90.1480.20:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103092, NULL, 'G3DSA:1.20.58.390:FF:000322', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103093, NULL, 'G3DSA:2.60.40.60:FF:000337', NULL, NULL, 'Cadherin 74A, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(103094, NULL, 'G3DSA:1.10.287.690:FF:000008', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(103095, NULL, 'G3DSA:1.10.510.10:FF:002641', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103096, NULL, 'G3DSA:2.30.30.40:FF:000304', NULL, NULL, 'Sporulation protein', NULL, NULL, NULL, NULL, NULL, 4),
(103097, NULL, 'G3DSA:1.25.10.10:FF:002411', NULL, NULL, 'CAP-G condensin subunit', NULL, NULL, NULL, NULL, NULL, 4),
(103098, NULL, 'G3DSA:1.10.287.160:FF:000024', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(103099, NULL, 'G3DSA:2.20.70.10:FF:000023', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(103100, NULL, 'G3DSA:2.40.160.210:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103101, NULL, 'G3DSA:2.120.10.30:FF:000234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103102, NULL, 'G3DSA:3.40.50.1820:FF:000160', NULL, NULL, 'Phospholipid:diacylglycerol acyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(103103, NULL, 'G3DSA:3.80.10.10:FF:002875', NULL, NULL, 'F-box/leucine rich repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103104, NULL, 'G3DSA:1.20.1530.20:FF:000051', NULL, NULL, 'Os12g0616500 protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(103105, NULL, 'G3DSA:3.40.50.10860:FF:000066', NULL, NULL, 'Bifunctional protein FolD', NULL, NULL, NULL, NULL, NULL, 4),
(103106, NULL, 'G3DSA:3.40.50.300:FF:002184', NULL, NULL, '6-phosphofructo-2-kinase/fructose-2, 6-bisphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(103107, NULL, 'G3DSA:3.40.50.720:FF:001764', NULL, NULL, 'NAD-dependent epimerase/dehydratase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(103108, NULL, 'G3DSA:3.30.750.80:FF:000003', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase K/L', NULL, NULL, NULL, NULL, NULL, 4),
(103109, NULL, 'G3DSA:1.10.150.240:FF:000083', NULL, NULL, 'Phosphoglycolate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(103110, NULL, 'G3DSA:2.30.42.10:FF:000042', NULL, NULL, 'Membrane-associated guanylate kinase, WW and PDZ domain-containing protein 3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(103111, NULL, 'G3DSA:3.50.7.10:FF:000060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103112, NULL, 'G3DSA:1.20.5.300:FF:000009', NULL, NULL, 'Spike glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(103113, NULL, 'G3DSA:3.10.20.90:FF:000570', NULL, NULL, 'Abnormal cell migration protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(103114, NULL, 'G3DSA:1.20.1250.20:FF:001850', NULL, NULL, 'Sodium-dependent glucose transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103115, NULL, 'G3DSA:3.90.660.10:FF:000012', NULL, NULL, 'Polyamine oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(103116, NULL, 'G3DSA:3.30.160.60:FF:000351', NULL, NULL, 'Zinc finger and AT-hook domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(103117, NULL, 'G3DSA:3.30.470.160:FF:000012', NULL, NULL, 'Uncharacterized inositol polyphosphate kinase C970.08', NULL, NULL, NULL, NULL, NULL, 4),
(103118, NULL, 'G3DSA:3.40.50.300:FF:004921', NULL, NULL, 'Protein-tyrosine sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(103119, NULL, 'G3DSA:2.70.170.10:FF:000247', NULL, NULL, 'Cholinergic receptor nicotinic beta 1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(103120, NULL, 'G3DSA:1.10.510.10:FF:000224', NULL, NULL, 'serine/threonine-protein kinase mph1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(103121, NULL, 'G3DSA:3.90.550.10:FF:000476', NULL, NULL, 'Glycosyltransferase involved in cell wall bisynthesis', NULL, NULL, NULL, NULL, NULL, 4),
(103122, NULL, 'G3DSA:1.10.10.10:FF:002085', NULL, NULL, 'Transcriptional regulator/arsenate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(103123, NULL, 'G3DSA:1.20.120.1490:FF:000006', NULL, NULL, 'CpxP superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(103124, NULL, 'G3DSA:1.10.1510.30:FF:000004', NULL, NULL, 'Probable tRNA pseudouridine synthase D 2', NULL, NULL, NULL, NULL, NULL, 4),
(103125, NULL, 'G3DSA:2.130.10.10:FF:000407', NULL, NULL, 'Eukaryotic translation initiation factor 2A', NULL, NULL, NULL, NULL, NULL, 4),
(103126, NULL, 'G3DSA:3.20.20.100:FF:000211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103127, NULL, 'G3DSA:1.10.3620.10:FF:000001', NULL, NULL, 'YdcF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(103128, NULL, 'G3DSA:1.25.40.10:FF:000614', NULL, NULL, 'Sister chromatid cohesion protein SCC4', NULL, NULL, NULL, NULL, NULL, 4),
(103129, NULL, 'G3DSA:2.40.10.10:FF:000237', NULL, NULL, 'Trypsin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103130, NULL, 'G3DSA:1.10.238.10:FF:000271', NULL, NULL, 'Epidermal growth factor receptor substrate 15 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(103131, NULL, 'G3DSA:3.90.1410.10:FF:000044', NULL, NULL, 'SET domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(103132, NULL, 'G3DSA:3.30.420.10:FF:000688', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103133, NULL, 'G3DSA:1.25.40.20:FF:000617', NULL, NULL, 'Ankyrin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(103134, NULL, 'G3DSA:3.30.1360.10:FF:000053', NULL, NULL, 'RNA polymerase I and III subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(103135, NULL, 'G3DSA:3.90.660.20:FF:000015', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(103136, NULL, 'G3DSA:3.20.20.140:FF:000049', NULL, NULL, 'DNA polymerase III subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(103137, NULL, 'G3DSA:3.40.850.10:FF:000280', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(103138, NULL, 'G3DSA:3.40.190.10:FF:000133', NULL, NULL, 'Lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(103139, NULL, 'G3DSA:2.60.120.650:FF:000204', NULL, NULL, 'Putative lysine-specific demethylase JMJ16', NULL, NULL, NULL, NULL, NULL, 4),
(103140, NULL, 'G3DSA:3.40.50.150:FF:000672', NULL, NULL, 'RNA methylase', NULL, NULL, NULL, NULL, NULL, 4),
(103141, NULL, 'G3DSA:3.30.1360.120:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103142, NULL, 'G3DSA:2.40.70.10:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103143, NULL, 'G3DSA:2.30.29.30:FF:001158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103144, NULL, 'G3DSA:3.90.226.10:FF:000296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103145, NULL, 'G3DSA:3.40.50.1820:FF:001615', NULL, NULL, 'Serine carboxypeptidase S28 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(103146, NULL, 'G3DSA:3.30.70.20:FF:000085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103147, NULL, 'G3DSA:1.20.1280.50:FF:000259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103148, NULL, 'G3DSA:2.60.40.10:FF:000429', NULL, NULL, 'Mast/stem cell growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(103149, NULL, 'G3DSA:3.30.830.10:FF:000062', NULL, NULL, 'Mitochondrial-processing peptidase subunit alpha-1', NULL, NULL, NULL, NULL, NULL, 4),
(103150, NULL, 'G3DSA:3.30.505.10:FF:000239', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103151, NULL, 'G3DSA:1.10.1410.10:FF:000108', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103152, NULL, 'G3DSA:1.10.510.10:FF:004086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103153, NULL, 'G3DSA:2.160.20.10:FF:000047', NULL, NULL, 'F-box protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(103154, NULL, 'G3DSA:2.130.10.10:FF:003898', NULL, NULL, 'WD40 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(103155, NULL, 'G3DSA:2.10.25.10:FF:000003', NULL, NULL, 'fibrillin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(103156, NULL, 'G3DSA:2.30.140.10:FF:000007', NULL, NULL, 'Polyamine aminopropyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(103157, NULL, 'G3DSA:3.40.1370.10:FF:000012', NULL, NULL, '50S ribosomal protein L4', NULL, NULL, NULL, NULL, NULL, 4),
(103158, NULL, 'G3DSA:3.30.2400.30:FF:000001', NULL, NULL, '29 kDa antigen', NULL, NULL, NULL, NULL, NULL, 4),
(103159, NULL, 'G3DSA:2.170.150.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103160, NULL, 'G3DSA:3.40.50.300:FF:002830', NULL, NULL, 'Guanylate-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(103161, NULL, 'G3DSA:3.40.50.10470:FF:000039', NULL, NULL, 'Translation initiation factor 2B', NULL, NULL, NULL, NULL, NULL, 4),
(103162, NULL, 'G3DSA:3.30.230.10:FF:000033', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(103163, NULL, 'G3DSA:1.10.220.10:FF:000005', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(103164, NULL, 'G3DSA:3.40.50.12760:FF:000018', NULL, NULL, 'AGAP005415-PA', NULL, NULL, NULL, NULL, NULL, 4),
(103165, NULL, 'G3DSA:2.60.40.10:FF:003009', NULL, NULL, 'Auxin-induced beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(103166, NULL, 'G3DSA:2.130.10.10:FF:004741', NULL, NULL, 'AAR103Cp', NULL, NULL, NULL, NULL, NULL, 4),
(103167, NULL, 'G3DSA:2.60.220.50:FF:000024', NULL, NULL, 'latrophilin Cirl isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(103168, NULL, 'G3DSA:3.30.1310.10:FF:000016', NULL, NULL, 'Nucleoid-associated protein SAMN04488058_11828', NULL, NULL, NULL, NULL, NULL, 4),
(103169, NULL, 'G3DSA:1.10.20.10:FF:000079', NULL, NULL, 'Transcription initiation factor TFIID subunit 6, putative', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(103170, NULL, 'G3DSA:3.40.30.10:FF:000933', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103171, NULL, 'G3DSA:2.40.100.10:FF:000042', NULL, NULL, 'Multifunctional urea amidolyase', NULL, NULL, NULL, NULL, NULL, 4),
(103172, NULL, 'G3DSA:3.30.430.20:FF:000017', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(103173, NULL, 'G3DSA:3.90.70.10:FF:000826', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103174, NULL, 'G3DSA:1.10.238.10:FF:000950', NULL, NULL, 'Calcium-binding protein CML42', NULL, NULL, NULL, NULL, NULL, 4),
(103175, NULL, 'G3DSA:3.90.740.10:FF:000013', NULL, NULL, 'Isoleucine--tRNA ligase, chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(103176, NULL, 'G3DSA:3.30.1330.20:FF:000054', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(103177, NULL, 'G3DSA:3.30.70.330:FF:001917', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103178, NULL, 'G3DSA:3.10.450.10:FF:000060', NULL, NULL, 'Ovocalyxin-32', NULL, NULL, NULL, NULL, NULL, 4),
(103179, NULL, 'G3DSA:1.25.40.10:FF:004330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103180, NULL, 'G3DSA:1.25.40.20:FF:001140', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(103181, NULL, 'G3DSA:1.10.510.10:FF:003776', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103182, NULL, 'G3DSA:3.30.200.20:FF:002125', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103183, NULL, 'G3DSA:1.10.150.20:FF:000305', NULL, NULL, '1,4-alpha-glucan branching enzyme TK1436', NULL, NULL, NULL, NULL, NULL, 4),
(103184, NULL, 'G3DSA:2.60.40.1180:FF:000155', NULL, NULL, 'Oligo-1,6-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(103185, NULL, 'G3DSA:3.80.10.10:FF:001740', NULL, NULL, 'K7_Sog2p', NULL, NULL, NULL, NULL, NULL, 4),
(103186, NULL, 'G3DSA:1.10.3210.10:FF:000127', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103187, NULL, 'G3DSA:2.30.180.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103188, NULL, 'G3DSA:1.10.510.10:FF:000903', NULL, NULL, 'Receptor-like protein kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(103189, NULL, 'G3DSA:1.10.10.10:FF:000314', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(103190, NULL, 'G3DSA:1.10.1370.30:FF:000032', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(103191, NULL, 'G3DSA:3.30.1330.30:FF:000057', NULL, NULL, 'Peptide chain release factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(103192, NULL, 'G3DSA:3.30.70.2190:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103193, NULL, 'G3DSA:3.20.20.80:FF:000100', NULL, NULL, 'Glycoside hydrolase superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(103194, NULL, 'G3DSA:1.20.1050.80:FF:000026', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103195, NULL, 'G3DSA:3.30.420.80:FF:000017', NULL, NULL, 'Uncharacterized protein TCIL3000_10_8880', NULL, NULL, NULL, NULL, NULL, 4),
(103196, NULL, 'G3DSA:3.40.50.1100:FF:000091', NULL, NULL, 'Related to L-serine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(103197, NULL, 'G3DSA:3.30.565.10:FF:000074', NULL, NULL, 'Sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(103198, NULL, 'G3DSA:3.30.200.20:FF:001995', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103199, NULL, 'G3DSA:3.80.10.10:FF:001947', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103200, NULL, 'G3DSA:3.10.100.10:FF:000011', NULL, NULL, 'Aggrecan core protein', NULL, NULL, NULL, NULL, NULL, 4),
(103201, NULL, 'G3DSA:3.30.420.610:FF:000019', NULL, NULL, 'Putative endonuclease or glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(103202, NULL, 'G3DSA:2.60.200.20:FF:000065', NULL, NULL, 'Serine/threonine-protein kinase RAD53', NULL, NULL, NULL, NULL, NULL, 4),
(103203, NULL, 'G3DSA:2.40.30.10:FF:000093', NULL, NULL, 'Naphthalene 1,2-dioxygenase reductase component', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(103204, NULL, 'G3DSA:3.30.70.270:FF:000303', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103205, NULL, 'G3DSA:1.20.58.70:FF:000059', NULL, NULL, 'Qa-SNARE protein', NULL, NULL, NULL, NULL, NULL, 4),
(103206, NULL, 'G3DSA:2.40.30.10:FF:000413', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103207, NULL, 'G3DSA:3.40.50.300:FF:008018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103208, NULL, 'G3DSA:3.40.140.10:FF:000035', NULL, NULL, 'dCMP deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(103209, NULL, 'G3DSA:1.10.400.10:FF:000042', NULL, NULL, 'Guanine nucleotide-binding protein alpha-12 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(103210, NULL, 'G3DSA:1.10.750.20:FF:000008', NULL, NULL, 'Suppressor of cytokine signaling, invertebrate', NULL, NULL, NULL, NULL, NULL, 4),
(103211, NULL, 'G3DSA:3.90.1070.20:FF:000008', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(103212, NULL, 'G3DSA:2.60.40.10:FF:000901', NULL, NULL, 'Titin b', NULL, NULL, NULL, NULL, NULL, 4),
(103213, NULL, 'G3DSA:1.25.40.10:FF:001749', NULL, NULL, 'Actin binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103214, NULL, 'G3DSA:3.90.70.10:FF:000147', NULL, NULL, 'Ubiquitin specific protease', NULL, NULL, NULL, NULL, NULL, 4),
(103215, NULL, 'G3DSA:2.20.28.10:FF:000015', NULL, NULL, 'DNA replication licensing factor MCM3', NULL, NULL, NULL, NULL, NULL, 4),
(103216, NULL, 'G3DSA:3.40.50.150:FF:000733', NULL, NULL, 'GD20129', NULL, NULL, NULL, NULL, NULL, 4),
(103217, NULL, 'G3DSA:1.10.1450.10:FF:000173', NULL, NULL, 'Retinal degradation slow', NULL, NULL, NULL, NULL, NULL, 4),
(103218, NULL, 'G3DSA:3.40.50.720:FF:001085', NULL, NULL, 'LD36273p', NULL, NULL, NULL, NULL, NULL, 4),
(103219, NULL, 'G3DSA:3.30.750.24:FF:000012', NULL, NULL, 'Sulfate transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(103220, NULL, 'G3DSA:1.10.3210.10:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103221, NULL, 'G3DSA:2.60.40.10:FF:002672', NULL, NULL, 'Ig and fibronectin type-III', NULL, NULL, NULL, NULL, NULL, 4),
(103222, NULL, 'G3DSA:3.40.50.12780:FF:000030', NULL, NULL, 'Acyl-CoA synthetase family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(103223, NULL, 'G3DSA:3.90.550.50:FF:000055', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(103224, NULL, 'G3DSA:2.70.98.10:FF:000028', NULL, NULL, 'Alpha-1,2-mannosidase family protein (AFU_orthologue AFUA_5G10520)', NULL, NULL, NULL, NULL, NULL, 4),
(103225, NULL, 'G3DSA:1.10.287.110:FF:000442', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103226, NULL, 'G3DSA:1.25.10.10:FF:001568', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103227, NULL, 'G3DSA:2.60.40.1220:FF:000009', NULL, NULL, 'Copper resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(103228, NULL, 'G3DSA:3.30.750.44:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103229, NULL, 'G3DSA:3.30.70.330:FF:001856', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103230, NULL, 'G3DSA:3.80.10.10:FF:001268', NULL, NULL, 'Receptor-like protein 9DC3', NULL, NULL, NULL, NULL, NULL, 4),
(103231, NULL, 'G3DSA:3.30.200.20:FF:000034', NULL, NULL, 'Kinase suppressor of Ras 1', NULL, NULL, NULL, NULL, NULL, 4),
(103232, NULL, 'G3DSA:3.30.1460.50:FF:000016', NULL, NULL, 'ubiquitin-like-conjugating enzyme ATG10 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(103233, NULL, 'G3DSA:3.10.20.90:FF:000418', NULL, NULL, 'UBX domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(103234, NULL, 'G3DSA:3.10.50.10:FF:000003', NULL, NULL, 'Class V chitinase CHIT5b', NULL, NULL, NULL, NULL, NULL, 4),
(103235, NULL, 'G3DSA:3.30.160.60:FF:005994', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103236, NULL, 'G3DSA:1.20.1510.10:FF:000013', NULL, NULL, 'Cation efflux family protein', NULL, NULL, NULL, NULL, NULL, 4),
(103237, NULL, 'G3DSA:2.60.40.10:FF:005691', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(103238, NULL, 'G3DSA:1.20.1640.10:FF:000084', NULL, NULL, 'PaTched Related family', NULL, NULL, NULL, NULL, NULL, 4),
(103239, NULL, 'G3DSA:3.90.70.10:FF:000473', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(103240, NULL, 'G3DSA:2.130.10.10:FF:000733', NULL, NULL, 'WD40 repeat-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(103241, NULL, 'G3DSA:2.80.10.50:FF:000282', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103242, NULL, 'G3DSA:2.60.40.10:FF:002846', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(103243, NULL, 'G3DSA:1.10.10.10:FF:001949', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103244, NULL, 'G3DSA:3.20.20.105:FF:000015', NULL, NULL, 'tRNA-guanine transglycosylases, various specificities family protein', NULL, NULL, NULL, NULL, NULL, 4),
(103245, NULL, 'G3DSA:3.40.50.300:FF:006427', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103246, NULL, 'G3DSA:1.10.260.60:FF:000005', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', NULL, NULL, NULL, NULL, NULL, 4),
(103247, NULL, 'G3DSA:1.10.510.10:FF:000078', NULL, NULL, 'Serine/threonine-protein kinase PRP4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(103248, NULL, 'G3DSA:2.60.200.20:FF:000126', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(103249, NULL, 'G3DSA:3.40.630.30:FF:000449', NULL, NULL, 'Iron transport protein B', NULL, NULL, NULL, NULL, NULL, 4),
(103250, NULL, 'G3DSA:3.40.50.300:FF:002504', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(103251, NULL, 'G3DSA:3.40.50.1780:FF:000007', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NAR1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103252, NULL, 'G3DSA:3.90.550.10:FF:000622', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103253, NULL, 'G3DSA:4.10.372.10:FF:000003', NULL, NULL, 'Lipoxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(103254, NULL, 'G3DSA:1.10.260.50:FF:000002', NULL, NULL, 'Cysteine desulfurase NifS', NULL, NULL, NULL, NULL, NULL, 4),
(103255, NULL, 'G3DSA:3.40.50.1000:FF:000740', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103256, NULL, 'G3DSA:1.20.1250.20:FF:001232', NULL, NULL, 'Protein NRT1/ PTR FAMILY 1.2', NULL, NULL, NULL, NULL, NULL, 4),
(103257, NULL, 'G3DSA:2.40.50.100:FF:000071', NULL, NULL, 'Dihydrolipoyllysine-residue succinyltransferase component of 2-oxoglutarate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(103258, NULL, 'G3DSA:3.30.2160.10:FF:000072', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103259, NULL, 'G3DSA:2.130.10.10:FF:000379', NULL, NULL, 'WD repeat domain 78', NULL, NULL, NULL, NULL, NULL, 4),
(103260, NULL, 'G3DSA:3.40.50.720:FF:001438', NULL, NULL, 'D-amino acid oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(103261, NULL, 'G3DSA:2.170.270.10:FF:000124', NULL, NULL, 'PR domain 4', NULL, NULL, NULL, NULL, NULL, 4),
(103262, NULL, 'G3DSA:2.40.50.140:FF:000324', NULL, NULL, 'Aspartate--tRNA(Asp/Asn) ligase', NULL, NULL, NULL, NULL, NULL, 4),
(103263, NULL, 'G3DSA:3.30.559.10:FF:000161', NULL, NULL, 'MFS transporter/NRPS-like enzyme, putative (JCVI)', NULL, NULL, NULL, NULL, NULL, 4),
(103264, NULL, 'G3DSA:3.40.50.1100:FF:000118', NULL, NULL, 'Related to CYS4-cystathionine beta-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(103265, NULL, 'G3DSA:3.30.160.60:FF:004712', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103266, NULL, 'G3DSA:1.20.1070.10:FF:002120', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103267, NULL, 'G3DSA:1.10.10.10:FF:000814', NULL, NULL, 'Unplaced genomic scaffold supercont1.10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(103268, NULL, 'G3DSA:3.40.630.10:FF:000089', NULL, NULL, 'N-acetylated alpha-linked acidic dipeptidase like 1', NULL, NULL, NULL, NULL, NULL, 4),
(103269, NULL, 'G3DSA:2.70.130.10:FF:000155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(103270, NULL, 'G3DSA:3.40.50.300:FF:001402', NULL, NULL, 'Discs, large homolog 3 (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(103271, NULL, 'G3DSA:3.40.630.10:FF:000443', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103272, NULL, 'G3DSA:3.40.50.300:FF:002684', NULL, NULL, 'Dynamin-1 family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103273, NULL, 'G3DSA:3.40.50.1760:FF:000001', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(103274, NULL, 'G3DSA:3.30.210.10:FF:000003', NULL, NULL, 'DNA nucleotidylexotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(103275, NULL, 'G3DSA:3.40.50.300:FF:006719', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103276, NULL, 'G3DSA:1.10.287.40:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103277, NULL, 'G3DSA:3.10.520.10:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103278, NULL, 'G3DSA:1.20.140.150:FF:000012', NULL, NULL, 'Claudin', NULL, NULL, NULL, NULL, NULL, 4),
(103279, NULL, 'G3DSA:3.40.30.10:FF:000787', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103280, NULL, 'G3DSA:1.10.510.10:FF:002848', NULL, NULL, 'Protein phosphatase 2C-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(103281, NULL, 'G3DSA:1.10.357.140:FF:000001', NULL, NULL, 'Protoheme IX farnesyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(103282, NULL, 'G3DSA:3.80.10.10:FF:001447', NULL, NULL, 'Os08g0459100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(103283, NULL, 'G3DSA:3.30.390.60:FF:000008', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(103284, NULL, 'G3DSA:3.40.50.1580:FF:000071', NULL, NULL, 'Purine nucleoside phosphorylase 4b', NULL, NULL, NULL, NULL, NULL, 4),
(103285, NULL, 'G3DSA:3.30.420.40:FF:000438', NULL, NULL, 'Related to ARP5-Actin-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(103286, NULL, 'G3DSA:3.70.10.10:FF:000127', NULL, NULL, 'RAD9 checkpoint clamp component B', NULL, NULL, NULL, NULL, NULL, 4),
(103287, NULL, 'G3DSA:3.40.50.1100:FF:000298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103288, NULL, 'G3DSA:3.40.50.1000:FF:000386', NULL, NULL, 'Mg-dependent acid phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(103289, NULL, 'G3DSA:3.30.390.50:FF:000005', NULL, NULL, 'Lipoyltransferase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(103290, NULL, 'G3DSA:4.10.400.10:FF:000283', NULL, NULL, 'glycoprotein 330-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(103291, NULL, 'G3DSA:3.40.50.1000:FF:000094', NULL, NULL, 'Haloacid dehalogenase like hydrolase domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(103292, NULL, 'G3DSA:2.60.40.790:FF:000063', NULL, NULL, 'Heat shock protein beta-9', NULL, NULL, NULL, NULL, NULL, 4),
(103293, NULL, 'G3DSA:1.20.1250.20:FF:000130', NULL, NULL, 'Protein NRT1/ PTR FAMILY 3.1', NULL, NULL, NULL, NULL, NULL, 4),
(103294, NULL, 'G3DSA:2.60.40.10:FF:005926', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103295, NULL, 'G3DSA:2.30.29.30:FF:000410', NULL, NULL, 'A-kinase anchor protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(103296, NULL, 'G3DSA:3.40.640.10:FF:000415', NULL, NULL, 'Bifunctional dethiobiotin synthetase/7,8-diamino-pelargonic acid aminotransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(103297, NULL, 'G3DSA:1.50.40.10:FF:000376', NULL, NULL, 'Mitochondrial substrate carrier family protein', NULL, NULL, NULL, NULL, NULL, 4),
(103298, NULL, 'G3DSA:3.30.70.100:FF:000152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103299, NULL, 'G3DSA:1.10.10.1740:FF:000003', NULL, NULL, 'Protein FATTY ACID EXPORT 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(103300, NULL, 'G3DSA:3.40.50.1010:FF:000097', NULL, NULL, 'AGAP008671-PA', NULL, NULL, NULL, NULL, NULL, 4),
(103301, NULL, 'G3DSA:1.25.10.10:FF:002383', NULL, NULL, 'Si:ch211-233m11.2', NULL, NULL, NULL, NULL, NULL, 4),
(103302, NULL, 'G3DSA:3.30.450.40:FF:000092', NULL, NULL, 'Crp family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(103303, NULL, 'G3DSA:1.10.472.10:FF:000331', NULL, NULL, 'Cyclin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(103304, NULL, 'G3DSA:3.30.428.70:FF:000009', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103305, NULL, 'G3DSA:3.90.1600.10:FF:000053', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(103306, NULL, 'G3DSA:3.30.40.10:FF:001682', NULL, NULL, 'FI06716p', NULL, NULL, NULL, NULL, NULL, 4),
(103307, NULL, 'G3DSA:1.20.1070.10:FF:000321', NULL, NULL, 'Octopamine receptor beta-3R', NULL, NULL, NULL, NULL, NULL, 4),
(103308, NULL, 'G3DSA:2.120.10.30:FF:000060', NULL, NULL, 'Putative strictosidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(103309, NULL, 'G3DSA:1.10.580.10:FF:000026', NULL, NULL, 'Citrate synthase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(103310, NULL, 'G3DSA:3.30.450.380:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103311, NULL, 'G3DSA:3.40.50.261:FF:000037', NULL, NULL, 'Succinate--CoA ligase [ADP/GDP-forming] subunit alpha, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(103312, NULL, 'G3DSA:1.10.1410.10:FF:000047', NULL, NULL, 'WGS project CABT00000000 data, contig 2.5', NULL, NULL, NULL, NULL, NULL, 4),
(103313, NULL, 'G3DSA:3.40.50.2000:FF:000085', NULL, NULL, 'alpha-1,3/1,6-mannosyltransferase ALG2', NULL, NULL, NULL, NULL, NULL, 4),
(103314, NULL, 'G3DSA:3.30.40.10:FF:000400', NULL, NULL, 'Bromodomain adjacent to zinc finger domain protein 2A', NULL, NULL, NULL, NULL, NULL, 4),
(103315, NULL, 'G3DSA:1.20.5.190:FF:000026', NULL, NULL, 'Unconventional myosin-X', NULL, NULL, NULL, NULL, NULL, 4),
(103316, NULL, 'G3DSA:1.20.272.10:FF:000033', NULL, NULL, 'Replication factor C small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(103317, NULL, 'G3DSA:3.40.50.300:FF:008283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103318, NULL, 'G3DSA:3.30.70.330:FF:000136', NULL, NULL, 'poly(U)-binding-splicing factor PUF60 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(103319, NULL, 'G3DSA:3.40.1010.10:FF:000019', NULL, NULL, 'Precorrin-6Y C(5,15)-methyltransferase [decarboxylating]', NULL, NULL, NULL, NULL, NULL, 4),
(103320, NULL, 'G3DSA:1.25.40.790:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103321, NULL, 'G3DSA:1.10.510.10:FF:003130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103322, NULL, 'G3DSA:3.90.550.10:FF:000330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103323, NULL, 'G3DSA:3.40.50.880:FF:000126', NULL, NULL, 'Carbamoyl-phosphate synthase small chain', NULL, NULL, NULL, NULL, NULL, 4),
(103324, NULL, 'G3DSA:3.90.1150.10:FF:000332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103325, NULL, 'G3DSA:1.25.10.10:FF:003400', NULL, NULL, 'Nucleolar protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(103326, NULL, 'G3DSA:3.80.10.10:FF:000312', NULL, NULL, 'Protein phosphatases pp1 regulatory subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103327, NULL, 'G3DSA:1.20.58.530:FF:000027', NULL, NULL, 'Dachs, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(103328, NULL, 'G3DSA:1.10.238.10:FF:000563', NULL, NULL, 'Sodium/calcium exchanger NCL', NULL, NULL, NULL, NULL, NULL, 4),
(103329, NULL, 'G3DSA:3.40.50.300:FF:002358', NULL, NULL, 'Rho-related GTP-binding protein RhoC', NULL, NULL, NULL, NULL, NULL, 4),
(103330, NULL, 'G3DSA:2.30.30.40:FF:000158', NULL, NULL, 'Osteoclast-stimulating factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(103331, NULL, 'G3DSA:3.40.50.2300:FF:000231', NULL, NULL, 'LacI family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(103332, NULL, 'G3DSA:3.40.50.150:FF:000407', NULL, NULL, 'O-methyltransferase 4', NULL, NULL, NULL, NULL, NULL, 4),
(103333, NULL, 'G3DSA:2.60.120.650:FF:000030', NULL, NULL, 'JmjC domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(103334, NULL, 'G3DSA:3.30.200.20:FF:000360', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(103335, NULL, 'G3DSA:1.10.10.60:FF:000161', NULL, NULL, 'POU domain protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(103336, NULL, 'G3DSA:2.10.25.10:FF:001138', NULL, NULL, 'Heart development protein with EGF-like domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(103337, NULL, 'G3DSA:2.130.10.10:FF:004095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103338, NULL, 'G3DSA:3.30.160.60:FF:000643', NULL, NULL, 'Zinc finger protein 668', NULL, NULL, NULL, NULL, NULL, 4),
(103339, NULL, 'G3DSA:2.60.120.330:FF:000198', NULL, NULL, 'Os08g0392300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(103340, NULL, 'G3DSA:3.30.40.10:FF:001709', NULL, NULL, 'JmjC domain, hydroxylase-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(103341, NULL, 'G3DSA:1.25.40.10:FF:000440', NULL, NULL, 'E3 ubiquitin-protein ligase PEP5', NULL, NULL, NULL, NULL, NULL, 4),
(103342, NULL, 'G3DSA:3.30.40.10:FF:001502', NULL, NULL, 'Putative RING finger domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(103343, NULL, 'G3DSA:1.25.40.770:FF:000011', NULL, NULL, 'TAF (TBP-associated transcription factor) family', NULL, NULL, NULL, NULL, NULL, 4),
(103344, NULL, 'G3DSA:2.70.150.10:FF:000190', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(103345, NULL, 'G3DSA:2.30.30.30:FF:000155', NULL, NULL, '50S ribosomal protein L24', NULL, NULL, NULL, NULL, NULL, 4),
(103346, NULL, 'G3DSA:1.20.58.480:FF:000023', NULL, NULL, 'Tryptophan oxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103347, NULL, 'G3DSA:1.20.1070.10:FF:001810', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103348, NULL, 'G3DSA:3.40.50.1820:FF:001262', NULL, NULL, 'Protein phosphatase methylesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(103349, NULL, 'G3DSA:1.10.10.60:FF:000368', NULL, NULL, 'Transcription factor MYB60', NULL, NULL, NULL, NULL, NULL, 4),
(103350, NULL, 'G3DSA:2.40.10.10:FF:000384', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103351, NULL, 'G3DSA:3.90.730.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103352, NULL, 'G3DSA:3.60.21.10:FF:000265', NULL, NULL, 'UDP-sugar hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103353, NULL, 'G3DSA:3.20.20.220:FF:000073', NULL, NULL, 'Probable proline dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(103354, NULL, 'G3DSA:1.25.40.10:FF:003548', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(103355, NULL, 'G3DSA:3.30.160.60:FF:004566', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103356, NULL, 'G3DSA:1.25.40.10:FF:002413', NULL, NULL, 'Vacuolar protein sorting-associated protein 41', NULL, NULL, NULL, NULL, NULL, 4),
(103357, NULL, 'G3DSA:1.25.50.20:FF:000062', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(103358, NULL, 'G3DSA:1.20.58.390:FF:000294', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103359, NULL, 'G3DSA:1.20.1050.10:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103360, NULL, 'G3DSA:2.130.10.130:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103361, NULL, 'G3DSA:3.40.50.300:FF:007973', NULL, NULL, 'SNF2 family N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(103362, NULL, 'G3DSA:2.60.120.260:FF:000003', NULL, NULL, 'Reelin', NULL, NULL, NULL, NULL, NULL, 4),
(103363, NULL, 'G3DSA:3.40.50.150:FF:000380', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103364, NULL, 'G3DSA:1.20.5.170:FF:000279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103365, NULL, 'G3DSA:3.30.60.30:FF:000177', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(103366, NULL, 'G3DSA:2.10.109.10:FF:000012', NULL, NULL, 'Peptidase/ serine-type peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(103367, NULL, 'G3DSA:2.70.170.10:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103368, NULL, 'G3DSA:1.10.287.1080:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103369, NULL, 'G3DSA:3.10.600.10:FF:000004', NULL, NULL, 'Pyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(103370, NULL, 'G3DSA:2.60.120.380:FF:000073', NULL, NULL, 'Clan SB, family S8, subtilisin-like serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(103371, NULL, 'G3DSA:2.10.70.10:FF:000164', NULL, NULL, 'Cysteine rich transmembrane BMP regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(103372, NULL, 'G3DSA:2.60.40.2080:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103373, NULL, 'G3DSA:3.40.190.10:FF:000425', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(103374, NULL, 'G3DSA:1.20.1070.10:FF:001277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103375, NULL, 'G3DSA:3.30.70.1620:FF:000018', NULL, NULL, 'Structural maintenance of chromosomes protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(103376, NULL, 'G3DSA:1.20.5.190:FF:000173', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103377, NULL, 'G3DSA:1.10.10.10:FF:000286', NULL, NULL, 'Heat shock transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(103378, NULL, 'G3DSA:2.60.40.10:FF:004437', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103379, NULL, 'G3DSA:3.90.1420.10:FF:000016', NULL, NULL, 'SET domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(103380, NULL, 'G3DSA:2.130.10.10:FF:000172', NULL, NULL, 'WD repeat domain 3', NULL, NULL, NULL, NULL, NULL, 4),
(103381, NULL, 'G3DSA:1.25.10.10:FF:003485', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(103382, NULL, 'G3DSA:1.10.10.60:FF:000722', NULL, NULL, 'Homeobox protein pal-1', NULL, NULL, NULL, NULL, NULL, 4),
(103383, NULL, 'G3DSA:2.60.40.10:FF:002285', NULL, NULL, 'Protein sidekick homolog', NULL, NULL, NULL, NULL, NULL, 4),
(103384, NULL, 'G3DSA:3.90.470.20:FF:000006', NULL, NULL, 'L-aminoadipate-semialdehyde dehydrogenase-phosphopantetheinyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(103385, NULL, 'G3DSA:3.60.15.10:FF:000144', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103386, NULL, 'G3DSA:3.50.4.10:FF:000020', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(103387, NULL, 'G3DSA:1.25.40.10:FF:001311', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(103388, NULL, 'G3DSA:3.40.30.10:FF:000607', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(103389, NULL, 'G3DSA:1.25.40.990:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103390, NULL, 'G3DSA:1.25.40.20:FF:001314', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103391, NULL, 'G3DSA:1.25.10.10:FF:002911', NULL, NULL, 'Exportin-T, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103392, NULL, 'G3DSA:1.10.510.10:FF:002820', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103393, NULL, 'G3DSA:1.10.10.2050:FF:000001', NULL, NULL, 'putative tRNA pseudouridine synthase Pus10', NULL, NULL, NULL, NULL, NULL, 4),
(103394, NULL, 'G3DSA:2.130.10.10:FF:002324', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(103395, NULL, 'G3DSA:3.80.10.10:FF:002549', NULL, NULL, 'AGAP002004-PA', NULL, NULL, NULL, NULL, NULL, 4),
(103396, NULL, 'G3DSA:2.40.70.10:FF:000185', NULL, NULL, 'Plasmepsin VIII', NULL, NULL, NULL, NULL, NULL, 4),
(103397, NULL, 'G3DSA:2.40.40.20:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103398, NULL, 'G3DSA:2.40.50.140:FF:000150', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(103399, NULL, 'G3DSA:3.90.470.10:FF:000003', NULL, NULL, '60S ribosomal protein L17', NULL, NULL, NULL, NULL, NULL, 4),
(103400, NULL, 'G3DSA:3.40.50.1820:FF:001469', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103401, NULL, 'G3DSA:3.80.10.10:FF:003185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103402, NULL, 'G3DSA:1.20.1070.10:FF:000967', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103403, NULL, 'G3DSA:2.40.30.10:FF:000267', NULL, NULL, 'Globin-like protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(103404, NULL, 'G3DSA:2.10.90.10:FF:000047', NULL, NULL, 'Left-right determination factor', NULL, NULL, NULL, NULL, NULL, 4),
(103405, NULL, 'G3DSA:1.25.40.10:FF:005139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103406, NULL, 'G3DSA:3.30.200.20:FF:002512', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103407, NULL, 'G3DSA:1.20.1070.10:FF:001456', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103408, NULL, 'G3DSA:3.30.56.10:FF:000032', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(103409, NULL, 'G3DSA:3.30.9.10:FF:000188', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103410, NULL, 'G3DSA:1.20.58.60:FF:000202', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(103411, NULL, 'G3DSA:1.20.1250.20:FF:001439', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103412, NULL, 'G3DSA:2.60.120.260:FF:000183', NULL, NULL, 'Fucolectin', NULL, NULL, NULL, NULL, NULL, 4),
(103413, NULL, 'G3DSA:3.90.1110.10:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103414, NULL, 'G3DSA:1.10.510.10:FF:004439', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103415, NULL, 'G3DSA:3.40.50.10810:FF:000012', NULL, NULL, 'RNA polymerase-associated protein RapA', NULL, NULL, NULL, NULL, NULL, 4),
(103416, NULL, 'G3DSA:3.90.1670.10:FF:000001', NULL, NULL, 'Protein FdhE', NULL, NULL, NULL, NULL, NULL, 4),
(103417, NULL, 'G3DSA:2.130.10.10:FF:002942', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103418, NULL, 'G3DSA:2.60.40.10:FF:000076', NULL, NULL, 'Leucine-rich repeat and Ig domain-containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(103419, NULL, 'G3DSA:3.90.45.10:FF:000021', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(103420, NULL, 'G3DSA:2.130.10.10:FF:006040', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103421, NULL, 'G3DSA:3.30.160.60:FF:005668', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103422, NULL, 'G3DSA:2.60.120.470:FF:000009', NULL, NULL, 'PITH domain-containing protein ZK353.9', NULL, NULL, NULL, NULL, NULL, 4),
(103423, NULL, 'G3DSA:3.30.310.10:FF:000067', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(103424, NULL, 'G3DSA:3.10.20.90:FF:000744', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103425, NULL, 'G3DSA:1.10.510.10:FF:002287', NULL, NULL, 'Dual specificity protein kinase splB', NULL, NULL, NULL, NULL, NULL, 4),
(103426, NULL, 'G3DSA:3.30.870.10:FF:000036', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(103427, NULL, 'G3DSA:3.30.160.60:FF:006157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103428, NULL, 'G3DSA:3.30.70.580:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103429, NULL, 'G3DSA:1.25.40.10:FF:000586', NULL, NULL, 'Bardet-Biedl syndrome 8', NULL, NULL, NULL, NULL, NULL, 4),
(103430, NULL, 'G3DSA:1.25.40.20:FF:000117', NULL, NULL, 'Protein fem-1 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(103431, NULL, 'G3DSA:3.30.160.60:FF:000317', NULL, NULL, 'zinc finger homeobox protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(103432, NULL, 'G3DSA:3.90.550.10:FF:000504', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103433, NULL, 'G3DSA:3.80.10.10:FF:003038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103434, NULL, 'G3DSA:3.40.50.300:FF:007647', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103435, NULL, 'G3DSA:3.40.50.620:FF:000071', NULL, NULL, '[Citrate [pro-3S]-lyase] ligase', NULL, NULL, NULL, NULL, NULL, 4),
(103436, NULL, 'G3DSA:1.10.418.10:FF:000009', NULL, NULL, 'smoothelin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(103437, NULL, 'G3DSA:2.30.30.40:FF:000484', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103438, NULL, 'G3DSA:3.30.70.330:FF:001682', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(103439, NULL, 'G3DSA:1.10.510.10:FF:000196', NULL, NULL, 'Probable serine/threonine protein kinase IREH1', NULL, NULL, NULL, NULL, NULL, 4),
(103440, NULL, 'G3DSA:1.20.1110.10:FF:000229', NULL, NULL, 'Flagellar associated protein, calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(103441, NULL, 'G3DSA:1.10.10.10:FF:002113', NULL, NULL, 'Response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(103442, NULL, 'G3DSA:1.10.150.240:FF:000111', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(103443, NULL, 'G3DSA:3.40.50.300:FF:004421', NULL, NULL, 'Adenylyl-sulfate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(103444, NULL, 'G3DSA:1.10.10.790:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103445, NULL, 'G3DSA:1.20.1070.10:FF:001664', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103446, NULL, 'G3DSA:3.30.70.20:FF:000113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103447, NULL, 'G3DSA:3.30.40.10:FF:001710', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(103448, NULL, 'G3DSA:2.10.110.10:FF:000083', NULL, NULL, 'LIM domain kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(103449, NULL, 'G3DSA:3.40.640.10:FF:000062', NULL, NULL, 'Cystathionine beta-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(103450, NULL, 'G3DSA:3.40.50.150:FF:000851', NULL, NULL, 'N-terminal Xaa-Pro-Lys N-methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(103451, NULL, 'G3DSA:2.60.40.10:FF:000840', NULL, NULL, 'Roundabout guidance receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(103452, NULL, 'G3DSA:3.40.50.200:FF:000029', NULL, NULL, 'Subtilisin-like serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(103453, NULL, 'G3DSA:1.10.510.10:FF:003012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103454, NULL, 'G3DSA:2.50.20.10:FF:000007', NULL, NULL, 'Outer-membrane lipoprotein carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(103455, NULL, 'G3DSA:2.60.120.920:FF:000162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103456, NULL, 'G3DSA:3.40.50.800:FF:000001', NULL, NULL, 'Threonine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(103457, NULL, 'G3DSA:4.10.60.10:FF:000142', NULL, NULL, 'DEAD-Box Protein', NULL, NULL, NULL, NULL, NULL, 4),
(103458, NULL, 'G3DSA:2.60.40.10:FF:004471', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103459, NULL, 'G3DSA:1.20.1250.20:FF:000304', NULL, NULL, 'Protein NRT1/ PTR FAMILY 6.4', NULL, NULL, NULL, NULL, NULL, 4),
(103460, NULL, 'G3DSA:3.40.190.10:FF:000633', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(103461, NULL, 'G3DSA:3.90.70.10:FF:000208', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(103462, NULL, 'G3DSA:3.30.870.10:FF:000154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103463, NULL, 'G3DSA:3.10.129.10:FF:000122', NULL, NULL, '3-hydroxyacyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(103464, NULL, 'G3DSA:3.30.70.270:FF:000011', NULL, NULL, 'DNA polymerase kappa', NULL, NULL, NULL, NULL, NULL, 4),
(103465, NULL, 'G3DSA:3.30.505.10:FF:000211', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103466, NULL, 'G3DSA:3.30.70.80:FF:000024', NULL, NULL, 'Putative subtilisin-like protease pr1a protein', NULL, NULL, NULL, NULL, NULL, 4),
(103467, NULL, 'G3DSA:1.20.1050.10:FF:000084', NULL, NULL, 'Cofactor for methionyl-and glutamyl-tRNA synthetases, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103468, NULL, 'G3DSA:2.80.10.50:FF:000197', NULL, NULL, 'Botulinum neurotoxin type G', NULL, NULL, NULL, NULL, NULL, 4),
(103469, NULL, 'G3DSA:1.10.287.1490:FF:000053', NULL, NULL, 'AGAP002527-PA', NULL, NULL, NULL, NULL, NULL, 4),
(103470, NULL, 'G3DSA:3.40.50.2020:FF:000063', NULL, NULL, 'Phosphoribosylpyrophosphate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(103471, NULL, 'G3DSA:1.10.555.10:FF:000193', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103472, NULL, 'G3DSA:3.10.250.10:FF:000078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(103473, NULL, 'G3DSA:3.40.1260.20:FF:000012', NULL, NULL, 'Cytoplasmic axial filament protein', NULL, NULL, NULL, NULL, NULL, 4),
(103474, NULL, 'G3DSA:4.10.830.10:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103475, NULL, 'G3DSA:2.70.170.10:FF:000281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103476, NULL, 'G3DSA:3.90.660.10:FF:000097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103477, NULL, 'G3DSA:3.40.1350.60:FF:000003', NULL, NULL, 'Sugar fermentation stimulation protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(103478, NULL, 'G3DSA:1.25.40.10:FF:000114', NULL, NULL, 'E3 SUMO-protein ligase RanBP2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(103479, NULL, 'G3DSA:2.40.10.10:FF:000176', NULL, NULL, 'Chymotrypsinogen A', NULL, NULL, NULL, NULL, NULL, 4),
(103480, NULL, 'G3DSA:1.10.3110.10:FF:000002', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(103481, NULL, 'G3DSA:3.30.43.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103482, NULL, 'G3DSA:1.10.238.10:FF:000916', NULL, NULL, 'Mitochondrial Rho GTPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(103483, NULL, 'G3DSA:3.40.50.300:FF:002419', NULL, NULL, 'ATP-dependent RNA helicase MSS116, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(103484, NULL, 'G3DSA:2.130.10.10:FF:002296', NULL, NULL, 'Telomerase Cajal body protein 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(103485, NULL, 'G3DSA:3.60.21.50:FF:000018', NULL, NULL, 'DNA polymerase epsilon subunit B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103486, NULL, 'G3DSA:2.120.10.30:FF:000088', NULL, NULL, 'Megalin, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(103487, NULL, 'G3DSA:3.30.450.70:FF:000016', NULL, NULL, 'Trafficking protein particle complex 2 like', NULL, NULL, NULL, NULL, NULL, 4),
(103488, NULL, 'G3DSA:2.40.50.140:FF:000116', NULL, NULL, 'Asparagine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(103489, NULL, 'G3DSA:1.25.40.10:FF:001103', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(103490, NULL, 'G3DSA:2.130.10.10:FF:000380', NULL, NULL, 'Dynein intermediate chain 2, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(103491, NULL, 'G3DSA:3.30.430.20:FF:000051', NULL, NULL, 'Cysteine-rich RLK (RECEPTOR-like protein kinase) 38', NULL, NULL, NULL, NULL, NULL, 4),
(103492, NULL, 'G3DSA:1.10.287.940:FF:000011', NULL, NULL, 'P2X purinoceptor', NULL, NULL, NULL, NULL, NULL, 4),
(103493, NULL, 'G3DSA:1.10.630.10:FF:000789', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103494, NULL, 'G3DSA:3.90.260.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103495, NULL, 'G3DSA:3.80.10.10:FF:002111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103496, NULL, 'G3DSA:3.30.70.3490:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103497, NULL, 'G3DSA:1.10.287.70:FF:000401', NULL, NULL, 'GD16867', NULL, NULL, NULL, NULL, NULL, 4),
(103498, NULL, 'G3DSA:3.10.180.10:FF:000111', NULL, NULL, '4-hydroxyphenylpyruvate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(103499, NULL, 'G3DSA:1.20.1260.140:FF:000004', NULL, NULL, 'Mitochondrial alternative oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(103500, NULL, 'G3DSA:3.10.100.10:FF:000365', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103501, NULL, 'G3DSA:3.40.30.10:FF:000815', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103502, NULL, 'G3DSA:4.10.970.10:FF:000016', NULL, NULL, 'ATP-dependent DNA helicase II subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(103503, NULL, 'G3DSA:1.25.40.20:FF:001106', NULL, NULL, '85/88 kDa calcium-independent phospholipase A2 isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(103504, NULL, 'G3DSA:1.25.10.10:FF:002703', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103505, NULL, 'G3DSA:2.40.70.10:FF:000393', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(103506, NULL, 'G3DSA:2.10.25.10:FF:000649', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(103507, NULL, 'G3DSA:2.60.40.60:FF:000629', NULL, NULL, 'putative protocadherin beta-18', NULL, NULL, NULL, NULL, NULL, 4),
(103508, NULL, 'G3DSA:1.10.287.110:FF:000088', NULL, NULL, 'Co-chaperone protein HscB homolog', NULL, NULL, NULL, NULL, NULL, 4),
(103509, NULL, 'G3DSA:3.30.70.2510:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103510, NULL, 'G3DSA:2.60.40.10:FF:006028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103511, NULL, 'G3DSA:2.30.39.10:FF:000074', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103512, NULL, 'G3DSA:1.25.40.10:FF:003874', NULL, NULL, 'Os12g0281933 protein', NULL, NULL, NULL, NULL, NULL, 4),
(103513, NULL, 'G3DSA:1.10.1450.10:FF:000139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103514, NULL, 'G3DSA:2.60.40.10:FF:001975', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103515, NULL, 'G3DSA:1.50.40.10:FF:000494', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103516, NULL, 'G3DSA:3.40.50.2300:FF:001658', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103517, NULL, 'G3DSA:1.25.40.20:FF:000443', NULL, NULL, 'Putative vps9 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(103518, NULL, 'G3DSA:1.25.10.10:FF:000174', NULL, NULL, 'Ecm29 proteasome adaptor and scaffold', NULL, NULL, NULL, NULL, NULL, 4),
(103519, NULL, 'G3DSA:3.90.70.40:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103520, NULL, 'G3DSA:3.80.10.10:FF:003364', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103521, NULL, 'G3DSA:3.40.50.1000:FF:000268', NULL, NULL, 'ATPase 4 plasma membrane-type', NULL, NULL, NULL, NULL, NULL, 4),
(103522, NULL, 'G3DSA:3.40.50.620:FF:000599', NULL, NULL, 'Tryptophan--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(103523, NULL, 'G3DSA:3.40.630.30:FF:000567', NULL, NULL, 'Acetyltransferase (GNAT) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(103524, NULL, 'G3DSA:1.20.58.60:FF:000410', NULL, NULL, 'Nesprin-1', NULL, NULL, NULL, NULL, NULL, 4),
(103525, NULL, 'G3DSA:3.90.1640.20:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103526, NULL, 'G3DSA:1.25.40.20:FF:000589', NULL, NULL, 'ankyrin repeat and KH domain-containing protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(103527, NULL, 'G3DSA:3.10.20.90:FF:000536', NULL, NULL, 'serine/threonine protein kinase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(103528, NULL, 'G3DSA:1.10.8.60:FF:000356', NULL, NULL, 'FtsH-like AAA+ protein', NULL, NULL, NULL, NULL, NULL, 4),
(103529, NULL, 'G3DSA:3.30.530.20:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103530, NULL, 'G3DSA:3.40.1740.10:FF:000001', NULL, NULL, 'UPF0301 protein YqgE', NULL, NULL, NULL, NULL, NULL, 4),
(103531, NULL, 'G3DSA:1.20.1250.20:FF:001732', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103532, NULL, 'G3DSA:2.130.10.10:FF:000587', NULL, NULL, 'Plexin A4, B', NULL, NULL, NULL, NULL, NULL, 4),
(103533, NULL, 'G3DSA:3.30.530.20:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103534, NULL, 'G3DSA:2.30.30.40:FF:000276', NULL, NULL, 'CheW-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(103535, NULL, 'G3DSA:1.10.287.110:FF:000408', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103536, NULL, 'G3DSA:3.40.50.720:FF:001646', NULL, NULL, 'UDP-glucose 4-epimerase (GalE-2)', NULL, NULL, NULL, NULL, NULL, 4),
(103537, NULL, 'G3DSA:3.90.70.10:FF:000265', NULL, NULL, 'ubiquitin carboxyl-terminal hydrolase 35', NULL, NULL, NULL, NULL, NULL, 4),
(103538, NULL, 'G3DSA:3.40.50.10190:FF:000079', NULL, NULL, 'Mutator 2, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(103539, NULL, 'G3DSA:1.20.1310.10:FF:000183', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103540, NULL, 'G3DSA:1.20.120.350:FF:000265', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(103541, NULL, 'G3DSA:3.30.160.60:FF:004920', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103542, NULL, 'G3DSA:2.60.40.10:FF:002638', NULL, NULL, 'Neuronal immunoglobulin domain-containing protein rig-3', NULL, NULL, NULL, NULL, NULL, 4),
(103543, NULL, 'G3DSA:2.70.150.10:FF:000072', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(103544, NULL, 'G3DSA:3.40.390.10:FF:000053', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(103545, NULL, 'G3DSA:3.30.200.20:FF:002304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103546, NULL, 'G3DSA:2.60.120.1040:FF:000006', NULL, NULL, 'Zinc finger protein zpr1', NULL, NULL, NULL, NULL, NULL, 4),
(103547, NULL, 'G3DSA:3.30.40.10:FF:001974', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103548, NULL, 'G3DSA:2.30.29.240:FF:000018', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(103549, NULL, 'G3DSA:1.10.506.10:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103550, NULL, 'G3DSA:1.20.120.1240:FF:000044', NULL, NULL, 'Dynamin-related GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(103551, NULL, 'G3DSA:2.130.10.10:FF:004802', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103552, NULL, 'G3DSA:3.30.450.40:FF:000266', NULL, NULL, 'Osmosensitive potassium channel sensor histidine kinase KdpD, KdpD and USP_OKCHK domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(103553, NULL, 'G3DSA:2.20.28.120:FF:000001', NULL, NULL, '50S ribosomal protein L33', NULL, NULL, NULL, NULL, NULL, 4),
(103554, NULL, 'G3DSA:3.80.30.20:FF:000024', NULL, NULL, 'Fe-S oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(103555, NULL, 'G3DSA:1.10.1170.10:FF:000011', NULL, NULL, 'E3 ubiquitin-protein ligase XIAP', NULL, NULL, NULL, NULL, NULL, 4),
(103556, NULL, 'G3DSA:2.60.40.60:FF:000422', NULL, NULL, 'Cadherin 26', NULL, NULL, NULL, NULL, NULL, 4),
(103557, NULL, 'G3DSA:2.170.270.10:FF:000096', NULL, NULL, 'Histone-lysine N-methyltransferase set-26', NULL, NULL, NULL, NULL, NULL, 4),
(103558, NULL, 'G3DSA:3.40.30.10:FF:000579', NULL, NULL, 'MIP10555p', NULL, NULL, NULL, NULL, NULL, 4),
(103559, NULL, 'G3DSA:1.25.40.10:FF:004537', NULL, NULL, 'Hsp70/Hsp90 organizing protein', NULL, NULL, NULL, NULL, NULL, 4),
(103560, NULL, 'G3DSA:1.20.1250.20:FF:001024', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(103561, NULL, 'G3DSA:3.30.559.30:FF:000021', NULL, NULL, 'Nonribosomal peptide synthetase 7', NULL, NULL, NULL, NULL, NULL, 4),
(103562, NULL, 'G3DSA:1.25.40.10:FF:004122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103563, NULL, 'G3DSA:3.30.160.60:FF:003869', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103564, NULL, 'G3DSA:2.60.120.10:FF:000409', NULL, NULL, '2-hydroxyethylphosphonate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(103565, NULL, 'G3DSA:3.40.50.2300:FF:000523', NULL, NULL, 'Response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(103566, NULL, 'G3DSA:2.60.40.1120:FF:000036', NULL, NULL, 'Putative vitamin B12 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(103567, NULL, 'G3DSA:2.60.40.10:FF:004263', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103568, NULL, 'G3DSA:2.60.40.60:FF:000484', NULL, NULL, 'Cadherin-89D', NULL, NULL, NULL, NULL, NULL, 4),
(103569, NULL, 'G3DSA:2.40.290.30:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103570, NULL, 'G3DSA:3.30.70.330:FF:000254', NULL, NULL, 'ATP-dependent RNA helicase DbpA', NULL, NULL, NULL, NULL, NULL, 4),
(103571, NULL, 'G3DSA:3.80.10.10:FF:001240', NULL, NULL, 'F-box/leucine rich repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(103572, NULL, 'G3DSA:1.10.10.60:FF:000076', NULL, NULL, 'Homeobox protein knotted-1-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(103573, NULL, 'G3DSA:3.40.1160.10:FF:000058', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(103574, NULL, 'G3DSA:1.20.1270.60:FF:000059', NULL, NULL, 'Rho GTPase activating protein 4b', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(103575, NULL, 'G3DSA:2.40.30.130:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103576, NULL, 'G3DSA:2.40.10.10:FF:000119', NULL, NULL, 'ORF1a polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(103577, NULL, 'G3DSA:3.80.10.10:FF:000020', NULL, NULL, 'Erbin isoform 7', NULL, NULL, NULL, NULL, NULL, 4),
(103578, NULL, 'G3DSA:3.60.21.10:FF:000439', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103579, NULL, 'G3DSA:3.40.50.880:FF:000070', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(103580, NULL, 'G3DSA:3.50.50.60:FF:001365', NULL, NULL, 'Monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103581, NULL, 'G3DSA:3.40.50.300:FF:000767', NULL, NULL, 'Putative ATP-dependent RNA helicase DHX35', NULL, NULL, NULL, NULL, NULL, 4),
(103582, NULL, 'G3DSA:3.40.50.1000:FF:000532', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103583, NULL, 'G3DSA:3.30.559.70:FF:000038', NULL, NULL, 'Carnitine O-acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103584, NULL, 'G3DSA:3.40.50.150:FF:001104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103585, NULL, 'G3DSA:1.20.1250.70:FF:000004', NULL, NULL, 'Interleukin', NULL, NULL, NULL, NULL, NULL, 4),
(103586, NULL, 'G3DSA:2.160.20.10:FF:000081', NULL, NULL, 'SHC SH2 domain-binding protein 1 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(103587, NULL, 'G3DSA:1.10.357.150:FF:000004', NULL, NULL, 'Centromere/kinetochore protein zw10 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(103588, NULL, 'G3DSA:1.10.10.10:FF:001596', NULL, NULL, '5-pentadecatrienyl resorcinol O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(103589, NULL, 'G3DSA:3.40.800.20:FF:000038', NULL, NULL, 'Histone deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(103590, NULL, 'G3DSA:3.40.50.10470:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103591, NULL, 'G3DSA:3.40.50.10490:FF:000079', NULL, NULL, 'Galactosamine 6-phosphate isomerase AgaS', NULL, NULL, NULL, NULL, NULL, 4),
(103592, NULL, 'G3DSA:3.40.50.1000:FF:000678', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103593, NULL, 'G3DSA:2.40.10.10:FF:000058', NULL, NULL, 'Tissue-type plasminogen activator', NULL, NULL, NULL, NULL, NULL, 4),
(103594, NULL, 'G3DSA:3.40.800.10:FF:000035', NULL, NULL, 'Arginase', NULL, NULL, NULL, NULL, NULL, 4),
(103595, NULL, 'G3DSA:3.10.450.10:FF:000059', NULL, NULL, 'Cysteine proteinase inhibitor 7', NULL, NULL, NULL, NULL, NULL, 4),
(103596, NULL, 'G3DSA:1.10.20.10:FF:000051', NULL, NULL, 'DNA polymerase epsilon 4, accessory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(103597, NULL, 'G3DSA:3.40.50.300:FF:000621', NULL, NULL, 'Interferon-induced GTP-binding protein Mx1', NULL, NULL, NULL, NULL, NULL, 4),
(103598, NULL, 'G3DSA:3.30.450.30:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103599, NULL, 'G3DSA:3.10.290.10:FF:000086', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(103600, NULL, 'G3DSA:3.40.50.300:FF:002712', NULL, NULL, 'GD25199', NULL, NULL, NULL, NULL, NULL, 4),
(103601, NULL, 'G3DSA:1.25.40.10:FF:004329', NULL, NULL, 'Signal recognition particle subunit SRP72', NULL, NULL, NULL, NULL, NULL, 4),
(103602, NULL, 'G3DSA:3.30.450.40:FF:000058', NULL, NULL, 'GAF domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(103603, NULL, 'G3DSA:1.10.10.10:FF:000932', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(103604, NULL, 'G3DSA:2.130.10.10:FF:002178', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(103605, NULL, 'G3DSA:2.60.40.10:FF:000463', NULL, NULL, 'Immunoglobulin heavy constant gamma 1', NULL, NULL, NULL, NULL, NULL, 4),
(103606, NULL, 'G3DSA:3.30.70.3250:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103607, NULL, 'G3DSA:3.80.10.10:FF:001801', NULL, NULL, 'LRR47', NULL, NULL, NULL, NULL, NULL, 4),
(103608, NULL, 'G3DSA:1.20.1270.280:FF:000059', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(103609, NULL, 'G3DSA:2.130.10.10:FF:004123', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103610, NULL, 'G3DSA:1.10.510.10:FF:004147', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103611, NULL, 'G3DSA:3.90.226.10:FF:000116', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(103612, NULL, 'G3DSA:3.30.200.20:FF:000652', NULL, NULL, 'probably inactive leucine-rich repeat receptor-like protein kinase At5g06940', NULL, NULL, NULL, NULL, NULL, 4),
(103613, NULL, 'G3DSA:2.60.120.1030:FF:000003', NULL, NULL, 'mRNA cleavage and polyadenylation factor CLP1', NULL, NULL, NULL, NULL, NULL, 4),
(103614, NULL, 'G3DSA:3.20.20.140:FF:000257', NULL, NULL, 'Alpha-D-ribose 1-methylphosphonate 5-triphosphate diphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(103615, NULL, 'G3DSA:3.50.50.60:FF:001247', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(103616, NULL, 'G3DSA:2.60.40.10:FF:004881', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103617, NULL, 'G3DSA:3.40.190.10:FF:000280', NULL, NULL, 'Prephenate dehydratase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103618, NULL, 'G3DSA:2.10.25.10:FF:000121', NULL, NULL, 'Neural EGFL like 2', NULL, NULL, NULL, NULL, NULL, 4),
(103619, NULL, 'G3DSA:3.60.110.10:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103620, NULL, 'G3DSA:3.30.60.20:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103621, NULL, 'G3DSA:3.40.50.11030:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103622, NULL, 'G3DSA:2.60.120.10:FF:000527', NULL, NULL, 'Diguanylate cyclase, CAP_ED domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(103623, NULL, 'G3DSA:3.40.50.1820:FF:001554', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103624, NULL, 'G3DSA:3.30.40.10:FF:001474', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(103625, NULL, 'G3DSA:1.20.1280.290:FF:000013', NULL, NULL, 'lysosomal amino acid transporter 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(103626, NULL, 'G3DSA:3.40.50.2300:FF:001187', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103627, NULL, 'G3DSA:1.20.1280.290:FF:000070', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103628, NULL, 'G3DSA:2.60.40.150:FF:000371', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(103629, NULL, 'G3DSA:2.60.40.60:FF:000630', NULL, NULL, 'Protocadherin 1 gamma 32', NULL, NULL, NULL, NULL, NULL, 4),
(103630, NULL, 'G3DSA:3.30.46.10:FF:000003', NULL, NULL, 'Glycine/sarcosine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(103631, NULL, 'G3DSA:3.40.50.2300:FF:000023', NULL, NULL, 'Transcriptional regulatory protein RcsB', NULL, NULL, NULL, NULL, NULL, 4),
(103632, NULL, 'G3DSA:1.20.1530.20:FF:000017', NULL, NULL, 'Na+/H+/K+ antiporter GerN', NULL, NULL, NULL, NULL, NULL, 4),
(103633, NULL, 'G3DSA:1.10.730.10:FF:000061', NULL, NULL, 'Valyl-tRNA synthetase, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(103634, NULL, 'G3DSA:2.10.110.10:FF:000021', NULL, NULL, 'Lim and senescent cell antigen-like-containing', NULL, NULL, NULL, NULL, NULL, 4),
(103635, NULL, 'G3DSA:4.10.240.10:FF:000186', NULL, NULL, 'Ecm22p', NULL, NULL, NULL, NULL, NULL, 4),
(103636, NULL, 'G3DSA:1.20.58.70:FF:000060', NULL, NULL, 'Syntaxin 2a', NULL, NULL, NULL, NULL, NULL, 4),
(103637, NULL, 'G3DSA:1.20.1250.20:FF:001524', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103638, NULL, 'G3DSA:3.20.20.70:FF:000389', NULL, NULL, 'Putative transmembrane GTPase FZO-like, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(103639, NULL, 'G3DSA:1.25.40.10:FF:000176', NULL, NULL, 'dynein assembly factor 4, axonemal isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(103640, NULL, 'G3DSA:3.30.70.1660:FF:000036', NULL, NULL, 'Uncharacterized protein PRFA2', NULL, NULL, NULL, NULL, NULL, 4),
(103641, NULL, 'G3DSA:3.40.50.1820:FF:001054', NULL, NULL, 'Retinoid-inducible serine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(103642, NULL, 'G3DSA:3.30.40.10:FF:002137', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(103643, NULL, 'G3DSA:3.50.80.10:FF:000003', NULL, NULL, 'probable D-tyrosyl-tRNA(Tyr) deacylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(103644, NULL, 'G3DSA:1.10.110.10:FF:000002', NULL, NULL, 'Non-specific lipid-transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(103645, NULL, 'G3DSA:3.30.1490.80:FF:000004', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(103646, NULL, 'G3DSA:2.40.128.700:FF:000004', NULL, NULL, 'Chromosome 23, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(103647, NULL, 'G3DSA:3.30.572.10:FF:000006', NULL, NULL, 'Thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(103648, NULL, 'G3DSA:2.60.40.10:FF:006062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103649, NULL, 'G3DSA:1.10.600.10:FF:000023', NULL, NULL, 'Squalene synthase', NULL, NULL, NULL, NULL, NULL, 4),
(103650, NULL, 'G3DSA:3.40.1360.10:FF:000039', NULL, NULL, 'Topoisomerase-like enzyme1', NULL, NULL, NULL, NULL, NULL, 4),
(103651, NULL, 'G3DSA:1.20.50.70:FF:000002', NULL, NULL, 'Complement component C3-4', NULL, NULL, NULL, NULL, NULL, 4),
(103652, NULL, 'G3DSA:3.30.70.330:FF:000462', NULL, NULL, 'Zinc finger CCCH domain-containing protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(103653, NULL, 'G3DSA:2.130.10.10:FF:002532', NULL, NULL, 'F-box/WD-40 repeat-containing protein At5g21040', NULL, NULL, NULL, NULL, NULL, 4),
(103654, NULL, 'G3DSA:2.40.30.10:FF:000121', NULL, NULL, 'Translation elongation factor Tu', NULL, NULL, NULL, NULL, NULL, 4),
(103655, NULL, 'G3DSA:2.60.40.60:FF:000276', NULL, NULL, 'FAT atypical cadherin 2', NULL, NULL, NULL, NULL, NULL, 4),
(103656, NULL, 'G3DSA:1.10.10.10:FF:001860', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(103657, NULL, 'G3DSA:1.20.1070.10:FF:001069', NULL, NULL, 'C-C chemokine receptor type 5', NULL, NULL, NULL, NULL, NULL, 4),
(103658, NULL, 'G3DSA:3.40.50.300:FF:004628', NULL, NULL, 'ABC transporter-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(103659, NULL, 'G3DSA:2.130.10.10:FF:004241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103660, NULL, 'G3DSA:3.40.50.150:FF:000087', NULL, NULL, 'tRNA1(Val) (adenine(37)-N6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(103661, NULL, 'G3DSA:3.40.980.10:FF:000019', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(103662, NULL, 'G3DSA:1.10.10.60:FF:000576', NULL, NULL, 'Double homeobox B-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(103663, NULL, 'G3DSA:2.130.10.10:FF:000087', NULL, NULL, 'WD repeat-containing protein 26 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(103664, NULL, 'G3DSA:3.40.640.10:FF:000180', NULL, NULL, 'Biogenic Amine Synthesis related', NULL, NULL, NULL, NULL, NULL, 4),
(103665, NULL, 'G3DSA:3.90.79.10:FF:000054', NULL, NULL, 'ADP compounds hydrolase nudE', NULL, NULL, NULL, NULL, NULL, 4),
(103666, NULL, 'G3DSA:3.40.47.10:FF:000117', NULL, NULL, '4-hydroxycoumarin synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(103667, NULL, 'G3DSA:3.30.70.1450:FF:000006', NULL, NULL, 'Citrate transporter protein', NULL, NULL, NULL, NULL, NULL, 4),
(103668, NULL, 'G3DSA:1.25.40.20:FF:000179', NULL, NULL, 'NF-kappa-B inhibitor zeta isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(103669, NULL, 'G3DSA:3.20.20.60:FF:000061', NULL, NULL, 'Phosphoenolpyruvate carboxylase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(103670, NULL, 'G3DSA:1.10.510.10:FF:003984', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103671, NULL, 'G3DSA:1.10.1420.10:FF:000199', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(103672, NULL, 'G3DSA:3.30.1330.10:FF:000017', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(103673, NULL, 'G3DSA:1.10.10.10:FF:000522', NULL, NULL, 'Forkhead domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(103674, NULL, 'G3DSA:3.40.50.300:FF:008518', NULL, NULL, 'AAA ATPase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(103675, NULL, 'G3DSA:1.10.510.10:FF:003894', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103676, NULL, 'G3DSA:1.10.3260.10:FF:000046', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(103677, NULL, 'G3DSA:1.10.10.10:FF:000432', NULL, NULL, 'Cullin 2', NULL, NULL, NULL, NULL, NULL, 4),
(103678, NULL, 'G3DSA:3.40.50.1000:FF:000414', NULL, NULL, 'Phosphoserine phosphatase SerB', NULL, NULL, NULL, NULL, NULL, 4),
(103679, NULL, 'G3DSA:1.20.120.350:FF:000208', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103680, NULL, 'G3DSA:1.10.1040.30:FF:000013', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103681, NULL, 'G3DSA:3.10.580.10:FF:000097', NULL, NULL, 'SNF1-related protein kinase regulatory subunit gamma-like PV42a', NULL, NULL, NULL, NULL, NULL, 4),
(103682, NULL, 'G3DSA:3.40.50.300:FF:000885', NULL, NULL, 'DNA polymerase theta', NULL, NULL, NULL, NULL, NULL, 4),
(103683, NULL, 'G3DSA:1.10.357.70:FF:000019', NULL, NULL, 'Component of the exocyst complex', NULL, NULL, NULL, NULL, NULL, 4),
(103684, NULL, 'G3DSA:2.130.10.10:FF:002442', NULL, NULL, 'Cleavage and polyadenylation specificity factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(103685, NULL, 'G3DSA:2.60.40.10:FF:001857', NULL, NULL, 'Hemicentin 2', NULL, NULL, NULL, NULL, NULL, 4),
(103686, NULL, 'G3DSA:3.40.50.300:FF:001695', NULL, NULL, 'ATP-binding cassette sub-family G member', NULL, NULL, NULL, NULL, NULL, 4),
(103687, NULL, 'G3DSA:2.130.10.10:FF:001104', NULL, NULL, 'WD repeat-containing protein 44 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(103688, NULL, 'G3DSA:3.40.50.300:FF:004157', NULL, NULL, 'Katanin p60 ATPase-containing subunit A-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(103689, NULL, 'G3DSA:1.10.472.10:FF:000185', NULL, NULL, 'FAM58A isoform 10', NULL, NULL, NULL, NULL, NULL, 4),
(103690, NULL, 'G3DSA:3.40.50.10330:FF:000048', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(103691, NULL, 'G3DSA:3.40.850.10:FF:000072', NULL, NULL, 'Kinesin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(103692, NULL, 'G3DSA:3.30.479.30:FF:000020', NULL, NULL, 'SPFH domain/Band 7 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(103693, NULL, 'G3DSA:1.10.730.20:FF:000007', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(103694, NULL, 'G3DSA:1.10.472.80:FF:000099', NULL, NULL, 'Gyl1p', NULL, NULL, NULL, NULL, NULL, 4),
(103695, NULL, 'G3DSA:3.40.225.10:FF:000030', NULL, NULL, 'Rhamnulose-1-phosphate aldolase/alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(103696, NULL, 'G3DSA:1.50.10.10:FF:000195', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(103697, NULL, 'G3DSA:3.40.33.10:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103698, NULL, 'G3DSA:3.30.50.10:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103699, NULL, 'G3DSA:3.50.50.60:FF:000230', NULL, NULL, 'Dihydrolipoyl dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(103700, NULL, 'G3DSA:3.30.1390.20:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103701, NULL, 'G3DSA:2.60.40.790:FF:000208', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103702, NULL, 'G3DSA:1.10.3720.10:FF:000183', NULL, NULL, 'ABC Amino Acid Transporter Permease', NULL, NULL, NULL, NULL, NULL, 4),
(103703, NULL, 'G3DSA:1.10.640.10:FF:000031', NULL, NULL, 'Myeloid-specific peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(103704, NULL, 'G3DSA:3.40.50.720:FF:000011', NULL, NULL, 'Potassium channel subfamily T member 1', NULL, NULL, NULL, NULL, NULL, 4),
(103705, NULL, 'G3DSA:2.60.40.10:FF:002880', NULL, NULL, 'Leptin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(103706, NULL, 'G3DSA:1.10.730.10:FF:000004', NULL, NULL, 'Isoleucyl-tRNA synthetase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(103707, NULL, 'G3DSA:3.30.70.330:FF:001272', NULL, NULL, 'U2 snRNP auxiliary factor large subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103708, NULL, 'G3DSA:3.50.50.100:FF:000008', NULL, NULL, 'External alternative NAD(P)H-ubiquinone oxidoreductase B1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(103709, NULL, 'G3DSA:3.30.160.60:FF:002734', NULL, NULL, 'CBN-HAM-2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(103710, NULL, 'G3DSA:3.30.40.10:FF:001917', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103711, NULL, 'G3DSA:3.30.200.20:FF:001787', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(103712, NULL, 'G3DSA:1.20.1250.20:FF:001939', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103713, NULL, 'G3DSA:3.30.160.60:FF:006365', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103714, NULL, 'G3DSA:3.90.226.10:FF:000324', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103715, NULL, 'G3DSA:3.30.160.60:FF:000525', NULL, NULL, 'IKAROS family zinc finger 1', NULL, NULL, NULL, NULL, NULL, 4),
(103716, NULL, 'G3DSA:3.30.160.60:FF:005140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103717, NULL, 'G3DSA:1.25.10.10:FF:000551', NULL, NULL, 'HEAT repeat-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(103718, NULL, 'G3DSA:1.10.8.270:FF:000042', NULL, NULL, 'TBC/Rab GTPase activating domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(103719, NULL, 'G3DSA:2.70.170.10:FF:000129', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103720, NULL, 'G3DSA:3.40.190.10:FF:000072', NULL, NULL, 'glutamate receptor ionotropic, kainate 4', NULL, NULL, NULL, NULL, NULL, 4),
(103721, NULL, 'G3DSA:2.120.10.80:FF:000024', NULL, NULL, 'Kelch-like ECH-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(103722, NULL, 'G3DSA:2.40.10.10:FF:000529', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103723, NULL, 'G3DSA:1.10.1070.11:FF:000044', NULL, NULL, 'NuA4 histone acetyltransferase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(103724, NULL, 'G3DSA:3.90.70.10:FF:000618', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103725, NULL, 'G3DSA:1.25.10.10:FF:001776', NULL, NULL, 'Importin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103726, NULL, 'G3DSA:3.30.720.210:FF:000023', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH 4', NULL, NULL, NULL, NULL, NULL, 4),
(103727, NULL, 'G3DSA:3.40.50.720:FF:001293', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(103728, NULL, 'G3DSA:1.20.1080.10:FF:000001', NULL, NULL, 'Probable aquaporin PIP1-2', NULL, NULL, NULL, NULL, NULL, 4),
(103729, NULL, 'G3DSA:3.90.470.20:FF:000040', NULL, NULL, 'Phosphopantetheinyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(103730, NULL, 'G3DSA:3.50.30.50:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103731, NULL, 'G3DSA:2.120.10.80:FF:000081', NULL, NULL, 'Multiple EGF like domains 8', NULL, NULL, NULL, NULL, NULL, 4),
(103732, NULL, 'G3DSA:1.10.860.10:FF:000008', NULL, NULL, 'Replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(103733, NULL, 'G3DSA:1.20.58.60:FF:000787', NULL, NULL, 'Dystonin', NULL, NULL, NULL, NULL, NULL, 4),
(103734, NULL, 'G3DSA:1.25.40.10:FF:000322', NULL, NULL, 'RNA polymerase-associated protein CTR9 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(103735, NULL, 'G3DSA:3.40.50.720:FF:002220', NULL, NULL, 'Glyoxylate reductase/hydroxypyruvate reductase b', NULL, NULL, NULL, NULL, NULL, 4),
(103736, NULL, 'G3DSA:3.40.640.10:FF:000028', NULL, NULL, 'L-seryl-tRNA(Sec) selenium transferase', NULL, NULL, NULL, NULL, NULL, 4),
(103737, NULL, 'G3DSA:3.40.50.2300:FF:000113', NULL, NULL, 'Low molecular weight protein-tyrosine-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(103738, NULL, 'G3DSA:2.60.40.150:FF:000219', NULL, NULL, 'Copine-E', NULL, NULL, NULL, NULL, NULL, 4),
(103739, NULL, 'G3DSA:3.40.190.10:FF:000015', NULL, NULL, 'Glycine cleavage system transcriptional activator', NULL, NULL, NULL, NULL, NULL, 4),
(103740, NULL, 'G3DSA:3.30.360.10:FF:000071', NULL, NULL, 'Dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103741, NULL, 'G3DSA:3.30.1370.10:FF:000082', NULL, NULL, 'RNA-binding protein PNO1', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(103742, NULL, 'G3DSA:2.40.240.10:FF:000018', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(103743, NULL, 'G3DSA:3.30.70.330:FF:001890', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103744, NULL, 'G3DSA:3.40.50.300:FF:006461', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103745, NULL, 'G3DSA:2.60.120.650:FF:000092', NULL, NULL, 'Specific transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(103746, NULL, 'G3DSA:3.40.395.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103747, NULL, 'G3DSA:1.10.240.10:FF:000006', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(103748, NULL, 'G3DSA:1.20.1280.50:FF:000085', NULL, NULL, 'F-box domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(103749, NULL, 'G3DSA:1.10.287.990:FF:000008', NULL, NULL, 'Superoxide dismutase [Fe]', NULL, NULL, NULL, NULL, NULL, 4),
(103750, NULL, 'G3DSA:2.40.70.10:FF:000505', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103751, NULL, 'G3DSA:3.40.50.300:FF:007855', NULL, NULL, 'Dicer-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103752, NULL, 'G3DSA:1.10.510.10:FF:002348', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103753, NULL, 'G3DSA:3.30.200.20:FF:000242', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(103754, NULL, 'G3DSA:2.30.30.40:FF:000630', NULL, NULL, 'EPS8-like 3a', NULL, NULL, NULL, NULL, NULL, 4),
(103755, NULL, 'G3DSA:3.90.132.10:FF:000027', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103756, NULL, 'G3DSA:2.60.11.10:FF:000008', NULL, NULL, 'Cytochrome c oxidase subunit 5b-2 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(103757, NULL, 'G3DSA:3.40.50.300:FF:006219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103758, NULL, 'G3DSA:2.30.250.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103759, NULL, 'G3DSA:1.20.1050.10:FF:000230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103760, NULL, 'G3DSA:1.25.10.10:FF:000758', NULL, NULL, 'Cadmus, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(103761, NULL, 'G3DSA:3.30.565.10:FF:000248', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(103762, NULL, 'G3DSA:1.20.1250.20:FF:001378', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103763, NULL, 'G3DSA:3.10.180.10:FF:000050', NULL, NULL, 'Probable ring-cleaving dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(103764, NULL, 'G3DSA:3.40.50.2300:FF:001451', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103765, NULL, 'G3DSA:2.40.10.10:FF:000322', NULL, NULL, 'Putative peptidase Cgl1093', NULL, NULL, NULL, NULL, NULL, 4),
(103766, NULL, 'G3DSA:3.30.200.20:FF:001580', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103767, NULL, 'G3DSA:1.20.120.1750:FF:000045', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(103768, NULL, 'G3DSA:3.30.160.60:FF:006275', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103769, NULL, 'G3DSA:2.60.40.60:FF:000219', NULL, NULL, 'Cadherin 5', NULL, NULL, NULL, NULL, NULL, 4),
(103770, NULL, 'G3DSA:3.40.630.10:FF:000297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103771, NULL, 'G3DSA:1.25.40.10:FF:002531', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g23020', NULL, NULL, NULL, NULL, NULL, 4),
(103772, NULL, 'G3DSA:1.10.510.10:FF:002702', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103773, NULL, 'G3DSA:1.10.418.10:FF:000043', NULL, NULL, 'Spectrin beta chain, non-erythrocytic', NULL, NULL, NULL, NULL, NULL, 4),
(103774, NULL, 'G3DSA:1.20.120.1760:FF:000048', NULL, NULL, 'Phosphatidylcholine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(103775, NULL, 'G3DSA:3.80.10.10:FF:003246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103776, NULL, 'G3DSA:3.30.420.40:FF:000472', NULL, NULL, 'Related to ARP5-Actin-related protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(103777, NULL, 'G3DSA:3.30.1120.10:FF:000007', NULL, NULL, 'Secreted sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(103778, NULL, 'G3DSA:1.25.40.470:FF:000011', NULL, NULL, 'Intraflagellar transport protein 140', NULL, NULL, NULL, NULL, NULL, 4),
(103779, NULL, 'G3DSA:1.10.287.1490:FF:000019', NULL, NULL, 'RAS and EF-hand domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(103780, NULL, 'G3DSA:2.130.10.10:FF:006039', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103781, NULL, 'G3DSA:1.25.40.20:FF:000325', NULL, NULL, 'Ankyrin repeat-containing protein YAR1', NULL, NULL, NULL, NULL, NULL, 4),
(103782, NULL, 'G3DSA:3.30.200.20:FF:002451', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103783, NULL, 'G3DSA:3.70.10.10:FF:000009', NULL, NULL, 'Proliferating cell nuclear antigen', NULL, NULL, NULL, NULL, NULL, 4),
(103784, NULL, 'G3DSA:3.40.50.300:FF:002476', NULL, NULL, 'Protein CHROMATIN REMODELING 19 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(103785, NULL, 'G3DSA:3.30.505.10:FF:000065', NULL, NULL, 'Transcription elongation factor SPT6', NULL, NULL, NULL, NULL, NULL, 4),
(103786, NULL, 'G3DSA:1.10.10.60:FF:000840', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103787, NULL, 'G3DSA:1.20.58.830:FF:000027', NULL, NULL, 'Erythrocyte membrane protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(103788, NULL, 'G3DSA:3.30.1370.10:FF:000025', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein K, like', NULL, NULL, NULL, NULL, NULL, 4),
(103789, NULL, 'G3DSA:1.20.5.1700:FF:000011', NULL, NULL, 'Homer scaffold protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(103790, NULL, 'G3DSA:3.30.830.10:FF:000236', NULL, NULL, 'Mitochondrial-processing peptidase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(103791, NULL, 'G3DSA:3.80.10.10:FF:003600', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103792, NULL, 'G3DSA:3.40.50.300:FF:004067', NULL, NULL, 'Benign gonial cell neoplasm protein', NULL, NULL, NULL, NULL, NULL, 4),
(103793, NULL, 'G3DSA:3.30.70.370:FF:000007', NULL, NULL, 'Plastid replication-repair enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(103794, NULL, 'G3DSA:3.30.1490.20:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103795, NULL, 'G3DSA:2.60.40.10:FF:004319', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103796, NULL, 'G3DSA:2.60.40.60:FF:000837', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103797, NULL, 'G3DSA:1.10.167.10:FF:000072', NULL, NULL, 'AGAP007895-PA', NULL, NULL, NULL, NULL, NULL, 4),
(103798, NULL, 'G3DSA:3.30.160.60:FF:001340', NULL, NULL, 'zinc finger protein 75D isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(103799, NULL, 'G3DSA:3.90.190.20:FF:000024', NULL, NULL, 'Dihydrofolate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(103800, NULL, 'G3DSA:3.50.50.60:FF:000437', NULL, NULL, 'FAD-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(103801, NULL, 'G3DSA:3.90.190.10:FF:000021', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase alpha', NULL, NULL, NULL, NULL, NULL, 4),
(103802, NULL, 'G3DSA:1.25.10.10:FF:002591', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103803, NULL, 'G3DSA:1.20.1050.10:FF:000320', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103804, NULL, 'G3DSA:3.10.129.10:FF:000240', NULL, NULL, '4-hydroxybenzoyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(103805, NULL, 'G3DSA:2.30.29.30:FF:000202', NULL, NULL, 'rab GTPase-activating protein 1-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(103806, NULL, 'G3DSA:1.25.40.10:FF:003666', NULL, NULL, 'FI18620p1', NULL, NULL, NULL, NULL, NULL, 4),
(103807, NULL, 'G3DSA:1.10.10.10:FF:000168', NULL, NULL, 'Replication protein A 32 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(103808, NULL, 'G3DSA:3.40.50.10610:FF:000008', NULL, NULL, 'Sll1835 protein', NULL, NULL, NULL, NULL, NULL, 4),
(103809, NULL, 'G3DSA:1.25.40.10:FF:000940', NULL, NULL, 'Os06g0185700 protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(103810, NULL, 'G3DSA:1.20.1560.10:FF:000403', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(103811, NULL, 'G3DSA:3.40.120.10:FF:000067', NULL, NULL, 'Phosphomannomutase PmmB', NULL, NULL, NULL, NULL, NULL, 4),
(103812, NULL, 'G3DSA:3.30.110.20:FF:000004', NULL, NULL, 'Ribonuclease P protein subunit p25-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(103813, NULL, 'G3DSA:1.25.10.10:FF:002349', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103814, NULL, 'G3DSA:1.10.150.20:FF:000013', NULL, NULL, 'U5 small nuclear ribonucleoprotein kDa helicase', NULL, NULL, NULL, NULL, NULL, 4),
(103815, NULL, 'G3DSA:4.10.60.10:FF:000260', NULL, NULL, 'Universal minicircle sequence binding protein (UMSBP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(103816, NULL, 'G3DSA:3.80.20.20:FF:000052', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(103817, NULL, 'G3DSA:3.40.50.150:FF:000907', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103818, NULL, 'G3DSA:3.30.110.30:FF:000007', NULL, NULL, 'Prolyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103819, NULL, 'G3DSA:4.10.60.10:FF:000203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103820, NULL, 'G3DSA:1.25.40.20:FF:000943', NULL, NULL, 'Os11g0199000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(103821, NULL, 'G3DSA:3.80.10.10:FF:003864', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103822, NULL, 'G3DSA:1.10.510.10:FF:002141', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(103823, NULL, 'G3DSA:2.40.30.10:FF:000385', NULL, NULL, 'Translation elongation factor G-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(103824, NULL, 'G3DSA:3.40.50.300:FF:002566', NULL, NULL, 'Translation factor GUF1 homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(103825, NULL, 'G3DSA:3.90.550.50:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103826, NULL, 'G3DSA:2.40.30.10:FF:000328', NULL, NULL, 'Dihydroorotate dehydrogenase B (NAD(+)), electron transfer subunit', NULL, NULL, NULL, NULL, NULL, 4),
(103827, NULL, 'G3DSA:1.10.150.20:FF:000070', NULL, NULL, 'DNA polymerase I, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103828, NULL, 'G3DSA:1.20.120.1750:FF:000135', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(103829, NULL, 'G3DSA:3.40.1810.10:FF:000029', NULL, NULL, 'MADS transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(103830, NULL, 'G3DSA:1.20.1070.10:FF:000849', NULL, NULL, 'Si:dkey-94e7.1', NULL, NULL, NULL, NULL, NULL, 4),
(103831, NULL, 'G3DSA:2.60.210.10:FF:000034', NULL, NULL, 'T23K8.6', NULL, NULL, NULL, NULL, NULL, 4),
(103832, NULL, 'G3DSA:3.30.420.140:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103833, NULL, 'G3DSA:1.10.287.110:FF:000296', NULL, NULL, 'Dnj-22', NULL, NULL, NULL, NULL, NULL, 4),
(103834, NULL, 'G3DSA:1.10.1620.10:FF:000001', NULL, NULL, '60S ribosomal protein-like L39', NULL, NULL, NULL, NULL, NULL, 4),
(103835, NULL, 'G3DSA:1.10.238.10:FF:000186', NULL, NULL, 'Secretagogin', NULL, NULL, NULL, NULL, NULL, 4),
(103836, NULL, 'G3DSA:3.30.63.20:FF:000001', NULL, NULL, '40S ribosomal protein S25', NULL, NULL, NULL, NULL, NULL, 4),
(103837, NULL, 'G3DSA:3.80.10.10:FF:001655', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(103838, NULL, 'G3DSA:3.40.630.10:FF:000090', NULL, NULL, 'M18 aspartyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(103839, NULL, 'G3DSA:2.40.160.10:FF:000017', NULL, NULL, 'Glucuronide uptake porin UidC', NULL, NULL, NULL, NULL, NULL, 4),
(103840, NULL, 'G3DSA:2.40.110.10:FF:000014', NULL, NULL, 'Probable acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(103841, NULL, 'G3DSA:2.60.200.20:FF:000211', NULL, NULL, 'Kinesin-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(103842, NULL, 'G3DSA:3.80.10.10:FF:000430', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase PEPR1', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(103843, NULL, 'G3DSA:2.130.10.10:FF:000851', NULL, NULL, 'VPS8 subunit of CORVET complex', NULL, NULL, NULL, NULL, NULL, 4),
(103844, NULL, 'G3DSA:3.40.50.720:FF:001910', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103845, NULL, 'G3DSA:3.90.70.10:FF:000355', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103846, NULL, 'G3DSA:3.90.550.10:FF:000684', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103847, NULL, 'G3DSA:3.30.200.20:FF:000152', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 7', NULL, NULL, NULL, NULL, NULL, 4),
(103848, NULL, 'G3DSA:2.40.30.180:FF:000006', NULL, NULL, 'Ubiquitin-activating enzyme E1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103849, NULL, 'G3DSA:1.25.40.10:FF:000406', NULL, NULL, 'Sel1 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(103850, NULL, 'G3DSA:4.10.860.120:FF:000019', NULL, NULL, 'DNA-directed RNA polymerase I largest subunit', NULL, NULL, NULL, NULL, NULL, 4),
(103851, NULL, 'G3DSA:2.30.30.40:FF:000192', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(103852, NULL, 'G3DSA:1.10.510.10:FF:000016', NULL, NULL, 'Somatic embryogenesis receptor-like kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(103853, NULL, 'G3DSA:2.130.10.10:FF:001599', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103854, NULL, 'G3DSA:1.20.140.150:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103855, NULL, 'G3DSA:3.90.550.10:FF:000212', NULL, NULL, 'Mannosyltransferase complex component', NULL, NULL, NULL, NULL, NULL, 4),
(103856, NULL, 'G3DSA:1.25.40.20:FF:000409', NULL, NULL, 'TRP (Transient receptor potential) channel family', NULL, NULL, NULL, NULL, NULL, 4),
(103857, NULL, 'G3DSA:3.30.565.10:FF:000512', NULL, NULL, 'Phosphate regulon sensor protein PhoR', NULL, NULL, NULL, NULL, NULL, 4),
(103858, NULL, 'G3DSA:3.30.70.330:FF:001974', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103859, NULL, 'G3DSA:3.10.110.10:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103860, NULL, 'G3DSA:1.20.120.350:FF:000181', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103861, NULL, 'G3DSA:3.30.40.10:FF:001890', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103862, NULL, 'G3DSA:2.70.130.10:FF:000037', NULL, NULL, 'Lysosomal enzyme receptor protein', NULL, NULL, NULL, NULL, NULL, 4),
(103863, NULL, 'G3DSA:3.20.20.10:FF:000068', NULL, NULL, 'Serine racemase', NULL, NULL, NULL, NULL, NULL, 4),
(103864, NULL, 'G3DSA:1.10.510.10:FF:000488', NULL, NULL, 'T3SS secreted effector NleH', NULL, NULL, NULL, NULL, NULL, 4),
(103865, NULL, 'G3DSA:3.40.50.300:FF:006837', NULL, NULL, 'GPN-loop GTPase 3', NULL, NULL, NULL, NULL, NULL, 4),
(103866, NULL, 'G3DSA:1.25.10.10:FF:000904', NULL, NULL, 'MOT1p protein', NULL, NULL, NULL, NULL, NULL, 4),
(103867, NULL, 'G3DSA:1.20.140.150:FF:000074', NULL, NULL, 'Outer dense fiber of sperm tails 4', NULL, NULL, NULL, NULL, NULL, 4),
(103868, NULL, 'G3DSA:3.30.160.60:FF:004774', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103869, NULL, 'G3DSA:3.40.1000.10:FF:000018', NULL, NULL, 'Ran-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103870, NULL, 'G3DSA:3.30.565.10:FF:000456', NULL, NULL, 'DNA mismatch repair protein domain', NULL, NULL, NULL, NULL, NULL, 4),
(103871, NULL, 'G3DSA:1.20.1310.10:FF:000149', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103872, NULL, 'G3DSA:3.90.226.10:FF:000088', NULL, NULL, 'S41 family peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(103873, NULL, 'G3DSA:3.30.1520.10:FF:000026', NULL, NULL, 'Phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(103874, NULL, 'G3DSA:2.130.10.10:FF:000615', NULL, NULL, 'Receptor for activated C kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(103875, NULL, 'G3DSA:2.60.120.1000:FF:000017', NULL, NULL, 'Si:dkey-21p1.3', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(103876, NULL, 'G3DSA:1.20.5.110:FF:000284', NULL, NULL, 't-SNARE domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(103877, NULL, 'G3DSA:3.30.200.20:FF:000096', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(103878, NULL, 'G3DSA:3.30.70.330:FF:001479', NULL, NULL, 'Os02g0602600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(103879, NULL, 'G3DSA:3.30.160.60:FF:000609', NULL, NULL, 'zinc finger protein 621', NULL, NULL, NULL, NULL, NULL, 4),
(103880, NULL, 'G3DSA:3.90.1100.10:FF:000026', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(103881, NULL, 'G3DSA:3.60.20.40:FF:000047', NULL, NULL, 'Gamma-glutamyltransferase 7-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(103882, NULL, 'G3DSA:2.170.270.10:FF:000186', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(103883, NULL, 'G3DSA:3.30.160.60:FF:004830', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103884, NULL, 'G3DSA:1.10.132.60:FF:000040', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(103885, NULL, 'G3DSA:2.30.180.10:FF:000190', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103886, NULL, 'G3DSA:2.10.25.10:FF:000211', NULL, NULL, 'Protein kinase C-binding protein NELL1', NULL, NULL, NULL, NULL, NULL, 4),
(103887, NULL, 'G3DSA:1.10.950.10:FF:000015', NULL, NULL, 'Erythrocyte membrane protein band 4.9, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103888, NULL, 'G3DSA:1.10.600.10:FF:000141', NULL, NULL, 'Terpene cyclase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103889, NULL, 'G3DSA:4.10.400.10:FF:000367', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103890, NULL, 'G3DSA:1.10.418.10:FF:000251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103891, NULL, 'G3DSA:3.90.1750.10:FF:000097', NULL, NULL, 'E3 ubiquitin-protein ligase UPL5', NULL, NULL, NULL, NULL, NULL, 4),
(103892, NULL, 'G3DSA:3.40.50.300:FF:007939', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(103893, NULL, 'G3DSA:3.30.1370.10:FF:000233', NULL, NULL, 'U1 snRNP-associated protein usp108', NULL, NULL, NULL, NULL, NULL, 4),
(103894, NULL, 'G3DSA:3.90.550.10:FF:000740', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103895, NULL, 'G3DSA:2.40.20.10:FF:000064', NULL, NULL, 'Plasminogen activator, urokinase b', NULL, NULL, NULL, NULL, NULL, 4),
(103896, NULL, 'G3DSA:2.40.30.170:FF:000003', NULL, NULL, 'Multidrug resistance protein A', NULL, NULL, NULL, NULL, NULL, 4),
(103897, NULL, 'G3DSA:3.40.50.1000:FF:000178', NULL, NULL, 'Predicted phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(103898, NULL, 'G3DSA:3.20.20.220:FF:000039', NULL, NULL, 'Proline dehydrogenase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(103899, NULL, 'G3DSA:2.60.40.10:FF:000963', NULL, NULL, 'Obscurin like 1', NULL, NULL, NULL, NULL, NULL, 4),
(103900, NULL, 'G3DSA:3.40.50.40:FF:000005', NULL, NULL, 'Glutaminase-asparaginase', NULL, NULL, NULL, NULL, NULL, 4),
(103901, NULL, 'G3DSA:3.40.50.880:FF:000008', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(103902, NULL, 'G3DSA:1.10.10.60:FF:000604', NULL, NULL, 'CRE-ZAG-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(103903, NULL, 'G3DSA:3.40.1080.10:FF:000001', NULL, NULL, 'Succinyl-coa:3-ketoacid-coenzyme a transferase subunit b', NULL, NULL, NULL, NULL, NULL, 4),
(103904, NULL, 'G3DSA:1.10.287.1490:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103905, NULL, 'G3DSA:3.40.50.150:FF:000464', NULL, NULL, 'DNA (Cytosine-5)-methyltransferase CMT2', NULL, NULL, NULL, NULL, NULL, 4),
(103906, NULL, 'G3DSA:1.10.10.10:FF:000578', NULL, NULL, 'HTH-type transcriptional regulator SarR', NULL, NULL, NULL, NULL, NULL, 4),
(103907, NULL, 'G3DSA:3.90.226.10:FF:000206', NULL, NULL, 'Benzoyl-CoA-dihydrodiol lyase', NULL, NULL, NULL, NULL, NULL, 4),
(103908, NULL, 'G3DSA:3.40.50.1820:FF:001407', NULL, NULL, 'Protein CBG05817', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(103909, NULL, 'G3DSA:3.40.50.1820:FF:001470', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103910, NULL, 'G3DSA:3.30.420.110:FF:000049', NULL, NULL, 'MutS protein homolog 4', NULL, NULL, NULL, NULL, NULL, 4),
(103911, NULL, 'G3DSA:1.10.10.10:FF:000106', NULL, NULL, 'Methionine aminopeptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(103912, NULL, 'G3DSA:3.40.50.300:FF:005848', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103913, NULL, 'G3DSA:2.40.10.10:FF:000092', NULL, NULL, 'Transmembrane protease serine 5', NULL, NULL, NULL, NULL, NULL, 4),
(103914, NULL, 'G3DSA:3.40.50.10810:FF:000220', NULL, NULL, 'AEL297Wp', NULL, NULL, NULL, NULL, NULL, 4),
(103915, NULL, 'G3DSA:2.10.50.10:FF:000163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103916, NULL, 'G3DSA:1.20.1070.10:FF:000759', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103917, NULL, 'G3DSA:3.20.20.60:FF:000089', NULL, NULL, 'Putative citrate/ citryl-CoA lyase', NULL, NULL, NULL, NULL, NULL, 4),
(103918, NULL, 'G3DSA:3.40.190.10:FF:000190', NULL, NULL, 'Glutamate receptor, ionotropic, delta 1b', NULL, NULL, NULL, NULL, NULL, 4),
(103919, NULL, 'G3DSA:3.20.20.60:FF:000145', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(103920, NULL, 'G3DSA:3.30.1600.10:FF:000027', NULL, NULL, 'NAD-dependent protein deacylase SIR2rp2', NULL, NULL, NULL, NULL, NULL, 4),
(103921, NULL, 'G3DSA:3.50.50.60:FF:001483', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103922, NULL, 'G3DSA:1.25.10.10:FF:001040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103923, NULL, 'G3DSA:2.10.25.10:FF:001195', NULL, NULL, 'Fibulin-1', NULL, NULL, NULL, NULL, NULL, 4),
(103924, NULL, 'G3DSA:2.30.29.30:FF:001276', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103925, NULL, 'G3DSA:3.80.10.10:FF:003656', NULL, NULL, 'F-box/LRR-repeat protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(103926, NULL, 'G3DSA:2.40.30.330:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103927, NULL, 'G3DSA:3.40.30.10:FF:000669', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(103928, NULL, 'G3DSA:1.25.40.20:FF:000735', NULL, NULL, 'Ankyrin repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(103929, NULL, 'G3DSA:3.40.50.300:FF:004218', NULL, NULL, 'DNA helicase related protein', NULL, NULL, NULL, NULL, NULL, 4),
(103930, NULL, 'G3DSA:3.40.30.10:FF:000523', NULL, NULL, 'Protein disulfide isomerase PDI3', NULL, NULL, NULL, NULL, NULL, 4),
(103931, NULL, 'G3DSA:3.40.190.290:FF:000024', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(103932, NULL, 'G3DSA:1.20.58.70:FF:000121', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103933, NULL, 'G3DSA:3.90.700.10:FF:000005', NULL, NULL, 'Succinate dehydrogenase flavoprotein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(103934, NULL, 'G3DSA:4.10.60.10:FF:000052', NULL, NULL, 'Putative universal minicircle sequence binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(103935, NULL, 'G3DSA:1.10.20.10:FF:000141', NULL, NULL, 'Inner kinetochore subunit MHF2', NULL, NULL, NULL, NULL, NULL, 4),
(103936, NULL, 'G3DSA:3.90.1290.10:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103937, NULL, 'G3DSA:4.10.400.10:FF:000165', NULL, NULL, 'low-density lipoprotein receptor-related protein 8 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(103938, NULL, 'G3DSA:1.25.40.10:FF:000732', NULL, NULL, 'Small Glutamine-rich Tetratrico repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(103939, NULL, 'G3DSA:3.30.160.60:FF:004448', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103940, NULL, 'G3DSA:2.60.40.60:FF:000394', NULL, NULL, 'Cadherin 23', NULL, NULL, NULL, NULL, NULL, 4),
(103941, NULL, 'G3DSA:1.10.10.60:FF:000806', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103942, NULL, 'G3DSA:1.25.40.10:FF:001188', NULL, NULL, 'Superkiller protein 3', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(103943, NULL, 'G3DSA:2.10.50.30:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103944, NULL, 'G3DSA:3.90.79.10:FF:000262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103945, NULL, 'G3DSA:2.60.40.2430:FF:000002', NULL, NULL, 'Sag1p', NULL, NULL, NULL, NULL, NULL, 4),
(103946, NULL, 'G3DSA:1.20.1310.10:FF:000003', NULL, NULL, 'Cullin 4A', NULL, NULL, NULL, NULL, NULL, 4),
(103947, NULL, 'G3DSA:3.90.1150.10:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103948, NULL, 'G3DSA:1.25.40.20:FF:000089', NULL, NULL, 'serine/threonine-protein kinase TNNI3K', NULL, NULL, NULL, NULL, NULL, 4),
(103949, NULL, 'G3DSA:1.10.510.10:FF:000342', NULL, NULL, 'L-type lectin-domain containing receptor kinase VIII.1', NULL, NULL, NULL, NULL, NULL, 4),
(103950, NULL, 'G3DSA:3.50.50.60:FF:000022', NULL, NULL, 'Glutamate synthase [NADH], amyloplastic', NULL, NULL, NULL, NULL, NULL, 4),
(103951, NULL, 'G3DSA:2.60.40.10:FF:003566', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103952, NULL, 'G3DSA:3.40.50.620:FF:000161', NULL, NULL, 'Electron transfer flavoprotein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(103953, NULL, 'G3DSA:1.25.40.10:FF:005347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103954, NULL, 'G3DSA:1.10.420.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103955, NULL, 'G3DSA:2.60.200.20:FF:000183', NULL, NULL, 'Forkhead-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(103956, NULL, 'G3DSA:1.25.40.10:FF:000086', NULL, NULL, 'HTH-type transcriptional regulator MalT', NULL, NULL, NULL, NULL, NULL, 4),
(103957, NULL, 'G3DSA:2.60.40.10:FF:004706', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103958, NULL, 'G3DSA:3.90.550.10:FF:000414', NULL, NULL, 'Cytidine monophosphate N-acetylneuraminic acid synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(103959, NULL, 'G3DSA:3.30.70.1050:FF:000010', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(103960, NULL, 'G3DSA:2.40.460.10:FF:000001', NULL, NULL, 'Acetyl-CoA carboxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(103961, NULL, 'G3DSA:1.20.1310.20:FF:000006', NULL, NULL, 'Erythrocyte binding antigen-140', NULL, NULL, NULL, NULL, NULL, 4),
(103962, NULL, 'G3DSA:3.40.50.300:FF:006635', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(103963, NULL, 'G3DSA:3.30.10.20:FF:000014', NULL, NULL, 'Serine/threonine-protein kinase StkP', NULL, NULL, NULL, NULL, NULL, 4),
(103964, NULL, 'G3DSA:1.25.40.20:FF:000561', NULL, NULL, 'Benign gonial cell neoplasm', NULL, NULL, NULL, NULL, NULL, 4),
(103965, NULL, 'G3DSA:3.40.190.10:FF:000510', NULL, NULL, 'Oligopeptide ABC transporter, oligopeptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(103966, NULL, 'G3DSA:3.30.40.10:FF:001564', NULL, NULL, 'Protein CBG00592', NULL, NULL, NULL, NULL, NULL, 4),
(103967, NULL, 'G3DSA:3.30.50.10:FF:000081', NULL, NULL, 'Steroid hormone receptor family member cnr14', NULL, NULL, NULL, NULL, NULL, 4),
(103968, NULL, 'G3DSA:3.40.50.300:FF:004544', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103969, NULL, 'G3DSA:3.40.50.720:FF:000191', NULL, NULL, 'Methylglyoxal reductase (NADPH-dependent)', NULL, NULL, NULL, NULL, NULL, 4),
(103970, NULL, 'G3DSA:3.90.190.10:FF:000549', NULL, NULL, 'AGAP000492-PA', NULL, NULL, NULL, NULL, NULL, 4),
(103971, NULL, 'G3DSA:2.130.10.10:FF:004033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(103972, NULL, 'G3DSA:3.40.50.300:FF:002892', NULL, NULL, 'GTP-binding protein SAR1b', NULL, NULL, NULL, NULL, NULL, 4),
(103973, NULL, 'G3DSA:1.10.510.10:FF:004029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103974, NULL, 'G3DSA:1.10.8.270:FF:000103', NULL, NULL, 'RabGAP', NULL, NULL, NULL, NULL, NULL, 4),
(103975, NULL, 'G3DSA:2.20.25.220:FF:000001', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(103976, NULL, 'G3DSA:1.25.40.10:FF:004419', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(103977, NULL, 'G3DSA:1.10.510.10:FF:001331', NULL, NULL, 'VRK serine/threonine kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(103978, NULL, 'G3DSA:2.20.25.240:FF:000007', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(103979, NULL, 'G3DSA:2.20.28.40:FF:000001', NULL, NULL, 'H/ACA ribonucleoprotein complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(103980, NULL, 'G3DSA:3.10.100.10:FF:000275', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(103981, NULL, 'G3DSA:2.40.70.10:FF:000270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103982, NULL, 'G3DSA:3.30.470.30:FF:000028', NULL, NULL, 'mRNA capping enzyme, beta chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(103983, NULL, 'G3DSA:2.60.120.200:FF:000210', NULL, NULL, 'Protein eyes shut homolog', NULL, NULL, NULL, NULL, NULL, 4),
(103984, NULL, 'G3DSA:1.20.144.10:FF:000067', NULL, NULL, 'PA-phosphatase related-family protein DDB_G0275547', NULL, NULL, NULL, NULL, NULL, 4),
(103985, NULL, 'G3DSA:3.40.50.1240:FF:000082', NULL, NULL, 'Phosphohistidine phosphatase SixA', NULL, NULL, NULL, NULL, NULL, 4),
(103986, NULL, 'G3DSA:1.20.5.1160:FF:000012', NULL, NULL, 'Myosin heavy chain 6', NULL, NULL, NULL, NULL, NULL, 4),
(103987, NULL, 'G3DSA:2.130.10.10:FF:003105', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(103988, NULL, 'G3DSA:3.30.470.20:FF:000025', NULL, NULL, 'Propionyl-CoA carboxylase alpha chain, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(103989, NULL, 'G3DSA:2.40.170.20:FF:000083', NULL, NULL, 'TonB-dependent receptor', NULL, NULL, NULL, NULL, NULL, 4),
(103990, NULL, 'G3DSA:3.30.160.60:FF:000935', NULL, NULL, 'PLAG1 like zinc finger 1', NULL, NULL, NULL, NULL, NULL, 4),
(103991, NULL, 'G3DSA:2.60.40.2130:FF:000007', NULL, NULL, 'Spondin-2', NULL, NULL, NULL, NULL, NULL, 4),
(103992, NULL, 'G3DSA:1.10.10.60:FF:000430', NULL, NULL, 'Chromatin remodeling protein', NULL, NULL, NULL, NULL, NULL, 4),
(103993, NULL, 'G3DSA:3.40.50.740:FF:000051', NULL, NULL, 'Extracellular dimethyl sulfoxide/manganese oxide reductase molybdopterin-binding subunit DmsA', NULL, NULL, NULL, NULL, NULL, 4),
(103994, NULL, 'G3DSA:1.20.1070.10:FF:001541', NULL, NULL, 'Neuropeptides B/W receptor type 2', NULL, NULL, NULL, NULL, NULL, 4),
(103995, NULL, 'G3DSA:1.20.1230.10:FF:000002', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(103996, NULL, 'G3DSA:3.90.70.10:FF:000708', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(103997, NULL, 'G3DSA:3.40.50.880:FF:000160', NULL, NULL, 'Protein G75B', NULL, NULL, NULL, NULL, NULL, 4),
(103998, NULL, 'G3DSA:3.40.50.300:FF:000649', NULL, NULL, 'Origin recognition complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(103999, NULL, 'G3DSA:2.60.40.10:FF:004055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104000, NULL, 'G3DSA:3.10.50.40:FF:000079', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(104001, NULL, 'G3DSA:3.40.50.1820:FF:001177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104002, NULL, 'G3DSA:2.60.120.40:FF:000042', NULL, NULL, 'Tumor necrosis factor ligand superfamily member 9', NULL, NULL, NULL, NULL, NULL, 4),
(104003, NULL, 'G3DSA:3.40.50.720:FF:000421', NULL, NULL, 'Probable NADP-dependent mannitol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(104004, NULL, 'G3DSA:3.30.559.70:FF:000010', NULL, NULL, 'Carnitine O-Acetyl-Transferase, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(104005, NULL, 'G3DSA:3.40.50.1580:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104006, NULL, 'G3DSA:1.10.472.10:FF:000123', NULL, NULL, 'Cyclin-Y-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(104007, NULL, 'G3DSA:3.30.70.60:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104008, NULL, 'G3DSA:3.40.50.1820:FF:001672', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(104009, NULL, 'G3DSA:3.40.50.1240:FF:000143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104010, NULL, 'G3DSA:1.10.390.40:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104011, NULL, 'G3DSA:3.75.10.10:FF:000010', NULL, NULL, 'Mitochondrial RNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(104012, NULL, 'G3DSA:4.10.800.20:FF:000007', NULL, NULL, 'AMP deaminase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104013, NULL, 'G3DSA:1.20.58.390:FF:000086', NULL, NULL, 'Acetylcholine receptor subunit beta-type acr-2', NULL, NULL, NULL, NULL, NULL, 4),
(104014, NULL, 'G3DSA:2.60.120.10:FF:000645', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104015, NULL, 'G3DSA:3.40.47.10:FF:000033', NULL, NULL, 'Fatty acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(104016, NULL, 'G3DSA:3.30.420.40:FF:000646', NULL, NULL, 'Actin-related protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(104017, NULL, 'G3DSA:4.10.800.10:FF:000004', NULL, NULL, 'SPARC-related modular calcium-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(104018, NULL, 'G3DSA:1.10.3720.10:FF:000003', NULL, NULL, 'Aliphatic sulfonate ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(104019, NULL, 'G3DSA:3.90.780.10:FF:000021', NULL, NULL, 'Phosphoesterase', NULL, NULL, NULL, NULL, NULL, 4),
(104020, NULL, 'G3DSA:3.30.780.10:FF:000006', NULL, NULL, 'Protein translation factor SUI1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(104021, NULL, 'G3DSA:1.10.3210.10:FF:000009', NULL, NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(104022, NULL, 'G3DSA:3.60.21.10:FF:000349', NULL, NULL, 'Uncharacterized protein C30A5.4', NULL, NULL, NULL, NULL, NULL, 4),
(104023, NULL, 'G3DSA:3.40.50.150:FF:000790', NULL, NULL, 'Salicylate/benzoate carboxyl methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(104024, NULL, 'G3DSA:3.40.50.11660:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104025, NULL, 'G3DSA:3.40.50.2020:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104026, NULL, 'G3DSA:1.10.510.10:FF:002433', NULL, NULL, 'Os04g0134400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(104027, NULL, 'G3DSA:1.10.3720.10:FF:000149', NULL, NULL, 'ABC transporter permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(104028, NULL, 'G3DSA:3.30.160.60:FF:002650', NULL, NULL, 'Zinc finger protein 236 variant', NULL, NULL, NULL, NULL, NULL, 4),
(104029, NULL, 'G3DSA:3.50.50.60:FF:000701', NULL, NULL, 'Probable flavin-containing monoamine oxidase B', NULL, NULL, NULL, NULL, NULL, 4),
(104030, NULL, 'G3DSA:3.80.10.10:FF:001239', NULL, NULL, 'Leucine rich repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(104031, NULL, 'G3DSA:3.40.50.1980:FF:000067', NULL, NULL, 'Hemin ABC transporter, periplasmic hemin-binding protein HutB', NULL, NULL, NULL, NULL, NULL, 4),
(104032, NULL, 'G3DSA:3.30.1380.20:FF:000057', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(104033, NULL, 'G3DSA:3.30.1680.10:FF:000043', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(104034, NULL, 'G3DSA:1.25.40.10:FF:002121', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g59720, chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(104035, NULL, 'G3DSA:3.30.160.100:FF:000008', NULL, NULL, 'Ribosomal subunit interface protein', NULL, NULL, NULL, NULL, NULL, 4),
(104036, NULL, 'G3DSA:3.40.50.2300:FF:000641', NULL, NULL, 'Low molecular weight phosphotyrosine protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(104037, NULL, 'G3DSA:1.20.1250.20:FF:001642', NULL, NULL, 'Transporter, MFS family protein', NULL, NULL, NULL, NULL, NULL, 4),
(104038, NULL, 'G3DSA:2.40.50.90:FF:000016', NULL, NULL, 'Tudor domain containing 9', NULL, NULL, NULL, NULL, NULL, 4),
(104039, NULL, 'G3DSA:3.30.70.1070:FF:000016', NULL, NULL, 'Endolytic peptidoglycan transglycosylase RlpA', NULL, NULL, NULL, NULL, NULL, 4),
(104040, NULL, 'G3DSA:3.40.50.1820:FF:000688', NULL, NULL, 'Esterase/lipase/thioesterase family protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(104041, NULL, 'G3DSA:1.10.630.10:FF:000289', NULL, NULL, 'Cytochrome P450, family 2, subfamily j, polypeptide 13', NULL, NULL, NULL, NULL, NULL, 4),
(104042, NULL, 'G3DSA:3.40.50.300:FF:008075', NULL, NULL, 'Atlastin GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(104043, NULL, 'G3DSA:1.10.472.10:FF:000269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104044, NULL, 'G3DSA:1.10.3130.10:FF:000008', NULL, NULL, 'Probable serine acetyltransferase 4', NULL, NULL, NULL, NULL, NULL, 4),
(104045, NULL, 'G3DSA:2.60.120.650:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104046, NULL, 'G3DSA:2.60.40.10:FF:005983', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104047, NULL, 'G3DSA:2.130.10.10:FF:000441', NULL, NULL, 'U3 small nucleolar RNA-associated protein 4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(104048, NULL, 'G3DSA:1.20.5.190:FF:000083', NULL, NULL, 'Myosin 10A, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(104049, NULL, 'G3DSA:2.130.10.10:FF:003870', NULL, NULL, 'Uncharacterized protein C1F3.03', NULL, NULL, NULL, NULL, NULL, 4),
(104050, NULL, 'G3DSA:3.30.70.590:FF:000017', NULL, NULL, 'Poly polymerase central domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(104051, NULL, 'G3DSA:2.70.170.10:FF:000163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104052, NULL, 'G3DSA:3.30.40.10:FF:000013', NULL, NULL, 'E3 ubiquitin-protein ligase MGRN1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(104053, NULL, 'G3DSA:3.30.160.60:FF:000379', NULL, NULL, 'Zinc finger and BTB domain-containing protein 46', NULL, NULL, NULL, NULL, NULL, 4),
(104054, NULL, 'G3DSA:1.25.40.720:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104055, NULL, 'G3DSA:3.40.50.720:FF:001680', NULL, NULL, 'Phosphoglycerate dehydrogenase SerA2-putative NAD-dependent 2-hydroxyacid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(104056, NULL, 'G3DSA:1.20.58.60:FF:000579', NULL, NULL, 'SEC14 domain and spectrin repeat-containing protein 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(104057, NULL, 'G3DSA:3.30.70.1230:FF:000233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104058, NULL, 'G3DSA:2.30.30.40:FF:000422', NULL, NULL, 'voltage-dependent L-type calcium channel subunit beta-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(104059, NULL, 'G3DSA:3.40.50.720:FF:001972', NULL, NULL, 'Blr5975 protein', NULL, NULL, NULL, NULL, NULL, 4),
(104060, NULL, 'G3DSA:3.30.230.70:FF:000028', NULL, NULL, 'exosome complex component RRP41', NULL, NULL, NULL, NULL, NULL, 4),
(104061, NULL, 'G3DSA:3.90.1150.10:FF:000416', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(104062, NULL, 'G3DSA:3.30.2350.20:FF:000022', NULL, NULL, 'GM25058', NULL, NULL, NULL, NULL, NULL, 4),
(104063, NULL, 'G3DSA:1.10.1450.10:FF:000055', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(104064, NULL, 'G3DSA:2.60.200.20:FF:000273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104065, NULL, 'G3DSA:2.40.33.10:FF:000043', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(104066, NULL, 'G3DSA:1.20.120.140:FF:000027', NULL, NULL, 'Signal recognition particle receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(104067, NULL, 'G3DSA:2.40.128.150:FF:000002', NULL, NULL, 'Arylamine N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(104068, NULL, 'G3DSA:3.90.290.10:FF:000023', NULL, NULL, 'Latent transforming growth factor beta binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(104069, NULL, 'G3DSA:2.10.220.10:FF:000147', NULL, NULL, 'Putative furin-like protease 2', NULL, NULL, NULL, NULL, NULL, 4),
(104070, NULL, 'G3DSA:2.120.10.30:FF:000352', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104071, NULL, 'G3DSA:1.25.10.10:FF:002147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104072, NULL, 'G3DSA:1.10.10.60:FF:000284', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(104073, NULL, 'G3DSA:3.30.60.30:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104074, NULL, 'G3DSA:3.90.1150.10:FF:000068', NULL, NULL, 'LPS biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(104075, NULL, 'G3DSA:3.40.50.300:FF:002919', NULL, NULL, 'Mg-protoporphyrin IX chelatase', NULL, NULL, NULL, NULL, NULL, 4),
(104076, NULL, 'G3DSA:3.40.50.300:FF:005202', NULL, NULL, 'Ras-related protein Rab-13', NULL, NULL, NULL, NULL, NULL, 4),
(104077, NULL, 'G3DSA:1.20.1090.10:FF:000030', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(104078, NULL, 'G3DSA:3.40.50.2300:FF:001597', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104079, NULL, 'G3DSA:3.30.420.40:FF:000972', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104080, NULL, 'G3DSA:1.20.5.4130:FF:000004', NULL, NULL, 'Disease resistance protein Pikm2-TS', NULL, NULL, NULL, NULL, NULL, 4),
(104081, NULL, 'G3DSA:1.25.40.10:FF:000822', NULL, NULL, 'ER membrane protein complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(104082, NULL, 'G3DSA:2.60.40.2030:FF:000005', NULL, NULL, 'Extracellular matrix protein FRAS1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(104083, NULL, 'G3DSA:2.130.10.10:FF:004179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104084, NULL, 'G3DSA:2.30.29.30:FF:001366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104085, NULL, 'G3DSA:3.40.50.300:FF:001779', NULL, NULL, 'Nickel ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(104086, NULL, 'G3DSA:3.90.980.20:FF:000005', NULL, NULL, 'Set1/Ash2 histone methyltransferase complex subunit ASH2', NULL, NULL, NULL, NULL, NULL, 4),
(104087, NULL, 'G3DSA:2.130.10.10:FF:005758', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104088, NULL, 'G3DSA:3.40.50.300:FF:006961', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104089, NULL, 'G3DSA:3.30.160.60:FF:002178', NULL, NULL, 'Zinc finger protein 169', NULL, NULL, NULL, NULL, NULL, 4),
(104090, NULL, 'G3DSA:1.25.40.10:FF:002031', NULL, NULL, 'Os03g0314400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(104091, NULL, 'G3DSA:3.90.230.10:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104092, NULL, 'G3DSA:1.25.70.10:FF:000032', NULL, NULL, 'PAS domain containing serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(104093, NULL, 'G3DSA:1.20.5.4770:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104094, NULL, 'G3DSA:2.60.40.1220:FF:000010', NULL, NULL, 'Copper resistance protein CopC / Copper resistance protein CopD', NULL, NULL, NULL, NULL, NULL, 4),
(104095, NULL, 'G3DSA:1.10.630.10:FF:000379', NULL, NULL, 'Cytochrome P450, family 4, subfamily f, polypeptide 13', NULL, NULL, NULL, NULL, NULL, 4),
(104096, NULL, 'G3DSA:2.140.10.30:FF:000014', NULL, NULL, 'Ste13p', NULL, NULL, NULL, NULL, NULL, 4),
(104097, NULL, 'G3DSA:1.25.40.90:FF:000008', NULL, NULL, 'VHS domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(104098, NULL, 'G3DSA:2.70.98.10:FF:000062', NULL, NULL, 'Alpha-1,2-mannosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104099, NULL, 'G3DSA:1.10.10.10:FF:000724', NULL, NULL, 'Histone H1-like protein in spermatids 1', NULL, NULL, NULL, NULL, NULL, 4),
(104100, NULL, 'G3DSA:3.30.310.50:FF:000023', NULL, NULL, 'Phosphoglucomutase', NULL, NULL, NULL, NULL, NULL, 4),
(104101, NULL, 'G3DSA:3.60.15.10:FF:000060', NULL, NULL, 'N-acyl homoserine lactonase AiiA', NULL, NULL, NULL, NULL, NULL, 4),
(104102, NULL, 'G3DSA:1.10.150.240:FF:000026', NULL, NULL, '2-deoxyglucose-6-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(104103, NULL, 'G3DSA:3.90.1750.10:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104104, NULL, 'G3DSA:3.40.190.10:FF:000841', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104105, NULL, 'G3DSA:3.50.50.60:FF:000027', NULL, NULL, 'Lysine-specific histone demethylase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(104106, NULL, 'G3DSA:3.40.50.720:FF:001495', NULL, NULL, 'SUMO-activating enzyme subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(104107, NULL, 'G3DSA:3.30.310.40:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104108, NULL, 'G3DSA:2.10.70.10:FF:000248', NULL, NULL, 'Selectin P', NULL, NULL, NULL, NULL, NULL, 4),
(104109, NULL, 'G3DSA:3.80.10.10:FF:003802', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104110, NULL, 'G3DSA:1.10.510.10:FF:004057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104111, NULL, 'G3DSA:3.30.160.60:FF:006073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104112, NULL, 'G3DSA:1.10.10.2210:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104113, NULL, 'G3DSA:3.30.710.10:FF:000204', NULL, NULL, 'BTB/POZ and TAZ domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(104114, NULL, 'G3DSA:3.40.50.920:FF:000037', NULL, NULL, 'Sulfite reductase [NADPH] flavoprotein component, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104115, NULL, 'G3DSA:3.40.30.10:FF:001012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104116, NULL, 'G3DSA:2.40.160.110:FF:000049', NULL, NULL, 'uncharacterized protein LOC100185667', NULL, NULL, NULL, NULL, NULL, 4),
(104117, NULL, 'G3DSA:2.80.10.50:FF:000225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104118, NULL, 'G3DSA:3.50.30.30:FF:000068', NULL, NULL, 'Carboxypeptidase Q', NULL, NULL, NULL, NULL, NULL, 4),
(104119, NULL, 'G3DSA:3.10.129.10:FF:000032', NULL, NULL, 'Acyl-CoA thioester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(104120, NULL, 'G3DSA:3.40.640.10:FF:000472', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104121, NULL, 'G3DSA:3.40.1110.10:FF:000465', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104122, NULL, 'G3DSA:3.30.200.20:FF:002041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104123, NULL, 'G3DSA:3.30.160.60:FF:004274', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104124, NULL, 'G3DSA:1.10.510.10:FF:000432', NULL, NULL, 'mitogen-activated protein kinase kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(104125, NULL, 'G3DSA:3.30.160.60:FF:001868', NULL, NULL, 'Zinc finger protein 264', NULL, NULL, NULL, NULL, NULL, 4),
(104126, NULL, 'G3DSA:1.20.120.530:FF:000021', NULL, NULL, 'Gluconate operon transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(104127, NULL, 'G3DSA:2.40.10.10:FF:000294', NULL, NULL, 'Modular serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(104128, NULL, 'G3DSA:1.10.287.2620:FF:000010', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(104129, NULL, 'G3DSA:3.90.1300.10:FF:000007', NULL, NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(104130, NULL, 'G3DSA:1.25.10.10:FF:000348', NULL, NULL, 'uncharacterized protein LOC106763108 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(104131, NULL, 'G3DSA:2.130.10.10:FF:002240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104132, NULL, 'G3DSA:2.60.120.10:FF:000792', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104133, NULL, 'G3DSA:2.80.10.50:FF:000079', NULL, NULL, 'Ricin', NULL, NULL, NULL, NULL, NULL, 4),
(104134, NULL, 'G3DSA:3.40.50.80:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104135, NULL, 'G3DSA:2.130.10.10:FF:000817', NULL, NULL, 'WGS project CABT00000000 data, contig 2.15', NULL, NULL, NULL, NULL, NULL, 4),
(104136, NULL, 'G3DSA:3.40.50.10810:FF:000192', NULL, NULL, 'Chromodomain helicase DNA-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(104137, NULL, 'G3DSA:3.40.50.300:FF:007001', NULL, NULL, 'Os06g0503100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(104138, NULL, 'G3DSA:1.10.620.20:FF:000027', NULL, NULL, 'Ribonucleoside-diphosphate reductase small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(104139, NULL, 'G3DSA:3.10.129.110:FF:000002', NULL, NULL, 'Fatty acid synthase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(104140, NULL, 'G3DSA:2.60.40.10:FF:000547', NULL, NULL, 'Titin a', NULL, NULL, NULL, NULL, NULL, 4),
(104141, NULL, 'G3DSA:1.25.40.10:FF:000204', NULL, NULL, 'Purkinje cell protein 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(104142, NULL, 'G3DSA:3.30.70.330:FF:001772', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104143, NULL, 'G3DSA:3.30.420.10:FF:000626', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104144, NULL, 'G3DSA:1.25.10.10:FF:001978', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104145, NULL, 'G3DSA:3.40.50.150:FF:000587', NULL, NULL, 'tRNA methyltransferase complex GCD14 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(104146, NULL, 'G3DSA:1.20.144.10:FF:000011', NULL, NULL, 'sphingosine-1-phosphate phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(104147, NULL, 'G3DSA:2.130.10.10:FF:001397', NULL, NULL, 'AGAP002030-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(104148, NULL, 'G3DSA:3.30.230.120:FF:000003', NULL, NULL, 'Probable glucuronokinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(104149, NULL, 'G3DSA:1.10.8.10:FF:000358', NULL, NULL, 'Ubiquitin-associated protein 2b', NULL, NULL, NULL, NULL, NULL, 4),
(104150, NULL, 'G3DSA:2.170.270.10:FF:000040', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(104151, NULL, 'G3DSA:3.30.160.60:FF:002357', NULL, NULL, 'Zinc finger protein 782', NULL, NULL, NULL, NULL, NULL, 4),
(104152, NULL, 'G3DSA:3.30.160.60:FF:000289', NULL, NULL, 'B-cell CLL/lymphoma 6, member B', NULL, NULL, NULL, NULL, NULL, 4),
(104153, NULL, 'G3DSA:1.10.150.50:FF:000197', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(104154, NULL, 'G3DSA:1.20.140.40:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104155, NULL, 'G3DSA:3.30.230.130:FF:000006', NULL, NULL, 'Cullin-4 like', NULL, NULL, NULL, NULL, NULL, 4),
(104156, NULL, 'G3DSA:3.40.50.720:FF:001354', NULL, NULL, 'Grp1p', NULL, NULL, NULL, NULL, NULL, 4),
(104157, NULL, 'G3DSA:2.130.10.10:FF:000295', NULL, NULL, 'Protein transport protein SEC31 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(104158, NULL, 'G3DSA:3.90.550.10:FF:000358', NULL, NULL, 'Procollagen-lysine, 2-oxoglutarate 5-dioxygenase 3', NULL, NULL, NULL, NULL, NULL, 4),
(104159, NULL, 'G3DSA:2.130.10.10:FF:005668', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104160, NULL, 'G3DSA:3.40.50.10810:FF:000276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104161, NULL, 'G3DSA:3.30.70.330:FF:000670', NULL, NULL, 'Unplaced genomic scaffold supercont1.9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(104162, NULL, 'G3DSA:3.80.10.10:FF:003128', NULL, NULL, 'LGI1B', NULL, NULL, NULL, NULL, NULL, 4),
(104163, NULL, 'G3DSA:3.30.390.110:FF:000001', NULL, NULL, 'Protein MAK16 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(104164, NULL, 'G3DSA:3.90.1150.10:FF:000040', NULL, NULL, 'Tyrosine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(104165, NULL, 'G3DSA:3.40.50.10900:FF:000005', NULL, NULL, 'Proteasome assembly chaperone 2', NULL, NULL, NULL, NULL, NULL, 4),
(104166, NULL, 'G3DSA:2.130.10.10:FF:001745', NULL, NULL, '6-phosphogluconolactonase', NULL, NULL, NULL, NULL, NULL, 4),
(104167, NULL, 'G3DSA:1.10.418.10:FF:000161', NULL, NULL, 'Fimbrin', NULL, NULL, NULL, NULL, NULL, 4),
(104168, NULL, 'G3DSA:2.130.10.10:FF:002381', NULL, NULL, 'GM18507', NULL, NULL, NULL, NULL, NULL, 4),
(104169, NULL, 'G3DSA:3.10.105.10:FF:000090', NULL, NULL, 'Glycine betaine/carnitine transport binding protein GbuC', NULL, NULL, NULL, NULL, NULL, 4),
(104170, NULL, 'G3DSA:1.20.1420.30:FF:000017', NULL, NULL, 'Calcium permease family membrane transporter', NULL, NULL, NULL, NULL, NULL, 4),
(104171, NULL, 'G3DSA:1.10.510.10:FF:001977', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104172, NULL, 'G3DSA:3.30.160.60:FF:003341', NULL, NULL, 'Zinc finger protein 1152', NULL, NULL, NULL, NULL, NULL, 4),
(104173, NULL, 'G3DSA:3.20.20.150:FF:000001', NULL, NULL, 'Probable endonuclease 4', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(104174, NULL, 'G3DSA:3.40.50.300:FF:004836', NULL, NULL, 'Mitochondrial Rho GTPase 3', NULL, NULL, NULL, NULL, NULL, 4),
(104175, NULL, 'G3DSA:3.40.1050.10:FF:000027', NULL, NULL, 'Carbon disulfide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(104176, NULL, 'G3DSA:2.60.40.10:FF:001003', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(104177, NULL, 'G3DSA:3.30.160.60:FF:002852', NULL, NULL, 'Dorsal Intercalation and Elongation defect', NULL, NULL, NULL, NULL, NULL, 4),
(104178, NULL, 'G3DSA:1.20.1270.220:FF:000002', NULL, NULL, 'Transcription factor GTE4', NULL, NULL, NULL, NULL, NULL, 4),
(104179, NULL, 'G3DSA:1.10.760.10:FF:000006', NULL, NULL, 'Cytochrome C', NULL, NULL, NULL, NULL, NULL, 4),
(104180, NULL, 'G3DSA:3.30.70.3290:FF:000013', NULL, NULL, '6-deoxyerythronolide-B synthase EryA2, modules 3 and 4', NULL, NULL, NULL, NULL, NULL, 4),
(104181, NULL, 'G3DSA:3.40.350.10:FF:000045', NULL, NULL, 'Metallopeptidase, family M24', NULL, NULL, NULL, NULL, NULL, 4),
(104182, NULL, 'G3DSA:3.40.640.10:FF:000146', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(104183, NULL, 'G3DSA:3.30.260.10:FF:000006', NULL, NULL, 'T-complex protein 1 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(104184, NULL, 'G3DSA:3.30.200.20:FF:001585', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104185, NULL, 'G3DSA:2.60.40.150:FF:000629', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104186, NULL, 'G3DSA:2.130.10.10:FF:005022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104187, NULL, 'G3DSA:2.60.40.10:FF:001649', NULL, NULL, 'T cell receptor gamma, variable 3', NULL, NULL, NULL, NULL, NULL, 4),
(104188, NULL, 'G3DSA:1.20.5.340:FF:000061', NULL, NULL, 'Myosin-3', NULL, NULL, NULL, NULL, NULL, 4),
(104189, NULL, 'G3DSA:2.170.270.10:FF:000181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104190, NULL, 'G3DSA:2.130.10.10:FF:004038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104191, NULL, 'G3DSA:3.40.50.1000:FF:000206', NULL, NULL, 'Probable sucrose-phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(104192, NULL, 'G3DSA:3.30.70.330:FF:000046', NULL, NULL, 'RNA-binding protein 14 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(104193, NULL, 'G3DSA:2.60.120.10:FF:000819', NULL, NULL, 'ADR385Wp', NULL, NULL, NULL, NULL, NULL, 4),
(104194, NULL, 'G3DSA:2.40.30.330:FF:000012', NULL, NULL, 'Protein CLP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(104195, NULL, 'G3DSA:1.10.510.10:FF:002910', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104196, NULL, 'G3DSA:2.60.120.970:FF:000098', NULL, NULL, 'Maverick', NULL, NULL, NULL, NULL, NULL, 4),
(104197, NULL, 'G3DSA:3.40.50.1010:FF:000209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104198, NULL, 'G3DSA:3.30.1020.10:FF:000005', NULL, NULL, 'Thiol-specific antioxidant protein', NULL, NULL, NULL, NULL, NULL, 4),
(104199, NULL, 'G3DSA:3.30.740.10:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104200, NULL, 'G3DSA:1.25.10.10:FF:000258', NULL, NULL, 'G-protein coupled receptor-associated sorting protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(104201, NULL, 'G3DSA:1.25.10.10:FF:002821', NULL, NULL, 'Wings apart-like protein homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(104202, NULL, 'G3DSA:2.60.40.10:FF:000637', NULL, NULL, 'Basement membrane proteoglycan', NULL, NULL, NULL, NULL, NULL, 4),
(104203, NULL, 'G3DSA:1.10.268.10:FF:000008', NULL, NULL, 'DNA gyrase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(104204, NULL, 'G3DSA:1.25.10.10:FF:002473', NULL, NULL, 'Tubulin-specific chaperone D', NULL, NULL, NULL, NULL, NULL, 4),
(104205, NULL, 'G3DSA:1.10.472.10:FF:000067', NULL, NULL, 'Retinoblastoma-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(104206, NULL, 'G3DSA:3.30.1390.20:FF:000029', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(104207, NULL, 'G3DSA:3.40.430.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(104208, NULL, 'G3DSA:2.10.90.10:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104209, NULL, 'G3DSA:3.90.70.80:FF:000010', NULL, NULL, 'OTU domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(104210, NULL, 'G3DSA:3.40.50.300:FF:000385', NULL, NULL, 'Structural maintenance of chromosomes 2', NULL, NULL, NULL, NULL, NULL, 4),
(104211, NULL, 'G3DSA:3.20.80.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104212, NULL, 'G3DSA:3.80.10.10:FF:003746', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(104213, NULL, 'G3DSA:2.30.30.490:FF:000011', NULL, NULL, 'DNA (cytosine-5)-methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(104214, NULL, 'G3DSA:1.10.1420.10:FF:000137', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(104215, NULL, 'G3DSA:3.20.20.140:FF:000459', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104216, NULL, 'G3DSA:3.40.50.1000:FF:000824', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104217, NULL, 'G3DSA:1.10.472.130:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104218, NULL, 'G3DSA:3.40.50.300:FF:000475', NULL, NULL, 'GTP-binding protein Rhes', NULL, NULL, NULL, NULL, NULL, 4),
(104219, NULL, 'G3DSA:3.30.1640.10:FF:000097', NULL, NULL, 'DNA replication licensing factor (Mcm)', NULL, NULL, NULL, NULL, NULL, 4),
(104220, NULL, 'G3DSA:1.25.40.20:FF:000825', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104221, NULL, 'G3DSA:3.10.20.30:FF:000069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104222, NULL, 'G3DSA:3.30.420.40:FF:000702', NULL, NULL, 'Acetate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(104223, NULL, 'G3DSA:3.20.20.70:FF:000474', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104224, NULL, 'G3DSA:1.20.200.10:FF:000007', NULL, NULL, 'Adenylosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(104225, NULL, 'G3DSA:1.10.195.10:FF:000001', NULL, NULL, 'Protein Vpu', NULL, NULL, NULL, NULL, NULL, 4),
(104226, NULL, 'G3DSA:3.90.550.50:FF:000140', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(104227, NULL, 'G3DSA:3.30.565.10:FF:000366', NULL, NULL, 'Hybrid signal transduction histidine kinase H', NULL, NULL, NULL, NULL, NULL, 4),
(104228, NULL, 'G3DSA:3.90.550.10:FF:000268', NULL, NULL, '2-C-methyl-D-erythritol 4-phosphate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(104229, NULL, 'G3DSA:2.30.30.40:FF:000512', NULL, NULL, 'Alpha-(1,6)-fucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(104230, NULL, 'G3DSA:2.60.40.10:FF:000019', NULL, NULL, 'receptor-type tyrosine-protein phosphatase kappa isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(104231, NULL, 'G3DSA:3.40.532.10:FF:000007', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(104232, NULL, 'G3DSA:2.60.120.260:FF:000126', NULL, NULL, 'Allantoicase', NULL, NULL, NULL, NULL, NULL, 4),
(104233, NULL, 'G3DSA:1.10.150.780:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104234, NULL, 'G3DSA:3.40.1110.10:FF:000139', NULL, NULL, 'Probable cation-transporting ATPase F', NULL, NULL, NULL, NULL, NULL, 4),
(104235, NULL, 'G3DSA:1.20.1250.20:FF:001496', NULL, NULL, 'Os11g0284032 protein', NULL, NULL, NULL, NULL, NULL, 4),
(104236, NULL, 'G3DSA:3.30.70.580:FF:000014', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(104237, NULL, 'G3DSA:1.25.10.10:FF:002203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104238, NULL, 'G3DSA:3.30.160.60:FF:002234', NULL, NULL, 'Zinc finger protein 444', NULL, NULL, NULL, NULL, NULL, 4),
(104239, NULL, 'G3DSA:3.50.50.100:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104240, NULL, 'G3DSA:2.120.10.30:FF:000442', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(104241, NULL, 'G3DSA:3.30.1140.60:FF:000006', NULL, NULL, 'F-actin-capping protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(104242, NULL, 'G3DSA:3.40.50.300:FF:006158', NULL, NULL, 'RIKEN cDNA 9930111J21 gene 1', NULL, NULL, NULL, NULL, NULL, 4),
(104243, NULL, 'G3DSA:3.40.250.10:FF:000189', NULL, NULL, 'MBL fold metallo-hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(104244, NULL, 'G3DSA:3.40.50.150:FF:000317', NULL, NULL, 'Putative methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(104245, NULL, 'G3DSA:1.10.150.770:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104246, NULL, 'G3DSA:3.40.50.300:FF:002420', NULL, NULL, 'ROK1p RNA-dependent ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(104247, NULL, 'G3DSA:3.30.830.10:FF:000207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104248, NULL, 'G3DSA:2.60.40.150:FF:000253', NULL, NULL, 'Protostome-specific GEF, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(104249, NULL, 'G3DSA:2.70.150.10:FF:000280', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(104250, NULL, 'G3DSA:3.80.10.10:FF:001386', NULL, NULL, 'Protein MALE DISCOVERER 1', NULL, NULL, NULL, NULL, NULL, 4),
(104251, NULL, 'G3DSA:3.40.390.10:FF:000261', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104252, NULL, 'G3DSA:2.10.25.10:FF:000975', NULL, NULL, 'MAM and LDL-receptor class A domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(104253, NULL, 'G3DSA:3.40.50.300:FF:002274', NULL, NULL, 'Si:dkeyp-69e1.8', NULL, NULL, NULL, NULL, NULL, 4),
(104254, NULL, 'G3DSA:3.30.160.60:FF:003015', NULL, NULL, 'Si:dkey-111k8.3', NULL, NULL, NULL, NULL, NULL, 4),
(104255, NULL, 'G3DSA:2.70.70.10:FF:000032', NULL, NULL, 'Peptidase family M23', NULL, NULL, NULL, NULL, NULL, 4),
(104256, NULL, 'G3DSA:3.40.50.300:FF:006545', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(104257, NULL, 'G3DSA:3.40.50.970:FF:000030', NULL, NULL, '1-deoxy-D-xylulose-5-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(104258, NULL, 'G3DSA:2.40.70.10:FF:000303', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104259, NULL, 'G3DSA:3.40.50.1460:FF:000001', NULL, NULL, 'Caspase-3 preproprotein', NULL, NULL, NULL, NULL, NULL, 4),
(104260, NULL, 'G3DSA:3.90.70.10:FF:000063', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(104261, NULL, 'G3DSA:3.30.1740.20:FF:000012', NULL, NULL, '40S ribosomal protein S26', NULL, NULL, NULL, NULL, NULL, 4),
(104262, NULL, 'G3DSA:3.30.420.40:FF:000085', NULL, NULL, 'Glycerol kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(104263, NULL, 'G3DSA:3.10.100.10:FF:000421', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104264, NULL, 'G3DSA:2.20.28.230:FF:000006', NULL, NULL, 'Zona pellucida sperm-binding protein 3 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(104265, NULL, 'G3DSA:3.90.70.10:FF:000591', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104266, NULL, 'G3DSA:2.130.10.10:FF:003021', NULL, NULL, 'ATG16/SAP18/CVT11/APG16, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104267, NULL, 'G3DSA:2.60.40.10:FF:002436', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(104268, NULL, 'G3DSA:1.20.1250.20:FF:001294', NULL, NULL, 'sialin-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(104269, NULL, 'G3DSA:2.60.40.3500:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104270, NULL, 'G3DSA:3.30.160.60:FF:000851', NULL, NULL, 'Putative transcriptional repressor ctcf', NULL, NULL, NULL, NULL, NULL, 4),
(104271, NULL, 'G3DSA:1.10.510.10:FF:004473', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104272, NULL, 'G3DSA:1.20.1250.20:FF:001350', NULL, NULL, 'Solute carrier family 2 member 1b', NULL, NULL, NULL, NULL, NULL, 4),
(104273, NULL, 'G3DSA:1.10.357.10:FF:000081', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(104274, NULL, 'G3DSA:3.40.50.1470:FF:000004', NULL, NULL, 'Probable peptidyl-tRNA hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(104275, NULL, 'G3DSA:3.40.630.10:FF:000027', NULL, NULL, 'N-fatty-acyl-amino acid synthase/hydrolase PM20D1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(104276, NULL, 'G3DSA:3.30.565.10:FF:000164', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(104277, NULL, 'G3DSA:3.40.50.300:FF:004359', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(104278, NULL, 'G3DSA:2.60.40.10:FF:000345', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(104279, NULL, 'G3DSA:3.20.20.70:FF:000766', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104280, NULL, 'G3DSA:1.10.357.20:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104281, NULL, 'G3DSA:3.30.160.60:FF:006247', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104282, NULL, 'G3DSA:3.80.10.10:FF:002965', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104283, NULL, 'G3DSA:3.30.160.60:FF:005578', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104284, NULL, 'G3DSA:2.30.130.40:FF:000021', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(104285, NULL, 'G3DSA:1.10.10.10:FF:000494', NULL, NULL, 'Blast:Protein gooseberry-neuro', NULL, NULL, NULL, NULL, NULL, 4),
(104286, NULL, 'G3DSA:2.60.40.790:FF:000181', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104287, NULL, 'G3DSA:3.90.1410.10:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104288, NULL, 'G3DSA:1.20.1070.10:FF:000091', NULL, NULL, 'G-protein coupled receptor 161', NULL, NULL, NULL, NULL, NULL, 4),
(104289, NULL, 'G3DSA:2.40.10.10:FF:000327', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104290, NULL, 'G3DSA:3.40.50.1480:FF:000007', NULL, NULL, 'Adenosylhomocysteinase', NULL, NULL, NULL, NULL, NULL, 4),
(104291, NULL, 'G3DSA:2.70.150.10:FF:000274', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(104292, NULL, 'G3DSA:1.10.472.10:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104293, NULL, 'G3DSA:1.10.1490.10:FF:000001', NULL, NULL, 'DNA fragmentation factor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(104294, NULL, 'G3DSA:2.30.29.30:FF:001192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104295, NULL, 'G3DSA:1.10.472.10:FF:000270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104296, NULL, 'G3DSA:2.40.30.10:FF:000183', NULL, NULL, 'NADPH oxidase 4', NULL, NULL, NULL, NULL, NULL, 4),
(104297, NULL, 'G3DSA:1.10.357.10:FF:000024', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(104298, NULL, 'G3DSA:3.30.420.110:FF:000021', NULL, NULL, 'DNA mismatch repair protein MSH2', NULL, NULL, NULL, NULL, NULL, 4),
(104299, NULL, 'G3DSA:3.30.160.60:FF:004651', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104300, NULL, 'G3DSA:1.10.10.10:FF:000550', NULL, NULL, 'Heat shock transcription factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(104301, NULL, 'G3DSA:3.40.50.300:FF:005938', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(104302, NULL, 'G3DSA:2.60.120.10:FF:000735', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104303, NULL, 'G3DSA:3.40.50.1440:FF:000046', NULL, NULL, 'DML1p protein', NULL, NULL, NULL, NULL, NULL, 4),
(104304, NULL, 'G3DSA:3.90.930.12:FF:000007', NULL, NULL, '60S ribosomal protein L6', NULL, NULL, NULL, NULL, NULL, 4),
(104305, NULL, 'G3DSA:3.40.50.300:FF:008254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104306, NULL, 'G3DSA:1.20.120.1750:FF:000130', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(104307, NULL, 'G3DSA:3.80.10.10:FF:001329', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(104308, NULL, 'G3DSA:3.20.20.140:FF:000465', NULL, NULL, 'Gll3396 protein', NULL, NULL, NULL, NULL, NULL, 4),
(104309, NULL, 'G3DSA:1.10.10.60:FF:000514', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(104310, NULL, 'G3DSA:1.25.40.10:FF:002205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(104311, NULL, 'G3DSA:3.40.50.720:FF:001169', NULL, NULL, 'Hydroxysteroid (17-beta) dehydrogenase 4, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(104312, NULL, 'G3DSA:1.10.246.60:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104313, NULL, 'G3DSA:3.40.50.300:FF:008198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104314, NULL, 'G3DSA:3.40.140.10:FF:000119', NULL, NULL, 'Non ATPase subunit MPR1 of 26S proteasome', NULL, NULL, NULL, NULL, NULL, 4),
(104315, NULL, 'G3DSA:1.10.10.60:FF:000458', NULL, NULL, 'Transcription factor MYB86', NULL, NULL, NULL, NULL, NULL, 4),
(104316, NULL, 'G3DSA:2.130.10.10:FF:003398', NULL, NULL, 'Metastasis associated 1 family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(104317, NULL, 'G3DSA:2.40.10.10:FF:000653', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104318, NULL, 'G3DSA:3.50.50.60:FF:001039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104319, NULL, 'G3DSA:3.40.50.2060:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104320, NULL, 'G3DSA:3.40.50.300:FF:006074', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(104321, NULL, 'G3DSA:3.60.20.10:FF:000179', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104322, NULL, 'G3DSA:3.30.420.40:FF:000028', NULL, NULL, 'heat shock 70 kDa protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(104323, NULL, 'G3DSA:3.40.50.300:FF:006017', NULL, NULL, 'ABC transporter H family member 4', NULL, NULL, NULL, NULL, NULL, 4),
(104324, NULL, 'G3DSA:3.40.140.10:FF:000158', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(104325, NULL, 'G3DSA:3.40.30.10:FF:000377', NULL, NULL, 'Putative glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(104326, NULL, 'G3DSA:2.60.40.4070:FF:000005', NULL, NULL, 'Minor extracellular protease VpR', NULL, NULL, NULL, NULL, NULL, 4),
(104327, NULL, 'G3DSA:2.60.40.10:FF:004673', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104328, NULL, 'G3DSA:3.90.182.10:FF:000002', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(104329, NULL, 'G3DSA:3.20.20.70:FF:000390', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(104330, NULL, 'G3DSA:3.60.15.10:FF:000234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104331, NULL, 'G3DSA:3.30.70.870:FF:000034', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(104332, NULL, 'G3DSA:3.40.47.10:FF:000180', NULL, NULL, 'Acetyl-CoA acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(104333, NULL, 'G3DSA:2.60.40.4060:FF:000002', NULL, NULL, 'Spondin-1', NULL, NULL, NULL, NULL, NULL, 4),
(104334, NULL, 'G3DSA:3.30.200.20:FF:001872', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104335, NULL, 'G3DSA:2.130.10.10:FF:002414', NULL, NULL, 'Notchless', NULL, NULL, NULL, NULL, NULL, 4),
(104336, NULL, 'G3DSA:2.170.270.10:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104337, NULL, 'G3DSA:1.20.1560.10:FF:000696', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104338, NULL, 'G3DSA:2.30.42.10:FF:000132', NULL, NULL, 'disks large homolog 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(104339, NULL, 'G3DSA:1.20.58.390:FF:000176', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(104340, NULL, 'G3DSA:1.25.70.10:FF:000088', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104341, NULL, 'G3DSA:3.30.830.10:FF:000152', NULL, NULL, 'Metalloenzyme, LuxS/M16 peptidase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(104342, NULL, 'G3DSA:2.40.100.10:FF:000126', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(104343, NULL, 'G3DSA:3.40.50.10420:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104344, NULL, 'G3DSA:1.10.238.10:FF:000714', NULL, NULL, 'Calcium-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(104345, NULL, 'G3DSA:3.30.70.1660:FF:000007', NULL, NULL, 'Peptide chain release factor 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(104346, NULL, 'G3DSA:3.30.70.330:FF:001827', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104347, NULL, 'G3DSA:2.60.40.150:FF:000455', NULL, NULL, 'AT3g18370/MYF24_8', NULL, NULL, NULL, NULL, NULL, 4),
(104348, NULL, 'G3DSA:1.10.10.60:FF:000571', NULL, NULL, 'Two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(104349, NULL, 'G3DSA:2.130.10.10:FF:000525', NULL, NULL, 'U4/U6 small nuclear ribonucleoprotein PRP4', NULL, NULL, NULL, NULL, NULL, 4),
(104350, NULL, 'G3DSA:1.20.58.80:FF:000091', NULL, NULL, 'Calpain-like protease palB', NULL, NULL, NULL, NULL, NULL, 4),
(104351, NULL, 'G3DSA:1.20.80.60:FF:000001', NULL, NULL, 'Sorting nexin-17 isoform1', NULL, NULL, NULL, NULL, NULL, 4),
(104352, NULL, 'G3DSA:3.30.70.330:FF:000900', NULL, NULL, 'Nuclear transport factor 2 domain containing protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(104353, NULL, 'G3DSA:3.20.180.10:FF:000002', NULL, NULL, 'BnaC05g47660D protein', NULL, NULL, NULL, NULL, NULL, 4),
(104354, NULL, 'G3DSA:3.40.30.10:FF:000490', NULL, NULL, 'Mitochondrial Ribosomal Protein, Large', NULL, NULL, NULL, NULL, NULL, 4),
(104355, NULL, 'G3DSA:3.10.20.90:FF:000334', NULL, NULL, 'Ubiquitin', NULL, NULL, NULL, NULL, NULL, 4),
(104356, NULL, 'G3DSA:2.30.29.30:FF:000787', NULL, NULL, 'WW domain-containing protein tag-325', NULL, NULL, NULL, NULL, NULL, 4),
(104357, NULL, 'G3DSA:3.30.160.60:FF:006360', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104358, NULL, 'G3DSA:3.40.1090.10:FF:000114', NULL, NULL, 'Patatin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(104359, NULL, 'G3DSA:3.30.160.60:FF:002649', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104360, NULL, 'G3DSA:2.60.40.150:FF:000635', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104361, NULL, 'G3DSA:2.10.110.10:FF:000291', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(104362, NULL, 'G3DSA:3.20.180.20:FF:000005', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104363, NULL, 'G3DSA:2.130.10.10:FF:001689', NULL, NULL, 'Transcriptional regulator, AraC/XylS family', NULL, NULL, NULL, NULL, NULL, 4),
(104364, NULL, 'G3DSA:2.40.10.10:FF:000614', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104365, NULL, 'G3DSA:2.30.38.10:FF:000021', NULL, NULL, 'Acyl-CoA ligase easD', NULL, NULL, NULL, NULL, NULL, 4),
(104366, NULL, 'G3DSA:3.40.50.150:FF:000643', NULL, NULL, 'Fibrillarin-like rRNA/tRNA 2''-O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(104367, NULL, 'G3DSA:3.40.50.720:FF:001528', NULL, NULL, 'Peroxisomal 2,4-dienoyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(104368, NULL, 'G3DSA:3.90.70.200:FF:000016', NULL, NULL, 'Rtf1p', NULL, NULL, NULL, NULL, NULL, 4),
(104369, NULL, 'G3DSA:2.130.10.10:FF:000469', NULL, NULL, 'Nucleotide binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(104370, NULL, 'G3DSA:2.20.70.10:FF:000107', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(104371, NULL, 'G3DSA:3.40.50.2300:FF:000293', NULL, NULL, 'Response regulator receiver domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(104372, NULL, 'G3DSA:3.30.70.1230:FF:000087', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(104373, NULL, 'G3DSA:4.10.1240.10:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104374, NULL, 'G3DSA:3.30.160.60:FF:002560', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104375, NULL, 'G3DSA:3.30.559.30:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104376, NULL, 'G3DSA:3.20.20.70:FF:000709', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104377, NULL, 'G3DSA:1.25.40.10:FF:001896', NULL, NULL, 'Anaphase-promoting complex subunit 8', NULL, NULL, NULL, NULL, NULL, 4),
(104378, NULL, 'G3DSA:1.10.238.10:FF:000478', NULL, NULL, 'EH domains and endocytosis-related protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(104379, NULL, 'G3DSA:2.130.10.10:FF:002616', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104380, NULL, 'G3DSA:3.90.550.10:FF:000066', NULL, NULL, 'Translation initiation factor eIF-2B subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(104381, NULL, 'G3DSA:3.40.850.10:FF:000100', NULL, NULL, 'Myosin F, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104382, NULL, 'G3DSA:3.10.20.90:FF:000098', NULL, NULL, 'Plexin D1', NULL, NULL, NULL, NULL, NULL, 4),
(104383, NULL, 'G3DSA:2.10.25.10:FF:001285', NULL, NULL, 'Hepatocyte growth factor activator', NULL, NULL, NULL, NULL, NULL, 4),
(104384, NULL, 'G3DSA:1.10.8.470:FF:000006', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(104385, NULL, 'G3DSA:3.40.50.1820:FF:000918', NULL, NULL, 'Serine carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104386, NULL, 'G3DSA:3.40.50.12240:FF:000008', NULL, NULL, 'ATPase, H+ transporting, lysosomal 56/58kD, V1 subunit B, isoform 2 variant', NULL, NULL, NULL, NULL, NULL, 4),
(104387, NULL, 'G3DSA:3.30.200.20:FF:001759', NULL, NULL, 'Rho-associated, coiled-coil-containing protein kinase 2b', NULL, NULL, NULL, NULL, NULL, 4),
(104388, NULL, 'G3DSA:3.20.20.80:FF:000010', NULL, NULL, 'glucan endo-1,3-beta-glucosidase, basic', NULL, NULL, NULL, NULL, NULL, 4),
(104389, NULL, 'G3DSA:1.20.1250.20:FF:002221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104390, NULL, 'G3DSA:1.20.1560.10:FF:000898', NULL, NULL, 'ATP binding cassette subfamily B member 8', NULL, NULL, NULL, NULL, NULL, 4),
(104391, NULL, 'G3DSA:3.40.630.30:FF:000365', NULL, NULL, 'GNAT family N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(104392, NULL, 'G3DSA:3.30.40.10:FF:002053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104393, NULL, 'G3DSA:3.40.50.300:FF:003111', NULL, NULL, 'Translation-associated GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(104394, NULL, 'G3DSA:1.10.730.10:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104395, NULL, 'G3DSA:3.10.110.10:FF:000337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104396, NULL, 'G3DSA:1.25.40.10:FF:001839', NULL, NULL, 'Pentatricopeptide (PPR) repeat-containing protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(104397, NULL, 'G3DSA:1.10.1420.10:FF:000053', NULL, NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(104398, NULL, 'G3DSA:3.30.40.10:FF:000344', NULL, NULL, 'protein SCAF11 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(104399, NULL, 'G3DSA:3.90.550.10:FF:000594', NULL, NULL, 'Glycosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104400, NULL, 'G3DSA:2.130.10.10:FF:005904', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104401, NULL, 'G3DSA:3.40.50.300:FF:000559', NULL, NULL, 'Nuclear/nucleolar GTPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(104402, NULL, 'G3DSA:3.60.10.10:FF:000032', NULL, NULL, 'inositol polyphosphate 5-phosphatase K isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(104403, NULL, 'G3DSA:3.60.21.10:FF:000350', NULL, NULL, '5'' nucleotidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104404, NULL, 'G3DSA:3.30.160.60:FF:002088', NULL, NULL, 'Zinc finger protein ZIC 3', NULL, NULL, NULL, NULL, NULL, 4),
(104405, NULL, 'G3DSA:1.20.58.1880:FF:000020', NULL, NULL, 'Nuclear receptor corepressor 2', NULL, NULL, NULL, NULL, NULL, 4),
(104406, NULL, 'G3DSA:2.170.150.80:FF:000035', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(104407, NULL, 'G3DSA:3.30.160.60:FF:006303', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104408, NULL, 'G3DSA:3.30.1490.100:FF:000053', NULL, NULL, 'Uncharacterized protein MG360', NULL, NULL, NULL, NULL, NULL, 4),
(104409, NULL, 'G3DSA:3.40.50.150:FF:000172', NULL, NULL, 'EEF1A lysine methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(104410, NULL, 'G3DSA:3.30.160.60:FF:006449', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(104411, NULL, 'G3DSA:3.30.420.40:FF:000556', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(104412, NULL, 'G3DSA:3.40.50.12650:FF:000047', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(104413, NULL, 'G3DSA:2.30.110.10:FF:000062', NULL, NULL, 'Monooxygenase HpaC', NULL, NULL, NULL, NULL, NULL, 4),
(104414, NULL, 'G3DSA:3.40.50.1000:FF:000650', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104415, NULL, 'G3DSA:3.40.50.300:FF:003201', NULL, NULL, 'AAA family ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104416, NULL, 'G3DSA:2.60.40.1280:FF:000005', NULL, NULL, 'Collagen adhesin', NULL, NULL, NULL, NULL, NULL, 4),
(104417, NULL, 'G3DSA:3.90.180.10:FF:000110', NULL, NULL, 'Alcohol dehydrogenase (Zn containing) (Adh-13)', NULL, NULL, NULL, NULL, NULL, 4),
(104418, NULL, 'G3DSA:1.10.510.10:FF:002764', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104419, NULL, 'G3DSA:2.60.40.10:FF:004145', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104420, NULL, 'G3DSA:3.30.505.10:FF:000149', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104421, NULL, 'G3DSA:6.20.250.70:FF:000003', NULL, NULL, 'DNA-directed RNA polymerase I subunit', NULL, NULL, NULL, NULL, NULL, 4),
(104422, NULL, 'G3DSA:3.40.50.12230:FF:000005', NULL, NULL, 'Methionyl-tRNA transformylase', NULL, NULL, NULL, NULL, NULL, 4),
(104423, NULL, 'G3DSA:2.120.10.30:FF:000150', NULL, NULL, 'Dipeptidyl peptidase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(104424, NULL, 'G3DSA:3.30.420.40:FF:000500', NULL, NULL, 'Heat shock-related 70 kDa protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(104425, NULL, 'G3DSA:3.40.1440.60:FF:000010', NULL, NULL, 'Probable primosomal protein N''', NULL, NULL, NULL, NULL, NULL, 4),
(104426, NULL, 'G3DSA:1.25.40.20:FF:000651', NULL, NULL, 'Rab GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104427, NULL, 'G3DSA:3.80.10.10:FF:003572', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104428, NULL, 'G3DSA:3.30.230.10:FF:000151', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(104429, NULL, 'G3DSA:2.130.10.10:FF:003869', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104430, NULL, 'G3DSA:1.20.1250.20:FF:002131', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(104431, NULL, 'G3DSA:2.60.120.260:FF:000418', NULL, NULL, 'Ephrin type-A receptor 7', NULL, NULL, NULL, NULL, NULL, 4),
(104432, NULL, 'G3DSA:2.40.170.20:FF:000116', NULL, NULL, 'SusC homolog', NULL, NULL, NULL, NULL, NULL, 4),
(104433, NULL, 'G3DSA:3.30.70.330:FF:001356', NULL, NULL, 'Probable splicing factor, arginine/serine-rich 7', NULL, NULL, NULL, NULL, NULL, 4),
(104434, NULL, 'G3DSA:4.10.520.10:FF:000022', NULL, NULL, 'DNA-binding protein HU-beta', NULL, NULL, NULL, NULL, NULL, 4),
(104435, NULL, 'G3DSA:2.30.30.140:FF:000249', NULL, NULL, 'Putative serine/threonine-protein kinase pats1', NULL, NULL, NULL, NULL, NULL, 4),
(104436, NULL, 'G3DSA:3.90.190.10:FF:000459', NULL, NULL, 'Protein tyrosine phosphatase receptor type K', NULL, NULL, NULL, NULL, NULL, 4),
(104437, NULL, 'G3DSA:3.30.1540.20:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104438, NULL, 'G3DSA:2.60.120.920:FF:000038', NULL, NULL, 'cardiomyopathy-associated protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(104439, NULL, 'G3DSA:3.10.100.10:FF:000039', NULL, NULL, 'Secretory phospholipase A2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(104440, NULL, 'G3DSA:2.40.50.140:FF:000442', NULL, NULL, 'Tyrosyl or methionyl-tRNA synthetase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(104441, NULL, 'G3DSA:1.20.920.20:FF:000020', NULL, NULL, 'Dynein, axonemal, heavy chain 5', NULL, NULL, NULL, NULL, NULL, 4),
(104442, NULL, 'G3DSA:3.90.1150.10:FF:000124', NULL, NULL, 'Histidinol-phosphate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(104443, NULL, 'G3DSA:1.25.10.10:FF:002057', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(104444, NULL, 'G3DSA:1.25.40.730:FF:000016', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(104445, NULL, 'G3DSA:1.10.8.60:FF:000238', NULL, NULL, 'AAA family ATPase, CDC48 subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(104446, NULL, 'G3DSA:3.100.10.20:FF:000003', NULL, NULL, 'CRISPR-associated endonuclease Cas1', NULL, NULL, NULL, NULL, NULL, 4),
(104447, NULL, 'G3DSA:3.40.50.300:FF:001110', NULL, NULL, 'F-box only protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(104448, NULL, 'G3DSA:1.10.1450.10:FF:000111', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(104449, NULL, 'G3DSA:3.30.200.20:FF:000326', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 14', NULL, NULL, NULL, NULL, NULL, 4),
(104450, NULL, 'G3DSA:3.30.497.10:FF:000117', NULL, NULL, 'Serpin peptidase inhibitor 27', NULL, NULL, NULL, NULL, NULL, 4),
(104451, NULL, 'G3DSA:2.60.34.10:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104452, NULL, 'G3DSA:1.10.287.940:FF:000016', NULL, NULL, 'P2X receptor B', NULL, NULL, NULL, NULL, NULL, 4),
(104453, NULL, 'G3DSA:3.30.9.10:FF:000249', NULL, NULL, 'Oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(104454, NULL, 'G3DSA:1.25.10.10:FF:000730', NULL, NULL, 'UTP10p Nucleolar protein', NULL, NULL, NULL, NULL, NULL, 4),
(104455, NULL, 'G3DSA:3.40.950.10:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104456, NULL, 'G3DSA:1.20.920.30:FF:000023', NULL, NULL, 'Glutathione S-transferase class-mu 26 kDa isozyme', NULL, NULL, NULL, NULL, NULL, 4),
(104457, NULL, 'G3DSA:3.30.457.60:FF:000017', NULL, NULL, 'Spindle assembly checkpoint component MAD1', NULL, NULL, NULL, NULL, NULL, 4),
(104458, NULL, 'G3DSA:3.40.630.10:FF:000207', NULL, NULL, 'Gamma-D-glutamyl-L-diamino acid endopeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(104459, NULL, 'G3DSA:1.10.167.10:FF:000009', NULL, NULL, 'G protein-coupled receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(104460, NULL, 'G3DSA:1.25.10.10:FF:000674', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(104461, NULL, 'G3DSA:1.10.287.950:FF:000019', NULL, NULL, 'Biofilm dispersion protein BdlA', NULL, NULL, NULL, NULL, NULL, 4),
(104462, NULL, 'G3DSA:1.10.565.10:FF:000047', NULL, NULL, 'Ultraspiracle, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(104463, NULL, 'G3DSA:3.40.50.620:FF:000829', NULL, NULL, 'AGAP011744-PA', NULL, NULL, NULL, NULL, NULL, 4),
(104464, NULL, 'G3DSA:3.90.105.10:FF:000032', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(104465, NULL, 'G3DSA:3.30.2350.20:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104466, NULL, 'G3DSA:3.10.100.10:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104467, NULL, 'G3DSA:1.10.3110.10:FF:000007', NULL, NULL, 'Amine oxidase, variant 2', NULL, NULL, NULL, NULL, NULL, 4),
(104468, NULL, 'G3DSA:1.20.990.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104469, NULL, 'G3DSA:2.60.120.620:FF:000162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104470, NULL, 'G3DSA:3.30.160.60:FF:000087', NULL, NULL, 'Zinc finger protein 354B', NULL, NULL, NULL, NULL, NULL, 4),
(104471, NULL, 'G3DSA:2.60.40.640:FF:000074', NULL, NULL, 'pH-response regulator protein palF/RIM8', NULL, NULL, NULL, NULL, NULL, 4),
(104472, NULL, 'G3DSA:3.30.160.60:FF:004358', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104473, NULL, 'G3DSA:3.50.50.60:FF:000353', NULL, NULL, 'Pipecolic acid oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(104474, NULL, 'G3DSA:3.40.140.100:FF:000019', NULL, NULL, 'Ubiquitin-like modifier-activating enzyme ATG7', NULL, NULL, NULL, NULL, NULL, 4),
(104475, NULL, 'G3DSA:2.60.120.200:FF:000007', NULL, NULL, 'neurexin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(104476, NULL, 'G3DSA:1.20.58.2220:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104477, NULL, 'G3DSA:3.30.200.20:FF:000511', NULL, NULL, 'Leucine-rich receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(104478, NULL, 'G3DSA:2.10.25.10:FF:001431', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104479, NULL, 'G3DSA:1.20.930.40:FF:000037', NULL, NULL, 'Os01g0740600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(104480, NULL, 'G3DSA:3.40.190.10:FF:000217', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(104481, NULL, 'G3DSA:2.40.70.10:FF:000067', NULL, NULL, 'Endopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104482, NULL, 'G3DSA:1.25.10.10:FF:002675', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104483, NULL, 'G3DSA:3.30.200.20:FF:001905', NULL, NULL, 'Discoidin domain receptor family, member 2, like', NULL, NULL, NULL, NULL, NULL, 4),
(104484, NULL, 'G3DSA:2.130.10.10:FF:002094', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1', NULL, NULL, NULL, NULL, NULL, 4),
(104485, NULL, 'G3DSA:2.40.160.110:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104486, NULL, 'G3DSA:3.40.50.2000:FF:000231', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(104487, NULL, 'G3DSA:3.40.50.2000:FF:000141', NULL, NULL, 'Lipopolysaccharide core heptosyltransferase RfaQ', NULL, NULL, NULL, NULL, NULL, 4),
(104488, NULL, 'G3DSA:3.30.420.270:FF:000018', NULL, NULL, 'Biopolymer transport protein ExbD', NULL, NULL, NULL, NULL, NULL, 4),
(104489, NULL, 'G3DSA:3.40.140.10:FF:000271', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(104490, NULL, 'G3DSA:2.120.10.80:FF:000226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104491, NULL, 'G3DSA:3.30.2410.10:FF:000018', NULL, NULL, 'Putative E3 ubiquitin-protein ligase HECTD3', NULL, NULL, NULL, NULL, NULL, 4),
(104492, NULL, 'G3DSA:2.60.40.60:FF:000753', NULL, NULL, 'Fat-like cadherin-related tumor suppressor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(104493, NULL, 'G3DSA:3.60.21.10:FF:000294', NULL, NULL, 'Acid sphingomyelinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104494, NULL, 'G3DSA:3.40.50.720:FF:001641', NULL, NULL, 'dTDP-glucose 4,6-dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(104495, NULL, 'G3DSA:1.10.560.10:FF:000058', NULL, NULL, 'T-complex protein 1 subunit zeta', NULL, NULL, NULL, NULL, NULL, 4),
(104496, NULL, 'G3DSA:2.130.10.10:FF:000582', NULL, NULL, 'Echinoderm microtubule-associated protein-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(104497, NULL, 'G3DSA:3.40.50.2020:FF:000147', NULL, NULL, 'Hypoxanthine/guanine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(104498, NULL, 'G3DSA:3.30.497.10:FF:000174', NULL, NULL, 'AGAP009213-PA', NULL, NULL, NULL, NULL, NULL, 4),
(104499, NULL, 'G3DSA:1.25.40.10:FF:003992', NULL, NULL, 'Uncharacterized protein C31F10.16', NULL, NULL, NULL, NULL, NULL, 4),
(104500, NULL, 'G3DSA:3.90.470.20:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104501, NULL, 'G3DSA:2.120.10.80:FF:000316', NULL, NULL, 'Multiple EGF like domains 8', NULL, NULL, NULL, NULL, NULL, 4),
(104502, NULL, 'G3DSA:2.60.120.10:FF:000589', NULL, NULL, 'Mannose-1-phosphate guanylyltransferase/mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(104503, NULL, 'G3DSA:1.25.10.10:FF:000056', NULL, NULL, 'FH1/FH2 domain-containing protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(104504, NULL, 'G3DSA:2.130.10.10:FF:003959', NULL, NULL, 'Os01g0606100-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(104505, NULL, 'G3DSA:3.90.550.50:FF:000139', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(104506, NULL, 'G3DSA:1.20.1070.10:FF:001248', NULL, NULL, 'Adhesion G-protein coupled receptor G2', NULL, NULL, NULL, NULL, NULL, 4),
(104507, NULL, 'G3DSA:1.20.1250.20:FF:001911', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(104508, NULL, 'G3DSA:3.30.360.10:FF:000008', NULL, NULL, 'Alpha-aminoadipic semialdehyde synthase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(104509, NULL, 'G3DSA:1.20.1250.20:FF:000422', NULL, NULL, 'Monocarboxylate transporter 9', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(104510, NULL, 'G3DSA:1.10.510.10:FF:000724', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(104511, NULL, 'G3DSA:3.30.160.60:FF:003667', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104512, NULL, 'G3DSA:3.90.226.10:FF:000032', NULL, NULL, 'Methylmalonyl-CoA decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(104513, NULL, 'G3DSA:3.30.40.10:FF:000777', NULL, NULL, 'Fife, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(104514, NULL, 'G3DSA:3.40.630.10:FF:000117', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(104515, NULL, 'G3DSA:3.10.20.90:FF:000952', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(104516, NULL, 'G3DSA:3.40.30.10:FF:001158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104517, NULL, 'G3DSA:2.70.40.10:FF:000030', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(104518, NULL, 'G3DSA:3.30.200.20:FF:001815', NULL, NULL, 'Myosin heavy chain kinase A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104519, NULL, 'G3DSA:3.40.190.10:FF:000307', NULL, NULL, 'Putative periplasmic aliphatic sulfonate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(104520, NULL, 'G3DSA:2.40.50.60:FF:000002', NULL, NULL, 'Cicadin', NULL, NULL, NULL, NULL, NULL, 4),
(104521, NULL, 'G3DSA:3.30.70.330:FF:003065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104522, NULL, 'G3DSA:1.10.238.10:FF:000063', NULL, NULL, 'Voltage-dependent N-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(104523, NULL, 'G3DSA:1.10.560.10:FF:000019', NULL, NULL, 'McKusick-Kaufman/Bardet-Biedl syndromes putative chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(104524, NULL, 'G3DSA:2.60.260.20:FF:000102', NULL, NULL, 'AGAP000008-PA', NULL, NULL, NULL, NULL, NULL, 4),
(104525, NULL, 'G3DSA:2.10.70.10:FF:000046', NULL, NULL, 'Membrane cofactor protein', NULL, NULL, NULL, NULL, NULL, 4),
(104526, NULL, 'G3DSA:2.10.25.10:FF:001341', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104527, NULL, 'G3DSA:1.20.1250.20:FF:000799', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(104528, NULL, 'G3DSA:3.40.50.300:FF:004691', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(104529, NULL, 'G3DSA:2.60.40.1510:FF:000029', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(104530, NULL, 'G3DSA:3.30.70.330:FF:002789', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104531, NULL, 'G3DSA:3.30.70.1400:FF:000014', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(104532, NULL, 'G3DSA:3.10.20.90:FF:001025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104533, NULL, 'G3DSA:2.40.70.10:FF:000123', NULL, NULL, 'Polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(104534, NULL, 'G3DSA:1.10.10.440:FF:000091', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(104535, NULL, 'G3DSA:2.60.40.10:FF:003892', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104536, NULL, 'G3DSA:2.60.40.60:FF:000714', NULL, NULL, 'Cdh-4', NULL, NULL, NULL, NULL, NULL, 4),
(104537, NULL, 'G3DSA:2.60.34.10:FF:000016', NULL, NULL, 'Heat shock protein 70', NULL, NULL, NULL, NULL, NULL, 4),
(104538, NULL, 'G3DSA:3.10.290.10:FF:000081', NULL, NULL, '30S ribosomal protein S4, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(104539, NULL, 'G3DSA:1.20.1600.10:FF:000048', NULL, NULL, 'Outer membrane protein TolC', NULL, NULL, NULL, NULL, NULL, 4),
(104540, NULL, 'G3DSA:1.10.238.10:FF:000681', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104541, NULL, 'G3DSA:3.30.160.60:FF:000233', NULL, NULL, 'Putative zinc finger protein 362', NULL, NULL, NULL, NULL, NULL, 4),
(104542, NULL, 'G3DSA:2.30.30.40:FF:000568', NULL, NULL, 'Peroxisomal membrane protein PEX13-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(104543, NULL, 'G3DSA:1.25.10.10:FF:000820', NULL, NULL, 'Pumilio/PUF RNA binding protein 5, putative', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(104544, NULL, 'G3DSA:1.20.1250.20:FF:001440', NULL, NULL, 'MFS quinate transporter, putative (AFU_orthologue AFUA_4G14670)', NULL, NULL, NULL, NULL, NULL, 4),
(104545, NULL, 'G3DSA:1.25.40.1030:FF:000053', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(104546, NULL, 'G3DSA:1.20.1070.10:FF:001580', NULL, NULL, 'Tachykinin receptor 3a', NULL, NULL, NULL, NULL, NULL, 4),
(104547, NULL, 'G3DSA:2.60.40.10:FF:002346', NULL, NULL, 'Stretchin-Mlck, isoform S', NULL, NULL, NULL, NULL, NULL, 4),
(104548, NULL, 'G3DSA:1.10.1410.10:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104549, NULL, 'G3DSA:2.60.40.150:FF:000399', NULL, NULL, 'Phosphatidylserine decarboxylase proenzyme 2', NULL, NULL, NULL, NULL, NULL, 4),
(104550, NULL, 'G3DSA:3.90.70.10:FF:000681', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104551, NULL, 'G3DSA:1.10.287.110:FF:000116', NULL, NULL, 'Erj5p', NULL, NULL, NULL, NULL, NULL, 4),
(104552, NULL, 'G3DSA:3.80.10.10:FF:000082', NULL, NULL, 'Leucine-rich repeat-containing 24', NULL, NULL, NULL, NULL, NULL, 4),
(104553, NULL, 'G3DSA:2.160.10.10:FF:000018', NULL, NULL, 'Mannose-1-phosphate guanyltransferase beta', NULL, NULL, NULL, NULL, NULL, 4),
(104554, NULL, 'G3DSA:3.10.20.90:FF:000862', NULL, NULL, 'Protein lgg', NULL, NULL, NULL, NULL, NULL, 4),
(104555, NULL, 'G3DSA:3.40.30.10:FF:000287', NULL, NULL, 'Protein disulfide-isomerase domain', NULL, NULL, NULL, NULL, NULL, 4),
(104556, NULL, 'G3DSA:3.30.70.980:FF:000067', NULL, NULL, 'Probable transcriptional regulatory protein MG332', NULL, NULL, NULL, NULL, NULL, 4),
(104557, NULL, 'G3DSA:3.80.10.10:FF:001532', NULL, NULL, 'F-box/LRR-repeat protein 4 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(104558, NULL, 'G3DSA:1.10.150.80:FF:000008', NULL, NULL, 'Polynucleotidyl transferase ribonuclease H fold protein with HRDC domain', NULL, NULL, NULL, NULL, NULL, 4),
(104559, NULL, 'G3DSA:1.10.533.10:FF:000294', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104560, NULL, 'G3DSA:2.60.120.620:FF:000072', NULL, NULL, 'GD21535', NULL, NULL, NULL, NULL, NULL, 4),
(104561, NULL, 'G3DSA:3.30.70.330:FF:002137', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104562, NULL, 'G3DSA:3.40.1090.10:FF:000153', NULL, NULL, 'Phospholipase A2', NULL, NULL, NULL, NULL, NULL, 4),
(104563, NULL, 'G3DSA:2.60.40.640:FF:000035', NULL, NULL, 'Carboxypeptidase Y-deficient', NULL, NULL, NULL, NULL, NULL, 4),
(104564, NULL, 'G3DSA:3.40.30.10:FF:001214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104565, NULL, 'G3DSA:2.130.10.10:FF:004325', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104566, NULL, 'G3DSA:2.60.260.20:FF:000012', NULL, NULL, 'dnaJ protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(104567, NULL, 'G3DSA:3.40.50.300:FF:000762', NULL, NULL, 'ATP-dependent helicase BRM', NULL, NULL, NULL, NULL, NULL, 4),
(104568, NULL, 'G3DSA:2.30.30.30:FF:000037', NULL, NULL, 'Transcription termination/antitermination factor NusG', NULL, NULL, NULL, NULL, NULL, 4),
(104569, NULL, 'G3DSA:1.10.10.10:FF:001888', NULL, NULL, 'TraR protein', NULL, NULL, NULL, NULL, NULL, 4),
(104570, NULL, 'G3DSA:2.60.40.60:FF:000192', NULL, NULL, 'neural-cadherin isoform X8', NULL, NULL, NULL, NULL, NULL, 4),
(104571, NULL, 'G3DSA:3.30.40.10:FF:001272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104572, NULL, 'G3DSA:3.30.160.60:FF:000761', NULL, NULL, 'Zinc finger protein 449', NULL, NULL, NULL, NULL, NULL, 4),
(104573, NULL, 'G3DSA:2.60.40.10:FF:003982', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104574, NULL, 'G3DSA:3.30.420.10:FF:000396', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104575, NULL, 'G3DSA:2.10.50.10:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104576, NULL, 'G3DSA:2.40.50.100:FF:000037', NULL, NULL, 'Molybdenum import ATP-binding protein ModC', NULL, NULL, NULL, NULL, NULL, 4),
(104577, NULL, 'G3DSA:3.40.190.290:FF:000114', NULL, NULL, 'Putative transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(104578, NULL, 'G3DSA:3.30.565.10:FF:000310', NULL, NULL, 'Endoplasmin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(104579, NULL, 'G3DSA:3.30.710.10:FF:000497', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104580, NULL, 'G3DSA:1.10.510.10:FF:000634', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(104581, NULL, 'G3DSA:3.30.160.60:FF:004504', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104582, NULL, 'G3DSA:3.90.1150.50:FF:000001', NULL, NULL, 'Transcription-repair-coupling factor', NULL, NULL, NULL, NULL, NULL, 4),
(104583, NULL, 'G3DSA:1.20.120.350:FF:000091', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(104584, NULL, 'G3DSA:1.20.120.330:FF:000023', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(104585, NULL, 'G3DSA:1.25.40.10:FF:004245', NULL, NULL, 'Putative cargo-transport protein ypp1', NULL, NULL, NULL, NULL, NULL, 4),
(104586, NULL, 'G3DSA:3.40.50.300:FF:004505', NULL, NULL, 'DNA repair helicase TFIIH P90', NULL, NULL, NULL, NULL, NULL, 4),
(104587, NULL, 'G3DSA:3.30.160.60:FF:001104', NULL, NULL, 'gastrula zinc finger protein XlCGF57.1-like', NULL, NULL, NULL, NULL, NULL, 4),
(104588, NULL, 'G3DSA:3.30.60.20:FF:000056', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(104589, NULL, 'G3DSA:3.10.20.90:FF:000805', NULL, NULL, 'Serine/threonine-protein kinase OSR1', NULL, NULL, NULL, NULL, NULL, 4),
(104590, NULL, 'G3DSA:1.10.533.10:FF:000237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104591, NULL, 'G3DSA:3.90.70.10:FF:000534', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(104592, NULL, 'G3DSA:3.40.30.10:FF:000995', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104593, NULL, 'G3DSA:1.10.472.170:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104594, NULL, 'G3DSA:3.40.50.300:FF:003055', NULL, NULL, 'GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(104595, NULL, 'G3DSA:4.10.75.10:FF:000013', NULL, NULL, 'Perlwapin', NULL, NULL, NULL, NULL, NULL, 4),
(104596, NULL, 'G3DSA:3.30.70.240:FF:000025', NULL, NULL, 'Transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(104597, NULL, 'G3DSA:1.10.1660.60:FF:000001', NULL, NULL, 'Phage excisionase', NULL, NULL, NULL, NULL, NULL, 4),
(104598, NULL, 'G3DSA:3.40.50.1000:FF:000594', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104599, NULL, 'G3DSA:1.10.533.10:FF:000147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104600, NULL, 'G3DSA:3.30.497.10:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104601, NULL, 'G3DSA:3.40.50.300:FF:000705', NULL, NULL, 'Endoribonuclease dicer-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(104602, NULL, 'G3DSA:3.40.50.300:FF:008434', NULL, NULL, 'CHL1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(104603, NULL, 'G3DSA:1.10.238.10:FF:000624', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104604, NULL, 'G3DSA:1.10.20.10:FF:000135', NULL, NULL, 'Transcription initiation factor TFIID subunit 11', NULL, NULL, NULL, NULL, NULL, 4),
(104605, NULL, 'G3DSA:3.30.420.390:FF:000003', NULL, NULL, 'DNA polymerase gamma, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(104606, NULL, 'G3DSA:3.40.50.1100:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104607, NULL, 'G3DSA:1.50.40.10:FF:000578', NULL, NULL, 'Solute carrier family 25 member 38', NULL, NULL, NULL, NULL, NULL, 4),
(104608, NULL, 'G3DSA:3.40.50.2000:FF:000321', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(104609, NULL, 'G3DSA:2.130.10.10:FF:004415', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104610, NULL, 'G3DSA:3.30.60.30:FF:000059', NULL, NULL, 'SPARC (osteonectin), cwcv and kazal like domains proteoglycan 2', NULL, NULL, NULL, NULL, NULL, 4),
(104611, NULL, 'G3DSA:1.20.1250.20:FF:001108', NULL, NULL, 'SCR1 protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(104612, NULL, 'G3DSA:1.10.238.10:FF:000534', NULL, NULL, 'Putative calcium-binding protein CML41', NULL, NULL, NULL, NULL, NULL, 4),
(104613, NULL, 'G3DSA:1.10.10.10:FF:001798', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(104614, NULL, 'G3DSA:1.25.40.20:FF:000448', NULL, NULL, 'ankyrin repeat domain-containing protein 50', NULL, NULL, NULL, NULL, NULL, 4),
(104615, NULL, 'G3DSA:1.10.20.10:FF:000225', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104616, NULL, 'G3DSA:3.60.21.10:FF:000147', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(104617, NULL, 'G3DSA:1.20.1070.10:FF:001338', NULL, NULL, 'AGAP011452-PA', NULL, NULL, NULL, NULL, NULL, 4),
(104618, NULL, 'G3DSA:3.30.40.10:FF:001648', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104619, NULL, 'G3DSA:2.60.120.10:FF:000499', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104620, NULL, 'G3DSA:3.40.50.1820:FF:001380', NULL, NULL, 'Acyl-protein thioesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(104621, NULL, 'G3DSA:3.30.540.10:FF:000051', NULL, NULL, 'Fructose-1,6-bisphosphatase class 1', NULL, NULL, NULL, NULL, NULL, 4),
(104622, NULL, 'G3DSA:1.20.1300.10:FF:000031', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(104623, NULL, 'G3DSA:3.40.50.300:FF:005000', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104624, NULL, 'G3DSA:2.60.40.790:FF:000029', NULL, NULL, 'Putative heat shock protein beta-6', NULL, NULL, NULL, NULL, NULL, 4),
(104625, NULL, 'G3DSA:2.60.40.10:FF:002964', NULL, NULL, 'C-Met receptor tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(104626, NULL, 'G3DSA:3.40.50.300:FF:006489', NULL, NULL, 'Os02g0749300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(104627, NULL, 'G3DSA:2.40.70.10:FF:000157', NULL, NULL, 'Plasmepsin VI', NULL, NULL, NULL, NULL, NULL, 4),
(104628, NULL, 'G3DSA:3.10.620.10:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104629, NULL, 'G3DSA:1.10.287.110:FF:000026', NULL, NULL, 'dnaJ homolog subfamily C member 8', NULL, NULL, NULL, NULL, NULL, 4),
(104630, NULL, 'G3DSA:1.20.140.10:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104631, NULL, 'G3DSA:1.20.1070.10:FF:001395', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(104632, NULL, 'G3DSA:3.90.550.50:FF:000229', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(104633, NULL, 'G3DSA:3.30.70.120:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104634, NULL, 'G3DSA:2.60.40.10:FF:002256', NULL, NULL, 'Interferon alpha/beta receptor 1a', NULL, NULL, NULL, NULL, NULL, 4),
(104635, NULL, 'G3DSA:2.60.40.770:FF:000023', NULL, NULL, 'Phosphorylase B kinase alpha, kpb1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104636, NULL, 'G3DSA:1.25.40.10:FF:001952', NULL, NULL, 'Pentatricopeptide repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(104637, NULL, 'G3DSA:1.25.40.20:FF:001432', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104638, NULL, 'G3DSA:3.40.109.10:FF:000052', NULL, NULL, 'Polyketide synthase/nonribosomal peptide synthetase hybrid RzxB', NULL, NULL, NULL, NULL, NULL, 4),
(104639, NULL, 'G3DSA:3.80.10.10:FF:000110', NULL, NULL, 'Leucine-rich repeat serine/threonine-protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(104640, NULL, 'G3DSA:3.30.160.100:FF:000014', NULL, NULL, 'Ribosome hibernation promoting factor', NULL, NULL, NULL, NULL, NULL, 4),
(104641, NULL, 'G3DSA:2.30.30.40:FF:000248', NULL, NULL, 'Ephexin, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(104642, NULL, 'G3DSA:2.130.10.10:FF:000609', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(104643, NULL, 'G3DSA:3.40.50.720:FF:001562', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(104644, NULL, 'G3DSA:1.20.80.10:FF:000003', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type 4', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(104645, NULL, 'G3DSA:3.40.50.150:FF:001071', NULL, NULL, 'AGAP007929-PA', NULL, NULL, NULL, NULL, NULL, 4),
(104646, NULL, 'G3DSA:3.90.1180.10:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104647, NULL, 'G3DSA:3.40.50.720:FF:002130', NULL, NULL, 'L-threonine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(104648, NULL, 'G3DSA:3.30.590.10:FF:000031', NULL, NULL, 'Gamma-glutamylanilide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(104649, NULL, 'G3DSA:3.30.160.60:FF:000553', NULL, NULL, 'Zinc finger and BTB domain-containing protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(104650, NULL, 'G3DSA:2.60.120.650:FF:000002', NULL, NULL, 'lysine-specific demethylase 6A isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(104651, NULL, 'G3DSA:3.10.450.50:FF:000015', NULL, NULL, 'Ras GTPase-activating protein-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(104652, NULL, 'G3DSA:1.20.1310.10:FF:000155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104653, NULL, 'G3DSA:3.40.50.300:FF:007299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104654, NULL, 'G3DSA:1.10.510.10:FF:000494', NULL, NULL, 'mitotic checkpoint serine/threonine-protein kinase BUB1 beta', NULL, NULL, NULL, NULL, NULL, 4),
(104655, NULL, 'G3DSA:2.130.10.10:FF:004297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104656, NULL, 'G3DSA:3.90.550.10:FF:000206', NULL, NULL, 'Glycosyl transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(104657, NULL, 'G3DSA:1.10.10.10:FF:000163', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(104658, NULL, 'G3DSA:3.30.1370.100:FF:000009', NULL, NULL, 'DNA mismatch repair protein PMS1', NULL, NULL, NULL, NULL, NULL, 4),
(104659, NULL, 'G3DSA:2.60.40.150:FF:000017', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(104660, NULL, 'G3DSA:3.60.21.10:FF:000355', NULL, NULL, 'Serine/threonine protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104661, NULL, 'G3DSA:3.40.190.10:FF:000302', NULL, NULL, 'Phosphate ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(104662, NULL, 'G3DSA:3.40.630.10:FF:000319', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(104663, NULL, 'G3DSA:3.10.20.90:FF:000188', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(104664, NULL, 'G3DSA:3.40.50.300:FF:006843', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NUBP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(104665, NULL, 'G3DSA:1.25.10.10:FF:002029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104666, NULL, 'G3DSA:3.90.226.10:FF:000094', NULL, NULL, 'Enoyl-CoA hydratase EchA2', NULL, NULL, NULL, NULL, NULL, 4),
(104667, NULL, 'G3DSA:1.10.150.780:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104668, NULL, 'G3DSA:4.10.1240.30:FF:000003', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(104669, NULL, 'G3DSA:3.30.160.60:FF:002644', NULL, NULL, 'Zinc finger protein 337', NULL, NULL, NULL, NULL, NULL, 4),
(104670, NULL, 'G3DSA:1.25.40.10:FF:004206', NULL, NULL, 'High chlorophyll fluorescence3', NULL, NULL, NULL, NULL, NULL, 4),
(104671, NULL, 'G3DSA:1.20.5.110:FF:000278', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(104672, NULL, 'G3DSA:2.40.70.10:FF:000062', NULL, NULL, 'ASpartyl Protease', NULL, NULL, NULL, NULL, NULL, 4),
(104673, NULL, 'G3DSA:3.40.50.1820:FF:001464', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(104674, NULL, 'G3DSA:1.10.520.10:FF:000045', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(104675, NULL, 'G3DSA:1.20.58.390:FF:000266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104676, NULL, 'G3DSA:2.60.40.1400:FF:000002', NULL, NULL, 'ATP-sensitive inward rectifier potassium channel 1', NULL, NULL, NULL, NULL, NULL, 4),
(104677, NULL, 'G3DSA:3.30.540.10:FF:000045', NULL, NULL, 'Inositol monophosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(104678, NULL, 'G3DSA:1.10.10.60:FF:000071', NULL, NULL, 'Retinal homeobox gene 2', NULL, NULL, NULL, NULL, NULL, 4),
(104679, NULL, 'G3DSA:3.40.50.300:FF:004752', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(104680, NULL, 'G3DSA:2.60.120.200:FF:000002', NULL, NULL, 'Thrombospondin 3', NULL, NULL, NULL, NULL, NULL, 4),
(104681, NULL, 'G3DSA:2.130.10.10:FF:002173', NULL, NULL, 'WD repeat domain 90', NULL, NULL, NULL, NULL, NULL, 4),
(104682, NULL, 'G3DSA:2.10.25.10:FF:000739', NULL, NULL, 'Blast:Protein eyes shut', NULL, NULL, NULL, NULL, NULL, 4),
(104683, NULL, 'G3DSA:1.10.510.10:FF:001011', NULL, NULL, 'CMGC/CDK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(104684, NULL, 'G3DSA:1.10.238.10:FF:000473', NULL, NULL, 'CDPK-related kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(104685, NULL, 'G3DSA:3.30.40.10:FF:001884', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104686, NULL, 'G3DSA:2.130.10.10:FF:000082', NULL, NULL, 'WD40 repeat-containing protein SMU1', NULL, NULL, NULL, NULL, NULL, 4),
(104687, NULL, 'G3DSA:3.60.40.10:FF:000101', NULL, NULL, 'Stage II sporulation protein E', NULL, NULL, NULL, NULL, NULL, 4),
(104688, NULL, 'G3DSA:3.30.160.60:FF:001216', NULL, NULL, 'Splicing factor 3A subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(104689, NULL, 'G3DSA:3.30.230.70:FF:000146', NULL, NULL, 'Exosome component 5', NULL, NULL, NULL, NULL, NULL, 4),
(104690, NULL, 'G3DSA:3.30.420.40:FF:000433', NULL, NULL, 'Heat shock protein family A (Hsp70) member 14', NULL, NULL, NULL, NULL, NULL, 4),
(104691, NULL, 'G3DSA:3.10.450.40:FF:000012', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(104692, NULL, 'G3DSA:1.20.5.1160:FF:000006', NULL, NULL, 'Myosin-XVIIIa isoform a', NULL, NULL, NULL, NULL, NULL, 4),
(104693, NULL, 'G3DSA:1.10.287.110:FF:000291', NULL, NULL, 'Putative dnaJ chaperone family protein', NULL, NULL, NULL, NULL, NULL, 4),
(104694, NULL, 'G3DSA:3.20.170.30:FF:000002', NULL, NULL, 'Phosphotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104695, NULL, 'G3DSA:2.30.29.30:FF:000500', NULL, NULL, 'mRNA-decapping enzyme 1B', NULL, NULL, NULL, NULL, NULL, 4),
(104696, NULL, 'G3DSA:3.40.50.1820:FF:001790', NULL, NULL, 'Lipase, endothelial', NULL, NULL, NULL, NULL, NULL, 4),
(104697, NULL, 'G3DSA:3.30.420.110:FF:000055', NULL, NULL, 'Muts domain V-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(104698, NULL, 'G3DSA:1.10.510.10:FF:002197', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(104699, NULL, 'G3DSA:3.30.160.60:FF:002318', NULL, NULL, 'zinc finger protein 837 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(104700, NULL, 'G3DSA:1.20.272.10:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104701, NULL, 'G3DSA:1.20.140.150:FF:000017', NULL, NULL, 'Claudin-12 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(104702, NULL, 'G3DSA:2.130.10.10:FF:002122', NULL, NULL, 'Transducin beta-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(104703, NULL, 'G3DSA:3.80.10.10:FF:001571', NULL, NULL, 'Internalin', NULL, NULL, NULL, NULL, NULL, 4),
(104704, NULL, 'G3DSA:3.30.70.330:FF:000338', NULL, NULL, 'polyadenylate-binding protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(104705, NULL, 'G3DSA:2.130.10.10:FF:004246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104706, NULL, 'G3DSA:3.40.50.300:FF:003988', NULL, NULL, 'Helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104707, NULL, 'G3DSA:3.30.300.150:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104708, NULL, 'G3DSA:3.40.50.1820:FF:001559', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104709, NULL, 'G3DSA:1.10.3720.10:FF:000155', NULL, NULL, 'ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(104710, NULL, 'G3DSA:1.10.10.10:FF:000258', NULL, NULL, 'DeoR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(104711, NULL, 'G3DSA:1.10.238.10:FF:000422', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(104712, NULL, 'G3DSA:3.40.47.10:FF:000241', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104713, NULL, 'G3DSA:3.30.40.10:FF:001558', NULL, NULL, 'Protein CBG14325', NULL, NULL, NULL, NULL, NULL, 4),
(104714, NULL, 'G3DSA:3.30.30.10:FF:000012', NULL, NULL, 'Defensin ARD1', NULL, NULL, NULL, NULL, NULL, 4),
(104715, NULL, 'G3DSA:3.20.20.220:FF:000045', NULL, NULL, 'Methylenetetrahydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(104716, NULL, 'G3DSA:3.40.50.1820:FF:000896', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(104717, NULL, 'G3DSA:1.20.120.1900:FF:000017', NULL, NULL, 'Spindle pole body protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104718, NULL, 'G3DSA:3.30.200.20:FF:000039', NULL, NULL, 'receptor-like protein kinase FERONIA', NULL, NULL, NULL, NULL, NULL, 4),
(104719, NULL, 'G3DSA:3.40.50.1980:FF:000005', NULL, NULL, 'Vitamin B12-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(104720, NULL, 'G3DSA:3.30.160.60:FF:000941', NULL, NULL, 'zinc finger protein ZFP69 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(104721, NULL, 'G3DSA:3.40.50.300:FF:001897', NULL, NULL, 'Myosin C', NULL, NULL, NULL, NULL, NULL, 4),
(104722, NULL, 'G3DSA:2.60.40.10:FF:004235', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104723, NULL, 'G3DSA:1.20.930.80:FF:000021', NULL, NULL, 'DNA primase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(104724, NULL, 'G3DSA:3.40.640.10:FF:000152', NULL, NULL, 'Serine-pyruvate aminotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104725, NULL, 'G3DSA:3.90.780.10:FF:000015', NULL, NULL, 'Trifunctional nucleotide phosphoesterase protein YfkN', NULL, NULL, NULL, NULL, NULL, 4),
(104726, NULL, 'G3DSA:3.30.70.330:FF:001980', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104727, NULL, 'G3DSA:3.30.30.30:FF:000018', NULL, NULL, 'Unplaced genomic scaffold supercont2.9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(104728, NULL, 'G3DSA:3.30.160.60:FF:004089', NULL, NULL, 'Si:dkey-89b17.4', NULL, NULL, NULL, NULL, NULL, 4),
(104729, NULL, 'G3DSA:1.10.1420.10:FF:000143', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(104730, NULL, 'G3DSA:3.10.450.320:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104731, NULL, 'G3DSA:3.40.50.740:FF:000045', NULL, NULL, 'Acetylene hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(104732, NULL, 'G3DSA:2.60.40.10:FF:002144', NULL, NULL, 'MHC class I antigen ZEA transcript variant 1', NULL, NULL, NULL, NULL, NULL, 4),
(104733, NULL, 'G3DSA:2.30.30.380:FF:000057', NULL, NULL, 'Thioredoxin family protein, selenocysteine-containing', NULL, NULL, NULL, NULL, NULL, 4),
(104734, NULL, 'G3DSA:3.40.50.2300:FF:000433', NULL, NULL, 'Pilus assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(104735, NULL, 'G3DSA:3.40.50.1970:FF:000002', NULL, NULL, 'Aldehyde-alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(104736, NULL, 'G3DSA:3.40.50.720:FF:001236', NULL, NULL, 'Polysaccharide biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(104737, NULL, 'G3DSA:3.80.10.10:FF:001296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104738, NULL, 'G3DSA:2.70.170.10:FF:000303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104739, NULL, 'G3DSA:3.40.50.300:FF:008193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104740, NULL, 'G3DSA:2.60.40.60:FF:000832', NULL, NULL, 'CaDHerin family', NULL, NULL, NULL, NULL, NULL, 4),
(104741, NULL, 'G3DSA:3.40.630.30:FF:000477', NULL, NULL, 'Acyl-CoA N-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(104742, NULL, 'G3DSA:1.25.40.20:FF:000095', NULL, NULL, 'Ankyrin 2, isoform J', NULL, NULL, NULL, NULL, NULL, 4),
(104743, NULL, 'G3DSA:1.25.10.10:FF:001692', NULL, NULL, 'ARM repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(104744, NULL, 'G3DSA:1.20.120.1760:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104745, NULL, 'G3DSA:3.40.190.10:FF:000009', NULL, NULL, 'Putative glutamate receptor ionotropic NMDA 2B', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(104746, NULL, 'G3DSA:1.20.144.10:FF:000073', NULL, NULL, 'Phospholipid phosphatase 3', NULL, NULL, NULL, NULL, NULL, 4),
(104747, NULL, 'G3DSA:3.90.640.10:FF:000005', NULL, NULL, 'Actin-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(104748, NULL, 'G3DSA:3.40.50.300:FF:006517', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104749, NULL, 'G3DSA:3.90.1750.10:FF:000007', NULL, NULL, 'E3 ubiquitin-protein ligase SMURF2', NULL, NULL, NULL, NULL, NULL, 4),
(104750, NULL, 'G3DSA:1.20.140.100:FF:000014', NULL, NULL, 'Putative dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(104751, NULL, 'G3DSA:3.90.550.10:FF:000420', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104752, NULL, 'G3DSA:3.10.20.90:FF:000446', NULL, NULL, 'Ubiquitin fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(104753, NULL, 'G3DSA:2.10.25.10:FF:001633', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104754, NULL, 'G3DSA:3.30.160.60:FF:000227', NULL, NULL, 'fez family zinc finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(104755, NULL, 'G3DSA:3.90.550.10:FF:000532', NULL, NULL, 'Dolichyl-phosphate beta-D-mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(104756, NULL, 'G3DSA:3.30.70.330:FF:001592', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104757, NULL, 'G3DSA:1.20.1510.10:FF:000041', NULL, NULL, 'Putative cation transporter', NULL, NULL, NULL, NULL, NULL, 4),
(104758, NULL, 'G3DSA:1.20.120.1750:FF:000051', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(104759, NULL, 'G3DSA:2.30.30.40:FF:000574', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104760, NULL, 'G3DSA:2.130.10.10:FF:000935', NULL, NULL, 'Small nucleolar ribonucleoprotein complex subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104761, NULL, 'G3DSA:3.30.565.10:FF:000304', NULL, NULL, 'Two-component sensor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(104762, NULL, 'G3DSA:2.80.10.50:FF:000219', NULL, NULL, 'AAL050Wp', NULL, NULL, NULL, NULL, NULL, 4),
(104763, NULL, 'G3DSA:2.70.220.10:FF:000010', NULL, NULL, 'Putative phosphatidylglycerol/phosphatidylinositol transfer protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(104764, NULL, 'G3DSA:3.40.1280.10:FF:000044', NULL, NULL, 'Variant surface glycoprotein (VSG), putative', NULL, NULL, NULL, NULL, NULL, 4),
(104765, NULL, 'G3DSA:3.40.50.1240:FF:000076', NULL, NULL, 'Phosphoglycerate/bisphosphoglycerate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(104766, NULL, 'G3DSA:2.60.40.10:FF:000278', NULL, NULL, 'Protein-glutamine gamma-glutamyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(104767, NULL, 'G3DSA:1.20.1070.10:FF:001754', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104768, NULL, 'G3DSA:3.30.70.1230:FF:000199', NULL, NULL, 'Adenylate cyclase 3', NULL, NULL, NULL, NULL, NULL, 4),
(104769, NULL, 'G3DSA:2.60.120.10:FF:000179', NULL, NULL, 'Cupin domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(104770, NULL, 'G3DSA:3.40.50.150:FF:000177', NULL, NULL, 'THUMP domain containing 2, isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(104771, NULL, 'G3DSA:3.30.160.60:FF:004982', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104772, NULL, 'G3DSA:3.30.70.2280:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104773, NULL, 'G3DSA:1.10.780.10:FF:000002', NULL, NULL, 'Hydrazine oxidoreductase HzoB', NULL, NULL, NULL, NULL, NULL, 4),
(104774, NULL, 'G3DSA:3.30.420.510:FF:000017', NULL, NULL, 'Patothenate kinase, fumble family protein', NULL, NULL, NULL, NULL, NULL, 4),
(104775, NULL, 'G3DSA:4.10.400.10:FF:000159', NULL, NULL, 'Low-density lipoprotein receptor-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(104776, NULL, 'G3DSA:3.40.50.150:FF:000823', NULL, NULL, 'Catechol O-methyltransferase domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(104777, NULL, 'G3DSA:3.30.60.30:FF:000172', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(104778, NULL, 'G3DSA:4.10.800.20:FF:000013', NULL, NULL, 'Adenosine monophosphate deaminase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104779, NULL, 'G3DSA:3.40.50.10810:FF:000214', NULL, NULL, 'SWI/SNF chromatin remodeling complex component', NULL, NULL, NULL, NULL, NULL, 4),
(104780, NULL, 'G3DSA:3.40.50.620:FF:000689', NULL, NULL, 'Asparagine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(104781, NULL, 'G3DSA:3.40.640.10:FF:000505', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104782, NULL, 'G3DSA:3.40.50.300:FF:002835', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(104783, NULL, 'G3DSA:1.20.1560.10:FF:000201', NULL, NULL, 'ABC transporter related', NULL, NULL, NULL, NULL, NULL, 4),
(104784, NULL, 'G3DSA:1.25.10.10:FF:002181', NULL, NULL, 'Tubulin-folding cofactor D', NULL, NULL, NULL, NULL, NULL, 4),
(104785, NULL, 'G3DSA:1.10.10.440:FF:000085', NULL, NULL, 'YALI0D02827p', NULL, NULL, NULL, NULL, NULL, 4),
(104786, NULL, 'G3DSA:2.90.10.10:FF:000033', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(104787, NULL, 'G3DSA:3.30.9.10:FF:000244', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(104788, NULL, 'G3DSA:2.20.70.10:FF:000225', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(104789, NULL, 'G3DSA:3.75.10.10:FF:000004', NULL, NULL, 'N(G),N(G)-dimethylarginine dimethylaminohydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(104790, NULL, 'G3DSA:2.170.130.10:FF:000024', NULL, NULL, 'Outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(104791, NULL, 'G3DSA:1.10.2020.20:FF:000003', NULL, NULL, 'Proteasomal ubiquitin receptor ADRM1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(104792, NULL, 'G3DSA:3.30.710.10:FF:000120', NULL, NULL, 'Bric a brac 2, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(104793, NULL, 'G3DSA:1.20.58.70:FF:000003', NULL, NULL, 'Qa-SNARE, Sso1/Syntaxin1-type, SYP12A-group', NULL, NULL, NULL, NULL, NULL, 4),
(104794, NULL, 'G3DSA:3.40.50.920:FF:000043', NULL, NULL, 'Thiamine diphosphate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(104795, NULL, 'G3DSA:3.40.1350.10:FF:000005', NULL, NULL, 'tRNA-splicing endonuclease subunit Sen2-1', NULL, NULL, NULL, NULL, NULL, 4),
(104796, NULL, 'G3DSA:4.10.800.10:FF:000010', NULL, NULL, 'Insulin-like growth factor binding protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(104797, NULL, 'G3DSA:3.10.110.10:FF:000006', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 Q2', NULL, NULL, NULL, NULL, NULL, 4),
(104798, NULL, 'G3DSA:3.30.200.20:FF:002035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104799, NULL, 'G3DSA:2.40.50.100:FF:000076', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(104800, NULL, 'G3DSA:3.40.50.2300:FF:000080', NULL, NULL, 'Two-component system response regulator BaeR', NULL, NULL, NULL, NULL, NULL, 4),
(104801, NULL, 'G3DSA:3.40.50.1240:FF:000025', NULL, NULL, '6-phosphofructo-2-kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(104802, NULL, 'G3DSA:3.40.50.1580:FF:000043', NULL, NULL, 'Purine nucleoside phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(104803, NULL, 'G3DSA:3.40.50.300:FF:007978', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104804, NULL, 'G3DSA:1.10.240.10:FF:000012', NULL, NULL, 'Tyrosyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(104805, NULL, 'G3DSA:2.160.20.10:FF:000171', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(104806, NULL, 'G3DSA:3.40.50.300:FF:008142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104807, NULL, 'G3DSA:3.40.50.12550:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104808, NULL, 'G3DSA:3.40.50.1010:FF:000187', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104809, NULL, 'G3DSA:2.60.40.10:FF:003133', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(104810, NULL, 'G3DSA:3.90.550.10:FF:000471', NULL, NULL, 'Glycosyl transferase family 2', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(104811, NULL, 'G3DSA:1.20.58.60:FF:000500', NULL, NULL, 'Nesprin-1', NULL, NULL, NULL, NULL, NULL, 4),
(104812, NULL, 'G3DSA:3.40.50.150:FF:000082', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase D', NULL, NULL, NULL, NULL, NULL, 4),
(104813, NULL, 'G3DSA:1.10.10.10:FF:000584', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(104814, NULL, 'G3DSA:3.30.160.60:FF:003993', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104815, NULL, 'G3DSA:3.20.20.80:FF:000836', NULL, NULL, '1,4-alpha-glucan-branching enzyme 2, chloroplastic/amyloplastic', NULL, NULL, NULL, NULL, NULL, 4),
(104816, NULL, 'G3DSA:1.20.1050.10:FF:000117', NULL, NULL, 'Putative methionyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(104817, NULL, 'G3DSA:3.40.50.720:FF:002225', NULL, NULL, 'uncharacterized protein LOC100184381', NULL, NULL, NULL, NULL, NULL, 4),
(104818, NULL, 'G3DSA:3.80.10.10:FF:003920', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(104819, NULL, 'G3DSA:1.10.390.10:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104820, NULL, 'G3DSA:3.30.70.100:FF:000028', NULL, NULL, 'N-terminal EF-hand calcium-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(104821, NULL, 'G3DSA:1.20.144.10:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104822, NULL, 'G3DSA:2.30.29.30:FF:001282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104823, NULL, 'G3DSA:3.60.15.10:FF:000200', NULL, NULL, 'Ribonuclease Z 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(104824, NULL, 'G3DSA:2.140.10.30:FF:000008', NULL, NULL, 'inactive dipeptidyl peptidase 10 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(104825, NULL, 'G3DSA:3.90.180.10:FF:000200', NULL, NULL, 'Asperfuranone polyketide synthase afoG', NULL, NULL, NULL, NULL, NULL, 4),
(104826, NULL, 'G3DSA:2.60.40.2090:FF:000001', NULL, NULL, 'Minor fimbrium anchoring subunit Mfa2', NULL, NULL, NULL, NULL, NULL, 4),
(104827, NULL, 'G3DSA:2.60.40.3440:FF:000001', NULL, NULL, 'Gamete expressed 2', NULL, NULL, NULL, NULL, NULL, 4),
(104828, NULL, 'G3DSA:3.40.50.1000:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104829, NULL, 'G3DSA:3.40.50.300:FF:005320', NULL, NULL, 'Altered inheritance of mitochondria protein 36, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(104830, NULL, 'G3DSA:3.90.1300.10:FF:000013', NULL, NULL, 'Amd2p', NULL, NULL, NULL, NULL, NULL, 4),
(104831, NULL, 'G3DSA:3.10.600.10:FF:000009', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(104832, NULL, 'G3DSA:1.20.1250.20:FF:001855', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104833, NULL, 'G3DSA:3.30.70.330:FF:001687', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104834, NULL, 'G3DSA:2.60.40.1670:FF:000004', NULL, NULL, 'SEC24 homolog D, COPII coat complex component', NULL, NULL, NULL, NULL, NULL, 4),
(104835, NULL, 'G3DSA:1.10.10.10:FF:001944', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104836, NULL, 'G3DSA:2.10.25.10:FF:001133', NULL, NULL, 'GD22026', NULL, NULL, NULL, NULL, NULL, 4),
(104837, NULL, 'G3DSA:3.30.70.330:FF:000131', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein h3 isoform', NULL, NULL, NULL, NULL, NULL, 4),
(104838, NULL, 'G3DSA:3.40.50.300:FF:004426', NULL, NULL, 'Shikimate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(104839, NULL, 'G3DSA:3.90.960.10:FF:000001', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(104840, NULL, 'G3DSA:3.40.50.300:FF:002740', NULL, NULL, 'p-loop hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(104841, NULL, 'G3DSA:3.40.120.10:FF:000028', NULL, NULL, 'GlcNAc phosphomutase', NULL, NULL, NULL, NULL, NULL, 4),
(104842, NULL, 'G3DSA:3.40.1360.10:FF:000045', NULL, NULL, 'DNA primase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(104843, NULL, 'G3DSA:1.10.10.60:FF:000424', NULL, NULL, 'ANTP homeobox protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(104844, NULL, 'G3DSA:2.30.29.30:FF:001068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104845, NULL, 'G3DSA:2.60.40.60:FF:000332', NULL, NULL, 'Fat-like cadherin-related tumor suppressor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(104846, NULL, 'G3DSA:1.10.472.10:FF:000180', NULL, NULL, 'Cyclin Dx', NULL, NULL, NULL, NULL, NULL, 4),
(104847, NULL, 'G3DSA:1.10.238.10:FF:000147', NULL, NULL, 'Calbindin 1', NULL, NULL, NULL, NULL, NULL, 4),
(104848, NULL, 'G3DSA:2.40.10.10:FF:000406', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104849, NULL, 'G3DSA:2.130.10.10:FF:003111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104850, NULL, 'G3DSA:3.40.50.300:FF:003937', NULL, NULL, 'Ferrous iron transport protein B', NULL, NULL, NULL, NULL, NULL, 4),
(104851, NULL, 'G3DSA:3.20.20.70:FF:000833', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104852, NULL, 'G3DSA:3.90.1600.10:FF:000058', NULL, NULL, 'DNA polymerase epsilon catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(104853, NULL, 'G3DSA:1.10.418.10:FF:000245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104854, NULL, 'G3DSA:4.10.1240.50:FF:000009', NULL, NULL, 'Protein CBR-LIN-40', NULL, NULL, NULL, NULL, NULL, 4),
(104855, NULL, 'G3DSA:3.50.50.60:FF:000235', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(104856, NULL, 'G3DSA:2.40.320.10:FF:000030', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 18', NULL, NULL, NULL, NULL, NULL, 4),
(104857, NULL, 'G3DSA:2.60.40.1660:FF:000001', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(104858, NULL, 'G3DSA:3.30.70.330:FF:000810', NULL, NULL, 'heterogeneous nuclear ribonucleoprotein Q isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(104859, NULL, 'G3DSA:3.30.160.60:FF:002739', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104860, NULL, 'G3DSA:3.40.640.10:FF:000090', NULL, NULL, 'Pyridoxal phosphate-dependent aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(104861, NULL, 'G3DSA:2.60.40.10:FF:002318', NULL, NULL, 'Cytochrome c oxidase accessory protein CcoG', NULL, NULL, NULL, NULL, NULL, 4),
(104862, NULL, 'G3DSA:3.40.50.300:FF:000262', NULL, NULL, 'Cytidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(104863, NULL, 'G3DSA:3.40.50.10260:FF:000004', NULL, NULL, 'yjeF N-terminal domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(104864, NULL, 'G3DSA:3.30.530.20:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104865, NULL, 'G3DSA:3.40.50.720:FF:001736', NULL, NULL, 'D-aspartate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(104866, NULL, 'G3DSA:3.30.60.10:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104867, NULL, 'G3DSA:2.40.33.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104868, NULL, 'G3DSA:2.30.30.40:FF:000074', NULL, NULL, 'E3 ubiquitin-protein ligase HERC2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(104869, NULL, 'G3DSA:3.80.10.10:FF:000222', NULL, NULL, 'F-box and leucine rich repeat protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(104870, NULL, 'G3DSA:2.30.30.110:FF:000004', NULL, NULL, 'mRNA interferase MazF4', NULL, NULL, NULL, NULL, NULL, 4),
(104871, NULL, 'G3DSA:3.40.50.12590:FF:000001', NULL, NULL, 'ATP phosphoribosyltransferase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(104872, NULL, 'G3DSA:1.25.60.10:FF:000003', NULL, NULL, 'Transport transmembrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(104873, NULL, 'G3DSA:2.60.120.650:FF:000114', NULL, NULL, 'Os02g0109501 protein', NULL, NULL, NULL, NULL, NULL, 4),
(104874, NULL, 'G3DSA:3.90.1150.10:FF:000130', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(104875, NULL, 'G3DSA:1.10.246.60:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104876, NULL, 'G3DSA:3.90.1150.10:FF:000422', NULL, NULL, 'L-threonine aldolase, low-specificity, putative', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(104877, NULL, 'G3DSA:2.30.30.100:FF:000001', NULL, NULL, 'RNA-binding protein Hfq', NULL, NULL, NULL, NULL, NULL, 4),
(104878, NULL, 'G3DSA:3.30.160.60:FF:000441', NULL, NULL, 'zinc finger protein 410 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(104879, NULL, 'G3DSA:1.10.1100.10:FF:000001', NULL, NULL, 'Transcription initiation factor TFIID subunit', NULL, NULL, NULL, NULL, NULL, 4),
(104880, NULL, 'G3DSA:3.40.50.300:FF:001054', NULL, NULL, 'ATPase, AAA family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104881, NULL, 'G3DSA:3.30.200.20:FF:002456', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104882, NULL, 'G3DSA:3.40.630.30:FF:000505', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104883, NULL, 'G3DSA:3.90.70.10:FF:000175', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 16', NULL, NULL, NULL, NULL, NULL, 4),
(104884, NULL, 'G3DSA:3.40.50.11860:FF:000001', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(104885, NULL, 'G3DSA:3.30.60.20:FF:000017', NULL, NULL, 'Thymidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(104886, NULL, 'G3DSA:1.20.990.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104887, NULL, 'G3DSA:3.10.110.10:FF:000332', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(104888, NULL, 'G3DSA:3.40.50.1000:FF:000263', NULL, NULL, 'Unplaced genomic scaffold supercont1.6, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(104889, NULL, 'G3DSA:2.60.120.560:FF:000008', NULL, NULL, 'Sucrose-6-phosphate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(104890, NULL, 'G3DSA:1.20.58.2010:FF:000003', NULL, NULL, 'Rop guanine nucleotide exchange factor 14', NULL, NULL, NULL, NULL, NULL, 4),
(104891, NULL, 'G3DSA:2.130.10.10:FF:000205', NULL, NULL, 'BTB/POZ domain-containing protein KCTD3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(104892, NULL, 'G3DSA:3.40.190.10:FF:000509', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(104893, NULL, 'G3DSA:3.20.20.70:FF:000507', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104894, NULL, 'G3DSA:3.40.33.10:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104895, NULL, 'G3DSA:2.30.29.30:FF:001309', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(104896, NULL, 'G3DSA:2.60.40.60:FF:000427', NULL, NULL, 'Protocadherin-15', NULL, NULL, NULL, NULL, NULL, 4),
(104897, NULL, 'G3DSA:1.10.10.1230:FF:000002', NULL, NULL, 'Penicillin-binding protein 2B', NULL, NULL, NULL, NULL, NULL, 4),
(104898, NULL, 'G3DSA:3.30.160.60:FF:004364', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104899, NULL, 'G3DSA:2.140.10.10:FF:000002', NULL, NULL, 'Glucose dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(104900, NULL, 'G3DSA:3.30.40.10:FF:001480', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104901, NULL, 'G3DSA:1.25.10.10:FF:000438', NULL, NULL, 'Splicing factor 3B subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(104902, NULL, 'G3DSA:3.90.1640.10:FF:000004', NULL, NULL, 'Prune exopolyphosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(104903, NULL, 'G3DSA:3.40.50.620:FF:000301', NULL, NULL, 'Probable electron transfer flavoprotein subunit alpha, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(104904, NULL, 'G3DSA:2.40.170.20:FF:000049', NULL, NULL, 'TonB-dependent receptor', NULL, NULL, NULL, NULL, NULL, 4),
(104905, NULL, 'G3DSA:1.10.506.10:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104906, NULL, 'G3DSA:1.10.287.370:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104907, NULL, 'G3DSA:2.60.120.330:FF:000075', NULL, NULL, 'Oxidoreductase, 2OG-Fe(II) oxygenase family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104908, NULL, 'G3DSA:4.10.400.10:FF:000098', NULL, NULL, 'low-density lipoprotein receptor-related protein 4', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(104909, NULL, 'G3DSA:3.40.30.10:FF:001006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104910, NULL, 'G3DSA:3.30.160.60:FF:006067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104911, NULL, 'G3DSA:3.30.160.60:FF:002470', NULL, NULL, 'Zinc finger protein 59', NULL, NULL, NULL, NULL, NULL, 4),
(104912, NULL, 'G3DSA:3.30.70.580:FF:000008', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(104913, NULL, 'G3DSA:2.60.34.10:FF:000011', NULL, NULL, 'Heat shock protein hsp88', NULL, NULL, NULL, NULL, NULL, 4),
(104914, NULL, 'G3DSA:2.40.10.10:FF:000114', NULL, NULL, 'Protein Z, vitamin K-dependent plasma glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(104915, NULL, 'G3DSA:1.10.620.20:FF:000033', NULL, NULL, 'Putative N-oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(104916, NULL, 'G3DSA:1.10.30.10:FF:000046', NULL, NULL, 'High mobility group box 4', NULL, NULL, NULL, NULL, NULL, 4),
(104917, NULL, 'G3DSA:2.30.30.30:FF:000071', NULL, NULL, 'Ribosomal protein L24/L26-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(104918, NULL, 'G3DSA:3.30.40.10:FF:001772', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104919, NULL, 'G3DSA:3.40.140.10:FF:000237', NULL, NULL, 'Mov34/MPN/PAD-1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(104920, NULL, 'G3DSA:2.40.70.10:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104921, NULL, 'G3DSA:3.30.160.60:FF:000727', NULL, NULL, 'Spalt-like transcription factor 3a', NULL, NULL, NULL, NULL, NULL, 4),
(104922, NULL, 'G3DSA:2.130.10.10:FF:001958', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104923, NULL, 'G3DSA:1.25.40.20:FF:001230', NULL, NULL, 'Ankyrin repeat and SOCS box-containing 2b', NULL, NULL, NULL, NULL, NULL, 4),
(104924, NULL, 'G3DSA:3.30.230.70:FF:000034', NULL, NULL, 'Exosome complex component RRP42', NULL, NULL, NULL, NULL, NULL, 4),
(104925, NULL, 'G3DSA:3.40.50.300:FF:004185', NULL, NULL, 'ABC transporter A family member 11', NULL, NULL, NULL, NULL, NULL, 4),
(104926, NULL, 'G3DSA:3.30.70.1230:FF:000227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104927, NULL, 'G3DSA:2.60.40.10:FF:003779', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104928, NULL, 'G3DSA:1.10.10.60:FF:000245', NULL, NULL, 'zinc finger homeobox protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(104929, NULL, 'G3DSA:2.60.40.1210:FF:000001', NULL, NULL, 'Monooxygenase, DBH-like 1, like', NULL, NULL, NULL, NULL, NULL, 4),
(104930, NULL, 'G3DSA:3.30.160.380:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104931, NULL, 'G3DSA:3.40.1230.10:FF:000007', NULL, NULL, 'NADH:Ubiquinone oxidoreductase Assembly Factor', NULL, NULL, NULL, NULL, NULL, 4),
(104932, NULL, 'G3DSA:2.130.10.10:FF:000256', NULL, NULL, 'WD repeat and SOCS box containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(104933, NULL, 'G3DSA:2.102.10.10:FF:000027', NULL, NULL, 'Non-heme iron oxygenase ferredoxin subunit', NULL, NULL, NULL, NULL, NULL, 4),
(104934, NULL, 'G3DSA:2.60.40.1220:FF:000004', NULL, NULL, 'Bacterial Ig-like domain, group 2', NULL, NULL, NULL, NULL, NULL, 4),
(104935, NULL, 'G3DSA:1.20.5.340:FF:000055', NULL, NULL, 'Protein CBR-PKD-2', NULL, NULL, NULL, NULL, NULL, 4),
(104936, NULL, 'G3DSA:3.40.800.10:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104937, NULL, 'G3DSA:3.30.565.10:FF:000243', NULL, NULL, 'Sensor histidine kinase/response regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104938, NULL, 'G3DSA:3.30.160.360:FF:000013', NULL, NULL, 'Methyl-CpG-binding domain 9', NULL, NULL, NULL, NULL, NULL, 4),
(104939, NULL, 'G3DSA:2.60.40.1230:FF:000007', NULL, NULL, 'AP-2 complex subunit alpha, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104940, NULL, 'G3DSA:1.10.287.110:FF:000447', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(104941, NULL, 'G3DSA:3.40.50.970:FF:000029', NULL, NULL, '2-succinyl-5-enolpyruvyl-6-hydroxy-3-cyclohexene-1-carboxylate synthase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(104942, NULL, 'G3DSA:3.40.50.2000:FF:000433', NULL, NULL, 'Cytidylyltransferase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(104943, NULL, 'G3DSA:2.10.25.10:FF:000970', NULL, NULL, 'Peptidase domain-containing-associated with muscle regeneration 1', NULL, NULL, NULL, NULL, NULL, 4),
(104944, NULL, 'G3DSA:3.80.10.10:FF:001099', NULL, NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(104945, NULL, 'G3DSA:3.40.50.10310:FF:000014', NULL, NULL, 'Creatinine amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(104946, NULL, 'G3DSA:3.40.50.720:FF:000213', NULL, NULL, 'Putative 2-hydroxyacid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(104947, NULL, 'G3DSA:3.40.800.20:FF:000044', NULL, NULL, 'Histone deacetylase B', NULL, NULL, NULL, NULL, NULL, 4),
(104948, NULL, 'G3DSA:2.120.10.30:FF:000262', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(104949, NULL, 'G3DSA:3.40.50.300:FF:004477', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104950, NULL, 'G3DSA:3.40.50.300:FF:004926', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104951, NULL, 'G3DSA:3.40.630.10:FF:000145', NULL, NULL, 'zinc carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(104952, NULL, 'G3DSA:1.10.10.10:FF:000319', NULL, NULL, 'RpiR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(104953, NULL, 'G3DSA:2.70.98.110:FF:000012', NULL, NULL, 'Glycoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(104954, NULL, 'G3DSA:2.60.200.20:FF:000216', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(104955, NULL, 'G3DSA:2.130.10.10:FF:004185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104956, NULL, 'G3DSA:4.10.220.110:FF:000002', NULL, NULL, 'Actin cross-linking toxin VgrG1', NULL, NULL, NULL, NULL, NULL, 4),
(104957, NULL, 'G3DSA:3.90.70.10:FF:000821', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104958, NULL, 'G3DSA:3.40.50.10810:FF:000153', NULL, NULL, 'Helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104959, NULL, 'G3DSA:1.10.400.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104960, NULL, 'G3DSA:2.40.70.10:FF:000269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104961, NULL, 'G3DSA:3.40.50.300:FF:006629', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104962, NULL, 'G3DSA:3.40.50.1820:FF:001385', NULL, NULL, 'FI18305p1', NULL, NULL, NULL, NULL, NULL, 4),
(104963, NULL, 'G3DSA:1.25.40.10:FF:000092', NULL, NULL, 'CCR4-NOT transcription complex subunit 10 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(104964, NULL, 'G3DSA:1.25.40.20:FF:000948', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104965, NULL, 'G3DSA:1.25.10.10:FF:000590', NULL, NULL, 'Condensin complex subunit 3, variant', NULL, NULL, NULL, NULL, NULL, 4),
(104966, NULL, 'G3DSA:2.60.40.2030:FF:000011', NULL, NULL, 'Fras1-related extracellular matrix protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(104967, NULL, 'G3DSA:3.40.30.10:FF:000843', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(104968, NULL, 'G3DSA:3.30.200.20:FF:000270', NULL, NULL, 'Serine/threonine-protein kinase bur1', NULL, NULL, NULL, NULL, NULL, 4),
(104969, NULL, 'G3DSA:1.10.238.10:FF:000394', NULL, NULL, 'Calcium-dependent protein kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(104970, NULL, 'G3DSA:1.10.287.550:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(104971, NULL, 'G3DSA:1.10.510.10:FF:000168', NULL, NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', NULL, NULL, NULL, NULL, NULL, 4),
(104972, NULL, 'G3DSA:1.10.287.110:FF:000240', NULL, NULL, 'Chaperone DnaJ-domain superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(104973, NULL, 'G3DSA:1.10.150.20:FF:000300', NULL, NULL, 'DNA-directed RNA polymerase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(104974, NULL, 'G3DSA:3.40.350.10:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104975, NULL, 'G3DSA:1.25.40.10:FF:000384', NULL, NULL, 'Probable pre-mRNA splicing factor prp1', NULL, NULL, NULL, NULL, NULL, 4),
(104976, NULL, 'G3DSA:3.90.70.10:FF:000203', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(104977, NULL, 'G3DSA:3.40.47.10:FF:000292', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104978, NULL, 'G3DSA:2.70.150.10:FF:000128', NULL, NULL, 'E1-E2 ATPase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(104979, NULL, 'G3DSA:1.25.40.20:FF:000387', NULL, NULL, 'Cortactin-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(104980, NULL, 'G3DSA:3.30.200.20:FF:000118', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(104981, NULL, 'G3DSA:3.30.70.870:FF:000040', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(104982, NULL, 'G3DSA:1.10.8.60:FF:000446', NULL, NULL, 'ATP-dependent zinc metallopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104983, NULL, 'G3DSA:1.10.8.270:FF:000070', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(104984, NULL, 'G3DSA:3.40.640.10:FF:000382', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104985, NULL, 'G3DSA:1.25.10.10:FF:000882', NULL, NULL, 'E3 ubiquitin-protein ligase HUWE1', NULL, NULL, NULL, NULL, NULL, 4),
(104986, NULL, 'G3DSA:1.10.238.10:FF:000068', NULL, NULL, 'SPARC isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(104987, NULL, 'G3DSA:1.20.1440.200:FF:000007', NULL, NULL, 'Vacuolar protein sorting-associated protein 28 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(104988, NULL, 'G3DSA:2.60.40.10:FF:002470', NULL, NULL, 'polycystin-1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(104989, NULL, 'G3DSA:3.30.70.330:FF:001766', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104990, NULL, 'G3DSA:1.10.10.60:FF:001301', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(104991, NULL, 'G3DSA:2.130.10.10:FF:000823', NULL, NULL, 'Cell cycle control protein (Cwf8), putative', NULL, NULL, NULL, NULL, NULL, 4),
(104992, NULL, 'G3DSA:2.170.270.10:FF:000034', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(104993, NULL, 'G3DSA:2.20.70.10:FF:000051', NULL, NULL, 'probable phosphoinositide phosphatase SAC9', NULL, NULL, NULL, NULL, NULL, 4),
(104994, NULL, 'G3DSA:3.30.450.40:FF:000210', NULL, NULL, 'Sodium/solute symporter, GAF and PP2C family protein serine/threonine phosphatase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(104995, NULL, 'G3DSA:3.30.1120.10:FF:000069', NULL, NULL, 'N-acetylgalactosamine 6-sulfatase (GALNS)', NULL, NULL, NULL, NULL, NULL, 4),
(104996, NULL, 'G3DSA:2.130.10.10:FF:002852', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(104997, NULL, 'G3DSA:1.10.472.80:FF:000094', NULL, NULL, 'GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104998, NULL, 'G3DSA:3.40.50.10810:FF:000102', NULL, NULL, 'Chromosome organization and biogenesis-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(104999, NULL, 'G3DSA:1.20.120.1900:FF:000085', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(105000, NULL, 'G3DSA:3.50.80.10:FF:000008', NULL, NULL, 'Putative D-tyrosyl-tRNA(Tyr) deacylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(105001, NULL, 'G3DSA:3.90.550.10:FF:000178', NULL, NULL, '2-C-methyl-D-erythritol 4-phosphate cytidylyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105002, NULL, 'G3DSA:1.20.1070.10:FF:000231', NULL, NULL, 'Allatostatin C receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(105003, NULL, 'G3DSA:1.20.1250.20:FF:000220', NULL, NULL, 'Probable anion transporter 7', NULL, NULL, NULL, NULL, NULL, 4),
(105004, NULL, 'G3DSA:3.40.50.10900:FF:000011', NULL, NULL, 'Proteasome assembly factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105005, NULL, 'G3DSA:1.20.58.70:FF:000115', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(105006, NULL, 'G3DSA:3.50.50.100:FF:000036', NULL, NULL, 'NADH dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(105007, NULL, 'G3DSA:4.10.400.10:FF:000047', NULL, NULL, 'Prolow-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(105008, NULL, 'G3DSA:3.40.30.10:FF:000517', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(105009, NULL, 'G3DSA:2.130.10.10:FF:004746', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105010, NULL, 'G3DSA:3.30.70.330:FF:002255', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105011, NULL, 'G3DSA:3.40.50.300:FF:002414', NULL, NULL, 'Nucleolar RNA helicase II, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105012, NULL, 'G3DSA:2.60.40.10:FF:001981', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(105013, NULL, 'G3DSA:3.50.50.60:FF:000561', NULL, NULL, 'Hydrogen cyanide synthase subunit HcnC', NULL, NULL, NULL, NULL, NULL, 4),
(105014, NULL, 'G3DSA:3.30.160.60:FF:004038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105015, NULL, 'G3DSA:3.10.430.100:FF:000013', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(105016, NULL, 'G3DSA:2.40.50.1000:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105017, NULL, 'G3DSA:1.20.200.10:FF:000013', NULL, NULL, 'Argininosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(105018, NULL, 'G3DSA:1.25.10.10:FF:002467', NULL, NULL, 'Plakophilin 4', NULL, NULL, NULL, NULL, NULL, 4),
(105019, NULL, 'G3DSA:3.30.457.60:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105020, NULL, 'G3DSA:1.10.274.30:FF:000023', NULL, NULL, 'Ci-male-specific lethal 3-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(105021, NULL, 'G3DSA:3.40.50.150:FF:001520', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105022, NULL, 'G3DSA:3.30.70.2510:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105023, NULL, 'G3DSA:3.90.550.10:FF:000706', NULL, NULL, 'Dolichyl-phosphate beta-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(105024, NULL, 'G3DSA:1.25.40.10:FF:000171', NULL, NULL, 'protein sel-1 homolog 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(105025, NULL, 'G3DSA:1.20.1270.10:FF:000100', NULL, NULL, 'Heat shock protein', NULL, NULL, NULL, NULL, NULL, 4),
(105026, NULL, 'G3DSA:2.60.40.1180:FF:000071', NULL, NULL, 'Probable glucan 1,3-alpha-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(105027, NULL, 'G3DSA:3.40.50.2000:FF:000107', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(105028, NULL, 'G3DSA:3.30.1060.10:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105029, NULL, 'G3DSA:2.120.10.80:FF:000086', NULL, NULL, 'Kelch-like protein 4 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(105030, NULL, 'G3DSA:3.30.70.1450:FF:000001', NULL, NULL, 'Trk system potassium transporter TrkA', NULL, NULL, NULL, NULL, NULL, 4),
(105031, NULL, 'G3DSA:2.60.40.10:FF:002195', NULL, NULL, 'Beta-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(105032, NULL, 'G3DSA:3.40.50.300:FF:008316', NULL, NULL, 'tRNA dimethylallyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(105033, NULL, 'G3DSA:2.10.70.10:FF:000254', NULL, NULL, 'Pxn-1', NULL, NULL, NULL, NULL, NULL, 4),
(105034, NULL, 'G3DSA:2.60.120.260:FF:000531', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105035, NULL, 'G3DSA:2.60.40.790:FF:000153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105036, NULL, 'G3DSA:3.30.200.20:FF:001579', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105037, NULL, 'G3DSA:1.10.10.60:FF:000812', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105038, NULL, 'G3DSA:3.30.450.40:FF:000261', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(105039, NULL, 'G3DSA:1.10.1070.11:FF:000049', NULL, NULL, 'Ataxia telangiectasia mutated, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105040, NULL, 'G3DSA:1.10.287.1490:FF:000143', NULL, NULL, 'Viral A-type inclusion protein, putative', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(105041, NULL, 'G3DSA:2.60.210.10:FF:000006', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 7', NULL, NULL, NULL, NULL, NULL, 4),
(105042, NULL, 'G3DSA:3.60.21.10:FF:000434', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105043, NULL, 'G3DSA:3.30.70.330:FF:000052', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein L like', NULL, NULL, NULL, NULL, NULL, 4),
(105044, NULL, 'G3DSA:3.80.10.10:FF:003095', NULL, NULL, 'Zgc:103424', NULL, NULL, NULL, NULL, NULL, 4),
(105045, NULL, 'G3DSA:1.10.8.60:FF:000497', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(105046, NULL, 'G3DSA:1.10.3730.20:FF:000035', NULL, NULL, 'Drug/metabolite transporter (DMT) superfamily permease', NULL, NULL, NULL, NULL, NULL, 4),
(105047, NULL, 'G3DSA:2.40.50.140:FF:000240', NULL, NULL, 'Uncharacterized protein At4g28440', NULL, NULL, NULL, NULL, NULL, 4),
(105048, NULL, 'G3DSA:3.30.60.60:FF:000017', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(105049, NULL, 'G3DSA:1.25.10.10:FF:000264', NULL, NULL, 'Protein kinase family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(105050, NULL, 'G3DSA:1.20.1420.30:FF:000023', NULL, NULL, 'Mitochondrial sodium/calcium exchanger protein', NULL, NULL, NULL, NULL, NULL, 4),
(105051, NULL, 'G3DSA:2.130.10.10:FF:002234', NULL, NULL, 'F-box-like/WD repeat-containing protein TBL1XR1', NULL, NULL, NULL, NULL, NULL, 4),
(105052, NULL, 'G3DSA:3.10.110.10:FF:000253', NULL, NULL, 'YALI0C02365p', NULL, NULL, NULL, NULL, NULL, 4),
(105053, NULL, 'G3DSA:2.40.50.640:FF:000002', NULL, NULL, 'Exoribonuclease 2', NULL, NULL, NULL, NULL, NULL, 4),
(105054, NULL, 'G3DSA:3.30.2160.10:FF:000009', NULL, NULL, 'E3 ubiquitin-protein ligase HECTD1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(105055, NULL, 'G3DSA:3.30.1390.20:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105056, NULL, 'G3DSA:3.30.930.10:FF:000148', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(105057, NULL, 'G3DSA:4.10.60.10:FF:000136', NULL, NULL, 'Glycine-rich RNA-binding protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(105058, NULL, 'G3DSA:2.130.10.10:FF:001312', NULL, NULL, 'AGAP011387-PA', NULL, NULL, NULL, NULL, NULL, 4),
(105059, NULL, 'G3DSA:2.40.70.10:FF:000011', NULL, NULL, 'Aspartic protease', NULL, NULL, NULL, NULL, NULL, 4),
(105060, NULL, 'G3DSA:1.20.120.980:FF:000043', NULL, NULL, 'Dipeptidyl-peptidase 7', NULL, NULL, NULL, NULL, NULL, 4),
(105061, NULL, 'G3DSA:3.90.1290.10:FF:000039', NULL, NULL, 'VAB-10A protein', NULL, NULL, NULL, NULL, NULL, 4),
(105062, NULL, 'G3DSA:3.30.70.330:FF:002204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105063, NULL, 'G3DSA:1.20.120.1490:FF:000001', NULL, NULL, 'Cell-envelope stress modulator CpxP', NULL, NULL, NULL, NULL, NULL, 4),
(105064, NULL, 'G3DSA:3.20.20.80:FF:000302', NULL, NULL, 'Galactolipid galactosyltransferase SFR2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(105065, NULL, 'G3DSA:3.90.1640.20:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105066, NULL, 'G3DSA:2.40.50.140:FF:000801', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105067, NULL, 'G3DSA:1.20.58.760:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105068, NULL, 'G3DSA:3.40.850.10:FF:000302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105069, NULL, 'G3DSA:2.60.260.20:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105070, NULL, 'G3DSA:2.10.25.10:FF:001307', NULL, NULL, 'Transmembrane cell adhesion receptor mua-3', NULL, NULL, NULL, NULL, NULL, 4),
(105071, NULL, 'G3DSA:3.60.21.10:FF:000029', NULL, NULL, 'UDP-2,3-diacylglucosamine hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(105072, NULL, 'G3DSA:1.25.10.10:FF:002416', NULL, NULL, 'Sister chromatid cohesion protein PDS5 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(105073, NULL, 'G3DSA:1.20.142.10:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(105074, NULL, 'G3DSA:3.40.50.300:FF:006343', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(105075, NULL, 'G3DSA:1.20.900.10:FF:000021', NULL, NULL, 'FERM, RhoGEF and pleckstrin domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(105076, NULL, 'G3DSA:2.60.40.60:FF:000506', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(105077, NULL, 'G3DSA:3.40.50.2300:FF:000321', NULL, NULL, 'Glutamate receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(105078, NULL, 'G3DSA:3.30.40.10:FF:001154', NULL, NULL, 'RING-H2 finger protein ATL2L', NULL, NULL, NULL, NULL, NULL, 4),
(105079, NULL, 'G3DSA:3.40.50.300:FF:000823', NULL, NULL, 'Small GTPase RAB, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105080, NULL, 'G3DSA:3.30.160.60:FF:004656', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105081, NULL, 'G3DSA:1.10.287.90:FF:000025', NULL, NULL, 'Cytochrome c oxidase subunit II', NULL, NULL, NULL, NULL, NULL, 4),
(105082, NULL, 'G3DSA:1.10.287.80:FF:000022', NULL, NULL, 'ATP synthase subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(105083, NULL, 'G3DSA:3.30.70.330:FF:001715', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105084, NULL, 'G3DSA:2.160.20.10:FF:000103', NULL, NULL, 'Pectin methylesterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105085, NULL, 'G3DSA:3.40.50.720:FF:001348', NULL, NULL, 'Putative enoyl reductase MmyQ', NULL, NULL, NULL, NULL, NULL, 4),
(105086, NULL, 'G3DSA:3.80.10.10:FF:003533', NULL, NULL, 'LOC100170568 protein', NULL, NULL, NULL, NULL, NULL, 4),
(105087, NULL, 'G3DSA:1.10.510.10:FF:002472', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105088, NULL, 'G3DSA:2.130.10.10:FF:000323', NULL, NULL, 'U4/U6 small nuclear ribonucleoprotein Prp4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(105089, NULL, 'G3DSA:2.60.40.150:FF:000309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105090, NULL, 'G3DSA:1.25.40.990:FF:000072', NULL, NULL, 'AGAP008902-PA', NULL, NULL, NULL, NULL, NULL, 4),
(105091, NULL, 'G3DSA:2.40.10.170:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105092, NULL, 'G3DSA:3.50.7.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105093, NULL, 'G3DSA:1.10.1900.40:FF:000003', NULL, NULL, 'Erythrocyte membrane protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(105094, NULL, 'G3DSA:1.10.3210.40:FF:000001', NULL, NULL, 'Integrating conjugative element relaxase, PFGI-1 class', NULL, NULL, NULL, NULL, NULL, 4),
(105095, NULL, 'G3DSA:3.10.20.820:FF:000002', NULL, NULL, 'Fumarate reductase flavoprotein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(105096, NULL, 'G3DSA:2.170.260.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105097, NULL, 'G3DSA:1.10.533.10:FF:000092', NULL, NULL, 'Netrin receptor unc-5', NULL, NULL, NULL, NULL, NULL, 4),
(105098, NULL, 'G3DSA:1.10.10.10:FF:002057', NULL, NULL, 'Two component transcriptional regulator, winged helix family', NULL, NULL, NULL, NULL, NULL, 4),
(105099, NULL, 'G3DSA:1.10.555.10:FF:000187', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105100, NULL, 'G3DSA:3.40.50.150:FF:000795', NULL, NULL, 'tRNA (guanine(37)-N1)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(105101, NULL, 'G3DSA:2.60.40.150:FF:000247', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(105102, NULL, 'G3DSA:1.25.40.540:FF:000021', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(105103, NULL, 'G3DSA:3.40.50.2300:FF:000203', NULL, NULL, 'LacI family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(105104, NULL, 'G3DSA:2.10.25.10:FF:000969', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(105105, NULL, 'G3DSA:3.30.40.10:FF:001654', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105106, NULL, 'G3DSA:2.60.120.40:FF:000047', NULL, NULL, 'TNF superfamily member 13', NULL, NULL, NULL, NULL, NULL, 4),
(105107, NULL, 'G3DSA:1.10.533.10:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(105108, NULL, 'G3DSA:3.30.420.40:FF:000141', NULL, NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(105109, NULL, 'G3DSA:2.60.120.260:FF:000093', NULL, NULL, 'Alpha-L-fucosidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(105110, NULL, 'G3DSA:3.30.200.20:FF:000450', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(105111, NULL, 'G3DSA:3.30.40.10:FF:000131', NULL, NULL, 'tyrosine-protein kinase BAZ1B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(105112, NULL, 'G3DSA:3.40.50.300:FF:004365', NULL, NULL, 'Dephospho-CoA kinase', NULL, NULL, NULL, NULL, NULL, 4),
(105113, NULL, 'G3DSA:3.40.50.300:FF:006068', NULL, NULL, 'Putative ATP-binding cassette sub-family A member 11', NULL, NULL, NULL, NULL, NULL, 4),
(105114, NULL, 'G3DSA:3.10.50.40:FF:000080', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(105115, NULL, 'G3DSA:2.160.10.10:FF:000013', NULL, NULL, 'Acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(105116, NULL, 'G3DSA:3.90.228.10:FF:000008', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(105117, NULL, 'G3DSA:2.80.10.50:FF:000158', NULL, NULL, 'Dolichyl-phosphate-mannose-protein mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(105118, NULL, 'G3DSA:2.60.260.20:FF:000158', NULL, NULL, 'Chaperone protein DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(105119, NULL, 'G3DSA:3.30.160.60:FF:005050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105120, NULL, 'G3DSA:3.30.450.40:FF:000209', NULL, NULL, 'Sensor cyclic diguanylate phosphodiesterase, GAF and GAF domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(105121, NULL, 'G3DSA:3.30.830.10:FF:000146', NULL, NULL, 'Metalloprotease, insulinase family', NULL, NULL, NULL, NULL, NULL, 4),
(105122, NULL, 'G3DSA:3.30.200.20:FF:001967', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105123, NULL, 'G3DSA:1.25.70.10:FF:000094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105124, NULL, 'G3DSA:1.10.630.10:FF:000845', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105125, NULL, 'G3DSA:3.20.14.10:FF:000003', NULL, NULL, 'L-fucose isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(105126, NULL, 'G3DSA:1.20.120.1750:FF:000017', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(105127, NULL, 'G3DSA:2.10.25.10:FF:001015', NULL, NULL, 'Fibrillin-1', NULL, NULL, NULL, NULL, NULL, 4),
(105128, NULL, 'G3DSA:2.130.10.10:FF:004538', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105129, NULL, 'G3DSA:2.130.10.10:FF:002408', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105130, NULL, 'G3DSA:2.170.120.12:FF:000020', NULL, NULL, 'RNA polymerase I and III subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(105131, NULL, 'G3DSA:2.70.170.10:FF:000242', NULL, NULL, 'Cholinergic receptor, nicotinic alpha 9', NULL, NULL, NULL, NULL, NULL, 4),
(105132, NULL, 'G3DSA:3.40.50.720:FF:001854', NULL, NULL, '15-hydroxyprostaglandin dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105133, NULL, 'G3DSA:3.40.30.10:FF:000282', NULL, NULL, 'thioredoxin domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(105134, NULL, 'G3DSA:3.40.50.150:FF:001312', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105135, NULL, 'G3DSA:3.30.40.10:FF:002261', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(105136, NULL, 'G3DSA:2.60.40.150:FF:000197', NULL, NULL, 'Protein BONZAI 1 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(105137, NULL, 'G3DSA:2.60.40.10:FF:002970', NULL, NULL, 'Mesocentin', NULL, NULL, NULL, NULL, NULL, 4),
(105138, NULL, 'G3DSA:3.30.160.60:FF:003021', NULL, NULL, 'Zinc finger protein 1144', NULL, NULL, NULL, NULL, NULL, 4),
(105139, NULL, 'G3DSA:2.60.120.40:FF:000008', NULL, NULL, 'Tumor necrosis factor ligand superfamily member 11', NULL, NULL, NULL, NULL, NULL, 4),
(105140, NULL, 'G3DSA:2.40.50.140:FF:000060', NULL, NULL, 'Ribosomal protein S12 methylthiotransferase RimO', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(105141, NULL, 'G3DSA:1.10.1420.10:FF:000047', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(105142, NULL, 'G3DSA:2.60.40.10:FF:000671', NULL, NULL, 'Vascular cell adhesion molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(105143, NULL, 'G3DSA:2.10.25.10:FF:001700', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105144, NULL, 'G3DSA:3.40.50.300:FF:002920', NULL, NULL, 'Toprim domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(105145, NULL, 'G3DSA:1.10.1170.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105146, NULL, 'G3DSA:2.130.10.10:FF:004651', NULL, NULL, 'Gastrulation defective protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(105147, NULL, 'G3DSA:1.25.40.990:FF:000015', NULL, NULL, 'Leukocyte receptor cluster member 8', NULL, NULL, NULL, NULL, NULL, 4),
(105148, NULL, 'G3DSA:2.40.30.10:FF:000177', NULL, NULL, 'Eukaryotic elongation factor, selenocysteine-tRNA-specific', NULL, NULL, NULL, NULL, NULL, 4),
(105149, NULL, 'G3DSA:3.40.50.1110:FF:000099', NULL, NULL, 'Acetylxylan esterase', NULL, NULL, NULL, NULL, NULL, 4),
(105150, NULL, 'G3DSA:1.20.1300.10:FF:000036', NULL, NULL, 'Succinate dehydrogenase membrane subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105151, NULL, 'G3DSA:1.10.10.60:FF:000312', NULL, NULL, 'Mix-type homeobox gene 1', NULL, NULL, NULL, NULL, NULL, 4),
(105152, NULL, 'G3DSA:2.60.40.1180:FF:000065', NULL, NULL, 'Isoamylase 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(105153, NULL, 'G3DSA:3.40.50.300:FF:006394', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105154, NULL, 'G3DSA:3.40.640.10:FF:000213', NULL, NULL, 'Putative serine--glyoxylate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(105155, NULL, 'G3DSA:1.20.58.670:FF:000013', NULL, NULL, 'Exocyst complex component SEC15', NULL, NULL, NULL, NULL, NULL, 4),
(105156, NULL, 'G3DSA:3.10.310.20:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105157, NULL, 'G3DSA:3.30.160.60:FF:004156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105158, NULL, 'G3DSA:2.30.29.30:FF:000051', NULL, NULL, 'Serine/threonine-protein phosphatase 4 regulatory subunit 3B', NULL, NULL, NULL, NULL, NULL, 4),
(105159, NULL, 'G3DSA:1.20.1070.10:FF:000001', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(105160, NULL, 'G3DSA:2.60.120.330:FF:000193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105161, NULL, 'G3DSA:3.10.100.10:FF:000101', NULL, NULL, 'C-type lectin domain family 12 member B', NULL, NULL, NULL, NULL, NULL, 4),
(105162, NULL, 'G3DSA:2.60.40.1170:FF:000062', NULL, NULL, 'Coatomer subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(105163, NULL, 'G3DSA:2.60.40.10:FF:005567', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105164, NULL, 'G3DSA:1.20.1250.20:FF:001288', NULL, NULL, 'Phthalate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105165, NULL, 'G3DSA:3.30.70.330:FF:001148', NULL, NULL, 'RNA recognition domain-containing protein (RRM)-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(105166, NULL, 'G3DSA:2.10.110.10:FF:000201', NULL, NULL, 'Transforming growth factor beta 1-induced transcript 1', NULL, NULL, NULL, NULL, NULL, 4),
(105167, NULL, 'G3DSA:3.30.160.60:FF:000845', NULL, NULL, 'C2H2 type conidiation transcription factor BrlA', NULL, NULL, NULL, NULL, NULL, 4),
(105168, NULL, 'G3DSA:2.60.120.20:FF:000002', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(105169, NULL, 'G3DSA:3.40.50.11380:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105170, NULL, 'G3DSA:1.10.150.20:FF:000221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105171, NULL, 'G3DSA:3.90.290.10:FF:000028', NULL, NULL, 'Fibrillin-1', NULL, NULL, NULL, NULL, NULL, 4),
(105172, NULL, 'G3DSA:2.70.70.10:FF:000026', NULL, NULL, 'Peptidase M23', NULL, NULL, NULL, NULL, NULL, 4),
(105173, NULL, 'G3DSA:1.10.290.10:FF:000009', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(105174, NULL, 'G3DSA:3.90.1410.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105175, NULL, 'G3DSA:1.10.287.1490:FF:000109', NULL, NULL, 'Viral A-type inclusion protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105176, NULL, 'G3DSA:2.30.30.400:FF:000001', NULL, NULL, 'Rho-dependent transcription termination (ROF)', NULL, NULL, NULL, NULL, NULL, 4),
(105177, NULL, 'G3DSA:3.40.50.2300:FF:001338', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105178, NULL, 'G3DSA:1.25.40.10:FF:002407', NULL, NULL, 'Os01g0959600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(105179, NULL, 'G3DSA:3.40.50.720:FF:000331', NULL, NULL, 'Retinol dehydrogenase 14 (All-trans/9-cis/11-cis)', NULL, NULL, NULL, NULL, NULL, 4),
(105180, NULL, 'G3DSA:2.40.10.10:FF:000440', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105181, NULL, 'G3DSA:1.10.10.1830:FF:000002', NULL, NULL, 'Putative siderophore biosysnthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(105182, NULL, 'G3DSA:3.40.50.1100:FF:000096', NULL, NULL, 'Related to cysteine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(105183, NULL, 'G3DSA:2.130.10.10:FF:002560', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(105184, NULL, 'G3DSA:1.25.40.10:FF:000266', NULL, NULL, 'Pentatricopeptide repeat domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(105185, NULL, 'G3DSA:3.30.40.10:FF:001266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105186, NULL, 'G3DSA:3.40.50.300:FF:006551', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(105187, NULL, 'G3DSA:3.30.160.60:FF:002026', NULL, NULL, 'Zinc finger protein 160', NULL, NULL, NULL, NULL, NULL, 4),
(105188, NULL, 'G3DSA:3.40.50.11370:FF:000011', NULL, NULL, 'Inositol-tetrakisphosphate 1-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(105189, NULL, 'G3DSA:4.10.1240.10:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105190, NULL, 'G3DSA:3.80.10.10:FF:001116', NULL, NULL, 'Toll-like receptor 7', NULL, NULL, NULL, NULL, NULL, 4),
(105191, NULL, 'G3DSA:1.10.730.10:FF:000151', NULL, NULL, 'Leucyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(105192, NULL, 'G3DSA:3.30.200.20:FF:000124', NULL, NULL, 'Cyclin-dependent kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(105193, NULL, 'G3DSA:3.90.70.200:FF:000022', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(105194, NULL, 'G3DSA:3.80.10.10:FF:001184', NULL, NULL, 'Acid labile subunit', NULL, NULL, NULL, NULL, NULL, 4),
(105195, NULL, 'G3DSA:3.30.200.20:FF:002248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105196, NULL, 'G3DSA:3.40.50.300:FF:007799', NULL, NULL, 'MutS domain V domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(105197, NULL, 'G3DSA:2.60.40.60:FF:000950', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(105198, NULL, 'G3DSA:2.20.70.10:FF:000113', NULL, NULL, 'Clustered-asparagine-rich protein', NULL, NULL, NULL, NULL, NULL, 4),
(105199, NULL, 'G3DSA:2.40.160.120:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105200, NULL, 'G3DSA:1.10.287.110:FF:000352', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105201, NULL, 'G3DSA:1.20.1250.20:FF:001552', NULL, NULL, 'MFS tranporter, putative (AFU_orthologue AFUA_7G06830)', NULL, NULL, NULL, NULL, NULL, 4),
(105202, NULL, 'G3DSA:3.40.50.170:FF:000003', NULL, NULL, 'Methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(105203, NULL, 'G3DSA:1.10.3430.10:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105204, NULL, 'G3DSA:2.170.270.10:FF:000208', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-9 specific', NULL, NULL, NULL, NULL, NULL, 4),
(105205, NULL, 'G3DSA:3.30.2170.10:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105206, NULL, 'G3DSA:3.90.70.10:FF:000793', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(105207, NULL, 'G3DSA:3.30.930.10:FF:000356', NULL, NULL, 'ATP phosphoribosyltransferase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(105208, NULL, 'G3DSA:3.60.15.10:FF:000021', NULL, NULL, 'Ribonuclease J', NULL, NULL, NULL, NULL, NULL, 4),
(105209, NULL, 'G3DSA:1.10.8.720:FF:000042', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(105210, NULL, 'G3DSA:3.40.50.300:FF:004308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105211, NULL, 'G3DSA:3.30.70.330:FF:001480', NULL, NULL, 'AGAP003170-PA', NULL, NULL, NULL, NULL, NULL, 4),
(105212, NULL, 'G3DSA:2.130.10.10:FF:002740', NULL, NULL, 'Katanin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105213, NULL, 'G3DSA:3.40.50.1000:FF:000712', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105214, NULL, 'G3DSA:2.60.120.10:FF:000297', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(105215, NULL, 'G3DSA:3.20.20.70:FF:000558', NULL, NULL, 'Fructose-bisphosphate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(105216, NULL, 'G3DSA:3.40.50.300:FF:004213', NULL, NULL, 'Protein CBR-MRP-3', NULL, NULL, NULL, NULL, NULL, 4),
(105217, NULL, 'G3DSA:1.10.3720.10:FF:000216', NULL, NULL, 'ABC transporter, permease protein, cysTW family', NULL, NULL, NULL, NULL, NULL, 4),
(105218, NULL, 'G3DSA:1.25.10.10:FF:002063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105219, NULL, 'G3DSA:1.20.1250.40:FF:000046', NULL, NULL, 'Peptide-receptor component', NULL, NULL, NULL, NULL, NULL, 4),
(105220, NULL, 'G3DSA:2.40.30.10:FF:000441', NULL, NULL, 'Elongation factor Tu', NULL, NULL, NULL, NULL, NULL, 4),
(105221, NULL, 'G3DSA:3.10.490.10:FF:000039', NULL, NULL, 'Gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(105222, NULL, 'G3DSA:3.40.50.12230:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105223, NULL, 'G3DSA:3.40.50.720:FF:001118', NULL, NULL, '6-phosphogluconate dehydrogenase, decarboxylating', NULL, NULL, NULL, NULL, NULL, 4),
(105224, NULL, 'G3DSA:1.10.510.10:FF:004271', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105225, NULL, 'G3DSA:3.10.100.10:FF:000163', NULL, NULL, 'Mannose binding lectin 2', NULL, NULL, NULL, NULL, NULL, 4),
(105226, NULL, 'G3DSA:1.10.510.10:FF:002085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105227, NULL, 'G3DSA:1.20.1070.10:FF:002125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105228, NULL, 'G3DSA:3.30.750.24:FF:000164', NULL, NULL, 'Sodium-independent sulfate anion transporter-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(105229, NULL, 'G3DSA:4.10.640.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105230, NULL, 'G3DSA:2.120.10.80:FF:000114', NULL, NULL, 'Kelch domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(105231, NULL, 'G3DSA:1.25.40.10:FF:004661', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105232, NULL, 'G3DSA:1.10.1370.20:FF:000001', NULL, NULL, 'Oligoendopeptidase F', NULL, NULL, NULL, NULL, NULL, 4),
(105233, NULL, 'G3DSA:3.10.20.90:FF:000800', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105234, NULL, 'G3DSA:1.10.132.60:FF:000045', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(105235, NULL, 'G3DSA:1.10.3480.10:FF:000001', NULL, NULL, 'Nitrate reductase molybdenum cofactor assembly chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(105236, NULL, 'G3DSA:2.30.180.10:FF:000195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105237, NULL, 'G3DSA:3.20.20.10:FF:000063', NULL, NULL, 'Pyridoxal phosphate homeostasis protein', NULL, NULL, NULL, NULL, NULL, 4),
(105238, NULL, 'G3DSA:2.60.40.10:FF:002762', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105239, NULL, 'G3DSA:1.10.1450.10:FF:000083', NULL, NULL, 'TetraSPanin family', NULL, NULL, NULL, NULL, NULL, 4),
(105240, NULL, 'G3DSA:2.60.40.10:FF:002705', NULL, NULL, 'von Willebrand factor A domain containing 1', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(105241, NULL, 'G3DSA:2.40.40.20:FF:000063', NULL, NULL, 'NADH dehydrogenase I, G subunit', NULL, NULL, NULL, NULL, NULL, 4),
(105242, NULL, 'G3DSA:1.10.238.200:FF:000027', NULL, NULL, 'DCN1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(105243, NULL, 'G3DSA:3.30.160.60:FF:006455', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105244, NULL, 'G3DSA:1.25.40.70:FF:000082', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(105245, NULL, 'G3DSA:1.25.40.10:FF:002295', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(105246, NULL, 'G3DSA:3.90.1480.20:FF:000023', NULL, NULL, 'ST6 (alpha-N-acetyl-neuraminyl-2,3-beta-galactosyl-1,3)-N-acetylgalactosaminide alpha-2,6-sialyltransferase 6', NULL, NULL, NULL, NULL, NULL, 4),
(105247, NULL, 'G3DSA:1.10.730.10:FF:000212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105248, NULL, 'G3DSA:2.170.150.80:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105249, NULL, 'G3DSA:2.60.40.10:FF:000553', NULL, NULL, 'Uncharacterized protein, isoform J', NULL, NULL, NULL, NULL, NULL, 4),
(105250, NULL, 'G3DSA:1.20.5.190:FF:000178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105251, NULL, 'G3DSA:3.40.50.1480:FF:000013', NULL, NULL, 'Adenosylhomocysteinase', NULL, NULL, NULL, NULL, NULL, 4),
(105252, NULL, 'G3DSA:3.30.500.10:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105253, NULL, 'G3DSA:3.10.580.20:FF:000010', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(105254, NULL, 'G3DSA:1.10.10.60:FF:000520', NULL, NULL, 'homeobox protein VENTX', NULL, NULL, NULL, NULL, NULL, 4),
(105255, NULL, 'G3DSA:3.40.605.10:FF:000082', NULL, NULL, 'Succinate-semialdehyde dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(105256, NULL, 'G3DSA:1.10.287.70:FF:000699', NULL, NULL, 'Voltage-dependent N-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(105257, NULL, 'G3DSA:1.10.238.10:FF:000708', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105258, NULL, 'G3DSA:3.30.160.60:FF:000492', NULL, NULL, 'Zinc finger and BTB domain containing 10', NULL, NULL, NULL, NULL, NULL, 4),
(105259, NULL, 'G3DSA:3.90.550.50:FF:000027', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(105260, NULL, 'G3DSA:3.30.559.30:FF:000077', NULL, NULL, 'Nonribosomal peptide synthase nlsA', NULL, NULL, NULL, NULL, NULL, 4),
(105261, NULL, 'G3DSA:1.10.630.10:FF:000727', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105262, NULL, 'G3DSA:3.90.1140.10:FF:000039', NULL, NULL, 'DUF455 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(105263, NULL, 'G3DSA:2.30.30.40:FF:000309', NULL, NULL, 'Purine-binding chemotaxis protein CheW', NULL, NULL, NULL, NULL, NULL, 4),
(105264, NULL, 'G3DSA:3.20.20.70:FF:000715', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105265, NULL, 'G3DSA:3.40.50.1470:FF:000010', NULL, NULL, 'CRS2-like protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(105266, NULL, 'G3DSA:1.10.510.10:FF:000960', NULL, NULL, 'Protein CBG19102', NULL, NULL, NULL, NULL, NULL, 4),
(105267, NULL, 'G3DSA:2.60.120.260:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105268, NULL, 'G3DSA:1.20.1070.10:FF:001193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105269, NULL, 'G3DSA:1.20.1070.10:FF:001136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105270, NULL, 'G3DSA:3.30.40.10:FF:001446', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(105271, NULL, 'G3DSA:1.10.1200.10:FF:000065', NULL, NULL, 'Peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(105272, NULL, 'G3DSA:2.60.40.10:FF:000339', NULL, NULL, 'Plexin A2', NULL, NULL, NULL, NULL, NULL, 4),
(105273, NULL, 'G3DSA:3.90.76.10:FF:000019', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(105274, NULL, 'G3DSA:2.30.29.30:FF:001186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105275, NULL, 'G3DSA:1.10.472.130:FF:000022', NULL, NULL, 'Dynein heavy chain 6, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(105276, NULL, 'G3DSA:3.30.200.20:FF:000770', NULL, NULL, 'SRSF protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(105277, NULL, 'G3DSA:2.130.10.10:FF:002622', NULL, NULL, 'WD40 repeat-containing protein DDB_G0271002', NULL, NULL, NULL, NULL, NULL, 4),
(105278, NULL, 'G3DSA:3.40.30.10:FF:000489', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105279, NULL, 'G3DSA:2.40.30.10:FF:000065', NULL, NULL, '50S ribosomal protein L3, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(105280, NULL, 'G3DSA:2.30.29.30:FF:000579', NULL, NULL, 'Kinesin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105281, NULL, 'G3DSA:1.10.510.10:FF:002646', NULL, NULL, 'Serine/threonine-protein kinase chk-2', NULL, NULL, NULL, NULL, NULL, 4),
(105282, NULL, 'G3DSA:3.40.190.10:FF:000223', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(105283, NULL, 'G3DSA:1.25.10.10:FF:000343', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(105284, NULL, 'G3DSA:1.10.540.10:FF:000057', NULL, NULL, 'L-prolyl-[peptidyl carrier protein] dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(105285, NULL, 'G3DSA:2.60.40.10:FF:000396', NULL, NULL, 'Fibronectin type III domain containing 3B', NULL, NULL, NULL, NULL, NULL, 4),
(105286, NULL, 'G3DSA:2.130.10.10:FF:000531', NULL, NULL, 'Probable catabolite repression protein creC', NULL, NULL, NULL, NULL, NULL, 4),
(105287, NULL, 'G3DSA:3.30.420.10:FF:000598', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105288, NULL, 'G3DSA:1.20.1070.10:FF:002030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105289, NULL, 'G3DSA:1.20.1310.10:FF:000216', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105290, NULL, 'G3DSA:1.10.1600.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105291, NULL, 'G3DSA:3.40.50.300:FF:000503', NULL, NULL, 'Peptide chain release factor subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(105292, NULL, 'G3DSA:3.80.10.10:FF:001392', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', NULL, NULL, NULL, NULL, NULL, 4),
(105293, NULL, 'G3DSA:1.25.40.10:FF:000058', NULL, NULL, 'Pre-mRNA processing factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(105294, NULL, 'G3DSA:3.30.160.150:FF:000001', NULL, NULL, 'LPS-assembly lipoprotein LptE', NULL, NULL, NULL, NULL, NULL, 4),
(105295, NULL, 'G3DSA:2.60.120.10:FF:000584', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(105296, NULL, 'G3DSA:3.40.50.300:FF:004831', NULL, NULL, 'YALI0F04356p', NULL, NULL, NULL, NULL, NULL, 4),
(105297, NULL, 'G3DSA:2.60.40.1510:FF:000035', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(105298, NULL, 'G3DSA:2.30.30.40:FF:000366', NULL, NULL, 'LIM and SH3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(105299, NULL, 'G3DSA:3.30.160.60:FF:000435', NULL, NULL, 'Zinc finger protein 827', NULL, NULL, NULL, NULL, NULL, 4),
(105300, NULL, 'G3DSA:2.30.42.10:FF:000244', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(105301, NULL, 'G3DSA:2.130.10.10:FF:002329', NULL, NULL, 'p21-activated protein kinase-interacting protein 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(105302, NULL, 'G3DSA:1.10.3210.10:FF:000122', NULL, NULL, 'Putative GTP diphosphokinase RSH2 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(105303, NULL, 'G3DSA:1.10.533.10:FF:000024', NULL, NULL, 'caspase-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(105304, NULL, 'G3DSA:3.30.70.330:FF:002704', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105305, NULL, 'G3DSA:3.40.50.300:FF:002386', NULL, NULL, 'Similar to mitochondrial ATPase (Afg1)', NULL, NULL, NULL, NULL, NULL, 4),
(105306, NULL, 'G3DSA:1.25.40.10:FF:002418', NULL, NULL, 'Pre-mRNA-processing factor 6-like Protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(105307, NULL, 'G3DSA:1.10.510.10:FF:002028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105308, NULL, 'G3DSA:3.30.200.20:FF:000562', NULL, NULL, 'STE20/SPS1-related proline-alanine-rich protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(105309, NULL, 'G3DSA:2.60.40.150:FF:000129', NULL, NULL, 'Synaptotagmin 12', NULL, NULL, NULL, NULL, NULL, 4),
(105310, NULL, 'G3DSA:2.10.25.10:FF:001425', NULL, NULL, 'mannan-binding lectin serine protease 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(105311, NULL, 'G3DSA:3.20.20.300:FF:000030', NULL, NULL, 'Os05g0449600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(105312, NULL, 'G3DSA:1.10.506.10:FF:000057', NULL, NULL, 'Probable Ras GTPase-activating-like protein ngap', NULL, NULL, NULL, NULL, NULL, 4),
(105313, NULL, 'G3DSA:3.40.50.1820:FF:000778', NULL, NULL, 'Esterase/lipase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(105314, NULL, 'G3DSA:3.30.1640.10:FF:000030', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(105315, NULL, 'G3DSA:1.25.40.10:FF:004032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105316, NULL, 'G3DSA:3.90.740.10:FF:000018', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(105317, NULL, 'G3DSA:1.20.5.110:FF:000166', NULL, NULL, 'BAP31 domain protein, putative (AFU_orthologue AFUA_1G14780)', NULL, NULL, NULL, NULL, NULL, 4),
(105318, NULL, 'G3DSA:1.10.1450.10:FF:000049', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(105319, NULL, 'G3DSA:2.130.10.10:FF:004090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105320, NULL, 'G3DSA:1.20.1280.290:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105321, NULL, 'G3DSA:3.20.20.80:FF:000595', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(105322, NULL, 'G3DSA:3.40.50.300:FF:006630', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105323, NULL, 'G3DSA:3.60.21.10:FF:000473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105324, NULL, 'G3DSA:3.90.740.10:FF:000075', NULL, NULL, 'Valyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(105325, NULL, 'G3DSA:3.80.10.10:FF:001745', NULL, NULL, 'Os04g0675800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(105326, NULL, 'G3DSA:1.20.1250.20:FF:001563', NULL, NULL, 'Solute carrier family 22 member 18', NULL, NULL, NULL, NULL, NULL, 4),
(105327, NULL, 'G3DSA:1.10.420.10:FF:000048', NULL, NULL, 'Os01g0378100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(105328, NULL, 'G3DSA:1.10.10.10:FF:000078', NULL, NULL, 'Transcriptional regulator AsnC', NULL, NULL, NULL, NULL, NULL, 4),
(105329, NULL, 'G3DSA:1.25.40.10:FF:003756', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105330, NULL, 'G3DSA:3.30.70.2740:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105331, NULL, 'G3DSA:1.25.40.10:FF:000619', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(105332, NULL, 'G3DSA:3.20.20.70:FF:000592', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105333, NULL, 'G3DSA:1.10.760.10:FF:000040', NULL, NULL, 'Probable cytochrome c', NULL, NULL, NULL, NULL, NULL, 4),
(105334, NULL, 'G3DSA:3.40.50.300:FF:008428', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105335, NULL, 'G3DSA:3.30.420.340:FF:000011', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4),
(105336, NULL, 'G3DSA:1.25.10.10:FF:002681', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105337, NULL, 'G3DSA:1.10.8.60:FF:000289', NULL, NULL, 'Transcriptional regulator TyrR', NULL, NULL, NULL, NULL, NULL, 4),
(105338, NULL, 'G3DSA:2.60.40.740:FF:000003', NULL, NULL, 'Cell surface antigen I/II', NULL, NULL, NULL, NULL, NULL, 4),
(105339, NULL, 'G3DSA:2.60.40.10:FF:002077', NULL, NULL, 'TWiK family of potassium channels', NULL, NULL, NULL, NULL, NULL, 4),
(105340, NULL, 'G3DSA:1.10.3090.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(105341, NULL, 'G3DSA:3.50.7.10:FF:000021', NULL, NULL, 'Bardet-Biedl syndrome 12 protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(105342, NULL, 'G3DSA:2.60.40.10:FF:000519', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(105343, NULL, 'G3DSA:2.40.100.10:FF:000098', NULL, NULL, 'Cyclophilin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105344, NULL, 'G3DSA:3.30.200.20:FF:001467', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(105345, NULL, 'G3DSA:1.10.472.10:FF:000275', NULL, NULL, 'CYCLIN B15', NULL, NULL, NULL, NULL, NULL, 4),
(105346, NULL, 'G3DSA:2.130.10.10:FF:002386', NULL, NULL, 'Uncharacterized WD repeat-containing protein YOL087C', NULL, NULL, NULL, NULL, NULL, 4),
(105347, NULL, 'G3DSA:3.20.20.450:FF:000001', NULL, NULL, 'Cyclic di-GMP phosphodiesterase yahA', NULL, NULL, NULL, NULL, NULL, 4),
(105348, NULL, 'G3DSA:1.10.10.60:FF:000930', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105349, NULL, 'G3DSA:1.20.58.80:FF:000006', NULL, NULL, 'Spastin', NULL, NULL, NULL, NULL, NULL, 4),
(105350, NULL, 'G3DSA:3.90.1810.10:FF:000001', NULL, NULL, 'Outer capsid protein lambda-2', NULL, NULL, NULL, NULL, NULL, 4),
(105351, NULL, 'G3DSA:1.10.510.10:FF:000229', NULL, NULL, 'Serine/threonine-protein kinase cot-1', NULL, NULL, NULL, NULL, NULL, 4),
(105352, NULL, 'G3DSA:3.80.10.10:FF:002021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105353, NULL, 'G3DSA:2.60.40.10:FF:000839', NULL, NULL, 'granulocyte colony-stimulating factor receptor isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(105354, NULL, 'G3DSA:3.30.830.10:FF:000067', NULL, NULL, 'Ubiquinol-cytochrome c reductase complex core protein 2 (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(105355, NULL, 'G3DSA:2.40.10.220:FF:000003', NULL, NULL, 'Alginate biosynthesis protein Alg44', NULL, NULL, NULL, NULL, NULL, 4),
(105356, NULL, 'G3DSA:3.40.50.2000:FF:000967', NULL, NULL, 'ADP-heptose--lipopolysaccharide heptosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105357, NULL, 'G3DSA:3.30.200.20:FF:002361', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105358, NULL, 'G3DSA:3.30.420.40:FF:000551', NULL, NULL, 'Actin', NULL, NULL, NULL, NULL, NULL, 4),
(105359, NULL, 'G3DSA:2.120.10.30:FF:000554', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105360, NULL, 'G3DSA:1.10.1300.10:FF:000050', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(105361, NULL, 'G3DSA:2.130.10.10:FF:003757', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105362, NULL, 'G3DSA:2.60.40.1700:FF:000002', NULL, NULL, 'Peptidyl arginine deiminase 6', NULL, NULL, NULL, NULL, NULL, 4),
(105363, NULL, 'G3DSA:2.30.29.30:FF:001394', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105364, NULL, 'G3DSA:1.10.472.10:FF:000011', NULL, NULL, 'Cyclin-Y isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(105365, NULL, 'G3DSA:1.10.238.10:FF:000355', NULL, NULL, 'Uncharacterized calcium-binding protein B0563.7', NULL, NULL, NULL, NULL, NULL, 4),
(105366, NULL, 'G3DSA:2.60.40.150:FF:000461', NULL, NULL, 'C2 calcium/lipid-binding plant phosphoribosyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(105367, NULL, 'G3DSA:1.10.238.10:FF:001203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105368, NULL, 'G3DSA:3.40.50.11380:FF:000003', NULL, NULL, 'probable UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SEC', NULL, NULL, NULL, NULL, NULL, 4),
(105369, NULL, 'G3DSA:3.40.50.2300:FF:001395', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105370, NULL, 'G3DSA:3.40.50.300:FF:000711', NULL, NULL, 'Si:dkey-27n6.1', NULL, NULL, NULL, NULL, NULL, 4),
(105371, NULL, 'G3DSA:3.30.450.200:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105372, NULL, 'G3DSA:1.10.418.10:FF:000133', NULL, NULL, 'Plectin b', NULL, NULL, NULL, NULL, NULL, 4),
(105373, NULL, 'G3DSA:3.80.10.10:FF:001127', NULL, NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g06840', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(105374, NULL, 'G3DSA:3.30.360.10:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105375, NULL, 'G3DSA:3.20.20.70:FF:000479', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105376, NULL, 'G3DSA:1.25.40.20:FF:000499', NULL, NULL, 'Wide awake, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(105377, NULL, 'G3DSA:1.25.40.20:FF:000269', NULL, NULL, 'caseinolytic peptidase B protein homolog isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(105378, NULL, 'G3DSA:3.40.30.10:FF:000782', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(105379, NULL, 'G3DSA:3.40.50.1820:FF:000036', NULL, NULL, 'Alpha/beta-Hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(105380, NULL, 'G3DSA:3.30.800.10:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105381, NULL, 'G3DSA:2.60.40.60:FF:000540', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105382, NULL, 'G3DSA:3.10.20.90:FF:000626', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(105383, NULL, 'G3DSA:3.30.70.330:FF:001648', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105384, NULL, 'G3DSA:3.40.50.150:FF:000531', NULL, NULL, 'Glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(105385, NULL, 'G3DSA:3.40.50.150:FF:000817', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105386, NULL, 'G3DSA:1.10.30.10:FF:000080', NULL, NULL, 'ARS-binding factor', NULL, NULL, NULL, NULL, NULL, 4),
(105387, NULL, 'G3DSA:2.60.40.150:FF:000747', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105388, NULL, 'G3DSA:3.40.630.30:FF:000657', NULL, NULL, 'Acteyltransferase GNAT family', NULL, NULL, NULL, NULL, NULL, 4),
(105389, NULL, 'G3DSA:1.25.40.1030:FF:000047', NULL, NULL, 'Protein transport protein SEC31 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(105390, NULL, 'G3DSA:2.60.40.10:FF:000632', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(105391, NULL, 'G3DSA:3.30.160.60:FF:005792', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105392, NULL, 'G3DSA:3.40.640.10:FF:000270', NULL, NULL, 'Aminotransferase, class V family', NULL, NULL, NULL, NULL, NULL, 4),
(105393, NULL, 'G3DSA:1.10.510.10:FF:000286', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 1 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(105394, NULL, 'G3DSA:1.10.10.10:FF:000819', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(105395, NULL, 'G3DSA:2.170.270.10:FF:000129', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(105396, NULL, 'G3DSA:1.10.10.60:FF:000037', NULL, NULL, 'chromodomain-helicase-DNA-binding protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(105397, NULL, 'G3DSA:3.10.490.10:FF:000028', NULL, NULL, 'Gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(105398, NULL, 'G3DSA:3.30.870.10:FF:000064', NULL, NULL, 'Phospholipase D, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105399, NULL, 'G3DSA:1.10.287.70:FF:000778', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105400, NULL, 'G3DSA:3.30.310.50:FF:000028', NULL, NULL, 'Phosphoglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(105401, NULL, 'G3DSA:3.10.310.10:FF:000021', NULL, NULL, 'Diaminopimelate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(105402, NULL, 'G3DSA:3.90.1150.10:FF:000208', NULL, NULL, 'Probable aminotransferase gliI', NULL, NULL, NULL, NULL, NULL, 4),
(105403, NULL, 'G3DSA:4.10.60.10:FF:000170', NULL, NULL, 'Zinc knuckle domain protein (Byr3), putative', NULL, NULL, NULL, NULL, NULL, 4),
(105404, NULL, 'G3DSA:4.10.640.10:FF:000025', NULL, NULL, '30S ribosomal protein S18', NULL, NULL, NULL, NULL, NULL, 4),
(105405, NULL, 'G3DSA:1.20.870.10:FF:000052', NULL, NULL, 'Rap guanine nucleotide exchange factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(105406, NULL, 'G3DSA:3.30.70.330:FF:002143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(105407, NULL, 'G3DSA:3.10.110.10:FF:000045', NULL, NULL, 'Ubiquitin conjugating enzyme E2 O', NULL, NULL, NULL, NULL, NULL, 4),
(105408, NULL, 'G3DSA:1.10.132.60:FF:000006', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(105409, NULL, 'G3DSA:1.10.3720.10:FF:000205', NULL, NULL, 'Spermidine/putrescine transport system permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(105410, NULL, 'G3DSA:2.60.40.150:FF:000540', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105411, NULL, 'G3DSA:3.40.50.200:FF:000119', NULL, NULL, 'Clan SB, family S8, subtilisin-like serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(105412, NULL, 'G3DSA:2.60.200.20:FF:000121', NULL, NULL, 'FHA domain/Ring finger domain/Zinc finger, C3HC4 type (RING finger) containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105413, NULL, 'G3DSA:3.40.50.300:FF:006276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105414, NULL, 'G3DSA:3.30.70.1400:FF:000008', NULL, NULL, 'Putative aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(105415, NULL, 'G3DSA:1.20.50.20:FF:000004', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(105416, NULL, 'G3DSA:1.10.10.2660:FF:000032', NULL, NULL, 'ThiF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(105417, NULL, 'G3DSA:2.130.10.10:FF:000941', NULL, NULL, 'WD repeat domain 75', NULL, NULL, NULL, NULL, NULL, 4),
(105418, NULL, 'G3DSA:2.130.10.10:FF:000048', NULL, NULL, 'semaphorin-5B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(105419, NULL, 'G3DSA:1.10.132.50:FF:000003', NULL, NULL, 'V-type proton ATPase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(105420, NULL, 'G3DSA:1.10.510.10:FF:004260', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105421, NULL, 'G3DSA:3.30.70.20:FF:000023', NULL, NULL, 'Dihydropyrimidine dehydrogenase [NADP(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(105422, NULL, 'G3DSA:3.30.160.60:FF:001008', NULL, NULL, 'transcriptional regulator Kaiso isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(105423, NULL, 'G3DSA:2.30.180.10:FF:000156', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105424, NULL, 'G3DSA:3.30.70.1150:FF:000001', NULL, NULL, 'Acetolactate synthase small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(105425, NULL, 'G3DSA:3.65.10.10:FF:000027', NULL, NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(105426, NULL, 'G3DSA:3.90.79.10:FF:000223', NULL, NULL, 'Protein CBR-ECH-5', NULL, NULL, NULL, NULL, NULL, 4),
(105427, NULL, 'G3DSA:1.10.238.10:FF:000630', NULL, NULL, 'BnaC05g51860D protein', NULL, NULL, NULL, NULL, NULL, 4),
(105428, NULL, 'G3DSA:3.40.50.1000:FF:000358', NULL, NULL, 'haloacid dehalogenase-like hydrolase domain-containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(105429, NULL, 'G3DSA:3.40.47.10:FF:000207', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105430, NULL, 'G3DSA:3.90.1750.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105431, NULL, 'G3DSA:3.40.50.150:FF:000256', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(105432, NULL, 'G3DSA:1.20.120.720:FF:000050', NULL, NULL, 'Chitin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(105433, NULL, 'G3DSA:2.60.40.150:FF:000186', NULL, NULL, 'Protein BONZAI 3', NULL, NULL, NULL, NULL, NULL, 4),
(105434, NULL, 'G3DSA:3.10.580.10:FF:000209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105435, NULL, 'G3DSA:3.50.50.60:FF:000061', NULL, NULL, 'Dihydropyrimidine dehydrogenase [NADP(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(105436, NULL, 'G3DSA:3.40.50.300:FF:002509', NULL, NULL, 'ABC transporter ATP-binding protein YtrE', NULL, NULL, NULL, NULL, NULL, 4),
(105437, NULL, 'G3DSA:1.10.510.10:FF:001123', NULL, NULL, 'CK1/CK1/CK1-D protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(105438, NULL, 'G3DSA:3.30.70.20:FF:000080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105439, NULL, 'G3DSA:1.50.40.10:FF:000584', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(105440, NULL, 'G3DSA:3.40.50.720:FF:000101', NULL, NULL, 'GDP-L-fucose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(105441, NULL, 'G3DSA:1.20.1560.10:FF:000836', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105442, NULL, 'G3DSA:1.10.10.10:FF:000612', NULL, NULL, 'RNA polymerase sigma factor FecI', NULL, NULL, NULL, NULL, NULL, 4),
(105443, NULL, 'G3DSA:3.30.160.60:FF:005999', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105444, NULL, 'G3DSA:3.40.50.300:FF:000941', NULL, NULL, 'Werner syndrome RecQ like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(105445, NULL, 'G3DSA:3.40.50.300:FF:003403', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(105446, NULL, 'G3DSA:3.40.50.300:FF:004718', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(105447, NULL, 'G3DSA:3.30.1370.10:FF:000115', NULL, NULL, 'Scp160p', NULL, NULL, NULL, NULL, NULL, 4),
(105448, NULL, 'G3DSA:3.30.710.10:FF:000412', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(105449, NULL, 'G3DSA:1.25.40.10:FF:004650', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105450, NULL, 'G3DSA:1.10.510.10:FF:000847', NULL, NULL, 'SCY1 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(105451, NULL, 'G3DSA:1.10.472.130:FF:000090', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(105452, NULL, 'G3DSA:3.30.40.10:FF:000018', NULL, NULL, 'Synaptotagmin-like 5, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(105453, NULL, 'G3DSA:1.10.472.130:FF:000033', NULL, NULL, 'Dynein, axonemal, heavy chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(105454, NULL, 'G3DSA:1.20.120.1790:FF:000001', NULL, NULL, 'roquin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(105455, NULL, 'G3DSA:3.40.1810.10:FF:000086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105456, NULL, 'G3DSA:2.40.10.10:FF:000232', NULL, NULL, 'Serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(105457, NULL, 'G3DSA:3.10.20.80:FF:000005', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(105458, NULL, 'G3DSA:2.10.25.10:FF:001083', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(105459, NULL, 'G3DSA:2.40.20.10:FF:000058', NULL, NULL, 'Lipoprotein(a)', NULL, NULL, NULL, NULL, NULL, 4),
(105460, NULL, 'G3DSA:2.60.40.10:FF:004561', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105461, NULL, 'G3DSA:3.40.525.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105462, NULL, 'G3DSA:1.20.1070.10:FF:001125', NULL, NULL, 'D(5)-like dopamine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(105463, NULL, 'G3DSA:3.30.70.980:FF:000073', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(105464, NULL, 'G3DSA:3.40.630.10:FF:000033', NULL, NULL, 'M17 leucyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(105465, NULL, 'G3DSA:3.30.1520.10:FF:000032', NULL, NULL, 'Sorting nexin 8', NULL, NULL, NULL, NULL, NULL, 4),
(105466, NULL, 'G3DSA:1.10.287.110:FF:000239', NULL, NULL, 'DnaJ domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(105467, NULL, 'G3DSA:3.10.20.70:FF:000002', NULL, NULL, 'Glutamine synthetase I', NULL, NULL, NULL, NULL, NULL, 4),
(105468, NULL, 'G3DSA:3.90.550.50:FF:000016', NULL, NULL, 'C1GALT1-specific chaperone 1', NULL, NULL, NULL, NULL, NULL, 4),
(105469, NULL, 'G3DSA:3.30.70.870:FF:000039', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(105470, NULL, 'G3DSA:3.40.525.10:FF:000013', NULL, NULL, 'Phosphatidylinositol transfer protein PDR16', NULL, NULL, NULL, NULL, NULL, 4),
(105471, NULL, 'G3DSA:3.30.1600.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105472, NULL, 'G3DSA:3.30.200.20:FF:000332', NULL, NULL, 'NIMA related kinase 11', NULL, NULL, NULL, NULL, NULL, 4),
(105473, NULL, 'G3DSA:1.20.140.150:FF:000068', NULL, NULL, 'P53 apoptosis effector-related to pmp22', NULL, NULL, NULL, NULL, NULL, 4),
(105474, NULL, 'G3DSA:3.30.160.60:FF:002565', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(105475, NULL, 'G3DSA:4.10.60.10:FF:000018', NULL, NULL, 'Splicing factor, arginine/serine-rich 7', NULL, NULL, NULL, NULL, NULL, 4),
(105476, NULL, 'G3DSA:1.10.8.60:FF:000564', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(105477, NULL, 'G3DSA:3.40.30.10:FF:001220', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(105478, NULL, 'G3DSA:1.25.10.10:FF:000382', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(105479, NULL, 'G3DSA:2.60.40.10:FF:002352', NULL, NULL, 'Blast:Protein sidekick', NULL, NULL, NULL, NULL, NULL, 4),
(105480, NULL, 'G3DSA:3.90.1140.10:FF:000028', NULL, NULL, 'RNA 2'',3''-cyclic phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(105481, NULL, 'G3DSA:2.30.30.380:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105482, NULL, 'G3DSA:3.30.1370.100:FF:000015', NULL, NULL, 'DNA mismatch repair protein PMS1', NULL, NULL, NULL, NULL, NULL, 4),
(105483, NULL, 'G3DSA:3.40.800.10:FF:000030', NULL, NULL, 'Agmatinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(105484, NULL, 'G3DSA:3.40.50.300:FF:004713', NULL, NULL, 'Ras-related protein RABG3a', NULL, NULL, NULL, NULL, NULL, 4),
(105485, NULL, 'G3DSA:1.10.287.550:FF:000012', NULL, NULL, 'Arylsulfatase E', NULL, NULL, NULL, NULL, NULL, 4),
(105486, NULL, 'G3DSA:3.90.70.10:FF:000293', NULL, NULL, 'WGS project CABT00000000 data, contig 2.33', NULL, NULL, NULL, NULL, NULL, 4),
(105487, NULL, 'G3DSA:2.130.10.10:FF:005882', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105488, NULL, 'G3DSA:3.40.190.10:FF:000285', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(105489, NULL, 'G3DSA:3.40.630.10:FF:000325', NULL, NULL, 'Glutamate carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105490, NULL, 'G3DSA:3.40.47.10:FF:000202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105491, NULL, 'G3DSA:2.60.40.10:FF:005859', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105492, NULL, 'G3DSA:2.60.40.10:FF:003768', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105493, NULL, 'G3DSA:3.60.20.10:FF:000100', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(105494, NULL, 'G3DSA:3.30.70.1230:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105495, NULL, 'G3DSA:2.30.30.40:FF:000310', NULL, NULL, 'Actin polymerization protein Bzz1', NULL, NULL, NULL, NULL, NULL, 4),
(105496, NULL, 'G3DSA:3.30.390.170:FF:000002', NULL, NULL, 'Envelope glycoprotein L', NULL, NULL, NULL, NULL, NULL, 4),
(105497, NULL, 'G3DSA:2.60.40.10:FF:002138', NULL, NULL, 'Uncharacterized protein YeeJ', NULL, NULL, NULL, NULL, NULL, 4),
(105498, NULL, 'G3DSA:1.20.1280.50:FF:000107', NULL, NULL, 'JmjC domain-containing histone demethylation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(105499, NULL, 'G3DSA:3.90.1140.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105500, NULL, 'G3DSA:3.30.2160.10:FF:000010', NULL, NULL, 'E3 ubiquitin-protein ligase HERC2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(105501, NULL, 'G3DSA:2.10.25.10:FF:001346', NULL, NULL, 'Notch homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(105502, NULL, 'G3DSA:2.60.120.10:FF:000292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105503, NULL, 'G3DSA:2.170.270.10:FF:000242', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(105504, NULL, 'G3DSA:2.60.200.10:FF:000005', NULL, NULL, 'Interferon regulatory factor 4 deltaE6', NULL, NULL, NULL, NULL, NULL, 4),
(105505, NULL, 'G3DSA:3.80.10.10:FF:000104', NULL, NULL, 'Tubulin-specific chaperone cofactor E-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(105506, NULL, 'G3DSA:3.40.50.300:FF:002622', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(105507, NULL, 'G3DSA:2.40.10.10:FF:000619', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105508, NULL, 'G3DSA:1.20.1270.220:FF:000007', NULL, NULL, 'Bromodomain factor', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(105509, NULL, 'G3DSA:2.60.40.60:FF:000489', NULL, NULL, 'Cadherin 17', NULL, NULL, NULL, NULL, NULL, 4),
(105510, NULL, 'G3DSA:3.40.1090.10:FF:000119', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(105511, NULL, 'G3DSA:3.40.50.1980:FF:000011', NULL, NULL, 'Histidinol dehydrogenase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(105512, NULL, 'G3DSA:3.30.1010.10:FF:000010', NULL, NULL, 'serine/threonine-protein kinase SMG1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(105513, NULL, 'G3DSA:1.50.40.10:FF:000258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105514, NULL, 'G3DSA:2.40.70.10:FF:000005', NULL, NULL, 'DNA damage inducible 1 homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(105515, NULL, 'G3DSA:3.90.550.50:FF:000061', NULL, NULL, 'AT4g00300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(105516, NULL, 'G3DSA:3.40.50.410:FF:000002', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(105517, NULL, 'G3DSA:2.70.98.20:FF:000037', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(105518, NULL, 'G3DSA:3.30.1640.10:FF:000092', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(105519, NULL, 'G3DSA:1.20.1250.20:FF:001737', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105520, NULL, 'G3DSA:1.25.40.10:FF:004094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105521, NULL, 'G3DSA:2.60.40.10:FF:004229', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105522, NULL, 'G3DSA:3.80.10.10:FF:003870', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105523, NULL, 'G3DSA:3.30.200.20:FF:002243', NULL, NULL, 'Pregnancy up-regulated nonubiquitous CaM kinase', NULL, NULL, NULL, NULL, NULL, 4),
(105524, NULL, 'G3DSA:3.40.50.10810:FF:000271', NULL, NULL, 'SNF2/RAD54 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(105525, NULL, 'G3DSA:3.90.70.10:FF:000411', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105526, NULL, 'G3DSA:3.30.70.330:FF:000400', NULL, NULL, 'Negative regulator of differentiation 1', NULL, NULL, NULL, NULL, NULL, 4),
(105527, NULL, 'G3DSA:3.50.50.60:FF:000229', NULL, NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(105528, NULL, 'G3DSA:1.10.1130.10:FF:000008', NULL, NULL, 'Nitrite reductase (cytochrome; ammonia-forming)', NULL, NULL, NULL, NULL, NULL, 4),
(105529, NULL, 'G3DSA:3.30.70.330:FF:001923', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105530, NULL, 'G3DSA:3.40.50.300:FF:008024', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(105531, NULL, 'G3DSA:1.20.120.140:FF:000022', NULL, NULL, 'Signal recognition particle receptor FtsY', NULL, NULL, NULL, NULL, NULL, 4),
(105532, NULL, 'G3DSA:2.70.98.10:FF:000034', NULL, NULL, 'Aldose 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(105533, NULL, 'G3DSA:3.30.200.20:FF:001349', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(105534, NULL, 'G3DSA:3.40.50.300:FF:001043', NULL, NULL, 'ciliogenesis and planar polarity effector 2', NULL, NULL, NULL, NULL, NULL, 4),
(105535, NULL, 'G3DSA:3.40.30.10:FF:000725', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105536, NULL, 'G3DSA:1.20.920.20:FF:000025', NULL, NULL, 'Dynein gamma chain, flagellar outer arm', NULL, NULL, NULL, NULL, NULL, 4),
(105537, NULL, 'G3DSA:2.130.10.10:FF:002116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105538, NULL, 'G3DSA:2.160.20.10:FF:000165', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(105539, NULL, 'G3DSA:3.30.420.40:FF:001040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105540, NULL, 'G3DSA:3.40.50.450:FF:000059', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(105541, NULL, 'G3DSA:2.170.150.20:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105542, NULL, 'G3DSA:2.170.150.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(105543, NULL, 'G3DSA:2.20.80.10:FF:000001', NULL, NULL, 'Vitellogenin 7', NULL, NULL, NULL, NULL, NULL, 4),
(105544, NULL, 'G3DSA:3.30.160.60:FF:002801', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105545, NULL, 'G3DSA:1.10.3080.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105546, NULL, 'G3DSA:1.10.1070.11:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105547, NULL, 'G3DSA:3.30.70.330:FF:000018', NULL, NULL, 'Polypyrimidine tract-binding protein 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(105548, NULL, 'G3DSA:3.10.580.10:FF:000187', NULL, NULL, 'Cysteine synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105549, NULL, 'G3DSA:3.30.830.10:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105550, NULL, 'G3DSA:3.10.450.120:FF:000006', NULL, NULL, 'Conserved protein with predicted RNA binding PUA domain', NULL, NULL, NULL, NULL, NULL, 4),
(105551, NULL, 'G3DSA:2.130.10.10:FF:003639', NULL, NULL, 'Gll0893 protein', NULL, NULL, NULL, NULL, NULL, 4),
(105552, NULL, 'G3DSA:1.25.40.10:FF:004150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105553, NULL, 'G3DSA:3.30.230.70:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105554, NULL, 'G3DSA:3.30.1010.10:FF:000061', NULL, NULL, 'Serine/threonine-protein kinase TEL1', NULL, NULL, NULL, NULL, NULL, 4),
(105555, NULL, 'G3DSA:3.40.50.800:FF:000086', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(105556, NULL, 'G3DSA:3.30.1540.20:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105557, NULL, 'G3DSA:3.40.50.300:FF:004595', NULL, NULL, 'ATP-dependent DNA helicase MCM (Intein-containing)', NULL, NULL, NULL, NULL, NULL, 4),
(105558, NULL, 'G3DSA:3.40.50.720:FF:002017', NULL, NULL, 'Gll1581 protein', NULL, NULL, NULL, NULL, NULL, 4),
(105559, NULL, 'G3DSA:3.40.50.1000:FF:000471', NULL, NULL, 'D,D-heptose 1,7-bisphosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(105560, NULL, 'G3DSA:3.40.50.10950:FF:000003', NULL, NULL, 'Phosphate acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(105561, NULL, 'G3DSA:1.20.120.1900:FF:000074', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(105562, NULL, 'G3DSA:3.20.20.300:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105563, NULL, 'G3DSA:3.10.180.10:FF:000044', NULL, NULL, 'Methylmalonyl-CoA-ethylmalonyl-CoA epimerase protein', NULL, NULL, NULL, NULL, NULL, 4),
(105564, NULL, 'G3DSA:3.40.50.1980:FF:000062', NULL, NULL, 'Iron(III) ABC transporter periplasmic iron-compound-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(105565, NULL, 'G3DSA:3.40.190.10:FF:000392', NULL, NULL, 'Probable sugar-binding lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(105566, NULL, 'G3DSA:3.30.2010.10:FF:000010', NULL, NULL, 'M48 family peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(105567, NULL, 'G3DSA:1.10.10.10:FF:001736', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(105568, NULL, 'G3DSA:2.40.50.140:FF:001246', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105569, NULL, 'G3DSA:1.20.140.100:FF:000020', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105570, NULL, 'G3DSA:3.40.50.720:FF:001556', NULL, NULL, 'Ubiquitin-activating enzyme E1', NULL, NULL, NULL, NULL, NULL, 4),
(105571, NULL, 'G3DSA:2.60.40.10:FF:004381', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105572, NULL, 'G3DSA:1.10.150.80:FF:000003', NULL, NULL, 'Bloom syndrome RecQ-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(105573, NULL, 'G3DSA:2.30.30.40:FF:000361', NULL, NULL, 'Heavy chain, Unconventional Myosin', NULL, NULL, NULL, NULL, NULL, 4),
(105574, NULL, 'G3DSA:3.40.47.10:FF:000084', NULL, NULL, 'Beta-keto-ACP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(105575, NULL, 'G3DSA:1.10.510.10:FF:002680', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(105576, NULL, 'G3DSA:1.20.920.30:FF:000028', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(105577, NULL, 'G3DSA:1.10.510.10:FF:004501', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105578, NULL, 'G3DSA:3.40.50.300:FF:001262', NULL, NULL, 'ABC transporter CDR4', NULL, NULL, NULL, NULL, NULL, 4),
(105579, NULL, 'G3DSA:3.40.50.670:FF:000001', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(105580, NULL, 'G3DSA:3.10.20.90:FF:000452', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105581, NULL, 'G3DSA:3.90.640.10:FF:000011', NULL, NULL, 'Heat shock protein family A (Hsp70) member 12A', NULL, NULL, NULL, NULL, NULL, 4),
(105582, NULL, 'G3DSA:3.40.50.2300:FF:001097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105583, NULL, 'G3DSA:3.50.30.50:FF:000012', NULL, NULL, 'Cyclase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(105584, NULL, 'G3DSA:3.90.230.10:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105585, NULL, 'G3DSA:3.40.50.11340:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105586, NULL, 'G3DSA:3.30.70.330:FF:001704', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105587, NULL, 'G3DSA:1.10.472.10:FF:000218', NULL, NULL, 'Retinoblastoma family protein', NULL, NULL, NULL, NULL, NULL, 4),
(105588, NULL, 'G3DSA:3.40.50.1820:FF:000042', NULL, NULL, 'probable strigolactone esterase DAD2', NULL, NULL, NULL, NULL, NULL, 4),
(105589, NULL, 'G3DSA:3.30.1380.20:FF:000001', NULL, NULL, 'Trafficking protein particle complex subunit BET3', NULL, NULL, NULL, NULL, NULL, 4),
(105590, NULL, 'G3DSA:2.60.40.10:FF:000340', NULL, NULL, 'Carcinoembryonic antigen-related cell adhesion molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(105591, NULL, 'G3DSA:2.40.50.140:FF:001139', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105592, NULL, 'G3DSA:3.40.50.150:FF:000295', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase H', NULL, NULL, NULL, NULL, NULL, 4),
(105593, NULL, 'G3DSA:3.90.1420.10:FF:000022', NULL, NULL, 'AGAP002018-PA', NULL, NULL, NULL, NULL, NULL, 4),
(105594, NULL, 'G3DSA:3.30.60.60:FF:000006', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(105595, NULL, 'G3DSA:3.90.740.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105596, NULL, 'G3DSA:3.30.70.2470:FF:000003', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(105597, NULL, 'G3DSA:1.25.10.10:FF:001686', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(105598, NULL, 'G3DSA:3.40.630.30:FF:000483', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105599, NULL, 'G3DSA:3.90.660.20:FF:000021', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(105600, NULL, 'G3DSA:1.20.58.1330:FF:000001', NULL, NULL, 'Early transcribed membrane protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(105601, NULL, 'G3DSA:2.130.10.10:FF:005556', NULL, NULL, 'semaphorin-4G-like isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(105602, NULL, 'G3DSA:3.30.890.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105603, NULL, 'G3DSA:2.160.20.10:FF:000114', NULL, NULL, 'Pectin lyase-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(105604, NULL, 'G3DSA:3.10.20.90:FF:000564', NULL, NULL, 'Autophagy-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(105605, NULL, 'G3DSA:3.40.630.30:FF:000595', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105606, NULL, 'G3DSA:1.10.10.10:FF:000371', NULL, NULL, 'Crossover junction endonuclease MUS81', NULL, NULL, NULL, NULL, NULL, 4),
(105607, NULL, 'G3DSA:2.70.150.10:FF:000302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105608, NULL, 'G3DSA:2.60.120.260:FF:000542', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105609, NULL, 'G3DSA:3.40.850.10:FF:000313', NULL, NULL, 'Kinesin heavy chain isoform 5C', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(105610, NULL, 'G3DSA:2.60.120.200:FF:000215', NULL, NULL, 'Si:dkey-22o22.2', NULL, NULL, NULL, NULL, NULL, 4),
(105611, NULL, 'G3DSA:1.10.510.10:FF:002528', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105612, NULL, 'G3DSA:3.30.70.2280:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105613, NULL, 'G3DSA:3.40.190.290:FF:000119', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(105614, NULL, 'G3DSA:2.60.40.10:FF:004611', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105615, NULL, 'G3DSA:3.40.710.10:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105616, NULL, 'G3DSA:3.30.160.360:FF:000007', NULL, NULL, 'Transforming growth factor beta regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(105617, NULL, 'G3DSA:2.60.40.10:FF:003987', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105618, NULL, 'G3DSA:3.20.20.70:FF:000827', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105619, NULL, 'G3DSA:2.60.40.1090:FF:000038', NULL, NULL, 'Fimbrial protein', NULL, NULL, NULL, NULL, NULL, 4),
(105620, NULL, 'G3DSA:2.60.200.20:FF:000278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105621, NULL, 'G3DSA:1.25.10.10:FF:002175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105622, NULL, 'G3DSA:2.60.40.60:FF:000596', NULL, NULL, 'Cadherin-related cell adhesion molecule', NULL, NULL, NULL, NULL, NULL, 4),
(105623, NULL, 'G3DSA:1.10.510.10:FF:002309', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105624, NULL, 'G3DSA:3.30.450.40:FF:000148', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(105625, NULL, 'G3DSA:3.80.10.10:FF:002869', NULL, NULL, 'Secreted protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105626, NULL, 'G3DSA:3.40.50.1820:FF:001733', NULL, NULL, 'Enniatin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(105627, NULL, 'G3DSA:3.40.50.1820:FF:001621', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105628, NULL, 'G3DSA:3.30.420.510:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105629, NULL, 'G3DSA:2.60.40.10:FF:005808', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105630, NULL, 'G3DSA:1.20.1070.10:FF:001748', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105631, NULL, 'G3DSA:3.10.28.10:FF:000024', NULL, NULL, 'Probable intron-encoded endonuclease 2', NULL, NULL, NULL, NULL, NULL, 4),
(105632, NULL, 'G3DSA:2.10.220.10:FF:000142', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(105633, NULL, 'G3DSA:1.10.238.10:FF:000304', NULL, NULL, 'calbindin-32 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(105634, NULL, 'G3DSA:1.20.1070.10:FF:001636', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105635, NULL, 'G3DSA:1.50.10.20:FF:000023', NULL, NULL, 'Thioester-containing protein 4, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(105636, NULL, 'G3DSA:2.60.200.20:FF:000059', NULL, NULL, 'FHA domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(105637, NULL, 'G3DSA:3.40.1210.10:FF:000006', NULL, NULL, '5''-nucleotidase SurE', NULL, NULL, NULL, NULL, NULL, 4),
(105638, NULL, 'G3DSA:1.10.287.70:FF:000486', NULL, NULL, 'TWiK family of potassium channels', NULL, NULL, NULL, NULL, NULL, 4),
(105639, NULL, 'G3DSA:3.40.50.1240:FF:000019', NULL, NULL, 'Periplasmic AppA protein', NULL, NULL, NULL, NULL, NULL, 4),
(105640, NULL, 'G3DSA:1.25.40.10:FF:002177', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(105641, NULL, 'G3DSA:1.10.10.10:FF:000320', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(105642, NULL, 'G3DSA:3.40.50.970:FF:000035', NULL, NULL, '2-succinyl-5-enolpyruvyl-6-hydroxy-3-cyclohexene-1-carboxylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(105643, NULL, 'G3DSA:3.40.50.1070:FF:000002', NULL, NULL, 'L-fucose isomerase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(105644, NULL, 'G3DSA:1.10.275.40:FF:000022', NULL, NULL, 'Helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105645, NULL, 'G3DSA:1.10.555.10:FF:000198', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105646, NULL, 'G3DSA:2.40.100.10:FF:000160', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(105647, NULL, 'G3DSA:3.30.1640.10:FF:000029', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(105648, NULL, 'G3DSA:2.30.30.30:FF:000032', NULL, NULL, '39S ribosomal protein L24, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(105649, NULL, 'G3DSA:1.10.510.10:FF:001972', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105650, NULL, 'G3DSA:3.90.226.10:FF:000330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105651, NULL, 'G3DSA:3.40.50.1440:FF:000080', NULL, NULL, 'Tubulin, epsilon 1', NULL, NULL, NULL, NULL, NULL, 4),
(105652, NULL, 'G3DSA:2.160.20.10:FF:000053', NULL, NULL, 'Polygalacturonase QRT3', NULL, NULL, NULL, NULL, NULL, 4),
(105653, NULL, 'G3DSA:2.170.130.10:FF:000030', NULL, NULL, 'TonB-dependent receptor plug domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(105654, NULL, 'G3DSA:3.30.260.10:FF:000001', NULL, NULL, '60 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(105655, NULL, 'G3DSA:3.30.70.2260:FF:000002', NULL, NULL, 'Exopolyphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(105656, NULL, 'G3DSA:3.30.450.20:FF:000142', NULL, NULL, 'PAS domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(105657, NULL, 'G3DSA:3.40.50.300:FF:008136', NULL, NULL, 'Roco6, ROCO family protein', NULL, NULL, NULL, NULL, NULL, 4),
(105658, NULL, 'G3DSA:2.40.50.90:FF:000140', NULL, NULL, 'RE70955p', NULL, NULL, NULL, NULL, NULL, 4),
(105659, NULL, 'G3DSA:3.80.10.10:FF:001453', NULL, NULL, 'Leucine Rich repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105660, NULL, 'G3DSA:1.25.10.10:FF:002405', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105661, NULL, 'G3DSA:1.10.472.10:FF:000393', NULL, NULL, 'CYclin H', NULL, NULL, NULL, NULL, NULL, 4),
(105662, NULL, 'G3DSA:2.40.50.140:FF:000560', NULL, NULL, '30S ribosomal protein S17', NULL, NULL, NULL, NULL, NULL, 4),
(105663, NULL, 'G3DSA:3.40.50.980:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105664, NULL, 'G3DSA:2.120.10.30:FF:000054', NULL, NULL, 'Peptidyl-alpha-hydroxyglycine alpha-amidating lyase 1', NULL, NULL, NULL, NULL, NULL, 4),
(105665, NULL, 'G3DSA:3.90.70.40:FF:000010', NULL, NULL, 'Ataxin 3 variant r', NULL, NULL, NULL, NULL, NULL, 4),
(105666, NULL, 'G3DSA:3.90.1530.30:FF:000002', NULL, NULL, 'Chromosome partitioning protein ParB', NULL, NULL, NULL, NULL, NULL, 4),
(105667, NULL, 'G3DSA:3.30.1360.10:FF:000047', NULL, NULL, 'DNA-directed RNA polymerases II IV and V subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(105668, NULL, 'G3DSA:2.80.10.50:FF:000276', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(105669, NULL, 'G3DSA:3.40.190.10:FF:000341', NULL, NULL, 'Phosphonate ABC transporter, phosphate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(105670, NULL, 'G3DSA:2.40.70.10:FF:000331', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105671, NULL, 'G3DSA:2.60.40.60:FF:000545', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105672, NULL, 'G3DSA:3.30.160.60:FF:002526', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(105673, NULL, 'G3DSA:3.90.260.10:FF:000044', NULL, NULL, 'XPC (Xeroderma Pigmentosum group C) DNA repair gene homolog', NULL, NULL, NULL, NULL, NULL, 4),
(105674, NULL, 'G3DSA:3.80.10.10:FF:003544', NULL, NULL, 'Cell polarity protein alp21', NULL, NULL, NULL, NULL, NULL, 4),
(105675, NULL, 'G3DSA:1.10.510.10:FF:002461', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105676, NULL, 'G3DSA:1.25.40.10:FF:002800', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(105677, NULL, 'G3DSA:3.40.33.10:FF:000086', NULL, NULL, 'Protein CBG01185', NULL, NULL, NULL, NULL, NULL, 4),
(105678, NULL, 'G3DSA:3.30.160.60:FF:004151', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105679, NULL, 'G3DSA:3.40.50.300:FF:004483', NULL, NULL, 'DNA repair protein rad-50', NULL, NULL, NULL, NULL, NULL, 4),
(105680, NULL, 'G3DSA:3.40.50.1460:FF:000086', NULL, NULL, 'Paracaspase', NULL, NULL, NULL, NULL, NULL, 4),
(105681, NULL, 'G3DSA:2.60.200.20:FF:000008', NULL, NULL, 'smad nuclear-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(105682, NULL, 'G3DSA:1.10.510.10:FF:003989', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105683, NULL, 'G3DSA:1.10.185.10:FF:000001', NULL, NULL, 'Gag polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(105684, NULL, 'G3DSA:1.20.1110.10:FF:000168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105685, NULL, 'G3DSA:3.30.530.20:FF:000143', NULL, NULL, 'Lipid-binding START protein', NULL, NULL, NULL, NULL, NULL, 4),
(105686, NULL, 'G3DSA:2.60.40.790:FF:000203', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105687, NULL, 'G3DSA:1.25.40.10:FF:000620', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(105688, NULL, 'G3DSA:3.10.450.50:FF:000021', NULL, NULL, 'Epoxide hydrolase EphG', NULL, NULL, NULL, NULL, NULL, 4),
(105689, NULL, 'G3DSA:2.20.70.10:FF:000231', NULL, NULL, 'Transcription elongation regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105690, NULL, 'G3DSA:3.30.70.1350:FF:000010', NULL, NULL, 'Cation efflux family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105691, NULL, 'G3DSA:3.30.70.330:FF:000344', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(105692, NULL, 'G3DSA:1.20.1060.20:FF:000003', NULL, NULL, 'Structural maintenance of chromosomes 4', NULL, NULL, NULL, NULL, NULL, 4),
(105693, NULL, 'G3DSA:2.130.10.10:FF:005994', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(105694, NULL, 'G3DSA:3.30.70.370:FF:000002', NULL, NULL, 'DNA polymerase gamma, catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(105695, NULL, 'G3DSA:2.20.28.10:FF:000009', NULL, NULL, 'RING finger and CHY zinc finger domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(105696, NULL, 'G3DSA:2.60.34.10:FF:000050', NULL, NULL, 'Heat shock protein 70, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105697, NULL, 'G3DSA:1.20.140.150:FF:000006', NULL, NULL, 'uncharacterized protein C16orf52 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(105698, NULL, 'G3DSA:3.40.50.2300:FF:000315', NULL, NULL, 'Glutamate receptor ionotropic, delta-1', NULL, NULL, NULL, NULL, NULL, 4),
(105699, NULL, 'G3DSA:3.90.70.10:FF:000181', NULL, NULL, 'Ubiquitin hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105700, NULL, 'G3DSA:3.40.50.720:FF:002012', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(105701, NULL, 'G3DSA:2.60.40.150:FF:000427', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(105702, NULL, 'G3DSA:3.40.930.10:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105703, NULL, 'G3DSA:2.70.98.110:FF:000006', NULL, NULL, 'Glucosidase I', NULL, NULL, NULL, NULL, NULL, 4),
(105704, NULL, 'G3DSA:3.40.50.300:FF:000554', NULL, NULL, 'ADP-ribosylation factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(105705, NULL, 'G3DSA:1.10.8.400:FF:000002', NULL, NULL, 'Enoyl-[acyl-carrier-protein] reductase [NADH]', NULL, NULL, NULL, NULL, NULL, 4),
(105706, NULL, 'G3DSA:3.30.40.10:FF:001822', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105707, NULL, 'G3DSA:3.40.50.10260:FF:000010', NULL, NULL, 'Edc3p', NULL, NULL, NULL, NULL, NULL, 4),
(105708, NULL, 'G3DSA:3.30.565.10:FF:000282', NULL, NULL, 'Signal transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(105709, NULL, 'G3DSA:3.30.2160.10:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105710, NULL, 'G3DSA:1.10.1670.10:FF:000032', NULL, NULL, 'Endonuclease III, putative', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(105711, NULL, 'G3DSA:2.60.40.10:FF:005685', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105712, NULL, 'G3DSA:2.60.120.740:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105713, NULL, 'G3DSA:1.20.58.390:FF:000204', NULL, NULL, 'Neurotransmitter-gated ion-channel ligand binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(105714, NULL, 'G3DSA:1.20.1250.20:FF:001518', NULL, NULL, 'Solute carrier family 19 member 3b', NULL, NULL, NULL, NULL, NULL, 4),
(105715, NULL, 'G3DSA:3.40.630.10:FF:000151', NULL, NULL, 'Blast:Carboxypeptidase B', NULL, NULL, NULL, NULL, NULL, 4),
(105716, NULL, 'G3DSA:2.40.170.20:FF:000111', NULL, NULL, 'SusC homolog', NULL, NULL, NULL, NULL, NULL, 4),
(105717, NULL, 'G3DSA:1.25.40.70:FF:000087', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(105718, NULL, 'G3DSA:2.30.30.40:FF:000068', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit beta-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(105719, NULL, 'G3DSA:1.10.30.10:FF:000085', NULL, NULL, 'Chromatin-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(105720, NULL, 'G3DSA:3.40.30.10:FF:001063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105721, NULL, 'G3DSA:3.30.2290.10:FF:000019', NULL, NULL, 'Sll0887 protein', NULL, NULL, NULL, NULL, NULL, 4),
(105722, NULL, 'G3DSA:3.30.830.10:FF:000028', NULL, NULL, 'Insulin-degrading enzyme-like 1 peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(105723, NULL, 'G3DSA:2.60.40.4370:FF:000005', NULL, NULL, 'Transcription factor tau subunit sfc7', NULL, NULL, NULL, NULL, NULL, 4),
(105724, NULL, 'G3DSA:2.40.30.110:FF:000013', NULL, NULL, 'Protein CBG22093', NULL, NULL, NULL, NULL, NULL, 4),
(105725, NULL, 'G3DSA:1.25.40.10:FF:002851', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g25580', NULL, NULL, NULL, NULL, NULL, 4),
(105726, NULL, 'G3DSA:3.30.70.330:FF:001709', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105727, NULL, 'G3DSA:1.20.58.390:FF:000255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105728, NULL, 'G3DSA:1.10.510.10:FF:004226', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105729, NULL, 'G3DSA:1.10.3470.10:FF:000051', NULL, NULL, 'ABC-3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(105730, NULL, 'G3DSA:2.130.10.10:FF:004533', NULL, NULL, 'Novel protein-containing four WD domain, G-beta repeats', NULL, NULL, NULL, NULL, NULL, 4),
(105731, NULL, 'G3DSA:3.30.70.380:FF:000005', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(105732, NULL, 'G3DSA:3.40.50.300:FF:002627', NULL, NULL, 'Gluconokinase', NULL, NULL, NULL, NULL, NULL, 4),
(105733, NULL, 'G3DSA:3.10.20.90:FF:000126', NULL, NULL, 'unconventional myosin-X', NULL, NULL, NULL, NULL, NULL, 4),
(105734, NULL, 'G3DSA:3.40.50.1100:FF:000175', NULL, NULL, 'Threonine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(105735, NULL, 'G3DSA:3.80.10.10:FF:001560', NULL, NULL, 'Adhesion G protein-coupled receptor A2', NULL, NULL, NULL, NULL, NULL, 4),
(105736, NULL, 'G3DSA:1.10.20.10:FF:000197', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105737, NULL, 'G3DSA:1.10.520.10:FF:000056', NULL, NULL, 'L-ascorbate peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(105738, NULL, 'G3DSA:3.30.1520.10:FF:000150', NULL, NULL, 'Sorting nexin 3', NULL, NULL, NULL, NULL, NULL, 4),
(105739, NULL, 'G3DSA:3.40.630.30:FF:000157', NULL, NULL, 'RNA cytidine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(105740, NULL, 'G3DSA:3.10.110.10:FF:000040', NULL, NULL, 'tumor susceptibility gene 101 protein', NULL, NULL, NULL, NULL, NULL, 4),
(105741, NULL, 'G3DSA:3.30.1330.20:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105742, NULL, 'G3DSA:2.40.30.130:FF:000019', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(105743, NULL, 'G3DSA:1.10.10.250:FF:000028', NULL, NULL, 'Large subunit ribosomal protein L11', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(105744, NULL, 'G3DSA:1.10.533.10:FF:000299', NULL, NULL, 'NACHT, LRR and PYD domains-containing protein 9B', NULL, NULL, NULL, NULL, NULL, 4),
(105745, NULL, 'G3DSA:3.30.40.10:FF:001148', NULL, NULL, 'FinTRIM family, member 82', NULL, NULL, NULL, NULL, NULL, 4),
(105746, NULL, 'G3DSA:3.90.70.10:FF:000416', NULL, NULL, 'Senescence-specific cysteine protease SAG39', NULL, NULL, NULL, NULL, NULL, 4),
(105747, NULL, 'G3DSA:1.10.10.60:FF:000632', NULL, NULL, 'Zinc finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(105748, NULL, 'G3DSA:3.30.40.10:FF:000136', NULL, NULL, 'E3 ubiquitin-protein ligase Topors', NULL, NULL, NULL, NULL, NULL, 4),
(105749, NULL, 'G3DSA:2.40.100.10:FF:000008', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(105750, NULL, 'G3DSA:1.25.40.20:FF:001224', NULL, NULL, 'Ankyrin repeat domain 27', NULL, NULL, NULL, NULL, NULL, 4),
(105751, NULL, 'G3DSA:1.25.10.10:FF:003479', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105752, NULL, 'G3DSA:3.60.21.10:FF:000142', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(105753, NULL, 'G3DSA:3.40.140.10:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105754, NULL, 'G3DSA:1.25.40.10:FF:000327', NULL, NULL, 'Pre-mRNA-splicing factor CLF1', NULL, NULL, NULL, NULL, NULL, 4),
(105755, NULL, 'G3DSA:3.30.497.10:FF:000022', NULL, NULL, 'SeRPin', NULL, NULL, NULL, NULL, NULL, 4),
(105756, NULL, 'G3DSA:1.10.238.10:FF:000686', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(105757, NULL, 'G3DSA:2.60.40.180:FF:000003', NULL, NULL, 'Uric acid degradation bifunctional protein TTL', NULL, NULL, NULL, NULL, NULL, 4),
(105758, NULL, 'G3DSA:1.10.10.10:FF:002118', NULL, NULL, 'Transcriptional regulator, AsnC family', NULL, NULL, NULL, NULL, NULL, 4),
(105759, NULL, 'G3DSA:3.30.70.580:FF:000065', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(105760, NULL, 'G3DSA:3.30.1060.10:FF:000007', NULL, NULL, 'Peptide methionine sulfoxide reductase msrA/msrB', NULL, NULL, NULL, NULL, NULL, 4),
(105761, NULL, 'G3DSA:1.25.40.20:FF:000656', NULL, NULL, 'Water witch, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(105762, NULL, 'G3DSA:1.10.3260.10:FF:000018', NULL, NULL, 'ATP-dependent DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(105763, NULL, 'G3DSA:2.60.40.60:FF:001001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105764, NULL, 'G3DSA:2.120.10.30:FF:000116', NULL, NULL, 'Serine/threonine-protein kinase pknD', NULL, NULL, NULL, NULL, NULL, 4),
(105765, NULL, 'G3DSA:1.25.40.10:FF:004217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105766, NULL, 'G3DSA:1.10.238.10:FF:000742', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105767, NULL, 'G3DSA:3.90.1110.10:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105768, NULL, 'G3DSA:3.40.30.10:FF:000495', NULL, NULL, 'Diphosphomevalonate decarboxylase MVD2', NULL, NULL, NULL, NULL, NULL, 4),
(105769, NULL, 'G3DSA:3.40.50.150:FF:000290', NULL, NULL, 'Polyamine aminopropyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(105770, NULL, 'G3DSA:1.20.58.390:FF:000148', NULL, NULL, 'Transmembrane ion channel', NULL, NULL, NULL, NULL, NULL, 4),
(105771, NULL, 'G3DSA:3.30.160.60:FF:003987', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105772, NULL, 'G3DSA:1.10.1410.10:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105773, NULL, 'G3DSA:3.40.630.10:FF:000095', NULL, NULL, 'N-acetylated alpha-linked acidic dipeptidase like 2', NULL, NULL, NULL, NULL, NULL, 4),
(105774, NULL, 'G3DSA:3.30.505.10:FF:000183', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105775, NULL, 'G3DSA:2.30.29.30:FF:001074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105776, NULL, 'G3DSA:3.55.40.20:FF:000004', NULL, NULL, 'Superoxide dismutase [Fe]', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(105777, NULL, 'G3DSA:3.40.50.1100:FF:000231', NULL, NULL, 'Cysteine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(105778, NULL, 'G3DSA:2.10.220.10:FF:000198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105779, NULL, 'G3DSA:3.90.550.10:FF:000184', NULL, NULL, 'Van1p', NULL, NULL, NULL, NULL, NULL, 4),
(105780, NULL, 'G3DSA:3.15.10.10:FF:000018', NULL, NULL, 'Nose resistant to fluoxetine protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(105781, NULL, 'G3DSA:3.30.10.20:FF:000019', NULL, NULL, 'Serine/threonine-protein kinase PrkC', NULL, NULL, NULL, NULL, NULL, 4),
(105782, NULL, 'G3DSA:2.10.50.10:FF:000039', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 19L', NULL, NULL, NULL, NULL, NULL, 4),
(105783, NULL, 'G3DSA:1.25.40.10:FF:001957', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105784, NULL, 'G3DSA:3.40.630.10:FF:000437', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105785, NULL, 'G3DSA:2.70.130.10:FF:000065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105786, NULL, 'G3DSA:3.40.1380.20:FF:000049', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(105787, NULL, 'G3DSA:1.10.10.10:FF:000376', NULL, NULL, 'Rrf2 family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(105788, NULL, 'G3DSA:3.40.50.300:FF:002678', NULL, NULL, 'ADP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(105789, NULL, 'G3DSA:3.10.20.90:FF:000177', NULL, NULL, 'UBX domain protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(105790, NULL, 'G3DSA:1.20.140.140:FF:000003', NULL, NULL, 'Protein orai', NULL, NULL, NULL, NULL, NULL, 4),
(105791, NULL, 'G3DSA:2.70.20.10:FF:000023', NULL, NULL, 'DNA topoisomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(105792, NULL, 'G3DSA:4.10.400.10:FF:000339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105793, NULL, 'G3DSA:3.30.160.60:FF:000109', NULL, NULL, 'Transcriptional repressor protein YY1', NULL, NULL, NULL, NULL, NULL, 4),
(105794, NULL, 'G3DSA:1.25.40.10:FF:002233', NULL, NULL, 'Protein THYLAKOID ASSEMBLY 8, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(105795, NULL, 'G3DSA:3.80.10.10:FF:001408', NULL, NULL, 'Si:ch211-171l17.14', NULL, NULL, NULL, NULL, NULL, 4),
(105796, NULL, 'G3DSA:2.40.50.140:FF:000234', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(105797, NULL, 'G3DSA:1.20.120.350:FF:000186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105798, NULL, 'G3DSA:1.10.287.110:FF:000234', NULL, NULL, 'Putative DNAJ domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(105799, NULL, 'G3DSA:2.60.200.20:FF:000003', NULL, NULL, 'sarcolemmal membrane-associated protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(105800, NULL, 'G3DSA:3.40.50.300:FF:000149', NULL, NULL, 'Nuclear valosin-containing protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(105801, NULL, 'G3DSA:2.40.30.270:FF:000033', NULL, NULL, 'Helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105802, NULL, 'G3DSA:3.40.50.1820:FF:001346', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105803, NULL, 'G3DSA:2.180.10.10:FF:000006', NULL, NULL, 'teneurin-a isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(105804, NULL, 'G3DSA:1.20.58.670:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105805, NULL, 'G3DSA:2.60.40.10:FF:002464', NULL, NULL, 'interleukin-3 receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(105806, NULL, 'G3DSA:3.10.450.320:FF:000004', NULL, NULL, 'Tim21 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(105807, NULL, 'G3DSA:4.10.280.10:FF:000166', NULL, NULL, 'Transcription factor bHLH52', NULL, NULL, NULL, NULL, NULL, 4),
(105808, NULL, 'G3DSA:1.20.1250.20:FF:001844', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105809, NULL, 'G3DSA:2.130.10.10:FF:000643', NULL, NULL, '60S ribosome biogenesis protein Sqt1', NULL, NULL, NULL, NULL, NULL, 4),
(105810, NULL, 'G3DSA:3.80.10.10:FF:001234', NULL, NULL, 'AGAP013454-PA', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(105811, NULL, 'G3DSA:3.40.50.300:FF:002066', NULL, NULL, 'GPN-loop GTPase 3', NULL, NULL, NULL, NULL, NULL, 4),
(105812, NULL, 'G3DSA:1.20.930.40:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105813, NULL, 'G3DSA:1.20.1070.10:FF:001804', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105814, NULL, 'G3DSA:1.10.418.50:FF:000004', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(105815, NULL, 'G3DSA:3.10.20.90:FF:000738', NULL, NULL, 'Plexin A3', NULL, NULL, NULL, NULL, NULL, 4),
(105816, NULL, 'G3DSA:3.10.20.90:FF:001020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105817, NULL, 'G3DSA:3.90.550.10:FF:000712', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105818, NULL, 'G3DSA:1.10.274.30:FF:000017', NULL, NULL, 'NuA4 complex subunit EAF3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(105819, NULL, 'G3DSA:3.20.20.70:FF:000597', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105820, NULL, 'G3DSA:3.40.50.300:FF:007967', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105821, NULL, 'G3DSA:2.60.40.10:FF:002812', NULL, NULL, 'KETtiN (Drosophila actin-binding) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(105822, NULL, 'G3DSA:2.60.40.10:FF:002756', NULL, NULL, 'Envelope glycoprotein E', NULL, NULL, NULL, NULL, NULL, 4),
(105823, NULL, 'G3DSA:3.10.20.90:FF:000396', NULL, NULL, 'GABARAPL2 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(105824, NULL, 'G3DSA:1.10.418.60:FF:000007', NULL, NULL, 'NDC80 kinetochore complex component NUF2', NULL, NULL, NULL, NULL, NULL, 4),
(105825, NULL, 'G3DSA:2.130.10.10:FF:004207', NULL, NULL, 'UTP4 small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4),
(105826, NULL, 'G3DSA:3.30.40.10:FF:001715', NULL, NULL, 'YALI0E27049p', NULL, NULL, NULL, NULL, NULL, 4),
(105827, NULL, 'G3DSA:3.30.160.60:FF:004095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105828, NULL, 'G3DSA:2.40.70.10:FF:000275', NULL, NULL, 'Aspartic peptidase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(105829, NULL, 'G3DSA:3.30.50.10:FF:000013', NULL, NULL, 'Nuclear receptor subfamily 1 group D member 2', NULL, NULL, NULL, NULL, NULL, 4),
(105830, NULL, 'G3DSA:3.40.50.300:FF:003696', NULL, NULL, 'Retrotransposon protein, putative, unclassified, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(105831, NULL, 'G3DSA:3.40.50.300:FF:006337', NULL, NULL, 'AAL030Cp', NULL, NULL, NULL, NULL, NULL, 4),
(105832, NULL, 'G3DSA:1.10.238.10:FF:000416', NULL, NULL, 'Aralar1, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(105833, NULL, 'G3DSA:1.10.287.550:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105834, NULL, 'G3DSA:3.10.450.120:FF:000001', NULL, NULL, 'DUF1947 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(105835, NULL, 'G3DSA:1.25.40.790:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105836, NULL, 'G3DSA:3.30.70.330:FF:001979', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105837, NULL, 'G3DSA:1.20.1070.10:FF:001462', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105838, NULL, 'G3DSA:3.10.20.310:FF:000029', NULL, NULL, 'Outer membrane protein assembly factor BamA', NULL, NULL, NULL, NULL, NULL, 4),
(105839, NULL, 'G3DSA:1.10.287.110:FF:000178', NULL, NULL, 'DnaJ family protein', NULL, NULL, NULL, NULL, NULL, 4),
(105840, NULL, 'G3DSA:1.20.1110.10:FF:000224', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105841, NULL, 'G3DSA:1.10.510.10:FF:004445', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105842, NULL, 'G3DSA:2.40.128.240:FF:000001', NULL, NULL, 'Transferrin binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(105843, NULL, 'G3DSA:2.60.40.790:FF:000147', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105844, NULL, 'G3DSA:1.10.510.10:FF:001005', NULL, NULL, 'NAK/BIKE protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(105845, NULL, 'G3DSA:1.10.3170.10:FF:000011', NULL, NULL, 'Exodeoxyribonuclease V subunit beta', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(105846, NULL, 'G3DSA:2.60.40.4060:FF:000007', NULL, NULL, 'Putative ferric-chelate reductase 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(105847, NULL, 'G3DSA:3.70.10.10:FF:000133', NULL, NULL, 'Checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(105848, NULL, 'G3DSA:3.30.70.330:FF:002997', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105849, NULL, 'G3DSA:3.30.160.60:FF:001222', NULL, NULL, 'zinc finger protein 639', NULL, NULL, NULL, NULL, NULL, 4),
(105850, NULL, 'G3DSA:3.40.50.300:FF:008462', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(105851, NULL, 'G3DSA:3.30.2160.10:FF:000015', NULL, NULL, 'IQ and HECT domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(105852, NULL, 'G3DSA:1.10.357.10:FF:000086', NULL, NULL, 'Transcriptional regulator AguR', NULL, NULL, NULL, NULL, NULL, 4),
(105853, NULL, 'G3DSA:2.40.50.100:FF:000065', NULL, NULL, '2-oxoglutarate dehydrogenase E2 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(105854, NULL, 'G3DSA:3.90.226.10:FF:000037', NULL, NULL, 'Retinol-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(105855, NULL, 'G3DSA:3.30.160.60:FF:004443', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105856, NULL, 'G3DSA:3.80.10.10:FF:001627', NULL, NULL, 'SCF E3 ubiquitin ligase complex F-box protein grrA', NULL, NULL, NULL, NULL, NULL, 4),
(105857, NULL, 'G3DSA:2.60.40.60:FF:000719', NULL, NULL, 'Fat-like cadherin-related tumor suppressor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(105858, NULL, 'G3DSA:1.10.287.1080:FF:000014', NULL, NULL, 'Nucleoside triphosphate pyrophosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(105859, NULL, 'G3DSA:2.60.120.380:FF:000067', NULL, NULL, 'Calpain-B-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(105860, NULL, 'G3DSA:1.20.272.10:FF:000027', NULL, NULL, 'DNA polymerase III subunit gamma/tau', NULL, NULL, NULL, NULL, NULL, 4),
(105861, NULL, 'G3DSA:1.10.10.1190:FF:000001', NULL, NULL, 'Antirestriction protein ArdA', NULL, NULL, NULL, NULL, NULL, 4),
(105862, NULL, 'G3DSA:3.40.50.300:FF:004191', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(105863, NULL, 'G3DSA:1.25.10.10:FF:000606', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(105864, NULL, 'G3DSA:3.40.190.10:FF:000515', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(105865, NULL, 'G3DSA:2.60.40.10:FF:004443', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105866, NULL, 'G3DSA:3.40.50.261:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105867, NULL, 'G3DSA:1.10.560.10:FF:000053', NULL, NULL, 'T-complex protein 1 subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(105868, NULL, 'G3DSA:3.30.40.10:FF:001766', NULL, NULL, 'CiGl protein', NULL, NULL, NULL, NULL, NULL, 4),
(105869, NULL, 'G3DSA:2.30.30.490:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105870, NULL, 'G3DSA:3.40.50.10310:FF:000008', NULL, NULL, 'Creatininase', NULL, NULL, NULL, NULL, NULL, 4),
(105871, NULL, 'G3DSA:1.20.1250.20:FF:001226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105872, NULL, 'G3DSA:2.60.260.20:FF:000107', NULL, NULL, 'Molecular chaperone DnaJ family', NULL, NULL, NULL, NULL, NULL, 4),
(105873, NULL, 'G3DSA:3.60.21.10:FF:000086', NULL, NULL, 'Shewanella-like protein phosphatase 2', NULL, NULL, NULL, NULL, NULL, 4),
(105874, NULL, 'G3DSA:2.10.109.10:FF:000006', NULL, NULL, 'DNA polymerase V subunit', NULL, NULL, NULL, NULL, NULL, 4),
(105875, NULL, 'G3DSA:3.30.420.10:FF:000278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105876, NULL, 'G3DSA:1.20.120.1900:FF:000079', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(105877, NULL, 'G3DSA:3.30.60.30:FF:000183', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(105878, NULL, 'G3DSA:3.30.160.60:FF:000733', NULL, NULL, 'Zinc finger protein 236 variant', NULL, NULL, NULL, NULL, NULL, 4),
(105879, NULL, 'G3DSA:1.25.40.10:FF:000108', NULL, NULL, 'Small glutamine-rich tetratricopeptide repeat-containing protein alpha', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(105880, NULL, 'G3DSA:1.25.10.10:FF:000051', NULL, NULL, 'E3 ubiquitin-protein ligase HECTD1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(105881, NULL, 'G3DSA:3.30.450.40:FF:000204', NULL, NULL, 'GAF sensor methyl-accepting chemotaxis sensory transducer, class 40H', NULL, NULL, NULL, NULL, NULL, 4),
(105882, NULL, 'G3DSA:1.10.510.10:FF:000516', NULL, NULL, 'VRK serine/threonine kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(105883, NULL, 'G3DSA:3.40.50.150:FF:000413', NULL, NULL, 'Methyltransferase, FxLD system', NULL, NULL, NULL, NULL, NULL, 4),
(105884, NULL, 'G3DSA:1.10.510.10:FF:000729', NULL, NULL, 'Putative cyclin-dependent kinase F-2', NULL, NULL, NULL, NULL, NULL, 4),
(105885, NULL, 'G3DSA:3.40.50.150:FF:001599', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105886, NULL, 'G3DSA:3.30.70.330:FF:002261', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105887, NULL, 'G3DSA:1.25.40.10:FF:000378', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(105888, NULL, 'G3DSA:1.20.1250.20:FF:000214', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(105889, NULL, 'G3DSA:1.10.418.40:FF:000001', NULL, NULL, 'beclin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(105890, NULL, 'G3DSA:3.40.30.10:FF:000169', NULL, NULL, 'DnaJ homolog subfamily C member 10', NULL, NULL, NULL, NULL, NULL, 4),
(105891, NULL, 'G3DSA:1.10.20.10:FF:000253', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105892, NULL, 'G3DSA:3.30.830.10:FF:000303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105893, NULL, 'G3DSA:1.10.472.10:FF:000511', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105894, NULL, 'G3DSA:1.10.10.10:FF:001955', NULL, NULL, 'COP9 signalosome complex subunit 12', NULL, NULL, NULL, NULL, NULL, 4),
(105895, NULL, 'G3DSA:3.90.70.10:FF:000467', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(105896, NULL, 'G3DSA:3.40.50.1000:FF:000476', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105897, NULL, 'G3DSA:3.40.50.300:FF:000880', NULL, NULL, 'Primosomal protein DnaI', NULL, NULL, NULL, NULL, NULL, 4),
(105898, NULL, 'G3DSA:3.40.50.1000:FF:000419', NULL, NULL, 'Haloacid dehalogenase-like hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(105899, NULL, 'G3DSA:3.40.50.2300:FF:000141', NULL, NULL, 'piwi-like protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(105900, NULL, 'G3DSA:3.40.50.720:FF:001848', NULL, NULL, 'Ubiquitin-activating enzyme e1 1 putative', NULL, NULL, NULL, NULL, NULL, 4),
(105901, NULL, 'G3DSA:3.30.1490.20:FF:000099', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(105902, NULL, 'G3DSA:1.10.533.10:FF:000086', NULL, NULL, 'AO66 ankyrin', NULL, NULL, NULL, NULL, NULL, 4),
(105903, NULL, 'G3DSA:1.20.5.190:FF:000021', NULL, NULL, 'IQ motif containing N', NULL, NULL, NULL, NULL, NULL, 4),
(105904, NULL, 'G3DSA:3.30.530.20:FF:000199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105905, NULL, 'G3DSA:1.10.150.240:FF:000105', NULL, NULL, 'Phosphoglycolate phosphatase, putative (AFU_orthologue AFUA_7G00760)', NULL, NULL, NULL, NULL, NULL, 4),
(105906, NULL, 'G3DSA:4.10.410.10:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105907, NULL, 'G3DSA:3.40.50.720:FF:001904', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105908, NULL, 'G3DSA:3.30.200.20:FF:000444', NULL, NULL, 'MDIS1-interacting receptor like kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(105909, NULL, 'G3DSA:3.90.79.10:FF:000228', NULL, NULL, 'mRNA-decapping enzyme subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(105910, NULL, 'G3DSA:1.10.10.60:FF:000363', NULL, NULL, 'Kismet, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(105911, NULL, 'G3DSA:3.40.50.2300:FF:000085', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(105912, NULL, 'G3DSA:2.60.40.10:FF:004050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(105913, NULL, 'G3DSA:2.60.40.60:FF:000214', NULL, NULL, 'Dachsous cadherin-related 1', NULL, NULL, NULL, NULL, NULL, 4),
(105914, NULL, 'G3DSA:1.10.238.10:FF:000181', NULL, NULL, 'CALML5 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(105915, NULL, 'G3DSA:2.130.10.10:FF:000317', NULL, NULL, 'striatin-4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(105916, NULL, 'G3DSA:2.160.10.10:FF:000052', NULL, NULL, 'Translation initiation factor eIF-2B subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(105917, NULL, 'G3DSA:2.130.10.10:FF:001897', NULL, NULL, 'EG:25E8.3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(105918, NULL, 'G3DSA:3.90.70.10:FF:000703', NULL, NULL, 'Cysteine proteinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105919, NULL, 'G3DSA:3.90.1150.10:FF:000192', NULL, NULL, 'Aminotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(105920, NULL, 'G3DSA:3.10.50.40:FF:000074', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(105921, NULL, 'G3DSA:2.60.40.1910:FF:000003', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(105922, NULL, 'G3DSA:2.30.39.10:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105923, NULL, 'G3DSA:1.25.40.10:FF:003868', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105924, NULL, 'G3DSA:1.20.1250.20:FF:002013', NULL, NULL, 'Transporter MFS superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(105925, NULL, 'G3DSA:2.40.30.10:FF:000334', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105926, NULL, 'G3DSA:2.60.40.640:FF:000063', NULL, NULL, 'Arrestin', NULL, NULL, NULL, NULL, NULL, 4),
(105927, NULL, 'G3DSA:2.60.40.60:FF:000158', NULL, NULL, 'Dachsous cadherin-related 1', NULL, NULL, NULL, NULL, NULL, 4),
(105928, NULL, 'G3DSA:3.30.40.10:FF:001592', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(105929, NULL, 'G3DSA:3.40.50.150:FF:000812', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105930, NULL, 'G3DSA:1.10.510.10:FF:000842', NULL, NULL, 'Nuclear receptor-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(105931, NULL, 'G3DSA:1.25.10.10:FF:000612', NULL, NULL, 'Serine/threonine-protein kinase Nek10', NULL, NULL, NULL, NULL, NULL, 4),
(105932, NULL, 'G3DSA:3.30.60.30:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105933, NULL, 'G3DSA:3.40.140.10:FF:000063', NULL, NULL, 'DNA repair protein RadC', NULL, NULL, NULL, NULL, NULL, 4),
(105934, NULL, 'G3DSA:3.30.1370.10:FF:000110', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(105935, NULL, 'G3DSA:3.30.200.20:FF:000500', NULL, NULL, 'Putative aminoglycoside phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(105936, NULL, 'G3DSA:1.25.40.10:FF:001688', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(105937, NULL, 'G3DSA:3.30.60.20:FF:000135', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(105938, NULL, 'G3DSA:2.160.20.70:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105939, NULL, 'G3DSA:2.30.29.30:FF:001304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105940, NULL, 'G3DSA:1.20.140.100:FF:000019', NULL, NULL, 'Putative dynein heavy chain, cytosolic', NULL, NULL, NULL, NULL, NULL, 4),
(105941, NULL, 'G3DSA:3.10.290.10:FF:000092', NULL, NULL, 'Pre-mRNA-processing factor 19 homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(105942, NULL, 'G3DSA:3.40.50.10860:FF:000038', NULL, NULL, 'Quinate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(105943, NULL, 'G3DSA:1.20.58.390:FF:000081', NULL, NULL, 'Proton-gated ion channel subunit pbo-5', NULL, NULL, NULL, NULL, NULL, 4),
(105944, NULL, 'G3DSA:1.20.1270.60:FF:000267', NULL, NULL, 'LD28528p', NULL, NULL, NULL, NULL, NULL, 4),
(105945, NULL, 'G3DSA:2.30.30.790:FF:000011', NULL, NULL, '50S ribosomal protein L19', NULL, NULL, NULL, NULL, NULL, 4),
(105946, NULL, 'G3DSA:3.30.750.70:FF:000005', NULL, NULL, 'Glycerol-3-phosphate regulon repressor DeoR family', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(105947, NULL, 'G3DSA:1.25.40.990:FF:000021', NULL, NULL, 'Proteasome 26S subunit, non-ATPase 8', NULL, NULL, NULL, NULL, NULL, 4),
(105948, NULL, 'G3DSA:3.40.50.2000:FF:000113', NULL, NULL, 'Alpha,alpha-trehalose-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(105949, NULL, 'G3DSA:1.10.10.10:FF:001388', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(105950, NULL, 'G3DSA:3.40.605.10:FF:000076', NULL, NULL, '4-hydroxybenzaldehyde dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(105951, NULL, 'G3DSA:3.90.70.10:FF:000742', NULL, NULL, 'Cysteine protease', NULL, NULL, NULL, NULL, NULL, 4),
(105952, NULL, 'G3DSA:2.60.40.2130:FF:000002', NULL, NULL, 'Putative Spondin-1', NULL, NULL, NULL, NULL, NULL, 4),
(105953, NULL, 'G3DSA:3.80.10.10:FF:001009', NULL, NULL, 'Pollen receptor-like kinase 6', NULL, NULL, NULL, NULL, NULL, 4),
(105954, NULL, 'G3DSA:1.10.510.10:FF:002972', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105955, NULL, 'G3DSA:1.10.260.170:FF:000007', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', NULL, NULL, NULL, NULL, NULL, 4),
(105956, NULL, 'G3DSA:3.30.160.60:FF:002296', NULL, NULL, 'Zinc finger protein 169', NULL, NULL, NULL, NULL, NULL, 4),
(105957, NULL, 'G3DSA:3.30.450.70:FF:000022', NULL, NULL, 'Trafficking protein particle complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(105958, NULL, 'G3DSA:2.130.10.10:FF:001953', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105959, NULL, 'G3DSA:1.10.533.10:FF:000029', NULL, NULL, 'Myeloid differentiation primary response protein MyD88', NULL, NULL, NULL, NULL, NULL, 4),
(105960, NULL, 'G3DSA:3.40.1810.10:FF:000024', NULL, NULL, 'Agamous-like MADS-box protein AGL80', NULL, NULL, NULL, NULL, NULL, 4),
(105961, NULL, 'G3DSA:2.60.40.10:FF:001008', NULL, NULL, 'Interleukin-12 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(105962, NULL, 'G3DSA:1.25.40.10:FF:001744', NULL, NULL, 'Outer envelope protein 64, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(105963, NULL, 'G3DSA:1.20.1070.10:FF:001187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105964, NULL, 'G3DSA:1.10.1200.270:FF:000029', NULL, NULL, 'Os01g0700300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(105965, NULL, 'G3DSA:2.130.10.10:FF:006045', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(105966, NULL, 'G3DSA:3.40.1110.10:FF:000347', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105967, NULL, 'G3DSA:2.80.10.50:FF:000107', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(105968, NULL, 'G3DSA:1.10.472.130:FF:000084', NULL, NULL, 'Dynein, axonemal, heavy chain 3, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(105969, NULL, 'G3DSA:3.40.50.1820:FF:001172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105970, NULL, 'G3DSA:3.60.40.10:FF:000388', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105971, NULL, 'G3DSA:1.20.120.610:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105972, NULL, 'G3DSA:2.30.180.10:FF:000105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105973, NULL, 'G3DSA:3.40.120.10:FF:000062', NULL, NULL, 'Phosphoacetylglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(105974, NULL, 'G3DSA:2.60.40.10:FF:006067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105975, NULL, 'G3DSA:2.30.29.30:FF:001248', NULL, NULL, 'Guanine exchange factor for Rac 30', NULL, NULL, NULL, NULL, NULL, 4),
(105976, NULL, 'G3DSA:3.40.50.2020:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105977, NULL, 'G3DSA:1.10.8.1290:FF:000003', NULL, NULL, 'Glutamine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(105978, NULL, 'G3DSA:3.20.80.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105979, NULL, 'G3DSA:2.10.25.10:FF:001751', NULL, NULL, 'Neuregulin 2b', NULL, NULL, NULL, NULL, NULL, 4),
(105980, NULL, 'G3DSA:3.30.160.60:FF:002239', NULL, NULL, 'Zinc finger protein 226', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(105981, NULL, 'G3DSA:1.10.1370.30:FF:000037', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(105982, NULL, 'G3DSA:1.25.10.10:FF:001916', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(105983, NULL, 'G3DSA:1.10.630.10:FF:000210', NULL, NULL, 'Ent-kaurenoic acid oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(105984, NULL, 'G3DSA:3.80.10.10:FF:001178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105985, NULL, 'G3DSA:2.115.10.20:FF:000013', NULL, NULL, 'Non-reducing end alpha-L-arabinofuranosidase BoGH43A', NULL, NULL, NULL, NULL, NULL, 4),
(105986, NULL, 'G3DSA:1.25.40.20:FF:000437', NULL, NULL, 'Lethal (2) 35Be', NULL, NULL, NULL, NULL, NULL, 4),
(105987, NULL, 'G3DSA:1.20.120.350:FF:000259', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105988, NULL, 'G3DSA:1.25.40.10:FF:000434', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(105989, NULL, 'G3DSA:1.10.20.10:FF:000146', NULL, NULL, 'Histone H2A', NULL, NULL, NULL, NULL, NULL, 4),
(105990, NULL, 'G3DSA:3.30.110.30:FF:000002', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(105991, NULL, 'G3DSA:3.40.525.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(105992, NULL, 'G3DSA:2.60.120.1040:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(105993, NULL, 'G3DSA:3.10.20.310:FF:000035', NULL, NULL, 'ShlB/FhaC/HecB family hemolysin secretion/activation protein', NULL, NULL, NULL, NULL, NULL, 4),
(105994, NULL, 'G3DSA:3.20.20.210:FF:000008', NULL, NULL, 'Uroporphyrinogen decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(105995, NULL, 'G3DSA:1.10.1300.10:FF:000044', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(105996, NULL, 'G3DSA:1.20.120.1080:FF:000058', NULL, NULL, 'ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(105997, NULL, 'G3DSA:2.60.40.10:FF:002644', NULL, NULL, 'Protease', NULL, NULL, NULL, NULL, NULL, 4),
(105998, NULL, 'G3DSA:1.10.220.10:FF:000067', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(105999, NULL, 'G3DSA:1.20.1250.20:FF:001670', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106000, NULL, 'G3DSA:3.40.50.300:FF:008423', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106001, NULL, 'G3DSA:3.90.1290.10:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106002, NULL, 'G3DSA:2.20.25.80:FF:000012', NULL, NULL, 'Probable WRKY transcription factor 38', NULL, NULL, NULL, NULL, NULL, 4),
(106003, NULL, 'G3DSA:1.10.510.10:FF:004153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106004, NULL, 'G3DSA:2.70.130.10:FF:000071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106005, NULL, 'G3DSA:2.60.40.1460:FF:000003', NULL, NULL, 'Integrin subunit alpha 7', NULL, NULL, NULL, NULL, NULL, 4),
(106006, NULL, 'G3DSA:3.90.550.10:FF:000190', NULL, NULL, '2-phospho-L-lactate guanylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(106007, NULL, 'G3DSA:1.25.40.10:FF:001963', NULL, NULL, 'Pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(106008, NULL, 'G3DSA:2.40.30.170:FF:000008', NULL, NULL, 'Multidrug resistance protein MdtN', NULL, NULL, NULL, NULL, NULL, 4),
(106009, NULL, 'G3DSA:1.10.510.10:FF:004265', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106010, NULL, 'G3DSA:3.40.800.10:FF:000029', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(106011, NULL, 'G3DSA:4.10.640.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106012, NULL, 'G3DSA:3.40.50.1240:FF:000020', NULL, NULL, 'Periplasmic AppA protein', NULL, NULL, NULL, NULL, NULL, 4),
(106013, NULL, 'G3DSA:2.20.25.90:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106014, NULL, 'G3DSA:3.40.640.10:FF:000320', NULL, NULL, 'Probable L-aspartate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(106015, NULL, 'G3DSA:3.40.640.10:FF:000500', NULL, NULL, 'Ornithine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(106016, NULL, 'G3DSA:3.30.465.10:FF:000010', NULL, NULL, 'DUF21 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(106017, NULL, 'G3DSA:3.30.420.40:FF:000764', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106018, NULL, 'G3DSA:3.60.20.40:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106019, NULL, 'G3DSA:3.40.50.80:FF:000202', NULL, NULL, 'Putative ferric reductase', NULL, NULL, NULL, NULL, NULL, 4),
(106020, NULL, 'G3DSA:3.30.70.330:FF:001474', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106021, NULL, 'G3DSA:3.10.330.20:FF:000025', NULL, NULL, 'Beta-aspartate methyltransferase (PimT), conjectural', NULL, NULL, NULL, NULL, NULL, 4),
(106022, NULL, 'G3DSA:1.10.472.10:FF:000062', NULL, NULL, 'Origin recognition complex subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(106023, NULL, 'G3DSA:2.60.40.10:FF:004830', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106024, NULL, 'G3DSA:1.10.472.10:FF:000005', NULL, NULL, 'G2/mitotic-specific cyclin B', NULL, NULL, NULL, NULL, NULL, 4),
(106025, NULL, 'G3DSA:2.60.40.2300:FF:000019', NULL, NULL, 'Neutral ceramidase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(106026, NULL, 'G3DSA:3.40.50.300:FF:001610', NULL, NULL, 'ABC transporter ATP-binding protein-sodium transport', NULL, NULL, NULL, NULL, NULL, 4),
(106027, NULL, 'G3DSA:3.40.1000.10:FF:000013', NULL, NULL, 'Putative lipoprotein LpqT', NULL, NULL, NULL, NULL, NULL, 4),
(106028, NULL, 'G3DSA:3.30.1370.130:FF:000001', NULL, NULL, 'Type IV pilus secretin PilQ', NULL, NULL, NULL, NULL, NULL, 4),
(106029, NULL, 'G3DSA:3.30.2350.20:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106030, NULL, 'G3DSA:3.90.70.40:FF:000009', NULL, NULL, 'Ataxin-3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(106031, NULL, 'G3DSA:3.40.50.1820:FF:001059', NULL, NULL, 'Lipase', NULL, NULL, NULL, NULL, NULL, 4),
(106032, NULL, 'G3DSA:1.10.720.60:FF:000024', NULL, NULL, 'Enolase-phosphatase E1', NULL, NULL, NULL, NULL, NULL, 4),
(106033, NULL, 'G3DSA:2.130.10.10:FF:000374', NULL, NULL, 'NACHT and WD repeat domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(106034, NULL, 'G3DSA:3.30.160.60:FF:005909', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106035, NULL, 'G3DSA:3.30.565.30:FF:000001', NULL, NULL, 'Sporulation initiation phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(106036, NULL, 'G3DSA:2.60.40.10:FF:001969', NULL, NULL, 'Cell surface A33 antigen', NULL, NULL, NULL, NULL, NULL, 4),
(106037, NULL, 'G3DSA:3.40.50.1000:FF:000526', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106038, NULL, 'G3DSA:2.60.120.260:FF:000211', NULL, NULL, 'Cytosolic endobeta-n-acetylglucosaminidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(106039, NULL, 'G3DSA:1.10.287.4280:FF:000002', NULL, NULL, 'Transcription factor unc-3', NULL, NULL, NULL, NULL, NULL, 4),
(106040, NULL, 'G3DSA:3.40.50.10470:FF:000067', NULL, NULL, 'Initiation factor 2 subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(106041, NULL, 'G3DSA:3.10.100.10:FF:000157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106042, NULL, 'G3DSA:1.20.1070.10:FF:001417', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106043, NULL, 'G3DSA:3.80.10.10:FF:004033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106044, NULL, 'G3DSA:3.40.50.300:FF:000773', NULL, NULL, 'Replication factor C subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(106045, NULL, 'G3DSA:2.120.10.80:FF:000260', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106046, NULL, 'G3DSA:1.10.486.10:FF:000003', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(106047, NULL, 'G3DSA:2.60.120.10:FF:000797', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106048, NULL, 'G3DSA:1.10.287.470:FF:000089', NULL, NULL, 'Multidrug resistance protein A', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(106049, NULL, 'G3DSA:3.30.160.60:FF:003875', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106050, NULL, 'G3DSA:2.60.120.920:FF:000156', NULL, NULL, 'Si:ch211-227e10.1', NULL, NULL, NULL, NULL, NULL, 4),
(106051, NULL, 'G3DSA:2.120.10.80:FF:000108', NULL, NULL, 'Kelch repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(106052, NULL, 'G3DSA:1.25.10.10:FF:000556', NULL, NULL, 'GCN1, eIF2 alpha kinase activator homolog', NULL, NULL, NULL, NULL, NULL, 4),
(106053, NULL, 'G3DSA:3.40.225.10:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106054, NULL, 'G3DSA:1.20.1250.20:FF:001176', NULL, NULL, 'GPH family Na+:melibiose symporter', NULL, NULL, NULL, NULL, NULL, 4),
(106055, NULL, 'G3DSA:3.40.50.11380:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106056, NULL, 'G3DSA:3.30.70.3490:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106057, NULL, 'G3DSA:3.40.190.10:FF:000010', NULL, NULL, 'glutamate receptor ionotropic, NMDA 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(106058, NULL, 'G3DSA:3.40.50.150:FF:000705', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106059, NULL, 'G3DSA:3.90.1680.10:FF:000001', NULL, NULL, 'Abasic site processing protein HMCES', NULL, NULL, NULL, NULL, NULL, 4),
(106060, NULL, 'G3DSA:3.30.160.60:FF:004482', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106061, NULL, 'G3DSA:1.10.10.60:FF:000306', NULL, NULL, 'Muscle segmentation homeobox', NULL, NULL, NULL, NULL, NULL, 4),
(106062, NULL, 'G3DSA:1.25.10.10:FF:001899', NULL, NULL, 'Pumilio-like 24 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(106063, NULL, 'G3DSA:1.20.1070.10:FF:001018', NULL, NULL, 'AKH/corazonin-related peptide', NULL, NULL, NULL, NULL, NULL, 4),
(106064, NULL, 'G3DSA:3.40.50.300:FF:007006', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106065, NULL, 'G3DSA:1.10.3430.10:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106066, NULL, 'G3DSA:3.20.20.370:FF:000028', NULL, NULL, 'Putative Chitin deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(106067, NULL, 'G3DSA:3.90.226.10:FF:000329', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106068, NULL, 'G3DSA:3.30.1360.140:FF:000002', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(106069, NULL, 'G3DSA:1.25.40.20:FF:001112', NULL, NULL, 'AGAP010413-PA', NULL, NULL, NULL, NULL, NULL, 4),
(106070, NULL, 'G3DSA:2.10.25.10:FF:001190', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106071, NULL, 'G3DSA:1.10.510.10:FF:003658', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106072, NULL, 'G3DSA:3.40.50.10190:FF:000197', NULL, NULL, 'Protein CBR-MUS-101', NULL, NULL, NULL, NULL, NULL, 4),
(106073, NULL, 'G3DSA:1.20.1250.20:FF:001119', NULL, NULL, 'Arabinose efflux permease', NULL, NULL, NULL, NULL, NULL, 4),
(106074, NULL, 'G3DSA:1.25.40.10:FF:004543', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106075, NULL, 'G3DSA:1.10.238.10:FF:000922', NULL, NULL, 'EF-hand calcium-binding domain-containing protein 6-like', NULL, NULL, NULL, NULL, NULL, 4),
(106076, NULL, 'G3DSA:3.10.120.10:FF:000046', NULL, NULL, 'Chitin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(106077, NULL, 'G3DSA:3.50.7.10:FF:000026', NULL, NULL, 'T-complex protein 1 subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(106078, NULL, 'G3DSA:3.40.1080.10:FF:000006', NULL, NULL, '6-acetamido-3-oxohexanoate:acetyl-CoA CoA transferase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(106079, NULL, 'G3DSA:1.10.510.10:FF:000555', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(106080, NULL, 'G3DSA:3.30.40.10:FF:000985', NULL, NULL, 'RING/U-box superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(106081, NULL, 'G3DSA:1.10.8.100:FF:000013', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(106082, NULL, 'G3DSA:1.25.40.10:FF:002126', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(106083, NULL, 'G3DSA:1.20.210.10:FF:000013', NULL, NULL, 'Cytochrome c oxidase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(106084, NULL, 'G3DSA:1.25.10.10:FF:002916', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106085, NULL, 'G3DSA:1.10.238.10:FF:000703', NULL, NULL, 'Calmodulin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(106086, NULL, 'G3DSA:1.20.1110.10:FF:000117', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(106087, NULL, 'G3DSA:1.20.58.80:FF:000057', NULL, NULL, 'Vacuolar protein sorting-associated protein 4B', NULL, NULL, NULL, NULL, NULL, 4),
(106088, NULL, 'G3DSA:2.60.40.150:FF:000135', NULL, NULL, 'Plant synaptotagmin', NULL, NULL, NULL, NULL, NULL, 4),
(106089, NULL, 'G3DSA:3.30.519.10:FF:000012', NULL, NULL, 'Rab proteins geranylgeranyltransferase component', NULL, NULL, NULL, NULL, NULL, 4),
(106090, NULL, 'G3DSA:2.10.25.10:FF:000857', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106091, NULL, 'G3DSA:3.40.50.300:FF:002392', NULL, NULL, 'DnaJ-like protein subfamily C member 27', NULL, NULL, NULL, NULL, NULL, 4),
(106092, NULL, 'G3DSA:2.60.40.150:FF:000079', NULL, NULL, 'copine-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(106093, NULL, 'G3DSA:2.40.10.10:FF:000389', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106094, NULL, 'G3DSA:3.80.10.10:FF:003651', NULL, NULL, 'F-box and leucine-rich repeat protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(106095, NULL, 'G3DSA:1.10.533.10:FF:000316', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106096, NULL, 'G3DSA:2.40.170.20:FF:000055', NULL, NULL, 'Heme receptor HasR', NULL, NULL, NULL, NULL, NULL, 4),
(106097, NULL, 'G3DSA:1.20.58.70:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106098, NULL, 'G3DSA:2.60.40.10:FF:002026', NULL, NULL, 'Prostaglandin F2 receptor inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(106099, NULL, 'G3DSA:2.30.42.10:FF:000250', NULL, NULL, 'Lap1, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(106100, NULL, 'G3DSA:1.10.418.10:FF:000127', NULL, NULL, 'Cortexillin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(106101, NULL, 'G3DSA:2.120.10.30:FF:000447', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106102, NULL, 'G3DSA:1.10.8.270:FF:000036', NULL, NULL, 'GTPase-activating protein GYP3', NULL, NULL, NULL, NULL, NULL, 4),
(106103, NULL, 'G3DSA:2.40.10.10:FF:000445', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106104, NULL, 'G3DSA:3.90.940.20:FF:000003', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106105, NULL, 'G3DSA:3.40.50.150:FF:001829', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106106, NULL, 'G3DSA:2.120.10.30:FF:000503', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106107, NULL, 'G3DSA:3.40.50.10740:FF:000002', NULL, NULL, 'Microcin immunity protein MccF', NULL, NULL, NULL, NULL, NULL, 4),
(106108, NULL, 'G3DSA:3.30.200.20:FF:001793', NULL, NULL, 'Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(106109, NULL, 'G3DSA:3.30.160.60:FF:002857', NULL, NULL, 'Si:dkeyp-82b4.3', NULL, NULL, NULL, NULL, NULL, 4),
(106110, NULL, 'G3DSA:2.40.30.10:FF:000172', NULL, NULL, 'Unplaced genomic scaffold supercont1.10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(106111, NULL, 'G3DSA:3.40.50.300:FF:006006', NULL, NULL, 'UvrABC system protein A', NULL, NULL, NULL, NULL, NULL, 4),
(106112, NULL, 'G3DSA:2.60.120.260:FF:000031', NULL, NULL, 'DUF642 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(106113, NULL, 'G3DSA:3.60.21.60:FF:000016', NULL, NULL, 'DNA polymerase alpha subunit B-like', NULL, NULL, NULL, NULL, NULL, 4),
(106114, NULL, 'G3DSA:3.40.50.980:FF:000044', NULL, NULL, 'Peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(106115, NULL, 'G3DSA:3.30.160.60:FF:003133', NULL, NULL, 'zinc finger protein 271', NULL, NULL, NULL, NULL, NULL, 4),
(106116, NULL, 'G3DSA:1.10.1040.10:FF:000001', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(P)+]', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(106117, NULL, 'G3DSA:1.25.10.10:FF:000500', NULL, NULL, 'VAC14 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(106118, NULL, 'G3DSA:1.10.220.60:FF:000003', NULL, NULL, 'GRIP and coiled-coil domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(106119, NULL, 'G3DSA:3.30.420.80:FF:000023', NULL, NULL, 'YALI0E14124p', NULL, NULL, NULL, NULL, NULL, 4),
(106120, NULL, 'G3DSA:3.40.190.10:FF:000066', NULL, NULL, 'Glutamate receptor ionotropic, NMDA 3A', NULL, NULL, NULL, NULL, NULL, 4),
(106121, NULL, 'G3DSA:2.40.100.10:FF:000047', NULL, NULL, 'Urea amidolyase', NULL, NULL, NULL, NULL, NULL, 4),
(106122, NULL, 'G3DSA:2.10.25.10:FF:001077', NULL, NULL, 'Notch receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(106123, NULL, 'G3DSA:3.40.50.1820:FF:001402', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106124, NULL, 'G3DSA:1.10.1410.10:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106125, NULL, 'G3DSA:3.60.21.50:FF:000013', NULL, NULL, 'DNA polymerase epsilon subunit b domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(106126, NULL, 'G3DSA:3.40.850.10:FF:000420', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106127, NULL, 'G3DSA:3.40.50.970:FF:000041', NULL, NULL, 'Pyruvate:ferredoxin (Flavodoxin) oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(106128, NULL, 'G3DSA:3.40.50.300:FF:000593', NULL, NULL, 'DNA repair protein RAD50', NULL, NULL, NULL, NULL, NULL, 4),
(106129, NULL, 'G3DSA:3.30.1380.20:FF:000052', NULL, NULL, 'Trafficking protein particle complex 6b-like', NULL, NULL, NULL, NULL, NULL, 4),
(106130, NULL, 'G3DSA:3.30.420.40:FF:000146', NULL, NULL, 'Type III pantothenate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(106131, NULL, 'G3DSA:2.60.40.10:FF:000845', NULL, NULL, 'Hyaluronan and proteoglycan link protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(106132, NULL, 'G3DSA:1.10.10.60:FF:000924', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106133, NULL, 'G3DSA:2.130.10.10:FF:005663', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106134, NULL, 'G3DSA:1.10.472.130:FF:000027', NULL, NULL, 'Dynein, axonemal, heavy chain 14', NULL, NULL, NULL, NULL, NULL, 4),
(106135, NULL, 'G3DSA:3.30.1370.10:FF:000109', NULL, NULL, 'Heterogeneous nuclear rnp K-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(106136, NULL, 'G3DSA:1.20.20.10:FF:000005', NULL, NULL, 'ATP synthase subunit 9, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(106137, NULL, 'G3DSA:1.10.510.10:FF:003990', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106138, NULL, 'G3DSA:3.50.50.60:FF:001359', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(106139, NULL, 'G3DSA:3.10.110.10:FF:000219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106140, NULL, 'G3DSA:1.20.120.720:FF:000044', NULL, NULL, 'Chitin synthase-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(106141, NULL, 'G3DSA:1.10.10.10:FF:000426', NULL, NULL, 'Transcriptional regulator MT0503', NULL, NULL, NULL, NULL, NULL, 4),
(106142, NULL, 'G3DSA:2.40.30.10:FF:000059', NULL, NULL, 'dual oxidase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(106143, NULL, 'G3DSA:3.20.20.70:FF:000266', NULL, NULL, '4-hydroxy-2-oxoglutarate aldolase/2-dehydro-3-deoxyphosphogluconate', NULL, NULL, NULL, NULL, NULL, 4),
(106144, NULL, 'G3DSA:3.80.10.10:FF:003033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106145, NULL, 'G3DSA:1.25.40.10:FF:002525', NULL, NULL, 'Zinc finger family protein', NULL, NULL, NULL, NULL, NULL, 4),
(106146, NULL, 'G3DSA:3.80.10.10:FF:001739', NULL, NULL, 'MIP30824p1', NULL, NULL, NULL, NULL, NULL, 4),
(106147, NULL, 'G3DSA:3.10.660.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106148, NULL, 'G3DSA:1.10.730.10:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106149, NULL, 'G3DSA:3.30.420.340:FF:000005', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(106150, NULL, 'G3DSA:2.60.40.10:FF:001121', NULL, NULL, 'Fc receptor like B', NULL, NULL, NULL, NULL, NULL, 4),
(106151, NULL, 'G3DSA:4.10.60.10:FF:000024', NULL, NULL, 'terminal uridylyltransferase 7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(106152, NULL, 'G3DSA:3.10.100.10:FF:000432', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106153, NULL, 'G3DSA:1.10.506.10:FF:000006', NULL, NULL, 'Plexin A1', NULL, NULL, NULL, NULL, NULL, 4),
(106154, NULL, 'G3DSA:2.130.10.10:FF:002734', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106155, NULL, 'G3DSA:1.20.870.10:FF:000046', NULL, NULL, 'Ras guanine nucleotide exchange factor V', NULL, NULL, NULL, NULL, NULL, 4),
(106156, NULL, 'G3DSA:1.10.472.10:FF:000623', NULL, NULL, 'Meiosis-specific cyclin rem1', NULL, NULL, NULL, NULL, NULL, 4),
(106157, NULL, 'G3DSA:2.60.40.10:FF:000227', NULL, NULL, 'Fibronectin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(106158, NULL, 'G3DSA:1.20.58.60:FF:000051', NULL, NULL, 'Short stop, isoform K', NULL, NULL, NULL, NULL, NULL, 4),
(106159, NULL, 'G3DSA:3.90.740.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106160, NULL, 'G3DSA:3.40.50.2300:FF:001445', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106161, NULL, 'G3DSA:1.25.40.10:FF:004324', NULL, NULL, 'Protein O-mannosyl-transferase TMTC1', NULL, NULL, NULL, NULL, NULL, 4),
(106162, NULL, 'G3DSA:2.60.40.10:FF:004555', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106163, NULL, 'G3DSA:3.80.10.10:FF:003538', NULL, NULL, 'Tubulin-specific chaperone cofactor E-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(106164, NULL, 'G3DSA:3.40.50.12280:FF:000003', NULL, NULL, 'NAD(P)H-quinone oxidoreductase subunit K, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(106165, NULL, 'G3DSA:1.10.287.2250:FF:000017', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106166, NULL, 'G3DSA:3.40.50.1820:FF:001677', NULL, NULL, 'ArfGAP', NULL, NULL, NULL, NULL, NULL, 4),
(106167, NULL, 'G3DSA:3.90.550.10:FF:000419', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106168, NULL, 'G3DSA:1.10.10.10:FF:000084', NULL, NULL, 'paired box protein Pax-9', NULL, NULL, NULL, NULL, NULL, 4),
(106169, NULL, 'G3DSA:2.60.40.10:FF:000284', NULL, NULL, 'interleukin-1 receptor accessory protein-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(106170, NULL, 'G3DSA:3.90.80.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106171, NULL, 'G3DSA:3.30.870.10:FF:000070', NULL, NULL, 'Phospholipase D family protein', NULL, NULL, NULL, NULL, NULL, 4),
(106172, NULL, 'G3DSA:2.60.40.10:FF:002425', NULL, NULL, 'Down syndrome cell adhesion molecule 3, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(106173, NULL, 'G3DSA:3.30.2140.20:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106174, NULL, 'G3DSA:1.25.40.10:FF:002183', NULL, NULL, 'GH04440p', NULL, NULL, NULL, NULL, NULL, 4),
(106175, NULL, 'G3DSA:1.10.510.10:FF:002079', NULL, NULL, 'Serine/threonine-protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(106176, NULL, 'G3DSA:1.10.10.60:FF:000582', NULL, NULL, 'HTH-type transcriptional regulator VirS', NULL, NULL, NULL, NULL, NULL, 4),
(106177, NULL, 'G3DSA:3.30.900.10:FF:000011', NULL, NULL, 'HORMA domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(106178, NULL, 'G3DSA:2.30.30.1020:FF:000007', NULL, NULL, 'Putative not2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(106179, NULL, 'G3DSA:3.40.50.150:FF:000525', NULL, NULL, 'S-adenosyl-methyltransferase mraW-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(106180, NULL, 'G3DSA:1.20.1250.20:FF:000102', NULL, NULL, 'Inner membrane protein ybjJ', NULL, NULL, NULL, NULL, NULL, 4),
(106181, NULL, 'G3DSA:3.40.50.150:FF:000582', NULL, NULL, 'AflS/ pathway regulator', NULL, NULL, NULL, NULL, NULL, 4),
(106182, NULL, 'G3DSA:3.30.60.60:FF:000012', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(106183, NULL, 'G3DSA:1.10.150.390:FF:000009', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(106184, NULL, 'G3DSA:1.50.40.10:FF:000371', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106185, NULL, 'G3DSA:1.10.940.10:FF:000020', NULL, NULL, 'Transcription antitermination protein NusB', NULL, NULL, NULL, NULL, NULL, 4),
(106186, NULL, 'G3DSA:2.70.170.10:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106187, NULL, 'G3DSA:3.30.800.10:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106188, NULL, 'G3DSA:3.40.395.10:FF:000036', NULL, NULL, 'Ubiquitin-like-specific protease ESD4', NULL, NULL, NULL, NULL, NULL, 4),
(106189, NULL, 'G3DSA:2.40.70.10:FF:000511', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106190, NULL, 'G3DSA:3.40.1280.10:FF:000100', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106191, NULL, 'G3DSA:2.130.10.10:FF:000593', NULL, NULL, 'Ribosome biogenesis protein ytm1', NULL, NULL, NULL, NULL, NULL, 4),
(106192, NULL, 'G3DSA:1.10.1170.10:FF:000005', NULL, NULL, 'Baculoviral IAP repeat containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(106193, NULL, 'G3DSA:1.20.120.1200:FF:000021', NULL, NULL, 'NADH-quinone oxidoreductase subunit J', NULL, NULL, NULL, NULL, NULL, 4),
(106194, NULL, 'G3DSA:3.30.160.60:FF:005786', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106195, NULL, 'G3DSA:3.40.640.10:FF:000264', NULL, NULL, 'Kynurenine--oxoglutarate transaminase 1', NULL, NULL, NULL, NULL, NULL, 4),
(106196, NULL, 'G3DSA:1.10.8.60:FF:000558', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106197, NULL, 'G3DSA:3.40.50.2300:FF:001389', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106198, NULL, 'G3DSA:3.40.140.10:FF:000282', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(106199, NULL, 'G3DSA:3.10.10.10:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106200, NULL, 'G3DSA:3.30.160.150:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106201, NULL, 'G3DSA:2.60.40.10:FF:005050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106202, NULL, 'G3DSA:3.30.160.60:FF:002970', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(106203, NULL, 'G3DSA:3.40.50.300:FF:006225', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106204, NULL, 'G3DSA:2.60.40.150:FF:000753', NULL, NULL, 'Prkca protein', NULL, NULL, NULL, NULL, NULL, 4),
(106205, NULL, 'G3DSA:2.60.220.30:FF:000007', NULL, NULL, 'Ankyrin-2 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(106206, NULL, 'G3DSA:3.65.10.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106207, NULL, 'G3DSA:2.120.10.30:FF:000560', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106208, NULL, 'G3DSA:1.20.1050.10:FF:000224', NULL, NULL, 'Glutathione s-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(106209, NULL, 'G3DSA:1.10.10.10:FF:001101', NULL, NULL, 'Ferric-uptake regulator', NULL, NULL, NULL, NULL, NULL, 4),
(106210, NULL, 'G3DSA:2.70.150.10:FF:000246', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(106211, NULL, 'G3DSA:1.10.150.20:FF:000064', NULL, NULL, 'Bifunctional 3''-5'' exonuclease/DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(106212, NULL, 'G3DSA:3.30.479.30:FF:000014', NULL, NULL, 'Inner membrane protein YqiK', NULL, NULL, NULL, NULL, NULL, 4),
(106213, NULL, 'G3DSA:1.10.510.10:FF:001859', NULL, NULL, 'Probable serine/threonine-protein kinase roco4', NULL, NULL, NULL, NULL, NULL, 4),
(106214, NULL, 'G3DSA:3.80.10.10:FF:002757', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106215, NULL, 'G3DSA:2.60.220.10:FF:000001', NULL, NULL, 'Chondroitin sulfate ABC exolyase', NULL, NULL, NULL, NULL, NULL, 4),
(106216, NULL, 'G3DSA:2.60.40.10:FF:002700', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(106217, NULL, 'G3DSA:3.30.559.30:FF:000015', NULL, NULL, 'Nonribosomal siderophore peptide synthase SidC', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(106218, NULL, 'G3DSA:1.25.40.10:FF:002744', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106219, NULL, 'G3DSA:3.30.559.30:FF:000072', NULL, NULL, 'Lovastatin nonaketide synthase, polyketide synthase component', NULL, NULL, NULL, NULL, NULL, 4),
(106220, NULL, 'G3DSA:1.20.120.1900:FF:000023', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(106221, NULL, 'G3DSA:1.10.510.10:FF:002354', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106222, NULL, 'G3DSA:3.40.1230.10:FF:000002', NULL, NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex assembly factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(106223, NULL, 'G3DSA:3.80.20.20:FF:000046', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(106224, NULL, 'G3DSA:1.20.1090.10:FF:000002', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(106225, NULL, 'G3DSA:3.40.50.1000:FF:000706', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106226, NULL, 'G3DSA:1.25.40.10:FF:003020', NULL, NULL, 'Tetratricopeptide repeat protein 30A', NULL, NULL, NULL, NULL, NULL, 4),
(106227, NULL, 'G3DSA:1.25.10.10:FF:002355', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106228, NULL, 'G3DSA:1.20.120.1910:FF:000026', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(106229, NULL, 'G3DSA:1.20.1250.40:FF:000041', NULL, NULL, 'DNA-directed RNA polymerase II subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(106230, NULL, 'G3DSA:1.10.3450.20:FF:000002', NULL, NULL, 'Nuclear pore complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(106231, NULL, 'G3DSA:1.20.58.340:FF:000088', NULL, NULL, 'Mg2+ transporter protein, CorA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(106232, NULL, 'G3DSA:1.10.357.70:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106233, NULL, 'G3DSA:3.40.50.12650:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106234, NULL, 'G3DSA:2.70.150.10:FF:000066', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(106235, NULL, 'G3DSA:2.60.120.260:FF:000250', NULL, NULL, 'Coagulation factor V', NULL, NULL, NULL, NULL, NULL, 4),
(106236, NULL, 'G3DSA:2.40.30.10:FF:000391', NULL, NULL, 'Mitochondrial tRNA-specific 2-thiouridylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(106237, NULL, 'G3DSA:1.10.510.10:FF:002135', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(106238, NULL, 'G3DSA:2.60.120.820:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106239, NULL, 'G3DSA:3.40.50.150:FF:000469', NULL, NULL, 'Spermine/spermidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(106240, NULL, 'G3DSA:3.40.50.1000:FF:000420', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(106241, NULL, 'G3DSA:3.40.640.10:FF:000207', NULL, NULL, 'DegT/DnrJ/EryC1/StrS aminotransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(106242, NULL, 'G3DSA:3.40.30.10:FF:000731', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106243, NULL, 'G3DSA:2.160.20.10:FF:000221', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106244, NULL, 'G3DSA:3.40.50.150:FF:001020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106245, NULL, 'G3DSA:1.10.1040.30:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106246, NULL, 'G3DSA:3.40.50.11410:FF:000001', NULL, NULL, 'Hydrogenase maturation GTPase HydF', NULL, NULL, NULL, NULL, NULL, 4),
(106247, NULL, 'G3DSA:1.10.10.10:FF:000606', NULL, NULL, 'Transcription factor E', NULL, NULL, NULL, NULL, NULL, 4),
(106248, NULL, 'G3DSA:3.30.65.10:FF:000008', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(106249, NULL, 'G3DSA:3.10.310.20:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106250, NULL, 'G3DSA:2.60.40.150:FF:000192', NULL, NULL, 'Calcium-dependent lipid-binding family protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(106251, NULL, 'G3DSA:1.10.760.10:FF:000034', NULL, NULL, 'Ubiquinol--cytochrome c reductase, cytochrome c1', NULL, NULL, NULL, NULL, NULL, 4),
(106252, NULL, 'G3DSA:2.40.50.730:FF:000023', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(106253, NULL, 'G3DSA:2.20.110.10:FF:000030', NULL, NULL, 'MORN repeat-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(106254, NULL, 'G3DSA:1.10.246.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106255, NULL, 'G3DSA:2.120.10.30:FF:000228', NULL, NULL, 'Flagellar glycoprotein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(106256, NULL, 'G3DSA:3.40.50.720:FF:001287', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(106257, NULL, 'G3DSA:1.20.58.830:FF:000033', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(106258, NULL, 'G3DSA:3.40.50.300:FF:002914', NULL, NULL, 'Shikimate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(106259, NULL, 'G3DSA:2.40.30.10:FF:000115', NULL, NULL, 'Eukaryotic translation elongation factor 1 alpha', NULL, NULL, NULL, NULL, NULL, 4),
(106260, NULL, 'G3DSA:1.25.40.150:FF:000005', NULL, NULL, 'V-type proton ATPase subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(106261, NULL, 'G3DSA:3.30.160.60:FF:006281', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106262, NULL, 'G3DSA:3.10.100.10:FF:000270', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106263, NULL, 'G3DSA:3.30.160.60:FF:002352', NULL, NULL, 'Zinc finger protein 154', NULL, NULL, NULL, NULL, NULL, 4),
(106264, NULL, 'G3DSA:3.30.160.60:FF:002913', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106265, NULL, 'G3DSA:3.40.50.300:FF:006282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106266, NULL, 'G3DSA:3.30.160.60:FF:006129', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106267, NULL, 'G3DSA:3.40.720.10:FF:000265', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106268, NULL, 'G3DSA:3.10.100.10:FF:000213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106269, NULL, 'G3DSA:3.40.50.2300:FF:001664', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106270, NULL, 'G3DSA:2.10.220.10:FF:000086', NULL, NULL, 'R-spondin-3', NULL, NULL, NULL, NULL, NULL, 4),
(106271, NULL, 'G3DSA:3.40.50.410:FF:000295', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106272, NULL, 'G3DSA:3.30.505.10:FF:000071', NULL, NULL, 'SH2 domain containing 3A', NULL, NULL, NULL, NULL, NULL, 4),
(106273, NULL, 'G3DSA:1.10.760.10:FF:000091', NULL, NULL, 'Fructose dehydrogenase cytochrome subunit', NULL, NULL, NULL, NULL, NULL, 4),
(106274, NULL, 'G3DSA:3.30.420.40:FF:000820', NULL, NULL, 'Os11g0187800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(106275, NULL, 'G3DSA:3.10.490.10:FF:000034', NULL, NULL, 'Gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(106276, NULL, 'G3DSA:3.30.70.330:FF:000170', NULL, NULL, 'Serine/arginine-rich splicing factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(106277, NULL, 'G3DSA:2.10.110.10:FF:000313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106278, NULL, 'G3DSA:1.20.1280.50:FF:000091', NULL, NULL, 'F-box protein', NULL, NULL, NULL, NULL, NULL, 4),
(106279, NULL, 'G3DSA:3.40.850.10:FF:000021', NULL, NULL, 'kinesin-like protein KIF16B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(106280, NULL, 'G3DSA:3.40.980.10:FF:000025', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(106281, NULL, 'G3DSA:1.10.510.10:FF:002753', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106282, NULL, 'G3DSA:2.40.50.140:FF:000122', NULL, NULL, 'Small ribosomal subunit biogenesis GTPase RsgA', NULL, NULL, NULL, NULL, NULL, 4),
(106283, NULL, 'G3DSA:1.10.1420.10:FF:000109', NULL, NULL, 'AaceriAFR603Cp', NULL, NULL, NULL, NULL, NULL, 4),
(106284, NULL, 'G3DSA:3.40.50.10810:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106285, NULL, 'G3DSA:2.10.220.10:FF:000029', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(106286, NULL, 'G3DSA:2.10.25.10:FF:001638', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106287, NULL, 'G3DSA:3.80.10.10:FF:003252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106288, NULL, 'G3DSA:1.20.1070.10:FF:000113', NULL, NULL, 'probable G-protein coupled receptor 85', NULL, NULL, NULL, NULL, NULL, 4),
(106289, NULL, 'G3DSA:1.10.150.380:FF:000006', NULL, NULL, 'Aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(106290, NULL, 'G3DSA:3.10.110.10:FF:000096', NULL, NULL, 'Ubiquitin-conjugating enzyme E2-21 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(106291, NULL, 'G3DSA:3.60.15.10:FF:000026', NULL, NULL, 'metallo-beta-lactamase domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(106292, NULL, 'G3DSA:3.30.230.130:FF:000034', NULL, NULL, 'Cullin', NULL, NULL, NULL, NULL, NULL, 4),
(106293, NULL, 'G3DSA:1.20.1560.10:FF:000488', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(106294, NULL, 'G3DSA:2.160.20.10:FF:000322', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106295, NULL, 'G3DSA:2.40.50.140:FF:000245', NULL, NULL, 'Programmed cell death 11', NULL, NULL, NULL, NULL, NULL, 4),
(106296, NULL, 'G3DSA:3.90.70.10:FF:000405', NULL, NULL, 'cathepsin L1-like isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(106297, NULL, 'G3DSA:3.90.550.10:FF:000734', NULL, NULL, 'Uncharacterized glycosyltransferase HI_1696', NULL, NULL, NULL, NULL, NULL, 4),
(106298, NULL, 'G3DSA:2.120.10.80:FF:000237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106299, NULL, 'G3DSA:1.25.40.10:FF:002008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106300, NULL, 'G3DSA:3.30.160.60:FF:004780', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106301, NULL, 'G3DSA:3.30.559.30:FF:000088', NULL, NULL, 'Nonribosomal peptide synthetase 9', NULL, NULL, NULL, NULL, NULL, 4),
(106302, NULL, 'G3DSA:4.10.860.120:FF:000025', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(106303, NULL, 'G3DSA:1.10.10.10:FF:001837', NULL, NULL, 'Transcription factor, E2F and DP-related', NULL, NULL, NULL, NULL, NULL, 4),
(106304, NULL, 'G3DSA:1.10.730.10:FF:000173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106305, NULL, 'G3DSA:3.30.200.20:FF:000146', NULL, NULL, 'receptor-like serine/threonine-protein kinase ALE2', NULL, NULL, NULL, NULL, NULL, 4),
(106306, NULL, 'G3DSA:3.40.50.620:FF:000796', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106307, NULL, 'G3DSA:2.130.10.10:FF:000621', NULL, NULL, 'Dmx like 2', NULL, NULL, NULL, NULL, NULL, 4),
(106308, NULL, 'G3DSA:3.30.565.10:FF:000506', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106309, NULL, 'G3DSA:3.40.50.300:FF:006315', NULL, NULL, 'DNA helicase INO80', NULL, NULL, NULL, NULL, NULL, 4),
(106310, NULL, 'G3DSA:3.40.50.300:FF:008439', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106311, NULL, 'G3DSA:2.40.180.10:FF:000013', NULL, NULL, 'Catalase', NULL, NULL, NULL, NULL, NULL, 4),
(106312, NULL, 'G3DSA:1.20.140.150:FF:000080', NULL, NULL, 'Non-anchored cell wall protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(106313, NULL, 'G3DSA:3.30.750.24:FF:000080', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(106314, NULL, 'G3DSA:3.40.50.300:FF:002616', NULL, NULL, 'Exonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(106315, NULL, 'G3DSA:3.40.190.290:FF:000018', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(106316, NULL, 'G3DSA:3.40.50.300:FF:005213', NULL, NULL, 'Rab-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(106317, NULL, 'G3DSA:2.20.70.10:FF:000118', NULL, NULL, 'Transcription elongation regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(106318, NULL, 'G3DSA:3.40.1050.10:FF:000016', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(106319, NULL, 'G3DSA:2.130.10.10:FF:004353', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106320, NULL, 'G3DSA:1.10.560.10:FF:000047', NULL, NULL, '60 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(106321, NULL, 'G3DSA:2.60.120.10:FF:000286', NULL, NULL, 'DNA damage-repair/toleration protein DRT102', NULL, NULL, NULL, NULL, NULL, 4),
(106322, NULL, 'G3DSA:3.40.50.300:FF:004180', NULL, NULL, 'Small GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(106323, NULL, 'G3DSA:2.60.40.60:FF:000388', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor', NULL, NULL, NULL, NULL, NULL, 4),
(106324, NULL, 'G3DSA:2.170.270.10:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106325, NULL, 'G3DSA:3.40.50.880:FF:000047', NULL, NULL, 'GMP synthase [glutamine-hydrolyzing] subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(106326, NULL, 'G3DSA:1.10.132.60:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106327, NULL, 'G3DSA:3.30.70.330:FF:000350', NULL, NULL, 'heterogeneous nuclear ribonucleoprotein A3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(106328, NULL, 'G3DSA:3.90.1290.10:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106329, NULL, 'G3DSA:1.20.1250.20:FF:001636', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106330, NULL, 'G3DSA:3.30.450.190:FF:000011', NULL, NULL, 'Ras-like small GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(106331, NULL, 'G3DSA:1.25.10.10:FF:002506', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106332, NULL, 'G3DSA:2.10.25.10:FF:001189', NULL, NULL, 'Fibrillin 1', NULL, NULL, NULL, NULL, NULL, 4),
(106333, NULL, 'G3DSA:3.40.50.2300:FF:001428', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106334, NULL, 'G3DSA:3.10.20.90:FF:000295', NULL, NULL, 'AGAP008705-PA', NULL, NULL, NULL, NULL, NULL, 4),
(106335, NULL, 'G3DSA:2.60.40.10:FF:002088', NULL, NULL, 'Polycystic kidney disease 1a', NULL, NULL, NULL, NULL, NULL, 4),
(106336, NULL, 'G3DSA:3.30.160.60:FF:000076', NULL, NULL, 'Putative cyclic AMP-dependent transcription factor ATF-2', NULL, NULL, NULL, NULL, NULL, 4),
(106337, NULL, 'G3DSA:3.30.2160.10:FF:000004', NULL, NULL, 'probable E3 ubiquitin-protein ligase HERC4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(106338, NULL, 'G3DSA:3.80.10.10:FF:003813', NULL, NULL, 'Volume-regulated anion channel subunit LRRC8C', NULL, NULL, NULL, NULL, NULL, 4),
(106339, NULL, 'G3DSA:1.20.1560.10:FF:000937', NULL, NULL, 'Chromosome 23, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(106340, NULL, 'G3DSA:1.10.472.170:FF:000011', NULL, NULL, 'Transcription initiation factor IIB', NULL, NULL, NULL, NULL, NULL, 4),
(106341, NULL, 'G3DSA:3.40.50.11860:FF:000006', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(106342, NULL, 'G3DSA:3.40.630.10:FF:000331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106343, NULL, 'G3DSA:3.30.1550.10:FF:000011', NULL, NULL, 'LSU ribosomal protein L11P', NULL, NULL, NULL, NULL, NULL, 4),
(106344, NULL, 'G3DSA:2.60.40.10:FF:000643', NULL, NULL, 'RIMS-binding protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(106345, NULL, 'G3DSA:3.40.50.2300:FF:000326', NULL, NULL, 'Vomeronasal 2, receptor 56', NULL, NULL, NULL, NULL, NULL, 4),
(106346, NULL, 'G3DSA:3.30.70.610:FF:000001', NULL, NULL, 'Quinone-dependent D-lactate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(106347, NULL, 'G3DSA:1.20.120.220:FF:000012', NULL, NULL, 'ATP synthase subunit a', NULL, NULL, NULL, NULL, NULL, 4),
(106348, NULL, 'G3DSA:2.60.40.150:FF:000124', NULL, NULL, 'extended synaptotagmin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(106349, NULL, 'G3DSA:3.60.21.10:FF:000462', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(106350, NULL, 'G3DSA:3.40.50.300:FF:005798', NULL, NULL, 'Peroxisome biogenesis protein 6', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(106351, NULL, 'G3DSA:1.20.120.350:FF:000068', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(106352, NULL, 'G3DSA:3.20.20.60:FF:000139', NULL, NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(106353, NULL, 'G3DSA:3.30.70.330:FF:000979', NULL, NULL, 'SUPpressor', NULL, NULL, NULL, NULL, NULL, 4),
(106354, NULL, 'G3DSA:1.20.5.190:FF:000094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106355, NULL, 'G3DSA:1.20.1070.10:FF:001535', NULL, NULL, 'Zgo4', NULL, NULL, NULL, NULL, NULL, 4),
(106356, NULL, 'G3DSA:1.10.20.10:FF:000337', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106357, NULL, 'G3DSA:3.40.350.10:FF:000056', NULL, NULL, 'SPT16 homolog, facilitates chromatin-remodeling subunit', NULL, NULL, NULL, NULL, NULL, 4),
(106358, NULL, 'G3DSA:1.10.510.10:FF:000645', NULL, NULL, 'Probable serine/threonine-protein kinase DDB_G0268078', NULL, NULL, NULL, NULL, NULL, 4),
(106359, NULL, 'G3DSA:1.10.510.10:FF:004344', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106360, NULL, 'G3DSA:2.60.40.1170:FF:000040', NULL, NULL, 'AP-2 complex subunit mu', NULL, NULL, NULL, NULL, NULL, 4),
(106361, NULL, 'G3DSA:3.20.20.70:FF:000468', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106362, NULL, 'G3DSA:3.40.50.1820:FF:001357', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106363, NULL, 'G3DSA:1.10.238.10:FF:000366', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(106364, NULL, 'G3DSA:1.10.287.90:FF:000020', NULL, NULL, 'Cytochrome c oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(106365, NULL, 'G3DSA:1.10.10.60:FF:000610', NULL, NULL, 'MmsAB operon regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(106366, NULL, 'G3DSA:1.20.1070.10:FF:001905', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106367, NULL, 'G3DSA:2.40.110.10:FF:000065', NULL, NULL, 'L-prolyl-[peptidyl-carrier protein] dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(106368, NULL, 'G3DSA:3.30.10.10:FF:000005', NULL, NULL, 'Probable Dol-P-Man:Man(7)GlcNAc(2)-PP-Dol alpha-1,6-mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(106369, NULL, 'G3DSA:3.40.30.10:FF:000719', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(106370, NULL, 'G3DSA:1.20.930.40:FF:000009', NULL, NULL, 'Glutamate carboxypeptidase 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(106371, NULL, 'G3DSA:1.10.472.10:FF:000410', NULL, NULL, 'Putative cyclin-F1-4', NULL, NULL, NULL, NULL, NULL, 4),
(106372, NULL, 'G3DSA:2.30.180.10:FF:000184', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106373, NULL, 'G3DSA:2.60.40.150:FF:000450', NULL, NULL, 'BON1-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(106374, NULL, 'G3DSA:1.25.10.10:FF:001989', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106375, NULL, 'G3DSA:1.20.120.230:FF:000015', NULL, NULL, 'Cas scaffold protein family member 4', NULL, NULL, NULL, NULL, NULL, 4),
(106376, NULL, 'G3DSA:1.10.540.10:FF:000147', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(106377, NULL, 'G3DSA:2.130.10.10:FF:002066', NULL, NULL, 'Transducin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(106378, NULL, 'G3DSA:2.60.40.10:FF:004342', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106379, NULL, 'G3DSA:3.30.10.20:FF:000008', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(106380, NULL, 'G3DSA:3.30.2350.10:FF:000030', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(106381, NULL, 'G3DSA:3.30.200.20:FF:002400', NULL, NULL, 'CDC7 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(106382, NULL, 'G3DSA:3.40.50.150:FF:000621', NULL, NULL, 'Nicotinamide N-methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(106383, NULL, 'G3DSA:3.40.140.10:FF:000147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106384, NULL, 'G3DSA:3.40.1090.10:FF:000125', NULL, NULL, 'Patatin like phospholipase domain containing 3', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(106385, NULL, 'G3DSA:3.30.200.20:FF:001883', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106386, NULL, 'G3DSA:1.10.10.10:FF:000056', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(106387, NULL, 'G3DSA:2.130.10.10:FF:002745', NULL, NULL, 'Kinetoplastid kinetochore protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(106388, NULL, 'G3DSA:1.10.287.70:FF:000789', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106389, NULL, 'G3DSA:2.80.10.50:FF:000068', NULL, NULL, 'Stromal cell-derived factor 2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(106390, NULL, 'G3DSA:2.40.30.10:FF:000525', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106391, NULL, 'G3DSA:2.60.40.10:FF:004712', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106392, NULL, 'G3DSA:3.40.50.2000:FF:000017', NULL, NULL, 'alpha,alpha-trehalose-phosphate synthase [UDP-forming] 6', NULL, NULL, NULL, NULL, NULL, 4),
(106393, NULL, 'G3DSA:1.10.472.130:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106394, NULL, 'G3DSA:2.60.120.260:FF:000441', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106395, NULL, 'G3DSA:3.90.70.10:FF:000394', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106396, NULL, 'G3DSA:3.90.550.10:FF:000408', NULL, NULL, 'Bifunctional enzyme IspD/IspF', NULL, NULL, NULL, NULL, NULL, 4),
(106397, NULL, 'G3DSA:3.90.1750.10:FF:000114', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106398, NULL, 'G3DSA:3.30.2350.20:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106399, NULL, 'G3DSA:2.30.29.30:FF:001063', NULL, NULL, 'Anillin, actin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(106400, NULL, 'G3DSA:2.40.10.10:FF:000625', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106401, NULL, 'G3DSA:1.50.40.10:FF:000590', NULL, NULL, 'Truncated non-functional calcium-binding mitochondrial carrier SAL1-1', NULL, NULL, NULL, NULL, NULL, 4),
(106402, NULL, 'G3DSA:1.10.10.10:FF:000735', NULL, NULL, 'Rrf2 family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(106403, NULL, 'G3DSA:1.10.20.10:FF:000028', NULL, NULL, 'Transcription initiation factor TFIID subunit 13', NULL, NULL, NULL, NULL, NULL, 4),
(106404, NULL, 'G3DSA:1.20.5.190:FF:000105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106405, NULL, 'G3DSA:1.25.10.10:FF:002832', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106406, NULL, 'G3DSA:3.80.10.10:FF:002032', NULL, NULL, 'Leucine rich repeat containing G protein-coupled receptor 6', NULL, NULL, NULL, NULL, NULL, 4),
(106407, NULL, 'G3DSA:1.10.3710.10:FF:000008', NULL, NULL, 'Recombination factor protein RarA', NULL, NULL, NULL, NULL, NULL, 4),
(106408, NULL, 'G3DSA:3.10.110.10:FF:000360', NULL, NULL, 'ESCRT-I complex subunit tsg101', NULL, NULL, NULL, NULL, NULL, 4),
(106409, NULL, 'G3DSA:3.50.50.60:FF:000016', NULL, NULL, 'Succinate dehydrogenase flavoprotein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(106410, NULL, 'G3DSA:2.40.30.10:FF:000188', NULL, NULL, 'Ria1p', NULL, NULL, NULL, NULL, NULL, 4),
(106411, NULL, 'G3DSA:1.10.287.630:FF:000002', NULL, NULL, 'Potassium/sodium hyperpolarization-activated cyclic nucleotide-gated channel 4', NULL, NULL, NULL, NULL, NULL, 4),
(106412, NULL, 'G3DSA:1.10.287.110:FF:000184', NULL, NULL, 'DnaJ domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(106413, NULL, 'G3DSA:3.40.50.300:FF:006641', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106414, NULL, 'G3DSA:3.30.60.20:FF:000045', NULL, NULL, 'Rho-associated protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(106415, NULL, 'G3DSA:1.25.40.800:FF:000009', NULL, NULL, 'Ccr4-Not transcription complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(106416, NULL, 'G3DSA:1.20.58.670:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106417, NULL, 'G3DSA:1.25.40.10:FF:002334', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g46580, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(106418, NULL, 'G3DSA:3.90.1410.10:FF:000156', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(106419, NULL, 'G3DSA:3.30.450.40:FF:000154', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(106420, NULL, 'G3DSA:3.20.20.80:FF:000797', NULL, NULL, 'Alpha-L-fucosidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(106421, NULL, 'G3DSA:1.25.40.10:FF:003745', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106422, NULL, 'G3DSA:1.10.287.110:FF:000228', NULL, NULL, 'Chaperone protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(106423, NULL, 'G3DSA:1.10.10.10:FF:000409', NULL, NULL, 'Anaphase-promoting complex subunit ApcB', NULL, NULL, NULL, NULL, NULL, 4),
(106424, NULL, 'G3DSA:2.40.320.10:FF:000002', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(106425, NULL, 'G3DSA:2.40.100.10:FF:000137', NULL, NULL, 'Type I inositol polyphosphate 5-phosphatase 10', NULL, NULL, NULL, NULL, NULL, 4),
(106426, NULL, 'G3DSA:2.60.40.150:FF:000803', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106427, NULL, 'G3DSA:3.30.565.10:FF:000136', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(106428, NULL, 'G3DSA:3.40.30.10:FF:000366', NULL, NULL, 'Spliceosomal U5 snRNP-specific protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(106429, NULL, 'G3DSA:1.10.10.60:FF:000273', NULL, NULL, 'MIS18 binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(106430, NULL, 'G3DSA:1.20.1280.50:FF:000197', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106431, NULL, 'G3DSA:3.30.428.10:FF:000020', NULL, NULL, 'Histidine triad nucleotide-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(106432, NULL, 'G3DSA:3.10.150.10:FF:000008', NULL, NULL, 'Proliferating cell nuclear antigen', NULL, NULL, NULL, NULL, NULL, 4),
(106433, NULL, 'G3DSA:3.30.50.10:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106434, NULL, 'G3DSA:2.60.120.260:FF:000115', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(106435, NULL, 'G3DSA:3.30.160.60:FF:004145', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106436, NULL, 'G3DSA:2.40.70.10:FF:000325', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106437, NULL, 'G3DSA:3.40.50.410:FF:000379', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106438, NULL, 'G3DSA:1.20.1070.10:FF:001209', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106439, NULL, 'G3DSA:2.60.120.20:FF:000013', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(106440, NULL, 'G3DSA:2.60.40.790:FF:000158', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106441, NULL, 'G3DSA:3.30.160.60:FF:004454', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106442, NULL, 'G3DSA:1.25.40.10:FF:002643', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106443, NULL, 'G3DSA:3.30.40.10:FF:001777', NULL, NULL, 'Putative RING zinc finger domain superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(106444, NULL, 'G3DSA:3.30.310.40:FF:000014', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106445, NULL, 'G3DSA:2.60.40.640:FF:000029', NULL, NULL, 'Rod1p', NULL, NULL, NULL, NULL, NULL, 4),
(106446, NULL, 'G3DSA:3.80.10.10:FF:001526', NULL, NULL, 'Leucine_rich_repeat/Leucine_Rich_repeat/Leucine_R ich_Repeat', NULL, NULL, NULL, NULL, NULL, 4),
(106447, NULL, 'G3DSA:1.10.230.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106448, NULL, 'G3DSA:3.90.70.10:FF:000731', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106449, NULL, 'G3DSA:3.40.50.300:FF:007130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106450, NULL, 'G3DSA:2.60.120.40:FF:000019', NULL, NULL, 'Tumor necrosis factor ligand superfamily member 13B', NULL, NULL, NULL, NULL, NULL, 4),
(106451, NULL, 'G3DSA:1.20.1090.10:FF:000007', NULL, NULL, 'Pentafunctional AROM polypeptide', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(106452, NULL, 'G3DSA:3.30.40.10:FF:001098', NULL, NULL, 'Tripartite motif family-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(106453, NULL, 'G3DSA:3.30.70.330:FF:002148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106454, NULL, 'G3DSA:1.20.930.20:FF:000003', NULL, NULL, 'DNA mismatch repair protein MLH1', NULL, NULL, NULL, NULL, NULL, 4),
(106455, NULL, 'G3DSA:3.40.50.1440:FF:000074', NULL, NULL, 'Tubulin gamma-2 chain', NULL, NULL, NULL, NULL, NULL, 4),
(106456, NULL, 'G3DSA:3.10.20.90:FF:000665', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106457, NULL, 'G3DSA:3.30.310.50:FF:000017', NULL, NULL, 'Phosphomannomutase PmmB', NULL, NULL, NULL, NULL, NULL, 4),
(106458, NULL, 'G3DSA:3.30.505.10:FF:000177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106459, NULL, 'G3DSA:3.30.497.10:FF:000106', NULL, NULL, 'Serpin B10', NULL, NULL, NULL, NULL, NULL, 4),
(106460, NULL, 'G3DSA:3.60.20.30:FF:000005', NULL, NULL, 'N(4)-(Beta-N-acetylglucosaminyl)-L-asparaginase', NULL, NULL, NULL, NULL, NULL, 4),
(106461, NULL, 'G3DSA:1.10.150.240:FF:000032', NULL, NULL, 'Hydrolase, haloacid dehalogenase-like family', NULL, NULL, NULL, NULL, NULL, 4),
(106462, NULL, 'G3DSA:2.70.170.10:FF:000152', NULL, NULL, 'Macaca fascicularis brain cDNA clone: QflA-17345, similar to human cholinergic receptor, nicotinic, beta polypeptide 2(neuronal) (CHRNB2), mRNA, RefSeq: NM_000748.1', NULL, NULL, NULL, NULL, NULL, 4),
(106463, NULL, 'G3DSA:3.90.550.10:FF:000381', NULL, NULL, 'Ceramide glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(106464, NULL, 'G3DSA:1.25.40.690:FF:000010', NULL, NULL, 'Nucleocytoplasmic transporter', NULL, NULL, NULL, NULL, NULL, 4),
(106465, NULL, 'G3DSA:3.40.630.30:FF:000696', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106466, NULL, 'G3DSA:2.30.170.40:FF:000006', NULL, NULL, 'Mitochondrial ribosomal protein L28, putative', NULL, NULL, NULL, NULL, NULL, 4),
(106467, NULL, 'G3DSA:3.40.50.1100:FF:000186', NULL, NULL, 'Cysteine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(106468, NULL, 'G3DSA:3.40.630.10:FF:000022', NULL, NULL, 'Carboxypeptidase Z', NULL, NULL, NULL, NULL, NULL, 4),
(106469, NULL, 'G3DSA:1.20.1070.10:FF:000124', NULL, NULL, 'Trace amine-associated receptor 20i', NULL, NULL, NULL, NULL, NULL, 4),
(106470, NULL, 'G3DSA:2.130.10.10:FF:003847', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106471, NULL, 'G3DSA:2.60.40.10:FF:000317', NULL, NULL, 'fibronectin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(106472, NULL, 'G3DSA:2.10.110.10:FF:000324', NULL, NULL, 'Protein CBR-LIM-9', NULL, NULL, NULL, NULL, NULL, 4),
(106473, NULL, 'G3DSA:1.20.1080.10:FF:000052', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106474, NULL, 'G3DSA:3.30.280.10:FF:000002', NULL, NULL, 'Urease subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(106475, NULL, 'G3DSA:1.20.1160.11:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106476, NULL, 'G3DSA:1.10.8.60:FF:000553', NULL, NULL, 'DNA polymerase III delta subunit HolA', NULL, NULL, NULL, NULL, NULL, 4),
(106477, NULL, 'G3DSA:3.40.50.300:FF:008232', NULL, NULL, 'Putative cysteine protease RD19C', NULL, NULL, NULL, NULL, NULL, 4),
(106478, NULL, 'G3DSA:3.30.830.10:FF:000157', NULL, NULL, 'Metalloprotease, insulinase family', NULL, NULL, NULL, NULL, NULL, 4),
(106479, NULL, 'G3DSA:1.25.10.10:FF:000371', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(106480, NULL, 'G3DSA:2.40.170.20:FF:000077', NULL, NULL, 'Transporter, outer membrane receptor (OMR) family', NULL, NULL, NULL, NULL, NULL, 4),
(106481, NULL, 'G3DSA:1.20.58.390:FF:000064', NULL, NULL, 'Neuronal acetylcholine receptor subunit alpha-7', NULL, NULL, NULL, NULL, NULL, 4),
(106482, NULL, 'G3DSA:1.10.506.10:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106483, NULL, 'G3DSA:2.10.220.10:FF:000136', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(106484, NULL, 'G3DSA:3.30.40.10:FF:001261', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106485, NULL, 'G3DSA:3.90.120.10:FF:000022', NULL, NULL, 'DNA (cytosine-5)-methyltransferase 3', NULL, NULL, NULL, NULL, NULL, 4),
(106486, NULL, 'G3DSA:3.20.20.70:FF:000794', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106487, NULL, 'G3DSA:2.60.40.10:FF:003869', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106488, NULL, 'G3DSA:3.40.30.70:FF:000001', NULL, NULL, 'Glutamate--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(106489, NULL, 'G3DSA:3.40.50.10310:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106490, NULL, 'G3DSA:3.30.70.330:FF:002311', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106491, NULL, 'G3DSA:3.40.50.300:FF:004387', NULL, NULL, 'Putative uridine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(106492, NULL, 'G3DSA:3.40.190.10:FF:000184', NULL, NULL, 'Phosphate ABC transporter, phosphate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(106493, NULL, 'G3DSA:3.80.10.10:FF:003117', NULL, NULL, 'Leucine rich repeat containing 6', NULL, NULL, NULL, NULL, NULL, 4),
(106494, NULL, 'G3DSA:3.30.60.30:FF:000048', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(106495, NULL, 'G3DSA:3.40.50.1000:FF:000835', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106496, NULL, 'G3DSA:3.40.830.10:FF:000003', NULL, NULL, '4,5-DOPA dioxygenase extradiol', NULL, NULL, NULL, NULL, NULL, 4),
(106497, NULL, 'G3DSA:2.60.40.1760:FF:000003', NULL, NULL, 'Glucosidase II alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(106498, NULL, 'G3DSA:1.25.10.10:FF:002153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106499, NULL, 'G3DSA:3.30.40.10:FF:001570', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(106500, NULL, 'G3DSA:3.60.21.10:FF:000136', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(106501, NULL, 'G3DSA:1.10.533.10:FF:000226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106502, NULL, 'G3DSA:3.90.1150.10:FF:000220', NULL, NULL, 'Serine--pyruvate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(106503, NULL, 'G3DSA:3.40.50.300:FF:002925', NULL, NULL, 'Circadian clock protein kinase KaiC', NULL, NULL, NULL, NULL, NULL, 4),
(106504, NULL, 'G3DSA:1.20.1280.50:FF:000208', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106505, NULL, 'G3DSA:3.40.47.10:FF:000022', NULL, NULL, 'Acetyl-CoA acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(106506, NULL, 'G3DSA:2.10.110.10:FF:000015', NULL, NULL, 'LIM domain only 3', NULL, NULL, NULL, NULL, NULL, 4),
(106507, NULL, 'G3DSA:2.130.10.10:FF:005764', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106508, NULL, 'G3DSA:1.25.40.10:FF:000182', NULL, NULL, 'Pre-mRNA-splicing factor SYF1', NULL, NULL, NULL, NULL, NULL, 4),
(106509, NULL, 'G3DSA:2.60.40.1180:FF:000060', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(106510, NULL, 'G3DSA:1.50.40.10:FF:000573', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106511, NULL, 'G3DSA:3.40.630.30:FF:000679', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106512, NULL, 'G3DSA:1.25.40.20:FF:000185', NULL, NULL, 'OSMotic avoidance abnormal family member', NULL, NULL, NULL, NULL, NULL, 4),
(106513, NULL, 'G3DSA:1.10.1450.10:FF:000061', NULL, NULL, 'KRR1 small subunit processome component homolog-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(106514, NULL, 'G3DSA:1.20.1070.10:FF:001552', NULL, NULL, 'D(1B) dopamine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(106515, NULL, 'G3DSA:1.10.150.20:FF:000210', NULL, NULL, 'DNA excision repair protein ERCC-1', NULL, NULL, NULL, NULL, NULL, 4),
(106516, NULL, 'G3DSA:3.90.290.10:FF:000017', NULL, NULL, 'latent-transforming growth factor beta-binding protein 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(106517, NULL, 'G3DSA:1.10.8.360:FF:000001', NULL, NULL, 'Chitinase domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(106518, NULL, 'G3DSA:3.90.930.12:FF:000002', NULL, NULL, '50S ribosomal protein L6', NULL, NULL, NULL, NULL, NULL, 4),
(106519, NULL, 'G3DSA:2.60.40.60:FF:000079', NULL, NULL, 'FAT atypical cadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(106520, NULL, 'G3DSA:3.30.70.3290:FF:000002', NULL, NULL, 'Non-reducing polyketide synthase nscA', NULL, NULL, NULL, NULL, NULL, 4),
(106521, NULL, 'G3DSA:4.10.60.10:FF:000063', NULL, NULL, 'Unplaced genomic scaffold supercont1.17, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(106522, NULL, 'G3DSA:2.60.40.150:FF:000433', NULL, NULL, 'Synaptotagmin-17', NULL, NULL, NULL, NULL, NULL, 4),
(106523, NULL, 'G3DSA:1.10.472.10:FF:000090', NULL, NULL, 'cyclin-T1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(106524, NULL, 'G3DSA:3.10.110.10:FF:000034', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 S', NULL, NULL, NULL, NULL, NULL, 4),
(106525, NULL, 'G3DSA:1.10.510.10:FF:000662', NULL, NULL, 'Serine/threonine-protein kinase WAG2', NULL, NULL, NULL, NULL, NULL, 4),
(106526, NULL, 'G3DSA:1.20.5.1760:FF:000001', NULL, NULL, 'Sfi1p', NULL, NULL, NULL, NULL, NULL, 4),
(106527, NULL, 'G3DSA:3.40.50.300:FF:004533', NULL, NULL, 'DNA mismatch repair protein MutS type 2', NULL, NULL, NULL, NULL, NULL, 4),
(106528, NULL, 'G3DSA:2.40.110.10:FF:000082', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106529, NULL, 'G3DSA:1.10.510.10:FF:004361', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106530, NULL, 'G3DSA:1.10.510.10:FF:000954', NULL, NULL, 'Tyrosine-protein kinase-like otk', NULL, NULL, NULL, NULL, NULL, 4),
(106531, NULL, 'G3DSA:3.80.10.10:FF:001852', NULL, NULL, 'YALI0B18759p', NULL, NULL, NULL, NULL, NULL, 4),
(106532, NULL, 'G3DSA:3.30.470.30:FF:000051', NULL, NULL, 'GD13702', NULL, NULL, NULL, NULL, NULL, 4),
(106533, NULL, 'G3DSA:3.30.2350.20:FF:000016', NULL, NULL, 'Unplaced genomic scaffold supercont2.23, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(106534, NULL, 'G3DSA:3.30.2350.10:FF:000013', NULL, NULL, 'TruB pseudouridine synthase family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(106535, NULL, 'G3DSA:3.40.50.720:FF:000106', NULL, NULL, 'NEDD8-activating enzyme E1 catalytic subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(106536, NULL, 'G3DSA:3.30.160.60:FF:002863', NULL, NULL, 'Zinc finger protein 671', NULL, NULL, NULL, NULL, NULL, 4),
(106537, NULL, 'G3DSA:2.80.10.50:FF:000085', NULL, NULL, '''putative glucan 1,3-beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(106538, NULL, 'G3DSA:3.90.1600.10:FF:000002', NULL, NULL, 'DNA polymerase zeta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(106539, NULL, 'G3DSA:3.30.1370.10:FF:000222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106540, NULL, 'G3DSA:1.10.510.10:FF:002562', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106541, NULL, 'G3DSA:2.30.30.1150:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106542, NULL, 'G3DSA:3.40.50.300:FF:000790', NULL, NULL, 'C1 tetrahydrofolate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(106543, NULL, 'G3DSA:1.10.730.10:FF:000156', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(106544, NULL, 'G3DSA:3.40.50.2000:FF:000034', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(106545, NULL, 'G3DSA:1.25.10.10:FF:000680', NULL, NULL, 'BNI1p Formin', NULL, NULL, NULL, NULL, NULL, 4),
(106546, NULL, 'G3DSA:2.40.10.10:FF:000642', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106547, NULL, 'G3DSA:3.30.200.60:FF:000001', NULL, NULL, 'Ubiquitin thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(106548, NULL, 'G3DSA:1.20.5.190:FF:000077', NULL, NULL, 'Class V myosin', NULL, NULL, NULL, NULL, NULL, 4),
(106549, NULL, 'G3DSA:6.10.300.40:FF:000001', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 4', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(106550, NULL, 'G3DSA:2.10.90.10:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106551, NULL, 'G3DSA:3.40.190.10:FF:000521', NULL, NULL, 'GD20046', NULL, NULL, NULL, NULL, NULL, 4),
(106552, NULL, 'G3DSA:3.40.50.150:FF:000149', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(106553, NULL, 'G3DSA:3.30.70.330:FF:001659', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106554, NULL, 'G3DSA:1.10.10.10:FF:000718', NULL, NULL, 'RNA polymerase sigma-70 factor, ECF subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(106555, NULL, 'G3DSA:2.60.40.10:FF:000660', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(106556, NULL, 'G3DSA:2.40.10.10:FF:000288', NULL, NULL, 'uncharacterized protein LOC100179458 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(106557, NULL, 'G3DSA:2.60.40.10:FF:005977', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106558, NULL, 'G3DSA:1.10.533.10:FF:000209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106559, NULL, 'G3DSA:3.40.50.150:FF:000284', NULL, NULL, 'Type I restriction enzyme StySJI M protein', NULL, NULL, NULL, NULL, NULL, 4),
(106560, NULL, 'G3DSA:3.30.1330.60:FF:000021', NULL, NULL, 'Outer membrane protein OmpA', NULL, NULL, NULL, NULL, NULL, 4),
(106561, NULL, 'G3DSA:3.30.420.10:FF:000593', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106562, NULL, 'G3DSA:2.60.40.60:FF:000725', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(106563, NULL, 'G3DSA:3.30.160.60:FF:002228', NULL, NULL, 'Putative transcription factor Ovo-like 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(106564, NULL, 'G3DSA:2.40.180.10:FF:000030', NULL, NULL, 'Linolenate 9R-lipoxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(106565, NULL, 'G3DSA:1.10.238.10:FF:000692', NULL, NULL, 'Calcium-binding protein E', NULL, NULL, NULL, NULL, NULL, 4),
(106566, NULL, 'G3DSA:3.90.1410.10:FF:000139', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106567, NULL, 'G3DSA:1.10.238.10:FF:000512', NULL, NULL, 'Putative TPR repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(106568, NULL, 'G3DSA:3.30.70.330:FF:001805', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106569, NULL, 'G3DSA:3.30.750.24:FF:000063', NULL, NULL, 'SulP family inorganic anion transporter', NULL, NULL, NULL, NULL, NULL, 4),
(106570, NULL, 'G3DSA:2.60.40.60:FF:000181', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106571, NULL, 'G3DSA:1.10.150.530:FF:000012', NULL, NULL, 'Dual-specificity RNA methyltransferase RlmN', NULL, NULL, NULL, NULL, NULL, 4),
(106572, NULL, 'G3DSA:3.90.1750.10:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106573, NULL, 'G3DSA:3.40.50.300:FF:002279', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(106574, NULL, 'G3DSA:2.60.40.4060:FF:000013', NULL, NULL, 'Spondin-1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(106575, NULL, 'G3DSA:2.40.100.10:FF:000154', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(106576, NULL, 'G3DSA:1.10.3210.10:FF:000015', NULL, NULL, 'Deoxynucleoside triphosphate triphosphohydrolase SAMHD1', NULL, NULL, NULL, NULL, NULL, 4),
(106577, NULL, 'G3DSA:2.30.29.30:FF:001372', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106578, NULL, 'G3DSA:3.90.79.10:FF:000251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106579, NULL, 'G3DSA:1.10.10.60:FF:000290', NULL, NULL, 'homeobox protein Hox-B3', NULL, NULL, NULL, NULL, NULL, 4),
(106580, NULL, 'G3DSA:3.10.100.10:FF:000062', NULL, NULL, 'C-type lectin domain family 2 member D', NULL, NULL, NULL, NULL, NULL, 4),
(106581, NULL, 'G3DSA:1.10.418.10:FF:000240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106582, NULL, 'G3DSA:2.60.120.260:FF:000132', NULL, NULL, 'Anaphase promoting complex subunit 10', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(106583, NULL, 'G3DSA:3.80.10.10:FF:003460', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106584, NULL, 'G3DSA:1.10.132.60:FF:000051', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(106585, NULL, 'G3DSA:2.40.30.10:FF:000216', NULL, NULL, 'Oxidoreductase, FAD-binding', NULL, NULL, NULL, NULL, NULL, 4),
(106586, NULL, 'G3DSA:1.20.1070.10:FF:001198', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(106587, NULL, 'G3DSA:3.40.50.300:FF:005489', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106588, NULL, 'G3DSA:2.60.40.640:FF:000046', NULL, NULL, 'RE18068p', NULL, NULL, NULL, NULL, NULL, 4),
(106589, NULL, 'G3DSA:2.60.200.20:FF:000177', NULL, NULL, 'E3 ubiquitin-protein ligase RNF8', NULL, NULL, NULL, NULL, NULL, 4),
(106590, NULL, 'G3DSA:1.20.1070.10:FF:001226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106591, NULL, 'G3DSA:1.20.120.330:FF:000045', NULL, NULL, 'Protein tyrosine kinase 2 beta', NULL, NULL, NULL, NULL, NULL, 4),
(106592, NULL, 'G3DSA:2.60.40.10:FF:002560', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(106593, NULL, 'G3DSA:4.10.1240.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106594, NULL, 'G3DSA:2.130.10.10:FF:004662', NULL, NULL, 'WD repeat-containing protein JIP5', NULL, NULL, NULL, NULL, NULL, 4),
(106595, NULL, 'G3DSA:2.60.40.10:FF:001132', NULL, NULL, 'Sidekick, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(106596, NULL, 'G3DSA:3.30.160.60:FF:004128', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106597, NULL, 'G3DSA:2.40.70.10:FF:000308', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106598, NULL, 'G3DSA:3.40.1050.10:FF:000033', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(106599, NULL, 'G3DSA:3.10.129.10:FF:000043', NULL, NULL, 'Bifunctional aldehyde dehydrogenase/enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(106600, NULL, 'G3DSA:3.20.20.210:FF:000014', NULL, NULL, 'Dimethylsulfide methyltransferase corrinoid protein', NULL, NULL, NULL, NULL, NULL, 4),
(106601, NULL, 'G3DSA:3.40.50.1440:FF:000057', NULL, NULL, 'Tubulin delta 1', NULL, NULL, NULL, NULL, NULL, 4),
(106602, NULL, 'G3DSA:1.10.730.10:FF:000201', NULL, NULL, 'Arginyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(106603, NULL, 'G3DSA:3.40.50.1000:FF:000509', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106604, NULL, 'G3DSA:2.60.40.1360:FF:000006', NULL, NULL, 'Alpha-mannosidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(106605, NULL, 'G3DSA:2.60.40.10:FF:002234', NULL, NULL, 'Mannosidase beta', NULL, NULL, NULL, NULL, NULL, 4),
(106606, NULL, 'G3DSA:2.60.40.2130:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106607, NULL, 'G3DSA:1.20.5.430:FF:000003', NULL, NULL, 'Heat shock factor binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(106608, NULL, 'G3DSA:1.10.220.10:FF:000073', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(106609, NULL, 'G3DSA:3.40.50.720:FF:001534', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106610, NULL, 'G3DSA:3.90.780.10:FF:000010', NULL, NULL, '2'',3''-cyclic-nucleotide 2''-phosphodiesterase / 3''-nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(106611, NULL, 'G3DSA:1.25.40.10:FF:000726', NULL, NULL, 'TPR-repeat-containing chaperone protein DNAJ', NULL, NULL, NULL, NULL, NULL, 4),
(106612, NULL, 'G3DSA:1.10.1660.10:FF:000014', NULL, NULL, 'MerR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(106613, NULL, 'G3DSA:1.20.5.440:FF:000006', NULL, NULL, 'ATP synthase epsilon chain', NULL, NULL, NULL, NULL, NULL, 4),
(106614, NULL, 'G3DSA:3.10.280.10:FF:000029', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106615, NULL, 'G3DSA:2.60.40.3690:FF:000003', NULL, NULL, 'Minor fimbrium subunit Mfa1', NULL, NULL, NULL, NULL, NULL, 4),
(106616, NULL, 'G3DSA:2.30.30.210:FF:000006', NULL, NULL, 'Ribonuclease P protein subunit p29', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(106617, NULL, 'G3DSA:1.25.40.20:FF:001011', NULL, NULL, 'ankyrin repeat and KH domain-containing protein 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(106618, NULL, 'G3DSA:3.30.200.20:FF:002254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106619, NULL, 'G3DSA:3.40.50.620:FF:000211', NULL, NULL, 'Dual-specific kinase DSK1-like', NULL, NULL, NULL, NULL, NULL, 4),
(106620, NULL, 'G3DSA:2.60.40.10:FF:000334', NULL, NULL, 'vesicle-associated membrane protein-associated protein A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(106621, NULL, 'G3DSA:3.10.20.740:FF:000006', NULL, NULL, 'NADH-ubiquinone oxidoreductase, subunit G, putative', NULL, NULL, NULL, NULL, NULL, 4),
(106622, NULL, 'G3DSA:1.25.40.20:FF:000729', NULL, NULL, 'Signal recognition particle 43 kDa protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(106623, NULL, 'G3DSA:1.50.40.10:FF:000247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106624, NULL, 'G3DSA:1.20.930.40:FF:000026', NULL, NULL, 'N-acetylated alpha-linked acidic dipeptidase like 1', NULL, NULL, NULL, NULL, NULL, 4),
(106625, NULL, 'G3DSA:1.10.510.10:FF:002236', NULL, NULL, 'Dual specificity mitogen-activated protein kinase kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(106626, NULL, 'G3DSA:3.40.50.150:FF:000593', NULL, NULL, 'Fibrillarin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(106627, NULL, 'G3DSA:1.10.10.10:FF:000073', NULL, NULL, 'E2F transcription factor 8', NULL, NULL, NULL, NULL, NULL, 4),
(106628, NULL, 'G3DSA:3.90.1110.10:FF:000009', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(106629, NULL, 'G3DSA:2.40.70.10:FF:000281', NULL, NULL, 'Aspartyl protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(106630, NULL, 'G3DSA:2.40.160.60:FF:000004', NULL, NULL, 'Long-chain fatty acid transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(106631, NULL, 'G3DSA:2.60.120.200:FF:000221', NULL, NULL, 'Axotactin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(106632, NULL, 'G3DSA:3.60.20.30:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106633, NULL, 'G3DSA:2.120.10.80:FF:000221', NULL, NULL, 'Acyl-CoA-binding domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(106634, NULL, 'G3DSA:3.40.50.620:FF:000520', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106635, NULL, 'G3DSA:1.10.506.10:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106636, NULL, 'G3DSA:3.40.850.10:FF:000212', NULL, NULL, 'Kinesin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(106637, NULL, 'G3DSA:3.90.70.10:FF:000068', NULL, NULL, 'Cysteine protease 1', NULL, NULL, NULL, NULL, NULL, 4),
(106638, NULL, 'G3DSA:3.20.20.70:FF:000777', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106639, NULL, 'G3DSA:3.30.1050.10:FF:000001', NULL, NULL, 'Putative Non-specific lipid-transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(106640, NULL, 'G3DSA:3.40.190.10:FF:000212', NULL, NULL, 'Amino acid ABC transporter, amino acid-binding protein/permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(106641, NULL, 'G3DSA:1.25.10.10:FF:000354', NULL, NULL, 'DUF1716 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(106642, NULL, 'G3DSA:3.90.120.10:FF:000005', NULL, NULL, 'tRNA (Cytosine(38)-C(5))-methyltransferase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(106643, NULL, 'G3DSA:2.60.40.60:FF:000416', NULL, NULL, 'Cadherin-related hmr-1', NULL, NULL, NULL, NULL, NULL, 4),
(106644, NULL, 'G3DSA:3.30.40.10:FF:001553', NULL, NULL, 'Protein CBR-ZHP-3', NULL, NULL, NULL, NULL, NULL, 4),
(106645, NULL, 'G3DSA:3.40.50.80:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106646, NULL, 'G3DSA:3.80.10.10:FF:003443', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106647, NULL, 'G3DSA:3.90.550.10:FF:000055', NULL, NULL, 'Alpha-1,3-mannosyl-glycoprotein 2-beta-N-acetylglucosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(106648, NULL, 'G3DSA:3.30.830.10:FF:000174', NULL, NULL, 'ACR069Cp', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(106649, NULL, 'G3DSA:3.80.10.10:FF:003134', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106650, NULL, 'G3DSA:3.30.160.60:FF:002537', NULL, NULL, 'Trade embargo', NULL, NULL, NULL, NULL, NULL, 4),
(106651, NULL, 'G3DSA:1.25.40.10:FF:001828', NULL, NULL, 'SNAP (Soluble NSF Attachment Protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(106652, NULL, 'G3DSA:3.90.70.10:FF:000377', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106653, NULL, 'G3DSA:1.25.10.10:FF:000045', NULL, NULL, 'Formin-like protein 3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(106654, NULL, 'G3DSA:3.55.40.20:FF:000010', NULL, NULL, 'Mitochondrial ribosomal small subunit component', NULL, NULL, NULL, NULL, NULL, 4),
(106655, NULL, 'G3DSA:2.40.160.50:FF:000001', NULL, NULL, 'Outer membrane protein assembly factor BamA', NULL, NULL, NULL, NULL, NULL, 4),
(106656, NULL, 'G3DSA:3.40.50.720:FF:002023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106657, NULL, 'G3DSA:3.40.140.10:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106658, NULL, 'G3DSA:3.10.129.10:FF:000026', NULL, NULL, 'Possible 4-hydroxybenzoyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(106659, NULL, 'G3DSA:3.40.50.1820:FF:000986', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106660, NULL, 'G3DSA:2.60.120.650:FF:000007', NULL, NULL, 'Jumonji, AT rich interactive domain 2', NULL, NULL, NULL, NULL, NULL, 4),
(106661, NULL, 'G3DSA:3.40.50.300:FF:002942', NULL, NULL, 'Putative ATP-dependent helicase IRC3', NULL, NULL, NULL, NULL, NULL, 4),
(106662, NULL, 'G3DSA:3.90.550.50:FF:000134', NULL, NULL, 'YALI0F23485p', NULL, NULL, NULL, NULL, NULL, 4),
(106663, NULL, 'G3DSA:3.50.50.60:FF:000033', NULL, NULL, 'Nitrite reductase [NAD(P)H], large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(106664, NULL, 'G3DSA:1.10.3460.10:FF:000033', NULL, NULL, 'Chlorophyll a-b binding protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(106665, NULL, 'G3DSA:3.40.50.10810:FF:000063', NULL, NULL, 'Chromosome 12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(106666, NULL, 'G3DSA:2.70.130.10:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106667, NULL, 'G3DSA:1.20.1250.20:FF:001771', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(106668, NULL, 'G3DSA:3.40.50.2000:FF:001119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106669, NULL, 'G3DSA:3.30.70.330:FF:001985', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106670, NULL, 'G3DSA:1.10.10.10:FF:000382', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(106671, NULL, 'G3DSA:3.30.160.60:FF:003026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106672, NULL, 'G3DSA:3.30.40.10:FF:000142', NULL, NULL, 'Recombination activating gene 1', NULL, NULL, NULL, NULL, NULL, 4),
(106673, NULL, 'G3DSA:3.30.70.1230:FF:000194', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106674, NULL, 'G3DSA:3.40.50.300:FF:000481', NULL, NULL, 'Structural maintenance of chromosomes 4', NULL, NULL, NULL, NULL, NULL, 4),
(106675, NULL, 'G3DSA:1.20.1070.10:FF:001861', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106676, NULL, 'G3DSA:1.25.40.10:FF:002317', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(106677, NULL, 'G3DSA:1.25.40.10:FF:000417', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g38010', NULL, NULL, NULL, NULL, NULL, 4),
(106678, NULL, 'G3DSA:3.80.10.10:FF:001189', NULL, NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At4g36180', NULL, NULL, NULL, NULL, NULL, 4),
(106679, NULL, 'G3DSA:3.40.109.10:FF:000030', NULL, NULL, 'Nitroreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(106680, NULL, 'G3DSA:3.40.50.1000:FF:000818', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106681, NULL, 'G3DSA:3.30.60.20:FF:000028', NULL, NULL, 'Thymidine kinase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(106682, NULL, 'G3DSA:1.10.418.10:FF:000138', NULL, NULL, 'Cortexillin I', NULL, NULL, NULL, NULL, NULL, 4),
(106683, NULL, 'G3DSA:3.10.450.50:FF:000060', NULL, NULL, 'Nuclear transport factor 2 (NTF2) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(106684, NULL, 'G3DSA:4.10.60.10:FF:000046', NULL, NULL, 'Zinc finger protein GIS2', NULL, NULL, NULL, NULL, NULL, 4),
(106685, NULL, 'G3DSA:1.10.472.10:FF:000073', NULL, NULL, 'C-type cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(106686, NULL, 'G3DSA:3.10.150.10:FF:000025', NULL, NULL, 'DNA polymerase III, beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(106687, NULL, 'G3DSA:1.25.10.10:FF:000915', NULL, NULL, 'Beta-catenin/armadillo-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(106688, NULL, 'G3DSA:2.60.40.10:FF:005668', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106689, NULL, 'G3DSA:3.30.1540.20:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106690, NULL, 'G3DSA:3.10.20.90:FF:000339', NULL, NULL, 'Caspar, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(106691, NULL, 'G3DSA:1.10.760.10:FF:000012', NULL, NULL, 'Cytochrome C', NULL, NULL, NULL, NULL, NULL, 4),
(106692, NULL, 'G3DSA:3.30.565.10:FF:000153', NULL, NULL, 'Two component sensor kinase HK1', NULL, NULL, NULL, NULL, NULL, 4),
(106693, NULL, 'G3DSA:4.10.860.120:FF:000008', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(106694, NULL, 'G3DSA:1.25.10.10:FF:002815', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106695, NULL, 'G3DSA:1.25.40.10:FF:003599', NULL, NULL, 'SARP family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(106696, NULL, 'G3DSA:1.10.1220.170:FF:000003', NULL, NULL, 'Antitoxin', NULL, NULL, NULL, NULL, NULL, 4),
(106697, NULL, 'G3DSA:3.40.50.1000:FF:000611', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106698, NULL, 'G3DSA:1.10.510.10:FF:000971', NULL, NULL, 'CMGC/SRPK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(106699, NULL, 'G3DSA:3.30.70.330:FF:000703', NULL, NULL, 'Splicing factor U2AF large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(106700, NULL, 'G3DSA:1.20.1250.20:FF:000001', NULL, NULL, 'Dicarboxylate MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(106701, NULL, 'G3DSA:3.30.40.10:FF:001805', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(106702, NULL, 'G3DSA:1.10.238.10:FF:000719', NULL, NULL, 'Calmodulin-like protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(106703, NULL, 'G3DSA:1.20.1070.10:FF:002041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106704, NULL, 'G3DSA:2.40.170.20:FF:000105', NULL, NULL, 'TonB-dependent ferric putrebactin siderophore receptor PutA', NULL, NULL, NULL, NULL, NULL, 4),
(106705, NULL, 'G3DSA:1.10.287.470:FF:000078', NULL, NULL, 'Efflux pump, RND family, membrane fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(106706, NULL, 'G3DSA:3.30.70.1360:FF:000002', NULL, NULL, 'Global nitrogen regulator NrpR', NULL, NULL, NULL, NULL, NULL, 4),
(106707, NULL, 'G3DSA:3.40.50.300:FF:004842', NULL, NULL, 'Werner helicase interacting protein, putative (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(106708, NULL, 'G3DSA:3.30.160.60:FF:006253', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106709, NULL, 'G3DSA:2.40.50.730:FF:000001', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(106710, NULL, 'G3DSA:2.120.10.30:FF:000346', NULL, NULL, 'Chloroplast protein HCF243', NULL, NULL, NULL, NULL, NULL, 4),
(106711, NULL, 'G3DSA:3.10.20.90:FF:000648', NULL, NULL, 'NEDD8-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(106712, NULL, 'G3DSA:3.30.160.60:FF:003982', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106713, NULL, 'G3DSA:3.90.79.10:FF:000234', NULL, NULL, 'Tellurite resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(106714, NULL, 'G3DSA:3.40.50.2300:FF:000091', NULL, NULL, 'Chemotaxis two-component response regulator protein', NULL, NULL, NULL, NULL, NULL, 4),
(106715, NULL, 'G3DSA:2.130.10.110:FF:000004', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(106716, NULL, 'G3DSA:3.30.160.60:FF:004600', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106717, NULL, 'G3DSA:1.10.340.30:FF:000031', NULL, NULL, 'Endonuclease III', NULL, NULL, NULL, NULL, NULL, 4),
(106718, NULL, 'G3DSA:1.10.238.10:FF:000821', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106719, NULL, 'G3DSA:3.10.50.40:FF:000068', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(106720, NULL, 'G3DSA:1.10.510.10:FF:003973', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106721, NULL, 'G3DSA:3.40.50.150:FF:000267', NULL, NULL, 'Putative methyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(106722, NULL, 'G3DSA:3.30.1330.10:FF:000028', NULL, NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(106723, NULL, 'G3DSA:1.10.287.20:FF:000004', NULL, NULL, 'Cytochrome b-c1 complex subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(106724, NULL, 'G3DSA:3.40.50.720:FF:001326', NULL, NULL, '3-oxoacyl-ACP reductase', NULL, NULL, NULL, NULL, NULL, 4),
(106725, NULL, 'G3DSA:1.50.40.10:FF:000455', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106726, NULL, 'G3DSA:3.90.70.10:FF:000585', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(106727, NULL, 'G3DSA:2.130.10.10:FF:000267', NULL, NULL, 'DNA damage-binding protein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(106728, NULL, 'G3DSA:2.60.40.60:FF:000197', NULL, NULL, 'FAT atypical cadherin 2', NULL, NULL, NULL, NULL, NULL, 4),
(106729, NULL, 'G3DSA:2.120.10.80:FF:000013', NULL, NULL, 'Kelch-like family member 7', NULL, NULL, NULL, NULL, NULL, 4),
(106730, NULL, 'G3DSA:3.30.565.10:FF:000170', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(106731, NULL, 'G3DSA:1.10.3260.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106732, NULL, 'G3DSA:3.40.50.300:FF:000138', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(106733, NULL, 'G3DSA:2.130.10.120:FF:000007', NULL, NULL, 'Prolyl endopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(106734, NULL, 'G3DSA:3.40.50.1580:FF:000048', NULL, NULL, 'S-methyl-5''-thioadenosine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(106735, NULL, 'G3DSA:1.25.40.10:FF:002188', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g31850, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(106736, NULL, 'G3DSA:1.10.10.440:FF:000063', NULL, NULL, 'Pre-mRNA-processing protein 40B', NULL, NULL, NULL, NULL, NULL, 4),
(106737, NULL, 'G3DSA:3.40.50.1820:FF:001166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106738, NULL, 'G3DSA:1.25.10.10:FF:000562', NULL, NULL, 'Microtubule-associated protein TORTIFOLIA1', NULL, NULL, NULL, NULL, NULL, 4),
(106739, NULL, 'G3DSA:3.50.50.100:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106740, NULL, 'G3DSA:3.40.50.300:FF:002280', NULL, NULL, 'Small GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(106741, NULL, 'G3DSA:2.40.50.430:FF:000001', NULL, NULL, 'DNA polymerase delta subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(106742, NULL, 'G3DSA:2.30.130.40:FF:000015', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106743, NULL, 'G3DSA:2.60.200.20:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106744, NULL, 'G3DSA:2.30.30.40:FF:000501', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106745, NULL, 'G3DSA:1.10.443.10:FF:000005', NULL, NULL, 'Phage integrase', NULL, NULL, NULL, NULL, NULL, 4),
(106746, NULL, 'G3DSA:3.40.50.300:FF:002807', NULL, NULL, 'DNA helicase 2', NULL, NULL, NULL, NULL, NULL, 4),
(106747, NULL, 'G3DSA:1.10.472.80:FF:000178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106748, NULL, 'G3DSA:2.60.40.60:FF:000208', NULL, NULL, 'neural-cadherin isoform X11', NULL, NULL, NULL, NULL, NULL, 4),
(106749, NULL, 'G3DSA:2.10.110.10:FF:000100', NULL, NULL, 'MICAL-like protein 1', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(106750, NULL, 'G3DSA:1.20.1440.130:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106751, NULL, 'G3DSA:3.40.630.30:FF:000472', NULL, NULL, 'DUF482 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(106752, NULL, 'G3DSA:1.10.10.60:FF:000508', NULL, NULL, 'Homeodomain transcription factor BW10a', NULL, NULL, NULL, NULL, NULL, 4),
(106753, NULL, 'G3DSA:3.40.120.10:FF:000056', NULL, NULL, 'Putative phosphomannomutase', NULL, NULL, NULL, NULL, NULL, 4),
(106754, NULL, 'G3DSA:3.10.110.10:FF:000017', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 2', NULL, NULL, NULL, NULL, NULL, 4),
(106755, NULL, 'G3DSA:2.70.40.10:FF:000002', NULL, NULL, 'dUTP diphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(106756, NULL, 'G3DSA:2.130.10.10:FF:001947', NULL, NULL, 'Probable cytosolic iron-sulfur protein assembly protein CIAO1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(106757, NULL, 'G3DSA:3.10.100.10:FF:000415', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106758, NULL, 'G3DSA:3.30.565.10:FF:000271', NULL, NULL, 'Anti-sigma B factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(106759, NULL, 'G3DSA:2.60.40.10:FF:002442', NULL, NULL, 'Plexin-2', NULL, NULL, NULL, NULL, NULL, 4),
(106760, NULL, 'G3DSA:2.10.25.10:FF:001543', NULL, NULL, 'Tissue plasminogen activator', NULL, NULL, NULL, NULL, NULL, 4),
(106761, NULL, 'G3DSA:2.60.40.150:FF:000348', NULL, NULL, 'Copine family protein', NULL, NULL, NULL, NULL, NULL, 4),
(106762, NULL, 'G3DSA:3.40.225.10:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106763, NULL, 'G3DSA:3.10.20.90:FF:000441', NULL, NULL, 'Cytoskeleton associated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(106764, NULL, 'G3DSA:3.60.21.10:FF:000119', NULL, NULL, 'Sphingomyelin phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(106765, NULL, 'G3DSA:2.60.40.10:FF:002913', NULL, NULL, 'Interleukin 12 receptor beta 2.b', NULL, NULL, NULL, NULL, NULL, 4),
(106766, NULL, 'G3DSA:3.10.110.10:FF:000343', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 N-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(106767, NULL, 'G3DSA:3.90.70.10:FF:000170', NULL, NULL, 'Ubiquitin specific peptidase 25', NULL, NULL, NULL, NULL, NULL, 4),
(106768, NULL, 'G3DSA:3.90.79.10:FF:000133', NULL, NULL, 'Diadenosine hexaphosphate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(106769, NULL, 'G3DSA:3.90.1440.10:FF:000012', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106770, NULL, 'G3DSA:3.40.50.150:FF:000166', NULL, NULL, 'Methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(106771, NULL, 'G3DSA:3.40.390.10:FF:000210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106772, NULL, 'G3DSA:3.90.230.10:FF:000025', NULL, NULL, 'Methionine aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(106773, NULL, 'G3DSA:3.40.50.300:FF:000817', NULL, NULL, 'GPN-loop GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(106774, NULL, 'G3DSA:3.40.50.2300:FF:000102', NULL, NULL, 'Nitrate/nitrite response regulator protein narP', NULL, NULL, NULL, NULL, NULL, 4),
(106775, NULL, 'G3DSA:3.40.50.300:FF:007012', NULL, NULL, 'RAB36, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(106776, NULL, 'G3DSA:3.40.50.1000:FF:000482', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106777, NULL, 'G3DSA:3.40.190.10:FF:000004', NULL, NULL, 'Porphobilinogen deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(106778, NULL, 'G3DSA:2.130.10.10:FF:000166', NULL, NULL, 'THO complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(106779, NULL, 'G3DSA:2.10.25.10:FF:001644', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106780, NULL, 'G3DSA:3.50.50.60:FF:000151', NULL, NULL, 'Protein CbrA', NULL, NULL, NULL, NULL, NULL, 4),
(106781, NULL, 'G3DSA:3.10.20.30:FF:000092', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106782, NULL, 'G3DSA:3.40.50.720:FF:001225', NULL, NULL, 'Homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(106783, NULL, 'G3DSA:1.10.8.60:FF:000199', NULL, NULL, 'IQ motif containing with AAA domain 1', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(106784, NULL, 'G3DSA:3.40.30.10:FF:001001', NULL, NULL, 'Iodothyronine deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(106785, NULL, 'G3DSA:3.50.40.10:FF:000006', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(106786, NULL, 'G3DSA:1.25.40.10:FF:004442', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106787, NULL, 'G3DSA:3.30.450.40:FF:000171', NULL, NULL, 'Stage II sporulation E family protein', NULL, NULL, NULL, NULL, NULL, 4),
(106788, NULL, 'G3DSA:3.30.310.130:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106789, NULL, 'G3DSA:2.40.10.10:FF:000333', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106790, NULL, 'G3DSA:2.10.25.10:FF:001217', NULL, NULL, 'CD248 molecule, endosialin a', NULL, NULL, NULL, NULL, NULL, 4),
(106791, NULL, 'G3DSA:2.40.10.10:FF:000081', NULL, NULL, 'Serine protease 56', NULL, NULL, NULL, NULL, NULL, 4),
(106792, NULL, 'G3DSA:2.40.50.140:FF:000700', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106793, NULL, 'G3DSA:1.20.1250.20:FF:001445', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106794, NULL, 'G3DSA:3.40.718.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106795, NULL, 'G3DSA:3.30.1010.10:FF:000100', NULL, NULL, 'Phosphatidyl inositol 3 kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(106796, NULL, 'G3DSA:3.40.50.1820:FF:001492', NULL, NULL, 'GH07181p', NULL, NULL, NULL, NULL, NULL, 4),
(106797, NULL, 'G3DSA:2.130.10.10:FF:002521', NULL, NULL, 'Vacuolar protein sorting-associated protein 11 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(106798, NULL, 'G3DSA:3.30.230.10:FF:000100', NULL, NULL, '30s ribosomal protein s5', NULL, NULL, NULL, NULL, NULL, 4),
(106799, NULL, 'G3DSA:3.30.70.330:FF:001777', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106800, NULL, 'G3DSA:1.10.357.10:FF:000030', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(106801, NULL, 'G3DSA:2.60.40.10:FF:000188', NULL, NULL, 'Interleukin-1 receptor accessory protein-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(106802, NULL, 'G3DSA:2.40.30.330:FF:000006', NULL, NULL, 'mRNA cleavage and polyadenylation factor CLP1', NULL, NULL, NULL, NULL, NULL, 4),
(106803, NULL, 'G3DSA:3.30.160.60:FF:002346', NULL, NULL, 'Zinc finger protein 658', NULL, NULL, NULL, NULL, NULL, 4),
(106804, NULL, 'G3DSA:1.25.40.10:FF:000209', NULL, NULL, 'Tetratricopeptide repeat domain 28', NULL, NULL, NULL, NULL, NULL, 4),
(106805, NULL, 'G3DSA:3.40.30.10:FF:000484', NULL, NULL, 'GRXS13', NULL, NULL, NULL, NULL, NULL, 4),
(106806, NULL, 'G3DSA:3.30.40.10:FF:001906', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106807, NULL, 'G3DSA:3.40.47.10:FF:000230', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106808, NULL, 'G3DSA:2.40.33.10:FF:000015', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(106809, NULL, 'G3DSA:3.40.1380.10:FF:000018', NULL, NULL, 'ATP synthase gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(106810, NULL, 'G3DSA:3.30.200.20:FF:002372', NULL, NULL, 'Protein kinase protein with adenine nucleotide alpha hydrolase-like domain', NULL, NULL, NULL, NULL, NULL, 4),
(106811, NULL, 'G3DSA:1.10.720.60:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106812, NULL, 'G3DSA:2.80.10.50:FF:000214', NULL, NULL, 'Fibroblast growth factor 8', NULL, NULL, NULL, NULL, NULL, 4),
(106813, NULL, 'G3DSA:3.40.50.300:FF:003999', NULL, NULL, 'ABC transporter, class F', NULL, NULL, NULL, NULL, NULL, 4),
(106814, NULL, 'G3DSA:2.60.40.10:FF:005994', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106815, NULL, 'G3DSA:1.20.58.70:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106816, NULL, 'G3DSA:3.30.160.60:FF:006045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106817, NULL, 'G3DSA:1.10.10.10:FF:000511', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(106818, NULL, 'G3DSA:3.40.50.300:FF:000346', NULL, NULL, 'RAB31, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(106819, NULL, 'G3DSA:2.60.40.10:FF:004358', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106820, NULL, 'G3DSA:3.30.110.110:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106821, NULL, 'G3DSA:3.90.1100.10:FF:000054', NULL, NULL, 'DNA-directed RNA polymerase I subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(106822, NULL, 'G3DSA:3.40.350.10:FF:000101', NULL, NULL, 'FACT complex subunit spt16-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(106823, NULL, 'G3DSA:3.30.70.1400:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106824, NULL, 'G3DSA:3.90.1150.10:FF:000102', NULL, NULL, 'Kynureninase', NULL, NULL, NULL, NULL, NULL, 4),
(106825, NULL, 'G3DSA:3.40.50.300:FF:004078', NULL, NULL, 'MPP7 isoform 5', NULL, NULL, NULL, NULL, NULL, 4),
(106826, NULL, 'G3DSA:3.40.50.150:FF:000475', NULL, NULL, 'Ubiquinone biosynthesis O-methyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(106827, NULL, 'G3DSA:4.10.60.10:FF:000029', NULL, NULL, 'Serine/arginine-rich splicing factor RSZ22A', NULL, NULL, NULL, NULL, NULL, 4),
(106828, NULL, 'G3DSA:1.25.40.10:FF:000390', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(106829, NULL, 'G3DSA:1.20.920.30:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106830, NULL, 'G3DSA:2.70.98.10:FF:000051', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(106831, NULL, 'G3DSA:3.30.70.1230:FF:000093', NULL, NULL, '7TM diverse intracellular signaling', NULL, NULL, NULL, NULL, NULL, 4),
(106832, NULL, 'G3DSA:3.30.1120.10:FF:000075', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106833, NULL, 'G3DSA:1.10.510.10:FF:000628', NULL, NULL, 'protein spire homolog 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(106834, NULL, 'G3DSA:1.20.120.520:FF:000012', NULL, NULL, 'Putative a receptor for ubiquitination targets', NULL, NULL, NULL, NULL, NULL, 4),
(106835, NULL, 'G3DSA:3.40.50.150:FF:000519', NULL, NULL, 'DNA (cytosine-5)-methyltransferase DRM2', NULL, NULL, NULL, NULL, NULL, 4),
(106836, NULL, 'G3DSA:1.10.150.40:FF:000008', NULL, NULL, 'barrier-to-autointegration factor', NULL, NULL, NULL, NULL, NULL, 4),
(106837, NULL, 'G3DSA:2.40.160.10:FF:000028', NULL, NULL, 'Outer membrane protein OmpT', NULL, NULL, NULL, NULL, NULL, 4),
(106838, NULL, 'G3DSA:1.20.120.230:FF:000032', NULL, NULL, 'Alpha-CaTuliN (Catenin/vinculin related)', NULL, NULL, NULL, NULL, NULL, 4),
(106839, NULL, 'G3DSA:1.25.40.20:FF:000393', NULL, NULL, 'CRE-GLNA-3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(106840, NULL, 'G3DSA:1.25.40.10:FF:002452', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g04760, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(106841, NULL, 'G3DSA:3.40.50.300:FF:004741', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106842, NULL, 'G3DSA:1.10.10.60:FF:000609', NULL, NULL, 'Homeobox B4', NULL, NULL, NULL, NULL, NULL, 4),
(106843, NULL, 'G3DSA:3.30.160.60:FF:006354', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106844, NULL, 'G3DSA:3.30.420.40:FF:000461', NULL, NULL, 'Type 4 actin', NULL, NULL, NULL, NULL, NULL, 4),
(106845, NULL, 'G3DSA:1.10.630.10:FF:000694', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106846, NULL, 'G3DSA:3.90.1750.10:FF:000069', NULL, NULL, 'HECT E3 ubiquitin ligase', NULL, NULL, NULL, NULL, NULL, 4),
(106847, NULL, 'G3DSA:1.10.1000.11:FF:000028', NULL, NULL, 'Protein transport protein sec71', NULL, NULL, NULL, NULL, NULL, 4),
(106848, NULL, 'G3DSA:3.80.10.10:FF:001644', NULL, NULL, 'LRR and NB-ARC domains-containing disease resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(106849, NULL, 'G3DSA:3.30.40.10:FF:000979', NULL, NULL, 'E3 ubiquitin-protein ligase SINA-like 10', NULL, NULL, NULL, NULL, NULL, 4),
(106850, NULL, 'G3DSA:3.40.190.10:FF:000313', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(106851, NULL, 'G3DSA:1.20.1610.10:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106852, NULL, 'G3DSA:3.40.50.300:FF:006287', NULL, NULL, 'Elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(106853, NULL, 'G3DSA:1.20.58.390:FF:000182', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106854, NULL, 'G3DSA:2.60.40.10:FF:001014', NULL, NULL, 'vascular endothelial growth factor receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(106855, NULL, 'G3DSA:3.40.190.290:FF:000052', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(106856, NULL, 'G3DSA:1.25.40.20:FF:000864', NULL, NULL, 'Transient receptor potential cation channel subfamily A member 1', NULL, NULL, NULL, NULL, NULL, 4),
(106857, NULL, 'G3DSA:2.60.40.10:FF:004151', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106858, NULL, 'G3DSA:2.40.30.170:FF:000014', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(106859, NULL, 'G3DSA:3.90.550.10:FF:000279', NULL, NULL, 'Glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(106860, NULL, 'G3DSA:3.20.180.20:FF:000011', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(106861, NULL, 'G3DSA:1.10.238.10:FF:000484', NULL, NULL, 'Calmodulin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(106862, NULL, 'G3DSA:1.20.120.530:FF:000015', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(106863, NULL, 'G3DSA:1.10.510.10:FF:002770', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106864, NULL, 'G3DSA:2.130.10.10:FF:004218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106865, NULL, 'G3DSA:2.40.50.100:FF:000149', NULL, NULL, 'Carbamoyl-phosphate synthase L chain, ATP binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(106866, NULL, 'G3DSA:1.10.132.130:FF:000002', NULL, NULL, 'Legumain preproprotein', NULL, NULL, NULL, NULL, NULL, 4),
(106867, NULL, 'G3DSA:2.120.10.30:FF:000363', NULL, NULL, 'Superoxide dismutase (SodC), Cu-Zn family', NULL, NULL, NULL, NULL, NULL, 4),
(106868, NULL, 'G3DSA:3.30.230.130:FF:000017', NULL, NULL, 'Cullin-3', NULL, NULL, NULL, NULL, NULL, 4),
(106869, NULL, 'G3DSA:2.170.120.20:FF:000009', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(106870, NULL, 'G3DSA:1.20.144.10:FF:000106', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106871, NULL, 'G3DSA:1.10.3430.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106872, NULL, 'G3DSA:3.30.70.590:FF:000006', NULL, NULL, 'Poly(A) polymerase PAP, putative', NULL, NULL, NULL, NULL, NULL, 4),
(106873, NULL, 'G3DSA:3.80.10.10:FF:001217', NULL, NULL, 'Protein halfway', NULL, NULL, NULL, NULL, NULL, 4),
(106874, NULL, 'G3DSA:3.40.640.10:FF:000157', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(106875, NULL, 'G3DSA:3.30.230.120:FF:000014', NULL, NULL, 'GHMP kinase', NULL, NULL, NULL, NULL, NULL, 4),
(106876, NULL, 'G3DSA:3.40.50.300:FF:002487', NULL, NULL, 'Guanine nucleotide-binding protein G(i) subunit alpha-1', NULL, NULL, NULL, NULL, NULL, 4),
(106877, NULL, 'G3DSA:3.40.50.300:FF:006332', NULL, NULL, 'Cell division control protein 48 homolog C', NULL, NULL, NULL, NULL, NULL, 4),
(106878, NULL, 'G3DSA:3.40.50.880:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106879, NULL, 'G3DSA:3.30.420.40:FF:000034', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(106880, NULL, 'G3DSA:2.160.20.10:FF:000305', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106881, NULL, 'G3DSA:1.10.510.10:FF:002219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106882, NULL, 'G3DSA:3.30.1680.10:FF:000015', NULL, NULL, 'semaphorin-6C isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(106883, NULL, 'G3DSA:1.25.10.10:FF:002271', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(106884, NULL, 'G3DSA:3.30.200.20:FF:000129', NULL, NULL, 'Transient receptor potential cation channel, subfamily M, member 7', NULL, NULL, NULL, NULL, NULL, 4),
(106885, NULL, 'G3DSA:1.20.1250.20:FF:000939', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106886, NULL, 'G3DSA:1.10.510.10:FF:000527', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(106887, NULL, 'G3DSA:1.20.120.1750:FF:000124', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(106888, NULL, 'G3DSA:3.30.70.580:FF:000003', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(106889, NULL, 'G3DSA:2.60.40.60:FF:000517', NULL, NULL, 'Protein CBG11732', NULL, NULL, NULL, NULL, NULL, 4),
(106890, NULL, 'G3DSA:2.60.120.10:FF:000741', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106891, NULL, 'G3DSA:2.30.30.210:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106892, NULL, 'G3DSA:2.130.10.10:FF:005747', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106893, NULL, 'G3DSA:3.30.200.20:FF:002271', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106894, NULL, 'G3DSA:1.25.40.10:FF:001845', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(106895, NULL, 'G3DSA:3.40.630.10:FF:000229', NULL, NULL, 'Carboxypeptidase Z', NULL, NULL, NULL, NULL, NULL, 4),
(106896, NULL, 'G3DSA:1.20.1050.10:FF:000241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106897, NULL, 'G3DSA:3.30.160.60:FF:002554', NULL, NULL, 'Zinc finger protein 778', NULL, NULL, NULL, NULL, NULL, 4),
(106898, NULL, 'G3DSA:3.40.50.1240:FF:000115', NULL, NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(106899, NULL, 'G3DSA:1.10.150.20:FF:000002', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(106900, NULL, 'G3DSA:1.10.238.10:FF:000175', NULL, NULL, 'Calpain 14', NULL, NULL, NULL, NULL, NULL, 4),
(106901, NULL, 'G3DSA:3.80.20.20:FF:000063', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(106902, NULL, 'G3DSA:3.30.420.40:FF:000343', NULL, NULL, 'Chromatin remodeling Snf/Swi complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(106903, NULL, 'G3DSA:3.90.550.10:FF:000072', NULL, NULL, 'UDP-N-acetylglucosamine diphosphorylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(106904, NULL, 'G3DSA:3.40.50.720:FF:002040', NULL, NULL, 'Probable NADPH-dependent quinone reductase tdiC', NULL, NULL, NULL, NULL, NULL, 4),
(106905, NULL, 'G3DSA:1.10.472.10:FF:000308', NULL, NULL, 'Mitotic cyclin 6', NULL, NULL, NULL, NULL, NULL, 4),
(106906, NULL, 'G3DSA:3.30.420.40:FF:000770', NULL, NULL, 'Heat shock protein 70 putative', NULL, NULL, NULL, NULL, NULL, 4),
(106907, NULL, 'G3DSA:3.40.50.300:FF:008541', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106908, NULL, 'G3DSA:3.40.50.1820:FF:000969', NULL, NULL, 'Cholinesterase, putative (AFU_orthologue AFUA_7G01710)', NULL, NULL, NULL, NULL, NULL, 4),
(106909, NULL, 'G3DSA:3.30.160.60:FF:000093', NULL, NULL, 'zinc finger protein 668 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(106910, NULL, 'G3DSA:3.80.10.10:FF:001335', NULL, NULL, 'Relaxin family peptide receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(106911, NULL, 'G3DSA:3.30.160.60:FF:004336', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106912, NULL, 'G3DSA:2.40.70.10:FF:000516', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106913, NULL, 'G3DSA:3.50.50.60:FF:000050', NULL, NULL, 'L-2-hydroxyglutarate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(106914, NULL, 'G3DSA:1.25.10.10:FF:002580', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106915, NULL, 'G3DSA:2.60.40.60:FF:000860', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106916, NULL, 'G3DSA:3.40.50.300:FF:003004', NULL, NULL, 'ras-related protein Rab-39B-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(106917, NULL, 'G3DSA:2.160.20.10:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106918, NULL, 'G3DSA:2.40.10.10:FF:000097', NULL, NULL, 'Coagulation factor XII', NULL, NULL, NULL, NULL, NULL, 4),
(106919, NULL, 'G3DSA:1.10.287.1490:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106920, NULL, 'G3DSA:1.10.238.10:FF:000411', NULL, NULL, 'Os12g0138050 protein', NULL, NULL, NULL, NULL, NULL, 4),
(106921, NULL, 'G3DSA:2.120.10.30:FF:000155', NULL, NULL, 'FI21413p1', NULL, NULL, NULL, NULL, NULL, 4),
(106922, NULL, 'G3DSA:3.60.21.50:FF:000007', NULL, NULL, 'DNA polymerase epsilon subunit', NULL, NULL, NULL, NULL, NULL, 4),
(106923, NULL, 'G3DSA:3.40.50.620:FF:000003', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(106924, NULL, 'G3DSA:1.10.275.40:FF:000011', NULL, NULL, 'DNA repair helicase Rad3', NULL, NULL, NULL, NULL, NULL, 4),
(106925, NULL, 'G3DSA:3.30.1490.110:FF:000005', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(106926, NULL, 'G3DSA:2.30.180.10:FF:000167', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106927, NULL, 'G3DSA:3.30.70.920:FF:000004', NULL, NULL, 'Chaperone NapD', NULL, NULL, NULL, NULL, NULL, 4),
(106928, NULL, 'G3DSA:2.10.70.10:FF:000097', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(106929, NULL, 'G3DSA:1.10.132.60:FF:000017', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(106930, NULL, 'G3DSA:1.10.472.10:FF:000426', NULL, NULL, 'Cyclin I, putative', NULL, NULL, NULL, NULL, NULL, 4),
(106931, NULL, 'G3DSA:3.40.50.150:FF:000930', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106932, NULL, 'G3DSA:4.10.400.10:FF:000154', NULL, NULL, 'Low-density lipoprotein receptor-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(106933, NULL, 'G3DSA:1.25.10.10:FF:002624', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106934, NULL, 'G3DSA:1.10.10.60:FF:000817', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106935, NULL, 'G3DSA:1.10.238.10:FF:000927', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(106936, NULL, 'G3DSA:1.25.40.10:FF:000518', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(106937, NULL, 'G3DSA:1.10.533.10:FF:000198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106938, NULL, 'G3DSA:3.30.1490.100:FF:000002', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(106939, NULL, 'G3DSA:2.40.30.10:FF:000407', NULL, NULL, 'Eukaryotic Release FActor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(106940, NULL, 'G3DSA:3.50.50.60:FF:000460', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(106941, NULL, 'G3DSA:3.30.390.110:FF:000006', NULL, NULL, '60S ribosomal protein L28', NULL, NULL, NULL, NULL, NULL, 4),
(106942, NULL, 'G3DSA:1.10.274.30:FF:000028', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106943, NULL, 'G3DSA:3.30.70.2190:FF:000009', NULL, NULL, 'FAD-linked oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(106944, NULL, 'G3DSA:1.25.40.10:FF:004560', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106945, NULL, 'G3DSA:2.60.120.260:FF:000323', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106946, NULL, 'G3DSA:3.90.70.10:FF:000276', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(106947, NULL, 'G3DSA:2.30.42.10:FF:000300', NULL, NULL, 'Par-3 family cell polarity regulator beta', NULL, NULL, NULL, NULL, NULL, 4),
(106948, NULL, 'G3DSA:3.40.30.10:FF:001107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106949, NULL, 'G3DSA:3.30.1490.120:FF:000008', NULL, NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(106950, NULL, 'G3DSA:1.10.238.10:FF:000057', NULL, NULL, 'Tubulin polymerization-promoting protein family member 3', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(106951, NULL, 'G3DSA:1.25.10.10:FF:000253', NULL, NULL, 'Splicing factor 3B subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(106952, NULL, 'G3DSA:3.40.50.300:FF:000447', NULL, NULL, 'helicase SKI2W isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(106953, NULL, 'G3DSA:1.10.510.10:FF:000319', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(106954, NULL, 'G3DSA:4.10.70.10:FF:000002', NULL, NULL, 'disintegrin and metalloproteinase domain-containing protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(106955, NULL, 'G3DSA:2.60.40.10:FF:002133', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(106956, NULL, 'G3DSA:2.60.40.10:FF:000761', NULL, NULL, 'palladin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(106957, NULL, 'G3DSA:2.60.120.40:FF:000036', NULL, NULL, 'C1qA', NULL, NULL, NULL, NULL, NULL, 4),
(106958, NULL, 'G3DSA:3.10.110.10:FF:000225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106959, NULL, 'G3DSA:2.60.40.10:FF:002649', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(106960, NULL, 'G3DSA:3.10.450.50:FF:000026', NULL, NULL, 'Steroid isomerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(106961, NULL, 'G3DSA:3.10.450.40:FF:000023', NULL, NULL, 'Type VI secretion system protein', NULL, NULL, NULL, NULL, NULL, 4),
(106962, NULL, 'G3DSA:2.130.10.10:FF:000312', NULL, NULL, 'WD repeat domain 91', NULL, NULL, NULL, NULL, NULL, 4),
(106963, NULL, 'G3DSA:1.10.20.10:FF:000219', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106964, NULL, 'G3DSA:3.10.20.310:FF:000018', NULL, NULL, 'ShlB/FhaC/HecB family hemolysin secretion/activation protein', NULL, NULL, NULL, NULL, NULL, 4),
(106965, NULL, 'G3DSA:3.40.50.150:FF:000828', NULL, NULL, 'tRNA wybutosine-synthesizing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(106966, NULL, 'G3DSA:3.30.160.60:FF:000284', NULL, NULL, 'Zinc finger protein 652 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(106967, NULL, 'G3DSA:3.60.15.10:FF:000032', NULL, NULL, 'Metallo-hydrolase/oxidoreductase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(106968, NULL, 'G3DSA:2.30.30.40:FF:000607', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106969, NULL, 'G3DSA:3.40.50.720:FF:002141', NULL, NULL, 'Os03g0184600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(106970, NULL, 'G3DSA:1.10.287.110:FF:000419', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106971, NULL, 'G3DSA:2.130.10.10:FF:000828', NULL, NULL, 'Ribosomal processing protein', NULL, NULL, NULL, NULL, NULL, 4),
(106972, NULL, 'G3DSA:3.40.50.720:FF:001635', NULL, NULL, 'Short-chain dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(106973, NULL, 'G3DSA:1.20.85.10:FF:000003', NULL, NULL, 'Photosystem II D2 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(106974, NULL, 'G3DSA:3.90.550.10:FF:000173', NULL, NULL, 'Cellulose synthase-like protein E1', NULL, NULL, NULL, NULL, NULL, 4),
(106975, NULL, 'G3DSA:3.10.20.90:FF:000547', NULL, NULL, 'Histidine ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(106976, NULL, 'G3DSA:2.130.10.10:FF:005955', NULL, NULL, 'R-SNARE protein, tomsyn-like family', NULL, NULL, NULL, NULL, NULL, 4),
(106977, NULL, 'G3DSA:3.40.50.1100:FF:000068', NULL, NULL, 'Catabolic L-serine/threonine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(106978, NULL, 'G3DSA:3.30.428.10:FF:000003', NULL, NULL, 'Purine nucleoside phosphoramidase', NULL, NULL, NULL, NULL, NULL, 4),
(106979, NULL, 'G3DSA:3.30.200.20:FF:002063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106980, NULL, 'G3DSA:3.30.160.60:FF:000194', NULL, NULL, 'Fez family zinc finger protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(106981, NULL, 'G3DSA:2.30.30.40:FF:000517', NULL, NULL, 'zinc finger protein (ZZ-type)-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(106982, NULL, 'G3DSA:3.40.50.300:FF:008440', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106983, NULL, 'G3DSA:1.10.510.10:FF:002427', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(106984, NULL, 'G3DSA:3.40.630.30:FF:000578', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106985, NULL, 'G3DSA:3.40.140.10:FF:000265', NULL, NULL, 'Activation-induced cytidine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(106986, NULL, 'G3DSA:3.80.10.10:FF:003325', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106987, NULL, 'G3DSA:3.30.70.330:FF:001468', NULL, NULL, 'U2 snRNP complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(106988, NULL, 'G3DSA:1.25.40.10:FF:002660', NULL, NULL, 'Evolutionarily conserved signaling intermediate in Toll pathway, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(106989, NULL, 'G3DSA:3.30.830.10:FF:000056', NULL, NULL, 'Falcilysin', NULL, NULL, NULL, NULL, NULL, 4),
(106990, NULL, 'G3DSA:1.25.40.20:FF:000763', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(106991, NULL, 'G3DSA:2.40.70.10:FF:000073', NULL, NULL, 'Aspartic proteinase PCS1', NULL, NULL, NULL, NULL, NULL, 4),
(106992, NULL, 'G3DSA:3.30.160.60:FF:004807', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(106993, NULL, 'G3DSA:2.40.340.10:FF:000003', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(106994, NULL, 'G3DSA:1.20.1270.280:FF:000082', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(106995, NULL, 'G3DSA:1.20.1250.20:FF:001299', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(106996, NULL, 'G3DSA:2.30.180.10:FF:000066', NULL, NULL, 'Transforming growth factor-beta-induced protein', NULL, NULL, NULL, NULL, NULL, 4),
(106997, NULL, 'G3DSA:1.25.40.70:FF:000059', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(106998, NULL, 'G3DSA:1.10.510.10:FF:002118', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF a', NULL, NULL, NULL, NULL, NULL, 4),
(106999, NULL, 'G3DSA:1.10.10.10:FF:000191', NULL, NULL, 'Transcription factor PU.1', NULL, NULL, NULL, NULL, NULL, 4),
(107000, NULL, 'G3DSA:1.10.287.950:FF:000025', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(107001, NULL, 'G3DSA:3.40.50.200:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107002, NULL, 'G3DSA:1.10.10.60:FF:000301', NULL, NULL, 'Formate hydrogenlyase transcriptional activator', NULL, NULL, NULL, NULL, NULL, 4),
(107003, NULL, 'G3DSA:1.10.287.940:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107004, NULL, 'G3DSA:1.20.1070.10:FF:001653', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107005, NULL, 'G3DSA:3.40.50.300:FF:001161', NULL, NULL, 'spermatogenesis-associated protein 5-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(107006, NULL, 'G3DSA:1.20.1250.20:FF:001962', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107007, NULL, 'G3DSA:1.20.20.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107008, NULL, 'G3DSA:3.30.590.10:FF:000003', NULL, NULL, 'Glutamine synthetase 2', NULL, NULL, NULL, NULL, NULL, 4),
(107009, NULL, 'G3DSA:3.40.50.10470:FF:000062', NULL, NULL, 'Methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(107010, NULL, 'G3DSA:3.10.20.90:FF:000856', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107011, NULL, 'G3DSA:3.10.580.10:FF:000176', NULL, NULL, 'Cystathionine beta-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(107012, NULL, 'G3DSA:3.40.50.880:FF:000031', NULL, NULL, 'Multifunctional tryptophan biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(107013, NULL, 'G3DSA:3.40.50.1000:FF:000291', NULL, NULL, 'Hydrolase, haloacid dehalogenase-like family', NULL, NULL, NULL, NULL, NULL, 4),
(107014, NULL, 'G3DSA:1.25.40.20:FF:001117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107015, NULL, 'G3DSA:1.20.120.140:FF:000005', NULL, NULL, 'Signal recognition particle 54 kDa protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(107016, NULL, 'G3DSA:2.70.150.10:FF:000252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107017, NULL, 'G3DSA:3.30.230.70:FF:000056', NULL, NULL, 'Exosome complex exonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107018, NULL, 'G3DSA:2.60.40.1170:FF:000023', NULL, NULL, 'AP-2 complex subunit mu', NULL, NULL, NULL, NULL, NULL, 4),
(107019, NULL, 'G3DSA:2.130.10.10:FF:000519', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(107020, NULL, 'G3DSA:2.30.30.40:FF:000046', NULL, NULL, 'Drebrin-like protein isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(107021, NULL, 'G3DSA:2.10.60.10:FF:000079', NULL, NULL, 'Serine/threonine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(107022, NULL, 'G3DSA:1.20.120.980:FF:000021', NULL, NULL, 'AGAP003642-PA', NULL, NULL, NULL, NULL, NULL, 4),
(107023, NULL, 'G3DSA:1.10.10.2660:FF:000009', NULL, NULL, 'Ubiquitin-activating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(107024, NULL, 'G3DSA:2.30.29.30:FF:000899', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(107025, NULL, 'G3DSA:4.10.180.10:FF:000001', NULL, NULL, 'Rhs element Vgr protein', NULL, NULL, NULL, NULL, NULL, 4),
(107026, NULL, 'G3DSA:3.30.460.80:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107027, NULL, 'G3DSA:3.40.50.1240:FF:000014', NULL, NULL, 'Multiple inositol polyphosphate phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(107028, NULL, 'G3DSA:3.30.590.20:FF:000006', NULL, NULL, 'Glutamate--cysteine ligase EgtA', NULL, NULL, NULL, NULL, NULL, 4),
(107029, NULL, 'G3DSA:1.20.1070.10:FF:001344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107030, NULL, 'G3DSA:2.40.10.10:FF:000187', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(107031, NULL, 'G3DSA:2.130.10.10:FF:004319', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(107032, NULL, 'G3DSA:2.170.130.10:FF:000035', NULL, NULL, 'Vitamin B12 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(107033, NULL, 'G3DSA:2.130.10.10:FF:002419', NULL, NULL, 'WD repeat-containing protein 16, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107034, NULL, 'G3DSA:3.30.160.60:FF:002655', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(107035, NULL, 'G3DSA:3.30.160.60:FF:000755', NULL, NULL, 'zinc finger protein 174', NULL, NULL, NULL, NULL, NULL, 4),
(107036, NULL, 'G3DSA:1.10.10.1100:FF:000019', NULL, NULL, 'Nitrogen fixation protein NifU', NULL, NULL, NULL, NULL, NULL, 4),
(107037, NULL, 'G3DSA:3.40.50.1820:FF:001374', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107038, NULL, 'G3DSA:1.20.120.1200:FF:000015', NULL, NULL, 'NADH-ubiquinone oxidoreductase chain 6', NULL, NULL, NULL, NULL, NULL, 4),
(107039, NULL, 'G3DSA:2.30.30.30:FF:000043', NULL, NULL, 'Transcription elongation factor SPT5', NULL, NULL, NULL, NULL, NULL, 4),
(107040, NULL, 'G3DSA:3.90.226.10:FF:000245', NULL, NULL, 'Enoyl-CoA hydratase/isomerase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(107041, NULL, 'G3DSA:1.10.510.10:FF:004018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107042, NULL, 'G3DSA:1.25.40.10:FF:001946', NULL, NULL, 'Os02g0730900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(107043, NULL, 'G3DSA:1.20.1250.20:FF:001092', NULL, NULL, 'Solute carrier family 37 member 4b', NULL, NULL, NULL, NULL, NULL, 4),
(107044, NULL, 'G3DSA:2.10.25.10:FF:001335', NULL, NULL, 'Notch receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(107045, NULL, 'G3DSA:3.40.50.10810:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107046, NULL, 'G3DSA:3.30.200.20:FF:001866', NULL, NULL, 'P21 protein (Cdc42/Rac)-activated kinase 2b', NULL, NULL, NULL, NULL, NULL, 4),
(107047, NULL, 'G3DSA:3.40.532.10:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107048, NULL, 'G3DSA:1.10.10.60:FF:000256', NULL, NULL, 'Even-skipped homeobox 1', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(107049, NULL, 'G3DSA:3.40.630.30:FF:000680', NULL, NULL, 'N-acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107050, NULL, 'G3DSA:3.40.630.10:FF:000123', NULL, NULL, 'Vacuolar carboxypeptidase Cps1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107051, NULL, 'G3DSA:2.60.40.10:FF:004903', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107052, NULL, 'G3DSA:1.10.533.10:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107053, NULL, 'G3DSA:3.40.50.1820:FF:000401', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(107054, NULL, 'G3DSA:2.60.34.10:FF:000022', NULL, NULL, 'Heat shock 70 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(107055, NULL, 'G3DSA:3.30.60.30:FF:000065', NULL, NULL, 'SPINK9 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(107056, NULL, 'G3DSA:3.30.60.20:FF:000062', NULL, NULL, 'Thymidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(107057, NULL, 'G3DSA:1.20.1300.10:FF:000025', NULL, NULL, 'Succinate dehydrogenase cytochrome B-556 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(107058, NULL, 'G3DSA:2.20.70.10:FF:000152', NULL, NULL, 'Pre-mRNA-processing factor 40 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(107059, NULL, 'G3DSA:3.40.50.300:FF:008131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107060, NULL, 'G3DSA:2.160.10.10:FF:000024', NULL, NULL, 'GDP-mannose pyrophosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(107061, NULL, 'G3DSA:3.40.50.1820:FF:001683', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(107062, NULL, 'G3DSA:1.10.287.110:FF:000329', NULL, NULL, 'Chaperone protein DNAj, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107063, NULL, 'G3DSA:3.40.1700.10:FF:000004', NULL, NULL, 'Diadenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(107064, NULL, 'G3DSA:3.90.550.10:FF:000482', NULL, NULL, 'Glycoside transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(107065, NULL, 'G3DSA:3.20.20.300:FF:000041', NULL, NULL, 'Putative lipoprotein YbbD', NULL, NULL, NULL, NULL, NULL, 4),
(107066, NULL, 'G3DSA:1.20.5.130:FF:000003', NULL, NULL, 'Bacteriocin curvaticin', NULL, NULL, NULL, NULL, NULL, 4),
(107067, NULL, 'G3DSA:1.10.472.80:FF:000279', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107068, NULL, 'G3DSA:1.10.1600.10:FF:000022', NULL, NULL, 'ATP-dependent DNA helicase II subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(107069, NULL, 'G3DSA:2.20.25.10:FF:000059', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(107070, NULL, 'G3DSA:1.10.20.10:FF:000129', NULL, NULL, 'Transcription factor TFIID complex subunit Taf13', NULL, NULL, NULL, NULL, NULL, 4),
(107071, NULL, 'G3DSA:3.40.720.10:FF:000259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107072, NULL, 'G3DSA:3.30.70.960:FF:000010', NULL, NULL, 'Transmembrane protease serine', NULL, NULL, NULL, NULL, NULL, 4),
(107073, NULL, 'G3DSA:3.30.160.600:FF:000001', NULL, NULL, 'DNA double-strand break repair protein Mre11', NULL, NULL, NULL, NULL, NULL, 4),
(107074, NULL, 'G3DSA:3.40.50.170:FF:000014', NULL, NULL, 'Phosphoribosylglycinamide formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(107075, NULL, 'G3DSA:3.40.50.2000:FF:000225', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(107076, NULL, 'G3DSA:3.30.70.980:FF:000016', NULL, NULL, 'Probable transcriptional regulatory protein HP_0162', NULL, NULL, NULL, NULL, NULL, 4),
(107077, NULL, 'G3DSA:3.30.1390.10:FF:000004', NULL, NULL, 'ATP-dependent Clp protease adapter protein ClpS', NULL, NULL, NULL, NULL, NULL, 4),
(107078, NULL, 'G3DSA:1.25.70.10:FF:000037', NULL, NULL, 'Transcription termination factor MTEF1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(107079, NULL, 'G3DSA:1.10.238.10:FF:000720', NULL, NULL, 'Calmodulin-like protein 30', NULL, NULL, NULL, NULL, NULL, 4),
(107080, NULL, 'G3DSA:3.40.50.11340:FF:000008', NULL, NULL, 'Galactoside 2-alpha-L-fucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(107081, NULL, 'G3DSA:1.20.5.340:FF:000083', NULL, NULL, 'Chloroplast Rat1', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(107082, NULL, 'G3DSA:2.60.40.150:FF:000096', NULL, NULL, 'E3 ubiquitin-protein ligase Nedd-4', NULL, NULL, NULL, NULL, NULL, 4),
(107083, NULL, 'G3DSA:1.20.1250.20:FF:001653', NULL, NULL, 'DHA2 family efflux MFS transporter permease subunit', NULL, NULL, NULL, NULL, NULL, 4),
(107084, NULL, 'G3DSA:1.10.730.10:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107085, NULL, 'G3DSA:2.60.120.650:FF:000125', NULL, NULL, 'AGAP004022-PA', NULL, NULL, NULL, NULL, NULL, 4),
(107086, NULL, 'G3DSA:3.20.20.220:FF:000051', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(107087, NULL, 'G3DSA:2.60.120.10:FF:000595', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107088, NULL, 'G3DSA:3.40.50.300:FF:008086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107089, NULL, 'G3DSA:3.40.640.10:FF:000303', NULL, NULL, 'Si:ch211-180m24.3', NULL, NULL, NULL, NULL, NULL, 4),
(107090, NULL, 'G3DSA:2.60.40.790:FF:000175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107091, NULL, 'G3DSA:3.30.200.20:FF:001557', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107092, NULL, 'G3DSA:1.10.2020.20:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107093, NULL, 'G3DSA:3.40.30.10:FF:000383', NULL, NULL, 'Thioredoxin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107094, NULL, 'G3DSA:3.30.40.10:FF:000260', NULL, NULL, 'RING finger protein 24', NULL, NULL, NULL, NULL, NULL, 4),
(107095, NULL, 'G3DSA:2.60.40.2560:FF:000001', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(107096, NULL, 'G3DSA:2.130.10.10:FF:004561', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107097, NULL, 'G3DSA:1.10.1130.10:FF:000014', NULL, NULL, 'Nitrite reductase (cytochrome; ammonia-forming)', NULL, NULL, NULL, NULL, NULL, 4),
(107098, NULL, 'G3DSA:1.10.287.3510:FF:000002', NULL, NULL, 'NADH-ubiquinone oxidoreductase chain 4L', NULL, NULL, NULL, NULL, NULL, 4),
(107099, NULL, 'G3DSA:3.40.50.300:FF:006186', NULL, NULL, 'Uncharacterized GTP-binding protein P8A3.05', NULL, NULL, NULL, NULL, NULL, 4),
(107100, NULL, 'G3DSA:1.25.40.10:FF:004251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107101, NULL, 'G3DSA:1.25.40.240:FF:000004', NULL, NULL, 'KU80 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107102, NULL, 'G3DSA:2.60.40.10:FF:004813', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107103, NULL, 'G3DSA:2.60.120.200:FF:000013', NULL, NULL, 'Slit guidance ligand 2', NULL, NULL, NULL, NULL, NULL, 4),
(107104, NULL, 'G3DSA:3.40.309.10:FF:000011', NULL, NULL, 'Delta-1-pyrroline-5-carboxylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(107105, NULL, 'G3DSA:1.20.200.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107106, NULL, 'G3DSA:1.10.540.10:FF:000046', NULL, NULL, 'Acyl-CoA dehydrogenase FadE17', NULL, NULL, NULL, NULL, NULL, 4),
(107107, NULL, 'G3DSA:1.10.30.10:FF:000057', NULL, NULL, 'Protein maelstrom 2', NULL, NULL, NULL, NULL, NULL, 4),
(107108, NULL, 'G3DSA:1.10.287.70:FF:000688', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(107109, NULL, 'G3DSA:2.170.270.10:FF:000219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107110, NULL, 'G3DSA:1.10.8.1290:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107111, NULL, 'G3DSA:3.30.530.20:FF:000132', NULL, NULL, 'F-box/WD repeat-containing protein A-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(107112, NULL, 'G3DSA:3.30.497.10:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107113, NULL, 'G3DSA:3.40.50.11320:FF:000002', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(107114, NULL, 'G3DSA:3.40.1690.10:FF:000019', NULL, NULL, 'Flagellar biosynthesis protein FlhB', NULL, NULL, NULL, NULL, NULL, 4),
(107115, NULL, 'G3DSA:3.40.800.20:FF:000049', NULL, NULL, 'Chromosome 16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(107116, NULL, 'G3DSA:3.30.70.330:FF:000024', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein q isoform', NULL, NULL, NULL, NULL, NULL, 4),
(107117, NULL, 'G3DSA:3.40.640.10:FF:000051', NULL, NULL, '1-aminocyclopropane-1-carboxylate synthase 3', NULL, NULL, NULL, NULL, NULL, 4),
(107118, NULL, 'G3DSA:2.60.40.10:FF:005786', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107119, NULL, 'G3DSA:2.60.40.10:FF:000851', NULL, NULL, 'interleukin-13 receptor subunit alpha-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(107120, NULL, 'G3DSA:1.25.40.250:FF:000007', NULL, NULL, 'COP9 signalosome, subunit CSN8, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107121, NULL, 'G3DSA:3.40.800.10:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107122, NULL, 'G3DSA:2.130.10.10:FF:004870', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107123, NULL, 'G3DSA:1.20.5.2440:FF:000014', NULL, NULL, 'Rab11 family-interacting protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(107124, NULL, 'G3DSA:3.40.30.10:FF:000692', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107125, NULL, 'G3DSA:3.10.290.10:FF:000075', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(107126, NULL, 'G3DSA:3.30.1390.20:FF:000007', NULL, NULL, '50S ribosomal protein L30', NULL, NULL, NULL, NULL, NULL, 4),
(107127, NULL, 'G3DSA:3.10.330.70:FF:000001', NULL, NULL, 'Putative lysine-specific demethylase 4a', NULL, NULL, NULL, NULL, NULL, 4),
(107128, NULL, 'G3DSA:2.40.30.130:FF:000036', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(107129, NULL, 'G3DSA:2.60.40.10:FF:000542', NULL, NULL, 'Interleukin-6 receptor subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(107130, NULL, 'G3DSA:1.20.1250.20:FF:000107', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(107131, NULL, 'G3DSA:2.40.160.10:FF:000012', NULL, NULL, 'Voltage-dependent anion-selective channel', NULL, NULL, NULL, NULL, NULL, 4),
(107132, NULL, 'G3DSA:2.60.40.150:FF:000539', NULL, NULL, 'E3 ubiquitin-protein ligase HECW1', NULL, NULL, NULL, NULL, NULL, 4),
(107133, NULL, 'G3DSA:2.40.20.10:FF:000019', NULL, NULL, 'Muscle, skeletal receptor tyrosine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(107134, NULL, 'G3DSA:3.30.1510.10:FF:000003', NULL, NULL, 'Formate--tetrahydrofolate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(107135, NULL, 'G3DSA:3.10.20.90:FF:000194', NULL, NULL, 'U11/U12 small nuclear ribonucleoprotein 25 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(107136, NULL, 'G3DSA:1.10.510.10:FF:000544', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(107137, NULL, 'G3DSA:3.90.550.10:FF:000156', NULL, NULL, 'Cellulose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(107138, NULL, 'G3DSA:3.40.30.10:FF:000574', NULL, NULL, 'Thioredoxin related transmembrane protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(107139, NULL, 'G3DSA:3.30.497.10:FF:000005', NULL, NULL, 'serpin I2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(107140, NULL, 'G3DSA:1.20.1070.10:FF:001434', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(107141, NULL, 'G3DSA:3.30.70.330:FF:002047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107142, NULL, 'G3DSA:3.40.50.300:FF:001998', NULL, NULL, 'ABC transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(107143, NULL, 'G3DSA:1.10.1240.40:FF:000003', NULL, NULL, 'Protein EMSY-LIKE 3 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(107144, NULL, 'G3DSA:2.40.10.10:FF:000524', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107145, NULL, 'G3DSA:1.10.1450.10:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107146, NULL, 'G3DSA:3.40.140.10:FF:000248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107147, NULL, 'G3DSA:1.20.1310.10:FF:000205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107148, NULL, 'G3DSA:2.60.40.10:FF:000109', NULL, NULL, 'obscurin isoform X5', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(107149, NULL, 'G3DSA:3.80.20.20:FF:000080', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(107150, NULL, 'G3DSA:3.40.50.300:FF:002471', NULL, NULL, 'Rab family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(107151, NULL, 'G3DSA:2.20.70.10:FF:000017', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(107152, NULL, 'G3DSA:3.40.50.720:FF:001079', NULL, NULL, 'Acylglycerone-phosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(107153, NULL, 'G3DSA:1.10.8.720:FF:000008', NULL, NULL, 'Dynein axonemal heavy chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(107154, NULL, 'G3DSA:2.60.40.60:FF:001113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107155, NULL, 'G3DSA:1.10.10.60:FF:000172', NULL, NULL, 'Homeobox and leucine zipper protein Homez', NULL, NULL, NULL, NULL, NULL, 4),
(107156, NULL, 'G3DSA:3.20.20.70:FF:000569', NULL, NULL, 'Delta-aminolevulinic acid dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(107157, NULL, 'G3DSA:3.50.50.60:FF:000241', NULL, NULL, 'Pyridine nucleotide-disulfide oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(107158, NULL, 'G3DSA:3.30.160.60:FF:004246', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107159, NULL, 'G3DSA:3.40.50.620:FF:000312', NULL, NULL, 'YdcF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(107160, NULL, 'G3DSA:3.30.70.330:FF:003149', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107161, NULL, 'G3DSA:2.120.10.30:FF:000240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107162, NULL, 'G3DSA:3.30.460.20:FF:000002', NULL, NULL, 'Cora family metal ion transporter', NULL, NULL, NULL, NULL, NULL, 4),
(107163, NULL, 'G3DSA:1.25.40.1010:FF:000007', NULL, NULL, 'NMDA receptor-regulated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107164, NULL, 'G3DSA:3.40.50.1100:FF:000287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107165, NULL, 'G3DSA:3.40.309.10:FF:000101', NULL, NULL, 'NAD(P)-dependent benzaldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(107166, NULL, 'G3DSA:3.40.50.1000:FF:000717', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107167, NULL, 'G3DSA:3.10.100.10:FF:000168', NULL, NULL, 'Phospholipase A2 receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(107168, NULL, 'G3DSA:1.10.8.710:FF:000005', NULL, NULL, 'Cytoplasmic dynein heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(107169, NULL, 'G3DSA:1.10.10.60:FF:000711', NULL, NULL, 'Homeobox protein HAT3.1', NULL, NULL, NULL, NULL, NULL, 4),
(107170, NULL, 'G3DSA:3.30.450.150:FF:000005', NULL, NULL, 'UPF0303 protein Ping_1243', NULL, NULL, NULL, NULL, NULL, 4),
(107171, NULL, 'G3DSA:4.10.640.10:FF:000020', NULL, NULL, '37S ribosomal protein RSM18, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(107172, NULL, 'G3DSA:2.70.130.10:FF:000144', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107173, NULL, 'G3DSA:2.30.30.40:FF:000147', NULL, NULL, 'Cas scaffold protein family member 4', NULL, NULL, NULL, NULL, NULL, 4),
(107174, NULL, 'G3DSA:1.25.40.10:FF:003970', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107175, NULL, 'G3DSA:1.20.272.10:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107176, NULL, 'G3DSA:2.70.150.10:FF:000151', NULL, NULL, 'Heavy metal translocating P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(107177, NULL, 'G3DSA:3.90.550.10:FF:000633', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107178, NULL, 'G3DSA:1.20.1310.20:FF:000057', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(107179, NULL, 'G3DSA:2.60.210.10:FF:000040', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(107180, NULL, 'G3DSA:3.40.630.10:FF:000230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107181, NULL, 'G3DSA:1.20.1310.10:FF:000054', NULL, NULL, 'Cullin-4', NULL, NULL, NULL, NULL, NULL, 4),
(107182, NULL, 'G3DSA:1.10.1370.30:FF:000026', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(107183, NULL, 'G3DSA:3.90.550.10:FF:000263', NULL, NULL, 'Probable glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(107184, NULL, 'G3DSA:3.40.50.300:FF:006416', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(107185, NULL, 'G3DSA:3.40.50.300:FF:008350', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(107186, NULL, 'G3DSA:1.10.730.10:FF:000072', NULL, NULL, 'Leucyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(107187, NULL, 'G3DSA:2.60.40.10:FF:006039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107188, NULL, 'G3DSA:3.30.505.10:FF:000059', NULL, NULL, 'hematopoietic SH2 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(107189, NULL, 'G3DSA:1.10.1410.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107190, NULL, 'G3DSA:3.30.565.10:FF:000361', NULL, NULL, 'PMS (Post Meiotic Segregation) family', NULL, NULL, NULL, NULL, NULL, 4),
(107191, NULL, 'G3DSA:2.60.120.10:FF:000387', NULL, NULL, 'cGMP-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(107192, NULL, 'G3DSA:3.90.470.20:FF:000012', NULL, NULL, 'Enterobactin synthase component D', NULL, NULL, NULL, NULL, NULL, 4),
(107193, NULL, 'G3DSA:3.30.160.60:FF:000980', NULL, NULL, 'Zinc finger protein, FOG family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(107194, NULL, 'G3DSA:3.40.50.300:FF:000907', NULL, NULL, 'Rho related BTB domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(107195, NULL, 'G3DSA:3.40.109.10:FF:000029', NULL, NULL, 'Molybdopterin biosynthesis protein MoeY', NULL, NULL, NULL, NULL, NULL, 4),
(107196, NULL, 'G3DSA:3.30.40.10:FF:001362', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107197, NULL, 'G3DSA:3.40.50.300:FF:005112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107198, NULL, 'G3DSA:3.40.640.10:FF:000511', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107199, NULL, 'G3DSA:3.60.21.10:FF:000198', NULL, NULL, 'Serine/threonine-protein phosphatase 2B catalytic subunit alpha isoform', NULL, NULL, NULL, NULL, NULL, 4),
(107200, NULL, 'G3DSA:3.40.50.1780:FF:000018', NULL, NULL, 'Iron-containing hydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107201, NULL, 'G3DSA:2.130.10.10:FF:006017', NULL, NULL, 'Probable U3 small nucleolar RNA-associated protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(107202, NULL, 'G3DSA:1.25.40.10:FF:001929', NULL, NULL, 'Cyc8p', NULL, NULL, NULL, NULL, NULL, 4),
(107203, NULL, 'G3DSA:1.10.10.10:FF:000308', NULL, NULL, 'DEP domain-containing mTOR-interacting protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(107204, NULL, 'G3DSA:2.70.98.110:FF:000001', NULL, NULL, 'Mannosyl-oligosaccharide glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(107205, NULL, 'G3DSA:3.40.50.300:FF:006096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107206, NULL, 'G3DSA:1.10.510.10:FF:000870', NULL, NULL, 'OSJNBa0016N04.16-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(107207, NULL, 'G3DSA:2.60.40.10:FF:000216', NULL, NULL, 'neogenin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(107208, NULL, 'G3DSA:2.30.30.40:FF:000624', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107209, NULL, 'G3DSA:3.30.30.170:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107210, NULL, 'G3DSA:3.90.1150.10:FF:000012', NULL, NULL, 'Glutamate-1-semialdehyde 2,1-aminomutase', NULL, NULL, NULL, NULL, NULL, 4),
(107211, NULL, 'G3DSA:3.40.50.300:FF:004488', NULL, NULL, 'ATP-dependent DEAD/H RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107212, NULL, 'G3DSA:3.40.50.1820:FF:001609', NULL, NULL, 'Os01g0315700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(107213, NULL, 'G3DSA:1.20.58.390:FF:000272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107214, NULL, 'G3DSA:2.60.40.790:FF:000052', NULL, NULL, 'ArsA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(107215, NULL, 'G3DSA:1.10.238.10:FF:000618', NULL, NULL, 'EF-hand calcium-binding domain-containing protein 6-like', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(107216, NULL, 'G3DSA:3.40.640.10:FF:000202', NULL, NULL, 'Probable aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(107217, NULL, 'G3DSA:2.30.42.10:FF:000036', NULL, NULL, 'Erbin isoform 7', NULL, NULL, NULL, NULL, NULL, 4),
(107218, NULL, 'G3DSA:3.50.30.30:FF:000175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107219, NULL, 'G3DSA:2.130.10.10:FF:003746', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107220, NULL, 'G3DSA:1.10.150.240:FF:000133', NULL, NULL, 'Glycosyl hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107221, NULL, 'G3DSA:1.10.510.10:FF:000218', NULL, NULL, 'Death-associated protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(107222, NULL, 'G3DSA:3.40.50.300:FF:006523', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(107223, NULL, 'G3DSA:1.10.1520.10:FF:000089', NULL, NULL, 'Endoribonuclease Dicer-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(107224, NULL, 'G3DSA:1.10.10.10:FF:002091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107225, NULL, 'G3DSA:2.60.40.10:FF:000744', NULL, NULL, 'Leucine rich repeat, Ig-like and transmembrane domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(107226, NULL, 'G3DSA:1.10.533.10:FF:000108', NULL, NULL, 'THO complex 1', NULL, NULL, NULL, NULL, NULL, 4),
(107227, NULL, 'G3DSA:3.30.1370.10:FF:000014', NULL, NULL, 'KRR1 small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4),
(107228, NULL, 'G3DSA:3.30.70.370:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107229, NULL, 'G3DSA:2.130.10.10:FF:000183', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1', NULL, NULL, NULL, NULL, NULL, 4),
(107230, NULL, 'G3DSA:3.40.50.300:FF:000582', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(107231, NULL, 'G3DSA:3.30.470.160:FF:000006', NULL, NULL, 'Kinase', NULL, NULL, NULL, NULL, NULL, 4),
(107232, NULL, 'G3DSA:3.40.50.10860:FF:000072', NULL, NULL, 'Methylenetetrahydrofolate dehydrogenase (NADP+-dependent) 1b', NULL, NULL, NULL, NULL, NULL, 4),
(107233, NULL, 'G3DSA:1.20.1070.10:FF:001760', NULL, NULL, 'Zg13', NULL, NULL, NULL, NULL, NULL, 4),
(107234, NULL, 'G3DSA:2.10.25.10:FF:001088', NULL, NULL, 'Si:ch211-241f5.3', NULL, NULL, NULL, NULL, NULL, 4),
(107235, NULL, 'G3DSA:2.60.200.20:FF:000071', NULL, NULL, 'AGAP004588-PA', NULL, NULL, NULL, NULL, NULL, 4),
(107236, NULL, 'G3DSA:3.40.50.12440:FF:000006', NULL, NULL, 'Nitrate reductase alpha subunit (NarG)', NULL, NULL, NULL, NULL, NULL, 4),
(107237, NULL, 'G3DSA:2.40.50.140:FF:000037', NULL, NULL, '26S protease regulatory subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(107238, NULL, 'G3DSA:3.90.1410.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107239, NULL, 'G3DSA:3.40.50.2000:FF:000118', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(107240, NULL, 'G3DSA:1.25.40.10:FF:003863', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107241, NULL, 'G3DSA:3.30.160.60:FF:004027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107242, NULL, 'G3DSA:2.130.10.10:FF:000413', NULL, NULL, 'elongator complex protein 2 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(107243, NULL, 'G3DSA:3.20.20.70:FF:000676', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107244, NULL, 'G3DSA:3.30.60.20:FF:000163', NULL, NULL, 'Serine/threonine protein kinase BRAF', NULL, NULL, NULL, NULL, NULL, 4),
(107245, NULL, 'G3DSA:1.20.140.100:FF:000008', NULL, NULL, 'Dynein heavy chain domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(107246, NULL, 'G3DSA:3.40.50.720:FF:001770', NULL, NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(107247, NULL, 'G3DSA:1.20.58.60:FF:000062', NULL, NULL, 'Short stop, isoform K', NULL, NULL, NULL, NULL, NULL, 4),
(107248, NULL, 'G3DSA:1.25.40.10:FF:004352', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(107249, NULL, 'G3DSA:3.90.260.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(107250, NULL, 'G3DSA:3.40.140.10:FF:000029', NULL, NULL, 'DNA dC->dU-editing enzyme APOBEC-3G', NULL, NULL, NULL, NULL, NULL, 4),
(107251, NULL, 'G3DSA:1.10.760.10:FF:000113', NULL, NULL, 'Methylamine utilization protein MauG, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107252, NULL, 'G3DSA:3.40.630.60:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107253, NULL, 'G3DSA:2.30.110.10:FF:000039', NULL, NULL, 'Deazaflavin-dependent nitroreductase', NULL, NULL, NULL, NULL, NULL, 4),
(107254, NULL, 'G3DSA:3.30.60.30:FF:000166', NULL, NULL, 'LOC557557 protein', NULL, NULL, NULL, NULL, NULL, 4),
(107255, NULL, 'G3DSA:1.10.3720.10:FF:000054', NULL, NULL, 'Molybdenum transport system permease', NULL, NULL, NULL, NULL, NULL, 4),
(107256, NULL, 'G3DSA:2.40.70.10:FF:000426', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107257, NULL, 'G3DSA:3.40.50.720:FF:000140', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] reductase', NULL, NULL, NULL, NULL, NULL, 4),
(107258, NULL, 'G3DSA:3.30.420.40:FF:000225', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(107259, NULL, 'G3DSA:3.10.290.10:FF:000058', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(107260, NULL, 'G3DSA:3.80.10.10:FF:001425', NULL, NULL, 'Protein windpipe', NULL, NULL, NULL, NULL, NULL, 4),
(107261, NULL, 'G3DSA:3.40.1230.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107262, NULL, 'G3DSA:1.20.58.80:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107263, NULL, 'G3DSA:3.40.50.1240:FF:000194', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107264, NULL, 'G3DSA:1.10.510.10:FF:000746', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(107265, NULL, 'G3DSA:2.30.30.30:FF:000144', NULL, NULL, '60S ribosomal protein L26-1', NULL, NULL, NULL, NULL, NULL, 4),
(107266, NULL, 'G3DSA:4.10.60.10:FF:000147', NULL, NULL, 'Rts protein', NULL, NULL, NULL, NULL, NULL, 4),
(107267, NULL, 'G3DSA:1.10.10.60:FF:000391', NULL, NULL, 'Homeobox transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(107268, NULL, 'G3DSA:3.40.30.10:FF:000467', NULL, NULL, '2-hydroxychromene-2-carboxylate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(107269, NULL, 'G3DSA:2.130.10.10:FF:000722', NULL, NULL, 'TBC1 domain family member 31', NULL, NULL, NULL, NULL, NULL, 4),
(107270, NULL, 'G3DSA:2.40.300.10:FF:000001', NULL, NULL, 'Head decoration protein D', NULL, NULL, NULL, NULL, NULL, 4),
(107271, NULL, 'G3DSA:2.40.30.10:FF:000087', NULL, NULL, 'Hybrid-cluster NAD(P)-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(107272, NULL, 'G3DSA:1.10.238.10:FF:000265', NULL, NULL, 'calcium-binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(107273, NULL, 'G3DSA:3.30.160.60:FF:000654', NULL, NULL, 'PR/SET domain 6', NULL, NULL, NULL, NULL, NULL, 4),
(107274, NULL, 'G3DSA:1.20.58.70:FF:000065', NULL, NULL, 'Syntaxin 1A', NULL, NULL, NULL, NULL, NULL, 4),
(107275, NULL, 'G3DSA:1.10.533.10:FF:000097', NULL, NULL, 'Death effector domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(107276, NULL, 'G3DSA:3.40.50.300:FF:006214', NULL, NULL, 'GTP-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(107277, NULL, 'G3DSA:3.40.50.300:FF:002364', NULL, NULL, 'DNA repair protein RadA', NULL, NULL, NULL, NULL, NULL, 4),
(107278, NULL, 'G3DSA:1.10.10.10:FF:001938', NULL, NULL, 'CG3509 protein', NULL, NULL, NULL, NULL, NULL, 4),
(107279, NULL, 'G3DSA:1.20.1050.10:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107280, NULL, 'G3DSA:1.10.510.10:FF:000067', NULL, NULL, 'calcium-dependent protein kinase 13', NULL, NULL, NULL, NULL, NULL, 4),
(107281, NULL, 'G3DSA:3.30.70.1170:FF:000018', NULL, NULL, 'RNA Methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(107282, NULL, 'G3DSA:2.120.10.80:FF:000136', NULL, NULL, 'Kelch domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(107283, NULL, 'G3DSA:1.10.510.10:FF:000437', NULL, NULL, 'Pseudopodium enriched atypical kinase 1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(107284, NULL, 'G3DSA:3.40.50.1000:FF:000408', NULL, NULL, 'Trehalose-6-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(107285, NULL, 'G3DSA:3.30.200.20:FF:000371', NULL, NULL, 'Protein NSP-INTERACTING KINASE 2', NULL, NULL, NULL, NULL, NULL, 4),
(107286, NULL, 'G3DSA:1.10.150.20:FF:000311', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107287, NULL, 'G3DSA:3.40.190.120:FF:000001', NULL, NULL, 'Amine ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(107288, NULL, 'G3DSA:1.10.530.10:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107289, NULL, 'G3DSA:2.40.100.10:FF:000036', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(107290, NULL, 'G3DSA:2.130.10.120:FF:000024', NULL, NULL, 'Oligopeptidase B PtrB', NULL, NULL, NULL, NULL, NULL, 4),
(107291, NULL, 'G3DSA:2.130.10.10:FF:003965', NULL, NULL, 'Autophagy-related protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(107292, NULL, 'G3DSA:3.40.50.300:FF:004269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107293, NULL, 'G3DSA:1.20.120.980:FF:000004', NULL, NULL, 'Thymus-specific serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(107294, NULL, 'G3DSA:1.10.287.690:FF:000014', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(107295, NULL, 'G3DSA:2.60.40.200:FF:000038', NULL, NULL, 'Probable copper chaperone for superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(107296, NULL, 'G3DSA:1.10.418.10:FF:000032', NULL, NULL, 'utrophin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(107297, NULL, 'G3DSA:3.90.79.10:FF:000043', NULL, NULL, '7,8-dihydro-8-oxoguanine triphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(107298, NULL, 'G3DSA:2.60.120.1440:FF:000014', NULL, NULL, 'Fec operon regulator FecR', NULL, NULL, NULL, NULL, NULL, 4),
(107299, NULL, 'G3DSA:2.130.10.110:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107300, NULL, 'G3DSA:1.10.10.60:FF:000402', NULL, NULL, 'Transcription factor MYB113', NULL, NULL, NULL, NULL, NULL, 4),
(107301, NULL, 'G3DSA:3.30.200.20:FF:001782', NULL, NULL, 'Disease resistance protein Cf-2.1-like', NULL, NULL, NULL, NULL, NULL, 4),
(107302, NULL, 'G3DSA:2.40.70.10:FF:000207', NULL, NULL, 'Acid protease', NULL, NULL, NULL, NULL, NULL, 4),
(107303, NULL, 'G3DSA:3.90.740.10:FF:000007', NULL, NULL, 'Valine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(107304, NULL, 'G3DSA:3.30.160.60:FF:001020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107305, NULL, 'G3DSA:1.10.287.1770:FF:000002', NULL, NULL, 'Ferrous iron transport protein B', NULL, NULL, NULL, NULL, NULL, 4),
(107306, NULL, 'G3DSA:2.130.10.10:FF:004454', NULL, NULL, 'Sterol regulatory element-binding protein cleavage-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(107307, NULL, 'G3DSA:3.90.226.10:FF:000144', NULL, NULL, 'GH11143p', NULL, NULL, NULL, NULL, NULL, 4),
(107308, NULL, 'G3DSA:1.10.510.10:FF:004119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107309, NULL, 'G3DSA:3.10.129.10:FF:000251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107310, NULL, 'G3DSA:3.40.50.2300:FF:001653', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107311, NULL, 'G3DSA:3.40.50.1980:FF:000106', NULL, NULL, 'Iron(III) ABC transporter, solute-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(107312, NULL, 'G3DSA:2.60.120.330:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107313, NULL, 'G3DSA:1.10.510.10:FF:001848', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107314, NULL, 'G3DSA:2.60.40.60:FF:001006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107315, NULL, 'G3DSA:3.40.50.720:FF:001298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107316, NULL, 'G3DSA:1.50.10.140:FF:000003', NULL, NULL, 'Cyclic beta-1,2-glucan synthase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(107317, NULL, 'G3DSA:3.20.20.80:FF:000679', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107318, NULL, 'G3DSA:3.40.50.150:FF:000520', NULL, NULL, 'tRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(107319, NULL, 'G3DSA:2.60.40.1120:FF:000064', NULL, NULL, 'AGAP002414-PA', NULL, NULL, NULL, NULL, NULL, 4),
(107320, NULL, 'G3DSA:1.20.144.10:FF:000016', NULL, NULL, 'Phospholipid phosphatase 2', NULL, NULL, NULL, NULL, NULL, 4),
(107321, NULL, 'G3DSA:3.40.1090.10:FF:000024', NULL, NULL, 'Lysophospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(107322, NULL, 'G3DSA:4.10.60.10:FF:000271', NULL, NULL, 'mRNA 3''-end-processing protein YTH1', NULL, NULL, NULL, NULL, NULL, 4),
(107323, NULL, 'G3DSA:1.10.565.10:FF:000098', NULL, NULL, 'Protein CBR-UNC-55, isoform a', NULL, NULL, NULL, NULL, NULL, 4),
(107324, NULL, 'G3DSA:3.30.9.10:FF:000199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107325, NULL, 'G3DSA:1.10.10.10:FF:000527', NULL, NULL, 'Vacuolar protein sorting protein (Vps36), putative', NULL, NULL, NULL, NULL, NULL, 4),
(107326, NULL, 'G3DSA:2.60.120.620:FF:000156', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(107327, NULL, 'G3DSA:2.60.40.10:FF:000435', NULL, NULL, 'Down syndrome cell adhesion molecule, isoform J', NULL, NULL, NULL, NULL, NULL, 4),
(107328, NULL, 'G3DSA:3.10.130.10:FF:000007', NULL, NULL, 'Inactive ribonuclease-like protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(107329, NULL, 'G3DSA:1.10.30.10:FF:000164', NULL, NULL, 'Maelstrom', NULL, NULL, NULL, NULL, NULL, 4),
(107330, NULL, 'G3DSA:3.40.50.620:FF:000110', NULL, NULL, 'Deoxyribodipyrimidine photolyase', NULL, NULL, NULL, NULL, NULL, 4),
(107331, NULL, 'G3DSA:1.10.8.270:FF:000154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107332, NULL, 'G3DSA:3.40.50.720:FF:001309', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(107333, NULL, 'G3DSA:3.30.160.60:FF:004706', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107334, NULL, 'G3DSA:2.10.25.10:FF:001560', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(107335, NULL, 'G3DSA:1.10.287.380:FF:000011', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(107336, NULL, 'G3DSA:1.20.58.530:FF:000016', NULL, NULL, 'Unconventional myosin-XVI', NULL, NULL, NULL, NULL, NULL, 4),
(107337, NULL, 'G3DSA:2.60.120.200:FF:000120', NULL, NULL, 'Axotactin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(107338, NULL, 'G3DSA:3.20.20.70:FF:000367', NULL, NULL, '2-isopropylmalate synthase, truncation', NULL, NULL, NULL, NULL, NULL, 4),
(107339, NULL, 'G3DSA:3.30.70.20:FF:000102', NULL, NULL, 'Formate dehydrogenase 2 subunit beta (cytochrome c-553)', NULL, NULL, NULL, NULL, NULL, 4),
(107340, NULL, 'G3DSA:3.50.4.10:FF:000031', NULL, NULL, 'NOmpA Homolog (Drosophila nompA: no mechanoreceptor potential A)', NULL, NULL, NULL, NULL, NULL, 4),
(107341, NULL, 'G3DSA:3.40.50.11040:FF:000008', NULL, NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', NULL, NULL, NULL, NULL, NULL, 4),
(107342, NULL, 'G3DSA:2.130.10.10:FF:000727', NULL, NULL, 'NACHT and WD repeat domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(107343, NULL, 'G3DSA:2.40.50.140:FF:000127', NULL, NULL, 'Exosome complex component RRP40', NULL, NULL, NULL, NULL, NULL, 4),
(107344, NULL, 'G3DSA:3.40.109.10:FF:000013', NULL, NULL, '5,6-dimethylbenzimidazole synthase', NULL, NULL, NULL, NULL, NULL, 4),
(107345, NULL, 'G3DSA:3.40.50.720:FF:001444', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(107346, NULL, 'G3DSA:1.25.40.10:FF:003953', NULL, NULL, 'Telomere elongation protein est1', NULL, NULL, NULL, NULL, NULL, 4),
(107347, NULL, 'G3DSA:2.120.10.80:FF:000119', NULL, NULL, 'Kelch-like 25', NULL, NULL, NULL, NULL, NULL, 4),
(107348, NULL, 'G3DSA:3.40.50.300:FF:001060', NULL, NULL, 'ATP-dependent RNA helicase RhlE', NULL, NULL, NULL, NULL, NULL, 4),
(107349, NULL, 'G3DSA:3.40.50.1780:FF:000013', NULL, NULL, 'Iron-sulfur cluster assembly associated protein Nar1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(107350, NULL, 'G3DSA:3.40.50.300:FF:006433', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107351, NULL, 'G3DSA:3.30.200.20:FF:002164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107352, NULL, 'G3DSA:1.20.1050.10:FF:000016', NULL, NULL, 'Glutathione S-transferase U9', NULL, NULL, NULL, NULL, NULL, 4),
(107353, NULL, 'G3DSA:1.10.10.10:FF:000617', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit K', NULL, NULL, NULL, NULL, NULL, 4),
(107354, NULL, 'G3DSA:1.10.1370.10:FF:000003', NULL, NULL, 'Mitochondrial intermediate peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(107355, NULL, 'G3DSA:3.30.70.1230:FF:000177', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(107356, NULL, 'G3DSA:3.10.330.20:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107357, NULL, 'G3DSA:1.10.1370.30:FF:000009', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(107358, NULL, 'G3DSA:3.40.50.300:FF:000256', NULL, NULL, 'Guanine nucleotide-binding protein G(t) subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(107359, NULL, 'G3DSA:3.40.50.11020:FF:000002', NULL, NULL, 'ORF1a polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(107360, NULL, 'G3DSA:2.60.40.290:FF:000008', NULL, NULL, 'Endo-1,4-beta-xylanase B', NULL, NULL, NULL, NULL, NULL, 4),
(107361, NULL, 'G3DSA:2.40.30.10:FF:000396', NULL, NULL, 'Mitochondrial tRNA-specific 2-thiouridylase 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(107362, NULL, 'G3DSA:2.60.40.820:FF:000010', NULL, NULL, 'T-box transcription factor TBX6', NULL, NULL, NULL, NULL, NULL, 4),
(107363, NULL, 'G3DSA:3.40.50.11030:FF:000005', NULL, NULL, 'Threonylcarbamoyl-AMP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(107364, NULL, 'G3DSA:3.30.160.60:FF:000963', NULL, NULL, 'zinc finger protein 546', NULL, NULL, NULL, NULL, NULL, 4),
(107365, NULL, 'G3DSA:3.40.1500.10:FF:000006', NULL, NULL, 'Coproporphyrinogen III oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(107366, NULL, 'G3DSA:1.10.630.10:FF:000486', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107367, NULL, 'G3DSA:2.130.10.10:FF:002291', NULL, NULL, 'At5g11240', NULL, NULL, NULL, NULL, NULL, 4),
(107368, NULL, 'G3DSA:3.40.50.720:FF:001096', NULL, NULL, 'Putative ubiquitin activating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(107369, NULL, 'G3DSA:2.170.270.10:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107370, NULL, 'G3DSA:3.30.830.10:FF:000258', NULL, NULL, 'Uncharacterized protein T8H10.60', NULL, NULL, NULL, NULL, NULL, 4),
(107371, NULL, 'G3DSA:3.40.50.300:FF:000902', NULL, NULL, 'Peptide chain release factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(107372, NULL, 'G3DSA:3.30.870.10:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107373, NULL, 'G3DSA:1.25.40.20:FF:000954', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107374, NULL, 'G3DSA:2.60.120.260:FF:000216', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(107375, NULL, 'G3DSA:3.40.50.1820:FF:001582', NULL, NULL, 'Alpha/beta-Hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(107376, NULL, 'G3DSA:2.160.10.10:FF:000125', NULL, NULL, 'Serine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(107377, NULL, 'G3DSA:3.10.450.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107378, NULL, 'G3DSA:2.130.10.10:FF:006034', NULL, NULL, 'Centriole proteome protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(107379, NULL, 'G3DSA:2.60.40.10:FF:004460', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107380, NULL, 'G3DSA:1.25.40.1010:FF:000002', NULL, NULL, 'N-terminal acetyltransferase catalytic subunit (NAT1)', NULL, NULL, NULL, NULL, NULL, 4),
(107381, NULL, 'G3DSA:3.20.20.80:FF:000696', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107382, NULL, 'G3DSA:1.10.472.10:FF:000325', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(107383, NULL, 'G3DSA:2.60.40.10:FF:000418', NULL, NULL, 'Neural cell adhesion molecule L1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(107384, NULL, 'G3DSA:1.20.1050.20:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107385, NULL, 'G3DSA:3.30.160.60:FF:006028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107386, NULL, 'G3DSA:2.130.10.130:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107387, NULL, 'G3DSA:1.10.455.10:FF:000016', NULL, NULL, '30S ribosomal protein S7', NULL, NULL, NULL, NULL, NULL, 4),
(107388, NULL, 'G3DSA:1.10.3720.10:FF:000200', NULL, NULL, 'ABC transporter permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(107389, NULL, 'G3DSA:3.30.160.60:FF:006270', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107390, NULL, 'G3DSA:3.30.70.1230:FF:000284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107391, NULL, 'G3DSA:1.25.10.10:FF:002731', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107392, NULL, 'G3DSA:1.50.40.10:FF:000472', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107393, NULL, 'G3DSA:3.30.70.890:FF:000085', NULL, NULL, 'Diphosphomevalonate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(107394, NULL, 'G3DSA:2.60.120.1040:FF:000001', NULL, NULL, 'Zinc finger protein ZPR1', NULL, NULL, NULL, NULL, NULL, 4),
(107395, NULL, 'G3DSA:3.90.79.10:FF:000015', NULL, NULL, 'Nudix hydrolase 8', NULL, NULL, NULL, NULL, NULL, 4),
(107396, NULL, 'G3DSA:1.20.140.30:FF:000002', NULL, NULL, 'MOB-like protein phocein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(107397, NULL, 'G3DSA:2.70.150.10:FF:000061', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(107398, NULL, 'G3DSA:3.40.50.300:FF:004179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107399, NULL, 'G3DSA:1.20.1530.20:FF:000062', NULL, NULL, 'Sodium-dependent transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(107400, NULL, 'G3DSA:3.40.30.10:FF:000793', NULL, NULL, 'Gcy-33', NULL, NULL, NULL, NULL, NULL, 4),
(107401, NULL, 'G3DSA:1.10.3730.20:FF:000029', NULL, NULL, 'EamA/RhaT family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(107402, NULL, 'G3DSA:2.60.40.1180:FF:000161', NULL, NULL, 'Alpha amylase catalytic region', NULL, NULL, NULL, NULL, NULL, 4),
(107403, NULL, 'G3DSA:3.30.420.40:FF:000118', NULL, NULL, 'Xylulose kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(107404, NULL, 'G3DSA:1.20.120.1760:FF:000043', NULL, NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(107405, NULL, 'G3DSA:1.25.40.10:FF:000081', NULL, NULL, 'squamous cell carcinoma antigen recognized by T-cells 3', NULL, NULL, NULL, NULL, NULL, 4),
(107406, NULL, 'G3DSA:3.90.1410.10:FF:000055', NULL, NULL, 'Cytoplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(107407, NULL, 'G3DSA:1.20.1250.20:FF:001861', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107408, NULL, 'G3DSA:3.30.160.60:FF:006163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107409, NULL, 'G3DSA:2.60.120.330:FF:000069', NULL, NULL, 'Probable ethylene-forming enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(107410, NULL, 'G3DSA:1.10.510.10:FF:002652', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107411, NULL, 'G3DSA:3.30.870.10:FF:000042', NULL, NULL, 'Cardiolipin synthetase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(107412, NULL, 'G3DSA:1.20.140.50:FF:000008', NULL, NULL, 'Hydroxyproline-rich glycoprotein family protein', NULL, NULL, NULL, NULL, NULL, 4),
(107413, NULL, 'G3DSA:3.30.420.40:FF:000444', NULL, NULL, 'Possible d-xylulose kinase xylB', NULL, NULL, NULL, NULL, NULL, 4),
(107414, NULL, 'G3DSA:2.130.10.10:FF:004128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107415, NULL, 'G3DSA:1.10.533.10:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107416, NULL, 'G3DSA:3.20.20.70:FF:000693', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(107417, NULL, 'G3DSA:3.10.600.10:FF:000010', NULL, NULL, 'Pyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(107418, NULL, 'G3DSA:2.60.40.10:FF:004257', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107419, NULL, 'G3DSA:2.10.25.10:FF:001234', NULL, NULL, 'Mucin-13', NULL, NULL, NULL, NULL, NULL, 4),
(107420, NULL, 'G3DSA:3.40.50.1000:FF:000392', NULL, NULL, 'NLI interacting factor family phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(107421, NULL, 'G3DSA:3.40.50.300:FF:002055', NULL, NULL, 'ATP-binding cassette protein subfamily C, member 1', NULL, NULL, NULL, NULL, NULL, 4),
(107422, NULL, 'G3DSA:3.40.50.1240:FF:000205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107423, NULL, 'G3DSA:3.30.70.20:FF:000118', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107424, NULL, 'G3DSA:2.20.70.10:FF:000034', NULL, NULL, 'syntaxin-binding protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(107425, NULL, 'G3DSA:3.20.20.105:FF:000009', NULL, NULL, 'Queuine tRNA-ribosyltransferase accessory subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(107426, NULL, 'G3DSA:3.30.450.20:FF:000659', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(107427, NULL, 'G3DSA:2.30.29.30:FF:000062', NULL, NULL, 'growth factor receptor-bound protein 10 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(107428, NULL, 'G3DSA:3.30.420.40:FF:000921', NULL, NULL, 'Centractin', NULL, NULL, NULL, NULL, NULL, 4),
(107429, NULL, 'G3DSA:3.30.160.60:FF:002762', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107430, NULL, 'G3DSA:1.10.287.40:FF:000027', NULL, NULL, 'Seryl-tRNA synthetase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(107431, NULL, 'G3DSA:2.60.40.10:FF:005887', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107432, NULL, 'G3DSA:3.80.10.10:FF:003218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107433, NULL, 'G3DSA:1.10.287.110:FF:000099', NULL, NULL, 'Chaperone protein DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(107434, NULL, 'G3DSA:1.10.630.10:FF:000828', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107435, NULL, 'G3DSA:1.10.10.60:FF:000155', NULL, NULL, 'ISWI chromatin-remodeling complex ATPase CHR11', NULL, NULL, NULL, NULL, NULL, 4),
(107436, NULL, 'G3DSA:3.40.50.1000:FF:000734', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107437, NULL, 'G3DSA:1.20.1310.10:FF:000200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107438, NULL, 'G3DSA:3.40.50.150:FF:000059', NULL, NULL, 'spermine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(107439, NULL, 'G3DSA:3.30.1460.50:FF:000022', NULL, NULL, 'AuTophaGy (Yeast Atg homolog)', NULL, NULL, NULL, NULL, NULL, 4),
(107440, NULL, 'G3DSA:1.10.472.80:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107441, NULL, 'G3DSA:1.20.140.40:FF:000005', NULL, NULL, 'Pectin methylesterase inhibitor 1', NULL, NULL, NULL, NULL, NULL, 4),
(107442, NULL, 'G3DSA:1.10.3460.10:FF:000016', NULL, NULL, 'Fucoxanthin chlorophyll a/c light-harvesting protein, lhcr type', NULL, NULL, NULL, NULL, NULL, 4),
(107443, NULL, 'G3DSA:1.10.10.10:FF:001000', NULL, NULL, 'Histone H1', NULL, NULL, NULL, NULL, NULL, 4),
(107444, NULL, 'G3DSA:2.60.120.10:FF:000696', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107445, NULL, 'G3DSA:3.30.200.20:FF:001456', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(107446, NULL, 'G3DSA:1.20.1440.340:FF:000004', NULL, NULL, 'Galactokinase', NULL, NULL, NULL, NULL, NULL, 4),
(107447, NULL, 'G3DSA:2.130.10.10:FF:001829', NULL, NULL, 'WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(107448, NULL, 'G3DSA:3.30.420.110:FF:000077', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(107449, NULL, 'G3DSA:1.25.40.20:FF:000084', NULL, NULL, 'Arf-GAP with GTPase, ANK repeat and PH domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(107450, NULL, 'G3DSA:3.60.21.10:FF:000344', NULL, NULL, 'Protein CBG21670', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(107451, NULL, 'G3DSA:2.60.40.1180:FF:000144', NULL, NULL, 'Alpha-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(107452, NULL, 'G3DSA:2.160.20.10:FF:000070', NULL, NULL, 'PKHD1 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(107453, NULL, 'G3DSA:3.30.160.60:FF:006472', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107454, NULL, 'G3DSA:1.10.287.3810:FF:000002', NULL, NULL, 'Tryptophan 2,3-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(107455, NULL, 'G3DSA:3.90.740.10:FF:000002', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(107456, NULL, 'G3DSA:3.40.50.1000:FF:000173', NULL, NULL, 'Membrane-associated phosphatidylinositol transfer protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(107457, NULL, 'G3DSA:1.10.3730.10:FF:000009', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(107458, NULL, 'G3DSA:2.40.160.210:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107459, NULL, 'G3DSA:1.10.8.60:FF:000098', NULL, NULL, 'Sigma-54-dependent transcriptional regulator YgeV', NULL, NULL, NULL, NULL, NULL, 4),
(107460, NULL, 'G3DSA:1.20.1530.20:FF:000045', NULL, NULL, 'Solute carrier family 10 member 4', NULL, NULL, NULL, NULL, NULL, 4),
(107461, NULL, 'G3DSA:1.20.1110.10:FF:000089', NULL, NULL, 'Sodium/potassium-transporting ATPase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(107462, NULL, 'G3DSA:2.130.10.10:FF:004089', NULL, NULL, 'WD repeat domain 93', NULL, NULL, NULL, NULL, NULL, 4),
(107463, NULL, 'G3DSA:1.20.58.80:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107464, NULL, 'G3DSA:3.30.1360.120:FF:000058', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(107465, NULL, 'G3DSA:1.10.1070.11:FF:000072', NULL, NULL, 'Phosphatidylinositol kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107466, NULL, 'G3DSA:2.40.100.10:FF:000019', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(107467, NULL, 'G3DSA:2.70.98.10:FF:000039', NULL, NULL, 'Alpha-1,2-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(107468, NULL, 'G3DSA:2.120.10.80:FF:000029', NULL, NULL, 'Kelch-like family member 17', NULL, NULL, NULL, NULL, NULL, 4),
(107469, NULL, 'G3DSA:3.40.50.150:FF:001211', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107470, NULL, 'G3DSA:3.10.20.90:FF:000750', NULL, NULL, 'Sorting nexin-17', NULL, NULL, NULL, NULL, NULL, 4),
(107471, NULL, 'G3DSA:3.40.50.1010:FF:000176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107472, NULL, 'G3DSA:2.70.170.10:FF:000253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107473, NULL, 'G3DSA:3.40.50.2300:FF:001327', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107474, NULL, 'G3DSA:3.70.10.10:FF:000094', NULL, NULL, 'Putative dna repair protein rad9 protein', NULL, NULL, NULL, NULL, NULL, 4),
(107475, NULL, 'G3DSA:1.25.10.10:FF:002254', NULL, NULL, 'Protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107476, NULL, 'G3DSA:1.10.472.10:FF:000634', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107477, NULL, 'G3DSA:3.30.200.20:FF:001765', NULL, NULL, 'Dual-specificity tyrosine-(Y)-phosphorylation-regulated kinase 1A, a', NULL, NULL, NULL, NULL, NULL, 4),
(107478, NULL, 'G3DSA:3.40.50.2300:FF:001636', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107479, NULL, 'G3DSA:2.130.10.10:FF:004437', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107480, NULL, 'G3DSA:2.130.10.10:FF:002330', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit WDR4', NULL, NULL, NULL, NULL, NULL, 4),
(107481, NULL, 'G3DSA:3.30.420.40:FF:000360', NULL, NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(107482, NULL, 'G3DSA:3.40.50.300:FF:006107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107483, NULL, 'G3DSA:2.80.10.50:FF:000169', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(107484, NULL, 'G3DSA:1.20.58.340:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107485, NULL, 'G3DSA:3.40.1090.10:FF:000041', NULL, NULL, 'Lysophospholipase NTE1', NULL, NULL, NULL, NULL, NULL, 4),
(107486, NULL, 'G3DSA:3.30.70.330:FF:000142', NULL, NULL, 'splicing regulatory glutamine/lysine-rich protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(107487, NULL, 'G3DSA:2.60.40.10:FF:002543', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107488, NULL, 'G3DSA:3.30.1460.50:FF:000005', NULL, NULL, 'Ubiquitin-like-conjugating enzyme ATG10', NULL, NULL, NULL, NULL, NULL, 4),
(107489, NULL, 'G3DSA:1.10.3120.10:FF:000002', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(107490, NULL, 'G3DSA:1.20.58.530:FF:000033', NULL, NULL, 'Chitin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(107491, NULL, 'G3DSA:1.20.120.1750:FF:000040', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(107492, NULL, 'G3DSA:1.25.40.10:FF:004133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107493, NULL, 'G3DSA:1.10.30.10:FF:000181', NULL, NULL, 'High mobility group box 2', NULL, NULL, NULL, NULL, NULL, 4),
(107494, NULL, 'G3DSA:1.10.150.240:FF:000116', NULL, NULL, 'Glycosyl hydrolase family 65 central catalytic domain/Haloacid dehalogenase-like hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107495, NULL, 'G3DSA:1.50.40.10:FF:000556', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107496, NULL, 'G3DSA:3.50.4.10:FF:000014', NULL, NULL, 'NOmpA Homolog (Drosophila nompA: no mechanoreceptor potential A)', NULL, NULL, NULL, NULL, NULL, 4),
(107497, NULL, 'G3DSA:1.10.10.10:FF:000634', NULL, NULL, 'HTH-type transcriptional regulator MmpR5', NULL, NULL, NULL, NULL, NULL, 4),
(107498, NULL, 'G3DSA:3.40.50.300:FF:006742', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107499, NULL, 'G3DSA:2.40.70.10:FF:000410', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107500, NULL, 'G3DSA:2.10.25.10:FF:001762', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107501, NULL, 'G3DSA:1.10.10.60:FF:000716', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107502, NULL, 'G3DSA:3.40.50.1240:FF:000087', NULL, NULL, 'Putative acid phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(107503, NULL, 'G3DSA:1.25.40.550:FF:000007', NULL, NULL, 'WGS project CABT00000000 data, contig 2.18', NULL, NULL, NULL, NULL, NULL, 4),
(107504, NULL, 'G3DSA:2.40.10.10:FF:000108', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(107505, NULL, 'G3DSA:1.20.1280.290:FF:000002', NULL, NULL, 'Bidirectional sugar transporter SWEET', NULL, NULL, NULL, NULL, NULL, 4),
(107506, NULL, 'G3DSA:1.10.10.10:FF:000292', NULL, NULL, 'O-methyltransferase ZRP4', NULL, NULL, NULL, NULL, NULL, 4),
(107507, NULL, 'G3DSA:2.60.120.10:FF:000477', NULL, NULL, 'Cupin-like domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(107508, NULL, 'G3DSA:3.50.7.10:FF:000037', NULL, NULL, 'Putative phosphatidylinositol (3,5) kinase', NULL, NULL, NULL, NULL, NULL, 4),
(107509, NULL, 'G3DSA:2.130.10.10:FF:000076', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(107510, NULL, 'G3DSA:3.30.230.70:FF:000157', NULL, NULL, 'EXOSome (Multiexonuclease complex) component', NULL, NULL, NULL, NULL, NULL, 4),
(107511, NULL, 'G3DSA:3.60.15.10:FF:000150', NULL, NULL, 'Glyoxalase II', NULL, NULL, NULL, NULL, NULL, 4),
(107512, NULL, 'G3DSA:1.10.510.10:FF:002017', NULL, NULL, 'Protein CBG18064', NULL, NULL, NULL, NULL, NULL, 4),
(107513, NULL, 'G3DSA:1.10.10.10:FF:002096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107514, NULL, 'G3DSA:2.170.270.10:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107515, NULL, 'G3DSA:1.25.40.10:FF:001699', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(107516, NULL, 'G3DSA:1.25.50.20:FF:000039', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(107517, NULL, 'G3DSA:3.40.50.720:FF:001753', NULL, NULL, 'Lovastatin nonaketide synthase, enoyl reductase component', NULL, NULL, NULL, NULL, NULL, 4),
(107518, NULL, 'G3DSA:1.20.1250.20:FF:002024', NULL, NULL, 'Putative inorganic phosphate cotransporter-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(107519, NULL, 'G3DSA:1.10.10.60:FF:000065', NULL, NULL, 'Visual system homeobox 1', NULL, NULL, NULL, NULL, NULL, 4),
(107520, NULL, 'G3DSA:2.30.42.10:FF:000401', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107521, NULL, 'G3DSA:3.40.50.12160:FF:000029', NULL, NULL, 'Ribosomal protein S12 methylthiotransferase RimO', NULL, NULL, NULL, NULL, NULL, 4),
(107522, NULL, 'G3DSA:1.10.10.440:FF:000046', NULL, NULL, 'WW domain-containing protein ZK1098.1', NULL, NULL, NULL, NULL, NULL, 4),
(107523, NULL, 'G3DSA:3.30.160.60:FF:001958', NULL, NULL, 'Zinc finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107524, NULL, 'G3DSA:1.10.8.270:FF:000047', NULL, NULL, 'TBC domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107525, NULL, 'G3DSA:2.60.40.10:FF:000289', NULL, NULL, 'Chromosome 6 open reading frame 106', NULL, NULL, NULL, NULL, NULL, 4),
(107526, NULL, 'G3DSA:2.60.120.10:FF:000168', NULL, NULL, 'Cupin domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(107527, NULL, 'G3DSA:1.25.40.530:FF:000001', NULL, NULL, 'Pleckstrin homology domain-containing family H member 2', NULL, NULL, NULL, NULL, NULL, 4),
(107528, NULL, 'G3DSA:2.40.10.10:FF:000417', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107529, NULL, 'G3DSA:3.40.50.300:FF:002690', NULL, NULL, 'Spermidine/putrescine ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(107530, NULL, 'G3DSA:3.40.190.290:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107531, NULL, 'G3DSA:1.10.510.10:FF:002326', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107532, NULL, 'G3DSA:3.40.50.2300:FF:001546', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107533, NULL, 'G3DSA:1.25.40.540:FF:000004', NULL, NULL, 'Type 2A phosphatase-associated protein 42,putative', NULL, NULL, NULL, NULL, NULL, 4),
(107534, NULL, 'G3DSA:3.40.640.10:FF:000421', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(107535, NULL, 'G3DSA:2.10.25.10:FF:001453', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(107536, NULL, 'G3DSA:3.30.200.20:FF:001675', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107537, NULL, 'G3DSA:2.70.130.10:FF:000149', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107538, NULL, 'G3DSA:3.90.1150.10:FF:000017', NULL, NULL, 'Ornithine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(107539, NULL, 'G3DSA:3.30.200.20:FF:001984', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107540, NULL, 'G3DSA:3.40.1360.10:FF:000034', NULL, NULL, 'Meiotic recombination protein SPO11-4', NULL, NULL, NULL, NULL, NULL, 4),
(107541, NULL, 'G3DSA:3.30.1330.10:FF:000012', NULL, NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(107542, NULL, 'G3DSA:1.25.10.10:FF:001888', NULL, NULL, 'CAND1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(107543, NULL, 'G3DSA:1.20.5.170:FF:000200', NULL, NULL, 'Putative basic-leucine zipper transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(107544, NULL, 'G3DSA:3.30.450.40:FF:000069', NULL, NULL, 'Putative transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(107545, NULL, 'G3DSA:1.10.287.600:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107546, NULL, 'G3DSA:1.10.10.10:FF:000943', NULL, NULL, 'Regulatory protein RecX', NULL, NULL, NULL, NULL, NULL, 4),
(107547, NULL, 'G3DSA:3.90.730.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107548, NULL, 'G3DSA:1.10.520.10:FF:000039', NULL, NULL, 'Os07g0639500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(107549, NULL, 'G3DSA:3.40.50.300:FF:002381', NULL, NULL, 'Type II/IV secretion system protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(107550, NULL, 'G3DSA:1.10.10.60:FF:000374', NULL, NULL, 'Arginine-glutamic acid dipeptide repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(107551, NULL, 'G3DSA:2.130.10.10:FF:000385', NULL, NULL, 'DDB1- and CUL4-associated factor 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(107552, NULL, 'G3DSA:3.40.50.150:FF:000374', NULL, NULL, 'Putative methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(107553, NULL, 'G3DSA:3.40.640.10:FF:000056', NULL, NULL, 'SelA-like pyridoxal phosphate-dependent enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(107554, NULL, 'G3DSA:3.40.50.1000:FF:000375', NULL, NULL, 'phosphoserine phosphatase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(107555, NULL, 'G3DSA:3.30.1330.60:FF:000004', NULL, NULL, 'Outer membrane protein A', NULL, NULL, NULL, NULL, NULL, 4),
(107556, NULL, 'G3DSA:3.30.420.40:FF:000135', NULL, NULL, 'Heat shock cognate 71 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(107557, NULL, 'G3DSA:1.25.40.10:FF:000064', NULL, NULL, 'Putative pre-mrna-processing factor 39', NULL, NULL, NULL, NULL, NULL, 4),
(107558, NULL, 'G3DSA:3.20.20.70:FF:000822', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107559, NULL, 'G3DSA:3.40.30.10:FF:000922', NULL, NULL, 'Iodothyronine deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(107560, NULL, 'G3DSA:1.10.510.10:FF:002871', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107561, NULL, 'G3DSA:2.40.50.140:FF:000021', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(107562, NULL, 'G3DSA:3.30.390.50:FF:000016', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(107563, NULL, 'G3DSA:1.10.1420.10:FF:000008', NULL, NULL, 'MutS homolog 5 (E. coli)', NULL, NULL, NULL, NULL, NULL, 4),
(107564, NULL, 'G3DSA:2.130.10.10:FF:004544', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107565, NULL, 'G3DSA:3.40.50.300:FF:004943', NULL, NULL, 'Small GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107566, NULL, 'G3DSA:2.30.29.30:FF:001147', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(107567, NULL, 'G3DSA:2.10.25.10:FF:000014', NULL, NULL, 'Latent-transforming growth factor beta-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(107568, NULL, 'G3DSA:3.40.532.10:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107569, NULL, 'G3DSA:1.20.1110.10:FF:000179', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107570, NULL, 'G3DSA:3.40.50.1100:FF:000107', NULL, NULL, 'Diaminopropionate ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(107571, NULL, 'G3DSA:3.40.462.20:FF:000004', NULL, NULL, 'FAD binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(107572, NULL, 'G3DSA:3.30.310.10:FF:000039', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(107573, NULL, 'G3DSA:2.120.10.30:FF:000037', NULL, NULL, 'Uncharacterized protein, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(107574, NULL, 'G3DSA:3.40.50.300:FF:008215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107575, NULL, 'G3DSA:2.60.40.10:FF:003959', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107576, NULL, 'G3DSA:1.10.510.10:FF:002343', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107577, NULL, 'G3DSA:1.10.400.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107578, NULL, 'G3DSA:2.60.200.20:FF:000093', NULL, NULL, 'Kinesin-3', NULL, NULL, NULL, NULL, NULL, 4),
(107579, NULL, 'G3DSA:2.30.30.40:FF:000602', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107580, NULL, 'G3DSA:2.40.50.100:FF:000060', NULL, NULL, 'Apicoplast ribosomal protein L27', NULL, NULL, NULL, NULL, NULL, 4),
(107581, NULL, 'G3DSA:2.130.10.10:FF:001796', NULL, NULL, 'WD repeat-containing protein 55 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(107582, NULL, 'G3DSA:2.60.40.60:FF:000315', NULL, NULL, 'CaDHerin family', NULL, NULL, NULL, NULL, NULL, 4),
(107583, NULL, 'G3DSA:2.40.30.10:FF:000290', NULL, NULL, 'Selenocysteine-specific translation elongation factor', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(107584, NULL, 'G3DSA:3.40.50.300:FF:003797', NULL, NULL, 'Protein CBG01632', NULL, NULL, NULL, NULL, NULL, 4),
(107585, NULL, 'G3DSA:3.90.70.40:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107586, NULL, 'G3DSA:3.90.105.10:FF:000009', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(107587, NULL, 'G3DSA:3.30.160.60:FF:000199', NULL, NULL, 'metal regulatory transcription factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(107588, NULL, 'G3DSA:3.30.40.10:FF:001704', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107589, NULL, 'G3DSA:1.20.58.1040:FF:000004', NULL, NULL, 'O-Glycosyl hydrolase family 17 protein', NULL, NULL, NULL, NULL, NULL, 4),
(107590, NULL, 'G3DSA:1.20.1270.280:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107591, NULL, 'G3DSA:3.30.70.920:FF:000021', NULL, NULL, 'Lrp/AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(107592, NULL, 'G3DSA:2.40.340.10:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107593, NULL, 'G3DSA:1.25.10.10:FF:002170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107594, NULL, 'G3DSA:3.10.660.10:FF:000002', NULL, NULL, 'DnaJ (Hsp40) homolog, subfamily C, member 24', NULL, NULL, NULL, NULL, NULL, 4),
(107595, NULL, 'G3DSA:1.25.40.70:FF:000076', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(107596, NULL, 'G3DSA:3.30.1330.50:FF:000001', NULL, NULL, '2-C-methyl-D-erythritol 2,4-cyclodiphosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(107597, NULL, 'G3DSA:3.30.160.360:FF:000002', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(107598, NULL, 'G3DSA:1.10.630.10:FF:000795', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(107599, NULL, 'G3DSA:1.10.10.10:FF:002107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107600, NULL, 'G3DSA:2.60.40.60:FF:000843', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107601, NULL, 'G3DSA:3.30.830.10:FF:000039', NULL, NULL, 'Ubiquinol-cytochrome c reductase core subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(107602, NULL, 'G3DSA:3.30.2020.30:FF:000034', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(107603, NULL, 'G3DSA:1.20.58.1030:FF:000001', NULL, NULL, 'DNA replication complex GINS protein PSF1', NULL, NULL, NULL, NULL, NULL, 4),
(107604, NULL, 'G3DSA:2.120.10.30:FF:000571', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107605, NULL, 'G3DSA:1.20.1070.10:FF:001670', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107606, NULL, 'G3DSA:2.30.30.40:FF:000063', NULL, NULL, 'Putative E3 ubiquitin-protein ligase SH3RF1', NULL, NULL, NULL, NULL, NULL, 4),
(107607, NULL, 'G3DSA:3.30.200.20:FF:002147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107608, NULL, 'G3DSA:3.40.50.150:FF:000368', NULL, NULL, 'Multisite-specific tRNA:(Cytosine-C(5))-methyltransferase trm4b', NULL, NULL, NULL, NULL, NULL, 4),
(107609, NULL, 'G3DSA:3.30.70.3250:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107610, NULL, 'G3DSA:3.30.2010.30:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107611, NULL, 'G3DSA:1.20.5.190:FF:000122', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107612, NULL, 'G3DSA:3.10.250.10:FF:000084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107613, NULL, 'G3DSA:1.20.1050.10:FF:000033', NULL, NULL, 'metaxin-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(107614, NULL, 'G3DSA:3.30.505.10:FF:000262', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107615, NULL, 'G3DSA:2.130.10.10:FF:005539', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107616, NULL, 'G3DSA:3.10.180.10:FF:000055', NULL, NULL, 'Protein yecM', NULL, NULL, NULL, NULL, NULL, 4),
(107617, NULL, 'G3DSA:3.90.550.10:FF:000487', NULL, NULL, '2-phospho-L-lactate guanylyltransferase protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(107618, NULL, 'G3DSA:3.30.200.20:FF:000601', NULL, NULL, 'Protein kinase C epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(107619, NULL, 'G3DSA:2.30.30.30:FF:000060', NULL, NULL, 'Transcription elongation factor SPT5', NULL, NULL, NULL, NULL, NULL, 4),
(107620, NULL, 'G3DSA:3.30.70.330:FF:001575', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107621, NULL, 'G3DSA:3.30.160.60:FF:000738', NULL, NULL, 'zinc finger protein Eos isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(107622, NULL, 'G3DSA:1.10.472.10:FF:000409', NULL, NULL, 'Cyclin-related protein FAM58A', NULL, NULL, NULL, NULL, NULL, 4),
(107623, NULL, 'G3DSA:1.10.418.10:FF:000048', NULL, NULL, 'Short stop, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(107624, NULL, 'G3DSA:2.30.29.240:FF:000024', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(107625, NULL, 'G3DSA:1.25.10.10:FF:000707', NULL, NULL, 'MMS19 nucleotide excision repair protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(107626, NULL, 'G3DSA:3.90.550.50:FF:000252', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(107627, NULL, 'G3DSA:1.25.40.10:FF:004335', NULL, NULL, 'Tetratricopeptide repeat domain 19', NULL, NULL, NULL, NULL, NULL, 4),
(107628, NULL, 'G3DSA:1.25.10.10:FF:000455', NULL, NULL, 'Karyopherin beta', NULL, NULL, NULL, NULL, NULL, 4),
(107629, NULL, 'G3DSA:1.10.510.10:FF:002545', NULL, NULL, 'Serine/threonine-protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107630, NULL, 'G3DSA:3.40.50.720:FF:000224', NULL, NULL, 'Hydroxysteroid 17-beta dehydrogenase 11', NULL, NULL, NULL, NULL, NULL, 4),
(107631, NULL, 'G3DSA:3.90.226.10:FF:000228', NULL, NULL, 'ATP-dependent Clp protease proteolytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(107632, NULL, 'G3DSA:1.10.3470.10:FF:000062', NULL, NULL, 'Probable ABC transporter permease protein HI_1471', NULL, NULL, NULL, NULL, NULL, 4),
(107633, NULL, 'G3DSA:3.30.160.60:FF:002453', NULL, NULL, 'Zinc finger protein 687', NULL, NULL, NULL, NULL, NULL, 4),
(107634, NULL, 'G3DSA:2.30.29.230:FF:000021', NULL, NULL, 'GTPase-activating protein gyp7', NULL, NULL, NULL, NULL, NULL, 4),
(107635, NULL, 'G3DSA:3.40.50.300:FF:002706', NULL, NULL, 'SEPT3 isoform 5', NULL, NULL, NULL, NULL, NULL, 4),
(107636, NULL, 'G3DSA:3.30.50.10:FF:000204', NULL, NULL, 'E78 nuclear receptor', NULL, NULL, NULL, NULL, NULL, 4),
(107637, NULL, 'G3DSA:3.40.190.10:FF:000111', NULL, NULL, 'Hca operon transcriptional activator', NULL, NULL, NULL, NULL, NULL, 4),
(107638, NULL, 'G3DSA:2.60.40.10:FF:004566', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107639, NULL, 'G3DSA:3.40.50.300:FF:000672', NULL, NULL, 'Trifunctional nicotinamide-nucleotide adenylyltransferase/ribosylnicotinamide kinase/transcriptional regulator NadR', NULL, NULL, NULL, NULL, NULL, 4),
(107640, NULL, 'G3DSA:3.90.70.10:FF:000259', NULL, NULL, 'Dipeptidyl peptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(107641, NULL, 'G3DSA:3.90.550.10:FF:000611', NULL, NULL, 'Os04g0613700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(107642, NULL, 'G3DSA:3.30.60.90:FF:000049', NULL, NULL, 'zinc finger protein (ZZ-type)-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(107643, NULL, 'G3DSA:3.10.170.20:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107644, NULL, 'G3DSA:3.40.50.1820:FF:001812', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107645, NULL, 'G3DSA:3.80.10.10:FF:001970', NULL, NULL, 'F-box protein', NULL, NULL, NULL, NULL, NULL, 4),
(107646, NULL, 'G3DSA:1.20.120.1750:FF:000023', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(107647, NULL, 'G3DSA:3.40.50.1580:FF:000060', NULL, NULL, 'S-methyl-5''-thioadenosine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(107648, NULL, 'G3DSA:3.30.70.2820:FF:000002', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(107649, NULL, 'G3DSA:2.40.10.310:FF:000002', NULL, NULL, '30S ribosomal protein S8e', NULL, NULL, NULL, NULL, NULL, 4),
(107650, NULL, 'G3DSA:3.30.160.60:FF:004690', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(107651, NULL, 'G3DSA:3.30.70.330:FF:001884', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107652, NULL, 'G3DSA:3.30.870.10:FF:000148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107653, NULL, 'G3DSA:3.40.470.10:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107654, NULL, 'G3DSA:2.130.10.10:FF:005848', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107655, NULL, 'G3DSA:1.20.1070.10:FF:000956', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107656, NULL, 'G3DSA:2.60.40.2810:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107657, NULL, 'G3DSA:1.25.40.20:FF:000319', NULL, NULL, 'E3 ubiquitin-protein ligase HACE1 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(107658, NULL, 'G3DSA:1.20.1280.50:FF:000079', NULL, NULL, 'Unplaced genomic scaffold supercont1.46, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(107659, NULL, 'G3DSA:1.25.40.10:FF:000316', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(107660, NULL, 'G3DSA:1.10.10.60:FF:000733', NULL, NULL, 'NANOG neighbor homeobox', NULL, NULL, NULL, NULL, NULL, 4),
(107661, NULL, 'G3DSA:2.120.10.30:FF:000239', NULL, NULL, 'Protein STRICTOSIDINE SYNTHASE-LIKE 3', NULL, NULL, NULL, NULL, NULL, 4),
(107662, NULL, 'G3DSA:3.80.30.20:FF:000030', NULL, NULL, 'Oxidative cyclase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107663, NULL, 'G3DSA:1.10.1070.11:FF:000066', NULL, NULL, 'NUC194_domain/Phosphatidylinositol_3-_and_4 -kinase_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(107664, NULL, 'G3DSA:3.40.720.10:FF:000366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107665, NULL, 'G3DSA:3.30.559.10:FF:000110', NULL, NULL, 'O-acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107666, NULL, 'G3DSA:1.10.418.10:FF:000155', NULL, NULL, 'Microtubule binding protein HOOK3, putative (AFU_orthologue AFUA_1G07490)', NULL, NULL, NULL, NULL, NULL, 4),
(107667, NULL, 'G3DSA:3.40.50.300:FF:000924', NULL, NULL, 'tRNA modification GTPase GTPBP3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(107668, NULL, 'G3DSA:1.10.472.130:FF:000016', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107669, NULL, 'G3DSA:2.60.40.10:FF:005893', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107670, NULL, 'G3DSA:1.10.510.10:FF:001016', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase SD3-1', NULL, NULL, NULL, NULL, NULL, 4),
(107671, NULL, 'G3DSA:3.40.50.1820:FF:001503', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107672, NULL, 'G3DSA:1.10.510.10:FF:000398', NULL, NULL, 'Calcium-dependent protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(107673, NULL, 'G3DSA:2.40.10.10:FF:000434', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107674, NULL, 'G3DSA:3.10.310.20:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107675, NULL, 'G3DSA:2.60.120.200:FF:000030', NULL, NULL, 'FAT atypical cadherin 4', NULL, NULL, NULL, NULL, NULL, 4),
(107676, NULL, 'G3DSA:1.25.40.10:FF:003498', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(107677, NULL, 'G3DSA:3.10.100.10:FF:000314', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107678, NULL, 'G3DSA:1.10.8.270:FF:000064', NULL, NULL, 'Small G protein-signaling modulator 1b', NULL, NULL, NULL, NULL, NULL, 4),
(107679, NULL, 'G3DSA:3.60.21.10:FF:000018', NULL, NULL, 'Phosphoesterase', NULL, NULL, NULL, NULL, NULL, 4),
(107680, NULL, 'G3DSA:1.10.30.10:FF:000074', NULL, NULL, 'SRY-related protein AMA1', NULL, NULL, NULL, NULL, NULL, 4),
(107681, NULL, 'G3DSA:3.90.550.50:FF:000033', NULL, NULL, 'GD23186', NULL, NULL, NULL, NULL, NULL, 4),
(107682, NULL, 'G3DSA:1.20.120.1900:FF:000091', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(107683, NULL, 'G3DSA:1.20.58.760:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(107684, NULL, 'G3DSA:3.10.110.10:FF:000118', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 N', NULL, NULL, NULL, NULL, NULL, 4),
(107685, NULL, 'G3DSA:3.90.226.10:FF:000122', NULL, NULL, 'Serine protease SPPA, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(107686, NULL, 'G3DSA:3.60.21.10:FF:000327', NULL, NULL, 'Vacuolar protein sorting-associated protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(107687, NULL, 'G3DSA:3.40.50.1820:FF:001267', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(107688, NULL, 'G3DSA:3.90.1150.10:FF:000091', NULL, NULL, 'Glutamic-oxaloacetic transaminase 1 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(107689, NULL, 'G3DSA:3.30.230.70:FF:000073', NULL, NULL, 'EXOSome (Multiexonuclease complex) component', NULL, NULL, NULL, NULL, NULL, 4),
(107690, NULL, 'G3DSA:3.30.70.330:FF:002502', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107691, NULL, 'G3DSA:3.40.50.1780:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107692, NULL, 'G3DSA:3.10.105.10:FF:000067', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(107693, NULL, 'G3DSA:2.30.30.140:FF:000339', NULL, NULL, 'RBB1NT (NUC162) domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(107694, NULL, 'G3DSA:3.30.2160.10:FF:000077', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(107695, NULL, 'G3DSA:3.90.1140.10:FF:000045', NULL, NULL, 'U6 snRNA phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(107696, NULL, 'G3DSA:4.10.90.10:FF:000003', NULL, NULL, 'Polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(107697, NULL, 'G3DSA:3.30.519.10:FF:000001', NULL, NULL, 'Rab GDP dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(107698, NULL, 'G3DSA:3.40.640.10:FF:000275', NULL, NULL, 'Bifunctional dethiobiotin synthetase/7,8-diamino-pelargonic acid aminotransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(107699, NULL, 'G3DSA:3.40.50.1010:FF:000069', NULL, NULL, 'Ribonuclease VapC', NULL, NULL, NULL, NULL, NULL, 4),
(107700, NULL, 'G3DSA:3.40.50.1000:FF:000156', NULL, NULL, 'PhosphoGlycolate Phosphatase Homolog', NULL, NULL, NULL, NULL, NULL, 4),
(107701, NULL, 'G3DSA:3.30.710.10:FF:000210', NULL, NULL, 'BTB/POZ domain-containing protein SR1IP1', NULL, NULL, NULL, NULL, NULL, 4),
(107702, NULL, 'G3DSA:2.130.10.10:FF:000744', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(107703, NULL, 'G3DSA:3.40.50.720:FF:001551', NULL, NULL, '3-oxoacyl-(Acyl carrier protein) reductase (FabG-6)', NULL, NULL, NULL, NULL, NULL, 4),
(107704, NULL, 'G3DSA:2.130.10.10:FF:002184', NULL, NULL, 'Cilia and flagella-associated protein 57', NULL, NULL, NULL, NULL, NULL, 4),
(107705, NULL, 'G3DSA:3.40.50.10810:FF:000169', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(107706, NULL, 'G3DSA:2.40.30.130:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107707, NULL, 'G3DSA:2.130.10.10:FF:000492', NULL, NULL, 'LEC14B homolog isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(107708, NULL, 'G3DSA:2.60.40.10:FF:002217', NULL, NULL, 'Roundabout 2', NULL, NULL, NULL, NULL, NULL, 4),
(107709, NULL, 'G3DSA:3.65.10.10:FF:000022', NULL, NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(107710, NULL, 'G3DSA:2.70.170.10:FF:000034', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(107711, NULL, 'G3DSA:3.60.130.20:FF:000004', NULL, NULL, 'Prolyl 3,4-dihydroxylase OGFOD1', NULL, NULL, NULL, NULL, NULL, 4),
(107712, NULL, 'G3DSA:2.70.130.10:FF:000166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107713, NULL, 'G3DSA:2.10.25.10:FF:001009', NULL, NULL, 'Protein CBG02502', NULL, NULL, NULL, NULL, NULL, 4),
(107714, NULL, 'G3DSA:3.90.70.10:FF:000478', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107715, NULL, 'G3DSA:1.20.140.150:FF:000001', NULL, NULL, 'Claudin', NULL, NULL, NULL, NULL, NULL, 4),
(107716, NULL, 'G3DSA:2.70.150.10:FF:000167', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(107717, NULL, 'G3DSA:3.40.50.300:FF:000891', NULL, NULL, 'ATP-binding cassette sub-family G member', NULL, NULL, NULL, NULL, NULL, 4),
(107718, NULL, 'G3DSA:1.25.40.10:FF:003189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107719, NULL, 'G3DSA:3.40.980.10:FF:000014', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(107720, NULL, 'G3DSA:1.20.1640.10:FF:000045', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(107721, NULL, 'G3DSA:3.40.30.10:FF:000158', NULL, NULL, 'Selenoprotein W', NULL, NULL, NULL, NULL, NULL, 4),
(107722, NULL, 'G3DSA:2.60.40.1120:FF:000042', NULL, NULL, 'Carboxypeptidase-like regulatory domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(107723, NULL, 'G3DSA:2.10.220.10:FF:000018', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(107724, NULL, 'G3DSA:3.30.160.60:FF:002672', NULL, NULL, 'Zinc finger protein 347', NULL, NULL, NULL, NULL, NULL, 4),
(107725, NULL, 'G3DSA:2.40.30.10:FF:000435', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107726, NULL, 'G3DSA:2.40.10.10:FF:000182', NULL, NULL, 'Zgc:163079', NULL, NULL, NULL, NULL, NULL, 4),
(107727, NULL, 'G3DSA:3.40.50.10810:FF:000080', NULL, NULL, 'DNA repair protein RAD16', NULL, NULL, NULL, NULL, NULL, 4),
(107728, NULL, 'G3DSA:3.10.490.10:FF:000045', NULL, NULL, 'Gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(107729, NULL, 'G3DSA:2.10.25.10:FF:001318', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(107730, NULL, 'G3DSA:2.60.40.790:FF:000068', NULL, NULL, '22.0 kDa class IV heat shock protein', NULL, NULL, NULL, NULL, NULL, 4),
(107731, NULL, 'G3DSA:2.60.200.20:FF:000104', NULL, NULL, 'Serine/threonine-protein kinase RAD53', NULL, NULL, NULL, NULL, NULL, 4),
(107732, NULL, 'G3DSA:3.30.559.30:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107733, NULL, 'G3DSA:3.40.50.720:FF:001860', NULL, NULL, 'Glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(107734, NULL, 'G3DSA:3.90.1110.10:FF:000021', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(107735, NULL, 'G3DSA:1.10.510.10:FF:000089', NULL, NULL, 'Tyrosine-protein kinase receptor TYRO3', NULL, NULL, NULL, NULL, NULL, 4),
(107736, NULL, 'G3DSA:3.40.30.10:FF:000809', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(107737, NULL, 'G3DSA:3.40.630.10:FF:000140', NULL, NULL, 'Carboxypeptidase d', NULL, NULL, NULL, NULL, NULL, 4),
(107738, NULL, 'G3DSA:3.30.450.40:FF:000272', NULL, NULL, 'PAS sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(107739, NULL, 'G3DSA:1.25.40.90:FF:000031', NULL, NULL, 'Vacuolar protein sorting-associated protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(107740, NULL, 'G3DSA:2.130.10.10:FF:005871', NULL, NULL, 'WD40 repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(107741, NULL, 'G3DSA:2.60.120.650:FF:000232', NULL, NULL, 'Lid2 complex component lid2', NULL, NULL, NULL, NULL, NULL, 4),
(107742, NULL, 'G3DSA:3.30.379.10:FF:000012', NULL, NULL, 'Beta-hexosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(107743, NULL, 'G3DSA:1.25.40.990:FF:000009', NULL, NULL, 'Dysferlin protein', NULL, NULL, NULL, NULL, NULL, 4),
(107744, NULL, 'G3DSA:1.25.40.10:FF:004116', NULL, NULL, 'Protein CBG21210', NULL, NULL, NULL, NULL, NULL, 4),
(107745, NULL, 'G3DSA:3.30.160.60:FF:002981', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107746, NULL, 'G3DSA:1.20.1250.20:FF:001546', NULL, NULL, 'MFS transporter, putative (AFU_orthologue AFUA_2G17840)', NULL, NULL, NULL, NULL, NULL, 4),
(107747, NULL, 'G3DSA:3.30.565.10:FF:000400', NULL, NULL, 'Two-component system sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(107748, NULL, 'G3DSA:1.25.10.10:FF:002400', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107749, NULL, 'G3DSA:1.10.533.10:FF:000018', NULL, NULL, 'Nuclear factor NF-kappa-B p105 subunit isoform 1', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(107750, NULL, 'G3DSA:2.20.25.10:FF:000076', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(107751, NULL, 'G3DSA:2.60.40.60:FF:000624', NULL, NULL, 'Desmocollin 1', NULL, NULL, NULL, NULL, NULL, 4),
(107752, NULL, 'G3DSA:3.40.50.1820:FF:001048', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(107753, NULL, 'G3DSA:3.40.50.1480:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107754, NULL, 'G3DSA:3.30.200.20:FF:000040', NULL, NULL, 'Dual specificity mitogen-activated protein kinase kinase', NULL, NULL, NULL, NULL, NULL, 4),
(107755, NULL, 'G3DSA:1.10.10.60:FF:000481', NULL, NULL, 'Hydrogenase-4 transcriptional activator', NULL, NULL, NULL, NULL, NULL, 4),
(107756, NULL, 'G3DSA:3.90.230.10:FF:000008', NULL, NULL, 'Proliferation-associated 2G4, b', NULL, NULL, NULL, NULL, NULL, 4),
(107757, NULL, 'G3DSA:1.10.530.10:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107758, NULL, 'G3DSA:1.25.40.10:FF:002082', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g02750', NULL, NULL, NULL, NULL, NULL, 4),
(107759, NULL, 'G3DSA:1.25.40.10:FF:004026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107760, NULL, 'G3DSA:1.20.120.1900:FF:000012', NULL, NULL, 'Putative gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(107761, NULL, 'G3DSA:2.30.30.40:FF:000372', NULL, NULL, 'Elongation factor 2 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(107762, NULL, 'G3DSA:3.20.20.410:FF:000001', NULL, NULL, 'Protein_of_uncharacterized_function_DUF72_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(107763, NULL, 'G3DSA:3.30.230.10:FF:000061', NULL, NULL, 'Galactokinase', NULL, NULL, NULL, NULL, NULL, 4),
(107764, NULL, 'G3DSA:1.10.20.10:FF:000354', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107765, NULL, 'G3DSA:3.30.1640.10:FF:000024', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(107766, NULL, 'G3DSA:1.10.730.10:FF:000055', NULL, NULL, 'Methionine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(107767, NULL, 'G3DSA:1.20.1270.20:FF:000002', NULL, NULL, 'Hydroxylamine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(107768, NULL, 'G3DSA:2.40.33.40:FF:000001', NULL, NULL, 'PTS system, glucitol/sorbitol-specific, IIA component', NULL, NULL, NULL, NULL, NULL, 4),
(107769, NULL, 'G3DSA:1.20.920.10:FF:000197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107770, NULL, 'G3DSA:1.20.1070.10:FF:001119', NULL, NULL, 'Tachykinin-like peptides receptor 86C', NULL, NULL, NULL, NULL, NULL, 4),
(107771, NULL, 'G3DSA:1.20.1560.10:FF:000100', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(107772, NULL, 'G3DSA:1.10.238.10:FF:000591', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107773, NULL, 'G3DSA:3.20.20.80:FF:000589', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(107774, NULL, 'G3DSA:3.30.1360.120:FF:000036', NULL, NULL, 'Putative transferase CAF17, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(107775, NULL, 'G3DSA:1.10.510.10:FF:000853', NULL, NULL, 'Related to ARK1-Actin Regulating Kinase', NULL, NULL, NULL, NULL, NULL, 4),
(107776, NULL, 'G3DSA:3.40.50.300:FF:007962', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107777, NULL, 'G3DSA:3.40.630.10:FF:000246', NULL, NULL, 'Metal-dependent amidase/aminoacylase/carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(107778, NULL, 'G3DSA:2.160.10.10:FF:000131', NULL, NULL, 'Acetyltransferase CysE/LacA/LpxA/NodL family', NULL, NULL, NULL, NULL, NULL, 4),
(107779, NULL, 'G3DSA:2.40.10.10:FF:000215', NULL, NULL, 'Trypsin domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(107780, NULL, 'G3DSA:2.60.120.330:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107781, NULL, 'G3DSA:3.90.70.10:FF:000169', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(107782, NULL, 'G3DSA:3.40.50.1820:FF:001576', NULL, NULL, 'Acetylcholinesterase, putative', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(107783, NULL, 'G3DSA:3.40.50.1980:FF:000073', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(107784, NULL, 'G3DSA:3.10.10.10:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107785, NULL, 'G3DSA:3.30.110.20:FF:000010', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(107786, NULL, 'G3DSA:3.30.160.60:FF:006359', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107787, NULL, 'G3DSA:3.30.1010.10:FF:000072', NULL, NULL, 'Phosphatidylinositol 3-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(107788, NULL, 'G3DSA:4.10.60.10:FF:000254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107789, NULL, 'G3DSA:1.20.930.80:FF:000004', NULL, NULL, 'DNA primase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(107790, NULL, 'G3DSA:1.20.120.1750:FF:000129', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(107791, NULL, 'G3DSA:3.40.190.10:FF:000420', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(107792, NULL, 'G3DSA:3.30.110.30:FF:000013', NULL, NULL, 'Anticodon binding domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(107793, NULL, 'G3DSA:3.30.40.10:FF:001923', NULL, NULL, 'RING/U-box superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(107794, NULL, 'G3DSA:3.30.70.330:FF:001794', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107795, NULL, 'G3DSA:1.20.930.70:FF:000001', NULL, NULL, 'Fatty acid synthase beta subunit dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(107796, NULL, 'G3DSA:2.60.40.1760:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107797, NULL, 'G3DSA:3.40.50.1000:FF:000066', NULL, NULL, 'Phosphomannomutase', NULL, NULL, NULL, NULL, NULL, 4),
(107798, NULL, 'G3DSA:3.30.1370.10:FF:000121', NULL, NULL, 'Meiotic recombination 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(107799, NULL, 'G3DSA:1.25.40.990:FF:000010', NULL, NULL, 'Leukocyte receptor cluster member', NULL, NULL, NULL, NULL, NULL, 4),
(107800, NULL, 'G3DSA:3.40.47.10:FF:000213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107801, NULL, 'G3DSA:1.25.40.10:FF:002424', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g09410, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(107802, NULL, 'G3DSA:1.25.40.10:FF:000283', NULL, NULL, 'Intraflagellar transport 88', NULL, NULL, NULL, NULL, NULL, 4),
(107803, NULL, 'G3DSA:3.40.50.300:FF:000363', NULL, NULL, 'Secretion related GTPase srgA', NULL, NULL, NULL, NULL, NULL, 4),
(107804, NULL, 'G3DSA:1.50.10.10:FF:000189', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(107805, NULL, 'G3DSA:3.40.47.10:FF:000123', NULL, NULL, 'Putative hydroxymethylglutaryl-CoA synthase', NULL, NULL, NULL, NULL, NULL, 4),
(107806, NULL, 'G3DSA:3.90.550.10:FF:000717', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107807, NULL, 'G3DSA:1.20.144.10:FF:000090', NULL, NULL, 'Lipid A 1-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(107808, NULL, 'G3DSA:3.30.200.20:FF:000455', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(107809, NULL, 'G3DSA:3.10.110.10:FF:000141', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 8', NULL, NULL, NULL, NULL, NULL, 4),
(107810, NULL, 'G3DSA:1.20.1070.10:FF:001451', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(107811, NULL, 'G3DSA:1.25.40.10:FF:000625', NULL, NULL, 'Tetratricopeptide repeat protein 30A', NULL, NULL, NULL, NULL, NULL, 4),
(107812, NULL, 'G3DSA:2.130.10.10:FF:002436', NULL, NULL, 'dmX-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(107813, NULL, 'G3DSA:2.130.10.10:FF:001110', NULL, NULL, 'Dynein intermediate chain 2, ciliary', NULL, NULL, NULL, NULL, NULL, 4),
(107814, NULL, 'G3DSA:2.60.40.10:FF:000525', NULL, NULL, 'neurofascin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(107815, NULL, 'G3DSA:1.25.40.20:FF:000286', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(107816, NULL, 'G3DSA:3.30.40.10:FF:001468', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(107817, NULL, 'G3DSA:1.25.10.10:FF:000146', NULL, NULL, 'putative MO25-like protein At5g47540', NULL, NULL, NULL, NULL, NULL, 4),
(107818, NULL, 'G3DSA:1.25.10.10:FF:000601', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(107819, NULL, 'G3DSA:3.40.50.2300:FF:000220', NULL, NULL, 'Glutamate receptor, ionotropic, delta 1', NULL, NULL, NULL, NULL, NULL, 4),
(107820, NULL, 'G3DSA:3.30.60.30:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107821, NULL, 'G3DSA:3.10.20.90:FF:000749', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107822, NULL, 'G3DSA:1.10.1510.30:FF:000015', NULL, NULL, 'Pseudouridylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(107823, NULL, 'G3DSA:1.20.1310.10:FF:000076', NULL, NULL, 'Cullin 4A', NULL, NULL, NULL, NULL, NULL, 4),
(107824, NULL, 'G3DSA:3.80.10.10:FF:001661', NULL, NULL, 'F-box/LRR-repeat protein 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(107825, NULL, 'G3DSA:3.30.60.20:FF:000146', NULL, NULL, 'Diacylglycerol kinase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(107826, NULL, 'G3DSA:2.10.50.30:FF:000005', NULL, NULL, 'Metabotropic glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(107827, NULL, 'G3DSA:1.10.3720.10:FF:000076', NULL, NULL, 'Peptide ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(107828, NULL, 'G3DSA:3.80.10.10:FF:001419', NULL, NULL, 'Leucin rich protein', NULL, NULL, NULL, NULL, NULL, 4),
(107829, NULL, 'G3DSA:3.30.40.10:FF:001671', NULL, NULL, 'Putative e3 ubiquitin-protein ligase trim71', NULL, NULL, NULL, NULL, NULL, 4),
(107830, NULL, 'G3DSA:3.30.590.10:FF:000020', NULL, NULL, 'Putative glutamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(107831, NULL, 'G3DSA:1.20.120.350:FF:000158', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107832, NULL, 'G3DSA:1.10.472.10:FF:000303', NULL, NULL, 'Cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(107833, NULL, 'G3DSA:1.10.472.80:FF:000195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107834, NULL, 'G3DSA:1.20.1250.20:FF:001327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107835, NULL, 'G3DSA:1.10.8.710:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107836, NULL, 'G3DSA:1.10.580.10:FF:000037', NULL, NULL, 'Citrate synthase-related protein DDB_G0287281', NULL, NULL, NULL, NULL, NULL, 4),
(107837, NULL, 'G3DSA:1.10.510.10:FF:004035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107838, NULL, 'G3DSA:2.160.10.10:FF:000041', NULL, NULL, 'POSSIBLE TRANSFERASE', NULL, NULL, NULL, NULL, NULL, 4),
(107839, NULL, 'G3DSA:2.20.70.10:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107840, NULL, 'G3DSA:3.30.450.30:FF:000050', NULL, NULL, 'Dynein, light chain, roadblock-type 1', NULL, NULL, NULL, NULL, NULL, 4),
(107841, NULL, 'G3DSA:3.30.200.20:FF:000910', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 11', NULL, NULL, NULL, NULL, NULL, 4),
(107842, NULL, 'G3DSA:1.10.8.720:FF:000025', NULL, NULL, 'Dynein gamma chain, flagellar outer arm', NULL, NULL, NULL, NULL, NULL, 4),
(107843, NULL, 'G3DSA:3.60.21.10:FF:000237', NULL, NULL, 'Uncharacterized metallophosphoesterase YunD', NULL, NULL, NULL, NULL, NULL, 4),
(107844, NULL, 'G3DSA:3.20.20.70:FF:000586', NULL, NULL, 'Ferredoxin/NAD(P)H-dependent glutamate synthase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(107845, NULL, 'G3DSA:3.80.10.10:FF:000947', NULL, NULL, 'Si:dkey-286j17.4', NULL, NULL, NULL, NULL, NULL, 4),
(107846, NULL, 'G3DSA:3.30.160.60:FF:000632', NULL, NULL, 'zinc finger protein 24 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(107847, NULL, 'G3DSA:1.10.238.10:FF:000259', NULL, NULL, 'Polycystin 2 like 1, transient receptor potential cation channel', NULL, NULL, NULL, NULL, NULL, 4),
(107848, NULL, 'G3DSA:1.10.10.790:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(107849, NULL, 'G3DSA:2.60.40.10:FF:006056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107850, NULL, 'G3DSA:1.25.10.10:FF:002276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107851, NULL, 'G3DSA:1.20.1250.20:FF:001075', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(107852, NULL, 'G3DSA:3.40.50.2300:FF:000017', NULL, NULL, 'PTS sugar transporter subunit IIB', NULL, NULL, NULL, NULL, NULL, 4),
(107853, NULL, 'G3DSA:1.25.40.20:FF:000628', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(107854, NULL, 'G3DSA:2.30.30.40:FF:000169', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase', NULL, NULL, NULL, NULL, NULL, 4),
(107855, NULL, 'G3DSA:3.30.70.330:FF:002412', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107856, NULL, 'G3DSA:3.80.10.10:FF:003549', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107857, NULL, 'G3DSA:2.40.50.100:FF:000166', NULL, NULL, 'HAE1 family effllux pump MFP component', NULL, NULL, NULL, NULL, NULL, 4),
(107858, NULL, 'G3DSA:3.30.420.10:FF:000486', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107859, NULL, 'G3DSA:3.30.450.40:FF:000053', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(107860, NULL, 'G3DSA:3.90.70.10:FF:000714', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(107861, NULL, 'G3DSA:3.30.360.10:FF:000065', NULL, NULL, '4-hydroxy-tetrahydrodipicolinate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(107862, NULL, 'G3DSA:3.80.10.10:FF:000115', NULL, NULL, 'leucine-rich repeat protein SHOC-2', NULL, NULL, NULL, NULL, NULL, 4),
(107863, NULL, 'G3DSA:3.30.565.10:FF:000254', NULL, NULL, 'Sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(107864, NULL, 'G3DSA:1.20.1300.10:FF:000008', NULL, NULL, 'Succinate dehydrogenase cytochrome b560 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(107865, NULL, 'G3DSA:3.30.160.60:FF:000429', NULL, NULL, 'Zinc finger homeobox protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(107866, NULL, 'G3DSA:3.30.1490.20:FF:000088', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(107867, NULL, 'G3DSA:3.40.50.450:FF:000048', NULL, NULL, 'Ysine decarboxylase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(107868, NULL, 'G3DSA:2.130.10.10:FF:004235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107869, NULL, 'G3DSA:3.40.50.300:FF:004634', NULL, NULL, 'Chloroplast SRP receptor', NULL, NULL, NULL, NULL, NULL, 4),
(107870, NULL, 'G3DSA:3.30.1370.10:FF:000031', NULL, NULL, 'ankyrin repeat domain-containing protein 17 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(107871, NULL, 'G3DSA:3.30.860.10:FF:000013', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(107872, NULL, 'G3DSA:2.40.70.10:FF:000180', NULL, NULL, 'Aspartyl protease AED1', NULL, NULL, NULL, NULL, NULL, 4),
(107873, NULL, 'G3DSA:1.10.510.10:FF:000763', NULL, NULL, 'Os01g0748600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(107874, NULL, 'G3DSA:1.10.10.390:FF:000008', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(107875, NULL, 'G3DSA:2.60.11.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107876, NULL, 'G3DSA:3.30.160.60:FF:000519', NULL, NULL, 'Zinc finger protein 470', NULL, NULL, NULL, NULL, NULL, 4),
(107877, NULL, 'G3DSA:3.90.79.10:FF:000150', NULL, NULL, 'Nudix hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107878, NULL, 'G3DSA:3.40.525.10:FF:000007', NULL, NULL, 'rho GTPase-activating protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(107879, NULL, 'G3DSA:3.40.50.10050:FF:000014', NULL, NULL, 'Translation initiation factor IF-2', NULL, NULL, NULL, NULL, NULL, 4),
(107880, NULL, 'G3DSA:3.40.50.1000:FF:000627', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107881, NULL, 'G3DSA:3.30.200.20:FF:000236', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(107882, NULL, 'G3DSA:3.30.420.80:FF:000012', NULL, NULL, '30S ribosomal protein S11', NULL, NULL, NULL, NULL, NULL, 4),
(107883, NULL, 'G3DSA:3.40.605.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107884, NULL, 'G3DSA:3.10.50.10:FF:000031', NULL, NULL, 'Chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107885, NULL, 'G3DSA:3.40.1380.20:FF:000038', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(107886, NULL, 'G3DSA:3.30.160.60:FF:000177', NULL, NULL, 'Zinc finger protein 512', NULL, NULL, NULL, NULL, NULL, 4),
(107887, NULL, 'G3DSA:2.70.40.10:FF:000007', NULL, NULL, 'dUTP pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(107888, NULL, 'G3DSA:3.50.50.60:FF:000134', NULL, NULL, 'FAD-dependent oxidoreductase domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(107889, NULL, 'G3DSA:3.40.50.2300:FF:000107', NULL, NULL, 'Aerobic respiration control sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(107890, NULL, 'G3DSA:1.20.1440.180:FF:000006', NULL, NULL, 'Serine/threonine-protein kinase/endoribonuclease IRE1', NULL, NULL, NULL, NULL, NULL, 4),
(107891, NULL, 'G3DSA:3.40.50.1820:FF:000885', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(107892, NULL, 'G3DSA:3.40.50.720:FF:000005', NULL, NULL, 'calcium-activated potassium channel subunit alpha-1 isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(107893, NULL, 'G3DSA:2.60.40.60:FF:000534', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107894, NULL, 'G3DSA:1.10.287.30:FF:000002', NULL, NULL, 'Regulatory protein E2', NULL, NULL, NULL, NULL, NULL, 4),
(107895, NULL, 'G3DSA:3.90.100.10:FF:000004', NULL, NULL, 'Lysine decarboxylase, constitutive', NULL, NULL, NULL, NULL, NULL, 4),
(107896, NULL, 'G3DSA:1.20.58.2220:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107897, NULL, 'G3DSA:1.25.40.10:FF:003969', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107898, NULL, 'G3DSA:1.20.58.390:FF:000047', NULL, NULL, 'Resistance to dieldrin, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(107899, NULL, 'G3DSA:3.40.50.1390:FF:000025', NULL, NULL, 'Bll5010 protein', NULL, NULL, NULL, NULL, NULL, 4),
(107900, NULL, 'G3DSA:1.20.1160.11:FF:000003', NULL, NULL, 'Paired amphipathic helix SIN3-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(107901, NULL, 'G3DSA:2.30.29.30:FF:001169', NULL, NULL, 'PH domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(107902, NULL, 'G3DSA:3.40.50.150:FF:000604', NULL, NULL, 'NOL1/NOP2/sun family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107903, NULL, 'G3DSA:1.10.560.10:FF:000148', NULL, NULL, 'Chaperonin-containing TCP1, subunit 6A (zeta 1)', NULL, NULL, NULL, NULL, NULL, 4),
(107904, NULL, 'G3DSA:2.40.70.10:FF:000090', NULL, NULL, 'Aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(107905, NULL, 'G3DSA:1.10.10.370:FF:000002', NULL, NULL, 'Sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(107906, NULL, 'G3DSA:2.60.120.620:FF:000139', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(107907, NULL, 'G3DSA:3.30.70.360:FF:000010', NULL, NULL, 'M20/M25/M40 family metallo-hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(107908, NULL, 'G3DSA:3.40.1380.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107909, NULL, 'G3DSA:2.30.180.10:FF:000083', NULL, NULL, 'FAS1 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(107910, NULL, 'G3DSA:3.40.30.10:FF:000938', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(107911, NULL, 'G3DSA:3.30.30.10:FF:000006', NULL, NULL, 'Defensin DFS2', NULL, NULL, NULL, NULL, NULL, 4),
(107912, NULL, 'G3DSA:1.20.1250.20:FF:001417', NULL, NULL, 'Siderophore iron transporter mirC', NULL, NULL, NULL, NULL, NULL, 4),
(107913, NULL, 'G3DSA:2.30.30.40:FF:000282', NULL, NULL, 'Intersectin 2', NULL, NULL, NULL, NULL, NULL, 4),
(107914, NULL, 'G3DSA:3.30.70.370:FF:000013', NULL, NULL, 'DNA-directed DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(107915, NULL, 'G3DSA:3.30.160.60:FF:004561', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107916, NULL, 'G3DSA:3.90.660.20:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107917, NULL, 'G3DSA:1.20.58.900:FF:000020', NULL, NULL, 'RUN Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(107918, NULL, 'G3DSA:2.70.130.10:FF:000060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107919, NULL, 'G3DSA:1.10.10.10:FF:002074', NULL, NULL, 'Fe(III)-induced transcriptional regulator IfcR', NULL, NULL, NULL, NULL, NULL, 4),
(107920, NULL, 'G3DSA:2.60.40.1510:FF:000052', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(107921, NULL, 'G3DSA:3.20.140.10:FF:000005', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(107922, NULL, 'G3DSA:1.10.167.10:FF:000066', NULL, NULL, 'Protein rax1', NULL, NULL, NULL, NULL, NULL, 4),
(107923, NULL, 'G3DSA:3.90.70.10:FF:000624', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107924, NULL, 'G3DSA:2.10.25.10:FF:000846', NULL, NULL, 'Vitamin K-dependent protein S', NULL, NULL, NULL, NULL, NULL, 4),
(107925, NULL, 'G3DSA:1.25.40.20:FF:000538', NULL, NULL, 'E3 ubiquitin-protein ligase HACE1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(107926, NULL, 'G3DSA:1.10.287.110:FF:000083', NULL, NULL, 'DnaJ and TPR domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(107927, NULL, 'G3DSA:1.10.340.30:FF:000014', NULL, NULL, 'Endonuclease III homolog', NULL, NULL, NULL, NULL, NULL, 4),
(107928, NULL, 'G3DSA:3.40.50.300:FF:004724', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107929, NULL, 'G3DSA:2.60.120.620:FF:000049', NULL, NULL, 'L-isoleucine-4-hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(107930, NULL, 'G3DSA:2.115.10.20:FF:000024', NULL, NULL, 'Levanase', NULL, NULL, NULL, NULL, NULL, 4),
(107931, NULL, 'G3DSA:1.10.3260.10:FF:000052', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(107932, NULL, 'G3DSA:3.40.50.1380:FF:000022', NULL, NULL, 'Phosphoribosylamine-glycine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(107933, NULL, 'G3DSA:2.120.10.80:FF:000030', NULL, NULL, 'Multiple epidermal growth factor-like domains 8', NULL, NULL, NULL, NULL, NULL, 4),
(107934, NULL, 'G3DSA:2.30.30.40:FF:000591', NULL, NULL, 'Rho GTPase-activating protein gacII', NULL, NULL, NULL, NULL, NULL, 4),
(107935, NULL, 'G3DSA:3.40.50.10190:FF:000186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107936, NULL, 'G3DSA:1.10.287.1490:FF:000025', NULL, NULL, 'golgin subfamily A member 3', NULL, NULL, NULL, NULL, NULL, 4),
(107937, NULL, 'G3DSA:1.25.40.10:FF:000535', NULL, NULL, 'Os03g0786900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(107938, NULL, 'G3DSA:3.80.10.10:FF:001751', NULL, NULL, 'centriolin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(107939, NULL, 'G3DSA:3.40.50.1100:FF:000293', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(107940, NULL, 'G3DSA:2.40.70.10:FF:000409', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107941, NULL, 'G3DSA:1.10.10.1590:FF:000003', NULL, NULL, 'NADH dehydrogenase I, E subunit', NULL, NULL, NULL, NULL, NULL, 4),
(107942, NULL, 'G3DSA:3.30.565.10:FF:000035', NULL, NULL, 'MORC family CW-type zinc finger protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(107943, NULL, 'G3DSA:3.90.226.10:FF:000009', NULL, NULL, 'Carnitinyl-CoA dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(107944, NULL, 'G3DSA:3.30.160.60:FF:004229', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107945, NULL, 'G3DSA:1.10.510.10:FF:004254', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107946, NULL, 'G3DSA:3.40.50.300:FF:004415', NULL, NULL, 'ABC transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(107947, NULL, 'G3DSA:3.80.10.10:FF:001442', NULL, NULL, 'Nischarin', NULL, NULL, NULL, NULL, NULL, 4),
(107948, NULL, 'G3DSA:3.90.260.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107949, NULL, 'G3DSA:3.30.160.60:FF:004471', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(107950, NULL, 'G3DSA:1.25.40.20:FF:000847', NULL, NULL, 'ankyrin repeat domain-containing protein 27-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(107951, NULL, 'G3DSA:1.10.10.440:FF:000068', NULL, NULL, 'Rho GTPase-activating protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(107952, NULL, 'G3DSA:3.40.50.1820:FF:001138', NULL, NULL, 'Lipase 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107953, NULL, 'G3DSA:1.10.510.10:FF:000292', NULL, NULL, 'Serine/threonine-protein kinase 36', NULL, NULL, NULL, NULL, NULL, 4),
(107954, NULL, 'G3DSA:4.10.400.10:FF:000238', NULL, NULL, 'LDL receptor related protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(107955, NULL, 'G3DSA:1.10.3210.10:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107956, NULL, 'G3DSA:1.10.510.10:FF:003978', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107957, NULL, 'G3DSA:1.20.144.10:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107958, NULL, 'G3DSA:3.40.50.300:FF:007849', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(107959, NULL, 'G3DSA:1.25.10.10:FF:000236', NULL, NULL, 'Vacuolar protein 8, variant', NULL, NULL, NULL, NULL, NULL, 4),
(107960, NULL, 'G3DSA:3.30.70.3490:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107961, NULL, 'G3DSA:1.20.140.150:FF:000107', NULL, NULL, 'Voltage-dependent calcium channel gamma-5 subunit-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(107962, NULL, 'G3DSA:3.40.190.10:FF:000330', NULL, NULL, 'Ionotropic receptor IR6', NULL, NULL, NULL, NULL, NULL, 4),
(107963, NULL, 'G3DSA:1.10.238.10:FF:000282', NULL, NULL, 'Endoplasmic reticulum-resident calcium binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(107964, NULL, 'G3DSA:3.40.30.10:FF:001181', NULL, NULL, 'Glutathione S-transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107965, NULL, 'G3DSA:2.60.40.60:FF:000282', NULL, NULL, 'Cadherin 96Cb, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(107966, NULL, 'G3DSA:4.10.640.10:FF:000019', NULL, NULL, 'Mitochondrial ribosomal protein S18', NULL, NULL, NULL, NULL, NULL, 4),
(107967, NULL, 'G3DSA:1.20.120.350:FF:000175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107968, NULL, 'G3DSA:1.25.10.10:FF:000910', NULL, NULL, 'DNA repair/transcription protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107969, NULL, 'G3DSA:3.60.15.10:FF:000037', NULL, NULL, 'tRNAse Z4', NULL, NULL, NULL, NULL, NULL, 4),
(107970, NULL, 'G3DSA:3.10.20.90:FF:000772', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 32', NULL, NULL, NULL, NULL, NULL, 4),
(107971, NULL, 'G3DSA:1.20.5.340:FF:000072', NULL, NULL, 'Tropomyosin 2', NULL, NULL, NULL, NULL, NULL, 4),
(107972, NULL, 'G3DSA:1.25.10.10:FF:000359', NULL, NULL, 'Protein-associating with the carboxyl-terminal domain of ezrin', NULL, NULL, NULL, NULL, NULL, 4),
(107973, NULL, 'G3DSA:3.40.50.11710:FF:000001', NULL, NULL, 'Cyclo(L-leucyl-L-leucyl) synthase', NULL, NULL, NULL, NULL, NULL, 4),
(107974, NULL, 'G3DSA:2.60.40.10:FF:000536', NULL, NULL, 'Hyaluronan and proteoglycan link protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(107975, NULL, 'G3DSA:2.40.30.130:FF:000042', NULL, NULL, 'Alanyl-tRNA synthetase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(107976, NULL, 'G3DSA:3.90.1170.20:FF:000016', NULL, NULL, 'Quinolinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(107977, NULL, 'G3DSA:2.60.120.620:FF:000038', NULL, NULL, 'YJR154W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(107978, NULL, 'G3DSA:2.70.170.10:FF:000045', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(107979, NULL, 'G3DSA:3.30.530.20:FF:000025', NULL, NULL, 'Phosphatidylinositol transfer protein beta', NULL, NULL, NULL, NULL, NULL, 4),
(107980, NULL, 'G3DSA:3.80.10.10:FF:003336', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107981, NULL, 'G3DSA:2.60.120.260:FF:000334', NULL, NULL, 'LOC51668 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107982, NULL, 'G3DSA:3.90.1170.10:FF:000013', NULL, NULL, 'Mitochondrial Ribosomal Protein, Large', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(107983, NULL, 'G3DSA:2.60.120.690:FF:000002', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 9', NULL, NULL, NULL, NULL, NULL, 4),
(107984, NULL, 'G3DSA:3.40.50.150:FF:000609', NULL, NULL, 'Putative nucleolar protein', NULL, NULL, NULL, NULL, NULL, 4),
(107985, NULL, 'G3DSA:3.40.50.2300:FF:001535', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107986, NULL, 'G3DSA:1.20.1690.10:FF:000008', NULL, NULL, 'V-type proton ATPase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(107987, NULL, 'G3DSA:1.20.120.530:FF:000010', NULL, NULL, 'Glc operon transcriptional activator', NULL, NULL, NULL, NULL, NULL, 4),
(107988, NULL, 'G3DSA:3.10.105.10:FF:000056', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(107989, NULL, 'G3DSA:3.30.70.330:FF:000501', NULL, NULL, 'Os04g0682400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(107990, NULL, 'G3DSA:1.10.4100.10:FF:000001', NULL, NULL, '2-methylcitrate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(107991, NULL, 'G3DSA:1.10.510.10:FF:004237', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(107992, NULL, 'G3DSA:1.10.418.10:FF:000150', NULL, NULL, 'Ras GTPase-activating-like protein, IQGAP family member, putative', NULL, NULL, NULL, NULL, NULL, 4),
(107993, NULL, 'G3DSA:2.30.29.30:FF:001377', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107994, NULL, 'G3DSA:3.90.1110.10:FF:000004', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(107995, NULL, 'G3DSA:3.10.350.10:FF:000001', NULL, NULL, 'Peptidoglycan-binding protein LysM', NULL, NULL, NULL, NULL, NULL, 4),
(107996, NULL, 'G3DSA:3.30.830.10:FF:000281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(107997, NULL, 'G3DSA:1.25.40.10:FF:002536', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(107998, NULL, 'G3DSA:3.40.850.10:FF:000105', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(107999, NULL, 'G3DSA:3.30.420.10:FF:000469', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108000, NULL, 'G3DSA:3.40.50.300:FF:008451', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(108001, NULL, 'G3DSA:1.20.1070.10:FF:001428', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108002, NULL, 'G3DSA:3.10.450.10:FF:000048', NULL, NULL, 'AGAP002879-PB', NULL, NULL, NULL, NULL, NULL, 4),
(108003, NULL, 'G3DSA:2.60.120.10:FF:000825', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108004, NULL, 'G3DSA:2.40.160.60:FF:000009', NULL, NULL, 'Outer membrane protein P1', NULL, NULL, NULL, NULL, NULL, 4),
(108005, NULL, 'G3DSA:3.40.50.300:FF:004073', NULL, NULL, 'UvrD/REP helicase N-terminal domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(108006, NULL, 'G3DSA:2.130.10.10:FF:000514', NULL, NULL, 'TORC1 growth control complex subunit Kog1', NULL, NULL, NULL, NULL, NULL, 4),
(108007, NULL, 'G3DSA:3.40.930.10:FF:000062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108008, NULL, 'G3DSA:2.130.10.10:FF:005399', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108009, NULL, 'G3DSA:2.30.30.1150:FF:000001', NULL, NULL, 'E3 ubiquitin-protein ligase UHRF2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(108010, NULL, 'G3DSA:2.60.40.60:FF:001012', NULL, NULL, 'Protein CBR-CDH-7', NULL, NULL, NULL, NULL, NULL, 4),
(108011, NULL, 'G3DSA:3.30.559.10:FF:000200', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(108012, NULL, 'G3DSA:2.30.42.10:FF:000261', NULL, NULL, 'general receptor for phosphoinositides 1-associated scaffold protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(108013, NULL, 'G3DSA:1.10.510.10:FF:000538', NULL, NULL, 'Casein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(108014, NULL, 'G3DSA:3.30.200.20:FF:000253', NULL, NULL, 'tribbles homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(108015, NULL, 'G3DSA:1.20.120.1200:FF:000004', NULL, NULL, 'NADH-quinone oxidoreductase subunit J', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(108016, NULL, 'G3DSA:1.10.630.10:FF:000699', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108017, NULL, 'G3DSA:3.20.80.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108018, NULL, 'G3DSA:1.20.58.80:FF:000074', NULL, NULL, 'Katanin p60 ATPase-containing subunit A1', NULL, NULL, NULL, NULL, NULL, 4),
(108019, NULL, 'G3DSA:2.20.70.10:FF:000130', NULL, NULL, 'Pre-mRNA-splicing factor dre4', NULL, NULL, NULL, NULL, NULL, 4),
(108020, NULL, 'G3DSA:1.20.210.10:FF:000002', NULL, NULL, 'Cytochrome o ubiquinol oxidase, subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(108021, NULL, 'G3DSA:1.10.10.10:FF:000842', NULL, NULL, 'Sst2p', NULL, NULL, NULL, NULL, NULL, 4),
(108022, NULL, 'G3DSA:3.40.50.300:FF:008546', NULL, NULL, 'Probable ribosome biogenesis GTPase A', NULL, NULL, NULL, NULL, NULL, 4),
(108023, NULL, 'G3DSA:1.25.10.10:FF:002613', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(108024, NULL, 'G3DSA:1.10.506.10:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108025, NULL, 'G3DSA:3.90.1100.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108026, NULL, 'G3DSA:3.40.395.10:FF:000047', NULL, NULL, 'Battenin', NULL, NULL, NULL, NULL, NULL, 4),
(108027, NULL, 'G3DSA:1.10.30.10:FF:000063', NULL, NULL, 'High mobility group protein B3', NULL, NULL, NULL, NULL, NULL, 4),
(108028, NULL, 'G3DSA:3.30.450.40:FF:000305', NULL, NULL, 'Putative signaling protein', NULL, NULL, NULL, NULL, NULL, 4),
(108029, NULL, 'G3DSA:3.40.50.150:FF:000514', NULL, NULL, 'Rhamnosyl O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(108030, NULL, 'G3DSA:1.20.58.70:FF:000071', NULL, NULL, 'Putative second mitochondria-derived activator of caspase', NULL, NULL, NULL, NULL, NULL, 4),
(108031, NULL, 'G3DSA:3.90.70.10:FF:000512', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(108032, NULL, 'G3DSA:2.40.50.140:FF:000352', NULL, NULL, 'CST complex subunit STN1', NULL, NULL, NULL, NULL, NULL, 4),
(108033, NULL, 'G3DSA:1.25.40.10:FF:002115', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g62720', NULL, NULL, NULL, NULL, NULL, 4),
(108034, NULL, 'G3DSA:2.60.40.10:FF:004914', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108035, NULL, 'G3DSA:3.40.50.880:FF:000154', NULL, NULL, 'Putative glutamine amidotransferase GAT1_2.1', NULL, NULL, NULL, NULL, NULL, 4),
(108036, NULL, 'G3DSA:3.40.50.1000:FF:000616', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108037, NULL, 'G3DSA:1.10.8.270:FF:000053', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(108038, NULL, 'G3DSA:1.20.1600.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108039, NULL, 'G3DSA:2.60.40.60:FF:000074', NULL, NULL, 'Desmoglein 4', NULL, NULL, NULL, NULL, NULL, 4),
(108040, NULL, 'G3DSA:3.20.20.70:FF:000575', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108041, NULL, 'G3DSA:3.30.200.20:FF:001776', NULL, NULL, 'Tyrosine-protein kinase-like otk', NULL, NULL, NULL, NULL, NULL, 4),
(108042, NULL, 'G3DSA:3.40.50.1000:FF:000830', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108043, NULL, 'G3DSA:1.10.10.60:FF:000166', NULL, NULL, 'homeobox protein Hox-C11', NULL, NULL, NULL, NULL, NULL, 4),
(108044, NULL, 'G3DSA:3.30.160.60:FF:006376', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108045, NULL, 'G3DSA:1.10.472.10:FF:000292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108046, NULL, 'G3DSA:3.10.129.10:FF:000150', NULL, NULL, 'Acyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(108047, NULL, 'G3DSA:3.40.50.300:FF:004168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108048, NULL, 'G3DSA:3.40.50.300:FF:000469', NULL, NULL, 'MAGUK p55 subfamily member 5', NULL, NULL, NULL, NULL, NULL, 4),
(108049, NULL, 'G3DSA:1.10.510.10:FF:004142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108050, NULL, 'G3DSA:3.40.1500.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(108051, NULL, 'G3DSA:2.120.10.80:FF:000344', NULL, NULL, 'Multiple EGF-like-domains 8', NULL, NULL, NULL, NULL, NULL, 4),
(108052, NULL, 'G3DSA:1.10.10.1540:FF:000005', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(108053, NULL, 'G3DSA:3.40.140.10:FF:000254', NULL, NULL, 'Cytidine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(108054, NULL, 'G3DSA:1.25.40.10:FF:000412', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(108055, NULL, 'G3DSA:3.40.50.2000:FF:000124', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(108056, NULL, 'G3DSA:2.130.10.10:FF:000177', NULL, NULL, 'WD repeat domain 3', NULL, NULL, NULL, NULL, NULL, 4),
(108057, NULL, 'G3DSA:1.20.1250.20:FF:000006', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(108058, NULL, 'G3DSA:1.20.1070.10:FF:001333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108059, NULL, 'G3DSA:3.30.1390.10:FF:000015', NULL, NULL, '60S ribosomal protein L7/L12, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108060, NULL, 'G3DSA:3.90.70.10:FF:000607', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108061, NULL, 'G3DSA:1.10.238.10:FF:000731', NULL, NULL, '45 kDa calcium-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(108062, NULL, 'G3DSA:3.10.150.10:FF:000020', NULL, NULL, 'Beta sliding clamp', NULL, NULL, NULL, NULL, NULL, 4),
(108063, NULL, 'G3DSA:2.40.50.740:FF:000009', NULL, NULL, '30S ribosomal protein S4e', NULL, NULL, NULL, NULL, NULL, 4),
(108064, NULL, 'G3DSA:3.90.930.12:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108065, NULL, 'G3DSA:1.10.287.70:FF:000002', NULL, NULL, 'Potassium voltage-gated channel subfamily a member', NULL, NULL, NULL, NULL, NULL, 4),
(108066, NULL, 'G3DSA:3.40.50.300:FF:001200', NULL, NULL, 'Conjugal transfer protein TraB', NULL, NULL, NULL, NULL, NULL, 4),
(108067, NULL, 'G3DSA:3.30.565.10:FF:000260', NULL, NULL, 'Histidine kinase sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(108068, NULL, 'G3DSA:2.60.120.200:FF:000699', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(108069, NULL, 'G3DSA:2.30.180.10:FF:000077', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(108070, NULL, 'G3DSA:1.10.287.80:FF:000005', NULL, NULL, 'ATP synthase gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(108071, NULL, 'G3DSA:3.90.79.10:FF:000144', NULL, NULL, 'MutT/nudix family protein', NULL, NULL, NULL, NULL, NULL, 4),
(108072, NULL, 'G3DSA:2.60.40.10:FF:000750', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(108073, NULL, 'G3DSA:2.60.40.790:FF:000170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108074, NULL, 'G3DSA:4.10.860.10:FF:000002', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4),
(108075, NULL, 'G3DSA:2.60.40.10:FF:000862', NULL, NULL, 'interleukin-12 receptor subunit beta-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(108076, NULL, 'G3DSA:3.10.170.20:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108077, NULL, 'G3DSA:3.30.1390.20:FF:000018', NULL, NULL, 'LSU ribosomal protein L7', NULL, NULL, NULL, NULL, NULL, 4),
(108078, NULL, 'G3DSA:3.30.70.330:FF:002160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108079, NULL, 'G3DSA:2.40.50.730:FF:000006', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(108080, NULL, 'G3DSA:3.30.40.10:FF:000035', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(108081, NULL, 'G3DSA:4.10.60.10:FF:000153', NULL, NULL, 'Cold shock domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(108082, NULL, 'G3DSA:1.10.3720.10:FF:000060', NULL, NULL, 'Inner membrane ABC transporter permease YehY', NULL, NULL, NULL, NULL, NULL, 4),
(108083, NULL, 'G3DSA:2.40.30.10:FF:000323', NULL, NULL, 'Translation initiation factor IF-2', NULL, NULL, NULL, NULL, NULL, 4),
(108084, NULL, 'G3DSA:3.30.1370.10:FF:000132', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(108085, NULL, 'G3DSA:3.40.50.1000:FF:000279', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(108086, NULL, 'G3DSA:3.30.420.40:FF:000803', NULL, NULL, 'Actin-related protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(108087, NULL, 'G3DSA:1.20.950.20:FF:000010', NULL, NULL, 'Nitrate reductase NarX', NULL, NULL, NULL, NULL, NULL, 4),
(108088, NULL, 'G3DSA:2.30.39.10:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108089, NULL, 'G3DSA:2.120.10.30:FF:000032', NULL, NULL, 'Protein STRICTOSIDINE SYNTHASE-LIKE 13', NULL, NULL, NULL, NULL, NULL, 4),
(108090, NULL, 'G3DSA:1.10.510.10:FF:003040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108091, NULL, 'G3DSA:1.10.357.70:FF:000014', NULL, NULL, 'Exocyst complex component, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108092, NULL, 'G3DSA:2.60.260.20:FF:000181', NULL, NULL, 'Chaperone protein dnaJ 3', NULL, NULL, NULL, NULL, NULL, 4),
(108093, NULL, 'G3DSA:3.50.50.60:FF:000140', NULL, NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(108094, NULL, 'G3DSA:3.30.1330.20:FF:000026', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(108095, NULL, 'G3DSA:1.10.287.90:FF:000008', NULL, NULL, 'Cytochrome c oxidase subunit 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108096, NULL, 'G3DSA:3.30.160.60:FF:004673', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108097, NULL, 'G3DSA:3.30.160.60:FF:002902', NULL, NULL, 'KLUmpfuss related', NULL, NULL, NULL, NULL, NULL, 4),
(108098, NULL, 'G3DSA:2.40.50.430:FF:000006', NULL, NULL, 'DNA polymerase delta small subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108099, NULL, 'G3DSA:3.40.50.1820:FF:001155', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(108100, NULL, 'G3DSA:1.20.120.1640:FF:000001', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(108101, NULL, 'G3DSA:3.40.50.300:FF:000806', NULL, NULL, 'DNA repair protein RAD51 homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(108102, NULL, 'G3DSA:1.25.40.20:FF:000741', NULL, NULL, 'Ankyrin repeat domain 6b', NULL, NULL, NULL, NULL, NULL, 4),
(108103, NULL, 'G3DSA:1.10.3730.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108104, NULL, 'G3DSA:3.90.430.10:FF:000001', NULL, NULL, 'Copper fist DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(108105, NULL, 'G3DSA:4.10.860.20:FF:000005', NULL, NULL, 'LD29542p', NULL, NULL, NULL, NULL, NULL, 4),
(108106, NULL, 'G3DSA:1.10.275.10:FF:000019', NULL, NULL, 'Putative mitochondrial-processing peptidase subunit beta mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(108107, NULL, 'G3DSA:3.80.10.10:FF:003662', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(108108, NULL, 'G3DSA:3.30.1330.60:FF:000009', NULL, NULL, 'Flagellar motor protein MotB', NULL, NULL, NULL, NULL, NULL, 4),
(108109, NULL, 'G3DSA:3.30.40.10:FF:001137', NULL, NULL, 'Vacuolar segregation protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108110, NULL, 'G3DSA:1.25.40.10:FF:003964', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108111, NULL, 'G3DSA:2.130.10.10:FF:002431', NULL, NULL, 'ELP2 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(108112, NULL, 'G3DSA:1.10.1170.10:FF:000016', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(108113, NULL, 'G3DSA:2.30.30.30:FF:000150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108114, NULL, 'G3DSA:3.40.50.300:FF:006422', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(108115, NULL, 'G3DSA:3.30.160.60:FF:005775', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108116, NULL, 'G3DSA:1.10.510.10:FF:000185', NULL, NULL, 'Ribosomal protein S6 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(108117, NULL, 'G3DSA:3.10.20.740:FF:000001', NULL, NULL, 'NADH-quinone oxidoreductase subunit G', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(108118, NULL, 'G3DSA:1.20.1310.10:FF:000060', NULL, NULL, 'Ubiquitin-protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108119, NULL, 'G3DSA:3.10.100.10:FF:000067', NULL, NULL, 'lymphocyte antigen 75 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(108120, NULL, 'G3DSA:1.10.8.60:FF:000429', NULL, NULL, 'peroxisome biogenesis protein 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(108121, NULL, 'G3DSA:2.120.10.80:FF:000018', NULL, NULL, 'Muskelin 1', NULL, NULL, NULL, NULL, NULL, 4),
(108122, NULL, 'G3DSA:2.160.10.10:FF:000029', NULL, NULL, 'Trimeric LpxA-like enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(108123, NULL, 'G3DSA:2.60.120.1440:FF:000008', NULL, NULL, 'FecR family protein', NULL, NULL, NULL, NULL, NULL, 4),
(108124, NULL, 'G3DSA:2.40.10.10:FF:000086', NULL, NULL, 'serine protease hepsin', NULL, NULL, NULL, NULL, NULL, 4),
(108125, NULL, 'G3DSA:1.25.40.20:FF:001016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108126, NULL, 'G3DSA:1.10.443.20:FF:000003', NULL, NULL, 'Centromere DNA-binding protein complex CBF3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(108127, NULL, 'G3DSA:3.30.160.60:FF:000648', NULL, NULL, 'Zinc finger protein rotund', NULL, NULL, NULL, NULL, NULL, 4),
(108128, NULL, 'G3DSA:3.10.50.40:FF:000057', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(108129, NULL, 'G3DSA:1.10.490.10:FF:000030', NULL, NULL, 'Blr4883 protein', NULL, NULL, NULL, NULL, NULL, 4),
(108130, NULL, 'G3DSA:1.20.58.670:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108131, NULL, 'G3DSA:3.40.190.290:FF:000030', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(108132, NULL, 'G3DSA:3.30.1330.10:FF:000023', NULL, NULL, 'Putative selenophosphate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(108133, NULL, 'G3DSA:1.20.120.30:FF:000001', NULL, NULL, 'Methyl-accepting chemotaxis protein II', NULL, NULL, NULL, NULL, NULL, 4),
(108134, NULL, 'G3DSA:3.40.50.1000:FF:000504', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108135, NULL, 'G3DSA:3.60.21.10:FF:000097', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(108136, NULL, 'G3DSA:3.10.100.10:FF:000281', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108137, NULL, 'G3DSA:1.20.1260.140:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108138, NULL, 'G3DSA:2.60.40.1170:FF:000028', NULL, NULL, 'Coatomer subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(108139, NULL, 'G3DSA:3.30.505.10:FF:000267', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108140, NULL, 'G3DSA:3.80.10.10:FF:003241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108141, NULL, 'G3DSA:3.40.640.10:FF:000410', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108142, NULL, 'G3DSA:1.10.10.1100:FF:000008', NULL, NULL, 'Nitrogen fixation protein NifU', NULL, NULL, NULL, NULL, NULL, 4),
(108143, NULL, 'G3DSA:2.130.10.10:FF:000840', NULL, NULL, 'Related to CAF4-CCR4 associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(108144, NULL, 'G3DSA:3.30.730.10:FF:000003', NULL, NULL, 'AP2-like ethylene-responsive transcription factor ANT', NULL, NULL, NULL, NULL, NULL, 4),
(108145, NULL, 'G3DSA:3.40.850.10:FF:000010', NULL, NULL, 'Kinesin family member 13A', NULL, NULL, NULL, NULL, NULL, 4),
(108146, NULL, 'G3DSA:3.40.50.300:FF:006197', NULL, NULL, 'Rcorf28', NULL, NULL, NULL, NULL, NULL, 4),
(108147, NULL, 'G3DSA:3.40.50.300:FF:006208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108148, NULL, 'G3DSA:1.20.120.1750:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108149, NULL, 'G3DSA:3.30.70.330:FF:002272', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108150, NULL, 'G3DSA:3.40.30.10:FF:001074', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(108151, NULL, 'G3DSA:1.20.5.4770:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(108152, NULL, 'G3DSA:2.10.220.10:FF:000097', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(108153, NULL, 'G3DSA:3.90.1310.10:FF:000002', NULL, NULL, 'Peptidoglycan D,D-transpeptidase FtsI', NULL, NULL, NULL, NULL, NULL, 4),
(108154, NULL, 'G3DSA:1.20.1280.50:FF:000169', NULL, NULL, 'Putative f-box protein 31', NULL, NULL, NULL, NULL, NULL, 4),
(108155, NULL, 'G3DSA:3.30.70.980:FF:000005', NULL, NULL, 'Probable transcriptional regulatory protein EDB18_6789', NULL, NULL, NULL, NULL, NULL, 4),
(108156, NULL, 'G3DSA:3.40.390.10:FF:000300', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108157, NULL, 'G3DSA:1.25.10.10:FF:002708', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108158, NULL, 'G3DSA:2.130.10.10:FF:002526', NULL, NULL, 'Intraflagellar transport 172', NULL, NULL, NULL, NULL, NULL, 4),
(108159, NULL, 'G3DSA:3.90.290.10:FF:000012', NULL, NULL, 'latent-transforming growth factor beta-binding protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(108160, NULL, 'G3DSA:3.90.550.10:FF:000627', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(108161, NULL, 'G3DSA:3.40.50.80:FF:000011', NULL, NULL, 'Sulfite reductase flavoprotein component', NULL, NULL, NULL, NULL, NULL, 4),
(108162, NULL, 'G3DSA:1.10.238.10:FF:000826', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108163, NULL, 'G3DSA:2.130.10.10:FF:001020', NULL, NULL, 'Intraflagellar transport protein 122 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(108164, NULL, 'G3DSA:2.30.30.40:FF:000153', NULL, NULL, 'rho guanine nucleotide exchange factor 26', NULL, NULL, NULL, NULL, NULL, 4),
(108165, NULL, 'G3DSA:2.60.120.10:FF:000488', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108166, NULL, 'G3DSA:3.40.50.300:FF:005011', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(108167, NULL, 'G3DSA:3.30.70.330:FF:000029', NULL, NULL, 'U2 small nuclear ribonucleoprotein B''''', NULL, NULL, NULL, NULL, NULL, 4),
(108168, NULL, 'G3DSA:3.40.50.300:FF:002156', NULL, NULL, 'DNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108169, NULL, 'G3DSA:2.130.10.10:FF:000391', NULL, NULL, 'sterol regulatory element-binding protein cleavage-activating protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(108170, NULL, 'G3DSA:1.20.1250.20:FF:001760', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(108171, NULL, 'G3DSA:1.10.287.1490:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108172, NULL, 'G3DSA:2.60.40.10:FF:000424', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(108173, NULL, 'G3DSA:3.40.50.11030:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108174, NULL, 'G3DSA:1.20.1070.10:FF:001900', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108175, NULL, 'G3DSA:1.10.1170.10:FF:000033', NULL, NULL, 'Apoptosis inhibitor IAP, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108176, NULL, 'G3DSA:3.30.160.60:FF:003858', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108177, NULL, 'G3DSA:1.10.486.10:FF:000020', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(108178, NULL, 'G3DSA:1.10.10.10:FF:000275', NULL, NULL, 'CST complex subunit STN1', NULL, NULL, NULL, NULL, NULL, 4),
(108179, NULL, 'G3DSA:1.25.40.690:FF:000015', NULL, NULL, 'Npp-10', NULL, NULL, NULL, NULL, NULL, 4),
(108180, NULL, 'G3DSA:1.25.10.10:FF:000247', NULL, NULL, 'calcium-binding protein 39', NULL, NULL, NULL, NULL, NULL, 4),
(108181, NULL, 'G3DSA:2.60.40.10:FF:000648', NULL, NULL, 'Intercellular adhesion molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(108182, NULL, 'G3DSA:3.10.20.90:FF:000660', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108183, NULL, 'G3DSA:2.130.10.10:FF:002105', NULL, NULL, 'Paralyzed flagella protein 20', NULL, NULL, NULL, NULL, NULL, 4),
(108184, NULL, 'G3DSA:1.20.58.870:FF:000005', NULL, NULL, 'Putative DNA replication licensing factor', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(108185, NULL, 'G3DSA:2.70.170.10:FF:000157', NULL, NULL, 'CHRNA7-FAM7A fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(108186, NULL, 'G3DSA:2.60.120.260:FF:000222', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(108187, NULL, 'G3DSA:3.80.10.10:FF:001324', NULL, NULL, 'PH domain leucine-rich repeat protein phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(108188, NULL, 'G3DSA:1.20.1050.10:FF:000022', NULL, NULL, 'ganglioside-induced differentiation-associated protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(108189, NULL, 'G3DSA:2.30.30.140:FF:000199', NULL, NULL, 'Tudor, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(108190, NULL, 'G3DSA:3.40.630.30:FF:000691', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108191, NULL, 'G3DSA:3.20.20.120:FF:000015', NULL, NULL, 'Bifunctional D-altronate/D-mannonate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(108192, NULL, 'G3DSA:1.20.58.1180:FF:000001', NULL, NULL, 'Mitochondrial large ribosomal subunit YmL35', NULL, NULL, NULL, NULL, NULL, 4),
(108193, NULL, 'G3DSA:3.30.420.40:FF:000680', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(108194, NULL, 'G3DSA:1.10.1070.11:FF:000100', NULL, NULL, 'Putative actin-fragmin kinase DDB_G0279609', NULL, NULL, NULL, NULL, NULL, 4),
(108195, NULL, 'G3DSA:1.25.40.10:FF:004453', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108196, NULL, 'G3DSA:3.90.1410.10:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108197, NULL, 'G3DSA:1.10.510.10:FF:004349', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108198, NULL, 'G3DSA:1.10.238.10:FF:000164', NULL, NULL, 'Serine/threonine-protein phosphatase with EF-hands', NULL, NULL, NULL, NULL, NULL, 4),
(108199, NULL, 'G3DSA:2.60.40.10:FF:002902', NULL, NULL, 'GM25484', NULL, NULL, NULL, NULL, NULL, 4),
(108200, NULL, 'G3DSA:1.20.5.100:FF:000028', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(108201, NULL, 'G3DSA:2.10.25.10:FF:001228', NULL, NULL, 'Fibulin 1', NULL, NULL, NULL, NULL, NULL, 4),
(108202, NULL, 'G3DSA:3.40.30.10:FF:000259', NULL, NULL, 'Thioredoxin-like protein Clot', NULL, NULL, NULL, NULL, NULL, 4),
(108203, NULL, 'G3DSA:3.60.21.10:FF:000338', NULL, NULL, 'Purple acid phosphatase 5', NULL, NULL, NULL, NULL, NULL, 4),
(108204, NULL, 'G3DSA:2.60.40.1180:FF:000048', NULL, NULL, 'Isoamylase 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(108205, NULL, 'G3DSA:2.30.29.230:FF:000004', NULL, NULL, 'TBC1 domain family, member 16', NULL, NULL, NULL, NULL, NULL, 4),
(108206, NULL, 'G3DSA:3.40.50.2300:FF:000450', NULL, NULL, 'Response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(108207, NULL, 'G3DSA:3.90.190.20:FF:000052', NULL, NULL, 'Folylpolyglutamate synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108208, NULL, 'G3DSA:3.90.550.10:FF:000274', NULL, NULL, 'Glycosyl transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(108209, NULL, 'G3DSA:3.40.50.150:FF:000391', NULL, NULL, 'General transcriptional corepressor tupA', NULL, NULL, NULL, NULL, NULL, 4),
(108210, NULL, 'G3DSA:1.10.630.10:FF:000002', NULL, NULL, 'Cytochrome P450 1A1', NULL, NULL, NULL, NULL, NULL, 4),
(108211, NULL, 'G3DSA:3.30.450.40:FF:000182', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(108212, NULL, 'G3DSA:1.20.58.860:FF:000002', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(108213, NULL, 'G3DSA:3.30.160.60:FF:000862', NULL, NULL, 'zinc finger protein 697', NULL, NULL, NULL, NULL, NULL, 4),
(108214, NULL, 'G3DSA:2.10.60.10:FF:000068', NULL, NULL, 'Serine/threonine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(108215, NULL, 'G3DSA:3.40.50.10860:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108216, NULL, 'G3DSA:3.40.50.1000:FF:000493', NULL, NULL, 'Phospholipid-transporting ATPase IA, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108217, NULL, 'G3DSA:2.130.10.10:FF:001003', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(108218, NULL, 'G3DSA:2.30.29.240:FF:000007', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(108219, NULL, 'G3DSA:1.10.510.10:FF:000426', NULL, NULL, 'Receptor-type tyrosine-protein kinase FLT3', NULL, NULL, NULL, NULL, NULL, 4),
(108220, NULL, 'G3DSA:2.60.40.1170:FF:000045', NULL, NULL, 'Probable coatomer subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(108221, NULL, 'G3DSA:3.30.1370.240:FF:000006', NULL, NULL, 'Phenylalanyl-tRNA synthetase alpha chain B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108222, NULL, 'G3DSA:1.10.287.110:FF:000223', NULL, NULL, 'Meiotically up-regulated gene 185 protein', NULL, NULL, NULL, NULL, NULL, 4),
(108223, NULL, 'G3DSA:2.60.40.150:FF:000326', NULL, NULL, 'Copine i-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(108224, NULL, 'G3DSA:3.40.50.620:FF:000104', NULL, NULL, 'Mitochondrial tRNA-specific 2-thiouridylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(108225, NULL, 'G3DSA:3.30.40.10:FF:000052', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(108226, NULL, 'G3DSA:1.10.150.240:FF:000122', NULL, NULL, 'Gll0254 protein', NULL, NULL, NULL, NULL, NULL, 4),
(108227, NULL, 'G3DSA:3.30.70.1320:FF:000007', NULL, NULL, 'Probable RND efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(108228, NULL, 'G3DSA:2.40.180.10:FF:000018', NULL, NULL, 'Catalase-related peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(108229, NULL, 'G3DSA:1.10.10.60:FF:000380', NULL, NULL, 'Brinker', NULL, NULL, NULL, NULL, NULL, 4),
(108230, NULL, 'G3DSA:3.30.9.10:FF:000098', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(108231, NULL, 'G3DSA:1.20.120.1750:FF:000034', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(108232, NULL, 'G3DSA:3.90.1290.10:FF:000062', NULL, NULL, 'Microtubule-actin crosslinking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(108233, NULL, 'G3DSA:3.80.20.20:FF:000057', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(108234, NULL, 'G3DSA:3.10.20.30:FF:000114', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108235, NULL, 'G3DSA:2.10.110.10:FF:000122', NULL, NULL, 'LIM domain and actin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(108236, NULL, 'G3DSA:1.20.1530.20:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108237, NULL, 'G3DSA:1.50.40.10:FF:000466', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108238, NULL, 'G3DSA:3.40.532.10:FF:000013', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(108239, NULL, 'G3DSA:3.30.70.890:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108240, NULL, 'G3DSA:1.20.120.1760:FF:000037', NULL, NULL, 'CDP-alcohol phosphatidyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(108241, NULL, 'G3DSA:2.60.40.10:FF:002453', NULL, NULL, 'KETtiN (Drosophila actin-binding) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(108242, NULL, 'G3DSA:3.90.226.10:FF:000352', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(108243, NULL, 'G3DSA:3.30.70.520:FF:000002', NULL, NULL, 'Formylmethanofuran--tetrahydromethanopterin formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(108244, NULL, 'G3DSA:3.30.200.20:FF:001990', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(108245, NULL, 'G3DSA:2.130.10.10:FF:006028', NULL, NULL, 'Probable elongator complex protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(108246, NULL, 'G3DSA:1.25.40.120:FF:000098', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(108247, NULL, 'G3DSA:3.80.10.10:FF:001650', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108248, NULL, 'G3DSA:2.80.10.50:FF:000175', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(108249, NULL, 'G3DSA:3.40.50.300:FF:006085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(108250, NULL, 'G3DSA:3.10.450.10:FF:000065', NULL, NULL, 'Kininogen 1', NULL, NULL, NULL, NULL, NULL, 4),
(108251, NULL, 'G3DSA:1.10.510.10:FF:000752', NULL, NULL, 'Obscurin isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(108252, NULL, 'G3DSA:3.90.550.50:FF:000050', NULL, NULL, 'Beta-1,3-galactosyltransferase 4', NULL, NULL, NULL, NULL, NULL, 4),
(108253, NULL, 'G3DSA:3.10.100.10:FF:000404', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108254, NULL, 'G3DSA:3.30.70.330:FF:001457', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108255, NULL, 'G3DSA:3.30.70.1300:FF:000001', NULL, NULL, 'UPF0301 protein YqgE', NULL, NULL, NULL, NULL, NULL, 4),
(108256, NULL, 'G3DSA:3.40.50.1820:FF:001481', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108257, NULL, 'G3DSA:1.10.510.10:FF:002904', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108258, NULL, 'G3DSA:2.70.150.10:FF:000257', NULL, NULL, 'E1-E2 ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108259, NULL, 'G3DSA:3.10.580.10:FF:000069', NULL, NULL, 'CBS domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(108260, NULL, 'G3DSA:3.30.160.60:FF:004914', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108261, NULL, 'G3DSA:1.10.238.10:FF:000490', NULL, NULL, 'N-terminal EF-hand calcium binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(108262, NULL, 'G3DSA:3.30.230.70:FF:000163', NULL, NULL, 'Exosome complex component RRP42-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(108263, NULL, 'G3DSA:2.130.10.120:FF:000018', NULL, NULL, 'Protease 2', NULL, NULL, NULL, NULL, NULL, 4),
(108264, NULL, 'G3DSA:3.90.79.10:FF:000032', NULL, NULL, 'Nudix hydrolase 25', NULL, NULL, NULL, NULL, NULL, 4),
(108265, NULL, 'G3DSA:3.30.160.60:FF:000295', NULL, NULL, 'zinc finger protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(108266, NULL, 'G3DSA:1.10.40.60:FF:000005', NULL, NULL, 'Type II secretion system protein K', NULL, NULL, NULL, NULL, NULL, 4),
(108267, NULL, 'G3DSA:1.10.40.50:FF:000002', NULL, NULL, 'Minichromosome maintenance (MCM2/3/5) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(108268, NULL, 'G3DSA:2.110.10.10:FF:000015', NULL, NULL, 'Matrix metallopeptidase 21', NULL, NULL, NULL, NULL, NULL, 4),
(108269, NULL, 'G3DSA:3.30.70.3250:FF:000007', NULL, NULL, 'Ribonuclease P protein component 2', NULL, NULL, NULL, NULL, NULL, 4),
(108270, NULL, 'G3DSA:2.10.110.10:FF:000105', NULL, NULL, 'Similar to LIM domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(108271, NULL, 'G3DSA:1.10.490.10:FF:000013', NULL, NULL, 'Globin, protozoan/cyanobacterial family', NULL, NULL, NULL, NULL, NULL, 4),
(108272, NULL, 'G3DSA:3.90.1140.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108273, NULL, 'G3DSA:2.60.40.150:FF:000343', NULL, NULL, 'Tcb3p', NULL, NULL, NULL, NULL, NULL, 4),
(108274, NULL, 'G3DSA:1.25.10.10:FF:001984', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108275, NULL, 'G3DSA:1.10.10.60:FF:000503', NULL, NULL, 'Myb-like transcription factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(108276, NULL, 'G3DSA:1.25.10.10:FF:002260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108277, NULL, 'G3DSA:3.90.1100.10:FF:000048', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(108278, NULL, 'G3DSA:2.40.50.180:FF:000010', NULL, NULL, 'Chemotaxis protein CheW', NULL, NULL, NULL, NULL, NULL, 4),
(108279, NULL, 'G3DSA:3.40.50.300:FF:003212', NULL, NULL, 'Putative cleavage/polyadenylation factor ia subunit clp1p', NULL, NULL, NULL, NULL, NULL, 4),
(108280, NULL, 'G3DSA:3.40.630.10:FF:000241', NULL, NULL, 'Metalloprotease', NULL, NULL, NULL, NULL, NULL, 4),
(108281, NULL, 'G3DSA:3.10.100.10:FF:000308', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108282, NULL, 'G3DSA:2.60.120.40:FF:000031', NULL, NULL, 'Tumor necrosis factor ligand superfamily member 14', NULL, NULL, NULL, NULL, NULL, 4),
(108283, NULL, 'G3DSA:3.30.1370.10:FF:000020', NULL, NULL, 'RNA-binding protein Nova-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(108284, NULL, 'G3DSA:3.60.40.10:FF:000377', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108285, NULL, 'G3DSA:1.20.144.10:FF:000005', NULL, NULL, 'phospholipid phosphatase-related protein type 1', NULL, NULL, NULL, NULL, NULL, 4),
(108286, NULL, 'G3DSA:2.60.40.10:FF:000199', NULL, NULL, 'next to BRCA1 gene 1 protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(108287, NULL, 'G3DSA:3.30.260.10:FF:000012', NULL, NULL, 'T-complex protein 1 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(108288, NULL, 'G3DSA:3.90.70.10:FF:000719', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108289, NULL, 'G3DSA:1.10.720.60:FF:000013', NULL, NULL, 'Putative bifunctional methylthioribulose-1-phosphate dehydratase/enolase-phosphatase E1', NULL, NULL, NULL, NULL, NULL, 4),
(108290, NULL, 'G3DSA:3.40.50.720:FF:001192', NULL, NULL, 'Short chain oxidoreductase (CsgA), putative (AFU_orthologue AFUA_4G00910)', NULL, NULL, NULL, NULL, NULL, 4),
(108291, NULL, 'G3DSA:3.40.190.10:FF:000077', NULL, NULL, 'Peptide ABC transporter substrate-binding protein SapA', NULL, NULL, NULL, NULL, NULL, 4),
(108292, NULL, 'G3DSA:3.40.50.1000:FF:000167', NULL, NULL, 'Sucrose-phosphate synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(108293, NULL, 'G3DSA:2.40.30.10:FF:000306', NULL, NULL, '60S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(108294, NULL, 'G3DSA:3.30.497.10:FF:000101', NULL, NULL, 'AGAP007691-PB', NULL, NULL, NULL, NULL, NULL, 4),
(108295, NULL, 'G3DSA:2.170.120.20:FF:000004', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(108296, NULL, 'G3DSA:1.10.238.150:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108297, NULL, 'G3DSA:3.40.50.300:FF:004494', NULL, NULL, 'ATP-dependent DEAD/H RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108298, NULL, 'G3DSA:3.40.50.300:FF:002723', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(108299, NULL, 'G3DSA:1.20.1250.20:FF:001529', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108300, NULL, 'G3DSA:1.25.10.10:FF:000573', NULL, NULL, 'Ran-binding protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(108301, NULL, 'G3DSA:2.80.10.50:FF:000192', NULL, NULL, 'Lymphocyte antigen 75', NULL, NULL, NULL, NULL, NULL, 4),
(108302, NULL, 'G3DSA:3.40.1090.10:FF:000035', NULL, NULL, 'Lysophospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(108303, NULL, 'G3DSA:3.40.1360.10:FF:000028', NULL, NULL, 'DNA primase DnaG', NULL, NULL, NULL, NULL, NULL, 4),
(108304, NULL, 'G3DSA:3.40.30.10:FF:001102', NULL, NULL, 'Glutathione S-transferase L2 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(108305, NULL, 'G3DSA:3.90.105.10:FF:000004', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(108306, NULL, 'G3DSA:2.40.10.10:FF:000423', NULL, NULL, 'Female reproductive tract protease', NULL, NULL, NULL, NULL, NULL, 4),
(108307, NULL, 'G3DSA:1.25.40.10:FF:000075', NULL, NULL, 'Crooked neck pre-mRNA-splicing factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(108308, NULL, 'G3DSA:3.50.50.60:FF:000252', NULL, NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(108309, NULL, 'G3DSA:3.30.565.10:FF:000372', NULL, NULL, 'Sensor box histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(108310, NULL, 'G3DSA:2.30.30.40:FF:000506', NULL, NULL, 'Abl protein tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(108311, NULL, 'G3DSA:3.40.120.10:FF:000045', NULL, NULL, 'Phosphoglucomutase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108312, NULL, 'G3DSA:2.30.310.10:FF:000009', NULL, NULL, 'RNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(108313, NULL, 'G3DSA:2.60.120.1190:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108314, NULL, 'G3DSA:3.90.79.10:FF:000239', NULL, NULL, 'Slr2078 protein', NULL, NULL, NULL, NULL, NULL, 4),
(108315, NULL, 'G3DSA:2.130.10.10:FF:002189', NULL, NULL, 'Protein CBR-NOL-10', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(108316, NULL, 'G3DSA:2.30.30.40:FF:000170', NULL, NULL, 'ABI gene family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(108317, NULL, 'G3DSA:4.10.400.10:FF:000356', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108318, NULL, 'G3DSA:3.40.30.10:FF:000826', NULL, NULL, 'Protein disulfide isomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(108319, NULL, 'G3DSA:3.40.50.1820:FF:001610', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108320, NULL, 'G3DSA:3.40.50.150:FF:000935', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108321, NULL, 'G3DSA:3.30.200.20:FF:000141', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(108322, NULL, 'G3DSA:2.130.10.10:FF:002543', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One component system)', NULL, NULL, NULL, NULL, NULL, 4),
(108323, NULL, 'G3DSA:3.40.50.1100:FF:000079', NULL, NULL, 'Putative pyridoxal-phosphate dependent protein F13B12.4', NULL, NULL, NULL, NULL, NULL, 4),
(108324, NULL, 'G3DSA:3.40.1410.10:FF:000010', NULL, NULL, 'Phosphonate utilization transcriptional regulator PhnR', NULL, NULL, NULL, NULL, NULL, 4),
(108325, NULL, 'G3DSA:1.10.287.990:FF:000003', NULL, NULL, 'Superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(108326, NULL, 'G3DSA:3.30.70.100:FF:000096', NULL, NULL, 'Putative ATP dependent copper transporter', NULL, NULL, NULL, NULL, NULL, 4),
(108327, NULL, 'G3DSA:3.30.565.10:FF:000501', NULL, NULL, 'PMS1 homolog 1, mismatch repair system component', NULL, NULL, NULL, NULL, NULL, 4),
(108328, NULL, 'G3DSA:3.90.550.10:FF:000403', NULL, NULL, 'Translation initiation factor eIF-2B subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(108329, NULL, 'G3DSA:1.20.920.30:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108330, NULL, 'G3DSA:3.40.640.10:FF:000073', NULL, NULL, 'Probable 4-aminobutyrate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(108331, NULL, 'G3DSA:3.40.50.2300:FF:001198', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108332, NULL, 'G3DSA:3.30.530.20:FF:000008', NULL, NULL, 'START domain containing 10', NULL, NULL, NULL, NULL, NULL, 4),
(108333, NULL, 'G3DSA:1.20.80.10:FF:000020', NULL, NULL, 'Unconventional myosin-X', NULL, NULL, NULL, NULL, NULL, 4),
(108334, NULL, 'G3DSA:1.25.40.20:FF:000078', NULL, NULL, 'Inversin', NULL, NULL, NULL, NULL, NULL, 4),
(108335, NULL, 'G3DSA:2.60.40.10:FF:004347', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108336, NULL, 'G3DSA:1.10.533.10:FF:000119', NULL, NULL, 'Mucosa-associated lymphoid tissue lymphoma translocation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(108337, NULL, 'G3DSA:4.10.1240.10:FF:000059', NULL, NULL, 'adhesion G protein-coupled receptor L3', NULL, NULL, NULL, NULL, NULL, 4),
(108338, NULL, 'G3DSA:3.40.50.1240:FF:000093', NULL, NULL, 'Membrane-bound acid phosphatase 2', NULL, NULL, NULL, NULL, NULL, 4),
(108339, NULL, 'G3DSA:3.40.50.300:FF:000571', NULL, NULL, 'Guanine nucleotide-binding protein-like NSN1', NULL, NULL, NULL, NULL, NULL, 4),
(108340, NULL, 'G3DSA:3.30.390.10:FF:000016', NULL, NULL, 'Gluconate dehydratase (GAD)', NULL, NULL, NULL, NULL, NULL, 4),
(108341, NULL, 'G3DSA:3.90.1150.10:FF:000113', NULL, NULL, 'Aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(108342, NULL, 'G3DSA:3.10.20.90:FF:000093', NULL, NULL, 'NSFL1 (P97) cofactor (P47)', NULL, NULL, NULL, NULL, NULL, 4),
(108343, NULL, 'G3DSA:1.25.40.10:FF:004127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108344, NULL, 'G3DSA:1.10.10.10:FF:000730', NULL, NULL, 'RpiR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(108345, NULL, 'G3DSA:3.40.50.2300:FF:000012', NULL, NULL, 'Catabolite control protein A', NULL, NULL, NULL, NULL, NULL, 4),
(108346, NULL, 'G3DSA:1.20.5.110:FF:000357', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(108347, NULL, 'G3DSA:2.40.70.10:FF:000320', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(108348, NULL, 'G3DSA:3.40.50.720:FF:001657', NULL, NULL, 'Cinnamate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(108349, NULL, 'G3DSA:3.30.40.10:FF:001463', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108350, NULL, 'G3DSA:3.30.420.40:FF:000450', NULL, NULL, 'Protein CBG05834', NULL, NULL, NULL, NULL, NULL, 4),
(108351, NULL, 'G3DSA:1.25.40.10:FF:003638', NULL, NULL, 'Tetratricopeptide repeat protein 21B', NULL, NULL, NULL, NULL, NULL, 4),
(108352, NULL, 'G3DSA:3.20.20.70:FF:000687', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108353, NULL, 'G3DSA:3.30.160.60:FF:004347', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108354, NULL, 'G3DSA:1.25.40.20:FF:000971', NULL, NULL, 'YALI0F16940p', NULL, NULL, NULL, NULL, NULL, 4),
(108355, NULL, 'G3DSA:2.20.70.10:FF:000028', NULL, NULL, 'WW domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(108356, NULL, 'G3DSA:3.30.1680.10:FF:000004', NULL, NULL, 'semaphorin-6D isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(108357, NULL, 'G3DSA:2.130.10.10:FF:004443', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108358, NULL, 'G3DSA:3.40.50.2300:FF:001294', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108359, NULL, 'G3DSA:1.10.30.10:FF:000175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108360, NULL, 'G3DSA:3.75.10.10:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108361, NULL, 'G3DSA:1.10.472.10:FF:000415', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108362, NULL, 'G3DSA:3.40.50.1820:FF:001817', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108363, NULL, 'G3DSA:2.130.10.10:FF:004230', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(108364, NULL, 'G3DSA:1.25.10.10:FF:002164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108365, NULL, 'G3DSA:1.20.58.390:FF:000171', NULL, NULL, 'Glycine receptor alpha 1 variant, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108366, NULL, 'G3DSA:3.30.200.20:FF:001888', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108367, NULL, 'G3DSA:2.60.40.820:FF:000004', NULL, NULL, 'T-box, brain 1', NULL, NULL, NULL, NULL, NULL, 4),
(108368, NULL, 'G3DSA:3.30.420.40:FF:000354', NULL, NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(108369, NULL, 'G3DSA:3.30.200.20:FF:000702', NULL, NULL, 'CMGC/CDK/CRK7 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(108370, NULL, 'G3DSA:2.130.10.10:FF:003954', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit wuho', NULL, NULL, NULL, NULL, NULL, 4),
(108371, NULL, 'G3DSA:3.30.230.10:FF:000201', NULL, NULL, 'Elongation factor like GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(108372, NULL, 'G3DSA:1.10.730.10:FF:000066', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(108373, NULL, 'G3DSA:3.30.830.10:FF:000264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108374, NULL, 'G3DSA:3.90.1410.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108375, NULL, 'G3DSA:3.40.50.11720:FF:000004', NULL, NULL, '3-deoxy-D-manno-octulosonic acid transferase', NULL, NULL, NULL, NULL, NULL, 4),
(108376, NULL, 'G3DSA:3.30.310.50:FF:000012', NULL, NULL, 'Phosphoacetylglucosamine mutase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108377, NULL, 'G3DSA:3.40.50.300:FF:002268', NULL, NULL, 'ABC transporter, (TAP family), putative', NULL, NULL, NULL, NULL, NULL, 4),
(108378, NULL, 'G3DSA:3.30.70.240:FF:000008', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(108379, NULL, 'G3DSA:2.60.40.3210:FF:000028', NULL, NULL, 'Zona pellucida glycoprotein 3c', NULL, NULL, NULL, NULL, NULL, 4),
(108380, NULL, 'G3DSA:1.10.510.10:FF:000308', NULL, NULL, 'Dual specificity protein kinase TTK', NULL, NULL, NULL, NULL, NULL, 4),
(108381, NULL, 'G3DSA:1.10.760.10:FF:000017', NULL, NULL, 'Di-heme cytochrome C peroxidase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(108382, NULL, 'G3DSA:1.25.40.10:FF:000642', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(108383, NULL, 'G3DSA:1.20.120.720:FF:000061', NULL, NULL, 'Myosin-J heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(108384, NULL, 'G3DSA:2.60.40.3500:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108385, NULL, 'G3DSA:3.90.550.10:FF:000392', NULL, NULL, 'Glycogenin (Glucosyltransferase), putative', NULL, NULL, NULL, NULL, NULL, 4),
(108386, NULL, 'G3DSA:1.10.10.60:FF:000941', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108387, NULL, 'G3DSA:2.60.40.60:FF:000736', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108388, NULL, 'G3DSA:3.40.50.10810:FF:000074', NULL, NULL, 'DNA dependent ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108389, NULL, 'G3DSA:3.50.50.60:FF:000038', NULL, NULL, 'L-aspartate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(108390, NULL, 'G3DSA:3.30.160.60:FF:006146', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108391, NULL, 'G3DSA:1.25.10.10:FF:000129', NULL, NULL, 'sperm-associated antigen 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(108392, NULL, 'G3DSA:1.10.10.10:FF:000387', NULL, NULL, 'DNA topoisomerase 6 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(108393, NULL, 'G3DSA:3.80.10.10:FF:001436', NULL, NULL, 'Si:ch211-15j1.4', NULL, NULL, NULL, NULL, NULL, 4),
(108394, NULL, 'G3DSA:3.80.10.10:FF:002959', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108395, NULL, 'G3DSA:1.10.287.1490:FF:000008', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(108396, NULL, 'G3DSA:1.10.400.10:FF:000070', NULL, NULL, 'Guanine nucleotide binding protein, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(108397, NULL, 'G3DSA:1.10.287.1040:FF:000008', NULL, NULL, 'Exodeoxyribonuclease 7 small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(108398, NULL, 'G3DSA:1.10.3720.10:FF:000059', NULL, NULL, 'Oligopeptide ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(108399, NULL, 'G3DSA:2.60.40.60:FF:000309', NULL, NULL, 'Protocadherin beta-8', NULL, NULL, NULL, NULL, NULL, 4),
(108400, NULL, 'G3DSA:3.40.50.720:FF:000230', NULL, NULL, 'Oxidoreductase, short chain dehydrogenase/reductase family', NULL, NULL, NULL, NULL, NULL, 4),
(108401, NULL, 'G3DSA:3.30.160.60:FF:002447', NULL, NULL, 'Zinc finger protein 606', NULL, NULL, NULL, NULL, NULL, 4),
(108402, NULL, 'G3DSA:3.90.180.10:FF:000003', NULL, NULL, 'L-threonine 3-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(108403, NULL, 'G3DSA:3.30.1360.10:FF:000064', NULL, NULL, 'RNA polymerase Rpb3/Rpb11 dimerisation domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(108404, NULL, 'G3DSA:1.10.238.10:FF:000276', NULL, NULL, 'N-terminal EF-hand calcium binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(108405, NULL, 'G3DSA:2.10.25.10:FF:001116', NULL, NULL, 'Neurogenic locus protein delta', NULL, NULL, NULL, NULL, NULL, 4),
(108406, NULL, 'G3DSA:1.25.10.10:FF:002259', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(108407, NULL, 'G3DSA:3.40.30.10:FF:000798', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108408, NULL, 'G3DSA:3.40.462.20:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108409, NULL, 'G3DSA:3.30.470.30:FF:000062', NULL, NULL, 'LIG3 isoform 10', NULL, NULL, NULL, NULL, NULL, 4),
(108410, NULL, 'G3DSA:1.10.472.10:FF:000320', NULL, NULL, 'Uncharacterized cyclin-L1-like protein C1296.05c', NULL, NULL, NULL, NULL, NULL, 4),
(108411, NULL, 'G3DSA:2.40.320.10:FF:000013', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 18', NULL, NULL, NULL, NULL, NULL, 4),
(108412, NULL, 'G3DSA:3.40.50.300:FF:008097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108413, NULL, 'G3DSA:3.40.190.10:FF:000532', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(108414, NULL, 'G3DSA:1.20.58.570:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(108415, NULL, 'G3DSA:3.40.50.300:FF:000239', NULL, NULL, 'Meiotic recombination protein DMC1', NULL, NULL, NULL, NULL, NULL, 4),
(108416, NULL, 'G3DSA:3.40.190.10:FF:000105', NULL, NULL, 'Serotransferrin', NULL, NULL, NULL, NULL, NULL, 4),
(108417, NULL, 'G3DSA:3.30.450.40:FF:000070', NULL, NULL, 'Unplaced genomic scaffold supercont1.28, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(108418, NULL, 'G3DSA:3.30.360.10:FF:000082', NULL, NULL, 'Nucleoside-diphosphate-sugar epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(108419, NULL, 'G3DSA:3.40.980.10:FF:000008', NULL, NULL, 'Molybdenum cofactor biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(108420, NULL, 'G3DSA:2.60.410.10:FF:000010', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(108421, NULL, 'G3DSA:3.40.50.300:FF:006646', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108422, NULL, 'G3DSA:2.60.120.10:FF:000729', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108423, NULL, 'G3DSA:1.20.1280.50:FF:000186', NULL, NULL, 'SCF ubiquitin ligase complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(108424, NULL, 'G3DSA:3.40.50.1000:FF:000381', NULL, NULL, 'Phospholipid-transporting ATPase IA, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108425, NULL, 'G3DSA:3.30.70.3530:FF:000001', NULL, NULL, 'Chorion-specific transcription factor GCMb', NULL, NULL, NULL, NULL, NULL, 4),
(108426, NULL, 'G3DSA:3.30.497.10:FF:000090', NULL, NULL, 'serine protease inhibitor isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(108427, NULL, 'G3DSA:1.25.40.10:FF:004341', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108428, NULL, 'G3DSA:3.90.70.10:FF:000057', NULL, NULL, 'Cysteine protease RD19A', NULL, NULL, NULL, NULL, NULL, 4),
(108429, NULL, 'G3DSA:1.20.1070.10:FF:001092', NULL, NULL, 'Trace amine-associated receptor 5', NULL, NULL, NULL, NULL, NULL, 4),
(108430, NULL, 'G3DSA:1.20.5.190:FF:000116', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108431, NULL, 'G3DSA:3.90.260.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108432, NULL, 'G3DSA:3.40.50.300:FF:004409', NULL, NULL, 'Ribose 1,5-bisphosphate phosphokinase PhnN', NULL, NULL, NULL, NULL, NULL, 4),
(108433, NULL, 'G3DSA:1.25.40.20:FF:000645', NULL, NULL, 'Rab GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108434, NULL, 'G3DSA:2.60.40.10:FF:004139', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108435, NULL, 'G3DSA:1.10.10.10:FF:000404', NULL, NULL, 'DeoR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(108436, NULL, 'G3DSA:3.90.930.12:FF:000013', NULL, NULL, '50S ribosomal protein L6', NULL, NULL, NULL, NULL, NULL, 4),
(108437, NULL, 'G3DSA:1.10.510.10:FF:000297', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(108438, NULL, 'G3DSA:3.90.132.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108439, NULL, 'G3DSA:1.20.1110.10:FF:000078', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(108440, NULL, 'G3DSA:3.40.50.2000:FF:001097', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(108441, NULL, 'G3DSA:1.10.510.10:FF:003866', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108442, NULL, 'G3DSA:1.10.760.10:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108443, NULL, 'G3DSA:3.40.50.300:FF:008108', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(108444, NULL, 'G3DSA:3.40.50.300:FF:000565', NULL, NULL, 'ABC bile acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(108445, NULL, 'G3DSA:3.30.460.90:FF:000006', NULL, NULL, 'Inositol 1,4,5-trisphosphate receptor-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(108446, NULL, 'G3DSA:1.10.472.10:FF:000207', NULL, NULL, 'Cyclin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108447, NULL, 'G3DSA:3.40.50.300:FF:002695', NULL, NULL, 'ABC multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(108448, NULL, 'G3DSA:2.60.40.10:FF:002009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108449, NULL, 'G3DSA:2.40.170.20:FF:000072', NULL, NULL, 'Hemin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(108450, NULL, 'G3DSA:3.90.1420.10:FF:000005', NULL, NULL, 'Rubisco methyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(108451, NULL, 'G3DSA:2.130.10.10:FF:000952', NULL, NULL, 'Pre-mRNA-processing factor 19', NULL, NULL, NULL, NULL, NULL, 4),
(108452, NULL, 'G3DSA:3.40.50.2300:FF:001086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108453, NULL, 'G3DSA:1.25.10.10:FF:002158', NULL, NULL, 'BRCA1-associated ATM activator 1', NULL, NULL, NULL, NULL, NULL, 4),
(108454, NULL, 'G3DSA:3.40.50.200:FF:000086', NULL, NULL, 'Serin endopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(108455, NULL, 'G3DSA:3.30.160.60:FF:004701', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108456, NULL, 'G3DSA:3.40.50.1980:FF:000090', NULL, NULL, 'Iron(3+)-hydroxamate-binding protein YxeB', NULL, NULL, NULL, NULL, NULL, 4),
(108457, NULL, 'G3DSA:4.10.60.10:FF:000041', NULL, NULL, 'Zinc finger CCHC domain-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(108458, NULL, 'G3DSA:3.30.160.60:FF:002773', NULL, NULL, 'AGAP006061-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(108459, NULL, 'G3DSA:3.10.28.10:FF:000002', NULL, NULL, 'Probable cell division protein WhiA', NULL, NULL, NULL, NULL, NULL, 4),
(108460, NULL, 'G3DSA:3.50.50.100:FF:000019', NULL, NULL, 'NADH dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(108461, NULL, 'G3DSA:1.20.1110.10:FF:000191', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108462, NULL, 'G3DSA:1.20.58.340:FF:000066', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(108463, NULL, 'G3DSA:3.10.150.10:FF:000019', NULL, NULL, 'Beta sliding clamp', NULL, NULL, NULL, NULL, NULL, 4),
(108464, NULL, 'G3DSA:3.30.565.10:FF:000158', NULL, NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(108465, NULL, 'G3DSA:3.80.10.10:FF:001863', NULL, NULL, 'Ribonuclease inhibitor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(108466, NULL, 'G3DSA:3.40.710.10:FF:000079', NULL, NULL, '6-aminohexanoate-dimer hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(108467, NULL, 'G3DSA:1.20.120.980:FF:000009', NULL, NULL, 'AGAP003640-PA', NULL, NULL, NULL, NULL, NULL, 4),
(108468, NULL, 'G3DSA:3.40.50.1820:FF:001705', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(108469, NULL, 'G3DSA:3.30.420.10:FF:000699', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108470, NULL, 'G3DSA:3.30.1330.30:FF:000147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108471, NULL, 'G3DSA:3.30.505.10:FF:000155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108472, NULL, 'G3DSA:3.30.200.20:FF:002052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108473, NULL, 'G3DSA:1.10.287.110:FF:000195', NULL, NULL, 'Tetratricopeptide repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(108474, NULL, 'G3DSA:3.40.50.1980:FF:000101', NULL, NULL, 'Histidinol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(108475, NULL, 'G3DSA:3.30.420.40:FF:000242', NULL, NULL, '53 kDa brg1-associated factor b', NULL, NULL, NULL, NULL, NULL, 4),
(108476, NULL, 'G3DSA:1.25.10.10:FF:002372', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108477, NULL, 'G3DSA:1.10.510.10:FF:002438', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108478, NULL, 'G3DSA:3.30.70.920:FF:000015', NULL, NULL, 'AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(108479, NULL, 'G3DSA:3.30.420.40:FF:000562', NULL, NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(108480, NULL, 'G3DSA:3.30.1330.60:FF:000010', NULL, NULL, 'Outer membrane protein class 4', NULL, NULL, NULL, NULL, NULL, 4),
(108481, NULL, 'G3DSA:1.20.1050.10:FF:000140', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(108482, NULL, 'G3DSA:1.25.40.10:FF:002087', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g62370', NULL, NULL, NULL, NULL, NULL, 4),
(108483, NULL, 'G3DSA:1.25.10.10:FF:000814', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(108484, NULL, 'G3DSA:3.40.630.30:FF:000359', NULL, NULL, 'GD19914', NULL, NULL, NULL, NULL, NULL, 4),
(108485, NULL, 'G3DSA:1.20.1070.10:FF:001872', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108486, NULL, 'G3DSA:3.60.21.10:FF:000451', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(108487, NULL, 'G3DSA:1.20.272.10:FF:000038', NULL, NULL, 'Replication factor C, subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(108488, NULL, 'G3DSA:3.40.30.10:FF:000714', NULL, NULL, 'Probable dolichyl-diphosphooligosaccharide--protein glycosyltransferase subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(108489, NULL, 'G3DSA:1.10.1600.10:FF:000011', NULL, NULL, 'Caenorhabditis KU', NULL, NULL, NULL, NULL, NULL, 4),
(108490, NULL, 'G3DSA:1.25.10.10:FF:002490', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108491, NULL, 'G3DSA:3.40.47.10:FF:000218', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108492, NULL, 'G3DSA:2.60.210.10:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(108493, NULL, 'G3DSA:1.20.140.150:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108494, NULL, 'G3DSA:1.10.1620.20:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108495, NULL, 'G3DSA:2.130.10.10:FF:005966', NULL, NULL, 'Vacuolar protein sorting/targeting protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(108496, NULL, 'G3DSA:2.60.40.10:FF:005775', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108497, NULL, 'G3DSA:3.40.47.10:FF:000106', NULL, NULL, 'Actinorhodin polyketide putative beta-ketoacyl synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(108498, NULL, 'G3DSA:3.40.50.1380:FF:000005', NULL, NULL, 'CAD protein-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(108499, NULL, 'G3DSA:1.10.8.710:FF:000016', NULL, NULL, 'Dynein heavy chain 5, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(108500, NULL, 'G3DSA:3.40.50.880:FF:000137', NULL, NULL, 'Catalase', NULL, NULL, NULL, NULL, NULL, 4),
(108501, NULL, 'G3DSA:3.30.40.10:FF:000501', NULL, NULL, 'E3 ubiquitin-protein ligase ZNRF4', NULL, NULL, NULL, NULL, NULL, 4),
(108502, NULL, 'G3DSA:2.120.10.30:FF:000245', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(108503, NULL, 'G3DSA:3.30.750.24:FF:000102', NULL, NULL, 'Sulphate permease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108504, NULL, 'G3DSA:3.40.800.20:FF:000061', NULL, NULL, 'Histone deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(108505, NULL, 'G3DSA:2.10.109.10:FF:000023', NULL, NULL, 'Mitochondrial inner membrane protease subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(108506, NULL, 'G3DSA:3.40.50.1390:FF:000008', NULL, NULL, 'DNA recombinase', NULL, NULL, NULL, NULL, NULL, 4),
(108507, NULL, 'G3DSA:4.10.10.10:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108508, NULL, 'G3DSA:3.10.110.10:FF:000236', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 C', NULL, NULL, NULL, NULL, NULL, 4),
(108509, NULL, 'G3DSA:3.10.110.10:FF:000124', NULL, NULL, 'Ubiquitin-conjugating enzyme E2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108510, NULL, 'G3DSA:1.10.3720.10:FF:000172', NULL, NULL, 'ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(108511, NULL, 'G3DSA:3.40.50.1820:FF:000879', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(108512, NULL, 'G3DSA:1.10.560.10:FF:000036', NULL, NULL, 'T-complex protein 1, theta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(108513, NULL, 'G3DSA:3.40.50.300:FF:004729', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(108514, NULL, 'G3DSA:3.40.50.720:FF:000022', NULL, NULL, 'Cinnamyl alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(108515, NULL, 'G3DSA:2.30.330.10:FF:000005', NULL, NULL, 'Flagellar motor switch protein', NULL, NULL, NULL, NULL, NULL, 4),
(108516, NULL, 'G3DSA:2.30.29.30:FF:000303', NULL, NULL, 'Sterol 3-beta-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(108517, NULL, 'G3DSA:1.10.10.10:FF:000067', NULL, NULL, 'Iron-dependent repressor IdeR', NULL, NULL, NULL, NULL, NULL, 4),
(108518, NULL, 'G3DSA:2.10.25.10:FF:000599', NULL, NULL, 'multiple epidermal growth factor-like domains protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(108519, NULL, 'G3DSA:1.10.3210.10:FF:000088', NULL, NULL, 'Metal-dependent phosphohydrolase HD sub domain', NULL, NULL, NULL, NULL, NULL, 4),
(108520, NULL, 'G3DSA:2.60.40.10:FF:000087', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(108521, NULL, 'G3DSA:3.30.505.10:FF:000054', NULL, NULL, 'Suppressor of cytokine signaling 1', NULL, NULL, NULL, NULL, NULL, 4),
(108522, NULL, 'G3DSA:2.130.10.10:FF:000059', NULL, NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', NULL, NULL, NULL, NULL, NULL, 4),
(108523, NULL, 'G3DSA:3.90.226.10:FF:000234', NULL, NULL, 'ATP-dependent Clp protease proteolytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(108524, NULL, 'G3DSA:1.10.10.10:FF:000179', NULL, NULL, 'DNA-binding response OmpR family regulator', NULL, NULL, NULL, NULL, NULL, 4),
(108525, NULL, 'G3DSA:1.25.40.10:FF:004240', NULL, NULL, 'Pentatricopeptide repeat protein (AFU_orthologue AFUA_2G12010)', NULL, NULL, NULL, NULL, NULL, 4),
(108526, NULL, 'G3DSA:1.20.1310.10:FF:000059', NULL, NULL, 'Cullin-4B', NULL, NULL, NULL, NULL, NULL, 4),
(108527, NULL, 'G3DSA:2.10.25.10:FF:001324', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108528, NULL, 'G3DSA:3.10.180.10:FF:000061', NULL, NULL, 'Putative protein C31H2.4', NULL, NULL, NULL, NULL, NULL, 4),
(108529, NULL, 'G3DSA:3.40.309.10:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108530, NULL, 'G3DSA:2.10.25.10:FF:001436', NULL, NULL, 'Laminin beta 1 chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108531, NULL, 'G3DSA:3.40.50.300:FF:000470', NULL, NULL, 'ATPase family, AAA domain containing 3A', NULL, NULL, NULL, NULL, NULL, 4),
(108532, NULL, 'G3DSA:2.120.10.30:FF:000144', NULL, NULL, 'Nhl repeat-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108533, NULL, 'G3DSA:3.40.640.10:FF:000281', NULL, NULL, 'Gamma-aminobutyrate transaminase POP2 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(108534, NULL, 'G3DSA:3.40.50.740:FF:000028', NULL, NULL, 'NADH-quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(108535, NULL, 'G3DSA:1.10.510.10:FF:002551', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(108536, NULL, 'G3DSA:3.40.50.1370:FF:000002', NULL, NULL, 'Aspartate carbamoyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(108537, NULL, 'G3DSA:1.25.10.10:FF:000461', NULL, NULL, 'Non-SMC condensin I complex, subunit G', NULL, NULL, NULL, NULL, NULL, 4),
(108538, NULL, 'G3DSA:3.30.460.80:FF:000003', NULL, NULL, 'Formate hydrogenlyase subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(108539, NULL, 'G3DSA:3.30.800.10:FF:000009', NULL, NULL, 'Phosphatidylinositol 4-phosphate 5-kinase its3', NULL, NULL, NULL, NULL, NULL, 4),
(108540, NULL, 'G3DSA:3.30.590.20:FF:000017', NULL, NULL, 'Putative glutamate--cysteine ligase 2', NULL, NULL, NULL, NULL, NULL, 4),
(108541, NULL, 'G3DSA:3.40.50.300:FF:004617', NULL, NULL, 'V-type proton ATPase catalytic subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(108542, NULL, 'G3DSA:1.10.940.10:FF:000003', NULL, NULL, 'Transcription antitermination factor NusB', NULL, NULL, NULL, NULL, NULL, 4),
(108543, NULL, 'G3DSA:3.10.20.90:FF:000755', NULL, NULL, 'AGAP011491-PA', NULL, NULL, NULL, NULL, NULL, 4),
(108544, NULL, 'G3DSA:1.20.58.60:FF:000888', NULL, NULL, 'Spectrin alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(108545, NULL, 'G3DSA:1.10.3460.10:FF:000022', NULL, NULL, 'Fucoxanthin chl a/c protein-deviant sequence', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(108546, NULL, 'G3DSA:1.10.418.60:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108547, NULL, 'G3DSA:3.90.70.10:FF:000484', NULL, NULL, 'Ubiquitin-specific protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108548, NULL, 'G3DSA:3.40.47.10:FF:000011', NULL, NULL, '3-ketoacyl-CoA thiolase', NULL, NULL, NULL, NULL, NULL, 4),
(108549, NULL, 'G3DSA:3.40.50.720:FF:001427', NULL, NULL, 'Polyketide synthase type I', NULL, NULL, NULL, NULL, NULL, 4),
(108550, NULL, 'G3DSA:1.10.357.10:FF:000018', NULL, NULL, 'Transcriptional regulator LuxT', NULL, NULL, NULL, NULL, NULL, 4),
(108551, NULL, 'G3DSA:2.60.40.60:FF:000641', NULL, NULL, 'AGAP002828-PA', NULL, NULL, NULL, NULL, NULL, 4),
(108552, NULL, 'G3DSA:2.30.29.30:FF:000888', NULL, NULL, 'Pleckstrin homology domain-containing family B member 2', NULL, NULL, NULL, NULL, NULL, 4),
(108553, NULL, 'G3DSA:2.40.100.10:FF:000132', NULL, NULL, 'Cyclophilin-type peptidylprolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(108554, NULL, 'G3DSA:3.40.50.1440:FF:000052', NULL, NULL, 'Tubulin/FtsZ GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(108555, NULL, 'G3DSA:1.10.1240.40:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108556, NULL, 'G3DSA:3.65.10.20:FF:000019', NULL, NULL, 'RNA 3''-terminal phosphate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(108557, NULL, 'G3DSA:2.130.10.10:FF:002088', NULL, NULL, 'Vacuolar protein sorting-associated protein 41', NULL, NULL, NULL, NULL, NULL, 4),
(108558, NULL, 'G3DSA:4.10.400.10:FF:000255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108559, NULL, 'G3DSA:1.10.150.240:FF:000010', NULL, NULL, 'Beta-phosphoglucomutase', NULL, NULL, NULL, NULL, NULL, 4),
(108560, NULL, 'G3DSA:2.60.40.1360:FF:000001', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(108561, NULL, 'G3DSA:3.65.10.10:FF:000016', NULL, NULL, 'Pentafunctional AROM polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(108562, NULL, 'G3DSA:1.10.287.40:FF:000022', NULL, NULL, 'Serine--tRNA ligase, chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(108563, NULL, 'G3DSA:2.60.40.10:FF:002341', NULL, NULL, 'Alpha-1-B glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(108564, NULL, 'G3DSA:3.30.1640.10:FF:000007', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(108565, NULL, 'G3DSA:3.40.190.290:FF:000029', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(108566, NULL, 'G3DSA:1.20.58.2220:FF:000044', NULL, NULL, 'Formin-homology and zinc finger domains protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(108567, NULL, 'G3DSA:2.60.450.20:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108568, NULL, 'G3DSA:1.10.418.40:FF:000012', NULL, NULL, 'AGAP012793-PA', NULL, NULL, NULL, NULL, NULL, 4),
(108569, NULL, 'G3DSA:2.170.270.10:FF:000113', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(108570, NULL, 'G3DSA:2.60.40.10:FF:004802', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108571, NULL, 'G3DSA:3.40.50.880:FF:000042', NULL, NULL, 'Pyridoxine 2', NULL, NULL, NULL, NULL, NULL, 4),
(108572, NULL, 'G3DSA:3.80.10.10:FF:001083', NULL, NULL, 'Ribonuclease inhibitor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(108573, NULL, 'G3DSA:3.40.50.1000:FF:000280', NULL, NULL, 'HAD-superfamily hydrolase, subfamily IIA containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(108574, NULL, 'G3DSA:2.40.70.10:FF:000292', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108575, NULL, 'G3DSA:1.10.1670.10:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108576, NULL, 'G3DSA:3.30.70.330:FF:001569', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108577, NULL, 'G3DSA:1.20.1500.20:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108578, NULL, 'G3DSA:1.10.287.1480:FF:000005', NULL, NULL, '30S ribosomal protein S14', NULL, NULL, NULL, NULL, NULL, 4),
(108579, NULL, 'G3DSA:1.10.238.10:FF:001102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(108580, NULL, 'G3DSA:2.130.10.10:FF:002313', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', NULL, NULL, NULL, NULL, NULL, 4),
(108581, NULL, 'G3DSA:3.30.565.10:FF:000259', NULL, NULL, 'Volvoxopsin-5, sensory rhodopsin with histidine kinase domain', NULL, NULL, NULL, NULL, NULL, 4),
(108582, NULL, 'G3DSA:1.10.8.720:FF:000019', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(108583, NULL, 'G3DSA:3.30.1360.120:FF:000053', NULL, NULL, 'Glycine cleavage system T protein, aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(108584, NULL, 'G3DSA:3.40.630.10:FF:000353', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108585, NULL, 'G3DSA:1.10.510.10:FF:002337', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108586, NULL, 'G3DSA:3.40.50.2060:FF:000018', NULL, NULL, 'Vacuolar protein sorting 33B', NULL, NULL, NULL, NULL, NULL, 4),
(108587, NULL, 'G3DSA:3.10.20.90:FF:000328', NULL, NULL, 'Focal adhesion kinase, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(108588, NULL, 'G3DSA:3.30.160.60:FF:000744', NULL, NULL, 'zinc finger E-box-binding homeobox 1', NULL, NULL, NULL, NULL, NULL, 4),
(108589, NULL, 'G3DSA:3.30.200.20:FF:002153', NULL, NULL, 'Os05g0333100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(108590, NULL, 'G3DSA:3.40.50.300:FF:004522', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108591, NULL, 'G3DSA:2.30.30.40:FF:000057', NULL, NULL, 'Dedicator of cytokinesis protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(108592, NULL, 'G3DSA:2.120.10.80:FF:000232', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(108593, NULL, 'G3DSA:2.30.30.30:FF:000054', NULL, NULL, 'Transcription elongation factor SPT5', NULL, NULL, NULL, NULL, NULL, 4),
(108594, NULL, 'G3DSA:3.90.550.10:FF:000723', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108595, NULL, 'G3DSA:3.10.450.160:FF:000001', NULL, NULL, 'Heavy metal resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(108596, NULL, 'G3DSA:3.40.50.300:FF:004056', NULL, NULL, 'Non-structural protein NS1', NULL, NULL, NULL, NULL, NULL, 4),
(108597, NULL, 'G3DSA:1.20.1540.10:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108598, NULL, 'G3DSA:3.30.160.20:FF:000199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108599, NULL, 'G3DSA:1.20.1070.10:FF:001445', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108600, NULL, 'G3DSA:2.70.150.10:FF:000049', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(108601, NULL, 'G3DSA:3.30.160.60:FF:005988', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108602, NULL, 'G3DSA:3.20.100.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108603, NULL, 'G3DSA:1.10.555.10:FF:000069', NULL, NULL, 'Rho GTPase Activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(108604, NULL, 'G3DSA:3.40.50.150:FF:000385', NULL, NULL, 'DNA (Cytosine-5)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(108605, NULL, 'G3DSA:3.30.860.10:FF:000007', NULL, NULL, '40S ribosomal protein S15', NULL, NULL, NULL, NULL, NULL, 4),
(108606, NULL, 'G3DSA:3.40.50.1000:FF:000487', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108607, NULL, 'G3DSA:2.30.29.30:FF:000989', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108608, NULL, 'G3DSA:1.10.530.10:FF:000085', NULL, NULL, 'Lyc2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(108609, NULL, 'G3DSA:1.25.40.990:FF:000004', NULL, NULL, 'Putative peptidase C48 domain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(108610, NULL, 'G3DSA:1.10.20.10:FF:000348', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108611, NULL, 'G3DSA:1.10.10.10:FF:000281', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(108612, NULL, 'G3DSA:1.10.20.10:FF:000118', NULL, NULL, 'Unplaced genomic scaffold supercont1.188, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(108613, NULL, 'G3DSA:1.10.287.690:FF:000003', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(108614, NULL, 'G3DSA:2.130.10.10:FF:004229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108615, NULL, 'G3DSA:3.10.310.20:FF:000013', NULL, NULL, 'Acidocalcisomal exopolyphosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108616, NULL, 'G3DSA:3.40.50.300:FF:002931', NULL, NULL, 'DNA repair helicase XPB-R', NULL, NULL, NULL, NULL, NULL, 4),
(108617, NULL, 'G3DSA:1.25.70.10:FF:000026', NULL, NULL, 'Mitochondrial transcription termination factor family protein', NULL, NULL, NULL, NULL, NULL, 4),
(108618, NULL, 'G3DSA:3.30.160.60:FF:006264', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108619, NULL, 'G3DSA:3.40.50.300:FF:004286', NULL, NULL, 'Homolog of S. Pombe Rad', NULL, NULL, NULL, NULL, NULL, 4),
(108620, NULL, 'G3DSA:1.10.287.110:FF:000318', NULL, NULL, 'Chaperone protein DNAj, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108621, NULL, 'G3DSA:2.60.40.3100:FF:000001', NULL, NULL, 'Arylsulfate sulfotransferase AssT', NULL, NULL, NULL, NULL, NULL, 4),
(108622, NULL, 'G3DSA:3.30.160.750:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108623, NULL, 'G3DSA:3.30.70.330:FF:001912', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108624, NULL, 'G3DSA:3.40.50.2300:FF:001647', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108625, NULL, 'G3DSA:3.30.40.10:FF:001575', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108626, NULL, 'G3DSA:3.30.70.330:FF:001558', NULL, NULL, 'Polyadenylate-binding protein, cytoplasmic and nuclear', NULL, NULL, NULL, NULL, NULL, 4),
(108627, NULL, 'G3DSA:3.30.160.60:FF:002335', NULL, NULL, 'C2H2 transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(108628, NULL, 'G3DSA:3.40.50.150:FF:001003', NULL, NULL, 'NOL1/NOP2/sun family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108629, NULL, 'G3DSA:2.60.40.10:FF:002548', NULL, NULL, 'Protein CBR-UNC-40', NULL, NULL, NULL, NULL, NULL, 4),
(108630, NULL, 'G3DSA:3.10.20.480:FF:000001', NULL, NULL, 'Antirestriction protein ArdA', NULL, NULL, NULL, NULL, NULL, 4),
(108631, NULL, 'G3DSA:2.60.40.10:FF:004690', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108632, NULL, 'G3DSA:3.30.160.60:FF:004465', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108633, NULL, 'G3DSA:3.30.40.10:FF:001345', NULL, NULL, 'PHD type transcription factor with transmembrane domain protein (PTM)', NULL, NULL, NULL, NULL, NULL, 4),
(108634, NULL, 'G3DSA:1.20.1280.50:FF:000074', NULL, NULL, 'GG17121', NULL, NULL, NULL, NULL, NULL, 4),
(108635, NULL, 'G3DSA:1.20.1280.50:FF:000175', NULL, NULL, 'Probable F-box protein At5g36000', NULL, NULL, NULL, NULL, NULL, 4),
(108636, NULL, 'G3DSA:2.30.29.30:FF:001265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108637, NULL, 'G3DSA:3.20.20.100:FF:000104', NULL, NULL, 'Probable oxidoreductase (Aldo-keto reductase family protein)', NULL, NULL, NULL, NULL, NULL, 4),
(108638, NULL, 'G3DSA:2.70.170.10:FF:000258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108639, NULL, 'G3DSA:2.40.37.20:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108640, NULL, 'G3DSA:1.10.1420.10:FF:000126', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(108641, NULL, 'G3DSA:3.20.20.140:FF:000448', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108642, NULL, 'G3DSA:1.10.3970.10:FF:000004', NULL, NULL, 'General Transcription Factor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(108643, NULL, 'G3DSA:3.40.50.150:FF:000727', NULL, NULL, 'Methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(108644, NULL, 'G3DSA:3.30.565.10:FF:000052', NULL, NULL, 'Two-component system sensor histidine kinase UhpB', NULL, NULL, NULL, NULL, NULL, 4),
(108645, NULL, 'G3DSA:1.20.140.40:FF:000084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108646, NULL, 'G3DSA:3.30.200.20:FF:000461', NULL, NULL, 'Serine/threonine-protein kinase SRPK1', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(108647, NULL, 'G3DSA:1.10.418.10:FF:000262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108648, NULL, 'G3DSA:4.10.970.10:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108649, NULL, 'G3DSA:3.50.4.10:FF:000025', NULL, NULL, 'PAN domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(108650, NULL, 'G3DSA:3.90.226.10:FF:000026', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(108651, NULL, 'G3DSA:2.130.10.10:FF:000290', NULL, NULL, 'Protein HIR', NULL, NULL, NULL, NULL, NULL, 4),
(108652, NULL, 'G3DSA:3.10.310.10:FF:000010', NULL, NULL, 'Proline racemase', NULL, NULL, NULL, NULL, NULL, 4),
(108653, NULL, 'G3DSA:2.70.150.10:FF:000162', NULL, NULL, 'Phospholipid-transporting ATPase IA, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108654, NULL, 'G3DSA:2.40.30.10:FF:000295', NULL, NULL, 'NADPH-dependent diflavin oxidoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(108655, NULL, 'G3DSA:3.40.50.720:FF:001865', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108656, NULL, 'G3DSA:3.40.50.150:FF:000486', NULL, NULL, 'O-methyltransferase glim', NULL, NULL, NULL, NULL, NULL, 4),
(108657, NULL, 'G3DSA:1.20.1310.10:FF:000172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108658, NULL, 'G3DSA:3.30.70.330:FF:001671', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108659, NULL, 'G3DSA:1.20.5.190:FF:000004', NULL, NULL, 'calmodulin-binding transcription activator 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(108660, NULL, 'G3DSA:1.20.140.150:FF:000091', NULL, NULL, 'Transmembrane protein 178B', NULL, NULL, NULL, NULL, NULL, 4),
(108661, NULL, 'G3DSA:2.30.130.30:FF:000001', NULL, NULL, 'UPF0267 protein YqfB', NULL, NULL, NULL, NULL, NULL, 4),
(108662, NULL, 'G3DSA:2.130.10.10:FF:005865', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(108663, NULL, 'G3DSA:1.10.3910.10:FF:000001', NULL, NULL, 'Iron-sulfur cluster repair protein ScdA', NULL, NULL, NULL, NULL, NULL, 4),
(108664, NULL, 'G3DSA:2.170.270.10:FF:000231', NULL, NULL, 'BAH domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(108665, NULL, 'G3DSA:3.40.50.300:FF:006540', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108666, NULL, 'G3DSA:3.40.50.1380:FF:000016', NULL, NULL, 'Carbamoyl phosphate synthetase II', NULL, NULL, NULL, NULL, NULL, 4),
(108667, NULL, 'G3DSA:2.60.120.10:FF:000617', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108668, NULL, 'G3DSA:3.90.550.10:FF:000515', NULL, NULL, 'Glycosyl transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(108669, NULL, 'G3DSA:3.30.590.10:FF:000014', NULL, NULL, 'arginine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(108670, NULL, 'G3DSA:1.10.10.10:FF:000180', NULL, NULL, 'Transcriptional activator NhaR', NULL, NULL, NULL, NULL, NULL, 4),
(108671, NULL, 'G3DSA:3.30.160.60:FF:000536', NULL, NULL, 'hypermethylated in cancer 2 protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(108672, NULL, 'G3DSA:2.130.10.10:FF:000632', NULL, NULL, 'WD repeat-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108673, NULL, 'G3DSA:3.90.1150.10:FF:000001', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(108674, NULL, 'G3DSA:3.80.10.10:FF:000599', NULL, NULL, 'Leucine-rich repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(108675, NULL, 'G3DSA:3.30.379.10:FF:000006', NULL, NULL, 'Extracellular xylan exo-alpha-(1->2)-glucuronosidase', NULL, NULL, NULL, NULL, NULL, 4),
(108676, NULL, 'G3DSA:1.10.340.30:FF:000020', NULL, NULL, 'Pre-mRNA splicing factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108677, NULL, 'G3DSA:3.90.550.50:FF:000145', NULL, NULL, 'Chondroitin sulfate synthase mig-22', NULL, NULL, NULL, NULL, NULL, 4),
(108678, NULL, 'G3DSA:3.90.70.10:FF:000046', NULL, NULL, 'ubiquitin carboxyl-terminal hydrolase 31', NULL, NULL, NULL, NULL, NULL, 4),
(108679, NULL, 'G3DSA:1.25.40.10:FF:003846', NULL, NULL, 'Nuclear autoantigenic sperm protein (histone-binding)', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(108680, NULL, 'G3DSA:1.10.1420.10:FF:000025', NULL, NULL, 'DNA mismatch repair protein msh3', NULL, NULL, NULL, NULL, NULL, 4),
(108681, NULL, 'G3DSA:2.60.40.10:FF:005876', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108682, NULL, 'G3DSA:3.10.10.10:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108683, NULL, 'G3DSA:1.10.150.20:FF:000103', NULL, NULL, 'DNA-directed RNA polymerase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(108684, NULL, 'G3DSA:3.20.20.210:FF:000025', NULL, NULL, 'Uroporphyrinogen decarboxylase 1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(108685, NULL, 'G3DSA:3.30.160.60:FF:002094', NULL, NULL, 'Zinc finger and BTB domain-containing 47b', NULL, NULL, NULL, NULL, NULL, 4),
(108686, NULL, 'G3DSA:2.70.130.10:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108687, NULL, 'G3DSA:1.20.58.1880:FF:000014', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(108688, NULL, 'G3DSA:3.30.200.20:FF:000803', NULL, NULL, 'Probable serine/threonine-protein kinase roco4', NULL, NULL, NULL, NULL, NULL, 4),
(108689, NULL, 'G3DSA:2.60.40.150:FF:000770', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108690, NULL, 'G3DSA:2.10.25.10:FF:001554', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108691, NULL, 'G3DSA:1.10.10.10:FF:002080', NULL, NULL, 'Meiotic recombination protein W68', NULL, NULL, NULL, NULL, NULL, 4),
(108692, NULL, 'G3DSA:3.30.70.330:FF:002064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108693, NULL, 'G3DSA:3.20.20.70:FF:000788', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108694, NULL, 'G3DSA:3.40.50.300:FF:006860', NULL, NULL, 'Lipid exporter ABCA1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108695, NULL, 'G3DSA:3.40.50.720:FF:001545', NULL, NULL, 'Glucose 1-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(108696, NULL, 'G3DSA:3.40.50.2300:FF:000124', NULL, NULL, 'PTS sugar transporter subunit IIB', NULL, NULL, NULL, NULL, NULL, 4),
(108697, NULL, 'G3DSA:3.30.450.40:FF:000277', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(108698, NULL, 'G3DSA:3.40.1090.10:FF:000136', NULL, NULL, 'Patatin', NULL, NULL, NULL, NULL, NULL, 4),
(108699, NULL, 'G3DSA:3.30.160.60:FF:004235', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108700, NULL, 'G3DSA:2.40.70.10:FF:000415', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108701, NULL, 'G3DSA:3.30.479.30:FF:000031', NULL, NULL, 'Sll0815 protein', NULL, NULL, NULL, NULL, NULL, 4),
(108702, NULL, 'G3DSA:3.40.50.1820:FF:001716', NULL, NULL, 'Protein kinase family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(108703, NULL, 'G3DSA:1.25.10.10:FF:002052', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(108704, NULL, 'G3DSA:2.130.10.10:FF:004342', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108705, NULL, 'G3DSA:1.20.58.390:FF:000283', NULL, NULL, 'Si:dkey-49c17.4', NULL, NULL, NULL, NULL, NULL, 4),
(108706, NULL, 'G3DSA:3.50.50.60:FF:001455', NULL, NULL, 'Oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108707, NULL, 'G3DSA:2.40.10.10:FF:000209', NULL, NULL, 'Serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(108708, NULL, 'G3DSA:3.40.50.1000:FF:000403', NULL, NULL, 'Cadmium, zinc and cobalt-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(108709, NULL, 'G3DSA:3.40.50.1390:FF:000019', NULL, NULL, 'Phage integrase family Site-specific recombinase', NULL, NULL, NULL, NULL, NULL, 4),
(108710, NULL, 'G3DSA:3.30.160.60:FF:003959', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108711, NULL, 'G3DSA:2.60.120.10:FF:000376', NULL, NULL, 'Germin-like protein subfamily 2 member 1', NULL, NULL, NULL, NULL, NULL, 4),
(108712, NULL, 'G3DSA:1.25.40.980:FF:000001', NULL, NULL, 'Protein transport protein SEC31', NULL, NULL, NULL, NULL, NULL, 4),
(108713, NULL, 'G3DSA:2.130.10.10:FF:004331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(108714, NULL, 'G3DSA:2.30.130.40:FF:000004', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(108715, NULL, 'G3DSA:2.130.10.10:FF:002190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108716, NULL, 'G3DSA:3.40.640.10:FF:000522', NULL, NULL, 'Ornithine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(108717, NULL, 'G3DSA:3.30.70.240:FF:000019', NULL, NULL, 'Elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(108718, NULL, 'G3DSA:1.10.1070.11:FF:000083', NULL, NULL, 'Serine/threonine-protein kinase TEL1', NULL, NULL, NULL, NULL, NULL, 4),
(108719, NULL, 'G3DSA:1.10.10.920:FF:000004', NULL, NULL, 'Oxygen-independent coproporphyrinogen III oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(108720, NULL, 'G3DSA:2.30.30.40:FF:000265', NULL, NULL, 'Myoblast city, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(108721, NULL, 'G3DSA:1.20.1250.20:FF:001434', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108722, NULL, 'G3DSA:1.10.357.70:FF:000008', NULL, NULL, 'Exocyst complex component', NULL, NULL, NULL, NULL, NULL, 4),
(108723, NULL, 'G3DSA:3.30.110.70:FF:000002', NULL, NULL, 'Heavy-metal-binding family protein', NULL, NULL, NULL, NULL, NULL, 4),
(108724, NULL, 'G3DSA:2.60.450.20:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108725, NULL, 'G3DSA:1.10.10.60:FF:000621', NULL, NULL, 'Lhx1/5 LIM homeobox protein', NULL, NULL, NULL, NULL, NULL, 4),
(108726, NULL, 'G3DSA:3.30.420.40:FF:000449', NULL, NULL, 'Heat shock protein 70', NULL, NULL, NULL, NULL, NULL, 4),
(108727, NULL, 'G3DSA:2.40.100.10:FF:000143', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(108728, NULL, 'G3DSA:3.40.50.300:FF:000918', NULL, NULL, 'tRNA dimethylallyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(108729, NULL, 'G3DSA:1.10.10.10:FF:000303', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(108730, NULL, 'G3DSA:2.130.10.10:FF:002077', NULL, NULL, 'Protein HIR', NULL, NULL, NULL, NULL, NULL, 4),
(108731, NULL, 'G3DSA:1.20.1560.10:FF:000004', NULL, NULL, 'ATP-binding cassette sub-family B member 7', NULL, NULL, NULL, NULL, NULL, 4),
(108732, NULL, 'G3DSA:3.40.50.1100:FF:000197', NULL, NULL, 'Os06g0564600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(108733, NULL, 'G3DSA:1.25.40.1010:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108734, NULL, 'G3DSA:1.10.10.910:FF:000001', NULL, NULL, 'ATP synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(108735, NULL, 'G3DSA:4.10.840.10:FF:000001', NULL, NULL, 'Rhodopsin', NULL, NULL, NULL, NULL, NULL, 4),
(108736, NULL, 'G3DSA:3.10.250.10:FF:000067', NULL, NULL, 'Lysyl oxidase homolog 3A', NULL, NULL, NULL, NULL, NULL, 4),
(108737, NULL, 'G3DSA:3.40.50.300:FF:008119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108738, NULL, 'G3DSA:1.20.144.10:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108739, NULL, 'G3DSA:1.10.1410.10:FF:000075', NULL, NULL, 'Poly(A) polymerase alpha', NULL, NULL, NULL, NULL, NULL, 4),
(108740, NULL, 'G3DSA:2.40.30.10:FF:000418', NULL, NULL, 'Selenocysteine-specific elongation factor SelB', NULL, NULL, NULL, NULL, NULL, 4),
(108741, NULL, 'G3DSA:3.30.565.10:FF:000490', NULL, NULL, 'Two-component sensor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(108742, NULL, 'G3DSA:3.30.200.60:FF:000006', NULL, NULL, 'OSIGBa0113E10.15 protein', NULL, NULL, NULL, NULL, NULL, 4),
(108743, NULL, 'G3DSA:1.20.1640.10:FF:000062', NULL, NULL, 'Patched-related protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(108744, NULL, 'G3DSA:1.25.10.10:FF:000472', NULL, NULL, 'Protein phosphatase PP2A regulatory subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(108745, NULL, 'G3DSA:1.25.40.20:FF:000853', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(108746, NULL, 'G3DSA:3.20.20.220:FF:000028', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(108747, NULL, 'G3DSA:1.10.3430.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(108748, NULL, 'G3DSA:1.10.540.10:FF:000136', NULL, NULL, 'GM09085p', NULL, NULL, NULL, NULL, NULL, 4),
(108749, NULL, 'G3DSA:3.40.50.300:FF:002611', NULL, NULL, 'Cell cycle checkpoint protein Rad17, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108750, NULL, 'G3DSA:1.25.40.10:FF:000850', NULL, NULL, 'Pre-mRNA-splicing factor SYF1', NULL, NULL, NULL, NULL, NULL, 4),
(108751, NULL, 'G3DSA:1.20.1440.180:FF:000012', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(108752, NULL, 'G3DSA:2.60.40.10:FF:004252', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108753, NULL, 'G3DSA:3.30.70.3490:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108754, NULL, 'G3DSA:1.10.8.270:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108755, NULL, 'G3DSA:1.10.390.10:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108756, NULL, 'G3DSA:3.90.1750.10:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108757, NULL, 'G3DSA:1.25.40.10:FF:000187', NULL, NULL, 'cell division cycle protein 23 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(108758, NULL, 'G3DSA:2.30.170.40:FF:000001', NULL, NULL, '50S ribosomal protein L28', NULL, NULL, NULL, NULL, NULL, 4),
(108759, NULL, 'G3DSA:1.10.10.790:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108760, NULL, 'G3DSA:1.20.58.1480:FF:000001', NULL, NULL, 'Lon protease', NULL, NULL, NULL, NULL, NULL, 4),
(108761, NULL, 'G3DSA:3.60.130.30:FF:000002', NULL, NULL, 'Thymine dioxygenase JBP1', NULL, NULL, NULL, NULL, NULL, 4),
(108762, NULL, 'G3DSA:2.60.40.3510:FF:000028', NULL, NULL, 'Jag2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(108763, NULL, 'G3DSA:3.30.70.3540:FF:000004', NULL, NULL, 'Polyprotein 1ab', NULL, NULL, NULL, NULL, NULL, 4),
(108764, NULL, 'G3DSA:2.30.30.1160:FF:000004', NULL, NULL, 'GD18353', NULL, NULL, NULL, NULL, NULL, 4),
(108765, NULL, 'G3DSA:2.60.40.150:FF:000438', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(108766, NULL, 'G3DSA:3.80.30.20:FF:000013', NULL, NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(108767, NULL, 'G3DSA:3.40.50.300:FF:004960', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108768, NULL, 'G3DSA:1.10.510.10:FF:004350', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108769, NULL, 'G3DSA:3.40.630.30:FF:000348', NULL, NULL, 'Acteyltransferase GNAT family', NULL, NULL, NULL, NULL, NULL, 4),
(108770, NULL, 'G3DSA:3.40.50.300:FF:002257', NULL, NULL, 'ATP-dependent DNA helicase UvrD', NULL, NULL, NULL, NULL, NULL, 4),
(108771, NULL, 'G3DSA:3.40.50.300:FF:000357', NULL, NULL, 'ATP-dependent RNA helicase DDX19B', NULL, NULL, NULL, NULL, NULL, 4),
(108772, NULL, 'G3DSA:3.10.20.90:FF:000317', NULL, NULL, 'Polyubiquitin-B', NULL, NULL, NULL, NULL, NULL, 4),
(108773, NULL, 'G3DSA:2.40.50.150:FF:000029', NULL, NULL, 'Os10g0495600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(108774, NULL, 'G3DSA:3.30.200.20:FF:000023', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(108775, NULL, 'G3DSA:2.10.110.10:FF:000010', NULL, NULL, 'PDZ and LIM domain protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(108776, NULL, 'G3DSA:2.20.70.10:FF:000242', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(108777, NULL, 'G3DSA:1.10.455.10:FF:000005', NULL, NULL, 'Ribosomal protein S7', NULL, NULL, NULL, NULL, NULL, 4),
(108778, NULL, 'G3DSA:1.10.287.110:FF:000431', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108779, NULL, 'G3DSA:3.90.1150.10:FF:000231', NULL, NULL, 'RE58623p', NULL, NULL, NULL, NULL, NULL, 4),
(108780, NULL, 'G3DSA:1.20.5.820:FF:000002', NULL, NULL, 'Sec61 trimeric complex component', NULL, NULL, NULL, NULL, NULL, 4),
(108781, NULL, 'G3DSA:3.40.50.1440:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108782, NULL, 'G3DSA:3.40.630.10:FF:000342', NULL, NULL, 'Clan MH, family M18, aspartyl aminopeptidase-like metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(108783, NULL, 'G3DSA:3.20.180.20:FF:000022', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(108784, NULL, 'G3DSA:1.25.40.10:FF:004009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108785, NULL, 'G3DSA:3.90.70.10:FF:000720', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108786, NULL, 'G3DSA:2.60.40.10:FF:003976', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108787, NULL, 'G3DSA:3.30.70.270:FF:000101', NULL, NULL, 'DNA-directed polymerase kappa, putative (AFU_orthologue AFUA_7G01270)', NULL, NULL, NULL, NULL, NULL, 4),
(108788, NULL, 'G3DSA:3.30.428.70:FF:000004', NULL, NULL, 'Phosphorylase, putative (AFU_orthologue AFUA_5G14690)', NULL, NULL, NULL, NULL, NULL, 4),
(108789, NULL, 'G3DSA:2.40.10.10:FF:000541', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108790, NULL, 'G3DSA:3.90.76.10:FF:000008', NULL, NULL, 'ABC transporter substrate-binding protein component', NULL, NULL, NULL, NULL, NULL, 4),
(108791, NULL, 'G3DSA:2.60.40.10:FF:002661', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(108792, NULL, 'G3DSA:2.170.8.10:FF:000001', NULL, NULL, 'Phosphoenolpyruvate carboxykinase (ATP)', NULL, NULL, NULL, NULL, NULL, 4),
(108793, NULL, 'G3DSA:3.30.60.30:FF:000155', NULL, NULL, 'Reversion-inducing cysteine-rich protein with Kazal motifs', NULL, NULL, NULL, NULL, NULL, 4),
(108794, NULL, 'G3DSA:2.10.25.10:FF:000498', NULL, NULL, 'Low-density lipoprotein receptor-related protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(108795, NULL, 'G3DSA:3.40.50.1240:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108796, NULL, 'G3DSA:2.60.200.20:FF:000076', NULL, NULL, 'Nuclear inhibitor of protein phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(108797, NULL, 'G3DSA:2.10.110.20:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108798, NULL, 'G3DSA:3.40.50.150:FF:000840', NULL, NULL, 'Putative antibiotic resistance rRNA adenine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(108799, NULL, 'G3DSA:1.10.400.10:FF:000081', NULL, NULL, 'Guanine nucleotide-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108800, NULL, 'G3DSA:3.30.70.2820:FF:000007', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(108801, NULL, 'G3DSA:2.40.110.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108802, NULL, 'G3DSA:1.10.510.10:FF:000640', NULL, NULL, 'Serine/threonine-protein kinase PRR1', NULL, NULL, NULL, NULL, NULL, 4),
(108803, NULL, 'G3DSA:3.40.140.10:FF:000046', NULL, NULL, 'AMSH-like ubiquitin thioesterase 2', NULL, NULL, NULL, NULL, NULL, 4),
(108804, NULL, 'G3DSA:3.40.50.300:FF:002818', NULL, NULL, 'CHL1p Probable DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(108805, NULL, 'G3DSA:1.10.472.80:FF:000189', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108806, NULL, 'G3DSA:3.40.50.1820:FF:001593', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108807, NULL, 'G3DSA:2.60.40.1760:FF:000014', NULL, NULL, 'Glucoamylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(108808, NULL, 'G3DSA:1.10.357.10:FF:000007', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(108809, NULL, 'G3DSA:1.25.40.20:FF:000292', NULL, NULL, 'No mechanoreceptor potential C, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(108810, NULL, 'G3DSA:3.40.50.1000:FF:000049', NULL, NULL, 'Class B acid phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(108811, NULL, 'G3DSA:3.30.710.10:FF:000103', NULL, NULL, 'Kelch-like 6 (Drosophila) (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(108812, NULL, 'G3DSA:3.10.110.10:FF:000135', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 G1', NULL, NULL, NULL, NULL, NULL, 4),
(108813, NULL, 'G3DSA:3.40.50.300:FF:008338', NULL, NULL, 'tRNA isopentenyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108814, NULL, 'G3DSA:3.30.60.20:FF:000152', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(108815, NULL, 'G3DSA:2.60.40.60:FF:000186', NULL, NULL, 'FAT atypical cadherin 2', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(108816, NULL, 'G3DSA:1.10.150.240:FF:000021', NULL, NULL, 'Hydrolase, haloacid dehalogenase-like family', NULL, NULL, NULL, NULL, NULL, 4),
(108817, NULL, 'G3DSA:1.10.8.870:FF:000025', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase (FAD-dependent), putative', NULL, NULL, NULL, NULL, NULL, 4),
(108818, NULL, 'G3DSA:1.10.1510.30:FF:000009', NULL, NULL, 'tRNA pseudouridine synthase D TruD', NULL, NULL, NULL, NULL, NULL, 4),
(108819, NULL, 'G3DSA:1.25.40.10:FF:004902', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108820, NULL, 'G3DSA:1.25.40.10:FF:002441', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g05670, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(108821, NULL, 'G3DSA:2.60.40.1080:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108822, NULL, 'G3DSA:3.30.420.80:FF:000006', NULL, NULL, '28S ribosomal protein S11, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(108823, NULL, 'G3DSA:2.80.10.50:FF:000287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108824, NULL, 'G3DSA:2.40.50.140:FF:000026', NULL, NULL, '30S ribosomal protein S17', NULL, NULL, NULL, NULL, NULL, 4),
(108825, NULL, 'G3DSA:3.30.160.60:FF:003150', NULL, NULL, 'Zinc finger protein 882', NULL, NULL, NULL, NULL, NULL, 4),
(108826, NULL, 'G3DSA:3.40.140.10:FF:000260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108827, NULL, 'G3DSA:3.40.1450.10:FF:000001', NULL, NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(108828, NULL, 'G3DSA:2.70.170.10:FF:000051', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(108829, NULL, 'G3DSA:3.40.50.300:FF:008445', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108830, NULL, 'G3DSA:3.60.15.10:FF:000043', NULL, NULL, 'Cleavage and polyadenylation specificity factor subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(108831, NULL, 'G3DSA:4.10.1240.10:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108832, NULL, 'G3DSA:2.70.150.10:FF:000044', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(108833, NULL, 'G3DSA:1.10.287.110:FF:000436', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(108834, NULL, 'G3DSA:1.10.10.10:FF:000741', NULL, NULL, 'Paired box protein Pax-5', NULL, NULL, NULL, NULL, NULL, 4),
(108835, NULL, 'G3DSA:2.60.120.260:FF:000340', NULL, NULL, 'YALI0E22825p', NULL, NULL, NULL, NULL, NULL, 4),
(108836, NULL, 'G3DSA:3.30.530.20:FF:000019', NULL, NULL, 'Abscisic acid receptor PYR1', NULL, NULL, NULL, NULL, NULL, 4),
(108837, NULL, 'G3DSA:1.10.10.2210:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108838, NULL, 'G3DSA:2.40.30.10:FF:000531', NULL, NULL, 'Mitochondrial tRNA-specific 2-thiouridylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(108839, NULL, 'G3DSA:1.20.5.340:FF:000066', NULL, NULL, 'Myosin-9', NULL, NULL, NULL, NULL, NULL, 4),
(108840, NULL, 'G3DSA:3.30.559.30:FF:000094', NULL, NULL, 'HC-toxin synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(108841, NULL, 'G3DSA:3.40.50.300:FF:005697', NULL, NULL, 'ORC1-type DNA replication protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(108842, NULL, 'G3DSA:3.10.490.10:FF:000056', NULL, NULL, 'Gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(108843, NULL, 'G3DSA:4.10.1140.10:FF:000001', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(108844, NULL, 'G3DSA:1.10.10.2200:FF:000001', NULL, NULL, 'Probable serine/threonine-protein kinase pats1', NULL, NULL, NULL, NULL, NULL, 4),
(108845, NULL, 'G3DSA:3.40.850.10:FF:000111', NULL, NULL, 'p-loop nucleoside triphosphate hydrolase superfamily protein with CH (Calponin Homology) domain', NULL, NULL, NULL, NULL, NULL, 4),
(108846, NULL, 'G3DSA:1.20.1250.40:FF:000018', NULL, NULL, 'WGS project CABT00000000 data, contig 2.3', NULL, NULL, NULL, NULL, NULL, 4),
(108847, NULL, 'G3DSA:2.130.10.10:FF:002751', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(108848, NULL, 'G3DSA:3.80.10.10:FF:003342', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108849, NULL, 'G3DSA:3.40.50.300:FF:004174', NULL, NULL, 'Multidrug resistance protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108850, NULL, 'G3DSA:3.40.50.80:FF:000005', NULL, NULL, 'NADH-cytochrome b5 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(108851, NULL, 'G3DSA:3.80.10.10:FF:003235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108852, NULL, 'G3DSA:1.20.120.230:FF:000021', NULL, NULL, 'Vinculin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(108853, NULL, 'G3DSA:2.10.110.10:FF:000330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108854, NULL, 'G3DSA:3.30.420.40:FF:000904', NULL, NULL, 'Immunoglobulin heavy chain binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108855, NULL, 'G3DSA:3.40.50.620:FF:000897', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108856, NULL, 'G3DSA:3.90.1170.10:FF:000007', NULL, NULL, 'Ribosomal protein L16', NULL, NULL, NULL, NULL, NULL, 4),
(108857, NULL, 'G3DSA:3.40.640.10:FF:000404', NULL, NULL, 'Uncharacterized aminotransferase C1039.07c', NULL, NULL, NULL, NULL, NULL, 4),
(108858, NULL, 'G3DSA:3.40.50.2300:FF:001529', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108859, NULL, 'G3DSA:3.40.50.150:FF:000615', NULL, NULL, 'Ubiquinone biosynthesis O-methyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(108860, NULL, 'G3DSA:3.40.850.10:FF:000004', NULL, NULL, 'Kinesin-like protein isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(108861, NULL, 'G3DSA:2.60.40.150:FF:000551', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108862, NULL, 'G3DSA:2.60.40.1180:FF:000037', NULL, NULL, 'Alpha-amylase A', NULL, NULL, NULL, NULL, NULL, 4),
(108863, NULL, 'G3DSA:1.10.510.10:FF:002096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108864, NULL, 'G3DSA:1.10.20.10:FF:000236', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108865, NULL, 'G3DSA:3.30.40.10:FF:001457', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108866, NULL, 'G3DSA:1.20.120.350:FF:000169', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108867, NULL, 'G3DSA:2.40.70.10:FF:000533', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108868, NULL, 'G3DSA:1.20.1250.20:FF:001209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108869, NULL, 'G3DSA:2.70.170.10:FF:000039', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(108870, NULL, 'G3DSA:3.30.160.60:FF:004353', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108871, NULL, 'G3DSA:2.40.50.140:FF:000251', NULL, NULL, 'MP18 RNA editing complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(108872, NULL, 'G3DSA:1.10.167.10:FF:000077', NULL, NULL, 'G protein-coupled receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(108873, NULL, 'G3DSA:3.40.720.10:FF:000349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108874, NULL, 'G3DSA:1.10.510.10:FF:000639', NULL, NULL, 'Related to serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(108875, NULL, 'G3DSA:3.40.50.150:FF:000508', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(108876, NULL, 'G3DSA:3.40.50.2300:FF:000006', NULL, NULL, 'Two-component system response regulator ArcA', NULL, NULL, NULL, NULL, NULL, 4),
(108877, NULL, 'G3DSA:3.10.330.20:FF:000003', NULL, NULL, 'tRNA (Adenine(58)-N(1))-methyltransferase, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(108878, NULL, 'G3DSA:2.60.40.150:FF:000444', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(108879, NULL, 'G3DSA:3.30.160.60:FF:005769', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108880, NULL, 'G3DSA:1.25.40.10:FF:002109', NULL, NULL, 'Tetratricopeptide repeat protein 30A', NULL, NULL, NULL, NULL, NULL, 4),
(108881, NULL, 'G3DSA:1.25.10.10:FF:002607', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(108882, NULL, 'G3DSA:3.90.70.10:FF:000832', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108883, NULL, 'G3DSA:3.30.160.60:FF:005983', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108884, NULL, 'G3DSA:3.30.70.1400:FF:000025', NULL, NULL, 'Sarcosine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(108885, NULL, 'G3DSA:1.10.418.10:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108886, NULL, 'G3DSA:2.60.40.1170:FF:000034', NULL, NULL, 'Putative AP-3 complex subunit mu', NULL, NULL, NULL, NULL, NULL, 4),
(108887, NULL, 'G3DSA:3.40.930.10:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108888, NULL, 'G3DSA:1.25.40.10:FF:002435', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At3g23330', NULL, NULL, NULL, NULL, NULL, 4),
(108889, NULL, 'G3DSA:3.30.110.110:FF:000018', NULL, NULL, 'Meiotic recombination 11', NULL, NULL, NULL, NULL, NULL, 4),
(108890, NULL, 'G3DSA:2.40.160.50:FF:000012', NULL, NULL, 'Outer membrane protein Omp85 family', NULL, NULL, NULL, NULL, NULL, 4),
(108891, NULL, 'G3DSA:3.80.10.10:FF:001195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108892, NULL, 'G3DSA:2.60.40.10:FF:002773', NULL, NULL, 'Tapasin long form', NULL, NULL, NULL, NULL, NULL, 4),
(108893, NULL, 'G3DSA:2.20.25.10:FF:000065', NULL, NULL, 'TFIIB zinc-binding, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108894, NULL, 'G3DSA:1.10.1450.10:FF:000072', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(108895, NULL, 'G3DSA:2.40.30.10:FF:000205', NULL, NULL, 'NADPH oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(108896, NULL, 'G3DSA:3.10.100.10:FF:000180', NULL, NULL, 'GD23749', NULL, NULL, NULL, NULL, NULL, 4),
(108897, NULL, 'G3DSA:1.20.58.390:FF:000165', NULL, NULL, 'AGAP007707-PA', NULL, NULL, NULL, NULL, NULL, 4),
(108898, NULL, 'G3DSA:2.60.120.260:FF:000014', NULL, NULL, 'E3 ubiquitin-protein ligase HECTD1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(108899, NULL, 'G3DSA:1.25.40.10:FF:002542', NULL, NULL, 'Pre-mRNA-splicing factor CLF1', NULL, NULL, NULL, NULL, NULL, 4),
(108900, NULL, 'G3DSA:3.40.30.10:FF:001080', NULL, NULL, 'UBX domain-containing protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(108901, NULL, 'G3DSA:3.40.50.790:FF:000009', NULL, NULL, '50S ribosomal protein L1, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108902, NULL, 'G3DSA:3.40.50.80:FF:000112', NULL, NULL, 'Putative nitrate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(108903, NULL, 'G3DSA:3.30.70.330:FF:000602', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(108904, NULL, 'G3DSA:2.60.40.60:FF:000287', NULL, NULL, 'Cadherin-4', NULL, NULL, NULL, NULL, NULL, 4),
(108905, NULL, 'G3DSA:3.40.50.150:FF:000941', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108906, NULL, 'G3DSA:3.10.450.10:FF:000054', NULL, NULL, 'Si:ch211-262h13.5', NULL, NULL, NULL, NULL, NULL, 4),
(108907, NULL, 'G3DSA:3.30.70.3250:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108908, NULL, 'G3DSA:1.10.1200.80:FF:000001', NULL, NULL, 'tRNA-dihydrouridine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(108909, NULL, 'G3DSA:3.80.10.10:FF:001088', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(108910, NULL, 'G3DSA:3.20.20.110:FF:000001', NULL, NULL, 'Ribulose bisphosphate carboxylase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(108911, NULL, 'G3DSA:2.30.29.30:FF:001383', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108912, NULL, 'G3DSA:3.40.50.300:FF:002717', NULL, NULL, 'Translation elongation factor EF-G', NULL, NULL, NULL, NULL, NULL, 4),
(108913, NULL, 'G3DSA:1.10.1170.10:FF:000022', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(108914, NULL, 'G3DSA:3.40.50.1110:FF:000088', NULL, NULL, 'Protein CBG20522', NULL, NULL, NULL, NULL, NULL, 4),
(108915, NULL, 'G3DSA:3.90.930.12:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108916, NULL, 'G3DSA:3.40.50.300:FF:006309', NULL, NULL, 'Discs, large homolog 4', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(108917, NULL, 'G3DSA:3.40.50.1100:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108918, NULL, 'G3DSA:3.10.100.10:FF:000073', NULL, NULL, 'Polycystic kidney disease protein 1-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(108919, NULL, 'G3DSA:2.130.10.10:FF:002318', NULL, NULL, 'Echinoderm microtubule-associated protein-like elp-1', NULL, NULL, NULL, NULL, NULL, 4),
(108920, NULL, 'G3DSA:3.30.70.890:FF:000068', NULL, NULL, 'Mevalonate 3-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(108921, NULL, 'G3DSA:3.30.160.60:FF:005876', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108922, NULL, 'G3DSA:1.25.40.10:FF:003739', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108923, NULL, 'G3DSA:3.30.1370.10:FF:000126', NULL, NULL, 'Protein CBR-SFA-1', NULL, NULL, NULL, NULL, NULL, 4),
(108924, NULL, 'G3DSA:3.30.420.10:FF:000694', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108925, NULL, 'G3DSA:1.25.40.10:FF:002328', NULL, NULL, 'Protein NPGR1', NULL, NULL, NULL, NULL, NULL, 4),
(108926, NULL, 'G3DSA:1.10.357.50:FF:000002', NULL, NULL, 'calcium-dependent secretion activator 2 isoform X7', NULL, NULL, NULL, NULL, NULL, 4),
(108927, NULL, 'G3DSA:2.30.42.10:FF:000160', NULL, NULL, 'RHPN1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(108928, NULL, 'G3DSA:1.25.10.10:FF:002714', NULL, NULL, 'Importin beta-like protein kap113', NULL, NULL, NULL, NULL, NULL, 4),
(108929, NULL, 'G3DSA:1.10.418.10:FF:000037', NULL, NULL, 'nesprin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(108930, NULL, 'G3DSA:2.10.25.10:FF:000947', NULL, NULL, 'Fat-like cadherin-related tumor suppressor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(108931, NULL, 'G3DSA:3.30.390.10:FF:000027', NULL, NULL, 'Muconate cycloisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(108932, NULL, 'G3DSA:3.10.150.10:FF:000014', NULL, NULL, 'Beta sliding clamp', NULL, NULL, NULL, NULL, NULL, 4),
(108933, NULL, 'G3DSA:1.10.150.530:FF:000001', NULL, NULL, 'Dual-specificity RNA methyltransferase RlmN', NULL, NULL, NULL, NULL, NULL, 4),
(108934, NULL, 'G3DSA:3.40.50.2000:FF:000242', NULL, NULL, 'Glycogen synthase', NULL, NULL, NULL, NULL, NULL, 4),
(108935, NULL, 'G3DSA:2.60.120.10:FF:000494', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108936, NULL, 'G3DSA:3.90.70.10:FF:000613', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108937, NULL, 'G3DSA:3.30.40.10:FF:000041', NULL, NULL, 'E3 ubiquitin-protein ligase SINAT3', NULL, NULL, NULL, NULL, NULL, 4),
(108938, NULL, 'G3DSA:1.20.1300.10:FF:000019', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(108939, NULL, 'G3DSA:1.10.150.240:FF:000009', NULL, NULL, 'Alpha-D-glucose-1-phosphate phosphatase YihX', NULL, NULL, NULL, NULL, NULL, 4),
(108940, NULL, 'G3DSA:3.40.50.1100:FF:000085', NULL, NULL, 'Threonine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(108941, NULL, 'G3DSA:3.30.70.20:FF:000091', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108942, NULL, 'G3DSA:3.30.160.60:FF:004572', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108943, NULL, 'G3DSA:1.20.1070.10:FF:001097', NULL, NULL, 'Opsin', NULL, NULL, NULL, NULL, NULL, 4),
(108944, NULL, 'G3DSA:3.30.160.60:FF:004460', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108945, NULL, 'G3DSA:3.10.170.20:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108946, NULL, 'G3DSA:1.10.287.70:FF:000795', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108947, NULL, 'G3DSA:2.60.40.150:FF:000337', NULL, NULL, 'U5 small nuclear ribonucleoprotein helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(108948, NULL, 'G3DSA:1.10.10.10:FF:002079', NULL, NULL, 'DNA topoisomerase VI, A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(108949, NULL, 'G3DSA:1.20.58.830:FF:000016', NULL, NULL, 'Erythrocyte binding antigen-181', NULL, NULL, NULL, NULL, NULL, 4),
(108950, NULL, 'G3DSA:3.90.79.10:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(108951, NULL, 'G3DSA:3.30.60.20:FF:000051', NULL, NULL, 'Thymidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(108952, NULL, 'G3DSA:1.20.1250.20:FF:001428', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108953, NULL, 'G3DSA:3.40.50.300:FF:004393', NULL, NULL, 'Ras family-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(108954, NULL, 'G3DSA:1.20.1070.10:FF:001327', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(108955, NULL, 'G3DSA:3.30.200.20:FF:002501', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108956, NULL, 'G3DSA:1.10.533.10:FF:000232', NULL, NULL, 'interleukin-1 receptor-associated kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(108957, NULL, 'G3DSA:3.30.2350.20:FF:000027', NULL, NULL, 'tRNA pseudouridine synthase d domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(108958, NULL, 'G3DSA:2.80.10.50:FF:000181', NULL, NULL, 'Fascin', NULL, NULL, NULL, NULL, NULL, 4),
(108959, NULL, 'G3DSA:3.30.60.30:FF:000054', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(108960, NULL, 'G3DSA:1.20.58.390:FF:000058', NULL, NULL, 'Nicotinic acetylcholine receptor alpha6, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(108961, NULL, 'G3DSA:3.30.1390.20:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108962, NULL, 'G3DSA:2.70.70.10:FF:000043', NULL, NULL, 'Conserved hypothetical secreted protein', NULL, NULL, NULL, NULL, NULL, 4),
(108963, NULL, 'G3DSA:2.60.260.20:FF:000080', NULL, NULL, 'DnaJ family protein', NULL, NULL, NULL, NULL, NULL, 4),
(108964, NULL, 'G3DSA:3.30.160.60:FF:002436', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108965, NULL, 'G3DSA:1.25.40.20:FF:001022', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(108966, NULL, 'G3DSA:3.40.50.2020:FF:000029', NULL, NULL, 'Orotate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(108967, NULL, 'G3DSA:3.30.160.750:FF:000001', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(108968, NULL, 'G3DSA:1.25.40.10:FF:002216', NULL, NULL, 'Os11g0460700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(108969, NULL, 'G3DSA:2.10.110.10:FF:000111', NULL, NULL, 'Four and a half LIM domains protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(108970, NULL, 'G3DSA:3.10.20.90:FF:000873', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108971, NULL, 'G3DSA:3.30.2350.10:FF:000024', NULL, NULL, 'Putative ribosomal large subunit pseudouridylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(108972, NULL, 'G3DSA:1.20.1070.10:FF:000130', NULL, NULL, 'Chemokine (C-C motif) receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(108973, NULL, 'G3DSA:3.40.50.10470:FF:000045', NULL, NULL, 'Translation initiation factor eIF2B alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(108974, NULL, 'G3DSA:2.70.150.10:FF:000263', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(108975, NULL, 'G3DSA:1.25.10.10:FF:001995', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108976, NULL, 'G3DSA:3.30.70.2170:FF:000003', NULL, NULL, 'V-type ATP synthase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(108977, NULL, 'G3DSA:3.30.390.50:FF:000011', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(108978, NULL, 'G3DSA:2.120.10.10:FF:000020', NULL, NULL, 'Glycoprotein G', NULL, NULL, NULL, NULL, NULL, 4),
(108979, NULL, 'G3DSA:2.70.170.10:FF:000270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108980, NULL, 'G3DSA:3.30.310.10:FF:000028', NULL, NULL, 'TATA-box-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(108981, NULL, 'G3DSA:2.60.40.10:FF:004027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108982, NULL, 'G3DSA:1.10.1410.10:FF:000070', NULL, NULL, 'DNA polymerase sigma-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(108983, NULL, 'G3DSA:2.40.50.430:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(108984, NULL, 'G3DSA:1.20.1600.10:FF:000059', NULL, NULL, 'Outer membrane efflux protein', NULL, NULL, NULL, NULL, NULL, 4),
(108985, NULL, 'G3DSA:3.30.1330.60:FF:000015', NULL, NULL, 'Outer membrane protein OmpA', NULL, NULL, NULL, NULL, NULL, 4),
(108986, NULL, 'G3DSA:2.60.40.150:FF:000118', NULL, NULL, 'otoferlin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(108987, NULL, 'G3DSA:3.40.50.300:FF:000677', NULL, NULL, 'ATP-dependent RNA helicase A', NULL, NULL, NULL, NULL, NULL, 4),
(108988, NULL, 'G3DSA:3.30.200.20:FF:000247', NULL, NULL, 'serine/threonine-protein kinase Nek4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(108989, NULL, 'G3DSA:1.20.1250.20:FF:000012', NULL, NULL, 'Nucleoside permease NupG', NULL, NULL, NULL, NULL, NULL, 4),
(108990, NULL, 'G3DSA:1.20.1250.20:FF:001198', NULL, NULL, 'Putative 3-phenylpropionic acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(108991, NULL, 'G3DSA:1.10.274.30:FF:000034', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(108992, NULL, 'G3DSA:3.20.20.70:FF:000581', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(108993, NULL, 'G3DSA:2.130.10.10:FF:000278', NULL, NULL, 'WD repeat-containing protein mip1', NULL, NULL, NULL, NULL, NULL, 4),
(108994, NULL, 'G3DSA:2.30.29.30:FF:001164', NULL, NULL, 'Si:ch211-122h15.4', NULL, NULL, NULL, NULL, NULL, 4),
(108995, NULL, 'G3DSA:4.10.640.10:FF:000008', NULL, NULL, '28S ribosomal protein S18b, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(108996, NULL, 'G3DSA:3.40.50.2000:FF:000023', NULL, NULL, 'ADP-heptose--LPS heptosyltransferase II', NULL, NULL, NULL, NULL, NULL, 4),
(108997, NULL, 'G3DSA:1.10.150.20:FF:000081', NULL, NULL, 'Protein translocation complex component (Npl1)', NULL, NULL, NULL, NULL, NULL, 4),
(108998, NULL, 'G3DSA:2.130.10.10:FF:002644', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(108999, NULL, 'G3DSA:3.40.50.1820:FF:001149', NULL, NULL, 'Triacylglycerol lipase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109000, NULL, 'G3DSA:1.20.1110.10:FF:000196', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109001, NULL, 'G3DSA:2.120.10.80:FF:000350', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109002, NULL, 'G3DSA:3.40.140.10:FF:000153', NULL, NULL, 'JAB1/MPN/MOV34 metalloenzyme domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(109003, NULL, 'G3DSA:1.25.40.10:FF:000311', NULL, NULL, 'Tetratricopeptide repeat domain 38', NULL, NULL, NULL, NULL, NULL, 4),
(109004, NULL, 'G3DSA:3.90.550.10:FF:000509', NULL, NULL, 'Exostosin-2', NULL, NULL, NULL, NULL, NULL, 4),
(109005, NULL, 'G3DSA:3.40.30.10:FF:000927', NULL, NULL, 'Uncharacterized protein C777.12c', NULL, NULL, NULL, NULL, NULL, 4),
(109006, NULL, 'G3DSA:3.30.200.20:FF:001877', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109007, NULL, 'G3DSA:3.40.50.300:FF:001301', NULL, NULL, 'Structural maintenance of chromosomes 5', NULL, NULL, NULL, NULL, NULL, 4),
(109008, NULL, 'G3DSA:3.30.450.40:FF:000176', NULL, NULL, 'Transcriptional regulator, IclR family', NULL, NULL, NULL, NULL, NULL, 4),
(109009, NULL, 'G3DSA:3.30.830.10:FF:000275', NULL, NULL, 'Protease of the insulinase family', NULL, NULL, NULL, NULL, NULL, 4),
(109010, NULL, 'G3DSA:1.20.120.1750:FF:000028', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(109011, NULL, 'G3DSA:2.60.40.10:FF:006051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109012, NULL, 'G3DSA:2.40.30.10:FF:000317', NULL, NULL, 'Elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(109013, NULL, 'G3DSA:3.30.497.10:FF:000112', NULL, NULL, 'Protease nexin PN-1', NULL, NULL, NULL, NULL, NULL, 4),
(109014, NULL, 'G3DSA:3.40.525.10:FF:000002', NULL, NULL, 'Alpha-tocopherol transfer protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(109015, NULL, 'G3DSA:3.40.50.1000:FF:000622', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109016, NULL, 'G3DSA:1.25.40.10:FF:003958', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109017, NULL, 'G3DSA:1.10.10.60:FF:000267', NULL, NULL, 'HTH-type transcriptional regulator GadX', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(109018, NULL, 'G3DSA:2.10.22.10:FF:000002', NULL, NULL, 'Cysteine rich transmembrane BMP regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(109019, NULL, 'G3DSA:3.40.50.2300:FF:000118', NULL, NULL, 'Maltose regulon regulatory protein MalI', NULL, NULL, NULL, NULL, NULL, 4),
(109020, NULL, 'G3DSA:1.10.510.10:FF:004243', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109021, NULL, 'G3DSA:2.60.40.10:FF:004920', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109022, NULL, 'G3DSA:2.120.10.30:FF:000026', NULL, NULL, 'hedgehog-interacting protein-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(109023, NULL, 'G3DSA:2.60.120.260:FF:000233', NULL, NULL, 'Anaphase promoting complex, subunit 10-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(109024, NULL, 'G3DSA:1.10.287.110:FF:000324', NULL, NULL, 'DnaJ-like protein subfamily C member 8', NULL, NULL, NULL, NULL, NULL, 4),
(109025, NULL, 'G3DSA:1.10.510.10:FF:000084', NULL, NULL, 'Wall-associated receptor kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(109026, NULL, 'G3DSA:3.20.20.120:FF:000009', NULL, NULL, 'L-talarate/galactarate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(109027, NULL, 'G3DSA:3.10.20.90:FF:000654', NULL, NULL, 'Small ubiquitin-related modifier 5', NULL, NULL, NULL, NULL, NULL, 4),
(109028, NULL, 'G3DSA:1.20.120.350:FF:000057', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(109029, NULL, 'G3DSA:2.70.130.10:FF:000161', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109030, NULL, 'G3DSA:3.80.10.10:FF:001318', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(109031, NULL, 'G3DSA:2.60.40.10:FF:002554', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109032, NULL, 'G3DSA:1.10.472.10:FF:000084', NULL, NULL, 'PCL9p Cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(109033, NULL, 'G3DSA:3.40.50.300:FF:008333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109034, NULL, 'G3DSA:1.25.40.10:FF:004801', NULL, NULL, 'Paf1 complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(109035, NULL, 'G3DSA:3.90.550.10:FF:000280', NULL, NULL, 'CDP-glycerol:poly(Glycerophosphate) glycerophosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(109036, NULL, 'G3DSA:3.90.950.10:FF:000023', NULL, NULL, 'Inosine triphosphate pyrophosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109037, NULL, 'G3DSA:3.30.70.1450:FF:000012', NULL, NULL, 'Trk system potassium uptake protein TrkA', NULL, NULL, NULL, NULL, NULL, 4),
(109038, NULL, 'G3DSA:3.90.550.10:FF:000616', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109039, NULL, 'G3DSA:3.20.80.10:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109040, NULL, 'G3DSA:1.25.40.240:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109041, NULL, 'G3DSA:2.20.70.10:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109042, NULL, 'G3DSA:3.20.20.100:FF:000003', NULL, NULL, 'Aldo-keto reductase family 1 member C3', NULL, NULL, NULL, NULL, NULL, 4),
(109043, NULL, 'G3DSA:3.40.50.1820:FF:001823', NULL, NULL, 'Triacylglycerol lipase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109044, NULL, 'G3DSA:2.60.120.920:FF:000139', NULL, NULL, 'FinTRIM family, member 82', NULL, NULL, NULL, NULL, NULL, 4),
(109045, NULL, 'G3DSA:3.90.550.50:FF:000044', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(109046, NULL, 'G3DSA:3.30.310.130:FF:000036', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109047, NULL, 'G3DSA:1.20.1070.10:FF:001546', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109048, NULL, 'G3DSA:1.10.10.60:FF:000048', NULL, NULL, 'Distal-less homeobox 2', NULL, NULL, NULL, NULL, NULL, 4),
(109049, NULL, 'G3DSA:2.20.100.10:FF:000001', NULL, NULL, 'semaphorin-5A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(109050, NULL, 'G3DSA:1.10.510.10:FF:002556', NULL, NULL, 'Putative mitogen-activated protein kinase kinase kinase 7-like', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(109051, NULL, 'G3DSA:1.10.1170.10:FF:000027', NULL, NULL, 'Baculoviral IAP repeat-containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(109052, NULL, 'G3DSA:3.30.70.330:FF:000035', NULL, NULL, '60S ribosomal protein L23a', NULL, NULL, NULL, NULL, NULL, 4),
(109053, NULL, 'G3DSA:3.40.50.1820:FF:000300', NULL, NULL, 'Lysosomal thioesterase PPT2-B', NULL, NULL, NULL, NULL, NULL, 4),
(109054, NULL, 'G3DSA:3.40.50.1000:FF:000841', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109055, NULL, 'G3DSA:2.30.29.230:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109056, NULL, 'G3DSA:1.10.472.10:FF:000202', NULL, NULL, 'BnaA03g50910D protein', NULL, NULL, NULL, NULL, NULL, 4),
(109057, NULL, 'G3DSA:3.30.110.150:FF:000002', NULL, NULL, 'Cell division protein SepF', NULL, NULL, NULL, NULL, NULL, 4),
(109058, NULL, 'G3DSA:3.80.10.10:FF:003454', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109059, NULL, 'G3DSA:1.10.238.10:FF:000158', NULL, NULL, 'Calcium-dependent protein kinase 28', NULL, NULL, NULL, NULL, NULL, 4),
(109060, NULL, 'G3DSA:3.90.1290.10:FF:000056', NULL, NULL, 'Microtubule-actin crosslinking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(109061, NULL, 'G3DSA:3.40.50.300:FF:006079', NULL, NULL, 'Elongation factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109062, NULL, 'G3DSA:3.40.50.10190:FF:000287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109063, NULL, 'G3DSA:3.30.60.190:FF:000013', NULL, NULL, 'Box C/D snoRNA processing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109064, NULL, 'G3DSA:3.30.200.20:FF:001658', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109065, NULL, 'G3DSA:3.30.70.330:FF:002171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109066, NULL, 'G3DSA:3.30.70.340:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109067, NULL, 'G3DSA:3.10.100.10:FF:000410', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109068, NULL, 'G3DSA:2.60.40.150:FF:000332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109069, NULL, 'G3DSA:3.40.50.880:FF:000036', NULL, NULL, 'Imidazole glycerol phosphate synthase hisHF', NULL, NULL, NULL, NULL, NULL, 4),
(109070, NULL, 'G3DSA:3.90.1170.10:FF:000002', NULL, NULL, '60S ribosomal protein L10', NULL, NULL, NULL, NULL, NULL, 4),
(109071, NULL, 'G3DSA:3.40.630.30:FF:000685', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109072, NULL, 'G3DSA:1.25.40.10:FF:000530', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g74850, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(109073, NULL, 'G3DSA:1.20.140.100:FF:000003', NULL, NULL, 'Dynein, axonemal, heavy chain 5', NULL, NULL, NULL, NULL, NULL, 4),
(109074, NULL, 'G3DSA:1.10.20.10:FF:000124', NULL, NULL, 'CCAAT-HAP3 transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(109075, NULL, 'G3DSA:1.25.40.20:FF:000533', NULL, NULL, 'ankyrin repeat and SAM domain-containing protein 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(109076, NULL, 'G3DSA:3.40.50.1820:FF:001475', NULL, NULL, 'Uncharacterized protein C8F11.08c', NULL, NULL, NULL, NULL, NULL, 4),
(109077, NULL, 'G3DSA:2.30.42.10:FF:000053', NULL, NULL, 'FERM and PDZ domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(109078, NULL, 'G3DSA:2.60.40.2860:FF:000001', NULL, NULL, '6-cysteine protein', NULL, NULL, NULL, NULL, NULL, 4),
(109079, NULL, 'G3DSA:1.20.1250.20:FF:000231', NULL, NULL, 'EmrB/QacA subfamily drug resistance transporter', NULL, NULL, NULL, NULL, NULL, 4),
(109080, NULL, 'G3DSA:1.10.1200.10:FF:000149', NULL, NULL, 'Polyketide synthase/nonribosomal peptide synthetase hybrid RzxA', NULL, NULL, NULL, NULL, NULL, 4),
(109081, NULL, 'G3DSA:1.10.150.20:FF:000204', NULL, NULL, 'PIN domain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(109082, NULL, 'G3DSA:2.10.110.10:FF:000116', NULL, NULL, 'Ap, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(109083, NULL, 'G3DSA:1.10.238.10:FF:000832', NULL, NULL, 'Calmodulin-like protein 10', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(109084, NULL, 'G3DSA:3.30.420.40:FF:000348', NULL, NULL, 'Transcriptional regulator Mb0495', NULL, NULL, NULL, NULL, NULL, 4),
(109085, NULL, 'G3DSA:2.60.40.10:FF:002447', NULL, NULL, 'Related to J kappa-recombination signal binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(109086, NULL, 'G3DSA:3.40.50.300:FF:008226', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(109087, NULL, 'G3DSA:3.40.640.10:FF:000067', NULL, NULL, 'Aminotransferase, class I/classII', NULL, NULL, NULL, NULL, NULL, 4),
(109088, NULL, 'G3DSA:3.30.830.10:FF:000270', NULL, NULL, 'Clan ME, family M16, insulinase-like metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(109089, NULL, 'G3DSA:3.30.390.60:FF:000014', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(109090, NULL, 'G3DSA:1.25.10.10:FF:000921', NULL, NULL, 'USO1 (Yeast transport protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(109091, NULL, 'G3DSA:3.30.200.20:FF:000135', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(109092, NULL, 'G3DSA:3.30.540.10:FF:000056', NULL, NULL, 'Fructose-1,6-bisphosphatase class 1', NULL, NULL, NULL, NULL, NULL, 4),
(109093, NULL, 'G3DSA:3.10.450.720:FF:000001', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase F', NULL, NULL, NULL, NULL, NULL, 4),
(109094, NULL, 'G3DSA:3.30.40.10:FF:001238', NULL, NULL, 'Increased DNA methylation 1', NULL, NULL, NULL, NULL, NULL, 4),
(109095, NULL, 'G3DSA:1.10.510.10:FF:000191', NULL, NULL, 'cyclin-dependent kinase-like 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(109096, NULL, 'G3DSA:3.40.50.300:FF:005005', NULL, NULL, 'Elongation factor EF-2', NULL, NULL, NULL, NULL, NULL, 4),
(109097, NULL, 'G3DSA:3.30.70.330:FF:001895', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109098, NULL, 'G3DSA:1.10.20.10:FF:000017', NULL, NULL, 'Ccaat-binding factor complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(109099, NULL, 'G3DSA:2.60.40.10:FF:004353', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109100, NULL, 'G3DSA:2.10.25.10:FF:001330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109101, NULL, 'G3DSA:3.40.30.10:FF:000591', NULL, NULL, 'Protein CBG18221', NULL, NULL, NULL, NULL, NULL, 4),
(109102, NULL, 'G3DSA:3.40.50.150:FF:000048', NULL, NULL, 'Spermidine synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(109103, NULL, 'G3DSA:2.80.10.50:FF:000186', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(109104, NULL, 'G3DSA:3.30.160.60:FF:001132', NULL, NULL, 'Zinc finger protein 341', NULL, NULL, NULL, NULL, NULL, 4),
(109105, NULL, 'G3DSA:1.20.1250.80:FF:000002', NULL, NULL, 'Interleukin 34', NULL, NULL, NULL, NULL, NULL, 4),
(109106, NULL, 'G3DSA:2.170.270.10:FF:000118', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(109107, NULL, 'G3DSA:1.10.30.10:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109108, NULL, 'G3DSA:2.30.29.240:FF:000013', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(109109, NULL, 'G3DSA:4.10.860.120:FF:000014', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(109110, NULL, 'G3DSA:3.30.710.10:FF:000002', NULL, NULL, 'Potassium voltage-gated channel subfamily C member 2', NULL, NULL, NULL, NULL, NULL, 4),
(109111, NULL, 'G3DSA:1.10.510.10:FF:004355', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109112, NULL, 'G3DSA:2.120.10.80:FF:000131', NULL, NULL, 'Kel3p', NULL, NULL, NULL, NULL, NULL, 4),
(109113, NULL, 'G3DSA:1.20.1270.350:FF:000001', NULL, NULL, 'dedicator of cytokinesis protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(109114, NULL, 'G3DSA:1.10.8.1190:FF:000001', NULL, NULL, 'Replicase polyprotein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(109115, NULL, 'G3DSA:3.30.200.20:FF:000028', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(109116, NULL, 'G3DSA:3.40.1090.10:FF:000029', NULL, NULL, 'Triacylglycerol lipase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(109117, NULL, 'G3DSA:2.40.110.10:FF:000076', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109118, NULL, 'G3DSA:1.20.1250.20:FF:001754', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109119, NULL, 'G3DSA:2.40.30.10:FF:000312', NULL, NULL, 'Peroxisome biogenesis protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(109120, NULL, 'G3DSA:3.30.160.60:FF:000856', NULL, NULL, 'B-box zinc finger protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(109121, NULL, 'G3DSA:1.10.510.10:FF:004462', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109122, NULL, 'G3DSA:2.60.40.10:FF:004701', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109123, NULL, 'G3DSA:1.10.20.120:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109124, NULL, 'G3DSA:1.10.10.10:FF:001697', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109125, NULL, 'G3DSA:2.60.120.650:FF:000024', NULL, NULL, 'Putative jumonji family transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(109126, NULL, 'G3DSA:3.60.20.40:FF:000019', NULL, NULL, 'ACY1 bifunctional acylase', NULL, NULL, NULL, NULL, NULL, 4),
(109127, NULL, 'G3DSA:1.20.1310.10:FF:000071', NULL, NULL, 'Ubiquitin-protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109128, NULL, 'G3DSA:3.40.50.880:FF:000143', NULL, NULL, 'Intraflagellar transport protein IFT52, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109129, NULL, 'G3DSA:1.10.720.60:FF:000007', NULL, NULL, 'Enolase-phosphatase E1', NULL, NULL, NULL, NULL, NULL, 4),
(109130, NULL, 'G3DSA:2.30.30.40:FF:000164', NULL, NULL, 'Cell division control protein', NULL, NULL, NULL, NULL, NULL, 4),
(109131, NULL, 'G3DSA:3.30.200.20:FF:000354', NULL, NULL, 'AGC/YANK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(109132, NULL, 'G3DSA:2.130.10.10:FF:002195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109133, NULL, 'G3DSA:4.10.400.10:FF:000362', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109134, NULL, 'G3DSA:1.10.1620.20:FF:000009', NULL, NULL, 'Putative ATP synthase subunit epsilon, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(109135, NULL, 'G3DSA:2.60.34.10:FF:000134', NULL, NULL, 'Heat shock protein 70 (HSP70)-4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109136, NULL, 'G3DSA:1.20.120.230:FF:000026', NULL, NULL, 'Rhea, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(109137, NULL, 'G3DSA:2.40.160.60:FF:000010', NULL, NULL, 'Outer membrane protein P1 (OmpP1)', NULL, NULL, NULL, NULL, NULL, 4),
(109138, NULL, 'G3DSA:3.40.50.2300:FF:000225', NULL, NULL, 'Sigma-54-dependent Fis family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(109139, NULL, 'G3DSA:3.30.160.60:FF:000637', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(109140, NULL, 'G3DSA:3.60.20.30:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109141, NULL, 'G3DSA:2.110.10.10:FF:000009', NULL, NULL, 'Hemopexin', NULL, NULL, NULL, NULL, NULL, 4),
(109142, NULL, 'G3DSA:2.30.30.30:FF:000161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109143, NULL, 'G3DSA:2.130.10.10:FF:002537', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109144, NULL, 'G3DSA:3.40.190.10:FF:000083', NULL, NULL, 'HTH-type transcriptional regulator MetR', NULL, NULL, NULL, NULL, NULL, 4),
(109145, NULL, 'G3DSA:3.90.70.10:FF:000725', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109146, NULL, 'G3DSA:3.90.79.20:FF:000029', NULL, NULL, 'Probable NADH pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(109147, NULL, 'G3DSA:3.40.50.2000:FF:000130', NULL, NULL, 'Glycosyl transferases group 1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(109148, NULL, 'G3DSA:3.30.70.660:FF:000010', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(109149, NULL, 'G3DSA:3.10.20.740:FF:000012', NULL, NULL, 'Formate dehydrogenase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(109150, NULL, 'G3DSA:1.25.40.20:FF:001241', NULL, NULL, 'Transient receptor potential channel pyrexia', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(109151, NULL, 'G3DSA:3.40.50.300:FF:004623', NULL, NULL, 'SNF2 family N-terminal domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(109152, NULL, 'G3DSA:2.40.30.170:FF:000031', NULL, NULL, 'Multidrug resistance protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109153, NULL, 'G3DSA:3.40.50.300:FF:002594', NULL, NULL, 'Pilus assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(109154, NULL, 'G3DSA:2.40.30.10:FF:000194', NULL, NULL, '50S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(109155, NULL, 'G3DSA:2.60.40.10:FF:002228', NULL, NULL, 'EPH receptor B2', NULL, NULL, NULL, NULL, NULL, 4),
(109156, NULL, 'G3DSA:1.10.238.10:FF:000725', NULL, NULL, 'Calmodulin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109157, NULL, 'G3DSA:3.40.50.300:FF:008007', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(109158, NULL, 'G3DSA:3.40.47.10:FF:000112', NULL, NULL, '3-oxoacyl-(Acyl-carrier-protein) synthase II', NULL, NULL, NULL, NULL, NULL, 4),
(109159, NULL, 'G3DSA:3.90.79.10:FF:000026', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(109160, NULL, 'G3DSA:1.10.720.50:FF:000004', NULL, NULL, 'DNA (cytosine-5-)-methyltransferase 3 beta, duplicate a', NULL, NULL, NULL, NULL, NULL, 4),
(109161, NULL, 'G3DSA:2.40.50.100:FF:000161', NULL, NULL, 'Exosome complex component CSL4', NULL, NULL, NULL, NULL, NULL, 4),
(109162, NULL, 'G3DSA:1.10.238.10:FF:000377', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(109163, NULL, 'G3DSA:1.25.40.20:FF:000752', NULL, NULL, 'Si:dkey-9i23.14', NULL, NULL, NULL, NULL, NULL, 4),
(109164, NULL, 'G3DSA:1.20.1250.20:FF:001193', NULL, NULL, 'Signal transducer', NULL, NULL, NULL, NULL, NULL, 4),
(109165, NULL, 'G3DSA:3.80.10.10:FF:003673', NULL, NULL, 'SCF E3 ubiquitin ligase complex F-box protein pof2', NULL, NULL, NULL, NULL, NULL, 4),
(109166, NULL, 'G3DSA:1.10.472.10:FF:000421', NULL, NULL, 'D1-type cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(109167, NULL, 'G3DSA:3.30.40.10:FF:002300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109168, NULL, 'G3DSA:2.60.40.1120:FF:000047', NULL, NULL, 'TonB-linked outer membrane protein, SusC/RagA family', NULL, NULL, NULL, NULL, NULL, 4),
(109169, NULL, 'G3DSA:3.30.30.10:FF:000001', NULL, NULL, 'Drosomycin 13', NULL, NULL, NULL, NULL, NULL, 4),
(109170, NULL, 'G3DSA:1.20.272.10:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109171, NULL, 'G3DSA:3.40.50.2020:FF:000136', NULL, NULL, 'Ribose-phosphate pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(109172, NULL, 'G3DSA:1.20.1250.20:FF:001316', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109173, NULL, 'G3DSA:3.30.40.10:FF:001676', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(109174, NULL, 'G3DSA:1.10.20.10:FF:000343', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109175, NULL, 'G3DSA:1.25.10.10:FF:000360', NULL, NULL, 'AP-3 complex subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(109176, NULL, 'G3DSA:1.10.238.10:FF:001001', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(109177, NULL, 'G3DSA:3.40.50.1820:FF:001256', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(109178, NULL, 'G3DSA:2.40.70.10:FF:000314', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109179, NULL, 'G3DSA:3.30.428.10:FF:000014', NULL, NULL, 'Putative histidine triad (HIT) protein', NULL, NULL, NULL, NULL, NULL, 4),
(109180, NULL, 'G3DSA:3.10.20.90:FF:000980', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109181, NULL, 'G3DSA:1.10.720.40:FF:000001', NULL, NULL, 'LEM domain containing 2, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(109182, NULL, 'G3DSA:1.25.40.10:FF:002104', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At3g05240', NULL, NULL, NULL, NULL, NULL, 4),
(109183, NULL, 'G3DSA:2.130.10.10:FF:003948', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(109184, NULL, 'G3DSA:3.10.50.40:FF:000158', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(109185, NULL, 'G3DSA:3.30.70.1230:FF:000188', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109186, NULL, 'G3DSA:1.10.560.10:FF:000143', NULL, NULL, 'Chaperonin 60 subunit alpha 2 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(109187, NULL, 'G3DSA:3.40.50.300:FF:004281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109188, NULL, 'G3DSA:3.40.50.150:FF:001689', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109189, NULL, 'G3DSA:1.10.1510.30:FF:000010', NULL, NULL, 'Probable tRNA pseudouridine synthase D', NULL, NULL, NULL, NULL, NULL, 4),
(109190, NULL, 'G3DSA:2.40.100.10:FF:000031', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(109191, NULL, 'G3DSA:1.10.287.110:FF:000217', NULL, NULL, 'DnaJ heat shock protein family (Hsp40) member B5', NULL, NULL, NULL, NULL, NULL, 4),
(109192, NULL, 'G3DSA:3.10.20.90:FF:000087', NULL, NULL, 'Inhibitor of nuclear factor kappa B kinase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(109193, NULL, 'G3DSA:3.90.70.10:FF:000506', NULL, NULL, 'Cathepsin L-like cysteine proteinase', NULL, NULL, NULL, NULL, NULL, 4),
(109194, NULL, 'G3DSA:2.40.50.140:FF:000144', NULL, NULL, 'Aspartate--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(109195, NULL, 'G3DSA:2.40.180.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109196, NULL, 'G3DSA:1.20.120.350:FF:000276', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109197, NULL, 'G3DSA:2.60.40.150:FF:000556', NULL, NULL, 'C2-domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109198, NULL, 'G3DSA:2.60.40.60:FF:000961', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109199, NULL, 'G3DSA:1.25.40.1050:FF:000002', NULL, NULL, '5''-3'' exoribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(109200, NULL, 'G3DSA:3.10.20.90:FF:000435', NULL, NULL, 'UBX domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(109201, NULL, 'G3DSA:2.30.180.10:FF:000178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109202, NULL, 'G3DSA:3.80.10.10:FF:001537', NULL, NULL, 'Si:ch211-233m11.1', NULL, NULL, NULL, NULL, NULL, 4),
(109203, NULL, 'G3DSA:3.40.50.10860:FF:000055', NULL, NULL, 'Methenyl tetrahydrofolate cyclohydrolase / NADP-dependent methylene H4F dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(109204, NULL, 'G3DSA:3.40.50.1780:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109205, NULL, 'G3DSA:3.90.79.10:FF:000245', NULL, NULL, 'Isopentenyl-diphosphate Delta-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(109206, NULL, 'G3DSA:3.30.160.60:FF:000424', NULL, NULL, 'Zinc finger protein 140', NULL, NULL, NULL, NULL, NULL, 4),
(109207, NULL, 'G3DSA:3.90.1170.20:FF:000005', NULL, NULL, 'Nicotinate-nucleotide pyrophosphorylase [carboxylating]', NULL, NULL, NULL, NULL, NULL, 4),
(109208, NULL, 'G3DSA:3.30.420.10:FF:000587', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109209, NULL, 'G3DSA:3.40.50.300:FF:008552', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109210, NULL, 'G3DSA:1.20.1250.20:FF:001535', NULL, NULL, 'Facilitated trehalose transporter Tret1-2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(109211, NULL, 'G3DSA:2.60.40.60:FF:000068', NULL, NULL, 'Desmoglein 1', NULL, NULL, NULL, NULL, NULL, 4),
(109212, NULL, 'G3DSA:2.40.20.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109213, NULL, 'G3DSA:3.40.190.10:FF:000206', NULL, NULL, 'Ferric iron ABC transporter, iron-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(109214, NULL, 'G3DSA:1.25.40.10:FF:002323', NULL, NULL, 'Lethal (2) k14710, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(109215, NULL, 'G3DSA:3.40.630.30:FF:000466', NULL, NULL, 'Acetyltransferase, GNAT family', NULL, NULL, NULL, NULL, NULL, 4),
(109216, NULL, 'G3DSA:1.10.510.10:FF:004136', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(109217, NULL, 'G3DSA:3.40.50.200:FF:000198', NULL, NULL, 'Putative serine protease (Putative secreted protein)', NULL, NULL, NULL, NULL, NULL, 4),
(109218, NULL, 'G3DSA:3.90.226.10:FF:000127', NULL, NULL, 'Malonate decarboxylase, gamma subunit', NULL, NULL, NULL, NULL, NULL, 4),
(109219, NULL, 'G3DSA:3.90.70.10:FF:000158', NULL, NULL, 'CathePsin Z', NULL, NULL, NULL, NULL, NULL, 4),
(109220, NULL, 'G3DSA:3.40.109.10:FF:000024', NULL, NULL, 'Nitroreductase', NULL, NULL, NULL, NULL, NULL, 4),
(109221, NULL, 'G3DSA:2.60.40.10:FF:002099', NULL, NULL, 'Glycoprotein E', NULL, NULL, NULL, NULL, NULL, 4),
(109222, NULL, 'G3DSA:3.40.50.150:FF:000722', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109223, NULL, 'G3DSA:1.10.220.150:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109224, NULL, 'G3DSA:3.90.120.10:FF:000011', NULL, NULL, 'Cytosine-C5 specific DNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(109225, NULL, 'G3DSA:3.40.120.10:FF:000039', NULL, NULL, 'Phosphoacetylglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(109226, NULL, 'G3DSA:3.40.50.720:FF:000123', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(109227, NULL, 'G3DSA:2.60.40.10:FF:003858', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109228, NULL, 'G3DSA:3.30.379.10:FF:000001', NULL, NULL, 'Beta-hexosaminidase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(109229, NULL, 'G3DSA:2.60.120.200:FF:000131', NULL, NULL, 'Probable alpha-L-arabinofuranosidase B', NULL, NULL, NULL, NULL, NULL, 4),
(109230, NULL, 'G3DSA:3.10.330.10:FF:000005', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(109231, NULL, 'G3DSA:1.25.40.10:FF:000069', NULL, NULL, 'CTR9 homolog, Paf1/RNA polymerase II complex component', NULL, NULL, NULL, NULL, NULL, 4),
(109232, NULL, 'G3DSA:3.60.20.10:FF:000010', NULL, NULL, 'Proteasome subunit beta type-1', NULL, NULL, NULL, NULL, NULL, 4),
(109233, NULL, 'G3DSA:1.10.1370.30:FF:000021', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(109234, NULL, 'G3DSA:3.30.50.10:FF:000103', NULL, NULL, 'Zinc finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109235, NULL, 'G3DSA:3.10.330.20:FF:000008', NULL, NULL, 'tRNA (Adenine-N(1)-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(109236, NULL, 'G3DSA:2.30.130.10:FF:000029', NULL, NULL, 'tRNA pseudouridine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(109237, NULL, 'G3DSA:3.10.100.10:FF:000292', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109238, NULL, 'G3DSA:2.60.40.1170:FF:000039', NULL, NULL, 'Coatomer subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(109239, NULL, 'G3DSA:3.40.50.12440:FF:000001', NULL, NULL, 'Nitrate reductase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(109240, NULL, 'G3DSA:3.40.50.1820:FF:001604', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109241, NULL, 'G3DSA:2.60.40.790:FF:000057', NULL, NULL, 'Small heat shock protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109242, NULL, 'G3DSA:1.10.506.10:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109243, NULL, 'G3DSA:3.40.850.20:FF:000002', NULL, NULL, 'Vegetative interaction with Kar3p', NULL, NULL, NULL, NULL, NULL, 4),
(109244, NULL, 'G3DSA:3.10.20.30:FF:000108', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109245, NULL, 'G3DSA:2.130.10.10:FF:000520', NULL, NULL, 'Protein CYPRO4', NULL, NULL, NULL, NULL, NULL, 4),
(109246, NULL, 'G3DSA:1.10.238.10:FF:000506', NULL, NULL, 'Calcium-binding protein CML38', NULL, NULL, NULL, NULL, NULL, 4),
(109247, NULL, 'G3DSA:2.60.40.10:FF:004134', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109248, NULL, 'G3DSA:1.20.1070.10:FF:001765', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109249, NULL, 'G3DSA:1.10.3720.10:FF:000071', NULL, NULL, 'Binding-protein dependent transport system inner membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(109250, NULL, 'G3DSA:3.40.50.1100:FF:000208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(109251, NULL, 'G3DSA:3.30.70.330:FF:001676', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109252, NULL, 'G3DSA:3.30.420.510:FF:000006', NULL, NULL, 'Pantothenate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(109253, NULL, 'G3DSA:3.30.160.60:FF:002099', NULL, NULL, 'Zinc finger protein 589', NULL, NULL, NULL, NULL, NULL, 4),
(109254, NULL, 'G3DSA:3.40.630.10:FF:000460', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109255, NULL, 'G3DSA:1.10.132.60:FF:000028', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(109256, NULL, 'G3DSA:2.30.30.40:FF:000377', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(109257, NULL, 'G3DSA:1.25.10.10:FF:000702', NULL, NULL, 'Putative sister chromatid cohesion and DNA repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(109258, NULL, 'G3DSA:3.10.28.10:FF:000007', NULL, NULL, 'Intron-encoded DNA endonuclease aI3', NULL, NULL, NULL, NULL, NULL, 4),
(109259, NULL, 'G3DSA:3.30.730.20:FF:000001', NULL, NULL, 'Cell division activator CedA', NULL, NULL, NULL, NULL, NULL, 4),
(109260, NULL, 'G3DSA:3.70.10.10:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109261, NULL, 'G3DSA:2.60.40.60:FF:000742', NULL, NULL, 'Cdh-4', NULL, NULL, NULL, NULL, NULL, 4),
(109262, NULL, 'G3DSA:1.10.340.30:FF:000025', NULL, NULL, 'Endonuclease III homolog', NULL, NULL, NULL, NULL, NULL, 4),
(109263, NULL, 'G3DSA:3.30.160.60:FF:006152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109264, NULL, 'G3DSA:3.40.50.10810:FF:000068', NULL, NULL, 'SNF2 domain-containing protein / helicase domain-containing protein / zinc finger protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(109265, NULL, 'G3DSA:3.10.20.90:FF:000542', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109266, NULL, 'G3DSA:1.25.40.20:FF:000639', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109267, NULL, 'G3DSA:1.10.10.10:FF:000393', NULL, NULL, 'Oocyte-specific H1 histone', NULL, NULL, NULL, NULL, NULL, 4),
(109268, NULL, 'G3DSA:3.40.1230.10:FF:000018', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109269, NULL, 'G3DSA:3.30.1370.70:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109270, NULL, 'G3DSA:1.10.10.10:FF:001011', NULL, NULL, 'LuxR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(109271, NULL, 'G3DSA:3.30.450.50:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109272, NULL, 'G3DSA:1.10.287.110:FF:000094', NULL, NULL, 'dnaJ homolog subfamily C member 28', NULL, NULL, NULL, NULL, NULL, 4),
(109273, NULL, 'G3DSA:3.30.830.10:FF:000051', NULL, NULL, 'A-pheromone processing metallopeptidase Ste23', NULL, NULL, NULL, NULL, NULL, 4),
(109274, NULL, 'G3DSA:3.30.160.60:FF:002880', NULL, NULL, 'Zinc finger imprinted 3', NULL, NULL, NULL, NULL, NULL, 4),
(109275, NULL, 'G3DSA:3.30.70.1070:FF:000005', NULL, NULL, 'Endolytic peptidoglycan transglycosylase RlpA', NULL, NULL, NULL, NULL, NULL, 4),
(109276, NULL, 'G3DSA:3.40.50.150:FF:000273', NULL, NULL, 'NOL1/NOP2/Sun domain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(109277, NULL, 'G3DSA:1.10.472.10:FF:000314', NULL, NULL, 'GD19061', NULL, NULL, NULL, NULL, NULL, 4),
(109278, NULL, 'G3DSA:2.60.40.2170:FF:000002', NULL, NULL, 'Tyrosine-protein kinase RYK', NULL, NULL, NULL, NULL, NULL, 4),
(109279, NULL, 'G3DSA:3.30.70.1060:FF:000002', NULL, NULL, 'Possible muconolactone isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(109280, NULL, 'G3DSA:3.40.50.1820:FF:001711', NULL, NULL, 'Oxysterol-binding protein-related protein 3B', NULL, NULL, NULL, NULL, NULL, 4),
(109281, NULL, 'G3DSA:1.10.510.10:FF:003967', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109282, NULL, 'G3DSA:3.30.70.330:FF:000147', NULL, NULL, 'Apoptotic chromatin condensation inducer in the nucleus', NULL, NULL, NULL, NULL, NULL, 4),
(109283, NULL, 'G3DSA:2.40.50.100:FF:000048', NULL, NULL, 'Protein Abitram', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(109284, NULL, 'G3DSA:3.30.200.20:FF:002046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109285, NULL, 'G3DSA:2.70.20.10:FF:000001', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(109286, NULL, 'G3DSA:2.30.30.30:FF:000048', NULL, NULL, 'Mitochondrial ribosomal protein L2', NULL, NULL, NULL, NULL, NULL, 4),
(109287, NULL, 'G3DSA:1.10.510.10:FF:002444', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109288, NULL, 'G3DSA:2.130.10.130:FF:000016', NULL, NULL, 'Phosphatidylinositol-glycan-specific phospholipase D', NULL, NULL, NULL, NULL, NULL, 4),
(109289, NULL, 'G3DSA:1.10.3720.10:FF:000065', NULL, NULL, 'Peptide ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(109290, NULL, 'G3DSA:3.40.50.150:FF:001796', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109291, NULL, 'G3DSA:2.120.10.30:FF:000470', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109292, NULL, 'G3DSA:3.40.50.300:FF:004516', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(109293, NULL, 'G3DSA:3.30.160.60:FF:000750', NULL, NULL, 'replication initiator 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(109294, NULL, 'G3DSA:1.20.1420.30:FF:000051', NULL, NULL, 'Na+/Ca+ antiporter, CaCA family', NULL, NULL, NULL, NULL, NULL, 4),
(109295, NULL, 'G3DSA:1.10.287.1040:FF:000014', NULL, NULL, 'Exodeoxyribonuclease 7 small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(109296, NULL, 'G3DSA:2.90.10.10:FF:000005', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(109297, NULL, 'G3DSA:3.40.630.30:FF:000573', NULL, NULL, 'Si:ch211-196f2.7', NULL, NULL, NULL, NULL, NULL, 4),
(109298, NULL, 'G3DSA:2.60.200.20:FF:000205', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(109299, NULL, 'G3DSA:2.130.10.10:FF:004117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109300, NULL, 'G3DSA:3.40.630.10:FF:000128', NULL, NULL, 'Protein CBG20482', NULL, NULL, NULL, NULL, NULL, 4),
(109301, NULL, 'G3DSA:3.30.365.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109302, NULL, 'G3DSA:3.30.1360.120:FF:000047', NULL, NULL, 'IBA57, iron-sulfur cluster assembly', NULL, NULL, NULL, NULL, NULL, 4),
(109303, NULL, 'G3DSA:3.90.550.10:FF:000386', NULL, NULL, '2-phospho-L-lactate guanylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(109304, NULL, 'G3DSA:2.60.40.10:FF:000194', NULL, NULL, 'Intercellular adhesion molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(109305, NULL, 'G3DSA:2.30.30.40:FF:000490', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109306, NULL, 'G3DSA:3.40.50.1010:FF:000277', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109307, NULL, 'G3DSA:3.40.50.1980:FF:000084', NULL, NULL, 'Iron-dicitrate ABC transporter bindinglipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(109308, NULL, 'G3DSA:3.40.50.300:FF:002369', NULL, NULL, 'GTPase HflX', NULL, NULL, NULL, NULL, NULL, 4),
(109309, NULL, 'G3DSA:3.30.160.60:FF:000418', NULL, NULL, 'zinc finger protein 48', NULL, NULL, NULL, NULL, NULL, 4),
(109310, NULL, 'G3DSA:3.50.50.60:FF:000145', NULL, NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(109311, NULL, 'G3DSA:3.30.420.80:FF:000001', NULL, NULL, '30S ribosomal protein S11', NULL, NULL, NULL, NULL, NULL, 4),
(109312, NULL, 'G3DSA:1.10.287.940:FF:000005', NULL, NULL, 'P2X purinoceptor', NULL, NULL, NULL, NULL, NULL, 4),
(109313, NULL, 'G3DSA:1.10.287.930:FF:000002', NULL, NULL, 'Potassium voltage-gated channel subfamily S member 1', NULL, NULL, NULL, NULL, NULL, 4),
(109314, NULL, 'G3DSA:2.120.10.30:FF:000138', NULL, NULL, 'Megalin, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(109315, NULL, 'G3DSA:1.20.1070.10:FF:001771', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109316, NULL, 'G3DSA:3.40.47.10:FF:000005', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase I', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(109317, NULL, 'G3DSA:3.90.70.10:FF:000490', NULL, NULL, 'Clan CA, family C1, cathepsin L-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(109318, NULL, 'G3DSA:2.30.30.40:FF:000383', NULL, NULL, 'Chemotaxis protein CheW', NULL, NULL, NULL, NULL, NULL, 4),
(109319, NULL, 'G3DSA:2.60.120.650:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109320, NULL, 'G3DSA:3.60.21.10:FF:000226', NULL, NULL, 'Purple acid phosphatase 3', NULL, NULL, NULL, NULL, NULL, 4),
(109321, NULL, 'G3DSA:3.10.20.90:FF:000429', NULL, NULL, 'Plexin C1', NULL, NULL, NULL, NULL, NULL, 4),
(109322, NULL, 'G3DSA:3.40.630.10:FF:000454', NULL, NULL, 'Nicastrin', NULL, NULL, NULL, NULL, NULL, 4),
(109323, NULL, 'G3DSA:1.25.40.20:FF:000746', NULL, NULL, 'Ankyrin repeat-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(109324, NULL, 'G3DSA:1.25.40.10:FF:000743', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(109325, NULL, 'G3DSA:1.20.1110.10:FF:000084', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(109326, NULL, 'G3DSA:1.20.1540.10:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109327, NULL, 'G3DSA:3.40.50.1240:FF:000109', NULL, NULL, 'Phosphoglycerate mutase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(109328, NULL, 'G3DSA:3.20.20.190:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109329, NULL, 'G3DSA:3.30.70.330:FF:002401', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109330, NULL, 'G3DSA:2.60.40.830:FF:000002', NULL, NULL, 'Cytochrome f', NULL, NULL, NULL, NULL, NULL, 4),
(109331, NULL, 'G3DSA:3.90.1720.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109332, NULL, 'G3DSA:3.30.360.10:FF:000076', NULL, NULL, 'Aspartate-semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(109333, NULL, 'G3DSA:3.30.70.330:FF:000260', NULL, NULL, 'Polypyrimidine tract-binding protein homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(109334, NULL, 'G3DSA:3.30.565.10:FF:000265', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(109335, NULL, 'G3DSA:3.40.50.10810:FF:000181', NULL, NULL, 'ATP-dependent helicase HepA', NULL, NULL, NULL, NULL, NULL, 4),
(109336, NULL, 'G3DSA:2.40.320.10:FF:000007', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 18', NULL, NULL, NULL, NULL, NULL, 4),
(109337, NULL, 'G3DSA:2.130.10.10:FF:004224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109338, NULL, 'G3DSA:1.10.560.10:FF:000137', NULL, NULL, 'T-complex protein 1 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(109339, NULL, 'G3DSA:1.10.287.40:FF:000016', NULL, NULL, 'Seryl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(109340, NULL, 'G3DSA:3.40.190.10:FF:000431', NULL, NULL, 'Sensor domain-containing diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(109341, NULL, 'G3DSA:2.40.70.10:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109342, NULL, 'G3DSA:1.25.10.10:FF:002265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109343, NULL, 'G3DSA:1.25.40.10:FF:004015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109344, NULL, 'G3DSA:1.25.10.10:FF:000135', NULL, NULL, 'Plakophilin 1', NULL, NULL, NULL, NULL, NULL, 4),
(109345, NULL, 'G3DSA:3.40.109.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109346, NULL, 'G3DSA:1.10.287.3510:FF:000007', NULL, NULL, 'Na+/H+ antiporter subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(109347, NULL, 'G3DSA:2.40.50.100:FF:000155', NULL, NULL, 'Bll5772 protein', NULL, NULL, NULL, NULL, NULL, 4),
(109348, NULL, 'G3DSA:3.30.70.20:FF:000107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109349, NULL, 'G3DSA:3.30.450.40:FF:000064', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(109350, NULL, 'G3DSA:3.40.30.10:FF:000697', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(109351, NULL, 'G3DSA:3.80.30.20:FF:000018', NULL, NULL, 'Anaerobic magnesium-protoporphyrin IX monomethyl ester cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(109352, NULL, 'G3DSA:1.10.1000.11:FF:000034', NULL, NULL, 'Ankyrin repeat, PH and SEC7 domain containing protein secG', NULL, NULL, NULL, NULL, NULL, 4),
(109353, NULL, 'G3DSA:1.50.40.10:FF:000348', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109354, NULL, 'G3DSA:3.30.160.60:FF:001025', NULL, NULL, 'zinc finger protein 34', NULL, NULL, NULL, NULL, NULL, 4),
(109355, NULL, 'G3DSA:3.80.10.10:FF:001543', NULL, NULL, 'Leucine-rich transmembrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109356, NULL, 'G3DSA:3.70.10.10:FF:000099', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109357, NULL, 'G3DSA:3.40.50.1240:FF:000216', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109358, NULL, 'G3DSA:3.10.110.10:FF:000023', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 J2', NULL, NULL, NULL, NULL, NULL, 4),
(109359, NULL, 'G3DSA:3.30.505.10:FF:000048', NULL, NULL, 'Signal transducer and transcription activator 6', NULL, NULL, NULL, NULL, NULL, 4),
(109360, NULL, 'G3DSA:3.30.1680.10:FF:000009', NULL, NULL, 'Semaphorin 6B isoform 3 variant', NULL, NULL, NULL, NULL, NULL, 4),
(109361, NULL, 'G3DSA:1.25.10.10:FF:000028', NULL, NULL, 'Transportin-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(109362, NULL, 'G3DSA:3.40.50.20:FF:000010', NULL, NULL, 'Propionyl-CoA carboxylase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(109363, NULL, 'G3DSA:3.30.450.30:FF:000061', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109364, NULL, 'G3DSA:1.20.1310.10:FF:000065', NULL, NULL, 'Cullin-like protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(109365, NULL, 'G3DSA:3.40.50.300:FF:006753', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109366, NULL, 'G3DSA:3.30.160.60:FF:004802', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109367, NULL, 'G3DSA:3.10.110.10:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109368, NULL, 'G3DSA:3.40.47.10:FF:000224', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109369, NULL, 'G3DSA:3.40.50.300:FF:000464', NULL, NULL, 'GTP-binding protein ypt5', NULL, NULL, NULL, NULL, NULL, 4),
(109370, NULL, 'G3DSA:2.60.120.1190:FF:000006', NULL, NULL, 'Discoidin domain-containing receptor tyrosine kinase B', NULL, NULL, NULL, NULL, NULL, 4),
(109371, NULL, 'G3DSA:2.40.70.10:FF:000078', NULL, NULL, 'Eukaryotic aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(109372, NULL, 'G3DSA:1.10.238.10:FF:000613', NULL, NULL, 'Putative centrin', NULL, NULL, NULL, NULL, NULL, 4),
(109373, NULL, 'G3DSA:3.10.450.50:FF:000043', NULL, NULL, 'mRNA export factor mex67, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109374, NULL, 'G3DSA:3.30.70.330:FF:002620', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109375, NULL, 'G3DSA:1.20.120.530:FF:000009', NULL, NULL, 'DNA-binding transcriptional repressor LldR', NULL, NULL, NULL, NULL, NULL, 4),
(109376, NULL, 'G3DSA:3.10.110.10:FF:000130', NULL, NULL, 'Ubiquitin-conjugating enzyme E2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109377, NULL, 'G3DSA:3.30.420.40:FF:000455', NULL, NULL, 'Heat shock protein 70', NULL, NULL, NULL, NULL, NULL, 4),
(109378, NULL, 'G3DSA:3.40.50.1820:FF:001368', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109379, NULL, 'G3DSA:2.40.33.10:FF:000009', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(109380, NULL, 'G3DSA:3.90.1100.10:FF:000060', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(109381, NULL, 'G3DSA:1.10.439.10:FF:000001', NULL, NULL, 'Acyl-homoserine lactone acylase QuiP', NULL, NULL, NULL, NULL, NULL, 4),
(109382, NULL, 'G3DSA:2.10.150.10:FF:000001', NULL, NULL, 'Urease subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(109383, NULL, 'G3DSA:1.10.238.10:FF:000383', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(109384, NULL, 'G3DSA:3.40.50.300:FF:004735', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit beta-2', NULL, NULL, NULL, NULL, NULL, 4),
(109385, NULL, 'G3DSA:3.60.21.10:FF:000445', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109386, NULL, 'G3DSA:2.130.10.10:FF:002083', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(109387, NULL, 'G3DSA:3.30.40.10:FF:001912', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109388, NULL, 'G3DSA:1.20.85.10:FF:000008', NULL, NULL, 'Photosynthetic reaction center subunit L', NULL, NULL, NULL, NULL, NULL, 4),
(109389, NULL, 'G3DSA:1.20.272.10:FF:000044', NULL, NULL, 'RFC (DNA replication factor) family', NULL, NULL, NULL, NULL, NULL, 4),
(109390, NULL, 'G3DSA:1.10.1600.10:FF:000005', NULL, NULL, 'ATP-dependent DNA helicase II subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(109391, NULL, 'G3DSA:3.90.70.10:FF:000383', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109392, NULL, 'G3DSA:3.90.70.10:FF:000271', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(109393, NULL, 'G3DSA:1.20.58.390:FF:000277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109394, NULL, 'G3DSA:1.20.1070.10:FF:001439', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(109395, NULL, 'G3DSA:3.20.20.210:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109396, NULL, 'G3DSA:3.10.20.90:FF:000199', NULL, NULL, 'fermitin family homolog 3', NULL, NULL, NULL, NULL, NULL, 4),
(109397, NULL, 'G3DSA:1.10.1410.10:FF:000069', NULL, NULL, 'Nucleolar protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(109398, NULL, 'G3DSA:2.60.40.1400:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109399, NULL, 'G3DSA:1.20.58.120:FF:000005', NULL, NULL, 'BAG family molecular chaperone regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(109400, NULL, 'G3DSA:1.25.40.10:FF:004234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109401, NULL, 'G3DSA:3.20.20.220:FF:000034', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(109402, NULL, 'G3DSA:3.40.30.10:FF:001203', NULL, NULL, 'Calsequestrin', NULL, NULL, NULL, NULL, NULL, 4),
(109403, NULL, 'G3DSA:1.10.540.10:FF:000029', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(109404, NULL, 'G3DSA:1.10.510.10:FF:000533', NULL, NULL, 'cyclin-dependent kinase 10', NULL, NULL, NULL, NULL, NULL, 4),
(109405, NULL, 'G3DSA:1.10.3210.10:FF:000094', NULL, NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(109406, NULL, 'G3DSA:3.90.550.10:FF:000167', NULL, NULL, 'UDP-N-acetylglucosamine pyrophosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(109407, NULL, 'G3DSA:1.20.58.2220:FF:000038', NULL, NULL, 'Cappuccino', NULL, NULL, NULL, NULL, NULL, 4),
(109408, NULL, 'G3DSA:1.25.40.10:FF:003397', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g37310', NULL, NULL, NULL, NULL, NULL, 4),
(109409, NULL, 'G3DSA:3.90.226.10:FF:000021', NULL, NULL, 'Acetyl-CoA carboxylase carboxyltransferase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(109410, NULL, 'G3DSA:2.60.40.60:FF:000635', NULL, NULL, 'AGAP002828-PA', NULL, NULL, NULL, NULL, NULL, 4),
(109411, NULL, 'G3DSA:2.10.25.10:FF:001223', NULL, NULL, 'Nimrod C1, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(109412, NULL, 'G3DSA:1.10.10.60:FF:000615', NULL, NULL, 'Distal-less homeobox 4', NULL, NULL, NULL, NULL, NULL, 4),
(109413, NULL, 'G3DSA:2.60.40.60:FF:000523', NULL, NULL, 'AGAP002828-PA', NULL, NULL, NULL, NULL, NULL, 4),
(109414, NULL, 'G3DSA:3.30.160.60:FF:002548', NULL, NULL, 'Zinc finger and SCAN domain-containing protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(109415, NULL, 'G3DSA:1.20.140.150:FF:000085', NULL, NULL, 'epithelial membrane protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(109416, NULL, 'G3DSA:1.10.287.950:FF:000008', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(109417, NULL, 'G3DSA:2.60.40.10:FF:005769', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109418, NULL, 'G3DSA:2.10.70.10:FF:000237', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109419, NULL, 'G3DSA:3.40.630.10:FF:000235', NULL, NULL, 'Carboxypeptidase Z', NULL, NULL, NULL, NULL, NULL, 4),
(109420, NULL, 'G3DSA:1.20.1520.10:FF:000002', NULL, NULL, 'ADP-ribosylation factor-like protein 2-binding protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(109421, NULL, 'G3DSA:3.10.20.90:FF:000761', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(109422, NULL, 'G3DSA:4.10.280.10:FF:000149', NULL, NULL, 'Related to centromere binding factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(109423, NULL, 'G3DSA:1.20.144.10:FF:000112', NULL, NULL, 'Acid phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(109424, NULL, 'G3DSA:3.40.50.1000:FF:000274', NULL, NULL, 'Phosphatidyl synthase', NULL, NULL, NULL, NULL, NULL, 4),
(109425, NULL, 'G3DSA:3.30.420.210:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109426, NULL, 'G3DSA:3.30.70.920:FF:000009', NULL, NULL, 'AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(109427, NULL, 'G3DSA:2.60.40.10:FF:002335', NULL, NULL, 'Calmodulin-binding transcription activator CBT', NULL, NULL, NULL, NULL, NULL, 4),
(109428, NULL, 'G3DSA:2.60.34.10:FF:000027', NULL, NULL, 'Heat shock 70 kDa protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(109429, NULL, 'G3DSA:1.10.3930.10:FF:000002', NULL, NULL, 'Arginine deiminase', NULL, NULL, NULL, NULL, NULL, 4),
(109430, NULL, 'G3DSA:2.60.11.10:FF:000003', NULL, NULL, 'Cytochrome c oxidase subunit IV', NULL, NULL, NULL, NULL, NULL, 4),
(109431, NULL, 'G3DSA:1.25.10.10:FF:002501', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109432, NULL, 'G3DSA:2.30.30.40:FF:000271', NULL, NULL, 'Protein BZZ1', NULL, NULL, NULL, NULL, NULL, 4),
(109433, NULL, 'G3DSA:3.90.230.10:FF:000019', NULL, NULL, 'Methionine aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(109434, NULL, 'G3DSA:1.20.58.110:FF:000002', NULL, NULL, '30S ribosomal protein S20', NULL, NULL, NULL, NULL, NULL, 4),
(109435, NULL, 'G3DSA:2.10.25.10:FF:001442', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109436, NULL, 'G3DSA:3.40.960.10:FF:000007', NULL, NULL, 'Very short patch repair endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(109437, NULL, 'G3DSA:1.10.10.2390:FF:000001', NULL, NULL, 'DUF3349 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(109438, NULL, 'G3DSA:2.60.40.10:FF:005988', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109439, NULL, 'G3DSA:1.10.418.60:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109440, NULL, 'G3DSA:3.30.70.330:FF:001783', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109441, NULL, 'G3DSA:4.10.400.10:FF:000249', NULL, NULL, 'LDL receptor protein 1, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(109442, NULL, 'G3DSA:3.90.226.10:FF:000240', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(109443, NULL, 'G3DSA:2.130.10.10:FF:004336', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(109444, NULL, 'G3DSA:3.40.50.720:FF:001433', NULL, NULL, 'Probable polyketide synthase 32', NULL, NULL, NULL, NULL, NULL, 4),
(109445, NULL, 'G3DSA:3.30.1330.120:FF:000007', NULL, NULL, 'Bll6362 protein', NULL, NULL, NULL, NULL, NULL, 4),
(109446, NULL, 'G3DSA:3.30.565.10:FF:000046', NULL, NULL, 'Signal transduction histidine-protein kinase BaeS', NULL, NULL, NULL, NULL, NULL, 4),
(109447, NULL, 'G3DSA:3.40.532.10:FF:000018', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase isozyme L1', NULL, NULL, NULL, NULL, NULL, 4),
(109448, NULL, 'G3DSA:3.30.200.20:FF:001664', NULL, NULL, 'Putative receptor-like protein kinase At2g30940', NULL, NULL, NULL, NULL, NULL, 4),
(109449, NULL, 'G3DSA:1.10.10.60:FF:000054', NULL, NULL, 'One cut domain family member', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(109450, NULL, 'G3DSA:1.25.40.690:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109451, NULL, 'G3DSA:3.30.870.10:FF:000047', NULL, NULL, 'Probable tyrosyl-DNA phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(109452, NULL, 'G3DSA:1.10.10.440:FF:000057', NULL, NULL, 'Transcription elongation regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(109453, NULL, 'G3DSA:2.130.10.10:FF:003499', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(109454, NULL, 'G3DSA:3.40.50.300:FF:003898', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(109455, NULL, 'G3DSA:2.60.40.60:FF:001130', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109456, NULL, 'G3DSA:1.10.3260.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109457, NULL, 'G3DSA:3.80.10.10:FF:001762', NULL, NULL, 'Tehao, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(109458, NULL, 'G3DSA:3.40.30.10:FF:000585', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(109459, NULL, 'G3DSA:3.80.10.10:FF:000014', NULL, NULL, 'Leucine-rich repeat and immunoglobulin-like domain-containing nogo receptor-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(109460, NULL, 'G3DSA:3.30.540.10:FF:000062', NULL, NULL, 'Inositol polyphosphate 1-phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109461, NULL, 'G3DSA:3.40.50.1390:FF:000014', NULL, NULL, 'DNA invertase', NULL, NULL, NULL, NULL, NULL, 4),
(109462, NULL, 'G3DSA:3.90.132.10:FF:000022', NULL, NULL, 'GP63-like', NULL, NULL, NULL, NULL, NULL, 4),
(109463, NULL, 'G3DSA:1.20.1560.10:FF:000111', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(109464, NULL, 'G3DSA:3.40.50.720:FF:000016', NULL, NULL, 'GDP-mannose 4,6-dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(109465, NULL, 'G3DSA:1.25.10.10:FF:002484', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109466, NULL, 'G3DSA:3.30.590.10:FF:000008', NULL, NULL, 'Gamma-glutamylputrescine synthetase PuuA', NULL, NULL, NULL, NULL, NULL, 4),
(109467, NULL, 'G3DSA:3.40.50.12160:FF:000018', NULL, NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(109468, NULL, 'G3DSA:3.90.1300.10:FF:000041', NULL, NULL, 'Fatty acid amide hydrolase, gene 1', NULL, NULL, NULL, NULL, NULL, 4),
(109469, NULL, 'G3DSA:1.10.510.10:FF:001140', NULL, NULL, 'Prr2p', NULL, NULL, NULL, NULL, NULL, 4),
(109470, NULL, 'G3DSA:2.20.70.10:FF:000135', NULL, NULL, 'U1 snRNP protein', NULL, NULL, NULL, NULL, NULL, 4),
(109471, NULL, 'G3DSA:3.40.50.1380:FF:000011', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(109472, NULL, 'G3DSA:2.130.10.10:FF:000065', NULL, NULL, 'WD repeat-containing protein 82', NULL, NULL, NULL, NULL, NULL, 4),
(109473, NULL, 'G3DSA:3.90.550.50:FF:000151', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(109474, NULL, 'G3DSA:1.20.5.1160:FF:000023', NULL, NULL, 'Intermediate filament protein ifa-1', NULL, NULL, NULL, NULL, NULL, 4),
(109475, NULL, 'G3DSA:3.40.50.2060:FF:000013', NULL, NULL, 'SNARE docking complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(109476, NULL, 'G3DSA:1.20.120.1750:FF:000141', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(109477, NULL, 'G3DSA:1.10.472.10:FF:000078', NULL, NULL, 'Cyclin-C1-2', NULL, NULL, NULL, NULL, NULL, 4),
(109478, NULL, 'G3DSA:3.30.420.40:FF:000017', NULL, NULL, 'Heat shock 70 kDa protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(109479, NULL, 'G3DSA:3.30.70.330:FF:001906', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109480, NULL, 'G3DSA:3.40.50.10420:FF:000058', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(109481, NULL, 'G3DSA:1.25.40.10:FF:000524', NULL, NULL, 'Transcription elongation factor GreA', NULL, NULL, NULL, NULL, NULL, 4),
(109482, NULL, 'G3DSA:3.30.160.60:FF:002329', NULL, NULL, 'Si:dkeyp-44b5.5', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(109483, NULL, 'G3DSA:1.50.40.10:FF:000567', NULL, NULL, 'Uncharacterized mitochondrial carrier C8C9.12c', NULL, NULL, NULL, NULL, NULL, 4),
(109484, NULL, 'G3DSA:3.30.1370.240:FF:000012', NULL, NULL, 'Phenylalanine-tRNA ligase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(109485, NULL, 'G3DSA:2.70.150.10:FF:000156', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(109486, NULL, 'G3DSA:2.10.25.10:FF:001661', NULL, NULL, 'Vacuolar-sorting receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(109487, NULL, 'G3DSA:3.40.50.150:FF:000379', NULL, NULL, 'Trans-aconitate 2-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(109488, NULL, 'G3DSA:1.20.1070.10:FF:000023', NULL, NULL, 'Relaxin family peptide receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(109489, NULL, 'G3DSA:1.25.40.20:FF:000527', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(109490, NULL, 'G3DSA:3.80.10.10:FF:003448', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109491, NULL, 'G3DSA:3.30.830.10:FF:000163', NULL, NULL, 'Os01g0779100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(109492, NULL, 'G3DSA:3.30.160.60:FF:004459', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109493, NULL, 'G3DSA:1.20.140.40:FF:000090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109494, NULL, 'G3DSA:1.10.275.40:FF:000005', NULL, NULL, 'TFIIH basal transcription factor complex helicase XPD subunit', NULL, NULL, NULL, NULL, NULL, 4),
(109495, NULL, 'G3DSA:2.30.29.30:FF:000995', NULL, NULL, 'Dynamin-related GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(109496, NULL, 'G3DSA:3.30.70.920:FF:000010', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(109497, NULL, 'G3DSA:3.10.310.20:FF:000007', NULL, NULL, 'protein prune homolog', NULL, NULL, NULL, NULL, NULL, 4),
(109498, NULL, 'G3DSA:3.40.640.10:FF:000174', NULL, NULL, 'Probable hercynylcysteine sulfoxide lyase', NULL, NULL, NULL, NULL, NULL, 4),
(109499, NULL, 'G3DSA:1.10.357.20:FF:000016', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109500, NULL, 'G3DSA:3.20.20.30:FF:000012', NULL, NULL, 'Alkanesulfonate monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(109501, NULL, 'G3DSA:1.10.357.10:FF:000013', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(109502, NULL, 'G3DSA:3.30.70.330:FF:000041', NULL, NULL, 'Epithelial splicing regulatory protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(109503, NULL, 'G3DSA:3.10.110.10:FF:000129', NULL, NULL, 'DEAD/DEAH box helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109504, NULL, 'G3DSA:2.60.200.20:FF:000082', NULL, NULL, 'DNA damage response protein RcaA', NULL, NULL, NULL, NULL, NULL, 4),
(109505, NULL, 'G3DSA:3.20.20.80:FF:000111', NULL, NULL, 'Soluble cell wall protein', NULL, NULL, NULL, NULL, NULL, 4),
(109506, NULL, 'G3DSA:3.10.20.30:FF:000097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109507, NULL, 'G3DSA:3.40.630.10:FF:000016', NULL, NULL, 'IAA-amino acid hydrolase ILR1-like 4', NULL, NULL, NULL, NULL, NULL, 4),
(109508, NULL, 'G3DSA:3.10.100.10:FF:000303', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109509, NULL, 'G3DSA:3.40.50.720:FF:001539', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109510, NULL, 'G3DSA:2.40.70.10:FF:000421', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109511, NULL, 'G3DSA:2.40.50.150:FF:000035', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(109512, NULL, 'G3DSA:3.40.640.10:FF:000516', NULL, NULL, 'Putative diaminobutyrate-pyruvate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(109513, NULL, 'G3DSA:3.30.160.60:FF:000188', NULL, NULL, 'Zinc finger protein 787', NULL, NULL, NULL, NULL, NULL, 4),
(109514, NULL, 'G3DSA:1.10.530.10:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109515, NULL, 'G3DSA:2.40.160.20:FF:000026', NULL, NULL, 'Major outer membrane protein P44-11', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(109516, NULL, 'G3DSA:3.30.1600.10:FF:000016', NULL, NULL, 'Sirtuin 5 and related class III sirtuins', NULL, NULL, NULL, NULL, NULL, 4),
(109517, NULL, 'G3DSA:3.30.40.10:FF:001569', NULL, NULL, 'Predicted zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(109518, NULL, 'G3DSA:2.60.40.150:FF:000663', NULL, NULL, 'Copine VII', NULL, NULL, NULL, NULL, NULL, 4),
(109519, NULL, 'G3DSA:2.60.40.1180:FF:000149', NULL, NULL, 'Acid Alpha Glucosidase Relate', NULL, NULL, NULL, NULL, NULL, 4),
(109520, NULL, 'G3DSA:1.20.1510.10:FF:000052', NULL, NULL, 'Cation efflux system protein', NULL, NULL, NULL, NULL, NULL, 4),
(109521, NULL, 'G3DSA:3.40.1090.10:FF:000142', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109522, NULL, 'G3DSA:3.40.50.300:FF:006534', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109523, NULL, 'G3DSA:3.30.60.30:FF:000161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109524, NULL, 'G3DSA:3.30.1330.100:FF:000001', NULL, NULL, 'Coenzyme F420:L-glutamate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(109525, NULL, 'G3DSA:2.130.10.10:FF:000626', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(109526, NULL, 'G3DSA:3.30.470.160:FF:000001', NULL, NULL, 'Kinase', NULL, NULL, NULL, NULL, NULL, 4),
(109527, NULL, 'G3DSA:3.40.630.20:FF:000019', NULL, NULL, 'Pyrrolidone carboxyl peptidase, truncation', NULL, NULL, NULL, NULL, NULL, 4),
(109528, NULL, 'G3DSA:1.10.1660.10:FF:000003', NULL, NULL, 'MerR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(109529, NULL, 'G3DSA:3.40.50.1440:FF:000164', NULL, NULL, 'Putative nucleolar protein 5-1', NULL, NULL, NULL, NULL, NULL, 4),
(109530, NULL, 'G3DSA:1.10.10.1940:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109531, NULL, 'G3DSA:2.40.160.10:FF:000023', NULL, NULL, 'Outer membrane protein II', NULL, NULL, NULL, NULL, NULL, 4),
(109532, NULL, 'G3DSA:2.70.170.10:FF:000264', NULL, NULL, 'GABA receptor alpha 6 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(109533, NULL, 'G3DSA:2.30.30.210:FF:000017', NULL, NULL, 'Ribonuclease P protein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(109534, NULL, 'G3DSA:3.40.50.150:FF:001110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109535, NULL, 'G3DSA:2.130.10.10:FF:000284', NULL, NULL, 'protein NEDD1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(109536, NULL, 'G3DSA:2.40.50.140:FF:000032', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(109537, NULL, 'G3DSA:1.25.10.10:FF:001883', NULL, NULL, 'HEAT repeat-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(109538, NULL, 'G3DSA:1.10.1420.10:FF:000019', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(109539, NULL, 'G3DSA:2.170.270.10:FF:000225', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(109540, NULL, 'G3DSA:3.40.190.10:FF:000318', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(109541, NULL, 'G3DSA:2.40.160.210:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109542, NULL, 'G3DSA:2.70.130.10:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109543, NULL, 'G3DSA:1.20.1250.20:FF:001086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109544, NULL, 'G3DSA:2.130.10.10:FF:005859', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109545, NULL, 'G3DSA:3.40.50.150:FF:000834', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase G', NULL, NULL, NULL, NULL, NULL, 4),
(109546, NULL, 'G3DSA:3.40.50.10210:FF:000001', NULL, NULL, 'Nicotinate-nucleotide--dimethylbenzimidazole phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(109547, NULL, 'G3DSA:2.60.40.1760:FF:000008', NULL, NULL, 'Alpha-xylosidase A', NULL, NULL, NULL, NULL, NULL, 4),
(109548, NULL, 'G3DSA:2.30.30.40:FF:000613', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(109549, NULL, 'G3DSA:3.40.50.300:FF:000683', NULL, NULL, 'Abc transporter f family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(109550, NULL, 'G3DSA:3.30.230.10:FF:000302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109551, NULL, 'G3DSA:1.20.1280.50:FF:000068', NULL, NULL, 'F-box domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(109552, NULL, 'G3DSA:2.40.10.10:FF:000316', NULL, NULL, 'GM13872', NULL, NULL, NULL, NULL, NULL, 4),
(109553, NULL, 'G3DSA:3.30.160.60:FF:002442', NULL, NULL, 'Expressed sequence AI877918', NULL, NULL, NULL, NULL, NULL, 4),
(109554, NULL, 'G3DSA:3.10.310.10:FF:000004', NULL, NULL, 'Diaminopimelate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(109555, NULL, 'G3DSA:3.40.50.300:FF:002824', NULL, NULL, 'Sigma-54 dependent transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(109556, NULL, 'G3DSA:2.40.37.20:FF:000004', NULL, NULL, 'Unplaced genomic scaffold supercont1.17, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(109557, NULL, 'G3DSA:1.10.3080.10:FF:000055', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(109558, NULL, 'G3DSA:2.40.37.10:FF:000001', NULL, NULL, 'Biosynthetic arginine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(109559, NULL, 'G3DSA:3.40.50.720:FF:001197', NULL, NULL, 'KR domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(109560, NULL, 'G3DSA:3.30.160.60:FF:006258', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109561, NULL, 'G3DSA:1.20.1250.20:FF:001647', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109562, NULL, 'G3DSA:2.30.30.140:FF:000098', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(109563, NULL, 'G3DSA:3.90.1150.10:FF:000225', NULL, NULL, 'Aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(109564, NULL, 'G3DSA:3.40.50.300:FF:002482', NULL, NULL, 'Large-subunit GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(109565, NULL, 'G3DSA:1.20.970.30:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109566, NULL, 'G3DSA:1.20.58.60:FF:000303', NULL, NULL, 'Karst, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(109567, NULL, 'G3DSA:2.60.120.10:FF:000269', NULL, NULL, 'DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(109568, NULL, 'G3DSA:3.40.190.290:FF:000035', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(109569, NULL, 'G3DSA:1.10.510.10:FF:002225', NULL, NULL, 'Likely protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(109570, NULL, 'G3DSA:3.50.4.10:FF:000019', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(109571, NULL, 'G3DSA:2.160.10.10:FF:000030', NULL, NULL, 'Putative GDP-mannose pyrophosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(109572, NULL, 'G3DSA:3.80.10.10:FF:003780', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109573, NULL, 'G3DSA:1.10.1420.10:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109574, NULL, 'G3DSA:3.40.50.300:FF:006192', NULL, NULL, 'Helicase conserved C-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(109575, NULL, 'G3DSA:3.40.30.10:FF:000708', NULL, NULL, 'Protein disulfide isomerase 3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109576, NULL, 'G3DSA:3.30.70.330:FF:001564', NULL, NULL, 'Zinc finger CCCH domain-containing protein 41', NULL, NULL, NULL, NULL, NULL, 4),
(109577, NULL, 'G3DSA:2.60.40.10:FF:004246', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109578, NULL, 'G3DSA:2.60.40.3500:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109579, NULL, 'G3DSA:2.160.20.10:FF:000311', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109580, NULL, 'G3DSA:1.10.510.10:FF:001949', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(109581, NULL, 'G3DSA:3.40.50.2300:FF:001299', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109582, NULL, 'G3DSA:4.10.410.10:FF:000076', NULL, NULL, 'Tissue factor pathway inhibitor', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(109583, NULL, 'G3DSA:1.25.40.10:FF:001598', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109584, NULL, 'G3DSA:3.30.465.10:FF:000100', NULL, NULL, 'CoB--CoM heterodisulfide reductase 2 iron-sulfur subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(109585, NULL, 'G3DSA:3.10.440.10:FF:000008', NULL, NULL, 'LSU ribosomal protein L31E', NULL, NULL, NULL, NULL, NULL, 4),
(109586, NULL, 'G3DSA:3.30.230.120:FF:000008', NULL, NULL, 'D-alpha-D-heptose-7-phosphate kinase HddA', NULL, NULL, NULL, NULL, NULL, 4),
(109587, NULL, 'G3DSA:2.60.120.260:FF:000121', NULL, NULL, 'Beta-galactosidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(109588, NULL, 'G3DSA:2.60.40.150:FF:000225', NULL, NULL, 'WWC family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(109589, NULL, 'G3DSA:1.20.1640.10:FF:000056', NULL, NULL, 'PaTched Related family', NULL, NULL, NULL, NULL, NULL, 4),
(109590, NULL, 'G3DSA:3.40.800.20:FF:000055', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109591, NULL, 'G3DSA:1.10.150.240:FF:000015', NULL, NULL, 'Acyl-CoA dehydrogenase family member 10', NULL, NULL, NULL, NULL, NULL, 4),
(109592, NULL, 'G3DSA:3.40.50.720:FF:001652', NULL, NULL, 'NAD dependent epimerase/dehydratase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109593, NULL, 'G3DSA:2.20.28.270:FF:000001', NULL, NULL, 'RNA polymerase-binding protein RbpA', NULL, NULL, NULL, NULL, NULL, 4),
(109594, NULL, 'G3DSA:2.130.10.10:FF:005972', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109595, NULL, 'G3DSA:1.25.40.240:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109596, NULL, 'G3DSA:2.130.10.10:FF:002425', NULL, NULL, 'Rabconnectin-3A', NULL, NULL, NULL, NULL, NULL, 4),
(109597, NULL, 'G3DSA:2.170.140.10:FF:000002', NULL, NULL, 'Gasp, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(109598, NULL, 'G3DSA:3.30.70.2820:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109599, NULL, 'G3DSA:3.40.800.10:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109600, NULL, 'G3DSA:1.20.5.190:FF:000111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109601, NULL, 'G3DSA:1.25.10.10:FF:002720', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109602, NULL, 'G3DSA:3.80.10.10:FF:003561', NULL, NULL, 'F-box and leucine-rich repeat protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(109603, NULL, 'G3DSA:3.40.50.1000:FF:000055', NULL, NULL, 'Haloacid dehalogenase-like hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(109604, NULL, 'G3DSA:1.20.1560.10:FF:000797', NULL, NULL, 'AGAP004600-PA', NULL, NULL, NULL, NULL, NULL, 4),
(109605, NULL, 'G3DSA:2.60.120.10:FF:000724', NULL, NULL, 'Cyclic nucleotide-gated potassium channel', NULL, NULL, NULL, NULL, NULL, 4),
(109606, NULL, 'G3DSA:3.30.230.70:FF:000062', NULL, NULL, 'Cell death-related nuclease 5', NULL, NULL, NULL, NULL, NULL, 4),
(109607, NULL, 'G3DSA:3.30.160.60:FF:006039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109608, NULL, 'G3DSA:3.40.50.300:FF:001987', NULL, NULL, 'replication factor C subunit 5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(109609, NULL, 'G3DSA:2.10.220.10:FF:000119', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(109610, NULL, 'G3DSA:2.40.10.10:FF:000535', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109611, NULL, 'G3DSA:3.90.320.20:FF:000001', NULL, NULL, 'Methyl-coenzyme M reductase I subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(109612, NULL, 'G3DSA:2.40.30.10:FF:000082', NULL, NULL, 'Putative translation elongation factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(109613, NULL, 'G3DSA:2.120.10.30:FF:000251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109614, NULL, 'G3DSA:1.10.472.10:FF:000533', NULL, NULL, 'T-type cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(109615, NULL, 'G3DSA:1.20.1270.280:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109616, NULL, 'G3DSA:3.10.290.10:FF:000069', NULL, NULL, '30S ribosomal protein S4, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(109617, NULL, 'G3DSA:1.25.40.20:FF:000640', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(109618, NULL, 'G3DSA:1.10.510.10:FF:002663', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109619, NULL, 'G3DSA:2.40.70.10:FF:000202', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109620, NULL, 'G3DSA:3.30.200.60:FF:000012', NULL, NULL, 'Ubiquitin thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(109621, NULL, 'G3DSA:2.30.130.40:FF:000010', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(109622, NULL, 'G3DSA:3.40.50.300:FF:003100', NULL, NULL, 'Rap GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109623, NULL, 'G3DSA:2.130.10.10:FF:001588', NULL, NULL, 'Chromosome segregation protein SMC', NULL, NULL, NULL, NULL, NULL, 4),
(109624, NULL, 'G3DSA:2.10.110.20:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109625, NULL, 'G3DSA:3.30.70.1230:FF:000076', NULL, NULL, 'pH-sensitive adenylate cyclase Rv1264', NULL, NULL, NULL, NULL, NULL, 4),
(109626, NULL, 'G3DSA:1.10.630.10:FF:000587', NULL, NULL, 'Cytochrome P450 84A1', NULL, NULL, NULL, NULL, NULL, 4),
(109627, NULL, 'G3DSA:3.20.180.20:FF:000016', NULL, NULL, 'Dynein heavy chain, cytosolic, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109628, NULL, 'G3DSA:3.40.309.10:FF:000005', NULL, NULL, '1-pyrroline-5-carboxylate dehydrogenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(109629, NULL, 'G3DSA:3.30.530.20:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109630, NULL, 'G3DSA:2.10.110.10:FF:000223', NULL, NULL, 'PDZ and LIM domain 5', NULL, NULL, NULL, NULL, NULL, 4),
(109631, NULL, 'G3DSA:1.20.120.980:FF:000015', NULL, NULL, 'Serine carboxypeptidase (S28) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(109632, NULL, 'G3DSA:1.10.10.10:FF:000174', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(109633, NULL, 'G3DSA:2.60.120.260:FF:000008', NULL, NULL, 'teneurin-3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(109634, NULL, 'G3DSA:2.60.40.10:FF:005882', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109635, NULL, 'G3DSA:1.25.40.10:FF:002093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109636, NULL, 'G3DSA:3.20.20.100:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109637, NULL, 'G3DSA:3.30.160.60:FF:006371', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109638, NULL, 'G3DSA:1.10.10.10:FF:000516', NULL, NULL, 'ets DNA-binding protein pokkuri', NULL, NULL, NULL, NULL, NULL, 4),
(109639, NULL, 'G3DSA:2.10.110.10:FF:000004', NULL, NULL, 'actin-binding LIM protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(109640, NULL, 'G3DSA:3.40.50.150:FF:000492', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase H', NULL, NULL, NULL, NULL, NULL, 4),
(109641, NULL, 'G3DSA:1.10.10.60:FF:000492', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(109642, NULL, 'G3DSA:2.60.40.10:FF:004465', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109643, NULL, 'G3DSA:3.40.50.300:FF:002263', NULL, NULL, 'DNA repair and recombination protein RAD54', NULL, NULL, NULL, NULL, NULL, 4),
(109644, NULL, 'G3DSA:2.60.40.2130:FF:000018', NULL, NULL, 'Spon2b protein', NULL, NULL, NULL, NULL, NULL, 4),
(109645, NULL, 'G3DSA:3.30.870.10:FF:000160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109646, NULL, 'G3DSA:3.30.420.40:FF:000236', NULL, NULL, 'Chromatin remodeling complex subunit (Arp9), putative', NULL, NULL, NULL, NULL, NULL, 4),
(109647, NULL, 'G3DSA:3.50.50.100:FF:000014', NULL, NULL, 'Hypothetical iron uptake cluster protein', NULL, NULL, NULL, NULL, NULL, 4),
(109648, NULL, 'G3DSA:1.10.418.10:FF:000256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109649, NULL, 'G3DSA:3.50.50.60:FF:001449', NULL, NULL, 'Os10g0516300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(109650, NULL, 'G3DSA:2.10.25.10:FF:001329', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(109651, NULL, 'G3DSA:1.20.58.80:FF:000080', NULL, NULL, 'Amsh, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109652, NULL, 'G3DSA:1.10.8.270:FF:000165', NULL, NULL, 'TBC1 domain family member 16', NULL, NULL, NULL, NULL, NULL, 4),
(109653, NULL, 'G3DSA:3.30.450.40:FF:000283', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(109654, NULL, 'G3DSA:2.80.10.50:FF:000074', NULL, NULL, 'Related to J kappa-recombination signal binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(109655, NULL, 'G3DSA:4.10.375.10:FF:000004', NULL, NULL, 'Lipoxygenase6', NULL, NULL, NULL, NULL, NULL, 4),
(109656, NULL, 'G3DSA:1.25.10.10:FF:002046', NULL, NULL, 'Translational activator GCN1', NULL, NULL, NULL, NULL, NULL, 4),
(109657, NULL, 'G3DSA:3.30.559.30:FF:000105', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(109658, NULL, 'G3DSA:3.30.160.60:FF:002661', NULL, NULL, 'DAZ interacting zinc finger protein 1 like', NULL, NULL, NULL, NULL, NULL, 4),
(109659, NULL, 'G3DSA:2.40.30.10:FF:000424', NULL, NULL, 'Predicted protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(109660, NULL, 'G3DSA:3.40.50.300:FF:002605', NULL, NULL, 'ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109661, NULL, 'G3DSA:2.130.10.120:FF:000013', NULL, NULL, 'Protease II', NULL, NULL, NULL, NULL, NULL, 4),
(109662, NULL, 'G3DSA:1.10.1450.10:FF:000066', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(109663, NULL, 'G3DSA:2.60.40.10:FF:001031', NULL, NULL, 'Vascular endothelial growth factor receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(109664, NULL, 'G3DSA:1.20.1610.10:FF:000009', NULL, NULL, 'Putative secreted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109665, NULL, 'G3DSA:2.130.10.110:FF:000010', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(109666, NULL, 'G3DSA:1.10.472.10:FF:000191', NULL, NULL, 'Cyclin-D5-1', NULL, NULL, NULL, NULL, NULL, 4),
(109667, NULL, 'G3DSA:3.80.10.10:FF:003903', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109668, NULL, 'G3DSA:3.40.50.720:FF:001871', NULL, NULL, 'Beta-ketoacyl-ACP reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109669, NULL, 'G3DSA:2.170.270.10:FF:000006', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(109670, NULL, 'G3DSA:2.40.10.10:FF:000193', NULL, NULL, 'Secreted trypsin-like serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(109671, NULL, 'G3DSA:3.30.1490.250:FF:000002', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(109672, NULL, 'G3DSA:2.30.29.30:FF:001271', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109673, NULL, 'G3DSA:2.60.40.10:FF:000755', NULL, NULL, 'Interleukin 5 receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(109674, NULL, 'G3DSA:2.130.10.10:FF:002206', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109675, NULL, 'G3DSA:3.40.50.2000:FF:000394', NULL, NULL, 'Glycosyl transferase family 1', NULL, NULL, NULL, NULL, NULL, 4),
(109676, NULL, 'G3DSA:1.10.10.60:FF:000705', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109677, NULL, 'G3DSA:3.40.50.10380:FF:000001', NULL, NULL, 'NAD-dependent malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(109678, NULL, 'G3DSA:3.20.20.60:FF:000044', NULL, NULL, 'HPCH/HPAI aldolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(109679, NULL, 'G3DSA:3.40.50.300:FF:000430', NULL, NULL, 'Probable Ras-related protein Rab-18', NULL, NULL, NULL, NULL, NULL, 4),
(109680, NULL, 'G3DSA:1.20.5.220:FF:000007', NULL, NULL, 'Large-conductance mechanosensitive channel', NULL, NULL, NULL, NULL, NULL, 4),
(109681, NULL, 'G3DSA:3.30.720.200:FF:000003', NULL, NULL, 'Glycine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(109682, NULL, 'G3DSA:3.30.1370.120:FF:000009', NULL, NULL, 'Type III secretion outer membrane pore YscC', NULL, NULL, NULL, NULL, NULL, 4),
(109683, NULL, 'G3DSA:3.60.20.10:FF:000050', NULL, NULL, 'Asparagine synthetase 2', NULL, NULL, NULL, NULL, NULL, 4),
(109684, NULL, 'G3DSA:2.130.10.10:FF:001705', NULL, NULL, 'Sensor histidine kinase TodS', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(109685, NULL, 'G3DSA:3.30.200.20:FF:002288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109686, NULL, 'G3DSA:3.30.70.330:FF:002536', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109687, NULL, 'G3DSA:1.10.640.10:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109688, NULL, 'G3DSA:4.10.400.10:FF:000266', NULL, NULL, 'Putative vitellogenin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(109689, NULL, 'G3DSA:3.30.479.30:FF:000003', NULL, NULL, 'Flotillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(109690, NULL, 'G3DSA:2.60.40.10:FF:001048', NULL, NULL, 'Sallimus, isoform Q', NULL, NULL, NULL, NULL, NULL, 4),
(109691, NULL, 'G3DSA:1.10.287.70:FF:000738', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109692, NULL, 'G3DSA:3.30.70.100:FF:000135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109693, NULL, 'G3DSA:1.10.1200.10:FF:000025', NULL, NULL, 'Phenolpthiocerol synthesis polyketide synthase PpsA', NULL, NULL, NULL, NULL, NULL, 4),
(109694, NULL, 'G3DSA:2.40.270.10:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109695, NULL, 'G3DSA:1.20.5.2950:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109696, NULL, 'G3DSA:1.20.1070.10:FF:001001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109697, NULL, 'G3DSA:3.30.160.60:FF:004403', NULL, NULL, 'Transcription factor IIIA', NULL, NULL, NULL, NULL, NULL, 4),
(109698, NULL, 'G3DSA:3.30.200.20:FF:001832', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109699, NULL, 'G3DSA:3.40.140.10:FF:000198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109700, NULL, 'G3DSA:1.10.3060.10:FF:000020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109701, NULL, 'G3DSA:3.90.1600.10:FF:000070', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(109702, NULL, 'G3DSA:2.60.60.20:FF:000012', NULL, NULL, 'polycystin-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(109703, NULL, 'G3DSA:2.10.220.10:FF:000041', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(109704, NULL, 'G3DSA:2.20.100.10:FF:000069', NULL, NULL, 'Cellular communication network factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(109705, NULL, 'G3DSA:2.60.40.10:FF:003818', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109706, NULL, 'G3DSA:3.40.50.150:FF:001705', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109707, NULL, 'G3DSA:3.30.160.60:FF:003094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109708, NULL, 'G3DSA:2.40.30.70:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109709, NULL, 'G3DSA:1.10.472.10:FF:000494', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109710, NULL, 'G3DSA:3.40.390.10:FF:000070', NULL, NULL, 'Matrix metallopeptidase 25b', NULL, NULL, NULL, NULL, NULL, 4),
(109711, NULL, 'G3DSA:3.40.50.1220:FF:000025', NULL, NULL, 'Pyruvate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(109712, NULL, 'G3DSA:1.25.40.10:FF:002429', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109713, NULL, 'G3DSA:3.30.565.10:FF:000411', NULL, NULL, 'Response receiver sensor histidine kinase, PAS domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(109714, NULL, 'G3DSA:3.40.50.720:FF:002557', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109715, NULL, 'G3DSA:3.40.50.1820:FF:000317', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(109716, NULL, 'G3DSA:3.80.10.10:FF:000475', NULL, NULL, 'Predicted gene 10436', NULL, NULL, NULL, NULL, NULL, 4),
(109717, NULL, 'G3DSA:4.10.1240.10:FF:000003', NULL, NULL, 'Putative cadherin EGF LAG seven-pass G-type receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(109718, NULL, 'G3DSA:3.30.70.330:FF:001108', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(109719, NULL, 'G3DSA:1.20.1250.20:FF:001687', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(109720, NULL, 'G3DSA:1.10.8.10:FF:000111', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(109721, NULL, 'G3DSA:3.30.160.60:FF:000660', NULL, NULL, 'zinc finger protein 64 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(109722, NULL, 'G3DSA:1.25.10.10:FF:000803', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109723, NULL, 'G3DSA:1.20.120.850:FF:000044', NULL, NULL, 'RAD54 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(109724, NULL, 'G3DSA:3.40.50.1820:FF:000789', NULL, NULL, 'GPI inositol-deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(109725, NULL, 'G3DSA:1.10.560.10:FF:000098', NULL, NULL, 'T-complex protein 1 subunit eta', NULL, NULL, NULL, NULL, NULL, 4),
(109726, NULL, 'G3DSA:3.30.70.1230:FF:000160', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109727, NULL, 'G3DSA:2.40.30.170:FF:000048', NULL, NULL, 'Cation efflux system protein', NULL, NULL, NULL, NULL, NULL, 4),
(109728, NULL, 'G3DSA:4.10.280.10:FF:000177', NULL, NULL, 'Transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(109729, NULL, 'G3DSA:2.30.29.30:FF:000186', NULL, NULL, 'Arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(109730, NULL, 'G3DSA:1.10.472.80:FF:000262', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109731, NULL, 'G3DSA:3.40.50.720:FF:001129', NULL, NULL, 'Possible transmembrane cation transporter', NULL, NULL, NULL, NULL, NULL, 4),
(109732, NULL, 'G3DSA:2.40.50.90:FF:000117', NULL, NULL, 'Tudor, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(109733, NULL, 'G3DSA:2.60.120.1440:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109734, NULL, 'G3DSA:3.40.50.300:FF:007990', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109735, NULL, 'G3DSA:3.30.450.40:FF:000249', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(109736, NULL, 'G3DSA:3.40.50.1000:FF:000723', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109737, NULL, 'G3DSA:1.20.1070.10:FF:000012', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(109738, NULL, 'G3DSA:2.60.40.10:FF:005382', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109739, NULL, 'G3DSA:3.40.50.300:FF:002667', NULL, NULL, 'ESX-5 secretion system protein EccC5', NULL, NULL, NULL, NULL, NULL, 4),
(109740, NULL, 'G3DSA:3.50.50.60:FF:000393', NULL, NULL, 'Related to flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(109741, NULL, 'G3DSA:1.50.40.10:FF:000359', NULL, NULL, 'Mitochondrial carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(109742, NULL, 'G3DSA:2.60.40.10:FF:002037', NULL, NULL, '1,4-alpha-glucan branching enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(109743, NULL, 'G3DSA:2.60.98.20:FF:000009', NULL, NULL, 'Flagellar hook protein FlgE', NULL, NULL, NULL, NULL, NULL, 4),
(109744, NULL, 'G3DSA:3.90.70.10:FF:000782', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109745, NULL, 'G3DSA:3.30.559.30:FF:000004', NULL, NULL, 'Enterobactin synthetase component F', NULL, NULL, NULL, NULL, NULL, 4),
(109746, NULL, 'G3DSA:2.60.120.10:FF:000191', NULL, NULL, 'Cyclic nucleotide-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(109747, NULL, 'G3DSA:3.30.160.60:FF:004875', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109748, NULL, 'G3DSA:3.30.300.130:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109749, NULL, 'G3DSA:3.80.10.10:FF:003229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109750, NULL, 'G3DSA:3.40.630.10:FF:000426', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109751, NULL, 'G3DSA:1.10.10.750:FF:000015', NULL, NULL, 'Small G protein signaling modulator', NULL, NULL, NULL, NULL, NULL, 4),
(109752, NULL, 'G3DSA:3.30.450.20:FF:000243', NULL, NULL, 'Cyclic di-GMP phosphodiesterase Gmr', NULL, NULL, NULL, NULL, NULL, 4),
(109753, NULL, 'G3DSA:1.10.472.10:FF:000022', NULL, NULL, 'cyclin-J isoform X1', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(109754, NULL, 'G3DSA:1.20.1250.10:FF:000110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109755, NULL, 'G3DSA:4.10.1080.10:FF:000001', NULL, NULL, 'Thrombospondin 3', NULL, NULL, NULL, NULL, NULL, 4),
(109756, NULL, 'G3DSA:3.30.200.20:FF:001040', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109757, NULL, 'G3DSA:3.30.420.10:FF:000525', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109758, NULL, 'G3DSA:1.20.1250.20:FF:002204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109759, NULL, 'G3DSA:3.40.50.1100:FF:000135', NULL, NULL, 'L-serine dehydratase/L-threonine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(109760, NULL, 'G3DSA:1.10.238.230:FF:000002', NULL, NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit B''''alpha', NULL, NULL, NULL, NULL, NULL, 4),
(109761, NULL, 'G3DSA:1.20.5.1010:FF:000001', NULL, NULL, 'Transient receptor potential cation channel subfamily M member 3', NULL, NULL, NULL, NULL, NULL, 4),
(109762, NULL, 'G3DSA:3.40.50.300:FF:005601', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109763, NULL, 'G3DSA:3.60.120.10:FF:000006', NULL, NULL, 'Anthranilate synthase component 1', NULL, NULL, NULL, NULL, NULL, 4),
(109764, NULL, 'G3DSA:1.25.40.10:FF:004785', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109765, NULL, 'G3DSA:3.40.250.10:FF:000060', NULL, NULL, 'Mitogen-activated protein kinase phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(109766, NULL, 'G3DSA:3.90.190.10:FF:000004', NULL, NULL, 'Protein phosphatase Slingshot homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(109767, NULL, 'G3DSA:1.10.287.10:FF:000035', NULL, NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(109768, NULL, 'G3DSA:3.10.110.20:FF:000003', NULL, NULL, 'Fancl, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(109769, NULL, 'G3DSA:3.10.270.10:FF:000006', NULL, NULL, 'GTP cyclohydrolase MptA', NULL, NULL, NULL, NULL, NULL, 4),
(109770, NULL, 'G3DSA:3.40.50.720:FF:000320', NULL, NULL, 'ubiquitin-like modifier-activating enzyme 7', NULL, NULL, NULL, NULL, NULL, 4),
(109771, NULL, 'G3DSA:3.70.10.10:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109772, NULL, 'G3DSA:2.10.90.10:FF:000064', NULL, NULL, 'Glycoprotein hormone alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(109773, NULL, 'G3DSA:3.80.10.10:FF:004218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109774, NULL, 'G3DSA:2.130.10.10:FF:005067', NULL, NULL, 'Cilia and flagella associated protein 57', NULL, NULL, NULL, NULL, NULL, 4),
(109775, NULL, 'G3DSA:1.10.510.10:FF:001376', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(109776, NULL, 'G3DSA:4.10.410.10:FF:000031', NULL, NULL, 'CRE-MEC-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(109777, NULL, 'G3DSA:1.20.1250.20:FF:000259', NULL, NULL, 'Major facilitator family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(109778, NULL, 'G3DSA:2.10.70.10:FF:000001', NULL, NULL, 'Selectin P', NULL, NULL, NULL, NULL, NULL, 4),
(109779, NULL, 'G3DSA:3.30.470.20:FF:000126', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(109780, NULL, 'G3DSA:3.30.420.40:FF:000101', NULL, NULL, 'FGGY carbohydrate kinase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(109781, NULL, 'G3DSA:1.10.630.10:FF:000334', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109782, NULL, 'G3DSA:3.40.50.1980:FF:000112', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(109783, NULL, 'G3DSA:1.20.58.340:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109784, NULL, 'G3DSA:3.30.230.10:FF:000342', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109785, NULL, 'G3DSA:1.25.10.10:FF:001259', NULL, NULL, 'Armadillo/beta-catenin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(109786, NULL, 'G3DSA:2.160.10.10:FF:000092', NULL, NULL, 'Serine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(109787, NULL, 'G3DSA:3.20.20.70:FF:000373', NULL, NULL, 'Putative pyridoxine biosynthesis protein pdx-1', NULL, NULL, NULL, NULL, NULL, 4),
(109788, NULL, 'G3DSA:2.40.50.140:FF:000633', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(109789, NULL, 'G3DSA:3.40.630.30:FF:000612', NULL, NULL, 'Glucosamine 6-phosphate N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(109790, NULL, 'G3DSA:3.30.160.60:FF:003414', NULL, NULL, 'Zinc finger protein 1183', NULL, NULL, NULL, NULL, NULL, 4),
(109791, NULL, 'G3DSA:3.30.40.10:FF:001665', NULL, NULL, 'Ras-like small GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109792, NULL, 'G3DSA:3.30.200.20:FF:000843', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(109793, NULL, 'G3DSA:1.20.1070.10:FF:000484', NULL, NULL, 'NeuroPeptide Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(109794, NULL, 'G3DSA:1.20.140.50:FF:000014', NULL, NULL, 'Vacuolar protein-sorting protein BRO1', NULL, NULL, NULL, NULL, NULL, 4),
(109795, NULL, 'G3DSA:1.10.287.450:FF:000004', NULL, NULL, 'Non-homologous end-joining factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(109796, NULL, 'G3DSA:3.30.70.990:FF:000002', NULL, NULL, 'UPF0234 protein LEP1GSC067_4943', NULL, NULL, NULL, NULL, NULL, 4),
(109797, NULL, 'G3DSA:2.10.25.10:FF:000458', NULL, NULL, 'prolow-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(109798, NULL, 'G3DSA:6.10.140.2220:FF:000053', NULL, NULL, 'Zinc finger (MYND type) family protein / programmed cell death 2 C-terminal domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(109799, NULL, 'G3DSA:2.60.120.260:FF:000227', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109800, NULL, 'G3DSA:1.25.10.10:FF:002248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109801, NULL, 'G3DSA:3.30.70.1230:FF:000008', NULL, NULL, 'Adenylate cyclase type 9', NULL, NULL, NULL, NULL, NULL, 4),
(109802, NULL, 'G3DSA:1.10.287.110:FF:000279', NULL, NULL, 'J-type chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(109803, NULL, 'G3DSA:3.60.21.10:FF:000041', NULL, NULL, 'Serine/threonine-protein phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(109804, NULL, 'G3DSA:3.30.720.50:FF:000003', NULL, NULL, 'E3 ubiquitin-protein ligase RNF146', NULL, NULL, NULL, NULL, NULL, 4),
(109805, NULL, 'G3DSA:3.30.40.10:FF:000737', NULL, NULL, 'E3 ubiquitin-protein ligase ORTHRUS 3', NULL, NULL, NULL, NULL, NULL, 4),
(109806, NULL, 'G3DSA:1.10.533.10:FF:000131', NULL, NULL, 'Fas-associated death domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(109807, NULL, 'G3DSA:2.30.30.140:FF:000058', NULL, NULL, 'Lamin B receptor', NULL, NULL, NULL, NULL, NULL, 4),
(109808, NULL, 'G3DSA:1.20.58.390:FF:000159', NULL, NULL, 'Acetylcholine receptor subunit alpha-type acr-16', NULL, NULL, NULL, NULL, NULL, 4),
(109809, NULL, 'G3DSA:1.25.40.20:FF:000460', NULL, NULL, 'Ankyrin repeat and SOCS box containing 15', NULL, NULL, NULL, NULL, NULL, 4),
(109810, NULL, 'G3DSA:3.40.33.10:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109811, NULL, 'G3DSA:2.60.120.260:FF:000666', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109812, NULL, 'G3DSA:3.40.50.1820:FF:001306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109813, NULL, 'G3DSA:3.30.710.10:FF:000452', NULL, NULL, 'GEO10396p1', NULL, NULL, NULL, NULL, NULL, 4),
(109814, NULL, 'G3DSA:3.90.70.80:FF:000050', NULL, NULL, 'OTU domain-containing protein 6B', NULL, NULL, NULL, NULL, NULL, 4),
(109815, NULL, 'G3DSA:3.20.100.10:FF:000003', NULL, NULL, 'Unplaced genomic scaffold supercont1.18, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(109816, NULL, 'G3DSA:1.20.5.190:FF:000010', NULL, NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(109817, NULL, 'G3DSA:2.130.10.10:FF:000716', NULL, NULL, 'WD repeat domain 11', NULL, NULL, NULL, NULL, NULL, 4),
(109818, NULL, 'G3DSA:1.25.40.180:FF:000177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109819, NULL, 'G3DSA:1.25.10.10:FF:001731', NULL, NULL, 'U3 small nucleolar RNA-associated protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(109820, NULL, 'G3DSA:3.40.50.2300:FF:000214', NULL, NULL, 'Two-component response regulator-like PRR37', NULL, NULL, NULL, NULL, NULL, 4),
(109821, NULL, 'G3DSA:4.10.1000.40:FF:000005', NULL, NULL, 'Polyadenylated RNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(109822, NULL, 'G3DSA:2.60.40.10:FF:002829', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(109823, NULL, 'G3DSA:3.30.1370.50:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109824, NULL, 'G3DSA:3.10.20.650:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109825, NULL, 'G3DSA:1.10.1520.10:FF:000100', NULL, NULL, 'Secreted protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109826, NULL, 'G3DSA:2.40.50.510:FF:000002', NULL, NULL, 'RecQ-mediated genome instability protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(109827, NULL, 'G3DSA:2.40.10.10:FF:000221', NULL, NULL, 'Si:dkey-33m11.8', NULL, NULL, NULL, NULL, NULL, 4),
(109828, NULL, 'G3DSA:2.60.120.290:FF:000242', NULL, NULL, 'Cubilin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(109829, NULL, 'G3DSA:3.90.70.10:FF:000310', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 30 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(109830, NULL, 'G3DSA:3.20.170.50:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109831, NULL, 'G3DSA:3.30.40.10:FF:000676', NULL, NULL, 'E3 ubiquitin-protein ligase RNF169', NULL, NULL, NULL, NULL, NULL, 4),
(109832, NULL, 'G3DSA:3.30.505.10:FF:000082', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(109833, NULL, 'G3DSA:3.40.50.300:FF:003656', NULL, NULL, 'DNA repair protein RAD51 homolog 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(109834, NULL, 'G3DSA:2.60.120.480:FF:000001', NULL, NULL, 'Ureidoglycolate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(109835, NULL, 'G3DSA:2.60.40.60:FF:000293', NULL, NULL, 'DE-cadherin', NULL, NULL, NULL, NULL, NULL, 4),
(109836, NULL, 'G3DSA:3.40.850.10:FF:000437', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109837, NULL, 'G3DSA:3.40.605.10:FF:000121', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109838, NULL, 'G3DSA:2.130.10.10:FF:004578', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109839, NULL, 'G3DSA:3.90.800.10:FF:000001', NULL, NULL, 'Glutamine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(109840, NULL, 'G3DSA:3.80.10.10:FF:004157', NULL, NULL, 'Ras guanine nucleotide exchange factor N', NULL, NULL, NULL, NULL, NULL, 4),
(109841, NULL, 'G3DSA:3.30.240.40:FF:000003', NULL, NULL, 'Protein E6', NULL, NULL, NULL, NULL, NULL, 4),
(109842, NULL, 'G3DSA:1.20.5.170:FF:000296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109843, NULL, 'G3DSA:1.10.3500.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109844, NULL, 'G3DSA:3.40.430.10:FF:000006', NULL, NULL, 'Riboflavin biosynthesis protein RibD', NULL, NULL, NULL, NULL, NULL, 4),
(109845, NULL, 'G3DSA:2.40.30.10:FF:000104', NULL, NULL, '50S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(109846, NULL, 'G3DSA:3.30.70.330:FF:000771', NULL, NULL, 'Polyadenylate-binding protein RBP45A', NULL, NULL, NULL, NULL, NULL, 4),
(109847, NULL, 'G3DSA:1.20.1250.20:FF:001215', NULL, NULL, 'AGAP011680-PA', NULL, NULL, NULL, NULL, NULL, 4),
(109848, NULL, 'G3DSA:2.130.10.10:FF:002341', NULL, NULL, 'Ddb1 and cul4-associated factor 11', NULL, NULL, NULL, NULL, NULL, 4),
(109849, NULL, 'G3DSA:3.30.428.10:FF:000054', NULL, NULL, 'Galactose-1-phosphate uridyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(109850, NULL, 'G3DSA:1.10.238.10:FF:000787', NULL, NULL, 'Mitochondrial substrate carrier family protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(109851, NULL, 'G3DSA:1.10.287.1080:FF:000003', NULL, NULL, 'Nucleoside triphosphate pyrophosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(109852, NULL, 'G3DSA:1.10.287.1490:FF:000036', NULL, NULL, 'Pi3K21B, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(109853, NULL, 'G3DSA:1.10.150.50:FF:000096', NULL, NULL, 'Sterile alpha motif domain containing 9 like', NULL, NULL, NULL, NULL, NULL, 4),
(109854, NULL, 'G3DSA:1.20.120.350:FF:000017', NULL, NULL, 'potassium voltage-gated channel subfamily KQT member 1', NULL, NULL, NULL, NULL, NULL, 4),
(109855, NULL, 'G3DSA:2.60.120.650:FF:000193', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109856, NULL, 'G3DSA:3.40.630.60:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109857, NULL, 'G3DSA:1.10.555.10:FF:000176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109858, NULL, 'G3DSA:1.20.120.230:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109859, NULL, 'G3DSA:2.170.270.10:FF:000141', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(109860, NULL, 'G3DSA:3.30.160.60:FF:001969', NULL, NULL, 'D19B', NULL, NULL, NULL, NULL, NULL, 4),
(109861, NULL, 'G3DSA:2.60.120.780:FF:000001', NULL, NULL, 'E3 SUMO-protein ligase PIAS2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(109862, NULL, 'G3DSA:3.40.718.10:FF:000017', NULL, NULL, 'Isocitrate dehydrogenase [NADP]', NULL, NULL, NULL, NULL, NULL, 4),
(109863, NULL, 'G3DSA:2.60.40.10:FF:004454', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109864, NULL, 'G3DSA:2.10.25.10:FF:001094', NULL, NULL, 'Crumbs cell polarity complex component 1', NULL, NULL, NULL, NULL, NULL, 4),
(109865, NULL, 'G3DSA:1.25.40.20:FF:001269', NULL, NULL, 'Ankyrin repeat and MYND domain-containing 2b', NULL, NULL, NULL, NULL, NULL, 4),
(109866, NULL, 'G3DSA:3.30.160.60:FF:001469', NULL, NULL, 'zinc finger protein 37 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(109867, NULL, 'G3DSA:3.30.160.60:FF:003914', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109868, NULL, 'G3DSA:3.40.605.10:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109869, NULL, 'G3DSA:1.10.287.130:FF:000026', NULL, NULL, 'Two-component system sensor histidine kinase PmrB', NULL, NULL, NULL, NULL, NULL, 4),
(109870, NULL, 'G3DSA:2.40.50.140:FF:000133', NULL, NULL, 'cold shock domain-containing protein E1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(109871, NULL, 'G3DSA:1.10.510.10:FF:003793', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109872, NULL, 'G3DSA:3.30.70.1170:FF:000029', NULL, NULL, 'tRNA (cytosine(49)-C(5))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(109873, NULL, 'G3DSA:3.30.420.40:FF:001057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109874, NULL, 'G3DSA:1.10.510.10:FF:003613', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109875, NULL, 'G3DSA:3.10.330.20:FF:000014', NULL, NULL, 'Protein L-isoaspartate methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(109876, NULL, 'G3DSA:3.20.20.140:FF:000212', NULL, NULL, 'DNA-directed DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(109877, NULL, 'G3DSA:1.20.1070.10:FF:000984', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109878, NULL, 'G3DSA:1.10.10.10:FF:000331', NULL, NULL, 'Anaphase-promoting complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(109879, NULL, 'G3DSA:2.120.10.80:FF:000125', NULL, NULL, 'kelch domain-containing protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(109880, NULL, 'G3DSA:2.30.30.490:FF:000051', NULL, NULL, 'PolyBRoMo domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(109881, NULL, 'G3DSA:3.40.50.300:FF:008327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109882, NULL, 'G3DSA:3.30.70.1770:FF:000001', NULL, NULL, 'Type III export protein PscD', NULL, NULL, NULL, NULL, NULL, 4),
(109883, NULL, 'G3DSA:2.40.250.10:FF:000007', NULL, NULL, 'Core binding factor beta subunit isoform 7', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(109884, NULL, 'G3DSA:3.30.930.10:FF:000316', NULL, NULL, 'Ferredoxin-fold anticodon-binding domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(109885, NULL, 'G3DSA:1.10.630.10:FF:000834', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109886, NULL, 'G3DSA:1.20.90.10:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109887, NULL, 'G3DSA:2.60.120.260:FF:000166', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(109888, NULL, 'G3DSA:3.30.1370.210:FF:000003', NULL, NULL, 'Zinc finger CCCH domain-containing protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(109889, NULL, 'G3DSA:1.25.40.10:FF:001620', NULL, NULL, 'probable UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SPINDLY', NULL, NULL, NULL, NULL, NULL, 4),
(109890, NULL, 'G3DSA:3.40.50.300:FF:005101', NULL, NULL, 'Energy-coupling factor transporter ATP-binding protein EcfA2', NULL, NULL, NULL, NULL, NULL, 4),
(109891, NULL, 'G3DSA:3.40.50.1240:FF:000183', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(109892, NULL, 'G3DSA:3.10.28.10:FF:000013', NULL, NULL, 'Protein RecA', NULL, NULL, NULL, NULL, NULL, 4),
(109893, NULL, 'G3DSA:1.25.10.10:FF:000303', NULL, NULL, 'splicing factor 3B subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(109894, NULL, 'G3DSA:1.20.1250.20:FF:001748', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109895, NULL, 'G3DSA:3.40.50.300:FF:007046', NULL, NULL, 'ATP-dependent DNA helicase PIF4', NULL, NULL, NULL, NULL, NULL, 4),
(109896, NULL, 'G3DSA:4.10.1000.10:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109897, NULL, 'G3DSA:3.40.50.620:FF:000728', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109898, NULL, 'G3DSA:2.10.25.10:FF:000958', NULL, NULL, 'Abnormal pharyngeal pumping eat-20', NULL, NULL, NULL, NULL, NULL, 4),
(109899, NULL, 'G3DSA:3.80.10.10:FF:003701', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(109900, NULL, 'G3DSA:1.25.10.10:FF:000011', NULL, NULL, 'Serine/threonine-protein phosphatase 2A regulatory subunit A alpha isoform', NULL, NULL, NULL, NULL, NULL, 4),
(109901, NULL, 'G3DSA:3.30.160.60:FF:001177', NULL, NULL, 'Zinc finger protein 33A', NULL, NULL, NULL, NULL, NULL, 4),
(109902, NULL, 'G3DSA:1.10.10.10:FF:001079', NULL, NULL, 'O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(109903, NULL, 'G3DSA:2.170.11.10:FF:000003', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(109904, NULL, 'G3DSA:2.60.40.150:FF:000236', NULL, NULL, 'Rabphilin, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(109905, NULL, 'G3DSA:3.50.30.30:FF:000023', NULL, NULL, 'E3 ubiquitin-protein ligase RNF43 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(109906, NULL, 'G3DSA:1.10.150.20:FF:000261', NULL, NULL, 'Protein PARTING DANCERS', NULL, NULL, NULL, NULL, NULL, 4),
(109907, NULL, 'G3DSA:1.20.1250.10:FF:000077', NULL, NULL, 'Colony-stimulating factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(109908, NULL, 'G3DSA:1.20.1050.130:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109909, NULL, 'G3DSA:3.30.160.60:FF:005331', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109910, NULL, 'G3DSA:3.30.930.10:FF:000024', NULL, NULL, 'Lipoate-protein ligase A', NULL, NULL, NULL, NULL, NULL, 4),
(109911, NULL, 'G3DSA:1.20.58.760:FF:000028', NULL, NULL, 'ATP-dependent metallopeptidase Hfl', NULL, NULL, NULL, NULL, NULL, 4),
(109912, NULL, 'G3DSA:1.20.1270.60:FF:000014', NULL, NULL, 'Protein hob3, variant', NULL, NULL, NULL, NULL, NULL, 4),
(109913, NULL, 'G3DSA:1.20.1260.100:FF:000003', NULL, NULL, 'Protein CBG24492', NULL, NULL, NULL, NULL, NULL, 4),
(109914, NULL, 'G3DSA:3.40.47.10:FF:000073', NULL, NULL, 'Acetyl-CoA acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(109915, NULL, 'G3DSA:1.10.1300.10:FF:000089', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(109916, NULL, 'G3DSA:3.40.630.30:FF:000112', NULL, NULL, 'N-acetyltransferase Eis', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(109917, NULL, 'G3DSA:1.10.10.10:FF:001612', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109918, NULL, 'G3DSA:3.40.50.300:FF:007338', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(109919, NULL, 'G3DSA:2.130.10.10:FF:001352', NULL, NULL, 'WD repeat domain 63', NULL, NULL, NULL, NULL, NULL, 4),
(109920, NULL, 'G3DSA:2.70.150.10:FF:000055', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(109921, NULL, 'G3DSA:2.40.10.10:FF:000693', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109922, NULL, 'G3DSA:2.10.110.10:FF:000212', NULL, NULL, 'Protein CBR-LIM-9', NULL, NULL, NULL, NULL, NULL, 4),
(109923, NULL, 'G3DSA:3.10.450.240:FF:000031', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109924, NULL, 'G3DSA:2.130.10.10:FF:004078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109925, NULL, 'G3DSA:2.40.50.140:FF:001122', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109926, NULL, 'G3DSA:1.10.40.30:FF:000018', NULL, NULL, 'Adenylosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(109927, NULL, 'G3DSA:3.15.10.10:FF:000007', NULL, NULL, 'BPI fold containing family C', NULL, NULL, NULL, NULL, NULL, 4),
(109928, NULL, 'G3DSA:1.10.3080.10:FF:000083', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(109929, NULL, 'G3DSA:3.40.50.150:FF:001644', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109930, NULL, 'G3DSA:3.30.390.80:FF:000003', NULL, NULL, 'DNA repair protein RAD59', NULL, NULL, NULL, NULL, NULL, 4),
(109931, NULL, 'G3DSA:2.10.220.10:FF:000102', NULL, NULL, 'R-spondin 2', NULL, NULL, NULL, NULL, NULL, 4),
(109932, NULL, 'G3DSA:3.30.160.190:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109933, NULL, 'G3DSA:3.40.50.2300:FF:000714', NULL, NULL, 'Sugar ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(109934, NULL, 'G3DSA:3.30.160.60:FF:002897', NULL, NULL, 'Zinc finger protein 623', NULL, NULL, NULL, NULL, NULL, 4),
(109935, NULL, 'G3DSA:1.10.3720.10:FF:000048', NULL, NULL, 'Thiamine/thiamine pyrophosphate ABC transporter permease ThiP', NULL, NULL, NULL, NULL, NULL, 4),
(109936, NULL, 'G3DSA:3.40.50.11210:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109937, NULL, 'G3DSA:3.30.40.10:FF:001373', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109938, NULL, 'G3DSA:3.20.20.150:FF:000069', NULL, NULL, 'Hydroxypyruvate isomerase (putative)', NULL, NULL, NULL, NULL, NULL, 4),
(109939, NULL, 'G3DSA:3.30.460.10:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109940, NULL, 'G3DSA:3.40.570.10:FF:000016', NULL, NULL, 'GG12061', NULL, NULL, NULL, NULL, NULL, 4),
(109941, NULL, 'G3DSA:2.60.40.10:FF:003465', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109942, NULL, 'G3DSA:3.40.50.300:FF:004584', NULL, NULL, 'HPr kinase/phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(109943, NULL, 'G3DSA:3.30.160.60:FF:004050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109944, NULL, 'G3DSA:2.40.70.10:FF:000230', NULL, NULL, 'ASpartyl Protease', NULL, NULL, NULL, NULL, NULL, 4),
(109945, NULL, 'G3DSA:3.90.1420.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109946, NULL, 'G3DSA:3.40.50.620:FF:000880', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109947, NULL, 'G3DSA:3.10.250.10:FF:000095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109948, NULL, 'G3DSA:4.10.280.10:FF:000205', NULL, NULL, 'REF-1', NULL, NULL, NULL, NULL, NULL, 4),
(109949, NULL, 'G3DSA:1.25.40.10:FF:000131', NULL, NULL, 'probable UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SEC', NULL, NULL, NULL, NULL, NULL, 4),
(109950, NULL, 'G3DSA:1.25.40.10:FF:002368', NULL, NULL, 'Os02g0552100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(109951, NULL, 'G3DSA:3.40.50.2300:FF:001203', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109952, NULL, 'G3DSA:3.40.50.150:FF:001352', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(109953, NULL, 'G3DSA:3.30.2320.80:FF:000004', NULL, NULL, 'Hydrogenase maturation factor HypA', NULL, NULL, NULL, NULL, NULL, 4),
(109954, NULL, 'G3DSA:3.30.1520.10:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109955, NULL, 'G3DSA:3.40.50.460:FF:000045', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit beta 2', NULL, NULL, NULL, NULL, NULL, 4),
(109956, NULL, 'G3DSA:3.40.50.150:FF:001205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109957, NULL, 'G3DSA:3.40.50.720:FF:000792', NULL, NULL, 'Bifunctional dehydrogenase/ferrochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(109958, NULL, 'G3DSA:1.10.10.160:FF:000052', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109959, NULL, 'G3DSA:1.10.630.10:FF:000042', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(109960, NULL, 'G3DSA:1.20.58.1280:FF:000003', NULL, NULL, 'DNA repair protein REV1', NULL, NULL, NULL, NULL, NULL, 4),
(109961, NULL, 'G3DSA:3.40.50.1000:FF:000695', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109962, NULL, 'G3DSA:1.10.340.70:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109963, NULL, 'G3DSA:3.80.10.10:FF:002392', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109964, NULL, 'G3DSA:1.25.10.10:FF:003176', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(109965, NULL, 'G3DSA:3.30.360.10:FF:000115', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(109966, NULL, 'G3DSA:3.30.450.20:FF:000682', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109967, NULL, 'G3DSA:2.40.128.620:FF:000002', NULL, NULL, 'Low-density lipoprotein receptor-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(109968, NULL, 'G3DSA:2.10.25.10:FF:000166', NULL, NULL, 'laminin subunit gamma-1', NULL, NULL, NULL, NULL, NULL, 4),
(109969, NULL, 'G3DSA:3.30.1330.30:FF:000074', NULL, NULL, 'Ribosomal protein L7Ae, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109970, NULL, 'G3DSA:3.30.70.1170:FF:000001', NULL, NULL, 'Ribosomal RNA methyltransferase Nop2', NULL, NULL, NULL, NULL, NULL, 4),
(109971, NULL, 'G3DSA:2.60.200.10:FF:000045', NULL, NULL, 'Interferon regulatory factor 4a', NULL, NULL, NULL, NULL, NULL, 4),
(109972, NULL, 'G3DSA:3.40.30.10:FF:000478', NULL, NULL, 'Eps1p', NULL, NULL, NULL, NULL, NULL, 4),
(109973, NULL, 'G3DSA:1.10.132.70:FF:000003', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(109974, NULL, 'G3DSA:3.90.226.10:FF:000133', NULL, NULL, 'Enoyl-CoA hydratase/isomerase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(109975, NULL, 'G3DSA:1.20.1070.10:FF:000192', NULL, NULL, 'Latrophilin 1', NULL, NULL, NULL, NULL, NULL, 4),
(109976, NULL, 'G3DSA:1.25.40.10:FF:003857', NULL, NULL, '1-aminocyclopropane-1-carboxylate oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(109977, NULL, 'G3DSA:1.20.58.60:FF:000539', NULL, NULL, 'Spectrin repeat containing nuclear envelope protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(109978, NULL, 'G3DSA:3.40.50.150:FF:000716', NULL, NULL, 'Cytosine-C5 specific DNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(109979, NULL, 'G3DSA:1.10.1300.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109980, NULL, 'G3DSA:3.40.50.150:FF:000896', NULL, NULL, 'MraW methylase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(109981, NULL, 'G3DSA:1.20.1310.10:FF:000048', NULL, NULL, 'Cullin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109982, NULL, 'G3DSA:1.25.40.70:FF:000042', NULL, NULL, 'Phosphatidylinositol 4-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(109983, NULL, 'G3DSA:2.40.50.140:FF:000925', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(109984, NULL, 'G3DSA:3.90.190.10:FF:000476', NULL, NULL, 'Dual specificity protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(109985, NULL, 'G3DSA:3.30.980.10:FF:000027', NULL, NULL, 'Threonine--tRNA ligase, chloroplastic/mitochondrial 2 isoform A', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(109986, NULL, 'G3DSA:3.80.10.10:FF:000975', NULL, NULL, 'Zyg eleven-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(109987, NULL, 'G3DSA:1.10.10.60:FF:000677', NULL, NULL, 'Sigma-54 dependent response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(109988, NULL, 'G3DSA:3.30.70.330:FF:000119', NULL, NULL, 'RNA-binding motif protein, X chromosome', NULL, NULL, NULL, NULL, NULL, 4),
(109989, NULL, 'G3DSA:3.30.2090.10:FF:000026', NULL, NULL, 'Acriflavine resistance protein B', NULL, NULL, NULL, NULL, NULL, 4),
(109990, NULL, 'G3DSA:1.25.40.10:FF:002929', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(109991, NULL, 'G3DSA:1.20.1070.10:FF:001501', NULL, NULL, 'Si:dkey-165n16.5', NULL, NULL, NULL, NULL, NULL, 4),
(109992, NULL, 'G3DSA:2.40.50.90:FF:000056', NULL, NULL, 'Transcriptional coactivator p100', NULL, NULL, NULL, NULL, NULL, 4),
(109993, NULL, 'G3DSA:3.30.200.20:FF:000051', NULL, NULL, 'Peripheral plasma membrane protein CASK isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(109994, NULL, 'G3DSA:2.130.10.10:FF:000424', NULL, NULL, 'p21-activated protein kinase-interacting protein 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(109995, NULL, 'G3DSA:3.20.20.10:FF:000023', NULL, NULL, 'Pyridoxal phosphate homeostasis protein', NULL, NULL, NULL, NULL, NULL, 4),
(109996, NULL, 'G3DSA:3.40.50.1450:FF:000009', NULL, NULL, 'Periplasmically oriented, membrane-bound [NiFe]-hydrogenase maturation protease', NULL, NULL, NULL, NULL, NULL, 4),
(109997, NULL, 'G3DSA:1.25.40.90:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(109998, NULL, 'G3DSA:1.20.1270.60:FF:000194', NULL, NULL, 'Dynamin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(109999, NULL, 'G3DSA:1.10.510.10:FF:000387', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(110000, NULL, 'G3DSA:2.60.40.10:FF:002537', NULL, NULL, 'Protein sidekick homolog', NULL, NULL, NULL, NULL, NULL, 4),
(110001, NULL, 'G3DSA:2.40.330.10:FF:000008', NULL, NULL, 'Reduced vernalization response 1', NULL, NULL, NULL, NULL, NULL, 4),
(110002, NULL, 'G3DSA:3.40.50.300:FF:001739', NULL, NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(110003, NULL, 'G3DSA:1.10.510.10:FF:000207', NULL, NULL, 'serine/threonine-protein kinase dst1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(110004, NULL, 'G3DSA:3.40.50.670:FF:000018', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(110005, NULL, 'G3DSA:1.25.40.550:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110006, NULL, 'G3DSA:1.25.40.10:FF:001087', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(110007, NULL, 'G3DSA:3.40.190.10:FF:000881', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110008, NULL, 'G3DSA:2.130.10.10:FF:000688', NULL, NULL, 'Periodic tryptophan protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(110009, NULL, 'G3DSA:3.40.50.720:FF:002057', NULL, NULL, 'ATG7 autophagy-related 7 homolog (S. cerevisiae)', NULL, NULL, NULL, NULL, NULL, 4),
(110010, NULL, 'G3DSA:3.40.50.1780:FF:000024', NULL, NULL, 'Putative hydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(110011, NULL, 'G3DSA:1.20.1110.10:FF:000100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110012, NULL, 'G3DSA:3.20.20.30:FF:000029', NULL, NULL, 'Alkanal monooxygenase alpha chain LuxA', NULL, NULL, NULL, NULL, NULL, 4),
(110013, NULL, 'G3DSA:3.40.50.300:FF:001711', NULL, NULL, 'GTPase HflX', NULL, NULL, NULL, NULL, NULL, 4),
(110014, NULL, 'G3DSA:1.20.5.50:FF:000004', NULL, NULL, 'Fibrinogen beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(110015, NULL, 'G3DSA:3.30.160.60:FF:003122', NULL, NULL, 'Meiotic central spindle, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(110016, NULL, 'G3DSA:2.30.29.30:FF:000039', NULL, NULL, 'Tensin 1', NULL, NULL, NULL, NULL, NULL, 4),
(110017, NULL, 'G3DSA:3.30.160.60:FF:005359', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(110018, NULL, 'G3DSA:3.20.20.60:FF:000105', NULL, NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(110019, NULL, 'G3DSA:2.60.40.10:FF:004746', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110020, NULL, 'G3DSA:3.30.1360.10:FF:000036', NULL, NULL, 'DNA-directed RNA polymerases II IV and V subunit 11', NULL, NULL, NULL, NULL, NULL, 4),
(110021, NULL, 'G3DSA:1.10.238.10:FF:001304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110022, NULL, 'G3DSA:2.30.29.150:FF:000008', NULL, NULL, 'Chromatin-specific transcription elongation factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110023, NULL, 'G3DSA:2.130.10.10:FF:002633', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110024, NULL, 'G3DSA:3.30.2350.10:FF:000064', NULL, NULL, 'Pseudouridylate synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110025, NULL, 'G3DSA:3.20.20.70:FF:000726', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110026, NULL, 'G3DSA:1.10.10.580:FF:000003', NULL, NULL, 'meiotic recombination protein REC8 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(110027, NULL, 'G3DSA:3.30.1360.120:FF:000064', NULL, NULL, 'Putative transferase CAF17, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(110028, NULL, 'G3DSA:2.60.120.920:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110029, NULL, 'G3DSA:3.40.50.1820:FF:001778', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110030, NULL, 'G3DSA:1.20.1250.20:FF:001187', NULL, NULL, 'Uncharacterized symporter YnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(110031, NULL, 'G3DSA:2.30.110.10:FF:000022', NULL, NULL, 'Heme utilization protein HutZ', NULL, NULL, NULL, NULL, NULL, 4),
(110032, NULL, 'G3DSA:3.20.20.80:FF:000263', NULL, NULL, 'Chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110033, NULL, 'G3DSA:2.60.120.200:FF:000255', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(110034, NULL, 'G3DSA:2.70.98.20:FF:000020', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(110035, NULL, 'G3DSA:2.30.39.10:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110036, NULL, 'G3DSA:3.20.20.140:FF:000392', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(110037, NULL, 'G3DSA:2.60.40.10:FF:003026', NULL, NULL, 'T-cell surface glycoprotein CD1A1 antigen', NULL, NULL, NULL, NULL, NULL, 4),
(110038, NULL, 'G3DSA:2.60.40.1120:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110039, NULL, 'G3DSA:3.80.10.10:FF:000003', NULL, NULL, 'Acidic leucine-rich nuclear phosphoprotein 32 family member A', NULL, NULL, NULL, NULL, NULL, 4),
(110040, NULL, 'G3DSA:1.25.40.10:FF:004493', NULL, NULL, 'MKIAA0372 protein', NULL, NULL, NULL, NULL, NULL, 4),
(110041, NULL, 'G3DSA:3.40.30.10:FF:000450', NULL, NULL, 'Probable nucleoredoxin 1', NULL, NULL, NULL, NULL, NULL, 4),
(110042, NULL, 'G3DSA:2.30.36.70:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110043, NULL, 'G3DSA:1.10.287.70:FF:000446', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110044, NULL, 'G3DSA:3.90.245.10:FF:000025', NULL, NULL, 'Probable ribonucleoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(110045, NULL, 'G3DSA:2.30.42.10:FF:000525', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110046, NULL, 'G3DSA:3.40.50.2000:FF:000214', NULL, NULL, 'Dolichol-linked oligosaccharide biosynthesis enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110047, NULL, 'G3DSA:3.30.760.10:FF:000016', NULL, NULL, 'Translation initiation factor eIF4E, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110048, NULL, 'G3DSA:1.10.3210.30:FF:000004', NULL, NULL, 'CRISPR-associated nuclease/helicase Cas3', NULL, NULL, NULL, NULL, NULL, 4),
(110049, NULL, 'G3DSA:3.30.70.330:FF:002828', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110050, NULL, 'G3DSA:3.30.63.10:FF:000009', NULL, NULL, 'Guanylate kinase 1', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(110051, NULL, 'G3DSA:3.30.420.40:FF:000129', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(110052, NULL, 'G3DSA:1.25.10.10:FF:002748', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110053, NULL, 'G3DSA:2.130.10.10:FF:001413', NULL, NULL, 'sperm-associated antigen 16 protein', NULL, NULL, NULL, NULL, NULL, 4),
(110054, NULL, 'G3DSA:3.15.20.10:FF:000013', NULL, NULL, 'Expression site-associated gene (ESAG) protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110055, NULL, 'G3DSA:3.40.50.12470:FF:000010', NULL, NULL, 'Oxoglutarate dehydrogenase (Succinyl-transferring), E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(110056, NULL, 'G3DSA:1.20.1560.10:FF:000651', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110057, NULL, 'G3DSA:1.10.10.60:FF:000885', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110058, NULL, 'G3DSA:1.20.58.60:FF:000511', NULL, NULL, 'Spectrin repeat-containing, nuclear envelope family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(110059, NULL, 'G3DSA:3.10.290.10:FF:000041', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(110060, NULL, 'G3DSA:3.40.50.300:FF:000722', NULL, NULL, 'Dynamin-2B isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(110061, NULL, 'G3DSA:1.20.1080.10:FF:000069', NULL, NULL, 'Aquaporin-B', NULL, NULL, NULL, NULL, NULL, 4),
(110062, NULL, 'G3DSA:1.20.1560.10:FF:000212', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110063, NULL, 'G3DSA:1.20.58.220:FF:000007', NULL, NULL, 'Phosphate-specific transport system accessory protein PhoU homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(110064, NULL, 'G3DSA:3.10.290.70:FF:000008', NULL, NULL, '40S ribosomal protein S8', NULL, NULL, NULL, NULL, NULL, 4),
(110065, NULL, 'G3DSA:3.50.50.60:FF:001090', NULL, NULL, 'Peroxisomal N1-acetyl-spermine/spermidine oxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110066, NULL, 'G3DSA:1.10.10.10:FF:001551', NULL, NULL, 'Phenylalanine--tRNA ligase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(110067, NULL, 'G3DSA:3.40.50.150:FF:001413', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110068, NULL, 'G3DSA:1.10.3720.10:FF:000020', NULL, NULL, 'Histidine ABC transporter permease HisQ', NULL, NULL, NULL, NULL, NULL, 4),
(110069, NULL, 'G3DSA:3.30.40.10:FF:001165', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(110070, NULL, 'G3DSA:2.60.120.180:FF:000001', NULL, NULL, 'Endo-1,4-beta-xylanase', NULL, NULL, NULL, NULL, NULL, 4),
(110071, NULL, 'G3DSA:1.10.10.2740:FF:000011', NULL, NULL, 'SH2 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(110072, NULL, 'G3DSA:3.40.50.300:FF:006118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110073, NULL, 'G3DSA:3.80.10.10:FF:001964', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(110074, NULL, 'G3DSA:2.40.30.10:FF:000284', NULL, NULL, 'Translation elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(110075, NULL, 'G3DSA:3.30.160.60:FF:004111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110076, NULL, 'G3DSA:3.30.930.10:FF:000255', NULL, NULL, 'Lysine--tRNA ligase cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(110077, NULL, 'G3DSA:2.60.40.10:FF:005090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110078, NULL, 'G3DSA:1.10.1200.10:FF:000172', NULL, NULL, 'Didemethylasterriquinone D synthetase tdiA', NULL, NULL, NULL, NULL, NULL, 4),
(110079, NULL, 'G3DSA:3.40.710.10:FF:000135', NULL, NULL, 'Penicillin-binding protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(110080, NULL, 'G3DSA:2.60.40.150:FF:000736', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(110081, NULL, 'G3DSA:3.40.532.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110082, NULL, 'G3DSA:1.10.510.10:FF:004102', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110083, NULL, 'G3DSA:2.60.120.920:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(110084, NULL, 'G3DSA:3.30.460.10:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110085, NULL, 'G3DSA:3.30.450.40:FF:000221', NULL, NULL, 'Phytochrome-like protein cph2', NULL, NULL, NULL, NULL, NULL, 4),
(110086, NULL, 'G3DSA:1.25.40.10:FF:002840', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(110087, NULL, 'G3DSA:3.10.280.10:FF:000012', NULL, NULL, 'Os05g0456000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(110088, NULL, 'G3DSA:3.30.160.20:FF:000255', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(110089, NULL, 'G3DSA:3.30.70.330:FF:002244', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110090, NULL, 'G3DSA:3.40.50.10140:FF:000013', NULL, NULL, 'Sterile alpha and TIR motif containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(110091, NULL, 'G3DSA:3.60.10.10:FF:000313', NULL, NULL, 'Endonuclease/Exonuclease/phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(110092, NULL, 'G3DSA:2.10.70.10:FF:000029', NULL, NULL, 'Inactive serine protease PAMR1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(110093, NULL, 'G3DSA:3.40.50.300:FF:004937', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110094, NULL, 'G3DSA:2.30.30.100:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110095, NULL, 'G3DSA:3.30.1330.30:FF:000102', NULL, NULL, '60S ribosomal protein L7a', NULL, NULL, NULL, NULL, NULL, 4),
(110096, NULL, 'G3DSA:3.30.870.10:FF:000053', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(110097, NULL, 'G3DSA:3.30.710.10:FF:000513', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110098, NULL, 'G3DSA:3.30.460.10:FF:000090', NULL, NULL, 'DNA-directed DNA/RNA polymerase mu', NULL, NULL, NULL, NULL, NULL, 4),
(110099, NULL, 'G3DSA:3.10.110.10:FF:000293', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110100, NULL, 'G3DSA:3.30.40.10:FF:000176', NULL, NULL, 'MDM4 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(110101, NULL, 'G3DSA:1.25.40.20:FF:000016', NULL, NULL, 'Ankyrin repeat and SOCS box containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(110102, NULL, 'G3DSA:3.30.160.60:FF:000216', NULL, NULL, 'Zinc finger protein 384 like', NULL, NULL, NULL, NULL, NULL, 4),
(110103, NULL, 'G3DSA:2.30.42.10:FF:000025', NULL, NULL, 'Glutamate receptor interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(110104, NULL, 'G3DSA:2.60.40.10:FF:002329', NULL, NULL, 'Alpha-1,4-glucan:maltose-1-phosphate maltosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(110105, NULL, 'G3DSA:3.30.160.60:FF:000688', NULL, NULL, 'zinc finger protein 197 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(110106, NULL, 'G3DSA:2.130.10.10:FF:000896', NULL, NULL, 'U3 small nucleolar RNA-associated protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(110107, NULL, 'G3DSA:1.10.510.10:FF:000095', NULL, NULL, 'protein STRUBBELIG-RECEPTOR FAMILY 8', NULL, NULL, NULL, NULL, NULL, 4),
(110108, NULL, 'G3DSA:1.10.287.110:FF:000251', NULL, NULL, 'Chaperone protein DnaJ 1', NULL, NULL, NULL, NULL, NULL, 4),
(110109, NULL, 'G3DSA:1.10.1380.10:FF:000009', NULL, NULL, 'CRE-NEP-2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(110110, NULL, 'G3DSA:2.60.120.820:FF:000002', NULL, NULL, 'E3 ubiquitin-protein ligase MYCBP2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(110111, NULL, 'G3DSA:3.40.50.1820:FF:000025', NULL, NULL, 'putative methylesterase 11, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(110112, NULL, 'G3DSA:2.60.40.60:FF:000793', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110113, NULL, 'G3DSA:3.30.300.30:FF:000117', NULL, NULL, 'AMP-dependent synthetase and ligase', NULL, NULL, NULL, NULL, NULL, 4),
(110114, NULL, 'G3DSA:3.40.50.720:FF:002265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110115, NULL, 'G3DSA:3.40.50.2300:FF:001142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110116, NULL, 'G3DSA:1.10.287.130:FF:000257', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(110117, NULL, 'G3DSA:3.40.50.300:FF:002375', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(110118, NULL, 'G3DSA:2.60.200.20:FF:000110', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110119, NULL, 'G3DSA:3.80.10.10:FF:003201', NULL, NULL, 'NLR family member X1', NULL, NULL, NULL, NULL, NULL, 4),
(110120, NULL, 'G3DSA:3.40.630.10:FF:000134', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(110121, NULL, 'G3DSA:3.40.50.800:FF:000046', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(110122, NULL, 'G3DSA:3.40.1180.10:FF:000020', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(110123, NULL, 'G3DSA:3.20.20.70:FF:000226', NULL, NULL, 'Transaldolase', NULL, NULL, NULL, NULL, NULL, 4),
(110124, NULL, 'G3DSA:3.30.50.10:FF:000002', NULL, NULL, 'Gata transcription factor gatad', NULL, NULL, NULL, NULL, NULL, 4),
(110125, NULL, 'G3DSA:1.25.40.10:FF:004285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110126, NULL, 'G3DSA:1.50.40.10:FF:000067', NULL, NULL, 'Mitochondrial substrate carrier family protein', NULL, NULL, NULL, NULL, NULL, 4),
(110127, NULL, 'G3DSA:3.90.105.10:FF:000015', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(110128, NULL, 'G3DSA:2.10.25.10:FF:000397', NULL, NULL, 'Otogelin', NULL, NULL, NULL, NULL, NULL, 4),
(110129, NULL, 'G3DSA:3.50.50.60:FF:001202', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(110130, NULL, 'G3DSA:3.40.630.10:FF:000398', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110131, NULL, 'G3DSA:3.20.20.190:FF:000002', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(110132, NULL, 'G3DSA:2.60.40.420:FF:000132', NULL, NULL, 'Multicopper oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(110133, NULL, 'G3DSA:2.30.29.30:FF:000247', NULL, NULL, 'pleckstrin homology domain-containing family F member 1', NULL, NULL, NULL, NULL, NULL, 4),
(110134, NULL, 'G3DSA:1.10.1040.10:FF:000018', NULL, NULL, 'Altronate oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(110135, NULL, 'G3DSA:1.10.510.10:FF:003585', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110136, NULL, 'G3DSA:3.10.20.90:FF:000109', NULL, NULL, 'Arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(110137, NULL, 'G3DSA:1.25.50.20:FF:000045', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(110138, NULL, 'G3DSA:1.20.140.10:FF:000114', NULL, NULL, 'acyl-CoA dehydrogenase family member 9, mitochondrial-like', NULL, NULL, NULL, NULL, NULL, 4),
(110139, NULL, 'G3DSA:2.60.120.260:FF:000519', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(110140, NULL, 'G3DSA:3.50.50.60:FF:000685', NULL, NULL, '2-polyprenyl-6-methoxyphenol hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(110141, NULL, 'G3DSA:1.25.40.420:FF:000058', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(110142, NULL, 'G3DSA:2.60.40.60:FF:000938', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110143, NULL, 'G3DSA:1.10.10.10:FF:000831', NULL, NULL, 'Interferon regulatory factor like protein', NULL, NULL, NULL, NULL, NULL, 4),
(110144, NULL, 'G3DSA:1.20.1250.20:FF:000198', NULL, NULL, 'High affinity nitrate transporter 2.5', NULL, NULL, NULL, NULL, NULL, 4),
(110145, NULL, 'G3DSA:3.20.20.150:FF:000041', NULL, NULL, 'Sugar phosphate isomerase/epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(110146, NULL, 'G3DSA:1.10.400.10:FF:000058', NULL, NULL, 'Guanine nucleotide-binding protein subunit alpha-12', NULL, NULL, NULL, NULL, NULL, 4),
(110147, NULL, 'G3DSA:3.30.470.20:FF:000065', NULL, NULL, 'Carbamoyl-phosphate synthase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(110148, NULL, 'G3DSA:2.130.10.10:FF:003561', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110149, NULL, 'G3DSA:2.130.10.10:FF:002841', NULL, NULL, 'Ribosome biogenesis protein BOP1 homolog', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(110150, NULL, 'G3DSA:3.30.2410.10:FF:000035', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(110151, NULL, 'G3DSA:2.10.70.10:FF:000181', NULL, NULL, 'Proclotting enzyme precursor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110152, NULL, 'G3DSA:3.30.200.20:FF:000551', NULL, NULL, 'STE20/SPS1-related proline-alanine-rich protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(110153, NULL, 'G3DSA:2.30.30.40:FF:000585', NULL, NULL, 'CD2-associated protein like', NULL, NULL, NULL, NULL, NULL, 4),
(110154, NULL, 'G3DSA:1.25.10.10:FF:002692', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(110155, NULL, 'G3DSA:1.10.510.10:FF:002865', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110156, NULL, 'G3DSA:2.70.130.10:FF:000172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110157, NULL, 'G3DSA:2.60.40.60:FF:000113', NULL, NULL, 'Cadherin-related family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(110158, NULL, 'G3DSA:3.40.50.1000:FF:000223', NULL, NULL, '3-deoxy-D-manno-octulosonate 8-phosphate phosphatase KdsC', NULL, NULL, NULL, NULL, NULL, 4),
(110159, NULL, 'G3DSA:2.60.120.10:FF:000836', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110160, NULL, 'G3DSA:3.60.15.10:FF:000009', NULL, NULL, 'Anaerobic nitric oxide reductase flavorubredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(110161, NULL, 'G3DSA:2.130.10.10:FF:000071', NULL, NULL, 'Bromodomain and WD repeat domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(110162, NULL, 'G3DSA:1.25.10.10:FF:003468', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(110163, NULL, 'G3DSA:3.40.50.300:FF:001386', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110164, NULL, 'G3DSA:3.90.190.10:FF:000184', NULL, NULL, 'Leucine rich repeat and phosphatase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(110165, NULL, 'G3DSA:1.25.40.10:FF:001412', NULL, NULL, 'RE19263p', NULL, NULL, NULL, NULL, NULL, 4),
(110166, NULL, 'G3DSA:2.130.10.10:FF:001205', NULL, NULL, 'Ribosome biogenesis protein WDR12 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(110167, NULL, 'G3DSA:1.10.10.10:FF:001287', NULL, NULL, 'Rrf2 family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(110168, NULL, 'G3DSA:1.10.510.10:FF:003821', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110169, NULL, 'G3DSA:2.60.34.10:FF:000090', NULL, NULL, 'Protein CBG18133', NULL, NULL, NULL, NULL, NULL, 4),
(110170, NULL, 'G3DSA:3.30.110.60:FF:000005', NULL, NULL, 'CRM-domain containing factor CFM2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(110171, NULL, 'G3DSA:3.30.200.20:FF:001332', NULL, NULL, 'Wall-associated receptor kinase-like 10', NULL, NULL, NULL, NULL, NULL, 4),
(110172, NULL, 'G3DSA:1.10.238.10:FF:000607', NULL, NULL, 'Calmodulin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110173, NULL, 'G3DSA:1.10.10.10:FF:000123', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(110174, NULL, 'G3DSA:2.40.50.690:FF:000011', NULL, NULL, 'Exosome complex exonuclease RRP44, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110175, NULL, 'G3DSA:3.30.70.330:FF:002980', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110176, NULL, 'G3DSA:3.30.1060.10:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110177, NULL, 'G3DSA:3.30.70.330:FF:000299', NULL, NULL, 'Serine/arginine-rich splicing factor RS31', NULL, NULL, NULL, NULL, NULL, 4),
(110178, NULL, 'G3DSA:3.40.50.300:FF:000458', NULL, NULL, 'ADP-ribosylation factor-like protein 4C', NULL, NULL, NULL, NULL, NULL, 4),
(110179, NULL, 'G3DSA:1.10.150.60:FF:000014', NULL, NULL, 'Osa, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(110180, NULL, 'G3DSA:2.60.120.10:FF:000252', NULL, NULL, 'Glutaminase 2', NULL, NULL, NULL, NULL, NULL, 4),
(110181, NULL, 'G3DSA:3.80.10.10:FF:001756', NULL, NULL, 'Toll-like receptor 15', NULL, NULL, NULL, NULL, NULL, 4),
(110182, NULL, 'G3DSA:3.40.50.300:FF:003595', NULL, NULL, 'WGS project CABT00000000 data, contig 2.18', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(110183, NULL, 'G3DSA:1.10.540.10:FF:000035', NULL, NULL, 'Acyl-CoA dehydrogenase FadE21', NULL, NULL, NULL, NULL, NULL, 4),
(110184, NULL, 'G3DSA:1.10.510.10:FF:003113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110185, NULL, 'G3DSA:3.60.20.10:FF:000078', NULL, NULL, 'Amidophosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(110186, NULL, 'G3DSA:3.40.50.2300:FF:001350', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110187, NULL, 'G3DSA:1.25.40.10:FF:004638', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110188, NULL, 'G3DSA:3.30.160.60:FF:003594', NULL, NULL, 'Zinc finger protein 224', NULL, NULL, NULL, NULL, NULL, 4),
(110189, NULL, 'G3DSA:3.80.10.10:FF:002684', NULL, NULL, 'Receptor-like protein kinase HSL1', NULL, NULL, NULL, NULL, NULL, 4),
(110190, NULL, 'G3DSA:3.90.1110.10:FF:000015', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(110191, NULL, 'G3DSA:1.10.287.70:FF:000710', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110192, NULL, 'G3DSA:1.20.1440.340:FF:000010', NULL, NULL, 'N-acetylgalactosamine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(110193, NULL, 'G3DSA:3.20.20.70:FF:000434', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110194, NULL, 'G3DSA:1.50.10.10:FF:000150', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(110195, NULL, 'G3DSA:3.40.50.300:FF:005129', NULL, NULL, 'Site-determining protein', NULL, NULL, NULL, NULL, NULL, 4),
(110196, NULL, 'G3DSA:3.30.9.10:FF:000120', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(110197, NULL, 'G3DSA:1.10.238.10:FF:000023', NULL, NULL, 'dystrophin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(110198, NULL, 'G3DSA:3.30.460.20:FF:000036', NULL, NULL, 'Magnesium transport protein CorA', NULL, NULL, NULL, NULL, NULL, 4),
(110199, NULL, 'G3DSA:1.25.40.1030:FF:000036', NULL, NULL, 'Protein transport protein Sec31, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110200, NULL, 'G3DSA:3.30.60.270:FF:000015', NULL, NULL, 'Sortilin-related VPS10 domain-containing receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(110201, NULL, 'G3DSA:2.60.120.200:FF:000608', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110202, NULL, 'G3DSA:3.40.390.10:FF:000098', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(110203, NULL, 'G3DSA:1.10.287.3510:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110204, NULL, 'G3DSA:3.40.50.620:FF:000228', NULL, NULL, 'Cysteinyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(110205, NULL, 'G3DSA:2.30.30.490:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110206, NULL, 'G3DSA:1.20.5.650:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110207, NULL, 'G3DSA:1.10.287.70:FF:000093', NULL, NULL, 'Calcium channel subunit Cch1', NULL, NULL, NULL, NULL, NULL, 4),
(110208, NULL, 'G3DSA:3.40.50.1010:FF:000108', NULL, NULL, 'Ribonuclease VapC', NULL, NULL, NULL, NULL, NULL, 4),
(110209, NULL, 'G3DSA:1.25.40.10:FF:004021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110210, NULL, 'G3DSA:3.90.1180.10:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110211, NULL, 'G3DSA:2.60.40.150:FF:000028', NULL, NULL, 'Synaptotagmin 7', NULL, NULL, NULL, NULL, NULL, 4),
(110212, NULL, 'G3DSA:3.40.50.1820:FF:000289', NULL, NULL, 'Pheromone-processing carboxypeptidase KEX1', NULL, NULL, NULL, NULL, NULL, 4),
(110213, NULL, 'G3DSA:1.50.10.10:FF:000239', NULL, NULL, 'N-acylglucosamine 2-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(110214, NULL, 'G3DSA:2.60.40.10:FF:003257', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110215, NULL, 'G3DSA:3.60.10.10:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110216, NULL, 'G3DSA:3.10.440.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110217, NULL, 'G3DSA:1.10.3120.10:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(110218, NULL, 'G3DSA:3.30.200.20:FF:000343', NULL, NULL, 'Acyl-CoA dehydrogenase family member 10', NULL, NULL, NULL, NULL, NULL, 4),
(110219, NULL, 'G3DSA:1.20.140.150:FF:000057', NULL, NULL, 'GH12419p1', NULL, NULL, NULL, NULL, NULL, 4),
(110220, NULL, 'G3DSA:3.30.160.60:FF:000160', NULL, NULL, 'zinc finger homeobox protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(110221, NULL, 'G3DSA:3.40.630.30:FF:000292', NULL, NULL, 'Putative GNAT family acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(110222, NULL, 'G3DSA:3.40.50.300:FF:001447', NULL, NULL, 'Ras-related protein Rab-1B', NULL, NULL, NULL, NULL, NULL, 4),
(110223, NULL, 'G3DSA:2.110.10.10:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110224, NULL, 'G3DSA:2.60.120.330:FF:000035', NULL, NULL, 'Probable fatty alcohol oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(110225, NULL, 'G3DSA:3.30.160.60:FF:000008', NULL, NULL, 'RB-associated KRAB zinc finger protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(110226, NULL, 'G3DSA:3.30.40.10:FF:001873', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110227, NULL, 'G3DSA:3.30.1520.10:FF:000043', NULL, NULL, 'SH3 and PX domain-containing protein 2B', NULL, NULL, NULL, NULL, NULL, 4),
(110228, NULL, 'G3DSA:3.10.105.10:FF:000016', NULL, NULL, 'Oligopeptide ABC transporter, solute-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(110229, NULL, 'G3DSA:3.40.50.1820:FF:001806', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(110230, NULL, 'G3DSA:3.90.25.10:FF:000003', NULL, NULL, 'GDP-mannose 4,6-dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(110231, NULL, 'G3DSA:3.40.30.10:FF:000006', NULL, NULL, 'Glutaredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(110232, NULL, 'G3DSA:3.50.50.60:FF:001410', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110233, NULL, 'G3DSA:3.20.20.80:FF:000494', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110234, NULL, 'G3DSA:3.10.20.90:FF:000261', NULL, NULL, 'Auxin response factor', NULL, NULL, NULL, NULL, NULL, 4),
(110235, NULL, 'G3DSA:3.40.50.2000:FF:000922', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110236, NULL, 'G3DSA:1.25.40.20:FF:000488', NULL, NULL, 'Espin-like a', NULL, NULL, NULL, NULL, NULL, 4),
(110237, NULL, 'G3DSA:2.80.10.50:FF:000034', NULL, NULL, 'Dolichyl-phosphate-mannose-protein mannosyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(110238, NULL, 'G3DSA:2.30.42.10:FF:000497', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110239, NULL, 'G3DSA:2.40.10.10:FF:000485', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110240, NULL, 'G3DSA:2.30.42.10:FF:000233', NULL, NULL, 'Related to GRH1-acetylated protein, involved in ER to Golgi transport', NULL, NULL, NULL, NULL, NULL, 4),
(110241, NULL, 'G3DSA:1.20.58.200:FF:000001', NULL, NULL, 'Translin-associated factor X', NULL, NULL, NULL, NULL, NULL, 4),
(110242, NULL, 'G3DSA:3.30.70.270:FF:000079', NULL, NULL, 'Diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(110243, NULL, 'G3DSA:3.30.420.10:FF:000025', NULL, NULL, 'Gag-Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(110244, NULL, 'G3DSA:1.20.58.120:FF:000011', NULL, NULL, 'BAG family molecular chaperone regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(110245, NULL, 'G3DSA:2.130.10.10:FF:004639', NULL, NULL, 'Chromosome 15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(110246, NULL, 'G3DSA:3.40.50.300:FF:005281', NULL, NULL, 'Putative gtpase rho', NULL, NULL, NULL, NULL, NULL, 4),
(110247, NULL, 'G3DSA:3.40.50.620:FF:000380', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(110248, NULL, 'G3DSA:3.40.50.720:FF:000112', NULL, NULL, 'Enoyl-[acyl-carrier-protein] reductase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(110249, NULL, 'G3DSA:3.10.20.600:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110250, NULL, 'G3DSA:3.10.100.10:FF:000320', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110251, NULL, 'G3DSA:3.90.470.40:FF:000001', NULL, NULL, 'DNA damage-inducible transcript 4 protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(110252, NULL, 'G3DSA:1.10.460.10:FF:000034', NULL, NULL, 'DNA topoisomerase (TopA)', NULL, NULL, NULL, NULL, NULL, 4),
(110253, NULL, 'G3DSA:2.60.40.60:FF:001102', NULL, NULL, 'CaDHerin family', NULL, NULL, NULL, NULL, NULL, 4),
(110254, NULL, 'G3DSA:1.10.510.10:FF:001876', NULL, NULL, 'PH-protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(110255, NULL, 'G3DSA:3.40.50.300:FF:000930', NULL, NULL, 'ORC1-type DNA replication protein', NULL, NULL, NULL, NULL, NULL, 4),
(110256, NULL, 'G3DSA:2.130.10.10:FF:004550', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110257, NULL, 'G3DSA:3.10.20.350:FF:000002', NULL, NULL, 'Replicase polyprotein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(110258, NULL, 'G3DSA:3.40.50.720:FF:000820', NULL, NULL, 'Putative oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(110259, NULL, 'G3DSA:3.40.720.10:FF:000372', NULL, NULL, 'Arylsulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(110260, NULL, 'G3DSA:1.20.120.980:FF:000032', NULL, NULL, 'Serine peptidase, family S28, putative (AFU_orthologue AFUA_4G03790)', NULL, NULL, NULL, NULL, NULL, 4),
(110261, NULL, 'G3DSA:2.60.110.10:FF:000015', NULL, NULL, 'Os05g0538500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(110262, NULL, 'G3DSA:2.160.20.10:FF:000238', NULL, NULL, 'Os11g0194000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(110263, NULL, 'G3DSA:3.40.640.10:FF:000371', NULL, NULL, 'PLP-dependent aminotransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(110264, NULL, 'G3DSA:3.10.310.10:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110265, NULL, 'G3DSA:2.120.10.80:FF:000097', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(110266, NULL, 'G3DSA:1.25.40.10:FF:002576', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g65570', NULL, NULL, NULL, NULL, NULL, 4),
(110267, NULL, 'G3DSA:3.40.50.300:FF:007490', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110268, NULL, 'G3DSA:1.10.10.10:FF:000623', NULL, NULL, 'Slf1p', NULL, NULL, NULL, NULL, NULL, 4),
(110269, NULL, 'G3DSA:2.40.20.10:FF:000047', NULL, NULL, 'Hepatocyte growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(110270, NULL, 'G3DSA:3.40.50.300:FF:007810', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110271, NULL, 'G3DSA:3.30.160.40:FF:000002', NULL, NULL, 'Porphobilinogen deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(110272, NULL, 'G3DSA:3.90.228.20:FF:000005', NULL, NULL, 'Phosphoenolpyruvate carboxykinase [GTP], mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(110273, NULL, 'G3DSA:1.25.40.10:FF:002076', NULL, NULL, 'Adenylate/guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(110274, NULL, 'G3DSA:1.20.1070.10:FF:000804', NULL, NULL, 'Tachykinin receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(110275, NULL, 'G3DSA:3.40.30.10:FF:000978', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110276, NULL, 'G3DSA:2.60.120.520:FF:000002', NULL, NULL, '4-deoxy-L-threo-5-hexosulose-uronate ketol-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(110277, NULL, 'G3DSA:1.50.40.10:FF:000331', NULL, NULL, 'Mitochondrial carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(110278, NULL, 'G3DSA:3.90.740.10:FF:000030', NULL, NULL, 'valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(110279, NULL, 'G3DSA:3.20.20.100:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110280, NULL, 'G3DSA:3.30.160.60:FF:006320', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110281, NULL, 'G3DSA:3.30.40.10:FF:000237', NULL, NULL, 'Histone-lysine N-methyltransferase 2C', NULL, NULL, NULL, NULL, NULL, 4),
(110282, NULL, 'G3DSA:1.25.40.10:FF:004993', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(110283, NULL, 'G3DSA:3.30.1640.10:FF:000018', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(110284, NULL, 'G3DSA:3.40.50.720:FF:000584', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(110285, NULL, 'G3DSA:3.40.190.10:FF:000942', NULL, NULL, 'Glutamate receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110286, NULL, 'G3DSA:2.60.40.10:FF:004162', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110287, NULL, 'G3DSA:3.30.200.20:FF:001068', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110288, NULL, 'G3DSA:3.40.50.300:FF:005865', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110289, NULL, 'G3DSA:3.40.80.10:FF:000009', NULL, NULL, 'Endolysin', NULL, NULL, NULL, NULL, NULL, 4),
(110290, NULL, 'G3DSA:2.130.10.10:FF:003622', NULL, NULL, 'WD repeat-containing protein 3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(110291, NULL, 'G3DSA:1.10.510.10:FF:001168', NULL, NULL, 'Protein CBG12029', NULL, NULL, NULL, NULL, NULL, 4),
(110292, NULL, 'G3DSA:1.20.120.1080:FF:000018', NULL, NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase prp16', NULL, NULL, NULL, NULL, NULL, 4),
(110293, NULL, 'G3DSA:3.30.450.90:FF:000011', NULL, NULL, 'Type II secretion system protein GspE', NULL, NULL, NULL, NULL, NULL, 4),
(110294, NULL, 'G3DSA:3.30.70.330:FF:000619', NULL, NULL, 'tRNA methyltransferase 2 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(110295, NULL, 'G3DSA:3.40.50.300:FF:004112', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(110296, NULL, 'G3DSA:1.20.1250.20:FF:000759', NULL, NULL, 'Drug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110297, NULL, 'G3DSA:1.10.287.370:FF:000014', NULL, NULL, 'Prefoldin subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(110298, NULL, 'G3DSA:3.50.50.60:FF:000746', NULL, NULL, 'Dihydropyrimidine dehydrogenase [NADP(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(110299, NULL, 'G3DSA:2.130.10.120:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110300, NULL, 'G3DSA:2.60.40.10:FF:002981', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase beta', NULL, NULL, NULL, NULL, NULL, 4),
(110301, NULL, 'G3DSA:3.40.50.80:FF:000129', NULL, NULL, 'GD19100', NULL, NULL, NULL, NULL, NULL, 4),
(110302, NULL, 'G3DSA:1.25.40.10:FF:001912', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(110303, NULL, 'G3DSA:2.60.40.10:FF:001812', NULL, NULL, 'Jitterbug, isoform M', NULL, NULL, NULL, NULL, NULL, 4),
(110304, NULL, 'G3DSA:3.40.50.620:FF:000436', NULL, NULL, 'Tryptophan--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(110305, NULL, 'G3DSA:3.30.200.20:FF:000904', NULL, NULL, 'Protein CBG18395', NULL, NULL, NULL, NULL, NULL, 4),
(110306, NULL, 'G3DSA:3.20.20.300:FF:000075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110307, NULL, 'G3DSA:3.30.70.330:FF:003025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110308, NULL, 'G3DSA:2.60.40.770:FF:000006', NULL, NULL, 'Lymphocyte antigen 96', NULL, NULL, NULL, NULL, NULL, 4),
(110309, NULL, 'G3DSA:3.30.565.10:FF:000203', NULL, NULL, 'Sensor kinase CitA', NULL, NULL, NULL, NULL, NULL, 4),
(110310, NULL, 'G3DSA:3.30.1360.40:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110311, NULL, 'G3DSA:2.10.25.10:FF:000430', NULL, NULL, 'Laminin subunit alpha 5', NULL, NULL, NULL, NULL, NULL, 4),
(110312, NULL, 'G3DSA:1.20.58.70:FF:000104', NULL, NULL, 'Diablo, IAP-binding mitochondrial protein a', NULL, NULL, NULL, NULL, NULL, 4),
(110313, NULL, 'G3DSA:3.40.190.290:FF:000041', NULL, NULL, 'HTH-type transcriptional regulator GltC', NULL, NULL, NULL, NULL, NULL, 4),
(110314, NULL, 'G3DSA:1.25.40.10:FF:004846', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110315, NULL, 'G3DSA:1.20.1070.10:FF:000692', NULL, NULL, 'NeuroPeptide Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(110316, NULL, 'G3DSA:1.10.10.60:FF:000060', NULL, NULL, 'MYB transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(110317, NULL, 'G3DSA:2.60.120.260:FF:000458', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110318, NULL, 'G3DSA:2.30.29.30:FF:000511', NULL, NULL, 'AGC/RSK/RSKP90 protein kinase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(110319, NULL, 'G3DSA:3.40.30.10:FF:000506', NULL, NULL, 'Thioredoxin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110320, NULL, 'G3DSA:2.40.50.140:FF:000425', NULL, NULL, 'Unplaced genomic scaffold supercont1.10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(110321, NULL, 'G3DSA:3.40.630.30:FF:000404', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(110322, NULL, 'G3DSA:3.30.70.270:FF:000320', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110323, NULL, 'G3DSA:3.30.70.870:FF:000051', NULL, NULL, 'Small GTP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(110324, NULL, 'G3DSA:3.30.60.20:FF:000096', NULL, NULL, 'Protein kinase D, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(110325, NULL, 'G3DSA:2.30.31.10:FF:000005', NULL, NULL, 'Putative transcriptional co-activator', NULL, NULL, NULL, NULL, NULL, 4),
(110326, NULL, 'G3DSA:3.50.7.10:FF:000009', NULL, NULL, 'T-complex protein 1 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(110327, NULL, 'G3DSA:1.10.510.10:FF:003321', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110328, NULL, 'G3DSA:3.40.50.300:FF:003095', NULL, NULL, 'Small GTPase EhRabX36, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110329, NULL, 'G3DSA:3.40.50.10490:FF:000034', NULL, NULL, 'Fructoselysine 6-phosphate deglycase', NULL, NULL, NULL, NULL, NULL, 4),
(110330, NULL, 'G3DSA:3.80.10.10:FF:002892', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(110331, NULL, 'G3DSA:2.60.40.3610:FF:000002', NULL, NULL, 'Outer membrane protein SusF', NULL, NULL, NULL, NULL, NULL, 4),
(110332, NULL, 'G3DSA:3.90.210.10:FF:000001', NULL, NULL, 'Cholera enterotoxin subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(110333, NULL, 'G3DSA:2.10.25.10:FF:001655', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110334, NULL, 'G3DSA:2.30.30.40:FF:000321', NULL, NULL, 'JNK Interacting Protein (Scaffold protein)', NULL, NULL, NULL, NULL, NULL, 4),
(110335, NULL, 'G3DSA:2.40.160.210:FF:000006', NULL, NULL, 'Acyl-CoA thioesterase II', NULL, NULL, NULL, NULL, NULL, 4),
(110336, NULL, 'G3DSA:1.20.1070.10:FF:001973', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110337, NULL, 'G3DSA:3.40.720.10:FF:000225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110338, NULL, 'G3DSA:3.40.50.10680:FF:000001', NULL, NULL, '2-phospho-L-lactate transferase', NULL, NULL, NULL, NULL, NULL, 4),
(110339, NULL, 'G3DSA:3.90.79.20:FF:000012', NULL, NULL, 'NADH pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(110340, NULL, 'G3DSA:1.10.150.830:FF:000001', NULL, NULL, 'Transcription factor cep-1', NULL, NULL, NULL, NULL, NULL, 4),
(110341, NULL, 'G3DSA:2.30.30.380:FF:000046', NULL, NULL, 'COPII vesicle coat protein', NULL, NULL, NULL, NULL, NULL, 4),
(110342, NULL, 'G3DSA:2.60.40.150:FF:000528', NULL, NULL, 'Phosphatidylinositol 3-kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(110343, NULL, 'G3DSA:3.30.1360.220:FF:000004', NULL, NULL, 'AGAP004049-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(110344, NULL, 'G3DSA:1.10.150.240:FF:000066', NULL, NULL, 'Beta-phosphoglucomutase family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(110345, NULL, 'G3DSA:1.10.630.10:FF:000103', NULL, NULL, 'Steroid C26-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(110346, NULL, 'G3DSA:1.25.40.470:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110347, NULL, 'G3DSA:3.40.50.2300:FF:000686', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(110348, NULL, 'G3DSA:1.20.58.60:FF:000478', NULL, NULL, 'Spectrin repeat-containing, nuclear envelope 1b', NULL, NULL, NULL, NULL, NULL, 4),
(110349, NULL, 'G3DSA:1.10.565.10:FF:000182', NULL, NULL, 'Nuclear receptor subfamily 1 group I member 3', NULL, NULL, NULL, NULL, NULL, 4),
(110350, NULL, 'G3DSA:3.40.50.2300:FF:000422', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(110351, NULL, 'G3DSA:1.25.40.10:FF:000895', NULL, NULL, 'PPR-repeat protein-like', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(110352, NULL, 'G3DSA:3.40.50.300:FF:006618', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(110353, NULL, 'G3DSA:2.60.120.330:FF:000182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110354, NULL, 'G3DSA:2.120.10.30:FF:000543', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110355, NULL, 'G3DSA:3.90.70.10:FF:000102', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(110356, NULL, 'G3DSA:2.20.25.10:FF:000025', NULL, NULL, 'UPF0434 protein SCO3027', NULL, NULL, NULL, NULL, NULL, 4),
(110357, NULL, 'G3DSA:3.80.20.20:FF:000097', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(110358, NULL, 'G3DSA:3.40.50.150:FF:001060', NULL, NULL, 'Leucine carboxyl methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(110359, NULL, 'G3DSA:1.20.5.340:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110360, NULL, 'G3DSA:3.10.20.90:FF:000845', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(110361, NULL, 'G3DSA:3.80.10.10:FF:002420', NULL, NULL, 'Leucine-rich repeat-containing 15', NULL, NULL, NULL, NULL, NULL, 4),
(110362, NULL, 'G3DSA:3.30.70.330:FF:000563', NULL, NULL, 'Nucleolin 2 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(110363, NULL, 'G3DSA:6.20.50.160:FF:000004', NULL, NULL, 'C5 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(110364, NULL, 'G3DSA:3.30.420.580:FF:000010', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(110365, NULL, 'G3DSA:3.40.50.80:FF:000073', NULL, NULL, 'ferric reduction oxidase 8, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(110366, NULL, 'G3DSA:3.30.70.141:FF:000018', NULL, NULL, 'Nucleoside diphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(110367, NULL, 'G3DSA:3.40.50.2000:FF:000714', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(110368, NULL, 'G3DSA:1.10.418.20:FF:000001', NULL, NULL, 'sentrin-specific protease 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(110369, NULL, 'G3DSA:2.60.40.10:FF:005443', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110370, NULL, 'G3DSA:3.30.40.10:FF:001401', NULL, NULL, 'ZNF1', NULL, NULL, NULL, NULL, NULL, 4),
(110371, NULL, 'G3DSA:3.30.200.20:FF:002496', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(110372, NULL, 'G3DSA:1.20.930.80:FF:000010', NULL, NULL, 'Putative eukaryotic-type dna primase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(110373, NULL, 'G3DSA:2.130.10.10:FF:001936', NULL, NULL, 'Protein HIR2', NULL, NULL, NULL, NULL, NULL, 4),
(110374, NULL, 'G3DSA:3.30.200.20:FF:001271', NULL, NULL, 'Protein CBG21908', NULL, NULL, NULL, NULL, NULL, 4),
(110375, NULL, 'G3DSA:3.30.450.20:FF:000474', NULL, NULL, 'Sensory box histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(110376, NULL, 'G3DSA:2.40.10.10:FF:000013', NULL, NULL, 'Coagulation factor X', NULL, NULL, NULL, NULL, NULL, 4),
(110377, NULL, 'G3DSA:3.40.850.10:FF:000229', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(110378, NULL, 'G3DSA:2.60.40.10:FF:003757', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110379, NULL, 'G3DSA:3.40.50.1010:FF:000260', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110380, NULL, 'G3DSA:3.40.50.300:FF:001239', NULL, NULL, 'ADP-ribosylation factor family protein', NULL, NULL, NULL, NULL, NULL, 4),
(110381, NULL, 'G3DSA:1.20.58.80:FF:000017', NULL, NULL, 'sorting nexin-15 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(110382, NULL, 'G3DSA:3.90.1140.10:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110383, NULL, 'G3DSA:2.40.160.110:FF:000010', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(110384, NULL, 'G3DSA:1.10.150.850:FF:000007', NULL, NULL, 'Transcription elongation factor spt6, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110385, NULL, 'G3DSA:1.10.10.1410:FF:000005', NULL, NULL, '60S acidic ribosomal protein, putative', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(110386, NULL, 'G3DSA:2.30.40.10:FF:000043', NULL, NULL, 'Adenine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(110387, NULL, 'G3DSA:2.40.128.320:FF:000002', NULL, NULL, 'Cytochrome c heme lyase', NULL, NULL, NULL, NULL, NULL, 4),
(110388, NULL, 'G3DSA:3.90.870.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110389, NULL, 'G3DSA:3.40.250.10:FF:000116', NULL, NULL, 'Sb(V)-As(V) reductase', NULL, NULL, NULL, NULL, NULL, 4),
(110390, NULL, 'G3DSA:2.130.10.10:FF:005567', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110391, NULL, 'G3DSA:2.170.150.10:FF:000014', NULL, NULL, 'Translationally controlled tumor protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(110392, NULL, 'G3DSA:1.20.5.110:FF:000121', NULL, NULL, 't-SNARE domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(110393, NULL, 'G3DSA:3.30.465.10:FF:000139', NULL, NULL, 'UDP-N-acetylenolpyruvoylglucosamine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(110394, NULL, 'G3DSA:3.20.20.100:FF:000048', NULL, NULL, 'Probable aldo-keto reductase 4', NULL, NULL, NULL, NULL, NULL, 4),
(110395, NULL, 'G3DSA:1.20.120.1910:FF:000009', NULL, NULL, 'Cysteine--tRNA ligase 1 cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(110396, NULL, 'G3DSA:2.60.40.10:FF:001548', NULL, NULL, 'Interferon receptor 1 isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(110397, NULL, 'G3DSA:2.60.120.200:FF:000755', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(110398, NULL, 'G3DSA:3.100.10.10:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110399, NULL, 'G3DSA:3.30.470.10:FF:000005', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(110400, NULL, 'G3DSA:3.10.250.10:FF:000123', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110401, NULL, 'G3DSA:1.20.1250.10:FF:000138', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110402, NULL, 'G3DSA:3.30.300.30:FF:000056', NULL, NULL, 'Putative peptide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(110403, NULL, 'G3DSA:1.10.20.10:FF:000096', NULL, NULL, 'Histone H3', NULL, NULL, NULL, NULL, NULL, 4),
(110404, NULL, 'G3DSA:1.10.340.30:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110405, NULL, 'G3DSA:2.160.20.10:FF:000182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110406, NULL, 'G3DSA:3.30.920.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110407, NULL, 'G3DSA:3.30.519.10:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110408, NULL, 'G3DSA:2.130.10.10:FF:002133', NULL, NULL, 'WD40 repeat-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(110409, NULL, 'G3DSA:1.25.40.930:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110410, NULL, 'G3DSA:1.10.1420.10:FF:000036', NULL, NULL, 'DNA mismatch repair protein Msh1', NULL, NULL, NULL, NULL, NULL, 4),
(110411, NULL, 'G3DSA:3.30.1490.100:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110412, NULL, 'G3DSA:3.20.20.80:FF:000847', NULL, NULL, 'Chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110413, NULL, 'G3DSA:1.10.760.10:FF:000107', NULL, NULL, 'Gll0910 protein', NULL, NULL, NULL, NULL, NULL, 4),
(110414, NULL, 'G3DSA:2.40.30.10:FF:000076', NULL, NULL, 'Elongation factor family protein', NULL, NULL, NULL, NULL, NULL, 4),
(110415, NULL, 'G3DSA:3.30.497.10:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110416, NULL, 'G3DSA:1.10.510.10:FF:004041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110417, NULL, 'G3DSA:3.30.300.10:FF:000050', NULL, NULL, 'S-adenosylmethionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(110418, NULL, 'G3DSA:2.60.120.970:FF:000019', NULL, NULL, 'Transforming growth factor beta-3', NULL, NULL, NULL, NULL, NULL, 4),
(110419, NULL, 'G3DSA:3.30.70.1730:FF:000068', NULL, NULL, 'Ribosome assembly factor mrt4', NULL, NULL, NULL, NULL, NULL, 4),
(110420, NULL, 'G3DSA:3.40.50.410:FF:000199', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(110421, NULL, 'G3DSA:3.30.420.40:FF:000629', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110422, NULL, 'G3DSA:2.120.10.80:FF:000333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110423, NULL, 'G3DSA:2.130.10.10:FF:003061', NULL, NULL, 'WD40-repeat-containing domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(110424, NULL, 'G3DSA:3.30.160.60:FF:003706', NULL, NULL, 'Zinc finger protein 936', NULL, NULL, NULL, NULL, NULL, 4),
(110425, NULL, 'G3DSA:2.60.40.1840:FF:000004', NULL, NULL, 'Aminopeptidase N', NULL, NULL, NULL, NULL, NULL, 4),
(110426, NULL, 'G3DSA:2.40.50.1020:FF:000016', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(110427, NULL, 'G3DSA:1.10.10.440:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110428, NULL, 'G3DSA:3.40.50.1820:FF:000525', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(110429, NULL, 'G3DSA:1.20.1560.10:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110430, NULL, 'G3DSA:3.40.850.10:FF:000381', NULL, NULL, 'Kinesin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110431, NULL, 'G3DSA:3.40.190.10:FF:000381', NULL, NULL, 'Amino acid ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(110432, NULL, 'G3DSA:1.25.40.20:FF:001769', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110433, NULL, 'G3DSA:2.40.50.40:FF:000035', NULL, NULL, 'Heterochromatin protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(110434, NULL, 'G3DSA:2.130.10.10:FF:004286', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(110435, NULL, 'G3DSA:2.30.30.650:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110436, NULL, 'G3DSA:1.10.8.720:FF:000031', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(110437, NULL, 'G3DSA:1.10.3260.10:FF:000001', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(110438, NULL, 'G3DSA:2.60.40.60:FF:000585', NULL, NULL, 'Cadherin 26, tandem duplicate 1', NULL, NULL, NULL, NULL, NULL, 4),
(110439, NULL, 'G3DSA:3.90.550.10:FF:000459', NULL, NULL, 'Undecaprenyl-phosphate glycosyltransferase, DPM1-like family', NULL, NULL, NULL, NULL, NULL, 4),
(110440, NULL, 'G3DSA:4.10.830.30:FF:000001', NULL, NULL, '50S ribosomal protein L31', NULL, NULL, NULL, NULL, NULL, 4),
(110441, NULL, 'G3DSA:1.20.120.820:FF:000001', NULL, NULL, 'Phosphoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(110442, NULL, 'G3DSA:1.10.10.10:FF:002068', NULL, NULL, 'ATP-dependent DNA helicase RecQ family', NULL, NULL, NULL, NULL, NULL, 4),
(110443, NULL, 'G3DSA:2.60.220.50:FF:000069', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(110444, NULL, 'G3DSA:1.25.50.20:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110445, NULL, 'G3DSA:1.10.630.10:FF:000626', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110446, NULL, 'G3DSA:3.30.70.1470:FF:000001', NULL, NULL, 'Putative caspase-2', NULL, NULL, NULL, NULL, NULL, 4),
(110447, NULL, 'G3DSA:1.10.510.10:FF:000595', NULL, NULL, 'Protein kinase, putative (AFU_orthologue AFUA_5G11840)', NULL, NULL, NULL, NULL, NULL, 4),
(110448, NULL, 'G3DSA:4.10.240.10:FF:000023', NULL, NULL, 'Fungal specific transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(110449, NULL, 'G3DSA:3.40.50.300:FF:007546', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(110450, NULL, 'G3DSA:1.10.20.140:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110451, NULL, 'G3DSA:2.10.110.10:FF:000184', NULL, NULL, 'DA1-related protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(110452, NULL, 'G3DSA:3.40.50.150:FF:000132', NULL, NULL, 'Protein arginine N-methyltransferase PRMT10', NULL, NULL, NULL, NULL, NULL, 4),
(110453, NULL, 'G3DSA:3.90.640.10:FF:000230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110454, NULL, 'G3DSA:3.30.200.20:FF:002349', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(110455, NULL, 'G3DSA:3.90.180.10:FF:000150', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(110456, NULL, 'G3DSA:1.10.8.60:FF:000165', NULL, NULL, 'Sigma-54-dependent transcriptional response regulator PilR', NULL, NULL, NULL, NULL, NULL, 4),
(110457, NULL, 'G3DSA:1.25.40.10:FF:005302', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(110458, NULL, 'G3DSA:1.25.40.180:FF:000205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110459, NULL, 'G3DSA:2.130.10.30:FF:000082', NULL, NULL, 'Related to FMP25-mitochondrial inner membrane protein involved in assembly of cytochrome bc1 complex', NULL, NULL, NULL, NULL, NULL, 4),
(110460, NULL, 'G3DSA:2.60.200.40:FF:000060', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(110461, NULL, 'G3DSA:3.30.505.10:FF:000110', NULL, NULL, 'Cell death abnormality protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(110462, NULL, 'G3DSA:1.25.40.10:FF:000631', NULL, NULL, 'Proteinaceous RNase P 2', NULL, NULL, NULL, NULL, NULL, 4),
(110463, NULL, 'G3DSA:1.25.40.10:FF:003357', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(110464, NULL, 'G3DSA:3.30.70.1390:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110465, NULL, 'G3DSA:3.30.230.10:FF:000134', NULL, NULL, 'MeValonate Kinase', NULL, NULL, NULL, NULL, NULL, 4),
(110466, NULL, 'G3DSA:1.10.3380.20:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110467, NULL, 'G3DSA:3.40.50.300:FF:002167', NULL, NULL, 'ATP-binding membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(110468, NULL, 'G3DSA:3.40.50.720:FF:001601', NULL, NULL, 'YALI0E05731p', NULL, NULL, NULL, NULL, NULL, 4),
(110469, NULL, 'G3DSA:1.10.420.10:FF:000060', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(110470, NULL, 'G3DSA:3.30.420.40:FF:000781', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110471, NULL, 'G3DSA:3.30.1330.90:FF:000013', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(110472, NULL, 'G3DSA:1.20.1280.50:FF:000130', NULL, NULL, 'F-box and WD domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110473, NULL, 'G3DSA:3.40.50.11060:FF:000014', NULL, NULL, 'putative GTP-binding protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(110474, NULL, 'G3DSA:3.30.365.10:FF:000019', NULL, NULL, 'indole-3-acetaldehyde oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(110475, NULL, 'G3DSA:1.10.510.10:FF:002657', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110476, NULL, 'G3DSA:4.10.1240.30:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110477, NULL, 'G3DSA:3.40.50.300:FF:002875', NULL, NULL, '3''-5'' exonuclease DinG', NULL, NULL, NULL, NULL, NULL, 4),
(110478, NULL, 'G3DSA:3.30.70.2390:FF:000002', NULL, NULL, 'LytR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(110479, NULL, 'G3DSA:1.20.990.10:FF:000038', NULL, NULL, 'Flavodoxin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(110480, NULL, 'G3DSA:1.50.10.20:FF:000040', NULL, NULL, 'Terpenoid cyclases/protein prenyltransferase alpha-alpha toroid', NULL, NULL, NULL, NULL, NULL, 4),
(110481, NULL, 'G3DSA:1.20.58.2220:FF:000055', NULL, NULL, 'Formin 2', NULL, NULL, NULL, NULL, NULL, 4),
(110482, NULL, 'G3DSA:3.50.50.60:FF:000893', NULL, NULL, 'Flavin-binding monooxygenase-like protein (AFU_orthologue AFUA_6G01900)', NULL, NULL, NULL, NULL, NULL, 4),
(110483, NULL, 'G3DSA:1.25.40.10:FF:001148', NULL, NULL, 'Pre-mRNA-processing factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(110484, NULL, 'G3DSA:3.30.40.10:FF:000384', NULL, NULL, '1-phosphatidylinositol-3-phosphate 5-kinase FAB1B', NULL, NULL, NULL, NULL, NULL, 4),
(110485, NULL, 'G3DSA:3.50.50.60:FF:000185', NULL, NULL, 'Kynurenine 3-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(110486, NULL, 'G3DSA:2.60.40.60:FF:000321', NULL, NULL, 'Cadherin-related tumor suppressor', NULL, NULL, NULL, NULL, NULL, 4),
(110487, NULL, 'G3DSA:3.60.40.10:FF:000141', NULL, NULL, 'Response regulator', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(110488, NULL, 'G3DSA:3.40.50.1480:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110489, NULL, 'G3DSA:1.20.1560.10:FF:000712', NULL, NULL, 'Os06g0561800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(110490, NULL, 'G3DSA:1.10.472.10:FF:000230', NULL, NULL, 'Cyclin I', NULL, NULL, NULL, NULL, NULL, 4),
(110491, NULL, 'G3DSA:3.30.710.10:FF:000160', NULL, NULL, 'YLR108C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(110492, NULL, 'G3DSA:3.30.70.600:FF:000015', NULL, NULL, 'Apicoplast ribosomal protein S10', NULL, NULL, NULL, NULL, NULL, 4),
(110493, NULL, 'G3DSA:3.40.50.300:FF:001650', NULL, NULL, 'ABC drug exporter AtrF', NULL, NULL, NULL, NULL, NULL, 4),
(110494, NULL, 'G3DSA:3.40.50.720:FF:002118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110495, NULL, 'G3DSA:2.30.29.30:FF:001175', NULL, NULL, 'ArfGAP with dual PH domains 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(110496, NULL, 'G3DSA:2.10.250.10:FF:000014', NULL, NULL, 'Calreticulin-2', NULL, NULL, NULL, NULL, NULL, 4),
(110497, NULL, 'G3DSA:2.60.40.10:FF:003234', NULL, NULL, 'Secreted protein BARF1', NULL, NULL, NULL, NULL, NULL, 4),
(110498, NULL, 'G3DSA:3.10.400.20:FF:000014', NULL, NULL, 'Translation initiation factor SUI1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110499, NULL, 'G3DSA:1.20.58.60:FF:000803', NULL, NULL, 'Elastin microfibril interfacer 1', NULL, NULL, NULL, NULL, NULL, 4),
(110500, NULL, 'G3DSA:1.10.287.70:FF:000154', NULL, NULL, 'Potassium channel subfamily K member 7', NULL, NULL, NULL, NULL, NULL, 4),
(110501, NULL, 'G3DSA:3.40.50.970:FF:000198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110502, NULL, 'G3DSA:2.40.180.10:FF:000007', NULL, NULL, 'lipoxygenase homology domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(110503, NULL, 'G3DSA:1.10.630.10:FF:000126', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(110504, NULL, 'G3DSA:1.25.10.10:FF:002512', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(110505, NULL, 'G3DSA:3.60.110.10:FF:000091', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110506, NULL, 'G3DSA:3.40.50.10930:FF:000003', NULL, NULL, 'RecBCD enzyme subunit RecC', NULL, NULL, NULL, NULL, NULL, 4),
(110507, NULL, 'G3DSA:1.20.58.60:FF:000747', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110508, NULL, 'G3DSA:3.40.50.300:FF:003072', NULL, NULL, 'Small GTPase EhRabX34, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110509, NULL, 'G3DSA:1.20.58.1880:FF:000003', NULL, NULL, 'chromatin complexes subunit BAP18 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(110510, NULL, 'G3DSA:1.25.10.10:FF:002456', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110511, NULL, 'G3DSA:1.20.1740.10:FF:000069', NULL, NULL, 'Cationic amino acid transporter 4', NULL, NULL, NULL, NULL, NULL, 4),
(110512, NULL, 'G3DSA:1.10.10.60:FF:000593', NULL, NULL, 'L-rhamnose operon transcriptional activator RhaR', NULL, NULL, NULL, NULL, NULL, 4),
(110513, NULL, 'G3DSA:1.10.510.10:FF:001112', NULL, NULL, 'Serine/threonine-protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110514, NULL, 'G3DSA:1.25.40.330:FF:000003', NULL, NULL, 'Adenylyl cyclase-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(110515, NULL, 'G3DSA:3.40.50.720:FF:001040', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(110516, NULL, 'G3DSA:3.40.800.10:FF:000018', NULL, NULL, 'Arginase', NULL, NULL, NULL, NULL, NULL, 4),
(110517, NULL, 'G3DSA:1.25.10.10:FF:002984', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110518, NULL, 'G3DSA:2.60.40.1110:FF:000016', NULL, NULL, 'Ptenb protein', NULL, NULL, NULL, NULL, NULL, 4),
(110519, NULL, 'G3DSA:6.10.250.3450:FF:000005', NULL, NULL, '60S ribosomal protein L35-1', NULL, NULL, NULL, NULL, NULL, 4),
(110520, NULL, 'G3DSA:1.10.287.70:FF:000210', NULL, NULL, 'Open rectifier potassium channel protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(110521, NULL, 'G3DSA:1.10.10.60:FF:000121', NULL, NULL, 'Myb transcription factor', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(110522, NULL, 'G3DSA:2.10.70.10:FF:000265', NULL, NULL, 'CUB and sushi domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(110523, NULL, 'G3DSA:1.10.10.830:FF:000005', NULL, NULL, 'Mitochondrial isoleucyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(110524, NULL, 'G3DSA:1.10.630.10:FF:000598', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110525, NULL, 'G3DSA:2.20.70.10:FF:000068', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(110526, NULL, 'G3DSA:3.30.9.10:FF:000143', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(110527, NULL, 'G3DSA:3.30.40.10:FF:000945', NULL, NULL, 'Protein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(110528, NULL, 'G3DSA:3.10.129.10:FF:000195', NULL, NULL, '4-hydroxybenzoyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(110529, NULL, 'G3DSA:2.20.25.160:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110530, NULL, 'G3DSA:4.10.520.10:FF:000005', NULL, NULL, 'Integration host factor', NULL, NULL, NULL, NULL, NULL, 4),
(110531, NULL, 'G3DSA:2.60.120.260:FF:000435', NULL, NULL, 'Beta-glucuronidase', NULL, NULL, NULL, NULL, NULL, 4),
(110532, NULL, 'G3DSA:1.10.510.10:FF:001584', NULL, NULL, 'Cell-cycle checkpoint protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110533, NULL, 'G3DSA:3.30.70.2690:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110534, NULL, 'G3DSA:3.40.30.10:FF:001175', NULL, NULL, 'Glutathione S-transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110535, NULL, 'G3DSA:1.10.510.10:FF:004338', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110536, NULL, 'G3DSA:3.40.50.450:FF:000008', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(110537, NULL, 'G3DSA:1.10.10.2220:FF:000001', NULL, NULL, 'ATP-dependent RecD-like DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(110538, NULL, 'G3DSA:1.25.40.20:FF:000252', NULL, NULL, 'acyl-CoA-binding domain-containing protein 6 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(110539, NULL, 'G3DSA:2.60.120.10:FF:000336', NULL, NULL, 'Uncharacterized NTE family protein M110.7', NULL, NULL, NULL, NULL, NULL, 4),
(110540, NULL, 'G3DSA:1.10.555.10:FF:000001', NULL, NULL, 'Rho GTPase activating protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(110541, NULL, 'G3DSA:3.30.160.60:FF:001705', NULL, NULL, 'Zinc finger and BTB domain-containing protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(110542, NULL, 'G3DSA:1.25.40.10:FF:000395', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(110543, NULL, 'G3DSA:1.50.40.10:FF:000270', NULL, NULL, 'Mitochondrial ornithine transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(110544, NULL, 'G3DSA:1.25.40.10:FF:003149', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g14470', NULL, NULL, NULL, NULL, NULL, 4),
(110545, NULL, 'G3DSA:3.40.50.300:FF:007254', NULL, NULL, 'Rab GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(110546, NULL, 'G3DSA:2.130.10.10:FF:000508', NULL, NULL, 'WD repeat-containing protein 54 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(110547, NULL, 'G3DSA:3.40.50.300:FF:007310', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(110548, NULL, 'G3DSA:3.90.640.10:FF:000174', NULL, NULL, 'Actin-related protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(110549, NULL, 'G3DSA:3.30.1430.10:FF:000008', NULL, NULL, '50S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(110550, NULL, 'G3DSA:3.30.200.20:FF:000579', NULL, NULL, 'cyclin-dependent kinase 20', NULL, NULL, NULL, NULL, NULL, 4),
(110551, NULL, 'G3DSA:2.130.10.10:FF:003853', NULL, NULL, 'Cilia- and flagella-associated protein 43', NULL, NULL, NULL, NULL, NULL, 4),
(110552, NULL, 'G3DSA:1.10.510.10:FF:000123', NULL, NULL, 'Tyrosine-protein kinase receptor Tie-1', NULL, NULL, NULL, NULL, NULL, 4),
(110553, NULL, 'G3DSA:1.25.40.10:FF:001295', NULL, NULL, 'GD25498', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(110554, NULL, 'G3DSA:2.60.40.60:FF:000877', NULL, NULL, 'E-cadherin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(110555, NULL, 'G3DSA:2.70.170.10:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110556, NULL, 'G3DSA:1.25.40.680:FF:000001', NULL, NULL, 'ESAT-6 secretion machinery protein EssB', NULL, NULL, NULL, NULL, NULL, 4),
(110557, NULL, 'G3DSA:3.30.40.10:FF:000468', NULL, NULL, 'RING/U-box superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(110558, NULL, 'G3DSA:1.10.10.10:FF:001348', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(110559, NULL, 'G3DSA:3.40.50.12780:FF:000075', NULL, NULL, '2-succinylbenzoate--CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(110560, NULL, 'G3DSA:3.90.180.10:FF:000094', NULL, NULL, 'Enoyl-[acyl-carrier-protein] reductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(110561, NULL, 'G3DSA:2.60.200.30:FF:000023', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(110562, NULL, 'G3DSA:1.20.120.520:FF:000001', NULL, NULL, 'Iron-sulfur cluster repair protein YtfE', NULL, NULL, NULL, NULL, NULL, 4),
(110563, NULL, 'G3DSA:2.130.10.10:FF:003358', NULL, NULL, 'Plexin B3', NULL, NULL, NULL, NULL, NULL, 4),
(110564, NULL, 'G3DSA:3.30.230.10:FF:000078', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(110565, NULL, 'G3DSA:1.25.10.10:FF:001523', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(110566, NULL, 'G3DSA:3.80.30.20:FF:000007', NULL, NULL, 'CDK5 regulatory subunit-associated protein 1 isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(110567, NULL, 'G3DSA:3.40.640.10:FF:000455', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110568, NULL, 'G3DSA:3.30.2130.30:FF:000031', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase K/L', NULL, NULL, NULL, NULL, NULL, 4),
(110569, NULL, 'G3DSA:1.25.40.120:FF:000058', NULL, NULL, 'Farnesyltransferase, CAAX box, alpha', NULL, NULL, NULL, NULL, NULL, 4),
(110570, NULL, 'G3DSA:3.60.130.10:FF:000035', NULL, NULL, 'Pyoverdine biosynthesis protein PvcB', NULL, NULL, NULL, NULL, NULL, 4),
(110571, NULL, 'G3DSA:2.40.128.130:FF:000007', NULL, NULL, 'Autotransporting virulence factor family member', NULL, NULL, NULL, NULL, NULL, 4),
(110572, NULL, 'G3DSA:3.40.1380.10:FF:000029', NULL, NULL, 'ATP synthase gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(110573, NULL, 'G3DSA:3.40.50.2300:FF:001434', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110574, NULL, 'G3DSA:3.40.50.10540:FF:000009', NULL, NULL, 'Acyl-CoA transferase/carnitine dehydratase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(110575, NULL, 'G3DSA:2.60.120.200:FF:000047', NULL, NULL, 'Slit guidance ligand 3', NULL, NULL, NULL, NULL, NULL, 4),
(110576, NULL, 'G3DSA:1.20.5.170:FF:000088', NULL, NULL, 'cyclic nucleotide-gated cation channel alpha-4', NULL, NULL, NULL, NULL, NULL, 4),
(110577, NULL, 'G3DSA:3.40.50.300:FF:005365', NULL, NULL, 'Dynamin-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110578, NULL, 'G3DSA:3.80.10.10:FF:004426', NULL, NULL, 'CLL2 clavata1-like receptor S/T protein kinase protein', NULL, NULL, NULL, NULL, NULL, 4),
(110579, NULL, 'G3DSA:1.20.1250.20:FF:000170', NULL, NULL, 'Solute carrier family 22 member 7', NULL, NULL, NULL, NULL, NULL, 4),
(110580, NULL, 'G3DSA:1.10.730.10:FF:000167', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(110581, NULL, 'G3DSA:1.25.40.10:FF:005190', NULL, NULL, 'Transcriptional activator domain', NULL, NULL, NULL, NULL, NULL, 4),
(110582, NULL, 'G3DSA:1.25.40.20:FF:001505', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110583, NULL, 'G3DSA:2.30.30.140:FF:000322', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110584, NULL, 'G3DSA:1.10.510.10:FF:001640', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110585, NULL, 'G3DSA:3.40.1190.20:FF:000175', NULL, NULL, 'Adenosine kinase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(110586, NULL, 'G3DSA:3.40.190.10:FF:000673', NULL, NULL, 'Uncharacterized solute-binding protein OE_3270R', NULL, NULL, NULL, NULL, NULL, 4),
(110587, NULL, 'G3DSA:3.90.740.10:FF:000058', NULL, NULL, 'Putative isoleucine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(110588, NULL, 'G3DSA:3.40.50.300:FF:003448', NULL, NULL, 'YALI0F31845p', NULL, NULL, NULL, NULL, NULL, 4),
(110589, NULL, 'G3DSA:3.50.50.60:FF:001174', NULL, NULL, 'Probable NADPH:adrenodoxin oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(110590, NULL, 'G3DSA:1.10.287.1890:FF:000004', NULL, NULL, 'tRNA (Adenine(22)-N(1))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(110591, NULL, 'G3DSA:3.80.10.10:FF:003965', NULL, NULL, 'Si:dkey-250k10.4', NULL, NULL, NULL, NULL, NULL, 4),
(110592, NULL, 'G3DSA:3.10.20.310:FF:000046', NULL, NULL, 'Outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(110593, NULL, 'G3DSA:1.10.10.10:FF:000415', NULL, NULL, 'meiotic recombination protein SPO11 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(110594, NULL, 'G3DSA:3.90.79.10:FF:000094', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(110595, NULL, 'G3DSA:2.80.10.50:FF:000118', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(110596, NULL, 'G3DSA:3.40.50.1000:FF:000459', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110597, NULL, 'G3DSA:1.10.10.10:FF:000887', NULL, NULL, 'Helicase family member', NULL, NULL, NULL, NULL, NULL, 4),
(110598, NULL, 'G3DSA:3.30.450.70:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110599, NULL, 'G3DSA:2.40.50.730:FF:000012', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(110600, NULL, 'G3DSA:1.25.10.10:FF:000039', NULL, NULL, 'Splicing factor 3B subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(110601, NULL, 'G3DSA:1.20.1070.10:FF:000720', NULL, NULL, 'KISS1 receptor b', NULL, NULL, NULL, NULL, NULL, 4),
(110602, NULL, 'G3DSA:1.10.3190.10:FF:000001', NULL, NULL, 'UPF0304 protein YfbU', NULL, NULL, NULL, NULL, NULL, 4),
(110603, NULL, 'G3DSA:2.60.40.10:FF:001784', NULL, NULL, 'Basement membrane proteoglycan', NULL, NULL, NULL, NULL, NULL, 4),
(110604, NULL, 'G3DSA:1.20.120.720:FF:000033', NULL, NULL, 'Myosin B', NULL, NULL, NULL, NULL, NULL, 4),
(110605, NULL, 'G3DSA:1.10.10.60:FF:000969', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110606, NULL, 'G3DSA:1.10.287.130:FF:000234', NULL, NULL, 'Sensor histidine kinase, Cache_1 and HAMP domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(110607, NULL, 'G3DSA:1.10.287.80:FF:000011', NULL, NULL, 'ATP synthase subunit gamma, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(110608, NULL, 'G3DSA:1.20.1070.10:FF:001232', NULL, NULL, 'corticotropin-releasing factor receptor 2-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(110609, NULL, 'G3DSA:2.60.40.10:FF:001256', NULL, NULL, 'Sallimus, isoform Q', NULL, NULL, NULL, NULL, NULL, 4),
(110610, NULL, 'G3DSA:3.20.19.10:FF:000014', NULL, NULL, 'Aconitate hydratase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(110611, NULL, 'G3DSA:1.20.58.390:FF:000070', NULL, NULL, 'Glycine receptor beta', NULL, NULL, NULL, NULL, NULL, 4),
(110612, NULL, 'G3DSA:3.40.120.10:FF:000051', NULL, NULL, 'Phosphoacetylglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(110613, NULL, 'G3DSA:1.10.730.20:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110614, NULL, 'G3DSA:2.60.40.10:FF:000856', NULL, NULL, 'Obscurin like 1', NULL, NULL, NULL, NULL, NULL, 4),
(110615, NULL, 'G3DSA:1.25.40.10:FF:002340', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(110616, NULL, 'G3DSA:3.30.160.60:FF:005600', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110617, NULL, 'G3DSA:3.30.1390.10:FF:000009', NULL, NULL, 'E3 ubiquitin-protein ligase UBR1', NULL, NULL, NULL, NULL, NULL, 4),
(110618, NULL, 'G3DSA:3.40.50.1820:FF:000997', NULL, NULL, 'Putative thioesterase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(110619, NULL, 'G3DSA:1.25.40.20:FF:000988', NULL, NULL, 'Transient receptor potential cation channel protein painless', NULL, NULL, NULL, NULL, NULL, 4),
(110620, NULL, 'G3DSA:3.40.1110.10:FF:000010', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(110621, NULL, 'G3DSA:3.40.50.10190:FF:000326', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110622, NULL, 'G3DSA:3.60.21.50:FF:000002', NULL, NULL, 'DNA polymerase delta small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(110623, NULL, 'G3DSA:1.25.40.10:FF:005038', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g20090', NULL, NULL, NULL, NULL, NULL, 4),
(110624, NULL, 'G3DSA:2.60.40.10:FF:005527', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110625, NULL, 'G3DSA:1.10.1410.10:FF:000007', NULL, NULL, 'poly(A) RNA polymerase GLD2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(110626, NULL, 'G3DSA:1.20.120.160:FF:000022', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(110627, NULL, 'G3DSA:3.40.50.10810:FF:000113', NULL, NULL, 'Putative snf2 family helicase atpase protein', NULL, NULL, NULL, NULL, NULL, 4),
(110628, NULL, 'G3DSA:2.60.120.200:FF:000171', NULL, NULL, 'Adhesion G-protein coupled receptor D2', NULL, NULL, NULL, NULL, NULL, 4),
(110629, NULL, 'G3DSA:2.170.260.40:FF:000008', NULL, NULL, '5''-3'' exoribonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(110630, NULL, 'G3DSA:1.20.1250.20:FF:000967', NULL, NULL, 'EmrB/QacA subfamily drug resistance transporter', NULL, NULL, NULL, NULL, NULL, 4),
(110631, NULL, 'G3DSA:3.30.40.10:FF:000029', NULL, NULL, 'lysine-specific demethylase 4C isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(110632, NULL, 'G3DSA:3.30.1010.10:FF:000049', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit gamma, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110633, NULL, 'G3DSA:3.40.50.12610:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110634, NULL, 'G3DSA:3.40.190.80:FF:000002', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(110635, NULL, 'G3DSA:2.40.128.110:FF:000001', NULL, NULL, 'UPF0312 protein HMPREF3014_17255', NULL, NULL, NULL, NULL, NULL, 4),
(110636, NULL, 'G3DSA:3.40.50.300:FF:000161', NULL, NULL, 'Small COPII coat GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(110637, NULL, 'G3DSA:2.20.25.10:FF:000109', NULL, NULL, 'Peptide-N(4)-(N-acetyl-beta-glucosaminyl)asparagine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(110638, NULL, 'G3DSA:3.60.10.10:FF:000369', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110639, NULL, 'G3DSA:4.10.960.10:FF:000004', NULL, NULL, '60S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(110640, NULL, 'G3DSA:3.40.1380.20:FF:000061', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(110641, NULL, 'G3DSA:1.20.1270.60:FF:000278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110642, NULL, 'G3DSA:3.30.70.330:FF:002805', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110643, NULL, 'G3DSA:3.90.70.10:FF:000574', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(110644, NULL, 'G3DSA:3.30.1370.10:FF:000065', NULL, NULL, 'KH domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(110645, NULL, 'G3DSA:2.130.10.30:FF:000138', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110646, NULL, 'G3DSA:3.40.50.720:FF:002349', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(110647, NULL, 'G3DSA:3.30.160.60:FF:000396', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(110648, NULL, 'G3DSA:3.30.70.360:FF:000050', NULL, NULL, 'Metal-dependent amidase/aminoacylase/carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(110649, NULL, 'G3DSA:1.20.120.1770:FF:000012', NULL, NULL, 'Transmembrane ascorbate ferrireductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(110650, NULL, 'G3DSA:2.10.10.80:FF:000001', NULL, NULL, 'Catalytic beta propeller domain of endosialidase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(110651, NULL, 'G3DSA:3.90.550.10:FF:000375', NULL, NULL, 'UDP-glucose glycoprotein glucosyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(110652, NULL, 'G3DSA:1.20.140.10:FF:000030', NULL, NULL, 'Acyl-CoA dehydrogenase FadE23', NULL, NULL, NULL, NULL, NULL, 4),
(110653, NULL, 'G3DSA:2.130.10.10:FF:002925', NULL, NULL, 'Protein CBG08107', NULL, NULL, NULL, NULL, NULL, 4),
(110654, NULL, 'G3DSA:3.80.10.10:FF:000683', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase GSO1', NULL, NULL, NULL, NULL, NULL, 4),
(110655, NULL, 'G3DSA:1.10.8.60:FF:000401', NULL, NULL, 'ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110656, NULL, 'G3DSA:2.130.10.10:FF:000132', NULL, NULL, 'DDB1- and CUL4-associated factor 13', NULL, NULL, NULL, NULL, NULL, 4),
(110657, NULL, 'G3DSA:3.90.1150.10:FF:000433', NULL, NULL, 'Sphingosine Phosphate Lyase', NULL, NULL, NULL, NULL, NULL, 4),
(110658, NULL, 'G3DSA:2.40.50.140:FF:000841', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110659, NULL, 'G3DSA:3.40.640.10:FF:000399', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110660, NULL, 'G3DSA:2.130.10.10:FF:003414', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(110661, NULL, 'G3DSA:1.20.1250.20:FF:001951', NULL, NULL, 'Peptide transporter PTR2', NULL, NULL, NULL, NULL, NULL, 4),
(110662, NULL, 'G3DSA:3.30.40.10:FF:000092', NULL, NULL, 'Lateral signaling target protein 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(110663, NULL, 'G3DSA:1.20.120.220:FF:000006', NULL, NULL, 'ATP synthase subunit a', NULL, NULL, NULL, NULL, NULL, 4),
(110664, NULL, 'G3DSA:3.30.70.260:FF:000019', NULL, NULL, 'Arogenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(110665, NULL, 'G3DSA:1.10.3270.10:FF:000002', NULL, NULL, '3-hydroxy-3-methylglutaryl coenzyme A reductase', NULL, NULL, NULL, NULL, NULL, 4),
(110666, NULL, 'G3DSA:2.30.30.40:FF:000405', NULL, NULL, 'small G protein signaling modulator 3 isoform X10', NULL, NULL, NULL, NULL, NULL, 4),
(110667, NULL, 'G3DSA:3.30.160.60:FF:002341', NULL, NULL, 'Zinc finger protein 80', NULL, NULL, NULL, NULL, NULL, 4),
(110668, NULL, 'G3DSA:1.20.1050.10:FF:000213', NULL, NULL, 'Glutathione S-transferase GSTU6', NULL, NULL, NULL, NULL, NULL, 4),
(110669, NULL, 'G3DSA:2.60.260.20:FF:000175', NULL, NULL, 'Chaperone protein', NULL, NULL, NULL, NULL, NULL, 4),
(110670, NULL, 'G3DSA:2.60.20.10:FF:000001', NULL, NULL, 'Crystallin gamma S', NULL, NULL, NULL, NULL, NULL, 4),
(110671, NULL, 'G3DSA:1.25.50.20:FF:000022', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(110672, NULL, 'G3DSA:2.40.50.140:FF:000897', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110673, NULL, 'G3DSA:1.10.10.2590:FF:000005', NULL, NULL, 'Early boundary activity protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(110674, NULL, 'G3DSA:3.30.160.60:FF:005067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110675, NULL, 'G3DSA:3.50.50.60:FF:000662', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110676, NULL, 'G3DSA:3.15.10.30:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110677, NULL, 'G3DSA:2.60.40.4380:FF:000002', NULL, NULL, 'Translational regulator CsrA', NULL, NULL, NULL, NULL, NULL, 4),
(110678, NULL, 'G3DSA:3.30.160.60:FF:004667', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110679, NULL, 'G3DSA:1.10.20.10:FF:000360', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110680, NULL, 'G3DSA:2.60.40.790:FF:000164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110681, NULL, 'G3DSA:3.40.50.300:FF:000958', NULL, NULL, 'Spastin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110682, NULL, 'G3DSA:1.10.510.10:FF:002888', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110683, NULL, 'G3DSA:1.25.40.10:FF:001351', NULL, NULL, 'Stress-induced-phosphoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(110684, NULL, 'G3DSA:1.10.472.80:FF:000054', NULL, NULL, 'Chromosome 16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(110685, NULL, 'G3DSA:3.40.50.410:FF:000227', NULL, NULL, 'Collagen alpha-1(XIV) chain-like', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(110686, NULL, 'G3DSA:3.40.50.300:FF:000222', NULL, NULL, 'RAB32, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(110687, NULL, 'G3DSA:3.40.50.2300:FF:000922', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110688, NULL, 'G3DSA:1.20.1540.10:FF:000065', NULL, NULL, 'Putative rhomboid protease YdcA protein', NULL, NULL, NULL, NULL, NULL, 4),
(110689, NULL, 'G3DSA:3.30.1910.20:FF:000003', NULL, NULL, 'Asparagine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(110690, NULL, 'G3DSA:1.10.510.10:FF:000651', NULL, NULL, 'Serine/threonine-protein kinase RAD53', NULL, NULL, NULL, NULL, NULL, 4),
(110691, NULL, 'G3DSA:3.30.70.560:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110692, NULL, 'G3DSA:1.20.1740.10:FF:000193', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(110693, NULL, 'G3DSA:1.10.101.10:FF:000004', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(110694, NULL, 'G3DSA:2.60.120.10:FF:000752', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110695, NULL, 'G3DSA:1.20.1740.10:FF:000013', NULL, NULL, 'Solute carrier family 12 member', NULL, NULL, NULL, NULL, NULL, 4),
(110696, NULL, 'G3DSA:1.20.1250.20:FF:000962', NULL, NULL, 'Membrane transporter', NULL, NULL, NULL, NULL, NULL, 4),
(110697, NULL, 'G3DSA:3.40.50.1440:FF:000063', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(110698, NULL, 'G3DSA:3.40.50.880:FF:000227', NULL, NULL, 'Carbamoyl-phosphate synthase small chain', NULL, NULL, NULL, NULL, NULL, 4),
(110699, NULL, 'G3DSA:1.25.40.420:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110700, NULL, 'G3DSA:1.10.1330.10:FF:000001', NULL, NULL, 'Endoglucanase D', NULL, NULL, NULL, NULL, NULL, 4),
(110701, NULL, 'G3DSA:3.40.50.720:FF:000876', NULL, NULL, 'Unplaced genomic scaffold supercont1.67, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(110702, NULL, 'G3DSA:3.40.30.10:FF:000742', NULL, NULL, 'YALI0F29381p', NULL, NULL, NULL, NULL, NULL, 4),
(110703, NULL, 'G3DSA:2.30.29.30:FF:000803', NULL, NULL, 'GD21193', NULL, NULL, NULL, NULL, NULL, 4),
(110704, NULL, 'G3DSA:1.25.10.10:FF:003440', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110705, NULL, 'G3DSA:2.60.120.200:FF:000547', NULL, NULL, 'Calnexin', NULL, NULL, NULL, NULL, NULL, 4),
(110706, NULL, 'G3DSA:1.10.510.10:FF:003905', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110707, NULL, 'G3DSA:3.20.20.140:FF:000009', NULL, NULL, 'Adenosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(110708, NULL, 'G3DSA:1.10.10.2030:FF:000006', NULL, NULL, 'Protein CBG23783', NULL, NULL, NULL, NULL, NULL, 4),
(110709, NULL, 'G3DSA:2.30.29.30:FF:000747', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(110710, NULL, 'G3DSA:3.30.70.390:FF:000002', NULL, NULL, 'ORF73', NULL, NULL, NULL, NULL, NULL, 4),
(110711, NULL, 'G3DSA:3.90.1410.10:FF:000004', NULL, NULL, 'N-lysine methyltransferase SETD6', NULL, NULL, NULL, NULL, NULL, 4),
(110712, NULL, 'G3DSA:3.90.228.10:FF:000031', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(110713, NULL, 'G3DSA:1.20.1280.50:FF:000219', NULL, NULL, 'F-box/kelch-repeat protein At4g19930', NULL, NULL, NULL, NULL, NULL, 4),
(110714, NULL, 'G3DSA:3.90.190.10:FF:000392', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110715, NULL, 'G3DSA:2.60.40.60:FF:000085', NULL, NULL, 'Calsyntenin 1', NULL, NULL, NULL, NULL, NULL, 4),
(110716, NULL, 'G3DSA:2.10.25.10:FF:001178', NULL, NULL, 'Eyes shut homolog', NULL, NULL, NULL, NULL, NULL, 4),
(110717, NULL, 'G3DSA:3.40.30.10:FF:000214', NULL, NULL, 'glutaredoxin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(110718, NULL, 'G3DSA:4.10.240.30:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110719, NULL, 'G3DSA:3.40.50.300:FF:001886', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(110720, NULL, 'G3DSA:3.80.10.10:FF:001987', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110721, NULL, 'G3DSA:1.25.10.10:FF:001528', NULL, NULL, 'YALI0F08165p', NULL, NULL, NULL, NULL, NULL, 4),
(110722, NULL, 'G3DSA:3.40.30.10:FF:001198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110723, NULL, 'G3DSA:1.10.132.20:FF:000005', NULL, NULL, 'Ribosome-recycling factor, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(110724, NULL, 'G3DSA:3.75.10.10:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110725, NULL, 'G3DSA:3.40.50.620:FF:000200', NULL, NULL, 'Nicotinamide-nucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(110726, NULL, 'G3DSA:3.90.1030.10:FF:000014', NULL, NULL, '50S ribosomal protein L17', NULL, NULL, NULL, NULL, NULL, 4),
(110727, NULL, 'G3DSA:3.40.50.1860:FF:000014', NULL, NULL, 'Glutamate racemase', NULL, NULL, NULL, NULL, NULL, 4),
(110728, NULL, 'G3DSA:1.20.1050.10:FF:000157', NULL, NULL, 'S-crystallin SL11', NULL, NULL, NULL, NULL, NULL, 4),
(110729, NULL, 'G3DSA:3.20.20.70:FF:000165', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(110730, NULL, 'G3DSA:3.20.20.70:FF:000642', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110731, NULL, 'G3DSA:3.30.70.330:FF:001316', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110732, NULL, 'G3DSA:1.20.5.1930:FF:000007', NULL, NULL, 'Two-component sensor histidine kinase DesR', NULL, NULL, NULL, NULL, NULL, 4),
(110733, NULL, 'G3DSA:1.10.10.10:FF:001904', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110734, NULL, 'G3DSA:3.10.100.10:FF:000056', NULL, NULL, 'Pulmonary surfactant-associated protein A', NULL, NULL, NULL, NULL, NULL, 4),
(110735, NULL, 'G3DSA:3.40.50.300:FF:005629', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110736, NULL, 'G3DSA:1.20.1280.290:FF:000053', NULL, NULL, 'Sugar transporter SWEET', NULL, NULL, NULL, NULL, NULL, 4),
(110737, NULL, 'G3DSA:3.40.50.1460:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110738, NULL, 'G3DSA:3.10.50.10:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110739, NULL, 'G3DSA:3.60.15.10:FF:000217', NULL, NULL, 'DNA repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110740, NULL, 'G3DSA:3.20.110.10:FF:000037', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(110741, NULL, 'G3DSA:1.10.8.60:FF:000373', NULL, NULL, 'GM14570', NULL, NULL, NULL, NULL, NULL, 4),
(110742, NULL, 'G3DSA:3.40.50.2300:FF:000978', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110743, NULL, 'G3DSA:2.60.40.4100:FF:000020', NULL, NULL, 'Matrix metallopeptidase 15a', NULL, NULL, NULL, NULL, NULL, 4),
(110744, NULL, 'G3DSA:1.20.120.330:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110745, NULL, 'G3DSA:2.60.40.10:FF:002801', NULL, NULL, 'HERV-H LTR-associating 2a, tandem duplicate 1', NULL, NULL, NULL, NULL, NULL, 4),
(110746, NULL, 'G3DSA:3.10.20.90:FF:000789', NULL, NULL, 'Autophagy protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(110747, NULL, 'G3DSA:2.60.120.290:FF:000034', NULL, NULL, 'complement C1s subcomponent', NULL, NULL, NULL, NULL, NULL, 4),
(110748, NULL, 'G3DSA:1.10.8.10:FF:000139', NULL, NULL, 'UV excision repair RAD23-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(110749, NULL, 'G3DSA:1.10.565.10:FF:000210', NULL, NULL, 'Estrogen receptor beta', NULL, NULL, NULL, NULL, NULL, 4),
(110750, NULL, 'G3DSA:3.90.550.10:FF:000667', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110751, NULL, 'G3DSA:1.20.1560.10:FF:000920', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110752, NULL, 'G3DSA:3.30.70.330:FF:001991', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110753, NULL, 'G3DSA:2.70.70.10:FF:000015', NULL, NULL, 'LysM domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(110754, NULL, 'G3DSA:3.30.160.60:FF:004611', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(110755, NULL, 'G3DSA:3.40.50.10810:FF:000057', NULL, NULL, 'Snf2/Rad54 family helicase', NULL, NULL, NULL, NULL, NULL, 4),
(110756, NULL, 'G3DSA:1.10.10.440:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110757, NULL, 'G3DSA:1.20.1560.10:FF:000948', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110758, NULL, 'G3DSA:2.60.120.650:FF:000013', NULL, NULL, 'Ribosomal oxygenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(110759, NULL, 'G3DSA:1.10.150.20:FF:000289', NULL, NULL, 'DNA-directed DNA/RNA polymerase mu', NULL, NULL, NULL, NULL, NULL, 4),
(110760, NULL, 'G3DSA:2.30.42.10:FF:000441', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110761, NULL, 'G3DSA:3.90.730.10:FF:000001', NULL, NULL, 'Ribonuclease T2', NULL, NULL, NULL, NULL, NULL, 4),
(110762, NULL, 'G3DSA:3.80.10.10:FF:002509', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110763, NULL, 'G3DSA:1.25.40.120:FF:000002', NULL, NULL, 'Protein farnesyltransferase/geranylgeranyltransferase type-1 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(110764, NULL, 'G3DSA:1.25.40.10:FF:000423', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(110765, NULL, 'G3DSA:3.30.565.10:FF:000147', NULL, NULL, 'Unplaced genomic scaffold supercont2.18, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(110766, NULL, 'G3DSA:2.40.50.170:FF:000001', NULL, NULL, 'Cathepsin L1', NULL, NULL, NULL, NULL, NULL, 4),
(110767, NULL, 'G3DSA:2.130.10.10:FF:005275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110768, NULL, 'G3DSA:2.40.30.10:FF:000020', NULL, NULL, 'Translation elongation factor EF-1', NULL, NULL, NULL, NULL, NULL, 4),
(110769, NULL, 'G3DSA:1.20.1560.10:FF:000387', NULL, NULL, 'ABC transporter related', NULL, NULL, NULL, NULL, NULL, 4),
(110770, NULL, 'G3DSA:1.10.510.10:FF:002040', NULL, NULL, 'Protein CBG10613', NULL, NULL, NULL, NULL, NULL, 4),
(110771, NULL, 'G3DSA:4.10.1000.10:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110772, NULL, 'G3DSA:1.25.40.10:FF:005066', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(110773, NULL, 'G3DSA:3.80.10.10:FF:004365', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(110774, NULL, 'G3DSA:2.60.40.1170:FF:000051', NULL, NULL, 'AP-3 complex subunit mu', NULL, NULL, NULL, NULL, NULL, 4),
(110775, NULL, 'G3DSA:3.30.930.10:FF:000171', NULL, NULL, 'Phenylalanyl-tRNA synthetase beta chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110776, NULL, 'G3DSA:3.40.50.970:FF:000193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110777, NULL, 'G3DSA:3.30.160.60:FF:005595', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110778, NULL, 'G3DSA:2.70.160.11:FF:000006', NULL, NULL, 'Protein arginine methyltransferase 9', NULL, NULL, NULL, NULL, NULL, 4),
(110779, NULL, 'G3DSA:1.10.238.10:FF:000170', NULL, NULL, 'reticulocalbin-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(110780, NULL, 'G3DSA:1.25.10.10:FF:003092', NULL, NULL, 'Wings apart-like protein homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(110781, NULL, 'G3DSA:2.60.40.10:FF:005151', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110782, NULL, 'G3DSA:1.10.12.70:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110783, NULL, 'G3DSA:2.60.40.1180:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110784, NULL, 'G3DSA:3.40.50.720:FF:001101', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(110785, NULL, 'G3DSA:3.30.40.10:FF:002093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110786, NULL, 'G3DSA:3.40.50.720:FF:001837', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110787, NULL, 'G3DSA:2.60.15.10:FF:000023', NULL, NULL, 'ATP synthase epsilon chain', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(110788, NULL, 'G3DSA:3.10.100.10:FF:000112', NULL, NULL, 'lectin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(110789, NULL, 'G3DSA:2.30.29.30:FF:000894', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110790, NULL, 'G3DSA:3.40.50.300:FF:005781', NULL, NULL, 'Putative serine/threonine-protein kinase pats1', NULL, NULL, NULL, NULL, NULL, 4),
(110791, NULL, 'G3DSA:1.25.40.10:FF:001356', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(110792, NULL, 'G3DSA:2.60.40.10:FF:001312', NULL, NULL, 'Interleukin 10 receptor subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(110793, NULL, 'G3DSA:3.40.50.1010:FF:000052', NULL, NULL, 'Exosome complex exonuclease RRP44', NULL, NULL, NULL, NULL, NULL, 4),
(110794, NULL, 'G3DSA:1.10.490.10:FF:000007', NULL, NULL, 'Diguanylate cyclase DosC', NULL, NULL, NULL, NULL, NULL, 4),
(110795, NULL, 'G3DSA:3.40.50.300:FF:001094', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(110796, NULL, 'G3DSA:3.40.50.300:FF:001150', NULL, NULL, 'Small GTP-binding protein sar1', NULL, NULL, NULL, NULL, NULL, 4),
(110797, NULL, 'G3DSA:2.60.40.10:FF:005943', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110798, NULL, 'G3DSA:1.10.472.10:FF:000106', NULL, NULL, 'Cyclin-SDS', NULL, NULL, NULL, NULL, NULL, 4),
(110799, NULL, 'G3DSA:3.30.450.230:FF:000001', NULL, NULL, 'Vacuolar v-SNARE', NULL, NULL, NULL, NULL, NULL, 4),
(110800, NULL, 'G3DSA:2.60.40.10:FF:001492', NULL, NULL, 'Adhesion molecule with Ig-like domain 3', NULL, NULL, NULL, NULL, NULL, 4),
(110801, NULL, 'G3DSA:3.10.580.10:FF:000108', NULL, NULL, 'Putative cation efflux protein', NULL, NULL, NULL, NULL, NULL, 4),
(110802, NULL, 'G3DSA:1.10.10.10:FF:001343', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110803, NULL, 'G3DSA:3.80.10.10:FF:004421', NULL, NULL, 'At5g27920', NULL, NULL, NULL, NULL, NULL, 4),
(110804, NULL, 'G3DSA:2.30.30.180:FF:000014', NULL, NULL, 'Ribosome maturation factor RimP', NULL, NULL, NULL, NULL, NULL, 4),
(110805, NULL, 'G3DSA:4.10.400.10:FF:000002', NULL, NULL, 'Low-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(110806, NULL, 'G3DSA:1.20.150.20:FF:000005', NULL, NULL, 'ATP synthase subunit alpha, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(110807, NULL, 'G3DSA:3.90.810.10:FF:000002', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(110808, NULL, 'G3DSA:3.40.50.980:FF:000055', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(110809, NULL, 'G3DSA:3.30.40.10:FF:000940', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(110810, NULL, 'G3DSA:3.90.780.10:FF:000004', NULL, NULL, 'UDP-sugar hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110811, NULL, 'G3DSA:1.10.520.10:FF:000005', NULL, NULL, 'Cytochrome c peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(110812, NULL, 'G3DSA:3.40.309.10:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110813, NULL, 'G3DSA:3.40.720.10:FF:000080', NULL, NULL, 'N-acetylgalactosamine 6-sulfatase (GALNS)', NULL, NULL, NULL, NULL, NULL, 4),
(110814, NULL, 'G3DSA:3.30.40.10:FF:000884', NULL, NULL, 'RING finger protein PSH1', NULL, NULL, NULL, NULL, NULL, 4),
(110815, NULL, 'G3DSA:3.50.50.60:FF:000246', NULL, NULL, 'Sulphydryl oxidase Sox', NULL, NULL, NULL, NULL, NULL, 4),
(110816, NULL, 'G3DSA:1.25.40.10:FF:002284', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g40410, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(110817, NULL, 'G3DSA:2.120.10.80:FF:000389', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(110818, NULL, 'G3DSA:3.60.40.10:FF:000197', NULL, NULL, 'Type 2C Protein Phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110819, NULL, 'G3DSA:3.40.50.720:FF:001045', NULL, NULL, 'Ketose-bisphosphate aldolase class-II family protein', NULL, NULL, NULL, NULL, NULL, 4),
(110820, NULL, 'G3DSA:3.30.505.10:FF:000166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(110821, NULL, 'G3DSA:1.10.10.60:FF:001077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110822, NULL, 'G3DSA:3.50.50.60:FF:000954', NULL, NULL, 'FAD-dependent glycerol-3-phosphate dehydrogenase, family protein', NULL, NULL, NULL, NULL, NULL, 4),
(110823, NULL, 'G3DSA:1.20.1070.10:FF:000304', NULL, NULL, 'Trissin receptor, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(110824, NULL, 'G3DSA:3.40.50.10380:FF:000029', NULL, NULL, 'NADP-dependent malic enzyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(110825, NULL, 'G3DSA:1.10.1040.50:FF:000007', NULL, NULL, '3-hydroxyacyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(110826, NULL, 'G3DSA:2.170.260.40:FF:000003', NULL, NULL, '5''-3'' exonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110827, NULL, 'G3DSA:3.40.50.10490:FF:000011', NULL, NULL, 'Arabinose 5-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(110828, NULL, 'G3DSA:3.90.640.10:FF:000202', NULL, NULL, 'Heat shock 70 kDa protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(110829, NULL, 'G3DSA:1.10.10.10:FF:000359', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(110830, NULL, 'G3DSA:1.20.1270.60:FF:000306', NULL, NULL, 'Meiotically up-regulated gene 64 protein', NULL, NULL, NULL, NULL, NULL, 4),
(110831, NULL, 'G3DSA:3.40.1800.20:FF:000015', NULL, NULL, 'FI19405p1', NULL, NULL, NULL, NULL, NULL, 4),
(110832, NULL, 'G3DSA:4.10.320.10:FF:000001', NULL, NULL, 'Dihydrolipoyllysine-residue succinyltransferase component of 2-oxoglutarate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(110833, NULL, 'G3DSA:1.10.510.10:FF:002601', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110834, NULL, 'G3DSA:3.10.280.10:FF:000035', NULL, NULL, 'Mitochondrial acidic protein mam33', NULL, NULL, NULL, NULL, NULL, 4),
(110835, NULL, 'G3DSA:1.10.472.10:FF:000286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110836, NULL, 'G3DSA:2.130.10.10:FF:001060', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(110837, NULL, 'G3DSA:3.20.20.30:FF:000001', NULL, NULL, 'Alkanesulfonate monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(110838, NULL, 'G3DSA:3.40.50.300:FF:000166', NULL, NULL, 'vesicle-fusing ATPase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(110839, NULL, 'G3DSA:2.30.30.40:FF:000113', NULL, NULL, 'unconventional myosin-VIIa', NULL, NULL, NULL, NULL, NULL, 4),
(110840, NULL, 'G3DSA:3.10.110.10:FF:000377', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110841, NULL, 'G3DSA:3.40.390.10:FF:000126', NULL, NULL, 'Matrix metalloproteinase 13', NULL, NULL, NULL, NULL, NULL, 4),
(110842, NULL, 'G3DSA:1.20.1110.10:FF:000128', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(110843, NULL, 'G3DSA:2.70.170.10:FF:000202', NULL, NULL, 'Gamma-aminobutyric acid type A receptor alpha2 subunit a', NULL, NULL, NULL, NULL, NULL, 4),
(110844, NULL, 'G3DSA:3.40.50.10090:FF:000066', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(110845, NULL, 'G3DSA:1.20.1310.10:FF:000020', NULL, NULL, 'Cullin-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110846, NULL, 'G3DSA:2.30.36.90:FF:000001', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(110847, NULL, 'G3DSA:1.20.80.10:FF:000048', NULL, NULL, 'Acyl-CoA binding domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(110848, NULL, 'G3DSA:3.40.50.2300:FF:000186', NULL, NULL, 'Glutamate receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(110849, NULL, 'G3DSA:1.20.920.10:FF:000180', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(110850, NULL, 'G3DSA:3.40.1110.10:FF:000015', NULL, NULL, 'ATPase copper transporting beta', NULL, NULL, NULL, NULL, NULL, 4),
(110851, NULL, 'G3DSA:3.10.150.10:FF:000031', NULL, NULL, 'Proliferating cell nuclear antigen', NULL, NULL, NULL, NULL, NULL, 4),
(110852, NULL, 'G3DSA:3.60.21.10:FF:000310', NULL, NULL, 'Ser/Thr protein phosphatase family protein, UDP-2,3-diacylglucosamine hydrolase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(110853, NULL, 'G3DSA:3.40.50.300:FF:002111', NULL, NULL, 'Origin of replication complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(110854, NULL, 'G3DSA:3.30.70.330:FF:000827', NULL, NULL, 'Related to pre-mRNA splicing factor', NULL, NULL, NULL, NULL, NULL, 4),
(110855, NULL, 'G3DSA:3.30.1490.120:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110856, NULL, 'G3DSA:1.10.8.10:FF:000291', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(110857, NULL, 'G3DSA:3.30.160.60:FF:004959', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110858, NULL, 'G3DSA:3.40.720.10:FF:000017', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(110859, NULL, 'G3DSA:2.60.40.10:FF:005235', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110860, NULL, 'G3DSA:2.20.70.10:FF:000124', NULL, NULL, 'DEAD box RNA helicase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(110861, NULL, 'G3DSA:1.10.1200.30:FF:000003', NULL, NULL, 'Gag polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(110862, NULL, 'G3DSA:2.40.50.100:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110863, NULL, 'G3DSA:3.90.1150.10:FF:000377', NULL, NULL, 'Methionine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(110864, NULL, 'G3DSA:3.40.850.10:FF:000206', NULL, NULL, 'Putative kinesin', NULL, NULL, NULL, NULL, NULL, 4),
(110865, NULL, 'G3DSA:1.20.920.10:FF:000028', NULL, NULL, 'Nuclear autoantigen Sp-100', NULL, NULL, NULL, NULL, NULL, 4),
(110866, NULL, 'G3DSA:1.20.1530.20:FF:000096', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(110867, NULL, 'G3DSA:1.10.1410.10:FF:000002', NULL, NULL, 'terminal uridylyltransferase 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(110868, NULL, 'G3DSA:3.40.1350.100:FF:000007', NULL, NULL, 'Protein TIC 22-like, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(110869, NULL, 'G3DSA:2.130.10.10:FF:001088', NULL, NULL, 'Notchless homolog, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110870, NULL, 'G3DSA:3.20.20.70:FF:000018', NULL, NULL, 'Probable transaldolase', NULL, NULL, NULL, NULL, NULL, 4),
(110871, NULL, 'G3DSA:1.10.510.10:FF:002596', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110872, NULL, 'G3DSA:2.130.10.10:FF:005331', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(110873, NULL, 'G3DSA:3.30.70.330:FF:001463', NULL, NULL, 'Pentatricopeptide (PPR) repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(110874, NULL, 'G3DSA:3.60.40.10:FF:000202', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(110875, NULL, 'G3DSA:3.40.50.2300:FF:000894', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110876, NULL, 'G3DSA:3.40.50.150:FF:000008', NULL, NULL, 'DNA (Cytosine-5)-methyltransferase 3A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(110877, NULL, 'G3DSA:1.20.1250.20:FF:001895', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110878, NULL, 'G3DSA:2.130.10.10:FF:005359', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110879, NULL, 'G3DSA:2.60.40.1460:FF:000014', NULL, NULL, 'Integrin alpha-PS3', NULL, NULL, NULL, NULL, NULL, 4),
(110880, NULL, 'G3DSA:3.40.50.12230:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110881, NULL, 'G3DSA:3.30.60.30:FF:000222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110882, NULL, 'G3DSA:3.30.200.20:FF:002260', NULL, NULL, 'Cell surface receptor daf-1', NULL, NULL, NULL, NULL, NULL, 4),
(110883, NULL, 'G3DSA:2.40.30.30:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110884, NULL, 'G3DSA:1.25.10.10:FF:000567', NULL, NULL, 'Karyopherin beta 2', NULL, NULL, NULL, NULL, NULL, 4),
(110885, NULL, 'G3DSA:3.30.450.40:FF:000165', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(110886, NULL, 'G3DSA:1.25.40.10:FF:003296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(110887, NULL, 'G3DSA:3.80.10.10:FF:000711', NULL, NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g12460', NULL, NULL, NULL, NULL, NULL, 4),
(110888, NULL, 'G3DSA:3.40.50.720:FF:000084', NULL, NULL, 'Short-chain dehydrogenase reductase', NULL, NULL, NULL, NULL, NULL, 4),
(110889, NULL, 'G3DSA:2.60.40.10:FF:000328', NULL, NULL, 'CLUMA_CG000981, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(110890, NULL, 'G3DSA:3.30.160.810:FF:000002', NULL, NULL, '50S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(110891, NULL, 'G3DSA:3.40.1160.10:FF:000018', NULL, NULL, 'Glutamate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(110892, NULL, 'G3DSA:3.40.50.1000:FF:000515', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110893, NULL, 'G3DSA:3.30.70.330:FF:002300', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110894, NULL, 'G3DSA:3.30.420.10:FF:000317', NULL, NULL, 'Polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(110895, NULL, 'G3DSA:1.20.58.1030:FF:000041', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(110896, NULL, 'G3DSA:2.40.170.20:FF:000066', NULL, NULL, 'Probable TonB-dependent receptor', NULL, NULL, NULL, NULL, NULL, 4),
(110897, NULL, 'G3DSA:3.80.10.10:FF:003437', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110898, NULL, 'G3DSA:3.30.70.330:FF:001811', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110899, NULL, 'G3DSA:1.10.730.10:FF:000162', NULL, NULL, 'Methionyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(110900, NULL, 'G3DSA:3.30.470.20:FF:000042', NULL, NULL, 'Synapsin III', NULL, NULL, NULL, NULL, NULL, 4),
(110901, NULL, 'G3DSA:2.130.10.10:FF:001621', NULL, NULL, 'Excision repair cross-complementation group 8', NULL, NULL, NULL, NULL, NULL, 4),
(110902, NULL, 'G3DSA:4.10.280.10:FF:000093', NULL, NULL, 'BHLH domain class transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(110903, NULL, 'G3DSA:4.10.80.160:FF:000003', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(110904, NULL, 'G3DSA:2.130.10.10:FF:001436', NULL, NULL, 'Putative WD-repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(110905, NULL, 'G3DSA:2.60.120.260:FF:000582', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110906, NULL, 'G3DSA:3.40.50.720:FF:001332', NULL, NULL, 'NAD(P)-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(110907, NULL, 'G3DSA:2.120.10.70:FF:000004', NULL, NULL, 'Putative secreted neuraminidase', NULL, NULL, NULL, NULL, NULL, 4),
(110908, NULL, 'G3DSA:3.80.10.10:FF:002004', NULL, NULL, 'Phytosulfokine receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(110909, NULL, 'G3DSA:3.30.1330.20:FF:000037', NULL, NULL, 'Alpha-tubulin,putative', NULL, NULL, NULL, NULL, NULL, 4),
(110910, NULL, 'G3DSA:1.10.1900.20:FF:000003', NULL, NULL, 'Mitochondrial ribosomal protein L20', NULL, NULL, NULL, NULL, NULL, 4),
(110911, NULL, 'G3DSA:3.40.50.300:FF:001178', NULL, NULL, 'ATP-binding cassette sub-family D member 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(110912, NULL, 'G3DSA:3.20.20.80:FF:000819', NULL, NULL, 'Alpha-L-iduronidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110913, NULL, 'G3DSA:1.10.12.10:FF:000021', NULL, NULL, '3-hydroxybutyryl-CoA dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(110914, NULL, 'G3DSA:1.10.3260.10:FF:000029', NULL, NULL, 'Thermostable DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(110915, NULL, 'G3DSA:1.25.40.570:FF:000024', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 13 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(110916, NULL, 'G3DSA:2.160.20.80:FF:000006', NULL, NULL, 'Thylakoid lumenal 17.4 kDa protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(110917, NULL, 'G3DSA:3.30.160.60:FF:002397', NULL, NULL, 'Zinc finger protein 320', NULL, NULL, NULL, NULL, NULL, 4),
(110918, NULL, 'G3DSA:3.55.50.30:FF:000019', NULL, NULL, 'Probable transmembrane sensor', NULL, NULL, NULL, NULL, NULL, 4),
(110919, NULL, 'G3DSA:3.90.1380.10:FF:000006', NULL, NULL, 'Threonine synthase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(110920, NULL, 'G3DSA:3.40.50.300:FF:003364', NULL, NULL, 'Si:dkey-110g7.8', NULL, NULL, NULL, NULL, NULL, 4),
(110921, NULL, 'G3DSA:3.30.160.60:FF:001413', NULL, NULL, 'tripartite motif-containing protein 47 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(110922, NULL, 'G3DSA:3.30.310.40:FF:000003', NULL, NULL, 'N-glycosylase/DNA lyase OGG1', NULL, NULL, NULL, NULL, NULL, 4),
(110923, NULL, 'G3DSA:3.30.40.10:FF:000653', NULL, NULL, 'RING/U-box superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(110924, NULL, 'G3DSA:3.40.50.1000:FF:000431', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110925, NULL, 'G3DSA:1.20.1560.10:FF:000156', NULL, NULL, 'Toxin secretion ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(110926, NULL, 'G3DSA:3.30.365.10:FF:000014', NULL, NULL, 'Selenate reductase, molybdenum-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(110927, NULL, 'G3DSA:2.60.40.10:FF:003526', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110928, NULL, 'G3DSA:3.30.160.60:FF:001885', NULL, NULL, 'Zgc:174653', NULL, NULL, NULL, NULL, NULL, 4),
(110929, NULL, 'G3DSA:2.30.29.30:FF:001203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110930, NULL, 'G3DSA:1.10.555.10:FF:000237', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110931, NULL, 'G3DSA:1.20.1220.12:FF:000004', NULL, NULL, 'Malate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(110932, NULL, 'G3DSA:3.40.50.620:FF:000705', NULL, NULL, 'Nicotinamide-nucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(110933, NULL, 'G3DSA:3.10.20.30:FF:000086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110934, NULL, 'G3DSA:2.60.40.2160:FF:000005', NULL, NULL, 'Interleukin 17 receptor E like', NULL, NULL, NULL, NULL, NULL, 4),
(110935, NULL, 'G3DSA:3.30.465.10:FF:000055', NULL, NULL, 'Possible alkyldihydroxyacetonephosphate synthase agpS', NULL, NULL, NULL, NULL, NULL, 4),
(110936, NULL, 'G3DSA:2.60.120.10:FF:000044', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(110937, NULL, 'G3DSA:3.40.50.300:FF:003420', NULL, NULL, 'Developmentally-regulated GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110938, NULL, 'G3DSA:1.25.40.20:FF:001685', NULL, NULL, 'Ankyrin 1', NULL, NULL, NULL, NULL, NULL, 4),
(110939, NULL, 'G3DSA:1.25.40.10:FF:001643', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(110940, NULL, 'G3DSA:3.40.50.300:FF:007107', NULL, NULL, 'Phosphoribulokinase', NULL, NULL, NULL, NULL, NULL, 4),
(110941, NULL, 'G3DSA:1.10.287.600:FF:000010', NULL, NULL, 'Tubulin delta chain', NULL, NULL, NULL, NULL, NULL, 4),
(110942, NULL, 'G3DSA:1.25.40.10:FF:005010', NULL, NULL, 'Tetratricopeptide repeat domain 21B', NULL, NULL, NULL, NULL, NULL, 4),
(110943, NULL, 'G3DSA:3.40.50.1820:FF:000609', NULL, NULL, 'Arylesterase', NULL, NULL, NULL, NULL, NULL, 4),
(110944, NULL, 'G3DSA:3.40.50.410:FF:000194', NULL, NULL, 'Collagen, type VII, alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(110945, NULL, 'G3DSA:2.40.70.10:FF:000286', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110946, NULL, 'G3DSA:1.20.5.2440:FF:000008', NULL, NULL, 'RAB11 family-interacting protein 5a (class I)', NULL, NULL, NULL, NULL, NULL, 4),
(110947, NULL, 'G3DSA:3.30.530.20:FF:000160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110948, NULL, 'G3DSA:1.25.10.10:FF:002220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110949, NULL, 'G3DSA:3.50.50.100:FF:000025', NULL, NULL, 'FAD-dependent pyridine nucleotide-disulfide oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(110950, NULL, 'G3DSA:3.80.10.10:FF:002476', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110951, NULL, 'G3DSA:2.120.10.30:FF:000043', NULL, NULL, 'NHL repeat containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(110952, NULL, 'G3DSA:3.90.226.10:FF:000341', NULL, NULL, 'Methylthioacryloyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(110953, NULL, 'G3DSA:3.30.160.60:FF:005628', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(110954, NULL, 'G3DSA:1.10.510.10:FF:001292', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(110955, NULL, 'G3DSA:1.10.10.10:FF:001056', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(110956, NULL, 'G3DSA:1.20.1250.20:FF:001979', NULL, NULL, 'Transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(110957, NULL, 'G3DSA:3.90.230.10:FF:000031', NULL, NULL, 'Proliferation-associated 2G4-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(110958, NULL, 'G3DSA:1.25.10.10:FF:001815', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110959, NULL, 'G3DSA:3.40.720.10:FF:000309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110960, NULL, 'G3DSA:2.60.210.10:FF:000074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110961, NULL, 'G3DSA:2.10.25.10:FF:001650', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110962, NULL, 'G3DSA:1.20.120.1080:FF:000013', NULL, NULL, 'ATP-dependent RNA helicase DHX34', NULL, NULL, NULL, NULL, NULL, 4),
(110963, NULL, 'G3DSA:2.60.220.50:FF:000064', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(110964, NULL, 'G3DSA:1.20.140.100:FF:000031', NULL, NULL, 'Cytoplasmic dynein 2 heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(110965, NULL, 'G3DSA:1.20.5.190:FF:000066', NULL, NULL, 'IQ calmodulin-binding motif family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(110966, NULL, 'G3DSA:3.30.230.40:FF:000002', NULL, NULL, 'Imidazoleglycerol-phosphate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(110967, NULL, 'G3DSA:3.30.420.10:FF:000233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110968, NULL, 'G3DSA:1.10.600.10:FF:000006', NULL, NULL, 'Farnesyl pyrophosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(110969, NULL, 'G3DSA:3.60.15.10:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110970, NULL, 'G3DSA:3.80.10.10:FF:000239', NULL, NULL, 'Nucleotide-binding oligomerization domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(110971, NULL, 'G3DSA:2.10.25.10:FF:001594', NULL, NULL, 'Neurogenic locus protein delta-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(110972, NULL, 'G3DSA:3.40.50.300:FF:001655', NULL, NULL, 'Sulfate/thiosulfate import ATP-binding protein CysA', NULL, NULL, NULL, NULL, NULL, 4),
(110973, NULL, 'G3DSA:3.30.1490.20:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110974, NULL, 'G3DSA:1.20.1250.20:FF:000731', NULL, NULL, 'MFS family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(110975, NULL, 'G3DSA:1.10.240.10:FF:000023', NULL, NULL, 'Tryptophan--tRNA ligase 2', NULL, NULL, NULL, NULL, NULL, 4),
(110976, NULL, 'G3DSA:2.60.40.10:FF:000295', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type substrate 1', NULL, NULL, NULL, NULL, NULL, 4),
(110977, NULL, 'G3DSA:1.10.510.10:FF:000887', NULL, NULL, 'Aurora B kinase', NULL, NULL, NULL, NULL, NULL, 4),
(110978, NULL, 'G3DSA:3.10.129.10:FF:000015', NULL, NULL, 'Fatty acid synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(110979, NULL, 'G3DSA:1.20.58.60:FF:000894', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110980, NULL, 'G3DSA:2.60.120.920:FF:000061', NULL, NULL, 'Tripartite motif containing 65', NULL, NULL, NULL, NULL, NULL, 4),
(110981, NULL, 'G3DSA:2.40.240.130:FF:000006', NULL, NULL, 'DIX domain containing 1 (DIXDC1), mRNA protein', NULL, NULL, NULL, NULL, NULL, 4),
(110982, NULL, 'G3DSA:3.40.50.300:FF:002959', NULL, NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(110983, NULL, 'G3DSA:2.70.98.40:FF:000003', NULL, NULL, 'Acid trehalase', NULL, NULL, NULL, NULL, NULL, 4),
(110984, NULL, 'G3DSA:1.20.1250.20:FF:000675', NULL, NULL, 'Major facilitator superfamily transporter', NULL, NULL, NULL, NULL, NULL, 4),
(110985, NULL, 'G3DSA:1.25.10.10:FF:001495', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(110986, NULL, 'G3DSA:3.30.450.20:FF:000535', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110987, NULL, 'G3DSA:1.20.5.110:FF:000149', NULL, NULL, 'SNARE domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(110988, NULL, 'G3DSA:3.40.50.300:FF:005073', NULL, NULL, 'Thyroid hormone receptor interactor 13', NULL, NULL, NULL, NULL, NULL, 4),
(110989, NULL, 'G3DSA:3.30.310.80:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110990, NULL, 'G3DSA:3.40.850.10:FF:000353', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(110991, NULL, 'G3DSA:2.40.30.230:FF:000004', NULL, NULL, 'ATP-dependent helicase NAM7', NULL, NULL, NULL, NULL, NULL, 4),
(110992, NULL, 'G3DSA:1.20.5.170:FF:000060', NULL, NULL, 'protein ABSCISIC ACID-INSENSITIVE 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(110993, NULL, 'G3DSA:3.20.20.70:FF:000081', NULL, NULL, 'Dihydrouridine synthase 1 like', NULL, NULL, NULL, NULL, NULL, 4),
(110994, NULL, 'G3DSA:2.60.40.10:FF:005674', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(110995, NULL, 'G3DSA:3.90.1750.10:FF:000018', NULL, NULL, 'E3 ubiquitin-protein ligase HECTD1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(110996, NULL, 'G3DSA:1.25.40.20:FF:001213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(110997, NULL, 'G3DSA:3.30.70.330:FF:000794', NULL, NULL, 'Gar2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(110998, NULL, 'G3DSA:3.40.50.2000:FF:000686', NULL, NULL, 'ADP-heptose:LPS heptosyltransferase II', NULL, NULL, NULL, NULL, NULL, 4),
(110999, NULL, 'G3DSA:2.130.10.10:FF:000216', NULL, NULL, 'Periodic tryptophan protein 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(111000, NULL, 'G3DSA:3.80.10.10:FF:004134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111001, NULL, 'G3DSA:2.30.29.30:FF:000478', NULL, NULL, 'JNK Interacting Protein (Scaffold protein)', NULL, NULL, NULL, NULL, NULL, 4),
(111002, NULL, 'G3DSA:1.10.510.10:FF:001668', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(111003, NULL, 'G3DSA:3.40.640.10:FF:000163', NULL, NULL, 'Phosphoserine transaminase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111004, NULL, 'G3DSA:3.40.720.10:FF:000164', NULL, NULL, 'Phosphatidylinositol glycan anchor biosynthesis class N', NULL, NULL, NULL, NULL, NULL, 4),
(111005, NULL, 'G3DSA:3.40.50.1820:FF:000761', NULL, NULL, 'Haloalkane dehalogenase', NULL, NULL, NULL, NULL, NULL, 4),
(111006, NULL, 'G3DSA:2.40.50.140:FF:001061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111007, NULL, 'G3DSA:2.60.40.10:FF:002240', NULL, NULL, 'Macrophage stimulating 1 receptor b', NULL, NULL, NULL, NULL, NULL, 4),
(111008, NULL, 'G3DSA:2.30.30.100:FF:000069', NULL, NULL, 'Small nuclear ribonucleoprotein Sm D2', NULL, NULL, NULL, NULL, NULL, 4),
(111009, NULL, 'G3DSA:1.10.3450.40:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111010, NULL, 'G3DSA:1.20.920.20:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111011, NULL, 'G3DSA:2.60.40.820:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111012, NULL, 'G3DSA:3.40.20.10:FF:000096', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(111013, NULL, 'G3DSA:2.40.160.20:FF:000037', NULL, NULL, 'Outer membrane porin', NULL, NULL, NULL, NULL, NULL, 4),
(111014, NULL, 'G3DSA:1.50.40.10:FF:000303', NULL, NULL, 'Mitochondrial carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(111015, NULL, 'G3DSA:1.20.120.140:FF:000011', NULL, NULL, 'Signal recognition particle 54 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(111016, NULL, 'G3DSA:1.10.287.3700:FF:000008', NULL, NULL, 'PAN2-PAN3 deadenylation complex subunit pan3', NULL, NULL, NULL, NULL, NULL, 4),
(111017, NULL, 'G3DSA:3.40.50.80:FF:000101', NULL, NULL, 'Metalloreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111018, NULL, 'G3DSA:3.90.199.10:FF:000001', NULL, NULL, 'DNA gyrase subunit A', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(111019, NULL, 'G3DSA:3.30.457.60:FF:000001', NULL, NULL, 'Mitotic spindle assembly checkpoint protein MAD1', NULL, NULL, NULL, NULL, NULL, 4),
(111020, NULL, 'G3DSA:1.10.10.60:FF:001133', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111021, NULL, 'G3DSA:3.30.559.10:FF:000234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111022, NULL, 'G3DSA:3.30.450.20:FF:000479', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111023, NULL, 'G3DSA:1.10.30.10:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111024, NULL, 'G3DSA:3.40.50.1000:FF:000807', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111025, NULL, 'G3DSA:1.20.90.10:FF:000021', NULL, NULL, 'Otoconin 90', NULL, NULL, NULL, NULL, NULL, 4),
(111026, NULL, 'G3DSA:3.40.50.10490:FF:000118', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111027, NULL, 'G3DSA:2.10.25.10:FF:001739', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111028, NULL, 'G3DSA:1.20.1250.20:FF:000203', NULL, NULL, 'Large neutral amino acids transporter small subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(111029, NULL, 'G3DSA:4.10.1130.20:FF:000003', NULL, NULL, 'Cysteine and histidine-rich domain-containing protein RAR1', NULL, NULL, NULL, NULL, NULL, 4),
(111030, NULL, 'G3DSA:1.20.120.1910:FF:000037', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(111031, NULL, 'G3DSA:3.30.1490.190:FF:000023', NULL, NULL, 'Ferric uptake regulation protein', NULL, NULL, NULL, NULL, NULL, 4),
(111032, NULL, 'G3DSA:3.80.10.10:FF:003729', NULL, NULL, 'AGAP000340-PA', NULL, NULL, NULL, NULL, NULL, 4),
(111033, NULL, 'G3DSA:1.10.472.10:FF:000578', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111034, NULL, 'G3DSA:1.10.560.10:FF:000042', NULL, NULL, 'T-complex polypeptide 1', NULL, NULL, NULL, NULL, NULL, 4),
(111035, NULL, 'G3DSA:3.30.1240.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111036, NULL, 'G3DSA:1.10.510.10:FF:002124', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(111037, NULL, 'G3DSA:3.20.10.10:FF:000017', NULL, NULL, 'Unplaced genomic scaffold supercont1.241, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(111038, NULL, 'G3DSA:1.20.1560.10:FF:000443', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111039, NULL, 'G3DSA:3.30.420.40:FF:000865', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111040, NULL, 'G3DSA:3.30.70.330:FF:000535', NULL, NULL, 'Serine/arginine-rich splicing factor SR45a', NULL, NULL, NULL, NULL, NULL, 4),
(111041, NULL, 'G3DSA:3.30.40.10:FF:002362', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(111042, NULL, 'G3DSA:3.40.30.10:FF:000181', NULL, NULL, 'Thiol-disulfide oxidoreductase ResA', NULL, NULL, NULL, NULL, NULL, 4),
(111043, NULL, 'G3DSA:3.30.70.330:FF:001047', NULL, NULL, 'Putative RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(111044, NULL, 'G3DSA:1.10.472.30:FF:000005', NULL, NULL, 'Transcription elongation factor S-II', NULL, NULL, NULL, NULL, NULL, 4),
(111045, NULL, 'G3DSA:1.20.1260.60:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111046, NULL, 'G3DSA:3.30.450.20:FF:000390', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(111047, NULL, 'G3DSA:3.90.1460.10:FF:000007', NULL, NULL, 'General transcription factor II-I repeat domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(111048, NULL, 'G3DSA:2.60.40.10:FF:000036', NULL, NULL, 'receptor-type tyrosine-protein phosphatase delta isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(111049, NULL, 'G3DSA:2.40.30.20:FF:000017', NULL, NULL, 'ATP synthase subunit alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(111050, NULL, 'G3DSA:1.20.900.10:FF:000089', NULL, NULL, 'PIX (PAK (p21-activated kinase) Interacting eXchange factor) homolog', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(111051, NULL, 'G3DSA:2.20.70.10:FF:000040', NULL, NULL, 'WW domain containing oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(111052, NULL, 'G3DSA:1.20.58.60:FF:000242', NULL, NULL, 'Dystrophin', NULL, NULL, NULL, NULL, NULL, 4),
(111053, NULL, 'G3DSA:1.20.20.10:FF:000016', NULL, NULL, 'ATP synthase subunit 9, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(111054, NULL, 'G3DSA:1.10.510.10:FF:004310', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111055, NULL, 'G3DSA:2.130.10.10:FF:006000', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111056, NULL, 'G3DSA:3.40.50.970:FF:000226', NULL, NULL, 'Gll1094 protein', NULL, NULL, NULL, NULL, NULL, 4),
(111057, NULL, 'G3DSA:1.20.58.400:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111058, NULL, 'G3DSA:4.10.60.10:FF:000035', NULL, NULL, 'Cellular nucleic acid-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(111059, NULL, 'G3DSA:1.10.150.20:FF:000053', NULL, NULL, 'T5 flap endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(111060, NULL, 'G3DSA:2.30.30.380:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111061, NULL, 'G3DSA:3.30.420.40:FF:000337', NULL, NULL, 'Actin-related protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(111062, NULL, 'G3DSA:1.10.10.60:FF:000149', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(111063, NULL, 'G3DSA:3.30.160.20:FF:000047', NULL, NULL, 'double-stranded RNA-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(111064, NULL, 'G3DSA:3.40.50.300:FF:006326', NULL, NULL, 'Uncharacterized AAA domain-containing protein P22H7.05c', NULL, NULL, NULL, NULL, NULL, 4),
(111065, NULL, 'G3DSA:2.170.300.10:FF:000015', NULL, NULL, 'multiple epidermal growth factor-like domains protein 11 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(111066, NULL, 'G3DSA:3.40.47.10:FF:000157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111067, NULL, 'G3DSA:2.130.10.10:FF:001144', NULL, NULL, 'WD40 repeat-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(111068, NULL, 'G3DSA:2.60.98.50:FF:000001', NULL, NULL, 'Envelopment polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(111069, NULL, 'G3DSA:1.10.8.60:FF:000081', NULL, NULL, 'AAA family ATPase/60S ribosome export protein', NULL, NULL, NULL, NULL, NULL, 4),
(111070, NULL, 'G3DSA:2.60.40.10:FF:001817', NULL, NULL, 'Basement membrane proteoglycan', NULL, NULL, NULL, NULL, NULL, 4),
(111071, NULL, 'G3DSA:1.20.5.520:FF:000007', NULL, NULL, 'Thymosin beta HOMOLOGUE', NULL, NULL, NULL, NULL, NULL, 4),
(111072, NULL, 'G3DSA:1.25.40.10:FF:003065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111073, NULL, 'G3DSA:1.10.8.60:FF:000457', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111074, NULL, 'G3DSA:3.40.50.720:FF:000909', NULL, NULL, 'Ornithine cyclodeaminase', NULL, NULL, NULL, NULL, NULL, 4),
(111075, NULL, 'G3DSA:3.30.1490.20:FF:000054', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(111076, NULL, 'G3DSA:3.40.50.150:FF:000424', NULL, NULL, 'Mitochondrial transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(111077, NULL, 'G3DSA:3.30.160.60:FF:006051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111078, NULL, 'G3DSA:3.90.70.80:FF:000078', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(111079, NULL, 'G3DSA:1.20.5.170:FF:000240', NULL, NULL, 'Cyclic AMP-dependent transcription factor ATF-4', NULL, NULL, NULL, NULL, NULL, 4),
(111080, NULL, 'G3DSA:3.30.800.10:FF:000015', NULL, NULL, 'Phosphatidylinositol-4-phosphate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(111081, NULL, 'G3DSA:1.10.840.10:FF:000024', NULL, NULL, 'Rap Guanine nucleotide Exchange Factor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(111082, NULL, 'G3DSA:1.10.167.20:FF:000001', NULL, NULL, 'Nucleoporin NUP170', NULL, NULL, NULL, NULL, NULL, 4),
(111083, NULL, 'G3DSA:3.10.110.10:FF:000085', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 C', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(111084, NULL, 'G3DSA:1.20.142.10:FF:000012', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(111085, NULL, 'G3DSA:1.20.1270.60:FF:000222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111086, NULL, 'G3DSA:3.30.230.120:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111087, NULL, 'G3DSA:3.40.50.150:FF:001588', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111088, NULL, 'G3DSA:4.10.1230.10:FF:000002', NULL, NULL, 'Ecotin family (I11)', NULL, NULL, NULL, NULL, NULL, 4),
(111089, NULL, 'G3DSA:2.40.30.10:FF:000492', NULL, NULL, 'Selenocysteine-specific elongation factor', NULL, NULL, NULL, NULL, NULL, 4),
(111090, NULL, 'G3DSA:3.40.50.300:FF:001942', NULL, NULL, 'DEAD-box ATP-dependent RNA helicase 50', NULL, NULL, NULL, NULL, NULL, 4),
(111091, NULL, 'G3DSA:3.40.190.10:FF:000526', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111092, NULL, 'G3DSA:3.30.420.10:FF:000609', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111093, NULL, 'G3DSA:3.90.1280.20:FF:000007', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(111094, NULL, 'G3DSA:2.30.40.10:FF:000127', NULL, NULL, 'Imidazolonepropionase', NULL, NULL, NULL, NULL, NULL, 4),
(111095, NULL, 'G3DSA:1.50.10.10:FF:000211', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(111096, NULL, 'G3DSA:1.10.472.10:FF:000522', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(111097, NULL, 'G3DSA:3.40.1110.10:FF:000246', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111098, NULL, 'G3DSA:3.80.10.10:FF:002656', NULL, NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase At3g28040', NULL, NULL, NULL, NULL, NULL, 4),
(111099, NULL, 'G3DSA:2.60.40.10:FF:001109', NULL, NULL, 'Kirre like nephrin family adhesion molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(111100, NULL, 'G3DSA:3.30.160.60:FF:001941', NULL, NULL, 'Zinc finger protein 460', NULL, NULL, NULL, NULL, NULL, 4),
(111101, NULL, 'G3DSA:3.40.50.300:FF:004668', NULL, NULL, 'ATP-dependent nuclease subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(111102, NULL, 'G3DSA:2.130.10.10:FF:001852', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111103, NULL, 'G3DSA:3.30.70.330:FF:001608', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111104, NULL, 'G3DSA:2.170.120.20:FF:000015', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(111105, NULL, 'G3DSA:3.50.50.60:FF:000477', NULL, NULL, 'GMC-type oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(111106, NULL, 'G3DSA:1.10.10.10:FF:001820', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111107, NULL, 'G3DSA:2.40.50.40:FF:000119', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(111108, NULL, 'G3DSA:1.20.1070.10:FF:000248', NULL, NULL, '5-hydroxytryptamine receptor 1A-beta', NULL, NULL, NULL, NULL, NULL, 4),
(111109, NULL, 'G3DSA:3.20.20.80:FF:000555', NULL, NULL, 'Chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111110, NULL, 'G3DSA:1.20.120.850:FF:000021', NULL, NULL, 'Protein CHROMATIN REMODELING 25', NULL, NULL, NULL, NULL, NULL, 4),
(111111, NULL, 'G3DSA:3.40.50.1820:FF:000233', NULL, NULL, 'Lysosomal Pro-X carboxypeptidase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(111112, NULL, 'G3DSA:3.30.360.10:FF:000031', NULL, NULL, 'Trans-1,2-dihydrobenzene-1,2-diol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(111113, NULL, 'G3DSA:1.10.760.10:FF:000023', NULL, NULL, 'Cytochrome c oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(111114, NULL, 'G3DSA:2.60.120.380:FF:000056', NULL, NULL, 'Putative calpain', NULL, NULL, NULL, NULL, NULL, 4),
(111115, NULL, 'G3DSA:3.40.50.300:FF:006293', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111116, NULL, 'G3DSA:1.10.10.10:FF:001112', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(111117, NULL, 'G3DSA:1.25.40.10:FF:003773', NULL, NULL, 'Tetratricopeptide repeat domain 37', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(111118, NULL, 'G3DSA:2.60.40.10:FF:001020', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(111119, NULL, 'G3DSA:1.10.246.190:FF:000002', NULL, NULL, 'Autophagy protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(111120, NULL, 'G3DSA:3.30.720.10:FF:000014', NULL, NULL, 'Related to Signal recognition particle 14 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(111121, NULL, 'G3DSA:2.60.120.290:FF:000181', NULL, NULL, 'Cubilin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(111122, NULL, 'G3DSA:1.10.3470.10:FF:000039', NULL, NULL, 'Manganese transport system membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(111123, NULL, 'G3DSA:3.30.70.20:FF:000006', NULL, NULL, 'Formate dehydrogenase iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4),
(111124, NULL, 'G3DSA:3.30.460.90:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111125, NULL, 'G3DSA:1.20.58.830:FF:000044', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(111126, NULL, 'G3DSA:4.10.910.10:FF:000001', NULL, NULL, '30S ribosomal protein S13', NULL, NULL, NULL, NULL, NULL, 4),
(111127, NULL, 'G3DSA:1.25.10.10:FF:000983', NULL, NULL, 'Dynein axonemal assembly factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(111128, NULL, 'G3DSA:1.10.246.140:FF:000009', NULL, NULL, 'Transcription and mRNA export factor ENY2', NULL, NULL, NULL, NULL, NULL, 4),
(111129, NULL, 'G3DSA:3.40.50.10190:FF:000039', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(111130, NULL, 'G3DSA:3.30.160.60:FF:001233', NULL, NULL, 'Zinc finger protein 319', NULL, NULL, NULL, NULL, NULL, 4),
(111131, NULL, 'G3DSA:1.25.10.10:FF:003384', NULL, NULL, 'Dynein, axonemal, assembly factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(111132, NULL, 'G3DSA:3.40.50.720:FF:002534', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111133, NULL, 'G3DSA:1.10.760.10:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111134, NULL, 'G3DSA:1.10.150.50:FF:000157', NULL, NULL, 'MAP kinase', NULL, NULL, NULL, NULL, NULL, 4),
(111135, NULL, 'G3DSA:2.40.50.140:FF:000077', NULL, NULL, 'Primosomal replication protein N', NULL, NULL, NULL, NULL, NULL, 4),
(111136, NULL, 'G3DSA:2.160.20.10:FF:000210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111137, NULL, 'G3DSA:3.40.50.720:FF:000404', NULL, NULL, 'SUMO-activating enzyme subunit 1B-2', NULL, NULL, NULL, NULL, NULL, 4),
(111138, NULL, 'G3DSA:1.10.150.50:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111139, NULL, 'G3DSA:3.80.10.10:FF:003881', NULL, NULL, 'Leucine-rich repeat (LRR) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(111140, NULL, 'G3DSA:2.10.50.10:FF:000090', NULL, NULL, 'signal peptide, CUB and EGF-like domain-containing protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(111141, NULL, 'G3DSA:3.40.50.300:FF:007815', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111142, NULL, 'G3DSA:1.10.246.90:FF:000015', NULL, NULL, 'NOP56 ribonucleoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(111143, NULL, 'G3DSA:3.40.30.10:FF:000686', NULL, NULL, 'Glutathione transferase', NULL, NULL, NULL, NULL, NULL, 4),
(111144, NULL, 'G3DSA:3.30.300.320:FF:000001', NULL, NULL, 'Neurogenic locus notch 1', NULL, NULL, NULL, NULL, NULL, 4),
(111145, NULL, 'G3DSA:3.10.100.10:FF:000348', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111146, NULL, 'G3DSA:2.30.29.30:FF:001259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111147, NULL, 'G3DSA:1.10.630.10:FF:000542', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111148, NULL, 'G3DSA:3.40.50.300:FF:004292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111149, NULL, 'G3DSA:3.40.50.10190:FF:000242', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(111150, NULL, 'G3DSA:3.30.230.10:FF:000403', NULL, NULL, 'Ribosome assembly protein 1', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(111151, NULL, 'G3DSA:1.10.1200.10:FF:000048', NULL, NULL, 'Nonribosomal peptide synthase SidE', NULL, NULL, NULL, NULL, NULL, 4),
(111152, NULL, 'G3DSA:3.40.50.2000:FF:000630', NULL, NULL, 'Alpha-1,3/1,6-mannosyltransferase ALG2', NULL, NULL, NULL, NULL, NULL, 4),
(111153, NULL, 'G3DSA:1.20.58.70:FF:000099', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(111154, NULL, 'G3DSA:3.80.10.10:FF:001695', NULL, NULL, 'Leucine rich repeats and death domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(111155, NULL, 'G3DSA:3.40.50.300:FF:002583', NULL, NULL, 'ATP-dependent DNA helicase fml1', NULL, NULL, NULL, NULL, NULL, 4),
(111156, NULL, 'G3DSA:3.40.50.720:FF:000348', NULL, NULL, '3-ketoacyl-ACP reductase', NULL, NULL, NULL, NULL, NULL, 4),
(111157, NULL, 'G3DSA:3.30.420.100:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111158, NULL, 'G3DSA:3.40.190.80:FF:000093', NULL, NULL, 'Fructose-bisphosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(111159, NULL, 'G3DSA:2.10.25.10:FF:000666', NULL, NULL, 'nidogen-1', NULL, NULL, NULL, NULL, NULL, 4),
(111160, NULL, 'G3DSA:1.25.40.20:FF:000960', NULL, NULL, 'YALI0E26081p', NULL, NULL, NULL, NULL, NULL, 4),
(111161, NULL, 'G3DSA:2.30.29.30:FF:000950', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111162, NULL, 'G3DSA:1.25.40.10:FF:000715', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(111163, NULL, 'G3DSA:1.20.200.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111164, NULL, 'G3DSA:3.40.630.30:FF:000584', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111165, NULL, 'G3DSA:1.20.58.60:FF:000039', NULL, NULL, 'Short stop, isoform N', NULL, NULL, NULL, NULL, NULL, 4),
(111166, NULL, 'G3DSA:2.60.120.330:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111167, NULL, 'G3DSA:3.40.1380.10:FF:000001', NULL, NULL, 'ATP synthase gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(111168, NULL, 'G3DSA:1.25.10.10:FF:003237', NULL, NULL, 'GTOR', NULL, NULL, NULL, NULL, NULL, 4),
(111169, NULL, 'G3DSA:2.30.39.10:FF:000057', NULL, NULL, 'Angiotensinogen', NULL, NULL, NULL, NULL, NULL, 4),
(111170, NULL, 'G3DSA:1.10.1520.10:FF:000072', NULL, NULL, 'Secreted protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111171, NULL, 'G3DSA:2.130.10.10:FF:003089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111172, NULL, 'G3DSA:2.60.40.10:FF:004510', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111173, NULL, 'G3DSA:3.40.50.300:FF:008035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111174, NULL, 'G3DSA:3.40.190.10:FF:000706', NULL, NULL, 'ABC transporter, periplasmic substrate-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111175, NULL, 'G3DSA:2.60.530.10:FF:000002', NULL, NULL, 'Oncofetal antigen', NULL, NULL, NULL, NULL, NULL, 4),
(111176, NULL, 'G3DSA:3.30.160.20:FF:000232', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(111177, NULL, 'G3DSA:3.30.200.20:FF:001416', NULL, NULL, 'Serine/threonine-protein kinase stt7, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(111178, NULL, 'G3DSA:3.40.50.1360:FF:000050', NULL, NULL, 'Glucosamine-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(111179, NULL, 'G3DSA:3.30.160.60:FF:004903', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111180, NULL, 'G3DSA:3.10.20.90:FF:000553', NULL, NULL, 'Conserved helix-loop-helix ubiquitous kinase', NULL, NULL, NULL, NULL, NULL, 4),
(111181, NULL, 'G3DSA:1.10.10.10:FF:002040', NULL, NULL, 'Lactamase beta 2', NULL, NULL, NULL, NULL, NULL, 4),
(111182, NULL, 'G3DSA:1.10.1030.10:FF:000017', NULL, NULL, 'Carbamoyl-phosphate synthase large chain, N-terminal section', NULL, NULL, NULL, NULL, NULL, 4),
(111183, NULL, 'G3DSA:3.40.50.300:FF:006854', NULL, NULL, 'Sll5042 protein', NULL, NULL, NULL, NULL, NULL, 4),
(111184, NULL, 'G3DSA:2.70.150.10:FF:000111', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(111185, NULL, 'G3DSA:1.25.40.470:FF:000051', NULL, NULL, 'IntraFlagellar Transport Associated', NULL, NULL, NULL, NULL, NULL, 4),
(111186, NULL, 'G3DSA:3.40.50.2300:FF:000130', NULL, NULL, 'Lactose operon repressor', NULL, NULL, NULL, NULL, NULL, 4),
(111187, NULL, 'G3DSA:1.10.510.10:FF:000179', NULL, NULL, 'MAP kinase-activated protein kinase 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(111188, NULL, 'G3DSA:1.20.1070.10:FF:000068', NULL, NULL, 'Smoothened, frizzled class receptor', NULL, NULL, NULL, NULL, NULL, 4),
(111189, NULL, 'G3DSA:1.10.530.10:FF:000034', NULL, NULL, 'Peptidoglycan transglycosylase gp16', NULL, NULL, NULL, NULL, NULL, 4),
(111190, NULL, 'G3DSA:2.60.40.150:FF:000764', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(111191, NULL, 'G3DSA:3.40.50.12780:FF:000159', NULL, NULL, 'NRPS-like enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111192, NULL, 'G3DSA:3.40.50.1820:FF:000053', NULL, NULL, 'Abhydrolase domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(111193, NULL, 'G3DSA:2.20.100.10:FF:000046', NULL, NULL, 'Cellular communication network factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(111194, NULL, 'G3DSA:1.25.40.180:FF:000121', NULL, NULL, 'Eukaryotic Initiation Factor', NULL, NULL, NULL, NULL, NULL, 4),
(111195, NULL, 'G3DSA:2.40.70.10:FF:000522', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111196, NULL, 'G3DSA:3.40.50.10590:FF:000002', NULL, NULL, 'Aminopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111197, NULL, 'G3DSA:3.40.50.620:FF:000144', NULL, NULL, 'Tryptophan--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(111198, NULL, 'G3DSA:3.80.10.10:FF:002712', NULL, NULL, 'Os06g0557700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(111199, NULL, 'G3DSA:3.30.160.60:FF:001380', NULL, NULL, 'Zinc finger protein 571', NULL, NULL, NULL, NULL, NULL, 4),
(111200, NULL, 'G3DSA:3.60.10.10:FF:000285', NULL, NULL, 'inositol polyphosphate 5-phosphatase K isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(111201, NULL, 'G3DSA:3.10.430.100:FF:000002', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(111202, NULL, 'G3DSA:1.10.506.10:FF:000017', NULL, NULL, 'Neurofibromin 1', NULL, NULL, NULL, NULL, NULL, 4),
(111203, NULL, 'G3DSA:3.30.710.10:FF:000244', NULL, NULL, 'Bath-43', NULL, NULL, NULL, NULL, NULL, 4),
(111204, NULL, 'G3DSA:3.40.50.10330:FF:000008', NULL, NULL, 'Probable lipid kinase YegS', NULL, NULL, NULL, NULL, NULL, 4),
(111205, NULL, 'G3DSA:2.130.10.10:FF:002869', NULL, NULL, 'RNA processing-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111206, NULL, 'G3DSA:4.10.400.10:FF:000058', NULL, NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein', NULL, NULL, NULL, NULL, NULL, 4),
(111207, NULL, 'G3DSA:1.10.287.70:FF:000441', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(111208, NULL, 'G3DSA:3.40.50.1820:FF:001161', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(111209, NULL, 'G3DSA:1.25.40.630:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111210, NULL, 'G3DSA:1.10.10.1320:FF:000006', NULL, NULL, 'Anti-sigma-K factor RskA', NULL, NULL, NULL, NULL, NULL, 4),
(111211, NULL, 'G3DSA:1.10.10.2670:FF:000018', NULL, NULL, 'ELL transcription elongation factor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(111212, NULL, 'G3DSA:3.30.70.1430:FF:000012', NULL, NULL, 'Putative multidrug resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(111213, NULL, 'G3DSA:3.10.50.40:FF:000063', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(111214, NULL, 'G3DSA:1.20.58.60:FF:000186', NULL, NULL, 'nesprin-1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(111215, NULL, 'G3DSA:3.90.15.10:FF:000002', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(111216, NULL, 'G3DSA:2.130.10.10:FF:000924', NULL, NULL, 'Dynein intermediate chain 3', NULL, NULL, NULL, NULL, NULL, 4),
(111217, NULL, 'G3DSA:2.60.120.430:FF:000003', NULL, NULL, 'FERONIA receptor-like kinase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(111218, NULL, 'G3DSA:3.30.200.20:FF:001563', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111219, NULL, 'G3DSA:1.10.1040.10:FF:000046', NULL, NULL, 'Ketose-bisphosphate aldolase class-II family protein', NULL, NULL, NULL, NULL, NULL, 4),
(111220, NULL, 'G3DSA:3.30.160.60:FF:002958', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111221, NULL, 'G3DSA:2.20.110.10:FF:000075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111222, NULL, 'G3DSA:2.60.40.10:FF:002745', NULL, NULL, 'Protein sidekick-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(111223, NULL, 'G3DSA:2.30.180.10:FF:000116', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111224, NULL, 'G3DSA:3.10.20.90:FF:000497', NULL, NULL, 'UV excision repair RAD23-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(111225, NULL, 'G3DSA:3.40.50.2020:FF:000080', NULL, NULL, 'Ribose-phosphate pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(111226, NULL, 'G3DSA:1.10.510.10:FF:001871', NULL, NULL, 'Probable kinase CHARK', NULL, NULL, NULL, NULL, NULL, 4),
(111227, NULL, 'G3DSA:2.130.10.10:FF:003330', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111228, NULL, 'G3DSA:2.40.30.170:FF:000020', NULL, NULL, 'Membrane fusion protein (MFP) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(111229, NULL, 'G3DSA:3.90.660.10:FF:000057', NULL, NULL, 'Spermine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(111230, NULL, 'G3DSA:3.30.70.1730:FF:000040', NULL, NULL, '39S ribosomal protein L10, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(111231, NULL, 'G3DSA:1.10.10.60:FF:000205', NULL, NULL, 'Transcriptional regulator, AraC family', NULL, NULL, NULL, NULL, NULL, 4),
(111232, NULL, 'G3DSA:3.20.20.10:FF:000046', NULL, NULL, 'Arginine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(111233, NULL, 'G3DSA:3.60.20.10:FF:000111', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(111234, NULL, 'G3DSA:3.80.10.10:FF:001223', NULL, NULL, 'Leucine-rich repeat extensin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(111235, NULL, 'G3DSA:3.30.559.10:FF:000054', NULL, NULL, 'Transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(111236, NULL, 'G3DSA:1.25.40.10:FF:001120', NULL, NULL, 'Sel1 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(111237, NULL, 'G3DSA:3.40.20.10:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111238, NULL, 'G3DSA:3.40.50.1010:FF:000288', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111239, NULL, 'G3DSA:1.10.287.70:FF:000238', NULL, NULL, 'Potassium intermediate/small conductance calcium-activated channel, subfamily N, member 4', NULL, NULL, NULL, NULL, NULL, 4),
(111240, NULL, 'G3DSA:3.40.50.10470:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111241, NULL, 'G3DSA:2.60.120.200:FF:000463', NULL, NULL, 'AGAP004993-PA', NULL, NULL, NULL, NULL, NULL, 4),
(111242, NULL, 'G3DSA:1.10.10.60:FF:000913', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111243, NULL, 'G3DSA:3.40.50.740:FF:000034', NULL, NULL, 'NADH Ubiquinone Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(111244, NULL, 'G3DSA:3.30.460.10:FF:000174', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(111245, NULL, 'G3DSA:3.30.160.60:FF:004139', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111246, NULL, 'G3DSA:2.130.10.10:FF:004634', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111247, NULL, 'G3DSA:1.20.1070.10:FF:000776', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(111248, NULL, 'G3DSA:3.40.50.1820:FF:001014', NULL, NULL, 'GPI inositol-deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(111249, NULL, 'G3DSA:1.10.510.10:FF:000943', NULL, NULL, 'testis-specific serine/threonine-protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(111250, NULL, 'G3DSA:1.20.1250.40:FF:000029', NULL, NULL, 'RNA polymerase Rpb4-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(111251, NULL, 'G3DSA:2.60.40.10:FF:000800', NULL, NULL, 'Cardiac titin', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(111252, NULL, 'G3DSA:3.40.50.10890:FF:000007', NULL, NULL, 'Cleavage and polyadenylation specificity factor, 73 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(111253, NULL, 'G3DSA:2.40.150.20:FF:000008', NULL, NULL, '60S ribosomal protein L23', NULL, NULL, NULL, NULL, NULL, 4),
(111254, NULL, 'G3DSA:1.20.1420.30:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111255, NULL, 'G3DSA:1.10.510.10:FF:003293', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111256, NULL, 'G3DSA:3.80.10.10:FF:000059', NULL, NULL, 'Chondroadherin like', NULL, NULL, NULL, NULL, NULL, 4),
(111257, NULL, 'G3DSA:3.40.50.11660:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111258, NULL, 'G3DSA:2.40.33.10:FF:000021', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(111259, NULL, 'G3DSA:1.10.3210.10:FF:000026', NULL, NULL, 'Metal-dependent phosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(111260, NULL, 'G3DSA:3.30.70.1000:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111261, NULL, 'G3DSA:1.20.1250.20:FF:001131', NULL, NULL, 'Major facilitator superfamily transporter', NULL, NULL, NULL, NULL, NULL, 4),
(111262, NULL, 'G3DSA:3.30.70.1990:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111263, NULL, 'G3DSA:2.60.40.1670:FF:000015', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(111264, NULL, 'G3DSA:2.60.450.10:FF:000001', NULL, NULL, 'Lipopolysaccharide export system protein LptC', NULL, NULL, NULL, NULL, NULL, 4),
(111265, NULL, 'G3DSA:3.20.20.80:FF:000499', NULL, NULL, 'Beta-glucosidase 11', NULL, NULL, NULL, NULL, NULL, 4),
(111266, NULL, 'G3DSA:1.20.1070.10:FF:002013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111267, NULL, 'G3DSA:1.25.10.10:FF:000511', NULL, NULL, 'synembryn-A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(111268, NULL, 'G3DSA:1.10.720.30:FF:000055', NULL, NULL, 'X-ray repair cross-complementing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(111269, NULL, 'G3DSA:3.30.460.10:FF:000207', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(111270, NULL, 'G3DSA:1.10.238.10:FF:000315', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase MINDY-3', NULL, NULL, NULL, NULL, NULL, 4),
(111271, NULL, 'G3DSA:3.30.40.10:FF:001957', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111272, NULL, 'G3DSA:3.40.50.1820:FF:001722', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111273, NULL, 'G3DSA:1.20.5.1190:FF:000010', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(111274, NULL, 'G3DSA:3.90.79.10:FF:000127', NULL, NULL, 'Phosphohydrolase (MutT/nudix family protein)', NULL, NULL, NULL, NULL, NULL, 4),
(111275, NULL, 'G3DSA:1.10.238.10:FF:001243', NULL, NULL, 'S100 calcium-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(111276, NULL, 'G3DSA:3.30.750.24:FF:000052', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(111277, NULL, 'G3DSA:3.30.40.10:FF:001249', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(111278, NULL, 'G3DSA:2.40.170.20:FF:000010', NULL, NULL, 'TonB-linked outer membrane protein, SusC/RagA family', NULL, NULL, NULL, NULL, NULL, 4),
(111279, NULL, 'G3DSA:3.30.160.60:FF:005123', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111280, NULL, 'G3DSA:2.130.10.10:FF:003706', NULL, NULL, 'Transcription initiation factor TFIID subunit', NULL, NULL, NULL, NULL, NULL, 4),
(111281, NULL, 'G3DSA:3.40.1110.10:FF:000302', NULL, NULL, 'Plasma membrane calcium-transporting ATPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(111282, NULL, 'G3DSA:1.20.1080.10:FF:000041', NULL, NULL, 'Aquaglyceroporin 2', NULL, NULL, NULL, NULL, NULL, 4),
(111283, NULL, 'G3DSA:3.80.10.10:FF:000391', NULL, NULL, 'Protein toll', NULL, NULL, NULL, NULL, NULL, 4),
(111284, NULL, 'G3DSA:3.90.660.10:FF:000113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111285, NULL, 'G3DSA:3.30.572.10:FF:000023', NULL, NULL, 'Thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(111286, NULL, 'G3DSA:2.30.30.40:FF:000349', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(111287, NULL, 'G3DSA:3.90.550.10:FF:000431', NULL, NULL, 'Exostosin-2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111288, NULL, 'G3DSA:3.90.70.10:FF:000282', NULL, NULL, 'Calpain-C', NULL, NULL, NULL, NULL, NULL, 4),
(111289, NULL, 'G3DSA:3.90.640.10:FF:000258', NULL, NULL, 'Actin-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(111290, NULL, 'G3DSA:3.30.160.60:FF:003178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111291, NULL, 'G3DSA:3.40.50.1970:FF:000047', NULL, NULL, 'Phosphoribosylamidoimidazole-succinocarboxamide synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111292, NULL, 'G3DSA:3.80.10.10:FF:000767', NULL, NULL, 'F-box/LRR-repeat protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(111293, NULL, 'G3DSA:1.10.287.110:FF:000335', NULL, NULL, 'Chaperone DnaJ-domain superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(111294, NULL, 'G3DSA:3.30.160.60:FF:000452', NULL, NULL, 'Transcription factor Ovo-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(111295, NULL, 'G3DSA:3.40.50.450:FF:000071', NULL, NULL, 'Nucleoside 2-deoxyribosyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(111296, NULL, 'G3DSA:3.30.450.50:FF:000022', NULL, NULL, 'Vesicle-associated membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(111297, NULL, 'G3DSA:3.30.70.80:FF:000041', NULL, NULL, 'Subtilisin-like protease', NULL, NULL, NULL, NULL, NULL, 4),
(111298, NULL, 'G3DSA:2.30.30.560:FF:000004', NULL, NULL, 'Major vault protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111299, NULL, 'G3DSA:1.20.5.110:FF:000205', NULL, NULL, 'Syntaxin 18', NULL, NULL, NULL, NULL, NULL, 4),
(111300, NULL, 'G3DSA:2.10.25.10:FF:000722', NULL, NULL, 'Protein eyes shut homolog', NULL, NULL, NULL, NULL, NULL, 4),
(111301, NULL, 'G3DSA:3.40.1190.20:FF:000231', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111302, NULL, 'G3DSA:3.30.780.10:FF:000046', NULL, NULL, 'Density-regulated protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(111303, NULL, 'G3DSA:3.40.50.300:FF:007782', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111304, NULL, 'G3DSA:3.30.160.60:FF:005831', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111305, NULL, 'G3DSA:1.10.510.10:FF:001904', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111306, NULL, 'G3DSA:3.10.450.50:FF:000032', NULL, NULL, 'Nuclear transport factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(111307, NULL, 'G3DSA:3.40.50.200:FF:000046', NULL, NULL, 'Subtilisin-like protease 3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111308, NULL, 'G3DSA:1.10.238.10:FF:000990', NULL, NULL, 'Calpain 9', NULL, NULL, NULL, NULL, NULL, 4),
(111309, NULL, 'G3DSA:1.10.3430.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111310, NULL, 'G3DSA:1.25.40.20:FF:001180', NULL, NULL, 'Ankyrin repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111311, NULL, 'G3DSA:3.90.1170.40:FF:000011', NULL, NULL, 'MoaD family protein', NULL, NULL, NULL, NULL, NULL, 4),
(111312, NULL, 'G3DSA:3.40.20.10:FF:000005', NULL, NULL, 'Gelsolin', NULL, NULL, NULL, NULL, NULL, 4),
(111313, NULL, 'G3DSA:3.30.200.20:FF:000635', NULL, NULL, 'Wall-associated receptor kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(111314, NULL, 'G3DSA:1.10.287.70:FF:000385', NULL, NULL, 'Voltage-gated sodium channel alpha subunit isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(111315, NULL, 'G3DSA:1.20.1070.10:FF:001737', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111316, NULL, 'G3DSA:2.10.25.10:FF:001122', NULL, NULL, 'Os10g0174548 protein', NULL, NULL, NULL, NULL, NULL, 4),
(111317, NULL, 'G3DSA:1.25.40.10:FF:004554', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111318, NULL, 'G3DSA:3.30.710.10:FF:000188', NULL, NULL, 'Si:rp71-39b20.4', NULL, NULL, NULL, NULL, NULL, 4),
(111319, NULL, 'G3DSA:1.50.10.20:FF:000068', NULL, NULL, 'Protein farnesyltransferase subunit beta', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(111320, NULL, 'G3DSA:1.50.10.10:FF:000155', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(111321, NULL, 'G3DSA:1.25.40.10:FF:004369', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111322, NULL, 'G3DSA:2.60.120.200:FF:000316', NULL, NULL, 'Beta-porphyranase A', NULL, NULL, NULL, NULL, NULL, 4),
(111323, NULL, 'G3DSA:2.60.40.10:FF:003673', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111324, NULL, 'G3DSA:3.40.50.620:FF:000672', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111325, NULL, 'G3DSA:3.40.50.1110:FF:000172', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(111326, NULL, 'G3DSA:1.25.40.20:FF:001741', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(111327, NULL, 'G3DSA:2.20.100.10:FF:000102', NULL, NULL, 'Complement component C6', NULL, NULL, NULL, NULL, NULL, 4),
(111328, NULL, 'G3DSA:1.10.510.10:FF:003669', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111329, NULL, 'G3DSA:1.10.8.430:FF:000005', NULL, NULL, 'Blast resistance protein Pi-ta variant 9', NULL, NULL, NULL, NULL, NULL, 4),
(111330, NULL, 'G3DSA:2.40.70.10:FF:000466', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111331, NULL, 'G3DSA:2.20.25.80:FF:000001', NULL, NULL, 'WRKY transcription factor 33', NULL, NULL, NULL, NULL, NULL, 4),
(111332, NULL, 'G3DSA:3.30.40.10:FF:001581', NULL, NULL, 'E3 ubiquitin-protein ligase RNF12-B', NULL, NULL, NULL, NULL, NULL, 4),
(111333, NULL, 'G3DSA:3.40.50.2300:FF:000506', NULL, NULL, 'Arsenic-transport integral membrane protein ARSC', NULL, NULL, NULL, NULL, NULL, 4),
(111334, NULL, 'G3DSA:1.20.1070.10:FF:001029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111335, NULL, 'G3DSA:3.30.160.60:FF:003886', NULL, NULL, 'Zinc finger protein 532, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(111336, NULL, 'G3DSA:1.20.1050.60:FF:000003', NULL, NULL, 'Alpha-1,2-mannosidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(111337, NULL, 'G3DSA:3.40.570.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111338, NULL, 'G3DSA:3.40.50.300:FF:006798', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(111339, NULL, 'G3DSA:3.40.50.1240:FF:000008', NULL, NULL, 'Ubiquitin associated and SH3 domain containing B', NULL, NULL, NULL, NULL, NULL, 4),
(111340, NULL, 'G3DSA:3.90.180.10:FF:000178', NULL, NULL, 'Sorbitol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(111341, NULL, 'G3DSA:1.25.40.10:FF:000659', NULL, NULL, 'AGAP002752-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(111342, NULL, 'G3DSA:1.25.40.20:FF:000196', NULL, NULL, 'Retinoic acid induced 14', NULL, NULL, NULL, NULL, NULL, 4),
(111343, NULL, 'G3DSA:3.40.50.1010:FF:000136', NULL, NULL, 'DNA-repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111344, NULL, 'G3DSA:3.30.160.60:FF:001121', NULL, NULL, 'zinc finger protein 3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(111345, NULL, 'G3DSA:1.20.1250.10:FF:000054', NULL, NULL, 'Prolactin 2', NULL, NULL, NULL, NULL, NULL, 4),
(111346, NULL, 'G3DSA:2.130.10.10:FF:002217', NULL, NULL, 'Ddb1 and cul4-associated factor 11', NULL, NULL, NULL, NULL, NULL, 4),
(111347, NULL, 'G3DSA:3.40.50.460:FF:000017', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(111348, NULL, 'G3DSA:3.40.50.300:FF:003128', NULL, NULL, 'Rad25/xp-B DNA repair helicase', NULL, NULL, NULL, NULL, NULL, 4),
(111349, NULL, 'G3DSA:2.60.40.10:FF:001576', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(111350, NULL, 'G3DSA:2.130.10.10:FF:002689', NULL, NULL, 'AGAP000480-PA', NULL, NULL, NULL, NULL, NULL, 4),
(111351, NULL, 'G3DSA:1.25.40.10:FF:002020', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g31400, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(111352, NULL, 'G3DSA:1.20.5.170:FF:000301', NULL, NULL, 'Tropomyosin 3', NULL, NULL, NULL, NULL, NULL, 4),
(111353, NULL, 'G3DSA:1.10.10.60:FF:000649', NULL, NULL, 'C. Elegans Homeobox', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(111354, NULL, 'G3DSA:1.10.268.10:FF:000019', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(111355, NULL, 'G3DSA:3.40.50.2000:FF:000450', NULL, NULL, 'Glycosyl transferase group 1', NULL, NULL, NULL, NULL, NULL, 4),
(111356, NULL, 'G3DSA:3.40.367.20:FF:000013', NULL, NULL, 'Glucokinase', NULL, NULL, NULL, NULL, NULL, 4),
(111357, NULL, 'G3DSA:2.160.20.10:FF:000266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111358, NULL, 'G3DSA:3.40.50.620:FF:000852', NULL, NULL, 'Probable isoleucine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(111359, NULL, 'G3DSA:4.10.400.10:FF:000322', NULL, NULL, 'sortilin-related receptor-like', NULL, NULL, NULL, NULL, NULL, 4),
(111360, NULL, 'G3DSA:1.10.3460.10:FF:000005', NULL, NULL, 'Chlorophyll a-b binding protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(111361, NULL, 'G3DSA:2.10.25.10:FF:000161', NULL, NULL, 'Signal peptide, CUB domain and EGF-like domain-containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(111362, NULL, 'G3DSA:1.20.120.1900:FF:000068', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(111363, NULL, 'G3DSA:3.30.450.20:FF:000507', NULL, NULL, 'Sensor protein, DUF3365, HAMP and PAS domain-containing, heme-binding', NULL, NULL, NULL, NULL, NULL, 4),
(111364, NULL, 'G3DSA:2.40.290.10:FF:000044', NULL, NULL, 'ABL117Cp', NULL, NULL, NULL, NULL, NULL, 4),
(111365, NULL, 'G3DSA:3.40.50.1820:FF:000845', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(111366, NULL, 'G3DSA:2.40.10.10:FF:000569', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111367, NULL, 'G3DSA:3.40.1090.10:FF:000069', NULL, NULL, 'Lysophospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(111368, NULL, 'G3DSA:3.30.160.60:FF:005336', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111369, NULL, 'G3DSA:3.30.420.40:FF:000949', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111370, NULL, 'G3DSA:1.10.287.100:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111371, NULL, 'G3DSA:3.30.70.330:FF:003048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111372, NULL, 'G3DSA:1.10.287.540:FF:000003', NULL, NULL, 'Calreticulin', NULL, NULL, NULL, NULL, NULL, 4),
(111373, NULL, 'G3DSA:1.10.30.10:FF:000158', NULL, NULL, 'HMG box family protein', NULL, NULL, NULL, NULL, NULL, 4),
(111374, NULL, 'G3DSA:3.20.20.60:FF:000100', NULL, NULL, 'Malate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(111375, NULL, 'G3DSA:1.20.5.520:FF:000002', NULL, NULL, 'Thymosin beta', NULL, NULL, NULL, NULL, NULL, 4),
(111376, NULL, 'G3DSA:3.40.47.10:FF:000078', NULL, NULL, 'Acetyl-CoA acetyltransferase FadA5', NULL, NULL, NULL, NULL, NULL, 4),
(111377, NULL, 'G3DSA:3.40.50.620:FF:000413', NULL, NULL, 'Two-component sensor KdpD', NULL, NULL, NULL, NULL, NULL, 4),
(111378, NULL, 'G3DSA:2.40.50.40:FF:000058', NULL, NULL, 'Protein SAWADEE HOMEODOMAIN HOMOLOG 1', NULL, NULL, NULL, NULL, NULL, 4),
(111379, NULL, 'G3DSA:2.60.40.1450:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111380, NULL, 'G3DSA:2.40.70.10:FF:000106', NULL, NULL, 'Plasmepsin VII', NULL, NULL, NULL, NULL, NULL, 4),
(111381, NULL, 'G3DSA:3.40.50.300:FF:000374', NULL, NULL, 'ATP-dependent RNA helicase DeaD', NULL, NULL, NULL, NULL, NULL, 4),
(111382, NULL, 'G3DSA:3.30.420.380:FF:000006', NULL, NULL, 'General secretion pathway protein L', NULL, NULL, NULL, NULL, NULL, 4),
(111383, NULL, 'G3DSA:3.30.710.10:FF:000328', NULL, NULL, 'BTB domain containing 6', NULL, NULL, NULL, NULL, NULL, 4),
(111384, NULL, 'G3DSA:3.30.200.20:FF:001304', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(111385, NULL, 'G3DSA:1.20.120.140:FF:000016', NULL, NULL, 'Signal recognition particle receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(111386, NULL, 'G3DSA:1.20.930.40:FF:000021', NULL, NULL, 'Peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(111387, NULL, 'G3DSA:2.130.10.10:FF:001228', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(111388, NULL, 'G3DSA:2.60.120.290:FF:000186', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(111389, NULL, 'G3DSA:3.90.550.10:FF:000583', NULL, NULL, 'Galactosylgalactosylxylosylprotein 3-beta-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(111390, NULL, 'G3DSA:3.40.50.720:FF:002181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111391, NULL, 'G3DSA:1.25.40.10:FF:000507', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(111392, NULL, 'G3DSA:1.10.3380.10:FF:000004', NULL, NULL, 'U5 small nuclear ribonucleoprotein 200 kDa helicase', NULL, NULL, NULL, NULL, NULL, 4),
(111393, NULL, 'G3DSA:2.10.25.10:FF:000902', NULL, NULL, 'AGAP000117-PA', NULL, NULL, NULL, NULL, NULL, 4),
(111394, NULL, 'G3DSA:1.10.532.10:FF:000016', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(111395, NULL, 'G3DSA:1.10.8.60:FF:000221', NULL, NULL, 'Replication factor C subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(111396, NULL, 'G3DSA:3.30.420.40:FF:001034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111397, NULL, 'G3DSA:1.20.1310.10:FF:000104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111398, NULL, 'G3DSA:3.40.50.11850:FF:000009', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(111399, NULL, 'G3DSA:1.10.246.190:FF:000007', NULL, NULL, 'Autophagy protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(111400, NULL, 'G3DSA:2.130.10.10:FF:005983', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111401, NULL, 'G3DSA:3.40.50.300:FF:008030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111402, NULL, 'G3DSA:1.10.167.10:FF:000032', NULL, NULL, 'RSG7', NULL, NULL, NULL, NULL, NULL, 4),
(111403, NULL, 'G3DSA:3.40.20.10:FF:000157', NULL, NULL, 'Glia maturation factor', NULL, NULL, NULL, NULL, NULL, 4),
(111404, NULL, 'G3DSA:1.20.1070.10:FF:001849', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111405, NULL, 'G3DSA:3.30.60.190:FF:000002', NULL, NULL, 'Zinc finger HIT domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(111406, NULL, 'G3DSA:3.40.525.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111407, NULL, 'G3DSA:1.25.10.10:FF:001787', NULL, NULL, 'Protein phosphatase 4, regulatory subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(111408, NULL, 'G3DSA:1.20.1050.10:FF:000005', NULL, NULL, 'Glutathione S-transferase A1', NULL, NULL, NULL, NULL, NULL, 4),
(111409, NULL, 'G3DSA:3.30.2350.10:FF:000069', NULL, NULL, 'H/ACA ribonucleoprotein complex subunit DKC1', NULL, NULL, NULL, NULL, NULL, 4),
(111410, NULL, 'G3DSA:1.20.120.350:FF:000080', NULL, NULL, 'Polycystic kidney disease 2', NULL, NULL, NULL, NULL, NULL, 4),
(111411, NULL, 'G3DSA:1.10.460.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111412, NULL, 'G3DSA:3.40.1090.10:FF:000018', NULL, NULL, 'Lysophospholipase NTE1', NULL, NULL, NULL, NULL, NULL, 4),
(111413, NULL, 'G3DSA:3.30.260.10:FF:000107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111414, NULL, 'G3DSA:3.30.540.10:FF:000096', NULL, NULL, 'Inositol polyphosphate-1-phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111415, NULL, 'G3DSA:1.20.1250.20:FF:001743', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111416, NULL, 'G3DSA:1.10.287.950:FF:000036', NULL, NULL, 'Membrane-anchored chemotaxis sensory transducer', NULL, NULL, NULL, NULL, NULL, 4),
(111417, NULL, 'G3DSA:3.40.1110.10:FF:000162', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(111418, NULL, 'G3DSA:3.90.470.40:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111419, NULL, 'G3DSA:1.20.144.10:FF:000022', NULL, NULL, 'Phospholipid phosphatase 5', NULL, NULL, NULL, NULL, NULL, 4),
(111420, NULL, 'G3DSA:4.10.280.10:FF:000233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(111421, NULL, 'G3DSA:1.50.10.20:FF:000124', NULL, NULL, 'Geranylgeranyl transferase type II beta subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111422, NULL, 'G3DSA:2.40.10.10:FF:000518', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111423, NULL, 'G3DSA:2.30.30.140:FF:000002', NULL, NULL, 'Fragile X mental retardation 1, isoform CRA_e', NULL, NULL, NULL, NULL, NULL, 4),
(111424, NULL, 'G3DSA:2.30.230.10:FF:000025', NULL, NULL, 'Hemolymph clottable protein', NULL, NULL, NULL, NULL, NULL, 4),
(111425, NULL, 'G3DSA:2.60.40.10:FF:001964', NULL, NULL, 'Cilia and flagella associated protein 65', NULL, NULL, NULL, NULL, NULL, 4),
(111426, NULL, 'G3DSA:3.40.50.620:FF:000464', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(111427, NULL, 'G3DSA:1.10.510.10:FF:000443', NULL, NULL, 'Testis-specific serine/threonine-protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(111428, NULL, 'G3DSA:1.10.10.60:FF:001217', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111429, NULL, 'G3DSA:2.40.50.40:FF:000007', NULL, NULL, 'Chromobox protein homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(111430, NULL, 'G3DSA:3.30.40.10:FF:000361', NULL, NULL, 'Tripartite motif-containing protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(111431, NULL, 'G3DSA:3.50.4.10:FF:000008', NULL, NULL, 'No-mechanoreceptor potential A long isoform', NULL, NULL, NULL, NULL, NULL, 4),
(111432, NULL, 'G3DSA:1.20.58.190:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111433, NULL, 'G3DSA:2.60.40.60:FF:001107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111434, NULL, 'G3DSA:1.20.1250.20:FF:000383', NULL, NULL, 'Blast:Monocarboxylate transporter 13', NULL, NULL, NULL, NULL, NULL, 4),
(111435, NULL, 'G3DSA:3.30.160.60:FF:003358', NULL, NULL, 'Zinc finger protein 1164', NULL, NULL, NULL, NULL, NULL, 4),
(111436, NULL, 'G3DSA:3.30.470.20:FF:000250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111437, NULL, 'G3DSA:3.30.70.330:FF:001603', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111438, NULL, 'G3DSA:2.130.10.10:FF:005562', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(111439, NULL, 'G3DSA:2.60.120.590:FF:000006', NULL, NULL, 'AlkB homolog 1, histone H2A dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(111440, NULL, 'G3DSA:4.10.410.10:FF:000087', NULL, NULL, 'Serine peptidase inhibitor, Kunitz type, 2', NULL, NULL, NULL, NULL, NULL, 4),
(111441, NULL, 'G3DSA:3.60.140.10:FF:000013', NULL, NULL, 'Polyphenol oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(111442, NULL, 'G3DSA:1.10.10.1050:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111443, NULL, 'G3DSA:2.40.50.150:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111444, NULL, 'G3DSA:1.50.40.10:FF:000415', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111445, NULL, 'G3DSA:3.40.30.10:FF:000894', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(111446, NULL, 'G3DSA:3.40.50.10420:FF:000030', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(111447, NULL, 'G3DSA:3.50.4.10:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111448, NULL, 'G3DSA:1.20.1420.30:FF:000040', NULL, NULL, 'Probable sodium/calcium exchanger antiporter', NULL, NULL, NULL, NULL, NULL, 4),
(111449, NULL, 'G3DSA:2.40.50.140:FF:000509', NULL, NULL, 'DNA-directed RNA polymerases I, II, and III subunit RPABC3', NULL, NULL, NULL, NULL, NULL, 4),
(111450, NULL, 'G3DSA:3.90.70.80:FF:000055', NULL, NULL, 'OTU domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(111451, NULL, 'G3DSA:3.40.50.300:FF:006113', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111452, NULL, 'G3DSA:3.30.40.10:FF:002177', NULL, NULL, 'Ci-Neuralized-b protein', NULL, NULL, NULL, NULL, NULL, 4),
(111453, NULL, 'G3DSA:3.50.30.50:FF:000006', NULL, NULL, 'Putative_cyclase_-_putative', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(111454, NULL, 'G3DSA:3.40.1170.10:FF:000019', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(111455, NULL, 'G3DSA:1.25.40.10:FF:001064', NULL, NULL, 'Tetratricopeptide repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(111456, NULL, 'G3DSA:2.60.40.10:FF:003993', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111457, NULL, 'G3DSA:3.40.50.300:FF:001734', NULL, NULL, 'Shikimate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(111458, NULL, 'G3DSA:2.40.50.140:FF:001145', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111459, NULL, 'G3DSA:1.20.1250.20:FF:000315', NULL, NULL, 'Glucuronide carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(111460, NULL, 'G3DSA:1.10.287.70:FF:000362', NULL, NULL, 'Potassium channel, subfamily K, member 10', NULL, NULL, NULL, NULL, NULL, 4),
(111461, NULL, 'G3DSA:2.30.30.100:FF:000209', NULL, NULL, 'Small nuclear ribonucleoprotein Sm D2', NULL, NULL, NULL, NULL, NULL, 4),
(111462, NULL, 'G3DSA:3.40.190.290:FF:000125', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(111463, NULL, 'G3DSA:1.10.560.10:FF:000154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111464, NULL, 'G3DSA:1.20.1560.10:FF:000656', NULL, NULL, 'ATP-binding cassette subfamily B member 5', NULL, NULL, NULL, NULL, NULL, 4),
(111465, NULL, 'G3DSA:3.30.70.330:FF:001232', NULL, NULL, 'U2 snRNP auxiliary factor small subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111466, NULL, 'G3DSA:3.30.460.10:FF:000095', NULL, NULL, 'RNA polymerase II, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111467, NULL, 'G3DSA:3.10.310.10:FF:000038', NULL, NULL, '2-methyl-aconitate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(111468, NULL, 'G3DSA:2.60.120.10:FF:000067', NULL, NULL, 'Solute carrier family 9 member C1', NULL, NULL, NULL, NULL, NULL, 4),
(111469, NULL, 'G3DSA:3.30.360.10:FF:000059', NULL, NULL, 'Oxidoreductase, Gfo/Idh/MocA family', NULL, NULL, NULL, NULL, NULL, 4),
(111470, NULL, 'G3DSA:2.60.40.1170:FF:000079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111471, NULL, 'G3DSA:3.40.50.300:FF:002791', NULL, NULL, 'DEAD-box ATP-dependent RNA helicase 17', NULL, NULL, NULL, NULL, NULL, 4),
(111472, NULL, 'G3DSA:2.30.29.30:FF:000242', NULL, NULL, 'serine/threonine-protein kinase MRCK gamma isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(111473, NULL, 'G3DSA:2.60.120.10:FF:000128', NULL, NULL, 'Cyclic nucleotide-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(111474, NULL, 'G3DSA:2.130.10.10:FF:001880', NULL, NULL, 'DDB1-and CUL4-associated factor 13', NULL, NULL, NULL, NULL, NULL, 4),
(111475, NULL, 'G3DSA:3.40.50.720:FF:000264', NULL, NULL, '4-hydroxy-tetrahydrodipicolinate reductase 2 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(111476, NULL, 'G3DSA:2.120.10.30:FF:000548', NULL, NULL, 'Glucose sorbosone dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(111477, NULL, 'G3DSA:2.30.29.30:FF:001231', NULL, NULL, 'Chromosome 15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(111478, NULL, 'G3DSA:3.90.25.10:FF:000031', NULL, NULL, 'UDP-glucose 4-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(111479, NULL, 'G3DSA:3.40.50.300:FF:003280', NULL, NULL, 'Dynein light intermediate chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111480, NULL, 'G3DSA:2.60.40.420:FF:000188', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(111481, NULL, 'G3DSA:3.40.50.300:FF:005106', NULL, NULL, 'Translocase of chloroplast 34 homolog, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(111482, NULL, 'G3DSA:1.10.10.60:FF:000880', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111483, NULL, 'G3DSA:2.40.50.1020:FF:000011', NULL, NULL, 'Two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(111484, NULL, 'G3DSA:3.10.100.10:FF:000376', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111485, NULL, 'G3DSA:2.40.50.770:FF:000024', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(111486, NULL, 'G3DSA:1.10.506.10:FF:000012', NULL, NULL, 'Plexin B1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(111487, NULL, 'G3DSA:3.30.160.60:FF:001913', NULL, NULL, 'Zinc finger with KRAB and SCAN domains 4', NULL, NULL, NULL, NULL, NULL, 4),
(111488, NULL, 'G3DSA:2.130.10.10:FF:005191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111489, NULL, 'G3DSA:3.30.420.10:FF:000261', NULL, NULL, '3''-5'' exonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111490, NULL, 'G3DSA:2.130.10.10:FF:000891', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', NULL, NULL, NULL, NULL, NULL, 4),
(111491, NULL, 'G3DSA:1.10.10.1200:FF:000004', NULL, NULL, 'Melanoma-associated antigen E1', NULL, NULL, NULL, NULL, NULL, 4),
(111492, NULL, 'G3DSA:1.10.1520.10:FF:000095', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(111493, NULL, 'G3DSA:2.60.40.60:FF:000169', NULL, NULL, 'Cadherin 17', NULL, NULL, NULL, NULL, NULL, 4),
(111494, NULL, 'G3DSA:3.30.710.10:FF:000480', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111495, NULL, 'G3DSA:1.10.287.690:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111496, NULL, 'G3DSA:1.20.1110.10:FF:000044', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(111497, NULL, 'G3DSA:1.10.510.10:FF:002860', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111498, NULL, 'G3DSA:3.30.200.20:FF:000399', NULL, NULL, 'Serine/threonine-protein kinase atg1', NULL, NULL, NULL, NULL, NULL, 4),
(111499, NULL, 'G3DSA:1.20.120.1760:FF:000003', NULL, NULL, 'CDP-diacylglycerol--inositol 3-phosphatidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(111500, NULL, 'G3DSA:1.20.1270.60:FF:000250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111501, NULL, 'G3DSA:2.60.34.10:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111502, NULL, 'G3DSA:2.60.120.200:FF:000732', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111503, NULL, 'G3DSA:1.20.120.1780:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111504, NULL, 'G3DSA:1.20.1150.12:FF:000004', NULL, NULL, 'Protein windbeutel', NULL, NULL, NULL, NULL, NULL, 4),
(111505, NULL, 'G3DSA:3.30.470.20:FF:000149', NULL, NULL, 'Ribosomal protein S6 modification protein', NULL, NULL, NULL, NULL, NULL, 4),
(111506, NULL, 'G3DSA:1.25.40.10:FF:002924', NULL, NULL, 'Signal recognition particle subunit SRP72', NULL, NULL, NULL, NULL, NULL, 4),
(111507, NULL, 'G3DSA:3.30.1520.10:FF:000195', NULL, NULL, 'SH3 and PX domains 2B', NULL, NULL, NULL, NULL, NULL, 4),
(111508, NULL, 'G3DSA:2.60.120.650:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111509, NULL, 'G3DSA:3.30.200.20:FF:001355', NULL, NULL, 'Os10g0141200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(111510, NULL, 'G3DSA:2.60.40.60:FF:000669', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(111511, NULL, 'G3DSA:3.30.160.60:FF:001172', NULL, NULL, 'Zinc finger protein rotund', NULL, NULL, NULL, NULL, NULL, 4),
(111512, NULL, 'G3DSA:3.30.390.30:FF:000005', NULL, NULL, 'Flavoprotein disulfide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(111513, NULL, 'G3DSA:1.10.238.10:FF:000310', NULL, NULL, 'Solute carrier family 25 (Mitochondrial phosphate transporter), member 23/24/25/41', NULL, NULL, NULL, NULL, NULL, 4),
(111514, NULL, 'G3DSA:3.40.50.300:FF:007462', NULL, NULL, 'U3 small nucleolar RNA-associated protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(111515, NULL, 'G3DSA:3.30.2400.10:FF:000001', NULL, NULL, 'Major capsid subunit', NULL, NULL, NULL, NULL, NULL, 4),
(111516, NULL, 'G3DSA:3.40.50.200:FF:000102', NULL, NULL, 'Subtilisin-like serine peptidase (Serine peptidase, clan sb, family s8-like protein)', NULL, NULL, NULL, NULL, NULL, 4),
(111517, NULL, 'G3DSA:2.130.10.10:FF:003566', NULL, NULL, 'Autophagy-related protein 16-2', NULL, NULL, NULL, NULL, NULL, 4),
(111518, NULL, 'G3DSA:2.170.270.10:FF:000017', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(111519, NULL, 'G3DSA:1.10.150.80:FF:000048', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(111520, NULL, 'G3DSA:3.80.10.10:FF:003757', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(111521, NULL, 'G3DSA:2.60.40.10:FF:005679', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111522, NULL, 'G3DSA:2.60.40.200:FF:000010', NULL, NULL, 'Copper-zinc superoxide dismutase 1', NULL, NULL, NULL, NULL, NULL, 4),
(111523, NULL, 'G3DSA:3.40.190.10:FF:000465', NULL, NULL, 'Peptide ABC transporter, solute-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(111524, NULL, 'G3DSA:3.40.630.30:FF:000640', NULL, NULL, 'Acetyltransferase, GNAT family protein', NULL, NULL, NULL, NULL, NULL, 4),
(111525, NULL, 'G3DSA:1.10.560.10:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111526, NULL, 'G3DSA:1.25.40.20:FF:000836', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111527, NULL, 'G3DSA:2.130.10.10:FF:005039', NULL, NULL, 'EMC Endoplasmic Membrane protein Complex (Yeast EMC) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(111528, NULL, 'G3DSA:3.30.420.10:FF:000210', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(111529, NULL, 'G3DSA:1.10.260.40:FF:000005', NULL, NULL, 'One cut domain family member', NULL, NULL, NULL, NULL, NULL, 4),
(111530, NULL, 'G3DSA:3.40.50.800:FF:000041', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(111531, NULL, 'G3DSA:3.30.565.10:FF:000355', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111532, NULL, 'G3DSA:3.40.50.300:FF:005157', NULL, NULL, 'YALI0D24123p', NULL, NULL, NULL, NULL, NULL, 4),
(111533, NULL, 'G3DSA:3.40.50.10810:FF:000265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111534, NULL, 'G3DSA:3.30.70.141:FF:000013', NULL, NULL, 'Nucleoside diphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(111535, NULL, 'G3DSA:1.20.1420.30:FF:000091', NULL, NULL, 'Potassium-dependent sodium-calcium exchanger, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111536, NULL, 'G3DSA:3.40.30.10:FF:000034', NULL, NULL, 'glutathione S-transferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(111537, NULL, 'G3DSA:3.40.50.2300:FF:001226', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111538, NULL, 'G3DSA:3.40.50.150:FF:001649', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111539, NULL, 'G3DSA:3.60.10.10:FF:000280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111540, NULL, 'G3DSA:1.25.10.10:FF:000798', NULL, NULL, 'Armadillo repeat-containing protein gudu', NULL, NULL, NULL, NULL, NULL, 4),
(111541, NULL, 'G3DSA:1.10.150.60:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111542, NULL, 'G3DSA:1.10.640.10:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111543, NULL, 'G3DSA:3.40.50.300:FF:007523', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111544, NULL, 'G3DSA:3.40.430.10:FF:000001', NULL, NULL, 'Dihydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(111545, NULL, 'G3DSA:3.40.50.300:FF:000778', NULL, NULL, 'GTP-binding protein YjiA', NULL, NULL, NULL, NULL, NULL, 4),
(111546, NULL, 'G3DSA:2.60.120.200:FF:000783', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111547, NULL, 'G3DSA:1.20.910.10:FF:000027', NULL, NULL, 'Transcriptional activator, TenA family', NULL, NULL, NULL, NULL, NULL, 4),
(111548, NULL, 'G3DSA:2.130.10.10:FF:002285', NULL, NULL, 'Peptide deformylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(111549, NULL, 'G3DSA:1.25.40.20:FF:001325', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111550, NULL, 'G3DSA:3.20.20.330:FF:000027', NULL, NULL, 'Homocysteine S-methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111551, NULL, 'G3DSA:1.10.132.30:FF:000014', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(111552, NULL, 'G3DSA:3.30.160.60:FF:000957', NULL, NULL, 'Zinc finger protein 12', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(111553, NULL, 'G3DSA:3.30.70.330:FF:002660', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111554, NULL, 'G3DSA:3.50.50.60:FF:001258', NULL, NULL, 'Invasion protein IbeA', NULL, NULL, NULL, NULL, NULL, 4),
(111555, NULL, 'G3DSA:3.30.160.60:FF:003419', NULL, NULL, 'FI01202p', NULL, NULL, NULL, NULL, NULL, 4),
(111556, NULL, 'G3DSA:3.40.50.720:FF:002242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111557, NULL, 'G3DSA:1.10.510.10:FF:003557', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111558, NULL, 'G3DSA:3.90.70.30:FF:000001', NULL, NULL, 'Glutathione gamma-glutamylcysteinyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(111559, NULL, 'G3DSA:3.30.470.30:FF:000039', NULL, NULL, 'AGAP000623-PA', NULL, NULL, NULL, NULL, NULL, 4),
(111560, NULL, 'G3DSA:2.60.120.10:FF:000516', NULL, NULL, '3-mercaptopropionate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(111561, NULL, 'G3DSA:3.40.50.1820:FF:000733', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(111562, NULL, 'G3DSA:1.20.1070.10:FF:001024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111563, NULL, 'G3DSA:3.40.50.150:FF:001728', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111564, NULL, 'G3DSA:3.40.30.10:FF:000394', NULL, NULL, 'Gdap1, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(111565, NULL, 'G3DSA:3.30.420.40:FF:000837', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(111566, NULL, 'G3DSA:1.10.238.10:FF:001248', NULL, NULL, 'Calcium-binding protein A', NULL, NULL, NULL, NULL, NULL, 4),
(111567, NULL, 'G3DSA:3.30.450.20:FF:000619', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111568, NULL, 'G3DSA:2.40.128.20:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111569, NULL, 'G3DSA:3.40.50.1820:FF:001301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111570, NULL, 'G3DSA:3.40.50.2020:FF:000052', NULL, NULL, 'Orotate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(111571, NULL, 'G3DSA:3.40.50.10140:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111572, NULL, 'G3DSA:3.30.1120.10:FF:000018', NULL, NULL, 'N-acetylgalactosamine 6-sulfate sulfatase (GALNS)', NULL, NULL, NULL, NULL, NULL, 4),
(111573, NULL, 'G3DSA:3.20.20.220:FF:000062', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(111574, NULL, 'G3DSA:2.130.10.10:FF:002577', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111575, NULL, 'G3DSA:3.40.50.140:FF:000011', NULL, NULL, 'DNA topoisomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(111576, NULL, 'G3DSA:2.60.120.200:FF:000491', NULL, NULL, 'Peptidase M23B', NULL, NULL, NULL, NULL, NULL, 4),
(111577, NULL, 'G3DSA:3.30.70.330:FF:002952', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111578, NULL, 'G3DSA:1.25.40.10:FF:003121', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g79490, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(111579, NULL, 'G3DSA:2.60.40.10:FF:004398', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111580, NULL, 'G3DSA:3.40.50.300:FF:002291', NULL, NULL, 'GTP-binding protein 1 (G-protein 1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(111581, NULL, 'G3DSA:1.25.40.20:FF:000044', NULL, NULL, 'CAP-Gly domain containing linker protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(111582, NULL, 'G3DSA:1.10.10.540:FF:000014', NULL, NULL, 'Ubiquitin receptor RAD23c', NULL, NULL, NULL, NULL, NULL, 4),
(111583, NULL, 'G3DSA:3.30.420.40:FF:000096', NULL, NULL, 'xylulose kinase', NULL, NULL, NULL, NULL, NULL, 4),
(111584, NULL, 'G3DSA:3.20.20.60:FF:000021', NULL, NULL, 'CoA ester lyase', NULL, NULL, NULL, NULL, NULL, 4),
(111585, NULL, 'G3DSA:3.40.50.300:FF:007574', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(111586, NULL, 'G3DSA:3.40.50.720:FF:002585', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111587, NULL, 'G3DSA:1.20.120.20:FF:000032', NULL, NULL, 'Apolipoprotein E', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(111588, NULL, 'G3DSA:3.30.160.60:FF:005887', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111589, NULL, 'G3DSA:3.40.390.10:FF:000042', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(111590, NULL, 'G3DSA:3.40.630.40:FF:000025', NULL, NULL, 'Putative N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(111591, NULL, 'G3DSA:3.40.50.150:FF:000340', NULL, NULL, 'Ubiquinone/menaquinone biosynthesis methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(111592, NULL, 'G3DSA:3.30.1370.100:FF:000026', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(111593, NULL, 'G3DSA:2.60.34.10:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111594, NULL, 'G3DSA:1.20.120.610:FF:000028', NULL, NULL, 'V-type proton ATPase proteolipid subunit', NULL, NULL, NULL, NULL, NULL, 4),
(111595, NULL, 'G3DSA:3.90.650.10:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111596, NULL, 'G3DSA:3.20.20.60:FF:000049', NULL, NULL, 'HpcH/HpaI aldolase/citrate lyase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(111597, NULL, 'G3DSA:3.20.20.80:FF:000027', NULL, NULL, 'Alpha-L-fucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(111598, NULL, 'G3DSA:3.30.200.20:FF:001804', NULL, NULL, 'Protein CBR-ZYG-8', NULL, NULL, NULL, NULL, NULL, 4),
(111599, NULL, 'G3DSA:1.10.1520.10:FF:000044', NULL, NULL, 'Putative RNase III', NULL, NULL, NULL, NULL, NULL, 4),
(111600, NULL, 'G3DSA:1.10.287.810:FF:000011', NULL, NULL, 'Mitochondrial regulator of splicing 5', NULL, NULL, NULL, NULL, NULL, 4),
(111601, NULL, 'G3DSA:3.80.10.10:FF:000891', NULL, NULL, 'adhesion G protein-coupled receptor A2', NULL, NULL, NULL, NULL, NULL, 4),
(111602, NULL, 'G3DSA:1.25.40.20:FF:001893', NULL, NULL, 'Transient receptor potential cation channel subfamily A member 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(111603, NULL, 'G3DSA:1.25.10.10:FF:001236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111604, NULL, 'G3DSA:3.90.640.10:FF:000022', NULL, NULL, 'heat shock 70 kDa protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(111605, NULL, 'G3DSA:1.25.40.20:FF:000432', NULL, NULL, 'E3 ubiquitin-protein ligase KEG', NULL, NULL, NULL, NULL, NULL, 4),
(111606, NULL, 'G3DSA:3.30.810.10:FF:000021', NULL, NULL, 'Phosphatidylinositol-4-phosphate 5-kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111607, NULL, 'G3DSA:3.80.10.10:FF:003353', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111608, NULL, 'G3DSA:1.25.40.10:FF:002845', NULL, NULL, 'Clustered mitochondria protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(111609, NULL, 'G3DSA:1.25.40.20:FF:000336', NULL, NULL, 'Ankyrin repeat domain-containing protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(111610, NULL, 'G3DSA:3.30.160.60:FF:001672', NULL, NULL, 'Zinc finger protein 614', NULL, NULL, NULL, NULL, NULL, 4),
(111611, NULL, 'G3DSA:2.10.25.10:FF:000514', NULL, NULL, 'prolow-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(111612, NULL, 'G3DSA:2.90.10.10:FF:000016', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(111613, NULL, 'G3DSA:1.10.510.10:FF:003265', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111614, NULL, 'G3DSA:1.10.238.10:FF:001299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111615, NULL, 'G3DSA:3.40.50.80:FF:000045', NULL, NULL, 'NADPH-cytochrome p450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(111616, NULL, 'G3DSA:2.70.20.10:FF:000012', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(111617, NULL, 'G3DSA:3.90.226.10:FF:000217', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(111618, NULL, 'G3DSA:3.30.160.60:FF:001964', NULL, NULL, 'Zinc finger protein 547', NULL, NULL, NULL, NULL, NULL, 4),
(111619, NULL, 'G3DSA:3.30.40.10:FF:001721', NULL, NULL, 'TNF receptor-associated factor 1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(111620, NULL, 'G3DSA:3.90.850.10:FF:000027', NULL, NULL, 'Fumarylacetoacetate_(FAA)_hydrolase_family_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(111621, NULL, 'G3DSA:2.30.29.30:FF:000663', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111622, NULL, 'G3DSA:1.20.1070.10:FF:000748', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(111623, NULL, 'G3DSA:3.40.50.300:FF:001442', NULL, NULL, 'Si:ch211-106j21.4', NULL, NULL, NULL, NULL, NULL, 4),
(111624, NULL, 'G3DSA:3.30.260.10:FF:000046', NULL, NULL, 'Chaperonin containing TCP1 subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(111625, NULL, 'G3DSA:3.40.50.12470:FF:000015', NULL, NULL, 'Dehydrogenase E1 and transketolase domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(111626, NULL, 'G3DSA:3.30.160.60:FF:005275', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111627, NULL, 'G3DSA:1.20.1110.10:FF:000095', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit alpha-1', NULL, NULL, NULL, NULL, NULL, 4),
(111628, NULL, 'G3DSA:3.30.40.10:FF:000209', NULL, NULL, 'E3 ubiquitin-protein ligase MARCH4', NULL, NULL, NULL, NULL, NULL, 4),
(111629, NULL, 'G3DSA:3.90.1300.10:FF:000030', NULL, NULL, 'Putative amidase C869.01', NULL, NULL, NULL, NULL, NULL, 4),
(111630, NULL, 'G3DSA:1.10.10.10:FF:000707', NULL, NULL, 'Vacuolar membrane-associated protein iml1', NULL, NULL, NULL, NULL, NULL, 4),
(111631, NULL, 'G3DSA:3.40.50.2300:FF:001147', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111632, NULL, 'G3DSA:4.10.1240.10:FF:000008', NULL, NULL, 'pituitary adenylate cyclase-activating polypeptide type I receptor', NULL, NULL, NULL, NULL, NULL, 4),
(111633, NULL, 'G3DSA:3.90.1200.10:FF:000045', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(111634, NULL, 'G3DSA:3.30.420.40:FF:000045', NULL, NULL, 'Glucokinase', NULL, NULL, NULL, NULL, NULL, 4),
(111635, NULL, 'G3DSA:3.30.160.60:FF:003830', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111636, NULL, 'G3DSA:2.40.10.10:FF:000069', NULL, NULL, 'Hyaluronan-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(111637, NULL, 'G3DSA:3.40.1690.20:FF:000016', NULL, NULL, 'Mitochondrial respiratory chain complexes assembly protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111638, NULL, 'G3DSA:3.30.43.10:FF:000042', NULL, NULL, 'Putative FAD-dependent oxygenase EncM', NULL, NULL, NULL, NULL, NULL, 4),
(111639, NULL, 'G3DSA:1.20.5.340:FF:000100', NULL, NULL, 'Outer capsid protein sigma-1', NULL, NULL, NULL, NULL, NULL, 4),
(111640, NULL, 'G3DSA:3.80.10.10:FF:001228', NULL, NULL, 'Outer_row_dynein-assembly_protein_7', NULL, NULL, NULL, NULL, NULL, 4),
(111641, NULL, 'G3DSA:1.50.40.10:FF:000483', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111642, NULL, 'G3DSA:3.20.20.100:FF:000043', NULL, NULL, 'Pyridoxal reductase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(111643, NULL, 'G3DSA:3.40.50.970:FF:000046', NULL, NULL, '2-hydroxyacyl-CoA lyase 1', NULL, NULL, NULL, NULL, NULL, 4),
(111644, NULL, 'G3DSA:3.70.10.10:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111645, NULL, 'G3DSA:1.25.40.10:FF:004841', NULL, NULL, 'Pre-mRNA-splicing factor CLF1', NULL, NULL, NULL, NULL, NULL, 4),
(111646, NULL, 'G3DSA:2.120.10.30:FF:000127', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(111647, NULL, 'G3DSA:3.40.50.720:FF:000556', NULL, NULL, 'Proline utilization protein PrnX-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(111648, NULL, 'G3DSA:3.90.650.10:FF:000028', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(111649, NULL, 'G3DSA:3.40.50.300:FF:003651', NULL, NULL, 'GM24810', NULL, NULL, NULL, NULL, NULL, 4),
(111650, NULL, 'G3DSA:3.10.20.90:FF:001014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111651, NULL, 'G3DSA:3.40.50.150:FF:001700', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111652, NULL, 'G3DSA:3.30.160.60:FF:003650', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(111653, NULL, 'G3DSA:3.30.70.330:FF:000355', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(111654, NULL, 'G3DSA:2.60.40.10:FF:003881', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111655, NULL, 'G3DSA:1.10.287.3240:FF:000033', NULL, NULL, 'V-type proton ATPase subunit D 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(111656, NULL, 'G3DSA:3.90.230.10:FF:000036', NULL, NULL, 'X-Pro dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(111657, NULL, 'G3DSA:1.20.920.30:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111658, NULL, 'G3DSA:1.20.920.10:FF:000213', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(111659, NULL, 'G3DSA:3.40.50.300:FF:005545', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111660, NULL, 'G3DSA:3.30.160.60:FF:001093', NULL, NULL, 'Zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(111661, NULL, 'G3DSA:3.30.70.340:FF:000004', NULL, NULL, 'Carboxypeptidase A6', NULL, NULL, NULL, NULL, NULL, 4),
(111662, NULL, 'G3DSA:3.30.428.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111663, NULL, 'G3DSA:2.60.40.10:FF:004370', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111664, NULL, 'G3DSA:1.10.472.10:FF:000466', NULL, NULL, 'Cyclin-dependent protein kinase complex component, putative (AFU_orthologue AFUA_2G07660)', NULL, NULL, NULL, NULL, NULL, 4),
(111665, NULL, 'G3DSA:3.30.160.60:FF:001621', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111666, NULL, 'G3DSA:1.10.1380.10:FF:000004', NULL, NULL, 'phosphate-regulating neutral endopeptidase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(111667, NULL, 'G3DSA:1.10.8.60:FF:000160', NULL, NULL, 'WGS project CABT00000000 data, contig 2.55', NULL, NULL, NULL, NULL, NULL, 4),
(111668, NULL, 'G3DSA:3.30.200.20:FF:001276', NULL, NULL, 'Ste20-like kinase, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(111669, NULL, 'G3DSA:2.60.40.60:FF:001046', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(111670, NULL, 'G3DSA:3.50.50.60:FF:001354', NULL, NULL, 'FAD-binding monooxygenase ausC', NULL, NULL, NULL, NULL, NULL, 4),
(111671, NULL, 'G3DSA:2.10.25.10:FF:000222', NULL, NULL, 'Latent transforming growth factor beta binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(111672, NULL, 'G3DSA:1.10.1420.10:FF:000160', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(111673, NULL, 'G3DSA:1.10.486.10:FF:000048', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(111674, NULL, 'G3DSA:3.40.50.300:FF:000874', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(111675, NULL, 'G3DSA:2.60.40.150:FF:000652', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(111676, NULL, 'G3DSA:3.10.490.20:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111677, NULL, 'G3DSA:1.25.40.10:FF:005330', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g52620', NULL, NULL, NULL, NULL, NULL, 4),
(111678, NULL, 'G3DSA:1.10.418.10:FF:000228', NULL, NULL, 'Plectin', NULL, NULL, NULL, NULL, NULL, 4),
(111679, NULL, 'G3DSA:3.40.190.10:FF:000386', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(111680, NULL, 'G3DSA:3.40.50.2300:FF:000658', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(111681, NULL, 'G3DSA:2.40.150.20:FF:000003', NULL, NULL, '60S ribosomal protein L23', NULL, NULL, NULL, NULL, NULL, 4),
(111682, NULL, 'G3DSA:3.90.730.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111683, NULL, 'G3DSA:1.25.40.10:FF:003329', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(111684, NULL, 'G3DSA:3.40.50.200:FF:000018', NULL, NULL, 'Type VII secretion-associated serine protease mycosin', NULL, NULL, NULL, NULL, NULL, 4),
(111685, NULL, 'G3DSA:1.10.3720.10:FF:000104', NULL, NULL, 'Peptide ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(111686, NULL, 'G3DSA:2.170.270.10:FF:000085', NULL, NULL, 'Histone-lysine N-methyltransferase family member SUVH9', NULL, NULL, NULL, NULL, NULL, 4),
(111687, NULL, 'G3DSA:3.30.1240.20:FF:000002', NULL, NULL, 'Phosphomannomutase', NULL, NULL, NULL, NULL, NULL, 4),
(111688, NULL, 'G3DSA:3.80.10.10:FF:001279', NULL, NULL, 'Nuclear RNA export factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(111689, NULL, 'G3DSA:1.10.287.70:FF:000070', NULL, NULL, 'Potassium channel, subfamily K, member 12 like', NULL, NULL, NULL, NULL, NULL, 4),
(111690, NULL, 'G3DSA:3.80.10.10:FF:001015', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(111691, NULL, 'G3DSA:1.10.10.10:FF:001556', NULL, NULL, 'Adenosine deaminase, RNA-specific', NULL, NULL, NULL, NULL, NULL, 4),
(111692, NULL, 'G3DSA:2.40.50.140:FF:001066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111693, NULL, 'G3DSA:1.10.630.10:FF:000311', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111694, NULL, 'G3DSA:4.10.240.10:FF:000175', NULL, NULL, 'Submerged protoperithecia-2', NULL, NULL, NULL, NULL, NULL, 4),
(111695, NULL, 'G3DSA:1.10.8.10:FF:000055', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(111696, NULL, 'G3DSA:3.40.50.720:FF:002293', NULL, NULL, 'dTDP-glucose 4-6-dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(111697, NULL, 'G3DSA:1.25.10.10:FF:001675', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111698, NULL, 'G3DSA:3.40.50.2000:FF:000719', NULL, NULL, 'Lipopolysaccharide core biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(111699, NULL, 'G3DSA:2.10.110.10:FF:000156', NULL, NULL, 'LIM Zinc finger domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(111700, NULL, 'G3DSA:1.20.82.10:FF:000002', NULL, NULL, 'ADP-ribosyl cyclase isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(111701, NULL, 'G3DSA:3.10.250.10:FF:000100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111702, NULL, 'G3DSA:1.10.630.10:FF:000339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111703, NULL, 'G3DSA:3.80.10.10:FF:000739', NULL, NULL, 'Leucine rich repeat neuronal 4', NULL, NULL, NULL, NULL, NULL, 4),
(111704, NULL, 'G3DSA:1.10.510.10:FF:001399', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(111705, NULL, 'G3DSA:1.20.1250.20:FF:000883', NULL, NULL, 'AGAP012371-PA', NULL, NULL, NULL, NULL, NULL, 4),
(111706, NULL, 'G3DSA:2.130.10.10:FF:003645', NULL, NULL, 'WD-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111707, NULL, 'G3DSA:3.30.160.60:FF:002110', NULL, NULL, 'Zinc finger protein 1053', NULL, NULL, NULL, NULL, NULL, 4),
(111708, NULL, 'G3DSA:3.20.20.70:FF:000378', NULL, NULL, 'Thiazole synthase', NULL, NULL, NULL, NULL, NULL, 4),
(111709, NULL, 'G3DSA:1.25.10.10:FF:003361', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111710, NULL, 'G3DSA:3.30.200.20:FF:000787', NULL, NULL, 'Protein kinase, putative (AFU_orthologue AFUA_2G16620)', NULL, NULL, NULL, NULL, NULL, 4),
(111711, NULL, 'G3DSA:3.30.1740.10:FF:000026', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(111712, NULL, 'G3DSA:3.30.760.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111713, NULL, 'G3DSA:3.30.710.10:FF:000036', NULL, NULL, 'Mod(Mdg4), isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(111714, NULL, 'G3DSA:3.30.230.10:FF:000286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111715, NULL, 'G3DSA:2.170.150.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111716, NULL, 'G3DSA:3.40.33.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111717, NULL, 'G3DSA:1.25.40.10:FF:003481', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(111718, NULL, 'G3DSA:3.40.50.200:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(111719, NULL, 'G3DSA:1.20.58.60:FF:000163', NULL, NULL, 'spectrin alpha chain, erythrocytic 1', NULL, NULL, NULL, NULL, NULL, 4),
(111720, NULL, 'G3DSA:3.30.710.10:FF:000249', NULL, NULL, 'WGS project CABT00000000 data, contig 2.12', NULL, NULL, NULL, NULL, NULL, 4),
(111721, NULL, 'G3DSA:1.20.1250.20:FF:002199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111722, NULL, 'G3DSA:2.30.30.140:FF:000114', NULL, NULL, 'RING finger protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(111723, NULL, 'G3DSA:1.10.20.10:FF:000040', NULL, NULL, 'TAF6-like RNA polymerase II p300/CBP-associated factor-associated factor 65 kDa subunit 6L', NULL, NULL, NULL, NULL, NULL, 4),
(111724, NULL, 'G3DSA:1.10.620.20:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111725, NULL, 'G3DSA:2.130.10.10:FF:004134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111726, NULL, 'G3DSA:1.10.565.10:FF:000030', NULL, NULL, 'Ecdysone receptor (Isoform A)', NULL, NULL, NULL, NULL, NULL, 4),
(111727, NULL, 'G3DSA:2.40.50.140:FF:000577', NULL, NULL, '50S ribosomal protein L2', NULL, NULL, NULL, NULL, NULL, 4),
(111728, NULL, 'G3DSA:2.60.120.200:FF:000440', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(111729, NULL, 'G3DSA:3.30.1610.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111730, NULL, 'G3DSA:2.60.40.10:FF:000115', NULL, NULL, 'filamin-C isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(111731, NULL, 'G3DSA:3.30.200.20:FF:001063', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(111732, NULL, 'G3DSA:3.30.420.10:FF:000502', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111733, NULL, 'G3DSA:3.40.1020.10:FF:000003', NULL, NULL, 'Threonine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(111734, NULL, 'G3DSA:2.60.40.10:FF:001525', NULL, NULL, 'Immunoglobulin-like and fibronectin type III domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(111735, NULL, 'G3DSA:3.70.10.10:FF:000060', NULL, NULL, 'Checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(111736, NULL, 'G3DSA:1.25.40.90:FF:000025', NULL, NULL, 'ENTH domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(111737, NULL, 'G3DSA:3.30.70.330:FF:002772', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111738, NULL, 'G3DSA:3.30.70.1620:FF:000007', NULL, NULL, 'Structural maintenance of chromosomes protein', NULL, NULL, NULL, NULL, NULL, 4),
(111739, NULL, 'G3DSA:3.30.70.660:FF:000050', NULL, NULL, 'tRNA pseudouridine synthase A-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(111740, NULL, 'G3DSA:3.30.420.10:FF:000710', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111741, NULL, 'G3DSA:3.30.200.100:FF:000002', NULL, NULL, 'Sigma-E factor regulatory protein RseB', NULL, NULL, NULL, NULL, NULL, 4),
(111742, NULL, 'G3DSA:3.40.50.150:FF:001357', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111743, NULL, 'G3DSA:1.25.10.10:FF:002804', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111744, NULL, 'G3DSA:3.40.50.300:FF:000666', NULL, NULL, 'ATP-dependent RNA helicase DDX50', NULL, NULL, NULL, NULL, NULL, 4),
(111745, NULL, 'G3DSA:1.10.10.10:FF:001495', NULL, NULL, 'Cullin', NULL, NULL, NULL, NULL, NULL, 4),
(111746, NULL, 'G3DSA:3.40.50.2000:FF:000158', NULL, NULL, 'UDP-glucuronosyltransferase 2A1', NULL, NULL, NULL, NULL, NULL, 4),
(111747, NULL, 'G3DSA:2.10.10.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111748, NULL, 'G3DSA:3.30.60.20:FF:000129', NULL, NULL, 'AGAP006932-PA', NULL, NULL, NULL, NULL, NULL, 4),
(111749, NULL, 'G3DSA:2.130.10.10:FF:002397', NULL, NULL, 'Cilia and flagella associated protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(111750, NULL, 'G3DSA:1.20.5.480:FF:000001', NULL, NULL, 'Formate dehydrogenase iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4),
(111751, NULL, 'G3DSA:3.40.50.2300:FF:000719', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111752, NULL, 'G3DSA:2.60.40.10:FF:001868', NULL, NULL, 'Down syndrome cell adhesion molecule', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(111753, NULL, 'G3DSA:2.60.40.10:FF:004038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111754, NULL, 'G3DSA:3.90.190.10:FF:000032', NULL, NULL, 'dual specificity protein phosphatase CDC14A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(111755, NULL, 'G3DSA:3.40.50.300:FF:000082', NULL, NULL, 'ISWI chromatin remodeling complex ATPase ISW1', NULL, NULL, NULL, NULL, NULL, 4),
(111756, NULL, 'G3DSA:3.40.50.2020:FF:000164', NULL, NULL, 'Ribose-phosphate pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(111757, NULL, 'G3DSA:1.10.238.10:FF:001327', NULL, NULL, 'Calpain-B-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(111758, NULL, 'G3DSA:2.60.120.10:FF:000628', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111759, NULL, 'G3DSA:3.30.1330.10:FF:000040', NULL, NULL, 'Hydrogenase expression/formation protein HypE', NULL, NULL, NULL, NULL, NULL, 4),
(111760, NULL, 'G3DSA:2.40.10.10:FF:000277', NULL, NULL, 'Trypsin domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(111761, NULL, 'G3DSA:2.60.40.1910:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111762, NULL, 'G3DSA:3.90.79.10:FF:000178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111763, NULL, 'G3DSA:1.20.1080.10:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111764, NULL, 'G3DSA:3.30.160.60:FF:005095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111765, NULL, 'G3DSA:1.20.5.190:FF:000015', NULL, NULL, 'IQ motif containing F5', NULL, NULL, NULL, NULL, NULL, 4),
(111766, NULL, 'G3DSA:1.10.390.10:FF:000062', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(111767, NULL, 'G3DSA:3.30.1300.10:FF:000004', NULL, NULL, 'Pantothenate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(111768, NULL, 'G3DSA:3.30.1220.10:FF:000003', NULL, NULL, 'YNR029C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(111769, NULL, 'G3DSA:2.20.100.10:FF:000254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111770, NULL, 'G3DSA:3.40.50.2300:FF:001670', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111771, NULL, 'G3DSA:3.40.228.10:FF:000025', NULL, NULL, 'Molybdopterin oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(111772, NULL, 'G3DSA:1.10.10.790:FF:000004', NULL, NULL, 'SURP and G-patch domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(111773, NULL, 'G3DSA:1.10.238.10:FF:000231', NULL, NULL, 'Calmodulin-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(111774, NULL, 'G3DSA:1.20.58.60:FF:000455', NULL, NULL, 'Dystrophin-1', NULL, NULL, NULL, NULL, NULL, 4),
(111775, NULL, 'G3DSA:1.25.40.10:FF:003301', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(111776, NULL, 'G3DSA:3.50.50.60:FF:001146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111777, NULL, 'G3DSA:2.60.40.10:FF:003381', NULL, NULL, 'Immunoglobulin heavy constant delta', NULL, NULL, NULL, NULL, NULL, 4),
(111778, NULL, 'G3DSA:2.60.120.650:FF:000226', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(111779, NULL, 'G3DSA:2.130.10.10:FF:002509', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(111780, NULL, 'G3DSA:3.30.420.40:FF:000657', NULL, NULL, 'Actin-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(111781, NULL, 'G3DSA:3.30.70.330:FF:000743', NULL, NULL, 'Similar to R3H domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(111782, NULL, 'G3DSA:2.10.25.10:FF:000453', NULL, NULL, 'Adhesion G protein-coupled receptor E1', NULL, NULL, NULL, NULL, NULL, 4),
(111783, NULL, 'G3DSA:2.130.10.10:FF:000368', NULL, NULL, 'Peptidylprolyl isomerase domain and WD repeat-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(111784, NULL, 'G3DSA:2.30.30.60:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111785, NULL, 'G3DSA:3.30.160.60:FF:002402', NULL, NULL, 'Zinc finger protein 347', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(111786, NULL, 'G3DSA:1.10.287.470:FF:000038', NULL, NULL, 'Efflux transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(111787, NULL, 'G3DSA:1.10.10.60:FF:000357', NULL, NULL, 'Motor neuron and pancreas homeobox 1', NULL, NULL, NULL, NULL, NULL, 4),
(111788, NULL, 'G3DSA:1.20.1050.130:FF:000038', NULL, NULL, 'Bifunctional glutamate/proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(111789, NULL, 'G3DSA:3.40.1160.10:FF:000013', NULL, NULL, 'Delta-1-pyrroline-5-carboxylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(111790, NULL, 'G3DSA:3.30.160.60:FF:003881', NULL, NULL, 'GD10245', NULL, NULL, NULL, NULL, NULL, 4),
(111791, NULL, 'G3DSA:3.30.200.20:FF:000287', NULL, NULL, 'Cell division cycle 7-related protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(111792, NULL, 'G3DSA:1.10.287.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111793, NULL, 'G3DSA:1.10.8.590:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111794, NULL, 'G3DSA:1.10.10.10:FF:002012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111795, NULL, 'G3DSA:2.60.40.10:FF:005730', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111796, NULL, 'G3DSA:1.10.510.10:FF:000151', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(111797, NULL, 'G3DSA:3.40.50.11350:FF:000005', NULL, NULL, 'O-fucosyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(111798, NULL, 'G3DSA:2.160.10.10:FF:000097', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(111799, NULL, 'G3DSA:1.10.150.240:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111800, NULL, 'G3DSA:1.10.8.1080:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111801, NULL, 'G3DSA:3.40.190.10:FF:000965', NULL, NULL, 'Glr3204 protein', NULL, NULL, NULL, NULL, NULL, 4),
(111802, NULL, 'G3DSA:1.10.555.10:FF:000092', NULL, NULL, 'RhoGAP domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(111803, NULL, 'G3DSA:3.40.50.10190:FF:000298', NULL, NULL, 'DNA topoisomerase 2-binding protein 1-A-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(111804, NULL, 'G3DSA:1.10.220.10:FF:000016', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(111805, NULL, 'G3DSA:1.20.1510.10:FF:000024', NULL, NULL, 'Solute carrier family 30 (Zinc transporter), member 1', NULL, NULL, NULL, NULL, NULL, 4),
(111806, NULL, 'G3DSA:3.80.10.10:FF:002864', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111807, NULL, 'G3DSA:1.25.10.10:FF:003209', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(111808, NULL, 'G3DSA:2.40.30.10:FF:000340', NULL, NULL, 'Eukaryotic peptide chain release factor GTP-binding subunit ERF3A', NULL, NULL, NULL, NULL, NULL, 4),
(111809, NULL, 'G3DSA:3.30.420.10:FF:000553', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111810, NULL, 'G3DSA:3.40.50.300:FF:002223', NULL, NULL, 'U5 small nuclear ribonucleoprotein helicase', NULL, NULL, NULL, NULL, NULL, 4),
(111811, NULL, 'G3DSA:1.10.287.1060:FF:000020', NULL, NULL, 'Cogc-4', NULL, NULL, NULL, NULL, NULL, 4),
(111812, NULL, 'G3DSA:2.30.42.10:FF:000609', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111813, NULL, 'G3DSA:1.20.140.40:FF:000073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111814, NULL, 'G3DSA:2.60.40.10:FF:005179', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111815, NULL, 'G3DSA:2.130.10.10:FF:004022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111816, NULL, 'G3DSA:3.40.50.10240:FF:000009', NULL, NULL, 'thiamin pyrophosphokinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(111817, NULL, 'G3DSA:1.20.58.1040:FF:000010', NULL, NULL, 'Glucan endo-13-beta-glucosidase 4', NULL, NULL, NULL, NULL, NULL, 4),
(111818, NULL, 'G3DSA:1.20.5.1180:FF:000001', NULL, NULL, 'Truncated geminin', NULL, NULL, NULL, NULL, NULL, 4),
(111819, NULL, 'G3DSA:2.40.250.10:FF:000002', NULL, NULL, 'Core binding factor beta subunit isoform 10', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(111820, NULL, 'G3DSA:1.20.1070.10:FF:000517', NULL, NULL, 'GoNadotropin-Releasing hormone Receptor (GnRHR) related', NULL, NULL, NULL, NULL, NULL, 4),
(111821, NULL, 'G3DSA:2.30.110.10:FF:000106', NULL, NULL, 'Uncharacterized protein C725.03', NULL, NULL, NULL, NULL, NULL, 4),
(111822, NULL, 'G3DSA:2.60.120.620:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111823, NULL, 'G3DSA:3.40.120.10:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111824, NULL, 'G3DSA:3.30.70.1600:FF:000001', NULL, NULL, 'RNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(111825, NULL, 'G3DSA:1.10.510.10:FF:001348', NULL, NULL, 'GAK Homolog', NULL, NULL, NULL, NULL, NULL, 4),
(111826, NULL, 'G3DSA:3.30.1360.180:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111827, NULL, 'G3DSA:3.90.550.10:FF:000291', NULL, NULL, '3-deoxy-D-manno-octulosonate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(111828, NULL, 'G3DSA:4.10.400.10:FF:000030', NULL, NULL, 'Sortilin related receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(111829, NULL, 'G3DSA:4.10.410.10:FF:000115', NULL, NULL, 'Salivary protein KUN-5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111830, NULL, 'G3DSA:2.60.40.10:FF:003049', NULL, NULL, 'Dyslexia-associated protein KIAA0319', NULL, NULL, NULL, NULL, NULL, 4),
(111831, NULL, 'G3DSA:2.40.440.10:FF:000022', NULL, NULL, 'ErfK/YbiS/YcfS/YnhG family protein', NULL, NULL, NULL, NULL, NULL, 4),
(111832, NULL, 'G3DSA:2.60.260.20:FF:000063', NULL, NULL, 'LOC100125006 protein', NULL, NULL, NULL, NULL, NULL, 4),
(111833, NULL, 'G3DSA:3.50.30.30:FF:000079', NULL, NULL, 'Glutamate carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111834, NULL, 'G3DSA:1.10.287.370:FF:000042', NULL, NULL, 'Prefoldin, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(111835, NULL, 'G3DSA:3.40.1110.10:FF:000454', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111836, NULL, 'G3DSA:3.40.50.300:FF:005837', NULL, NULL, 'Lantibiotic mersacidin transporter system', NULL, NULL, NULL, NULL, NULL, 4),
(111837, NULL, 'G3DSA:3.30.70.890:FF:000034', NULL, NULL, 'Diphosphomevalonate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(111838, NULL, 'G3DSA:1.20.120.350:FF:000141', NULL, NULL, 'Voltage-gated Ca2+ channel, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(111839, NULL, 'G3DSA:3.40.50.10330:FF:000003', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(111840, NULL, 'G3DSA:2.130.10.10:FF:004926', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111841, NULL, 'G3DSA:3.80.10.10:FF:000498', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(111842, NULL, 'G3DSA:2.120.10.80:FF:000209', NULL, NULL, 'Protein CBG01796', NULL, NULL, NULL, NULL, NULL, 4),
(111843, NULL, 'G3DSA:2.30.29.30:FF:000955', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111844, NULL, 'G3DSA:3.40.1080.10:FF:000012', NULL, NULL, 'Possible CoA-transferase (Beta subunit)', NULL, NULL, NULL, NULL, NULL, 4),
(111845, NULL, 'G3DSA:3.20.80.10:FF:000055', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(111846, NULL, 'G3DSA:3.40.50.300:FF:000986', NULL, NULL, 'rab-like protein 2B isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(111847, NULL, 'G3DSA:3.90.640.10:FF:000253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111848, NULL, 'G3DSA:3.40.50.1440:FF:000147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111849, NULL, 'G3DSA:3.40.50.150:FF:001149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111850, NULL, 'G3DSA:1.10.20.10:FF:000152', NULL, NULL, 'CBF/NF-Y transcription factor family protein', NULL, NULL, NULL, NULL, NULL, 4),
(111851, NULL, 'G3DSA:3.60.15.10:FF:000133', NULL, NULL, 'Cleavage and polyadenylation specificity factor, 73 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(111852, NULL, 'G3DSA:3.40.50.1820:FF:000284', NULL, NULL, 'Triacylglycerol lipase A', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(111853, NULL, 'G3DSA:1.10.238.230:FF:000007', NULL, NULL, 'Phosphatase regulatory subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111854, NULL, 'G3DSA:2.60.120.10:FF:000308', NULL, NULL, 'Phospholipase A1 member A', NULL, NULL, NULL, NULL, NULL, 4),
(111855, NULL, 'G3DSA:3.40.1170.60:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111856, NULL, 'G3DSA:3.40.50.300:FF:005657', NULL, NULL, 'ATP-dependent DNA helicase Hel308', NULL, NULL, NULL, NULL, NULL, 4),
(111857, NULL, 'G3DSA:3.30.160.60:FF:006000', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111858, NULL, 'G3DSA:3.10.20.310:FF:000041', NULL, NULL, 'Chloroplast outer envelope protein', NULL, NULL, NULL, NULL, NULL, 4),
(111859, NULL, 'G3DSA:1.25.10.10:FF:000770', NULL, NULL, 'Protein phosphatase 4, regulatory subunit 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(111860, NULL, 'G3DSA:1.25.10.10:FF:001444', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(111861, NULL, 'G3DSA:3.40.50.2300:FF:001439', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111862, NULL, 'G3DSA:3.10.20.620:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111863, NULL, 'G3DSA:3.30.56.10:FF:000021', NULL, NULL, 'Phenylalanyl-tRNA synthetase beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(111864, NULL, 'G3DSA:1.20.1070.10:FF:001288', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(111865, NULL, 'G3DSA:1.10.4160.10:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111866, NULL, 'G3DSA:2.130.10.10:FF:003302', NULL, NULL, 'Transducin (beta)-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(111867, NULL, 'G3DSA:1.25.40.330:FF:000008', NULL, NULL, 'Adenylyl cyclase-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(111868, NULL, 'G3DSA:3.30.1370.210:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111869, NULL, 'G3DSA:3.40.50.620:FF:000756', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111870, NULL, 'G3DSA:2.170.270.10:FF:000197', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(111871, NULL, 'G3DSA:1.20.1070.10:FF:000299', NULL, NULL, '5-hydroxytryptamine receptor 2B', NULL, NULL, NULL, NULL, NULL, 4),
(111872, NULL, 'G3DSA:3.90.1150.220:FF:000001', NULL, NULL, 'Non-structural maintenance of chromosomes element 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(111873, NULL, 'G3DSA:1.10.10.2660:FF:000021', NULL, NULL, 'Ubiquitin activating enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111874, NULL, 'G3DSA:3.50.50.60:FF:001466', NULL, NULL, 'Os01g0269100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(111875, NULL, 'G3DSA:3.40.1190.20:FF:000091', NULL, NULL, 'ATP-dependent (S)-NAD(P)H-hydrate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(111876, NULL, 'G3DSA:1.20.120.550:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111877, NULL, 'G3DSA:1.10.150.20:FF:000058', NULL, NULL, 'Helicase, POLQ like', NULL, NULL, NULL, NULL, NULL, 4),
(111878, NULL, 'G3DSA:3.40.50.720:FF:000376', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(111879, NULL, 'G3DSA:3.30.200.20:FF:000495', NULL, NULL, 'Nodulation receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(111880, NULL, 'G3DSA:3.30.830.10:FF:000247', NULL, NULL, 'Probable zinc protease', NULL, NULL, NULL, NULL, NULL, 4),
(111881, NULL, 'G3DSA:1.10.10.10:FF:000775', NULL, NULL, 'PadR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(111882, NULL, 'G3DSA:3.90.39.10:FF:000001', NULL, NULL, 'Hexon protein', NULL, NULL, NULL, NULL, NULL, 4),
(111883, NULL, 'G3DSA:2.60.40.420:FF:000076', NULL, NULL, 'Spore coat protein A', NULL, NULL, NULL, NULL, NULL, 4),
(111884, NULL, 'G3DSA:1.20.5.2950:FF:000004', NULL, NULL, 'V-type proton ATPase subunit G', NULL, NULL, NULL, NULL, NULL, 4),
(111885, NULL, 'G3DSA:3.30.160.60:FF:005836', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111886, NULL, 'G3DSA:3.40.50.300:FF:007866', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(111887, NULL, 'G3DSA:1.10.533.10:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111888, NULL, 'G3DSA:3.10.20.90:FF:000637', NULL, NULL, 'Putative small ubiquitin-related modifier 7', NULL, NULL, NULL, NULL, NULL, 4),
(111889, NULL, 'G3DSA:2.60.40.150:FF:000360', NULL, NULL, 'Phosphatidylinositol 3-kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111890, NULL, 'G3DSA:3.40.50.720:FF:002473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111891, NULL, 'G3DSA:1.10.10.10:FF:001848', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111892, NULL, 'G3DSA:3.30.200.20:FF:000219', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(111893, NULL, 'G3DSA:1.20.1600.10:FF:000031', NULL, NULL, 'Outer membrane protein TolC, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111894, NULL, 'G3DSA:3.40.630.30:FF:000668', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(111895, NULL, 'G3DSA:3.40.50.300:FF:004640', NULL, NULL, 'Recombinase RecB', NULL, NULL, NULL, NULL, NULL, 4),
(111896, NULL, 'G3DSA:3.30.160.60:FF:005679', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111897, NULL, 'G3DSA:2.30.30.140:FF:000345', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(111898, NULL, 'G3DSA:3.90.550.50:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111899, NULL, 'G3DSA:1.25.40.10:FF:003037', NULL, NULL, 'Os01g0884800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(111900, NULL, 'G3DSA:3.80.10.10:FF:003145', NULL, NULL, 'AT02704p', NULL, NULL, NULL, NULL, NULL, 4),
(111901, NULL, 'G3DSA:1.20.5.170:FF:000268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111902, NULL, 'G3DSA:2.130.10.10:FF:001728', NULL, NULL, 'Similar to DDB1B (Damaged DNA Binding protein 1 B) damaged DNA binding / protein binding', NULL, NULL, NULL, NULL, NULL, 4),
(111903, NULL, 'G3DSA:3.30.1370.120:FF:000004', NULL, NULL, 'DNA transporter HofQ', NULL, NULL, NULL, NULL, NULL, 4),
(111904, NULL, 'G3DSA:1.20.58.60:FF:000742', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111905, NULL, 'G3DSA:1.10.100.10:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111906, NULL, 'G3DSA:3.40.190.10:FF:000678', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(111907, NULL, 'G3DSA:1.25.40.20:FF:000224', NULL, NULL, 'SH3 and multiple ankyrin repeat domains protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(111908, NULL, 'G3DSA:2.60.40.10:FF:001233', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(111909, NULL, 'G3DSA:2.60.40.3170:FF:000010', NULL, NULL, 'Tripeptidyl-peptidase II, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111910, NULL, 'G3DSA:4.10.280.10:FF:000121', NULL, NULL, 'Serine-rich protein TYE7', NULL, NULL, NULL, NULL, NULL, 4),
(111911, NULL, 'G3DSA:2.40.50.140:FF:000869', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111912, NULL, 'G3DSA:3.90.1150.10:FF:000085', NULL, NULL, 'LL-diaminopimelate aminotransferase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(111913, NULL, 'G3DSA:1.20.1730.10:FF:000035', NULL, NULL, 'High affinity choline transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111914, NULL, 'G3DSA:3.30.70.1440:FF:000009', NULL, NULL, 'RND multidrug efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(111915, NULL, 'G3DSA:2.30.180.10:FF:000111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111916, NULL, 'G3DSA:3.90.550.10:FF:000015', NULL, NULL, 'Glucomannan 4-beta-mannosyltransferase 9', NULL, NULL, NULL, NULL, NULL, 4),
(111917, NULL, 'G3DSA:1.10.510.10:FF:003377', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111918, NULL, 'G3DSA:3.40.50.300:FF:005096', NULL, NULL, 'Energy-coupling factor transporter ATP-binding protein EcfA', NULL, NULL, NULL, NULL, NULL, 4),
(111919, NULL, 'G3DSA:2.20.70.10:FF:000096', NULL, NULL, 'E3 ubiquitin-protein ligase NEDD4 isoform X4', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(111920, NULL, 'G3DSA:3.40.50.1820:FF:001273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111921, NULL, 'G3DSA:3.40.50.80:FF:000096', NULL, NULL, 'NADPH-dependent ferric siderophore reductase', NULL, NULL, NULL, NULL, NULL, 4),
(111922, NULL, 'G3DSA:3.30.70.330:FF:000586', NULL, NULL, 'Nucleolysin TIA-1 isoform p40', NULL, NULL, NULL, NULL, NULL, 4),
(111923, NULL, 'G3DSA:1.10.630.10:FF:000047', NULL, NULL, 'Cytochrome P450 monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(111924, NULL, 'G3DSA:3.30.450.20:FF:000266', NULL, NULL, 'Voltage-dependent calcium channel subunit alpha-2/delta-1', NULL, NULL, NULL, NULL, NULL, 4),
(111925, NULL, 'G3DSA:1.20.1560.10:FF:000595', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(111926, NULL, 'G3DSA:1.25.40.10:FF:000951', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(111927, NULL, 'G3DSA:2.30.29.30:FF:000455', NULL, NULL, 'Psy2p', NULL, NULL, NULL, NULL, NULL, 4),
(111928, NULL, 'G3DSA:2.130.10.10:FF:006051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111929, NULL, 'G3DSA:2.60.40.10:FF:005466', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111930, NULL, 'G3DSA:1.20.1250.20:FF:001400', NULL, NULL, 'Major facilitator superfamily MFS_1', NULL, NULL, NULL, NULL, NULL, 4),
(111931, NULL, 'G3DSA:1.10.8.10:FF:000347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111932, NULL, 'G3DSA:3.90.870.10:FF:000011', NULL, NULL, 'tRNA threonylcarbamoyl adenosine modification protein, Sua5/YciO/YrdC/YwlC family', NULL, NULL, NULL, NULL, NULL, 4),
(111933, NULL, 'G3DSA:3.90.950.10:FF:000012', NULL, NULL, 'dTTP/UTP pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(111934, NULL, 'G3DSA:3.30.160.60:FF:000036', NULL, NULL, 'GLI family zinc finger 3', NULL, NULL, NULL, NULL, NULL, 4),
(111935, NULL, 'G3DSA:1.25.10.10:FF:001287', NULL, NULL, 'Armadillo repeat-containing protein wrm-1', NULL, NULL, NULL, NULL, NULL, 4),
(111936, NULL, 'G3DSA:2.60.40.10:FF:002857', NULL, NULL, 'GD11718', NULL, NULL, NULL, NULL, NULL, 4),
(111937, NULL, 'G3DSA:2.60.40.10:FF:002032', NULL, NULL, 'FiLamiN (Actin binding protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(111938, NULL, 'G3DSA:3.30.420.10:FF:000492', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111939, NULL, 'G3DSA:2.120.10.30:FF:000099', NULL, NULL, 'Meiotic P26, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(111940, NULL, 'G3DSA:1.20.1740.10:FF:000249', NULL, NULL, 'Solute carrier family 7 member 8b', NULL, NULL, NULL, NULL, NULL, 4),
(111941, NULL, 'G3DSA:3.30.200.20:FF:001124', NULL, NULL, 'S-receptor kinase1', NULL, NULL, NULL, NULL, NULL, 4),
(111942, NULL, 'G3DSA:4.10.400.10:FF:000210', NULL, NULL, 'Serine protease nudel', NULL, NULL, NULL, NULL, NULL, 4),
(111943, NULL, 'G3DSA:2.60.40.10:FF:001172', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(111944, NULL, 'G3DSA:3.30.230.10:FF:000055', NULL, NULL, 'DNA topoisomerase (ATP-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4),
(111945, NULL, 'G3DSA:3.90.190.10:FF:000156', NULL, NULL, 'Inositol_hexakisphosphate', NULL, NULL, NULL, NULL, NULL, 4),
(111946, NULL, 'G3DSA:3.30.160.60:FF:003127', NULL, NULL, 'GM26116', NULL, NULL, NULL, NULL, NULL, 4),
(111947, NULL, 'G3DSA:3.30.450.20:FF:000327', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(111948, NULL, 'G3DSA:3.40.50.1000:FF:000015', NULL, NULL, 'CTD small phosphatase-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(111949, NULL, 'G3DSA:2.60.120.10:FF:000460', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111950, NULL, 'G3DSA:3.30.70.330:FF:000804', NULL, NULL, 'Poly(A) binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(111951, NULL, 'G3DSA:3.40.1110.10:FF:000274', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111952, NULL, 'G3DSA:3.40.50.1100:FF:000219', NULL, NULL, 'Protein CBG07184', NULL, NULL, NULL, NULL, NULL, 4),
(111953, NULL, 'G3DSA:3.30.420.40:FF:000253', NULL, NULL, 'Heat shock protein, putative', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(111954, NULL, 'G3DSA:1.25.40.10:FF:002132', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(111955, NULL, 'G3DSA:1.20.1110.10:FF:000123', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111956, NULL, 'G3DSA:2.10.70.10:FF:000153', NULL, NULL, 'Hig-anchoring scaffold protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(111957, NULL, 'G3DSA:3.40.190.10:FF:000414', NULL, NULL, 'DNA-binding transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(111958, NULL, 'G3DSA:3.40.50.1820:FF:000492', NULL, NULL, 'Putative phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(111959, NULL, 'G3DSA:2.40.128.180:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111960, NULL, 'G3DSA:3.30.2140.20:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111961, NULL, 'G3DSA:1.10.10.60:FF:001138', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111962, NULL, 'G3DSA:2.60.40.60:FF:000141', NULL, NULL, 'Cadherin 23', NULL, NULL, NULL, NULL, NULL, 4),
(111963, NULL, 'G3DSA:3.90.20.20:FF:000012', NULL, NULL, 'Protein GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(111964, NULL, 'G3DSA:1.25.40.10:FF:004318', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111965, NULL, 'G3DSA:2.40.50.140:FF:000953', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111966, NULL, 'G3DSA:3.40.50.720:FF:000056', NULL, NULL, 'ADP-L-glycero-D-manno-heptose-6-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(111967, NULL, 'G3DSA:2.40.50.100:FF:000172', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(111968, NULL, 'G3DSA:3.40.50.1000:FF:000690', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111969, NULL, 'G3DSA:3.40.50.300:FF:005337', NULL, NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', NULL, NULL, NULL, NULL, NULL, 4),
(111970, NULL, 'G3DSA:3.30.70.270:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111971, NULL, 'G3DSA:1.25.10.10:FF:002568', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111972, NULL, 'G3DSA:1.25.40.10:FF:003413', NULL, NULL, 'Os05g0305300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(111973, NULL, 'G3DSA:1.20.1070.10:FF:000164', NULL, NULL, 'Muscarinic acetylcholine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(111974, NULL, 'G3DSA:2.40.70.10:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111975, NULL, 'G3DSA:3.80.10.10:FF:002364', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111976, NULL, 'G3DSA:2.60.40.10:FF:003313', NULL, NULL, 'Cell adhesion molecule, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111977, NULL, 'G3DSA:2.130.10.10:FF:001380', NULL, NULL, 'WD repeat-containing protein 11 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(111978, NULL, 'G3DSA:1.10.555.10:FF:000024', NULL, NULL, 'Rho GTPase-activating protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(111979, NULL, 'G3DSA:2.10.90.10:FF:000148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111980, NULL, 'G3DSA:2.70.130.10:FF:000020', NULL, NULL, 'Insulin-like growth factor 2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(111981, NULL, 'G3DSA:2.40.50.90:FF:000033', NULL, NULL, 'Transcription factor (Snd1/p100), putative', NULL, NULL, NULL, NULL, NULL, 4),
(111982, NULL, 'G3DSA:3.30.450.30:FF:000044', NULL, NULL, 'Profilin', NULL, NULL, NULL, NULL, NULL, 4),
(111983, NULL, 'G3DSA:1.10.8.10:FF:000167', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(111984, NULL, 'G3DSA:1.10.287.1490:FF:000031', NULL, NULL, 'Putative WEB family protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(111985, NULL, 'G3DSA:1.10.268.20:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(111986, NULL, 'G3DSA:2.40.240.10:FF:000041', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(111987, NULL, 'G3DSA:3.90.25.10:FF:000059', NULL, NULL, 'dTDP-glucose 4,6-dehydratase, putative', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(111988, NULL, 'G3DSA:4.10.410.10:FF:000036', NULL, NULL, 'Protein CBR-MEC-1', NULL, NULL, NULL, NULL, NULL, 4),
(111989, NULL, 'G3DSA:1.20.140.150:FF:000113', NULL, NULL, 'uncharacterized protein LOC100175559', NULL, NULL, NULL, NULL, NULL, 4),
(111990, NULL, 'G3DSA:3.30.70.100:FF:000112', NULL, NULL, 'Stress-response A/B barrel domain-containing protein DABB1', NULL, NULL, NULL, NULL, NULL, 4),
(111991, NULL, 'G3DSA:1.25.40.10:FF:000103', NULL, NULL, 'small glutamine-rich tetratricopeptide repeat-containing protein beta', NULL, NULL, NULL, NULL, NULL, 4),
(111992, NULL, 'G3DSA:1.10.510.10:FF:001409', NULL, NULL, 'CK1 family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(111993, NULL, 'G3DSA:3.90.1150.10:FF:000321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111994, NULL, 'G3DSA:3.40.50.300:FF:001503', NULL, NULL, 'Replication factor C subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(111995, NULL, 'G3DSA:1.10.510.10:FF:002129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(111996, NULL, 'G3DSA:2.70.170.10:FF:000062', NULL, NULL, 'Histamine-gated chloride channel subunit', NULL, NULL, NULL, NULL, NULL, 4),
(111997, NULL, 'G3DSA:3.40.50.1010:FF:000075', NULL, NULL, 'Ribonuclease VapC', NULL, NULL, NULL, NULL, NULL, 4),
(111998, NULL, 'G3DSA:1.25.40.180:FF:000093', NULL, NULL, 'Non-muscle caldesmon, putative', NULL, NULL, NULL, NULL, NULL, 4),
(111999, NULL, 'G3DSA:3.40.640.10:FF:000039', NULL, NULL, 'Tryptophanase', NULL, NULL, NULL, NULL, NULL, 4),
(112000, NULL, 'G3DSA:2.20.70.10:FF:000276', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(112001, NULL, 'G3DSA:4.10.60.10:FF:000248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112002, NULL, 'G3DSA:3.40.50.10930:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112003, NULL, 'G3DSA:3.90.70.10:FF:000366', NULL, NULL, 'Putative ubiquitin-hydrolase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(112004, NULL, 'G3DSA:3.20.20.80:FF:000550', NULL, NULL, 'Mannan endo-1,4-beta-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(112005, NULL, 'G3DSA:1.20.20.10:FF:000011', NULL, NULL, 'ATP synthase subunit c', NULL, NULL, NULL, NULL, NULL, 4),
(112006, NULL, 'G3DSA:3.30.230.10:FF:000398', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112007, NULL, 'G3DSA:2.40.37.10:FF:000086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112008, NULL, 'G3DSA:3.40.850.10:FF:000414', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112009, NULL, 'G3DSA:2.60.120.260:FF:000082', NULL, NULL, 'Sad1/UNC domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(112010, NULL, 'G3DSA:3.50.50.60:FF:000802', NULL, NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(112011, NULL, 'G3DSA:3.30.565.10:FF:000467', NULL, NULL, 'TNF receptor-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(112012, NULL, 'G3DSA:3.30.70.1230:FF:000036', NULL, NULL, 'Adenylate/guanylate cyclase catalytic domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(112013, NULL, 'G3DSA:3.30.160.60:FF:004555', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112014, NULL, 'G3DSA:2.60.40.10:FF:003942', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112015, NULL, 'G3DSA:2.10.25.10:FF:000806', NULL, NULL, 'fibrillin-1', NULL, NULL, NULL, NULL, NULL, 4),
(112016, NULL, 'G3DSA:1.25.10.10:FF:002304', NULL, NULL, 'AP-3 complex subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(112017, NULL, 'G3DSA:3.10.110.10:FF:000169', NULL, NULL, 'Orf protein', NULL, NULL, NULL, NULL, NULL, 4),
(112018, NULL, 'G3DSA:1.20.1560.10:FF:000095', NULL, NULL, 'ABC multidrug transporter Mdr2', NULL, NULL, NULL, NULL, NULL, 4),
(112019, NULL, 'G3DSA:1.20.1510.10:FF:000092', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112020, NULL, 'G3DSA:3.30.160.60:FF:005915', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112021, NULL, 'G3DSA:2.40.30.10:FF:000109', NULL, NULL, 'NADPH--cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(112022, NULL, 'G3DSA:3.40.33.10:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112023, NULL, 'G3DSA:1.10.287.70:FF:000654', NULL, NULL, 'Protein CBR-TWK-17', NULL, NULL, NULL, NULL, NULL, 4),
(112024, NULL, 'G3DSA:1.10.510.10:FF:002360', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112025, NULL, 'G3DSA:2.60.40.60:FF:000618', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112026, NULL, 'G3DSA:1.20.5.270:FF:000005', NULL, NULL, 'Cytochrome b-c1 complex subunit Rieske, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(112027, NULL, 'G3DSA:3.80.10.10:FF:003645', NULL, NULL, 'Os08g0203400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(112028, NULL, 'G3DSA:2.40.170.10:FF:000001', NULL, NULL, 'Maltoporin', NULL, NULL, NULL, NULL, NULL, 4),
(112029, NULL, 'G3DSA:3.40.50.11980:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112030, NULL, 'G3DSA:2.130.10.10:FF:004994', NULL, NULL, 'SOF1 protein-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(112031, NULL, 'G3DSA:2.60.120.820:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112032, NULL, 'G3DSA:1.25.40.420:FF:000002', NULL, NULL, 'Kelch-like family member 13', NULL, NULL, NULL, NULL, NULL, 4),
(112033, NULL, 'G3DSA:3.40.720.10:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112034, NULL, 'G3DSA:3.40.50.1240:FF:000188', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112035, NULL, 'G3DSA:1.25.40.800:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112036, NULL, 'G3DSA:1.10.357.140:FF:000012', NULL, NULL, 'Prenyltransferase, UbiA family', NULL, NULL, NULL, NULL, NULL, 4),
(112037, NULL, 'G3DSA:2.40.160.10:FF:000040', NULL, NULL, 'Voltage-dependent anion-selective channel, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112038, NULL, 'G3DSA:1.20.58.60:FF:000663', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112039, NULL, 'G3DSA:1.10.510.10:FF:003641', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112040, NULL, 'G3DSA:1.10.510.10:FF:003765', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112041, NULL, 'G3DSA:2.40.50.140:FF:000689', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(112042, NULL, 'G3DSA:3.40.50.10190:FF:000011', NULL, NULL, 'DNA repair protein REV1', NULL, NULL, NULL, NULL, NULL, 4),
(112043, NULL, 'G3DSA:2.30.110.10:FF:000045', NULL, NULL, 'Oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(112044, NULL, 'G3DSA:2.20.100.10:FF:000097', NULL, NULL, 'ADAMTS like 5', NULL, NULL, NULL, NULL, NULL, 4),
(112045, NULL, 'G3DSA:3.40.50.880:FF:000019', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase subunit PurQ', NULL, NULL, NULL, NULL, NULL, 4),
(112046, NULL, 'G3DSA:2.160.20.20:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112047, NULL, 'G3DSA:3.40.50.2000:FF:000006', NULL, NULL, 'Sucrose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(112048, NULL, 'G3DSA:1.25.40.180:FF:000172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112049, NULL, 'G3DSA:1.25.40.10:FF:002396', NULL, NULL, 'ERAD-associated E3 ubiquitin-protein ligase component HRD3A', NULL, NULL, NULL, NULL, NULL, 4),
(112050, NULL, 'G3DSA:3.30.70.330:FF:000243', NULL, NULL, 'DNA polymerase delta-interacting protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(112051, NULL, 'G3DSA:2.120.10.80:FF:000277', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(112052, NULL, 'G3DSA:3.40.50.620:FF:000621', NULL, NULL, 'Transport protein (Probable substrate cationic amino acids)', NULL, NULL, NULL, NULL, NULL, 4),
(112053, NULL, 'G3DSA:2.60.200.20:FF:000166', NULL, NULL, 'Nibrin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112054, NULL, 'G3DSA:2.130.10.10:FF:002785', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112055, NULL, 'G3DSA:2.10.25.10:FF:000110', NULL, NULL, 'Signal peptide, CUB domain and EGF-like domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(112056, NULL, 'G3DSA:3.10.100.10:FF:000264', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112057, NULL, 'G3DSA:1.20.1070.10:FF:002193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112058, NULL, 'G3DSA:3.30.70.330:FF:001524', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112059, NULL, 'G3DSA:1.20.810.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112060, NULL, 'G3DSA:2.130.10.10:FF:001149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112061, NULL, 'G3DSA:2.60.120.260:FF:000643', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112062, NULL, 'G3DSA:2.60.40.720:FF:000008', NULL, NULL, 'Runx2b splice form 4', NULL, NULL, NULL, NULL, NULL, 4),
(112063, NULL, 'G3DSA:3.30.70.330:FF:001867', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112064, NULL, 'G3DSA:3.10.50.10:FF:000025', NULL, NULL, 'Chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112065, NULL, 'G3DSA:3.30.1490.180:FF:000009', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(112066, NULL, 'G3DSA:2.40.20.10:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112067, NULL, 'G3DSA:3.10.250.10:FF:000090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112068, NULL, 'G3DSA:4.10.900.10:FF:000023', NULL, NULL, 'Cadherin 18, type 2a', NULL, NULL, NULL, NULL, NULL, 4),
(112069, NULL, 'G3DSA:3.30.1340.30:FF:000007', NULL, NULL, 'Osmotically inducible protein', NULL, NULL, NULL, NULL, NULL, 4),
(112070, NULL, 'G3DSA:3.40.50.360:FF:000072', NULL, NULL, 'Flavodoxin', NULL, NULL, NULL, NULL, NULL, 4),
(112071, NULL, 'G3DSA:3.40.390.10:FF:000154', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(112072, NULL, 'G3DSA:3.40.50.300:FF:007170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112073, NULL, 'G3DSA:3.30.70.920:FF:000049', NULL, NULL, 'Transcriptional regulator, AsnC family', NULL, NULL, NULL, NULL, NULL, 4),
(112074, NULL, 'G3DSA:3.30.750.44:FF:000007', NULL, NULL, 'Periplasmic tail-specific protease', NULL, NULL, NULL, NULL, NULL, 4),
(112075, NULL, 'G3DSA:3.80.10.10:FF:003988', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(112076, NULL, 'G3DSA:3.40.1620.70:FF:000004', NULL, NULL, 'Collagen, type XV, alpha 1b', NULL, NULL, NULL, NULL, NULL, 4),
(112077, NULL, 'G3DSA:3.40.50.2300:FF:000158', NULL, NULL, 'Sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(112078, NULL, 'G3DSA:3.60.10.10:FF:000049', NULL, NULL, 'uncharacterized protein LOC103698197 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(112079, NULL, 'G3DSA:3.40.50.1370:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112080, NULL, 'G3DSA:3.30.750.24:FF:000001', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(112081, NULL, 'G3DSA:3.30.930.10:FF:000311', NULL, NULL, 'tRNA synthetase-related / tRNA ligase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(112082, NULL, 'G3DSA:3.90.70.10:FF:000630', NULL, NULL, 'Ubiquitin specific protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112083, NULL, 'G3DSA:2.60.40.2070:FF:000006', NULL, NULL, 'Fimbrial assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(112084, NULL, 'G3DSA:1.25.40.20:FF:000544', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(112085, NULL, 'G3DSA:2.30.180.10:FF:000032', NULL, NULL, 'Fasciclin domain-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112086, NULL, 'G3DSA:2.60.40.10:FF:005387', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112087, NULL, 'G3DSA:3.40.190.10:FF:000757', NULL, NULL, 'Hydroxymethylbilane synthase (Porphobilinogen deaminase)', NULL, NULL, NULL, NULL, NULL, 4),
(112088, NULL, 'G3DSA:2.60.40.1150:FF:000005', NULL, NULL, 'Adaptor protein (AP) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(112089, NULL, 'G3DSA:3.20.20.80:FF:000139', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(112090, NULL, 'G3DSA:3.40.50.1980:FF:000056', NULL, NULL, 'Ferric hydroxamate receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(112091, NULL, 'G3DSA:3.10.20.90:FF:000901', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112092, NULL, 'G3DSA:3.40.30.10:FF:000326', NULL, NULL, 'Bacterioferritin comigratory protein', NULL, NULL, NULL, NULL, NULL, 4),
(112093, NULL, 'G3DSA:1.10.12.10:FF:000026', NULL, NULL, '3-hydroxybutyryl-CoA dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(112094, NULL, 'G3DSA:3.40.50.2000:FF:000681', NULL, NULL, 'Glycosyl transferase group 1', NULL, NULL, NULL, NULL, NULL, 4),
(112095, NULL, 'G3DSA:3.90.550.20:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112096, NULL, 'G3DSA:3.40.50.300:FF:004376', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112097, NULL, 'G3DSA:1.20.58.70:FF:000048', NULL, NULL, 'Syntaxin 7-like', NULL, NULL, NULL, NULL, NULL, 4),
(112098, NULL, 'G3DSA:3.30.1330.30:FF:000046', NULL, NULL, '60S ribosomal protein L7ae/L30e, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112099, NULL, 'G3DSA:3.30.230.70:FF:000101', NULL, NULL, '3''-5''-exoribonuclease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(112100, NULL, 'G3DSA:1.25.40.10:FF:001856', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(112101, NULL, 'G3DSA:3.90.550.10:FF:000083', NULL, NULL, 'Glucose-1-phosphate adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(112102, NULL, 'G3DSA:1.10.150.20:FF:000137', NULL, NULL, 'DNApol-iota, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(112103, NULL, 'G3DSA:3.30.160.60:FF:002689', NULL, NULL, 'Protein suppressor of hairy wing', NULL, NULL, NULL, NULL, NULL, 4),
(112104, NULL, 'G3DSA:3.30.420.40:FF:000596', NULL, NULL, 'Heat shock protein 70 homolog LHS1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112105, NULL, 'G3DSA:3.30.420.100:FF:000001', NULL, NULL, '50S ribosomal protein L18', NULL, NULL, NULL, NULL, NULL, 4),
(112106, NULL, 'G3DSA:2.10.25.10:FF:000189', NULL, NULL, 'Laminin subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(112107, NULL, 'G3DSA:1.10.3210.10:FF:000077', NULL, NULL, 'dGTP triphosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(112108, NULL, 'G3DSA:3.30.1420.10:FF:000002', NULL, NULL, 'Sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(112109, NULL, 'G3DSA:1.25.40.20:FF:001393', NULL, NULL, 'Transient receptor potential channel 4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112110, NULL, 'G3DSA:3.30.559.30:FF:000009', NULL, NULL, 'Nonribosomal peptide synthase Pes1', NULL, NULL, NULL, NULL, NULL, 4),
(112111, NULL, 'G3DSA:3.30.200.20:FF:000848', NULL, NULL, 'Tyrosine-sulfated glycopeptide receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(112112, NULL, 'G3DSA:3.40.50.620:FF:000060', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(112113, NULL, 'G3DSA:3.30.479.30:FF:000008', NULL, NULL, 'Stomatin-like protein 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(112114, NULL, 'G3DSA:3.30.160.60:FF:001464', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112115, NULL, 'G3DSA:3.40.1390.10:FF:000002', NULL, NULL, 'UDP-N-acetylmuramoyl-L-alanyl-D-glutamate--2,6-diaminopimelate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(112116, NULL, 'G3DSA:1.10.10.970:FF:000002', NULL, NULL, 'Tpt1p', NULL, NULL, NULL, NULL, NULL, 4),
(112117, NULL, 'G3DSA:3.40.50.720:FF:000617', NULL, NULL, 'NEDD8-activating enzyme E1 catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(112118, NULL, 'G3DSA:2.130.10.10:FF:005270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112119, NULL, 'G3DSA:1.20.140.10:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112120, NULL, 'G3DSA:3.30.160.60:FF:004898', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112121, NULL, 'G3DSA:1.10.510.10:FF:000331', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 19', NULL, NULL, NULL, NULL, NULL, 4),
(112122, NULL, 'G3DSA:3.30.1340.10:FF:000001', NULL, NULL, 'Phosphocarrier, HPr family', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(112123, NULL, 'G3DSA:3.30.479.20:FF:000062', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(112124, NULL, 'G3DSA:2.60.40.150:FF:000023', NULL, NULL, 'Double C2-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(112125, NULL, 'G3DSA:1.20.1720.10:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112126, NULL, 'G3DSA:3.40.50.2300:FF:000427', NULL, NULL, 'Pheromone and odorant receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112127, NULL, 'G3DSA:1.20.1560.10:FF:000943', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112128, NULL, 'G3DSA:3.40.50.2000:FF:001018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112129, NULL, 'G3DSA:3.30.160.20:FF:000108', NULL, NULL, 'Double-stranded RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(112130, NULL, 'G3DSA:3.30.559.70:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112131, NULL, 'G3DSA:3.30.1370.110:FF:000012', NULL, NULL, 'UBA/TS-N_domain/CUE_domain/Domain_of_uncharacterized_function_(DUF1771)/Smr_domain_containing_protein', NULL, NULL, NULL, NULL, NULL, 4),
(112132, NULL, 'G3DSA:3.40.50.300:FF:006793', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112133, NULL, 'G3DSA:3.10.580.10:FF:000136', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(112134, NULL, 'G3DSA:3.30.70.330:FF:002480', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112135, NULL, 'G3DSA:3.80.10.10:FF:002184', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(112136, NULL, 'G3DSA:3.30.160.100:FF:000020', NULL, NULL, 'Ribosome hibernation promoting factor', NULL, NULL, NULL, NULL, NULL, 4),
(112137, NULL, 'G3DSA:2.60.40.10:FF:005915', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112138, NULL, 'G3DSA:1.20.1740.10:FF:000125', NULL, NULL, 'Arginine permease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112139, NULL, 'G3DSA:3.80.10.10:FF:002240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112140, NULL, 'G3DSA:3.90.190.10:FF:000268', NULL, NULL, 'Si:ch1073-391i24.1', NULL, NULL, NULL, NULL, NULL, 4),
(112141, NULL, 'G3DSA:3.40.50.2000:FF:000506', NULL, NULL, 'OSJNBb0080H08.20 protein', NULL, NULL, NULL, NULL, NULL, 4),
(112142, NULL, 'G3DSA:3.30.40.10:FF:000417', NULL, NULL, 'E3 ubiquitin ligase BIG BROTHER-related', NULL, NULL, NULL, NULL, NULL, 4),
(112143, NULL, 'G3DSA:2.120.10.30:FF:000279', NULL, NULL, 'Low density lipoprotein receptor-related protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(112144, NULL, 'G3DSA:3.30.720.210:FF:000012', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(112145, NULL, 'G3DSA:1.20.1720.10:FF:000130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112146, NULL, 'G3DSA:2.10.25.10:FF:000745', NULL, NULL, 'Sushi, nidogen and EGF like domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(112147, NULL, 'G3DSA:3.30.559.70:FF:000061', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(112148, NULL, 'G3DSA:2.20.110.10:FF:000047', NULL, NULL, 'MORN_repeat', NULL, NULL, NULL, NULL, NULL, 4),
(112149, NULL, 'G3DSA:3.30.1050.10:FF:000018', NULL, NULL, 'Alkyl/aryl-sulfatase BDS1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112150, NULL, 'G3DSA:3.30.1120.30:FF:000041', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(112151, NULL, 'G3DSA:1.25.10.10:FF:003024', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(112152, NULL, 'G3DSA:3.40.1170.60:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112153, NULL, 'G3DSA:1.10.287.70:FF:000593', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112154, NULL, 'G3DSA:3.20.10.10:FF:000045', NULL, NULL, 'Branched-chain amino-acid transaminase, putative (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(112155, NULL, 'G3DSA:3.40.50.300:FF:005314', NULL, NULL, 'YALI0E02750p', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(112156, NULL, 'G3DSA:3.40.50.1820:FF:001514', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112157, NULL, 'G3DSA:1.20.1050.10:FF:000281', NULL, NULL, 'Glutathione-S-transferase theta, GST, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112158, NULL, 'G3DSA:3.30.160.60:FF:002745', NULL, NULL, 'Zinc finger protein 284', NULL, NULL, NULL, NULL, NULL, 4),
(112159, NULL, 'G3DSA:2.130.10.10:FF:001560', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112160, NULL, 'G3DSA:1.50.40.10:FF:000207', NULL, NULL, 'Solute carrier family 25, member 33/36', NULL, NULL, NULL, NULL, NULL, 4),
(112161, NULL, 'G3DSA:3.30.40.10:FF:001985', NULL, NULL, 'Ariadne homolog 2 (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(112162, NULL, 'G3DSA:1.20.1070.10:FF:000276', NULL, NULL, 'G protein-coupled receptor 25', NULL, NULL, NULL, NULL, NULL, 4),
(112163, NULL, 'G3DSA:1.25.40.10:FF:003537', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112164, NULL, 'G3DSA:3.40.1010.10:FF:000002', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase I', NULL, NULL, NULL, NULL, NULL, 4),
(112165, NULL, 'G3DSA:2.70.150.10:FF:000139', NULL, NULL, 'Cation-transporting ATPase 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112166, NULL, 'G3DSA:3.40.50.150:FF:000076', NULL, NULL, 'probable methyltransferase PMT21', NULL, NULL, NULL, NULL, NULL, 4),
(112167, NULL, 'G3DSA:3.10.20.90:FF:000345', NULL, NULL, 'Ubiquitin regulatory X', NULL, NULL, NULL, NULL, NULL, 4),
(112168, NULL, 'G3DSA:3.40.50.300:FF:002515', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(112169, NULL, 'G3DSA:1.10.238.10:FF:000523', NULL, NULL, 'CAMK/CDPK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(112170, NULL, 'G3DSA:1.10.510.10:FF:003826', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112171, NULL, 'G3DSA:1.10.600.10:FF:000034', NULL, NULL, 'Farnesyl-diphosphate farnesyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(112172, NULL, 'G3DSA:1.10.630.10:FF:000603', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112173, NULL, 'G3DSA:3.30.160.60:FF:003206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112174, NULL, 'G3DSA:3.60.21.10:FF:000361', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112175, NULL, 'G3DSA:3.40.30.10:FF:000618', NULL, NULL, 'Protein disulfide isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(112176, NULL, 'G3DSA:2.130.10.10:FF:003802', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112177, NULL, 'G3DSA:1.10.238.10:FF:001035', NULL, NULL, 'Calcium-binding EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(112178, NULL, 'G3DSA:3.40.50.12500:FF:000002', NULL, NULL, 'Maleate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(112179, NULL, 'G3DSA:1.10.4160.10:FF:000022', NULL, NULL, 'Permease', NULL, NULL, NULL, NULL, NULL, 4),
(112180, NULL, 'G3DSA:3.40.50.20:FF:000050', NULL, NULL, 'Formate-dependent phosphoribosylglycinamide formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(112181, NULL, 'G3DSA:1.25.40.720:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112182, NULL, 'G3DSA:1.20.120.430:FF:000002', NULL, NULL, 'tRNA modification GTPase GTPBP3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(112183, NULL, 'G3DSA:3.80.10.10:FF:000211', NULL, NULL, 'vasorin', NULL, NULL, NULL, NULL, NULL, 4),
(112184, NULL, 'G3DSA:2.130.10.10:FF:005831', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112185, NULL, 'G3DSA:2.60.40.10:FF:002301', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(112186, NULL, 'G3DSA:3.40.190.10:FF:000178', NULL, NULL, 'Glutamate receptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(112187, NULL, 'G3DSA:1.10.630.10:FF:000547', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112188, NULL, 'G3DSA:2.60.40.10:FF:001733', NULL, NULL, 'Titin', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(112189, NULL, 'G3DSA:3.10.20.90:FF:000401', NULL, NULL, 'UBX domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(112190, NULL, 'G3DSA:1.10.10.10:FF:000590', NULL, NULL, 'Transcriptional regulator, MarR family', NULL, NULL, NULL, NULL, NULL, 4),
(112191, NULL, 'G3DSA:3.40.50.1000:FF:000190', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(112192, NULL, 'G3DSA:3.40.630.30:FF:000432', NULL, NULL, 'Acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112193, NULL, 'G3DSA:2.40.33.10:FF:000026', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(112194, NULL, 'G3DSA:3.30.230.130:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112195, NULL, 'G3DSA:1.10.1070.11:FF:000055', NULL, NULL, 'PIKK family atypical protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(112196, NULL, 'G3DSA:3.30.230.70:FF:000045', NULL, NULL, 'Exosome-associated protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(112197, NULL, 'G3DSA:1.25.10.10:FF:001467', NULL, NULL, 'Protein CLASP-2', NULL, NULL, NULL, NULL, NULL, 4),
(112198, NULL, 'G3DSA:2.120.10.80:FF:000092', NULL, NULL, 'Dynein heavy chain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(112199, NULL, 'G3DSA:2.30.29.30:FF:000450', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(112200, NULL, 'G3DSA:1.20.1070.10:FF:001529', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112201, NULL, 'G3DSA:1.25.10.10:FF:000270', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(112202, NULL, 'G3DSA:3.60.110.10:FF:000028', NULL, NULL, 'Hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112203, NULL, 'G3DSA:1.20.1070.10:FF:000332', NULL, NULL, 'Blast:Calcitonin gene-related peptide type 1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(112204, NULL, 'G3DSA:3.80.10.10:FF:003140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112205, NULL, 'G3DSA:3.30.70.1130:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112206, NULL, 'G3DSA:3.30.40.10:FF:001878', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112207, NULL, 'G3DSA:3.30.160.60:FF:006056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112208, NULL, 'G3DSA:1.10.510.10:FF:003141', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112209, NULL, 'G3DSA:3.40.309.10:FF:000045', NULL, NULL, 'Gamma-glutamyl phosphate reductase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(112210, NULL, 'G3DSA:1.10.10.10:FF:001843', NULL, NULL, 'LD29662p', NULL, NULL, NULL, NULL, NULL, 4),
(112211, NULL, 'G3DSA:1.20.1250.20:FF:001007', NULL, NULL, 'solute carrier family 2, facilitated glucose transporter member 6 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(112212, NULL, 'G3DSA:3.20.20.80:FF:000471', NULL, NULL, 'Arabinogalactan endo-beta-1,4-galactanase', NULL, NULL, NULL, NULL, NULL, 4),
(112213, NULL, 'G3DSA:3.30.160.60:FF:002638', NULL, NULL, 'Zinc finger protein 416', NULL, NULL, NULL, NULL, NULL, 4),
(112214, NULL, 'G3DSA:3.80.10.10:FF:002925', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112215, NULL, 'G3DSA:3.30.70.1450:FF:000046', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(112216, NULL, 'G3DSA:1.20.1070.10:FF:000225', NULL, NULL, 'Opsin 3', NULL, NULL, NULL, NULL, NULL, 4),
(112217, NULL, 'G3DSA:1.10.110.10:FF:000019', NULL, NULL, 'Bifunctional inhibitor/lipid-transfer protein/seed storage 2S albumin superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(112218, NULL, 'G3DSA:1.20.1050.10:FF:000218', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(112219, NULL, 'G3DSA:3.40.50.300:FF:001947', NULL, NULL, 'ESX-1 secretion system protein EccCb1', NULL, NULL, NULL, NULL, NULL, 4),
(112220, NULL, 'G3DSA:2.30.42.10:FF:000317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112221, NULL, 'G3DSA:1.10.8.60:FF:000452', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(112222, NULL, 'G3DSA:3.40.50.620:FF:000695', NULL, NULL, 'Nicotinamide-nucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(112223, NULL, 'G3DSA:3.30.160.60:FF:001441', NULL, NULL, 'Zinc finger protein 217', NULL, NULL, NULL, NULL, NULL, 4),
(112224, NULL, 'G3DSA:2.60.40.10:FF:004662', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112225, NULL, 'G3DSA:1.10.510.10:FF:003933', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112226, NULL, 'G3DSA:2.70.220.10:FF:000004', NULL, NULL, 'Related to phosphatidylglycerol/phosphatidylinositol transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(112227, NULL, 'G3DSA:3.30.160.60:FF:001385', NULL, NULL, 'zinc finger protein 774', NULL, NULL, NULL, NULL, NULL, 4),
(112228, NULL, 'G3DSA:3.40.50.720:FF:000848', NULL, NULL, 'UDP-glucose 4-epimerase galE1', NULL, NULL, NULL, NULL, NULL, 4),
(112229, NULL, 'G3DSA:2.130.10.10:FF:000929', NULL, NULL, 'Ribosomal assembly complex component Ipi3', NULL, NULL, NULL, NULL, NULL, 4),
(112230, NULL, 'G3DSA:3.60.15.10:FF:000189', NULL, NULL, 'Beta-lactamase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(112231, NULL, 'G3DSA:3.90.660.10:FF:000136', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112232, NULL, 'G3DSA:1.20.1250.20:FF:001900', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(112233, NULL, 'G3DSA:1.10.10.10:FF:001051', NULL, NULL, 'Carminomycin 4-O-methyltransferase DnrK', NULL, NULL, NULL, NULL, NULL, 4),
(112234, NULL, 'G3DSA:2.40.50.140:FF:000397', NULL, NULL, 'Probable DNA-directed RNA polymerase II chain Rpb7', NULL, NULL, NULL, NULL, NULL, 4),
(112235, NULL, 'G3DSA:3.30.310.50:FF:000040', NULL, NULL, 'Threonine aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(112236, NULL, 'G3DSA:3.20.20.190:FF:000007', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(112237, NULL, 'G3DSA:1.10.510.10:FF:003877', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112238, NULL, 'G3DSA:3.50.50.60:FF:000977', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112239, NULL, 'G3DSA:3.40.50.620:FF:000700', NULL, NULL, 'Electron transfer flavoprotein beta subunit EtfB', NULL, NULL, NULL, NULL, NULL, 4),
(112240, NULL, 'G3DSA:2.20.25.370:FF:000001', NULL, NULL, 'IPI internal head protein', NULL, NULL, NULL, NULL, NULL, 4),
(112241, NULL, 'G3DSA:3.40.109.10:FF:000041', NULL, NULL, 'Nitroreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(112242, NULL, 'G3DSA:3.30.160.60:FF:006112', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112243, NULL, 'G3DSA:3.20.20.140:FF:000476', NULL, NULL, 'Adenosine deaminase 2', NULL, NULL, NULL, NULL, NULL, 4),
(112244, NULL, 'G3DSA:3.30.70.330:FF:001816', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112245, NULL, 'G3DSA:2.130.10.10:FF:002009', NULL, NULL, 'Eukaryotic translation initiation factor 2A', NULL, NULL, NULL, NULL, NULL, 4),
(112246, NULL, 'G3DSA:3.40.50.300:FF:002408', NULL, NULL, 'Rab32 family GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112247, NULL, 'G3DSA:2.160.20.10:FF:000002', NULL, NULL, 'Endopolygalacturonase D', NULL, NULL, NULL, NULL, NULL, 4),
(112248, NULL, 'G3DSA:3.90.1750.10:FF:000013', NULL, NULL, 'Apoptosis-resistant E3 ubiquitin protein ligase 1', NULL, NULL, NULL, NULL, NULL, 4),
(112249, NULL, 'G3DSA:1.20.200.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112250, NULL, 'G3DSA:1.10.510.10:FF:001909', NULL, NULL, 'Inhibitor of nuclear factor kappa B kinase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(112251, NULL, 'G3DSA:1.20.1280.50:FF:000214', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(112252, NULL, 'G3DSA:3.20.20.80:FF:000319', NULL, NULL, 'Putative beta-glucosidase 15', NULL, NULL, NULL, NULL, NULL, 4),
(112253, NULL, 'G3DSA:3.30.930.10:FF:000232', NULL, NULL, 'PEK/GCN2 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(112254, NULL, 'G3DSA:3.10.180.10:FF:000100', NULL, NULL, 'Glyoxalase family protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(112255, NULL, 'G3DSA:2.10.25.10:FF:000638', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(112256, NULL, 'G3DSA:3.30.450.40:FF:000081', NULL, NULL, 'Vanadium nitrogenase sigma54-dependent transcriptional activator, VnfA', NULL, NULL, NULL, NULL, NULL, 4),
(112257, NULL, 'G3DSA:2.60.40.10:FF:005230', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112258, NULL, 'G3DSA:3.50.50.60:FF:001123', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(112259, NULL, 'G3DSA:1.10.472.10:FF:000174', NULL, NULL, 'Cyclin-D1-1', NULL, NULL, NULL, NULL, NULL, 4),
(112260, NULL, 'G3DSA:3.10.580.10:FF:000029', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(112261, NULL, 'G3DSA:3.30.60.90:FF:000009', NULL, NULL, 'ZZ-type zinc finger-containing protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(112262, NULL, 'G3DSA:1.10.10.2330:FF:000006', NULL, NULL, 'Phenylalanine-tRNA ligase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(112263, NULL, 'G3DSA:1.20.5.170:FF:000032', NULL, NULL, 'UDP-3-O-(3-hydroxymyristoyl)glucosamine N-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(112264, NULL, 'G3DSA:1.10.1070.11:FF:000004', NULL, NULL, 'Phosphatidylinositol 4-kinase, catalytic, beta', NULL, NULL, NULL, NULL, NULL, 4),
(112265, NULL, 'G3DSA:1.10.150.110:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112266, NULL, 'G3DSA:2.60.40.1670:FF:000010', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(112267, NULL, 'G3DSA:1.10.555.10:FF:000209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112268, NULL, 'G3DSA:2.120.10.80:FF:000041', NULL, NULL, 'kelch-like protein 10 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(112269, NULL, 'G3DSA:1.20.1740.10:FF:000018', NULL, NULL, 'solute carrier family 12 member 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(112270, NULL, 'G3DSA:3.30.70.240:FF:000036', NULL, NULL, 'Translation factor GUF1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(112271, NULL, 'G3DSA:3.40.50.1820:FF:000109', NULL, NULL, 'Lipase, endothelial', NULL, NULL, NULL, NULL, NULL, 4),
(112272, NULL, 'G3DSA:3.40.50.2000:FF:001063', NULL, NULL, 'Glycogen [starch] synthase', NULL, NULL, NULL, NULL, NULL, 4),
(112273, NULL, 'G3DSA:3.20.20.70:FF:000086', NULL, NULL, 'IMP dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112274, NULL, 'G3DSA:3.40.50.2300:FF:000478', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(112275, NULL, 'G3DSA:3.30.200.20:FF:002029', NULL, NULL, 'calmodulin-dependent protein kinase homologue isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(112276, NULL, 'G3DSA:3.90.190.10:FF:000217', NULL, NULL, 'Tyrosine-protein phosphatase yvh1', NULL, NULL, NULL, NULL, NULL, 4),
(112277, NULL, 'G3DSA:2.60.40.10:FF:000795', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(112278, NULL, 'G3DSA:3.30.70.1230:FF:000216', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(112279, NULL, 'G3DSA:3.40.630.150:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112280, NULL, 'G3DSA:1.20.1640.10:FF:000073', NULL, NULL, 'PaTched Related family', NULL, NULL, NULL, NULL, NULL, 4),
(112281, NULL, 'G3DSA:3.80.10.10:FF:000323', NULL, NULL, 'Leucine-rich repeat-containing protein 49 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(112282, NULL, 'G3DSA:2.60.40.10:FF:002245', NULL, NULL, 'Adhesion G protein-coupled receptor F5', NULL, NULL, NULL, NULL, NULL, 4),
(112283, NULL, 'G3DSA:1.25.40.10:FF:002637', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(112284, NULL, 'G3DSA:2.60.200.20:FF:000222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112285, NULL, 'G3DSA:3.30.465.10:FF:000134', NULL, NULL, 'Putative oxidoreductase, FAD-binding', NULL, NULL, NULL, NULL, NULL, 4),
(112286, NULL, 'G3DSA:3.40.50.1820:FF:000261', NULL, NULL, 'Tributyrin esterase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(112287, NULL, 'G3DSA:3.40.50.720:FF:001337', NULL, NULL, 'Short-chain dehydrogenase/reductase SDR', NULL, NULL, NULL, NULL, NULL, 4),
(112288, NULL, 'G3DSA:3.30.160.20:FF:000171', NULL, NULL, 'Endoribonuclease Dicer-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(112289, NULL, 'G3DSA:2.30.29.30:FF:000394', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(112290, NULL, 'G3DSA:3.20.20.190:FF:000058', NULL, NULL, 'Pgc1p', NULL, NULL, NULL, NULL, NULL, 4),
(112291, NULL, 'G3DSA:3.30.70.20:FF:000130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112292, NULL, 'G3DSA:1.10.472.10:FF:000674', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112293, NULL, 'G3DSA:1.25.10.10:FF:000955', NULL, NULL, 'Related to negative regulator of mitosis', NULL, NULL, NULL, NULL, NULL, 4),
(112294, NULL, 'G3DSA:3.40.50.150:FF:001436', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112295, NULL, 'G3DSA:1.10.1040.50:FF:000002', NULL, NULL, 'Trifunctional enzyme subunit alpha, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(112296, NULL, 'G3DSA:2.40.50.100:FF:000121', NULL, NULL, 'Molybdenum ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(112297, NULL, 'G3DSA:3.10.180.10:FF:000095', NULL, NULL, 'Putative N-acetyltransferase YjaB', NULL, NULL, NULL, NULL, NULL, 4),
(112298, NULL, 'G3DSA:1.25.40.10:FF:000890', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(112299, NULL, 'G3DSA:2.70.98.90:FF:000001', NULL, NULL, 'Membrane protein insertase YidC', NULL, NULL, NULL, NULL, NULL, 4),
(112300, NULL, 'G3DSA:2.120.10.30:FF:000335', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(112301, NULL, 'G3DSA:2.130.10.10:FF:002953', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112302, NULL, 'G3DSA:3.90.79.10:FF:000099', NULL, NULL, 'Unplaced genomic scaffold supercont1.9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(112303, NULL, 'G3DSA:3.40.50.300:FF:001099', NULL, NULL, 'Iron-sulfur cluster carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(112304, NULL, 'G3DSA:3.10.20.90:FF:000289', NULL, NULL, 'Ubiquitin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112305, NULL, 'G3DSA:1.25.40.120:FF:000007', NULL, NULL, 'CaaX farnesyltransferase alpha subunit Ram2', NULL, NULL, NULL, NULL, NULL, 4),
(112306, NULL, 'G3DSA:3.20.20.140:FF:000072', NULL, NULL, 'Hydrolase, TatD family protein', NULL, NULL, NULL, NULL, NULL, 4),
(112307, NULL, 'G3DSA:1.10.490.160:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112308, NULL, 'G3DSA:3.90.1150.10:FF:000309', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(112309, NULL, 'G3DSA:1.20.1070.10:FF:000220', NULL, NULL, 'Probable G-protein coupled receptor 176', NULL, NULL, NULL, NULL, NULL, 4),
(112310, NULL, 'G3DSA:2.30.30.40:FF:000580', NULL, NULL, 'Chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(112311, NULL, 'G3DSA:3.90.980.10:FF:000008', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(112312, NULL, 'G3DSA:3.30.200.20:FF:001568', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112313, NULL, 'G3DSA:1.20.5.170:FF:000083', NULL, NULL, 'Transcription factor VIP1', NULL, NULL, NULL, NULL, NULL, 4),
(112314, NULL, 'G3DSA:1.25.40.10:FF:004998', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112315, NULL, 'G3DSA:3.80.10.10:FF:002009', NULL, NULL, 'NLR family CARD domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(112316, NULL, 'G3DSA:3.30.497.10:FF:000073', NULL, NULL, 'Accessory gland protein Acp76A', NULL, NULL, NULL, NULL, NULL, 4),
(112317, NULL, 'G3DSA:1.10.287.110:FF:000015', NULL, NULL, 'dnaJ homolog subfamily C member 3', NULL, NULL, NULL, NULL, NULL, 4),
(112318, NULL, 'G3DSA:3.30.70.330:FF:001075', NULL, NULL, 'RNA-binding protein 8A', NULL, NULL, NULL, NULL, NULL, 4),
(112319, NULL, 'G3DSA:2.10.25.10:FF:000790', NULL, NULL, 'Fat-like cadherin-related tumor suppressor homolog', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(112320, NULL, 'G3DSA:1.20.58.60:FF:000394', NULL, NULL, 'Nesprin-2', NULL, NULL, NULL, NULL, NULL, 4),
(112321, NULL, 'G3DSA:1.10.510.10:FF:004389', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112322, NULL, 'G3DSA:1.20.140.90:FF:000003', NULL, NULL, 'MaLonyl CoA Decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(112323, NULL, 'G3DSA:1.20.1560.10:FF:000072', NULL, NULL, 'ATP binding cassette subfamily B member 5', NULL, NULL, NULL, NULL, NULL, 4),
(112324, NULL, 'G3DSA:2.130.10.10:FF:005775', NULL, NULL, 'Protein FAN', NULL, NULL, NULL, NULL, NULL, 4),
(112325, NULL, 'G3DSA:3.40.50.300:FF:002459', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(112326, NULL, 'G3DSA:3.30.420.10:FF:000733', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112327, NULL, 'G3DSA:1.10.287.770:FF:000010', NULL, NULL, 'Pickpocket 23, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(112328, NULL, 'G3DSA:3.40.50.1820:FF:001458', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112329, NULL, 'G3DSA:1.10.10.60:FF:000918', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112330, NULL, 'G3DSA:3.10.580.10:FF:000024', NULL, NULL, 'Chloride channel 2c', NULL, NULL, NULL, NULL, NULL, 4),
(112331, NULL, 'G3DSA:1.25.40.10:FF:001272', NULL, NULL, 'Pentatricopeptide repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(112332, NULL, 'G3DSA:2.60.390.10:FF:000002', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(112333, NULL, 'G3DSA:3.30.559.10:FF:000026', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(112334, NULL, 'G3DSA:2.130.10.10:FF:000211', NULL, NULL, 'striatin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(112335, NULL, 'G3DSA:1.20.1250.20:FF:000670', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(112336, NULL, 'G3DSA:3.30.40.10:FF:000529', NULL, NULL, 'Tetratricopeptide repeat domain 3', NULL, NULL, NULL, NULL, NULL, 4),
(112337, NULL, 'G3DSA:2.130.10.10:FF:005770', NULL, NULL, 'EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(112338, NULL, 'G3DSA:2.60.40.10:FF:001756', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(112339, NULL, 'G3DSA:3.40.50.300:FF:007231', NULL, NULL, 'RAS, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112340, NULL, 'G3DSA:3.10.110.10:FF:000326', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112341, NULL, 'G3DSA:3.90.70.10:FF:000815', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112342, NULL, 'G3DSA:3.30.430.20:FF:000040', NULL, NULL, 'L-type lectin-domain containing receptor kinase IX.1', NULL, NULL, NULL, NULL, NULL, 4),
(112343, NULL, 'G3DSA:1.20.1540.10:FF:000037', NULL, NULL, 'Rhomboid family intramembrane serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(112344, NULL, 'G3DSA:1.10.510.10:FF:001224', NULL, NULL, 'Serine/threonine-protein kinase ATG1t', NULL, NULL, NULL, NULL, NULL, 4),
(112345, NULL, 'G3DSA:3.40.190.10:FF:000173', NULL, NULL, 'Probable glutamine-binding lipoprotein glnH', NULL, NULL, NULL, NULL, NULL, 4),
(112346, NULL, 'G3DSA:3.30.160.60:FF:004662', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112347, NULL, 'G3DSA:3.90.1150.10:FF:000080', NULL, NULL, 'Bifunctional dethiobiotin synthetase/adenosylmethionine-8-amino-7-oxononanoate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(112348, NULL, 'G3DSA:2.60.120.200:FF:000108', NULL, NULL, 'collagen alpha-1(XXII) chain isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(112349, NULL, 'G3DSA:2.10.50.10:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112350, NULL, 'G3DSA:3.80.10.10:FF:000216', NULL, NULL, 'ATP synthase subunit s, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(112351, NULL, 'G3DSA:3.30.342.10:FF:000006', NULL, NULL, 'DNA-directed DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(112352, NULL, 'G3DSA:3.10.20.30:FF:000018', NULL, NULL, 'Succinate dehydrogenase iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(112353, NULL, 'G3DSA:1.25.40.20:FF:001909', NULL, NULL, 'Ankyrin 2, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(112354, NULL, 'G3DSA:3.40.1190.20:FF:000107', NULL, NULL, 'Bifunctional NAD(P)H-hydrate repair enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(112355, NULL, 'G3DSA:3.30.70.330:FF:001367', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112356, NULL, 'G3DSA:2.60.40.60:FF:000377', NULL, NULL, 'Dachsous cadherin-related 1a', NULL, NULL, NULL, NULL, NULL, 4),
(112357, NULL, 'G3DSA:1.10.720.30:FF:000032', NULL, NULL, 'Blast:SAP domain-containing ribonucleoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(112358, NULL, 'G3DSA:3.30.40.10:FF:002334', NULL, NULL, 'E3 ubiquitin-protein ligase rnf213-beta', NULL, NULL, NULL, NULL, NULL, 4),
(112359, NULL, 'G3DSA:1.10.720.30:FF:000083', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(112360, NULL, 'G3DSA:3.40.50.300:FF:002403', NULL, NULL, 'Ribosome biogenesis GTP-binding protein YsxC', NULL, NULL, NULL, NULL, NULL, 4),
(112361, NULL, 'G3DSA:3.10.129.10:FF:000083', NULL, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(112362, NULL, 'G3DSA:1.10.220.150:FF:000033', NULL, NULL, 'stromal membrane-associated protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(112363, NULL, 'G3DSA:1.10.400.10:FF:000002', NULL, NULL, 'guanine nucleotide-binding protein G(Q) subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(112364, NULL, 'G3DSA:2.10.25.10:FF:001127', NULL, NULL, 'Fibulin 2', NULL, NULL, NULL, NULL, NULL, 4),
(112365, NULL, 'G3DSA:2.30.29.30:FF:000399', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(112366, NULL, 'G3DSA:1.20.1080.10:FF:000046', NULL, NULL, 'Aquaporin', NULL, NULL, NULL, NULL, NULL, 4),
(112367, NULL, 'G3DSA:1.10.1670.10:FF:000083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112368, NULL, 'G3DSA:2.130.10.10:FF:004426', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(112369, NULL, 'G3DSA:3.30.750.24:FF:000057', NULL, NULL, 'Anion transporter SULP-1a', NULL, NULL, NULL, NULL, NULL, 4),
(112370, NULL, 'G3DSA:3.30.1330.30:FF:000107', NULL, NULL, 'selenocysteine insertion sequence-binding protein 2-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(112371, NULL, 'G3DSA:2.60.40.10:FF:003605', NULL, NULL, 'Natural killer cell receptor 2B4', NULL, NULL, NULL, NULL, NULL, 4),
(112372, NULL, 'G3DSA:3.30.40.10:FF:002042', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(112373, NULL, 'G3DSA:3.30.110.10:FF:000007', NULL, NULL, 'Translation initiation factor IF-3', NULL, NULL, NULL, NULL, NULL, 4),
(112374, NULL, 'G3DSA:2.130.10.10:FF:003914', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112375, NULL, 'G3DSA:3.80.10.10:FF:000267', NULL, NULL, 'NLR family CARD domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(112376, NULL, 'G3DSA:3.80.10.10:FF:004505', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112377, NULL, 'G3DSA:3.10.129.10:FF:000190', NULL, NULL, 'UPF0644 protein PB2B4.06', NULL, NULL, NULL, NULL, NULL, 4),
(112378, NULL, 'G3DSA:1.10.287.130:FF:000173', NULL, NULL, 'Sensor histidine kinase/response regulator LuxN', NULL, NULL, NULL, NULL, NULL, 4),
(112379, NULL, 'G3DSA:3.30.70.330:FF:001024', NULL, NULL, 'RNA-binding protein Y14B', NULL, NULL, NULL, NULL, NULL, 4),
(112380, NULL, 'G3DSA:1.10.10.10:FF:001899', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112381, NULL, 'G3DSA:3.40.50.300:FF:004825', NULL, NULL, 'SNF2-related domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(112382, NULL, 'G3DSA:2.60.40.60:FF:000034', NULL, NULL, 'Protocadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(112383, NULL, 'G3DSA:3.60.20.10:FF:000263', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112384, NULL, 'G3DSA:3.90.70.10:FF:000523', NULL, NULL, 'Flagellar associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(112385, NULL, 'G3DSA:3.40.50.300:FF:004932', NULL, NULL, 'Glr0454 protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(112386, NULL, 'G3DSA:1.10.530.10:FF:000006', NULL, NULL, 'Flagellar assembly peptidoglycan hydrolase FlgJ', NULL, NULL, NULL, NULL, NULL, 4),
(112387, NULL, 'G3DSA:3.40.720.10:FF:000377', NULL, NULL, 'Acid phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(112388, NULL, 'G3DSA:3.30.160.60:FF:005623', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112389, NULL, 'G3DSA:3.40.50.12160:FF:000041', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(112390, NULL, 'G3DSA:1.25.70.10:FF:000099', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112391, NULL, 'G3DSA:1.10.3210.10:FF:000021', NULL, NULL, 'HD domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(112392, NULL, 'G3DSA:2.10.70.10:FF:000260', NULL, NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(112393, NULL, 'G3DSA:3.40.50.12760:FF:000001', NULL, NULL, 'Cap methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(112394, NULL, 'G3DSA:3.40.50.1970:FF:000019', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(112395, NULL, 'G3DSA:3.30.450.60:FF:000087', NULL, NULL, 'Signal recognition particle receptor', NULL, NULL, NULL, NULL, NULL, 4),
(112396, NULL, 'G3DSA:3.40.50.12780:FF:000007', NULL, NULL, 'Acyl-coenzyme A synthetase ACSM2A, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(112397, NULL, 'G3DSA:3.80.10.10:FF:000559', NULL, NULL, 'Blast:JmjC domain-containing histone demethylation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(112398, NULL, 'G3DSA:3.40.50.300:FF:004876', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112399, NULL, 'G3DSA:3.30.559.10:FF:000077', NULL, NULL, 'HXXXD-type acyl-transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(112400, NULL, 'G3DSA:3.30.1370.170:FF:000002', NULL, NULL, 'Erythronate-4-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(112401, NULL, 'G3DSA:1.20.1440.340:FF:000015', NULL, NULL, 'Protein CBG25027', NULL, NULL, NULL, NULL, NULL, 4),
(112402, NULL, 'G3DSA:3.30.470.20:FF:000093', NULL, NULL, 'Phosphoribosylamine--glycine ligase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(112403, NULL, 'G3DSA:1.10.10.2520:FF:000001', NULL, NULL, 'Spore cortex-lytic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(112404, NULL, 'G3DSA:3.90.660.10:FF:000029', NULL, NULL, 'Blast:Spermine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(112405, NULL, 'G3DSA:1.20.5.340:FF:000049', NULL, NULL, 'NHS-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(112406, NULL, 'G3DSA:3.30.40.10:FF:002385', NULL, NULL, 'Uncharacterized RING finger protein C57A7.09', NULL, NULL, NULL, NULL, NULL, 4),
(112407, NULL, 'G3DSA:1.20.1070.10:FF:002018', NULL, NULL, 'Octopamine receptor beta-3R-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(112408, NULL, 'G3DSA:2.60.40.60:FF:000326', NULL, NULL, 'cadherin-18 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(112409, NULL, 'G3DSA:3.30.160.60:FF:004263', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112410, NULL, 'G3DSA:3.30.40.10:FF:000592', NULL, NULL, 'E3 ubiquitin-protein ligase MSL2', NULL, NULL, NULL, NULL, NULL, 4),
(112411, NULL, 'G3DSA:3.40.50.300:FF:003572', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112412, NULL, 'G3DSA:3.30.70.260:FF:000082', NULL, NULL, 'Phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(112413, NULL, 'G3DSA:2.60.120.560:FF:000014', NULL, NULL, 'Sucrose-6-phosphate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(112414, NULL, 'G3DSA:1.10.12.10:FF:000049', NULL, NULL, 'Probable enoyl-CoA hydratase/isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(112415, NULL, 'G3DSA:3.40.50.300:FF:004140', NULL, NULL, 'Chromosomal replication initiator DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(112416, NULL, 'G3DSA:3.40.50.360:FF:000077', NULL, NULL, 'Nitric oxide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(112417, NULL, 'G3DSA:1.10.1200.270:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112418, NULL, 'G3DSA:3.90.190.10:FF:000212', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(112419, NULL, 'G3DSA:2.60.40.10:FF:003650', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112420, NULL, 'G3DSA:1.10.287.110:FF:000127', NULL, NULL, 'Chaperone protein DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(112421, NULL, 'G3DSA:2.40.50.140:FF:000846', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112422, NULL, 'G3DSA:1.25.40.10:FF:005162', NULL, NULL, 'rRNA biogenesis protein rrp5', NULL, NULL, NULL, NULL, NULL, 4),
(112423, NULL, 'G3DSA:3.40.850.10:FF:000257', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(112424, NULL, 'G3DSA:3.40.50.620:FF:000588', NULL, NULL, 'Asparagine synthetase [glutamine-hydrolyzing] 1', NULL, NULL, NULL, NULL, NULL, 4),
(112425, NULL, 'G3DSA:3.40.50.150:FF:000632', NULL, NULL, 'DNA methyltransferase putative', NULL, NULL, NULL, NULL, NULL, 4),
(112426, NULL, 'G3DSA:3.90.550.50:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112427, NULL, 'G3DSA:1.25.10.10:FF:002809', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112428, NULL, 'G3DSA:2.30.29.30:FF:000798', NULL, NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', NULL, NULL, NULL, NULL, NULL, 4),
(112429, NULL, 'G3DSA:3.40.50.1910:FF:000024', NULL, NULL, 'Syntaxin binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112430, NULL, 'G3DSA:3.30.160.60:FF:004370', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112431, NULL, 'G3DSA:3.30.40.10:FF:001081', NULL, NULL, 'Putative Peroxisome biosynthesis protein (PAS10/Peroxin-12)', NULL, NULL, NULL, NULL, NULL, 4),
(112432, NULL, 'G3DSA:3.30.450.190:FF:000028', NULL, NULL, 'RAs-related GTP binding protein C homolog', NULL, NULL, NULL, NULL, NULL, 4),
(112433, NULL, 'G3DSA:3.40.190.10:FF:000122', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(112434, NULL, 'G3DSA:2.60.40.60:FF:000433', NULL, NULL, 'Kugelei, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(112435, NULL, 'G3DSA:1.10.510.10:FF:000948', NULL, NULL, 'Related to GCN2-ser/thr protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(112436, NULL, 'G3DSA:3.80.10.10:FF:002740', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(112437, NULL, 'G3DSA:3.40.50.300:FF:007282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112438, NULL, 'G3DSA:3.40.50.300:FF:003864', NULL, NULL, 'Small GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112439, NULL, 'G3DSA:1.20.1540.10:FF:000088', NULL, NULL, 'Rhomboid-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(112440, NULL, 'G3DSA:3.30.1010.10:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112441, NULL, 'G3DSA:3.40.50.300:FF:008187', NULL, NULL, 'Putative 6-phosphofructo-2-kinase/fructose-2,6-biphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(112442, NULL, 'G3DSA:1.20.1250.20:FF:000607', NULL, NULL, 'Amino acid/peptide transporter (Peptide:H+ symporter)', NULL, NULL, NULL, NULL, NULL, 4),
(112443, NULL, 'G3DSA:3.90.70.10:FF:000074', NULL, NULL, 'Pro-cathepsin H', NULL, NULL, NULL, NULL, NULL, 4),
(112444, NULL, 'G3DSA:3.30.160.60:FF:002189', NULL, NULL, 'zinc finger protein ZIC 4', NULL, NULL, NULL, NULL, NULL, 4),
(112445, NULL, 'G3DSA:3.40.250.10:FF:000228', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(112446, NULL, 'G3DSA:3.40.50.300:FF:008243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112447, NULL, 'G3DSA:1.25.40.20:FF:001005', NULL, NULL, 'Palmitoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(112448, NULL, 'G3DSA:1.10.100.10:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112449, NULL, 'G3DSA:3.40.640.10:FF:000376', NULL, NULL, 'Phosphoserineaminotransferase, putative1', NULL, NULL, NULL, NULL, NULL, 4),
(112450, NULL, 'G3DSA:2.60.40.2300:FF:000002', NULL, NULL, 'Neutral/alkaline non-lysosomal ceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(112451, NULL, 'G3DSA:3.40.390.10:FF:000177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(112452, NULL, 'G3DSA:3.90.640.10:FF:000197', NULL, NULL, 'Actin, alpha 1, skeletal muscle', NULL, NULL, NULL, NULL, NULL, 4),
(112453, NULL, 'G3DSA:3.10.430.100:FF:000007', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(112454, NULL, 'G3DSA:1.10.1370.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112455, NULL, 'G3DSA:2.40.50.140:FF:000453', NULL, NULL, 'BRCA2, oligonucleotide/oligosaccharide-binding, domain 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(112456, NULL, 'G3DSA:3.40.50.150:FF:000071', NULL, NULL, 'Protein arginine N-methyltransferase 7', NULL, NULL, NULL, NULL, NULL, 4),
(112457, NULL, 'G3DSA:3.40.50.10190:FF:000247', NULL, NULL, 'DNA-repair protein XRCC1', NULL, NULL, NULL, NULL, NULL, 4),
(112458, NULL, 'G3DSA:1.10.8.140:FF:000014', NULL, NULL, 'Os05g0546500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(112459, NULL, 'G3DSA:1.25.10.10:FF:001500', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(112460, NULL, 'G3DSA:3.40.50.720:FF:000904', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] reductase FabG', NULL, NULL, NULL, NULL, NULL, 4),
(112461, NULL, 'G3DSA:1.10.1030.10:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112462, NULL, 'G3DSA:2.160.20.10:FF:000058', NULL, NULL, 'Right handed beta helix region', NULL, NULL, NULL, NULL, NULL, 4),
(112463, NULL, 'G3DSA:3.40.140.10:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112464, NULL, 'G3DSA:3.40.190.10:FF:000734', NULL, NULL, 'Glycine betaine transport system permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(112465, NULL, 'G3DSA:2.60.120.260:FF:000486', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112466, NULL, 'G3DSA:2.60.40.4330:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112467, NULL, 'G3DSA:3.30.70.330:FF:002328', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112468, NULL, 'G3DSA:1.10.10.650:FF:000024', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(112469, NULL, 'G3DSA:3.40.50.10490:FF:000062', NULL, NULL, '30S ribosomal protein S2', NULL, NULL, NULL, NULL, NULL, 4),
(112470, NULL, 'G3DSA:1.20.1250.20:FF:002120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112471, NULL, 'G3DSA:1.10.10.10:FF:000595', NULL, NULL, 'Sugar-specific transcriptional regulator, TrmB family', NULL, NULL, NULL, NULL, NULL, 4),
(112472, NULL, 'G3DSA:1.20.142.10:FF:000017', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(112473, NULL, 'G3DSA:2.40.70.10:FF:000494', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112474, NULL, 'G3DSA:1.10.3110.10:FF:000018', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(112475, NULL, 'G3DSA:2.130.10.10:FF:002897', NULL, NULL, 'Protein HIRA homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(112476, NULL, 'G3DSA:1.25.40.10:FF:002632', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g18110, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(112477, NULL, 'G3DSA:3.80.10.10:FF:003488', NULL, NULL, 'Os10g0148800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(112478, NULL, 'G3DSA:1.25.10.10:FF:003029', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(112479, NULL, 'G3DSA:2.20.28.30:FF:000004', NULL, NULL, 'DNA-directed RNA polymerases I', NULL, NULL, NULL, NULL, NULL, 4),
(112480, NULL, 'G3DSA:2.30.30.140:FF:000238', NULL, NULL, 'GM03859p', NULL, NULL, NULL, NULL, NULL, 4),
(112481, NULL, 'G3DSA:3.40.50.620:FF:000644', NULL, NULL, 'Glutamine-dependent NAD(+) synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(112482, NULL, 'G3DSA:3.30.465.10:FF:000078', NULL, NULL, 'Glycolate oxidase, subunit GlcE', NULL, NULL, NULL, NULL, NULL, 4),
(112483, NULL, 'G3DSA:3.40.50.1000:FF:000875', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112484, NULL, 'G3DSA:3.30.565.10:FF:000063', NULL, NULL, 'DNA topoisomerase (ATP-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(112485, NULL, 'G3DSA:1.10.8.720:FF:000036', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(112486, NULL, 'G3DSA:3.50.50.60:FF:000741', NULL, NULL, 'NAD dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112487, NULL, 'G3DSA:3.40.50.300:FF:004320', NULL, NULL, 'Ras-related protein Rab-3B', NULL, NULL, NULL, NULL, NULL, 4),
(112488, NULL, 'G3DSA:3.40.50.360:FF:000133', NULL, NULL, 'Flavodoxin-like fold family protein', NULL, NULL, NULL, NULL, NULL, 4),
(112489, NULL, 'G3DSA:3.90.70.10:FF:000866', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112490, NULL, 'G3DSA:3.30.300.320:FF:000006', NULL, NULL, 'GNPTAB protein', NULL, NULL, NULL, NULL, NULL, 4),
(112491, NULL, 'G3DSA:1.10.274.100:FF:000025', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(112492, NULL, 'G3DSA:3.90.70.10:FF:000130', NULL, NULL, 'Cysteine proteinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(112493, NULL, 'G3DSA:3.30.200.20:FF:001624', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112494, NULL, 'G3DSA:3.40.190.10:FF:000914', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(112495, NULL, 'G3DSA:3.40.440.10:FF:000007', NULL, NULL, 'Adenylosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(112496, NULL, 'G3DSA:3.40.50.300:FF:003920', NULL, NULL, 'Dephospho-CoA kinase', NULL, NULL, NULL, NULL, NULL, 4),
(112497, NULL, 'G3DSA:3.40.50.300:FF:007754', NULL, NULL, 'Ras-related protein RABG3a', NULL, NULL, NULL, NULL, NULL, 4),
(112498, NULL, 'G3DSA:2.130.10.10:FF:003297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112499, NULL, 'G3DSA:1.25.40.20:FF:001680', NULL, NULL, 'RE06111p', NULL, NULL, NULL, NULL, NULL, 4),
(112500, NULL, 'G3DSA:3.30.1180.20:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112501, NULL, 'G3DSA:1.20.58.60:FF:000686', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112502, NULL, 'G3DSA:1.10.15.30:FF:000005', NULL, NULL, '60S ribosomal protein L7, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112503, NULL, 'G3DSA:3.80.10.10:FF:003089', NULL, NULL, 'Antagonist of mitotic exit network 1', NULL, NULL, NULL, NULL, NULL, 4),
(112504, NULL, 'G3DSA:3.90.1530.10:FF:000007', NULL, NULL, 'Chromosome partitioning protein ParB', NULL, NULL, NULL, NULL, NULL, 4),
(112505, NULL, 'G3DSA:2.170.300.10:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112506, NULL, 'G3DSA:4.10.240.10:FF:000051', NULL, NULL, 'Hal9p', NULL, NULL, NULL, NULL, NULL, 4),
(112507, NULL, 'G3DSA:3.30.300.30:FF:000033', NULL, NULL, 'Nonribosomal siderophore peptide synthase SidC', NULL, NULL, NULL, NULL, NULL, 4),
(112508, NULL, 'G3DSA:3.40.50.1950:FF:000013', NULL, NULL, 'Flavin prenyltransferase UbiX', NULL, NULL, NULL, NULL, NULL, 4),
(112509, NULL, 'G3DSA:3.30.70.80:FF:000013', NULL, NULL, 'Alkaline serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(112510, NULL, 'G3DSA:1.10.10.60:FF:000200', NULL, NULL, 'Homeobox-leucine zipper protein ATHB-13', NULL, NULL, NULL, NULL, NULL, 4),
(112511, NULL, 'G3DSA:3.30.160.60:FF:000328', NULL, NULL, 'Zinc finger protein 1079', NULL, NULL, NULL, NULL, NULL, 4),
(112512, NULL, 'G3DSA:3.30.457.60:FF:000006', NULL, NULL, 'Spindle assembly checkpoint component MAD1', NULL, NULL, NULL, NULL, NULL, 4),
(112513, NULL, 'G3DSA:3.40.630.30:FF:000376', NULL, NULL, 'IP09891p', NULL, NULL, NULL, NULL, NULL, 4),
(112514, NULL, 'G3DSA:1.10.437.10:FF:000036', NULL, NULL, 'bcl-2-related ovarian killer protein homolog B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(112515, NULL, 'G3DSA:3.80.10.10:FF:000615', NULL, NULL, 'NLR family pyrin domain containing 12', NULL, NULL, NULL, NULL, NULL, 4),
(112516, NULL, 'G3DSA:1.20.5.4010:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112517, NULL, 'G3DSA:2.60.40.10:FF:002189', NULL, NULL, 'Mesocentin', NULL, NULL, NULL, NULL, NULL, 4),
(112518, NULL, 'G3DSA:1.10.510.10:FF:003085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(112519, NULL, 'G3DSA:2.60.40.10:FF:003549', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112520, NULL, 'G3DSA:3.30.9.10:FF:000064', NULL, NULL, 'Glycine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(112521, NULL, 'G3DSA:3.40.50.2300:FF:000534', NULL, NULL, 'LacI family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(112522, NULL, 'G3DSA:3.40.50.10190:FF:000034', NULL, NULL, 'SMC5-SMC6 complex localization factor protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(112523, NULL, 'G3DSA:1.25.40.10:FF:000783', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(112524, NULL, 'G3DSA:3.20.20.190:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112525, NULL, 'G3DSA:1.10.400.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112526, NULL, 'G3DSA:3.40.50.740:FF:000039', NULL, NULL, 'Nuo-5', NULL, NULL, NULL, NULL, NULL, 4),
(112527, NULL, 'G3DSA:3.80.10.10:FF:002920', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112528, NULL, 'G3DSA:3.10.450.10:FF:000020', NULL, NULL, 'Cystatin-M', NULL, NULL, NULL, NULL, NULL, 4),
(112529, NULL, 'G3DSA:1.20.1070.10:FF:000568', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112530, NULL, 'G3DSA:3.40.50.1260:FF:000014', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(112531, NULL, 'G3DSA:2.20.100.10:FF:000041', NULL, NULL, 'ADAMTS like 1', NULL, NULL, NULL, NULL, NULL, 4),
(112532, NULL, 'G3DSA:1.10.510.10:FF:004097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112533, NULL, 'G3DSA:3.40.50.300:FF:000610', NULL, NULL, 'Multidrug resistance-associated ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(112534, NULL, 'G3DSA:2.130.10.10:FF:002846', NULL, NULL, 'Periodic tryptophan protein 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(112535, NULL, 'G3DSA:1.10.238.10:FF:000467', NULL, NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', NULL, NULL, NULL, NULL, NULL, 4),
(112536, NULL, 'G3DSA:1.20.58.390:FF:000075', NULL, NULL, 'Neuronal acetylcholine receptor subunit alpha-9-II', NULL, NULL, NULL, NULL, NULL, 4),
(112537, NULL, 'G3DSA:3.90.550.10:FF:000307', NULL, NULL, 'Glycosyl transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(112538, NULL, 'G3DSA:2.170.16.10:FF:000031', NULL, NULL, 'DNA polymerase II large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(112539, NULL, 'G3DSA:2.20.90.10:FF:000007', NULL, NULL, 'Vitellogenin-3', NULL, NULL, NULL, NULL, NULL, 4),
(112540, NULL, 'G3DSA:1.25.40.90:FF:000020', NULL, NULL, 'regulation of nuclear pre-mRNA domain-containing protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(112541, NULL, 'G3DSA:2.60.120.260:FF:000087', NULL, NULL, 'Cytosolic endo-beta-N-acetylglucosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(112542, NULL, 'G3DSA:3.40.50.1820:FF:001565', NULL, NULL, 'Os11g0119100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(112543, NULL, 'G3DSA:1.25.40.20:FF:001617', NULL, NULL, 'GIT1 (Mammalian G protein-coupled receptor kinase InTeractor 1) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(112544, NULL, 'G3DSA:3.80.10.10:FF:004449', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112545, NULL, 'G3DSA:3.30.200.20:FF:000663', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(112546, NULL, 'G3DSA:1.10.10.60:FF:000413', NULL, NULL, 'Myb-like DNA-binding domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(112547, NULL, 'G3DSA:2.30.30.40:FF:000473', NULL, NULL, 'RIM Binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(112548, NULL, 'G3DSA:1.25.10.10:FF:000663', NULL, NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(112549, NULL, 'G3DSA:1.50.10.10:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112550, NULL, 'G3DSA:3.30.780.10:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112551, NULL, 'G3DSA:3.50.30.20:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(112552, NULL, 'G3DSA:1.25.40.630:FF:000003', NULL, NULL, 'Polyadenylation factor subunit CstF64, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112553, NULL, 'G3DSA:2.130.10.10:FF:003122', NULL, NULL, 'Predicted WD40 repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(112554, NULL, 'G3DSA:3.40.50.1820:FF:000553', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(112555, NULL, 'G3DSA:3.40.1190.20:FF:000170', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(112556, NULL, 'G3DSA:3.30.230.10:FF:000162', NULL, NULL, 'U5 small nuclear ribonucleoprotein component, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112557, NULL, 'G3DSA:4.10.400.10:FF:000053', NULL, NULL, 'Very low density lipoprotein receptor', NULL, NULL, NULL, NULL, NULL, 4),
(112558, NULL, 'G3DSA:2.130.10.10:FF:003858', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112559, NULL, 'G3DSA:3.40.630.10:FF:000218', NULL, NULL, 'Putative carboxypeptidase d', NULL, NULL, NULL, NULL, NULL, 4),
(112560, NULL, 'G3DSA:3.30.465.10:FF:000027', NULL, NULL, 'D-lactate dehydrogenase [cytochrome], mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(112561, NULL, 'G3DSA:1.10.533.10:FF:000136', NULL, NULL, 'Interferon-induced with helicase C domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(112562, NULL, 'G3DSA:1.10.238.10:FF:000815', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112563, NULL, 'G3DSA:2.60.120.200:FF:000671', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112564, NULL, 'G3DSA:2.60.40.1180:FF:000172', NULL, NULL, 'Extracellular exo-alpha-L-arabinofuranosidase', NULL, NULL, NULL, NULL, NULL, 4),
(112565, NULL, 'G3DSA:3.40.50.920:FF:000048', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(112566, NULL, 'G3DSA:1.20.58.1370:FF:000002', NULL, NULL, 'lysine-specific demethylase 6A isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(112567, NULL, 'G3DSA:2.60.40.10:FF:001340', NULL, NULL, 'Polymeric immunoglobulin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(112568, NULL, 'G3DSA:3.30.497.10:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112569, NULL, 'G3DSA:3.40.50.1100:FF:000051', NULL, NULL, '2-amino-4-ketopentanoate thiolase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(112570, NULL, 'G3DSA:1.10.238.10:FF:000759', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112571, NULL, 'G3DSA:3.10.20.80:FF:000011', NULL, NULL, 'Translation initiation factor IF3-4, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(112572, NULL, 'G3DSA:2.60.260.20:FF:000170', NULL, NULL, 'Radial spoke protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(112573, NULL, 'G3DSA:3.30.70.360:FF:000055', NULL, NULL, 'IAA-amino acid hydrolase ILR1-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(112574, NULL, 'G3DSA:3.30.450.20:FF:000215', NULL, NULL, 'Sensory box/GGDEF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(112575, NULL, 'G3DSA:3.30.160.380:FF:000002', NULL, NULL, 'Endoribonuclease Dicer isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(112576, NULL, 'G3DSA:3.30.780.10:FF:000023', NULL, NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(112577, NULL, 'G3DSA:3.30.200.20:FF:001012', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(112578, NULL, 'G3DSA:2.60.40.790:FF:000080', NULL, NULL, 'Protein SHQ1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(112579, NULL, 'G3DSA:3.40.50.11660:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112580, NULL, 'G3DSA:3.40.50.1820:FF:001222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112581, NULL, 'G3DSA:2.40.50.120:FF:000003', NULL, NULL, 'Secreted frizzled-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(112582, NULL, 'G3DSA:3.30.420.270:FF:000029', NULL, NULL, 'Biopolymer transport exbD protein', NULL, NULL, NULL, NULL, NULL, 4),
(112583, NULL, 'G3DSA:3.40.50.720:FF:000325', NULL, NULL, 'UDP-glucose 6-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(112584, NULL, 'G3DSA:4.10.60.10:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112585, NULL, 'G3DSA:2.130.10.10:FF:005207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112586, NULL, 'G3DSA:3.50.50.60:FF:000634', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(112587, NULL, 'G3DSA:1.20.120.330:FF:000034', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(112588, NULL, 'G3DSA:3.30.70.330:FF:001255', NULL, NULL, 'RNA-binding protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(112589, NULL, 'G3DSA:2.120.10.80:FF:000384', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112590, NULL, 'G3DSA:3.40.50.410:FF:000351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112591, NULL, 'G3DSA:3.10.20.90:FF:000053', NULL, NULL, 'UV excision repair protein RAD23 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(112592, NULL, 'G3DSA:3.90.190.20:FF:000041', NULL, NULL, 'Folylpolyglutamate synthase/dihydrofolate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(112593, NULL, 'G3DSA:2.40.10.10:FF:000226', NULL, NULL, 'GD10792', NULL, NULL, NULL, NULL, NULL, 4),
(112594, NULL, 'G3DSA:3.40.50.300:FF:005606', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112595, NULL, 'G3DSA:3.10.50.40:FF:000124', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(112596, NULL, 'G3DSA:1.10.10.10:FF:000882', NULL, NULL, 'Transcription regulator, Crp family', NULL, NULL, NULL, NULL, NULL, 4),
(112597, NULL, 'G3DSA:2.60.120.330:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112598, NULL, 'G3DSA:1.20.58.390:FF:000131', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(112599, NULL, 'G3DSA:1.25.40.840:FF:000004', NULL, NULL, 'CCR4-NOT transcription complex subunit 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112600, NULL, 'G3DSA:3.90.25.10:FF:000054', NULL, NULL, 'UDP-glucose 4-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(112601, NULL, 'G3DSA:1.25.50.20:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112602, NULL, 'G3DSA:2.60.40.10:FF:001284', NULL, NULL, 'Myomesin 2', NULL, NULL, NULL, NULL, NULL, 4),
(112603, NULL, 'G3DSA:1.20.1250.20:FF:001451', NULL, NULL, 'IP13170p', NULL, NULL, NULL, NULL, NULL, 4),
(112604, NULL, 'G3DSA:3.30.420.40:FF:000040', NULL, NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(112605, NULL, 'G3DSA:3.40.50.1820:FF:000497', NULL, NULL, 'KAT8 regulatory NSL complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(112606, NULL, 'G3DSA:1.20.120.1750:FF:000118', NULL, NULL, 'Protein CBG20927', NULL, NULL, NULL, NULL, NULL, 4),
(112607, NULL, 'G3DSA:2.10.90.10:FF:000036', NULL, NULL, 'Sclerostin', NULL, NULL, NULL, NULL, NULL, 4),
(112608, NULL, 'G3DSA:1.10.3230.20:FF:000002', NULL, NULL, 'Packaged DNA stabilization protein p27', NULL, NULL, NULL, NULL, NULL, 4),
(112609, NULL, 'G3DSA:1.25.40.550:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112610, NULL, 'G3DSA:2.40.50.140:FF:000009', NULL, NULL, 'Elongation factor P', NULL, NULL, NULL, NULL, NULL, 4),
(112611, NULL, 'G3DSA:1.25.40.10:FF:000491', NULL, NULL, 'Crooked neck-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(112612, NULL, 'G3DSA:1.25.10.10:FF:001231', NULL, NULL, 'GD23466', NULL, NULL, NULL, NULL, NULL, 4),
(112613, NULL, 'G3DSA:1.10.510.10:FF:001404', NULL, NULL, 'Serine/threonine-protein kinase WARTS homolog', NULL, NULL, NULL, NULL, NULL, 4),
(112614, NULL, 'G3DSA:3.40.50.1110:FF:000048', NULL, NULL, 'GDSL family lipase', NULL, NULL, NULL, NULL, NULL, 4),
(112615, NULL, 'G3DSA:2.130.10.10:FF:003066', NULL, NULL, 'Histone lysine N-methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112616, NULL, 'G3DSA:1.25.40.90:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(112617, NULL, 'G3DSA:1.20.1280.170:FF:000011', NULL, NULL, 'Exocyst subunit Exo70 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(112618, NULL, 'G3DSA:3.40.605.10:FF:000126', NULL, NULL, 'Aldehyde dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112619, NULL, 'G3DSA:1.25.40.10:FF:002289', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g28050', NULL, NULL, NULL, NULL, NULL, 4),
(112620, NULL, 'G3DSA:1.10.2000.10:FF:000010', NULL, NULL, 'Smoothened, frizzled class receptor', NULL, NULL, NULL, NULL, NULL, 4),
(112621, NULL, 'G3DSA:3.20.20.120:FF:000026', NULL, NULL, 'Enolase 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112622, NULL, 'G3DSA:3.40.630.30:FF:000084', NULL, NULL, 'Probable N-acetyltransferase HLS1-like', NULL, NULL, NULL, NULL, NULL, 4),
(112623, NULL, 'G3DSA:3.90.20.20:FF:000017', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(112624, NULL, 'G3DSA:3.80.10.10:FF:000503', NULL, NULL, 'Leucine rich repeats and transmembrane domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(112625, NULL, 'G3DSA:3.40.50.150:FF:000688', NULL, NULL, 'Methyltransferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(112626, NULL, 'G3DSA:3.40.50.620:FF:000172', NULL, NULL, 'Related to choline-phosphate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(112627, NULL, 'G3DSA:3.40.630.30:FF:000140', NULL, NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', NULL, NULL, NULL, NULL, NULL, 4),
(112628, NULL, 'G3DSA:3.90.550.20:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112629, NULL, 'G3DSA:1.25.40.20:FF:001056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112630, NULL, 'G3DSA:3.30.70.330:FF:001311', NULL, NULL, 'Putative RNA-binding protein ARP1', NULL, NULL, NULL, NULL, NULL, 4),
(112631, NULL, 'G3DSA:3.30.40.10:FF:002154', NULL, NULL, 'Structure-specific endonuclease subunit SLX1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(112632, NULL, 'G3DSA:1.25.40.10:FF:004762', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(112633, NULL, 'G3DSA:2.60.40.10:FF:004954', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112634, NULL, 'G3DSA:1.20.1000.10:FF:000002', NULL, NULL, 'Guanylate-binding family protein', NULL, NULL, NULL, NULL, NULL, 4),
(112635, NULL, 'G3DSA:1.10.630.10:FF:000839', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112636, NULL, 'G3DSA:1.25.40.10:FF:000159', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(112637, NULL, 'G3DSA:1.10.150.50:FF:000236', NULL, NULL, 'Dual specificity protein kinase splA', NULL, NULL, NULL, NULL, NULL, 4),
(112638, NULL, 'G3DSA:3.10.350.10:FF:000035', NULL, NULL, 'Stage VI sporulation protein D', NULL, NULL, NULL, NULL, NULL, 4),
(112639, NULL, 'G3DSA:3.30.420.10:FF:000497', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112640, NULL, 'G3DSA:1.20.5.110:FF:000093', NULL, NULL, 'Vesicle-trafficking protein SEC22b, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112641, NULL, 'G3DSA:1.10.510.10:FF:000735', NULL, NULL, 'serine/threonine-protein kinase 32B isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(112642, NULL, 'G3DSA:1.25.10.10:FF:001175', NULL, NULL, 'Protein CBG06442', NULL, NULL, NULL, NULL, NULL, 4),
(112643, NULL, 'G3DSA:3.30.160.60:FF:000952', NULL, NULL, 'RE1-silencing transcription factor B', NULL, NULL, NULL, NULL, NULL, 4),
(112644, NULL, 'G3DSA:3.30.300.110:FF:000005', NULL, NULL, 'tRNA (guanine(37)-N1)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(112645, NULL, 'G3DSA:3.20.20.140:FF:000184', NULL, NULL, 'Putative metal-dependent phosphoesterases (PHP family)', NULL, NULL, NULL, NULL, NULL, 4),
(112646, NULL, 'G3DSA:1.10.3330.10:FF:000001', NULL, NULL, '2-oxo-4-hydroxy-4-carboxy-5-ureidoimidazoline decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(112647, NULL, 'G3DSA:1.20.1250.20:FF:001395', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(112648, NULL, 'G3DSA:1.20.1070.10:FF:001237', NULL, NULL, 'Frizzled class receptor 6', NULL, NULL, NULL, NULL, NULL, 4),
(112649, NULL, 'G3DSA:1.10.238.10:FF:000074', NULL, NULL, 'epidermal growth factor receptor substrate 15 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(112650, NULL, 'G3DSA:3.30.40.10:FF:000709', NULL, NULL, 'Lysine-specific demethylase 5B-B', NULL, NULL, NULL, NULL, NULL, 4),
(112651, NULL, 'G3DSA:3.30.160.60:FF:005044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112652, NULL, 'G3DSA:4.10.60.10:FF:000187', NULL, NULL, 'Cold shock protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(112653, NULL, 'G3DSA:2.60.120.200:FF:000339', NULL, NULL, 'Calreticulin 3', NULL, NULL, NULL, NULL, NULL, 4),
(112654, NULL, 'G3DSA:3.80.10.10:FF:002633', NULL, NULL, 'MDIS1-interacting receptor like kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(112655, NULL, 'G3DSA:1.10.510.10:FF:004046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112656, NULL, 'G3DSA:2.40.50.140:FF:000341', NULL, NULL, 'aspartate--tRNA ligase, mitochondrial isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(112657, NULL, 'G3DSA:3.90.70.10:FF:000579', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112658, NULL, 'G3DSA:3.20.20.80:FF:000763', NULL, NULL, 'Glucosylceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(112659, NULL, 'G3DSA:1.20.1560.10:FF:000600', NULL, NULL, 'MDR-like ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(112660, NULL, 'G3DSA:3.20.20.70:FF:000721', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112661, NULL, 'G3DSA:3.30.310.10:FF:000051', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(112662, NULL, 'G3DSA:3.30.230.10:FF:000050', NULL, NULL, 'DNA topoisomerase 6 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(112663, NULL, 'G3DSA:1.25.40.10:FF:003981', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112664, NULL, 'G3DSA:1.25.10.10:FF:003316', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(112665, NULL, 'G3DSA:1.20.1730.10:FF:000012', NULL, NULL, 'sodium/myo-inositol cotransporter 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(112666, NULL, 'G3DSA:1.10.1450.10:FF:000100', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(112667, NULL, 'G3DSA:3.90.180.10:FF:000155', NULL, NULL, 'Zinc-type alcohol dehydrogenase-like protein C16A3.02c', NULL, NULL, NULL, NULL, NULL, 4),
(112668, NULL, 'G3DSA:3.40.640.10:FF:000483', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112669, NULL, 'G3DSA:1.10.1200.10:FF:000109', NULL, NULL, 'Amino acid adenylation', NULL, NULL, NULL, NULL, NULL, 4),
(112670, NULL, 'G3DSA:3.40.50.300:FF:001498', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(112671, NULL, 'G3DSA:3.20.20.140:FF:000420', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112672, NULL, 'G3DSA:3.40.50.10980:FF:000001', NULL, NULL, 'Nibrin', NULL, NULL, NULL, NULL, NULL, 4),
(112673, NULL, 'G3DSA:3.40.50.300:FF:008479', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112674, NULL, 'G3DSA:3.40.50.720:FF:000612', NULL, NULL, 'Dihydrodipicolinate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(112675, NULL, 'G3DSA:3.90.470.20:FF:000023', NULL, NULL, 'L-aminoadipate-semialdehyde dehydrogenase-phosphopantetheinyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(112676, NULL, 'G3DSA:1.10.150.50:FF:000005', NULL, NULL, 'Liprin-beta-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(112677, NULL, 'G3DSA:2.60.120.610:FF:000001', NULL, NULL, 'Probable arabinosyltransferase C', NULL, NULL, NULL, NULL, NULL, 4),
(112678, NULL, 'G3DSA:4.10.95.10:FF:000003', NULL, NULL, 'Cytochrome c oxidase subunit 6A, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(112679, NULL, 'G3DSA:3.40.1060.10:FF:000005', NULL, NULL, 'Aconitate hydratase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(112680, NULL, 'G3DSA:2.40.50.140:FF:000285', NULL, NULL, 'Exosome component 1', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(112681, NULL, 'G3DSA:1.10.150.50:FF:000129', NULL, NULL, 'Probable serine/threonine-protein kinase DDB_G0278535', NULL, NULL, NULL, NULL, NULL, 4),
(112682, NULL, 'G3DSA:1.10.246.20:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112683, NULL, 'G3DSA:3.40.50.10090:FF:000043', NULL, NULL, 'Porphyrin biosynthesis protein [includes: uroporphyrin-III C-methyltransferase and uroporphyrinogen-III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(112684, NULL, 'G3DSA:1.10.10.1180:FF:000009', NULL, NULL, 'Lap-Emerin-Man domain protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(112685, NULL, 'G3DSA:1.10.510.10:FF:000100', NULL, NULL, 'inhibitor of nuclear factor kappa-B kinase subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(112686, NULL, 'G3DSA:1.25.40.10:FF:003088', NULL, NULL, 'Pentatricopeptide repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(112687, NULL, 'G3DSA:3.40.50.1000:FF:000583', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112688, NULL, 'G3DSA:3.40.50.300:FF:004084', NULL, NULL, 'Related to ras-related GTPase rag', NULL, NULL, NULL, NULL, NULL, 4),
(112689, NULL, 'G3DSA:3.30.160.60:FF:002133', NULL, NULL, 'Zinc finger protein 175', NULL, NULL, NULL, NULL, NULL, 4),
(112690, NULL, 'G3DSA:3.90.76.10:FF:000025', NULL, NULL, 'Extracellular solute-binding protein, family 5', NULL, NULL, NULL, NULL, NULL, 4),
(112691, NULL, 'G3DSA:1.50.10.20:FF:000147', NULL, NULL, 'Terpene cyclase/mutase family member', NULL, NULL, NULL, NULL, NULL, 4),
(112692, NULL, 'G3DSA:3.40.50.300:FF:008535', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112693, NULL, 'G3DSA:3.30.420.110:FF:000066', NULL, NULL, 'Mismatch repair-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112694, NULL, 'G3DSA:3.40.30.10:FF:001170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112695, NULL, 'G3DSA:1.10.3500.10:FF:000009', NULL, NULL, 'Transcription elongation factor SPT6', NULL, NULL, NULL, NULL, NULL, 4),
(112696, NULL, 'G3DSA:3.30.160.60:FF:001733', NULL, NULL, 'zinc finger protein 827 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(112697, NULL, 'G3DSA:1.10.555.10:FF:000029', NULL, NULL, 'DEP domain-containing protein 1B isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(112698, NULL, 'G3DSA:2.60.40.10:FF:003206', NULL, NULL, 'CD83 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(112699, NULL, 'G3DSA:1.25.40.10:FF:001851', NULL, NULL, 'Mitochondrial fission 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(112700, NULL, 'G3DSA:1.20.1250.20:FF:000091', NULL, NULL, 'Lysophospholipid transporter LplT', NULL, NULL, NULL, NULL, NULL, 4),
(112701, NULL, 'G3DSA:2.60.40.10:FF:003318', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112702, NULL, 'G3DSA:1.20.1560.10:FF:000420', NULL, NULL, 'ATP-binding cassette protein subfamily B, member 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112703, NULL, 'G3DSA:1.20.58.480:FF:000006', NULL, NULL, 'Related to BNA2-tryptophan 2,3-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(112704, NULL, 'G3DSA:3.30.9.10:FF:000171', NULL, NULL, 'Bcdao11', NULL, NULL, NULL, NULL, NULL, 4),
(112705, NULL, 'G3DSA:3.30.200.20:FF:001916', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(112706, NULL, 'G3DSA:3.40.50.10190:FF:000303', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(112707, NULL, 'G3DSA:3.40.850.10:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112708, NULL, 'G3DSA:3.20.20.70:FF:000485', NULL, NULL, 'Fructose-bisphosphate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(112709, NULL, 'G3DSA:3.40.50.620:FF:000913', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112710, NULL, 'G3DSA:3.30.420.40:FF:000888', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112711, NULL, 'G3DSA:3.40.50.1820:FF:001857', NULL, NULL, 'Lipase 1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(112712, NULL, 'G3DSA:3.80.10.10:FF:003196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(112713, NULL, 'G3DSA:1.20.1070.10:FF:002081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112714, NULL, 'G3DSA:4.10.280.10:FF:000172', NULL, NULL, 'Basic helix-loop-helix (BHLH) DNA-binding superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(112715, NULL, 'G3DSA:1.50.40.10:FF:000191', NULL, NULL, 'Solute carrier family 25 member 4', NULL, NULL, NULL, NULL, NULL, 4),
(112716, NULL, 'G3DSA:3.40.850.10:FF:000089', NULL, NULL, 'Myosin VC', NULL, NULL, NULL, NULL, NULL, 4),
(112717, NULL, 'G3DSA:1.10.630.10:FF:000098', NULL, NULL, 'Cytochrome P450 71A26', NULL, NULL, NULL, NULL, NULL, 4),
(112718, NULL, 'G3DSA:1.10.10.10:FF:001264', NULL, NULL, 'Probable serine/threonine-protein kinase pats1', NULL, NULL, NULL, NULL, NULL, 4),
(112719, NULL, 'G3DSA:3.30.710.10:FF:000305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112720, NULL, 'G3DSA:3.30.160.60:FF:000896', NULL, NULL, 'Zinc finger protein 805', NULL, NULL, NULL, NULL, NULL, 4),
(112721, NULL, 'G3DSA:3.90.180.10:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112722, NULL, 'G3DSA:3.40.50.2000:FF:000950', NULL, NULL, 'Glycosyltransferase 1 domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(112723, NULL, 'G3DSA:2.60.40.1400:FF:000007', NULL, NULL, 'Inward Rectifying K (Potassium) channel family', NULL, NULL, NULL, NULL, NULL, 4),
(112724, NULL, 'G3DSA:2.30.29.30:FF:000742', NULL, NULL, 'ESCRT-II complex subunit VPS36', NULL, NULL, NULL, NULL, NULL, 4),
(112725, NULL, 'G3DSA:1.20.1250.20:FF:000046', NULL, NULL, '3-phenylpropionic acid MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(112726, NULL, 'G3DSA:3.30.70.330:FF:002036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112727, NULL, 'G3DSA:3.30.2090.10:FF:000021', NULL, NULL, 'RND multidrug efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(112728, NULL, 'G3DSA:3.80.10.10:FF:000447', NULL, NULL, 'Glucose-repressible alcohol dehydrogenase transcriptional effector', NULL, NULL, NULL, NULL, NULL, 4),
(112729, NULL, 'G3DSA:1.20.120.350:FF:000192', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112730, NULL, 'G3DSA:3.30.980.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112731, NULL, 'G3DSA:3.40.50.450:FF:000003', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(112732, NULL, 'G3DSA:1.20.920.10:FF:000096', NULL, NULL, 'PolyBRoMo domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(112733, NULL, 'G3DSA:3.10.50.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112734, NULL, 'G3DSA:3.40.50.10540:FF:000004', NULL, NULL, 'Probable alpha-methylacyl-CoA racemase mcr', NULL, NULL, NULL, NULL, NULL, 4),
(112735, NULL, 'G3DSA:1.10.510.10:FF:000679', NULL, NULL, 'Casein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112736, NULL, 'G3DSA:2.40.160.120:FF:000007', NULL, NULL, 'Oxysterol binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(112737, NULL, 'G3DSA:1.10.1040.10:FF:000069', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(112738, NULL, 'G3DSA:1.10.510.10:FF:003534', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112739, NULL, 'G3DSA:1.25.40.10:FF:000215', NULL, NULL, 'Prolyl 3-hydroxylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(112740, NULL, 'G3DSA:3.30.40.10:FF:000861', NULL, NULL, 'SH3 domain protein (AFU_orthologue AFUA_2G13880)', NULL, NULL, NULL, NULL, NULL, 4),
(112741, NULL, 'G3DSA:3.30.420.10:FF:000385', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112742, NULL, 'G3DSA:2.30.30.40:FF:000181', NULL, NULL, 'GRB2-related adapter protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(112743, NULL, 'G3DSA:1.20.58.530:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112744, NULL, 'G3DSA:3.30.1490.80:FF:000021', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(112745, NULL, 'G3DSA:2.60.120.260:FF:000194', NULL, NULL, 'Cell wall-associated protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(112746, NULL, 'G3DSA:3.40.50.300:FF:006169', NULL, NULL, 'DNA helicase II', NULL, NULL, NULL, NULL, NULL, 4),
(112747, NULL, 'G3DSA:2.130.10.10:FF:003353', NULL, NULL, 'Flagellar associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(112748, NULL, 'G3DSA:3.30.70.330:FF:000799', NULL, NULL, '31 kDa ribonucleoprotein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(112749, NULL, 'G3DSA:3.30.70.330:FF:003109', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112750, NULL, 'G3DSA:3.80.20.20:FF:000102', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(112751, NULL, 'G3DSA:3.90.650.10:FF:000023', NULL, NULL, 'Selenide water dikinase', NULL, NULL, NULL, NULL, NULL, 4),
(112752, NULL, 'G3DSA:1.10.287.370:FF:000065', NULL, NULL, 'Molecular chaperone prefoldin, subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(112753, NULL, 'G3DSA:2.10.25.10:FF:000402', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(112754, NULL, 'G3DSA:3.30.2290.10:FF:000002', NULL, NULL, 'Metalloprotease PmbA homolog', NULL, NULL, NULL, NULL, NULL, 4),
(112755, NULL, 'G3DSA:1.25.40.10:FF:005274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112756, NULL, 'G3DSA:3.40.50.620:FF:000352', NULL, NULL, 'YdcF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(112757, NULL, 'G3DSA:3.40.30.10:FF:000219', NULL, NULL, 'NADH-ubiquinone oxidoreductase 10.5 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(112758, NULL, 'G3DSA:1.20.5.490:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112759, NULL, 'G3DSA:1.10.490.10:FF:000002', NULL, NULL, 'Hemoglobin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(112760, NULL, 'G3DSA:1.10.418.20:FF:000006', NULL, NULL, 'Probable ubiquitin-like-specific protease 2A', NULL, NULL, NULL, NULL, NULL, 4),
(112761, NULL, 'G3DSA:1.10.418.10:FF:000060', NULL, NULL, 'Sperm flagellar protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(112762, NULL, 'G3DSA:3.40.50.1820:FF:000784', NULL, NULL, 'Putative serine esterase-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(112763, NULL, 'G3DSA:3.10.350.10:FF:000080', NULL, NULL, 'LysM peptidoglycan-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(112764, NULL, 'G3DSA:3.40.50.2300:FF:000826', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112765, NULL, 'G3DSA:2.30.33.40:FF:000002', NULL, NULL, '10 kDa chaperonin, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(112766, NULL, 'G3DSA:3.90.850.10:FF:000004', NULL, NULL, 'Fumarylacetoacetase', NULL, NULL, NULL, NULL, NULL, 4),
(112767, NULL, 'G3DSA:3.40.50.1110:FF:000104', NULL, NULL, 'SGNH/GDSL hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(112768, NULL, 'G3DSA:3.40.50.720:FF:001124', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(112769, NULL, 'G3DSA:1.20.1300.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112770, NULL, 'G3DSA:2.60.120.310:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112771, NULL, 'G3DSA:3.90.1150.10:FF:000372', NULL, NULL, 'O-acetylhomoserine (Thiol)-lyase MetY', NULL, NULL, NULL, NULL, NULL, 4),
(112772, NULL, 'G3DSA:2.60.40.10:FF:001464', NULL, NULL, 'Sialic acid binding Ig like lectin 15', NULL, NULL, NULL, NULL, NULL, 4),
(112773, NULL, 'G3DSA:3.30.365.10:FF:000082', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(112774, NULL, 'G3DSA:2.60.220.50:FF:000041', NULL, NULL, 'Adhesion G protein-coupled receptor E5b, duplicate 3', NULL, NULL, NULL, NULL, NULL, 4),
(112775, NULL, 'G3DSA:2.60.40.10:FF:001520', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(112776, NULL, 'G3DSA:3.30.200.20:FF:000556', NULL, NULL, 'Stretchin-Mlck, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(112777, NULL, 'G3DSA:2.60.110.10:FF:000010', NULL, NULL, 'Nuclear pore complex protein NUP96', NULL, NULL, NULL, NULL, NULL, 4),
(112778, NULL, 'G3DSA:3.80.10.10:FF:002072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(112779, NULL, 'G3DSA:1.25.40.10:FF:001564', NULL, NULL, 'Pentatricopeptide repeat-containing protein103', NULL, NULL, NULL, NULL, NULL, 4),
(112780, NULL, 'G3DSA:2.170.140.10:FF:000036', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(112781, NULL, 'G3DSA:3.30.1150.10:FF:000003', NULL, NULL, 'Protein TonB', NULL, NULL, NULL, NULL, NULL, 4),
(112782, NULL, 'G3DSA:3.80.10.10:FF:003937', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112783, NULL, 'G3DSA:3.60.40.10:FF:000225', NULL, NULL, 'Protein phosphatase 2C catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(112784, NULL, 'G3DSA:3.50.50.60:FF:000454', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(112785, NULL, 'G3DSA:1.20.1070.10:FF:000512', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112786, NULL, 'G3DSA:3.90.1430.10:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112787, NULL, 'G3DSA:3.40.33.10:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112788, NULL, 'G3DSA:1.25.10.10:FF:001051', NULL, NULL, 'Tubulin folding cofactor D', NULL, NULL, NULL, NULL, NULL, 4),
(112789, NULL, 'G3DSA:3.40.50.790:FF:000032', NULL, NULL, '39S ribosomal protein L1, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(112790, NULL, 'G3DSA:3.60.40.10:FF:000169', NULL, NULL, 'Phosphatase 2C-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(112791, NULL, 'G3DSA:3.40.50.1010:FF:000024', NULL, NULL, 'flap endonuclease GEN homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(112792, NULL, 'G3DSA:3.50.50.60:FF:000398', NULL, NULL, 'p-hydroxybenzoate hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(112793, NULL, 'G3DSA:3.40.50.150:FF:000924', NULL, NULL, 'probable 28S rRNA (Cytosine-C(5))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(112794, NULL, 'G3DSA:1.10.10.60:FF:000469', NULL, NULL, 'Homeobox protein ceh-30', NULL, NULL, NULL, NULL, NULL, 4),
(112795, NULL, 'G3DSA:3.90.190.10:FF:000504', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(112796, NULL, 'G3DSA:2.60.40.10:FF:006011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112797, NULL, 'G3DSA:1.10.472.10:FF:000281', NULL, NULL, 'Cyclin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112798, NULL, 'G3DSA:1.10.287.950:FF:000031', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(112799, NULL, 'G3DSA:2.60.120.620:FF:000061', NULL, NULL, 'GD14754', NULL, NULL, NULL, NULL, NULL, 4),
(112800, NULL, 'G3DSA:3.40.50.11610:FF:000016', NULL, NULL, '2-oxoglutarate dehydrogenase E1 component,putative', NULL, NULL, NULL, NULL, NULL, 4),
(112801, NULL, 'G3DSA:3.40.50.1470:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112802, NULL, 'G3DSA:2.60.40.10:FF:005735', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112803, NULL, 'G3DSA:2.40.50.140:FF:000902', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112804, NULL, 'G3DSA:3.80.10.10:FF:004213', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(112805, NULL, 'G3DSA:1.25.40.10:FF:003649', NULL, NULL, 'CCR4-NOT transcription complex subunit 10', NULL, NULL, NULL, NULL, NULL, 4),
(112806, NULL, 'G3DSA:3.30.70.330:FF:000855', NULL, NULL, 'SRA stem-loop-interacting RNA-binding protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(112807, NULL, 'G3DSA:1.10.1450.10:FF:000156', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(112808, NULL, 'G3DSA:1.20.930.10:FF:000034', NULL, NULL, 'Transcription elongation factor S-II', NULL, NULL, NULL, NULL, NULL, 4),
(112809, NULL, 'G3DSA:1.10.510.10:FF:001516', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112810, NULL, 'G3DSA:3.40.50.410:FF:000171', NULL, NULL, 'Tellurium resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(112811, NULL, 'G3DSA:3.40.720.10:FF:000085', NULL, NULL, 'Non-specific phospholipase C3', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(112812, NULL, 'G3DSA:3.30.420.40:FF:000545', NULL, NULL, 'Endoplasmic reticulum chaperone BiP', NULL, NULL, NULL, NULL, NULL, 4),
(112813, NULL, 'G3DSA:2.60.40.3180:FF:000007', NULL, NULL, 'Transcription factor unc-3', NULL, NULL, NULL, NULL, NULL, 4),
(112814, NULL, 'G3DSA:3.40.50.150:FF:001200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112815, NULL, 'G3DSA:1.10.2000.10:FF:000078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112816, NULL, 'G3DSA:1.10.10.10:FF:001320', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112817, NULL, 'G3DSA:3.90.1100.10:FF:000037', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(112818, NULL, 'G3DSA:2.10.60.10:FF:000028', NULL, NULL, 'Lymphocyte antigen 6 complex locus G6E', NULL, NULL, NULL, NULL, NULL, 4),
(112819, NULL, 'G3DSA:1.10.510.10:FF:001117', NULL, NULL, 'MOK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(112820, NULL, 'G3DSA:3.40.50.150:FF:001088', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112821, NULL, 'G3DSA:1.10.510.10:FF:000499', NULL, NULL, 'Serine/threonine-protein kinase KIC1', NULL, NULL, NULL, NULL, NULL, 4),
(112822, NULL, 'G3DSA:3.40.630.30:FF:000264', NULL, NULL, 'Streptothricin acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(112823, NULL, 'G3DSA:3.10.20.90:FF:000233', NULL, NULL, 'Predicted NADPH oxidase activator 1', NULL, NULL, NULL, NULL, NULL, 4),
(112824, NULL, 'G3DSA:2.160.20.10:FF:000289', NULL, NULL, 'Periplasmic copper-binding', NULL, NULL, NULL, NULL, NULL, 4),
(112825, NULL, 'G3DSA:3.30.70.330:FF:000911', NULL, NULL, 'Unplaced genomic scaffold supercont2.5, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(112826, NULL, 'G3DSA:1.20.58.390:FF:000311', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112827, NULL, 'G3DSA:3.90.245.10:FF:000020', NULL, NULL, 'Inosine-uridine preferring nucleoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(112828, NULL, 'G3DSA:1.10.10.2660:FF:000026', NULL, NULL, 'Ubiquitin-like modifier-activating enzyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(112829, NULL, 'G3DSA:3.40.367.20:FF:000036', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(112830, NULL, 'G3DSA:3.30.200.20:FF:000899', NULL, NULL, 'AGAP005471-PA', NULL, NULL, NULL, NULL, NULL, 4),
(112831, NULL, 'G3DSA:3.30.160.60:FF:005567', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112832, NULL, 'G3DSA:1.20.1250.20:FF:002176', NULL, NULL, 'Os11g0637000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(112833, NULL, 'G3DSA:1.20.144.10:FF:000078', NULL, NULL, 'PA-phosphatase related-family protein DDB_G0268928', NULL, NULL, NULL, NULL, NULL, 4),
(112834, NULL, 'G3DSA:3.30.70.560:FF:000014', NULL, NULL, 'Dihydropteroate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(112835, NULL, 'G3DSA:3.30.230.80:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112836, NULL, 'G3DSA:3.30.420.10:FF:000109', NULL, NULL, 'RNA exonuclease 3', NULL, NULL, NULL, NULL, NULL, 4),
(112837, NULL, 'G3DSA:3.30.160.60:FF:001857', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112838, NULL, 'G3DSA:1.10.238.10:FF:000579', NULL, NULL, 'NKD2, WNT signaling pathway inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(112839, NULL, 'G3DSA:2.10.25.10:FF:001419', NULL, NULL, 'Fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(112840, NULL, 'G3DSA:3.30.420.40:FF:000601', NULL, NULL, 'Actin-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(112841, NULL, 'G3DSA:1.50.40.10:FF:000039', NULL, NULL, 'Solute carrier family 25 member 35', NULL, NULL, NULL, NULL, NULL, 4),
(112842, NULL, 'G3DSA:3.30.1490.120:FF:000014', NULL, NULL, 'Related to dna-dependent rna polymerase I subunit a43 (Rpa43)', NULL, NULL, NULL, NULL, NULL, 4),
(112843, NULL, 'G3DSA:3.40.366.10:FF:000053', NULL, NULL, 'Fatty acid synthase beta subunit aflB', NULL, NULL, NULL, NULL, NULL, 4),
(112844, NULL, 'G3DSA:3.30.870.10:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(112845, NULL, 'G3DSA:3.40.50.1820:FF:000441', NULL, NULL, 'Lipoprotein lipase', NULL, NULL, NULL, NULL, NULL, 4),
(112846, NULL, 'G3DSA:1.25.10.10:FF:000775', NULL, NULL, 'Phospholipase A-2-activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112847, NULL, 'G3DSA:1.10.3410.10:FF:000002', NULL, NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(112848, NULL, 'G3DSA:3.40.1110.10:FF:000223', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(112849, NULL, 'G3DSA:3.30.300.20:FF:000047', NULL, NULL, 'Ribosome-binding factor A', NULL, NULL, NULL, NULL, NULL, 4),
(112850, NULL, 'G3DSA:3.40.50.300:FF:005045', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(112851, NULL, 'G3DSA:3.30.60.30:FF:000014', NULL, NULL, 'WAP, Kazal, immunoglobulin, Kunitz and NTR domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(112852, NULL, 'G3DSA:3.30.310.80:FF:000032', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(112853, NULL, 'G3DSA:3.90.700.10:FF:000016', NULL, NULL, 'Fumarate reductase/succinate dehydrogenase flavoprotein domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(112854, NULL, 'G3DSA:1.20.1070.10:FF:000456', NULL, NULL, 'FlaMIngo (Cadherin plus 7TM domain) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(112855, NULL, 'G3DSA:1.10.510.10:FF:003372', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112856, NULL, 'G3DSA:1.25.40.10:FF:002688', NULL, NULL, 'Signal recognition particle subunit SRP72', NULL, NULL, NULL, NULL, NULL, 4),
(112857, NULL, 'G3DSA:3.30.9.10:FF:000019', NULL, NULL, 'Hydroxyglutarate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(112858, NULL, 'G3DSA:2.130.10.10:FF:003010', NULL, NULL, 'Dynein intermediate chain', NULL, NULL, NULL, NULL, NULL, 4),
(112859, NULL, 'G3DSA:3.40.30.10:FF:000057', NULL, NULL, 'NADH-quinone oxidoreductase subunit E', NULL, NULL, NULL, NULL, NULL, 4),
(112860, NULL, 'G3DSA:3.40.50.410:FF:000019', NULL, NULL, 'SEC24 homolog B, COPII coat complex component', NULL, NULL, NULL, NULL, NULL, 4),
(112861, NULL, 'G3DSA:1.20.120.220:FF:000001', NULL, NULL, 'ATP synthase subunit a, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(112862, NULL, 'G3DSA:3.90.470.20:FF:000079', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(112863, NULL, 'G3DSA:2.10.10.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112864, NULL, 'G3DSA:2.60.120.1000:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112865, NULL, 'G3DSA:3.30.70.3400:FF:000007', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(112866, NULL, 'G3DSA:3.40.50.1000:FF:000307', NULL, NULL, 'Polynucleotide kinase 3''-phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112867, NULL, 'G3DSA:3.40.50.150:FF:000183', NULL, NULL, 'Geranyl diphosphate 2-C-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(112868, NULL, 'G3DSA:3.40.50.300:FF:002116', NULL, NULL, 'ATP-dependent DNA helicase UvrD', NULL, NULL, NULL, NULL, NULL, 4),
(112869, NULL, 'G3DSA:1.10.630.10:FF:000278', NULL, NULL, 'Cytochrome P450 3A12', NULL, NULL, NULL, NULL, NULL, 4),
(112870, NULL, 'G3DSA:3.30.420.110:FF:000010', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(112871, NULL, 'G3DSA:1.10.220.20:FF:000002', NULL, NULL, 'Brefeldin A-inhibited guanine nucleotide-exchange protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(112872, NULL, 'G3DSA:3.60.15.10:FF:000245', NULL, NULL, 'Coenzyme PQQ synthesis protein B', NULL, NULL, NULL, NULL, NULL, 4),
(112873, NULL, 'G3DSA:1.20.1270.250:FF:000005', NULL, NULL, 'AGAP009166-PA', NULL, NULL, NULL, NULL, NULL, 4),
(112874, NULL, 'G3DSA:3.30.160.60:FF:006404', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112875, NULL, 'G3DSA:3.40.50.360:FF:000021', NULL, NULL, 'Nitric oxide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(112876, NULL, 'G3DSA:2.60.15.10:FF:000028', NULL, NULL, 'ATP synthase epsilon chain', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(112877, NULL, 'G3DSA:3.30.200.20:FF:002136', NULL, NULL, 'GH04968p', NULL, NULL, NULL, NULL, NULL, 4),
(112878, NULL, 'G3DSA:3.40.30.10:FF:000950', NULL, NULL, 'CaDmium Responsive', NULL, NULL, NULL, NULL, NULL, 4),
(112879, NULL, 'G3DSA:2.60.120.260:FF:000374', NULL, NULL, 'Teneurin-m-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(112880, NULL, 'G3DSA:3.40.50.300:FF:001678', NULL, NULL, 'Disks large 5', NULL, NULL, NULL, NULL, NULL, 4),
(112881, NULL, 'G3DSA:3.30.2410.10:FF:000007', NULL, NULL, 'Putative E3 ubiquitin-protein ligase HECTD1', NULL, NULL, NULL, NULL, NULL, 4),
(112882, NULL, 'G3DSA:3.20.20.140:FF:000364', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112883, NULL, 'G3DSA:1.20.1250.20:FF:002232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112884, NULL, 'G3DSA:1.10.10.10:FF:000483', NULL, NULL, 'Transcriptional coactivator ADA2', NULL, NULL, NULL, NULL, NULL, 4),
(112885, NULL, 'G3DSA:2.60.120.260:FF:000430', NULL, NULL, 'beta-galactosidase-1-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(112886, NULL, 'G3DSA:1.20.1560.10:FF:000364', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112887, NULL, 'G3DSA:3.30.160.60:FF:001677', NULL, NULL, 'Zinc finger protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(112888, NULL, 'G3DSA:2.60.120.10:FF:000016', NULL, NULL, 'Pyrimidine/purine nucleoside phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(112889, NULL, 'G3DSA:3.40.190.290:FF:000069', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(112890, NULL, 'G3DSA:3.30.50.10:FF:000182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112891, NULL, 'G3DSA:1.25.10.10:FF:002012', NULL, NULL, 'YALI0D22440p', NULL, NULL, NULL, NULL, NULL, 4),
(112892, NULL, 'G3DSA:1.20.1510.10:FF:000029', NULL, NULL, 'Zinc transporter 7', NULL, NULL, NULL, NULL, NULL, 4),
(112893, NULL, 'G3DSA:1.25.40.10:FF:003144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112894, NULL, 'G3DSA:3.40.50.720:FF:001961', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112895, NULL, 'G3DSA:3.50.50.60:FF:001415', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112896, NULL, 'G3DSA:1.10.510.10:FF:001792', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112897, NULL, 'G3DSA:3.40.50.720:FF:000668', NULL, NULL, 'Unplaced genomic scaffold supercont1.13, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(112898, NULL, 'G3DSA:1.25.40.10:FF:003306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112899, NULL, 'G3DSA:1.25.10.10:FF:001736', NULL, NULL, 'Protein SINE1', NULL, NULL, NULL, NULL, NULL, 4),
(112900, NULL, 'G3DSA:3.40.50.2000:FF:000219', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(112901, NULL, 'G3DSA:3.30.160.60:FF:006348', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112902, NULL, 'G3DSA:3.20.20.70:FF:000142', NULL, NULL, 'bifunctional 3-dehydroquinate dehydratase/shikimate dehydrogenase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(112903, NULL, 'G3DSA:1.20.1250.20:FF:001956', NULL, NULL, 'Uncharacterized membrane protein C14C4.07', NULL, NULL, NULL, NULL, NULL, 4),
(112904, NULL, 'G3DSA:2.60.40.1730:FF:000090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112905, NULL, 'G3DSA:3.20.20.140:FF:000240', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(112906, NULL, 'G3DSA:3.40.50.300:FF:005949', NULL, NULL, 'DNA mismatch repair protein Msh2', NULL, NULL, NULL, NULL, NULL, 4),
(112907, NULL, 'G3DSA:1.10.3860.10:FF:000030', NULL, NULL, 'C4-dicarboxylate transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(112908, NULL, 'G3DSA:1.20.1250.20:FF:002356', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112909, NULL, 'G3DSA:2.60.120.650:FF:000221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(112910, NULL, 'G3DSA:3.30.530.20:FF:000036', NULL, NULL, 'Homeobox-leucine zipper protein HDG7', NULL, NULL, NULL, NULL, NULL, 4),
(112911, NULL, 'G3DSA:3.30.360.10:FF:000110', NULL, NULL, 'Aspartate-semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(112912, NULL, 'G3DSA:3.90.810.10:FF:000007', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(112913, NULL, 'G3DSA:1.20.58.60:FF:000450', NULL, NULL, 'Spectrin beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(112914, NULL, 'G3DSA:3.40.720.10:FF:000141', NULL, NULL, 'Alkaline phosphatase PhoK', NULL, NULL, NULL, NULL, NULL, 4),
(112915, NULL, 'G3DSA:3.30.40.10:FF:000024', NULL, NULL, 'RING finger protein 44 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(112916, NULL, 'G3DSA:1.20.5.730:FF:000003', NULL, NULL, 'rab GTPase-binding effector protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(112917, NULL, 'G3DSA:3.20.20.100:FF:000200', NULL, NULL, 'Aldo-keto reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112918, NULL, 'G3DSA:1.20.920.30:FF:000034', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112919, NULL, 'G3DSA:1.25.40.420:FF:000053', NULL, NULL, 'BTB/POZ domain-containing protein 6-B', NULL, NULL, NULL, NULL, NULL, 4),
(112920, NULL, 'G3DSA:1.20.920.10:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112921, NULL, 'G3DSA:3.90.1200.10:FF:000022', NULL, NULL, 'Choline Kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(112922, NULL, 'G3DSA:3.30.40.10:FF:002098', NULL, NULL, 'LD43541p', NULL, NULL, NULL, NULL, NULL, 4),
(112923, NULL, 'G3DSA:2.130.10.10:FF:005483', NULL, NULL, 'Protein CBR-ELPC-2', NULL, NULL, NULL, NULL, NULL, 4),
(112924, NULL, 'G3DSA:3.40.50.300:FF:001155', NULL, NULL, 'minichromosome maintenance domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(112925, NULL, 'G3DSA:1.20.120.1240:FF:000061', NULL, NULL, 'Dynamin-related GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(112926, NULL, 'G3DSA:1.10.10.10:FF:001500', NULL, NULL, 'Transcriptional regulator LdrP', NULL, NULL, NULL, NULL, NULL, 4),
(112927, NULL, 'G3DSA:1.25.70.10:FF:000043', NULL, NULL, 'At1g61990/F8K4_18', NULL, NULL, NULL, NULL, NULL, 4),
(112928, NULL, 'G3DSA:3.90.550.10:FF:000695', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112929, NULL, 'G3DSA:3.80.10.10:FF:002976', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112930, NULL, 'G3DSA:3.40.50.300:FF:004589', NULL, NULL, 'SNF2 DNA repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112931, NULL, 'G3DSA:2.60.40.10:FF:004898', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112932, NULL, 'G3DSA:2.40.50.90:FF:000084', NULL, NULL, 'Tudor domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(112933, NULL, 'G3DSA:3.30.70.20:FF:000074', NULL, NULL, 'DNA-directed RNA polymerase I-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(112934, NULL, 'G3DSA:3.30.420.10:FF:000441', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112935, NULL, 'G3DSA:3.30.1360.180:FF:000003', NULL, NULL, 'Type I phosphodiesterase/nucleotide pyrophosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(112936, NULL, 'G3DSA:2.60.40.10:FF:004774', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112937, NULL, 'G3DSA:3.60.40.10:FF:000045', NULL, NULL, 'Stage II sporulation protein E', NULL, NULL, NULL, NULL, NULL, 4),
(112938, NULL, 'G3DSA:2.60.200.20:FF:000115', NULL, NULL, 'E3 ubiquitin-protein ligase CHFR isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(112939, NULL, 'G3DSA:1.25.40.10:FF:002868', NULL, NULL, 'Peroxisomal biogenesis factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(112940, NULL, 'G3DSA:3.90.190.10:FF:000448', NULL, NULL, 'Protein-tyrosine phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112941, NULL, 'G3DSA:1.25.40.10:FF:003705', NULL, NULL, 'Cell division cycle protein 23 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(112942, NULL, 'G3DSA:2.60.40.10:FF:005174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(112943, NULL, 'G3DSA:2.30.29.30:FF:000163', NULL, NULL, 'unconventional myosin-X', NULL, NULL, NULL, NULL, NULL, 4),
(112944, NULL, 'G3DSA:1.10.10.10:FF:000207', NULL, NULL, 'Cullin 9', NULL, NULL, NULL, NULL, NULL, 4),
(112945, NULL, 'G3DSA:3.40.850.10:FF:000145', NULL, NULL, 'Myosin XIX', NULL, NULL, NULL, NULL, NULL, 4),
(112946, NULL, 'G3DSA:3.30.450.20:FF:000558', NULL, NULL, 'C4-dicarboxylate transport sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(112947, NULL, 'G3DSA:3.30.70.330:FF:000294', NULL, NULL, 'Serine/arginine-rich splicing factor RS31', NULL, NULL, NULL, NULL, NULL, 4),
(112948, NULL, 'G3DSA:3.30.450.30:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112949, NULL, 'G3DSA:3.30.1680.10:FF:000032', NULL, NULL, 'Plexin A2', NULL, NULL, NULL, NULL, NULL, 4),
(112950, NULL, 'G3DSA:3.40.50.150:FF:000868', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112951, NULL, 'G3DSA:3.40.630.30:FF:000320', NULL, NULL, 'N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(112952, NULL, 'G3DSA:3.90.190.10:FF:000324', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112953, NULL, 'G3DSA:3.40.50.300:FF:008299', NULL, NULL, 'Protein CBG18556', NULL, NULL, NULL, NULL, NULL, 4),
(112954, NULL, 'G3DSA:2.30.29.30:FF:000686', NULL, NULL, 'Kinesin', NULL, NULL, NULL, NULL, NULL, 4),
(112955, NULL, 'G3DSA:1.10.630.10:FF:000154', NULL, NULL, 'Cytochrome P450 135B1', NULL, NULL, NULL, NULL, NULL, 4),
(112956, NULL, 'G3DSA:3.40.50.300:FF:005388', NULL, NULL, 'Replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(112957, NULL, 'G3DSA:3.40.50.2000:FF:000894', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(112958, NULL, 'G3DSA:3.40.50.720:FF:001629', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(112959, NULL, 'G3DSA:3.40.50.150:FF:001144', NULL, NULL, 'N(4)-bis(aminopropyl)spermidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(112960, NULL, 'G3DSA:3.30.450.20:FF:000035', NULL, NULL, 'Aryl hydrocarbon receptor', NULL, NULL, NULL, NULL, NULL, 4),
(112961, NULL, 'G3DSA:1.10.8.10:FF:000116', NULL, NULL, 'Holliday junction ATP-dependent DNA helicase RuvA', NULL, NULL, NULL, NULL, NULL, 4),
(112962, NULL, 'G3DSA:3.30.160.60:FF:005387', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112963, NULL, 'G3DSA:3.90.1200.10:FF:000073', NULL, NULL, 'Choline/ethanolamine kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112964, NULL, 'G3DSA:2.30.29.30:FF:000927', NULL, NULL, 'Cyclic GMP-binding protein D', NULL, NULL, NULL, NULL, NULL, 4),
(112965, NULL, 'G3DSA:1.20.1070.10:FF:000872', NULL, NULL, 'C1A receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112966, NULL, 'G3DSA:1.20.1270.10:FF:000061', NULL, NULL, 'Heat shock protein family A (Hsp70) member 5', NULL, NULL, NULL, NULL, NULL, 4),
(112967, NULL, 'G3DSA:3.40.50.300:FF:008395', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(112968, NULL, 'G3DSA:3.40.190.10:FF:000830', NULL, NULL, 'Putative ABC transporter binding lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(112969, NULL, 'G3DSA:3.30.160.60:FF:001065', NULL, NULL, 'PR domain zinc finger protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(112970, NULL, 'G3DSA:1.10.575.10:FF:000008', NULL, NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(112971, NULL, 'G3DSA:3.40.850.10:FF:000049', NULL, NULL, 'kinesin-like protein KIF20B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(112972, NULL, 'G3DSA:1.10.8.60:FF:000114', NULL, NULL, 'Transcriptional regulator RtcR', NULL, NULL, NULL, NULL, NULL, 4),
(112973, NULL, 'G3DSA:2.170.270.10:FF:000192', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(112974, NULL, 'G3DSA:1.20.1170.10:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112975, NULL, 'G3DSA:1.10.510.10:FF:003681', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112976, NULL, 'G3DSA:3.80.10.10:FF:000054', NULL, NULL, 'FLII, actin remodeling protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(112977, NULL, 'G3DSA:2.60.40.10:FF:001632', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(112978, NULL, 'G3DSA:3.40.50.410:FF:000103', NULL, NULL, 'Sec23/sec24 transport family protein', NULL, NULL, NULL, NULL, NULL, 4),
(112979, NULL, 'G3DSA:3.30.160.60:FF:001109', NULL, NULL, 'Zinc finger protein 407', NULL, NULL, NULL, NULL, NULL, 4),
(112980, NULL, 'G3DSA:1.10.600.10:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112981, NULL, 'G3DSA:3.30.70.1590:FF:000003', NULL, NULL, 'Myosin-Va isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(112982, NULL, 'G3DSA:1.10.8.10:FF:000162', NULL, NULL, 'Folate receptor alpha', NULL, NULL, NULL, NULL, NULL, 4),
(112983, NULL, 'G3DSA:2.40.37.10:FF:000063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112984, NULL, 'G3DSA:1.10.150.50:FF:000045', NULL, NULL, 'SAM domain, SH3 domain and nuclear localization signals 1', NULL, NULL, NULL, NULL, NULL, 4),
(112985, NULL, 'G3DSA:3.30.70.330:FF:001968', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112986, NULL, 'G3DSA:3.50.50.60:FF:000342', NULL, NULL, 'Pyridine nucleotide-disulfide oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(112987, NULL, 'G3DSA:1.10.10.10:FF:000691', NULL, NULL, 'Hydrogen peroxide-inducible genes activator', NULL, NULL, NULL, NULL, NULL, 4),
(112988, NULL, 'G3DSA:3.40.50.300:FF:001470', NULL, NULL, 'Interferon-induced guanylate-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(112989, NULL, 'G3DSA:3.40.50.1820:FF:000901', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(112990, NULL, 'G3DSA:3.30.300.180:FF:000009', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(112991, NULL, 'G3DSA:3.30.1120.90:FF:000008', NULL, NULL, 'Vacuolar sorting protein', NULL, NULL, NULL, NULL, NULL, 4),
(112992, NULL, 'G3DSA:3.20.20.10:FF:000074', NULL, NULL, 'Os04g0136500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(112993, NULL, 'G3DSA:2.60.40.10:FF:004858', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(112994, NULL, 'G3DSA:1.20.810.10:FF:000003', NULL, NULL, 'Menaquinol-Cytochrome c reductase cytochrome b6 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(112995, NULL, 'G3DSA:2.60.120.330:FF:000114', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(112996, NULL, 'G3DSA:2.60.120.260:FF:000278', NULL, NULL, 'Glycosyl hydrolase family 85', NULL, NULL, NULL, NULL, NULL, 4),
(112997, NULL, 'G3DSA:3.40.50.300:FF:003605', NULL, NULL, 'GM25836', NULL, NULL, NULL, NULL, NULL, 4),
(112998, NULL, 'G3DSA:2.60.40.10:FF:001099', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(112999, NULL, 'G3DSA:3.90.1150.10:FF:000057', NULL, NULL, 'Acetylornithine aminotransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(113000, NULL, 'G3DSA:3.90.470.10:FF:000054', NULL, NULL, 'Ribosomal protein L22, putative', NULL, NULL, NULL, NULL, NULL, 4),
(113001, NULL, 'G3DSA:3.30.160.60:FF:005443', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113002, NULL, 'G3DSA:3.30.420.40:FF:000961', NULL, NULL, 'ARP1 actin related protein 1 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(113003, NULL, 'G3DSA:1.25.40.180:FF:000126', NULL, NULL, 'Zinc finger CCCH domain-containing protein 43', NULL, NULL, NULL, NULL, NULL, 4),
(113004, NULL, 'G3DSA:3.80.10.10:FF:002780', NULL, NULL, 'Leucine-rich repeat-containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(113005, NULL, 'G3DSA:2.60.40.2690:FF:000012', NULL, NULL, 'AEL014Cp', NULL, NULL, NULL, NULL, NULL, 4),
(113006, NULL, 'G3DSA:3.90.550.10:FF:000690', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113007, NULL, 'G3DSA:1.10.1420.10:FF:000087', NULL, NULL, 'Endonuclease MutS2', NULL, NULL, NULL, NULL, NULL, 4),
(113008, NULL, 'G3DSA:3.20.20.80:FF:000634', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113009, NULL, 'G3DSA:1.20.5.370:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113010, NULL, 'G3DSA:3.40.430.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(113011, NULL, 'G3DSA:1.20.1250.20:FF:000647', NULL, NULL, 'Autophagy-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(113012, NULL, 'G3DSA:1.50.40.10:FF:000308', NULL, NULL, 'Mitochondrial substrate carrier family protein', NULL, NULL, NULL, NULL, NULL, 4),
(113013, NULL, 'G3DSA:1.50.10.10:FF:000127', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(113014, NULL, 'G3DSA:1.10.287.890:FF:000001', NULL, NULL, 'tRNA dimethylallyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(113015, NULL, 'G3DSA:3.40.50.300:FF:004224', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(113016, NULL, 'G3DSA:2.10.110.10:FF:000280', NULL, NULL, 'YALI0F13211p', NULL, NULL, NULL, NULL, NULL, 4),
(113017, NULL, 'G3DSA:3.40.720.10:FF:000293', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(113018, NULL, 'G3DSA:3.30.1370.100:FF:000021', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(113019, NULL, 'G3DSA:1.10.510.10:FF:002736', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(113020, NULL, 'G3DSA:1.10.640.10:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113021, NULL, 'G3DSA:1.25.40.10:FF:004734', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113022, NULL, 'G3DSA:1.25.10.10:FF:000854', NULL, NULL, 'Heat repeat domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(113023, NULL, 'G3DSA:2.60.34.10:FF:000067', NULL, NULL, 'Luminal-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(113024, NULL, 'G3DSA:3.30.160.60:FF:002054', NULL, NULL, 'Zinc finger protein 460', NULL, NULL, NULL, NULL, NULL, 4),
(113025, NULL, 'G3DSA:2.40.50.40:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113026, NULL, 'G3DSA:1.20.1270.60:FF:000082', NULL, NULL, 'Endophilin B, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(113027, NULL, 'G3DSA:3.30.70.330:FF:002587', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113028, NULL, 'G3DSA:2.40.20.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113029, NULL, 'G3DSA:1.25.10.10:FF:001843', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113030, NULL, 'G3DSA:2.60.40.150:FF:000596', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113031, NULL, 'G3DSA:3.40.1390.10:FF:000007', NULL, NULL, 'UDP-N-acetylmuramoyl-L-alanyl-D-glutamate--2,6-diaminopimelate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(113032, NULL, 'G3DSA:1.20.1250.20:FF:000208', NULL, NULL, 'solute carrier family 2, facilitated glucose transporter member 10', NULL, NULL, NULL, NULL, NULL, 4),
(113033, NULL, 'G3DSA:3.40.630.30:FF:000180', NULL, NULL, 'RNA cytidine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(113034, NULL, 'G3DSA:3.30.160.60:FF:001548', NULL, NULL, 'Zinc finger protein 277, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(113035, NULL, 'G3DSA:3.80.10.10:FF:002341', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(113036, NULL, 'G3DSA:3.30.200.20:FF:002237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113037, NULL, 'G3DSA:1.10.620.20:FF:000038', NULL, NULL, 'Delta-9-ACP desaturase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(113038, NULL, 'G3DSA:2.130.10.10:FF:005016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113039, NULL, 'G3DSA:1.10.287.1490:FF:000087', NULL, NULL, 'Structural maintenance of chromosomes protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(113040, NULL, 'G3DSA:1.20.58.1220:FF:000013', NULL, NULL, 'Exocyst complex component 8', NULL, NULL, NULL, NULL, NULL, 4),
(113041, NULL, 'G3DSA:3.10.110.10:FF:000197', NULL, NULL, 'Probable serine/threonine-protein kinase ifkC', NULL, NULL, NULL, NULL, NULL, 4),
(113042, NULL, 'G3DSA:1.20.120.1110:FF:000005', NULL, NULL, 'Nervy', NULL, NULL, NULL, NULL, NULL, 4),
(113043, NULL, 'G3DSA:1.10.3080.10:FF:000015', NULL, NULL, 'Chloride channel protein EriC', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(113044, NULL, 'G3DSA:3.30.1410.10:FF:000001', NULL, NULL, 'GTP cyclohydrolase 1 feedback regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(113045, NULL, 'G3DSA:2.10.25.10:FF:000407', NULL, NULL, 'Laminin subunit alpha-3', NULL, NULL, NULL, NULL, NULL, 4),
(113046, NULL, 'G3DSA:3.30.40.10:FF:000788', NULL, NULL, 'Unplaced genomic scaffold supercont1.168, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(113047, NULL, 'G3DSA:1.20.58.2220:FF:000004', NULL, NULL, 'Formin homology 2 domain-containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(113048, NULL, 'G3DSA:3.40.50.2000:FF:000782', NULL, NULL, 'Digalactosyldiacylglycerol synthase 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(113049, NULL, 'G3DSA:1.20.1070.10:FF:001052', NULL, NULL, 'Retinal pigment epithelium derived rhodopsin homolog (Predicted), isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(113050, NULL, 'G3DSA:3.80.10.10:FF:001835', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113051, NULL, 'G3DSA:4.10.280.110:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113052, NULL, 'G3DSA:2.60.200.20:FF:000014', NULL, NULL, 'FHA domain-containing protein FHA2', NULL, NULL, NULL, NULL, NULL, 4),
(113053, NULL, 'G3DSA:3.20.20.80:FF:000151', NULL, NULL, 'Glucan endo-1,3-beta-glucosidase btgC', NULL, NULL, NULL, NULL, NULL, 4),
(113054, NULL, 'G3DSA:2.10.25.140:FF:000007', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(113055, NULL, 'G3DSA:2.30.30.40:FF:000681', NULL, NULL, 'Variant SH3 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(113056, NULL, 'G3DSA:3.40.1440.10:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113057, NULL, 'G3DSA:1.10.510.10:FF:002253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113058, NULL, 'G3DSA:3.30.930.10:FF:000384', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113059, NULL, 'G3DSA:3.30.70.330:FF:003093', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113060, NULL, 'G3DSA:1.25.40.10:FF:000682', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g16610', NULL, NULL, NULL, NULL, NULL, 4),
(113061, NULL, 'G3DSA:2.60.120.340:FF:000004', NULL, NULL, 'Histone deacetylase HDT1', NULL, NULL, NULL, NULL, NULL, 4),
(113062, NULL, 'G3DSA:1.20.1250.20:FF:000490', NULL, NULL, 'Solute carrier family 16 member 6', NULL, NULL, NULL, NULL, NULL, 4),
(113063, NULL, 'G3DSA:3.30.40.10:FF:001305', NULL, NULL, 'E3 ubiquitin-protein ligase MBR2', NULL, NULL, NULL, NULL, NULL, 4),
(113064, NULL, 'G3DSA:3.30.70.330:FF:003104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113065, NULL, 'G3DSA:3.80.20.20:FF:000029', NULL, NULL, 'Sps22p', NULL, NULL, NULL, NULL, NULL, 4),
(113066, NULL, 'G3DSA:3.20.20.140:FF:000280', NULL, NULL, 'Adenosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(113067, NULL, 'G3DSA:3.30.70.3030:FF:000003', NULL, NULL, 'U3 small nucleolar RNA-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(113068, NULL, 'G3DSA:1.25.10.10:FF:001360', NULL, NULL, 'Armadillo-type protein', NULL, NULL, NULL, NULL, NULL, 4),
(113069, NULL, 'G3DSA:1.10.238.10:FF:000675', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(113070, NULL, 'G3DSA:1.10.10.160:FF:000001', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(113071, NULL, 'G3DSA:3.40.50.620:FF:000357', NULL, NULL, 'Nicotinate/nicotinamide mononucleotide adenyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(113072, NULL, 'G3DSA:3.30.56.30:FF:000004', NULL, NULL, 'Signal recognition particle 19 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(113073, NULL, 'G3DSA:1.10.268.10:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113074, NULL, 'G3DSA:3.10.290.20:FF:000010', NULL, NULL, 'NEDD8-activating enzyme E1 catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(113075, NULL, 'G3DSA:3.40.50.150:FF:001273', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113076, NULL, 'G3DSA:3.40.50.720:FF:001360', NULL, NULL, 'Prephenate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(113077, NULL, 'G3DSA:4.10.365.10:FF:000003', NULL, NULL, 'cyclin-dependent kinase inhibitor 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(113078, NULL, 'G3DSA:3.40.50.720:FF:000724', NULL, NULL, 'C-terminal-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(113079, NULL, 'G3DSA:3.70.10.10:FF:000032', NULL, NULL, 'Proliferating cell nuclear antigen', NULL, NULL, NULL, NULL, NULL, 4),
(113080, NULL, 'G3DSA:1.10.510.10:FF:000336', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(113081, NULL, 'G3DSA:3.40.50.1220:FF:000076', NULL, NULL, 'N(2)-(2-carboxyethyl)arginine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(113082, NULL, 'G3DSA:3.40.50.2300:FF:000635', NULL, NULL, 'GLutamate Receptor family (AMPA)', NULL, NULL, NULL, NULL, NULL, 4),
(113083, NULL, 'G3DSA:3.30.160.60:FF:000929', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(113084, NULL, 'G3DSA:1.10.1040.10:FF:000102', NULL, NULL, 'Ketose-bisphosphate aldolase class-II family protein', NULL, NULL, NULL, NULL, NULL, 4),
(113085, NULL, 'G3DSA:3.40.50.300:FF:005961', NULL, NULL, 'Ferrous iron transporter B', NULL, NULL, NULL, NULL, NULL, 4),
(113086, NULL, 'G3DSA:3.30.70.330:FF:000187', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein Q', NULL, NULL, NULL, NULL, NULL, 4),
(113087, NULL, 'G3DSA:3.40.910.10:FF:000004', NULL, NULL, 'Probable deoxyhypusine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(113088, NULL, 'G3DSA:3.40.50.11350:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113089, NULL, 'G3DSA:3.30.360.10:FF:000003', NULL, NULL, 'Inositol-3-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(113090, NULL, 'G3DSA:3.40.50.1400:FF:000006', NULL, NULL, 'Ferrochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(113091, NULL, 'G3DSA:3.80.10.10:FF:004106', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(113092, NULL, 'G3DSA:3.30.830.10:FF:000011', NULL, NULL, 'Presequence protease, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(113093, NULL, 'G3DSA:1.25.40.10:FF:004425', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113094, NULL, 'G3DSA:1.25.10.10:FF:003288', NULL, NULL, 'Zer1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(113095, NULL, 'G3DSA:2.30.110.10:FF:000101', NULL, NULL, 'Flavin reductase (NADPH)', NULL, NULL, NULL, NULL, NULL, 4),
(113096, NULL, 'G3DSA:3.30.450.50:FF:000027', NULL, NULL, 'vesicle-associated membrane protein 714-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(113097, NULL, 'G3DSA:3.40.50.2300:FF:000765', NULL, NULL, 'Vomeronasal 2 receptor, h32', NULL, NULL, NULL, NULL, NULL, 4),
(113098, NULL, 'G3DSA:1.25.40.20:FF:001657', NULL, NULL, 'BTB/POZ domain and ankyrin repeat-containing protein NOOT2', NULL, NULL, NULL, NULL, NULL, 4),
(113099, NULL, 'G3DSA:1.25.40.10:FF:003436', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g49170, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(113100, NULL, 'G3DSA:3.40.50.1110:FF:000043', NULL, NULL, 'Esterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(113101, NULL, 'G3DSA:2.60.40.420:FF:000261', NULL, NULL, 'Os11g0426400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(113102, NULL, 'G3DSA:3.40.1190.10:FF:000026', NULL, NULL, 'Bifunctional folylpolyglutamate synthase/dihydrofolate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(113103, NULL, 'G3DSA:3.30.40.10:FF:002250', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(113104, NULL, 'G3DSA:2.20.100.10:FF:000170', NULL, NULL, 'Semaphorin-5c', NULL, NULL, NULL, NULL, NULL, 4),
(113105, NULL, 'G3DSA:3.40.190.10:FF:000493', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(113106, NULL, 'G3DSA:3.10.330.10:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113107, NULL, 'G3DSA:3.40.50.150:FF:000784', NULL, NULL, 'Probable BsuMI modification methylase subunit YdiO', NULL, NULL, NULL, NULL, NULL, 4),
(113108, NULL, 'G3DSA:3.30.70.260:FF:000042', NULL, NULL, 'Sigma-54 dependent transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(113109, NULL, 'G3DSA:3.40.50.1000:FF:000774', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113110, NULL, 'G3DSA:2.10.25.10:FF:001043', NULL, NULL, 'von Willebrand factor D and EGF domains', NULL, NULL, NULL, NULL, NULL, 4),
(113111, NULL, 'G3DSA:2.60.40.60:FF:000697', NULL, NULL, 'Cdh-4', NULL, NULL, NULL, NULL, NULL, 4),
(113112, NULL, 'G3DSA:1.10.405.10:FF:000013', NULL, NULL, 'GDP dissociation inhibitor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(113113, NULL, 'G3DSA:3.40.225.10:FF:000007', NULL, NULL, 'Methylthioribulose-1-phosphate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(113114, NULL, 'G3DSA:3.30.420.40:FF:000652', NULL, NULL, 'Actin-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(113115, NULL, 'G3DSA:3.40.50.300:FF:006950', NULL, NULL, 'Telomere length regulation protein elg1', NULL, NULL, NULL, NULL, NULL, 4),
(113116, NULL, 'G3DSA:1.10.287.70:FF:000317', NULL, NULL, 'Voltage-gated Ca2+ channel, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(113117, NULL, 'G3DSA:3.20.70.20:FF:000012', NULL, NULL, 'Formate C-acetyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(113118, NULL, 'G3DSA:1.20.1410.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113119, NULL, 'G3DSA:2.130.10.10:FF:002392', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113120, NULL, 'G3DSA:1.20.1420.30:FF:000028', NULL, NULL, 'Cation/calcium exchanger 5', NULL, NULL, NULL, NULL, NULL, 4),
(113121, NULL, 'G3DSA:1.20.1050.10:FF:000180', NULL, NULL, 'Phi class glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(113122, NULL, 'G3DSA:2.60.40.60:FF:000242', NULL, NULL, 'Cadherin 16, KSP-cadherin', NULL, NULL, NULL, NULL, NULL, 4),
(113123, NULL, 'G3DSA:3.40.50.300:FF:002307', NULL, NULL, 'Guanine nucleotide-binding protein G(k) subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(113124, NULL, 'G3DSA:1.20.5.4820:FF:000003', NULL, NULL, 'Unconventional myosin ID', NULL, NULL, NULL, NULL, NULL, 4),
(113125, NULL, 'G3DSA:3.40.50.300:FF:005652', NULL, NULL, 'Nucleotide-binding oligomerization domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(113126, NULL, 'G3DSA:2.10.70.10:FF:000052', NULL, NULL, 'Complement factor B', NULL, NULL, NULL, NULL, NULL, 4),
(113127, NULL, 'G3DSA:2.170.300.10:FF:000043', NULL, NULL, 'Multiple EGF-like-domains 10', NULL, NULL, NULL, NULL, NULL, 4),
(113128, NULL, 'G3DSA:3.90.110.10:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113129, NULL, 'G3DSA:2.60.40.10:FF:005814', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113130, NULL, 'G3DSA:3.30.160.60:FF:001418', NULL, NULL, 'Zinc finger protein 770', NULL, NULL, NULL, NULL, NULL, 4),
(113131, NULL, 'G3DSA:2.60.120.920:FF:000066', NULL, NULL, 'Si:ch211-208f21.3', NULL, NULL, NULL, NULL, NULL, 4),
(113132, NULL, 'G3DSA:3.30.1490.20:FF:000026', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(113133, NULL, 'G3DSA:2.40.50.140:FF:000993', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113134, NULL, 'G3DSA:2.30.30.190:FF:000028', NULL, NULL, 'DyNactin Complex component', NULL, NULL, NULL, NULL, NULL, 4),
(113135, NULL, 'G3DSA:3.30.40.10:FF:000316', NULL, NULL, 'E3 ubiquitin-protein ligase RNF180', NULL, NULL, NULL, NULL, NULL, 4),
(113136, NULL, 'G3DSA:2.30.29.30:FF:000618', NULL, NULL, 'Pleckstrin homology (PH) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(113137, NULL, 'G3DSA:2.30.42.10:FF:000137', NULL, NULL, 'Synaptopodin 2-like a', NULL, NULL, NULL, NULL, NULL, 4),
(113138, NULL, 'G3DSA:3.40.50.2300:FF:001254', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113139, NULL, 'G3DSA:1.20.58.60:FF:000270', NULL, NULL, 'Microtubule-actin cross-linking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(113140, NULL, 'G3DSA:3.40.50.1220:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113141, NULL, 'G3DSA:2.40.240.10:FF:000001', NULL, NULL, 'Glutamine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(113142, NULL, 'G3DSA:3.40.50.261:FF:000003', NULL, NULL, 'ATP-citrate synthase subunit', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(113143, NULL, 'G3DSA:1.50.10.130:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113144, NULL, 'G3DSA:3.40.47.10:FF:000185', NULL, NULL, 'BIOTIN PIMELOYL-COA SYNTHESIS PROTEIN', NULL, NULL, NULL, NULL, NULL, 4),
(113145, NULL, 'G3DSA:3.30.200.20:FF:000955', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(113146, NULL, 'G3DSA:2.60.40.10:FF:005494', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113147, NULL, 'G3DSA:1.10.472.80:FF:000211', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113148, NULL, 'G3DSA:2.30.29.30:FF:001107', NULL, NULL, 'Multisubstrate adapter protein soc-1', NULL, NULL, NULL, NULL, NULL, 4),
(113149, NULL, 'G3DSA:1.20.1070.10:FF:000433', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(113150, NULL, 'G3DSA:2.130.10.10:FF:003538', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', NULL, NULL, NULL, NULL, NULL, 4),
(113151, NULL, 'G3DSA:2.60.40.10:FF:000008', NULL, NULL, 'roundabout homolog 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(113152, NULL, 'G3DSA:2.40.50.140:FF:000684', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113153, NULL, 'G3DSA:3.30.200.20:FF:000894', NULL, NULL, 'Ethanolamine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(113154, NULL, 'G3DSA:2.30.42.10:FF:000593', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113155, NULL, 'G3DSA:3.30.540.10:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113156, NULL, 'G3DSA:1.10.1200.10:FF:000093', NULL, NULL, 'Nonribosomal peptide synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(113157, NULL, 'G3DSA:3.30.470.30:FF:000034', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(113158, NULL, 'G3DSA:3.10.105.10:FF:000112', NULL, NULL, 'Dipeptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(113159, NULL, 'G3DSA:1.20.870.10:FF:000012', NULL, NULL, 'Rap guanine nucleotide exchange factor like 1', NULL, NULL, NULL, NULL, NULL, 4),
(113160, NULL, 'G3DSA:3.30.230.10:FF:000393', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113161, NULL, 'G3DSA:3.40.1110.10:FF:000459', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113162, NULL, 'G3DSA:1.25.10.10:FF:002669', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(113163, NULL, 'G3DSA:1.20.1070.10:FF:000063', NULL, NULL, 'C-X-C chemokine receptor type 4', NULL, NULL, NULL, NULL, NULL, 4),
(113164, NULL, 'G3DSA:1.10.472.80:FF:000150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113165, NULL, 'G3DSA:3.40.50.300:FF:004696', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113166, NULL, 'G3DSA:2.40.400.10:FF:000003', NULL, NULL, 'Protein NEOXANTHIN-DEFICIENT 1', NULL, NULL, NULL, NULL, NULL, 4),
(113167, NULL, 'G3DSA:1.20.1510.10:FF:000097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113168, NULL, 'G3DSA:1.10.630.10:FF:000755', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113169, NULL, 'G3DSA:3.40.50.300:FF:006478', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113170, NULL, 'G3DSA:2.30.110.10:FF:000090', NULL, NULL, 'PPOX class F420-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(113171, NULL, 'G3DSA:2.130.10.10:FF:001756', NULL, NULL, 'WD-repeat family protein/ BING4', NULL, NULL, NULL, NULL, NULL, 4),
(113172, NULL, 'G3DSA:3.30.1640.10:FF:000086', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(113173, NULL, 'G3DSA:1.25.10.10:FF:000062', NULL, NULL, 'Serine/threonine-protein phosphatase 2A regulatory subunit A alpha isoform', NULL, NULL, NULL, NULL, NULL, 4),
(113174, NULL, 'G3DSA:2.130.10.10:FF:001301', NULL, NULL, 'Beta-alanine-activating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(113175, NULL, 'G3DSA:2.20.25.240:FF:000013', NULL, NULL, 'Pharyngeal Enhancer Binding', NULL, NULL, NULL, NULL, NULL, 4),
(113176, NULL, 'G3DSA:3.30.300.160:FF:000003', NULL, NULL, 'Type IV-A pilus assembly ATPase PilB', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(113177, NULL, 'G3DSA:4.10.1060.10:FF:000017', NULL, NULL, 'FUS RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(113178, NULL, 'G3DSA:1.10.510.10:FF:001325', NULL, NULL, 'Serine/threonine protein kinase RIO1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(113179, NULL, 'G3DSA:2.130.10.10:FF:004027', NULL, NULL, 'Nucleoporin 43', NULL, NULL, NULL, NULL, NULL, 4),
(113180, NULL, 'G3DSA:3.30.420.10:FF:000637', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113181, NULL, 'G3DSA:1.25.40.20:FF:000100', NULL, NULL, 'unconventional myosin-XVI', NULL, NULL, NULL, NULL, NULL, 4),
(113182, NULL, 'G3DSA:1.10.8.60:FF:000244', NULL, NULL, 'AAA family ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(113183, NULL, 'G3DSA:2.120.10.80:FF:000193', NULL, NULL, 'F-box/kelch-repeat protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(113184, NULL, 'G3DSA:3.30.710.10:FF:000401', NULL, NULL, 'BTB domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(113185, NULL, 'G3DSA:1.10.10.60:FF:000773', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113186, NULL, 'G3DSA:3.30.70.580:FF:000020', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(113187, NULL, 'G3DSA:3.20.20.60:FF:000156', NULL, NULL, 'Aldolase like', NULL, NULL, NULL, NULL, NULL, 4),
(113188, NULL, 'G3DSA:3.30.260.10:FF:000102', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113189, NULL, 'G3DSA:3.40.50.1820:FF:000238', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(113190, NULL, 'G3DSA:1.25.40.90:FF:000099', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(113191, NULL, 'G3DSA:1.10.1580.10:FF:000008', NULL, NULL, 'Large subunit GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(113192, NULL, 'G3DSA:3.20.20.80:FF:000651', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113193, NULL, 'G3DSA:3.40.630.30:FF:000163', NULL, NULL, 'GM12182p', NULL, NULL, NULL, NULL, NULL, 4),
(113194, NULL, 'G3DSA:3.40.50.2000:FF:000326', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(113195, NULL, 'G3DSA:1.20.1070.10:FF:001844', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113196, NULL, 'G3DSA:2.60.40.1180:FF:000104', NULL, NULL, 'Domain_of_uncharacterized_function_(DUF1935)_-_pu tative', NULL, NULL, NULL, NULL, NULL, 4),
(113197, NULL, 'G3DSA:3.20.90.10:FF:000005', NULL, NULL, 'Tubby-like F-box protein', NULL, NULL, NULL, NULL, NULL, 4),
(113198, NULL, 'G3DSA:2.20.70.10:FF:000091', NULL, NULL, 'Flowering time control protein FCA isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(113199, NULL, 'G3DSA:3.40.50.150:FF:001301', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113200, NULL, 'G3DSA:3.40.50.720:FF:002186', NULL, NULL, 'ATG7 autophagy-related 7 homolog (S. cerevisiae)', NULL, NULL, NULL, NULL, NULL, 4),
(113201, NULL, 'G3DSA:1.10.10.10:FF:001663', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113202, NULL, 'G3DSA:3.10.20.90:FF:000132', NULL, NULL, 'Ras association domain-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(113203, NULL, 'G3DSA:1.10.3380.10:FF:000027', NULL, NULL, 'Translocation protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(113204, NULL, 'G3DSA:1.20.1270.60:FF:000143', NULL, NULL, 'Proline-serine-threonine phosphatase-interacting protein 1b', NULL, NULL, NULL, NULL, NULL, 4),
(113205, NULL, 'G3DSA:2.60.40.10:FF:000952', NULL, NULL, 'PZP, alpha-2-macroglobulin like', NULL, NULL, NULL, NULL, NULL, 4),
(113206, NULL, 'G3DSA:1.10.287.70:FF:000626', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113207, NULL, 'G3DSA:1.20.1280.20:FF:000019', NULL, NULL, 'Co-chaperone HscB, C-terminal oligomerization domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(113208, NULL, 'G3DSA:3.30.10.20:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113209, NULL, 'G3DSA:1.25.40.10:FF:003806', NULL, NULL, 'Peroxisomal targeting signal receptor', NULL, NULL, NULL, NULL, NULL, 4),
(113210, NULL, 'G3DSA:2.60.40.10:FF:004403', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(113211, NULL, 'G3DSA:2.60.40.10:FF:005022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113212, NULL, 'G3DSA:1.25.40.10:FF:002952', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(113213, NULL, 'G3DSA:3.30.460.10:FF:000067', NULL, NULL, 'Terminal uridylyltransferase cid1', NULL, NULL, NULL, NULL, NULL, 4),
(113214, NULL, 'G3DSA:3.30.930.10:FF:000367', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113215, NULL, 'G3DSA:2.10.220.10:FF:000153', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(113216, NULL, 'G3DSA:3.30.200.20:FF:001720', NULL, NULL, 'YALI0F23287p', NULL, NULL, NULL, NULL, NULL, 4),
(113217, NULL, 'G3DSA:3.40.1550.20:FF:000001', NULL, NULL, 'Transcriptional regulator MraZ', NULL, NULL, NULL, NULL, NULL, 4),
(113218, NULL, 'G3DSA:3.40.50.1820:FF:000385', NULL, NULL, 'Alpha/beta fold family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(113219, NULL, 'G3DSA:2.60.120.740:FF:000017', NULL, NULL, 'adhesion G protein-coupled receptor L3', NULL, NULL, NULL, NULL, NULL, 4),
(113220, NULL, 'G3DSA:2.60.40.790:FF:000012', NULL, NULL, 'SGT1 homolog, MIS12 kinetochore complex assembly cochaperone', NULL, NULL, NULL, NULL, NULL, 4),
(113221, NULL, 'G3DSA:1.10.287.2620:FF:000004', NULL, NULL, 'Dynein axonemal heavy chain 17', NULL, NULL, NULL, NULL, NULL, 4),
(113222, NULL, 'G3DSA:1.25.40.10:FF:002497', NULL, NULL, 'Histone demethylase UTY', NULL, NULL, NULL, NULL, NULL, 4),
(113223, NULL, 'G3DSA:3.40.50.2300:FF:000265', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(113224, NULL, 'G3DSA:2.30.110.10:FF:000073', NULL, NULL, 'GM21452', NULL, NULL, NULL, NULL, NULL, 4),
(113225, NULL, 'G3DSA:3.20.20.140:FF:000263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113226, NULL, 'G3DSA:3.30.830.10:FF:000320', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113227, NULL, 'G3DSA:2.130.10.10:FF:003201', NULL, NULL, 'AaceriAAL060Wp', NULL, NULL, NULL, NULL, NULL, 4),
(113228, NULL, 'G3DSA:1.20.5.110:FF:000273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113229, NULL, 'G3DSA:3.40.50.300:FF:003735', NULL, NULL, 'DNA mismatch repair protein MSH3', NULL, NULL, NULL, NULL, NULL, 4),
(113230, NULL, 'G3DSA:1.10.1740.10:FF:000015', NULL, NULL, 'RNA polymerase sigma factor SigX', NULL, NULL, NULL, NULL, NULL, 4),
(113231, NULL, 'G3DSA:1.10.472.10:FF:000382', NULL, NULL, 'Putative cyclin-D7-1', NULL, NULL, NULL, NULL, NULL, 4),
(113232, NULL, 'G3DSA:3.90.70.10:FF:000422', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113233, NULL, 'G3DSA:1.10.510.10:FF:003664', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113234, NULL, 'G3DSA:1.10.10.10:FF:000674', NULL, NULL, 'U5 small nuclear ribonucleoprotein helicase', NULL, NULL, NULL, NULL, NULL, 4),
(113235, NULL, 'G3DSA:1.20.58.90:FF:000003', NULL, NULL, 'Centrosomal protein of 57 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(113236, NULL, 'G3DSA:3.30.70.100:FF:000056', NULL, NULL, 'Heavy metal transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(113237, NULL, 'G3DSA:3.30.160.60:FF:005943', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113238, NULL, 'G3DSA:2.60.120.260:FF:000615', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113239, NULL, 'G3DSA:2.40.50.140:FF:000184', NULL, NULL, 'replication protein A 32 kDa subunit A-like', NULL, NULL, NULL, NULL, NULL, 4),
(113240, NULL, 'G3DSA:3.40.630.10:FF:000494', NULL, NULL, 'Clan MH, family M18, aspartyl aminopeptidase-like metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(113241, NULL, 'G3DSA:3.60.160.10:FF:000003', NULL, NULL, 'Altered inheritance of mitochondria protein 24, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(113242, NULL, 'G3DSA:3.80.10.10:FF:003752', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113243, NULL, 'G3DSA:3.20.200.10:FF:000016', NULL, NULL, 'Alpha-kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(113244, NULL, 'G3DSA:1.10.510.10:FF:000027', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(113245, NULL, 'G3DSA:1.20.1480.30:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113246, NULL, 'G3DSA:3.40.50.620:FF:000296', NULL, NULL, 'Universal stress protein family', NULL, NULL, NULL, NULL, NULL, 4),
(113247, NULL, 'G3DSA:2.60.40.1120:FF:000002', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(113248, NULL, 'G3DSA:3.40.50.720:FF:001489', NULL, NULL, 'YALI0E19657p', NULL, NULL, NULL, NULL, NULL, 4),
(113249, NULL, 'G3DSA:2.30.30.1020:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113250, NULL, 'G3DSA:3.40.50.11350:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113251, NULL, 'G3DSA:3.30.2290.10:FF:000025', NULL, NULL, 'PmbA protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(113252, NULL, 'G3DSA:3.50.50.60:FF:000325', NULL, NULL, 'Squalene monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(113253, NULL, 'G3DSA:2.70.130.10:FF:000104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113254, NULL, 'G3DSA:3.40.850.10:FF:000521', NULL, NULL, 'Protein CBR-KLP-13', NULL, NULL, NULL, NULL, NULL, 4),
(113255, NULL, 'G3DSA:2.60.120.200:FF:000204', NULL, NULL, 'Crumbs cell polarity complex component 2', NULL, NULL, NULL, NULL, NULL, 4),
(113256, NULL, 'G3DSA:1.20.5.110:FF:000317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113257, NULL, 'G3DSA:3.40.50.300:FF:007630', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(113258, NULL, 'G3DSA:1.20.58.390:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113259, NULL, 'G3DSA:3.30.1360.20:FF:000005', NULL, NULL, 'Putative pterin-4-alpha-carbinolamine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(113260, NULL, 'G3DSA:2.60.120.10:FF:000123', NULL, NULL, 'cGMP-dependent protein kinase 14-1', NULL, NULL, NULL, NULL, NULL, 4),
(113261, NULL, 'G3DSA:1.20.1560.10:FF:000628', NULL, NULL, 'Os02g0189800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(113262, NULL, 'G3DSA:2.60.40.10:FF:004875', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113263, NULL, 'G3DSA:2.10.25.10:FF:001498', NULL, NULL, 'Faulty attraction, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(113264, NULL, 'G3DSA:1.25.40.820:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113265, NULL, 'G3DSA:2.130.10.10:FF:002684', NULL, NULL, 'WD-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(113266, NULL, 'G3DSA:3.30.160.60:FF:003465', NULL, NULL, 'IP14705p', NULL, NULL, NULL, NULL, NULL, 4),
(113267, NULL, 'G3DSA:3.40.366.10:FF:000025', NULL, NULL, 'Fatty acid synthase beta subunit aflB', NULL, NULL, NULL, NULL, NULL, 4),
(113268, NULL, 'G3DSA:3.50.50.60:FF:001270', NULL, NULL, 'Cc2-17', NULL, NULL, NULL, NULL, NULL, 4),
(113269, NULL, 'G3DSA:2.130.10.10:FF:004527', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(113270, NULL, 'G3DSA:3.40.50.300:FF:003252', NULL, NULL, 'Putative SNF2 family helicase', NULL, NULL, NULL, NULL, NULL, 4),
(113271, NULL, 'G3DSA:3.90.1300.10:FF:000018', NULL, NULL, 'Fatty acid amide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(113272, NULL, 'G3DSA:2.40.15.10:FF:000001', NULL, NULL, 'protein p13 MTCP-1', NULL, NULL, NULL, NULL, NULL, 4),
(113273, NULL, 'G3DSA:2.40.30.10:FF:000497', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113274, NULL, 'G3DSA:1.10.510.10:FF:001764', NULL, NULL, 'cyclin-dependent kinase 12-like', NULL, NULL, NULL, NULL, NULL, 4),
(113275, NULL, 'G3DSA:1.20.1250.20:FF:001619', NULL, NULL, 'Os02g0757400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(113276, NULL, 'G3DSA:3.40.50.1000:FF:000791', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113277, NULL, 'G3DSA:2.60.40.1680:FF:000001', NULL, NULL, 'Baseplate wedge tail fiber connector', NULL, NULL, NULL, NULL, NULL, 4),
(113278, NULL, 'G3DSA:3.40.50.300:FF:007097', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(113279, NULL, 'G3DSA:1.20.190.60:FF:000003', NULL, NULL, 'Protein CBR-SMG-7', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(113280, NULL, 'G3DSA:3.20.20.70:FF:000294', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(113281, NULL, 'G3DSA:1.10.287.310:FF:000007', NULL, NULL, '50S ribosomal protein L29', NULL, NULL, NULL, NULL, NULL, 4),
(113282, NULL, 'G3DSA:3.30.2160.10:FF:000021', NULL, NULL, 'E3 ubiquitin-protein ligase HECTD1', NULL, NULL, NULL, NULL, NULL, 4),
(113283, NULL, 'G3DSA:3.30.70.660:FF:000055', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(113284, NULL, 'G3DSA:3.30.160.60:FF:003774', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113285, NULL, 'G3DSA:4.10.280.10:FF:000109', NULL, NULL, 'Transcription factor bHLH91-like', NULL, NULL, NULL, NULL, NULL, 4),
(113286, NULL, 'G3DSA:3.90.470.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113287, NULL, 'G3DSA:3.40.50.150:FF:000767', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113288, NULL, 'G3DSA:3.30.70.1820:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113289, NULL, 'G3DSA:2.30.42.10:FF:000093', NULL, NULL, 'multiple PDZ domain protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(113290, NULL, 'G3DSA:3.30.160.60:FF:005460', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113291, NULL, 'G3DSA:2.10.25.10:FF:001526', NULL, NULL, 'Sperm transmembrane protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(113292, NULL, 'G3DSA:2.70.50.30:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113293, NULL, 'G3DSA:3.40.50.720:FF:002006', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(113294, NULL, 'G3DSA:3.90.1750.20:FF:000004', NULL, NULL, 'Recombinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(113295, NULL, 'G3DSA:3.90.190.10:FF:000116', NULL, NULL, 'YVH1p Protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(113296, NULL, 'G3DSA:1.10.533.10:FF:000052', NULL, NULL, 'Putative receptor-interacting serine/threonine-protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(113297, NULL, 'G3DSA:2.130.10.10:FF:000475', NULL, NULL, 'Kinesin family member 21B', NULL, NULL, NULL, NULL, NULL, 4),
(113298, NULL, 'G3DSA:2.130.10.10:FF:001273', NULL, NULL, 'WD domain, G-beta repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(113299, NULL, 'G3DSA:3.40.525.10:FF:000069', NULL, NULL, 'Sec14p-like phosphatidylinositol transfer family protein', NULL, NULL, NULL, NULL, NULL, 4),
(113300, NULL, 'G3DSA:2.60.120.920:FF:000049', NULL, NULL, 'Tripartite motif containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(113301, NULL, 'G3DSA:3.30.1490.20:FF:000009', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(113302, NULL, 'G3DSA:2.60.40.150:FF:000287', NULL, NULL, 'Multiple C2 domains, transmembrane 1b', NULL, NULL, NULL, NULL, NULL, 4),
(113303, NULL, 'G3DSA:2.30.30.170:FF:000005', NULL, NULL, 'Fibronectin binding autolysin', NULL, NULL, NULL, NULL, NULL, 4),
(113304, NULL, 'G3DSA:1.20.1720.10:FF:000034', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(113305, NULL, 'G3DSA:2.70.150.10:FF:000004', NULL, NULL, 'Plasma membrane ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(113306, NULL, 'G3DSA:1.10.10.1320:FF:000001', NULL, NULL, 'Anti-sigma-K factor RskA', NULL, NULL, NULL, NULL, NULL, 4),
(113307, NULL, 'G3DSA:3.40.50.720:FF:000432', NULL, NULL, 'Blast:Glyoxylate reductase/hydroxypyruvate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(113308, NULL, 'G3DSA:2.40.50.90:FF:000005', NULL, NULL, 'Staphylococcal nuclease domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(113309, NULL, 'G3DSA:2.40.10.10:FF:000597', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113310, NULL, 'G3DSA:2.130.10.10:FF:005146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113311, NULL, 'G3DSA:1.20.1730.10:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113312, NULL, 'G3DSA:3.30.420.10:FF:000154', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(113313, NULL, 'G3DSA:2.10.25.10:FF:000346', NULL, NULL, 'Cartilage oligomeric matrix protein', NULL, NULL, NULL, NULL, NULL, 4),
(113314, NULL, 'G3DSA:3.90.920.10:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113315, NULL, 'G3DSA:1.20.58.340:FF:000026', NULL, NULL, 'Metal ion channel-Mg2+, Co2+ and Ni2', NULL, NULL, NULL, NULL, NULL, 4),
(113316, NULL, 'G3DSA:3.30.420.310:FF:000002', NULL, NULL, '2-dehydro-3-deoxygalactonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(113317, NULL, 'G3DSA:3.30.390.30:FF:000050', NULL, NULL, 'FAD-dependent pyridine nucleotide-disulphide oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(113318, NULL, 'G3DSA:1.10.150.20:FF:000165', NULL, NULL, 'Holliday junction ATP-dependent DNA helicase RuvA', NULL, NULL, NULL, NULL, NULL, 4),
(113319, NULL, 'G3DSA:2.30.42.10:FF:000576', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113320, NULL, 'G3DSA:3.40.50.1240:FF:000132', NULL, NULL, 'Ubiquitin associated and SH3 domain containing A', NULL, NULL, NULL, NULL, NULL, 4),
(113321, NULL, 'G3DSA:1.10.1200.10:FF:000076', NULL, NULL, 'Nonribosomal peptide synthase GliP2', NULL, NULL, NULL, NULL, NULL, 4),
(113322, NULL, 'G3DSA:3.40.630.10:FF:000185', NULL, NULL, 'Nicastrin', NULL, NULL, NULL, NULL, NULL, 4),
(113323, NULL, 'G3DSA:3.30.70.270:FF:000180', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113324, NULL, 'G3DSA:3.60.21.60:FF:000044', NULL, NULL, 'DNA polymerase alpha subunit B-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(113325, NULL, 'G3DSA:1.10.238.10:FF:000203', NULL, NULL, 'Probable calcium-binding protein CML27', NULL, NULL, NULL, NULL, NULL, 4),
(113326, NULL, 'G3DSA:1.10.30.50:FF:000018', NULL, NULL, 'Phage endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(113327, NULL, 'G3DSA:3.30.420.10:FF:000284', NULL, NULL, 'Integrase/recombinase, core domain family', NULL, NULL, NULL, NULL, NULL, 4),
(113328, NULL, 'G3DSA:1.10.274.10:FF:000005', NULL, NULL, 'Fused phosphoenolpyruvate-protein phosphotransferase PtsP/GAF domain', NULL, NULL, NULL, NULL, NULL, 4),
(113329, NULL, 'G3DSA:1.20.1110.10:FF:000151', NULL, NULL, 'Cation-transporter ATPase I CtpI', NULL, NULL, NULL, NULL, NULL, 4),
(113330, NULL, 'G3DSA:3.40.1280.30:FF:000011', NULL, NULL, 'tRNA (Guanine-1)-methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(113331, NULL, 'G3DSA:2.120.10.80:FF:000176', NULL, NULL, 'Protein CBR-TAG-53', NULL, NULL, NULL, NULL, NULL, 4),
(113332, NULL, 'G3DSA:3.30.310.210:FF:000009', NULL, NULL, 'Defective in germ line development protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(113333, NULL, 'G3DSA:1.20.1250.20:FF:001136', NULL, NULL, 'Synaptic vesicle glycoprotein 2Ba', NULL, NULL, NULL, NULL, NULL, 4),
(113334, NULL, 'G3DSA:1.10.510.10:FF:000819', NULL, NULL, 'TKL protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(113335, NULL, 'G3DSA:3.30.50.10:FF:000070', NULL, NULL, 'Nuclear hormone receptor family member nhr-2', NULL, NULL, NULL, NULL, NULL, 4),
(113336, NULL, 'G3DSA:1.20.58.1120:FF:000068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113337, NULL, 'G3DSA:1.10.1070.11:FF:000139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113338, NULL, 'G3DSA:1.10.510.10:FF:001308', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(113339, NULL, 'G3DSA:1.10.555.10:FF:000097', NULL, NULL, 'CYtoKinesis defect', NULL, NULL, NULL, NULL, NULL, 4),
(113340, NULL, 'G3DSA:1.10.630.10:FF:000738', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113341, NULL, 'G3DSA:1.10.630.10:FF:000093', NULL, NULL, 'Cytochrome P450 monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(113342, NULL, 'G3DSA:1.25.40.80:FF:000011', NULL, NULL, 'Deoxyribodipyrimidine photolyase single-strand-specific', NULL, NULL, NULL, NULL, NULL, 4),
(113343, NULL, 'G3DSA:1.20.1310.20:FF:000017', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(113344, NULL, 'G3DSA:3.40.50.300:FF:001127', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(113345, NULL, 'G3DSA:1.10.10.10:FF:001180', NULL, NULL, 'Myelin regulatory factor homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(113346, NULL, 'G3DSA:3.40.50.720:FF:000741', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(113347, NULL, 'G3DSA:2.60.120.430:FF:000026', NULL, NULL, 'Os05g0261700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(113348, NULL, 'G3DSA:1.10.10.60:FF:001262', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113349, NULL, 'G3DSA:2.130.10.10:FF:000784', NULL, NULL, 'U3 small nucleolar RNA-interacting protein 2,putative', NULL, NULL, NULL, NULL, NULL, 4),
(113350, NULL, 'G3DSA:3.30.420.40:FF:001006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113351, NULL, 'G3DSA:1.25.40.10:FF:001980', NULL, NULL, 'Os02g0555100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(113352, NULL, 'G3DSA:1.20.1250.20:FF:001799', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113353, NULL, 'G3DSA:3.90.226.10:FF:000184', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(113354, NULL, 'G3DSA:3.60.110.10:FF:000068', NULL, NULL, 'Glutamine-dependent NAD(+) synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(113355, NULL, 'G3DSA:3.40.50.1400:FF:000023', NULL, NULL, 'Ferrochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(113356, NULL, 'G3DSA:3.10.620.30:FF:000011', NULL, NULL, 'Transglutaminase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(113357, NULL, 'G3DSA:3.10.20.90:FF:000957', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113358, NULL, 'G3DSA:1.25.40.20:FF:001218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113359, NULL, 'G3DSA:3.30.450.20:FF:000586', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(113360, NULL, 'G3DSA:3.30.200.20:FF:000972', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(113361, NULL, 'G3DSA:3.40.50.620:FF:000857', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113362, NULL, 'G3DSA:3.40.50.1820:FF:000677', NULL, NULL, 'Alpha/beta hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(113363, NULL, 'G3DSA:1.20.1250.20:FF:000310', NULL, NULL, 'SPX domain-containing membrane protein At4g11810', NULL, NULL, NULL, NULL, NULL, 4),
(113364, NULL, 'G3DSA:2.60.40.420:FF:000244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113365, NULL, 'G3DSA:2.30.29.30:FF:000135', NULL, NULL, 'Myotubularin related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(113366, NULL, 'G3DSA:3.40.50.850:FF:000016', NULL, NULL, 'Cysteine hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(113367, NULL, 'G3DSA:3.30.160.60:FF:002846', NULL, NULL, 'Si:dkey-237m9.1', NULL, NULL, NULL, NULL, NULL, 4),
(113368, NULL, 'G3DSA:3.40.50.720:FF:000180', NULL, NULL, '4-hydroxy-tetrahydrodipicolinate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(113369, NULL, 'G3DSA:1.10.1140.10:FF:000003', NULL, NULL, 'Vacuolar ATP synthase catalytic subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(113370, NULL, 'G3DSA:3.40.50.1820:FF:000368', NULL, NULL, 'Unplaced genomic scaffold supercont2.8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(113371, NULL, 'G3DSA:3.30.70.850:FF:000005', NULL, NULL, 'Neuroendocrine convertase', NULL, NULL, NULL, NULL, NULL, 4),
(113372, NULL, 'G3DSA:3.30.160.60:FF:003335', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113373, NULL, 'G3DSA:1.20.58.390:FF:000210', NULL, NULL, 'Nicotinic acetylcholine receptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(113374, NULL, 'G3DSA:1.10.455.10:FF:000033', NULL, NULL, 'Ribosomal protein S7, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(113375, NULL, 'G3DSA:3.40.50.2300:FF:000282', NULL, NULL, 'Heme response regulator HssR', NULL, NULL, NULL, NULL, NULL, 4),
(113376, NULL, 'G3DSA:2.10.25.10:FF:000907', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(113377, NULL, 'G3DSA:3.10.105.10:FF:000084', NULL, NULL, 'Peptide ABC transporter, periplasmic peptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(113378, NULL, 'G3DSA:2.30.180.10:FF:000004', NULL, NULL, 'periostin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(113379, NULL, 'G3DSA:3.30.70.60:FF:000035', NULL, NULL, 'Type IV pilus biogenesis protein PilO', NULL, NULL, NULL, NULL, NULL, 4),
(113380, NULL, 'G3DSA:3.90.20.20:FF:000040', NULL, NULL, 'Putative molecular chaperone of the grpe family', NULL, NULL, NULL, NULL, NULL, 4),
(113381, NULL, 'G3DSA:1.10.287.700:FF:000001', NULL, NULL, 'Alpha-synuclein', NULL, NULL, NULL, NULL, NULL, 4),
(113382, NULL, 'G3DSA:3.30.565.10:FF:000462', NULL, NULL, 'Sensory box histidine kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(113383, NULL, 'G3DSA:3.40.50.300:FF:002324', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(113384, NULL, 'G3DSA:1.25.40.430:FF:000027', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(113385, NULL, 'G3DSA:1.25.40.10:FF:001671', NULL, NULL, 'AT28279p', NULL, NULL, NULL, NULL, NULL, 4),
(113386, NULL, 'G3DSA:1.25.40.10:FF:004397', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113387, NULL, 'G3DSA:2.130.10.10:FF:005455', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113388, NULL, 'G3DSA:3.10.28.10:FF:000064', NULL, NULL, 'Ribonucleoside-diphosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(113389, NULL, 'G3DSA:1.10.245.10:FF:000006', NULL, NULL, 'SWI/SNF nucleosome remodeling complex component', NULL, NULL, NULL, NULL, NULL, 4),
(113390, NULL, 'G3DSA:3.30.1960.10:FF:000014', NULL, NULL, 'tRNA wybutosine-synthesizing protein 3 isoform 2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(113391, NULL, 'G3DSA:3.90.110.10:FF:000016', NULL, NULL, 'L-lactate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(113392, NULL, 'G3DSA:3.40.50.960:FF:000021', NULL, NULL, '6,7-dimethyl-8-ribityllumazine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(113393, NULL, 'G3DSA:2.10.25.10:FF:000981', NULL, NULL, 'Wing blister, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(113394, NULL, 'G3DSA:2.170.300.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113395, NULL, 'G3DSA:3.90.1800.10:FF:000028', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(113396, NULL, 'G3DSA:3.30.1740.10:FF:000003', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(113397, NULL, 'G3DSA:3.30.413.10:FF:000025', NULL, NULL, 'Nitrite reductase (NAD(P)H) large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(113398, NULL, 'G3DSA:1.20.1250.20:FF:001928', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113399, NULL, 'G3DSA:1.10.3730.20:FF:000046', NULL, NULL, 'Small multidrug resistance efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(113400, NULL, 'G3DSA:2.130.10.10:FF:005590', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113401, NULL, 'G3DSA:3.40.640.10:FF:000112', NULL, NULL, 'Probable cysteine desulfurase', NULL, NULL, NULL, NULL, NULL, 4),
(113402, NULL, 'G3DSA:3.20.20.100:FF:000071', NULL, NULL, 'Aldose reductase', NULL, NULL, NULL, NULL, NULL, 4),
(113403, NULL, 'G3DSA:3.40.250.10:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113404, NULL, 'G3DSA:1.20.1270.60:FF:000273', NULL, NULL, 'Zgc:158689', NULL, NULL, NULL, NULL, NULL, 4),
(113405, NULL, 'G3DSA:2.60.40.10:FF:002958', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113406, NULL, 'G3DSA:3.10.20.230:FF:000033', NULL, NULL, 'Doublecortin domain-containing 2B', NULL, NULL, NULL, NULL, NULL, 4),
(113407, NULL, 'G3DSA:3.40.50.360:FF:000049', NULL, NULL, 'FMN-dependent NADH-azoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(113408, NULL, 'G3DSA:1.20.120.610:FF:000005', NULL, NULL, 'V-type sodium ATPase subunit K', NULL, NULL, NULL, NULL, NULL, 4),
(113409, NULL, 'G3DSA:1.25.10.10:FF:001708', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(113410, NULL, 'G3DSA:3.40.630.30:FF:000033', NULL, NULL, 'N-alpha-acetyltransferase 40 isoform X1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(113411, NULL, 'G3DSA:2.40.50.140:FF:000976', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113412, NULL, 'G3DSA:3.20.20.140:FF:000133', NULL, NULL, 'Amidohydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(113413, NULL, 'G3DSA:3.40.50.1820:FF:001649', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113414, NULL, 'G3DSA:3.40.50.300:FF:002908', NULL, NULL, 'Septin CDC11', NULL, NULL, NULL, NULL, NULL, 4),
(113415, NULL, 'G3DSA:3.40.850.10:FF:000297', NULL, NULL, 'Kinesin-related protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(113416, NULL, 'G3DSA:3.30.60.90:FF:000004', NULL, NULL, 'Putative E3 ubiquitin-protein ligase MIB2', NULL, NULL, NULL, NULL, NULL, 4),
(113417, NULL, 'G3DSA:3.40.50.1820:FF:000710', NULL, NULL, 'FI22312p1', NULL, NULL, NULL, NULL, NULL, 4),
(113418, NULL, 'G3DSA:1.20.1250.20:FF:001344', NULL, NULL, 'Solute carrier family 2, facilitated glucose transporter member 12', NULL, NULL, NULL, NULL, NULL, 4),
(113419, NULL, 'G3DSA:1.20.5.110:FF:000042', NULL, NULL, 'protein BRICK 1', NULL, NULL, NULL, NULL, NULL, 4),
(113420, NULL, 'G3DSA:3.30.40.100:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113421, NULL, 'G3DSA:3.30.160.60:FF:000800', NULL, NULL, 'zinc finger protein 181 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(113422, NULL, 'G3DSA:3.60.15.10:FF:000240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113423, NULL, 'G3DSA:3.20.20.300:FF:000007', NULL, NULL, 'Lysosomal beta glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(113424, NULL, 'G3DSA:3.40.850.10:FF:000196', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(113425, NULL, 'G3DSA:3.10.20.90:FF:000002', NULL, NULL, 'Erythrocyte protein band 4.1-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(113426, NULL, 'G3DSA:2.60.40.10:FF:001880', NULL, NULL, 'Mga2p', NULL, NULL, NULL, NULL, NULL, 4),
(113427, NULL, 'G3DSA:3.40.50.80:FF:000197', NULL, NULL, 'Ferric reductase-like transmembrane component', NULL, NULL, NULL, NULL, NULL, 4),
(113428, NULL, 'G3DSA:3.30.70.1350:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113429, NULL, 'G3DSA:3.90.1860.10:FF:000004', NULL, NULL, 'tRNA-splicing ligase RtcB', NULL, NULL, NULL, NULL, NULL, 4),
(113430, NULL, 'G3DSA:1.10.510.10:FF:003433', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113431, NULL, 'G3DSA:3.30.230.30:FF:000005', NULL, NULL, 'Protein IMPACT homolog', NULL, NULL, NULL, NULL, NULL, 4),
(113432, NULL, 'G3DSA:1.20.1070.10:FF:000624', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113433, NULL, 'G3DSA:2.10.25.10:FF:000554', NULL, NULL, 'Cubilin', NULL, NULL, NULL, NULL, NULL, 4),
(113434, NULL, 'G3DSA:1.20.91.20:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113435, NULL, 'G3DSA:1.10.472.80:FF:000133', NULL, NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', NULL, NULL, NULL, NULL, NULL, 4),
(113436, NULL, 'G3DSA:3.30.160.60:FF:000901', NULL, NULL, 'CCCTC-binding factor like', NULL, NULL, NULL, NULL, NULL, 4),
(113437, NULL, 'G3DSA:2.60.40.10:FF:005623', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113438, NULL, 'G3DSA:2.30.42.10:FF:000654', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113439, NULL, 'G3DSA:3.30.70.330:FF:000642', NULL, NULL, 'U2 snRNP auxiliary factor large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(113440, NULL, 'G3DSA:1.10.1410.10:FF:000030', NULL, NULL, 'PAP/25A associated domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(113441, NULL, 'G3DSA:3.40.50.10470:FF:000005', NULL, NULL, 'translation initiation factor eIF-2B subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(113442, NULL, 'G3DSA:2.60.120.200:FF:000176', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(113443, NULL, 'G3DSA:1.20.58.60:FF:000562', NULL, NULL, 'Plectin', NULL, NULL, NULL, NULL, NULL, 4),
(113444, NULL, 'G3DSA:3.30.420.10:FF:000654', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113445, NULL, 'G3DSA:3.40.50.300:FF:001818', NULL, NULL, 'Probable anion transporter atpase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(113446, NULL, 'G3DSA:2.60.120.10:FF:000640', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113447, NULL, 'G3DSA:3.30.1360.40:FF:000028', NULL, NULL, 'DNA gyrase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(113448, NULL, 'G3DSA:3.30.1330.230:FF:000001', NULL, NULL, 'Ribosomal protein S12 methylthiotransferase accessory factor YcaO', NULL, NULL, NULL, NULL, NULL, 4),
(113449, NULL, 'G3DSA:3.30.1320.10:FF:000011', NULL, NULL, 'Mitochondrial ribosomal protein S16', NULL, NULL, NULL, NULL, NULL, 4),
(113450, NULL, 'G3DSA:3.90.650.10:FF:000074', NULL, NULL, '75b', NULL, NULL, NULL, NULL, NULL, 4),
(113451, NULL, 'G3DSA:2.60.40.10:FF:003369', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113452, NULL, 'G3DSA:3.90.70.10:FF:000686', NULL, NULL, 'Ubiquitin-specific peptidase 36', NULL, NULL, NULL, NULL, NULL, 4),
(113453, NULL, 'G3DSA:1.10.533.10:FF:000035', NULL, NULL, 'nucleolar protein 3 isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(113454, NULL, 'G3DSA:3.40.50.150:FF:001256', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113455, NULL, 'G3DSA:1.10.10.760:FF:000001', NULL, NULL, 'Malto-oligosyltrehalose trehalohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(113456, NULL, 'G3DSA:3.40.50.880:FF:000194', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(113457, NULL, 'G3DSA:2.130.10.10:FF:004971', NULL, NULL, 'WD repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(113458, NULL, 'G3DSA:3.40.1620.60:FF:000007', NULL, NULL, 'Sol narae, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(113459, NULL, 'G3DSA:3.30.160.60:FF:005691', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113460, NULL, 'G3DSA:3.40.50.2300:FF:000618', NULL, NULL, 'Chromosome 15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(113461, NULL, 'G3DSA:1.10.10.60:FF:000464', NULL, NULL, 'DNA invertase', NULL, NULL, NULL, NULL, NULL, 4),
(113462, NULL, 'G3DSA:3.30.2300.10:FF:000010', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(113463, NULL, 'G3DSA:3.30.1370.10:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113464, NULL, 'G3DSA:3.40.50.80:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113465, NULL, 'G3DSA:1.10.3380.10:FF:000044', NULL, NULL, 'Type III restriction enzyme, res subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(113466, NULL, 'G3DSA:1.10.287.70:FF:000497', NULL, NULL, 'Inward Rectifying K (Potassium) channel family', NULL, NULL, NULL, NULL, NULL, 4),
(113467, NULL, 'G3DSA:1.10.10.160:FF:000029', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(113468, NULL, 'G3DSA:3.40.1350.10:FF:000033', NULL, NULL, 'Sen15p', NULL, NULL, NULL, NULL, NULL, 4),
(113469, NULL, 'G3DSA:3.50.50.60:FF:001522', NULL, NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', NULL, NULL, NULL, NULL, NULL, 4),
(113470, NULL, 'G3DSA:3.30.160.60:FF:005151', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113471, NULL, 'G3DSA:3.40.1280.10:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113472, NULL, 'G3DSA:3.30.1330.40:FF:000043', NULL, NULL, 'RidA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(113473, NULL, 'G3DSA:2.60.40.10:FF:000351', NULL, NULL, 'CD166 antigen isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(113474, NULL, 'G3DSA:3.80.10.10:FF:004241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113475, NULL, 'G3DSA:3.30.1520.10:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113476, NULL, 'G3DSA:3.30.200.20:FF:001591', NULL, NULL, 'Receptor tyrosine kinase Torso-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(113477, NULL, 'G3DSA:2.30.38.10:FF:000015', NULL, NULL, 'Amino acid adenylation', NULL, NULL, NULL, NULL, NULL, 4),
(113478, NULL, 'G3DSA:3.40.30.10:FF:000427', NULL, NULL, 'Protein disulfide-isomerase A4', NULL, NULL, NULL, NULL, NULL, 4),
(113479, NULL, 'G3DSA:1.25.40.20:FF:001320', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(113480, NULL, 'G3DSA:1.25.40.20:FF:000600', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113481, NULL, 'G3DSA:3.30.70.330:FF:000687', NULL, NULL, '54S ribosomal protein L23, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(113482, NULL, 'G3DSA:3.30.160.60:FF:001992', NULL, NULL, 'Zinc finger and SCAN domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(113483, NULL, 'G3DSA:1.10.730.10:FF:000139', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(113484, NULL, 'G3DSA:1.25.10.10:FF:001282', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(113485, NULL, 'G3DSA:2.30.30.140:FF:000137', NULL, NULL, 'Protein MOS2', NULL, NULL, NULL, NULL, NULL, 4),
(113486, NULL, 'G3DSA:1.10.510.10:FF:001455', NULL, NULL, 'CAMK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(113487, NULL, 'G3DSA:3.30.70.580:FF:000048', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(113488, NULL, 'G3DSA:3.90.480.20:FF:000001', NULL, NULL, 'Nitrite reductase [NAD(P)H] large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(113489, NULL, 'G3DSA:3.30.250.20:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113490, NULL, 'G3DSA:3.30.56.10:FF:000009', NULL, NULL, 'Phenylalanine-tRNA ligase, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(113491, NULL, 'G3DSA:2.60.120.650:FF:000081', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(113492, NULL, 'G3DSA:3.40.50.1820:FF:001065', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(113493, NULL, 'G3DSA:2.20.25.80:FF:000006', NULL, NULL, 'WRKY transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(113494, NULL, 'G3DSA:2.20.25.10:FF:000093', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(113495, NULL, 'G3DSA:1.20.58.340:FF:000009', NULL, NULL, 'Magnesium transporter MRS2-1', NULL, NULL, NULL, NULL, NULL, 4),
(113496, NULL, 'G3DSA:1.10.10.2170:FF:000003', NULL, NULL, 'Telomeric repeat-binding factor 2-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(113497, NULL, 'G3DSA:1.20.1560.10:FF:000319', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(113498, NULL, 'G3DSA:2.60.120.10:FF:000095', NULL, NULL, 'HTH-type transcriptional activator RhaR', NULL, NULL, NULL, NULL, NULL, 4),
(113499, NULL, 'G3DSA:3.30.40.10:FF:000816', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(113500, NULL, 'G3DSA:3.40.50.150:FF:000003', NULL, NULL, 'Blast:Protein arginine N-methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(113501, NULL, 'G3DSA:1.20.1250.20:FF:000990', NULL, NULL, 'Probable sphingolipid transporter spinster homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(113502, NULL, 'G3DSA:1.10.8.60:FF:000036', NULL, NULL, 'Spastin', NULL, NULL, NULL, NULL, NULL, 4),
(113503, NULL, 'G3DSA:3.30.160.60:FF:005382', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113504, NULL, 'G3DSA:3.40.50.1820:FF:000446', NULL, NULL, 'Alpha/beta-Hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(113505, NULL, 'G3DSA:2.40.30.10:FF:000008', NULL, NULL, 'Translation initiation factor IF-2', NULL, NULL, NULL, NULL, NULL, 4),
(113506, NULL, 'G3DSA:2.60.120.620:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113507, NULL, 'G3DSA:1.10.1780.10:FF:000006', NULL, NULL, 'Chaperone protein ClpB3, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(113508, NULL, 'G3DSA:3.30.2130.30:FF:000008', NULL, NULL, 'THUMP domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(113509, NULL, 'G3DSA:1.10.10.10:FF:001163', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(113510, NULL, 'G3DSA:3.30.160.60:FF:002245', NULL, NULL, 'Zinc finger protein 473', NULL, NULL, NULL, NULL, NULL, 4),
(113511, NULL, 'G3DSA:1.25.40.10:FF:001536', NULL, NULL, 'SYF pre-mRNA splicing factor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(113512, NULL, 'G3DSA:2.130.10.10:FF:003229', NULL, NULL, 'Cilia- and flagella-associated protein 43', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(113513, NULL, 'G3DSA:3.30.230.10:FF:000263', NULL, NULL, '30S ribosomal protein S9, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(113514, NULL, 'G3DSA:3.40.50.620:FF:000812', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113515, NULL, 'G3DSA:3.30.930.10:FF:000412', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 4-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(113516, NULL, 'G3DSA:2.60.40.10:FF:003678', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113517, NULL, 'G3DSA:1.10.10.10:FF:001871', NULL, NULL, 'Uncharacterized protein MJ0241', NULL, NULL, NULL, NULL, NULL, 4),
(113518, NULL, 'G3DSA:2.40.128.330:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113519, NULL, 'G3DSA:1.25.40.10:FF:003014', NULL, NULL, 'Intraflagellar transport protein IFT88', NULL, NULL, NULL, NULL, NULL, 4),
(113520, NULL, 'G3DSA:3.30.160.60:FF:001565', NULL, NULL, 'zinc finger protein 263', NULL, NULL, NULL, NULL, NULL, 4),
(113521, NULL, 'G3DSA:1.10.10.440:FF:000006', NULL, NULL, 'Transcription elongation regulator 1 (CA150)', NULL, NULL, NULL, NULL, NULL, 4),
(113522, NULL, 'G3DSA:2.20.100.10:FF:000209', NULL, NULL, 'Thrombospondin type-1 domain-containing protein 7B', NULL, NULL, NULL, NULL, NULL, 4),
(113523, NULL, 'G3DSA:1.25.40.10:FF:005223', NULL, NULL, 'Pentatricopeptide (PPR) repeat-containing protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(113524, NULL, 'G3DSA:3.30.160.60:FF:001520', NULL, NULL, 'Zinc finger protein 423', NULL, NULL, NULL, NULL, NULL, 4),
(113525, NULL, 'G3DSA:3.30.70.870:FF:000028', NULL, NULL, 'Pre-mRNA-splicing factor SNU114', NULL, NULL, NULL, NULL, NULL, 4),
(113526, NULL, 'G3DSA:3.90.190.10:FF:000364', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113527, NULL, 'G3DSA:2.40.50.140:FF:000745', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113528, NULL, 'G3DSA:3.30.200.20:FF:002428', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113529, NULL, 'G3DSA:3.40.50.790:FF:000037', NULL, NULL, 'Putative ribosome biogenesis protein C8F11.04', NULL, NULL, NULL, NULL, NULL, 4),
(113530, NULL, 'G3DSA:3.40.50.1010:FF:000131', NULL, NULL, 'Tegument host shutoff protein', NULL, NULL, NULL, NULL, NULL, 4),
(113531, NULL, 'G3DSA:3.40.50.2300:FF:001462', NULL, NULL, 'Circadian clock protein KaiA', NULL, NULL, NULL, NULL, NULL, 4),
(113532, NULL, 'G3DSA:3.10.10.10:FF:000006', NULL, NULL, 'Paternally expressed 10', NULL, NULL, NULL, NULL, NULL, 4),
(113533, NULL, 'G3DSA:1.10.260.40:FF:000033', NULL, NULL, 'AnsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(113534, NULL, 'G3DSA:3.20.20.80:FF:000712', NULL, NULL, 'Glucosylceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(113535, NULL, 'G3DSA:1.20.1530.20:FF:000028', NULL, NULL, 'Cation/H(+) antiporter 14', NULL, NULL, NULL, NULL, NULL, 4),
(113536, NULL, 'G3DSA:3.40.50.10330:FF:000059', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(113537, NULL, 'G3DSA:3.40.50.720:FF:000972', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(113538, NULL, 'G3DSA:1.10.287.1260:FF:000001', NULL, NULL, 'Small-conductance mechanosensitive channel MscS', NULL, NULL, NULL, NULL, NULL, 4),
(113539, NULL, 'G3DSA:1.10.472.130:FF:000078', NULL, NULL, 'Dynein axonemal heavy chain 10', NULL, NULL, NULL, NULL, NULL, 4),
(113540, NULL, 'G3DSA:2.40.170.20:FF:000122', NULL, NULL, 'Transporter, outer membrane receptor (OMR) family', NULL, NULL, NULL, NULL, NULL, 4),
(113541, NULL, 'G3DSA:1.10.167.10:FF:000004', NULL, NULL, 'sorting nexin-14 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(113542, NULL, 'G3DSA:3.30.70.850:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113543, NULL, 'G3DSA:3.40.50.11500:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113544, NULL, 'G3DSA:3.40.50.1970:FF:000042', NULL, NULL, 'NADH-dependent butanol dehydrogenase A', NULL, NULL, NULL, NULL, NULL, 4),
(113545, NULL, 'G3DSA:3.90.1520.10:FF:000001', NULL, NULL, 'Guanylate cyclase soluble subunit beta-1', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(113546, NULL, 'G3DSA:1.10.10.60:FF:001184', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113547, NULL, 'G3DSA:1.10.1300.10:FF:000038', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(113548, NULL, 'G3DSA:2.60.120.10:FF:000432', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(113549, NULL, 'G3DSA:3.60.40.10:FF:000062', NULL, NULL, 'Protein phosphatase 1K, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(113550, NULL, 'G3DSA:2.130.10.30:FF:000014', NULL, NULL, 'probable E3 ubiquitin-protein ligase HERC4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(113551, NULL, 'G3DSA:1.20.1740.10:FF:000148', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(113552, NULL, 'G3DSA:3.30.1370.10:FF:000093', NULL, NULL, 'KH domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(113553, NULL, 'G3DSA:2.60.40.10:FF:003105', NULL, NULL, 'Protein sidekick-2', NULL, NULL, NULL, NULL, NULL, 4),
(113554, NULL, 'G3DSA:3.40.50.300:FF:006450', NULL, NULL, 'Predicted ABC-type transport system, ATPase component', NULL, NULL, NULL, NULL, NULL, 4),
(113555, NULL, 'G3DSA:3.30.160.60:FF:004763', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113556, NULL, 'G3DSA:1.25.40.180:FF:000273', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113557, NULL, 'G3DSA:3.40.190.10:FF:000813', NULL, NULL, 'Transferrin-a', NULL, NULL, NULL, NULL, NULL, 4),
(113558, NULL, 'G3DSA:1.20.1720.10:FF:000135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113559, NULL, 'G3DSA:3.40.50.2000:FF:000635', NULL, NULL, 'Alphaalpha-trehalose-phosphate synthase [UDP-forming] 5', NULL, NULL, NULL, NULL, NULL, 4),
(113560, NULL, 'G3DSA:3.40.50.150:FF:000576', NULL, NULL, 'Cyclopropane-fatty-acyl-phospholipid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(113561, NULL, 'G3DSA:3.90.470.20:FF:000074', NULL, NULL, 'YALI0E09306p', NULL, NULL, NULL, NULL, NULL, 4),
(113562, NULL, 'G3DSA:1.10.10.10:FF:000090', NULL, NULL, 'Phosphatidylinositol-3,4,5-trisphosphate dependent Rac exchange factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(113563, NULL, 'G3DSA:3.50.30.30:FF:000091', NULL, NULL, 'Plr-1', NULL, NULL, NULL, NULL, NULL, 4),
(113564, NULL, 'G3DSA:2.30.230.10:FF:000020', NULL, NULL, 'GD21667', NULL, NULL, NULL, NULL, NULL, 4),
(113565, NULL, 'G3DSA:3.30.500.40:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113566, NULL, 'G3DSA:2.130.10.10:FF:003190', NULL, NULL, 'WD repeat-containing protein 37', NULL, NULL, NULL, NULL, NULL, 4),
(113567, NULL, 'G3DSA:3.40.630.10:FF:000286', NULL, NULL, 'Peptidase M20 domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(113568, NULL, 'G3DSA:3.30.70.141:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113569, NULL, 'G3DSA:2.60.40.10:FF:001571', NULL, NULL, 'Down syndrome cell adhesion molecule-like protein Dscam2', NULL, NULL, NULL, NULL, NULL, 4),
(113570, NULL, 'G3DSA:2.60.40.1530:FF:000018', NULL, NULL, 'Integrin alpha-PS1', NULL, NULL, NULL, NULL, NULL, 4),
(113571, NULL, 'G3DSA:3.40.50.10190:FF:000354', NULL, NULL, 'DNA damage response protein Mdb1', NULL, NULL, NULL, NULL, NULL, 4),
(113572, NULL, 'G3DSA:3.20.20.10:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113573, NULL, 'G3DSA:3.30.420.140:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113574, NULL, 'G3DSA:3.40.50.720:FF:000663', NULL, NULL, 'Multifunctional enzyme siroheme synthase CYSG: uroporphyrin-III C-methyltransferase + precorrin-2 oxidase + ferrochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(113575, NULL, 'G3DSA:2.60.40.10:FF:004297', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113576, NULL, 'G3DSA:1.10.510.10:FF:000836', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(113577, NULL, 'G3DSA:2.30.29.30:FF:000270', NULL, NULL, 'Pleckstrin homology-like domain family A member 3', NULL, NULL, NULL, NULL, NULL, 4),
(113578, NULL, 'G3DSA:3.90.530.10:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(113579, NULL, 'G3DSA:3.30.420.110:FF:000015', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(113580, NULL, 'G3DSA:3.30.2130.10:FF:000002', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(113581, NULL, 'G3DSA:1.10.860.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113582, NULL, 'G3DSA:3.30.200.20:FF:001703', NULL, NULL, 'Calcium/calmodulin dependent protein kinase kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(113583, NULL, 'G3DSA:3.40.30.10:FF:001046', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(113584, NULL, 'G3DSA:2.130.10.10:FF:005910', NULL, NULL, 'ADL316Cp', NULL, NULL, NULL, NULL, NULL, 4),
(113585, NULL, 'G3DSA:2.40.50.140:FF:001173', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113586, NULL, 'G3DSA:2.40.70.10:FF:000573', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113587, NULL, 'G3DSA:3.30.740.10:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113588, NULL, 'G3DSA:2.20.100.10:FF:000198', NULL, NULL, 'Sema domain, seven thrombospondin repeats (type 1 and type 1-like), transmembrane domain (TM) and short cytoplasmic domain, (semaphorin) 5Ba', NULL, NULL, NULL, NULL, NULL, 4),
(113589, NULL, 'G3DSA:2.40.240.10:FF:000029', NULL, NULL, 'Glutamine-tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(113590, NULL, 'G3DSA:1.10.510.10:FF:000128', NULL, NULL, 'serine/threonine-protein kinase ULK2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(113591, NULL, 'G3DSA:2.130.10.10:FF:000104', NULL, NULL, 'Kinesin family member 21A', NULL, NULL, NULL, NULL, NULL, 4),
(113592, NULL, 'G3DSA:1.10.472.10:FF:000365', NULL, NULL, 'Cyclin-D1-1', NULL, NULL, NULL, NULL, NULL, 4),
(113593, NULL, 'G3DSA:1.20.1250.20:FF:002316', NULL, NULL, 'Inhibitor of growth family protein 2like, putative', NULL, NULL, NULL, NULL, NULL, 4),
(113594, NULL, 'G3DSA:1.10.238.10:FF:000883', NULL, NULL, 'Calcium-binding endonuclease/exonuclease/phosphatase family', NULL, NULL, NULL, NULL, NULL, 4),
(113595, NULL, 'G3DSA:2.10.110.10:FF:000263', NULL, NULL, 'Protein CBR-LIM-7', NULL, NULL, NULL, NULL, NULL, 4),
(113596, NULL, 'G3DSA:3.40.50.300:FF:004241', NULL, NULL, 'HTH-type transcriptional regulator MalT', NULL, NULL, NULL, NULL, NULL, 4),
(113597, NULL, 'G3DSA:1.10.8.10:FF:000032', NULL, NULL, 'Release factor glutamine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(113598, NULL, 'G3DSA:3.40.50.11260:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113599, NULL, 'G3DSA:3.30.160.60:FF:004954', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113600, NULL, 'G3DSA:3.30.530.20:FF:000087', NULL, NULL, 'Phytohormone-binding protein CSBP', NULL, NULL, NULL, NULL, NULL, 4),
(113601, NULL, 'G3DSA:3.30.420.40:FF:000197', NULL, NULL, 'Heat shock protein 105', NULL, NULL, NULL, NULL, NULL, 4),
(113602, NULL, 'G3DSA:1.10.630.10:FF:000194', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(113603, NULL, 'G3DSA:1.25.40.10:FF:001328', NULL, NULL, 'Superkiller 3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(113604, NULL, 'G3DSA:1.20.920.20:FF:000014', NULL, NULL, 'dynein heavy chain 2, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(113605, NULL, 'G3DSA:2.130.10.10:FF:001195', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(113606, NULL, 'G3DSA:3.40.50.2300:FF:001119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113607, NULL, 'G3DSA:3.30.160.60:FF:002037', NULL, NULL, 'zinc finger protein 64 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(113608, NULL, 'G3DSA:3.30.710.10:FF:000295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113609, NULL, 'G3DSA:3.40.50.2000:FF:000282', NULL, NULL, 'Putative lipopolysaccharide heptosyltransferase II', NULL, NULL, NULL, NULL, NULL, 4),
(113610, NULL, 'G3DSA:1.10.30.10:FF:000102', NULL, NULL, 'Transcription factor Sox-7', NULL, NULL, NULL, NULL, NULL, 4),
(113611, NULL, 'G3DSA:3.30.70.330:FF:002896', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(113612, NULL, 'G3DSA:1.25.10.10:FF:001490', NULL, NULL, 'Protein raptor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(113613, NULL, 'G3DSA:3.60.130.10:FF:000030', NULL, NULL, 'Taurine catabolism dioxygenase, TauD/TfdA family', NULL, NULL, NULL, NULL, NULL, 4),
(113614, NULL, 'G3DSA:2.40.30.170:FF:000071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113615, NULL, 'G3DSA:3.60.10.10:FF:000234', NULL, NULL, 'Inositol polyphosphate 5-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(113616, NULL, 'G3DSA:1.10.1450.10:FF:000105', NULL, NULL, 'Tsp-20', NULL, NULL, NULL, NULL, NULL, 4),
(113617, NULL, 'G3DSA:1.10.1040.10:FF:000086', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(113618, NULL, 'G3DSA:1.10.565.10:FF:000053', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(113619, NULL, 'G3DSA:3.40.50.150:FF:001195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113620, NULL, 'G3DSA:3.20.110.20:FF:000001', NULL, NULL, 'Flagellin modification glycoside hydrolase family 57', NULL, NULL, NULL, NULL, NULL, 4),
(113621, NULL, 'G3DSA:1.10.3110.10:FF:000013', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(113622, NULL, 'G3DSA:3.40.1310.20:FF:000005', NULL, NULL, 'Large T antigen', NULL, NULL, NULL, NULL, NULL, 4),
(113623, NULL, 'G3DSA:3.90.70.10:FF:000231', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(113624, NULL, 'G3DSA:3.90.640.10:FF:000207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113625, NULL, 'G3DSA:1.10.555.10:FF:000125', NULL, NULL, 'Protein CBR-OCRL-1', NULL, NULL, NULL, NULL, NULL, 4),
(113626, NULL, 'G3DSA:1.10.10.460:FF:000001', NULL, NULL, 'Ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(113627, NULL, 'G3DSA:2.60.200.20:FF:000031', NULL, NULL, 'Forkhead box protein K1', NULL, NULL, NULL, NULL, NULL, 4),
(113628, NULL, 'G3DSA:3.30.160.60:FF:000137', NULL, NULL, 'Putative zinc finger protein 143', NULL, NULL, NULL, NULL, NULL, 4),
(113629, NULL, 'G3DSA:1.10.238.10:FF:001147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113630, NULL, 'G3DSA:2.40.30.10:FF:000508', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(113631, NULL, 'G3DSA:1.25.40.10:FF:005122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113632, NULL, 'G3DSA:3.20.20.80:FF:000403', NULL, NULL, 'Arabinofuranosidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(113633, NULL, 'G3DSA:1.25.10.10:FF:001343', NULL, NULL, 'YALI0E12243p', NULL, NULL, NULL, NULL, NULL, 4),
(113634, NULL, 'G3DSA:3.20.20.80:FF:000504', NULL, NULL, 'Putative beta transglucosylase, GH17 family (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(113635, NULL, 'G3DSA:3.30.9.10:FF:000255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113636, NULL, 'G3DSA:3.60.20.10:FF:000162', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113637, NULL, 'G3DSA:2.20.28.10:FF:000021', NULL, NULL, 'DNA replication licensing factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(113638, NULL, 'G3DSA:1.20.1250.20:FF:001035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113639, NULL, 'G3DSA:2.60.40.10:FF:003886', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113640, NULL, 'G3DSA:2.30.30.40:FF:000664', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113641, NULL, 'G3DSA:1.25.40.10:FF:003228', NULL, NULL, 'Protein O-mannosyl-transferase TMTC4', NULL, NULL, NULL, NULL, NULL, 4),
(113642, NULL, 'G3DSA:3.40.1170.60:FF:000017', NULL, NULL, 'Putative DNA polymerase kappa', NULL, NULL, NULL, NULL, NULL, 4),
(113643, NULL, 'G3DSA:2.130.10.10:FF:004718', NULL, NULL, 'WD repeat-containing protein 55 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(113644, NULL, 'G3DSA:3.50.50.60:FF:001022', NULL, NULL, 'N,N-dimethylglycine oxidase, putative (AFU_orthologue AFUA_8G06470)', NULL, NULL, NULL, NULL, NULL, 4),
(113645, NULL, 'G3DSA:1.25.40.720:FF:000007', NULL, NULL, 'WGS project CABT00000000 data, contig 2.6', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(113646, NULL, 'G3DSA:1.20.1250.20:FF:000416', NULL, NULL, 'acetyl-coenzyme A transporter 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(113647, NULL, 'G3DSA:1.10.10.1620:FF:000001', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(113648, NULL, 'G3DSA:3.30.420.40:FF:000152', NULL, NULL, 'actin, alpha skeletal muscle isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(113649, NULL, 'G3DSA:3.40.50.300:FF:006141', NULL, NULL, 'Chromodomain-helicase-DNA-binding protein 3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(113650, NULL, 'G3DSA:2.130.10.10:FF:005808', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113651, NULL, 'G3DSA:3.10.180.10:FF:000027', NULL, NULL, '1,2-dihydroxynaphthalene dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(113652, NULL, 'G3DSA:3.30.760.10:FF:000084', NULL, NULL, 'Eukaryotic translation initiation factor 4E6, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(113653, NULL, 'G3DSA:1.25.10.10:FF:002771', NULL, NULL, 'AP-4 complex subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(113654, NULL, 'G3DSA:3.40.50.1110:FF:000121', NULL, NULL, 'Probable cytochrome c', NULL, NULL, NULL, NULL, NULL, 4),
(113655, NULL, 'G3DSA:2.60.40.420:FF:000053', NULL, NULL, 'Laccase', NULL, NULL, NULL, NULL, NULL, 4),
(113656, NULL, 'G3DSA:1.25.40.10:FF:000002', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(113657, NULL, 'G3DSA:3.10.350.10:FF:000063', NULL, NULL, 'Peptidoglycan endopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(113658, NULL, 'G3DSA:1.20.120.720:FF:000038', NULL, NULL, 'Class II myosin', NULL, NULL, NULL, NULL, NULL, 4),
(113659, NULL, 'G3DSA:3.30.1120.10:FF:000030', NULL, NULL, 'N-acetylgalactosamine-6-sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(113660, NULL, 'G3DSA:3.30.40.10:FF:000108', NULL, NULL, 'E3 ubiquitin-protein ligase MARCH7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(113661, NULL, 'G3DSA:1.25.40.10:FF:001171', NULL, NULL, 'Os12g0557800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(113662, NULL, 'G3DSA:3.40.50.620:FF:000048', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(113663, NULL, 'G3DSA:2.60.40.10:FF:002397', NULL, NULL, 'Immunoglobulin heavy variable 4-9', NULL, NULL, NULL, NULL, NULL, 4),
(113664, NULL, 'G3DSA:3.90.209.20:FF:000001', NULL, NULL, 'Hemagglutinin', NULL, NULL, NULL, NULL, NULL, 4),
(113665, NULL, 'G3DSA:3.80.10.10:FF:000407', NULL, NULL, 'leucine-rich repeat protein SHOC-2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(113666, NULL, 'G3DSA:3.15.10.30:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113667, NULL, 'G3DSA:3.40.140.20:FF:000004', NULL, NULL, 'Bifunctional purine biosynthesis protein PURH', NULL, NULL, NULL, NULL, NULL, 4),
(113668, NULL, 'G3DSA:2.160.20.10:FF:000261', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113669, NULL, 'G3DSA:1.10.390.10:FF:000039', NULL, NULL, 'thyrotropin-releasing hormone-degrading ectoenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(113670, NULL, 'G3DSA:2.130.10.10:FF:000576', NULL, NULL, 'Ribosome biogenesis protein ERB1', NULL, NULL, NULL, NULL, NULL, 4),
(113671, NULL, 'G3DSA:2.160.10.10:FF:000069', NULL, NULL, 'Eukaryotic translation initiation factor 2B, subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(113672, NULL, 'G3DSA:2.60.40.10:FF:001071', NULL, NULL, 'obscurin isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(113673, NULL, 'G3DSA:2.60.120.380:FF:000005', NULL, NULL, 'calpain-type cysteine protease DEK1', NULL, NULL, NULL, NULL, NULL, 4),
(113674, NULL, 'G3DSA:3.40.50.150:FF:000312', NULL, NULL, 'NOP2/Sun RNA methyltransferase family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(113675, NULL, 'G3DSA:3.90.1150.10:FF:000265', NULL, NULL, 'Pyridoxal phosphate-dependent aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(113676, NULL, 'G3DSA:1.10.8.60:FF:000345', NULL, NULL, 'Werner helicase interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(113677, NULL, 'G3DSA:1.25.40.20:FF:001426', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(113678, NULL, 'G3DSA:1.10.510.10:FF:004170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113679, NULL, 'G3DSA:3.40.50.720:FF:000399', NULL, NULL, 'Probable oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(113680, NULL, 'G3DSA:3.40.50.300:FF:003836', NULL, NULL, 'Toxin-coregulated pilus biosynthesis protein T', NULL, NULL, NULL, NULL, NULL, 4),
(113681, NULL, 'G3DSA:2.60.40.10:FF:005123', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113682, NULL, 'G3DSA:3.30.720.10:FF:000019', NULL, NULL, 'Signal recognition particle 9 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(113683, NULL, 'G3DSA:3.40.800.20:FF:000004', NULL, NULL, 'Histone deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(113684, NULL, 'G3DSA:3.30.30.30:FF:000029', NULL, NULL, 'Heat shock protein 70kD, putative', NULL, NULL, NULL, NULL, NULL, 4),
(113685, NULL, 'G3DSA:1.25.10.10:FF:001388', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113686, NULL, 'G3DSA:2.60.420.10:FF:000005', NULL, NULL, 'Alpha,alpha-trehalose phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(113687, NULL, 'G3DSA:2.10.50.30:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113688, NULL, 'G3DSA:3.90.550.50:FF:000235', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(113689, NULL, 'G3DSA:3.60.10.10:FF:000381', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113690, NULL, 'G3DSA:3.40.1810.10:FF:000052', NULL, NULL, 'MADS-box transcription factor pvg4', NULL, NULL, NULL, NULL, NULL, 4),
(113691, NULL, 'G3DSA:3.30.1110.10:FF:000001', NULL, NULL, 'Adenosine kinase a', NULL, NULL, NULL, NULL, NULL, 4),
(113692, NULL, 'G3DSA:3.50.50.60:FF:000550', NULL, NULL, 'Possible oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(113693, NULL, 'G3DSA:3.30.60.30:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113694, NULL, 'G3DSA:1.10.472.10:FF:000573', NULL, NULL, 'Cyclin D3', NULL, NULL, NULL, NULL, NULL, 4),
(113695, NULL, 'G3DSA:3.20.20.70:FF:000614', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113696, NULL, 'G3DSA:3.40.50.1700:FF:000006', NULL, NULL, 'Lysosomal beta glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(113697, NULL, 'G3DSA:3.40.50.800:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113698, NULL, 'G3DSA:3.20.20.70:FF:000305', NULL, NULL, 'TIM-barrel enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(113699, NULL, 'G3DSA:2.30.39.10:FF:000006', NULL, NULL, 'Plasminogen activator inhibitor 1', NULL, NULL, NULL, NULL, NULL, 4),
(113700, NULL, 'G3DSA:1.20.5.690:FF:000002', NULL, NULL, 'Importin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(113701, NULL, 'G3DSA:2.40.50.140:FF:000554', NULL, NULL, 'Yeast MCM (Licensing factor) related', NULL, NULL, NULL, NULL, NULL, 4),
(113702, NULL, 'G3DSA:2.102.10.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113703, NULL, 'G3DSA:2.40.420.20:FF:000007', NULL, NULL, 'HAE1 family efflux pump MFP component', NULL, NULL, NULL, NULL, NULL, 4),
(113704, NULL, 'G3DSA:3.30.40.210:FF:000004', NULL, NULL, 'Transcription elongation factor SPT4', NULL, NULL, NULL, NULL, NULL, 4),
(113705, NULL, 'G3DSA:3.30.160.60:FF:001626', NULL, NULL, 'Zinc finger protein 384', NULL, NULL, NULL, NULL, NULL, 4),
(113706, NULL, 'G3DSA:1.20.1560.10:FF:000280', NULL, NULL, 'Chromosome 16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(113707, NULL, 'G3DSA:2.60.200.40:FF:000037', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(113708, NULL, 'G3DSA:3.40.1000.30:FF:000007', NULL, NULL, 'proteasome inhibitor PI31 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(113709, NULL, 'G3DSA:1.25.10.10:FF:000871', NULL, NULL, 'HEAT repeat domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(113710, NULL, 'G3DSA:3.40.1000.50:FF:000002', NULL, NULL, 'Repressor of RNA polymerase III transcription MAF1', NULL, NULL, NULL, NULL, NULL, 4),
(113711, NULL, 'G3DSA:1.20.990.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(113712, NULL, 'G3DSA:1.20.1070.10:FF:000563', NULL, NULL, 'Sex peptide receptor', NULL, NULL, NULL, NULL, NULL, 4),
(113713, NULL, 'G3DSA:3.30.70.1290:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113714, NULL, 'G3DSA:1.50.10.20:FF:000017', NULL, NULL, 'Protein farnesyltransferase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(113715, NULL, 'G3DSA:3.30.160.60:FF:001317', NULL, NULL, 'zinc finger protein 576 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(113716, NULL, 'G3DSA:1.25.40.10:FF:000608', NULL, NULL, 'Putative pre-mRNA splicing factor', NULL, NULL, NULL, NULL, NULL, 4),
(113717, NULL, 'G3DSA:3.40.50.300:FF:000290', NULL, NULL, 'Protein-tyrosine sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(113718, NULL, 'G3DSA:3.30.1470.10:FF:000005', NULL, NULL, 'Centrosomal protein 164', NULL, NULL, NULL, NULL, NULL, 4),
(113719, NULL, 'G3DSA:1.20.120.350:FF:000085', NULL, NULL, 'potassium voltage-gated channel subfamily G member 2', NULL, NULL, NULL, NULL, NULL, 4),
(113720, NULL, 'G3DSA:2.130.10.10:FF:000003', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(113721, NULL, 'G3DSA:3.40.50.2000:FF:000534', NULL, NULL, 'Glycogen [starch] synthase', NULL, NULL, NULL, NULL, NULL, 4),
(113722, NULL, 'G3DSA:1.20.120.640:FF:000003', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(113723, NULL, 'G3DSA:3.40.50.720:FF:002450', NULL, NULL, 'SUMO-activating enzyme subunit', NULL, NULL, NULL, NULL, NULL, 4),
(113724, NULL, 'G3DSA:3.20.20.70:FF:000193', NULL, NULL, 'L-lactate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(113725, NULL, 'G3DSA:2.60.40.10:FF:005831', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113726, NULL, 'G3DSA:3.10.20.90:FF:000502', NULL, NULL, 'Ubiquitin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(113727, NULL, 'G3DSA:1.10.1520.10:FF:000021', NULL, NULL, 'RNA editing complex protein MP67', NULL, NULL, NULL, NULL, NULL, 4),
(113728, NULL, 'G3DSA:3.40.720.10:FF:000304', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(113729, NULL, 'G3DSA:3.40.970.10:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113730, NULL, 'G3DSA:3.30.70.330:FF:001159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113731, NULL, 'G3DSA:2.20.25.10:FF:000104', NULL, NULL, 'Transcription factor S, archaeal', NULL, NULL, NULL, NULL, NULL, 4),
(113732, NULL, 'G3DSA:2.40.110.10:FF:000048', NULL, NULL, 'Acyl-CoA dehydrogenase, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4),
(113733, NULL, 'G3DSA:3.80.10.10:FF:000554', NULL, NULL, 'Acidic leucine-rich nuclear phosphoprotein 32-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(113734, NULL, 'G3DSA:3.40.50.1460:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113735, NULL, 'G3DSA:2.10.25.10:FF:001026', NULL, NULL, 'Eater', NULL, NULL, NULL, NULL, NULL, 4),
(113736, NULL, 'G3DSA:1.10.10.10:FF:001219', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(113737, NULL, 'G3DSA:2.30.34.10:FF:000001', NULL, NULL, 'leishmanolysin-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(113738, NULL, 'G3DSA:1.20.1280.290:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113739, NULL, 'G3DSA:2.20.100.10:FF:000153', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs adt-2', NULL, NULL, NULL, NULL, NULL, 4),
(113740, NULL, 'G3DSA:1.10.840.10:FF:000029', NULL, NULL, 'Ras guanine nucleotide exchange factor E', NULL, NULL, NULL, NULL, NULL, 4),
(113741, NULL, 'G3DSA:1.10.437.10:FF:000031', NULL, NULL, 'BH3-interacting domain death agonist', NULL, NULL, NULL, NULL, NULL, 4),
(113742, NULL, 'G3DSA:1.25.40.10:FF:002508', NULL, NULL, 'CS_domain/TPR_repeat/Tetratricopeptide_repeat_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(113743, NULL, 'G3DSA:3.20.20.190:FF:000137', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113744, NULL, 'G3DSA:3.40.50.200:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(113745, NULL, 'G3DSA:3.30.160.60:FF:004499', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113746, NULL, 'G3DSA:3.40.50.300:FF:003527', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit beta-2', NULL, NULL, NULL, NULL, NULL, 4),
(113747, NULL, 'G3DSA:1.10.420.10:FF:000037', NULL, NULL, 'Peroxidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(113748, NULL, 'G3DSA:3.90.550.10:FF:000116', NULL, NULL, 'Poly-beta-1,6-N-acetyl-D-glucosamine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(113749, NULL, 'G3DSA:1.25.40.10:FF:002817', NULL, NULL, 'Transcription factor Tcc1p', NULL, NULL, NULL, NULL, NULL, 4),
(113750, NULL, 'G3DSA:1.20.1070.10:FF:001389', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(113751, NULL, 'G3DSA:3.40.50.10880:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113752, NULL, 'G3DSA:2.60.120.200:FF:000103', NULL, NULL, 'L-type lectin-domain containing receptor kinase IX.1', NULL, NULL, NULL, NULL, NULL, 4),
(113753, NULL, 'G3DSA:3.30.300.10:FF:000027', NULL, NULL, 'GMP synthase (Glutamine-hydrolysing)', NULL, NULL, NULL, NULL, NULL, 4),
(113754, NULL, 'G3DSA:1.20.58.60:FF:000135', NULL, NULL, 'Spectrin beta chain, non-erythrocytic', NULL, NULL, NULL, NULL, NULL, 4),
(113755, NULL, 'G3DSA:3.80.10.10:FF:000863', NULL, NULL, 'Class II major histocompatibility complex transactivator', NULL, NULL, NULL, NULL, NULL, 4),
(113756, NULL, 'G3DSA:3.30.230.80:FF:000014', NULL, NULL, 'Lipophosphoglycan biosynthetic protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(113757, NULL, 'G3DSA:1.10.287.160:FF:000018', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(113758, NULL, 'G3DSA:3.40.50.2000:FF:000843', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113759, NULL, 'G3DSA:2.50.20.10:FF:000018', NULL, NULL, 'Outer-membrane lipoprotein carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(113760, NULL, 'G3DSA:1.20.1070.10:FF:000416', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113761, NULL, 'G3DSA:2.40.10.10:FF:000142', NULL, NULL, 'Clip-domain serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(113762, NULL, 'G3DSA:3.40.50.300:FF:005522', NULL, NULL, 'Si:dkeyp-52c3.7', NULL, NULL, NULL, NULL, NULL, 4),
(113763, NULL, 'G3DSA:1.20.5.170:FF:000167', NULL, NULL, 'UDP-3-O-acylglucosamine N-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(113764, NULL, 'G3DSA:1.10.287.70:FF:000598', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113765, NULL, 'G3DSA:1.10.10.60:FF:000565', NULL, NULL, 'DNA methylation and regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(113766, NULL, 'G3DSA:3.60.21.10:FF:000153', NULL, NULL, 'Exonuclease II', NULL, NULL, NULL, NULL, NULL, 4),
(113767, NULL, 'G3DSA:2.60.40.10:FF:000452', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(113768, NULL, 'G3DSA:2.160.20.10:FF:000159', NULL, NULL, 'Cell surface glycoprotein (S-layer protein)', NULL, NULL, NULL, NULL, NULL, 4),
(113769, NULL, 'G3DSA:3.30.200.20:FF:001809', NULL, NULL, 'Probable serine/threonine-protein kinase DDB_G0277071', NULL, NULL, NULL, NULL, NULL, 4),
(113770, NULL, 'G3DSA:3.40.30.10:FF:000074', NULL, NULL, 'endoplasmic reticulum resident protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(113771, NULL, 'G3DSA:1.10.287.70:FF:000289', NULL, NULL, 'CRE-TWK-18 protein', NULL, NULL, NULL, NULL, NULL, 4),
(113772, NULL, 'G3DSA:3.40.50.300:FF:007422', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(113773, NULL, 'G3DSA:4.10.280.10:FF:000065', NULL, NULL, 'class A basic helix-loop-helix protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(113774, NULL, 'G3DSA:3.40.50.1010:FF:000237', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113775, NULL, 'G3DSA:1.10.10.10:FF:001528', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(113776, NULL, 'G3DSA:3.40.390.10:FF:000278', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113777, NULL, 'G3DSA:1.10.238.10:FF:001294', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(113778, NULL, 'G3DSA:1.10.287.1240:FF:000006', NULL, NULL, 'Exodeoxyribonuclease I', NULL, NULL, NULL, NULL, NULL, 4),
(113779, NULL, 'G3DSA:2.60.40.10:FF:003577', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113780, NULL, 'G3DSA:3.90.70.10:FF:000894', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113781, NULL, 'G3DSA:1.20.120.1910:FF:000032', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(113782, NULL, 'G3DSA:2.20.110.10:FF:000024', NULL, NULL, 'MATH and UCH domain protein, putaitve', NULL, NULL, NULL, NULL, NULL, 4),
(113783, NULL, 'G3DSA:3.30.260.10:FF:000091', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113784, NULL, 'G3DSA:3.30.160.60:FF:003673', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113785, NULL, 'G3DSA:1.10.238.20:FF:000015', NULL, NULL, 'Odorant-binding protein 56h', NULL, NULL, NULL, NULL, NULL, 4),
(113786, NULL, 'G3DSA:3.40.50.10240:FF:000021', NULL, NULL, 'Thiamine pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(113787, NULL, 'G3DSA:3.40.190.10:FF:000358', NULL, NULL, 'Lipoprotein LPQZ', NULL, NULL, NULL, NULL, NULL, 4),
(113788, NULL, 'G3DSA:2.60.120.200:FF:000412', NULL, NULL, 'Laminin alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(113789, NULL, 'G3DSA:1.50.40.10:FF:000410', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113790, NULL, 'G3DSA:2.60.40.10:FF:000143', NULL, NULL, 'Vascular endothelial growth factor receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(113791, NULL, 'G3DSA:2.60.120.10:FF:000331', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(113792, NULL, 'G3DSA:3.40.50.150:FF:001756', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113793, NULL, 'G3DSA:1.10.730.10:FF:000038', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(113794, NULL, 'G3DSA:3.20.110.10:FF:000009', NULL, NULL, '1,4-alpha-glucan branching enzyme TK1436', NULL, NULL, NULL, NULL, NULL, 4),
(113795, NULL, 'G3DSA:1.10.10.440:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113796, NULL, 'G3DSA:3.30.497.10:FF:000180', NULL, NULL, 'AGAP009670-PA', NULL, NULL, NULL, NULL, NULL, 4),
(113797, NULL, 'G3DSA:1.10.510.10:FF:001556', NULL, NULL, 'CMGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(113798, NULL, 'G3DSA:2.80.10.50:FF:000113', NULL, NULL, 'Kunitz-type serine protease inhibitor DrTI', NULL, NULL, NULL, NULL, NULL, 4),
(113799, NULL, 'G3DSA:3.40.50.720:FF:001017', NULL, NULL, 'Related to ERG27-3-keto sterol reductase', NULL, NULL, NULL, NULL, NULL, 4),
(113800, NULL, 'G3DSA:2.120.10.30:FF:000200', NULL, NULL, 'Low-density lipoprotein RecePtor related', NULL, NULL, NULL, NULL, NULL, 4),
(113801, NULL, 'G3DSA:2.40.30.30:FF:000003', NULL, NULL, 'Riboflavin biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(113802, NULL, 'G3DSA:3.40.50.410:FF:000334', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113803, NULL, 'G3DSA:2.170.190.11:FF:000006', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(113804, NULL, 'G3DSA:1.20.120.20:FF:000037', NULL, NULL, 'Zgc:162608', NULL, NULL, NULL, NULL, NULL, 4),
(113805, NULL, 'G3DSA:3.10.450.350:FF:000013', NULL, NULL, 'Cell wall endopeptidase family M23/M37', NULL, NULL, NULL, NULL, NULL, 4),
(113806, NULL, 'G3DSA:3.40.630.30:FF:000533', NULL, NULL, 'O-GlcNAcase-like', NULL, NULL, NULL, NULL, NULL, 4),
(113807, NULL, 'G3DSA:3.10.20.10:FF:000035', NULL, NULL, '60S ribosomal protein L18a', NULL, NULL, NULL, NULL, NULL, 4),
(113808, NULL, 'G3DSA:3.30.420.10:FF:000093', NULL, NULL, 'DNA polymerase III subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(113809, NULL, 'G3DSA:3.40.190.10:FF:000049', NULL, NULL, 'Putrescine-binding periplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(113810, NULL, 'G3DSA:3.30.450.20:FF:000131', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(113811, NULL, 'G3DSA:3.30.200.20:FF:001248', NULL, NULL, 'Serine/threonine protein kinase 21', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(113812, NULL, 'G3DSA:3.30.930.10:FF:000176', NULL, NULL, 'Phenylalanyl-tRNA synthetase alpha chain B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(113813, NULL, 'G3DSA:3.10.290.10:FF:000018', NULL, NULL, '40S ribosomal protein S9', NULL, NULL, NULL, NULL, NULL, 4),
(113814, NULL, 'G3DSA:3.40.50.2000:FF:000990', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113815, NULL, 'G3DSA:3.80.10.10:FF:002763', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113816, NULL, 'G3DSA:3.40.50.1100:FF:000023', NULL, NULL, 'Cysteine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(113817, NULL, 'G3DSA:1.10.510.10:FF:003242', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113818, NULL, 'G3DSA:2.130.10.10:FF:000559', NULL, NULL, 'Coatomer subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(113819, NULL, 'G3DSA:3.30.160.60:FF:000031', NULL, NULL, 'GLI family zinc finger 3', NULL, NULL, NULL, NULL, NULL, 4),
(113820, NULL, 'G3DSA:3.40.30.10:FF:000630', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(113821, NULL, 'G3DSA:3.10.450.50:FF:000009', NULL, NULL, 'Calcium/calmodulin-dependent protein kinase type II', NULL, NULL, NULL, NULL, NULL, 4),
(113822, NULL, 'G3DSA:3.10.450.240:FF:000008', NULL, NULL, '39S ribosomal protein L45, mitochondrial isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(113823, NULL, 'G3DSA:3.40.50.720:FF:002080', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(113824, NULL, 'G3DSA:3.10.580.10:FF:000092', NULL, NULL, 'D-arabinose 5-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(113825, NULL, 'G3DSA:3.30.559.10:FF:000138', NULL, NULL, 'Glycoside hydrolase family 128 protein', NULL, NULL, NULL, NULL, NULL, 4),
(113826, NULL, 'G3DSA:1.25.10.10:FF:001944', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113827, NULL, 'G3DSA:3.40.50.150:FF:001065', NULL, NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(113828, NULL, 'G3DSA:2.10.230.10:FF:000007', NULL, NULL, 'DnaJ protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(113829, NULL, 'G3DSA:2.130.10.10:FF:003307', NULL, NULL, 'Transducin beta-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(113830, NULL, 'G3DSA:4.10.240.10:FF:000074', NULL, NULL, 'Unplaced genomic scaffold supercont2.11, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(113831, NULL, 'G3DSA:1.50.40.10:FF:000163', NULL, NULL, 'Mitochondrial carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(113832, NULL, 'G3DSA:1.10.630.10:FF:000654', NULL, NULL, 'Cytochrome P450, family 51', NULL, NULL, NULL, NULL, NULL, 4),
(113833, NULL, 'G3DSA:2.102.10.10:FF:000038', NULL, NULL, 'Rieske (2Fe-2S) protein', NULL, NULL, NULL, NULL, NULL, 4),
(113834, NULL, 'G3DSA:3.30.70.330:FF:000878', NULL, NULL, 'Unplaced genomic scaffold supercont1.15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(113835, NULL, 'G3DSA:1.25.40.20:FF:001449', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113836, NULL, 'G3DSA:2.20.25.20:FF:000011', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(113837, NULL, 'G3DSA:3.30.160.60:FF:003690', NULL, NULL, 'Zinc finger and BTB domain-containing 17', NULL, NULL, NULL, NULL, NULL, 4),
(113838, NULL, 'G3DSA:3.30.750.24:FF:000136', NULL, NULL, 'Sulfate transporter/antisigma-factor antagonist STAS', NULL, NULL, NULL, NULL, NULL, 4),
(113839, NULL, 'G3DSA:2.10.25.10:FF:001251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113840, NULL, 'G3DSA:2.30.42.10:FF:000368', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113841, NULL, 'G3DSA:3.30.2230.10:FF:000021', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(113842, NULL, 'G3DSA:3.40.390.80:FF:000001', NULL, NULL, 'TRPM8 channel-associated factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(113843, NULL, 'G3DSA:3.30.1490.180:FF:000037', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(113844, NULL, 'G3DSA:1.25.40.20:FF:000937', NULL, NULL, 'Ankyrin repeats (3 copies), putative', NULL, NULL, NULL, NULL, NULL, 4),
(113845, NULL, 'G3DSA:1.20.1600.10:FF:000008', NULL, NULL, 'Periplasmic type I secretion system protein', NULL, NULL, NULL, NULL, NULL, 4),
(113846, NULL, 'G3DSA:3.30.2350.20:FF:000078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113847, NULL, 'G3DSA:1.20.58.390:FF:000316', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113848, NULL, 'G3DSA:3.40.50.2300:FF:000866', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113849, NULL, 'G3DSA:1.10.510.10:FF:000600', NULL, NULL, 'Phosphoenolpyruvate carboxylase kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(113850, NULL, 'G3DSA:3.40.50.150:FF:000992', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113851, NULL, 'G3DSA:3.10.20.90:FF:000238', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(113852, NULL, 'G3DSA:2.60.120.320:FF:000010', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(113853, NULL, 'G3DSA:1.20.1250.20:FF:000546', NULL, NULL, 'BSC6p protein', NULL, NULL, NULL, NULL, NULL, 4),
(113854, NULL, 'G3DSA:1.10.510.10:FF:001539', NULL, NULL, 'HRK1p Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(113855, NULL, 'G3DSA:3.20.20.70:FF:000530', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113856, NULL, 'G3DSA:1.20.1260.10:FF:000038', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(113857, NULL, 'G3DSA:2.60.40.60:FF:000450', NULL, NULL, 'Cadherin 5', NULL, NULL, NULL, NULL, NULL, 4),
(113858, NULL, 'G3DSA:3.40.50.10190:FF:000219', NULL, NULL, 'Nibrin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(113859, NULL, 'G3DSA:2.40.10.10:FF:000041', NULL, NULL, 'kallikrein-6 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(113860, NULL, 'G3DSA:3.40.630.30:FF:000269', NULL, NULL, 'GNAT family N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(113861, NULL, 'G3DSA:1.20.120.1080:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113862, NULL, 'G3DSA:3.30.70.260:FF:000143', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(113863, NULL, 'G3DSA:1.25.40.10:FF:000827', NULL, NULL, 'Tetratricopeptide repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(113864, NULL, 'G3DSA:3.30.160.20:FF:000120', NULL, NULL, 'RISC-loading complex subunit TARBP2', NULL, NULL, NULL, NULL, NULL, 4),
(113865, NULL, 'G3DSA:3.30.540.30:FF:000006', NULL, NULL, 'Clan M-, family M49, dipeptidylpeptidase III-like metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(113866, NULL, 'G3DSA:1.25.10.10:FF:002563', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113867, NULL, 'G3DSA:3.30.160.20:FF:000159', NULL, NULL, 'Ribonuclease 3', NULL, NULL, NULL, NULL, NULL, 4),
(113868, NULL, 'G3DSA:3.30.1370.10:FF:000177', NULL, NULL, 'Hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(113869, NULL, 'G3DSA:2.60.40.10:FF:001677', NULL, NULL, 'Fasciclin 2, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(113870, NULL, 'G3DSA:3.30.565.10:FF:000563', NULL, NULL, 'Response regulator receiver domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(113871, NULL, 'G3DSA:3.40.50.300:FF:006686', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113872, NULL, 'G3DSA:1.25.10.10:FF:002877', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(113873, NULL, 'G3DSA:3.40.50.300:FF:000273', NULL, NULL, 'GTP-binding protein Rheb homolog', NULL, NULL, NULL, NULL, NULL, 4),
(113874, NULL, 'G3DSA:3.40.50.300:FF:008294', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113875, NULL, 'G3DSA:1.25.40.20:FF:001292', NULL, NULL, 'Os07g0481700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(113876, NULL, 'G3DSA:3.30.430.20:FF:000023', NULL, NULL, 'Antifungal protein ginkbilobin-2', NULL, NULL, NULL, NULL, NULL, 4),
(113877, NULL, 'G3DSA:1.10.1410.10:FF:000114', NULL, NULL, 'Trf4 poly(A) polymerase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(113878, NULL, 'G3DSA:3.40.50.1820:FF:000469', NULL, NULL, 'Pyochelin biosynthetic protein PchC', NULL, NULL, NULL, NULL, NULL, 4),
(113879, NULL, 'G3DSA:1.25.40.10:FF:003205', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(113880, NULL, 'G3DSA:3.30.200.20:FF:001147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113881, NULL, 'G3DSA:1.20.58.60:FF:000798', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113882, NULL, 'G3DSA:3.30.1640.10:FF:000041', NULL, NULL, 'DNA replication helicase protein MCM', NULL, NULL, NULL, NULL, NULL, 4),
(113883, NULL, 'G3DSA:3.40.50.300:FF:004325', NULL, NULL, 'ATP synthase alpha subunit vacuolar, putative', NULL, NULL, NULL, NULL, NULL, 4),
(113884, NULL, 'G3DSA:3.80.10.10:FF:003858', NULL, NULL, 'Toll, putative', NULL, NULL, NULL, NULL, NULL, 4),
(113885, NULL, 'G3DSA:3.20.20.140:FF:000369', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113886, NULL, 'G3DSA:2.40.50.140:FF:000785', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113887, NULL, 'G3DSA:1.25.40.10:FF:001772', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(113888, NULL, 'G3DSA:3.30.160.60:FF:005488', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113889, NULL, 'G3DSA:1.10.640.10:FF:000003', NULL, NULL, 'chorion peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(113890, NULL, 'G3DSA:3.40.50.1260:FF:000037', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(113891, NULL, 'G3DSA:1.25.10.10:FF:002080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113892, NULL, 'G3DSA:3.30.2060.10:FF:000002', NULL, NULL, 'Transcription-repair-coupling factor', NULL, NULL, NULL, NULL, NULL, 4),
(113893, NULL, 'G3DSA:3.90.1450.10:FF:000001', NULL, NULL, 'Guanylate cyclase activator 2B', NULL, NULL, NULL, NULL, NULL, 4),
(113894, NULL, 'G3DSA:3.30.450.20:FF:000030', NULL, NULL, 'Phytochrome', NULL, NULL, NULL, NULL, NULL, 4),
(113895, NULL, 'G3DSA:3.40.50.720:FF:000516', NULL, NULL, 'UDP-glucose 4-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(113896, NULL, 'G3DSA:1.25.10.10:FF:000163', NULL, NULL, 'Phospholipase A-2-activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(113897, NULL, 'G3DSA:3.40.50.1240:FF:000031', NULL, NULL, '6-phosphofructo-2-kinase/fructose-2, 6-bisphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(113898, NULL, 'G3DSA:1.20.58.60:FF:000371', NULL, NULL, 'Muscle-specific protein 300 kDa, isoform L', NULL, NULL, NULL, NULL, NULL, 4),
(113899, NULL, 'G3DSA:3.40.50.300:FF:004808', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113900, NULL, 'G3DSA:3.10.450.30:FF:000003', NULL, NULL, 'Hirsutellin A', NULL, NULL, NULL, NULL, NULL, 4),
(113901, NULL, 'G3DSA:2.40.50.140:FF:000892', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113902, NULL, 'G3DSA:1.20.1250.20:FF:000063', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(113903, NULL, 'G3DSA:3.80.10.10:FF:000638', NULL, NULL, 'Si:dkey-16p6.1', NULL, NULL, NULL, NULL, NULL, 4),
(113904, NULL, 'G3DSA:2.30.30.30:FF:000088', NULL, NULL, 'Probable 39S ribosomal protein L24, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(113905, NULL, 'G3DSA:3.30.750.210:FF:000001', NULL, NULL, 'CDK5 regulatory subunit-associated protein 1-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(113906, NULL, 'G3DSA:3.40.50.1000:FF:000083', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(113907, NULL, 'G3DSA:1.25.40.10:FF:003700', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113908, NULL, 'G3DSA:3.40.50.2300:FF:000490', NULL, NULL, 'Vomeronasal 2 receptor, x1', NULL, NULL, NULL, NULL, NULL, 4),
(113909, NULL, 'G3DSA:3.10.105.10:FF:000011', NULL, NULL, 'ABC transporter, substrate-binding protein, family 5', NULL, NULL, NULL, NULL, NULL, 4),
(113910, NULL, 'G3DSA:1.25.40.10:FF:004189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(113911, NULL, 'G3DSA:3.90.228.10:FF:000036', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(113912, NULL, 'G3DSA:1.10.630.10:FF:000177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113913, NULL, 'G3DSA:1.10.4200.10:FF:000003', NULL, NULL, 'Probable 2-(5''''-triphosphoribosyl)-3''-dephosphocoenzyme-A synthase', NULL, NULL, NULL, NULL, NULL, 4),
(113914, NULL, 'G3DSA:3.40.50.12760:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113915, NULL, 'G3DSA:3.50.50.60:FF:000078', NULL, NULL, 'Blast:Putative apoptosis-inducing factor 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(113916, NULL, 'G3DSA:2.60.40.380:FF:000007', NULL, NULL, 'Probable secreted alkaline phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(113917, NULL, 'G3DSA:3.40.50.300:FF:003943', NULL, NULL, 'GTP-binding protein ypt1', NULL, NULL, NULL, NULL, NULL, 4),
(113918, NULL, 'G3DSA:3.40.50.300:FF:007675', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113919, NULL, 'G3DSA:3.90.640.10:FF:000129', NULL, NULL, 'Actin-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(113920, NULL, 'G3DSA:3.40.1350.60:FF:000014', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(113921, NULL, 'G3DSA:3.30.200.20:FF:000528', NULL, NULL, 'serine/threonine-protein kinase Nek10 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(113922, NULL, 'G3DSA:3.40.50.11500:FF:000011', NULL, NULL, 'Denn domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(113923, NULL, 'G3DSA:2.170.120.12:FF:000037', NULL, NULL, 'RNA polymerase II core subunit', NULL, NULL, NULL, NULL, NULL, 4),
(113924, NULL, 'G3DSA:3.40.50.2300:FF:000057', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(113925, NULL, 'G3DSA:1.25.40.20:FF:001073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113926, NULL, 'G3DSA:2.10.25.10:FF:001627', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113927, NULL, 'G3DSA:3.10.129.10:FF:000088', NULL, NULL, 'Putative esterase F42H10.6', NULL, NULL, NULL, NULL, NULL, 4),
(113928, NULL, 'G3DSA:3.40.250.10:FF:000184', NULL, NULL, 'Thiosulfate sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(113929, NULL, 'G3DSA:3.90.660.10:FF:000006', NULL, NULL, 'Lysine-specific histone demethylase 1 3', NULL, NULL, NULL, NULL, NULL, 4),
(113930, NULL, 'G3DSA:1.10.150.120:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113931, NULL, 'G3DSA:3.30.70.330:FF:002249', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113932, NULL, 'G3DSA:1.50.10.10:FF:000026', NULL, NULL, 'Trehalase', NULL, NULL, NULL, NULL, NULL, 4),
(113933, NULL, 'G3DSA:3.40.50.2300:FF:000181', NULL, NULL, 'Two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(113934, NULL, 'G3DSA:3.30.160.60:FF:000345', NULL, NULL, 'Zinc finger protein Gfi-1', NULL, NULL, NULL, NULL, NULL, 4),
(113935, NULL, 'G3DSA:3.40.190.10:FF:000622', NULL, NULL, 'Amino acid ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(113936, NULL, 'G3DSA:1.10.287.470:FF:000010', NULL, NULL, 'Auxiliary transport protein, membrane fusion protein family', NULL, NULL, NULL, NULL, NULL, 4),
(113937, NULL, 'G3DSA:3.90.650.10:FF:000051', NULL, NULL, 'Thiamine-monophosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(113938, NULL, 'G3DSA:3.30.565.10:FF:000198', NULL, NULL, 'Phosphoglycerate transport regulatory protein PgtB', NULL, NULL, NULL, NULL, NULL, 4),
(113939, NULL, 'G3DSA:3.40.50.10810:FF:000001', NULL, NULL, 'chromodomain-helicase-DNA-binding protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(113940, NULL, 'G3DSA:3.30.200.20:FF:001512', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(113941, NULL, 'G3DSA:3.40.50.1820:FF:000593', NULL, NULL, 'Alpha/beta hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(113942, NULL, 'G3DSA:1.20.1070.10:FF:002086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(113943, NULL, 'G3DSA:3.20.20.190:FF:000131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113944, NULL, 'G3DSA:1.20.5.170:FF:000144', NULL, NULL, 'Male-specific lethal-1', NULL, NULL, NULL, NULL, NULL, 4),
(113945, NULL, 'G3DSA:2.40.70.10:FF:000382', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113946, NULL, 'G3DSA:2.130.10.10:FF:002493', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(113947, NULL, 'G3DSA:3.40.50.300:FF:003813', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(113948, NULL, 'G3DSA:3.40.50.300:FF:004432', NULL, NULL, 'Lipopolysaccharide biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(113949, NULL, 'G3DSA:3.80.10.10:FF:004005', NULL, NULL, 'Leucine-rich repeats and immunoglobulin-like domains 2', NULL, NULL, NULL, NULL, NULL, 4),
(113950, NULL, 'G3DSA:3.40.50.300:FF:003504', NULL, NULL, 'Mismatch repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(113951, NULL, 'G3DSA:3.30.160.60:FF:005016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113952, NULL, 'G3DSA:3.60.21.10:FF:000254', NULL, NULL, 'UDP-2,3-diacylglucosamine diphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(113953, NULL, 'G3DSA:3.30.505.10:FF:000115', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(113954, NULL, 'G3DSA:1.10.3210.10:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113955, NULL, 'G3DSA:3.40.140.10:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113956, NULL, 'G3DSA:1.25.40.10:FF:001300', NULL, NULL, 'Pentatricopeptide repeat protein PPR1106-17', NULL, NULL, NULL, NULL, NULL, 4),
(113957, NULL, 'G3DSA:2.10.110.10:FF:000072', NULL, NULL, 'Four and a half LIM domains protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(113958, NULL, 'G3DSA:1.10.1450.10:FF:000021', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(113959, NULL, 'G3DSA:3.30.40.10:FF:002339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113960, NULL, 'G3DSA:2.30.30.40:FF:000456', NULL, NULL, 'Putative voltage-dependent l-type calcium channel subunit beta-2', NULL, NULL, NULL, NULL, NULL, 4),
(113961, NULL, 'G3DSA:1.20.5.110:FF:000065', NULL, NULL, 'SEC22 (YLR268W)', NULL, NULL, NULL, NULL, NULL, 4),
(113962, NULL, 'G3DSA:2.60.40.1230:FF:000018', NULL, NULL, 'AP-1 complex subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(113963, NULL, 'G3DSA:1.20.1250.20:FF:000439', NULL, NULL, 'Multidrug MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(113964, NULL, 'G3DSA:2.30.140.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113965, NULL, 'G3DSA:2.60.40.10:FF:002296', NULL, NULL, 'Os11g0274100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(113966, NULL, 'G3DSA:3.20.20.105:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113967, NULL, 'G3DSA:3.40.50.720:FF:001461', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(113968, NULL, 'G3DSA:3.30.310.10:FF:000056', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(113969, NULL, 'G3DSA:2.20.25.110:FF:000002', NULL, NULL, 'D-alanine-D-alanine ligase related protein', NULL, NULL, NULL, NULL, NULL, 4),
(113970, NULL, 'G3DSA:3.40.50.960:FF:000004', NULL, NULL, '6,7-dimethyl-8-ribityllumazine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(113971, NULL, 'G3DSA:3.90.1480.20:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113972, NULL, 'G3DSA:1.20.58.80:FF:000012', NULL, NULL, 'AMSH-like protease isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(113973, NULL, 'G3DSA:3.30.70.330:FF:002795', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113974, NULL, 'G3DSA:3.40.50.10130:FF:000027', NULL, NULL, 'Restriction endonuclease type II-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(113975, NULL, 'G3DSA:3.40.50.620:FF:000256', NULL, NULL, 'Adenine nucleotide alpha hydrolases-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(113976, NULL, 'G3DSA:3.40.1410.10:FF:000050', NULL, NULL, 'TraR protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(113977, NULL, 'G3DSA:3.60.10.10:FF:000009', NULL, NULL, 'DNA-(apurinic or apyrimidinic site) lyase', NULL, NULL, NULL, NULL, NULL, 4),
(113978, NULL, 'G3DSA:3.40.50.1820:FF:000137', NULL, NULL, 'EEB1p Acyl-coenzymeA:ethanol O-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(113979, NULL, 'G3DSA:1.25.40.10:FF:001227', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g26900, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(113980, NULL, 'G3DSA:3.30.200.20:FF:001017', NULL, NULL, 'Cyclin-dependent kinase G-1', NULL, NULL, NULL, NULL, NULL, 4),
(113981, NULL, 'G3DSA:1.20.1070.10:FF:000647', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(113982, NULL, 'G3DSA:1.10.260.100:FF:000015', NULL, NULL, 'Hsc70-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(113983, NULL, 'G3DSA:2.60.40.650:FF:000004', NULL, NULL, 'Sulfite oxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(113984, NULL, 'G3DSA:1.20.1560.10:FF:000499', NULL, NULL, 'ATP-binding cassette sub-family B member 5', NULL, NULL, NULL, NULL, NULL, 4),
(113985, NULL, 'G3DSA:3.50.50.60:FF:000117', NULL, NULL, 'Pyruvate dehydrogenase phosphatase regulatory subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(113986, NULL, 'G3DSA:3.10.129.10:FF:000127', NULL, NULL, 'Itaconyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(113987, NULL, 'G3DSA:1.10.238.10:FF:000574', NULL, NULL, 'Phosphatidylinositol-4-phosphate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(113988, NULL, 'G3DSA:3.40.50.360:FF:000026', NULL, NULL, 'Flavoprotein MioC', NULL, NULL, NULL, NULL, NULL, 4),
(113989, NULL, 'G3DSA:3.40.1190.20:FF:000124', NULL, NULL, 'Pyridoxal kina', NULL, NULL, NULL, NULL, NULL, 4),
(113990, NULL, 'G3DSA:1.10.1670.10:FF:000015', NULL, NULL, 'Endonuclease III homolog', NULL, NULL, NULL, NULL, NULL, 4),
(113991, NULL, 'G3DSA:3.30.160.60:FF:001756', NULL, NULL, 'Zinc finger and AT-hook domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(113992, NULL, 'G3DSA:1.20.1250.20:FF:000282', NULL, NULL, 'NarK/NasA family nitrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(113993, NULL, 'G3DSA:3.50.50.60:FF:001062', NULL, NULL, 'Succinate dehydrogenase complex, subunit A, flavoprotein (Fp)', NULL, NULL, NULL, NULL, NULL, 4),
(113994, NULL, 'G3DSA:1.25.40.10:FF:002391', NULL, NULL, 'Os05g0586900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(113995, NULL, 'G3DSA:2.60.120.260:FF:000379', NULL, NULL, 'Beta-galactosidase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(113996, NULL, 'G3DSA:3.30.930.10:FF:000283', NULL, NULL, 'Prolyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(113997, NULL, 'G3DSA:1.10.510.10:FF:003473', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(113998, NULL, 'G3DSA:1.10.10.60:FF:000548', NULL, NULL, 'PTS-dependent dihydroxyacetone kinase operon regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(113999, NULL, 'G3DSA:3.80.10.10:FF:000099', NULL, NULL, 'Tropomodulin, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(114000, NULL, 'G3DSA:3.10.20.30:FF:000030', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(114001, NULL, 'G3DSA:1.20.58.390:FF:000007', NULL, NULL, 'Neuronal acetylcholine receptor subunit alpha-7', NULL, NULL, NULL, NULL, NULL, 4),
(114002, NULL, 'G3DSA:2.10.25.10:FF:000306', NULL, NULL, 'Multiple epidermal growth factor-like domains 6', NULL, NULL, NULL, NULL, NULL, 4),
(114003, NULL, 'G3DSA:3.30.40.10:FF:000889', NULL, NULL, 'Pib1p', NULL, NULL, NULL, NULL, NULL, 4),
(114004, NULL, 'G3DSA:2.60.40.60:FF:000826', NULL, NULL, 'E-cadherin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(114005, NULL, 'G3DSA:3.80.10.10:FF:000508', NULL, NULL, 'NLR family CARD domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(114006, NULL, 'G3DSA:3.30.300.30:FF:000112', NULL, NULL, 'Nonribosomal peptide synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114007, NULL, 'G3DSA:1.50.40.10:FF:000382', NULL, NULL, 'Nicotinamide adenine dinucleotide transporter 1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(114008, NULL, 'G3DSA:2.60.220.30:FF:000018', NULL, NULL, 'P53-induced death domain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(114009, NULL, 'G3DSA:2.60.40.10:FF:003780', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114010, NULL, 'G3DSA:1.10.8.10:FF:000268', NULL, NULL, 'AT07671p', NULL, NULL, NULL, NULL, NULL, 4),
(114011, NULL, 'G3DSA:1.25.40.120:FF:000053', NULL, NULL, 'Rab geranylgeranyl transferase like protein', NULL, NULL, NULL, NULL, NULL, 4),
(114012, NULL, 'G3DSA:3.80.10.10:FF:002116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114013, NULL, 'G3DSA:2.30.30.40:FF:000080', NULL, NULL, 'Peripheral plasma membrane protein CASK isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(114014, NULL, 'G3DSA:2.30.33.40:FF:000007', NULL, NULL, '10 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(114015, NULL, 'G3DSA:3.40.50.300:FF:006725', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114016, NULL, 'G3DSA:2.60.120.430:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114017, NULL, 'G3DSA:1.10.3810.10:FF:000027', NULL, NULL, 'Penicillin binding protein 1C PbpC', NULL, NULL, NULL, NULL, NULL, 4),
(114018, NULL, 'G3DSA:3.90.550.10:FF:000324', NULL, NULL, 'Glucuronokinase with putative uridyl pyrophosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(114019, NULL, 'G3DSA:3.40.50.720:FF:001152', NULL, NULL, 'C-methyltransferase NovU', NULL, NULL, NULL, NULL, NULL, 4),
(114020, NULL, 'G3DSA:2.60.40.1730:FF:000062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114021, NULL, 'G3DSA:3.40.50.300:FF:006377', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114022, NULL, 'G3DSA:1.20.940.10:FF:000012', NULL, NULL, 'Protein transport protein SEC31', NULL, NULL, NULL, NULL, NULL, 4),
(114023, NULL, 'G3DSA:4.10.60.10:FF:000119', NULL, NULL, 'Gag polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(114024, NULL, 'G3DSA:1.25.40.30:FF:000002', NULL, NULL, 'Clathrin and VPS domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(114025, NULL, 'G3DSA:2.70.160.11:FF:000057', NULL, NULL, 'Protein arginine methyltransferase 3', NULL, NULL, NULL, NULL, NULL, 4),
(114026, NULL, 'G3DSA:3.40.50.970:FF:000142', NULL, NULL, 'Phenylpyruvate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(114027, NULL, 'G3DSA:3.40.50.150:FF:000683', NULL, NULL, 'BnaA02g09640D protein', NULL, NULL, NULL, NULL, NULL, 4),
(114028, NULL, 'G3DSA:1.10.730.10:FF:000111', NULL, NULL, 'Probable valine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(114029, NULL, 'G3DSA:3.60.20.10:FF:000218', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114030, NULL, 'G3DSA:3.30.60.10:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114031, NULL, 'G3DSA:1.10.8.1310:FF:000015', NULL, NULL, 'TBC1 domain family member 20/GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114032, NULL, 'G3DSA:3.30.300.30:FF:000140', NULL, NULL, 'Saframycin Mx1 synthetase B', NULL, NULL, NULL, NULL, NULL, 4),
(114033, NULL, 'G3DSA:2.10.90.10:FF:000160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114034, NULL, 'G3DSA:1.25.10.10:FF:002872', NULL, NULL, 'MMS19 nucleotide excision repair protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(114035, NULL, 'G3DSA:2.30.29.30:FF:001315', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(114036, NULL, 'G3DSA:3.30.310.240:FF:000001', NULL, NULL, 'CP4-57 prophage RNase LS', NULL, NULL, NULL, NULL, NULL, 4),
(114037, NULL, 'G3DSA:2.60.40.420:FF:000160', NULL, NULL, 'Copper tolerance protein', NULL, NULL, NULL, NULL, NULL, 4),
(114038, NULL, 'G3DSA:1.25.40.10:FF:002716', NULL, NULL, 'Kinesin Light Chain', NULL, NULL, NULL, NULL, NULL, 4),
(114039, NULL, 'G3DSA:2.40.10.10:FF:000350', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114040, NULL, 'G3DSA:3.40.50.620:FF:000251', NULL, NULL, 'Probable nicotinate-nucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(114041, NULL, 'G3DSA:3.40.50.2000:FF:000866', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(114042, NULL, 'G3DSA:3.30.40.10:FF:000541', NULL, NULL, 'BOI-related E3 ubiquitin-protein ligase 1', NULL, NULL, NULL, NULL, NULL, 4),
(114043, NULL, 'G3DSA:1.10.287.70:FF:000525', NULL, NULL, 'Hydrolase, alpha/beta fold family protein, putative, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(114044, NULL, 'G3DSA:3.40.50.1260:FF:000054', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(114045, NULL, 'G3DSA:2.70.98.30:FF:000017', NULL, NULL, 'Protein CBR-AMAN-2', NULL, NULL, NULL, NULL, NULL, 4),
(114046, NULL, 'G3DSA:1.20.1200.10:FF:000006', NULL, NULL, 'Cobalamin adenosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(114047, NULL, 'G3DSA:3.80.10.10:FF:003061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114048, NULL, 'G3DSA:3.40.30.10:FF:000321', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(114049, NULL, 'G3DSA:3.40.50.720:FF:001388', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(114050, NULL, 'G3DSA:1.10.565.10:FF:000154', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(114051, NULL, 'G3DSA:3.80.10.10:FF:000655', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(114052, NULL, 'G3DSA:1.20.1070.10:FF:001597', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114053, NULL, 'G3DSA:1.20.1070.10:FF:000208', NULL, NULL, 'Alpha-1D adrenergic receptor', NULL, NULL, NULL, NULL, NULL, 4),
(114054, NULL, 'G3DSA:2.60.120.10:FF:000224', NULL, NULL, 'Cyclic nucleotide-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(114055, NULL, 'G3DSA:3.30.160.60:FF:003318', NULL, NULL, 'Protein CBR-EOR-1', NULL, NULL, NULL, NULL, NULL, 4),
(114056, NULL, 'G3DSA:1.20.1560.10:FF:000864', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(114057, NULL, 'G3DSA:2.60.40.10:FF:005600', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114058, NULL, 'G3DSA:2.60.220.30:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114059, NULL, 'G3DSA:1.10.8.270:FF:000137', NULL, NULL, 'TBC1 domain family member 10B', NULL, NULL, NULL, NULL, NULL, 4),
(114060, NULL, 'G3DSA:1.10.472.10:FF:000718', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(114061, NULL, 'G3DSA:3.20.20.80:FF:000842', NULL, NULL, '1,4-alpha-glucan branching enzyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(114062, NULL, 'G3DSA:3.40.50.150:FF:001481', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114063, NULL, 'G3DSA:1.25.40.20:FF:000140', NULL, NULL, 'Calmodulin-binding transcription activator 2', NULL, NULL, NULL, NULL, NULL, 4),
(114064, NULL, 'G3DSA:3.40.50.10810:FF:000006', NULL, NULL, 'Putative DNA helicase INO80', NULL, NULL, NULL, NULL, NULL, 4),
(114065, NULL, 'G3DSA:2.60.120.650:FF:000064', NULL, NULL, 'Lysine-specific demethylase jmjd-3.1', NULL, NULL, NULL, NULL, NULL, 4),
(114066, NULL, 'G3DSA:1.10.246.130:FF:000012', NULL, NULL, 'Protein-glutamine gamma-glutamyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114067, NULL, 'G3DSA:3.30.710.10:FF:000300', NULL, NULL, 'Protein CBG19111', NULL, NULL, NULL, NULL, NULL, 4),
(114068, NULL, 'G3DSA:3.40.50.2000:FF:000427', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(114069, NULL, 'G3DSA:1.20.5.490:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114070, NULL, 'G3DSA:3.50.50.60:FF:000297', NULL, NULL, 'FAD-containing monooxygenase MymA', NULL, NULL, NULL, NULL, NULL, 4),
(114071, NULL, 'G3DSA:4.10.240.10:FF:000091', NULL, NULL, 'Multidrug resistance regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(114072, NULL, 'G3DSA:1.20.1720.10:FF:000051', NULL, NULL, 'Major facilitator superfamily transporter', NULL, NULL, NULL, NULL, NULL, 4),
(114073, NULL, 'G3DSA:1.20.58.780:FF:000001', NULL, NULL, 'Surface layer (S-layer) glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(114074, NULL, 'G3DSA:1.10.150.60:FF:000019', NULL, NULL, 'Transcription factor jumonji (JmjC) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(114075, NULL, 'G3DSA:3.30.160.60:FF:000340', NULL, NULL, 'zinc finger protein 473 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(114076, NULL, 'G3DSA:3.30.70.1900:FF:000001', NULL, NULL, 'CRISPR-associated endoribonuclease Cas6', NULL, NULL, NULL, NULL, NULL, 4),
(114077, NULL, 'G3DSA:3.30.420.40:FF:000388', NULL, NULL, 'Actin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(114078, NULL, 'G3DSA:3.30.200.20:FF:000747', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(114079, NULL, 'G3DSA:3.10.100.10:FF:000005', NULL, NULL, 'collectin-11 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(114080, NULL, 'G3DSA:3.30.505.10:FF:000222', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114081, NULL, 'G3DSA:3.30.1120.130:FF:000002', NULL, NULL, 'Serine/threonine-protein kinase PLK4', NULL, NULL, NULL, NULL, NULL, 4),
(114082, NULL, 'G3DSA:1.25.40.10:FF:001755', NULL, NULL, 'Actin binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114083, NULL, 'G3DSA:2.30.42.10:FF:000345', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114084, NULL, 'G3DSA:3.30.559.70:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114085, NULL, 'G3DSA:3.40.1160.10:FF:000069', NULL, NULL, 'Lysine-sensitive aspartokinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(114086, NULL, 'G3DSA:3.40.50.300:FF:007670', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114087, NULL, 'G3DSA:3.40.50.1110:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114088, NULL, 'G3DSA:2.60.40.10:FF:002852', NULL, NULL, 'Immunoglobulin heavy variable 6-1', NULL, NULL, NULL, NULL, NULL, 4),
(114089, NULL, 'G3DSA:2.130.10.10:FF:001964', NULL, NULL, 'Eukaryotic translation initiation factor eif2a protein', NULL, NULL, NULL, NULL, NULL, 4),
(114090, NULL, 'G3DSA:3.30.420.40:FF:000736', NULL, NULL, 'Actin-like protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(114091, NULL, 'G3DSA:2.10.25.10:FF:000301', NULL, NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein', NULL, NULL, NULL, NULL, NULL, 4),
(114092, NULL, 'G3DSA:3.20.20.140:FF:000408', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114093, NULL, 'G3DSA:2.30.29.30:FF:000371', NULL, NULL, 'Pebble, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(114094, NULL, 'G3DSA:2.60.40.10:FF:003785', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114095, NULL, 'G3DSA:3.90.1410.10:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114096, NULL, 'G3DSA:3.40.710.10:FF:000011', NULL, NULL, 'Penicillin-binding protein AmpH', NULL, NULL, NULL, NULL, NULL, 4),
(114097, NULL, 'G3DSA:3.40.50.12670:FF:000002', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(114098, NULL, 'G3DSA:3.40.1770.10:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114099, NULL, 'G3DSA:2.60.40.10:FF:005578', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114100, NULL, 'G3DSA:1.10.510.10:FF:003809', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114101, NULL, 'G3DSA:1.10.1450.10:FF:000004', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(114102, NULL, 'G3DSA:1.25.40.10:FF:003661', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g71490', NULL, NULL, NULL, NULL, NULL, 4),
(114103, NULL, 'G3DSA:2.30.140.10:FF:000013', NULL, NULL, 'Spermidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(114104, NULL, 'G3DSA:3.90.190.10:FF:000347', NULL, NULL, 'Dual specificity protein phosphatase 22', NULL, NULL, NULL, NULL, NULL, 4),
(114105, NULL, 'G3DSA:3.30.70.330:FF:000086', NULL, NULL, 'Putative Cytoplasmic polyadenylation element-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(114106, NULL, 'G3DSA:3.90.550.10:FF:000010', NULL, NULL, 'Galactosylgalactosylxylosylprotein 3-beta-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(114107, NULL, 'G3DSA:1.10.10.2430:FF:000002', NULL, NULL, 'BcDNA.LD23876', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(114108, NULL, 'G3DSA:3.40.50.2000:FF:000181', NULL, NULL, 'Lipopolysaccharide heptosyltransferase I', NULL, NULL, NULL, NULL, NULL, 4),
(114109, NULL, 'G3DSA:3.40.1110.10:FF:000358', NULL, NULL, 'Putative phospholipid-transporting ATPase C4F10.16c', NULL, NULL, NULL, NULL, NULL, 4),
(114110, NULL, 'G3DSA:2.40.30.30:FF:000008', NULL, NULL, 'Riboflavin kinase', NULL, NULL, NULL, NULL, NULL, 4),
(114111, NULL, 'G3DSA:3.40.50.2300:FF:001018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114112, NULL, 'G3DSA:3.40.50.800:FF:000018', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(114113, NULL, 'G3DSA:1.25.40.170:FF:000005', NULL, NULL, 'Smg, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(114114, NULL, 'G3DSA:2.60.120.970:FF:000047', NULL, NULL, 'Transforming growth factor beta', NULL, NULL, NULL, NULL, NULL, 4),
(114115, NULL, 'G3DSA:3.30.342.10:FF:000051', NULL, NULL, 'DNA polymerase B region', NULL, NULL, NULL, NULL, NULL, 4),
(114116, NULL, 'G3DSA:3.40.50.150:FF:001857', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114117, NULL, 'G3DSA:2.60.260.40:FF:000001', NULL, NULL, 'NADH dehydrogenase [ubiquinone] iron-sulfur protein 6, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(114118, NULL, 'G3DSA:1.25.40.10:FF:004509', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114119, NULL, 'G3DSA:1.10.510.10:FF:002961', NULL, NULL, 'Dual specificity protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114120, NULL, 'G3DSA:3.40.190.10:FF:000257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114121, NULL, 'G3DSA:1.10.287.2900:FF:000004', NULL, NULL, 'NADH-ubiquinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(114122, NULL, 'G3DSA:3.40.47.10:FF:000286', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114123, NULL, 'G3DSA:2.30.29.30:FF:000843', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114124, NULL, 'G3DSA:3.60.10.10:FF:000026', NULL, NULL, 'Exodeoxyribonuclease III', NULL, NULL, NULL, NULL, NULL, 4),
(114125, NULL, 'G3DSA:1.25.40.180:FF:000048', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(114126, NULL, 'G3DSA:1.20.1270.10:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114127, NULL, 'G3DSA:3.20.20.80:FF:000735', NULL, NULL, 'Linamarase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(114128, NULL, 'G3DSA:1.20.58.1970:FF:000002', NULL, NULL, 'Oligomeric Golgi complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(114129, NULL, 'G3DSA:3.30.160.60:FF:006180', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114130, NULL, 'G3DSA:1.20.1530.20:FF:000101', NULL, NULL, 'Malonate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114131, NULL, 'G3DSA:3.30.1370.10:FF:000194', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(114132, NULL, 'G3DSA:1.10.1870.10:FF:000019', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(114133, NULL, 'G3DSA:3.40.50.410:FF:000087', NULL, NULL, 'TRAP-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(114134, NULL, 'G3DSA:1.20.1050.10:FF:000286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114135, NULL, 'G3DSA:1.20.1070.10:FF:000664', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(114136, NULL, 'G3DSA:2.60.40.10:FF:000688', NULL, NULL, 'Leptin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(114137, NULL, 'G3DSA:1.10.8.10:FF:000240', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(114138, NULL, 'G3DSA:2.70.170.10:FF:000197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114139, NULL, 'G3DSA:3.30.70.330:FF:001070', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit G', NULL, NULL, NULL, NULL, NULL, 4),
(114140, NULL, 'G3DSA:3.80.10.10:FF:001588', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(114141, NULL, 'G3DSA:3.30.450.20:FF:000367', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(114142, NULL, 'G3DSA:3.30.420.140:FF:000013', NULL, NULL, 'Putative pre-16S rRNA nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(114143, NULL, 'G3DSA:3.40.50.1820:FF:000340', NULL, NULL, 'Serine esterase (DUF676) protein', NULL, NULL, NULL, NULL, NULL, 4),
(114144, NULL, 'G3DSA:2.30.30.70:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114145, NULL, 'G3DSA:3.40.50.300:FF:005197', NULL, NULL, 'Polysaccharide biosynthesis tyrosine autokinase', NULL, NULL, NULL, NULL, NULL, 4),
(114146, NULL, 'G3DSA:3.40.50.11580:FF:000001', NULL, NULL, 'Replicase polyprotein 1ab', NULL, NULL, NULL, NULL, NULL, 4),
(114147, NULL, 'G3DSA:3.30.160.60:FF:005235', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114148, NULL, 'G3DSA:3.90.960.10:FF:000018', NULL, NULL, 'HDOD domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(114149, NULL, 'G3DSA:3.20.20.80:FF:000387', NULL, NULL, 'Chitinase 12', NULL, NULL, NULL, NULL, NULL, 4),
(114150, NULL, 'G3DSA:2.130.10.10:FF:001981', NULL, NULL, 'WD repeat-containing and planar cell polarity effector protein fritz homolog', NULL, NULL, NULL, NULL, NULL, 4),
(114151, NULL, 'G3DSA:3.40.1170.10:FF:000042', NULL, NULL, 'MutS 6 isoform 1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(114152, NULL, 'G3DSA:3.30.420.40:FF:000753', NULL, NULL, 'AaceriAGR099Cp', NULL, NULL, NULL, NULL, NULL, 4),
(114153, NULL, 'G3DSA:3.80.10.10:FF:002572', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114154, NULL, 'G3DSA:3.30.40.10:FF:000760', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(114155, NULL, 'G3DSA:3.40.1110.10:FF:000375', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114156, NULL, 'G3DSA:3.40.50.300:FF:004797', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114157, NULL, 'G3DSA:3.20.20.80:FF:000426', NULL, NULL, 'Glucosylceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(114158, NULL, 'G3DSA:3.40.33.10:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114159, NULL, 'G3DSA:1.25.40.450:FF:000005', NULL, NULL, 'Nuclear pore complex protein Nup155', NULL, NULL, NULL, NULL, NULL, 4),
(114160, NULL, 'G3DSA:3.30.40.10:FF:001160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114161, NULL, 'G3DSA:2.130.10.10:FF:004398', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114162, NULL, 'G3DSA:3.40.50.720:FF:000769', NULL, NULL, 'Forever young oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(114163, NULL, 'G3DSA:2.60.40.10:FF:001672', NULL, NULL, 'Triggering receptor expressed on myeloid cells like 2', NULL, NULL, NULL, NULL, NULL, 4),
(114164, NULL, 'G3DSA:3.40.50.2000:FF:000557', NULL, NULL, 'UDP-glycosyltransferase 76D1', NULL, NULL, NULL, NULL, NULL, 4),
(114165, NULL, 'G3DSA:3.60.20.10:FF:000185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114166, NULL, 'G3DSA:3.30.40.10:FF:000232', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM11', NULL, NULL, NULL, NULL, NULL, 4),
(114167, NULL, 'G3DSA:3.30.70.330:FF:001412', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(114168, NULL, 'G3DSA:3.30.1120.30:FF:000013', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(114169, NULL, 'G3DSA:1.10.3200.20:FF:000006', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(114170, NULL, 'G3DSA:1.10.8.1220:FF:000016', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(114171, NULL, 'G3DSA:3.30.760.10:FF:000011', NULL, NULL, 'Eukaryotic translation initiation factor 4E', NULL, NULL, NULL, NULL, NULL, 4),
(114172, NULL, 'G3DSA:3.40.50.300:FF:005421', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114173, NULL, 'G3DSA:2.60.40.10:FF:000379', NULL, NULL, 'Glucans biosynthesis protein D', NULL, NULL, NULL, NULL, NULL, 4),
(114174, NULL, 'G3DSA:1.20.1250.20:FF:002333', NULL, NULL, 'Protein NRT1/ PTR FAMILY 7.1', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(114175, NULL, 'G3DSA:1.10.510.10:FF:002944', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114176, NULL, 'G3DSA:3.40.50.2000:FF:001046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114177, NULL, 'G3DSA:2.30.30.100:FF:000029', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm1', NULL, NULL, NULL, NULL, NULL, 4),
(114178, NULL, 'G3DSA:1.20.120.1240:FF:000033', NULL, NULL, 'DNM1 isoform 12', NULL, NULL, NULL, NULL, NULL, 4),
(114179, NULL, 'G3DSA:3.10.450.50:FF:000088', NULL, NULL, 'Isoaspartyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(114180, NULL, 'G3DSA:3.40.50.1440:FF:000012', NULL, NULL, 'Tubulin gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(114181, NULL, 'G3DSA:2.60.40.150:FF:000040', NULL, NULL, 'synaptotagmin-like protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(114182, NULL, 'G3DSA:3.40.50.300:FF:005730', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114183, NULL, 'G3DSA:1.20.1740.10:FF:000064', NULL, NULL, 'Spore germination protein GerKB', NULL, NULL, NULL, NULL, NULL, 4),
(114184, NULL, 'G3DSA:1.10.510.10:FF:003580', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114185, NULL, 'G3DSA:1.25.10.10:FF:001927', NULL, NULL, 'PIKK family atypical protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(114186, NULL, 'G3DSA:3.90.1150.170:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114187, NULL, 'G3DSA:2.30.29.30:FF:001332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114188, NULL, 'G3DSA:1.10.30.10:FF:000001', NULL, NULL, 'transcription factor 7 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(114189, NULL, 'G3DSA:3.90.1010.10:FF:000002', NULL, NULL, 'Iron-sulfur cluster assembly scaffold protein NifU', NULL, NULL, NULL, NULL, NULL, 4),
(114190, NULL, 'G3DSA:3.80.10.10:FF:002077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114191, NULL, 'G3DSA:3.90.1600.10:FF:000047', NULL, NULL, 'DNA polymerase alpha subunit one', NULL, NULL, NULL, NULL, NULL, 4),
(114192, NULL, 'G3DSA:3.90.190.10:FF:000263', NULL, NULL, 'probable rhodanese domain-containing dual specificity protein phosphatase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(114193, NULL, 'G3DSA:1.25.40.10:FF:003880', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114194, NULL, 'G3DSA:2.130.10.10:FF:005707', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114195, NULL, 'G3DSA:3.40.50.150:FF:001172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114196, NULL, 'G3DSA:2.120.10.30:FF:000094', NULL, NULL, 'Protein CBG06215', NULL, NULL, NULL, NULL, NULL, 4),
(114197, NULL, 'G3DSA:2.60.40.10:FF:000727', NULL, NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein', NULL, NULL, NULL, NULL, NULL, 4),
(114198, NULL, 'G3DSA:3.20.20.80:FF:000050', NULL, NULL, 'Beta-mannosidase B', NULL, NULL, NULL, NULL, NULL, 4),
(114199, NULL, 'G3DSA:1.25.10.10:FF:001579', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114200, NULL, 'G3DSA:2.60.40.10:FF:004959', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114201, NULL, 'G3DSA:3.30.40.10:FF:000917', NULL, NULL, 'E3 ubiquitin-protein ligase BOI', NULL, NULL, NULL, NULL, NULL, 4),
(114202, NULL, 'G3DSA:3.40.50.300:FF:001835', NULL, NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(114203, NULL, 'G3DSA:3.20.20.70:FF:000513', NULL, NULL, 'Dihydroorotate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(114204, NULL, 'G3DSA:3.30.200.110:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114205, NULL, 'G3DSA:2.10.60.10:FF:000023', NULL, NULL, 'CD59 glycoprotein preproprotein', NULL, NULL, NULL, NULL, NULL, 4),
(114206, NULL, 'G3DSA:3.30.70.330:FF:000451', NULL, NULL, 'Polyadenylate-binding protein RBP45C', NULL, NULL, NULL, NULL, NULL, 4),
(114207, NULL, 'G3DSA:2.40.10.10:FF:000378', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(114208, NULL, 'G3DSA:1.20.5.2210:FF:000001', NULL, NULL, 'ATP synthase F(0) complex subunit B1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(114209, NULL, 'G3DSA:3.30.70.1230:FF:000137', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(114210, NULL, 'G3DSA:2.10.70.10:FF:000158', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(114211, NULL, 'G3DSA:1.10.418.10:FF:000195', NULL, NULL, 'protein Hook homolog 3', NULL, NULL, NULL, NULL, NULL, 4),
(114212, NULL, 'G3DSA:3.40.50.300:FF:005758', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114213, NULL, 'G3DSA:1.20.1050.10:FF:000106', NULL, NULL, 'Glutathione S-transferase 3', NULL, NULL, NULL, NULL, NULL, 4),
(114214, NULL, 'G3DSA:3.30.160.60:FF:001649', NULL, NULL, 'C2H2 transcription factor Swi5', NULL, NULL, NULL, NULL, NULL, 4),
(114215, NULL, 'G3DSA:3.40.50.1460:FF:000018', NULL, NULL, 'Caspase-3', NULL, NULL, NULL, NULL, NULL, 4),
(114216, NULL, 'G3DSA:2.130.10.10:FF:002021', NULL, NULL, 'WD repeat-containing protein AAC3', NULL, NULL, NULL, NULL, NULL, 4),
(114217, NULL, 'G3DSA:3.60.110.10:FF:000040', NULL, NULL, 'Os06g0206000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(114218, NULL, 'G3DSA:3.80.10.10:FF:002425', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114219, NULL, 'G3DSA:2.60.220.50:FF:000013', NULL, NULL, 'Adhesion G protein-coupled receptor E1', NULL, NULL, NULL, NULL, NULL, 4),
(114220, NULL, 'G3DSA:2.60.40.10:FF:005359', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114221, NULL, 'G3DSA:3.80.10.10:FF:004022', NULL, NULL, 'Protein CBR-LET-413', NULL, NULL, NULL, NULL, NULL, 4),
(114222, NULL, 'G3DSA:1.25.10.10:FF:001152', NULL, NULL, 'Putative pumillio protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(114223, NULL, 'G3DSA:2.130.10.130:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114224, NULL, 'G3DSA:3.30.160.60:FF:002138', NULL, NULL, 'Zinc finger transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(114225, NULL, 'G3DSA:3.30.430.20:FF:000028', NULL, NULL, 'Putative DUF26-domain receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(114226, NULL, 'G3DSA:1.25.40.20:FF:000701', NULL, NULL, 'Os12g0283700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(114227, NULL, 'G3DSA:3.40.1280.10:FF:000033', NULL, NULL, 'rRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(114228, NULL, 'G3DSA:1.20.58.1610:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114229, NULL, 'G3DSA:3.90.190.20:FF:000029', NULL, NULL, 'Bifunctional folylpolyglutamate synthase/dihydrofolate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(114230, NULL, 'G3DSA:3.40.50.12710:FF:000020', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7', NULL, NULL, NULL, NULL, NULL, 4),
(114231, NULL, 'G3DSA:3.30.40.10:FF:000125', NULL, NULL, 'Putative PHD finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(114232, NULL, 'G3DSA:1.10.750.20:FF:000003', NULL, NULL, 'WD repeat and SOCS box-containing 1, isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(114233, NULL, 'G3DSA:1.10.1520.10:FF:000105', NULL, NULL, 'Os09g0315100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(114234, NULL, 'G3DSA:2.60.40.10:FF:005128', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114235, NULL, 'G3DSA:2.30.30.770:FF:000005', NULL, NULL, '60S ribosomal protein L27, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114236, NULL, 'G3DSA:3.40.50.300:FF:001234', NULL, NULL, 'ABC multidrug transporter SitT', NULL, NULL, NULL, NULL, NULL, 4),
(114237, NULL, 'G3DSA:3.40.50.720:FF:002422', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114238, NULL, 'G3DSA:1.10.287.130:FF:000150', NULL, NULL, 'Two-component system sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(114239, NULL, 'G3DSA:1.25.10.10:FF:003260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114240, NULL, 'G3DSA:3.60.40.10:FF:000293', NULL, NULL, 'Pentatricopeptide repeat (PPR) superfamily protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(114241, NULL, 'G3DSA:2.30.30.40:FF:000006', NULL, NULL, 'RIMS-binding protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(114242, NULL, 'G3DSA:3.20.20.70:FF:000277', NULL, NULL, 'Phosphoribosylanthranilate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(114243, NULL, 'G3DSA:3.30.70.980:FF:000033', NULL, NULL, 'Translational Activator of Cytochrome c Oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(114244, NULL, 'G3DSA:3.30.1780.10:FF:000023', NULL, NULL, 'Chromosome 15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(114245, NULL, 'G3DSA:2.30.30.1020:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114246, NULL, 'G3DSA:3.40.630.30:FF:000617', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114247, NULL, 'G3DSA:3.40.50.300:FF:007653', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(114248, NULL, 'G3DSA:3.40.50.300:FF:005505', NULL, NULL, 'ABC Transporter family', NULL, NULL, NULL, NULL, NULL, 4),
(114249, NULL, 'G3DSA:2.130.10.10:FF:003982', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114250, NULL, 'G3DSA:2.60.40.1930:FF:000003', NULL, NULL, 'CD109 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(114251, NULL, 'G3DSA:2.160.10.10:FF:000108', NULL, NULL, 'Eukaryotic translation initiation factor 2B subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(114252, NULL, 'G3DSA:3.90.1150.10:FF:000304', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(114253, NULL, 'G3DSA:3.30.160.60:FF:000795', NULL, NULL, 'Zinc finger homeobox protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(114254, NULL, 'G3DSA:3.30.70.80:FF:000018', NULL, NULL, 'YHR138C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(114255, NULL, 'G3DSA:3.30.470.20:FF:000222', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(114256, NULL, 'G3DSA:1.20.1110.10:FF:000235', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(114257, NULL, 'G3DSA:2.50.20.10:FF:000013', NULL, NULL, 'Outer-membrane lipoprotein carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(114258, NULL, 'G3DSA:1.25.40.10:FF:002733', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114259, NULL, 'G3DSA:3.20.20.190:FF:000053', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(114260, NULL, 'G3DSA:3.20.20.140:FF:000032', NULL, NULL, 'Allantoinase Dal1', NULL, NULL, NULL, NULL, NULL, 4),
(114261, NULL, 'G3DSA:1.10.10.10:FF:000016', NULL, NULL, 'Forkhead box protein I1', NULL, NULL, NULL, NULL, NULL, 4),
(114262, NULL, 'G3DSA:3.50.50.60:FF:000533', NULL, NULL, '2-octaprenyl-3-methyl-6-methoxy-1,4-benzoquinol hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(114263, NULL, 'G3DSA:2.100.10.30:FF:000010', NULL, NULL, 'natterin-like protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(114264, NULL, 'G3DSA:3.30.420.10:FF:000177', NULL, NULL, 'Ribonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114265, NULL, 'G3DSA:1.25.40.70:FF:000019', NULL, NULL, 'Phosphatidylinositol 3-kinase VPS34', NULL, NULL, NULL, NULL, NULL, 4),
(114266, NULL, 'G3DSA:1.25.40.10:FF:003352', NULL, NULL, 'TPR repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114267, NULL, 'G3DSA:3.20.20.450:FF:000018', NULL, NULL, 'Probable diguanylate cyclase DgcE', NULL, NULL, NULL, NULL, NULL, 4),
(114268, NULL, 'G3DSA:3.30.160.60:FF:004538', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114269, NULL, 'G3DSA:3.40.50.720:FF:000168', NULL, NULL, 'Fatty acid synthase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(114270, NULL, 'G3DSA:3.10.100.10:FF:000371', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114271, NULL, 'G3DSA:1.25.40.20:FF:000595', NULL, NULL, 'Os11g0435300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(114272, NULL, 'G3DSA:3.40.50.1170:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114273, NULL, 'G3DSA:2.40.30.10:FF:000233', NULL, NULL, 'Elongation factor G2-like protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(114274, NULL, 'G3DSA:4.10.1000.10:FF:000013', NULL, NULL, 'zinc finger CCCH domain-containing protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(114275, NULL, 'G3DSA:3.40.1280.10:FF:000016', NULL, NULL, 'rRNA methylase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(114276, NULL, 'G3DSA:1.10.390.10:FF:000011', NULL, NULL, 'Transcription initiation factor TFIID subunit', NULL, NULL, NULL, NULL, NULL, 4),
(114277, NULL, 'G3DSA:1.20.140.40:FF:000022', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(114278, NULL, 'G3DSA:2.60.120.10:FF:000679', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114279, NULL, 'G3DSA:3.30.450.20:FF:000114', NULL, NULL, 'Hypoxia inducible factor 1 subunit alpha, like', NULL, NULL, NULL, NULL, NULL, 4),
(114280, NULL, 'G3DSA:3.30.200.20:FF:002001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114281, NULL, 'G3DSA:1.10.8.60:FF:000261', NULL, NULL, '26S protease regulatory subunit 6B', NULL, NULL, NULL, NULL, NULL, 4),
(114282, NULL, 'G3DSA:2.40.420.20:FF:000024', NULL, NULL, 'RagD protein', NULL, NULL, NULL, NULL, NULL, 4),
(114283, NULL, 'G3DSA:2.30.39.10:FF:000080', NULL, NULL, 'Accessory gland protein Acp76A', NULL, NULL, NULL, NULL, NULL, 4),
(114284, NULL, 'G3DSA:1.10.1580.10:FF:000025', NULL, NULL, 'Ribosome biogenesis GTPase A', NULL, NULL, NULL, NULL, NULL, 4),
(114285, NULL, 'G3DSA:6.10.140.2220:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114286, NULL, 'G3DSA:2.60.120.970:FF:000064', NULL, NULL, 'bone morphogenetic protein 8B-like', NULL, NULL, NULL, NULL, NULL, 4),
(114287, NULL, 'G3DSA:3.90.190.10:FF:000572', NULL, NULL, 'Map kinase phosphatase-M B2 isoform', NULL, NULL, NULL, NULL, NULL, 4),
(114288, NULL, 'G3DSA:3.40.50.11380:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114289, NULL, 'G3DSA:3.40.50.1010:FF:000001', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(114290, NULL, 'G3DSA:3.40.50.300:FF:001599', NULL, NULL, 'guanine nucleotide-binding protein G(Olf) subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(114291, NULL, 'G3DSA:2.60.40.10:FF:004089', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114292, NULL, 'G3DSA:2.130.10.10:FF:005691', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114293, NULL, 'G3DSA:1.10.8.10:FF:000015', NULL, NULL, 'Chromosome 6 C6orf106 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(114294, NULL, 'G3DSA:2.60.120.290:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114295, NULL, 'G3DSA:2.60.40.10:FF:001441', NULL, NULL, 'Interleukin-18 receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(114296, NULL, 'G3DSA:3.40.720.10:FF:000057', NULL, NULL, 'Arylsulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(114297, NULL, 'G3DSA:1.10.8.660:FF:000001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114298, NULL, 'G3DSA:1.20.1270.60:FF:000166', NULL, NULL, 'Sorting NeXin', NULL, NULL, NULL, NULL, NULL, 4),
(114299, NULL, 'G3DSA:4.10.410.10:FF:000008', NULL, NULL, 'Serine peptidase inhibitor, Kunitz type 1', NULL, NULL, NULL, NULL, NULL, 4),
(114300, NULL, 'G3DSA:3.90.190.10:FF:000133', NULL, NULL, 'Leucine rich repeat and phosphatase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(114301, NULL, 'G3DSA:2.10.25.160:FF:000002', NULL, NULL, 'Cysteine protease 1', NULL, NULL, NULL, NULL, NULL, 4),
(114302, NULL, 'G3DSA:3.40.50.360:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114303, NULL, 'G3DSA:1.10.630.10:FF:000519', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114304, NULL, 'G3DSA:3.40.50.12780:FF:000035', NULL, NULL, 'Acetyl-coenzyme A synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(114305, NULL, 'G3DSA:1.25.10.10:FF:002905', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114306, NULL, 'G3DSA:2.30.30.100:FF:000176', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm3', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(114307, NULL, 'G3DSA:3.10.580.10:FF:000001', NULL, NULL, 'Putative metal transporter CNNM3 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(114308, NULL, 'G3DSA:1.10.3380.30:FF:000038', NULL, NULL, 'Probable ATP-dependent helicase MJ1401', NULL, NULL, NULL, NULL, NULL, 4),
(114309, NULL, 'G3DSA:3.40.50.1110:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114310, NULL, 'G3DSA:1.10.10.740:FF:000001', NULL, NULL, 'Cysteine-rich secretory protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(114311, NULL, 'G3DSA:1.10.287.160:FF:000013', NULL, NULL, 'Protein Kinase N (PKN) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(114312, NULL, 'G3DSA:3.30.70.330:FF:002665', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114313, NULL, 'G3DSA:3.60.21.60:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114314, NULL, 'G3DSA:2.40.20.10:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114315, NULL, 'G3DSA:3.90.70.10:FF:000006', NULL, NULL, 'Cathepsin S', NULL, NULL, NULL, NULL, NULL, 4),
(114316, NULL, 'G3DSA:3.30.70.330:FF:001631', NULL, NULL, 'Poly(A) binding protein Pab2', NULL, NULL, NULL, NULL, NULL, 4),
(114317, NULL, 'G3DSA:1.25.40.10:FF:000479', NULL, NULL, 'Wolfram syndrome 1 (Wolframin)', NULL, NULL, NULL, NULL, NULL, 4),
(114318, NULL, 'G3DSA:1.20.190.20:FF:000002', NULL, NULL, '14-3-3 protein epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(114319, NULL, 'G3DSA:1.25.10.10:FF:002799', NULL, NULL, 'DnaJ homolog subfamily C member 13-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(114320, NULL, 'G3DSA:3.30.160.60:FF:003543', NULL, NULL, 'Zinc finger protein 529', NULL, NULL, NULL, NULL, NULL, 4),
(114321, NULL, 'G3DSA:3.50.50.60:FF:000898', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(114322, NULL, 'G3DSA:2.130.10.10:FF:003454', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(114323, NULL, 'G3DSA:3.30.200.20:FF:000978', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114324, NULL, 'G3DSA:3.30.230.10:FF:000370', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114325, NULL, 'G3DSA:3.40.1800.30:FF:000001', NULL, NULL, 'Histone deacetylase complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(114326, NULL, 'G3DSA:3.10.50.10:FF:000008', NULL, NULL, 'Chitinase 11', NULL, NULL, NULL, NULL, NULL, 4),
(114327, NULL, 'G3DSA:1.20.1280.50:FF:000242', NULL, NULL, 'F-box and WD repeat domain-containing 11', NULL, NULL, NULL, NULL, NULL, 4),
(114328, NULL, 'G3DSA:2.10.50.10:FF:000067', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 14', NULL, NULL, NULL, NULL, NULL, 4),
(114329, NULL, 'G3DSA:3.30.420.40:FF:000989', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114330, NULL, 'G3DSA:1.25.40.10:FF:003245', NULL, NULL, 'Probable pre-mRNA splicing factor prp1', NULL, NULL, NULL, NULL, NULL, 4),
(114331, NULL, 'G3DSA:3.40.1090.10:FF:000097', NULL, NULL, 'Lysophospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(114332, NULL, 'G3DSA:3.10.250.10:FF:000027', NULL, NULL, 'Transmembrane serine protease 2', NULL, NULL, NULL, NULL, NULL, 4),
(114333, NULL, 'G3DSA:3.30.870.10:FF:000002', NULL, NULL, 'Cardiolipin synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(114334, NULL, 'G3DSA:2.40.50.140:FF:000970', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114335, NULL, 'G3DSA:2.10.220.10:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114336, NULL, 'G3DSA:3.90.226.10:FF:000285', NULL, NULL, 'ATP-dependent Clp protease proteolytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(114337, NULL, 'G3DSA:2.120.10.30:FF:000419', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(114338, NULL, 'G3DSA:3.30.60.30:FF:000082', NULL, NULL, 'AGRin (Synaptic protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(114339, NULL, 'G3DSA:3.60.21.10:FF:000170', NULL, NULL, 'Metallophosphoesterase, phosphate-repressible', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(114340, NULL, 'G3DSA:3.30.9.10:FF:000272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114341, NULL, 'G3DSA:2.60.120.200:FF:000659', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114342, NULL, 'G3DSA:2.10.25.10:FF:000290', NULL, NULL, 'EGF-containing fibulin-like extracellular matrix protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(114343, NULL, 'G3DSA:3.30.1050.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114344, NULL, 'G3DSA:3.40.50.410:FF:000339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114345, NULL, 'G3DSA:1.20.1280.50:FF:000135', NULL, NULL, 'FBD, F-box and Leucine Rich Repeat domains containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(114346, NULL, 'G3DSA:2.60.120.260:FF:000306', NULL, NULL, 'AGAP011177-PA', NULL, NULL, NULL, NULL, NULL, 4),
(114347, NULL, 'G3DSA:2.60.40.10:FF:003330', NULL, NULL, 'NPHS1 adhesion molecule, nephrin', NULL, NULL, NULL, NULL, NULL, 4),
(114348, NULL, 'G3DSA:1.25.40.20:FF:000123', NULL, NULL, 'regulatory protein NPR3-like', NULL, NULL, NULL, NULL, NULL, 4),
(114349, NULL, 'G3DSA:3.90.1150.10:FF:000293', NULL, NULL, 'Glycine dehydrogenase (decarboxylating)', NULL, NULL, NULL, NULL, NULL, 4),
(114350, NULL, 'G3DSA:3.20.20.330:FF:000022', NULL, NULL, 'Homocysteine S-methyltransferase YbgG', NULL, NULL, NULL, NULL, NULL, 4),
(114351, NULL, 'G3DSA:1.10.8.100:FF:000002', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(114352, NULL, 'G3DSA:1.20.1250.20:FF:002108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114353, NULL, 'G3DSA:3.40.47.10:FF:000269', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114354, NULL, 'G3DSA:1.10.472.10:FF:000157', NULL, NULL, 'Putative cyclin-F2-1', NULL, NULL, NULL, NULL, NULL, 4),
(114355, NULL, 'G3DSA:1.10.20.10:FF:000045', NULL, NULL, 'Histone H2B', NULL, NULL, NULL, NULL, NULL, 4),
(114356, NULL, 'G3DSA:3.40.50.300:FF:000615', NULL, NULL, 'pre-mRNA-splicing factor ATP-dependent RNA helicase DEAH7', NULL, NULL, NULL, NULL, NULL, 4),
(114357, NULL, 'G3DSA:3.80.10.10:FF:003044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114358, NULL, 'G3DSA:3.90.70.10:FF:000787', NULL, NULL, 'ubiquitin carboxyl-terminal hydrolase 37', NULL, NULL, NULL, NULL, NULL, 4),
(114359, NULL, 'G3DSA:1.25.40.10:FF:000788', NULL, NULL, 'Phosphoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(114360, NULL, 'G3DSA:2.60.120.330:FF:000086', NULL, NULL, 'Gibberellin 3-oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(114361, NULL, 'G3DSA:3.30.200.20:FF:000764', NULL, NULL, 'CMGC/MAPK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(114362, NULL, 'G3DSA:3.40.50.1010:FF:000232', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114363, NULL, 'G3DSA:2.40.10.10:FF:000125', NULL, NULL, 'inactive serine protease 54', NULL, NULL, NULL, NULL, NULL, 4),
(114364, NULL, 'G3DSA:1.25.40.470:FF:000028', NULL, NULL, 'Intraflagellar transport protein 140-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(114365, NULL, 'G3DSA:1.10.3520.10:FF:000016', NULL, NULL, 'RH52220p', NULL, NULL, NULL, NULL, NULL, 4),
(114366, NULL, 'G3DSA:2.60.40.10:FF:003094', NULL, NULL, 'Interleukin 2 receptor gamma common.a', NULL, NULL, NULL, NULL, NULL, 4),
(114367, NULL, 'G3DSA:3.60.10.10:FF:000156', NULL, NULL, 'DUF455 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(114368, NULL, 'G3DSA:1.10.510.10:FF:003326', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114369, NULL, 'G3DSA:3.30.479.20:FF:000017', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(114370, NULL, 'G3DSA:3.40.1110.10:FF:000122', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(114371, NULL, 'G3DSA:3.30.70.1230:FF:000031', NULL, NULL, 'Adenylate cyclase type 7', NULL, NULL, NULL, NULL, NULL, 4),
(114372, NULL, 'G3DSA:3.30.200.20:FF:001164', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(114373, NULL, 'G3DSA:2.60.40.10:FF:002060', NULL, NULL, 'Neuroglian, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(114374, NULL, 'G3DSA:2.60.40.60:FF:000478', NULL, NULL, 'Cadherin-87A', NULL, NULL, NULL, NULL, NULL, 4),
(114375, NULL, 'G3DSA:3.40.50.1820:FF:000941', NULL, NULL, 'Lipase/esterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114376, NULL, 'G3DSA:3.30.200.20:FF:001692', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114377, NULL, 'G3DSA:1.20.1270.280:FF:000008', NULL, NULL, 'Dynein axonemal heavy chain 11', NULL, NULL, NULL, NULL, NULL, 4),
(114378, NULL, 'G3DSA:3.40.309.10:FF:000073', NULL, NULL, 'Aldehyde dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114379, NULL, 'G3DSA:2.60.40.10:FF:001076', NULL, NULL, 'Triggering receptor expressed on myeloid cells 2', NULL, NULL, NULL, NULL, NULL, 4),
(114380, NULL, 'G3DSA:3.80.10.10:FF:002908', NULL, NULL, 'Leucine-rich repeat and death domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(114381, NULL, 'G3DSA:3.30.160.60:FF:002829', NULL, NULL, 'Zinc finger protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(114382, NULL, 'G3DSA:1.10.10.60:FF:001189', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114383, NULL, 'G3DSA:3.40.50.2300:FF:001563', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114384, NULL, 'G3DSA:2.60.40.60:FF:001097', NULL, NULL, 'Cadherin 26', NULL, NULL, NULL, NULL, NULL, 4),
(114385, NULL, 'G3DSA:1.10.287.370:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114386, NULL, 'G3DSA:3.30.428.10:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114387, NULL, 'G3DSA:1.10.510.10:FF:002489', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114388, NULL, 'G3DSA:3.40.50.300:FF:001919', NULL, NULL, 'ATP-dependent protease ATPase subunit HslU1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114389, NULL, 'G3DSA:3.40.50.800:FF:000097', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(114390, NULL, 'G3DSA:1.25.40.10:FF:000007', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(114391, NULL, 'G3DSA:1.25.10.10:FF:000399', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114392, NULL, 'G3DSA:1.10.510.10:FF:004198', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114393, NULL, 'G3DSA:1.20.1080.10:FF:000018', NULL, NULL, 'Aquaporin', NULL, NULL, NULL, NULL, NULL, 4),
(114394, NULL, 'G3DSA:1.10.630.10:FF:000199', NULL, NULL, 'Probable cytochrome P450 6d2', NULL, NULL, NULL, NULL, NULL, 4),
(114395, NULL, 'G3DSA:1.20.1560.10:FF:000263', NULL, NULL, 'Multidrug resistance-associated protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(114396, NULL, 'G3DSA:1.10.10.570:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114397, NULL, 'G3DSA:3.40.190.10:FF:000274', NULL, NULL, 'Nickel ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(114398, NULL, 'G3DSA:3.40.50.2300:FF:001035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114399, NULL, 'G3DSA:3.40.50.2000:FF:000973', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114400, NULL, 'G3DSA:3.60.20.10:FF:000055', NULL, NULL, 'Proteasome subunit alpha type', NULL, NULL, NULL, NULL, NULL, 4),
(114401, NULL, 'G3DSA:1.10.287.2620:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114402, NULL, 'G3DSA:3.30.70.330:FF:001940', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114403, NULL, 'G3DSA:3.40.50.300:FF:008378', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(114404, NULL, 'G3DSA:2.40.50.40:FF:000030', NULL, NULL, 'Chemokine (C-C motif) ligand 44', NULL, NULL, NULL, NULL, NULL, 4),
(114405, NULL, 'G3DSA:3.40.50.720:FF:001949', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114406, NULL, 'G3DSA:3.40.50.720:FF:001697', NULL, NULL, 'UDP-N-acetyl-D-glucosamine 6-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(114407, NULL, 'G3DSA:4.10.240.10:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114408, NULL, 'G3DSA:1.25.40.10:FF:002025', NULL, NULL, 'Tetratricopeptide repeat protein 21B', NULL, NULL, NULL, NULL, NULL, 4),
(114409, NULL, 'G3DSA:1.20.1740.10:FF:000142', NULL, NULL, 'Amino acid transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114410, NULL, 'G3DSA:3.40.50.2020:FF:000057', NULL, NULL, 'Hypoxanthine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(114411, NULL, 'G3DSA:3.40.50.1000:FF:000010', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(114412, NULL, 'G3DSA:1.20.58.60:FF:000618', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114413, NULL, 'G3DSA:3.30.920.20:FF:000004', NULL, NULL, 'GAS2-like protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(114414, NULL, 'G3DSA:1.25.10.10:FF:003041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114415, NULL, 'G3DSA:2.40.37.10:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114416, NULL, 'G3DSA:1.10.600.10:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114417, NULL, 'G3DSA:1.10.565.10:FF:000070', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(114418, NULL, 'G3DSA:1.25.40.420:FF:000007', NULL, NULL, 'Kelch-like family member 7', NULL, NULL, NULL, NULL, NULL, 4),
(114419, NULL, 'G3DSA:3.90.45.10:FF:000010', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(114420, NULL, 'G3DSA:1.25.10.10:FF:003417', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114421, NULL, 'G3DSA:3.20.20.70:FF:000058', NULL, NULL, '2-dehydro-3-deoxyphosphooctonate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(114422, NULL, 'G3DSA:1.20.920.60:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114423, NULL, 'G3DSA:1.25.40.450:FF:000022', NULL, NULL, 'Nuclear pore protein', NULL, NULL, NULL, NULL, NULL, 4),
(114424, NULL, 'G3DSA:1.10.238.10:FF:001063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114425, NULL, 'G3DSA:2.60.120.10:FF:000100', NULL, NULL, 'CRP-like protein Clp', NULL, NULL, NULL, NULL, NULL, 4),
(114426, NULL, 'G3DSA:1.10.1200.10:FF:000104', NULL, NULL, 'Polyketide synthase type I', NULL, NULL, NULL, NULL, NULL, 4),
(114427, NULL, 'G3DSA:3.40.50.1460:FF:000125', NULL, NULL, 'Senescence enhanced2b', NULL, NULL, NULL, NULL, NULL, 4),
(114428, NULL, 'G3DSA:3.30.160.60:FF:005252', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114429, NULL, 'G3DSA:3.80.10.10:FF:002532', NULL, NULL, 'Leucine-rich repeats and immunoglobulin-like domains protein sma-10', NULL, NULL, NULL, NULL, NULL, 4),
(114430, NULL, 'G3DSA:1.10.506.10:FF:000040', NULL, NULL, 'Plexin-2', NULL, NULL, NULL, NULL, NULL, 4),
(114431, NULL, 'G3DSA:2.30.30.490:FF:000028', NULL, NULL, 'DNA (Cytosine-5)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(114432, NULL, 'G3DSA:2.60.220.50:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114433, NULL, 'G3DSA:3.40.80.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114434, NULL, 'G3DSA:3.30.200.20:FF:001383', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(114435, NULL, 'G3DSA:3.40.50.300:FF:002982', NULL, NULL, 'Protein CBR-MRP-2', NULL, NULL, NULL, NULL, NULL, 4),
(114436, NULL, 'G3DSA:1.25.10.10:FF:001383', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114437, NULL, 'G3DSA:1.25.40.990:FF:000066', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(114438, NULL, 'G3DSA:2.80.10.50:FF:000006', NULL, NULL, 'Ryanodine receptor 2 (Cardiac)', NULL, NULL, NULL, NULL, NULL, 4),
(114439, NULL, 'G3DSA:3.40.50.300:FF:007759', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114440, NULL, 'G3DSA:3.30.160.60:FF:005808', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(114441, NULL, 'G3DSA:3.90.1750.10:FF:000041', NULL, NULL, 'Ubiquitin ligase (E3)', NULL, NULL, NULL, NULL, NULL, 4),
(114442, NULL, 'G3DSA:3.40.720.10:FF:000276', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(114443, NULL, 'G3DSA:3.90.940.40:FF:000003', NULL, NULL, 'Protein CHLORORESPIRATORY REDUCTION 7 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(114444, NULL, 'G3DSA:3.10.50.30:FF:000003', NULL, NULL, 'Transcription elongation factor GreA', NULL, NULL, NULL, NULL, NULL, 4),
(114445, NULL, 'G3DSA:1.25.40.20:FF:000229', NULL, NULL, 'protein TANC1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(114446, NULL, 'G3DSA:3.40.630.10:FF:000393', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114447, NULL, 'G3DSA:2.30.42.10:FF:000238', NULL, NULL, 'Inactivation-no-after-potential D protein', NULL, NULL, NULL, NULL, NULL, 4),
(114448, NULL, 'G3DSA:2.40.160.10:FF:000068', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(114449, NULL, 'G3DSA:3.30.70.890:FF:000006', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(114450, NULL, 'G3DSA:1.20.120.730:FF:000002', NULL, NULL, 'Protein transport protein Sec24C isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(114451, NULL, 'G3DSA:1.20.5.4820:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114452, NULL, 'G3DSA:3.30.420.140:FF:000035', NULL, NULL, 'Glycine rich protein', NULL, NULL, NULL, NULL, NULL, 4),
(114453, NULL, 'G3DSA:1.20.1560.10:FF:000044', NULL, NULL, 'ABC transporter B family member 9', NULL, NULL, NULL, NULL, NULL, 4),
(114454, NULL, 'G3DSA:3.30.40.10:FF:001053', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(114455, NULL, 'G3DSA:1.10.8.60:FF:000480', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114456, NULL, 'G3DSA:1.20.5.110:FF:000172', NULL, NULL, 'Hemagglutinin-neuraminidase', NULL, NULL, NULL, NULL, NULL, 4),
(114457, NULL, 'G3DSA:1.10.287.70:FF:000042', NULL, NULL, 'potassium voltage-gated channel subfamily H member 8', NULL, NULL, NULL, NULL, NULL, 4),
(114458, NULL, 'G3DSA:1.25.40.10:FF:004498', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114459, NULL, 'G3DSA:3.30.1330.40:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114460, NULL, 'G3DSA:3.40.50.300:FF:000306', NULL, NULL, 'ADP-ribosylation factor-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(114461, NULL, 'G3DSA:1.10.540.10:FF:000063', NULL, NULL, 'Putative acyl-CoA dehydrogenase YdbM', NULL, NULL, NULL, NULL, NULL, 4),
(114462, NULL, 'G3DSA:2.30.29.90:FF:000001', NULL, NULL, 'exocyst complex component 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(114463, NULL, 'G3DSA:2.60.40.10:FF:003706', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114464, NULL, 'G3DSA:2.40.128.330:FF:000011', NULL, NULL, 'Magnesium transporter MRS2', NULL, NULL, NULL, NULL, NULL, 4),
(114465, NULL, 'G3DSA:3.30.70.330:FF:002356', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114466, NULL, 'G3DSA:1.20.58.1200:FF:000002', NULL, NULL, 'RNA silencing suppressor', NULL, NULL, NULL, NULL, NULL, 4),
(114467, NULL, 'G3DSA:3.40.50.1820:FF:001290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114468, NULL, 'G3DSA:3.30.420.10:FF:000053', NULL, NULL, 'Werner syndrome ATP-dependent helicase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(114469, NULL, 'G3DSA:3.90.226.10:FF:000318', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114470, NULL, 'G3DSA:3.40.50.300:FF:003488', NULL, NULL, 'Spermatogenesis-associated protein 5-like protein 1, variant 2', NULL, NULL, NULL, NULL, NULL, 4),
(114471, NULL, 'G3DSA:3.20.190.10:FF:000008', NULL, NULL, 'Formamidopyrimidine-DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(114472, NULL, 'G3DSA:2.20.25.670:FF:000001', NULL, NULL, 'Chorion-specific transcription factor GCMb', NULL, NULL, NULL, NULL, NULL, 4),
(114473, NULL, 'G3DSA:3.40.850.10:FF:000066', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(114474, NULL, 'G3DSA:1.20.5.4570:FF:000001', NULL, NULL, 'Ferulic acid decarboxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(114475, NULL, 'G3DSA:3.30.160.60:FF:005466', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114476, NULL, 'G3DSA:3.20.10.10:FF:000040', NULL, NULL, 'Branched-chain amino acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(114477, NULL, 'G3DSA:1.25.40.20:FF:001865', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(114478, NULL, 'G3DSA:1.10.640.10:FF:000025', NULL, NULL, 'GH11385p', NULL, NULL, NULL, NULL, NULL, 4),
(114479, NULL, 'G3DSA:2.10.25.10:FF:000323', NULL, NULL, 'EGF-containing fibulin-like extracellular matrix protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(114480, NULL, 'G3DSA:3.30.1330.20:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114481, NULL, 'G3DSA:1.10.510.10:FF:003017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114482, NULL, 'G3DSA:2.60.120.590:FF:000057', NULL, NULL, 'Alpha-ketoglutarate-dependent dioxygenase alkB homolog 3', NULL, NULL, NULL, NULL, NULL, 4),
(114483, NULL, 'G3DSA:2.60.260.20:FF:000046', NULL, NULL, 'Chaperone DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(114484, NULL, 'G3DSA:3.40.50.720:FF:000747', NULL, NULL, 'NAD(P) dependent steroid dehydrogenase-like', NULL, NULL, NULL, NULL, NULL, 4),
(114485, NULL, 'G3DSA:1.20.5.780:FF:000001', NULL, NULL, 'Fxyd domain-containing ion transport regulator', NULL, NULL, NULL, NULL, NULL, 4),
(114486, NULL, 'G3DSA:3.90.70.10:FF:000658', NULL, NULL, 'Protein CBR-DUO-2', NULL, NULL, NULL, NULL, NULL, 4),
(114487, NULL, 'G3DSA:3.40.390.10:FF:000238', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114488, NULL, 'G3DSA:1.20.1270.60:FF:000042', NULL, NULL, 'Vacuolar targeting protein Atg24', NULL, NULL, NULL, NULL, NULL, 4),
(114489, NULL, 'G3DSA:3.40.630.30:FF:000308', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(114490, NULL, 'G3DSA:2.60.40.10:FF:003021', NULL, NULL, 'Microfibril-associated glycoprotein 3', NULL, NULL, NULL, NULL, NULL, 4),
(114491, NULL, 'G3DSA:2.130.10.10:FF:000020', NULL, NULL, 'Guanine nucleotide-binding protein beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(114492, NULL, 'G3DSA:1.10.10.41:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114493, NULL, 'G3DSA:1.10.1270.20:FF:000004', NULL, NULL, 'tRNA (guanine-N(1)-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(114494, NULL, 'G3DSA:1.10.8.530:FF:000013', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(114495, NULL, 'G3DSA:1.20.1110.10:FF:000016', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(114496, NULL, 'G3DSA:1.20.120.790:FF:000014', NULL, NULL, 'Heat shock protein', NULL, NULL, NULL, NULL, NULL, 4),
(114497, NULL, 'G3DSA:3.40.50.2300:FF:000074', NULL, NULL, 'Fis family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(114498, NULL, 'G3DSA:3.30.160.60:FF:004847', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114499, NULL, 'G3DSA:3.30.70.2200:FF:000001', NULL, NULL, 'tRNA(Ile2) 2-agmatinylcytidine synthetase TiaS', NULL, NULL, NULL, NULL, NULL, 4),
(114500, NULL, 'G3DSA:1.10.10.10:FF:001764', NULL, NULL, 'DNA directed RNA polymeras-like protein III subunit Rpc82', NULL, NULL, NULL, NULL, NULL, 4),
(114501, NULL, 'G3DSA:3.30.160.60:FF:003234', NULL, NULL, 'GM13094', NULL, NULL, NULL, NULL, NULL, 4),
(114502, NULL, 'G3DSA:3.40.50.720:FF:000533', NULL, NULL, '6-phosphogluconate dehydrogenase, decarboxylating', NULL, NULL, NULL, NULL, NULL, 4),
(114503, NULL, 'G3DSA:2.170.260.10:FF:000011', NULL, NULL, 'Endoribonuclease Dicer-like 2 isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(114504, NULL, 'G3DSA:3.30.160.60:FF:000828', NULL, NULL, 'Zinc finger protein, FOG family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(114505, NULL, 'G3DSA:1.20.58.1370:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114506, NULL, 'G3DSA:1.10.357.10:FF:000058', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(114507, NULL, 'G3DSA:3.80.10.10:FF:003297', NULL, NULL, 'Si:zfos-364h11.2', NULL, NULL, NULL, NULL, NULL, 4),
(114508, NULL, 'G3DSA:3.30.450.350:FF:000003', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(114509, NULL, 'G3DSA:3.40.50.10490:FF:000085', NULL, NULL, 'Glucose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(114510, NULL, 'G3DSA:1.50.10.10:FF:000099', NULL, NULL, 'Cellulose 1,4-beta-cellobiosidase', NULL, NULL, NULL, NULL, NULL, 4),
(114511, NULL, 'G3DSA:2.130.10.10:FF:001200', NULL, NULL, 'Cleavage stimulation factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(114512, NULL, 'G3DSA:2.20.100.10:FF:000193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114513, NULL, 'G3DSA:1.20.5.220:FF:000002', NULL, NULL, 'gem-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(114514, NULL, 'G3DSA:1.20.1070.10:FF:001361', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114515, NULL, 'G3DSA:1.20.1730.10:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114516, NULL, 'G3DSA:2.60.120.260:FF:000295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114517, NULL, 'G3DSA:3.40.50.300:FF:000981', NULL, NULL, 'ADP-ribosylation factor-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(114518, NULL, 'G3DSA:3.20.20.300:FF:000024', NULL, NULL, 'Beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(114519, NULL, 'G3DSA:3.40.50.1820:FF:001666', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114520, NULL, 'G3DSA:2.40.50.140:FF:000661', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114521, NULL, 'G3DSA:3.30.1540.10:FF:000005', NULL, NULL, 'succinate--hydroxymethylglutarate CoA-transferase isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(114522, NULL, 'G3DSA:1.20.120.1080:FF:000069', NULL, NULL, 'Helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114523, NULL, 'G3DSA:3.50.50.60:FF:000909', NULL, NULL, 'FAD/NAD(P)-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(114524, NULL, 'G3DSA:2.60.40.60:FF:000006', NULL, NULL, 'Protocadherin alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(114525, NULL, 'G3DSA:2.60.120.650:FF:000209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114526, NULL, 'G3DSA:3.10.450.60:FF:000001', NULL, NULL, 'arachidonate 12-lipoxygenase, 12R-type', NULL, NULL, NULL, NULL, NULL, 4),
(114527, NULL, 'G3DSA:2.60.120.470:FF:000004', NULL, NULL, 'PITH domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(114528, NULL, 'G3DSA:3.40.250.10:FF:000223', NULL, NULL, 'Putative thiosulfate sulfurtransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(114529, NULL, 'G3DSA:3.30.70.330:FF:001176', NULL, NULL, 'Nuclear localization sequence binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(114530, NULL, 'G3DSA:1.20.5.170:FF:000184', NULL, NULL, 'Stress activated transcription factor atfs-1', NULL, NULL, NULL, NULL, NULL, 4),
(114531, NULL, 'G3DSA:1.10.533.10:FF:000260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114532, NULL, 'G3DSA:2.30.30.30:FF:000127', NULL, NULL, 'Putative 60S ribosomal protein L14', NULL, NULL, NULL, NULL, NULL, 4),
(114533, NULL, 'G3DSA:3.90.1580.10:FF:000005', NULL, NULL, 'Formylglycine-generating enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(114534, NULL, 'G3DSA:2.30.39.10:FF:000113', NULL, NULL, 'Serpin peptidase inhibitor 8', NULL, NULL, NULL, NULL, NULL, 4),
(114535, NULL, 'G3DSA:3.30.540.10:FF:000028', NULL, NULL, '3''(2''),5''-bisphosphate nucleotidase CysQ', NULL, NULL, NULL, NULL, NULL, 4),
(114536, NULL, 'G3DSA:1.10.10.140:FF:000006', NULL, NULL, 'Cytochrome C oxidase subunit VI', NULL, NULL, NULL, NULL, NULL, 4),
(114537, NULL, 'G3DSA:3.30.540.30:FF:000023', NULL, NULL, 'Dipeptidyl peptidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(114538, NULL, 'G3DSA:3.30.420.10:FF:000429', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114539, NULL, 'G3DSA:3.40.50.2300:FF:000849', NULL, NULL, 'Pheromone and odorant receptor, putative', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(114540, NULL, 'G3DSA:3.40.50.1820:FF:000576', NULL, NULL, 'PPE family protein', NULL, NULL, NULL, NULL, NULL, 4),
(114541, NULL, 'G3DSA:3.90.25.10:FF:000008', NULL, NULL, 'GDP-mannose 4,6 dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(114542, NULL, 'G3DSA:2.110.10.10:FF:000077', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(114543, NULL, 'G3DSA:2.40.128.20:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114544, NULL, 'G3DSA:3.80.10.10:FF:000424', NULL, NULL, 'Volume-regulated anion channel subunit LRRC8E', NULL, NULL, NULL, NULL, NULL, 4),
(114545, NULL, 'G3DSA:1.20.5.4010:FF:000002', NULL, NULL, 'Held out wings, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(114546, NULL, 'G3DSA:2.40.50.140:FF:000329', NULL, NULL, '26S protease subunit component', NULL, NULL, NULL, NULL, NULL, 4),
(114547, NULL, 'G3DSA:3.40.50.450:FF:000104', NULL, NULL, 'ATP-dependent 6-phosphofructokinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(114548, NULL, 'G3DSA:1.25.40.20:FF:001409', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114549, NULL, 'G3DSA:3.30.559.10:FF:000178', NULL, NULL, 'Ferricrocin synthetase (Nonribosomal peptide siderophore synthase ) (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(114550, NULL, 'G3DSA:1.20.1050.130:FF:000010', NULL, NULL, 'probable elongation factor 1-beta', NULL, NULL, NULL, NULL, NULL, 4),
(114551, NULL, 'G3DSA:1.25.40.10:FF:004953', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114552, NULL, 'G3DSA:1.10.10.10:FF:001399', NULL, NULL, 'LuxR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(114553, NULL, 'G3DSA:3.90.660.10:FF:000080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114554, NULL, 'G3DSA:3.90.320.10:FF:000043', NULL, NULL, 'Exodeoxyribonuclease V beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(114555, NULL, 'G3DSA:1.10.287.70:FF:000418', NULL, NULL, 'Novel protein similar to human voltage-gated L-type calcium channel subunit (Isl)', NULL, NULL, NULL, NULL, NULL, 4),
(114556, NULL, 'G3DSA:1.50.10.20:FF:000091', NULL, NULL, 'Terpene cyclase/mutase family member', NULL, NULL, NULL, NULL, NULL, 4),
(114557, NULL, 'G3DSA:1.10.472.80:FF:000138', NULL, NULL, 'TBC1 domain family member', NULL, NULL, NULL, NULL, NULL, 4),
(114558, NULL, 'G3DSA:3.90.550.50:FF:000196', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(114559, NULL, 'G3DSA:3.40.50.620:FF:000273', NULL, NULL, 'Universal stress protein Rv3134c', NULL, NULL, NULL, NULL, NULL, 4),
(114560, NULL, 'G3DSA:2.30.30.190:FF:000005', NULL, NULL, 'CAP-Gly domain containing linker protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(114561, NULL, 'G3DSA:3.30.420.10:FF:000738', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114562, NULL, 'G3DSA:2.40.50.140:FF:001257', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114563, NULL, 'G3DSA:3.40.190.10:FF:000021', NULL, NULL, 'DNA-binding transcriptional regulator OxyR', NULL, NULL, NULL, NULL, NULL, 4),
(114564, NULL, 'G3DSA:3.80.20.20:FF:000001', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(114565, NULL, 'G3DSA:3.30.710.10:FF:000373', NULL, NULL, 'BTB (POZ) domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(114566, NULL, 'G3DSA:1.10.10.820:FF:000036', NULL, NULL, 'Myh9 protein', NULL, NULL, NULL, NULL, NULL, 4),
(114567, NULL, 'G3DSA:3.30.160.60:FF:004870', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114568, NULL, 'G3DSA:3.30.40.10:FF:001614', NULL, NULL, 'Pre-mRNA-splicing factor CWC24', NULL, NULL, NULL, NULL, NULL, 4),
(114569, NULL, 'G3DSA:3.30.2350.10:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114570, NULL, 'G3DSA:3.40.1810.10:FF:000035', NULL, NULL, 'MADS-box transcription factor 13', NULL, NULL, NULL, NULL, NULL, 4),
(114571, NULL, 'G3DSA:3.30.750.24:FF:000029', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(114572, NULL, 'G3DSA:3.40.50.20:FF:000055', NULL, NULL, 'Glutamate--LysW ligase ArgX', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(114573, NULL, 'G3DSA:3.40.1190.20:FF:000046', NULL, NULL, 'Adenosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(114574, NULL, 'G3DSA:2.30.30.140:FF:000053', NULL, NULL, 'tudor domain-containing protein 7 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(114575, NULL, 'G3DSA:2.60.120.200:FF:000098', NULL, NULL, 'Laminin subunit alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(114576, NULL, 'G3DSA:2.60.120.200:FF:000283', NULL, NULL, 'Adhesion G protein-coupled receptor G6', NULL, NULL, NULL, NULL, NULL, 4),
(114577, NULL, 'G3DSA:3.90.550.20:FF:000001', NULL, NULL, 'MIPC synthase subunit (SurA)', NULL, NULL, NULL, NULL, NULL, 4),
(114578, NULL, 'G3DSA:3.40.30.10:FF:001271', NULL, NULL, 'Calsequestrin', NULL, NULL, NULL, NULL, NULL, 4),
(114579, NULL, 'G3DSA:1.10.8.50:FF:000016', NULL, NULL, 'Type 2 DNA topoisomerase 6 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(114580, NULL, 'G3DSA:3.90.70.10:FF:000315', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114581, NULL, 'G3DSA:1.25.40.10:FF:005353', NULL, NULL, 'Pentatricopeptide repeat-containing protein 10, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(114582, NULL, 'G3DSA:1.10.357.150:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114583, NULL, 'G3DSA:1.20.1250.20:FF:000855', NULL, NULL, 'Blast:Membrane-associated transporter protein', NULL, NULL, NULL, NULL, NULL, 4),
(114584, NULL, 'G3DSA:3.40.20.10:FF:000129', NULL, NULL, 'Cofilin-1A', NULL, NULL, NULL, NULL, NULL, 4),
(114585, NULL, 'G3DSA:3.30.160.60:FF:003919', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114586, NULL, 'G3DSA:3.80.10.10:FF:001352', NULL, NULL, 'F-box/LRR-repeat protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(114587, NULL, 'G3DSA:3.30.40.10:FF:001980', NULL, NULL, 'Uncharacterized RING finger protein C16G5.03', NULL, NULL, NULL, NULL, NULL, 4),
(114588, NULL, 'G3DSA:3.40.50.300:FF:000054', NULL, NULL, 'ABC multidrug transporter atrF', NULL, NULL, NULL, NULL, NULL, 4),
(114589, NULL, 'G3DSA:1.10.238.10:FF:000658', NULL, NULL, 'Calmodulin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114590, NULL, 'G3DSA:3.40.50.300:FF:004016', NULL, NULL, 'Os05g0150600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(114591, NULL, 'G3DSA:3.30.70.100:FF:000163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114592, NULL, 'G3DSA:1.20.120.360:FF:000003', NULL, NULL, 'Axin interactor, dorsalization-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(114593, NULL, 'G3DSA:3.90.150.10:FF:000007', NULL, NULL, 'Variant surface glycoprotein (VSG), putative', NULL, NULL, NULL, NULL, NULL, 4),
(114594, NULL, 'G3DSA:1.10.510.10:FF:000235', NULL, NULL, 'Serine/threonine-protein kinase ark1', NULL, NULL, NULL, NULL, NULL, 4),
(114595, NULL, 'G3DSA:3.40.50.10990:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114596, NULL, 'G3DSA:3.30.230.10:FF:000038', NULL, NULL, 'Galactokinase', NULL, NULL, NULL, NULL, NULL, 4),
(114597, NULL, 'G3DSA:1.50.10.160:FF:000020', NULL, NULL, 'Putative geranyllinalool synthase', NULL, NULL, NULL, NULL, NULL, 4),
(114598, NULL, 'G3DSA:2.40.50.140:FF:001038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114599, NULL, 'G3DSA:3.40.50.300:FF:003179', NULL, NULL, 'Dynein heavy chain 6, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(114600, NULL, 'G3DSA:1.20.5.650:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114601, NULL, 'G3DSA:3.30.300.30:FF:000005', NULL, NULL, 'Acyl-coenzyme A synthetase ACSM5, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(114602, NULL, 'G3DSA:1.20.120.350:FF:000124', NULL, NULL, 'Four domain-type voltage-gated ion channel alpha-1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(114603, NULL, 'G3DSA:2.60.40.60:FF:000933', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114604, NULL, 'G3DSA:2.40.150.20:FF:000031', NULL, NULL, 'Protein 23 of the large ribosomal subunit', NULL, NULL, NULL, NULL, NULL, 4),
(114605, NULL, 'G3DSA:3.40.50.300:FF:007198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(114606, NULL, 'G3DSA:2.40.50.140:FF:000638', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114607, NULL, 'G3DSA:1.20.1640.10:FF:000101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114608, NULL, 'G3DSA:2.60.40.1390:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114609, NULL, 'G3DSA:1.10.555.10:FF:000108', NULL, NULL, 'Rho GTPase Activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(114610, NULL, 'G3DSA:1.10.287.70:FF:000603', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114611, NULL, 'G3DSA:2.60.40.630:FF:000009', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(114612, NULL, 'G3DSA:1.20.5.170:FF:000037', NULL, NULL, 'cyclic AMP-responsive element-binding protein 3-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(114613, NULL, 'G3DSA:1.10.150.50:FF:000028', NULL, NULL, 'caskin-2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(114614, NULL, 'G3DSA:3.80.10.10:FF:001043', NULL, NULL, 'Leucine-rich repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(114615, NULL, 'G3DSA:4.10.400.10:FF:000081', NULL, NULL, 'Low-density lipoprotein receptor-related protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(114616, NULL, 'G3DSA:3.80.10.10:FF:004477', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(114617, NULL, 'G3DSA:3.30.40.10:FF:002233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114618, NULL, 'G3DSA:2.60.40.60:FF:000225', NULL, NULL, 'Dachsous cadherin-related 1', NULL, NULL, NULL, NULL, NULL, 4),
(114619, NULL, 'G3DSA:3.30.160.60:FF:004162', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114620, NULL, 'G3DSA:3.90.180.10:FF:000054', NULL, NULL, 'Probable NADPH quinone oxidoreductase fadB4', NULL, NULL, NULL, NULL, NULL, 4),
(114621, NULL, 'G3DSA:3.40.50.620:FF:000487', NULL, NULL, 'Leucyl-tRNA synthetase b', NULL, NULL, NULL, NULL, NULL, 4),
(114622, NULL, 'G3DSA:3.30.40.10:FF:000996', NULL, NULL, 'Os05g0476901 protein', NULL, NULL, NULL, NULL, NULL, 4),
(114623, NULL, 'G3DSA:1.25.40.20:FF:001556', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114624, NULL, 'G3DSA:2.30.29.170:FF:000014', NULL, NULL, 'Putative DUF1126 protein/EF-hand domain pair, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114625, NULL, 'G3DSA:2.130.10.10:FF:003673', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(114626, NULL, 'G3DSA:3.40.225.10:FF:000024', NULL, NULL, 'Class II aldolase/adducin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(114627, NULL, 'G3DSA:3.40.50.300:FF:007074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114628, NULL, 'G3DSA:2.10.25.10:FF:000537', NULL, NULL, 'Notch 3', NULL, NULL, NULL, NULL, NULL, 4),
(114629, NULL, 'G3DSA:1.10.10.1020:FF:000001', NULL, NULL, 'RecBCD enzyme subunit RecD', NULL, NULL, NULL, NULL, NULL, 4),
(114630, NULL, 'G3DSA:3.10.25.10:FF:000012', NULL, NULL, 'Methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(114631, NULL, 'G3DSA:2.60.120.650:FF:000086', NULL, NULL, 'CXXC finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(114632, NULL, 'G3DSA:3.40.50.300:FF:002779', NULL, NULL, 'Uncharacterized protein Rv1278', NULL, NULL, NULL, NULL, NULL, 4),
(114633, NULL, 'G3DSA:3.30.230.10:FF:000347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114634, NULL, 'G3DSA:1.10.10.10:FF:002017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114635, NULL, 'G3DSA:1.10.287.70:FF:000261', NULL, NULL, 'Outward-rectifier potassium channel TOK1', NULL, NULL, NULL, NULL, NULL, 4),
(114636, NULL, 'G3DSA:3.10.20.90:FF:000929', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114637, NULL, 'G3DSA:1.10.260.30:FF:000013', NULL, NULL, 'Signal recognition particle 54 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(114638, NULL, 'G3DSA:3.30.710.10:FF:000064', NULL, NULL, 'Ankyrin repeat and BTB/POZ domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(114639, NULL, 'G3DSA:3.40.390.10:FF:000025', NULL, NULL, 'endothelin-converting enzyme-like 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(114640, NULL, 'G3DSA:3.40.1000.10:FF:000024', NULL, NULL, 'Putative secreted protein', NULL, NULL, NULL, NULL, NULL, 4),
(114641, NULL, 'G3DSA:3.30.160.60:FF:002161', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(114642, NULL, 'G3DSA:3.30.420.10:FF:000418', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114643, NULL, 'G3DSA:2.60.40.10:FF:001104', NULL, NULL, 'Heparan sulfate proteoglycan 2', NULL, NULL, NULL, NULL, NULL, 4),
(114644, NULL, 'G3DSA:1.10.246.140:FF:000004', NULL, NULL, 'Transcription and mRNA export factor SUS1', NULL, NULL, NULL, NULL, NULL, 4),
(114645, NULL, 'G3DSA:1.50.10.10:FF:000234', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(114646, NULL, 'G3DSA:3.40.30.10:FF:000085', NULL, NULL, 'Selenoprotein T', NULL, NULL, NULL, NULL, NULL, 4),
(114647, NULL, 'G3DSA:2.60.40.150:FF:000601', NULL, NULL, 'Phosphatidylinositol 3-kinase vps34', NULL, NULL, NULL, NULL, NULL, 4),
(114648, NULL, 'G3DSA:2.40.50.140:FF:000189', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114649, NULL, 'G3DSA:1.25.40.20:FF:000353', NULL, NULL, 'Bromodomain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(114650, NULL, 'G3DSA:1.10.510.10:FF:000022', NULL, NULL, 'Serine/threonine-protein kinase 24', NULL, NULL, NULL, NULL, NULL, 4),
(114651, NULL, 'G3DSA:2.40.37.10:FF:000069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114652, NULL, 'G3DSA:2.130.10.10:FF:001649', NULL, NULL, 'WD repeat domain 59', NULL, NULL, NULL, NULL, NULL, 4),
(114653, NULL, 'G3DSA:1.25.40.10:FF:000928', NULL, NULL, 'Tetratricopeptide repeat domain 7B', NULL, NULL, NULL, NULL, NULL, 4),
(114654, NULL, 'G3DSA:1.10.630.10:FF:000070', NULL, NULL, 'cytochrome P450 18a1', NULL, NULL, NULL, NULL, NULL, 4),
(114655, NULL, 'G3DSA:3.20.200.10:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114656, NULL, 'G3DSA:3.20.20.70:FF:000619', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114657, NULL, 'G3DSA:2.40.160.120:FF:000024', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(114658, NULL, 'G3DSA:1.25.40.20:FF:001876', NULL, NULL, 'Testis expressed 14, intercellular bridge forming factor', NULL, NULL, NULL, NULL, NULL, 4),
(114659, NULL, 'G3DSA:3.20.20.140:FF:000268', NULL, NULL, 'Ribonuclease P protein subunit drpp30', NULL, NULL, NULL, NULL, NULL, 4),
(114660, NULL, 'G3DSA:3.40.50.1820:FF:001413', NULL, NULL, 'Uncharacterized protein C959.06c', NULL, NULL, NULL, NULL, NULL, 4),
(114661, NULL, 'G3DSA:1.10.510.10:FF:003248', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114662, NULL, 'G3DSA:1.10.510.10:FF:002629', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114663, NULL, 'G3DSA:3.40.850.10:FF:000061', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(114664, NULL, 'G3DSA:3.50.50.60:FF:000769', NULL, NULL, 'Sarcosine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(114665, NULL, 'G3DSA:3.30.1490.430:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114666, NULL, 'G3DSA:1.25.40.10:FF:002492', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At1g77010, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(114667, NULL, 'G3DSA:3.30.200.20:FF:002344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114668, NULL, 'G3DSA:1.20.1070.10:FF:000439', NULL, NULL, 'Neuropeptide receptor 18', NULL, NULL, NULL, NULL, NULL, 4),
(114669, NULL, 'G3DSA:2.60.120.10:FF:000437', NULL, NULL, 'Uncharacterized NTE family protein M110.7', NULL, NULL, NULL, NULL, NULL, 4),
(114670, NULL, 'G3DSA:1.10.1300.10:FF:000033', NULL, NULL, 'Putative cAMP-specific phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(114671, NULL, 'G3DSA:1.25.40.10:FF:005246', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(114672, NULL, 'G3DSA:1.25.10.10:FF:001366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114673, NULL, 'G3DSA:1.20.58.760:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114674, NULL, 'G3DSA:3.20.20.80:FF:000527', NULL, NULL, 'Chitinase domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(114675, NULL, 'G3DSA:1.20.1280.50:FF:000006', NULL, NULL, 'Transport inhibitor response 1', NULL, NULL, NULL, NULL, NULL, 4),
(114676, NULL, 'G3DSA:2.40.30.10:FF:000469', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114677, NULL, 'G3DSA:2.60.120.200:FF:000423', NULL, NULL, 'Carbonic anhydrase VI', NULL, NULL, NULL, NULL, NULL, 4),
(114678, NULL, 'G3DSA:3.40.50.10190:FF:000118', NULL, NULL, 'DNA topoisomerase 2-binding protein 1-A-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(114679, NULL, 'G3DSA:3.40.50.1010:FF:000092', NULL, NULL, 'Ribonuclease VapC', NULL, NULL, NULL, NULL, NULL, 4),
(114680, NULL, 'G3DSA:3.40.50.1000:FF:000667', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114681, NULL, 'G3DSA:2.60.120.330:FF:000007', NULL, NULL, 'Protein DMR6-like oxygenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(114682, NULL, 'G3DSA:3.40.50.720:FF:001141', NULL, NULL, 'GDP-6-deoxy-D-mannose reductase', NULL, NULL, NULL, NULL, NULL, 4),
(114683, NULL, 'G3DSA:3.40.50.300:FF:003712', NULL, NULL, 'ATP-binding cassette efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(114684, NULL, 'G3DSA:1.20.90.10:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114685, NULL, 'G3DSA:1.10.287.110:FF:000386', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114686, NULL, 'G3DSA:3.40.190.10:FF:000818', NULL, NULL, 'Transcriptional regulator MetR', NULL, NULL, NULL, NULL, NULL, 4),
(114687, NULL, 'G3DSA:3.90.850.10:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114688, NULL, 'G3DSA:1.10.10.10:FF:000679', NULL, NULL, 'Forkhead transcription factor 3 (Freac-3), putative', NULL, NULL, NULL, NULL, NULL, 4),
(114689, NULL, 'G3DSA:2.60.40.10:FF:000587', NULL, NULL, 'Immunoglobulin like domain containing receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(114690, NULL, 'G3DSA:3.40.50.300:FF:001363', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(114691, NULL, 'G3DSA:1.10.287.70:FF:000053', NULL, NULL, 'Voltage-dependent T-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(114692, NULL, 'G3DSA:3.40.1550.20:FF:000006', NULL, NULL, 'Transcriptional regulator MraZ', NULL, NULL, NULL, NULL, NULL, 4),
(114693, NULL, 'G3DSA:2.10.90.10:FF:000171', NULL, NULL, 'Transforming growth factor beta', NULL, NULL, NULL, NULL, NULL, 4),
(114694, NULL, 'G3DSA:2.10.110.10:FF:000268', NULL, NULL, 'Ttx-3', NULL, NULL, NULL, NULL, NULL, 4),
(114695, NULL, 'G3DSA:3.40.50.300:FF:006938', NULL, NULL, 'Branched-chain amino acid ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(114696, NULL, 'G3DSA:3.80.10.10:FF:000531', NULL, NULL, 'Slit guidance ligand 3', NULL, NULL, NULL, NULL, NULL, 4),
(114697, NULL, 'G3DSA:3.40.50.410:FF:000098', NULL, NULL, 'Copine-5', NULL, NULL, NULL, NULL, NULL, 4),
(114698, NULL, 'G3DSA:3.10.28.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114699, NULL, 'G3DSA:2.130.10.10:FF:002268', NULL, NULL, 'U3 small nucleolar RNA interacting protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114700, NULL, 'G3DSA:2.130.10.10:FF:003206', NULL, NULL, 'Flagellar associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(114701, NULL, 'G3DSA:3.90.1030.20:FF:000006', NULL, NULL, 'DNA polymerase delta subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(114702, NULL, 'G3DSA:3.30.470.20:FF:000019', NULL, NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(114703, NULL, 'G3DSA:3.30.160.60:FF:001981', NULL, NULL, 'Zinc finger protein 425', NULL, NULL, NULL, NULL, NULL, 4),
(114704, NULL, 'G3DSA:3.40.33.10:FF:000119', NULL, NULL, 'Vap-1', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(114705, NULL, 'G3DSA:3.40.50.2000:FF:000287', NULL, NULL, 'UDP-glycosyltransferase 74D1', NULL, NULL, NULL, NULL, NULL, 4),
(114706, NULL, 'G3DSA:1.10.3060.10:FF:000008', NULL, NULL, 'Protein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(114707, NULL, 'G3DSA:3.40.630.30:FF:000168', NULL, NULL, 'Spermidine/spermine N1-acetyltransferase 1a, duplicate 1', NULL, NULL, NULL, NULL, NULL, 4),
(114708, NULL, 'G3DSA:3.40.50.150:FF:000891', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114709, NULL, 'G3DSA:2.60.40.10:FF:003572', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114710, NULL, 'G3DSA:3.30.160.60:FF:004398', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114711, NULL, 'G3DSA:3.30.450.20:FF:000350', NULL, NULL, 'GGDEF domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(114712, NULL, 'G3DSA:1.25.40.10:FF:003430', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(114713, NULL, 'G3DSA:2.40.70.10:FF:000578', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114714, NULL, 'G3DSA:3.30.70.330:FF:001283', NULL, NULL, 'Polyadenylate-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114715, NULL, 'G3DSA:1.20.58.390:FF:000215', NULL, NULL, 'Nicotinic acetylcholine receptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(114716, NULL, 'G3DSA:3.80.10.10:FF:004230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114717, NULL, 'G3DSA:3.30.1360.210:FF:000012', NULL, NULL, '60S ribosomal protein L22-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114718, NULL, 'G3DSA:3.80.10.10:FF:002768', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(114719, NULL, 'G3DSA:3.50.50.60:FF:000870', NULL, NULL, 'Digeranylgeranylglycerophospholipid reductase 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(114720, NULL, 'G3DSA:3.40.50.1100:FF:000242', NULL, NULL, 'Si:ch73-263o4.3', NULL, NULL, NULL, NULL, NULL, 4),
(114721, NULL, 'G3DSA:3.90.226.10:FF:000189', NULL, NULL, 'methylglutaconyl-CoA hydratase, mitochondrial-like', NULL, NULL, NULL, NULL, NULL, 4),
(114722, NULL, 'G3DSA:1.25.40.10:FF:000024', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(114723, NULL, 'G3DSA:1.20.1250.20:FF:001260', NULL, NULL, 'GD18866', NULL, NULL, NULL, NULL, NULL, 4),
(114724, NULL, 'G3DSA:1.10.3780.10:FF:000001', NULL, NULL, 'Starch-binding outer membrane lipoprotein SusD', NULL, NULL, NULL, NULL, NULL, 4),
(114725, NULL, 'G3DSA:3.40.50.300:FF:007883', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114726, NULL, 'G3DSA:3.40.50.300:FF:000857', NULL, NULL, 'GTP-binding protein 8 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(114727, NULL, 'G3DSA:1.20.920.10:FF:000129', NULL, NULL, 'Bromodomain and WD repeat-containing protein 3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(114728, NULL, 'G3DSA:3.80.10.10:FF:001728', NULL, NULL, 'Component of U2 snRNP, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114729, NULL, 'G3DSA:3.30.70.270:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114730, NULL, 'G3DSA:3.30.160.60:FF:005819', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114731, NULL, 'G3DSA:3.90.70.10:FF:000675', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114732, NULL, 'G3DSA:4.10.410.10:FF:000019', NULL, NULL, 'collagen alpha-1(VII) chain', NULL, NULL, NULL, NULL, NULL, 4),
(114733, NULL, 'G3DSA:2.60.40.10:FF:001093', NULL, NULL, 'Interleukin 20 receptor subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(114734, NULL, 'G3DSA:3.40.50.10260:FF:000038', NULL, NULL, 'YjeF N-terminal domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(114735, NULL, 'G3DSA:2.30.40.10:FF:000066', NULL, NULL, 'Periplasmic amidohydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(114736, NULL, 'G3DSA:2.30.180.10:FF:000009', NULL, NULL, 'Fasciclin-like arabinogalactan protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(114737, NULL, 'G3DSA:3.10.290.10:FF:000013', NULL, NULL, 'Ribosome-associated protein YbcJ', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(114738, NULL, 'G3DSA:1.20.1250.20:FF:000754', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(114739, NULL, 'G3DSA:3.40.50.620:FF:000043', NULL, NULL, 'Phosphoadenosine phosphosulfate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(114740, NULL, 'G3DSA:2.30.42.10:FF:000098', NULL, NULL, 'regulator of G-protein signaling 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(114741, NULL, 'G3DSA:3.20.20.100:FF:000155', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(114742, NULL, 'G3DSA:1.25.40.90:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114743, NULL, 'G3DSA:1.20.1330.10:FF:000004', NULL, NULL, 'Flagellin', NULL, NULL, NULL, NULL, NULL, 4),
(114744, NULL, 'G3DSA:3.10.350.10:FF:000052', NULL, NULL, 'Peptidase, M23/M37 family', NULL, NULL, NULL, NULL, NULL, 4),
(114745, NULL, 'G3DSA:2.10.70.10:FF:000057', NULL, NULL, 'Pappalysin 1', NULL, NULL, NULL, NULL, NULL, 4),
(114746, NULL, 'G3DSA:1.25.40.10:FF:001194', NULL, NULL, 'Os06g0143500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(114747, NULL, 'G3DSA:2.20.28.10:FF:000043', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(114748, NULL, 'G3DSA:3.40.50.10860:FF:000010', NULL, NULL, 'Leucine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(114749, NULL, 'G3DSA:3.30.450.20:FF:000119', NULL, NULL, 'Serine threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(114750, NULL, 'G3DSA:1.20.1440.80:FF:000005', NULL, NULL, 'Gap junction protein', NULL, NULL, NULL, NULL, NULL, 4),
(114751, NULL, 'G3DSA:1.10.196.10:FF:000009', NULL, NULL, 'Regulator of G-protein signaling 1', NULL, NULL, NULL, NULL, NULL, 4),
(114752, NULL, 'G3DSA:2.20.100.10:FF:000176', NULL, NULL, 'LOC100158609 protein', NULL, NULL, NULL, NULL, NULL, 4),
(114753, NULL, 'G3DSA:3.90.1410.10:FF:000100', NULL, NULL, 'Ribosomal lysine N-methyltransferase 4', NULL, NULL, NULL, NULL, NULL, 4),
(114754, NULL, 'G3DSA:3.30.810.10:FF:000004', NULL, NULL, 'Phosphatidylinositol 5-phosphate 4-kinase type-2 beta', NULL, NULL, NULL, NULL, NULL, 4),
(114755, NULL, 'G3DSA:6.10.140.2220:FF:000030', NULL, NULL, 'histone-lysine N-methyltransferase SMYD3', NULL, NULL, NULL, NULL, NULL, 4),
(114756, NULL, 'G3DSA:2.130.10.10:FF:004151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114757, NULL, 'G3DSA:1.10.472.10:FF:000707', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114758, NULL, 'G3DSA:3.30.70.330:FF:000647', NULL, NULL, 'CCCH zinc finger and RRM domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(114759, NULL, 'G3DSA:1.25.10.10:FF:000747', NULL, NULL, 'Shattered', NULL, NULL, NULL, NULL, NULL, 4),
(114760, NULL, 'G3DSA:1.10.8.270:FF:000002', NULL, NULL, 'TBC1 domain family member 9B', NULL, NULL, NULL, NULL, NULL, 4),
(114761, NULL, 'G3DSA:3.30.1610.10:FF:000005', NULL, NULL, 'Nucleoporin autopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114762, NULL, 'G3DSA:3.30.40.10:FF:002126', NULL, NULL, 'General transcription and DNA repair factor IIH', NULL, NULL, NULL, NULL, NULL, 4),
(114763, NULL, 'G3DSA:3.10.20.90:FF:000025', NULL, NULL, 'Afadin, adherens junction formation factor', NULL, NULL, NULL, NULL, NULL, 4),
(114764, NULL, 'G3DSA:1.20.1250.20:FF:000866', NULL, NULL, 'MFS multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114765, NULL, 'G3DSA:3.40.50.300:FF:007091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114766, NULL, 'G3DSA:3.10.20.90:FF:000137', NULL, NULL, 'Fas associated factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(114767, NULL, 'G3DSA:3.30.160.60:FF:006213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114768, NULL, 'G3DSA:1.20.1310.20:FF:000012', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(114769, NULL, 'G3DSA:3.60.40.10:FF:000309', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(114770, NULL, 'G3DSA:3.40.630.10:FF:000050', NULL, NULL, 'Carboxypeptidase O', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(114771, NULL, 'G3DSA:2.160.20.70:FF:000014', NULL, NULL, 'Adenylyl cyclase-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(114772, NULL, 'G3DSA:1.10.1040.10:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114773, NULL, 'G3DSA:3.40.50.1170:FF:000010', NULL, NULL, 'Asparaginase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114774, NULL, 'G3DSA:3.90.1150.10:FF:000276', NULL, NULL, 'PLP-dependent transferase', NULL, NULL, NULL, NULL, NULL, 4),
(114775, NULL, 'G3DSA:3.20.20.190:FF:000030', NULL, NULL, '1-phosphatidylinositol phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(114776, NULL, 'G3DSA:2.30.42.10:FF:000469', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114777, NULL, 'G3DSA:1.20.5.340:FF:000021', NULL, NULL, 'Myosin heavy chain, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(114778, NULL, 'G3DSA:3.30.230.80:FF:000003', NULL, NULL, 'endoplasmin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(114779, NULL, 'G3DSA:3.30.160.60:FF:000132', NULL, NULL, 'PR domain zinc finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(114780, NULL, 'G3DSA:1.25.40.860:FF:000027', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(114781, NULL, 'G3DSA:2.60.120.10:FF:000651', NULL, NULL, 'Probable homogentisate 1,2-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(114782, NULL, 'G3DSA:1.20.58.610:FF:000006', NULL, NULL, 'Hsp90 co-chaperone Cdc37', NULL, NULL, NULL, NULL, NULL, 4),
(114783, NULL, 'G3DSA:2.60.120.310:FF:000001', NULL, NULL, 'peptidyl-glycine alpha-amidating monooxygenase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(114784, NULL, 'G3DSA:2.30.42.10:FF:000109', NULL, NULL, 'partitioning defective 3 homolog isoform X9', NULL, NULL, NULL, NULL, NULL, 4),
(114785, NULL, 'G3DSA:3.30.1360.40:FF:000005', NULL, NULL, 'DNA topoisomerase 4 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(114786, NULL, 'G3DSA:3.20.20.100:FF:000060', NULL, NULL, 'Putative oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(114787, NULL, 'G3DSA:3.40.630.30:FF:000056', NULL, NULL, 'Glycylpeptide N-tetradecanoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(114788, NULL, 'G3DSA:3.40.50.300:FF:007102', NULL, NULL, 'ABC transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(114789, NULL, 'G3DSA:3.40.640.10:FF:000247', NULL, NULL, 'Aminotransferase, class I', NULL, NULL, NULL, NULL, NULL, 4),
(114790, NULL, 'G3DSA:2.170.30.10:FF:000002', NULL, NULL, 'Capsid protein', NULL, NULL, NULL, NULL, NULL, 4),
(114791, NULL, 'G3DSA:3.90.550.10:FF:000111', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(114792, NULL, 'G3DSA:3.40.250.10:FF:000083', NULL, NULL, 'MercaptoPyruvate SulfurTransferase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(114793, NULL, 'G3DSA:1.25.10.10:FF:003283', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(114794, NULL, 'G3DSA:3.30.70.1350:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114795, NULL, 'G3DSA:2.60.40.420:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114796, NULL, 'G3DSA:3.60.10.10:FF:000341', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(114797, NULL, 'G3DSA:3.30.160.60:FF:002953', NULL, NULL, 'Zinc finger protein 579', NULL, NULL, NULL, NULL, NULL, 4),
(114798, NULL, 'G3DSA:3.40.50.300:FF:000065', NULL, NULL, 'Eukaryotic translation initiation factor 2 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(114799, NULL, 'G3DSA:2.60.40.60:FF:000118', NULL, NULL, 'protocadherin Fat 4', NULL, NULL, NULL, NULL, NULL, 4),
(114800, NULL, 'G3DSA:3.30.70.330:FF:000226', NULL, NULL, 'Non-POU domain-containing octamer-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(114801, NULL, 'G3DSA:3.40.50.300:FF:004117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114802, NULL, 'G3DSA:3.30.160.60:FF:001542', NULL, NULL, 'zinc finger protein 3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(114803, NULL, 'G3DSA:2.30.30.40:FF:000669', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(114804, NULL, 'G3DSA:2.60.40.1960:FF:000001', NULL, NULL, 'Cathepsin D', NULL, NULL, NULL, NULL, NULL, 4),
(114805, NULL, 'G3DSA:3.80.10.10:FF:000970', NULL, NULL, 'Glycoprotein hormone receptor II', NULL, NULL, NULL, NULL, NULL, 4),
(114806, NULL, 'G3DSA:3.60.40.10:FF:000298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114807, NULL, 'G3DSA:3.30.200.20:FF:001725', NULL, NULL, 'Putative serine/threonine-protein kinase haspin homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(114808, NULL, 'G3DSA:3.90.79.10:FF:000195', NULL, NULL, 'NUDIX hydrolase, conserved', NULL, NULL, NULL, NULL, NULL, 4),
(114809, NULL, 'G3DSA:3.20.20.150:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114810, NULL, 'G3DSA:2.60.40.10:FF:002953', NULL, NULL, 'Complement 4B (Chido blood group)', NULL, NULL, NULL, NULL, NULL, 4),
(114811, NULL, 'G3DSA:3.30.160.60:FF:003779', NULL, NULL, 'Fruitless', NULL, NULL, NULL, NULL, NULL, 4),
(114812, NULL, 'G3DSA:3.40.50.1100:FF:000130', NULL, NULL, 'Cysteine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(114813, NULL, 'G3DSA:1.10.30.10:FF:000107', NULL, NULL, 'transcription factor protein', NULL, NULL, NULL, NULL, NULL, 4),
(114814, NULL, 'G3DSA:3.40.50.80:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114815, NULL, 'G3DSA:1.25.10.10:FF:003069', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(114816, NULL, 'G3DSA:3.40.930.10:FF:000011', NULL, NULL, 'Anion exchange protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(114817, NULL, 'G3DSA:1.20.58.390:FF:000103', NULL, NULL, 'Si:ch211-256e16.10', NULL, NULL, NULL, NULL, NULL, 4),
(114818, NULL, 'G3DSA:2.60.40.10:FF:004639', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114819, NULL, 'G3DSA:2.20.25.10:FF:000020', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(114820, NULL, 'G3DSA:3.50.50.60:FF:001275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114821, NULL, 'G3DSA:3.40.50.10240:FF:000032', NULL, NULL, 'Thiamin diphosphokinase2', NULL, NULL, NULL, NULL, NULL, 4),
(114822, NULL, 'G3DSA:3.30.40.10:FF:001300', NULL, NULL, 'YALI0E12639p', NULL, NULL, NULL, NULL, NULL, 4),
(114823, NULL, 'G3DSA:1.10.10.1460:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114824, NULL, 'G3DSA:2.60.200.40:FF:000014', NULL, NULL, 'Ceramide kinase', NULL, NULL, NULL, NULL, NULL, 4),
(114825, NULL, 'G3DSA:1.10.10.10:FF:001635', NULL, NULL, 'Transcriptional regulator, metal-sensing', NULL, NULL, NULL, NULL, NULL, 4),
(114826, NULL, 'G3DSA:3.30.70.330:FF:002901', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114827, NULL, 'G3DSA:3.80.10.10:FF:002347', NULL, NULL, 'Platelet glycoprotein V', NULL, NULL, NULL, NULL, NULL, 4),
(114828, NULL, 'G3DSA:3.30.70.660:FF:000078', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(114829, NULL, 'G3DSA:1.10.287.130:FF:000021', NULL, NULL, 'Sensor histidine kinase KdpD', NULL, NULL, NULL, NULL, NULL, 4),
(114830, NULL, 'G3DSA:3.30.420.40:FF:000528', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(114831, NULL, 'G3DSA:3.30.450.30:FF:000027', NULL, NULL, 'Cell polarity determinant GTPase-activating protein MglB', NULL, NULL, NULL, NULL, NULL, 4),
(114832, NULL, 'G3DSA:3.20.70.20:FF:000018', NULL, NULL, 'Vitamin B12-dependent ribonucleotide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(114833, NULL, 'G3DSA:2.60.40.10:FF:003442', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114834, NULL, 'G3DSA:3.90.1150.10:FF:000181', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(114835, NULL, 'G3DSA:3.40.50.150:FF:001279', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114836, NULL, 'G3DSA:3.30.70.330:FF:001171', NULL, NULL, 'Zinc finger protein containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(114837, NULL, 'G3DSA:1.10.238.10:FF:001187', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(114838, NULL, 'G3DSA:2.30.34.10:FF:000006', NULL, NULL, 'Major surface protease-like protein C', NULL, NULL, NULL, NULL, NULL, 4),
(114839, NULL, 'G3DSA:2.60.120.260:FF:000290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114840, NULL, 'G3DSA:3.40.50.11260:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114841, NULL, 'G3DSA:1.25.40.180:FF:000250', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114842, NULL, 'G3DSA:3.40.50.300:FF:001346', NULL, NULL, 'ATP-dependent helicase', NULL, NULL, NULL, NULL, NULL, 4),
(114843, NULL, 'G3DSA:2.120.10.80:FF:000069', NULL, NULL, 'Multiple epidermal growth factor-like domains protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(114844, NULL, 'G3DSA:2.160.20.10:FF:000154', NULL, NULL, 'Cell surface glycoprotein (S-layer protein)', NULL, NULL, NULL, NULL, NULL, 4),
(114845, NULL, 'G3DSA:3.40.50.740:FF:000062', NULL, NULL, 'NADH-quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(114846, NULL, 'G3DSA:3.40.50.1000:FF:000779', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114847, NULL, 'G3DSA:2.60.120.200:FF:000311', NULL, NULL, 'Possible beta-1,3-glucanase', NULL, NULL, NULL, NULL, NULL, 4),
(114848, NULL, 'G3DSA:3.40.50.360:FF:000173', NULL, NULL, 'Flavodoxin', NULL, NULL, NULL, NULL, NULL, 4),
(114849, NULL, 'G3DSA:1.10.8.10:FF:000038', NULL, NULL, 'tudor domain-containing protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(114850, NULL, 'G3DSA:3.20.20.190:FF:000159', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114851, NULL, 'G3DSA:1.10.3380.10:FF:000021', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(114852, NULL, 'G3DSA:2.30.40.10:FF:000150', NULL, NULL, 'Uncharacterized protein MJ0699', NULL, NULL, NULL, NULL, NULL, 4),
(114853, NULL, 'G3DSA:1.25.40.10:FF:000816', NULL, NULL, 'ALBINO3-like protein 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(114854, NULL, 'G3DSA:1.20.120.1750:FF:000085', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(114855, NULL, 'G3DSA:1.20.1070.10:FF:001496', NULL, NULL, 'Si:ch211-137j23.8', NULL, NULL, NULL, NULL, NULL, 4),
(114856, NULL, 'G3DSA:1.10.510.10:FF:003118', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114857, NULL, 'G3DSA:3.30.200.20:FF:001708', NULL, NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 182', NULL, NULL, NULL, NULL, NULL, 4),
(114858, NULL, 'G3DSA:1.20.80.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114859, NULL, 'G3DSA:2.60.40.10:FF:001216', NULL, NULL, 'Myosin binding protein C, fast type', NULL, NULL, NULL, NULL, NULL, 4),
(114860, NULL, 'G3DSA:3.30.160.60:FF:001525', NULL, NULL, 'Tripartite motif-containing protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(114861, NULL, 'G3DSA:3.30.200.20:FF:001372', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114862, NULL, 'G3DSA:1.25.40.20:FF:001764', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(114863, NULL, 'G3DSA:1.20.890.10:FF:000002', NULL, NULL, 'cAMP-dependent protein kinase type II-alpha regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(114864, NULL, 'G3DSA:1.20.120.850:FF:000049', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(114865, NULL, 'G3DSA:3.90.190.10:FF:000583', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(114866, NULL, 'G3DSA:2.60.120.200:FF:000199', NULL, NULL, 'Hydroxyproline O-galactosyltransferase GALT4', NULL, NULL, NULL, NULL, NULL, 4),
(114867, NULL, 'G3DSA:3.20.20.80:FF:000639', NULL, NULL, 'Amylo-1,6-glucosidase, 4-alpha-glucanotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(114868, NULL, 'G3DSA:3.40.50.80:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114869, NULL, 'G3DSA:1.25.40.10:FF:004739', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(114870, NULL, 'G3DSA:3.60.21.10:FF:000046', NULL, NULL, 'Metallophosphoesterase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(114871, NULL, 'G3DSA:3.40.50.200:FF:000153', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 4, furin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114872, NULL, 'G3DSA:2.40.440.10:FF:000005', NULL, NULL, 'L,D-transpeptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(114873, NULL, 'G3DSA:3.40.710.10:FF:000112', NULL, NULL, 'Penicillin-binding protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(114874, NULL, 'G3DSA:3.40.850.10:FF:000173', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(114875, NULL, 'G3DSA:1.10.3380.30:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114876, NULL, 'G3DSA:2.30.250.10:FF:000004', NULL, NULL, 'Probable M18 family aminopeptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(114877, NULL, 'G3DSA:3.40.50.11530:FF:000003', NULL, NULL, 'Interleukin-17 receptor D', NULL, NULL, NULL, NULL, NULL, 4),
(114878, NULL, 'G3DSA:3.20.20.140:FF:000156', NULL, NULL, 'Histidinol-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(114879, NULL, 'G3DSA:3.40.50.620:FF:000481', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114880, NULL, 'G3DSA:1.25.40.10:FF:005358', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114881, NULL, 'G3DSA:1.20.1560.10:FF:000286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114882, NULL, 'G3DSA:3.80.10.10:FF:002785', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114883, NULL, 'G3DSA:1.20.58.60:FF:000146', NULL, NULL, 'dystrophin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(114884, NULL, 'G3DSA:2.60.40.10:FF:000132', NULL, NULL, 'Inositol polyphosphate 5-phosphatase OCRL-1 isoform b', NULL, NULL, NULL, NULL, NULL, 4),
(114885, NULL, 'G3DSA:1.10.10.440:FF:000001', NULL, NULL, 'Transcription elongation regulator 1 like', NULL, NULL, NULL, NULL, NULL, 4),
(114886, NULL, 'G3DSA:1.10.486.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114887, NULL, 'G3DSA:3.40.50.1000:FF:000116', NULL, NULL, 'N-acylneuraminate-9-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(114888, NULL, 'G3DSA:3.40.50.300:FF:003600', NULL, NULL, 'Arsenical pump-driving ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(114889, NULL, 'G3DSA:2.60.120.920:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114890, NULL, 'G3DSA:1.10.287.70:FF:000278', NULL, NULL, 'Cyclic Nucleotide Gated channel', NULL, NULL, NULL, NULL, NULL, 4),
(114891, NULL, 'G3DSA:3.40.50.12710:FF:000043', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7', NULL, NULL, NULL, NULL, NULL, 4),
(114892, NULL, 'G3DSA:2.90.10.10:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114893, NULL, 'G3DSA:2.60.200.20:FF:000267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114894, NULL, 'G3DSA:3.40.50.1100:FF:000028', NULL, NULL, 'Tryptophan synthase beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(114895, NULL, 'G3DSA:1.20.1370.10:FF:000001', NULL, NULL, 'Phenoloxidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(114896, NULL, 'G3DSA:2.60.40.10:FF:002161', NULL, NULL, 'Cilia and flagella associated protein 65', NULL, NULL, NULL, NULL, NULL, 4),
(114897, NULL, 'G3DSA:3.30.43.10:FF:000025', NULL, NULL, 'L-gulono-1,4-lactone dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(114898, NULL, 'G3DSA:3.40.640.10:FF:000359', NULL, NULL, 'Cystathionine Beta Lyase', NULL, NULL, NULL, NULL, NULL, 4),
(114899, NULL, 'G3DSA:1.10.238.10:FF:000782', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114900, NULL, 'G3DSA:2.170.190.11:FF:000001', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(114901, NULL, 'G3DSA:1.10.3500.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114902, NULL, 'G3DSA:3.30.200.20:FF:000427', NULL, NULL, 'Wnk protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(114903, NULL, 'G3DSA:3.40.350.10:FF:000028', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(114904, NULL, 'G3DSA:3.40.50.720:FF:002113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114905, NULL, 'G3DSA:3.30.160.60:FF:000244', NULL, NULL, 'zinc finger protein 423', NULL, NULL, NULL, NULL, NULL, 4),
(114906, NULL, 'G3DSA:3.30.465.10:FF:000050', NULL, NULL, 'Membrane protein TerC', NULL, NULL, NULL, NULL, NULL, 4),
(114907, NULL, 'G3DSA:2.130.10.10:FF:000340', NULL, NULL, 'Rho guanine nucleotide exchange factor (GEF) 10', NULL, NULL, NULL, NULL, NULL, 4),
(114908, NULL, 'G3DSA:3.30.530.20:FF:000188', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(114909, NULL, 'G3DSA:2.70.98.10:FF:000118', NULL, NULL, 'Xanthan lyase', NULL, NULL, NULL, NULL, NULL, 4),
(114910, NULL, 'G3DSA:1.20.120.350:FF:000012', NULL, NULL, 'Voltage-dependent T-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(114911, NULL, 'G3DSA:3.30.40.10:FF:002238', NULL, NULL, 'Xnf7, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114912, NULL, 'G3DSA:3.90.550.10:FF:000223', NULL, NULL, 'DUF2064 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(114913, NULL, 'G3DSA:3.40.50.300:FF:005528', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114914, NULL, 'G3DSA:3.40.50.11950:FF:000005', NULL, NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(114915, NULL, 'G3DSA:1.25.40.90:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114916, NULL, 'G3DSA:1.25.40.10:FF:001435', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(114917, NULL, 'G3DSA:1.25.10.10:FF:000298', NULL, NULL, 'Serum amyloid A like 1', NULL, NULL, NULL, NULL, NULL, 4),
(114918, NULL, 'G3DSA:3.90.76.10:FF:000042', NULL, NULL, 'Oligopeptide-binding protein AppA', NULL, NULL, NULL, NULL, NULL, 4),
(114919, NULL, 'G3DSA:3.40.50.300:FF:004005', NULL, NULL, 'GD12861', NULL, NULL, NULL, NULL, NULL, 4),
(114920, NULL, 'G3DSA:3.40.718.10:FF:000012', NULL, NULL, 'Homoisocitrate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(114921, NULL, 'G3DSA:3.30.710.10:FF:000396', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(114922, NULL, 'G3DSA:2.30.30.40:FF:000557', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114923, NULL, 'G3DSA:3.30.1490.480:FF:000009', NULL, NULL, 'Endolytic murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(114924, NULL, 'G3DSA:3.40.1090.10:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114925, NULL, 'G3DSA:1.20.120.1880:FF:000005', NULL, NULL, 'Nuclear pore complex protein Nup155', NULL, NULL, NULL, NULL, NULL, 4),
(114926, NULL, 'G3DSA:3.40.1110.10:FF:000145', NULL, NULL, 'Copper-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(114927, NULL, 'G3DSA:1.10.510.10:FF:001320', NULL, NULL, 'Serine/threonine protein kinase ppk15, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114928, NULL, 'G3DSA:3.40.50.300:FF:002774', NULL, NULL, 'ATP-dependent DNA helicase chl1', NULL, NULL, NULL, NULL, NULL, 4),
(114929, NULL, 'G3DSA:2.60.120.10:FF:000084', NULL, NULL, '(S)-ureidoglycine aminohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(114930, NULL, 'G3DSA:2.170.270.10:FF:000068', NULL, NULL, 'SET domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(114931, NULL, 'G3DSA:2.30.30.490:FF:000005', NULL, NULL, 'Arginine-glutamic acid dipeptide (RE) repeats', NULL, NULL, NULL, NULL, NULL, 4),
(114932, NULL, 'G3DSA:1.20.1560.10:FF:000735', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114933, NULL, 'G3DSA:3.90.1800.10:FF:000023', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(114934, NULL, 'G3DSA:2.60.40.10:FF:001655', NULL, NULL, 'Blast:Dyslexia-associated protein KIAA0319', NULL, NULL, NULL, NULL, NULL, 4),
(114935, NULL, 'G3DSA:1.50.40.10:FF:000174', NULL, NULL, 'Mitochondrial substrate carrier family protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(114936, NULL, 'G3DSA:2.60.120.200:FF:000648', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114937, NULL, 'G3DSA:2.60.40.10:FF:004982', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114938, NULL, 'G3DSA:2.170.130.10:FF:000007', NULL, NULL, 'Fe(3+) dicitrate transport protein FecA', NULL, NULL, NULL, NULL, NULL, 4),
(114939, NULL, 'G3DSA:2.60.40.10:FF:004061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114940, NULL, 'G3DSA:3.40.605.10:FF:000109', NULL, NULL, '10-formyltetrahydrofolate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(114941, NULL, 'G3DSA:3.40.630.30:FF:000409', NULL, NULL, 'Bifunctional protein NCOAT-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(114942, NULL, 'G3DSA:3.20.20.60:FF:000072', NULL, NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(114943, NULL, 'G3DSA:1.10.1670.40:FF:000007', NULL, NULL, 'DNA-3-methyladenine glycosylase II', NULL, NULL, NULL, NULL, NULL, 4),
(114944, NULL, 'G3DSA:2.40.50.140:FF:000217', NULL, NULL, 'DNA damage induced apoptosis suppressor', NULL, NULL, NULL, NULL, NULL, 4),
(114945, NULL, 'G3DSA:1.20.5.170:FF:000291', NULL, NULL, 'Protein CBG22431', NULL, NULL, NULL, NULL, NULL, 4),
(114946, NULL, 'G3DSA:3.40.950.10:FF:000006', NULL, NULL, 'Fe-hydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114947, NULL, 'G3DSA:3.30.420.10:FF:000632', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114948, NULL, 'G3DSA:2.130.10.10:FF:005674', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114949, NULL, 'G3DSA:1.20.1260.10:FF:000010', NULL, NULL, '1,2-phenylacetyl-CoA epoxidase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(114950, NULL, 'G3DSA:3.30.50.10:FF:000058', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(114951, NULL, 'G3DSA:1.25.40.10:FF:002941', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114952, NULL, 'G3DSA:3.10.105.10:FF:000117', NULL, NULL, 'ABC-type dipeptide transport system, periplasmic component', NULL, NULL, NULL, NULL, NULL, 4),
(114953, NULL, 'G3DSA:3.40.50.300:FF:004909', NULL, NULL, 'Mitochondrial escape protein 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(114954, NULL, 'G3DSA:1.25.40.10:FF:003913', NULL, NULL, 'LOC100001597 protein', NULL, NULL, NULL, NULL, NULL, 4),
(114955, NULL, 'G3DSA:3.60.21.10:FF:000389', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114956, NULL, 'G3DSA:1.25.40.10:FF:004178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114957, NULL, 'G3DSA:2.60.40.10:FF:005707', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114958, NULL, 'G3DSA:4.10.280.110:FF:000014', NULL, NULL, 'Potassium channel regulatory factor', NULL, NULL, NULL, NULL, NULL, 4),
(114959, NULL, 'G3DSA:1.10.1520.10:FF:000027', NULL, NULL, 'Ribonuclease 3', NULL, NULL, NULL, NULL, NULL, 4),
(114960, NULL, 'G3DSA:2.130.10.10:FF:000109', NULL, NULL, 'WD repeat domain 36', NULL, NULL, NULL, NULL, NULL, 4),
(114961, NULL, 'G3DSA:1.25.10.10:FF:002776', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114962, NULL, 'G3DSA:3.30.450.20:FF:000007', NULL, NULL, 'Nuclear receptor coactivator', NULL, NULL, NULL, NULL, NULL, 4),
(114963, NULL, 'G3DSA:1.10.287.1260:FF:000012', NULL, NULL, 'Mechanosensitive ion channel family protein', NULL, NULL, NULL, NULL, NULL, 4),
(114964, NULL, 'G3DSA:2.30.30.30:FF:000099', NULL, NULL, 'Ribosomal protein L26', NULL, NULL, NULL, NULL, NULL, 4),
(114965, NULL, 'G3DSA:3.40.50.300:FF:007445', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114966, NULL, 'G3DSA:3.30.70.260:FF:000065', NULL, NULL, 'Phosphoserine phosphatase SerB', NULL, NULL, NULL, NULL, NULL, 4),
(114967, NULL, 'G3DSA:3.40.1190.20:FF:000023', NULL, NULL, 'ATP-dependent (S)-NAD(P)H-hydrate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(114968, NULL, 'G3DSA:3.40.50.300:FF:006034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114969, NULL, 'G3DSA:2.30.29.30:FF:000354', NULL, NULL, 'Lnk, isoform D', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(114970, NULL, 'G3DSA:3.40.50.1110:FF:000020', NULL, NULL, 'Esterase, putative (AFU_orthologue AFUA_1G03170)', NULL, NULL, NULL, NULL, NULL, 4),
(114971, NULL, 'G3DSA:2.10.25.10:FF:000531', NULL, NULL, 'otogelin', NULL, NULL, NULL, NULL, NULL, 4),
(114972, NULL, 'G3DSA:1.10.555.10:FF:000232', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114973, NULL, 'G3DSA:1.20.1050.10:FF:000073', NULL, NULL, 'Glutathione S-transferase theta-1', NULL, NULL, NULL, NULL, NULL, 4),
(114974, NULL, 'G3DSA:3.30.1360.70:FF:000003', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(114975, NULL, 'G3DSA:2.60.40.640:FF:000102', NULL, NULL, 'Protein ttm-2', NULL, NULL, NULL, NULL, NULL, 4),
(114976, NULL, 'G3DSA:1.10.10.10:FF:001652', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 12', NULL, NULL, NULL, NULL, NULL, 4),
(114977, NULL, 'G3DSA:1.20.1070.10:FF:000877', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114978, NULL, 'G3DSA:2.120.10.30:FF:000436', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(114979, NULL, 'G3DSA:3.20.20.80:FF:000611', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114980, NULL, 'G3DSA:3.30.160.60:FF:002498', NULL, NULL, 'Transcription factor Ken', NULL, NULL, NULL, NULL, NULL, 4),
(114981, NULL, 'G3DSA:3.30.70.330:FF:002564', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114982, NULL, 'G3DSA:2.170.200.10:FF:000002', NULL, NULL, 'Regulatory protein E2', NULL, NULL, NULL, NULL, NULL, 4),
(114983, NULL, 'G3DSA:3.90.1150.10:FF:000164', NULL, NULL, 'Ornithine--oxo-acid transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(114984, NULL, 'G3DSA:3.30.160.60:FF:003807', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114985, NULL, 'G3DSA:2.40.30.170:FF:000076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114986, NULL, 'G3DSA:1.10.10.60:FF:000992', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114987, NULL, 'G3DSA:1.10.150.50:FF:000152', NULL, NULL, 'Ephrin type-A receptor 4-B', NULL, NULL, NULL, NULL, NULL, 4),
(114988, NULL, 'G3DSA:2.10.25.10:FF:000661', NULL, NULL, 'Basement membrane proteoglycan', NULL, NULL, NULL, NULL, NULL, 4),
(114989, NULL, 'G3DSA:3.20.70.20:FF:000035', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(114990, NULL, 'G3DSA:3.40.50.150:FF:001296', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114991, NULL, 'G3DSA:1.20.5.320:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114992, NULL, 'G3DSA:2.10.25.10:FF:001150', NULL, NULL, 'Wnt inhibitory factor', NULL, NULL, NULL, NULL, NULL, 4),
(114993, NULL, 'G3DSA:2.20.110.10:FF:000002', NULL, NULL, 'Phosphatidylinositol 4-phosphate 5-kinase 8', NULL, NULL, NULL, NULL, NULL, 4),
(114994, NULL, 'G3DSA:3.30.160.60:FF:005707', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(114995, NULL, 'G3DSA:1.25.40.10:FF:000687', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g33170', NULL, NULL, NULL, NULL, NULL, 4),
(114996, NULL, 'G3DSA:2.40.10.10:FF:000018', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(114997, NULL, 'G3DSA:3.30.40.10:FF:001058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(114998, NULL, 'G3DSA:1.10.555.10:FF:000102', NULL, NULL, 'Rho GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(114999, NULL, 'G3DSA:3.40.30.10:FF:000877', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115000, NULL, 'G3DSA:1.20.120.1130:FF:000005', NULL, NULL, 'Vacuolar protein sorting-associated protein 28 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(115001, NULL, 'G3DSA:2.60.40.10:FF:001885', NULL, NULL, 'Neuromusculin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(115002, NULL, 'G3DSA:3.30.1520.10:FF:000127', NULL, NULL, 'YALI0C16412p', NULL, NULL, NULL, NULL, NULL, 4),
(115003, NULL, 'G3DSA:3.40.140.10:FF:000203', NULL, NULL, 'COP9 signalosome complex subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(115004, NULL, 'G3DSA:1.25.40.180:FF:000233', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(115005, NULL, 'G3DSA:1.10.8.60:FF:000137', NULL, NULL, 'AAA-type ATPase family protein / ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(115006, NULL, 'G3DSA:1.10.150.50:FF:000022', NULL, NULL, 'Transcription factor CP2 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(115007, NULL, 'G3DSA:3.30.260.10:FF:000097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115008, NULL, 'G3DSA:3.70.10.10:FF:000037', NULL, NULL, 'Checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(115009, NULL, 'G3DSA:3.40.50.1010:FF:000215', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115010, NULL, 'G3DSA:3.30.160.20:FF:000131', NULL, NULL, 'GM23818', NULL, NULL, NULL, NULL, NULL, 4),
(115011, NULL, 'G3DSA:2.60.40.1180:FF:000099', NULL, NULL, 'Solute carrier family 3 member 2', NULL, NULL, NULL, NULL, NULL, 4),
(115012, NULL, 'G3DSA:2.40.50.140:FF:001162', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115013, NULL, 'G3DSA:2.20.28.10:FF:000026', NULL, NULL, 'DNA replication licensing factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115014, NULL, 'G3DSA:3.40.50.300:FF:006130', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(115015, NULL, 'G3DSA:3.30.420.40:FF:000966', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(115016, NULL, 'G3DSA:1.50.10.20:FF:000012', NULL, NULL, 'Geranylgeranyl transferase type-2 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(115017, NULL, 'G3DSA:3.30.70.330:FF:000664', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(115018, NULL, 'G3DSA:3.40.50.2300:FF:000630', NULL, NULL, 'Metabotropic glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(115019, NULL, 'G3DSA:3.30.1120.10:FF:000035', NULL, NULL, 'N-acetylgalactosamine 6-sulfatase (GALNS)', NULL, NULL, NULL, NULL, NULL, 4),
(115020, NULL, 'G3DSA:3.20.20.80:FF:000078', NULL, NULL, 'Endo-beta-1,4-glucanase B', NULL, NULL, NULL, NULL, NULL, 4),
(115021, NULL, 'G3DSA:3.30.40.10:FF:000569', NULL, NULL, 'Chromatin modification-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(115022, NULL, 'G3DSA:1.10.510.10:FF:001983', NULL, NULL, 'Serine/threonine-protein kinase-like protein At1g28390', NULL, NULL, NULL, NULL, NULL, 4),
(115023, NULL, 'G3DSA:3.90.1290.10:FF:000011', NULL, NULL, 'Short stop, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(115024, NULL, 'G3DSA:2.20.25.30:FF:000008', NULL, NULL, 'G protein-coupled receptor', NULL, NULL, NULL, NULL, NULL, 4),
(115025, NULL, 'G3DSA:1.20.5.340:FF:000004', NULL, NULL, 'Myosin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(115026, NULL, 'G3DSA:1.20.1070.10:FF:000540', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115027, NULL, 'G3DSA:3.60.120.10:FF:000001', NULL, NULL, 'Isochorismate synthase EntC', NULL, NULL, NULL, NULL, NULL, 4),
(115028, NULL, 'G3DSA:2.130.10.30:FF:000003', NULL, NULL, 'E3 ubiquitin-protein ligase HERC2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(115029, NULL, 'G3DSA:2.10.50.10:FF:000062', NULL, NULL, 'Cysteine repeat modular protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(115030, NULL, 'G3DSA:2.60.120.10:FF:000207', NULL, NULL, 'Cyclic nucleotide binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(115031, NULL, 'G3DSA:3.40.190.290:FF:000097', NULL, NULL, 'Transcriptional regulator,LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(115032, NULL, 'G3DSA:3.40.390.10:FF:000255', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115033, NULL, 'G3DSA:2.170.300.10:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115034, NULL, 'G3DSA:3.30.1140.32:FF:000022', NULL, NULL, '30S ribosomal protein S3', NULL, NULL, NULL, NULL, NULL, 4),
(115035, NULL, 'G3DSA:3.40.50.720:FF:000764', NULL, NULL, 'Possible ketoacyl reductase', NULL, NULL, NULL, NULL, NULL, 4),
(115036, NULL, 'G3DSA:2.60.40.10:FF:000828', NULL, NULL, 'Protogenin', NULL, NULL, NULL, NULL, NULL, 4),
(115037, NULL, 'G3DSA:1.10.630.10:FF:000418', NULL, NULL, 'Cytochrome P450 family 26 subfamily A member 1', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(115038, NULL, 'G3DSA:1.25.40.860:FF:000010', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(115039, NULL, 'G3DSA:1.20.58.1610:FF:000012', NULL, NULL, 'F(420)H(2) dehydrogenase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(115040, NULL, 'G3DSA:1.25.40.10:FF:001204', NULL, NULL, 'Pentatricopeptide (PPR) repeat protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(115041, NULL, 'G3DSA:2.130.10.10:FF:005702', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115042, NULL, 'G3DSA:3.40.50.150:FF:000323', NULL, NULL, 'Polyprotein P1234', NULL, NULL, NULL, NULL, NULL, 4),
(115043, NULL, 'G3DSA:2.60.40.1660:FF:000029', NULL, NULL, 'Sodium/potassium-dependent ATPase beta subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115044, NULL, 'G3DSA:1.50.40.10:FF:000511', NULL, NULL, 'Carnitine/acylcarnitine translocase', NULL, NULL, NULL, NULL, NULL, 4),
(115045, NULL, 'G3DSA:3.40.1280.30:FF:000022', NULL, NULL, 'tRNA (Guanine-9-N(1)-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(115046, NULL, 'G3DSA:1.10.10.10:FF:001539', NULL, NULL, 'Type III restriction enzyme, res subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(115047, NULL, 'G3DSA:3.90.640.10:FF:000101', NULL, NULL, '105/110 kDa heat shock protein/ nucleotide-binding domain', NULL, NULL, NULL, NULL, NULL, 4),
(115048, NULL, 'G3DSA:2.10.25.10:FF:001493', NULL, NULL, 'Neurogenic locus notch-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(115049, NULL, 'G3DSA:2.30.42.10:FF:000126', NULL, NULL, 'Piccolo presynaptic cytomatrix protein', NULL, NULL, NULL, NULL, NULL, 4),
(115050, NULL, 'G3DSA:1.10.510.10:FF:000252', NULL, NULL, 'Receptor-like protein kinase FERONIA', NULL, NULL, NULL, NULL, NULL, 4),
(115051, NULL, 'G3DSA:1.10.238.10:FF:001271', NULL, NULL, 'Probable calcium-binding protein CML1', NULL, NULL, NULL, NULL, NULL, 4),
(115052, NULL, 'G3DSA:1.20.1250.20:FF:000299', NULL, NULL, 'Major facilitator superfamily domain containing 4B', NULL, NULL, NULL, NULL, NULL, 4),
(115053, NULL, 'G3DSA:4.10.1000.10:FF:000114', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(115054, NULL, 'G3DSA:2.60.40.60:FF:000686', NULL, NULL, 'Cadherin-4', NULL, NULL, NULL, NULL, NULL, 4),
(115055, NULL, 'G3DSA:1.10.357.10:FF:000075', NULL, NULL, 'Ubiquinone biosynthesis protein COQ9', NULL, NULL, NULL, NULL, NULL, 4),
(115056, NULL, 'G3DSA:2.40.50.100:FF:000104', NULL, NULL, 'Glycerol-3-phosphate ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(115057, NULL, 'G3DSA:1.25.10.10:FF:001596', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115058, NULL, 'G3DSA:3.30.70.20:FF:000057', NULL, NULL, 'Ferredoxin-type protein NapF', NULL, NULL, NULL, NULL, NULL, 4),
(115059, NULL, 'G3DSA:1.25.40.10:FF:002828', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g50990', NULL, NULL, NULL, NULL, NULL, 4),
(115060, NULL, 'G3DSA:1.20.1070.10:FF:000085', NULL, NULL, '5-hydroxytryptamine receptor 1F', NULL, NULL, NULL, NULL, NULL, 4),
(115061, NULL, 'G3DSA:3.30.1740.10:FF:000009', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(115062, NULL, 'G3DSA:3.30.740.10:FF:000009', NULL, NULL, 'Dynein light chain', NULL, NULL, NULL, NULL, NULL, 4),
(115063, NULL, 'G3DSA:2.60.120.290:FF:000057', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(115064, NULL, 'G3DSA:3.40.366.10:FF:000036', NULL, NULL, 'Malonyl CoA-acyl carrier protein transacylase', NULL, NULL, NULL, NULL, NULL, 4),
(115065, NULL, 'G3DSA:1.10.220.110:FF:000004', NULL, NULL, 'GDNF family receptor alpha 4', NULL, NULL, NULL, NULL, NULL, 4),
(115066, NULL, 'G3DSA:3.40.630.10:FF:000078', NULL, NULL, 'Glutamate carboxypeptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(115067, NULL, 'G3DSA:3.30.450.40:FF:000114', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(115068, NULL, 'G3DSA:3.80.10.10:FF:000874', NULL, NULL, 'Probable LRR receptor-like serine/threonine-protein kinase RFK1', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(115069, NULL, 'G3DSA:3.40.50.10130:FF:000016', NULL, NULL, 'Hef nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(115070, NULL, 'G3DSA:2.30.30.140:FF:000131', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(115071, NULL, 'G3DSA:1.20.1270.130:FF:000003', NULL, NULL, 'Type III secretion system effector E3 ubiquitin transferase SlrP', NULL, NULL, NULL, NULL, NULL, 4),
(115072, NULL, 'G3DSA:3.40.50.200:FF:000041', NULL, NULL, 'Proline rich membrane-anchored mycosin', NULL, NULL, NULL, NULL, NULL, 4),
(115073, NULL, 'G3DSA:3.30.470.20:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115074, NULL, 'G3DSA:1.10.565.10:FF:000159', NULL, NULL, 'Nr1d1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(115075, NULL, 'G3DSA:2.60.40.10:FF:000244', NULL, NULL, 'carcinoembryonic antigen-related cell adhesion molecule 16', NULL, NULL, NULL, NULL, NULL, 4),
(115076, NULL, 'G3DSA:2.60.120.560:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115077, NULL, 'G3DSA:1.10.150.20:FF:000266', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(115078, NULL, 'G3DSA:2.130.10.10:FF:004494', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115079, NULL, 'G3DSA:1.25.40.20:FF:001634', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(115080, NULL, 'G3DSA:1.20.58.60:FF:000034', NULL, NULL, 'kalirin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(115081, NULL, 'G3DSA:3.40.1360.10:FF:000062', NULL, NULL, 'Meiotic recombination protein rec12', NULL, NULL, NULL, NULL, NULL, 4),
(115082, NULL, 'G3DSA:1.20.140.10:FF:000058', NULL, NULL, 'Putative acyl-CoA oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(115083, NULL, 'G3DSA:3.30.300.20:FF:000019', NULL, NULL, 'Ribosome-binding factor A', NULL, NULL, NULL, NULL, NULL, 4),
(115084, NULL, 'G3DSA:2.30.29.30:FF:000146', NULL, NULL, 'FACT complex subunit POB3', NULL, NULL, NULL, NULL, NULL, 4),
(115085, NULL, 'G3DSA:1.25.40.410:FF:000010', NULL, NULL, 'Dck1p', NULL, NULL, NULL, NULL, NULL, 4),
(115086, NULL, 'G3DSA:2.30.29.170:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115087, NULL, 'G3DSA:3.40.50.2000:FF:000742', NULL, NULL, 'UDP-glucoronosyl and UDP-glucosyl transferase family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115088, NULL, 'G3DSA:3.50.50.60:FF:001045', NULL, NULL, 'Pyridine nucleotide-disulfide oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(115089, NULL, 'G3DSA:2.60.120.430:FF:000020', NULL, NULL, 'Nodulation receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(115090, NULL, 'G3DSA:3.30.70.330:FF:001732', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115091, NULL, 'G3DSA:2.130.10.10:FF:000795', NULL, NULL, 'Transducin beta-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(115092, NULL, 'G3DSA:3.30.1010.10:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115093, NULL, 'G3DSA:4.10.410.20:FF:000005', NULL, NULL, 'Endonuclease, poly(U) specific', NULL, NULL, NULL, NULL, NULL, 4),
(115094, NULL, 'G3DSA:3.40.50.10890:FF:000002', NULL, NULL, 'Integrator complex subunit 11', NULL, NULL, NULL, NULL, NULL, 4),
(115095, NULL, 'G3DSA:3.90.660.10:FF:000001', NULL, NULL, 'Lysine-specific histone demethylase', NULL, NULL, NULL, NULL, NULL, 4),
(115096, NULL, 'G3DSA:3.40.190.10:FF:000482', NULL, NULL, 'GD19935', NULL, NULL, NULL, NULL, NULL, 4),
(115097, NULL, 'G3DSA:3.40.50.2300:FF:001243', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115098, NULL, 'G3DSA:3.60.70.12:FF:000004', NULL, NULL, 'Beta-peptidyl aminopeptidase BapA', NULL, NULL, NULL, NULL, NULL, 4),
(115099, NULL, 'G3DSA:3.30.420.140:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115100, NULL, 'G3DSA:2.60.120.740:FF:000012', NULL, NULL, 'Eva-1 homolog C', NULL, NULL, NULL, NULL, NULL, 4),
(115101, NULL, 'G3DSA:3.40.50.1000:FF:000324', NULL, NULL, 'Putative Alpha,alpha-trehalose-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(115102, NULL, 'G3DSA:3.40.50.1010:FF:000007', NULL, NULL, 'PhoH family protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(115103, NULL, 'G3DSA:1.10.860.10:FF:000019', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(115104, NULL, 'G3DSA:2.60.40.150:FF:000152', NULL, NULL, 'Synaptotagmin like 3', NULL, NULL, NULL, NULL, NULL, 4),
(115105, NULL, 'G3DSA:3.30.70.330:FF:002351', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115106, NULL, 'G3DSA:3.40.250.10:FF:000195', NULL, NULL, 'Adenylyltransferase and sulfurtransferase UBA4', NULL, NULL, NULL, NULL, NULL, 4),
(115107, NULL, 'G3DSA:1.10.10.60:FF:000784', NULL, NULL, 'Homeobox protein Hox-C3a', NULL, NULL, NULL, NULL, NULL, 4),
(115108, NULL, 'G3DSA:3.40.50.1240:FF:000059', NULL, NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(115109, NULL, 'G3DSA:1.10.220.30:FF:000022', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(115110, NULL, 'G3DSA:1.10.510.10:FF:001191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115111, NULL, 'G3DSA:2.30.29.70:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115112, NULL, 'G3DSA:3.40.50.300:FF:007214', NULL, NULL, 'DNA replication protein DnaC', NULL, NULL, NULL, NULL, NULL, 4),
(115113, NULL, 'G3DSA:1.20.1740.10:FF:000272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115114, NULL, 'G3DSA:1.20.1460.10:FF:000008', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(115115, NULL, 'G3DSA:3.30.460.10:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115116, NULL, 'G3DSA:2.10.25.10:FF:000874', NULL, NULL, 'Thrombomodulin', NULL, NULL, NULL, NULL, NULL, 4),
(115117, NULL, 'G3DSA:3.30.450.60:FF:000019', NULL, NULL, 'Coatomer subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(115118, NULL, 'G3DSA:3.20.20.100:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115119, NULL, 'G3DSA:1.10.285.10:FF:000008', NULL, NULL, 'Glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(115120, NULL, 'G3DSA:3.30.50.10:FF:000154', NULL, NULL, 'DGATAe protein', NULL, NULL, NULL, NULL, NULL, 4),
(115121, NULL, 'G3DSA:3.40.50.970:FF:000125', NULL, NULL, '2-oxoacid:ferredoxin oxidoreductase, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(115122, NULL, 'G3DSA:1.25.10.10:FF:003153', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(115123, NULL, 'G3DSA:2.20.25.530:FF:000004', NULL, NULL, 'Ribonuclease H2 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(115124, NULL, 'G3DSA:3.20.20.80:FF:000286', NULL, NULL, 'Chondroitin proteoglycan 2', NULL, NULL, NULL, NULL, NULL, 4),
(115125, NULL, 'G3DSA:3.10.20.30:FF:000035', NULL, NULL, 'Electron transfer protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115126, NULL, 'G3DSA:1.10.220.150:FF:000016', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(115127, NULL, 'G3DSA:1.10.510.10:FF:001775', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115128, NULL, 'G3DSA:3.30.420.10:FF:000070', NULL, NULL, 'DNA polymerase nu', NULL, NULL, NULL, NULL, NULL, 4),
(115129, NULL, 'G3DSA:1.10.630.10:FF:000750', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115130, NULL, 'G3DSA:2.30.18.10:FF:000008', NULL, NULL, 'Transcription factor TFIIA complex large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(115131, NULL, 'G3DSA:3.40.50.12370:FF:000002', NULL, NULL, 'Cation/H(+) antiporter 14', NULL, NULL, NULL, NULL, NULL, 4),
(115132, NULL, 'G3DSA:2.130.10.10:FF:001751', NULL, NULL, 'GM17824', NULL, NULL, NULL, NULL, NULL, 4),
(115133, NULL, 'G3DSA:1.10.472.80:FF:000234', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115134, NULL, 'G3DSA:2.20.70.10:FF:000208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115135, NULL, 'G3DSA:3.40.50.960:FF:000009', NULL, NULL, '6,7-dimethyl-8-ribityllumazine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(115136, NULL, 'G3DSA:3.40.1190.10:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(115137, NULL, 'G3DSA:2.20.70.10:FF:000197', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-36 specific', NULL, NULL, NULL, NULL, NULL, 4),
(115138, NULL, 'G3DSA:3.40.50.300:FF:001812', NULL, NULL, 'C4-dicarboxylate transport transcriptional regulatory protein DctD', NULL, NULL, NULL, NULL, NULL, 4),
(115139, NULL, 'G3DSA:2.10.50.10:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115140, NULL, 'G3DSA:2.30.29.30:FF:001102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115141, NULL, 'G3DSA:3.60.10.10:FF:000257', NULL, NULL, 'Endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(115142, NULL, 'G3DSA:1.20.1250.20:FF:002339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115143, NULL, 'G3DSA:2.40.50.100:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115144, NULL, 'G3DSA:3.40.50.720:FF:001702', NULL, NULL, 'Phosphoglycerate dehydrogenase SerA2-putative NAD-dependent 2-hydroxyacid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(115145, NULL, 'G3DSA:3.30.70.270:FF:000056', NULL, NULL, 'Sister chromatid cohesion protein Eso1', NULL, NULL, NULL, NULL, NULL, 4),
(115146, NULL, 'G3DSA:3.80.10.10:FF:004472', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(115147, NULL, 'G3DSA:1.10.540.10:FF:000080', NULL, NULL, 'Probable acyl-coA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(115148, NULL, 'G3DSA:3.40.50.300:FF:003960', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(115149, NULL, 'G3DSA:3.30.200.20:FF:000871', NULL, NULL, 'G2-specific protein kinase nimA', NULL, NULL, NULL, NULL, NULL, 4),
(115150, NULL, 'G3DSA:1.10.1760.20:FF:000008', NULL, NULL, 'Substrate-specific component NiaX of predicted niacin ECF transporter', NULL, NULL, NULL, NULL, NULL, 4),
(115151, NULL, 'G3DSA:1.20.1640.10:FF:000106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115152, NULL, 'G3DSA:3.30.1490.20:FF:000003', NULL, NULL, 'acetyl-CoA carboxylase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(115153, NULL, 'G3DSA:3.30.200.20:FF:000186', NULL, NULL, 'Serine/threonine-protein kinase PBS1', NULL, NULL, NULL, NULL, NULL, 4),
(115154, NULL, 'G3DSA:1.20.5.110:FF:000312', NULL, NULL, 'syntaxin-17-like', NULL, NULL, NULL, NULL, NULL, 4),
(115155, NULL, 'G3DSA:2.30.40.10:FF:000178', NULL, NULL, 'Gll3395 protein', NULL, NULL, NULL, NULL, NULL, 4),
(115156, NULL, 'G3DSA:3.40.50.2300:FF:000287', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(115157, NULL, 'G3DSA:3.40.50.12390:FF:000008', NULL, NULL, 'XRN 5''-3'' exonuclease N-terminus, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115158, NULL, 'G3DSA:1.20.1280.20:FF:000014', NULL, NULL, 'J-type chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(115159, NULL, 'G3DSA:2.60.40.150:FF:000051', NULL, NULL, 'Synaptotagmin 11', NULL, NULL, NULL, NULL, NULL, 4),
(115160, NULL, 'G3DSA:2.10.110.10:FF:000285', NULL, NULL, 'LIM-domain containing phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(115161, NULL, 'G3DSA:3.30.9.10:FF:000047', NULL, NULL, 'tRNA 5-methylaminomethyl-2-thiouridine biosynthesis bifunctional protein MnmC', NULL, NULL, NULL, NULL, NULL, 4),
(115162, NULL, 'G3DSA:3.30.590.10:FF:000059', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(115163, NULL, 'G3DSA:3.90.190.10:FF:000240', NULL, NULL, 'Protein CBG16631', NULL, NULL, NULL, NULL, NULL, 4),
(115164, NULL, 'G3DSA:2.30.30.40:FF:000220', NULL, NULL, 'FYN binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(115165, NULL, 'G3DSA:3.30.565.10:FF:000546', NULL, NULL, 'Protein-histidine kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115166, NULL, 'G3DSA:3.40.50.2300:FF:000950', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115167, NULL, 'G3DSA:3.30.230.10:FF:000269', NULL, NULL, 'Diphosphomevalonate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(115168, NULL, 'G3DSA:2.70.98.30:FF:000012', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(115169, NULL, 'G3DSA:3.40.30.10:FF:000534', NULL, NULL, 'Lipoyl synthase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(115170, NULL, 'G3DSA:1.10.472.80:FF:000026', NULL, NULL, 'Mitotic check point protein (Bub2)', NULL, NULL, NULL, NULL, NULL, 4),
(115171, NULL, 'G3DSA:3.40.50.150:FF:001621', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115172, NULL, 'G3DSA:3.30.70.260:FF:000166', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(115173, NULL, 'G3DSA:1.10.10.820:FF:000019', NULL, NULL, 'Unconventional myosin ID', NULL, NULL, NULL, NULL, NULL, 4),
(115174, NULL, 'G3DSA:2.60.120.650:FF:000069', NULL, NULL, 'Lysine demethylase 5A', NULL, NULL, NULL, NULL, NULL, 4),
(115175, NULL, 'G3DSA:1.20.1250.20:FF:000624', NULL, NULL, 'Major facilitator transporter', NULL, NULL, NULL, NULL, NULL, 4),
(115176, NULL, 'G3DSA:1.20.1250.20:FF:001243', NULL, NULL, 'Putative inorganic phosphate cotransporter-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(115177, NULL, 'G3DSA:3.40.50.300:FF:003628', NULL, NULL, 'Si:dkeyp-52c3.7', NULL, NULL, NULL, NULL, NULL, 4),
(115178, NULL, 'G3DSA:1.10.1380.10:FF:000021', NULL, NULL, 'NEPrilysin metallopeptidase family', NULL, NULL, NULL, NULL, NULL, 4),
(115179, NULL, 'G3DSA:1.25.10.10:FF:000859', NULL, NULL, 'Pumilio homolog 24', NULL, NULL, NULL, NULL, NULL, 4),
(115180, NULL, 'G3DSA:1.20.59.10:FF:000004', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(115181, NULL, 'G3DSA:3.30.930.10:FF:000047', NULL, NULL, 'serine--tRNA ligase, mitochondrial isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(115182, NULL, 'G3DSA:1.25.10.10:FF:000404', NULL, NULL, 'AP-3 complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(115183, NULL, 'G3DSA:3.30.1490.40:FF:000009', NULL, NULL, 'SYH1p protein', NULL, NULL, NULL, NULL, NULL, 4),
(115184, NULL, 'G3DSA:2.60.40.10:FF:003813', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115185, NULL, 'G3DSA:1.10.760.10:FF:000074', NULL, NULL, 'Nicotinate dehydrogenase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(115186, NULL, 'G3DSA:3.30.70.330:FF:000434', NULL, NULL, 'Bruno 2, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(115187, NULL, 'G3DSA:2.130.10.10:FF:002829', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115188, NULL, 'G3DSA:2.130.10.10:FF:002717', NULL, NULL, 'Retina aberrant in pattern', NULL, NULL, NULL, NULL, NULL, 4),
(115189, NULL, 'G3DSA:1.10.287.110:FF:000043', NULL, NULL, 'J-domain protein required for chloroplast accumulation response 1', NULL, NULL, NULL, NULL, NULL, 4),
(115190, NULL, 'G3DSA:1.10.10.10:FF:000224', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(115191, NULL, 'G3DSA:1.10.510.10:FF:000460', NULL, NULL, 'Cyclin dependent kinase 19', NULL, NULL, NULL, NULL, NULL, 4),
(115192, NULL, 'G3DSA:3.30.1140.60:FF:000023', NULL, NULL, 'F-actin-capping protein subunit alpha-1', NULL, NULL, NULL, NULL, NULL, 4),
(115193, NULL, 'G3DSA:3.60.40.10:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115194, NULL, 'G3DSA:3.30.70.330:FF:003071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115195, NULL, 'G3DSA:3.30.70.100:FF:000051', NULL, NULL, 'Acylphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(115196, NULL, 'G3DSA:3.50.50.60:FF:000426', NULL, NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(115197, NULL, 'G3DSA:1.25.10.10:FF:001023', NULL, NULL, 'TATA-binding protein interacting (TIP20), putative', NULL, NULL, NULL, NULL, NULL, 4),
(115198, NULL, 'G3DSA:1.25.40.10:FF:004970', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115199, NULL, 'G3DSA:3.30.1360.230:FF:000001', NULL, NULL, 'Suppressor of fused homolog', NULL, NULL, NULL, NULL, NULL, 4),
(115200, NULL, 'G3DSA:1.10.287.130:FF:000049', NULL, NULL, 'C4-dicarboxylate transport sensor protein DctB', NULL, NULL, NULL, NULL, NULL, 4),
(115201, NULL, 'G3DSA:3.80.10.10:FF:001599', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(115202, NULL, 'G3DSA:3.30.70.330:FF:002929', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115203, NULL, 'G3DSA:1.25.40.430:FF:000016', NULL, NULL, 'BUB1 mitotic checkpoint serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(115204, NULL, 'G3DSA:3.30.70.3080:FF:000001', NULL, NULL, 'Trehalose-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(115205, NULL, 'G3DSA:3.30.200.20:FF:001259', NULL, NULL, 'Receptor-like serine/threonine-protein kinase SD1-6', NULL, NULL, NULL, NULL, NULL, 4),
(115206, NULL, 'G3DSA:3.40.50.2000:FF:001035', NULL, NULL, 'AGAP002783-PA', NULL, NULL, NULL, NULL, NULL, 4),
(115207, NULL, 'G3DSA:3.30.40.10:FF:000338', NULL, NULL, 'E3 ubiquitin-protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115208, NULL, 'G3DSA:1.10.10.10:FF:000808', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(115209, NULL, 'G3DSA:3.40.50.300:FF:006826', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(115210, NULL, 'G3DSA:3.40.50.300:FF:003257', NULL, NULL, 'AAA family ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115211, NULL, 'G3DSA:3.30.160.60:FF:006421', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115212, NULL, 'G3DSA:1.25.40.180:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115213, NULL, 'G3DSA:3.40.50.720:FF:002321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115214, NULL, 'G3DSA:3.90.1200.10:FF:000062', NULL, NULL, 'Hydroxylysine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(115215, NULL, 'G3DSA:2.10.25.10:FF:000762', NULL, NULL, 'WNT inhibitory factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(115216, NULL, 'G3DSA:2.60.40.10:FF:001447', NULL, NULL, 'Obscurin like 1', NULL, NULL, NULL, NULL, NULL, 4),
(115217, NULL, 'G3DSA:3.30.70.330:FF:000895', NULL, NULL, 'Hsh49p', NULL, NULL, NULL, NULL, NULL, 4),
(115218, NULL, 'G3DSA:1.20.58.340:FF:000021', NULL, NULL, 'Magnesium and cobalt transporter CorA', NULL, NULL, NULL, NULL, NULL, 4),
(115219, NULL, 'G3DSA:1.25.40.10:FF:003560', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115220, NULL, 'G3DSA:3.30.559.10:FF:000285', NULL, NULL, 'Carnitine O-palmitoyltransferase II, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115221, NULL, 'G3DSA:1.10.510.10:FF:003686', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115222, NULL, 'G3DSA:3.40.50.300:FF:002431', NULL, NULL, 'Repressor protein', NULL, NULL, NULL, NULL, NULL, 4),
(115223, NULL, 'G3DSA:1.10.800.10:FF:000010', NULL, NULL, 'Phenylalanine 4-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(115224, NULL, 'G3DSA:1.25.40.10:FF:000367', NULL, NULL, 'Tetratricopeptide repeat domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(115225, NULL, 'G3DSA:2.40.10.10:FF:000709', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115226, NULL, 'G3DSA:3.30.160.60:FF:001076', NULL, NULL, 'zinc finger protein 697', NULL, NULL, NULL, NULL, NULL, 4),
(115227, NULL, 'G3DSA:3.40.50.150:FF:001745', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115228, NULL, 'G3DSA:3.40.50.800:FF:000102', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(115229, NULL, 'G3DSA:3.30.70.2650:FF:000001', NULL, NULL, 'PaaX domain-containing protein, C-domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(115230, NULL, 'G3DSA:3.40.50.1820:FF:001430', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115231, NULL, 'G3DSA:2.40.350.20:FF:000001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115232, NULL, 'G3DSA:3.30.70.270:FF:000264', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115233, NULL, 'G3DSA:1.20.1560.10:FF:000847', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115234, NULL, 'G3DSA:2.40.30.10:FF:000132', NULL, NULL, 'Translation initiation factor aIF-2', NULL, NULL, NULL, NULL, NULL, 4),
(115235, NULL, 'G3DSA:2.10.25.10:FF:001279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115236, NULL, 'G3DSA:1.10.10.1760:FF:000003', NULL, NULL, '60S ribosomal protein L36', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(115237, NULL, 'G3DSA:1.10.1300.10:FF:000016', NULL, NULL, 'cGMP-specific phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(115238, NULL, 'G3DSA:3.30.160.60:FF:004055', NULL, NULL, 'Zinc finger imprinted 3', NULL, NULL, NULL, NULL, NULL, 4),
(115239, NULL, 'G3DSA:1.25.40.10:FF:004077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115240, NULL, 'G3DSA:3.80.10.10:FF:003853', NULL, NULL, 'PH domain and leucine-rich repeat protein phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(115241, NULL, 'G3DSA:1.20.120.1900:FF:000040', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(115242, NULL, 'G3DSA:3.30.70.1230:FF:000244', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(115243, NULL, 'G3DSA:2.40.50.90:FF:000112', NULL, NULL, 'RING finger protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(115244, NULL, 'G3DSA:2.60.120.260:FF:000514', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(115245, NULL, 'G3DSA:1.10.640.10:FF:000008', NULL, NULL, 'Dual oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(115246, NULL, 'G3DSA:3.40.190.10:FF:000369', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(115247, NULL, 'G3DSA:2.70.130.10:FF:000099', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115248, NULL, 'G3DSA:3.30.70.3030:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115249, NULL, 'G3DSA:1.10.150.460:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115250, NULL, 'G3DSA:1.50.10.10:FF:000104', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(115251, NULL, 'G3DSA:3.40.50.720:FF:000640', NULL, NULL, 'Very-long-chain 3-oxoacyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(115252, NULL, 'G3DSA:1.25.10.10:FF:001832', NULL, NULL, 'Tubulin-specific chaperone D', NULL, NULL, NULL, NULL, NULL, 4),
(115253, NULL, 'G3DSA:1.25.40.10:FF:000232', NULL, NULL, '28S ribosomal protein S27, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(115254, NULL, 'G3DSA:6.10.140.2160:FF:000001', NULL, NULL, 'Terminase small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(115255, NULL, 'G3DSA:1.25.40.90:FF:000093', NULL, NULL, 'AaceriAEL209Wp', NULL, NULL, NULL, NULL, NULL, 4),
(115256, NULL, 'G3DSA:3.60.90.10:FF:000020', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(115257, NULL, 'G3DSA:1.10.167.10:FF:000015', NULL, NULL, 'Regulator of G-protein signaling 17', NULL, NULL, NULL, NULL, NULL, 4),
(115258, NULL, 'G3DSA:3.40.50.150:FF:000211', NULL, NULL, 'Methyltransferase-like protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(115259, NULL, 'G3DSA:3.30.450.50:FF:000005', NULL, NULL, 'arf-GAP domain and FG repeat-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(115260, NULL, 'G3DSA:1.20.5.50:FF:000009', NULL, NULL, 'Fibrinogen gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(115261, NULL, 'G3DSA:1.25.40.10:FF:003222', NULL, NULL, 'Protein O-mannosyl-transferase TMTC3', NULL, NULL, NULL, NULL, NULL, 4),
(115262, NULL, 'G3DSA:2.130.10.10:FF:005466', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(115263, NULL, 'G3DSA:3.40.525.10:FF:000047', NULL, NULL, 'CRAL/TRIO domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115264, NULL, 'G3DSA:2.130.10.10:FF:001537', NULL, NULL, 'Phosphoinositide 3-kinase regulatory subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(115265, NULL, 'G3DSA:1.10.10.60:FF:001285', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115266, NULL, 'G3DSA:2.60.40.10:FF:003358', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115267, NULL, 'G3DSA:1.10.150.20:FF:000160', NULL, NULL, '5''-3'' exonuclease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(115268, NULL, 'G3DSA:3.40.1370.10:FF:000023', NULL, NULL, 'Ribosomal protein L4/L1 family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115269, NULL, 'G3DSA:2.130.10.10:FF:003437', NULL, NULL, 'Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(115270, NULL, 'G3DSA:3.90.180.10:FF:000071', NULL, NULL, 'NAD-dependent alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(115271, NULL, 'G3DSA:1.20.5.370:FF:000013', NULL, NULL, 'Ligase-interacting factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(115272, NULL, 'G3DSA:3.30.200.20:FF:000995', NULL, NULL, 'PAK4-inhibitor inka2', NULL, NULL, NULL, NULL, NULL, 4),
(115273, NULL, 'G3DSA:3.30.160.60:FF:003330', NULL, NULL, 'C2H2 transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115274, NULL, 'G3DSA:1.10.472.80:FF:000110', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(115275, NULL, 'G3DSA:3.30.420.10:FF:000289', NULL, NULL, 'Exonuclease-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(115276, NULL, 'G3DSA:1.25.40.700:FF:000007', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(115277, NULL, 'G3DSA:1.10.3080.10:FF:000004', NULL, NULL, 'Chloride channel ClC3', NULL, NULL, NULL, NULL, NULL, 4),
(115278, NULL, 'G3DSA:3.30.160.60:FF:001773', NULL, NULL, 'zinc finger protein 827 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(115279, NULL, 'G3DSA:3.30.450.20:FF:000575', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115280, NULL, 'G3DSA:3.30.565.10:FF:000338', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(115281, NULL, 'G3DSA:1.20.5.2210:FF:000007', NULL, NULL, 'ATP synthase F(0) complex subunit B1, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(115282, NULL, 'G3DSA:3.30.40.10:FF:000783', NULL, NULL, 'SWI/SNF family DNA-dependent ATPase Ris1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115283, NULL, 'G3DSA:1.25.10.10:FF:000539', NULL, NULL, 'Exportin-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115284, NULL, 'G3DSA:3.90.190.10:FF:000341', NULL, NULL, 'Kinetoplastid-specific dual specificity phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115285, NULL, 'G3DSA:3.30.360.10:FF:000014', NULL, NULL, 'N-acetyl-gamma-glutamyl-phosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(115286, NULL, 'G3DSA:3.30.160.60:FF:005027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115287, NULL, 'G3DSA:3.10.20.90:FF:000946', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', NULL, NULL, NULL, NULL, NULL, 4),
(115288, NULL, 'G3DSA:3.50.50.60:FF:000218', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] flavoprotein subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(115289, NULL, 'G3DSA:1.10.225.10:FF:000016', NULL, NULL, 'Saposin-related', NULL, NULL, NULL, NULL, NULL, 4),
(115290, NULL, 'G3DSA:2.10.220.10:FF:000046', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5b', NULL, NULL, NULL, NULL, NULL, 4),
(115291, NULL, 'G3DSA:1.10.238.10:FF:000208', NULL, NULL, 'Dual oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(115292, NULL, 'G3DSA:1.10.10.10:FF:000567', NULL, NULL, 'paired box protein Pax-6 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(115293, NULL, 'G3DSA:3.30.40.10:FF:000440', NULL, NULL, 'RING finger and transmembrane domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(115294, NULL, 'G3DSA:3.40.50.300:FF:001594', NULL, NULL, 'Branched-chain-amino-acid aminotransferase-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(115295, NULL, 'G3DSA:1.25.40.990:FF:000049', NULL, NULL, 'AaceriAGL315Wp', NULL, NULL, NULL, NULL, NULL, 4),
(115296, NULL, 'G3DSA:3.30.70.141:FF:000030', NULL, NULL, 'Nucleoside diphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(115297, NULL, 'G3DSA:1.20.1270.10:FF:000084', NULL, NULL, 'Chaperone protein DnaK', NULL, NULL, NULL, NULL, NULL, 4),
(115298, NULL, 'G3DSA:3.80.10.10:FF:002217', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', NULL, NULL, NULL, NULL, NULL, 4),
(115299, NULL, 'G3DSA:3.40.50.300:FF:005966', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115300, NULL, 'G3DSA:1.10.287.130:FF:000133', NULL, NULL, 'Sensory box sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(115301, NULL, 'G3DSA:3.40.50.1820:FF:000345', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(115302, NULL, 'G3DSA:1.20.920.10:FF:000112', NULL, NULL, 'Bromodomain and WD repeat-containing DDB_G0285837', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(115303, NULL, 'G3DSA:1.20.1280.50:FF:000118', NULL, NULL, 'GD22710', NULL, NULL, NULL, NULL, NULL, 4),
(115304, NULL, 'G3DSA:2.40.50.140:FF:001274', NULL, NULL, 'Telomere-binding protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(115305, NULL, 'G3DSA:3.40.50.300:FF:006242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115306, NULL, 'G3DSA:3.40.50.150:FF:001380', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115307, NULL, 'G3DSA:1.20.1110.10:FF:000252', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115308, NULL, 'G3DSA:1.10.357.120:FF:000001', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(115309, NULL, 'G3DSA:3.40.50.1820:FF:000924', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115310, NULL, 'G3DSA:1.25.40.10:FF:000575', NULL, NULL, 'Pre-mRNA-splicing factor, Crooked neck-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(115311, NULL, 'G3DSA:2.60.20.10:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115312, NULL, 'G3DSA:3.40.50.300:FF:003049', NULL, NULL, 'Fungal_tRNA_ligase_phosphodiesterase_domain_conta ining_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(115313, NULL, 'G3DSA:3.40.50.2300:FF:000742', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115314, NULL, 'G3DSA:1.20.1250.20:FF:000074', NULL, NULL, 'Nucleoside transporter yegT', NULL, NULL, NULL, NULL, NULL, 4),
(115315, NULL, 'G3DSA:3.30.420.10:FF:000401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115316, NULL, 'G3DSA:3.30.1380.20:FF:000012', NULL, NULL, 'Trafficking protein particle complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(115317, NULL, 'G3DSA:2.130.10.10:FF:001296', NULL, NULL, 'Unplaced genomic scaffold supercont1.219, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(115318, NULL, 'G3DSA:3.80.10.10:FF:001700', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115319, NULL, 'G3DSA:2.40.30.20:FF:000034', NULL, NULL, 'ATP synthase subunit alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(115320, NULL, 'G3DSA:3.30.1520.20:FF:000001', NULL, NULL, 'Exodeoxyribonuclease I', NULL, NULL, NULL, NULL, NULL, 4),
(115321, NULL, 'G3DSA:2.40.10.10:FF:000586', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115322, NULL, 'G3DSA:2.60.40.10:FF:005258', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115323, NULL, 'G3DSA:3.20.20.80:FF:000162', NULL, NULL, 'Cell wall alpha-1,3-glucan synthase mok12', NULL, NULL, NULL, NULL, NULL, 4),
(115324, NULL, 'G3DSA:2.60.40.420:FF:000267', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(115325, NULL, 'G3DSA:2.130.10.10:FF:004847', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115326, NULL, 'G3DSA:3.30.559.30:FF:000032', NULL, NULL, 'Aspergillus niger contig An11c0010, genomic contig', NULL, NULL, NULL, NULL, NULL, 4),
(115327, NULL, 'G3DSA:1.25.50.20:FF:000073', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(115328, NULL, 'G3DSA:3.40.50.1820:FF:001773', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(115329, NULL, 'G3DSA:1.25.10.10:FF:003277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115330, NULL, 'G3DSA:1.25.10.10:FF:001719', NULL, NULL, 'AGAP011454-PA', NULL, NULL, NULL, NULL, NULL, 4),
(115331, NULL, 'G3DSA:3.90.1150.10:FF:000517', NULL, NULL, 'Lallo-threonine aldolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115332, NULL, 'G3DSA:3.40.30.10:FF:001254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115333, NULL, 'G3DSA:3.30.160.70:FF:000005', NULL, NULL, 'Methylated-DNA--protein-cysteine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(115334, NULL, 'G3DSA:3.40.50.150:FF:000109', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(115335, NULL, 'G3DSA:3.40.50.300:FF:002532', NULL, NULL, 'DEAD/H-box helicase 11', NULL, NULL, NULL, NULL, NULL, 4),
(115336, NULL, 'G3DSA:3.10.129.10:FF:000228', NULL, NULL, 'Fatty acid synthetase beta subunit, putative (JCVI)', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(115337, NULL, 'G3DSA:3.40.50.720:FF:000185', NULL, NULL, 'peroxisomal multifunctional enzyme type 2', NULL, NULL, NULL, NULL, NULL, 4),
(115338, NULL, 'G3DSA:2.10.110.10:FF:000055', NULL, NULL, 'Actin binding LIM protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(115339, NULL, 'G3DSA:3.40.50.300:FF:005180', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(115340, NULL, 'G3DSA:3.40.50.620:FF:000037', NULL, NULL, 'Glutamine--tRNA ligase cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(115341, NULL, 'G3DSA:3.30.750.44:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115342, NULL, 'G3DSA:3.90.190.10:FF:000009', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase beta', NULL, NULL, NULL, NULL, NULL, 4),
(115343, NULL, 'G3DSA:3.80.10.10:FF:000076', NULL, NULL, 'protein lap4 isoform X23', NULL, NULL, NULL, NULL, NULL, 4),
(115344, NULL, 'G3DSA:3.10.110.10:FF:000192', NULL, NULL, 'Ubiquitin-binding ESCRT-I subunit protein', NULL, NULL, NULL, NULL, NULL, 4),
(115345, NULL, 'G3DSA:3.90.1480.20:FF:000034', NULL, NULL, 'CMP-N-acetylneuraminate-beta-galactosamide-alpha-2,3-sialyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(115346, NULL, 'G3DSA:2.130.10.30:FF:000115', NULL, NULL, 'Serine/threonine-protein kinase-like protein CCR1', NULL, NULL, NULL, NULL, NULL, 4),
(115347, NULL, 'G3DSA:2.60.220.50:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115348, NULL, 'G3DSA:3.40.47.10:FF:000174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115349, NULL, 'G3DSA:1.25.40.10:FF:003801', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(115350, NULL, 'G3DSA:1.10.10.410:FF:000003', NULL, NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit E', NULL, NULL, NULL, NULL, NULL, 4),
(115351, NULL, 'G3DSA:2.60.120.200:FF:000631', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115352, NULL, 'G3DSA:3.40.50.300:FF:007203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115353, NULL, 'G3DSA:1.10.10.10:FF:001747', NULL, NULL, 'YALI0F20724p', NULL, NULL, NULL, NULL, NULL, 4),
(115354, NULL, 'G3DSA:3.30.70.330:FF:002452', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115355, NULL, 'G3DSA:1.10.1740.10:FF:000010', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(115356, NULL, 'G3DSA:3.40.50.300:FF:006585', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115357, NULL, 'G3DSA:3.30.70.120:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115358, NULL, 'G3DSA:1.10.533.10:FF:000288', NULL, NULL, 'I Kappa B homolog', NULL, NULL, NULL, NULL, NULL, 4),
(115359, NULL, 'G3DSA:3.40.50.10330:FF:000071', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(115360, NULL, 'G3DSA:3.40.50.300:FF:002190', NULL, NULL, 'ABC transporter B family member 5', NULL, NULL, NULL, NULL, NULL, 4),
(115361, NULL, 'G3DSA:3.40.50.2000:FF:000658', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(115362, NULL, 'G3DSA:3.90.1860.10:FF:000015', NULL, NULL, 'tRNA-splicing ligase RtcB homolog', NULL, NULL, NULL, NULL, NULL, 4),
(115363, NULL, 'G3DSA:1.20.1050.120:FF:000001', NULL, NULL, 'Fatty acid synthase beta subunit dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(115364, NULL, 'G3DSA:3.30.160.60:FF:004510', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115365, NULL, 'G3DSA:3.40.50.300:FF:004685', NULL, NULL, 'ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115366, NULL, 'G3DSA:3.20.110.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115367, NULL, 'G3DSA:2.60.40.10:FF:004538', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115368, NULL, 'G3DSA:2.70.50.30:FF:000003', NULL, NULL, 'Rho GDP-dissociation inhibitor 1', NULL, NULL, NULL, NULL, NULL, 4),
(115369, NULL, 'G3DSA:1.10.510.10:FF:001432', NULL, NULL, 'Serine/threonine-protein kinase Nek6', NULL, NULL, NULL, NULL, NULL, 4),
(115370, NULL, 'G3DSA:3.30.500.10:FF:000003', NULL, NULL, 'IgG receptor FcRn large subunit p51', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(115371, NULL, 'G3DSA:2.60.120.920:FF:000173', NULL, NULL, 'Ryanodine receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(115372, NULL, 'G3DSA:3.40.50.300:FF:000402', NULL, NULL, 'Ras-related protein Rab-27A', NULL, NULL, NULL, NULL, NULL, 4),
(115373, NULL, 'G3DSA:2.130.10.10:FF:001857', NULL, NULL, 'AGAP000602-PA', NULL, NULL, NULL, NULL, NULL, 4),
(115374, NULL, 'G3DSA:2.60.40.1510:FF:000001', NULL, NULL, 'Integrin alpha V', NULL, NULL, NULL, NULL, NULL, 4),
(115375, NULL, 'G3DSA:2.40.50.140:FF:000768', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115376, NULL, 'G3DSA:2.60.120.330:FF:000215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115377, NULL, 'G3DSA:3.40.30.10:FF:000293', NULL, NULL, 'Maleylacetoacetate isomerase MaiA', NULL, NULL, NULL, NULL, NULL, 4),
(115378, NULL, 'G3DSA:2.30.29.30:FF:001208', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(115379, NULL, 'G3DSA:3.30.450.40:FF:000013', NULL, NULL, 'Sensor histidine kinase YehU', NULL, NULL, NULL, NULL, NULL, 4),
(115380, NULL, 'G3DSA:1.25.10.10:FF:001158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115381, NULL, 'G3DSA:3.90.260.10:FF:000004', NULL, NULL, 'Protein-glutamine gamma-glutamyltransferase 5', NULL, NULL, NULL, NULL, NULL, 4),
(115382, NULL, 'G3DSA:2.130.10.10:FF:005123', NULL, NULL, 'Neurobeachin/beige protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115383, NULL, 'G3DSA:1.20.1280.290:FF:000058', NULL, NULL, 'Sugar efflux transporter for intercellular exchange, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115384, NULL, 'G3DSA:1.10.260.40:FF:000022', NULL, NULL, 'POU domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(115385, NULL, 'G3DSA:2.60.40.10:FF:005819', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115386, NULL, 'G3DSA:1.10.287.70:FF:000733', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115387, NULL, 'G3DSA:3.30.160.60:FF:002610', NULL, NULL, 'Zinc finger protein 732', NULL, NULL, NULL, NULL, NULL, 4),
(115388, NULL, 'G3DSA:3.40.50.720:FF:002085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115389, NULL, 'G3DSA:1.10.510.10:FF:003456', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115390, NULL, 'G3DSA:2.40.50.140:FF:000998', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115391, NULL, 'G3DSA:3.80.10.10:FF:004117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115392, NULL, 'G3DSA:2.40.30.110:FF:000002', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(115393, NULL, 'G3DSA:2.10.25.10:FF:000773', NULL, NULL, 'Mesocentin', NULL, NULL, NULL, NULL, NULL, 4),
(115394, NULL, 'G3DSA:1.10.405.10:FF:000002', NULL, NULL, 'Guanosine nucleotide diphosphate dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(115395, NULL, 'G3DSA:1.20.810.10:FF:000008', NULL, NULL, 'Cytochrome b', NULL, NULL, NULL, NULL, NULL, 4),
(115396, NULL, 'G3DSA:2.60.60.20:FF:000035', NULL, NULL, 'Lipoxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(115397, NULL, 'G3DSA:1.20.58.60:FF:000354', NULL, NULL, 'VAB-10B protein', NULL, NULL, NULL, NULL, NULL, 4),
(115398, NULL, 'G3DSA:1.10.375.10:FF:000004', NULL, NULL, 'Gag polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(115399, NULL, 'G3DSA:3.30.830.10:FF:000112', NULL, NULL, 'Protease, insulinase family/protease, insulinase family', NULL, NULL, NULL, NULL, NULL, 4),
(115400, NULL, 'G3DSA:3.40.50.10420:FF:000007', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(115401, NULL, 'G3DSA:2.60.40.1530:FF:000007', NULL, NULL, 'Integrin subunit alpha 10', NULL, NULL, NULL, NULL, NULL, 4),
(115402, NULL, 'G3DSA:3.30.200.20:FF:000539', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(115403, NULL, 'G3DSA:1.20.1640.10:FF:000005', NULL, NULL, 'Multidrug resistance protein MdtC', NULL, NULL, NULL, NULL, NULL, 4),
(115404, NULL, 'G3DSA:1.20.120.1760:FF:000071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115405, NULL, 'G3DSA:3.30.30.30:FF:000041', NULL, NULL, 'Heat shock protein 110, putative', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(115406, NULL, 'G3DSA:1.25.40.20:FF:001084', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(115407, NULL, 'G3DSA:1.10.238.10:FF:000894', NULL, NULL, 'Mechanosensitive ion channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(115408, NULL, 'G3DSA:1.10.10.10:FF:001404', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(115409, NULL, 'G3DSA:2.10.25.10:FF:001734', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115410, NULL, 'G3DSA:3.40.50.2000:FF:000315', NULL, NULL, 'Glycosyltransferase, group 1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(115411, NULL, 'G3DSA:1.10.268.10:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115412, NULL, 'G3DSA:3.40.50.1220:FF:000053', NULL, NULL, 'Phenylpyruvate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(115413, NULL, 'G3DSA:3.30.70.330:FF:000198', NULL, NULL, 'CUGBP Elav-like family member 6 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(115414, NULL, 'G3DSA:3.40.50.300:FF:001251', NULL, NULL, 'Multidrug resistance protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(115415, NULL, 'G3DSA:1.10.437.10:FF:000008', NULL, NULL, 'Bcl-2-related protein A1', NULL, NULL, NULL, NULL, NULL, 4),
(115416, NULL, 'G3DSA:3.30.2320.80:FF:000009', NULL, NULL, 'Hydrogenase maturation factor HypA', NULL, NULL, NULL, NULL, NULL, 4),
(115417, NULL, 'G3DSA:1.25.40.10:FF:001547', NULL, NULL, 'Pentatricopeptide repeat-containing protein 1, mitochondrial-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(115418, NULL, 'G3DSA:1.10.10.10:FF:001186', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC6', NULL, NULL, NULL, NULL, NULL, 4),
(115419, NULL, 'G3DSA:2.60.40.790:FF:000001', NULL, NULL, 'Nuclear migration protein nudC', NULL, NULL, NULL, NULL, NULL, 4),
(115420, NULL, 'G3DSA:3.90.1380.10:FF:000001', NULL, NULL, 'Threonine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(115421, NULL, 'G3DSA:1.20.1050.10:FF:000185', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(115422, NULL, 'G3DSA:3.40.50.620:FF:000835', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115423, NULL, 'G3DSA:2.30.42.10:FF:000553', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115424, NULL, 'G3DSA:2.130.10.10:FF:002476', NULL, NULL, 'Intraflagellar transport protein 140 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(115425, NULL, 'G3DSA:3.40.720.10:FF:000169', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(115426, NULL, 'G3DSA:2.60.120.200:FF:000070', NULL, NULL, 'Serum amyloid P-component', NULL, NULL, NULL, NULL, NULL, 4),
(115427, NULL, 'G3DSA:3.40.570.10:FF:000011', NULL, NULL, 'Putative endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(115428, NULL, 'G3DSA:1.25.40.70:FF:000014', NULL, NULL, 'Phosphatidylinositol-4-phosphate 3-kinase C2 domain-containing subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(115429, NULL, 'G3DSA:2.60.40.10:FF:003919', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115430, NULL, 'G3DSA:2.10.25.10:FF:001599', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115431, NULL, 'G3DSA:2.60.120.10:FF:000196', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(115432, NULL, 'G3DSA:3.40.50.720:FF:000308', NULL, NULL, 'NEDD8-activating enzyme E1 catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(115433, NULL, 'G3DSA:3.40.220.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115434, NULL, 'G3DSA:3.30.460.10:FF:000078', NULL, NULL, 'Topoisomerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115435, NULL, 'G3DSA:1.20.1560.10:FF:000527', NULL, NULL, 'ABC multidrug transporter mdr4', NULL, NULL, NULL, NULL, NULL, 4),
(115436, NULL, 'G3DSA:2.130.10.10:FF:002818', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115437, NULL, 'G3DSA:1.10.287.310:FF:000002', NULL, NULL, '60S ribosomal protein L35', NULL, NULL, NULL, NULL, NULL, 4),
(115438, NULL, 'G3DSA:2.60.120.260:FF:000059', NULL, NULL, 'Probable allantoicase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(115439, NULL, 'G3DSA:1.50.40.10:FF:000275', NULL, NULL, 'Mitochondrial phosphate carrier 1', NULL, NULL, NULL, NULL, NULL, 4),
(115440, NULL, 'G3DSA:3.30.70.330:FF:001491', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115441, NULL, 'G3DSA:1.20.1440.260:FF:000002', NULL, NULL, 'YALI0F07953p', NULL, NULL, NULL, NULL, NULL, 4),
(115442, NULL, 'G3DSA:3.40.50.150:FF:001048', NULL, NULL, 'Modification methylase', NULL, NULL, NULL, NULL, NULL, 4),
(115443, NULL, 'G3DSA:2.60.40.10:FF:004870', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115444, NULL, 'G3DSA:1.25.40.820:FF:000026', NULL, NULL, 'RNA polymerase II-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(115445, NULL, 'G3DSA:3.30.470.20:FF:000227', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(115446, NULL, 'G3DSA:1.20.91.20:FF:000003', NULL, NULL, 'Complement C4-A', NULL, NULL, NULL, NULL, NULL, 4),
(115447, NULL, 'G3DSA:1.20.120.350:FF:000220', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115448, NULL, 'G3DSA:3.40.50.300:FF:003151', NULL, NULL, 'Mismatch repair protein MSH8, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115449, NULL, 'G3DSA:3.30.160.60:FF:005483', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115450, NULL, 'G3DSA:3.40.30.10:FF:000635', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(115451, NULL, 'G3DSA:2.40.160.120:FF:000030', NULL, NULL, 'Oxysterol binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(115452, NULL, 'G3DSA:1.20.120.350:FF:000225', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115453, NULL, 'G3DSA:2.130.10.10:FF:004842', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115454, NULL, 'G3DSA:3.40.50.300:FF:005753', NULL, NULL, 'DNA replication licensing factor, MCM2/3/5 family', NULL, NULL, NULL, NULL, NULL, 4),
(115455, NULL, 'G3DSA:3.80.10.10:FF:001144', NULL, NULL, 'Leucine rich repeats and death domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(115456, NULL, 'G3DSA:1.20.920.10:FF:000135', NULL, NULL, 'Transcription regulatory protein SNF2', NULL, NULL, NULL, NULL, NULL, 4),
(115457, NULL, 'G3DSA:3.40.395.10:FF:000002', NULL, NULL, 'Putative sentrin-specific protease 5', NULL, NULL, NULL, NULL, NULL, 4),
(115458, NULL, 'G3DSA:2.102.10.10:FF:000050', NULL, NULL, 'Archaeal Rieske-type ferredoxin (Arf)', NULL, NULL, NULL, NULL, NULL, 4),
(115459, NULL, 'G3DSA:3.40.30.10:FF:000079', NULL, NULL, 'UBX domain-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(115460, NULL, 'G3DSA:3.40.50.150:FF:000559', NULL, NULL, 'Proliferating-cell nucleolar antigen p120, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115461, NULL, 'G3DSA:2.60.40.150:FF:000495', NULL, NULL, 'Synaptotagmin-C', NULL, NULL, NULL, NULL, NULL, 4),
(115462, NULL, 'G3DSA:3.80.10.10:FF:000632', NULL, NULL, 'DNA repair protein Rad7, protein', NULL, NULL, NULL, NULL, NULL, 4),
(115463, NULL, 'G3DSA:1.10.1420.10:FF:000188', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(115464, NULL, 'G3DSA:3.40.640.10:FF:000348', NULL, NULL, 'Spore coat polysaccharide biosynthesis proteinSpsC', NULL, NULL, NULL, NULL, NULL, 4),
(115465, NULL, 'G3DSA:3.30.500.40:FF:000001', NULL, NULL, 'Zinc finger, FYVE domain-containing 9a', NULL, NULL, NULL, NULL, NULL, 4),
(115466, NULL, 'G3DSA:2.130.10.10:FF:005354', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115467, NULL, 'G3DSA:3.40.1160.10:FF:000086', NULL, NULL, 'Amino-acid acetyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(115468, NULL, 'G3DSA:2.130.10.10:FF:001065', NULL, NULL, 'Dual oxidase maturation factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115469, NULL, 'G3DSA:2.20.25.20:FF:000017', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(115470, NULL, 'G3DSA:3.30.40.10:FF:002025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115471, NULL, 'G3DSA:1.25.40.10:FF:004633', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(115472, NULL, 'G3DSA:3.90.370.10:FF:000001', NULL, NULL, 'Metalloproteinase inhibitor 3', NULL, NULL, NULL, NULL, NULL, 4),
(115473, NULL, 'G3DSA:2.40.30.10:FF:000475', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115474, NULL, 'G3DSA:3.40.50.2000:FF:000978', NULL, NULL, 'Mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(115475, NULL, 'G3DSA:3.30.420.10:FF:000424', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115476, NULL, 'G3DSA:1.10.472.130:FF:000050', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115477, NULL, 'G3DSA:2.30.30.140:FF:000266', NULL, NULL, 'NuA4 complex subunit EAF3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(115478, NULL, 'G3DSA:1.10.418.10:FF:000200', NULL, NULL, 'Plastin 2 putative', NULL, NULL, NULL, NULL, NULL, 4),
(115479, NULL, 'G3DSA:1.25.40.10:FF:005145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115480, NULL, 'G3DSA:3.30.559.10:FF:000150', NULL, NULL, 'Siderophore peptide synthetase fer3', NULL, NULL, NULL, NULL, NULL, 4),
(115481, NULL, 'G3DSA:2.40.110.10:FF:000020', NULL, NULL, 'Putative acyl-CoA dehydrogenase YdbM', NULL, NULL, NULL, NULL, NULL, 4),
(115482, NULL, 'G3DSA:3.30.70.330:FF:000439', NULL, NULL, 'La-related protein 6 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(115483, NULL, 'G3DSA:3.30.160.60:FF:005932', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115484, NULL, 'G3DSA:3.30.420.40:FF:000860', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115485, NULL, 'G3DSA:3.90.810.10:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115486, NULL, 'G3DSA:1.10.10.60:FF:001161', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115487, NULL, 'G3DSA:3.30.9.10:FF:000036', NULL, NULL, 'Chromosome 15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(115488, NULL, 'G3DSA:4.10.280.10:FF:000076', NULL, NULL, 'hypoxia-inducible factor 3-alpha isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(115489, NULL, 'G3DSA:1.10.472.10:FF:000606', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115490, NULL, 'G3DSA:1.10.287.370:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115491, NULL, 'G3DSA:2.130.10.10:FF:001172', NULL, NULL, 'Histone acetyltransferase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(115492, NULL, 'G3DSA:2.30.29.30:FF:000826', NULL, NULL, 'FACT complex subunit POB3', NULL, NULL, NULL, NULL, NULL, 4),
(115493, NULL, 'G3DSA:2.30.40.10:FF:000167', NULL, NULL, 'Guanine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(115494, NULL, 'G3DSA:2.20.130.20:FF:000006', NULL, NULL, 'Alpha-2-macroglobulin', NULL, NULL, NULL, NULL, NULL, 4),
(115495, NULL, 'G3DSA:2.60.220.30:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115496, NULL, 'G3DSA:2.60.40.10:FF:003341', NULL, NULL, 'Plexin b1a', NULL, NULL, NULL, NULL, NULL, 4),
(115497, NULL, 'G3DSA:2.60.200.40:FF:000020', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(115498, NULL, 'G3DSA:2.30.29.30:FF:000820', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(115499, NULL, 'G3DSA:3.40.80.10:FF:000032', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(115500, NULL, 'G3DSA:3.40.50.1000:FF:000566', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115501, NULL, 'G3DSA:1.10.10.410:FF:000008', NULL, NULL, 'Aspartyl-glutamyl-tRNA amidotransferase subunit B protein', NULL, NULL, NULL, NULL, NULL, 4),
(115502, NULL, 'G3DSA:1.10.30.10:FF:000113', NULL, NULL, 'GH11850p', NULL, NULL, NULL, NULL, NULL, 4),
(115503, NULL, 'G3DSA:1.25.40.180:FF:000025', NULL, NULL, 'MIF4G domain containing a', NULL, NULL, NULL, NULL, NULL, 4),
(115504, NULL, 'G3DSA:1.10.238.10:FF:000888', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115505, NULL, 'G3DSA:1.10.238.10:FF:000102', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(115506, NULL, 'G3DSA:2.60.120.200:FF:000524', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115507, NULL, 'G3DSA:3.40.50.2300:FF:000973', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115508, NULL, 'G3DSA:2.60.220.50:FF:000018', NULL, NULL, 'Adhesion G protein-coupled receptor G6', NULL, NULL, NULL, NULL, NULL, 4),
(115509, NULL, 'G3DSA:2.20.25.10:FF:000121', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(115510, NULL, 'G3DSA:1.25.40.470:FF:000005', NULL, NULL, 'Intraflagellar transport protein 122 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(115511, NULL, 'G3DSA:1.10.4020.10:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115512, NULL, 'G3DSA:3.40.1110.10:FF:000482', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115513, NULL, 'G3DSA:3.40.140.10:FF:000097', NULL, NULL, 'Cytidine deaminase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(115514, NULL, 'G3DSA:3.80.10.10:FF:001251', NULL, NULL, 'Leucine rich repeats (6 copies)/Leucine Rich repeat', NULL, NULL, NULL, NULL, NULL, 4),
(115515, NULL, 'G3DSA:3.30.2160.10:FF:000049', NULL, NULL, 'E3 ubiquitin-protein ligase UPL1', NULL, NULL, NULL, NULL, NULL, 4),
(115516, NULL, 'G3DSA:3.30.160.60:FF:001750', NULL, NULL, 'Zinc finger protein 222', NULL, NULL, NULL, NULL, NULL, 4),
(115517, NULL, 'G3DSA:2.70.160.11:FF:000034', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(115518, NULL, 'G3DSA:3.40.50.720:FF:000409', NULL, NULL, 'NADPH HC toxin reductase', NULL, NULL, NULL, NULL, NULL, 4),
(115519, NULL, 'G3DSA:3.90.1210.10:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115520, NULL, 'G3DSA:1.10.3470.10:FF:000034', NULL, NULL, 'Iron ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(115521, NULL, 'G3DSA:2.60.120.200:FF:000417', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115522, NULL, 'G3DSA:2.60.40.1530:FF:000013', NULL, NULL, 'Integrin alpha 4', NULL, NULL, NULL, NULL, NULL, 4),
(115523, NULL, 'G3DSA:3.20.20.70:FF:000625', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115524, NULL, 'G3DSA:3.40.220.10:FF:000024', NULL, NULL, 'Probable cytosol aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(115525, NULL, 'G3DSA:3.40.50.12780:FF:000131', NULL, NULL, 'Acyl-CoA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(115526, NULL, 'G3DSA:2.130.10.10:FF:005247', NULL, NULL, 'Uncharacterized WD repeat-containing protein C3D6.12', NULL, NULL, NULL, NULL, NULL, 4),
(115527, NULL, 'G3DSA:1.20.1080.10:FF:000029', NULL, NULL, 'Aquaporin NIP1-1', NULL, NULL, NULL, NULL, NULL, 4),
(115528, NULL, 'G3DSA:3.40.1390.30:FF:000013', NULL, NULL, 'GTP cyclohydrolase 1 type 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(115529, NULL, 'G3DSA:3.30.710.10:FF:000165', NULL, NULL, 'Blast:Protein jim lovell', NULL, NULL, NULL, NULL, NULL, 4),
(115530, NULL, 'G3DSA:1.20.58.390:FF:000002', NULL, NULL, 'Putative gamma-aminobutyric acid receptor subunit alpha-5', NULL, NULL, NULL, NULL, NULL, 4),
(115531, NULL, 'G3DSA:3.10.410.10:FF:000001', NULL, NULL, 'Putative formate--tetrahydrofolate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(115532, NULL, 'G3DSA:2.170.140.10:FF:000053', NULL, NULL, 'Obstructor-J', NULL, NULL, NULL, NULL, NULL, 4),
(115533, NULL, 'G3DSA:3.40.50.720:FF:001944', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115534, NULL, 'G3DSA:3.30.160.60:FF:003785', NULL, NULL, 'Ras-responsive element-binding protein 1b', NULL, NULL, NULL, NULL, NULL, 4),
(115535, NULL, 'G3DSA:1.20.1270.280:FF:000025', NULL, NULL, 'Putative dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(115536, NULL, 'G3DSA:3.40.50.300:FF:002987', NULL, NULL, 'RecBCD enzyme subunit RecD', NULL, NULL, NULL, NULL, NULL, 4),
(115537, NULL, 'G3DSA:2.60.40.420:FF:000036', NULL, NULL, 'L-ascorbate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(115538, NULL, 'G3DSA:1.10.20.10:FF:000287', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115539, NULL, 'G3DSA:3.30.70.330:FF:000872', NULL, NULL, 'Npl3p', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(115540, NULL, 'G3DSA:2.60.40.150:FF:000500', NULL, NULL, 'synaptotagmin-7', NULL, NULL, NULL, NULL, NULL, 4),
(115541, NULL, 'G3DSA:2.60.40.60:FF:000017', NULL, NULL, 'Cadherin 24', NULL, NULL, NULL, NULL, NULL, 4),
(115542, NULL, 'G3DSA:3.30.710.10:FF:000272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115543, NULL, 'G3DSA:3.40.50.410:FF:000204', NULL, NULL, 'ATP-dependent DNA helicase II subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(115544, NULL, 'G3DSA:1.20.900.10:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115545, NULL, 'G3DSA:3.30.499.10:FF:000004', NULL, NULL, 'Aconitate hydratase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(115546, NULL, 'G3DSA:3.40.50.720:FF:002326', NULL, NULL, 'glyoxylate reductase/hydroxypyruvate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(115547, NULL, 'G3DSA:3.40.50.10330:FF:000076', NULL, NULL, 'Inorganic polyphosphate/ATP-NAD kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115548, NULL, 'G3DSA:3.20.20.70:FF:000518', NULL, NULL, 'Tungsten-containing aldehyde ferredoxin oxidoreductase cofactor modifying protein', NULL, NULL, NULL, NULL, NULL, 4),
(115549, NULL, 'G3DSA:2.40.100.10:FF:000087', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(115550, NULL, 'G3DSA:3.40.720.10:FF:000068', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(115551, NULL, 'G3DSA:3.30.160.60:FF:003678', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115552, NULL, 'G3DSA:1.10.510.10:FF:001533', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(115553, NULL, 'G3DSA:1.20.1560.10:FF:000504', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115554, NULL, 'G3DSA:1.10.238.10:FF:000995', NULL, NULL, 'Defective in cullin neddylation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(115555, NULL, 'G3DSA:1.10.8.960:FF:000001', NULL, NULL, 'Glutamate--cysteine ligase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(115556, NULL, 'G3DSA:1.20.1330.10:FF:000010', NULL, NULL, 'Flagellin', NULL, NULL, NULL, NULL, NULL, 4),
(115557, NULL, 'G3DSA:2.60.420.10:FF:000016', NULL, NULL, 'Cyclic beta 1-2 glucan synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(115558, NULL, 'G3DSA:2.130.10.10:FF:002369', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(115559, NULL, 'G3DSA:2.60.40.10:FF:001424', NULL, NULL, 'Triggering receptor expressed on myeloid cells like 1', NULL, NULL, NULL, NULL, NULL, 4),
(115560, NULL, 'G3DSA:3.40.50.2000:FF:000074', NULL, NULL, 'Alpha-(1-2)-phosphatidylinositol mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(115561, NULL, 'G3DSA:3.30.230.10:FF:000027', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(115562, NULL, 'G3DSA:1.10.472.10:FF:000713', NULL, NULL, 'G2/M mitosis-specific cyclin B, copy C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(115563, NULL, 'G3DSA:3.40.50.12780:FF:000024', NULL, NULL, 'Nonribosomal siderophore peptide synthase SidC', NULL, NULL, NULL, NULL, NULL, 4),
(115564, NULL, 'G3DSA:3.40.1770.10:FF:000003', NULL, NULL, 'Urocanate hydratase 1', NULL, NULL, NULL, NULL, NULL, 4),
(115565, NULL, 'G3DSA:2.60.120.10:FF:000090', NULL, NULL, 'Sodium/hydrogen exchanger 7', NULL, NULL, NULL, NULL, NULL, 4),
(115566, NULL, 'G3DSA:2.80.10.50:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115567, NULL, 'G3DSA:3.80.10.10:FF:002993', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115568, NULL, 'G3DSA:1.10.10.10:FF:000011', NULL, NULL, 'Phosphate regulon transcriptional regulator PhoB', NULL, NULL, NULL, NULL, NULL, 4),
(115569, NULL, 'G3DSA:1.10.510.10:FF:002837', NULL, NULL, 'Serine/threonine-protein kinase B', NULL, NULL, NULL, NULL, NULL, 4),
(115570, NULL, 'G3DSA:3.40.50.300:FF:002768', NULL, NULL, 'ATP-dependent DEAD/H RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115571, NULL, 'G3DSA:1.20.140.10:FF:000053', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(115572, NULL, 'G3DSA:1.25.70.10:FF:000060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115573, NULL, 'G3DSA:2.60.40.1970:FF:000010', NULL, NULL, 'YEATS family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115574, NULL, 'G3DSA:2.30.180.10:FF:000015', NULL, NULL, 'Fasciclin-like arabinogalactan protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(115575, NULL, 'G3DSA:1.20.1250.20:FF:001479', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115576, NULL, 'G3DSA:1.20.5.110:FF:000177', NULL, NULL, 'Tetratricopeptide repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(115577, NULL, 'G3DSA:1.20.5.320:FF:000015', NULL, NULL, 'Fibritin', NULL, NULL, NULL, NULL, NULL, 4),
(115578, NULL, 'G3DSA:1.10.510.10:FF:002949', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115579, NULL, 'G3DSA:3.40.50.1260:FF:000031', NULL, NULL, 'Phosphoglycerate kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(115580, NULL, 'G3DSA:2.80.10.50:FF:000242', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(115581, NULL, 'G3DSA:2.60.210.10:FF:000079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115582, NULL, 'G3DSA:3.40.1390.20:FF:000016', NULL, NULL, 'Inorganic pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(115583, NULL, 'G3DSA:2.40.30.10:FF:000368', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(115584, NULL, 'G3DSA:3.40.50.1820:FF:000570', NULL, NULL, 'At5g44250', NULL, NULL, NULL, NULL, NULL, 4),
(115585, NULL, 'G3DSA:3.40.850.10:FF:000274', NULL, NULL, 'Kinesin-like protein KIF7', NULL, NULL, NULL, NULL, NULL, 4),
(115586, NULL, 'G3DSA:3.10.110.10:FF:000298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115587, NULL, 'G3DSA:3.30.160.60:FF:005128', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115588, NULL, 'G3DSA:4.10.400.10:FF:000070', NULL, NULL, 'low-density lipoprotein receptor-related protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(115589, NULL, 'G3DSA:3.30.930.10:FF:000159', NULL, NULL, 'Octanoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(115590, NULL, 'G3DSA:3.40.50.300:FF:001571', NULL, NULL, 'Deoxynucleoside kinase', NULL, NULL, NULL, NULL, NULL, 4),
(115591, NULL, 'G3DSA:1.50.40.10:FF:000516', NULL, NULL, 'Uncharacterized mitochondrial carrier C8C9.12c', NULL, NULL, NULL, NULL, NULL, 4),
(115592, NULL, 'G3DSA:3.90.320.10:FF:000066', NULL, NULL, 'Chromosome 15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(115593, NULL, 'G3DSA:2.30.30.40:FF:000001', NULL, NULL, 'Sorbin and SH3 domain-containing protein 1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(115594, NULL, 'G3DSA:1.25.10.10:FF:000646', NULL, NULL, 'HEAT repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(115595, NULL, 'G3DSA:3.40.980.10:FF:000042', NULL, NULL, 'Putative molybdopterin biosynthesis protein MJ0666', NULL, NULL, NULL, NULL, NULL, 4),
(115596, NULL, 'G3DSA:3.50.50.60:FF:000538', NULL, NULL, 'Ferredoxin--NADP reductase', NULL, NULL, NULL, NULL, NULL, 4),
(115597, NULL, 'G3DSA:3.40.50.1820:FF:001082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115598, NULL, 'G3DSA:1.25.10.10:FF:001135', NULL, NULL, 'Protein CBG10339', NULL, NULL, NULL, NULL, NULL, 4),
(115599, NULL, 'G3DSA:3.40.30.10:FF:000186', NULL, NULL, 'Thioredoxin-like protein AAED1', NULL, NULL, NULL, NULL, NULL, 4),
(115600, NULL, 'G3DSA:1.20.1070.10:FF:000771', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115601, NULL, 'G3DSA:3.40.50.2000:FF:000293', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115602, NULL, 'G3DSA:3.40.50.300:FF:002083', NULL, NULL, 'Nicotinamide riboside kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(115603, NULL, 'G3DSA:2.60.40.150:FF:000388', NULL, NULL, 'Myosin light chain kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115604, NULL, 'G3DSA:3.30.200.20:FF:001141', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(115605, NULL, 'G3DSA:1.20.120.310:FF:000005', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(115606, NULL, 'G3DSA:2.60.220.50:FF:000148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115607, NULL, 'G3DSA:1.10.630.10:FF:000171', NULL, NULL, 'Putative cytochrome P450 128', NULL, NULL, NULL, NULL, NULL, 4),
(115608, NULL, 'G3DSA:3.10.110.10:FF:000309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115609, NULL, 'G3DSA:3.40.1110.10:FF:000370', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115610, NULL, 'G3DSA:3.40.50.12620:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115611, NULL, 'G3DSA:2.130.10.10:FF:004735', NULL, NULL, 'EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(115612, NULL, 'G3DSA:3.40.50.300:FF:003499', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(115613, NULL, 'G3DSA:3.10.20.230:FF:000016', NULL, NULL, 'Serine/threonine-protein kinase DCLK1', NULL, NULL, NULL, NULL, NULL, 4),
(115614, NULL, 'G3DSA:1.25.40.10:FF:002267', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g26460, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(115615, NULL, 'G3DSA:2.60.40.10:FF:005590', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115616, NULL, 'G3DSA:3.30.70.120:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115617, NULL, 'G3DSA:1.25.40.20:FF:000128', NULL, NULL, 'short transient receptor potential channel 5', NULL, NULL, NULL, NULL, NULL, 4),
(115618, NULL, 'G3DSA:2.60.260.20:FF:000147', NULL, NULL, 'DnaJ-like subfamily B member 1', NULL, NULL, NULL, NULL, NULL, 4),
(115619, NULL, 'G3DSA:3.40.50.2000:FF:000079', NULL, NULL, 'Trehalose-6-phosphate synthase 8', NULL, NULL, NULL, NULL, NULL, 4),
(115620, NULL, 'G3DSA:1.10.418.10:FF:000088', NULL, NULL, 'Alpha-actinin, sarcomeric', NULL, NULL, NULL, NULL, NULL, 4),
(115621, NULL, 'G3DSA:1.20.1250.20:FF:002103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115622, NULL, 'G3DSA:3.30.200.20:FF:002552', NULL, NULL, 'Os11g0691300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(115623, NULL, 'G3DSA:1.10.10.10:FF:000466', NULL, NULL, 'Z-DNA binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(115624, NULL, 'G3DSA:2.40.240.20:FF:000010', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4),
(115625, NULL, 'G3DSA:1.20.5.350:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115626, NULL, 'G3DSA:3.30.470.10:FF:000028', NULL, NULL, 'Aminodeoxychorismate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(115627, NULL, 'G3DSA:2.20.25.690:FF:000001', NULL, NULL, 'Tripeptidyl-peptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(115628, NULL, 'G3DSA:3.30.450.20:FF:000451', NULL, NULL, 'Calcium channel, voltage-dependent, alpha 2/delta subunit 2b', NULL, NULL, NULL, NULL, NULL, 4),
(115629, NULL, 'G3DSA:3.40.50.720:FF:001028', NULL, NULL, 'Glucose-6-phosphate 1-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(115630, NULL, 'G3DSA:2.130.10.10:FF:005224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115631, NULL, 'G3DSA:3.30.40.10:FF:001513', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115632, NULL, 'G3DSA:1.20.1250.20:FF:002092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115633, NULL, 'G3DSA:3.30.70.330:FF:001384', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(115634, NULL, 'G3DSA:3.10.450.10:FF:000003', NULL, NULL, 'Cathelicidin antimicrobial peptide', NULL, NULL, NULL, NULL, NULL, 4),
(115635, NULL, 'G3DSA:1.10.510.10:FF:003349', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115636, NULL, 'G3DSA:3.20.20.70:FF:000406', NULL, NULL, 'Pyridoxal 5''-phosphate synthase subunit PdxS', NULL, NULL, NULL, NULL, NULL, 4),
(115637, NULL, 'G3DSA:3.40.50.1170:FF:000004', NULL, NULL, 'L-asparaginase, type I', NULL, NULL, NULL, NULL, NULL, 4),
(115638, NULL, 'G3DSA:1.10.3380.30:FF:000033', NULL, NULL, 'ATP-dependent DNA helicase Hel308', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(115639, NULL, 'G3DSA:2.30.30.100:FF:000046', NULL, NULL, 'RNA-binding protein Hfq', NULL, NULL, NULL, NULL, NULL, 4),
(115640, NULL, 'G3DSA:1.10.238.10:FF:000214', NULL, NULL, 'Calcium-binding protein CML42', NULL, NULL, NULL, NULL, NULL, 4),
(115641, NULL, 'G3DSA:3.40.50.2020:FF:000181', NULL, NULL, 'AER083Cp', NULL, NULL, NULL, NULL, NULL, 4),
(115642, NULL, 'G3DSA:3.30.160.60:FF:001880', NULL, NULL, 'zinc finger protein 69 homolog isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(115643, NULL, 'G3DSA:3.30.70.270:FF:000051', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(115644, NULL, 'G3DSA:1.10.8.500:FF:000009', NULL, NULL, 'HAMP domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(115645, NULL, 'G3DSA:3.40.50.300:FF:001138', NULL, NULL, 'Structural maintenance of chromosomes protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(115646, NULL, 'G3DSA:2.60.40.10:FF:001205', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase O', NULL, NULL, NULL, NULL, NULL, 4),
(115647, NULL, 'G3DSA:2.20.70.10:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115648, NULL, 'G3DSA:1.20.5.10:FF:000003', NULL, NULL, 'Adenomatous polyposis coli protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(115649, NULL, 'G3DSA:1.10.510.10:FF:002152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115650, NULL, 'G3DSA:1.20.1070.10:FF:001260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115651, NULL, 'G3DSA:2.120.10.80:FF:000417', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115652, NULL, 'G3DSA:1.10.472.80:FF:000239', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115653, NULL, 'G3DSA:3.10.250.10:FF:000022', NULL, NULL, 'lysyl oxidase homolog 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(115654, NULL, 'G3DSA:3.30.160.60:FF:003566', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115655, NULL, 'G3DSA:3.30.450.70:FF:000005', NULL, NULL, 'Trafficking protein particle complex subunit 2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(115656, NULL, 'G3DSA:1.25.40.180:FF:000020', NULL, NULL, 'Eukaryotic translation initiation factor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(115657, NULL, 'G3DSA:3.80.10.10:FF:001032', NULL, NULL, 'Os06g0557100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(115658, NULL, 'G3DSA:1.20.1440.240:FF:000002', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(115659, NULL, 'G3DSA:3.30.310.220:FF:000001', NULL, NULL, 'Probable serine/threonine-protein kinase KCC4', NULL, NULL, NULL, NULL, NULL, 4),
(115660, NULL, 'G3DSA:1.20.120.350:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115661, NULL, 'G3DSA:3.40.630.30:FF:000393', NULL, NULL, 'Glr1099 protein', NULL, NULL, NULL, NULL, NULL, 4),
(115662, NULL, 'G3DSA:1.25.40.10:FF:000474', NULL, NULL, 'Pentatricopeptide repeat protein PPR986-12', NULL, NULL, NULL, NULL, NULL, 4),
(115663, NULL, 'G3DSA:1.20.5.350:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115664, NULL, 'G3DSA:1.10.510.10:FF:004411', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115665, NULL, 'G3DSA:1.10.10.10:FF:001427', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(115666, NULL, 'G3DSA:3.10.20.90:FF:000362', NULL, NULL, 'Ubiquitin-like protein ATG12', NULL, NULL, NULL, NULL, NULL, 4),
(115667, NULL, 'G3DSA:3.30.559.10:FF:000262', NULL, NULL, 'Dihydrolipoyllysine-residue succinyltransferase component of 2-oxoglutarate dehydrogenase complex, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(115668, NULL, 'G3DSA:1.10.10.160:FF:000012', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(115669, NULL, 'G3DSA:3.30.1490.50:FF:000001', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(115670, NULL, 'G3DSA:3.30.710.10:FF:000053', NULL, NULL, 'potassium voltage-gated channel subfamily A member 4', NULL, NULL, NULL, NULL, NULL, 4),
(115671, NULL, 'G3DSA:3.40.1090.10:FF:000092', NULL, NULL, 'Patatin-like phospholipase domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(115672, NULL, 'G3DSA:3.10.20.90:FF:000710', NULL, NULL, 'Autophagy protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(115673, NULL, 'G3DSA:1.20.1070.10:FF:002114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115674, NULL, 'G3DSA:1.25.40.10:FF:004745', NULL, NULL, 'Os08g0153600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(115675, NULL, 'G3DSA:3.40.50.450:FF:000076', NULL, NULL, '6-phosphofructokinase, pyrophosphate-dependent', NULL, NULL, NULL, NULL, NULL, 4),
(115676, NULL, 'G3DSA:3.30.70.3000:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115677, NULL, 'G3DSA:3.80.10.10:FF:000762', NULL, NULL, 'probable inactive leucine-rich repeat receptor-like protein kinase At3g03770', NULL, NULL, NULL, NULL, NULL, 4),
(115678, NULL, 'G3DSA:3.40.1350.10:FF:000016', NULL, NULL, 'tRNA-splicing endonuclease subunit Sen34', NULL, NULL, NULL, NULL, NULL, 4),
(115679, NULL, 'G3DSA:2.60.120.380:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115680, NULL, 'G3DSA:3.40.50.300:FF:000059', NULL, NULL, 'ABC transporter G family member 40', NULL, NULL, NULL, NULL, NULL, 4),
(115681, NULL, 'G3DSA:3.40.50.300:FF:004011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115682, NULL, 'G3DSA:1.20.1250.20:FF:000523', NULL, NULL, 'MFS multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115683, NULL, 'G3DSA:3.90.550.50:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115684, NULL, 'G3DSA:3.40.50.2300:FF:000843', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115685, NULL, 'G3DSA:1.20.5.30:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115686, NULL, 'G3DSA:3.30.70.3490:FF:000017', NULL, NULL, 'Oxysterol binding protein (Orp8), putative', NULL, NULL, NULL, NULL, NULL, 4),
(115687, NULL, 'G3DSA:2.30.30.140:FF:000154', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(115688, NULL, 'G3DSA:1.10.3430.10:FF:000037', NULL, NULL, 'Ammonium transporter', NULL, NULL, NULL, NULL, NULL, 4),
(115689, NULL, 'G3DSA:1.10.238.10:FF:000107', NULL, NULL, 'Troponin C, skeletal muscle', NULL, NULL, NULL, NULL, NULL, 4),
(115690, NULL, 'G3DSA:1.20.1270.60:FF:000290', NULL, NULL, 'Protein kinase C and casein kinase substrate in neurons 1a', NULL, NULL, NULL, NULL, NULL, 4),
(115691, NULL, 'G3DSA:2.60.40.790:FF:000113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115692, NULL, 'G3DSA:1.20.120.160:FF:000045', NULL, NULL, 'PAS sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(115693, NULL, 'G3DSA:2.40.420.20:FF:000001', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(115694, NULL, 'G3DSA:2.30.30.140:FF:000261', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(115695, NULL, 'G3DSA:3.30.9.10:FF:000148', NULL, NULL, 'Aerobic glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(115696, NULL, 'G3DSA:1.25.40.10:FF:002609', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115697, NULL, 'G3DSA:3.90.228.10:FF:000019', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(115698, NULL, 'G3DSA:1.10.560.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115699, NULL, 'G3DSA:3.30.1490.70:FF:000007', NULL, NULL, 'Unplaced genomic scaffold supercont2.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(115700, NULL, 'G3DSA:1.25.40.10:FF:005015', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g39710', NULL, NULL, NULL, NULL, NULL, 4),
(115701, NULL, 'G3DSA:3.30.559.10:FF:000155', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(115702, NULL, 'G3DSA:1.50.10.10:FF:000003', NULL, NULL, 'Cytoplasmic trehalase', NULL, NULL, NULL, NULL, NULL, 4),
(115703, NULL, 'G3DSA:3.40.50.300:FF:007658', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(115704, NULL, 'G3DSA:1.20.1070.10:FF:001945', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115705, NULL, 'G3DSA:2.180.10.10:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(115706, NULL, 'G3DSA:3.60.10.10:FF:000133', NULL, NULL, 'INositol Polyphosphate-5-Phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(115707, NULL, 'G3DSA:3.40.1160.10:FF:000081', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(115708, NULL, 'G3DSA:3.30.750.24:FF:000153', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(115709, NULL, 'G3DSA:2.60.40.1930:FF:000026', NULL, NULL, 'MHC-linked complement C4', NULL, NULL, NULL, NULL, NULL, 4),
(115710, NULL, 'G3DSA:3.40.50.980:FF:000004', NULL, NULL, '2,3-dihydroxybenzoate-AMP ligase', NULL, NULL, NULL, NULL, NULL, 4),
(115711, NULL, 'G3DSA:3.50.50.60:FF:000994', NULL, NULL, 'Probable polyamine oxidase 5', NULL, NULL, NULL, NULL, NULL, 4),
(115712, NULL, 'G3DSA:1.25.10.10:FF:001591', NULL, NULL, 'Importin-beta N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(115713, NULL, 'G3DSA:3.40.50.11660:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115714, NULL, 'G3DSA:3.30.230.10:FF:000246', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(115715, NULL, 'G3DSA:2.60.40.10:FF:000031', NULL, NULL, 'Myosin-binding protein C, slow type', NULL, NULL, NULL, NULL, NULL, 4),
(115716, NULL, 'G3DSA:3.10.50.40:FF:000091', NULL, NULL, 'HEN1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(115717, NULL, 'G3DSA:3.40.50.300:FF:003387', NULL, NULL, 'UMP-CMP kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115718, NULL, 'G3DSA:3.50.30.30:FF:000107', NULL, NULL, 'Naaladl1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(115719, NULL, 'G3DSA:1.10.287.70:FF:000177', NULL, NULL, 'Cation channel sperm associated 4', NULL, NULL, NULL, NULL, NULL, 4),
(115720, NULL, 'G3DSA:3.40.190.10:FF:000605', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(115721, NULL, 'G3DSA:2.30.26.10:FF:000004', NULL, NULL, 'Dihydroorotate dehydrogenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(115722, NULL, 'G3DSA:2.60.40.820:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115723, NULL, 'G3DSA:1.10.472.80:FF:000003', NULL, NULL, 'Putative TBC1 domain family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(115724, NULL, 'G3DSA:1.10.8.10:FF:000370', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115725, NULL, 'G3DSA:3.80.10.10:FF:002555', NULL, NULL, 'AGAP010770-PA', NULL, NULL, NULL, NULL, NULL, 4),
(115726, NULL, 'G3DSA:3.40.30.10:FF:001147', NULL, NULL, 'Glutathione S-transferase pi 1', NULL, NULL, NULL, NULL, NULL, 4),
(115727, NULL, 'G3DSA:1.25.40.10:FF:003565', NULL, NULL, 'Tetratricopeptide repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115728, NULL, 'G3DSA:2.60.40.1910:FF:000020', NULL, NULL, 'Peptidase family m1 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115729, NULL, 'G3DSA:3.40.50.410:FF:000311', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115730, NULL, 'G3DSA:2.40.70.10:FF:000365', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115731, NULL, 'G3DSA:2.40.70.10:FF:000258', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115732, NULL, 'G3DSA:3.30.1050.10:FF:000035', NULL, NULL, 'Acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(115733, NULL, 'G3DSA:3.40.1190.20:FF:000147', NULL, NULL, 'Carbohydrate kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(115734, NULL, 'G3DSA:3.90.180.10:FF:000077', NULL, NULL, 'Alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(115735, NULL, 'G3DSA:1.10.287.70:FF:000284', NULL, NULL, 'Two pore potassium channel protein sup-9', NULL, NULL, NULL, NULL, NULL, 4),
(115736, NULL, 'G3DSA:2.130.10.10:FF:004050', NULL, NULL, 'Anaphase-promoting complex subunit 4-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(115737, NULL, 'G3DSA:2.10.25.10:FF:000329', NULL, NULL, 'Collagen and calcium-binding EGF domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(115738, NULL, 'G3DSA:3.30.565.10:FF:000439', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', NULL, NULL, NULL, NULL, NULL, 4),
(115739, NULL, 'G3DSA:3.30.70.270:FF:000163', NULL, NULL, 'Retrovirus-related Pol polyprotein from transposon gypsy-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(115740, NULL, 'G3DSA:3.30.200.20:FF:002557', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115741, NULL, 'G3DSA:1.20.1280.50:FF:000231', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(115742, NULL, 'G3DSA:3.40.50.620:FF:000279', NULL, NULL, 'Valine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(115743, NULL, 'G3DSA:3.40.50.200:FF:000147', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(115744, NULL, 'G3DSA:3.40.50.880:FF:000087', NULL, NULL, 'Peptidase S51 dipeptidase E', NULL, NULL, NULL, NULL, NULL, 4),
(115745, NULL, 'G3DSA:1.10.510.10:FF:003450', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115746, NULL, 'G3DSA:2.170.140.10:FF:000058', NULL, NULL, 'GH13361p', NULL, NULL, NULL, NULL, NULL, 4),
(115747, NULL, 'G3DSA:4.10.240.10:FF:000208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115748, NULL, 'G3DSA:3.40.50.300:FF:000514', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(115749, NULL, 'G3DSA:1.25.40.20:FF:001185', NULL, NULL, 'SH3 and multiple ankyrin repeat domains 3', NULL, NULL, NULL, NULL, NULL, 4),
(115750, NULL, 'G3DSA:1.20.5.190:FF:000167', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115751, NULL, 'G3DSA:3.20.20.70:FF:000069', NULL, NULL, 'Dihydroorotate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(115752, NULL, 'G3DSA:3.40.50.10860:FF:000004', NULL, NULL, 'Quinate/shikimate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(115753, NULL, 'G3DSA:3.40.50.12780:FF:000136', NULL, NULL, 'L-prolyl-AMP Ligase PltF', NULL, NULL, NULL, NULL, NULL, 4),
(115754, NULL, 'G3DSA:3.30.70.330:FF:002912', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115755, NULL, 'G3DSA:1.25.40.1040:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115756, NULL, 'G3DSA:2.60.34.10:FF:000078', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(115757, NULL, 'G3DSA:3.30.70.330:FF:002688', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115758, NULL, 'G3DSA:2.40.240.20:FF:000015', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4),
(115759, NULL, 'G3DSA:3.30.40.10:FF:000445', NULL, NULL, 'E3 ubiquitin-protein ligase PDZRN3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(115760, NULL, 'G3DSA:3.30.230.10:FF:000139', NULL, NULL, 'DNA mismatch repair protein mlh1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115761, NULL, 'G3DSA:3.40.20.10:FF:000028', NULL, NULL, 'Villin-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(115762, NULL, 'G3DSA:3.30.40.10:FF:000097', NULL, NULL, 'E3 ubiquitin-protein ligase DTX4', NULL, NULL, NULL, NULL, NULL, 4),
(115763, NULL, 'G3DSA:1.20.58.60:FF:000719', NULL, NULL, 'Spectrin beta chain, non-erythrocytic 5-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(115764, NULL, 'G3DSA:1.25.40.10:FF:001648', NULL, NULL, 'Os06g0231400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(115765, NULL, 'G3DSA:2.130.10.10:FF:000115', NULL, NULL, 'DDB1- and CUL4-associated factor 11 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(115766, NULL, 'G3DSA:1.10.10.41:FF:000004', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(115767, NULL, 'G3DSA:2.60.120.470:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115768, NULL, 'G3DSA:1.10.220.160:FF:000002', NULL, NULL, 'SET and MYND domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(115769, NULL, 'G3DSA:3.30.70.100:FF:000039', NULL, NULL, 'Carbamoyltransferase HypF', NULL, NULL, NULL, NULL, NULL, 4),
(115770, NULL, 'G3DSA:2.40.170.20:FF:000015', NULL, NULL, 'TonB-dependent siderophore receptor', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(115771, NULL, 'G3DSA:3.90.1150.10:FF:000512', NULL, NULL, 'Protein CBG02613', NULL, NULL, NULL, NULL, NULL, 4),
(115772, NULL, 'G3DSA:2.30.30.100:FF:000041', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm5', NULL, NULL, NULL, NULL, NULL, 4),
(115773, NULL, 'G3DSA:3.30.200.20:FF:001933', NULL, NULL, 'Protein kinase domain-containing protein ppk3', NULL, NULL, NULL, NULL, NULL, 4),
(115774, NULL, 'G3DSA:1.10.640.10:FF:000020', NULL, NULL, 'Heme peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(115775, NULL, 'G3DSA:3.40.50.1820:FF:000929', NULL, NULL, 'AB-hydrolase associated lipase region containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(115776, NULL, 'G3DSA:2.30.39.10:FF:000085', NULL, NULL, 'Serine protease inhibitor serpin', NULL, NULL, NULL, NULL, NULL, 4),
(115777, NULL, 'G3DSA:3.90.280.10:FF:000011', NULL, NULL, 'UPF0098 protein Rv2140c', NULL, NULL, NULL, NULL, NULL, 4),
(115778, NULL, 'G3DSA:2.60.40.10:FF:005595', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115779, NULL, 'G3DSA:1.10.238.10:FF:000091', NULL, NULL, 'Serine/threonine-protein phosphatase 2A regulatory subunit B'''' subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(115780, NULL, 'G3DSA:3.30.1010.10:FF:000044', NULL, NULL, 'Phosphatidylinositol 3-and 4-kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115781, NULL, 'G3DSA:3.40.50.1110:FF:000144', NULL, NULL, 'Mu phage tail fiber protein GpS', NULL, NULL, NULL, NULL, NULL, 4),
(115782, NULL, 'G3DSA:3.30.1540.20:FF:000019', NULL, NULL, 'PMS1 homolog 2, mismatch repair system component', NULL, NULL, NULL, NULL, NULL, 4),
(115783, NULL, 'G3DSA:1.10.287.1260:FF:000006', NULL, NULL, 'Mechanosensitive ion channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(115784, NULL, 'G3DSA:1.10.565.10:FF:000058', NULL, NULL, 'Thyroid hormone receptor beta', NULL, NULL, NULL, NULL, NULL, 4),
(115785, NULL, 'G3DSA:3.40.50.300:FF:005860', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115786, NULL, 'G3DSA:1.20.58.60:FF:000377', NULL, NULL, 'Spectrin beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(115787, NULL, 'G3DSA:3.90.70.10:FF:000091', NULL, NULL, 'Aminopeptidase C', NULL, NULL, NULL, NULL, NULL, 4),
(115788, NULL, 'G3DSA:2.60.40.60:FF:000809', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(115789, NULL, 'G3DSA:3.30.160.60:FF:004746', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115790, NULL, 'G3DSA:3.90.640.10:FF:000106', NULL, NULL, 'Heat shock protein 70, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115791, NULL, 'G3DSA:1.10.390.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115792, NULL, 'G3DSA:3.90.45.10:FF:000015', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(115793, NULL, 'G3DSA:3.40.449.10:FF:000004', NULL, NULL, 'phosphoenolpyruvate carboxykinase [ATP]-like', NULL, NULL, NULL, NULL, NULL, 4),
(115794, NULL, 'G3DSA:1.25.10.10:FF:003052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115795, NULL, 'G3DSA:1.25.40.10:FF:004526', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115796, NULL, 'G3DSA:3.90.550.50:FF:000095', NULL, NULL, 'Beta 3-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(115797, NULL, 'G3DSA:1.10.357.120:FF:000006', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(115798, NULL, 'G3DSA:3.40.50.150:FF:000104', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(115799, NULL, 'G3DSA:3.30.70.240:FF:000053', NULL, NULL, 'Putative tetracycline resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(115800, NULL, 'G3DSA:2.60.120.200:FF:000654', NULL, NULL, 'Laminin subunit alpha 5', NULL, NULL, NULL, NULL, NULL, 4),
(115801, NULL, 'G3DSA:3.70.10.10:FF:000043', NULL, NULL, 'DNA polymerase processivity factor', NULL, NULL, NULL, NULL, NULL, 4),
(115802, NULL, 'G3DSA:1.25.40.720:FF:000002', NULL, NULL, 'Embryo defective 2423', NULL, NULL, NULL, NULL, NULL, 4),
(115803, NULL, 'G3DSA:2.40.40.20:FF:000074', NULL, NULL, 'DMSO reductase chain A', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(115804, NULL, 'G3DSA:3.40.50.300:FF:000301', NULL, NULL, 'Peptide transport system ATP-binding protein sapF', NULL, NULL, NULL, NULL, NULL, 4),
(115805, NULL, 'G3DSA:1.10.8.60:FF:000013', NULL, NULL, 'DNA polymerase III subunit gamma/tau', NULL, NULL, NULL, NULL, NULL, 4),
(115806, NULL, 'G3DSA:1.10.287.70:FF:000047', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(115807, NULL, 'G3DSA:3.30.497.10:FF:000056', NULL, NULL, 'Serine protease inhibitor (SERPIN) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(115808, NULL, 'G3DSA:3.10.50.40:FF:000107', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(115809, NULL, 'G3DSA:3.40.50.1820:FF:001205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115810, NULL, 'G3DSA:3.30.200.20:FF:000079', NULL, NULL, 'Calcium/calmodulin-dependent protein kinase kinase 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(115811, NULL, 'G3DSA:1.20.120.340:FF:000003', NULL, NULL, 'Flagellar secretion chaperone FliS', NULL, NULL, NULL, NULL, NULL, 4),
(115812, NULL, 'G3DSA:3.40.50.300:FF:003948', NULL, NULL, 'Transposition helper protein', NULL, NULL, NULL, NULL, NULL, 4),
(115813, NULL, 'G3DSA:2.130.10.10:FF:005803', NULL, NULL, 'WD repeat and HMG-box DNA-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(115814, NULL, 'G3DSA:3.30.70.260:FF:000059', NULL, NULL, 'Diaminopimelate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(115815, NULL, 'G3DSA:3.30.40.10:FF:001406', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(115816, NULL, 'G3DSA:1.25.40.10:FF:001305', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g14470', NULL, NULL, NULL, NULL, NULL, 4),
(115817, NULL, 'G3DSA:3.80.10.10:FF:001936', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase PEPR1', NULL, NULL, NULL, NULL, NULL, 4),
(115818, NULL, 'G3DSA:1.25.40.10:FF:004184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115819, NULL, 'G3DSA:3.40.50.10190:FF:000343', NULL, NULL, 'S-M checkpoint control protein rad4', NULL, NULL, NULL, NULL, NULL, 4),
(115820, NULL, 'G3DSA:1.20.1070.10:FF:001153', NULL, NULL, 'Neuropeptide FF receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(115821, NULL, 'G3DSA:2.130.10.10:FF:003431', NULL, NULL, 'Raptor, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(115822, NULL, 'G3DSA:1.10.10.60:FF:000104', NULL, NULL, 'trihelix transcription factor ASIL2', NULL, NULL, NULL, NULL, NULL, 4),
(115823, NULL, 'G3DSA:3.10.129.10:FF:000116', NULL, NULL, 'Thioesterase superfamily, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115824, NULL, 'G3DSA:2.60.40.2030:FF:000045', NULL, NULL, 'Adhesion G-protein-coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(115825, NULL, 'G3DSA:3.30.700.30:FF:000002', NULL, NULL, 'Propionyl-CoA carboxylase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(115826, NULL, 'G3DSA:1.10.150.300:FF:000005', NULL, NULL, 'Obg-like ATPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(115827, NULL, 'G3DSA:2.40.50.140:FF:000762', NULL, NULL, 'ABC transporter, ATP binding protein (Glucose)', NULL, NULL, NULL, NULL, NULL, 4),
(115828, NULL, 'G3DSA:3.10.20.30:FF:000041', NULL, NULL, 'Glycine-betaine demethylase subunit GbcB', NULL, NULL, NULL, NULL, NULL, 4),
(115829, NULL, 'G3DSA:3.80.10.10:FF:002212', NULL, NULL, 'LOC502201 protein', NULL, NULL, NULL, NULL, NULL, 4),
(115830, NULL, 'G3DSA:4.10.240.10:FF:000079', NULL, NULL, 'TBS1p protein', NULL, NULL, NULL, NULL, NULL, 4),
(115831, NULL, 'G3DSA:1.20.1270.280:FF:000020', NULL, NULL, 'Putative dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(115832, NULL, 'G3DSA:3.10.300.10:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115833, NULL, 'G3DSA:1.20.5.170:FF:000161', NULL, NULL, 'Tropomyosin 3', NULL, NULL, NULL, NULL, NULL, 4),
(115834, NULL, 'G3DSA:3.40.50.300:FF:008619', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115835, NULL, 'G3DSA:3.40.50.620:FF:000149', NULL, NULL, 'Glutamate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(115836, NULL, 'G3DSA:1.25.10.10:FF:003389', NULL, NULL, 'Nucleolar protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(115837, NULL, 'G3DSA:1.20.1250.20:FF:000175', NULL, NULL, 'Inorganic phosphate transporter 1-6', NULL, NULL, NULL, NULL, NULL, 4),
(115838, NULL, 'G3DSA:1.10.238.10:FF:001052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115839, NULL, 'G3DSA:2.60.40.10:FF:003122', NULL, NULL, 'Pkd1', NULL, NULL, NULL, NULL, NULL, 4),
(115840, NULL, 'G3DSA:2.60.120.590:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115841, NULL, 'G3DSA:2.40.50.140:FF:001049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115842, NULL, 'G3DSA:3.80.10.10:FF:000290', NULL, NULL, 'Slit guidance ligand 1', NULL, NULL, NULL, NULL, NULL, 4),
(115843, NULL, 'G3DSA:3.40.1280.30:FF:000016', NULL, NULL, 'tRNA methyltransferase 10 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(115844, NULL, 'G3DSA:2.60.40.60:FF:000692', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(115845, NULL, 'G3DSA:3.30.700.10:FF:000007', NULL, NULL, 'MSHA pilin protein MshB', NULL, NULL, NULL, NULL, NULL, 4),
(115846, NULL, 'G3DSA:1.20.58.1030:FF:000046', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(115847, NULL, 'G3DSA:1.20.1050.10:FF:000078', NULL, NULL, 'Protein CBG04233', NULL, NULL, NULL, NULL, NULL, 4),
(115848, NULL, 'G3DSA:2.130.10.10:FF:000789', NULL, NULL, 'Transcription factor (SPT8), putative', NULL, NULL, NULL, NULL, NULL, 4),
(115849, NULL, 'G3DSA:2.30.30.1020:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115850, NULL, 'G3DSA:3.30.1300.30:FF:000010', NULL, NULL, 'Serum resistance protein DrsA', NULL, NULL, NULL, NULL, NULL, 4),
(115851, NULL, 'G3DSA:3.80.10.10:FF:000868', NULL, NULL, 'OSJNBa0064H22.13 protein', NULL, NULL, NULL, NULL, NULL, 4),
(115852, NULL, 'G3DSA:2.40.50.140:FF:000537', NULL, NULL, 'Class II aaRS and biotin synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(115853, NULL, 'G3DSA:3.30.160.60:FF:005590', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115854, NULL, 'G3DSA:3.40.50.970:FF:000018', NULL, NULL, '2-oxoglutarate dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(115855, NULL, 'G3DSA:3.40.50.1820:FF:000132', NULL, NULL, 'caffeoylshikimate esterase', NULL, NULL, NULL, NULL, NULL, 4),
(115856, NULL, 'G3DSA:3.40.50.10420:FF:000002', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(115857, NULL, 'G3DSA:3.40.50.150:FF:001852', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115858, NULL, 'G3DSA:3.30.200.20:FF:001484', NULL, NULL, 'AGC (cAMP-dependent, cGMP-dependent and protein kinase C) kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(115859, NULL, 'G3DSA:1.10.510.10:FF:003006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115860, NULL, 'G3DSA:2.20.25.500:FF:000001', NULL, NULL, 'Nuclear pore complex protein Nup85', NULL, NULL, NULL, NULL, NULL, 4),
(115861, NULL, 'G3DSA:1.10.472.10:FF:000258', NULL, NULL, 'Cyclin domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(115862, NULL, 'G3DSA:1.10.565.10:FF:000165', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(115863, NULL, 'G3DSA:2.30.29.30:FF:001091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115864, NULL, 'G3DSA:3.60.10.10:FF:000364', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115865, NULL, 'G3DSA:2.130.10.10:FF:003549', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115866, NULL, 'G3DSA:1.10.510.10:FF:002388', NULL, NULL, 'Serine/threonine protein kinase-56', NULL, NULL, NULL, NULL, NULL, 4),
(115867, NULL, 'G3DSA:3.40.250.10:FF:000088', NULL, NULL, 'Putative NADH oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(115868, NULL, 'G3DSA:1.10.287.110:FF:000150', NULL, NULL, 'Molecular chaperone DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(115869, NULL, 'G3DSA:3.90.190.10:FF:000471', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(115870, NULL, 'G3DSA:3.30.30.30:FF:000046', NULL, NULL, 'YALI0B12474p', NULL, NULL, NULL, NULL, NULL, 4),
(115871, NULL, 'G3DSA:2.30.30.140:FF:000030', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(115872, NULL, 'G3DSA:3.30.40.10:FF:001749', NULL, NULL, 'Variant in methylation102', NULL, NULL, NULL, NULL, NULL, 4),
(115873, NULL, 'G3DSA:3.40.50.10580:FF:000010', NULL, NULL, 'V-type ATP synthase subunit F', NULL, NULL, NULL, NULL, NULL, 4),
(115874, NULL, 'G3DSA:1.20.1070.10:FF:000203', NULL, NULL, 'gonadotropin-releasing hormone receptor', NULL, NULL, NULL, NULL, NULL, 4),
(115875, NULL, 'G3DSA:3.40.190.80:FF:000025', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(115876, NULL, 'G3DSA:3.30.450.20:FF:000687', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(115877, NULL, 'G3DSA:3.80.10.10:FF:003628', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115878, NULL, 'G3DSA:3.30.160.60:FF:004639', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115879, NULL, 'G3DSA:3.10.250.10:FF:000128', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115880, NULL, 'G3DSA:2.60.120.200:FF:000075', NULL, NULL, 'Calreticulin', NULL, NULL, NULL, NULL, NULL, 4),
(115881, NULL, 'G3DSA:2.60.120.10:FF:000201', NULL, NULL, 'NTE family protein', NULL, NULL, NULL, NULL, NULL, 4),
(115882, NULL, 'G3DSA:1.20.1460.20:FF:000005', NULL, NULL, 'V-type ATP synthase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(115883, NULL, 'G3DSA:1.10.10.10:FF:001972', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115884, NULL, 'G3DSA:3.90.70.10:FF:000107', NULL, NULL, 'General secretion pathway protein A', NULL, NULL, NULL, NULL, NULL, 4),
(115885, NULL, 'G3DSA:3.40.1380.20:FF:000066', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(115886, NULL, 'G3DSA:3.40.50.1450:FF:000004', NULL, NULL, 'Germination protease', NULL, NULL, NULL, NULL, NULL, 4),
(115887, NULL, 'G3DSA:3.30.160.60:FF:001312', NULL, NULL, 'Histone-lysine N-methyltransferase PRDM9', NULL, NULL, NULL, NULL, NULL, 4),
(115888, NULL, 'G3DSA:3.30.300.10:FF:000022', NULL, NULL, 'GMP synthase (glutamine-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4),
(115889, NULL, 'G3DSA:3.30.450.40:FF:000120', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(115890, NULL, 'G3DSA:1.25.10.10:FF:002321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115891, NULL, 'G3DSA:1.25.40.10:FF:004869', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115892, NULL, 'G3DSA:1.10.287.110:FF:000144', NULL, NULL, 'TPR-repeat-containing chaperone protein DNAJ', NULL, NULL, NULL, NULL, NULL, 4),
(115893, NULL, 'G3DSA:1.20.1560.10:FF:000055', NULL, NULL, 'ABC multidrug transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(115894, NULL, 'G3DSA:3.30.1700.10:FF:000001', NULL, NULL, 'UDP-3-O-acyl-N-acetylglucosamine deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(115895, NULL, 'G3DSA:1.10.287.70:FF:000502', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115896, NULL, 'G3DSA:3.40.50.300:FF:007208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115897, NULL, 'G3DSA:3.30.40.10:FF:000552', NULL, NULL, 'Anaphase promoting complex subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115898, NULL, 'G3DSA:3.30.420.10:FF:000076', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(115899, NULL, 'G3DSA:3.90.640.10:FF:000090', NULL, NULL, 'Chaperone protein DNAK, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115900, NULL, 'G3DSA:2.60.40.1730:FF:000067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115901, NULL, 'G3DSA:3.40.50.11260:FF:000006', NULL, NULL, 'endoplasmin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(115902, NULL, 'G3DSA:3.30.160.60:FF:004971', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115903, NULL, 'G3DSA:1.10.8.60:FF:000249', NULL, NULL, 'ESX-3 secretion system protein EccA3', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(115904, NULL, 'G3DSA:3.30.40.10:FF:001064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115905, NULL, 'G3DSA:1.25.40.10:FF:001199', NULL, NULL, 'Response regulator VieB', NULL, NULL, NULL, NULL, NULL, 4),
(115906, NULL, 'G3DSA:3.60.40.10:FF:000192', NULL, NULL, 'Probable protein phosphatase 2C 54', NULL, NULL, NULL, NULL, NULL, 4),
(115907, NULL, 'G3DSA:1.25.40.430:FF:000022', NULL, NULL, 'Checkpoint serine/threonine-protein kinase bub1', NULL, NULL, NULL, NULL, NULL, 4),
(115908, NULL, 'G3DSA:2.130.10.10:FF:003881', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115909, NULL, 'G3DSA:3.40.50.720:FF:000871', NULL, NULL, 'HydroxySteroid Dehydrogenase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(115910, NULL, 'G3DSA:2.10.80.10:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115911, NULL, 'G3DSA:3.80.10.10:FF:000183', NULL, NULL, 'nuclear RNA export factor 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(115912, NULL, 'G3DSA:3.40.50.12760:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115913, NULL, 'G3DSA:3.20.20.80:FF:000179', NULL, NULL, 'Chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(115914, NULL, 'G3DSA:2.130.10.10:FF:001520', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115915, NULL, 'G3DSA:2.60.40.10:FF:000935', NULL, NULL, 'Uncharacterized protein, isoform I', NULL, NULL, NULL, NULL, NULL, 4),
(115916, NULL, 'G3DSA:1.25.40.20:FF:000696', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(115917, NULL, 'G3DSA:1.20.1070.10:FF:001041', NULL, NULL, 'Follicle-stimulating hormone receptor', NULL, NULL, NULL, NULL, NULL, 4),
(115918, NULL, 'G3DSA:1.20.1250.20:FF:000411', NULL, NULL, 'Probable high-affinity nitrate transporter 2.4', NULL, NULL, NULL, NULL, NULL, 4),
(115919, NULL, 'G3DSA:3.40.50.150:FF:000216', NULL, NULL, 'S-adenosylmethionine-dependent methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115920, NULL, 'G3DSA:3.30.70.330:FF:002345', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115921, NULL, 'G3DSA:3.30.1490.40:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115922, NULL, 'G3DSA:2.60.40.10:FF:005027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115923, NULL, 'G3DSA:1.25.40.10:FF:003672', NULL, NULL, 'Peroxisomal targeting signal 1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(115924, NULL, 'G3DSA:2.130.10.10:FF:002026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115925, NULL, 'G3DSA:1.10.10.60:FF:000778', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115926, NULL, 'G3DSA:3.60.110.10:FF:000045', NULL, NULL, 'Putative nitrilase/cyanide hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(115927, NULL, 'G3DSA:3.40.50.10130:FF:000022', NULL, NULL, 'DNA excision repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(115928, NULL, 'G3DSA:1.25.40.20:FF:001533', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115929, NULL, 'G3DSA:3.40.50.1460:FF:000102', NULL, NULL, 'AGAP012945-PA', NULL, NULL, NULL, NULL, NULL, 4),
(115930, NULL, 'G3DSA:1.20.1540.10:FF:000060', NULL, NULL, 'Rhomboid-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(115931, NULL, 'G3DSA:1.10.287.700:FF:000006', NULL, NULL, 'Late embryogenesis abundant protein (LEA) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(115932, NULL, 'G3DSA:2.60.40.1290:FF:000002', NULL, NULL, 'Fibronectin-binding protein A', NULL, NULL, NULL, NULL, NULL, 4),
(115933, NULL, 'G3DSA:3.30.70.270:FF:000287', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115934, NULL, 'G3DSA:1.20.5.390:FF:000002', NULL, NULL, 'NF-kappa-B essential modulator isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(115935, NULL, 'G3DSA:3.40.50.300:FF:003263', NULL, NULL, 'RecBCD enzyme subunit RecC', NULL, NULL, NULL, NULL, NULL, 4),
(115936, NULL, 'G3DSA:2.60.120.260:FF:000626', NULL, NULL, 'EGF-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(115937, NULL, 'G3DSA:1.20.5.110:FF:000306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115938, NULL, 'G3DSA:1.25.40.120:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115939, NULL, 'G3DSA:1.25.40.20:FF:001640', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(115940, NULL, 'G3DSA:1.10.238.10:FF:001164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115941, NULL, 'G3DSA:2.170.130.30:FF:000002', NULL, NULL, 'Transcobalamin-2', NULL, NULL, NULL, NULL, NULL, 4),
(115942, NULL, 'G3DSA:1.10.520.10:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115943, NULL, 'G3DSA:3.30.420.40:FF:001017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115944, NULL, 'G3DSA:3.30.160.20:FF:000024', NULL, NULL, 'double-stranded RNA-binding protein Staufen homolog 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(115945, NULL, 'G3DSA:1.20.1310.10:FF:000121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115946, NULL, 'G3DSA:1.20.1270.60:FF:000065', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(115947, NULL, 'G3DSA:2.30.30.40:FF:000214', NULL, NULL, 'SH3 domain-containing protein 19 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(115948, NULL, 'G3DSA:3.40.50.1370:FF:000064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115949, NULL, 'G3DSA:3.30.160.60:FF:001205', NULL, NULL, 'Tripartite motif containing 45', NULL, NULL, NULL, NULL, NULL, 4),
(115950, NULL, 'G3DSA:3.30.160.60:FF:000587', NULL, NULL, 'Zinc finger protein 711', NULL, NULL, NULL, NULL, NULL, 4),
(115951, NULL, 'G3DSA:1.10.1740.10:FF:000004', NULL, NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(115952, NULL, 'G3DSA:2.30.42.10:FF:000446', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115953, NULL, 'G3DSA:3.40.50.300:FF:007439', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115954, NULL, 'G3DSA:1.20.1640.10:FF:000112', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115955, NULL, 'G3DSA:3.80.10.10:FF:002324', NULL, NULL, 'Chondroadherin-like a', NULL, NULL, NULL, NULL, NULL, 4),
(115956, NULL, 'G3DSA:3.40.50.300:FF:003156', NULL, NULL, 'Dynein heavy chain 14, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(115957, NULL, 'G3DSA:3.40.50.300:FF:003044', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(115958, NULL, 'G3DSA:3.40.50.300:FF:001026', NULL, NULL, 'Phosphomevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(115959, NULL, 'G3DSA:3.40.850.10:FF:000510', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(115960, NULL, 'G3DSA:3.40.50.300:FF:006697', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115961, NULL, 'G3DSA:3.40.50.2300:FF:000405', NULL, NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(115962, NULL, 'G3DSA:2.130.10.10:FF:003662', NULL, NULL, 'AGAP010737-PA', NULL, NULL, NULL, NULL, NULL, 4),
(115963, NULL, 'G3DSA:3.30.260.10:FF:000074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115964, NULL, 'G3DSA:3.40.50.300:FF:007315', NULL, NULL, 'ORC (Origin Recognition Complex) subunit', NULL, NULL, NULL, NULL, NULL, 4),
(115965, NULL, 'G3DSA:3.60.130.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115966, NULL, 'G3DSA:3.10.129.10:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115967, NULL, 'G3DSA:2.60.40.4100:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115968, NULL, 'G3DSA:2.130.10.10:FF:003774', NULL, NULL, 'Mitotic checkpoint protein bub3', NULL, NULL, NULL, NULL, NULL, 4),
(115969, NULL, 'G3DSA:1.25.10.10:FF:000410', NULL, NULL, 'Mini spindles, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(115970, NULL, 'G3DSA:1.20.1250.20:FF:001030', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(115971, NULL, 'G3DSA:3.30.160.20:FF:000148', NULL, NULL, 'Similar to NF-kappa-B-repressing factor (NFkB-repressing factor) (Transcription factor NRF) (ITBA4 protein)', NULL, NULL, NULL, NULL, NULL, 4),
(115972, NULL, 'G3DSA:1.20.810.10:FF:000014', NULL, NULL, 'Cytochrome b', NULL, NULL, NULL, NULL, NULL, 4),
(115973, NULL, 'G3DSA:3.40.50.1980:FF:000039', NULL, NULL, 'Iron-hydroxamate ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(115974, NULL, 'G3DSA:2.20.110.10:FF:000007', NULL, NULL, 'Flagellar component', NULL, NULL, NULL, NULL, NULL, 4),
(115975, NULL, 'G3DSA:3.40.50.20:FF:000078', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(115976, NULL, 'G3DSA:1.50.40.10:FF:000168', NULL, NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(115977, NULL, 'G3DSA:3.20.20.190:FF:000154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115978, NULL, 'G3DSA:2.70.98.30:FF:000006', NULL, NULL, 'Endo-1,3-beta-glucanase Engl1', NULL, NULL, NULL, NULL, NULL, 4),
(115979, NULL, 'G3DSA:3.40.50.1820:FF:000817', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(115980, NULL, 'G3DSA:1.20.58.60:FF:000247', NULL, NULL, 'Spectrin repeat-containing, nuclear envelope family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(115981, NULL, 'G3DSA:2.130.10.10:FF:005011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115982, NULL, 'G3DSA:3.30.70.330:FF:003076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115983, NULL, 'G3DSA:1.25.40.10:FF:000923', NULL, NULL, 'Transcription factor IIIC-gamma subunit', NULL, NULL, NULL, NULL, NULL, 4),
(115984, NULL, 'G3DSA:3.80.10.10:FF:004466', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(115985, NULL, 'G3DSA:2.60.40.10:FF:003914', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115986, NULL, 'G3DSA:1.10.8.50:FF:000027', NULL, NULL, '30S ribosomal protein S13', NULL, NULL, NULL, NULL, NULL, 4),
(115987, NULL, 'G3DSA:2.60.20.10:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115988, NULL, 'G3DSA:3.30.1520.10:FF:000015', NULL, NULL, 'Sorting nexin 1', NULL, NULL, NULL, NULL, NULL, 4),
(115989, NULL, 'G3DSA:2.40.10.10:FF:000030', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(115990, NULL, 'G3DSA:3.40.50.2000:FF:000422', NULL, NULL, 'GDP-mannose--glycolipid 4-beta-D-mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(115991, NULL, 'G3DSA:4.10.400.10:FF:000182', NULL, NULL, 'MAM and LDL-receptor class A domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(115992, NULL, 'G3DSA:3.40.50.150:FF:000997', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115993, NULL, 'G3DSA:1.10.150.80:FF:000020', NULL, NULL, 'RecQ family helicase MusN', NULL, NULL, NULL, NULL, NULL, 4),
(115994, NULL, 'G3DSA:3.30.420.150:FF:000027', NULL, NULL, 'RNA polymerase II transcriptional coactivator KELP', NULL, NULL, NULL, NULL, NULL, 4),
(115995, NULL, 'G3DSA:2.60.40.10:FF:004302', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115996, NULL, 'G3DSA:3.30.160.60:FF:005258', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115997, NULL, 'G3DSA:3.80.10.10:FF:001487', NULL, NULL, 'Receptor-like protein 33', NULL, NULL, NULL, NULL, NULL, 4),
(115998, NULL, 'G3DSA:1.10.510.10:FF:003225', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(115999, NULL, 'G3DSA:2.40.30.270:FF:000016', NULL, NULL, 'DNA-binding protein SMUBP-2', NULL, NULL, NULL, NULL, NULL, 4),
(116000, NULL, 'G3DSA:1.10.8.60:FF:000581', NULL, NULL, 'Nuclear VCP-like', NULL, NULL, NULL, NULL, NULL, 4),
(116001, NULL, 'G3DSA:1.25.40.10:FF:004976', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116002, NULL, 'G3DSA:3.40.50.2300:FF:001012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116003, NULL, 'G3DSA:1.10.1520.10:FF:000004', NULL, NULL, 'Endoribonuclease dicer-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(116004, NULL, 'G3DSA:1.10.10.60:FF:000672', NULL, NULL, 'Ribonuclease J', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(116005, NULL, 'G3DSA:3.10.580.10:FF:000007', NULL, NULL, 'Arabinose 5-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(116006, NULL, 'G3DSA:1.20.960.30:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116007, NULL, 'G3DSA:1.10.800.10:FF:000004', NULL, NULL, 'Tyrosine 3-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(116008, NULL, 'G3DSA:3.40.50.300:FF:004792', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(116009, NULL, 'G3DSA:3.90.1150.10:FF:000405', NULL, NULL, 'Glycine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(116010, NULL, 'G3DSA:3.40.640.10:FF:000011', NULL, NULL, 'Ornithine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(116011, NULL, 'G3DSA:3.80.10.10:FF:000071', NULL, NULL, 'peroxidasin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(116012, NULL, 'G3DSA:3.20.20.100:FF:000178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116013, NULL, 'G3DSA:1.20.1600.10:FF:000003', NULL, NULL, 'Multidrug efflux system outer membrane subunit', NULL, NULL, NULL, NULL, NULL, 4),
(116014, NULL, 'G3DSA:1.10.340.30:FF:000082', NULL, NULL, '3-methyladenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(116015, NULL, 'G3DSA:1.20.5.3070:FF:000001', NULL, NULL, 'Flavin-dependent thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(116016, NULL, 'G3DSA:3.40.630.30:FF:000516', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116017, NULL, 'G3DSA:1.20.1250.20:FF:000068', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(116018, NULL, 'G3DSA:3.40.50.300:FF:005410', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(116019, NULL, 'G3DSA:3.40.50.2000:FF:001041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116020, NULL, 'G3DSA:3.40.47.10:FF:000281', NULL, NULL, 'Gll2853 protein', NULL, NULL, NULL, NULL, NULL, 4),
(116021, NULL, 'G3DSA:1.20.120.1160:FF:000003', NULL, NULL, 'Nucleoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(116022, NULL, 'G3DSA:1.20.960.10:FF:000002', NULL, NULL, 'Mitochondrial import receptor subunit TOM20', NULL, NULL, NULL, NULL, NULL, 4),
(116023, NULL, 'G3DSA:2.130.10.10:FF:004393', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(116024, NULL, 'G3DSA:2.170.270.10:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116025, NULL, 'G3DSA:3.40.33.10:FF:000007', NULL, NULL, 'Venom allergen', NULL, NULL, NULL, NULL, NULL, 4),
(116026, NULL, 'G3DSA:1.20.1110.10:FF:000140', NULL, NULL, 'Cation transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(116027, NULL, 'G3DSA:2.60.40.2690:FF:000001', NULL, NULL, 'Splicing factor 3a, subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(116028, NULL, 'G3DSA:1.10.510.10:FF:002500', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116029, NULL, 'G3DSA:1.20.5.2650:FF:000004', NULL, NULL, '40S ribosomal protein S6', NULL, NULL, NULL, NULL, NULL, 4),
(116030, NULL, 'G3DSA:2.40.50.140:FF:000318', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(116031, NULL, 'G3DSA:3.30.160.60:FF:003442', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116032, NULL, 'G3DSA:3.90.70.10:FF:000214', NULL, NULL, 'Cathepsin B-like cysteine proteinase', NULL, NULL, NULL, NULL, NULL, 4),
(116033, NULL, 'G3DSA:3.30.70.330:FF:002457', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116034, NULL, 'G3DSA:1.25.40.20:FF:001421', NULL, NULL, 'S-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(116035, NULL, 'G3DSA:3.80.10.10:FF:004342', NULL, NULL, 'Si:dkey-118k5.3', NULL, NULL, NULL, NULL, NULL, 4),
(116036, NULL, 'G3DSA:3.30.1490.180:FF:000026', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(116037, NULL, 'G3DSA:3.30.1050.10:FF:000041', NULL, NULL, 'Stomatin-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(116038, NULL, 'G3DSA:3.30.50.10:FF:000053', NULL, NULL, 'GATA transcription factor 15', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(116039, NULL, 'G3DSA:2.40.10.10:FF:000698', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116040, NULL, 'G3DSA:2.40.70.10:FF:000022', NULL, NULL, 'Aspartyl protease AED3', NULL, NULL, NULL, NULL, NULL, 4),
(116041, NULL, 'G3DSA:3.40.30.120:FF:000001', NULL, NULL, 'FAD monooxygenase, PheA/TfdB family', NULL, NULL, NULL, NULL, NULL, 4),
(116042, NULL, 'G3DSA:3.40.30.10:FF:001259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116043, NULL, 'G3DSA:3.30.1010.10:FF:000151', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', NULL, NULL, NULL, NULL, NULL, 4),
(116044, NULL, 'G3DSA:1.10.10.160:FF:000006', NULL, NULL, 'ATP-dependent DNA helicase Rep', NULL, NULL, NULL, NULL, NULL, 4),
(116045, NULL, 'G3DSA:3.20.20.80:FF:000398', NULL, NULL, 'CD98 heavy chain, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(116046, NULL, 'G3DSA:1.10.510.10:FF:001663', NULL, NULL, 'Putative serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(116047, NULL, 'G3DSA:3.90.226.10:FF:000077', NULL, NULL, 'Putative enoyl-CoA hydratase echA21', NULL, NULL, NULL, NULL, NULL, 4),
(116048, NULL, 'G3DSA:1.10.1320.10:FF:000023', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(116049, NULL, 'G3DSA:3.100.10.10:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116050, NULL, 'G3DSA:3.40.50.620:FF:000604', NULL, NULL, 'Asparagine synthetase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(116051, NULL, 'G3DSA:2.130.10.30:FF:000110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116052, NULL, 'G3DSA:1.20.1250.20:FF:000630', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(116053, NULL, 'G3DSA:2.10.25.10:FF:000082', NULL, NULL, 'Laminin subunit alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(116054, NULL, 'G3DSA:3.30.300.30:FF:000016', NULL, NULL, 'Fatty-acid-CoA ligase FadD26', NULL, NULL, NULL, NULL, NULL, 4),
(116055, NULL, 'G3DSA:1.10.3720.10:FF:000121', NULL, NULL, 'Amino acid ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(116056, NULL, 'G3DSA:3.40.50.720:FF:000539', NULL, NULL, 'Ubiquitin-like modifier-activating enzyme 5', NULL, NULL, NULL, NULL, NULL, 4),
(116057, NULL, 'G3DSA:1.25.10.10:FF:001607', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116058, NULL, 'G3DSA:3.40.50.300:FF:000407', NULL, NULL, 'Rho-related GTP-binding protein RhoE', NULL, NULL, NULL, NULL, NULL, 4),
(116059, NULL, 'G3DSA:3.40.50.360:FF:000150', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(116060, NULL, 'G3DSA:1.20.1250.20:FF:001827', NULL, NULL, 'Proton:peptide symporter POT family', NULL, NULL, NULL, NULL, NULL, 4),
(116061, NULL, 'G3DSA:2.40.150.20:FF:000020', NULL, NULL, 'Mitochondrial Ribosomal Protein, Large', NULL, NULL, NULL, NULL, NULL, 4),
(116062, NULL, 'G3DSA:3.30.70.1730:FF:000063', NULL, NULL, 'Ribosome assembly factor mrt4', NULL, NULL, NULL, NULL, NULL, 4),
(116063, NULL, 'G3DSA:1.20.1060.20:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116064, NULL, 'G3DSA:3.80.10.10:FF:002105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116065, NULL, 'G3DSA:2.130.10.10:FF:000008', NULL, NULL, 'Coatomer subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(116066, NULL, 'G3DSA:1.20.1460.10:FF:000014', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(116067, NULL, 'G3DSA:3.30.70.330:FF:001620', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116068, NULL, 'G3DSA:2.40.50.40:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116069, NULL, 'G3DSA:3.60.90.10:FF:000014', NULL, NULL, 'S-adenosylmethionine decarboxylase-ornithine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(116070, NULL, 'G3DSA:1.10.220.30:FF:000039', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(116071, NULL, 'G3DSA:1.25.40.180:FF:000256', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116072, NULL, 'G3DSA:1.20.900.10:FF:000010', NULL, NULL, 'Rho guanine nucleotide exchange factor 3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(116073, NULL, 'G3DSA:1.10.840.10:FF:000001', NULL, NULL, 'Rap guanine nucleotide exchange factor (GEF) 6', NULL, NULL, NULL, NULL, NULL, 4),
(116074, NULL, 'G3DSA:3.30.70.3310:FF:000003', NULL, NULL, 'Neurogenic locus notch 1', NULL, NULL, NULL, NULL, NULL, 4),
(116075, NULL, 'G3DSA:1.10.287.720:FF:000001', NULL, NULL, 'Major pollen allergen Ole e 6', NULL, NULL, NULL, NULL, NULL, 4),
(116076, NULL, 'G3DSA:2.70.150.10:FF:000212', NULL, NULL, 'ATPase, class VI, type 11B', NULL, NULL, NULL, NULL, NULL, 4),
(116077, NULL, 'G3DSA:3.40.50.12350:FF:000013', NULL, NULL, 'Eyes absent homolog', NULL, NULL, NULL, NULL, NULL, 4),
(116078, NULL, 'G3DSA:1.20.1070.10:FF:000309', NULL, NULL, 'Moody, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(116079, NULL, 'G3DSA:1.10.10.10:FF:000915', NULL, NULL, 'DtxR family iron (Metal) dependent repressor', NULL, NULL, NULL, NULL, NULL, 4),
(116080, NULL, 'G3DSA:1.10.220.10:FF:000033', NULL, NULL, 'Annexin A13,-like', NULL, NULL, NULL, NULL, NULL, 4),
(116081, NULL, 'G3DSA:1.20.940.10:FF:000018', NULL, NULL, 'Potassium channel regulatory factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116082, NULL, 'G3DSA:1.10.860.10:FF:000014', NULL, NULL, 'Replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(116083, NULL, 'G3DSA:3.30.70.3030:FF:000008', NULL, NULL, 'Nucleolar protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(116084, NULL, 'G3DSA:1.25.40.710:FF:000016', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(116085, NULL, 'G3DSA:3.20.190.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116086, NULL, 'G3DSA:4.10.1000.10:FF:000002', NULL, NULL, 'Zinc finger protein 36, C3H1 type-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(116087, NULL, 'G3DSA:2.130.10.10:FF:004954', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116088, NULL, 'G3DSA:1.20.920.10:FF:000005', NULL, NULL, 'protein kinase C-binding protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(116089, NULL, 'G3DSA:1.20.1070.10:FF:001602', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(116090, NULL, 'G3DSA:2.60.40.60:FF:000798', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116091, NULL, 'G3DSA:2.60.120.290:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116092, NULL, 'G3DSA:3.90.550.10:FF:000566', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(116093, NULL, 'G3DSA:3.30.160.60:FF:005696', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116094, NULL, 'G3DSA:3.40.190.10:FF:000594', NULL, NULL, 'Glutamate receptor 1.4', NULL, NULL, NULL, NULL, NULL, 4),
(116095, NULL, 'G3DSA:2.60.200.30:FF:000028', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(116096, NULL, 'G3DSA:3.90.1010.10:FF:000007', NULL, NULL, 'Cysteine desulfurase, sulfur acceptor subunit CsdE', NULL, NULL, NULL, NULL, NULL, 4),
(116097, NULL, 'G3DSA:3.50.30.30:FF:000096', NULL, NULL, 'Receptor homology region, transmembrane domain- and RING domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(116098, NULL, 'G3DSA:1.20.1260.10:FF:000015', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(116099, NULL, 'G3DSA:3.40.950.10:FF:000001', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor narfl', NULL, NULL, NULL, NULL, NULL, 4),
(116100, NULL, 'G3DSA:2.60.40.10:FF:004645', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116101, NULL, 'G3DSA:3.30.1330.40:FF:000060', NULL, NULL, 'Ribonuclease UK114', NULL, NULL, NULL, NULL, NULL, 4),
(116102, NULL, 'G3DSA:3.40.50.12660:FF:000005', NULL, NULL, 'Mca1p', NULL, NULL, NULL, NULL, NULL, 4),
(116103, NULL, 'G3DSA:3.40.50.280:FF:000019', NULL, NULL, 'Corrinoid protein', NULL, NULL, NULL, NULL, NULL, 4),
(116104, NULL, 'G3DSA:3.40.50.10810:FF:000248', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(116105, NULL, 'G3DSA:3.90.190.10:FF:000577', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116106, NULL, 'G3DSA:3.90.1150.10:FF:000169', NULL, NULL, 'Uncharacterized protein Rv1519', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(116107, NULL, 'G3DSA:1.10.150.20:FF:000154', NULL, NULL, 'Putative DNA repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(116108, NULL, 'G3DSA:2.60.40.60:FF:001074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116109, NULL, 'G3DSA:2.30.29.30:FF:000034', NULL, NULL, 'amyloid beta A4 precursor protein-binding family B member 2', NULL, NULL, NULL, NULL, NULL, 4),
(116110, NULL, 'G3DSA:1.10.3520.10:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116111, NULL, 'G3DSA:2.130.10.10:FF:000683', NULL, NULL, 'WD-40 repeat protein family', NULL, NULL, NULL, NULL, NULL, 4),
(116112, NULL, 'G3DSA:2.40.10.10:FF:000592', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116113, NULL, 'G3DSA:3.40.50.720:FF:001253', NULL, NULL, 'Alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(116114, NULL, 'G3DSA:3.30.50.10:FF:000159', NULL, NULL, 'AGAP012223-PA', NULL, NULL, NULL, NULL, NULL, 4),
(116115, NULL, 'G3DSA:3.30.470.20:FF:000233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116116, NULL, 'G3DSA:2.60.40.10:FF:001992', NULL, NULL, 'FiLamiN (Actin binding protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(116117, NULL, 'G3DSA:3.30.70.330:FF:000327', NULL, NULL, 'ras GTPase-activating protein-binding protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(116118, NULL, 'G3DSA:1.10.1580.10:FF:000002', NULL, NULL, 'Guanine nucleotide-binding protein-like 3 (nucleolar)-like', NULL, NULL, NULL, NULL, NULL, 4),
(116119, NULL, 'G3DSA:2.130.10.10:FF:002824', NULL, NULL, 'Actin related protein 2/3 complex, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116120, NULL, 'G3DSA:1.25.40.860:FF:000033', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(116121, NULL, 'G3DSA:2.60.40.10:FF:000699', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(116122, NULL, 'G3DSA:3.40.50.2300:FF:001355', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116123, NULL, 'G3DSA:3.40.50.11990:FF:000006', NULL, NULL, 'CDC73 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(116124, NULL, 'G3DSA:3.40.50.2000:FF:000765', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(116125, NULL, 'G3DSA:3.40.50.720:FF:002433', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase (NAD(P)(+))', NULL, NULL, NULL, NULL, NULL, 4),
(116126, NULL, 'G3DSA:2.130.10.10:FF:005915', NULL, NULL, 'Serine/threonine-protein kinase ppk19', NULL, NULL, NULL, NULL, NULL, 4),
(116127, NULL, 'G3DSA:3.40.50.2300:FF:000394', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(116128, NULL, 'G3DSA:3.30.70.1230:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116129, NULL, 'G3DSA:3.40.30.10:FF:000641', NULL, NULL, 'Rho-class glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(116130, NULL, 'G3DSA:3.30.1360.40:FF:000011', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(116131, NULL, 'G3DSA:3.60.15.10:FF:000116', NULL, NULL, 'Cleavage and polyadenylation specificity factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116132, NULL, 'G3DSA:3.10.250.10:FF:000016', NULL, NULL, 'Scavenger receptor cysteine-rich protein type 12', NULL, NULL, NULL, NULL, NULL, 4),
(116133, NULL, 'G3DSA:3.40.190.290:FF:000092', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(116134, NULL, 'G3DSA:3.10.120.10:FF:000012', NULL, NULL, 'Mitochondrial cytochrome b2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116135, NULL, 'G3DSA:3.10.310.10:FF:000061', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(116136, NULL, 'G3DSA:3.10.490.20:FF:000003', NULL, NULL, 'Dynein heavy chain 5, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(116137, NULL, 'G3DSA:2.40.160.110:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116138, NULL, 'G3DSA:2.10.230.10:FF:000002', NULL, NULL, 'Molecular chaperone DnaJ', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(116139, NULL, 'G3DSA:3.30.1120.30:FF:000024', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(116140, NULL, 'G3DSA:1.20.1050.10:FF:000314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116141, NULL, 'G3DSA:2.20.25.30:FF:000003', NULL, NULL, '50S ribosomal protein L37e', NULL, NULL, NULL, NULL, NULL, 4),
(116142, NULL, 'G3DSA:1.10.287.1540:FF:000001', NULL, NULL, 'Activator of photopigment and puc expression', NULL, NULL, NULL, NULL, NULL, 4),
(116143, NULL, 'G3DSA:1.20.5.1940:FF:000004', NULL, NULL, 'Vacuolar protein sorting-associated protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(116144, NULL, 'G3DSA:2.10.25.10:FF:000767', NULL, NULL, 'Vasorin a', NULL, NULL, NULL, NULL, NULL, 4),
(116145, NULL, 'G3DSA:3.30.160.60:FF:003223', NULL, NULL, 'FI23536p1', NULL, NULL, NULL, NULL, NULL, 4),
(116146, NULL, 'G3DSA:3.40.50.720:FF:000292', NULL, NULL, 'Putative D-lactate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(116147, NULL, 'G3DSA:1.10.8.1210:FF:000002', NULL, NULL, 'Glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(116148, NULL, 'G3DSA:3.10.100.10:FF:000247', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116149, NULL, 'G3DSA:3.80.10.10:FF:002448', NULL, NULL, 'Leucine-rich repeat protein (LRRP)', NULL, NULL, NULL, NULL, NULL, 4),
(116150, NULL, 'G3DSA:1.10.30.10:FF:000006', NULL, NULL, 'High mobility group protein B1', NULL, NULL, NULL, NULL, NULL, 4),
(116151, NULL, 'G3DSA:4.10.780.10:FF:000007', NULL, NULL, 'Pyruvate:ferredoxin oxidoreductase/NADPH-cytochrome P450 reductase PNO', NULL, NULL, NULL, NULL, NULL, 4),
(116152, NULL, 'G3DSA:1.20.1070.10:FF:000641', NULL, NULL, 'Adhesion G protein-coupled receptor L3', NULL, NULL, NULL, NULL, NULL, 4),
(116153, NULL, 'G3DSA:2.60.40.10:FF:005606', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116154, NULL, 'G3DSA:3.40.1440.10:FF:000012', NULL, NULL, 'Structure-specific endonuclease subunit SLX1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(116155, NULL, 'G3DSA:2.60.40.150:FF:000045', NULL, NULL, 'Dedicator of cytokinesis protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(116156, NULL, 'G3DSA:3.10.450.240:FF:000003', NULL, NULL, '39S ribosomal protein L45, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(116157, NULL, 'G3DSA:3.20.20.80:FF:000055', NULL, NULL, 'Trehalose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(116158, NULL, 'G3DSA:2.120.10.30:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116159, NULL, 'G3DSA:2.60.40.10:FF:002610', NULL, NULL, 'Muscle M-line assembly protein unc-89-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(116160, NULL, 'G3DSA:3.40.1110.10:FF:000038', NULL, NULL, 'Copper-exporting P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(116161, NULL, 'G3DSA:3.90.530.10:FF:000003', NULL, NULL, 'Dna repair rad14 protein', NULL, NULL, NULL, NULL, NULL, 4),
(116162, NULL, 'G3DSA:1.50.10.10:FF:000110', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(116163, NULL, 'G3DSA:1.10.10.10:FF:000230', NULL, NULL, 'HTH-type transcriptional regulator tdcA', NULL, NULL, NULL, NULL, NULL, 4),
(116164, NULL, 'G3DSA:1.20.58.60:FF:000826', NULL, NULL, 'Si:ch211-207i1.2', NULL, NULL, NULL, NULL, NULL, 4),
(116165, NULL, 'G3DSA:1.10.630.10:FF:000643', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116166, NULL, 'G3DSA:3.30.70.330:FF:001507', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116167, NULL, 'G3DSA:2.130.10.10:FF:001644', NULL, NULL, 'Dynein axonemal intermediate chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(116168, NULL, 'G3DSA:2.60.40.10:FF:001317', NULL, NULL, 'Immunoglobulin kappa chain variable 4-54', NULL, NULL, NULL, NULL, NULL, 4),
(116169, NULL, 'G3DSA:3.30.450.20:FF:000581', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116170, NULL, 'G3DSA:1.25.40.20:FF:001078', NULL, NULL, 'arf-GAP with GTPase, ANK repeat and PH domain-containing protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(116171, NULL, 'G3DSA:1.10.510.10:FF:001084', NULL, NULL, 'Unplaced genomic scaffold supercont1.29, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(116172, NULL, 'G3DSA:1.20.1110.10:FF:000027', NULL, NULL, 'Calcium-transporting ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116173, NULL, 'G3DSA:3.40.50.720:FF:002214', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(116174, NULL, 'G3DSA:3.40.50.720:FF:001596', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116175, NULL, 'G3DSA:1.25.10.10:FF:002664', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116176, NULL, 'G3DSA:3.30.230.130:FF:000068', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(116177, NULL, 'G3DSA:1.20.58.90:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116178, NULL, 'G3DSA:2.30.29.30:FF:000719', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116179, NULL, 'G3DSA:3.40.50.2000:FF:000186', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(116180, NULL, 'G3DSA:3.30.70.330:FF:002800', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116181, NULL, 'G3DSA:1.20.1740.10:FF:000041', NULL, NULL, 'Amino acid permease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116182, NULL, 'G3DSA:3.10.110.10:FF:000186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116183, NULL, 'G3DSA:1.20.1740.10:FF:000165', NULL, NULL, 'Amino acid transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(116184, NULL, 'G3DSA:3.30.40.10:FF:000333', NULL, NULL, 'Zinc finger FYVE-type containing 19', NULL, NULL, NULL, NULL, NULL, 4),
(116185, NULL, 'G3DSA:1.20.58.70:FF:000020', NULL, NULL, 't-SNARE domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(116186, NULL, 'G3DSA:3.40.50.300:FF:006933', NULL, NULL, 'Cytidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(116187, NULL, 'G3DSA:3.40.30.10:FF:000422', NULL, NULL, 'Peroxiredoxin-like 2 family protein, selenocysteine-containing', NULL, NULL, NULL, NULL, NULL, 4),
(116188, NULL, 'G3DSA:3.30.470.20:FF:000014', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(116189, NULL, 'G3DSA:2.30.250.10:FF:000009', NULL, NULL, 'Aspartyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(116190, NULL, 'G3DSA:2.30.30.100:FF:000153', NULL, NULL, 'Small nuclear ribonucleoprotein F', NULL, NULL, NULL, NULL, NULL, 4),
(116191, NULL, 'G3DSA:3.40.50.1000:FF:000111', NULL, NULL, 'Trehalose-6-phosphate synthase 6', NULL, NULL, NULL, NULL, NULL, 4),
(116192, NULL, 'G3DSA:2.30.29.30:FF:000377', NULL, NULL, 'Shc transforming protein', NULL, NULL, NULL, NULL, NULL, 4),
(116193, NULL, 'G3DSA:2.40.240.10:FF:000024', NULL, NULL, 'Glutamine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(116194, NULL, 'G3DSA:3.20.20.450:FF:000029', NULL, NULL, 'Putative diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(116195, NULL, 'G3DSA:1.10.600.10:FF:000130', NULL, NULL, 'Os11g0474583 protein', NULL, NULL, NULL, NULL, NULL, 4),
(116196, NULL, 'G3DSA:1.10.10.60:FF:001054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116197, NULL, 'G3DSA:1.20.120.1240:FF:000038', NULL, NULL, 'Dynamin related protein', NULL, NULL, NULL, NULL, NULL, 4),
(116198, NULL, 'G3DSA:3.20.20.140:FF:000055', NULL, NULL, 'Uracil-5-carboxylate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(116199, NULL, 'G3DSA:2.60.40.10:FF:005483', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116200, NULL, 'G3DSA:1.20.5.320:FF:000021', NULL, NULL, 'COL24A1 isoform 5', NULL, NULL, NULL, NULL, NULL, 4),
(116201, NULL, 'G3DSA:3.40.50.300:FF:005174', NULL, NULL, 'ATP-dependent dethiobiotin synthetase BioD', NULL, NULL, NULL, NULL, NULL, 4),
(116202, NULL, 'G3DSA:3.30.60.20:FF:000101', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(116203, NULL, 'G3DSA:1.10.8.10:FF:000263', NULL, NULL, 'Death-associated inhibitor of apoptosis 2', NULL, NULL, NULL, NULL, NULL, 4),
(116204, NULL, 'G3DSA:1.20.1070.10:FF:000080', NULL, NULL, 'probable G-protein coupled receptor 63', NULL, NULL, NULL, NULL, NULL, 4),
(116205, NULL, 'G3DSA:3.30.740.10:FF:000004', NULL, NULL, 'Dynein light chain', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(116206, NULL, 'G3DSA:3.20.20.70:FF:000850', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116207, NULL, 'G3DSA:1.20.1420.10:FF:000017', NULL, NULL, 'Talin', NULL, NULL, NULL, NULL, NULL, 4),
(116208, NULL, 'G3DSA:1.10.472.10:FF:000590', NULL, NULL, 'Cyclin, N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(116209, NULL, 'G3DSA:2.130.10.10:FF:004499', NULL, NULL, 'Cytoplasmic dynein 1 intermediate chain-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(116210, NULL, 'G3DSA:3.30.1640.10:FF:000069', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(116211, NULL, 'G3DSA:3.40.309.10:FF:000062', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(116212, NULL, 'G3DSA:3.90.190.20:FF:000018', NULL, NULL, 'Folylpolyglutamate synthase/dihydrofolate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(116213, NULL, 'G3DSA:2.60.120.10:FF:000544', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(116214, NULL, 'G3DSA:2.60.120.260:FF:000065', NULL, NULL, 'Beta-galactosidase A', NULL, NULL, NULL, NULL, NULL, 4),
(116215, NULL, 'G3DSA:1.10.730.10:FF:000010', NULL, NULL, 'methionine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(116216, NULL, 'G3DSA:3.80.10.10:FF:003960', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', NULL, NULL, NULL, NULL, NULL, 4),
(116217, NULL, 'G3DSA:3.90.70.200:FF:000005', NULL, NULL, 'Related to Pol II transcription elongation factor', NULL, NULL, NULL, NULL, NULL, 4),
(116218, NULL, 'G3DSA:3.30.300.130:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116219, NULL, 'G3DSA:3.30.360.20:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116220, NULL, 'G3DSA:3.30.70.890:FF:000017', NULL, NULL, 'MeValonate Kinase', NULL, NULL, NULL, NULL, NULL, 4),
(116221, NULL, 'G3DSA:1.10.510.10:FF:003804', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116222, NULL, 'G3DSA:1.20.1720.10:FF:000057', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(116223, NULL, 'G3DSA:3.40.50.300:FF:005972', NULL, NULL, 'ATP-binding cassette alpha-factor transporter', NULL, NULL, NULL, NULL, NULL, 4),
(116224, NULL, 'G3DSA:2.60.40.1180:FF:000205', NULL, NULL, 'Endoglycoceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(116225, NULL, 'G3DSA:1.10.510.10:FF:002045', NULL, NULL, 'Protein CBG14958', NULL, NULL, NULL, NULL, NULL, 4),
(116226, NULL, 'G3DSA:1.25.40.570:FF:000047', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit E', NULL, NULL, NULL, NULL, NULL, 4),
(116227, NULL, 'G3DSA:1.25.10.10:FF:001028', NULL, NULL, 'Unplaced genomic scaffold supercont1.17, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(116228, NULL, 'G3DSA:3.90.190.10:FF:000139', NULL, NULL, 'Putative dual specificity phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(116229, NULL, 'G3DSA:3.40.50.1000:FF:000330', NULL, NULL, 'Copper-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(116230, NULL, 'G3DSA:3.40.50.720:FF:000977', NULL, NULL, 'Ornithine cyclodeaminase', NULL, NULL, NULL, NULL, NULL, 4),
(116231, NULL, 'G3DSA:1.20.120.1080:FF:000081', NULL, NULL, 'Tudor domain containing 9', NULL, NULL, NULL, NULL, NULL, 4),
(116232, NULL, 'G3DSA:1.10.3810.10:FF:000004', NULL, NULL, 'Biosynthetic peptidoglycan transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(116233, NULL, 'G3DSA:3.60.10.10:FF:000021', NULL, NULL, 'PGAP2-interacting protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(116234, NULL, 'G3DSA:3.30.160.60:FF:002262', NULL, NULL, 'Zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(116235, NULL, 'G3DSA:2.40.30.10:FF:000025', NULL, NULL, 'Nitric oxide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(116236, NULL, 'G3DSA:1.10.1780.10:FF:000001', NULL, NULL, 'ATP-dependent Clp protease ATP-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(116237, NULL, 'G3DSA:1.10.510.10:FF:001769', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116238, NULL, 'G3DSA:3.30.56.10:FF:000004', NULL, NULL, 'Phenylalanyl-tRNA synthetase, beta subunit', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(116239, NULL, 'G3DSA:2.30.29.30:FF:000938', NULL, NULL, 'UDP-sugar-dependent glycosyltransferase 52', NULL, NULL, NULL, NULL, NULL, 4),
(116240, NULL, 'G3DSA:3.90.1750.10:FF:000030', NULL, NULL, 'IQ and HECT domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(116241, NULL, 'G3DSA:1.25.40.60:FF:000005', NULL, NULL, 'Vacuolar protein sorting-associated protein 45 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(116242, NULL, 'G3DSA:3.30.450.20:FF:000344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116243, NULL, 'G3DSA:2.30.140.10:FF:000018', NULL, NULL, 'Spermine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(116244, NULL, 'G3DSA:2.10.25.10:FF:001386', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116245, NULL, 'G3DSA:1.20.1560.10:FF:000179', NULL, NULL, 'Abc transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(116246, NULL, 'G3DSA:3.30.2410.10:FF:000030', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(116247, NULL, 'G3DSA:3.50.50.60:FF:001382', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116248, NULL, 'G3DSA:3.30.9.10:FF:000042', NULL, NULL, 'Malate:quinone oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116249, NULL, 'G3DSA:1.20.1250.20:FF:002209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116250, NULL, 'G3DSA:1.10.10.880:FF:000003', NULL, NULL, 'Anti-sigma-E factor RseA', NULL, NULL, NULL, NULL, NULL, 4),
(116251, NULL, 'G3DSA:2.30.42.10:FF:000340', NULL, NULL, 'Zinc metalloprotease', NULL, NULL, NULL, NULL, NULL, 4),
(116252, NULL, 'G3DSA:3.30.200.20:FF:002445', NULL, NULL, 'TGF-beta receptor type-2', NULL, NULL, NULL, NULL, NULL, 4),
(116253, NULL, 'G3DSA:1.25.40.10:FF:003453', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At1g13800', NULL, NULL, NULL, NULL, NULL, 4),
(116254, NULL, 'G3DSA:2.60.120.260:FF:000407', NULL, NULL, 'Carbohydrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(116255, NULL, 'G3DSA:2.10.90.10:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116256, NULL, 'G3DSA:3.30.230.70:FF:000129', NULL, NULL, 'AGAP002177-PA', NULL, NULL, NULL, NULL, NULL, 4),
(116257, NULL, 'G3DSA:1.10.3730.20:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116258, NULL, 'G3DSA:3.40.390.10:FF:000250', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116259, NULL, 'G3DSA:1.50.40.10:FF:000062', NULL, NULL, 'mitochondrial uncoupling protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(116260, NULL, 'G3DSA:2.30.40.10:FF:000173', NULL, NULL, 'Putative formylmethanofuran dehydrogenase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(116261, NULL, 'G3DSA:3.30.930.10:FF:000272', NULL, NULL, 'ATP phosphoribosyltransferase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(116262, NULL, 'G3DSA:3.40.50.880:FF:000199', NULL, NULL, 'Guanine monophosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(116263, NULL, 'G3DSA:3.50.50.60:FF:000089', NULL, NULL, 'dimethylglycine dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(116264, NULL, 'G3DSA:3.40.50.300:FF:001369', NULL, NULL, 'Putative pre-mRNA splicing factor', NULL, NULL, NULL, NULL, NULL, 4),
(116265, NULL, 'G3DSA:1.25.40.90:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116266, NULL, 'G3DSA:2.70.170.10:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116267, NULL, 'G3DSA:3.40.50.2300:FF:000377', NULL, NULL, 'Metabotropic GLutamate receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(116268, NULL, 'G3DSA:3.60.21.10:FF:000411', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(116269, NULL, 'G3DSA:3.10.20.320:FF:000004', NULL, NULL, 'LPXTG cell wall anchor domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(116270, NULL, 'G3DSA:3.40.50.1910:FF:000035', NULL, NULL, 'Syntaxin binding protein 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116271, NULL, 'G3DSA:3.40.50.300:FF:007355', NULL, NULL, 'Dicer-1', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(116272, NULL, 'G3DSA:1.25.10.10:FF:001422', NULL, NULL, 'HEAT repeat containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(116273, NULL, 'G3DSA:3.60.10.10:FF:000122', NULL, NULL, 'Frag1/DRAM/Sfk1_family_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(116274, NULL, 'G3DSA:1.25.40.10:FF:003048', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g67570, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(116275, NULL, 'G3DSA:3.30.230.10:FF:000179', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(116276, NULL, 'G3DSA:1.10.630.10:FF:000704', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116277, NULL, 'G3DSA:3.40.1160.10:FF:000092', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(116278, NULL, 'G3DSA:1.20.58.1100:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116279, NULL, 'G3DSA:3.40.50.12780:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116280, NULL, 'G3DSA:2.130.10.10:FF:005404', NULL, NULL, 'Kinesin-Like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(116281, NULL, 'G3DSA:2.80.10.50:FF:000017', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(116282, NULL, 'G3DSA:2.60.120.330:FF:000052', NULL, NULL, '1-aminocyclopropane-1-carboxylate oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(116283, NULL, 'G3DSA:3.40.50.720:FF:002074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116284, NULL, 'G3DSA:3.30.70.330:FF:001390', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(116285, NULL, 'G3DSA:1.20.120.1080:FF:000092', NULL, NULL, 'ATP-dependent RNA helicase DEAH13', NULL, NULL, NULL, NULL, NULL, 4),
(116286, NULL, 'G3DSA:1.10.510.10:FF:002202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116287, NULL, 'G3DSA:3.10.450.240:FF:000014', NULL, NULL, 'Meiotic recombination protein DMC1', NULL, NULL, NULL, NULL, NULL, 4),
(116288, NULL, 'G3DSA:3.40.50.10090:FF:000021', NULL, NULL, 'Uroporphyrinogen-III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(116289, NULL, 'G3DSA:3.30.160.60:FF:000025', NULL, NULL, 'Spalt-like transcription factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(116290, NULL, 'G3DSA:1.20.1270.60:FF:000031', NULL, NULL, 'Putative DCC-interacting protein 13-beta isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(116291, NULL, 'G3DSA:3.90.320.10:FF:000021', NULL, NULL, 'DNA helicase UvrD', NULL, NULL, NULL, NULL, NULL, 4),
(116292, NULL, 'G3DSA:3.10.20.310:FF:000001', NULL, NULL, 'Outer membrane protein assembly factor BamA', NULL, NULL, NULL, NULL, NULL, 4),
(116293, NULL, 'G3DSA:3.30.499.10:FF:000010', NULL, NULL, '3-isopropylmalate dehydratase large subunit, chloroplastic-like', NULL, NULL, NULL, NULL, NULL, 4),
(116294, NULL, 'G3DSA:2.70.98.30:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116295, NULL, 'G3DSA:3.40.50.300:FF:005264', NULL, NULL, 'Si:ch211-227e10.1', NULL, NULL, NULL, NULL, NULL, 4),
(116296, NULL, 'G3DSA:3.90.1640.10:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116297, NULL, 'G3DSA:3.60.40.10:FF:000096', NULL, NULL, 'Protein phosphatase PPM8, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116298, NULL, 'G3DSA:1.20.58.60:FF:000169', NULL, NULL, 'nesprin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(116299, NULL, 'G3DSA:3.30.70.270:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116300, NULL, 'G3DSA:1.20.5.540:FF:000002', NULL, NULL, 'Succinate dehydrogenase cytochrome b560 subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(116301, NULL, 'G3DSA:3.20.20.80:FF:000572', NULL, NULL, 'Beta-mannanase', NULL, NULL, NULL, NULL, NULL, 4),
(116302, NULL, 'G3DSA:2.30.29.30:FF:001012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116303, NULL, 'G3DSA:3.30.70.260:FF:000093', NULL, NULL, 'UPF0250 protein BLA59_03950', NULL, NULL, NULL, NULL, NULL, 4),
(116304, NULL, 'G3DSA:2.60.40.10:FF:005426', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(116305, NULL, 'G3DSA:3.40.1110.10:FF:000055', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(116306, NULL, 'G3DSA:1.20.120.1220:FF:000004', NULL, NULL, 'Type 4 prepilin-like proteins leader peptide-processing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(116307, NULL, 'G3DSA:3.40.1190.20:FF:000130', NULL, NULL, 'Ribokinase', NULL, NULL, NULL, NULL, NULL, 4),
(116308, NULL, 'G3DSA:3.30.70.330:FF:000928', NULL, NULL, 'U4/U6 snRNA-associated-splicing factor', NULL, NULL, NULL, NULL, NULL, 4),
(116309, NULL, 'G3DSA:3.40.50.1820:FF:000952', NULL, NULL, 'Slr1506 protein', NULL, NULL, NULL, NULL, NULL, 4),
(116310, NULL, 'G3DSA:1.10.418.10:FF:000189', NULL, NULL, 'Coiled-coil domain containing 88A', NULL, NULL, NULL, NULL, NULL, 4),
(116311, NULL, 'G3DSA:3.30.40.10:FF:002019', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(116312, NULL, 'G3DSA:1.10.10.60:FF:000222', NULL, NULL, 'Transcription factor MYB36', NULL, NULL, NULL, NULL, NULL, 4),
(116313, NULL, 'G3DSA:2.130.10.10:FF:003313', NULL, NULL, 'transducin beta-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(116314, NULL, 'G3DSA:1.10.287.520:FF:000003', NULL, NULL, 'Bone morphogenetic protein antagonist noggin', NULL, NULL, NULL, NULL, NULL, 4),
(116315, NULL, 'G3DSA:2.30.30.280:FF:000004', NULL, NULL, 'tRNA-specific 2-thiouridylase MnmA', NULL, NULL, NULL, NULL, NULL, 4),
(116316, NULL, 'G3DSA:2.60.40.10:FF:002200', NULL, NULL, 'Interleukin 2 receptor subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(116317, NULL, 'G3DSA:3.30.2350.10:FF:000081', NULL, NULL, 'tRNA pseudouridine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(116318, NULL, 'G3DSA:3.90.640.10:FF:000275', NULL, NULL, 'Mitochondrial-type heat shock protein70 putative', NULL, NULL, NULL, NULL, NULL, 4),
(116319, NULL, 'G3DSA:3.30.40.10:FF:000367', NULL, NULL, 'Cbl proto-oncogene C', NULL, NULL, NULL, NULL, NULL, 4),
(116320, NULL, 'G3DSA:2.130.10.10:FF:001661', NULL, NULL, 'Periodic tryptophan protein 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(116321, NULL, 'G3DSA:3.40.50.2000:FF:000877', NULL, NULL, 'Mannosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116322, NULL, 'G3DSA:3.90.180.10:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116323, NULL, 'G3DSA:1.20.58.60:FF:000702', NULL, NULL, 'CDC-42 Guanine nucleotide Exchange Factor', NULL, NULL, NULL, NULL, NULL, 4),
(116324, NULL, 'G3DSA:1.10.533.10:FF:000001', NULL, NULL, 'Unc-5 netrin receptor B', NULL, NULL, NULL, NULL, NULL, 4),
(116325, NULL, 'G3DSA:1.10.287.70:FF:000255', NULL, NULL, 'TWiK family of potassium channels', NULL, NULL, NULL, NULL, NULL, 4),
(116326, NULL, 'G3DSA:2.120.10.80:FF:000288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116327, NULL, 'G3DSA:1.10.555.10:FF:000046', NULL, NULL, 'Rho GTPase-activating protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(116328, NULL, 'G3DSA:3.80.10.10:FF:001301', NULL, NULL, 'Leucine rich repeat and phosphatase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(116329, NULL, 'G3DSA:1.20.58.60:FF:000848', NULL, NULL, 'Microtubule-actin cross-linking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(116330, NULL, 'G3DSA:3.40.50.1010:FF:000243', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116331, NULL, 'G3DSA:2.60.40.820:FF:000027', NULL, NULL, 'Tbx15 protein', NULL, NULL, NULL, NULL, NULL, 4),
(116332, NULL, 'G3DSA:1.10.287.130:FF:000009', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(116333, NULL, 'G3DSA:3.40.190.10:FF:000925', NULL, NULL, 'AGAP006026-PA', NULL, NULL, NULL, NULL, NULL, 4),
(116334, NULL, 'G3DSA:1.20.120.1630:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116335, NULL, 'G3DSA:2.60.40.10:FF:001683', NULL, NULL, 'Protein tyrosine phosphatase, receptor type Q', NULL, NULL, NULL, NULL, NULL, 4),
(116336, NULL, 'G3DSA:3.60.60.10:FF:000007', NULL, NULL, 'Dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(116337, NULL, 'G3DSA:3.40.50.1000:FF:000240', NULL, NULL, 'Hydrolase (HAD superfamily)', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(116338, NULL, 'G3DSA:3.40.50.150:FF:001661', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116339, NULL, 'G3DSA:1.20.1250.20:FF:002193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116340, NULL, 'G3DSA:1.25.10.10:FF:000320', NULL, NULL, 'DnaJ homolog subfamily C GRV2', NULL, NULL, NULL, NULL, NULL, 4),
(116341, NULL, 'G3DSA:3.90.1290.10:FF:000016', NULL, NULL, 'Uncharacterized protein, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(116342, NULL, 'G3DSA:1.20.1420.30:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116343, NULL, 'G3DSA:3.30.2230.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116344, NULL, 'G3DSA:1.10.8.60:FF:000502', NULL, NULL, 'ATPase, AAA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(116345, NULL, 'G3DSA:1.20.58.1120:FF:000017', NULL, NULL, 'Dynein beta chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116346, NULL, 'G3DSA:3.40.50.300:FF:007029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116347, NULL, 'G3DSA:1.10.510.10:FF:003304', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116348, NULL, 'G3DSA:3.30.1370.210:FF:000020', NULL, NULL, 'Zinc finger protein family member', NULL, NULL, NULL, NULL, NULL, 4),
(116349, NULL, 'G3DSA:3.40.50.620:FF:000745', NULL, NULL, 'Glr0923 protein', NULL, NULL, NULL, NULL, NULL, 4),
(116350, NULL, 'G3DSA:3.90.1150.10:FF:000478', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116351, NULL, 'G3DSA:2.20.70.10:FF:000169', NULL, NULL, 'Pre-mRNA processing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116352, NULL, 'G3DSA:2.40.50.140:FF:000942', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116353, NULL, 'G3DSA:1.10.1200.270:FF:000001', NULL, NULL, 'Salicylate/benzoate carboxyl methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(116354, NULL, 'G3DSA:3.40.50.410:FF:000154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116355, NULL, 'G3DSA:1.10.10.10:FF:001096', NULL, NULL, 'Protein FEV', NULL, NULL, NULL, NULL, NULL, 4),
(116356, NULL, 'G3DSA:3.40.50.2000:FF:000405', NULL, NULL, 'WbcM protein', NULL, NULL, NULL, NULL, NULL, 4),
(116357, NULL, 'G3DSA:1.25.40.10:FF:004829', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116358, NULL, 'G3DSA:2.60.120.920:FF:000015', NULL, NULL, 'LOW QUALITY PROTEIN: probable E3 ubiquitin-protein ligase HERC1', NULL, NULL, NULL, NULL, NULL, 4),
(116359, NULL, 'G3DSA:3.30.930.10:FF:000007', NULL, NULL, 'Bifunctional glutamate/proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(116360, NULL, 'G3DSA:2.60.40.10:FF:005752', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116361, NULL, 'G3DSA:3.30.160.60:FF:002588', NULL, NULL, 'Zinc finger protein 787', NULL, NULL, NULL, NULL, NULL, 4),
(116362, NULL, 'G3DSA:2.40.240.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116363, NULL, 'G3DSA:3.30.160.60:FF:002003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116364, NULL, 'G3DSA:3.40.720.10:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116365, NULL, 'G3DSA:3.90.79.10:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116366, NULL, 'G3DSA:1.25.40.20:FF:000151', NULL, NULL, 'Tonsoku like, DNA repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(116367, NULL, 'G3DSA:2.10.110.10:FF:000049', NULL, NULL, 'Four and a half LIM domains protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(116368, NULL, 'G3DSA:3.40.190.170:FF:000016', NULL, NULL, 'C4-dicarboxylase binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(116369, NULL, 'G3DSA:3.40.50.1460:FF:000029', NULL, NULL, 'Death related ced-3/Nedd2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(116370, NULL, 'G3DSA:3.80.10.10:FF:000784', NULL, NULL, 'leucine-rich repeat receptor protein kinase EMS1', NULL, NULL, NULL, NULL, NULL, 4),
(116371, NULL, 'G3DSA:3.50.50.60:FF:000084', NULL, NULL, 'Flavoprotein disulfide reductase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(116372, NULL, 'G3DSA:2.60.120.290:FF:000079', NULL, NULL, 'Zinc metalloproteinase', NULL, NULL, NULL, NULL, NULL, 4),
(116373, NULL, 'G3DSA:1.20.1270.60:FF:000177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116374, NULL, 'G3DSA:2.170.300.10:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116375, NULL, 'G3DSA:3.40.50.620:FF:000099', NULL, NULL, 'cryptochrome-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(116376, NULL, 'G3DSA:1.20.1560.10:FF:000196', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116377, NULL, 'G3DSA:3.30.160.60:FF:005494', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116378, NULL, 'G3DSA:2.60.40.10:FF:001418', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(116379, NULL, 'G3DSA:3.40.50.200:FF:000063', NULL, NULL, 'p-domain proprotein convertase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116380, NULL, 'G3DSA:2.130.10.10:FF:001335', NULL, NULL, 'Guanine nucleotide-binding protein subunit beta 2-l', NULL, NULL, NULL, NULL, NULL, 4),
(116381, NULL, 'G3DSA:3.60.140.10:FF:000019', NULL, NULL, 'Polyphenol oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(116382, NULL, 'G3DSA:1.20.1070.10:FF:000175', NULL, NULL, 'Prostaglandin D2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(116383, NULL, 'G3DSA:3.30.160.60:FF:005229', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116384, NULL, 'G3DSA:2.40.10.10:FF:000676', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116385, NULL, 'G3DSA:1.25.40.10:FF:003374', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g55740, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(116386, NULL, 'G3DSA:1.25.40.90:FF:000065', NULL, NULL, 'ENTH domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(116387, NULL, 'G3DSA:3.30.160.60:FF:003105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116388, NULL, 'G3DSA:3.30.780.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116389, NULL, 'G3DSA:1.25.40.180:FF:000340', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116390, NULL, 'G3DSA:1.20.1270.280:FF:000031', NULL, NULL, 'Putative dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(116391, NULL, 'G3DSA:3.40.50.150:FF:000233', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase C', NULL, NULL, NULL, NULL, NULL, 4),
(116392, NULL, 'G3DSA:3.20.20.70:FF:000243', NULL, NULL, 'Probable transmembrane GTPase FZO-like, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(116393, NULL, 'G3DSA:3.30.420.10:FF:000216', NULL, NULL, 'Exosome complex exonuclease RRP6, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116394, NULL, 'G3DSA:1.10.10.350:FF:000002', NULL, NULL, 'Glutamate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(116395, NULL, 'G3DSA:3.30.470.30:FF:000085', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(116396, NULL, 'G3DSA:3.90.245.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116397, NULL, 'G3DSA:3.40.50.620:FF:000571', NULL, NULL, 'Phosphopantetheine adenylyltransferase putative', NULL, NULL, NULL, NULL, NULL, 4),
(116398, NULL, 'G3DSA:2.30.39.10:FF:000135', NULL, NULL, 'Serpin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116399, NULL, 'G3DSA:1.25.40.10:FF:004476', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g61870, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(116400, NULL, 'G3DSA:3.10.129.10:FF:000094', NULL, NULL, '4-hydroxybenzoyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(116401, NULL, 'G3DSA:3.20.20.80:FF:000246', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(116402, NULL, 'G3DSA:3.40.50.2000:FF:000731', NULL, NULL, 'Putative teichuronic acid biosynthesis glycosyl transferase TuaC', NULL, NULL, NULL, NULL, NULL, 4),
(116403, NULL, 'G3DSA:2.170.210.20:FF:000005', NULL, NULL, 'Centriole protein', NULL, NULL, NULL, NULL, NULL, 4),
(116404, NULL, 'G3DSA:3.30.70.3220:FF:000004', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(116405, NULL, 'G3DSA:3.40.50.2300:FF:001220', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116406, NULL, 'G3DSA:2.30.180.10:FF:000133', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116407, NULL, 'G3DSA:3.40.50.300:FF:005590', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116408, NULL, 'G3DSA:3.40.50.300:FF:007681', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116409, NULL, 'G3DSA:3.40.50.300:FF:005910', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116410, NULL, 'G3DSA:2.60.120.200:FF:000272', NULL, NULL, 'Laminin-like protein epi-1', NULL, NULL, NULL, NULL, NULL, 4),
(116411, NULL, 'G3DSA:1.10.287.70:FF:000429', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(116412, NULL, 'G3DSA:3.40.50.980:FF:000010', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(116413, NULL, 'G3DSA:1.10.630.10:FF:000025', NULL, NULL, 'Prostaglandin I2 (prostacyclin) synthase', NULL, NULL, NULL, NULL, NULL, 4),
(116414, NULL, 'G3DSA:1.10.510.10:FF:001685', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116415, NULL, 'G3DSA:3.30.40.10:FF:001210', NULL, NULL, 'PHD-finger domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(116416, NULL, 'G3DSA:2.170.210.10:FF:000002', NULL, NULL, 'DNA repair protein XRCC4', NULL, NULL, NULL, NULL, NULL, 4),
(116417, NULL, 'G3DSA:3.30.200.20:FF:000534', NULL, NULL, 'Myosin light chain kinase', NULL, NULL, NULL, NULL, NULL, 4),
(116418, NULL, 'G3DSA:1.10.10.10:FF:001449', NULL, NULL, 'Vacuolar-sorting protein SNF8', NULL, NULL, NULL, NULL, NULL, 4),
(116419, NULL, 'G3DSA:3.30.470.20:FF:000082', NULL, NULL, 'D-alanine-D-alanine ligase family', NULL, NULL, NULL, NULL, NULL, 4),
(116420, NULL, 'G3DSA:2.60.40.10:FF:001357', NULL, NULL, 'Interferon lambda receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(116421, NULL, 'G3DSA:3.90.1410.10:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116422, NULL, 'G3DSA:3.30.70.2850:FF:000027', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(116423, NULL, 'G3DSA:1.10.510.10:FF:003630', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116424, NULL, 'G3DSA:1.25.40.20:FF:001286', NULL, NULL, 'Transient receptor potential ion channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(116425, NULL, 'G3DSA:1.25.10.10:FF:002883', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(116426, NULL, 'G3DSA:3.40.50.10330:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116427, NULL, 'G3DSA:3.20.20.100:FF:000150', NULL, NULL, 'Uncharacterized oxidoreductase C28F2.05', NULL, NULL, NULL, NULL, NULL, 4),
(116428, NULL, 'G3DSA:3.30.519.10:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116429, NULL, 'G3DSA:2.60.40.10:FF:003509', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116430, NULL, 'G3DSA:2.10.25.10:FF:000149', NULL, NULL, 'Fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(116431, NULL, 'G3DSA:3.40.50.300:FF:001195', NULL, NULL, 'DNA repair protein rad50', NULL, NULL, NULL, NULL, NULL, 4),
(116432, NULL, 'G3DSA:2.20.200.10:FF:000003', NULL, NULL, 'Multidrug efflux outer membrane protein OprN', NULL, NULL, NULL, NULL, NULL, 4),
(116433, NULL, 'G3DSA:2.130.10.10:FF:004887', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116434, NULL, 'G3DSA:2.30.29.170:FF:000003', NULL, NULL, 'EF-hand domain (C-terminal) containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(116435, NULL, 'G3DSA:4.10.400.10:FF:000103', NULL, NULL, 'Atrial natriuretic peptide-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(116436, NULL, 'G3DSA:3.30.70.330:FF:002699', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116437, NULL, 'G3DSA:1.25.40.10:FF:001603', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116438, NULL, 'G3DSA:3.40.50.300:FF:003347', NULL, NULL, 'N-acetyltransferase, GNAT family protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(116439, NULL, 'G3DSA:1.20.1280.290:FF:000098', NULL, NULL, 'Sugar transporter SWEET', NULL, NULL, NULL, NULL, NULL, 4),
(116440, NULL, 'G3DSA:3.40.250.10:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116441, NULL, 'G3DSA:2.40.70.10:FF:000359', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116442, NULL, 'G3DSA:3.40.50.300:FF:006692', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116443, NULL, 'G3DSA:2.130.10.10:FF:002796', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116444, NULL, 'G3DSA:1.20.58.1380:FF:000016', NULL, NULL, 'ADR216Wp', NULL, NULL, NULL, NULL, NULL, 4),
(116445, NULL, 'G3DSA:1.25.10.10:FF:003193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116446, NULL, 'G3DSA:2.60.120.10:FF:000061', NULL, NULL, 'Potassium voltage-gated channel subfamily H member 3', NULL, NULL, NULL, NULL, NULL, 4),
(116447, NULL, 'G3DSA:3.80.10.10:FF:004527', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116448, NULL, 'G3DSA:3.80.10.10:FF:001886', NULL, NULL, 'MAP kinase phosphatase with leucine-rich repeats protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(116449, NULL, 'G3DSA:3.40.50.10490:FF:000051', NULL, NULL, 'Sugar isomerase, AgaS family', NULL, NULL, NULL, NULL, NULL, 4),
(116450, NULL, 'G3DSA:3.40.190.290:FF:000086', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(116451, NULL, 'G3DSA:3.30.465.10:FF:000038', NULL, NULL, 'D-lactate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(116452, NULL, 'G3DSA:1.25.40.20:FF:001606', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116453, NULL, 'G3DSA:3.40.30.10:FF:000315', NULL, NULL, 'Glutathione peroxidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(116454, NULL, 'G3DSA:3.40.50.300:FF:005438', NULL, NULL, 'putative helicase MOV-10 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(116455, NULL, 'G3DSA:3.40.50.620:FF:000419', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(116456, NULL, 'G3DSA:3.30.70.330:FF:003042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116457, NULL, 'G3DSA:2.30.30.140:FF:000221', NULL, NULL, 'glyoxylate/succinic semialdehyde reductase 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(116458, NULL, 'G3DSA:1.20.1050.40:FF:000008', NULL, NULL, 'Putative thimet oligopeptidase (Metallo-peptidase, clan ma(E), family m3)', NULL, NULL, NULL, NULL, NULL, 4),
(116459, NULL, 'G3DSA:3.50.30.20:FF:000003', NULL, NULL, 'Carbamoyl-phosphate synthase arginine-specific small chain', NULL, NULL, NULL, NULL, NULL, 4),
(116460, NULL, 'G3DSA:2.40.50.90:FF:000073', NULL, NULL, 'Tudor domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(116461, NULL, 'G3DSA:3.30.70.1180:FF:000021', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(116462, NULL, 'G3DSA:3.30.1490.220:FF:000004', NULL, NULL, 'Inositol-tetrakisphosphate 1-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(116463, NULL, 'G3DSA:3.40.50.150:FF:000879', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', NULL, NULL, NULL, NULL, NULL, 4),
(116464, NULL, 'G3DSA:3.40.50.300:FF:003286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116465, NULL, 'G3DSA:3.50.30.30:FF:000006', NULL, NULL, 'Putative signal peptide peptidase-like 2B', NULL, NULL, NULL, NULL, NULL, 4),
(116466, NULL, 'G3DSA:1.10.150.20:FF:000244', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(116467, NULL, 'G3DSA:3.30.980.10:FF:000044', NULL, NULL, 'Alanyl-tRNA editing protein AlaX-M', NULL, NULL, NULL, NULL, NULL, 4),
(116468, NULL, 'G3DSA:2.30.30.100:FF:000142', NULL, NULL, 'Small nuclear ribonucleoprotein F, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116469, NULL, 'G3DSA:3.40.50.1820:FF:000008', NULL, NULL, 'Alpha/beta hydrolase domain-containing protein 17B', NULL, NULL, NULL, NULL, NULL, 4),
(116470, NULL, 'G3DSA:3.30.300.350:FF:000004', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(116471, NULL, 'G3DSA:3.30.420.10:FF:000542', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116472, NULL, 'G3DSA:1.25.40.190:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116473, NULL, 'G3DSA:2.60.120.230:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116474, NULL, 'G3DSA:3.20.20.10:FF:000006', NULL, NULL, 'Ornithine decarboxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(116475, NULL, 'G3DSA:2.30.30.40:FF:000130', NULL, NULL, 'Discs large 5, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(116476, NULL, 'G3DSA:3.90.70.10:FF:000001', NULL, NULL, 'Calpain-1 catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(116477, NULL, 'G3DSA:1.25.40.10:FF:000468', NULL, NULL, 'Intraflagellar transport 88 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(116478, NULL, 'G3DSA:3.30.1520.10:FF:000088', NULL, NULL, 'Atypical/BCR protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(116479, NULL, 'G3DSA:3.10.310.40:FF:000007', NULL, NULL, 'Alanine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(116480, NULL, 'G3DSA:3.30.40.10:FF:000193', NULL, NULL, 'lysine-specific demethylase PHF2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(116481, NULL, 'G3DSA:1.25.40.180:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116482, NULL, 'G3DSA:3.20.20.20:FF:000009', NULL, NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(116483, NULL, 'G3DSA:3.90.1750.10:FF:000035', NULL, NULL, 'Circadian trip, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(116484, NULL, 'G3DSA:2.40.30.170:FF:000065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116485, NULL, 'G3DSA:1.25.40.170:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116486, NULL, 'G3DSA:1.20.140.10:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116487, NULL, 'G3DSA:1.10.490.10:FF:000053', NULL, NULL, 'Zgc:92880 protein', NULL, NULL, NULL, NULL, NULL, 4),
(116488, NULL, 'G3DSA:1.10.8.10:FF:000274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116489, NULL, 'G3DSA:3.40.50.300:FF:003965', NULL, NULL, 'Dicer-like 105', NULL, NULL, NULL, NULL, NULL, 4),
(116490, NULL, 'G3DSA:1.20.1310.20:FF:000040', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(116491, NULL, 'G3DSA:3.40.50.970:FF:000092', NULL, NULL, '2-oxoglutarate decarboxylase/hydro-lyase/magnesium ion-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(116492, NULL, 'G3DSA:3.30.70.100:FF:000005', NULL, NULL, 'Copper-exporting P-type ATPase A', NULL, NULL, NULL, NULL, NULL, 4),
(116493, NULL, 'G3DSA:1.10.510.10:FF:001713', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116494, NULL, 'G3DSA:3.40.50.300:FF:006899', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116495, NULL, 'G3DSA:3.40.50.300:FF:007181', NULL, NULL, 'AFR656Cp', NULL, NULL, NULL, NULL, NULL, 4),
(116496, NULL, 'G3DSA:3.80.10.10:FF:002903', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116497, NULL, 'G3DSA:1.10.540.10:FF:000113', NULL, NULL, 'Peroxisomal acyl-coenzyme A oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(116498, NULL, 'G3DSA:2.30.29.30:FF:000169', NULL, NULL, 'Fibroblast growth factor receptor substrate 2', NULL, NULL, NULL, NULL, NULL, 4),
(116499, NULL, 'G3DSA:1.20.1250.20:FF:002367', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116500, NULL, 'G3DSA:3.20.20.70:FF:000743', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116501, NULL, 'G3DSA:3.40.50.300:FF:002976', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(116502, NULL, 'G3DSA:3.40.50.300:FF:001841', NULL, NULL, 'DEAD/DEAH box helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116503, NULL, 'G3DSA:3.30.70.330:FF:000754', NULL, NULL, 'mRNA processing protein', NULL, NULL, NULL, NULL, NULL, 4),
(116504, NULL, 'G3DSA:1.20.1560.10:FF:000050', NULL, NULL, 'Vacuolar ABC heavy metal transporter (Hmt1)', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(116505, NULL, 'G3DSA:3.30.565.10:FF:000102', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(116506, NULL, 'G3DSA:3.10.105.10:FF:000033', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(116507, NULL, 'G3DSA:3.40.50.20:FF:000027', NULL, NULL, 'D-alanine-D-alanine ligase family', NULL, NULL, NULL, NULL, NULL, 4),
(116508, NULL, 'G3DSA:3.30.2410.10:FF:000052', NULL, NULL, 'Probable E3 ubiquitin-protein ligase mug30', NULL, NULL, NULL, NULL, NULL, 4),
(116509, NULL, 'G3DSA:3.30.450.20:FF:000226', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(116510, NULL, 'G3DSA:1.25.10.10:FF:000966', NULL, NULL, 'Armadillo/beta-catenin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(116511, NULL, 'G3DSA:3.20.20.80:FF:000746', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116512, NULL, 'G3DSA:2.60.40.10:FF:001711', NULL, NULL, 'Platelet and endothelial cell adhesion molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(116513, NULL, 'G3DSA:3.30.710.10:FF:000289', NULL, NULL, 'SKP1-like protein 1A isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(116514, NULL, 'G3DSA:2.10.230.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116515, NULL, 'G3DSA:1.20.120.810:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116516, NULL, 'G3DSA:1.10.10.750:FF:000032', NULL, NULL, 'Similar to GTPase-activating protein GYP5', NULL, NULL, NULL, NULL, NULL, 4),
(116517, NULL, 'G3DSA:2.30.42.10:FF:000542', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116518, NULL, 'G3DSA:3.80.10.10:FF:002257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116519, NULL, 'G3DSA:1.25.40.180:FF:000014', NULL, NULL, 'Putative regulator of nonsense transcripts 2', NULL, NULL, NULL, NULL, NULL, 4),
(116520, NULL, 'G3DSA:1.25.40.420:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116521, NULL, 'G3DSA:3.30.420.10:FF:000188', NULL, NULL, 'YALI0B06303p', NULL, NULL, NULL, NULL, NULL, 4),
(116522, NULL, 'G3DSA:2.30.30.380:FF:000001', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(116523, NULL, 'G3DSA:3.30.200.20:FF:001023', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116524, NULL, 'G3DSA:1.50.40.10:FF:000522', NULL, NULL, 'Mitochondrial energy transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(116525, NULL, 'G3DSA:3.40.50.2000:FF:000377', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(116526, NULL, 'G3DSA:3.30.40.10:FF:000428', NULL, NULL, 'U-box domain-containing protein 54', NULL, NULL, NULL, NULL, NULL, 4),
(116527, NULL, 'G3DSA:1.20.1070.10:FF:001895', NULL, NULL, 'Frizzled class receptor 7', NULL, NULL, NULL, NULL, NULL, 4),
(116528, NULL, 'G3DSA:1.10.510.10:FF:001359', NULL, NULL, 'Serine-threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116529, NULL, 'G3DSA:1.10.287.470:FF:000027', NULL, NULL, 'HAE1 family efflux pump MFP component', NULL, NULL, NULL, NULL, NULL, 4),
(116530, NULL, 'G3DSA:2.130.10.10:FF:003813', NULL, NULL, 'AEL063Wp', NULL, NULL, NULL, NULL, NULL, 4),
(116531, NULL, 'G3DSA:3.40.50.720:FF:000303', NULL, NULL, 'Redox-sensing transcriptional repressor Rex', NULL, NULL, NULL, NULL, NULL, 4),
(116532, NULL, 'G3DSA:3.30.70.2610:FF:000006', NULL, NULL, 'RNA polymerase II transcription factor B subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(116533, NULL, 'G3DSA:2.40.20.10:FF:000002', NULL, NULL, 'Hepatocyte growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(116534, NULL, 'G3DSA:1.10.630.10:FF:000351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116535, NULL, 'G3DSA:3.40.50.300:FF:000121', NULL, NULL, 'RNA cytidine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(116536, NULL, 'G3DSA:2.170.240.10:FF:000004', NULL, NULL, 'Collagen type IV alpha 6 chain', NULL, NULL, NULL, NULL, NULL, 4),
(116537, NULL, 'G3DSA:3.30.70.330:FF:000428', NULL, NULL, 'Related to WHI3-involved in regulation of cell size', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(116538, NULL, 'G3DSA:3.40.50.2300:FF:001512', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116539, NULL, 'G3DSA:1.10.1200.10:FF:000042', NULL, NULL, 'Mrpl13p', NULL, NULL, NULL, NULL, NULL, 4),
(116540, NULL, 'G3DSA:1.10.340.70:FF:000009', NULL, NULL, 'Gag-Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(116541, NULL, 'G3DSA:3.40.50.720:FF:000775', NULL, NULL, 'C-terminal-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(116542, NULL, 'G3DSA:2.130.10.10:FF:003252', NULL, NULL, 'WD repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116543, NULL, 'G3DSA:3.40.30.10:FF:001097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116544, NULL, 'G3DSA:3.40.50.720:FF:000157', NULL, NULL, 'Quinoid dihydropteridine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(116545, NULL, 'G3DSA:3.30.460.10:FF:000016', NULL, NULL, 'Multifunctional CCA protein', NULL, NULL, NULL, NULL, NULL, 4),
(116546, NULL, 'G3DSA:2.10.25.10:FF:000475', NULL, NULL, 'latent-transforming growth factor beta-binding protein 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(116547, NULL, 'G3DSA:1.20.120.1080:FF:000119', NULL, NULL, 'YALI0C02365p', NULL, NULL, NULL, NULL, NULL, 4),
(116548, NULL, 'G3DSA:3.40.1110.10:FF:000408', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116549, NULL, 'G3DSA:2.20.100.10:FF:000086', NULL, NULL, 'ADAMTS like 3', NULL, NULL, NULL, NULL, NULL, 4),
(116550, NULL, 'G3DSA:1.20.120.50:FF:000001', NULL, NULL, 'GGDEF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(116551, NULL, 'G3DSA:2.60.40.10:FF:005073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116552, NULL, 'G3DSA:3.30.70.330:FF:002199', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116553, NULL, 'G3DSA:3.40.50.1820:FF:000626', NULL, NULL, 'Probable inactive carboxylesterase Os04g0669700', NULL, NULL, NULL, NULL, NULL, 4),
(116554, NULL, 'G3DSA:3.90.190.10:FF:000493', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116555, NULL, 'G3DSA:1.25.10.10:FF:003046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116556, NULL, 'G3DSA:3.50.50.60:FF:000937', NULL, NULL, 'NADH-rubredoxin oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(116557, NULL, 'G3DSA:2.10.25.10:FF:000621', NULL, NULL, 'Crumbs, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(116558, NULL, 'G3DSA:1.10.287.1150:FF:000002', NULL, NULL, '2-oxoglutarate dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(116559, NULL, 'G3DSA:3.40.50.1820:FF:000334', NULL, NULL, 'S-formylglutathione hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(116560, NULL, 'G3DSA:3.30.460.20:FF:000019', NULL, NULL, 'Magnesium and cobalt transport protein CorA, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116561, NULL, 'G3DSA:3.90.1180.10:FF:000008', NULL, NULL, '50S ribosomal protein L13', NULL, NULL, NULL, NULL, NULL, 4),
(116562, NULL, 'G3DSA:3.60.110.10:FF:000017', NULL, NULL, 'Carbon-nitrogen hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(116563, NULL, 'G3DSA:1.20.1250.20:FF:000568', NULL, NULL, 'Transporter, major facilitator family protein', NULL, NULL, NULL, NULL, NULL, 4),
(116564, NULL, 'G3DSA:1.20.58.60:FF:000641', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116565, NULL, 'G3DSA:2.30.29.30:FF:000702', NULL, NULL, 'EPS8-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(116566, NULL, 'G3DSA:2.40.50.140:FF:000796', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116567, NULL, 'G3DSA:3.30.160.60:FF:003077', NULL, NULL, 'Zinc finger protein 579', NULL, NULL, NULL, NULL, NULL, 4),
(116568, NULL, 'G3DSA:3.30.710.10:FF:000435', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116569, NULL, 'G3DSA:2.60.40.10:FF:000694', NULL, NULL, 'Myotilin', NULL, NULL, NULL, NULL, NULL, 4),
(116570, NULL, 'G3DSA:3.40.1180.10:FF:000003', NULL, NULL, 'Isoprenyl transferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(116571, NULL, 'G3DSA:3.40.50.1220:FF:000008', NULL, NULL, 'Acetolactate synthase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(116572, NULL, 'G3DSA:1.20.1250.20:FF:000922', NULL, NULL, 'Solute carrier family 2 member 13', NULL, NULL, NULL, NULL, NULL, 4),
(116573, NULL, 'G3DSA:4.10.80.30:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116574, NULL, 'G3DSA:1.25.10.10:FF:001129', NULL, NULL, 'Putative STAG3-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(116575, NULL, 'G3DSA:1.20.1090.10:FF:000058', NULL, NULL, 'Glycerol-1-phosphate dehydrogenase (NAD(P)(+))', NULL, NULL, NULL, NULL, NULL, 4),
(116576, NULL, 'G3DSA:2.60.40.60:FF:000776', NULL, NULL, 'Cadherin', NULL, NULL, NULL, NULL, NULL, 4),
(116577, NULL, 'G3DSA:3.30.420.140:FF:000007', NULL, NULL, 'Transcription elongation factor SPT6', NULL, NULL, NULL, NULL, NULL, 4),
(116578, NULL, 'G3DSA:2.130.10.10:FF:005730', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116579, NULL, 'G3DSA:3.90.1150.10:FF:000506', NULL, NULL, 'Glycine cleavage system P protein', NULL, NULL, NULL, NULL, NULL, 4),
(116580, NULL, 'G3DSA:4.10.240.10:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116581, NULL, 'G3DSA:2.130.10.10:FF:003459', NULL, NULL, 'AGAP008620-PA', NULL, NULL, NULL, NULL, NULL, 4),
(116582, NULL, 'G3DSA:2.60.40.10:FF:003156', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(116583, NULL, 'G3DSA:1.20.1560.10:FF:000903', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116584, NULL, 'G3DSA:1.10.2000.10:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116585, NULL, 'G3DSA:2.10.25.10:FF:001577', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116586, NULL, 'G3DSA:3.90.550.20:FF:000007', NULL, NULL, 'Glycosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116587, NULL, 'G3DSA:3.40.190.80:FF:000047', NULL, NULL, 'Carbohydrate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(116588, NULL, 'G3DSA:3.30.40.10:FF:001856', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116589, NULL, 'G3DSA:1.10.510.10:FF:000696', NULL, NULL, 'NIMA-related kinase 10', NULL, NULL, NULL, NULL, NULL, 4),
(116590, NULL, 'G3DSA:3.30.160.60:FF:005022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116591, NULL, 'G3DSA:1.10.10.10:FF:001157', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(116592, NULL, 'G3DSA:2.30.42.10:FF:000216', NULL, NULL, 'Uncharacterized protein, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(116593, NULL, 'G3DSA:1.20.1070.10:FF:002092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116594, NULL, 'G3DSA:3.30.70.270:FF:000157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116595, NULL, 'G3DSA:3.40.1110.10:FF:000201', NULL, NULL, 'Proton motive ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116596, NULL, 'G3DSA:1.20.1070.10:FF:000349', NULL, NULL, 'prolactin-releasing peptide receptor', NULL, NULL, NULL, NULL, NULL, 4),
(116597, NULL, 'G3DSA:3.90.550.10:FF:000004', NULL, NULL, 'UDP-glucose glycoprotein glucosyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(116598, NULL, 'G3DSA:3.30.40.10:FF:002345', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(116599, NULL, 'G3DSA:3.30.70.330:FF:002906', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116600, NULL, 'G3DSA:1.10.287.70:FF:000194', NULL, NULL, 'Voltage-gated Ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(116601, NULL, 'G3DSA:3.30.70.1230:FF:000143', NULL, NULL, 'Adenylate/guanylate cyclase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(116602, NULL, 'G3DSA:3.30.479.10:FF:000008', NULL, NULL, '6-pyruvoyl tetrahydrobiopterin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(116603, NULL, 'G3DSA:2.170.16.10:FF:000008', NULL, NULL, 'Protein RecA', NULL, NULL, NULL, NULL, NULL, 4),
(116604, NULL, 'G3DSA:3.40.50.2000:FF:000905', NULL, NULL, 'UDP-N-acetylglucosamine 2-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(116605, NULL, 'G3DSA:3.30.190.20:FF:000009', NULL, NULL, 'Ribosomal protein L10a', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(116606, NULL, 'G3DSA:3.40.50.620:FF:000806', NULL, NULL, 'Nicotinamide mononucleotide adenylyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116607, NULL, 'G3DSA:3.30.200.20:FF:000826', NULL, NULL, 'Protein CBG09071', NULL, NULL, NULL, NULL, NULL, 4),
(116608, NULL, 'G3DSA:3.30.230.10:FF:000325', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116609, NULL, 'G3DSA:3.30.450.20:FF:000552', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(116610, NULL, 'G3DSA:2.60.40.640:FF:000097', NULL, NULL, 'Arrestin 3, retinal (X-arrestin)', NULL, NULL, NULL, NULL, NULL, 4),
(116611, NULL, 'G3DSA:3.40.190.10:FF:000779', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(116612, NULL, 'G3DSA:3.90.650.10:FF:000040', NULL, NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(116613, NULL, 'G3DSA:1.10.1060.10:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116614, NULL, 'G3DSA:1.25.40.10:FF:005291', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116615, NULL, 'G3DSA:2.30.29.30:FF:000495', NULL, NULL, 'Acidic elicitin A1', NULL, NULL, NULL, NULL, NULL, 4),
(116616, NULL, 'G3DSA:3.50.50.60:FF:000376', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(116617, NULL, 'G3DSA:3.80.10.10:FF:001594', NULL, NULL, 'Os06g0692600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(116618, NULL, 'G3DSA:3.30.160.60:FF:000997', NULL, NULL, 'Zinc finger and BTB domain-containing protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(116619, NULL, 'G3DSA:3.40.50.9100:FF:000001', NULL, NULL, '3-dehydroquinate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(116620, NULL, 'G3DSA:3.30.470.20:FF:000256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116621, NULL, 'G3DSA:3.30.428.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116622, NULL, 'G3DSA:2.60.40.10:FF:001183', NULL, NULL, 'Cytokine receptor common subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(116623, NULL, 'G3DSA:2.40.50.100:FF:000099', NULL, NULL, 'V-type ATP synthase alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(116624, NULL, 'G3DSA:3.40.50.720:FF:000483', NULL, NULL, 'Pentafunctional AROM polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(116625, NULL, 'G3DSA:3.40.50.150:FF:001335', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116626, NULL, 'G3DSA:3.40.50.10330:FF:000109', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(116627, NULL, 'G3DSA:3.40.50.300:FF:005764', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(116628, NULL, 'G3DSA:2.60.40.60:FF:000130', NULL, NULL, 'cadherin-23 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(116629, NULL, 'G3DSA:3.40.50.300:FF:003639', NULL, NULL, 'RAD50 DNA repair-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(116630, NULL, 'G3DSA:1.10.10.60:FF:001296', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116631, NULL, 'G3DSA:2.60.40.10:FF:003335', NULL, NULL, 'Immunoglobulin domain-containing protein Y54G2A.25', NULL, NULL, NULL, NULL, NULL, 4),
(116632, NULL, 'G3DSA:2.10.50.10:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116633, NULL, 'G3DSA:3.90.190.10:FF:000167', NULL, NULL, 'Putative prenylated protein tyrosine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(116634, NULL, 'G3DSA:1.10.287.10:FF:000052', NULL, NULL, 'Asparagine--tRNA ligase, cytoplasmic 1', NULL, NULL, NULL, NULL, NULL, 4),
(116635, NULL, 'G3DSA:3.80.10.10:FF:002083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116636, NULL, 'G3DSA:3.30.160.60:FF:001486', NULL, NULL, 'Zinc finger protein 174', NULL, NULL, NULL, NULL, NULL, 4),
(116637, NULL, 'G3DSA:2.60.120.200:FF:000564', NULL, NULL, 'Galectin-10', NULL, NULL, NULL, NULL, NULL, 4),
(116638, NULL, 'G3DSA:1.10.510.10:FF:003922', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116639, NULL, 'G3DSA:1.10.150.110:FF:000010', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(116640, NULL, 'G3DSA:1.10.12.10:FF:000004', NULL, NULL, 'Delta3,5-delta2,4-dienoyl-CoA isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(116641, NULL, 'G3DSA:1.10.225.10:FF:000027', NULL, NULL, 'MGC154673 protein', NULL, NULL, NULL, NULL, NULL, 4),
(116642, NULL, 'G3DSA:1.20.1560.10:FF:000549', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116643, NULL, 'G3DSA:1.25.40.20:FF:001578', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116644, NULL, 'G3DSA:1.25.40.10:FF:003520', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116645, NULL, 'G3DSA:1.10.287.70:FF:000755', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116646, NULL, 'G3DSA:3.30.470.20:FF:000109', NULL, NULL, 'Inositol 1,3,4-trisphosphate 5/6-kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116647, NULL, 'G3DSA:3.30.930.10:FF:000333', NULL, NULL, 'Prolyl Amino-acyl tRNA Synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(116648, NULL, 'G3DSA:1.10.10.2670:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116649, NULL, 'G3DSA:1.10.3200.20:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116650, NULL, 'G3DSA:3.40.366.10:FF:000059', NULL, NULL, 'Malonyl-CoA--acyl carrier protein transacylase', NULL, NULL, NULL, NULL, NULL, 4),
(116651, NULL, 'G3DSA:1.25.10.10:FF:001276', NULL, NULL, 'formin-like protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(116652, NULL, 'G3DSA:2.40.50.140:FF:000616', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(116653, NULL, 'G3DSA:1.20.5.240:FF:000002', NULL, NULL, 'Matrix metalloproteinase-28-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(116654, NULL, 'G3DSA:3.40.30.10:FF:000141', NULL, NULL, 'Thioredoxin domain-containing protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(116655, NULL, 'G3DSA:3.30.160.60:FF:003431', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116656, NULL, 'G3DSA:3.30.450.20:FF:000373', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(116657, NULL, 'G3DSA:3.40.1110.10:FF:000381', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116658, NULL, 'G3DSA:3.30.9.10:FF:000103', NULL, NULL, 'Opine oxidase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(116659, NULL, 'G3DSA:2.40.128.180:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116660, NULL, 'G3DSA:3.30.40.10:FF:000754', NULL, NULL, 'ATP-dependent helicase ULS1', NULL, NULL, NULL, NULL, NULL, 4),
(116661, NULL, 'G3DSA:2.60.120.650:FF:000058', NULL, NULL, 'Lysine-specific demethylase JMJ25 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(116662, NULL, 'G3DSA:1.10.510.10:FF:003484', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116663, NULL, 'G3DSA:3.20.20.70:FF:000417', NULL, NULL, 'Glycerol uptake operon antiterminator regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(116664, NULL, 'G3DSA:3.30.70.330:FF:001064', NULL, NULL, 'GM25167', NULL, NULL, NULL, NULL, NULL, 4),
(116665, NULL, 'G3DSA:1.10.150.130:FF:000016', NULL, NULL, 'Inner kinetochore protein/centromere binding factor Cbf3a', NULL, NULL, NULL, NULL, NULL, 4),
(116666, NULL, 'G3DSA:1.20.1560.10:FF:000342', NULL, NULL, 'ATP-dependent bile acid transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116667, NULL, 'G3DSA:3.40.50.620:FF:000245', NULL, NULL, 'FAD synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(116668, NULL, 'G3DSA:2.60.40.150:FF:000719', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(116669, NULL, 'G3DSA:3.40.190.10:FF:000572', NULL, NULL, 'Extracellular solute-binding protein family 5', NULL, NULL, NULL, NULL, NULL, 4),
(116670, NULL, 'G3DSA:1.20.1720.10:FF:000085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116671, NULL, 'G3DSA:2.30.27.10:FF:000001', NULL, NULL, 'Attachment protein G3P', NULL, NULL, NULL, NULL, NULL, 4),
(116672, NULL, 'G3DSA:1.25.40.570:FF:000069', NULL, NULL, 'COP9 signalosome complex subunit 2, putative', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(116673, NULL, 'G3DSA:2.60.120.260:FF:000649', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116674, NULL, 'G3DSA:1.10.510.10:FF:000050', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(116675, NULL, 'G3DSA:2.60.490.10:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116676, NULL, 'G3DSA:1.10.287.130:FF:000156', NULL, NULL, 'Probable two-component sensor', NULL, NULL, NULL, NULL, NULL, 4),
(116677, NULL, 'G3DSA:1.10.10.10:FF:000022', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(116678, NULL, 'G3DSA:2.30.30.140:FF:000075', NULL, NULL, 'putative ATP-dependent RNA helicase TDRD12', NULL, NULL, NULL, NULL, NULL, 4),
(116679, NULL, 'G3DSA:1.10.150.120:FF:000013', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(116680, NULL, 'G3DSA:3.30.200.20:FF:000388', NULL, NULL, 'Mitogen-activated protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(116681, NULL, 'G3DSA:2.30.30.40:FF:000012', NULL, NULL, 'Arf-GAP with SH3 domain, ANK repeat and PH domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(116682, NULL, 'G3DSA:2.60.120.290:FF:000107', NULL, NULL, 'Protein CBR-MIG-13', NULL, NULL, NULL, NULL, NULL, 4),
(116683, NULL, 'G3DSA:3.30.450.60:FF:000070', NULL, NULL, 'AP complex subunit sigma', NULL, NULL, NULL, NULL, NULL, 4),
(116684, NULL, 'G3DSA:3.40.50.1820:FF:000126', NULL, NULL, 'Lipase', NULL, NULL, NULL, NULL, NULL, 4),
(116685, NULL, 'G3DSA:3.40.50.720:FF:002366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116686, NULL, 'G3DSA:3.30.160.60:FF:000789', NULL, NULL, 'Zinc finger protein 329', NULL, NULL, NULL, NULL, NULL, 4),
(116687, NULL, 'G3DSA:1.20.1440.100:FF:000005', NULL, NULL, 'HAD-IB family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(116688, NULL, 'G3DSA:3.40.50.300:FF:004893', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(116689, NULL, 'G3DSA:3.40.50.300:FF:001756', NULL, NULL, 'Si:dkey-185m8.2', NULL, NULL, NULL, NULL, NULL, 4),
(116690, NULL, 'G3DSA:3.40.50.620:FF:000127', NULL, NULL, 'Glutamate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(116691, NULL, 'G3DSA:3.40.50.1820:FF:000598', NULL, NULL, 'Cholinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(116692, NULL, 'G3DSA:2.70.50.80:FF:000001', NULL, NULL, 'Transcriptional enhancer factor TEF-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116693, NULL, 'G3DSA:3.30.780.10:FF:000029', NULL, NULL, 'Translation initiation factor SUI1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(116694, NULL, 'G3DSA:2.10.55.10:FF:000005', NULL, NULL, 'Leishmanolysin-like peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(116695, NULL, 'G3DSA:1.20.5.710:FF:000014', NULL, NULL, '50S ribosomal protein L7/L12', NULL, NULL, NULL, NULL, NULL, 4),
(116696, NULL, 'G3DSA:1.20.140.10:FF:000013', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(116697, NULL, 'G3DSA:1.25.40.60:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116698, NULL, 'G3DSA:2.60.220.50:FF:000171', NULL, NULL, 'Receptor for egg jelly 3 protein; Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116699, NULL, 'G3DSA:1.20.1250.20:FF:001878', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116700, NULL, 'G3DSA:3.40.390.10:FF:000199', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116701, NULL, 'G3DSA:3.20.20.450:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116702, NULL, 'G3DSA:3.30.40.10:FF:000075', NULL, NULL, 'Putative e3 ubiquitin-protein ligase rnf43', NULL, NULL, NULL, NULL, NULL, 4),
(116703, NULL, 'G3DSA:2.30.170.20:FF:000017', NULL, NULL, 'Ribosomal protein L24e, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116704, NULL, 'G3DSA:2.10.10.10:FF:000008', NULL, NULL, 'Epididymal sperm-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(116705, NULL, 'G3DSA:3.20.20.190:FF:000103', NULL, NULL, 'Glycerophosphoryl diester phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(116706, NULL, 'G3DSA:2.60.40.1090:FF:000015', NULL, NULL, 'Type 1 fimbrin D-mannose specific adhesin', NULL, NULL, NULL, NULL, NULL, 4),
(116707, NULL, 'G3DSA:3.40.50.2300:FF:000731', NULL, NULL, 'Two-component response regulator,transcriptional regulatory protein LuxO', NULL, NULL, NULL, NULL, NULL, 4),
(116708, NULL, 'G3DSA:3.50.50.60:FF:000584', NULL, NULL, 'Sulfide Quinone oxidoReDuctase', NULL, NULL, NULL, NULL, NULL, 4),
(116709, NULL, 'G3DSA:1.25.40.10:FF:003402', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g37230', NULL, NULL, NULL, NULL, NULL, 4),
(116710, NULL, 'G3DSA:3.40.50.720:FF:000275', NULL, NULL, 'Alcohol dehydrogenase AdhA', NULL, NULL, NULL, NULL, NULL, 4),
(116711, NULL, 'G3DSA:3.30.460.10:FF:000134', NULL, NULL, 'Uncharacterized protein TCIL3000_9_2600', NULL, NULL, NULL, NULL, NULL, 4),
(116712, NULL, 'G3DSA:1.10.30.10:FF:000023', NULL, NULL, 'nucleolar transcription factor 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(116713, NULL, 'G3DSA:1.20.1250.20:FF:000361', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(116714, NULL, 'G3DSA:1.50.40.10:FF:000022', NULL, NULL, 'mitochondrial carrier homolog 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(116715, NULL, 'G3DSA:3.30.60.30:FF:000031', NULL, NULL, 'Serine protease inhibitor Kazal-type 2', NULL, NULL, NULL, NULL, NULL, 4),
(116716, NULL, 'G3DSA:3.60.10.10:FF:000414', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(116717, NULL, 'G3DSA:2.130.10.10:FF:004595', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116718, NULL, 'G3DSA:3.30.50.10:FF:000047', NULL, NULL, 'glucocorticoid receptor isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(116719, NULL, 'G3DSA:3.30.428.10:FF:000037', NULL, NULL, 'AGAP010932-PA', NULL, NULL, NULL, NULL, NULL, 4),
(116720, NULL, 'G3DSA:3.30.160.60:FF:001840', NULL, NULL, 'Paternally-expressed gene 3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(116721, NULL, 'G3DSA:4.10.400.10:FF:000075', NULL, NULL, 'Low-density lipoprotein receptor-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(116722, NULL, 'G3DSA:1.10.8.1220:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116723, NULL, 'G3DSA:2.60.120.200:FF:000238', NULL, NULL, 'Os04g0141400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(116724, NULL, 'G3DSA:2.60.40.10:FF:005134', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116725, NULL, 'G3DSA:1.10.10.1050:FF:000010', NULL, NULL, 'mRNA decapping protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116726, NULL, 'G3DSA:3.90.1150.10:FF:000299', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(116727, NULL, 'G3DSA:1.10.287.770:FF:000027', NULL, NULL, 'Pickpocket 14', NULL, NULL, NULL, NULL, NULL, 4),
(116728, NULL, 'G3DSA:4.10.1060.50:FF:000001', NULL, NULL, 'ubiquitin-60S ribosomal protein L40', NULL, NULL, NULL, NULL, NULL, 4),
(116729, NULL, 'G3DSA:2.130.10.10:FF:000907', NULL, NULL, 'WD repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(116730, NULL, 'G3DSA:1.10.510.10:FF:001831', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116731, NULL, 'G3DSA:3.40.50.1260:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116732, NULL, 'G3DSA:2.10.60.10:FF:000045', NULL, NULL, 'Potassium inwardly-rectifying channel, subfamily J, member 11,-like', NULL, NULL, NULL, NULL, NULL, 4),
(116733, NULL, 'G3DSA:3.80.10.10:FF:003100', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(116734, NULL, 'G3DSA:3.40.50.300:FF:006984', NULL, NULL, 'Dephospho-CoA kinase', NULL, NULL, NULL, NULL, NULL, 4),
(116735, NULL, 'G3DSA:3.30.2450.30:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116736, NULL, 'G3DSA:3.40.50.300:FF:003847', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116737, NULL, 'G3DSA:3.40.50.300:FF:005556', NULL, NULL, 'Double Clp-N motif-containing P-loop nucleoside triphosphate hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(116738, NULL, 'G3DSA:3.30.559.10:FF:000009', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(116739, NULL, 'G3DSA:2.60.40.10:FF:001391', NULL, NULL, 'Beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(116740, NULL, 'G3DSA:3.40.930.10:FF:000016', NULL, NULL, 'Galactitol-specific enzyme IIA of phosphotransferase system', NULL, NULL, NULL, NULL, NULL, 4),
(116741, NULL, 'G3DSA:3.30.70.330:FF:002671', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116742, NULL, 'G3DSA:3.30.200.20:FF:001377', NULL, NULL, 'TAO kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(116743, NULL, 'G3DSA:1.20.120.1920:FF:000001', NULL, NULL, 'Ubiquitin associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(116744, NULL, 'G3DSA:3.40.1380.20:FF:000021', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(116745, NULL, 'G3DSA:3.30.40.10:FF:000546', NULL, NULL, 'Regulating synaptic membrane exocytosis 1', NULL, NULL, NULL, NULL, NULL, 4),
(116746, NULL, 'G3DSA:3.30.160.60:FF:001306', NULL, NULL, 'Zinc finger protein 287', NULL, NULL, NULL, NULL, NULL, 4),
(116747, NULL, 'G3DSA:1.25.10.10:FF:002849', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116748, NULL, 'G3DSA:3.40.1280.10:FF:000067', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(116749, NULL, 'G3DSA:1.20.1560.10:FF:000049', NULL, NULL, 'ABC transporter B family member 6', NULL, NULL, NULL, NULL, NULL, 4),
(116750, NULL, 'G3DSA:1.10.101.10:FF:000021', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(116751, NULL, 'G3DSA:1.20.120.720:FF:000016', NULL, NULL, 'Myosin VB', NULL, NULL, NULL, NULL, NULL, 4),
(116752, NULL, 'G3DSA:3.30.360.10:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116753, NULL, 'G3DSA:2.60.40.10:FF:001239', NULL, NULL, 'Programmed cell death 1 ligand 2', NULL, NULL, NULL, NULL, NULL, 4),
(116754, NULL, 'G3DSA:1.25.10.10:FF:001068', NULL, NULL, 'Unplaced genomic scaffold supercont2.21, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(116755, NULL, 'G3DSA:1.20.970.10:FF:000025', NULL, NULL, 'Anthranilate phosphoribosyl transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116756, NULL, 'G3DSA:2.10.90.10:FF:000081', NULL, NULL, 'DAN domain family member 5', NULL, NULL, NULL, NULL, NULL, 4),
(116757, NULL, 'G3DSA:1.20.1560.10:FF:000550', NULL, NULL, 'AGAP012467-PA', NULL, NULL, NULL, NULL, NULL, 4),
(116758, NULL, 'G3DSA:1.10.150.250:FF:000001', NULL, NULL, 'FAD assembly factor SdhE', NULL, NULL, NULL, NULL, NULL, 4),
(116759, NULL, 'G3DSA:3.80.10.10:FF:002583', NULL, NULL, 'Leucine-rich repeat serine/threonine-protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(116760, NULL, 'G3DSA:1.25.40.10:FF:001249', NULL, NULL, 'Mitochondrial fission 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(116761, NULL, 'G3DSA:2.130.10.10:FF:005258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116762, NULL, 'G3DSA:2.60.40.10:FF:003920', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116763, NULL, 'G3DSA:3.60.40.10:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116764, NULL, 'G3DSA:2.60.120.260:FF:000149', NULL, NULL, 'Leupeptin-inactivating enzyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(116765, NULL, 'G3DSA:2.60.40.4150:FF:000001', NULL, NULL, 'Type VI secretion system lipoprotein TssJ', NULL, NULL, NULL, NULL, NULL, 4),
(116766, NULL, 'G3DSA:3.80.10.10:FF:000930', NULL, NULL, 'F-box/LRR-repeat protein 20', NULL, NULL, NULL, NULL, NULL, 4),
(116767, NULL, 'G3DSA:1.10.150.810:FF:000006', NULL, NULL, 'Putative DNA polymerase kappa', NULL, NULL, NULL, NULL, NULL, 4),
(116768, NULL, 'G3DSA:1.20.58.390:FF:000030', NULL, NULL, 'Acetylcholine receptor subunit alpha-L1', NULL, NULL, NULL, NULL, NULL, 4),
(116769, NULL, 'G3DSA:2.60.470.10:FF:000019', NULL, NULL, 'Pickpocket 15', NULL, NULL, NULL, NULL, NULL, 4),
(116770, NULL, 'G3DSA:2.30.30.490:FF:000034', NULL, NULL, 'protein polybromo-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(116771, NULL, 'G3DSA:1.10.510.10:FF:002495', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116772, NULL, 'G3DSA:3.40.50.2300:FF:000995', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116773, NULL, 'G3DSA:3.90.226.10:FF:000178', NULL, NULL, 'Acetyl-CoA carboxylase multifunctional enzyme AccADCB', NULL, NULL, NULL, NULL, NULL, 4),
(116774, NULL, 'G3DSA:1.25.10.20:FF:000031', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(116775, NULL, 'G3DSA:1.10.506.10:FF:000034', NULL, NULL, 'IRA1p GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(116776, NULL, 'G3DSA:2.30.39.10:FF:000017', NULL, NULL, 'Serpin family A member 10', NULL, NULL, NULL, NULL, NULL, 4),
(116777, NULL, 'G3DSA:3.30.450.20:FF:000165', NULL, NULL, 'Unplaced genomic scaffold supercont2.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(116778, NULL, 'G3DSA:4.10.1060.10:FF:000040', NULL, NULL, 'E3 SUMO-protein ligase RanBP2', NULL, NULL, NULL, NULL, NULL, 4),
(116779, NULL, 'G3DSA:1.10.10.10:FF:001921', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(116780, NULL, 'G3DSA:3.90.180.10:FF:000048', NULL, NULL, 'Protein YIM1', NULL, NULL, NULL, NULL, NULL, 4),
(116781, NULL, 'G3DSA:3.30.70.260:FF:000121', NULL, NULL, 'Chorismate mutase/prephenate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(116782, NULL, 'G3DSA:3.40.50.11840:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116783, NULL, 'G3DSA:1.10.10.650:FF:000002', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(116784, NULL, 'G3DSA:3.40.50.11610:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116785, NULL, 'G3DSA:1.10.510.10:FF:003276', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116786, NULL, 'G3DSA:2.130.10.10:FF:005112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116787, NULL, 'G3DSA:3.90.190.10:FF:000521', NULL, NULL, 'Dual-specificity protein phosphatase 26', NULL, NULL, NULL, NULL, NULL, 4),
(116788, NULL, 'G3DSA:3.30.1010.10:FF:000089', NULL, NULL, 'Phosphatidylinositol 4-kinase beta', NULL, NULL, NULL, NULL, NULL, 4),
(116789, NULL, 'G3DSA:1.10.10.60:FF:001032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116790, NULL, 'G3DSA:3.30.70.1230:FF:000025', NULL, NULL, 'Adenylate cyclase 1', NULL, NULL, NULL, NULL, NULL, 4),
(116791, NULL, 'G3DSA:3.30.450.20:FF:000108', NULL, NULL, 'Methyl-accepting chemotaxis protein signaling domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(116792, NULL, 'G3DSA:3.40.50.300:FF:008052', NULL, NULL, 'Dynein heavy chain 3', NULL, NULL, NULL, NULL, NULL, 4),
(116793, NULL, 'G3DSA:3.40.50.2000:FF:000259', NULL, NULL, 'Glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(116794, NULL, 'G3DSA:2.130.10.10:FF:003931', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116795, NULL, 'G3DSA:1.10.1520.10:FF:000055', NULL, NULL, 'Endoribonuclease Dicer homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(116796, NULL, 'G3DSA:1.20.1270.60:FF:000323', NULL, NULL, 'Insulin receptor tyrosine kinase substrate, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116797, NULL, 'G3DSA:3.40.50.410:FF:000300', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(116798, NULL, 'G3DSA:3.30.200.20:FF:001641', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116799, NULL, 'G3DSA:2.60.40.10:FF:001918', NULL, NULL, 'Immunoglobulin light 1 constant 3', NULL, NULL, NULL, NULL, NULL, 4),
(116800, NULL, 'G3DSA:3.80.10.10:FF:002318', NULL, NULL, 'AGAP012317-PA', NULL, NULL, NULL, NULL, NULL, 4),
(116801, NULL, 'G3DSA:3.20.20.60:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116802, NULL, 'G3DSA:1.10.238.210:FF:000007', NULL, NULL, 'Glutaminase 2a (liver, mitochondrial)', NULL, NULL, NULL, NULL, NULL, 4),
(116803, NULL, 'G3DSA:1.10.3030.10:FF:000001', NULL, NULL, 'Gamete antigen 27/25', NULL, NULL, NULL, NULL, NULL, 4),
(116804, NULL, 'G3DSA:2.130.10.10:FF:001043', NULL, NULL, 'WD repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(116805, NULL, 'G3DSA:3.40.50.300:FF:002004', NULL, NULL, 'ABC transporter I family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(116806, NULL, 'G3DSA:1.20.920.20:FF:000048', NULL, NULL, 'Si:dkey-11m19.5', NULL, NULL, NULL, NULL, NULL, 4),
(116807, NULL, 'G3DSA:1.20.1270.10:FF:000095', NULL, NULL, 'Protein CBG18133', NULL, NULL, NULL, NULL, NULL, 4),
(116808, NULL, 'G3DSA:3.20.20.70:FF:000125', NULL, NULL, 'Lipoyl synthase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(116809, NULL, 'G3DSA:1.10.8.60:FF:000210', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(116810, NULL, 'G3DSA:2.130.10.10:FF:003167', NULL, NULL, 'Periodic tryptophan protein 2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(116811, NULL, 'G3DSA:1.10.8.10:FF:000066', NULL, NULL, 'Baculoviral IAP repeat containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(116812, NULL, 'G3DSA:1.25.40.10:FF:000794', NULL, NULL, 'NRDE-2, necessary for RNA interference, domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(116813, NULL, 'G3DSA:1.10.10.250:FF:000005', NULL, NULL, 'Mitochondrial 54S ribosomal protein YmL19', NULL, NULL, NULL, NULL, NULL, 4),
(116814, NULL, 'G3DSA:2.60.40.10:FF:000986', NULL, NULL, 'Titin b', NULL, NULL, NULL, NULL, NULL, 4),
(116815, NULL, 'G3DSA:3.40.50.2030:FF:000009', NULL, NULL, 'Carbon monoxide dehydrogenase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(116816, NULL, 'G3DSA:1.20.1250.20:FF:000097', NULL, NULL, 'protein spinster homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(116817, NULL, 'G3DSA:3.40.50.300:FF:007501', NULL, NULL, 'ATP-dependent RNA helicase rok1', NULL, NULL, NULL, NULL, NULL, 4),
(116818, NULL, 'G3DSA:3.40.50.300:FF:003701', NULL, NULL, 'Dynein heavy chain 14, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(116819, NULL, 'G3DSA:1.20.920.10:FF:000045', NULL, NULL, 'protein polybromo-1', NULL, NULL, NULL, NULL, NULL, 4),
(116820, NULL, 'G3DSA:1.10.287.370:FF:000087', NULL, NULL, 'KE2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(116821, NULL, 'G3DSA:1.25.40.10:FF:002885', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(116822, NULL, 'G3DSA:1.50.10.20:FF:000085', NULL, NULL, 'Cpras2, large protein with the cpRAS domain', NULL, NULL, NULL, NULL, NULL, 4),
(116823, NULL, 'G3DSA:1.10.510.10:FF:003158', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116824, NULL, 'G3DSA:3.30.160.60:FF:001099', NULL, NULL, 'zinc finger and BTB domain-containing protein 49', NULL, NULL, NULL, NULL, NULL, 4),
(116825, NULL, 'G3DSA:3.30.710.10:FF:000261', NULL, NULL, 'Assembly of substrate-specific ubiquitin ligase complexes modulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116826, NULL, 'G3DSA:3.40.50.2300:FF:000877', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116827, NULL, 'G3DSA:1.20.1250.20:FF:002159', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116828, NULL, 'G3DSA:2.60.40.10:FF:004729', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116829, NULL, 'G3DSA:2.130.10.10:FF:005376', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116830, NULL, 'G3DSA:3.40.1190.20:FF:000158', NULL, NULL, 'PfkB domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(116831, NULL, 'G3DSA:2.40.30.30:FF:000014', NULL, NULL, 'RNA-binding riboflavin kinase RibR', NULL, NULL, NULL, NULL, NULL, 4),
(116832, NULL, 'G3DSA:3.30.2350.10:FF:000047', NULL, NULL, 'tRNA pseudouridine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(116833, NULL, 'G3DSA:1.10.520.10:FF:000022', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(116834, NULL, 'G3DSA:2.60.40.10:FF:005191', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116835, NULL, 'G3DSA:2.30.36.70:FF:000006', NULL, NULL, 'Actin-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(116836, NULL, 'G3DSA:2.130.10.10:FF:004387', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116837, NULL, 'G3DSA:3.30.1490.180:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(116838, NULL, 'G3DSA:3.40.50.1110:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116839, NULL, 'G3DSA:2.60.40.10:FF:002054', NULL, NULL, 'Secreted and transmembrane protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(116840, NULL, 'G3DSA:3.40.50.1100:FF:000152', NULL, NULL, 'Putative 1-aminocyclopropane-1-carboxylate deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(116841, NULL, 'G3DSA:3.40.630.30:FF:000303', NULL, NULL, 'O-GlcNAcase', NULL, NULL, NULL, NULL, NULL, 4),
(116842, NULL, 'G3DSA:3.30.420.10:FF:000334', NULL, NULL, 'DNA polymerase zeta catalytic subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116843, NULL, 'G3DSA:3.40.50.150:FF:001161', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116844, NULL, 'G3DSA:3.40.50.410:FF:000036', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(116845, NULL, 'G3DSA:1.50.40.10:FF:000230', NULL, NULL, 'GM18585', NULL, NULL, NULL, NULL, NULL, 4),
(116846, NULL, 'G3DSA:3.60.21.10:FF:000496', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(116847, NULL, 'G3DSA:3.30.70.330:FF:000962', NULL, NULL, 'RBMX2 ortholog', NULL, NULL, NULL, NULL, NULL, 4),
(116848, NULL, 'G3DSA:1.10.10.580:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116849, NULL, 'G3DSA:3.40.50.2020:FF:000006', NULL, NULL, 'Hypoxanthine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(116850, NULL, 'G3DSA:3.40.50.720:FF:000511', NULL, NULL, 'oxidoreductase HTATIP2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(116851, NULL, 'G3DSA:2.60.40.10:FF:000929', NULL, NULL, 'Roundabout guidance receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(116852, NULL, 'G3DSA:3.20.20.330:FF:000016', NULL, NULL, 'Putative uncharacterized protein YMR321C', NULL, NULL, NULL, NULL, NULL, 4),
(116853, NULL, 'G3DSA:1.20.1740.10:FF:000114', NULL, NULL, 'Solute carrier family 12 member 1', NULL, NULL, NULL, NULL, NULL, 4),
(116854, NULL, 'G3DSA:3.30.200.20:FF:001169', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(116855, NULL, 'G3DSA:2.130.10.10:FF:001514', NULL, NULL, 'U3 small nucleolar RNA-associated protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(116856, NULL, 'G3DSA:3.60.20.10:FF:000241', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116857, NULL, 'G3DSA:3.40.33.10:FF:000029', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(116858, NULL, 'G3DSA:1.20.1560.10:FF:000257', NULL, NULL, 'ABC transporter ABCC.6, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116859, NULL, 'G3DSA:2.130.10.10:FF:002032', NULL, NULL, 'Protein HIRA', NULL, NULL, NULL, NULL, NULL, 4),
(116860, NULL, 'G3DSA:2.10.50.10:FF:000073', NULL, NULL, 'TNF receptor superfamily member 9', NULL, NULL, NULL, NULL, NULL, 4),
(116861, NULL, 'G3DSA:1.20.1070.10:FF:000793', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116862, NULL, 'G3DSA:1.10.1200.10:FF:000008', NULL, NULL, 'Acyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(116863, NULL, 'G3DSA:2.60.120.200:FF:000390', NULL, NULL, 'Glycosidase', NULL, NULL, NULL, NULL, NULL, 4),
(116864, NULL, 'G3DSA:1.10.8.10:FF:000009', NULL, NULL, 'Putative E3 ubiquitin-protein ligase UBR5', NULL, NULL, NULL, NULL, NULL, 4),
(116865, NULL, 'G3DSA:3.40.50.1760:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116866, NULL, 'G3DSA:3.40.1340.10:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116867, NULL, 'G3DSA:3.80.10.10:FF:002375', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116868, NULL, 'G3DSA:3.40.50.300:FF:001077', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(116869, NULL, 'G3DSA:3.30.70.330:FF:002553', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116870, NULL, 'G3DSA:3.40.50.10140:FF:000058', NULL, NULL, 'Putative serine/threonine-protein kinase pats1', NULL, NULL, NULL, NULL, NULL, 4),
(116871, NULL, 'G3DSA:1.10.1580.10:FF:000031', NULL, NULL, 'Mitochondrial GTPase 1', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(116872, NULL, 'G3DSA:2.60.120.260:FF:000357', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116873, NULL, 'G3DSA:3.30.160.60:FF:004212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116874, NULL, 'G3DSA:1.10.442.10:FF:000003', NULL, NULL, 'Cytochrome c oxidase subunit 4 isoform 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(116875, NULL, 'G3DSA:3.50.50.60:FF:001101', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(116876, NULL, 'G3DSA:3.20.20.80:FF:000185', NULL, NULL, '1,4-beta-xylanase', NULL, NULL, NULL, NULL, NULL, 4),
(116877, NULL, 'G3DSA:1.10.1740.240:FF:000001', NULL, NULL, 'Endolysin', NULL, NULL, NULL, NULL, NULL, 4),
(116878, NULL, 'G3DSA:3.30.450.200:FF:000003', NULL, NULL, 'DENN domain containing 1A', NULL, NULL, NULL, NULL, NULL, 4),
(116879, NULL, 'G3DSA:2.40.30.20:FF:000011', NULL, NULL, 'Riboflavin synthase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(116880, NULL, 'G3DSA:3.30.1640.30:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116881, NULL, 'G3DSA:3.30.200.20:FF:001170', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(116882, NULL, 'G3DSA:2.60.40.1670:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116883, NULL, 'G3DSA:1.10.238.10:FF:000332', NULL, NULL, 'Myosin A tail domain interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(116884, NULL, 'G3DSA:3.80.10.10:FF:000992', NULL, NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(116885, NULL, 'G3DSA:1.10.1040.50:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116886, NULL, 'G3DSA:3.40.50.2300:FF:001041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116887, NULL, 'G3DSA:2.10.50.10:FF:000016', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 10B', NULL, NULL, NULL, NULL, NULL, 4),
(116888, NULL, 'G3DSA:2.60.40.10:FF:005718', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116889, NULL, 'G3DSA:1.10.510.10:FF:001567', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116890, NULL, 'G3DSA:4.10.240.10:FF:000129', NULL, NULL, 'C6 finger transcription factor fumR', NULL, NULL, NULL, NULL, NULL, 4),
(116891, NULL, 'G3DSA:3.30.160.60:FF:003285', NULL, NULL, 'Zinc finger protein 793', NULL, NULL, NULL, NULL, NULL, 4),
(116892, NULL, 'G3DSA:3.20.20.80:FF:000128', NULL, NULL, 'Endo-1,6-beta-D-glucanase neg1', NULL, NULL, NULL, NULL, NULL, 4),
(116893, NULL, 'G3DSA:1.10.10.10:FF:001450', NULL, NULL, 'Vacuolar-sorting protein SNF8', NULL, NULL, NULL, NULL, NULL, 4),
(116894, NULL, 'G3DSA:1.10.238.10:FF:001226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116895, NULL, 'G3DSA:1.25.40.70:FF:000025', NULL, NULL, 'Phosphatidylinositol 3-kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116896, NULL, 'G3DSA:2.130.10.10:FF:004948', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116897, NULL, 'G3DSA:3.30.160.60:FF:003605', NULL, NULL, 'Early growth response 3', NULL, NULL, NULL, NULL, NULL, 4),
(116898, NULL, 'G3DSA:1.25.10.10:FF:003254', NULL, NULL, 'ARMADILLO BTB ARABIDOPSIS PROTEIN 1', NULL, NULL, NULL, NULL, NULL, 4),
(116899, NULL, 'G3DSA:3.80.10.10:FF:000284', NULL, NULL, 'extracellular matrix protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(116900, NULL, 'G3DSA:1.20.58.1250:FF:000005', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(116901, NULL, 'G3DSA:3.20.20.70:FF:000182', NULL, NULL, 'Glycerol uptake operon antiterminator regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(116902, NULL, 'G3DSA:2.40.50.140:FF:000588', NULL, NULL, 'Single-stranded DNA binding protein Ssb', NULL, NULL, NULL, NULL, NULL, 4),
(116903, NULL, 'G3DSA:1.10.8.70:FF:000005', NULL, NULL, 'Glutamate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(116904, NULL, 'G3DSA:2.60.40.1730:FF:000073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116905, NULL, 'G3DSA:1.20.1250.10:FF:000094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(116906, NULL, 'G3DSA:1.25.40.20:FF:000797', NULL, NULL, 'Ankyrin repeat-containing protein NPR4', NULL, NULL, NULL, NULL, NULL, 4),
(116907, NULL, 'G3DSA:1.10.10.10:FF:001657', NULL, NULL, 'Helix-turn-helix transcriptional regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116908, NULL, 'G3DSA:3.40.50.1220:FF:000042', NULL, NULL, 'Alpha-keto-acid decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(116909, NULL, 'G3DSA:4.10.280.10:FF:000194', NULL, NULL, 'Max-like protein X', NULL, NULL, NULL, NULL, NULL, 4),
(116910, NULL, 'G3DSA:1.10.8.60:FF:000002', NULL, NULL, 'ATP-dependent Clp protease ATP-binding subunit ClpX', NULL, NULL, NULL, NULL, NULL, 4),
(116911, NULL, 'G3DSA:1.25.40.120:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116912, NULL, 'G3DSA:1.20.1250.20:FF:001996', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116913, NULL, 'G3DSA:1.10.2000.10:FF:000027', NULL, NULL, 'Transmembrane receptor', NULL, NULL, NULL, NULL, NULL, 4),
(116914, NULL, 'G3DSA:1.10.8.60:FF:000474', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116915, NULL, 'G3DSA:1.50.10.10:FF:000048', NULL, NULL, 'Unsaturated chondroitin disaccharide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(116916, NULL, 'G3DSA:1.20.1270.60:FF:000205', NULL, NULL, 'Protein kinase C and casein kinase substrate in neurons protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(116917, NULL, 'G3DSA:3.90.1200.10:FF:000005', NULL, NULL, 'Choline kinase alpha', NULL, NULL, NULL, NULL, NULL, 4),
(116918, NULL, 'G3DSA:3.80.10.10:FF:000520', NULL, NULL, 'Leucine rich repeat containing 15', NULL, NULL, NULL, NULL, NULL, 4),
(116919, NULL, 'G3DSA:3.40.50.1460:FF:000063', NULL, NULL, 'Vacuolar processing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(116920, NULL, 'G3DSA:3.40.47.10:FF:000264', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116921, NULL, 'G3DSA:1.20.5.110:FF:000222', NULL, NULL, 'Synaptobrevin 9-2', NULL, NULL, NULL, NULL, NULL, 4),
(116922, NULL, 'G3DSA:3.40.50.150:FF:000441', NULL, NULL, 'FkbM family methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(116923, NULL, 'G3DSA:3.30.160.60:FF:004420', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116924, NULL, 'G3DSA:3.30.70.330:FF:001125', NULL, NULL, 'Flowering time control protein FPA isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(116925, NULL, 'G3DSA:2.130.10.10:FF:005522', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116926, NULL, 'G3DSA:2.60.40.10:FF:004937', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116927, NULL, 'G3DSA:3.30.160.60:FF:005230', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116928, NULL, 'G3DSA:3.40.50.300:FF:004775', NULL, NULL, 'Interferon gamma-inducible protein 47', NULL, NULL, NULL, NULL, NULL, 4),
(116929, NULL, 'G3DSA:3.40.50.300:FF:007237', NULL, NULL, 'Gtr1/RagA G protein conserved region containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(116930, NULL, 'G3DSA:3.60.10.10:FF:000004', NULL, NULL, 'Type II inositol 1,4,5-trisphosphate 5-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(116931, NULL, 'G3DSA:1.20.1290.10:FF:000006', NULL, NULL, 'Carboxymuconolactone decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(116932, NULL, 'G3DSA:2.30.30.140:FF:000160', NULL, NULL, 'Maternal protein tudor', NULL, NULL, NULL, NULL, NULL, 4),
(116933, NULL, 'G3DSA:1.20.5.170:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116934, NULL, 'G3DSA:3.30.1370.10:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116935, NULL, 'G3DSA:3.90.650.10:FF:000006', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(116936, NULL, 'G3DSA:1.10.472.80:FF:000245', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116937, NULL, 'G3DSA:3.30.40.10:FF:002284', NULL, NULL, 'Protein CBG09969', NULL, NULL, NULL, NULL, NULL, 4),
(116938, NULL, 'G3DSA:1.25.40.10:FF:005257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(116939, NULL, 'G3DSA:1.20.1560.10:FF:000757', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116940, NULL, 'G3DSA:2.130.10.10:FF:003667', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116941, NULL, 'G3DSA:2.10.25.10:FF:001369', NULL, NULL, 'Laminin, gamma 2', NULL, NULL, NULL, NULL, NULL, 4),
(116942, NULL, 'G3DSA:1.25.10.10:FF:001629', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116943, NULL, 'G3DSA:1.10.287.3240:FF:000011', NULL, NULL, 'V-type proton ATPase subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(116944, NULL, 'G3DSA:2.60.120.330:FF:000226', NULL, NULL, 'Putative 2-oxoacid dependent dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(116945, NULL, 'G3DSA:3.30.450.20:FF:000518', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(116946, NULL, 'G3DSA:3.40.850.10:FF:000128', NULL, NULL, 'Dachs, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(116947, NULL, 'G3DSA:3.40.50.720:FF:001146', NULL, NULL, 'Pantotheic acid-3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(116948, NULL, 'G3DSA:3.30.720.90:FF:000004', NULL, NULL, 'Probable 60S ribosomal protein L38', NULL, NULL, NULL, NULL, NULL, 4),
(116949, NULL, 'G3DSA:3.90.70.10:FF:000765', NULL, NULL, 'Ubiquitin-specific peptidase 2a', NULL, NULL, NULL, NULL, NULL, 4),
(116950, NULL, 'G3DSA:3.50.50.60:FF:001511', NULL, NULL, 'D-amino acid dehydrogenase, small chain', NULL, NULL, NULL, NULL, NULL, 4),
(116951, NULL, 'G3DSA:3.80.10.10:FF:000166', NULL, NULL, 'Dynein assembly factor 1, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(116952, NULL, 'G3DSA:3.30.40.10:FF:001002', NULL, NULL, 'Zinc finger domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(116953, NULL, 'G3DSA:3.80.10.10:FF:004320', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116954, NULL, 'G3DSA:3.40.1280.10:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116955, NULL, 'G3DSA:2.30.42.10:FF:000188', NULL, NULL, 'PDZ domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(116956, NULL, 'G3DSA:1.10.3720.10:FF:000239', NULL, NULL, 'Glycine betaine/proline ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(116957, NULL, 'G3DSA:3.40.50.12780:FF:000237', NULL, NULL, 'Mutant e4 ebony', NULL, NULL, NULL, NULL, NULL, 4),
(116958, NULL, 'G3DSA:3.40.720.10:FF:000181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116959, NULL, 'G3DSA:3.50.50.60:FF:001308', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(116960, NULL, 'G3DSA:3.40.50.300:FF:003139', NULL, NULL, 'NACHT, LRR and PYD domains-containing protein 12 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(116961, NULL, 'G3DSA:1.25.40.570:FF:000007', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 11', NULL, NULL, NULL, NULL, NULL, 4),
(116962, NULL, 'G3DSA:2.40.128.20:FF:000018', NULL, NULL, 'Glial lazarillo, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(116963, NULL, 'G3DSA:3.40.50.300:FF:000413', NULL, NULL, 'Translocase of chloroplast 120, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(116964, NULL, 'G3DSA:2.30.29.210:FF:000004', NULL, NULL, 'Transcription factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(116965, NULL, 'G3DSA:1.10.510.10:FF:001067', NULL, NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 75', NULL, NULL, NULL, NULL, NULL, 4),
(116966, NULL, 'G3DSA:1.10.10.10:FF:001242', NULL, NULL, 'HSF33, heat shock transcription factor DNA-binding domain-containing protein, DNA binding, transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(116967, NULL, 'G3DSA:2.170.260.10:FF:000005', NULL, NULL, 'Endoribonuclease Dicer 1', NULL, NULL, NULL, NULL, NULL, 4),
(116968, NULL, 'G3DSA:3.40.50.300:FF:007708', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116969, NULL, 'G3DSA:3.10.420.10:FF:000001', NULL, NULL, 'Protein-export chaperone SecB', NULL, NULL, NULL, NULL, NULL, 4),
(116970, NULL, 'G3DSA:3.30.1120.30:FF:000018', NULL, NULL, 'PLK/PLK1 protein kinase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(116971, NULL, 'G3DSA:3.30.70.330:FF:002519', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116972, NULL, 'G3DSA:3.20.20.80:FF:000780', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(116973, NULL, 'G3DSA:1.10.510.10:FF:003219', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116974, NULL, 'G3DSA:1.10.10.60:FF:001150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116975, NULL, 'G3DSA:1.10.1410.40:FF:000005', NULL, NULL, 'MB21D2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(116976, NULL, 'G3DSA:2.30.29.30:FF:001130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116977, NULL, 'G3DSA:1.10.510.10:FF:003422', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116978, NULL, 'G3DSA:3.40.50.11990:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116979, NULL, 'G3DSA:2.60.120.200:FF:000446', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116980, NULL, 'G3DSA:2.30.29.220:FF:000007', NULL, NULL, 'FACT complex subunit POB3', NULL, NULL, NULL, NULL, NULL, 4),
(116981, NULL, 'G3DSA:2.130.10.10:FF:001722', NULL, NULL, 'Phosphoinositide 3-kinase regulatory subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(116982, NULL, 'G3DSA:1.25.10.10:FF:002439', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116983, NULL, 'G3DSA:2.30.29.30:FF:001220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(116984, NULL, 'G3DSA:1.10.286.20:FF:000002', NULL, NULL, 'Regulator of nucleoside diphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(116985, NULL, 'G3DSA:3.30.200.110:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116986, NULL, 'G3DSA:1.20.1280.50:FF:000028', NULL, NULL, 'Transport inhibitor response 1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(116987, NULL, 'G3DSA:2.160.20.10:FF:000339', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(116988, NULL, 'G3DSA:1.25.40.10:FF:004594', NULL, NULL, 'Uncharacterized Sel1-like repeat-containing protein C1B3.10c', NULL, NULL, NULL, NULL, NULL, 4),
(116989, NULL, 'G3DSA:2.60.40.10:FF:003543', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116990, NULL, 'G3DSA:1.10.3860.10:FF:000013', NULL, NULL, 'Amino acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(116991, NULL, 'G3DSA:2.60.40.1390:FF:000015', NULL, NULL, 'YALI0B14773p', NULL, NULL, NULL, NULL, NULL, 4),
(116992, NULL, 'G3DSA:1.25.40.10:FF:001811', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At1g64310', NULL, NULL, NULL, NULL, NULL, 4),
(116993, NULL, 'G3DSA:3.40.50.150:FF:001722', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(116994, NULL, 'G3DSA:3.40.1110.10:FF:000173', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(116995, NULL, 'G3DSA:3.30.200.20:FF:000860', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(116996, NULL, 'G3DSA:2.30.29.30:FF:000556', NULL, NULL, 'Serine/threonine-protein kinase dkf-1', NULL, NULL, NULL, NULL, NULL, 4),
(116997, NULL, 'G3DSA:1.20.1070.10:FF:000293', NULL, NULL, '2-oxoglutarate receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(116998, NULL, 'G3DSA:3.40.30.10:FF:000107', NULL, NULL, 'Protein disulfide-isomerase 5-2', NULL, NULL, NULL, NULL, NULL, 4),
(116999, NULL, 'G3DSA:1.25.10.10:FF:001214', NULL, NULL, 'Phosphoinositide-3-kinase, regulatory subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(117000, NULL, 'G3DSA:1.20.90.10:FF:000004', NULL, NULL, 'Group XIIA secretory phospholipase A2', NULL, NULL, NULL, NULL, NULL, 4),
(117001, NULL, 'G3DSA:1.20.1250.20:FF:000714', NULL, NULL, 'Unplaced genomic scaffold supercont2.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(117002, NULL, 'G3DSA:2.30.30.140:FF:000013', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(117003, NULL, 'G3DSA:3.60.20.10:FF:000033', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(117004, NULL, 'G3DSA:3.10.20.90:FF:000070', NULL, NULL, 'E3 ubiquitin-protein ligase RBBP6 isoform X2', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(117005, NULL, 'G3DSA:1.25.40.20:FF:001814', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117006, NULL, 'G3DSA:3.40.50.300:FF:002212', NULL, NULL, 'AAA family ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117007, NULL, 'G3DSA:3.40.1110.10:FF:000116', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(117008, NULL, 'G3DSA:1.10.238.10:FF:001260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117009, NULL, 'G3DSA:2.60.120.10:FF:000561', NULL, NULL, 'cAMP-dependent protein kinase type II-alpha regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(117010, NULL, 'G3DSA:3.80.10.10:FF:003510', NULL, NULL, 'ELRR (Extracellular Leucine-Rich Repeat) ONly', NULL, NULL, NULL, NULL, NULL, 4),
(117011, NULL, 'G3DSA:1.20.1160.20:FF:000005', NULL, NULL, 'Grid2 interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(117012, NULL, 'G3DSA:1.25.40.560:FF:000004', NULL, NULL, 'Zn-finger (Ran-binding)-3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(117013, NULL, 'G3DSA:2.130.10.10:FF:005612', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117014, NULL, 'G3DSA:2.60.40.60:FF:000894', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117015, NULL, 'G3DSA:3.40.50.300:FF:001548', NULL, NULL, 'ABC efflux transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(117016, NULL, 'G3DSA:2.130.10.10:FF:001161', NULL, NULL, 'Peroxisomal targeting signal 2 receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117017, NULL, 'G3DSA:1.20.120.1080:FF:000120', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(117018, NULL, 'G3DSA:1.10.238.200:FF:000004', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(117019, NULL, 'G3DSA:3.40.50.720:FF:002574', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117020, NULL, 'G3DSA:3.90.550.10:FF:000768', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(117021, NULL, 'G3DSA:3.40.50.300:FF:007147', NULL, NULL, 'Adenylyl-sulfate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(117022, NULL, 'G3DSA:3.30.160.20:FF:000154', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(117023, NULL, 'G3DSA:1.25.40.10:FF:001250', NULL, NULL, 'Mitochondrial fission 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(117024, NULL, 'G3DSA:2.20.100.10:FF:000232', NULL, NULL, 'F-spondin', NULL, NULL, NULL, NULL, NULL, 4),
(117025, NULL, 'G3DSA:2.40.50.140:FF:000824', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117026, NULL, 'G3DSA:3.60.10.10:FF:000268', NULL, NULL, 'DNA-(apurinic or apyrimidinic site) lyase', NULL, NULL, NULL, NULL, NULL, 4),
(117027, NULL, 'G3DSA:1.20.1250.20:FF:000804', NULL, NULL, 'MFS family major facilitator transporter', NULL, NULL, NULL, NULL, NULL, 4),
(117028, NULL, 'G3DSA:1.10.287.820:FF:000003', NULL, NULL, 'Blast:Sodium channel protein Nach', NULL, NULL, NULL, NULL, NULL, 4),
(117029, NULL, 'G3DSA:1.10.3730.20:FF:000012', NULL, NULL, 'DUF803 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(117030, NULL, 'G3DSA:1.20.5.110:FF:000076', NULL, NULL, 'SNARE protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117031, NULL, 'G3DSA:3.40.50.300:FF:001902', NULL, NULL, 'ATP dependent DEAD-box helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117032, NULL, 'G3DSA:2.60.40.60:FF:001147', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(117033, NULL, 'G3DSA:1.20.120.1530:FF:000007', NULL, NULL, 'Two-component osmosensing histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(117034, NULL, 'G3DSA:1.10.8.480:FF:000020', NULL, NULL, 'Dimethyladenosine transferase', NULL, NULL, NULL, NULL, NULL, 4),
(117035, NULL, 'G3DSA:3.20.20.80:FF:000538', NULL, NULL, 'Chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117036, NULL, 'G3DSA:3.40.50.1820:FF:000744', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117037, NULL, 'G3DSA:3.30.9.10:FF:000221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(117038, NULL, 'G3DSA:3.40.1110.10:FF:000263', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117039, NULL, 'G3DSA:3.30.260.10:FF:000068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117040, NULL, 'G3DSA:1.10.8.10:FF:000302', NULL, NULL, 'Ubiquitin-conjugating enzyme E2Ka (UBC1 homolog, yeast)', NULL, NULL, NULL, NULL, NULL, 4),
(117041, NULL, 'G3DSA:3.80.10.10:FF:004174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117042, NULL, 'G3DSA:3.40.50.20:FF:000061', NULL, NULL, 'Ribosomal protein S6 glutaminyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(117043, NULL, 'G3DSA:3.30.160.60:FF:001806', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117044, NULL, 'G3DSA:3.30.200.20:FF:001523', NULL, NULL, 'Ribosomal protein S6 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(117045, NULL, 'G3DSA:1.20.1260.10:FF:000066', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(117046, NULL, 'G3DSA:3.30.420.40:FF:000995', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117047, NULL, 'G3DSA:3.40.630.10:FF:000409', NULL, NULL, 'Peptidase M20 domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(117048, NULL, 'G3DSA:2.20.110.10:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117049, NULL, 'G3DSA:3.40.430.10:FF:000023', NULL, NULL, 'Putative dihydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(117050, NULL, 'G3DSA:3.90.980.20:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117051, NULL, 'G3DSA:2.30.42.10:FF:000334', NULL, NULL, 'Mitochondrial scaffolding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(117052, NULL, 'G3DSA:1.10.10.10:FF:001803', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117053, NULL, 'G3DSA:3.40.190.10:FF:000690', NULL, NULL, 'Polar amino acid uptake family ABC transporter, periplasmic substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(117054, NULL, 'G3DSA:3.90.850.10:FF:000021', NULL, NULL, '2-keto-4-pentenoate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(117055, NULL, 'G3DSA:3.30.40.10:FF:002227', NULL, NULL, 'PDZ domain containing ring finger 4', NULL, NULL, NULL, NULL, NULL, 4),
(117056, NULL, 'G3DSA:3.20.20.70:FF:000535', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117057, NULL, 'G3DSA:2.130.10.10:FF:000233', NULL, NULL, 'Kinesin family member 21A', NULL, NULL, NULL, NULL, NULL, 4),
(117058, NULL, 'G3DSA:2.120.10.30:FF:000498', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117059, NULL, 'G3DSA:3.30.420.40:FF:000938', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(117060, NULL, 'G3DSA:3.40.50.300:FF:006927', NULL, NULL, 'ATP-binding cassette transporter, subfamily G, member 42, group PDR-like protein PpABCG42', NULL, NULL, NULL, NULL, NULL, 4),
(117061, NULL, 'G3DSA:3.30.559.10:FF:000127', NULL, NULL, 'Amino acid adenylation', NULL, NULL, NULL, NULL, NULL, 4),
(117062, NULL, 'G3DSA:1.10.10.10:FF:000786', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(117063, NULL, 'G3DSA:1.25.40.10:FF:001457', NULL, NULL, 'Os06g0114366 protein', NULL, NULL, NULL, NULL, NULL, 4),
(117064, NULL, 'G3DSA:2.10.270.10:FF:000004', NULL, NULL, 'Toxin B', NULL, NULL, NULL, NULL, NULL, 4),
(117065, NULL, 'G3DSA:1.20.140.10:FF:000070', NULL, NULL, 'Acyl-CoA dehydrogenase FadE22', NULL, NULL, NULL, NULL, NULL, 4),
(117066, NULL, 'G3DSA:3.90.520.10:FF:000002', NULL, NULL, 'Mothers against decapentaplegic homolog', NULL, NULL, NULL, NULL, NULL, 4),
(117067, NULL, 'G3DSA:3.30.200.20:FF:002097', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(117068, NULL, 'G3DSA:1.10.150.50:FF:000174', NULL, NULL, 'Ephrin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(117069, NULL, 'G3DSA:2.60.40.10:FF:001503', NULL, NULL, 'Immunoglobulin superfamily member 5', NULL, NULL, NULL, NULL, NULL, 4),
(117070, NULL, 'G3DSA:3.90.190.10:FF:000285', NULL, NULL, 'DUSP11 isoform 5', NULL, NULL, NULL, NULL, NULL, 4),
(117071, NULL, 'G3DSA:1.20.5.2700:FF:000002', NULL, NULL, 'NADH-ubiquinone oxidoreductase chain 5', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(117072, NULL, 'G3DSA:3.40.50.300:FF:001341', NULL, NULL, 'NLR family pyrin domain containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(117073, NULL, 'G3DSA:3.90.1740.10:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117074, NULL, 'G3DSA:1.20.58.240:FF:000002', NULL, NULL, 'Bifunctional protein NCOAT', NULL, NULL, NULL, NULL, NULL, 4),
(117075, NULL, 'G3DSA:1.10.555.10:FF:000254', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117076, NULL, 'G3DSA:3.20.10.10:FF:000034', NULL, NULL, '4-amino-4-deoxychorismate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(117077, NULL, 'G3DSA:1.20.120.790:FF:000020', NULL, NULL, 'Chaperone protein HtpG', NULL, NULL, NULL, NULL, NULL, 4),
(117078, NULL, 'G3DSA:2.10.70.10:FF:000282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117079, NULL, 'G3DSA:3.40.50.720:FF:000983', NULL, NULL, 'Short-chain dehydrogenase/reductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(117080, NULL, 'G3DSA:2.60.40.420:FF:000177', NULL, NULL, 'Copper-containing nitrite reductase', NULL, NULL, NULL, NULL, NULL, 4),
(117081, NULL, 'G3DSA:3.20.20.140:FF:000403', NULL, NULL, 'Alkylphosphonate utilization protein PhnM, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117082, NULL, 'G3DSA:1.10.630.10:FF:000317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117083, NULL, 'G3DSA:3.40.50.720:FF:002427', NULL, NULL, 'Myo-inositol-1-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(117084, NULL, 'G3DSA:3.30.70.330:FF:001182', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(117085, NULL, 'G3DSA:3.30.40.10:FF:000693', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(117086, NULL, 'G3DSA:2.120.10.30:FF:000588', NULL, NULL, 'Protein STRICTOSIDINE SYNTHASE-LIKE 2', NULL, NULL, NULL, NULL, NULL, 4),
(117087, NULL, 'G3DSA:2.40.50.140:FF:000734', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117088, NULL, 'G3DSA:1.20.1070.10:FF:000383', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117089, NULL, 'G3DSA:3.40.50.10810:FF:000130', NULL, NULL, 'WGS project CABT00000000 data, contig 2.20', NULL, NULL, NULL, NULL, NULL, 4),
(117090, NULL, 'G3DSA:1.20.5.1300:FF:000009', NULL, NULL, 'Histidinol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(117091, NULL, 'G3DSA:3.40.50.1820:FF:000834', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(117092, NULL, 'G3DSA:3.30.420.40:FF:000848', NULL, NULL, 'Chaperone protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(117093, NULL, 'G3DSA:2.130.10.10:FF:003460', NULL, NULL, 'Histidine kinase/response regulator hybrid protein', NULL, NULL, NULL, NULL, NULL, 4),
(117094, NULL, 'G3DSA:3.30.160.60:FF:006011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117095, NULL, 'G3DSA:1.10.230.10:FF:000011', NULL, NULL, 'Citrate synthase-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117096, NULL, 'G3DSA:1.20.1070.10:FF:001310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117097, NULL, 'G3DSA:1.20.1600.10:FF:000020', NULL, NULL, 'Outer membrane protein TolC', NULL, NULL, NULL, NULL, NULL, 4),
(117098, NULL, 'G3DSA:1.10.1040.10:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117099, NULL, 'G3DSA:3.10.20.620:FF:000004', NULL, NULL, 'Autophagy protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(117100, NULL, 'G3DSA:1.10.287.1060:FF:000008', NULL, NULL, 'ESAT-6-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(117101, NULL, 'G3DSA:2.30.30.190:FF:000011', NULL, NULL, 'CAP-Gly domain-containing linker protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(117102, NULL, 'G3DSA:1.20.930.10:FF:000017', NULL, NULL, 'Transcription elongation factor S-II', NULL, NULL, NULL, NULL, NULL, 4),
(117103, NULL, 'G3DSA:2.60.120.590:FF:000017', NULL, NULL, 'RNA demethylase ALKBH9B', NULL, NULL, NULL, NULL, NULL, 4),
(117104, NULL, 'G3DSA:3.30.160.20:FF:000007', NULL, NULL, 'Double-stranded RNA-binding protein Staufen homolog 1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(117105, NULL, 'G3DSA:2.30.29.30:FF:000910', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(117106, NULL, 'G3DSA:3.40.190.10:FF:000780', NULL, NULL, 'Extracellular solute-binding protein family 5', NULL, NULL, NULL, NULL, NULL, 4),
(117107, NULL, 'G3DSA:3.40.50.1370:FF:000036', NULL, NULL, 'Putative aspartate carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(117108, NULL, 'G3DSA:3.40.50.1360:FF:000033', NULL, NULL, '6-phosphogluconolactonase', NULL, NULL, NULL, NULL, NULL, 4),
(117109, NULL, 'G3DSA:1.20.5.110:FF:000340', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117110, NULL, 'G3DSA:3.30.300.180:FF:000015', NULL, NULL, 'Chromosomal replication initiator protein DnaA 2', NULL, NULL, NULL, NULL, NULL, 4),
(117111, NULL, 'G3DSA:3.30.160.60:FF:001071', NULL, NULL, 'zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(117112, NULL, 'G3DSA:3.40.20.10:FF:000112', NULL, NULL, 'BnaC03g35080D protein', NULL, NULL, NULL, NULL, NULL, 4),
(117113, NULL, 'G3DSA:3.30.160.60:FF:003195', NULL, NULL, 'Zinc finger protein 789', NULL, NULL, NULL, NULL, NULL, 4),
(117114, NULL, 'G3DSA:1.25.40.10:FF:000878', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(117115, NULL, 'G3DSA:3.30.950.10:FF:000008', NULL, NULL, 'Related to MET1-siroheme synthase', NULL, NULL, NULL, NULL, NULL, 4),
(117116, NULL, 'G3DSA:3.30.70.330:FF:001007', NULL, NULL, 'Homologous to Drosophila SQD (Squid) protein', NULL, NULL, NULL, NULL, NULL, 4),
(117117, NULL, 'G3DSA:3.40.50.2000:FF:001012', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(117118, NULL, 'G3DSA:4.10.240.10:FF:000130', NULL, NULL, 'Transcriptional regulatory protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117119, NULL, 'G3DSA:3.40.50.150:FF:000025', NULL, NULL, 'N-terminal Xaa-Pro-Lys N-methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(117120, NULL, 'G3DSA:3.30.930.10:FF:000390', NULL, NULL, 'Phenylalanyl-tRNA synthetase alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(117121, NULL, 'G3DSA:3.40.50.10330:FF:000025', NULL, NULL, 'NAD+ kinase Utr1', NULL, NULL, NULL, NULL, NULL, 4),
(117122, NULL, 'G3DSA:2.60.40.10:FF:003190', NULL, NULL, 'Glycoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(117123, NULL, 'G3DSA:3.90.1200.10:FF:000067', NULL, NULL, 'Uncharacterized protein sll1119', NULL, NULL, NULL, NULL, NULL, 4),
(117124, NULL, 'G3DSA:3.30.710.10:FF:000227', NULL, NULL, 'Ankyrin repeat and BTB domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(117125, NULL, 'G3DSA:3.40.50.620:FF:000363', NULL, NULL, 'Isoleucyl-tRNA synthetase cytoplasmic, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117126, NULL, 'G3DSA:2.60.40.60:FF:000984', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117127, NULL, 'G3DSA:3.30.1120.30:FF:000047', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(117128, NULL, 'G3DSA:1.10.8.60:FF:000064', NULL, NULL, 'IQ motif containing with AAA domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(117129, NULL, 'G3DSA:1.10.8.60:FF:000120', NULL, NULL, 'Sigma-54-dependent Fis family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(117130, NULL, 'G3DSA:2.130.10.10:FF:001127', NULL, NULL, 'Protein kinase and ribonuclease Ire1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117131, NULL, 'G3DSA:2.170.190.11:FF:000012', NULL, NULL, 'Molybdopterin molybdenumtransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(117132, NULL, 'G3DSA:3.30.910.20:FF:000009', NULL, NULL, 'Skp-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(117133, NULL, 'G3DSA:2.40.10.10:FF:000468', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117134, NULL, 'G3DSA:1.10.1200.60:FF:000001', NULL, NULL, '50S ribosomal protein L19e', NULL, NULL, NULL, NULL, NULL, 4),
(117135, NULL, 'G3DSA:2.70.98.90:FF:000007', NULL, NULL, 'Membrane protein insertase YidC', NULL, NULL, NULL, NULL, NULL, 4),
(117136, NULL, 'G3DSA:3.20.20.140:FF:000318', NULL, NULL, 'Guanine deaminase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(117137, NULL, 'G3DSA:3.90.1580.10:FF:000027', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(117138, NULL, 'G3DSA:1.10.8.270:FF:000098', NULL, NULL, 'Rab-GTPase-TBC domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117139, NULL, 'G3DSA:3.30.200.20:FF:000742', NULL, NULL, 'Receptor-like protein kinase ANXUR2', NULL, NULL, NULL, NULL, NULL, 4),
(117140, NULL, 'G3DSA:3.50.50.60:FF:000819', NULL, NULL, 'Fructose dehydrogenase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(117141, NULL, 'G3DSA:3.10.490.20:FF:000008', NULL, NULL, 'dynein heavy chain 2, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(117142, NULL, 'G3DSA:2.30.29.30:FF:000438', NULL, NULL, 'uncharacterized protein LOC108093793 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(117143, NULL, 'G3DSA:3.30.230.10:FF:000241', NULL, NULL, 'Galactokinase', NULL, NULL, NULL, NULL, NULL, 4),
(117144, NULL, 'G3DSA:1.25.40.10:FF:005083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117145, NULL, 'G3DSA:1.10.1750.10:FF:000010', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(117146, NULL, 'G3DSA:1.10.510.10:FF:003719', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117147, NULL, 'G3DSA:3.30.429.10:FF:000005', NULL, NULL, 'Macrophage migration inhibitory factor', NULL, NULL, NULL, NULL, NULL, 4),
(117148, NULL, 'G3DSA:2.130.10.10:FF:005292', NULL, NULL, 'Periodic tryptophan protein 2 homolog-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(117149, NULL, 'G3DSA:1.10.150.50:FF:000051', NULL, NULL, 'Lymphocyte cytosolic protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(117150, NULL, 'G3DSA:3.30.190.20:FF:000043', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(117151, NULL, 'G3DSA:3.30.200.20:FF:001731', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(117152, NULL, 'G3DSA:2.60.40.10:FF:006000', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117153, NULL, 'G3DSA:2.40.155.10:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(117154, NULL, 'G3DSA:3.60.20.10:FF:000151', NULL, NULL, 'Proteasome endopeptidase complex', NULL, NULL, NULL, NULL, NULL, 4),
(117155, NULL, 'G3DSA:1.25.10.10:FF:003075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117156, NULL, 'G3DSA:2.60.40.10:FF:002728', NULL, NULL, 'Inositol polyphosphate 5-phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117157, NULL, 'G3DSA:3.30.2130.30:FF:000019', NULL, NULL, 'Probable tRNA sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(117158, NULL, 'G3DSA:1.10.287.70:FF:000637', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117159, NULL, 'G3DSA:3.40.50.20:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117160, NULL, 'G3DSA:3.30.1120.10:FF:000041', NULL, NULL, 'Arylsulfatase A [precursor]', NULL, NULL, NULL, NULL, NULL, 4),
(117161, NULL, 'G3DSA:2.60.120.380:FF:000016', NULL, NULL, 'Calpain 13', NULL, NULL, NULL, NULL, NULL, 4),
(117162, NULL, 'G3DSA:1.20.1250.20:FF:001586', NULL, NULL, 'MFS transporter, putative (AFU_orthologue AFUA_5G13160)', NULL, NULL, NULL, NULL, NULL, 4),
(117163, NULL, 'G3DSA:2.150.10.10:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117164, NULL, 'G3DSA:4.10.280.110:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117165, NULL, 'G3DSA:3.40.50.300:FF:005702', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117166, NULL, 'G3DSA:1.20.930.60:FF:000015', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(117167, NULL, 'G3DSA:1.20.1740.10:FF:000030', NULL, NULL, 'solute carrier family 12 member 8', NULL, NULL, NULL, NULL, NULL, 4),
(117168, NULL, 'G3DSA:1.20.1740.10:FF:000176', NULL, NULL, 'Transport protein (Probable substrate cationic amino acids)', NULL, NULL, NULL, NULL, NULL, 4),
(117169, NULL, 'G3DSA:1.25.40.10:FF:004684', NULL, NULL, 'Tetratricopeptide repeat protein 1', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(117170, NULL, 'G3DSA:3.10.580.10:FF:000041', NULL, NULL, 'Cystathionine beta-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(117171, NULL, 'G3DSA:1.10.1670.40:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117172, NULL, 'G3DSA:1.25.10.10:FF:003131', NULL, NULL, 'Leucine-rich repeat kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(117173, NULL, 'G3DSA:1.10.3080.10:FF:000009', NULL, NULL, 'Chloride voltage-gated channel 6', NULL, NULL, NULL, NULL, NULL, 4),
(117174, NULL, 'G3DSA:1.25.10.10:FF:001837', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117175, NULL, 'G3DSA:3.40.50.300:FF:000003', NULL, NULL, 'Elongation factor Tu', NULL, NULL, NULL, NULL, NULL, 4),
(117176, NULL, 'G3DSA:3.20.20.380:FF:000008', NULL, NULL, 'Putative homeostasis protein', NULL, NULL, NULL, NULL, NULL, 4),
(117177, NULL, 'G3DSA:2.60.120.10:FF:000443', NULL, NULL, 'Os05g0197200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(117178, NULL, 'G3DSA:1.20.1250.20:FF:000653', NULL, NULL, 'Polyamine transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117179, NULL, 'G3DSA:2.40.50.140:FF:000678', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117180, NULL, 'G3DSA:2.10.110.30:FF:000004', NULL, NULL, 'Ubr2p', NULL, NULL, NULL, NULL, NULL, 4),
(117181, NULL, 'G3DSA:3.40.630.30:FF:000218', NULL, NULL, 'GCN5-related N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(117182, NULL, 'G3DSA:3.40.50.150:FF:001604', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117183, NULL, 'G3DSA:1.20.1740.10:FF:000232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117184, NULL, 'G3DSA:3.30.1240.10:FF:000044', NULL, NULL, 'Cof-type HAD-IIB family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(117185, NULL, 'G3DSA:3.40.1190.20:FF:000068', NULL, NULL, 'ATP-dependent (S)-NAD(P)H-hydrate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(117186, NULL, 'G3DSA:3.40.630.150:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117187, NULL, 'G3DSA:1.20.120.350:FF:000118', NULL, NULL, 'Voltage-dependent calcium channel subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117188, NULL, 'G3DSA:3.50.50.60:FF:001281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117189, NULL, 'G3DSA:2.70.98.70:FF:000001', NULL, NULL, 'dermatan-sulfate epimerase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(117190, NULL, 'G3DSA:3.30.930.10:FF:000064', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(117191, NULL, 'G3DSA:1.10.472.140:FF:000002', NULL, NULL, 'RB transcriptional corepressor 1', NULL, NULL, NULL, NULL, NULL, 4),
(117192, NULL, 'G3DSA:3.90.260.10:FF:000021', NULL, NULL, 'Transglutaminase 6', NULL, NULL, NULL, NULL, NULL, 4),
(117193, NULL, 'G3DSA:1.20.1070.10:FF:001102', NULL, NULL, 'Prostaglandin E2 receptor EP4 subtype', NULL, NULL, NULL, NULL, NULL, 4),
(117194, NULL, 'G3DSA:3.30.70.2000:FF:000003', NULL, NULL, 'INSOmniac (Drosophila sleep affecting) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(117195, NULL, 'G3DSA:3.40.910.10:FF:000010', NULL, NULL, 'Deoxyhypusine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(117196, NULL, 'G3DSA:3.30.160.60:FF:005286', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117197, NULL, 'G3DSA:2.40.150.20:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117198, NULL, 'G3DSA:3.30.70.330:FF:000193', NULL, NULL, 'RNA-binding motif protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(117199, NULL, 'G3DSA:2.60.120.680:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(117200, NULL, 'G3DSA:2.60.40.2690:FF:000006', NULL, NULL, 'Splicing factor 3a subunit 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117201, NULL, 'G3DSA:3.20.20.370:FF:000005', NULL, NULL, 'Delta-lactam-biosynthetic de-N-acetylase', NULL, NULL, NULL, NULL, NULL, 4),
(117202, NULL, 'G3DSA:3.30.160.60:FF:004302', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117203, NULL, 'G3DSA:3.40.50.720:FF:000039', NULL, NULL, 'Alcohol dehydrogenase AdhP', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(117204, NULL, 'G3DSA:1.20.1560.10:FF:000611', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117205, NULL, 'G3DSA:3.40.50.10190:FF:000320', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117206, NULL, 'G3DSA:3.80.10.10:FF:001678', NULL, NULL, 'Calmodulin-binding receptor kinase CaMRLK', NULL, NULL, NULL, NULL, NULL, 4),
(117207, NULL, 'G3DSA:3.40.50.300:FF:003757', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(117208, NULL, 'G3DSA:1.10.600.10:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117209, NULL, 'G3DSA:1.10.287.130:FF:000190', NULL, NULL, 'Sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(117210, NULL, 'G3DSA:1.10.132.30:FF:000025', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(117211, NULL, 'G3DSA:3.90.1750.20:FF:000010', NULL, NULL, 'DNA recombinase', NULL, NULL, NULL, NULL, NULL, 4),
(117212, NULL, 'G3DSA:1.10.575.10:FF:000014', NULL, NULL, 'Phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(117213, NULL, 'G3DSA:1.20.1280.290:FF:000036', NULL, NULL, 'Sugar transporter SWEET', NULL, NULL, NULL, NULL, NULL, 4),
(117214, NULL, 'G3DSA:1.10.132.20:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117215, NULL, 'G3DSA:3.30.160.20:FF:000215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117216, NULL, 'G3DSA:1.10.150.20:FF:000036', NULL, NULL, 'Polymerase (DNA directed), theta', NULL, NULL, NULL, NULL, NULL, 4),
(117217, NULL, 'G3DSA:2.40.20.10:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117218, NULL, 'G3DSA:3.80.10.10:FF:002818', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117219, NULL, 'G3DSA:1.25.40.10:FF:002969', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117220, NULL, 'G3DSA:3.40.50.720:FF:002282', NULL, NULL, 'Inositol-3-phosphate synthase isozyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(117221, NULL, 'G3DSA:3.30.310.10:FF:000005', NULL, NULL, 'TATA box-binding protein-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(117222, NULL, 'G3DSA:2.130.10.10:FF:003049', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117223, NULL, 'G3DSA:3.40.50.300:FF:004983', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(117224, NULL, 'G3DSA:1.25.40.20:FF:000033', NULL, NULL, 'E3 ubiquitin-protein ligase HECTD1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(117225, NULL, 'G3DSA:3.30.40.10:FF:000159', NULL, NULL, 'BRCA1-associated protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(117226, NULL, 'G3DSA:3.80.10.10:FF:000374', NULL, NULL, 'volume-regulated anion channel subunit LRRC8E isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(117227, NULL, 'G3DSA:3.30.160.60:FF:005606', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117228, NULL, 'G3DSA:2.10.80.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117229, NULL, 'G3DSA:3.40.50.300:FF:007563', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117230, NULL, 'G3DSA:4.10.1060.10:FF:000039', NULL, NULL, 'Zinc finger Ran-binding domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(117231, NULL, 'G3DSA:1.10.3380.10:FF:000049', NULL, NULL, 'U5 small nuclear ribonucleoprotein 200 kDa helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117232, NULL, 'G3DSA:1.10.10.10:FF:001511', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117233, NULL, 'G3DSA:3.40.390.10:FF:000289', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117234, NULL, 'G3DSA:1.20.1110.10:FF:000145', NULL, NULL, 'Potassium/sodium efflux P-type ATPase, fungal-type', NULL, NULL, NULL, NULL, NULL, 4),
(117235, NULL, 'G3DSA:3.40.50.10190:FF:000017', NULL, NULL, 'PAX interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(117236, NULL, 'G3DSA:1.25.40.10:FF:004947', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(117237, NULL, 'G3DSA:3.40.50.11260:FF:000001', NULL, NULL, 'Heat shock protein 90 alpha', NULL, NULL, NULL, NULL, NULL, 4),
(117238, NULL, 'G3DSA:1.25.40.20:FF:000679', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117239, NULL, 'G3DSA:2.60.120.1540:FF:000010', NULL, NULL, 'Alpha-2-macroglobulin-like', NULL, NULL, NULL, NULL, NULL, 4),
(117240, NULL, 'G3DSA:3.50.30.30:FF:000124', NULL, NULL, 'Carboxypeptidase Q', NULL, NULL, NULL, NULL, NULL, 4),
(117241, NULL, 'G3DSA:3.30.465.10:FF:000095', NULL, NULL, 'Magnesium and cobalt efflux protein', NULL, NULL, NULL, NULL, NULL, 4),
(117242, NULL, 'G3DSA:1.10.510.10:FF:001921', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(117243, NULL, 'G3DSA:2.60.40.10:FF:005218', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117244, NULL, 'G3DSA:3.20.20.100:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117245, NULL, 'G3DSA:3.30.200.40:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117246, NULL, 'G3DSA:3.60.21.10:FF:000203', NULL, NULL, 'Ser/Thr protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117247, NULL, 'G3DSA:1.25.40.10:FF:000030', NULL, NULL, 'Tetratricopeptide repeat domain 7B', NULL, NULL, NULL, NULL, NULL, 4),
(117248, NULL, 'G3DSA:2.30.30.140:FF:000159', NULL, NULL, 'GM21401', NULL, NULL, NULL, NULL, NULL, 4),
(117249, NULL, 'G3DSA:3.90.70.130:FF:000001', NULL, NULL, 'Probable Ufm1-specific protease 2', NULL, NULL, NULL, NULL, NULL, 4),
(117250, NULL, 'G3DSA:3.90.180.10:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117251, NULL, 'G3DSA:2.40.50.140:FF:000532', NULL, NULL, 'Transcription elongation factor Spt6', NULL, NULL, NULL, NULL, NULL, 4),
(117252, NULL, 'G3DSA:3.40.50.10240:FF:000026', NULL, NULL, 'Thiamine pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(117253, NULL, 'G3DSA:1.25.40.20:FF:001724', NULL, NULL, 'Death-associated protein kinase dapk-1', NULL, NULL, NULL, NULL, NULL, 4),
(117254, NULL, 'G3DSA:3.30.230.10:FF:000387', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(117255, NULL, 'G3DSA:3.40.50.300:FF:001633', NULL, NULL, 'Thymidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(117256, NULL, 'G3DSA:2.10.25.10:FF:000357', NULL, NULL, 'cartilage acidic protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(117257, NULL, 'G3DSA:3.30.390.30:FF:000027', NULL, NULL, 'Nitrite reductase [NAD(P)H], large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(117258, NULL, 'G3DSA:3.30.365.10:FF:000036', NULL, NULL, 'Nicotinate dehydrogenase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(117259, NULL, 'G3DSA:3.50.50.60:FF:001011', NULL, NULL, 'lysine-specific histone demethylase 1B', NULL, NULL, NULL, NULL, NULL, 4),
(117260, NULL, 'G3DSA:3.40.50.150:FF:001806', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117261, NULL, 'G3DSA:3.30.200.20:FF:000888', NULL, NULL, 'Putative cyclin-dependent kinase F-2', NULL, NULL, NULL, NULL, NULL, 4),
(117262, NULL, 'G3DSA:3.30.830.10:FF:000005', NULL, NULL, 'nardilysin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(117263, NULL, 'G3DSA:1.20.1070.10:FF:001046', NULL, NULL, 'Bacteriorhodopsin', NULL, NULL, NULL, NULL, NULL, 4),
(117264, NULL, 'G3DSA:1.10.630.10:FF:000761', NULL, NULL, 'Cytochrome P450 family 76 subfamily C polypeptide 7', NULL, NULL, NULL, NULL, NULL, 4),
(117265, NULL, 'G3DSA:1.25.40.10:FF:002767', NULL, NULL, 'AGAP009674-PA', NULL, NULL, NULL, NULL, NULL, 4),
(117266, NULL, 'G3DSA:2.10.25.10:FF:001200', NULL, NULL, 'mannan-binding lectin serine protease 1', NULL, NULL, NULL, NULL, NULL, 4),
(117267, NULL, 'G3DSA:3.40.50.2300:FF:000759', NULL, NULL, 'Extracellular calcium-sensing receptor', NULL, NULL, NULL, NULL, NULL, 4),
(117268, NULL, 'G3DSA:2.130.10.10:FF:001453', NULL, NULL, 'Ribosome biogenesis protein BOP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(117269, NULL, 'G3DSA:3.30.70.330:FF:001209', NULL, NULL, 'FI22004p1', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(117270, NULL, 'G3DSA:3.40.1160.10:FF:000035', NULL, NULL, 'Diaminopimelate decarboxylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117271, NULL, 'G3DSA:1.20.1110.10:FF:000201', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117272, NULL, 'G3DSA:3.40.50.720:FF:002512', NULL, NULL, 'Nicotinate-nucleotide pyrophosphorylase AND conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(117273, NULL, 'G3DSA:3.30.1330.40:FF:000032', NULL, NULL, 'RidA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(117274, NULL, 'G3DSA:1.10.1200.10:FF:000126', NULL, NULL, 'Lovastatin diketide synthase LovF', NULL, NULL, NULL, NULL, NULL, 4),
(117275, NULL, 'G3DSA:1.20.1560.10:FF:000078', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(117276, NULL, 'G3DSA:3.30.1490.20:FF:000032', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(117277, NULL, 'G3DSA:1.10.630.10:FF:000233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117278, NULL, 'G3DSA:2.20.70.10:FF:000287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117279, NULL, 'G3DSA:3.50.50.60:FF:000499', NULL, NULL, 'Sarcosine oxidase, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(117280, NULL, 'G3DSA:1.25.40.10:FF:000676', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g41720', NULL, NULL, NULL, NULL, NULL, 4),
(117281, NULL, 'G3DSA:2.40.50.140:FF:001021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117282, NULL, 'G3DSA:3.90.1860.10:FF:000009', NULL, NULL, 'RNA-splicing ligase RtcB', NULL, NULL, NULL, NULL, NULL, 4),
(117283, NULL, 'G3DSA:2.40.10.190:FF:000005', NULL, NULL, '60S ribosomal protein L35a', NULL, NULL, NULL, NULL, NULL, 4),
(117284, NULL, 'G3DSA:4.10.400.10:FF:000221', NULL, NULL, 'Terribly reduced optic lobes, isoform AT', NULL, NULL, NULL, NULL, NULL, 4),
(117285, NULL, 'G3DSA:1.20.1250.20:FF:001001', NULL, NULL, 'putative inorganic phosphate cotransporter', NULL, NULL, NULL, NULL, NULL, 4),
(117286, NULL, 'G3DSA:3.40.50.1010:FF:000035', NULL, NULL, 'Fcf1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117287, NULL, 'G3DSA:1.25.10.10:FF:002765', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117288, NULL, 'G3DSA:2.160.20.70:FF:000020', NULL, NULL, 'Tubulin binding cofactor C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117289, NULL, 'G3DSA:3.10.200.10:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117290, NULL, 'G3DSA:1.20.1070.10:FF:001687', NULL, NULL, 'Olfactory receptor 1461', NULL, NULL, NULL, NULL, NULL, 4),
(117291, NULL, 'G3DSA:1.20.1050.90:FF:000001', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(117292, NULL, 'G3DSA:2.60.120.200:FF:000480', NULL, NULL, 'Putative transmembrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(117293, NULL, 'G3DSA:2.160.20.80:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117294, NULL, 'G3DSA:2.60.40.10:FF:001475', NULL, NULL, 'TAP binding protein-like variant', NULL, NULL, NULL, NULL, NULL, 4),
(117295, NULL, 'G3DSA:3.40.50.12780:FF:000119', NULL, NULL, 'AM-toxin synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(117296, NULL, 'G3DSA:3.30.1140.32:FF:000011', NULL, NULL, '40S ribosomal protein S3', NULL, NULL, NULL, NULL, NULL, 4),
(117297, NULL, 'G3DSA:3.40.50.1000:FF:000768', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117298, NULL, 'G3DSA:3.30.1130.10:FF:000013', NULL, NULL, 'Dihydroneopterin aldolase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(117299, NULL, 'G3DSA:3.40.50.1820:FF:001031', NULL, NULL, 'Lipase/serine esterase, putative (AFU_orthologue AFUA_3G04240)', NULL, NULL, NULL, NULL, NULL, 4),
(117300, NULL, 'G3DSA:3.40.50.1110:FF:000037', NULL, NULL, 'Carbohydrate esterase family 3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(117301, NULL, 'G3DSA:3.40.50.720:FF:000567', NULL, NULL, 'UDP-glucuronic acid decarboxylase Uxs1p', NULL, NULL, NULL, NULL, NULL, 4),
(117302, NULL, 'G3DSA:3.40.50.1000:FF:000032', NULL, NULL, 'Cytosolic 5-nucleotidase 3-like', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(117303, NULL, 'G3DSA:3.40.50.1100:FF:000034', NULL, NULL, 'Diaminopropionate ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(117304, NULL, 'G3DSA:3.30.60.30:FF:000115', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(117305, NULL, 'G3DSA:1.20.120.1080:FF:000035', NULL, NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117306, NULL, 'G3DSA:3.10.250.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117307, NULL, 'G3DSA:2.20.100.10:FF:000024', NULL, NULL, 'Spondin-1', NULL, NULL, NULL, NULL, NULL, 4),
(117308, NULL, 'G3DSA:3.40.50.300:FF:000531', NULL, NULL, 'Preprotein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(117309, NULL, 'G3DSA:2.30.30.140:FF:000103', NULL, NULL, 'Fmr1, isoform J', NULL, NULL, NULL, NULL, NULL, 4),
(117310, NULL, 'G3DSA:2.10.220.10:FF:000203', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(117311, NULL, 'G3DSA:3.40.50.1820:FF:000542', NULL, NULL, 'Serine carboxypeptidase1', NULL, NULL, NULL, NULL, NULL, 4),
(117312, NULL, 'G3DSA:3.30.70.2350:FF:000001', NULL, NULL, 'Rhomboid protease GlpG', NULL, NULL, NULL, NULL, NULL, 4),
(117313, NULL, 'G3DSA:1.25.40.10:FF:001660', NULL, NULL, 'General transcriptional corepressor CYC8', NULL, NULL, NULL, NULL, NULL, 4),
(117314, NULL, 'G3DSA:1.10.510.10:FF:002579', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117315, NULL, 'G3DSA:3.40.50.620:FF:000537', NULL, NULL, 'Glutamyl-Q tRNA(Asp) synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(117316, NULL, 'G3DSA:1.10.390.10:FF:000051', NULL, NULL, 'GM24727', NULL, NULL, NULL, NULL, NULL, 4),
(117317, NULL, 'G3DSA:3.30.450.20:FF:000081', NULL, NULL, 'Dysfusion, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(117318, NULL, 'G3DSA:3.40.228.10:FF:000008', NULL, NULL, 'Thiosulfate reductase PhsA', NULL, NULL, NULL, NULL, NULL, 4),
(117319, NULL, 'G3DSA:1.25.40.10:FF:001721', NULL, NULL, 'Related to SGT1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(117320, NULL, 'G3DSA:3.30.200.20:FF:000798', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase SD3-1', NULL, NULL, NULL, NULL, NULL, 4),
(117321, NULL, 'G3DSA:3.40.50.1110:FF:000065', NULL, NULL, 'Rhamnogalacturonan acetylesterase', NULL, NULL, NULL, NULL, NULL, 4),
(117322, NULL, 'G3DSA:3.40.1800.20:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117323, NULL, 'G3DSA:3.90.70.10:FF:000883', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117324, NULL, 'G3DSA:3.30.230.10:FF:000297', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(117325, NULL, 'G3DSA:1.25.40.20:FF:001663', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117326, NULL, 'G3DSA:1.10.8.60:FF:000390', NULL, NULL, 'ATPase family associated with various cellular activities (AAA), putative', NULL, NULL, NULL, NULL, NULL, 4),
(117327, NULL, 'G3DSA:3.40.390.10:FF:000019', NULL, NULL, 'Mitochondrial intermediate peptidase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(117328, NULL, 'G3DSA:3.50.50.60:FF:000971', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(117329, NULL, 'G3DSA:3.40.50.2000:FF:000613', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(117330, NULL, 'G3DSA:3.40.50.300:FF:003229', NULL, NULL, 'Peroxisomal biogenesis factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(117331, NULL, 'G3DSA:2.20.25.390:FF:000001', NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-like protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(117332, NULL, 'G3DSA:2.40.30.20:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117333, NULL, 'G3DSA:3.30.160.60:FF:002796', NULL, NULL, 'Zinc finger protein 574', NULL, NULL, NULL, NULL, NULL, 4),
(117334, NULL, 'G3DSA:1.10.510.10:FF:001421', NULL, NULL, 'Membrane-associated tyrosine-and threonine-specific cdc2-inhibitory kinase-like Protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(117335, NULL, 'G3DSA:3.40.720.10:FF:000326', NULL, NULL, 'Protein CBG15598', NULL, NULL, NULL, NULL, NULL, 4),
(117336, NULL, 'G3DSA:2.130.10.10:FF:005814', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117337, NULL, 'G3DSA:2.20.25.10:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117338, NULL, 'G3DSA:3.90.70.80:FF:000095', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(117339, NULL, 'G3DSA:3.40.50.720:FF:001500', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117340, NULL, 'G3DSA:4.10.260.10:FF:000013', NULL, NULL, 'Guanine nucleotide-binding protein subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(117341, NULL, 'G3DSA:1.25.40.10:FF:001042', NULL, NULL, 'Anaphase-promoting complex subunit CDC23', NULL, NULL, NULL, NULL, NULL, 4),
(117342, NULL, 'G3DSA:1.10.510.10:FF:002995', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117343, NULL, 'G3DSA:1.20.80.10:FF:000065', NULL, NULL, 'Golgi resident protein GCP60', NULL, NULL, NULL, NULL, NULL, 4),
(117344, NULL, 'G3DSA:3.30.710.10:FF:000351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117345, NULL, 'G3DSA:3.40.50.2300:FF:000495', NULL, NULL, 'Transcriptional regulator, LacI family', NULL, NULL, NULL, NULL, NULL, 4),
(117346, NULL, 'G3DSA:2.40.160.50:FF:000035', NULL, NULL, '75 kDa chloroplast membrane translocon', NULL, NULL, NULL, NULL, NULL, 4),
(117347, NULL, 'G3DSA:2.30.40.10:FF:000088', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(117348, NULL, 'G3DSA:3.30.420.10:FF:000250', NULL, NULL, 'Ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(117349, NULL, 'G3DSA:3.50.7.10:FF:000088', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117350, NULL, 'G3DSA:3.30.40.10:FF:000485', NULL, NULL, 'ATP-dependent RNA helicase DEAH12 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(117351, NULL, 'G3DSA:2.60.40.10:FF:005308', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117352, NULL, 'G3DSA:1.10.510.10:FF:003068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117353, NULL, 'G3DSA:2.60.120.10:FF:000027', NULL, NULL, 'Protein kinase cAMP-dependent type II regulatory subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(117354, NULL, 'G3DSA:2.30.40.10:FF:000144', NULL, NULL, 'Amidohydrolase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(117355, NULL, 'G3DSA:1.20.120.240:FF:000001', NULL, NULL, 'Major outer surface protein C', NULL, NULL, NULL, NULL, NULL, 4),
(117356, NULL, 'G3DSA:3.80.10.10:FF:002791', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117357, NULL, 'G3DSA:3.40.50.800:FF:000063', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(117358, NULL, 'G3DSA:3.40.50.2300:FF:000613', NULL, NULL, 'Metabotropic GLutamate receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(117359, NULL, 'G3DSA:3.90.1310.10:FF:000042', NULL, NULL, 'Cell division protein ftsI', NULL, NULL, NULL, NULL, NULL, 4),
(117360, NULL, 'G3DSA:3.40.309.10:FF:000028', NULL, NULL, 'Gamma-glutamyl phosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(117361, NULL, 'G3DSA:1.20.1250.20:FF:000658', NULL, NULL, 'Hexose transporter', NULL, NULL, NULL, NULL, NULL, 4),
(117362, NULL, 'G3DSA:3.30.420.10:FF:000008', NULL, NULL, 'Ribonuclease H', NULL, NULL, NULL, NULL, NULL, 4),
(117363, NULL, 'G3DSA:2.60.40.420:FF:000115', NULL, NULL, 'Conidial pigment biosynthesis oxidase Arb2/brown2', NULL, NULL, NULL, NULL, NULL, 4),
(117364, NULL, 'G3DSA:3.40.718.10:FF:000057', NULL, NULL, 'Isocitrate dehydrogenase 3 (NAD+) gamma', NULL, NULL, NULL, NULL, NULL, 4),
(117365, NULL, 'G3DSA:1.20.1250.20:FF:002075', NULL, NULL, 'Protein NRT1/ PTR FAMILY 1.2', NULL, NULL, NULL, NULL, NULL, 4),
(117366, NULL, 'G3DSA:3.30.420.40:FF:000787', NULL, NULL, 'Actin-related protein 4A', NULL, NULL, NULL, NULL, NULL, 4),
(117367, NULL, 'G3DSA:1.10.460.10:FF:000017', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(117368, NULL, 'G3DSA:3.30.450.20:FF:000283', NULL, NULL, 'Helix-loop-helix 34', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(117369, NULL, 'G3DSA:1.10.510.10:FF:001893', NULL, NULL, 'Probable serine/threonine-protein kinase DDB_G0291918', NULL, NULL, NULL, NULL, NULL, 4),
(117370, NULL, 'G3DSA:3.40.190.10:FF:000656', NULL, NULL, 'ABC transporter, binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(117371, NULL, 'G3DSA:3.40.50.2300:FF:001602', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117372, NULL, 'G3DSA:3.50.50.60:FF:000645', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(117373, NULL, 'G3DSA:3.40.50.300:FF:005382', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(117374, NULL, 'G3DSA:1.20.900.10:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117375, NULL, 'G3DSA:3.40.50.410:FF:000070', NULL, NULL, 'sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(117376, NULL, 'G3DSA:1.10.287.70:FF:000463', NULL, NULL, 'Potassium voltage-gated channel protein eag', NULL, NULL, NULL, NULL, NULL, 4),
(117377, NULL, 'G3DSA:3.30.9.10:FF:000013', NULL, NULL, 'tRNA 5-methylaminomethyl-2-thiouridine biosynthesis bifunctional protein MnmC', NULL, NULL, NULL, NULL, NULL, 4),
(117378, NULL, 'G3DSA:3.40.50.2000:FF:000523', NULL, NULL, 'Glycosyltransferase family 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(117379, NULL, 'G3DSA:2.80.10.50:FF:000135', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(117380, NULL, 'G3DSA:3.90.245.10:FF:000008', NULL, NULL, 'Uridine nucleosidase', NULL, NULL, NULL, NULL, NULL, 4),
(117381, NULL, 'G3DSA:3.20.20.190:FF:000165', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117382, NULL, 'G3DSA:3.30.200.20:FF:001080', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(117383, NULL, 'G3DSA:2.60.40.10:FF:005488', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117384, NULL, 'G3DSA:3.80.10.10:FF:002167', NULL, NULL, 'F-box/LRR-repeat protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(117385, NULL, 'G3DSA:4.10.400.10:FF:000311', NULL, NULL, 'LDL receptor repeat-containing protein egg-1', NULL, NULL, NULL, NULL, NULL, 4),
(117386, NULL, 'G3DSA:3.40.50.1000:FF:000122', NULL, NULL, 'Trehalose 6-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(117387, NULL, 'G3DSA:3.30.160.60:FF:005937', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117388, NULL, 'G3DSA:2.60.120.260:FF:000565', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117389, NULL, 'G3DSA:1.10.10.10:FF:000668', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(117390, NULL, 'G3DSA:1.10.8.10:FF:000217', NULL, NULL, 'Peptidyl-tRNA hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117391, NULL, 'G3DSA:3.30.160.60:FF:003813', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117392, NULL, 'G3DSA:3.30.160.20:FF:000069', NULL, NULL, 'Disco interacting protein isoform TO67', NULL, NULL, NULL, NULL, NULL, 4),
(117393, NULL, 'G3DSA:2.10.25.10:FF:000183', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(117394, NULL, 'G3DSA:3.40.50.300:FF:005472', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(117395, NULL, 'G3DSA:1.20.1070.10:FF:000613', NULL, NULL, 'Parietopsin', NULL, NULL, NULL, NULL, NULL, 4),
(117396, NULL, 'G3DSA:3.40.50.300:FF:005674', NULL, NULL, 'Molybdopterin synthase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(117397, NULL, 'G3DSA:3.50.50.60:FF:000792', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(117398, NULL, 'G3DSA:2.60.200.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117399, NULL, 'G3DSA:1.25.40.10:FF:001665', NULL, NULL, 'General transcription factor 3C polypeptide 3 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(117400, NULL, 'G3DSA:1.25.40.20:FF:001668', NULL, NULL, '2-oxoisovalerate dehydrogenase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(117401, NULL, 'G3DSA:3.40.50.410:FF:000272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117402, NULL, 'G3DSA:3.30.160.60:FF:004797', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117403, NULL, 'G3DSA:3.40.50.1700:FF:000028', NULL, NULL, 'Glycoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(117404, NULL, 'G3DSA:3.30.1340.30:FF:000001', NULL, NULL, 'Molecular chaperone OsmY', NULL, NULL, NULL, NULL, NULL, 4),
(117405, NULL, 'G3DSA:3.30.1490.190:FF:000006', NULL, NULL, 'Fur family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(117406, NULL, 'G3DSA:3.40.50.620:FF:000627', NULL, NULL, 'Arginyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(117407, NULL, 'G3DSA:1.20.58.400:FF:000011', NULL, NULL, 'Putative Qb-SNARE protein', NULL, NULL, NULL, NULL, NULL, 4),
(117408, NULL, 'G3DSA:3.30.40.10:FF:000631', NULL, NULL, 'Os03g0377600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(117409, NULL, 'G3DSA:3.30.1490.180:FF:000003', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(117410, NULL, 'G3DSA:1.25.10.10:FF:001186', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(117411, NULL, 'G3DSA:1.10.486.10:FF:000065', NULL, NULL, 'UvrD/REP helicase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(117412, NULL, 'G3DSA:3.40.50.2000:FF:000995', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117413, NULL, 'G3DSA:3.30.830.10:FF:000298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117414, NULL, 'G3DSA:3.80.10.10:FF:004056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117415, NULL, 'G3DSA:3.40.50.360:FF:000116', NULL, NULL, 'Sulfite reductase (Nadph), alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(117416, NULL, 'G3DSA:1.25.40.10:FF:003458', NULL, NULL, 'Os11g0109800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(117417, NULL, 'G3DSA:3.90.830.10:FF:000020', NULL, NULL, 'Vacuolar protein sorting-associated protein 45, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117418, NULL, 'G3DSA:3.60.110.10:FF:000074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117419, NULL, 'G3DSA:3.30.420.40:FF:001012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117420, NULL, 'G3DSA:2.60.40.10:FF:005016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117421, NULL, 'G3DSA:1.20.1560.10:FF:000465', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(117422, NULL, 'G3DSA:1.10.565.10:FF:000103', NULL, NULL, 'Nuclear receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(117423, NULL, 'G3DSA:3.40.50.1010:FF:000125', NULL, NULL, 'DNA-repair protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(117424, NULL, 'G3DSA:1.20.1070.10:FF:000883', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117425, NULL, 'G3DSA:1.10.287.4070:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117426, NULL, 'G3DSA:3.40.50.300:FF:006809', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117427, NULL, 'G3DSA:3.40.50.720:FF:001410', NULL, NULL, 'UDP-glucose 4-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(117428, NULL, 'G3DSA:3.10.20.230:FF:000011', NULL, NULL, 'Doublecortin domain containing 2B', NULL, NULL, NULL, NULL, NULL, 4),
(117429, NULL, 'G3DSA:3.60.10.10:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117430, NULL, 'G3DSA:2.130.10.10:FF:000997', NULL, NULL, 'AGAP002030-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(117431, NULL, 'G3DSA:1.20.58.150:FF:000008', NULL, NULL, 'Putative clathrin assembly protein At1g33340', NULL, NULL, NULL, NULL, NULL, 4),
(117432, NULL, 'G3DSA:3.80.10.10:FF:003010', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(117433, NULL, 'G3DSA:3.20.20.190:FF:000075', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(117434, NULL, 'G3DSA:3.10.110.10:FF:000068', NULL, NULL, 'Ubiquitin-conjugating enzyme E2-20 kDa', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(117435, NULL, 'G3DSA:3.40.50.300:FF:005056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117436, NULL, 'G3DSA:3.30.310.80:FF:000043', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(117437, NULL, 'G3DSA:3.30.420.10:FF:000160', NULL, NULL, 'Cruciform cutting endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(117438, NULL, 'G3DSA:1.20.1250.10:FF:000032', NULL, NULL, 'Interleukin-22', NULL, NULL, NULL, NULL, NULL, 4),
(117439, NULL, 'G3DSA:3.40.50.510:FF:000004', NULL, NULL, 'Dihydroxyacetone kinase subunit DhaM', NULL, NULL, NULL, NULL, NULL, 4),
(117440, NULL, 'G3DSA:2.60.120.290:FF:000017', NULL, NULL, 'Platelet derived growth factor C', NULL, NULL, NULL, NULL, NULL, 4),
(117441, NULL, 'G3DSA:2.170.300.10:FF:000032', NULL, NULL, 'Platelet endothelial aggregation receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(117442, NULL, 'G3DSA:2.80.10.50:FF:000051', NULL, NULL, 'Fascin', NULL, NULL, NULL, NULL, NULL, 4),
(117443, NULL, 'G3DSA:1.10.10.60:FF:001239', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117444, NULL, 'G3DSA:3.40.50.80:FF:000028', NULL, NULL, 'Respiratory burst oxidase protein E', NULL, NULL, NULL, NULL, NULL, 4),
(117445, NULL, 'G3DSA:2.60.120.10:FF:000117', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(117446, NULL, 'G3DSA:3.30.160.60:FF:001924', NULL, NULL, 'Charlatan, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(117447, NULL, 'G3DSA:1.10.150.220:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117448, NULL, 'G3DSA:3.30.40.10:FF:000575', NULL, NULL, 'Cellulose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(117449, NULL, 'G3DSA:3.80.10.10:FF:004112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117450, NULL, 'G3DSA:4.10.1000.10:FF:000154', NULL, NULL, 'zinc finger CCCH domain-containing protein 10 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(117451, NULL, 'G3DSA:3.40.850.10:FF:000336', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(117452, NULL, 'G3DSA:3.30.70.330:FF:000485', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(117453, NULL, 'G3DSA:2.60.40.10:FF:005634', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117454, NULL, 'G3DSA:3.40.50.10490:FF:000135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117455, NULL, 'G3DSA:1.10.10.60:FF:000099', NULL, NULL, 'MYB transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(117456, NULL, 'G3DSA:1.20.120.850:FF:000004', NULL, NULL, 'DNA repair and recombination protein RAD54B', NULL, NULL, NULL, NULL, NULL, 4),
(117457, NULL, 'G3DSA:3.30.479.20:FF:000040', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(117458, NULL, 'G3DSA:1.25.50.20:FF:000005', NULL, NULL, 'Aminopeptidase N-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(117459, NULL, 'G3DSA:1.10.1220.10:FF:000010', NULL, NULL, 'Putative nickel-responsive regulator', NULL, NULL, NULL, NULL, NULL, 4),
(117460, NULL, 'G3DSA:3.30.70.330:FF:001625', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117461, NULL, 'G3DSA:3.30.590.50:FF:000015', NULL, NULL, 'Glutamate-cysteine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(117462, NULL, 'G3DSA:3.50.50.60:FF:001191', NULL, NULL, 'Sulfide Quinone oxidoReDuctase', NULL, NULL, NULL, NULL, NULL, 4),
(117463, NULL, 'G3DSA:1.10.510.10:FF:003220', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117464, NULL, 'G3DSA:3.40.50.720:FF:002309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117465, NULL, 'G3DSA:1.25.50.10:FF:000002', NULL, NULL, 'Puromycin-sensitive aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(117466, NULL, 'G3DSA:1.25.40.10:FF:003610', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(117467, NULL, 'G3DSA:3.30.70.150:FF:000003', NULL, NULL, 'Ribulose bisphosphate carboxylase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(117468, NULL, 'G3DSA:1.25.40.470:FF:000073', NULL, NULL, 'WD-repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(117469, NULL, 'G3DSA:3.40.50.300:FF:005707', NULL, NULL, 'Dynein heavy chain domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(117470, NULL, 'G3DSA:1.25.40.10:FF:003082', NULL, NULL, 'Pentatricopeptide repeat domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(117471, NULL, 'G3DSA:3.40.50.2300:FF:000585', NULL, NULL, 'Branched-chain amino acid ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(117472, NULL, 'G3DSA:1.25.40.180:FF:000071', NULL, NULL, 'Eukaryotic translation initiation factor 4 gamma', NULL, NULL, NULL, NULL, NULL, 4),
(117473, NULL, 'G3DSA:1.25.40.10:FF:002593', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117474, NULL, 'G3DSA:3.30.900.10:FF:000034', NULL, NULL, 'DNA polymerase zeta processivity subunit', NULL, NULL, NULL, NULL, NULL, 4),
(117475, NULL, 'G3DSA:3.30.160.20:FF:000125', NULL, NULL, 'Peptide chain release factor 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117476, NULL, 'G3DSA:2.30.30.1020:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117477, NULL, 'G3DSA:1.20.1540.10:FF:000048', NULL, NULL, 'Rhomboid protease ROM9', NULL, NULL, NULL, NULL, NULL, 4),
(117478, NULL, 'G3DSA:2.70.50.30:FF:000008', NULL, NULL, 'Immunoglobulin E-set', NULL, NULL, NULL, NULL, NULL, 4),
(117479, NULL, 'G3DSA:1.10.10.60:FF:000986', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117480, NULL, 'G3DSA:3.40.50.300:FF:006776', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117481, NULL, 'G3DSA:3.40.50.2000:FF:000467', NULL, NULL, '3-deoxy-D-manno-octulosonic acid transferase', NULL, NULL, NULL, NULL, NULL, 4),
(117482, NULL, 'G3DSA:2.60.120.260:FF:000621', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117483, NULL, 'G3DSA:3.40.50.300:FF:001487', NULL, NULL, 'Shikimate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(117484, NULL, 'G3DSA:1.10.10.10:FF:001034', NULL, NULL, 'Two component transcriptional regulator, winged helix family', NULL, NULL, NULL, NULL, NULL, 4),
(117485, NULL, 'G3DSA:1.10.510.10:FF:001275', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(117486, NULL, 'G3DSA:1.10.630.10:FF:000435', NULL, NULL, 'Cytochrome P450 76A2', NULL, NULL, NULL, NULL, NULL, 4),
(117487, NULL, 'G3DSA:3.30.56.30:FF:000010', NULL, NULL, 'Signal recognition particle sec65 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(117488, NULL, 'G3DSA:1.10.630.10:FF:000087', NULL, NULL, 'Thromboxane A synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(117489, NULL, 'G3DSA:1.20.120.1240:FF:000067', NULL, NULL, 'Dynamin-related GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(117490, NULL, 'G3DSA:1.10.150.200:FF:000003', NULL, NULL, 'Maltooligosyl trehalose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(117491, NULL, 'G3DSA:1.10.10.60:FF:001116', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117492, NULL, 'G3DSA:1.10.3370.10:FF:000021', NULL, NULL, 'Protein transport protein sec61 alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117493, NULL, 'G3DSA:2.60.40.10:FF:001273', NULL, NULL, 'Hibris, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(117494, NULL, 'G3DSA:3.40.1170.60:FF:000028', NULL, NULL, 'DNA polymerase eta', NULL, NULL, NULL, NULL, NULL, 4),
(117495, NULL, 'G3DSA:2.10.25.10:FF:000559', NULL, NULL, 'Crumbs 2, cell polarity complex component', NULL, NULL, NULL, NULL, NULL, 4),
(117496, NULL, 'G3DSA:3.30.43.10:FF:000019', NULL, NULL, 'L-galactono-1,4-lactone dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(117497, NULL, 'G3DSA:1.20.1070.10:FF:000703', NULL, NULL, 'Protein CBG03949', NULL, NULL, NULL, NULL, NULL, 4),
(117498, NULL, 'G3DSA:1.10.575.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117499, NULL, 'G3DSA:3.40.50.1820:FF:000716', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117500, NULL, 'G3DSA:2.60.40.10:FF:001891', NULL, NULL, 'Tyrosine protein kinase receptor tie-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117501, NULL, 'G3DSA:1.20.120.1910:FF:000054', NULL, NULL, 'Os10g0463100 protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(117502, NULL, 'G3DSA:3.30.460.10:FF:000196', NULL, NULL, 'Ribosomal silencing factor RsfS', NULL, NULL, NULL, NULL, NULL, 4),
(117503, NULL, 'G3DSA:1.10.472.10:FF:000685', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117504, NULL, 'G3DSA:3.40.50.410:FF:000362', NULL, NULL, 'Bcl-2-associated transcription factor (BTF), putative', NULL, NULL, NULL, NULL, NULL, 4),
(117505, NULL, 'G3DSA:2.60.40.10:FF:005544', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117506, NULL, 'G3DSA:3.90.850.10:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117507, NULL, 'G3DSA:1.10.275.10:FF:000002', NULL, NULL, 'Argininosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(117508, NULL, 'G3DSA:2.130.10.10:FF:001930', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(117509, NULL, 'G3DSA:3.30.70.330:FF:000518', NULL, NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(117510, NULL, 'G3DSA:2.60.60.20:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117511, NULL, 'G3DSA:3.40.50.300:FF:005146', NULL, NULL, 'Torsin-1A', NULL, NULL, NULL, NULL, NULL, 4),
(117512, NULL, 'G3DSA:1.20.5.110:FF:000194', NULL, NULL, 'Synaptosomal-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(117513, NULL, 'G3DSA:3.60.21.10:FF:000001', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(117514, NULL, 'G3DSA:3.40.50.720:FF:000393', NULL, NULL, 'Homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(117515, NULL, 'G3DSA:2.60.40.420:FF:000059', NULL, NULL, 'L-ascorbate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(117516, NULL, 'G3DSA:1.20.930.60:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117517, NULL, 'G3DSA:2.60.120.10:FF:000353', NULL, NULL, 'Transcription regulator, CRP family', NULL, NULL, NULL, NULL, NULL, 4),
(117518, NULL, 'G3DSA:3.30.70.660:FF:000089', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(117519, NULL, 'G3DSA:1.20.5.170:FF:000015', NULL, NULL, 'ARF GTPase-activating protein GIT2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(117520, NULL, 'G3DSA:1.10.1740.10:FF:000009', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(117521, NULL, 'G3DSA:1.20.950.20:FF:000027', NULL, NULL, 'Cytochrome b561', NULL, NULL, NULL, NULL, NULL, 4),
(117522, NULL, 'G3DSA:2.60.40.420:FF:000031', NULL, NULL, 'Laccase-2 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(117523, NULL, 'G3DSA:1.20.120.160:FF:000005', NULL, NULL, 'Histidine-containing phosphotransfer protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(117524, NULL, 'G3DSA:1.50.10.10:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117525, NULL, 'G3DSA:2.60.120.970:FF:000070', NULL, NULL, 'Inhibin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(117526, NULL, 'G3DSA:3.90.190.10:FF:000605', NULL, NULL, 'MkpA protein', NULL, NULL, NULL, NULL, NULL, 4),
(117527, NULL, 'G3DSA:3.40.1110.10:FF:000324', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117528, NULL, 'G3DSA:3.30.9.10:FF:000160', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(117529, NULL, 'G3DSA:4.10.1000.10:FF:000064', NULL, NULL, 'Putative zinc finger domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(117530, NULL, 'G3DSA:1.10.275.30:FF:000008', NULL, NULL, 'DNA helicase RepD', NULL, NULL, NULL, NULL, NULL, 4),
(117531, NULL, 'G3DSA:1.10.630.10:FF:000620', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117532, NULL, 'G3DSA:2.60.40.10:FF:001621', NULL, NULL, 'Immunoglobulin heavy variable 2-6-8', NULL, NULL, NULL, NULL, NULL, 4),
(117533, NULL, 'G3DSA:2.40.50.700:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117534, NULL, 'G3DSA:3.30.450.20:FF:000316', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(117535, NULL, 'G3DSA:1.10.275.20:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(117536, NULL, 'G3DSA:2.30.29.30:FF:000348', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(117537, NULL, 'G3DSA:3.40.50.970:FF:000209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117538, NULL, 'G3DSA:3.40.50.720:FF:002456', NULL, NULL, 'Methylenetetrahydrofolate dehydrogenase (NADP+-dependent) 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(117539, NULL, 'G3DSA:2.130.10.10:FF:005640', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117540, NULL, 'G3DSA:3.40.910.10:FF:000015', NULL, NULL, 'Deoxyhypusine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(117541, NULL, 'G3DSA:1.20.1720.10:FF:000028', NULL, NULL, 'Multidrug MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(117542, NULL, 'G3DSA:1.20.120.150:FF:000002', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(117543, NULL, 'G3DSA:3.60.20.10:FF:000095', NULL, NULL, 'Asparagine synthase (Glutamine-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4),
(117544, NULL, 'G3DSA:3.10.105.10:FF:000123', NULL, NULL, 'Dipeptide binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(117545, NULL, 'G3DSA:1.25.10.10:FF:002939', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117546, NULL, 'G3DSA:2.60.40.10:FF:000778', NULL, NULL, 'Fibronectin type III domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(117547, NULL, 'G3DSA:2.30.29.30:FF:000641', NULL, NULL, 'Exocyst complex component', NULL, NULL, NULL, NULL, NULL, 4),
(117548, NULL, 'G3DSA:2.10.110.10:FF:000139', NULL, NULL, 'Protein CBR-ZYX-1', NULL, NULL, NULL, NULL, NULL, 4),
(117549, NULL, 'G3DSA:3.30.40.10:FF:002199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117550, NULL, 'G3DSA:1.20.120.1020:FF:000001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117551, NULL, 'G3DSA:2.60.120.200:FF:000715', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117552, NULL, 'G3DSA:2.40.50.90:FF:000163', NULL, NULL, 'Tudor domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(117553, NULL, 'G3DSA:2.30.30.190:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117554, NULL, 'G3DSA:3.40.50.150:FF:001419', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117555, NULL, 'G3DSA:3.30.1370.50:FF:000009', NULL, NULL, 'RBS1p protein', NULL, NULL, NULL, NULL, NULL, 4),
(117556, NULL, 'G3DSA:3.30.1360.40:FF:000034', NULL, NULL, 'ribosome-recycling factor, mitochondrial-like', NULL, NULL, NULL, NULL, NULL, 4),
(117557, NULL, 'G3DSA:1.20.1530.20:FF:000079', NULL, NULL, 'Probable sodium/hydrogen antiporter', NULL, NULL, NULL, NULL, NULL, 4),
(117558, NULL, 'G3DSA:3.80.10.10:FF:000402', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase IRK', NULL, NULL, NULL, NULL, NULL, 4),
(117559, NULL, 'G3DSA:3.90.640.10:FF:000039', NULL, NULL, 'Hsp70 family chaperone Lhs1/Orp150', NULL, NULL, NULL, NULL, NULL, 4),
(117560, NULL, 'G3DSA:3.30.160.60:FF:002503', NULL, NULL, 'Zinc finger protein 280D', NULL, NULL, NULL, NULL, NULL, 4),
(117561, NULL, 'G3DSA:2.60.40.200:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117562, NULL, 'G3DSA:2.10.25.10:FF:000503', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(117563, NULL, 'G3DSA:1.25.40.860:FF:000004', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(117564, NULL, 'G3DSA:3.40.50.2300:FF:000669', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117565, NULL, 'G3DSA:1.25.10.10:FF:001219', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(117566, NULL, 'G3DSA:1.20.120.20:FF:000015', NULL, NULL, 'Zgc:162608', NULL, NULL, NULL, NULL, NULL, 4),
(117567, NULL, 'G3DSA:2.120.10.30:FF:000526', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(117568, NULL, 'G3DSA:3.40.1110.10:FF:000291', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(117569, NULL, 'G3DSA:3.30.1520.10:FF:000173', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(117570, NULL, 'G3DSA:3.20.20.140:FF:000083', NULL, NULL, 'Dihydroorotase, homodimeric type', NULL, NULL, NULL, NULL, NULL, 4),
(117571, NULL, 'G3DSA:2.40.50.120:FF:000048', NULL, NULL, 'Metalloproteinase inhibitor 2', NULL, NULL, NULL, NULL, NULL, 4),
(117572, NULL, 'G3DSA:2.70.160.11:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117573, NULL, 'G3DSA:2.30.110.10:FF:000005', NULL, NULL, 'NAD(P)H-hydrate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(117574, NULL, 'G3DSA:3.40.850.10:FF:000246', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(117575, NULL, 'G3DSA:1.10.3380.10:FF:000050', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(117576, NULL, 'G3DSA:3.30.450.20:FF:000642', NULL, NULL, 'Histidine kinase response regulator hybrid protein', NULL, NULL, NULL, NULL, NULL, 4),
(117577, NULL, 'G3DSA:3.40.30.10:FF:000433', NULL, NULL, 'Probable dolichyl-diphosphooligosaccharide--protein glycosyltransferase subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(117578, NULL, 'G3DSA:1.25.40.530:FF:000018', NULL, NULL, 'Unconventional myosin heavy chain 6', NULL, NULL, NULL, NULL, NULL, 4),
(117579, NULL, 'G3DSA:1.25.10.10:FF:001130', NULL, NULL, 'TORTIFOLIA1-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(117580, NULL, 'G3DSA:3.40.50.300:FF:002330', NULL, NULL, 'ATP-dependent RNA helicase DDX27', NULL, NULL, NULL, NULL, NULL, 4),
(117581, NULL, 'G3DSA:3.20.20.150:FF:000029', NULL, NULL, 'L-xylulose 5-phosphate 3-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(117582, NULL, 'G3DSA:2.130.10.10:FF:005584', NULL, NULL, 'Myosin heavy chain kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(117583, NULL, 'G3DSA:1.20.120.20:FF:000009', NULL, NULL, 'apolipoprotein A-V', NULL, NULL, NULL, NULL, NULL, 4),
(117584, NULL, 'G3DSA:2.70.20.30:FF:000001', NULL, NULL, 'Matrix protein', NULL, NULL, NULL, NULL, NULL, 4),
(117585, NULL, 'G3DSA:3.90.1420.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117586, NULL, 'G3DSA:3.30.160.60:FF:003487', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117587, NULL, 'G3DSA:2.40.50.140:FF:000386', NULL, NULL, 'rRNA biogenesis protein RRP5', NULL, NULL, NULL, NULL, NULL, 4),
(117588, NULL, 'G3DSA:1.20.58.80:FF:000034', NULL, NULL, 'STAM binding protein like 1', NULL, NULL, NULL, NULL, NULL, 4),
(117589, NULL, 'G3DSA:3.30.160.60:FF:001778', NULL, NULL, 'ras-responsive element-binding protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(117590, NULL, 'G3DSA:1.20.1560.10:FF:000752', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117591, NULL, 'G3DSA:1.10.472.80:FF:000071', NULL, NULL, 'TBC1 domain family', NULL, NULL, NULL, NULL, NULL, 4),
(117592, NULL, 'G3DSA:2.60.40.10:FF:004999', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117593, NULL, 'G3DSA:2.60.120.650:FF:000176', NULL, NULL, 'PHD zinc finger-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(117594, NULL, 'G3DSA:1.10.220.30:FF:000016', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(117595, NULL, 'G3DSA:1.20.120.350:FF:000034', NULL, NULL, 'Sodium leak channel non-selective protein', NULL, NULL, NULL, NULL, NULL, 4),
(117596, NULL, 'G3DSA:1.20.1510.10:FF:000075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117597, NULL, 'G3DSA:1.10.260.100:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117598, NULL, 'G3DSA:3.40.50.11500:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117599, NULL, 'G3DSA:1.10.510.10:FF:001185', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117600, NULL, 'G3DSA:1.20.58.90:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117601, NULL, 'G3DSA:1.10.510.10:FF:000201', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(117602, NULL, 'G3DSA:1.20.272.10:FF:000089', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(117603, NULL, 'G3DSA:3.40.50.970:FF:000119', NULL, NULL, '2-oxoglutarate dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117604, NULL, 'G3DSA:3.40.910.10:FF:000009', NULL, NULL, 'Deoxyhypusine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(117605, NULL, 'G3DSA:1.25.40.510:FF:000012', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(117606, NULL, 'G3DSA:2.160.20.10:FF:000137', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(117607, NULL, 'G3DSA:2.60.40.10:FF:000401', NULL, NULL, 'Down syndrome cell adhesion molecule', NULL, NULL, NULL, NULL, NULL, 4),
(117608, NULL, 'G3DSA:2.30.30.100:FF:000232', NULL, NULL, 'Sm-like protein LSM6A', NULL, NULL, NULL, NULL, NULL, 4),
(117609, NULL, 'G3DSA:2.60.120.590:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117610, NULL, 'G3DSA:3.40.1280.10:FF:000123', NULL, NULL, 'Similar to LOC495800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(117611, NULL, 'G3DSA:1.10.472.10:FF:000359', NULL, NULL, 'Cyclin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117612, NULL, 'G3DSA:2.60.120.200:FF:000772', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117613, NULL, 'G3DSA:1.25.40.10:FF:004768', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117614, NULL, 'G3DSA:1.10.150.670:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117615, NULL, 'G3DSA:1.10.3590.10:FF:000003', NULL, NULL, 'acid-sensing ion channel 3 isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(117616, NULL, 'G3DSA:1.10.287.70:FF:000547', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117617, NULL, 'G3DSA:3.40.50.2000:FF:000793', NULL, NULL, 'Trehalose-6-phosphate synthase/phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(117618, NULL, 'G3DSA:2.10.25.10:FF:000560', NULL, NULL, 'Teneurin-m-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(117619, NULL, 'G3DSA:3.40.30.10:FF:000231', NULL, NULL, 'Glutathione S-transferase PARB', NULL, NULL, NULL, NULL, NULL, 4),
(117620, NULL, 'G3DSA:1.25.40.10:FF:002677', NULL, NULL, 'Coatomer epsilon subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(117621, NULL, 'G3DSA:1.10.510.10:FF:001505', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117622, NULL, 'G3DSA:3.30.200.20:FF:001107', NULL, NULL, 'Interleukin-1 receptor-associated kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(117623, NULL, 'G3DSA:3.50.20.20:FF:000002', NULL, NULL, 'Sex-regulated protein janus-B', NULL, NULL, NULL, NULL, NULL, 4),
(117624, NULL, 'G3DSA:3.30.70.330:FF:003008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117625, NULL, 'G3DSA:3.20.20.80:FF:000336', NULL, NULL, '1,4-alpha-glucan-branching enzyme 2, chloroplastic/amyloplastic', NULL, NULL, NULL, NULL, NULL, 4),
(117626, NULL, 'G3DSA:3.30.470.20:FF:000172', NULL, NULL, 'Bifunctional purine synthesis protein purC/E', NULL, NULL, NULL, NULL, NULL, 4),
(117627, NULL, 'G3DSA:2.60.40.1820:FF:000010', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(117628, NULL, 'G3DSA:3.30.70.1350:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117629, NULL, 'G3DSA:2.10.10.100:FF:000002', NULL, NULL, 'UDP-N-acetylhexosamine pyrophosphorylase-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(117630, NULL, 'G3DSA:1.20.1070.10:FF:000467', NULL, NULL, 'NeuroPeptide Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(117631, NULL, 'G3DSA:3.40.50.620:FF:000453', NULL, NULL, 'tRNA-specific 2-thiouridylase MnmA', NULL, NULL, NULL, NULL, NULL, 4),
(117632, NULL, 'G3DSA:1.25.10.10:FF:001545', NULL, NULL, 'Importin beta, nuclear transport factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117633, NULL, 'G3DSA:1.20.1560.10:FF:000639', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117634, NULL, 'G3DSA:3.20.110.10:FF:000015', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(117635, NULL, 'G3DSA:3.90.650.10:FF:000068', NULL, NULL, 'AGAP002091-PA', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(117636, NULL, 'G3DSA:1.25.40.10:FF:004392', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117637, NULL, 'G3DSA:3.20.20.70:FF:000333', NULL, NULL, 'GTP 3'',8-cyclase 1', NULL, NULL, NULL, NULL, NULL, 4),
(117638, NULL, 'G3DSA:1.10.510.10:FF:000578', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(117639, NULL, 'G3DSA:3.40.50.10190:FF:000348', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117640, NULL, 'G3DSA:1.20.1250.20:FF:000984', NULL, NULL, 'Solute carrier family 16 member 9', NULL, NULL, NULL, NULL, NULL, 4),
(117641, NULL, 'G3DSA:3.10.50.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117642, NULL, 'G3DSA:1.10.730.10:FF:000089', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(117643, NULL, 'G3DSA:3.40.630.30:FF:000421', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117644, NULL, 'G3DSA:3.30.70.330:FF:002935', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117645, NULL, 'G3DSA:3.30.2090.10:FF:000009', NULL, NULL, 'Cation efflux system protein CusA', NULL, NULL, NULL, NULL, NULL, 4),
(117646, NULL, 'G3DSA:2.10.25.10:FF:001487', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117647, NULL, 'G3DSA:1.20.1420.30:FF:000107', NULL, NULL, 'AGAP010976-PA', NULL, NULL, NULL, NULL, NULL, 4),
(117648, NULL, 'G3DSA:1.10.1780.10:FF:000012', NULL, NULL, 'ATP-dependent Clp protease regulatory subunit ClpC', NULL, NULL, NULL, NULL, NULL, 4),
(117649, NULL, 'G3DSA:3.40.390.10:FF:000109', NULL, NULL, 'Matrix metallopeptidase 19', NULL, NULL, NULL, NULL, NULL, 4),
(117650, NULL, 'G3DSA:2.130.10.30:FF:000065', NULL, NULL, 'NEK (NEver in mitosis Kinase) Like', NULL, NULL, NULL, NULL, NULL, 4),
(117651, NULL, 'G3DSA:3.10.20.370:FF:000002', NULL, NULL, 'Gag-Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(117652, NULL, 'G3DSA:1.10.8.10:FF:000184', NULL, NULL, 'P phosphoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(117653, NULL, 'G3DSA:3.40.50.150:FF:000115', NULL, NULL, 'Cyclopropane mycolic acid synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(117654, NULL, 'G3DSA:1.20.1730.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117655, NULL, 'G3DSA:1.10.418.10:FF:000279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117656, NULL, 'G3DSA:3.30.70.330:FF:000844', NULL, NULL, 'Proteins containing the RNA recognition motif', NULL, NULL, NULL, NULL, NULL, 4),
(117657, NULL, 'G3DSA:1.10.640.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117658, NULL, 'G3DSA:1.10.8.270:FF:000188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117659, NULL, 'G3DSA:3.30.160.60:FF:005376', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117660, NULL, 'G3DSA:3.40.50.150:FF:001043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117661, NULL, 'G3DSA:2.20.25.10:FF:000042', NULL, NULL, 'Peptide-N(4)-(N-acetyl-beta-glucosaminyl)asparagine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(117662, NULL, 'G3DSA:1.20.1280.20:FF:000008', NULL, NULL, 'J-type co-chaperone JAC1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(117663, NULL, 'G3DSA:3.40.50.1820:FF:000452', NULL, NULL, 'ABHydrolase Domain containing homolog', NULL, NULL, NULL, NULL, NULL, 4),
(117664, NULL, 'G3DSA:2.60.40.10:FF:005460', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117665, NULL, 'G3DSA:3.20.20.220:FF:000011', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(117666, NULL, 'G3DSA:3.40.50.10490:FF:000141', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117667, NULL, 'G3DSA:3.30.500.10:FF:000020', NULL, NULL, 'Orla-UEA*0201 protein', NULL, NULL, NULL, NULL, NULL, 4),
(117668, NULL, 'G3DSA:3.80.10.10:FF:003948', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117669, NULL, 'G3DSA:3.40.50.300:FF:001964', NULL, NULL, 'Non-structural polyprotein pORF1', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(117670, NULL, 'G3DSA:1.20.1180.10:FF:000003', NULL, NULL, 'Protein ROOT HAIR DEFECTIVE 3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(117671, NULL, 'G3DSA:2.10.109.10:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117672, NULL, 'G3DSA:3.30.60.110:FF:000001', NULL, NULL, 'Probable alpha-methylacyl-CoA racemase mcr', NULL, NULL, NULL, NULL, NULL, 4),
(117673, NULL, 'G3DSA:3.30.505.10:FF:000003', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(117674, NULL, 'G3DSA:3.40.50.150:FF:001751', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117675, NULL, 'G3DSA:2.60.40.10:FF:004853', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117676, NULL, 'G3DSA:3.60.40.10:FF:000124', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(117677, NULL, 'G3DSA:1.20.1070.10:FF:000411', NULL, NULL, 'Zgc:162592', NULL, NULL, NULL, NULL, NULL, 4),
(117678, NULL, 'G3DSA:1.50.40.10:FF:000292', NULL, NULL, 'Mitochondrial carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(117679, NULL, 'G3DSA:2.30.42.10:FF:000508', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117680, NULL, 'G3DSA:1.20.1260.10:FF:000061', NULL, NULL, 'Hypothetical membrane protein, conserved, DUF125 family', NULL, NULL, NULL, NULL, NULL, 4),
(117681, NULL, 'G3DSA:1.10.287.70:FF:000132', NULL, NULL, 'OSMotic avoidance abnormal family member', NULL, NULL, NULL, NULL, NULL, 4),
(117682, NULL, 'G3DSA:3.30.1520.10:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117683, NULL, 'G3DSA:1.25.40.20:FF:001376', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117684, NULL, 'G3DSA:2.130.10.10:FF:002150', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(117685, NULL, 'G3DSA:3.30.160.60:FF:001632', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117686, NULL, 'G3DSA:1.10.437.10:FF:000025', NULL, NULL, 'BCL2 like 13', NULL, NULL, NULL, NULL, NULL, 4),
(117687, NULL, 'G3DSA:1.10.1760.20:FF:000014', NULL, NULL, 'Pantothenic acid transporter pant', NULL, NULL, NULL, NULL, NULL, 4),
(117688, NULL, 'G3DSA:1.20.1250.20:FF:000512', NULL, NULL, 'Putative inorganic phosphate cotransporter-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(117689, NULL, 'G3DSA:3.30.420.40:FF:000410', NULL, NULL, 'Actin-related protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(117690, NULL, 'G3DSA:3.90.190.10:FF:000083', NULL, NULL, 'Dual specificity protein phosphatase 12-like', NULL, NULL, NULL, NULL, NULL, 4),
(117691, NULL, 'G3DSA:3.30.70.270:FF:000242', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117692, NULL, 'G3DSA:1.25.10.10:FF:002001', NULL, NULL, 'Armadillo-type protein', NULL, NULL, NULL, NULL, NULL, 4),
(117693, NULL, 'G3DSA:1.20.1260.10:FF:000004', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(117694, NULL, 'G3DSA:1.20.1050.10:FF:000292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117695, NULL, 'G3DSA:1.20.5.170:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117696, NULL, 'G3DSA:1.10.8.1020:FF:000001', NULL, NULL, 'RecQ-mediated genome instability protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(117697, NULL, 'G3DSA:2.40.30.20:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117698, NULL, 'G3DSA:3.10.250.10:FF:000140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117699, NULL, 'G3DSA:1.10.630.10:FF:000143', NULL, NULL, 'Cytochrome P450 714D1', NULL, NULL, NULL, NULL, NULL, 4),
(117700, NULL, 'G3DSA:1.10.10.10:FF:001326', NULL, NULL, 'ADP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(117701, NULL, 'G3DSA:3.10.580.10:FF:000125', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(117702, NULL, 'G3DSA:1.25.40.10:FF:001373', NULL, NULL, 'Tetratricopeptide repeat domain 26', NULL, NULL, NULL, NULL, NULL, 4),
(117703, NULL, 'G3DSA:2.60.40.10:FF:001565', NULL, NULL, 'Immunoglobulin superfamily member 22', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(117704, NULL, 'G3DSA:3.40.50.720:FF:000657', NULL, NULL, '4-hydroxy-tetrahydrodipicolinate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(117705, NULL, 'G3DSA:1.10.10.160:FF:000035', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(117706, NULL, 'G3DSA:3.40.800.20:FF:000010', NULL, NULL, 'Histone deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(117707, NULL, 'G3DSA:3.10.400.20:FF:000031', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(117708, NULL, 'G3DSA:3.40.50.880:FF:000188', NULL, NULL, 'Carbamoyl-phosphate synthase small chain', NULL, NULL, NULL, NULL, NULL, 4),
(117709, NULL, 'G3DSA:1.10.510.10:FF:001449', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117710, NULL, 'G3DSA:2.20.25.190:FF:000003', NULL, NULL, 'Transcription elongation factor 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(117711, NULL, 'G3DSA:3.40.1620.60:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117712, NULL, 'G3DSA:3.30.160.60:FF:003723', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117713, NULL, 'G3DSA:1.10.1370.10:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117714, NULL, 'G3DSA:3.90.640.10:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117715, NULL, 'G3DSA:3.30.2070.10:FF:000008', NULL, NULL, 'Molybdopterin oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(117716, NULL, 'G3DSA:3.60.40.10:FF:000034', NULL, NULL, 'PAS domain S-box protein', NULL, NULL, NULL, NULL, NULL, 4),
(117717, NULL, 'G3DSA:3.30.960.10:FF:000009', NULL, NULL, 'Heat shock protein family A (Hsp70) member 9', NULL, NULL, NULL, NULL, NULL, 4),
(117718, NULL, 'G3DSA:2.60.40.10:FF:005836', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117719, NULL, 'G3DSA:2.130.10.10:FF:004977', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117720, NULL, 'G3DSA:3.20.20.300:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117721, NULL, 'G3DSA:3.30.1360.10:FF:000019', NULL, NULL, 'DNA-directed RNA polymerase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(117722, NULL, 'G3DSA:3.30.160.60:FF:005319', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117723, NULL, 'G3DSA:3.90.1860.10:FF:000010', NULL, NULL, 'tRNA-splicing ligase RtcB', NULL, NULL, NULL, NULL, NULL, 4),
(117724, NULL, 'G3DSA:3.80.10.10:FF:000661', NULL, NULL, 'Extracellular matrix protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(117725, NULL, 'G3DSA:3.50.50.60:FF:000786', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117726, NULL, 'G3DSA:3.90.190.10:FF:000370', NULL, NULL, 'Protein tyrosine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(117727, NULL, 'G3DSA:1.20.1250.20:FF:002277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117728, NULL, 'G3DSA:1.20.1070.10:FF:002176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117729, NULL, 'G3DSA:1.10.510.10:FF:004001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117730, NULL, 'G3DSA:2.130.10.10:FF:004269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117731, NULL, 'G3DSA:3.50.50.60:FF:000729', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(117732, NULL, 'G3DSA:3.90.190.10:FF:000313', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(117733, NULL, 'G3DSA:1.20.1280.50:FF:000023', NULL, NULL, 'F-box/LRR-repeat protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(117734, NULL, 'G3DSA:2.130.10.10:FF:001543', NULL, NULL, 'Dug2p', NULL, NULL, NULL, NULL, NULL, 4),
(117735, NULL, 'G3DSA:3.20.20.140:FF:000285', NULL, NULL, 'Histidinol-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(117736, NULL, 'G3DSA:1.10.3080.10:FF:000010', NULL, NULL, 'Voltage-gated ClC-type chloride channel ClcB', NULL, NULL, NULL, NULL, NULL, 4),
(117737, NULL, 'G3DSA:2.120.10.30:FF:000296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117738, NULL, 'G3DSA:3.40.50.300:FF:000183', NULL, NULL, 'ABC transporter ATP-binding protein yjjK', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(117739, NULL, 'G3DSA:3.30.70.330:FF:001210', NULL, NULL, 'AGAP002655-PA', NULL, NULL, NULL, NULL, NULL, 4),
(117740, NULL, 'G3DSA:3.40.50.850:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117741, NULL, 'G3DSA:2.60.120.260:FF:000475', NULL, NULL, 'Anaphase-promoting complex subunit 10', NULL, NULL, NULL, NULL, NULL, 4),
(117742, NULL, 'G3DSA:1.20.920.10:FF:000163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117743, NULL, 'G3DSA:1.10.8.60:FF:000148', NULL, NULL, 'Putative ATPase, AAA family', NULL, NULL, NULL, NULL, NULL, 4),
(117744, NULL, 'G3DSA:3.30.420.10:FF:000452', NULL, NULL, 'Target of EGR1 protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(117745, NULL, 'G3DSA:3.80.10.10:FF:000604', NULL, NULL, 'Si:ch211-156p11.1', NULL, NULL, NULL, NULL, NULL, 4),
(117746, NULL, 'G3DSA:2.40.50.140:FF:000908', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117747, NULL, 'G3DSA:3.40.50.2000:FF:001102', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(117748, NULL, 'G3DSA:3.40.50.1260:FF:000003', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(117749, NULL, 'G3DSA:1.20.920.10:FF:000106', NULL, NULL, 'Bromodomain', NULL, NULL, NULL, NULL, NULL, 4),
(117750, NULL, 'G3DSA:2.10.25.10:FF:000267', NULL, NULL, 'pro-neuregulin-3, membrane-bound isoform', NULL, NULL, NULL, NULL, NULL, 4),
(117751, NULL, 'G3DSA:3.40.630.10:FF:000499', NULL, NULL, 'Aspartyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(117752, NULL, 'G3DSA:4.10.240.10:FF:000040', NULL, NULL, 'CEP3p kinetochore protein', NULL, NULL, NULL, NULL, NULL, 4),
(117753, NULL, 'G3DSA:3.30.160.60:FF:005522', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117754, NULL, 'G3DSA:4.10.280.10:FF:000014', NULL, NULL, 'Max dimerization protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(117755, NULL, 'G3DSA:3.40.50.150:FF:001189', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117756, NULL, 'G3DSA:2.60.200.40:FF:000043', NULL, NULL, 'Sphingosine kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(117757, NULL, 'G3DSA:3.40.50.300:FF:007473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117758, NULL, 'G3DSA:4.10.900.10:FF:000006', NULL, NULL, 'Cadherin-9 preproprotein', NULL, NULL, NULL, NULL, NULL, 4),
(117759, NULL, 'G3DSA:1.10.10.200:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117760, NULL, 'G3DSA:3.30.160.60:FF:000143', NULL, NULL, 'Zinc finger protein 521', NULL, NULL, NULL, NULL, NULL, 4),
(117761, NULL, 'G3DSA:3.80.10.10:FF:000458', NULL, NULL, 'Leucine rich repeat containing 57', NULL, NULL, NULL, NULL, NULL, 4),
(117762, NULL, 'G3DSA:3.50.50.60:FF:000168', NULL, NULL, 'Probable sarcosine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(117763, NULL, 'G3DSA:2.40.50.140:FF:001167', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117764, NULL, 'G3DSA:2.40.50.140:FF:001223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117765, NULL, 'G3DSA:1.20.1280.180:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117766, NULL, 'G3DSA:3.30.760.10:FF:000090', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(117767, NULL, 'G3DSA:1.25.40.10:FF:005116', NULL, NULL, 'Pentatricopeptide (PPR) repeat-containing protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(117768, NULL, 'G3DSA:3.40.1190.20:FF:000012', NULL, NULL, 'Ribokinase', NULL, NULL, NULL, NULL, NULL, 4),
(117769, NULL, 'G3DSA:3.30.9.10:FF:000305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117770, NULL, 'G3DSA:2.60.200.30:FF:000040', NULL, NULL, 'Uncharacterized kinase C24B10.02c', NULL, NULL, NULL, NULL, NULL, 4),
(117771, NULL, 'G3DSA:3.20.20.80:FF:000156', NULL, NULL, 'Chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(117772, NULL, 'G3DSA:1.25.10.10:FF:000489', NULL, NULL, 'Armadillo repeat containing 8', NULL, NULL, NULL, NULL, NULL, 4),
(117773, NULL, 'G3DSA:1.10.10.10:FF:001365', NULL, NULL, 'DNA-binding SARP family transcriptional activator', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(117774, NULL, 'G3DSA:3.40.50.300:FF:003673', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(117775, NULL, 'G3DSA:1.25.40.20:FF:001522', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(117776, NULL, 'G3DSA:2.60.120.200:FF:000064', NULL, NULL, 'Laminin subunit alpha 4', NULL, NULL, NULL, NULL, NULL, 4),
(117777, NULL, 'G3DSA:3.40.1810.10:FF:000001', NULL, NULL, 'Myocyte-specific enhancer factor 2A homolog', NULL, NULL, NULL, NULL, NULL, 4),
(117778, NULL, 'G3DSA:3.80.10.10:FF:004443', NULL, NULL, 'MDIS1-interacting receptor like kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(117779, NULL, 'G3DSA:3.90.190.10:FF:000403', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117780, NULL, 'G3DSA:2.40.50.100:FF:000222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117781, NULL, 'G3DSA:3.80.10.10:FF:004258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117782, NULL, 'G3DSA:3.30.420.10:FF:000339', NULL, NULL, 'AGAP007399-PA', NULL, NULL, NULL, NULL, NULL, 4),
(117783, NULL, 'G3DSA:2.60.40.10:FF:003420', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117784, NULL, 'G3DSA:2.30.30.140:FF:000305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117785, NULL, 'G3DSA:1.20.1070.10:FF:000557', NULL, NULL, 'Melatonin receptor type 1A', NULL, NULL, NULL, NULL, NULL, 4),
(117786, NULL, 'G3DSA:1.10.555.10:FF:000131', NULL, NULL, 'Chromosome 16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(117787, NULL, 'G3DSA:1.25.40.10:FF:001334', NULL, NULL, 'OSJNBa0041A02.15 protein', NULL, NULL, NULL, NULL, NULL, 4),
(117788, NULL, 'G3DSA:3.40.50.360:FF:000032', NULL, NULL, 'Bifunctional cytochrome P450/NADPH--P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(117789, NULL, 'G3DSA:2.130.10.30:FF:000155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117790, NULL, 'G3DSA:1.20.1250.20:FF:000366', NULL, NULL, 'Sucrose transport protein SUT5', NULL, NULL, NULL, NULL, NULL, 4),
(117791, NULL, 'G3DSA:3.40.50.2300:FF:000905', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117792, NULL, 'G3DSA:2.60.40.340:FF:000012', NULL, NULL, 'RELA proto-oncogene, NF-kB subunit', NULL, NULL, NULL, NULL, NULL, 4),
(117793, NULL, 'G3DSA:3.40.50.720:FF:002192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117794, NULL, 'G3DSA:3.10.310.10:FF:000049', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(117795, NULL, 'G3DSA:1.10.510.10:FF:003074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117796, NULL, 'G3DSA:1.10.287.1700:FF:000004', NULL, NULL, 'Flagellar export protein FliJ', NULL, NULL, NULL, NULL, NULL, 4),
(117797, NULL, 'G3DSA:3.90.850.10:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117798, NULL, 'G3DSA:1.10.340.30:FF:000048', NULL, NULL, 'Endonuclease III-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(117799, NULL, 'G3DSA:3.30.1140.32:FF:000005', NULL, NULL, '40S ribosomal protein S3', NULL, NULL, NULL, NULL, NULL, 4),
(117800, NULL, 'G3DSA:2.40.40.20:FF:000012', NULL, NULL, 'Vesicle-fusing ATPase protein', NULL, NULL, NULL, NULL, NULL, 4),
(117801, NULL, 'G3DSA:2.60.40.10:FF:003217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117802, NULL, 'G3DSA:3.30.70.660:FF:000033', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(117803, NULL, 'G3DSA:2.10.70.10:FF:000102', NULL, NULL, 'Sushi domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(117804, NULL, 'G3DSA:3.90.1150.10:FF:000271', NULL, NULL, 'Glycine cleavage system P protein', NULL, NULL, NULL, NULL, NULL, 4),
(117805, NULL, 'G3DSA:1.25.40.660:FF:000006', NULL, NULL, 'Vacuolar protein sorting-associated protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(117806, NULL, 'G3DSA:1.10.1220.10:FF:000009', NULL, NULL, 'Antitoxin EndoAI', NULL, NULL, NULL, NULL, NULL, 4),
(117807, NULL, 'G3DSA:2.60.120.620:FF:000105', NULL, NULL, 'Os03g0166100 protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(117808, NULL, 'G3DSA:1.10.390.10:FF:000045', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(117809, NULL, 'G3DSA:3.10.290.10:FF:000024', NULL, NULL, 'RNA pseudouridine synthase 2 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(117810, NULL, 'G3DSA:1.20.1740.10:FF:000086', NULL, NULL, 'Amino acid transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117811, NULL, 'G3DSA:1.20.1250.20:FF:000276', NULL, NULL, 'Sugar transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(117812, NULL, 'G3DSA:1.20.5.420:FF:000017', NULL, NULL, 'Maltose/maltodextrin-binding periplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(117813, NULL, 'G3DSA:2.30.29.110:FF:000002', NULL, NULL, 'Type II inositol 1,4,5-trisphosphate 5-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(117814, NULL, 'G3DSA:1.10.510.10:FF:001562', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(117815, NULL, 'G3DSA:2.60.120.620:FF:000015', NULL, NULL, 'Prolyl 4-hydroxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(117816, NULL, 'G3DSA:3.30.300.10:FF:000033', NULL, NULL, 'S-adenosylmethionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(117817, NULL, 'G3DSA:1.25.40.650:FF:000003', NULL, NULL, 'Penicillin-binding protein activator', NULL, NULL, NULL, NULL, NULL, 4),
(117818, NULL, 'G3DSA:3.30.160.60:FF:001722', NULL, NULL, 'Zinc finger protein 155', NULL, NULL, NULL, NULL, NULL, 4),
(117819, NULL, 'G3DSA:1.10.490.30:FF:000002', NULL, NULL, 'Colicin-E1', NULL, NULL, NULL, NULL, NULL, 4),
(117820, NULL, 'G3DSA:3.40.190.10:FF:000364', NULL, NULL, 'Si:dkey-183j2.10', NULL, NULL, NULL, NULL, NULL, 4),
(117821, NULL, 'G3DSA:1.10.238.20:FF:000009', NULL, NULL, 'AGAP012321-PA', NULL, NULL, NULL, NULL, NULL, 4),
(117822, NULL, 'G3DSA:1.25.10.10:FF:000202', NULL, NULL, 'HEAT repeat-containing protein 5B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(117823, NULL, 'G3DSA:3.40.225.10:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117824, NULL, 'G3DSA:3.30.40.10:FF:000962', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117825, NULL, 'G3DSA:2.60.120.200:FF:000154', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(117826, NULL, 'G3DSA:3.10.129.10:FF:000178', NULL, NULL, 'Bifunctional 3-hydroxyacyl-CoA dehydrogenase/thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(117827, NULL, 'G3DSA:1.20.58.60:FF:000438', NULL, NULL, 'Nesprin-1', NULL, NULL, NULL, NULL, NULL, 4),
(117828, NULL, 'G3DSA:3.40.50.2300:FF:001310', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117829, NULL, 'G3DSA:3.30.70.330:FF:002227', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117830, NULL, 'G3DSA:1.20.1560.10:FF:000134', NULL, NULL, 'ABC transporter transmembrane region', NULL, NULL, NULL, NULL, NULL, 4),
(117831, NULL, 'G3DSA:1.10.238.10:FF:000006', NULL, NULL, 'Calmodulin 1', NULL, NULL, NULL, NULL, NULL, 4),
(117832, NULL, 'G3DSA:2.60.40.60:FF:000568', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117833, NULL, 'G3DSA:3.40.50.12780:FF:000092', NULL, NULL, 'Solute carrier family 27 member 4', NULL, NULL, NULL, NULL, NULL, 4),
(117834, NULL, 'G3DSA:1.25.40.10:FF:002823', NULL, NULL, 'Sll0837 protein', NULL, NULL, NULL, NULL, NULL, 4),
(117835, NULL, 'G3DSA:4.10.60.10:FF:000198', NULL, NULL, 'Cold shock domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(117836, NULL, 'G3DSA:3.30.300.20:FF:000036', NULL, NULL, 'GTPase Der', NULL, NULL, NULL, NULL, NULL, 4),
(117837, NULL, 'G3DSA:3.80.10.10:FF:002313', NULL, NULL, 'AGAP001470-PA', NULL, NULL, NULL, NULL, NULL, 4),
(117838, NULL, 'G3DSA:1.10.510.10:FF:003692', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117839, NULL, 'G3DSA:2.60.220.50:FF:000086', NULL, NULL, 'SET domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(117840, NULL, 'G3DSA:2.60.40.10:FF:003835', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117841, NULL, 'G3DSA:3.30.300.30:FF:000039', NULL, NULL, 'Benzoate-CoA ligase family', NULL, NULL, NULL, NULL, NULL, 4),
(117842, NULL, 'G3DSA:1.20.1270.60:FF:000295', NULL, NULL, 'ArfGAP with SH3 domain, ankyrin repeat and PH domain 3', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(117843, NULL, 'G3DSA:1.10.10.800:FF:000007', NULL, NULL, 'Alpha/Beta hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(117844, NULL, 'G3DSA:3.90.640.10:FF:000191', NULL, NULL, 'Protein-vacuolar targeting-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117845, NULL, 'G3DSA:3.30.499.10:FF:000009', NULL, NULL, 'Aconitate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(117846, NULL, 'G3DSA:2.40.30.260:FF:000002', NULL, NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme GidA', NULL, NULL, NULL, NULL, NULL, 4),
(117847, NULL, 'G3DSA:2.70.160.11:FF:000079', NULL, NULL, 'Protein arginine N-methyltransferase PRMT1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117848, NULL, 'G3DSA:3.80.10.10:FF:000548', NULL, NULL, 'Receptor-like protein kinase HSL1', NULL, NULL, NULL, NULL, NULL, 4),
(117849, NULL, 'G3DSA:1.10.287.70:FF:000076', NULL, NULL, 'Potassium channel subfamily K member', NULL, NULL, NULL, NULL, NULL, 4),
(117850, NULL, 'G3DSA:1.20.1270.10:FF:000033', NULL, NULL, 'heat shock 70 kDa protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(117851, NULL, 'G3DSA:1.20.58.60:FF:000495', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(117852, NULL, 'G3DSA:2.102.10.10:FF:000004', NULL, NULL, '3-phenylpropionate/cinnamic acid dioxygenase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(117853, NULL, 'G3DSA:1.25.40.120:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117854, NULL, 'G3DSA:1.10.101.10:FF:000026', NULL, NULL, 'Lytic transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(117855, NULL, 'G3DSA:1.25.10.10:FF:001506', NULL, NULL, 'Sorting Of Apical Proteins', NULL, NULL, NULL, NULL, NULL, 4),
(117856, NULL, 'G3DSA:3.80.10.10:FF:000368', NULL, NULL, 'Chondroadherin like', NULL, NULL, NULL, NULL, NULL, 4),
(117857, NULL, 'G3DSA:3.30.230.10:FF:000095', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(117858, NULL, 'G3DSA:2.60.40.1930:FF:000037', NULL, NULL, 'Complement component C5', NULL, NULL, NULL, NULL, NULL, 4),
(117859, NULL, 'G3DSA:3.30.70.260:FF:000036', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(117860, NULL, 'G3DSA:3.30.160.60:FF:005432', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117861, NULL, 'G3DSA:1.10.287.130:FF:000184', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(117862, NULL, 'G3DSA:3.40.630.30:FF:000185', NULL, NULL, 'YDR391C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(117863, NULL, 'G3DSA:4.10.280.10:FF:000104', NULL, NULL, 'Transcription factor bHLH34', NULL, NULL, NULL, NULL, NULL, 4),
(117864, NULL, 'G3DSA:3.40.50.300:FF:003763', NULL, NULL, 'Nethylmaleimide sensitive fusion family protein', NULL, NULL, NULL, NULL, NULL, 4),
(117865, NULL, 'G3DSA:1.25.40.10:FF:000968', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(117866, NULL, 'G3DSA:3.40.50.1820:FF:000396', NULL, NULL, 'Acyl-protein thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(117867, NULL, 'G3DSA:3.20.20.70:FF:000187', NULL, NULL, 'Fructose-bisphosphate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(117868, NULL, 'G3DSA:3.40.50.150:FF:001099', NULL, NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(117869, NULL, 'G3DSA:3.40.50.1760:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117870, NULL, 'G3DSA:2.60.40.10:FF:003925', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117871, NULL, 'G3DSA:3.10.129.10:FF:000268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117872, NULL, 'G3DSA:3.40.140.70:FF:000007', NULL, NULL, 'Putative ubiquitin activating e1 enzyme-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(117873, NULL, 'G3DSA:1.25.40.10:FF:005173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117874, NULL, 'G3DSA:1.20.58.390:FF:000232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117875, NULL, 'G3DSA:2.60.120.330:FF:000142', NULL, NULL, 'Putative 2-oxoglutarate-dependent dioxygenase DIN11', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(117876, NULL, 'G3DSA:3.80.10.10:FF:002403', NULL, NULL, 'PH domain and leucine-rich repeat protein phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(117877, NULL, 'G3DSA:2.60.120.590:FF:000080', NULL, NULL, 'AGAP000155-PA', NULL, NULL, NULL, NULL, NULL, 4),
(117878, NULL, 'G3DSA:3.40.50.300:FF:007416', NULL, NULL, 'p-GlycoProtein related', NULL, NULL, NULL, NULL, NULL, 4),
(117879, NULL, 'G3DSA:1.10.287.660:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117880, NULL, 'G3DSA:1.10.150.560:FF:000004', NULL, NULL, 'Major DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(117881, NULL, 'G3DSA:3.30.70.270:FF:000039', NULL, NULL, 'Paternally expressed 10', NULL, NULL, NULL, NULL, NULL, 4),
(117882, NULL, 'G3DSA:1.10.150.550:FF:000001', NULL, NULL, 'Nucleoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(117883, NULL, 'G3DSA:3.40.710.10:FF:000028', NULL, NULL, 'Penicillin-binding protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(117884, NULL, 'G3DSA:2.60.40.10:FF:003274', NULL, NULL, 'Leucine-rich repeat-containing 24', NULL, NULL, NULL, NULL, NULL, 4),
(117885, NULL, 'G3DSA:3.40.50.720:FF:000803', NULL, NULL, 'UDP-galactopyranose mutase', NULL, NULL, NULL, NULL, NULL, 4),
(117886, NULL, 'G3DSA:3.40.250.10:FF:000133', NULL, NULL, 'M-phase inducer phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117887, NULL, 'G3DSA:3.40.50.1220:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117888, NULL, 'G3DSA:2.40.50.140:FF:000296', NULL, NULL, 'Putative DNA helicase MCM8', NULL, NULL, NULL, NULL, NULL, 4),
(117889, NULL, 'G3DSA:1.10.287.130:FF:000217', NULL, NULL, 'Sensor histidine kinase, NtrB-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(117890, NULL, 'G3DSA:3.40.50.720:FF:000713', NULL, NULL, 'Short-chain type dehydrogenase/reductase', NULL, NULL, NULL, NULL, NULL, 4),
(117891, NULL, 'G3DSA:3.30.70.330:FF:002755', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117892, NULL, 'G3DSA:1.20.1270.60:FF:000328', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117893, NULL, 'G3DSA:3.30.70.330:FF:002845', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117894, NULL, 'G3DSA:1.20.930.60:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117895, NULL, 'G3DSA:2.30.30.30:FF:000094', NULL, NULL, 'Transcription termination/antitermination protein NusG', NULL, NULL, NULL, NULL, NULL, 4),
(117896, NULL, 'G3DSA:2.170.120.40:FF:000010', NULL, NULL, 'Putative exported protein', NULL, NULL, NULL, NULL, NULL, 4),
(117897, NULL, 'G3DSA:1.20.120.230:FF:000049', NULL, NULL, 'breast cancer anti-estrogen resistance protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(117898, NULL, 'G3DSA:1.10.287.70:FF:000019', NULL, NULL, 'G protein-activated inward rectifier potassium channel 1', NULL, NULL, NULL, NULL, NULL, 4),
(117899, NULL, 'G3DSA:3.40.250.10:FF:000043', NULL, NULL, 'Sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(117900, NULL, 'G3DSA:3.30.590.10:FF:000054', NULL, NULL, 'Arginine kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117901, NULL, 'G3DSA:1.25.10.10:FF:000112', NULL, NULL, 'Kinesin associated protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(117902, NULL, 'G3DSA:3.10.20.870:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117903, NULL, 'G3DSA:2.160.10.10:FF:000075', NULL, NULL, 'Putative nonribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(117904, NULL, 'G3DSA:1.10.287.130:FF:000127', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(117905, NULL, 'G3DSA:2.102.10.10:FF:000061', NULL, NULL, 'Non-heme iron oxygenase ferredoxin subunit', NULL, NULL, NULL, NULL, NULL, 4),
(117906, NULL, 'G3DSA:3.30.40.10:FF:001182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117907, NULL, 'G3DSA:2.60.34.10:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117908, NULL, 'G3DSA:2.60.40.10:FF:004201', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(117909, NULL, 'G3DSA:3.40.50.2300:FF:000815', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117910, NULL, 'G3DSA:1.20.58.60:FF:000348', NULL, NULL, 'Nesprin-2', NULL, NULL, NULL, NULL, NULL, 4),
(117911, NULL, 'G3DSA:3.40.710.10:FF:000180', NULL, NULL, 'Multimodular transpeptidase-transglycosylase PBP 1A', NULL, NULL, NULL, NULL, NULL, 4),
(117912, NULL, 'G3DSA:2.10.25.10:FF:000413', NULL, NULL, 'Crumbs cell polarity complex component 1', NULL, NULL, NULL, NULL, NULL, 4),
(117913, NULL, 'G3DSA:1.10.472.80:FF:000161', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117914, NULL, 'G3DSA:3.30.70.260:FF:000183', NULL, NULL, 'Chorismate mutase/prephenate dehydratase (P-protein)', NULL, NULL, NULL, NULL, NULL, 4),
(117915, NULL, 'G3DSA:3.30.200.20:FF:000944', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(117916, NULL, 'G3DSA:3.30.1370.30:FF:000003', NULL, NULL, '30S ribosomal protein S8', NULL, NULL, NULL, NULL, NULL, 4),
(117917, NULL, 'G3DSA:3.30.160.60:FF:003577', NULL, NULL, 'Zinc finger protein 770', NULL, NULL, NULL, NULL, NULL, 4),
(117918, NULL, 'G3DSA:1.10.238.160:FF:000003', NULL, NULL, 'DNA-binding transcriptional activator AlpA', NULL, NULL, NULL, NULL, NULL, 4),
(117919, NULL, 'G3DSA:3.10.20.90:FF:000154', NULL, NULL, 'Large proline-rich protein BAG6', NULL, NULL, NULL, NULL, NULL, 4),
(117920, NULL, 'G3DSA:1.10.1410.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117921, NULL, 'G3DSA:1.20.5.710:FF:000019', NULL, NULL, '50S ribosomal protein L7/L12', NULL, NULL, NULL, NULL, NULL, 4),
(117922, NULL, 'G3DSA:1.10.1000.11:FF:000011', NULL, NULL, 'Gluconokinase', NULL, NULL, NULL, NULL, NULL, 4),
(117923, NULL, 'G3DSA:3.40.50.2300:FF:000872', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117924, NULL, 'G3DSA:2.30.30.40:FF:000658', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(117925, NULL, 'G3DSA:2.60.120.200:FF:000625', NULL, NULL, 'Putative L-type lectin-domain containing receptor kinase V.8', NULL, NULL, NULL, NULL, NULL, 4),
(117926, NULL, 'G3DSA:3.10.590.10:FF:000007', NULL, NULL, 'YDR374C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(117927, NULL, 'G3DSA:2.60.40.10:FF:003364', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF b', NULL, NULL, NULL, NULL, NULL, 4),
(117928, NULL, 'G3DSA:2.60.420.10:FF:000011', NULL, NULL, 'Glycoside hydrolase family 65 protein', NULL, NULL, NULL, NULL, NULL, 4),
(117929, NULL, 'G3DSA:3.30.70.270:FF:000186', NULL, NULL, 'Bifunctional diguanylate cyclase/phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(117930, NULL, 'G3DSA:1.20.5.1200:FF:000007', NULL, NULL, 'Retinaldehyde binding protein 1b', NULL, NULL, NULL, NULL, NULL, 4),
(117931, NULL, 'G3DSA:3.30.565.10:FF:000220', NULL, NULL, 'Molecular chaperone/ Grp94/Hsp90', NULL, NULL, NULL, NULL, NULL, 4),
(117932, NULL, 'G3DSA:3.90.550.10:FF:000122', NULL, NULL, 'Dolichol-phosphate mannosyltransferase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(117933, NULL, 'G3DSA:1.10.1240.10:FF:000011', NULL, NULL, 'Methanosarcina family methyltransferase cognate corrinoid protein', NULL, NULL, NULL, NULL, NULL, 4),
(117934, NULL, 'G3DSA:3.40.50.1820:FF:001323', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117935, NULL, 'G3DSA:3.30.460.10:FF:000050', NULL, NULL, 'DNA polymerase POL4', NULL, NULL, NULL, NULL, NULL, 4),
(117936, NULL, 'G3DSA:2.60.120.200:FF:000682', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117937, NULL, 'G3DSA:2.60.470.10:FF:000014', NULL, NULL, 'Amiloride-sensitive sodium channel subunit beta-2', NULL, NULL, NULL, NULL, NULL, 4),
(117938, NULL, 'G3DSA:2.20.110.10:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117939, NULL, 'G3DSA:4.10.240.10:FF:000124', NULL, NULL, 'C6 finger domain transcription factor gliZ', NULL, NULL, NULL, NULL, NULL, 4),
(117940, NULL, 'G3DSA:1.20.1600.10:FF:000014', NULL, NULL, 'Alkaline protease secretion protein AprF', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(117941, NULL, 'G3DSA:1.10.238.270:FF:000008', NULL, NULL, 'GD25818', NULL, NULL, NULL, NULL, NULL, 4),
(117942, NULL, 'G3DSA:1.10.238.260:FF:000005', NULL, NULL, 'Putative homocitrate synthase AksA', NULL, NULL, NULL, NULL, NULL, 4),
(117943, NULL, 'G3DSA:2.130.10.30:FF:000037', NULL, NULL, 'Inhibitor of Bruton tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(117944, NULL, 'G3DSA:3.40.50.300:FF:007411', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117945, NULL, 'G3DSA:3.90.79.20:FF:000001', NULL, NULL, 'NADH pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(117946, NULL, 'G3DSA:2.30.42.10:FF:000418', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117947, NULL, 'G3DSA:3.20.20.70:FF:000041', NULL, NULL, 'Fructose-bisphosphate aldolase class I', NULL, NULL, NULL, NULL, NULL, 4),
(117948, NULL, 'G3DSA:1.20.272.10:FF:000010', NULL, NULL, 'Replication factor C subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(117949, NULL, 'G3DSA:1.20.120.1530:FF:000002', NULL, NULL, 'Two-component osmosensing histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(117950, NULL, 'G3DSA:2.130.10.10:FF:000031', NULL, NULL, 'Splicing factor 3b subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(117951, NULL, 'G3DSA:1.20.1740.10:FF:000119', NULL, NULL, 'Solute carrier family 7 member 7', NULL, NULL, NULL, NULL, NULL, 4),
(117952, NULL, 'G3DSA:1.10.640.10:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117953, NULL, 'G3DSA:1.25.40.10:FF:002975', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117954, NULL, 'G3DSA:1.20.1720.10:FF:000080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117955, NULL, 'G3DSA:1.25.10.10:FF:001950', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(117956, NULL, 'G3DSA:3.90.190.10:FF:000318', NULL, NULL, 'Probable protein tyrosine phosphatase type IVA B', NULL, NULL, NULL, NULL, NULL, 4),
(117957, NULL, 'G3DSA:3.20.20.80:FF:000044', NULL, NULL, 'Chitinase III C10701-rice', NULL, NULL, NULL, NULL, NULL, 4),
(117958, NULL, 'G3DSA:3.40.850.10:FF:000544', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(117959, NULL, 'G3DSA:3.30.720.200:FF:000009', NULL, NULL, 'Glycine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(117960, NULL, 'G3DSA:2.130.10.10:FF:005932', NULL, NULL, 'Neurobeachin/beige protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117961, NULL, 'G3DSA:3.50.50.60:FF:000286', NULL, NULL, 'Malate:quinone oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(117962, NULL, 'G3DSA:1.25.40.20:FF:000887', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117963, NULL, 'G3DSA:3.30.1370.120:FF:000021', NULL, NULL, 'General secretion pathway protein D', NULL, NULL, NULL, NULL, NULL, 4),
(117964, NULL, 'G3DSA:1.25.40.20:FF:001404', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117965, NULL, 'G3DSA:2.60.40.10:FF:005275', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117966, NULL, 'G3DSA:3.40.33.10:FF:000024', NULL, NULL, 'Protein CBG17169', NULL, NULL, NULL, NULL, NULL, 4),
(117967, NULL, 'G3DSA:3.40.50.12780:FF:000232', NULL, NULL, 'Uncharacterized protein C56F8.02', NULL, NULL, NULL, NULL, NULL, 4),
(117968, NULL, 'G3DSA:3.30.70.270:FF:000247', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117969, NULL, 'G3DSA:1.25.10.10:FF:003018', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(117970, NULL, 'G3DSA:3.40.850.10:FF:000482', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(117971, NULL, 'G3DSA:3.30.160.60:FF:003307', NULL, NULL, 'KAISO-like zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(117972, NULL, 'G3DSA:3.80.10.10:FF:004325', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117973, NULL, 'G3DSA:3.40.50.12660:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117974, NULL, 'G3DSA:3.30.160.20:FF:000070', NULL, NULL, 'Related to MRF1-peptide chain release factor, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(117975, NULL, 'G3DSA:2.120.10.30:FF:000178', NULL, NULL, 'Gluconolactonase', NULL, NULL, NULL, NULL, NULL, 4),
(117976, NULL, 'G3DSA:1.10.510.10:FF:003186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117977, NULL, 'G3DSA:1.20.1250.10:FF:000116', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117978, NULL, 'G3DSA:1.10.630.10:FF:000553', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117979, NULL, 'G3DSA:1.20.1070.10:FF:000377', NULL, NULL, 'DOPamine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(117980, NULL, 'G3DSA:1.10.8.60:FF:000058', NULL, NULL, 'Cell division control protein', NULL, NULL, NULL, NULL, NULL, 4),
(117981, NULL, 'G3DSA:1.50.10.20:FF:000080', NULL, NULL, 'Mannan endo-1,6-alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(117982, NULL, 'G3DSA:2.40.50.140:FF:000740', NULL, NULL, 'Interferon-activable protein 202', NULL, NULL, NULL, NULL, NULL, 4),
(117983, NULL, 'G3DSA:3.30.70.3170:FF:000005', NULL, NULL, 'Ribosomal protein S5 domain 2-type protein', NULL, NULL, NULL, NULL, NULL, 4),
(117984, NULL, 'G3DSA:3.40.50.12650:FF:000013', NULL, NULL, 'MoRTal germline', NULL, NULL, NULL, NULL, NULL, 4),
(117985, NULL, 'G3DSA:3.40.20.10:FF:000106', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(117986, NULL, 'G3DSA:1.25.40.10:FF:000884', NULL, NULL, 'TPR repeat-containing protein C19B12.01', NULL, NULL, NULL, NULL, NULL, 4),
(117987, NULL, 'G3DSA:3.90.800.10:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(117988, NULL, 'G3DSA:2.130.10.10:FF:004943', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117989, NULL, 'G3DSA:3.30.300.30:FF:000157', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(117990, NULL, 'G3DSA:3.40.1410.10:FF:000044', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(117991, NULL, 'G3DSA:1.50.40.10:FF:000320', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117992, NULL, 'G3DSA:3.80.10.10:FF:000161', NULL, NULL, 'F-box/LRR-repeat protein 17 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(117993, NULL, 'G3DSA:2.170.150.80:FF:000001', NULL, NULL, 'NAC domain-containing protein 73', NULL, NULL, NULL, NULL, NULL, 4),
(117994, NULL, 'G3DSA:3.40.50.300:FF:007506', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117995, NULL, 'G3DSA:3.90.190.10:FF:000369', NULL, NULL, 'Paladin', NULL, NULL, NULL, NULL, NULL, 4),
(117996, NULL, 'G3DSA:3.80.10.10:FF:002285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(117997, NULL, 'G3DSA:1.20.1250.20:FF:002311', NULL, NULL, 'Major facilitator family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(117998, NULL, 'G3DSA:1.10.287.70:FF:000199', NULL, NULL, 'Glutamate receptor ionotropic, NMDA 2B', NULL, NULL, NULL, NULL, NULL, 4),
(117999, NULL, 'G3DSA:1.20.910.10:FF:000044', NULL, NULL, 'Putative hydroxymethylpyrimidine/phosphomethylpyrimidine kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(118000, NULL, 'G3DSA:3.20.20.380:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118001, NULL, 'G3DSA:1.10.630.10:FF:000227', NULL, NULL, 'Putative cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(118002, NULL, 'G3DSA:1.10.940.10:FF:000037', NULL, NULL, 'tRNA/rRNA cytosine-C5-methylase, NOL1/NOP2/Sun family', NULL, NULL, NULL, NULL, NULL, 4),
(118003, NULL, 'G3DSA:3.40.50.620:FF:000801', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(118004, NULL, 'G3DSA:3.60.15.10:FF:000088', NULL, NULL, 'Quinolone signal response protein', NULL, NULL, NULL, NULL, NULL, 4),
(118005, NULL, 'G3DSA:3.30.900.10:FF:000028', NULL, NULL, 'AGAP001326-PA', NULL, NULL, NULL, NULL, NULL, 4),
(118006, NULL, 'G3DSA:3.40.1280.10:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118007, NULL, 'G3DSA:3.90.190.10:FF:000223', NULL, NULL, 'Putative tyrosine specific protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(118008, NULL, 'G3DSA:3.40.50.450:FF:000109', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(118009, NULL, 'G3DSA:3.40.50.2300:FF:000821', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118010, NULL, 'G3DSA:3.20.20.70:FF:000092', NULL, NULL, 'Uridine monophosphate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(118011, NULL, 'G3DSA:3.30.559.10:FF:000251', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(118012, NULL, 'G3DSA:3.40.50.300:FF:000323', NULL, NULL, 'Thymidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(118013, NULL, 'G3DSA:3.30.200.20:FF:001293', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(118014, NULL, 'G3DSA:1.10.238.10:FF:001136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118015, NULL, 'G3DSA:2.40.270.10:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118016, NULL, 'G3DSA:4.10.240.10:FF:000219', NULL, NULL, 'Uncharacterized transcriptional regulatory protein C2H10.01', NULL, NULL, NULL, NULL, NULL, 4),
(118017, NULL, 'G3DSA:1.25.40.420:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118018, NULL, 'G3DSA:1.10.510.10:FF:004288', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118019, NULL, 'G3DSA:1.10.472.10:FF:000449', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118020, NULL, 'G3DSA:3.30.450.20:FF:000496', NULL, NULL, 'PAS domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(118021, NULL, 'G3DSA:3.40.50.300:FF:008400', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118022, NULL, 'G3DSA:3.80.10.10:FF:004376', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(118023, NULL, 'G3DSA:1.20.5.170:FF:000138', NULL, NULL, 'ATF (cAMP-dependent transcription factor) family', NULL, NULL, NULL, NULL, NULL, 4),
(118024, NULL, 'G3DSA:2.60.40.10:FF:000053', NULL, NULL, 'Roundabout guidance receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(118025, NULL, 'G3DSA:3.40.190.10:FF:000869', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118026, NULL, 'G3DSA:3.30.70.270:FF:000298', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118027, NULL, 'G3DSA:1.10.10.60:FF:000020', NULL, NULL, 'Ceramide synthase 5', NULL, NULL, NULL, NULL, NULL, 4),
(118028, NULL, 'G3DSA:3.40.50.10140:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118029, NULL, 'G3DSA:1.20.1070.10:FF:001479', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118030, NULL, 'G3DSA:3.30.230.10:FF:000235', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(118031, NULL, 'G3DSA:3.30.1520.10:FF:000083', NULL, NULL, 'GG16618', NULL, NULL, NULL, NULL, NULL, 4),
(118032, NULL, 'G3DSA:1.25.40.10:FF:001452', NULL, NULL, 'Vegetative storage protein', NULL, NULL, NULL, NULL, NULL, 4),
(118033, NULL, 'G3DSA:3.10.490.10:FF:000011', NULL, NULL, 'Troponin C-akin-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(118034, NULL, 'G3DSA:3.30.200.20:FF:000736', NULL, NULL, 'Putative serine/threonine-protein kinase At1g18390 family', NULL, NULL, NULL, NULL, NULL, 4),
(118035, NULL, 'G3DSA:2.130.10.10:FF:005606', NULL, NULL, 'Vacuolar protein sorting/targeting protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(118036, NULL, 'G3DSA:3.60.10.10:FF:000392', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118037, NULL, 'G3DSA:3.20.10.10:FF:000039', NULL, NULL, 'Probable branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(118038, NULL, 'G3DSA:1.20.58.60:FF:000225', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(118039, NULL, 'G3DSA:1.10.287.70:FF:000750', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(118040, NULL, 'G3DSA:3.30.70.100:FF:000180', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118041, NULL, 'G3DSA:3.30.950.10:FF:000014', NULL, NULL, 'Bifunctional S-adenosyl-L-methionine-precorrin-2 methyl transferase/precorrin-3 methylase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(118042, NULL, 'G3DSA:2.30.29.30:FF:000293', NULL, NULL, 'EPS8 like 3', NULL, NULL, NULL, NULL, NULL, 4),
(118043, NULL, 'G3DSA:1.10.8.10:FF:000004', NULL, NULL, 'ubiquitin-associated protein 2-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(118044, NULL, 'G3DSA:3.40.50.970:FF:000097', NULL, NULL, 'Met5 protein', NULL, NULL, NULL, NULL, NULL, 4),
(118045, NULL, 'G3DSA:1.25.40.20:FF:001455', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118046, NULL, 'G3DSA:1.10.10.10:FF:001505', NULL, NULL, 'Bacterial regulatory s, crp family protein', NULL, NULL, NULL, NULL, NULL, 4),
(118047, NULL, 'G3DSA:3.10.490.20:FF:000014', NULL, NULL, 'Dynein heavy chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(118048, NULL, 'G3DSA:1.20.58.60:FF:000551', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(118049, NULL, 'G3DSA:3.90.215.10:FF:000012', NULL, NULL, 'GH13859p', NULL, NULL, NULL, NULL, NULL, 4),
(118050, NULL, 'G3DSA:1.10.10.1340:FF:000001', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 31', NULL, NULL, NULL, NULL, NULL, 4),
(118051, NULL, 'G3DSA:3.30.160.60:FF:005724', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118052, NULL, 'G3DSA:1.10.150.120:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118053, NULL, 'G3DSA:1.25.40.10:FF:000558', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g39710', NULL, NULL, NULL, NULL, NULL, 4),
(118054, NULL, 'G3DSA:1.20.1250.20:FF:001794', NULL, NULL, 'Putative transporter', NULL, NULL, NULL, NULL, NULL, 4),
(118055, NULL, 'G3DSA:3.30.300.30:FF:000106', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(118056, NULL, 'G3DSA:3.30.450.60:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118057, NULL, 'G3DSA:3.40.50.1220:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118058, NULL, 'G3DSA:1.25.40.820:FF:000009', NULL, NULL, 'Putative RNA polymerase II subunit B1 CTD phosphatase rpap-2', NULL, NULL, NULL, NULL, NULL, 4),
(118059, NULL, 'G3DSA:3.40.720.10:FF:000186', NULL, NULL, 'Iduronate-2-sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(118060, NULL, 'G3DSA:3.50.30.30:FF:000130', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(118061, NULL, 'G3DSA:3.40.50.11350:FF:000022', NULL, NULL, 'Protein MANNAN SYNTHESIS-RELATED 2', NULL, NULL, NULL, NULL, NULL, 4),
(118062, NULL, 'G3DSA:2.60.40.10:FF:002402', NULL, NULL, 'Zwei Ig domain protein zig-4', NULL, NULL, NULL, NULL, NULL, 4),
(118063, NULL, 'G3DSA:1.25.40.570:FF:000064', NULL, NULL, 'COP9 signalosome complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(118064, NULL, 'G3DSA:4.10.1000.10:FF:000148', NULL, NULL, 'Protein CBG07225', NULL, NULL, NULL, NULL, NULL, 4),
(118065, NULL, 'G3DSA:2.130.10.10:FF:005202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118066, NULL, 'G3DSA:3.30.1360.70:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118067, NULL, 'G3DSA:1.20.1050.10:FF:000168', NULL, NULL, 'Tef4p', NULL, NULL, NULL, NULL, NULL, 4),
(118068, NULL, 'G3DSA:3.40.50.10130:FF:000050', NULL, NULL, 'DNA repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(118069, NULL, 'G3DSA:3.30.930.10:FF:000070', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(118070, NULL, 'G3DSA:1.20.1050.10:FF:000056', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(118071, NULL, 'G3DSA:1.10.8.1220:FF:000022', NULL, NULL, 'Dynein beta chain, flagellar outer arm', NULL, NULL, NULL, NULL, NULL, 4),
(118072, NULL, 'G3DSA:1.10.8.60:FF:000272', NULL, NULL, 'Replication factor C large subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(118073, NULL, 'G3DSA:1.10.287.130:FF:000072', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(118074, NULL, 'G3DSA:2.60.40.10:FF:005628', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118075, NULL, 'G3DSA:3.40.50.300:FF:001846', NULL, NULL, 'ATP binding cassette subfamily A member 8', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(118076, NULL, 'G3DSA:2.60.120.920:FF:000190', NULL, NULL, 'Butyrophilin-like 7', NULL, NULL, NULL, NULL, NULL, 4),
(118077, NULL, 'G3DSA:3.40.50.150:FF:001812', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118078, NULL, 'G3DSA:3.30.160.60:FF:003633', NULL, NULL, 'Zinc finger protein 131', NULL, NULL, NULL, NULL, NULL, 4),
(118079, NULL, 'G3DSA:3.40.50.150:FF:001863', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118080, NULL, 'G3DSA:3.80.10.10:FF:000840', NULL, NULL, 'Probable inactive leucine-rich repeat receptor kinase XIAO', NULL, NULL, NULL, NULL, NULL, 4),
(118081, NULL, 'G3DSA:1.25.40.20:FF:001730', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118082, NULL, 'G3DSA:3.80.10.10:FF:002931', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118083, NULL, 'G3DSA:3.30.460.10:FF:000106', NULL, NULL, 'poly(A) RNA polymerase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(118084, NULL, 'G3DSA:3.20.20.80:FF:000095', NULL, NULL, 'Endochitinase B1', NULL, NULL, NULL, NULL, NULL, 4),
(118085, NULL, 'G3DSA:1.25.40.120:FF:000013', NULL, NULL, 'Geranylgeranyl transferase type-2 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(118086, NULL, 'G3DSA:3.30.70.330:FF:002429', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118087, NULL, 'G3DSA:2.60.120.200:FF:000569', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118088, NULL, 'G3DSA:1.10.3380.10:FF:000055', NULL, NULL, 'AGR113Wp', NULL, NULL, NULL, NULL, NULL, 4),
(118089, NULL, 'G3DSA:3.40.720.10:FF:000091', NULL, NULL, 'Phosphatidylinositol glycan anchor biosynthesis, class N', NULL, NULL, NULL, NULL, NULL, 4),
(118090, NULL, 'G3DSA:3.40.630.30:FF:000426', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118091, NULL, 'G3DSA:2.30.30.40:FF:000299', NULL, NULL, 'Endophilin B, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(118092, NULL, 'G3DSA:3.40.50.11210:FF:000008', NULL, NULL, 'Rap-GAP domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(118093, NULL, 'G3DSA:3.40.50.2000:FF:000175', NULL, NULL, 'Glycogen synthase', NULL, NULL, NULL, NULL, NULL, 4),
(118094, NULL, 'G3DSA:1.20.1740.10:FF:000024', NULL, NULL, 'High affinity cationic amino acid transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(118095, NULL, 'G3DSA:1.25.10.10:FF:000961', NULL, NULL, 'integrator complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(118096, NULL, 'G3DSA:1.20.5.5160:FF:000004', NULL, NULL, 'Pab1p-dependent poly(A) ribonuclease subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(118097, NULL, 'G3DSA:1.25.40.20:FF:001781', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118098, NULL, 'G3DSA:3.40.140.70:FF:000002', NULL, NULL, 'Autophagy-related protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(118099, NULL, 'G3DSA:3.10.580.10:FF:000035', NULL, NULL, 'Protein SDS23', NULL, NULL, NULL, NULL, NULL, 4),
(118100, NULL, 'G3DSA:1.10.8.1320:FF:000001', NULL, NULL, 'Envelope glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(118101, NULL, 'G3DSA:3.40.50.360:FF:000122', NULL, NULL, 'Sulfite reductase', NULL, NULL, NULL, NULL, NULL, 4),
(118102, NULL, 'G3DSA:3.40.1190.10:FF:000003', NULL, NULL, 'UDP-N-acetylmuramate--L-alanyl-gamma-D-glutamyl-meso-2,6-diaminoheptandioate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(118103, NULL, 'G3DSA:3.30.300.20:FF:000042', NULL, NULL, 'Ribosome-binding factor A', NULL, NULL, NULL, NULL, NULL, 4),
(118104, NULL, 'G3DSA:3.40.1190.20:FF:000006', NULL, NULL, 'Adenosine kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(118105, NULL, 'G3DSA:1.10.1200.270:FF:000006', NULL, NULL, 'Os06g0313320 protein', NULL, NULL, NULL, NULL, NULL, 4),
(118106, NULL, 'G3DSA:3.90.245.10:FF:000014', NULL, NULL, 'Nucleoside hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(118107, NULL, 'G3DSA:3.20.20.80:FF:000370', NULL, NULL, 'Cyanidin 3-O-glucoside 5-O-glucosyltransferase (acyl-glucose)', NULL, NULL, NULL, NULL, NULL, 4),
(118108, NULL, 'G3DSA:1.20.1560.10:FF:000605', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(118109, NULL, 'G3DSA:3.40.50.300:FF:006051', NULL, NULL, 'Dynamin 2b', NULL, NULL, NULL, NULL, NULL, 4),
(118110, NULL, 'G3DSA:2.60.40.60:FF:001063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118111, NULL, 'G3DSA:2.60.40.10:FF:001913', NULL, NULL, 'Mast/stem cell growth factor receptor Kit', NULL, NULL, NULL, NULL, NULL, 4),
(118112, NULL, 'G3DSA:1.10.510.10:FF:001915', NULL, NULL, 'Dual specificity protein kinase zak2', NULL, NULL, NULL, NULL, NULL, 4),
(118113, NULL, 'G3DSA:3.30.1330.90:FF:000024', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(118114, NULL, 'G3DSA:3.40.50.11660:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118115, NULL, 'G3DSA:3.60.40.10:FF:000152', NULL, NULL, 'Protein phosphatase 2C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(118116, NULL, 'G3DSA:1.20.1250.20:FF:000445', NULL, NULL, 'putative inorganic phosphate cotransporter', NULL, NULL, NULL, NULL, NULL, 4),
(118117, NULL, 'G3DSA:3.30.1330.80:FF:000021', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(118118, NULL, 'G3DSA:3.30.40.10:FF:002340', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118119, NULL, 'G3DSA:3.30.505.10:FF:000121', NULL, NULL, 'FYN isoform 7', NULL, NULL, NULL, NULL, NULL, 4),
(118120, NULL, 'G3DSA:2.60.40.10:FF:005224', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118121, NULL, 'G3DSA:3.30.160.60:FF:000502', NULL, NULL, 'Zinc finger protein 710', NULL, NULL, NULL, NULL, NULL, 4),
(118122, NULL, 'G3DSA:3.40.720.10:FF:000040', NULL, NULL, 'Alkaline phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(118123, NULL, 'G3DSA:2.60.130.10:FF:000005', NULL, NULL, 'Catechol 1,2-dioxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(118124, NULL, 'G3DSA:2.60.220.50:FF:000047', NULL, NULL, 'Si:ch211-241f5.3', NULL, NULL, NULL, NULL, NULL, 4),
(118125, NULL, 'G3DSA:3.40.50.150:FF:001245', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118126, NULL, 'G3DSA:2.60.120.10:FF:000230', NULL, NULL, 'cAMP-dependent protein kinase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(118127, NULL, 'G3DSA:3.80.10.10:FF:002408', NULL, NULL, 'Toll receptor 13', NULL, NULL, NULL, NULL, NULL, 4),
(118128, NULL, 'G3DSA:4.10.260.10:FF:000007', NULL, NULL, 'Guanine nucleotide-binding protein subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(118129, NULL, 'G3DSA:1.10.510.10:FF:002989', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118130, NULL, 'G3DSA:3.30.160.20:FF:000002', NULL, NULL, '40S ribosomal protein S2', NULL, NULL, NULL, NULL, NULL, 4),
(118131, NULL, 'G3DSA:1.20.1270.60:FF:000087', NULL, NULL, 'Rho guanyl nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(118132, NULL, 'G3DSA:3.30.1640.30:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118133, NULL, 'G3DSA:3.30.70.270:FF:000326', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118134, NULL, 'G3DSA:3.30.420.10:FF:000047', NULL, NULL, 'Ribonuclease HIII', NULL, NULL, NULL, NULL, NULL, 4),
(118135, NULL, 'G3DSA:1.10.8.10:FF:000330', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(118136, NULL, 'G3DSA:1.10.10.1800:FF:000010', NULL, NULL, 'Glucose-inhibited division family A protein', NULL, NULL, NULL, NULL, NULL, 4),
(118137, NULL, 'G3DSA:2.30.29.30:FF:000225', NULL, NULL, 'GRAM domain containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(118138, NULL, 'G3DSA:3.50.30.20:FF:000008', NULL, NULL, 'CRE-PYR-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(118139, NULL, 'G3DSA:2.130.10.10:FF:005820', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118140, NULL, 'G3DSA:1.20.58.60:FF:000293', NULL, NULL, 'Spectrin, beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(118141, NULL, 'G3DSA:3.30.1330.30:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118142, NULL, 'G3DSA:1.20.58.1780:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118143, NULL, 'G3DSA:2.10.25.10:FF:000565', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(118144, NULL, 'G3DSA:3.30.160.60:FF:003375', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118145, NULL, 'G3DSA:3.90.226.10:FF:000268', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(118146, NULL, 'G3DSA:1.25.40.10:FF:003464', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(118147, NULL, 'G3DSA:1.25.40.20:FF:000999', NULL, NULL, 'Ankyrin repeat domain-containing protein 49', NULL, NULL, NULL, NULL, NULL, 4),
(118148, NULL, 'G3DSA:3.40.50.800:FF:000024', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(118149, NULL, 'G3DSA:3.40.50.2020:FF:000001', NULL, NULL, 'Ribose-phosphate pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(118150, NULL, 'G3DSA:3.40.50.150:FF:000969', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118151, NULL, 'G3DSA:3.30.160.60:FF:005224', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118152, NULL, 'G3DSA:2.10.25.10:FF:000273', NULL, NULL, 'Putative latent-transforming growth factor beta-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(118153, NULL, 'G3DSA:3.90.550.60:FF:000002', NULL, NULL, 'Galactofuranosyl transferase GlfT1', NULL, NULL, NULL, NULL, NULL, 4),
(118154, NULL, 'G3DSA:3.90.1720.10:FF:000005', NULL, NULL, 'Amidase', NULL, NULL, NULL, NULL, NULL, 4),
(118155, NULL, 'G3DSA:2.60.120.260:FF:000273', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(118156, NULL, 'G3DSA:1.25.40.10:FF:000996', NULL, NULL, 'Small kernel1', NULL, NULL, NULL, NULL, NULL, 4),
(118157, NULL, 'G3DSA:3.20.20.190:FF:000108', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118158, NULL, 'G3DSA:2.60.40.10:FF:001508', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(118159, NULL, 'G3DSA:1.10.630.10:FF:000441', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118160, NULL, 'G3DSA:3.30.2020.30:FF:000011', NULL, NULL, 'Trimethyllysine hydroxylase, epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(118161, NULL, 'G3DSA:3.40.50.11900:FF:000002', NULL, NULL, '(R)-2-hydroxyisocaproyl-CoA dehydratase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(118162, NULL, 'G3DSA:1.10.40.30:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118163, NULL, 'G3DSA:3.40.50.410:FF:000356', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118164, NULL, 'G3DSA:3.40.50.620:FF:000189', NULL, NULL, 'Probable nicotinate-nucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(118165, NULL, 'G3DSA:2.40.50.140:FF:000852', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118166, NULL, 'G3DSA:1.10.10.10:FF:000988', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(118167, NULL, 'G3DSA:2.40.50.140:FF:000498', NULL, NULL, 'sn-glycerol-3-phosphate ABC transporter ATP-binding protein UgpC', NULL, NULL, NULL, NULL, NULL, 4),
(118168, NULL, 'G3DSA:3.90.1150.210:FF:000009', NULL, NULL, 'F-actin-capping protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(118169, NULL, 'G3DSA:3.40.50.2300:FF:001164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118170, NULL, 'G3DSA:3.20.20.100:FF:000094', NULL, NULL, 'AGAP012038-PA', NULL, NULL, NULL, NULL, NULL, 4),
(118171, NULL, 'G3DSA:3.30.470.20:FF:000087', NULL, NULL, 'Inositol-tetrakisphosphate 1-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(118172, NULL, 'G3DSA:3.30.200.20:FF:001225', NULL, NULL, 'Pim-1 proto-oncogene, serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(118173, NULL, 'G3DSA:1.20.120.900:FF:000008', NULL, NULL, 'Putative peroxisomal biogenesis factor 19', NULL, NULL, NULL, NULL, NULL, 4),
(118174, NULL, 'G3DSA:3.40.50.300:FF:005820', NULL, NULL, 'Hydin, axonemal central pair apparatus protein', NULL, NULL, NULL, NULL, NULL, 4),
(118175, NULL, 'G3DSA:3.40.50.720:FF:001787', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118176, NULL, 'G3DSA:2.130.10.10:FF:001666', NULL, NULL, 'Vegetative incompatibility WD repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(118177, NULL, 'G3DSA:3.90.660.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118178, NULL, 'G3DSA:3.60.40.10:FF:000040', NULL, NULL, 'Protein serine/threonine phosphatase 2C', NULL, NULL, NULL, NULL, NULL, 4),
(118179, NULL, 'G3DSA:2.60.120.260:FF:000559', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118180, NULL, 'G3DSA:3.50.50.60:FF:000639', NULL, NULL, 'Glucose-methanol-choline oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(118181, NULL, 'G3DSA:3.30.40.10:FF:000923', NULL, NULL, 'FI06144p', NULL, NULL, NULL, NULL, NULL, 4),
(118182, NULL, 'G3DSA:4.10.240.10:FF:000045', NULL, NULL, 'Stb5p', NULL, NULL, NULL, NULL, NULL, 4),
(118183, NULL, 'G3DSA:3.40.50.2300:FF:000372', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(118184, NULL, 'G3DSA:2.40.50.140:FF:000526', NULL, NULL, 'Exoribonuclease 2', NULL, NULL, NULL, NULL, NULL, 4),
(118185, NULL, 'G3DSA:2.60.40.10:FF:005550', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118186, NULL, 'G3DSA:1.25.40.1040:FF:000033', NULL, NULL, 'N(alpha)-acetyltransferase 15, NatA auxiliary subunit', NULL, NULL, NULL, NULL, NULL, 4),
(118187, NULL, 'G3DSA:1.25.40.1030:FF:000030', NULL, NULL, 'Protein transport protein SEC31', NULL, NULL, NULL, NULL, NULL, 4),
(118188, NULL, 'G3DSA:2.60.40.420:FF:000025', NULL, NULL, 'FET5p Multicopper oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(118189, NULL, 'G3DSA:3.40.50.10190:FF:000202', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(118190, NULL, 'G3DSA:3.30.2010.10:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118191, NULL, 'G3DSA:3.80.10.10:FF:000609', NULL, NULL, 'Tsukushi, small leucine rich proteoglycan', NULL, NULL, NULL, NULL, NULL, 4),
(118192, NULL, 'G3DSA:1.20.1560.10:FF:000870', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118193, NULL, 'G3DSA:3.90.1310.10:FF:000036', NULL, NULL, 'Peptidoglycan D,D-transpeptidase FtsI', NULL, NULL, NULL, NULL, NULL, 4),
(118194, NULL, 'G3DSA:3.40.50.1460:FF:000024', NULL, NULL, 'Caspase 21', NULL, NULL, NULL, NULL, NULL, 4),
(118195, NULL, 'G3DSA:1.25.10.10:FF:002759', NULL, NULL, 'AP-3 complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(118196, NULL, 'G3DSA:1.10.630.10:FF:000053', NULL, NULL, 'Cytochrome P450 benzoate 4-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(118197, NULL, 'G3DSA:3.40.50.2030:FF:000004', NULL, NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(118198, NULL, 'G3DSA:3.30.70.330:FF:000698', NULL, NULL, '33 kDa ribonucleoprotein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(118199, NULL, 'G3DSA:3.30.230.10:FF:000409', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(118200, NULL, 'G3DSA:3.40.850.10:FF:000044', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(118201, NULL, 'G3DSA:3.40.710.10:FF:000146', NULL, NULL, 'Penicillin-binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(118202, NULL, 'G3DSA:3.30.50.10:FF:000137', NULL, NULL, 'GR', NULL, NULL, NULL, NULL, NULL, 4),
(118203, NULL, 'G3DSA:1.10.150.20:FF:000249', NULL, NULL, 'DNA-directed RNA polymerase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(118204, NULL, 'G3DSA:1.25.40.10:FF:003604', NULL, NULL, 'YALI0B12408p', NULL, NULL, NULL, NULL, NULL, 4),
(118205, NULL, 'G3DSA:1.20.140.10:FF:000075', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(118206, NULL, 'G3DSA:2.30.29.30:FF:001017', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(118207, NULL, 'G3DSA:3.40.50.410:FF:000126', NULL, NULL, 'Voltage-dependent calcium channel subunit alpha-2/delta-1', NULL, NULL, NULL, NULL, NULL, 4),
(118208, NULL, 'G3DSA:3.40.50.720:FF:001062', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(118209, NULL, 'G3DSA:1.25.40.20:FF:001281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(118210, NULL, 'G3DSA:2.60.40.10:FF:003504', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118211, NULL, 'G3DSA:2.130.10.10:FF:003515', NULL, NULL, 'Elongator complex protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(118212, NULL, 'G3DSA:3.90.70.10:FF:000124', NULL, NULL, 'ubiquitin carboxyl-terminal hydrolase 26', NULL, NULL, NULL, NULL, NULL, 4),
(118213, NULL, 'G3DSA:1.20.1560.10:FF:000426', NULL, NULL, 'ATP-binding cassette permease', NULL, NULL, NULL, NULL, NULL, 4),
(118214, NULL, 'G3DSA:2.60.40.10:FF:002987', NULL, NULL, 'GG16886', NULL, NULL, NULL, NULL, NULL, 4),
(118215, NULL, 'G3DSA:3.30.930.10:FF:000423', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(118216, NULL, 'G3DSA:3.30.420.10:FF:000098', NULL, NULL, 'Polynucleotidyl transferase ribonuclease H-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(118217, NULL, 'G3DSA:2.20.25.10:FF:000132', NULL, NULL, 'DNA-directed RNA polymerase II 15.1 kDa polypeptide-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(118218, NULL, 'G3DSA:3.90.550.50:FF:000078', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(118219, NULL, 'G3DSA:3.40.50.300:FF:002009', NULL, NULL, 'Ribosome biogenesis GTPase A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(118220, NULL, 'G3DSA:1.20.1250.20:FF:002069', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(118221, NULL, 'G3DSA:3.80.10.10:FF:003887', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(118222, NULL, 'G3DSA:3.40.50.2300:FF:000607', NULL, NULL, 'Sensory box sensor histidine kinase/response regulator VieS', NULL, NULL, NULL, NULL, NULL, 4),
(118223, NULL, 'G3DSA:3.40.50.720:FF:000505', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(118224, NULL, 'G3DSA:3.30.160.60:FF:001576', NULL, NULL, 'HKR1, GLI-Kruppel zinc finger family member', NULL, NULL, NULL, NULL, NULL, 4),
(118225, NULL, 'G3DSA:3.80.10.10:FF:002459', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118226, NULL, 'G3DSA:2.60.210.10:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118227, NULL, 'G3DSA:2.130.10.10:FF:000874', NULL, NULL, 'U3 small nucleolar RNA-associated protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(118228, NULL, 'G3DSA:1.10.10.60:FF:000863', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118229, NULL, 'G3DSA:2.40.50.140:FF:001015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118230, NULL, 'G3DSA:1.25.40.180:FF:000284', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118231, NULL, 'G3DSA:1.20.1070.10:FF:000670', NULL, NULL, 'Orexin receptor type 1', NULL, NULL, NULL, NULL, NULL, 4),
(118232, NULL, 'G3DSA:1.25.40.10:FF:001126', NULL, NULL, 'Daf-16-Dependent Longevity (WT but not daf-16 lifespan increased)', NULL, NULL, NULL, NULL, NULL, 4),
(118233, NULL, 'G3DSA:1.20.1070.10:FF:001928', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118234, NULL, 'G3DSA:3.40.190.10:FF:000920', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(118235, NULL, 'G3DSA:3.30.420.10:FF:000340', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(118236, NULL, 'G3DSA:1.10.274.100:FF:000019', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(118237, NULL, 'G3DSA:1.20.58.1030:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118238, NULL, 'G3DSA:3.40.50.10490:FF:000056', NULL, NULL, 'Ribosomal protein S2', NULL, NULL, NULL, NULL, NULL, 4),
(118239, NULL, 'G3DSA:3.40.50.1820:FF:000278', NULL, NULL, 'Esterase LipF', NULL, NULL, NULL, NULL, NULL, 4),
(118240, NULL, 'G3DSA:1.10.1030.10:FF:000006', NULL, NULL, 'Carbamoyl-phosphate synthase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(118241, NULL, 'G3DSA:3.10.20.230:FF:000005', NULL, NULL, 'Doublecortin domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(118242, NULL, 'G3DSA:2.60.120.290:FF:000023', NULL, NULL, 'Multiple epidermal growth factor-like domains 8', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(118243, NULL, 'G3DSA:3.90.640.10:FF:000073', NULL, NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(118244, NULL, 'G3DSA:3.30.160.60:FF:005550', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118245, NULL, 'G3DSA:2.10.25.10:FF:000891', NULL, NULL, 'Calcium binding EGF domain containing protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(118246, NULL, 'G3DSA:3.40.50.300:FF:001672', NULL, NULL, 'Multidrug ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(118247, NULL, 'G3DSA:2.60.120.970:FF:000013', NULL, NULL, 'Bone morphogenetic protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(118248, NULL, 'G3DSA:1.10.8.20:FF:000007', NULL, NULL, 'Sec14p-like phosphatidylinositol transfer family protein', NULL, NULL, NULL, NULL, NULL, 4),
(118249, NULL, 'G3DSA:1.20.5.930:FF:000001', NULL, NULL, 'Integrin subunit alpha V', NULL, NULL, NULL, NULL, NULL, 4),
(118250, NULL, 'G3DSA:3.40.50.300:FF:004134', NULL, NULL, 'GM21411', NULL, NULL, NULL, NULL, NULL, 4),
(118251, NULL, 'G3DSA:1.10.510.10:FF:001803', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(118252, NULL, 'G3DSA:3.30.465.10:FF:000033', NULL, NULL, 'L-gulonolactone oxidase 5', NULL, NULL, NULL, NULL, NULL, 4),
(118253, NULL, 'G3DSA:1.10.10.10:FF:000781', NULL, NULL, 'Meiotic recombination protein spo11', NULL, NULL, NULL, NULL, NULL, 4),
(118254, NULL, 'G3DSA:2.40.128.20:FF:000013', NULL, NULL, 'OsWRKY4 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(118255, NULL, 'G3DSA:1.10.150.910:FF:000008', NULL, NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(118256, NULL, 'G3DSA:1.10.287.610:FF:000002', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(118257, NULL, 'G3DSA:1.20.1560.10:FF:000252', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(118258, NULL, 'G3DSA:3.60.10.10:FF:000212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118259, NULL, 'G3DSA:1.20.120.1320:FF:000006', NULL, NULL, 'Aspartate kinase /homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(118260, NULL, 'G3DSA:2.30.30.140:FF:000165', NULL, NULL, 'Tudor, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(118261, NULL, 'G3DSA:1.20.120.160:FF:000011', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(118262, NULL, 'G3DSA:2.40.420.20:FF:000029', NULL, NULL, 'Efflux transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(118263, NULL, 'G3DSA:3.50.50.60:FF:001303', NULL, NULL, 'Mercuric reductase', NULL, NULL, NULL, NULL, NULL, 4),
(118264, NULL, 'G3DSA:1.10.510.10:FF:003214', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118265, NULL, 'G3DSA:2.60.40.10:FF:002936', NULL, NULL, 'DLEC1, cilia and flagella associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(118266, NULL, 'G3DSA:3.50.50.60:FF:001516', NULL, NULL, 'D-amino acid dehydrogenase, small chain', NULL, NULL, NULL, NULL, NULL, 4),
(118267, NULL, 'G3DSA:3.80.10.10:FF:002734', NULL, NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At2g02780', NULL, NULL, NULL, NULL, NULL, 4),
(118268, NULL, 'G3DSA:1.25.10.10:FF:002113', NULL, NULL, 'Formin-3', NULL, NULL, NULL, NULL, NULL, 4),
(118269, NULL, 'G3DSA:1.25.40.10:FF:005049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118270, NULL, 'G3DSA:3.90.228.10:FF:000042', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(118271, NULL, 'G3DSA:3.10.20.410:FF:000003', NULL, NULL, 'Fimbrial outer membrane usher protein', NULL, NULL, NULL, NULL, NULL, 4),
(118272, NULL, 'G3DSA:1.10.150.900:FF:000005', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(118273, NULL, 'G3DSA:1.10.510.10:FF:001680', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(118274, NULL, 'G3DSA:2.30.30.100:FF:000086', NULL, NULL, 'SNRPF isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(118275, NULL, 'G3DSA:3.80.10.10:FF:003836', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(118276, NULL, 'G3DSA:2.60.40.10:FF:003212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118277, NULL, 'G3DSA:3.90.1800.10:FF:000006', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(118278, NULL, 'G3DSA:2.70.160.11:FF:000023', NULL, NULL, 'Protein arginine methyltransferase 9', NULL, NULL, NULL, NULL, NULL, 4),
(118279, NULL, 'G3DSA:3.40.30.10:FF:000051', NULL, NULL, 'endoplasmic reticulum resident protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(118280, NULL, 'G3DSA:3.30.70.2850:FF:000022', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(118281, NULL, 'G3DSA:1.10.287.570:FF:000001', NULL, NULL, 'Anion exchange protein', NULL, NULL, NULL, NULL, NULL, 4),
(118282, NULL, 'G3DSA:3.30.260.10:FF:000063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118283, NULL, 'G3DSA:3.40.50.10190:FF:000253', NULL, NULL, 'YALI0B15576p', NULL, NULL, NULL, NULL, NULL, 4),
(118284, NULL, 'G3DSA:3.30.9.10:FF:000070', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(118285, NULL, 'G3DSA:2.20.100.10:FF:000108', NULL, NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif, 13', NULL, NULL, NULL, NULL, NULL, 4),
(118286, NULL, 'G3DSA:1.10.565.10:FF:000081', NULL, NULL, 'Nuclear receptor', NULL, NULL, NULL, NULL, NULL, 4),
(118287, NULL, 'G3DSA:3.90.190.10:FF:000611', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118288, NULL, 'G3DSA:1.25.10.10:FF:001624', NULL, NULL, 'Wings apart-like protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(118289, NULL, 'G3DSA:3.90.1150.10:FF:000473', NULL, NULL, 'Putative L-allo-threonine aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(118290, NULL, 'G3DSA:3.40.50.300:FF:000211', NULL, NULL, 'Elongation factor 1-alpha', NULL, NULL, NULL, NULL, NULL, 4),
(118291, NULL, 'G3DSA:1.10.150.170:FF:000005', NULL, NULL, 'Probable methyltransferase-like protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(118292, NULL, 'G3DSA:3.55.50.10:FF:000002', NULL, NULL, 'Late control gene D protein', NULL, NULL, NULL, NULL, NULL, 4),
(118293, NULL, 'G3DSA:1.20.1070.10:FF:001979', NULL, NULL, 'G protein-coupled receptor 33', NULL, NULL, NULL, NULL, NULL, 4),
(118294, NULL, 'G3DSA:2.60.120.290:FF:000074', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(118295, NULL, 'G3DSA:3.90.830.10:FF:000014', NULL, NULL, 'Syntaxin binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(118296, NULL, 'G3DSA:1.10.510.10:FF:003832', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118297, NULL, 'G3DSA:1.25.40.10:FF:004892', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118298, NULL, 'G3DSA:3.40.250.10:FF:000015', NULL, NULL, 'Sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(118299, NULL, 'G3DSA:1.25.10.10:FF:003215', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(118300, NULL, 'G3DSA:1.50.40.10:FF:000432', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118301, NULL, 'G3DSA:2.60.40.10:FF:003425', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118302, NULL, 'G3DSA:3.90.1410.10:FF:000021', NULL, NULL, 'SET_domain_containing_protein', NULL, NULL, NULL, NULL, NULL, 4),
(118303, NULL, 'G3DSA:1.25.40.10:FF:001401', NULL, NULL, 'General transcription factor 3C polypeptide 3 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(118304, NULL, 'G3DSA:3.20.20.80:FF:000662', NULL, NULL, 'Glucosylceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(118305, NULL, 'G3DSA:1.25.40.10:FF:002587', NULL, NULL, 'Os12g0490100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(118306, NULL, 'G3DSA:3.80.10.10:FF:002173', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(118307, NULL, 'G3DSA:3.40.50.300:FF:001493', NULL, NULL, 'Mitochondrial ATPase (Afg1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(118308, NULL, 'G3DSA:2.20.70.30:FF:000006', NULL, NULL, 'Nascent polypeptide-associated complex alpha subunit Egd2', NULL, NULL, NULL, NULL, NULL, 4),
(118309, NULL, 'G3DSA:3.40.50.1000:FF:000881', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(118310, NULL, 'G3DSA:3.20.20.140:FF:000026', NULL, NULL, 'D-phenylhydantoinase', NULL, NULL, NULL, NULL, NULL, 4),
(118311, NULL, 'G3DSA:3.40.50.300:FF:001397', NULL, NULL, 'Primosomal protein N''', NULL, NULL, NULL, NULL, NULL, 4),
(118312, NULL, 'G3DSA:3.40.50.720:FF:000831', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(118313, NULL, 'G3DSA:1.10.110.10:FF:000025', NULL, NULL, 'At4g12360', NULL, NULL, NULL, NULL, NULL, 4),
(118314, NULL, 'G3DSA:3.40.50.1910:FF:000030', NULL, NULL, 'Syntaxin-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(118315, NULL, 'G3DSA:1.20.5.170:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118316, NULL, 'G3DSA:1.10.472.80:FF:000043', NULL, NULL, 'Pollux, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(118317, NULL, 'G3DSA:1.20.1250.20:FF:000271', NULL, NULL, 'Monocarboxylate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(118318, NULL, 'G3DSA:2.60.120.340:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118319, NULL, 'G3DSA:2.60.40.60:FF:000040', NULL, NULL, 'cadherin EGF LAG seven-pass G-type receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(118320, NULL, 'G3DSA:3.40.1110.10:FF:000111', NULL, NULL, 'Phospholipid-transporting ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(118321, NULL, 'G3DSA:3.40.50.2300:FF:000933', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118322, NULL, 'G3DSA:1.10.510.10:FF:003427', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118323, NULL, 'G3DSA:3.40.5.10:FF:000016', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(118324, NULL, 'G3DSA:2.60.40.10:FF:003830', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118325, NULL, 'G3DSA:2.80.10.50:FF:000141', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(118326, NULL, 'G3DSA:1.10.510.10:FF:002938', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118327, NULL, 'G3DSA:3.30.50.10:FF:000188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118328, NULL, 'G3DSA:3.30.40.10:FF:002109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118329, NULL, 'G3DSA:1.10.510.10:FF:001062', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(118330, NULL, 'G3DSA:2.30.42.10:FF:000486', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118331, NULL, 'G3DSA:3.60.40.10:FF:000326', NULL, NULL, 'Os12g0198200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(118332, NULL, 'G3DSA:3.50.50.60:FF:000409', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(118333, NULL, 'G3DSA:2.30.30.490:FF:000039', NULL, NULL, 'Histone-lysine N-methyltransferase ash1', NULL, NULL, NULL, NULL, NULL, 4),
(118334, NULL, 'G3DSA:3.30.1240.10:FF:000050', NULL, NULL, 'HAD-superfamily hydrolase, subfamily IIB', NULL, NULL, NULL, NULL, NULL, 4),
(118335, NULL, 'G3DSA:2.60.120.330:FF:000024', NULL, NULL, 'Probable 2-oxoglutarate-dependent dioxygenase At3g49630', NULL, NULL, NULL, NULL, NULL, 4),
(118336, NULL, 'G3DSA:3.60.20.10:FF:000038', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(118337, NULL, 'G3DSA:3.30.160.60:FF:001834', NULL, NULL, 'Zinc finger protein 836', NULL, NULL, NULL, NULL, NULL, 4),
(118338, NULL, 'G3DSA:3.30.310.80:FF:000037', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(118339, NULL, 'G3DSA:1.20.90.10:FF:000009', NULL, NULL, 'Otoconin-90', NULL, NULL, NULL, NULL, NULL, 4),
(118340, NULL, 'G3DSA:1.25.10.10:FF:001006', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(118341, NULL, 'G3DSA:3.90.80.10:FF:000001', NULL, NULL, 'Inorganic pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(118342, NULL, 'G3DSA:2.30.40.10:FF:000032', NULL, NULL, 'Imidazolonepropionase', NULL, NULL, NULL, NULL, NULL, 4),
(118343, NULL, 'G3DSA:1.10.238.10:FF:000765', NULL, NULL, 'Lysophospholipid acyltransferase LPEAT2', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(118344, NULL, 'G3DSA:1.20.190.50:FF:000011', NULL, NULL, 'Nuclear pore complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(118345, NULL, 'G3DSA:2.40.420.20:FF:000030', NULL, NULL, 'RND family efflux transporter, MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(118346, NULL, 'G3DSA:2.90.10.30:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118347, NULL, 'G3DSA:2.30.140.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118348, NULL, 'G3DSA:3.40.50.1400:FF:000028', NULL, NULL, 'Ferrochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(118349, NULL, 'G3DSA:3.30.1370.10:FF:000048', NULL, NULL, 'RNA-binding protein PNO1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(118350, NULL, 'G3DSA:3.40.720.10:FF:000214', NULL, NULL, 'Choline-sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(118351, NULL, 'G3DSA:1.25.40.10:FF:001160', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(118352, NULL, 'G3DSA:1.25.40.20:FF:001163', NULL, NULL, 'Glycerophosphocholine phosphodiesterase Gde1, putative (AFU_orthologue AFUA_5G11590)', NULL, NULL, NULL, NULL, NULL, 4),
(118353, NULL, 'G3DSA:3.40.50.300:FF:007703', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(118354, NULL, 'G3DSA:3.80.10.10:FF:004084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118355, NULL, 'G3DSA:2.40.50.90:FF:000157', NULL, NULL, 'Blr1266 protein', NULL, NULL, NULL, NULL, NULL, 4),
(118356, NULL, 'G3DSA:3.40.120.10:FF:000011', NULL, NULL, 'Alpha-D-glucose phosphate-specific phosphoglucomutase', NULL, NULL, NULL, NULL, NULL, 4),
(118357, NULL, 'G3DSA:1.20.1560.10:FF:000218', NULL, NULL, 'Putative ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(118358, NULL, 'G3DSA:3.40.50.300:FF:001228', NULL, NULL, 'GTP-binding nuclear protein', NULL, NULL, NULL, NULL, NULL, 4),
(118359, NULL, 'G3DSA:3.30.470.20:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118360, NULL, 'G3DSA:1.10.3200.20:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118361, NULL, 'G3DSA:1.20.1560.10:FF:000701', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(118362, NULL, 'G3DSA:3.30.1330.30:FF:000001', NULL, NULL, '60S ribosomal protein L30', NULL, NULL, NULL, NULL, NULL, 4),
(118363, NULL, 'G3DSA:2.60.40.420:FF:000233', NULL, NULL, 'Periplasmic cell division protein (SufI)', NULL, NULL, NULL, NULL, NULL, 4),
(118364, NULL, 'G3DSA:3.80.10.10:FF:002526', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118365, NULL, 'G3DSA:1.20.1440.100:FF:000011', NULL, NULL, 'HAD-IB family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(118366, NULL, 'G3DSA:1.20.1070.10:FF:000669', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118367, NULL, 'G3DSA:1.25.10.10:FF:003198', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(118368, NULL, 'G3DSA:3.30.450.20:FF:000221', NULL, NULL, 'Sensor kinase CitA', NULL, NULL, NULL, NULL, NULL, 4),
(118369, NULL, 'G3DSA:3.40.50.300:FF:007057', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(118370, NULL, 'G3DSA:1.25.10.10:FF:001124', NULL, NULL, 'Protein CBG09895', NULL, NULL, NULL, NULL, NULL, 4),
(118371, NULL, 'G3DSA:1.20.1090.10:FF:000053', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(118372, NULL, 'G3DSA:1.25.40.10:FF:003290', NULL, NULL, 'Vacuolar protein sorting-associated protein 41 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(118373, NULL, 'G3DSA:1.10.1040.10:FF:000063', NULL, NULL, 'D-mannonate oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(118374, NULL, 'G3DSA:1.10.510.10:FF:001303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118375, NULL, 'G3DSA:1.20.1070.10:FF:002182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118376, NULL, 'G3DSA:3.40.1180.10:FF:000008', NULL, NULL, 'NUS1, dehydrodolichyl diphosphate synthase subunit', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(118377, NULL, 'G3DSA:3.40.50.300:FF:003319', NULL, NULL, 'Dephospho-CoA kinase', NULL, NULL, NULL, NULL, NULL, 4),
(118378, NULL, 'G3DSA:3.10.350.10:FF:000086', NULL, NULL, 'Lytic transglycosylase, SLT, LysM and LysM domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(118379, NULL, 'G3DSA:1.10.510.10:FF:003540', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118380, NULL, 'G3DSA:3.40.1260.10:FF:000009', NULL, NULL, 'Sulfur relay protein DsrH', NULL, NULL, NULL, NULL, NULL, 4),
(118381, NULL, 'G3DSA:3.10.50.40:FF:000023', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(118382, NULL, 'G3DSA:2.30.39.10:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118383, NULL, 'G3DSA:3.40.50.1820:FF:001121', NULL, NULL, 'Lipase family member K', NULL, NULL, NULL, NULL, NULL, 4),
(118384, NULL, 'G3DSA:1.10.472.10:FF:000679', NULL, NULL, 'Meiotically up-regulated gene 80 protein', NULL, NULL, NULL, NULL, NULL, 4),
(118385, NULL, 'G3DSA:1.10.340.70:FF:000037', NULL, NULL, 'Transposon Tf2-6 polyprotein-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(118386, NULL, 'G3DSA:3.40.630.30:FF:000134', NULL, NULL, 'Probable acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(118387, NULL, 'G3DSA:1.25.40.10:FF:003251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118388, NULL, 'G3DSA:3.40.50.410:FF:000244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118389, NULL, 'G3DSA:3.20.20.70:FF:000327', NULL, NULL, 'At4g21320p-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(118390, NULL, 'G3DSA:3.10.20.90:FF:000103', NULL, NULL, 'Merlin isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(118391, NULL, 'G3DSA:3.30.780.10:FF:000068', NULL, NULL, 'Protein translation factor SUI1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(118392, NULL, 'G3DSA:2.60.120.200:FF:000620', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(118393, NULL, 'G3DSA:1.10.555.10:FF:000136', NULL, NULL, 'T-cell activation GTPase activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(118394, NULL, 'G3DSA:2.60.120.260:FF:000481', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118395, NULL, 'G3DSA:2.60.40.10:FF:003419', NULL, NULL, 'Tyrosine-protein kinase receptor cam-1', NULL, NULL, NULL, NULL, NULL, 4),
(118396, NULL, 'G3DSA:1.10.10.10:FF:001118', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(118397, NULL, 'G3DSA:1.25.10.10:FF:003423', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118398, NULL, 'G3DSA:3.30.1490.80:FF:000027', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(118399, NULL, 'G3DSA:2.60.200.40:FF:000048', NULL, NULL, 'Ceramide kinase-like isoform 31', NULL, NULL, NULL, NULL, NULL, 4),
(118400, NULL, 'G3DSA:1.20.990.10:FF:000032', NULL, NULL, 'GD19100', NULL, NULL, NULL, NULL, NULL, 4),
(118401, NULL, 'G3DSA:1.25.40.10:FF:001047', NULL, NULL, 'Chlororespiratory reduction 4', NULL, NULL, NULL, NULL, NULL, 4),
(118402, NULL, 'G3DSA:2.10.70.10:FF:000074', NULL, NULL, 'CUB and Sushi multiple domains 3', NULL, NULL, NULL, NULL, NULL, 4),
(118403, NULL, 'G3DSA:1.10.150.50:FF:000230', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(118404, NULL, 'G3DSA:3.40.950.10:FF:000023', NULL, NULL, 'Iron hydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(118405, NULL, 'G3DSA:6.10.140.2220:FF:000007', NULL, NULL, 'Zinc finger MYND domain-containing protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(118406, NULL, 'G3DSA:2.70.160.11:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118407, NULL, 'G3DSA:1.50.10.10:FF:000043', NULL, NULL, 'Family 65 glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(118408, NULL, 'G3DSA:2.60.220.50:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118409, NULL, 'G3DSA:3.30.160.60:FF:001508', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM62', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(118410, NULL, 'G3DSA:3.40.50.300:FF:001285', NULL, NULL, 'galactose-3-O-sulfotransferase 3', NULL, NULL, NULL, NULL, NULL, 4),
(118411, NULL, 'G3DSA:3.60.21.10:FF:000063', NULL, NULL, 'Calcineurin-like phosphoesterase domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(118412, NULL, 'G3DSA:3.20.20.140:FF:000234', NULL, NULL, 'AMP deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(118413, NULL, 'G3DSA:3.50.30.80:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118414, NULL, 'G3DSA:2.10.109.10:FF:000068', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(118415, NULL, 'G3DSA:3.40.190.10:FF:000577', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(118416, NULL, 'G3DSA:6.10.140.2220:FF:000064', NULL, NULL, 'GM03859p', NULL, NULL, NULL, NULL, NULL, 4),
(118417, NULL, 'G3DSA:3.20.20.80:FF:000656', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118418, NULL, 'G3DSA:3.40.50.1110:FF:000003', NULL, NULL, 'GDSL esterase/lipase APG', NULL, NULL, NULL, NULL, NULL, 4),
(118419, NULL, 'G3DSA:3.40.50.1820:FF:000654', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(118420, NULL, 'G3DSA:2.40.50.120:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118421, NULL, 'G3DSA:3.30.710.10:FF:000137', NULL, NULL, 'Keap1, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(118422, NULL, 'G3DSA:2.30.30.490:FF:000073', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(118423, NULL, 'G3DSA:3.40.220.10:FF:000013', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(118424, NULL, 'G3DSA:1.10.150.170:FF:000011', NULL, NULL, 'S-adenosyl-methyltransferase mraW-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(118425, NULL, 'G3DSA:3.30.9.10:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118426, NULL, 'G3DSA:2.60.120.330:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118427, NULL, 'G3DSA:1.50.10.160:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118428, NULL, 'G3DSA:2.130.10.10:FF:003291', NULL, NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', NULL, NULL, NULL, NULL, NULL, 4),
(118429, NULL, 'G3DSA:2.60.40.10:FF:003476', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118430, NULL, 'G3DSA:3.20.20.140:FF:000077', NULL, NULL, 'putative deoxyribonuclease TATDN1 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(118431, NULL, 'G3DSA:2.30.42.10:FF:000598', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118432, NULL, 'G3DSA:1.10.3370.10:FF:000015', NULL, NULL, 'Accessory Sec system protein translocase subunit SecY2', NULL, NULL, NULL, NULL, NULL, 4),
(118433, NULL, 'G3DSA:3.90.25.10:FF:000048', NULL, NULL, 'Novel protein similar to bacterial GDP-mannose 4,6-dehydratases', NULL, NULL, NULL, NULL, NULL, 4),
(118434, NULL, 'G3DSA:1.25.10.10:FF:003462', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118435, NULL, 'G3DSA:3.40.140.10:FF:000012', NULL, NULL, 'nuclear protein localization protein 4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(118436, NULL, 'G3DSA:1.25.40.10:FF:003138', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(118437, NULL, 'G3DSA:2.60.120.200:FF:000570', NULL, NULL, 'Sex hormone-binding globulin', NULL, NULL, NULL, NULL, NULL, 4),
(118438, NULL, 'G3DSA:3.30.1240.10:FF:000016', NULL, NULL, 'Cof-type HAD-IIB family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(118439, NULL, 'G3DSA:2.40.50.140:FF:000291', NULL, NULL, 'mRNA-capping enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(118440, NULL, 'G3DSA:3.90.1150.10:FF:000147', NULL, NULL, 'Aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(118441, NULL, 'G3DSA:3.80.10.10:FF:000453', NULL, NULL, 'Leucine-rich receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(118442, NULL, 'G3DSA:2.30.30.550:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(118443, NULL, 'G3DSA:1.50.10.10:FF:000138', NULL, NULL, 'N-acylglucosamine 2-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(118444, NULL, 'G3DSA:4.10.280.10:FF:000216', NULL, NULL, 'BHLH transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(118445, NULL, 'G3DSA:1.25.40.180:FF:000104', NULL, NULL, 'Nonsense-mediated mRNA decay protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(118446, NULL, 'G3DSA:1.10.8.60:FF:000154', NULL, NULL, 'Heat shock protein 101', NULL, NULL, NULL, NULL, NULL, 4),
(118447, NULL, 'G3DSA:3.30.300.130:FF:000017', NULL, NULL, 'Iron-sulfur cluster carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(118448, NULL, 'G3DSA:1.25.40.180:FF:000216', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118449, NULL, 'G3DSA:3.40.50.300:FF:002122', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(118450, NULL, 'G3DSA:2.20.100.10:FF:000029', NULL, NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif, 6', NULL, NULL, NULL, NULL, NULL, 4),
(118451, NULL, 'G3DSA:3.40.50.10330:FF:000115', NULL, NULL, 'NAD kinase b', NULL, NULL, NULL, NULL, NULL, 4),
(118452, NULL, 'G3DSA:3.40.50.150:FF:001037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118453, NULL, 'G3DSA:3.20.20.20:FF:000037', NULL, NULL, '6-hydroxymethyl-7,8-dihydropterin pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(118454, NULL, 'G3DSA:1.10.238.10:FF:000973', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118455, NULL, 'G3DSA:3.30.160.60:FF:006298', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118456, NULL, 'G3DSA:3.40.1190.20:FF:000214', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118457, NULL, 'G3DSA:3.40.50.10380:FF:000023', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(118458, NULL, 'G3DSA:1.20.900.10:FF:000038', NULL, NULL, 'Myosin-M heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(118459, NULL, 'G3DSA:2.130.10.30:FF:000071', NULL, NULL, 'Claret, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(118460, NULL, 'G3DSA:2.130.10.10:FF:005314', NULL, NULL, 'WD repeat-containing protein 16-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(118461, NULL, 'G3DSA:2.70.160.11:FF:000017', NULL, NULL, 'Protein arginine N-methyltransferase 1.6', NULL, NULL, NULL, NULL, NULL, 4),
(118462, NULL, 'G3DSA:3.80.10.10:FF:000610', NULL, NULL, 'Plant intracellular Ras-group-related LRR protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(118463, NULL, 'G3DSA:3.40.640.10:FF:000438', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118464, NULL, 'G3DSA:1.20.1280.50:FF:000141', NULL, NULL, 'F-box only protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(118465, NULL, 'G3DSA:3.50.50.60:FF:000735', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(118466, NULL, 'G3DSA:1.25.10.10:FF:001332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118467, NULL, 'G3DSA:3.40.850.10:FF:000095', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(118468, NULL, 'G3DSA:1.25.40.610:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118469, NULL, 'G3DSA:2.40.70.10:FF:000449', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118470, NULL, 'G3DSA:3.40.30.10:FF:000225', NULL, NULL, 'Thioredoxin-like protein AAED1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(118471, NULL, 'G3DSA:2.60.40.10:FF:003751', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118472, NULL, 'G3DSA:2.170.120.40:FF:000015', NULL, NULL, 'YbbR family protein', NULL, NULL, NULL, NULL, NULL, 4),
(118473, NULL, 'G3DSA:3.10.350.10:FF:000029', NULL, NULL, 'Membrane-bound lytic murein transglycosylase D', NULL, NULL, NULL, NULL, NULL, 4),
(118474, NULL, 'G3DSA:1.20.1250.20:FF:002283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118475, NULL, 'G3DSA:1.10.510.10:FF:001511', NULL, NULL, 'Serine/threonine-protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(118476, NULL, 'G3DSA:2.60.40.10:FF:005342', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(118477, NULL, 'G3DSA:1.20.1270.60:FF:000036', NULL, NULL, 'Arf-GAP with SH3 domain, ANK repeat and PH domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(118478, NULL, 'G3DSA:1.20.5.110:FF:000250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118479, NULL, 'G3DSA:1.20.58.1120:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118480, NULL, 'G3DSA:2.60.120.920:FF:000105', NULL, NULL, 'Protein CBG15934', NULL, NULL, NULL, NULL, NULL, 4),
(118481, NULL, 'G3DSA:3.30.300.110:FF:000011', NULL, NULL, 'tRNA(Phe) (4-demethylwyosine(37)-C(7)) aminocarboxypropyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(118482, NULL, 'G3DSA:3.30.67.10:FF:000001', NULL, NULL, 'Envelope glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(118483, NULL, 'G3DSA:1.25.40.470:FF:000034', NULL, NULL, 'Coatomer alpha subunit putative', NULL, NULL, NULL, NULL, NULL, 4),
(118484, NULL, 'G3DSA:4.10.240.10:FF:000096', NULL, NULL, 'C6 transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(118485, NULL, 'G3DSA:1.10.20.140:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118486, NULL, 'G3DSA:1.20.58.80:FF:000040', NULL, NULL, 'MIT domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(118487, NULL, 'G3DSA:1.10.630.10:FF:000261', NULL, NULL, 'Cytochrome P450 52E1', NULL, NULL, NULL, NULL, NULL, 4),
(118488, NULL, 'G3DSA:2.60.40.10:FF:002487', NULL, NULL, 'Immunoglobulin heavy variable 13-2', NULL, NULL, NULL, NULL, NULL, 4),
(118489, NULL, 'G3DSA:1.25.40.10:FF:003930', NULL, NULL, 'Coatomer subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(118490, NULL, 'G3DSA:1.20.58.90:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118491, NULL, 'G3DSA:3.40.20.10:FF:000045', NULL, NULL, 'Actin binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(118492, NULL, 'G3DSA:3.40.50.720:FF:001579', NULL, NULL, 'Uncharacterized oxidoreductase SPBC1348.09', NULL, NULL, NULL, NULL, NULL, 4),
(118493, NULL, 'G3DSA:3.30.200.20:FF:001113', NULL, NULL, 'Serine/threonine-protein kinase D1044.8', NULL, NULL, NULL, NULL, NULL, 4),
(118494, NULL, 'G3DSA:3.40.50.2000:FF:000787', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118495, NULL, 'G3DSA:3.40.850.10:FF:000038', NULL, NULL, 'chromosome-associated kinesin KIF4A', NULL, NULL, NULL, NULL, NULL, 4),
(118496, NULL, 'G3DSA:3.30.2090.10:FF:000015', NULL, NULL, 'Resistance-Nodulation-cell Division (RND) efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(118497, NULL, 'G3DSA:2.30.30.100:FF:000018', NULL, NULL, 'Small nuclear ribonucleoprotein Sm D2', NULL, NULL, NULL, NULL, NULL, 4),
(118498, NULL, 'G3DSA:3.50.50.60:FF:000640', NULL, NULL, 'Probable polyamine oxidase 5', NULL, NULL, NULL, NULL, NULL, 4),
(118499, NULL, 'G3DSA:2.130.10.10:FF:001048', NULL, NULL, 'BnaA09g40460D protein', NULL, NULL, NULL, NULL, NULL, 4),
(118500, NULL, 'G3DSA:2.60.40.1180:FF:000003', NULL, NULL, '1,4-alpha-glucan-branching enzyme, chloroplastic/amyloplastic', NULL, NULL, NULL, NULL, NULL, 4),
(118501, NULL, 'G3DSA:1.25.10.10:FF:002647', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(118502, NULL, 'G3DSA:1.20.1250.20:FF:000563', NULL, NULL, 'Proton-dependent Oligopeptide Transporter (POT) Family', NULL, NULL, NULL, NULL, NULL, 4),
(118503, NULL, 'G3DSA:3.40.50.410:FF:000064', NULL, NULL, 'RNA polymerase II transcription factor B subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(118504, NULL, 'G3DSA:3.30.70.330:FF:001423', NULL, NULL, 'Feminization Of Germline', NULL, NULL, NULL, NULL, NULL, 4),
(118505, NULL, 'G3DSA:3.10.580.10:FF:000131', NULL, NULL, 'CBS domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(118506, NULL, 'G3DSA:3.10.129.10:FF:000184', NULL, NULL, 'Acyl-ACP thioesterase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(118507, NULL, 'G3DSA:3.30.980.10:FF:000016', NULL, NULL, 'Threonine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(118508, NULL, 'G3DSA:4.10.70.30:FF:000002', NULL, NULL, 'Disintegrin and metalloproteinase domain-containing protein 17', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(118509, NULL, 'G3DSA:3.50.50.60:FF:000847', NULL, NULL, 'Electron-transferring-flavoprotein dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(118510, NULL, 'G3DSA:1.25.40.10:FF:004386', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118511, NULL, 'G3DSA:1.20.1070.10:FF:000405', NULL, NULL, 'G-protein coupled receptor GRL101 precursor-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(118512, NULL, 'G3DSA:3.30.40.10:FF:000715', NULL, NULL, 'E3 ubiquitin-protein ligase RING1', NULL, NULL, NULL, NULL, NULL, 4),
(118513, NULL, 'G3DSA:1.20.1250.20:FF:000506', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(118514, NULL, 'G3DSA:1.10.1050.10:FF:000002', NULL, NULL, '30S ribosomal protein S4, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(118515, NULL, 'G3DSA:3.30.1010.10:FF:000027', NULL, NULL, 'Atypical/PI4K protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(118516, NULL, 'G3DSA:4.10.60.10:FF:000086', NULL, NULL, 'ATP-dependent DNA helicase Q4', NULL, NULL, NULL, NULL, NULL, 4),
(118517, NULL, 'G3DSA:3.80.10.10:FF:003302', NULL, NULL, 'NLR family member X1', NULL, NULL, NULL, NULL, NULL, 4),
(118518, NULL, 'G3DSA:3.30.160.60:FF:001784', NULL, NULL, 'Zinc finger protein 768', NULL, NULL, NULL, NULL, NULL, 4),
(118519, NULL, 'G3DSA:3.30.9.100:FF:000003', NULL, NULL, 'Probable alkylhalidase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(118520, NULL, 'G3DSA:1.10.10.60:FF:001094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118521, NULL, 'G3DSA:2.60.120.620:FF:000010', NULL, NULL, 'Prolyl 3-hydroxylase OGFOD1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(118522, NULL, 'G3DSA:3.40.50.720:FF:001270', NULL, NULL, 'ApbA-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(118523, NULL, 'G3DSA:3.40.140.10:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118524, NULL, 'G3DSA:1.20.1280.170:FF:000005', NULL, NULL, 'Exocyst complex component 7', NULL, NULL, NULL, NULL, NULL, 4),
(118525, NULL, 'G3DSA:2.120.10.80:FF:000378', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118526, NULL, 'G3DSA:1.50.40.10:FF:000140', NULL, NULL, 'Mitochondriale tricarboxylate carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(118527, NULL, 'G3DSA:3.40.630.30:FF:000213', NULL, NULL, 'GNAT family N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(118528, NULL, 'G3DSA:1.20.1250.10:FF:000037', NULL, NULL, 'Prolactin', NULL, NULL, NULL, NULL, NULL, 4),
(118529, NULL, 'G3DSA:3.40.850.10:FF:000252', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(118530, NULL, 'G3DSA:3.40.50.300:FF:003471', NULL, NULL, 'GG17442', NULL, NULL, NULL, NULL, NULL, 4),
(118531, NULL, 'G3DSA:3.30.160.60:FF:005106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118532, NULL, 'G3DSA:2.130.10.30:FF:000149', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118533, NULL, 'G3DSA:3.30.1490.20:FF:000037', NULL, NULL, 'D-alanine-D-alanine ligase family', NULL, NULL, NULL, NULL, NULL, 4),
(118534, NULL, 'G3DSA:2.130.10.10:FF:003139', NULL, NULL, 'Tomosyn-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(118535, NULL, 'G3DSA:4.10.900.10:FF:000012', NULL, NULL, 'Putative DE-cadherin', NULL, NULL, NULL, NULL, NULL, 4),
(118536, NULL, 'G3DSA:3.40.50.300:FF:003196', NULL, NULL, 'UvrABC system protein A', NULL, NULL, NULL, NULL, NULL, 4),
(118537, NULL, 'G3DSA:1.20.1270.60:FF:000093', NULL, NULL, 'Rho GTPase-activating protein 92B', NULL, NULL, NULL, NULL, NULL, 4),
(118538, NULL, 'G3DSA:3.30.470.10:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118539, NULL, 'G3DSA:1.20.1070.10:FF:000462', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(118540, NULL, 'G3DSA:3.30.200.20:FF:000618', NULL, NULL, 'Serine/threonine-protein kinase CTR1', NULL, NULL, NULL, NULL, NULL, 4),
(118541, NULL, 'G3DSA:3.10.450.50:FF:000083', NULL, NULL, 'YALI0F00638p', NULL, NULL, NULL, NULL, NULL, 4),
(118542, NULL, 'G3DSA:2.10.50.10:FF:000140', NULL, NULL, 'TNF receptor superfamily member 10c', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(118543, NULL, 'G3DSA:3.30.160.60:FF:005174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118544, NULL, 'G3DSA:3.30.70.330:FF:001069', NULL, NULL, 'Eukaryotic translation initiation factor 4H', NULL, NULL, NULL, NULL, NULL, 4),
(118545, NULL, 'G3DSA:1.25.40.10:FF:001570', NULL, NULL, 'Tetratricopeptide-like helical', NULL, NULL, NULL, NULL, NULL, 4),
(118546, NULL, 'G3DSA:2.60.40.10:FF:000896', NULL, NULL, 'kin of IRRE-like protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(118547, NULL, 'G3DSA:1.20.5.170:FF:000077', NULL, NULL, 'LAO/AO transport system kinase', NULL, NULL, NULL, NULL, NULL, 4),
(118548, NULL, 'G3DSA:3.40.50.1820:FF:001110', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(118549, NULL, 'G3DSA:2.20.100.10:FF:000142', NULL, NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 13', NULL, NULL, NULL, NULL, NULL, 4),
(118550, NULL, 'G3DSA:3.60.130.10:FF:000018', NULL, NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(118551, NULL, 'G3DSA:3.30.710.10:FF:000148', NULL, NULL, 'Ribbon', NULL, NULL, NULL, NULL, NULL, 4),
(118552, NULL, 'G3DSA:1.25.40.20:FF:001573', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118553, NULL, 'G3DSA:3.40.33.10:FF:000142', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(118554, NULL, 'G3DSA:3.40.50.300:FF:001880', NULL, NULL, 'Structural maintenance of chromosomes protein', NULL, NULL, NULL, NULL, NULL, 4),
(118555, NULL, 'G3DSA:1.10.260.40:FF:000056', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(118556, NULL, 'G3DSA:3.30.40.10:FF:001530', NULL, NULL, 'Putative E3 ubiquitin-protein ligase UBR7', NULL, NULL, NULL, NULL, NULL, 4),
(118557, NULL, 'G3DSA:1.25.10.10:FF:003187', NULL, NULL, 'Valyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(118558, NULL, 'G3DSA:3.80.10.10:FF:004494', NULL, NULL, 'Leucine-rich repeat receptor-like tyrosine-protein kinase PXC3', NULL, NULL, NULL, NULL, NULL, 4),
(118559, NULL, 'G3DSA:1.20.1540.10:FF:000043', NULL, NULL, 'Rhomboid family protease GlpG', NULL, NULL, NULL, NULL, NULL, 4),
(118560, NULL, 'G3DSA:3.20.20.80:FF:000218', NULL, NULL, 'Chitinase domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(118561, NULL, 'G3DSA:3.30.930.10:FF:000131', NULL, NULL, 'Proline--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(118562, NULL, 'G3DSA:3.10.50.40:FF:000012', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(118563, NULL, 'G3DSA:1.10.1060.10:FF:000008', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase, anaerobic, C subunit', NULL, NULL, NULL, NULL, NULL, 4),
(118564, NULL, 'G3DSA:3.40.850.10:FF:000370', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(118565, NULL, 'G3DSA:3.60.40.10:FF:000270', NULL, NULL, 'Stp1/IreP family PP2C-type Ser/Thr phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(118566, NULL, 'G3DSA:2.20.50.20:FF:000002', NULL, NULL, 'Vitellogenin', NULL, NULL, NULL, NULL, NULL, 4),
(118567, NULL, 'G3DSA:3.20.20.70:FF:000215', NULL, NULL, 'Dihydroorotate dehydrogenase A (fumarate)', NULL, NULL, NULL, NULL, NULL, 4),
(118568, NULL, 'G3DSA:2.60.60.20:FF:000001', NULL, NULL, 'DENN domain containing 5B', NULL, NULL, NULL, NULL, NULL, 4),
(118569, NULL, 'G3DSA:1.10.510.10:FF:001180', NULL, NULL, 'Cdc2-related kinase 8', NULL, NULL, NULL, NULL, NULL, 4),
(118570, NULL, 'G3DSA:1.10.1370.10:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118571, NULL, 'G3DSA:2.60.40.10:FF:005842', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118572, NULL, 'G3DSA:3.30.160.60:FF:005516', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118573, NULL, 'G3DSA:2.40.40.20:FF:000006', NULL, NULL, 'vesicle-fusing ATPase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(118574, NULL, 'G3DSA:2.30.29.30:FF:000854', NULL, NULL, 'Insulin receptor substrate 1-A', NULL, NULL, NULL, NULL, NULL, 4),
(118575, NULL, 'G3DSA:2.60.40.10:FF:001413', NULL, NULL, 'Vasorin', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(118576, NULL, 'G3DSA:3.40.50.10330:FF:000104', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(118577, NULL, 'G3DSA:3.40.250.10:FF:000127', NULL, NULL, 'Sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(118578, NULL, 'G3DSA:3.30.160.60:FF:001284', NULL, NULL, 'Zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(118579, NULL, 'G3DSA:3.30.1360.40:FF:000039', NULL, NULL, 'Arginine repressor', NULL, NULL, NULL, NULL, NULL, 4),
(118580, NULL, 'G3DSA:2.60.120.200:FF:000502', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(118581, NULL, 'G3DSA:2.60.60.30:FF:000004', NULL, NULL, 'Tellurium resistance protein TerA', NULL, NULL, NULL, NULL, NULL, 4),
(118582, NULL, 'G3DSA:3.50.50.60:FF:001067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118583, NULL, 'G3DSA:3.10.290.10:FF:000030', NULL, NULL, 'RNA pseudouridylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(118584, NULL, 'G3DSA:1.10.510.10:FF:003720', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118585, NULL, 'G3DSA:1.20.5.500:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118586, NULL, 'G3DSA:1.20.1250.20:FF:000771', NULL, NULL, 'Blast:UNC93-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(118587, NULL, 'G3DSA:3.30.70.330:FF:002761', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118588, NULL, 'G3DSA:3.90.810.10:FF:000013', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(118589, NULL, 'G3DSA:1.20.1070.10:FF:000905', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118590, NULL, 'G3DSA:2.40.40.10:FF:000003', NULL, NULL, 'Endolytic peptidoglycan transglycosylase RlpA', NULL, NULL, NULL, NULL, NULL, 4),
(118591, NULL, 'G3DSA:3.30.70.330:FF:002497', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118592, NULL, 'G3DSA:3.20.20.140:FF:000291', NULL, NULL, 'Probable histidinol-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(118593, NULL, 'G3DSA:1.25.40.20:FF:001516', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118594, NULL, 'G3DSA:1.25.40.10:FF:001513', NULL, NULL, 'OSJNBa0060P14.4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(118595, NULL, 'G3DSA:3.40.50.720:FF:000455', NULL, NULL, 'Putative mitochondrial saccharopine dehydrogenase-like oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(118596, NULL, 'G3DSA:3.30.365.10:FF:000031', NULL, NULL, 'Xanthine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(118597, NULL, 'G3DSA:2.60.40.10:FF:003487', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118598, NULL, 'G3DSA:1.10.472.80:FF:000155', NULL, NULL, 'Putative rab-like GTPase activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(118599, NULL, 'G3DSA:3.30.60.30:FF:000121', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(118600, NULL, 'G3DSA:1.20.1280.270:FF:000002', NULL, NULL, 'bifunctional arginine demethylase and lysyl-hydroxylase JMJD6 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(118601, NULL, 'G3DSA:3.40.50.11000:FF:000002', NULL, NULL, 'Fe-S cluster assembly protein DRE2', NULL, NULL, NULL, NULL, NULL, 4),
(118602, NULL, 'G3DSA:3.40.50.300:FF:007911', NULL, NULL, 'Cytochrome P450 71A26', NULL, NULL, NULL, NULL, NULL, 4),
(118603, NULL, 'G3DSA:1.25.40.10:FF:002795', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118604, NULL, 'G3DSA:1.10.600.10:FF:000113', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(118605, NULL, 'G3DSA:1.20.5.470:FF:000009', NULL, NULL, 'Argininosuccinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(118606, NULL, 'G3DSA:3.40.50.150:FF:000874', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118607, NULL, 'G3DSA:3.40.190.80:FF:000042', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(118608, NULL, 'G3DSA:1.10.10.10:FF:001039', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(118609, NULL, 'G3DSA:1.25.40.10:FF:003312', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(118610, NULL, 'G3DSA:3.30.465.10:FF:000128', NULL, NULL, 'Glycolate oxidase subunit glcE', NULL, NULL, NULL, NULL, NULL, 4),
(118611, NULL, 'G3DSA:2.60.40.10:FF:004847', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118612, NULL, 'G3DSA:3.60.40.10:FF:000118', NULL, NULL, 'Phosphatase 2C-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(118613, NULL, 'G3DSA:1.25.40.10:FF:002475', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g01030, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(118614, NULL, 'G3DSA:1.25.40.610:FF:000003', NULL, NULL, 'adhesion G protein-coupled receptor L3', NULL, NULL, NULL, NULL, NULL, 4),
(118615, NULL, 'G3DSA:2.30.30.140:FF:000070', NULL, NULL, 'Scm like with four mbt domains 2', NULL, NULL, NULL, NULL, NULL, 4),
(118616, NULL, 'G3DSA:2.130.10.10:FF:003280', NULL, NULL, 'Cilia- and flagella-associated protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(118617, NULL, 'G3DSA:2.60.40.10:FF:002695', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(118618, NULL, 'G3DSA:1.20.58.760:FF:000006', NULL, NULL, 'ATP-dependent zinc metalloprotease FTSH 7, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(118619, NULL, 'G3DSA:2.40.50.90:FF:000078', NULL, NULL, 'Nuclease homologue', NULL, NULL, NULL, NULL, NULL, 4),
(118620, NULL, 'G3DSA:3.40.50.10190:FF:000135', NULL, NULL, 'DNA topoisomerase II-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(118621, NULL, 'G3DSA:3.30.450.20:FF:000428', NULL, NULL, 'Sensor histidine kinase, PAS, PAS and PAS domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(118622, NULL, 'G3DSA:1.20.1740.10:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118623, NULL, 'G3DSA:3.90.320.10:FF:000026', NULL, NULL, 'ATP-dependent DNA helicase Dna2', NULL, NULL, NULL, NULL, NULL, 4),
(118624, NULL, 'G3DSA:1.20.1420.10:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118625, NULL, 'G3DSA:2.130.10.10:FF:005432', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118626, NULL, 'G3DSA:3.40.50.150:FF:001537', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118627, NULL, 'G3DSA:2.60.40.650:FF:000010', NULL, NULL, 'Nitrate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(118628, NULL, 'G3DSA:3.10.290.70:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118629, NULL, 'G3DSA:3.40.630.10:FF:000387', NULL, NULL, 'Peptidase M20 domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(118630, NULL, 'G3DSA:3.20.20.190:FF:000013', NULL, NULL, 'Glycerophosphodiester phosphodiesterase GDPDL3', NULL, NULL, NULL, NULL, NULL, 4),
(118631, NULL, 'G3DSA:4.10.400.10:FF:000108', NULL, NULL, 'Low-density lipoprotein receptor-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(118632, NULL, 'G3DSA:1.10.530.10:FF:000051', NULL, NULL, 'Lytic transglycosylase, SLT, LysM and LysM domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(118633, NULL, 'G3DSA:1.20.920.10:FF:000101', NULL, NULL, 'GM23532', NULL, NULL, NULL, NULL, NULL, 4),
(118634, NULL, 'G3DSA:2.102.10.10:FF:000010', NULL, NULL, 'Ubiquinol-cytochrome c reductase iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4),
(118635, NULL, 'G3DSA:1.25.40.20:FF:000145', NULL, NULL, 'NF-kappa-B inhibitor-like protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(118636, NULL, 'G3DSA:1.25.10.10:FF:001742', NULL, NULL, 'Pdr6p', NULL, NULL, NULL, NULL, NULL, 4),
(118637, NULL, 'G3DSA:3.40.630.30:FF:000191', NULL, NULL, 'Hydrolase, NUDIX family protein', NULL, NULL, NULL, NULL, NULL, 4),
(118638, NULL, 'G3DSA:3.30.1490.80:FF:000038', NULL, NULL, 'Glutathione synthetase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(118639, NULL, 'G3DSA:2.30.30.90:FF:000010', NULL, NULL, 'Iron-dependent repressor IdeR/DtxR', NULL, NULL, NULL, NULL, NULL, 4),
(118640, NULL, 'G3DSA:1.20.1250.20:FF:002362', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(118641, NULL, 'G3DSA:3.40.50.720:FF:002394', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(118642, NULL, 'G3DSA:1.10.8.10:FF:000122', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(118643, NULL, 'G3DSA:3.40.50.450:FF:000110', NULL, NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase LOG7', NULL, NULL, NULL, NULL, NULL, 4),
(118644, NULL, 'G3DSA:3.90.215.10:FF:000006', NULL, NULL, 'Fibrinogen beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(118645, NULL, 'G3DSA:1.10.630.10:FF:000148', NULL, NULL, 'Os05g0515200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(118646, NULL, 'G3DSA:1.10.260.100:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118647, NULL, 'G3DSA:1.20.1070.10:FF:001400', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118648, NULL, 'G3DSA:2.130.10.10:FF:002908', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118649, NULL, 'G3DSA:3.30.499.10:FF:000015', NULL, NULL, 'Aconitate hydratase 1', NULL, NULL, NULL, NULL, NULL, 4),
(118650, NULL, 'G3DSA:1.10.630.10:FF:000502', NULL, NULL, 'Obtusifoliol 14-alpha demethylase', NULL, NULL, NULL, NULL, NULL, 4),
(118651, NULL, 'G3DSA:1.10.510.10:FF:003927', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118652, NULL, 'G3DSA:1.20.58.1800:FF:000002', NULL, NULL, 'Trehalose-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(118653, NULL, 'G3DSA:3.60.10.10:FF:000324', NULL, NULL, 'Fgr14p', NULL, NULL, NULL, NULL, NULL, 4),
(118654, NULL, 'G3DSA:3.40.50.300:FF:007068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118655, NULL, 'G3DSA:3.30.70.1730:FF:000023', NULL, NULL, '50S ribosomal protein L10', NULL, NULL, NULL, NULL, NULL, 4),
(118656, NULL, 'G3DSA:1.20.1560.10:FF:000370', NULL, NULL, 'Novel protein similar to human transporter 2, ATP-binding cassette, sub-family B (MDR/TAP2)', NULL, NULL, NULL, NULL, NULL, 4),
(118657, NULL, 'G3DSA:1.20.5.110:FF:000109', NULL, NULL, 'Vesicle-associated membrane protein 722', NULL, NULL, NULL, NULL, NULL, 4),
(118658, NULL, 'G3DSA:3.30.460.10:FF:000044', NULL, NULL, 'ATPase synthesis protein 25, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(118659, NULL, 'G3DSA:2.40.37.10:FF:000041', NULL, NULL, 'Alanine racemase', NULL, NULL, NULL, NULL, NULL, 4),
(118660, NULL, 'G3DSA:2.30.29.170:FF:000008', NULL, NULL, 'EF-hand domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(118661, NULL, 'G3DSA:1.10.510.10:FF:004203', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118662, NULL, 'G3DSA:2.60.120.10:FF:000229', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(118663, NULL, 'G3DSA:1.20.5.460:FF:000006', NULL, NULL, 'Malate/L-lactate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(118664, NULL, 'G3DSA:1.10.287.70:FF:000424', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(118665, NULL, 'G3DSA:1.25.40.10:FF:001901', NULL, NULL, 'GM26497', NULL, NULL, NULL, NULL, NULL, 4),
(118666, NULL, 'G3DSA:1.20.1250.20:FF:000153', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(118667, NULL, 'G3DSA:3.30.160.60:FF:002301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118668, NULL, 'G3DSA:2.130.10.10:FF:003128', NULL, NULL, 'Protein CBG19705', NULL, NULL, NULL, NULL, NULL, 4),
(118669, NULL, 'G3DSA:3.30.200.20:FF:000950', NULL, NULL, 'Os09g0559900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(118670, NULL, 'G3DSA:3.30.559.10:FF:000184', NULL, NULL, 'Brassinosteroid-related acyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(118671, NULL, 'G3DSA:1.10.840.10:FF:000041', NULL, NULL, 'Cyclic GMP-binding protein C', NULL, NULL, NULL, NULL, NULL, 4),
(118672, NULL, 'G3DSA:1.20.58.60:FF:000843', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118673, NULL, 'G3DSA:3.100.10.10:FF:000028', NULL, NULL, 'LSU ribosomal protein L18E', NULL, NULL, NULL, NULL, NULL, 4),
(118674, NULL, 'G3DSA:3.40.50.300:FF:008485', NULL, NULL, 'Putative multidrug resistance-associated protein lethal(2)03659-like Protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(118675, NULL, 'G3DSA:3.40.50.1820:FF:000216', NULL, NULL, 'Alpha/beta-Hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(118676, NULL, 'G3DSA:3.30.590.10:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118677, NULL, 'G3DSA:1.10.287.130:FF:000004', NULL, NULL, 'Ethylene receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(118678, NULL, 'G3DSA:3.90.660.10:FF:000074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118679, NULL, 'G3DSA:3.10.590.10:FF:000013', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(118680, NULL, 'G3DSA:1.20.58.930:FF:000001', NULL, NULL, 'Biosynthetic arginine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(118681, NULL, 'G3DSA:2.60.120.290:FF:000141', NULL, NULL, 'GD12774', NULL, NULL, NULL, NULL, NULL, 4),
(118682, NULL, 'G3DSA:3.10.20.90:FF:000160', NULL, NULL, 'Polyubiquitin-C', NULL, NULL, NULL, NULL, NULL, 4),
(118683, NULL, 'G3DSA:1.25.40.20:FF:001904', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118684, NULL, 'G3DSA:3.20.20.370:FF:000011', NULL, NULL, 'Carbohydrate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(118685, NULL, 'G3DSA:3.30.413.10:FF:000014', NULL, NULL, 'Sulfite reductase [ferredoxin], chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(118686, NULL, 'G3DSA:6.10.250.3360:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118687, NULL, 'G3DSA:3.40.50.2000:FF:000349', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(118688, NULL, 'G3DSA:1.25.10.10:FF:002967', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118689, NULL, 'G3DSA:3.30.900.10:FF:000062', NULL, NULL, 'Meiosis-specific protein hop1', NULL, NULL, NULL, NULL, NULL, 4),
(118690, NULL, 'G3DSA:1.10.8.60:FF:000507', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118691, NULL, 'G3DSA:1.10.10.10:FF:001152', NULL, NULL, 'Bacteriochlorophyllide d C-20 methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(118692, NULL, 'G3DSA:3.10.196.10:FF:000007', NULL, NULL, 'Methionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(118693, NULL, 'G3DSA:2.10.25.10:FF:000065', NULL, NULL, 'Laminin subunit beta 1', NULL, NULL, NULL, NULL, NULL, 4),
(118694, NULL, 'G3DSA:3.40.50.300:FF:006894', NULL, NULL, 'ABC-type sodium efflux system ATPase component NatA', NULL, NULL, NULL, NULL, NULL, 4),
(118695, NULL, 'G3DSA:3.30.160.60:FF:003925', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118696, NULL, 'G3DSA:3.40.50.720:FF:002517', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(118697, NULL, 'G3DSA:3.60.130.10:FF:000075', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(118698, NULL, 'G3DSA:3.20.20.140:FF:000313', NULL, NULL, 'Amidohydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(118699, NULL, 'G3DSA:2.60.40.10:FF:006005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118700, NULL, 'G3DSA:1.20.1250.20:FF:002305', NULL, NULL, 'Permeases of the major facilitator superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(118701, NULL, 'G3DSA:3.30.190.10:FF:000001', NULL, NULL, 'Ribulose bisphosphate carboxylase small chain, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(118702, NULL, 'G3DSA:2.40.50.140:FF:000791', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118703, NULL, 'G3DSA:3.50.50.60:FF:000527', NULL, NULL, 'Long-chain-alcohol oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(118704, NULL, 'G3DSA:3.90.190.10:FF:000111', NULL, NULL, 'Putative phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(118705, NULL, 'G3DSA:1.10.10.10:FF:000876', NULL, NULL, 'Response regulator protein TodT', NULL, NULL, NULL, NULL, NULL, 4),
(118706, NULL, 'G3DSA:2.60.40.10:FF:003712', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118707, NULL, 'G3DSA:1.10.510.10:FF:003309', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118708, NULL, 'G3DSA:1.10.1760.20:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118709, NULL, 'G3DSA:2.60.120.200:FF:000277', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(118710, NULL, 'G3DSA:1.10.510.10:FF:003366', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118711, NULL, 'G3DSA:1.20.5.170:FF:000190', NULL, NULL, 'Cyclic AMP-responsive element-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(118712, NULL, 'G3DSA:3.30.40.10:FF:000636', NULL, NULL, 'Protein CBG17014', NULL, NULL, NULL, NULL, NULL, 4),
(118713, NULL, 'G3DSA:1.20.120.450:FF:000002', NULL, NULL, 'Maleylpyruvate isomerase family mycothiol-dependent enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(118714, NULL, 'G3DSA:2.130.10.10:FF:003403', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118715, NULL, 'G3DSA:2.60.40.10:FF:001059', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(118716, NULL, 'G3DSA:2.40.160.30:FF:000001', NULL, NULL, 'oxygen-evolving enhancer protein 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(118717, NULL, 'G3DSA:3.40.710.10:FF:000034', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(118718, NULL, 'G3DSA:1.10.510.10:FF:001741', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118719, NULL, 'G3DSA:3.80.10.10:FF:004264', NULL, NULL, 'Protein-lysine N-methyltransferase EFM4', NULL, NULL, NULL, NULL, NULL, 4),
(118720, NULL, 'G3DSA:3.40.50.300:FF:003460', NULL, NULL, 'Putative ribosome biogenesis GTPase RsgA', NULL, NULL, NULL, NULL, NULL, 4),
(118721, NULL, 'G3DSA:2.10.25.10:FF:000683', NULL, NULL, 'Blast:Protein eyes shut', NULL, NULL, NULL, NULL, NULL, 4),
(118722, NULL, 'G3DSA:3.30.70.1820:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118723, NULL, 'G3DSA:1.25.10.10:FF:000848', NULL, NULL, 'Epoxyqueuosine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(118724, NULL, 'G3DSA:3.30.70.260:FF:000087', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(118725, NULL, 'G3DSA:3.30.70.360:FF:000061', NULL, NULL, 'Peptidase M20', NULL, NULL, NULL, NULL, NULL, 4),
(118726, NULL, 'G3DSA:3.40.605.10:FF:000014', NULL, NULL, 'aldehyde dehydrogenase 22A1', NULL, NULL, NULL, NULL, NULL, 4),
(118727, NULL, 'G3DSA:1.10.10.10:FF:001713', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(118728, NULL, 'G3DSA:1.10.10.10:FF:001770', NULL, NULL, 'ORC1-type DNA replication protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(118729, NULL, 'G3DSA:3.40.50.300:FF:005612', NULL, NULL, 'YALI0D15246p', NULL, NULL, NULL, NULL, NULL, 4),
(118730, NULL, 'G3DSA:1.20.58.400:FF:000016', NULL, NULL, 'GD13885', NULL, NULL, NULL, NULL, NULL, 4),
(118731, NULL, 'G3DSA:2.60.120.590:FF:000074', NULL, NULL, 'Os06g0286310 protein', NULL, NULL, NULL, NULL, NULL, 4),
(118732, NULL, 'G3DSA:3.30.160.20:FF:000064', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(118733, NULL, 'G3DSA:3.80.10.10:FF:004207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118734, NULL, 'G3DSA:1.25.40.10:FF:005167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118735, NULL, 'G3DSA:3.50.50.60:FF:001421', NULL, NULL, 'Rab proteins geranylgeranyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(118736, NULL, 'G3DSA:3.20.20.70:FF:000035', NULL, NULL, 'Putative N-acetylmannosamine-6-phosphate 2-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(118737, NULL, 'G3DSA:2.10.25.10:FF:000801', NULL, NULL, 'Notch homolog 2 N-terminal-like protein C', NULL, NULL, NULL, NULL, NULL, 4),
(118738, NULL, 'G3DSA:1.20.1740.10:FF:000081', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(118739, NULL, 'G3DSA:3.20.20.80:FF:000038', NULL, NULL, '1,3-beta-glucanosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(118740, NULL, 'G3DSA:3.90.380.10:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118741, NULL, 'G3DSA:3.40.50.300:FF:007349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118742, NULL, 'G3DSA:2.30.42.10:FF:000424', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118743, NULL, 'G3DSA:3.30.160.60:FF:003257', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(118744, NULL, 'G3DSA:3.80.10.10:FF:000048', NULL, NULL, 'BDNF/NT-3 growth factors receptor', NULL, NULL, NULL, NULL, NULL, 4),
(118745, NULL, 'G3DSA:2.60.40.10:FF:001626', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(118746, NULL, 'G3DSA:1.25.40.370:FF:000009', NULL, NULL, 'Apaf-1/CED-4-related caspase activator Dapaf-1S', NULL, NULL, NULL, NULL, NULL, 4),
(118747, NULL, 'G3DSA:1.20.1640.10:FF:000022', NULL, NULL, 'Dispatched RND transporter family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(118748, NULL, 'G3DSA:3.40.50.1910:FF:000029', NULL, NULL, 'Sec1 family domain-containing protein MIP3', NULL, NULL, NULL, NULL, NULL, 4),
(118749, NULL, 'G3DSA:2.130.10.10:FF:000992', NULL, NULL, 'WD repeat-containing protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(118750, NULL, 'G3DSA:1.25.40.10:FF:003582', NULL, NULL, 'histone demethylase UTY', NULL, NULL, NULL, NULL, NULL, 4),
(118751, NULL, 'G3DSA:3.30.160.60:FF:006005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118752, NULL, 'G3DSA:1.20.1250.20:FF:002249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118753, NULL, 'G3DSA:3.30.160.60:FF:003313', NULL, NULL, 'transcription factor grauzone isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(118754, NULL, 'G3DSA:2.30.29.30:FF:000287', NULL, NULL, 'TBC1 domain family member 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(118755, NULL, 'G3DSA:1.20.120.1220:FF:000010', NULL, NULL, 'Putative type 4 prepilin-like proteins leader peptide-processing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(118756, NULL, 'G3DSA:3.30.930.10:FF:000013', NULL, NULL, 'Aspartate--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(118757, NULL, 'G3DSA:3.40.190.10:FF:000919', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118758, NULL, 'G3DSA:1.10.150.650:FF:000003', NULL, NULL, 'Php domain n-terminal region:php domain c-terminal region', NULL, NULL, NULL, NULL, NULL, 4),
(118759, NULL, 'G3DSA:3.40.33.10:FF:000030', NULL, NULL, 'Cysteine-rich secretory protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(118760, NULL, 'G3DSA:3.40.630.10:FF:000269', NULL, NULL, 'Uncharacterized protein YqgT', NULL, NULL, NULL, NULL, NULL, 4),
(118761, NULL, 'G3DSA:3.40.50.150:FF:001655', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118762, NULL, 'G3DSA:2.60.40.10:FF:003717', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118763, NULL, 'G3DSA:3.30.230.70:FF:000096', NULL, NULL, 'YALI0E06039p', NULL, NULL, NULL, NULL, NULL, 4),
(118764, NULL, 'G3DSA:3.60.40.10:FF:000039', NULL, NULL, 'Stage II sporulation protein E', NULL, NULL, NULL, NULL, NULL, 4),
(118765, NULL, 'G3DSA:3.30.70.141:FF:000007', NULL, NULL, 'Protein XRP2', NULL, NULL, NULL, NULL, NULL, 4),
(118766, NULL, 'G3DSA:3.10.450.240:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118767, NULL, 'G3DSA:3.80.10.10:FF:004382', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118768, NULL, 'G3DSA:2.40.240.10:FF:000046', NULL, NULL, 'Glutaminyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(118769, NULL, 'G3DSA:3.40.309.10:FF:000096', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(118770, NULL, 'G3DSA:3.40.50.300:FF:005270', NULL, NULL, 'Gluconokinase', NULL, NULL, NULL, NULL, NULL, 4),
(118771, NULL, 'G3DSA:2.130.10.10:FF:001604', NULL, NULL, 'WD domain, G-beta repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(118772, NULL, 'G3DSA:3.30.70.330:FF:000288', NULL, NULL, 'Splicing factor 3b subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(118773, NULL, 'G3DSA:3.30.505.10:FF:000008', NULL, NULL, 'SH2B adapter protein 1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(118774, NULL, 'G3DSA:1.20.5.170:FF:000251', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(118775, NULL, 'G3DSA:1.10.10.60:FF:000599', NULL, NULL, 'Two-component system sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(118776, NULL, 'G3DSA:3.90.1150.10:FF:000484', NULL, NULL, 'GH27315p', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(118777, NULL, 'G3DSA:3.40.30.10:FF:001237', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(118778, NULL, 'G3DSA:1.10.150.670:FF:000009', NULL, NULL, 'Methyl methanesulfonate sensitivity 4', NULL, NULL, NULL, NULL, NULL, 4),
(118779, NULL, 'G3DSA:2.130.10.10:FF:000025', NULL, NULL, 'FIZZY-related 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(118780, NULL, 'G3DSA:3.40.20.10:FF:000163', NULL, NULL, 'Twinfilin', NULL, NULL, NULL, NULL, NULL, 4),
(118781, NULL, 'G3DSA:3.40.50.300:FF:003134', NULL, NULL, 'Hypothetical alanine and arginine rich protein', NULL, NULL, NULL, NULL, NULL, 4),
(118782, NULL, 'G3DSA:1.10.565.10:FF:000024', NULL, NULL, 'Nuclear receptor subfamily 1 group I member 2', NULL, NULL, NULL, NULL, NULL, 4),
(118783, NULL, 'G3DSA:3.40.50.720:FF:000893', NULL, NULL, 'Quinone reductase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(118784, NULL, 'G3DSA:3.30.1490.100:FF:000019', NULL, NULL, 'Putative DNA polymerase iota', NULL, NULL, NULL, NULL, NULL, 4),
(118785, NULL, 'G3DSA:3.40.50.2300:FF:001046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118786, NULL, 'G3DSA:1.25.40.120:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118787, NULL, 'G3DSA:1.20.1720.10:FF:000023', NULL, NULL, 'Tetracycline resistance protein TETA(L)/TETK', NULL, NULL, NULL, NULL, NULL, 4),
(118788, NULL, 'G3DSA:1.10.10.500:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118789, NULL, 'G3DSA:3.40.250.10:FF:000009', NULL, NULL, 'tRNA 2-selenouridine/geranyl-2-thiouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(118790, NULL, 'G3DSA:3.30.70.1230:FF:000210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118791, NULL, 'G3DSA:4.10.280.10:FF:000227', NULL, NULL, 'Transcription factor bHLH14', NULL, NULL, NULL, NULL, NULL, 4),
(118792, NULL, 'G3DSA:1.20.58.2220:FF:000010', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(118793, NULL, 'G3DSA:1.25.40.10:FF:001339', NULL, NULL, 'Prolyl 3-hydroxylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(118794, NULL, 'G3DSA:1.20.1250.10:FF:000099', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118795, NULL, 'G3DSA:1.10.238.10:FF:001142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118796, NULL, 'G3DSA:3.40.1410.10:FF:000038', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(118797, NULL, 'G3DSA:3.80.10.10:FF:002139', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(118798, NULL, 'G3DSA:2.40.50.140:FF:000408', NULL, NULL, 'Ribonuclease R', NULL, NULL, NULL, NULL, NULL, 4),
(118799, NULL, 'G3DSA:3.90.190.10:FF:000375', NULL, NULL, 'Paladin', NULL, NULL, NULL, NULL, NULL, 4),
(118800, NULL, 'G3DSA:3.20.190.10:FF:000003', NULL, NULL, 'endonuclease 8-like 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(118801, NULL, 'G3DSA:3.30.300.30:FF:000163', NULL, NULL, 'Hydroxamate-type ferrichrome siderophore peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(118802, NULL, 'G3DSA:1.25.10.10:FF:000899', NULL, NULL, 'Microtubule associated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(118803, NULL, 'G3DSA:3.90.1150.10:FF:000439', NULL, NULL, 'Putative transcriptional regulator, GntR family', NULL, NULL, NULL, NULL, NULL, 4),
(118804, NULL, 'G3DSA:1.10.357.140:FF:000029', NULL, NULL, '1,4-dihydroxy-2-naphthoate prenyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(118805, NULL, 'G3DSA:6.10.250.3310:FF:000003', NULL, NULL, 'Signal transducer and activator of transcription 1', NULL, NULL, NULL, NULL, NULL, 4),
(118806, NULL, 'G3DSA:1.10.565.10:FF:000075', NULL, NULL, 'Retinoic acid receptor', NULL, NULL, NULL, NULL, NULL, 4),
(118807, NULL, 'G3DSA:2.30.29.30:FF:000236', NULL, NULL, 'Unconventional myosin-X', NULL, NULL, NULL, NULL, NULL, 4),
(118808, NULL, 'G3DSA:1.10.10.440:FF:000023', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(118809, NULL, 'G3DSA:2.40.50.770:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(118810, NULL, 'G3DSA:3.30.450.260:FF:000004', NULL, NULL, 'Soluble guanylate cyclase 88E', NULL, NULL, NULL, NULL, NULL, 4),
(118811, NULL, 'G3DSA:3.30.450.250:FF:000001', NULL, NULL, 'Signal transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(118812, NULL, 'G3DSA:3.40.50.1820:FF:000946', NULL, NULL, 'YALI0F16687p', NULL, NULL, NULL, NULL, NULL, 4),
(118813, NULL, 'G3DSA:3.40.50.12230:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118814, NULL, 'G3DSA:3.40.850.10:FF:000538', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118815, NULL, 'G3DSA:1.20.5.170:FF:000195', NULL, NULL, 'Intermediate filament protein ifb-2', NULL, NULL, NULL, NULL, NULL, 4),
(118816, NULL, 'G3DSA:2.60.40.60:FF:001057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118817, NULL, 'G3DSA:1.10.238.10:FF:001086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118818, NULL, 'G3DSA:2.30.29.30:FF:000343', NULL, NULL, 'Calcium-dependent secretion activator', NULL, NULL, NULL, NULL, NULL, 4),
(118819, NULL, 'G3DSA:3.60.21.70:FF:000002', NULL, NULL, 'YGR266W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(118820, NULL, 'G3DSA:3.30.200.20:FF:000793', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(118821, NULL, 'G3DSA:3.30.1360.200:FF:000009', NULL, NULL, 'Bifunctional preprotein translocase subunit SecD/SecF', NULL, NULL, NULL, NULL, NULL, 4),
(118822, NULL, 'G3DSA:3.30.200.20:FF:002187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118823, NULL, 'G3DSA:3.80.10.10:FF:004319', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118824, NULL, 'G3DSA:1.10.8.10:FF:000061', NULL, NULL, 'ubiquitin-associated domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(118825, NULL, 'G3DSA:2.60.120.10:FF:000241', NULL, NULL, 'Cyclic nucleotide-binding domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(118826, NULL, 'G3DSA:1.25.40.20:FF:001494', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118827, NULL, 'G3DSA:1.20.120.1240:FF:000016', NULL, NULL, 'Dynamin GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(118828, NULL, 'G3DSA:3.40.50.300:FF:005258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118829, NULL, 'G3DSA:3.40.50.1820:FF:000839', NULL, NULL, 'Serine carboxypeptidase S28 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(118830, NULL, 'G3DSA:1.25.40.180:FF:000278', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118831, NULL, 'G3DSA:3.40.50.300:FF:003078', NULL, NULL, 'Rho family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(118832, NULL, 'G3DSA:2.130.10.10:FF:001548', NULL, NULL, 'Autophagy-related protein 16 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(118833, NULL, 'G3DSA:1.10.246.80:FF:000001', NULL, NULL, 'CCA-adding enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(118834, NULL, 'G3DSA:2.130.10.10:FF:001329', NULL, NULL, 'Set1 WD40 repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(118835, NULL, 'G3DSA:1.10.10.2770:FF:000003', NULL, NULL, 'Selenocysteine-specific elongation factor', NULL, NULL, NULL, NULL, NULL, 4),
(118836, NULL, 'G3DSA:3.40.50.10420:FF:000024', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(118837, NULL, 'G3DSA:1.25.40.180:FF:000334', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118838, NULL, 'G3DSA:1.25.10.10:FF:001630', NULL, NULL, 'Plakophilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(118839, NULL, 'G3DSA:3.30.450.70:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118840, NULL, 'G3DSA:3.30.310.130:FF:000002', NULL, NULL, 'SUMO specific peptidase 6', NULL, NULL, NULL, NULL, NULL, 4),
(118841, NULL, 'G3DSA:3.40.50.2300:FF:001153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118842, NULL, 'G3DSA:3.30.70.330:FF:000069', NULL, NULL, 'CUGBP Elav-like family member 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(118843, NULL, 'G3DSA:1.10.8.60:FF:000266', NULL, NULL, 'Related to RIX7-AAA-type ATPase required for biogenesis and nuclear export of 60S ribosomal subunits', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(118844, NULL, 'G3DSA:2.40.50.90:FF:000191', NULL, NULL, 'AT14886p', NULL, NULL, NULL, NULL, NULL, 4),
(118845, NULL, 'G3DSA:1.25.40.10:FF:003256', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(118846, NULL, 'G3DSA:2.60.120.590:FF:000012', NULL, NULL, 'AlkB homolog 8, tRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(118847, NULL, 'G3DSA:1.10.8.10:FF:000010', NULL, NULL, 'Putative ubiquitin-conjugating enzyme e2 k', NULL, NULL, NULL, NULL, NULL, 4),
(118848, NULL, 'G3DSA:1.10.10.60:FF:000981', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118849, NULL, 'G3DSA:3.40.390.10:FF:000233', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118850, NULL, 'G3DSA:1.10.220.30:FF:000011', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(118851, NULL, 'G3DSA:2.60.40.150:FF:000697', NULL, NULL, 'Protein kinase N3', NULL, NULL, NULL, NULL, NULL, 4),
(118852, NULL, 'G3DSA:3.40.50.1820:FF:000098', NULL, NULL, 'palmitoyl-protein thioesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(118853, NULL, 'G3DSA:3.30.710.10:FF:000429', NULL, NULL, 'Transmembrane 9 superfamily member 4-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(118854, NULL, 'G3DSA:3.30.450.60:FF:000036', NULL, NULL, 'Clathrin adaptor complex small chain subfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(118855, NULL, 'G3DSA:1.25.40.820:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118856, NULL, 'G3DSA:3.30.450.20:FF:000608', NULL, NULL, 'Sensor histidine kinase, Cache_1 and HAMP domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(118857, NULL, 'G3DSA:3.40.50.720:FF:000718', NULL, NULL, 'Putative oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(118858, NULL, 'G3DSA:3.30.160.60:FF:004100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118859, NULL, 'G3DSA:3.40.50.800:FF:000035', NULL, NULL, 'Prolyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(118860, NULL, 'G3DSA:2.10.25.10:FF:000060', NULL, NULL, 'Neurogenic locus notch protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(118861, NULL, 'G3DSA:3.20.20.80:FF:000252', NULL, NULL, 'Putative myosin class II heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(118862, NULL, 'G3DSA:2.60.40.2030:FF:000028', NULL, NULL, 'Adhesion G-protein coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(118863, NULL, 'G3DSA:1.20.1070.10:FF:001170', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(118864, NULL, 'G3DSA:1.25.40.10:FF:002918', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(118865, NULL, 'G3DSA:2.130.10.10:FF:005090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118866, NULL, 'G3DSA:3.20.20.80:FF:000364', NULL, NULL, 'Glucosylceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(118867, NULL, 'G3DSA:3.80.10.10:FF:002465', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118868, NULL, 'G3DSA:3.10.310.10:FF:000044', NULL, NULL, 'Diaminopimelate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(118869, NULL, 'G3DSA:1.10.565.10:FF:000131', NULL, NULL, 'Nuclear receptor', NULL, NULL, NULL, NULL, NULL, 4),
(118870, NULL, 'G3DSA:3.40.50.300:FF:003353', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(118871, NULL, 'G3DSA:1.20.1070.10:FF:002148', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(118872, NULL, 'G3DSA:1.10.150.20:FF:000238', NULL, NULL, 'Ubiquitin carrier protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(118873, NULL, 'G3DSA:2.40.420.20:FF:000035', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(118874, NULL, 'G3DSA:2.40.10.480:FF:000002', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(118875, NULL, 'G3DSA:3.20.20.100:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118876, NULL, 'G3DSA:3.40.1130.10:FF:000005', NULL, NULL, 'Glycerol-3-phosphate acyltransferase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(118877, NULL, 'G3DSA:3.60.10.10:FF:000274', NULL, NULL, 'CCR4-NOT transcription complex subunit 6-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(118878, NULL, 'G3DSA:1.20.1070.10:FF:000057', NULL, NULL, 'Beta-1 adrenergic receptor', NULL, NULL, NULL, NULL, NULL, 4),
(118879, NULL, 'G3DSA:1.20.80.10:FF:000060', NULL, NULL, 'Acyl CoA binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(118880, NULL, 'G3DSA:3.30.710.10:FF:000474', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118881, NULL, 'G3DSA:1.20.58.1030:FF:000024', NULL, NULL, 'DNA replication complex GINS protein SLD5', NULL, NULL, NULL, NULL, NULL, 4),
(118882, NULL, 'G3DSA:3.40.50.2000:FF:000669', NULL, NULL, 'Glycosyl transferase group 1', NULL, NULL, NULL, NULL, NULL, 4),
(118883, NULL, 'G3DSA:1.20.1250.20:FF:000158', NULL, NULL, 'Solute carrier family 15 member 2', NULL, NULL, NULL, NULL, NULL, 4),
(118884, NULL, 'G3DSA:1.20.1420.30:FF:000085', NULL, NULL, 'Putative cation exchanger C3A12.06c', NULL, NULL, NULL, NULL, NULL, 4),
(118885, NULL, 'G3DSA:3.40.50.620:FF:000751', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118886, NULL, 'G3DSA:1.25.40.10:FF:001165', NULL, NULL, 'Predicted TPR repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(118887, NULL, 'G3DSA:3.30.559.10:FF:000189', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(118888, NULL, 'G3DSA:1.25.40.20:FF:001168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118889, NULL, 'G3DSA:2.60.120.650:FF:000171', NULL, NULL, 'Lysine demethylase 4C', NULL, NULL, NULL, NULL, NULL, 4),
(118890, NULL, 'G3DSA:1.25.40.10:FF:004942', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118891, NULL, 'G3DSA:3.40.50.720:FF:000781', NULL, NULL, 'YML131W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(118892, NULL, 'G3DSA:2.60.120.260:FF:000593', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118893, NULL, 'G3DSA:3.40.1180.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118894, NULL, 'G3DSA:2.60.40.10:FF:005960', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118895, NULL, 'G3DSA:3.30.160.60:FF:001166', NULL, NULL, 'Phage integrase', NULL, NULL, NULL, NULL, NULL, 4),
(118896, NULL, 'G3DSA:3.30.70.330:FF:002435', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118897, NULL, 'G3DSA:3.30.70.2850:FF:000033', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(118898, NULL, 'G3DSA:3.40.50.2000:FF:000169', NULL, NULL, 'UDP-Glycosyltransferase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(118899, NULL, 'G3DSA:1.20.1110.10:FF:000050', NULL, NULL, 'Cation transporting P-ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(118900, NULL, 'G3DSA:3.30.40.10:FF:001204', NULL, NULL, 'Putative E3 ubiquitin-protein ligase RHY1A', NULL, NULL, NULL, NULL, NULL, 4),
(118901, NULL, 'G3DSA:3.30.1110.10:FF:000006', NULL, NULL, 'adenosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(118902, NULL, 'G3DSA:3.90.1290.10:FF:000022', NULL, NULL, 'Dystonin', NULL, NULL, NULL, NULL, NULL, 4),
(118903, NULL, 'G3DSA:3.40.50.2300:FF:001102', NULL, NULL, 'Taste receptor type 1 member 2', NULL, NULL, NULL, NULL, NULL, 4),
(118904, NULL, 'G3DSA:3.30.519.10:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118905, NULL, 'G3DSA:1.10.8.60:FF:000215', NULL, NULL, 'BMA-SPAS-1, isoform e', NULL, NULL, NULL, NULL, NULL, 4),
(118906, NULL, 'G3DSA:3.90.190.10:FF:000431', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118907, NULL, 'G3DSA:1.20.1560.10:FF:000139', NULL, NULL, 'ATP-binding Cassette (ABC) Superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(118908, NULL, 'G3DSA:3.100.10.10:FF:000023', NULL, NULL, '50S ribosomal protein L15', NULL, NULL, NULL, NULL, NULL, 4),
(118909, NULL, 'G3DSA:2.60.40.10:FF:005067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118910, NULL, 'G3DSA:3.40.140.20:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(118911, NULL, 'G3DSA:3.40.1110.10:FF:000061', NULL, NULL, 'Potassium-transporting ATPase alpha chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(118912, NULL, 'G3DSA:1.25.40.660:FF:000001', NULL, NULL, 'Vacuolar protein sorting-associated protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(118913, NULL, 'G3DSA:3.60.110.10:FF:000079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118914, NULL, 'G3DSA:3.20.20.300:FF:000086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118915, NULL, 'G3DSA:2.60.40.10:FF:005281', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118916, NULL, 'G3DSA:2.60.40.4100:FF:000003', NULL, NULL, 'Transforming growth factor beta receptor type 3', NULL, NULL, NULL, NULL, NULL, 4),
(118917, NULL, 'G3DSA:1.20.1050.10:FF:000174', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(118918, NULL, 'G3DSA:3.40.50.720:FF:002068', NULL, NULL, 'Ubiquitin-like modifier-activating enzyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(118919, NULL, 'G3DSA:1.20.1250.20:FF:001052', NULL, NULL, 'High-affinity nicotinic acid transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(118920, NULL, 'G3DSA:1.10.8.10:FF:000280', NULL, NULL, 'Putative BOI-related E3 ubiquitin-protein ligase 3', NULL, NULL, NULL, NULL, NULL, 4),
(118921, NULL, 'G3DSA:3.50.50.60:FF:000292', NULL, NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(118922, NULL, 'G3DSA:3.30.160.60:FF:005437', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118923, NULL, 'G3DSA:3.90.1170.50:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118924, NULL, 'G3DSA:1.10.510.10:FF:003192', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118925, NULL, 'G3DSA:1.10.10.60:FF:001037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118926, NULL, 'G3DSA:3.40.50.300:FF:001728', NULL, NULL, 'Ras related protein1', NULL, NULL, NULL, NULL, NULL, 4),
(118927, NULL, 'G3DSA:1.20.1250.20:FF:001788', NULL, NULL, 'Allantoate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(118928, NULL, 'G3DSA:3.40.50.2300:FF:001372', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118929, NULL, 'G3DSA:3.30.450.50:FF:000033', NULL, NULL, 'Putative SNARE protein', NULL, NULL, NULL, NULL, NULL, 4),
(118930, NULL, 'G3DSA:3.30.160.60:FF:002060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118931, NULL, 'G3DSA:3.40.30.10:FF:000500', NULL, NULL, 'TCHQD class glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(118932, NULL, 'G3DSA:3.30.450.40:FF:000030', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(118933, NULL, 'G3DSA:3.90.180.10:FF:000043', NULL, NULL, 'Alcohol dehydrogenase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(118934, NULL, 'G3DSA:2.70.98.10:FF:000085', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(118935, NULL, 'G3DSA:1.25.40.10:FF:003812', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118936, NULL, 'G3DSA:2.60.120.290:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118937, NULL, 'G3DSA:2.30.30.830:FF:000006', NULL, NULL, 'Competence protein D', NULL, NULL, NULL, NULL, NULL, 4),
(118938, NULL, 'G3DSA:3.30.200.20:FF:000101', NULL, NULL, 'CDPK-related kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(118939, NULL, 'G3DSA:3.90.1170.40:FF:000022', NULL, NULL, 'Os02g0517366 protein', NULL, NULL, NULL, NULL, NULL, 4),
(118940, NULL, 'G3DSA:1.20.1310.20:FF:000034', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(118941, NULL, 'G3DSA:3.30.70.100:FF:000011', NULL, NULL, 'Acylphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(118942, NULL, 'G3DSA:3.40.50.2300:FF:000259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118943, NULL, 'G3DSA:2.30.42.10:FF:000194', NULL, NULL, 'ligand of Numb protein X 2', NULL, NULL, NULL, NULL, NULL, 4),
(118944, NULL, 'G3DSA:3.30.160.60:FF:004948', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(118945, NULL, 'G3DSA:1.20.58.60:FF:000343', NULL, NULL, 'SMAll', NULL, NULL, NULL, NULL, NULL, 4),
(118946, NULL, 'G3DSA:3.40.720.10:FF:000034', NULL, NULL, 'Membrane-associated phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(118947, NULL, 'G3DSA:3.40.50.620:FF:000239', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(118948, NULL, 'G3DSA:3.30.160.60:FF:003083', NULL, NULL, 'Zinc finger and SCAN domain containing protein 4F', NULL, NULL, NULL, NULL, NULL, 4),
(118949, NULL, 'G3DSA:3.30.160.60:FF:003369', NULL, NULL, 'Zinc finger protein 778', NULL, NULL, NULL, NULL, NULL, 4),
(118950, NULL, 'G3DSA:3.40.50.2300:FF:000990', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118951, NULL, 'G3DSA:3.10.250.10:FF:000145', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118952, NULL, 'G3DSA:3.40.50.300:FF:003971', NULL, NULL, 'Holdfast attachment protein C', NULL, NULL, NULL, NULL, NULL, 4),
(118953, NULL, 'G3DSA:3.40.50.12780:FF:000058', NULL, NULL, 'Acetyl-coenzyme A synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(118954, NULL, 'G3DSA:3.40.50.150:FF:001251', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118955, NULL, 'G3DSA:3.30.930.10:FF:000069', NULL, NULL, 'Seryl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(118956, NULL, 'G3DSA:2.60.120.920:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118957, NULL, 'G3DSA:1.25.10.10:FF:003136', NULL, NULL, 'Diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(118958, NULL, 'G3DSA:3.30.160.60:FF:003425', NULL, NULL, 'Zinc finger protein 655', NULL, NULL, NULL, NULL, NULL, 4),
(118959, NULL, 'G3DSA:2.10.25.10:FF:000913', NULL, NULL, 'Coagulation factor VII', NULL, NULL, NULL, NULL, NULL, 4),
(118960, NULL, 'G3DSA:2.20.25.350:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118961, NULL, 'G3DSA:3.90.70.10:FF:000759', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118962, NULL, 'G3DSA:3.30.40.10:FF:000187', NULL, NULL, 'E3 ubiquitin-protein ligase ATL6', NULL, NULL, NULL, NULL, NULL, 4),
(118963, NULL, 'G3DSA:1.10.132.30:FF:000020', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(118964, NULL, 'G3DSA:3.30.70.120:FF:000017', NULL, NULL, 'Periplasmic divalent cation tolerance protein', NULL, NULL, NULL, NULL, NULL, 4),
(118965, NULL, 'G3DSA:1.20.1560.10:FF:000813', NULL, NULL, 'AGAP004602-PA', NULL, NULL, NULL, NULL, NULL, 4),
(118966, NULL, 'G3DSA:3.30.70.260:FF:000031', NULL, NULL, 'LDLR chaperone MESD', NULL, NULL, NULL, NULL, NULL, 4),
(118967, NULL, 'G3DSA:3.30.930.10:FF:000417', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118968, NULL, 'G3DSA:1.50.40.10:FF:000084', NULL, NULL, 'Mitochondrial carrier protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(118969, NULL, 'G3DSA:1.25.40.10:FF:004268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118970, NULL, 'G3DSA:2.20.100.10:FF:000092', NULL, NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 13', NULL, NULL, NULL, NULL, NULL, 4),
(118971, NULL, 'G3DSA:3.30.420.40:FF:000495', NULL, NULL, 'Heat shock protein 4b', NULL, NULL, NULL, NULL, NULL, 4),
(118972, NULL, 'G3DSA:3.40.190.10:FF:000459', NULL, NULL, 'Glycine cleavage operon activator', NULL, NULL, NULL, NULL, NULL, 4),
(118973, NULL, 'G3DSA:3.40.50.720:FF:000163', NULL, NULL, '6-phospho-beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(118974, NULL, 'G3DSA:3.30.70.270:FF:000034', NULL, NULL, 'Diguanylate cyclase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(118975, NULL, 'G3DSA:1.20.1730.10:FF:000029', NULL, NULL, 'GM16419', NULL, NULL, NULL, NULL, NULL, 4),
(118976, NULL, 'G3DSA:3.60.110.10:FF:000023', NULL, NULL, 'Related to NIT3-nitrilase', NULL, NULL, NULL, NULL, NULL, 4),
(118977, NULL, 'G3DSA:2.60.120.200:FF:000777', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118978, NULL, 'G3DSA:2.30.30.620:FF:000005', NULL, NULL, 'Major vault protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(118979, NULL, 'G3DSA:1.20.5.110:FF:000216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118980, NULL, 'G3DSA:4.10.80.340:FF:000001', NULL, NULL, 'Protein V', NULL, NULL, NULL, NULL, NULL, 4),
(118981, NULL, 'G3DSA:2.40.50.140:FF:000178', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(118982, NULL, 'G3DSA:3.90.15.10:FF:000008', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(118983, NULL, 'G3DSA:1.10.150.50:FF:000056', NULL, NULL, 'Ectoderm-expressed 4, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(118984, NULL, 'G3DSA:1.20.58.1030:FF:000029', NULL, NULL, 'DNA replication complex GINS protein SLD5', NULL, NULL, NULL, NULL, NULL, 4),
(118985, NULL, 'G3DSA:2.40.40.20:FF:000040', NULL, NULL, 'AAA family ATPase, CDC48 subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(118986, NULL, 'G3DSA:1.10.10.10:FF:001270', NULL, NULL, 'RpiR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(118987, NULL, 'G3DSA:1.10.287.810:FF:000005', NULL, NULL, 'Mitochondrial import inner membrane translocase subunit Tim8 B', NULL, NULL, NULL, NULL, NULL, 4),
(118988, NULL, 'G3DSA:3.40.50.300:FF:007624', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118989, NULL, 'G3DSA:3.40.50.150:FF:000020', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase M', NULL, NULL, NULL, NULL, NULL, 4),
(118990, NULL, 'G3DSA:3.30.70.100:FF:000062', NULL, NULL, 'Copper resistance-associated P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(118991, NULL, 'G3DSA:1.10.287.470:FF:000033', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(118992, NULL, 'G3DSA:3.40.50.300:FF:005770', NULL, NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 9', NULL, NULL, NULL, NULL, NULL, 4),
(118993, NULL, 'G3DSA:2.70.50.80:FF:000006', NULL, NULL, 'Transcriptional enhancer factor TEF-1', NULL, NULL, NULL, NULL, NULL, 4),
(118994, NULL, 'G3DSA:1.50.40.10:FF:000202', NULL, NULL, 'AT11877p', NULL, NULL, NULL, NULL, NULL, 4),
(118995, NULL, 'G3DSA:3.40.50.2000:FF:000383', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(118996, NULL, 'G3DSA:3.30.160.60:FF:004999', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(118997, NULL, 'G3DSA:2.10.230.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118998, NULL, 'G3DSA:3.60.40.10:FF:000332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(118999, NULL, 'G3DSA:1.10.10.10:FF:000994', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119000, NULL, 'G3DSA:2.60.40.4100:FF:000008', NULL, NULL, 'Zona pellucida-like domain containing 1a', NULL, NULL, NULL, NULL, NULL, 4),
(119001, NULL, 'G3DSA:2.60.120.290:FF:000080', NULL, NULL, 'Zinc metalloproteinase', NULL, NULL, NULL, NULL, NULL, 4),
(119002, NULL, 'G3DSA:1.25.40.10:FF:004616', NULL, NULL, 'AGAP010426-PA', NULL, NULL, NULL, NULL, NULL, 4),
(119003, NULL, 'G3DSA:1.25.40.20:FF:000038', NULL, NULL, 'Arf-GAP with GTPase, ANK repeat and PH domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(119004, NULL, 'G3DSA:2.40.50.140:FF:001072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119005, NULL, 'G3DSA:1.20.1270.10:FF:000038', NULL, NULL, 'Heat shock protein 110', NULL, NULL, NULL, NULL, NULL, 4),
(119006, NULL, 'G3DSA:1.20.1720.10:FF:000079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119007, NULL, 'G3DSA:3.40.50.720:FF:002579', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119008, NULL, 'G3DSA:1.10.630.10:FF:000109', NULL, NULL, 'Heme peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(119009, NULL, 'G3DSA:1.20.1600.10:FF:000025', NULL, NULL, 'Multidrug efflux outer membrane protein OprN', NULL, NULL, NULL, NULL, NULL, 4),
(119010, NULL, 'G3DSA:2.130.10.10:FF:004825', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119011, NULL, 'G3DSA:3.40.50.300:FF:001509', NULL, NULL, 'Cytoplasmic dynein 1 light intermediate chain', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(119012, NULL, 'G3DSA:2.130.10.10:FF:005371', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119013, NULL, 'G3DSA:3.40.50.2300:FF:000664', NULL, NULL, 'Sensory box sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(119014, NULL, 'G3DSA:3.40.50.1820:FF:000391', NULL, NULL, 'Putative acetyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(119015, NULL, 'G3DSA:3.30.70.330:FF:000748', NULL, NULL, 'RNA Binding Motif protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(119016, NULL, 'G3DSA:3.30.565.10:FF:000012', NULL, NULL, 'Heat shock cognate protein', NULL, NULL, NULL, NULL, NULL, 4),
(119017, NULL, 'G3DSA:2.40.30.170:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119018, NULL, 'G3DSA:3.40.1170.20:FF:000005', NULL, NULL, 'tRNA-splicing endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(119019, NULL, 'G3DSA:2.130.10.10:FF:004477', NULL, NULL, 'GH20665p', NULL, NULL, NULL, NULL, NULL, 4),
(119020, NULL, 'G3DSA:4.10.87.10:FF:000001', NULL, NULL, 'mRNA-capping enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(119021, NULL, 'G3DSA:3.40.1170.10:FF:000002', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(119022, NULL, 'G3DSA:3.40.50.300:FF:007175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119023, NULL, 'G3DSA:1.25.40.10:FF:000906', NULL, NULL, 'BnaA09g39930D protein', NULL, NULL, NULL, NULL, NULL, 4),
(119024, NULL, 'G3DSA:2.60.40.10:FF:005286', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119025, NULL, 'G3DSA:2.130.10.10:FF:003572', NULL, NULL, 'Os02g0539900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(119026, NULL, 'G3DSA:3.30.70.330:FF:002547', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119027, NULL, 'G3DSA:1.10.287.70:FF:000761', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119028, NULL, 'G3DSA:6.10.250.3260:FF:000004', NULL, NULL, 'LSU ribosomal protein L21E', NULL, NULL, NULL, NULL, NULL, 4),
(119029, NULL, 'G3DSA:2.60.120.260:FF:000267', NULL, NULL, 'SCO-spondin', NULL, NULL, NULL, NULL, NULL, 4),
(119030, NULL, 'G3DSA:3.30.200.20:FF:000949', NULL, NULL, 'Os11g0150700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(119031, NULL, 'G3DSA:1.10.150.50:FF:000112', NULL, NULL, 'Phospholipase DDHD2', NULL, NULL, NULL, NULL, NULL, 4),
(119032, NULL, 'G3DSA:2.30.29.30:FF:000517', NULL, NULL, 'Adaptin earbinding coat-associated protein 2 (Necap-2) isoform', NULL, NULL, NULL, NULL, NULL, 4),
(119033, NULL, 'G3DSA:3.30.1520.10:FF:000094', NULL, NULL, 'Kinesin family member 16B', NULL, NULL, NULL, NULL, NULL, 4),
(119034, NULL, 'G3DSA:3.40.50.700:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119035, NULL, 'G3DSA:4.10.1240.10:FF:000014', NULL, NULL, 'Growth hormone-releasing hormone receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(119036, NULL, 'G3DSA:2.130.10.10:FF:003465', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(119037, NULL, 'G3DSA:2.40.50.90:FF:000039', NULL, NULL, 'Tudor staphylococcal nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(119038, NULL, 'G3DSA:1.25.40.10:FF:004886', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119039, NULL, 'G3DSA:3.20.70.20:FF:000052', NULL, NULL, 'Ribonucleoside-diphosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(119040, NULL, 'G3DSA:3.40.50.2000:FF:000725', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119041, NULL, 'G3DSA:3.40.50.300:FF:005500', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(119042, NULL, 'G3DSA:3.40.190.10:FF:000858', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119043, NULL, 'G3DSA:2.40.50.140:FF:000739', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119044, NULL, 'G3DSA:3.40.50.720:FF:002287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119045, NULL, 'G3DSA:3.40.50.300:FF:005551', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119046, NULL, 'G3DSA:3.30.1960.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(119047, NULL, 'G3DSA:1.10.3090.10:FF:000010', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(119048, NULL, 'G3DSA:1.10.287.130:FF:000066', NULL, NULL, 'PAS domain-containing sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(119049, NULL, 'G3DSA:1.10.10.250:FF:000011', NULL, NULL, 'Rpl-12', NULL, NULL, NULL, NULL, NULL, 4),
(119050, NULL, 'G3DSA:4.10.280.10:FF:000042', NULL, NULL, 'transcription factor bHLH48-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(119051, NULL, 'G3DSA:1.20.1440.170:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119052, NULL, 'G3DSA:1.10.510.10:FF:000044', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(119053, NULL, 'G3DSA:3.60.10.10:FF:000386', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119054, NULL, 'G3DSA:2.70.130.10:FF:000121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119055, NULL, 'G3DSA:2.40.50.100:FF:000014', NULL, NULL, 'Maltose/maltodextrin import ATP-binding protein MalK', NULL, NULL, NULL, NULL, NULL, 4),
(119056, NULL, 'G3DSA:3.30.160.60:FF:005730', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119057, NULL, 'G3DSA:1.10.8.60:FF:000322', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119058, NULL, 'G3DSA:2.60.120.330:FF:000018', NULL, NULL, '2-oxoglutarate (2OG) and Fe(II)-dependent oxygenase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(119059, NULL, 'G3DSA:1.10.287.130:FF:000122', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(119060, NULL, 'G3DSA:1.10.287.110:FF:000060', NULL, NULL, 'DnaJ (Hsp40) homolog, subfamily C, member 30', NULL, NULL, NULL, NULL, NULL, 4),
(119061, NULL, 'G3DSA:1.10.20.10:FF:000202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119062, NULL, 'G3DSA:2.130.10.10:FF:003173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119063, NULL, 'G3DSA:3.20.20.100:FF:000037', NULL, NULL, 'L-galactose dehydrogenase (L-GalDH)', NULL, NULL, NULL, NULL, NULL, 4),
(119064, NULL, 'G3DSA:3.40.5.50:FF:000005', NULL, NULL, 'DNA replication complex GINS protein PSF2', NULL, NULL, NULL, NULL, NULL, 4),
(119065, NULL, 'G3DSA:3.80.10.10:FF:000666', NULL, NULL, 'Nucleotide-binding oligomerization domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(119066, NULL, 'G3DSA:1.25.40.10:FF:004835', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119067, NULL, 'G3DSA:3.40.50.720:FF:000270', NULL, NULL, 'ubiquitin-conjugating enzyme E2 variant 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(119068, NULL, 'G3DSA:2.170.150.80:FF:000012', NULL, NULL, 'NAC with transmembrane motif1', NULL, NULL, NULL, NULL, NULL, 4),
(119069, NULL, 'G3DSA:3.10.450.590:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119070, NULL, 'G3DSA:1.10.510.10:FF:001623', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119071, NULL, 'G3DSA:3.40.50.150:FF:001874', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119072, NULL, 'G3DSA:3.40.50.850:FF:000022', NULL, NULL, 'SA0181 protein', NULL, NULL, NULL, NULL, NULL, 4),
(119073, NULL, 'G3DSA:3.30.160.60:FF:003695', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119074, NULL, 'G3DSA:2.130.10.10:FF:003521', NULL, NULL, 'Elongator complex protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(119075, NULL, 'G3DSA:2.130.10.10:FF:003807', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119076, NULL, 'G3DSA:3.10.129.10:FF:000206', NULL, NULL, 'Thioesterase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(119077, NULL, 'G3DSA:2.60.120.200:FF:000507', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119078, NULL, 'G3DSA:1.10.10.60:FF:000014', NULL, NULL, 'SWI/SNF complex subunit SMARCC2 isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(119079, NULL, 'G3DSA:3.30.70.330:FF:002379', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(119080, NULL, 'G3DSA:2.60.40.420:FF:000238', NULL, NULL, 'Bll2293 protein', NULL, NULL, NULL, NULL, NULL, 4),
(119081, NULL, 'G3DSA:3.90.550.10:FF:000240', NULL, NULL, 'N-acylneuraminate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(119082, NULL, 'G3DSA:1.10.472.80:FF:000037', NULL, NULL, 'TBC1 domain family member 21', NULL, NULL, NULL, NULL, NULL, 4),
(119083, NULL, 'G3DSA:3.90.640.10:FF:000067', NULL, NULL, 'Actin-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(119084, NULL, 'G3DSA:3.40.50.300:FF:000205', NULL, NULL, 'ABC transporter B family member 4', NULL, NULL, NULL, NULL, NULL, 4),
(119085, NULL, 'G3DSA:3.30.710.10:FF:000255', NULL, NULL, 'Elc1 elongin C', NULL, NULL, NULL, NULL, NULL, 4),
(119086, NULL, 'G3DSA:3.40.5.60:FF:000008', NULL, NULL, 'DNA replication complex GINS protein SLD5', NULL, NULL, NULL, NULL, NULL, 4),
(119087, NULL, 'G3DSA:4.10.280.10:FF:000222', NULL, NULL, 'Transcription factor bHLH99', NULL, NULL, NULL, NULL, NULL, 4),
(119088, NULL, 'G3DSA:1.20.1070.10:FF:000169', NULL, NULL, 'Retinal pigment epithelium-derived rhodopsin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(119089, NULL, 'G3DSA:1.10.238.10:FF:000130', NULL, NULL, 'TBC1 domain family member 9B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(119090, NULL, 'G3DSA:2.10.25.10:FF:000508', NULL, NULL, 'Eyes shut homolog', NULL, NULL, NULL, NULL, NULL, 4),
(119091, NULL, 'G3DSA:1.25.40.10:FF:005111', NULL, NULL, 'Tetratricopeptide repeat domain 3', NULL, NULL, NULL, NULL, NULL, 4),
(119092, NULL, 'G3DSA:2.20.70.10:FF:000175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119093, NULL, 'G3DSA:3.40.50.620:FF:000863', NULL, NULL, 'Glutamine-dependent NAD(+) synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(119094, NULL, 'G3DSA:3.30.70.330:FF:002727', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119095, NULL, 'G3DSA:3.30.70.330:FF:002873', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119096, NULL, 'G3DSA:3.80.10.10:FF:001161', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(119097, NULL, 'G3DSA:2.30.42.10:FF:000429', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119098, NULL, 'G3DSA:1.20.120.350:FF:000242', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119099, NULL, 'G3DSA:3.40.50.300:FF:003027', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(119100, NULL, 'G3DSA:1.10.287.820:FF:000008', NULL, NULL, 'Pickpocket 10', NULL, NULL, NULL, NULL, NULL, 4),
(119101, NULL, 'G3DSA:3.30.559.10:FF:000245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119102, NULL, 'G3DSA:3.40.50.300:FF:007916', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119103, NULL, 'G3DSA:3.40.605.10:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119104, NULL, 'G3DSA:1.10.150.850:FF:000001', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(119105, NULL, 'G3DSA:2.130.10.10:FF:003246', NULL, NULL, 'Probable cleavage and polyadenylation specificity factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(119106, NULL, 'G3DSA:2.60.120.200:FF:000558', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119107, NULL, 'G3DSA:2.60.40.1730:FF:000101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119108, NULL, 'G3DSA:1.20.120.1750:FF:000068', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(119109, NULL, 'G3DSA:1.10.10.800:FF:000002', NULL, NULL, 'OpdE downstream ORF 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119110, NULL, 'G3DSA:3.30.200.20:FF:001405', NULL, NULL, 'MAP kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(119111, NULL, 'G3DSA:1.10.510.10:FF:004496', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119112, NULL, 'G3DSA:3.40.250.10:FF:000161', NULL, NULL, 'YALI0F15367p', NULL, NULL, NULL, NULL, NULL, 4),
(119113, NULL, 'G3DSA:2.10.25.10:FF:000352', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(119114, NULL, 'G3DSA:3.40.50.620:FF:000458', NULL, NULL, 'NH(3)-dependent NAD(+) synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(119115, NULL, 'G3DSA:3.30.40.10:FF:001030', NULL, NULL, 'MIB (MIndBomb) ubiquitin ligase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(119116, NULL, 'G3DSA:1.20.1250.20:FF:000484', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(119117, NULL, 'G3DSA:1.10.1080.10:FF:000009', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(119118, NULL, 'G3DSA:1.25.40.10:FF:005324', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g52620', NULL, NULL, NULL, NULL, NULL, 4),
(119119, NULL, 'G3DSA:2.130.10.10:FF:003791', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119120, NULL, 'G3DSA:1.10.246.190:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119121, NULL, 'G3DSA:2.60.40.640:FF:000012', NULL, NULL, 'vacuolar protein sorting-associated protein 26A', NULL, NULL, NULL, NULL, NULL, 4),
(119122, NULL, 'G3DSA:2.60.40.10:FF:001177', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase beta', NULL, NULL, NULL, NULL, NULL, 4),
(119123, NULL, 'G3DSA:3.30.70.330:FF:003003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119124, NULL, 'G3DSA:3.30.160.60:FF:000210', NULL, NULL, 'Zinc finger RNA-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(119125, NULL, 'G3DSA:1.10.287.70:FF:000137', NULL, NULL, 'Slowpoke 2, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(119126, NULL, 'G3DSA:1.10.287.70:FF:000542', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119127, NULL, 'G3DSA:3.30.160.60:FF:003644', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119128, NULL, 'G3DSA:1.10.640.10:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119129, NULL, 'G3DSA:3.80.10.10:FF:002521', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119130, NULL, 'G3DSA:2.30.30.1190:FF:000013', NULL, NULL, 'Zinc finger nuclease 2', NULL, NULL, NULL, NULL, NULL, 4),
(119131, NULL, 'G3DSA:1.10.510.10:FF:000786', NULL, NULL, 'caM kinase-like vesicle-associated protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(119132, NULL, 'G3DSA:1.20.58.60:FF:000287', NULL, NULL, 'Utrophin', NULL, NULL, NULL, NULL, NULL, 4),
(119133, NULL, 'G3DSA:1.20.58.340:FF:000032', NULL, NULL, 'Magnesium and cobalt transport protein CorA, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119134, NULL, 'G3DSA:3.40.710.10:FF:000152', NULL, NULL, 'Probable peptidoglycan D,D-transpeptidase PbpC', NULL, NULL, NULL, NULL, NULL, 4),
(119135, NULL, 'G3DSA:3.40.1000.30:FF:000002', NULL, NULL, 'Proteasome inhibitor PI31 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(119136, NULL, 'G3DSA:2.60.40.650:FF:000015', NULL, NULL, 'Sulfite dehydrogenase molybdopterin-binding subunit SorA', NULL, NULL, NULL, NULL, NULL, 4),
(119137, NULL, 'G3DSA:3.40.50.300:FF:003645', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119138, NULL, 'G3DSA:2.30.39.10:FF:000051', NULL, NULL, 'Serpin-Z2A', NULL, NULL, NULL, NULL, NULL, 4),
(119139, NULL, 'G3DSA:1.10.3550.10:FF:000001', NULL, NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(119140, NULL, 'G3DSA:3.90.1150.210:FF:000015', NULL, NULL, 'Unplaced genomic scaffold supercont2.11, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(119141, NULL, 'G3DSA:1.25.10.10:FF:003428', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119142, NULL, 'G3DSA:1.25.40.1040:FF:000027', NULL, NULL, 'mRNA 3''-end-processing protein RNA14', NULL, NULL, NULL, NULL, NULL, 4),
(119143, NULL, 'G3DSA:1.10.418.10:FF:000110', NULL, NULL, 'Unplaced genomic scaffold supercont2.13, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(119144, NULL, 'G3DSA:3.40.50.300:FF:007568', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119145, NULL, 'G3DSA:2.60.120.200:FF:000159', NULL, NULL, 'Glycosidase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(119146, NULL, 'G3DSA:2.70.150.10:FF:000010', NULL, NULL, 'Potassium-transporting ATPase ATP-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(119147, NULL, 'G3DSA:3.30.1370.50:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119148, NULL, 'G3DSA:2.60.40.60:FF:001052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119149, NULL, 'G3DSA:2.10.50.30:FF:000028', NULL, NULL, 'metabotropic glutamate receptor 3-like', NULL, NULL, NULL, NULL, NULL, 4),
(119150, NULL, 'G3DSA:1.20.1420.10:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119151, NULL, 'G3DSA:1.20.58.240:FF:000007', NULL, NULL, 'protein O-GlcNAcase-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(119152, NULL, 'G3DSA:2.40.30.200:FF:000001', NULL, NULL, 'Distal tail protein', NULL, NULL, NULL, NULL, NULL, 4),
(119153, NULL, 'G3DSA:1.25.10.10:FF:002698', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119154, NULL, 'G3DSA:3.30.160.60:FF:000261', NULL, NULL, 'Zinc finger protein 521', NULL, NULL, NULL, NULL, NULL, 4),
(119155, NULL, 'G3DSA:1.10.390.10:FF:000056', NULL, NULL, 'Protein CBG20905', NULL, NULL, NULL, NULL, NULL, 4),
(119156, NULL, 'G3DSA:1.10.150.240:FF:000049', NULL, NULL, 'AT11641p', NULL, NULL, NULL, NULL, NULL, 4),
(119157, NULL, 'G3DSA:1.20.58.1070:FF:000013', NULL, NULL, 'Gem-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(119158, NULL, 'G3DSA:3.30.420.10:FF:000660', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119159, NULL, 'G3DSA:1.20.1270.60:FF:000317', NULL, NULL, 'Variant SH3 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(119160, NULL, 'G3DSA:2.60.40.1390:FF:000010', NULL, NULL, 'Related to acid phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(119161, NULL, 'G3DSA:3.30.413.10:FF:000019', NULL, NULL, 'Nitrite/sulfite reductase, 4Fe-4S iron-sulfur cluster-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(119162, NULL, 'G3DSA:3.40.1110.10:FF:000403', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119163, NULL, 'G3DSA:1.10.150.810:FF:000012', NULL, NULL, 'DINP protein, human muc B family', NULL, NULL, NULL, NULL, NULL, 4),
(119164, NULL, 'G3DSA:3.40.50.150:FF:001363', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119165, NULL, 'G3DSA:3.40.50.11210:FF:000003', NULL, NULL, 'RAP1 GTPase activating protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(119166, NULL, 'G3DSA:3.40.50.720:FF:000269', NULL, NULL, 'Trans-1,2-dihydrobenzene-1,2-diol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(119167, NULL, 'G3DSA:3.40.605.10:FF:000019', NULL, NULL, 'probable aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(119168, NULL, 'G3DSA:1.20.58.60:FF:000517', NULL, NULL, 'Spectrin repeat containing, nuclear envelope 1a', NULL, NULL, NULL, NULL, NULL, 4),
(119169, NULL, 'G3DSA:1.25.40.70:FF:000031', NULL, NULL, 'Putative phosphatidylinositol 3-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(119170, NULL, 'G3DSA:3.30.200.20:FF:000394', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(119171, NULL, 'G3DSA:3.40.720.10:FF:000208', NULL, NULL, 'Type I phosphodiesterase/nucleotide pyrophosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(119172, NULL, 'G3DSA:3.40.140.20:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119173, NULL, 'G3DSA:3.30.70.330:FF:000636', NULL, NULL, 'Cell wall integrity protein scw1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119174, NULL, 'G3DSA:3.30.200.20:FF:002535', NULL, NULL, 'Cyclin dependent kinase 20', NULL, NULL, NULL, NULL, NULL, 4),
(119175, NULL, 'G3DSA:1.10.510.10:FF:003478', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119176, NULL, 'G3DSA:3.30.450.20:FF:000159', NULL, NULL, 'Alkaline phosphatase synthesis sensor protein PhoR', NULL, NULL, NULL, NULL, NULL, 4),
(119177, NULL, 'G3DSA:1.25.50.20:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119178, NULL, 'G3DSA:3.40.50.300:FF:002858', NULL, NULL, 'DNA repair helicase rad3/xp-D, putative', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(119179, NULL, 'G3DSA:3.80.10.10:FF:001919', NULL, NULL, 'Protein phosphatase 2C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(119180, NULL, 'G3DSA:3.40.50.1700:FF:000023', NULL, NULL, 'Glucan 1,4-beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(119181, NULL, 'G3DSA:1.10.510.10:FF:001354', NULL, NULL, 'Serine/threonine protein kinase sid1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119182, NULL, 'G3DSA:2.10.25.10:FF:000391', NULL, NULL, 'Weary, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(119183, NULL, 'G3DSA:3.90.1740.10:FF:000001', NULL, NULL, 'Tetratricopeptide repeat protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(119184, NULL, 'G3DSA:3.50.50.80:FF:000005', NULL, NULL, 'Ubiquitin-activating enzyme E1', NULL, NULL, NULL, NULL, NULL, 4),
(119185, NULL, 'G3DSA:3.30.1330.40:FF:000037', NULL, NULL, 'Chorismate mutase AroH', NULL, NULL, NULL, NULL, NULL, 4),
(119186, NULL, 'G3DSA:2.60.40.10:FF:003482', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119187, NULL, 'G3DSA:2.60.40.420:FF:000183', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(119188, NULL, 'G3DSA:1.20.5.110:FF:000104', NULL, NULL, 'Synaptobrevin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(119189, NULL, 'G3DSA:1.10.1090.10:FF:000004', NULL, NULL, 'Probable cytochrome b-c1 complex subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(119190, NULL, 'G3DSA:1.20.1080.10:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119191, NULL, 'G3DSA:1.20.1250.20:FF:000832', NULL, NULL, 'L-Proline/Glycine betaine transporter ProP', NULL, NULL, NULL, NULL, NULL, 4),
(119192, NULL, 'G3DSA:1.10.390.10:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119193, NULL, 'G3DSA:3.40.50.1400:FF:000034', NULL, NULL, 'Sirohydrochlorin cobaltochelatase CbiKP', NULL, NULL, NULL, NULL, NULL, 4),
(119194, NULL, 'G3DSA:2.60.220.50:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119195, NULL, 'G3DSA:3.30.70.960:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119196, NULL, 'G3DSA:2.30.40.10:FF:000026', NULL, NULL, 'Imidazolonepropionase', NULL, NULL, NULL, NULL, NULL, 4),
(119197, NULL, 'G3DSA:3.30.70.60:FF:000018', NULL, NULL, '30S ribosomal protein S6', NULL, NULL, NULL, NULL, NULL, 4),
(119198, NULL, 'G3DSA:1.20.58.390:FF:000024', NULL, NULL, 'Glutamate-gated chloride channel alpha', NULL, NULL, NULL, NULL, NULL, 4),
(119199, NULL, 'G3DSA:3.30.930.10:FF:000305', NULL, NULL, 'Serine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(119200, NULL, 'G3DSA:2.60.40.650:FF:000009', NULL, NULL, 'probable sulfite oxidase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(119201, NULL, 'G3DSA:2.10.50.10:FF:000022', NULL, NULL, 'Signal peptide, CUB domain and EGF-like domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(119202, NULL, 'G3DSA:1.20.1070.10:FF:000731', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(119203, NULL, 'G3DSA:4.10.1060.10:FF:000034', NULL, NULL, 'Nucleoporin 153kD, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(119204, NULL, 'G3DSA:2.10.25.10:FF:000059', NULL, NULL, 'Mannan-binding lectin serine protease 1', NULL, NULL, NULL, NULL, NULL, 4),
(119205, NULL, 'G3DSA:2.30.40.10:FF:000083', NULL, NULL, 'Cytosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(119206, NULL, 'G3DSA:3.40.50.10470:FF:000011', NULL, NULL, 'Methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(119207, NULL, 'G3DSA:1.10.10.10:FF:001444', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(119208, NULL, 'G3DSA:2.60.220.50:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119209, NULL, 'G3DSA:3.30.160.60:FF:001458', NULL, NULL, 'INSM transcriptional repressor 1', NULL, NULL, NULL, NULL, NULL, 4),
(119210, NULL, 'G3DSA:3.40.50.2000:FF:000057', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(119211, NULL, 'G3DSA:3.40.50.300:FF:001279', NULL, NULL, 'ATP-dependent RNA helicase DEAH12 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(119212, NULL, 'G3DSA:3.40.50.1820:FF:001115', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(119213, NULL, 'G3DSA:3.40.50.300:FF:001335', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(119214, NULL, 'G3DSA:3.40.50.10480:FF:000014', NULL, NULL, 'Brix domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(119215, NULL, 'G3DSA:3.30.420.10:FF:000603', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119216, NULL, 'G3DSA:3.10.20.10:FF:000029', NULL, NULL, '60S ribosomal protein L18a', NULL, NULL, NULL, NULL, NULL, 4),
(119217, NULL, 'G3DSA:3.30.40.10:FF:000698', NULL, NULL, 'Tripartite motif containing 15', NULL, NULL, NULL, NULL, NULL, 4),
(119218, NULL, 'G3DSA:3.40.50.300:FF:003465', NULL, NULL, 'AAA family ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119219, NULL, 'G3DSA:3.40.50.1820:FF:000547', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119220, NULL, 'G3DSA:3.40.1370.10:FF:000040', NULL, NULL, '50S ribosomal protein L4, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(119221, NULL, 'G3DSA:1.20.1250.20:FF:001501', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(119222, NULL, 'G3DSA:1.20.58.60:FF:000556', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(119223, NULL, 'G3DSA:3.10.50.40:FF:000017', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(119224, NULL, 'G3DSA:1.10.1040.10:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119225, NULL, 'G3DSA:3.40.720.10:FF:000321', NULL, NULL, 'Iduronate-2-sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(119226, NULL, 'G3DSA:3.30.200.20:FF:002479', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(119227, NULL, 'G3DSA:3.30.160.60:FF:003931', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119228, NULL, 'G3DSA:1.20.1050.40:FF:000003', NULL, NULL, 'Oligopeptidase A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119229, NULL, 'G3DSA:1.25.40.10:FF:005055', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g20090', NULL, NULL, NULL, NULL, NULL, 4),
(119230, NULL, 'G3DSA:1.25.40.10:FF:005105', NULL, NULL, 'TPR domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(119231, NULL, 'G3DSA:3.40.120.10:FF:000005', NULL, NULL, 'Phosphoglucomutase 5', NULL, NULL, NULL, NULL, NULL, 4),
(119232, NULL, 'G3DSA:3.30.70.940:FF:000021', NULL, NULL, 'Transcription termination/antitermination protein NusG', NULL, NULL, NULL, NULL, NULL, 4),
(119233, NULL, 'G3DSA:1.10.238.10:FF:000124', NULL, NULL, 'Calpain-1 catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(119234, NULL, 'G3DSA:3.40.190.10:FF:000684', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119235, NULL, 'G3DSA:3.50.30.30:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119236, NULL, 'G3DSA:1.25.40.20:FF:001786', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(119237, NULL, 'G3DSA:3.30.710.10:FF:000087', NULL, NULL, 'Kelch-like family member 15', NULL, NULL, NULL, NULL, NULL, 4),
(119238, NULL, 'G3DSA:2.130.10.10:FF:002791', NULL, NULL, 'DDB1- and CUL4-associated factor 10', NULL, NULL, NULL, NULL, NULL, 4),
(119239, NULL, 'G3DSA:1.20.900.10:FF:000044', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(119240, NULL, 'G3DSA:3.50.50.60:FF:000578', NULL, NULL, 'FAD-dependent monooxygenase ausM', NULL, NULL, NULL, NULL, NULL, 4),
(119241, NULL, 'G3DSA:3.30.60.20:FF:000079', NULL, NULL, 'Heavy chain, Unconventional Myosin', NULL, NULL, NULL, NULL, NULL, 4),
(119242, NULL, 'G3DSA:3.40.50.10490:FF:000017', NULL, NULL, '40S ribosomal protein SA', NULL, NULL, NULL, NULL, NULL, 4),
(119243, NULL, 'G3DSA:4.10.900.10:FF:000017', NULL, NULL, 'Transcription factor 7 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(119244, NULL, 'G3DSA:3.10.20.90:FF:000688', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119245, NULL, 'G3DSA:3.40.50.720:FF:000562', NULL, NULL, 'Short-chain dehydrogenase/reductase SDR', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(119246, NULL, 'G3DSA:3.80.10.10:FF:000492', NULL, NULL, 'Si:dkey-16p6.1', NULL, NULL, NULL, NULL, NULL, 4),
(119247, NULL, 'G3DSA:1.20.900.10:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119248, NULL, 'G3DSA:1.25.40.180:FF:000222', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119249, NULL, 'G3DSA:3.40.50.1820:FF:000328', NULL, NULL, 'Alpha/beta fold hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(119250, NULL, 'G3DSA:3.20.20.10:FF:000040', NULL, NULL, 'Alanine racemase', NULL, NULL, NULL, NULL, NULL, 4),
(119251, NULL, 'G3DSA:3.40.1190.20:FF:000220', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119252, NULL, 'G3DSA:3.10.20.620:FF:000009', NULL, NULL, 'Autophagy protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(119253, NULL, 'G3DSA:3.30.160.60:FF:005842', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119254, NULL, 'G3DSA:1.10.486.10:FF:000060', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(119255, NULL, 'G3DSA:3.40.190.10:FF:000864', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119256, NULL, 'G3DSA:2.40.40.20:FF:000001', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(119257, NULL, 'G3DSA:2.60.120.380:FF:000050', NULL, NULL, 'Glycoside hydrolase family 3 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(119258, NULL, 'G3DSA:2.60.60.20:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119259, NULL, 'G3DSA:3.60.10.10:FF:000094', NULL, NULL, 'Sphingomyelin phosphodiesterase 2', NULL, NULL, NULL, NULL, NULL, 4),
(119260, NULL, 'G3DSA:3.80.10.10:FF:000722', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(119261, NULL, 'G3DSA:3.30.70.890:FF:000040', NULL, NULL, 'Mevalonate kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119262, NULL, 'G3DSA:3.30.40.10:FF:001423', NULL, NULL, 'Tripartite motif-containing 38', NULL, NULL, NULL, NULL, NULL, 4),
(119263, NULL, 'G3DSA:3.40.50.1820:FF:000508', NULL, NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(119264, NULL, 'G3DSA:3.30.2130.30:FF:000014', NULL, NULL, 'Putative RNA methylase', NULL, NULL, NULL, NULL, NULL, 4),
(119265, NULL, 'G3DSA:3.90.640.10:FF:000247', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(119266, NULL, 'G3DSA:3.30.160.60:FF:003818', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119267, NULL, 'G3DSA:3.30.420.10:FF:000328', NULL, NULL, 'GM25386', NULL, NULL, NULL, NULL, NULL, 4),
(119268, NULL, 'G3DSA:1.10.287.70:FF:000250', NULL, NULL, 'Small conductance calcium-activated potassium channel-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(119269, NULL, 'G3DSA:3.40.50.720:FF:001000', NULL, NULL, 'Gluconate 5-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(119270, NULL, 'G3DSA:3.40.50.10190:FF:000141', NULL, NULL, 'RNA Polymerase II CTD phosphatase Fcp1', NULL, NULL, NULL, NULL, NULL, 4),
(119271, NULL, 'G3DSA:1.10.510.10:FF:001573', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(119272, NULL, 'G3DSA:3.30.1330.30:FF:000091', NULL, NULL, 'Pelo protein', NULL, NULL, NULL, NULL, NULL, 4),
(119273, NULL, 'G3DSA:1.25.40.10:FF:004599', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119274, NULL, 'G3DSA:2.60.120.200:FF:000384', NULL, NULL, 'Crumbs family member 1, photoreceptor morphogenesis associated', NULL, NULL, NULL, NULL, NULL, 4),
(119275, NULL, 'G3DSA:1.10.287.2720:FF:000006', NULL, NULL, 'Similar to oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(119276, NULL, 'G3DSA:3.50.50.60:FF:000853', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(119277, NULL, 'G3DSA:2.40.70.10:FF:000567', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119278, NULL, 'G3DSA:3.60.20.10:FF:000117', NULL, NULL, 'Proteasome endopeptidase complex', NULL, NULL, NULL, NULL, NULL, 4),
(119279, NULL, 'G3DSA:3.30.420.10:FF:000547', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(119280, NULL, 'G3DSA:4.10.1240.10:FF:000020', NULL, NULL, 'Adhesion G protein-coupled receptor F3', NULL, NULL, NULL, NULL, NULL, 4),
(119281, NULL, 'G3DSA:1.25.40.20:FF:001842', NULL, NULL, 'AGAP003151-PA', NULL, NULL, NULL, NULL, NULL, 4),
(119282, NULL, 'G3DSA:1.20.920.10:FF:000039', NULL, NULL, 'Transcription initiation factor TFIID subunit', NULL, NULL, NULL, NULL, NULL, 4),
(119283, NULL, 'G3DSA:1.25.10.10:FF:001450', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119284, NULL, 'G3DSA:2.130.10.10:FF:001099', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(119285, NULL, 'G3DSA:2.20.100.10:FF:000147', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs gon-1', NULL, NULL, NULL, NULL, NULL, 4),
(119286, NULL, 'G3DSA:3.40.50.300:FF:002010', NULL, NULL, 'IstB-like ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(119287, NULL, 'G3DSA:1.20.1250.20:FF:002070', NULL, NULL, 'RH14816p', NULL, NULL, NULL, NULL, NULL, 4),
(119288, NULL, 'G3DSA:1.10.150.210:FF:000001', NULL, NULL, 'Phosphoserine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(119289, NULL, 'G3DSA:2.130.10.10:FF:002678', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119290, NULL, 'G3DSA:3.30.200.20:FF:001231', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 10', NULL, NULL, NULL, NULL, NULL, 4),
(119291, NULL, 'G3DSA:3.40.50.300:FF:000031', NULL, NULL, 'Eukaryotic initiation factor 4A-III', NULL, NULL, NULL, NULL, NULL, 4),
(119292, NULL, 'G3DSA:3.30.710.10:FF:000143', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(119293, NULL, 'G3DSA:3.40.220.10:FF:000007', NULL, NULL, 'O-acetyl-ADP-ribose deacetylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(119294, NULL, 'G3DSA:1.20.1560.10:FF:000544', NULL, NULL, 'ATP-binding cassette (ABC) transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119295, NULL, 'G3DSA:2.20.70.30:FF:000001', NULL, NULL, 'Transcription factor BTF3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(119296, NULL, 'G3DSA:3.30.170.10:FF:000005', NULL, NULL, 'Cyclin-dependent kinases regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(119297, NULL, 'G3DSA:3.40.20.10:FF:000051', NULL, NULL, 'Actin-depolymerizing factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(119298, NULL, 'G3DSA:3.30.160.60:FF:003190', NULL, NULL, 'zinc finger protein 235 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(119299, NULL, 'G3DSA:1.20.5.500:FF:000007', NULL, NULL, 'ATPase inhibitor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119300, NULL, 'G3DSA:1.20.58.60:FF:000736', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119301, NULL, 'G3DSA:1.20.1270.10:FF:000044', NULL, NULL, 'Heat shock 70 kDa protein BIP2', NULL, NULL, NULL, NULL, NULL, 4),
(119302, NULL, 'G3DSA:2.10.70.10:FF:000080', NULL, NULL, 'Membrane cofactor protein', NULL, NULL, NULL, NULL, NULL, 4),
(119303, NULL, 'G3DSA:3.30.160.60:FF:005281', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119304, NULL, 'G3DSA:3.40.1160.10:FF:000007', NULL, NULL, 'Carbamate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(119305, NULL, 'G3DSA:3.90.79.10:FF:000285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119306, NULL, 'G3DSA:3.30.70.2760:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119307, NULL, 'G3DSA:2.10.25.10:FF:000239', NULL, NULL, 'Sushi, nidogen and EGF-like domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(119308, NULL, 'G3DSA:3.30.1520.10:FF:000049', NULL, NULL, 'Vacuolar sorting protein VPS1', NULL, NULL, NULL, NULL, NULL, 4),
(119309, NULL, 'G3DSA:3.20.70.20:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119310, NULL, 'G3DSA:2.70.130.10:FF:000014', NULL, NULL, 'glucosidase 2 subunit beta isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(119311, NULL, 'G3DSA:3.40.190.10:FF:000807', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119312, NULL, 'G3DSA:3.40.50.150:FF:001582', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(119313, NULL, 'G3DSA:2.30.30.100:FF:000024', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm4', NULL, NULL, NULL, NULL, NULL, 4),
(119314, NULL, 'G3DSA:1.10.8.640:FF:000001', NULL, NULL, 'Cytochrome c-type biogenesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(119315, NULL, 'G3DSA:3.90.1760.10:FF:000002', NULL, NULL, 'Calmodulin-sensitive adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(119316, NULL, 'G3DSA:3.80.10.10:FF:004090', NULL, NULL, 'Brassinosteroid-insensitive 1', NULL, NULL, NULL, NULL, NULL, 4),
(119317, NULL, 'G3DSA:3.30.160.60:FF:001571', NULL, NULL, 'Zinc finger protein 687', NULL, NULL, NULL, NULL, NULL, 4),
(119318, NULL, 'G3DSA:1.25.40.10:FF:003200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119319, NULL, 'G3DSA:1.20.5.710:FF:000008', NULL, NULL, '50S ribosomal protein L7/L12', NULL, NULL, NULL, NULL, NULL, 4),
(119320, NULL, 'G3DSA:3.30.710.10:FF:000199', NULL, NULL, 'Blast:BTB/POZ domain-containing protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(119321, NULL, 'G3DSA:3.40.50.1820:FF:000660', NULL, NULL, 'ArylForMamiDase', NULL, NULL, NULL, NULL, NULL, 4),
(119322, NULL, 'G3DSA:1.20.58.1120:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119323, NULL, 'G3DSA:3.40.50.2300:FF:000883', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119324, NULL, 'G3DSA:2.10.70.10:FF:000023', NULL, NULL, 'protein kinase C-binding protein NELL2', NULL, NULL, NULL, NULL, NULL, 4),
(119325, NULL, 'G3DSA:1.20.5.700:FF:000005', NULL, NULL, 'Cytochrome b6-f complex iron-sulfur subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(119326, NULL, 'G3DSA:3.80.10.10:FF:002813', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(119327, NULL, 'G3DSA:1.20.58.2190:FF:000012', NULL, NULL, 'Wall-associated receptor kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(119328, NULL, 'G3DSA:2.60.120.330:FF:000131', NULL, NULL, 'Aspartate beta-hydroxylase domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(119329, NULL, 'G3DSA:3.40.50.1820:FF:001003', NULL, NULL, 'Lipase domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119330, NULL, 'G3DSA:3.30.160.60:FF:001514', NULL, NULL, 'Zinc finger protein 407', NULL, NULL, NULL, NULL, NULL, 4),
(119331, NULL, 'G3DSA:3.40.50.300:FF:007063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119332, NULL, 'G3DSA:3.40.50.300:FF:003752', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(119333, NULL, 'G3DSA:2.130.10.10:FF:005320', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119334, NULL, 'G3DSA:3.30.2230.10:FF:000010', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(119335, NULL, 'G3DSA:1.25.40.610:FF:000008', NULL, NULL, 'Adhesion G protein-coupled receptor F1', NULL, NULL, NULL, NULL, NULL, 4),
(119336, NULL, 'G3DSA:2.60.40.10:FF:004212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119337, NULL, 'G3DSA:3.50.7.10:FF:000083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119338, NULL, 'G3DSA:3.30.70.2750:FF:000003', NULL, NULL, 'V-type ATP synthase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(119339, NULL, 'G3DSA:3.30.200.20:FF:002299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119340, NULL, 'G3DSA:3.30.160.60:FF:003751', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119341, NULL, 'G3DSA:1.20.1250.20:FF:000776', NULL, NULL, 'Putative multidrug transporter', NULL, NULL, NULL, NULL, NULL, 4),
(119342, NULL, 'G3DSA:3.30.70.330:FF:002766', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119343, NULL, 'G3DSA:1.20.1070.10:FF:000675', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119344, NULL, 'G3DSA:1.20.58.1080:FF:000016', NULL, NULL, 'ATP-dependent RNA helicase suv3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(119345, NULL, 'G3DSA:3.40.50.1110:FF:000161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119346, NULL, 'G3DSA:1.20.1070.10:FF:000618', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(119347, NULL, 'G3DSA:3.30.40.10:FF:000928', NULL, NULL, 'Putative E3 ubiquitin-protein ligase UNKL', NULL, NULL, NULL, NULL, NULL, 4),
(119348, NULL, 'G3DSA:3.30.160.60:FF:001239', NULL, NULL, 'Zinc finger protein 615', NULL, NULL, NULL, NULL, NULL, 4),
(119349, NULL, 'G3DSA:3.40.47.10:FF:000258', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119350, NULL, 'G3DSA:3.40.50.720:FF:002304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119351, NULL, 'G3DSA:3.20.20.70:FF:000209', NULL, NULL, 'Deoxyribose-phosphate aldolase (putative)', NULL, NULL, NULL, NULL, NULL, 4),
(119352, NULL, 'G3DSA:3.30.470.10:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119353, NULL, 'G3DSA:4.10.240.10:FF:000006', NULL, NULL, 'Positive regulator of purine utilization', NULL, NULL, NULL, NULL, NULL, 4),
(119354, NULL, 'G3DSA:3.40.50.720:FF:002248', NULL, NULL, 'Putative dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(119355, NULL, 'G3DSA:3.30.1370.10:FF:000166', NULL, NULL, 'Vigilin 1', NULL, NULL, NULL, NULL, NULL, 4),
(119356, NULL, 'G3DSA:2.10.110.10:FF:000257', NULL, NULL, 'Transcription factor Lmx1b', NULL, NULL, NULL, NULL, NULL, 4),
(119357, NULL, 'G3DSA:3.40.50.2000:FF:000618', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119358, NULL, 'G3DSA:2.30.39.10:FF:000012', NULL, NULL, 'Serpin family E member 3', NULL, NULL, NULL, NULL, NULL, 4),
(119359, NULL, 'G3DSA:2.30.30.140:FF:000007', NULL, NULL, 'Lethal(3)malignant brain tumor-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(119360, NULL, 'G3DSA:2.30.42.10:FF:000536', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119361, NULL, 'G3DSA:3.80.10.10:FF:001796', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119362, NULL, 'G3DSA:3.40.50.12780:FF:000114', NULL, NULL, 'Aspergillus niger contig An11c0010, genomic contig', NULL, NULL, NULL, NULL, NULL, 4),
(119363, NULL, 'G3DSA:3.30.930.10:FF:000125', NULL, NULL, 'Prolyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(119364, NULL, 'G3DSA:3.30.230.10:FF:000117', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(119365, NULL, 'G3DSA:3.50.50.60:FF:001016', NULL, NULL, 'Salicylate hydroxylase, putative (AFU_orthologue AFUA_7G00590)', NULL, NULL, NULL, NULL, NULL, 4),
(119366, NULL, 'G3DSA:3.10.110.10:FF:000276', NULL, NULL, 'ubiquitin-conjugating enzyme E2 J1-like', NULL, NULL, NULL, NULL, NULL, 4),
(119367, NULL, 'G3DSA:3.40.50.150:FF:001543', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119368, NULL, 'G3DSA:1.10.10.60:FF:001088', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119369, NULL, 'G3DSA:2.130.10.10:FF:005045', NULL, NULL, 'Chromosome 12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(119370, NULL, 'G3DSA:1.10.472.10:FF:000567', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(119371, NULL, 'G3DSA:2.30.29.30:FF:001124', NULL, NULL, 'AGAP008316-PA', NULL, NULL, NULL, NULL, NULL, 4),
(119372, NULL, 'G3DSA:3.30.70.2050:FF:000001', NULL, NULL, 'Copper chaperone NosL', NULL, NULL, NULL, NULL, NULL, 4),
(119373, NULL, 'G3DSA:3.30.70.330:FF:001131', NULL, NULL, 'Putative RRM RNA binding protein NSAP1', NULL, NULL, NULL, NULL, NULL, 4),
(119374, NULL, 'G3DSA:3.30.70.330:FF:001417', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(119375, NULL, 'G3DSA:1.10.510.10:FF:002697', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119376, NULL, 'G3DSA:3.60.20.10:FF:000156', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119377, NULL, 'G3DSA:3.20.20.140:FF:000021', NULL, NULL, 'Guanine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(119378, NULL, 'G3DSA:1.25.40.470:FF:000039', NULL, NULL, 'Intraflagellar transport protein 80, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119379, NULL, 'G3DSA:1.20.1560.10:FF:000763', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119380, NULL, 'G3DSA:1.10.238.10:FF:001254', NULL, NULL, 'Calcium-binding protein F', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(119381, NULL, 'G3DSA:3.20.20.150:FF:000024', NULL, NULL, 'L-rhamnose isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(119382, NULL, 'G3DSA:2.60.40.10:FF:003594', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119383, NULL, 'G3DSA:3.40.1110.10:FF:000167', NULL, NULL, 'Probable cation-transporting P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(119384, NULL, 'G3DSA:3.30.470.20:FF:000048', NULL, NULL, 'D-alanine--D-alanine ligase family', NULL, NULL, NULL, NULL, NULL, 4),
(119385, NULL, 'G3DSA:3.10.20.620:FF:000010', NULL, NULL, 'Autophagy protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(119386, NULL, 'G3DSA:3.40.50.1820:FF:000840', NULL, NULL, 'LIPA isoform 8', NULL, NULL, NULL, NULL, NULL, 4),
(119387, NULL, 'G3DSA:1.20.120.1630:FF:000032', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(119388, NULL, 'G3DSA:3.10.450.50:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119389, NULL, 'G3DSA:1.10.8.1080:FF:000002', NULL, NULL, 'Glucokinase regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(119390, NULL, 'G3DSA:2.130.10.10:FF:001773', NULL, NULL, 'Striatin-4-like', NULL, NULL, NULL, NULL, NULL, 4),
(119391, NULL, 'G3DSA:3.40.50.720:FF:000449', NULL, NULL, 'Ubiquitin-activating enzyme (E1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(119392, NULL, 'G3DSA:1.10.510.10:FF:003714', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119393, NULL, 'G3DSA:1.10.238.10:FF:000978', NULL, NULL, 'Calcium-dependent protein kinase 25', NULL, NULL, NULL, NULL, NULL, 4),
(119394, NULL, 'G3DSA:3.40.50.300:FF:005444', NULL, NULL, 'Oligopeptide/dipeptide ABC transporter, ATPase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(119395, NULL, 'G3DSA:1.20.1250.20:FF:000720', NULL, NULL, 'Aflatoxin efflux pump AFLT, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119396, NULL, 'G3DSA:3.90.190.10:FF:000049', NULL, NULL, 'Dual specificity protein phosphatase 14', NULL, NULL, NULL, NULL, NULL, 4),
(119397, NULL, 'G3DSA:2.130.10.10:FF:001374', NULL, NULL, 'Unplaced genomic scaffold supercont2.8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(119398, NULL, 'G3DSA:3.30.200.20:FF:001175', NULL, NULL, 'STE20-related kinase adapter protein alpha isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(119399, NULL, 'G3DSA:3.60.130.10:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119400, NULL, 'G3DSA:2.60.40.150:FF:000478', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119401, NULL, 'G3DSA:2.60.40.10:FF:000789', NULL, NULL, 'Interleukin 12 receptor subunit beta 2', NULL, NULL, NULL, NULL, NULL, 4),
(119402, NULL, 'G3DSA:3.20.20.80:FF:000600', NULL, NULL, 'Novel protein similar to vertebrate hexosaminidase A (Alpha polypeptide) (HEXA)', NULL, NULL, NULL, NULL, NULL, 4),
(119403, NULL, 'G3DSA:3.30.420.40:FF:000202', NULL, NULL, 'pantothenate kinase 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(119404, NULL, 'G3DSA:3.40.50.300:FF:006568', NULL, NULL, 'Small GTPase RhoQ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119405, NULL, 'G3DSA:2.20.70.10:FF:000282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119406, NULL, 'G3DSA:2.30.29.30:FF:000904', NULL, NULL, 'insulin receptor substrate 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(119407, NULL, 'G3DSA:2.10.70.80:FF:000016', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(119408, NULL, 'G3DSA:3.90.640.10:FF:000028', NULL, NULL, 'Actin-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(119409, NULL, 'G3DSA:3.30.160.60:FF:001278', NULL, NULL, 'C2H2 finger domain protein FlbC', NULL, NULL, NULL, NULL, NULL, 4),
(119410, NULL, 'G3DSA:2.30.29.30:FF:000848', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119411, NULL, 'G3DSA:3.30.559.10:FF:000133', NULL, NULL, 'Nonribosomal peptide synthase GliP', NULL, NULL, NULL, NULL, NULL, 4),
(119412, NULL, 'G3DSA:2.60.40.10:FF:004499', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119413, NULL, 'G3DSA:2.130.10.10:FF:004769', NULL, NULL, 'WD repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(119414, NULL, 'G3DSA:3.40.605.10:FF:000020', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(119415, NULL, 'G3DSA:3.30.200.20:FF:001517', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(119416, NULL, 'G3DSA:1.20.1070.10:FF:000911', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119417, NULL, 'G3DSA:2.60.40.10:FF:001065', NULL, NULL, 'Immunoglobulin superfamily member 10', NULL, NULL, NULL, NULL, NULL, 4),
(119418, NULL, 'G3DSA:2.10.25.10:FF:001818', NULL, NULL, 'Sperm transmembrane protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(119419, NULL, 'G3DSA:3.40.30.10:FF:000551', NULL, NULL, 'Protein disulfide isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(119420, NULL, 'G3DSA:2.60.40.10:FF:005393', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119421, NULL, 'G3DSA:3.30.160.60:FF:005168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119422, NULL, 'G3DSA:3.40.850.10:FF:000364', NULL, NULL, 'Chitin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(119423, NULL, 'G3DSA:2.30.30.140:FF:000283', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(119424, NULL, 'G3DSA:4.10.110.10:FF:000002', NULL, NULL, 'Maltase-glucoamylase, intestinal', NULL, NULL, NULL, NULL, NULL, 4),
(119425, NULL, 'G3DSA:3.80.10.10:FF:003595', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119426, NULL, 'G3DSA:3.30.40.10:FF:002278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119427, NULL, 'G3DSA:3.30.470.20:FF:000104', NULL, NULL, 'ATP-grasp domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(119428, NULL, 'G3DSA:3.40.50.2000:FF:000675', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(119429, NULL, 'G3DSA:1.10.510.10:FF:002410', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119430, NULL, 'G3DSA:3.30.450.20:FF:000378', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(119431, NULL, 'G3DSA:2.60.40.10:FF:005336', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119432, NULL, 'G3DSA:1.20.120.420:FF:000016', NULL, NULL, 'Methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(119433, NULL, 'G3DSA:3.40.390.10:FF:000284', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119434, NULL, 'G3DSA:1.25.10.10:FF:002973', NULL, NULL, 'Beta-tubulin cofactor D family protein', NULL, NULL, NULL, NULL, NULL, 4),
(119435, NULL, 'G3DSA:1.10.472.10:FF:000680', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119436, NULL, 'G3DSA:3.30.200.20:FF:001118', NULL, NULL, 'Os07g0129900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(119437, NULL, 'G3DSA:3.60.130.10:FF:000024', NULL, NULL, 'Pentalenolactone F synthase', NULL, NULL, NULL, NULL, NULL, 4),
(119438, NULL, 'G3DSA:1.10.510.10:FF:000898', NULL, NULL, 'Cyclin-dependent kinase F-1', NULL, NULL, NULL, NULL, NULL, 4),
(119439, NULL, 'G3DSA:2.60.40.10:FF:003195', NULL, NULL, 'Immunoglobulin light 4 variable 9', NULL, NULL, NULL, NULL, NULL, 4),
(119440, NULL, 'G3DSA:3.90.190.10:FF:000162', NULL, NULL, 'Tyrosine-protein phosphatase vhp-1', NULL, NULL, NULL, NULL, NULL, 4),
(119441, NULL, 'G3DSA:3.90.190.10:FF:000105', NULL, NULL, 'Protein tyrosine phosphatase type IVA 3', NULL, NULL, NULL, NULL, NULL, 4),
(119442, NULL, 'G3DSA:3.20.20.100:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119443, NULL, 'G3DSA:3.40.50.200:FF:000001', NULL, NULL, 'Furin 2, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(119444, NULL, 'G3DSA:1.20.900.10:FF:000083', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF a', NULL, NULL, NULL, NULL, NULL, 4),
(119445, NULL, 'G3DSA:3.40.50.300:FF:004769', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(119446, NULL, 'G3DSA:3.40.390.10:FF:000227', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119447, NULL, 'G3DSA:2.40.128.180:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119448, NULL, 'G3DSA:3.30.2460.20:FF:000002', NULL, NULL, 'Protein Wnt', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(119449, NULL, 'G3DSA:1.10.1050.10:FF:000007', NULL, NULL, '30S ribosomal protein S4 B', NULL, NULL, NULL, NULL, NULL, 4),
(119450, NULL, 'G3DSA:1.25.40.180:FF:000166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119451, NULL, 'G3DSA:1.10.840.10:FF:000035', NULL, NULL, 'Drosophila SOS homolog', NULL, NULL, NULL, NULL, NULL, 4),
(119452, NULL, 'G3DSA:2.30.29.30:FF:000961', NULL, NULL, 'Exocyst complex component EXO84', NULL, NULL, NULL, NULL, NULL, 4),
(119453, NULL, 'G3DSA:2.70.170.10:FF:000011', NULL, NULL, 'Gamma-aminobutyric acid receptor subunit pi isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(119454, NULL, 'G3DSA:3.30.70.1230:FF:000261', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(119455, NULL, 'G3DSA:1.10.238.210:FF:000013', NULL, NULL, 'Ankyrin repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(119456, NULL, 'G3DSA:2.60.120.290:FF:000135', NULL, NULL, 'GD12774', NULL, NULL, NULL, NULL, NULL, 4),
(119457, NULL, 'G3DSA:3.30.160.60:FF:001391', NULL, NULL, 'Zinc finger protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(119458, NULL, 'G3DSA:3.40.50.800:FF:000029', NULL, NULL, 'Glycine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(119459, NULL, 'G3DSA:2.60.40.60:FF:000888', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119460, NULL, 'G3DSA:2.30.30.90:FF:000004', NULL, NULL, 'Ferrous iron transport protein B', NULL, NULL, NULL, NULL, NULL, 4),
(119461, NULL, 'G3DSA:3.20.20.80:FF:000325', NULL, NULL, 'GPI-anchored cell wall beta-1,3-endoglucanase EglC', NULL, NULL, NULL, NULL, NULL, 4),
(119462, NULL, 'G3DSA:2.130.10.10:FF:000879', NULL, NULL, 'Pre-mrna-splicing factor rse1', NULL, NULL, NULL, NULL, NULL, 4),
(119463, NULL, 'G3DSA:3.40.50.720:FF:002580', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(119464, NULL, 'G3DSA:1.20.120.1080:FF:000114', NULL, NULL, 'Putative deah-box rna helicase', NULL, NULL, NULL, NULL, NULL, 4),
(119465, NULL, 'G3DSA:1.20.1070.10:FF:002187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119466, NULL, 'G3DSA:1.10.238.200:FF:000010', NULL, NULL, 'Defective in cullin neddylation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(119467, NULL, 'G3DSA:1.20.1420.10:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119468, NULL, 'G3DSA:2.60.120.380:FF:000011', NULL, NULL, 'Calpain 12', NULL, NULL, NULL, NULL, NULL, 4),
(119469, NULL, 'G3DSA:3.40.30.10:FF:000113', NULL, NULL, 'ganglioside-induced differentiation-associated protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(119470, NULL, 'G3DSA:3.20.20.70:FF:000322', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(119471, NULL, 'G3DSA:3.30.930.10:FF:000182', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(119472, NULL, 'G3DSA:2.130.10.10:FF:005084', NULL, NULL, 'Cell division cycle protein cdt2', NULL, NULL, NULL, NULL, NULL, 4),
(119473, NULL, 'G3DSA:4.10.1000.10:FF:000036', NULL, NULL, 'Zinc finger CCCH domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(119474, NULL, 'G3DSA:3.30.450.20:FF:000491', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(119475, NULL, 'G3DSA:2.130.10.10:FF:005264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119476, NULL, 'G3DSA:3.30.565.10:FF:000299', NULL, NULL, 'Putative postmeiotic segregation increased 2-like protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(119477, NULL, 'G3DSA:2.10.25.140:FF:000002', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(119478, NULL, 'G3DSA:3.30.420.10:FF:000042', NULL, NULL, 'poly(A)-specific ribonuclease PARN', NULL, NULL, NULL, NULL, NULL, 4),
(119479, NULL, 'G3DSA:3.15.10.20:FF:000004', NULL, NULL, 'Hsp90 co-chaperone AHA1', NULL, NULL, NULL, NULL, NULL, 4),
(119480, NULL, 'G3DSA:1.10.1200.10:FF:000003', NULL, NULL, 'Acyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(119481, NULL, 'G3DSA:3.30.450.20:FF:000434', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(119482, NULL, 'G3DSA:3.80.10.10:FF:002291', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119483, NULL, 'G3DSA:3.80.10.10:FF:002577', NULL, NULL, 'Receptor-like protein kinase BRI1-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(119484, NULL, 'G3DSA:1.10.10.350:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119485, NULL, 'G3DSA:1.10.12.10:FF:000032', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(119486, NULL, 'G3DSA:1.25.40.570:FF:000013', NULL, NULL, 'Proteasome regulatory particle subunit (RpnG)', NULL, NULL, NULL, NULL, NULL, 4),
(119487, NULL, 'G3DSA:1.50.10.10:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119488, NULL, 'G3DSA:1.25.40.570:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119489, NULL, 'G3DSA:3.60.10.10:FF:000055', NULL, NULL, 'Putative calcium-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(119490, NULL, 'G3DSA:1.10.150.20:FF:000188', NULL, NULL, 'Restriction endonuclease type II-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(119491, NULL, 'G3DSA:3.80.10.10:FF:000902', NULL, NULL, 'F-box protein SKIP19', NULL, NULL, NULL, NULL, NULL, 4),
(119492, NULL, 'G3DSA:1.10.600.10:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119493, NULL, 'G3DSA:3.15.10.10:FF:000001', NULL, NULL, 'phospholipid transfer protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(119494, NULL, 'G3DSA:1.20.120.1320:FF:000001', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(119495, NULL, 'G3DSA:3.40.50.11840:FF:000012', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(119496, NULL, 'G3DSA:3.40.50.300:FF:005882', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(119497, NULL, 'G3DSA:3.40.50.2000:FF:000495', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(119498, NULL, 'G3DSA:1.10.287.1150:FF:000007', NULL, NULL, '2-oxoglutarate dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(119499, NULL, 'G3DSA:3.40.50.11850:FF:000015', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(119500, NULL, 'G3DSA:1.10.10.60:FF:000868', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119501, NULL, 'G3DSA:2.160.20.10:FF:000345', NULL, NULL, 'Protein CBG11506', NULL, NULL, NULL, NULL, NULL, 4),
(119502, NULL, 'G3DSA:2.60.120.290:FF:000192', NULL, NULL, 'AGAP005526-PA', NULL, NULL, NULL, NULL, NULL, 4),
(119503, NULL, 'G3DSA:4.10.410.10:FF:000042', NULL, NULL, 'CBN-MEC-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(119504, NULL, 'G3DSA:3.30.413.10:FF:000020', NULL, NULL, 'Sulfite reductase', NULL, NULL, NULL, NULL, NULL, 4),
(119505, NULL, 'G3DSA:3.40.50.410:FF:000238', NULL, NULL, 'TROVE domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(119506, NULL, 'G3DSA:1.10.10.10:FF:000140', NULL, NULL, 'Histone H1.0', NULL, NULL, NULL, NULL, NULL, 4),
(119507, NULL, 'G3DSA:3.15.10.30:FF:000007', NULL, NULL, 'GD18997', NULL, NULL, NULL, NULL, NULL, 4),
(119508, NULL, 'G3DSA:3.30.160.60:FF:005729', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119509, NULL, 'G3DSA:2.40.50.40:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119510, NULL, 'G3DSA:2.30.30.380:FF:000006', NULL, NULL, 'TGF-beta activated kinase 1 (MAP3K7) binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(119511, NULL, 'G3DSA:2.40.50.150:FF:000001', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(119512, NULL, 'G3DSA:2.30.29.30:FF:000562', NULL, NULL, 'Protein kinase D4', NULL, NULL, NULL, NULL, NULL, 4),
(119513, NULL, 'G3DSA:3.50.50.60:FF:001073', NULL, NULL, 'Putative lysine-specific histone demethylase 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(119514, NULL, 'G3DSA:3.20.20.10:FF:000001', NULL, NULL, 'Biosynthetic arginine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(119515, NULL, 'G3DSA:1.50.40.10:FF:000314', NULL, NULL, 'Mitochondrial carrier protein, putative (AFU_orthologue AFUA_4G06390)', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(119516, NULL, 'G3DSA:6.10.140.2220:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119517, NULL, 'G3DSA:1.25.40.10:FF:002469', NULL, NULL, 'Os08g0131000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(119518, NULL, 'G3DSA:2.30.30.370:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119519, NULL, 'G3DSA:2.60.40.10:FF:005516', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119520, NULL, 'G3DSA:3.30.70.330:FF:000693', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119521, NULL, 'G3DSA:1.10.510.10:FF:001393', NULL, NULL, 'Calmodulin-binding receptor kinase CaMRLK', NULL, NULL, NULL, NULL, NULL, 4),
(119522, NULL, 'G3DSA:2.60.120.10:FF:000235', NULL, NULL, 'Mannose-6-phosphate isomerase type 1', NULL, NULL, NULL, NULL, NULL, 4),
(119523, NULL, 'G3DSA:2.130.10.10:FF:004589', NULL, NULL, 'Inner dynein arm I1 intermediate chain IC140', NULL, NULL, NULL, NULL, NULL, 4),
(119524, NULL, 'G3DSA:1.10.238.10:FF:001198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119525, NULL, 'G3DSA:6.10.140.2220:FF:000013', NULL, NULL, 'N-lysine methyltransferase SMYD2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(119526, NULL, 'G3DSA:3.90.1520.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119527, NULL, 'G3DSA:3.20.20.70:FF:000541', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119528, NULL, 'G3DSA:3.30.505.10:FF:000014', NULL, NULL, 'Phosphatidylinositol 3-kinase regulatory subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(119529, NULL, 'G3DSA:1.10.1900.10:FF:000011', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(119530, NULL, 'G3DSA:1.25.10.10:FF:001337', NULL, NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(119531, NULL, 'G3DSA:2.40.37.10:FF:000035', NULL, NULL, 'Ornithine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(119532, NULL, 'G3DSA:3.60.10.10:FF:000330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119533, NULL, 'G3DSA:3.30.420.40:FF:000944', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119534, NULL, 'G3DSA:3.50.50.60:FF:000797', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(119535, NULL, 'G3DSA:3.90.190.10:FF:000381', NULL, NULL, 'Dual specificity phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(119536, NULL, 'G3DSA:1.25.10.10:FF:001394', NULL, NULL, 'Transportin 2', NULL, NULL, NULL, NULL, NULL, 4),
(119537, NULL, 'G3DSA:1.20.5.470:FF:000015', NULL, NULL, 'Argininosuccinate synthase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(119538, NULL, 'G3DSA:3.90.930.40:FF:000003', NULL, NULL, 'Cupin_superfamily_protein/Cupin-like_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(119539, NULL, 'G3DSA:3.60.15.10:FF:000083', NULL, NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(119540, NULL, 'G3DSA:3.40.930.10:FF:000022', NULL, NULL, 'Frv operon regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(119541, NULL, 'G3DSA:1.20.1280.50:FF:000034', NULL, NULL, 'Coronatine-insensitive protein homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(119542, NULL, 'G3DSA:3.40.50.300:FF:004988', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(119543, NULL, 'G3DSA:1.25.40.180:FF:000109', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(119544, NULL, 'G3DSA:3.30.70.330:FF:001530', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119545, NULL, 'G3DSA:3.40.50.10330:FF:000110', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(119546, NULL, 'G3DSA:3.20.20.80:FF:000544', NULL, NULL, 'Di-N-acetylchitobiase', NULL, NULL, NULL, NULL, NULL, 4),
(119547, NULL, 'G3DSA:1.20.1070.10:FF:000170', NULL, NULL, 'Free fatty acid receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(119548, NULL, 'G3DSA:1.20.970.10:FF:000031', NULL, NULL, 'Pyrimidine-nucleoside phosphorylase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(119549, NULL, 'G3DSA:1.10.10.60:FF:001144', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119550, NULL, 'G3DSA:2.130.10.10:FF:001155', NULL, NULL, 'UTP13p Nucleolar protein', NULL, NULL, NULL, NULL, NULL, 4),
(119551, NULL, 'G3DSA:3.40.50.300:FF:001554', NULL, NULL, 'Translation elongation factor Tu', NULL, NULL, NULL, NULL, NULL, 4),
(119552, NULL, 'G3DSA:3.30.40.10:FF:000423', NULL, NULL, 'Ring finger protein 122', NULL, NULL, NULL, NULL, NULL, 4),
(119553, NULL, 'G3DSA:2.160.10.30:FF:000002', NULL, NULL, 'UTP--glucose-1-phosphate uridylyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119554, NULL, 'G3DSA:3.40.50.80:FF:000146', NULL, NULL, 'NADPH--cytochrome P450 reductase 2', NULL, NULL, NULL, NULL, NULL, 4),
(119555, NULL, 'G3DSA:2.10.25.10:FF:001695', NULL, NULL, 'Adhesion G protein-coupled receptor E1', NULL, NULL, NULL, NULL, NULL, 4),
(119556, NULL, 'G3DSA:2.130.10.10:FF:004792', NULL, NULL, 'Protein phosphatase PP2A regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(119557, NULL, 'G3DSA:3.40.50.1950:FF:000002', NULL, NULL, 'Coenzyme A biosynthesis bifunctional protein CoaBC', NULL, NULL, NULL, NULL, NULL, 4),
(119558, NULL, 'G3DSA:1.20.58.60:FF:000753', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119559, NULL, 'G3DSA:3.90.1170.40:FF:000016', NULL, NULL, 'Molybdopterin synthase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(119560, NULL, 'G3DSA:1.10.287.570:FF:000006', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(119561, NULL, 'G3DSA:2.70.98.10:FF:000079', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(119562, NULL, 'G3DSA:1.25.40.180:FF:000082', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(119563, NULL, 'G3DSA:3.40.800.20:FF:000021', NULL, NULL, 'histone deacetylase 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(119564, NULL, 'G3DSA:3.30.160.20:FF:000058', NULL, NULL, 'Small RNA 2', NULL, NULL, NULL, NULL, NULL, 4),
(119565, NULL, 'G3DSA:4.10.280.10:FF:000126', NULL, NULL, 'Protein WBSCR14 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(119566, NULL, 'G3DSA:3.40.50.10330:FF:000031', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(119567, NULL, 'G3DSA:1.10.8.60:FF:000070', NULL, NULL, 'DNA polymerase clamp loader subunit', NULL, NULL, NULL, NULL, NULL, 4),
(119568, NULL, 'G3DSA:3.30.70.100:FF:000073', NULL, NULL, 'NIPSNAP', NULL, NULL, NULL, NULL, NULL, 4),
(119569, NULL, 'G3DSA:1.20.1310.10:FF:000099', NULL, NULL, 'SCF ubiquitin ligase subunit CulC, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119570, NULL, 'G3DSA:1.10.8.10:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119571, NULL, 'G3DSA:3.40.50.10190:FF:000163', NULL, NULL, 'BRCT domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(119572, NULL, 'G3DSA:1.10.510.10:FF:003725', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119573, NULL, 'G3DSA:2.40.40.20:FF:000017', NULL, NULL, 'Formate dehydrogenase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(119574, NULL, 'G3DSA:1.20.5.990:FF:000002', NULL, NULL, 'Optineurin', NULL, NULL, NULL, NULL, NULL, 4),
(119575, NULL, 'G3DSA:2.30.30.230:FF:000001', NULL, NULL, 'Fumarylacetoacetase', NULL, NULL, NULL, NULL, NULL, 4),
(119576, NULL, 'G3DSA:1.20.5.110:FF:000334', NULL, NULL, 'Synaptobrevin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(119577, NULL, 'G3DSA:1.20.5.170:FF:000245', NULL, NULL, 'FBJ murine osteosarcoma viral oncogene homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(119578, NULL, 'G3DSA:3.10.400.20:FF:000008', NULL, NULL, 'RNA binding protein Ligatin/Tma64, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119579, NULL, 'G3DSA:3.30.70.330:FF:001013', NULL, NULL, 'TIA-1/TIAL RNA binding protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(119580, NULL, 'G3DSA:3.60.110.10:FF:000085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119581, NULL, 'G3DSA:3.90.1170.50:FF:000019', NULL, NULL, 'Isoquinoline 1-oxidoreductase, beta subunit, putative', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(119582, NULL, 'G3DSA:3.40.50.300:FF:006787', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119583, NULL, 'G3DSA:3.40.50.2000:FF:000456', NULL, NULL, 'Glycosyltransferase family 9 protein', NULL, NULL, NULL, NULL, NULL, 4),
(119584, NULL, 'G3DSA:1.25.40.470:FF:000062', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(119585, NULL, 'G3DSA:2.30.30.140:FF:000316', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(119586, NULL, 'G3DSA:3.40.50.300:FF:001953', NULL, NULL, 'ATP-dependent RNA helicase DBP1', NULL, NULL, NULL, NULL, NULL, 4),
(119587, NULL, 'G3DSA:3.80.10.10:FF:002824', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(119588, NULL, 'G3DSA:3.40.50.12780:FF:000081', NULL, NULL, 'Possible fatty-acid-CoA ligase fadD10', NULL, NULL, NULL, NULL, NULL, 4),
(119589, NULL, 'G3DSA:1.10.600.10:FF:000091', NULL, NULL, 'Os05g0235701 protein', NULL, NULL, NULL, NULL, NULL, 4),
(119590, NULL, 'G3DSA:2.120.10.30:FF:000285', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM71', NULL, NULL, NULL, NULL, NULL, 4),
(119591, NULL, 'G3DSA:3.40.50.720:FF:002169', NULL, NULL, 'Os08g0516100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(119592, NULL, 'G3DSA:3.40.309.10:FF:000039', NULL, NULL, 'Aldehyde dehydrogenase ALDC', NULL, NULL, NULL, NULL, NULL, 4),
(119593, NULL, 'G3DSA:3.40.50.300:FF:003561', NULL, NULL, 'ras-related protein Rab-22A', NULL, NULL, NULL, NULL, NULL, 4),
(119594, NULL, 'G3DSA:1.25.10.10:FF:001517', NULL, NULL, 'Formin-H', NULL, NULL, NULL, NULL, NULL, 4),
(119595, NULL, 'G3DSA:1.10.472.10:FF:000556', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(119596, NULL, 'G3DSA:1.20.1280.50:FF:000051', NULL, NULL, 'F-box and WD-40 domain-containing protein MET30', NULL, NULL, NULL, NULL, NULL, 4),
(119597, NULL, 'G3DSA:1.20.58.400:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119598, NULL, 'G3DSA:1.10.540.10:FF:000001', NULL, NULL, 'Very long-chain-specific acyl-CoA dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(119599, NULL, 'G3DSA:3.50.50.60:FF:001331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119600, NULL, 'G3DSA:3.30.450.20:FF:000294', NULL, NULL, 'GGDEF domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(119601, NULL, 'G3DSA:3.40.50.10490:FF:000146', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119602, NULL, 'G3DSA:1.25.10.10:FF:003125', NULL, NULL, 'HEAT repeat-containing protein 2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(119603, NULL, 'G3DSA:2.40.50.140:FF:001190', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119604, NULL, 'G3DSA:1.20.120.550:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119605, NULL, 'G3DSA:2.130.10.10:FF:003690', NULL, NULL, 'F-box and WD domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119606, NULL, 'G3DSA:2.60.120.680:FF:000005', NULL, NULL, 'Golgi resident protein GCP60', NULL, NULL, NULL, NULL, NULL, 4),
(119607, NULL, 'G3DSA:3.90.340.10:FF:000016', NULL, NULL, 'Nitric oxide synthase, inducible', NULL, NULL, NULL, NULL, NULL, 4),
(119608, NULL, 'G3DSA:3.30.160.60:FF:003156', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(119609, NULL, 'G3DSA:3.30.110.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119610, NULL, 'G3DSA:1.25.40.10:FF:001019', NULL, NULL, 'ATPase expression protein', NULL, NULL, NULL, NULL, NULL, 4),
(119611, NULL, 'G3DSA:1.20.1070.10:FF:000916', NULL, NULL, 'Olfactory receptor 893', NULL, NULL, NULL, NULL, NULL, 4),
(119612, NULL, 'G3DSA:1.25.40.20:FF:001511', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119613, NULL, 'G3DSA:3.80.10.10:FF:004432', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119614, NULL, 'G3DSA:3.40.50.720:FF:001989', NULL, NULL, 'Short chain dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(119615, NULL, 'G3DSA:2.40.160.20:FF:000003', NULL, NULL, 'Outer membrane protein A', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(119616, NULL, 'G3DSA:3.30.559.10:FF:000239', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(119617, NULL, 'G3DSA:2.10.25.10:FF:000700', NULL, NULL, 'Basement membrane proteoglycan', NULL, NULL, NULL, NULL, NULL, 4),
(119618, NULL, 'G3DSA:3.40.50.300:FF:002133', NULL, NULL, 'Ras family protein', NULL, NULL, NULL, NULL, NULL, 4),
(119619, NULL, 'G3DSA:1.10.357.140:FF:000035', NULL, NULL, 'UbiA prenyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(119620, NULL, 'G3DSA:3.60.10.10:FF:000217', NULL, NULL, 'Sphingomyelinase DDB_G0288017', NULL, NULL, NULL, NULL, NULL, 4),
(119621, NULL, 'G3DSA:1.25.10.10:FF:003451', NULL, NULL, 'Splicing factor subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119622, NULL, 'G3DSA:1.20.1740.10:FF:000226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119623, NULL, 'G3DSA:3.40.1160.10:FF:000041', NULL, NULL, 'Glutamate 5-kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119624, NULL, 'G3DSA:3.30.70.330:FF:002957', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119625, NULL, 'G3DSA:1.10.287.2720:FF:000001', NULL, NULL, 'Oxysterol-binding OBPalpha', NULL, NULL, NULL, NULL, NULL, 4),
(119626, NULL, 'G3DSA:3.40.50.300:FF:007260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119627, NULL, 'G3DSA:2.30.42.10:FF:000267', NULL, NULL, 'Protein CBR-STN-1', NULL, NULL, NULL, NULL, NULL, 4),
(119628, NULL, 'G3DSA:1.20.120.1080:FF:000041', NULL, NULL, 'RNA HelicAse', NULL, NULL, NULL, NULL, NULL, 4),
(119629, NULL, 'G3DSA:1.10.10.60:FF:000756', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119630, NULL, 'G3DSA:4.10.240.10:FF:000017', NULL, NULL, 'Transcriptional regulator UME6', NULL, NULL, NULL, NULL, NULL, 4),
(119631, NULL, 'G3DSA:1.20.1250.20:FF:000501', NULL, NULL, 'Multidrug resistance protein B', NULL, NULL, NULL, NULL, NULL, 4),
(119632, NULL, 'G3DSA:1.10.10.10:FF:001680', NULL, NULL, 'Winged helix-turn-helix transcriptional regulator, Rrf2 family', NULL, NULL, NULL, NULL, NULL, 4),
(119633, NULL, 'G3DSA:3.40.710.10:FF:000039', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(119634, NULL, 'G3DSA:2.10.109.10:FF:000046', NULL, NULL, 'Mitochondrial inner membrane protease subunit', NULL, NULL, NULL, NULL, NULL, 4),
(119635, NULL, 'G3DSA:1.25.40.20:FF:001348', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119636, NULL, 'G3DSA:2.60.40.10:FF:003077', NULL, NULL, 'Sensory AXon guidance', NULL, NULL, NULL, NULL, NULL, 4),
(119637, NULL, 'G3DSA:3.90.180.10:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119638, NULL, 'G3DSA:2.60.60.20:FF:000063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119639, NULL, 'G3DSA:2.40.50.140:FF:000728', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119640, NULL, 'G3DSA:3.40.50.300:FF:003235', NULL, NULL, 'ABC transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(119641, NULL, 'G3DSA:1.25.40.10:FF:001345', NULL, NULL, 'ETO1-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(119642, NULL, 'G3DSA:1.10.10.60:FF:001099', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119643, NULL, 'G3DSA:1.10.486.10:FF:000043', NULL, NULL, 'ATP-dependent DNA helicase UvrD', NULL, NULL, NULL, NULL, NULL, 4),
(119644, NULL, 'G3DSA:3.30.160.60:FF:003835', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119645, NULL, 'G3DSA:2.30.29.30:FF:000770', NULL, NULL, 'Sprouty-related, EVH1 domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(119646, NULL, 'G3DSA:2.60.120.200:FF:000367', NULL, NULL, 'Laminin, alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(119647, NULL, 'G3DSA:1.20.58.60:FF:000118', NULL, NULL, 'Dystrophin', NULL, NULL, NULL, NULL, NULL, 4),
(119648, NULL, 'G3DSA:3.30.160.60:FF:001711', NULL, NULL, 'Flt3-interacting zinc finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(119649, NULL, 'G3DSA:1.10.4160.10:FF:000016', NULL, NULL, 'Purine-cytosine related permease', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(119650, NULL, 'G3DSA:3.80.10.10:FF:001998', NULL, NULL, 'Toll-like receptor 22', NULL, NULL, NULL, NULL, NULL, 4),
(119651, NULL, 'G3DSA:1.10.238.10:FF:001029', NULL, NULL, 'Myosin regulatory light chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(119652, NULL, 'G3DSA:2.60.40.10:FF:005005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119653, NULL, 'G3DSA:2.60.120.380:FF:000022', NULL, NULL, 'AGAP012066-PA', NULL, NULL, NULL, NULL, NULL, 4),
(119654, NULL, 'G3DSA:3.80.10.10:FF:004269', NULL, NULL, 'Mesoderm induction early response, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119655, NULL, 'G3DSA:4.10.400.10:FF:000215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119656, NULL, 'G3DSA:1.20.1560.10:FF:000454', NULL, NULL, 'HlyB/MsbA family ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(119657, NULL, 'G3DSA:3.30.9.10:FF:000300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119658, NULL, 'G3DSA:3.30.40.10:FF:000951', NULL, NULL, 'Blast:SEC23-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(119659, NULL, 'G3DSA:3.10.20.770:FF:000004', NULL, NULL, 'Phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit beta isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(119660, NULL, 'G3DSA:3.40.50.300:FF:001627', NULL, NULL, 'Nuclear DNA helicase II', NULL, NULL, NULL, NULL, NULL, 4),
(119661, NULL, 'G3DSA:2.20.100.10:FF:000018', NULL, NULL, 'Thrombospondin type 1 domain containing 7A', NULL, NULL, NULL, NULL, NULL, 4),
(119662, NULL, 'G3DSA:3.40.50.1370:FF:000042', NULL, NULL, 'Ornithine carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(119663, NULL, 'G3DSA:3.90.190.10:FF:000425', NULL, NULL, 'Conserved expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(119664, NULL, 'G3DSA:3.40.50.1010:FF:000029', NULL, NULL, 'DNA repair protein UVH3', NULL, NULL, NULL, NULL, NULL, 4),
(119665, NULL, 'G3DSA:3.80.10.10:FF:002178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119666, NULL, 'G3DSA:1.10.1740.10:FF:000032', NULL, NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(119667, NULL, 'G3DSA:1.10.510.10:FF:001590', NULL, NULL, 'STE family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(119668, NULL, 'G3DSA:3.30.70.330:FF:000833', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(119669, NULL, 'G3DSA:2.60.40.10:FF:001262', NULL, NULL, 'Immunoglobulin superfamily member 10', NULL, NULL, NULL, NULL, NULL, 4),
(119670, NULL, 'G3DSA:2.60.220.50:FF:000075', NULL, NULL, 'Putative class b secretin-like g-protein coupled receptor gprcir1', NULL, NULL, NULL, NULL, NULL, 4),
(119671, NULL, 'G3DSA:1.10.630.10:FF:000446', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119672, NULL, 'G3DSA:1.10.287.70:FF:000008', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(119673, NULL, 'G3DSA:3.40.50.720:FF:002506', NULL, NULL, 'Probable polyketide synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(119674, NULL, 'G3DSA:1.10.238.10:FF:000849', NULL, NULL, 'EF-hand superfamily Ca2+-modulated protein (AFU_orthologue AFUA_5G13630)', NULL, NULL, NULL, NULL, NULL, 4),
(119675, NULL, 'G3DSA:2.130.10.10:FF:001447', NULL, NULL, 'Nucleoporin NUP159', NULL, NULL, NULL, NULL, NULL, 4),
(119676, NULL, 'G3DSA:3.80.10.10:FF:000380', NULL, NULL, 'Putative inactive leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(119677, NULL, 'G3DSA:3.40.50.410:FF:000249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119678, NULL, 'G3DSA:3.40.720.10:FF:000130', NULL, NULL, 'GPI ethanolamine phosphate transferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(119679, NULL, 'G3DSA:1.10.40.70:FF:000002', NULL, NULL, 'Type II secretion system protein', NULL, NULL, NULL, NULL, NULL, 4),
(119680, NULL, 'G3DSA:3.40.630.10:FF:000477', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119681, NULL, 'G3DSA:3.90.105.20:FF:000001', NULL, NULL, '60S acidic ribosomal protein P0', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(119682, NULL, 'G3DSA:1.20.58.60:FF:000427', NULL, NULL, 'Nesprin-2', NULL, NULL, NULL, NULL, NULL, 4),
(119683, NULL, 'G3DSA:1.25.10.10:FF:001197', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(119684, NULL, 'G3DSA:1.10.10.10:FF:001045', NULL, NULL, 'ELL complex EAP30 subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119685, NULL, 'G3DSA:1.10.510.10:FF:001264', NULL, NULL, 'Putative serine/threonine-protein kinase C01C4.3', NULL, NULL, NULL, NULL, NULL, 4),
(119686, NULL, 'G3DSA:3.60.40.10:FF:000371', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119687, NULL, 'G3DSA:2.60.120.200:FF:000693', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(119688, NULL, 'G3DSA:2.10.25.10:FF:000054', NULL, NULL, 'Slit guidance ligand 2', NULL, NULL, NULL, NULL, NULL, 4),
(119689, NULL, 'G3DSA:3.40.50.2000:FF:000826', NULL, NULL, 'Sucrose synthase 3', NULL, NULL, NULL, NULL, NULL, 4),
(119690, NULL, 'G3DSA:2.60.40.10:FF:000160', NULL, NULL, 'Titin a', NULL, NULL, NULL, NULL, NULL, 4),
(119691, NULL, 'G3DSA:2.130.10.10:FF:000767', NULL, NULL, 'WD repeat-containing protein 65', NULL, NULL, NULL, NULL, NULL, 4),
(119692, NULL, 'G3DSA:2.30.30.1020:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119693, NULL, 'G3DSA:3.40.718.10:FF:000068', NULL, NULL, 'Isocitrate dehydrogenase [NADP]', NULL, NULL, NULL, NULL, NULL, 4),
(119694, NULL, 'G3DSA:3.40.390.10:FF:000295', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119695, NULL, 'G3DSA:2.10.70.10:FF:000113', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(119696, NULL, 'G3DSA:3.40.50.360:FF:000083', NULL, NULL, 'NADPH-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(119697, NULL, 'G3DSA:3.30.1330.40:FF:000009', NULL, NULL, 'Endoribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(119698, NULL, 'G3DSA:1.25.10.10:FF:001208', NULL, NULL, 'Sister chromatid cohesion protein PDS5 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(119699, NULL, 'G3DSA:3.40.1110.10:FF:000313', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119700, NULL, 'G3DSA:3.30.40.10:FF:000625', NULL, NULL, 'E3 ubiquitin ligase Rnf157', NULL, NULL, NULL, NULL, NULL, 4),
(119701, NULL, 'G3DSA:2.30.29.30:FF:000118', NULL, NULL, 'GULP PTB domain containing engulfment adaptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(119702, NULL, 'G3DSA:3.30.160.60:FF:005073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119703, NULL, 'G3DSA:3.30.70.330:FF:002278', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119704, NULL, 'G3DSA:3.10.100.10:FF:000399', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119705, NULL, 'G3DSA:3.40.50.300:FF:000216', NULL, NULL, 'Type VII secretion ATPase EccA', NULL, NULL, NULL, NULL, NULL, 4),
(119706, NULL, 'G3DSA:3.10.250.10:FF:000044', NULL, NULL, 'Protein bark beetle', NULL, NULL, NULL, NULL, NULL, 4),
(119707, NULL, 'G3DSA:3.30.1240.10:FF:000038', NULL, NULL, 'Cof-like hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(119708, NULL, 'G3DSA:3.30.450.20:FF:000614', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119709, NULL, 'G3DSA:3.40.630.30:FF:000550', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(119710, NULL, 'G3DSA:1.20.5.100:FF:000005', NULL, NULL, 'Penicillin-binding protein 1b', NULL, NULL, NULL, NULL, NULL, 4),
(119711, NULL, 'G3DSA:3.30.1330.30:FF:000006', NULL, NULL, 'Peptide chain release factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(119712, NULL, 'G3DSA:3.30.430.20:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119713, NULL, 'G3DSA:3.30.1330.20:FF:000003', NULL, NULL, 'Tubulin gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(119714, NULL, 'G3DSA:1.20.5.110:FF:000008', NULL, NULL, 'Syntaxin 132', NULL, NULL, NULL, NULL, NULL, 4),
(119715, NULL, 'G3DSA:2.60.40.10:FF:001469', NULL, NULL, 'protein sidekick isoform X9', NULL, NULL, NULL, NULL, NULL, 4),
(119716, NULL, 'G3DSA:2.40.50.90:FF:000168', NULL, NULL, 'Tudor domain containing protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(119717, NULL, 'G3DSA:3.30.70.330:FF:000496', NULL, NULL, 'RNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(119718, NULL, 'G3DSA:3.30.70.1020:FF:000001', NULL, NULL, 'Alpha,alpha-trehalose-phosphate synthase [UDP-forming] 1', NULL, NULL, NULL, NULL, NULL, 4),
(119719, NULL, 'G3DSA:2.60.120.200:FF:000704', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119720, NULL, 'G3DSA:3.90.660.10:FF:000063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119721, NULL, 'G3DSA:1.10.10.2330:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119722, NULL, 'G3DSA:1.20.1250.10:FF:000009', NULL, NULL, 'Growth hormone', NULL, NULL, NULL, NULL, NULL, 4),
(119723, NULL, 'G3DSA:1.10.10.10:FF:001354', NULL, NULL, 'Putative disease resistance protein At3g14460', NULL, NULL, NULL, NULL, NULL, 4),
(119724, NULL, 'G3DSA:1.10.287.130:FF:000077', NULL, NULL, 'Sensor histidine kinase SaeS', NULL, NULL, NULL, NULL, NULL, 4),
(119725, NULL, 'G3DSA:2.70.170.10:FF:000298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119726, NULL, 'G3DSA:3.40.470.10:FF:000020', NULL, NULL, 'Type-5 uracil-DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(119727, NULL, 'G3DSA:3.100.10.10:FF:000017', NULL, NULL, 'Mrpl10p', NULL, NULL, NULL, NULL, NULL, 4),
(119728, NULL, 'G3DSA:2.30.40.10:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119729, NULL, 'G3DSA:3.40.50.300:FF:003870', NULL, NULL, 'Putative elongator complex protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(119730, NULL, 'G3DSA:3.80.10.10:FF:000907', NULL, NULL, 'Volume-regulated anion channel subunit LRRC8E isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(119731, NULL, 'G3DSA:1.20.1560.10:FF:000780', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119732, NULL, 'G3DSA:1.20.1050.130:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119733, NULL, 'G3DSA:3.40.1190.20:FF:000181', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119734, NULL, 'G3DSA:3.40.1690.20:FF:000011', NULL, NULL, 'ParaPleGiN AAA protease family', NULL, NULL, NULL, NULL, NULL, 4),
(119735, NULL, 'G3DSA:1.20.1720.10:FF:000017', NULL, NULL, 'Drug resistance MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(119736, NULL, 'G3DSA:2.130.10.10:FF:003701', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119737, NULL, 'G3DSA:3.30.200.20:FF:000585', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(119738, NULL, 'G3DSA:1.20.1250.20:FF:002255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119739, NULL, 'G3DSA:3.30.559.10:FF:000195', NULL, NULL, 'At5g02890', NULL, NULL, NULL, NULL, NULL, 4),
(119740, NULL, 'G3DSA:3.30.70.1320:FF:000001', NULL, NULL, 'Efflux pump membrane transporter', NULL, NULL, NULL, NULL, NULL, 4),
(119741, NULL, 'G3DSA:1.20.1270.60:FF:000126', NULL, NULL, 'SIP3p Transcription cofactor', NULL, NULL, NULL, NULL, NULL, 4),
(119742, NULL, 'G3DSA:1.25.40.10:FF:002789', NULL, NULL, 'U3 small nucleolar RNA-associated protein 6 homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(119743, NULL, 'G3DSA:3.30.420.40:FF:000798', NULL, NULL, 'Major actin', NULL, NULL, NULL, NULL, NULL, 4),
(119744, NULL, 'G3DSA:1.10.840.10:FF:000046', NULL, NULL, 'Phospholipase C epsilon, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119745, NULL, 'G3DSA:3.30.450.20:FF:000305', NULL, NULL, 'GGDEF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(119746, NULL, 'G3DSA:1.10.275.20:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119747, NULL, 'G3DSA:2.60.40.10:FF:003723', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119748, NULL, 'G3DSA:1.20.58.340:FF:000043', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(119749, NULL, 'G3DSA:2.30.230.10:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119750, NULL, 'G3DSA:2.10.25.10:FF:000363', NULL, NULL, 'Meprin A subunit', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(119751, NULL, 'G3DSA:3.80.10.10:FF:002471', NULL, NULL, 'Probable serine/threonine-protein kinase roco4', NULL, NULL, NULL, NULL, NULL, 4),
(119752, NULL, 'G3DSA:3.30.390.30:FF:000033', NULL, NULL, 'Putative pyridine nucleotide-disulfide oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(119753, NULL, 'G3DSA:3.30.479.20:FF:000051', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(119754, NULL, 'G3DSA:1.20.950.20:FF:000016', NULL, NULL, 'Formate dehydrogenase-N subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(119755, NULL, 'G3DSA:3.20.20.140:FF:000015', NULL, NULL, 'CAD protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(119756, NULL, 'G3DSA:3.20.20.150:FF:000018', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(119757, NULL, 'G3DSA:1.25.10.10:FF:002299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119758, NULL, 'G3DSA:3.20.20.140:FF:000324', NULL, NULL, 'Dihydroorotase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119759, NULL, 'G3DSA:1.10.3660.10:FF:000009', NULL, NULL, 'Prephenate dehydrogenase tyrA', NULL, NULL, NULL, NULL, NULL, 4),
(119760, NULL, 'G3DSA:3.30.230.10:FF:000084', NULL, NULL, 'Diphosphomevalonate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(119761, NULL, 'G3DSA:2.60.40.10:FF:001941', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(119762, NULL, 'G3DSA:1.10.510.10:FF:003416', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119763, NULL, 'G3DSA:3.50.50.60:FF:000516', NULL, NULL, 'FAD-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(119764, NULL, 'G3DSA:2.40.50.700:FF:000003', NULL, NULL, 'DIS3-like exonuclease 2', NULL, NULL, NULL, NULL, NULL, 4),
(119765, NULL, 'G3DSA:3.60.20.10:FF:000145', NULL, NULL, 'Proteasome subunit alpha type', NULL, NULL, NULL, NULL, NULL, 4),
(119766, NULL, 'G3DSA:3.50.50.60:FF:000825', NULL, NULL, 'Sll0703 protein', NULL, NULL, NULL, NULL, NULL, 4),
(119767, NULL, 'G3DSA:1.10.10.10:FF:000865', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(119768, NULL, 'G3DSA:2.30.39.10:FF:000040', NULL, NULL, 'Serpin peptidase inhibitor 7', NULL, NULL, NULL, NULL, NULL, 4),
(119769, NULL, 'G3DSA:3.30.470.20:FF:000177', NULL, NULL, 'Tubulin-tyrosine ligase family-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(119770, NULL, 'G3DSA:3.50.50.60:FF:001005', NULL, NULL, 'Lysine-specific histone demethylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(119771, NULL, 'G3DSA:3.30.160.60:FF:003509', NULL, NULL, 'Zinc finger protein 829', NULL, NULL, NULL, NULL, NULL, 4),
(119772, NULL, 'G3DSA:1.10.275.10:FF:000013', NULL, NULL, 'Argininosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(119773, NULL, 'G3DSA:3.40.50.720:FF:002495', NULL, NULL, 'UDP-glucose 4-epimerase 4', NULL, NULL, NULL, NULL, NULL, 4),
(119774, NULL, 'G3DSA:2.40.420.20:FF:000041', NULL, NULL, 'RND efflux membrane fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(119775, NULL, 'G3DSA:3.40.1030.10:FF:000003', NULL, NULL, 'Pyrimidine-nucleoside phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(119776, NULL, 'G3DSA:1.10.1040.10:FF:000041', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(119777, NULL, 'G3DSA:6.10.140.2220:FF:000002', NULL, NULL, 'Protein kinase C-binding protein 1 isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(119778, NULL, 'G3DSA:3.90.640.10:FF:000180', NULL, NULL, 'Actin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119779, NULL, 'G3DSA:3.40.50.720:FF:000354', NULL, NULL, 'UDP-galactopyranose mutase', NULL, NULL, NULL, NULL, NULL, 4),
(119780, NULL, 'G3DSA:3.30.420.40:FF:000489', NULL, NULL, 'Heat shock protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119781, NULL, 'G3DSA:1.20.1270.420:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119782, NULL, 'G3DSA:1.25.40.20:FF:001039', NULL, NULL, 'Os09g0331600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(119783, NULL, 'G3DSA:1.20.930.50:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(119784, NULL, 'G3DSA:2.30.29.30:FF:000753', NULL, NULL, 'Amyloid beta precursor protein binding family B member 1', NULL, NULL, NULL, NULL, NULL, 4),
(119785, NULL, 'G3DSA:1.25.10.10:FF:003434', NULL, NULL, 'Maestro heat-like repeat-containing protein family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(119786, NULL, 'G3DSA:3.40.50.880:FF:000177', NULL, NULL, 'Imidazole glycerol phosphate synthase subunit HisH 2', NULL, NULL, NULL, NULL, NULL, 4),
(119787, NULL, 'G3DSA:1.20.5.1160:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119788, NULL, 'G3DSA:3.40.1160.10:FF:000024', NULL, NULL, 'Uridylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(119789, NULL, 'G3DSA:2.60.40.3120:FF:000001', NULL, NULL, 'cytosolic carboxypeptidase 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(119790, NULL, 'G3DSA:3.40.50.1820:FF:000194', NULL, NULL, 'Alpha/beta hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119791, NULL, 'G3DSA:3.20.140.10:FF:000028', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(119792, NULL, 'G3DSA:3.90.1150.10:FF:000366', NULL, NULL, 'UDP-2-acetamido-2-deoxy-3-oxo-D-glucuronate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(119793, NULL, 'G3DSA:3.30.1600.10:FF:000010', NULL, NULL, 'NAD-dependent protein deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(119794, NULL, 'G3DSA:3.40.470.10:FF:000003', NULL, NULL, 'G/U mismatch-specific DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(119795, NULL, 'G3DSA:1.20.120.1380:FF:000007', NULL, NULL, 'Flagellar biosynthesis regulator FlhF', NULL, NULL, NULL, NULL, NULL, 4),
(119796, NULL, 'G3DSA:3.30.70.330:FF:002648', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119797, NULL, 'G3DSA:1.20.58.400:FF:000005', NULL, NULL, 'Vesicle transport through interaction with t-snares 1a', NULL, NULL, NULL, NULL, NULL, 4),
(119798, NULL, 'G3DSA:1.20.58.100:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119799, NULL, 'G3DSA:2.160.20.10:FF:000098', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(119800, NULL, 'G3DSA:3.40.710.10:FF:000056', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase DacB', NULL, NULL, NULL, NULL, NULL, 4),
(119801, NULL, 'G3DSA:2.60.40.10:FF:003414', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119802, NULL, 'G3DSA:3.60.10.10:FF:000190', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(119803, NULL, 'G3DSA:2.10.109.10:FF:000063', NULL, NULL, 'Probable signal peptidase I-2', NULL, NULL, NULL, NULL, NULL, 4),
(119804, NULL, 'G3DSA:3.30.40.10:FF:002087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119805, NULL, 'G3DSA:1.20.120.1240:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119806, NULL, 'G3DSA:2.40.290.10:FF:000021', NULL, NULL, 'Caenorhabditis KU', NULL, NULL, NULL, NULL, NULL, 4),
(119807, NULL, 'G3DSA:1.20.930.60:FF:000004', NULL, NULL, 'Protein-glutamate O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(119808, NULL, 'G3DSA:3.30.1440.10:FF:000003', NULL, NULL, 'Ribosomal protein L5', NULL, NULL, NULL, NULL, NULL, 4),
(119809, NULL, 'G3DSA:3.10.590.10:FF:000002', NULL, NULL, 'YTH domain-containing protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(119810, NULL, 'G3DSA:2.60.40.10:FF:005314', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119811, NULL, 'G3DSA:1.20.1560.10:FF:000471', NULL, NULL, 'ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(119812, NULL, 'G3DSA:1.20.5.170:FF:000228', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(119813, NULL, 'G3DSA:2.150.10.10:FF:000002', NULL, NULL, 'Leukotoxin', NULL, NULL, NULL, NULL, NULL, 4),
(119814, NULL, 'G3DSA:3.40.50.10140:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119815, NULL, 'G3DSA:1.20.58.930:FF:000006', NULL, NULL, 'Arginine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(119816, NULL, 'G3DSA:2.40.160.50:FF:000029', NULL, NULL, 'Surface antigen', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(119817, NULL, 'G3DSA:3.40.50.10190:FF:000180', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(119818, NULL, 'G3DSA:2.130.10.10:FF:004999', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119819, NULL, 'G3DSA:2.70.160.11:FF:000012', NULL, NULL, 'Protein arginine N-methyltransferase PRMT10', NULL, NULL, NULL, NULL, NULL, 4),
(119820, NULL, 'G3DSA:2.10.90.10:FF:000013', NULL, NULL, 'Gremlin', NULL, NULL, NULL, NULL, NULL, 4),
(119821, NULL, 'G3DSA:1.10.1820.10:FF:000016', NULL, NULL, 'Casein kinase II beta2 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(119822, NULL, 'G3DSA:2.130.10.10:FF:004819', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119823, NULL, 'G3DSA:3.40.50.12160:FF:000001', NULL, NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(119824, NULL, 'G3DSA:3.30.450.60:FF:000047', NULL, NULL, 'AP-1 complex subunit mu-2', NULL, NULL, NULL, NULL, NULL, 4),
(119825, NULL, 'G3DSA:1.25.40.770:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119826, NULL, 'G3DSA:2.60.220.50:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119827, NULL, 'G3DSA:3.40.50.300:FF:004050', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(119828, NULL, 'G3DSA:3.30.40.10:FF:000479', NULL, NULL, 'E3 ubiquitin-protein ligase Arkadia', NULL, NULL, NULL, NULL, NULL, 4),
(119829, NULL, 'G3DSA:3.90.640.10:FF:000163', NULL, NULL, 'Actin-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(119830, NULL, 'G3DSA:2.60.40.10:FF:001615', NULL, NULL, 'Tyrosine-protein kinase receptor Tie-1 isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(119831, NULL, 'G3DSA:1.10.8.60:FF:000053', NULL, NULL, 'DNA polymerase epsilon subunit', NULL, NULL, NULL, NULL, NULL, 4),
(119832, NULL, 'G3DSA:1.20.1070.10:FF:000933', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119833, NULL, 'G3DSA:3.10.20.90:FF:000795', NULL, NULL, 'AT15685p', NULL, NULL, NULL, NULL, NULL, 4),
(119834, NULL, 'G3DSA:1.25.40.180:FF:000065', NULL, NULL, 'Nuclear cap-binding protein subunit 1-B', NULL, NULL, NULL, NULL, NULL, 4),
(119835, NULL, 'G3DSA:3.40.50.1360:FF:000022', NULL, NULL, 'DNA-binding transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(119836, NULL, 'G3DSA:1.25.40.10:FF:004908', NULL, NULL, 'Os09g0555400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(119837, NULL, 'G3DSA:2.10.25.10:FF:000037', NULL, NULL, 'Signal peptide, CUB domain and EGF-like domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(119838, NULL, 'G3DSA:1.10.150.50:FF:000062', NULL, NULL, 'Sterile alpha and TIR motif containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(119839, NULL, 'G3DSA:3.30.450.20:FF:000631', NULL, NULL, 'Hybrid sensor kinase RscS', NULL, NULL, NULL, NULL, NULL, 4),
(119840, NULL, 'G3DSA:3.40.50.2000:FF:000473', NULL, NULL, 'Glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(119841, NULL, 'G3DSA:2.60.120.290:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119842, NULL, 'G3DSA:3.30.160.60:FF:002200', NULL, NULL, 'zinc finger protein 341 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(119843, NULL, 'G3DSA:2.40.50.120:FF:000026', NULL, NULL, 'AGAP000228-PA', NULL, NULL, NULL, NULL, NULL, 4),
(119844, NULL, 'G3DSA:3.30.160.60:FF:001918', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119845, NULL, 'G3DSA:1.10.510.10:FF:003742', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119846, NULL, 'G3DSA:1.20.1070.10:FF:002171', NULL, NULL, 'AGAP013324-PA', NULL, NULL, NULL, NULL, NULL, 4),
(119847, NULL, 'G3DSA:3.10.50.10:FF:000054', NULL, NULL, 'Chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119848, NULL, 'G3DSA:3.40.50.300:FF:005152', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(119849, NULL, 'G3DSA:1.10.10.10:FF:001028', NULL, NULL, 'LuxR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(119850, NULL, 'G3DSA:3.40.1110.10:FF:000330', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(119851, NULL, 'G3DSA:3.30.70.270:FF:000028', NULL, NULL, 'Diguanylate cyclase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(119852, NULL, 'G3DSA:1.10.510.10:FF:001281', NULL, NULL, 'NNK1p Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(119853, NULL, 'G3DSA:3.40.850.10:FF:000549', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(119854, NULL, 'G3DSA:3.30.1330.40:FF:000026', NULL, NULL, 'Translation initiation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(119855, NULL, 'G3DSA:3.30.420.10:FF:000137', NULL, NULL, 'ISPsy4, transposase', NULL, NULL, NULL, NULL, NULL, 4),
(119856, NULL, 'G3DSA:3.40.50.360:FF:000127', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(119857, NULL, 'G3DSA:2.60.40.10:FF:004797', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119858, NULL, 'G3DSA:3.30.1360.120:FF:000030', NULL, NULL, 'GTPase MSS1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(119859, NULL, 'G3DSA:3.30.930.10:FF:000075', NULL, NULL, 'probable asparagine--tRNA ligase, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(119860, NULL, 'G3DSA:2.60.40.10:FF:004488', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119861, NULL, 'G3DSA:3.40.50.300:FF:003914', NULL, NULL, 'Putative recombinase rad51', NULL, NULL, NULL, NULL, NULL, 4),
(119862, NULL, 'G3DSA:1.25.10.10:FF:002962', NULL, NULL, 'Exportin-4-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(119863, NULL, 'G3DSA:3.30.1330.30:FF:000023', NULL, NULL, 'rRNA methyltransferase 3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(119864, NULL, 'G3DSA:1.25.10.10:FF:001534', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(119865, NULL, 'G3DSA:3.30.70.260:FF:000025', NULL, NULL, 'Probable septum site-determining protein MinC', NULL, NULL, NULL, NULL, NULL, 4),
(119866, NULL, 'G3DSA:3.30.70.330:FF:002750', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119867, NULL, 'G3DSA:3.80.10.10:FF:000037', NULL, NULL, 'Toll-like receptor 7', NULL, NULL, NULL, NULL, NULL, 4),
(119868, NULL, 'G3DSA:3.10.580.10:FF:000030', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(119869, NULL, 'G3DSA:1.10.260.40:FF:000078', NULL, NULL, 'Helix-turn-helix domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(119870, NULL, 'G3DSA:3.30.70.330:FF:001322', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119871, NULL, 'G3DSA:3.40.50.300:FF:007922', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119872, NULL, 'G3DSA:2.40.50.90:FF:000185', NULL, NULL, 'Tudor domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(119873, NULL, 'G3DSA:2.40.50.100:FF:000020', NULL, NULL, '50S ribosomal protein L27', NULL, NULL, NULL, NULL, NULL, 4),
(119874, NULL, 'G3DSA:3.30.160.60:FF:003173', NULL, NULL, 'AGAP007915-PA', NULL, NULL, NULL, NULL, NULL, 4),
(119875, NULL, 'G3DSA:1.25.40.10:FF:001036', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At1g03510', NULL, NULL, NULL, NULL, NULL, 4),
(119876, NULL, 'G3DSA:3.30.70.250:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119877, NULL, 'G3DSA:3.80.10.10:FF:004415', NULL, NULL, 'Lumican, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119878, NULL, 'G3DSA:1.25.10.10:FF:001860', NULL, NULL, 'Os02g0146400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(119879, NULL, 'G3DSA:3.30.70.330:FF:000850', NULL, NULL, 'Serine/arginine-rich splicing factor SR45a', NULL, NULL, NULL, NULL, NULL, 4),
(119880, NULL, 'G3DSA:2.60.40.10:FF:003386', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119881, NULL, 'G3DSA:1.20.1250.10:FF:000026', NULL, NULL, 'Interferon beta', NULL, NULL, NULL, NULL, NULL, 4),
(119882, NULL, 'G3DSA:1.10.10.390:FF:000002', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(119883, NULL, 'G3DSA:3.40.50.1010:FF:000046', NULL, NULL, 'RAD2p Single-stranded DNA endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(119884, NULL, 'G3DSA:3.30.70.100:FF:000101', NULL, NULL, 'Cation transport ATPase, E1-E2 family', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(119885, NULL, 'G3DSA:2.60.120.10:FF:000140', NULL, NULL, 'Bacilysin biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(119886, NULL, 'G3DSA:2.40.50.120:FF:000043', NULL, NULL, 'Meteorin-like, glial cell differentiation regulator a', NULL, NULL, NULL, NULL, NULL, 4),
(119887, NULL, 'G3DSA:3.40.50.2020:FF:000012', NULL, NULL, 'Phosphoribosyl pyrophosphate synthase-associated protein 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(119888, NULL, 'G3DSA:3.40.50.620:FF:000650', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119889, NULL, 'G3DSA:3.40.50.1260:FF:000008', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(119890, NULL, 'G3DSA:4.10.400.10:FF:000232', NULL, NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(119891, NULL, 'G3DSA:3.30.160.60:FF:003482', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119892, NULL, 'G3DSA:2.60.40.10:FF:002588', NULL, NULL, 'Suppressor protein SPT23, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119893, NULL, 'G3DSA:3.40.50.300:FF:007613', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119894, NULL, 'G3DSA:3.30.160.60:FF:002071', NULL, NULL, 'Zinc finger protein 570', NULL, NULL, NULL, NULL, NULL, 4),
(119895, NULL, 'G3DSA:1.25.40.10:FF:001362', NULL, NULL, 'RNA splicing factor', NULL, NULL, NULL, NULL, NULL, 4),
(119896, NULL, 'G3DSA:2.40.50.140:FF:001201', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119897, NULL, 'G3DSA:3.30.200.20:FF:001411', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119898, NULL, 'G3DSA:3.40.366.10:FF:000008', NULL, NULL, 'Mycocerosic acid synthase-like polyketide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(119899, NULL, 'G3DSA:1.10.3720.10:FF:000099', NULL, NULL, 'Inner membrane ABC transporter permease ynjC', NULL, NULL, NULL, NULL, NULL, 4),
(119900, NULL, 'G3DSA:3.60.20.10:FF:000128', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(119901, NULL, 'G3DSA:1.25.40.10:FF:003262', NULL, NULL, 'Transmembrane and tetratricopeptide repeat-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(119902, NULL, 'G3DSA:3.30.470.20:FF:000205', NULL, NULL, 'Inositol-tetrakisphosphate 1-kinase b', NULL, NULL, NULL, NULL, NULL, 4),
(119903, NULL, 'G3DSA:1.10.510.10:FF:003181', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119904, NULL, 'G3DSA:1.20.5.500:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119905, NULL, 'G3DSA:1.10.472.140:FF:000013', NULL, NULL, 'Retinoblastoma family protein', NULL, NULL, NULL, NULL, NULL, 4),
(119906, NULL, 'G3DSA:3.30.160.60:FF:005308', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119907, NULL, 'G3DSA:3.40.1170.60:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119908, NULL, 'G3DSA:2.30.30.1190:FF:000007', NULL, NULL, 'DExH-box helicase 57', NULL, NULL, NULL, NULL, NULL, 4),
(119909, NULL, 'G3DSA:3.30.1360.120:FF:000013', NULL, NULL, 'Sarcosine dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(119910, NULL, 'G3DSA:1.25.40.20:FF:001365', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119911, NULL, 'G3DSA:3.30.450.20:FF:000322', NULL, NULL, 'Sensory box histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(119912, NULL, 'G3DSA:3.30.479.30:FF:000037', NULL, NULL, 'stomatin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(119913, NULL, 'G3DSA:3.20.20.140:FF:000341', NULL, NULL, 'ACR238Wp', NULL, NULL, NULL, NULL, NULL, 4),
(119914, NULL, 'G3DSA:3.30.200.40:FF:000006', NULL, NULL, 'Scavenger mRNA-decapping enzyme DcpS', NULL, NULL, NULL, NULL, NULL, 4),
(119915, NULL, 'G3DSA:3.80.10.10:FF:004286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119916, NULL, 'G3DSA:3.40.20.10:FF:000090', NULL, NULL, 'Variant sh3 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(119917, NULL, 'G3DSA:2.20.100.10:FF:000035', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 12', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(119918, NULL, 'G3DSA:3.80.10.10:FF:002515', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(119919, NULL, 'G3DSA:3.30.420.270:FF:000001', NULL, NULL, 'Tol-Pal system protein TolR', NULL, NULL, NULL, NULL, NULL, 4),
(119920, NULL, 'G3DSA:1.10.10.10:FF:001337', NULL, NULL, 'Response regulator receiver', NULL, NULL, NULL, NULL, NULL, 4),
(119921, NULL, 'G3DSA:2.60.40.10:FF:003740', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119922, NULL, 'G3DSA:2.30.30.140:FF:000300', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(119923, NULL, 'G3DSA:3.40.50.1370:FF:000025', NULL, NULL, 'Aspartate carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(119924, NULL, 'G3DSA:2.60.40.10:FF:002897', NULL, NULL, 'Deleted in lung and esophageal cancer protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(119925, NULL, 'G3DSA:3.30.200.20:FF:001309', NULL, NULL, 'Vesicle-associated protein 1-1', NULL, NULL, NULL, NULL, NULL, 4),
(119926, NULL, 'G3DSA:2.60.40.1730:FF:000005', NULL, NULL, 'Aminopeptidase N', NULL, NULL, NULL, NULL, NULL, 4),
(119927, NULL, 'G3DSA:3.40.50.1820:FF:000059', NULL, NULL, 'Fatty acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(119928, NULL, 'G3DSA:3.40.50.12780:FF:000097', NULL, NULL, 'AMP-dependent synthetase and ligase', NULL, NULL, NULL, NULL, NULL, 4),
(119929, NULL, 'G3DSA:1.10.238.10:FF:000866', NULL, NULL, 'RabGAP/TBC domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(119930, NULL, 'G3DSA:3.40.605.10:FF:000042', NULL, NULL, 'Succinate semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(119931, NULL, 'G3DSA:3.40.720.10:FF:000113', NULL, NULL, 'Phosphonoacetate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(119932, NULL, 'G3DSA:3.80.10.10:FF:000363', NULL, NULL, 'Leucine-rich repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(119933, NULL, 'G3DSA:3.30.160.60:FF:000300', NULL, NULL, 'PR domain zinc finger protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(119934, NULL, 'G3DSA:1.10.10.200:FF:000002', NULL, NULL, 'Probable transcriptional regulatory protein CLM62_37755', NULL, NULL, NULL, NULL, NULL, 4),
(119935, NULL, 'G3DSA:1.10.510.10:FF:003079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119936, NULL, 'G3DSA:2.30.130.10:FF:000001', NULL, NULL, 'H/ACA ribonucleoprotein complex subunit CBF5', NULL, NULL, NULL, NULL, NULL, 4),
(119937, NULL, 'G3DSA:1.10.1080.10:FF:000015', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(119938, NULL, 'G3DSA:3.40.50.2000:FF:000809', NULL, NULL, 'Putative alpha,alpha-trehalose-phosphate synthase [UDP-forming] 106 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(119939, NULL, 'G3DSA:3.30.190.20:FF:000032', NULL, NULL, '50S ribosomal protein L1', NULL, NULL, NULL, NULL, NULL, 4),
(119940, NULL, 'G3DSA:2.10.70.10:FF:000130', NULL, NULL, 'Complement factor H', NULL, NULL, NULL, NULL, NULL, 4),
(119941, NULL, 'G3DSA:3.60.10.10:FF:000173', NULL, NULL, 'Putative endonuclease/exonuclease/phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(119942, NULL, 'G3DSA:1.50.40.10:FF:000090', NULL, NULL, 'Folate transporter 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(119943, NULL, 'G3DSA:3.30.160.20:FF:000221', NULL, NULL, 'HEN1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(119944, NULL, 'G3DSA:1.20.120.850:FF:000010', NULL, NULL, 'E1A-binding protein p400 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(119945, NULL, 'G3DSA:3.40.50.300:FF:005359', NULL, NULL, 'Dynein axonemal heavy chain 3', NULL, NULL, NULL, NULL, NULL, 4),
(119946, NULL, 'G3DSA:3.40.50.2300:FF:001080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119947, NULL, 'G3DSA:1.20.1070.10:FF:000046', NULL, NULL, '5-hydroxytryptamine receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(119948, NULL, 'G3DSA:1.20.1250.20:FF:000338', NULL, NULL, 'Putative plastidic glucose transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(119949, NULL, 'G3DSA:3.30.450.50:FF:000044', NULL, NULL, 'Synaptobrevin 9-2', NULL, NULL, NULL, NULL, NULL, 4),
(119950, NULL, 'G3DSA:1.10.510.10:FF:001617', NULL, NULL, 'Ser/thr protein kinase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(119951, NULL, 'G3DSA:1.20.140.10:FF:000108', NULL, NULL, 'Acyl-CoA dehydrogenase long chain', NULL, NULL, NULL, NULL, NULL, 4),
(119952, NULL, 'G3DSA:1.20.920.10:FF:000174', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(119953, NULL, 'G3DSA:3.30.479.20:FF:000034', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(119954, NULL, 'G3DSA:3.50.50.60:FF:000960', NULL, NULL, 'Glycine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(119955, NULL, 'G3DSA:1.20.1050.10:FF:000163', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(119956, NULL, 'G3DSA:1.10.1220.10:FF:000004', NULL, NULL, 'Macrodomain Ter protein', NULL, NULL, NULL, NULL, NULL, 4),
(119957, NULL, 'G3DSA:1.20.1070.10:FF:000607', NULL, NULL, '5-hydroxytryptamine receptor 4-like', NULL, NULL, NULL, NULL, NULL, 4),
(119958, NULL, 'G3DSA:2.60.40.10:FF:005331', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119959, NULL, 'G3DSA:1.10.1200.120:FF:000001', NULL, NULL, 'Large-conductance mechanosensitive channel', NULL, NULL, NULL, NULL, NULL, 4),
(119960, NULL, 'G3DSA:1.10.510.10:FF:002899', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119961, NULL, 'G3DSA:2.60.40.1090:FF:000021', NULL, NULL, 'Fimbrial-like adhesin protein', NULL, NULL, NULL, NULL, NULL, 4),
(119962, NULL, 'G3DSA:3.40.50.2300:FF:000591', NULL, NULL, 'Two-component system sensor molecule', NULL, NULL, NULL, NULL, NULL, 4),
(119963, NULL, 'G3DSA:1.10.405.10:FF:000030', NULL, NULL, 'PLATZ transcription factor family protein', NULL, NULL, NULL, NULL, NULL, 4),
(119964, NULL, 'G3DSA:3.80.10.10:FF:000924', NULL, NULL, 'Receptor like protein 39', NULL, NULL, NULL, NULL, NULL, 4),
(119965, NULL, 'G3DSA:3.80.10.10:FF:000672', NULL, NULL, 'Leucine Rich Repeat family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(119966, NULL, 'G3DSA:3.30.420.10:FF:000463', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119967, NULL, 'G3DSA:2.60.40.10:FF:001486', NULL, NULL, 'Interleukin-1 receptor accessory protein-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(119968, NULL, 'G3DSA:3.30.200.20:FF:001102', NULL, NULL, 'Mitochondrial ribosomal protein L48, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119969, NULL, 'G3DSA:3.30.70.1430:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119970, NULL, 'G3DSA:3.30.450.20:FF:000277', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(119971, NULL, 'G3DSA:2.30.29.30:FF:000444', NULL, NULL, 'Decapping enzyme Dcp1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119972, NULL, 'G3DSA:2.60.40.10:FF:005640', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119973, NULL, 'G3DSA:3.10.129.10:FF:000173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119974, NULL, 'G3DSA:1.20.1250.20:FF:000029', NULL, NULL, 'solute carrier family 2, facilitated glucose transporter member 4', NULL, NULL, NULL, NULL, NULL, 4),
(119975, NULL, 'G3DSA:3.10.250.10:FF:000061', NULL, NULL, 'Macrophage scavenger receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(119976, NULL, 'G3DSA:2.130.10.10:FF:001582', NULL, NULL, 'WD domain', NULL, NULL, NULL, NULL, NULL, 4),
(119977, NULL, 'G3DSA:3.30.40.10:FF:000608', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(119978, NULL, 'G3DSA:3.30.70.330:FF:000479', NULL, NULL, 'Splicing factor 3B subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(119979, NULL, 'G3DSA:1.10.220.150:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119980, NULL, 'G3DSA:1.25.50.20:FF:000011', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(119981, NULL, 'G3DSA:3.40.1280.10:FF:000090', NULL, NULL, 'Putative methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(119982, NULL, 'G3DSA:2.60.450.10:FF:000007', NULL, NULL, 'Lipopolysaccharide export system protein LptC', NULL, NULL, NULL, NULL, NULL, 4),
(119983, NULL, 'G3DSA:3.40.50.10490:FF:000129', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119984, NULL, 'G3DSA:1.25.40.10:FF:004925', NULL, NULL, 'Pre-mRNA-processing factor 6-like Protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(119985, NULL, 'G3DSA:1.10.287.470:FF:000050', NULL, NULL, 'Resistance-Nodulation-Cell Division (RND) efflux membrane fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(119986, NULL, 'G3DSA:1.20.120.790:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(119987, NULL, 'G3DSA:3.90.640.10:FF:000045', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(119988, NULL, 'G3DSA:3.80.10.10:FF:000346', NULL, NULL, 'Leucine rich repeat containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(119989, NULL, 'G3DSA:2.60.120.200:FF:000721', NULL, NULL, 'MshA pili-associated adhesin MshQ', NULL, NULL, NULL, NULL, NULL, 4),
(119990, NULL, 'G3DSA:3.10.50.10:FF:000071', NULL, NULL, 'CHItinase-Like', NULL, NULL, NULL, NULL, NULL, 4),
(119991, NULL, 'G3DSA:3.20.20.100:FF:000127', NULL, NULL, 'Glycerol dehydrogenase (GCY1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(119992, NULL, 'G3DSA:3.40.250.10:FF:000138', NULL, NULL, 'AGAP000552-PA', NULL, NULL, NULL, NULL, NULL, 4),
(119993, NULL, 'G3DSA:3.30.160.60:FF:005634', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(119994, NULL, 'G3DSA:3.40.605.10:FF:000025', NULL, NULL, 'NADP-dependent glyceraldehyde-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(119995, NULL, 'G3DSA:1.10.8.60:FF:000406', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(119996, NULL, 'G3DSA:2.30.29.30:FF:000635', NULL, NULL, 'BPH1p Protein', NULL, NULL, NULL, NULL, NULL, 4),
(119997, NULL, 'G3DSA:1.50.10.100:FF:000002', NULL, NULL, 'Alginate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(119998, NULL, 'G3DSA:2.60.40.650:FF:000021', NULL, NULL, 'Sulfite-dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(119999, NULL, 'G3DSA:1.20.1250.20:FF:000782', NULL, NULL, 'Proton-dependent oligopeptide transport family protein', NULL, NULL, NULL, NULL, NULL, 4),
(120000, NULL, 'G3DSA:1.20.1050.90:FF:000012', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(120001, NULL, 'G3DSA:2.60.40.200:FF:000015', NULL, NULL, 'Copper/zinc superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(120002, NULL, 'G3DSA:1.25.10.10:FF:001652', NULL, NULL, 'TORTIFOLIA1-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(120003, NULL, 'G3DSA:3.20.20.80:FF:000813', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120004, NULL, 'G3DSA:3.30.428.40:FF:000001', NULL, NULL, 'AT3G19900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(120005, NULL, 'G3DSA:4.10.1000.10:FF:000058', NULL, NULL, 'putative cleavage and polyadenylation specificity factor subunit 4-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(120006, NULL, 'G3DSA:2.60.40.1390:FF:000004', NULL, NULL, 'Myelin regulatory factor', NULL, NULL, NULL, NULL, NULL, 4),
(120007, NULL, 'G3DSA:3.60.40.10:FF:000337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120008, NULL, 'G3DSA:3.40.50.1400:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120009, NULL, 'G3DSA:1.10.1420.10:FF:000002', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(120010, NULL, 'G3DSA:2.60.120.290:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120011, NULL, 'G3DSA:3.10.50.40:FF:000130', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(120012, NULL, 'G3DSA:3.40.50.300:FF:003426', NULL, NULL, 'Related to Ras-like G protein RagD', NULL, NULL, NULL, NULL, NULL, 4),
(120013, NULL, 'G3DSA:2.30.30.140:FF:000081', NULL, NULL, 'Tudor domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(120014, NULL, 'G3DSA:3.40.50.150:FF:001790', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120015, NULL, 'G3DSA:3.30.40.10:FF:001699', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(120016, NULL, 'G3DSA:3.90.190.10:FF:000616', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120017, NULL, 'G3DSA:1.25.40.20:FF:001691', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(120018, NULL, 'G3DSA:3.30.70.330:FF:001193', NULL, NULL, 'Os07g0615400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(120019, NULL, 'G3DSA:2.40.50.140:FF:000493', NULL, NULL, 'DIS3 exonuclease 2', NULL, NULL, NULL, NULL, NULL, 4),
(120020, NULL, 'G3DSA:3.30.70.660:FF:000038', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(120021, NULL, 'G3DSA:3.30.310.80:FF:000015', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(120022, NULL, 'G3DSA:3.40.50.300:FF:007158', NULL, NULL, 'Os01g0681100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(120023, NULL, 'G3DSA:3.30.200.20:FF:002529', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120024, NULL, 'G3DSA:1.25.40.10:FF:001800', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(120025, NULL, 'G3DSA:3.30.310.20:FF:000003', NULL, NULL, 'DNA-3-methyladenine glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(120026, NULL, 'G3DSA:3.30.70.330:FF:001204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120027, NULL, 'G3DSA:1.20.5.110:FF:000143', NULL, NULL, 'Syntaxin 8', NULL, NULL, NULL, NULL, NULL, 4),
(120028, NULL, 'G3DSA:1.10.418.20:FF:000012', NULL, NULL, 'Unplaced genomic scaffold supercont1.23, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(120029, NULL, 'G3DSA:3.40.50.2000:FF:000591', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(120030, NULL, 'G3DSA:3.30.465.10:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120031, NULL, 'G3DSA:3.30.300.20:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120032, NULL, 'G3DSA:1.10.418.40:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120033, NULL, 'G3DSA:2.130.10.10:FF:002993', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(120034, NULL, 'G3DSA:2.60.40.10:FF:001823', NULL, NULL, 'Down syndrome cell adhesion molecule 2, isoform Q', NULL, NULL, NULL, NULL, NULL, 4),
(120035, NULL, 'G3DSA:2.70.50.30:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120036, NULL, 'G3DSA:2.40.128.20:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120037, NULL, 'G3DSA:1.10.510.10:FF:003490', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120038, NULL, 'G3DSA:1.20.58.1070:FF:000007', NULL, NULL, 'Chromosome 23, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(120039, NULL, 'G3DSA:2.60.40.10:FF:003532', NULL, NULL, 'Polycystic kidney disease 1 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(120040, NULL, 'G3DSA:3.90.650.10:FF:000017', NULL, NULL, 'Probable phosphoribosylformylglycinamidine synthase, chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(120041, NULL, 'G3DSA:3.90.70.80:FF:000027', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120042, NULL, 'G3DSA:1.20.120.1770:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120043, NULL, 'G3DSA:3.40.50.2000:FF:000164', NULL, NULL, 'Lipopolysaccharide heptosyltransferase I', NULL, NULL, NULL, NULL, NULL, 4),
(120044, NULL, 'G3DSA:3.50.30.30:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120045, NULL, 'G3DSA:1.20.58.2190:FF:000006', NULL, NULL, 'N-glycanase 1', NULL, NULL, NULL, NULL, NULL, 4),
(120046, NULL, 'G3DSA:3.60.15.10:FF:000178', NULL, NULL, 'Hydroxyacylglutathione hydrolase 3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(120047, NULL, 'G3DSA:3.40.50.970:FF:000069', NULL, NULL, '1-deoxy-D-xylulose 5-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(120048, NULL, 'G3DSA:2.60.220.50:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120049, NULL, 'G3DSA:3.90.640.10:FF:000146', NULL, NULL, 'Actin-related protein 3-1', NULL, NULL, NULL, NULL, NULL, 4),
(120050, NULL, 'G3DSA:3.90.550.20:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(120051, NULL, 'G3DSA:1.20.120.350:FF:000040', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(120052, NULL, 'G3DSA:3.90.1240.10:FF:000002', NULL, NULL, 'Botulinum neurotoxin type A', NULL, NULL, NULL, NULL, NULL, 4),
(120053, NULL, 'G3DSA:2.60.40.2860:FF:000024', NULL, NULL, '6-cysteine protein', NULL, NULL, NULL, NULL, NULL, 4),
(120054, NULL, 'G3DSA:3.30.160.20:FF:000193', NULL, NULL, 'Adenosine deaminase domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(120055, NULL, 'G3DSA:1.25.40.570:FF:000075', NULL, NULL, 'Protein CBR-CSN-2', NULL, NULL, NULL, NULL, NULL, 4),
(120056, NULL, 'G3DSA:1.20.1070.10:FF:000681', NULL, NULL, 'GoNadotropin-Releasing hormone Receptor (GnRHR) related', NULL, NULL, NULL, NULL, NULL, 4),
(120057, NULL, 'G3DSA:2.60.40.1180:FF:000121', NULL, NULL, 'Maltase B1, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(120058, NULL, 'G3DSA:1.10.287.130:FF:000105', NULL, NULL, 'Putative sensory histidine kinase in two-component regulatory system', NULL, NULL, NULL, NULL, NULL, 4),
(120059, NULL, 'G3DSA:2.170.300.10:FF:000009', NULL, NULL, 'Terribly reduced optic lobes, isoform AK', NULL, NULL, NULL, NULL, NULL, 4),
(120060, NULL, 'G3DSA:3.50.7.10:FF:000077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120061, NULL, 'G3DSA:3.40.50.300:FF:008586', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120062, NULL, 'G3DSA:3.90.245.10:FF:000019', NULL, NULL, 'Putative nucleoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(120063, NULL, 'G3DSA:3.75.10.10:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120064, NULL, 'G3DSA:3.30.1490.20:FF:000060', NULL, NULL, 'Phosphoglucan, water dikinase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(120065, NULL, 'G3DSA:1.25.40.20:FF:001803', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120066, NULL, 'G3DSA:2.60.120.260:FF:000469', NULL, NULL, 'Glycosyl hydrolases family 2, sugar binding domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(120067, NULL, 'G3DSA:3.80.10.10:FF:003898', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120068, NULL, 'G3DSA:3.30.420.40:FF:001080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120069, NULL, 'G3DSA:1.20.910.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120070, NULL, 'G3DSA:1.10.287.70:FF:000025', NULL, NULL, 'Voltage-dependent R-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(120071, NULL, 'G3DSA:3.30.300.30:FF:000067', NULL, NULL, 'Nonribosomal peptide synthase GliP2', NULL, NULL, NULL, NULL, NULL, 4),
(120072, NULL, 'G3DSA:2.130.10.10:FF:001801', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(120073, NULL, 'G3DSA:1.10.1370.40:FF:000001', NULL, NULL, 'Dipeptidyl carboxypeptidase II', NULL, NULL, NULL, NULL, NULL, 4),
(120074, NULL, 'G3DSA:1.25.40.10:FF:000974', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(120075, NULL, 'G3DSA:1.25.10.10:FF:001225', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(120076, NULL, 'G3DSA:1.20.58.60:FF:000399', NULL, NULL, 'VAB-10B protein', NULL, NULL, NULL, NULL, NULL, 4),
(120077, NULL, 'G3DSA:2.60.40.10:FF:001278', NULL, NULL, 'Defective proboscis extension response', NULL, NULL, NULL, NULL, NULL, 4),
(120078, NULL, 'G3DSA:3.90.180.10:FF:000009', NULL, NULL, 'Reticulon-4-interacting protein 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(120079, NULL, 'G3DSA:1.50.40.10:FF:000117', NULL, NULL, 'SLC25A32 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(120080, NULL, 'G3DSA:3.40.50.1110:FF:000060', NULL, NULL, 'GDSL-like Lipase/Acylhydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(120081, NULL, 'G3DSA:3.30.160.60:FF:001683', NULL, NULL, 'Zinc finger protein 467', NULL, NULL, NULL, NULL, NULL, 4),
(120082, NULL, 'G3DSA:3.30.1460.20:FF:000024', NULL, NULL, 'Actin-related protein 2/3 complex subunit 2B', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(120083, NULL, 'G3DSA:3.50.50.80:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120084, NULL, 'G3DSA:1.10.3860.10:FF:000024', NULL, NULL, 'Amino acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(120085, NULL, 'G3DSA:3.30.930.10:FF:000103', NULL, NULL, 'Lipoate-protein ligase A type 2', NULL, NULL, NULL, NULL, NULL, 4),
(120086, NULL, 'G3DSA:2.30.29.30:FF:001141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120087, NULL, 'G3DSA:3.30.160.60:FF:001935', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120088, NULL, 'G3DSA:1.20.1410.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120089, NULL, 'G3DSA:3.40.1110.10:FF:000184', NULL, NULL, 'Cation transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(120090, NULL, 'G3DSA:1.20.120.1750:FF:000169', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(120091, NULL, 'G3DSA:1.10.565.10:FF:000114', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(120092, NULL, 'G3DSA:1.10.287.610:FF:000007', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(120093, NULL, 'G3DSA:3.90.640.90:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120094, NULL, 'G3DSA:2.60.120.10:FF:000038', NULL, NULL, 'cGMP-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(120095, NULL, 'G3DSA:3.40.50.300:FF:004033', NULL, NULL, 'DNA replication helicase Dna2', NULL, NULL, NULL, NULL, NULL, 4),
(120096, NULL, 'G3DSA:2.60.120.290:FF:000012', NULL, NULL, 'mannan-binding lectin serine protease 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(120097, NULL, 'G3DSA:3.10.20.870:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120098, NULL, 'G3DSA:3.90.79.10:FF:000279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120099, NULL, 'G3DSA:3.40.33.10:FF:000052', NULL, NULL, 'SCP-Like extracellular protein', NULL, NULL, NULL, NULL, NULL, 4),
(120100, NULL, 'G3DSA:3.40.50.1460:FF:000052', NULL, NULL, 'GPI8 transamidase isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(120101, NULL, 'G3DSA:3.40.50.300:FF:005461', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(120102, NULL, 'G3DSA:2.130.10.10:FF:001790', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120103, NULL, 'G3DSA:3.40.50.2300:FF:000248', NULL, NULL, 'LacI family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(120104, NULL, 'G3DSA:1.10.287.600:FF:000004', NULL, NULL, 'Tubulin gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(120105, NULL, 'G3DSA:1.20.80.10:FF:000043', NULL, NULL, 'Protein expanded', NULL, NULL, NULL, NULL, NULL, 4),
(120106, NULL, 'G3DSA:3.40.850.10:FF:000460', NULL, NULL, 'Kinesin family member C1', NULL, NULL, NULL, NULL, NULL, 4),
(120107, NULL, 'G3DSA:3.30.160.60:FF:001256', NULL, NULL, 'zinc finger protein 664', NULL, NULL, NULL, NULL, NULL, 4),
(120108, NULL, 'G3DSA:3.30.559.10:FF:000240', NULL, NULL, 'Choline O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(120109, NULL, 'G3DSA:1.10.8.140:FF:000020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120110, NULL, 'G3DSA:3.80.10.10:FF:001060', NULL, NULL, 'OSJNBa0064H22.13 protein', NULL, NULL, NULL, NULL, NULL, 4),
(120111, NULL, 'G3DSA:3.40.50.1360:FF:000005', NULL, NULL, '6-phosphogluconolactonase', NULL, NULL, NULL, NULL, NULL, 4),
(120112, NULL, 'G3DSA:3.80.10.10:FF:000716', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase GSO1', NULL, NULL, NULL, NULL, NULL, 4),
(120113, NULL, 'G3DSA:1.10.287.70:FF:000126', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(120114, NULL, 'G3DSA:2.120.10.80:FF:000159', NULL, NULL, 'tRNA wybutosine-synthesizing protein 2/3/4', NULL, NULL, NULL, NULL, NULL, 4),
(120115, NULL, 'G3DSA:4.10.240.10:FF:000034', NULL, NULL, 'Chromosome 16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(120116, NULL, 'G3DSA:1.10.20.120:FF:000002', NULL, NULL, 'Ribonuclease H2 subunit B', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(120117, NULL, 'G3DSA:3.30.160.60:FF:001727', NULL, NULL, 'Zinc finger protein 350', NULL, NULL, NULL, NULL, NULL, 4),
(120118, NULL, 'G3DSA:1.10.10.10:FF:000657', NULL, NULL, 'Two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(120119, NULL, 'G3DSA:1.10.20.140:FF:000008', NULL, NULL, 'tRNA dimethylallyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(120120, NULL, 'G3DSA:3.90.190.10:FF:000408', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120121, NULL, 'G3DSA:1.10.510.10:FF:001146', NULL, NULL, 'Protein CBG08226', NULL, NULL, NULL, NULL, NULL, 4),
(120122, NULL, 'G3DSA:3.30.70.270:FF:000236', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120123, NULL, 'G3DSA:1.25.40.10:FF:005061', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g62670, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(120124, NULL, 'G3DSA:1.20.920.10:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120125, NULL, 'G3DSA:3.40.50.300:FF:005713', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120126, NULL, 'G3DSA:3.30.40.10:FF:001013', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(120127, NULL, 'G3DSA:1.20.1070.10:FF:000254', NULL, NULL, 'Cholecystokinin receptor type A', NULL, NULL, NULL, NULL, NULL, 4),
(120128, NULL, 'G3DSA:1.20.1250.20:FF:002064', NULL, NULL, 'Os11g0284300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(120129, NULL, 'G3DSA:3.30.40.10:FF:000507', NULL, NULL, 'Transcription factor jumonji (JmjC) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(120130, NULL, 'G3DSA:3.40.50.720:FF:000606', NULL, NULL, 'Chromosome 15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(120131, NULL, 'G3DSA:1.10.1280.10:FF:000013', NULL, NULL, 'Tyrosinase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(120132, NULL, 'G3DSA:3.20.20.80:FF:000033', NULL, NULL, 'Glucan 1,3-beta-glucosidase A', NULL, NULL, NULL, NULL, NULL, 4),
(120133, NULL, 'G3DSA:1.20.1730.10:FF:000063', NULL, NULL, 'High-affinity choline transporter', NULL, NULL, NULL, NULL, NULL, 4),
(120134, NULL, 'G3DSA:1.10.630.10:FF:000800', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120135, NULL, 'G3DSA:3.40.50.620:FF:000874', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(120136, NULL, 'G3DSA:3.30.420.10:FF:000446', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120137, NULL, 'G3DSA:3.30.40.10:FF:000934', NULL, NULL, 'Os03g0648600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(120138, NULL, 'G3DSA:2.30.29.30:FF:000427', NULL, NULL, 'Adaptin ear-binding coat-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(120139, NULL, 'G3DSA:3.40.50.1820:FF:000755', NULL, NULL, 'Protein CBG02889', NULL, NULL, NULL, NULL, NULL, 4),
(120140, NULL, 'G3DSA:1.20.1070.10:FF:000372', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120141, NULL, 'G3DSA:1.10.600.10:FF:000057', NULL, NULL, 'Geranylgeranyl pyrophosphate synthetase, putative [includes: dimethylallyltranstransferase (Ec 2.5.1.1) geranyltranstransferase (Ec 2.5.1.10) farnesyltranstransferas (Ec 2.5.1.29)]', NULL, NULL, NULL, NULL, NULL, 4),
(120142, NULL, 'G3DSA:3.30.190.20:FF:000015', NULL, NULL, '50S ribosomal protein L1', NULL, NULL, NULL, NULL, NULL, 4),
(120143, NULL, 'G3DSA:2.10.25.10:FF:000245', NULL, NULL, 'latent-transforming growth factor beta-binding protein 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(120144, NULL, 'G3DSA:3.10.460.20:FF:000001', NULL, NULL, 'Matrix protein', NULL, NULL, NULL, NULL, NULL, 4),
(120145, NULL, 'G3DSA:3.90.1280.20:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120146, NULL, 'G3DSA:1.20.1250.20:FF:000681', NULL, NULL, 'Sugar efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(120147, NULL, 'G3DSA:2.10.25.10:FF:000924', NULL, NULL, 'Notch 3', NULL, NULL, NULL, NULL, NULL, 4),
(120148, NULL, 'G3DSA:3.90.190.10:FF:000307', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(120149, NULL, 'G3DSA:3.20.20.70:FF:000030', NULL, NULL, 'Nicotinate-nucleotide pyrophosphorylase, carboxylating', NULL, NULL, NULL, NULL, NULL, 4),
(120150, NULL, 'G3DSA:2.130.10.10:FF:001138', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(120151, NULL, 'G3DSA:3.90.1580.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120152, NULL, 'G3DSA:1.10.10.60:FF:001127', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120153, NULL, 'G3DSA:3.40.50.720:FF:000915', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(120154, NULL, 'G3DSA:1.10.630.10:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120155, NULL, 'G3DSA:3.30.40.10:FF:001322', NULL, NULL, 'GD24619', NULL, NULL, NULL, NULL, NULL, 4),
(120156, NULL, 'G3DSA:1.10.20.130:FF:000005', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(120157, NULL, 'G3DSA:3.10.20.410:FF:000008', NULL, NULL, 'Fimbrial biogenesis outer membrane usher protein', NULL, NULL, NULL, NULL, NULL, 4),
(120158, NULL, 'G3DSA:2.60.120.590:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120159, NULL, 'G3DSA:3.30.160.20:FF:000075', NULL, NULL, 'Os04g0529500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(120160, NULL, 'G3DSA:3.20.140.10:FF:000045', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(120161, NULL, 'G3DSA:3.40.50.150:FF:001094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120162, NULL, 'G3DSA:1.10.8.10:FF:000223', NULL, NULL, 'K7_Rup1p', NULL, NULL, NULL, NULL, NULL, 4),
(120163, NULL, 'G3DSA:3.40.50.970:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120164, NULL, 'G3DSA:1.10.150.50:FF:000106', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(120165, NULL, 'G3DSA:3.30.710.10:FF:000356', NULL, NULL, 'AaceriACR082Cp', NULL, NULL, NULL, NULL, NULL, 4),
(120166, NULL, 'G3DSA:3.30.70.600:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120167, NULL, 'G3DSA:3.40.50.300:FF:007276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120168, NULL, 'G3DSA:3.20.20.80:FF:000342', NULL, NULL, 'Malto-oligosyltrehalose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(120169, NULL, 'G3DSA:3.30.420.40:FF:000927', NULL, NULL, 'Actin-like protein 3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120170, NULL, 'G3DSA:3.40.50.300:FF:001661', NULL, NULL, 'RAD17 checkpoint clamp loader component', NULL, NULL, NULL, NULL, NULL, 4),
(120171, NULL, 'G3DSA:2.170.140.10:FF:000019', NULL, NULL, 'Mucin 26B', NULL, NULL, NULL, NULL, NULL, 4),
(120172, NULL, 'G3DSA:1.25.10.70:FF:000001', NULL, NULL, 'Nucleoporin NUP188', NULL, NULL, NULL, NULL, NULL, 4),
(120173, NULL, 'G3DSA:3.40.710.10:FF:000073', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(120174, NULL, 'G3DSA:3.30.40.10:FF:002216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120175, NULL, 'G3DSA:1.25.10.10:FF:003097', NULL, NULL, 'CLIP-associating protein', NULL, NULL, NULL, NULL, NULL, 4),
(120176, NULL, 'G3DSA:1.20.58.60:FF:000298', NULL, NULL, 'Spectrin repeat containing nuclear envelope protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(120177, NULL, 'G3DSA:3.30.70.330:FF:002087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120178, NULL, 'G3DSA:3.40.50.150:FF:000975', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120179, NULL, 'G3DSA:1.20.120.1070:FF:000004', NULL, NULL, 'GH22202', NULL, NULL, NULL, NULL, NULL, 4),
(120180, NULL, 'G3DSA:1.20.1260.10:FF:000055', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(120181, NULL, 'G3DSA:3.30.50.10:FF:000199', NULL, NULL, 'C2C2-GATA transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(120182, NULL, 'G3DSA:3.40.50.300:FF:001970', NULL, NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(120183, NULL, 'G3DSA:3.40.50.2000:FF:000944', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120184, NULL, 'G3DSA:2.120.10.30:FF:000577', NULL, NULL, 'Protein STRICTOSIDINE SYNTHASE-LIKE 3', NULL, NULL, NULL, NULL, NULL, 4),
(120185, NULL, 'G3DSA:1.25.40.20:FF:001382', NULL, NULL, 'Calmodulin-binding transcription activator 4', NULL, NULL, NULL, NULL, NULL, 4),
(120186, NULL, 'G3DSA:1.10.510.10:FF:000893', NULL, NULL, 'CAMK/CAMK1 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(120187, NULL, 'G3DSA:2.60.40.60:FF:000051', NULL, NULL, 'FAT atypical cadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(120188, NULL, 'G3DSA:3.40.1190.20:FF:000063', NULL, NULL, 'Pyridoxal kinase', NULL, NULL, NULL, NULL, NULL, 4),
(120189, NULL, 'G3DSA:3.30.710.10:FF:000238', NULL, NULL, 'Probable voltage-gated potassium channel subunit kvs-4', NULL, NULL, NULL, NULL, NULL, 4),
(120190, NULL, 'G3DSA:3.30.1520.10:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120191, NULL, 'G3DSA:2.130.10.10:FF:005533', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120192, NULL, 'G3DSA:2.130.10.10:FF:005281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120193, NULL, 'G3DSA:2.60.40.10:FF:004696', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120194, NULL, 'G3DSA:1.25.40.270:FF:000002', NULL, NULL, 'callose synthase 3', NULL, NULL, NULL, NULL, NULL, 4),
(120195, NULL, 'G3DSA:3.40.50.2300:FF:000456', NULL, NULL, 'Gamma-aminobutyric acid type B receptor subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(120196, NULL, 'G3DSA:1.25.10.10:FF:000837', NULL, NULL, 'Importin subunit alpha-3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120197, NULL, 'G3DSA:3.30.70.330:FF:002396', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120198, NULL, 'G3DSA:1.10.510.10:FF:002927', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120199, NULL, 'G3DSA:2.60.40.420:FF:000109', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(120200, NULL, 'G3DSA:1.20.120.1080:FF:000007', NULL, NULL, 'Probable ATP-dependent RNA helicase DHX35', NULL, NULL, NULL, NULL, NULL, 4),
(120201, NULL, 'G3DSA:1.10.640.10:FF:000065', NULL, NULL, 'Oxidase/peroxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120202, NULL, 'G3DSA:1.20.920.10:FF:000202', NULL, NULL, 'Bromodomain and WD repeat domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(120203, NULL, 'G3DSA:1.10.274.100:FF:000008', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(120204, NULL, 'G3DSA:2.60.110.10:FF:000004', NULL, NULL, 'THAUMATIN-LIKE PROTEIN 1', NULL, NULL, NULL, NULL, NULL, 4),
(120205, NULL, 'G3DSA:3.30.2130.30:FF:000042', NULL, NULL, 'Probable tRNA sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(120206, NULL, 'G3DSA:3.40.1380.20:FF:000010', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(120207, NULL, 'G3DSA:2.60.120.10:FF:000802', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120208, NULL, 'G3DSA:2.60.40.10:FF:001514', NULL, NULL, 'CD8 alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(120209, NULL, 'G3DSA:1.10.10.10:FF:001371', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(120210, NULL, 'G3DSA:2.30.30.100:FF:000193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120211, NULL, 'G3DSA:1.10.150.50:FF:000207', NULL, NULL, 'Sec-23 interacting protein P125, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120212, NULL, 'G3DSA:2.60.40.420:FF:000098', NULL, NULL, 'Putative multicopper oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(120213, NULL, 'G3DSA:1.10.630.10:FF:000480', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120214, NULL, 'G3DSA:2.60.120.290:FF:000219', NULL, NULL, 'CUB domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(120215, NULL, 'G3DSA:2.60.40.1730:FF:000106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120216, NULL, 'G3DSA:3.40.50.300:FF:007467', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(120217, NULL, 'G3DSA:3.20.20.140:FF:000442', NULL, NULL, 'ADR119Wp', NULL, NULL, NULL, NULL, NULL, 4),
(120218, NULL, 'G3DSA:3.40.920.10:FF:000010', NULL, NULL, 'Phenylglyoxylate acceptor oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(120219, NULL, 'G3DSA:1.20.120.690:FF:000001', NULL, NULL, 'Protein RDM1', NULL, NULL, NULL, NULL, NULL, 4),
(120220, NULL, 'G3DSA:3.40.50.620:FF:000195', NULL, NULL, 'Tryptophan--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(120221, NULL, 'G3DSA:1.20.58.2220:FF:000021', NULL, NULL, 'Formin 3, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(120222, NULL, 'G3DSA:1.20.1250.20:FF:002272', NULL, NULL, 'Galactoside permease', NULL, NULL, NULL, NULL, NULL, 4),
(120223, NULL, 'G3DSA:1.10.630.10:FF:000238', NULL, NULL, 'Cytochrome P450 2A6', NULL, NULL, NULL, NULL, NULL, 4),
(120224, NULL, 'G3DSA:2.130.10.10:FF:005180', NULL, NULL, 'Ribosome biogenesis protein WDR12 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(120225, NULL, 'G3DSA:3.40.220.10:FF:000002', NULL, NULL, 'Core histone macro-H2A', NULL, NULL, NULL, NULL, NULL, 4),
(120226, NULL, 'G3DSA:3.40.50.300:FF:007821', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120227, NULL, 'G3DSA:3.30.900.10:FF:000039', NULL, NULL, 'Spindle assembly checkpoint component MAD2', NULL, NULL, NULL, NULL, NULL, 4),
(120228, NULL, 'G3DSA:3.90.180.10:FF:000127', NULL, NULL, 'Alcohol dehydrogenase-like 6', NULL, NULL, NULL, NULL, NULL, 4),
(120229, NULL, 'G3DSA:2.130.10.10:FF:001239', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(120230, NULL, 'G3DSA:2.130.10.30:FF:000161', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120231, NULL, 'G3DSA:2.130.10.10:FF:001481', NULL, NULL, 'PRP4p Splicing factor', NULL, NULL, NULL, NULL, NULL, 4),
(120232, NULL, 'G3DSA:2.130.10.10:FF:000975', NULL, NULL, 'Dynein, axonemal, intermediate chain 2a', NULL, NULL, NULL, NULL, NULL, 4),
(120233, NULL, 'G3DSA:2.40.50.40:FF:000069', NULL, NULL, 'Chromatin remodeling factor CHD3 (PICKLE)', NULL, NULL, NULL, NULL, NULL, 4),
(120234, NULL, 'G3DSA:3.40.50.2300:FF:000557', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(120235, NULL, 'G3DSA:3.40.1800.20:FF:000026', NULL, NULL, 'LD47721p', NULL, NULL, NULL, NULL, NULL, 4),
(120236, NULL, 'G3DSA:2.40.50.140:FF:000599', NULL, NULL, 'tRNA binding domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120237, NULL, 'G3DSA:4.10.280.10:FF:000008', NULL, NULL, 'Nuclear receptor coactivator', NULL, NULL, NULL, NULL, NULL, 4),
(120238, NULL, 'G3DSA:1.10.246.90:FF:000021', NULL, NULL, 'U4/U6 small nuclear ribonucleoprotein Prp31', NULL, NULL, NULL, NULL, NULL, 4),
(120239, NULL, 'G3DSA:1.20.1250.20:FF:000473', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(120240, NULL, 'G3DSA:3.30.2310.20:FF:000002', NULL, NULL, 'mRNA interferase toxin RelE', NULL, NULL, NULL, NULL, NULL, 4),
(120241, NULL, 'G3DSA:2.130.10.10:FF:003381', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(120242, NULL, 'G3DSA:2.60.40.10:FF:003841', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120243, NULL, 'G3DSA:3.60.40.10:FF:000028', NULL, NULL, 'Protein phosphatase 1H', NULL, NULL, NULL, NULL, NULL, 4),
(120244, NULL, 'G3DSA:1.10.510.10:FF:001808', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120245, NULL, 'G3DSA:3.40.50.300:FF:005567', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120246, NULL, 'G3DSA:2.10.50.10:FF:000084', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 18', NULL, NULL, NULL, NULL, NULL, 4),
(120247, NULL, 'G3DSA:2.30.29.30:FF:000326', NULL, NULL, 'TBC1 domain family member 2B', NULL, NULL, NULL, NULL, NULL, 4),
(120248, NULL, 'G3DSA:1.10.8.1120:FF:000003', NULL, NULL, 'Histone RNA hairpin-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120249, NULL, 'G3DSA:3.40.50.11890:FF:000004', NULL, NULL, '(R)-2-hydroxyacyl-CoA dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(120250, NULL, 'G3DSA:3.30.505.10:FF:000031', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(120251, NULL, 'G3DSA:1.20.5.400:FF:000005', NULL, NULL, 'Centrosomal protein 164', NULL, NULL, NULL, NULL, NULL, 4),
(120252, NULL, 'G3DSA:2.30.30.100:FF:000237', NULL, NULL, 'Enhancer of mRNA-decapping protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(120253, NULL, 'G3DSA:3.30.70.330:FF:002749', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120254, NULL, 'G3DSA:3.40.50.1010:FF:000030', NULL, NULL, 'flap endonuclease GEN-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(120255, NULL, 'G3DSA:1.25.40.1030:FF:000002', NULL, NULL, 'Protein transport protein sec16', NULL, NULL, NULL, NULL, NULL, 4),
(120256, NULL, 'G3DSA:3.30.70.100:FF:000202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120257, NULL, 'G3DSA:2.10.25.10:FF:000716', NULL, NULL, 'Crumbs, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(120258, NULL, 'G3DSA:3.80.10.10:FF:003589', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120259, NULL, 'G3DSA:3.40.50.10190:FF:000045', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(120260, NULL, 'G3DSA:1.25.10.10:FF:001961', NULL, NULL, 'SYmmetrical Sister cell hermaphrodite gonad defect', NULL, NULL, NULL, NULL, NULL, 4),
(120261, NULL, 'G3DSA:3.30.70.330:FF:000951', NULL, NULL, 'nucleolysin TIA-1 isoform X7', NULL, NULL, NULL, NULL, NULL, 4),
(120262, NULL, 'G3DSA:1.10.1520.10:FF:000066', NULL, NULL, 'Mitochondrial ribosomal protein L44', NULL, NULL, NULL, NULL, NULL, 4),
(120263, NULL, 'G3DSA:1.20.1270.60:FF:000334', NULL, NULL, 'Rho GTPase-activating protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(120264, NULL, 'G3DSA:2.70.150.10:FF:000297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120265, NULL, 'G3DSA:3.40.50.150:FF:001138', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120266, NULL, 'G3DSA:1.20.1270.60:FF:000244', NULL, NULL, 'Rho-GTPase-activating protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(120267, NULL, 'G3DSA:3.40.50.1820:FF:000093', NULL, NULL, 'protein ABHD14A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(120268, NULL, 'G3DSA:3.30.450.20:FF:000086', NULL, NULL, 'PAS domain-containing sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(120269, NULL, 'G3DSA:2.130.10.10:FF:003038', NULL, NULL, 'Uncharacterized WD repeat-containing protein slr1410', NULL, NULL, NULL, NULL, NULL, 4),
(120270, NULL, 'G3DSA:3.30.160.60:FF:001374', NULL, NULL, 'zinc finger and BTB domain-containing protein 39', NULL, NULL, NULL, NULL, NULL, 4),
(120271, NULL, 'G3DSA:3.30.70.330:FF:002839', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120272, NULL, 'G3DSA:1.20.1250.10:FF:000127', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120273, NULL, 'G3DSA:3.30.450.20:FF:000176', NULL, NULL, 'Serine/threonine phosphatase containing a PAS domain', NULL, NULL, NULL, NULL, NULL, 4),
(120274, NULL, 'G3DSA:3.30.450.30:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120275, NULL, 'G3DSA:3.20.20.80:FF:000460', NULL, NULL, 'Putative metal-nicotianamine transporter YSL6', NULL, NULL, NULL, NULL, NULL, 4),
(120276, NULL, 'G3DSA:1.25.40.10:FF:003071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120277, NULL, 'G3DSA:2.60.120.200:FF:000676', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120278, NULL, 'G3DSA:1.25.40.10:FF:000665', NULL, NULL, 'Pre-mRNA-processing factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(120279, NULL, 'G3DSA:3.90.190.10:FF:000055', NULL, NULL, 'mRNA capping enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(120280, NULL, 'G3DSA:3.90.190.10:FF:000510', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120281, NULL, 'G3DSA:3.40.50.10190:FF:000146', NULL, NULL, 'BRCT domain protein (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(120282, NULL, 'G3DSA:3.30.200.20:FF:000377', NULL, NULL, 'Serine threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(120283, NULL, 'G3DSA:3.40.50.620:FF:000666', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120284, NULL, 'G3DSA:1.10.10.60:FF:001228', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(120285, NULL, 'G3DSA:3.30.930.10:FF:000221', NULL, NULL, 'Biotin--acetyl-CoA-carboxylase ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120286, NULL, 'G3DSA:1.20.1250.20:FF:000372', NULL, NULL, 'Monocarboxylate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(120287, NULL, 'G3DSA:2.40.270.10:FF:000020', NULL, NULL, 'DNA-directed RNA polymerase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(120288, NULL, 'G3DSA:3.50.50.60:FF:000617', NULL, NULL, 'Prenylcysteine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(120289, NULL, 'G3DSA:3.30.70.360:FF:000038', NULL, NULL, 'Dipeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120290, NULL, 'G3DSA:3.30.70.330:FF:000378', NULL, NULL, 'Cleavage stimulating factor 64', NULL, NULL, NULL, NULL, NULL, 4),
(120291, NULL, 'G3DSA:2.10.109.10:FF:000029', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(120292, NULL, 'G3DSA:3.10.129.10:FF:000274', NULL, NULL, 'Acyl-[acyl-carrier-protein] hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(120293, NULL, 'G3DSA:1.10.510.10:FF:003080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120294, NULL, 'G3DSA:3.30.365.10:FF:000042', NULL, NULL, 'Glyceraldehyde dehydrogenase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(120295, NULL, 'G3DSA:1.10.10.10:FF:000966', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(120296, NULL, 'G3DSA:3.40.50.10490:FF:000163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120297, NULL, 'G3DSA:2.60.120.260:FF:000587', NULL, NULL, 'Reelin', NULL, NULL, NULL, NULL, NULL, 4),
(120298, NULL, 'G3DSA:3.30.40.10:FF:001131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120299, NULL, 'G3DSA:3.30.2440.10:FF:000003', NULL, NULL, 'SPI-2 type III secretion system effector SifA', NULL, NULL, NULL, NULL, NULL, 4),
(120300, NULL, 'G3DSA:3.55.30.10:FF:000001', NULL, NULL, '33 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(120301, NULL, 'G3DSA:1.20.990.10:FF:000004', NULL, NULL, 'Sulfite reductase [NADPH] flavoprotein alpha-component', NULL, NULL, NULL, NULL, NULL, 4),
(120302, NULL, 'G3DSA:3.20.20.190:FF:000070', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(120303, NULL, 'G3DSA:1.25.10.10:FF:001079', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(120304, NULL, 'G3DSA:1.10.287.70:FF:000334', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120305, NULL, 'G3DSA:4.10.240.10:FF:000152', NULL, NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(120306, NULL, 'G3DSA:2.60.40.10:FF:001470', NULL, NULL, 'Advanced glycosylation end product-specific receptor', NULL, NULL, NULL, NULL, NULL, 4),
(120307, NULL, 'G3DSA:3.40.50.300:FF:001318', NULL, NULL, 'DNA repair protein RAD51', NULL, NULL, NULL, NULL, NULL, 4),
(120308, NULL, 'G3DSA:1.10.101.10:FF:000032', NULL, NULL, 'ErfK/YbiS/YcfS/YnhG family protein', NULL, NULL, NULL, NULL, NULL, 4),
(120309, NULL, 'G3DSA:1.25.40.20:FF:000201', NULL, NULL, 'NF-kappa-B inhibitor beta', NULL, NULL, NULL, NULL, NULL, 4),
(120310, NULL, 'G3DSA:3.60.15.10:FF:000077', NULL, NULL, 'Ribonuclease J', NULL, NULL, NULL, NULL, NULL, 4),
(120311, NULL, 'G3DSA:3.30.160.60:FF:000401', NULL, NULL, 'Zinc finger and AT-hook domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(120312, NULL, 'G3DSA:2.30.30.830:FF:000001', NULL, NULL, 'Type 4 fimbrial biogenesis protein PilP', NULL, NULL, NULL, NULL, NULL, 4),
(120313, NULL, 'G3DSA:2.30.40.10:FF:000122', NULL, NULL, 'Prolidase (Xaa-Pro dipeptidase) (PepQ-like1)', NULL, NULL, NULL, NULL, NULL, 4),
(120314, NULL, 'G3DSA:3.30.390.130:FF:000001', NULL, NULL, 'Probable E3 ubiquitin-protein ligase DTX3', NULL, NULL, NULL, NULL, NULL, 4),
(120315, NULL, 'G3DSA:3.10.200.10:FF:000007', NULL, NULL, 'Alpha carbonic anhydrase 3', NULL, NULL, NULL, NULL, NULL, 4),
(120316, NULL, 'G3DSA:3.10.129.110:FF:000019', NULL, NULL, 'Polyketide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(120317, NULL, 'G3DSA:1.10.287.130:FF:000178', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(120318, NULL, 'G3DSA:2.60.40.10:FF:003268', NULL, NULL, 'Cytokine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(120319, NULL, 'G3DSA:3.40.50.300:FF:003218', NULL, NULL, 'ABC a-pheromone efflux pump AtrD', NULL, NULL, NULL, NULL, NULL, 4),
(120320, NULL, 'G3DSA:3.40.50.2300:FF:001271', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120321, NULL, 'G3DSA:3.30.390.150:FF:000007', NULL, NULL, 'Tenomodulin', NULL, NULL, NULL, NULL, NULL, 4),
(120322, NULL, 'G3DSA:3.40.190.10:FF:000976', NULL, NULL, 'Maltose ABC transporter, maltose binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(120323, NULL, 'G3DSA:3.40.367.20:FF:000053', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(120324, NULL, 'G3DSA:3.30.200.20:FF:000938', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120325, NULL, 'G3DSA:1.25.40.20:FF:001483', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120326, NULL, 'G3DSA:2.40.37.10:FF:000029', NULL, NULL, 'Arginine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(120327, NULL, 'G3DSA:3.10.20.770:FF:000021', NULL, NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(120328, NULL, 'G3DSA:3.30.420.610:FF:000002', NULL, NULL, 'Meiosis regulator and mRNA stability factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(120329, NULL, 'G3DSA:3.40.190.10:FF:000667', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120330, NULL, 'G3DSA:1.10.1240.10:FF:000005', NULL, NULL, 'Methionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(120331, NULL, 'G3DSA:1.20.1560.10:FF:000437', NULL, NULL, 'Protein CBR-PGP-7', NULL, NULL, NULL, NULL, NULL, 4),
(120332, NULL, 'G3DSA:2.10.10.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120333, NULL, 'G3DSA:3.80.10.10:FF:002616', NULL, NULL, 'Leucine-rich repeat serine/threonine-protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(120334, NULL, 'G3DSA:2.10.25.10:FF:001689', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120335, NULL, 'G3DSA:2.60.470.10:FF:000008', NULL, NULL, 'Pickpocket 26', NULL, NULL, NULL, NULL, NULL, 4),
(120336, NULL, 'G3DSA:3.40.30.10:FF:000236', NULL, NULL, 'Chloride intracellular channel 1', NULL, NULL, NULL, NULL, NULL, 4),
(120337, NULL, 'G3DSA:3.40.50.1820:FF:001020', NULL, NULL, 'protein ABHD14B', NULL, NULL, NULL, NULL, NULL, 4),
(120338, NULL, 'G3DSA:3.40.50.410:FF:000025', NULL, NULL, 'Vitrin', NULL, NULL, NULL, NULL, NULL, 4),
(120339, NULL, 'G3DSA:2.170.120.30:FF:000001', NULL, NULL, 'YbbR-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(120340, NULL, 'G3DSA:1.25.40.10:FF:001480', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(120341, NULL, 'G3DSA:1.25.40.10:FF:002874', NULL, NULL, 'YALI0F27753p', NULL, NULL, NULL, NULL, NULL, 4),
(120342, NULL, 'G3DSA:2.60.40.10:FF:005522', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120343, NULL, 'G3DSA:3.30.470.20:FF:000194', NULL, NULL, 'Synapsin III', NULL, NULL, NULL, NULL, NULL, 4),
(120344, NULL, 'G3DSA:1.50.10.10:FF:000161', NULL, NULL, 'Family 48 cellulase', NULL, NULL, NULL, NULL, NULL, 4),
(120345, NULL, 'G3DSA:3.40.50.10140:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120346, NULL, 'G3DSA:1.20.1560.10:FF:000128', NULL, NULL, 'ABC transporter B family member 21', NULL, NULL, NULL, NULL, NULL, 4),
(120347, NULL, 'G3DSA:3.40.50.150:FF:001447', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120348, NULL, 'G3DSA:1.20.58.60:FF:000192', NULL, NULL, 'coiled-coil domain-containing protein 141 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(120349, NULL, 'G3DSA:2.10.90.10:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120350, NULL, 'G3DSA:3.40.50.720:FF:000707', NULL, NULL, 'Trk system potassium uptake protein TrkA', NULL, NULL, NULL, NULL, NULL, 4),
(120351, NULL, 'G3DSA:3.40.50.300:FF:007731', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(120352, NULL, 'G3DSA:3.40.250.10:FF:000037', NULL, NULL, 'Dual-specificity phosphatase CDC25', NULL, NULL, NULL, NULL, NULL, 4),
(120353, NULL, 'G3DSA:3.40.50.10130:FF:000044', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120354, NULL, 'G3DSA:3.30.870.10:FF:000188', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120355, NULL, 'G3DSA:3.40.1670.10:FF:000006', NULL, NULL, '3-octaprenyl-4-hydroxybenzoate carboxy-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(120356, NULL, 'G3DSA:4.10.1000.10:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120357, NULL, 'G3DSA:1.25.40.20:FF:001792', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120358, NULL, 'G3DSA:2.130.10.30:FF:000059', NULL, NULL, 'Alpha tubulin suppressor', NULL, NULL, NULL, NULL, NULL, 4),
(120359, NULL, 'G3DSA:3.40.50.2300:FF:000809', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120360, NULL, 'G3DSA:3.30.160.60:FF:003526', NULL, NULL, 'Chromosome undetermined SCAF9247, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(120361, NULL, 'G3DSA:2.170.120.40:FF:000004', NULL, NULL, 'CdaA regulatory protein CdaR', NULL, NULL, NULL, NULL, NULL, 4),
(120362, NULL, 'G3DSA:1.20.1270.10:FF:000027', NULL, NULL, 'Heat shock protein 70', NULL, NULL, NULL, NULL, NULL, 4),
(120363, NULL, 'G3DSA:3.40.50.150:FF:001801', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120364, NULL, 'G3DSA:1.25.10.10:FF:003333', NULL, NULL, 'AEL006Wp', NULL, NULL, NULL, NULL, NULL, 4),
(120365, NULL, 'G3DSA:3.40.630.30:FF:000224', NULL, NULL, 'N-acetyltransferase Eis', NULL, NULL, NULL, NULL, NULL, 4),
(120366, NULL, 'G3DSA:3.80.10.10:FF:000245', NULL, NULL, 'Leucine rich repeat containing 55', NULL, NULL, NULL, NULL, NULL, 4),
(120367, NULL, 'G3DSA:3.40.20.10:FF:000101', NULL, NULL, 'Actin-depolymerizing factor 2, isoform c', NULL, NULL, NULL, NULL, NULL, 4),
(120368, NULL, 'G3DSA:2.30.42.10:FF:000059', NULL, NULL, 'unconventional myosin-XVIIIa isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(120369, NULL, 'G3DSA:1.25.40.1040:FF:000005', NULL, NULL, 'Cleavage stimulation factor subunit 77', NULL, NULL, NULL, NULL, NULL, 4),
(120370, NULL, 'G3DSA:3.30.200.20:FF:001091', NULL, NULL, 'Dual specificity mitogen-activated protein kinase kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(120371, NULL, 'G3DSA:3.40.50.300:FF:007512', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120372, NULL, 'G3DSA:3.40.50.10330:FF:000014', NULL, NULL, 'NAD kinase a', NULL, NULL, NULL, NULL, NULL, 4),
(120373, NULL, 'G3DSA:1.25.10.10:FF:003243', NULL, NULL, 'Protein CELLULOSE SYNTHASE INTERACTIVE 3', NULL, NULL, NULL, NULL, NULL, 4),
(120374, NULL, 'G3DSA:2.60.220.50:FF:000092', NULL, NULL, 'Adhesion G protein-coupled receptor L1', NULL, NULL, NULL, NULL, NULL, 4),
(120375, NULL, 'G3DSA:1.20.5.110:FF:000351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120376, NULL, 'G3DSA:3.60.10.10:FF:000291', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120377, NULL, 'G3DSA:1.25.40.470:FF:000045', NULL, NULL, 'Intraflagellar transport 140', NULL, NULL, NULL, NULL, NULL, 4),
(120378, NULL, 'G3DSA:2.130.10.10:FF:002875', NULL, NULL, 'NACHT and WD40 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(120379, NULL, 'G3DSA:2.40.50.140:FF:001010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120380, NULL, 'G3DSA:1.20.58.60:FF:000444', NULL, NULL, 'AGAP009554-PA', NULL, NULL, NULL, NULL, NULL, 4),
(120381, NULL, 'G3DSA:1.10.10.60:FF:000964', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120382, NULL, 'G3DSA:1.25.10.10:FF:001181', NULL, NULL, 'Epoxyqueuosine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(120383, NULL, 'G3DSA:3.40.850.10:FF:000358', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120384, NULL, 'G3DSA:1.10.510.10:FF:001247', NULL, NULL, 'Myosin Light Chain Kinase related', NULL, NULL, NULL, NULL, NULL, 4),
(120385, NULL, 'G3DSA:1.10.287.130:FF:000223', NULL, NULL, 'GAF domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(120386, NULL, 'G3DSA:3.30.70.560:FF:000008', NULL, NULL, '2-amino-4-hydroxy-6-hydroxymethyldihydropteridine pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(120387, NULL, 'G3DSA:2.40.50.140:FF:000392', NULL, NULL, 'RecQ mediated genome instability 2', NULL, NULL, NULL, NULL, NULL, 4),
(120388, NULL, 'G3DSA:3.30.160.60:FF:005735', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120389, NULL, 'G3DSA:3.30.160.60:FF:003274', NULL, NULL, 'Zinc finger protein 408', NULL, NULL, NULL, NULL, NULL, 4),
(120390, NULL, 'G3DSA:3.30.420.10:FF:000345', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120391, NULL, 'G3DSA:1.25.40.660:FF:000012', NULL, NULL, 'Vacuolar protein sorting-associated protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(120392, NULL, 'G3DSA:3.40.50.300:FF:005360', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120393, NULL, 'G3DSA:1.10.132.30:FF:000019', NULL, NULL, 'DNA-directed RNA polymerase IV subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(120394, NULL, 'G3DSA:3.80.10.10:FF:002706', NULL, NULL, 'Receptor-like protein kinase HSL1', NULL, NULL, NULL, NULL, NULL, 4),
(120395, NULL, 'G3DSA:3.30.70.330:FF:000849', NULL, NULL, 'Os03g0374575 protein', NULL, NULL, NULL, NULL, NULL, 4),
(120396, NULL, 'G3DSA:2.60.40.10:FF:005213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120397, NULL, 'G3DSA:3.30.342.10:FF:000017', NULL, NULL, 'DNA polymerase epsilon catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(120398, NULL, 'G3DSA:1.10.565.10:FF:000215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120399, NULL, 'G3DSA:1.20.920.10:FF:000056', NULL, NULL, 'Bromodomain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(120400, NULL, 'G3DSA:1.10.238.10:FF:001237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120401, NULL, 'G3DSA:3.90.25.10:FF:000071', NULL, NULL, 'dTDP-4-dehydrorhamnose reductase', NULL, NULL, NULL, NULL, NULL, 4),
(120402, NULL, 'G3DSA:3.40.50.1760:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120403, NULL, 'G3DSA:2.10.10.100:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120404, NULL, 'G3DSA:1.20.1070.10:FF:000725', NULL, NULL, '5-hydroxytryptamine (Serotonin) receptor 2B, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(120405, NULL, 'G3DSA:1.20.58.1020:FF:000010', NULL, NULL, 'DNA replication complex GINS protein PSF2', NULL, NULL, NULL, NULL, NULL, 4),
(120406, NULL, 'G3DSA:2.120.10.80:FF:000367', NULL, NULL, 'Multiple EGF like domains 8', NULL, NULL, NULL, NULL, NULL, 4),
(120407, NULL, 'G3DSA:3.40.50.10320:FF:000011', NULL, NULL, 'N-acetylglucosaminylphosphatidylinositol deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(120408, NULL, 'G3DSA:3.30.160.60:FF:006399', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120409, NULL, 'G3DSA:3.40.50.12780:FF:000108', NULL, NULL, 'NonRibosomal Peptide Synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(120410, NULL, 'G3DSA:2.60.120.10:FF:000022', NULL, NULL, 'Patatin like phospholipase domain containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(120411, NULL, 'G3DSA:3.30.160.60:FF:005426', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120412, NULL, 'G3DSA:1.25.40.10:FF:004717', NULL, NULL, 'Tetratricopeptide repeat protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(120413, NULL, 'G3DSA:1.10.8.10:FF:000077', NULL, NULL, 'Ubiquilin like', NULL, NULL, NULL, NULL, NULL, 4),
(120414, NULL, 'G3DSA:1.20.5.1430:FF:000020', NULL, NULL, 'Microtubule plus-end binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(120415, NULL, 'G3DSA:1.20.1270.330:FF:000001', NULL, NULL, 'EscN/YscN/HrcN family type III secretion system ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(120416, NULL, 'G3DSA:2.130.10.10:FF:001902', NULL, NULL, 'AGAP008620-PA', NULL, NULL, NULL, NULL, NULL, 4),
(120417, NULL, 'G3DSA:3.40.50.1000:FF:000757', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120418, NULL, 'G3DSA:1.50.40.10:FF:000101', NULL, NULL, 'SLC (SoLute Carrier) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(120419, NULL, 'G3DSA:3.40.140.70:FF:000013', NULL, NULL, 'Ubiquitin-like modifier-activating enzyme atg7', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(120420, NULL, 'G3DSA:3.30.420.10:FF:000036', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(120421, NULL, 'G3DSA:1.20.920.20:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120422, NULL, 'G3DSA:3.40.1450.10:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120423, NULL, 'G3DSA:3.40.630.30:FF:000325', NULL, NULL, 'Putative acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(120424, NULL, 'G3DSA:3.30.70.330:FF:000934', NULL, NULL, 'Polyadenylate-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120425, NULL, 'G3DSA:2.170.130.10:FF:000081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120426, NULL, 'G3DSA:1.20.1270.60:FF:000025', NULL, NULL, 'arf-GAP with coiled-coil, ANK repeat and PH domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(120427, NULL, 'G3DSA:3.40.50.450:FF:000020', NULL, NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(120428, NULL, 'G3DSA:3.90.640.10:FF:000281', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120429, NULL, 'G3DSA:3.30.559.10:FF:000094', NULL, NULL, 'Mitochondrial carnitine O-acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120430, NULL, 'G3DSA:3.40.50.10090:FF:000015', NULL, NULL, 'Uroporphyrinogen III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(120431, NULL, 'G3DSA:1.20.1720.10:FF:000118', NULL, NULL, 'Bcr/CflA family efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(120432, NULL, 'G3DSA:1.25.40.1040:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120433, NULL, 'G3DSA:1.20.1270.10:FF:000117', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(120434, NULL, 'G3DSA:3.40.50.460:FF:000023', NULL, NULL, 'Phosphofructokinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(120435, NULL, 'G3DSA:1.10.10.10:FF:001781', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120436, NULL, 'G3DSA:3.40.20.10:FF:000056', NULL, NULL, 'Quail, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(120437, NULL, 'G3DSA:1.20.1250.20:FF:000602', NULL, NULL, 'MFS family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(120438, NULL, 'G3DSA:3.30.1950.10:FF:000002', NULL, NULL, 'Periplasmic polysaccharide biosynthesis/export protein', NULL, NULL, NULL, NULL, NULL, 4),
(120439, NULL, 'G3DSA:2.20.100.10:FF:000119', NULL, NULL, 'Circumsporozoite-and TRAP-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(120440, NULL, 'G3DSA:2.60.120.920:FF:000021', NULL, NULL, 'Si:dkey-16p6.1', NULL, NULL, NULL, NULL, NULL, 4),
(120441, NULL, 'G3DSA:3.40.50.300:FF:001526', NULL, NULL, 'GPN-loop GTPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(120442, NULL, 'G3DSA:1.10.287.70:FF:000216', NULL, NULL, 'Polycystic kidney disease 1b', NULL, NULL, NULL, NULL, NULL, 4),
(120443, NULL, 'G3DSA:1.10.287.70:FF:000098', NULL, NULL, 'Potassium two pore domain channel subfamily K member 16', NULL, NULL, NULL, NULL, NULL, 4),
(120444, NULL, 'G3DSA:3.30.420.10:FF:000362', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120445, NULL, 'G3DSA:3.90.360.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120446, NULL, 'G3DSA:1.10.630.10:FF:000710', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120447, NULL, 'G3DSA:1.10.510.10:FF:001056', NULL, NULL, 'STE/STE20/MST protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(120448, NULL, 'G3DSA:1.10.10.10:FF:001253', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(120449, NULL, 'G3DSA:3.20.20.30:FF:000035', NULL, NULL, 'Natural product biosynthesis luciferase-like monooxygenase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(120450, NULL, 'G3DSA:1.10.560.10:FF:000002', NULL, NULL, '60 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(120451, NULL, 'G3DSA:3.30.450.20:FF:000406', NULL, NULL, 'C4-dicarboxylate transport sensor protein dctB', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(120452, NULL, 'G3DSA:3.90.190.10:FF:000280', NULL, NULL, 'Protein-tyrosine phosphatase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(120453, NULL, 'G3DSA:3.30.420.40:FF:000899', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(120454, NULL, 'G3DSA:1.20.58.60:FF:000219', NULL, NULL, 'Uncharacterized protein, isoform J', NULL, NULL, NULL, NULL, NULL, 4),
(120455, NULL, 'G3DSA:3.30.70.330:FF:000395', NULL, NULL, 'Polyadenylate-binding protein RBP47', NULL, NULL, NULL, NULL, NULL, 4),
(120456, NULL, 'G3DSA:1.10.10.2670:FF:000001', NULL, NULL, 'E3 ubiquitin-protein ligase UBR2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(120457, NULL, 'G3DSA:3.20.20.140:FF:000425', NULL, NULL, 'Allantoinase', NULL, NULL, NULL, NULL, NULL, 4),
(120458, NULL, 'G3DSA:2.130.10.10:FF:001711', NULL, NULL, 'Transducin beta-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(120459, NULL, 'G3DSA:3.40.190.10:FF:000875', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120460, NULL, 'G3DSA:3.40.50.620:FF:000902', NULL, NULL, 'Os01g0691500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(120461, NULL, 'G3DSA:1.20.920.20:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120462, NULL, 'G3DSA:1.20.920.10:FF:000073', NULL, NULL, 'Chromatin structure-remodeling complex subunit rsc4', NULL, NULL, NULL, NULL, NULL, 4),
(120463, NULL, 'G3DSA:1.10.2000.10:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120464, NULL, 'G3DSA:3.40.50.300:FF:007361', NULL, NULL, 'Transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120465, NULL, 'G3DSA:3.40.1490.10:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120466, NULL, 'G3DSA:3.20.20.20:FF:000032', NULL, NULL, '4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase (flavodoxin)', NULL, NULL, NULL, NULL, NULL, 4),
(120467, NULL, 'G3DSA:1.25.10.10:FF:001416', NULL, NULL, 'Proteasome-associated protein ECM29 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(120468, NULL, 'G3DSA:1.20.1310.20:FF:000051', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(120469, NULL, 'G3DSA:1.10.287.3240:FF:000022', NULL, NULL, 'V-type proton ATPase subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(120470, NULL, 'G3DSA:3.40.50.12780:FF:000182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120471, NULL, 'G3DSA:3.40.50.300:FF:006888', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(120472, NULL, 'G3DSA:1.10.287.70:FF:000109', NULL, NULL, 'Voltage-gated potassium channel', NULL, NULL, NULL, NULL, NULL, 4),
(120473, NULL, 'G3DSA:2.130.10.10:FF:004893', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120474, NULL, 'G3DSA:2.60.120.290:FF:000236', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(120475, NULL, 'G3DSA:3.40.30.10:FF:000028', NULL, NULL, 'Glutaredoxin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(120476, NULL, 'G3DSA:1.10.8.60:FF:000171', NULL, NULL, 'Lon protease', NULL, NULL, NULL, NULL, NULL, 4),
(120477, NULL, 'G3DSA:3.30.70.1180:FF:000015', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(120478, NULL, 'G3DSA:1.10.8.10:FF:000307', NULL, NULL, 'Doublesex- and mab-3-related transcription factor A2', NULL, NULL, NULL, NULL, NULL, 4),
(120479, NULL, 'G3DSA:3.80.10.10:FF:000155', NULL, NULL, 'Putative inactive leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(120480, NULL, 'G3DSA:3.90.950.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120481, NULL, 'G3DSA:3.40.50.1220:FF:000019', NULL, NULL, 'NAD-dependent protein deacetylase sirtuin-1', NULL, NULL, NULL, NULL, NULL, 4),
(120482, NULL, 'G3DSA:2.70.100.10:FF:000001', NULL, NULL, 'Glucanase', NULL, NULL, NULL, NULL, NULL, 4),
(120483, NULL, 'G3DSA:3.90.190.10:FF:000173', NULL, NULL, 'Dual specificity protein phosphatase putative', NULL, NULL, NULL, NULL, NULL, 4),
(120484, NULL, 'G3DSA:3.40.50.10490:FF:000045', NULL, NULL, '30S ribosomal protein S2', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(120485, NULL, 'G3DSA:2.60.40.4230:FF:000002', NULL, NULL, 'Resistin-like alpha', NULL, NULL, NULL, NULL, NULL, 4),
(120486, NULL, 'G3DSA:3.40.630.10:FF:000376', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120487, NULL, 'G3DSA:1.10.510.10:FF:003287', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120488, NULL, 'G3DSA:3.30.200.20:FF:001203', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(120489, NULL, 'G3DSA:3.40.50.20:FF:000038', NULL, NULL, 'Biotin carboxylase subunit of acetyl CoA carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(120490, NULL, 'G3DSA:3.30.450.20:FF:000513', NULL, NULL, 'Transcription activator of gluconeogenesis ERT1', NULL, NULL, NULL, NULL, NULL, 4),
(120491, NULL, 'G3DSA:3.50.50.60:FF:000926', NULL, NULL, '3-hydroxybenzoate 4-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(120492, NULL, 'G3DSA:3.40.430.10:FF:000012', NULL, NULL, 'Riboflavin biosynthesis protein RibD', NULL, NULL, NULL, NULL, NULL, 4),
(120493, NULL, 'G3DSA:3.30.40.10:FF:000524', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(120494, NULL, 'G3DSA:3.30.460.10:FF:000005', NULL, NULL, 'terminal uridylyltransferase 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(120495, NULL, 'G3DSA:3.40.50.1820:FF:000323', NULL, NULL, 'Homoserine O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(120496, NULL, 'G3DSA:3.80.10.10:FF:000481', NULL, NULL, 'F-box/LRR-repeat protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(120497, NULL, 'G3DSA:1.20.1560.10:FF:000027', NULL, NULL, 'ATP-binding cassette subfamily C member 4', NULL, NULL, NULL, NULL, NULL, 4),
(120498, NULL, 'G3DSA:1.20.58.60:FF:000854', NULL, NULL, 'Spectrin beta chain, non-erythrocytic 5-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(120499, NULL, 'G3DSA:3.40.1110.10:FF:000105', NULL, NULL, 'Calcium-translocating P-type ATPase, PMCA-type', NULL, NULL, NULL, NULL, NULL, 4),
(120500, NULL, 'G3DSA:3.40.50.150:FF:001548', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120501, NULL, 'G3DSA:3.60.40.10:FF:000146', NULL, NULL, 'Protein phosphatase 2C', NULL, NULL, NULL, NULL, NULL, 4),
(120502, NULL, 'G3DSA:3.30.420.10:FF:000255', NULL, NULL, 'Reverse transcriptase, RNaseH, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120503, NULL, 'G3DSA:1.10.3370.10:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120504, NULL, 'G3DSA:3.30.200.20:FF:001310', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120505, NULL, 'G3DSA:2.60.40.10:FF:003622', NULL, NULL, 'Hemocyte protein-glutamine gamma-glutamyltransferase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(120506, NULL, 'G3DSA:3.40.1110.10:FF:000212', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(120507, NULL, 'G3DSA:2.40.50.140:FF:000583', NULL, NULL, 'Holliday junction ATP-dependent DNA helicase RuvA', NULL, NULL, NULL, NULL, NULL, 4),
(120508, NULL, 'G3DSA:1.10.1200.10:FF:000031', NULL, NULL, 'Acyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(120509, NULL, 'G3DSA:3.30.200.20:FF:002294', NULL, NULL, 'Spore coat protein I', NULL, NULL, NULL, NULL, NULL, 4),
(120510, NULL, 'G3DSA:3.30.450.40:FF:000199', NULL, NULL, 'Stage II sporulation E family protein', NULL, NULL, NULL, NULL, NULL, 4),
(120511, NULL, 'G3DSA:1.20.58.860:FF:000019', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(120512, NULL, 'G3DSA:3.30.160.60:FF:003408', NULL, NULL, 'H0806H05.6 protein', NULL, NULL, NULL, NULL, NULL, 4),
(120513, NULL, 'G3DSA:2.40.20.10:FF:000013', NULL, NULL, 'Plasminogen', NULL, NULL, NULL, NULL, NULL, 4),
(120514, NULL, 'G3DSA:3.40.190.80:FF:000053', NULL, NULL, 'Fructose-1,6-bisphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(120515, NULL, 'G3DSA:3.30.230.10:FF:000292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120516, NULL, 'G3DSA:1.10.10.10:FF:001146', NULL, NULL, 'Cyclic AMP receptor protein', NULL, NULL, NULL, NULL, NULL, 4),
(120517, NULL, 'G3DSA:1.50.10.20:FF:000074', NULL, NULL, 'F3F9.1', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(120518, NULL, 'G3DSA:2.60.40.10:FF:001054', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', NULL, NULL, NULL, NULL, NULL, 4),
(120519, NULL, 'G3DSA:3.90.1530.10:FF:000002', NULL, NULL, 'Putative transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(120520, NULL, 'G3DSA:1.20.1560.10:FF:000881', NULL, NULL, 'ABC multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120521, NULL, 'G3DSA:1.10.510.10:FF:001163', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(120522, NULL, 'G3DSA:3.60.40.10:FF:000253', NULL, NULL, 'Serine phosphatase, SpoIIE domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(120523, NULL, 'G3DSA:3.30.160.60:FF:005179', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120524, NULL, 'G3DSA:3.40.50.720:FF:000146', NULL, NULL, 'Ketol-acid reductoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(120525, NULL, 'G3DSA:3.30.200.20:FF:000686', NULL, NULL, 'Ribosomal protein S6 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(120526, NULL, 'G3DSA:1.10.1530.10:FF:000005', NULL, NULL, 'L-malate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(120527, NULL, 'G3DSA:3.30.230.10:FF:000185', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(120528, NULL, 'G3DSA:3.30.420.40:FF:000697', NULL, NULL, 'Carbohydrate kinase FGGY', NULL, NULL, NULL, NULL, NULL, 4),
(120529, NULL, 'G3DSA:1.10.418.70:FF:000004', NULL, NULL, 'Intraflagellar transport protein 81', NULL, NULL, NULL, NULL, NULL, 4),
(120530, NULL, 'G3DSA:1.25.40.210:FF:000001', NULL, NULL, 'Telomeric repeat-binding factor', NULL, NULL, NULL, NULL, NULL, 4),
(120531, NULL, 'G3DSA:3.40.50.300:FF:000110', NULL, NULL, 'tight junction protein ZO-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(120532, NULL, 'G3DSA:1.50.10.10:FF:000071', NULL, NULL, 'Non-lysosomal glucosylceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(120533, NULL, 'G3DSA:2.10.25.10:FF:000155', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(120534, NULL, 'G3DSA:1.25.10.10:FF:003350', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120535, NULL, 'G3DSA:3.30.70.2460:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120536, NULL, 'G3DSA:1.10.10.60:FF:000857', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120537, NULL, 'G3DSA:3.60.10.10:FF:000318', NULL, NULL, 'Salivary nitrophorin', NULL, NULL, NULL, NULL, NULL, 4),
(120538, NULL, 'G3DSA:1.10.10.1200:FF:000010', NULL, NULL, 'Melanoma antigen, family A, 4', NULL, NULL, NULL, NULL, NULL, 4),
(120539, NULL, 'G3DSA:2.60.120.200:FF:000805', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120540, NULL, 'G3DSA:3.80.10.10:FF:000262', NULL, NULL, 'F-box/LRR-repeat protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(120541, NULL, 'G3DSA:1.20.120.1320:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120542, NULL, 'G3DSA:2.20.28.290:FF:000001', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(120543, NULL, 'G3DSA:1.50.10.160:FF:000003', NULL, NULL, 'Aphidicolan-16-beta-ol synthase', NULL, NULL, NULL, NULL, NULL, 4),
(120544, NULL, 'G3DSA:2.130.10.10:FF:003600', NULL, NULL, 'p21-activated protein kinase-interacting protein 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(120545, NULL, 'G3DSA:2.60.120.200:FF:000575', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120546, NULL, 'G3DSA:1.10.150.510:FF:000001', NULL, NULL, 'Receptor activity modifying protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(120547, NULL, 'G3DSA:2.130.10.10:FF:004584', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120548, NULL, 'G3DSA:2.60.40.10:FF:005106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120549, NULL, 'G3DSA:3.40.50.2020:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120550, NULL, 'G3DSA:3.40.50.300:FF:006995', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(120551, NULL, 'G3DSA:3.30.450.20:FF:000193', NULL, NULL, 'Transcriptional regulator, LuxR family', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(120552, NULL, 'G3DSA:3.90.70.10:FF:000023', NULL, NULL, 'Senescence-specific cysteine protease SAG39', NULL, NULL, NULL, NULL, NULL, 4),
(120553, NULL, 'G3DSA:3.80.10.10:FF:004533', NULL, NULL, 'F-box domain containing protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(120554, NULL, 'G3DSA:1.20.58.830:FF:000010', NULL, NULL, 'Erythrocyte-binding antigen 175', NULL, NULL, NULL, NULL, NULL, 4),
(120555, NULL, 'G3DSA:3.30.70.2450:FF:000003', NULL, NULL, 'p-nitrophenol monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(120556, NULL, 'G3DSA:1.20.910.10:FF:000005', NULL, NULL, 'Heme oxygenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(120557, NULL, 'G3DSA:2.130.10.10:FF:005724', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120558, NULL, 'G3DSA:1.25.40.20:FF:001612', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120559, NULL, 'G3DSA:1.25.40.570:FF:000002', NULL, NULL, 'COP9 signalosome complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(120560, NULL, 'G3DSA:2.30.30.140:FF:000215', NULL, NULL, 'Chromatin modification-related protein EAF3', NULL, NULL, NULL, NULL, NULL, 4),
(120561, NULL, 'G3DSA:3.40.50.300:FF:001852', NULL, NULL, 'Peroxisomal biogenesis factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(120562, NULL, 'G3DSA:3.30.160.60:FF:003627', NULL, NULL, 'Zinc finger protein PAG-3', NULL, NULL, NULL, NULL, NULL, 4),
(120563, NULL, 'G3DSA:2.40.128.260:FF:000001', NULL, NULL, 'Type IV secretion system protein', NULL, NULL, NULL, NULL, NULL, 4),
(120564, NULL, 'G3DSA:3.40.250.10:FF:000240', NULL, NULL, 'Rhodanese homology domain pair protein', NULL, NULL, NULL, NULL, NULL, 4),
(120565, NULL, 'G3DSA:2.10.60.10:FF:000040', NULL, NULL, 'Lymphocyte antigen 6 complex locus G6D', NULL, NULL, NULL, NULL, NULL, 4),
(120566, NULL, 'G3DSA:2.170.16.10:FF:000014', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(120567, NULL, 'G3DSA:1.25.10.10:FF:001096', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120568, NULL, 'G3DSA:1.20.58.60:FF:000528', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120569, NULL, 'G3DSA:3.40.50.1460:FF:000035', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120570, NULL, 'G3DSA:2.10.70.10:FF:000214', NULL, NULL, 'Protein lev-9', NULL, NULL, NULL, NULL, NULL, 4),
(120571, NULL, 'G3DSA:3.40.850.10:FF:000443', NULL, NULL, 'Os11g0581000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(120572, NULL, 'G3DSA:3.50.50.60:FF:000387', NULL, NULL, 'Probable monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(120573, NULL, 'G3DSA:2.40.128.270:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120574, NULL, 'G3DSA:3.30.342.10:FF:000034', NULL, NULL, 'DNA polymerase 3', NULL, NULL, NULL, NULL, NULL, 4),
(120575, NULL, 'G3DSA:3.40.50.1820:FF:000632', NULL, NULL, 'Protein CBR-LIPL-6', NULL, NULL, NULL, NULL, NULL, 4),
(120576, NULL, 'G3DSA:1.20.990.10:FF:000021', NULL, NULL, 'NADPH-dependent diflavin oxidoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(120577, NULL, 'G3DSA:1.25.40.10:FF:004791', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g21170', NULL, NULL, NULL, NULL, NULL, 4),
(120578, NULL, 'G3DSA:2.120.10.30:FF:000386', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120579, NULL, 'G3DSA:3.30.1520.10:FF:000077', NULL, NULL, 'Phosphoinositide-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120580, NULL, 'G3DSA:1.20.1250.20:FF:000911', NULL, NULL, 'Similar to MFS sugar transporter', NULL, NULL, NULL, NULL, NULL, 4),
(120581, NULL, 'G3DSA:3.40.50.12710:FF:000003', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7', NULL, NULL, NULL, NULL, NULL, 4),
(120582, NULL, 'G3DSA:3.40.50.300:FF:005904', NULL, NULL, 'tRNA modification GTPase MnmE', NULL, NULL, NULL, NULL, NULL, 4),
(120583, NULL, 'G3DSA:1.10.10.10:FF:001472', NULL, NULL, 'Forkhead domain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(120584, NULL, 'G3DSA:2.40.50.140:FF:001116', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(120585, NULL, 'G3DSA:3.90.640.10:FF:000062', NULL, NULL, 'Lhs1p', NULL, NULL, NULL, NULL, NULL, 4),
(120586, NULL, 'G3DSA:1.10.510.10:FF:000061', NULL, NULL, 'Putative cyclin-dependent kinase 17', NULL, NULL, NULL, NULL, NULL, 4),
(120587, NULL, 'G3DSA:1.10.8.10:FF:000105', NULL, NULL, 'Protein NBR1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(120588, NULL, 'G3DSA:3.30.160.60:FF:005651', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120589, NULL, 'G3DSA:3.10.20.90:FF:000879', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120590, NULL, 'G3DSA:2.60.220.50:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120591, NULL, 'G3DSA:1.20.1050.10:FF:000269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120592, NULL, 'G3DSA:1.25.40.10:FF:003407', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(120593, NULL, 'G3DSA:3.40.50.10190:FF:000264', NULL, NULL, 'DNA topoisomerase 2-binding protein 1-A', NULL, NULL, NULL, NULL, NULL, 4),
(120594, NULL, 'G3DSA:1.20.1560.10:FF:000662', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120595, NULL, 'G3DSA:1.10.287.70:FF:000435', NULL, NULL, 'Voltage-dependent T-type calcium channel subunit alpha-1H', NULL, NULL, NULL, NULL, NULL, 4),
(120596, NULL, 'G3DSA:1.10.150.20:FF:000087', NULL, NULL, 'Flap endonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(120597, NULL, 'G3DSA:3.40.50.2300:FF:000708', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120598, NULL, 'G3DSA:1.25.10.10:FF:001635', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120599, NULL, 'G3DSA:1.25.40.10:FF:001137', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(120600, NULL, 'G3DSA:3.40.50.410:FF:000160', NULL, NULL, 'Caenorhabditis KU', NULL, NULL, NULL, NULL, NULL, 4),
(120601, NULL, 'G3DSA:3.30.40.10:FF:000743', NULL, NULL, 'PHD finger and BAH domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(120602, NULL, 'G3DSA:1.20.58.1120:FF:000023', NULL, NULL, 'Dynein heavy chain at 16F', NULL, NULL, NULL, NULL, NULL, 4),
(120603, NULL, 'G3DSA:2.60.120.200:FF:000266', NULL, NULL, 'Beta 1, 3 galactosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(120604, NULL, 'G3DSA:1.20.1250.20:FF:000591', NULL, NULL, 'Transporter, major facilitator family protein', NULL, NULL, NULL, NULL, NULL, 4),
(120605, NULL, 'G3DSA:4.10.400.10:FF:000007', NULL, NULL, 'Low density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(120606, NULL, 'G3DSA:1.20.1560.10:FF:000353', NULL, NULL, 'ABC a-pheromone efflux pump AtrD', NULL, NULL, NULL, NULL, NULL, 4),
(120607, NULL, 'G3DSA:1.10.510.10:FF:001691', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(120608, NULL, 'G3DSA:3.60.130.10:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120609, NULL, 'G3DSA:2.70.98.30:FF:000034', NULL, NULL, 'Alpha-mannosidase 2c1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120610, NULL, 'G3DSA:3.40.50.620:FF:000565', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(120611, NULL, 'G3DSA:3.30.160.60:FF:003381', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120612, NULL, 'G3DSA:3.30.200.20:FF:000837', NULL, NULL, 'AGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(120613, NULL, 'G3DSA:3.20.20.70:FF:000221', NULL, NULL, 'tRNA-dihydrouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(120614, NULL, 'G3DSA:1.10.510.10:FF:001702', NULL, NULL, 'Os11g0549300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(120615, NULL, 'G3DSA:2.60.120.650:FF:000047', NULL, NULL, 'Putative jumonji family transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(120616, NULL, 'G3DSA:3.40.720.10:FF:000219', NULL, NULL, 'Arylsulfatase A', NULL, NULL, NULL, NULL, NULL, 4),
(120617, NULL, 'G3DSA:3.40.50.2000:FF:000574', NULL, NULL, 'Probable glycosyltransferase WbpH', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(120618, NULL, 'G3DSA:3.30.160.60:FF:003936', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120619, NULL, 'G3DSA:1.10.246.90:FF:000009', NULL, NULL, 'Putative snoRNA binding domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(120620, NULL, 'G3DSA:1.10.510.10:FF:001382', NULL, NULL, 'Protein STRUBBELIG-RECEPTOR FAMILY 4', NULL, NULL, NULL, NULL, NULL, 4),
(120621, NULL, 'G3DSA:3.30.70.330:FF:000625', NULL, NULL, 'myelin expression factor 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(120622, NULL, 'G3DSA:1.20.1070.10:FF:000490', NULL, NULL, 'Growth hormone releasing hormone receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(120623, NULL, 'G3DSA:3.40.1110.10:FF:000431', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120624, NULL, 'G3DSA:2.70.70.10:FF:000049', NULL, NULL, 'Putative lipoprotein NlpD', NULL, NULL, NULL, NULL, NULL, 4),
(120625, NULL, 'G3DSA:1.10.150.810:FF:000001', NULL, NULL, 'DNA polymerase kappa', NULL, NULL, NULL, NULL, NULL, 4),
(120626, NULL, 'G3DSA:2.60.120.200:FF:000603', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120627, NULL, 'G3DSA:3.30.160.20:FF:000176', NULL, NULL, 'Putative endoribonuclease dicer', NULL, NULL, NULL, NULL, NULL, 4),
(120628, NULL, 'G3DSA:3.10.310.40:FF:000013', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(120629, NULL, 'G3DSA:3.40.50.970:FF:000086', NULL, NULL, 'Sulfite reductase (NADPH) hemoprotein, beta-component', NULL, NULL, NULL, NULL, NULL, 4),
(120630, NULL, 'G3DSA:1.10.490.10:FF:000047', NULL, NULL, 'Uncharacterized globin-like protein aq_211', NULL, NULL, NULL, NULL, NULL, 4),
(120631, NULL, 'G3DSA:3.90.1200.10:FF:000011', NULL, NULL, 'Spore coat protein YutH', NULL, NULL, NULL, NULL, NULL, 4),
(120632, NULL, 'G3DSA:1.10.10.1800:FF:000004', NULL, NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', NULL, NULL, NULL, NULL, NULL, 4),
(120633, NULL, 'G3DSA:1.25.40.210:FF:000006', NULL, NULL, 'Telomeric repeat-binding factor a', NULL, NULL, NULL, NULL, NULL, 4),
(120634, NULL, 'G3DSA:1.20.1070.10:FF:000810', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120635, NULL, 'G3DSA:1.20.58.60:FF:000635', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120636, NULL, 'G3DSA:2.60.40.790:FF:000198', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120637, NULL, 'G3DSA:1.10.510.10:FF:003271', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120638, NULL, 'G3DSA:1.25.40.10:FF:000766', NULL, NULL, 'Prolyl 4-hydroxylase alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120639, NULL, 'G3DSA:3.30.300.20:FF:000081', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120640, NULL, 'G3DSA:3.30.110.170:FF:000002', NULL, NULL, 'Interleukin-1 receptor-associated kinase 1-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(120641, NULL, 'G3DSA:1.20.120.1920:FF:000006', NULL, NULL, 'Ubiquitin-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(120642, NULL, 'G3DSA:3.40.50.80:FF:000135', NULL, NULL, 'Ferric reductase transmembrane component, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120643, NULL, 'G3DSA:2.60.120.200:FF:000485', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120644, NULL, 'G3DSA:2.60.40.60:FF:001136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120645, NULL, 'G3DSA:3.30.300.30:FF:000084', NULL, NULL, 'Enniatin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(120646, NULL, 'G3DSA:3.30.420.40:FF:001063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120647, NULL, 'G3DSA:1.20.58.1120:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120648, NULL, 'G3DSA:2.60.120.200:FF:000261', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(120649, NULL, 'G3DSA:2.30.29.30:FF:001023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120650, NULL, 'G3DSA:2.30.29.30:FF:000219', NULL, NULL, 'Arf-GAP with GTPase, ANK repeat and PH domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(120651, NULL, 'G3DSA:2.10.25.10:FF:000615', NULL, NULL, 'Laminin subunit gamma-3', NULL, NULL, NULL, NULL, NULL, 4),
(120652, NULL, 'G3DSA:3.50.50.60:FF:000696', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(120653, NULL, 'G3DSA:1.25.40.10:FF:003514', NULL, NULL, 'Uncharacterized protein, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(120654, NULL, 'G3DSA:2.30.42.10:FF:000492', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120655, NULL, 'G3DSA:2.30.30.490:FF:000045', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120656, NULL, 'G3DSA:3.10.280.10:FF:000001', NULL, NULL, 'Complement component 1 Q subcomponent-binding protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(120657, NULL, 'G3DSA:3.20.180.20:FF:000039', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120658, NULL, 'G3DSA:2.130.10.10:FF:000868', NULL, NULL, 'WD repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(120659, NULL, 'G3DSA:3.60.10.10:FF:000425', NULL, NULL, 'Calcium-dependent lipid-binding (CaLB domain) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(120660, NULL, 'G3DSA:1.20.120.1080:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120661, NULL, 'G3DSA:1.20.120.1910:FF:000003', NULL, NULL, 'Cysteine--tRNA ligase CPS1, chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(120662, NULL, 'G3DSA:3.30.40.10:FF:000833', NULL, NULL, 'Suppressor 2 of zeste 4-31', NULL, NULL, NULL, NULL, NULL, 4),
(120663, NULL, 'G3DSA:3.40.850.10:FF:000459', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(120664, NULL, 'G3DSA:1.20.1560.10:FF:000336', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(120665, NULL, 'G3DSA:1.20.140.10:FF:000081', NULL, NULL, 'GD25894', NULL, NULL, NULL, NULL, NULL, 4),
(120666, NULL, 'G3DSA:1.10.510.10:FF:001365', NULL, NULL, 'Serine/threonine protein kinase cds1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120667, NULL, 'G3DSA:2.60.120.970:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120668, NULL, 'G3DSA:3.40.50.150:FF:001239', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120669, NULL, 'G3DSA:3.20.20.140:FF:000206', NULL, NULL, 'Triazine hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(120670, NULL, 'G3DSA:3.40.33.10:FF:000035', NULL, NULL, 'CRISP3: cysteine-rich secretory protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120671, NULL, 'G3DSA:3.40.50.300:FF:001217', NULL, NULL, 'Ras-related protein RABA3', NULL, NULL, NULL, NULL, NULL, 4),
(120672, NULL, 'G3DSA:4.10.1240.10:FF:000025', NULL, NULL, 'Corticotropin releasing hormone receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(120673, NULL, 'G3DSA:2.60.40.10:FF:001363', NULL, NULL, 'Interleukin 10 receptor subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(120674, NULL, 'G3DSA:1.10.630.10:FF:000345', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120675, NULL, 'G3DSA:1.10.150.110:FF:000004', NULL, NULL, 'DNA polymerase lambda', NULL, NULL, NULL, NULL, NULL, 4),
(120676, NULL, 'G3DSA:3.40.630.40:FF:000019', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120677, NULL, 'G3DSA:1.25.40.10:FF:003059', NULL, NULL, 'PPR domain-containing protein/PPR_2 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(120678, NULL, 'G3DSA:2.30.40.10:FF:000021', NULL, NULL, 'Dihydropyrimidinase-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(120679, NULL, 'G3DSA:2.30.30.380:FF:000040', NULL, NULL, 'Putative cysteine peptidase, Clan CA, family C19', NULL, NULL, NULL, NULL, NULL, 4),
(120680, NULL, 'G3DSA:1.10.150.120:FF:000007', NULL, NULL, 'indole-3-acetaldehyde oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(120681, NULL, 'G3DSA:3.40.50.2300:FF:000366', NULL, NULL, 'Ethylene receptor', NULL, NULL, NULL, NULL, NULL, 4),
(120682, NULL, 'G3DSA:2.130.10.10:FF:001346', NULL, NULL, 'Uncharacterized protein C3H8.05c', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(120683, NULL, 'G3DSA:1.20.1720.10:FF:000091', NULL, NULL, 'MFS multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120684, NULL, 'G3DSA:3.40.50.720:FF:000825', NULL, NULL, '3-beta hydroxysteroid dehydrogenase/isomerase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(120685, NULL, 'G3DSA:3.40.50.720:FF:002405', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120686, NULL, 'G3DSA:3.50.50.60:FF:000589', NULL, NULL, 'FAD-dependent oxidoreductase domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(120687, NULL, 'G3DSA:3.40.30.10:FF:000118', NULL, NULL, 'Peroxiredoxin AhpE', NULL, NULL, NULL, NULL, NULL, 4),
(120688, NULL, 'G3DSA:2.60.40.10:FF:001705', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(120689, NULL, 'G3DSA:3.40.630.30:FF:000016', NULL, NULL, 'nudix hydrolase 2', NULL, NULL, NULL, NULL, NULL, 4),
(120690, NULL, 'G3DSA:3.30.1330.90:FF:000018', NULL, NULL, 'L-serine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(120691, NULL, 'G3DSA:2.130.10.10:FF:001672', NULL, NULL, 'Periodic tryptophan protein 2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(120692, NULL, 'G3DSA:3.80.10.10:FF:002263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120693, NULL, 'G3DSA:1.10.1060.10:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120694, NULL, 'G3DSA:1.20.1070.10:FF:000271', NULL, NULL, 'Octopamine receptor beta-2R', NULL, NULL, NULL, NULL, NULL, 4),
(120695, NULL, 'G3DSA:3.20.20.80:FF:000549', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120696, NULL, 'G3DSA:2.60.120.920:FF:000004', NULL, NULL, 'Butyrophilin subfamily 1 member A1', NULL, NULL, NULL, NULL, NULL, 4),
(120697, NULL, 'G3DSA:3.30.60.90:FF:000021', NULL, NULL, 'Unplaced genomic scaffold supercont1.18, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(120698, NULL, 'G3DSA:1.10.630.10:FF:000671', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120699, NULL, 'G3DSA:2.60.34.20:FF:000002', NULL, NULL, 'A1 cistron-splicing factor AAR2', NULL, NULL, NULL, NULL, NULL, 4),
(120700, NULL, 'G3DSA:3.40.50.12780:FF:000209', NULL, NULL, 'Acyl-CoA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120701, NULL, 'G3DSA:2.130.10.10:FF:005073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120702, NULL, 'G3DSA:3.30.950.10:FF:000003', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase I', NULL, NULL, NULL, NULL, NULL, 4),
(120703, NULL, 'G3DSA:3.90.1720.10:FF:000011', NULL, NULL, 'Trypanothione synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120704, NULL, 'G3DSA:1.20.1560.10:FF:000572', NULL, NULL, 'ABC transporter B family member 28', NULL, NULL, NULL, NULL, NULL, 4),
(120705, NULL, 'G3DSA:3.40.50.720:FF:000477', NULL, NULL, 'Peroxisomal 2,4-dienoyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(120706, NULL, 'G3DSA:3.30.160.60:FF:003717', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120707, NULL, 'G3DSA:3.40.50.2300:FF:000927', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120708, NULL, 'G3DSA:3.40.630.20:FF:000013', NULL, NULL, 'Pyroglutamyl-peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(120709, NULL, 'G3DSA:2.130.10.10:FF:005617', NULL, NULL, 'Sperm associated antigen 9a', NULL, NULL, NULL, NULL, NULL, 4),
(120710, NULL, 'G3DSA:1.10.10.750:FF:000026', NULL, NULL, 'GM26567', NULL, NULL, NULL, NULL, NULL, 4),
(120711, NULL, 'G3DSA:3.30.160.60:FF:005325', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120712, NULL, 'G3DSA:3.20.20.140:FF:000116', NULL, NULL, 'N-acyl-D-amino acid deacylase protein', NULL, NULL, NULL, NULL, NULL, 4),
(120713, NULL, 'G3DSA:1.10.510.10:FF:001707', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase kinase', NULL, NULL, NULL, NULL, NULL, 4),
(120714, NULL, 'G3DSA:1.10.8.870:FF:000002', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(120715, NULL, 'G3DSA:3.90.1150.10:FF:000467', NULL, NULL, 'dTDP-3-amino-3,4,6-trideoxy-alpha-D-glucose transaminase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(120716, NULL, 'G3DSA:3.40.50.720:FF:000786', NULL, NULL, 'Adenylyltransferase and sulfurtransferase MOCS3', NULL, NULL, NULL, NULL, NULL, 4),
(120717, NULL, 'G3DSA:2.60.40.10:FF:001840', NULL, NULL, 'Roundabout 2', NULL, NULL, NULL, NULL, NULL, 4),
(120718, NULL, 'G3DSA:1.10.8.10:FF:000324', NULL, NULL, 'UBA/TS-N domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(120719, NULL, 'G3DSA:2.130.10.10:FF:005382', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120720, NULL, 'G3DSA:1.10.287.10:FF:000029', NULL, NULL, 'Glycine--tRNA ligase, mitochondrial 1', NULL, NULL, NULL, NULL, NULL, 4),
(120721, NULL, 'G3DSA:3.65.10.20:FF:000013', NULL, NULL, 'TatD related DNase', NULL, NULL, NULL, NULL, NULL, 4),
(120722, NULL, 'G3DSA:1.10.565.10:FF:000007', NULL, NULL, 'Hepatocyte nuclear factor 4 alpha', NULL, NULL, NULL, NULL, NULL, 4),
(120723, NULL, 'G3DSA:4.10.860.10:FF:000019', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4),
(120724, NULL, 'G3DSA:3.90.70.80:FF:000044', NULL, NULL, 'Ubiquitin thioesterase OTU1', NULL, NULL, NULL, NULL, NULL, 4),
(120725, NULL, 'G3DSA:1.20.1080.10:FF:000097', NULL, NULL, 'Aquaporin-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(120726, NULL, 'G3DSA:6.10.140.2220:FF:000075', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120727, NULL, 'G3DSA:3.40.50.720:FF:002063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120728, NULL, 'G3DSA:1.10.10.10:FF:001562', NULL, NULL, 'EAP30/Vps36 family-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(120729, NULL, 'G3DSA:2.130.10.10:FF:002976', NULL, NULL, 'UTP15 C terminal, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120730, NULL, 'G3DSA:1.20.58.60:FF:000545', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120731, NULL, 'G3DSA:2.60.40.10:FF:004004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120732, NULL, 'G3DSA:1.10.150.910:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120733, NULL, 'G3DSA:3.30.980.10:FF:000033', NULL, NULL, 'Probable threonine--tRNA ligase 2, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(120734, NULL, 'G3DSA:3.40.50.2000:FF:000248', NULL, NULL, 'Alpha,alpha-trehalose-phosphate synthase [UDP-forming] 1', NULL, NULL, NULL, NULL, NULL, 4),
(120735, NULL, 'G3DSA:2.160.20.10:FF:000188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120736, NULL, 'G3DSA:2.60.40.3180:FF:000002', NULL, NULL, 'transcription factor COE2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(120737, NULL, 'G3DSA:3.40.50.300:FF:001436', NULL, NULL, 'Developmentally-regulated GTP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(120738, NULL, 'G3DSA:2.60.120.260:FF:000672', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(120739, NULL, 'G3DSA:3.40.50.150:FF:001329', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120740, NULL, 'G3DSA:3.30.70.2850:FF:000016', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(120741, NULL, 'G3DSA:1.25.40.180:FF:000290', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120742, NULL, 'G3DSA:1.20.58.1020:FF:000009', NULL, NULL, 'DNA replication complex GINS protein PSF2', NULL, NULL, NULL, NULL, NULL, 4),
(120743, NULL, 'G3DSA:1.10.340.70:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120744, NULL, 'G3DSA:3.30.470.20:FF:000076', NULL, NULL, 'Glutamine-hydrolysing carbamoyl-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(120745, NULL, 'G3DSA:2.130.10.10:FF:001037', NULL, NULL, 'Blast:DDB1-and CUL4-associated factor 12', NULL, NULL, NULL, NULL, NULL, 4),
(120746, NULL, 'G3DSA:1.10.287.370:FF:000019', NULL, NULL, 'Prefoldin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(120747, NULL, 'G3DSA:3.30.160.60:FF:005544', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120748, NULL, 'G3DSA:2.60.490.10:FF:000015', NULL, NULL, 'P2X purinoceptor', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(120749, NULL, 'G3DSA:3.30.450.20:FF:000529', NULL, NULL, 'Putative diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(120750, NULL, 'G3DSA:1.10.630.10:FF:000036', NULL, NULL, 'CYtochrome P450 family', NULL, NULL, NULL, NULL, NULL, 4),
(120751, NULL, 'G3DSA:1.10.20.70:FF:000001', NULL, NULL, 'Cleavage stimulation factor subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(120752, NULL, 'G3DSA:3.90.190.10:FF:000190', NULL, NULL, 'Protein-tyrosine-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(120753, NULL, 'G3DSA:3.40.1110.10:FF:000066', NULL, NULL, 'Cadmium-translocating P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(120754, NULL, 'G3DSA:3.30.1310.20:FF:000002', NULL, NULL, 'Phosphoribosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(120755, NULL, 'G3DSA:3.40.50.2000:FF:000490', NULL, NULL, 'Glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(120756, NULL, 'G3DSA:3.40.50.460:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120757, NULL, 'G3DSA:3.40.50.410:FF:000143', NULL, NULL, 'ATP-dependent DNA helicase II subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(120758, NULL, 'G3DSA:1.10.2000.10:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120759, NULL, 'G3DSA:1.20.58.1880:FF:000037', NULL, NULL, 'REST corepressor 3', NULL, NULL, NULL, NULL, NULL, 4),
(120760, NULL, 'G3DSA:3.30.70.1180:FF:000010', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(120761, NULL, 'G3DSA:3.30.470.30:FF:000079', NULL, NULL, 'Putative DNA ligase 4', NULL, NULL, NULL, NULL, NULL, 4),
(120762, NULL, 'G3DSA:3.40.190.10:FF:000566', NULL, NULL, 'Molybdenum cofactor biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(120763, NULL, 'G3DSA:2.130.10.10:FF:002667', NULL, NULL, 'Guanine nucleotide-binding protein negative regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(120764, NULL, 'G3DSA:2.60.40.420:FF:000008', NULL, NULL, 'Ubiquinol oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(120765, NULL, 'G3DSA:3.30.160.20:FF:000092', NULL, NULL, 'Related to MRPL3-Mitochondrial ribosomal protein, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(120766, NULL, 'G3DSA:1.20.1560.10:FF:000555', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120767, NULL, 'G3DSA:1.25.10.20:FF:000003', NULL, NULL, 'Vitellogenin C', NULL, NULL, NULL, NULL, NULL, 4),
(120768, NULL, 'G3DSA:2.30.42.10:FF:000531', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120769, NULL, 'G3DSA:3.50.50.60:FF:001230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120770, NULL, 'G3DSA:2.60.120.330:FF:000030', NULL, NULL, 'Thymine dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(120771, NULL, 'G3DSA:3.80.10.10:FF:000801', NULL, NULL, 'Outer arm dynein light chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(120772, NULL, 'G3DSA:3.30.160.60:FF:005196', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120773, NULL, 'G3DSA:2.120.10.30:FF:000493', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120774, NULL, 'G3DSA:3.40.630.10:FF:000100', NULL, NULL, 'Arginine utilization protein RocB', NULL, NULL, NULL, NULL, NULL, 4),
(120775, NULL, 'G3DSA:3.60.40.10:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120776, NULL, 'G3DSA:1.25.10.10:FF:001309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120777, NULL, 'G3DSA:1.50.10.20:FF:000046', NULL, NULL, 'Protein geranylgeranyltransferase type I subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(120778, NULL, 'G3DSA:2.130.10.10:FF:005308', NULL, NULL, 'U3 small nucleolar RNA-associated protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(120779, NULL, 'G3DSA:3.40.50.2300:FF:001170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120780, NULL, 'G3DSA:1.20.1250.20:FF:002171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120781, NULL, 'G3DSA:1.10.260.40:FF:000095', NULL, NULL, 'MBF1 transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(120782, NULL, 'G3DSA:2.30.30.140:FF:000108', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(120783, NULL, 'G3DSA:1.25.10.10:FF:001551', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120784, NULL, 'G3DSA:1.20.1280.50:FF:000152', NULL, NULL, 'F-box/LRR-repeat protein 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(120785, NULL, 'G3DSA:3.40.50.300:FF:001745', NULL, NULL, 'DEAD/DEAH box helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120786, NULL, 'G3DSA:1.20.1270.60:FF:000020', NULL, NULL, 'SLIT-ROBO Rho GTPase activating protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(120787, NULL, 'G3DSA:2.10.110.10:FF:000246', NULL, NULL, 'LIM domain-containing protein WLIM2a', NULL, NULL, NULL, NULL, NULL, 4),
(120788, NULL, 'G3DSA:3.30.930.10:FF:000120', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(120789, NULL, 'G3DSA:1.25.40.90:FF:000071', NULL, NULL, 'Clathrin assembly factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(120790, NULL, 'G3DSA:3.30.160.60:FF:001273', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(120791, NULL, 'G3DSA:2.70.70.10:FF:000066', NULL, NULL, 'Zinc metalloendopeptidase, M23 family', NULL, NULL, NULL, NULL, NULL, 4),
(120792, NULL, 'G3DSA:3.40.1110.10:FF:000414', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120793, NULL, 'G3DSA:2.60.40.1180:FF:000014', NULL, NULL, '1,4-alpha-glucan-branching enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(120794, NULL, 'G3DSA:2.60.120.10:FF:000701', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120795, NULL, 'G3DSA:3.30.160.60:FF:005853', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120796, NULL, 'G3DSA:3.40.50.10090:FF:000032', NULL, NULL, 'Uroporphyrinogen III synthase/methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(120797, NULL, 'G3DSA:3.40.630.30:FF:000106', NULL, NULL, 'Acetyltransferase At1g77540', NULL, NULL, NULL, NULL, NULL, 4),
(120798, NULL, 'G3DSA:2.60.40.10:FF:000997', NULL, NULL, 'Colony stimulating factor 3 receptor (Granulocyte)', NULL, NULL, NULL, NULL, NULL, 4),
(120799, NULL, 'G3DSA:3.20.20.60:FF:000111', NULL, NULL, 'Isocitrate lyase 1', NULL, NULL, NULL, NULL, NULL, 4),
(120800, NULL, 'G3DSA:3.30.2460.20:FF:000007', NULL, NULL, 'Protein Wnt', NULL, NULL, NULL, NULL, NULL, 4),
(120801, NULL, 'G3DSA:3.90.215.10:FF:000001', NULL, NULL, 'Tenascin isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(120802, NULL, 'G3DSA:2.60.40.60:FF:000989', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120803, NULL, 'G3DSA:2.30.42.10:FF:000183', NULL, NULL, 'Golgi reassembly-stacking protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(120804, NULL, 'G3DSA:2.30.30.100:FF:000092', NULL, NULL, 'Small nuclear ribonucleoprotein E', NULL, NULL, NULL, NULL, NULL, 4),
(120805, NULL, 'G3DSA:1.20.58.60:FF:000326', NULL, NULL, 'Muscle-specific protein 300 kDa, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(120806, NULL, 'G3DSA:3.20.20.70:FF:000114', NULL, NULL, 'Decarboxylase,orotidine phosphate', NULL, NULL, NULL, NULL, NULL, 4),
(120807, NULL, 'G3DSA:2.30.29.30:FF:000192', NULL, NULL, 'SH2B adapter protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(120808, NULL, 'G3DSA:3.40.640.10:FF:000197', NULL, NULL, 'Glycine dehydrogenase (decarboxylating)', NULL, NULL, NULL, NULL, NULL, 4),
(120809, NULL, 'G3DSA:3.90.190.10:FF:000509', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120810, NULL, 'G3DSA:3.30.160.60:FF:001492', NULL, NULL, 'Zinc finger protein 444', NULL, NULL, NULL, NULL, NULL, 4),
(120811, NULL, 'G3DSA:3.30.160.60:FF:001582', NULL, NULL, 'zinc finger protein 197', NULL, NULL, NULL, NULL, NULL, 4),
(120812, NULL, 'G3DSA:1.10.510.10:FF:000999', NULL, NULL, 'Si:dkey-8e10.3', NULL, NULL, NULL, NULL, NULL, 4),
(120813, NULL, 'G3DSA:1.10.1200.10:FF:000121', NULL, NULL, 'Saframycin Mx1 synthetase B', NULL, NULL, NULL, NULL, NULL, 4),
(120814, NULL, 'G3DSA:3.40.50.300:FF:007052', NULL, NULL, 'ABC transporter ATP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120815, NULL, 'G3DSA:3.40.50.300:FF:002015', NULL, NULL, 'SWIM-type zinc finger 7 associated protein 1', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(120816, NULL, 'G3DSA:3.30.505.10:FF:000132', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(120817, NULL, 'G3DSA:1.10.510.10:FF:001926', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120818, NULL, 'G3DSA:1.10.357.90:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120819, NULL, 'G3DSA:3.20.10.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120820, NULL, 'G3DSA:1.20.1070.10:FF:000355', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120821, NULL, 'G3DSA:1.20.1070.10:FF:002069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120822, NULL, 'G3DSA:1.10.1520.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120823, NULL, 'G3DSA:3.20.20.80:FF:000117', NULL, NULL, 'Lactase', NULL, NULL, NULL, NULL, NULL, 4),
(120824, NULL, 'G3DSA:3.40.190.10:FF:000785', NULL, NULL, 'Hydroxymethylbilane synthase', NULL, NULL, NULL, NULL, NULL, 4),
(120825, NULL, 'G3DSA:1.25.40.70:FF:000036', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', NULL, NULL, NULL, NULL, NULL, 4),
(120826, NULL, 'G3DSA:1.20.900.10:FF:000049', NULL, NULL, 'Rho guanine nucleotide exchange factor 38', NULL, NULL, NULL, NULL, NULL, 4),
(120827, NULL, 'G3DSA:1.25.40.10:FF:002683', NULL, NULL, 'Putative peroxisomal targeting signal 1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(120828, NULL, 'G3DSA:3.60.15.10:FF:000268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120829, NULL, 'G3DSA:1.20.1560.10:FF:000246', NULL, NULL, 'Probable multidrug resistance ABC transporter ATP-binding/permease protein YheH', NULL, NULL, NULL, NULL, NULL, 4),
(120830, NULL, 'G3DSA:3.30.40.10:FF:000850', NULL, NULL, 'Pep7p', NULL, NULL, NULL, NULL, NULL, 4),
(120831, NULL, 'G3DSA:1.20.120.1080:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120832, NULL, 'G3DSA:3.40.50.20:FF:000033', NULL, NULL, 'Carbamoyl-phosphate synthase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(120833, NULL, 'G3DSA:3.80.10.10:FF:001897', NULL, NULL, 'Tubulin-specific chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(120834, NULL, 'G3DSA:3.80.10.10:FF:002386', NULL, NULL, 'Protein phosphatase 1, regulatory subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120835, NULL, 'G3DSA:2.30.42.10:FF:000076', NULL, NULL, 'Protein lin-7 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(120836, NULL, 'G3DSA:3.70.10.10:FF:000110', NULL, NULL, 'Rad1 DNA damage checkpoint protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120837, NULL, 'G3DSA:3.40.50.12470:FF:000004', NULL, NULL, '2-oxoglutarate dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(120838, NULL, 'G3DSA:2.40.10.480:FF:000007', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(120839, NULL, 'G3DSA:1.20.1540.10:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120840, NULL, 'G3DSA:3.40.50.300:FF:001184', NULL, NULL, 'Chromatin complex subunit A 106', NULL, NULL, NULL, NULL, NULL, 4),
(120841, NULL, 'G3DSA:3.30.160.60:FF:001357', NULL, NULL, 'Zinc finger protein 580', NULL, NULL, NULL, NULL, NULL, 4),
(120842, NULL, 'G3DSA:1.25.40.10:FF:001154', NULL, NULL, 'Protein CBG09283', NULL, NULL, NULL, NULL, NULL, 4),
(120843, NULL, 'G3DSA:4.10.410.10:FF:000053', NULL, NULL, 'Protein CBG09606', NULL, NULL, NULL, NULL, NULL, 4),
(120844, NULL, 'G3DSA:1.10.287.10:FF:000007', NULL, NULL, 'Glycyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(120845, NULL, 'G3DSA:3.30.40.10:FF:000069', NULL, NULL, 'E3 ubiquitin-protein ligase RNF115', NULL, NULL, NULL, NULL, NULL, 4),
(120846, NULL, 'G3DSA:1.10.1520.10:FF:000049', NULL, NULL, '60S ribosomal protein L3, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120847, NULL, 'G3DSA:2.130.10.10:FF:001363', NULL, NULL, 'Tex1p', NULL, NULL, NULL, NULL, NULL, 4),
(120848, NULL, 'G3DSA:1.25.40.20:FF:001157', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(120849, NULL, 'G3DSA:3.30.40.10:FF:001215', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(120850, NULL, 'G3DSA:3.30.710.10:FF:000463', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120851, NULL, 'G3DSA:1.20.1080.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120852, NULL, 'G3DSA:1.10.287.130:FF:000094', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(120853, NULL, 'G3DSA:2.40.128.80:FF:000008', NULL, NULL, 'Dipeptidyl-peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(120854, NULL, 'G3DSA:2.60.40.10:FF:001924', NULL, NULL, 'KETtiN (Drosophila actin-binding) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(120855, NULL, 'G3DSA:2.130.10.10:FF:002892', NULL, NULL, 'WD repeat-containing protein AAC3', NULL, NULL, NULL, NULL, NULL, 4),
(120856, NULL, 'G3DSA:3.90.1150.10:FF:000248', NULL, NULL, 'Kynureninase', NULL, NULL, NULL, NULL, NULL, 4),
(120857, NULL, 'G3DSA:1.10.10.750:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120858, NULL, 'G3DSA:3.30.460.10:FF:000140', NULL, NULL, 'ATPase synthesis protein 25, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(120859, NULL, 'G3DSA:1.10.1060.10:FF:000025', NULL, NULL, 'Dihydropyrimidine dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120860, NULL, 'G3DSA:3.90.1310.10:FF:000019', NULL, NULL, 'Penicillin-binding membrane protein PbpB', NULL, NULL, NULL, NULL, NULL, 4),
(120861, NULL, 'G3DSA:3.40.50.620:FF:000649', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120862, NULL, 'G3DSA:3.30.70.330:FF:002194', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120863, NULL, 'G3DSA:1.20.5.460:FF:000001', NULL, NULL, 'Bifunctional protein PutA', NULL, NULL, NULL, NULL, NULL, 4),
(120864, NULL, 'G3DSA:2.10.10.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120865, NULL, 'G3DSA:3.30.40.10:FF:000597', NULL, NULL, 'RING finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(120866, NULL, 'G3DSA:1.25.40.10:FF:003823', NULL, NULL, 'Peroxisomal biogenesis factor 5 like', NULL, NULL, NULL, NULL, NULL, 4),
(120867, NULL, 'G3DSA:1.20.5.1300:FF:000015', NULL, NULL, 'Histidinol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(120868, NULL, 'G3DSA:3.30.930.10:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120869, NULL, 'G3DSA:1.10.10.60:FF:000947', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120870, NULL, 'G3DSA:3.40.50.720:FF:002372', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120871, NULL, 'G3DSA:2.130.10.10:FF:003510', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120872, NULL, 'G3DSA:3.30.50.10:FF:000098', NULL, NULL, 'Farnesoid X receptor beta splice variant 5', NULL, NULL, NULL, NULL, NULL, 4),
(120873, NULL, 'G3DSA:1.50.40.10:FF:000016', NULL, NULL, 'Solute carrier family 25 member 23', NULL, NULL, NULL, NULL, NULL, 4),
(120874, NULL, 'G3DSA:3.40.50.300:FF:005449', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120875, NULL, 'G3DSA:4.10.400.10:FF:000024', NULL, NULL, 'Low-density lipoprotein RecePtor related', NULL, NULL, NULL, NULL, NULL, 4),
(120876, NULL, 'G3DSA:1.25.40.820:FF:000004', NULL, NULL, 'Putative RNA polymerase II subunit B1 CTD phosphatase rtr1', NULL, NULL, NULL, NULL, NULL, 4),
(120877, NULL, 'G3DSA:4.10.1000.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120878, NULL, 'G3DSA:1.10.10.60:FF:001026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120879, NULL, 'G3DSA:3.30.1360.180:FF:000014', NULL, NULL, 'Alkaline-phosphatase-like family protein', NULL, NULL, NULL, NULL, NULL, 4),
(120880, NULL, 'G3DSA:2.60.120.10:FF:000050', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(120881, NULL, 'G3DSA:3.90.245.10:FF:000031', NULL, NULL, 'AT5g18860/F17K4_110', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(120882, NULL, 'G3DSA:3.50.30.30:FF:000028', NULL, NULL, 'N-acetylated alpha-linked acidic dipeptidase like 2', NULL, NULL, NULL, NULL, NULL, 4),
(120883, NULL, 'G3DSA:2.60.40.420:FF:000227', NULL, NULL, 'Chromosome 12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(120884, NULL, 'G3DSA:2.130.10.10:FF:005056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120885, NULL, 'G3DSA:3.40.960.10:FF:000001', NULL, NULL, 'Very short patch repair endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(120886, NULL, 'G3DSA:3.40.720.10:FF:000220', NULL, NULL, 'Arylsulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(120887, NULL, 'G3DSA:3.60.150.10:FF:000014', NULL, NULL, 'Chorismate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(120888, NULL, 'G3DSA:3.30.160.60:FF:005089', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120889, NULL, 'G3DSA:1.20.1070.10:FF:000580', NULL, NULL, 'probable G-protein coupled receptor Mth-like 9', NULL, NULL, NULL, NULL, NULL, 4),
(120890, NULL, 'G3DSA:1.10.287.70:FF:000351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120891, NULL, 'G3DSA:1.10.10.10:FF:000983', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120892, NULL, 'G3DSA:2.90.10.30:FF:000005', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase LECRK1', NULL, NULL, NULL, NULL, NULL, 4),
(120893, NULL, 'G3DSA:1.10.720.30:FF:000021', NULL, NULL, 'ATP-dependent DNA helicase 2 subunit KU70', NULL, NULL, NULL, NULL, NULL, 4),
(120894, NULL, 'G3DSA:3.90.190.10:FF:000515', NULL, NULL, 'MAP kinase phosphatase 2', NULL, NULL, NULL, NULL, NULL, 4),
(120895, NULL, 'G3DSA:1.20.140.10:FF:000120', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120896, NULL, 'G3DSA:2.40.50.150:FF:000012', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(120897, NULL, 'G3DSA:3.80.10.10:FF:004078', NULL, NULL, 'Protein phosphatase 2C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120898, NULL, 'G3DSA:3.50.50.60:FF:001084', NULL, NULL, 'Polyamine oxidase (exo-N4-amino)', NULL, NULL, NULL, NULL, NULL, 4),
(120899, NULL, 'G3DSA:1.10.1040.10:FF:000024', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(120900, NULL, 'G3DSA:3.30.930.10:FF:000193', NULL, NULL, 'DNA polymerase gamma 35kD', NULL, NULL, NULL, NULL, NULL, 4),
(120901, NULL, 'G3DSA:1.10.10.350:FF:000007', NULL, NULL, 'Glutamate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(120902, NULL, 'G3DSA:3.40.190.170:FF:000005', NULL, NULL, 'C4-dicarboxylate ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(120903, NULL, 'G3DSA:2.60.40.150:FF:000202', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(120904, NULL, 'G3DSA:3.40.50.300:FF:006978', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120905, NULL, 'G3DSA:1.10.287.1060:FF:000014', NULL, NULL, 'conserved oligomeric Golgi complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(120906, NULL, 'G3DSA:1.10.630.10:FF:000255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120907, NULL, 'G3DSA:3.30.30.30:FF:000001', NULL, NULL, 'heat shock 70 kDa protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(120908, NULL, 'G3DSA:3.40.190.160:FF:000002', NULL, NULL, 'Integral membrane indolylacetylinositol arabinosyltransferase embA', NULL, NULL, NULL, NULL, NULL, 4),
(120909, NULL, 'G3DSA:3.40.350.10:FF:000096', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120910, NULL, 'G3DSA:1.25.40.180:FF:000317', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120911, NULL, 'G3DSA:1.25.40.20:FF:000162', NULL, NULL, 'Ankyrin repeat domain-containing protein 54', NULL, NULL, NULL, NULL, NULL, 4),
(120912, NULL, 'G3DSA:1.25.40.10:FF:000749', NULL, NULL, 'U3 snoRNP protein', NULL, NULL, NULL, NULL, NULL, 4),
(120913, NULL, 'G3DSA:3.20.20.100:FF:000026', NULL, NULL, 'Gamma-cysteine synthetase regulatory subunit, putative', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(120914, NULL, 'G3DSA:3.60.130.10:FF:000013', NULL, NULL, 'Alpha-ketoglutarate-dependent L-arginine hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(120915, NULL, 'G3DSA:3.40.50.1820:FF:000177', NULL, NULL, 'Group XV phospholipase A2', NULL, NULL, NULL, NULL, NULL, 4),
(120916, NULL, 'G3DSA:1.10.8.60:FF:000513', NULL, NULL, 'Regulatory protease', NULL, NULL, NULL, NULL, NULL, 4),
(120917, NULL, 'G3DSA:4.10.480.10:FF:000001', NULL, NULL, 'Hydrogenase 2 small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(120918, NULL, 'G3DSA:3.40.50.720:FF:002259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120919, NULL, 'G3DSA:2.60.40.10:FF:001385', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(120920, NULL, 'G3DSA:1.10.150.510:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120921, NULL, 'G3DSA:3.40.390.10:FF:000216', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120922, NULL, 'G3DSA:2.40.50.40:FF:000086', NULL, NULL, 'C-C motif chemokine 4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(120923, NULL, 'G3DSA:3.30.420.10:FF:000031', NULL, NULL, 'RNA exonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(120924, NULL, 'G3DSA:1.10.150.50:FF:000180', NULL, NULL, 'Arrestin domain-containing protein B', NULL, NULL, NULL, NULL, NULL, 4),
(120925, NULL, 'G3DSA:1.25.10.10:FF:002855', NULL, NULL, 'Anaphase-promoting complex subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120926, NULL, 'G3DSA:2.30.29.30:FF:000528', NULL, NULL, 'FACT complex subunit POB3', NULL, NULL, NULL, NULL, NULL, 4),
(120927, NULL, 'G3DSA:1.10.287.110:FF:000301', NULL, NULL, 'Heat shock protein DnaJ family protein', NULL, NULL, NULL, NULL, NULL, 4),
(120928, NULL, 'G3DSA:2.130.10.10:FF:001256', NULL, NULL, 'Unplaced genomic scaffold supercont1.223, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(120929, NULL, 'G3DSA:3.60.20.10:FF:000235', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120930, NULL, 'G3DSA:1.20.1050.10:FF:000247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120931, NULL, 'G3DSA:2.60.120.920:FF:000111', NULL, NULL, 'Protein TRAUCO', NULL, NULL, NULL, NULL, NULL, 4),
(120932, NULL, 'G3DSA:3.10.330.10:FF:000028', NULL, NULL, 'Vesicle-fusing ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(120933, NULL, 'G3DSA:1.20.140.10:FF:000007', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(120934, NULL, 'G3DSA:3.40.1340.10:FF:000004', NULL, NULL, 'DNA-directed RNA polymerases I, II, and III subunit RPABC1', NULL, NULL, NULL, NULL, NULL, 4),
(120935, NULL, 'G3DSA:2.60.40.420:FF:000082', NULL, NULL, 'Extracellular dihydrogeodin oxidase/laccase', NULL, NULL, NULL, NULL, NULL, 4),
(120936, NULL, 'G3DSA:3.50.50.60:FF:000948', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120937, NULL, 'G3DSA:3.40.50.410:FF:000250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120938, NULL, 'G3DSA:3.30.460.10:FF:000027', NULL, NULL, 'Poly(A) polymerase PAP', NULL, NULL, NULL, NULL, NULL, 4),
(120939, NULL, 'G3DSA:2.30.30.100:FF:000119', NULL, NULL, 'LSM domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120940, NULL, 'G3DSA:3.20.20.80:FF:000443', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120941, NULL, 'G3DSA:1.20.1090.10:FF:000047', NULL, NULL, 'Iron-containing alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(120942, NULL, 'G3DSA:1.10.10.10:FF:001601', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120943, NULL, 'G3DSA:3.30.450.20:FF:000058', NULL, NULL, 'neuronal PAS domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(120944, NULL, 'G3DSA:3.80.10.10:FF:000823', NULL, NULL, 'F-box/LRR-repeat protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(120945, NULL, 'G3DSA:2.40.50.140:FF:000931', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120946, NULL, 'G3DSA:2.20.28.100:FF:000001', NULL, NULL, 'Desulforedoxin, putative', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(120947, NULL, 'G3DSA:3.40.50.300:FF:001762', NULL, NULL, 'Sulfotransferase 3, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(120948, NULL, 'G3DSA:1.10.510.10:FF:003635', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120949, NULL, 'G3DSA:1.10.630.10:FF:000362', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120950, NULL, 'G3DSA:3.20.20.70:FF:000440', NULL, NULL, 'dTDP-4-amino-4,6-dideoxy-D-glucose ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(120951, NULL, 'G3DSA:1.10.8.1220:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120952, NULL, 'G3DSA:2.60.40.1490:FF:000006', NULL, NULL, 'ASF1 like histone chaperone, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120953, NULL, 'G3DSA:3.30.70.330:FF:002974', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120954, NULL, 'G3DSA:3.40.630.30:FF:000241', NULL, NULL, 'Acetyltransferase GNAT family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(120955, NULL, 'G3DSA:1.25.40.420:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120956, NULL, 'G3DSA:2.40.50.140:FF:000167', NULL, NULL, 'Minichromosome maintenance 10 replication initiation factor', NULL, NULL, NULL, NULL, NULL, 4),
(120957, NULL, 'G3DSA:1.20.920.10:FF:000051', NULL, NULL, 'Transcription initiation factor TFIID subunit', NULL, NULL, NULL, NULL, NULL, 4),
(120958, NULL, 'G3DSA:1.20.1740.10:FF:000209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120959, NULL, 'G3DSA:2.60.40.150:FF:000579', NULL, NULL, 'Activating signal cointegrator 1 complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(120960, NULL, 'G3DSA:3.30.200.20:FF:001326', NULL, NULL, 'Serine/threonine-protein kinase cbk1', NULL, NULL, NULL, NULL, NULL, 4),
(120961, NULL, 'G3DSA:3.10.20.90:FF:000210', NULL, NULL, 'Putative Sorting nexin-27', NULL, NULL, NULL, NULL, NULL, 4),
(120962, NULL, 'G3DSA:1.10.630.10:FF:000564', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120963, NULL, 'G3DSA:2.60.40.1730:FF:000022', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(120964, NULL, 'G3DSA:1.10.238.20:FF:000032', NULL, NULL, 'Odorant binding protein 24', NULL, NULL, NULL, NULL, NULL, 4),
(120965, NULL, 'G3DSA:3.30.70.330:FF:000956', NULL, NULL, 'Protein CBR-SPN-4', NULL, NULL, NULL, NULL, NULL, 4),
(120966, NULL, 'G3DSA:1.20.58.60:FF:000309', NULL, NULL, 'Spectrin beta non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(120967, NULL, 'G3DSA:3.40.1190.20:FF:000102', NULL, NULL, 'Ribokinase', NULL, NULL, NULL, NULL, NULL, 4),
(120968, NULL, 'G3DSA:3.30.160.60:FF:005960', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120969, NULL, 'G3DSA:1.10.10.60:FF:001245', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120970, NULL, 'G3DSA:1.20.1070.10:FF:000832', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(120971, NULL, 'G3DSA:1.10.8.10:FF:000072', NULL, NULL, 'Activating signal cointegrator 1 complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(120972, NULL, 'G3DSA:3.20.20.70:FF:000131', NULL, NULL, 'Transaldolase', NULL, NULL, NULL, NULL, NULL, 4),
(120973, NULL, 'G3DSA:1.20.58.150:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120974, NULL, 'G3DSA:3.40.50.10330:FF:000121', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(120975, NULL, 'G3DSA:1.10.3080.10:FF:000032', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(120976, NULL, 'G3DSA:1.10.510.10:FF:001724', NULL, NULL, 'Putative WAK family receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(120977, NULL, 'G3DSA:3.40.30.10:FF:000012', NULL, NULL, 'Monothiol glutaredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(120978, NULL, 'G3DSA:2.40.270.10:FF:000003', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(120979, NULL, 'G3DSA:2.60.40.10:FF:005415', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120980, NULL, 'G3DSA:2.40.50.140:FF:000818', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(120981, NULL, 'G3DSA:3.90.228.10:FF:000053', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(120982, NULL, 'G3DSA:3.40.50.20:FF:000016', NULL, NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(120983, NULL, 'G3DSA:3.30.160.60:FF:003291', NULL, NULL, 'Histone-lysine N-methyltransferase PRDM9', NULL, NULL, NULL, NULL, NULL, 4),
(120984, NULL, 'G3DSA:1.10.1200.10:FF:000014', NULL, NULL, 'Multifunctional mycocerosic acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(120985, NULL, 'G3DSA:1.10.565.10:FF:000013', NULL, NULL, 'Peroxisome proliferator-activated receptor delta', NULL, NULL, NULL, NULL, NULL, 4),
(120986, NULL, 'G3DSA:3.80.10.10:FF:002280', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(120987, NULL, 'G3DSA:3.30.160.60:FF:005409', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(120988, NULL, 'G3DSA:1.25.40.10:FF:002879', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120989, NULL, 'G3DSA:3.20.20.80:FF:000134', NULL, NULL, 'Glycoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(120990, NULL, 'G3DSA:3.30.40.10:FF:000182', NULL, NULL, 'rabphilin-3A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(120991, NULL, 'G3DSA:2.60.120.290:FF:000214', NULL, NULL, 'C-type LECtin', NULL, NULL, NULL, NULL, NULL, 4),
(120992, NULL, 'G3DSA:1.25.40.10:FF:003043', NULL, NULL, 'Os06g0694300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(120993, NULL, 'G3DSA:3.30.230.10:FF:000218', NULL, NULL, 'Mitochondrial elongation factor G2', NULL, NULL, NULL, NULL, NULL, 4),
(120994, NULL, 'G3DSA:3.40.50.12110:FF:000003', NULL, NULL, 'Possible DNA repair photolyase', NULL, NULL, NULL, NULL, NULL, 4),
(120995, NULL, 'G3DSA:3.30.300.30:FF:000168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120996, NULL, 'G3DSA:3.30.160.60:FF:001609', NULL, NULL, 'Zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(120997, NULL, 'G3DSA:2.130.10.10:FF:001565', NULL, NULL, 'Semaphorin-2A', NULL, NULL, NULL, NULL, NULL, 4),
(120998, NULL, 'G3DSA:2.130.10.10:FF:005415', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(120999, NULL, 'G3DSA:2.60.40.1480:FF:000003', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(121000, NULL, 'G3DSA:3.30.470.10:FF:000056', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(121001, NULL, 'G3DSA:1.25.40.10:FF:004824', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g46610', NULL, NULL, NULL, NULL, NULL, 4),
(121002, NULL, 'G3DSA:3.80.10.10:FF:002369', NULL, NULL, 'At1g80630', NULL, NULL, NULL, NULL, NULL, 4),
(121003, NULL, 'G3DSA:3.40.50.2000:FF:000265', NULL, NULL, 'D-inositol 3-phosphate glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(121004, NULL, 'G3DSA:3.40.50.300:FF:005562', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121005, NULL, 'G3DSA:2.30.29.30:FF:000860', NULL, NULL, 'Protein loc100159627 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(121006, NULL, 'G3DSA:3.30.470.20:FF:000059', NULL, NULL, 'Synapsin-3', NULL, NULL, NULL, NULL, NULL, 4),
(121007, NULL, 'G3DSA:3.20.80.10:FF:000004', NULL, NULL, 'DNA gyrase inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(121008, NULL, 'G3DSA:3.40.50.300:FF:005814', NULL, NULL, 'Dicer Related Helicase', NULL, NULL, NULL, NULL, NULL, 4),
(121009, NULL, 'G3DSA:1.20.58.100:FF:000005', NULL, NULL, 'Succinate dehydrogenase flavoprotein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(121010, NULL, 'G3DSA:3.40.1180.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121011, NULL, 'G3DSA:4.10.280.10:FF:000143', NULL, NULL, 'Rtg1p', NULL, NULL, NULL, NULL, NULL, 4),
(121012, NULL, 'G3DSA:3.30.530.20:FF:000210', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(121013, NULL, 'G3DSA:1.25.40.10:FF:002790', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(121014, NULL, 'G3DSA:3.40.50.300:FF:001543', NULL, NULL, 'GTPase Era', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(121015, NULL, 'G3DSA:1.10.287.370:FF:000036', NULL, NULL, 'Prefoldin, alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121016, NULL, 'G3DSA:3.30.1360.170:FF:000011', NULL, NULL, 'Cation efflux system protein', NULL, NULL, NULL, NULL, NULL, 4),
(121017, NULL, 'G3DSA:2.70.150.10:FF:000021', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(121018, NULL, 'G3DSA:2.60.40.10:FF:005437', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121019, NULL, 'G3DSA:1.20.1740.10:FF:000120', NULL, NULL, 'Y+L amino acid transporter 2', NULL, NULL, NULL, NULL, NULL, 4),
(121020, NULL, 'G3DSA:2.130.10.10:FF:005163', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(121021, NULL, 'G3DSA:3.40.50.620:FF:000234', NULL, NULL, 'Methionine--tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121022, NULL, 'G3DSA:2.130.10.10:FF:000958', NULL, NULL, 'Elongator acetyltransferase complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(121023, NULL, 'G3DSA:2.40.290.10:FF:000004', NULL, NULL, 'Non-homologous end joining protein Ku', NULL, NULL, NULL, NULL, NULL, 4),
(121024, NULL, 'G3DSA:1.10.287.380:FF:000039', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(121025, NULL, 'G3DSA:1.10.10.10:FF:001236', NULL, NULL, 'Iron dependent repressor', NULL, NULL, NULL, NULL, NULL, 4),
(121026, NULL, 'G3DSA:2.60.40.10:FF:002003', NULL, NULL, 'Transmembrane and immunoglobulin domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(121027, NULL, 'G3DSA:1.20.58.110:FF:000008', NULL, NULL, '30S ribosomal protein S20', NULL, NULL, NULL, NULL, NULL, 4),
(121028, NULL, 'G3DSA:1.25.10.10:FF:001326', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(121029, NULL, 'G3DSA:1.25.10.10:FF:001074', NULL, NULL, 'Formin like 1', NULL, NULL, NULL, NULL, NULL, 4),
(121030, NULL, 'G3DSA:1.10.510.10:FF:003164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121031, NULL, 'G3DSA:2.30.31.10:FF:000011', NULL, NULL, 'RNA polymerase II transcriptional coactivator KELP', NULL, NULL, NULL, NULL, NULL, 4),
(121032, NULL, 'G3DSA:1.10.8.140:FF:000019', NULL, NULL, 'Programmed cell death, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121033, NULL, 'G3DSA:2.30.29.30:FF:000309', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(121034, NULL, 'G3DSA:3.40.850.10:FF:000465', NULL, NULL, 'Kinesin-like protein tea2', NULL, NULL, NULL, NULL, NULL, 4),
(121035, NULL, 'G3DSA:2.60.120.10:FF:000246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121036, NULL, 'G3DSA:3.80.10.10:FF:004314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121037, NULL, 'G3DSA:3.30.450.20:FF:000423', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121038, NULL, 'G3DSA:3.30.160.60:FF:003072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121039, NULL, 'G3DSA:3.80.10.10:FF:002841', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121040, NULL, 'G3DSA:3.40.50.300:FF:005253', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(121041, NULL, 'G3DSA:3.50.50.60:FF:001314', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(121042, NULL, 'G3DSA:2.30.29.30:FF:000298', NULL, NULL, 'FACT complex subunit SSRP1', NULL, NULL, NULL, NULL, NULL, 4),
(121043, NULL, 'G3DSA:3.40.50.12780:FF:000215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121044, NULL, 'G3DSA:2.30.30.140:FF:000182', NULL, NULL, 'Transcription factor, Tudor domain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121045, NULL, 'G3DSA:3.40.50.150:FF:001464', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121046, NULL, 'G3DSA:2.60.120.970:FF:000120', NULL, NULL, 'Bone morphogenetic protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(121047, NULL, 'G3DSA:2.60.40.10:FF:005185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121048, NULL, 'G3DSA:3.30.1370.210:FF:000025', NULL, NULL, 'Zinc finger cx8-c-x5-c-x3-h type (and similar) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(121049, NULL, 'G3DSA:3.40.190.10:FF:000892', NULL, NULL, 'Transcriptional regulator LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(121050, NULL, 'G3DSA:3.30.450.60:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121051, NULL, 'G3DSA:3.30.160.60:FF:001048', NULL, NULL, 'replication initiator 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(121052, NULL, 'G3DSA:3.40.50.10230:FF:000001', NULL, NULL, 'Precorrin-8X methylmutase', NULL, NULL, NULL, NULL, NULL, 4),
(121053, NULL, 'G3DSA:1.25.10.10:FF:003108', NULL, NULL, 'Protein peg1', NULL, NULL, NULL, NULL, NULL, 4),
(121054, NULL, 'G3DSA:3.60.10.10:FF:000408', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121055, NULL, 'G3DSA:1.50.40.10:FF:000325', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121056, NULL, 'G3DSA:3.20.20.20:FF:000015', NULL, NULL, 'Probable bifunctional folylpolyglutamate synthase/dihydropteroate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(121057, NULL, 'G3DSA:3.30.70.600:FF:000021', NULL, NULL, '30S ribosomal protein S10', NULL, NULL, NULL, NULL, NULL, 4),
(121058, NULL, 'G3DSA:2.60.40.2860:FF:000007', NULL, NULL, 'Transmission-blocking target antigen S230', NULL, NULL, NULL, NULL, NULL, 4),
(121059, NULL, 'G3DSA:2.60.40.10:FF:001694', NULL, NULL, 'Basement membrane proteoglycan', NULL, NULL, NULL, NULL, NULL, 4),
(121060, NULL, 'G3DSA:3.40.50.1010:FF:000254', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121061, NULL, 'G3DSA:3.40.50.720:FF:000590', NULL, NULL, 'Glucose-6-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(121062, NULL, 'G3DSA:3.40.50.720:FF:002478', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121063, NULL, 'G3DSA:2.30.40.10:FF:000094', NULL, NULL, 'Cytosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(121064, NULL, 'G3DSA:3.40.50.300:FF:006669', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121065, NULL, 'G3DSA:1.10.472.80:FF:000048', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(121066, NULL, 'G3DSA:1.10.2000.10:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121067, NULL, 'G3DSA:3.20.20.10:FF:000012', NULL, NULL, 'Carboxynorspermidine/carboxyspermidine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(121068, NULL, 'G3DSA:3.30.200.20:FF:001074', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(121069, NULL, 'G3DSA:3.40.50.10240:FF:000004', NULL, NULL, 'Thiamin pyrophosphokinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(121070, NULL, 'G3DSA:3.40.50.10490:FF:000028', NULL, NULL, 'HTH-type transcriptional regulator MurR', NULL, NULL, NULL, NULL, NULL, 4),
(121071, NULL, 'G3DSA:3.40.50.300:FF:005343', NULL, NULL, 'Anion-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(121072, NULL, 'G3DSA:2.60.40.2840:FF:000001', NULL, NULL, 'E3 ubiquitin-protein ligase HECW2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(121073, NULL, 'G3DSA:3.30.160.60:FF:003852', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121074, NULL, 'G3DSA:1.25.10.10:FF:001107', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(121075, NULL, 'G3DSA:1.10.486.10:FF:000026', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(121076, NULL, 'G3DSA:3.40.50.150:FF:001773', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121077, NULL, 'G3DSA:1.25.40.20:FF:001808', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(121078, NULL, 'G3DSA:1.10.510.10:FF:001472', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121079, NULL, 'G3DSA:1.10.287.70:FF:000570', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121080, NULL, 'G3DSA:1.10.3370.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121081, NULL, 'G3DSA:3.90.550.10:FF:000032', NULL, NULL, 'xyloglucan 6-xylosyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(121082, NULL, 'G3DSA:3.40.50.2000:FF:000916', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(121083, NULL, 'G3DSA:3.30.1460.20:FF:000007', NULL, NULL, 'Arp2/3 complex 34 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(121084, NULL, 'G3DSA:3.80.10.10:FF:003696', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121085, NULL, 'G3DSA:1.20.5.1430:FF:000003', NULL, NULL, 'microtubule-associated protein RP/EB family member 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(121086, NULL, 'G3DSA:1.10.287.370:FF:000020', NULL, NULL, 'Unplaced genomic scaffold supercont2.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(121087, NULL, 'G3DSA:1.10.10.350:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121088, NULL, 'G3DSA:3.40.50.2300:FF:000692', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121089, NULL, 'G3DSA:1.10.510.10:FF:002798', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121090, NULL, 'G3DSA:2.130.10.10:FF:002998', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121091, NULL, 'G3DSA:2.130.10.10:FF:003274', NULL, NULL, 'Notchless', NULL, NULL, NULL, NULL, NULL, 4),
(121092, NULL, 'G3DSA:2.60.40.10:FF:003493', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121093, NULL, 'G3DSA:2.10.25.10:FF:000138', NULL, NULL, 'Laminin subunit beta 1', NULL, NULL, NULL, NULL, NULL, 4),
(121094, NULL, 'G3DSA:1.10.287.10:FF:000030', NULL, NULL, 'Related to ataxin-3', NULL, NULL, NULL, NULL, NULL, 4),
(121095, NULL, 'G3DSA:4.10.60.10:FF:000069', NULL, NULL, 'Glycine-rich RNA-binding protein RZ1A', NULL, NULL, NULL, NULL, NULL, 4),
(121096, NULL, 'G3DSA:1.25.40.10:FF:001805', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(121097, NULL, 'G3DSA:3.90.550.20:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121098, NULL, 'G3DSA:3.10.20.10:FF:000018', NULL, NULL, 'Sulfur carrier protein FdhD', NULL, NULL, NULL, NULL, NULL, 4),
(121099, NULL, 'G3DSA:3.10.20.90:FF:000896', NULL, NULL, 'BAG family molecular chaperone regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(121100, NULL, 'G3DSA:2.60.40.10:FF:002689', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121101, NULL, 'G3DSA:1.20.80.10:FF:000026', NULL, NULL, 'Enoyl-CoA delta isomerase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(121102, NULL, 'G3DSA:3.40.50.620:FF:000543', NULL, NULL, 'Glutamyl-Q tRNA(Asp) synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(121103, NULL, 'G3DSA:2.60.40.10:FF:005095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121104, NULL, 'G3DSA:2.10.25.10:FF:000380', NULL, NULL, 'EGF-containing fibulin-like extracellular matrix protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(121105, NULL, 'G3DSA:1.20.58.60:FF:000770', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121106, NULL, 'G3DSA:3.40.50.1220:FF:000093', NULL, NULL, 'NAD-dependent protein deacylase SIR2rp2', NULL, NULL, NULL, NULL, NULL, 4),
(121107, NULL, 'G3DSA:3.40.50.300:FF:003089', NULL, NULL, 'Rab family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(121108, NULL, 'G3DSA:2.60.40.3210:FF:000011', NULL, NULL, 'Placenta-specific protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(121109, NULL, 'G3DSA:3.30.420.10:FF:000671', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121110, NULL, 'G3DSA:3.30.1370.50:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121111, NULL, 'G3DSA:3.30.40.10:FF:000378', NULL, NULL, 'TRAF-type zinc finger domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(121112, NULL, 'G3DSA:1.10.8.60:FF:000423', NULL, NULL, 'DNA polymerase III subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(121113, NULL, 'G3DSA:2.60.120.330:FF:000029', NULL, NULL, 'KAR-UP oxidoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(121114, NULL, 'G3DSA:3.30.70.330:FF:003121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121115, NULL, 'G3DSA:3.30.413.10:FF:000008', NULL, NULL, 'Sulfite reductase [ferredoxin], chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(121116, NULL, 'G3DSA:2.60.40.10:FF:004111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(121117, NULL, 'G3DSA:2.60.120.200:FF:000592', NULL, NULL, 'Collagen type XVI alpha 1 chain', NULL, NULL, NULL, NULL, NULL, 4),
(121118, NULL, 'G3DSA:3.30.499.10:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121119, NULL, 'G3DSA:3.80.10.10:FF:000571', NULL, NULL, 'Kek6, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(121120, NULL, 'G3DSA:1.10.20.140:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121121, NULL, 'G3DSA:2.30.150.10:FF:000002', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(121122, NULL, 'G3DSA:3.40.50.460:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121123, NULL, 'G3DSA:1.10.1300.10:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121124, NULL, 'G3DSA:1.25.40.20:FF:001466', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121125, NULL, 'G3DSA:4.10.1060.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121126, NULL, 'G3DSA:3.80.10.10:FF:004387', NULL, NULL, 'NACHT, LRR and PYD domains-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(121127, NULL, 'G3DSA:2.20.100.10:FF:000136', NULL, NULL, 'SPONdin (Extracellular matrix glycoprotein) family', NULL, NULL, NULL, NULL, NULL, 4),
(121128, NULL, 'G3DSA:1.20.1080.10:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121129, NULL, 'G3DSA:4.10.110.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121130, NULL, 'G3DSA:1.25.40.180:FF:000211', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121131, NULL, 'G3DSA:2.30.42.10:FF:000385', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121132, NULL, 'G3DSA:3.50.30.30:FF:000051', NULL, NULL, 'Extracellular serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(121133, NULL, 'G3DSA:3.30.465.10:FF:000089', NULL, NULL, 'Protein CBG09729', NULL, NULL, NULL, NULL, NULL, 4),
(121134, NULL, 'G3DSA:3.80.10.10:FF:002370', NULL, NULL, 'GH01279p', NULL, NULL, NULL, NULL, NULL, 4),
(121135, NULL, 'G3DSA:3.30.1460.10:FF:000004', NULL, NULL, 'Type III secretion chaperone SycN', NULL, NULL, NULL, NULL, NULL, 4),
(121136, NULL, 'G3DSA:3.40.50.300:FF:003544', NULL, NULL, 'Arl_B38 protein', NULL, NULL, NULL, NULL, NULL, 4),
(121137, NULL, 'G3DSA:1.20.5.110:FF:000025', NULL, NULL, 'Putative WASH complex subunit CCDC53', NULL, NULL, NULL, NULL, NULL, 4),
(121138, NULL, 'G3DSA:1.20.1250.20:FF:000237', NULL, NULL, 'Solute carrier family 2 (Facilitated glucose transporter), member 12', NULL, NULL, NULL, NULL, NULL, 4),
(121139, NULL, 'G3DSA:1.10.555.10:FF:000260', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121140, NULL, 'G3DSA:1.20.5.170:FF:000127', NULL, NULL, 'Protein CBR-ATF-2', NULL, NULL, NULL, NULL, NULL, 4),
(121141, NULL, 'G3DSA:3.20.20.300:FF:000081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121142, NULL, 'G3DSA:2.30.42.10:FF:000637', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121143, NULL, 'G3DSA:1.10.287.3240:FF:000005', NULL, NULL, 'coiled-coil domain-containing protein 115', NULL, NULL, NULL, NULL, NULL, 4),
(121144, NULL, 'G3DSA:3.90.20.20:FF:000006', NULL, NULL, 'GrpE protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(121145, NULL, 'G3DSA:2.40.50.140:FF:000476', NULL, NULL, '26S proteasome regulatory subunit 8', NULL, NULL, NULL, NULL, NULL, 4),
(121146, NULL, 'G3DSA:1.25.40.10:FF:001463', NULL, NULL, 'tetratricopeptide repeat protein 30 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(121147, NULL, 'G3DSA:1.25.40.20:FF:001718', NULL, NULL, 'Inhibitor of Bruton tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(121148, NULL, 'G3DSA:3.30.160.60:FF:005090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121149, NULL, 'G3DSA:1.20.5.100:FF:000022', NULL, NULL, 'Ubiquinol-cytochrome c reductase cytochrome c1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(121150, NULL, 'G3DSA:3.40.50.720:FF:000932', NULL, NULL, '3-oxoacyl-[acyl-carrier protein] reductase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(121151, NULL, 'G3DSA:1.25.40.20:FF:001921', NULL, NULL, 'Ion channel NompC', NULL, NULL, NULL, NULL, NULL, 4),
(121152, NULL, 'G3DSA:3.40.50.10470:FF:000022', NULL, NULL, 'Translation initiation factor EIF-2b alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121153, NULL, 'G3DSA:3.40.250.10:FF:000262', NULL, NULL, 'ACR158Wp', NULL, NULL, NULL, NULL, NULL, 4),
(121154, NULL, 'G3DSA:2.60.300.12:FF:000004', NULL, NULL, 'Fe/S biogenesis protein NfuA', NULL, NULL, NULL, NULL, NULL, 4),
(121155, NULL, 'G3DSA:2.130.10.10:FF:003145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121156, NULL, 'G3DSA:3.40.710.10:FF:000157', NULL, NULL, 'Penicillin-binding protein, 1A family', NULL, NULL, NULL, NULL, NULL, 4),
(121157, NULL, 'G3DSA:1.20.1430.10:FF:000001', NULL, NULL, '1,4-alpha-glucan branching enzyme TK1436', NULL, NULL, NULL, NULL, NULL, 4),
(121158, NULL, 'G3DSA:1.10.238.10:FF:000967', NULL, NULL, 'EHS-1', NULL, NULL, NULL, NULL, NULL, 4),
(121159, NULL, 'G3DSA:1.10.8.60:FF:000204', NULL, NULL, 'Replication factor C subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(121160, NULL, 'G3DSA:3.40.50.720:FF:000680', NULL, NULL, 'AflX/ ordB/ monooxygenase/ oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(121161, NULL, 'G3DSA:1.20.1250.10:FF:000144', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121162, NULL, 'G3DSA:3.40.50.300:FF:007383', NULL, NULL, 'atlastin-2', NULL, NULL, NULL, NULL, NULL, 4),
(121163, NULL, 'G3DSA:2.10.70.10:FF:000231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121164, NULL, 'G3DSA:1.25.40.10:FF:001244', NULL, NULL, 'HCP-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(121165, NULL, 'G3DSA:1.10.287.520:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121166, NULL, 'G3DSA:2.130.10.10:FF:003055', NULL, NULL, 'Transducin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(121167, NULL, 'G3DSA:3.30.300.30:FF:000062', NULL, NULL, 'RfbL protein', NULL, NULL, NULL, NULL, NULL, 4),
(121168, NULL, 'G3DSA:2.30.280.10:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121169, NULL, 'G3DSA:1.10.10.10:FF:001455', NULL, NULL, 'VIRF-1', NULL, NULL, NULL, NULL, NULL, 4),
(121170, NULL, 'G3DSA:3.30.420.40:FF:001085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121171, NULL, 'G3DSA:3.40.50.300:FF:008001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121172, NULL, 'G3DSA:1.20.1250.20:FF:000147', NULL, NULL, 'Protein NRT1/ PTR family 5.10', NULL, NULL, NULL, NULL, NULL, 4),
(121173, NULL, 'G3DSA:2.170.300.10:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121174, NULL, 'G3DSA:1.25.40.10:FF:004897', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121175, NULL, 'G3DSA:3.75.10.10:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121176, NULL, 'G3DSA:2.60.40.10:FF:003616', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121177, NULL, 'G3DSA:2.60.40.10:FF:002998', NULL, NULL, 'AGAP003656-PB', NULL, NULL, NULL, NULL, NULL, 4),
(121178, NULL, 'G3DSA:1.20.1270.60:FF:000109', NULL, NULL, 'Rho-GTPase-activating protein RGD2', NULL, NULL, NULL, NULL, NULL, 4),
(121179, NULL, 'G3DSA:3.40.50.2300:FF:000782', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121180, NULL, 'G3DSA:1.25.40.20:FF:000994', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(121181, NULL, 'G3DSA:3.30.160.320:FF:000001', NULL, NULL, 'Antimicrobial protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(121182, NULL, 'G3DSA:3.30.200.20:FF:001220', NULL, NULL, 'ABL protein', NULL, NULL, NULL, NULL, NULL, 4),
(121183, NULL, 'G3DSA:2.40.50.1020:FF:000022', NULL, NULL, 'Carbon monoxide dehydrogenase operon C protein', NULL, NULL, NULL, NULL, NULL, 4),
(121184, NULL, 'G3DSA:3.40.50.360:FF:000009', NULL, NULL, 'NADPH--cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(121185, NULL, 'G3DSA:3.40.1190.20:FF:000208', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(121186, NULL, 'G3DSA:2.130.10.10:FF:003583', NULL, NULL, 'CDH1-B', NULL, NULL, NULL, NULL, NULL, 4),
(121187, NULL, 'G3DSA:1.10.287.70:FF:000660', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121188, NULL, 'G3DSA:2.30.39.10:FF:000023', NULL, NULL, 'SeRPin', NULL, NULL, NULL, NULL, NULL, 4),
(121189, NULL, 'G3DSA:3.30.160.60:FF:001812', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121190, NULL, 'G3DSA:3.20.20.100:FF:000099', NULL, NULL, 'Oxidoreductase, aldo/keto reductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(121191, NULL, 'G3DSA:3.30.70.270:FF:000219', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121192, NULL, 'G3DSA:1.20.5.110:FF:000115', NULL, NULL, 'Protein transport protein SEC22', NULL, NULL, NULL, NULL, NULL, 4),
(121193, NULL, 'G3DSA:1.10.640.10:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121194, NULL, 'G3DSA:4.10.400.10:FF:000114', NULL, NULL, 'Suppressor of tumorigenicity 14 protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(121195, NULL, 'G3DSA:1.20.930.10:FF:000023', NULL, NULL, 'Transcription elongation factor (TFIIS) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(121196, NULL, 'G3DSA:3.10.129.10:FF:000049', NULL, NULL, 'PaaI family thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(121197, NULL, 'G3DSA:1.25.40.10:FF:000991', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(121198, NULL, 'G3DSA:1.25.40.10:FF:004588', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121199, NULL, 'G3DSA:2.20.25.350:FF:000001', NULL, NULL, 'Eukaryotic translation initiation factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(121200, NULL, 'G3DSA:3.50.50.60:FF:000842', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(121201, NULL, 'G3DSA:3.10.129.10:FF:000291', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121202, NULL, 'G3DSA:3.30.160.60:FF:000053', NULL, NULL, 'zinc finger protein 182 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(121203, NULL, 'G3DSA:2.40.70.10:FF:000556', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121204, NULL, 'G3DSA:3.40.50.720:FF:000371', NULL, NULL, 'Inositol-3-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(121205, NULL, 'G3DSA:3.80.10.10:FF:000790', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase PEPR1', NULL, NULL, NULL, NULL, NULL, 4),
(121206, NULL, 'G3DSA:3.40.1410.10:FF:000033', NULL, NULL, 'Probable chorismate pyruvate-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(121207, NULL, 'G3DSA:3.40.50.300:FF:003454', NULL, NULL, 'Translation initiation factor IF-2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121208, NULL, 'G3DSA:3.40.1280.10:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121209, NULL, 'G3DSA:1.10.20.10:FF:000101', NULL, NULL, 'Transcriptional activator SPT7', NULL, NULL, NULL, NULL, NULL, 4),
(121210, NULL, 'G3DSA:3.40.50.2300:FF:000473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121211, NULL, 'G3DSA:3.30.160.60:FF:004937', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121212, NULL, 'G3DSA:3.30.2130.30:FF:000025', NULL, NULL, 'THUMP domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(121213, NULL, 'G3DSA:1.20.1160.20:FF:000011', NULL, NULL, 'Regulator of telomere elongation helicase 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(121214, NULL, 'G3DSA:1.20.58.1070:FF:000002', NULL, NULL, 'Survival motor neuron containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(121215, NULL, 'G3DSA:3.30.760.10:FF:000067', NULL, NULL, 'Eukaryotic translation initiation factor 4E family member 1c', NULL, NULL, NULL, NULL, NULL, 4),
(121216, NULL, 'G3DSA:3.30.40.10:FF:000288', NULL, NULL, 'Probable E3 ubiquitin ligase SUD1', NULL, NULL, NULL, NULL, NULL, 4),
(121217, NULL, 'G3DSA:2.60.40.10:FF:003307', NULL, NULL, 'Leukemia inhibitory factor receptor alpha b', NULL, NULL, NULL, NULL, NULL, 4),
(121218, NULL, 'G3DSA:3.40.50.620:FF:000088', NULL, NULL, 'Ethanolamine-phosphate cytidylyltransferase isoform 2', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(121219, NULL, 'G3DSA:2.40.30.170:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121220, NULL, 'G3DSA:3.90.79.20:FF:000006', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(121221, NULL, 'G3DSA:3.40.50.1820:FF:000429', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(121222, NULL, 'G3DSA:3.40.50.300:FF:007692', NULL, NULL, 'Protein CBG10112', NULL, NULL, NULL, NULL, NULL, 4),
(121223, NULL, 'G3DSA:3.40.50.2020:FF:000113', NULL, NULL, 'Probable adenine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(121224, NULL, 'G3DSA:3.30.900.10:FF:000056', NULL, NULL, 'Him-Three Paralog', NULL, NULL, NULL, NULL, NULL, 4),
(121225, NULL, 'G3DSA:2.10.50.10:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121226, NULL, 'G3DSA:1.25.10.20:FF:000025', NULL, NULL, 'Vitellogenin 7', NULL, NULL, NULL, NULL, NULL, 4),
(121227, NULL, 'G3DSA:3.30.750.24:FF:000119', NULL, NULL, 'Solute carrier family 26 member 10', NULL, NULL, NULL, NULL, NULL, 4),
(121228, NULL, 'G3DSA:2.60.40.10:FF:002779', NULL, NULL, 'Short-form leptin receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(121229, NULL, 'G3DSA:1.20.58.1080:FF:000005', NULL, NULL, 'Mitochondrial ATP-dependent RNA helicase Suv3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121230, NULL, 'G3DSA:1.20.5.170:FF:000094', NULL, NULL, 'Beaded filament structural protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(121231, NULL, 'G3DSA:1.10.390.10:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121232, NULL, 'G3DSA:1.20.58.1770:FF:000004', NULL, NULL, 'Rab interacting lysosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(121233, NULL, 'G3DSA:2.20.100.10:FF:000226', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs gon-1', NULL, NULL, NULL, NULL, NULL, 4),
(121234, NULL, 'G3DSA:1.25.40.10:FF:005206', NULL, NULL, 'PH domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(121235, NULL, 'G3DSA:3.30.70.270:FF:000129', NULL, NULL, 'GGDEF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(121236, NULL, 'G3DSA:1.20.1250.20:FF:000708', NULL, NULL, 'Unplaced genomic scaffold supercont1.134, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(121237, NULL, 'G3DSA:1.10.260.40:FF:000073', NULL, NULL, 'transcription factor protein', NULL, NULL, NULL, NULL, NULL, 4),
(121238, NULL, 'G3DSA:3.40.50.2300:FF:001400', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121239, NULL, 'G3DSA:1.20.1070.10:FF:000686', NULL, NULL, '5-hydroxytryptamine receptor 7', NULL, NULL, NULL, NULL, NULL, 4),
(121240, NULL, 'G3DSA:2.40.50.140:FF:000947', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121241, NULL, 'G3DSA:3.40.50.2000:FF:000720', NULL, NULL, 'Lipopolysaccharide heptosyltransferase-1', NULL, NULL, NULL, NULL, NULL, 4),
(121242, NULL, 'G3DSA:1.20.1250.20:FF:000456', NULL, NULL, 'Solute carrier family 45 member 2', NULL, NULL, NULL, NULL, NULL, 4),
(121243, NULL, 'G3DSA:1.10.580.10:FF:000003', NULL, NULL, 'Citrate synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(121244, NULL, 'G3DSA:2.130.10.10:FF:003616', NULL, NULL, 'EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(121245, NULL, 'G3DSA:3.30.160.60:FF:001503', NULL, NULL, 'zinc finger protein 33B isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(121246, NULL, 'G3DSA:3.10.20.710:FF:000003', NULL, NULL, 'DNA-binding protein SATB', NULL, NULL, NULL, NULL, NULL, 4),
(121247, NULL, 'G3DSA:2.130.10.10:FF:003364', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121248, NULL, 'G3DSA:3.40.50.1820:FF:000738', NULL, NULL, 'Probable protein phosphatase methylesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(121249, NULL, 'G3DSA:3.30.70.1730:FF:000017', NULL, NULL, '60S acidic ribosomal protein P0', NULL, NULL, NULL, NULL, NULL, 4),
(121250, NULL, 'G3DSA:3.30.160.20:FF:000103', NULL, NULL, 'Ribonuclease 3', NULL, NULL, NULL, NULL, NULL, 4),
(121251, NULL, 'G3DSA:1.25.40.20:FF:001247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(121252, NULL, 'G3DSA:3.40.50.10190:FF:000062', NULL, NULL, 'Pebble, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(121253, NULL, 'G3DSA:2.10.25.10:FF:000470', NULL, NULL, 'Stabilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(121254, NULL, 'G3DSA:3.30.70.330:FF:003031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121255, NULL, 'G3DSA:2.10.70.10:FF:000012', NULL, NULL, 'Seizure related 6 homolog like', NULL, NULL, NULL, NULL, NULL, 4),
(121256, NULL, 'G3DSA:3.80.10.10:FF:004168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121257, NULL, 'G3DSA:1.10.10.500:FF:000002', NULL, NULL, 'Prospero homeobox 3', NULL, NULL, NULL, NULL, NULL, 4),
(121258, NULL, 'G3DSA:3.30.160.60:FF:004105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121259, NULL, 'G3DSA:1.20.1270.60:FF:000019', NULL, NULL, 'rho GTPase-activating protein 17 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(121260, NULL, 'G3DSA:3.30.70.260:FF:000126', NULL, NULL, 'Homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(121261, NULL, 'G3DSA:3.50.50.60:FF:000932', NULL, NULL, 'Nitrate reductase, NADH oxidase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(121262, NULL, 'G3DSA:1.25.40.10:FF:004678', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(121263, NULL, 'G3DSA:1.10.555.10:FF:000041', NULL, NULL, 'Rho GTPase activator (Rgd1)', NULL, NULL, NULL, NULL, NULL, 4),
(121264, NULL, 'G3DSA:2.60.40.10:FF:003184', NULL, NULL, 'Alpha-2-macroglobulin-like', NULL, NULL, NULL, NULL, NULL, 4),
(121265, NULL, 'G3DSA:3.65.10.20:FF:000002', NULL, NULL, 'GM19193', NULL, NULL, NULL, NULL, NULL, 4),
(121266, NULL, 'G3DSA:3.60.10.10:FF:000066', NULL, NULL, 'Inositol polyphosphate-5-phosphatase Kb', NULL, NULL, NULL, NULL, NULL, 4),
(121267, NULL, 'G3DSA:3.40.50.300:FF:005803', NULL, NULL, 'Interferon-induced with helicase C domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(121268, NULL, 'G3DSA:2.60.40.60:FF:000978', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121269, NULL, 'G3DSA:2.160.20.10:FF:000328', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121270, NULL, 'G3DSA:3.30.1550.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121271, NULL, 'G3DSA:1.10.630.10:FF:000132', NULL, NULL, 'Benzoate 4-monooxygenase cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(121272, NULL, 'G3DSA:3.30.479.20:FF:000039', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(121273, NULL, 'G3DSA:3.40.50.150:FF:000031', NULL, NULL, 'Putative Histone-arginine methyltransferase CARM1', NULL, NULL, NULL, NULL, NULL, 4),
(121274, NULL, 'G3DSA:3.40.50.170:FF:000037', NULL, NULL, 'Phosphoribosylglycinamide formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(121275, NULL, 'G3DSA:2.10.25.10:FF:001779', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121276, NULL, 'G3DSA:1.20.900.10:FF:000072', NULL, NULL, 'Putative Rho guanine nucleotide exchange factor FGD-1', NULL, NULL, NULL, NULL, NULL, 4),
(121277, NULL, 'G3DSA:2.170.130.10:FF:000075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121278, NULL, 'G3DSA:3.40.50.1360:FF:000027', NULL, NULL, '6-phosphogluconolactonase', NULL, NULL, NULL, NULL, NULL, 4),
(121279, NULL, 'G3DSA:3.30.70.330:FF:000389', NULL, NULL, 'RNA binding motif protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(121280, NULL, 'G3DSA:3.40.190.10:FF:000774', NULL, NULL, 'Oligopeptide Binding Lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(121281, NULL, 'G3DSA:2.10.25.10:FF:000256', NULL, NULL, 'Signal peptide, CUB domain and EGF like domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(121282, NULL, 'G3DSA:3.30.40.10:FF:000939', NULL, NULL, 'TFIIH basal transcription factor complex p44 subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121283, NULL, 'G3DSA:3.40.630.30:FF:000331', NULL, NULL, 'GCN5-related N-acetyltransferase-like', NULL, NULL, NULL, NULL, NULL, 4),
(121284, NULL, 'G3DSA:1.10.150.50:FF:000101', NULL, NULL, 'Sterile alpha and TIR motif-containing protein tir-1', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(121285, NULL, 'G3DSA:1.50.10.10:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121286, NULL, 'G3DSA:1.10.600.10:FF:000079', NULL, NULL, '2-methylisoborneol synthase', NULL, NULL, NULL, NULL, NULL, 4),
(121287, NULL, 'G3DSA:3.10.20.90:FF:000300', NULL, NULL, 'UV excision repair protein Rad23', NULL, NULL, NULL, NULL, NULL, 4),
(121288, NULL, 'G3DSA:3.60.130.10:FF:000092', NULL, NULL, 'Clavaminate synthase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(121289, NULL, 'G3DSA:1.25.40.1040:FF:000016', NULL, NULL, 'N-alpha-acetyltransferase 16, NatA auxiliary subunit isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(121290, NULL, 'G3DSA:3.40.50.410:FF:000047', NULL, NULL, 'von Willebrand factor A domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(121291, NULL, 'G3DSA:3.40.50.2300:FF:000916', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121292, NULL, 'G3DSA:3.30.40.10:FF:000844', NULL, NULL, 'E3 ubiquitin-protein ligase RNF187', NULL, NULL, NULL, NULL, NULL, 4),
(121293, NULL, 'G3DSA:1.20.1250.20:FF:002148', NULL, NULL, 'Putative transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(121294, NULL, 'G3DSA:1.10.238.20:FF:000037', NULL, NULL, 'AGAP000580-PA', NULL, NULL, NULL, NULL, NULL, 4),
(121295, NULL, 'G3DSA:3.30.160.60:FF:001604', NULL, NULL, 'Zinc finger and SCAN domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(121296, NULL, 'G3DSA:2.40.50.1070:FF:000014', NULL, NULL, 'GD12311', NULL, NULL, NULL, NULL, NULL, 4),
(121297, NULL, 'G3DSA:3.40.50.150:FF:001554', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121298, NULL, 'G3DSA:3.80.10.10:FF:004281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121299, NULL, 'G3DSA:1.25.40.1030:FF:000013', NULL, NULL, 'Protein transport protein sec16', NULL, NULL, NULL, NULL, NULL, 4),
(121300, NULL, 'G3DSA:1.10.1300.10:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121301, NULL, 'G3DSA:3.30.70.1230:FF:000053', NULL, NULL, 'Guanylate cyclase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121302, NULL, 'G3DSA:2.170.8.10:FF:000018', NULL, NULL, 'Phosphoenol pyruvate carboxykinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121303, NULL, 'G3DSA:3.10.390.10:FF:000009', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(121304, NULL, 'G3DSA:3.30.160.60:FF:005292', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121305, NULL, 'G3DSA:3.30.160.60:FF:001593', NULL, NULL, 'Zinc finger protein 513a', NULL, NULL, NULL, NULL, NULL, 4),
(121306, NULL, 'G3DSA:3.40.1110.10:FF:000206', NULL, NULL, 'Phospholipid-transporting ATPase IIB, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121307, NULL, 'G3DSA:1.25.40.10:FF:004583', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g59600', NULL, NULL, NULL, NULL, NULL, 4),
(121308, NULL, 'G3DSA:1.20.1260.10:FF:000077', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(121309, NULL, 'G3DSA:2.40.37.10:FF:000018', NULL, NULL, 'S-adenosylmethionine decarboxylase/ornithine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(121310, NULL, 'G3DSA:3.30.1930.10:FF:000001', NULL, NULL, 'Major capsid protein E', NULL, NULL, NULL, NULL, NULL, 4),
(121311, NULL, 'G3DSA:3.90.320.10:FF:000009', NULL, NULL, 'Exonuclease V, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121312, NULL, 'G3DSA:2.130.10.10:FF:003162', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(121313, NULL, 'G3DSA:3.40.50.1820:FF:000424', NULL, NULL, 'YDL057W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(121314, NULL, 'G3DSA:3.80.10.10:FF:000582', NULL, NULL, 'NLR family CARD domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(121315, NULL, 'G3DSA:1.25.40.10:FF:005184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121316, NULL, 'G3DSA:1.20.1730.10:FF:000052', NULL, NULL, 'High affinity choline transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121317, NULL, 'G3DSA:2.60.40.10:FF:005319', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(121318, NULL, 'G3DSA:2.130.10.10:FF:005511', NULL, NULL, 'Uncharacterized WD repeat-containing protein C1306.02', NULL, NULL, NULL, NULL, NULL, 4),
(121319, NULL, 'G3DSA:3.40.50.300:FF:001425', NULL, NULL, 'Dynamin GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121320, NULL, 'G3DSA:2.30.29.30:FF:000972', NULL, NULL, 'Pleckstrin homology domain-containing family A member 8', NULL, NULL, NULL, NULL, NULL, 4),
(121321, NULL, 'G3DSA:2.10.70.10:FF:000220', NULL, NULL, 'Protein lev-9', NULL, NULL, NULL, NULL, NULL, 4),
(121322, NULL, 'G3DSA:3.40.50.10190:FF:000056', NULL, NULL, 'Pescadillo homolog', NULL, NULL, NULL, NULL, NULL, 4),
(121323, NULL, 'G3DSA:3.30.70.330:FF:002643', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121324, NULL, 'G3DSA:3.40.50.150:FF:001228', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121325, NULL, 'G3DSA:2.60.40.10:FF:001481', NULL, NULL, 'CD101 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(121326, NULL, 'G3DSA:3.60.20.40:FF:000002', NULL, NULL, 'gamma-glutamyltransferase 7', NULL, NULL, NULL, NULL, NULL, 4),
(121327, NULL, 'G3DSA:3.40.30.50:FF:000001', NULL, NULL, '15 kDa selenoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(121328, NULL, 'G3DSA:1.10.287.3240:FF:000016', NULL, NULL, 'V-type ATPase d subunit putative', NULL, NULL, NULL, NULL, NULL, 4),
(121329, NULL, 'G3DSA:3.40.50.720:FF:000573', NULL, NULL, 'GDP-mannose 6-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(121330, NULL, 'G3DSA:3.40.50.10490:FF:000039', NULL, NULL, 'Glucose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(121331, NULL, 'G3DSA:3.10.450.50:FF:000066', NULL, NULL, 'Nuclear transport factor 2 (NTF2) family protein with RNA binding (RRM-RBD-RNP motifs) domain', NULL, NULL, NULL, NULL, NULL, 4),
(121332, NULL, 'G3DSA:2.150.10.10:FF:000007', NULL, NULL, 'Bifunctional hemolysin/adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(121333, NULL, 'G3DSA:3.90.640.10:FF:000168', NULL, NULL, 'Actin-related protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(121334, NULL, 'G3DSA:1.20.1560.10:FF:000347', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(121335, NULL, 'G3DSA:3.40.50.1820:FF:000750', NULL, NULL, 'Valacyclovir hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121336, NULL, 'G3DSA:3.40.50.2000:FF:000607', NULL, NULL, 'UDP-glucose iridoid glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(121337, NULL, 'G3DSA:3.20.100.30:FF:000003', NULL, NULL, 'Vacuolar transporter chaperone 4 catalytic subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121338, NULL, 'G3DSA:1.10.3860.10:FF:000002', NULL, NULL, 'Amino acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(121339, NULL, 'G3DSA:3.30.70.340:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121340, NULL, 'G3DSA:3.10.310.40:FF:000002', NULL, NULL, 'alanine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(121341, NULL, 'G3DSA:3.30.1330.30:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121342, NULL, 'G3DSA:1.10.8.10:FF:000313', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(121343, NULL, 'G3DSA:3.90.1580.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121344, NULL, 'G3DSA:2.30.39.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121345, NULL, 'G3DSA:3.40.50.1460:FF:000041', NULL, NULL, 'DRaptor', NULL, NULL, NULL, NULL, NULL, 4),
(121346, NULL, 'G3DSA:3.30.930.10:FF:000114', NULL, NULL, 'Glycine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(121347, NULL, 'G3DSA:2.20.100.10:FF:000125', NULL, NULL, 'Circumsporozoite-and TRAP-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(121348, NULL, 'G3DSA:2.40.50.140:FF:000835', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121349, NULL, 'G3DSA:3.40.50.720:FF:000359', NULL, NULL, 'hydroxysteroid 11-beta-dehydrogenase 1-like protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(121350, NULL, 'G3DSA:3.20.20.190:FF:000081', NULL, NULL, 'Glycosylphosphatidylinositol-specific phospholipase C', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(121351, NULL, 'G3DSA:1.25.40.20:FF:001825', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121352, NULL, 'G3DSA:2.10.25.10:FF:000582', NULL, NULL, 'sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(121353, NULL, 'G3DSA:2.60.120.920:FF:000122', NULL, NULL, 'F-box/SPRY domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(121354, NULL, 'G3DSA:1.10.510.10:FF:001483', NULL, NULL, 'Serine/threonine protein kinase US3', NULL, NULL, NULL, NULL, NULL, 4),
(121355, NULL, 'G3DSA:1.25.40.10:FF:003060', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g11310, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(121356, NULL, 'G3DSA:3.90.1720.10:FF:000022', NULL, NULL, 'Phage tail fiber protein', NULL, NULL, NULL, NULL, NULL, 4),
(121357, NULL, 'G3DSA:1.50.40.10:FF:000106', NULL, NULL, 'NAD+ transporter', NULL, NULL, NULL, NULL, NULL, 4),
(121358, NULL, 'G3DSA:3.30.160.60:FF:003728', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121359, NULL, 'G3DSA:3.40.50.1820:FF:000519', NULL, NULL, 'Protein CBG05033', NULL, NULL, NULL, NULL, NULL, 4),
(121360, NULL, 'G3DSA:2.60.120.200:FF:000474', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121361, NULL, 'G3DSA:1.20.1250.20:FF:000703', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(121362, NULL, 'G3DSA:3.40.630.20:FF:000002', NULL, NULL, 'Pyroglutamyl-peptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(121363, NULL, 'G3DSA:3.40.140.100:FF:000002', NULL, NULL, 'Ubiquitin-like modifier-activating enzyme atg7', NULL, NULL, NULL, NULL, NULL, 4),
(121364, NULL, 'G3DSA:1.10.510.10:FF:003411', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121365, NULL, 'G3DSA:3.30.54.20:FF:000008', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(121366, NULL, 'G3DSA:1.10.287.210:FF:000005', NULL, NULL, 'Envelope glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(121367, NULL, 'G3DSA:1.25.40.10:FF:001822', NULL, NULL, 'Pentatricopeptide repeat-containing family protein', NULL, NULL, NULL, NULL, NULL, 4),
(121368, NULL, 'G3DSA:1.20.1070.10:FF:000602', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(121369, NULL, 'G3DSA:3.40.640.10:FF:000298', NULL, NULL, 'Glycine cleavage system P-protein', NULL, NULL, NULL, NULL, NULL, 4),
(121370, NULL, 'G3DSA:3.30.70.360:FF:000027', NULL, NULL, 'N-carbamoyl-L-amino acid hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(121371, NULL, 'G3DSA:3.30.190.20:FF:000037', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(121372, NULL, 'G3DSA:3.40.630.30:FF:000005', NULL, NULL, 'Ribosomal protein alanine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(121373, NULL, 'G3DSA:3.30.160.60:FF:000070', NULL, NULL, 'zinc finger protein 689 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(121374, NULL, 'G3DSA:1.20.1560.10:FF:000561', NULL, NULL, 'Multidrug resistance protein 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121375, NULL, 'G3DSA:2.60.40.420:FF:000093', NULL, NULL, 'Copper-containing nitrite reductase', NULL, NULL, NULL, NULL, NULL, 4),
(121376, NULL, 'G3DSA:3.40.50.10190:FF:000270', NULL, NULL, 'DNA topoisomerase 2-binding protein 1-A', NULL, NULL, NULL, NULL, NULL, 4),
(121377, NULL, 'G3DSA:1.10.287.1060:FF:000003', NULL, NULL, 'Alpha-(1,6)-fucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(121378, NULL, 'G3DSA:1.25.10.10:FF:002838', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121379, NULL, 'G3DSA:1.25.10.10:FF:003232', NULL, NULL, 'Protein aardvark', NULL, NULL, NULL, NULL, NULL, 4),
(121380, NULL, 'G3DSA:1.20.1450.10:FF:000002', NULL, NULL, 'Ammonia monooxygenase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(121381, NULL, 'G3DSA:1.10.10.10:FF:001573', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(121382, NULL, 'G3DSA:3.30.160.60:FF:001267', NULL, NULL, 'Zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(121383, NULL, 'G3DSA:1.20.58.900:FF:000037', NULL, NULL, 'RUN domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(121384, NULL, 'G3DSA:3.40.50.300:FF:004977', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(121385, NULL, 'G3DSA:2.30.29.30:FF:000551', NULL, NULL, 'Inactive tyrosine-protein kinase kin-32', NULL, NULL, NULL, NULL, NULL, 4),
(121386, NULL, 'G3DSA:3.40.630.40:FF:000008', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase LytC', NULL, NULL, NULL, NULL, NULL, 4),
(121387, NULL, 'G3DSA:3.40.50.2300:FF:000579', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121388, NULL, 'G3DSA:2.40.50.140:FF:001083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121389, NULL, 'G3DSA:1.20.5.1030:FF:000001', NULL, NULL, 'Preprotein translocase subunit SecE', NULL, NULL, NULL, NULL, NULL, 4),
(121390, NULL, 'G3DSA:3.50.50.60:FF:001224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121391, NULL, 'G3DSA:1.20.930.10:FF:000006', NULL, NULL, 'Serine/threonine-protein phosphatase 1 regulatory subunit 10', NULL, NULL, NULL, NULL, NULL, 4),
(121392, NULL, 'G3DSA:1.20.5.110:FF:000132', NULL, NULL, 'Syntaxin 8', NULL, NULL, NULL, NULL, NULL, 4),
(121393, NULL, 'G3DSA:3.40.50.720:FF:002276', NULL, NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121394, NULL, 'G3DSA:4.10.1060.10:FF:000045', NULL, NULL, 'Zinc finger RANBP2-type containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(121395, NULL, 'G3DSA:1.25.10.10:FF:003344', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(121396, NULL, 'G3DSA:3.30.70.330:FF:002738', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121397, NULL, 'G3DSA:2.120.10.30:FF:000599', NULL, NULL, 'Acylamino acid-releasing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(121398, NULL, 'G3DSA:3.80.10.10:FF:000256', NULL, NULL, 'NLR family pyrin domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(121399, NULL, 'G3DSA:2.60.40.10:FF:005533', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121400, NULL, 'G3DSA:3.30.420.10:FF:000570', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121401, NULL, 'G3DSA:2.10.90.10:FF:000120', NULL, NULL, 'Brain-derived neurotrophic factor', NULL, NULL, NULL, NULL, NULL, 4),
(121402, NULL, 'G3DSA:3.30.160.60:FF:003049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121403, NULL, 'G3DSA:3.40.50.300:FF:002240', NULL, NULL, 'ATP-dependent DEAD/H RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(121404, NULL, 'G3DSA:3.30.760.10:FF:000056', NULL, NULL, 'Eukaryotic translation initiation factor 4E', NULL, NULL, NULL, NULL, NULL, 4),
(121405, NULL, 'G3DSA:2.10.50.10:FF:000106', NULL, NULL, 'Si:ch211-261n11.8', NULL, NULL, NULL, NULL, NULL, 4),
(121406, NULL, 'G3DSA:2.70.160.11:FF:000091', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(121407, NULL, 'G3DSA:3.30.710.10:FF:000019', NULL, NULL, 'Potassium voltage-gated channel, subfamily G, member 1', NULL, NULL, NULL, NULL, NULL, 4),
(121408, NULL, 'G3DSA:2.60.120.200:FF:000148', NULL, NULL, 'Collagen, type XIX, alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(121409, NULL, 'G3DSA:2.120.10.30:FF:000487', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121410, NULL, 'G3DSA:3.40.710.10:FF:000163', NULL, NULL, 'Penicillin-binding protein 1C (PBP-1c)', NULL, NULL, NULL, NULL, NULL, 4),
(121411, NULL, 'G3DSA:3.80.10.10:FF:002622', NULL, NULL, 'Nuclear factor of kappa light polypeptide gene enhancer in B-cells inhibitor-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(121412, NULL, 'G3DSA:3.60.40.10:FF:000247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121413, NULL, 'G3DSA:3.90.120.10:FF:000028', NULL, NULL, 'DNA-cytosine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(121414, NULL, 'G3DSA:1.10.400.10:FF:000098', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(121415, NULL, 'G3DSA:3.20.20.140:FF:000105', NULL, NULL, 'Amidohydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(121416, NULL, 'G3DSA:3.30.450.30:FF:000078', NULL, NULL, 'Late endosomal/lysosomal adaptor, MAPK and MTOR activator 2', NULL, NULL, NULL, NULL, NULL, 4),
(121417, NULL, 'G3DSA:1.20.1070.10:FF:000809', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121418, NULL, 'G3DSA:1.20.5.1040:FF:000004', NULL, NULL, 'Sensor protein qseC', NULL, NULL, NULL, NULL, NULL, 4),
(121419, NULL, 'G3DSA:3.30.70.330:FF:001120', NULL, NULL, 'RNA-binding protein rnp24, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121420, NULL, 'G3DSA:3.40.710.10:FF:000051', NULL, NULL, 'Penicillin-binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(121421, NULL, 'G3DSA:3.30.420.40:FF:000579', NULL, NULL, 'Cell growth defect factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(121422, NULL, 'G3DSA:3.10.310.50:FF:000005', NULL, NULL, 'Protein CBG08983', NULL, NULL, NULL, NULL, NULL, 4),
(121423, NULL, 'G3DSA:3.30.450.20:FF:000075', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(121424, NULL, 'G3DSA:1.25.40.10:FF:003155', NULL, NULL, 'Os08g0494350 protein', NULL, NULL, NULL, NULL, NULL, 4),
(121425, NULL, 'G3DSA:2.30.30.490:FF:000056', NULL, NULL, 'Ash1 (absent, small, or homeotic)-like', NULL, NULL, NULL, NULL, NULL, 4),
(121426, NULL, 'G3DSA:1.10.150.50:FF:000090', NULL, NULL, 'Bem1 interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(121427, NULL, 'G3DSA:1.10.510.10:FF:002000', NULL, NULL, 'Kinase-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(121428, NULL, 'G3DSA:2.30.29.30:FF:000646', NULL, NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', NULL, NULL, NULL, NULL, NULL, 4),
(121429, NULL, 'G3DSA:3.30.160.60:FF:003942', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121430, NULL, 'G3DSA:4.10.280.10:FF:000019', NULL, NULL, 'Myc proto-oncogene protein', NULL, NULL, NULL, NULL, NULL, 4),
(121431, NULL, 'G3DSA:3.40.50.300:FF:007153', NULL, NULL, 'N-deacetylase/N-sulfotransferase (heparan glucosaminyl) 2a', NULL, NULL, NULL, NULL, NULL, 4),
(121432, NULL, 'G3DSA:2.30.30.100:FF:000198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121433, NULL, 'G3DSA:1.10.510.10:FF:003506', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121434, NULL, 'G3DSA:1.10.3370.10:FF:000032', NULL, NULL, 'Protein translocase subunit SecY', NULL, NULL, NULL, NULL, NULL, 4),
(121435, NULL, 'G3DSA:1.10.555.10:FF:000170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121436, NULL, 'G3DSA:1.10.132.30:FF:000031', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(121437, NULL, 'G3DSA:3.40.1670.10:FF:000001', NULL, NULL, '3-octaprenyl-4-hydroxybenzoate carboxy-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(121438, NULL, 'G3DSA:3.40.390.10:FF:000076', NULL, NULL, 'membrane metallo-endopeptidase-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(121439, NULL, 'G3DSA:1.20.1270.10:FF:000016', NULL, NULL, 'Heat shock protein 70', NULL, NULL, NULL, NULL, NULL, 4),
(121440, NULL, 'G3DSA:2.10.25.10:FF:001684', NULL, NULL, 'Latent transforming growth factor beta binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(121441, NULL, 'G3DSA:3.90.640.10:FF:000056', NULL, NULL, 'Heat shock 70 kDa protein 4L', NULL, NULL, NULL, NULL, NULL, 4),
(121442, NULL, 'G3DSA:3.40.50.720:FF:000685', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(121443, NULL, 'G3DSA:3.40.50.300:FF:007832', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121444, NULL, 'G3DSA:3.30.160.20:FF:000209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121445, NULL, 'G3DSA:1.10.510.10:FF:001820', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121446, NULL, 'G3DSA:2.60.40.10:FF:003279', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121447, NULL, 'G3DSA:1.20.58.60:FF:000646', NULL, NULL, 'Nesprin-1', NULL, NULL, NULL, NULL, NULL, 4),
(121448, NULL, 'G3DSA:3.40.50.1010:FF:000041', NULL, NULL, 'Unplaced genomic scaffold supercont1.259, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(121449, NULL, 'G3DSA:3.80.10.10:FF:002510', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121450, NULL, 'G3DSA:1.20.1560.10:FF:000235', NULL, NULL, 'Multidrug resistance-associated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121451, NULL, 'G3DSA:3.40.50.300:FF:003780', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121452, NULL, 'G3DSA:3.10.20.90:FF:000997', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(121453, NULL, 'G3DSA:3.40.30.10:FF:000343', NULL, NULL, 'Protein disulfide isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(121454, NULL, 'G3DSA:1.20.1070.10:FF:001203', NULL, NULL, 'Parietopsin', NULL, NULL, NULL, NULL, NULL, 4),
(121455, NULL, 'G3DSA:1.20.970.10:FF:000020', NULL, NULL, 'Anthranilate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(121456, NULL, 'G3DSA:2.30.42.10:FF:000632', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121457, NULL, 'G3DSA:2.60.40.2170:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121458, NULL, 'G3DSA:1.10.1200.10:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121459, NULL, 'G3DSA:2.60.40.650:FF:000026', NULL, NULL, 'Sulfite oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(121460, NULL, 'G3DSA:3.30.40.10:FF:000491', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(121461, NULL, 'G3DSA:3.80.10.10:FF:002717', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121462, NULL, 'G3DSA:4.10.1000.10:FF:000053', NULL, NULL, 'Putative zinc finger CCCH domain-containing protein 48', NULL, NULL, NULL, NULL, NULL, 4),
(121463, NULL, 'G3DSA:1.25.10.10:FF:003439', NULL, NULL, 'Splicing factor subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121464, NULL, 'G3DSA:2.60.120.10:FF:000033', NULL, NULL, 'Centromere protein C 1', NULL, NULL, NULL, NULL, NULL, 4),
(121465, NULL, 'G3DSA:3.40.50.300:FF:005466', NULL, NULL, 'ATP-dependent DEAD/H RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121466, NULL, 'G3DSA:3.30.70.330:FF:001541', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121467, NULL, 'G3DSA:1.20.58.1480:FF:000018', NULL, NULL, 'AGAP005299-PA', NULL, NULL, NULL, NULL, NULL, 4),
(121468, NULL, 'G3DSA:3.30.342.10:FF:000028', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(121469, NULL, 'G3DSA:1.10.287.660:FF:000005', NULL, NULL, 'Vacuolar protein-sorting-associated protein 37 homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(121470, NULL, 'G3DSA:1.25.40.180:FF:000312', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121471, NULL, 'G3DSA:1.20.58.60:FF:000860', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121472, NULL, 'G3DSA:2.60.40.1090:FF:000010', NULL, NULL, 'Fimbrial adhesin FimH', NULL, NULL, NULL, NULL, NULL, 4),
(121473, NULL, 'G3DSA:3.90.25.10:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121474, NULL, 'G3DSA:1.25.40.10:FF:000979', NULL, NULL, 'tetratricopeptide repeat protein 28', NULL, NULL, NULL, NULL, NULL, 4),
(121475, NULL, 'G3DSA:1.20.1250.20:FF:000815', NULL, NULL, 'Membrane-associated transporter protein', NULL, NULL, NULL, NULL, NULL, 4),
(121476, NULL, 'G3DSA:1.20.1070.10:FF:000714', NULL, NULL, 'G protein-coupled receptor 55', NULL, NULL, NULL, NULL, NULL, 4),
(121477, NULL, 'G3DSA:2.20.100.10:FF:000237', NULL, NULL, 'Thrombospondin, type I, domain-containing 7Ba', NULL, NULL, NULL, NULL, NULL, 4),
(121478, NULL, 'G3DSA:3.40.50.410:FF:000373', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(121479, NULL, 'G3DSA:1.20.930.20:FF:000009', NULL, NULL, 'Os12g0249900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(121480, NULL, 'G3DSA:1.10.1710.10:FF:000002', NULL, NULL, 'RNA chaperone ProQ', NULL, NULL, NULL, NULL, NULL, 4),
(121481, NULL, 'G3DSA:2.130.10.10:FF:003257', NULL, NULL, 'Periodic tryptophan protein 2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(121482, NULL, 'G3DSA:3.40.630.30:FF:000117', NULL, NULL, 'GCN5-related N-acetyltransferase protein-like', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(121483, NULL, 'G3DSA:3.30.200.20:FF:002395', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121484, NULL, 'G3DSA:3.30.420.40:FF:000011', NULL, NULL, 'Actin isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(121485, NULL, 'G3DSA:1.20.1110.10:FF:000061', NULL, NULL, 'Cation transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(121486, NULL, 'G3DSA:3.90.230.10:FF:000002', NULL, NULL, 'Xaa-Pro aminopeptidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(121487, NULL, 'G3DSA:3.40.390.10:FF:000093', NULL, NULL, 'Disintegrin and metalloproteinase domain-containing protein B', NULL, NULL, NULL, NULL, NULL, 4),
(121488, NULL, 'G3DSA:3.40.350.10:FF:000079', NULL, NULL, 'Uncharacterized peptidase C18A7.01', NULL, NULL, NULL, NULL, NULL, 4),
(121489, NULL, 'G3DSA:3.30.160.20:FF:000182', NULL, NULL, 'Ribosomal protein S5, C-terminal domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(121490, NULL, 'G3DSA:3.40.50.2300:FF:001405', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121491, NULL, 'G3DSA:1.20.1420.30:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121492, NULL, 'G3DSA:3.40.250.10:FF:000032', NULL, NULL, 'Rhodanese-like domain-containing protein 14, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(121493, NULL, 'G3DSA:3.40.20.10:FF:000174', NULL, NULL, 'ABR105Cp', NULL, NULL, NULL, NULL, NULL, 4),
(121494, NULL, 'G3DSA:3.40.1280.10:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121495, NULL, 'G3DSA:1.10.275.20:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121496, NULL, 'G3DSA:1.10.101.10:FF:000010', NULL, NULL, 'Murein L,D-transpeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(121497, NULL, 'G3DSA:1.20.1740.10:FF:000007', NULL, NULL, 'APC family permease', NULL, NULL, NULL, NULL, NULL, 4),
(121498, NULL, 'G3DSA:1.50.10.10:FF:000060', NULL, NULL, 'Glycosyl hydrolase family 65 central catalytic domain/Haloacid dehalogenase-like hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121499, NULL, 'G3DSA:2.60.40.10:FF:005196', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121500, NULL, 'G3DSA:1.10.472.80:FF:000060', NULL, NULL, 'TBC domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121501, NULL, 'G3DSA:1.10.10.10:FF:001910', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121502, NULL, 'G3DSA:1.25.40.10:FF:002666', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121503, NULL, 'G3DSA:1.20.1070.10:FF:002159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121504, NULL, 'G3DSA:1.25.40.10:FF:005307', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121505, NULL, 'G3DSA:1.20.1070.10:FF:000265', NULL, NULL, 'Blast:Neuropeptide Y receptor', NULL, NULL, NULL, NULL, NULL, 4),
(121506, NULL, 'G3DSA:1.20.970.10:FF:000003', NULL, NULL, 'Anthranilate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(121507, NULL, 'G3DSA:3.40.50.2000:FF:000580', NULL, NULL, '1,2-diacylglycerol 3-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(121508, NULL, 'G3DSA:3.30.70.940:FF:000004', NULL, NULL, 'Transcription antitermination protein RfaH', NULL, NULL, NULL, NULL, NULL, 4),
(121509, NULL, 'G3DSA:3.40.50.2300:FF:000804', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121510, NULL, 'G3DSA:3.20.20.70:FF:000350', NULL, NULL, 'Glutamate synthase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(121511, NULL, 'G3DSA:3.40.50.1700:FF:000034', NULL, NULL, 'Beta-glucosidase (Gentiobiase)', NULL, NULL, NULL, NULL, NULL, 4),
(121512, NULL, 'G3DSA:1.20.1300.20:FF:000005', NULL, NULL, 'Ubiquitin thioesterase otubain-like', NULL, NULL, NULL, NULL, NULL, 4),
(121513, NULL, 'G3DSA:3.40.50.300:FF:007720', NULL, NULL, 'DsRNA-specific nuclease dicer and related ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(121514, NULL, 'G3DSA:3.40.50.1110:FF:000071', NULL, NULL, 'Esterase', NULL, NULL, NULL, NULL, NULL, 4),
(121515, NULL, 'G3DSA:1.20.1160.11:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(121516, NULL, 'G3DSA:3.30.420.220:FF:000003', NULL, NULL, 'Nop family pre-rRNA processing protein', NULL, NULL, NULL, NULL, NULL, 4),
(121517, NULL, 'G3DSA:3.30.1240.10:FF:000033', NULL, NULL, 'Cof family hydrolase subfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(121518, NULL, 'G3DSA:3.30.420.60:FF:000017', NULL, NULL, 'ERF1 domain 3 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(121519, NULL, 'G3DSA:3.40.720.10:FF:000332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121520, NULL, 'G3DSA:1.10.418.20:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121521, NULL, 'G3DSA:2.30.170.20:FF:000006', NULL, NULL, '50S ribosomal protein L24e', NULL, NULL, NULL, NULL, NULL, 4),
(121522, NULL, 'G3DSA:3.30.70.930:FF:000001', NULL, NULL, 'ECM15p protein', NULL, NULL, NULL, NULL, NULL, 4),
(121523, NULL, 'G3DSA:1.20.1560.10:FF:000914', NULL, NULL, 'ATP-binding cassette transporter, subfamily B, member 7, group TAP protein PpABCB7', NULL, NULL, NULL, NULL, NULL, 4),
(121524, NULL, 'G3DSA:3.30.70.3270:FF:000002', NULL, NULL, 'NADH-quinone oxidoreductase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(121525, NULL, 'G3DSA:2.130.10.10:FF:005623', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121526, NULL, 'G3DSA:4.10.400.10:FF:000013', NULL, NULL, 'Prolow-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(121527, NULL, 'G3DSA:3.50.50.60:FF:000595', NULL, NULL, 'FAD/NAD(P)-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(121528, NULL, 'G3DSA:3.40.50.1820:FF:000536', NULL, NULL, 'Abhydrolase domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(121529, NULL, 'G3DSA:1.25.40.10:FF:005072', NULL, NULL, 'Tetratricopeptide repeat domain 37', NULL, NULL, NULL, NULL, NULL, 4),
(121530, NULL, 'G3DSA:1.25.10.10:FF:001192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121531, NULL, 'G3DSA:3.20.20.80:FF:000353', NULL, NULL, 'Glycoside hydrolase family 2 sugar binding', NULL, NULL, NULL, NULL, NULL, 4),
(121532, NULL, 'G3DSA:3.30.2460.20:FF:000013', NULL, NULL, 'Protein Wnt', NULL, NULL, NULL, NULL, NULL, 4),
(121533, NULL, 'G3DSA:1.10.510.10:FF:001269', NULL, NULL, 'Cyclin dependent kinase 6', NULL, NULL, NULL, NULL, NULL, 4),
(121534, NULL, 'G3DSA:4.10.240.10:FF:000141', NULL, NULL, 'Ty1 enhancer activator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121535, NULL, 'G3DSA:2.60.40.10:FF:003167', NULL, NULL, 'Anosmin 1a', NULL, NULL, NULL, NULL, NULL, 4),
(121536, NULL, 'G3DSA:3.60.10.10:FF:000083', NULL, NULL, 'Putative inositol polyphosphate phosphatase (Synaptogenin-like) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(121537, NULL, 'G3DSA:1.10.730.10:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121538, NULL, 'G3DSA:2.130.10.30:FF:000054', NULL, NULL, 'Scf associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(121539, NULL, 'G3DSA:3.30.70.890:FF:000051', NULL, NULL, 'Diphosphomevalonate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(121540, NULL, 'G3DSA:1.10.287.70:FF:000227', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(121541, NULL, 'G3DSA:1.25.40.10:FF:001143', NULL, NULL, 'Pol II transcription elongation factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121542, NULL, 'G3DSA:3.30.160.60:FF:003521', NULL, NULL, 'Zinc finger protein 541', NULL, NULL, NULL, NULL, NULL, 4),
(121543, NULL, 'G3DSA:3.80.10.10:FF:004067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121544, NULL, 'G3DSA:2.30.29.30:FF:000079', NULL, NULL, 'unconventional myosin-VIIa', NULL, NULL, NULL, NULL, NULL, 4),
(121545, NULL, 'G3DSA:2.10.50.10:FF:000011', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 21', NULL, NULL, NULL, NULL, NULL, 4),
(121546, NULL, 'G3DSA:3.80.10.10:FF:004404', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121547, NULL, 'G3DSA:2.60.40.690:FF:000010', NULL, NULL, 'C3 and PZP-like alpha-2-macroglobulin domain-containing protein 8', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(121548, NULL, 'G3DSA:2.40.128.20:FF:000030', NULL, NULL, 'Chloroplastic lipocalin', NULL, NULL, NULL, NULL, NULL, 4),
(121549, NULL, 'G3DSA:1.10.10.10:FF:001814', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(121550, NULL, 'G3DSA:2.10.90.10:FF:000103', NULL, NULL, 'Bone morphogenetic protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(121551, NULL, 'G3DSA:3.80.10.10:FF:000705', NULL, NULL, 'Glucose-repressible alcohol dehydrogenase transcriptional effector', NULL, NULL, NULL, NULL, NULL, 4),
(121552, NULL, 'G3DSA:1.20.900.10:FF:000055', NULL, NULL, 'UNC-112-Interacting Guanine nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(121553, NULL, 'G3DSA:1.20.1070.10:FF:000591', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(121554, NULL, 'G3DSA:2.30.40.10:FF:000015', NULL, NULL, 'Imidazolonepropionase', NULL, NULL, NULL, NULL, NULL, 4),
(121555, NULL, 'G3DSA:3.40.33.10:FF:000041', NULL, NULL, 'GD25808', NULL, NULL, NULL, NULL, NULL, 4),
(121556, NULL, 'G3DSA:3.40.50.300:FF:001751', NULL, NULL, 'ABC bile acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(121557, NULL, 'G3DSA:3.80.10.10:FF:002605', NULL, NULL, 'Leucine rich repeat kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(121558, NULL, 'G3DSA:3.20.20.70:FF:000120', NULL, NULL, 'Pyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(121559, NULL, 'G3DSA:1.20.1250.20:FF:002165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121560, NULL, 'G3DSA:2.40.420.20:FF:000046', NULL, NULL, 'Component of multidrug efflux system', NULL, NULL, NULL, NULL, NULL, 4),
(121561, NULL, 'G3DSA:3.90.190.10:FF:000532', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121562, NULL, 'G3DSA:1.10.3180.10:FF:000006', NULL, NULL, 'Os04g0456900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(121563, NULL, 'G3DSA:2.130.10.10:FF:003824', NULL, NULL, 'Meiotic recombination protein rec14', NULL, NULL, NULL, NULL, NULL, 4),
(121564, NULL, 'G3DSA:1.50.10.20:FF:000063', NULL, NULL, 'Protein farnesyltransferase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(121565, NULL, 'G3DSA:3.80.10.10:FF:004308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121566, NULL, 'G3DSA:2.60.40.10:FF:001267', NULL, NULL, 'Immunoglobulin-like and fibronectin type III domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(121567, NULL, 'G3DSA:3.40.50.620:FF:000773', NULL, NULL, 'Phosphopantetheine adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(121568, NULL, 'G3DSA:2.130.10.10:FF:001907', NULL, NULL, 'Mitotic checkpoint protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121569, NULL, 'G3DSA:1.10.510.10:FF:003169', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121570, NULL, 'G3DSA:1.20.1250.20:FF:001889', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121571, NULL, 'G3DSA:3.40.50.10090:FF:000026', NULL, NULL, 'GG16951', NULL, NULL, NULL, NULL, NULL, 4),
(121572, NULL, 'G3DSA:1.25.40.10:FF:000867', NULL, NULL, 'ETO1-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(121573, NULL, 'G3DSA:3.30.300.30:FF:000078', NULL, NULL, 'Nonribosomal peptide synthetase 7', NULL, NULL, NULL, NULL, NULL, 4),
(121574, NULL, 'G3DSA:3.30.420.10:FF:000244', NULL, NULL, 'Exonuclease mut-7', NULL, NULL, NULL, NULL, NULL, 4),
(121575, NULL, 'G3DSA:1.10.3380.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121576, NULL, 'G3DSA:3.40.50.2000:FF:000821', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121577, NULL, 'G3DSA:3.30.200.20:FF:001321', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121578, NULL, 'G3DSA:4.10.1070.10:FF:000001', NULL, NULL, 'Short tail fiber protein gp12', NULL, NULL, NULL, NULL, NULL, 4),
(121579, NULL, 'G3DSA:1.10.555.10:FF:000153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121580, NULL, 'G3DSA:2.130.10.10:FF:004100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121581, NULL, 'G3DSA:1.20.58.390:FF:000041', NULL, NULL, 'Neuronal acetylcholine receptor subunit alpha-5', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(121582, NULL, 'G3DSA:1.25.10.10:FF:001641', NULL, NULL, 'Synembryn-A', NULL, NULL, NULL, NULL, NULL, 4),
(121583, NULL, 'G3DSA:1.10.20.140:FF:000014', NULL, NULL, 'tRNA dimethylallyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(121584, NULL, 'G3DSA:2.130.10.10:FF:004797', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121585, NULL, 'G3DSA:3.40.50.300:FF:006989', NULL, NULL, 'ATP-binding cassette transporter, subfamily G, member 6, group WBC protein PpABCG6', NULL, NULL, NULL, NULL, NULL, 4),
(121586, NULL, 'G3DSA:3.40.50.2300:FF:000349', NULL, NULL, 'PTS fructose transporter subunit IIB', NULL, NULL, NULL, NULL, NULL, 4),
(121587, NULL, 'G3DSA:2.60.40.10:FF:002110', NULL, NULL, 'Calmodulin-binding transcription activator 4', NULL, NULL, NULL, NULL, NULL, 4),
(121588, NULL, 'G3DSA:2.60.40.1180:FF:000020', NULL, NULL, 'Pancreatic alpha-amylase', NULL, NULL, NULL, NULL, NULL, 4),
(121589, NULL, 'G3DSA:3.30.1490.20:FF:000071', NULL, NULL, 'Succinyl-CoA synthetase beta subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121590, NULL, 'G3DSA:3.30.40.10:FF:001007', NULL, NULL, 'Zinc finger domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(121591, NULL, 'G3DSA:3.40.50.1910:FF:000007', NULL, NULL, 'syntaxin-binding protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(121592, NULL, 'G3DSA:1.20.1270.60:FF:000233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121593, NULL, 'G3DSA:1.25.40.280:FF:000016', NULL, NULL, 'pH-response regulator protein palA/RIM20', NULL, NULL, NULL, NULL, NULL, 4),
(121594, NULL, 'G3DSA:3.30.40.10:FF:002289', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(121595, NULL, 'G3DSA:1.20.1160.20:FF:000016', NULL, NULL, 'Regulator of telomere elongation helicase 1', NULL, NULL, NULL, NULL, NULL, 4),
(121596, NULL, 'G3DSA:1.20.990.10:FF:000015', NULL, NULL, 'NADPH-dependent diflavin oxidoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(121597, NULL, 'G3DSA:2.60.120.650:FF:000148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121598, NULL, 'G3DSA:1.20.5.110:FF:000020', NULL, NULL, 'synaptobrevin homolog YKT6', NULL, NULL, NULL, NULL, NULL, 4),
(121599, NULL, 'G3DSA:2.60.40.10:FF:003728', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121600, NULL, 'G3DSA:2.60.40.10:FF:004010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121601, NULL, 'G3DSA:2.60.40.10:FF:005421', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121602, NULL, 'G3DSA:3.30.1520.10:FF:000178', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(121603, NULL, 'G3DSA:3.60.20.10:FF:000140', NULL, NULL, 'Proteasome endopeptidase complex', NULL, NULL, NULL, NULL, NULL, 4),
(121604, NULL, 'G3DSA:2.60.40.10:FF:001834', NULL, NULL, 'Blast:Twitchin', NULL, NULL, NULL, NULL, NULL, 4),
(121605, NULL, 'G3DSA:3.60.40.10:FF:000017', NULL, NULL, 'phosphatase 1L isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(121606, NULL, 'G3DSA:1.20.1740.10:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121607, NULL, 'G3DSA:1.20.1250.20:FF:000580', NULL, NULL, 'Unplaced genomic scaffold supercont2.27, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(121608, NULL, 'G3DSA:1.10.238.10:FF:001119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121609, NULL, 'G3DSA:3.50.50.60:FF:000718', NULL, NULL, 'Probable oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(121610, NULL, 'G3DSA:1.20.5.110:FF:000227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121611, NULL, 'G3DSA:3.90.190.10:FF:000302', NULL, NULL, 'Tyrosine specific protein phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(121612, NULL, 'G3DSA:1.20.58.60:FF:000197', NULL, NULL, 'Alpha spectrin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(121613, NULL, 'G3DSA:1.10.287.380:FF:000028', NULL, NULL, 'Valine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(121614, NULL, 'G3DSA:3.40.50.300:FF:003342', NULL, NULL, 'DNA polymerase III subunit gamma/tau', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(121615, NULL, 'G3DSA:3.40.30.10:FF:000360', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(121616, NULL, 'G3DSA:1.20.1610.10:FF:000003', NULL, NULL, 'Glycoside hydrolase family 92 protein', NULL, NULL, NULL, NULL, NULL, 4),
(121617, NULL, 'G3DSA:3.40.50.300:FF:005236', NULL, NULL, 'Slr1428 protein', NULL, NULL, NULL, NULL, NULL, 4),
(121618, NULL, 'G3DSA:1.50.40.10:FF:000123', NULL, NULL, 'Solute carrier family 25 (Mitochondrial S-adenosylmethionine transporter), member 26', NULL, NULL, NULL, NULL, NULL, 4),
(121619, NULL, 'G3DSA:2.60.40.10:FF:003521', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121620, NULL, 'G3DSA:1.25.10.70:FF:000012', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(121621, NULL, 'G3DSA:3.40.50.970:FF:000176', NULL, NULL, 'Pyruvate dehydrogenase E1 component alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121622, NULL, 'G3DSA:4.10.1240.10:FF:000031', NULL, NULL, 'Growth hormone-releasing hormone receptor a', NULL, NULL, NULL, NULL, NULL, 4),
(121623, NULL, 'G3DSA:3.30.40.10:FF:000518', NULL, NULL, 'Ubiquitin conjugation factor E4 A', NULL, NULL, NULL, NULL, NULL, 4),
(121624, NULL, 'G3DSA:2.30.29.30:FF:000534', NULL, NULL, 'TBC1 (tre-2/USP6, BUB2, cdc16) domain family, member 1', NULL, NULL, NULL, NULL, NULL, 4),
(121625, NULL, 'G3DSA:3.30.450.20:FF:000187', NULL, NULL, 'Hypoxia-inducible factor 1-alpha', NULL, NULL, NULL, NULL, NULL, 4),
(121626, NULL, 'G3DSA:1.10.287.370:FF:000025', NULL, NULL, 'Prefoldin subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(121627, NULL, 'G3DSA:3.40.50.300:FF:007265', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(121628, NULL, 'G3DSA:2.30.42.10:FF:000177', NULL, NULL, 'delphilin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(121629, NULL, 'G3DSA:1.10.10.10:FF:000758', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(121630, NULL, 'G3DSA:3.60.10.10:FF:000419', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121631, NULL, 'G3DSA:2.40.50.140:FF:000268', NULL, NULL, 'Mitochondrial ribosomal protein S17', NULL, NULL, NULL, NULL, NULL, 4),
(121632, NULL, 'G3DSA:1.25.40.10:FF:002992', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(121633, NULL, 'G3DSA:1.10.357.50:FF:000019', NULL, NULL, 'Exocyst complex component 3', NULL, NULL, NULL, NULL, NULL, 4),
(121634, NULL, 'G3DSA:1.25.40.20:FF:000302', NULL, NULL, 'Ankyrin repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(121635, NULL, 'G3DSA:3.90.70.80:FF:000038', NULL, NULL, 'OTU domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(121636, NULL, 'G3DSA:3.30.70.1230:FF:000070', NULL, NULL, 'Probable lignin peroxidase lipJ', NULL, NULL, NULL, NULL, NULL, 4),
(121637, NULL, 'G3DSA:3.40.1110.10:FF:000420', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121638, NULL, 'G3DSA:3.50.50.60:FF:001207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121639, NULL, 'G3DSA:1.25.10.10:FF:001315', NULL, NULL, 'Raptor_N-terminal_CASPase_like_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(121640, NULL, 'G3DSA:3.30.590.50:FF:000009', NULL, NULL, 'Glutamate--cysteine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(121641, NULL, 'G3DSA:3.40.1380.20:FF:000015', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(121642, NULL, 'G3DSA:1.25.40.10:FF:002896', NULL, NULL, 'Pre-mRNA-splicing factor SYF1', NULL, NULL, NULL, NULL, NULL, 4),
(121643, NULL, 'G3DSA:1.25.40.10:FF:001710', NULL, NULL, 'Os01g0977400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(121644, NULL, 'G3DSA:1.10.357.20:FF:000010', NULL, NULL, 'Solute carrier family 41 (magnesium transporter), member 2a', NULL, NULL, NULL, NULL, NULL, 4),
(121645, NULL, 'G3DSA:3.40.1190.20:FF:000074', NULL, NULL, '6-phosphofructokinase pfkb (Phosphohexokinase) (Phosphofructokinase)', NULL, NULL, NULL, NULL, NULL, 4),
(121646, NULL, 'G3DSA:3.30.1390.30:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(121647, NULL, 'G3DSA:1.10.1040.50:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121648, NULL, 'G3DSA:3.30.70.330:FF:001103', NULL, NULL, 'Putative RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(121649, NULL, 'G3DSA:3.40.50.1820:FF:000862', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(121650, NULL, 'G3DSA:3.40.50.1700:FF:000051', NULL, NULL, 'Beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(121651, NULL, 'G3DSA:3.40.50.720:FF:000247', NULL, NULL, 'NADPH-dependent 2,4-dienoyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(121652, NULL, 'G3DSA:1.25.40.20:FF:001713', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121653, NULL, 'G3DSA:1.10.357.30:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121654, NULL, 'G3DSA:3.40.718.10:FF:000063', NULL, NULL, 'Isocitrate/isopropylmalate dehydrogenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(121655, NULL, 'G3DSA:3.40.50.150:FF:001571', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121656, NULL, 'G3DSA:1.10.520.10:FF:000011', NULL, NULL, 'L-ascorbate peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(121657, NULL, 'G3DSA:1.10.510.10:FF:001371', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121658, NULL, 'G3DSA:3.40.50.300:FF:003549', NULL, NULL, 'ABC transporter family-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(121659, NULL, 'G3DSA:3.40.50.300:FF:001088', NULL, NULL, 'uncharacterized protein ycf45 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(121660, NULL, 'G3DSA:1.10.510.10:FF:003523', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121661, NULL, 'G3DSA:3.90.360.10:FF:000006', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(121662, NULL, 'G3DSA:1.10.10.10:FF:001247', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(121663, NULL, 'G3DSA:1.25.40.10:FF:003172', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(121664, NULL, 'G3DSA:3.40.50.740:FF:000011', NULL, NULL, 'Molybdopterin oxidoreductase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(121665, NULL, 'G3DSA:3.30.710.10:FF:000345', NULL, NULL, 'BTB/POZ domain-containing protein 9-like', NULL, NULL, NULL, NULL, NULL, 4),
(121666, NULL, 'G3DSA:3.20.20.140:FF:000431', NULL, NULL, 'Multidrug resistance protein B', NULL, NULL, NULL, NULL, NULL, 4),
(121667, NULL, 'G3DSA:3.30.200.20:FF:000478', NULL, NULL, 'Serine/threonine-protein kinase N2', NULL, NULL, NULL, NULL, NULL, 4),
(121668, NULL, 'G3DSA:2.60.220.50:FF:000070', NULL, NULL, 'Flamingo 1b', NULL, NULL, NULL, NULL, NULL, 4),
(121669, NULL, 'G3DSA:3.80.10.10:FF:001993', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(121670, NULL, 'G3DSA:3.30.160.60:FF:001930', NULL, NULL, 'Zinc finger protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(121671, NULL, 'G3DSA:1.10.510.10:FF:004012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121672, NULL, 'G3DSA:2.130.10.10:FF:001357', NULL, NULL, 'WD repeat-containing protein 26 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(121673, NULL, 'G3DSA:2.60.40.10:FF:005078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121674, NULL, 'G3DSA:3.90.660.10:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121675, NULL, 'G3DSA:3.40.50.720:FF:000808', NULL, NULL, 'Iridoid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(121676, NULL, 'G3DSA:1.10.630.10:FF:000356', NULL, NULL, 'Cytochrome P450 4F12', NULL, NULL, NULL, NULL, NULL, 4),
(121677, NULL, 'G3DSA:2.60.120.260:FF:000576', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121678, NULL, 'G3DSA:1.10.10.1940:FF:000001', NULL, NULL, 'Matrix metallopeptidase 23B', NULL, NULL, NULL, NULL, NULL, 4),
(121679, NULL, 'G3DSA:2.30.110.10:FF:000011', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(121680, NULL, 'G3DSA:3.30.160.60:FF:001363', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(121681, NULL, 'G3DSA:3.30.200.20:FF:001534', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(121682, NULL, 'G3DSA:3.30.40.10:FF:001221', NULL, NULL, 'Putative e3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(121683, NULL, 'G3DSA:3.30.70.250:FF:000011', NULL, NULL, 'Related to Malonyl CoA-acyl carrier protein transacylase', NULL, NULL, NULL, NULL, NULL, 4),
(121684, NULL, 'G3DSA:3.40.50.360:FF:000105', NULL, NULL, 'Homolog to NAD(P)H dehydrogenase (Quinone)', NULL, NULL, NULL, NULL, NULL, 4),
(121685, NULL, 'G3DSA:1.10.1080.10:FF:000026', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(121686, NULL, 'G3DSA:2.60.120.200:FF:000709', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121687, NULL, 'G3DSA:1.10.150.20:FF:000328', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121688, NULL, 'G3DSA:3.40.50.1220:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121689, NULL, 'G3DSA:3.40.50.620:FF:000655', NULL, NULL, 'Valyl Amino-acyl tRNA Synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(121690, NULL, 'G3DSA:3.30.200.20:FF:000927', NULL, NULL, 'Cyclin-dependent kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(121691, NULL, 'G3DSA:3.50.30.30:FF:000034', NULL, NULL, 'Probable glutamate carboxypeptidase VP8', NULL, NULL, NULL, NULL, NULL, 4),
(121692, NULL, 'G3DSA:3.40.50.2300:FF:000580', NULL, NULL, 'TMAO reductase system periplasmic protein TorT', NULL, NULL, NULL, NULL, NULL, 4),
(121693, NULL, 'G3DSA:1.20.1250.20:FF:000254', NULL, NULL, 'MAL31p Maltose permease', NULL, NULL, NULL, NULL, NULL, 4),
(121694, NULL, 'G3DSA:1.10.10.750:FF:000037', NULL, NULL, 'Plant adhesion molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(121695, NULL, 'G3DSA:1.20.5.170:FF:000009', NULL, NULL, 'probable transcription factor PosF21', NULL, NULL, NULL, NULL, NULL, 4),
(121696, NULL, 'G3DSA:2.170.16.10:FF:000003', NULL, NULL, 'Homothallism endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(121697, NULL, 'G3DSA:3.40.50.2000:FF:000692', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(121698, NULL, 'G3DSA:3.30.70.330:FF:001092', NULL, NULL, 'serine/arginine-rich splicing factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(121699, NULL, 'G3DSA:3.40.50.300:FF:005028', NULL, NULL, 'Gluconokinase', NULL, NULL, NULL, NULL, NULL, 4),
(121700, NULL, 'G3DSA:2.130.10.10:FF:002886', NULL, NULL, 'U3 small nucleolar RNA-associated protein 15 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(121701, NULL, 'G3DSA:3.30.160.60:FF:004010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121702, NULL, 'G3DSA:3.30.420.10:FF:000126', NULL, NULL, '3''-5'' exonuclease domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(121703, NULL, 'G3DSA:3.10.50.10:FF:000059', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(121704, NULL, 'G3DSA:1.10.510.10:FF:001932', NULL, NULL, 'Protein CBG11137', NULL, NULL, NULL, NULL, NULL, 4),
(121705, NULL, 'G3DSA:1.10.1200.120:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121706, NULL, 'G3DSA:3.30.260.10:FF:000029', NULL, NULL, 'Chaperonin containing TCP1 subunit 6B', NULL, NULL, NULL, NULL, NULL, 4),
(121707, NULL, 'G3DSA:1.25.40.10:FF:001581', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(121708, NULL, 'G3DSA:2.40.50.450:FF:000001', NULL, NULL, 'Fe(3+) ions import ATP-binding protein FbpC', NULL, NULL, NULL, NULL, NULL, 4),
(121709, NULL, 'G3DSA:1.20.1560.10:FF:000802', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121710, NULL, 'G3DSA:1.20.1320.30:FF:000004', NULL, NULL, 'Retinoic acid inducible protein I transcript variant 2', NULL, NULL, NULL, NULL, NULL, 4),
(121711, NULL, 'G3DSA:2.60.120.10:FF:000151', NULL, NULL, 'Cupin domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(121712, NULL, 'G3DSA:2.60.470.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(121713, NULL, 'G3DSA:3.60.130.10:FF:000007', NULL, NULL, 'Alpha-ketoglutarate-dependent taurine dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(121714, NULL, 'G3DSA:3.20.20.80:FF:000241', NULL, NULL, 'Glycoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(121715, NULL, 'G3DSA:3.10.260.10:FF:000005', NULL, NULL, 'Transcriptional repressor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121716, NULL, 'G3DSA:1.25.40.20:FF:001584', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(121717, NULL, 'G3DSA:1.20.1320.20:FF:000001', NULL, NULL, 'Fanconi anemia, complementation group M', NULL, NULL, NULL, NULL, NULL, 4),
(121718, NULL, 'G3DSA:2.60.40.150:FF:000686', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(121719, NULL, 'G3DSA:3.50.50.60:FF:000483', NULL, NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(121720, NULL, 'G3DSA:3.40.850.10:FF:000347', NULL, NULL, 'Centromere protein E', NULL, NULL, NULL, NULL, NULL, 4),
(121721, NULL, 'G3DSA:1.10.287.130:FF:000212', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(121722, NULL, 'G3DSA:1.10.1060.10:FF:000031', NULL, NULL, 'Formate dehydrogenase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(121723, NULL, 'G3DSA:3.90.1260.10:FF:000003', NULL, NULL, 'Argininosuccinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(121724, NULL, 'G3DSA:3.40.50.300:FF:001649', NULL, NULL, 'DNA repair protein RAD50', NULL, NULL, NULL, NULL, NULL, 4),
(121725, NULL, 'G3DSA:3.40.50.2000:FF:000579', NULL, NULL, 'Glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(121726, NULL, 'G3DSA:3.30.420.40:FF:001068', NULL, NULL, 'Hsp70', NULL, NULL, NULL, NULL, NULL, 4),
(121727, NULL, 'G3DSA:2.130.10.10:FF:005741', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121728, NULL, 'G3DSA:3.90.190.10:FF:000077', NULL, NULL, 'Myotubularin related protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(121729, NULL, 'G3DSA:3.40.1800.20:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121730, NULL, 'G3DSA:1.20.120.1630:FF:000015', NULL, NULL, '3-oxo-5-alpha-steroid 4-dehydrogenase (DUF1295)', NULL, NULL, NULL, NULL, NULL, 4),
(121731, NULL, 'G3DSA:2.10.25.10:FF:000610', NULL, NULL, 'protein HEG homolog 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(121732, NULL, 'G3DSA:2.40.50.140:FF:001206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121733, NULL, 'G3DSA:3.40.50.150:FF:001458', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121734, NULL, 'G3DSA:2.30.130.110:FF:000006', NULL, NULL, 'Altronate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(121735, NULL, 'G3DSA:3.30.1370.10:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121736, NULL, 'G3DSA:1.20.1250.20:FF:001985', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121737, NULL, 'G3DSA:1.10.287.70:FF:000345', NULL, NULL, 'GM20581', NULL, NULL, NULL, NULL, NULL, 4),
(121738, NULL, 'G3DSA:3.30.160.60:FF:003066', NULL, NULL, 'GH13825', NULL, NULL, NULL, NULL, NULL, 4),
(121739, NULL, 'G3DSA:2.30.30.100:FF:000226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121740, NULL, 'G3DSA:3.30.70.1730:FF:000012', NULL, NULL, 'Mitochondrial Ribosomal Protein, Large', NULL, NULL, NULL, NULL, NULL, 4),
(121741, NULL, 'G3DSA:3.30.1390.30:FF:000004', NULL, NULL, 'Penicillin-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(121742, NULL, 'G3DSA:1.25.40.10:FF:004818', NULL, NULL, 'Tetratricopeptide repeat domain 21B', NULL, NULL, NULL, NULL, NULL, 4),
(121743, NULL, 'G3DSA:3.30.160.60:FF:005527', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121744, NULL, 'G3DSA:3.30.160.60:FF:003493', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121745, NULL, 'G3DSA:3.60.60.10:FF:000018', NULL, NULL, 'Slr1772 protein', NULL, NULL, NULL, NULL, NULL, 4),
(121746, NULL, 'G3DSA:2.30.130.10:FF:000006', NULL, NULL, 'putative methyltransferase NSUN6 isoform X2', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(121747, NULL, 'G3DSA:3.30.70.330:FF:002188', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121748, NULL, 'G3DSA:1.20.58.60:FF:000079', NULL, NULL, 'Spectrin alpha chain, non-erythrocytic 1', NULL, NULL, NULL, NULL, NULL, 4),
(121749, NULL, 'G3DSA:3.30.160.60:FF:005207', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121750, NULL, 'G3DSA:4.10.280.50:FF:000003', NULL, NULL, 'Glutamate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(121751, NULL, 'G3DSA:3.30.40.10:FF:002317', NULL, NULL, 'zinc finger protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(121752, NULL, 'G3DSA:3.30.70.260:FF:000014', NULL, NULL, 'Methionine import ATP-binding protein MetN', NULL, NULL, NULL, NULL, NULL, 4),
(121753, NULL, 'G3DSA:1.10.10.350:FF:000013', NULL, NULL, 'Glutamine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(121754, NULL, 'G3DSA:2.60.490.10:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121755, NULL, 'G3DSA:3.40.50.1000:FF:000858', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121756, NULL, 'G3DSA:3.40.50.2300:FF:000675', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121757, NULL, 'G3DSA:1.25.40.10:FF:002784', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121758, NULL, 'G3DSA:3.40.50.620:FF:000560', NULL, NULL, 'Probable nicotinate-nucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(121759, NULL, 'G3DSA:2.60.40.10:FF:002919', NULL, NULL, 'Interleukin 10 receptor, beta', NULL, NULL, NULL, NULL, NULL, 4),
(121760, NULL, 'G3DSA:3.30.40.10:FF:001120', NULL, NULL, 'Chromatin modification-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(121761, NULL, 'G3DSA:1.20.1250.20:FF:002378', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(121762, NULL, 'G3DSA:2.40.50.140:FF:001111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121763, NULL, 'G3DSA:3.30.710.10:FF:000457', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121764, NULL, 'G3DSA:1.10.1400.10:FF:000001', NULL, NULL, 'Acyl-homoserine lactone acylase QuiP', NULL, NULL, NULL, NULL, NULL, 4),
(121765, NULL, 'G3DSA:2.130.10.30:FF:000172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121766, NULL, 'G3DSA:3.20.80.10:FF:000010', NULL, NULL, 'SOUL heme-binding family protein', NULL, NULL, NULL, NULL, NULL, 4),
(121767, NULL, 'G3DSA:3.40.50.300:FF:003903', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121768, NULL, 'G3DSA:3.40.50.300:FF:007602', NULL, NULL, 'DEAD-box ATP-dependent RNA helicase rde-12', NULL, NULL, NULL, NULL, NULL, 4),
(121769, NULL, 'G3DSA:3.30.930.10:FF:000210', NULL, NULL, 'Mitochondrial lysyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121770, NULL, 'G3DSA:1.20.1070.10:FF:000826', NULL, NULL, 'Cannabinoid receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(121771, NULL, 'G3DSA:2.20.70.10:FF:000158', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(121772, NULL, 'G3DSA:1.10.3730.20:FF:000001', NULL, NULL, 'Quaternary ammonium compound resistance transporter SugE', NULL, NULL, NULL, NULL, NULL, 4),
(121773, NULL, 'G3DSA:2.130.10.10:FF:003611', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121774, NULL, 'G3DSA:1.10.510.10:FF:001718', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(121775, NULL, 'G3DSA:1.25.40.950:FF:000003', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(121776, NULL, 'G3DSA:1.10.150.50:FF:000073', NULL, NULL, 'Gemini, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(121777, NULL, 'G3DSA:2.130.10.10:FF:005062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121778, NULL, 'G3DSA:1.20.58.100:FF:000011', NULL, NULL, 'Fumarate reductase flavoprotein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(121779, NULL, 'G3DSA:2.120.10.30:FF:000369', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(121780, NULL, 'G3DSA:1.10.357.90:FF:000003', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(121781, NULL, 'G3DSA:3.40.50.300:FF:007271', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121782, NULL, 'G3DSA:3.20.20.70:FF:000007', NULL, NULL, 'Chromosome 19 SCAF14664, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(121783, NULL, 'G3DSA:3.40.50.720:FF:002164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121784, NULL, 'G3DSA:3.20.20.60:FF:000004', NULL, NULL, '5-keto-4-deoxy-D-glucarate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(121785, NULL, 'G3DSA:3.40.1410.10:FF:000027', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(121786, NULL, 'G3DSA:1.25.40.420:FF:000070', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(121787, NULL, 'G3DSA:3.30.559.10:FF:000228', NULL, NULL, 'Hydroxamate-type ferrichrome siderophore peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(121788, NULL, 'G3DSA:3.80.10.10:FF:002156', NULL, NULL, 'F-box protein At5g51370', NULL, NULL, NULL, NULL, NULL, 4),
(121789, NULL, 'G3DSA:2.60.40.10:FF:001604', NULL, NULL, 'Down syndrome cell adhesion molecule 3, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(121790, NULL, 'G3DSA:3.40.720.10:FF:000006', NULL, NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(121791, NULL, 'G3DSA:3.10.450.40:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121792, NULL, 'G3DSA:3.40.50.2000:FF:000478', NULL, NULL, 'UDP-glycosyltransferase 88F4', NULL, NULL, NULL, NULL, NULL, 4),
(121793, NULL, 'G3DSA:1.20.1070.10:FF:001996', NULL, NULL, 'Zgc:123156 protein', NULL, NULL, NULL, NULL, NULL, 4),
(121794, NULL, 'G3DSA:2.30.30.380:FF:000023', NULL, NULL, 'Vesicle coat component', NULL, NULL, NULL, NULL, NULL, 4),
(121795, NULL, 'G3DSA:3.30.40.10:FF:000283', NULL, NULL, '1-phosphatidylinositol-3-phosphate 5-kinase (Fab1)', NULL, NULL, NULL, NULL, NULL, 4),
(121796, NULL, 'G3DSA:2.10.25.10:FF:000705', NULL, NULL, 'Notch 2', NULL, NULL, NULL, NULL, NULL, 4),
(121797, NULL, 'G3DSA:2.60.40.10:FF:003280', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121798, NULL, 'G3DSA:3.30.559.10:FF:000116', NULL, NULL, 'Putative diacyglycerol O-acyltransferase Rv2484c', NULL, NULL, NULL, NULL, NULL, 4),
(121799, NULL, 'G3DSA:3.30.40.10:FF:000395', NULL, NULL, 'Putative Peroxisome biosynthesis protein (Peroxin-10)', NULL, NULL, NULL, NULL, NULL, 4),
(121800, NULL, 'G3DSA:3.10.20.770:FF:000009', NULL, NULL, 'Phosphatidylinositol 3-kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121801, NULL, 'G3DSA:3.90.1150.10:FF:000456', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(121802, NULL, 'G3DSA:1.20.1740.10:FF:000215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121803, NULL, 'G3DSA:1.10.600.10:FF:000080', NULL, NULL, 'Isoprenoid synthase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(121804, NULL, 'G3DSA:2.60.40.10:FF:001722', NULL, NULL, 'Sidekick, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(121805, NULL, 'G3DSA:2.30.30.230:FF:000006', NULL, NULL, 'Fumarylacetoacetase', NULL, NULL, NULL, NULL, NULL, 4),
(121806, NULL, 'G3DSA:3.40.50.300:FF:005348', NULL, NULL, 'AGAP002836-PA', NULL, NULL, NULL, NULL, NULL, 4),
(121807, NULL, 'G3DSA:1.10.260.40:FF:000090', NULL, NULL, '2-hydroxyethylphosphonate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(121808, NULL, 'G3DSA:2.60.120.1020:FF:000006', NULL, NULL, 'Peptide-N(4)-(N-acetyl-beta-glucosaminyl)asparagine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(121809, NULL, 'G3DSA:2.40.290.10:FF:000010', NULL, NULL, 'X-ray repair cross-complementing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(121810, NULL, 'G3DSA:1.10.510.10:FF:001612', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(121811, NULL, 'G3DSA:2.20.110.10:FF:000069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121812, NULL, 'G3DSA:2.60.40.10:FF:003633', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121813, NULL, 'G3DSA:1.25.40.10:FF:003722', NULL, NULL, 'Os06g0228900 protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(121814, NULL, 'G3DSA:1.25.40.10:FF:003621', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121815, NULL, 'G3DSA:3.80.10.10:FF:004185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121816, NULL, 'G3DSA:3.20.20.80:FF:000561', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121817, NULL, 'G3DSA:3.40.50.620:FF:000447', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(121818, NULL, 'G3DSA:3.30.70.260:FF:000109', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(121819, NULL, 'G3DSA:3.30.200.20:FF:000719', NULL, NULL, 'CMGC/GSK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(121820, NULL, 'G3DSA:1.25.40.660:FF:000023', NULL, NULL, 'Vacuolar protein sorting 35, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121821, NULL, 'G3DSA:3.30.70.330:FF:003014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121822, NULL, 'G3DSA:1.25.40.20:FF:001264', NULL, NULL, 'Ankyrin repeat and SOCS box-containing 12', NULL, NULL, NULL, NULL, NULL, 4),
(121823, NULL, 'G3DSA:1.10.472.100:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121824, NULL, 'G3DSA:1.10.8.10:FF:000190', NULL, NULL, 'Vacuolar protein sorting 13 homolog D', NULL, NULL, NULL, NULL, NULL, 4),
(121825, NULL, 'G3DSA:1.25.40.10:FF:001261', NULL, NULL, 'Protein NASP homolog', NULL, NULL, NULL, NULL, NULL, 4),
(121826, NULL, 'G3DSA:3.40.50.12780:FF:000086', NULL, NULL, 'O-succinylbenzoic acid--CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(121827, NULL, 'G3DSA:1.25.10.10:FF:002956', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121828, NULL, 'G3DSA:3.40.250.10:FF:000245', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(121829, NULL, 'G3DSA:1.25.40.510:FF:000006', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(121830, NULL, 'G3DSA:1.20.1720.10:FF:000107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121831, NULL, 'G3DSA:3.40.50.300:FF:005680', NULL, NULL, 'Dynein-1-beta heavy chain, flagellar inner arm I1 complex', NULL, NULL, NULL, NULL, NULL, 4),
(121832, NULL, 'G3DSA:1.20.58.60:FF:000764', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(121833, NULL, 'G3DSA:1.10.287.950:FF:000002', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(121834, NULL, 'G3DSA:3.10.580.10:FF:000153', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(121835, NULL, 'G3DSA:4.10.80.300:FF:000001', NULL, NULL, 'H/ACA ribonucleoprotein complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(121836, NULL, 'G3DSA:2.20.110.10:FF:000070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121837, NULL, 'G3DSA:3.40.50.360:FF:000004', NULL, NULL, 'NAD(P)H dehydrogenase (quinone)', NULL, NULL, NULL, NULL, NULL, 4),
(121838, NULL, 'G3DSA:1.10.4050.10:FF:000002', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(121839, NULL, 'G3DSA:3.40.1110.10:FF:000083', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(121840, NULL, 'G3DSA:3.30.230.70:FF:000079', NULL, NULL, 'Exosome non-catalytic core subunit', NULL, NULL, NULL, NULL, NULL, 4),
(121841, NULL, 'G3DSA:3.40.50.300:FF:007366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121842, NULL, 'G3DSA:1.10.101.10:FF:000009', NULL, NULL, 'Peptidoglycan hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(121843, NULL, 'G3DSA:2.170.130.10:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121844, NULL, 'G3DSA:3.30.70.2840:FF:000002', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(121845, NULL, 'G3DSA:3.80.10.10:FF:000817', NULL, NULL, 'P53-induced death domain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(121846, NULL, 'G3DSA:3.40.850.10:FF:000561', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(121847, NULL, 'G3DSA:1.10.8.10:FF:000201', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 28', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(121848, NULL, 'G3DSA:3.10.450.700:FF:000012', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(121849, NULL, 'G3DSA:1.10.1220.10:FF:000015', NULL, NULL, 'Antitoxin VapB2', NULL, NULL, NULL, NULL, NULL, 4),
(121850, NULL, 'G3DSA:3.30.160.60:FF:005415', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121851, NULL, 'G3DSA:1.10.10.10:FF:001702', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(121852, NULL, 'G3DSA:1.20.120.1080:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121853, NULL, 'G3DSA:3.10.129.10:FF:000066', NULL, NULL, 'Acyl-acyl carrier protein thioesterase ATL3 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(121854, NULL, 'G3DSA:3.30.450.20:FF:000636', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121855, NULL, 'G3DSA:1.10.720.30:FF:000015', NULL, NULL, '3''-5'' exoribonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(121856, NULL, 'G3DSA:1.20.1510.10:FF:000069', NULL, NULL, 'Zinc transporter 33D, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(121857, NULL, 'G3DSA:3.90.380.10:FF:000002', NULL, NULL, 'Carnitine monooxygenase oxygenase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(121858, NULL, 'G3DSA:2.130.10.10:FF:003723', NULL, NULL, 'Uncharacterized protein C18E5.01', NULL, NULL, NULL, NULL, NULL, 4),
(121859, NULL, 'G3DSA:1.10.40.30:FF:000013', NULL, NULL, 'Adenylosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(121860, NULL, 'G3DSA:2.130.10.10:FF:005409', NULL, NULL, 'Poly(A) specific ribonuclease subunit PAN2', NULL, NULL, NULL, NULL, NULL, 4),
(121861, NULL, 'G3DSA:2.30.29.30:FF:001040', NULL, NULL, 'ArfGAP with GTPase domain, ankyrin repeat and PH domain 2', NULL, NULL, NULL, NULL, NULL, 4),
(121862, NULL, 'G3DSA:3.30.720.150:FF:000005', NULL, NULL, 'UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase 110 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(121863, NULL, 'G3DSA:2.60.450.10:FF:000018', NULL, NULL, 'LPS ABC transporter periplasmic component', NULL, NULL, NULL, NULL, NULL, 4),
(121864, NULL, 'G3DSA:3.30.160.60:FF:006022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121865, NULL, 'G3DSA:1.10.150.120:FF:000002', NULL, NULL, 'xanthine dehydrogenase/oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(121866, NULL, 'G3DSA:1.10.287.70:FF:000553', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(121867, NULL, 'G3DSA:3.30.70.330:FF:000838', NULL, NULL, 'Gbp2p', NULL, NULL, NULL, NULL, NULL, 4),
(121868, NULL, 'G3DSA:3.30.1480.10:FF:000005', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(121869, NULL, 'G3DSA:2.60.120.290:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121870, NULL, 'G3DSA:3.40.33.10:FF:000153', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(121871, NULL, 'G3DSA:2.60.120.920:FF:000010', NULL, NULL, 'E3 ubiquitin-protein ligase Midline-1', NULL, NULL, NULL, NULL, NULL, 4),
(121872, NULL, 'G3DSA:4.10.400.10:FF:000131', NULL, NULL, 'Low-density lipoprotein receptor-related protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(121873, NULL, 'G3DSA:2.130.10.10:FF:001571', NULL, NULL, 'WGS project CABT00000000 data, contig 2.25', NULL, NULL, NULL, NULL, NULL, 4),
(121874, NULL, 'G3DSA:3.30.160.20:FF:000210', NULL, NULL, 'Double-stranded RNA-binding protein Staufen homolog', NULL, NULL, NULL, NULL, NULL, 4),
(121875, NULL, 'G3DSA:3.40.250.10:FF:000150', NULL, NULL, 'Adenylyltransferase and sulfurtransferase MOCS3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(121876, NULL, 'G3DSA:3.40.50.2300:FF:000787', NULL, NULL, 'Periplasmic binding abc transporter protein', NULL, NULL, NULL, NULL, NULL, 4),
(121877, NULL, 'G3DSA:1.10.630.10:FF:000570', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121878, NULL, 'G3DSA:3.30.70.2850:FF:000005', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(121879, NULL, 'G3DSA:1.20.1250.20:FF:000349', NULL, NULL, 'Major facilitator superfamily domain-containing 12a', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(121880, NULL, 'G3DSA:1.25.40.10:FF:005313', NULL, NULL, 'Eukaryotic elongation factor 2 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(121881, NULL, 'G3DSA:1.20.5.170:FF:000122', NULL, NULL, 'Oncoprotein MEQ', NULL, NULL, NULL, NULL, NULL, 4),
(121882, NULL, 'G3DSA:1.10.12.10:FF:000015', NULL, NULL, 'Enoyl-CoA hydratase/isomerase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(121883, NULL, 'G3DSA:2.60.40.1730:FF:000016', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(121884, NULL, 'G3DSA:3.40.50.1220:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121885, NULL, 'G3DSA:2.40.50.140:FF:000723', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121886, NULL, 'G3DSA:1.10.287.10:FF:000013', NULL, NULL, 'Glutamyl(E) Amino-acyl tRNA Synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(121887, NULL, 'G3DSA:1.25.10.10:FF:001753', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121888, NULL, 'G3DSA:3.40.30.10:FF:000130', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(121889, NULL, 'G3DSA:3.40.1180.10:FF:000031', NULL, NULL, 'Cis-prenyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121890, NULL, 'G3DSA:3.40.50.720:FF:002484', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121891, NULL, 'G3DSA:2.40.50.40:FF:000081', NULL, NULL, 'Chromatin-associated protein swi6', NULL, NULL, NULL, NULL, NULL, 4),
(121892, NULL, 'G3DSA:3.40.50.720:FF:000926', NULL, NULL, 'Short-chain dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(121893, NULL, 'G3DSA:1.20.120.1080:FF:000030', NULL, NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase PRP2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121894, NULL, 'G3DSA:1.10.10.200:FF:000007', NULL, NULL, 'Probable transcriptional regulatory protein AC801_15750', NULL, NULL, NULL, NULL, NULL, 4),
(121895, NULL, 'G3DSA:1.10.150.670:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121896, NULL, 'G3DSA:3.80.10.10:FF:000464', NULL, NULL, 'P53-induced death domain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(121897, NULL, 'G3DSA:3.40.50.300:FF:001296', NULL, NULL, 'Vacuolar membrane ATPase subunit a', NULL, NULL, NULL, NULL, NULL, 4),
(121898, NULL, 'G3DSA:1.25.10.10:FF:000005', NULL, NULL, 'CLIP-associating protein 1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(121899, NULL, 'G3DSA:2.40.50.140:FF:000369', NULL, NULL, 'ATP-dependent DNA helicase RecG', NULL, NULL, NULL, NULL, NULL, 4),
(121900, NULL, 'G3DSA:2.60.40.10:FF:003072', NULL, NULL, 'Protein CBR-SAX-3', NULL, NULL, NULL, NULL, NULL, 4),
(121901, NULL, 'G3DSA:3.60.10.10:FF:000178', NULL, NULL, 'Tyrosyl-DNA phosphodiesterase 2', NULL, NULL, NULL, NULL, NULL, 4),
(121902, NULL, 'G3DSA:2.40.270.10:FF:000008', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(121903, NULL, 'G3DSA:1.20.1070.10:FF:001788', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121904, NULL, 'G3DSA:3.30.2090.10:FF:000004', NULL, NULL, 'Multidrug resistance protein MdtC', NULL, NULL, NULL, NULL, NULL, 4),
(121905, NULL, 'G3DSA:1.20.1720.10:FF:000006', NULL, NULL, 'Multidrug resistance protein D', NULL, NULL, NULL, NULL, NULL, 4),
(121906, NULL, 'G3DSA:3.30.1460.20:FF:000013', NULL, NULL, 'Arp2/3 complex 34 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(121907, NULL, 'G3DSA:3.40.50.720:FF:001202', NULL, NULL, '2-deoxy-D-gluconate 3-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(121908, NULL, 'G3DSA:3.30.450.20:FF:000530', NULL, NULL, 'Response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(121909, NULL, 'G3DSA:1.25.50.20:FF:000016', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(121910, NULL, 'G3DSA:2.60.40.10:FF:002796', NULL, NULL, 'Platelet-derived growth factor receptor alpha', NULL, NULL, NULL, NULL, NULL, 4),
(121911, NULL, 'G3DSA:1.20.5.110:FF:000019', NULL, NULL, 'Vesicle-trafficking protein SEC22b', NULL, NULL, NULL, NULL, NULL, 4),
(121912, NULL, 'G3DSA:1.10.8.60:FF:000530', NULL, NULL, 'ATPase, AAA family protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(121913, NULL, 'G3DSA:1.25.10.20:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121914, NULL, 'G3DSA:3.60.15.10:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121915, NULL, 'G3DSA:3.40.50.300:FF:001638', NULL, NULL, 'NACHT and WD40 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(121916, NULL, 'G3DSA:1.10.357.140:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121917, NULL, 'G3DSA:3.20.80.10:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121918, NULL, 'G3DSA:3.40.190.10:FF:000886', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121919, NULL, 'G3DSA:3.30.9.10:FF:000210', NULL, NULL, 'Dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(121920, NULL, 'G3DSA:3.40.50.300:FF:005921', NULL, NULL, 'ABC transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(121921, NULL, 'G3DSA:1.10.10.440:FF:000040', NULL, NULL, 'Pre-mRNA-processing factor 40, putative', NULL, NULL, NULL, NULL, NULL, 4),
(121922, NULL, 'G3DSA:1.25.40.20:FF:001472', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121923, NULL, 'G3DSA:1.10.510.10:FF:003495', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121924, NULL, 'G3DSA:3.30.780.10:FF:000052', NULL, NULL, 'Translation machinery-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(121925, NULL, 'G3DSA:3.10.100.10:FF:000298', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121926, NULL, 'G3DSA:3.80.10.10:FF:004393', NULL, NULL, 'Leucine-rich repeats and immunoglobulin-like domains 2', NULL, NULL, NULL, NULL, NULL, 4),
(121927, NULL, 'G3DSA:1.10.3820.10:FF:000005', NULL, NULL, 'Cytochrome C', NULL, NULL, NULL, NULL, NULL, 4),
(121928, NULL, 'G3DSA:3.30.70.330:FF:000277', NULL, NULL, 'RNA binding motif protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(121929, NULL, 'G3DSA:1.10.1370.40:FF:000012', NULL, NULL, 'Clan MA, family M3, oligopeptidase A-like metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(121930, NULL, 'G3DSA:3.30.160.60:FF:002998', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121931, NULL, 'G3DSA:2.30.42.10:FF:000391', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121932, NULL, 'G3DSA:3.40.1190.20:FF:000192', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121933, NULL, 'G3DSA:3.30.40.10:FF:000726', NULL, NULL, 'Os11g0142900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(121934, NULL, 'G3DSA:2.20.100.10:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121935, NULL, 'G3DSA:2.10.70.10:FF:000006', NULL, NULL, 'Fibronectin 1', NULL, NULL, NULL, NULL, NULL, 4),
(121936, NULL, 'G3DSA:3.40.50.1820:FF:000963', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121937, NULL, 'G3DSA:1.10.560.10:FF:000120', NULL, NULL, 'T-complex protein 1 subunit eta', NULL, NULL, NULL, NULL, NULL, 4),
(121938, NULL, 'G3DSA:2.130.10.10:FF:005168', NULL, NULL, 'AEL269Cp', NULL, NULL, NULL, NULL, NULL, 4),
(121939, NULL, 'G3DSA:3.80.10.10:FF:000806', NULL, NULL, 'Transforming growth factor beta activator LRRC33', NULL, NULL, NULL, NULL, NULL, 4),
(121940, NULL, 'G3DSA:1.25.40.10:FF:004695', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121941, NULL, 'G3DSA:1.10.8.430:FF:000011', NULL, NULL, 'Disease resistance RPP13-like protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(121942, NULL, 'G3DSA:3.40.50.300:FF:003550', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121943, NULL, 'G3DSA:3.40.50.150:FF:001666', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121944, NULL, 'G3DSA:1.10.10.10:FF:001129', NULL, NULL, 'Transcription factor ets-4', NULL, NULL, NULL, NULL, NULL, 4),
(121945, NULL, 'G3DSA:2.60.40.420:FF:000222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121946, NULL, 'G3DSA:2.20.70.140:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121947, NULL, 'G3DSA:3.40.50.460:FF:000034', NULL, NULL, 'Phosphofructokinase family protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(121948, NULL, 'G3DSA:3.40.605.10:FF:000143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121949, NULL, 'G3DSA:1.10.10.160:FF:000057', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(121950, NULL, 'G3DSA:3.40.30.10:FF:000017', NULL, NULL, 'Protein disulfide-isomerase A4', NULL, NULL, NULL, NULL, NULL, 4),
(121951, NULL, 'G3DSA:3.40.50.300:FF:001537', NULL, NULL, 'Secretion related GTPase SrgD', NULL, NULL, NULL, NULL, NULL, 4),
(121952, NULL, 'G3DSA:1.10.238.110:FF:000011', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(121953, NULL, 'G3DSA:1.10.8.60:FF:000300', NULL, NULL, 'Transitional endoplasmic reticulum ATPase TER94-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(121954, NULL, 'G3DSA:3.40.50.450:FF:000031', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(121955, NULL, 'G3DSA:3.10.170.20:FF:000001', NULL, NULL, 'Peptidase M8, leishmanolysin', NULL, NULL, NULL, NULL, NULL, 4),
(121956, NULL, 'G3DSA:3.40.390.10:FF:000188', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121957, NULL, 'G3DSA:1.10.510.10:FF:002894', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121958, NULL, 'G3DSA:3.90.640.10:FF:000264', NULL, NULL, 'Actin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(121959, NULL, 'G3DSA:1.20.58.60:FF:000534', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121960, NULL, 'G3DSA:3.30.710.10:FF:000446', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121961, NULL, 'G3DSA:2.60.120.290:FF:000118', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(121962, NULL, 'G3DSA:3.60.40.10:FF:000360', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121963, NULL, 'G3DSA:3.30.70.660:FF:000027', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(121964, NULL, 'G3DSA:3.80.10.10:FF:003111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121965, NULL, 'G3DSA:1.20.1410.10:FF:000005', NULL, NULL, 'cyclin-D1-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(121966, NULL, 'G3DSA:2.30.30.140:FF:000311', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121967, NULL, 'G3DSA:2.60.120.200:FF:000356', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(121968, NULL, 'G3DSA:1.20.920.20:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121969, NULL, 'G3DSA:2.30.42.10:FF:000289', NULL, NULL, 'Glutamate receptor-interacting protein 2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(121970, NULL, 'G3DSA:1.20.1250.60:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121971, NULL, 'G3DSA:3.60.40.10:FF:000129', NULL, NULL, 'Stage II sporulation protein E', NULL, NULL, NULL, NULL, NULL, 4),
(121972, NULL, 'G3DSA:1.10.720.80:FF:000002', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(121973, NULL, 'G3DSA:1.20.1050.10:FF:000264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121974, NULL, 'G3DSA:3.30.70.330:FF:001215', NULL, NULL, 'Mud1p', NULL, NULL, NULL, NULL, NULL, 4),
(121975, NULL, 'G3DSA:1.10.238.10:FF:001018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121976, NULL, 'G3DSA:1.10.10.650:FF:000013', NULL, NULL, 'Transcription elongation factor Spt6', NULL, NULL, NULL, NULL, NULL, 4),
(121977, NULL, 'G3DSA:3.30.1330.30:FF:000012', NULL, NULL, 'growth arrest and DNA damage-inducible protein GADD45 alpha', NULL, NULL, NULL, NULL, NULL, 4),
(121978, NULL, 'G3DSA:1.10.540.10:FF:000012', NULL, NULL, 'Acyl-CoA dehydrogenase short/branched chain', NULL, NULL, NULL, NULL, NULL, 4),
(121979, NULL, 'G3DSA:1.10.510.10:FF:001270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121980, NULL, 'G3DSA:2.40.50.140:FF:001100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121981, NULL, 'G3DSA:2.10.25.10:FF:000144', NULL, NULL, 'Low-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(121982, NULL, 'G3DSA:3.10.50.40:FF:000141', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(121983, NULL, 'G3DSA:3.40.50.300:FF:003437', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(121984, NULL, 'G3DSA:1.10.510.10:FF:000994', NULL, NULL, 'Hypoxia Inhibited Receptor tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(121985, NULL, 'G3DSA:1.10.1200.10:FF:000020', NULL, NULL, 'Peptide synthetase mbtE', NULL, NULL, NULL, NULL, NULL, 4),
(121986, NULL, 'G3DSA:3.30.460.10:FF:000123', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(121987, NULL, 'G3DSA:3.40.50.620:FF:000094', NULL, NULL, 'Tryptophan--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(121988, NULL, 'G3DSA:1.10.10.350:FF:000024', NULL, NULL, 'Glutamate--tRNA ligase 2', NULL, NULL, NULL, NULL, NULL, 4),
(121989, NULL, 'G3DSA:2.60.220.50:FF:000182', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(121990, NULL, 'G3DSA:3.30.160.60:FF:005645', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(121991, NULL, 'G3DSA:1.10.8.60:FF:000075', NULL, NULL, 'Spermatogenesis-associated protein 5-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(121992, NULL, 'G3DSA:4.10.280.10:FF:000020', NULL, NULL, 'class E basic helix-loop-helix protein 40', NULL, NULL, NULL, NULL, NULL, 4),
(121993, NULL, 'G3DSA:1.20.1070.10:FF:002064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121994, NULL, 'G3DSA:3.80.10.10:FF:002594', NULL, NULL, 'Cyclic nucleotide-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(121995, NULL, 'G3DSA:1.20.140.10:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121996, NULL, 'G3DSA:3.30.1330.40:FF:000015', NULL, NULL, 'Fanconi anemia group J protein', NULL, NULL, NULL, NULL, NULL, 4),
(121997, NULL, 'G3DSA:1.20.1250.40:FF:000001', NULL, NULL, 'DNA-directed RNA polymerase II subunit RPB4', NULL, NULL, NULL, NULL, NULL, 4),
(121998, NULL, 'G3DSA:2.40.50.770:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(121999, NULL, 'G3DSA:3.40.50.300:FF:000014', NULL, NULL, 'DNA polymerase III subunit gamma/tau', NULL, NULL, NULL, NULL, NULL, 4),
(122000, NULL, 'G3DSA:3.20.20.80:FF:000802', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122001, NULL, 'G3DSA:3.40.50.10380:FF:000012', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(122002, NULL, 'G3DSA:3.30.230.10:FF:000089', NULL, NULL, 'Type 2 DNA topoisomerase 6 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(122003, NULL, 'G3DSA:2.30.42.10:FF:000278', NULL, NULL, 'DEGP protease 2', NULL, NULL, NULL, NULL, NULL, 4),
(122004, NULL, 'G3DSA:1.20.1270.60:FF:000115', NULL, NULL, 'Putative Dynamin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(122005, NULL, 'G3DSA:3.30.160.60:FF:001155', NULL, NULL, 'Zinc finger 30C', NULL, NULL, NULL, NULL, NULL, 4),
(122006, NULL, 'G3DSA:3.10.580.10:FF:000052', NULL, NULL, 'Cystathionine beta-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(122007, NULL, 'G3DSA:1.20.5.170:FF:000223', NULL, NULL, 'YALI0D23287p', NULL, NULL, NULL, NULL, NULL, 4),
(122008, NULL, 'G3DSA:3.40.50.2300:FF:000467', NULL, NULL, 'Probable two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(122009, NULL, 'G3DSA:2.40.240.130:FF:000001', NULL, NULL, 'Segment polarity protein dishevelled homolog DVL-1', NULL, NULL, NULL, NULL, NULL, 4),
(122010, NULL, 'G3DSA:1.25.40.120:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122011, NULL, 'G3DSA:3.30.200.20:FF:000596', NULL, NULL, 'Possible aminoglycoside phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(122012, NULL, 'G3DSA:3.30.1440.10:FF:000008', NULL, NULL, 'Ribosomal L5P family protein', NULL, NULL, NULL, NULL, NULL, 4),
(122013, NULL, 'G3DSA:3.60.20.10:FF:000252', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122014, NULL, 'G3DSA:2.60.40.10:FF:001368', NULL, NULL, 'Leucine rich repeat, Ig-like and transmembrane domains 3', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(122015, NULL, 'G3DSA:3.30.1520.10:FF:000066', NULL, NULL, 'Related to BEM3-GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(122016, NULL, 'G3DSA:1.10.418.70:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122017, NULL, 'G3DSA:3.50.50.60:FF:001112', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(122018, NULL, 'G3DSA:3.30.540.10:FF:000079', NULL, NULL, 'Inositol monophosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(122019, NULL, 'G3DSA:1.20.1250.20:FF:000692', NULL, NULL, 'SLC (SoLute Carrier) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(122020, NULL, 'G3DSA:3.30.420.40:FF:001079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122021, NULL, 'G3DSA:1.10.10.10:FF:001461', NULL, NULL, 'RIO-like kinase', NULL, NULL, NULL, NULL, NULL, 4),
(122022, NULL, 'G3DSA:1.25.10.10:FF:000938', NULL, NULL, 'protein penguin', NULL, NULL, NULL, NULL, NULL, 4),
(122023, NULL, 'G3DSA:1.10.10.2330:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122024, NULL, 'G3DSA:3.40.50.10140:FF:000070', NULL, NULL, 'Toll-like receptor 19', NULL, NULL, NULL, NULL, NULL, 4),
(122025, NULL, 'G3DSA:3.40.850.10:FF:000448', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(122026, NULL, 'G3DSA:1.20.58.2130:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122027, NULL, 'G3DSA:3.40.190.10:FF:000448', NULL, NULL, 'ABC transporter, substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(122028, NULL, 'G3DSA:3.30.70.330:FF:000597', NULL, NULL, 'Putative RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(122029, NULL, 'G3DSA:1.25.10.10:FF:001091', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(122030, NULL, 'G3DSA:1.10.1040.10:FF:000029', NULL, NULL, '6-phosphogluconate dehydrogenase (Decarboxylating)', NULL, NULL, NULL, NULL, NULL, 4),
(122031, NULL, 'G3DSA:3.30.160.60:FF:005084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122032, NULL, 'G3DSA:3.60.110.10:FF:000096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122033, NULL, 'G3DSA:3.30.60.90:FF:000032', NULL, NULL, 'E3 ubiquitin-protein ligase HERC2', NULL, NULL, NULL, NULL, NULL, 4),
(122034, NULL, 'G3DSA:3.50.50.60:FF:000494', NULL, NULL, 'FAD-dependent monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(122035, NULL, 'G3DSA:2.130.10.10:FF:001812', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(122036, NULL, 'G3DSA:1.20.58.2140:FF:000008', NULL, NULL, 'Translin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(122037, NULL, 'G3DSA:1.20.1070.10:FF:000473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122038, NULL, 'G3DSA:1.20.1250.20:FF:000462', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122039, NULL, 'G3DSA:3.30.70.330:FF:000939', NULL, NULL, 'Putative polypyrimidine tract binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(122040, NULL, 'G3DSA:3.30.1370.210:FF:000008', NULL, NULL, 'zinc finger CCCH domain-containing protein 11A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(122041, NULL, 'G3DSA:3.90.340.10:FF:000005', NULL, NULL, 'Nitric oxide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(122042, NULL, 'G3DSA:2.130.10.10:FF:005303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122043, NULL, 'G3DSA:1.50.40.10:FF:000011', NULL, NULL, 'Mitochondrial thiamine pyrophosphate carrier 1', NULL, NULL, NULL, NULL, NULL, 4),
(122044, NULL, 'G3DSA:2.70.160.11:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122045, NULL, 'G3DSA:3.40.50.2000:FF:000372', NULL, NULL, 'UDP-Glycosyltransferase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(122046, NULL, 'G3DSA:2.60.120.200:FF:000811', NULL, NULL, 'Calreticulin', NULL, NULL, NULL, NULL, NULL, 4),
(122047, NULL, 'G3DSA:1.25.40.20:FF:000510', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(122048, NULL, 'G3DSA:3.30.310.10:FF:000011', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(122049, NULL, 'G3DSA:3.90.1170.50:FF:000008', NULL, NULL, 'Xanthine dehydrogenase, molybdenum binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(122050, NULL, 'G3DSA:3.30.930.10:FF:000209', NULL, NULL, 'ATP phosphoribosyltransferase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(122051, NULL, 'G3DSA:1.25.40.10:FF:003267', NULL, NULL, 'Pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(122052, NULL, 'G3DSA:3.90.1170.40:FF:000005', NULL, NULL, 'Putative molybdenum cofactor biosynthesis protein e2 moaE2', NULL, NULL, NULL, NULL, NULL, 4),
(122053, NULL, 'G3DSA:2.130.10.10:FF:003370', NULL, NULL, 'Selective LIM binding factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122054, NULL, 'G3DSA:2.60.300.12:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122055, NULL, 'G3DSA:1.10.630.10:FF:000811', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(122056, NULL, 'G3DSA:1.10.510.10:FF:003618', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122057, NULL, 'G3DSA:1.20.1740.10:FF:000092', NULL, NULL, 'Putative L-type amino acid transporter 1-like protein MLAS', NULL, NULL, NULL, NULL, NULL, 4),
(122058, NULL, 'G3DSA:1.20.1080.10:FF:000092', NULL, NULL, 'Aquaporin-2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122059, NULL, 'G3DSA:1.10.10.60:FF:001240', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122060, NULL, 'G3DSA:3.90.1170.30:FF:000002', NULL, NULL, 'Pyrimidine-nucleoside phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(122061, NULL, 'G3DSA:1.10.287.10:FF:000024', NULL, NULL, 'Protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(122062, NULL, 'G3DSA:3.90.1150.10:FF:000355', NULL, NULL, 'dTDP-4-amino-4,6-dideoxygalactose transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(122063, NULL, 'G3DSA:3.10.450.40:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122064, NULL, 'G3DSA:2.40.50.90:FF:000180', NULL, NULL, 'Enhanced RNAI (RNA interference)', NULL, NULL, NULL, NULL, NULL, 4),
(122065, NULL, 'G3DSA:1.10.510.10:FF:001157', NULL, NULL, 'Calcium/calmodulin-dependent protein kinase type II delta 1 chain', NULL, NULL, NULL, NULL, NULL, 4),
(122066, NULL, 'G3DSA:1.20.1250.20:FF:001777', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122067, NULL, 'G3DSA:3.80.10.10:FF:002055', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase PEPR1', NULL, NULL, NULL, NULL, NULL, 4),
(122068, NULL, 'G3DSA:1.10.510.10:FF:003950', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122069, NULL, 'G3DSA:3.30.559.10:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122070, NULL, 'G3DSA:2.130.10.10:FF:001458', NULL, NULL, 'Os01g0606133 protein', NULL, NULL, NULL, NULL, NULL, 4),
(122071, NULL, 'G3DSA:3.30.70.330:FF:002851', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122072, NULL, 'G3DSA:3.30.1640.30:FF:000002', NULL, NULL, 'Spaetzle-processing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(122073, NULL, 'G3DSA:3.30.310.130:FF:000013', NULL, NULL, 'Related to protease ULP2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(122074, NULL, 'G3DSA:1.10.640.10:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122075, NULL, 'G3DSA:2.60.40.420:FF:000087', NULL, NULL, 'Spore coat protein A', NULL, NULL, NULL, NULL, NULL, 4),
(122076, NULL, 'G3DSA:3.80.10.10:FF:001779', NULL, NULL, 'F-box/LRR-repeat protein 14-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(122077, NULL, 'G3DSA:3.40.50.2300:FF:001304', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122078, NULL, 'G3DSA:3.40.50.720:FF:000365', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(122079, NULL, 'G3DSA:3.30.160.60:FF:001716', NULL, NULL, 'Zinc finger protein 516', NULL, NULL, NULL, NULL, NULL, 4),
(122080, NULL, 'G3DSA:3.80.10.10:FF:004516', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(122081, NULL, 'G3DSA:1.20.1560.10:FF:000460', NULL, NULL, 'ABC transporter D family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(122082, NULL, 'G3DSA:3.30.160.60:FF:004589', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122083, NULL, 'G3DSA:2.60.120.920:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122084, NULL, 'G3DSA:3.40.50.2000:FF:000933', NULL, NULL, 'Mannosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122085, NULL, 'G3DSA:3.90.190.10:FF:000420', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122086, NULL, 'G3DSA:3.50.50.60:FF:000836', NULL, NULL, 'Probable FAD-dependent oxidoreductase PA4991', NULL, NULL, NULL, NULL, NULL, 4),
(122087, NULL, 'G3DSA:2.60.260.20:FF:000097', NULL, NULL, 'Chaperone protein DNAJ-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(122088, NULL, 'G3DSA:1.10.720.30:FF:000004', NULL, NULL, 'heterogeneous nuclear ribonucleoprotein U isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(122089, NULL, 'G3DSA:2.10.25.10:FF:000374', NULL, NULL, 'Integrin subunit beta like 1', NULL, NULL, NULL, NULL, NULL, 4),
(122090, NULL, 'G3DSA:3.30.390.30:FF:000022', NULL, NULL, 'Nitrite reductase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(122091, NULL, 'G3DSA:3.50.30.30:FF:000045', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(122092, NULL, 'G3DSA:3.30.40.10:FF:002194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122093, NULL, 'G3DSA:3.30.160.60:FF:003616', NULL, NULL, 'histone H4 transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(122094, NULL, 'G3DSA:3.20.20.140:FF:000004', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(122095, NULL, 'G3DSA:2.10.220.10:FF:000001', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(122096, NULL, 'G3DSA:1.25.40.10:FF:002907', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(122097, NULL, 'G3DSA:2.130.10.10:FF:003712', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122098, NULL, 'G3DSA:3.30.930.10:FF:000002', NULL, NULL, 'Threonine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(122099, NULL, 'G3DSA:3.80.10.10:FF:003679', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(122100, NULL, 'G3DSA:3.30.200.20:FF:001433', NULL, NULL, 'Homoserine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(122101, NULL, 'G3DSA:2.60.120.290:FF:000231', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(122102, NULL, 'G3DSA:1.10.8.10:FF:000212', NULL, NULL, 'GD19730', NULL, NULL, NULL, NULL, NULL, 4),
(122103, NULL, 'G3DSA:3.40.50.1820:FF:000183', NULL, NULL, 'Phosphatidylcholine-sterol acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(122104, NULL, 'G3DSA:3.30.160.60:FF:000879', NULL, NULL, 'Chromosome alignment maintaining phosphoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(122105, NULL, 'G3DSA:1.25.10.10:FF:001433', NULL, NULL, 'TSC complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(122106, NULL, 'G3DSA:2.60.120.620:FF:000021', NULL, NULL, 'WGS project CABT00000000 data, contig 2.8', NULL, NULL, NULL, NULL, NULL, 4),
(122107, NULL, 'G3DSA:2.130.10.10:FF:001251', NULL, NULL, 'Autophagy-related protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(122108, NULL, 'G3DSA:3.30.390.80:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122109, NULL, 'G3DSA:2.40.30.300:FF:000003', NULL, NULL, 'DEAD-box family ATP dependent helicase', NULL, NULL, NULL, NULL, NULL, 4),
(122110, NULL, 'G3DSA:3.20.20.80:FF:000448', NULL, NULL, 'Mannosidase, endo-alpha', NULL, NULL, NULL, NULL, NULL, 4),
(122111, NULL, 'G3DSA:1.10.150.510:FF:000012', NULL, NULL, 'Si:ch73-334d15.2', NULL, NULL, NULL, NULL, NULL, 4),
(122112, NULL, 'G3DSA:2.130.10.10:FF:004685', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122113, NULL, 'G3DSA:1.10.630.10:FF:000250', NULL, NULL, 'Cytochrome P450, family 71, subfamily B, polypeptide 37', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(122114, NULL, 'G3DSA:1.10.510.10:FF:003057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122115, NULL, 'G3DSA:2.30.29.30:FF:000871', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(122116, NULL, 'G3DSA:3.40.50.300:FF:002032', NULL, NULL, 'DNA repair helicase RAD3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122117, NULL, 'G3DSA:3.80.10.10:FF:000576', NULL, NULL, 'Leucine rich repeats and transmembrane domains 2', NULL, NULL, NULL, NULL, NULL, 4),
(122118, NULL, 'G3DSA:2.130.10.10:FF:005410', NULL, NULL, 'BEACH domain-containing protein lvsA', NULL, NULL, NULL, NULL, NULL, 4),
(122119, NULL, 'G3DSA:4.10.280.10:FF:000132', NULL, NULL, 'CRE-HLH-2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(122120, NULL, 'G3DSA:1.10.1200.10:FF:000019', NULL, NULL, 'Phenolpthiocerol synthesis type-I polyketide synthase PPSA', NULL, NULL, NULL, NULL, NULL, 4),
(122121, NULL, 'G3DSA:3.40.50.720:FF:000472', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(122122, NULL, 'G3DSA:3.30.160.60:FF:001587', NULL, NULL, 'Zinc finger protein 57', NULL, NULL, NULL, NULL, NULL, 4),
(122123, NULL, 'G3DSA:2.40.40.10:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122124, NULL, 'G3DSA:2.10.25.10:FF:001785', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122125, NULL, 'G3DSA:3.40.50.1820:FF:000418', NULL, NULL, 'Lpx1p', NULL, NULL, NULL, NULL, NULL, 4),
(122126, NULL, 'G3DSA:1.20.120.560:FF:000007', NULL, NULL, 'pH-response regulator protein palA/RIM20', NULL, NULL, NULL, NULL, NULL, 4),
(122127, NULL, 'G3DSA:2.130.10.10:FF:004786', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122128, NULL, 'G3DSA:3.30.9.10:FF:000081', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(122129, NULL, 'G3DSA:3.40.30.10:FF:000135', NULL, NULL, 'DnaJ homolog subfamily C member 10', NULL, NULL, NULL, NULL, NULL, 4),
(122130, NULL, 'G3DSA:1.25.40.180:FF:000076', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(122131, NULL, 'G3DSA:1.25.40.10:FF:004577', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122132, NULL, 'G3DSA:3.20.20.140:FF:000330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122133, NULL, 'G3DSA:3.30.70.330:FF:001440', NULL, NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(122134, NULL, 'G3DSA:3.60.20.10:FF:000139', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(122135, NULL, 'G3DSA:1.25.40.10:FF:003054', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(122136, NULL, 'G3DSA:1.10.287.3550:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122137, NULL, 'G3DSA:2.60.120.200:FF:000468', NULL, NULL, 'Heparan sulfate proteoglycan 2', NULL, NULL, NULL, NULL, NULL, 4),
(122138, NULL, 'G3DSA:3.30.479.30:FF:000048', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(122139, NULL, 'G3DSA:1.25.40.1030:FF:000007', NULL, NULL, 'Protein transport protein (SEC31), putative', NULL, NULL, NULL, NULL, NULL, 4),
(122140, NULL, 'G3DSA:1.20.900.10:FF:000066', NULL, NULL, 'RhoGAP domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(122141, NULL, 'G3DSA:2.40.50.1070:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122142, NULL, 'G3DSA:2.130.10.10:FF:003263', NULL, NULL, 'RNA polymerase II Elongator subunit', NULL, NULL, NULL, NULL, NULL, 4),
(122143, NULL, 'G3DSA:3.40.50.300:FF:003662', NULL, NULL, 'Dynein heavy chain 5, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(122144, NULL, 'G3DSA:2.20.100.10:FF:000131', NULL, NULL, 'papilin isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(122145, NULL, 'G3DSA:1.10.510.10:FF:002101', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122146, NULL, 'G3DSA:2.40.50.140:FF:000829', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(122147, NULL, 'G3DSA:3.40.190.10:FF:000768', NULL, NULL, 'ABC-type transport system periplasmic substrate-binding protein (Probable substrate dipeptide/oligopeptide)', NULL, NULL, NULL, NULL, NULL, 4),
(122148, NULL, 'G3DSA:3.40.50.2000:FF:000927', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122149, NULL, 'G3DSA:3.30.40.10:FF:000838', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122150, NULL, 'G3DSA:3.40.1190.20:FF:000080', NULL, NULL, 'BnaC05g04640D protein', NULL, NULL, NULL, NULL, NULL, 4),
(122151, NULL, 'G3DSA:3.30.450.20:FF:000395', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(122152, NULL, 'G3DSA:3.30.479.20:FF:000045', NULL, NULL, 'Elongation factor Ts, mitochondrial 1', NULL, NULL, NULL, NULL, NULL, 4),
(122153, NULL, 'G3DSA:2.60.40.10:FF:001149', NULL, NULL, 'Turtle, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(122154, NULL, 'G3DSA:3.30.70.330:FF:002637', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122155, NULL, 'G3DSA:3.30.200.20:FF:001192', NULL, NULL, 'Probable kinase CHARK', NULL, NULL, NULL, NULL, NULL, 4),
(122156, NULL, 'G3DSA:3.30.160.60:FF:003734', NULL, NULL, 'Kruppel-Like Factor (Zinc finger protein)', NULL, NULL, NULL, NULL, NULL, 4),
(122157, NULL, 'G3DSA:3.40.630.30:FF:000230', NULL, NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', NULL, NULL, NULL, NULL, NULL, 4),
(122158, NULL, 'G3DSA:1.10.510.10:FF:001477', NULL, NULL, 'Protein CBG16284', NULL, NULL, NULL, NULL, NULL, 4),
(122159, NULL, 'G3DSA:3.80.10.10:FF:002723', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(122160, NULL, 'G3DSA:1.20.1560.10:FF:000448', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122161, NULL, 'G3DSA:2.60.15.10:FF:000006', NULL, NULL, 'ATP synthase epsilon chain', NULL, NULL, NULL, NULL, NULL, 4),
(122162, NULL, 'G3DSA:3.40.50.150:FF:001127', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122163, NULL, 'G3DSA:2.60.40.10:FF:003178', NULL, NULL, '4-alpha-glucanotransferase DPE2', NULL, NULL, NULL, NULL, NULL, 4),
(122164, NULL, 'G3DSA:1.25.40.180:FF:000183', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122165, NULL, 'G3DSA:1.20.58.60:FF:000652', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122166, NULL, 'G3DSA:1.20.1290.10:FF:000017', NULL, NULL, '4-carboxymuconolactone decarboxylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122167, NULL, 'G3DSA:1.20.58.150:FF:000003', NULL, NULL, 'Putative clathrin assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(122168, NULL, 'G3DSA:2.30.42.10:FF:000519', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122169, NULL, 'G3DSA:1.10.10.10:FF:001360', NULL, NULL, 'Rho-GTPase-activating protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(122170, NULL, 'G3DSA:3.30.160.60:FF:003841', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122171, NULL, 'G3DSA:3.30.160.60:FF:001694', NULL, NULL, 'zinc finger protein with KRAB and SCAN domains 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(122172, NULL, 'G3DSA:1.20.58.160:FF:000006', NULL, NULL, 'TOM1-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(122173, NULL, 'G3DSA:3.40.50.150:FF:001234', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122174, NULL, 'G3DSA:3.30.200.20:FF:002389', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122175, NULL, 'G3DSA:1.10.510.10:FF:003624', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122176, NULL, 'G3DSA:2.130.10.10:FF:003156', NULL, NULL, 'Chromatin assembly factor 1, subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(122177, NULL, 'G3DSA:1.25.10.10:FF:000697', NULL, NULL, 'Sister chromatid cohesion protein', NULL, NULL, NULL, NULL, NULL, 4),
(122178, NULL, 'G3DSA:3.30.420.60:FF:000006', NULL, NULL, 'Protein pelota homolog', NULL, NULL, NULL, NULL, NULL, 4),
(122179, NULL, 'G3DSA:3.30.70.330:FF:002963', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122180, NULL, 'G3DSA:3.20.20.10:FF:000017', NULL, NULL, 'Alanine racemase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(122181, NULL, 'G3DSA:3.80.10.10:FF:004180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122182, NULL, 'G3DSA:1.20.1070.10:FF:000815', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(122183, NULL, 'G3DSA:3.40.50.300:FF:003555', NULL, NULL, 'RAB43, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(122184, NULL, 'G3DSA:1.20.1070.10:FF:000478', NULL, NULL, 'DihydroCaffeic Acid Receptor', NULL, NULL, NULL, NULL, NULL, 4),
(122185, NULL, 'G3DSA:1.10.2000.10:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122186, NULL, 'G3DSA:1.20.5.100:FF:000011', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(122187, NULL, 'G3DSA:3.30.70.330:FF:001333', NULL, NULL, 'ACINus (Mammalian Apoptotic Chromatin condensation Inducer in the Nucleus) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(122188, NULL, 'G3DSA:1.25.40.10:FF:003380', NULL, NULL, 'Os03g0861900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(122189, NULL, 'G3DSA:3.40.30.10:FF:000242', NULL, NULL, 'Ypt homolog1', NULL, NULL, NULL, NULL, NULL, 4),
(122190, NULL, 'G3DSA:2.10.25.10:FF:000262', NULL, NULL, 'Thrombospondin 4', NULL, NULL, NULL, NULL, NULL, 4),
(122191, NULL, 'G3DSA:2.30.30.490:FF:000062', NULL, NULL, 'PolyBRoMo domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(122192, NULL, 'G3DSA:1.20.930.10:FF:000012', NULL, NULL, 'Protein IWS1 homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(122193, NULL, 'G3DSA:1.10.287.370:FF:000031', NULL, NULL, 'Prefoldin subunit 6, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122194, NULL, 'G3DSA:3.60.20.10:FF:000246', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122195, NULL, 'G3DSA:3.30.930.10:FF:000434', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122196, NULL, 'G3DSA:3.30.760.10:FF:000062', NULL, NULL, 'eukaryotic translation initiation factor 4E-1A', NULL, NULL, NULL, NULL, NULL, 4),
(122197, NULL, 'G3DSA:1.20.1250.20:FF:002154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122198, NULL, 'G3DSA:3.40.50.10490:FF:000152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122199, NULL, 'G3DSA:3.90.320.10:FF:000015', NULL, NULL, 'ATP-dependent helicase/nuclease subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(122200, NULL, 'G3DSA:1.20.5.110:FF:000014', NULL, NULL, 'Transport protein sec22', NULL, NULL, NULL, NULL, NULL, 4),
(122201, NULL, 'G3DSA:1.10.1670.10:FF:000066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122202, NULL, 'G3DSA:3.50.50.60:FF:000724', NULL, NULL, 'Dihydrolipoamide dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122203, NULL, 'G3DSA:1.25.40.10:FF:005201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122204, NULL, 'G3DSA:1.25.10.10:FF:001321', NULL, NULL, 'IMportin Beta family', NULL, NULL, NULL, NULL, NULL, 4),
(122205, NULL, 'G3DSA:1.10.287.380:FF:000034', NULL, NULL, 'tRNA synthetases class I-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(122206, NULL, 'G3DSA:1.20.1270.60:FF:000227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122207, NULL, 'G3DSA:3.20.20.140:FF:000223', NULL, NULL, 'TatD DNase', NULL, NULL, NULL, NULL, NULL, 4),
(122208, NULL, 'G3DSA:2.40.40.20:FF:000023', NULL, NULL, 'Tetrathionate reductase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(122209, NULL, 'G3DSA:3.30.160.60:FF:002211', NULL, NULL, 'Tripartite motif-containing protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(122210, NULL, 'G3DSA:3.90.190.10:FF:000066', NULL, NULL, 'Dual specificity protein phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(122211, NULL, 'G3DSA:2.60.40.10:FF:005432', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122212, NULL, 'G3DSA:1.10.1300.10:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122213, NULL, 'G3DSA:1.10.510.10:FF:003731', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122214, NULL, 'G3DSA:3.60.10.10:FF:000072', NULL, NULL, 'Extracellular nuclease', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(122215, NULL, 'G3DSA:3.40.630.30:FF:000123', NULL, NULL, 'N-terminal acetyltransferase A complex catalytic subunit ARD1', NULL, NULL, NULL, NULL, NULL, 4),
(122216, NULL, 'G3DSA:1.10.287.1150:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122217, NULL, 'G3DSA:1.10.533.10:FF:000102', NULL, NULL, 'Imd', NULL, NULL, NULL, NULL, NULL, 4),
(122218, NULL, 'G3DSA:1.10.357.40:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122219, NULL, 'G3DSA:3.30.780.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122220, NULL, 'G3DSA:2.10.50.10:FF:000112', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 6', NULL, NULL, NULL, NULL, NULL, 4),
(122221, NULL, 'G3DSA:3.40.50.720:FF:001888', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122222, NULL, 'G3DSA:1.25.10.70:FF:000006', NULL, NULL, 'Nucleoporin subcomplex protein binding to Pom34-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(122223, NULL, 'G3DSA:2.60.40.10:FF:001380', NULL, NULL, 'Peripheral-type benzodiazepine receptor-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(122224, NULL, 'G3DSA:3.90.190.20:FF:000069', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(122225, NULL, 'G3DSA:3.30.70.330:FF:002744', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122226, NULL, 'G3DSA:1.25.40.90:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122227, NULL, 'G3DSA:1.10.510.10:FF:001258', NULL, NULL, 'Protein CBG18395', NULL, NULL, NULL, NULL, NULL, 4),
(122228, NULL, 'G3DSA:3.30.70.330:FF:002856', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122229, NULL, 'G3DSA:1.25.10.10:FF:003226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122230, NULL, 'G3DSA:3.30.40.10:FF:000619', NULL, NULL, 'Putative E3 ubiquitin-protein ligase HERC1', NULL, NULL, NULL, NULL, NULL, 4),
(122231, NULL, 'G3DSA:3.10.200.10:FF:000013', NULL, NULL, 'Carbonic AnHydrase', NULL, NULL, NULL, NULL, NULL, 4),
(122232, NULL, 'G3DSA:3.90.190.10:FF:000526', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122233, NULL, 'G3DSA:3.40.50.410:FF:000255', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(122234, NULL, 'G3DSA:2.60.220.50:FF:000081', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(122235, NULL, 'G3DSA:2.60.40.550:FF:000002', NULL, NULL, 'Ecotin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122236, NULL, 'G3DSA:3.30.413.10:FF:000003', NULL, NULL, 'Sulfite reductase [NADPH] hemoprotein beta-component', NULL, NULL, NULL, NULL, NULL, 4),
(122237, NULL, 'G3DSA:2.30.30.100:FF:000097', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm8', NULL, NULL, NULL, NULL, NULL, 4),
(122238, NULL, 'G3DSA:1.25.40.20:FF:001819', NULL, NULL, 'Skeletrophin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122239, NULL, 'G3DSA:2.30.42.10:FF:000626', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122240, NULL, 'G3DSA:2.10.25.10:FF:000481', NULL, NULL, 'Integrin subunit beta like 1', NULL, NULL, NULL, NULL, NULL, 4),
(122241, NULL, 'G3DSA:2.40.50.140:FF:000936', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122242, NULL, 'G3DSA:2.30.29.30:FF:000545', NULL, NULL, 'Phosphoinositide 3-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(122243, NULL, 'G3DSA:3.90.25.10:FF:000076', NULL, NULL, 'UDP-glucose 4-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(122244, NULL, 'G3DSA:3.30.1370.30:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122245, NULL, 'G3DSA:2.30.39.10:FF:000034', NULL, NULL, 'Serine proteinase inhibitor 2', NULL, NULL, NULL, NULL, NULL, 4),
(122246, NULL, 'G3DSA:3.30.160.60:FF:003515', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122247, NULL, 'G3DSA:2.40.50.90:FF:000067', NULL, NULL, 'Tudor domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(122248, NULL, 'G3DSA:1.10.150.50:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(122249, NULL, 'G3DSA:3.40.1110.10:FF:000307', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122250, NULL, 'G3DSA:1.20.1070.10:FF:000708', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122251, NULL, 'G3DSA:3.30.40.10:FF:002295', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(122252, NULL, 'G3DSA:1.10.510.10:FF:000769', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122253, NULL, 'G3DSA:2.40.50.120:FF:000037', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(122254, NULL, 'G3DSA:1.10.287.660:FF:000011', NULL, NULL, 'Protein SRN2', NULL, NULL, NULL, NULL, NULL, 4),
(122255, NULL, 'G3DSA:1.20.1070.10:FF:000585', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122256, NULL, 'G3DSA:3.80.10.10:FF:002504', NULL, NULL, 'ADR009Wp', NULL, NULL, NULL, NULL, NULL, 4),
(122257, NULL, 'G3DSA:3.40.50.2000:FF:000708', NULL, NULL, 'Lipopolysaccharide core biosynthesis protein rfaQ', NULL, NULL, NULL, NULL, NULL, 4),
(122258, NULL, 'G3DSA:3.40.50.300:FF:004859', NULL, NULL, 'Mismatch repair protein MSH5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122259, NULL, 'G3DSA:2.10.25.10:FF:001678', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122260, NULL, 'G3DSA:1.10.486.10:FF:000037', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(122261, NULL, 'G3DSA:3.30.70.2150:FF:000003', NULL, NULL, 'GlcNAc-binding protein A', NULL, NULL, NULL, NULL, NULL, 4),
(122262, NULL, 'G3DSA:2.10.90.10:FF:000002', NULL, NULL, 'Brain-derived neurotrophic factor', NULL, NULL, NULL, NULL, NULL, 4),
(122263, NULL, 'G3DSA:3.20.20.80:FF:000673', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(122264, NULL, 'G3DSA:1.20.970.10:FF:000014', NULL, NULL, 'Anthranilate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(122265, NULL, 'G3DSA:3.40.720.10:FF:000124', NULL, NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(122266, NULL, 'G3DSA:1.25.10.10:FF:003445', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122267, NULL, 'G3DSA:2.60.120.330:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122268, NULL, 'G3DSA:3.40.1690.20:FF:000005', NULL, NULL, 'Paraplegin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122269, NULL, 'G3DSA:3.40.50.300:FF:001419', NULL, NULL, 'Macrolide ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(122270, NULL, 'G3DSA:2.60.40.10:FF:003285', NULL, NULL, 'Mcam protein', NULL, NULL, NULL, NULL, NULL, 4),
(122271, NULL, 'G3DSA:1.10.1370.10:FF:000026', NULL, NULL, 'Si:ch73-1a9.4', NULL, NULL, NULL, NULL, NULL, 4),
(122272, NULL, 'G3DSA:1.10.555.10:FF:000052', NULL, NULL, 'Rho GTPase-activating protein REN1', NULL, NULL, NULL, NULL, NULL, 4),
(122273, NULL, 'G3DSA:1.20.1410.10:FF:000011', NULL, NULL, 'Cyclin-D1-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(122274, NULL, 'G3DSA:3.40.390.10:FF:000194', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(122275, NULL, 'G3DSA:1.10.510.10:FF:003512', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122276, NULL, 'G3DSA:1.10.287.470:FF:000061', NULL, NULL, 'Putative multidrug resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(122277, NULL, 'G3DSA:3.40.1690.10:FF:000002', NULL, NULL, 'SPI-1 type III secretion system export apparatus protein SpaS', NULL, NULL, NULL, NULL, NULL, 4),
(122278, NULL, 'G3DSA:2.130.10.110:FF:000027', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(122279, NULL, 'G3DSA:2.60.120.230:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122280, NULL, 'G3DSA:1.10.10.160:FF:000063', NULL, NULL, 'Probable DNA helicase II homolog', NULL, NULL, NULL, NULL, NULL, 4),
(122281, NULL, 'G3DSA:3.40.720.10:FF:000343', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122282, NULL, 'G3DSA:2.30.29.30:FF:000764', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(122283, NULL, 'G3DSA:3.40.50.150:FF:001346', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122284, NULL, 'G3DSA:3.40.50.720:FF:002377', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122285, NULL, 'G3DSA:2.40.128.20:FF:000024', NULL, NULL, 'Neutrophil gelatinase-associated lipocalin', NULL, NULL, NULL, NULL, NULL, 4),
(122286, NULL, 'G3DSA:1.20.1560.10:FF:000229', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122287, NULL, 'G3DSA:1.20.140.10:FF:000002', NULL, NULL, 'Acyl-CoA dehydrogenase short/branched chain', NULL, NULL, NULL, NULL, NULL, 4),
(122288, NULL, 'G3DSA:3.10.390.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122289, NULL, 'G3DSA:1.10.10.650:FF:000007', NULL, NULL, 'Transcription elongation factor Spt6', NULL, NULL, NULL, NULL, NULL, 4),
(122290, NULL, 'G3DSA:1.10.630.10:FF:000019', NULL, NULL, 'Cytochrome P450 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(122291, NULL, 'G3DSA:2.130.10.10:FF:003044', NULL, NULL, 'Small nucleolar ribonucleoprotein complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(122292, NULL, 'G3DSA:3.80.10.10:FF:002493', NULL, NULL, 'Tubulin-specific chaperone E', NULL, NULL, NULL, NULL, NULL, 4),
(122293, NULL, 'G3DSA:1.50.40.10:FF:000112', NULL, NULL, 'Mitochondrial carrier protein (Pet8), putative', NULL, NULL, NULL, NULL, NULL, 4),
(122294, NULL, 'G3DSA:1.20.1270.10:FF:000022', NULL, NULL, 'Heat shock protein 70', NULL, NULL, NULL, NULL, NULL, 4),
(122295, NULL, 'G3DSA:3.30.1150.10:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122296, NULL, 'G3DSA:4.10.280.10:FF:000025', NULL, NULL, 'protein atonal homolog 7', NULL, NULL, NULL, NULL, NULL, 4),
(122297, NULL, 'G3DSA:3.30.450.20:FF:000288', NULL, NULL, 'Development and carotenogenesis control-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(122298, NULL, 'G3DSA:3.30.930.10:FF:000108', NULL, NULL, 'Octanoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(122299, NULL, 'G3DSA:2.60.120.200:FF:000710', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122300, NULL, 'G3DSA:3.30.160.60:FF:005191', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122301, NULL, 'G3DSA:1.20.140.20:FF:000005', NULL, NULL, 'Pkp1p', NULL, NULL, NULL, NULL, NULL, 4),
(122302, NULL, 'G3DSA:3.40.50.1700:FF:000040', NULL, NULL, 'Periplasmic beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(122303, NULL, 'G3DSA:1.20.5.110:FF:000126', NULL, NULL, 'Protein CBR-SYX-2', NULL, NULL, NULL, NULL, NULL, 4),
(122304, NULL, 'G3DSA:2.130.10.10:FF:001913', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(122305, NULL, 'G3DSA:2.30.29.30:FF:000085', NULL, NULL, 'Pleckstrin homology domain-containing family A member 8', NULL, NULL, NULL, NULL, NULL, 4),
(122306, NULL, 'G3DSA:1.10.10.60:FF:001009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122307, NULL, 'G3DSA:3.40.718.10:FF:000074', NULL, NULL, 'Isopropylmalate dehydrogenase1', NULL, NULL, NULL, NULL, NULL, 4),
(122308, NULL, 'G3DSA:3.40.50.150:FF:001560', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122309, NULL, 'G3DSA:3.50.50.60:FF:001432', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122310, NULL, 'G3DSA:3.30.160.60:FF:000986', NULL, NULL, 'Zinc finger protein 541', NULL, NULL, NULL, NULL, NULL, 4),
(122311, NULL, 'G3DSA:1.10.10.790:FF:000021', NULL, NULL, 'RNA splicing factor', NULL, NULL, NULL, NULL, NULL, 4),
(122312, NULL, 'G3DSA:3.30.1330.30:FF:000124', NULL, NULL, '40S ribosomal protein S12', NULL, NULL, NULL, NULL, NULL, 4),
(122313, NULL, 'G3DSA:1.25.40.470:FF:000056', NULL, NULL, 'Selective LIM binding factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122314, NULL, 'G3DSA:2.60.40.10:FF:005651', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122315, NULL, 'G3DSA:1.25.40.10:FF:003161', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(122316, NULL, 'G3DSA:3.20.20.140:FF:000111', NULL, NULL, 'Membrane dipeptidase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(122317, NULL, 'G3DSA:3.80.10.10:FF:000469', NULL, NULL, 'Receptor-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(122318, NULL, 'G3DSA:1.20.1250.20:FF:002373', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122319, NULL, 'G3DSA:1.10.357.30:FF:000002', NULL, NULL, 'Exocyst complex component', NULL, NULL, NULL, NULL, NULL, 4),
(122320, NULL, 'G3DSA:2.30.40.10:FF:000009', NULL, NULL, '5-methylthioadenosine/S-adenosylhomocysteine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(122321, NULL, 'G3DSA:3.30.930.10:FF:000322', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(122322, NULL, 'G3DSA:3.50.30.30:FF:000152', NULL, NULL, 'F10A2.10 protein', NULL, NULL, NULL, NULL, NULL, 4),
(122323, NULL, 'G3DSA:3.40.50.300:FF:007714', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122324, NULL, 'G3DSA:1.20.58.60:FF:000433', NULL, NULL, 'AGAP009554-PA', NULL, NULL, NULL, NULL, NULL, 4),
(122325, NULL, 'G3DSA:3.30.70.330:FF:001114', NULL, NULL, 'Ribonucleoprotein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122326, NULL, 'G3DSA:3.60.10.10:FF:000184', NULL, NULL, 'CCR4-NOT transcription complex, subunit 6-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(122327, NULL, 'G3DSA:3.40.50.12430:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122328, NULL, 'G3DSA:1.50.10.10:FF:000054', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(122329, NULL, 'G3DSA:1.25.40.180:FF:000306', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122330, NULL, 'G3DSA:1.20.58.100:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122331, NULL, 'G3DSA:3.40.50.1820:FF:000188', NULL, NULL, 'putative lipase ROG1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(122332, NULL, 'G3DSA:3.40.1280.10:FF:000084', NULL, NULL, 'tRNA/rRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(122333, NULL, 'G3DSA:3.30.2130.30:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122334, NULL, 'G3DSA:3.90.640.10:FF:000157', NULL, NULL, 'Cysteinyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122335, NULL, 'G3DSA:1.10.437.10:FF:000053', NULL, NULL, 'BCL2-associated X, apoptosis regulator a', NULL, NULL, NULL, NULL, NULL, 4),
(122336, NULL, 'G3DSA:3.30.160.60:FF:001475', NULL, NULL, 'Zinc finger protein 585A', NULL, NULL, NULL, NULL, NULL, 4),
(122337, NULL, 'G3DSA:2.60.40.10:FF:003408', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122338, NULL, 'G3DSA:3.30.70.330:FF:002418', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122339, NULL, 'G3DSA:3.50.50.60:FF:000943', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(122340, NULL, 'G3DSA:2.130.10.10:FF:003375', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122341, NULL, 'G3DSA:3.30.710.10:FF:000339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122342, NULL, 'G3DSA:3.30.460.10:FF:000022', NULL, NULL, 'poly(A) RNA polymerase GLD2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(122343, NULL, 'G3DSA:1.25.40.10:FF:003166', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At3g01580', NULL, NULL, NULL, NULL, NULL, 4),
(122344, NULL, 'G3DSA:1.20.58.60:FF:000871', NULL, NULL, 'Spectrin repeat containing nuclear envelope protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(122345, NULL, 'G3DSA:3.40.50.720:FF:000702', NULL, NULL, 'NADH dehydrogenase (Ubiquinone)', NULL, NULL, NULL, NULL, NULL, 4),
(122346, NULL, 'G3DSA:1.25.10.10:FF:001540', NULL, NULL, 'Adaptin N terminal region family protein', NULL, NULL, NULL, NULL, NULL, 4),
(122347, NULL, 'G3DSA:3.40.1160.10:FF:000030', NULL, NULL, 'Uridylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(122348, NULL, 'G3DSA:3.40.390.10:FF:000087', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(122349, NULL, 'G3DSA:3.40.50.2300:FF:001063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122350, NULL, 'G3DSA:3.10.350.10:FF:000018', NULL, NULL, 'Peptidoglycan endopeptidase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(122351, NULL, 'G3DSA:1.20.1250.20:FF:000467', NULL, NULL, 'Putative MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(122352, NULL, 'G3DSA:2.60.120.230:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122353, NULL, 'G3DSA:1.20.1250.20:FF:000809', NULL, NULL, 'Proline/betaine transporter (ProP)', NULL, NULL, NULL, NULL, NULL, 4),
(122354, NULL, 'G3DSA:3.40.50.300:FF:003774', NULL, NULL, 'DNA repair helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122355, NULL, 'G3DSA:2.60.120.200:FF:000249', NULL, NULL, 'Calsyntenin-1, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(122356, NULL, 'G3DSA:2.60.40.1080:FF:000001', NULL, NULL, 'Bacterial Ig-like domain, group 2', NULL, NULL, NULL, NULL, NULL, 4),
(122357, NULL, 'G3DSA:3.40.710.10:FF:000062', NULL, NULL, 'Peptidase M15', NULL, NULL, NULL, NULL, NULL, 4),
(122358, NULL, 'G3DSA:3.40.50.2000:FF:000815', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(122359, NULL, 'G3DSA:3.30.420.10:FF:000238', NULL, NULL, 'Retrovirus-related Pol polyprotein from transposon 412-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(122360, NULL, 'G3DSA:2.60.40.200:FF:000032', NULL, NULL, 'Superoxide dismutase [Cu-Zn]', NULL, NULL, NULL, NULL, NULL, 4),
(122361, NULL, 'G3DSA:1.50.10.20:FF:000057', NULL, NULL, 'Glutinol synthase', NULL, NULL, NULL, NULL, NULL, 4),
(122362, NULL, 'G3DSA:2.60.40.1090:FF:000004', NULL, NULL, 'Fimbrial protein BcfF', NULL, NULL, NULL, NULL, NULL, 4),
(122363, NULL, 'G3DSA:3.80.10.10:FF:002611', NULL, NULL, 'Nuclear pore complex protein NUP107', NULL, NULL, NULL, NULL, NULL, 4),
(122364, NULL, 'G3DSA:2.60.40.10:FF:003066', NULL, NULL, 'Myosin-light-chain kinase', NULL, NULL, NULL, NULL, NULL, 4),
(122365, NULL, 'G3DSA:3.30.900.10:FF:000051', NULL, NULL, 'Autophagy-related protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(122366, NULL, 'G3DSA:3.40.630.30:FF:000342', NULL, NULL, 'Acetylglutamate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(122367, NULL, 'G3DSA:3.30.160.60:FF:001817', NULL, NULL, 'Zinc finger protein 275', NULL, NULL, NULL, NULL, NULL, 4),
(122368, NULL, 'G3DSA:3.30.160.60:FF:005421', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122369, NULL, 'G3DSA:2.30.170.20:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122370, NULL, 'G3DSA:1.10.510.10:FF:001039', NULL, NULL, 'Casein kinase I isoform delta', NULL, NULL, NULL, NULL, NULL, 4),
(122371, NULL, 'G3DSA:1.10.287.130:FF:000083', NULL, NULL, 'Putative two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(122372, NULL, 'G3DSA:2.60.40.10:FF:003173', NULL, NULL, 'Platelet-derived growth factor receptor, alpha polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(122373, NULL, 'G3DSA:1.20.900.10:FF:000061', NULL, NULL, 'TIAM (Mammalian Tumor Invasion And Metastasis factor) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(122374, NULL, 'G3DSA:3.40.1190.20:FF:000203', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122375, NULL, 'G3DSA:2.10.10.10:FF:000003', NULL, NULL, 'binder of sperm protein homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(122376, NULL, 'G3DSA:1.20.81.10:FF:000005', NULL, NULL, 'GG17180', NULL, NULL, NULL, NULL, NULL, 4),
(122377, NULL, 'G3DSA:3.40.50.720:FF:001303', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(122378, NULL, 'G3DSA:2.40.240.10:FF:000063', NULL, NULL, 'Ribosomal protein L25/Gln-tRNA synthetase, anti-codon-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(122379, NULL, 'G3DSA:3.40.50.1820:FF:000637', NULL, NULL, 'AGAP011682-PA', NULL, NULL, NULL, NULL, NULL, 4),
(122380, NULL, 'G3DSA:2.60.40.1730:FF:000011', NULL, NULL, 'Arginyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(122381, NULL, 'G3DSA:3.30.1490.220:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122382, NULL, 'G3DSA:3.30.470.20:FF:000183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122383, NULL, 'G3DSA:2.60.40.10:FF:001609', NULL, NULL, 'Centrosomal protein 192', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(122384, NULL, 'G3DSA:2.30.39.10:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122385, NULL, 'G3DSA:4.10.1060.10:FF:000051', NULL, NULL, 'Nuclear pore complex protein Nup153-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(122386, NULL, 'G3DSA:3.40.190.10:FF:000549', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(122387, NULL, 'G3DSA:3.30.190.20:FF:000026', NULL, NULL, 'Mitochondrial ribosomal protein L1', NULL, NULL, NULL, NULL, NULL, 4),
(122388, NULL, 'G3DSA:3.30.1480.10:FF:000011', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(122389, NULL, 'G3DSA:3.30.1240.10:FF:000027', NULL, NULL, 'HAD family phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(122390, NULL, 'G3DSA:1.10.357.30:FF:000007', NULL, NULL, 'Exocyst complex component', NULL, NULL, NULL, NULL, NULL, 4),
(122391, NULL, 'G3DSA:2.20.70.70:FF:000001', NULL, NULL, 'Penicillin-binding protein 2X', NULL, NULL, NULL, NULL, NULL, 4),
(122392, NULL, 'G3DSA:3.20.20.80:FF:000347', NULL, NULL, 'Probable glucosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(122393, NULL, 'G3DSA:2.60.40.60:FF:001029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122394, NULL, 'G3DSA:1.25.10.20:FF:000020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(122395, NULL, 'G3DSA:1.10.238.10:FF:001125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122396, NULL, 'G3DSA:1.20.58.1120:FF:000028', NULL, NULL, 'Putative dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(122397, NULL, 'G3DSA:2.60.40.10:FF:003515', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122398, NULL, 'G3DSA:1.25.40.90:FF:000054', NULL, NULL, 'Putative clathrin assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(122399, NULL, 'G3DSA:2.30.30.100:FF:000108', NULL, NULL, 'Small nuclear ribonucleoprotein E', NULL, NULL, NULL, NULL, NULL, 4),
(122400, NULL, 'G3DSA:2.60.120.380:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122401, NULL, 'G3DSA:3.20.20.70:FF:000344', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(122402, NULL, 'G3DSA:3.40.50.1820:FF:000295', NULL, NULL, 'neurotactin', NULL, NULL, NULL, NULL, NULL, 4),
(122403, NULL, 'G3DSA:3.80.10.10:FF:000357', NULL, NULL, 'F-box/LRR-repeat protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(122404, NULL, 'G3DSA:3.50.50.60:FF:001213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122405, NULL, 'G3DSA:1.20.1420.30:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122406, NULL, 'G3DSA:1.20.1300.20:FF:000011', NULL, NULL, 'Chromosome undetermined SCAF10229, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(122407, NULL, 'G3DSA:1.20.990.10:FF:000009', NULL, NULL, 'NADPH--cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(122408, NULL, 'G3DSA:2.30.42.10:FF:000396', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122409, NULL, 'G3DSA:1.25.40.660:FF:000017', NULL, NULL, 'Vacuolar protein sorting-associated protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(122410, NULL, 'G3DSA:3.30.70.360:FF:000033', NULL, NULL, 'Acetylornithine deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(122411, NULL, 'G3DSA:1.25.40.270:FF:000007', NULL, NULL, 'Vta1 like, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122412, NULL, 'G3DSA:3.40.50.300:FF:007607', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122413, NULL, 'G3DSA:3.40.50.150:FF:001565', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122414, NULL, 'G3DSA:2.40.420.20:FF:000052', NULL, NULL, 'Membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(122415, NULL, 'G3DSA:3.40.50.1700:FF:000045', NULL, NULL, 'Beta-D-glucan exohydrolase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(122416, NULL, 'G3DSA:1.20.58.1460:FF:000001', NULL, NULL, 'Phenylacetic acid degradation operon negative regulatory protein paaX', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(122417, NULL, 'G3DSA:2.130.10.10:FF:003830', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122418, NULL, 'G3DSA:2.60.40.10:FF:003392', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122419, NULL, 'G3DSA:4.10.240.10:FF:000028', NULL, NULL, 'Uncharacterized transcriptional regulatory protein C1773.12', NULL, NULL, NULL, NULL, NULL, 4),
(122420, NULL, 'G3DSA:1.10.10.900:FF:000004', NULL, NULL, 'Shwachman-Bodian-Diamond syndrome (SBDS) protein/SBDS protein C-terminal domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122421, NULL, 'G3DSA:1.20.1250.20:FF:000916', NULL, NULL, 'Cis,cis-muconate transporter MucK', NULL, NULL, NULL, NULL, NULL, 4),
(122422, NULL, 'G3DSA:1.25.40.20:FF:001707', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122423, NULL, 'G3DSA:3.10.129.10:FF:000167', NULL, NULL, 'Thioesterase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(122424, NULL, 'G3DSA:3.40.190.80:FF:000070', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(122425, NULL, 'G3DSA:1.25.40.20:FF:001371', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122426, NULL, 'G3DSA:1.10.510.10:FF:003394', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122427, NULL, 'G3DSA:1.20.1250.20:FF:000574', NULL, NULL, 'Unplaced genomic scaffold supercont2.19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(122428, NULL, 'G3DSA:3.30.70.330:FF:003126', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122429, NULL, 'G3DSA:1.10.510.10:FF:003517', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122430, NULL, 'G3DSA:3.30.200.210:FF:000007', NULL, NULL, 'Molybdopterin oxidoreductase Fe4S4 region', NULL, NULL, NULL, NULL, NULL, 4),
(122431, NULL, 'G3DSA:1.25.40.10:FF:000873', NULL, NULL, 'Clustered mitochondria protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(122432, NULL, 'G3DSA:1.10.20.140:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122433, NULL, 'G3DSA:2.10.70.10:FF:000107', NULL, NULL, 'Complement factor H', NULL, NULL, NULL, NULL, NULL, 4),
(122434, NULL, 'G3DSA:3.90.1280.20:FF:000002', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(122435, NULL, 'G3DSA:1.10.510.10:FF:003175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122436, NULL, 'G3DSA:3.30.1520.10:FF:000184', NULL, NULL, 'Ribosomal protein S6 kinase C1', NULL, NULL, NULL, NULL, NULL, 4),
(122437, NULL, 'G3DSA:1.10.60.30:FF:000003', NULL, NULL, 'UPF0307 protein XC_1511', NULL, NULL, NULL, NULL, NULL, 4),
(122438, NULL, 'G3DSA:3.40.50.620:FF:000335', NULL, NULL, 'Tyrosyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(122439, NULL, 'G3DSA:1.25.10.10:FF:003338', NULL, NULL, 'YALI0D22440p', NULL, NULL, NULL, NULL, NULL, 4),
(122440, NULL, 'G3DSA:3.80.10.10:FF:004073', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122441, NULL, 'G3DSA:3.30.230.10:FF:000319', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122442, NULL, 'G3DSA:1.10.400.10:FF:000087', NULL, NULL, 'Si:ch211-207c7.2', NULL, NULL, NULL, NULL, NULL, 4),
(122443, NULL, 'G3DSA:3.90.360.10:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122444, NULL, 'G3DSA:1.25.40.10:FF:001704', NULL, NULL, 'Os03g0314400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(122445, NULL, 'G3DSA:3.60.40.10:FF:000023', NULL, NULL, 'Protein phosphatase, Mg2+/Mn2+-dependent, 1G', NULL, NULL, NULL, NULL, NULL, 4),
(122446, NULL, 'G3DSA:3.30.70.1450:FF:000029', NULL, NULL, 'Potassium transporter peripheral membrane component', NULL, NULL, NULL, NULL, NULL, 4),
(122447, NULL, 'G3DSA:3.10.20.90:FF:000311', NULL, NULL, 'UBX domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(122448, NULL, 'G3DSA:3.40.50.740:FF:000005', NULL, NULL, 'Anaerobic dimethyl sulfoxide reductase, A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(122449, NULL, 'G3DSA:3.40.50.300:FF:003881', NULL, NULL, 'Capsular polysaccharide biosynthesis homolog', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(122450, NULL, 'G3DSA:3.90.180.10:FF:000026', NULL, NULL, 'Chlorophyll synthesis pathway protein BchC', NULL, NULL, NULL, NULL, NULL, 4),
(122451, NULL, 'G3DSA:3.80.10.10:FF:003797', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122452, NULL, 'G3DSA:2.30.110.10:FF:000016', NULL, NULL, 'Flavin reductase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(122453, NULL, 'G3DSA:2.130.10.10:FF:003482', NULL, NULL, 'enhancer of mRNA-decapping protein 4-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(122454, NULL, 'G3DSA:3.30.1460.20:FF:000018', NULL, NULL, 'Arp2/3 complex 34 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(122455, NULL, 'G3DSA:3.30.40.10:FF:002076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122456, NULL, 'G3DSA:4.10.1030.10:FF:000004', NULL, NULL, 'Cullin-1', NULL, NULL, NULL, NULL, NULL, 4),
(122457, NULL, 'G3DSA:3.40.50.300:FF:004966', NULL, NULL, 'Rab_B73 protein', NULL, NULL, NULL, NULL, NULL, 4),
(122458, NULL, 'G3DSA:3.40.50.1370:FF:000019', NULL, NULL, 'Aspartate carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(122459, NULL, 'G3DSA:2.30.29.30:FF:000540', NULL, NULL, 'sesquipedalian-1-like', NULL, NULL, NULL, NULL, NULL, 4),
(122460, NULL, 'G3DSA:2.40.10.330:FF:000002', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(122461, NULL, 'G3DSA:3.30.460.50:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122462, NULL, 'G3DSA:3.40.50.12780:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122463, NULL, 'G3DSA:3.60.10.10:FF:000077', NULL, NULL, 'Carbon catabolite repressor protein 4 1', NULL, NULL, NULL, NULL, NULL, 4),
(122464, NULL, 'G3DSA:2.40.50.90:FF:000062', NULL, NULL, 'Tudor domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(122465, NULL, 'G3DSA:3.30.450.50:FF:000050', NULL, NULL, '25.3 kDa vesicle transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(122466, NULL, 'G3DSA:1.25.40.10:FF:004796', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(122467, NULL, 'G3DSA:3.80.10.10:FF:002830', NULL, NULL, 'SCF E3 ubiquitin ligase complex F-box protein pof2', NULL, NULL, NULL, NULL, NULL, 4),
(122468, NULL, 'G3DSA:3.90.70.10:FF:000040', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 37', NULL, NULL, NULL, NULL, NULL, 4),
(122469, NULL, 'G3DSA:1.10.287.70:FF:000233', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(122470, NULL, 'G3DSA:3.30.200.20:FF:001315', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122471, NULL, 'G3DSA:3.40.50.300:FF:000115', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(122472, NULL, 'G3DSA:1.20.1070.10:FF:001889', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122473, NULL, 'G3DSA:1.10.8.720:FF:000002', NULL, NULL, 'Dynein heavy chain 9, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(122474, NULL, 'G3DSA:3.30.450.60:FF:000053', NULL, NULL, 'Protein CBG13942', NULL, NULL, NULL, NULL, NULL, 4),
(122475, NULL, 'G3DSA:3.30.160.60:FF:003392', NULL, NULL, 'Hermaphrodite, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(122476, NULL, 'G3DSA:1.10.238.10:FF:000040', NULL, NULL, 'Ryanodine receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(122477, NULL, 'G3DSA:3.80.10.10:FF:004292', NULL, NULL, 'Si:dkey-51d8.1', NULL, NULL, NULL, NULL, NULL, 4),
(122478, NULL, 'G3DSA:3.30.70.330:FF:002289', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122479, NULL, 'G3DSA:1.25.10.10:FF:003119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122480, NULL, 'G3DSA:2.60.40.10:FF:003734', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122481, NULL, 'G3DSA:3.40.50.300:FF:007259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122482, NULL, 'G3DSA:1.20.1730.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122483, NULL, 'G3DSA:3.40.1650.10:FF:000005', NULL, NULL, 'Fucose mutarotase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(122484, NULL, 'G3DSA:3.10.50.40:FF:000040', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(122485, NULL, 'G3DSA:3.40.50.300:FF:003336', NULL, NULL, 'Heparan-sulfate 6-O-sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(122486, NULL, 'G3DSA:1.20.1070.10:FF:002165', NULL, NULL, 'AGAP013324-PA', NULL, NULL, NULL, NULL, NULL, 4),
(122487, NULL, 'G3DSA:2.30.30.140:FF:000210', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(122488, NULL, 'G3DSA:1.20.1070.10:FF:000259', NULL, NULL, 'G-protein coupled receptor', NULL, NULL, NULL, NULL, NULL, 4),
(122489, NULL, 'G3DSA:2.40.10.340:FF:000005', NULL, NULL, 'Rod shape-determining protein MreC', NULL, NULL, NULL, NULL, NULL, 4),
(122490, NULL, 'G3DSA:2.60.40.10:FF:000300', NULL, NULL, 'fibronectin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(122491, NULL, 'G3DSA:2.10.50.10:FF:000005', NULL, NULL, 'signal peptide, CUB and EGF-like domain-containing protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(122492, NULL, 'G3DSA:2.40.10.350:FF:000008', NULL, NULL, 'Cell shape-determining protein MreC', NULL, NULL, NULL, NULL, NULL, 4),
(122493, NULL, 'G3DSA:3.60.20.10:FF:000134', NULL, NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', NULL, NULL, NULL, NULL, NULL, 4),
(122494, NULL, 'G3DSA:1.10.238.20:FF:000043', NULL, NULL, 'AGAP003307-PB', NULL, NULL, NULL, NULL, NULL, 4),
(122495, NULL, 'G3DSA:3.80.10.10:FF:001200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122496, NULL, 'G3DSA:3.40.50.1360:FF:000016', NULL, NULL, 'Central glycolytic genes regulator', NULL, NULL, NULL, NULL, NULL, 4),
(122497, NULL, 'G3DSA:2.130.10.10:FF:004909', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122498, NULL, 'G3DSA:1.20.5.110:FF:000233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122499, NULL, 'G3DSA:2.130.10.30:FF:000060', NULL, NULL, 'Regulator of chromosome condensation', NULL, NULL, NULL, NULL, NULL, 4),
(122500, NULL, 'G3DSA:3.30.70.240:FF:000002', NULL, NULL, 'GTP-binding protein TypA', NULL, NULL, NULL, NULL, NULL, 4),
(122501, NULL, 'G3DSA:3.40.50.360:FF:000111', NULL, NULL, 'SPbeta prophage-derived protein NrdI', NULL, NULL, NULL, NULL, NULL, 4),
(122502, NULL, 'G3DSA:2.60.40.3510:FF:000011', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(122503, NULL, 'G3DSA:3.90.660.10:FF:000046', NULL, NULL, 'Flavin monoamine oxidase-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(122504, NULL, 'G3DSA:3.90.70.80:FF:000033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(122505, NULL, 'G3DSA:3.40.50.720:FF:000814', NULL, NULL, 'Probable short chain alcohol dehydrogenase/reductase', NULL, NULL, NULL, NULL, NULL, 4),
(122506, NULL, 'G3DSA:1.20.120.1770:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122507, NULL, 'G3DSA:3.40.50.300:FF:007591', NULL, NULL, 'Dead/deah box helicase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(122508, NULL, 'G3DSA:1.25.40.20:FF:000061', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(122509, NULL, 'G3DSA:3.40.250.10:FF:000144', NULL, NULL, 'Thiosulfate sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(122510, NULL, 'G3DSA:3.40.50.1820:FF:000076', NULL, NULL, 'phospholipase A1', NULL, NULL, NULL, NULL, NULL, 4),
(122511, NULL, 'G3DSA:1.20.120.1760:FF:000020', NULL, NULL, 'cardiolipin synthase (CMP-forming), mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(122512, NULL, 'G3DSA:1.10.287.110:FF:000200', NULL, NULL, 'DnaJ domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(122513, NULL, 'G3DSA:2.120.10.90:FF:000004', NULL, NULL, 'DNA gyrase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(122514, NULL, 'G3DSA:1.10.287.130:FF:000206', NULL, NULL, 'HAMP domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(122515, NULL, 'G3DSA:3.40.390.10:FF:000317', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122516, NULL, 'G3DSA:3.30.1330.70:FF:000001', NULL, NULL, 'Crossover junction endodeoxyribonuclease RusA', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(122517, NULL, 'G3DSA:1.10.287.1490:FF:000002', NULL, NULL, 'epidermal growth factor receptor substrate 15-like 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(122518, NULL, 'G3DSA:3.10.10.10:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122519, NULL, 'G3DSA:1.10.1520.10:FF:000061', NULL, NULL, 'Ribonuclease 3', NULL, NULL, NULL, NULL, NULL, 4),
(122520, NULL, 'G3DSA:2.60.40.10:FF:005084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122521, NULL, 'G3DSA:2.10.60.10:FF:000051', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(122522, NULL, 'G3DSA:2.30.130.10:FF:000012', NULL, NULL, 'tRNA pseudouridine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(122523, NULL, 'G3DSA:2.60.40.150:FF:000787', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122524, NULL, 'G3DSA:3.60.15.10:FF:000279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122525, NULL, 'G3DSA:2.40.50.140:FF:001105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122526, NULL, 'G3DSA:1.10.472.80:FF:000172', NULL, NULL, 'Chromosome 16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(122527, NULL, 'G3DSA:2.40.50.140:FF:000487', NULL, NULL, 'Minichromosome maintenance 8 homologous recombination repair factor', NULL, NULL, NULL, NULL, NULL, 4),
(122528, NULL, 'G3DSA:3.30.310.80:FF:000009', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(122529, NULL, 'G3DSA:2.20.70.10:FF:000259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122530, NULL, 'G3DSA:1.10.720.30:FF:000009', NULL, NULL, 'E3 SUMO-protein ligase PIAS4', NULL, NULL, NULL, NULL, NULL, 4),
(122531, NULL, 'G3DSA:3.30.160.60:FF:005640', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122532, NULL, 'G3DSA:1.20.1250.20:FF:000355', NULL, NULL, 'SLC (SoLute Carrier) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(122533, NULL, 'G3DSA:3.40.50.620:FF:000554', NULL, NULL, 'Electron transfer flavoprotein beta-subunit', NULL, NULL, NULL, NULL, NULL, 4),
(122534, NULL, 'G3DSA:3.30.390.30:FF:000016', NULL, NULL, 'Putidaredoxin reductase CamA', NULL, NULL, NULL, NULL, NULL, 4),
(122535, NULL, 'G3DSA:3.60.10.10:FF:000420', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122536, NULL, 'G3DSA:2.130.10.10:FF:003605', NULL, NULL, 'Guanine nucleotide-binding protein subunit beta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(122537, NULL, 'G3DSA:1.10.12.10:FF:000009', NULL, NULL, 'Methylmalonyl-CoA decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(122538, NULL, 'G3DSA:3.30.930.10:FF:000092', NULL, NULL, 'Histidyl-tRNA synthetase putative', NULL, NULL, NULL, NULL, NULL, 4),
(122539, NULL, 'G3DSA:1.25.40.10:FF:002778', NULL, NULL, 'TPR-repeat-containing chaperone protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122540, NULL, 'G3DSA:3.40.50.2300:FF:000681', NULL, NULL, 'Metabotropic glutamate receptor-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(122541, NULL, 'G3DSA:1.10.40.30:FF:000007', NULL, NULL, 'Adenylosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(122542, NULL, 'G3DSA:3.30.470.20:FF:000071', NULL, NULL, 'methylcrotonoyl-CoA carboxylase subunit alpha, mitochondrial isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(122543, NULL, 'G3DSA:1.20.120.1320:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122544, NULL, 'G3DSA:1.10.287.70:FF:000452', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(122545, NULL, 'G3DSA:3.40.50.620:FF:000548', NULL, NULL, 'Asparagine synthase (Glutamine-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4),
(122546, NULL, 'G3DSA:3.30.1330.90:FF:000007', NULL, NULL, 'L-serine dehydratase, iron-sulfur-dependent, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(122547, NULL, 'G3DSA:3.30.1010.10:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122548, NULL, 'G3DSA:3.90.1150.10:FF:000349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(122549, NULL, 'G3DSA:3.30.70.260:FF:000008', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(122550, NULL, 'G3DSA:2.60.450.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122551, NULL, 'G3DSA:3.40.50.360:FF:000094', NULL, NULL, 'Flavodoxin', NULL, NULL, NULL, NULL, NULL, 4),
(122552, NULL, 'G3DSA:2.120.10.10:FF:000037', NULL, NULL, 'Probable sialidase', NULL, NULL, NULL, NULL, NULL, 4),
(122553, NULL, 'G3DSA:1.25.40.10:FF:004919', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(122554, NULL, 'G3DSA:3.30.70.250:FF:000005', NULL, NULL, 'Malonyl-CoA-acyl carrier protein transacylase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(122555, NULL, 'G3DSA:3.30.40.10:FF:001114', NULL, NULL, 'RING/FYVE/PHD-type zinc finger family protein', NULL, NULL, NULL, NULL, NULL, 4),
(122556, NULL, 'G3DSA:3.80.10.10:FF:002049', NULL, NULL, 'Os11g0695000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(122557, NULL, 'G3DSA:3.75.10.10:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122558, NULL, 'G3DSA:2.10.25.10:FF:000604', NULL, NULL, 'otogelin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(122559, NULL, 'G3DSA:1.10.8.60:FF:000412', NULL, NULL, 'Peroxisome biogenesis protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(122560, NULL, 'G3DSA:2.120.10.90:FF:000010', NULL, NULL, 'DNA topoisomerase 4 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(122561, NULL, 'G3DSA:3.30.1330.80:FF:000004', NULL, NULL, 'AT-hook motif nuclear-localized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122562, NULL, 'G3DSA:2.10.25.10:FF:000930', NULL, NULL, 'Meprin A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(122563, NULL, 'G3DSA:3.10.280.10:FF:000006', NULL, NULL, 'Mitochondrial glycoprotein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(122564, NULL, 'G3DSA:3.40.50.1220:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122565, NULL, 'G3DSA:2.60.120.200:FF:000816', NULL, NULL, 'Sex hormone-binding globulin', NULL, NULL, NULL, NULL, NULL, 4),
(122566, NULL, 'G3DSA:3.40.50.300:FF:007484', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122567, NULL, 'G3DSA:3.80.10.10:FF:004522', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(122568, NULL, 'G3DSA:3.10.450.700:FF:000006', NULL, NULL, 'Pur alpha Like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(122569, NULL, 'G3DSA:1.20.910.10:FF:000016', NULL, NULL, 'Heme oxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(122570, NULL, 'G3DSA:3.30.160.60:FF:004004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122571, NULL, 'G3DSA:3.30.342.10:FF:000023', NULL, NULL, 'DNA polymerase epsilon catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(122572, NULL, 'G3DSA:3.40.50.720:FF:000921', NULL, NULL, 'Putative short chain dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(122573, NULL, 'G3DSA:3.60.110.10:FF:000006', NULL, NULL, 'Bifunctional nitrilase/nitrile hydratase NIT4B', NULL, NULL, NULL, NULL, NULL, 4),
(122574, NULL, 'G3DSA:3.40.250.10:FF:000251', NULL, NULL, 'probable rhodanese domain-containing dual specificity protein phosphatase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(122575, NULL, 'G3DSA:1.20.5.170:FF:000116', NULL, NULL, 'Transcription regulatory protein SNF2', NULL, NULL, NULL, NULL, NULL, 4),
(122576, NULL, 'G3DSA:2.40.10.340:FF:000011', NULL, NULL, 'Cell shape-determining protein MreC', NULL, NULL, NULL, NULL, NULL, 4),
(122577, NULL, 'G3DSA:1.20.58.1020:FF:000004', NULL, NULL, 'GINS complex protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122578, NULL, 'G3DSA:3.60.10.10:FF:000307', NULL, NULL, 'Endonuclease/Exonuclease/phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(122579, NULL, 'G3DSA:1.10.10.1500:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122580, NULL, 'G3DSA:3.30.160.60:FF:003386', NULL, NULL, 'Endolytic murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(122581, NULL, 'G3DSA:3.30.70.2850:FF:000011', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(122582, NULL, 'G3DSA:3.50.50.60:FF:001000', NULL, NULL, 'Electron-transferring-flavoprotein dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(122583, NULL, 'G3DSA:1.10.510.10:FF:001825', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(122584, NULL, 'G3DSA:2.130.10.10:FF:002987', NULL, NULL, 'YALI0B17798p', NULL, NULL, NULL, NULL, NULL, 4),
(122585, NULL, 'G3DSA:1.20.1070.10:FF:000147', NULL, NULL, 'Histamine H1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(122586, NULL, 'G3DSA:3.80.10.10:FF:002381', NULL, NULL, 'AGAP000340-PA', NULL, NULL, NULL, NULL, NULL, 4),
(122587, NULL, 'G3DSA:3.40.50.300:FF:005354', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122588, NULL, 'G3DSA:1.20.1050.80:FF:000003', NULL, NULL, 'rab5 GDP/GTP exchange factor isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(122589, NULL, 'G3DSA:3.30.70.330:FF:002295', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122590, NULL, 'G3DSA:1.25.40.20:FF:001590', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122591, NULL, 'G3DSA:2.60.120.10:FF:000145', NULL, NULL, 'Vicilin-like antimicrobial peptides 2-2', NULL, NULL, NULL, NULL, NULL, 4),
(122592, NULL, 'G3DSA:3.40.50.10140:FF:000064', NULL, NULL, 'Uncharacterized protein PHLOEM PROTEIN 2-LIKE A7', NULL, NULL, NULL, NULL, NULL, 4),
(122593, NULL, 'G3DSA:1.20.58.1030:FF:000007', NULL, NULL, 'GINS complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(122594, NULL, 'G3DSA:1.20.1250.20:FF:000248', NULL, NULL, 'Inner membrane transporter ydiN', NULL, NULL, NULL, NULL, NULL, 4),
(122595, NULL, 'G3DSA:1.10.890.20:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122596, NULL, 'G3DSA:1.25.40.10:FF:002891', NULL, NULL, 'Fanconi anemia group G protein', NULL, NULL, NULL, NULL, NULL, 4),
(122597, NULL, 'G3DSA:3.30.160.60:FF:005314', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122598, NULL, 'G3DSA:3.50.30.30:FF:000040', NULL, NULL, 'Aminopeptidase YwaD', NULL, NULL, NULL, NULL, NULL, 4),
(122599, NULL, 'G3DSA:2.30.29.30:FF:000197', NULL, NULL, 'obscurin isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(122600, NULL, 'G3DSA:3.40.1360.10:FF:000011', NULL, NULL, 'Type 2 DNA topoisomerase 6 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(122601, NULL, 'G3DSA:3.30.70.270:FF:000337', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122602, NULL, 'G3DSA:3.40.50.10130:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122603, NULL, 'G3DSA:1.20.1050.90:FF:000006', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(122604, NULL, 'G3DSA:3.30.40.10:FF:000496', NULL, NULL, 'E3 ubiquitin-protein ligase RNF185 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(122605, NULL, 'G3DSA:1.20.80.10:FF:000037', NULL, NULL, 'E3 ubiquitin-protein ligase MYLIP-A', NULL, NULL, NULL, NULL, NULL, 4),
(122606, NULL, 'G3DSA:3.30.200.20:FF:001208', NULL, NULL, 'Putative DUF26-domain receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(122607, NULL, 'G3DSA:3.40.50.300:FF:000340', NULL, NULL, 'Bloom syndrome, RecQ helicase', NULL, NULL, NULL, NULL, NULL, 4),
(122608, NULL, 'G3DSA:1.10.10.60:FF:000739', NULL, NULL, 'Arginine-fifty homeobox', NULL, NULL, NULL, NULL, NULL, 4),
(122609, NULL, 'G3DSA:3.20.20.70:FF:000119', NULL, NULL, 'tRNA-dihydrouridine(16) synthase', NULL, NULL, NULL, NULL, NULL, 4),
(122610, NULL, 'G3DSA:2.10.25.10:FF:000711', NULL, NULL, 'Laminin-like protein epi-1', NULL, NULL, NULL, NULL, NULL, 4),
(122611, NULL, 'G3DSA:3.90.1150.10:FF:000462', NULL, NULL, '2''-deamino-2''-hydroxyneamine transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(122612, NULL, 'G3DSA:3.40.50.300:FF:006877', NULL, NULL, 'Type IV secretion system protein VirB4', NULL, NULL, NULL, NULL, NULL, 4),
(122613, NULL, 'G3DSA:3.30.160.60:FF:003279', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122614, NULL, 'G3DSA:1.20.1160.20:FF:000022', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(122615, NULL, 'G3DSA:3.80.10.10:FF:000138', NULL, NULL, 'geranylgeranyl transferase type-2 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(122616, NULL, 'G3DSA:3.30.40.10:FF:000389', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM62', NULL, NULL, NULL, NULL, NULL, 4),
(122617, NULL, 'G3DSA:3.30.160.60:FF:003167', NULL, NULL, 'Zinc finger protein 521', NULL, NULL, NULL, NULL, NULL, 4),
(122618, NULL, 'G3DSA:3.90.70.10:FF:000849', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122619, NULL, 'G3DSA:3.40.50.2000:FF:000366', NULL, NULL, 'Glycoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(122620, NULL, 'G3DSA:3.30.40.10:FF:000277', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(122621, NULL, 'G3DSA:1.25.40.20:FF:001477', NULL, NULL, 'Transient receptor potential cation channel subfamily V member 5', NULL, NULL, NULL, NULL, NULL, 4),
(122622, NULL, 'G3DSA:1.20.1720.10:FF:000096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122623, NULL, 'G3DSA:3.30.70.330:FF:003132', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122624, NULL, 'G3DSA:3.30.160.20:FF:000204', NULL, NULL, 'STAUfen (DsRNA binding protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(122625, NULL, 'G3DSA:2.10.25.10:FF:000823', NULL, NULL, 'Epidermal growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(122626, NULL, 'G3DSA:3.30.1440.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122627, NULL, 'G3DSA:3.30.70.330:FF:003020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122628, NULL, 'G3DSA:1.10.260.40:FF:000084', NULL, NULL, 'Phage repressor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(122629, NULL, 'G3DSA:1.10.132.30:FF:000036', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(122630, NULL, 'G3DSA:2.30.29.30:FF:000433', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(122631, NULL, 'G3DSA:1.10.565.10:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122632, NULL, 'G3DSA:3.40.50.620:FF:000329', NULL, NULL, 'Glutamate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(122633, NULL, 'G3DSA:2.60.40.10:FF:001610', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(122634, NULL, 'G3DSA:3.40.50.300:FF:005135', NULL, NULL, 'Site-determining protein', NULL, NULL, NULL, NULL, NULL, 4),
(122635, NULL, 'G3DSA:1.10.510.10:FF:000988', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(122636, NULL, 'G3DSA:1.10.640.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122637, NULL, 'G3DSA:3.90.340.10:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122638, NULL, 'G3DSA:3.30.1520.10:FF:000072', NULL, NULL, 'YKR078W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(122639, NULL, 'G3DSA:1.25.40.10:FF:002997', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g08510', NULL, NULL, NULL, NULL, NULL, 4),
(122640, NULL, 'G3DSA:1.10.1220.10:FF:000021', NULL, NULL, 'ACP thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(122641, NULL, 'G3DSA:1.20.58.60:FF:000085', NULL, NULL, 'dystonin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(122642, NULL, 'G3DSA:2.130.10.10:FF:001700', NULL, NULL, 'NACHT and WD repeat domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(122643, NULL, 'G3DSA:2.40.50.140:FF:000594', NULL, NULL, 'Ribosomal protein S28e', NULL, NULL, NULL, NULL, NULL, 4),
(122644, NULL, 'G3DSA:3.80.10.10:FF:004409', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122645, NULL, 'G3DSA:3.40.50.720:FF:002158', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(122646, NULL, 'G3DSA:2.10.110.40:FF:000002', NULL, NULL, 'CBN-CBP-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(122647, NULL, 'G3DSA:3.30.160.60:FF:004696', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122648, NULL, 'G3DSA:2.30.42.10:FF:000284', NULL, NULL, 'Inactivation-no-after-potential D protein', NULL, NULL, NULL, NULL, NULL, 4),
(122649, NULL, 'G3DSA:2.60.120.280:FF:000003', NULL, NULL, 'MmsAB operon regulatory protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(122650, NULL, 'G3DSA:3.30.420.10:FF:000019', NULL, NULL, 'RNA exonuclease NEF-sp', NULL, NULL, NULL, NULL, NULL, 4),
(122651, NULL, 'G3DSA:1.10.101.10:FF:000015', NULL, NULL, 'Putative lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(122652, NULL, 'G3DSA:1.10.510.10:FF:003282', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122653, NULL, 'G3DSA:4.10.240.10:FF:000135', NULL, NULL, 'Zinc finger-containing transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122654, NULL, 'G3DSA:3.30.1640.30:FF:000007', NULL, NULL, 'GD17179', NULL, NULL, NULL, NULL, NULL, 4),
(122655, NULL, 'G3DSA:2.60.120.330:FF:000041', NULL, NULL, 'Hyoscyamine 6-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(122656, NULL, 'G3DSA:3.40.720.10:FF:000012', NULL, NULL, 'N-acetylglucosamine-6-sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(122657, NULL, 'G3DSA:1.10.287.70:FF:000671', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(122658, NULL, 'G3DSA:3.40.50.300:FF:007372', NULL, NULL, 'Sulfate adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(122659, NULL, 'G3DSA:2.60.120.380:FF:000027', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122660, NULL, 'G3DSA:1.10.287.70:FF:000339', NULL, NULL, 'polycystic kidney disease 2-like 2 protein isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(122661, NULL, 'G3DSA:1.25.40.10:FF:001255', NULL, NULL, 'Coatomer subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(122662, NULL, 'G3DSA:1.10.287.130:FF:000195', NULL, NULL, 'Hybrid sensory kinase', NULL, NULL, NULL, NULL, NULL, 4),
(122663, NULL, 'G3DSA:3.30.300.30:FF:000073', NULL, NULL, 'Surfactin synthase subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(122664, NULL, 'G3DSA:1.10.8.60:FF:000305', NULL, NULL, 'AAA-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(122665, NULL, 'G3DSA:2.60.120.290:FF:000006', NULL, NULL, 'Mannan-binding lectin serine protease 1', NULL, NULL, NULL, NULL, NULL, 4),
(122666, NULL, 'G3DSA:2.60.40.10:FF:001593', NULL, NULL, 'Isoamylase 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(122667, NULL, 'G3DSA:3.30.160.60:FF:005533', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122668, NULL, 'G3DSA:2.60.40.2860:FF:000018', NULL, NULL, 'Membrane protein pf12', NULL, NULL, NULL, NULL, NULL, 4),
(122669, NULL, 'G3DSA:3.10.400.20:FF:000003', NULL, NULL, 'Eukaryotic translation initiation factor 2D isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(122670, NULL, 'G3DSA:1.20.1270.60:FF:000008', NULL, NULL, 'Sorting nexin', NULL, NULL, NULL, NULL, NULL, 4),
(122671, NULL, 'G3DSA:2.130.10.30:FF:000166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122672, NULL, 'G3DSA:3.40.20.10:FF:000073', NULL, NULL, 'Protein transport protein Sec24C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122673, NULL, 'G3DSA:3.40.50.460:FF:000028', NULL, NULL, 'ATP-dependent 6-phosphofructokinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(122674, NULL, 'G3DSA:2.60.470.10:FF:000025', NULL, NULL, 'Pickpocket 22, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(122675, NULL, 'G3DSA:3.40.50.2300:FF:000574', NULL, NULL, 'Response regulator PleD', NULL, NULL, NULL, NULL, NULL, 4),
(122676, NULL, 'G3DSA:2.60.120.970:FF:000002', NULL, NULL, 'Transforming growth factor beta', NULL, NULL, NULL, NULL, NULL, 4),
(122677, NULL, 'G3DSA:1.25.40.20:FF:001258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122678, NULL, 'G3DSA:1.20.1720.10:FF:000113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122679, NULL, 'G3DSA:3.80.10.10:FF:004179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122680, NULL, 'G3DSA:3.10.129.10:FF:000279', NULL, NULL, 'Acyl-CoA thioesterase 11a', NULL, NULL, NULL, NULL, NULL, 4),
(122681, NULL, 'G3DSA:1.20.1270.50:FF:000005', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(122682, NULL, 'G3DSA:3.30.70.260:FF:000115', NULL, NULL, 'Phenylalanine-4-hydroxylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122683, NULL, 'G3DSA:3.30.559.10:FF:000099', NULL, NULL, 'Nonribosomal peptide synthase SidC', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(122684, NULL, 'G3DSA:1.20.1070.10:FF:000366', NULL, NULL, 'Olfactory receptor family 52 subfamily D member 1', NULL, NULL, NULL, NULL, NULL, 4),
(122685, NULL, 'G3DSA:3.60.20.10:FF:000027', NULL, NULL, 'Proteasome subunit beta type-6', NULL, NULL, NULL, NULL, NULL, 4),
(122686, NULL, 'G3DSA:2.130.10.10:FF:002768', NULL, NULL, 'YALI0A04653p', NULL, NULL, NULL, NULL, NULL, 4),
(122687, NULL, 'G3DSA:1.10.132.70:FF:000020', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(122688, NULL, 'G3DSA:1.10.220.150:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122689, NULL, 'G3DSA:1.25.40.10:FF:004689', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122690, NULL, 'G3DSA:1.10.510.10:FF:001606', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122691, NULL, 'G3DSA:3.30.460.10:FF:000128', NULL, NULL, 'Speckle targeted PIP5K1A-regulated poly(A) polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(122692, NULL, 'G3DSA:3.30.70.1730:FF:000006', NULL, NULL, '39S ribosomal protein L10, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(122693, NULL, 'G3DSA:3.30.200.20:FF:001540', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122694, NULL, 'G3DSA:3.40.50.10190:FF:000051', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(122695, NULL, 'G3DSA:3.30.70.270:FF:000118', NULL, NULL, 'GGDEF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(122696, NULL, 'G3DSA:3.40.50.410:FF:000042', NULL, NULL, 'Copine 4', NULL, NULL, NULL, NULL, NULL, 4),
(122697, NULL, 'G3DSA:3.40.50.620:FF:000661', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122698, NULL, 'G3DSA:3.30.200.20:FF:000933', NULL, NULL, 'CAMK/CAMKL protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(122699, NULL, 'G3DSA:3.30.750.24:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122700, NULL, 'G3DSA:2.60.40.2840:FF:000012', NULL, NULL, 'E3 ubiquitin-protein ligase hecw-1', NULL, NULL, NULL, NULL, NULL, 4),
(122701, NULL, 'G3DSA:3.10.260.10:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122702, NULL, 'G3DSA:2.60.120.200:FF:000362', NULL, NULL, 'Non-reducing end alpha-L-arabinofuranosidase BoGH43A', NULL, NULL, NULL, NULL, NULL, 4),
(122703, NULL, 'G3DSA:2.40.50.140:FF:001212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122704, NULL, 'G3DSA:3.30.420.40:FF:001074', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(122705, NULL, 'G3DSA:3.40.50.2300:FF:001411', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122706, NULL, 'G3DSA:3.30.300.20:FF:000070', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(122707, NULL, 'G3DSA:3.90.190.10:FF:000178', NULL, NULL, 'Dual specificity protein phosphatase putative', NULL, NULL, NULL, NULL, NULL, 4),
(122708, NULL, 'G3DSA:3.80.10.10:FF:002162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122709, NULL, 'G3DSA:3.40.50.450:FF:000025', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(122710, NULL, 'G3DSA:2.160.20.10:FF:000199', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(122711, NULL, 'G3DSA:2.60.40.10:FF:003627', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122712, NULL, 'G3DSA:1.20.1250.10:FF:000133', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122713, NULL, 'G3DSA:1.10.510.10:FF:003843', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122714, NULL, 'G3DSA:1.10.630.10:FF:000244', NULL, NULL, 'Cytochrome P450 family 7 subfamily B member 1', NULL, NULL, NULL, NULL, NULL, 4),
(122715, NULL, 'G3DSA:1.10.357.140:FF:000052', NULL, NULL, 'Os08g0389300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(122716, NULL, 'G3DSA:3.40.50.2000:FF:001080', NULL, NULL, 'Granule-bound starch synthase 1 chloroplastic/amyloplastic', NULL, NULL, NULL, NULL, NULL, 4),
(122717, NULL, 'G3DSA:2.130.10.10:FF:001245', NULL, NULL, 'Putative poly(A) export protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(122718, NULL, 'G3DSA:3.30.900.10:FF:000045', NULL, NULL, 'Mitotic spindle assembly checkpoint protein MAD2B', NULL, NULL, NULL, NULL, NULL, 4),
(122719, NULL, 'G3DSA:1.10.10.10:FF:001135', NULL, NULL, 'Vacuolar protein sorting 36, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122720, NULL, 'G3DSA:2.60.120.260:FF:000464', NULL, NULL, 'Putative beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(122721, NULL, 'G3DSA:3.40.50.300:FF:008569', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122722, NULL, 'G3DSA:3.40.50.300:FF:005915', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122723, NULL, 'G3DSA:1.10.150.670:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122724, NULL, 'G3DSA:1.20.120.1380:FF:000013', NULL, NULL, 'Flagellar GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122725, NULL, 'G3DSA:3.90.180.10:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122726, NULL, 'G3DSA:4.10.1090.10:FF:000002', NULL, NULL, 'Neck appendage protein', NULL, NULL, NULL, NULL, NULL, 4),
(122727, NULL, 'G3DSA:2.40.50.40:FF:000075', NULL, NULL, 'Like heterochromatin protein (LHP1)', NULL, NULL, NULL, NULL, NULL, 4),
(122728, NULL, 'G3DSA:3.40.50.720:FF:002490', NULL, NULL, 'Polyketide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(122729, NULL, 'G3DSA:1.10.8.60:FF:000182', NULL, NULL, 'AAA-type ATPase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(122730, NULL, 'G3DSA:3.40.50.11060:FF:000008', NULL, NULL, 'GTPase HflX', NULL, NULL, NULL, NULL, NULL, 4),
(122731, NULL, 'G3DSA:1.25.40.510:FF:000001', NULL, NULL, 'Nucleoporin GLE1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(122732, NULL, 'G3DSA:2.10.25.10:FF:000368', NULL, NULL, 'Delta-like 3 (Drosophila), isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(122733, NULL, 'G3DSA:2.130.10.10:FF:004898', NULL, NULL, 'Pre-mRNA-processing factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(122734, NULL, 'G3DSA:3.20.20.300:FF:000069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122735, NULL, 'G3DSA:3.30.70.330:FF:003019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122736, NULL, 'G3DSA:3.30.40.10:FF:000732', NULL, NULL, 'Zinc finger FYVE domain-containing protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(122737, NULL, 'G3DSA:3.10.180.10:FF:000078', NULL, NULL, 'Methylmalonyl-CoA epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(122738, NULL, 'G3DSA:2.40.270.10:FF:000014', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(122739, NULL, 'G3DSA:2.40.50.140:FF:000375', NULL, NULL, 'DNA ligase k alpha, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122740, NULL, 'G3DSA:2.60.120.290:FF:000225', NULL, NULL, 'C-type LECtin', NULL, NULL, NULL, NULL, NULL, 4),
(122741, NULL, 'G3DSA:1.25.40.20:FF:001820', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(122742, NULL, 'G3DSA:3.40.50.620:FF:000442', NULL, NULL, 'Asparagine synthetase, glutamine-hydrolyzing', NULL, NULL, NULL, NULL, NULL, 4),
(122743, NULL, 'G3DSA:3.30.160.60:FF:005752', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122744, NULL, 'G3DSA:1.10.10.10:FF:000859', NULL, NULL, 'COP9 signalosome', NULL, NULL, NULL, NULL, NULL, 4),
(122745, NULL, 'G3DSA:1.20.1070.10:FF:002058', NULL, NULL, 'Growth hormone-releasing hormone receptor b', NULL, NULL, NULL, NULL, NULL, 4),
(122746, NULL, 'G3DSA:1.20.1320.30:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122747, NULL, 'G3DSA:3.40.1500.20:FF:000003', NULL, NULL, 'Os10g0389300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(122748, NULL, 'G3DSA:3.40.50.300:FF:003443', NULL, NULL, 'Eukaryotic initiation factor 4A-III', NULL, NULL, NULL, NULL, NULL, 4),
(122749, NULL, 'G3DSA:1.20.990.10:FF:000010', NULL, NULL, 'Sulfite reductase [NADPH] flavoprotein component', NULL, NULL, NULL, NULL, NULL, 4),
(122750, NULL, 'G3DSA:3.20.20.80:FF:000454', NULL, NULL, 'Glycoside hydrolase superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(122751, NULL, 'G3DSA:3.40.50.2300:FF:000793', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(122752, NULL, 'G3DSA:3.40.50.300:FF:000008', NULL, NULL, 'ATP-dependent RNA helicase RhlB', NULL, NULL, NULL, NULL, NULL, 4),
(122753, NULL, 'G3DSA:2.130.10.10:FF:005516', NULL, NULL, 'Small nucleolar ribonucleoprotein complex subunit (Pwp2), putative (AFU_orthologue AFUA_5G03090)', NULL, NULL, NULL, NULL, NULL, 4),
(122754, NULL, 'G3DSA:3.80.10.10:FF:002942', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122755, NULL, 'G3DSA:1.10.3860.10:FF:000007', NULL, NULL, 'Dicarboxylate/amino acid:cation symporter', NULL, NULL, NULL, NULL, NULL, 4),
(122756, NULL, 'G3DSA:3.30.450.20:FF:000182', NULL, NULL, 'Magnesium or manganese-dependent protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(122757, NULL, 'G3DSA:1.10.150.510:FF:000006', NULL, NULL, 'Receptor (G protein-coupled) activity-modifying protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(122758, NULL, 'G3DSA:3.40.50.300:FF:001644', NULL, NULL, 'ABC transporter G family member 5', NULL, NULL, NULL, NULL, NULL, 4),
(122759, NULL, 'G3DSA:1.10.287.70:FF:000340', NULL, NULL, 'ATP-sensitive inward rectifier potassium channel 8', NULL, NULL, NULL, NULL, NULL, 4),
(122760, NULL, 'G3DSA:2.40.50.140:FF:000717', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122761, NULL, 'G3DSA:3.30.40.10:FF:000390', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM50', NULL, NULL, NULL, NULL, NULL, 4),
(122762, NULL, 'G3DSA:1.20.120.1080:FF:000024', NULL, NULL, 'ATP-dependent RNA helicase DHX8', NULL, NULL, NULL, NULL, NULL, 4),
(122763, NULL, 'G3DSA:2.130.10.10:FF:000969', NULL, NULL, 'WD repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(122764, NULL, 'G3DSA:3.30.160.60:FF:003622', NULL, NULL, 'Zinc finger E-box-binding homeobox 2', NULL, NULL, NULL, NULL, NULL, 4),
(122765, NULL, 'G3DSA:3.40.50.80:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122766, NULL, 'G3DSA:1.20.1270.60:FF:000340', NULL, NULL, 'Uncharacterized PH domain-containing protein C19A8.02', NULL, NULL, NULL, NULL, NULL, 4),
(122767, NULL, 'G3DSA:3.80.10.10:FF:000470', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', NULL, NULL, NULL, NULL, NULL, 4),
(122768, NULL, 'G3DSA:2.120.10.30:FF:000594', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122769, NULL, 'G3DSA:1.25.40.10:FF:002559', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At3g18840', NULL, NULL, NULL, NULL, NULL, 4),
(122770, NULL, 'G3DSA:1.20.1050.10:FF:000258', NULL, NULL, 'glutathione S-transferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(122771, NULL, 'G3DSA:3.30.160.20:FF:000081', NULL, NULL, 'Ribonuclease 3', NULL, NULL, NULL, NULL, NULL, 4),
(122772, NULL, 'G3DSA:1.25.40.180:FF:000295', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122773, NULL, 'G3DSA:3.20.20.140:FF:000094', NULL, NULL, 'Probable antibiotic-resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(122774, NULL, 'G3DSA:3.90.190.10:FF:000291', NULL, NULL, 'Dual specificity protein phosphatase CDC14A-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(122775, NULL, 'G3DSA:3.40.50.720:FF:000691', NULL, NULL, 'NAD-dependent alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(122776, NULL, 'G3DSA:3.30.160.60:FF:001481', NULL, NULL, 'zinc finger protein 696', NULL, NULL, NULL, NULL, NULL, 4),
(122777, NULL, 'G3DSA:3.40.50.11040:FF:000002', NULL, NULL, 'RNA cytidine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(122778, NULL, 'G3DSA:2.60.40.10:FF:005207', NULL, NULL, 'Alpha-amylase SusG', NULL, NULL, NULL, NULL, NULL, 4),
(122779, NULL, 'G3DSA:3.40.850.10:FF:000235', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(122780, NULL, 'G3DSA:3.30.40.10:FF:000058', NULL, NULL, 'E3 ubiquitin-protein ligase Arkadia isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(122781, NULL, 'G3DSA:3.30.530.20:FF:000002', NULL, NULL, 'Coenzyme Q-binding protein COQ10 homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(122782, NULL, 'G3DSA:1.10.8.10:FF:000083', NULL, NULL, 'Ubiquitin-conjugating enzyme E2', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(122783, NULL, 'G3DSA:3.40.50.10330:FF:000020', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(122784, NULL, 'G3DSA:2.60.40.10:FF:002211', NULL, NULL, 'GL25248', NULL, NULL, NULL, NULL, NULL, 4),
(122785, NULL, 'G3DSA:1.20.1740.10:FF:000108', NULL, NULL, 'Serine transporter', NULL, NULL, NULL, NULL, NULL, 4),
(122786, NULL, 'G3DSA:1.20.58.530:FF:000010', NULL, NULL, 'Myosin IIIA', NULL, NULL, NULL, NULL, NULL, 4),
(122787, NULL, 'G3DSA:3.40.720.10:FF:000231', NULL, NULL, 'Non-specific phospholipase C4', NULL, NULL, NULL, NULL, NULL, 4),
(122788, NULL, 'G3DSA:2.30.29.30:FF:000652', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(122789, NULL, 'G3DSA:1.10.10.60:FF:001234', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122790, NULL, 'G3DSA:1.20.920.20:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122791, NULL, 'G3DSA:1.10.287.10:FF:000018', NULL, NULL, 'Ataxin-3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(122792, NULL, 'G3DSA:3.30.420.10:FF:000351', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(122793, NULL, 'G3DSA:2.40.50.90:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122794, NULL, 'G3DSA:3.90.640.10:FF:000270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122795, NULL, 'G3DSA:3.40.50.300:FF:001189', NULL, NULL, 'DAR GTPase 3 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(122796, NULL, 'G3DSA:1.20.1080.10:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122797, NULL, 'G3DSA:1.25.10.10:FF:003007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122798, NULL, 'G3DSA:1.10.1040.10:FF:000035', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(122799, NULL, 'G3DSA:3.90.380.10:FF:000007', NULL, NULL, 'Naphthalene 1,2-dioxygenase system, large oxygenase component', NULL, NULL, NULL, NULL, NULL, 4),
(122800, NULL, 'G3DSA:2.20.110.10:FF:000064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122801, NULL, 'G3DSA:1.50.40.10:FF:000224', NULL, NULL, 'WGS project CABT00000000 data, contig 2.3', NULL, NULL, NULL, NULL, NULL, 4),
(122802, NULL, 'G3DSA:3.50.50.60:FF:000269', NULL, NULL, 'FAD-dependent urate hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(122803, NULL, 'G3DSA:3.40.50.1010:FF:000153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122804, NULL, 'G3DSA:1.25.40.10:FF:003615', NULL, NULL, 'Pentatricopeptide repeat-containing protein 10, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(122805, NULL, 'G3DSA:1.20.920.10:FF:000062', NULL, NULL, 'RSC complex member', NULL, NULL, NULL, NULL, NULL, 4),
(122806, NULL, 'G3DSA:2.60.40.10:FF:005645', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122807, NULL, 'G3DSA:3.40.50.410:FF:000261', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(122808, NULL, 'G3DSA:3.30.70.330:FF:001002', NULL, NULL, 'Multiple RNA-binding domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(122809, NULL, 'G3DSA:3.20.20.70:FF:000451', NULL, NULL, 'N-(5''-phosphoribosyl)anthranilate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(122810, NULL, 'G3DSA:1.10.8.480:FF:000003', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(122811, NULL, 'G3DSA:3.40.50.150:FF:001672', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122812, NULL, 'G3DSA:1.10.600.10:FF:000074', NULL, NULL, 'NADH dehydrogenase (ubiquinone) complex I, assembly factor 6 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(122813, NULL, 'G3DSA:3.60.21.10:FF:000102', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(122814, NULL, 'G3DSA:3.30.9.10:FF:000204', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(122815, NULL, 'G3DSA:1.10.4030.10:FF:000001', NULL, NULL, 'Chaperone SurA', NULL, NULL, NULL, NULL, NULL, 4),
(122816, NULL, 'G3DSA:1.25.40.10:FF:003273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(122817, NULL, 'G3DSA:3.80.10.10:FF:000812', NULL, NULL, 'Zinc finger protein family member, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122818, NULL, 'G3DSA:1.10.238.110:FF:000005', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(122819, NULL, 'G3DSA:3.30.160.60:FF:003280', NULL, NULL, 'Zinc finger protein 586', NULL, NULL, NULL, NULL, NULL, 4),
(122820, NULL, 'G3DSA:3.20.20.70:FF:000013', NULL, NULL, 'Class II fructose-bisphosphate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(122821, NULL, 'G3DSA:1.10.4160.10:FF:000005', NULL, NULL, 'Thiamine transporter', NULL, NULL, NULL, NULL, NULL, 4),
(122822, NULL, 'G3DSA:1.10.287.470:FF:000055', NULL, NULL, 'RND family resistance-nodulation-cell division efflux pump', NULL, NULL, NULL, NULL, NULL, 4),
(122823, NULL, 'G3DSA:2.60.40.10:FF:001374', NULL, NULL, 'Echinoid, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(122824, NULL, 'G3DSA:3.30.565.10:FF:000389', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(122825, NULL, 'G3DSA:3.30.450.20:FF:000524', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(122826, NULL, 'G3DSA:1.20.1050.130:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122827, NULL, 'G3DSA:1.20.58.1710:FF:000003', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 8', NULL, NULL, NULL, NULL, NULL, 4),
(122828, NULL, 'G3DSA:4.10.770.10:FF:000001', NULL, NULL, 'Runt-related transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(122829, NULL, 'G3DSA:2.60.120.10:FF:000600', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122830, NULL, 'G3DSA:1.20.1250.20:FF:000810', NULL, NULL, 'Protein CBG12142', NULL, NULL, NULL, NULL, NULL, 4),
(122831, NULL, 'G3DSA:3.80.10.10:FF:002268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122832, NULL, 'G3DSA:2.30.40.10:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122833, NULL, 'G3DSA:1.20.970.10:FF:000008', NULL, NULL, 'Anthranilate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(122834, NULL, 'G3DSA:3.30.160.60:FF:001149', NULL, NULL, 'Zinc finger protein 571', NULL, NULL, NULL, NULL, NULL, 4),
(122835, NULL, 'G3DSA:3.50.50.60:FF:001106', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(122836, NULL, 'G3DSA:1.20.1270.60:FF:000121', NULL, NULL, 'GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122837, NULL, 'G3DSA:3.30.450.20:FF:000069', NULL, NULL, 'Aryl hydrocarbon receptor', NULL, NULL, NULL, NULL, NULL, 4),
(122838, NULL, 'G3DSA:1.10.3460.10:FF:000039', NULL, NULL, 'Fucoxanthin chl a/c protein, lhca clade', NULL, NULL, NULL, NULL, NULL, 4),
(122839, NULL, 'G3DSA:2.60.40.10:FF:001716', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(122840, NULL, 'G3DSA:3.40.630.30:FF:000011', NULL, NULL, 'Diamine acetyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(122841, NULL, 'G3DSA:3.50.50.60:FF:000488', NULL, NULL, '2-octaprenyl-6-methoxyphenyl hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(122842, NULL, 'G3DSA:3.90.190.10:FF:000072', NULL, NULL, 'Phosphoglucan phosphatase LSF1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(122843, NULL, 'G3DSA:3.30.70.330:FF:000726', NULL, NULL, 'UBP1-associated protein 2A', NULL, NULL, NULL, NULL, NULL, 4),
(122844, NULL, 'G3DSA:3.40.720.10:FF:000118', NULL, NULL, 'Lipid A phosphoethanolamine transferase', NULL, NULL, NULL, NULL, NULL, 4),
(122845, NULL, 'G3DSA:1.10.720.30:FF:000010', NULL, NULL, 'SAFB-like transcription modulator isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(122846, NULL, 'G3DSA:1.10.510.10:FF:003405', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122847, NULL, 'G3DSA:1.20.1280.120:FF:000002', NULL, NULL, 'Catalase-related peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(122848, NULL, 'G3DSA:1.10.510.10:FF:002787', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122849, NULL, 'G3DSA:3.40.50.150:FF:001453', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(122850, NULL, 'G3DSA:1.20.1280.130:FF:000005', NULL, NULL, 'Putative vacuolar sorting protein vps45', NULL, NULL, NULL, NULL, NULL, 4),
(122851, NULL, 'G3DSA:3.20.20.60:FF:000010', NULL, NULL, 'Phosphoenolpyruvate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(122852, NULL, 'G3DSA:1.20.1260.10:FF:000072', NULL, NULL, 'Dichlorochromopyrrolate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(122853, NULL, 'G3DSA:3.90.190.10:FF:000414', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122854, NULL, 'G3DSA:2.10.110.10:FF:000347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122855, NULL, 'G3DSA:3.60.60.10:FF:000024', NULL, NULL, 'Secernin 2', NULL, NULL, NULL, NULL, NULL, 4),
(122856, NULL, 'G3DSA:3.30.1370.210:FF:000014', NULL, NULL, 'Muscleblind-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(122857, NULL, 'G3DSA:1.20.1250.20:FF:002047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122858, NULL, 'G3DSA:3.40.50.150:FF:000958', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122859, NULL, 'G3DSA:2.30.29.30:FF:000539', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(122860, NULL, 'G3DSA:1.10.510.10:FF:003063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122861, NULL, 'G3DSA:1.25.10.10:FF:001427', NULL, NULL, 'STU2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(122862, NULL, 'G3DSA:3.20.20.140:FF:000217', NULL, NULL, 'Dihydropyrimidinase-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(122863, NULL, 'G3DSA:3.60.40.10:FF:000135', NULL, NULL, 'Ser/Thr phosphatase 2C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122864, NULL, 'G3DSA:2.130.10.10:FF:004679', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122865, NULL, 'G3DSA:3.40.50.10380:FF:000006', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(122866, NULL, 'G3DSA:3.40.50.1820:FF:000531', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(122867, NULL, 'G3DSA:1.25.10.10:FF:001085', NULL, NULL, 'HEAT repeat-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(122868, NULL, 'G3DSA:3.30.160.60:FF:005297', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122869, NULL, 'G3DSA:3.30.70.3270:FF:000007', NULL, NULL, 'NADH-quinone oxidoreductase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(122870, NULL, 'G3DSA:3.40.850.10:FF:000454', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(122871, NULL, 'G3DSA:1.20.1740.10:FF:000221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122872, NULL, 'G3DSA:3.90.190.20:FF:000075', NULL, NULL, 'FolC bifunctional protein', NULL, NULL, NULL, NULL, NULL, 4),
(122873, NULL, 'G3DSA:3.40.50.410:FF:000148', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(122874, NULL, 'G3DSA:2.60.40.150:FF:000101', NULL, NULL, 'Synaptotagmin 13', NULL, NULL, NULL, NULL, NULL, 4),
(122875, NULL, 'G3DSA:3.40.1110.10:FF:000190', NULL, NULL, 'Copper-transporting ATPase RAN1', NULL, NULL, NULL, NULL, NULL, 4),
(122876, NULL, 'G3DSA:3.30.40.10:FF:002188', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(122877, NULL, 'G3DSA:2.60.40.10:FF:000879', NULL, NULL, 'Colony stimulating factor 3 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(122878, NULL, 'G3DSA:4.10.640.40:FF:000006', NULL, NULL, 'Cytoplasmic polyadenylation element-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(122879, NULL, 'G3DSA:1.10.10.60:FF:000958', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122880, NULL, 'G3DSA:1.20.1070.10:FF:000821', NULL, NULL, 'AGAP008703-PA', NULL, NULL, NULL, NULL, NULL, 4),
(122881, NULL, 'G3DSA:3.30.200.20:FF:001085', NULL, NULL, 'serine/threonine-protein kinase 10 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(122882, NULL, 'G3DSA:1.10.630.10:FF:000463', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122883, NULL, 'G3DSA:1.10.10.350:FF:000018', NULL, NULL, 'Glutamate--tRNA ligase 2', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(122884, NULL, 'G3DSA:3.90.1220.10:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122885, NULL, 'G3DSA:1.20.58.60:FF:000540', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122886, NULL, 'G3DSA:1.20.120.1630:FF:000009', NULL, NULL, 'C-14 sterol reductase', NULL, NULL, NULL, NULL, NULL, 4),
(122887, NULL, 'G3DSA:3.40.50.1460:FF:000046', NULL, NULL, 'Putative inactive caspase B', NULL, NULL, NULL, NULL, NULL, 4),
(122888, NULL, 'G3DSA:2.60.40.10:FF:001155', NULL, NULL, 'Down syndrome cell adhesion molecule 4, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(122889, NULL, 'G3DSA:3.30.1330.40:FF:000021', NULL, NULL, 'ATP binding L-PSP endoribonuclease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(122890, NULL, 'G3DSA:1.20.1050.10:FF:000039', NULL, NULL, 'Glutathione S-transferase theta-1', NULL, NULL, NULL, NULL, NULL, 4),
(122891, NULL, 'G3DSA:1.10.630.10:FF:000805', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122892, NULL, 'G3DSA:2.30.42.10:FF:000407', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122893, NULL, 'G3DSA:1.10.287.3990:FF:000005', NULL, NULL, '26S proteasome regulatory subunit RPN10', NULL, NULL, NULL, NULL, NULL, 4),
(122894, NULL, 'G3DSA:3.40.50.720:FF:001995', NULL, NULL, 'Blr6358 protein', NULL, NULL, NULL, NULL, NULL, 4),
(122895, NULL, 'G3DSA:2.130.10.10:FF:001464', NULL, NULL, 'Ubiquitin-binding TORC1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(122896, NULL, 'G3DSA:3.40.50.300:FF:001863', NULL, NULL, 'Heparan sulfate 2-o-sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(122897, NULL, 'G3DSA:2.60.120.680:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122898, NULL, 'G3DSA:3.40.50.2000:FF:000585', NULL, NULL, 'Beta-1,6-galactofuranosyltransferase WbbI', NULL, NULL, NULL, NULL, NULL, 4),
(122899, NULL, 'G3DSA:3.30.160.60:FF:005078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122900, NULL, 'G3DSA:3.60.40.10:FF:000354', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122901, NULL, 'G3DSA:2.130.10.10:FF:005174', NULL, NULL, 'AGAP006092-PA', NULL, NULL, NULL, NULL, NULL, 4),
(122902, NULL, 'G3DSA:3.30.930.10:FF:000215', NULL, NULL, 'Proline--tRNA ligase cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(122903, NULL, 'G3DSA:2.60.40.420:FF:000216', NULL, NULL, 'Laccase family multicopper oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(122904, NULL, 'G3DSA:1.10.287.3980:FF:000002', NULL, NULL, '50S ribosomal protein L34', NULL, NULL, NULL, NULL, NULL, 4),
(122905, NULL, 'G3DSA:3.40.309.10:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122906, NULL, 'G3DSA:3.40.50.800:FF:000052', NULL, NULL, 'Glycine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(122907, NULL, 'G3DSA:3.20.20.80:FF:000235', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(122908, NULL, 'G3DSA:1.50.40.10:FF:000005', NULL, NULL, 'Mitochondrial phosphate carrier protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(122909, NULL, 'G3DSA:1.10.472.10:FF:000657', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122910, NULL, 'G3DSA:3.30.70.330:FF:001221', NULL, NULL, 'Ras-Gtpase-activating protein SH3 (Three) domain-Binding Protein', NULL, NULL, NULL, NULL, NULL, 4),
(122911, NULL, 'G3DSA:2.30.31.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122912, NULL, 'G3DSA:3.40.30.10:FF:000023', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(122913, NULL, 'G3DSA:1.10.150.20:FF:000098', NULL, NULL, 'RNA polymerase alpha subunit domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(122914, NULL, 'G3DSA:3.40.50.10490:FF:000040', NULL, NULL, 'RpiR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(122915, NULL, 'G3DSA:1.20.120.550:FF:000004', NULL, NULL, 'Microsomal glutathione S-transferase 3', NULL, NULL, NULL, NULL, NULL, 4),
(122916, NULL, 'G3DSA:1.20.1250.20:FF:002266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(122917, NULL, 'G3DSA:1.10.565.10:FF:000002', NULL, NULL, 'Retinoic acid receptor RXR-alpha', NULL, NULL, NULL, NULL, NULL, 4),
(122918, NULL, 'G3DSA:3.40.50.300:FF:005573', NULL, NULL, 'C-1-tetrahydrofolate synthase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(122919, NULL, 'G3DSA:3.10.580.10:FF:000046', NULL, NULL, 'SNF1-related protein kinase regulatory subunit gamma-1-like', NULL, NULL, NULL, NULL, NULL, 4),
(122920, NULL, 'G3DSA:3.30.60.90:FF:000026', NULL, NULL, 'Unplaced genomic scaffold supercont1.170, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(122921, NULL, 'G3DSA:3.30.420.10:FF:000132', NULL, NULL, 'CAF1 family ribonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122922, NULL, 'G3DSA:2.130.10.10:FF:001806', NULL, NULL, 'U4/U6 small nuclear ribonuclear protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122923, NULL, 'G3DSA:3.40.1180.10:FF:000025', NULL, NULL, 'Alkyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(122924, NULL, 'G3DSA:3.20.20.70:FF:000232', NULL, NULL, 'Deoxyribose-phosphate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(122925, NULL, 'G3DSA:2.60.40.10:FF:004589', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122926, NULL, 'G3DSA:3.40.50.720:FF:002271', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(122927, NULL, 'G3DSA:3.30.70.330:FF:000945', NULL, NULL, 'Os04g0682400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(122928, NULL, 'G3DSA:1.20.1560.10:FF:000673', NULL, NULL, 'Uncharacterized protein TagC', NULL, NULL, NULL, NULL, NULL, 4),
(122929, NULL, 'G3DSA:3.40.50.720:FF:000578', NULL, NULL, '3-ketodihydrosphingosine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(122930, NULL, 'G3DSA:3.30.160.60:FF:001368', NULL, NULL, 'Zinc finger protein 547', NULL, NULL, NULL, NULL, NULL, 4),
(122931, NULL, 'G3DSA:1.20.120.540:FF:000001', NULL, NULL, 'Blast:Putative inorganic phosphate cotransporter', NULL, NULL, NULL, NULL, NULL, 4),
(122932, NULL, 'G3DSA:2.10.25.10:FF:000751', NULL, NULL, 'Crumbs family member 1, photoreceptor morphogenesis associated', NULL, NULL, NULL, NULL, NULL, 4),
(122933, NULL, 'G3DSA:3.40.50.150:FF:000037', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase J', NULL, NULL, NULL, NULL, NULL, 4),
(122934, NULL, 'G3DSA:3.30.540.30:FF:000012', NULL, NULL, 'Dipeptidyl peptidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(122935, NULL, 'G3DSA:3.30.70.330:FF:000884', NULL, NULL, 'Nucleotide/nucleic acid binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(122936, NULL, 'G3DSA:2.130.10.10:FF:005360', NULL, NULL, 'WD repeat-containing protein 91 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(122937, NULL, 'G3DSA:1.10.287.850:FF:000001', NULL, NULL, 'PE_PGRS39', NULL, NULL, NULL, NULL, NULL, 4),
(122938, NULL, 'G3DSA:3.30.565.10:FF:000524', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(122939, NULL, 'G3DSA:2.30.30.140:FF:000290', NULL, NULL, 'AT14886p', NULL, NULL, NULL, NULL, NULL, 4),
(122940, NULL, 'G3DSA:2.70.130.10:FF:000105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122941, NULL, 'G3DSA:1.25.10.10:FF:000916', NULL, NULL, 'AGAP003548-PA', NULL, NULL, NULL, NULL, NULL, 4),
(122942, NULL, 'G3DSA:3.90.79.10:FF:000004', NULL, NULL, 'NADH pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(122943, NULL, 'G3DSA:3.40.50.2000:FF:001024', NULL, NULL, 'Os02g0206400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(122944, NULL, 'G3DSA:3.30.420.310:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122945, NULL, 'G3DSA:1.25.40.470:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122946, NULL, 'G3DSA:2.60.120.200:FF:000429', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(122947, NULL, 'G3DSA:1.10.510.10:FF:000028', NULL, NULL, 'serine/threonine-protein kinase D6PK-like', NULL, NULL, NULL, NULL, NULL, 4),
(122948, NULL, 'G3DSA:3.90.70.10:FF:000423', NULL, NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', NULL, NULL, NULL, NULL, NULL, 4),
(122949, NULL, 'G3DSA:2.130.10.10:FF:000037', NULL, NULL, 'Putative echinoderm microtubule-associated protein-like 6', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(122950, NULL, 'G3DSA:3.30.160.20:FF:000076', NULL, NULL, 'Class I peptide chain release factor', NULL, NULL, NULL, NULL, NULL, 4),
(122951, NULL, 'G3DSA:3.30.160.60:FF:005944', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122952, NULL, 'G3DSA:1.10.730.10:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122953, NULL, 'G3DSA:3.30.70.330:FF:000412', NULL, NULL, 'Mitochondrial ribosomal protein L23, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122954, NULL, 'G3DSA:3.10.100.10:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122955, NULL, 'G3DSA:3.30.450.20:FF:000356', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(122956, NULL, 'G3DSA:3.30.559.10:FF:000111', NULL, NULL, 'Trichothecene 3-O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(122957, NULL, 'G3DSA:1.10.8.10:FF:000224', NULL, NULL, 'GH08043p', NULL, NULL, NULL, NULL, NULL, 4),
(122958, NULL, 'G3DSA:3.40.50.1100:FF:000248', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(122959, NULL, 'G3DSA:3.90.70.10:FF:000895', NULL, NULL, 'Uncharacterized protein AT4g22410', NULL, NULL, NULL, NULL, NULL, 4),
(122960, NULL, 'G3DSA:3.90.550.10:FF:000752', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122961, NULL, 'G3DSA:3.40.50.300:FF:001532', NULL, NULL, 'Translation elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(122962, NULL, 'G3DSA:1.10.10.140:FF:000007', NULL, NULL, 'Cytochrome oxidase c subunit VIb', NULL, NULL, NULL, NULL, NULL, 4),
(122963, NULL, 'G3DSA:3.40.50.1440:FF:000092', NULL, NULL, 'Putative delta-like tubulin', NULL, NULL, NULL, NULL, NULL, 4),
(122964, NULL, 'G3DSA:2.30.29.30:FF:000299', NULL, NULL, 'SH2B adapter protein 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(122965, NULL, 'G3DSA:3.30.200.20:FF:000164', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(122966, NULL, 'G3DSA:3.30.200.20:FF:001153', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122967, NULL, 'G3DSA:1.10.1420.10:FF:000149', NULL, NULL, 'DNA mismatch repair protein Msh2', NULL, NULL, NULL, NULL, NULL, 4),
(122968, NULL, 'G3DSA:1.25.10.10:FF:001905', NULL, NULL, 'Proteasome-associated protein ECM29 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(122969, NULL, 'G3DSA:1.25.40.10:FF:005095', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g32415, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(122970, NULL, 'G3DSA:3.30.2160.10:FF:000022', NULL, NULL, 'E3 ubiquitin-protein ligase HECTD1', NULL, NULL, NULL, NULL, NULL, 4),
(122971, NULL, 'G3DSA:3.80.10.10:FF:000116', NULL, NULL, 'Leucine-rich repeat-containing protein 40', NULL, NULL, NULL, NULL, NULL, 4),
(122972, NULL, 'G3DSA:3.40.50.300:FF:001971', NULL, NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(122973, NULL, 'G3DSA:1.20.5.1430:FF:000004', NULL, NULL, 'Microtubule-associated protein RP/EB family member 1B', NULL, NULL, NULL, NULL, NULL, 4),
(122974, NULL, 'G3DSA:1.10.8.1310:FF:000004', NULL, NULL, 'GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(122975, NULL, 'G3DSA:2.10.90.10:FF:000177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122976, NULL, 'G3DSA:1.20.1250.20:FF:002317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122977, NULL, 'G3DSA:2.20.110.10:FF:000008', NULL, NULL, 'Junctophilin', NULL, NULL, NULL, NULL, NULL, 4),
(122978, NULL, 'G3DSA:2.30.30.1150:FF:000007', NULL, NULL, 'RING/FYVE/PHD-type zinc finger family protein', NULL, NULL, NULL, NULL, NULL, 4),
(122979, NULL, 'G3DSA:3.40.50.1000:FF:000044', NULL, NULL, 'CTD nuclear envelope phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(122980, NULL, 'G3DSA:3.80.10.10:FF:001105', NULL, NULL, 'Leucine rich repeat protein phosphatase 2c domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(122981, NULL, 'G3DSA:3.30.70.330:FF:001401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(122982, NULL, 'G3DSA:2.130.10.10:FF:004371', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122983, NULL, 'G3DSA:1.25.40.10:FF:003650', NULL, NULL, 'Tetratricopeptide repeat protein 37', NULL, NULL, NULL, NULL, NULL, 4),
(122984, NULL, 'G3DSA:2.60.40.790:FF:000013', NULL, NULL, 'Very-long-chain (3R)-3-hydroxyacyl-CoA dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(122985, NULL, 'G3DSA:3.80.10.10:FF:004450', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(122986, NULL, 'G3DSA:1.10.510.10:FF:001017', NULL, NULL, 'SPA1-related 4', NULL, NULL, NULL, NULL, NULL, 4),
(122987, NULL, 'G3DSA:3.40.50.300:FF:005714', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(122988, NULL, 'G3DSA:3.30.160.60:FF:004163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122989, NULL, 'G3DSA:1.10.287.70:FF:000498', NULL, NULL, 'Inward rectifier potassium channel Kirbac3.1', NULL, NULL, NULL, NULL, NULL, 4),
(122990, NULL, 'G3DSA:2.130.10.10:FF:001818', NULL, NULL, 'WD domain, G-beta repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(122991, NULL, 'G3DSA:3.30.70.3550:FF:000002', NULL, NULL, 'Leucyl/phenylalanyl-tRNA--protein transferase', NULL, NULL, NULL, NULL, NULL, 4),
(122992, NULL, 'G3DSA:1.25.40.20:FF:001562', NULL, NULL, 'Ankyrin repeat domain 6', NULL, NULL, NULL, NULL, NULL, 4),
(122993, NULL, 'G3DSA:3.40.50.150:FF:001818', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(122994, NULL, 'G3DSA:3.60.40.10:FF:000107', NULL, NULL, 'Protein phosphatase 2C 21', NULL, NULL, NULL, NULL, NULL, 4),
(122995, NULL, 'G3DSA:3.40.50.1460:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(122996, NULL, 'G3DSA:3.30.559.70:FF:000022', NULL, NULL, 'Choline O-acyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122997, NULL, 'G3DSA:1.20.1250.20:FF:000991', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(122998, NULL, 'G3DSA:1.20.1310.20:FF:000018', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(122999, NULL, 'G3DSA:1.50.10.10:FF:000032', NULL, NULL, 'Vacuolar acid trehalase', NULL, NULL, NULL, NULL, NULL, 4),
(123000, NULL, 'G3DSA:2.40.50.140:FF:000746', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123001, NULL, 'G3DSA:3.20.20.70:FF:000486', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123002, NULL, 'G3DSA:3.80.10.10:FF:000588', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(123003, NULL, 'G3DSA:1.25.10.10:FF:002041', NULL, NULL, 'Cytoskeleton-associated protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(123004, NULL, 'G3DSA:3.40.50.2000:FF:000035', NULL, NULL, 'Trehalose-6-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(123005, NULL, 'G3DSA:1.20.1560.10:FF:000472', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123006, NULL, 'G3DSA:3.40.420.10:FF:000001', NULL, NULL, 'Ricin', NULL, NULL, NULL, NULL, NULL, 4),
(123007, NULL, 'G3DSA:3.30.10.20:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123008, NULL, 'G3DSA:1.20.1160.11:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123009, NULL, 'G3DSA:3.90.215.10:FF:000018', NULL, NULL, 'Techylectin-5A', NULL, NULL, NULL, NULL, NULL, 4),
(123010, NULL, 'G3DSA:3.60.110.10:FF:000001', NULL, NULL, 'biotinidase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(123011, NULL, 'G3DSA:1.10.287.110:FF:000072', NULL, NULL, 'DnaJ family protein', NULL, NULL, NULL, NULL, NULL, 4),
(123012, NULL, 'G3DSA:3.30.1360.20:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123013, NULL, 'G3DSA:3.40.50.300:FF:007159', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(123014, NULL, 'G3DSA:1.20.144.10:FF:000079', NULL, NULL, 'Glucose-6-phosphatase a, catalytic subunit, tandem duplicate 1', NULL, NULL, NULL, NULL, NULL, 4),
(123015, NULL, 'G3DSA:3.40.850.10:FF:000230', NULL, NULL, 'Kinesin-5', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(123016, NULL, 'G3DSA:3.30.160.60:FF:006080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123017, NULL, 'G3DSA:3.30.1330.40:FF:000044', NULL, NULL, 'Ribonuclease UK114', NULL, NULL, NULL, NULL, NULL, 4),
(123018, NULL, 'G3DSA:1.10.8.60:FF:000278', NULL, NULL, 'Smallminded, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(123019, NULL, 'G3DSA:3.50.30.30:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123020, NULL, 'G3DSA:3.30.70.20:FF:000035', NULL, NULL, 'Iron hydrogenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(123021, NULL, 'G3DSA:2.60.40.10:FF:005495', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123022, NULL, 'G3DSA:3.30.70.1230:FF:000273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123023, NULL, 'G3DSA:2.10.70.20:FF:000004', NULL, NULL, 'Type II secretion system protein J', NULL, NULL, NULL, NULL, NULL, 4),
(123024, NULL, 'G3DSA:3.40.50.10240:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123025, NULL, 'G3DSA:1.10.287.130:FF:000078', NULL, NULL, 'Heme sensor histidine kinase HssS', NULL, NULL, NULL, NULL, NULL, 4),
(123026, NULL, 'G3DSA:3.40.50.620:FF:000049', NULL, NULL, 'Probable glutamine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(123027, NULL, 'G3DSA:2.130.10.10:FF:005208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123028, NULL, 'G3DSA:3.30.930.10:FF:000076', NULL, NULL, 'Threonine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(123029, NULL, 'G3DSA:1.25.10.10:FF:001052', NULL, NULL, 'Pumilio domain-containing protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(123030, NULL, 'G3DSA:3.80.10.10:FF:002533', NULL, NULL, 'F-box and leucine rich repeat protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(123031, NULL, 'G3DSA:2.60.40.10:FF:000352', NULL, NULL, 'Cell adhesion molecule-related/down-regulated by oncogenes', NULL, NULL, NULL, NULL, NULL, 4),
(123032, NULL, 'G3DSA:2.30.170.20:FF:000001', NULL, NULL, 'probable ribosome biogenesis protein RLP24', NULL, NULL, NULL, NULL, NULL, 4),
(123033, NULL, 'G3DSA:1.20.960.10:FF:000003', NULL, NULL, 'Translocase of outer mitochondrial membrane 20 like', NULL, NULL, NULL, NULL, NULL, 4),
(123034, NULL, 'G3DSA:4.10.60.10:FF:000064', NULL, NULL, 'Unplaced genomic scaffold supercont1.38, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(123035, NULL, 'G3DSA:2.130.10.10:FF:003382', NULL, NULL, 'Syntaxin-binding protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(123036, NULL, 'G3DSA:3.30.70.1660:FF:000020', NULL, NULL, 'Peptide chain release factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(123037, NULL, 'G3DSA:3.40.50.1220:FF:000138', NULL, NULL, 'Sirtuin 1', NULL, NULL, NULL, NULL, NULL, 4),
(123038, NULL, 'G3DSA:3.20.20.190:FF:000087', NULL, NULL, 'Glycerophosphodiester phosphodiesterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(123039, NULL, 'G3DSA:1.10.1200.10:FF:000138', NULL, NULL, 'Nonribosomal peptide synthase, putative (JCVI)', NULL, NULL, NULL, NULL, NULL, 4),
(123040, NULL, 'G3DSA:2.30.42.10:FF:000638', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123041, NULL, 'G3DSA:3.40.50.150:FF:001465', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123042, NULL, 'G3DSA:3.40.50.300:FF:007631', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123043, NULL, 'G3DSA:1.25.40.20:FF:000101', NULL, NULL, 'Transient receptor potential cation channel subfamily V member 3', NULL, NULL, NULL, NULL, NULL, 4),
(123044, NULL, 'G3DSA:2.60.40.1960:FF:000007', NULL, NULL, 'Nothepsin', NULL, NULL, NULL, NULL, NULL, 4),
(123045, NULL, 'G3DSA:3.40.50.720:FF:002350', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(123046, NULL, 'G3DSA:1.25.10.10:FF:000063', NULL, NULL, 'Putative cytoskeleton-associated protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(123047, NULL, 'G3DSA:3.30.1370.10:FF:000094', NULL, NULL, 'Exosome complex component RRP40, putative', NULL, NULL, NULL, NULL, NULL, 4),
(123048, NULL, 'G3DSA:1.10.10.60:FF:000026', NULL, NULL, 'Nuclear receptor corepressor 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(123049, NULL, 'G3DSA:3.80.10.10:FF:003022', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(123050, NULL, 'G3DSA:3.40.50.2300:FF:000827', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123051, NULL, 'G3DSA:3.60.10.10:FF:000398', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123052, NULL, 'G3DSA:1.20.1110.10:FF:000213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123053, NULL, 'G3DSA:3.30.160.60:FF:000773', NULL, NULL, 'Zinc finger protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(123054, NULL, 'G3DSA:3.55.50.30:FF:000020', NULL, NULL, 'Fec operon regulator FecR', NULL, NULL, NULL, NULL, NULL, 4),
(123055, NULL, 'G3DSA:3.30.420.40:FF:000714', NULL, NULL, 'Actin-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(123056, NULL, 'G3DSA:1.20.1050.10:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123057, NULL, 'G3DSA:2.170.300.10:FF:000044', NULL, NULL, 'Multiple epidermal growth factor-like domains protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(123058, NULL, 'G3DSA:3.20.20.70:FF:000839', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123059, NULL, 'G3DSA:1.20.1300.10:FF:000043', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(123060, NULL, 'G3DSA:3.50.50.60:FF:001495', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123061, NULL, 'G3DSA:3.40.50.1110:FF:000105', NULL, NULL, 'SGNH-hydrolase lipoprotein, lysophospholipase L1-like subgroup', NULL, NULL, NULL, NULL, NULL, 4),
(123062, NULL, 'G3DSA:3.10.129.10:FF:000044', NULL, NULL, 'Acyl-ACP thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(123063, NULL, 'G3DSA:2.30.29.30:FF:001288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123064, NULL, 'G3DSA:3.40.50.10130:FF:000005', NULL, NULL, 'crossover junction endonuclease MUS81 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(123065, NULL, 'G3DSA:3.30.420.10:FF:000638', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123066, NULL, 'G3DSA:2.60.40.1660:FF:000007', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(123067, NULL, 'G3DSA:3.20.20.80:FF:000376', NULL, NULL, 'Glycosyl hydrolase family 17 protein', NULL, NULL, NULL, NULL, NULL, 4),
(123068, NULL, 'G3DSA:3.30.160.60:FF:001762', NULL, NULL, 'zinc finger protein 140 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(123069, NULL, 'G3DSA:2.60.490.10:FF:000004', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(123070, NULL, 'G3DSA:3.40.50.1000:FF:000836', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123071, NULL, 'G3DSA:1.10.287.130:FF:000139', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(123072, NULL, 'G3DSA:3.20.20.60:FF:000157', NULL, NULL, 'Aldolase like', NULL, NULL, NULL, NULL, NULL, 4),
(123073, NULL, 'G3DSA:3.30.830.10:FF:000192', NULL, NULL, 'Metalloprotease', NULL, NULL, NULL, NULL, NULL, 4),
(123074, NULL, 'G3DSA:3.30.160.60:FF:003999', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123075, NULL, 'G3DSA:1.20.1000.10:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123076, NULL, 'G3DSA:2.160.20.10:FF:000031', NULL, NULL, 'PKHD1 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(123077, NULL, 'G3DSA:3.90.25.10:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123078, NULL, 'G3DSA:3.90.120.10:FF:000023', NULL, NULL, 'DNA (cytosine-5)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(123079, NULL, 'G3DSA:3.40.50.300:FF:006703', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123080, NULL, 'G3DSA:3.40.50.300:FF:002960', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(123081, NULL, 'G3DSA:1.25.10.10:FF:003289', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(123082, NULL, 'G3DSA:2.60.40.10:FF:003139', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123083, NULL, 'G3DSA:1.20.120.1080:FF:000103', NULL, NULL, 'Putative ATP-dependent RNA helicase DHX37', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(123084, NULL, 'G3DSA:3.30.300.20:FF:000048', NULL, NULL, 'Ribosome-binding factor A', NULL, NULL, NULL, NULL, NULL, 4),
(123085, NULL, 'G3DSA:1.20.1070.10:FF:000625', NULL, NULL, 'Chemokine (C-C motif) receptor 10', NULL, NULL, NULL, NULL, NULL, 4),
(123086, NULL, 'G3DSA:3.90.1300.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123087, NULL, 'G3DSA:3.40.1160.10:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123088, NULL, 'G3DSA:3.40.50.1820:FF:000610', NULL, NULL, 'LIPaSe related', NULL, NULL, NULL, NULL, NULL, 4),
(123089, NULL, 'G3DSA:3.30.160.60:FF:005505', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123090, NULL, 'G3DSA:1.10.287.70:FF:000059', NULL, NULL, 'Voltage-dependent N-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(123091, NULL, 'G3DSA:2.30.29.30:FF:000832', NULL, NULL, 'Kinesin-3 motor protein', NULL, NULL, NULL, NULL, NULL, 4),
(123092, NULL, 'G3DSA:1.20.1280.50:FF:000243', NULL, NULL, 'LOC100145488 protein', NULL, NULL, NULL, NULL, NULL, 4),
(123093, NULL, 'G3DSA:1.25.40.10:FF:001233', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g50420', NULL, NULL, NULL, NULL, NULL, 4),
(123094, NULL, 'G3DSA:1.10.510.10:FF:000680', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(123095, NULL, 'G3DSA:2.60.40.1180:FF:000105', NULL, NULL, 'Calpain family cysteine protease-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(123096, NULL, 'G3DSA:3.80.10.10:FF:003522', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(123097, NULL, 'G3DSA:1.10.238.10:FF:000428', NULL, NULL, 'Probable SAC6-actin filament bundling protein, fimbrin', NULL, NULL, NULL, NULL, NULL, 4),
(123098, NULL, 'G3DSA:3.30.1330.10:FF:000029', NULL, NULL, 'Trifunctional purine biosynthetic protein adenosine-3', NULL, NULL, NULL, NULL, NULL, 4),
(123099, NULL, 'G3DSA:3.30.70.330:FF:002649', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123100, NULL, 'G3DSA:1.25.70.10:FF:000100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123101, NULL, 'G3DSA:1.25.40.20:FF:000601', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123102, NULL, 'G3DSA:1.25.40.10:FF:000744', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(123103, NULL, 'G3DSA:3.40.50.150:FF:000829', NULL, NULL, 'mRNA cap guanine-N7 methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(123104, NULL, 'G3DSA:3.40.390.10:FF:000211', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(123105, NULL, 'G3DSA:3.40.640.10:FF:000012', NULL, NULL, 'alanine aminotransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(123106, NULL, 'G3DSA:2.30.30.40:FF:000434', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(123107, NULL, 'G3DSA:3.90.550.50:FF:000005', NULL, NULL, 'Hydroxyproline O-galactosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(123108, NULL, 'G3DSA:3.30.930.10:FF:000137', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(123109, NULL, 'G3DSA:3.10.50.40:FF:000001', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(123110, NULL, 'G3DSA:1.20.58.60:FF:000771', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(123111, NULL, 'G3DSA:2.60.40.1400:FF:000008', NULL, NULL, 'ATP-sensitive inward rectifier potassium channel 10', NULL, NULL, NULL, NULL, NULL, 4),
(123112, NULL, 'G3DSA:3.40.50.10860:FF:000016', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(123113, NULL, 'G3DSA:1.20.1280.170:FF:000012', NULL, NULL, 'Exocyst subunit Exo70 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(123114, NULL, 'G3DSA:1.20.1070.10:FF:001114', NULL, NULL, 'Rhodopsin', NULL, NULL, NULL, NULL, NULL, 4),
(123115, NULL, 'G3DSA:3.40.1060.10:FF:000006', NULL, NULL, 'Aconitate hydratase 1', NULL, NULL, NULL, NULL, NULL, 4),
(123116, NULL, 'G3DSA:1.20.58.70:FF:000009', NULL, NULL, 'Syntaxin 12', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(123117, NULL, 'G3DSA:3.40.50.300:FF:000190', NULL, NULL, 'ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(123118, NULL, 'G3DSA:3.40.50.800:FF:000098', NULL, NULL, 'Anticodon binding domain of tRNAs-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(123119, NULL, 'G3DSA:1.20.1250.20:FF:001980', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123120, NULL, 'G3DSA:2.40.170.20:FF:000123', NULL, NULL, 'SusC homolog', NULL, NULL, NULL, NULL, NULL, 4),
(123121, NULL, 'G3DSA:3.30.200.20:FF:001945', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123122, NULL, 'G3DSA:3.40.50.920:FF:000049', NULL, NULL, 'Indolepyruvate oxidoreductase subunit IorA', NULL, NULL, NULL, NULL, NULL, 4),
(123123, NULL, 'G3DSA:3.40.50.410:FF:000284', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(123124, NULL, 'G3DSA:1.10.510.10:FF:002006', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(123125, NULL, 'G3DSA:2.70.150.10:FF:000168', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(123126, NULL, 'G3DSA:3.30.70.330:FF:001340', NULL, NULL, 'GD18742', NULL, NULL, NULL, NULL, NULL, 4),
(123127, NULL, 'G3DSA:1.10.565.10:FF:000115', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(123128, NULL, 'G3DSA:3.80.10.10:FF:004511', NULL, NULL, 'Pollen receptor-like kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(123129, NULL, 'G3DSA:1.10.8.100:FF:000019', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(123130, NULL, 'G3DSA:3.40.50.300:FF:006203', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(123131, NULL, 'G3DSA:1.25.40.10:FF:000244', NULL, NULL, 'SGT1 homolog, MIS12 kinetochore complex assembly cochaperone', NULL, NULL, NULL, NULL, NULL, 4),
(123132, NULL, 'G3DSA:3.40.50.11840:FF:000001', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(123133, NULL, 'G3DSA:3.50.50.60:FF:001523', NULL, NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', NULL, NULL, NULL, NULL, NULL, 4),
(123134, NULL, 'G3DSA:2.40.240.10:FF:000002', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(123135, NULL, 'G3DSA:1.10.238.10:FF:000075', NULL, NULL, 'synergin gamma isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(123136, NULL, 'G3DSA:1.10.10.440:FF:000007', NULL, NULL, 'Putative rho GTPase-activating protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(123137, NULL, 'G3DSA:1.25.10.10:FF:001844', NULL, NULL, 'AGAP004535-PA', NULL, NULL, NULL, NULL, NULL, 4),
(123138, NULL, 'G3DSA:3.30.1490.70:FF:000013', NULL, NULL, 'DNA ligase 3', NULL, NULL, NULL, NULL, NULL, 4),
(123139, NULL, 'G3DSA:1.10.3370.10:FF:000004', NULL, NULL, 'Protein translocase subunit SecY', NULL, NULL, NULL, NULL, NULL, 4),
(123140, NULL, 'G3DSA:1.10.10.10:FF:001872', NULL, NULL, 'Selenocysteine-specific elongation factor', NULL, NULL, NULL, NULL, NULL, 4),
(123141, NULL, 'G3DSA:2.30.29.30:FF:000771', NULL, NULL, 'CCM2-like scaffold protein', NULL, NULL, NULL, NULL, NULL, 4),
(123142, NULL, 'G3DSA:1.20.5.190:FF:000095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123143, NULL, 'G3DSA:1.10.472.10:FF:000635', NULL, NULL, 'cyclin-H', NULL, NULL, NULL, NULL, NULL, 4),
(123144, NULL, 'G3DSA:1.10.287.110:FF:000100', NULL, NULL, 'DnaJ domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(123145, NULL, 'G3DSA:1.10.8.270:FF:000110', NULL, NULL, 'Rab-GTPase-TBC domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(123146, NULL, 'G3DSA:1.10.10.10:FF:001725', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(123147, NULL, 'G3DSA:2.60.40.10:FF:003078', NULL, NULL, 'Vascular endothelial growth factor receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(123148, NULL, 'G3DSA:2.60.120.970:FF:000020', NULL, NULL, 'growth/differentiation factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(123149, NULL, 'G3DSA:3.90.132.10:FF:000011', NULL, NULL, 'Cell surface protease gp63, putative', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(123150, NULL, 'G3DSA:3.10.450.50:FF:000089', NULL, NULL, 'Nuclear export factor-b', NULL, NULL, NULL, NULL, NULL, 4),
(123151, NULL, 'G3DSA:3.30.40.10:FF:000497', NULL, NULL, 'RING-H2 finger protein ATL73', NULL, NULL, NULL, NULL, NULL, 4),
(123152, NULL, 'G3DSA:3.30.200.20:FF:002081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123153, NULL, 'G3DSA:3.30.40.10:FF:001014', NULL, NULL, 'Lysine (K)-specific demethylase 5C', NULL, NULL, NULL, NULL, NULL, 4),
(123154, NULL, 'G3DSA:1.10.390.10:FF:000091', NULL, NULL, 'Protease m1 zinc metalloprotease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(123155, NULL, 'G3DSA:3.40.50.2300:FF:001316', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123156, NULL, 'G3DSA:2.10.110.10:FF:000033', NULL, NULL, 'LIM/homeobox protein Lhx9 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(123157, NULL, 'G3DSA:3.40.50.1460:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123158, NULL, 'G3DSA:3.30.1050.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123159, NULL, 'G3DSA:3.30.420.40:FF:000214', NULL, NULL, 'Pantothenate kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(123160, NULL, 'G3DSA:3.90.400.10:FF:000005', NULL, NULL, 'Trehalose synthase TreS', NULL, NULL, NULL, NULL, NULL, 4),
(123161, NULL, 'G3DSA:2.60.40.10:FF:002330', NULL, NULL, 'Myotactin form B', NULL, NULL, NULL, NULL, NULL, 4),
(123162, NULL, 'G3DSA:1.10.260.100:FF:000021', NULL, NULL, 'Heat shock protein STI1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(123163, NULL, 'G3DSA:3.40.1160.10:FF:000042', NULL, NULL, 'Delta-1-pyrroline-5-carboxylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(123164, NULL, 'G3DSA:1.25.40.180:FF:000318', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123165, NULL, 'G3DSA:3.60.20.10:FF:000224', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123166, NULL, 'G3DSA:2.130.10.10:FF:003882', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123167, NULL, 'G3DSA:1.20.1560.10:FF:000825', NULL, NULL, 'ABC protein, subfamily ABCB/MDR', NULL, NULL, NULL, NULL, NULL, 4),
(123168, NULL, 'G3DSA:1.10.510.10:FF:000972', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(123169, NULL, 'G3DSA:3.80.10.10:FF:002033', NULL, NULL, 'F-box/LRR-repeat protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(123170, NULL, 'G3DSA:2.10.70.10:FF:000294', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123171, NULL, 'G3DSA:3.40.50.300:FF:002460', NULL, NULL, 'Regulator of nonsense transcripts 1', NULL, NULL, NULL, NULL, NULL, 4),
(123172, NULL, 'G3DSA:3.40.30.70:FF:000002', NULL, NULL, 'Glutamyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(123173, NULL, 'G3DSA:3.30.70.850:FF:000006', NULL, NULL, 'Endoprotease bli', NULL, NULL, NULL, NULL, NULL, 4),
(123174, NULL, 'G3DSA:1.10.10.10:FF:001433', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(123175, NULL, 'G3DSA:3.40.50.880:FF:000048', NULL, NULL, 'DJ-1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(123176, NULL, 'G3DSA:3.40.50.450:FF:000037', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(123177, NULL, 'G3DSA:1.20.1740.10:FF:000098', NULL, NULL, 'Arginine/ornithine antiporter', NULL, NULL, NULL, NULL, NULL, 4),
(123178, NULL, 'G3DSA:2.30.30.140:FF:000351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123179, NULL, 'G3DSA:1.20.1050.80:FF:000010', NULL, NULL, 'protein sprint isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(123180, NULL, 'G3DSA:3.40.50.300:FF:008148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123181, NULL, 'G3DSA:2.60.120.10:FF:000657', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123182, NULL, 'G3DSA:2.10.70.10:FF:000114', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(123183, NULL, 'G3DSA:3.40.50.1580:FF:000049', NULL, NULL, 'Purine nucleoside phosphorylase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(123184, NULL, 'G3DSA:3.30.750.24:FF:000081', NULL, NULL, 'Sodium-independent anion transporter', NULL, NULL, NULL, NULL, NULL, 4),
(123185, NULL, 'G3DSA:1.10.1040.10:FF:000103', NULL, NULL, 'Oxidoreductase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(123186, NULL, 'G3DSA:3.40.30.10:FF:000271', NULL, NULL, 'Thioredoxin reductase 1, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(123187, NULL, 'G3DSA:3.40.50.2300:FF:001463', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123188, NULL, 'G3DSA:3.30.559.10:FF:000083', NULL, NULL, 'Probable non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(123189, NULL, 'G3DSA:3.30.200.20:FF:000956', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(123190, NULL, 'G3DSA:1.20.190.20:FF:000003', NULL, NULL, 'Casparian strip membrane protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(123191, NULL, 'G3DSA:2.130.10.10:FF:003735', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123192, NULL, 'G3DSA:3.30.160.60:FF:006433', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123193, NULL, 'G3DSA:1.10.10.790:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123194, NULL, 'G3DSA:2.40.100.10:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123195, NULL, 'G3DSA:3.30.730.10:FF:000009', NULL, NULL, 'AP2 domain containing protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(123196, NULL, 'G3DSA:3.20.20.70:FF:000547', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123197, NULL, 'G3DSA:1.20.1070.10:FF:000125', NULL, NULL, 'growth hormone secretagogue receptor type 1', NULL, NULL, NULL, NULL, NULL, 4),
(123198, NULL, 'G3DSA:3.40.309.10:FF:000074', NULL, NULL, 'Succinate-semialdehyde dehydrogenase [NADP(+)] GabD', NULL, NULL, NULL, NULL, NULL, 4),
(123199, NULL, 'G3DSA:2.60.120.200:FF:000076', NULL, NULL, 'basement membrane-specific heparan sulfate proteoglycan core protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(123200, NULL, 'G3DSA:2.40.160.10:FF:000029', NULL, NULL, 'Porin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(123201, NULL, 'G3DSA:2.60.220.50:FF:000154', NULL, NULL, 'Adhesion G protein-coupled receptor L4', NULL, NULL, NULL, NULL, NULL, 4),
(123202, NULL, 'G3DSA:3.40.50.720:FF:001361', NULL, NULL, 'Prephenate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(123203, NULL, 'G3DSA:3.30.430.20:FF:000001', NULL, NULL, 'cysteine-rich repeat secretory protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(123204, NULL, 'G3DSA:3.40.50.2300:FF:000799', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(123205, NULL, 'G3DSA:2.70.160.11:FF:000063', NULL, NULL, 'Protein arginine N-methyltransferase 6', NULL, NULL, NULL, NULL, NULL, 4),
(123206, NULL, 'G3DSA:3.40.50.1820:FF:000110', NULL, NULL, 'Hormone-sensitive lipase', NULL, NULL, NULL, NULL, NULL, 4),
(123207, NULL, 'G3DSA:1.10.287.4310:FF:000001', NULL, NULL, 'Coupling of ubiquitin conjugation to ER degradation', NULL, NULL, NULL, NULL, NULL, 4),
(123208, NULL, 'G3DSA:1.25.10.10:FF:000124', NULL, NULL, 'lisH domain-containing protein ARMC9 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(123209, NULL, 'G3DSA:3.40.50.300:FF:002308', NULL, NULL, 'Similar to Rho-like small GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(123210, NULL, 'G3DSA:2.30.170.40:FF:000007', NULL, NULL, '50S ribosomal protein L28', NULL, NULL, NULL, NULL, NULL, 4),
(123211, NULL, 'G3DSA:3.30.559.30:FF:000089', NULL, NULL, 'Nonribosomal peptide synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(123212, NULL, 'G3DSA:3.30.470.20:FF:000239', NULL, NULL, 'Inositol-tetrakisphosphate 1-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(123213, NULL, 'G3DSA:2.30.30.770:FF:000006', NULL, NULL, '60S ribosomal protein L27', NULL, NULL, NULL, NULL, NULL, 4),
(123214, NULL, 'G3DSA:3.80.10.10:FF:000908', NULL, NULL, 'Receptor like protein 41', NULL, NULL, NULL, NULL, NULL, 4),
(123215, NULL, 'G3DSA:1.10.510.10:FF:000180', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(123216, NULL, 'G3DSA:3.90.190.10:FF:000297', NULL, NULL, 'Protein-tyrosine phosphatase-like protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(123217, NULL, 'G3DSA:1.10.8.60:FF:000306', NULL, NULL, 'AAA ATPase central domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(123218, NULL, 'G3DSA:3.40.50.12780:FF:000160', NULL, NULL, 'Nonribosomal peptide synthase, putative (JCVI)', NULL, NULL, NULL, NULL, NULL, 4),
(123219, NULL, 'G3DSA:1.20.930.20:FF:000004', NULL, NULL, 'E3 ubiquitin-protein ligase CBL-C', NULL, NULL, NULL, NULL, NULL, 4),
(123220, NULL, 'G3DSA:3.30.60.90:FF:000038', NULL, NULL, 'E3_ubiquitin-protein_ligase_KCMF1_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(123221, NULL, 'G3DSA:2.10.110.10:FF:000325', NULL, NULL, 'AGAP012744-PA', NULL, NULL, NULL, NULL, NULL, 4),
(123222, NULL, 'G3DSA:2.40.50.140:FF:001235', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123223, NULL, 'G3DSA:3.40.50.300:FF:004225', NULL, NULL, 'Homolog to translation elongation factor aEF-1 alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(123224, NULL, 'G3DSA:3.50.7.10:FF:000010', NULL, NULL, 'T-complex protein 1 subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(123225, NULL, 'G3DSA:3.40.1810.10:FF:000013', NULL, NULL, 'Transcription factor, MADS-box', NULL, NULL, NULL, NULL, NULL, 4),
(123226, NULL, 'G3DSA:2.40.160.10:FF:000001', NULL, NULL, 'Voltage-dependent anion-selective channel protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(123227, NULL, 'G3DSA:2.60.40.10:FF:005848', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123228, NULL, 'G3DSA:3.40.50.12160:FF:000002', NULL, NULL, 'Ribosomal protein S12 methylthiotransferase RimO', NULL, NULL, NULL, NULL, NULL, 4),
(123229, NULL, 'G3DSA:3.40.50.620:FF:000549', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(123230, NULL, 'G3DSA:1.20.1170.10:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123231, NULL, 'G3DSA:2.60.40.2690:FF:000013', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(123232, NULL, 'G3DSA:3.30.160.60:FF:000301', NULL, NULL, 'Zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(123233, NULL, 'G3DSA:2.60.40.10:FF:003611', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123234, NULL, 'G3DSA:1.25.10.10:FF:001552', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123235, NULL, 'G3DSA:3.30.450.60:FF:000048', NULL, NULL, 'AP complex subunit sigma', NULL, NULL, NULL, NULL, NULL, 4),
(123236, NULL, 'G3DSA:1.25.40.80:FF:000012', NULL, NULL, 'Deoxyribodipyrimidine photolyase', NULL, NULL, NULL, NULL, NULL, 4),
(123237, NULL, 'G3DSA:2.60.200.20:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123238, NULL, 'G3DSA:4.10.800.10:FF:000016', NULL, NULL, 'Thyroglobulin', NULL, NULL, NULL, NULL, NULL, 4),
(123239, NULL, 'G3DSA:3.50.50.60:FF:000859', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(123240, NULL, 'G3DSA:1.20.1440.90:FF:000003', NULL, NULL, 'Phosphoenolpyruvate carboxylase 4', NULL, NULL, NULL, NULL, NULL, 4),
(123241, NULL, 'G3DSA:3.30.230.70:FF:000074', NULL, NULL, 'EXOSome (Multiexonuclease complex) component', NULL, NULL, NULL, NULL, NULL, 4),
(123242, NULL, 'G3DSA:2.30.30.30:FF:000105', NULL, NULL, 'Apicoplast ribosomal protein L2', NULL, NULL, NULL, NULL, NULL, 4),
(123243, NULL, 'G3DSA:1.25.40.10:FF:004959', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123244, NULL, 'G3DSA:3.40.20.10:FF:000034', NULL, NULL, 'protein flightless-1 homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(123245, NULL, 'G3DSA:3.40.980.10:FF:000003', NULL, NULL, 'Molybdenum cofactor biosynthesis protein B', NULL, NULL, NULL, NULL, NULL, 4),
(123246, NULL, 'G3DSA:2.30.30.90:FF:000016', NULL, NULL, 'Ferrous iron transport protein A', NULL, NULL, NULL, NULL, NULL, 4),
(123247, NULL, 'G3DSA:2.10.220.10:FF:000154', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(123248, NULL, 'G3DSA:3.40.1110.10:FF:000331', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123249, NULL, 'G3DSA:1.25.40.120:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(123250, NULL, 'G3DSA:3.30.160.60:FF:005152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123251, NULL, 'G3DSA:1.20.1070.10:FF:002042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123252, NULL, 'G3DSA:3.30.565.10:FF:000496', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123253, NULL, 'G3DSA:2.40.10.10:FF:000334', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123254, NULL, 'G3DSA:3.30.160.60:FF:002690', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123255, NULL, 'G3DSA:2.60.60.20:FF:000064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123256, NULL, 'G3DSA:3.30.70.330:FF:001368', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(123257, NULL, 'G3DSA:2.60.260.20:FF:000024', NULL, NULL, 'Mitochondrial protein import protein MAS5', NULL, NULL, NULL, NULL, NULL, 4),
(123258, NULL, 'G3DSA:2.70.150.10:FF:000140', NULL, NULL, 'Sarco/endoplasmic reticulum Ca2+ -ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(123259, NULL, 'G3DSA:3.30.310.10:FF:000017', NULL, NULL, 'Ribonuclease HIII', NULL, NULL, NULL, NULL, NULL, 4),
(123260, NULL, 'G3DSA:3.80.10.10:FF:002825', NULL, NULL, 'Protein CBG03541', NULL, NULL, NULL, NULL, NULL, 4),
(123261, NULL, 'G3DSA:3.10.110.10:FF:000198', NULL, NULL, 'Ubiquitin-conjugating enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(123262, NULL, 'G3DSA:3.90.660.10:FF:000142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123263, NULL, 'G3DSA:3.40.50.300:FF:002016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123264, NULL, 'G3DSA:1.10.630.10:FF:000508', NULL, NULL, 'Epoxyalcohol synthase CYP443D1', NULL, NULL, NULL, NULL, NULL, 4),
(123265, NULL, 'G3DSA:3.40.390.10:FF:000183', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123266, NULL, 'G3DSA:3.65.10.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123267, NULL, 'G3DSA:3.40.50.150:FF:000537', NULL, NULL, 'tRNA/rRNA cytosine-C5-methylase RsmB', NULL, NULL, NULL, NULL, NULL, 4),
(123268, NULL, 'G3DSA:3.30.160.60:FF:004516', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123269, NULL, 'G3DSA:3.90.260.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123270, NULL, 'G3DSA:3.40.250.10:FF:000201', NULL, NULL, 'ACL041Cp', NULL, NULL, NULL, NULL, NULL, 4),
(123271, NULL, 'G3DSA:2.130.10.10:FF:005860', NULL, NULL, 'Two-component system sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(123272, NULL, 'G3DSA:3.30.450.40:FF:000042', NULL, NULL, 'Probable diguanylate cyclase YeaP', NULL, NULL, NULL, NULL, NULL, 4),
(123273, NULL, 'G3DSA:4.10.240.10:FF:000052', NULL, NULL, 'Activator of stress genes', NULL, NULL, NULL, NULL, NULL, 4),
(123274, NULL, 'G3DSA:3.80.10.10:FF:000088', NULL, NULL, 'Putative leucine-rich repeat-containing protein 41', NULL, NULL, NULL, NULL, NULL, 4),
(123275, NULL, 'G3DSA:2.60.120.330:FF:000148', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(123276, NULL, 'G3DSA:3.30.70.260:FF:000104', NULL, NULL, 'Threonine dehydratase (IlvA)', NULL, NULL, NULL, NULL, NULL, 4),
(123277, NULL, 'G3DSA:3.30.60.30:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123278, NULL, 'G3DSA:3.10.450.50:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123279, NULL, 'G3DSA:3.80.10.10:FF:000616', NULL, NULL, 'Tubulin-specific chaperone E', NULL, NULL, NULL, NULL, NULL, 4),
(123280, NULL, 'G3DSA:2.130.10.10:FF:002454', NULL, NULL, 'WD repeat domain 3', NULL, NULL, NULL, NULL, NULL, 4),
(123281, NULL, 'G3DSA:2.70.50.30:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123282, NULL, 'G3DSA:3.30.230.10:FF:000163', NULL, NULL, 'DNA repair protein RadA', NULL, NULL, NULL, NULL, NULL, 4),
(123283, NULL, 'G3DSA:2.30.42.10:FF:000346', NULL, NULL, 'LIM domain kinase 1b', NULL, NULL, NULL, NULL, NULL, 4),
(123284, NULL, 'G3DSA:3.40.50.12370:FF:000008', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(123285, NULL, 'G3DSA:3.30.200.20:FF:000664', NULL, NULL, 'Cyclin-dependent kinase F-1', NULL, NULL, NULL, NULL, NULL, 4),
(123286, NULL, 'G3DSA:2.60.40.10:FF:004567', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123287, NULL, 'G3DSA:2.130.10.10:FF:001526', NULL, NULL, 'WD domain, G-beta repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(123288, NULL, 'G3DSA:3.40.50.300:FF:003769', NULL, NULL, 'ABC transporter, multidrug resistance associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(123289, NULL, 'G3DSA:3.30.70.330:FF:001901', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123290, NULL, 'G3DSA:2.60.40.150:FF:000821', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123291, NULL, 'G3DSA:1.25.40.10:FF:001672', NULL, NULL, 'Intraflagellar transport protein IFT88, putative', NULL, NULL, NULL, NULL, NULL, 4),
(123292, NULL, 'G3DSA:2.20.28.120:FF:000013', NULL, NULL, 'RM33, ribosomal protein 33 mitochondrial large ribosomal subunit', NULL, NULL, NULL, NULL, NULL, 4),
(123293, NULL, 'G3DSA:2.60.40.10:FF:005056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123294, NULL, 'G3DSA:3.30.200.20:FF:001592', NULL, NULL, 'Os11g0485700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(123295, NULL, 'G3DSA:1.10.530.10:FF:000063', NULL, NULL, 'Lysozyme g', NULL, NULL, NULL, NULL, NULL, 4),
(123296, NULL, 'G3DSA:1.10.10.60:FF:000318', NULL, NULL, 'homeobox protein notochord', NULL, NULL, NULL, NULL, NULL, 4),
(123297, NULL, 'G3DSA:1.10.2000.10:FF:000011', NULL, NULL, 'Corin, serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(123298, NULL, 'G3DSA:1.10.533.10:FF:000305', NULL, NULL, 'Retinoic acid-inducible protein Ia', NULL, NULL, NULL, NULL, NULL, 4),
(123299, NULL, 'G3DSA:3.60.15.10:FF:000274', NULL, NULL, 'DNA repair metallo-beta-lactamase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(123300, NULL, 'G3DSA:3.60.21.10:FF:000215', NULL, NULL, 'Serine/threonine-protein phosphatase with EF-hands', NULL, NULL, NULL, NULL, NULL, 4),
(123301, NULL, 'G3DSA:1.10.287.310:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123302, NULL, 'G3DSA:2.30.30.40:FF:000081', NULL, NULL, 'Tight junction protein ZO-2 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(123303, NULL, 'G3DSA:3.40.50.80:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123304, NULL, 'G3DSA:3.40.50.720:FF:000433', NULL, NULL, 'Alanine dehydrogenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(123305, NULL, 'G3DSA:3.40.50.1820:FF:000902', NULL, NULL, 'S-formylglutathione hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(123306, NULL, 'G3DSA:1.20.1250.20:FF:000491', NULL, NULL, 'Major facilitator transporter', NULL, NULL, NULL, NULL, NULL, 4),
(123307, NULL, 'G3DSA:1.20.5.990:FF:000003', NULL, NULL, 'NF-kappa-B essential modulator isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(123308, NULL, 'G3DSA:3.10.580.10:FF:000081', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(123309, NULL, 'G3DSA:2.40.40.10:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123310, NULL, 'G3DSA:1.25.40.990:FF:000027', NULL, NULL, 'SAC3/GANP family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(123311, NULL, 'G3DSA:1.20.1070.10:FF:000917', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123312, NULL, 'G3DSA:3.30.890.10:FF:000021', NULL, NULL, 'Bromodomain adjacent to zinc finger domain protein 2A', NULL, NULL, NULL, NULL, NULL, 4),
(123313, NULL, 'G3DSA:1.25.10.10:FF:001405', NULL, NULL, 'Pumilio homolog 23', NULL, NULL, NULL, NULL, NULL, 4),
(123314, NULL, 'G3DSA:1.10.10.60:FF:000498', NULL, NULL, 'Transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(123315, NULL, 'G3DSA:2.170.260.10:FF:000017', NULL, NULL, 'Ago1p', NULL, NULL, NULL, NULL, NULL, 4),
(123316, NULL, 'G3DSA:1.20.1080.10:FF:000070', NULL, NULL, 'Water-specific aquaporin', NULL, NULL, NULL, NULL, NULL, 4),
(123317, NULL, 'G3DSA:1.20.1740.10:FF:000070', NULL, NULL, 'Amino acid transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(123318, NULL, 'G3DSA:3.40.50.2300:FF:001024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123319, NULL, 'G3DSA:1.20.1250.20:FF:002025', NULL, NULL, 'Zgc:63767', NULL, NULL, NULL, NULL, NULL, 4),
(123320, NULL, 'G3DSA:1.25.40.10:FF:002189', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g18110, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(123321, NULL, 'G3DSA:3.20.20.140:FF:000033', NULL, NULL, 'Adenosine deaminase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(123322, NULL, 'G3DSA:3.30.40.10:FF:000789', NULL, NULL, 'Os03g0380900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(123323, NULL, 'G3DSA:3.90.190.10:FF:000117', NULL, NULL, 'Unplaced genomic scaffold supercont1.162, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(123324, NULL, 'G3DSA:1.10.510.10:FF:001489', NULL, NULL, 'Kinase, CAMK CAMKL', NULL, NULL, NULL, NULL, NULL, 4),
(123325, NULL, 'G3DSA:2.160.20.10:FF:000323', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123326, NULL, 'G3DSA:1.10.220.30:FF:000028', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(123327, NULL, 'G3DSA:1.10.150.50:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123328, NULL, 'G3DSA:3.30.420.270:FF:000002', NULL, NULL, 'TonB system transport protein ExbD', NULL, NULL, NULL, NULL, NULL, 4),
(123329, NULL, 'G3DSA:3.40.50.300:FF:000482', NULL, NULL, 'Multidrug resistance-associated protein member 4', NULL, NULL, NULL, NULL, NULL, 4),
(123330, NULL, 'G3DSA:3.40.50.1820:FF:001419', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123331, NULL, 'G3DSA:1.20.58.920:FF:000004', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(123332, NULL, 'G3DSA:3.30.160.60:FF:000481', NULL, NULL, 'zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(123333, NULL, 'G3DSA:3.60.10.10:FF:000426', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123334, NULL, 'G3DSA:1.10.472.130:FF:000011', NULL, NULL, 'dynein heavy chain 12, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(123335, NULL, 'G3DSA:3.40.30.10:FF:000119', NULL, NULL, 'Maleylacetoacetate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(123336, NULL, 'G3DSA:1.20.1640.10:FF:000034', NULL, NULL, 'Protein-export membrane protein SecF', NULL, NULL, NULL, NULL, NULL, 4),
(123337, NULL, 'G3DSA:3.40.50.300:FF:006350', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123338, NULL, 'G3DSA:3.90.1480.20:FF:000012', NULL, NULL, 'ST6 beta-galactoside alpha-2,6-sialyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(123339, NULL, 'G3DSA:1.20.1720.10:FF:000035', NULL, NULL, 'Bcr/CflA family efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(123340, NULL, 'G3DSA:3.20.20.370:FF:000017', NULL, NULL, 'Lactam utilization protein lamB', NULL, NULL, NULL, NULL, NULL, 4),
(123341, NULL, 'G3DSA:1.10.287.20:FF:000005', NULL, NULL, 'Cytochrome b-c1 complex subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(123342, NULL, 'G3DSA:1.25.70.10:FF:000072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123343, NULL, 'G3DSA:1.10.286.20:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123344, NULL, 'G3DSA:2.130.10.10:FF:003090', NULL, NULL, 'Putative U4/U6 small nuclear ribonucleoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(123345, NULL, 'G3DSA:1.10.510.10:FF:003434', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123346, NULL, 'G3DSA:1.25.40.20:FF:000573', NULL, NULL, 'Uncharacterized protein, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(123347, NULL, 'G3DSA:3.30.505.10:FF:000223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123348, NULL, 'G3DSA:2.60.40.60:FF:000698', NULL, NULL, 'Fat-like cadherin-related tumor suppressor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(123349, NULL, 'G3DSA:3.30.565.10:FF:000232', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(123350, NULL, 'G3DSA:1.25.10.10:FF:003322', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(123351, NULL, 'G3DSA:3.40.50.300:FF:007131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123352, NULL, 'G3DSA:2.130.10.10:FF:002954', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123353, NULL, 'G3DSA:2.30.42.10:FF:000138', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(123354, NULL, 'G3DSA:1.25.40.20:FF:000129', NULL, NULL, 'Fibronectin type 3 and ankyrin repeat domains 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(123355, NULL, 'G3DSA:3.90.550.10:FF:000460', NULL, NULL, 'Glycosyl transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(123356, NULL, 'G3DSA:2.60.40.1390:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123357, NULL, 'G3DSA:3.90.1370.10:FF:000001', NULL, NULL, 'Outer capsid protein mu-1', NULL, NULL, NULL, NULL, NULL, 4),
(123358, NULL, 'G3DSA:2.20.28.200:FF:000003', NULL, NULL, 'NAD-dependent protein deacetylase SRT1', NULL, NULL, NULL, NULL, NULL, 4),
(123359, NULL, 'G3DSA:3.40.120.10:FF:000017', NULL, NULL, 'glucose 1,6-bisphosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(123360, NULL, 'G3DSA:3.40.190.10:FF:000022', NULL, NULL, 'ATP phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(123361, NULL, 'G3DSA:3.30.160.60:FF:000273', NULL, NULL, 'Odd-skipped-related transciption factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(123362, NULL, 'G3DSA:3.30.50.10:FF:000115', NULL, NULL, 'Protein CBG20719', NULL, NULL, NULL, NULL, NULL, 4),
(123363, NULL, 'G3DSA:1.25.40.20:FF:000073', NULL, NULL, 'Ankyrin repeat domain-containing protein 13C', NULL, NULL, NULL, NULL, NULL, 4),
(123364, NULL, 'G3DSA:3.40.50.720:FF:002378', NULL, NULL, 'Dehydrogenase orsE', NULL, NULL, NULL, NULL, NULL, 4),
(123365, NULL, 'G3DSA:3.20.20.70:FF:000339', NULL, NULL, 'Dihydroorotate dehydrogenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(123366, NULL, 'G3DSA:2.60.40.150:FF:000321', NULL, NULL, '16 kDa phloem protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(123367, NULL, 'G3DSA:1.10.472.80:FF:000083', NULL, NULL, 'Oxidant-induced cell-cycle arrest protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(123368, NULL, 'G3DSA:3.30.160.60:FF:000329', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM9 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(123369, NULL, 'G3DSA:3.40.190.10:FF:000494', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(123370, NULL, 'G3DSA:3.90.25.10:FF:000060', NULL, NULL, 'UDP-glucose 4-epimerase 4', NULL, NULL, NULL, NULL, NULL, 4),
(123371, NULL, 'G3DSA:3.40.50.1820:FF:001599', NULL, NULL, 'Methyl esterase 11', NULL, NULL, NULL, NULL, NULL, 4),
(123372, NULL, 'G3DSA:1.10.10.10:FF:000944', NULL, NULL, 'O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(123373, NULL, 'G3DSA:3.30.470.20:FF:000178', NULL, NULL, 'CPSase', NULL, NULL, NULL, NULL, NULL, 4),
(123374, NULL, 'G3DSA:2.60.300.12:FF:000005', NULL, NULL, 'Fe-S cluster assembly scaffold SufA', NULL, NULL, NULL, NULL, NULL, 4),
(123375, NULL, 'G3DSA:2.60.120.200:FF:000137', NULL, NULL, 'Multiplexin collagen isoform Ap3', NULL, NULL, NULL, NULL, NULL, 4),
(123376, NULL, 'G3DSA:3.80.10.10:FF:001869', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(123377, NULL, 'G3DSA:3.30.160.60:FF:003499', NULL, NULL, 'Protein suppressor of hairy wing', NULL, NULL, NULL, NULL, NULL, 4),
(123378, NULL, 'G3DSA:3.60.10.10:FF:000370', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123379, NULL, 'G3DSA:2.60.40.10:FF:001841', NULL, NULL, 'Neuromusculin, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(123380, NULL, 'G3DSA:3.30.200.20:FF:000456', NULL, NULL, 'Myosin IIIA', NULL, NULL, NULL, NULL, NULL, 4),
(123381, NULL, 'G3DSA:3.40.630.10:FF:000039', NULL, NULL, 'Peptidase M20 domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(123382, NULL, 'G3DSA:3.20.20.190:FF:000115', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123383, NULL, 'G3DSA:1.10.10.1940:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(123384, NULL, 'G3DSA:1.10.287.70:FF:000470', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123385, NULL, 'G3DSA:1.25.40.10:FF:004398', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123386, NULL, 'G3DSA:3.40.1110.10:FF:000359', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123387, NULL, 'G3DSA:3.40.50.300:FF:005894', NULL, NULL, 'GTPase HflX', NULL, NULL, NULL, NULL, NULL, 4),
(123388, NULL, 'G3DSA:2.60.40.60:FF:000226', NULL, NULL, 'Dachsous, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(123389, NULL, 'G3DSA:1.20.120.1760:FF:000032', NULL, NULL, 'Choline/ethanolamine phosphotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(123390, NULL, 'G3DSA:1.25.40.10:FF:002689', NULL, NULL, 'YALI0C01397p', NULL, NULL, NULL, NULL, NULL, 4),
(123391, NULL, 'G3DSA:3.40.30.10:FF:000771', NULL, NULL, 'Peroxiredoxin domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(123392, NULL, 'G3DSA:3.30.1230.20:FF:000002', NULL, NULL, '40S ribosomal protein S21', NULL, NULL, NULL, NULL, NULL, 4),
(123393, NULL, 'G3DSA:3.10.100.10:FF:000433', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123394, NULL, 'G3DSA:2.130.10.10:FF:001965', NULL, NULL, 'Raptor_N-terminal_CASPase_like_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(123395, NULL, 'G3DSA:1.10.418.20:FF:000030', NULL, NULL, 'Ubiquitin-like-specific protease 2', NULL, NULL, NULL, NULL, NULL, 4),
(123396, NULL, 'G3DSA:2.40.128.20:FF:000002', NULL, NULL, 'Outer membrane lipoprotein Blc', NULL, NULL, NULL, NULL, NULL, 4),
(123397, NULL, 'G3DSA:3.60.40.10:FF:000254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123398, NULL, 'G3DSA:2.60.40.420:FF:000245', NULL, NULL, 'Spore coat protein', NULL, NULL, NULL, NULL, NULL, 4),
(123399, NULL, 'G3DSA:1.25.10.10:FF:002333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123400, NULL, 'G3DSA:1.10.3210.10:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123401, NULL, 'G3DSA:1.20.58.60:FF:000624', NULL, NULL, 'Microtubule-actin crosslinking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(123402, NULL, 'G3DSA:1.25.10.10:FF:001613', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123403, NULL, 'G3DSA:1.20.1560.10:FF:000764', NULL, NULL, 'Putative multidrug resistance-associated protein lethal(2)03659-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(123404, NULL, 'G3DSA:2.30.29.30:FF:001316', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(123405, NULL, 'G3DSA:3.40.50.360:FF:000162', NULL, NULL, 'NADPH-cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(123406, NULL, 'G3DSA:1.10.3720.10:FF:000133', NULL, NULL, 'Iron ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(123407, NULL, 'G3DSA:3.30.30.30:FF:000007', NULL, NULL, 'Heat shock 70 kDa protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(123408, NULL, 'G3DSA:1.10.1040.10:FF:000075', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(123409, NULL, 'G3DSA:3.30.710.10:FF:000418', NULL, NULL, 'BTB/POZ domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(123410, NULL, 'G3DSA:2.60.98.20:FF:000010', NULL, NULL, 'Flagellar hook protein FlgE', NULL, NULL, NULL, NULL, NULL, 4),
(123411, NULL, 'G3DSA:3.40.710.10:FF:000192', NULL, NULL, 'Penicillin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(123412, NULL, 'G3DSA:6.10.250.3340:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123413, NULL, 'G3DSA:2.60.40.10:FF:002830', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123414, NULL, 'G3DSA:1.10.510.10:FF:002506', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123415, NULL, 'G3DSA:3.30.450.200:FF:000015', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(123416, NULL, 'G3DSA:2.60.40.10:FF:003550', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123417, NULL, 'G3DSA:3.40.50.300:FF:008120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(123418, NULL, 'G3DSA:3.40.50.720:FF:000725', NULL, NULL, '2-ketogluconate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(123419, NULL, 'G3DSA:3.40.50.1470:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123420, NULL, 'G3DSA:3.40.50.150:FF:000184', NULL, NULL, 'Protein-lysine N-methyltransferase Os01g0121100', NULL, NULL, NULL, NULL, NULL, 4),
(123421, NULL, 'G3DSA:1.10.510.10:FF:003934', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123422, NULL, 'G3DSA:2.130.10.10:FF:004399', NULL, NULL, 'Pre-mRNA-processing factor 19 homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(123423, NULL, 'G3DSA:3.10.20.70:FF:000008', NULL, NULL, 'Gamma-glutamylputrescine synthetase PuuA', NULL, NULL, NULL, NULL, NULL, 4),
(123424, NULL, 'G3DSA:3.30.40.10:FF:000997', NULL, NULL, 'Male-specific lethal 2', NULL, NULL, NULL, NULL, NULL, 4),
(123425, NULL, 'G3DSA:1.25.40.10:FF:003206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123426, NULL, 'G3DSA:3.30.830.10:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123427, NULL, 'G3DSA:3.40.190.80:FF:000031', NULL, NULL, 'Inositol-monophosphatase ImpA', NULL, NULL, NULL, NULL, NULL, 4),
(123428, NULL, 'G3DSA:3.10.20.90:FF:000874', NULL, NULL, 'Ubiquitin-like protein ATG12', NULL, NULL, NULL, NULL, NULL, 4),
(123429, NULL, 'G3DSA:2.130.10.110:FF:000022', NULL, NULL, 'Clathrin heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(123430, NULL, 'G3DSA:1.10.8.620:FF:000001', NULL, NULL, 'Beta-lactamase', NULL, NULL, NULL, NULL, NULL, 4),
(123431, NULL, 'G3DSA:3.40.50.1450:FF:000010', NULL, NULL, 'Methyl viologen-reducing hydrogenase maturation protease', NULL, NULL, NULL, NULL, NULL, 4),
(123432, NULL, 'G3DSA:3.30.470.30:FF:000068', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(123433, NULL, 'G3DSA:3.60.10.10:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123434, NULL, 'G3DSA:3.40.50.150:FF:001526', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123435, NULL, 'G3DSA:3.40.50.300:FF:007659', NULL, NULL, 'PDR12 (PLEIOTROPIC DRUG RESISTANCE 12)', NULL, NULL, NULL, NULL, NULL, 4),
(123436, NULL, 'G3DSA:3.40.50.1580:FF:000021', NULL, NULL, 'MTA/SAH nucleosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(123437, NULL, 'G3DSA:3.40.50.1460:FF:000070', NULL, NULL, 'cell death protein 3-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(123438, NULL, 'G3DSA:3.30.70.330:FF:002149', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123439, NULL, 'G3DSA:1.10.506.10:FF:000102', NULL, NULL, 'Neurofibromin-A', NULL, NULL, NULL, NULL, NULL, 4),
(123440, NULL, 'G3DSA:2.115.10.20:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123441, NULL, 'G3DSA:3.40.470.10:FF:000004', NULL, NULL, 'Uracil-DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(123442, NULL, 'G3DSA:1.10.730.10:FF:000011', NULL, NULL, 'Leucine--tRNA ligase chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(123443, NULL, 'G3DSA:1.20.1070.10:FF:000097', NULL, NULL, 'olfactory receptor 2A12-like', NULL, NULL, NULL, NULL, NULL, 4),
(123444, NULL, 'G3DSA:1.10.10.60:FF:000998', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123445, NULL, 'G3DSA:3.30.160.60:FF:002307', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123446, NULL, 'G3DSA:1.10.1200.10:FF:000077', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(123447, NULL, 'G3DSA:3.30.160.60:FF:005652', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123448, NULL, 'G3DSA:3.30.160.60:FF:004224', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123449, NULL, 'G3DSA:1.25.40.10:FF:002953', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123450, NULL, 'G3DSA:1.20.1070.10:FF:001878', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123451, NULL, 'G3DSA:1.20.1270.50:FF:000006', NULL, NULL, 'Alpha-mannosidase mngB', NULL, NULL, NULL, NULL, NULL, 4),
(123452, NULL, 'G3DSA:2.102.10.10:FF:000016', NULL, NULL, 'Nitrite reductase/ring-hydroxylating ferredoxin subunit', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(123453, NULL, 'G3DSA:2.60.40.150:FF:000057', NULL, NULL, 'active breakpoint cluster region-related protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(123454, NULL, 'G3DSA:3.40.50.720:FF:001130', NULL, NULL, 'Possible dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(123455, NULL, 'G3DSA:3.30.160.60:FF:005444', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123456, NULL, 'G3DSA:3.10.20.360:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123457, NULL, 'G3DSA:2.60.40.10:FF:002122', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(123458, NULL, 'G3DSA:3.10.20.90:FF:000166', NULL, NULL, 'serine/threonine-protein kinase WNK3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(123459, NULL, 'G3DSA:2.70.130.10:FF:000077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123460, NULL, 'G3DSA:3.40.1440.10:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123461, NULL, 'G3DSA:1.20.58.60:FF:000271', NULL, NULL, 'Spectrin repeat containing nuclear envelope protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(123462, NULL, 'G3DSA:4.10.40.10:FF:000001', NULL, NULL, 'Omega-agatoxin-Aa4a', NULL, NULL, NULL, NULL, NULL, 4),
(123463, NULL, 'G3DSA:3.30.1410.10:FF:000002', NULL, NULL, 'GCHFR, GFRP: GTP cyclohydrolase 1 feedback regulatory protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(123464, NULL, 'G3DSA:2.130.10.10:FF:002746', NULL, NULL, 'Os09g0477800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(123465, NULL, 'G3DSA:3.30.420.40:FF:000894', NULL, NULL, 'Acetate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(123466, NULL, 'G3DSA:3.40.50.720:FF:001714', NULL, NULL, 'Glyoxylate reductase/hydroxypyruvate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(123467, NULL, 'G3DSA:1.10.3090.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123468, NULL, 'G3DSA:3.30.70.330:FF:003138', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123469, NULL, 'G3DSA:1.25.40.20:FF:000281', NULL, NULL, 'Oxysterol binding protein (Osh1)', NULL, NULL, NULL, NULL, NULL, 4),
(123470, NULL, 'G3DSA:3.40.50.410:FF:000104', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(123471, NULL, 'G3DSA:2.60.40.10:FF:003286', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123472, NULL, 'G3DSA:2.60.200.20:FF:000015', NULL, NULL, 'E3 ubiquitin-protein ligase RNF8', NULL, NULL, NULL, NULL, NULL, 4),
(123473, NULL, 'G3DSA:3.40.190.10:FF:000230', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(123474, NULL, 'G3DSA:1.20.1310.10:FF:000133', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123475, NULL, 'G3DSA:3.40.1190.20:FF:000108', NULL, NULL, 'PfkB domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(123476, NULL, 'G3DSA:3.40.50.1440:FF:000120', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(123477, NULL, 'G3DSA:1.10.287.660:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123478, NULL, 'G3DSA:1.10.1670.10:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123479, NULL, 'G3DSA:1.10.600.10:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123480, NULL, 'G3DSA:1.10.10.10:FF:001664', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(123481, NULL, 'G3DSA:3.80.10.10:FF:001252', NULL, NULL, 'Fish-lips, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(123482, NULL, 'G3DSA:3.40.50.300:FF:000835', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(123483, NULL, 'G3DSA:3.20.20.10:FF:000075', NULL, NULL, 'Ornithine decarboxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(123484, NULL, 'G3DSA:1.10.287.70:FF:000559', NULL, NULL, 'Cyclic nucleotide-gated cation channel', NULL, NULL, NULL, NULL, NULL, 4),
(123485, NULL, 'G3DSA:3.40.30.10:FF:000063', NULL, NULL, '2-Cys peroxiredoxin BAS1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(123486, NULL, 'G3DSA:1.25.40.10:FF:001441', NULL, NULL, 'Putative TPR repeat family protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(123487, NULL, 'G3DSA:3.40.50.300:FF:005186', NULL, NULL, 'Shikimate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(123488, NULL, 'G3DSA:1.20.1270.10:FF:000045', NULL, NULL, 'Heat shock protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(123489, NULL, 'G3DSA:2.120.10.80:FF:000238', NULL, NULL, 'Peptidase S8 and S53 subtilisin kexin sedolisin', NULL, NULL, NULL, NULL, NULL, 4),
(123490, NULL, 'G3DSA:1.20.1730.10:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123491, NULL, 'G3DSA:2.60.40.10:FF:004275', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123492, NULL, 'G3DSA:1.20.1530.20:FF:000001', NULL, NULL, 'Glutathione-regulated potassium-efflux system protein KefB', NULL, NULL, NULL, NULL, NULL, 4),
(123493, NULL, 'G3DSA:3.40.640.10:FF:000276', NULL, NULL, '40S ribosomal protein S4-3', NULL, NULL, NULL, NULL, NULL, 4),
(123494, NULL, 'G3DSA:2.130.10.10:FF:000537', NULL, NULL, 'Ribosome biogenesis protein ENP2', NULL, NULL, NULL, NULL, NULL, 4),
(123495, NULL, 'G3DSA:3.50.50.60:FF:001315', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(123496, NULL, 'G3DSA:3.40.50.1240:FF:000032', NULL, NULL, 'Blast:Protein UBASH3A homolog', NULL, NULL, NULL, NULL, NULL, 4),
(123497, NULL, 'G3DSA:1.20.1070.10:FF:001053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123498, NULL, 'G3DSA:3.30.70.330:FF:000912', NULL, NULL, 'Probable RNA-binding protein ARP1', NULL, NULL, NULL, NULL, NULL, 4),
(123499, NULL, 'G3DSA:3.40.720.10:FF:000277', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(123500, NULL, 'G3DSA:3.60.130.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123501, NULL, 'G3DSA:3.30.710.10:FF:000273', NULL, NULL, 'Hypermethylated in cancer 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(123502, NULL, 'G3DSA:3.30.40.10:FF:001514', NULL, NULL, 'Zinc finger domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(123503, NULL, 'G3DSA:2.60.40.60:FF:000434', NULL, NULL, 'Cadherin-4', NULL, NULL, NULL, NULL, NULL, 4),
(123504, NULL, 'G3DSA:1.20.1070.10:FF:001261', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123505, NULL, 'G3DSA:1.10.10.60:FF:000526', NULL, NULL, 'Transcriptional regulator, TetR family', NULL, NULL, NULL, NULL, NULL, 4),
(123506, NULL, 'G3DSA:2.60.40.790:FF:000193', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123507, NULL, 'G3DSA:2.60.40.10:FF:000413', NULL, NULL, 'Down syndrome cell adhesion molecule, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(123508, NULL, 'G3DSA:3.30.342.10:FF:000035', NULL, NULL, 'DNA polymerase epsilon catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(123509, NULL, 'G3DSA:3.30.160.60:FF:003819', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123510, NULL, 'G3DSA:3.10.400.10:FF:000006', NULL, NULL, 'Sulfate adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(123511, NULL, 'G3DSA:2.10.70.10:FF:000086', NULL, NULL, 'Hig-anchoring scaffold protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(123512, NULL, 'G3DSA:2.60.120.20:FF:000014', NULL, NULL, 'Structural polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(123513, NULL, 'G3DSA:1.10.1070.11:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123514, NULL, 'G3DSA:1.10.238.10:FF:000400', NULL, NULL, 'EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(123515, NULL, 'G3DSA:3.40.50.11540:FF:000001', NULL, NULL, 'NADH dehydrogenase [ubiquinone] flavoprotein 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(123516, NULL, 'G3DSA:3.30.70.330:FF:003077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123517, NULL, 'G3DSA:2.30.40.10:FF:000095', NULL, NULL, 'Guanine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(123518, NULL, 'G3DSA:3.40.50.10330:FF:000032', NULL, NULL, 'NADH kinase pos5, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(123519, NULL, 'G3DSA:1.10.287.470:FF:000011', NULL, NULL, 'Efflux transporter, RND family, MFP subunit', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(123520, NULL, 'G3DSA:1.10.620.20:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123521, NULL, 'G3DSA:3.40.50.300:FF:000251', NULL, NULL, 'ABC transporter B family member 19', NULL, NULL, NULL, NULL, NULL, 4),
(123522, NULL, 'G3DSA:3.30.70.1590:FF:000004', NULL, NULL, 'unconventional myosin-XVIIIa isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(123523, NULL, 'G3DSA:3.40.1360.10:FF:000023', NULL, NULL, 'DNA topoisomerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(123524, NULL, 'G3DSA:1.10.510.10:FF:003726', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123525, NULL, 'G3DSA:3.90.1450.10:FF:000002', NULL, NULL, 'Guanylate cyclase activator 2A', NULL, NULL, NULL, NULL, NULL, 4),
(123526, NULL, 'G3DSA:3.40.50.2300:FF:001255', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123527, NULL, 'G3DSA:2.60.40.10:FF:002622', NULL, NULL, 'Immunoglobulin light 3 variable 2', NULL, NULL, NULL, NULL, NULL, 4),
(123528, NULL, 'G3DSA:3.60.160.10:FF:000004', NULL, NULL, 'Altered inheritance of mitochondria protein 24, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(123529, NULL, 'G3DSA:2.40.30.10:FF:000189', NULL, NULL, 'Cytochrome C', NULL, NULL, NULL, NULL, NULL, 4),
(123530, NULL, 'G3DSA:2.30.280.10:FF:000001', NULL, NULL, 'E3 ubiquitin-protein ligase UHRF1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(123531, NULL, 'G3DSA:2.60.40.10:FF:005348', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123532, NULL, 'G3DSA:3.90.1150.180:FF:000001', NULL, NULL, 'L-seryl-tRNA(Sec) selenium transferase', NULL, NULL, NULL, NULL, NULL, 4),
(123533, NULL, 'G3DSA:3.30.200.20:FF:000809', NULL, NULL, 'Ser/Thr Kinase', NULL, NULL, NULL, NULL, NULL, 4),
(123534, NULL, 'G3DSA:2.60.40.1730:FF:000023', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(123535, NULL, 'G3DSA:3.30.1330.30:FF:000007', NULL, NULL, '23S rRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(123536, NULL, 'G3DSA:3.40.50.10490:FF:000147', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123537, NULL, 'G3DSA:3.30.160.60:FF:003235', NULL, NULL, 'Blast:Transcription factor grauzone', NULL, NULL, NULL, NULL, NULL, 4),
(123538, NULL, 'G3DSA:3.30.1330.10:FF:000001', NULL, NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(123539, NULL, 'G3DSA:2.60.120.10:FF:000157', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(123540, NULL, 'G3DSA:3.40.1280.30:FF:000028', NULL, NULL, 'tRNA methyltransferase 10 homolog C', NULL, NULL, NULL, NULL, NULL, 4),
(123541, NULL, 'G3DSA:3.40.50.150:FF:001318', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123542, NULL, 'G3DSA:1.20.1270.280:FF:000009', NULL, NULL, 'Dynein, axonemal, heavy chain 6', NULL, NULL, NULL, NULL, NULL, 4),
(123543, NULL, 'G3DSA:1.20.58.1610:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123544, NULL, 'G3DSA:3.40.1010.10:FF:000003', NULL, NULL, 'Putative Uroporphyrinogen-III C-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(123545, NULL, 'G3DSA:1.10.10.10:FF:001080', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(123546, NULL, 'G3DSA:1.10.510.10:FF:001517', NULL, NULL, 'Protein kinase domain containing protein expressed', NULL, NULL, NULL, NULL, NULL, 4),
(123547, NULL, 'G3DSA:3.90.190.10:FF:000089', NULL, NULL, 'Cyclin dependent kinase inhibitor 3', NULL, NULL, NULL, NULL, NULL, 4),
(123548, NULL, 'G3DSA:2.160.20.10:FF:000295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123549, NULL, 'G3DSA:3.40.367.20:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123550, NULL, 'G3DSA:1.20.1250.20:FF:001480', NULL, NULL, 'Solute carrier family 22 member 7b, tandem duplicate 2', NULL, NULL, NULL, NULL, NULL, 4),
(123551, NULL, 'G3DSA:3.20.20.105:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123552, NULL, 'G3DSA:3.30.160.60:FF:004724', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(123553, NULL, 'G3DSA:3.30.70.100:FF:000017', NULL, NULL, 'Protein NipSnap homolog 3A', NULL, NULL, NULL, NULL, NULL, 4),
(123554, NULL, 'G3DSA:1.20.1070.10:FF:001614', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123555, NULL, 'G3DSA:3.30.710.10:FF:000065', NULL, NULL, 'zinc finger and BTB domain-containing protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(123556, NULL, 'G3DSA:3.30.450.40:FF:000250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123557, NULL, 'G3DSA:1.20.80.10:FF:000077', NULL, NULL, 'Myosin-I heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(123558, NULL, 'G3DSA:3.30.300.30:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123559, NULL, 'G3DSA:1.10.510.10:FF:004131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123560, NULL, 'G3DSA:2.40.50.40:FF:000087', NULL, NULL, 'Chemokine (C-C motif) ligand 34b, duplicate 4', NULL, NULL, NULL, NULL, NULL, 4),
(123561, NULL, 'G3DSA:1.10.10.160:FF:000018', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(123562, NULL, 'G3DSA:3.40.720.10:FF:000338', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123563, NULL, 'G3DSA:1.20.1060.20:FF:000009', NULL, NULL, 'Chromosome partition protein Smc', NULL, NULL, NULL, NULL, NULL, 4),
(123564, NULL, 'G3DSA:1.10.890.20:FF:000002', NULL, NULL, 'Chalcone-flavonone isomerase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(123565, NULL, 'G3DSA:3.30.9.10:FF:000172', NULL, NULL, 'N-methyl-L-tryptophan oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(123566, NULL, 'G3DSA:3.10.20.90:FF:000374', NULL, NULL, 'Motor AXon guidance', NULL, NULL, NULL, NULL, NULL, 4),
(123567, NULL, 'G3DSA:3.80.10.10:FF:001044', NULL, NULL, 'F-box protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(123568, NULL, 'G3DSA:3.40.718.10:FF:000069', NULL, NULL, 'Isocitrate dehydrogenase [NADP]', NULL, NULL, NULL, NULL, NULL, 4),
(123569, NULL, 'G3DSA:3.40.630.10:FF:000511', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123570, NULL, 'G3DSA:1.25.40.10:FF:000536', NULL, NULL, 'Regulator of microtubule dynamics protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(123571, NULL, 'G3DSA:3.30.9.10:FF:000025', NULL, NULL, 'Oxidoreductase, FAD dependent', NULL, NULL, NULL, NULL, NULL, 4),
(123572, NULL, 'G3DSA:3.40.1090.10:FF:000098', NULL, NULL, 'Phospholipase A2', NULL, NULL, NULL, NULL, NULL, 4),
(123573, NULL, 'G3DSA:1.10.418.80:FF:000002', NULL, NULL, 'Ubiquitin C-terminal hydrolase L3', NULL, NULL, NULL, NULL, NULL, 4),
(123574, NULL, 'G3DSA:1.10.150.120:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123575, NULL, 'G3DSA:1.25.10.10:FF:001260', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(123576, NULL, 'G3DSA:3.80.10.10:FF:002325', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(123577, NULL, 'G3DSA:2.130.10.10:FF:003151', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', NULL, NULL, NULL, NULL, NULL, 4),
(123578, NULL, 'G3DSA:1.50.40.10:FF:000591', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123579, NULL, 'G3DSA:3.30.450.30:FF:000005', NULL, NULL, 'Ragulator complex protein LAMTOR5 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(123580, NULL, 'G3DSA:3.10.120.10:FF:000024', NULL, NULL, 'L-lactate dehydrogenase (Cytochrome), putative', NULL, NULL, NULL, NULL, NULL, 4),
(123581, NULL, 'G3DSA:1.10.238.10:FF:000900', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123582, NULL, 'G3DSA:2.60.120.330:FF:000087', NULL, NULL, 'OSJNBa0073E02.10 protein', NULL, NULL, NULL, NULL, NULL, 4),
(123583, NULL, 'G3DSA:2.40.10.10:FF:000126', NULL, NULL, 'TISP43 isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(123584, NULL, 'G3DSA:3.40.640.10:FF:000484', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123585, NULL, 'G3DSA:3.40.50.970:FF:000103', NULL, NULL, '2-succinyl-5-enolpyruvyl-6-hydroxy-3-cyclohexene-1-carboxylate synthase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(123586, NULL, 'G3DSA:1.10.287.380:FF:000017', NULL, NULL, 'Holdfast attachment protein C', NULL, NULL, NULL, NULL, NULL, 4),
(123587, NULL, 'G3DSA:3.40.50.2000:FF:000827', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123588, NULL, 'G3DSA:3.40.50.620:FF:000493', NULL, NULL, 'Probable electron transfer flavoprotein alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(123589, NULL, 'G3DSA:3.40.50.10190:FF:000063', NULL, NULL, 'Pebble, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(123590, NULL, 'G3DSA:1.10.287.130:FF:000050', NULL, NULL, 'Related to histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(123591, NULL, 'G3DSA:2.70.170.10:FF:000231', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(123592, NULL, 'G3DSA:1.20.58.60:FF:000832', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123593, NULL, 'G3DSA:3.40.50.1010:FF:000165', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123594, NULL, 'G3DSA:1.10.1200.10:FF:000110', NULL, NULL, 'Acyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(123595, NULL, 'G3DSA:2.60.40.10:FF:004067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123596, NULL, 'G3DSA:3.40.50.80:FF:000186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123597, NULL, 'G3DSA:3.40.50.2300:FF:000327', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(123598, NULL, 'G3DSA:3.60.40.10:FF:000046', NULL, NULL, 'Probable protein phosphatase 2C 9', NULL, NULL, NULL, NULL, NULL, 4),
(123599, NULL, 'G3DSA:3.30.70.330:FF:002621', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123600, NULL, 'G3DSA:3.10.129.110:FF:000008', NULL, NULL, 'Phenolpthiocerol synthesis type-I polyketide synthase ppsA', NULL, NULL, NULL, NULL, NULL, 4),
(123601, NULL, 'G3DSA:3.90.660.10:FF:000081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123602, NULL, 'G3DSA:2.130.10.10:FF:002246', NULL, NULL, 'Autophagy-related protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(123603, NULL, 'G3DSA:2.30.40.10:FF:000156', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(123604, NULL, 'G3DSA:3.40.50.720:FF:000225', NULL, NULL, 'Dihydrofolate reductase FolM', NULL, NULL, NULL, NULL, NULL, 4),
(123605, NULL, 'G3DSA:3.30.200.20:FF:001384', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(123606, NULL, 'G3DSA:3.30.40.10:FF:001306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123607, NULL, 'G3DSA:2.10.220.10:FF:000215', NULL, NULL, 'Erb-b2 receptor tyrosine kinase 3a', NULL, NULL, NULL, NULL, NULL, 4),
(123608, NULL, 'G3DSA:3.40.30.10:FF:000563', NULL, NULL, 'Thiol-dependent reductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(123609, NULL, 'G3DSA:3.90.70.80:FF:000016', NULL, NULL, 'Putative ubiquitin thioesterase otu1', NULL, NULL, NULL, NULL, NULL, 4),
(123610, NULL, 'G3DSA:4.10.400.10:FF:000115', NULL, NULL, 'integral membrane protein DGCR2/IDD isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(123611, NULL, 'G3DSA:3.10.250.10:FF:000028', NULL, NULL, 'T-cell surface glycoprotein CD5', NULL, NULL, NULL, NULL, NULL, 4),
(123612, NULL, 'G3DSA:3.40.30.10:FF:000619', NULL, NULL, 'Protein disulfide isomerase family A member 2', NULL, NULL, NULL, NULL, NULL, 4),
(123613, NULL, 'G3DSA:1.50.40.10:FF:000444', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123614, NULL, 'G3DSA:3.90.1150.10:FF:000193', NULL, NULL, '8-amino-7-oxononanoate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(123615, NULL, 'G3DSA:2.60.120.10:FF:000365', NULL, NULL, 'cAMP-dependent protein kinase regulatory chain', NULL, NULL, NULL, NULL, NULL, 4),
(123616, NULL, 'G3DSA:2.10.25.10:FF:001768', NULL, NULL, 'Brevican', NULL, NULL, NULL, NULL, NULL, 4),
(123617, NULL, 'G3DSA:4.10.240.10:FF:000113', NULL, NULL, 'C6 finger domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(123618, NULL, 'G3DSA:3.40.140.10:FF:000283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123619, NULL, 'G3DSA:3.40.50.300:FF:005394', NULL, NULL, 'ABC transporter G family member 16', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(123620, NULL, 'G3DSA:1.10.630.10:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123621, NULL, 'G3DSA:1.10.287.550:FF:000001', NULL, NULL, 'Arylsulfatase E', NULL, NULL, NULL, NULL, NULL, 4),
(123622, NULL, 'G3DSA:3.30.160.60:FF:000981', NULL, NULL, 'ras-responsive element-binding protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(123623, NULL, 'G3DSA:3.10.580.10:FF:000137', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(123624, NULL, 'G3DSA:2.40.40.20:FF:000052', NULL, NULL, 'Transitional endoplasmic reticulum ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(123625, NULL, 'G3DSA:3.40.190.10:FF:000847', NULL, NULL, 'Polar amino acid uptake family ABC transporter, periplasmic substrate-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(123626, NULL, 'G3DSA:1.10.287.370:FF:000071', NULL, NULL, 'Prefoldin subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(123627, NULL, 'G3DSA:3.30.70.330:FF:001429', NULL, NULL, 'Polyadenylate-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(123628, NULL, 'G3DSA:3.30.43.10:FF:000003', NULL, NULL, 'Alkylglycerone-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(123629, NULL, 'G3DSA:3.50.50.60:FF:000798', NULL, NULL, 'FAD/NAD(P)-binding oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(123630, NULL, 'G3DSA:2.30.30.100:FF:000154', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm3', NULL, NULL, NULL, NULL, NULL, 4),
(123631, NULL, 'G3DSA:1.25.40.1040:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123632, NULL, 'G3DSA:1.10.238.10:FF:001064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123633, NULL, 'G3DSA:2.80.10.50:FF:000147', NULL, NULL, 'Botulinum neurotoxin type C', NULL, NULL, NULL, NULL, NULL, 4),
(123634, NULL, 'G3DSA:3.30.70.3250:FF:000002', NULL, NULL, 'ribonuclease P protein subunit p14', NULL, NULL, NULL, NULL, NULL, 4),
(123635, NULL, 'G3DSA:2.60.40.10:FF:005556', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123636, NULL, 'G3DSA:3.30.160.60:FF:006169', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123637, NULL, 'G3DSA:3.90.380.10:FF:000008', NULL, NULL, 'Aromatic ring-hydroxylating dioxygenase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(123638, NULL, 'G3DSA:2.10.25.10:FF:000279', NULL, NULL, 'Neurogenic locus notch 1', NULL, NULL, NULL, NULL, NULL, 4),
(123639, NULL, 'G3DSA:3.40.630.30:FF:000517', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(123640, NULL, 'G3DSA:3.30.420.40:FF:000686', NULL, NULL, 'N-acetylmuramic acid/N-acetylglucosamine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(123641, NULL, 'G3DSA:3.90.190.10:FF:000589', NULL, NULL, 'Si:ch1073-391i24.1', NULL, NULL, NULL, NULL, NULL, 4),
(123642, NULL, 'G3DSA:3.10.100.10:FF:000169', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123643, NULL, 'G3DSA:3.40.50.2300:FF:001608', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123644, NULL, 'G3DSA:1.10.287.570:FF:000007', NULL, NULL, 'Borate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(123645, NULL, 'G3DSA:1.10.1520.10:FF:000005', NULL, NULL, 'Putative endoribonuclease dicer', NULL, NULL, NULL, NULL, NULL, 4),
(123646, NULL, 'G3DSA:3.40.33.10:FF:000013', NULL, NULL, 'SCP-Like extracellular protein', NULL, NULL, NULL, NULL, NULL, 4),
(123647, NULL, 'G3DSA:3.40.50.300:FF:001499', NULL, NULL, 'Origin recognition complex subunit 4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(123648, NULL, 'G3DSA:1.20.1420.10:FF:000023', NULL, NULL, 'Talin', NULL, NULL, NULL, NULL, NULL, 4),
(123649, NULL, 'G3DSA:3.80.10.10:FF:002797', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(123650, NULL, 'G3DSA:1.10.510.10:FF:000500', NULL, NULL, 'serine/threonine-protein kinase SBK1', NULL, NULL, NULL, NULL, NULL, 4),
(123651, NULL, 'G3DSA:3.30.40.10:FF:001778', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123652, NULL, 'G3DSA:1.25.40.20:FF:000781', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(123653, NULL, 'G3DSA:2.30.30.40:FF:000226', NULL, NULL, 'Chemotaxis protein CheV', NULL, NULL, NULL, NULL, NULL, 4),
(123654, NULL, 'G3DSA:1.20.1420.30:FF:000029', NULL, NULL, 'Calcium/proton exchanger', NULL, NULL, NULL, NULL, NULL, 4),
(123655, NULL, 'G3DSA:1.10.510.10:FF:003226', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123656, NULL, 'G3DSA:1.25.40.570:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123657, NULL, 'G3DSA:1.20.1270.10:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123658, NULL, 'G3DSA:1.20.120.340:FF:000009', NULL, NULL, 'Perilipin', NULL, NULL, NULL, NULL, NULL, 4),
(123659, NULL, 'G3DSA:1.20.58.760:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123660, NULL, 'G3DSA:3.30.70.3270:FF:000008', NULL, NULL, 'NADH-quinone oxidoreductase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(123661, NULL, 'G3DSA:3.40.250.10:FF:000173', NULL, NULL, 'Rhodanese homology domain superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(123662, NULL, 'G3DSA:1.10.1440.10:FF:000004', NULL, NULL, 'Plant Late Embryo Abundant (LEA) related', NULL, NULL, NULL, NULL, NULL, 4),
(123663, NULL, 'G3DSA:3.40.50.10900:FF:000017', NULL, NULL, 'Proteasome assembly chaperone 2', NULL, NULL, NULL, NULL, NULL, 4),
(123664, NULL, 'G3DSA:3.90.550.10:FF:000252', NULL, NULL, 'Protein O-linked-mannose beta-1,2-N-acetylglucosaminyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(123665, NULL, 'G3DSA:3.30.160.60:FF:004988', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123666, NULL, 'G3DSA:2.40.50.90:FF:000085', NULL, NULL, 'Tudor, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(123667, NULL, 'G3DSA:3.90.640.10:FF:000079', NULL, NULL, 'Chaperone protein HscA homolog', NULL, NULL, NULL, NULL, NULL, 4),
(123668, NULL, 'G3DSA:2.60.40.10:FF:000060', NULL, NULL, 'Myosin-binding protein C, slow type', NULL, NULL, NULL, NULL, NULL, 4),
(123669, NULL, 'G3DSA:3.40.50.300:FF:004989', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(123670, NULL, 'G3DSA:1.10.3210.10:FF:000050', NULL, NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(123671, NULL, 'G3DSA:2.60.120.650:FF:000042', NULL, NULL, 'Transcription factor jumonji (JmjC) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(123672, NULL, 'G3DSA:1.20.5.110:FF:000026', NULL, NULL, 'BET1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(123673, NULL, 'G3DSA:1.20.120.1110:FF:000006', NULL, NULL, 'TAF (TBP-associated transcription factor) family', NULL, NULL, NULL, NULL, NULL, 4),
(123674, NULL, 'G3DSA:2.40.70.10:FF:000343', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123675, NULL, 'G3DSA:1.10.418.30:FF:000004', NULL, NULL, 'Kinetochore protein ndc-80', NULL, NULL, NULL, NULL, NULL, 4),
(123676, NULL, 'G3DSA:2.10.25.10:FF:000543', NULL, NULL, 'Merozoite surface antigen 1', NULL, NULL, NULL, NULL, NULL, 4),
(123677, NULL, 'G3DSA:3.40.1190.20:FF:000052', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(123678, NULL, 'G3DSA:1.10.10.60:FF:001307', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123679, NULL, 'G3DSA:3.40.50.300:FF:006411', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123680, NULL, 'G3DSA:2.60.40.640:FF:000108', NULL, NULL, 'Down syndrome critical region protein 3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(123681, NULL, 'G3DSA:3.40.630.10:FF:000247', NULL, NULL, 'N-acetyl-L,L-diaminopimelate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(123682, NULL, 'G3DSA:2.40.150.20:FF:000032', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(123683, NULL, 'G3DSA:2.40.170.20:FF:000095', NULL, NULL, 'TonB-dependent receptor', NULL, NULL, NULL, NULL, NULL, 4),
(123684, NULL, 'G3DSA:3.30.70.330:FF:001840', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123685, NULL, 'G3DSA:1.20.1260.10:FF:000016', NULL, NULL, 'Ferritin heavy chain', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(123686, NULL, 'G3DSA:3.30.450.80:FF:000003', NULL, NULL, 'LuxR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(123687, NULL, 'G3DSA:3.30.160.60:FF:002779', NULL, NULL, 'Zinc fingers and homeoboxes 3', NULL, NULL, NULL, NULL, NULL, 4),
(123688, NULL, 'G3DSA:2.130.10.10:FF:001465', NULL, NULL, 'Chromatin assembly factor 1 subunit FAS2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(123689, NULL, 'G3DSA:3.10.105.10:FF:000129', NULL, NULL, 'Putative bifunctional protein [include methyl-accepting chemotaxis protein and an extracellular solute-binding protein]', NULL, NULL, NULL, NULL, NULL, 4),
(123690, NULL, 'G3DSA:3.30.420.40:FF:000422', NULL, NULL, 'Chaperone protein DNAK, putative', NULL, NULL, NULL, NULL, NULL, 4),
(123691, NULL, 'G3DSA:3.90.190.10:FF:000325', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123692, NULL, 'G3DSA:1.20.1280.50:FF:000035', NULL, NULL, 'F-box/LRR-repeat protein 6 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(123693, NULL, 'G3DSA:1.25.40.10:FF:003150', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g30700', NULL, NULL, NULL, NULL, NULL, 4),
(123694, NULL, 'G3DSA:3.40.50.1820:FF:000582', NULL, NULL, 'Chlorophyllase-1', NULL, NULL, NULL, NULL, NULL, 4),
(123695, NULL, 'G3DSA:1.10.510.10:FF:000236', NULL, NULL, 'Casein kinase 1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(123696, NULL, 'G3DSA:2.30.140.10:FF:000019', NULL, NULL, 'SPermiDine Synthase', NULL, NULL, NULL, NULL, NULL, 4),
(123697, NULL, 'G3DSA:3.30.70.1170:FF:000030', NULL, NULL, 'NOL1/NOP2/Sun (TRNA and rRNA cytosine-C5-methyltransferase) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(123698, NULL, 'G3DSA:3.40.50.300:FF:001740', NULL, NULL, 'Obg-like ATPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(123699, NULL, 'G3DSA:4.10.830.40:FF:000004', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(123700, NULL, 'G3DSA:1.20.970.10:FF:000032', NULL, NULL, 'Anthranilate synthase component II', NULL, NULL, NULL, NULL, NULL, 4),
(123701, NULL, 'G3DSA:3.40.50.720:FF:000933', NULL, NULL, 'Putative beta-ketoacyl-(Acyl-carrier-protein) reductase', NULL, NULL, NULL, NULL, NULL, 4),
(123702, NULL, 'G3DSA:3.40.930.10:FF:000023', NULL, NULL, 'HPr family phosphocarrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(123703, NULL, 'G3DSA:3.30.40.10:FF:000289', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(123704, NULL, 'G3DSA:1.10.472.10:FF:000135', NULL, NULL, 'Cyclin G', NULL, NULL, NULL, NULL, NULL, 4),
(123705, NULL, 'G3DSA:2.60.40.10:FF:001341', NULL, NULL, 'Sidestep, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(123706, NULL, 'G3DSA:3.30.505.10:FF:000015', NULL, NULL, 'Growth factor receptor-bound protein 10 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(123707, NULL, 'G3DSA:3.30.450.20:FF:000564', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123708, NULL, 'G3DSA:3.90.660.20:FF:000027', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(123709, NULL, 'G3DSA:1.25.10.10:FF:000708', NULL, NULL, 'Probable SPO76 protein', NULL, NULL, NULL, NULL, NULL, 4),
(123710, NULL, 'G3DSA:1.10.510.10:FF:001989', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(123711, NULL, 'G3DSA:3.40.50.1260:FF:000043', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(123712, NULL, 'G3DSA:1.10.10.10:FF:000736', NULL, NULL, 'transcription factor Spi-C-like isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(123713, NULL, 'G3DSA:3.40.50.300:FF:008620', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123714, NULL, 'G3DSA:2.130.10.10:FF:003674', NULL, NULL, 'WD repeat domain 62', NULL, NULL, NULL, NULL, NULL, 4),
(123715, NULL, 'G3DSA:3.30.930.10:FF:000401', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(123716, NULL, 'G3DSA:3.30.760.10:FF:000068', NULL, NULL, 'Eukaryotic translation initiation factor 4E-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(123717, NULL, 'G3DSA:1.20.900.10:FF:000027', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(123718, NULL, 'G3DSA:1.20.5.730:FF:000004', NULL, NULL, 'SGO1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(123719, NULL, 'G3DSA:2.30.29.170:FF:000015', NULL, NULL, 'GM23827', NULL, NULL, NULL, NULL, NULL, 4),
(123720, NULL, 'G3DSA:2.60.120.260:FF:000251', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(123721, NULL, 'G3DSA:3.80.10.10:FF:003814', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123722, NULL, 'G3DSA:3.90.700.10:FF:000017', NULL, NULL, '3-ketosteroid dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(123723, NULL, 'G3DSA:1.25.40.10:FF:003706', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123724, NULL, 'G3DSA:3.90.226.10:FF:000162', NULL, NULL, 'Similar to propionyl-CoA carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(123725, NULL, 'G3DSA:3.80.20.20:FF:000002', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(123726, NULL, 'G3DSA:3.40.50.20:FF:000011', NULL, NULL, 'CAD protein-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(123727, NULL, 'G3DSA:3.80.10.10:FF:004478', NULL, NULL, 'Putative leucine-rich repeat receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(123728, NULL, 'G3DSA:2.130.10.10:FF:001318', NULL, NULL, 'RNA polymerase II Elongator subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(123729, NULL, 'G3DSA:1.25.10.10:FF:002541', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123730, NULL, 'G3DSA:3.90.1580.10:FF:000011', NULL, NULL, 'Gliding motility lipoprotein GldK', NULL, NULL, NULL, NULL, NULL, 4),
(123731, NULL, 'G3DSA:2.60.40.10:FF:006012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123732, NULL, 'G3DSA:2.130.10.10:FF:004899', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123733, NULL, 'G3DSA:1.20.1070.10:FF:000597', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(123734, NULL, 'G3DSA:1.20.1070.10:FF:000333', NULL, NULL, 'Relaxin receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(123735, NULL, 'G3DSA:2.10.25.10:FF:000690', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123736, NULL, 'G3DSA:3.20.190.10:FF:000009', NULL, NULL, 'Unplaced genomic scaffold supercont1.232, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(123737, NULL, 'G3DSA:1.20.120.730:FF:000003', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(123738, NULL, 'G3DSA:1.10.555.10:FF:000261', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123739, NULL, 'G3DSA:1.25.40.10:FF:004898', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123740, NULL, 'G3DSA:2.60.40.1120:FF:000082', NULL, NULL, 'Peptidase S8 and S53 subtilisin kexin sedolisin', NULL, NULL, NULL, NULL, NULL, 4),
(123741, NULL, 'G3DSA:1.10.287.1490:FF:000121', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(123742, NULL, 'G3DSA:1.10.150.50:FF:000181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123743, NULL, 'G3DSA:3.80.10.10:FF:001605', NULL, NULL, 'Inactive leucine-rich repeat receptor-like protein kinase isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(123744, NULL, 'G3DSA:3.30.160.60:FF:004016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123745, NULL, 'G3DSA:2.60.40.10:FF:001902', NULL, NULL, 'Biofilm-promoting protein BpfA', NULL, NULL, NULL, NULL, NULL, 4),
(123746, NULL, 'G3DSA:3.30.1520.10:FF:000156', NULL, NULL, 'Sorting nexin 6', NULL, NULL, NULL, NULL, NULL, 4),
(123747, NULL, 'G3DSA:1.10.437.10:FF:000065', NULL, NULL, 'BCL2-associated X, apoptosis regulator a', NULL, NULL, NULL, NULL, NULL, 4),
(123748, NULL, 'G3DSA:2.130.10.10:FF:000801', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(123749, NULL, 'G3DSA:1.25.10.10:FF:003058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123750, NULL, 'G3DSA:1.10.630.10:FF:000716', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(123751, NULL, 'G3DSA:2.120.10.30:FF:000072', NULL, NULL, 'Blast:Prolow-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(123752, NULL, 'G3DSA:1.20.1250.20:FF:000552', NULL, NULL, 'Pantothenate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(123753, NULL, 'G3DSA:3.30.1370.10:FF:000239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123754, NULL, 'G3DSA:3.30.70.940:FF:000033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(123755, NULL, 'G3DSA:1.25.40.180:FF:000262', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123756, NULL, 'G3DSA:1.10.486.10:FF:000077', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(123757, NULL, 'G3DSA:1.10.565.10:FF:000087', NULL, NULL, 'Estrogen-related receptor alpha', NULL, NULL, NULL, NULL, NULL, 4),
(123758, NULL, 'G3DSA:1.10.238.10:FF:000136', NULL, NULL, 'Calpain small subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(123759, NULL, 'G3DSA:2.20.100.10:FF:000070', NULL, NULL, 'SCO-spondin', NULL, NULL, NULL, NULL, NULL, 4),
(123760, NULL, 'G3DSA:3.40.50.300:FF:002516', NULL, NULL, 'YDR020C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(123761, NULL, 'G3DSA:1.10.630.10:FF:000008', NULL, NULL, 'Cytochrome P450 71D8', NULL, NULL, NULL, NULL, NULL, 4),
(123762, NULL, 'G3DSA:1.25.40.860:FF:000016', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(123763, NULL, 'G3DSA:3.30.1010.10:FF:000073', NULL, NULL, 'Putative phosphatidylinositol 4-kinase alpha-like protein P2', NULL, NULL, NULL, NULL, NULL, 4),
(123764, NULL, 'G3DSA:3.30.70.330:FF:002357', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123765, NULL, 'G3DSA:3.30.70.270:FF:000225', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123766, NULL, 'G3DSA:2.130.10.10:FF:005416', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123767, NULL, 'G3DSA:3.40.50.1360:FF:000039', NULL, NULL, 'Putative Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(123768, NULL, 'G3DSA:2.60.40.10:FF:004831', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123769, NULL, 'G3DSA:1.10.10.60:FF:001223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123770, NULL, 'G3DSA:2.10.25.10:FF:000807', NULL, NULL, 'Low-density lipoprotein receptor domain class A', NULL, NULL, NULL, NULL, NULL, 4),
(123771, NULL, 'G3DSA:2.40.170.10:FF:000002', NULL, NULL, 'Cryptic outer membrane porin BglH', NULL, NULL, NULL, NULL, NULL, 4),
(123772, NULL, 'G3DSA:3.30.70.270:FF:000164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123773, NULL, 'G3DSA:3.90.370.10:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123774, NULL, 'G3DSA:3.30.70.1230:FF:000065', NULL, NULL, 'Photoactivated adenylate cyclase subunit alpha-like protein ST-', NULL, NULL, NULL, NULL, NULL, 4),
(123775, NULL, 'G3DSA:3.20.20.540:FF:000001', NULL, NULL, 'Phosphomethylpyrimidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(123776, NULL, 'G3DSA:1.20.890.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123777, NULL, 'G3DSA:2.110.10.10:FF:000055', NULL, NULL, 'Paraflagellar rod component, putative', NULL, NULL, NULL, NULL, NULL, 4),
(123778, NULL, 'G3DSA:3.40.1110.10:FF:000123', NULL, NULL, 'Calcium motive P-type ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(123779, NULL, 'G3DSA:3.30.559.30:FF:000061', NULL, NULL, 'Nonribosomal peptide synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(123780, NULL, 'G3DSA:3.40.850.10:FF:000022', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(123781, NULL, 'G3DSA:2.60.40.10:FF:000560', NULL, NULL, 'Nectin cell adhesion molecule 4', NULL, NULL, NULL, NULL, NULL, 4),
(123782, NULL, 'G3DSA:1.20.1250.40:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123783, NULL, 'G3DSA:3.30.190.20:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123784, NULL, 'G3DSA:3.30.160.60:FF:005360', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(123785, NULL, 'G3DSA:3.40.50.300:FF:004141', NULL, NULL, 'Protein CBR-PRX-6', NULL, NULL, NULL, NULL, NULL, 4),
(123786, NULL, 'G3DSA:3.10.450.40:FF:000024', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(123787, NULL, 'G3DSA:1.10.510.10:FF:003198', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123788, NULL, 'G3DSA:2.60.40.150:FF:000613', NULL, NULL, 'Meiotically up-regulated gene 190 protein', NULL, NULL, NULL, NULL, NULL, 4),
(123789, NULL, 'G3DSA:3.30.230.70:FF:000158', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(123790, NULL, 'G3DSA:2.60.120.330:FF:000064', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(123791, NULL, 'G3DSA:3.40.50.12650:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123792, NULL, 'G3DSA:2.40.30.10:FF:000009', NULL, NULL, 'Eukaryotic translation initiation factor 2 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(123793, NULL, 'G3DSA:2.120.10.80:FF:000210', NULL, NULL, 'F-box/kelch-repeat protein At4g19330', NULL, NULL, NULL, NULL, NULL, 4),
(123794, NULL, 'G3DSA:2.40.10.10:FF:000103', NULL, NULL, 'Protease Do-like 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(123795, NULL, 'G3DSA:3.30.160.60:FF:001554', NULL, NULL, 'Zinc finger 202 m1', NULL, NULL, NULL, NULL, NULL, 4),
(123796, NULL, 'G3DSA:1.10.150.50:FF:000006', NULL, NULL, 'SH3 and multiple ankyrin repeat domains protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(123797, NULL, 'G3DSA:3.40.1110.10:FF:000067', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(123798, NULL, 'G3DSA:1.25.40.10:FF:001464', NULL, NULL, 'Protein CTR9-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(123799, NULL, 'G3DSA:3.40.50.1820:FF:000374', NULL, NULL, 'DiAcylGlycerol Lipase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(123800, NULL, 'G3DSA:3.10.450.10:FF:000009', NULL, NULL, 'Alpha-2-HS-glycoprotein 2', NULL, NULL, NULL, NULL, NULL, 4),
(123801, NULL, 'G3DSA:3.80.10.10:FF:003253', NULL, NULL, 'Leucine-rich repeat-containing protein sog2', NULL, NULL, NULL, NULL, NULL, 4),
(123802, NULL, 'G3DSA:3.40.710.10:FF:000012', NULL, NULL, 'Beta-lactamase', NULL, NULL, NULL, NULL, NULL, 4),
(123803, NULL, 'G3DSA:3.10.330.10:FF:000006', NULL, NULL, 'Peroxisome biogenesis factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(123804, NULL, 'G3DSA:3.30.1520.10:FF:000100', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(123805, NULL, 'G3DSA:2.60.260.40:FF:000002', NULL, NULL, 'NADH dehydrogenase [ubiquinone] iron-sulfur protein 6, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(123806, NULL, 'G3DSA:2.60.40.10:FF:004775', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123807, NULL, 'G3DSA:1.10.238.20:FF:000049', NULL, NULL, 'AGAP005182-PA', NULL, NULL, NULL, NULL, NULL, 4),
(123808, NULL, 'G3DSA:2.130.10.10:FF:005888', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123809, NULL, 'G3DSA:2.60.40.10:FF:005287', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123810, NULL, 'G3DSA:1.10.246.140:FF:000010', NULL, NULL, 'Transcription and mRNA export factor SUS1', NULL, NULL, NULL, NULL, NULL, 4),
(123811, NULL, 'G3DSA:3.40.50.300:FF:008412', NULL, NULL, 'Regulator of nonsense transcripts putative', NULL, NULL, NULL, NULL, NULL, 4),
(123812, NULL, 'G3DSA:3.50.50.60:FF:000298', NULL, NULL, 'Succinate dehydrogenase complex flavoprotein subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(123813, NULL, 'G3DSA:1.25.40.10:FF:001025', NULL, NULL, 'Protein KINESIN LIGHT CHAIN-RELATED 2', NULL, NULL, NULL, NULL, NULL, 4),
(123814, NULL, 'G3DSA:3.40.50.620:FF:000813', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123815, NULL, 'G3DSA:2.60.200.40:FF:000026', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(123816, NULL, 'G3DSA:3.30.160.60:FF:001993', NULL, NULL, 'Zinc finger protein 467', NULL, NULL, NULL, NULL, NULL, 4),
(123817, NULL, 'G3DSA:2.60.40.10:FF:005820', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(123818, NULL, 'G3DSA:2.170.130.10:FF:000036', NULL, NULL, 'Outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(123819, NULL, 'G3DSA:1.25.40.20:FF:001793', NULL, NULL, 'CARD- and ANK-containing Inflammasome Adaptor Protein', NULL, NULL, NULL, NULL, NULL, 4),
(123820, NULL, 'G3DSA:2.40.50.40:FF:000064', NULL, NULL, 'Signal recognition particle 43 kDa protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(123821, NULL, 'G3DSA:3.40.50.2000:FF:000299', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(123822, NULL, 'G3DSA:1.20.5.390:FF:000003', NULL, NULL, 'NF-kappa-B essential modulator isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(123823, NULL, 'G3DSA:3.30.70.330:FF:002593', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123824, NULL, 'G3DSA:3.30.9.30:FF:000003', NULL, NULL, 'FAD/NAD(P)-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(123825, NULL, 'G3DSA:2.30.29.30:FF:001024', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(123826, NULL, 'G3DSA:3.40.50.300:FF:005130', NULL, NULL, 'ATPase involved in chromosome partitioning-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(123827, NULL, 'G3DSA:1.10.1000.11:FF:000023', NULL, NULL, 'ARFGEF1', NULL, NULL, NULL, NULL, NULL, 4),
(123828, NULL, 'G3DSA:3.20.20.140:FF:000241', NULL, NULL, 'Selenium metabolism SsnA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(123829, NULL, 'G3DSA:1.10.238.10:FF:000636', NULL, NULL, 'calmodulin-like protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(123830, NULL, 'G3DSA:3.40.430.10:FF:000030', NULL, NULL, 'Dihydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(123831, NULL, 'G3DSA:1.25.40.20:FF:001298', NULL, NULL, 'GA binding protein transcription factor subunit beta 2b', NULL, NULL, NULL, NULL, NULL, 4),
(123832, NULL, 'G3DSA:1.10.30.10:FF:000119', NULL, NULL, 'High mobility group protein homolog TDP-1', NULL, NULL, NULL, NULL, NULL, 4),
(123833, NULL, 'G3DSA:1.25.40.10:FF:000952', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(123834, NULL, 'G3DSA:2.60.40.1860:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123835, NULL, 'G3DSA:3.40.50.300:FF:003185', NULL, NULL, 'Zinc finger, NFX1-type-containing 1, gene 2', NULL, NULL, NULL, NULL, NULL, 4),
(123836, NULL, 'G3DSA:2.60.40.1730:FF:000107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123837, NULL, 'G3DSA:1.10.10.10:FF:001164', NULL, NULL, 'SirA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(123838, NULL, 'G3DSA:3.30.70.330:FF:002121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123839, NULL, 'G3DSA:3.80.10.10:FF:003730', NULL, NULL, 'Leucine-rich repeat-containing protein let-4', NULL, NULL, NULL, NULL, NULL, 4),
(123840, NULL, 'G3DSA:2.130.10.10:FF:001673', NULL, NULL, 'GM19772', NULL, NULL, NULL, NULL, NULL, 4),
(123841, NULL, 'G3DSA:3.90.80.10:FF:000013', NULL, NULL, 'Pyrophosphatase (inorganic) 2', NULL, NULL, NULL, NULL, NULL, 4),
(123842, NULL, 'G3DSA:1.10.418.10:FF:000257', NULL, NULL, 'Flagellar associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(123843, NULL, 'G3DSA:2.40.110.10:FF:000026', NULL, NULL, '4-hydroxyphenylacetate 3-monooxygenase oxygenase component', NULL, NULL, NULL, NULL, NULL, 4),
(123844, NULL, 'G3DSA:3.40.525.10:FF:000025', NULL, NULL, 'PATELLIN 2', NULL, NULL, NULL, NULL, NULL, 4),
(123845, NULL, 'G3DSA:3.40.720.10:FF:000310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123846, NULL, 'G3DSA:1.10.238.200:FF:000011', NULL, NULL, 'DCN1-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(123847, NULL, 'G3DSA:1.20.1070.10:FF:000389', NULL, NULL, 'Galanin-like G-protein coupled receptor npr-9', NULL, NULL, NULL, NULL, NULL, 4),
(123848, NULL, 'G3DSA:1.10.510.10:FF:002214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123849, NULL, 'G3DSA:3.40.50.10490:FF:000063', NULL, NULL, 'SIS domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(123850, NULL, 'G3DSA:3.10.590.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(123851, NULL, 'G3DSA:4.10.1240.10:FF:000060', NULL, NULL, 'Adhesion G protein-coupled receptor B3', NULL, NULL, NULL, NULL, NULL, 4),
(123852, NULL, 'G3DSA:3.40.640.10:FF:000220', NULL, NULL, 'Kynureninase', NULL, NULL, NULL, NULL, NULL, 4),
(123853, NULL, 'G3DSA:2.60.40.10:FF:004303', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123854, NULL, 'G3DSA:3.30.160.60:FF:003319', NULL, NULL, 'U1 zinc finger family protein', NULL, NULL, NULL, NULL, NULL, 4),
(123855, NULL, 'G3DSA:1.10.472.10:FF:000719', NULL, NULL, 'G1/S-specific cyclin-E-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(123856, NULL, 'G3DSA:1.20.58.60:FF:000563', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123857, NULL, 'G3DSA:3.40.50.1820:FF:001627', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(123858, NULL, 'G3DSA:3.40.50.620:FF:000318', NULL, NULL, 'YML096W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(123859, NULL, 'G3DSA:1.10.555.10:FF:000114', NULL, NULL, 'RhoGAP domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(123860, NULL, 'G3DSA:1.20.1250.20:FF:002261', NULL, NULL, 'Potassium channel, putative', NULL, NULL, NULL, NULL, NULL, 4),
(123861, NULL, 'G3DSA:3.30.200.20:FF:001737', NULL, NULL, 'Serine/threonine-protein kinase Chk1', NULL, NULL, NULL, NULL, NULL, 4),
(123862, NULL, 'G3DSA:3.30.450.20:FF:000620', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123863, NULL, 'G3DSA:2.60.40.150:FF:000557', NULL, NULL, 'C2 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(123864, NULL, 'G3DSA:3.30.70.660:FF:000016', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(123865, NULL, 'G3DSA:3.20.20.80:FF:000112', NULL, NULL, 'Alpha-glucosidase AglA', NULL, NULL, NULL, NULL, NULL, 4),
(123866, NULL, 'G3DSA:2.60.34.10:FF:000028', NULL, NULL, 'Heat shock protein 4b', NULL, NULL, NULL, NULL, NULL, 4),
(123867, NULL, 'G3DSA:2.30.30.40:FF:000642', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123868, NULL, 'G3DSA:2.130.10.10:FF:005944', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(123869, NULL, 'G3DSA:3.40.50.300:FF:001268', NULL, NULL, 'RAP1B, member of RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(123870, NULL, 'G3DSA:3.10.20.90:FF:000458', NULL, NULL, 'Erythrocyte membrane protein band 4.1a', NULL, NULL, NULL, NULL, NULL, 4),
(123871, NULL, 'G3DSA:2.30.30.100:FF:000215', NULL, NULL, 'RNA-binding protein Hfq', NULL, NULL, NULL, NULL, NULL, 4),
(123872, NULL, 'G3DSA:1.20.1330.10:FF:000016', NULL, NULL, 'Flagellin', NULL, NULL, NULL, NULL, NULL, 4),
(123873, NULL, 'G3DSA:3.10.350.10:FF:000064', NULL, NULL, 'Putative cell wall hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(123874, NULL, 'G3DSA:3.20.20.70:FF:000750', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123875, NULL, 'G3DSA:1.20.1510.10:FF:000053', NULL, NULL, 'Solute carrier family 30 member 1', NULL, NULL, NULL, NULL, NULL, 4),
(123876, NULL, 'G3DSA:3.10.290.10:FF:000093', NULL, NULL, '40S ribosomal protein S4-3', NULL, NULL, NULL, NULL, NULL, 4),
(123877, NULL, 'G3DSA:2.90.10.10:FF:000045', NULL, NULL, 'Os06g0619600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(123878, NULL, 'G3DSA:2.60.120.650:FF:000098', NULL, NULL, 'Jumonji domain-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(123879, NULL, 'G3DSA:1.20.1250.20:FF:001272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123880, NULL, 'G3DSA:1.10.150.240:FF:000095', NULL, NULL, 'Haloacid dehalogenase-like hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(123881, NULL, 'G3DSA:3.40.1770.10:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123882, NULL, 'G3DSA:3.40.630.30:FF:000489', NULL, NULL, 'GNAT family N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(123883, NULL, 'G3DSA:2.40.50.90:FF:000141', NULL, NULL, 'YALI0B03960p', NULL, NULL, NULL, NULL, NULL, 4),
(123884, NULL, 'G3DSA:2.10.25.10:FF:000487', NULL, NULL, 'Fibulin 5', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(123885, NULL, 'G3DSA:2.30.40.10:FF:000072', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(123886, NULL, 'G3DSA:1.25.10.10:FF:001636', NULL, NULL, 'Imb-3', NULL, NULL, NULL, NULL, NULL, 4),
(123887, NULL, 'G3DSA:2.60.120.200:FF:000637', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123888, NULL, 'G3DSA:1.10.220.10:FF:000017', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(123889, NULL, 'G3DSA:1.10.3660.10:FF:000015', NULL, NULL, 'Prephenate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(123890, NULL, 'G3DSA:1.20.58.1930:FF:000002', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(123891, NULL, 'G3DSA:1.10.8.10:FF:000016', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(123892, NULL, 'G3DSA:1.10.357.20:FF:000005', NULL, NULL, 'Magnesium transporter MgtE', NULL, NULL, NULL, NULL, NULL, 4),
(123893, NULL, 'G3DSA:3.40.50.1700:FF:000012', NULL, NULL, 'Glycoside hydrolase family 3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(123894, NULL, 'G3DSA:3.30.40.10:FF:002183', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(123895, NULL, 'G3DSA:3.30.200.20:FF:001361', NULL, NULL, 'Calcium-dependent protein kinase 1 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(123896, NULL, 'G3DSA:2.40.50.140:FF:001151', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123897, NULL, 'G3DSA:3.40.50.850:FF:000005', NULL, NULL, 'Isochorismatase hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(123898, NULL, 'G3DSA:3.40.50.2000:FF:000619', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123899, NULL, 'G3DSA:2.60.40.10:FF:002886', NULL, NULL, 'Leptin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(123900, NULL, 'G3DSA:3.60.21.60:FF:000005', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(123901, NULL, 'G3DSA:3.40.50.2300:FF:001232', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123902, NULL, 'G3DSA:3.30.70.330:FF:000204', NULL, NULL, 'Synaptojanin 2', NULL, NULL, NULL, NULL, NULL, 4),
(123903, NULL, 'G3DSA:1.20.272.10:FF:000073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123904, NULL, 'G3DSA:1.10.630.10:FF:000363', NULL, NULL, 'Chromosome 16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(123905, NULL, 'G3DSA:1.10.3120.10:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123906, NULL, 'G3DSA:2.30.42.10:FF:000110', NULL, NULL, 'multiple PDZ domain protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(123907, NULL, 'G3DSA:1.20.1250.20:FF:000288', NULL, NULL, 'Solute carrier family 45, member 2', NULL, NULL, NULL, NULL, NULL, 4),
(123908, NULL, 'G3DSA:1.20.1250.20:FF:002109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123909, NULL, 'G3DSA:3.80.10.10:FF:001313', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(123910, NULL, 'G3DSA:3.40.50.720:FF:000641', NULL, NULL, 'D-amino acid oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(123911, NULL, 'G3DSA:3.90.530.10:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123912, NULL, 'G3DSA:3.40.720.10:FF:000254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123913, NULL, 'G3DSA:2.60.40.10:FF:003347', NULL, NULL, 'Immunoglobulin domain-containing protein Y54G2A.25', NULL, NULL, NULL, NULL, NULL, 4),
(123914, NULL, 'G3DSA:3.90.1410.10:FF:000112', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(123915, NULL, 'G3DSA:1.10.287.770:FF:000011', NULL, NULL, 'Sodium channel epithelial 1 delta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(123916, NULL, 'G3DSA:3.30.160.60:FF:003471', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123917, NULL, 'G3DSA:3.30.450.20:FF:000148', NULL, NULL, 'PTS-dependent dihydroxyacetone kinase operon regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(123918, NULL, 'G3DSA:3.40.50.300:FF:001763', NULL, NULL, 'Ras family gtpase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(123919, NULL, 'G3DSA:3.20.20.140:FF:000117', NULL, NULL, 'Probable phosphatase C1142_00695', NULL, NULL, NULL, NULL, NULL, 4),
(123920, NULL, 'G3DSA:2.60.120.10:FF:000096', NULL, NULL, '2-aminoethanethiol dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(123921, NULL, 'G3DSA:1.20.58.390:FF:000008', NULL, NULL, 'Cholinergic receptor nicotinic beta 4 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(123922, NULL, 'G3DSA:1.20.120.1070:FF:000005', NULL, NULL, 'Translation initiation factor EIF-2b alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(123923, NULL, 'G3DSA:2.40.50.120:FF:000032', NULL, NULL, 'netrin-4', NULL, NULL, NULL, NULL, NULL, 4),
(123924, NULL, 'G3DSA:3.30.70.2740:FF:000001', NULL, NULL, 'D-lactate dehydrogenase mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(123925, NULL, 'G3DSA:3.40.50.2300:FF:000119', NULL, NULL, 'Maltose regulon regulatory protein MalI', NULL, NULL, NULL, NULL, NULL, 4),
(123926, NULL, 'G3DSA:3.20.20.70:FF:000311', NULL, NULL, 'Probable galactinol--sucrose galactosyltransferase 5', NULL, NULL, NULL, NULL, NULL, 4),
(123927, NULL, 'G3DSA:3.40.50.300:FF:002252', NULL, NULL, 'Type IV secretion system protein', NULL, NULL, NULL, NULL, NULL, 4),
(123928, NULL, 'G3DSA:3.40.50.150:FF:000245', NULL, NULL, 'Methyltransferase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(123929, NULL, 'G3DSA:3.40.50.300:FF:005506', NULL, NULL, 'Putative DEAD/DEAH box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(123930, NULL, 'G3DSA:1.10.287.470:FF:000039', NULL, NULL, 'Efflux transporter, RND family, MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(123931, NULL, 'G3DSA:3.30.710.10:FF:000334', NULL, NULL, 'Ankyrin repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(123932, NULL, 'G3DSA:2.60.40.60:FF:001131', NULL, NULL, 'Protocadherin beta-6, putative', NULL, NULL, NULL, NULL, NULL, 4),
(123933, NULL, 'G3DSA:3.40.50.720:FF:001153', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(123934, NULL, 'G3DSA:1.20.1250.20:FF:000783', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(123935, NULL, 'G3DSA:1.10.246.60:FF:000001', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit J', NULL, NULL, NULL, NULL, NULL, 4),
(123936, NULL, 'G3DSA:1.10.555.10:FF:000058', NULL, NULL, 'GTPase-activating protein pac-1', NULL, NULL, NULL, NULL, NULL, 4),
(123937, NULL, 'G3DSA:1.20.1250.10:FF:000015', NULL, NULL, 'thrombopoietin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(123938, NULL, 'G3DSA:3.40.50.620:FF:000757', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123939, NULL, 'G3DSA:3.90.76.10:FF:000026', NULL, NULL, 'Peptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(123940, NULL, 'G3DSA:3.30.160.60:FF:001026', NULL, NULL, 'zinc finger protein 383', NULL, NULL, NULL, NULL, NULL, 4),
(123941, NULL, 'G3DSA:3.40.140.10:FF:000103', NULL, NULL, 'WGS project CABT00000000 data, contig 2.3', NULL, NULL, NULL, NULL, NULL, 4),
(123942, NULL, 'G3DSA:2.60.120.10:FF:000101', NULL, NULL, 'Cyclic nucleotide-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(123943, NULL, 'G3DSA:3.90.650.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123944, NULL, 'G3DSA:3.40.50.2300:FF:001108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123945, NULL, 'G3DSA:3.30.300.20:FF:000020', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(123946, NULL, 'G3DSA:3.30.300.30:FF:000169', NULL, NULL, 'Ferrichrome siderophore peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(123947, NULL, 'G3DSA:2.130.10.10:FF:004955', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123948, NULL, 'G3DSA:2.130.10.10:FF:001234', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(123949, NULL, 'G3DSA:3.30.420.40:FF:000006', NULL, NULL, 'Molecular chaperone DnaK', NULL, NULL, NULL, NULL, NULL, 4),
(123950, NULL, 'G3DSA:3.30.390.50:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(123951, NULL, 'G3DSA:3.30.160.60:FF:002807', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123952, NULL, 'G3DSA:2.60.120.590:FF:000063', NULL, NULL, 'Uncharacterized protein P8A3.02c', NULL, NULL, NULL, NULL, NULL, 4),
(123953, NULL, 'G3DSA:3.30.390.30:FF:000011', NULL, NULL, 'Apoptosis-inducing factor, mitochondrion-associated, 3', NULL, NULL, NULL, NULL, NULL, 4),
(123954, NULL, 'G3DSA:3.40.50.150:FF:000801', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123955, NULL, 'G3DSA:3.30.70.330:FF:002065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123956, NULL, 'G3DSA:1.10.10.10:FF:000652', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(123957, NULL, 'G3DSA:3.40.50.10140:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123958, NULL, 'G3DSA:1.10.260.40:FF:000034', NULL, NULL, 'LexA family transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(123959, NULL, 'G3DSA:3.80.10.10:FF:004186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123960, NULL, 'G3DSA:3.40.1690.10:FF:000008', NULL, NULL, 'FlhB-like flagellar biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(123961, NULL, 'G3DSA:3.90.1290.10:FF:000028', NULL, NULL, 'AGAP011396-PA', NULL, NULL, NULL, NULL, NULL, 4),
(123962, NULL, 'G3DSA:1.20.58.370:FF:000002', NULL, NULL, 'Binding-protein-dependent transport systems inner membrane component', NULL, NULL, NULL, NULL, NULL, 4),
(123963, NULL, 'G3DSA:3.40.33.10:FF:000160', NULL, NULL, 'Protein CBG21986', NULL, NULL, NULL, NULL, NULL, 4),
(123964, NULL, 'G3DSA:2.30.30.100:FF:000210', NULL, NULL, 'Sm protein', NULL, NULL, NULL, NULL, NULL, 4),
(123965, NULL, 'G3DSA:2.60.40.1530:FF:000019', NULL, NULL, 'Integrin alpha 5', NULL, NULL, NULL, NULL, NULL, 4),
(123966, NULL, 'G3DSA:3.30.160.60:FF:002010', NULL, NULL, 'Zinc finger, C2H2 type', NULL, NULL, NULL, NULL, NULL, 4),
(123967, NULL, 'G3DSA:1.25.40.10:FF:001817', NULL, NULL, 'Type 4 fimbrial biogenesis protein PilF', NULL, NULL, NULL, NULL, NULL, 4),
(123968, NULL, 'G3DSA:3.40.50.11500:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123969, NULL, 'G3DSA:3.30.70.2850:FF:000034', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(123970, NULL, 'G3DSA:1.25.40.20:FF:001354', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(123971, NULL, 'G3DSA:3.60.10.10:FF:000134', NULL, NULL, 'Sphingomyelinase C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(123972, NULL, 'G3DSA:3.90.190.10:FF:000061', NULL, NULL, 'tyrosine-protein phosphatase non-receptor type 23 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(123973, NULL, 'G3DSA:3.30.200.20:FF:001209', NULL, NULL, 'Serine/threonine-protein kinase MRCK beta', NULL, NULL, NULL, NULL, NULL, 4),
(123974, NULL, 'G3DSA:2.40.30.10:FF:000161', NULL, NULL, 'Elongation factor Tu, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(123975, NULL, 'G3DSA:1.20.120.1220:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123976, NULL, 'G3DSA:2.20.80.10:FF:000007', NULL, NULL, 'Apolipophorin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(123977, NULL, 'G3DSA:2.60.40.1510:FF:000013', NULL, NULL, 'Integrin, alpha 9', NULL, NULL, NULL, NULL, NULL, 4),
(123978, NULL, 'G3DSA:2.40.70.10:FF:000427', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123979, NULL, 'G3DSA:1.10.520.10:FF:000057', NULL, NULL, 'Catalase/peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(123980, NULL, 'G3DSA:3.40.50.300:FF:008356', NULL, NULL, 'Putative ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(123981, NULL, 'G3DSA:1.25.10.10:FF:001760', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123982, NULL, 'G3DSA:1.20.58.390:FF:000160', NULL, NULL, '5-hydroxytryptamine (serotonin) receptor 3B', NULL, NULL, NULL, NULL, NULL, 4),
(123983, NULL, 'G3DSA:1.25.40.10:FF:003442', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(123984, NULL, 'G3DSA:2.10.110.10:FF:000117', NULL, NULL, 'CBN-TAG-273 protein', NULL, NULL, NULL, NULL, NULL, 4),
(123985, NULL, 'G3DSA:3.40.33.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(123986, NULL, 'G3DSA:2.10.70.10:FF:000030', NULL, NULL, 'Sushi domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(123987, NULL, 'G3DSA:3.40.50.2000:FF:000243', NULL, NULL, 'Glycosyl transferase family 1', NULL, NULL, NULL, NULL, NULL, 4),
(123988, NULL, 'G3DSA:3.40.50.720:FF:000169', NULL, NULL, 'Enoyl-[acyl-carrier-protein] reductase [NADH]', NULL, NULL, NULL, NULL, NULL, 4),
(123989, NULL, 'G3DSA:1.10.620.20:FF:000011', NULL, NULL, 'Ribonucleotide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(123990, NULL, 'G3DSA:2.10.25.10:FF:001471', NULL, NULL, 'slit homolog 2 protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(123991, NULL, 'G3DSA:1.20.1560.10:FF:000264', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(123992, NULL, 'G3DSA:2.40.160.120:FF:000036', NULL, NULL, 'Oxysterol binding protein like 8', NULL, NULL, NULL, NULL, NULL, 4),
(123993, NULL, 'G3DSA:3.40.50.10730:FF:000005', NULL, NULL, 'Urocanate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(123994, NULL, 'G3DSA:1.25.40.10:FF:005331', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g62370', NULL, NULL, NULL, NULL, NULL, 4),
(123995, NULL, 'G3DSA:1.20.1070.10:FF:001322', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(123996, NULL, 'G3DSA:3.40.50.300:FF:003741', NULL, NULL, 'WGS project CABT00000000 data, contig 2.29', NULL, NULL, NULL, NULL, NULL, 4),
(123997, NULL, 'G3DSA:1.10.287.110:FF:000280', NULL, NULL, 'DnaJ domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(123998, NULL, 'G3DSA:2.60.40.10:FF:003903', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(123999, NULL, 'G3DSA:4.10.280.10:FF:000026', NULL, NULL, 'Basic helix-loop-helix family, member e23', NULL, NULL, NULL, NULL, NULL, 4),
(124000, NULL, 'G3DSA:3.40.50.300:FF:003505', NULL, NULL, 'Protein SUPPRESSOR OF MAX2 1', NULL, NULL, NULL, NULL, NULL, 4),
(124001, NULL, 'G3DSA:3.40.50.10260:FF:000016', NULL, NULL, 'Pyridoxamine 5-phosphate oxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(124002, NULL, 'G3DSA:1.50.10.10:FF:000116', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(124003, NULL, 'G3DSA:3.60.110.10:FF:000029', NULL, NULL, 'Protein N-terminal amidase', NULL, NULL, NULL, NULL, NULL, 4),
(124004, NULL, 'G3DSA:3.30.420.10:FF:000554', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124005, NULL, 'G3DSA:1.10.533.10:FF:000036', NULL, NULL, 'Ankyrin 2, isoform M', NULL, NULL, NULL, NULL, NULL, 4),
(124006, NULL, 'G3DSA:2.40.10.10:FF:000598', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124007, NULL, 'G3DSA:3.40.190.80:FF:000054', NULL, NULL, 'Fructose-1,6-bisphosphatase/inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(124008, NULL, 'G3DSA:3.90.550.10:FF:000044', NULL, NULL, 'Galactosylgalactosylxylosylprotein 3-beta-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(124009, NULL, 'G3DSA:4.10.60.10:FF:000272', NULL, NULL, 'Putative germ-line specific RNA helicase vasa protein', NULL, NULL, NULL, NULL, NULL, 4),
(124010, NULL, 'G3DSA:3.40.50.1000:FF:000752', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124011, NULL, 'G3DSA:2.40.70.10:FF:000135', NULL, NULL, 'Peptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(124012, NULL, 'G3DSA:2.130.10.10:FF:002538', NULL, NULL, 'Os04g0619700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(124013, NULL, 'G3DSA:3.30.70.330:FF:002913', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124014, NULL, 'G3DSA:1.20.1050.10:FF:000034', NULL, NULL, 'Transcriptional regulator URE2', NULL, NULL, NULL, NULL, NULL, 4),
(124015, NULL, 'G3DSA:1.10.640.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124016, NULL, 'G3DSA:1.10.472.10:FF:000343', NULL, NULL, 'Cyclin B-like protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(124017, NULL, 'G3DSA:3.40.50.150:FF:001257', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124018, NULL, 'G3DSA:3.40.50.300:FF:003685', NULL, NULL, 'DEAD/DEAH box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(124019, NULL, 'G3DSA:1.10.3380.30:FF:000039', NULL, NULL, 'DEAD/DEAH box helicase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(124020, NULL, 'G3DSA:3.30.420.140:FF:000047', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(124021, NULL, 'G3DSA:2.60.40.60:FF:000203', NULL, NULL, 'Cadherin 23', NULL, NULL, NULL, NULL, NULL, 4),
(124022, NULL, 'G3DSA:3.30.530.20:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124023, NULL, 'G3DSA:1.20.1070.10:FF:001030', NULL, NULL, 'Relaxin family peptide receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(124024, NULL, 'G3DSA:3.30.40.10:FF:002211', NULL, NULL, 'Lysine-specific demethylase 7 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(124025, NULL, 'G3DSA:3.30.470.30:FF:000012', NULL, NULL, 'Probable DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(124026, NULL, 'G3DSA:3.40.50.1980:FF:000141', NULL, NULL, 'Putative ferrichrome-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(124027, NULL, 'G3DSA:3.30.450.20:FF:000587', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124028, NULL, 'G3DSA:3.40.190.290:FF:000098', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(124029, NULL, 'G3DSA:3.30.760.10:FF:000045', NULL, NULL, 'Eukaryotic initiation factor 4E family protein', NULL, NULL, NULL, NULL, NULL, 4),
(124030, NULL, 'G3DSA:1.20.5.170:FF:000201', NULL, NULL, 'Filament-like plant protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(124031, NULL, 'G3DSA:3.40.50.1220:FF:000110', NULL, NULL, 'Histone deacetylase HDAC silent information regulator protein 2 Sir2 sirtuin', NULL, NULL, NULL, NULL, NULL, 4),
(124032, NULL, 'G3DSA:3.40.50.300:FF:004489', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(124033, NULL, 'G3DSA:3.10.129.10:FF:000252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124034, NULL, 'G3DSA:3.60.130.10:FF:000087', NULL, NULL, 'Butyrobetaine (gamma), 2-oxoglutarate dioxygenase (gamma-butyrobetaine hydroxylase) 1', NULL, NULL, NULL, NULL, NULL, 4),
(124035, NULL, 'G3DSA:3.40.50.720:FF:002439', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(124036, NULL, 'G3DSA:3.20.20.80:FF:000168', NULL, NULL, 'Chitodextrinase', NULL, NULL, NULL, NULL, NULL, 4),
(124037, NULL, 'G3DSA:3.30.40.10:FF:001194', NULL, NULL, 'Uncharacterized protein AT4g35070', NULL, NULL, NULL, NULL, NULL, 4),
(124038, NULL, 'G3DSA:3.40.50.720:FF:000697', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(124039, NULL, 'G3DSA:3.40.50.300:FF:007428', NULL, NULL, 'ATP-dependent DEAD/H RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(124040, NULL, 'G3DSA:2.160.20.10:FF:000059', NULL, NULL, 'E1B 55 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(124041, NULL, 'G3DSA:3.30.160.60:FF:003735', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124042, NULL, 'G3DSA:1.10.1080.10:FF:000021', NULL, NULL, 'Glutathione synthetase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(124043, NULL, 'G3DSA:2.30.29.30:FF:000624', NULL, NULL, 'Protein CBG23324', NULL, NULL, NULL, NULL, NULL, 4),
(124044, NULL, 'G3DSA:1.10.510.10:FF:003670', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124045, NULL, 'G3DSA:1.25.40.10:FF:001964', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(124046, NULL, 'G3DSA:3.90.550.10:FF:000191', NULL, NULL, '2-C-methyl-D-erythritol 4-phosphate cytidylyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(124047, NULL, 'G3DSA:3.30.420.10:FF:000407', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124048, NULL, 'G3DSA:3.10.20.600:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124049, NULL, 'G3DSA:3.40.1490.10:FF:000004', NULL, NULL, 'Peptidyl-tRNA hydrolase PTH2, putative', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(124050, NULL, 'G3DSA:2.10.25.10:FF:000482', NULL, NULL, 'Shifted, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(124051, NULL, 'G3DSA:2.40.50.90:FF:000146', NULL, NULL, 'YALI0B03960p', NULL, NULL, NULL, NULL, NULL, 4),
(124052, NULL, 'G3DSA:3.20.20.140:FF:000297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124053, NULL, 'G3DSA:1.20.85.10:FF:000009', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(124054, NULL, 'G3DSA:3.30.70.330:FF:002857', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124055, NULL, 'G3DSA:2.130.10.10:FF:002162', NULL, NULL, 'Two-component system sensor histidine kinase-response regulator hybrid protein', NULL, NULL, NULL, NULL, NULL, 4),
(124056, NULL, 'G3DSA:2.40.50.140:FF:000038', NULL, NULL, 'Exosome complex component RRP4', NULL, NULL, NULL, NULL, NULL, 4),
(124057, NULL, 'G3DSA:3.40.605.10:FF:000026', NULL, NULL, 'Aldehyde dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(124058, NULL, 'G3DSA:1.20.1720.10:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124059, NULL, 'G3DSA:1.20.920.10:FF:000118', NULL, NULL, 'GD10895', NULL, NULL, NULL, NULL, NULL, 4),
(124060, NULL, 'G3DSA:3.30.470.20:FF:000094', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(124061, NULL, 'G3DSA:1.10.10.750:FF:000044', NULL, NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', NULL, NULL, NULL, NULL, NULL, 4),
(124062, NULL, 'G3DSA:1.10.510.10:FF:003518', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124063, NULL, 'G3DSA:3.30.413.10:FF:000026', NULL, NULL, 'Sulfite reductase-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(124064, NULL, 'G3DSA:2.20.80.10:FF:000002', NULL, NULL, 'Apolipoprotein B-100', NULL, NULL, NULL, NULL, NULL, 4),
(124065, NULL, 'G3DSA:1.25.40.10:FF:004370', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(124066, NULL, 'G3DSA:3.30.70.330:FF:001137', NULL, NULL, 'Multiple RNA-binding domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(124067, NULL, 'G3DSA:3.40.50.300:FF:003213', NULL, NULL, 'Multidrug resistance-associated protein lethal(2)03659', NULL, NULL, NULL, NULL, NULL, 4),
(124068, NULL, 'G3DSA:1.20.1250.20:FF:000344', NULL, NULL, 'Feline leukemia virus subgroup C cellular receptor family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(124069, NULL, 'G3DSA:1.10.630.10:FF:000739', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124070, NULL, 'G3DSA:3.40.30.10:FF:000299', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(124071, NULL, 'G3DSA:3.10.20.620:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124072, NULL, 'G3DSA:3.40.50.720:FF:002586', NULL, NULL, 'NmrA-like family domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(124073, NULL, 'G3DSA:2.60.40.10:FF:001925', NULL, NULL, 'KETtiN (Drosophila actin-binding) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(124074, NULL, 'G3DSA:2.160.10.10:FF:000002', NULL, NULL, 'Serine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(124075, NULL, 'G3DSA:3.80.10.10:FF:003314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124076, NULL, 'G3DSA:2.60.120.920:FF:000022', NULL, NULL, 'E3 ubiquitin-protein ligase NEURL1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(124077, NULL, 'G3DSA:1.10.10.10:FF:001580', NULL, NULL, 'Sialic acid utilization regulator, RpiR family', NULL, NULL, NULL, NULL, NULL, 4),
(124078, NULL, 'G3DSA:3.90.550.50:FF:000213', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(124079, NULL, 'G3DSA:2.60.40.10:FF:002414', NULL, NULL, 'Myotactin form A', NULL, NULL, NULL, NULL, NULL, 4),
(124080, NULL, 'G3DSA:1.10.3380.10:FF:000033', NULL, NULL, 'ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(124081, NULL, 'G3DSA:3.40.390.10:FF:000003', NULL, NULL, 'endothelin-converting enzyme 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(124082, NULL, 'G3DSA:3.20.20.240:FF:000001', NULL, NULL, 'Probable methylmalonyl-coa mutase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(124083, NULL, 'G3DSA:3.60.21.10:FF:000362', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124084, NULL, 'G3DSA:2.30.42.10:FF:000054', NULL, NULL, 'multiple PDZ domain protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(124085, NULL, 'G3DSA:1.10.3460.10:FF:000034', NULL, NULL, 'Early light-inducible protein', NULL, NULL, NULL, NULL, NULL, 4),
(124086, NULL, 'G3DSA:2.40.30.20:FF:000023', NULL, NULL, 'Riboflavin synthase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(124087, NULL, 'G3DSA:3.40.630.30:FF:000197', NULL, NULL, 'Possible 8-amino-7-oxononanoate synthase bioF2', NULL, NULL, NULL, NULL, NULL, 4),
(124088, NULL, 'G3DSA:1.20.5.170:FF:000145', NULL, NULL, 'ATG16-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(124089, NULL, 'G3DSA:3.20.20.70:FF:000255', NULL, NULL, 'Dihydroorotate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(124090, NULL, 'G3DSA:1.10.287.110:FF:000128', NULL, NULL, 'Co-chaperone protein HscB homolog', NULL, NULL, NULL, NULL, NULL, 4),
(124091, NULL, 'G3DSA:3.30.1120.10:FF:000019', NULL, NULL, 'Arylsulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(124092, NULL, 'G3DSA:3.30.70.330:FF:000968', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit G', NULL, NULL, NULL, NULL, NULL, 4),
(124093, NULL, 'G3DSA:3.30.30.110:FF:000001', NULL, NULL, 'Antibacterial factor-related peptide 2', NULL, NULL, NULL, NULL, NULL, 4),
(124094, NULL, 'G3DSA:1.10.630.10:FF:000216', NULL, NULL, 'Cytochrome P450 2C23a', NULL, NULL, NULL, NULL, NULL, 4),
(124095, NULL, 'G3DSA:2.60.40.10:FF:002358', NULL, NULL, 'Follistatin like 4', NULL, NULL, NULL, NULL, NULL, 4),
(124096, NULL, 'G3DSA:3.40.570.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124097, NULL, 'G3DSA:1.10.238.200:FF:000016', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(124098, NULL, 'G3DSA:1.20.1070.10:FF:001406', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124099, NULL, 'G3DSA:1.25.10.10:FF:000832', NULL, NULL, 'Importin subunit alpha-2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(124100, NULL, 'G3DSA:1.50.40.10:FF:000091', NULL, NULL, 'Mitochondrial carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(124101, NULL, 'G3DSA:3.30.530.20:FF:000065', NULL, NULL, 'Ribosome association toxin RatA', NULL, NULL, NULL, NULL, NULL, 4),
(124102, NULL, 'G3DSA:3.90.1200.10:FF:000051', NULL, NULL, 'Spore coat protein CotS', NULL, NULL, NULL, NULL, NULL, 4),
(124103, NULL, 'G3DSA:1.25.40.10:FF:003881', NULL, NULL, 'p60=60 kDa stress-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(124104, NULL, 'G3DSA:3.30.160.60:FF:002015', NULL, NULL, 'ZNF596 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(124105, NULL, 'G3DSA:1.20.58.390:FF:000244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124106, NULL, 'G3DSA:3.40.630.30:FF:000017', NULL, NULL, 'RNA cytidine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(124107, NULL, 'G3DSA:3.40.350.10:FF:000001', NULL, NULL, 'Putative xaa-Pro aminopeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(124108, NULL, 'G3DSA:1.20.5.170:FF:000229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124109, NULL, 'G3DSA:3.60.20.40:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124110, NULL, 'G3DSA:3.20.20.80:FF:000084', NULL, NULL, 'Beta-mannosidase A', NULL, NULL, NULL, NULL, NULL, 4),
(124111, NULL, 'G3DSA:3.30.497.10:FF:000186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124112, NULL, 'G3DSA:2.60.40.10:FF:003342', NULL, NULL, 'Fibronectin 1b', NULL, NULL, NULL, NULL, NULL, 4),
(124113, NULL, 'G3DSA:3.40.50.150:FF:001173', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124114, NULL, 'G3DSA:1.25.40.20:FF:000337', NULL, NULL, 'AF4/FMR2 family member 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(124115, NULL, 'G3DSA:1.25.40.10:FF:003386', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(124116, NULL, 'G3DSA:2.60.40.10:FF:001869', NULL, NULL, 'Fimbrial chaperone protein ElfD', NULL, NULL, NULL, NULL, NULL, 4),
(124117, NULL, 'G3DSA:3.40.50.300:FF:003180', NULL, NULL, 'Putative ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(124118, NULL, 'G3DSA:1.20.58.60:FF:000855', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124119, NULL, 'G3DSA:3.30.1520.10:FF:000095', NULL, NULL, 'Rho GTPase-activating protein 33', NULL, NULL, NULL, NULL, NULL, 4),
(124120, NULL, 'G3DSA:2.60.40.60:FF:000018', NULL, NULL, 'Protocadherin gamma c3', NULL, NULL, NULL, NULL, NULL, 4),
(124121, NULL, 'G3DSA:3.80.10.10:FF:003258', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(124122, NULL, 'G3DSA:3.40.950.10:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124123, NULL, 'G3DSA:1.10.10.10:FF:001956', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124124, NULL, 'G3DSA:1.10.10.2430:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124125, NULL, 'G3DSA:1.10.287.810:FF:000012', NULL, NULL, 'Mitochondrial import inner membrane translocase subunit TIM13, putative', NULL, NULL, NULL, NULL, NULL, 4),
(124126, NULL, 'G3DSA:2.60.120.200:FF:000784', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(124127, NULL, 'G3DSA:3.40.30.10:FF:000355', NULL, NULL, 'Glutathione S-transferase U10', NULL, NULL, NULL, NULL, NULL, 4),
(124128, NULL, 'G3DSA:3.40.140.70:FF:000019', NULL, NULL, 'Putative ubiquitin activating E1 enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(124129, NULL, 'G3DSA:3.20.20.220:FF:000023', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(124130, NULL, 'G3DSA:1.25.40.430:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124131, NULL, 'G3DSA:3.40.50.300:FF:007923', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124132, NULL, 'G3DSA:3.30.2460.20:FF:000008', NULL, NULL, 'Protein Wnt-4', NULL, NULL, NULL, NULL, NULL, 4),
(124133, NULL, 'G3DSA:3.40.930.10:FF:000028', NULL, NULL, 'PTS system, nitrogen regulatory IIA component', NULL, NULL, NULL, NULL, NULL, 4),
(124134, NULL, 'G3DSA:1.10.287.1490:FF:000060', NULL, NULL, 'Phosphoinositide-3-kinase, regulatory subunit 3a (gamma)', NULL, NULL, NULL, NULL, NULL, 4),
(124135, NULL, 'G3DSA:2.30.30.190:FF:000017', NULL, NULL, 'Pac2p', NULL, NULL, NULL, NULL, NULL, 4),
(124136, NULL, 'G3DSA:4.10.400.20:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124137, NULL, 'G3DSA:1.20.970.10:FF:000037', NULL, NULL, 'Anthranilate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(124138, NULL, 'G3DSA:2.130.10.10:FF:003651', NULL, NULL, 'Protein sof1', NULL, NULL, NULL, NULL, NULL, 4),
(124139, NULL, 'G3DSA:3.40.630.10:FF:000011', NULL, NULL, 'cytosolic carboxypeptidase 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(124140, NULL, 'G3DSA:3.10.250.10:FF:000005', NULL, NULL, 'Neurotrypsin isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(124141, NULL, 'G3DSA:3.10.20.90:FF:000930', NULL, NULL, 'Plexin A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(124142, NULL, 'G3DSA:1.20.58.60:FF:000416', NULL, NULL, 'Spectrin repeat containing nuclear envelope family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(124143, NULL, 'G3DSA:2.40.15.10:FF:000002', NULL, NULL, 'T-cell leukemia/lymphoma protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(124144, NULL, 'G3DSA:2.60.120.620:FF:000027', NULL, NULL, 'Oxidoreductase, 2OG-Fe(II) oxygenase family family', NULL, NULL, NULL, NULL, NULL, 4),
(124145, NULL, 'G3DSA:1.25.40.10:FF:002897', NULL, NULL, 'Intraflagellar transport particle protein 88', NULL, NULL, NULL, NULL, NULL, 4),
(124146, NULL, 'G3DSA:1.10.1410.20:FF:000005', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(124147, NULL, 'G3DSA:2.60.120.10:FF:000573', NULL, NULL, 'Cyclic nucleotide-binding', NULL, NULL, NULL, NULL, NULL, 4),
(124148, NULL, 'G3DSA:3.40.1650.10:FF:000006', NULL, NULL, 'Fucose operon FucU protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(124149, NULL, 'G3DSA:2.60.40.10:FF:005764', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124150, NULL, 'G3DSA:1.10.287.70:FF:000762', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(124151, NULL, 'G3DSA:1.25.40.10:FF:003734', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124152, NULL, 'G3DSA:1.25.10.10:FF:000271', NULL, NULL, 'HEAT repeat-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(124153, NULL, 'G3DSA:1.10.560.10:FF:000003', NULL, NULL, 'T-complex protein 1 subunit eta', NULL, NULL, NULL, NULL, NULL, 4),
(124154, NULL, 'G3DSA:3.30.70.330:FF:001929', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124155, NULL, 'G3DSA:3.30.420.100:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124156, NULL, 'G3DSA:1.25.10.10:FF:002597', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124157, NULL, 'G3DSA:1.10.10.10:FF:000236', NULL, NULL, 'Cell division protein FtsK', NULL, NULL, NULL, NULL, NULL, 4),
(124158, NULL, 'G3DSA:3.40.630.30:FF:000202', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(124159, NULL, 'G3DSA:3.30.40.10:FF:000266', NULL, NULL, 'Peroxisome assembly protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(124160, NULL, 'G3DSA:3.80.10.10:FF:004242', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(124161, NULL, 'G3DSA:3.40.50.300:FF:005978', NULL, NULL, 'CRISPR-associated helicase Cas3', NULL, NULL, NULL, NULL, NULL, 4),
(124162, NULL, 'G3DSA:3.30.70.660:FF:000011', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(124163, NULL, 'G3DSA:1.20.120.1900:FF:000029', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(124164, NULL, 'G3DSA:2.30.29.30:FF:000568', NULL, NULL, 'Related to Stress-activated map kinase interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(124165, NULL, 'G3DSA:3.30.1360.40:FF:000017', NULL, NULL, 'DNA topoisomerase 4 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(124166, NULL, 'G3DSA:2.180.10.10:FF:000007', NULL, NULL, 'Si:ch211-12m10.1', NULL, NULL, NULL, NULL, NULL, 4),
(124167, NULL, 'G3DSA:3.20.20.60:FF:000073', NULL, NULL, 'HpcH/HpaI aldolase/citrate lyase family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(124168, NULL, 'G3DSA:3.30.450.20:FF:000064', NULL, NULL, 'Vivid PAS protein VVD', NULL, NULL, NULL, NULL, NULL, 4),
(124169, NULL, 'G3DSA:3.40.50.720:FF:002147', NULL, NULL, 'ATG7 autophagy-related 7 homolog (S. cerevisiae)', NULL, NULL, NULL, NULL, NULL, 4),
(124170, NULL, 'G3DSA:1.20.120.350:FF:000102', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(124171, NULL, 'G3DSA:2.30.30.790:FF:000017', NULL, NULL, 'Mitochondrial 54S ribosomal protein IMG1', NULL, NULL, NULL, NULL, NULL, 4),
(124172, NULL, 'G3DSA:1.10.3260.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124173, NULL, 'G3DSA:3.30.70.250:FF:000006', NULL, NULL, 'Malonyl CoA-acyl carrier protein transacylase', NULL, NULL, NULL, NULL, NULL, 4),
(124174, NULL, 'G3DSA:3.40.50.150:FF:001549', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124175, NULL, 'G3DSA:3.40.50.150:FF:001734', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124176, NULL, 'G3DSA:3.30.200.20:FF:000400', NULL, NULL, 'Tyrosine kinase non receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(124177, NULL, 'G3DSA:1.25.40.570:FF:000076', NULL, NULL, 'Protein CBR-CSN-2', NULL, NULL, NULL, NULL, NULL, 4),
(124178, NULL, 'G3DSA:2.60.120.470:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124179, NULL, 'G3DSA:3.40.50.300:FF:002196', NULL, NULL, 'ABC transporter B family member 5', NULL, NULL, NULL, NULL, NULL, 4),
(124180, NULL, 'G3DSA:2.60.120.330:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124181, NULL, 'G3DSA:3.30.1490.20:FF:000015', NULL, NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(124182, NULL, 'G3DSA:3.80.10.10:FF:002297', NULL, NULL, 'F-box/LRR-repeat protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(124183, NULL, 'G3DSA:2.120.10.90:FF:000011', NULL, NULL, 'DNA topoisomerase 4 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(124184, NULL, 'G3DSA:3.30.40.10:FF:000761', NULL, NULL, 'Os01g0844700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(124185, NULL, 'G3DSA:3.30.930.10:FF:000368', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124186, NULL, 'G3DSA:1.20.1510.10:FF:000058', NULL, NULL, 'Metal tolerance protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(124187, NULL, 'G3DSA:1.10.357.140:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124188, NULL, 'G3DSA:1.10.8.1080:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124189, NULL, 'G3DSA:3.30.40.10:FF:001250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124190, NULL, 'G3DSA:2.30.42.10:FF:000582', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124191, NULL, 'G3DSA:3.80.10.10:FF:000296', NULL, NULL, 'mRNA export factor MEX67', NULL, NULL, NULL, NULL, NULL, 4),
(124192, NULL, 'G3DSA:2.30.30.40:FF:000018', NULL, NULL, 'Brain-specific angiogenesis inhibitor 1-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(124193, NULL, 'G3DSA:1.20.1050.130:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124194, NULL, 'G3DSA:2.130.10.10:FF:005596', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(124195, NULL, 'G3DSA:3.60.21.10:FF:000131', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(124196, NULL, 'G3DSA:3.30.40.10:FF:001722', NULL, NULL, 'E3 ubiquitin-protein ligase RNF34', NULL, NULL, NULL, NULL, NULL, 4),
(124197, NULL, 'G3DSA:1.10.510.10:FF:002361', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124198, NULL, 'G3DSA:1.25.40.10:FF:004403', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g21470', NULL, NULL, NULL, NULL, NULL, 4),
(124199, NULL, 'G3DSA:2.130.10.10:FF:005124', NULL, NULL, 'Os07g0693700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(124200, NULL, 'G3DSA:2.30.30.30:FF:000021', NULL, NULL, 'DNA/RNA-binding protein KIN17, putative', NULL, NULL, NULL, NULL, NULL, 4),
(124201, NULL, 'G3DSA:2.60.120.560:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124202, NULL, 'G3DSA:3.40.50.1110:FF:000021', NULL, NULL, 'Lysophospholipase L1', NULL, NULL, NULL, NULL, NULL, 4),
(124203, NULL, 'G3DSA:3.40.50.1820:FF:000138', NULL, NULL, 'Neuroligin-1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(124204, NULL, 'G3DSA:2.40.50.140:FF:000510', NULL, NULL, 'DNA-directed RNA polymerases I, II, and III subunit RPABC3', NULL, NULL, NULL, NULL, NULL, 4),
(124205, NULL, 'G3DSA:3.40.640.10:FF:000068', NULL, NULL, 'Putative aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(124206, NULL, 'G3DSA:3.90.1150.10:FF:000198', NULL, NULL, 'Aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(124207, NULL, 'G3DSA:2.60.120.290:FF:000119', NULL, NULL, 'AGAP011909-PA', NULL, NULL, NULL, NULL, NULL, 4),
(124208, NULL, 'G3DSA:2.30.130.10:FF:000018', NULL, NULL, 'Glutamate 5-kinase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(124209, NULL, 'G3DSA:2.10.25.10:FF:001499', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(124210, NULL, 'G3DSA:2.60.40.10:FF:005579', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124211, NULL, 'G3DSA:3.80.10.10:FF:000352', NULL, NULL, 'Erbb2 interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(124212, NULL, 'G3DSA:1.10.150.20:FF:000290', NULL, NULL, 'DNA nucleotidylexotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(124213, NULL, 'G3DSA:2.130.10.10:FF:005652', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124214, NULL, 'G3DSA:2.60.40.2170:FF:000008', NULL, NULL, 'Derailed 2, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(124215, NULL, 'G3DSA:3.40.50.150:FF:000329', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(124216, NULL, 'G3DSA:3.30.160.60:FF:001846', NULL, NULL, 'ZNF121 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(124217, NULL, 'G3DSA:1.20.120.340:FF:000004', NULL, NULL, 'Perilipin', NULL, NULL, NULL, NULL, NULL, 4),
(124218, NULL, 'G3DSA:2.10.60.10:FF:000057', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(124219, NULL, 'G3DSA:2.30.42.10:FF:000615', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124220, NULL, 'G3DSA:2.30.130.40:FF:000033', NULL, NULL, 'Protein cereblon', NULL, NULL, NULL, NULL, NULL, 4),
(124221, NULL, 'G3DSA:4.10.410.10:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124222, NULL, 'G3DSA:1.25.10.10:FF:000040', NULL, NULL, 'Importin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(124223, NULL, 'G3DSA:6.10.140.2220:FF:000019', NULL, NULL, 'Putative MYND finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(124224, NULL, 'G3DSA:2.40.50.140:FF:000454', NULL, NULL, 'Replication factor A protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(124225, NULL, 'G3DSA:1.25.40.20:FF:001646', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124226, NULL, 'G3DSA:1.25.40.10:FF:001172', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(124227, NULL, 'G3DSA:3.90.20.20:FF:000041', NULL, NULL, 'GrpE protein homolog 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(124228, NULL, 'G3DSA:3.40.50.1820:FF:000666', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(124229, NULL, 'G3DSA:3.30.40.10:FF:000614', NULL, NULL, 'Unplaced genomic scaffold supercont2.21, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(124230, NULL, 'G3DSA:2.10.25.10:FF:001027', NULL, NULL, 'Transmembrane matrix receptor MUP-4', NULL, NULL, NULL, NULL, NULL, 4),
(124231, NULL, 'G3DSA:3.30.70.330:FF:000592', NULL, NULL, 'CUGBP Elav-like family member 4', NULL, NULL, NULL, NULL, NULL, 4),
(124232, NULL, 'G3DSA:3.30.420.10:FF:000138', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(124233, NULL, 'G3DSA:3.10.20.30:FF:000047', NULL, NULL, 'Adenylate/guanylate cyclase catalytic domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(124234, NULL, 'G3DSA:3.40.50.12760:FF:000002', NULL, NULL, 'Cap methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(124235, NULL, 'G3DSA:2.40.50.100:FF:000021', NULL, NULL, 'DNA-binding transcriptional regulator ModE', NULL, NULL, NULL, NULL, NULL, 4),
(124236, NULL, 'G3DSA:1.10.30.10:FF:000035', NULL, NULL, 'Maelstrom spermatogenic transposon silencer', NULL, NULL, NULL, NULL, NULL, 4),
(124237, NULL, 'G3DSA:3.80.10.10:FF:004039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124238, NULL, 'G3DSA:3.10.290.20:FF:000011', NULL, NULL, 'Ubiquitin-activating enzyme E1-like', NULL, NULL, NULL, NULL, NULL, 4),
(124239, NULL, 'G3DSA:2.30.30.170:FF:000006', NULL, NULL, 'Fibronectin binding autolysin', NULL, NULL, NULL, NULL, NULL, 4),
(124240, NULL, 'G3DSA:3.40.50.300:FF:003269', NULL, NULL, 'ATP binding cassette subfamily G member 5', NULL, NULL, NULL, NULL, NULL, 4),
(124241, NULL, 'G3DSA:1.10.10.10:FF:001017', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(124242, NULL, 'G3DSA:3.40.850.10:FF:000258', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(124243, NULL, 'G3DSA:1.10.10.60:FF:001038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124244, NULL, 'G3DSA:1.10.400.10:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124245, NULL, 'G3DSA:1.10.510.10:FF:001253', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(124246, NULL, 'G3DSA:3.10.200.10:FF:000002', NULL, NULL, 'Carbonic anhydrase-related protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(124247, NULL, 'G3DSA:2.60.40.1090:FF:000027', NULL, NULL, 'Fimbrial-like adhesin protein YadK', NULL, NULL, NULL, NULL, NULL, 4),
(124248, NULL, 'G3DSA:3.30.710.10:FF:000481', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(124249, NULL, 'G3DSA:1.25.40.20:FF:001118', NULL, NULL, 'Ankyrin repeat', NULL, NULL, NULL, NULL, NULL, 4),
(124250, NULL, 'G3DSA:1.25.40.10:FF:000660', NULL, NULL, 'Protein SLOW GREEN 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(124251, NULL, 'G3DSA:2.60.120.260:FF:000487', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124252, NULL, 'G3DSA:1.10.510.10:FF:004070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124253, NULL, 'G3DSA:1.20.58.80:FF:000046', NULL, NULL, 'Protein spartin', NULL, NULL, NULL, NULL, NULL, 4),
(124254, NULL, 'G3DSA:2.30.110.10:FF:000074', NULL, NULL, 'Protease synthase and sporulation negative regulatory protein PAI 2', NULL, NULL, NULL, NULL, NULL, 4),
(124255, NULL, 'G3DSA:1.10.405.10:FF:000014', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(124256, NULL, 'G3DSA:1.20.140.10:FF:000082', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(124257, NULL, 'G3DSA:1.10.245.10:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124258, NULL, 'G3DSA:3.40.50.620:FF:000521', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(124259, NULL, 'G3DSA:3.30.870.10:FF:000166', NULL, NULL, 'Tyrosyl-DNA phosphodiesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(124260, NULL, 'G3DSA:1.10.510.10:FF:002978', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124261, NULL, 'G3DSA:1.10.238.10:FF:000928', NULL, NULL, 'Calcium-binding allergen Ole e 8', NULL, NULL, NULL, NULL, NULL, 4),
(124262, NULL, 'G3DSA:3.40.50.1000:FF:000336', NULL, NULL, 'Alpha,alpha-trehalose phosphate synthase subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(124263, NULL, 'G3DSA:3.40.50.2300:FF:000743', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124264, NULL, 'G3DSA:3.90.226.10:FF:000246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124265, NULL, 'G3DSA:1.25.40.10:FF:003678', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(124266, NULL, 'G3DSA:3.30.9.10:FF:000233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124267, NULL, 'G3DSA:1.20.1250.20:FF:002289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124268, NULL, 'G3DSA:1.20.1050.120:FF:000002', NULL, NULL, 'Fatty acid synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(124269, NULL, 'G3DSA:1.10.287.130:FF:000055', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(124270, NULL, 'G3DSA:1.25.10.10:FF:002069', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(124271, NULL, 'G3DSA:3.20.20.80:FF:000404', NULL, NULL, 'Alpha-L-fucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(124272, NULL, 'G3DSA:2.30.30.140:FF:000087', NULL, NULL, 'Putative ATP-dependent RNA helicase TDRD12', NULL, NULL, NULL, NULL, NULL, 4),
(124273, NULL, 'G3DSA:2.10.220.10:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124274, NULL, 'G3DSA:2.130.10.10:FF:001381', NULL, NULL, 'cleavage and polyadenylation specificity factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(124275, NULL, 'G3DSA:3.30.420.40:FF:000153', NULL, NULL, 'Putative fructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(124276, NULL, 'G3DSA:3.30.40.10:FF:002267', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(124277, NULL, 'G3DSA:1.20.1090.10:FF:000008', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(124278, NULL, 'G3DSA:2.30.30.40:FF:000350', NULL, NULL, 'Sorting nexin', NULL, NULL, NULL, NULL, NULL, 4),
(124279, NULL, 'G3DSA:1.10.510.10:FF:002029', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(124280, NULL, 'G3DSA:3.30.60.30:FF:000043', NULL, NULL, 'Protein BM-40', NULL, NULL, NULL, NULL, NULL, 4),
(124281, NULL, 'G3DSA:1.20.1250.20:FF:001800', NULL, NULL, 'Siderophore iron transporter 2', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(124282, NULL, 'G3DSA:1.10.1420.10:FF:000065', NULL, NULL, 'MutS family protein', NULL, NULL, NULL, NULL, NULL, 4),
(124283, NULL, 'G3DSA:3.30.160.60:FF:003027', NULL, NULL, 'GDNF-inducible zinc finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(124284, NULL, 'G3DSA:2.170.16.10:FF:000015', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(124285, NULL, 'G3DSA:1.10.472.10:FF:000427', NULL, NULL, 'G1 cyclin CYD-1', NULL, NULL, NULL, NULL, NULL, 4),
(124286, NULL, 'G3DSA:3.30.70.141:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124287, NULL, 'G3DSA:3.30.160.60:FF:003504', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124288, NULL, 'G3DSA:2.40.30.10:FF:000397', NULL, NULL, 'Nitrate reductase [NAD(P)H]', NULL, NULL, NULL, NULL, NULL, 4),
(124289, NULL, 'G3DSA:2.10.50.10:FF:000028', NULL, NULL, 'Signal peptide, CUB domain and EGF like domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(124290, NULL, 'G3DSA:1.10.8.10:FF:000196', NULL, NULL, 'Ubiquitin-conjugating enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(124291, NULL, 'G3DSA:3.40.50.300:FF:004961', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124292, NULL, 'G3DSA:1.10.20.10:FF:000006', NULL, NULL, 'Nuclear transcription factor Y subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(124293, NULL, 'G3DSA:2.20.25.10:FF:000054', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(124294, NULL, 'G3DSA:3.90.70.10:FF:000131', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(124295, NULL, 'G3DSA:3.90.640.10:FF:000107', NULL, NULL, 'Actin-57B-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(124296, NULL, 'G3DSA:3.40.850.10:FF:000314', NULL, NULL, 'Myosin', NULL, NULL, NULL, NULL, NULL, 4),
(124297, NULL, 'G3DSA:2.60.40.420:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124298, NULL, 'G3DSA:3.30.1380.20:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124299, NULL, 'G3DSA:3.40.50.300:FF:006142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124300, NULL, 'G3DSA:1.10.510.10:FF:003703', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124301, NULL, 'G3DSA:3.30.160.60:FF:004808', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124302, NULL, 'G3DSA:3.30.70.270:FF:000080', NULL, NULL, 'Bifunctional diguanylate cyclase/phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(124303, NULL, 'G3DSA:2.60.120.1040:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124304, NULL, 'G3DSA:3.30.70.330:FF:002626', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124305, NULL, 'G3DSA:3.30.70.330:FF:001424', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(124306, NULL, 'G3DSA:3.30.900.10:FF:000017', NULL, NULL, 'Autophagy-related protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(124307, NULL, 'G3DSA:3.30.420.10:FF:000290', NULL, NULL, 'DNA polymerase III, epsilon chain', NULL, NULL, NULL, NULL, NULL, 4),
(124308, NULL, 'G3DSA:3.30.70.1290:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124309, NULL, 'G3DSA:2.30.29.30:FF:000799', NULL, NULL, 'Rho guanine nucleotide exchange factor 25', NULL, NULL, NULL, NULL, NULL, 4),
(124310, NULL, 'G3DSA:3.30.710.10:FF:000149', NULL, NULL, 'Blast:Protein bric-a-brac 1', NULL, NULL, NULL, NULL, NULL, 4),
(124311, NULL, 'G3DSA:1.25.10.10:FF:000888', NULL, NULL, 'HEAT repeat domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(124312, NULL, 'G3DSA:2.70.130.10:FF:000021', NULL, NULL, 'Protein OS-9 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(124313, NULL, 'G3DSA:2.130.10.10:FF:001049', NULL, NULL, 'CG1109', NULL, NULL, NULL, NULL, NULL, 4),
(124314, NULL, 'G3DSA:1.20.1270.60:FF:000127', NULL, NULL, 'Protein CBG03954', NULL, NULL, NULL, NULL, NULL, 4),
(124315, NULL, 'G3DSA:1.20.58.60:FF:000799', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124316, NULL, 'G3DSA:1.20.1250.20:FF:000636', NULL, NULL, 'Multidrug MFS transporter', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(124317, NULL, 'G3DSA:3.40.50.1360:FF:000011', NULL, NULL, 'Deoxyribose operon repressor', NULL, NULL, NULL, NULL, NULL, 4),
(124318, NULL, 'G3DSA:1.10.510.10:FF:004215', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124319, NULL, 'G3DSA:1.25.10.10:FF:000416', NULL, NULL, 'Armadillo repeat-containing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(124320, NULL, 'G3DSA:1.20.1250.20:FF:001036', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(124321, NULL, 'G3DSA:1.10.10.10:FF:000091', NULL, NULL, 'Cullin 3', NULL, NULL, NULL, NULL, NULL, 4),
(124322, NULL, 'G3DSA:1.20.1560.10:FF:000909', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124323, NULL, 'G3DSA:3.40.50.1100:FF:000220', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(124324, NULL, 'G3DSA:3.40.50.300:FF:002488', NULL, NULL, 'Ras family GTPase (Rab4b), putative', NULL, NULL, NULL, NULL, NULL, 4),
(124325, NULL, 'G3DSA:1.20.58.1120:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124326, NULL, 'G3DSA:1.10.510.10:FF:000472', NULL, NULL, 'Receptor interacting serine/threonine kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(124327, NULL, 'G3DSA:3.40.50.1380:FF:000017', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(124328, NULL, 'G3DSA:2.20.25.10:FF:000110', NULL, NULL, 'Bacterial MDR-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(124329, NULL, 'G3DSA:3.40.50.1100:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124330, NULL, 'G3DSA:3.90.1100.10:FF:000010', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(124331, NULL, 'G3DSA:1.10.1420.10:FF:000121', NULL, NULL, 'MutS domain V domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(124332, NULL, 'G3DSA:3.90.320.10:FF:000004', NULL, NULL, 'Probable exonuclease V', NULL, NULL, NULL, NULL, NULL, 4),
(124333, NULL, 'G3DSA:3.40.50.1000:FF:000191', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(124334, NULL, 'G3DSA:2.60.40.10:FF:001633', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(124335, NULL, 'G3DSA:3.90.850.10:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124336, NULL, 'G3DSA:3.40.630.30:FF:000433', NULL, NULL, 'Cilia- and flagella-associated protein 61', NULL, NULL, NULL, NULL, NULL, 4),
(124337, NULL, 'G3DSA:1.10.8.60:FF:000222', NULL, NULL, 'Replication factor C, subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(124338, NULL, 'G3DSA:3.10.20.90:FF:000402', NULL, NULL, 'Ubiquitin-like protein DSK2', NULL, NULL, NULL, NULL, NULL, 4),
(124339, NULL, 'G3DSA:1.20.1250.20:FF:000108', NULL, NULL, 'Monosaccharide-sensing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(124340, NULL, 'G3DSA:2.130.10.10:FF:003235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124341, NULL, 'G3DSA:2.40.50.1060:FF:000001', NULL, NULL, 'Twist neighbor protein', NULL, NULL, NULL, NULL, NULL, 4),
(124342, NULL, 'G3DSA:3.80.10.10:FF:001128', NULL, NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At2g16250', NULL, NULL, NULL, NULL, NULL, 4),
(124343, NULL, 'G3DSA:1.25.10.10:FF:001288', NULL, NULL, 'Proteasome activator complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(124344, NULL, 'G3DSA:2.60.40.10:FF:005472', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124345, NULL, 'G3DSA:3.30.1360.140:FF:000008', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(124346, NULL, 'G3DSA:2.130.10.10:FF:001757', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(124347, NULL, 'G3DSA:2.40.70.10:FF:000051', NULL, NULL, 'Putative aspartic protease', NULL, NULL, NULL, NULL, NULL, 4),
(124348, NULL, 'G3DSA:3.50.50.60:FF:000803', NULL, NULL, 'Monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(124349, NULL, 'G3DSA:3.40.140.100:FF:000003', NULL, NULL, 'Autophagy ubiquitin-activating enzyme ApgG', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(124350, NULL, 'G3DSA:2.30.29.30:FF:001260', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(124351, NULL, 'G3DSA:2.130.10.10:FF:003943', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124352, NULL, 'G3DSA:3.40.50.300:FF:005686', NULL, NULL, 'L-seryl-tRNA(Sec) kinase', NULL, NULL, NULL, NULL, NULL, 4),
(124353, NULL, 'G3DSA:1.10.10.60:FF:001190', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124354, NULL, 'G3DSA:1.25.40.10:FF:001880', NULL, NULL, 'Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(124355, NULL, 'G3DSA:2.60.120.10:FF:000281', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(124356, NULL, 'G3DSA:1.50.40.10:FF:000360', NULL, NULL, 'Mitochondrial carrier domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(124357, NULL, 'G3DSA:4.10.400.10:FF:000351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124358, NULL, 'G3DSA:3.40.720.10:FF:000069', NULL, NULL, 'Phosphate starvation-inducible protein PsiE', NULL, NULL, NULL, NULL, NULL, 4),
(124359, NULL, 'G3DSA:2.30.29.30:FF:001108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124360, NULL, 'G3DSA:3.80.10.10:FF:003786', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124361, NULL, 'G3DSA:1.25.10.10:FF:002125', NULL, NULL, 'Gamma-adaptin', NULL, NULL, NULL, NULL, NULL, 4),
(124362, NULL, 'G3DSA:1.20.58.1120:FF:000001', NULL, NULL, 'dynein heavy chain 2, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(124363, NULL, 'G3DSA:1.10.510.10:FF:003142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124364, NULL, 'G3DSA:2.10.230.10:FF:000008', NULL, NULL, 'Apj1p', NULL, NULL, NULL, NULL, NULL, 4),
(124365, NULL, 'G3DSA:1.25.40.20:FF:000865', NULL, NULL, 'Ankyrin-like with transmembrane domains protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(124366, NULL, 'G3DSA:3.40.50.1010:FF:000137', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124367, NULL, 'G3DSA:2.60.120.260:FF:000543', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124368, NULL, 'G3DSA:3.30.450.20:FF:000295', NULL, NULL, 'GGDEF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(124369, NULL, 'G3DSA:3.90.1600.10:FF:000008', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(124370, NULL, 'G3DSA:3.90.470.20:FF:000052', NULL, NULL, 'Probable phosphopantetheinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(124371, NULL, 'G3DSA:3.80.10.10:FF:001460', NULL, NULL, 'Jetlag, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(124372, NULL, 'G3DSA:1.50.40.10:FF:000208', NULL, NULL, 'Mitochondrial ornithine carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(124373, NULL, 'G3DSA:3.30.559.10:FF:000139', NULL, NULL, 'Putative alcohol O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(124374, NULL, 'G3DSA:3.30.67.10:FF:000002', NULL, NULL, 'Envelope glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(124375, NULL, 'G3DSA:3.40.50.920:FF:000021', NULL, NULL, 'Unplaced genomic scaffold supercont2.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(124376, NULL, 'G3DSA:2.60.120.1000:FF:000001', NULL, NULL, 'Collagen alpha-1 type I chain', NULL, NULL, NULL, NULL, NULL, 4),
(124377, NULL, 'G3DSA:3.30.230.10:FF:000308', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(124378, NULL, 'G3DSA:3.40.50.300:FF:007867', NULL, NULL, 'ATP-dependent DNA helicase Hel308', NULL, NULL, NULL, NULL, NULL, 4),
(124379, NULL, 'G3DSA:3.40.50.11860:FF:000007', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(124380, NULL, 'G3DSA:4.10.640.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124381, NULL, 'G3DSA:3.30.40.10:FF:000558', NULL, NULL, 'Cellulose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(124382, NULL, 'G3DSA:2.120.10.30:FF:000364', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124383, NULL, 'G3DSA:3.40.50.1820:FF:000290', NULL, NULL, 'Alpha/Beta hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(124384, NULL, 'G3DSA:3.10.105.10:FF:000045', NULL, NULL, 'ABC transporter, periplasmic component', NULL, NULL, NULL, NULL, NULL, 4),
(124385, NULL, 'G3DSA:3.40.50.10190:FF:000147', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(124386, NULL, 'G3DSA:3.90.1520.10:FF:000007', NULL, NULL, 'Soluble guanylate cyclase 88E', NULL, NULL, NULL, NULL, NULL, 4),
(124387, NULL, 'G3DSA:1.10.510.10:FF:001197', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(124388, NULL, 'G3DSA:2.80.10.50:FF:000063', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(124389, NULL, 'G3DSA:3.30.160.60:FF:004432', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124390, NULL, 'G3DSA:3.30.190.20:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124391, NULL, 'G3DSA:2.40.30.110:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124392, NULL, 'G3DSA:3.40.50.300:FF:004433', NULL, NULL, 'LP07781p', NULL, NULL, NULL, NULL, NULL, 4),
(124393, NULL, 'G3DSA:3.40.50.300:FF:006759', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124394, NULL, 'G3DSA:1.25.40.10:FF:000188', NULL, NULL, 'adenosine monophosphate-protein transferase FICD', NULL, NULL, NULL, NULL, NULL, 4),
(124395, NULL, 'G3DSA:1.10.510.10:FF:001961', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124396, NULL, 'G3DSA:3.90.70.10:FF:000187', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(124397, NULL, 'G3DSA:3.90.550.10:FF:000336', NULL, NULL, 'Glycosyltransferase 25 family member', NULL, NULL, NULL, NULL, NULL, 4),
(124398, NULL, 'G3DSA:2.130.10.10:FF:006052', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(124399, NULL, 'G3DSA:3.40.50.300:FF:003977', NULL, NULL, 'Guanine nucleotide-binding protein G(q) subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(124400, NULL, 'G3DSA:3.10.20.90:FF:000082', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type 13', NULL, NULL, NULL, NULL, NULL, 4),
(124401, NULL, 'G3DSA:1.25.40.20:FF:001826', NULL, NULL, 'Transient receptor potential cation channel subfamily V member 2', NULL, NULL, NULL, NULL, NULL, 4),
(124402, NULL, 'G3DSA:1.20.5.1180:FF:000002', NULL, NULL, 'Centrosomal protein of 55 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(124403, NULL, 'G3DSA:2.120.10.30:FF:000420', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(124404, NULL, 'G3DSA:1.10.150.190:FF:000001', NULL, NULL, 'Eukaryotic translation initiation factor 2 subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(124405, NULL, 'G3DSA:2.60.40.10:FF:000144', NULL, NULL, 'receptor-type tyrosine-protein phosphatase delta isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(124406, NULL, 'G3DSA:2.20.100.10:FF:000154', NULL, NULL, 'GD10853', NULL, NULL, NULL, NULL, NULL, 4),
(124407, NULL, 'G3DSA:1.10.10.10:FF:001669', NULL, NULL, 'Transcriptional regulator MarR family', NULL, NULL, NULL, NULL, NULL, 4),
(124408, NULL, 'G3DSA:1.20.1560.10:FF:000533', NULL, NULL, 'ABC multidrug transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(124409, NULL, 'G3DSA:3.30.70.1440:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124410, NULL, 'G3DSA:2.130.10.10:FF:000453', NULL, NULL, 'Telomerase Cajal body protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(124411, NULL, 'G3DSA:3.30.2280.10:FF:000002', NULL, NULL, 'Clustered mitochondria protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(124412, NULL, 'G3DSA:3.30.160.60:FF:002302', NULL, NULL, 'Zinc finger protein 517', NULL, NULL, NULL, NULL, NULL, 4),
(124413, NULL, 'G3DSA:2.20.100.10:FF:000007', NULL, NULL, 'Thrombospondin 1', NULL, NULL, NULL, NULL, NULL, 4),
(124414, NULL, 'G3DSA:3.40.50.2300:FF:000035', NULL, NULL, 'metabotropic glutamate receptor 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(124415, NULL, 'G3DSA:3.30.40.10:FF:001486', NULL, NULL, 'LD46221p', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(124416, NULL, 'G3DSA:1.10.275.20:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124417, NULL, 'G3DSA:1.25.40.180:FF:000026', NULL, NULL, 'Regulator of nonsense transcripts UPF2', NULL, NULL, NULL, NULL, NULL, 4),
(124418, NULL, 'G3DSA:3.30.420.10:FF:000610', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124419, NULL, 'G3DSA:1.10.287.70:FF:000531', NULL, NULL, 'Potassium channel, KvQLT family', NULL, NULL, NULL, NULL, NULL, 4),
(124420, NULL, 'G3DSA:3.30.200.20:FF:001092', NULL, NULL, 'Cyclin dependent kinase 9', NULL, NULL, NULL, NULL, NULL, 4),
(124421, NULL, 'G3DSA:1.10.510.10:FF:001433', NULL, NULL, 'Protein CBG20555', NULL, NULL, NULL, NULL, NULL, 4),
(124422, NULL, 'G3DSA:3.40.50.10810:FF:000018', NULL, NULL, 'Putative DNA excision repair protein ERCC-6', NULL, NULL, NULL, NULL, NULL, 4),
(124423, NULL, 'G3DSA:3.40.50.1820:FF:001066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124424, NULL, 'G3DSA:3.30.160.60:FF:002246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124425, NULL, 'G3DSA:3.40.50.300:FF:004197', NULL, NULL, 'Guanylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(124426, NULL, 'G3DSA:1.10.472.10:FF:000051', NULL, NULL, 'Retinoblastoma-like 2, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(124427, NULL, 'G3DSA:2.40.50.590:FF:000004', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(124428, NULL, 'G3DSA:4.10.1060.10:FF:000023', NULL, NULL, 'Ran-binding zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(124429, NULL, 'G3DSA:1.10.287.70:FF:000475', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124430, NULL, 'G3DSA:1.10.3450.40:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124431, NULL, 'G3DSA:1.25.10.10:FF:002833', NULL, NULL, 'Transportin MOS14', NULL, NULL, NULL, NULL, NULL, 4),
(124432, NULL, 'G3DSA:1.10.510.10:FF:002181', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124433, NULL, 'G3DSA:3.10.105.10:FF:000101', NULL, NULL, 'ABC-type dipeptide transport system periplasmic component', NULL, NULL, NULL, NULL, NULL, 4),
(124434, NULL, 'G3DSA:2.60.40.10:FF:004359', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124435, NULL, 'G3DSA:2.130.10.10:FF:004871', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(124436, NULL, 'G3DSA:2.130.10.10:FF:004668', NULL, NULL, 'WD repeat-containing protein JIP5', NULL, NULL, NULL, NULL, NULL, 4),
(124437, NULL, 'G3DSA:2.60.120.290:FF:000086', NULL, NULL, 'LOW QUALITY PROTEIN: putative DMBT1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(124438, NULL, 'G3DSA:3.40.50.1820:FF:001594', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124439, NULL, 'G3DSA:3.30.200.20:FF:000872', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(124440, NULL, 'G3DSA:2.60.120.200:FF:000368', NULL, NULL, 'Adhesion G protein-coupled receptor D1', NULL, NULL, NULL, NULL, NULL, 4),
(124441, NULL, 'G3DSA:3.40.190.10:FF:000763', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(124442, NULL, 'G3DSA:3.30.40.210:FF:000005', NULL, NULL, 'Transcription elongation factor SPT4', NULL, NULL, NULL, NULL, NULL, 4),
(124443, NULL, 'G3DSA:1.20.144.10:FF:000051', NULL, NULL, 'Phospholipid phosphatase homolog 1.2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(124444, NULL, 'G3DSA:1.20.5.190:FF:000100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124445, NULL, 'G3DSA:3.40.50.800:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124446, NULL, 'G3DSA:3.60.40.10:FF:000338', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124447, NULL, 'G3DSA:3.50.50.60:FF:000770', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(124448, NULL, 'G3DSA:3.70.10.10:FF:000049', NULL, NULL, 'DNA polymerase III subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(124449, NULL, 'G3DSA:1.20.1410.10:FF:000017', NULL, NULL, 'Os05g0554500 protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(124450, NULL, 'G3DSA:3.30.160.60:FF:006141', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124451, NULL, 'G3DSA:1.20.1420.30:FF:000001', NULL, NULL, 'sodium/calcium exchanger 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(124452, NULL, 'G3DSA:3.40.20.10:FF:000057', NULL, NULL, 'Gelsolin, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(124453, NULL, 'G3DSA:2.60.60.20:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124454, NULL, 'G3DSA:1.25.10.10:FF:002305', NULL, NULL, 'mRNA cleavage and polyadenylation specificity factor complex subunit pta1', NULL, NULL, NULL, NULL, NULL, 4),
(124455, NULL, 'G3DSA:3.30.420.610:FF:000003', NULL, NULL, 'Meiosis regulator and mRNA stability factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(124456, NULL, 'G3DSA:2.10.25.10:FF:000774', NULL, NULL, 'von Willebrand factor D and EGF domains', NULL, NULL, NULL, NULL, NULL, 4),
(124457, NULL, 'G3DSA:3.20.20.150:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124458, NULL, 'G3DSA:3.40.50.80:FF:000006', NULL, NULL, 'Dual oxidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(124459, NULL, 'G3DSA:3.30.470.20:FF:000150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124460, NULL, 'G3DSA:1.10.630.10:FF:000071', NULL, NULL, 'Cytochrome P450 703A2', NULL, NULL, NULL, NULL, NULL, 4),
(124461, NULL, 'G3DSA:3.30.1640.10:FF:000042', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(124462, NULL, 'G3DSA:1.20.1730.10:FF:000041', NULL, NULL, 'sodium/glucose cotransporter 5-like', NULL, NULL, NULL, NULL, NULL, 4),
(124463, NULL, 'G3DSA:3.20.10.10:FF:000074', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(124464, NULL, 'G3DSA:3.40.50.300:FF:005158', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(124465, NULL, 'G3DSA:1.10.472.130:FF:000034', NULL, NULL, 'Dynein beta chain, flagellar outer arm', NULL, NULL, NULL, NULL, NULL, 4),
(124466, NULL, 'G3DSA:2.160.20.10:FF:000115', NULL, NULL, 'Polygalacturonase', NULL, NULL, NULL, NULL, NULL, 4),
(124467, NULL, 'G3DSA:2.130.10.10:FF:005091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124468, NULL, 'G3DSA:3.30.830.10:FF:000276', NULL, NULL, 'Phosphoglycan beta 1,3 galactosyltransferase 5', NULL, NULL, NULL, NULL, NULL, 4),
(124469, NULL, 'G3DSA:3.40.1050.10:FF:000005', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(124470, NULL, 'G3DSA:3.30.230.70:FF:000102', NULL, NULL, 'Exosome complex exonuclease RRP42', NULL, NULL, NULL, NULL, NULL, 4),
(124471, NULL, 'G3DSA:2.60.40.60:FF:000967', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(124472, NULL, 'G3DSA:4.10.860.120:FF:000003', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(124473, NULL, 'G3DSA:3.40.50.1110:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124474, NULL, 'G3DSA:3.50.50.60:FF:000567', NULL, NULL, 'Paromamine 6''-oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(124475, NULL, 'G3DSA:1.10.3730.20:FF:000047', NULL, NULL, 'EamA/RhaT family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(124476, NULL, 'G3DSA:1.25.40.10:FF:001733', NULL, NULL, 'Os04g0218100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(124477, NULL, 'G3DSA:1.10.630.10:FF:000447', NULL, NULL, 'Premnaspirodiene oxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(124478, NULL, 'G3DSA:1.25.40.10:FF:004459', NULL, NULL, 'Tetratricopeptide repeat protein 30 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(124479, NULL, 'G3DSA:3.90.190.10:FF:000617', NULL, NULL, 'LD15107p', NULL, NULL, NULL, NULL, NULL, 4),
(124480, NULL, 'G3DSA:2.60.40.150:FF:000052', NULL, NULL, 'RAS p21 protein activator 1', NULL, NULL, NULL, NULL, NULL, 4),
(124481, NULL, 'G3DSA:2.30.29.30:FF:000855', NULL, NULL, 'MMS19 nucleotide excision repair protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(124482, NULL, 'G3DSA:3.30.160.20:FF:000137', NULL, NULL, 'Putative RNase III', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(124483, NULL, 'G3DSA:1.10.443.10:FF:000006', NULL, NULL, 'Prophage integrase IntS', NULL, NULL, NULL, NULL, NULL, 4),
(124484, NULL, 'G3DSA:3.90.1150.10:FF:000485', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124485, NULL, 'G3DSA:3.30.1550.10:FF:000012', NULL, NULL, 'Probable 39S ribosomal protein L11, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(124486, NULL, 'G3DSA:2.10.25.10:FF:000251', NULL, NULL, 'sushi, nidogen and EGF-like domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(124487, NULL, 'G3DSA:1.10.2000.10:FF:000067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124488, NULL, 'G3DSA:3.40.50.170:FF:000015', NULL, NULL, 'Putative methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(124489, NULL, 'G3DSA:3.40.50.1220:FF:000054', NULL, NULL, 'Putative acetolactate synthase IlvG', NULL, NULL, NULL, NULL, NULL, 4),
(124490, NULL, 'G3DSA:3.80.10.10:FF:001280', NULL, NULL, 'Leucine rich repeats and immunoglobulin like domains 2', NULL, NULL, NULL, NULL, NULL, 4),
(124491, NULL, 'G3DSA:3.30.1340.10:FF:000002', NULL, NULL, 'PTS phosphocarrier protein NPr', NULL, NULL, NULL, NULL, NULL, 4),
(124492, NULL, 'G3DSA:1.10.8.270:FF:000082', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(124493, NULL, 'G3DSA:1.20.5.110:FF:000262', NULL, NULL, 'Vesicle-associated membrane protein 7b', NULL, NULL, NULL, NULL, NULL, 4),
(124494, NULL, 'G3DSA:3.30.1360.70:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124495, NULL, 'G3DSA:2.20.50.20:FF:000003', NULL, NULL, 'Microsomal triglyceride transfer protein large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(124496, NULL, 'G3DSA:1.10.8.60:FF:000042', NULL, NULL, '4-hydroxy-2-oxovalerate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(124497, NULL, 'G3DSA:3.30.2440.10:FF:000004', NULL, NULL, 'Type III secretion system effector SopD2', NULL, NULL, NULL, NULL, NULL, 4),
(124498, NULL, 'G3DSA:3.90.1150.10:FF:000518', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124499, NULL, 'G3DSA:3.30.830.10:FF:000309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124500, NULL, 'G3DSA:3.40.1180.10:FF:000009', NULL, NULL, 'Alkyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(124501, NULL, 'G3DSA:1.20.1250.20:FF:001564', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(124502, NULL, 'G3DSA:1.10.150.650:FF:000004', NULL, NULL, 'PHP domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(124503, NULL, 'G3DSA:1.10.10.250:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124504, NULL, 'G3DSA:3.30.160.60:FF:005736', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124505, NULL, 'G3DSA:3.40.50.300:FF:007687', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(124506, NULL, 'G3DSA:2.130.10.10:FF:003179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124507, NULL, 'G3DSA:3.40.50.2020:FF:000018', NULL, NULL, 'Phosphoribosyl pyrophosphate synthase-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(124508, NULL, 'G3DSA:2.60.40.2560:FF:000002', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(124509, NULL, 'G3DSA:3.90.1310.10:FF:000020', NULL, NULL, 'Cell division protein/Peptidoglycan synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(124510, NULL, 'G3DSA:1.10.510.10:FF:004159', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124511, NULL, 'G3DSA:3.40.1000.10:FF:000002', NULL, NULL, 'Protein dcrB', NULL, NULL, NULL, NULL, NULL, 4),
(124512, NULL, 'G3DSA:1.10.287.610:FF:000008', NULL, NULL, 'Apicoplast ribosomal protein S2', NULL, NULL, NULL, NULL, NULL, 4),
(124513, NULL, 'G3DSA:3.40.350.10:FF:000057', NULL, NULL, 'xaa-Pro aminopeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(124514, NULL, 'G3DSA:1.25.40.770:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124515, NULL, 'G3DSA:1.25.40.10:FF:002661', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(124516, NULL, 'G3DSA:3.30.70.360:FF:000039', NULL, NULL, 'Vacuolar carboxypeptidase Cps1, putative (AFU_orthologue AFUA_3G07040)', NULL, NULL, NULL, NULL, NULL, 4),
(124517, NULL, 'G3DSA:3.30.200.20:FF:001653', NULL, NULL, 'STE20-related kinase adapter protein alpha isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(124518, NULL, 'G3DSA:1.10.510.10:FF:001809', NULL, NULL, 'Serine/threonine protein kinase-41', NULL, NULL, NULL, NULL, NULL, 4),
(124519, NULL, 'G3DSA:1.10.1070.11:FF:000084', NULL, NULL, 'Phosphatidylinositol 3-kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(124520, NULL, 'G3DSA:3.40.1370.10:FF:000024', NULL, NULL, '50S ribosomal protein L4', NULL, NULL, NULL, NULL, NULL, 4),
(124521, NULL, 'G3DSA:3.40.50.2300:FF:001339', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124522, NULL, 'G3DSA:1.10.3200.20:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124523, NULL, 'G3DSA:2.10.25.10:FF:000195', NULL, NULL, 'versican core protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(124524, NULL, 'G3DSA:3.80.10.10:FF:002241', NULL, NULL, 'Receptor like protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(124525, NULL, 'G3DSA:3.40.1000.30:FF:000008', NULL, NULL, 'Uncharacterized protein, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(124526, NULL, 'G3DSA:1.10.2020.20:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124527, NULL, 'G3DSA:3.30.160.60:FF:001470', NULL, NULL, 'zinc finger protein 699 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(124528, NULL, 'G3DSA:2.60.40.10:FF:003578', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124529, NULL, 'G3DSA:3.60.90.10:FF:000021', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(124530, NULL, 'G3DSA:3.40.50.300:FF:001471', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(124531, NULL, 'G3DSA:2.130.10.10:FF:000829', NULL, NULL, 'Polyadenylation factor subunit 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(124532, NULL, 'G3DSA:3.40.50.300:FF:005922', NULL, NULL, 'ATP-binding cassette (ABC) transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(124533, NULL, 'G3DSA:3.60.20.10:FF:000016', NULL, NULL, 'Proteasome subunit alpha type-6', NULL, NULL, NULL, NULL, NULL, 4),
(124534, NULL, 'G3DSA:3.30.1360.120:FF:000093', NULL, NULL, 'Uncharacterized protein aq_2005', NULL, NULL, NULL, NULL, NULL, 4),
(124535, NULL, 'G3DSA:3.40.190.10:FF:000578', NULL, NULL, 'ABC transporter peptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(124536, NULL, 'G3DSA:3.40.50.410:FF:000340', NULL, NULL, 'Anthrax toxin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(124537, NULL, 'G3DSA:1.25.50.20:FF:000074', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(124538, NULL, 'G3DSA:2.130.10.10:FF:004163', NULL, NULL, 'Protein CBG20697', NULL, NULL, NULL, NULL, NULL, 4),
(124539, NULL, 'G3DSA:3.40.50.720:FF:001422', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124540, NULL, 'G3DSA:3.30.160.60:FF:000357', NULL, NULL, 'GLIS family zinc finger 2', NULL, NULL, NULL, NULL, NULL, 4),
(124541, NULL, 'G3DSA:3.30.70.340:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124542, NULL, 'G3DSA:3.40.50.2300:FF:001524', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124543, NULL, 'G3DSA:1.10.418.10:FF:000173', NULL, NULL, 'Gelation factor', NULL, NULL, NULL, NULL, NULL, 4),
(124544, NULL, 'G3DSA:3.40.718.10:FF:000041', NULL, NULL, 'Isocitrate dehydrogenase [NAD] subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(124545, NULL, 'G3DSA:3.40.50.300:FF:000543', NULL, NULL, 'Dynein axonemal heavy chain 5', NULL, NULL, NULL, NULL, NULL, 4),
(124546, NULL, 'G3DSA:3.30.450.60:FF:000025', NULL, NULL, 'Coatomer subunit zeta, putative', NULL, NULL, NULL, NULL, NULL, 4),
(124547, NULL, 'G3DSA:3.60.20.10:FF:000163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124548, NULL, 'G3DSA:3.40.50.2300:FF:001671', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124549, NULL, 'G3DSA:4.10.400.10:FF:000295', NULL, NULL, 'Low-density lipoprotein receptor, putative', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(124550, NULL, 'G3DSA:1.20.1560.10:FF:000680', NULL, NULL, 'Uncharacterized protein TagB', NULL, NULL, NULL, NULL, NULL, 4),
(124551, NULL, 'G3DSA:1.10.287.1490:FF:000149', NULL, NULL, 'Low-CO2-inducible protein', NULL, NULL, NULL, NULL, NULL, 4),
(124552, NULL, 'G3DSA:2.60.40.10:FF:003055', NULL, NULL, 'GM25453', NULL, NULL, NULL, NULL, NULL, 4),
(124553, NULL, 'G3DSA:2.60.40.10:FF:000705', NULL, NULL, 'Plexin B1', NULL, NULL, NULL, NULL, NULL, 4),
(124554, NULL, 'G3DSA:2.30.30.140:FF:000143', NULL, NULL, 'SAGA-associated factor 29', NULL, NULL, NULL, NULL, NULL, 4),
(124555, NULL, 'G3DSA:2.30.39.10:FF:000147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124556, NULL, 'G3DSA:3.90.1580.10:FF:000039', NULL, NULL, 'Chaperonin containing TCP1 subunit 6A', NULL, NULL, NULL, NULL, NULL, 4),
(124557, NULL, 'G3DSA:3.40.50.300:FF:005214', NULL, NULL, 'Iron(III)-transport ATP-binding protein sfuC', NULL, NULL, NULL, NULL, NULL, 4),
(124558, NULL, 'G3DSA:3.30.160.60:FF:005921', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124559, NULL, 'G3DSA:1.25.40.1010:FF:000019', NULL, NULL, 'Tetratricopeptide repeat (TPR)-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(124560, NULL, 'G3DSA:3.30.2360.10:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124561, NULL, 'G3DSA:3.30.230.80:FF:000015', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(124562, NULL, 'G3DSA:1.10.10.60:FF:000442', NULL, NULL, 'DNA methyltransferase 1-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(124563, NULL, 'G3DSA:1.10.10.60:FF:000818', NULL, NULL, 'Zinc fingers and homeoboxes 3', NULL, NULL, NULL, NULL, NULL, 4),
(124564, NULL, 'G3DSA:3.40.250.10:FF:000257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124565, NULL, 'G3DSA:3.40.50.2000:FF:000535', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124566, NULL, 'G3DSA:3.50.50.60:FF:001023', NULL, NULL, 'Rab proteins geranylgeranyltransferase component A', NULL, NULL, NULL, NULL, NULL, 4),
(124567, NULL, 'G3DSA:2.120.10.80:FF:000154', NULL, NULL, 'Blast:Kelch-like protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(124568, NULL, 'G3DSA:3.20.20.190:FF:000143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124569, NULL, 'G3DSA:3.30.505.50:FF:000004', NULL, NULL, 'Dormancy associated translation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(124570, NULL, 'G3DSA:2.20.100.10:FF:000098', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 7', NULL, NULL, NULL, NULL, NULL, 4),
(124571, NULL, 'G3DSA:3.40.50.2300:FF:000563', NULL, NULL, 'Receptor-type guanylate cyclase gcy-4', NULL, NULL, NULL, NULL, NULL, 4),
(124572, NULL, 'G3DSA:3.30.1490.180:FF:000015', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(124573, NULL, 'G3DSA:3.30.160.60:FF:001318', NULL, NULL, 'zinc finger protein 641', NULL, NULL, NULL, NULL, NULL, 4),
(124574, NULL, 'G3DSA:1.10.1070.11:FF:000117', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', NULL, NULL, NULL, NULL, NULL, 4),
(124575, NULL, 'G3DSA:3.90.920.10:FF:000005', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(124576, NULL, 'G3DSA:3.80.10.10:FF:002617', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124577, NULL, 'G3DSA:3.80.10.10:FF:002802', NULL, NULL, 'At5g27920', NULL, NULL, NULL, NULL, NULL, 4),
(124578, NULL, 'G3DSA:3.30.70.330:FF:000120', NULL, NULL, 'Negative regulator of differentiation 1', NULL, NULL, NULL, NULL, NULL, 4),
(124579, NULL, 'G3DSA:1.25.10.10:FF:001344', NULL, NULL, 'Uncharacterized protein CaJ7.0091', NULL, NULL, NULL, NULL, NULL, 4),
(124580, NULL, 'G3DSA:2.60.40.10:FF:005000', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124581, NULL, 'G3DSA:1.10.238.10:FF:001148', NULL, NULL, 'Ras-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(124582, NULL, 'G3DSA:3.40.50.300:FF:000919', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(124583, NULL, 'G3DSA:1.50.40.10:FF:000175', NULL, NULL, 'Mitochondrial carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(124584, NULL, 'G3DSA:3.90.550.10:FF:000224', NULL, NULL, 'Probable molybdenum cofactor guanylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(124585, NULL, 'G3DSA:2.60.40.10:FF:002206', NULL, NULL, 'V-set and immunoglobulin domain containing 10 like', NULL, NULL, NULL, NULL, NULL, 4),
(124586, NULL, 'G3DSA:1.10.8.270:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124587, NULL, 'G3DSA:2.40.50.140:FF:000802', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124588, NULL, 'G3DSA:2.30.29.30:FF:000355', NULL, NULL, 'protein SPIRRIG isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(124589, NULL, 'G3DSA:1.20.120.980:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124590, NULL, 'G3DSA:2.10.25.10:FF:000695', NULL, NULL, 'Plasminogen activator', NULL, NULL, NULL, NULL, NULL, 4),
(124591, NULL, 'G3DSA:3.40.50.10090:FF:000027', NULL, NULL, 'Uroporphyrinogen-III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(124592, NULL, 'G3DSA:2.40.240.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124593, NULL, 'G3DSA:2.30.30.380:FF:000075', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(124594, NULL, 'G3DSA:1.20.140.150:FF:000086', NULL, NULL, 'uncharacterized protein LOC100186803', NULL, NULL, NULL, NULL, NULL, 4),
(124595, NULL, 'G3DSA:3.30.70.1590:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124596, NULL, 'G3DSA:3.40.50.1820:FF:000907', NULL, NULL, 'Lipase member H-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(124597, NULL, 'G3DSA:3.30.70.3460:FF:000003', NULL, NULL, 'Heme d1 biosynthesis protein NirL', NULL, NULL, NULL, NULL, NULL, 4),
(124598, NULL, 'G3DSA:3.30.750.24:FF:000086', NULL, NULL, 'RNA recognition motif-containing protein RRM', NULL, NULL, NULL, NULL, NULL, 4),
(124599, NULL, 'G3DSA:3.30.70.330:FF:000356', NULL, NULL, 'Translation initiation factor 4B', NULL, NULL, NULL, NULL, NULL, 4),
(124600, NULL, 'G3DSA:1.20.5.990:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124601, NULL, 'G3DSA:1.10.20.10:FF:000153', NULL, NULL, 'histone H3-like centromeric protein A isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(124602, NULL, 'G3DSA:1.25.10.10:FF:001428', NULL, NULL, 'AGAP000770-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(124603, NULL, 'G3DSA:3.40.50.300:FF:001004', NULL, NULL, 'DNA excision repair protein ERCC-6-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(124604, NULL, 'G3DSA:3.40.50.2300:FF:001440', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124605, NULL, 'G3DSA:2.130.10.10:FF:003758', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124606, NULL, 'G3DSA:3.30.230.130:FF:000046', NULL, NULL, 'Cullin-5', NULL, NULL, NULL, NULL, NULL, 4),
(124607, NULL, 'G3DSA:3.30.160.20:FF:000132', NULL, NULL, 'Peptide chain release factor H', NULL, NULL, NULL, NULL, NULL, 4),
(124608, NULL, 'G3DSA:3.30.160.60:FF:003263', NULL, NULL, 'Zinc finger protein 479', NULL, NULL, NULL, NULL, NULL, 4),
(124609, NULL, 'G3DSA:1.10.10.10:FF:001748', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(124610, NULL, 'G3DSA:3.30.1130.10:FF:000025', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(124611, NULL, 'G3DSA:1.20.1600.10:FF:000032', NULL, NULL, 'Outer membrane efflux protein', NULL, NULL, NULL, NULL, NULL, 4),
(124612, NULL, 'G3DSA:3.90.190.10:FF:000241', NULL, NULL, 'Protein tyrosine phosphatase domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(124613, NULL, 'G3DSA:3.40.50.720:FF:000961', NULL, NULL, '4-hydroxy-tetrahydrodipicolinate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(124614, NULL, 'G3DSA:1.10.510.10:FF:000977', NULL, NULL, 'Fibroblast growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(124615, NULL, 'G3DSA:1.20.1740.10:FF:000093', NULL, NULL, 'Amino acid permease', NULL, NULL, NULL, NULL, NULL, 4),
(124616, NULL, 'G3DSA:1.20.80.10:FF:000021', NULL, NULL, 'pleckstrin homology domain-containing family H member 2', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(124617, NULL, 'G3DSA:1.25.40.10:FF:003594', NULL, NULL, 'SARP family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(124618, NULL, 'G3DSA:3.40.630.150:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124619, NULL, 'G3DSA:3.40.50.1000:FF:000100', NULL, NULL, 'Alpha,alpha-trehalose-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(124620, NULL, 'G3DSA:1.20.58.390:FF:000328', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124621, NULL, 'G3DSA:3.30.110.70:FF:000003', NULL, NULL, 'Heavy-metal-binding family protein', NULL, NULL, NULL, NULL, NULL, 4),
(124622, NULL, 'G3DSA:2.20.70.10:FF:000029', NULL, NULL, 'pre-mRNA-processing factor 40 homolog A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(124623, NULL, 'G3DSA:3.30.420.390:FF:000009', NULL, NULL, 'POLG (Mitochondrial DNA POLymerase Gamma)', NULL, NULL, NULL, NULL, NULL, 4),
(124624, NULL, 'G3DSA:3.40.50.1370:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124625, NULL, 'G3DSA:1.10.287.550:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124626, NULL, 'G3DSA:3.20.20.70:FF:000103', NULL, NULL, 'Putative deoxyribose-phosphate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(124627, NULL, 'G3DSA:1.20.1250.20:FF:000496', NULL, NULL, 'Cyanate transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(124628, NULL, 'G3DSA:2.60.40.10:FF:001638', NULL, NULL, 'Eph receptor tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(124629, NULL, 'G3DSA:1.20.1070.10:FF:002047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124630, NULL, 'G3DSA:1.10.630.10:FF:000571', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124631, NULL, 'G3DSA:1.10.238.10:FF:001092', NULL, NULL, 'Follistatin like 4', NULL, NULL, NULL, NULL, NULL, 4),
(124632, NULL, 'G3DSA:1.20.1310.10:FF:000217', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124633, NULL, 'G3DSA:1.20.5.4820:FF:000009', NULL, NULL, 'Myosin B', NULL, NULL, NULL, NULL, NULL, 4),
(124634, NULL, 'G3DSA:1.10.150.670:FF:000015', NULL, NULL, 'Essential Meiotic Endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(124635, NULL, 'G3DSA:3.30.1410.10:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124636, NULL, 'G3DSA:1.20.120.1910:FF:000038', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(124637, NULL, 'G3DSA:2.40.170.20:FF:000100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124638, NULL, 'G3DSA:2.60.40.10:FF:005972', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124639, NULL, 'G3DSA:2.130.10.10:FF:003707', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124640, NULL, 'G3DSA:3.80.10.10:FF:004394', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124641, NULL, 'G3DSA:3.30.420.10:FF:000323', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124642, NULL, 'G3DSA:3.40.50.300:FF:001055', NULL, NULL, 'putative pre-mRNA-splicing factor ATP-dependent RNA helicase DHX32', NULL, NULL, NULL, NULL, NULL, 4),
(124643, NULL, 'G3DSA:1.10.510.10:FF:001984', NULL, NULL, 'Kinase, CMGC RCK', NULL, NULL, NULL, NULL, NULL, 4),
(124644, NULL, 'G3DSA:3.40.50.2060:FF:000002', NULL, NULL, 'sec1 family domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(124645, NULL, 'G3DSA:3.40.50.880:FF:000172', NULL, NULL, 'Glutamine amidotransferase (Homolog to GMP synthase subunit A)', NULL, NULL, NULL, NULL, NULL, 4),
(124646, NULL, 'G3DSA:3.30.70.270:FF:000309', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124647, NULL, 'G3DSA:1.10.472.10:FF:000079', NULL, NULL, 'Putative cyclin-T1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(124648, NULL, 'G3DSA:1.10.287.70:FF:000554', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124649, NULL, 'G3DSA:3.40.50.1010:FF:000249', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124650, NULL, 'G3DSA:3.30.160.60:FF:006017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(124651, NULL, 'G3DSA:3.40.50.800:FF:000103', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(124652, NULL, 'G3DSA:1.20.5.1160:FF:000024', NULL, NULL, 'Putative keratin-87 protein', NULL, NULL, NULL, NULL, NULL, 4),
(124653, NULL, 'G3DSA:2.30.29.30:FF:000304', NULL, NULL, 'Beta-1-syntrophin isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(124654, NULL, 'G3DSA:1.10.167.20:FF:000002', NULL, NULL, 'Nuclear pore complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(124655, NULL, 'G3DSA:3.40.50.300:FF:002432', NULL, NULL, 'ATP synthase subunit alpha, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(124656, NULL, 'G3DSA:2.60.40.10:FF:005180', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124657, NULL, 'G3DSA:3.30.70.260:FF:000099', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(124658, NULL, 'G3DSA:2.130.10.130:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124659, NULL, 'G3DSA:1.25.40.10:FF:000800', NULL, NULL, 'Protein STABILIZED1', NULL, NULL, NULL, NULL, NULL, 4),
(124660, NULL, 'G3DSA:2.40.50.140:FF:001207', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124661, NULL, 'G3DSA:1.25.40.10:FF:002133', NULL, NULL, 'U4/U6-U5 snRNP complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(124662, NULL, 'G3DSA:3.40.50.300:FF:001908', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(124663, NULL, 'G3DSA:2.70.98.30:FF:000046', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(124664, NULL, 'G3DSA:1.20.1250.20:FF:001064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124665, NULL, 'G3DSA:1.20.1050.10:FF:000186', NULL, NULL, 'Bus-18', NULL, NULL, NULL, NULL, NULL, 4),
(124666, NULL, 'G3DSA:3.30.200.20:FF:001417', NULL, NULL, 'Mitogen-activated kinase kinase (MAKK), putative', NULL, NULL, NULL, NULL, NULL, 4),
(124667, NULL, 'G3DSA:3.30.200.20:FF:000220', NULL, NULL, 'mitogen-activated protein kinase kinase kinase 20 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(124668, NULL, 'G3DSA:2.130.10.10:FF:003319', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124669, NULL, 'G3DSA:2.30.24.10:FF:000001', NULL, NULL, 'Cryptic beta-glucoside bgl operon antiterminator', NULL, NULL, NULL, NULL, NULL, 4),
(124670, NULL, 'G3DSA:3.40.50.1970:FF:000020', NULL, NULL, 'Alcohol dehydrogenase, iron-dependent', NULL, NULL, NULL, NULL, NULL, 4),
(124671, NULL, 'G3DSA:1.25.40.10:FF:004111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124672, NULL, 'G3DSA:3.40.50.2300:FF:000451', NULL, NULL, 'Two-component response regulator ORR33', NULL, NULL, NULL, NULL, NULL, 4),
(124673, NULL, 'G3DSA:3.30.420.220:FF:000004', NULL, NULL, 'Uncharacterized NOP5 family protein MJ0694', NULL, NULL, NULL, NULL, NULL, 4),
(124674, NULL, 'G3DSA:3.40.50.150:FF:000532', NULL, NULL, 'Chemotaxis protein methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(124675, NULL, 'G3DSA:3.30.160.60:FF:005449', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124676, NULL, 'G3DSA:2.10.25.10:FF:001263', NULL, NULL, 'Receptor tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(124677, NULL, 'G3DSA:2.30.42.10:FF:000374', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124678, NULL, 'G3DSA:1.10.437.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124679, NULL, 'G3DSA:3.20.20.80:FF:000432', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124680, NULL, 'G3DSA:3.40.50.80:FF:000219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124681, NULL, 'G3DSA:3.30.40.10:FF:001042', NULL, NULL, 'Protein CBR-CBP-1', NULL, NULL, NULL, NULL, NULL, 4),
(124682, NULL, 'G3DSA:3.90.780.10:FF:000033', NULL, NULL, '5'' nucleotidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(124683, NULL, 'G3DSA:3.40.50.300:FF:006647', NULL, NULL, 'Torsin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(124684, NULL, 'G3DSA:3.30.1490.180:FF:000010', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(124685, NULL, 'G3DSA:3.80.10.10:FF:001600', NULL, NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase At5g58150', NULL, NULL, NULL, NULL, NULL, 4),
(124686, NULL, 'G3DSA:3.80.10.10:FF:002089', NULL, NULL, 'Cell surface glycoprotein gp138', NULL, NULL, NULL, NULL, NULL, 4),
(124687, NULL, 'G3DSA:3.40.50.300:FF:005219', NULL, NULL, 'U3 small nucleolar RNA-associated protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(124688, NULL, 'G3DSA:3.90.740.10:FF:000019', NULL, NULL, 'Isoleucine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(124689, NULL, 'G3DSA:2.60.200.20:FF:000251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124690, NULL, 'G3DSA:3.90.660.10:FF:000018', NULL, NULL, 'Renalase', NULL, NULL, NULL, NULL, NULL, 4),
(124691, NULL, 'G3DSA:1.20.1530.20:FF:000057', NULL, NULL, 'Na(+)/H(+) antiporter NhaS2', NULL, NULL, NULL, NULL, NULL, 4),
(124692, NULL, 'G3DSA:3.40.50.300:FF:000066', NULL, NULL, 'ABC transporter B family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(124693, NULL, 'G3DSA:1.10.510.10:FF:002501', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124694, NULL, 'G3DSA:3.90.1150.10:FF:000226', NULL, NULL, 'Adenosylmethionine--8-amino-7-oxononanoate transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(124695, NULL, 'G3DSA:3.10.10.10:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124696, NULL, 'G3DSA:1.50.10.150:FF:000012', NULL, NULL, 'Voltage-dependent anion channel', NULL, NULL, NULL, NULL, NULL, 4),
(124697, NULL, 'G3DSA:2.130.10.10:FF:002870', NULL, NULL, 'Related to KOG1-Subunit of TORC1, a rapamycin-sensitive complex involved in growth control', NULL, NULL, NULL, NULL, NULL, 4),
(124698, NULL, 'G3DSA:3.30.70.80:FF:000002', NULL, NULL, 'Subtilisin-like protease SBT5.3', NULL, NULL, NULL, NULL, NULL, 4),
(124699, NULL, 'G3DSA:3.20.20.100:FF:000217', NULL, NULL, 'Aldo-keto-reductase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(124700, NULL, 'G3DSA:3.40.50.720:FF:001366', NULL, NULL, 'Formate dehydrogenase chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(124701, NULL, 'G3DSA:1.10.418.40:FF:000013', NULL, NULL, 'Beclin-1-like protein A', NULL, NULL, NULL, NULL, NULL, 4),
(124702, NULL, 'G3DSA:3.80.10.10:FF:002038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124703, NULL, 'G3DSA:1.25.40.20:FF:000157', NULL, NULL, 'short transient receptor potential channel 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(124704, NULL, 'G3DSA:1.20.1250.20:FF:001856', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124705, NULL, 'G3DSA:3.30.505.10:FF:000251', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124706, NULL, 'G3DSA:2.10.220.10:FF:000210', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(124707, NULL, 'G3DSA:3.90.1150.10:FF:000338', NULL, NULL, 'Histidinol-phosphate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(124708, NULL, 'G3DSA:1.10.565.10:FF:000143', NULL, NULL, 'Peroxisome proliferator-activated receptor alpha', NULL, NULL, NULL, NULL, NULL, 4),
(124709, NULL, 'G3DSA:2.40.320.10:FF:000008', NULL, NULL, 'Zinc phosphodiesterase ELAC protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(124710, NULL, 'G3DSA:3.40.50.300:FF:003825', NULL, NULL, 'Putative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(124711, NULL, 'G3DSA:1.10.285.10:FF:000009', NULL, NULL, 'Glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(124712, NULL, 'G3DSA:3.30.160.60:FF:005680', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124713, NULL, 'G3DSA:1.25.40.10:FF:001256', NULL, NULL, 'Alpha-soluble NSF attachment protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(124714, NULL, 'G3DSA:1.25.40.180:FF:000346', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124715, NULL, 'G3DSA:3.30.1380.20:FF:000013', NULL, NULL, 'Trafficking protein particle complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(124716, NULL, 'G3DSA:1.20.1070.10:FF:000069', NULL, NULL, 'Prokineticin receptor 2', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(124717, NULL, 'G3DSA:3.40.50.300:FF:008143', NULL, NULL, 'Fanconi anemia group M protein', NULL, NULL, NULL, NULL, NULL, 4),
(124718, NULL, 'G3DSA:3.10.20.870:FF:000006', NULL, NULL, 'Related to DOA1-involved in ubiquitin-dependent proteolysis', NULL, NULL, NULL, NULL, NULL, 4),
(124719, NULL, 'G3DSA:1.10.150.850:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124720, NULL, 'G3DSA:1.10.220.30:FF:000023', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(124721, NULL, 'G3DSA:1.20.1110.10:FF:000236', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124722, NULL, 'G3DSA:1.20.80.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124723, NULL, 'G3DSA:3.30.230.10:FF:000399', NULL, NULL, 'Putative tetracycline resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(124724, NULL, 'G3DSA:2.60.40.1730:FF:000051', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(124725, NULL, 'G3DSA:3.40.50.720:FF:000910', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(124726, NULL, 'G3DSA:2.40.50.100:FF:000026', NULL, NULL, '50S ribosomal protein L27', NULL, NULL, NULL, NULL, NULL, 4),
(124727, NULL, 'G3DSA:3.30.160.60:FF:001234', NULL, NULL, 'Zinc finger protein 394', NULL, NULL, NULL, NULL, NULL, 4),
(124728, NULL, 'G3DSA:2.20.100.10:FF:000238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124729, NULL, 'G3DSA:1.10.8.60:FF:000334', NULL, NULL, 'Vesicle-fusing ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(124730, NULL, 'G3DSA:3.40.50.1820:FF:000054', NULL, NULL, 'Alpha/beta-Hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(124731, NULL, 'G3DSA:3.40.50.300:FF:008204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124732, NULL, 'G3DSA:1.10.10.440:FF:000035', NULL, NULL, 'Putative ff domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(124733, NULL, 'G3DSA:3.40.50.1820:FF:000166', NULL, NULL, 'group XV phospholipase A2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(124734, NULL, 'G3DSA:3.40.50.300:FF:003472', NULL, NULL, 'GTP-binding nuclear protein', NULL, NULL, NULL, NULL, NULL, 4),
(124735, NULL, 'G3DSA:3.40.50.12370:FF:000003', NULL, NULL, 'Os05g0276100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(124736, NULL, 'G3DSA:1.25.10.10:FF:000068', NULL, NULL, 'cytoskeleton-associated protein 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(124737, NULL, 'G3DSA:3.30.420.80:FF:000030', NULL, NULL, '40S ribosomal protein S14-3', NULL, NULL, NULL, NULL, NULL, 4),
(124738, NULL, 'G3DSA:3.90.1150.10:FF:000277', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(124739, NULL, 'G3DSA:3.40.30.10:FF:000535', NULL, NULL, 'Nitroreductase', NULL, NULL, NULL, NULL, NULL, 4),
(124740, NULL, 'G3DSA:1.20.1560.10:FF:000848', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(124741, NULL, 'G3DSA:1.10.150.490:FF:000001', NULL, NULL, 'Gag polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(124742, NULL, 'G3DSA:2.10.70.10:FF:000058', NULL, NULL, 'sushi repeat-containing protein SRPX2', NULL, NULL, NULL, NULL, NULL, 4),
(124743, NULL, 'G3DSA:3.90.228.10:FF:000060', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(124744, NULL, 'G3DSA:2.40.20.10:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124745, NULL, 'G3DSA:1.10.12.10:FF:000050', NULL, NULL, 'Enoyl-CoA hydratase domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(124746, NULL, 'G3DSA:2.40.240.10:FF:000007', NULL, NULL, 'Glutamine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(124747, NULL, 'G3DSA:3.20.20.80:FF:000320', NULL, NULL, 'Glucan endo-1,3-beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(124748, NULL, 'G3DSA:3.30.870.10:FF:000082', NULL, NULL, 'Cardiolipin synthase family enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(124749, NULL, 'G3DSA:3.40.50.11370:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124750, NULL, 'G3DSA:2.30.29.30:FF:000708', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(124751, NULL, 'G3DSA:1.50.40.10:FF:000596', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(124752, NULL, 'G3DSA:1.20.1250.20:FF:001805', NULL, NULL, 'Siderophore iron transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(124753, NULL, 'G3DSA:1.10.3720.10:FF:000217', NULL, NULL, 'Sulfate ABC transport system permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(124754, NULL, 'G3DSA:3.40.50.970:FF:000159', NULL, NULL, 'Oxoglutarate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(124755, NULL, 'G3DSA:3.30.420.40:FF:000158', NULL, NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(124756, NULL, 'G3DSA:2.60.40.10:FF:000649', NULL, NULL, 'Advanced glycosylation end product-specific receptor', NULL, NULL, NULL, NULL, NULL, 4),
(124757, NULL, 'G3DSA:1.10.132.80:FF:000001', NULL, NULL, 'Terminase small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(124758, NULL, 'G3DSA:3.60.21.10:FF:000210', NULL, NULL, 'Phosphoesterase', NULL, NULL, NULL, NULL, NULL, 4),
(124759, NULL, 'G3DSA:3.90.550.50:FF:000180', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(124760, NULL, 'G3DSA:3.30.1300.30:FF:000011', NULL, NULL, 'Type II secretion system protein K', NULL, NULL, NULL, NULL, NULL, 4),
(124761, NULL, 'G3DSA:1.20.58.60:FF:000276', NULL, NULL, 'Utrophin', NULL, NULL, NULL, NULL, NULL, 4),
(124762, NULL, 'G3DSA:3.40.50.1460:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124763, NULL, 'G3DSA:1.20.1540.10:FF:000094', NULL, NULL, 'Rhomboid family protease', NULL, NULL, NULL, NULL, NULL, 4),
(124764, NULL, 'G3DSA:2.30.30.30:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124765, NULL, 'G3DSA:3.40.50.300:FF:006698', NULL, NULL, 'Obg-like ATPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(124766, NULL, 'G3DSA:3.20.20.100:FF:000156', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(124767, NULL, 'G3DSA:2.130.10.10:FF:001521', NULL, NULL, 'CPSF A subunit region protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(124768, NULL, 'G3DSA:2.60.40.10:FF:001689', NULL, NULL, 'Myoblast growth factor receptor egl-15', NULL, NULL, NULL, NULL, NULL, 4),
(124769, NULL, 'G3DSA:3.40.720.10:FF:000041', NULL, NULL, 'GPI ethanolamine phosphate transferase 3', NULL, NULL, NULL, NULL, NULL, 4),
(124770, NULL, 'G3DSA:2.130.10.10:FF:002010', NULL, NULL, 'WD40 repeat-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(124771, NULL, 'G3DSA:3.40.50.10420:FF:000031', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(124772, NULL, 'G3DSA:3.10.20.90:FF:000790', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124773, NULL, 'G3DSA:2.60.40.150:FF:000765', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124774, NULL, 'G3DSA:1.10.510.10:FF:000505', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(124775, NULL, 'G3DSA:4.10.410.20:FF:000006', NULL, NULL, 'proteoglycan 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(124776, NULL, 'G3DSA:1.25.40.10:FF:002245', NULL, NULL, 'Tetratricopeptide repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(124777, NULL, 'G3DSA:3.30.70.260:FF:000048', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(124778, NULL, 'G3DSA:1.10.10.350:FF:000008', NULL, NULL, 'Glutamate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(124779, NULL, 'G3DSA:1.20.1280.50:FF:000119', NULL, NULL, 'Related to pyrimidine 5-nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(124780, NULL, 'G3DSA:3.40.50.1760:FF:000007', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(124781, NULL, 'G3DSA:2.130.10.130:FF:000005', NULL, NULL, 'Integrin alpha L', NULL, NULL, NULL, NULL, NULL, 4),
(124782, NULL, 'G3DSA:2.60.40.10:FF:004123', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124783, NULL, 'G3DSA:3.40.50.11950:FF:000006', NULL, NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(124784, NULL, 'G3DSA:1.10.510.10:FF:003850', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124785, NULL, 'G3DSA:3.80.10.10:FF:000291', NULL, NULL, 'F-box and leucine rich repeat protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(124786, NULL, 'G3DSA:3.40.1080.10:FF:000013', NULL, NULL, 'Citrate lyase alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(124787, NULL, 'G3DSA:3.40.640.10:FF:000040', NULL, NULL, 'UDP-4-amino-4-deoxy-L-arabinose--oxoglutarate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(124788, NULL, 'G3DSA:3.40.50.300:FF:003421', NULL, NULL, 'tRNA isopentenyltransferase putative', NULL, NULL, NULL, NULL, NULL, 4),
(124789, NULL, 'G3DSA:3.30.1370.100:FF:000027', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(124790, NULL, 'G3DSA:1.10.287.70:FF:000503', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124791, NULL, 'G3DSA:3.30.70.330:FF:002773', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124792, NULL, 'G3DSA:2.130.10.10:FF:002398', NULL, NULL, 'Protein CBG10826', NULL, NULL, NULL, NULL, NULL, 4),
(124793, NULL, 'G3DSA:2.170.270.10:FF:000198', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(124794, NULL, 'G3DSA:2.130.10.10:FF:000161', NULL, NULL, 'DNA damage-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(124795, NULL, 'G3DSA:3.40.920.10:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124796, NULL, 'G3DSA:3.60.70.12:FF:000005', NULL, NULL, 'Arginine biosynthesis bifunctional protein ArgJ', NULL, NULL, NULL, NULL, NULL, 4),
(124797, NULL, 'G3DSA:3.30.1610.10:FF:000006', NULL, NULL, 'Nuclear pore complex protein Nup98', NULL, NULL, NULL, NULL, NULL, 4),
(124798, NULL, 'G3DSA:1.10.730.10:FF:000067', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(124799, NULL, 'G3DSA:3.30.160.60:FF:005528', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124800, NULL, 'G3DSA:2.10.25.10:FF:001151', NULL, NULL, 'Platelet endothelial aggregation receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(124801, NULL, 'G3DSA:3.40.50.300:FF:007187', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NUBP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(124802, NULL, 'G3DSA:3.30.1330.30:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124803, NULL, 'G3DSA:1.10.238.10:FF:000423', NULL, NULL, 'Polcalcin Jun o 2', NULL, NULL, NULL, NULL, NULL, 4),
(124804, NULL, 'G3DSA:3.30.342.10:FF:000012', NULL, NULL, 'DNA polymerase epsilon catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(124805, NULL, 'G3DSA:3.30.160.60:FF:002774', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(124806, NULL, 'G3DSA:3.40.720.10:FF:000102', NULL, NULL, 'Cofactor-independent phosphoglycerate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(124807, NULL, 'G3DSA:3.30.40.10:FF:001542', NULL, NULL, 'Ring finger domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(124808, NULL, 'G3DSA:3.20.20.190:FF:000082', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(124809, NULL, 'G3DSA:1.10.565.10:FF:000059', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(124810, NULL, 'G3DSA:3.80.10.10:FF:000240', NULL, NULL, 'Leucine rich repeat containing 3C', NULL, NULL, NULL, NULL, NULL, 4),
(124811, NULL, 'G3DSA:4.10.480.10:FF:000002', NULL, NULL, 'Hydrogenase-1 small chain', NULL, NULL, NULL, NULL, NULL, 4),
(124812, NULL, 'G3DSA:1.10.8.50:FF:000005', NULL, NULL, 'Endonuclease 8', NULL, NULL, NULL, NULL, NULL, 4),
(124813, NULL, 'G3DSA:3.30.1400.10:FF:000001', NULL, NULL, 'Cell division protein ZipA', NULL, NULL, NULL, NULL, NULL, 4),
(124814, NULL, 'G3DSA:2.130.10.30:FF:000167', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124815, NULL, 'G3DSA:2.60.40.60:FF:000350', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(124816, NULL, 'G3DSA:3.40.30.10:FF:001024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(124817, NULL, 'G3DSA:1.10.510.10:FF:001141', NULL, NULL, 'Os01g0155500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(124818, NULL, 'G3DSA:1.10.287.3240:FF:000017', NULL, NULL, 'GM21350', NULL, NULL, NULL, NULL, NULL, 4),
(124819, NULL, 'G3DSA:3.30.110.10:FF:000013', NULL, NULL, 'Translation initiation factor IF-3 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(124820, NULL, 'G3DSA:3.40.50.150:FF:001442', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124821, NULL, 'G3DSA:3.40.50.12280:FF:000009', NULL, NULL, 'NADH dehydrogenase [ubiquinone] iron-sulfur protein 7, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(124822, NULL, 'G3DSA:3.10.100.10:FF:000017', NULL, NULL, 'collectin-12 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(124823, NULL, 'G3DSA:3.40.190.10:FF:000078', NULL, NULL, 'glutamate receptor ionotropic, NMDA 3B', NULL, NULL, NULL, NULL, NULL, 4),
(124824, NULL, 'G3DSA:3.30.200.20:FF:000580', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(124825, NULL, 'G3DSA:1.10.472.10:FF:000579', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124826, NULL, 'G3DSA:2.130.10.10:FF:001442', NULL, NULL, 'Nucleoporin 214', NULL, NULL, NULL, NULL, NULL, 4),
(124827, NULL, 'G3DSA:3.40.395.10:FF:000031', NULL, NULL, 'YALI0E21153p', NULL, NULL, NULL, NULL, NULL, 4),
(124828, NULL, 'G3DSA:1.10.490.10:FF:000008', NULL, NULL, 'non-symbiotic hemoglobin 1', NULL, NULL, NULL, NULL, NULL, 4),
(124829, NULL, 'G3DSA:1.25.10.10:FF:001057', NULL, NULL, 'Clathrin-coated vesicle protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(124830, NULL, 'G3DSA:1.10.230.10:FF:000023', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(124831, NULL, 'G3DSA:3.30.40.10:FF:002391', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124832, NULL, 'G3DSA:3.80.10.10:FF:004455', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124833, NULL, 'G3DSA:3.40.50.10330:FF:000116', NULL, NULL, 'Ceramide kinase-like isoform 9', NULL, NULL, NULL, NULL, NULL, 4),
(124834, NULL, 'G3DSA:1.25.40.20:FF:001534', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(124835, NULL, 'G3DSA:1.10.287.70:FF:000054', NULL, NULL, 'Voltage-dependent T-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(124836, NULL, 'G3DSA:2.30.30.40:FF:000378', NULL, NULL, 'Elongation factor 2 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(124837, NULL, 'G3DSA:1.10.510.10:FF:002473', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124838, NULL, 'G3DSA:3.60.10.10:FF:000393', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124839, NULL, 'G3DSA:1.10.555.10:FF:000266', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124840, NULL, 'G3DSA:3.30.160.60:FF:006085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124841, NULL, 'G3DSA:1.10.510.10:FF:003378', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124842, NULL, 'G3DSA:2.130.10.10:FF:005383', NULL, NULL, 'CPSF A subunit region family protein', NULL, NULL, NULL, NULL, NULL, 4),
(124843, NULL, 'G3DSA:2.60.40.10:FF:003555', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124844, NULL, 'G3DSA:2.20.110.10:FF:000036', NULL, NULL, 'MORN repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(124845, NULL, 'G3DSA:1.25.10.10:FF:003053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124846, NULL, 'G3DSA:2.60.40.640:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124847, NULL, 'G3DSA:2.60.40.1170:FF:000012', NULL, NULL, 'Stonin 2', NULL, NULL, NULL, NULL, NULL, 4),
(124848, NULL, 'G3DSA:3.40.190.10:FF:000819', NULL, NULL, 'Glutamate ionotropic receptor delta type subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(124849, NULL, 'G3DSA:1.20.1250.20:FF:000867', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(124850, NULL, 'G3DSA:1.20.5.730:FF:000009', NULL, NULL, 'Rabaptin, RAB GTPase binding effector protein 2', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(124851, NULL, 'G3DSA:1.20.58.480:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124852, NULL, 'G3DSA:3.40.50.1820:FF:000846', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124853, NULL, 'G3DSA:2.60.40.2170:FF:000003', NULL, NULL, 'Shifted, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(124854, NULL, 'G3DSA:1.25.10.10:FF:002777', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124855, NULL, 'G3DSA:2.60.120.260:FF:000043', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(124856, NULL, 'G3DSA:3.40.1190.20:FF:000075', NULL, NULL, 'Mak32p', NULL, NULL, NULL, NULL, NULL, 4),
(124857, NULL, 'G3DSA:2.60.40.10:FF:003263', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124858, NULL, 'G3DSA:3.20.20.70:FF:000603', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124859, NULL, 'G3DSA:3.60.15.10:FF:000038', NULL, NULL, 'DNA cross-link repair protein pso2/snm1', NULL, NULL, NULL, NULL, NULL, 4),
(124860, NULL, 'G3DSA:2.60.40.1960:FF:000002', NULL, NULL, 'Pepsin-like aspartic protease A1', NULL, NULL, NULL, NULL, NULL, 4),
(124861, NULL, 'G3DSA:1.25.40.10:FF:004050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124862, NULL, 'G3DSA:1.20.1270.60:FF:000312', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124863, NULL, 'G3DSA:1.10.10.10:FF:000500', NULL, NULL, 'Phenylacetic acid degradation operon negative regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(124864, NULL, 'G3DSA:1.20.1070.10:FF:001137', NULL, NULL, 'Substance-K receptor', NULL, NULL, NULL, NULL, NULL, 4),
(124865, NULL, 'G3DSA:3.40.50.300:FF:000515', NULL, NULL, 'GTPase Obg', NULL, NULL, NULL, NULL, NULL, 4),
(124866, NULL, 'G3DSA:3.30.40.10:FF:000845', NULL, NULL, 'RING-H2 finger protein ATL75-like', NULL, NULL, NULL, NULL, NULL, 4),
(124867, NULL, 'G3DSA:2.60.120.200:FF:000132', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(124868, NULL, 'G3DSA:3.40.250.10:FF:000145', NULL, NULL, 'Sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(124869, NULL, 'G3DSA:3.30.505.10:FF:000190', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124870, NULL, 'G3DSA:3.20.20.70:FF:000042', NULL, NULL, 'Pyridoxine 5''-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(124871, NULL, 'G3DSA:2.60.40.10:FF:002706', NULL, NULL, 'AGAP009061-PA', NULL, NULL, NULL, NULL, NULL, 4),
(124872, NULL, 'G3DSA:2.60.40.10:FF:006017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124873, NULL, 'G3DSA:3.10.260.10:FF:000006', NULL, NULL, 'Swi4p', NULL, NULL, NULL, NULL, NULL, 4),
(124874, NULL, 'G3DSA:3.80.10.10:FF:002477', NULL, NULL, 'Si:ch1073-82l19.1', NULL, NULL, NULL, NULL, NULL, 4),
(124875, NULL, 'G3DSA:3.10.180.10:FF:000005', NULL, NULL, 'YecM family protein', NULL, NULL, NULL, NULL, NULL, 4),
(124876, NULL, 'G3DSA:1.10.510.10:FF:001192', NULL, NULL, 'SH3 domain-binding kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(124877, NULL, 'G3DSA:3.30.40.10:FF:002239', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(124878, NULL, 'G3DSA:3.10.50.40:FF:000024', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase FKBP1A', NULL, NULL, NULL, NULL, NULL, 4),
(124879, NULL, 'G3DSA:3.30.1010.10:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124880, NULL, 'G3DSA:3.60.10.10:FF:000342', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(124881, NULL, 'G3DSA:3.40.50.20:FF:000067', NULL, NULL, 'Carbamoyl-phosphate synthetase 2, aspartate transcarbamylase, and dihydroorotase', NULL, NULL, NULL, NULL, NULL, 4),
(124882, NULL, 'G3DSA:1.25.10.10:FF:001349', NULL, NULL, 'Nucleotide exchange factor SIL1', NULL, NULL, NULL, NULL, NULL, 4),
(124883, NULL, 'G3DSA:1.25.40.860:FF:000011', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(124884, NULL, 'G3DSA:3.50.50.60:FF:001028', NULL, NULL, 'Rab proteins geranylgeranyltransferase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(124885, NULL, 'G3DSA:2.130.10.10:FF:002510', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124886, NULL, 'G3DSA:3.40.50.970:FF:000047', NULL, NULL, 'Probable pyruvate-flavodoxin oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(124887, NULL, 'G3DSA:3.20.20.190:FF:000031', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(124888, NULL, 'G3DSA:1.20.1740.10:FF:000154', NULL, NULL, 'Solute carrier family 7 member 3', NULL, NULL, NULL, NULL, NULL, 4),
(124889, NULL, 'G3DSA:2.130.10.10:FF:005624', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', NULL, NULL, NULL, NULL, NULL, 4),
(124890, NULL, 'G3DSA:3.40.47.10:FF:000219', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124891, NULL, 'G3DSA:2.60.40.10:FF:004623', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124892, NULL, 'G3DSA:3.60.20.10:FF:000168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124893, NULL, 'G3DSA:1.20.1250.20:FF:000575', NULL, NULL, 'Vba1p', NULL, NULL, NULL, NULL, NULL, 4),
(124894, NULL, 'G3DSA:1.20.120.720:FF:000062', NULL, NULL, 'Myosin, heavy chain 15', NULL, NULL, NULL, NULL, NULL, 4),
(124895, NULL, 'G3DSA:3.40.50.300:FF:007136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124896, NULL, 'G3DSA:1.25.40.10:FF:004662', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124897, NULL, 'G3DSA:1.20.120.1080:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124898, NULL, 'G3DSA:3.60.21.10:FF:000159', NULL, NULL, 'Bifunctional 5-nucleotidase/2,3-cyclic phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(124899, NULL, 'G3DSA:2.40.50.140:FF:000010', NULL, NULL, 'Transcription termination factor Rho', NULL, NULL, NULL, NULL, NULL, 4),
(124900, NULL, 'G3DSA:3.40.50.1820:FF:001122', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(124901, NULL, 'G3DSA:2.60.40.1450:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124902, NULL, 'G3DSA:3.40.50.360:FF:000038', NULL, NULL, 'NADPH-dependent FMN reductase', NULL, NULL, NULL, NULL, NULL, 4),
(124903, NULL, 'G3DSA:2.130.10.10:FF:005332', NULL, NULL, 'WD-40 repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(124904, NULL, 'G3DSA:3.30.60.60:FF:000018', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(124905, NULL, 'G3DSA:1.10.8.720:FF:000060', NULL, NULL, 'Si:dkey-11m19.5', NULL, NULL, NULL, NULL, NULL, 4),
(124906, NULL, 'G3DSA:1.20.80.60:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124907, NULL, 'G3DSA:1.10.565.10:FF:000031', NULL, NULL, 'Nuclear receptor subfamily 0 group B member 1', NULL, NULL, NULL, NULL, NULL, 4),
(124908, NULL, 'G3DSA:2.60.40.10:FF:004915', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124909, NULL, 'G3DSA:3.90.660.10:FF:000086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124910, NULL, 'G3DSA:1.10.510.10:FF:001933', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(124911, NULL, 'G3DSA:3.30.1450.10:FF:000004', NULL, NULL, 'Outer membrane protein assembly factor BamE', NULL, NULL, NULL, NULL, NULL, 4),
(124912, NULL, 'G3DSA:2.130.10.10:FF:002802', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124913, NULL, 'G3DSA:2.40.30.10:FF:000453', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124914, NULL, 'G3DSA:3.30.230.40:FF:000003', NULL, NULL, 'Imidazoleglycerol-phosphate dehydratase HisB', NULL, NULL, NULL, NULL, NULL, 4),
(124915, NULL, 'G3DSA:2.30.30.30:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124916, NULL, 'G3DSA:3.30.365.10:FF:000048', NULL, NULL, 'Molybdopterin-binding domain of aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(124917, NULL, 'G3DSA:3.90.640.10:FF:000023', NULL, NULL, 'Hsp70 chaperone (BiP)', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(124918, NULL, 'G3DSA:2.120.10.30:FF:000280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124919, NULL, 'G3DSA:1.25.40.180:FF:000234', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124920, NULL, 'G3DSA:2.40.50.100:FF:000105', NULL, NULL, 'sn-glycerol-3-phosphate ABC transporter ATP-binding protein UgpC', NULL, NULL, NULL, NULL, NULL, 4),
(124921, NULL, 'G3DSA:3.10.105.10:FF:000040', NULL, NULL, 'Probable glycine betaine-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(124922, NULL, 'G3DSA:3.30.70.330:FF:001896', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124923, NULL, 'G3DSA:2.60.40.150:FF:000473', NULL, NULL, 'YALI0B13904p', NULL, NULL, NULL, NULL, NULL, 4),
(124924, NULL, 'G3DSA:1.20.1250.20:FF:000524', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(124925, NULL, 'G3DSA:1.25.40.10:FF:000688', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(124926, NULL, 'G3DSA:2.40.230.10:FF:000001', NULL, NULL, 'Phospholipase A(1)', NULL, NULL, NULL, NULL, NULL, 4),
(124927, NULL, 'G3DSA:2.10.25.10:FF:001763', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124928, NULL, 'G3DSA:3.30.70.940:FF:000005', NULL, NULL, 'Transcription elongation factor SPT5', NULL, NULL, NULL, NULL, NULL, 4),
(124929, NULL, 'G3DSA:3.40.50.10190:FF:000091', NULL, NULL, 'Regulator of Ty1 transposition', NULL, NULL, NULL, NULL, NULL, 4),
(124930, NULL, 'G3DSA:3.30.160.60:FF:004168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124931, NULL, 'G3DSA:3.40.50.10190:FF:000040', NULL, NULL, 'Mediator of DNA damage checkpoint protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(124932, NULL, 'G3DSA:1.10.600.10:FF:000063', NULL, NULL, 'Farnesyl-diphosphate farnesyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(124933, NULL, 'G3DSA:1.10.10.1000:FF:000001', NULL, NULL, 'YopR family type III secretion effector', NULL, NULL, NULL, NULL, NULL, 4),
(124934, NULL, 'G3DSA:3.80.10.10:FF:003045', NULL, NULL, 'Slit3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(124935, NULL, 'G3DSA:1.10.10.60:FF:000942', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124936, NULL, 'G3DSA:3.30.70.920:FF:000050', NULL, NULL, 'Leucine-responsive regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(124937, NULL, 'G3DSA:3.40.50.1820:FF:000458', NULL, NULL, 'LDH1p Serine hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(124938, NULL, 'G3DSA:2.60.40.60:FF:000962', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(124939, NULL, 'G3DSA:3.40.190.10:FF:000027', NULL, NULL, 'DNA-binding transcriptional regulator OxyR', NULL, NULL, NULL, NULL, NULL, 4),
(124940, NULL, 'G3DSA:2.120.10.80:FF:000002', NULL, NULL, 'Kelch-like family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(124941, NULL, 'G3DSA:3.60.10.10:FF:000050', NULL, NULL, 'Type I inositol polyphosphate 5-phosphatase 8', NULL, NULL, NULL, NULL, NULL, 4),
(124942, NULL, 'G3DSA:2.130.10.10:FF:000953', NULL, NULL, 'Putative peptidyl-prolyl cis-trans isomerase and WD40 repeat domain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(124943, NULL, 'G3DSA:3.20.100.20:FF:000001', NULL, NULL, 'mRNA-capping enzyme catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(124944, NULL, 'G3DSA:1.20.120.1300:FF:000001', NULL, NULL, '5,10-methenyltetrahydromethanopterin hydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(124945, NULL, 'G3DSA:2.60.40.10:FF:002145', NULL, NULL, 'Major histocompatibility complex class I LDA', NULL, NULL, NULL, NULL, NULL, 4),
(124946, NULL, 'G3DSA:1.10.287.1390:FF:000001', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(124947, NULL, 'G3DSA:3.30.160.60:FF:000245', NULL, NULL, 'zinc finger protein Gfi-1', NULL, NULL, NULL, NULL, NULL, 4),
(124948, NULL, 'G3DSA:1.25.10.10:FF:001928', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(124949, NULL, 'G3DSA:3.80.10.10:FF:002769', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124950, NULL, 'G3DSA:3.90.226.10:FF:000010', NULL, NULL, 'acetyl-CoA carboxylase isoform X2', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(124951, NULL, 'G3DSA:3.30.70.330:FF:001716', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124952, NULL, 'G3DSA:3.60.15.10:FF:000089', NULL, NULL, 'Possible hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(124953, NULL, 'G3DSA:2.10.25.10:FF:001712', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(124954, NULL, 'G3DSA:3.30.63.20:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124955, NULL, 'G3DSA:3.30.200.20:FF:002378', NULL, NULL, 'Meiosis-specific serine/threonine-protein kinase mek1', NULL, NULL, NULL, NULL, NULL, 4),
(124956, NULL, 'G3DSA:1.20.920.10:FF:000034', NULL, NULL, 'Bromodomain and WD repeat domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(124957, NULL, 'G3DSA:1.20.58.2230:FF:000002', NULL, NULL, 'AFR652Wp', NULL, NULL, NULL, NULL, NULL, 4),
(124958, NULL, 'G3DSA:1.10.10.10:FF:001248', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(124959, NULL, 'G3DSA:2.30.30.100:FF:000182', NULL, NULL, 'Like-Sm ribonucleoprotein core', NULL, NULL, NULL, NULL, NULL, 4),
(124960, NULL, 'G3DSA:3.30.160.60:FF:003651', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124961, NULL, 'G3DSA:3.75.10.10:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124962, NULL, 'G3DSA:1.25.10.10:FF:002417', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124963, NULL, 'G3DSA:1.20.120.1320:FF:000007', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(124964, NULL, 'G3DSA:3.30.60.30:FF:000190', NULL, NULL, 'Osteonectin; SPARC; Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124965, NULL, 'G3DSA:3.40.140.10:FF:000075', NULL, NULL, 'COP9 signalosome complex subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(124966, NULL, 'G3DSA:3.30.300.210:FF:000002', NULL, NULL, 'Ger(X)C family spore germination protein', NULL, NULL, NULL, NULL, NULL, 4),
(124967, NULL, 'G3DSA:3.30.160.60:FF:001346', NULL, NULL, 'zinc finger protein 398', NULL, NULL, NULL, NULL, NULL, 4),
(124968, NULL, 'G3DSA:2.60.40.1390:FF:000027', NULL, NULL, 'Transcriptional regulator PacG/VIB-1', NULL, NULL, NULL, NULL, NULL, 4),
(124969, NULL, 'G3DSA:3.40.1000.10:FF:000025', NULL, NULL, 'RGM domain family, member D', NULL, NULL, NULL, NULL, NULL, 4),
(124970, NULL, 'G3DSA:2.30.30.140:FF:000295', NULL, NULL, 'Protein lin-61', NULL, NULL, NULL, NULL, NULL, 4),
(124971, NULL, 'G3DSA:2.130.10.10:FF:005675', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124972, NULL, 'G3DSA:2.40.30.10:FF:000402', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124973, NULL, 'G3DSA:3.50.50.60:FF:001079', NULL, NULL, 'Succinate dehydrogenase (quinone)', NULL, NULL, NULL, NULL, NULL, 4),
(124974, NULL, 'G3DSA:2.60.40.60:FF:000911', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124975, NULL, 'G3DSA:3.60.40.10:FF:000170', NULL, NULL, 'Type 2C protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(124976, NULL, 'G3DSA:3.30.70.330:FF:002385', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124977, NULL, 'G3DSA:3.30.70.3040:FF:000001', NULL, NULL, 'Cell division protein FtsX', NULL, NULL, NULL, NULL, NULL, 4),
(124978, NULL, 'G3DSA:1.20.1250.20:FF:001013', NULL, NULL, 'Os04g0452600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(124979, NULL, 'G3DSA:1.25.40.10:FF:001177', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(124980, NULL, 'G3DSA:3.80.10.10:FF:000583', NULL, NULL, '18w protein', NULL, NULL, NULL, NULL, NULL, 4),
(124981, NULL, 'G3DSA:2.20.100.10:FF:000159', NULL, NULL, 'spondin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(124982, NULL, 'G3DSA:3.40.250.10:FF:000196', NULL, NULL, 'Adenylyltransferase and sulfurtransferase UBA4', NULL, NULL, NULL, NULL, NULL, 4),
(124983, NULL, 'G3DSA:1.25.40.10:FF:002537', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(124984, NULL, 'G3DSA:2.60.98.10:FF:000001', NULL, NULL, 'Envelope glycoprotein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(124985, NULL, 'G3DSA:3.40.50.1460:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124986, NULL, 'G3DSA:2.30.180.10:FF:000061', NULL, NULL, 'Vacuolar membrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(124987, NULL, 'G3DSA:3.30.1520.10:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124988, NULL, 'G3DSA:2.40.70.10:FF:000399', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124989, NULL, 'G3DSA:3.30.70.240:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124990, NULL, 'G3DSA:3.30.200.20:FF:001529', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124991, NULL, 'G3DSA:3.40.190.10:FF:000639', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(124992, NULL, 'G3DSA:3.40.1800.20:FF:000021', NULL, NULL, 'GD13125', NULL, NULL, NULL, NULL, NULL, 4),
(124993, NULL, 'G3DSA:3.10.180.10:FF:000056', NULL, NULL, 'Predicted enzyme related to lactoylglutathione lyase', NULL, NULL, NULL, NULL, NULL, 4),
(124994, NULL, 'G3DSA:1.10.10.60:FF:000993', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124995, NULL, 'G3DSA:1.10.533.10:FF:000272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124996, NULL, 'G3DSA:3.40.50.2000:FF:000563', NULL, NULL, 'Glycosyltransferase WbuB', NULL, NULL, NULL, NULL, NULL, 4),
(124997, NULL, 'G3DSA:1.10.510.10:FF:002422', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(124998, NULL, 'G3DSA:1.20.1560.10:FF:000769', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(124999, NULL, 'G3DSA:1.25.40.20:FF:001585', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125000, NULL, 'G3DSA:3.40.50.720:FF:000809', NULL, NULL, 'Very-long-chain 3-oxoacyl-CoA reductase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(125001, NULL, 'G3DSA:3.40.1190.20:FF:000024', NULL, NULL, 'Ribokinase', NULL, NULL, NULL, NULL, NULL, 4),
(125002, NULL, 'G3DSA:1.25.40.10:FF:005359', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125003, NULL, 'G3DSA:2.130.10.10:FF:001493', NULL, NULL, 'WD domain, G-beta repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(125004, NULL, 'G3DSA:3.40.50.1820:FF:000407', NULL, NULL, 'Protein FAM135A', NULL, NULL, NULL, NULL, NULL, 4),
(125005, NULL, 'G3DSA:1.10.10.10:FF:001809', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125006, NULL, 'G3DSA:3.40.50.1100:FF:000304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125007, NULL, 'G3DSA:1.20.1260.10:FF:000044', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(125008, NULL, 'G3DSA:3.30.465.10:FF:000084', NULL, NULL, 'Transporter, HlyC/CorC family', NULL, NULL, NULL, NULL, NULL, 4),
(125009, NULL, 'G3DSA:2.40.440.10:FF:000006', NULL, NULL, 'L,D-transpeptidase catalytic domain', NULL, NULL, NULL, NULL, NULL, 4),
(125010, NULL, 'G3DSA:2.60.120.10:FF:000360', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125011, NULL, 'G3DSA:2.10.25.10:FF:000987', NULL, NULL, 'Transmembrane cell adhesion receptor mua-3', NULL, NULL, NULL, NULL, NULL, 4),
(125012, NULL, 'G3DSA:3.30.365.10:FF:000020', NULL, NULL, 'Selenate reductase subunit YgfN', NULL, NULL, NULL, NULL, NULL, 4),
(125013, NULL, 'G3DSA:3.30.1360.70:FF:000004', NULL, NULL, 'Probable arginine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(125014, NULL, 'G3DSA:3.40.50.300:FF:007075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125015, NULL, 'G3DSA:1.20.58.1070:FF:000019', NULL, NULL, 'Survival motor neuron interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(125016, NULL, 'G3DSA:2.30.39.10:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125017, NULL, 'G3DSA:2.60.260.20:FF:000176', NULL, NULL, 'Zgc:122979', NULL, NULL, NULL, NULL, NULL, 4),
(125018, NULL, 'G3DSA:2.40.10.10:FF:000250', NULL, NULL, 'AGAP009216-PA', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(125019, NULL, 'G3DSA:1.25.10.10:FF:003266', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(125020, NULL, 'G3DSA:2.10.110.10:FF:000089', NULL, NULL, 'LIM and SH3 domain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(125021, NULL, 'G3DSA:2.40.50.140:FF:000982', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125022, NULL, 'G3DSA:2.70.70.10:FF:000044', NULL, NULL, 'Protease LasA', NULL, NULL, NULL, NULL, NULL, 4),
(125023, NULL, 'G3DSA:2.130.10.10:FF:003027', NULL, NULL, 'Protein HIR2', NULL, NULL, NULL, NULL, NULL, 4),
(125024, NULL, 'G3DSA:2.30.29.30:FF:000063', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(125025, NULL, 'G3DSA:1.25.40.10:FF:001705', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g74850, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(125026, NULL, 'G3DSA:1.10.287.2250:FF:000012', NULL, NULL, 'Senescence-specific cysteine protease SAG39', NULL, NULL, NULL, NULL, NULL, 4),
(125027, NULL, 'G3DSA:2.60.220.50:FF:000177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125028, NULL, 'G3DSA:3.40.50.11210:FF:000009', NULL, NULL, 'Uncharacterized protein, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(125029, NULL, 'G3DSA:1.10.510.10:FF:004007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125030, NULL, 'G3DSA:2.60.40.150:FF:000265', NULL, NULL, 'Inn1p', NULL, NULL, NULL, NULL, NULL, 4),
(125031, NULL, 'G3DSA:1.20.140.40:FF:000034', NULL, NULL, 'Invertase/pectin methylesterase inhibitor family protein', NULL, NULL, NULL, NULL, NULL, 4),
(125032, NULL, 'G3DSA:3.40.50.300:FF:007715', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125033, NULL, 'G3DSA:3.50.50.60:FF:001107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125034, NULL, 'G3DSA:1.20.1260.110:FF:000001', NULL, NULL, 'DNA integrity scanning protein DisA', NULL, NULL, NULL, NULL, NULL, 4),
(125035, NULL, 'G3DSA:3.40.50.2000:FF:000804', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125036, NULL, 'G3DSA:3.40.718.10:FF:000046', NULL, NULL, 'Isocitrate dehydrogenase [NAD] regulatory subunit 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(125037, NULL, 'G3DSA:2.40.30.10:FF:000245', NULL, NULL, 'Terephthalate 1,2-dioxygenase, reductase component 2', NULL, NULL, NULL, NULL, NULL, 4),
(125038, NULL, 'G3DSA:3.40.50.720:FF:002434', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(125039, NULL, 'G3DSA:3.30.70.1350:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125040, NULL, 'G3DSA:3.30.160.60:FF:002987', NULL, NULL, 'Zinc finger protein 945', NULL, NULL, NULL, NULL, NULL, 4),
(125041, NULL, 'G3DSA:3.30.360.20:FF:000001', NULL, NULL, 'RNA terminal phosphate cyclase-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(125042, NULL, 'G3DSA:1.10.10.10:FF:001456', NULL, NULL, 'Transcription initiation factor IIF subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(125043, NULL, 'G3DSA:2.60.120.10:FF:000601', NULL, NULL, 'Mannose-1-phosphate guanylyltransferase/mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(125044, NULL, 'G3DSA:1.20.5.780:FF:000002', NULL, NULL, 'FXYD domain-containing ion transport regulator', NULL, NULL, NULL, NULL, NULL, 4),
(125045, NULL, 'G3DSA:3.40.570.10:FF:000045', NULL, NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(125046, NULL, 'G3DSA:1.20.1070.10:FF:001581', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125047, NULL, 'G3DSA:2.130.10.10:FF:005175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125048, NULL, 'G3DSA:3.30.70.20:FF:000030', NULL, NULL, 'Putative oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(125049, NULL, 'G3DSA:1.10.225.10:FF:000005', NULL, NULL, 'prosaposin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(125050, NULL, 'G3DSA:3.40.50.300:FF:003764', NULL, NULL, 'Protein CBG17574', NULL, NULL, NULL, NULL, NULL, 4),
(125051, NULL, 'G3DSA:2.60.40.1170:FF:000080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(125052, NULL, 'G3DSA:2.10.70.10:FF:000142', NULL, NULL, 'Coagulation factor XIII B chain', NULL, NULL, NULL, NULL, NULL, 4),
(125053, NULL, 'G3DSA:3.40.1120.10:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125054, NULL, 'G3DSA:1.20.1250.20:FF:001513', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125055, NULL, 'G3DSA:3.20.20.70:FF:000671', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125056, NULL, 'G3DSA:1.25.10.10:FF:002709', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125057, NULL, 'G3DSA:2.40.170.20:FF:000128', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125058, NULL, 'G3DSA:3.30.200.20:FF:001940', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125059, NULL, 'G3DSA:3.80.10.10:FF:001021', NULL, NULL, 'Leucine-rich receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(125060, NULL, 'G3DSA:3.40.50.1820:FF:001190', NULL, NULL, 'AGAP004013-PA', NULL, NULL, NULL, NULL, NULL, 4),
(125061, NULL, 'G3DSA:3.10.50.40:FF:000092', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(125062, NULL, 'G3DSA:1.20.5.110:FF:000003', NULL, NULL, '60S ribosomal protein L13', NULL, NULL, NULL, NULL, NULL, 4),
(125063, NULL, 'G3DSA:3.40.50.1700:FF:000035', NULL, NULL, 'Beta-N-acetylglucosaminidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(125064, NULL, 'G3DSA:2.60.40.640:FF:000075', NULL, NULL, 'pH-response regulator protein palF/RIM8', NULL, NULL, NULL, NULL, NULL, 4),
(125065, NULL, 'G3DSA:3.30.70.2740:FF:000006', NULL, NULL, 'NAD-independent D-lactate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(125066, NULL, 'G3DSA:3.70.10.10:FF:000021', NULL, NULL, 'DNA damage checkpoint', NULL, NULL, NULL, NULL, NULL, 4),
(125067, NULL, 'G3DSA:2.60.120.330:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125068, NULL, 'G3DSA:3.40.50.300:FF:000779', NULL, NULL, 'Probable ATP-dependent RNA helicase DHR1', NULL, NULL, NULL, NULL, NULL, 4),
(125069, NULL, 'G3DSA:3.40.50.80:FF:000158', NULL, NULL, 'YALI0F29161p', NULL, NULL, NULL, NULL, NULL, 4),
(125070, NULL, 'G3DSA:2.60.40.10:FF:000700', NULL, NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein', NULL, NULL, NULL, NULL, NULL, 4),
(125071, NULL, 'G3DSA:2.60.40.10:FF:004011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125072, NULL, 'G3DSA:2.60.40.1910:FF:000009', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(125073, NULL, 'G3DSA:3.20.20.140:FF:000038', NULL, NULL, 'Adenosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(125074, NULL, 'G3DSA:3.30.160.60:FF:000806', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(125075, NULL, 'G3DSA:3.20.180.20:FF:000017', NULL, NULL, 'Ciliary dynein heavy chain 11', NULL, NULL, NULL, NULL, NULL, 4),
(125076, NULL, 'G3DSA:2.60.40.10:FF:003494', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125077, NULL, 'G3DSA:3.50.50.60:FF:001259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125078, NULL, 'G3DSA:1.10.287.70:FF:000615', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125079, NULL, 'G3DSA:3.40.190.120:FF:000002', NULL, NULL, 'Osmoprotectant ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(125080, NULL, 'G3DSA:3.40.50.300:FF:007979', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125081, NULL, 'G3DSA:3.40.50.1820:FF:000615', NULL, NULL, 'Meta cleavage compound hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(125082, NULL, 'G3DSA:1.10.3430.10:FF:000066', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(125083, NULL, 'G3DSA:3.90.730.10:FF:000030', NULL, NULL, 'Ribonuclease T2, like', NULL, NULL, NULL, NULL, NULL, 4),
(125084, NULL, 'G3DSA:1.25.40.180:FF:000285', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125085, NULL, 'G3DSA:3.40.50.300:FF:001616', NULL, NULL, 'Lsa family ABC-F type ribosomal protection protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(125086, NULL, 'G3DSA:3.30.1520.10:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125087, NULL, 'G3DSA:1.10.533.10:FF:000160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125088, NULL, 'G3DSA:3.30.200.20:FF:000512', NULL, NULL, 'Receptor-like protein kinase HSL1', NULL, NULL, NULL, NULL, NULL, 4),
(125089, NULL, 'G3DSA:2.60.40.10:FF:005528', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125090, NULL, 'G3DSA:3.30.70.330:FF:002885', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125091, NULL, 'G3DSA:1.20.5.1040:FF:000005', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(125092, NULL, 'G3DSA:3.90.180.10:FF:000116', NULL, NULL, 'Alcohol dehydrogenase, zinc-containing', NULL, NULL, NULL, NULL, NULL, 4),
(125093, NULL, 'G3DSA:3.80.10.10:FF:000791', NULL, NULL, 'F-box/LRR-repeat protein 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(125094, NULL, 'G3DSA:3.40.50.2020:FF:000069', NULL, NULL, 'Zgc:174895', NULL, NULL, NULL, NULL, NULL, 4),
(125095, NULL, 'G3DSA:3.30.160.60:FF:005972', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125096, NULL, 'G3DSA:3.10.290.10:FF:000098', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(125097, NULL, 'G3DSA:2.80.10.50:FF:000271', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(125098, NULL, 'G3DSA:3.90.1410.10:FF:000033', NULL, NULL, 'histone-lysine N-methyltransferase setd3-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(125099, NULL, 'G3DSA:2.60.40.60:FF:000170', NULL, NULL, 'FAT atypical cadherin 4', NULL, NULL, NULL, NULL, NULL, 4),
(125100, NULL, 'G3DSA:3.30.70.330:FF:000648', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(125101, NULL, 'G3DSA:3.40.50.300:FF:006355', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125102, NULL, 'G3DSA:1.25.40.10:FF:004611', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125103, NULL, 'G3DSA:1.25.40.180:FF:000054', NULL, NULL, 'MIF4G domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(125104, NULL, 'G3DSA:3.90.1580.10:FF:000034', NULL, NULL, 'Zgc:136465 protein', NULL, NULL, NULL, NULL, NULL, 4),
(125105, NULL, 'G3DSA:2.130.10.10:FF:000009', NULL, NULL, 'Protein transport protein Sec31A isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(125106, NULL, 'G3DSA:2.60.220.30:FF:000019', NULL, NULL, 'AGAP009061-PA', NULL, NULL, NULL, NULL, NULL, 4),
(125107, NULL, 'G3DSA:3.30.930.10:FF:000424', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(125108, NULL, 'G3DSA:4.10.280.10:FF:000054', NULL, NULL, 'hairy and enhancer of split-related protein HELT', NULL, NULL, NULL, NULL, NULL, 4),
(125109, NULL, 'G3DSA:3.30.590.10:FF:000009', NULL, NULL, 'Lengsin, lens protein with glutamine synthetase domain', NULL, NULL, NULL, NULL, NULL, 4),
(125110, NULL, 'G3DSA:2.40.40.10:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125111, NULL, 'G3DSA:2.60.40.10:FF:001138', NULL, NULL, 'Sallimus, isoform P', NULL, NULL, NULL, NULL, NULL, 4),
(125112, NULL, 'G3DSA:3.40.50.720:FF:001006', NULL, NULL, 'GD20759', NULL, NULL, NULL, NULL, NULL, 4),
(125113, NULL, 'G3DSA:3.90.550.10:FF:000196', NULL, NULL, 'Glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(125114, NULL, 'G3DSA:3.30.200.20:FF:000248', NULL, NULL, 'Serine/threonine-protein kinase PBS1', NULL, NULL, NULL, NULL, NULL, 4),
(125115, NULL, 'G3DSA:3.30.70.1400:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125116, NULL, 'G3DSA:2.130.10.10:FF:005916', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(125117, NULL, 'G3DSA:1.25.40.10:FF:003094', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(125118, NULL, 'G3DSA:1.10.555.10:FF:000053', NULL, NULL, 'RhoGAP domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(125119, NULL, 'G3DSA:3.40.1160.10:FF:000070', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(125120, NULL, 'G3DSA:1.10.1270.20:FF:000005', NULL, NULL, 'tRNA (guanine-N(1)-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(125121, NULL, 'G3DSA:3.30.160.60:FF:000065', NULL, NULL, 'B-cell CLL/lymphoma 6, member B', NULL, NULL, NULL, NULL, NULL, 4),
(125122, NULL, 'G3DSA:3.30.2350.20:FF:000062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125123, NULL, 'G3DSA:3.30.40.10:FF:001334', NULL, NULL, 'Ubiquitin conjugating enzyme interacting protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(125124, NULL, 'G3DSA:3.30.160.60:FF:001577', NULL, NULL, 'Crooked legs, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(125125, NULL, 'G3DSA:1.20.1300.10:FF:000048', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(125126, NULL, 'G3DSA:3.40.50.850:FF:000028', NULL, NULL, 'Nicotinamidase', NULL, NULL, NULL, NULL, NULL, 4),
(125127, NULL, 'G3DSA:1.10.510.10:FF:002130', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(125128, NULL, 'G3DSA:1.10.8.10:FF:000140', NULL, NULL, 'UBX domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(125129, NULL, 'G3DSA:2.60.40.10:FF:002774', NULL, NULL, 'MHC class II antigen beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(125130, NULL, 'G3DSA:1.20.58.1590:FF:000001', NULL, NULL, 'Tethering factor for nuclear proteasome STS1', NULL, NULL, NULL, NULL, NULL, 4),
(125131, NULL, 'G3DSA:1.25.40.10:FF:001969', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g06140, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(125132, NULL, 'G3DSA:1.20.58.60:FF:000804', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(125133, NULL, 'G3DSA:2.60.120.380:FF:000062', NULL, NULL, 'Calpain-5', NULL, NULL, NULL, NULL, NULL, 4),
(125134, NULL, 'G3DSA:3.60.10.10:FF:000162', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(125135, NULL, 'G3DSA:1.10.287.110:FF:000420', NULL, NULL, 'DnaJ-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(125136, NULL, 'G3DSA:1.20.1250.20:FF:001305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125137, NULL, 'G3DSA:2.30.34.10:FF:000007', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(125138, NULL, 'G3DSA:3.20.20.80:FF:000399', NULL, NULL, 'Lactase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(125139, NULL, 'G3DSA:2.30.29.30:FF:000804', NULL, NULL, 'ADR388Cp', NULL, NULL, NULL, NULL, NULL, 4),
(125140, NULL, 'G3DSA:3.10.100.10:FF:000113', NULL, NULL, 'CD72 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(125141, NULL, 'G3DSA:3.40.50.150:FF:001650', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125142, NULL, 'G3DSA:3.40.50.10190:FF:000271', NULL, NULL, 'DNA topoisomerase 2-binding protein 1-A', NULL, NULL, NULL, NULL, NULL, 4),
(125143, NULL, 'G3DSA:3.10.100.10:FF:000225', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125144, NULL, 'G3DSA:3.20.20.140:FF:000302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125145, NULL, 'G3DSA:3.40.50.720:FF:000017', NULL, NULL, 'Malate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(125146, NULL, 'G3DSA:1.10.1200.10:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125147, NULL, 'G3DSA:3.50.50.60:FF:000915', NULL, NULL, 'L-lysine 6-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(125148, NULL, 'G3DSA:3.60.20.10:FF:000247', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125149, NULL, 'G3DSA:3.30.70.330:FF:002677', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125150, NULL, 'G3DSA:1.25.10.10:FF:000411', NULL, NULL, 'protein VAC14 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(125151, NULL, 'G3DSA:2.60.40.10:FF:005680', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125152, NULL, 'G3DSA:1.25.40.20:FF:001877', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(125153, NULL, 'G3DSA:1.10.10.830:FF:000006', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(125154, NULL, 'G3DSA:1.20.1270.60:FF:000104', NULL, NULL, 'Unplaced genomic scaffold supercont1.20, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(125155, NULL, 'G3DSA:1.10.2000.10:FF:000016', NULL, NULL, 'Frizzled', NULL, NULL, NULL, NULL, NULL, 4),
(125156, NULL, 'G3DSA:1.10.510.10:FF:001692', NULL, NULL, 'Gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(125157, NULL, 'G3DSA:1.10.10.10:FF:000096', NULL, NULL, 'Rap guanine nucleotide exchange factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(125158, NULL, 'G3DSA:3.30.420.10:FF:000615', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125159, NULL, 'G3DSA:3.30.160.20:FF:000053', NULL, NULL, 'protein SON isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(125160, NULL, 'G3DSA:3.30.200.20:FF:001237', NULL, NULL, 'Os04g0370100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(125161, NULL, 'G3DSA:3.40.50.300:FF:000627', NULL, NULL, 'Methylenetetrahydrofolate dehydrogenase (NADP+ dependent) 1 like', NULL, NULL, NULL, NULL, NULL, 4),
(125162, NULL, 'G3DSA:1.10.20.10:FF:000057', NULL, NULL, 'ankyrin repeat and BTB/POZ domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(125163, NULL, 'G3DSA:1.10.10.650:FF:000008', NULL, NULL, 'Transcription elongation factor SPT6', NULL, NULL, NULL, NULL, NULL, 4),
(125164, NULL, 'G3DSA:2.40.70.10:FF:000079', NULL, NULL, 'Putative aspartic proteinase nepenthesin II', NULL, NULL, NULL, NULL, NULL, 4),
(125165, NULL, 'G3DSA:1.20.120.160:FF:000023', NULL, NULL, 'Gliding motility regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(125166, NULL, 'G3DSA:1.20.120.350:FF:000046', NULL, NULL, 'Potassium voltage-gated channel subfamily F member 1', NULL, NULL, NULL, NULL, NULL, 4),
(125167, NULL, 'G3DSA:3.40.50.2000:FF:000119', NULL, NULL, 'Glycosyl transferase group 1', NULL, NULL, NULL, NULL, NULL, 4),
(125168, NULL, 'G3DSA:2.130.10.10:FF:003207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125169, NULL, 'G3DSA:3.40.190.10:FF:000319', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(125170, NULL, 'G3DSA:3.30.70.330:FF:000468', NULL, NULL, 'Related to single-stranded DNA-binding protein MSSP-1', NULL, NULL, NULL, NULL, NULL, 4),
(125171, NULL, 'G3DSA:1.20.1050.10:FF:000298', NULL, NULL, 'Glutathione s-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(125172, NULL, 'G3DSA:2.30.42.10:FF:000262', NULL, NULL, 'Golgi reassembly stacking protein', NULL, NULL, NULL, NULL, NULL, 4),
(125173, NULL, 'G3DSA:3.40.50.1100:FF:000012', NULL, NULL, 'Threonine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(125174, NULL, 'G3DSA:3.30.479.20:FF:000023', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(125175, NULL, 'G3DSA:1.25.40.10:FF:005128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125176, NULL, 'G3DSA:3.80.10.10:FF:002589', NULL, NULL, 'Leucine-rich repeat-containing protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(125177, NULL, 'G3DSA:1.25.10.10:FF:002985', NULL, NULL, 'Proteasome component ecm29', NULL, NULL, NULL, NULL, NULL, 4),
(125178, NULL, 'G3DSA:4.10.1240.10:FF:000083', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(125179, NULL, 'G3DSA:3.40.50.300:FF:005630', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(125180, NULL, 'G3DSA:3.30.1330.100:FF:000002', NULL, NULL, 'Coenzyme F420:L-glutamate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(125181, NULL, 'G3DSA:3.40.50.2300:FF:000794', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125182, NULL, 'G3DSA:3.30.1330.20:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125183, NULL, 'G3DSA:3.40.50.10330:FF:000060', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(125184, NULL, 'G3DSA:3.40.50.1110:FF:000072', NULL, NULL, 'Lipase/acylhydrolase, GDSL family', NULL, NULL, NULL, NULL, NULL, 4),
(125185, NULL, 'G3DSA:2.60.40.10:FF:001077', NULL, NULL, 'T-lymphocyte activation antigen CD80', NULL, NULL, NULL, NULL, NULL, 4),
(125186, NULL, 'G3DSA:1.50.10.10:FF:000055', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(125187, NULL, 'G3DSA:1.25.40.10:FF:004454', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(125188, NULL, 'G3DSA:1.10.10.60:FF:000150', NULL, NULL, 'POU domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(125189, NULL, 'G3DSA:3.30.160.60:FF:003943', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125190, NULL, 'G3DSA:1.25.40.10:FF:003673', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At1g12700, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(125191, NULL, 'G3DSA:2.40.50.140:FF:000870', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125192, NULL, 'G3DSA:1.25.40.10:FF:000008', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(125193, NULL, 'G3DSA:2.10.25.10:FF:000919', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125194, NULL, 'G3DSA:3.60.40.10:FF:000231', NULL, NULL, 'Stage II sporulation E family protein', NULL, NULL, NULL, NULL, NULL, 4),
(125195, NULL, 'G3DSA:1.10.10.60:FF:000493', NULL, NULL, 'Homeobox protein Ved', NULL, NULL, NULL, NULL, NULL, 4),
(125196, NULL, 'G3DSA:1.20.140.150:FF:000018', NULL, NULL, 'Transmembrane protein 178B', NULL, NULL, NULL, NULL, NULL, 4),
(125197, NULL, 'G3DSA:2.10.109.10:FF:000075', NULL, NULL, 'Uncharacterized protein HI_1546', NULL, NULL, NULL, NULL, NULL, 4),
(125198, NULL, 'G3DSA:3.60.130.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125199, NULL, 'G3DSA:3.30.40.10:FF:001834', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125200, NULL, 'G3DSA:3.30.160.60:FF:005000', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125201, NULL, 'G3DSA:2.60.120.330:FF:000143', NULL, NULL, 'Gibberellin 2-beta-dioxygenase 8', NULL, NULL, NULL, NULL, NULL, 4),
(125202, NULL, 'G3DSA:1.10.3470.10:FF:000063', NULL, NULL, 'Putative ABC transporter permease protein MJ0876', NULL, NULL, NULL, NULL, NULL, 4),
(125203, NULL, 'G3DSA:3.90.1150.10:FF:000434', NULL, NULL, 'Glutamic-oxaloacetic transaminase 1, soluble', NULL, NULL, NULL, NULL, NULL, 4),
(125204, NULL, 'G3DSA:1.20.58.60:FF:000647', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125205, NULL, 'G3DSA:3.40.50.720:FF:001978', NULL, NULL, '(S)-1-Phenylethanol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(125206, NULL, 'G3DSA:3.40.50.300:FF:000274', NULL, NULL, 'ras-related protein RABA5a', NULL, NULL, NULL, NULL, NULL, 4),
(125207, NULL, 'G3DSA:3.40.1170.10:FF:000020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(125208, NULL, 'G3DSA:3.30.160.60:FF:004668', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125209, NULL, 'G3DSA:2.60.40.10:FF:003847', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125210, NULL, 'G3DSA:2.60.40.2030:FF:000023', NULL, NULL, 'Adhesion G protein-coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(125211, NULL, 'G3DSA:3.90.70.10:FF:000479', NULL, NULL, 'Cathepsin K-like', NULL, NULL, NULL, NULL, NULL, 4),
(125212, NULL, 'G3DSA:1.10.1410.10:FF:000115', NULL, NULL, 'Nucleolar protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(125213, NULL, 'G3DSA:2.60.370.10:FF:000001', NULL, NULL, 'COX11 cytochrome c oxidase assembly homolog', NULL, NULL, NULL, NULL, NULL, 4),
(125214, NULL, 'G3DSA:3.30.70.580:FF:000026', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(125215, NULL, 'G3DSA:1.20.1310.20:FF:000046', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(125216, NULL, 'G3DSA:3.40.50.200:FF:000070', NULL, NULL, 'Gob-1', NULL, NULL, NULL, NULL, NULL, 4),
(125217, NULL, 'G3DSA:3.40.50.410:FF:000368', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125218, NULL, 'G3DSA:3.40.20.10:FF:000006', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(125219, NULL, 'G3DSA:3.40.50.150:FF:001493', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125220, NULL, 'G3DSA:1.10.630.10:FF:000683', NULL, NULL, 'Cytochrome P450, family 2, subfamily j, polypeptide 13', NULL, NULL, NULL, NULL, NULL, 4),
(125221, NULL, 'G3DSA:3.40.50.1820:FF:000397', NULL, NULL, 'YAL049C-like protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(125222, NULL, 'G3DSA:2.40.50.1060:FF:000006', NULL, NULL, 'TWIST neighbor', NULL, NULL, NULL, NULL, NULL, 4),
(125223, NULL, 'G3DSA:3.20.180.10:FF:000003', NULL, NULL, 'Heme oxygenase HugZ', NULL, NULL, NULL, NULL, NULL, 4),
(125224, NULL, 'G3DSA:3.40.50.880:FF:000200', NULL, NULL, 'CTP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(125225, NULL, 'G3DSA:1.10.20.10:FF:000265', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125226, NULL, 'G3DSA:3.30.160.60:FF:000453', NULL, NULL, 'GLIS family zinc finger 3', NULL, NULL, NULL, NULL, NULL, 4),
(125227, NULL, 'G3DSA:3.40.50.1000:FF:000331', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(125228, NULL, 'G3DSA:2.10.110.10:FF:000269', NULL, NULL, 'LIM and senescent cell antigen-like-containing domain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(125229, NULL, 'G3DSA:3.30.160.60:FF:002482', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125230, NULL, 'G3DSA:1.20.1110.10:FF:000028', NULL, NULL, 'ATPase, P-type, K/Mg/Cd/Cu/Zn/Na/Ca/Na/H-transporter', NULL, NULL, NULL, NULL, NULL, 4),
(125231, NULL, 'G3DSA:3.30.530.20:FF:000060', NULL, NULL, 'Polyketide cyclase/dehydrase/lipid transport superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(125232, NULL, 'G3DSA:1.10.540.10:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125233, NULL, 'G3DSA:1.25.10.10:FF:002209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125234, NULL, 'G3DSA:2.60.40.10:FF:000621', NULL, NULL, 'Immunoglobulin superfamily member 10', NULL, NULL, NULL, NULL, NULL, 4),
(125235, NULL, 'G3DSA:1.10.510.10:FF:001484', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(125236, NULL, 'G3DSA:3.30.420.10:FF:000115', NULL, NULL, 'Ribonuclease H', NULL, NULL, NULL, NULL, NULL, 4),
(125237, NULL, 'G3DSA:3.40.50.620:FF:000605', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(125238, NULL, 'G3DSA:2.60.40.150:FF:000501', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(125239, NULL, 'G3DSA:1.20.58.900:FF:000021', NULL, NULL, 'GM19009', NULL, NULL, NULL, NULL, NULL, 4),
(125240, NULL, 'G3DSA:1.10.287.70:FF:000767', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125241, NULL, 'G3DSA:3.40.50.2000:FF:000187', NULL, NULL, 'Glycogen synthase', NULL, NULL, NULL, NULL, NULL, 4),
(125242, NULL, 'G3DSA:1.10.287.700:FF:000007', NULL, NULL, 'Tail tape measure protein gp18', NULL, NULL, NULL, NULL, NULL, 4),
(125243, NULL, 'G3DSA:3.30.420.40:FF:001018', NULL, NULL, 'Protein CBG19479', NULL, NULL, NULL, NULL, NULL, 4),
(125244, NULL, 'G3DSA:1.10.1370.10:FF:000009', NULL, NULL, 'Putative mitochondrial intermediate peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(125245, NULL, 'G3DSA:1.10.579.10:FF:000001', NULL, NULL, 'Cryptochrome 1', NULL, NULL, NULL, NULL, NULL, 4),
(125246, NULL, 'G3DSA:3.20.20.70:FF:000519', NULL, NULL, 'Imidazole glycerol phosphate synthase subunit HisF', NULL, NULL, NULL, NULL, NULL, 4),
(125247, NULL, 'G3DSA:2.60.450.10:FF:000002', NULL, NULL, 'Lipopolysaccharide export system protein LptA', NULL, NULL, NULL, NULL, NULL, 4),
(125248, NULL, 'G3DSA:3.50.50.100:FF:000054', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(125249, NULL, 'G3DSA:1.25.10.10:FF:002485', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(125250, NULL, 'G3DSA:2.30.30.100:FF:000098', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm7', NULL, NULL, NULL, NULL, NULL, 4),
(125251, NULL, 'G3DSA:3.40.50.300:FF:005450', NULL, NULL, 'ATP-binding cassette sub-family A member 3-like isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(125252, NULL, 'G3DSA:1.20.58.60:FF:000304', NULL, NULL, 'Microtubule-actin cross-linking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(125253, NULL, 'G3DSA:2.60.120.430:FF:000004', NULL, NULL, 'Putative leucine-rich repeat receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(125254, NULL, 'G3DSA:1.20.1070.10:FF:000709', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(125255, NULL, 'G3DSA:1.20.1070.10:FF:000861', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125256, NULL, 'G3DSA:1.25.40.20:FF:000106', NULL, NULL, 'Ankyrin repeat domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(125257, NULL, 'G3DSA:1.25.40.10:FF:002037', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(125258, NULL, 'G3DSA:2.30.130.10:FF:000013', NULL, NULL, 'H/ACA ribonucleoprotein complex subunit DKC1', NULL, NULL, NULL, NULL, NULL, 4),
(125259, NULL, 'G3DSA:3.30.200.20:FF:001029', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(125260, NULL, 'G3DSA:3.40.50.10810:FF:000114', NULL, NULL, 'DNA repair protein rad8', NULL, NULL, NULL, NULL, NULL, 4),
(125261, NULL, 'G3DSA:1.20.120.350:FF:000254', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125262, NULL, 'G3DSA:1.25.40.10:FF:004954', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(125263, NULL, 'G3DSA:3.40.190.10:FF:000527', NULL, NULL, 'Norspermidine sensor', NULL, NULL, NULL, NULL, NULL, 4),
(125264, NULL, 'G3DSA:3.30.70.330:FF:000709', NULL, NULL, 'RNA binding motif protein 28', NULL, NULL, NULL, NULL, NULL, 4),
(125265, NULL, 'G3DSA:2.10.70.10:FF:000266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125266, NULL, 'G3DSA:3.30.160.60:FF:003443', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125267, NULL, 'G3DSA:2.60.40.60:FF:001007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125268, NULL, 'G3DSA:3.80.10.10:FF:001572', NULL, NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', NULL, NULL, NULL, NULL, NULL, 4),
(125269, NULL, 'G3DSA:3.40.50.720:FF:002355', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125270, NULL, 'G3DSA:3.40.50.1820:FF:001414', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125271, NULL, 'G3DSA:3.30.160.60:FF:003763', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125272, NULL, 'G3DSA:3.40.50.2000:FF:000451', NULL, NULL, 'Group 1 glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(125273, NULL, 'G3DSA:2.40.50.100:FF:000077', NULL, NULL, 'Glycoside hydrolase family 43', NULL, NULL, NULL, NULL, NULL, 4),
(125274, NULL, 'G3DSA:3.60.10.10:FF:000403', NULL, NULL, 'Os05g0535600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(125275, NULL, 'G3DSA:3.40.50.10490:FF:000124', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(125276, NULL, 'G3DSA:1.20.1560.10:FF:000056', NULL, NULL, 'Alpha-hemolysin translocation ATP-binding protein HlyB', NULL, NULL, NULL, NULL, NULL, 4),
(125277, NULL, 'G3DSA:3.30.1330.80:FF:000005', NULL, NULL, 'AT-hook motif nuclear-localized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125278, NULL, 'G3DSA:2.40.10.10:FF:000070', NULL, NULL, 'Urokinase-type plasminogen activator', NULL, NULL, NULL, NULL, NULL, 4),
(125279, NULL, 'G3DSA:1.20.5.190:FF:000151', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125280, NULL, 'G3DSA:2.60.40.10:FF:004331', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125281, NULL, 'G3DSA:1.10.1030.10:FF:000018', NULL, NULL, 'Carbamoyl phosphate synthase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(125282, NULL, 'G3DSA:3.40.50.300:FF:001684', NULL, NULL, 'Intraflagellar transport 27 homolog (Chlamydomonas)', NULL, NULL, NULL, NULL, NULL, 4),
(125283, NULL, 'G3DSA:3.40.50.11350:FF:000034', NULL, NULL, 'Galactoside 2-alpha-L-fucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(125284, NULL, 'G3DSA:2.30.39.10:FF:000063', NULL, NULL, 'Leukocyte elastase inhibitor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(125285, NULL, 'G3DSA:3.40.50.11380:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125286, NULL, 'G3DSA:3.40.50.620:FF:000869', NULL, NULL, 'Putative tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(125287, NULL, 'G3DSA:1.25.40.10:FF:003330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(125288, NULL, 'G3DSA:2.60.40.1670:FF:000016', NULL, NULL, 'SEC24 family, member B', NULL, NULL, NULL, NULL, NULL, 4),
(125289, NULL, 'G3DSA:3.30.2160.10:FF:000078', NULL, NULL, 'Probable ubiquitin fusion degradation protein C12B10.01c', NULL, NULL, NULL, NULL, NULL, 4),
(125290, NULL, 'G3DSA:3.30.40.10:FF:000553', NULL, NULL, 'Zinc finger, C3HC4 type family protein', NULL, NULL, NULL, NULL, NULL, 4),
(125291, NULL, 'G3DSA:2.10.220.10:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125292, NULL, 'G3DSA:3.10.129.10:FF:000100', NULL, NULL, 'Related to acyl-coa thioester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(125293, NULL, 'G3DSA:2.60.120.1540:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125294, NULL, 'G3DSA:3.40.50.150:FF:000301', NULL, NULL, 'Calmodulin-lysine N-methyltransferase isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(125295, NULL, 'G3DSA:3.90.810.10:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125296, NULL, 'G3DSA:3.90.15.10:FF:000003', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(125297, NULL, 'G3DSA:2.170.270.10:FF:000102', NULL, NULL, 'AGAP013275-PA', NULL, NULL, NULL, NULL, NULL, 4),
(125298, NULL, 'G3DSA:1.10.10.750:FF:000021', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(125299, NULL, 'G3DSA:3.40.390.10:FF:000059', NULL, NULL, 'Oligopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(125300, NULL, 'G3DSA:1.10.510.10:FF:004507', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125301, NULL, 'G3DSA:2.130.10.10:FF:005736', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125302, NULL, 'G3DSA:3.40.1190.20:FF:000232', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125303, NULL, 'G3DSA:1.25.40.60:FF:000006', NULL, NULL, 'Sec1 family superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(125304, NULL, 'G3DSA:1.25.10.10:FF:001580', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(125305, NULL, 'G3DSA:1.20.930.40:FF:000038', NULL, NULL, 'Glutamate carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(125306, NULL, 'G3DSA:3.50.50.60:FF:000983', NULL, NULL, 'FAD/NAD(P)-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(125307, NULL, 'G3DSA:1.10.3520.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125308, NULL, 'G3DSA:2.60.40.10:FF:004511', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125309, NULL, 'G3DSA:1.10.510.10:FF:000056', NULL, NULL, 'calcium-dependent protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(125310, NULL, 'G3DSA:2.70.130.10:FF:000133', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125311, NULL, 'G3DSA:3.40.50.720:FF:001074', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(125312, NULL, 'G3DSA:1.20.120.1600:FF:000001', NULL, NULL, 'HAD hydrolase, family IA', NULL, NULL, NULL, NULL, NULL, 4),
(125313, NULL, 'G3DSA:1.20.1280.50:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125314, NULL, 'G3DSA:1.25.40.20:FF:000449', NULL, NULL, 'Ankyrin repeat domain-containing protein 50', NULL, NULL, NULL, NULL, NULL, 4),
(125315, NULL, 'G3DSA:3.90.180.10:FF:000055', NULL, NULL, 'GroES-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(125316, NULL, 'G3DSA:3.90.640.10:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125317, NULL, 'G3DSA:2.40.70.10:FF:000287', NULL, NULL, 'Pepsin A', NULL, NULL, NULL, NULL, NULL, 4),
(125318, NULL, 'G3DSA:1.20.1070.10:FF:002098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125319, NULL, 'G3DSA:1.10.8.430:FF:000006', NULL, NULL, 'Disease resistance protein Piks-2', NULL, NULL, NULL, NULL, NULL, 4),
(125320, NULL, 'G3DSA:1.20.1110.10:FF:000180', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125321, NULL, 'G3DSA:2.60.40.2130:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125322, NULL, 'G3DSA:3.20.140.10:FF:000006', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(125323, NULL, 'G3DSA:3.40.50.300:FF:002140', NULL, NULL, 'Small GTP-binding protein Rab11', NULL, NULL, NULL, NULL, NULL, 4),
(125324, NULL, 'G3DSA:1.10.287.1890:FF:000005', NULL, NULL, 'tRNA-m1A22 methylase', NULL, NULL, NULL, NULL, NULL, 4),
(125325, NULL, 'G3DSA:1.20.58.1120:FF:000006', NULL, NULL, 'cytoplasmic dynein 2 heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(125326, NULL, 'G3DSA:2.10.25.10:FF:000015', NULL, NULL, 'neurexin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(125327, NULL, 'G3DSA:1.20.140.100:FF:000032', NULL, NULL, 'Inner dynein arm 1 heavy chain 1-ALPHa', NULL, NULL, NULL, NULL, NULL, 4),
(125328, NULL, 'G3DSA:2.70.160.11:FF:000035', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(125329, NULL, 'G3DSA:4.10.280.10:FF:000234', NULL, NULL, 'Helix Loop Helix', NULL, NULL, NULL, NULL, NULL, 4),
(125330, NULL, 'G3DSA:2.10.60.10:FF:000052', NULL, NULL, 'Irditoxin subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(125331, NULL, 'G3DSA:3.30.1120.30:FF:000025', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(125332, NULL, 'G3DSA:3.40.1170.60:FF:000006', NULL, NULL, 'DNA polymerase iota', NULL, NULL, NULL, NULL, NULL, 4),
(125333, NULL, 'G3DSA:3.20.20.10:FF:000052', NULL, NULL, 'Pyridoxal phosphate homeostasis protein', NULL, NULL, NULL, NULL, NULL, 4),
(125334, NULL, 'G3DSA:3.90.550.10:FF:000432', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125335, NULL, 'G3DSA:3.30.40.10:FF:000474', NULL, NULL, 'CLUMA_CG009069, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(125336, NULL, 'G3DSA:1.10.630.10:FF:000340', NULL, NULL, 'Cytochrome P450 1A1', NULL, NULL, NULL, NULL, NULL, 4),
(125337, NULL, 'G3DSA:2.40.50.140:FF:000459', NULL, NULL, 'ATP-dependent DNA helicase RecG', NULL, NULL, NULL, NULL, NULL, 4),
(125338, NULL, 'G3DSA:3.40.630.30:FF:000438', NULL, NULL, 'Acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(125339, NULL, 'G3DSA:1.50.40.10:FF:000500', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125340, NULL, 'G3DSA:3.30.70.3490:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125341, NULL, 'G3DSA:1.25.40.120:FF:000031', NULL, NULL, 'RAB geranylgeranyl transferase alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(125342, NULL, 'G3DSA:1.20.1560.10:FF:000617', NULL, NULL, 'Protein CBR-PGP-8', NULL, NULL, NULL, NULL, NULL, 4),
(125343, NULL, 'G3DSA:3.40.30.10:FF:000243', NULL, NULL, 'Prostamide/prostaglandin F synthase', NULL, NULL, NULL, NULL, NULL, 4),
(125344, NULL, 'G3DSA:4.10.400.10:FF:000059', NULL, NULL, 'Prolow-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(125345, NULL, 'G3DSA:3.30.230.10:FF:000168', NULL, NULL, 'Putative kinase', NULL, NULL, NULL, NULL, NULL, 4),
(125346, NULL, 'G3DSA:3.30.230.120:FF:000009', NULL, NULL, 'D-glycero-alpha-D-manno-heptose 7-phosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(125347, NULL, 'G3DSA:2.60.40.420:FF:000037', NULL, NULL, 'Ceruloplasmin', NULL, NULL, NULL, NULL, NULL, 4),
(125348, NULL, 'G3DSA:3.40.50.1000:FF:000196', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(125349, NULL, 'G3DSA:1.20.1560.10:FF:000320', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(125350, NULL, 'G3DSA:1.10.287.70:FF:000262', NULL, NULL, 'Cyclic nucleotide-gated ion channel 2', NULL, NULL, NULL, NULL, NULL, 4),
(125351, NULL, 'G3DSA:3.10.20.90:FF:000407', NULL, NULL, 'Small ubiquitin-related modifier 2 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(125352, NULL, 'G3DSA:4.10.240.10:FF:000057', NULL, NULL, 'Transcription factor PDR3', NULL, NULL, NULL, NULL, NULL, 4),
(125353, NULL, 'G3DSA:2.102.10.10:FF:000039', NULL, NULL, 'Rieske (2Fe-2S) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(125354, NULL, 'G3DSA:2.60.120.200:FF:000284', NULL, NULL, 'Cadherin-related hmr-1', NULL, NULL, NULL, NULL, NULL, 4),
(125355, NULL, 'G3DSA:2.60.120.10:FF:000421', NULL, NULL, 'bifunctional peptidase and (3S)-lysyl hydroxylase JMJD7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(125356, NULL, 'G3DSA:1.20.58.60:FF:000568', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125357, NULL, 'G3DSA:3.40.50.12760:FF:000007', NULL, NULL, 'CMTR1 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(125358, NULL, 'G3DSA:2.60.120.260:FF:000627', NULL, NULL, 'Reelin', NULL, NULL, NULL, NULL, NULL, 4),
(125359, NULL, 'G3DSA:1.20.5.1940:FF:000005', NULL, NULL, 'Hse1p', NULL, NULL, NULL, NULL, NULL, 4),
(125360, NULL, 'G3DSA:2.40.20.10:FF:000008', NULL, NULL, 'Hepatocyte growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(125361, NULL, 'G3DSA:2.60.40.10:FF:000357', NULL, NULL, 'Fc receptor like 1', NULL, NULL, NULL, NULL, NULL, 4),
(125362, NULL, 'G3DSA:3.30.505.10:FF:000200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125363, NULL, 'G3DSA:3.90.70.10:FF:000136', NULL, NULL, 'Ubiquitin C-terminal hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(125364, NULL, 'G3DSA:1.20.5.110:FF:000211', NULL, NULL, 'Si:ch211-208k15.1', NULL, NULL, NULL, NULL, NULL, 4),
(125365, NULL, 'G3DSA:2.30.29.30:FF:000416', NULL, NULL, 'Cell 12A endoglucanase', NULL, NULL, NULL, NULL, NULL, 4),
(125366, NULL, 'G3DSA:3.40.50.1820:FF:000958', NULL, NULL, 'Alpha/beta hydrolase fold-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(125367, NULL, 'G3DSA:3.40.50.300:FF:007636', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125368, NULL, 'G3DSA:3.30.430.20:FF:000057', NULL, NULL, 'Plasmodesmata-located protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(125369, NULL, 'G3DSA:3.30.1490.120:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125370, NULL, 'G3DSA:1.10.30.10:FF:000007', NULL, NULL, 'Transcription factor SOX', NULL, NULL, NULL, NULL, NULL, 4),
(125371, NULL, 'G3DSA:3.10.20.700:FF:000001', NULL, NULL, 'Group 4 capsule (G4C) polysaccharide, YmcB', NULL, NULL, NULL, NULL, NULL, 4),
(125372, NULL, 'G3DSA:3.80.10.10:FF:002269', NULL, NULL, 'F-box protein At-B', NULL, NULL, NULL, NULL, NULL, 4),
(125373, NULL, 'G3DSA:2.130.10.10:FF:002302', NULL, NULL, 'Coatomer protein complex, subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(125374, NULL, 'G3DSA:3.30.40.10:FF:000210', NULL, NULL, 'E3 ubiquitin-protein ligase TRAF7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(125375, NULL, 'G3DSA:3.40.1390.20:FF:000005', NULL, NULL, 'HPr kinase/phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(125376, NULL, 'G3DSA:3.40.640.10:FF:000517', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125377, NULL, 'G3DSA:3.30.1330.40:FF:000049', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(125378, NULL, 'G3DSA:2.40.50.140:FF:001258', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125379, NULL, 'G3DSA:3.30.70.330:FF:000148', NULL, NULL, 'Putative CUGBP Elav-like family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(125380, NULL, 'G3DSA:3.50.50.60:FF:000011', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(125381, NULL, 'G3DSA:2.60.40.10:FF:005028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125382, NULL, 'G3DSA:3.80.10.10:FF:003106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125383, NULL, 'G3DSA:3.40.50.300:FF:004202', NULL, NULL, 'tRNA isopentenyltransferase, putative (AFU_orthologue AFUA_6G05070)', NULL, NULL, NULL, NULL, NULL, 4),
(125384, NULL, 'G3DSA:2.130.10.10:FF:003527', NULL, NULL, 'Probable U3 small nucleolar RNA-associated protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(125385, NULL, 'G3DSA:1.10.8.60:FF:000514', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125386, NULL, 'G3DSA:2.60.120.970:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125387, NULL, 'G3DSA:3.40.1500.20:FF:000004', NULL, NULL, 'Os10g0389100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(125388, NULL, 'G3DSA:1.25.10.10:FF:000332', NULL, NULL, 'Ran-binding protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(125389, NULL, 'G3DSA:3.90.190.10:FF:000292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(125390, NULL, 'G3DSA:1.20.1740.10:FF:000042', NULL, NULL, 'Similar to amino acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(125391, NULL, 'G3DSA:2.60.40.10:FF:001717', NULL, NULL, 'Interleukin 12 receptor subunit beta 1', NULL, NULL, NULL, NULL, NULL, 4),
(125392, NULL, 'G3DSA:2.40.110.10:FF:000021', NULL, NULL, 'Flavin-dependent monooxygenase, oxygenase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(125393, NULL, 'G3DSA:3.40.50.300:FF:001408', NULL, NULL, 'GTP-binding protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(125394, NULL, 'G3DSA:3.40.50.12780:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125395, NULL, 'G3DSA:1.10.1200.10:FF:000054', NULL, NULL, 'Fatty-acid-CoA ligase FadD9', NULL, NULL, NULL, NULL, NULL, 4),
(125396, NULL, 'G3DSA:3.30.70.360:FF:000011', NULL, NULL, 'Succinyl-diaminopimelate desuccinylase', NULL, NULL, NULL, NULL, NULL, 4),
(125397, NULL, 'G3DSA:3.30.470.20:FF:000234', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(125398, NULL, 'G3DSA:3.40.1550.20:FF:000007', NULL, NULL, 'Transcriptional regulator MraZ', NULL, NULL, NULL, NULL, NULL, 4),
(125399, NULL, 'G3DSA:1.20.5.170:FF:000257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125400, NULL, 'G3DSA:3.40.50.620:FF:000526', NULL, NULL, 'Putative pantetheine-phosphate adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(125401, NULL, 'G3DSA:2.170.300.10:FF:000100', NULL, NULL, 'Scavenger receptor class F, member 1', NULL, NULL, NULL, NULL, NULL, 4),
(125402, NULL, 'G3DSA:3.40.1810.10:FF:000036', NULL, NULL, 'Agamous-like MADS-box protein AGL3 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(125403, NULL, 'G3DSA:3.40.50.720:FF:002086', NULL, NULL, 'Nicotinamide nucleotide transhydrogenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(125404, NULL, 'G3DSA:3.40.850.10:FF:000550', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(125405, NULL, 'G3DSA:3.30.70.330:FF:003110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125406, NULL, 'G3DSA:3.80.10.10:FF:003781', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125407, NULL, 'G3DSA:3.60.21.10:FF:000423', NULL, NULL, '3'',5''-cyclic adenosine monophosphate phosphodiesterase CpdA', NULL, NULL, NULL, NULL, NULL, 4),
(125408, NULL, 'G3DSA:1.25.40.10:FF:002981', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g13770, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(125409, NULL, 'G3DSA:3.30.160.60:FF:001077', NULL, NULL, 'Zinc finger protein 1026', NULL, NULL, NULL, NULL, NULL, 4),
(125410, NULL, 'G3DSA:2.40.160.180:FF:000003', NULL, NULL, 'Porin', NULL, NULL, NULL, NULL, NULL, 4),
(125411, NULL, 'G3DSA:3.40.850.10:FF:000494', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125412, NULL, 'G3DSA:3.30.70.330:FF:001508', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125413, NULL, 'G3DSA:3.40.50.300:FF:007367', NULL, NULL, 'MCM3', NULL, NULL, NULL, NULL, NULL, 4),
(125414, NULL, 'G3DSA:3.20.20.60:FF:000050', NULL, NULL, 'Citrate lyase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(125415, NULL, 'G3DSA:3.40.309.10:FF:000107', NULL, NULL, 'Methylmalonate semialdehyde dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(125416, NULL, 'G3DSA:3.80.10.10:FF:002246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125417, NULL, 'G3DSA:1.10.472.170:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125418, NULL, 'G3DSA:4.10.400.10:FF:000290', NULL, NULL, 'Megalin, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(125419, NULL, 'G3DSA:1.50.10.20:FF:000092', NULL, NULL, 'Terpene synthase family protein (AFU_orthologue AFUA_5G15060)', NULL, NULL, NULL, NULL, NULL, 4),
(125420, NULL, 'G3DSA:1.10.1740.10:FF:000044', NULL, NULL, 'Probable sigma-70 factor, ECF subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(125421, NULL, 'G3DSA:3.40.50.620:FF:000369', NULL, NULL, 'Nicotinate-nicotinamide nucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(125422, NULL, 'G3DSA:3.40.20.10:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125423, NULL, 'G3DSA:2.40.70.10:FF:000023', NULL, NULL, 'Aspartic protease', NULL, NULL, NULL, NULL, NULL, 4),
(125424, NULL, 'G3DSA:3.20.20.240:FF:000006', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(125425, NULL, 'G3DSA:3.40.50.300:FF:006911', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125426, NULL, 'G3DSA:1.10.510.10:FF:003147', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125427, NULL, 'G3DSA:3.10.129.110:FF:000003', NULL, NULL, 'Probable polyketide synthase pks1', NULL, NULL, NULL, NULL, NULL, 4),
(125428, NULL, 'G3DSA:3.30.230.70:FF:000107', NULL, NULL, 'Nucleolar autoantigen-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(125429, NULL, 'G3DSA:1.10.560.10:FF:000008', NULL, NULL, 'T-complex protein 1 subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(125430, NULL, 'G3DSA:3.30.2230.10:FF:000027', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(125431, NULL, 'G3DSA:3.50.50.60:FF:000303', NULL, NULL, 'L-amino-acid oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(125432, NULL, 'G3DSA:1.25.40.660:FF:000007', NULL, NULL, 'Vacuolar protein sorting-associated protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(125433, NULL, 'G3DSA:3.10.129.10:FF:000257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125434, NULL, 'G3DSA:2.130.10.10:FF:002241', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(125435, NULL, 'G3DSA:3.30.540.10:FF:000057', NULL, NULL, 'Inositol monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(125436, NULL, 'G3DSA:2.40.50.140:FF:000690', NULL, NULL, 'Putative methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(125437, NULL, 'G3DSA:3.40.50.300:FF:007423', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125438, NULL, 'G3DSA:1.20.810.10:FF:000015', NULL, NULL, 'Cytochrome b', NULL, NULL, NULL, NULL, NULL, 4),
(125439, NULL, 'G3DSA:1.20.58.1120:FF:000029', NULL, NULL, 'Dynein heavy chain 5, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(125440, NULL, 'G3DSA:1.20.1110.10:FF:000005', NULL, NULL, 'Plasma membrane ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(125441, NULL, 'G3DSA:1.20.1270.60:FF:000043', NULL, NULL, 'Brain-specific angiogenesis inhibitor 1-associated protein 2-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(125442, NULL, 'G3DSA:3.30.9.10:FF:000205', NULL, NULL, 'Zgc:172341', NULL, NULL, NULL, NULL, NULL, 4),
(125443, NULL, 'G3DSA:2.60.40.10:FF:003786', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125444, NULL, 'G3DSA:3.10.110.10:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125445, NULL, 'G3DSA:3.30.160.60:FF:000565', NULL, NULL, 'Zinc finger protein 575', NULL, NULL, NULL, NULL, NULL, 4),
(125446, NULL, 'G3DSA:3.40.50.720:FF:002142', NULL, NULL, 'Biliverdin reductase A', NULL, NULL, NULL, NULL, NULL, 4),
(125447, NULL, 'G3DSA:3.40.50.410:FF:000020', NULL, NULL, 'protein transport protein Sec24D isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(125448, NULL, 'G3DSA:3.40.50.300:FF:000335', NULL, NULL, 'ATP binding cassette subfamily A member 5', NULL, NULL, NULL, NULL, NULL, 4),
(125449, NULL, 'G3DSA:3.40.50.720:FF:001630', NULL, NULL, 'Short-chain dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(125450, NULL, 'G3DSA:2.130.10.10:FF:002134', NULL, NULL, 'WD domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(125451, NULL, 'G3DSA:3.20.20.80:FF:000056', NULL, NULL, 'Pancreatic alpha-amylase', NULL, NULL, NULL, NULL, NULL, 4),
(125452, NULL, 'G3DSA:3.40.50.150:FF:001673', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125453, NULL, 'G3DSA:2.10.25.10:FF:001420', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125454, NULL, 'G3DSA:3.40.50.300:FF:006170', NULL, NULL, 'Putative ABC transporter ATP-binding protein MG187', NULL, NULL, NULL, NULL, NULL, 4),
(125455, NULL, 'G3DSA:3.30.70.3000:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(125456, NULL, 'G3DSA:2.60.40.10:FF:000121', NULL, NULL, 'Collagen type XII alpha 1 chain', NULL, NULL, NULL, NULL, NULL, 4),
(125457, NULL, 'G3DSA:1.20.5.4570:FF:000002', NULL, NULL, 'Ferulic acid decarboxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(125458, NULL, 'G3DSA:1.10.10.60:FF:001274', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125459, NULL, 'G3DSA:3.40.50.880:FF:000020', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(125460, NULL, 'G3DSA:2.60.40.10:FF:003842', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125461, NULL, 'G3DSA:2.40.70.10:FF:000130', NULL, NULL, 'Retrovirus-related Pol polyprotein from transposon opus-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(125462, NULL, 'G3DSA:3.30.230.10:FF:000303', NULL, NULL, 'MutL homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(125463, NULL, 'G3DSA:3.30.200.20:FF:000804', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(125464, NULL, 'G3DSA:1.10.287.70:FF:000267', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(125465, NULL, 'G3DSA:1.10.3500.10:FF:000010', NULL, NULL, 'Transcription elongation factor SPT6', NULL, NULL, NULL, NULL, NULL, 4),
(125466, NULL, 'G3DSA:1.20.1070.10:FF:001873', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125467, NULL, 'G3DSA:2.40.290.10:FF:000005', NULL, NULL, 'X-ray repair cross-complementing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(125468, NULL, 'G3DSA:1.20.5.170:FF:000206', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit beta-2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(125469, NULL, 'G3DSA:1.10.150.650:FF:000009', NULL, NULL, 'Metal-dependent phosphoesterase, PHP family', NULL, NULL, NULL, NULL, NULL, 4),
(125470, NULL, 'G3DSA:3.90.1010.10:FF:000008', NULL, NULL, 'Iron-sulfur cluster assembly enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(125471, NULL, 'G3DSA:3.30.260.10:FF:000075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125472, NULL, 'G3DSA:3.40.30.10:FF:000743', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(125473, NULL, 'G3DSA:3.40.50.10050:FF:000015', NULL, NULL, 'Translation initiation factor IF-2', NULL, NULL, NULL, NULL, NULL, 4),
(125474, NULL, 'G3DSA:1.20.58.60:FF:000068', NULL, NULL, 'Short stop, isoform K', NULL, NULL, NULL, NULL, NULL, 4),
(125475, NULL, 'G3DSA:3.60.20.10:FF:000011', NULL, NULL, 'Amidophosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(125476, NULL, 'G3DSA:3.30.160.60:FF:000514', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125477, NULL, 'G3DSA:3.30.160.60:FF:000621', NULL, NULL, 'FLT3-interacting zinc finger 1', NULL, NULL, NULL, NULL, NULL, 4),
(125478, NULL, 'G3DSA:1.25.40.10:FF:001413', NULL, NULL, 'Tetratricopeptide repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(125479, NULL, 'G3DSA:1.20.120.140:FF:000040', NULL, NULL, 'Signal recognition particle receptor FtsY', NULL, NULL, NULL, NULL, NULL, 4),
(125480, NULL, 'G3DSA:4.10.470.10:FF:000001', NULL, NULL, 'Ricin', NULL, NULL, NULL, NULL, NULL, 4),
(125481, NULL, 'G3DSA:3.40.50.12780:FF:000188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125482, NULL, 'G3DSA:2.60.120.970:FF:000104', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(125483, NULL, 'G3DSA:1.10.287.70:FF:000323', NULL, NULL, 'Large conductance calcium-activated potassium (BK) channel alpha subunit a', NULL, NULL, NULL, NULL, NULL, 4),
(125484, NULL, 'G3DSA:2.60.40.10:FF:002482', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125485, NULL, 'G3DSA:3.50.50.60:FF:000247', NULL, NULL, 'Flavin-binding monooxygenase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(125486, NULL, 'G3DSA:1.20.58.110:FF:000003', NULL, NULL, '30S ribosomal protein S20, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(125487, NULL, 'G3DSA:1.10.472.10:FF:000399', NULL, NULL, 'YALI0C10516p', NULL, NULL, NULL, NULL, NULL, 4),
(125488, NULL, 'G3DSA:1.25.40.10:FF:001520', NULL, NULL, 'histone-lysine N-methyltransferase SMYD3', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(125489, NULL, 'G3DSA:3.90.550.10:FF:000600', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125490, NULL, 'G3DSA:2.160.20.10:FF:000290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125491, NULL, 'G3DSA:1.20.272.10:FF:000022', NULL, NULL, 'Replication factor C subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(125492, NULL, 'G3DSA:2.160.20.10:FF:000183', NULL, NULL, 'Cell surface glycoprotein (S-layer protein)', NULL, NULL, NULL, NULL, NULL, 4),
(125493, NULL, 'G3DSA:3.30.40.10:FF:001273', NULL, NULL, 'SNF2 family N-terminal domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(125494, NULL, 'G3DSA:3.30.70.330:FF:003054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125495, NULL, 'G3DSA:3.40.50.720:FF:001574', NULL, NULL, 'Oxidoreductase, short chain dehydrogenase/reductase family', NULL, NULL, NULL, NULL, NULL, 4),
(125496, NULL, 'G3DSA:3.30.460.10:FF:000112', NULL, NULL, 'Speckle targeted PIP5K1A-regulated poly(A) polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(125497, NULL, 'G3DSA:2.60.40.2860:FF:000002', NULL, NULL, 'Transmission-blocking target antigen s230', NULL, NULL, NULL, NULL, NULL, 4),
(125498, NULL, 'G3DSA:3.30.160.60:FF:001818', NULL, NULL, 'GDNF-inducible zinc finger protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(125499, NULL, 'G3DSA:3.40.50.2300:FF:000771', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125500, NULL, 'G3DSA:3.90.55.10:FF:000005', NULL, NULL, 'Biotin sulfoxide reductas2', NULL, NULL, NULL, NULL, NULL, 4),
(125501, NULL, 'G3DSA:1.10.150.80:FF:000021', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(125502, NULL, 'G3DSA:1.20.120.1750:FF:000063', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(125503, NULL, 'G3DSA:3.30.565.10:FF:000204', NULL, NULL, 'Heat shock protein HSP 90-beta', NULL, NULL, NULL, NULL, NULL, 4),
(125504, NULL, 'G3DSA:1.20.58.340:FF:000050', NULL, NULL, 'Cation transporter', NULL, NULL, NULL, NULL, NULL, 4),
(125505, NULL, 'G3DSA:3.40.50.11240:FF:000001', NULL, NULL, 'Ethanolamine ammonia-lyase light chain', NULL, NULL, NULL, NULL, NULL, 4),
(125506, NULL, 'G3DSA:1.20.5.4130:FF:000005', NULL, NULL, 'NBS-LRR class disease resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(125507, NULL, 'G3DSA:1.20.1310.10:FF:000009', NULL, NULL, 'Cullin 5', NULL, NULL, NULL, NULL, NULL, 4),
(125508, NULL, 'G3DSA:3.30.160.60:FF:002982', NULL, NULL, 'Zinc finger protein 1009', NULL, NULL, NULL, NULL, NULL, 4),
(125509, NULL, 'G3DSA:3.30.310.130:FF:000008', NULL, NULL, 'Ubiquitin-like-specific protease 1', NULL, NULL, NULL, NULL, NULL, 4),
(125510, NULL, 'G3DSA:3.90.228.20:FF:000006', NULL, NULL, 'Phosphoenolpyruvate carboxykinase [GTP], mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(125511, NULL, 'G3DSA:3.90.1750.10:FF:000019', NULL, NULL, 'E3 ubiquitin-protein ligase HACE1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(125512, NULL, 'G3DSA:3.30.450.350:FF:000004', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(125513, NULL, 'G3DSA:3.30.70.1730:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125514, NULL, 'G3DSA:3.30.1380.10:FF:000004', NULL, NULL, 'Endolysin', NULL, NULL, NULL, NULL, NULL, 4),
(125515, NULL, 'G3DSA:3.10.20.230:FF:000017', NULL, NULL, 'Serine/threonine-protein kinase GA29083', NULL, NULL, NULL, NULL, NULL, 4),
(125516, NULL, 'G3DSA:2.60.120.260:FF:000548', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125517, NULL, 'G3DSA:2.30.29.90:FF:000002', NULL, NULL, 'syntaxin-binding protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(125518, NULL, 'G3DSA:3.30.420.10:FF:000054', NULL, NULL, 'Werner Syndrome-like exonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(125519, NULL, 'G3DSA:2.20.70.10:FF:000237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125520, NULL, 'G3DSA:2.60.120.290:FF:000147', NULL, NULL, 'AGAP005526-PA', NULL, NULL, NULL, NULL, NULL, 4),
(125521, NULL, 'G3DSA:3.90.550.10:FF:000544', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(125522, NULL, 'G3DSA:1.10.238.10:FF:000215', NULL, NULL, 'CDPK-related kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(125523, NULL, 'G3DSA:1.25.40.10:FF:002829', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(125524, NULL, 'G3DSA:3.40.390.10:FF:000239', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125525, NULL, 'G3DSA:1.10.510.10:FF:000348', NULL, NULL, 'serine/threonine-protein kinase VRK1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(125526, NULL, 'G3DSA:3.20.20.150:FF:000075', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(125527, NULL, 'G3DSA:3.40.50.11260:FF:000007', NULL, NULL, 'Heat shock protein 90', NULL, NULL, NULL, NULL, NULL, 4),
(125528, NULL, 'G3DSA:1.10.510.10:FF:001753', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(125529, NULL, 'G3DSA:3.90.1750.20:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125530, NULL, 'G3DSA:3.90.190.10:FF:000561', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125531, NULL, 'G3DSA:3.20.20.80:FF:000163', NULL, NULL, 'Putative beta-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(125532, NULL, 'G3DSA:1.10.1040.10:FF:000070', NULL, NULL, '3-hydroxyisobutyrate dehydrogenase, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4),
(125533, NULL, 'G3DSA:3.90.70.10:FF:000215', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 16', NULL, NULL, NULL, NULL, NULL, 4),
(125534, NULL, 'G3DSA:1.25.40.10:FF:000160', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(125535, NULL, 'G3DSA:2.60.40.60:FF:000670', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125536, NULL, 'G3DSA:1.10.510.10:FF:001697', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125537, NULL, 'G3DSA:2.60.120.590:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125538, NULL, 'G3DSA:1.25.10.20:FF:000009', NULL, NULL, 'Microsomal triacylglycerol transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(125539, NULL, 'G3DSA:1.25.40.10:FF:003318', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g22070', NULL, NULL, NULL, NULL, NULL, 4),
(125540, NULL, 'G3DSA:3.30.310.80:FF:000049', NULL, NULL, '5''-AMP-activated protein kinase catalytic subunit alpha-1', NULL, NULL, NULL, NULL, NULL, 4),
(125541, NULL, 'G3DSA:1.10.20.10:FF:000001', NULL, NULL, 'Histone H3', NULL, NULL, NULL, NULL, NULL, 4),
(125542, NULL, 'G3DSA:1.10.10.10:FF:001517', NULL, NULL, 'General transcription factor IIE subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(125543, NULL, 'G3DSA:1.10.240.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125544, NULL, 'G3DSA:3.40.190.80:FF:000059', NULL, NULL, 'Fructose-1,6-bisphosphatase class 1', NULL, NULL, NULL, NULL, NULL, 4),
(125545, NULL, 'G3DSA:1.10.640.10:FF:000009', NULL, NULL, 'Peroxidase, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(125546, NULL, 'G3DSA:3.40.50.1240:FF:000144', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125547, NULL, 'G3DSA:1.10.1400.10:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125548, NULL, 'G3DSA:2.60.120.380:FF:000085', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(125549, NULL, 'G3DSA:3.30.63.10:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125550, NULL, 'G3DSA:2.40.128.20:FF:000025', NULL, NULL, 'UPF0678 fatty acid-binding protein-like protein Rv0813c', NULL, NULL, NULL, NULL, NULL, 4),
(125551, NULL, 'G3DSA:3.30.470.20:FF:000155', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(125552, NULL, 'G3DSA:3.60.10.10:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125553, NULL, 'G3DSA:1.20.1560.10:FF:000213', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(125554, NULL, 'G3DSA:3.80.10.10:FF:000852', NULL, NULL, 'Blast:Chaoptin', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(125555, NULL, 'G3DSA:1.50.40.10:FF:000383', NULL, NULL, 'Mitochondrial carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(125556, NULL, 'G3DSA:3.30.50.10:FF:000031', NULL, NULL, 'Ecdysone receptor A1', NULL, NULL, NULL, NULL, NULL, 4),
(125557, NULL, 'G3DSA:3.30.300.30:FF:000118', NULL, NULL, 'Phenylacetate--coenzyme A ligase', NULL, NULL, NULL, NULL, NULL, 4),
(125558, NULL, 'G3DSA:2.170.270.10:FF:000046', NULL, NULL, 'SET-domain containing protein lysine methyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(125559, NULL, 'G3DSA:2.60.40.10:FF:003050', NULL, NULL, 'Tapasin long form', NULL, NULL, NULL, NULL, NULL, 4),
(125560, NULL, 'G3DSA:1.10.10.10:FF:001113', NULL, NULL, 'Putative plectin/S10 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(125561, NULL, 'G3DSA:1.10.472.80:FF:000055', NULL, NULL, 'TBC domain-containing protein C1778.09', NULL, NULL, NULL, NULL, NULL, 4),
(125562, NULL, 'G3DSA:3.30.160.60:FF:002931', NULL, NULL, 'zinc finger protein 585A-like', NULL, NULL, NULL, NULL, NULL, 4),
(125563, NULL, 'G3DSA:3.30.360.10:FF:000060', NULL, NULL, 'Unplaced genomic scaffold supercont2.12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(125564, NULL, 'G3DSA:3.30.70.1440:FF:000010', NULL, NULL, 'Transporter, AcrB/D/F family', NULL, NULL, NULL, NULL, NULL, 4),
(125565, NULL, 'G3DSA:2.60.120.200:FF:000340', NULL, NULL, 'Si:dkey-1m11.6', NULL, NULL, NULL, NULL, NULL, 4),
(125566, NULL, 'G3DSA:1.10.560.10:FF:000071', NULL, NULL, 'TCP-1/cpn60 chaperonin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(125567, NULL, 'G3DSA:2.90.10.10:FF:000040', NULL, NULL, 'Mannose-binding lectin', NULL, NULL, NULL, NULL, NULL, 4),
(125568, NULL, 'G3DSA:3.30.160.60:FF:006293', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125569, NULL, 'G3DSA:3.40.50.300:FF:000279', NULL, NULL, 'peripheral plasma membrane protein CASK isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(125570, NULL, 'G3DSA:4.10.400.10:FF:000227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125571, NULL, 'G3DSA:1.10.3660.10:FF:000010', NULL, NULL, 'Prephenate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(125572, NULL, 'G3DSA:1.20.1050.90:FF:000007', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(125573, NULL, 'G3DSA:1.20.1230.10:FF:000008', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(125574, NULL, 'G3DSA:1.10.630.10:FF:000239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125575, NULL, 'G3DSA:2.30.42.10:FF:000610', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125576, NULL, 'G3DSA:3.30.1460.10:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125577, NULL, 'G3DSA:1.10.1420.10:FF:000060', NULL, NULL, 'DNA mismatch repair protein spellchecker 1', NULL, NULL, NULL, NULL, NULL, 4),
(125578, NULL, 'G3DSA:2.70.40.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125579, NULL, 'G3DSA:3.30.1480.10:FF:000012', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(125580, NULL, 'G3DSA:3.40.190.120:FF:000007', NULL, NULL, 'Possible osmoprotectant (Glycine betaine/carnitine/choline/L-proline) binding lipoprotein ProX', NULL, NULL, NULL, NULL, NULL, 4),
(125581, NULL, 'G3DSA:3.40.30.10:FF:000799', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125582, NULL, 'G3DSA:2.130.10.10:FF:001785', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125583, NULL, 'G3DSA:2.60.40.10:FF:001425', NULL, NULL, 'Interferon gamma receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(125584, NULL, 'G3DSA:3.40.850.10:FF:000319', NULL, NULL, 'Kinesin-like protein KIF26B', NULL, NULL, NULL, NULL, NULL, 4),
(125585, NULL, 'G3DSA:1.10.1320.10:FF:000001', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(125586, NULL, 'G3DSA:3.15.10.10:FF:000013', NULL, NULL, 'Expression site-associated gene (ESAG) protein, putative', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(125587, NULL, 'G3DSA:1.20.59.10:FF:000005', NULL, NULL, 'Chorismate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(125588, NULL, 'G3DSA:2.60.40.1230:FF:000019', NULL, NULL, 'Golgi-localized, ADP-ribosylation factor binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(125589, NULL, 'G3DSA:2.40.50.140:FF:000538', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(125590, NULL, 'G3DSA:3.20.20.70:FF:000278', NULL, NULL, 'Lactate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(125591, NULL, 'G3DSA:3.40.50.2300:FF:001283', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125592, NULL, 'G3DSA:3.30.559.10:FF:000263', NULL, NULL, 'Dihydrolipoyllysine-residue succinyltransferase component of 2-oxoglutarate dehydrogenase complex, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(125593, NULL, 'G3DSA:3.30.230.10:FF:000247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125594, NULL, 'G3DSA:3.30.1360.120:FF:000025', NULL, NULL, 'tRNA modification GTPase MnmE', NULL, NULL, NULL, NULL, NULL, 4),
(125595, NULL, 'G3DSA:2.130.10.10:FF:005096', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(125596, NULL, 'G3DSA:3.40.50.1980:FF:000017', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(125597, NULL, 'G3DSA:3.40.50.300:FF:001639', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(125598, NULL, 'G3DSA:3.40.50.1820:FF:000638', NULL, NULL, 'Dipeptidyl peptidase IV-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(125599, NULL, 'G3DSA:3.30.200.20:FF:000748', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RCH1', NULL, NULL, NULL, NULL, NULL, 4),
(125600, NULL, 'G3DSA:4.10.240.10:FF:000136', NULL, NULL, 'Uncharacterized transcriptional regulatory protein YFL052W', NULL, NULL, NULL, NULL, NULL, 4),
(125601, NULL, 'G3DSA:2.30.29.30:FF:001136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125602, NULL, 'G3DSA:3.20.20.60:FF:000005', NULL, NULL, 'Isocitrate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(125603, NULL, 'G3DSA:3.40.50.1000:FF:000252', NULL, NULL, 'Enolase-phosphatase E1', NULL, NULL, NULL, NULL, NULL, 4),
(125604, NULL, 'G3DSA:2.40.50.140:FF:001027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125605, NULL, 'G3DSA:2.60.40.10:FF:000065', NULL, NULL, 'roundabout homolog 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(125606, NULL, 'G3DSA:3.40.1230.10:FF:000019', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(125607, NULL, 'G3DSA:3.40.50.200:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125608, NULL, 'G3DSA:1.50.40.10:FF:000332', NULL, NULL, 'Mitochondrial dicarboxylate carrier', NULL, NULL, NULL, NULL, NULL, 4),
(125609, NULL, 'G3DSA:2.10.25.10:FF:000982', NULL, NULL, 'Fibrillin-1', NULL, NULL, NULL, NULL, NULL, 4),
(125610, NULL, 'G3DSA:1.20.140.10:FF:000087', NULL, NULL, 'Flavin-dependent monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(125611, NULL, 'G3DSA:1.20.58.60:FF:000063', NULL, NULL, 'Short stop, isoform K', NULL, NULL, NULL, NULL, NULL, 4),
(125612, NULL, 'G3DSA:3.30.200.20:FF:000012', NULL, NULL, 'microtubule-associated serine/threonine-protein kinase 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(125613, NULL, 'G3DSA:3.30.2350.10:FF:000025', NULL, NULL, 'Related to DRAP deaminase RIB2', NULL, NULL, NULL, NULL, NULL, 4),
(125614, NULL, 'G3DSA:1.20.1250.20:FF:000232', NULL, NULL, 'Organic cation/carnitine transporter 7', NULL, NULL, NULL, NULL, NULL, 4),
(125615, NULL, 'G3DSA:1.10.520.20:FF:000003', NULL, NULL, 'ATP synthase F1, delta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(125616, NULL, 'G3DSA:1.10.540.10:FF:000064', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(125617, NULL, 'G3DSA:3.40.50.300:FF:006855', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125618, NULL, 'G3DSA:4.10.410.10:FF:000060', NULL, NULL, 'Tissue factor pathway inhibitor', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(125619, NULL, 'G3DSA:3.30.450.40:FF:000222', NULL, NULL, 'GAF domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(125620, NULL, 'G3DSA:3.30.310.220:FF:000002', NULL, NULL, 'Serine/threonine protein kinase (Kcc4)', NULL, NULL, NULL, NULL, NULL, 4),
(125621, NULL, 'G3DSA:1.25.10.10:FF:003261', NULL, NULL, 'Ras guanine nucleotide exchange factor L', NULL, NULL, NULL, NULL, NULL, 4),
(125622, NULL, 'G3DSA:3.40.50.620:FF:000021', NULL, NULL, 'Riboflavin biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(125623, NULL, 'G3DSA:1.20.1070.10:FF:001822', NULL, NULL, 'melatonin receptor type 1B-A-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(125624, NULL, 'G3DSA:1.20.58.2220:FF:000016', NULL, NULL, 'Formin 2', NULL, NULL, NULL, NULL, NULL, 4),
(125625, NULL, 'G3DSA:2.30.30.910:FF:000003', NULL, NULL, 'Basal-body rod modification protein FlgD', NULL, NULL, NULL, NULL, NULL, 4),
(125626, NULL, 'G3DSA:1.20.5.110:FF:000234', NULL, NULL, 'BET1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(125627, NULL, 'G3DSA:1.10.1450.10:FF:000117', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(125628, NULL, 'G3DSA:1.20.1270.60:FF:000099', NULL, NULL, 'Rho guanine nucleotide exchange factor 37', NULL, NULL, NULL, NULL, NULL, 4),
(125629, NULL, 'G3DSA:1.20.120.730:FF:000008', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(125630, NULL, 'G3DSA:2.40.30.170:FF:000077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125631, NULL, 'G3DSA:1.10.510.10:FF:002765', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125632, NULL, 'G3DSA:1.20.5.110:FF:000178', NULL, NULL, 'Qc-SNARE protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(125633, NULL, 'G3DSA:3.30.160.60:FF:005236', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125634, NULL, 'G3DSA:3.40.50.300:FF:007479', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125635, NULL, 'G3DSA:1.10.287.160:FF:000002', NULL, NULL, 'Putative serine/threonine-protein kinase N2', NULL, NULL, NULL, NULL, NULL, 4),
(125636, NULL, 'G3DSA:3.80.10.10:FF:001813', NULL, NULL, 'Os06g0179800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(125637, NULL, 'G3DSA:1.10.8.60:FF:000014', NULL, NULL, 'DNA-binding transcriptional regulator NtrC', NULL, NULL, NULL, NULL, NULL, 4),
(125638, NULL, 'G3DSA:1.10.2000.10:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125639, NULL, 'G3DSA:1.20.210.10:FF:000031', NULL, NULL, 'Cytochrome c oxidase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(125640, NULL, 'G3DSA:3.30.200.20:FF:001861', NULL, NULL, 'Os11g0691300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(125641, NULL, 'G3DSA:2.40.50.140:FF:001090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125642, NULL, 'G3DSA:3.40.50.10140:FF:000042', NULL, NULL, 'Phosphoinositide-3-kinase adaptor protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(125643, NULL, 'G3DSA:3.80.10.10:FF:004163', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(125644, NULL, 'G3DSA:3.40.630.10:FF:000455', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125645, NULL, 'G3DSA:3.30.760.10:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125646, NULL, 'G3DSA:3.40.630.10:FF:000399', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(125647, NULL, 'G3DSA:1.10.760.10:FF:000052', NULL, NULL, 'L-cysteine S-thiosulfotransferase subunit SoxA', NULL, NULL, NULL, NULL, NULL, 4),
(125648, NULL, 'G3DSA:3.30.1680.10:FF:000044', NULL, NULL, 'Macrophage-stimulating 1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(125649, NULL, 'G3DSA:3.40.50.410:FF:000132', NULL, NULL, '60 kDa SS-A/Ro ribonucleoprotein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(125650, NULL, 'G3DSA:2.30.30.140:FF:000019', NULL, NULL, 'MBT domain-containing protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(125651, NULL, 'G3DSA:3.40.50.300:FF:008480', NULL, NULL, 'ABC transporter C family member 14', NULL, NULL, NULL, NULL, NULL, 4),
(125652, NULL, 'G3DSA:3.40.50.2300:FF:000619', NULL, NULL, 'Vomeronasal 2, receptor 120', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(125653, NULL, 'G3DSA:2.30.29.90:FF:000007', NULL, NULL, 'Exocyst complex component SEC3', NULL, NULL, NULL, NULL, NULL, 4),
(125654, NULL, 'G3DSA:3.40.50.2020:FF:000013', NULL, NULL, 'Amidophosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(125655, NULL, 'G3DSA:1.25.40.10:FF:000957', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g39530', NULL, NULL, NULL, NULL, NULL, 4),
(125656, NULL, 'G3DSA:3.80.10.10:FF:001757', NULL, NULL, 'NLR family CARD domain-containing 8', NULL, NULL, NULL, NULL, NULL, 4),
(125657, NULL, 'G3DSA:3.30.40.230:FF:000011', NULL, NULL, 'Glycine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(125658, NULL, 'G3DSA:2.60.40.10:FF:003898', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125659, NULL, 'G3DSA:3.30.160.60:FF:003387', NULL, NULL, 'Zinc finger protein 764', NULL, NULL, NULL, NULL, NULL, 4),
(125660, NULL, 'G3DSA:3.40.50.300:FF:003264', NULL, NULL, 'RecBCD enzyme subunit RecC', NULL, NULL, NULL, NULL, NULL, 4),
(125661, NULL, 'G3DSA:3.30.1370.10:FF:000178', NULL, NULL, 'DDX53 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(125662, NULL, 'G3DSA:1.20.1050.70:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125663, NULL, 'G3DSA:3.30.1340.10:FF:000007', NULL, NULL, 'HPr family phosphocarrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(125664, NULL, 'G3DSA:3.40.1110.10:FF:000179', NULL, NULL, 'Probable cadmium/zinc-transporting ATPase HMA1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(125665, NULL, 'G3DSA:1.10.238.10:FF:001209', NULL, NULL, 'EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(125666, NULL, 'G3DSA:3.40.50.2000:FF:000294', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125667, NULL, 'G3DSA:2.10.25.10:FF:000931', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125668, NULL, 'G3DSA:3.60.21.60:FF:000028', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(125669, NULL, 'G3DSA:3.80.10.10:FF:001864', NULL, NULL, 'Leucine rich repeat containing 40', NULL, NULL, NULL, NULL, NULL, 4),
(125670, NULL, 'G3DSA:2.60.40.1180:FF:000021', NULL, NULL, 'Alpha-amylase', NULL, NULL, NULL, NULL, NULL, 4),
(125671, NULL, 'G3DSA:1.25.40.10:FF:001469', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(125672, NULL, 'G3DSA:2.40.30.10:FF:000133', NULL, NULL, 'Flavodoxin reductase Hmp', NULL, NULL, NULL, NULL, NULL, 4),
(125673, NULL, 'G3DSA:3.40.50.300:FF:002988', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(125674, NULL, 'G3DSA:3.30.160.60:FF:001970', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125675, NULL, 'G3DSA:2.60.420.10:FF:000017', NULL, NULL, 'Glycosyl hydrolase family 65 central catalytic domain/Haloacid dehalogenase-like hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(125676, NULL, 'G3DSA:1.20.58.2010:FF:000015', NULL, NULL, 'Rop guanine nucleotide exchange factor 7', NULL, NULL, NULL, NULL, NULL, 4),
(125677, NULL, 'G3DSA:2.60.40.10:FF:001133', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(125678, NULL, 'G3DSA:3.40.1190.10:FF:000015', NULL, NULL, 'Dihydrofolate synthase/folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(125679, NULL, 'G3DSA:2.60.120.200:FF:000688', NULL, NULL, 'Protein eyes shut homolog', NULL, NULL, NULL, NULL, NULL, 4),
(125680, NULL, 'G3DSA:2.100.10.50:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125681, NULL, 'G3DSA:3.20.20.80:FF:000556', NULL, NULL, 'Chitinase 3 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(125682, NULL, 'G3DSA:1.20.1410.10:FF:000045', NULL, NULL, 'Kynureninase', NULL, NULL, NULL, NULL, NULL, 4),
(125683, NULL, 'G3DSA:1.50.40.10:FF:000388', NULL, NULL, 'Mitochondrial amino acid carrier', NULL, NULL, NULL, NULL, NULL, 4),
(125684, NULL, 'G3DSA:2.40.30.40:FF:000001', NULL, NULL, 'Peptidase M28', NULL, NULL, NULL, NULL, NULL, 4),
(125685, NULL, 'G3DSA:2.30.29.30:FF:000916', NULL, NULL, 'Rho GTPase-activating protein gacEE', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(125686, NULL, 'G3DSA:3.10.250.10:FF:000056', NULL, NULL, 'CD6 antigen', NULL, NULL, NULL, NULL, NULL, 4),
(125687, NULL, 'G3DSA:1.10.220.110:FF:000005', NULL, NULL, 'GDNF family receptor alpha 2b', NULL, NULL, NULL, NULL, NULL, 4),
(125688, NULL, 'G3DSA:3.30.2230.10:FF:000022', NULL, NULL, 'ubiquitin carboxyl-terminal hydrolase 32', NULL, NULL, NULL, NULL, NULL, 4),
(125689, NULL, 'G3DSA:1.10.1900.10:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(125690, NULL, 'G3DSA:1.10.10.10:FF:000152', NULL, NULL, 'FadR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(125691, NULL, 'G3DSA:3.40.50.720:FF:001029', NULL, NULL, 'Enoyl-[acyl-carrier-protein] reductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(125692, NULL, 'G3DSA:3.30.1390.30:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125693, NULL, 'G3DSA:1.10.10.60:FF:000650', NULL, NULL, 'Ventral homeobox', NULL, NULL, NULL, NULL, NULL, 4),
(125694, NULL, 'G3DSA:1.20.1070.10:FF:001081', NULL, NULL, 'Alpha-1A adrenergic receptor', NULL, NULL, NULL, NULL, NULL, 4),
(125695, NULL, 'G3DSA:2.10.25.10:FF:000190', NULL, NULL, 'fibulin-5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(125696, NULL, 'G3DSA:1.10.418.10:FF:000201', NULL, NULL, 'Interaptin', NULL, NULL, NULL, NULL, NULL, 4),
(125697, NULL, 'G3DSA:1.10.8.60:FF:000065', NULL, NULL, 'Loader of gp41 DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(125698, NULL, 'G3DSA:2.60.40.10:FF:000857', NULL, NULL, 'PKHD1 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(125699, NULL, 'G3DSA:3.40.50.300:FF:006018', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(125700, NULL, 'G3DSA:3.40.1450.10:FF:000002', NULL, NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(125701, NULL, 'G3DSA:3.30.2020.30:FF:000023', NULL, NULL, 'YALI0C10604p', NULL, NULL, NULL, NULL, NULL, 4),
(125702, NULL, 'G3DSA:3.40.50.1820:FF:000790', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(125703, NULL, 'G3DSA:3.40.50.300:FF:004438', NULL, NULL, 'ARF2', NULL, NULL, NULL, NULL, NULL, 4),
(125704, NULL, 'G3DSA:1.10.268.10:FF:000020', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(125705, NULL, 'G3DSA:2.60.120.200:FF:000396', NULL, NULL, 'vitamin K-dependent protein S-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(125706, NULL, 'G3DSA:3.40.50.300:FF:005006', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(125707, NULL, 'G3DSA:1.25.40.570:FF:000025', NULL, NULL, '26S proteasome regulatory subunit RPN6', NULL, NULL, NULL, NULL, NULL, 4),
(125708, NULL, 'G3DSA:3.10.130.10:FF:000002', NULL, NULL, 'Inactive ribonuclease-like protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(125709, NULL, 'G3DSA:2.60.40.10:FF:005404', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125710, NULL, 'G3DSA:3.30.70.270:FF:000085', NULL, NULL, 'Endogenous retrovirus group K member 10 Pol protein', NULL, NULL, NULL, NULL, NULL, 4),
(125711, NULL, 'G3DSA:1.20.5.110:FF:000285', NULL, NULL, 'Protein transport protein sec9', NULL, NULL, NULL, NULL, NULL, 4),
(125712, NULL, 'G3DSA:3.30.420.10:FF:000059', NULL, NULL, 'Exosome complex exonuclease Rrp6', NULL, NULL, NULL, NULL, NULL, 4),
(125713, NULL, 'G3DSA:4.10.1240.10:FF:000032', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(125714, NULL, 'G3DSA:3.30.1370.10:FF:000234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125715, NULL, 'G3DSA:2.20.28.10:FF:000027', NULL, NULL, 'Rubredoxin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(125716, NULL, 'G3DSA:2.60.40.10:FF:000913', NULL, NULL, 'Interleukin 31 receptor A', NULL, NULL, NULL, NULL, NULL, 4),
(125717, NULL, 'G3DSA:3.40.50.1240:FF:000088', NULL, NULL, 'F13K23.10 protein', NULL, NULL, NULL, NULL, NULL, 4),
(125718, NULL, 'G3DSA:1.25.40.20:FF:001242', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(125719, NULL, 'G3DSA:1.10.3720.10:FF:000009', NULL, NULL, 'Amino acid ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(125720, NULL, 'G3DSA:1.20.120.1780:FF:000010', NULL, NULL, 'Naringenin 8-dimethylallyltransferase 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(125721, NULL, 'G3DSA:2.40.37.10:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125722, NULL, 'G3DSA:3.40.50.2000:FF:000743', NULL, NULL, 'Protein CBG06545', NULL, NULL, NULL, NULL, NULL, 4),
(125723, NULL, 'G3DSA:1.10.540.10:FF:000069', NULL, NULL, 'Acyl-CoA dehydrogenase type 2', NULL, NULL, NULL, NULL, NULL, 4),
(125724, NULL, 'G3DSA:3.40.850.10:FF:000090', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(125725, NULL, 'G3DSA:3.40.190.80:FF:000003', NULL, NULL, 'PAP-specific phosphatase HAL2-like', NULL, NULL, NULL, NULL, NULL, 4),
(125726, NULL, 'G3DSA:4.10.280.10:FF:000077', NULL, NULL, 'transcription factor HES-3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(125727, NULL, 'G3DSA:1.10.472.80:FF:000223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125728, NULL, 'G3DSA:1.25.40.450:FF:000006', NULL, NULL, 'Putative nuclear pore complex protein (NUP155)', NULL, NULL, NULL, NULL, NULL, 4),
(125729, NULL, 'G3DSA:2.20.50.20:FF:000008', NULL, NULL, 'Vitellogenin A2', NULL, NULL, NULL, NULL, NULL, 4),
(125730, NULL, 'G3DSA:3.80.10.10:FF:003606', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125731, NULL, 'G3DSA:3.40.50.720:FF:002198', NULL, NULL, 'NAD-dependent epimerase/dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(125732, NULL, 'G3DSA:3.30.70.330:FF:002565', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125733, NULL, 'G3DSA:3.30.1370.10:FF:000127', NULL, NULL, 'RNA-binding KH domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(125734, NULL, 'G3DSA:3.40.50.2300:FF:001171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125735, NULL, 'G3DSA:3.90.550.10:FF:000488', NULL, NULL, '2-phospho-L-lactate guanylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(125736, NULL, 'G3DSA:3.30.420.10:FF:000110', NULL, NULL, 'DNA polymerase III polC-type', NULL, NULL, NULL, NULL, NULL, 4),
(125737, NULL, 'G3DSA:2.40.10.10:FF:000570', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125738, NULL, 'G3DSA:3.40.50.1820:FF:001751', NULL, NULL, 'Prolylcarboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(125739, NULL, 'G3DSA:2.130.10.10:FF:004876', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(125740, NULL, 'G3DSA:2.70.170.10:FF:000023', NULL, NULL, 'Acetylcholine receptor subunit beta-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(125741, NULL, 'G3DSA:2.130.10.10:FF:005500', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125742, NULL, 'G3DSA:2.120.10.30:FF:000572', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125743, NULL, 'G3DSA:2.60.40.10:FF:000172', NULL, NULL, 'Down syndrome cell adhesion molecule b', NULL, NULL, NULL, NULL, NULL, 4),
(125744, NULL, 'G3DSA:1.10.287.110:FF:000364', NULL, NULL, 'Chaperone protein DNAj, putative', NULL, NULL, NULL, NULL, NULL, 4),
(125745, NULL, 'G3DSA:3.30.40.10:FF:000710', NULL, NULL, 'mitogen-activated protein kinase kinase kinase 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(125746, NULL, 'G3DSA:2.30.30.140:FF:000082', NULL, NULL, 'Fragile X mental retardation syndrome-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(125747, NULL, 'G3DSA:3.40.50.300:FF:003949', NULL, NULL, 'Large subunit GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(125748, NULL, 'G3DSA:3.10.20.90:FF:000582', NULL, NULL, 'Ubiquitin-like protein ATG12', NULL, NULL, NULL, NULL, NULL, 4),
(125749, NULL, 'G3DSA:1.25.40.10:FF:005235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125750, NULL, 'G3DSA:3.30.710.10:FF:000093', NULL, NULL, 'Potassium voltage-gated channel subfamily V member 2', NULL, NULL, NULL, NULL, NULL, 4),
(125751, NULL, 'G3DSA:3.30.450.50:FF:000051', NULL, NULL, 'Vesicle-associated membrane protein 7-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(125752, NULL, 'G3DSA:3.40.50.1220:FF:000082', NULL, NULL, 'Chromosome 16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(125753, NULL, 'G3DSA:2.40.40.20:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125754, NULL, 'G3DSA:2.130.10.10:FF:004039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125755, NULL, 'G3DSA:3.90.230.10:FF:000060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125756, NULL, 'G3DSA:3.40.50.2000:FF:000687', NULL, NULL, 'UDP-glycosyltransferase 89C1', NULL, NULL, NULL, NULL, NULL, 4),
(125757, NULL, 'G3DSA:3.30.420.40:FF:000001', NULL, NULL, 'Actin, muscle', NULL, NULL, NULL, NULL, NULL, 4),
(125758, NULL, 'G3DSA:3.40.50.200:FF:000075', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 6', NULL, NULL, NULL, NULL, NULL, 4),
(125759, NULL, 'G3DSA:2.30.40.10:FF:000151', NULL, NULL, 'Glr3518 protein', NULL, NULL, NULL, NULL, NULL, 4),
(125760, NULL, 'G3DSA:1.20.1440.240:FF:000003', NULL, NULL, 'WGS project CABT00000000 data, contig 2.11', NULL, NULL, NULL, NULL, NULL, 4),
(125761, NULL, 'G3DSA:2.60.120.970:FF:000048', NULL, NULL, 'Nodal-related 1', NULL, NULL, NULL, NULL, NULL, 4),
(125762, NULL, 'G3DSA:3.40.1350.10:FF:000017', NULL, NULL, 'Restriction system protein MRR', NULL, NULL, NULL, NULL, NULL, 4),
(125763, NULL, 'G3DSA:2.70.170.10:FF:000203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125764, NULL, 'G3DSA:3.80.20.20:FF:000058', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(125765, NULL, 'G3DSA:1.10.472.130:FF:000039', NULL, NULL, 'Dynein heavy chain domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(125766, NULL, 'G3DSA:2.60.120.290:FF:000203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125767, NULL, 'G3DSA:3.40.1370.10:FF:000001', NULL, NULL, '50S ribosomal protein L4', NULL, NULL, NULL, NULL, NULL, 4),
(125768, NULL, 'G3DSA:3.40.50.300:FF:001347', NULL, NULL, 'Putative ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(125769, NULL, 'G3DSA:3.30.9.10:FF:000020', NULL, NULL, 'L-2-hydroxyglutarate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(125770, NULL, 'G3DSA:2.60.120.200:FF:000345', NULL, NULL, 'Laminin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(125771, NULL, 'G3DSA:2.130.10.10:FF:005152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125772, NULL, 'G3DSA:3.20.20.70:FF:000334', NULL, NULL, 'CNX2', NULL, NULL, NULL, NULL, NULL, 4),
(125773, NULL, 'G3DSA:2.80.10.50:FF:000119', NULL, NULL, 'C-type mannose receptor 2 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(125774, NULL, 'G3DSA:3.90.70.80:FF:000011', NULL, NULL, 'tumor necrosis factor alpha-induced protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(125775, NULL, 'G3DSA:3.30.460.10:FF:000056', NULL, NULL, 'Poly(A) polymerase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(125776, NULL, 'G3DSA:1.20.1560.10:FF:000505', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(125777, NULL, 'G3DSA:1.20.1070.10:FF:001766', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125778, NULL, 'G3DSA:1.20.5.340:FF:000005', NULL, NULL, 'Forkhead box P1, isoform CRA_f', NULL, NULL, NULL, NULL, NULL, 4),
(125779, NULL, 'G3DSA:1.10.510.10:FF:001461', NULL, NULL, 'PRKACB isoform 6', NULL, NULL, NULL, NULL, NULL, 4),
(125780, NULL, 'G3DSA:3.50.30.30:FF:000080', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(125781, NULL, 'G3DSA:2.10.25.10:FF:000419', NULL, NULL, 'Complement C1r subcomponent', NULL, NULL, NULL, NULL, NULL, 4),
(125782, NULL, 'G3DSA:1.10.472.80:FF:000167', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125783, NULL, 'G3DSA:1.10.540.10:FF:000120', NULL, NULL, 'Acyl CoA DeHydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(125784, NULL, 'G3DSA:1.50.40.10:FF:000040', NULL, NULL, 'mitochondrial carnitine/acylcarnitine carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(125785, NULL, 'G3DSA:3.10.450.40:FF:000029', NULL, NULL, 'Elastase', NULL, NULL, NULL, NULL, NULL, 4),
(125786, NULL, 'G3DSA:1.20.1160.20:FF:000017', NULL, NULL, 'Delphilin', NULL, NULL, NULL, NULL, NULL, 4),
(125787, NULL, 'G3DSA:3.20.20.80:FF:000612', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(125788, NULL, 'G3DSA:1.10.486.10:FF:000021', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(125789, NULL, 'G3DSA:3.30.1490.50:FF:000002', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(125790, NULL, 'G3DSA:1.25.40.10:FF:003830', NULL, NULL, 'AGAP010928-PA', NULL, NULL, NULL, NULL, NULL, 4),
(125791, NULL, 'G3DSA:1.20.1270.60:FF:000048', NULL, NULL, 'BAR adaptor protein RVS167', NULL, NULL, NULL, NULL, NULL, 4),
(125792, NULL, 'G3DSA:2.130.10.10:FF:004663', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125793, NULL, 'G3DSA:3.40.220.10:FF:000025', NULL, NULL, 'Polyprotein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(125794, NULL, 'G3DSA:2.60.34.10:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125795, NULL, 'G3DSA:3.30.300.130:FF:000012', NULL, NULL, 'NifU-like protein 1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(125796, NULL, 'G3DSA:1.10.630.10:FF:000840', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125797, NULL, 'G3DSA:3.40.50.1240:FF:000037', NULL, NULL, 'Sedoheptulose 1,7-bisphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(125798, NULL, 'G3DSA:3.30.40.10:FF:001278', NULL, NULL, 'Putative RING zinc finger domain superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(125799, NULL, 'G3DSA:3.40.50.10810:FF:000226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125800, NULL, 'G3DSA:2.170.270.10:FF:000041', NULL, NULL, 'Histone-lysine N-methyltransferase SETMAR', NULL, NULL, NULL, NULL, NULL, 4),
(125801, NULL, 'G3DSA:3.40.50.300:FF:002640', NULL, NULL, 'DEAD-box ATP-dependent RNA helicase 25', NULL, NULL, NULL, NULL, NULL, 4),
(125802, NULL, 'G3DSA:3.30.70.100:FF:000192', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125803, NULL, 'G3DSA:1.10.238.10:FF:001272', NULL, NULL, 'Serine/threonine-protein phosphatase 2A regulatory subunit rsa-1', NULL, NULL, NULL, NULL, NULL, 4),
(125804, NULL, 'G3DSA:2.30.30.1020:FF:000019', NULL, NULL, 'CCR4-NOT transcription complex subunit 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(125805, NULL, 'G3DSA:3.30.160.60:FF:001869', NULL, NULL, 'Snail family zinc finger 1', NULL, NULL, NULL, NULL, NULL, 4),
(125806, NULL, 'G3DSA:1.20.1560.10:FF:000556', NULL, NULL, 'p-GlycoProtein related', NULL, NULL, NULL, NULL, NULL, 4),
(125807, NULL, 'G3DSA:3.30.110.110:FF:000002', NULL, NULL, 'Double-strand break repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(125808, NULL, 'G3DSA:3.30.160.60:FF:005860', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125809, NULL, 'G3DSA:3.40.720.10:FF:000333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125810, NULL, 'G3DSA:2.60.40.150:FF:000260', NULL, NULL, 'Nicotinic receptor-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(125811, NULL, 'G3DSA:1.10.418.10:FF:000021', NULL, NULL, 'Leucine-rich repeat and calponin homology domain-containing protein 1 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(125812, NULL, 'G3DSA:3.40.50.150:FF:000324', NULL, NULL, 'N2,N2-dimethylguanosine tRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(125813, NULL, 'G3DSA:3.30.420.610:FF:000008', NULL, NULL, 'Tudor domain-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(125814, NULL, 'G3DSA:3.30.1490.20:FF:000111', NULL, NULL, 'Succinate--CoA ligase [GDP-forming] subunit beta, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(125815, NULL, 'G3DSA:3.30.310.80:FF:000044', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(125816, NULL, 'G3DSA:3.80.10.10:FF:000796', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(125817, NULL, 'G3DSA:1.25.40.20:FF:001798', NULL, NULL, 'Protein CBG15247', NULL, NULL, NULL, NULL, NULL, 4),
(125818, NULL, 'G3DSA:3.40.640.10:FF:000332', NULL, NULL, 'Saframycin Mx1 synthetase B', NULL, NULL, NULL, NULL, NULL, 4),
(125819, NULL, 'G3DSA:3.30.1640.10:FF:000047', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(125820, NULL, 'G3DSA:2.60.120.620:FF:000078', NULL, NULL, 'Phytanoyl-CoA alpha-hydroxylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(125821, NULL, 'G3DSA:3.70.10.10:FF:000044', NULL, NULL, 'Proliferating cell nuclear antigen', NULL, NULL, NULL, NULL, NULL, 4),
(125822, NULL, 'G3DSA:2.60.40.4130:FF:000001', NULL, NULL, 'Peptidase Vpr Serine peptidase MEROPS family S08A', NULL, NULL, NULL, NULL, NULL, 4),
(125823, NULL, 'G3DSA:3.30.70.580:FF:000021', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(125824, NULL, 'G3DSA:3.80.10.10:FF:001072', NULL, NULL, 'F-box/LRR-repeat protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(125825, NULL, 'G3DSA:1.50.10.20:FF:000097', NULL, NULL, 'Complement component C5', NULL, NULL, NULL, NULL, NULL, 4),
(125826, NULL, 'G3DSA:3.30.428.10:FF:000015', NULL, NULL, 'm7GpppX diphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(125827, NULL, 'G3DSA:1.10.1300.10:FF:000062', NULL, NULL, 'Calcium/calmodulin-dependent 3'',5''-cyclic nucleotide phosphodiesterase 1B', NULL, NULL, NULL, NULL, NULL, 4),
(125828, NULL, 'G3DSA:1.25.40.10:FF:001525', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(125829, NULL, 'G3DSA:3.30.565.10:FF:000316', NULL, NULL, 'Sensor histidine kinase VirS', NULL, NULL, NULL, NULL, NULL, 4),
(125830, NULL, 'G3DSA:3.40.50.300:FF:005950', NULL, NULL, 'DNA mismatch repair protein Msh3', NULL, NULL, NULL, NULL, NULL, 4),
(125831, NULL, 'G3DSA:1.10.3520.10:FF:000005', NULL, NULL, 'Accelerated cell death 11', NULL, NULL, NULL, NULL, NULL, 4),
(125832, NULL, 'G3DSA:1.10.8.10:FF:000308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125833, NULL, 'G3DSA:1.25.40.70:FF:000043', NULL, NULL, 'Phosphatidylinositol 4-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(125834, NULL, 'G3DSA:3.40.30.10:FF:000350', NULL, NULL, 'Blast:Thioredoxin, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(125835, NULL, 'G3DSA:3.30.70.330:FF:000704', NULL, NULL, 'Ribosome biogenesis (Nop4)', NULL, NULL, NULL, NULL, NULL, 4),
(125836, NULL, 'G3DSA:3.30.70.2140:FF:000001', NULL, NULL, 'Endoplasmin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(125837, NULL, 'G3DSA:2.40.50.90:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125838, NULL, 'G3DSA:2.30.39.10:FF:000086', NULL, NULL, 'GM20003', NULL, NULL, NULL, NULL, NULL, 4),
(125839, NULL, 'G3DSA:1.25.10.10:FF:000624', NULL, NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(125840, NULL, 'G3DSA:1.10.730.20:FF:000008', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(125841, NULL, 'G3DSA:3.40.1110.10:FF:000415', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125842, NULL, 'G3DSA:2.10.70.10:FF:000035', NULL, NULL, 'Seizure related 6 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(125843, NULL, 'G3DSA:2.30.29.30:FF:000647', NULL, NULL, 'Putative GDP-GTP exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(125844, NULL, 'G3DSA:1.10.1450.10:FF:000005', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(125845, NULL, 'G3DSA:1.20.1250.20:FF:001356', NULL, NULL, 'MFS sugar transporter, putative (AFU_orthologue AFUA_3G02890)', NULL, NULL, NULL, NULL, NULL, 4),
(125846, NULL, 'G3DSA:1.20.1270.60:FF:000279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125847, NULL, 'G3DSA:1.20.58.530:FF:000005', NULL, NULL, 'unconventional myosin-IXa isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(125848, NULL, 'G3DSA:2.60.120.920:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125849, NULL, 'G3DSA:1.20.5.110:FF:000054', NULL, NULL, 'Protein transport protein BOS1', NULL, NULL, NULL, NULL, NULL, 4),
(125850, NULL, 'G3DSA:1.25.10.10:FF:000568', NULL, NULL, 'Tubulin folding cofactor D', NULL, NULL, NULL, NULL, NULL, 4),
(125851, NULL, 'G3DSA:3.40.50.720:FF:001866', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125852, NULL, 'G3DSA:3.40.50.410:FF:000256', NULL, NULL, 'Voltage-dependent calcium channel subunit alpha-2/delta-3', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(125853, NULL, 'G3DSA:3.10.350.10:FF:000092', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(125854, NULL, 'G3DSA:2.60.120.10:FF:000652', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125855, NULL, 'G3DSA:3.40.140.10:FF:000024', NULL, NULL, 'AMSH-like ubiquitin thioesterase 3', NULL, NULL, NULL, NULL, NULL, 4),
(125856, NULL, 'G3DSA:3.40.30.10:FF:000294', NULL, NULL, 'Glutathione S-transferase, N-terminal domain containing protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(125857, NULL, 'G3DSA:1.20.1250.20:FF:000900', NULL, NULL, 'Proton-dependent oligopeptide transporter, POT family', NULL, NULL, NULL, NULL, NULL, 4),
(125858, NULL, 'G3DSA:3.50.7.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125859, NULL, 'G3DSA:3.30.70.330:FF:002834', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125860, NULL, 'G3DSA:1.20.1270.60:FF:000335', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125861, NULL, 'G3DSA:1.20.58.390:FF:000036', NULL, NULL, 'Nicotinic acetylcholine receptor subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(125862, NULL, 'G3DSA:1.20.1250.20:FF:000844', NULL, NULL, 'Os09g0297300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(125863, NULL, 'G3DSA:3.80.10.10:FF:000408', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(125864, NULL, 'G3DSA:3.10.290.10:FF:000103', NULL, NULL, 'Tyrosine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(125865, NULL, 'G3DSA:1.20.1250.20:FF:000788', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(125866, NULL, 'G3DSA:4.10.1060.10:FF:000046', NULL, NULL, 'Si:ch1073-55a19.2', NULL, NULL, NULL, NULL, NULL, 4),
(125867, NULL, 'G3DSA:3.40.50.410:FF:000312', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125868, NULL, 'G3DSA:2.60.120.260:FF:000099', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(125869, NULL, 'G3DSA:3.30.160.60:FF:000857', NULL, NULL, 'Zinc finger protein 512B', NULL, NULL, NULL, NULL, NULL, 4),
(125870, NULL, 'G3DSA:3.90.1410.10:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125871, NULL, 'G3DSA:3.30.1370.30:FF:000009', NULL, NULL, 'Putative 30S ribosomal protein S8', NULL, NULL, NULL, NULL, NULL, 4),
(125872, NULL, 'G3DSA:3.90.1860.10:FF:000016', NULL, NULL, 'tRNA-splicing ligase RtcB homolog', NULL, NULL, NULL, NULL, NULL, 4),
(125873, NULL, 'G3DSA:3.90.190.20:FF:000002', NULL, NULL, 'UDP-N-acetylmuramate--L-alanyl-gamma-D-glutamyl-meso-2,6-diaminoheptandioate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(125874, NULL, 'G3DSA:2.60.40.10:FF:004062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125875, NULL, 'G3DSA:3.20.20.140:FF:000089', NULL, NULL, 'Amidohydrolase 2', NULL, NULL, NULL, NULL, NULL, 4),
(125876, NULL, 'G3DSA:1.10.150.50:FF:000186', NULL, NULL, 'Leucine-rich repeat and sterile alpha motif-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(125877, NULL, 'G3DSA:2.60.40.200:FF:000027', NULL, NULL, 'Superoxide dismutase [Cu-Zn]', NULL, NULL, NULL, NULL, NULL, 4),
(125878, NULL, 'G3DSA:2.30.30.190:FF:000012', NULL, NULL, 'CAP-Gly domain-containing linker protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(125879, NULL, 'G3DSA:1.20.1260.100:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125880, NULL, 'G3DSA:3.30.1330.20:FF:000010', NULL, NULL, 'Cell division protein FtsZ 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(125881, NULL, 'G3DSA:2.60.40.10:FF:002881', NULL, NULL, 'CD166 antigen homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(125882, NULL, 'G3DSA:3.30.160.60:FF:002370', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125883, NULL, 'G3DSA:3.30.70.330:FF:001216', NULL, NULL, 'RNA binding motif protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(125884, NULL, 'G3DSA:1.10.1740.220:FF:000001', NULL, NULL, 'Protein phosphatase fem-2', NULL, NULL, NULL, NULL, NULL, 4),
(125885, NULL, 'G3DSA:2.30.40.10:FF:000044', NULL, NULL, 'Guanine deaminase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(125886, NULL, 'G3DSA:4.10.60.10:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125887, NULL, 'G3DSA:3.40.50.410:FF:000363', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125888, NULL, 'G3DSA:3.10.20.90:FF:000014', NULL, NULL, 'Ubiquitin-60S ribosomal L40 fusion', NULL, NULL, NULL, NULL, NULL, 4),
(125889, NULL, 'G3DSA:3.30.160.60:FF:000222', NULL, NULL, 'Putative transcriptional repressor ctcf', NULL, NULL, NULL, NULL, NULL, 4),
(125890, NULL, 'G3DSA:1.25.40.540:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125891, NULL, 'G3DSA:2.60.40.640:FF:000024', NULL, NULL, 'Down syndrome critical region protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(125892, NULL, 'G3DSA:1.10.510.10:FF:004390', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125893, NULL, 'G3DSA:2.60.220.50:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125894, NULL, 'G3DSA:3.40.50.620:FF:000077', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(125895, NULL, 'G3DSA:3.40.630.30:FF:000045', NULL, NULL, 'N-acetylglutamate synthase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(125896, NULL, 'G3DSA:3.40.190.10:FF:000971', NULL, NULL, 'ABC-type dipeptide/oligopeptide transport system, probable periplasmic component', NULL, NULL, NULL, NULL, NULL, 4),
(125897, NULL, 'G3DSA:1.25.50.20:FF:000051', NULL, NULL, 'GM17926', NULL, NULL, NULL, NULL, NULL, 4),
(125898, NULL, 'G3DSA:2.130.10.10:FF:000329', NULL, NULL, 'WD repeat-containing protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(125899, NULL, 'G3DSA:3.30.160.60:FF:006309', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125900, NULL, 'G3DSA:3.80.10.10:FF:002538', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125901, NULL, 'G3DSA:3.40.190.290:FF:000070', NULL, NULL, 'HTH-type transcriptional regulator ArgP', NULL, NULL, NULL, NULL, NULL, 4),
(125902, NULL, 'G3DSA:3.50.50.60:FF:001490', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125903, NULL, 'G3DSA:3.20.20.80:FF:000724', NULL, NULL, '1,3-beta-glucanosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(125904, NULL, 'G3DSA:2.60.40.790:FF:000041', NULL, NULL, 'Protein SGT1 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(125905, NULL, 'G3DSA:1.10.287.380:FF:000012', NULL, NULL, 'Valine-tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(125906, NULL, 'G3DSA:3.40.50.300:FF:000043', NULL, NULL, 'Vacuolar protein sorting-associated protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(125907, NULL, 'G3DSA:3.30.310.180:FF:000001', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 20', NULL, NULL, NULL, NULL, NULL, 4),
(125908, NULL, 'G3DSA:3.40.120.10:FF:000080', NULL, NULL, 'Phosphohexomutase (Phosphoglucomutase / phosphomannomutase)', NULL, NULL, NULL, NULL, NULL, 4),
(125909, NULL, 'G3DSA:3.30.2350.20:FF:000011', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(125910, NULL, 'G3DSA:1.10.630.10:FF:000003', NULL, NULL, 'cytochrome P450 3A12-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(125911, NULL, 'G3DSA:2.60.40.1180:FF:000133', NULL, NULL, 'Alpha-N-arabinofuranosidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(125912, NULL, 'G3DSA:4.10.280.10:FF:000003', NULL, NULL, 'microphthalmia-associated transcription factor isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(125913, NULL, 'G3DSA:1.25.40.10:FF:001812', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g29760, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(125914, NULL, 'G3DSA:1.20.58.900:FF:000026', NULL, NULL, 'Small G protein signaling modulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(125915, NULL, 'G3DSA:1.25.40.10:FF:003942', NULL, NULL, 'Probable coatomer subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(125916, NULL, 'G3DSA:3.50.50.60:FF:000646', NULL, NULL, 'Glycerol3-phosphate dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(125917, NULL, 'G3DSA:3.40.50.1000:FF:000488', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(125918, NULL, 'G3DSA:1.10.8.60:FF:000519', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125919, NULL, 'G3DSA:3.20.20.140:FF:000145', NULL, NULL, '2-amino-3-carboxymuconate-6-semialdehyde decarboxylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(125920, NULL, 'G3DSA:1.25.50.20:FF:000006', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(125921, NULL, 'G3DSA:3.40.710.10:FF:000040', NULL, NULL, 'Methicillin resistance protein FmtA', NULL, NULL, NULL, NULL, NULL, 4),
(125922, NULL, 'G3DSA:3.30.70.360:FF:000016', NULL, NULL, 'Peptidase family M20/M25/M40', NULL, NULL, NULL, NULL, NULL, 4),
(125923, NULL, 'G3DSA:2.10.25.10:FF:000127', NULL, NULL, 'Neurogenic locus notch protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(125924, NULL, 'G3DSA:3.30.760.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125925, NULL, 'G3DSA:3.40.50.150:FF:001381', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125926, NULL, 'G3DSA:3.40.80.10:FF:000010', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(125927, NULL, 'G3DSA:3.40.50.720:FF:001922', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(125928, NULL, 'G3DSA:3.30.70.1470:FF:000002', NULL, NULL, 'Caspase-3', NULL, NULL, NULL, NULL, NULL, 4),
(125929, NULL, 'G3DSA:3.30.310.10:FF:000012', NULL, NULL, 'Beta-adaptin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(125930, NULL, 'G3DSA:2.130.10.10:FF:000661', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(125931, NULL, 'G3DSA:3.30.160.60:FF:001526', NULL, NULL, 'zinc finger protein 282', NULL, NULL, NULL, NULL, NULL, 4),
(125932, NULL, 'G3DSA:3.50.50.60:FF:000539', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(125933, NULL, 'G3DSA:3.40.50.300:FF:002191', NULL, NULL, 'Putative DEAD/DEAH box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(125934, NULL, 'G3DSA:1.10.510.10:FF:001309', NULL, NULL, 'GM12753', NULL, NULL, NULL, NULL, NULL, 4),
(125935, NULL, 'G3DSA:1.10.510.10:FF:003439', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125936, NULL, 'G3DSA:3.30.230.10:FF:000011', NULL, NULL, 'DNA repair protein RadA', NULL, NULL, NULL, NULL, NULL, 4),
(125937, NULL, 'G3DSA:1.20.1560.10:FF:000269', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(125938, NULL, 'G3DSA:3.30.40.10:FF:000766', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(125939, NULL, 'G3DSA:3.90.1480.20:FF:000035', NULL, NULL, 'Lactosylceramide alpha-2,3-sialyltransferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(125940, NULL, 'G3DSA:3.90.1410.10:FF:000140', NULL, NULL, 'Rubisco small subunit N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(125941, NULL, 'G3DSA:3.40.50.300:FF:003533', NULL, NULL, 'ADP-ribosylation factor-like protein 13B', NULL, NULL, NULL, NULL, NULL, 4),
(125942, NULL, 'G3DSA:2.60.40.10:FF:001189', NULL, NULL, 'Semaphorin 4C', NULL, NULL, NULL, NULL, NULL, 4),
(125943, NULL, 'G3DSA:3.30.60.90:FF:000010', NULL, NULL, 'auxin transport protein BIG', NULL, NULL, NULL, NULL, NULL, 4),
(125944, NULL, 'G3DSA:3.40.50.300:FF:006462', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125945, NULL, 'G3DSA:1.25.10.10:FF:001136', NULL, NULL, 'Beta-catenin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(125946, NULL, 'G3DSA:2.30.40.10:FF:000100', NULL, NULL, 'N-formimino-L-glutamate deiminase', NULL, NULL, NULL, NULL, NULL, 4),
(125947, NULL, 'G3DSA:1.20.890.10:FF:000003', NULL, NULL, 'protein dpy-30 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(125948, NULL, 'G3DSA:3.30.200.20:FF:000405', NULL, NULL, 'T3SS secreted effector NleH', NULL, NULL, NULL, NULL, NULL, 4),
(125949, NULL, 'G3DSA:2.60.120.200:FF:000289', NULL, NULL, 'Emp46p', NULL, NULL, NULL, NULL, NULL, 4),
(125950, NULL, 'G3DSA:1.10.555.10:FF:000210', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125951, NULL, 'G3DSA:2.30.29.30:FF:000012', NULL, NULL, 'Arf-GAP with SH3 domain, ANK repeat and PH domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(125952, NULL, 'G3DSA:4.10.60.10:FF:000148', NULL, NULL, 'Replication protein A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(125953, NULL, 'G3DSA:1.10.150.20:FF:000082', NULL, NULL, 'DNA-directed RNA polymerase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(125954, NULL, 'G3DSA:1.25.40.20:FF:001910', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125955, NULL, 'G3DSA:1.20.5.2950:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125956, NULL, 'G3DSA:1.20.1250.40:FF:000002', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC9', NULL, NULL, NULL, NULL, NULL, 4),
(125957, NULL, 'G3DSA:1.20.1070.10:FF:001474', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125958, NULL, 'G3DSA:1.20.120.350:FF:000097', NULL, NULL, 'Calcium channel subunit Cch1', NULL, NULL, NULL, NULL, NULL, 4),
(125959, NULL, 'G3DSA:2.130.10.10:FF:005444', NULL, NULL, 'Protein CBR-ELPC-2', NULL, NULL, NULL, NULL, NULL, 4),
(125960, NULL, 'G3DSA:3.30.920.10:FF:000024', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(125961, NULL, 'G3DSA:2.60.40.10:FF:000464', NULL, NULL, 'Putative obscurin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(125962, NULL, 'G3DSA:1.10.486.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125963, NULL, 'G3DSA:3.30.420.10:FF:000402', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125964, NULL, 'G3DSA:3.10.20.90:FF:000290', NULL, NULL, 'Autophagy protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(125965, NULL, 'G3DSA:3.30.160.430:FF:000001', NULL, NULL, 'Spindle pole component', NULL, NULL, NULL, NULL, NULL, 4),
(125966, NULL, 'G3DSA:3.20.20.70:FF:000626', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125967, NULL, 'G3DSA:1.25.40.20:FF:001854', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125968, NULL, 'G3DSA:3.40.50.300:FF:003657', NULL, NULL, 'DEAD-box ATP-dependent RNA helicase 22', NULL, NULL, NULL, NULL, NULL, 4),
(125969, NULL, 'G3DSA:2.70.150.10:FF:000084', NULL, NULL, 'Probable cation-transporting ATPase HI_0290', NULL, NULL, NULL, NULL, NULL, 4),
(125970, NULL, 'G3DSA:2.60.120.690:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125971, NULL, 'G3DSA:3.30.565.10:FF:000024', NULL, NULL, 'heat shock protein 90-5, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(125972, NULL, 'G3DSA:3.30.200.20:FF:001709', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125973, NULL, 'G3DSA:2.60.40.10:FF:004859', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125974, NULL, 'G3DSA:1.25.40.10:FF:004667', NULL, NULL, 'Os03g0435200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(125975, NULL, 'G3DSA:1.10.510.10:FF:001641', NULL, NULL, 'Os06g0191500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(125976, NULL, 'G3DSA:3.40.50.1000:FF:000600', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125977, NULL, 'G3DSA:1.25.40.10:FF:005179', NULL, NULL, 'Antiporter/ drug transporter', NULL, NULL, NULL, NULL, NULL, 4),
(125978, NULL, 'G3DSA:1.20.5.340:FF:000050', NULL, NULL, 'Myosin heavy chain, muscle', NULL, NULL, NULL, NULL, NULL, 4),
(125979, NULL, 'G3DSA:3.30.450.20:FF:000272', NULL, NULL, 'Sensor histidine kinase RcsC', NULL, NULL, NULL, NULL, NULL, 4),
(125980, NULL, 'G3DSA:3.40.50.620:FF:000818', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125981, NULL, 'G3DSA:1.25.40.10:FF:005067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125982, NULL, 'G3DSA:4.10.75.10:FF:000002', NULL, NULL, 'WAP, Kazal, immunoglobulin, Kunitz and NTR domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(125983, NULL, 'G3DSA:3.40.50.300:FF:005681', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(125984, NULL, 'G3DSA:3.40.50.300:FF:003477', NULL, NULL, 'Mitochondrial ribosome-associated GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(125985, NULL, 'G3DSA:1.20.1560.10:FF:000325', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(125986, NULL, 'G3DSA:3.80.20.20:FF:000007', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(125987, NULL, 'G3DSA:2.130.10.10:FF:003258', NULL, NULL, 'Transducin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(125988, NULL, 'G3DSA:3.30.40.10:FF:002003', NULL, NULL, 'Putative RING zinc finger domain superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(125989, NULL, 'G3DSA:3.40.1110.10:FF:000128', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(125990, NULL, 'G3DSA:3.40.50.300:FF:007928', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(125991, NULL, 'G3DSA:2.20.100.10:FF:000215', NULL, NULL, 'Semaphorin-5A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(125992, NULL, 'G3DSA:2.40.160.20:FF:000010', NULL, NULL, 'Outer membrane porin F', NULL, NULL, NULL, NULL, NULL, 4),
(125993, NULL, 'G3DSA:1.10.510.10:FF:002153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125994, NULL, 'G3DSA:3.30.1360.230:FF:000002', NULL, NULL, 'Suppressor of fused homolog', NULL, NULL, NULL, NULL, NULL, 4),
(125995, NULL, 'G3DSA:3.50.50.60:FF:000691', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(125996, NULL, 'G3DSA:3.30.559.30:FF:000033', NULL, NULL, 'Nonribosomal peptide synthase GliP', NULL, NULL, NULL, NULL, NULL, 4),
(125997, NULL, 'G3DSA:2.40.70.10:FF:000579', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(125998, NULL, 'G3DSA:1.20.5.4820:FF:000004', NULL, NULL, 'Myosin IE', NULL, NULL, NULL, NULL, NULL, 4),
(125999, NULL, 'G3DSA:3.30.70.1230:FF:000060', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(126000, NULL, 'G3DSA:1.10.3380.30:FF:000011', NULL, NULL, 'DEAD/DEAH box RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(126001, NULL, 'G3DSA:3.30.479.30:FF:000032', NULL, NULL, 'Protein HflK', NULL, NULL, NULL, NULL, NULL, 4),
(126002, NULL, 'G3DSA:3.30.450.40:FF:000278', NULL, NULL, 'Diguanylate cyclase with PAS/PAC sensor', NULL, NULL, NULL, NULL, NULL, 4),
(126003, NULL, 'G3DSA:2.60.120.310:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126004, NULL, 'G3DSA:2.10.25.10:FF:000307', NULL, NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein', NULL, NULL, NULL, NULL, NULL, 4),
(126005, NULL, 'G3DSA:2.10.109.10:FF:000024', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(126006, NULL, 'G3DSA:3.20.20.140:FF:000325', NULL, NULL, 'Os07g0157900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(126007, NULL, 'G3DSA:2.60.260.40:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126008, NULL, 'G3DSA:2.10.90.10:FF:000093', NULL, NULL, 'AGAP000859-PA', NULL, NULL, NULL, NULL, NULL, 4),
(126009, NULL, 'G3DSA:3.40.50.720:FF:001181', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(126010, NULL, 'G3DSA:3.90.550.10:FF:000201', NULL, NULL, 'Probable Csh5-chitin synthase 5', NULL, NULL, NULL, NULL, NULL, 4),
(126011, NULL, 'G3DSA:1.20.1560.10:FF:000612', NULL, NULL, 'Protein CBR-PGP-12', NULL, NULL, NULL, NULL, NULL, 4),
(126012, NULL, 'G3DSA:3.40.50.2300:FF:000951', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126013, NULL, 'G3DSA:2.60.120.200:FF:000576', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(126014, NULL, 'G3DSA:3.40.50.720:FF:000517', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(126015, NULL, 'G3DSA:1.25.40.1030:FF:000042', NULL, NULL, 'Protein transport protein sec16', NULL, NULL, NULL, NULL, NULL, 4),
(126016, NULL, 'G3DSA:3.40.50.10240:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126017, NULL, 'G3DSA:3.30.9.80:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126018, NULL, 'G3DSA:3.90.70.10:FF:000428', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(126019, NULL, 'G3DSA:3.40.140.10:FF:000131', NULL, NULL, 'Sulfurylase', NULL, NULL, NULL, NULL, NULL, 4),
(126020, NULL, 'G3DSA:1.10.510.10:FF:002714', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(126021, NULL, 'G3DSA:1.10.10.60:FF:001162', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126022, NULL, 'G3DSA:3.30.1130.10:FF:000020', NULL, NULL, 'Folic acid synthesis protein fol1', NULL, NULL, NULL, NULL, NULL, 4),
(126023, NULL, 'G3DSA:3.40.50.150:FF:000032', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase G', NULL, NULL, NULL, NULL, NULL, 4),
(126024, NULL, 'G3DSA:1.10.472.10:FF:000130', NULL, NULL, 'G2/mitotic-specific cyclin S13-7', NULL, NULL, NULL, NULL, NULL, 4),
(126025, NULL, 'G3DSA:1.10.287.810:FF:000017', NULL, NULL, 'Mitochondrial import inner membrane translocase subunit TIM8', NULL, NULL, NULL, NULL, NULL, 4),
(126026, NULL, 'G3DSA:3.30.160.60:FF:004275', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126027, NULL, 'G3DSA:1.10.555.10:FF:000030', NULL, NULL, 'rho GTPase-activating protein 9 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(126028, NULL, 'G3DSA:3.50.50.60:FF:000359', NULL, NULL, 'Methylenetetrahydrofolate--tRNA-(uracil-5-)-methyltransferase TrmFO', NULL, NULL, NULL, NULL, NULL, 4),
(126029, NULL, 'G3DSA:1.10.1370.10:FF:000004', NULL, NULL, 'Mitochondrial intermediate peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(126030, NULL, 'G3DSA:1.20.58.760:FF:000001', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(126031, NULL, 'G3DSA:3.40.50.10190:FF:000208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126032, NULL, 'G3DSA:1.25.40.700:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126033, NULL, 'G3DSA:3.40.50.460:FF:000006', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(126034, NULL, 'G3DSA:3.30.160.60:FF:002038', NULL, NULL, 'ZFP42 zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(126035, NULL, 'G3DSA:1.10.20.10:FF:000214', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126036, NULL, 'G3DSA:3.90.190.10:FF:000409', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126037, NULL, 'G3DSA:3.30.160.60:FF:001638', NULL, NULL, 'Zinc finger protein 668', NULL, NULL, NULL, NULL, NULL, 4),
(126038, NULL, 'G3DSA:1.10.260.40:FF:000062', NULL, NULL, 'Predicted transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(126039, NULL, 'G3DSA:3.40.50.1820:FF:001127', NULL, NULL, 'Dipeptidyl aminopeptidase 4', NULL, NULL, NULL, NULL, NULL, 4),
(126040, NULL, 'G3DSA:1.10.8.10:FF:000191', NULL, NULL, 'RAD23 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126041, NULL, 'G3DSA:3.40.720.10:FF:000226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126042, NULL, 'G3DSA:3.40.50.150:FF:001105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126043, NULL, 'G3DSA:3.40.50.2000:FF:000979', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126044, NULL, 'G3DSA:1.25.40.20:FF:001293', NULL, NULL, 'Ankyrin repeat and zinc finger domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(126045, NULL, 'G3DSA:3.40.50.2000:FF:000855', NULL, NULL, 'Granule bound starch synthase', NULL, NULL, NULL, NULL, NULL, 4),
(126046, NULL, 'G3DSA:1.25.40.10:FF:001756', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(126047, NULL, 'G3DSA:3.50.4.10:FF:000060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126048, NULL, 'G3DSA:3.30.40.10:FF:002059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126049, NULL, 'G3DSA:2.130.10.10:FF:003819', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126050, NULL, 'G3DSA:1.10.155.10:FF:000005', NULL, NULL, 'Chemotaxis protein methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(126051, NULL, 'G3DSA:1.20.58.1420:FF:000001', NULL, NULL, 'RINT-1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(126052, NULL, 'G3DSA:1.10.10.10:FF:001169', NULL, NULL, 'Uncharacterized HTH-type transcriptional regulator YbbH', NULL, NULL, NULL, NULL, NULL, 4),
(126053, NULL, 'G3DSA:1.20.920.10:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(126054, NULL, 'G3DSA:2.130.10.10:FF:001173', NULL, NULL, 'Transcription factor tau 91 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(126055, NULL, 'G3DSA:1.25.40.10:FF:000396', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g36730', NULL, NULL, NULL, NULL, NULL, 4),
(126056, NULL, 'G3DSA:3.40.850.10:FF:000106', NULL, NULL, 'Kinesin-like protein KAR3', NULL, NULL, NULL, NULL, NULL, 4),
(126057, NULL, 'G3DSA:3.40.640.10:FF:000225', NULL, NULL, 'Glycine dehydrogenase [decarboxylating], mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(126058, NULL, 'G3DSA:3.10.50.40:FF:000029', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(126059, NULL, 'G3DSA:1.20.58.60:FF:000355', NULL, NULL, 'Spectrin, beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(126060, NULL, 'G3DSA:1.25.20.10:FF:000001', NULL, NULL, 'Soluble lytic murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(126061, NULL, 'G3DSA:2.60.120.650:FF:000126', NULL, NULL, 'C-module-binding factor A', NULL, NULL, NULL, NULL, NULL, 4),
(126062, NULL, 'G3DSA:1.20.1250.20:FF:001300', NULL, NULL, 'Solute carrier family 16 member 9b', NULL, NULL, NULL, NULL, NULL, 4),
(126063, NULL, 'G3DSA:2.130.10.10:FF:003590', NULL, NULL, 'Zinc finger protein 106a', NULL, NULL, NULL, NULL, NULL, 4),
(126064, NULL, 'G3DSA:1.20.140.10:FF:000143', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(126065, NULL, 'G3DSA:3.10.20.90:FF:000138', NULL, NULL, 'ubiquitin domain-containing protein UBFD1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(126066, NULL, 'G3DSA:3.40.30.10:FF:000512', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(126067, NULL, 'G3DSA:1.25.40.10:FF:003381', NULL, NULL, 'Pentatricopeptide repeat (PPR-like) superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(126068, NULL, 'G3DSA:1.20.58.60:FF:000299', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(126069, NULL, 'G3DSA:2.30.30.40:FF:000086', NULL, NULL, 'signal transducing adapter molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(126070, NULL, 'G3DSA:1.20.1250.20:FF:001244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126071, NULL, 'G3DSA:1.20.1060.10:FF:000012', NULL, NULL, 'AGAP007533-PA', NULL, NULL, NULL, NULL, NULL, 4),
(126072, NULL, 'G3DSA:1.10.30.10:FF:000114', NULL, NULL, 'Gcf1p', NULL, NULL, NULL, NULL, NULL, 4),
(126073, NULL, 'G3DSA:3.40.720.10:FF:000046', NULL, NULL, 'DUF229 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(126074, NULL, 'G3DSA:3.40.850.10:FF:000382', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(126075, NULL, 'G3DSA:1.20.58.60:FF:000411', NULL, NULL, 'Nesprin-1', NULL, NULL, NULL, NULL, NULL, 4),
(126076, NULL, 'G3DSA:1.10.1140.10:FF:000015', NULL, NULL, 'Vacuolar ATP synthase catalytic subunit-related / V-ATPase-related / vacuolar proton pump-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(126077, NULL, 'G3DSA:2.30.30.40:FF:000142', NULL, NULL, 'melanoma inhibitory activity protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(126078, NULL, 'G3DSA:3.30.70.260:FF:000043', NULL, NULL, 'Phosphoserine phosphatase SerB', NULL, NULL, NULL, NULL, NULL, 4),
(126079, NULL, 'G3DSA:1.25.10.10:FF:002592', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126080, NULL, 'G3DSA:1.20.5.1430:FF:000009', NULL, NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(126081, NULL, 'G3DSA:1.25.10.10:FF:003210', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(126082, NULL, 'G3DSA:3.40.470.10:FF:000009', NULL, NULL, 'Uracil-DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(126083, NULL, 'G3DSA:3.40.50.300:FF:001791', NULL, NULL, 'RAD3-like DNA-binding helicase protein', NULL, NULL, NULL, NULL, NULL, 4),
(126084, NULL, 'G3DSA:3.40.630.30:FF:000225', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(126085, NULL, 'G3DSA:3.40.630.30:FF:000169', NULL, NULL, 'N-acetylglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(126086, NULL, 'G3DSA:3.40.50.620:FF:000257', NULL, NULL, 'Universal stress protein Rv1636', NULL, NULL, NULL, NULL, NULL, 4),
(126087, NULL, 'G3DSA:3.20.20.70:FF:000227', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(126088, NULL, 'G3DSA:2.130.10.10:FF:001734', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126089, NULL, 'G3DSA:3.30.420.40:FF:000506', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(126090, NULL, 'G3DSA:3.80.10.10:FF:001521', NULL, NULL, 'F-box/LRR-repeat protein 3 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(126091, NULL, 'G3DSA:1.20.1250.20:FF:002137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126092, NULL, 'G3DSA:3.30.160.60:FF:003151', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126093, NULL, 'G3DSA:2.60.120.920:FF:000050', NULL, NULL, 'Neuralized E3 ubiquitin protein ligase 3', NULL, NULL, NULL, NULL, NULL, 4),
(126094, NULL, 'G3DSA:3.30.56.10:FF:000038', NULL, NULL, 'AGAP003517-PA', NULL, NULL, NULL, NULL, NULL, 4),
(126095, NULL, 'G3DSA:3.30.200.20:FF:002373', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126096, NULL, 'G3DSA:1.10.287.660:FF:000006', NULL, NULL, 'Protein GET1', NULL, NULL, NULL, NULL, NULL, 4),
(126097, NULL, 'G3DSA:1.10.10.1180:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126098, NULL, 'G3DSA:3.30.2160.10:FF:000027', NULL, NULL, 'Ubiquitin-protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126099, NULL, 'G3DSA:3.30.160.60:FF:000060', NULL, NULL, 'zinc finger protein 436', NULL, NULL, NULL, NULL, NULL, 4),
(126100, NULL, 'G3DSA:3.80.10.10:FF:004270', NULL, NULL, 'Si:zfos-364h11.2', NULL, NULL, NULL, NULL, NULL, 4),
(126101, NULL, 'G3DSA:3.40.30.10:FF:001075', NULL, NULL, 'Selenoprotein U', NULL, NULL, NULL, NULL, NULL, 4),
(126102, NULL, 'G3DSA:3.40.50.1820:FF:000689', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(126103, NULL, 'G3DSA:3.40.50.300:FF:000223', NULL, NULL, 'Dynein heavy chain 3, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(126104, NULL, 'G3DSA:3.30.365.10:FF:000043', NULL, NULL, 'Aldehyde oxidase and xanthine dehydrogenase, a/b hammerhead domain', NULL, NULL, NULL, NULL, NULL, 4),
(126105, NULL, 'G3DSA:1.20.58.390:FF:000216', NULL, NULL, 'Nicotinic acetylcholine receptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(126106, NULL, 'G3DSA:3.30.70.2350:FF:000002', NULL, NULL, 'GlpG protein', NULL, NULL, NULL, NULL, NULL, 4),
(126107, NULL, 'G3DSA:1.10.1670.10:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126108, NULL, 'G3DSA:1.20.58.80:FF:000018', NULL, NULL, 'nuclear receptor-binding factor 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(126109, NULL, 'G3DSA:1.20.1270.60:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126110, NULL, 'G3DSA:3.60.20.40:FF:000003', NULL, NULL, 'Gamma-glutamyltranspeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(126111, NULL, 'G3DSA:3.80.10.10:FF:000228', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM1', NULL, NULL, NULL, NULL, NULL, 4),
(126112, NULL, 'G3DSA:3.40.50.10090:FF:000004', NULL, NULL, 'Uroporphyrinogen-III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(126113, NULL, 'G3DSA:2.10.50.10:FF:000107', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 5', NULL, NULL, NULL, NULL, NULL, 4),
(126114, NULL, 'G3DSA:3.80.10.10:FF:003994', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126115, NULL, 'G3DSA:3.60.40.10:FF:000282', NULL, NULL, 'Protein phosphatase, Mg2+/Mn2+ dependent 1F', NULL, NULL, NULL, NULL, NULL, 4),
(126116, NULL, 'G3DSA:1.10.135.10:FF:000010', NULL, NULL, 'Creatine kinase B', NULL, NULL, NULL, NULL, NULL, 4),
(126117, NULL, 'G3DSA:3.30.70.80:FF:000025', NULL, NULL, 'Probable endopeptidase K', NULL, NULL, NULL, NULL, NULL, 4),
(126118, NULL, 'G3DSA:3.20.20.80:FF:000848', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(126119, NULL, 'G3DSA:3.40.800.10:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126120, NULL, 'G3DSA:3.40.140.70:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126121, NULL, 'G3DSA:1.50.40.10:FF:000152', NULL, NULL, 'Mitochondrial carrier domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(126122, NULL, 'G3DSA:1.10.10.10:FF:000444', NULL, NULL, 'Rrf2 family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(126123, NULL, 'G3DSA:2.60.120.260:FF:000335', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126124, NULL, 'G3DSA:1.10.730.10:FF:000224', NULL, NULL, 'Os06g0645400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(126125, NULL, 'G3DSA:1.10.405.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126126, NULL, 'G3DSA:1.50.40.10:FF:000096', NULL, NULL, 'ADP,ATP carrier protein 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(126127, NULL, 'G3DSA:3.40.30.10:FF:000911', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(126128, NULL, 'G3DSA:1.10.510.10:FF:002658', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126129, NULL, 'G3DSA:1.10.3470.10:FF:000012', NULL, NULL, 'Zinc ABC transporter, permease', NULL, NULL, NULL, NULL, NULL, 4),
(126130, NULL, 'G3DSA:1.20.1280.50:FF:000271', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(126131, NULL, 'G3DSA:1.10.1220.10:FF:000016', NULL, NULL, 'DNA-damage-inducible protein J', NULL, NULL, NULL, NULL, NULL, 4),
(126132, NULL, 'G3DSA:1.10.630.10:FF:000391', NULL, NULL, 'Os11g0469900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(126133, NULL, 'G3DSA:3.40.50.300:FF:002752', NULL, NULL, 'Septum formation initiator', NULL, NULL, NULL, NULL, NULL, 4),
(126134, NULL, 'G3DSA:1.10.238.10:FF:000760', NULL, NULL, 'Predicted dual oxidase-D', NULL, NULL, NULL, NULL, NULL, 4),
(126135, NULL, 'G3DSA:3.40.50.300:FF:002696', NULL, NULL, 'ATP-binding cassette protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126136, NULL, 'G3DSA:2.40.10.230:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126137, NULL, 'G3DSA:2.60.120.330:FF:000036', NULL, NULL, 'Oxidoreductase, 2OG-Fe(II) oxygenase family', NULL, NULL, NULL, NULL, NULL, 4),
(126138, NULL, 'G3DSA:1.10.510.10:FF:000005', NULL, NULL, 'cAMP-dependent protein kinase catalytic subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(126139, NULL, 'G3DSA:3.30.70.330:FF:002273', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126140, NULL, 'G3DSA:1.20.1250.20:FF:000283', NULL, NULL, 'MFS sugar transporter', NULL, NULL, NULL, NULL, NULL, 4),
(126141, NULL, 'G3DSA:2.40.50.140:FF:000807', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126142, NULL, 'G3DSA:3.30.1060.10:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126143, NULL, 'G3DSA:1.20.58.60:FF:000012', NULL, NULL, 'Microtubule-actin cross-linking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(126144, NULL, 'G3DSA:3.30.40.10:FF:000261', NULL, NULL, 'Mindbomb E3 ubiquitin protein ligase 2', NULL, NULL, NULL, NULL, NULL, 4),
(126145, NULL, 'G3DSA:2.40.50.140:FF:000302', NULL, NULL, 'rRNA biogenesis protein rrp5', NULL, NULL, NULL, NULL, NULL, 4),
(126146, NULL, 'G3DSA:2.170.16.10:FF:000043', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(126147, NULL, 'G3DSA:3.30.160.60:FF:003095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126148, NULL, 'G3DSA:3.30.2410.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126149, NULL, 'G3DSA:3.30.160.60:FF:002190', NULL, NULL, 'Zinc finger protein 658', NULL, NULL, NULL, NULL, NULL, 4),
(126150, NULL, 'G3DSA:3.30.40.10:FF:001166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126151, NULL, 'G3DSA:2.30.42.10:FF:000498', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126152, NULL, 'G3DSA:3.40.50.300:FF:000622', NULL, NULL, 'ATP-binding cassette sub-family G member 2', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(126153, NULL, 'G3DSA:3.30.70.100:FF:000080', NULL, NULL, 'Copper-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(126154, NULL, 'G3DSA:3.30.50.10:FF:000087', NULL, NULL, 'Mineralocorticoid receptor', NULL, NULL, NULL, NULL, NULL, 4),
(126155, NULL, 'G3DSA:1.10.150.50:FF:000130', NULL, NULL, 'Serine/threonine-protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126156, NULL, 'G3DSA:3.80.10.10:FF:000560', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3', NULL, NULL, NULL, NULL, NULL, 4),
(126157, NULL, 'G3DSA:3.40.50.1820:FF:001307', NULL, NULL, 'Hydrolase, alpha/beta fold family protein', NULL, NULL, NULL, NULL, NULL, 4),
(126158, NULL, 'G3DSA:3.40.50.1820:FF:000402', NULL, NULL, 'Putative siderophore biosysnthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(126159, NULL, 'G3DSA:3.30.420.10:FF:000166', NULL, NULL, 'Exonuclease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(126160, NULL, 'G3DSA:3.40.50.300:FF:001392', NULL, NULL, 'GTPase IMAP family member GIMD1', NULL, NULL, NULL, NULL, NULL, 4),
(126161, NULL, 'G3DSA:3.40.50.300:FF:006967', NULL, NULL, 'Uncharacterized protein ABCG27', NULL, NULL, NULL, NULL, NULL, 4),
(126162, NULL, 'G3DSA:1.20.1260.10:FF:000067', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(126163, NULL, 'G3DSA:3.40.710.10:FF:000164', NULL, NULL, 'Penicillin-binding protein, class 1A', NULL, NULL, NULL, NULL, NULL, 4),
(126164, NULL, 'G3DSA:3.20.20.140:FF:000269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126165, NULL, 'G3DSA:1.20.1070.10:FF:000417', NULL, NULL, 'CCK-like receptor', NULL, NULL, NULL, NULL, NULL, 4),
(126166, NULL, 'G3DSA:3.90.120.30:FF:000001', NULL, NULL, 'Cytosine-specific methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(126167, NULL, 'G3DSA:1.10.1060.10:FF:000014', NULL, NULL, 'DgcB, Dimethylglycine catabolism', NULL, NULL, NULL, NULL, NULL, 4),
(126168, NULL, 'G3DSA:3.40.630.10:FF:000163', NULL, NULL, 'Aminoacyl-histidine dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(126169, NULL, 'G3DSA:3.20.20.100:FF:000105', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(126170, NULL, 'G3DSA:3.40.50.410:FF:000076', NULL, NULL, 'general transcription factor IIH subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(126171, NULL, 'G3DSA:3.10.620.30:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(126172, NULL, 'G3DSA:1.10.10.10:FF:001225', NULL, NULL, 'EAP30/Vps36 family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126173, NULL, 'G3DSA:3.30.360.10:FF:000015', NULL, NULL, 'Glucose-6-phosphate 1-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(126174, NULL, 'G3DSA:3.30.420.10:FF:000346', NULL, NULL, 'Polynucleotidyl transferase, ribonuclease H-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(126175, NULL, 'G3DSA:1.20.920.10:FF:000057', NULL, NULL, 'Polybromo 1', NULL, NULL, NULL, NULL, NULL, 4),
(126176, NULL, 'G3DSA:3.30.70.330:FF:001492', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126177, NULL, 'G3DSA:2.70.170.10:FF:000259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126178, NULL, 'G3DSA:1.25.40.10:FF:004847', NULL, NULL, 'Anaphase-promoting complex subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(126179, NULL, 'G3DSA:3.40.1090.10:FF:000070', NULL, NULL, 'Patatin', NULL, NULL, NULL, NULL, NULL, 4),
(126180, NULL, 'G3DSA:3.20.20.100:FF:000049', NULL, NULL, 'Oxidoreductase, aldo/keto reductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(126181, NULL, 'G3DSA:3.30.160.60:FF:003712', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126182, NULL, 'G3DSA:6.20.50.160:FF:000005', NULL, NULL, 'Thioester-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(126183, NULL, 'G3DSA:3.40.50.300:FF:003713', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(126184, NULL, 'G3DSA:1.10.10.10:FF:000949', NULL, NULL, 'Contig184, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(126185, NULL, 'G3DSA:3.40.50.150:FF:001049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(126186, NULL, 'G3DSA:2.60.40.3710:FF:000004', NULL, NULL, 'POSSIBLE CONSERVED EXPORTED PROTEIN', NULL, NULL, NULL, NULL, NULL, 4),
(126187, NULL, 'G3DSA:3.30.60.30:FF:000251', NULL, NULL, 'Agrin-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(126188, NULL, 'G3DSA:2.30.110.10:FF:000051', NULL, NULL, 'YKL070W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(126189, NULL, 'G3DSA:2.130.10.10:FF:005388', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126190, NULL, 'G3DSA:1.10.287.110:FF:000252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126191, NULL, 'G3DSA:3.30.9.10:FF:000256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126192, NULL, 'G3DSA:3.30.40.10:FF:000822', NULL, NULL, 'Chromatin modification-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(126193, NULL, 'G3DSA:4.10.1240.10:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126194, NULL, 'G3DSA:1.25.40.10:FF:005123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126195, NULL, 'G3DSA:2.60.120.20:FF:000019', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(126196, NULL, 'G3DSA:3.90.660.10:FF:000030', NULL, NULL, 'Unplaced genomic scaffold supercont1.10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(126197, NULL, 'G3DSA:1.20.1070.10:FF:001530', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126198, NULL, 'G3DSA:3.30.40.10:FF:001222', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(126199, NULL, 'G3DSA:1.10.10.10:FF:001405', NULL, NULL, 'Iron dependent repressor', NULL, NULL, NULL, NULL, NULL, 4),
(126200, NULL, 'G3DSA:1.20.1070.10:FF:000237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126201, NULL, 'G3DSA:1.20.990.10:FF:000044', NULL, NULL, '(methionine synthase) reductase', NULL, NULL, NULL, NULL, NULL, 4),
(126202, NULL, 'G3DSA:2.60.40.10:FF:004679', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126203, NULL, 'G3DSA:1.25.40.820:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126204, NULL, 'G3DSA:3.40.50.1820:FF:000346', NULL, NULL, 'Oleoyl-ACP hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(126205, NULL, 'G3DSA:2.60.120.620:FF:000022', NULL, NULL, 'Prolyl 4-hydroxylase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(126206, NULL, 'G3DSA:1.20.120.350:FF:000041', NULL, NULL, 'Transmembrane protein 266', NULL, NULL, NULL, NULL, NULL, 4),
(126207, NULL, 'G3DSA:3.30.420.140:FF:000019', NULL, NULL, 'Transcription modulator/accessory protein,putative', NULL, NULL, NULL, NULL, NULL, 4),
(126208, NULL, 'G3DSA:2.60.120.10:FF:000073', NULL, NULL, 'Glycinin G1', NULL, NULL, NULL, NULL, NULL, 4),
(126209, NULL, 'G3DSA:3.40.50.2000:FF:000799', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126210, NULL, 'G3DSA:3.10.28.10:FF:000042', NULL, NULL, 'Replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(126211, NULL, 'G3DSA:1.10.287.130:FF:000134', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(126212, NULL, 'G3DSA:3.80.10.10:FF:000740', NULL, NULL, 'Leucine rich repeat neuronal 4', NULL, NULL, NULL, NULL, NULL, 4),
(126213, NULL, 'G3DSA:3.30.505.10:FF:000195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126214, NULL, 'G3DSA:2.40.20.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126215, NULL, 'G3DSA:1.25.40.10:FF:004903', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126216, NULL, 'G3DSA:3.40.50.300:FF:006063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126217, NULL, 'G3DSA:3.40.950.10:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126218, NULL, 'G3DSA:1.25.40.10:FF:000452', NULL, NULL, 'pentatricopeptide repeat-containing protein At2g03880, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(126219, NULL, 'G3DSA:1.50.10.20:FF:000041', NULL, NULL, 'Geranylgeranyltransferase I beta subunit, putative', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(126220, NULL, 'G3DSA:3.30.160.70:FF:000006', NULL, NULL, 'Methylated-DNA--protein-cysteine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(126221, NULL, 'G3DSA:3.30.70.330:FF:000199', NULL, NULL, 'Putative peroxisome proliferator-activated receptor gamma coactivator-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(126222, NULL, 'G3DSA:3.30.160.60:FF:003494', NULL, NULL, 'Zinc finger and BTB domain containing 41', NULL, NULL, NULL, NULL, NULL, 4),
(126223, NULL, 'G3DSA:2.30.29.30:FF:000068', NULL, NULL, 'Son of sevenless homolog 1 (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(126224, NULL, 'G3DSA:2.60.40.10:FF:005079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126225, NULL, 'G3DSA:3.60.21.10:FF:000154', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(126226, NULL, 'G3DSA:1.10.580.10:FF:000010', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(126227, NULL, 'G3DSA:2.60.40.1180:FF:000077', NULL, NULL, 'Maltase A7', NULL, NULL, NULL, NULL, NULL, 4),
(126228, NULL, 'G3DSA:2.60.40.10:FF:000969', NULL, NULL, 'Advanced glycosylation end product-specific receptor', NULL, NULL, NULL, NULL, NULL, 4),
(126229, NULL, 'G3DSA:3.90.180.10:FF:000004', NULL, NULL, 'probable cinnamyl alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(126230, NULL, 'G3DSA:1.25.10.10:FF:002193', NULL, NULL, 'Coatomer subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(126231, NULL, 'G3DSA:1.10.8.190:FF:000001', NULL, NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(126232, NULL, 'G3DSA:1.10.238.20:FF:000021', NULL, NULL, 'Odorant-binding protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(126233, NULL, 'G3DSA:3.30.540.10:FF:000001', NULL, NULL, 'Fructose-1,6-bisphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(126234, NULL, 'G3DSA:1.10.10.10:FF:000388', NULL, NULL, 'plectin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(126235, NULL, 'G3DSA:3.40.109.10:FF:000002', NULL, NULL, 'Oxygen-insensitive NAD(P)H nitroreductase', NULL, NULL, NULL, NULL, NULL, 4),
(126236, NULL, 'G3DSA:3.30.160.60:FF:000801', NULL, NULL, 'zinc finger protein 461 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(126237, NULL, 'G3DSA:3.30.160.60:FF:004511', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126238, NULL, 'G3DSA:2.60.120.260:FF:000279', NULL, NULL, 'Glycoside hydrolase family 29', NULL, NULL, NULL, NULL, NULL, 4),
(126239, NULL, 'G3DSA:1.25.40.10:FF:003886', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126240, NULL, 'G3DSA:3.30.930.10:FF:000429', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126241, NULL, 'G3DSA:3.40.50.1100:FF:000243', NULL, NULL, 'Cysteine synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126242, NULL, 'G3DSA:1.25.40.120:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126243, NULL, 'G3DSA:1.10.10.1210:FF:000002', NULL, NULL, 'melanoma-associated antigen E1', NULL, NULL, NULL, NULL, NULL, 4),
(126244, NULL, 'G3DSA:1.25.40.10:FF:004162', NULL, NULL, 'Signal recognition particle subunit SRP72', NULL, NULL, NULL, NULL, NULL, 4),
(126245, NULL, 'G3DSA:3.90.740.10:FF:000031', NULL, NULL, 'valine--tRNA ligase, chloroplastic/mitochondrial 2 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(126246, NULL, 'G3DSA:3.20.20.80:FF:000668', NULL, NULL, 'Gll2003 protein', NULL, NULL, NULL, NULL, NULL, 4),
(126247, NULL, 'G3DSA:3.40.50.620:FF:000313', NULL, NULL, 'DUF218 domain', NULL, NULL, NULL, NULL, NULL, 4),
(126248, NULL, 'G3DSA:1.10.287.70:FF:000610', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126249, NULL, 'G3DSA:1.10.167.10:FF:000016', NULL, NULL, 'Regulator of G protein signaling 22', NULL, NULL, NULL, NULL, NULL, 4),
(126250, NULL, 'G3DSA:2.40.50.140:FF:000246', NULL, NULL, 'DNA helicase MCM8', NULL, NULL, NULL, NULL, NULL, 4),
(126251, NULL, 'G3DSA:3.40.30.10:FF:000855', NULL, NULL, 'Zgc:136472', NULL, NULL, NULL, NULL, NULL, 4),
(126252, NULL, 'G3DSA:2.30.42.10:FF:000554', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(126253, NULL, 'G3DSA:3.40.50.1000:FF:000544', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126254, NULL, 'G3DSA:1.10.3370.10:FF:000027', NULL, NULL, 'Sec61 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126255, NULL, 'G3DSA:2.60.40.10:FF:001369', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(126256, NULL, 'G3DSA:3.30.420.270:FF:000030', NULL, NULL, 'Biopolymer transport protein ExbD/TolR', NULL, NULL, NULL, NULL, NULL, 4),
(126257, NULL, 'G3DSA:3.40.50.1010:FF:000081', NULL, NULL, 'Ribonuclease VapC', NULL, NULL, NULL, NULL, NULL, 4),
(126258, NULL, 'G3DSA:1.10.287.70:FF:000211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126259, NULL, 'G3DSA:2.110.10.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126260, NULL, 'G3DSA:2.30.29.30:FF:001029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126261, NULL, 'G3DSA:2.130.10.10:FF:001678', NULL, NULL, 'WD domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(126262, NULL, 'G3DSA:3.90.79.20:FF:000013', NULL, NULL, 'NADH pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(126263, NULL, 'G3DSA:2.60.120.200:FF:000632', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126264, NULL, 'G3DSA:3.90.260.10:FF:000005', NULL, NULL, 'DNA repair protein rhp41', NULL, NULL, NULL, NULL, NULL, 4),
(126265, NULL, 'G3DSA:3.90.210.10:FF:000002', NULL, NULL, 'Pierisin', NULL, NULL, NULL, NULL, NULL, 4),
(126266, NULL, 'G3DSA:3.30.1360.10:FF:000065', NULL, NULL, 'DNA-directed RNA polymerase, alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126267, NULL, 'G3DSA:3.20.20.70:FF:000047', NULL, NULL, '3-dehydroquinate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(126268, NULL, 'G3DSA:3.30.70.270:FF:000321', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126269, NULL, 'G3DSA:1.10.10.1900:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126270, NULL, 'G3DSA:2.70.160.11:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126271, NULL, 'G3DSA:3.30.497.10:FF:000034', NULL, NULL, 'SERPINH1 isoform 13', NULL, NULL, NULL, NULL, NULL, 4),
(126272, NULL, 'G3DSA:1.10.472.80:FF:000111', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(126273, NULL, 'G3DSA:3.80.10.10:FF:004118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126274, NULL, 'G3DSA:3.40.50.300:FF:006271', NULL, NULL, 'Mitochondrial Rho GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(126275, NULL, 'G3DSA:1.10.246.120:FF:000004', NULL, NULL, 'Vacuolar sorting protein', NULL, NULL, NULL, NULL, NULL, 4),
(126276, NULL, 'G3DSA:2.130.10.10:FF:001077', NULL, NULL, 'Elongator protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(126277, NULL, 'G3DSA:1.20.5.500:FF:000002', NULL, NULL, 'Lamin A/C', NULL, NULL, NULL, NULL, NULL, 4),
(126278, NULL, 'G3DSA:3.60.20.10:FF:000112', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(126279, NULL, 'G3DSA:3.30.420.10:FF:000430', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126280, NULL, 'G3DSA:1.20.920.10:FF:000141', NULL, NULL, 'Putative polybromo 1', NULL, NULL, NULL, NULL, NULL, 4),
(126281, NULL, 'G3DSA:1.20.80.10:FF:000009', NULL, NULL, 'FERM and PDZ domain containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(126282, NULL, 'G3DSA:1.10.630.10:FF:000076', NULL, NULL, 'Cytochrome P450 monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(126283, NULL, 'G3DSA:1.10.510.10:FF:004311', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126284, NULL, 'G3DSA:1.10.238.10:FF:000479', NULL, NULL, 'EH domains and endocytosis-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(126285, NULL, 'G3DSA:3.40.50.150:FF:001077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126286, NULL, 'G3DSA:2.40.30.30:FF:000015', NULL, NULL, 'Riboflavin kinase/fmn adenylyltransferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(126287, NULL, 'G3DSA:3.10.20.90:FF:000262', NULL, NULL, 'E3 ubiquitin-protein ligase MYLIP', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(126288, NULL, 'G3DSA:2.30.29.30:FF:000411', NULL, NULL, 'Blast:Rho GTPase-activating protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(126289, NULL, 'G3DSA:3.40.50.2300:FF:000878', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126290, NULL, 'G3DSA:3.30.160.60:FF:002167', NULL, NULL, 'Si:ch211-269m15.3', NULL, NULL, NULL, NULL, NULL, 4),
(126291, NULL, 'G3DSA:1.20.1560.10:FF:000421', NULL, NULL, 'ATP-binding cassette protein subfamily B, member 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126292, NULL, 'G3DSA:3.20.20.60:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126293, NULL, 'G3DSA:3.80.10.10:FF:001156', NULL, NULL, 'Protein STRUBBELIG-RECEPTOR FAMILY 6 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(126294, NULL, 'G3DSA:1.25.10.10:FF:001956', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(126295, NULL, 'G3DSA:4.10.400.10:FF:000328', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126296, NULL, 'G3DSA:3.30.70.260:FF:000155', NULL, NULL, 'ribose-5-phosphate isomerase-like', NULL, NULL, NULL, NULL, NULL, 4),
(126297, NULL, 'G3DSA:2.130.10.10:FF:003814', NULL, NULL, 'Peroxisomal targeting signal 2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(126298, NULL, 'G3DSA:3.40.50.1000:FF:000095', NULL, NULL, 'haloacid dehalogenase-like hydrolase domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(126299, NULL, 'G3DSA:3.40.50.20:FF:000062', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(126300, NULL, 'G3DSA:3.30.40.10:FF:001418', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126301, NULL, 'G3DSA:3.10.450.240:FF:000032', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(126302, NULL, 'G3DSA:1.25.40.10:FF:004055', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(126303, NULL, 'G3DSA:3.30.70.120:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126304, NULL, 'G3DSA:3.30.420.40:FF:000282', NULL, NULL, 'Actin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126305, NULL, 'G3DSA:1.10.238.210:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126306, NULL, 'G3DSA:2.20.25.10:FF:000026', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(126307, NULL, 'G3DSA:1.20.58.60:FF:000720', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126308, NULL, 'G3DSA:3.90.550.10:FF:000701', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126309, NULL, 'G3DSA:1.10.510.10:FF:002057', NULL, NULL, 'Kinase, STE Dicty2', NULL, NULL, NULL, NULL, NULL, 4),
(126310, NULL, 'G3DSA:3.30.1370.110:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126311, NULL, 'G3DSA:3.40.50.620:FF:000280', NULL, NULL, 'DUF218 domain', NULL, NULL, NULL, NULL, NULL, 4),
(126312, NULL, 'G3DSA:3.40.50.2300:FF:000395', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(126313, NULL, 'G3DSA:2.130.10.10:FF:003331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126314, NULL, 'G3DSA:2.40.50.140:FF:000797', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126315, NULL, 'G3DSA:3.30.70.141:FF:000019', NULL, NULL, 'Nucleoside diphosphate kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126316, NULL, 'G3DSA:2.10.70.10:FF:000182', NULL, NULL, 'thyroid peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(126317, NULL, 'G3DSA:1.20.1720.10:FF:000086', NULL, NULL, 'Bcr/CflA family efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(126318, NULL, 'G3DSA:3.40.50.2000:FF:000895', NULL, NULL, 'ADP-heptose:LPS heptosyltransferase II, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126319, NULL, 'G3DSA:1.10.150.60:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126320, NULL, 'G3DSA:3.40.50.2300:FF:000439', NULL, NULL, 'Transcription factor SKN7', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(126321, NULL, 'G3DSA:1.25.10.10:FF:001473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126322, NULL, 'G3DSA:1.10.238.10:FF:000007', NULL, NULL, 'Putative myosin regulatory light chain sqh', NULL, NULL, NULL, NULL, NULL, 4),
(126323, NULL, 'G3DSA:3.30.710.10:FF:000177', NULL, NULL, 'Protein CBR-KVS-5', NULL, NULL, NULL, NULL, NULL, 4),
(126324, NULL, 'G3DSA:1.10.472.130:FF:000062', NULL, NULL, 'Inner dynein arm 1 heavy chain 1-ALPHa', NULL, NULL, NULL, NULL, NULL, 4),
(126325, NULL, 'G3DSA:1.10.10.10:FF:001321', NULL, NULL, 'Two component transcriptional regulator, winged helix family', NULL, NULL, NULL, NULL, NULL, 4),
(126326, NULL, 'G3DSA:1.20.1070.10:FF:001974', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126327, NULL, 'G3DSA:3.40.50.180:FF:000001', NULL, NULL, 'Protein-glutamate methylesterase/protein-glutamine glutaminase', NULL, NULL, NULL, NULL, NULL, 4),
(126328, NULL, 'G3DSA:3.40.50.150:FF:000088', NULL, NULL, 'Polyamine aminopropyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(126329, NULL, 'G3DSA:1.25.40.180:FF:000239', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126330, NULL, 'G3DSA:1.10.510.10:FF:003838', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126331, NULL, 'G3DSA:2.170.270.10:FF:000203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126332, NULL, 'G3DSA:3.30.70.1450:FF:000007', NULL, NULL, 'K(+)/H(+) antiporter NhaP2', NULL, NULL, NULL, NULL, NULL, 4),
(126333, NULL, 'G3DSA:1.10.8.140:FF:000003', NULL, NULL, 'Programmed cell death 5', NULL, NULL, NULL, NULL, NULL, 4),
(126334, NULL, 'G3DSA:3.40.50.10090:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126335, NULL, 'G3DSA:3.80.10.10:FF:003410', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(126336, NULL, 'G3DSA:3.60.110.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126337, NULL, 'G3DSA:2.10.25.10:FF:000330', NULL, NULL, 'usherin', NULL, NULL, NULL, NULL, NULL, 4),
(126338, NULL, 'G3DSA:3.60.21.10:FF:000266', NULL, NULL, 'Ser/Thr protein phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(126339, NULL, 'G3DSA:2.40.70.10:FF:000394', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126340, NULL, 'G3DSA:1.25.40.770:FF:000012', NULL, NULL, 'TAF6-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(126341, NULL, 'G3DSA:2.40.100.10:FF:000104', NULL, NULL, 'Cyclophilin-like peptidyl-prolyl cis-trans isomerase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(126342, NULL, 'G3DSA:3.20.20.140:FF:000393', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126343, NULL, 'G3DSA:3.30.40.10:FF:002363', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(126344, NULL, 'G3DSA:3.40.50.1110:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126345, NULL, 'G3DSA:3.90.190.10:FF:000229', NULL, NULL, 'Dual specificity phosphatase 10', NULL, NULL, NULL, NULL, NULL, 4),
(126346, NULL, 'G3DSA:3.80.10.10:FF:002584', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126347, NULL, 'G3DSA:3.40.50.300:FF:005326', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126348, NULL, 'G3DSA:3.20.20.70:FF:000098', NULL, NULL, 'Bifunctional 3-deoxy-7-phosphoheptulonate synthase/chorismate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(126349, NULL, 'G3DSA:2.60.40.150:FF:000080', NULL, NULL, 'Putative synaptotagmin-12', NULL, NULL, NULL, NULL, NULL, 4),
(126350, NULL, 'G3DSA:3.30.420.40:FF:000765', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126351, NULL, 'G3DSA:2.40.50.1000:FF:000011', NULL, NULL, '30S ribosomal protein S17', NULL, NULL, NULL, NULL, NULL, 4),
(126352, NULL, 'G3DSA:1.25.40.10:FF:004538', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126353, NULL, 'G3DSA:1.25.40.10:FF:005044', NULL, NULL, 'Tetratricopeptide repeat protein 21B', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(126354, NULL, 'G3DSA:1.10.287.110:FF:000021', NULL, NULL, 'DnaJ (Hsp40) homolog, subfamily B, member 2', NULL, NULL, NULL, NULL, NULL, 4),
(126355, NULL, 'G3DSA:3.40.190.10:FF:000943', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126356, NULL, 'G3DSA:2.130.10.30:FF:000144', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126357, NULL, 'G3DSA:1.25.10.10:FF:003081', NULL, NULL, 'Pumilio/PUF RNA binding protein 8, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126358, NULL, 'G3DSA:3.30.200.20:FF:000113', NULL, NULL, 'Putative tyrosine-protein kinase receptor Tie-1', NULL, NULL, NULL, NULL, NULL, 4),
(126359, NULL, 'G3DSA:3.30.559.10:FF:000162', NULL, NULL, 'Enniatin synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(126360, NULL, 'G3DSA:3.30.230.70:FF:000006', NULL, NULL, 'polyribonucleotide nucleotidyltransferase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(126361, NULL, 'G3DSA:3.40.50.2300:FF:001384', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126362, NULL, 'G3DSA:4.10.60.10:FF:000013', NULL, NULL, 'Zinc finger CCHC domain-containing protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(126363, NULL, 'G3DSA:3.40.1190.20:FF:000029', NULL, NULL, 'Ribokinase', NULL, NULL, NULL, NULL, NULL, 4),
(126364, NULL, 'G3DSA:2.10.230.10:FF:000031', NULL, NULL, 'Putative dnaJ chaperone family protein', NULL, NULL, NULL, NULL, NULL, 4),
(126365, NULL, 'G3DSA:2.30.30.40:FF:000322', NULL, NULL, 'Myosin I', NULL, NULL, NULL, NULL, NULL, 4),
(126366, NULL, 'G3DSA:3.40.630.30:FF:000293', NULL, NULL, 'Acetyltransferase, GNAT family', NULL, NULL, NULL, NULL, NULL, 4),
(126367, NULL, 'G3DSA:2.10.25.10:FF:001156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126368, NULL, 'G3DSA:3.30.70.1430:FF:000001', NULL, NULL, 'Efflux pump membrane transporter', NULL, NULL, NULL, NULL, NULL, 4),
(126369, NULL, 'G3DSA:3.10.430.100:FF:000019', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(126370, NULL, 'G3DSA:3.40.367.20:FF:000019', NULL, NULL, 'Glucokinase', NULL, NULL, NULL, NULL, NULL, 4),
(126371, NULL, 'G3DSA:3.80.10.10:FF:000976', NULL, NULL, 'Adhesion G protein-coupled receptor A2', NULL, NULL, NULL, NULL, NULL, 4),
(126372, NULL, 'G3DSA:1.10.150.50:FF:000158', NULL, NULL, 'Leucine-rich repeat and sterile alpha motif-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(126373, NULL, 'G3DSA:2.60.40.60:FF:000355', NULL, NULL, 'Cadherin 16, KSP-cadherin', NULL, NULL, NULL, NULL, NULL, 4),
(126374, NULL, 'G3DSA:1.20.5.520:FF:000008', NULL, NULL, 'thymosin beta-12', NULL, NULL, NULL, NULL, NULL, 4),
(126375, NULL, 'G3DSA:3.30.1120.30:FF:000053', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(126376, NULL, 'G3DSA:1.20.1070.10:FF:000193', NULL, NULL, 'Mas-related G-protein coupled receptor member E', NULL, NULL, NULL, NULL, NULL, 4),
(126377, NULL, 'G3DSA:1.10.132.70:FF:000004', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(126378, NULL, 'G3DSA:3.30.70.330:FF:000463', NULL, NULL, 'Nuclear acid binding', NULL, NULL, NULL, NULL, NULL, 4),
(126379, NULL, 'G3DSA:3.40.30.10:FF:000203', NULL, NULL, 'Protein disulfide isomerase family A member 2', NULL, NULL, NULL, NULL, NULL, 4),
(126380, NULL, 'G3DSA:1.25.40.10:FF:002610', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At2g01510', NULL, NULL, NULL, NULL, NULL, 4),
(126381, NULL, 'G3DSA:2.40.50.1020:FF:000017', NULL, NULL, 'Two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(126382, NULL, 'G3DSA:3.40.50.300:FF:003718', NULL, NULL, 'Cystic Fibrosis Transmembrane conductance regulator homolog', NULL, NULL, NULL, NULL, NULL, 4),
(126383, NULL, 'G3DSA:2.60.120.200:FF:000008', NULL, NULL, 'Collagen type XII alpha 1 chain', NULL, NULL, NULL, NULL, NULL, 4),
(126384, NULL, 'G3DSA:2.60.40.1840:FF:000005', NULL, NULL, 'Membrane alanine aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(126385, NULL, 'G3DSA:1.20.1070.10:FF:000676', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(126386, NULL, 'G3DSA:2.130.10.10:FF:005568', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(126387, NULL, 'G3DSA:3.30.360.20:FF:000006', NULL, NULL, '18S rRNA biogenesis protein RCL1', NULL, NULL, NULL, NULL, NULL, 4),
(126388, NULL, 'G3DSA:3.40.50.2000:FF:000086', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(126389, NULL, 'G3DSA:1.20.5.110:FF:000094', NULL, NULL, 'SNARE protein', NULL, NULL, NULL, NULL, NULL, 4),
(126390, NULL, 'G3DSA:3.20.20.80:FF:000747', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126391, NULL, 'G3DSA:1.25.10.10:FF:002092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126392, NULL, 'G3DSA:3.30.230.10:FF:000404', NULL, NULL, 'Elongation factor G, domain IV family protein', NULL, NULL, NULL, NULL, NULL, 4),
(126393, NULL, 'G3DSA:1.10.150.20:FF:000306', NULL, NULL, 'DNA polymerase eta', NULL, NULL, NULL, NULL, NULL, 4),
(126394, NULL, 'G3DSA:2.60.120.330:FF:000227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126395, NULL, 'G3DSA:3.30.200.20:FF:000905', NULL, NULL, 'Death associated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(126396, NULL, 'G3DSA:3.40.250.10:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126397, NULL, 'G3DSA:3.40.50.720:FF:000854', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(126398, NULL, 'G3DSA:2.60.120.430:FF:000009', NULL, NULL, 'Receptor like protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(126399, NULL, 'G3DSA:3.40.449.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126400, NULL, 'G3DSA:3.30.30.30:FF:000030', NULL, NULL, 'Chaperone protein DNAK, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126401, NULL, 'G3DSA:1.10.8.1220:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126402, NULL, 'G3DSA:4.10.1000.40:FF:000006', NULL, NULL, 'Zinc finger CCCH domain-containing protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(126403, NULL, 'G3DSA:3.50.50.60:FF:000455', NULL, NULL, 'Prenylcysteine lyase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126404, NULL, 'G3DSA:3.30.930.10:FF:000188', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(126405, NULL, 'G3DSA:1.25.10.10:FF:001164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126406, NULL, 'G3DSA:3.40.50.300:FF:008199', NULL, NULL, 'Transitional endoplasmic reticulum ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(126407, NULL, 'G3DSA:3.90.180.10:FF:000111', NULL, NULL, 'Putative NADP-dependent alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(126408, NULL, 'G3DSA:3.40.390.10:FF:000262', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126409, NULL, 'G3DSA:2.130.10.10:FF:005129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126410, NULL, 'G3DSA:3.30.160.60:FF:000722', NULL, NULL, 'zinc finger protein 346 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(126411, NULL, 'G3DSA:2.170.240.10:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126412, NULL, 'G3DSA:2.30.30.40:FF:000485', NULL, NULL, 'Peripheral-type benzodiazepine receptor-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(126413, NULL, 'G3DSA:2.130.10.10:FF:002033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(126414, NULL, 'G3DSA:1.10.418.10:FF:000105', NULL, NULL, 'Microtubule End Binding Protein', NULL, NULL, NULL, NULL, NULL, 4),
(126415, NULL, 'G3DSA:2.10.110.10:FF:000084', NULL, NULL, 'transforming growth factor beta-1-induced transcript 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(126416, NULL, 'G3DSA:3.30.70.330:FF:001289', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(126417, NULL, 'G3DSA:3.10.20.540:FF:000003', NULL, NULL, 'Replicase polyprotein 1ab', NULL, NULL, NULL, NULL, NULL, 4),
(126418, NULL, 'G3DSA:1.25.40.10:FF:001784', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g22070', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(126419, NULL, 'G3DSA:3.30.505.10:FF:000127', NULL, NULL, 'Signal transducer and activator of transcription 1', NULL, NULL, NULL, NULL, NULL, 4),
(126420, NULL, 'G3DSA:2.130.10.10:FF:002858', NULL, NULL, 'PRP19-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126421, NULL, 'G3DSA:3.60.10.10:FF:000286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126422, NULL, 'G3DSA:3.40.718.10:FF:000018', NULL, NULL, 'Isocitrate dehydrogenase [NADP]', NULL, NULL, NULL, NULL, NULL, 4),
(126423, NULL, 'G3DSA:3.90.550.10:FF:000331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126424, NULL, 'G3DSA:1.10.287.130:FF:000027', NULL, NULL, 'Sensor histidine kinase KdpD', NULL, NULL, NULL, NULL, NULL, 4),
(126425, NULL, 'G3DSA:1.20.1070.10:FF:001165', NULL, NULL, 'Tachykinin-like peptides receptor 99D', NULL, NULL, NULL, NULL, NULL, 4),
(126426, NULL, 'G3DSA:1.10.510.10:FF:003355', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126427, NULL, 'G3DSA:1.10.510.10:FF:001877', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126428, NULL, 'G3DSA:1.20.5.780:FF:000007', NULL, NULL, 'FXYD domain-containing ion transport regulator', NULL, NULL, NULL, NULL, NULL, 4),
(126429, NULL, 'G3DSA:1.10.565.10:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126430, NULL, 'G3DSA:3.40.50.1820:FF:001650', NULL, NULL, 'Triacylglycerol lipase', NULL, NULL, NULL, NULL, NULL, 4),
(126431, NULL, 'G3DSA:1.10.510.10:FF:002866', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126432, NULL, 'G3DSA:1.10.8.50:FF:000028', NULL, NULL, 'Type 2 DNA topoisomerase 6 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(126433, NULL, 'G3DSA:3.40.50.300:FF:003848', NULL, NULL, 'Pleiotropic drug resistance 12 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(126434, NULL, 'G3DSA:3.30.70.1230:FF:000222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126435, NULL, 'G3DSA:3.40.850.10:FF:000281', NULL, NULL, 'Kinesin motor subunit-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(126436, NULL, 'G3DSA:1.25.40.20:FF:001641', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(126437, NULL, 'G3DSA:1.20.120.1760:FF:000009', NULL, NULL, 'Phosphatidylcholine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(126438, NULL, 'G3DSA:3.30.300.10:FF:000011', NULL, NULL, 'S-adenosylmethionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(126439, NULL, 'G3DSA:3.40.50.300:FF:001920', NULL, NULL, 'RAB5B, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(126440, NULL, 'G3DSA:3.30.70.330:FF:001761', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126441, NULL, 'G3DSA:2.10.90.10:FF:000065', NULL, NULL, 'Brain-derived neurotrophic factor', NULL, NULL, NULL, NULL, NULL, 4),
(126442, NULL, 'G3DSA:1.10.510.10:FF:004002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126443, NULL, 'G3DSA:3.40.50.300:FF:005282', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(126444, NULL, 'G3DSA:3.40.50.2300:FF:000086', NULL, NULL, 'Two-component system response regulator ChvI', NULL, NULL, NULL, NULL, NULL, 4),
(126445, NULL, 'G3DSA:3.40.250.10:FF:000089', NULL, NULL, 'DOA4p Ubiquitin hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(126446, NULL, 'G3DSA:1.20.1070.10:FF:000985', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126447, NULL, 'G3DSA:1.10.533.10:FF:000165', NULL, NULL, 'Ankyrin', NULL, NULL, NULL, NULL, NULL, 4),
(126448, NULL, 'G3DSA:3.40.50.12280:FF:000004', NULL, NULL, 'NADH-quinone oxidoreductase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(126449, NULL, 'G3DSA:3.40.50.620:FF:000633', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(126450, NULL, 'G3DSA:1.10.10.60:FF:001066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126451, NULL, 'G3DSA:1.10.10.1740:FF:000004', NULL, NULL, 'YJR085C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(126452, NULL, 'G3DSA:2.80.10.50:FF:000035', NULL, NULL, 'Mannose receptor C type 2', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(126453, NULL, 'G3DSA:1.20.120.330:FF:000012', NULL, NULL, 'SPI-1 type III secretion system needle tip complex protein SipB', NULL, NULL, NULL, NULL, NULL, 4),
(126454, NULL, 'G3DSA:3.30.160.60:FF:002959', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126455, NULL, 'G3DSA:2.130.10.10:FF:005259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126456, NULL, 'G3DSA:3.60.10.10:FF:000347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126457, NULL, 'G3DSA:3.40.50.150:FF:001869', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126458, NULL, 'G3DSA:3.30.160.60:FF:003595', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126459, NULL, 'G3DSA:2.30.29.30:FF:000248', NULL, NULL, 'TBC1 domain family member 2A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(126460, NULL, 'G3DSA:3.20.20.70:FF:000435', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126461, NULL, 'G3DSA:3.80.10.10:FF:003882', NULL, NULL, 'Leucine-rich repeat-containing 32', NULL, NULL, NULL, NULL, NULL, 4),
(126462, NULL, 'G3DSA:3.80.10.10:FF:000537', NULL, NULL, 'F-box domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(126463, NULL, 'G3DSA:2.130.10.10:FF:000897', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(126464, NULL, 'G3DSA:2.130.10.10:FF:003022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126465, NULL, 'G3DSA:1.20.1110.10:FF:000264', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126466, NULL, 'G3DSA:3.20.20.190:FF:000036', NULL, NULL, 'Glycerophosphodiester phosphodiesterase, cytosolic', NULL, NULL, NULL, NULL, NULL, 4),
(126467, NULL, 'G3DSA:1.20.58.760:FF:000029', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(126468, NULL, 'G3DSA:3.90.640.10:FF:000130', NULL, NULL, 'Actin-related protein 3, putative arp3', NULL, NULL, NULL, NULL, NULL, 4),
(126469, NULL, 'G3DSA:3.30.160.20:FF:000025', NULL, NULL, 'APOBEC1 complementation factor isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(126470, NULL, 'G3DSA:3.40.50.150:FF:001414', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126471, NULL, 'G3DSA:1.10.10.60:FF:000886', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126472, NULL, 'G3DSA:3.30.450.70:FF:000017', NULL, NULL, 'Sybindin-like family protein', NULL, NULL, NULL, NULL, NULL, 4),
(126473, NULL, 'G3DSA:3.40.50.10810:FF:000030', NULL, NULL, 'ATP-dependent DNA helicase DDM1', NULL, NULL, NULL, NULL, NULL, 4),
(126474, NULL, 'G3DSA:3.40.50.300:FF:004337', NULL, NULL, 'Septum site-determining protein MinD', NULL, NULL, NULL, NULL, NULL, 4),
(126475, NULL, 'G3DSA:2.170.150.80:FF:000007', NULL, NULL, 'NAC domain-containing protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(126476, NULL, 'G3DSA:3.40.50.300:FF:002100', NULL, NULL, 'DEAD/DEAH box helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126477, NULL, 'G3DSA:3.30.720.50:FF:000004', NULL, NULL, 'Probable E3 ubiquitin-protein ligase DTX2', NULL, NULL, NULL, NULL, NULL, 4),
(126478, NULL, 'G3DSA:3.40.50.300:FF:007682', NULL, NULL, 'ATPase family AAA domaincontaining protein 5-like, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126479, NULL, 'G3DSA:1.20.940.10:FF:000024', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(126480, NULL, 'G3DSA:2.60.40.10:FF:005135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126481, NULL, 'G3DSA:1.10.10.10:FF:000495', NULL, NULL, 'RecQ family helicase MusN', NULL, NULL, NULL, NULL, NULL, 4),
(126482, NULL, 'G3DSA:3.40.1380.10:FF:000002', NULL, NULL, 'ATP synthase gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(126483, NULL, 'G3DSA:3.30.450.50:FF:000011', NULL, NULL, 'Vesicle-associated membrane protein 714', NULL, NULL, NULL, NULL, NULL, 4),
(126484, NULL, 'G3DSA:2.10.50.10:FF:000152', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(126485, NULL, 'G3DSA:3.30.230.90:FF:000001', NULL, NULL, 'Proteasome chaperone 3', NULL, NULL, NULL, NULL, NULL, 4),
(126486, NULL, 'G3DSA:3.40.50.300:FF:004837', NULL, NULL, 'Type II/IV secretion system ATPase TadZ/CpaE, associated with Flp pilus assembly', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(126487, NULL, 'G3DSA:3.40.50.300:FF:005635', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126488, NULL, 'G3DSA:1.10.420.10:FF:000021', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(126489, NULL, 'G3DSA:3.20.110.10:FF:000010', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(126490, NULL, 'G3DSA:3.30.565.10:FF:000120', NULL, NULL, 'Pkp2p', NULL, NULL, NULL, NULL, NULL, 4),
(126491, NULL, 'G3DSA:3.40.50.450:FF:000088', NULL, NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(126492, NULL, 'G3DSA:3.90.79.10:FF:000072', NULL, NULL, 'Nucleoside diphosphate-linked moiety X motif 19', NULL, NULL, NULL, NULL, NULL, 4),
(126493, NULL, 'G3DSA:3.30.750.24:FF:000030', NULL, NULL, 'STAS domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(126494, NULL, 'G3DSA:1.10.510.10:FF:000921', NULL, NULL, 'Serine/threonine-protein kinase STE7', NULL, NULL, NULL, NULL, NULL, 4),
(126495, NULL, 'G3DSA:1.25.10.10:FF:002120', NULL, NULL, 'Cell division control protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(126496, NULL, 'G3DSA:2.60.120.780:FF:000002', NULL, NULL, 'E3 SUMO-protein ligase PIAS4', NULL, NULL, NULL, NULL, NULL, 4),
(126497, NULL, 'G3DSA:3.30.200.20:FF:000568', NULL, NULL, 'Putative serine threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(126498, NULL, 'G3DSA:3.30.1330.30:FF:000075', NULL, NULL, 'H/ACA ribonucleoprotein complex subunit 2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(126499, NULL, 'G3DSA:1.10.840.10:FF:000013', NULL, NULL, 'Kinase non-catalytic C-lobe domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(126500, NULL, 'G3DSA:3.80.10.10:FF:000184', NULL, NULL, 'leucine-rich repeat-containing protein 24', NULL, NULL, NULL, NULL, NULL, 4),
(126501, NULL, 'G3DSA:1.10.225.10:FF:000028', NULL, NULL, 'Ecdysone dependent glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(126502, NULL, 'G3DSA:3.20.20.70:FF:000418', NULL, NULL, 'Glycerol uptake operon antiterminator-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(126503, NULL, 'G3DSA:2.60.40.10:FF:001762', NULL, NULL, 'Basement membrane proteoglycan', NULL, NULL, NULL, NULL, NULL, 4),
(126504, NULL, 'G3DSA:3.40.50.2300:FF:001367', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126505, NULL, 'G3DSA:3.30.160.60:FF:004084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126506, NULL, 'G3DSA:3.40.50.1820:FF:000161', NULL, NULL, 'Epoxide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(126507, NULL, 'G3DSA:3.30.559.30:FF:000038', NULL, NULL, 'Probable non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(126508, NULL, 'G3DSA:2.60.40.420:FF:000065', NULL, NULL, 'Fibrocystin-L', NULL, NULL, NULL, NULL, NULL, 4),
(126509, NULL, 'G3DSA:3.40.50.1100:FF:000136', NULL, NULL, 'L-threonine dehydratase catabolic TdcB', NULL, NULL, NULL, NULL, NULL, 4),
(126510, NULL, 'G3DSA:3.40.50.410:FF:000233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126511, NULL, 'G3DSA:3.30.430.20:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126512, NULL, 'G3DSA:3.40.50.150:FF:000588', NULL, NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(126513, NULL, 'G3DSA:3.50.50.60:FF:000808', NULL, NULL, 'FAD-dependent oxidoreductase domain-containing protein 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(126514, NULL, 'G3DSA:3.80.10.10:FF:000667', NULL, NULL, 'Leucine-rich repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(126515, NULL, 'G3DSA:3.90.190.10:FF:000168', NULL, NULL, 'Protein tyrosine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(126516, NULL, 'G3DSA:3.30.160.60:FF:000352', NULL, NULL, 'zinc finger protein 3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(126517, NULL, 'G3DSA:1.10.220.150:FF:000045', NULL, NULL, 'Ultradian oscillation regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126518, NULL, 'G3DSA:3.40.30.10:FF:000220', NULL, NULL, 'Selenoprotein V', NULL, NULL, NULL, NULL, NULL, 4),
(126519, NULL, 'G3DSA:3.30.310.10:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(126520, NULL, 'G3DSA:3.40.50.300:FF:004354', NULL, NULL, 'Bacitracin ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(126521, NULL, 'G3DSA:3.10.20.90:FF:000615', NULL, NULL, 'Probable ubiquitin carboxyl-terminal hydrolase 5', NULL, NULL, NULL, NULL, NULL, 4),
(126522, NULL, 'G3DSA:3.40.50.300:FF:005782', NULL, NULL, 'Probable serine/threonine-protein kinase pats1', NULL, NULL, NULL, NULL, NULL, 4),
(126523, NULL, 'G3DSA:1.10.472.80:FF:000263', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126524, NULL, 'G3DSA:2.60.120.970:FF:000071', NULL, NULL, 'Bone morphogenetic protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(126525, NULL, 'G3DSA:3.30.450.20:FF:000244', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(126526, NULL, 'G3DSA:1.20.1600.10:FF:000037', NULL, NULL, 'Outer membrane efflux protein', NULL, NULL, NULL, NULL, NULL, 4),
(126527, NULL, 'G3DSA:2.40.50.140:FF:000667', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126528, NULL, 'G3DSA:3.40.630.30:FF:000646', NULL, NULL, 'Uncharacterized N-acetyltransferase C9.02c', NULL, NULL, NULL, NULL, NULL, 4),
(126529, NULL, 'G3DSA:3.40.50.1820:FF:001779', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(126530, NULL, 'G3DSA:4.10.1000.10:FF:000143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126531, NULL, 'G3DSA:3.90.180.10:FF:000083', NULL, NULL, 'Zinc-binding dehydrogenase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(126532, NULL, 'G3DSA:3.10.20.30:FF:000042', NULL, NULL, 'Ferredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(126533, NULL, 'G3DSA:3.40.50.11980:FF:000009', NULL, NULL, 'Antiporter/ drug transporter', NULL, NULL, NULL, NULL, NULL, 4),
(126534, NULL, 'G3DSA:2.60.40.1180:FF:000217', NULL, NULL, 'Glycogen isoamylase GlgX', NULL, NULL, NULL, NULL, NULL, 4),
(126535, NULL, 'G3DSA:2.70.130.10:FF:000026', NULL, NULL, 'cation-independent mannose-6-phosphate receptor isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(126536, NULL, 'G3DSA:2.60.60.20:FF:000013', NULL, NULL, 'lipoxygenase homology domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(126537, NULL, 'G3DSA:3.40.190.290:FF:000002', NULL, NULL, 'HTH-type transcriptional regulator ArgP', NULL, NULL, NULL, NULL, NULL, 4),
(126538, NULL, 'G3DSA:1.20.58.390:FF:000031', NULL, NULL, 'Cholinergic receptor nicotinic beta 1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(126539, NULL, 'G3DSA:1.10.150.20:FF:000295', NULL, NULL, 'DNA polymerase I family protein', NULL, NULL, NULL, NULL, NULL, 4),
(126540, NULL, 'G3DSA:1.10.1420.10:FF:000200', NULL, NULL, 'MutS homolog 6', NULL, NULL, NULL, NULL, NULL, 4),
(126541, NULL, 'G3DSA:3.30.450.40:FF:000121', NULL, NULL, 'Serine/threonine protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(126542, NULL, 'G3DSA:2.60.40.10:FF:003027', NULL, NULL, 'Granulocyte-macrophage colony-stimulating factor receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(126543, NULL, 'G3DSA:3.90.70.10:FF:000344', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(126544, NULL, 'G3DSA:1.10.510.10:FF:001540', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(126545, NULL, 'G3DSA:3.30.300.30:FF:000017', NULL, NULL, 'Acyl-CoA synthetase short-chain family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(126546, NULL, 'G3DSA:2.60.120.260:FF:000419', NULL, NULL, 'Hect domain and RLD 2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(126547, NULL, 'G3DSA:3.90.25.10:FF:000037', NULL, NULL, 'NAD-dependent epimerase/dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(126548, NULL, 'G3DSA:1.20.5.220:FF:000008', NULL, NULL, 'Exosome complex exonuclease RRP6', NULL, NULL, NULL, NULL, NULL, 4),
(126549, NULL, 'G3DSA:2.130.10.10:FF:004303', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(126550, NULL, 'G3DSA:3.20.20.100:FF:000212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126551, NULL, 'G3DSA:3.40.50.2300:FF:000895', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(126552, NULL, 'G3DSA:1.10.510.10:FF:001568', NULL, NULL, 'uncharacterized protein LOC106771884 isoform X8', NULL, NULL, NULL, NULL, NULL, 4),
(126553, NULL, 'G3DSA:2.130.10.10:FF:000116', NULL, NULL, 'DDB1- and CUL4-associated factor 10', NULL, NULL, NULL, NULL, NULL, 4),
(126554, NULL, 'G3DSA:2.130.10.10:FF:005731', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126555, NULL, 'G3DSA:3.40.50.10420:FF:000019', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(126556, NULL, 'G3DSA:3.30.40.10:FF:000581', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(126557, NULL, 'G3DSA:3.30.830.10:FF:000124', NULL, NULL, 'Mitochondrial processing peptidase alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126558, NULL, 'G3DSA:3.90.1380.10:FF:000007', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(126559, NULL, 'G3DSA:1.25.10.10:FF:003401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126560, NULL, 'G3DSA:1.10.530.10:FF:000012', NULL, NULL, 'Endochitinase EP3', NULL, NULL, NULL, NULL, NULL, 4),
(126561, NULL, 'G3DSA:3.30.1150.10:FF:000015', NULL, NULL, 'Protein TonB', NULL, NULL, NULL, NULL, NULL, 4),
(126562, NULL, 'G3DSA:2.130.10.10:FF:002403', NULL, NULL, 'U3 small nucleolar RNA-associated protein 4 homolog isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(126563, NULL, 'G3DSA:3.30.40.10:FF:000446', NULL, NULL, 'Autoimmune regulator', NULL, NULL, NULL, NULL, NULL, 4),
(126564, NULL, 'G3DSA:2.40.10.10:FF:000255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126565, NULL, 'G3DSA:1.10.8.10:FF:000292', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(126566, NULL, 'G3DSA:2.130.10.10:FF:001886', NULL, NULL, 'Transducin beta protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(126567, NULL, 'G3DSA:2.60.40.10:FF:004516', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126568, NULL, 'G3DSA:3.30.1640.10:FF:000070', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(126569, NULL, 'G3DSA:3.40.50.300:FF:003409', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(126570, NULL, 'G3DSA:2.60.120.920:FF:000179', NULL, NULL, 'Si:dkeyp-123a12.2', NULL, NULL, NULL, NULL, NULL, 4),
(126571, NULL, 'G3DSA:2.60.40.10:FF:002201', NULL, NULL, 'sialoadhesin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(126572, NULL, 'G3DSA:3.40.50.720:FF:000793', NULL, NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(126573, NULL, 'G3DSA:2.30.29.30:FF:000720', NULL, NULL, 'UNC-34', NULL, NULL, NULL, NULL, NULL, 4),
(126574, NULL, 'G3DSA:3.40.50.1820:FF:000498', NULL, NULL, 'AGAP010390-PA', NULL, NULL, NULL, NULL, NULL, 4),
(126575, NULL, 'G3DSA:3.30.710.10:FF:000514', NULL, NULL, 'Protein CBG12958', NULL, NULL, NULL, NULL, NULL, 4),
(126576, NULL, 'G3DSA:1.10.238.10:FF:000024', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(126577, NULL, 'G3DSA:2.60.40.10:FF:005944', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126578, NULL, 'G3DSA:3.40.50.980:FF:000011', NULL, NULL, 'Long-chain-fatty-acid--CoA ligase FadD1', NULL, NULL, NULL, NULL, NULL, 4),
(126579, NULL, 'G3DSA:3.80.10.10:FF:003101', NULL, NULL, 'Protein CBG03663', NULL, NULL, NULL, NULL, NULL, 4),
(126580, NULL, 'G3DSA:3.30.9.90:FF:000010', NULL, NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126581, NULL, 'G3DSA:2.30.30.140:FF:000059', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(126582, NULL, 'G3DSA:1.20.1250.20:FF:000440', NULL, NULL, 'Peptide transporter PTR2', NULL, NULL, NULL, NULL, NULL, 4),
(126583, NULL, 'G3DSA:1.20.5.170:FF:000049', NULL, NULL, 'X-box binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(126584, NULL, 'G3DSA:1.20.1270.60:FF:000195', NULL, NULL, 'Age1p', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(126585, NULL, 'G3DSA:1.20.5.190:FF:000044', NULL, NULL, 'Neuromodulin isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(126586, NULL, 'G3DSA:3.30.70.20:FF:000086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126587, NULL, 'G3DSA:1.10.10.10:FF:000023', NULL, NULL, 'Two-component response regulator OmpR', NULL, NULL, NULL, NULL, NULL, 4),
(126588, NULL, 'G3DSA:1.10.238.10:FF:001305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126589, NULL, 'G3DSA:1.10.510.10:FF:003485', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126590, NULL, 'G3DSA:3.30.710.10:FF:000205', NULL, NULL, 'Eor-1', NULL, NULL, NULL, NULL, NULL, 4),
(126591, NULL, 'G3DSA:3.30.830.10:FF:000141', NULL, NULL, 'Catalytic/ metal ion binding / metalloendopeptidase/ zinc ion binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(126592, NULL, 'G3DSA:1.10.357.140:FF:000018', NULL, NULL, 'Protoheme IX farnesyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(126593, NULL, 'G3DSA:1.10.510.10:FF:002849', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126594, NULL, 'G3DSA:1.20.1050.130:FF:000016', NULL, NULL, 'Glutathione S-transferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(126595, NULL, 'G3DSA:2.130.10.10:FF:005276', NULL, NULL, 'WD40-repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(126596, NULL, 'G3DSA:3.20.20.140:FF:000084', NULL, NULL, 'Peptidase M38', NULL, NULL, NULL, NULL, NULL, 4),
(126597, NULL, 'G3DSA:3.30.160.60:FF:004876', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126598, NULL, 'G3DSA:1.20.58.60:FF:000383', NULL, NULL, 'Spectrin beta chain, non-erythrocytic', NULL, NULL, NULL, NULL, NULL, 4),
(126599, NULL, 'G3DSA:2.30.29.30:FF:001237', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(126600, NULL, 'G3DSA:1.10.510.10:FF:004283', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126601, NULL, 'G3DSA:2.130.10.30:FF:000127', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126602, NULL, 'G3DSA:3.30.420.40:FF:000310', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(126603, NULL, 'G3DSA:3.40.50.10420:FF:000036', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(126604, NULL, 'G3DSA:1.10.10.60:FF:001083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126605, NULL, 'G3DSA:1.10.579.10:FF:000006', NULL, NULL, 'Cryptochrome DASH', NULL, NULL, NULL, NULL, NULL, 4),
(126606, NULL, 'G3DSA:1.20.1560.10:FF:000084', NULL, NULL, 'Multidrug resistance-associated protein ABC domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(126607, NULL, 'G3DSA:1.10.10.60:FF:000105', NULL, NULL, 'Zinc finger E-box binding homeobox 2', NULL, NULL, NULL, NULL, NULL, 4),
(126608, NULL, 'G3DSA:1.20.1250.20:FF:002368', NULL, NULL, 'Synaptic vesicle glycoprotein 2B-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(126609, NULL, 'G3DSA:1.10.290.10:FF:000004', NULL, NULL, 'DNA topoisomerase 3', NULL, NULL, NULL, NULL, NULL, 4),
(126610, NULL, 'G3DSA:1.25.10.10:FF:000175', NULL, NULL, 'lisH domain and HEAT repeat-containing protein KIAA1468 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(126611, NULL, 'G3DSA:1.10.8.10:FF:000275', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(126612, NULL, 'G3DSA:3.40.50.720:FF:001973', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126613, NULL, 'G3DSA:3.40.50.300:FF:001583', NULL, NULL, 'RAB42, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(126614, NULL, 'G3DSA:3.50.50.60:FF:001427', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126615, NULL, 'G3DSA:1.10.8.60:FF:000357', NULL, NULL, 'AAA ATPase central domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(126616, NULL, 'G3DSA:1.10.510.10:FF:001438', NULL, NULL, 'CMGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(126617, NULL, 'G3DSA:3.90.320.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126618, NULL, 'G3DSA:3.40.50.150:FF:000560', NULL, NULL, 'Mitochondrial N(5)-glutamine methyltransferase MTQ1, putative', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(126619, NULL, 'G3DSA:1.10.510.10:FF:000949', NULL, NULL, 'Serine/threonine-protein kinase PTK1/STK1', NULL, NULL, NULL, NULL, NULL, 4),
(126620, NULL, 'G3DSA:1.10.472.10:FF:000023', NULL, NULL, 'Transcription initiation factor IIB', NULL, NULL, NULL, NULL, NULL, 4),
(126621, NULL, 'G3DSA:1.10.10.10:FF:001776', NULL, NULL, 'Selenocysteine-specific translation elongation factor', NULL, NULL, NULL, NULL, NULL, 4),
(126622, NULL, 'G3DSA:3.90.1480.20:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126623, NULL, 'G3DSA:1.10.12.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126624, NULL, 'G3DSA:3.40.50.720:FF:002462', NULL, NULL, 'Putative NADP-dependent alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(126625, NULL, 'G3DSA:3.40.50.10810:FF:000013', NULL, NULL, 'E3 ubiquitin-protein ligase SHPRH isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(126626, NULL, 'G3DSA:2.40.240.10:FF:000053', NULL, NULL, 'Glutaminyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(126627, NULL, 'G3DSA:1.20.120.1770:FF:000001', NULL, NULL, 'Cytochrome b reductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(126628, NULL, 'G3DSA:1.10.510.10:FF:003794', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126629, NULL, 'G3DSA:1.25.10.10:FF:003429', NULL, NULL, 'Splicing factor subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126630, NULL, 'G3DSA:3.40.50.1460:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126631, NULL, 'G3DSA:1.20.1560.10:FF:000393', NULL, NULL, 'ABC superfamily ATP binding cassette transporter, ABC/membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(126632, NULL, 'G3DSA:3.40.50.1000:FF:000123', NULL, NULL, 'glycerol-3-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(126633, NULL, 'G3DSA:1.50.40.10:FF:000068', NULL, NULL, 'Mitochondrial brown fat uncoupling protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(126634, NULL, 'G3DSA:2.130.10.10:FF:001869', NULL, NULL, 'AGAP011163-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(126635, NULL, 'G3DSA:3.40.50.300:FF:000431', NULL, NULL, 'Regulator of telomere elongation helicase 1', NULL, NULL, NULL, NULL, NULL, 4),
(126636, NULL, 'G3DSA:2.102.10.10:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126637, NULL, 'G3DSA:3.40.980.10:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126638, NULL, 'G3DSA:3.40.1110.10:FF:000382', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126639, NULL, 'G3DSA:2.60.40.1930:FF:000032', NULL, NULL, 'Complement component 4A (Rodgers blood group)', NULL, NULL, NULL, NULL, NULL, 4),
(126640, NULL, 'G3DSA:3.30.565.10:FF:000103', NULL, NULL, 'Sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(126641, NULL, 'G3DSA:1.20.1250.20:FF:001749', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126642, NULL, 'G3DSA:1.25.10.10:FF:001501', NULL, NULL, 'U3 small nucleolar RNA-associated protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(126643, NULL, 'G3DSA:2.40.30.30:FF:000032', NULL, NULL, 'Riboflavin kinase', NULL, NULL, NULL, NULL, NULL, 4),
(126644, NULL, 'G3DSA:2.60.40.650:FF:000016', NULL, NULL, 'Oxidoreductase molybdopterin binding', NULL, NULL, NULL, NULL, NULL, 4),
(126645, NULL, 'G3DSA:3.40.570.10:FF:000017', NULL, NULL, 'IP10440p', NULL, NULL, NULL, NULL, NULL, 4),
(126646, NULL, 'G3DSA:1.10.510.10:FF:001129', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(126647, NULL, 'G3DSA:3.40.50.1220:FF:000059', NULL, NULL, 'NAD-dependent protein deacetylase sirtuin-6 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(126648, NULL, 'G3DSA:3.10.20.870:FF:000001', NULL, NULL, 'Phospholipase A-2-activating protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(126649, NULL, 'G3DSA:3.30.1380.20:FF:000018', NULL, NULL, 'Unplaced genomic scaffold supercont1.170, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(126650, NULL, 'G3DSA:2.130.10.10:FF:001094', NULL, NULL, 'Regulator of (H+)-ATPase in vacuolar membrane', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(126651, NULL, 'G3DSA:1.20.58.60:FF:000692', NULL, NULL, 'Nesprin-1', NULL, NULL, NULL, NULL, NULL, 4),
(126652, NULL, 'G3DSA:2.60.120.200:FF:000660', NULL, NULL, 'Laminin subunit alpha 5', NULL, NULL, NULL, NULL, NULL, 4),
(126653, NULL, 'G3DSA:1.10.630.10:FF:000559', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(126654, NULL, 'G3DSA:1.10.8.10:FF:000145', NULL, NULL, 'AAA-type ATPase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(126655, NULL, 'G3DSA:3.40.1810.10:FF:000064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126656, NULL, 'G3DSA:1.10.287.110:FF:000151', NULL, NULL, 'Unplaced genomic scaffold supercont2.14, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(126657, NULL, 'G3DSA:1.20.1070.10:FF:002019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126658, NULL, 'G3DSA:3.40.50.360:FF:000050', NULL, NULL, 'NAD(P)H-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(126659, NULL, 'G3DSA:2.60.40.10:FF:001892', NULL, NULL, 'Bent, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(126660, NULL, 'G3DSA:3.30.70.330:FF:001317', NULL, NULL, 'GM11898', NULL, NULL, NULL, NULL, NULL, 4),
(126661, NULL, 'G3DSA:1.20.120.310:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126662, NULL, 'G3DSA:2.60.200.20:FF:000144', NULL, NULL, 'Transcription factor 19-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(126663, NULL, 'G3DSA:2.60.40.630:FF:000010', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(126664, NULL, 'G3DSA:1.20.120.1810:FF:000002', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(126665, NULL, 'G3DSA:3.40.1000.50:FF:000014', NULL, NULL, 'Repressor of RNA polymerase III transcription MAF1', NULL, NULL, NULL, NULL, NULL, 4),
(126666, NULL, 'G3DSA:2.60.40.10:FF:002381', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(126667, NULL, 'G3DSA:2.60.120.1560:FF:000005', NULL, NULL, 'YHR212W-A-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(126668, NULL, 'G3DSA:3.10.450.50:FF:000010', NULL, NULL, 'Ras GTPase-activating protein-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(126669, NULL, 'G3DSA:1.10.357.100:FF:000001', NULL, NULL, 'Protein transport protein TIP20', NULL, NULL, NULL, NULL, NULL, 4),
(126670, NULL, 'G3DSA:3.40.50.300:FF:007760', NULL, NULL, 'Protein CBR-RAB-30', NULL, NULL, NULL, NULL, NULL, 4),
(126671, NULL, 'G3DSA:3.30.40.10:FF:001065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126672, NULL, 'G3DSA:1.10.287.70:FF:000290', NULL, NULL, 'TWiK family of potassium channels', NULL, NULL, NULL, NULL, NULL, 4),
(126673, NULL, 'G3DSA:3.40.440.10:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126674, NULL, 'G3DSA:3.40.50.410:FF:000216', NULL, NULL, 'von Willebrand factor', NULL, NULL, NULL, NULL, NULL, 4),
(126675, NULL, 'G3DSA:1.25.40.10:FF:001312', NULL, NULL, 'RNA polymerase-associated protein CTR9', NULL, NULL, NULL, NULL, NULL, 4),
(126676, NULL, 'G3DSA:3.40.50.2300:FF:000748', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126677, NULL, 'G3DSA:3.30.479.10:FF:000009', NULL, NULL, '6-carboxy-5,6,7,8-tetrahydropterin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(126678, NULL, 'G3DSA:1.10.510.10:FF:002074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126679, NULL, 'G3DSA:3.90.190.10:FF:000477', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126680, NULL, 'G3DSA:1.20.1250.20:FF:002238', NULL, NULL, 'Solute carrier family 22 member 7b, tandem duplicate 1', NULL, NULL, NULL, NULL, NULL, 4),
(126681, NULL, 'G3DSA:1.10.510.10:FF:000612', NULL, NULL, 'Serine/threonine-protein kinase AFC2', NULL, NULL, NULL, NULL, NULL, 4),
(126682, NULL, 'G3DSA:3.30.300.320:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126683, NULL, 'G3DSA:3.40.50.150:FF:000897', NULL, NULL, 'tRNA (cytosine(38)-C(5))-methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(126684, NULL, 'G3DSA:3.40.50.150:FF:001386', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126685, NULL, 'G3DSA:3.30.160.60:FF:005056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126686, NULL, 'G3DSA:3.10.450.240:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126687, NULL, 'G3DSA:2.170.11.10:FF:000004', NULL, NULL, 'DNA topoisomerase I,-like', NULL, NULL, NULL, NULL, NULL, 4),
(126688, NULL, 'G3DSA:1.10.390.10:FF:000040', NULL, NULL, 'Aminopeptidase M1', NULL, NULL, NULL, NULL, NULL, 4),
(126689, NULL, 'G3DSA:3.40.50.300:FF:005765', NULL, NULL, 'Guanylate kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126690, NULL, 'G3DSA:4.10.240.10:FF:000001', NULL, NULL, 'Fungal specific transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126691, NULL, 'G3DSA:4.10.900.10:FF:000001', NULL, NULL, 'Cadherin 2', NULL, NULL, NULL, NULL, NULL, 4),
(126692, NULL, 'G3DSA:1.20.1070.10:FF:001502', NULL, NULL, 'MCG116182, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(126693, NULL, 'G3DSA:1.10.357.120:FF:000007', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(126694, NULL, 'G3DSA:3.90.280.10:FF:000012', NULL, NULL, 'YLR179C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(126695, NULL, 'G3DSA:1.10.510.10:FF:003338', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126696, NULL, 'G3DSA:3.30.750.24:FF:000058', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(126697, NULL, 'G3DSA:3.40.50.300:FF:006254', NULL, NULL, 'Type III restriction enzyme, res subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(126698, NULL, 'G3DSA:2.10.70.10:FF:000165', NULL, NULL, 'Complement C1r subcomponent-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(126699, NULL, 'G3DSA:2.130.10.10:FF:004612', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126700, NULL, 'G3DSA:2.60.40.10:FF:005635', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126701, NULL, 'G3DSA:3.40.50.300:FF:003865', NULL, NULL, 'Dynamin-like protein B', NULL, NULL, NULL, NULL, NULL, 4),
(126702, NULL, 'G3DSA:2.30.29.30:FF:000591', NULL, NULL, 'Ran-specific GTPase-activating protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(126703, NULL, 'G3DSA:3.40.50.720:FF:001282', NULL, NULL, 'Auxin-responsive protein', NULL, NULL, NULL, NULL, NULL, 4),
(126704, NULL, 'G3DSA:2.130.10.10:FF:003994', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(126705, NULL, 'G3DSA:2.60.40.1930:FF:000015', NULL, NULL, 'Complement C5', NULL, NULL, NULL, NULL, NULL, 4),
(126706, NULL, 'G3DSA:2.40.420.20:FF:000036', NULL, NULL, 'Hemolysin secretion protein D', NULL, NULL, NULL, NULL, NULL, 4),
(126707, NULL, 'G3DSA:2.60.40.10:FF:000256', NULL, NULL, 'myopalladin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(126708, NULL, 'G3DSA:3.40.50.10890:FF:000008', NULL, NULL, 'Cleavage and polyadenylation specificity factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126709, NULL, 'G3DSA:2.30.30.100:FF:000075', NULL, NULL, 'Small nuclear ribonucleoprotein Sm D2', NULL, NULL, NULL, NULL, NULL, 4),
(126710, NULL, 'G3DSA:3.90.226.10:FF:000297', NULL, NULL, 'Acetyl CoA carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(126711, NULL, 'G3DSA:3.40.50.720:FF:000192', NULL, NULL, 'Enoyl-[acyl-carrier-protein] reductase [NADH]', NULL, NULL, NULL, NULL, NULL, 4),
(126712, NULL, 'G3DSA:3.40.50.12710:FF:000032', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7', NULL, NULL, NULL, NULL, NULL, 4),
(126713, NULL, 'G3DSA:2.160.20.80:FF:000012', NULL, NULL, 'thylakoid lumenal protein TL20.3, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(126714, NULL, 'G3DSA:3.30.300.30:FF:000034', NULL, NULL, 'Fatty-acid-CoA ligase FadD17', NULL, NULL, NULL, NULL, NULL, 4),
(126715, NULL, 'G3DSA:1.10.390.10:FF:000068', NULL, NULL, 'Glutamyl aminopeptidase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(126716, NULL, 'G3DSA:2.60.40.1180:FF:000234', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(126717, NULL, 'G3DSA:3.30.70.80:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126718, NULL, 'G3DSA:1.10.10.60:FF:000369', NULL, NULL, 'Intestine specific homeobox', NULL, NULL, NULL, NULL, NULL, 4),
(126719, NULL, 'G3DSA:3.30.740.10:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126720, NULL, 'G3DSA:3.30.200.20:FF:001496', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(126721, NULL, 'G3DSA:3.30.420.40:FF:000102', NULL, NULL, 'Putative glycerol kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(126722, NULL, 'G3DSA:1.10.390.10:FF:000023', NULL, NULL, 'Chromosome 9 open reading frame 3', NULL, NULL, NULL, NULL, NULL, 4),
(126723, NULL, 'G3DSA:2.120.10.30:FF:000004', NULL, NULL, 'Tripartite motif containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(126724, NULL, 'G3DSA:3.30.1360.120:FF:000109', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(126725, NULL, 'G3DSA:1.20.120.1490:FF:000007', NULL, NULL, 'Periplasmic stress adaptor protein CpxP', NULL, NULL, NULL, NULL, NULL, 4),
(126726, NULL, 'G3DSA:1.10.10.10:FF:001984', NULL, NULL, 'Peroxisomal membrane protein pex14', NULL, NULL, NULL, NULL, NULL, 4),
(126727, NULL, 'G3DSA:1.20.1540.10:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126728, NULL, 'G3DSA:1.10.287.130:FF:000162', NULL, NULL, 'Two component system histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(126729, NULL, 'G3DSA:1.50.40.10:FF:000523', NULL, NULL, 'Putative mitochondrial carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(126730, NULL, 'G3DSA:3.30.360.50:FF:000004', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(126731, NULL, 'G3DSA:3.40.50.2020:FF:000081', NULL, NULL, 'Putative ribose-phosphate pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(126732, NULL, 'G3DSA:3.30.230.10:FF:000376', NULL, NULL, '40S ribosomal protein S2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126733, NULL, 'G3DSA:1.25.10.10:FF:000203', NULL, NULL, 'HEAT repeat containing 5B', NULL, NULL, NULL, NULL, NULL, 4),
(126734, NULL, 'G3DSA:1.20.1270.60:FF:000178', NULL, NULL, 'Cell division control protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126735, NULL, 'G3DSA:3.30.450.20:FF:000699', NULL, NULL, 'Methyl accepting sensory transducer with Cache_2 small molecule binding domain', NULL, NULL, NULL, NULL, NULL, 4),
(126736, NULL, 'G3DSA:3.30.870.10:FF:000115', NULL, NULL, 'Phospholipase D1', NULL, NULL, NULL, NULL, NULL, 4),
(126737, NULL, 'G3DSA:2.10.60.10:FF:000006', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(126738, NULL, 'G3DSA:1.20.5.170:FF:000066', NULL, NULL, 'DNA damage-inducible transcript 3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(126739, NULL, 'G3DSA:2.60.40.1910:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126740, NULL, 'G3DSA:2.60.40.10:FF:005152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126741, NULL, 'G3DSA:3.30.1140.32:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126742, NULL, 'G3DSA:2.60.40.4060:FF:000008', NULL, NULL, 'Defense protein l(2)34Fc', NULL, NULL, NULL, NULL, NULL, 4),
(126743, NULL, 'G3DSA:1.20.1250.20:FF:000423', NULL, NULL, 'Putative inorganic phosphate cotransporter-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(126744, NULL, 'G3DSA:2.120.10.30:FF:000105', NULL, NULL, 'Low-density lipoprotein receptor-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(126745, NULL, 'G3DSA:3.30.450.70:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126746, NULL, 'G3DSA:3.30.40.10:FF:001082', NULL, NULL, 'TRAF-type zinc finger domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(126747, NULL, 'G3DSA:1.10.132.30:FF:000003', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(126748, NULL, 'G3DSA:3.10.290.10:FF:000002', NULL, NULL, '40S ribosomal protein S4', NULL, NULL, NULL, NULL, NULL, 4),
(126749, NULL, 'G3DSA:1.10.274.30:FF:000012', NULL, NULL, 'Chromatin modification-related protein EAF3', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(126750, NULL, 'G3DSA:1.20.1250.20:FF:000895', NULL, NULL, 'YDR387C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(126751, NULL, 'G3DSA:1.20.1050.40:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126752, NULL, 'G3DSA:1.20.1270.280:FF:000032', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(126753, NULL, 'G3DSA:2.30.29.30:FF:000748', NULL, NULL, 'Rho guanine nucleotide exchange factor 25', NULL, NULL, NULL, NULL, NULL, 4),
(126754, NULL, 'G3DSA:2.60.40.4380:FF:000003', NULL, NULL, 'Carbon storage regulator', NULL, NULL, NULL, NULL, NULL, 4),
(126755, NULL, 'G3DSA:1.25.10.10:FF:000675', NULL, NULL, 'Phosphoinositide 3-kinase regulatory subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(126756, NULL, 'G3DSA:3.20.20.100:FF:000184', NULL, NULL, 'Aldo-keto reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126757, NULL, 'G3DSA:3.10.580.10:FF:000013', NULL, NULL, 'Arabinose 5-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(126758, NULL, 'G3DSA:3.30.420.110:FF:000027', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(126759, NULL, 'G3DSA:2.40.50.840:FF:000001', NULL, NULL, 'Acetyl-CoA acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(126760, NULL, 'G3DSA:2.40.50.90:FF:000118', NULL, NULL, 'Transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126761, NULL, 'G3DSA:1.10.8.270:FF:000031', NULL, NULL, 'TBC1 domain family member 5', NULL, NULL, NULL, NULL, NULL, 4),
(126762, NULL, 'G3DSA:2.30.29.30:FF:000692', NULL, NULL, 'Tectonin beta-propeller repeat-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(126763, NULL, 'G3DSA:3.40.250.10:FF:000105', NULL, NULL, 'Rodhanase family domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(126764, NULL, 'G3DSA:3.30.70.330:FF:001261', NULL, NULL, 'Nucleic acid binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126765, NULL, 'G3DSA:1.25.40.10:FF:000031', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(126766, NULL, 'G3DSA:2.10.25.10:FF:000358', NULL, NULL, 'protein HEG homolog 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(126767, NULL, 'G3DSA:2.60.40.640:FF:000131', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(126768, NULL, 'G3DSA:3.30.230.40:FF:000008', NULL, NULL, 'Imidazoleglycerol-phosphate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(126769, NULL, 'G3DSA:1.10.10.2010:FF:000001', NULL, NULL, 'Nuclear valosin-containing protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(126770, NULL, 'G3DSA:1.10.840.10:FF:000030', NULL, NULL, 'SH2 domain-containing 3Cb', NULL, NULL, NULL, NULL, NULL, 4),
(126771, NULL, 'G3DSA:3.40.850.10:FF:000207', NULL, NULL, 'Putative kinesin', NULL, NULL, NULL, NULL, NULL, 4),
(126772, NULL, 'G3DSA:3.30.930.10:FF:000317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126773, NULL, 'G3DSA:1.25.40.10:FF:001121', NULL, NULL, 'Co-chaperone YbbN', NULL, NULL, NULL, NULL, NULL, 4),
(126774, NULL, 'G3DSA:1.25.40.20:FF:000713', NULL, NULL, 'E3 ubiquitin-protein ligase KEG', NULL, NULL, NULL, NULL, NULL, 4),
(126775, NULL, 'G3DSA:1.10.418.10:FF:000122', NULL, NULL, 'Coiled-coil domain containing 88C', NULL, NULL, NULL, NULL, NULL, 4),
(126776, NULL, 'G3DSA:3.40.605.10:FF:000094', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(126777, NULL, 'G3DSA:3.30.470.20:FF:000026', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(126778, NULL, 'G3DSA:1.25.10.10:FF:001029', NULL, NULL, 'LD28549p', NULL, NULL, NULL, NULL, NULL, 4),
(126779, NULL, 'G3DSA:3.30.200.20:FF:002013', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(126780, NULL, 'G3DSA:3.60.15.10:FF:000145', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(126781, NULL, 'G3DSA:2.30.180.10:FF:000016', NULL, NULL, 'Stabilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(126782, NULL, 'G3DSA:1.10.287.370:FF:000003', NULL, NULL, 'Prefoldin subunit 6', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(126783, NULL, 'G3DSA:2.30.30.40:FF:000030', NULL, NULL, 'rho GTPase-activating protein 32 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(126784, NULL, 'G3DSA:3.30.200.20:FF:001602', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126785, NULL, 'G3DSA:3.40.50.200:FF:000047', NULL, NULL, 'Dipeptidyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(126786, NULL, 'G3DSA:2.60.40.10:FF:002510', NULL, NULL, 'SNF1 protein kinase subunit beta-1', NULL, NULL, NULL, NULL, NULL, 4),
(126787, NULL, 'G3DSA:3.40.50.2000:FF:000647', NULL, NULL, 'Glycosyl transferase, family 9', NULL, NULL, NULL, NULL, NULL, 4),
(126788, NULL, 'G3DSA:3.30.160.60:FF:000913', NULL, NULL, 'zinc finger protein 235 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(126789, NULL, 'G3DSA:2.60.40.10:FF:001993', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(126790, NULL, 'G3DSA:2.30.42.10:FF:000559', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126791, NULL, 'G3DSA:3.40.50.10190:FF:000259', NULL, NULL, 'Esc4p', NULL, NULL, NULL, NULL, NULL, 4),
(126792, NULL, 'G3DSA:3.40.50.10310:FF:000003', NULL, NULL, 'Creatinine amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(126793, NULL, 'G3DSA:3.40.50.1760:FF:000002', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(126794, NULL, 'G3DSA:3.30.930.10:FF:000160', NULL, NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(126795, NULL, 'G3DSA:3.80.10.10:FF:003382', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126796, NULL, 'G3DSA:1.25.40.10:FF:004982', NULL, NULL, 'Tetratricopeptide repeat domain 21A', NULL, NULL, NULL, NULL, NULL, 4),
(126797, NULL, 'G3DSA:2.60.40.60:FF:000810', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126798, NULL, 'G3DSA:3.40.50.300:FF:002084', NULL, NULL, 'Adenylate kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(126799, NULL, 'G3DSA:1.25.40.20:FF:000461', NULL, NULL, 'Ankyrin repeat domain-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(126800, NULL, 'G3DSA:1.20.1250.20:FF:001249', NULL, NULL, 'Sugar transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126801, NULL, 'G3DSA:3.30.160.60:FF:003786', NULL, NULL, 'Transcription factor IIIA', NULL, NULL, NULL, NULL, NULL, 4),
(126802, NULL, 'G3DSA:3.60.10.10:FF:000038', NULL, NULL, 'type IV inositol polyphosphate 5-phosphatase 3', NULL, NULL, NULL, NULL, NULL, 4),
(126803, NULL, 'G3DSA:3.40.50.880:FF:000099', NULL, NULL, 'Para-aminobenzoate synthase PabaA', NULL, NULL, NULL, NULL, NULL, 4),
(126804, NULL, 'G3DSA:2.10.25.10:FF:000667', NULL, NULL, 'Delta/notch like EGF repeat containing', NULL, NULL, NULL, NULL, NULL, 4),
(126805, NULL, 'G3DSA:3.40.50.10330:FF:000009', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(126806, NULL, 'G3DSA:3.30.70.270:FF:000304', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126807, NULL, 'G3DSA:2.40.50.90:FF:000017', NULL, NULL, 'Ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(126808, NULL, 'G3DSA:2.40.20.10:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126809, NULL, 'G3DSA:1.25.10.10:FF:000776', NULL, NULL, 'TORC1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(126810, NULL, 'G3DSA:3.30.70.1230:FF:000161', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(126811, NULL, 'G3DSA:1.10.287.70:FF:000739', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126812, NULL, 'G3DSA:3.40.50.300:FF:002128', NULL, NULL, 'AAA family ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126813, NULL, 'G3DSA:2.60.120.10:FF:000444', NULL, NULL, 'Germin-like protein subfamily 1 member 13', NULL, NULL, NULL, NULL, NULL, 4),
(126814, NULL, 'G3DSA:3.30.160.60:FF:005848', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126815, NULL, 'G3DSA:1.25.40.180:FF:000178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126816, NULL, 'G3DSA:3.20.70.20:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(126817, NULL, 'G3DSA:2.20.25.80:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126818, NULL, 'G3DSA:3.90.190.10:FF:000246', NULL, NULL, 'Protein CBG22522', NULL, NULL, NULL, NULL, NULL, 4),
(126819, NULL, 'G3DSA:3.30.160.60:FF:004404', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126820, NULL, 'G3DSA:1.25.40.20:FF:001539', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(126821, NULL, 'G3DSA:2.60.120.200:FF:000525', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(126822, NULL, 'G3DSA:2.130.10.10:FF:000560', NULL, NULL, 'LLGL scribble cell polarity complex component 1', NULL, NULL, NULL, NULL, NULL, 4),
(126823, NULL, 'G3DSA:3.40.50.300:FF:004146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126824, NULL, 'G3DSA:3.30.200.20:FF:000776', NULL, NULL, 'Flk-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(126825, NULL, 'G3DSA:2.40.30.10:FF:000037', NULL, NULL, 'Sulfite reductase flavoprotein component', NULL, NULL, NULL, NULL, NULL, 4),
(126826, NULL, 'G3DSA:3.40.50.300:FF:002437', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(126827, NULL, 'G3DSA:3.30.70.1130:FF:000001', NULL, NULL, 'Eukaryotic translation initiation factor 2 subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(126828, NULL, 'G3DSA:1.20.1250.10:FF:000111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126829, NULL, 'G3DSA:3.40.1110.10:FF:000252', NULL, NULL, 'ATPase 2 plasma membrane-type', NULL, NULL, NULL, NULL, NULL, 4),
(126830, NULL, 'G3DSA:1.25.40.20:FF:000814', NULL, NULL, 'Os09g0331600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(126831, NULL, 'G3DSA:1.20.1050.20:FF:000003', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(126832, NULL, 'G3DSA:2.120.10.30:FF:000313', NULL, NULL, 'SMP-30/gluconolactonase/LRE family protein', NULL, NULL, NULL, NULL, NULL, 4),
(126833, NULL, 'G3DSA:3.30.40.10:FF:000929', NULL, NULL, 'GM23514', NULL, NULL, NULL, NULL, NULL, 4),
(126834, NULL, 'G3DSA:2.30.42.40:FF:000001', NULL, NULL, 'Trafficking protein particle complex 4', NULL, NULL, NULL, NULL, NULL, 4),
(126835, NULL, 'G3DSA:1.25.40.610:FF:000009', NULL, NULL, 'Adhesion G protein-coupled receptor L3', NULL, NULL, NULL, NULL, NULL, 4),
(126836, NULL, 'G3DSA:3.90.1070.20:FF:000009', NULL, NULL, 'Polymerase (RNA) II (DNA directed) polypeptide B', NULL, NULL, NULL, NULL, NULL, 4),
(126837, NULL, 'G3DSA:3.90.70.80:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126838, NULL, 'G3DSA:4.10.960.10:FF:000005', NULL, NULL, '60S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(126839, NULL, 'G3DSA:2.130.10.10:FF:005231', NULL, NULL, 'WD-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126840, NULL, 'G3DSA:1.10.3500.10:FF:000038', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(126841, NULL, 'G3DSA:2.60.40.1120:FF:000014', NULL, NULL, 'Carboxypeptidase M', NULL, NULL, NULL, NULL, NULL, 4),
(126842, NULL, 'G3DSA:1.10.150.20:FF:000031', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(126843, NULL, 'G3DSA:3.40.50.720:FF:000293', NULL, NULL, 'NADPH-dependent F420 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(126844, NULL, 'G3DSA:1.20.1250.20:FF:000631', NULL, NULL, 'Predicted arabinose efflux permease, MFS family', NULL, NULL, NULL, NULL, NULL, 4),
(126845, NULL, 'G3DSA:2.130.10.10:FF:004983', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126846, NULL, 'G3DSA:1.20.20.10:FF:000017', NULL, NULL, 'ATP synthase subunit c', NULL, NULL, NULL, NULL, NULL, 4),
(126847, NULL, 'G3DSA:2.60.120.480:FF:000002', NULL, NULL, 'Probable ureidoglycolate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(126848, NULL, 'G3DSA:2.130.10.10:FF:005601', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126849, NULL, 'G3DSA:1.10.10.10:FF:000040', NULL, NULL, 'segment polarity protein dishevelled homolog DVL-3', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(126850, NULL, 'G3DSA:3.40.1190.20:FF:000131', NULL, NULL, 'Ribokinase', NULL, NULL, NULL, NULL, NULL, 4),
(126851, NULL, 'G3DSA:3.30.710.10:FF:000306', NULL, NULL, 'Putative skp1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(126852, NULL, 'G3DSA:3.30.160.60:FF:004859', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126853, NULL, 'G3DSA:1.20.120.1080:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126854, NULL, 'G3DSA:3.90.550.10:FF:000229', NULL, NULL, 'Glycosyltransferase-like protein LARGE', NULL, NULL, NULL, NULL, NULL, 4),
(126855, NULL, 'G3DSA:4.10.1130.20:FF:000004', NULL, NULL, 'integrin beta-1-binding protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(126856, NULL, 'G3DSA:1.10.486.10:FF:000009', NULL, NULL, 'ATP-dependent helicase/nuclease subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(126857, NULL, 'G3DSA:3.50.50.60:FF:001282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126858, NULL, 'G3DSA:3.40.1160.10:FF:000093', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(126859, NULL, 'G3DSA:3.30.70.270:FF:000293', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126860, NULL, 'G3DSA:1.10.510.10:FF:000157', NULL, NULL, 'Ribosomal protein S6 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(126861, NULL, 'G3DSA:2.20.25.190:FF:000004', NULL, NULL, 'Transcription elongation factor 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(126862, NULL, 'G3DSA:3.40.50.300:FF:007991', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126863, NULL, 'G3DSA:3.90.660.10:FF:000013', NULL, NULL, 'Renalase isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(126864, NULL, 'G3DSA:1.25.40.20:FF:000505', NULL, NULL, 'Regulatory protein NPR3', NULL, NULL, NULL, NULL, NULL, 4),
(126865, NULL, 'G3DSA:2.70.98.70:FF:000002', NULL, NULL, 'Heparin and heparin-sulfate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(126866, NULL, 'G3DSA:1.20.1250.20:FF:001148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126867, NULL, 'G3DSA:3.30.200.20:FF:002221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126868, NULL, 'G3DSA:3.40.395.10:FF:000003', NULL, NULL, 'Sentrin-specific protease 8', NULL, NULL, NULL, NULL, NULL, 4),
(126869, NULL, 'G3DSA:2.70.170.10:FF:000102', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(126870, NULL, 'G3DSA:1.20.1740.10:FF:000177', NULL, NULL, 'Solute carrier family 12 member 8', NULL, NULL, NULL, NULL, NULL, 4),
(126871, NULL, 'G3DSA:2.10.210.10:FF:000001', NULL, NULL, 'Cytochrome b-c1 complex subunit Rieske, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(126872, NULL, 'G3DSA:3.40.50.1820:FF:000823', NULL, NULL, 'Protein CBG23034', NULL, NULL, NULL, NULL, NULL, 4),
(126873, NULL, 'G3DSA:2.60.200.40:FF:000021', NULL, NULL, 'Diacylglycerol kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(126874, NULL, 'G3DSA:1.20.80.60:FF:000002', NULL, NULL, 'sorting nexin-27 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(126875, NULL, 'G3DSA:2.40.170.20:FF:000027', NULL, NULL, 'Heme transport protein HutA', NULL, NULL, NULL, NULL, NULL, 4),
(126876, NULL, 'G3DSA:3.40.50.300:FF:001611', NULL, NULL, 'Probable GTP-binding protein EngB', NULL, NULL, NULL, NULL, NULL, 4),
(126877, NULL, 'G3DSA:3.40.30.10:FF:000187', NULL, NULL, 'Thiol:disulfide interchange protein', NULL, NULL, NULL, NULL, NULL, 4),
(126878, NULL, 'G3DSA:1.20.1070.10:FF:000529', NULL, NULL, 'Si:ch211-240b21.4', NULL, NULL, NULL, NULL, NULL, 4),
(126879, NULL, 'G3DSA:2.60.40.10:FF:004308', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126880, NULL, 'G3DSA:1.20.1730.10:FF:000092', NULL, NULL, 'Solute carrier family 5 member 7', NULL, NULL, NULL, NULL, NULL, 4),
(126881, NULL, 'G3DSA:1.20.58.60:FF:000248', NULL, NULL, 'Synaptic nuclear envelope 1', NULL, NULL, NULL, NULL, NULL, 4),
(126882, NULL, 'G3DSA:2.10.80.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126883, NULL, 'G3DSA:3.40.50.300:FF:000094', NULL, NULL, 'GTPase Era', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(126884, NULL, 'G3DSA:2.10.25.10:FF:000459', NULL, NULL, 'Axotactin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(126885, NULL, 'G3DSA:3.40.430.10:FF:000007', NULL, NULL, 'Bifunctional dihydrofolate reductase-thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(126886, NULL, 'G3DSA:1.25.40.420:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126887, NULL, 'G3DSA:2.60.120.200:FF:000789', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(126888, NULL, 'G3DSA:3.30.70.870:FF:000012', NULL, NULL, 'Elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(126889, NULL, 'G3DSA:2.60.120.10:FF:000236', NULL, NULL, 'Uncharacterized NTE family protein ZK370.4', NULL, NULL, NULL, NULL, NULL, 4),
(126890, NULL, 'G3DSA:3.20.20.380:FF:000003', NULL, NULL, 'Copper homeostasis protein CutC', NULL, NULL, NULL, NULL, NULL, 4),
(126891, NULL, 'G3DSA:1.25.10.10:FF:000984', NULL, NULL, 'U-box domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(126892, NULL, 'G3DSA:3.30.70.330:FF:002380', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126893, NULL, 'G3DSA:1.20.58.60:FF:000591', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(126894, NULL, 'G3DSA:3.30.1360.140:FF:000003', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(126895, NULL, 'G3DSA:1.20.1070.10:FF:000468', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126896, NULL, 'G3DSA:2.30.33.40:FF:000019', NULL, NULL, 'Co-chaperonin GroES', NULL, NULL, NULL, NULL, NULL, 4),
(126897, NULL, 'G3DSA:1.25.40.20:FF:000005', NULL, NULL, 'Neurogenic locus notch 1', NULL, NULL, NULL, NULL, NULL, 4),
(126898, NULL, 'G3DSA:3.10.110.10:FF:000338', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 D/E', NULL, NULL, NULL, NULL, NULL, 4),
(126899, NULL, 'G3DSA:3.40.50.150:FF:000217', NULL, NULL, 'Methyltransferase protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(126900, NULL, 'G3DSA:3.20.20.300:FF:000036', NULL, NULL, 'Beta-N-acetylglucosaminidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126901, NULL, 'G3DSA:3.40.50.300:FF:000330', NULL, NULL, 'Septum-promoting GTP-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(126902, NULL, 'G3DSA:3.40.50.150:FF:000689', NULL, NULL, '4-dimethylallyltryptophan N-methyltransferase easF', NULL, NULL, NULL, NULL, NULL, 4),
(126903, NULL, 'G3DSA:1.10.20.10:FF:000321', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126904, NULL, 'G3DSA:2.60.120.200:FF:000317', NULL, NULL, 'Drosophila CRumBs homolog', NULL, NULL, NULL, NULL, NULL, 4),
(126905, NULL, 'G3DSA:2.40.10.10:FF:000710', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126906, NULL, 'G3DSA:1.20.5.1930:FF:000013', NULL, NULL, 'Sensory box histidine kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126907, NULL, 'G3DSA:3.50.50.60:FF:000663', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(126908, NULL, 'G3DSA:3.30.160.60:FF:003578', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126909, NULL, 'G3DSA:1.25.40.10:FF:005027', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(126910, NULL, 'G3DSA:1.20.58.1540:FF:000003', NULL, NULL, 'Bud site selection protein', NULL, NULL, NULL, NULL, NULL, 4),
(126911, NULL, 'G3DSA:3.80.10.10:FF:003073', NULL, NULL, 'Os12g0157550 protein', NULL, NULL, NULL, NULL, NULL, 4),
(126912, NULL, 'G3DSA:3.40.640.10:FF:000141', NULL, NULL, 'Glutamate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(126913, NULL, 'G3DSA:2.60.40.10:FF:003370', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(126914, NULL, 'G3DSA:3.30.200.20:FF:001041', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(126915, NULL, 'G3DSA:3.30.160.60:FF:001678', NULL, NULL, 'Zinc finger protein rotund', NULL, NULL, NULL, NULL, NULL, 4),
(126916, NULL, 'G3DSA:2.60.40.60:FF:000046', NULL, NULL, 'Protocadherin beta 5', NULL, NULL, NULL, NULL, NULL, 4),
(126917, NULL, 'G3DSA:2.60.40.150:FF:000400', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(126918, NULL, 'G3DSA:3.10.580.10:FF:000221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126919, NULL, 'G3DSA:1.20.140.150:FF:000030', NULL, NULL, 'lens fiber membrane intrinsic protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(126920, NULL, 'G3DSA:1.10.510.10:FF:003810', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126921, NULL, 'G3DSA:3.40.710.10:FF:000124', NULL, NULL, 'Uncharacterized protein MT1414', NULL, NULL, NULL, NULL, NULL, 4),
(126922, NULL, 'G3DSA:2.40.50.100:FF:000133', NULL, NULL, 'Sodium:proton antiporter', NULL, NULL, NULL, NULL, NULL, 4),
(126923, NULL, 'G3DSA:1.25.10.10:FF:003390', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126924, NULL, 'G3DSA:3.60.120.10:FF:000007', NULL, NULL, 'Salicylate synthase Irp9', NULL, NULL, NULL, NULL, NULL, 4),
(126925, NULL, 'G3DSA:1.20.58.340:FF:000010', NULL, NULL, 'Magnesium transporter MRS2-I', NULL, NULL, NULL, NULL, NULL, 4),
(126926, NULL, 'G3DSA:3.30.160.60:FF:005573', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126927, NULL, 'G3DSA:3.30.30.30:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126928, NULL, 'G3DSA:3.90.800.10:FF:000002', NULL, NULL, 'Glutamine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(126929, NULL, 'G3DSA:3.40.720.10:FF:000097', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(126930, NULL, 'G3DSA:3.30.160.150:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126931, NULL, 'G3DSA:3.40.50.720:FF:000545', NULL, NULL, 'Dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126932, NULL, 'G3DSA:2.30.30.1020:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126933, NULL, 'G3DSA:3.30.1490.190:FF:000024', NULL, NULL, 'Ferric uptake regulator, Fur family', NULL, NULL, NULL, NULL, NULL, 4),
(126934, NULL, 'G3DSA:1.25.10.10:FF:001395', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126935, NULL, 'G3DSA:2.20.70.10:FF:000102', NULL, NULL, 'Pre-mRNA-processing factor 40 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(126936, NULL, 'G3DSA:1.20.1250.20:FF:001957', NULL, NULL, 'Facilitated trehalose transporter Tret1-2 homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(126937, NULL, 'G3DSA:3.30.710.10:FF:000194', NULL, NULL, 'Os12g0595600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(126938, NULL, 'G3DSA:1.10.472.80:FF:000162', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126939, NULL, 'G3DSA:1.10.8.60:FF:000149', NULL, NULL, 'AAA family ATPase/60S ribosome export protein Rix7', NULL, NULL, NULL, NULL, NULL, 4),
(126940, NULL, 'G3DSA:3.80.10.10:FF:001173', NULL, NULL, 'Si:ch211-213a13.2', NULL, NULL, NULL, NULL, NULL, 4),
(126941, NULL, 'G3DSA:1.10.238.10:FF:000788', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(126942, NULL, 'G3DSA:3.30.1370.30:FF:000004', NULL, NULL, '30S ribosomal protein S8, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(126943, NULL, 'G3DSA:2.20.100.10:FF:000103', NULL, NULL, 'SCO-spondin', NULL, NULL, NULL, NULL, NULL, 4),
(126944, NULL, 'G3DSA:3.80.10.10:FF:004354', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126945, NULL, 'G3DSA:2.30.30.50:FF:000004', NULL, NULL, 'Cobalt-containing nitrile hydratase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(126946, NULL, 'G3DSA:1.20.58.60:FF:000748', NULL, NULL, 'Spectrin, beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(126947, NULL, 'G3DSA:1.25.40.10:FF:003127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126948, NULL, 'G3DSA:3.60.10.10:FF:000139', NULL, NULL, 'Type II inositol-1-1,4,5-trisphosphate 5-phosphatase rlated, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126949, NULL, 'G3DSA:3.30.70.60:FF:000047', NULL, NULL, 'Fimbrial assembly membrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126950, NULL, 'G3DSA:1.20.1330.10:FF:000011', NULL, NULL, 'Flagellin', NULL, NULL, NULL, NULL, NULL, 4),
(126951, NULL, 'G3DSA:1.25.40.20:FF:000152', NULL, NULL, 'neurogenic locus notch homolog protein 4', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(126952, NULL, 'G3DSA:3.80.10.10:FF:001948', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(126953, NULL, 'G3DSA:1.10.10.880:FF:000004', NULL, NULL, 'Anti-sigma-E factor RseA', NULL, NULL, NULL, NULL, NULL, 4),
(126954, NULL, 'G3DSA:3.40.50.300:FF:007108', NULL, NULL, 'Small GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126955, NULL, 'G3DSA:3.20.20.80:FF:000308', NULL, NULL, 'Glycoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(126956, NULL, 'G3DSA:3.40.50.1820:FF:001015', NULL, NULL, 'Lecithin-cholesterol acyltransferase-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(126957, NULL, 'G3DSA:3.40.50.1000:FF:000595', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126958, NULL, 'G3DSA:1.10.287.70:FF:000391', NULL, NULL, 'Potassium channel, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126959, NULL, 'G3DSA:3.10.105.10:FF:000096', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(126960, NULL, 'G3DSA:1.10.555.10:FF:000238', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126961, NULL, 'G3DSA:3.40.50.2300:FF:000956', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126962, NULL, 'G3DSA:3.50.50.60:FF:001074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126963, NULL, 'G3DSA:3.30.1490.20:FF:000010', NULL, NULL, 'Phosphoenolpyruvate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(126964, NULL, 'G3DSA:3.30.40.10:FF:002054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126965, NULL, 'G3DSA:3.30.572.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126966, NULL, 'G3DSA:1.20.1250.20:FF:000529', NULL, NULL, 'Membrane transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(126967, NULL, 'G3DSA:3.40.50.1460:FF:000002', NULL, NULL, 'GPI-anchor transamidase', NULL, NULL, NULL, NULL, NULL, 4),
(126968, NULL, 'G3DSA:3.20.20.80:FF:000617', NULL, NULL, 'Glucosylceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(126969, NULL, 'G3DSA:3.60.40.10:FF:000175', NULL, NULL, 'Protein phosphatase 2C', NULL, NULL, NULL, NULL, NULL, 4),
(126970, NULL, 'G3DSA:3.30.70.890:FF:000018', NULL, NULL, 'Phosphomevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(126971, NULL, 'G3DSA:3.40.50.150:FF:000116', NULL, NULL, 'probable protein arginine N-methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(126972, NULL, 'G3DSA:2.130.10.10:FF:001285', NULL, NULL, 'Transducin beta-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(126973, NULL, 'G3DSA:1.10.510.10:FF:001085', NULL, NULL, 'Serine/threonine-protein kinase NIM1', NULL, NULL, NULL, NULL, NULL, 4),
(126974, NULL, 'G3DSA:1.10.287.600:FF:000011', NULL, NULL, 'Tubulin gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(126975, NULL, 'G3DSA:3.30.200.20:FF:002322', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126976, NULL, 'G3DSA:3.30.50.10:FF:000183', NULL, NULL, 'Protein CBG24391', NULL, NULL, NULL, NULL, NULL, 4),
(126977, NULL, 'G3DSA:1.25.10.10:FF:002884', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126978, NULL, 'G3DSA:3.10.20.90:FF:000031', NULL, NULL, 'Partitioning defective 6 homolog alpha', NULL, NULL, NULL, NULL, NULL, 4),
(126979, NULL, 'G3DSA:1.10.510.10:FF:000820', NULL, NULL, 'ULK/ULK protein kinase, variant 1', NULL, NULL, NULL, NULL, NULL, 4),
(126980, NULL, 'G3DSA:3.40.630.30:FF:000062', NULL, NULL, 'Nucleoside diphosphate-linked moiety X motif 6', NULL, NULL, NULL, NULL, NULL, 4),
(126981, NULL, 'G3DSA:1.10.510.10:FF:001910', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126982, NULL, 'G3DSA:3.40.50.300:FF:005973', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(126983, NULL, 'G3DSA:2.60.40.10:FF:001318', NULL, NULL, 'T cell receptor alpha constant', NULL, NULL, NULL, NULL, NULL, 4),
(126984, NULL, 'G3DSA:3.30.160.60:FF:006192', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126985, NULL, 'G3DSA:2.10.25.10:FF:001639', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(126986, NULL, 'G3DSA:1.25.40.10:FF:004555', NULL, NULL, 'Os11g0266800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(126987, NULL, 'G3DSA:3.40.1190.20:FF:000176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126988, NULL, 'G3DSA:1.10.630.10:FF:000284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126989, NULL, 'G3DSA:4.10.400.10:FF:000300', NULL, NULL, 'low-density lipoprotein receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(126990, NULL, 'G3DSA:3.30.70.270:FF:000192', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126991, NULL, 'G3DSA:1.25.40.1040:FF:000062', NULL, NULL, 'AGAP003595-PA', NULL, NULL, NULL, NULL, NULL, 4),
(126992, NULL, 'G3DSA:2.30.29.30:FF:000383', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(126993, NULL, 'G3DSA:3.50.50.60:FF:001383', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126994, NULL, 'G3DSA:2.60.40.10:FF:002190', NULL, NULL, 'Mesocentin', NULL, NULL, NULL, NULL, NULL, 4),
(126995, NULL, 'G3DSA:2.60.40.200:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(126996, NULL, 'G3DSA:1.20.142.10:FF:000029', NULL, NULL, 'Poly (ADP-ribose) polymerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(126997, NULL, 'G3DSA:3.30.160.60:FF:004292', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(126998, NULL, 'G3DSA:1.10.287.70:FF:000082', NULL, NULL, 'Cytochrome c oxidase subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(126999, NULL, 'G3DSA:2.20.110.10:FF:000031', NULL, NULL, 'Phosphatidylinositol 4-phosphate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(127000, NULL, 'G3DSA:3.40.47.10:FF:000298', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127001, NULL, 'G3DSA:2.30.42.10:FF:000458', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127002, NULL, 'G3DSA:3.30.160.60:FF:005264', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127003, NULL, 'G3DSA:3.40.50.300:FF:001156', NULL, NULL, 'Polynucleotide 5-hydroxyl-kinase grc3', NULL, NULL, NULL, NULL, NULL, 4),
(127004, NULL, 'G3DSA:2.80.10.50:FF:000018', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(127005, NULL, 'G3DSA:3.30.420.390:FF:000004', NULL, NULL, 'DNA polymerase subunit gamma-1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(127006, NULL, 'G3DSA:1.20.120.1240:FF:000062', NULL, NULL, 'Interferon-induced GTP-binding protein Mx1', NULL, NULL, NULL, NULL, NULL, 4),
(127007, NULL, 'G3DSA:3.40.50.1110:FF:000173', NULL, NULL, 'Phospholipase B1', NULL, NULL, NULL, NULL, NULL, 4),
(127008, NULL, 'G3DSA:2.60.40.10:FF:002965', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127009, NULL, 'G3DSA:3.90.70.10:FF:000799', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(127010, NULL, 'G3DSA:1.25.40.10:FF:002301', NULL, NULL, 'OSJNBb0012E08.2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(127011, NULL, 'G3DSA:2.40.30.130:FF:000020', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(127012, NULL, 'G3DSA:3.40.50.300:FF:003056', NULL, NULL, 'Nucleotide binding protein 2 putative', NULL, NULL, NULL, NULL, NULL, 4),
(127013, NULL, 'G3DSA:3.30.70.330:FF:002941', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127014, NULL, 'G3DSA:3.40.190.10:FF:000151', NULL, NULL, 'Phosphate ABC transporter periplasmic phosphate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(127015, NULL, 'G3DSA:1.10.1420.10:FF:000172', NULL, NULL, 'Mismatch repair protein MSH5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(127016, NULL, 'G3DSA:3.40.50.10470:FF:000012', NULL, NULL, 'Eukaryotic translation initiation factor 2B, subunit 2 beta', NULL, NULL, NULL, NULL, NULL, 4),
(127017, NULL, 'G3DSA:1.25.40.20:FF:001433', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127018, NULL, 'G3DSA:2.60.40.10:FF:001684', NULL, NULL, 'Terribly reduced optic lobes, isoform BA', NULL, NULL, NULL, NULL, NULL, 4),
(127019, NULL, 'G3DSA:1.10.510.10:FF:002265', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(127020, NULL, 'G3DSA:2.60.120.920:FF:000078', NULL, NULL, 'GD12021', NULL, NULL, NULL, NULL, NULL, 4),
(127021, NULL, 'G3DSA:3.90.245.10:FF:000003', NULL, NULL, 'Pyrimidine-specific ribonucleoside hydrolase RihB', NULL, NULL, NULL, NULL, NULL, 4),
(127022, NULL, 'G3DSA:3.30.160.60:FF:003364', NULL, NULL, 'Zinc finger protein 860', NULL, NULL, NULL, NULL, NULL, 4),
(127023, NULL, 'G3DSA:3.90.640.10:FF:000259', NULL, NULL, 'Actin-17', NULL, NULL, NULL, NULL, NULL, 4),
(127024, NULL, 'G3DSA:2.180.10.10:FF:000035', NULL, NULL, 'Teneurin-4', NULL, NULL, NULL, NULL, NULL, 4),
(127025, NULL, 'G3DSA:3.80.10.10:FF:000459', NULL, NULL, 'Leucine-rich repeat-containing protein 45', NULL, NULL, NULL, NULL, NULL, 4),
(127026, NULL, 'G3DSA:4.10.280.10:FF:000110', NULL, NULL, 'Aspartyl-phosphate phosphatase Spo0E', NULL, NULL, NULL, NULL, NULL, 4),
(127027, NULL, 'G3DSA:1.10.10.60:FF:000094', NULL, NULL, 'Homeobox protein Hox-A3', NULL, NULL, NULL, NULL, NULL, 4),
(127028, NULL, 'G3DSA:3.10.300.10:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127029, NULL, 'G3DSA:1.10.472.10:FF:000478', NULL, NULL, 'Cyclin-F', NULL, NULL, NULL, NULL, NULL, 4),
(127030, NULL, 'G3DSA:3.20.20.330:FF:000005', NULL, NULL, 'AdoMet-homocysteine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(127031, NULL, 'G3DSA:3.30.420.10:FF:000661', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127032, NULL, 'G3DSA:3.30.60.30:FF:000015', NULL, NULL, 'Transmembrane agrin', NULL, NULL, NULL, NULL, NULL, 4),
(127033, NULL, 'G3DSA:1.50.10.10:FF:000111', NULL, NULL, 'lanC-like protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(127034, NULL, 'G3DSA:2.70.170.10:FF:000208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127035, NULL, 'G3DSA:1.25.40.10:FF:004510', NULL, NULL, 'Protein NPGR1', NULL, NULL, NULL, NULL, NULL, 4),
(127036, NULL, 'G3DSA:2.60.40.10:FF:005736', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127037, NULL, 'G3DSA:2.130.10.10:FF:004511', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127038, NULL, 'G3DSA:1.20.920.10:FF:000006', NULL, NULL, 'protein polybromo-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(127039, NULL, 'G3DSA:1.50.10.10:FF:000009', NULL, NULL, 'mannosyl-oligosaccharide glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(127040, NULL, 'G3DSA:2.60.200.30:FF:000029', NULL, NULL, 'NAD kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(127041, NULL, 'G3DSA:3.20.20.140:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127042, NULL, 'G3DSA:3.20.20.80:FF:000764', NULL, NULL, 'Beta-glucosidase 32', NULL, NULL, NULL, NULL, NULL, 4),
(127043, NULL, 'G3DSA:1.10.730.10:FF:000140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127044, NULL, 'G3DSA:3.30.420.10:FF:000559', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127045, NULL, 'G3DSA:1.10.287.160:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127046, NULL, 'G3DSA:2.60.40.790:FF:000125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127047, NULL, 'G3DSA:1.25.40.10:FF:005174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127048, NULL, 'G3DSA:3.40.720.10:FF:000209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127049, NULL, 'G3DSA:3.40.605.10:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127050, NULL, 'G3DSA:2.130.10.10:FF:005337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127051, NULL, 'G3DSA:1.10.8.720:FF:000065', NULL, NULL, 'Dynein heavy chain 9', NULL, NULL, NULL, NULL, NULL, 4),
(127052, NULL, 'G3DSA:3.40.50.12660:FF:000011', NULL, NULL, 'Putative metacaspase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(127053, NULL, 'G3DSA:3.60.21.10:FF:000058', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(127054, NULL, 'G3DSA:3.40.30.10:FF:001159', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(127055, NULL, 'G3DSA:2.20.25.10:FF:000009', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(127056, NULL, 'G3DSA:3.90.370.10:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127057, NULL, 'G3DSA:3.30.70.330:FF:003009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127058, NULL, 'G3DSA:3.40.50.2000:FF:000439', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(127059, NULL, 'G3DSA:3.30.70.100:FF:000040', NULL, NULL, 'Stress-response A/B barrel domain-containing protein HS1', NULL, NULL, NULL, NULL, NULL, 4),
(127060, NULL, 'G3DSA:2.60.220.50:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127061, NULL, 'G3DSA:2.10.50.10:FF:000091', NULL, NULL, 'EPH receptor B6', NULL, NULL, NULL, NULL, NULL, 4),
(127062, NULL, 'G3DSA:3.60.20.10:FF:000067', NULL, NULL, 'Glutamine-fructose-6-phosphate transaminase (Isomerizing)', NULL, NULL, NULL, NULL, NULL, 4),
(127063, NULL, 'G3DSA:3.40.50.2300:FF:001575', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127064, NULL, 'G3DSA:3.30.465.10:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127065, NULL, 'G3DSA:3.30.460.10:FF:000213', NULL, NULL, 'U Six snRNA Interacting Protein', NULL, NULL, NULL, NULL, NULL, 4),
(127066, NULL, 'G3DSA:3.40.50.720:FF:001473', NULL, NULL, 'Hypothetical pyrroline-5-carboxylate reductase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(127067, NULL, 'G3DSA:1.20.5.340:FF:000033', NULL, NULL, 'Stromal interaction molecule', NULL, NULL, NULL, NULL, NULL, 4),
(127068, NULL, 'G3DSA:2.60.40.1730:FF:000091', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127069, NULL, 'G3DSA:1.10.472.80:FF:000015', NULL, NULL, 'TBC domain-containing protein kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(127070, NULL, 'G3DSA:3.80.10.10:FF:002454', NULL, NULL, 'Leucine-rich repeat-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(127071, NULL, 'G3DSA:3.80.10.10:FF:000768', NULL, NULL, 'Toll-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(127072, NULL, 'G3DSA:2.130.10.10:FF:002050', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(127073, NULL, 'G3DSA:2.130.10.10:FF:005028', NULL, NULL, 'DNA damage-binding protein CMR1', NULL, NULL, NULL, NULL, NULL, 4),
(127074, NULL, 'G3DSA:3.30.40.10:FF:001435', NULL, NULL, 'TNF receptor-associated factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(127075, NULL, 'G3DSA:3.30.160.60:FF:000705', NULL, NULL, 'zinc finger protein 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(127076, NULL, 'G3DSA:3.40.50.1010:FF:000244', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127077, NULL, 'G3DSA:1.20.890.10:FF:000008', NULL, NULL, 'Nucleoside diphosphate kinase homolog 5', NULL, NULL, NULL, NULL, NULL, 4),
(127078, NULL, 'G3DSA:2.60.200.10:FF:000023', NULL, NULL, 'Interferon regulatory factor 4a', NULL, NULL, NULL, NULL, NULL, 4),
(127079, NULL, 'G3DSA:1.20.58.60:FF:000703', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127080, NULL, 'G3DSA:3.40.50.1110:FF:000026', NULL, NULL, 'GDSL esterase/lipase At3g14220', NULL, NULL, NULL, NULL, NULL, 4),
(127081, NULL, 'G3DSA:3.30.70.260:FF:000094', NULL, NULL, 'Homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(127082, NULL, 'G3DSA:3.40.30.10:FF:000642', NULL, NULL, 'Glutaredoxin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(127083, NULL, 'G3DSA:3.30.720.200:FF:000004', NULL, NULL, 'Glycyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(127084, NULL, 'G3DSA:2.60.120.10:FF:000545', NULL, NULL, 'uncharacterized protein LOC100180193 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(127085, NULL, 'G3DSA:1.20.1070.10:FF:001182', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(127086, NULL, 'G3DSA:1.20.1070.10:FF:001957', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127087, NULL, 'G3DSA:1.10.720.30:FF:000061', NULL, NULL, '3''-5'' exoribonuclease 1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(127088, NULL, 'G3DSA:3.40.50.2000:FF:000748', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127089, NULL, 'G3DSA:3.90.228.10:FF:000020', NULL, NULL, 'Zinc finger CCCH-type containing, antiviral 1', NULL, NULL, NULL, NULL, NULL, 4),
(127090, NULL, 'G3DSA:1.10.287.70:FF:000638', NULL, NULL, 'AGAP010806-PA', NULL, NULL, NULL, NULL, NULL, 4),
(127091, NULL, 'G3DSA:3.30.160.60:FF:004320', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127092, NULL, 'G3DSA:3.30.1140.60:FF:000024', NULL, NULL, 'F-actin-capping protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(127093, NULL, 'G3DSA:2.130.10.10:FF:004848', NULL, NULL, 'Protein SLOW WALKER 1', NULL, NULL, NULL, NULL, NULL, 4),
(127094, NULL, 'G3DSA:1.25.40.180:FF:000138', NULL, NULL, 'Nuclear cap-binding protein subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(127095, NULL, 'G3DSA:3.30.980.10:FF:000005', NULL, NULL, 'Threonyl-tRNA synthetase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(127096, NULL, 'G3DSA:1.10.8.60:FF:000126', NULL, NULL, 'Vacuolar protein sorting-associated protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(127097, NULL, 'G3DSA:3.40.50.300:FF:005181', NULL, NULL, 'ATP-dependent dethiobiotin synthetase BioD', NULL, NULL, NULL, NULL, NULL, 4),
(127098, NULL, 'G3DSA:3.40.50.620:FF:000864', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(127099, NULL, 'G3DSA:2.40.30.170:FF:000009', NULL, NULL, 'Efflux transporter, RND family, MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(127100, NULL, 'G3DSA:1.25.40.10:FF:004639', NULL, NULL, '40 kDa peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(127101, NULL, 'G3DSA:3.30.70.1230:FF:000121', NULL, NULL, 'Adenylate/guanylate cyclase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(127102, NULL, 'G3DSA:1.20.1250.20:FF:001704', NULL, NULL, 'Solute carrier family 2 (Facilitated glucose transporter), member 6 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(127103, NULL, 'G3DSA:3.90.810.10:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127104, NULL, 'G3DSA:3.40.50.150:FF:001622', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127105, NULL, 'G3DSA:3.10.490.10:FF:000023', NULL, NULL, 'Gliotoxin biosynthesis protein GliK', NULL, NULL, NULL, NULL, NULL, 4),
(127106, NULL, 'G3DSA:2.30.29.30:FF:000939', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127107, NULL, 'G3DSA:3.90.1600.10:FF:000031', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(127108, NULL, 'G3DSA:1.20.1270.10:FF:000073', NULL, NULL, 'Cytosolic HSP70', NULL, NULL, NULL, NULL, NULL, 4),
(127109, NULL, 'G3DSA:3.30.560.10:FF:000013', NULL, NULL, 'Dehydrogenase pkfF', NULL, NULL, NULL, NULL, NULL, 4),
(127110, NULL, 'G3DSA:1.20.1250.10:FF:000066', NULL, NULL, 'Prolactin-3C1', NULL, NULL, NULL, NULL, NULL, 4),
(127111, NULL, 'G3DSA:3.30.300.160:FF:000015', NULL, NULL, 'Type II secretion system protein E', NULL, NULL, NULL, NULL, NULL, 4),
(127112, NULL, 'G3DSA:3.20.20.80:FF:000533', NULL, NULL, 'Maltase-glucoamylase, intestinal', NULL, NULL, NULL, NULL, NULL, 4),
(127113, NULL, 'G3DSA:3.40.5.120:FF:000001', NULL, NULL, 'probable global transcription activator SNF2L2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(127114, NULL, 'G3DSA:1.10.10.820:FF:000020', NULL, NULL, 'Myosin B', NULL, NULL, NULL, NULL, NULL, 4),
(127115, NULL, 'G3DSA:2.30.30.40:FF:000221', NULL, NULL, 'SH3 and cysteine-rich domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(127116, NULL, 'G3DSA:1.20.1070.10:FF:000338', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127117, NULL, 'G3DSA:3.30.40.10:FF:001519', NULL, NULL, 'Putative ring finger protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(127118, NULL, 'G3DSA:3.40.525.10:FF:000076', NULL, NULL, 'Sec14p-like phosphatidylinositol transfer family protein', NULL, NULL, NULL, NULL, NULL, 4),
(127119, NULL, 'G3DSA:3.30.540.10:FF:000006', NULL, NULL, 'Fructose-1,6-bisphosphatase class 1', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(127120, NULL, 'G3DSA:1.10.510.10:FF:001646', NULL, NULL, 'Serine/threonine-protein kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(127121, NULL, 'G3DSA:1.10.1300.10:FF:000045', NULL, NULL, '3'',5''-cyclic-nucleotide phosphodiesterase regA', NULL, NULL, NULL, NULL, NULL, 4),
(127122, NULL, 'G3DSA:1.10.520.10:FF:000006', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(127123, NULL, 'G3DSA:3.40.1110.10:FF:000174', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(127124, NULL, 'G3DSA:3.30.70.330:FF:001497', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127125, NULL, 'G3DSA:3.40.47.10:FF:000051', NULL, NULL, '3-oxoacyl-Acyl-carrier-protein synthase III', NULL, NULL, NULL, NULL, NULL, 4),
(127126, NULL, 'G3DSA:3.40.50.620:FF:000381', NULL, NULL, 'Isoleucyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(127127, NULL, 'G3DSA:1.10.10.10:FF:000231', NULL, NULL, 'HTH-type transcriptional activator AllS', NULL, NULL, NULL, NULL, NULL, 4),
(127128, NULL, 'G3DSA:3.30.160.60:FF:002066', NULL, NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(127129, NULL, 'G3DSA:1.10.287.2620:FF:000011', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(127130, NULL, 'G3DSA:1.20.1070.10:FF:000884', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(127131, NULL, 'G3DSA:1.10.287.70:FF:000655', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127132, NULL, 'G3DSA:2.120.10.80:FF:000098', NULL, NULL, 'Acyl-CoA-binding domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(127133, NULL, 'G3DSA:1.10.135.10:FF:000015', NULL, NULL, 'Creatine kinase, M-type', NULL, NULL, NULL, NULL, NULL, 4),
(127134, NULL, 'G3DSA:1.10.8.10:FF:000067', NULL, NULL, 'E3 ubiquitin-protein ligase UPL1', NULL, NULL, NULL, NULL, NULL, 4),
(127135, NULL, 'G3DSA:4.10.1240.30:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127136, NULL, 'G3DSA:2.60.120.290:FF:000198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127137, NULL, 'G3DSA:3.90.640.10:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127138, NULL, 'G3DSA:1.10.510.10:FF:002158', NULL, NULL, 'Calcium/calmodulin dependent protein kinase kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(127139, NULL, 'G3DSA:1.25.40.10:FF:001992', NULL, NULL, 'GM24226', NULL, NULL, NULL, NULL, NULL, 4),
(127140, NULL, 'G3DSA:3.30.70.330:FF:002486', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127141, NULL, 'G3DSA:3.40.50.261:FF:000015', NULL, NULL, 'Acyl-CoA synthetase FdrA', NULL, NULL, NULL, NULL, NULL, 4),
(127142, NULL, 'G3DSA:3.40.140.10:FF:000215', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit F', NULL, NULL, NULL, NULL, NULL, 4),
(127143, NULL, 'G3DSA:2.130.10.10:FF:005467', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127144, NULL, 'G3DSA:1.10.10.10:FF:000124', NULL, NULL, 'Redox-sensing transcriptional repressor Rex', NULL, NULL, NULL, NULL, NULL, 4),
(127145, NULL, 'G3DSA:3.90.1030.10:FF:000015', NULL, NULL, 'Mitochondrial Ribosomal Protein, Large', NULL, NULL, NULL, NULL, NULL, 4),
(127146, NULL, 'G3DSA:2.130.10.10:FF:001178', NULL, NULL, 'YNL035C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(127147, NULL, 'G3DSA:2.40.70.10:FF:000500', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127148, NULL, 'G3DSA:3.10.110.10:FF:000063', NULL, NULL, 'CDC34p Ubiquitin-conjugating enzyme (E2)', NULL, NULL, NULL, NULL, NULL, 4),
(127149, NULL, 'G3DSA:1.25.40.10:FF:005258', NULL, NULL, 'S1 RNA binding domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(127150, NULL, 'G3DSA:4.10.400.10:FF:000183', NULL, NULL, 'Prolow-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(127151, NULL, 'G3DSA:3.90.1150.10:FF:000069', NULL, NULL, 'L-threonine aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(127152, NULL, 'G3DSA:3.40.50.300:FF:005866', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(127153, NULL, 'G3DSA:3.40.50.410:FF:000008', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(127154, NULL, 'G3DSA:3.40.50.1820:FF:000267', NULL, NULL, 'Alpha/beta-Hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(127155, NULL, 'G3DSA:2.40.240.20:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127156, NULL, 'G3DSA:4.10.240.10:FF:000181', NULL, NULL, 'Zcf14p', NULL, NULL, NULL, NULL, NULL, 4),
(127157, NULL, 'G3DSA:2.60.120.10:FF:000461', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127158, NULL, 'G3DSA:1.20.1070.10:FF:000445', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(127159, NULL, 'G3DSA:1.10.10.10:FF:000596', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(127160, NULL, 'G3DSA:1.10.880.10:FF:000004', NULL, NULL, 'Nuclear factor, erythroid 2', NULL, NULL, NULL, NULL, NULL, 4),
(127161, NULL, 'G3DSA:1.10.10.10:FF:001220', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(127162, NULL, 'G3DSA:3.30.70.1230:FF:000014', NULL, NULL, 'adenylate cyclase type 9', NULL, NULL, NULL, NULL, NULL, 4),
(127163, NULL, 'G3DSA:2.60.40.10:FF:002307', NULL, NULL, 'PLeXin', NULL, NULL, NULL, NULL, NULL, 4),
(127164, NULL, 'G3DSA:3.80.10.10:FF:000745', NULL, NULL, 'Trophoblast glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(127165, NULL, 'G3DSA:1.10.510.10:FF:003254', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127166, NULL, 'G3DSA:3.40.1010.10:FF:000008', NULL, NULL, 'Similar to nucleoside triphosphate pyrophosphohydrolase, MazG', NULL, NULL, NULL, NULL, NULL, 4),
(127167, NULL, 'G3DSA:3.30.1490.80:FF:000005', NULL, NULL, 'Glutathione synthetase, isoform K', NULL, NULL, NULL, NULL, NULL, 4),
(127168, NULL, 'G3DSA:3.30.1520.10:FF:000044', NULL, NULL, 'Kinesin-like protein KIF16B', NULL, NULL, NULL, NULL, NULL, 4),
(127169, NULL, 'G3DSA:1.25.40.10:FF:003021', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(127170, NULL, 'G3DSA:2.70.98.20:FF:000004', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(127171, NULL, 'G3DSA:3.40.50.300:FF:002201', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(127172, NULL, 'G3DSA:3.30.1640.10:FF:000098', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(127173, NULL, 'G3DSA:3.40.50.2300:FF:000294', NULL, NULL, 'Stage II sporulation protein E', NULL, NULL, NULL, NULL, NULL, 4),
(127174, NULL, 'G3DSA:3.30.70.100:FF:000141', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127175, NULL, 'G3DSA:3.40.50.10810:FF:000277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127176, NULL, 'G3DSA:1.10.10.60:FF:001167', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127177, NULL, 'G3DSA:3.30.1520.10:FF:000151', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(127178, NULL, 'G3DSA:3.40.50.12500:FF:000008', NULL, NULL, 'Hydantoin racemase', NULL, NULL, NULL, NULL, NULL, 4),
(127179, NULL, 'G3DSA:1.20.1110.10:FF:000056', NULL, NULL, 'Cation transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(127180, NULL, 'G3DSA:2.60.40.60:FF:001075', NULL, NULL, 'Protocadherin fat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(127181, NULL, 'G3DSA:3.30.70.1560:FF:000012', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(127182, NULL, 'G3DSA:3.30.386.10:FF:000001', NULL, NULL, 'Chitosanase', NULL, NULL, NULL, NULL, NULL, 4),
(127183, NULL, 'G3DSA:3.50.50.60:FF:000354', NULL, NULL, 'Similar to fructosyl-amino acid oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(127184, NULL, 'G3DSA:1.25.40.70:FF:000003', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', NULL, NULL, NULL, NULL, NULL, 4),
(127185, NULL, 'G3DSA:3.30.710.10:FF:000385', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127186, NULL, 'G3DSA:1.10.510.10:FF:003939', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127187, NULL, 'G3DSA:3.40.50.1860:FF:000015', NULL, NULL, 'Aspartate racemase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(127188, NULL, 'G3DSA:1.10.10.10:FF:002029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127189, NULL, 'G3DSA:2.10.25.10:FF:000431', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(127190, NULL, 'G3DSA:1.25.40.10:FF:001076', NULL, NULL, 'protein SMG5-like', NULL, NULL, NULL, NULL, NULL, 4),
(127191, NULL, 'G3DSA:2.60.40.10:FF:005719', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127192, NULL, 'G3DSA:1.10.510.10:FF:004103', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127193, NULL, 'G3DSA:2.130.10.10:FF:005040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127194, NULL, 'G3DSA:3.40.50.300:FF:008305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127195, NULL, 'G3DSA:3.30.1220.10:FF:000004', NULL, NULL, 'COBW domain-containing protein C15D4.05', NULL, NULL, NULL, NULL, NULL, 4),
(127196, NULL, 'G3DSA:3.10.20.90:FF:000514', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(127197, NULL, 'G3DSA:3.30.160.60:FF:001886', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127198, NULL, 'G3DSA:3.50.30.30:FF:000012', NULL, NULL, 'E3 ubiquitin-protein ligase RNF13', NULL, NULL, NULL, NULL, NULL, 4),
(127199, NULL, 'G3DSA:3.40.50.2300:FF:001159', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127200, NULL, 'G3DSA:1.50.10.20:FF:000029', NULL, NULL, 'Geranylgeranyl transferase type-2 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(127201, NULL, 'G3DSA:1.10.238.10:FF:001193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127202, NULL, 'G3DSA:3.80.10.10:FF:000875', NULL, NULL, 'Blast:F-box/LRR-repeat protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(127203, NULL, 'G3DSA:1.20.140.10:FF:000059', NULL, NULL, 'Acyl-CoA dehydrogenase, C-terminal domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(127204, NULL, 'G3DSA:2.40.50.140:FF:000111', NULL, NULL, 'mRNA-capping enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(127205, NULL, 'G3DSA:3.30.70.390:FF:000003', NULL, NULL, 'Immediate-early protein', NULL, NULL, NULL, NULL, NULL, 4),
(127206, NULL, 'G3DSA:3.80.10.10:FF:001364', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127207, NULL, 'G3DSA:3.30.70.660:FF:000084', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(127208, NULL, 'G3DSA:2.10.70.10:FF:000081', NULL, NULL, 'Cellular communication network factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(127209, NULL, 'G3DSA:3.30.160.60:FF:002375', NULL, NULL, 'Zinc finger protein 268', NULL, NULL, NULL, NULL, NULL, 4),
(127210, NULL, 'G3DSA:1.25.40.90:FF:000009', NULL, NULL, 'Putative signal transducing adapter molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(127211, NULL, 'G3DSA:3.40.50.410:FF:000317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127212, NULL, 'G3DSA:3.40.50.300:FF:003292', NULL, NULL, 'DEAH-box helicase 40', NULL, NULL, NULL, NULL, NULL, 4),
(127213, NULL, 'G3DSA:2.60.40.10:FF:004090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127214, NULL, 'G3DSA:3.30.1360.40:FF:000012', NULL, NULL, 'DNA topoisomerase (ATP-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4),
(127215, NULL, 'G3DSA:3.40.190.10:FF:000398', NULL, NULL, 'Si:dkey-183j2.10', NULL, NULL, NULL, NULL, NULL, 4),
(127216, NULL, 'G3DSA:2.30.30.40:FF:000586', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127217, NULL, 'G3DSA:3.40.50.620:FF:000072', NULL, NULL, 'Protein FixA homolog', NULL, NULL, NULL, NULL, NULL, 4),
(127218, NULL, 'G3DSA:3.40.630.30:FF:000545', NULL, NULL, 'ABC-type transporter, ATPase component, fused to acetyltransferase domain', NULL, NULL, NULL, NULL, NULL, 4),
(127219, NULL, 'G3DSA:3.80.10.10:FF:002353', NULL, NULL, 'Receptor-like protein 52', NULL, NULL, NULL, NULL, NULL, 4),
(127220, NULL, 'G3DSA:2.130.10.10:FF:004056', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(127221, NULL, 'G3DSA:3.30.200.20:FF:000799', NULL, NULL, 'AGC protein kinase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(127222, NULL, 'G3DSA:1.10.15.40:FF:000003', NULL, NULL, 'Sulfite reductase', NULL, NULL, NULL, NULL, NULL, 4),
(127223, NULL, 'G3DSA:3.40.50.2000:FF:000664', NULL, NULL, 'Glycosyl transferase family 28', NULL, NULL, NULL, NULL, NULL, 4),
(127224, NULL, 'G3DSA:3.30.780.10:FF:000007', NULL, NULL, 'Putative eukaryotic translation initiation factor 2d', NULL, NULL, NULL, NULL, NULL, 4),
(127225, NULL, 'G3DSA:2.60.40.1660:FF:000030', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(127226, NULL, 'G3DSA:1.10.418.20:FF:000007', NULL, NULL, 'Blast:Sentrin-specific protease 7', NULL, NULL, NULL, NULL, NULL, 4),
(127227, NULL, 'G3DSA:1.10.1520.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127228, NULL, 'G3DSA:3.40.50.2300:FF:000647', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(127229, NULL, 'G3DSA:1.10.10.10:FF:000601', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(127230, NULL, 'G3DSA:3.30.70.330:FF:002806', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127231, NULL, 'G3DSA:2.60.40.150:FF:000181', NULL, NULL, 'Synaptotagmin 4', NULL, NULL, NULL, NULL, NULL, 4),
(127232, NULL, 'G3DSA:3.30.160.60:FF:001447', NULL, NULL, 'Zinc finger protein 585B', NULL, NULL, NULL, NULL, NULL, 4),
(127233, NULL, 'G3DSA:3.30.70.270:FF:000057', NULL, NULL, 'DNA polymerase eta isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(127234, NULL, 'G3DSA:2.10.25.10:FF:000122', NULL, NULL, 'Protein crumbs homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(127235, NULL, 'G3DSA:3.30.310.80:FF:000061', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(127236, NULL, 'G3DSA:3.40.50.300:FF:005074', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(127237, NULL, 'G3DSA:3.40.1190.10:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127238, NULL, 'G3DSA:3.10.290.10:FF:000042', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(127239, NULL, 'G3DSA:2.130.10.10:FF:002959', NULL, NULL, 'Uncharacterized WD repeat-containing protein sll1491', NULL, NULL, NULL, NULL, NULL, 4),
(127240, NULL, 'G3DSA:3.40.50.1980:FF:000068', NULL, NULL, 'Adhesion protein', NULL, NULL, NULL, NULL, NULL, 4),
(127241, NULL, 'G3DSA:1.10.150.240:FF:000100', NULL, NULL, 'HAD-superfamily hydrolase, subfamily IA, variant 3', NULL, NULL, NULL, NULL, NULL, 4),
(127242, NULL, 'G3DSA:2.40.50.260:FF:000001', NULL, NULL, 'Baseplate hub subunit and tail lysozyme', NULL, NULL, NULL, NULL, NULL, 4),
(127243, NULL, 'G3DSA:1.25.40.10:FF:000587', NULL, NULL, 'Outer membrane protein assembly factor BamD', NULL, NULL, NULL, NULL, NULL, 4),
(127244, NULL, 'G3DSA:3.30.450.50:FF:000039', NULL, NULL, 'V-SNARE', NULL, NULL, NULL, NULL, NULL, 4),
(127245, NULL, 'G3DSA:1.10.238.10:FF:001204', NULL, NULL, 'Protofilament ribbon protein of flagellar microtubules', NULL, NULL, NULL, NULL, NULL, 4),
(127246, NULL, 'G3DSA:3.40.20.10:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127247, NULL, 'G3DSA:2.10.50.10:FF:000051', NULL, NULL, 'Cysteine repeat modular protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(127248, NULL, 'G3DSA:1.25.10.10:FF:002221', NULL, NULL, 'Beta-catenin hmp-2', NULL, NULL, NULL, NULL, NULL, 4),
(127249, NULL, 'G3DSA:3.50.50.60:FF:000882', NULL, NULL, 'FAD-dependent monooxygenase fmqB', NULL, NULL, NULL, NULL, NULL, 4),
(127250, NULL, 'G3DSA:3.40.50.720:FF:000753', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(127251, NULL, 'G3DSA:3.30.160.60:FF:005629', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127252, NULL, 'G3DSA:3.40.50.1820:FF:001678', NULL, NULL, 'Biotin biosynthesis bifunctional protein BioHC', NULL, NULL, NULL, NULL, NULL, 4),
(127253, NULL, 'G3DSA:3.30.420.40:FF:001046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127254, NULL, 'G3DSA:3.40.50.2000:FF:000794', NULL, NULL, 'Glycosyltransferase family 20-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(127255, NULL, 'G3DSA:3.30.565.10:FF:000209', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(127256, NULL, 'G3DSA:3.30.200.20:FF:002558', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127257, NULL, 'G3DSA:1.20.1270.60:FF:000094', NULL, NULL, 'SLIT-ROBO Rho GTPase-activating 2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(127258, NULL, 'G3DSA:1.20.58.90:FF:000015', NULL, NULL, 'SNARE protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(127259, NULL, 'G3DSA:1.10.10.160:FF:000013', NULL, NULL, 'RecBCD enzyme subunit RecC', NULL, NULL, NULL, NULL, NULL, 4),
(127260, NULL, 'G3DSA:3.30.50.10:FF:000082', NULL, NULL, 'NR2E3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(127261, NULL, 'G3DSA:3.30.70.3030:FF:000015', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(127262, NULL, 'G3DSA:2.40.50.170:FF:000002', NULL, NULL, 'Dipeptidyl aminopeptidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(127263, NULL, 'G3DSA:3.30.310.130:FF:000003', NULL, NULL, 'SUMO specific peptidase 7', NULL, NULL, NULL, NULL, NULL, 4),
(127264, NULL, 'G3DSA:3.20.19.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127265, NULL, 'G3DSA:3.40.1170.10:FF:000025', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(127266, NULL, 'G3DSA:3.40.1170.60:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127267, NULL, 'G3DSA:3.30.1780.10:FF:000001', NULL, NULL, 'Ketimine reductase mu-crystallin', NULL, NULL, NULL, NULL, NULL, 4),
(127268, NULL, 'G3DSA:2.60.120.920:FF:000095', NULL, NULL, 'Ryanodine receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(127269, NULL, 'G3DSA:2.60.40.10:FF:003471', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127270, NULL, 'G3DSA:2.60.120.330:FF:000013', NULL, NULL, 'Gibberellin 3-beta-dioxygenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(127271, NULL, 'G3DSA:3.30.200.20:FF:002249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127272, NULL, 'G3DSA:3.30.40.10:FF:002155', NULL, NULL, 'Structure-specific endonuclease subunit SLX1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(127273, NULL, 'G3DSA:3.40.50.1000:FF:000679', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127274, NULL, 'G3DSA:2.30.42.10:FF:000475', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127275, NULL, 'G3DSA:2.60.40.60:FF:000147', NULL, NULL, 'Cadherin 23', NULL, NULL, NULL, NULL, NULL, 4),
(127276, NULL, 'G3DSA:1.20.1050.10:FF:000085', NULL, NULL, 'Probable glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(127277, NULL, 'G3DSA:2.60.120.590:FF:000035', NULL, NULL, 'AFR741Wp', NULL, NULL, NULL, NULL, NULL, 4),
(127278, NULL, 'G3DSA:1.25.40.10:FF:002402', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g46610', NULL, NULL, NULL, NULL, NULL, 4),
(127279, NULL, 'G3DSA:2.60.98.50:FF:000002', NULL, NULL, 'Envelopment polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(127280, NULL, 'G3DSA:3.40.50.2300:FF:000979', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127281, NULL, 'G3DSA:3.30.300.70:FF:000006', NULL, NULL, 'Ribosome maturation factor RimP', NULL, NULL, NULL, NULL, NULL, 4),
(127282, NULL, 'G3DSA:3.30.160.60:FF:006118', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127283, NULL, 'G3DSA:2.10.50.30:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127284, NULL, 'G3DSA:3.90.450.1:FF:000001', NULL, NULL, 'Attachment protein G3P', NULL, NULL, NULL, NULL, NULL, 4),
(127285, NULL, 'G3DSA:1.10.220.120:FF:000002', NULL, NULL, 'RNA polymerase sigma factor SigA', NULL, NULL, NULL, NULL, NULL, 4),
(127286, NULL, 'G3DSA:3.90.550.10:FF:000595', NULL, NULL, 'Gll2190 protein', NULL, NULL, NULL, NULL, NULL, 4),
(127287, NULL, 'G3DSA:3.40.120.10:FF:000085', NULL, NULL, 'Phosphomannomutase', NULL, NULL, NULL, NULL, NULL, 4),
(127288, NULL, 'G3DSA:2.60.120.10:FF:000680', NULL, NULL, 'uncharacterized protein LOC100184049 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(127289, NULL, 'G3DSA:3.40.30.10:FF:000411', NULL, NULL, 'Protein disulfide isomerase MPD2', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(127290, NULL, 'G3DSA:3.90.640.80:FF:000004', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(127291, NULL, 'G3DSA:3.40.50.150:FF:001841', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127292, NULL, 'G3DSA:1.25.40.10:FF:002857', NULL, NULL, 'Tetratricopeptide repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(127293, NULL, 'G3DSA:3.30.160.60:FF:005472', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127294, NULL, 'G3DSA:3.40.80.10:FF:000015', NULL, NULL, 'PGRP-LA, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(127295, NULL, 'G3DSA:3.90.980.20:FF:000023', NULL, NULL, 'Cysteine-rich protein 2-binding protein-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(127296, NULL, 'G3DSA:1.20.1070.10:FF:000754', NULL, NULL, '5-hydroxytryptamine (Serotonin) receptor 2B, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(127297, NULL, 'G3DSA:3.90.550.10:FF:000100', NULL, NULL, 'translation initiation factor eIF-2B subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(127298, NULL, 'G3DSA:3.30.160.60:FF:003920', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127299, NULL, 'G3DSA:2.20.100.10:FF:000210', NULL, NULL, 'Thrombospondin type-1 domain-containing protein 7B', NULL, NULL, NULL, NULL, NULL, 4),
(127300, NULL, 'G3DSA:3.30.420.40:FF:000990', NULL, NULL, 'Heat shock cognate 70 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(127301, NULL, 'G3DSA:1.25.40.10:FF:005275', NULL, NULL, 'AGR352Cp', NULL, NULL, NULL, NULL, NULL, 4),
(127302, NULL, 'G3DSA:1.10.10.60:FF:001297', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127303, NULL, 'G3DSA:2.40.50.540:FF:000001', NULL, NULL, 'Copper homeostasis/adhesion lipoprotein NlpE', NULL, NULL, NULL, NULL, NULL, 4),
(127304, NULL, 'G3DSA:3.20.20.80:FF:000663', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127305, NULL, 'G3DSA:3.30.60.30:FF:000223', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(127306, NULL, 'G3DSA:1.10.3110.10:FF:000019', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(127307, NULL, 'G3DSA:1.20.120.220:FF:000007', NULL, NULL, 'ATP synthase subunit a', NULL, NULL, NULL, NULL, NULL, 4),
(127308, NULL, 'G3DSA:3.60.21.10:FF:000491', NULL, NULL, 'Protein CBG05769', NULL, NULL, NULL, NULL, NULL, 4),
(127309, NULL, 'G3DSA:2.40.10.120:FF:000007', NULL, NULL, 'Periplasmic serine endoprotease DegP-like', NULL, NULL, NULL, NULL, NULL, 4),
(127310, NULL, 'G3DSA:3.30.160.60:FF:000161', NULL, NULL, 'Zinc finger protein 366', NULL, NULL, NULL, NULL, NULL, 4),
(127311, NULL, 'G3DSA:3.40.50.720:FF:002546', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127312, NULL, 'G3DSA:3.40.190.10:FF:000718', NULL, NULL, 'Sll1762 protein', NULL, NULL, NULL, NULL, NULL, 4),
(127313, NULL, 'G3DSA:2.10.220.10:FF:000058', NULL, NULL, 'Fraser extracellular matrix complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(127314, NULL, 'G3DSA:1.10.10.10:FF:000579', NULL, NULL, 'Transcriptional regulator, MarR family', NULL, NULL, NULL, NULL, NULL, 4),
(127315, NULL, 'G3DSA:3.80.10.10:FF:003657', NULL, NULL, 'F-box/leucine rich repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(127316, NULL, 'G3DSA:3.90.199.10:FF:000002', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(127317, NULL, 'G3DSA:3.40.50.720:FF:002018', NULL, NULL, '3beta-hydroxysteroid-dehydrogenase/decarboxylase isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(127318, NULL, 'G3DSA:1.10.150.770:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127319, NULL, 'G3DSA:2.60.40.10:FF:005399', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127320, NULL, 'G3DSA:3.40.50.1000:FF:000696', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127321, NULL, 'G3DSA:2.40.128.20:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127322, NULL, 'G3DSA:3.30.70.330:FF:000569', NULL, NULL, 'ELAV-Type RNA binding-protein family', NULL, NULL, NULL, NULL, NULL, 4),
(127323, NULL, 'G3DSA:3.40.50.11850:FF:000010', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(127324, NULL, 'G3DSA:3.40.50.80:FF:000079', NULL, NULL, 'Fre7p', NULL, NULL, NULL, NULL, NULL, 4),
(127325, NULL, 'G3DSA:3.30.1490.80:FF:000022', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(127326, NULL, 'G3DSA:3.30.2320.80:FF:000010', NULL, NULL, 'Hydrogenase maturation factor HypA', NULL, NULL, NULL, NULL, NULL, 4),
(127327, NULL, 'G3DSA:1.10.510.10:FF:000051', NULL, NULL, 'Receptor-like serine/threonine-protein kinase ALE2', NULL, NULL, NULL, NULL, NULL, 4),
(127328, NULL, 'G3DSA:4.10.280.10:FF:000211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127329, NULL, 'G3DSA:3.40.1170.60:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127330, NULL, 'G3DSA:3.10.310.10:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127331, NULL, 'G3DSA:3.90.245.10:FF:000026', NULL, NULL, 'Protein CBG02610', NULL, NULL, NULL, NULL, NULL, 4),
(127332, NULL, 'G3DSA:2.60.40.10:FF:004887', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127333, NULL, 'G3DSA:3.60.21.10:FF:000311', NULL, NULL, 'Metallophosphoesterase', NULL, NULL, NULL, NULL, NULL, 4),
(127334, NULL, 'G3DSA:3.30.160.60:FF:003679', NULL, NULL, 'Zinc finger and SCAN domain containing 4, pseudogene 3', NULL, NULL, NULL, NULL, NULL, 4),
(127335, NULL, 'G3DSA:1.25.40.10:FF:003818', NULL, NULL, 'Si:dkey-206p8.1', NULL, NULL, NULL, NULL, NULL, 4),
(127336, NULL, 'G3DSA:2.40.50.140:FF:000089', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(127337, NULL, 'G3DSA:3.40.630.30:FF:000068', NULL, NULL, 'Tabtoxin resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(127338, NULL, 'G3DSA:1.10.510.10:FF:003563', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127339, NULL, 'G3DSA:2.60.120.620:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127340, NULL, 'G3DSA:3.40.50.300:FF:003157', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(127341, NULL, 'G3DSA:2.60.40.10:FF:000964', NULL, NULL, 'Stretchin-Mlck, isoform T', NULL, NULL, NULL, NULL, NULL, 4),
(127342, NULL, 'G3DSA:1.20.1070.10:FF:001373', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127343, NULL, 'G3DSA:1.10.510.10:FF:001669', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(127344, NULL, 'G3DSA:3.30.260.10:FF:000007', NULL, NULL, 'Chaperonin 60 subunit beta 2', NULL, NULL, NULL, NULL, NULL, 4),
(127345, NULL, 'G3DSA:3.30.160.60:FF:004303', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127346, NULL, 'G3DSA:3.40.630.10:FF:000404', NULL, NULL, 'Bll2698 protein', NULL, NULL, NULL, NULL, NULL, 4),
(127347, NULL, 'G3DSA:2.60.120.260:FF:000655', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(127348, NULL, 'G3DSA:3.40.50.300:FF:003612', NULL, NULL, 'MAGUK p55 subfamily member 3', NULL, NULL, NULL, NULL, NULL, 4),
(127349, NULL, 'G3DSA:1.10.150.900:FF:000006', NULL, NULL, 'Peptidase M20/M25/M40 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(127350, NULL, 'G3DSA:3.30.930.10:FF:000391', NULL, NULL, 'Glycyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(127351, NULL, 'G3DSA:1.10.10.2480:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127352, NULL, 'G3DSA:1.10.287.770:FF:000016', NULL, NULL, 'Degenerin-like protein unc-105', NULL, NULL, NULL, NULL, NULL, 4),
(127353, NULL, 'G3DSA:2.40.70.10:FF:000478', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127354, NULL, 'G3DSA:2.30.30.490:FF:000012', NULL, NULL, 'metastasis-associated protein MTA3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(127355, NULL, 'G3DSA:6.10.250.3450:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127356, NULL, 'G3DSA:4.10.410.10:FF:000048', NULL, NULL, 'Protein CBR-MLT-11', NULL, NULL, NULL, NULL, NULL, 4),
(127357, NULL, 'G3DSA:3.40.225.10:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127358, NULL, 'G3DSA:1.20.58.390:FF:000115', NULL, NULL, 'GABA/Glycine Receptor family (See gbr)', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(127359, NULL, 'G3DSA:2.60.40.10:FF:003718', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127360, NULL, 'G3DSA:3.80.10.10:FF:002662', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', NULL, NULL, NULL, NULL, NULL, 4),
(127361, NULL, 'G3DSA:3.30.300.180:FF:000010', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(127362, NULL, 'G3DSA:3.10.450.10:FF:000004', NULL, NULL, 'Cystatin C', NULL, NULL, NULL, NULL, NULL, 4),
(127363, NULL, 'G3DSA:2.60.270.20:FF:000002', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(127364, NULL, 'G3DSA:1.10.1200.10:FF:000009', NULL, NULL, 'Isochorismatase', NULL, NULL, NULL, NULL, NULL, 4),
(127365, NULL, 'G3DSA:1.10.150.300:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127366, NULL, 'G3DSA:2.30.30.140:FF:000031', NULL, NULL, 'DNA/RNA-binding protein KIN17 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(127367, NULL, 'G3DSA:3.40.50.1100:FF:000035', NULL, NULL, 'Serine dehydratase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(127368, NULL, 'G3DSA:1.10.287.70:FF:000402', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(127369, NULL, 'G3DSA:1.10.472.80:FF:000116', NULL, NULL, 'Rab GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(127370, NULL, 'G3DSA:2.130.10.10:FF:003106', NULL, NULL, 'Mono-functional DNA-alkylating methyl methanesulfonate N-term-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(127371, NULL, 'G3DSA:3.30.230.10:FF:000359', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127372, NULL, 'G3DSA:3.30.500.10:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127373, NULL, 'G3DSA:2.40.160.120:FF:000031', NULL, NULL, 'Oxysterol-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(127374, NULL, 'G3DSA:1.10.1040.50:FF:000008', NULL, NULL, '3-hydroxyacyl-CoA dehydrogenase PaaC', NULL, NULL, NULL, NULL, NULL, 4),
(127375, NULL, 'G3DSA:3.30.70.1170:FF:000002', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase B', NULL, NULL, NULL, NULL, NULL, 4),
(127376, NULL, 'G3DSA:3.60.10.10:FF:000246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127377, NULL, 'G3DSA:3.40.50.300:FF:007890', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127378, NULL, 'G3DSA:1.25.40.990:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127379, NULL, 'G3DSA:1.10.1040.10:FF:000007', NULL, NULL, 'Ketol-acid reductoisomerase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(127380, NULL, 'G3DSA:3.40.720.10:FF:000203', NULL, NULL, 'N-acetylgalactosamine 6-sulfate sulfatase (GALNS)', NULL, NULL, NULL, NULL, NULL, 4),
(127381, NULL, 'G3DSA:4.10.400.10:FF:000222', NULL, NULL, 'Low-density lipoprotein receptor-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(127382, NULL, 'G3DSA:1.25.10.10:FF:000220', NULL, NULL, 'inverted formin-2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(127383, NULL, 'G3DSA:1.10.1040.30:FF:000002', NULL, NULL, 'ISWI chromatin-remodeling complex ATPase CHR11', NULL, NULL, NULL, NULL, NULL, 4),
(127384, NULL, 'G3DSA:3.40.50.150:FF:001206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127385, NULL, 'G3DSA:6.10.140.2150:FF:000010', NULL, NULL, 'Aspartate aminotransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(127386, NULL, 'G3DSA:2.130.10.10:FF:000689', NULL, NULL, 'U4/U6 small nuclear ribonucleoprotein PRP4-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(127387, NULL, 'G3DSA:1.10.10.430:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127388, NULL, 'G3DSA:3.40.50.1000:FF:000140', NULL, NULL, 'Pyridoxal phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(127389, NULL, 'G3DSA:3.30.980.10:FF:000028', NULL, NULL, 'Threonyl/alanyl tRNA synthetase SAD', NULL, NULL, NULL, NULL, NULL, 4),
(127390, NULL, 'G3DSA:1.20.1070.10:FF:001749', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(127391, NULL, 'G3DSA:1.10.10.60:FF:000678', NULL, NULL, 'C. Elegans Homeobox', NULL, NULL, NULL, NULL, NULL, 4),
(127392, NULL, 'G3DSA:4.10.280.110:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127393, NULL, 'G3DSA:2.60.120.260:FF:000436', NULL, NULL, 'Glycoside hydrolase family 2 sugar binding', NULL, NULL, NULL, NULL, NULL, 4),
(127394, NULL, 'G3DSA:2.20.25.530:FF:000005', NULL, NULL, 'ribonuclease H2 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(127395, NULL, 'G3DSA:3.90.70.10:FF:000327', NULL, NULL, 'Vignain', NULL, NULL, NULL, NULL, NULL, 4),
(127396, NULL, 'G3DSA:1.25.10.10:FF:003182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127397, NULL, 'G3DSA:3.90.550.20:FF:000013', NULL, NULL, 'Alpha1,4-N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(127398, NULL, 'G3DSA:3.30.70.330:FF:001536', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127399, NULL, 'G3DSA:2.130.10.10:FF:002139', NULL, NULL, 'Protein kinase family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(127400, NULL, 'G3DSA:3.40.50.12230:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127401, NULL, 'G3DSA:2.20.70.30:FF:000007', NULL, NULL, 'Nascent polypeptide-associated complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(127402, NULL, 'G3DSA:2.30.30.100:FF:000159', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm3', NULL, NULL, NULL, NULL, NULL, 4),
(127403, NULL, 'G3DSA:3.40.720.10:FF:000198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127404, NULL, 'G3DSA:2.20.70.10:FF:000001', NULL, NULL, 'Membrane-associated guanylate kinase, WW and PDZ domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(127405, NULL, 'G3DSA:1.25.10.10:FF:000304', NULL, NULL, 'MAP3K epsilon protein kinase 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(127406, NULL, 'G3DSA:1.10.1670.40:FF:000013', NULL, NULL, '3-methyladenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(127407, NULL, 'G3DSA:3.30.200.20:FF:000304', NULL, NULL, 'eIF-2-alpha kinase GCN2', NULL, NULL, NULL, NULL, NULL, 4),
(127408, NULL, 'G3DSA:1.20.58.60:FF:000147', NULL, NULL, 'utrophin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(127409, NULL, 'G3DSA:1.10.1760.20:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127410, NULL, 'G3DSA:1.25.40.20:FF:000360', NULL, NULL, 'Ankyrin repeat domain 33', NULL, NULL, NULL, NULL, NULL, 4),
(127411, NULL, 'G3DSA:4.10.240.10:FF:000220', NULL, NULL, 'Chromosome 12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(127412, NULL, 'G3DSA:3.40.50.1100:FF:000052', NULL, NULL, 'Threonine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(127413, NULL, 'G3DSA:3.30.160.60:FF:000121', NULL, NULL, 'zinc finger protein 385B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(127414, NULL, 'G3DSA:1.20.1310.10:FF:000021', NULL, NULL, 'Cullin-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(127415, NULL, 'G3DSA:3.80.10.10:FF:003281', NULL, NULL, 'Toll-like receptor22', NULL, NULL, NULL, NULL, NULL, 4),
(127416, NULL, 'G3DSA:2.60.40.420:FF:000149', NULL, NULL, 'PKHD1 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(127417, NULL, 'G3DSA:1.10.3330.10:FF:000007', NULL, NULL, '2-oxo-4-hydroxy-4-carboxy-5-ureidoimidazoline decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(127418, NULL, 'G3DSA:3.30.60.20:FF:000130', NULL, NULL, 'Rho kinase', NULL, NULL, NULL, NULL, NULL, 4),
(127419, NULL, 'G3DSA:3.30.470.20:FF:000043', NULL, NULL, 'acetyl-CoA carboxylase 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(127420, NULL, 'G3DSA:1.10.510.10:FF:000360', NULL, NULL, 'Ephrin type-A receptor 10', NULL, NULL, NULL, NULL, NULL, 4),
(127421, NULL, 'G3DSA:3.20.20.70:FF:000204', NULL, NULL, 'Peroxisomal (S)-2-hydroxy-acid oxidase GLO4', NULL, NULL, NULL, NULL, NULL, 4),
(127422, NULL, 'G3DSA:3.10.50.40:FF:000108', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(127423, NULL, 'G3DSA:1.20.1740.10:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(127424, NULL, 'G3DSA:3.40.50.1820:FF:000806', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(127425, NULL, 'G3DSA:2.130.10.10:FF:003123', NULL, NULL, 'YALI0D06435p', NULL, NULL, NULL, NULL, NULL, 4),
(127426, NULL, 'G3DSA:3.30.70.330:FF:001188', NULL, NULL, 'Cold sensitive u2 snRNA suppressor', NULL, NULL, NULL, NULL, NULL, 4),
(127427, NULL, 'G3DSA:3.20.20.70:FF:000199', NULL, NULL, 'Phosphoribosylanthranilate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(127428, NULL, 'G3DSA:2.130.10.10:FF:004051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127429, NULL, 'G3DSA:3.30.40.10:FF:001626', NULL, NULL, 'Ret finger protein-like 4', NULL, NULL, NULL, NULL, NULL, 4),
(127430, NULL, 'G3DSA:1.25.10.10:FF:002693', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(127431, NULL, 'G3DSA:1.20.1280.290:FF:000087', NULL, NULL, 'Maltose exporter-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(127432, NULL, 'G3DSA:3.40.50.1100:FF:000271', NULL, NULL, 'Threonine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(127433, NULL, 'G3DSA:1.20.58.60:FF:000512', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(127434, NULL, 'G3DSA:2.30.42.10:FF:000003', NULL, NULL, 'Regulating synaptic membrane exocytosis protein 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(127435, NULL, 'G3DSA:3.30.70.2280:FF:000003', NULL, NULL, 'DEAD-box ATP-dependent RNA helicase 7', NULL, NULL, NULL, NULL, NULL, 4),
(127436, NULL, 'G3DSA:6.10.140.2220:FF:000042', NULL, NULL, 'GD11837', NULL, NULL, NULL, NULL, NULL, 4),
(127437, NULL, 'G3DSA:3.80.10.10:FF:000436', NULL, NULL, 'Si:dkey-16p6.1', NULL, NULL, NULL, NULL, NULL, 4),
(127438, NULL, 'G3DSA:3.40.50.1000:FF:000701', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127439, NULL, 'G3DSA:1.20.1250.20:FF:000215', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(127440, NULL, 'G3DSA:3.40.50.2300:FF:000850', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127441, NULL, 'G3DSA:3.40.50.360:FF:000078', NULL, NULL, 'Chromate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(127442, NULL, 'G3DSA:1.20.120.350:FF:000226', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127443, NULL, 'G3DSA:3.30.160.60:FF:003903', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127444, NULL, 'G3DSA:3.40.30.10:FF:000451', NULL, NULL, 'glutaredoxin-3', NULL, NULL, NULL, NULL, NULL, 4),
(127445, NULL, 'G3DSA:3.30.2410.10:FF:000036', NULL, NULL, 'Ubiquitin-protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(127446, NULL, 'G3DSA:3.30.56.10:FF:000033', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(127447, NULL, 'G3DSA:1.10.3720.10:FF:000021', NULL, NULL, 'Glutamate/aspartate ABC transporter, permease protein GltJ', NULL, NULL, NULL, NULL, NULL, 4),
(127448, NULL, 'G3DSA:1.20.5.170:FF:000196', NULL, NULL, 'AGAP006031-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(127449, NULL, 'G3DSA:3.90.70.10:FF:000108', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(127450, NULL, 'G3DSA:1.10.30.20:FF:000004', NULL, NULL, 'DNA helicase RepD', NULL, NULL, NULL, NULL, NULL, 4),
(127451, NULL, 'G3DSA:2.60.40.4330:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127452, NULL, 'G3DSA:3.30.420.40:FF:000973', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127453, NULL, 'G3DSA:1.25.40.420:FF:000059', NULL, NULL, 'AT19737p', NULL, NULL, NULL, NULL, NULL, 4),
(127454, NULL, 'G3DSA:1.10.287.1260:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127455, NULL, 'G3DSA:3.50.50.60:FF:000910', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(127456, NULL, 'G3DSA:2.20.25.160:FF:000006', NULL, NULL, 'Aspartoacylase', NULL, NULL, NULL, NULL, NULL, 4),
(127457, NULL, 'G3DSA:3.10.20.90:FF:000037', NULL, NULL, 'Gamma-aminobutyric acid receptor-associated protein-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(127458, NULL, 'G3DSA:3.60.21.10:FF:000182', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(127459, NULL, 'G3DSA:1.20.120.790:FF:000026', NULL, NULL, 'Heat shock protein 90, putative', NULL, NULL, NULL, NULL, NULL, 4),
(127460, NULL, 'G3DSA:3.20.20.80:FF:000516', NULL, NULL, 'Glycoside hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(127461, NULL, 'G3DSA:3.60.40.10:FF:000074', NULL, NULL, 'Protein phosphatase 2C 11', NULL, NULL, NULL, NULL, NULL, 4),
(127462, NULL, 'G3DSA:3.80.10.10:FF:000892', NULL, NULL, 'Os08g0322500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(127463, NULL, 'G3DSA:2.60.40.780:FF:000004', NULL, NULL, 'AGAP002496-PA', NULL, NULL, NULL, NULL, NULL, 4),
(127464, NULL, 'G3DSA:1.10.238.10:FF:000108', NULL, NULL, 'Calbindin 1', NULL, NULL, NULL, NULL, NULL, 4),
(127465, NULL, 'G3DSA:2.10.25.10:FF:000914', NULL, NULL, 'Crumbs 1, cell polarity complex component', NULL, NULL, NULL, NULL, NULL, 4),
(127466, NULL, 'G3DSA:2.60.40.150:FF:000506', NULL, NULL, 'synaptotagmin-12', NULL, NULL, NULL, NULL, NULL, 4),
(127467, NULL, 'G3DSA:3.30.160.60:FF:003555', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127468, NULL, 'G3DSA:3.30.70.330:FF:000699', NULL, NULL, 'U2 small nuclear ribonucleoprotein B', NULL, NULL, NULL, NULL, NULL, 4),
(127469, NULL, 'G3DSA:3.30.70.330:FF:002481', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127470, NULL, 'G3DSA:3.10.180.90:FF:000001', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(127471, NULL, 'G3DSA:3.90.1720.10:FF:000006', NULL, NULL, 'Lecithin retinol acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(127472, NULL, 'G3DSA:3.40.50.1820:FF:001206', NULL, NULL, 'Phosphatidylcholine-sterol acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(127473, NULL, 'G3DSA:3.30.70.330:FF:000917', NULL, NULL, 'Unplaced genomic scaffold supercont1.45, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(127474, NULL, 'G3DSA:3.40.630.10:FF:000062', NULL, NULL, 'Cytosolic carboxypeptidase 6', NULL, NULL, NULL, NULL, NULL, 4),
(127475, NULL, 'G3DSA:3.40.850.10:FF:000078', NULL, NULL, 'Putative Kinesin-7', NULL, NULL, NULL, NULL, NULL, 4),
(127476, NULL, 'G3DSA:1.25.40.20:FF:000921', NULL, NULL, 'S-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(127477, NULL, 'G3DSA:1.25.40.10:FF:004746', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127478, NULL, 'G3DSA:3.40.50.12780:FF:000137', NULL, NULL, 'Probable L-prolyl-AMP ligase PigI', NULL, NULL, NULL, NULL, NULL, 4),
(127479, NULL, 'G3DSA:2.40.50.150:FF:000007', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(127480, NULL, 'G3DSA:1.10.220.160:FF:000003', NULL, NULL, 'Histone-lysine N-methyltransferase SMYD3', NULL, NULL, NULL, NULL, NULL, 4),
(127481, NULL, 'G3DSA:2.60.40.690:FF:000005', NULL, NULL, 'CD109 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(127482, NULL, 'G3DSA:3.40.50.200:FF:000024', NULL, NULL, 'Subtilisin-like protease 2', NULL, NULL, NULL, NULL, NULL, 4),
(127483, NULL, 'G3DSA:1.25.40.10:FF:003335', NULL, NULL, 'TPR repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(127484, NULL, 'G3DSA:1.20.1270.10:FF:000101', NULL, NULL, 'Hsp70 family chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(127485, NULL, 'G3DSA:2.40.30.10:FF:000054', NULL, NULL, 'Translation initiation factor IF-2', NULL, NULL, NULL, NULL, NULL, 4),
(127486, NULL, 'G3DSA:1.10.472.10:FF:000287', NULL, NULL, 'G1/S-specific cyclin-E', NULL, NULL, NULL, NULL, NULL, 4),
(127487, NULL, 'G3DSA:3.30.780.10:FF:000024', NULL, NULL, 'Translation_initiation_factor_SUI1_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(127488, NULL, 'G3DSA:3.30.1680.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127489, NULL, 'G3DSA:1.25.10.10:FF:002018', NULL, NULL, 'Dynein axonemal assembly factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(127490, NULL, 'G3DSA:3.40.630.30:FF:000629', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127491, NULL, 'G3DSA:1.10.437.10:FF:000037', NULL, NULL, 'apoptosis regulator Bcl-2', NULL, NULL, NULL, NULL, NULL, 4),
(127492, NULL, 'G3DSA:2.60.120.200:FF:000109', NULL, NULL, 'Laminin subunit alpha 3', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(127493, NULL, 'G3DSA:2.30.30.40:FF:000114', NULL, NULL, 'Rho GTPase activating protein 42', NULL, NULL, NULL, NULL, NULL, 4),
(127494, NULL, 'G3DSA:3.40.50.10490:FF:000012', NULL, NULL, '40S ribosomal protein SA', NULL, NULL, NULL, NULL, NULL, 4),
(127495, NULL, 'G3DSA:3.30.60.30:FF:000094', NULL, NULL, 'GD12589', NULL, NULL, NULL, NULL, NULL, 4),
(127496, NULL, 'G3DSA:3.10.20.70:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127497, NULL, 'G3DSA:3.40.30.10:FF:000304', NULL, NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(127498, NULL, 'G3DSA:3.30.9.10:FF:000284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127499, NULL, 'G3DSA:2.60.120.380:FF:000017', NULL, NULL, 'Putative kinesin', NULL, NULL, NULL, NULL, NULL, 4),
(127500, NULL, 'G3DSA:3.40.50.300:FF:006962', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(127501, NULL, 'G3DSA:3.40.50.300:FF:007451', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127502, NULL, 'G3DSA:1.10.1520.10:FF:000117', NULL, NULL, 'Dicer-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(127503, NULL, 'G3DSA:3.30.572.10:FF:000001', NULL, NULL, 'Thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(127504, NULL, 'G3DSA:3.10.490.10:FF:000006', NULL, NULL, 'Gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(127505, NULL, 'G3DSA:3.40.850.10:FF:000426', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127506, NULL, 'G3DSA:1.10.167.10:FF:000044', NULL, NULL, 'Rgs2p', NULL, NULL, NULL, NULL, NULL, 4),
(127507, NULL, 'G3DSA:3.30.1120.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127508, NULL, 'G3DSA:2.60.40.150:FF:000164', NULL, NULL, 'Protein unc-13 homolog D', NULL, NULL, NULL, NULL, NULL, 4),
(127509, NULL, 'G3DSA:2.30.29.30:FF:000967', NULL, NULL, 'TBC1 domain family member 2B-like', NULL, NULL, NULL, NULL, NULL, 4),
(127510, NULL, 'G3DSA:1.10.10.10:FF:001905', NULL, NULL, 'O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(127511, NULL, 'G3DSA:3.40.20.10:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127512, NULL, 'G3DSA:3.30.420.10:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127513, NULL, 'G3DSA:3.60.40.10:FF:000198', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(127514, NULL, 'G3DSA:2.60.40.60:FF:000602', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127515, NULL, 'G3DSA:3.40.850.10:FF:000387', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127516, NULL, 'G3DSA:1.25.40.10:FF:003026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127517, NULL, 'G3DSA:2.60.40.790:FF:000142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127518, NULL, 'G3DSA:2.60.40.10:FF:001346', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(127519, NULL, 'G3DSA:3.30.360.10:FF:000043', NULL, NULL, 'Dihydrodiol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(127520, NULL, 'G3DSA:3.30.1360.80:FF:000001', NULL, NULL, 'S-ribosylhomocysteine lyase', NULL, NULL, NULL, NULL, NULL, 4),
(127521, NULL, 'G3DSA:3.10.290.70:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127522, NULL, 'G3DSA:1.25.40.990:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127523, NULL, 'G3DSA:3.30.420.10:FF:000666', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127524, NULL, 'G3DSA:1.25.40.10:FF:003785', NULL, NULL, 'PPR repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(127525, NULL, 'G3DSA:3.40.50.300:FF:000200', NULL, NULL, 'Uridine-cytidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(127526, NULL, 'G3DSA:1.10.238.10:FF:000243', NULL, NULL, 'EF-hand calcium binding domain 6', NULL, NULL, NULL, NULL, NULL, 4),
(127527, NULL, 'G3DSA:2.60.120.650:FF:000194', NULL, NULL, 'Putative lysine-specific demethylase ELF6', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(127528, NULL, 'G3DSA:3.70.10.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127529, NULL, 'G3DSA:3.30.40.10:FF:000137', NULL, NULL, 'RanBP-type and C3HC4-type zinc finger-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(127530, NULL, 'G3DSA:3.30.160.60:FF:001902', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127531, NULL, 'G3DSA:3.60.21.10:FF:000075', NULL, NULL, 'Glideosome-associated protein 50', NULL, NULL, NULL, NULL, NULL, 4),
(127532, NULL, 'G3DSA:3.30.70.330:FF:001160', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(127533, NULL, 'G3DSA:2.60.40.3230:FF:000001', NULL, NULL, 'DUF1425 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(127534, NULL, 'G3DSA:3.30.30.30:FF:000070', NULL, NULL, 'Heat shock protein 70 family', NULL, NULL, NULL, NULL, NULL, 4),
(127535, NULL, 'G3DSA:3.55.40.20:FF:000005', NULL, NULL, 'Superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(127536, NULL, 'G3DSA:3.90.190.10:FF:000038', NULL, NULL, 'Tyrosine-protein phosphatase CDC14', NULL, NULL, NULL, NULL, NULL, 4),
(127537, NULL, 'G3DSA:3.30.1320.10:FF:000023', NULL, NULL, '30S ribosomal protein S16', NULL, NULL, NULL, NULL, NULL, 4),
(127538, NULL, 'G3DSA:2.170.300.10:FF:000072', NULL, NULL, 'Multiple epidermal growth factor-like domains 6', NULL, NULL, NULL, NULL, NULL, 4),
(127539, NULL, 'G3DSA:1.10.10.10:FF:001557', NULL, NULL, 'Pca regulon regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(127540, NULL, 'G3DSA:2.10.25.10:FF:001611', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127541, NULL, 'G3DSA:3.40.50.11660:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127542, NULL, 'G3DSA:3.30.160.60:FF:004067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127543, NULL, 'G3DSA:3.30.160.60:FF:003448', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127544, NULL, 'G3DSA:3.50.50.60:FF:001152', NULL, NULL, 'Choline dehydrogenase, like protein', NULL, NULL, NULL, NULL, NULL, 4),
(127545, NULL, 'G3DSA:3.30.530.20:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127546, NULL, 'G3DSA:1.25.40.20:FF:000606', NULL, NULL, 'Os01g0943800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(127547, NULL, 'G3DSA:3.80.10.10:FF:002437', NULL, NULL, 'F-box/LRR-repeat protein 3 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(127548, NULL, 'G3DSA:3.40.50.10860:FF:000011', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(127549, NULL, 'G3DSA:3.60.10.10:FF:000263', NULL, NULL, 'Deoxyribonuclease 1-like 4, tandem duplicate 2', NULL, NULL, NULL, NULL, NULL, 4),
(127550, NULL, 'G3DSA:1.50.10.10:FF:000004', NULL, NULL, 'Phosphorylase b kinase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(127551, NULL, 'G3DSA:2.160.20.70:FF:000021', NULL, NULL, 'Adenylyl cyclase-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(127552, NULL, 'G3DSA:3.30.160.60:FF:005157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127553, NULL, 'G3DSA:2.40.50.120:FF:000009', NULL, NULL, 'Complement C4-A', NULL, NULL, NULL, NULL, NULL, 4),
(127554, NULL, 'G3DSA:3.30.70.1730:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127555, NULL, 'G3DSA:3.20.20.80:FF:000191', NULL, NULL, 'Mannosylglycoprotein endo-beta-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(127556, NULL, 'G3DSA:3.30.70.980:FF:000045', NULL, NULL, 'Probable transcriptional regulatory protein A1E_02520', NULL, NULL, NULL, NULL, NULL, 4),
(127557, NULL, 'G3DSA:1.25.40.10:FF:000132', NULL, NULL, 'Histone-lysine N-methyltransferase SMYD1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(127558, NULL, 'G3DSA:3.40.640.10:FF:000489', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127559, NULL, 'G3DSA:1.10.238.10:FF:001277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127560, NULL, 'G3DSA:3.90.45.10:FF:000022', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(127561, NULL, 'G3DSA:3.40.50.720:FF:002327', NULL, NULL, 'AGAP009611-PA', NULL, NULL, NULL, NULL, NULL, 4),
(127562, NULL, 'G3DSA:3.20.20.150:FF:000047', NULL, NULL, 'Xylose isomerase domain protein TIM barrel', NULL, NULL, NULL, NULL, NULL, 4),
(127563, NULL, 'G3DSA:3.40.50.150:FF:001280', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127564, NULL, 'G3DSA:1.20.120.610:FF:000017', NULL, NULL, 'V-type proton ATPase proteolipid subunit', NULL, NULL, NULL, NULL, NULL, 4),
(127565, NULL, 'G3DSA:3.30.50.10:FF:000166', NULL, NULL, 'Protein CBG26996', NULL, NULL, NULL, NULL, NULL, 4),
(127566, NULL, 'G3DSA:3.80.10.10:FF:003966', NULL, NULL, 'Si:dkey-27n6.4', NULL, NULL, NULL, NULL, NULL, 4),
(127567, NULL, 'G3DSA:3.90.226.10:FF:000302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127568, NULL, 'G3DSA:1.10.10.440:FF:000030', NULL, NULL, 'Pre-mRNA-processing protein 40C', NULL, NULL, NULL, NULL, NULL, 4),
(127569, NULL, 'G3DSA:1.10.565.10:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127570, NULL, 'G3DSA:3.40.50.300:FF:001139', NULL, NULL, 'Orf1ab polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(127571, NULL, 'G3DSA:3.40.50.11530:FF:000004', NULL, NULL, 'Interleukin 17 receptor B', NULL, NULL, NULL, NULL, NULL, 4),
(127572, NULL, 'G3DSA:3.30.1360.120:FF:000020', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(127573, NULL, 'G3DSA:1.25.40.420:FF:000019', NULL, NULL, 'Kelch-like 11 (Drosophila) (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(127574, NULL, 'G3DSA:3.30.70.330:FF:001845', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127575, NULL, 'G3DSA:1.10.287.460:FF:000002', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(127576, NULL, 'G3DSA:1.20.120.1760:FF:000083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127577, NULL, 'G3DSA:1.20.960.10:FF:000008', NULL, NULL, 'Translocase of outer mitochondrial membrane 20 like', NULL, NULL, NULL, NULL, NULL, 4),
(127578, NULL, 'G3DSA:3.30.200.20:FF:001069', NULL, NULL, 'Os12g0427100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(127579, NULL, 'G3DSA:3.40.50.300:FF:002229', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(127580, NULL, 'G3DSA:2.60.120.620:FF:000090', NULL, NULL, '2-oxoglutarate and iron-dependent oxygenase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(127581, NULL, 'G3DSA:3.40.50.1820:FF:000470', NULL, NULL, 'Dipeptidyl-peptidase 5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(127582, NULL, 'G3DSA:3.10.100.10:FF:000276', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127583, NULL, 'G3DSA:3.10.20.90:FF:000059', NULL, NULL, 'Microtubule-associated proteins 1A/1B light chain 3B', NULL, NULL, NULL, NULL, NULL, 4),
(127584, NULL, 'G3DSA:3.30.1370.10:FF:000099', NULL, NULL, 'Pbp2p', NULL, NULL, NULL, NULL, NULL, 4),
(127585, NULL, 'G3DSA:3.40.50.300:FF:008272', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(127586, NULL, 'G3DSA:1.10.10.750:FF:000004', NULL, NULL, 'Putative rab gtpase-activating protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(127587, NULL, 'G3DSA:3.40.50.1820:FF:000245', NULL, NULL, 'Alpha/beta fold hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(127588, NULL, 'G3DSA:3.90.440.10:FF:000002', NULL, NULL, 'Nitric oxide synthase oxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(127589, NULL, 'G3DSA:1.25.40.10:FF:001548', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g30825, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(127590, NULL, 'G3DSA:1.20.58.390:FF:000137', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(127591, NULL, 'G3DSA:3.40.640.10:FF:000124', NULL, NULL, 'Acetylornithine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(127592, NULL, 'G3DSA:1.10.287.70:FF:000508', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127593, NULL, 'G3DSA:1.10.510.10:FF:000848', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(127594, NULL, 'G3DSA:1.10.210.20:FF:000002', NULL, NULL, '1H-3-hydroxy-4-oxoquinoline 2,4-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(127595, NULL, 'G3DSA:1.25.40.10:FF:002638', NULL, NULL, 'Im:7136784 protein', NULL, NULL, NULL, NULL, NULL, 4),
(127596, NULL, 'G3DSA:3.20.20.10:FF:000007', NULL, NULL, 'Pyridoxal phosphate homeostasis protein', NULL, NULL, NULL, NULL, NULL, 4),
(127597, NULL, 'G3DSA:1.25.40.20:FF:000230', NULL, NULL, 'transient receptor potential cation channel subfamily V member 6', NULL, NULL, NULL, NULL, NULL, 4),
(127598, NULL, 'G3DSA:2.30.31.10:FF:000006', NULL, NULL, 'Putative RNA polymerase II transcriptional coactivator', NULL, NULL, NULL, NULL, NULL, 4),
(127599, NULL, 'G3DSA:3.40.50.10330:FF:000083', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(127600, NULL, 'G3DSA:3.40.1110.10:FF:000027', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(127601, NULL, 'G3DSA:1.10.510.10:FF:003119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127602, NULL, 'G3DSA:3.40.50.1820:FF:000722', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(127603, NULL, 'G3DSA:1.10.630.10:FF:000323', NULL, NULL, 'Cytochrome P450 71B10', NULL, NULL, NULL, NULL, NULL, 4),
(127604, NULL, 'G3DSA:1.20.1560.10:FF:000657', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127605, NULL, 'G3DSA:3.30.450.20:FF:000019', NULL, NULL, 'Aryl hydrocarbon receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(127606, NULL, 'G3DSA:3.40.50.1820:FF:000953', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127607, NULL, 'G3DSA:3.40.50.200:FF:000154', NULL, NULL, 'Subtilisin-like serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(127608, NULL, 'G3DSA:1.10.30.10:FF:000142', NULL, NULL, 'PMS1 homolog 1, mismatch repair system component', NULL, NULL, NULL, NULL, NULL, 4),
(127609, NULL, 'G3DSA:1.20.1740.10:FF:000047', NULL, NULL, 'Amino acid transporter AVT1A', NULL, NULL, NULL, NULL, NULL, 4),
(127610, NULL, 'G3DSA:1.20.120.1080:FF:000070', NULL, NULL, 'ATP-dependent RNA helicase DQX1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(127611, NULL, 'G3DSA:3.30.60.270:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127612, NULL, 'G3DSA:3.20.70.20:FF:000041', NULL, NULL, 'Ribonucleotide reductase catalytic subunit M1', NULL, NULL, NULL, NULL, NULL, 4),
(127613, NULL, 'G3DSA:1.20.1250.20:FF:001620', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127614, NULL, 'G3DSA:1.25.40.10:FF:001913', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(127615, NULL, 'G3DSA:2.60.120.10:FF:000314', NULL, NULL, 'Cyclic nucleotide dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(127616, NULL, 'G3DSA:3.30.70.330:FF:002464', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127617, NULL, 'G3DSA:3.90.550.10:FF:000140', NULL, NULL, 'Procollagen-lysine,2-oxoglutarate 5-dioxygenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(127618, NULL, 'G3DSA:2.40.128.620:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127619, NULL, 'G3DSA:2.70.170.10:FF:000091', NULL, NULL, 'Gamma-aminobutyric acid type A receptor alpha2 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(127620, NULL, 'G3DSA:3.40.30.10:FF:001176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127621, NULL, 'G3DSA:1.25.40.20:FF:001450', NULL, NULL, 'AGAP001061-PB', NULL, NULL, NULL, NULL, NULL, 4),
(127622, NULL, 'G3DSA:3.60.40.10:FF:000091', NULL, NULL, 'Stage II sporulation protein E', NULL, NULL, NULL, NULL, NULL, 4),
(127623, NULL, 'G3DSA:2.40.50.510:FF:000003', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(127624, NULL, 'G3DSA:3.80.10.10:FF:004371', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127625, NULL, 'G3DSA:2.60.220.50:FF:000025', NULL, NULL, 'Adhesion G protein-coupled receptor G7', NULL, NULL, NULL, NULL, NULL, 4),
(127626, NULL, 'G3DSA:2.40.50.100:FF:000217', NULL, NULL, 'Sugar ABC transportor, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(127627, NULL, 'G3DSA:2.40.30.10:FF:000138', NULL, NULL, 'Eukaryotic peptide chain release factor GTP-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(127628, NULL, 'G3DSA:3.40.1090.10:FF:000002', NULL, NULL, 'Phospholipase A2', NULL, NULL, NULL, NULL, NULL, 4),
(127629, NULL, 'G3DSA:1.10.10.10:FF:001293', NULL, NULL, 'Putative zinc-dependent repressor ZntR, DtxR superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(127630, NULL, 'G3DSA:2.40.20.10:FF:000003', NULL, NULL, 'Inactive tyrosine-protein kinase transmembrane receptor ROR1', NULL, NULL, NULL, NULL, NULL, 4),
(127631, NULL, 'G3DSA:3.30.70.330:FF:001952', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127632, NULL, 'G3DSA:3.30.200.20:FF:001597', NULL, NULL, 'Receptor-like serine/threonine-protein kinase SD1-8', NULL, NULL, NULL, NULL, NULL, 4),
(127633, NULL, 'G3DSA:1.20.1280.50:FF:000147', NULL, NULL, 'Os05g0139300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(127634, NULL, 'G3DSA:3.30.9.10:FF:000177', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(127635, NULL, 'G3DSA:1.10.472.80:FF:000032', NULL, NULL, 'TBC1 domain family member 24 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(127636, NULL, 'G3DSA:2.40.70.10:FF:000028', NULL, NULL, 'Eukaryotic aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(127637, NULL, 'G3DSA:3.30.230.10:FF:000275', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(127638, NULL, 'G3DSA:1.10.8.10:FF:000252', NULL, NULL, 'inhibitor of apoptosis protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(127639, NULL, 'G3DSA:2.60.120.10:FF:000005', NULL, NULL, 'Germin-like protein subfamily 1 member 8', NULL, NULL, NULL, NULL, NULL, 4),
(127640, NULL, 'G3DSA:3.40.50.800:FF:000108', NULL, NULL, 'AER105Wp', NULL, NULL, NULL, NULL, NULL, 4),
(127641, NULL, 'G3DSA:3.10.129.10:FF:000229', NULL, NULL, 'Acyl-CoA thioesterase 12', NULL, NULL, NULL, NULL, NULL, 4),
(127642, NULL, 'G3DSA:3.10.20.90:FF:000823', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(127643, NULL, 'G3DSA:2.130.10.10:FF:003359', NULL, NULL, 'Apoptotic protease-activating factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(127644, NULL, 'G3DSA:2.60.120.920:FF:000073', NULL, NULL, 'Butyrophilin like 3', NULL, NULL, NULL, NULL, NULL, 4),
(127645, NULL, 'G3DSA:3.30.40.10:FF:001290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127646, NULL, 'G3DSA:4.10.1080.10:FF:000002', NULL, NULL, 'Thrombospondin 3', NULL, NULL, NULL, NULL, NULL, 4),
(127647, NULL, 'G3DSA:2.60.40.10:FF:003235', NULL, NULL, 'Erythropoietin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(127648, NULL, 'G3DSA:3.30.40.10:FF:000890', NULL, NULL, 'PHD finger protein EHD3', NULL, NULL, NULL, NULL, NULL, 4),
(127649, NULL, 'G3DSA:2.40.50.140:FF:000875', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127650, NULL, 'G3DSA:3.40.50.880:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127651, NULL, 'G3DSA:1.20.5.170:FF:000274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127652, NULL, 'G3DSA:2.60.40.10:FF:001453', NULL, NULL, 'Turtle, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(127653, NULL, 'G3DSA:4.10.110.10:FF:000008', NULL, NULL, 'mucin-5AC isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(127654, NULL, 'G3DSA:3.30.200.20:FF:001288', NULL, NULL, 'Spore coat protein', NULL, NULL, NULL, NULL, NULL, 4),
(127655, NULL, 'G3DSA:1.25.10.10:FF:001400', NULL, NULL, 'Protein VAC14 homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(127656, NULL, 'G3DSA:3.40.50.10470:FF:000017', NULL, NULL, 'eIF2B 34 kDa alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(127657, NULL, 'G3DSA:3.40.1030.10:FF:000010', NULL, NULL, 'Anthranilate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(127658, NULL, 'G3DSA:3.30.160.60:FF:000014', NULL, NULL, 'Transcription factor Sp3', NULL, NULL, NULL, NULL, NULL, 4),
(127659, NULL, 'G3DSA:3.40.50.300:FF:007344', NULL, NULL, 'RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(127660, NULL, 'G3DSA:1.20.1560.10:FF:000876', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(127661, NULL, 'G3DSA:1.20.5.270:FF:000006', NULL, NULL, 'Cytochrome b-c1 complex subunit Rieske, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(127662, NULL, 'G3DSA:1.10.510.10:FF:004182', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127663, NULL, 'G3DSA:3.40.120.10:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127664, NULL, 'G3DSA:1.10.150.80:FF:000026', NULL, NULL, 'ATP-dependent DEAD/H DNA helicase recQ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(127665, NULL, 'G3DSA:4.10.280.110:FF:000003', NULL, NULL, 'Pre-mRNA splicing factor, variant', NULL, NULL, NULL, NULL, NULL, 4),
(127666, NULL, 'G3DSA:1.10.238.10:FF:000552', NULL, NULL, 'Probable mitochondrial carrier protein ARALAR1', NULL, NULL, NULL, NULL, NULL, 4),
(127667, NULL, 'G3DSA:2.40.50.690:FF:000012', NULL, NULL, 'DIS3-like exonuclease 2', NULL, NULL, NULL, NULL, NULL, 4),
(127668, NULL, 'G3DSA:1.25.40.120:FF:000036', NULL, NULL, 'GM18897', NULL, NULL, NULL, NULL, NULL, 4),
(127669, NULL, 'G3DSA:2.60.40.10:FF:002982', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127670, NULL, 'G3DSA:3.40.50.720:FF:001057', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(127671, NULL, 'G3DSA:1.25.40.10:FF:003566', NULL, NULL, 'Tetratricopeptide repeat protein 21B', NULL, NULL, NULL, NULL, NULL, 4),
(127672, NULL, 'G3DSA:3.90.70.10:FF:000552', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127673, NULL, 'G3DSA:3.90.190.10:FF:000584', NULL, NULL, 'Si:ch1073-391i24.1', NULL, NULL, NULL, NULL, NULL, 4),
(127674, NULL, 'G3DSA:3.40.50.1000:FF:000224', NULL, NULL, 'Hydrolase, haloacid dehalogenase-like family', NULL, NULL, NULL, NULL, NULL, 4),
(127675, NULL, 'G3DSA:1.20.1250.20:FF:002345', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(127676, NULL, 'G3DSA:3.40.390.10:FF:000054', NULL, NULL, 'Blast:Endothelin-converting enzyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(127677, NULL, 'G3DSA:3.50.30.10:FF:000001', NULL, NULL, 'Phosphoenolpyruvate-protein phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(127678, NULL, 'G3DSA:3.40.50.300:FF:003634', NULL, NULL, 'Os11g0649000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(127679, NULL, 'G3DSA:3.30.810.10:FF:000005', NULL, NULL, 'Phosphatidylinositol 4-phosphate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(127680, NULL, 'G3DSA:2.60.40.1180:FF:000009', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(127681, NULL, 'G3DSA:2.170.130.20:FF:000005', NULL, NULL, 'Multidomain scavenger receptor', NULL, NULL, NULL, NULL, NULL, 4),
(127682, NULL, 'G3DSA:3.30.930.10:FF:000261', NULL, NULL, 'Phenylalanine--tRNA ligase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(127683, NULL, 'G3DSA:2.10.220.10:FF:000075', NULL, NULL, 'Fraser extracellular matrix complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(127684, NULL, 'G3DSA:1.25.40.180:FF:000155', NULL, NULL, 'Nonsense-mediated mRNA decay protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(127685, NULL, 'G3DSA:1.10.472.10:FF:000394', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127686, NULL, 'G3DSA:3.30.70.330:FF:001391', NULL, NULL, 'Cytoplasmic polyadenylation element-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(127687, NULL, 'G3DSA:1.20.1310.20:FF:000041', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(127688, NULL, 'G3DSA:3.30.470.20:FF:000127', NULL, NULL, 'ATP-citrate synthase alpha chain protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(127689, NULL, 'G3DSA:1.25.40.10:FF:000929', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127690, NULL, 'G3DSA:3.40.50.300:FF:003073', NULL, NULL, 'Lipopolysaccharide biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(127691, NULL, 'G3DSA:4.10.60.10:FF:000249', NULL, NULL, 'Rothmund-thomson syndrome DNA helicase recq4, putative', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(127692, NULL, 'G3DSA:3.40.50.2300:FF:001468', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127693, NULL, 'G3DSA:1.10.555.10:FF:000002', NULL, NULL, 'rho GTPase-activating protein 32 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(127694, NULL, 'G3DSA:2.60.120.920:FF:000106', NULL, NULL, 'Ring finger protein 123', NULL, NULL, NULL, NULL, NULL, 4),
(127695, NULL, 'G3DSA:1.25.40.10:FF:003257', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(127696, NULL, 'G3DSA:1.10.220.10:FF:000040', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(127697, NULL, 'G3DSA:1.10.10.10:FF:001304', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(127698, NULL, 'G3DSA:3.90.550.50:FF:000101', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(127699, NULL, 'G3DSA:3.40.30.10:FF:000226', NULL, NULL, 'Thioredoxin domain containing 16', NULL, NULL, NULL, NULL, NULL, 4),
(127700, NULL, 'G3DSA:3.30.160.60:FF:003139', NULL, NULL, 'Zinc finger protein 1144', NULL, NULL, NULL, NULL, NULL, 4),
(127701, NULL, 'G3DSA:3.40.710.10:FF:000141', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(127702, NULL, 'G3DSA:3.40.50.1010:FF:000013', NULL, NULL, 'Constitutive coactivator of peroxisome proliferator-activated receptor gamma', NULL, NULL, NULL, NULL, NULL, 4),
(127703, NULL, 'G3DSA:2.40.40.20:FF:000007', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(127704, NULL, 'G3DSA:1.10.472.80:FF:000246', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127705, NULL, 'G3DSA:1.20.1560.10:FF:000168', NULL, NULL, 'ABC transporter ATP-binding protein/permease', NULL, NULL, NULL, NULL, NULL, 4),
(127706, NULL, 'G3DSA:2.60.40.10:FF:005505', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127707, NULL, 'G3DSA:2.60.40.10:FF:001998', NULL, NULL, 'Unc-89 protein', NULL, NULL, NULL, NULL, NULL, 4),
(127708, NULL, 'G3DSA:1.25.10.10:FF:003165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127709, NULL, 'G3DSA:3.90.70.10:FF:000243', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(127710, NULL, 'G3DSA:3.90.640.10:FF:000219', NULL, NULL, 'Actin-related protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(127711, NULL, 'G3DSA:3.40.50.300:FF:000414', NULL, NULL, 'ATP-dependent RNA helicase DHX30 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(127712, NULL, 'G3DSA:3.80.10.10:FF:001712', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', NULL, NULL, NULL, NULL, NULL, 4),
(127713, NULL, 'G3DSA:3.40.50.410:FF:000099', NULL, NULL, 'Yku70p', NULL, NULL, NULL, NULL, NULL, 4),
(127714, NULL, 'G3DSA:2.60.120.200:FF:000553', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127715, NULL, 'G3DSA:3.40.1110.10:FF:000483', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127716, NULL, 'G3DSA:3.30.160.60:FF:002830', NULL, NULL, 'Zinc finger protein ZAT11', NULL, NULL, NULL, NULL, NULL, 4),
(127717, NULL, 'G3DSA:1.10.730.10:FF:000123', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(127718, NULL, 'G3DSA:1.10.238.10:FF:001171', NULL, NULL, 'Secreted protein, acidic, cysteine-rich (osteonectin)', NULL, NULL, NULL, NULL, NULL, 4),
(127719, NULL, 'G3DSA:3.30.70.330:FF:000772', NULL, NULL, 'Putative RNA binding ribonucleoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(127720, NULL, 'G3DSA:1.25.40.470:FF:000012', NULL, NULL, 'intraflagellar transport protein 172 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(127721, NULL, 'G3DSA:1.20.5.350:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127722, NULL, 'G3DSA:3.90.1150.10:FF:000086', NULL, NULL, 'Putative acetylornithine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(127723, NULL, 'G3DSA:3.30.70.1230:FF:000245', NULL, NULL, 'Atrial natriuretic peptide receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(127724, NULL, 'G3DSA:3.20.20.140:FF:000168', NULL, NULL, 'Predicted metal-dependent hydrolase, TIM-barrel fold', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(127725, NULL, 'G3DSA:3.40.50.11260:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127726, NULL, 'G3DSA:3.10.110.10:FF:000102', NULL, NULL, 'Os02g0721100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(127727, NULL, 'G3DSA:2.30.39.10:FF:000018', NULL, NULL, 'Angiotensinogen', NULL, NULL, NULL, NULL, NULL, 4),
(127728, NULL, 'G3DSA:3.30.450.20:FF:000480', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127729, NULL, 'G3DSA:2.60.40.640:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127730, NULL, 'G3DSA:1.10.1870.10:FF:000020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(127731, NULL, 'G3DSA:3.30.559.10:FF:000268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127732, NULL, 'G3DSA:1.20.1070.10:FF:001266', NULL, NULL, 'low-density lipoprotein receptor-related protein 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(127733, NULL, 'G3DSA:1.10.10.60:FF:000785', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127734, NULL, 'G3DSA:3.30.70.270:FF:000276', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127735, NULL, 'G3DSA:3.40.50.300:FF:001847', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(127736, NULL, 'G3DSA:1.20.90.10:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127737, NULL, 'G3DSA:2.70.98.20:FF:000026', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(127738, NULL, 'G3DSA:2.60.120.480:FF:000007', NULL, NULL, 'Ureidoglycolate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(127739, NULL, 'G3DSA:3.40.1550.10:FF:000010', NULL, NULL, 'Chemotaxis protein CheX', NULL, NULL, NULL, NULL, NULL, 4),
(127740, NULL, 'G3DSA:3.30.70.370:FF:000008', NULL, NULL, 'DNA polymerase nu', NULL, NULL, NULL, NULL, NULL, 4),
(127741, NULL, 'G3DSA:1.10.238.10:FF:000895', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127742, NULL, 'G3DSA:3.40.605.10:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127743, NULL, 'G3DSA:3.40.50.300:FF:004253', NULL, NULL, 'Spermatogenesis-associated 5', NULL, NULL, NULL, NULL, NULL, 4),
(127744, NULL, 'G3DSA:2.40.50.140:FF:000566', NULL, NULL, 'Unplaced genomic scaffold supercont1.10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(127745, NULL, 'G3DSA:3.90.730.10:FF:000013', NULL, NULL, 'Ribonuclease T', NULL, NULL, NULL, NULL, NULL, 4),
(127746, NULL, 'G3DSA:3.40.50.150:FF:000352', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(127747, NULL, 'G3DSA:1.10.400.10:FF:000059', NULL, NULL, 'AGAP005773-PA', NULL, NULL, NULL, NULL, NULL, 4),
(127748, NULL, 'G3DSA:1.10.1200.270:FF:000018', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(127749, NULL, 'G3DSA:2.60.40.1730:FF:000074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127750, NULL, 'G3DSA:3.30.460.10:FF:000079', NULL, NULL, 'PAP-associated domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(127751, NULL, 'G3DSA:1.20.5.170:FF:000089', NULL, NULL, 'Putative global transcription activator SNF2L2', NULL, NULL, NULL, NULL, NULL, 4),
(127752, NULL, 'G3DSA:3.40.50.1440:FF:000024', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(127753, NULL, 'G3DSA:1.20.58.1210:FF:000005', NULL, NULL, 'EXOCyst component', NULL, NULL, NULL, NULL, NULL, 4),
(127754, NULL, 'G3DSA:1.20.1250.20:FF:002093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127755, NULL, 'G3DSA:2.130.10.10:FF:003578', NULL, NULL, 'Regulatory-associated protein of TOR 1', NULL, NULL, NULL, NULL, NULL, 4),
(127756, NULL, 'G3DSA:3.30.40.10:FF:000901', NULL, NULL, 'RING finger protein B', NULL, NULL, NULL, NULL, NULL, 4),
(127757, NULL, 'G3DSA:3.80.10.10:FF:000329', NULL, NULL, 'Tonsoku like, DNA repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(127758, NULL, 'G3DSA:1.25.40.70:FF:000020', NULL, NULL, 'Phosphatidylinositol 4-kinase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(127759, NULL, 'G3DSA:3.90.930.1:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127760, NULL, 'G3DSA:2.60.40.10:FF:000273', NULL, NULL, 'contactin-3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(127761, NULL, 'G3DSA:3.40.50.300:FF:005742', NULL, NULL, 'ATP-dependent nuclease subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(127762, NULL, 'G3DSA:3.30.160.60:FF:004775', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127763, NULL, 'G3DSA:2.170.300.10:FF:000049', NULL, NULL, 'Adhesion G protein-coupled receptor L3', NULL, NULL, NULL, NULL, NULL, 4),
(127764, NULL, 'G3DSA:3.30.300.10:FF:000051', NULL, NULL, 'S-adenosylmethionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(127765, NULL, 'G3DSA:3.30.200.20:FF:001524', NULL, NULL, 'Cyclin-dependent kinase G-1', NULL, NULL, NULL, NULL, NULL, 4),
(127766, NULL, 'G3DSA:3.30.70.260:FF:000178', NULL, NULL, 'Aspartokinase 1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(127767, NULL, 'G3DSA:1.25.40.90:FF:000026', NULL, NULL, 'RNA binding protein Nrd1', NULL, NULL, NULL, NULL, NULL, 4),
(127768, NULL, 'G3DSA:1.20.120.1240:FF:000045', NULL, NULL, 'Dynamin-related protein,putative', NULL, NULL, NULL, NULL, NULL, 4),
(127769, NULL, 'G3DSA:3.40.50.720:FF:000309', NULL, NULL, 'synaptic vesicle membrane protein VAT-1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(127770, NULL, 'G3DSA:1.20.1560.10:FF:000404', NULL, NULL, 'ABC transporter protein AtrC', NULL, NULL, NULL, NULL, NULL, 4),
(127771, NULL, 'G3DSA:2.80.10.50:FF:000243', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(127772, NULL, 'G3DSA:2.10.25.10:FF:001050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127773, NULL, 'G3DSA:3.30.160.60:FF:001341', NULL, NULL, 'Zinc finger and SCAN domain containing 10', NULL, NULL, NULL, NULL, NULL, 4),
(127774, NULL, 'G3DSA:2.130.10.10:FF:001633', NULL, NULL, 'Chromosome transmission fidelity 4', NULL, NULL, NULL, NULL, NULL, 4),
(127775, NULL, 'G3DSA:1.10.630.10:FF:000632', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127776, NULL, 'G3DSA:2.130.10.10:FF:000796', NULL, NULL, 'Splicing factor 3B subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(127777, NULL, 'G3DSA:3.40.50.720:FF:001602', NULL, NULL, 'NT5C1B-RDH14 readthrough', NULL, NULL, NULL, NULL, NULL, 4),
(127778, NULL, 'G3DSA:3.40.1280.30:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127779, NULL, 'G3DSA:3.40.50.150:FF:001313', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127780, NULL, 'G3DSA:3.40.50.970:FF:000154', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(127781, NULL, 'G3DSA:1.10.390.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127782, NULL, 'G3DSA:3.40.190.10:FF:000179', NULL, NULL, 'Glycine/betaine ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(127783, NULL, 'G3DSA:1.10.560.10:FF:000076', NULL, NULL, 'T-complex protein 1 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(127784, NULL, 'G3DSA:1.25.40.20:FF:001085', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(127785, NULL, 'G3DSA:4.10.900.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127786, NULL, 'G3DSA:1.50.40.10:FF:000540', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127787, NULL, 'G3DSA:3.15.20.10:FF:000014', NULL, NULL, 'Lipid-binding serum glycoprotein family protein', NULL, NULL, NULL, NULL, NULL, 4),
(127788, NULL, 'G3DSA:2.40.10.10:FF:000362', NULL, NULL, 'Coagulation factor VII', NULL, NULL, NULL, NULL, NULL, 4),
(127789, NULL, 'G3DSA:1.10.10.790:FF:000005', NULL, NULL, 'Splicing factor, suppressor of white-apricot homolog', NULL, NULL, NULL, NULL, NULL, 4),
(127790, NULL, 'G3DSA:3.30.1360.70:FF:000009', NULL, NULL, 'Arginine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(127791, NULL, 'G3DSA:2.30.29.30:FF:000147', NULL, NULL, 'SH3 domain-binding protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(127792, NULL, 'G3DSA:3.40.50.2000:FF:000878', NULL, NULL, 'Glycosyl transferase, group 1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(127793, NULL, 'G3DSA:3.40.50.10140:FF:000014', NULL, NULL, 'TIR domain-containing adapter molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(127794, NULL, 'G3DSA:3.40.630.10:FF:000298', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(127795, NULL, 'G3DSA:3.30.530.20:FF:000205', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(127796, NULL, 'G3DSA:3.40.50.450:FF:000009', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(127797, NULL, 'G3DSA:1.20.1270.140:FF:000001', NULL, NULL, 'Type III effector protein AvrPto1', NULL, NULL, NULL, NULL, NULL, 4),
(127798, NULL, 'G3DSA:3.40.50.300:FF:002123', NULL, NULL, 'ATP-binding cassette bilirubin transporter', NULL, NULL, NULL, NULL, NULL, 4),
(127799, NULL, 'G3DSA:3.30.200.20:FF:001833', NULL, NULL, 'Putative muscle m-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(127800, NULL, 'G3DSA:3.40.50.12550:FF:000001', NULL, NULL, 'Ubiquitin-activating enzyme E1 1', NULL, NULL, NULL, NULL, NULL, 4),
(127801, NULL, 'G3DSA:3.30.450.40:FF:000014', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(127802, NULL, 'G3DSA:1.10.1070.11:FF:000140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127803, NULL, 'G3DSA:3.40.190.10:FF:000634', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(127804, NULL, 'G3DSA:3.80.10.10:FF:002893', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127805, NULL, 'G3DSA:3.40.140.10:FF:000232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127806, NULL, 'G3DSA:2.70.150.10:FF:000016', NULL, NULL, 'Calcium-transporting P-type ATPase putative', NULL, NULL, NULL, NULL, NULL, 4),
(127807, NULL, 'G3DSA:2.60.120.260:FF:000200', NULL, NULL, 'Beta-mannosidase A', NULL, NULL, NULL, NULL, NULL, 4),
(127808, NULL, 'G3DSA:3.40.50.300:FF:005557', NULL, NULL, 'Protein SMAX1-LIKE 5', NULL, NULL, NULL, NULL, NULL, 4),
(127809, NULL, 'G3DSA:1.10.510.10:FF:002613', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127810, NULL, 'G3DSA:3.30.160.60:FF:006012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127811, NULL, 'G3DSA:2.130.10.10:FF:001780', NULL, NULL, 'Cirrhosis, autosomal recessive 1A (Cirhin)', NULL, NULL, NULL, NULL, NULL, 4),
(127812, NULL, 'G3DSA:3.30.2130.10:FF:000014', NULL, NULL, 'Aspartate kinase, monofunctional class', NULL, NULL, NULL, NULL, NULL, 4),
(127813, NULL, 'G3DSA:2.130.10.10:FF:001105', NULL, NULL, 'WD40-repeat-containing domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(127814, NULL, 'G3DSA:1.20.1530.20:FF:000113', NULL, NULL, 'K(+) efflux antiporter 3 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(127815, NULL, 'G3DSA:3.40.366.10:FF:000037', NULL, NULL, 'Malonyl CoA-acyl carrier protein transacylase', NULL, NULL, NULL, NULL, NULL, 4),
(127816, NULL, 'G3DSA:3.80.10.10:FF:001965', NULL, NULL, 'F-box/LRR-repeat protein At3g48880', NULL, NULL, NULL, NULL, NULL, 4),
(127817, NULL, 'G3DSA:3.40.50.720:FF:000438', NULL, NULL, 'Os06g0299100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(127818, NULL, 'G3DSA:3.30.110.20:FF:000005', NULL, NULL, 'Uncharacterized protein At2g34160', NULL, NULL, NULL, NULL, NULL, 4),
(127819, NULL, 'G3DSA:1.20.58.2220:FF:000011', NULL, NULL, 'Inverted formin, FH2 and WH2 domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(127820, NULL, 'G3DSA:1.10.8.60:FF:000166', NULL, NULL, 'DNA polymerase III subunit gamma/tau', NULL, NULL, NULL, NULL, NULL, 4),
(127821, NULL, 'G3DSA:1.10.196.10:FF:000015', NULL, NULL, 'Axin-1', NULL, NULL, NULL, NULL, NULL, 4),
(127822, NULL, 'G3DSA:1.20.1640.10:FF:000006', NULL, NULL, 'Protein-export membrane protein SecF', NULL, NULL, NULL, NULL, NULL, 4),
(127823, NULL, 'G3DSA:1.20.58.340:FF:000038', NULL, NULL, 'Magnesium transporter MRS2-C', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(127824, NULL, 'G3DSA:2.60.40.60:FF:000838', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127825, NULL, 'G3DSA:2.30.29.30:FF:001131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127826, NULL, 'G3DSA:3.40.50.300:FF:000178', NULL, NULL, 'Arf-GAP with GTPase, ANK repeat and PH domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(127827, NULL, 'G3DSA:3.40.50.300:FF:000886', NULL, NULL, 'Putative GTP-binding protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(127828, NULL, 'G3DSA:3.30.40.10:FF:002138', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(127829, NULL, 'G3DSA:3.40.50.300:FF:007996', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127830, NULL, 'G3DSA:3.40.50.720:FF:000984', NULL, NULL, 'Dihydroflavonol 4-reductase family', NULL, NULL, NULL, NULL, NULL, 4),
(127831, NULL, 'G3DSA:1.25.40.10:FF:001677', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At3g49142', NULL, NULL, NULL, NULL, NULL, 4),
(127832, NULL, 'G3DSA:2.60.40.10:FF:003454', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127833, NULL, 'G3DSA:1.20.1730.10:FF:000018', NULL, NULL, 'Transporter, SSS family', NULL, NULL, NULL, NULL, NULL, 4),
(127834, NULL, 'G3DSA:2.10.270.10:FF:000005', NULL, NULL, 'Lysozyme', NULL, NULL, NULL, NULL, NULL, 4),
(127835, NULL, 'G3DSA:3.40.50.150:FF:000661', NULL, NULL, 'NOL1/NOP2/sun family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(127836, NULL, 'G3DSA:2.130.10.10:FF:001414', NULL, NULL, 'Enhancer of mRNA-decapping protein 4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(127837, NULL, 'G3DSA:3.30.43.10:FF:000054', NULL, NULL, 'Xanthine dehydrogenase, A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(127838, NULL, 'G3DSA:1.10.3810.10:FF:000011', NULL, NULL, 'Transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(127839, NULL, 'G3DSA:3.30.1140.32:FF:000023', NULL, NULL, '40S ribosomal protein S3-1', NULL, NULL, NULL, NULL, NULL, 4),
(127840, NULL, 'G3DSA:2.40.30.10:FF:000032', NULL, NULL, 'NADH-cytochrome b5 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(127841, NULL, 'G3DSA:3.30.160.60:FF:001650', NULL, NULL, 'zinc finger protein 524', NULL, NULL, NULL, NULL, NULL, 4),
(127842, NULL, 'G3DSA:3.80.10.10:FF:002218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127843, NULL, 'G3DSA:3.30.200.20:FF:000669', NULL, NULL, 'Inactive leucine-rich repeat receptor-like protein kinase CORYNE', NULL, NULL, NULL, NULL, NULL, 4),
(127844, NULL, 'G3DSA:1.10.8.60:FF:000019', NULL, NULL, 'AFG3-like AAA ATPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(127845, NULL, 'G3DSA:1.20.900.10:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127846, NULL, 'G3DSA:3.40.50.300:FF:004562', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127847, NULL, 'G3DSA:3.40.50.150:FF:000133', NULL, NULL, '2-methoxy-6-polyprenyl-1,4-benzoquinol methylase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(127848, NULL, 'G3DSA:1.10.238.260:FF:000006', NULL, NULL, 'Homocitrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(127849, NULL, 'G3DSA:2.30.30.100:FF:000070', NULL, NULL, 'Small nuclear ribonucleoprotein F', NULL, NULL, NULL, NULL, NULL, 4),
(127850, NULL, 'G3DSA:1.20.1250.20:FF:000979', NULL, NULL, 'Major facilitator superfamily domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(127851, NULL, 'G3DSA:2.30.29.30:FF:000512', NULL, NULL, 'Dynein beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(127852, NULL, 'G3DSA:1.20.1510.10:FF:000002', NULL, NULL, 'zinc transporter 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(127853, NULL, 'G3DSA:3.30.70.1400:FF:000009', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(127854, NULL, 'G3DSA:2.40.170.20:FF:000044', NULL, NULL, 'SusC homolog', NULL, NULL, NULL, NULL, NULL, 4),
(127855, NULL, 'G3DSA:1.10.510.10:FF:001776', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(127856, NULL, 'G3DSA:1.10.8.270:FF:000115', NULL, NULL, 'Plant adhesion molecule 1', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(127857, NULL, 'G3DSA:3.30.870.10:FF:000110', NULL, NULL, 'PhosphoLipase D', NULL, NULL, NULL, NULL, NULL, 4),
(127858, NULL, 'G3DSA:3.30.70.100:FF:000068', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(127859, NULL, 'G3DSA:3.90.230.10:FF:000065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127860, NULL, 'G3DSA:1.25.10.10:FF:000759', NULL, NULL, 'AGAP007568-PA', NULL, NULL, NULL, NULL, NULL, 4),
(127861, NULL, 'G3DSA:1.20.91.10:FF:000001', NULL, NULL, 'Matrix protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(127862, NULL, 'G3DSA:3.30.710.10:FF:000278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127863, NULL, 'G3DSA:2.40.50.90:FF:000034', NULL, NULL, 'Unplaced genomic scaffold supercont1.17, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(127864, NULL, 'G3DSA:3.80.10.10:FF:001257', NULL, NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(127865, NULL, 'G3DSA:3.40.1390.30:FF:000014', NULL, NULL, 'GTP cyclohydrolase 1 type 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(127866, NULL, 'G3DSA:1.10.287.3490:FF:000007', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 11', NULL, NULL, NULL, NULL, NULL, 4),
(127867, NULL, 'G3DSA:1.10.3730.20:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127868, NULL, 'G3DSA:3.30.160.60:FF:006321', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127869, NULL, 'G3DSA:3.80.10.10:FF:003202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127870, NULL, 'G3DSA:2.30.30.90:FF:000011', NULL, NULL, 'Metalloregulator ScaR', NULL, NULL, NULL, NULL, NULL, 4),
(127871, NULL, 'G3DSA:3.40.50.620:FF:000178', NULL, NULL, 'YdcF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(127872, NULL, 'G3DSA:3.30.450.20:FF:000351', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(127873, NULL, 'G3DSA:3.90.228.10:FF:000048', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(127874, NULL, 'G3DSA:3.30.70.660:FF:000067', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(127875, NULL, 'G3DSA:2.60.120.200:FF:000188', NULL, NULL, 'Os08g0124000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(127876, NULL, 'G3DSA:1.20.5.110:FF:000077', NULL, NULL, 'Putative SNARE protein', NULL, NULL, NULL, NULL, NULL, 4),
(127877, NULL, 'G3DSA:1.20.1250.20:FF:001165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127878, NULL, 'G3DSA:2.10.60.10:FF:000001', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(127879, NULL, 'G3DSA:2.130.10.10:FF:003887', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(127880, NULL, 'G3DSA:3.30.830.10:FF:000332', NULL, NULL, 'Protein CBG17023', NULL, NULL, NULL, NULL, NULL, 4),
(127881, NULL, 'G3DSA:3.50.50.60:FF:000438', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(127882, NULL, 'G3DSA:3.40.50.1240:FF:000189', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127883, NULL, 'G3DSA:1.10.418.10:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127884, NULL, 'G3DSA:3.40.50.1820:FF:001195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127885, NULL, 'G3DSA:3.40.50.300:FF:001504', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(127886, NULL, 'G3DSA:3.10.50.40:FF:000097', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(127887, NULL, 'G3DSA:2.10.25.10:FF:000228', NULL, NULL, 'agrin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(127888, NULL, 'G3DSA:2.60.40.10:FF:004415', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127889, NULL, 'G3DSA:1.20.1270.10:FF:000090', NULL, NULL, 'Heat shock 70 kDa protein A', NULL, NULL, NULL, NULL, NULL, 4),
(127890, NULL, 'G3DSA:3.30.160.60:FF:005028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127891, NULL, 'G3DSA:2.10.90.10:FF:000172', NULL, NULL, 'Transforming growth factor, beta 2', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(127892, NULL, 'G3DSA:1.10.246.130:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127893, NULL, 'G3DSA:3.40.50.720:FF:000770', NULL, NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(127894, NULL, 'G3DSA:1.25.50.20:FF:000107', NULL, NULL, 'Peptidase family m1 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(127895, NULL, 'G3DSA:3.30.565.10:FF:000092', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(127896, NULL, 'G3DSA:3.40.1350.10:FF:000045', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(127897, NULL, 'G3DSA:2.130.10.10:FF:004539', NULL, NULL, 'WD40-repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(127898, NULL, 'G3DSA:1.10.630.10:FF:000104', NULL, NULL, 'Cytochrome P450 family 81 subfamily D polypeptide 8', NULL, NULL, NULL, NULL, NULL, 4),
(127899, NULL, 'G3DSA:1.10.3890.10:FF:000004', NULL, NULL, 'High frequency lysogenization protein HflD homolog', NULL, NULL, NULL, NULL, NULL, 4),
(127900, NULL, 'G3DSA:2.30.30.140:FF:000267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127901, NULL, 'G3DSA:3.40.50.800:FF:000002', NULL, NULL, 'Glycine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(127902, NULL, 'G3DSA:3.30.160.20:FF:000160', NULL, NULL, 'Double-stranded RNA-specific adenosine deaminase adr-2', NULL, NULL, NULL, NULL, NULL, 4),
(127903, NULL, 'G3DSA:2.130.10.10:FF:005832', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127904, NULL, 'G3DSA:3.40.50.300:FF:004938', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(127905, NULL, 'G3DSA:3.90.1200.10:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127906, NULL, 'G3DSA:2.60.40.60:FF:000462', NULL, NULL, 'Cadherin 2', NULL, NULL, NULL, NULL, NULL, 4),
(127907, NULL, 'G3DSA:1.25.40.20:FF:001894', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127908, NULL, 'G3DSA:1.25.10.10:FF:002468', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127909, NULL, 'G3DSA:1.20.900.10:FF:000134', NULL, NULL, 'BAR domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(127910, NULL, 'G3DSA:3.40.1160.10:FF:000098', NULL, NULL, 'Aspartate/glutamate/uridylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(127911, NULL, 'G3DSA:3.30.565.10:FF:000468', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127912, NULL, 'G3DSA:1.10.10.10:FF:001309', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(127913, NULL, 'G3DSA:2.70.170.10:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127914, NULL, 'G3DSA:1.20.5.500:FF:000008', NULL, NULL, 'Lamin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(127915, NULL, 'G3DSA:3.20.20.70:FF:000542', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127916, NULL, 'G3DSA:2.60.40.10:FF:000020', NULL, NULL, 'Fibroblast growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(127917, NULL, 'G3DSA:1.10.530.10:FF:000035', NULL, NULL, 'Lytic murein transglycosylase B', NULL, NULL, NULL, NULL, NULL, 4),
(127918, NULL, 'G3DSA:2.30.30.140:FF:000278', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(127919, NULL, 'G3DSA:3.90.550.10:FF:000696', NULL, NULL, 'UDP-N-acetylglucosamine pyrophosphorylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(127920, NULL, 'G3DSA:3.40.50.300:FF:001476', NULL, NULL, 'Dynein heavy chain domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(127921, NULL, 'G3DSA:1.20.1260.60:FF:000014', NULL, NULL, 'Actin domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(127922, NULL, 'G3DSA:1.20.120.350:FF:000237', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127923, NULL, 'G3DSA:2.102.10.10:FF:000062', NULL, NULL, 'Cytochrome b/b6 complex, iron-sulfur cluster-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(127924, NULL, 'G3DSA:3.30.420.340:FF:000006', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(127925, NULL, 'G3DSA:1.20.120.1080:FF:000098', NULL, NULL, 'Putative pre-mRNA-splicing factor ATP-dependent RNA helicase C20H4.09', NULL, NULL, NULL, NULL, NULL, 4),
(127926, NULL, 'G3DSA:3.40.50.1820:FF:001431', NULL, NULL, 'Dynein light chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(127927, NULL, 'G3DSA:3.30.40.10:FF:001430', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(127928, NULL, 'G3DSA:3.40.50.1100:FF:000260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127929, NULL, 'G3DSA:1.10.510.10:FF:001545', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(127930, NULL, 'G3DSA:1.10.287.370:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127931, NULL, 'G3DSA:2.60.40.10:FF:003246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127932, NULL, 'G3DSA:2.10.25.10:FF:000223', NULL, NULL, 'Fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(127933, NULL, 'G3DSA:1.10.8.10:FF:000168', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(127934, NULL, 'G3DSA:3.50.50.60:FF:001388', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(127935, NULL, 'G3DSA:1.20.1560.10:FF:000409', NULL, NULL, 'Multidrug resistance-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(127936, NULL, 'G3DSA:3.30.200.20:FF:001260', NULL, NULL, 'Protein_kinase_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(127937, NULL, 'G3DSA:3.40.50.2300:FF:000400', NULL, NULL, 'Signal transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(127938, NULL, 'G3DSA:3.40.50.300:FF:008513', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127939, NULL, 'G3DSA:3.30.479.10:FF:000003', NULL, NULL, '6-pyruvoyl tetrahydrobiopterin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(127940, NULL, 'G3DSA:3.80.10.10:FF:000644', NULL, NULL, 'Putative inactive leucine-rich repeat receptor-like protein kinase isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(127941, NULL, 'G3DSA:1.10.238.230:FF:000008', NULL, NULL, 'Serine/threonine-protein phosphatase 2A regulatory subunit B'''' subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(127942, NULL, 'G3DSA:3.30.160.60:FF:001655', NULL, NULL, 'FinTRIM family, member 82', NULL, NULL, NULL, NULL, NULL, 4),
(127943, NULL, 'G3DSA:3.30.40.10:FF:000906', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(127944, NULL, 'G3DSA:2.120.10.80:FF:000311', NULL, NULL, 'Leucine carboxyl methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(127945, NULL, 'G3DSA:2.70.150.10:FF:000112', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(127946, NULL, 'G3DSA:3.30.479.30:FF:000009', NULL, NULL, 'Erlin-2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(127947, NULL, 'G3DSA:3.40.50.410:FF:000109', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(127948, NULL, 'G3DSA:3.30.70.330:FF:001396', NULL, NULL, 'APOBEC1 complementation factor', NULL, NULL, NULL, NULL, NULL, 4),
(127949, NULL, 'G3DSA:3.40.50.720:FF:000540', NULL, NULL, 'Oxidoreductase, short chain dehydrogenase/reductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(127950, NULL, 'G3DSA:4.10.240.10:FF:000080', NULL, NULL, 'Transcriptional regulatory protein EDS1', NULL, NULL, NULL, NULL, NULL, 4),
(127951, NULL, 'G3DSA:1.10.287.70:FF:000166', NULL, NULL, 'Voltage-gated Ca2+ channel, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(127952, NULL, 'G3DSA:2.60.40.420:FF:000060', NULL, NULL, 'L-ascorbate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(127953, NULL, 'G3DSA:3.90.70.10:FF:000788', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(127954, NULL, 'G3DSA:1.20.120.1880:FF:000006', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(127955, NULL, 'G3DSA:1.20.58.1290:FF:000001', NULL, NULL, 'CarD family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(127956, NULL, 'G3DSA:1.20.140.150:FF:000035', NULL, NULL, 'LHFPL tetraspan subfamily member 4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(127957, NULL, 'G3DSA:2.60.120.200:FF:000441', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(127958, NULL, 'G3DSA:2.60.40.60:FF:000041', NULL, NULL, 'FAT atypical cadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(127959, NULL, 'G3DSA:1.25.40.20:FF:000949', NULL, NULL, 'Transcription factor TOXE', NULL, NULL, NULL, NULL, NULL, 4),
(127960, NULL, 'G3DSA:2.30.40.10:FF:000179', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(127961, NULL, 'G3DSA:3.30.1610.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127962, NULL, 'G3DSA:3.90.70.10:FF:000900', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(127963, NULL, 'G3DSA:2.130.10.10:FF:004747', NULL, NULL, 'WD repeat domain-containing protein 83 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(127964, NULL, 'G3DSA:2.60.40.10:FF:001217', NULL, NULL, 'phosphatidylinositol phosphatase PTPRQ isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(127965, NULL, 'G3DSA:2.60.40.10:FF:005500', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127966, NULL, 'G3DSA:2.30.29.30:FF:001344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127967, NULL, 'G3DSA:1.10.10.1760:FF:000004', NULL, NULL, '60S ribosomal protein L36', NULL, NULL, NULL, NULL, NULL, 4),
(127968, NULL, 'G3DSA:1.20.1530.20:FF:000006', NULL, NULL, 'Putative transporter YfdV', NULL, NULL, NULL, NULL, NULL, 4),
(127969, NULL, 'G3DSA:3.80.10.10:FF:001049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127970, NULL, 'G3DSA:1.20.58.60:FF:000708', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127971, NULL, 'G3DSA:3.30.470.10:FF:000034', NULL, NULL, 'Probable branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(127972, NULL, 'G3DSA:3.30.40.10:FF:000002', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(127973, NULL, 'G3DSA:3.30.450.20:FF:000463', NULL, NULL, 'Hypoxia-inducible factor 1 alpha, putative', NULL, NULL, NULL, NULL, NULL, 4),
(127974, NULL, 'G3DSA:3.40.50.300:FF:002095', NULL, NULL, 'mRNA cleavage and polyadenylation factor clp1', NULL, NULL, NULL, NULL, NULL, 4),
(127975, NULL, 'G3DSA:2.130.10.10:FF:001993', NULL, NULL, 'Serine/threonine-protein kinase PRP4', NULL, NULL, NULL, NULL, NULL, 4),
(127976, NULL, 'G3DSA:1.20.920.60:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127977, NULL, 'G3DSA:2.60.120.10:FF:000781', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127978, NULL, 'G3DSA:1.10.8.50:FF:000022', NULL, NULL, 'Fibronectin/fibrinogen-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(127979, NULL, 'G3DSA:3.10.100.10:FF:000034', NULL, NULL, 'secretory phospholipase A2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(127980, NULL, 'G3DSA:2.160.10.10:FF:000098', NULL, NULL, 'Serine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(127981, NULL, 'G3DSA:3.30.9.10:FF:000048', NULL, NULL, 'Glycine oxidase ThiO', NULL, NULL, NULL, NULL, NULL, 4),
(127982, NULL, 'G3DSA:3.60.10.10:FF:000033', NULL, NULL, 'sphingomyelin phosphodiesterase 2', NULL, NULL, NULL, NULL, NULL, 4),
(127983, NULL, 'G3DSA:3.30.230.10:FF:000039', NULL, NULL, 'Lon protease homolog 2, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(127984, NULL, 'G3DSA:1.10.287.70:FF:000071', NULL, NULL, 'Two pore calcium channel protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(127985, NULL, 'G3DSA:3.50.30.10:FF:000006', NULL, NULL, 'UDP-glucose 4-epimerase GalE4', NULL, NULL, NULL, NULL, NULL, 4),
(127986, NULL, 'G3DSA:3.30.830.10:FF:000017', NULL, NULL, 'nardilysin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(127987, NULL, 'G3DSA:3.30.200.20:FF:002457', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127988, NULL, 'G3DSA:3.40.33.10:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(127989, NULL, 'G3DSA:3.40.1190.20:FF:000136', NULL, NULL, 'Adenosine kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(127990, NULL, 'G3DSA:3.30.160.60:FF:005837', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127991, NULL, 'G3DSA:3.40.50.2300:FF:001491', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127992, NULL, 'G3DSA:3.50.50.60:FF:000674', NULL, NULL, '3-dehydro-bile acid delta(4,6)-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(127993, NULL, 'G3DSA:3.30.2080.10:FF:000009', NULL, NULL, 'Glycoside hydrolase family 92 protein', NULL, NULL, NULL, NULL, NULL, 4),
(127994, NULL, 'G3DSA:3.30.160.60:FF:004409', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(127995, NULL, 'G3DSA:3.30.70.1860:FF:000001', NULL, NULL, 'EMB3143', NULL, NULL, NULL, NULL, NULL, 4),
(127996, NULL, 'G3DSA:1.25.40.10:FF:005151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(127997, NULL, 'G3DSA:3.60.40.10:FF:000214', NULL, NULL, 'Phosphoprotein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(127998, NULL, 'G3DSA:2.60.120.610:FF:000002', NULL, NULL, 'Probable arabinosyltransferase B', NULL, NULL, NULL, NULL, NULL, 4),
(127999, NULL, 'G3DSA:3.30.559.10:FF:000055', NULL, NULL, 'Nonribosomal peptide synthetase sidC', NULL, NULL, NULL, NULL, NULL, 4),
(128000, NULL, 'G3DSA:1.10.1450.10:FF:000033', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(128001, NULL, 'G3DSA:3.20.20.80:FF:000741', NULL, NULL, 'Chitinase 3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(128002, NULL, 'G3DSA:1.20.5.170:FF:000061', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(128003, NULL, 'G3DSA:2.40.100.10:FF:000099', NULL, NULL, 'Putative peptidyl prolyl cis trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(128004, NULL, 'G3DSA:2.30.110.10:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128005, NULL, 'G3DSA:3.30.450.200:FF:000010', NULL, NULL, 'DENN/MADD domain-containing 3a', NULL, NULL, NULL, NULL, NULL, 4),
(128006, NULL, 'G3DSA:1.20.120.720:FF:000045', NULL, NULL, 'Myosin IHb', NULL, NULL, NULL, NULL, NULL, 4),
(128007, NULL, 'G3DSA:3.30.160.60:FF:004640', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128008, NULL, 'G3DSA:3.30.200.20:FF:001046', NULL, NULL, 'Serine/threonine-protein kinase PknK', NULL, NULL, NULL, NULL, NULL, 4),
(128009, NULL, 'G3DSA:1.20.1270.280:FF:000037', NULL, NULL, 'Dynein, axonemal, heavy chain 7', NULL, NULL, NULL, NULL, NULL, 4),
(128010, NULL, 'G3DSA:3.40.1110.10:FF:000275', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128011, NULL, 'G3DSA:1.20.120.1760:FF:000004', NULL, NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(128012, NULL, 'G3DSA:1.20.120.610:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128013, NULL, 'G3DSA:1.10.1410.10:FF:000019', NULL, NULL, 'Nuclear poly(A) polymerase 3', NULL, NULL, NULL, NULL, NULL, 4),
(128014, NULL, 'G3DSA:3.40.1390.30:FF:000025', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128015, NULL, 'G3DSA:3.40.50.720:FF:000326', NULL, NULL, 'NADH-ubiquinone oxidoreductase 39 kD subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(128016, NULL, 'G3DSA:1.10.1200.260:FF:000004', NULL, NULL, 'Potassium voltage-gated channel protein eag', NULL, NULL, NULL, NULL, NULL, 4),
(128017, NULL, 'G3DSA:3.40.50.300:FF:004461', NULL, NULL, 'Developmentally-regulated GTP-binding protein 2, variant', NULL, NULL, NULL, NULL, NULL, 4),
(128018, NULL, 'G3DSA:2.60.120.330:FF:000221', NULL, NULL, 'Os06g0176650 protein', NULL, NULL, NULL, NULL, NULL, 4),
(128019, NULL, 'G3DSA:3.30.40.140:FF:000001', NULL, NULL, 'E3 ubiquitin-protein ligase CHFR isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(128020, NULL, 'G3DSA:1.25.40.10:FF:004971', NULL, NULL, 'Developmental protein DG1091', NULL, NULL, NULL, NULL, NULL, 4),
(128021, NULL, 'G3DSA:2.130.10.10:FF:005692', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(128022, NULL, 'G3DSA:3.30.1740.10:FF:000010', NULL, NULL, 'Putative DNA repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(128023, NULL, 'G3DSA:3.10.290.20:FF:000016', NULL, NULL, 'SUMO-activating enzyme subunit', NULL, NULL, NULL, NULL, NULL, 4),
(128024, NULL, 'G3DSA:1.10.1040.10:FF:000108', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase (NAD(P)(+))', NULL, NULL, NULL, NULL, NULL, 4),
(128025, NULL, 'G3DSA:3.40.50.1820:FF:001094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128026, NULL, 'G3DSA:3.40.50.300:FF:000650', NULL, NULL, 'DNA helicase MCM8 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(128027, NULL, 'G3DSA:1.20.1050.10:FF:000118', NULL, NULL, 'Chloride intracellular channel 3', NULL, NULL, NULL, NULL, NULL, 4),
(128028, NULL, 'G3DSA:3.40.50.620:FF:000173', NULL, NULL, 'tRNA(Ile)-lysidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(128029, NULL, 'G3DSA:3.30.160.60:FF:002274', NULL, NULL, 'Zinc finger protein 432', NULL, NULL, NULL, NULL, NULL, 4),
(128030, NULL, 'G3DSA:3.40.50.12780:FF:000036', NULL, NULL, 'Acetoacetyl-CoA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(128031, NULL, 'G3DSA:1.25.40.10:FF:001565', NULL, NULL, 'PPR superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(128032, NULL, 'G3DSA:3.90.175.10:FF:000003', NULL, NULL, 'Grass carp reovirus (GCRV)-induced gene 2p', NULL, NULL, NULL, NULL, NULL, 4),
(128033, NULL, 'G3DSA:1.20.58.80:FF:000041', NULL, NULL, 'ATPase, AAA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(128034, NULL, 'G3DSA:1.10.533.10:FF:000300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128035, NULL, 'G3DSA:2.170.260.10:FF:000012', NULL, NULL, 'Endoribonuclease Dicer-like 2 isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(128036, NULL, 'G3DSA:1.10.10.10:FF:001540', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128037, NULL, 'G3DSA:3.30.70.330:FF:000777', NULL, NULL, 'Os01g0765300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(128038, NULL, 'G3DSA:2.130.10.10:FF:005253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128039, NULL, 'G3DSA:3.30.60.30:FF:000234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128040, NULL, 'G3DSA:2.80.10.50:FF:000254', NULL, NULL, 'Fascin', NULL, NULL, NULL, NULL, NULL, 4),
(128041, NULL, 'G3DSA:2.60.120.650:FF:000199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128042, NULL, 'G3DSA:3.40.720.10:FF:000092', NULL, NULL, 'Alkaline phosphatase PafA', NULL, NULL, NULL, NULL, NULL, 4),
(128043, NULL, 'G3DSA:2.60.120.780:FF:000007', NULL, NULL, 'E3 SUMO-protein ligase gei-17', NULL, NULL, NULL, NULL, NULL, 4),
(128044, NULL, 'G3DSA:3.40.605.10:FF:000127', NULL, NULL, 'Aldehyde dehydrogenase 3 family member B1', NULL, NULL, NULL, NULL, NULL, 4),
(128045, NULL, 'G3DSA:1.20.120.310:FF:000012', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(128046, NULL, 'G3DSA:3.40.50.2020:FF:000086', NULL, NULL, 'Erythromycin esterase', NULL, NULL, NULL, NULL, NULL, 4),
(128047, NULL, 'G3DSA:3.10.50.30:FF:000004', NULL, NULL, 'Transcription elongation factor GreA', NULL, NULL, NULL, NULL, NULL, 4),
(128048, NULL, 'G3DSA:1.25.40.10:FF:002296', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(128049, NULL, 'G3DSA:2.60.40.640:FF:000120', NULL, NULL, 'Protein ste7', NULL, NULL, NULL, NULL, NULL, 4),
(128050, NULL, 'G3DSA:2.60.40.10:FF:004983', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128051, NULL, 'G3DSA:2.60.40.150:FF:000405', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128052, NULL, 'G3DSA:1.10.510.10:FF:001916', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128053, NULL, 'G3DSA:3.40.50.10330:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128054, NULL, 'G3DSA:2.40.440.10:FF:000023', NULL, NULL, 'Slr0769 protein', NULL, NULL, NULL, NULL, NULL, 4),
(128055, NULL, 'G3DSA:1.25.10.10:FF:001849', NULL, NULL, 'Importin beta', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(128056, NULL, 'G3DSA:3.30.40.10:FF:001851', NULL, NULL, 'RING finger protein mug145', NULL, NULL, NULL, NULL, NULL, 4),
(128057, NULL, 'G3DSA:3.30.420.10:FF:000211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128058, NULL, 'G3DSA:2.30.29.30:FF:001232', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128059, NULL, 'G3DSA:1.10.3810.10:FF:000016', NULL, NULL, 'Penicillin-binding protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(128060, NULL, 'G3DSA:2.70.70.10:FF:000027', NULL, NULL, 'Glycyl-glycine endopeptidase LytM', NULL, NULL, NULL, NULL, NULL, 4),
(128061, NULL, 'G3DSA:3.30.60.30:FF:000122', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(128062, NULL, 'G3DSA:3.50.50.60:FF:001500', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128063, NULL, 'G3DSA:1.25.10.10:FF:002889', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128064, NULL, 'G3DSA:1.20.1070.10:FF:000653', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128065, NULL, 'G3DSA:3.40.50.300:FF:005658', NULL, NULL, 'Bifunctional 3''-phosphoadenosine 5''-phosphosulfate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(128066, NULL, 'G3DSA:2.60.120.10:FF:000129', NULL, NULL, 'Transcriptional regulator FixK', NULL, NULL, NULL, NULL, NULL, 4),
(128067, NULL, 'G3DSA:1.10.238.210:FF:000002', NULL, NULL, 'Blast:Glutaminase kidney isoform, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(128068, NULL, 'G3DSA:3.30.160.60:FF:005045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128069, NULL, 'G3DSA:3.40.140.10:FF:000007', NULL, NULL, 'Cytidine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(128070, NULL, 'G3DSA:2.120.10.30:FF:000549', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128071, NULL, 'G3DSA:2.130.10.10:FF:001881', NULL, NULL, 'WD repeat and HMG-box DNA binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(128072, NULL, 'G3DSA:2.60.40.10:FF:001329', NULL, NULL, 'Basigin', NULL, NULL, NULL, NULL, NULL, 4),
(128073, NULL, 'G3DSA:2.40.420.20:FF:000013', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(128074, NULL, 'G3DSA:2.20.25.20:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128075, NULL, 'G3DSA:1.20.1250.20:FF:000075', NULL, NULL, 'Lactose permease', NULL, NULL, NULL, NULL, NULL, 4),
(128076, NULL, 'G3DSA:1.20.1270.60:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128077, NULL, 'G3DSA:4.10.1000.10:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128078, NULL, 'G3DSA:3.40.50.1820:FF:000475', NULL, NULL, 'YPR147C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(128079, NULL, 'G3DSA:3.40.50.980:FF:000016', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(128080, NULL, 'G3DSA:3.40.50.10190:FF:000332', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128081, NULL, 'G3DSA:2.130.10.10:FF:000936', NULL, NULL, 'Periodic tryptophan protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(128082, NULL, 'G3DSA:1.25.40.20:FF:000466', NULL, NULL, 'Mann-cup, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(128083, NULL, 'G3DSA:1.10.10.60:FF:000925', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128084, NULL, 'G3DSA:3.90.1180.10:FF:000003', NULL, NULL, '60S ribosomal protein L13a-4', NULL, NULL, NULL, NULL, NULL, 4),
(128085, NULL, 'G3DSA:2.70.220.10:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128086, NULL, 'G3DSA:3.10.20.90:FF:000481', NULL, NULL, 'NSFL1 cofactor p47, putative', NULL, NULL, NULL, NULL, NULL, 4),
(128087, NULL, 'G3DSA:1.25.40.20:FF:001197', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128088, NULL, 'G3DSA:3.80.10.10:FF:002898', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128089, NULL, 'G3DSA:6.10.140.2220:FF:000059', NULL, NULL, 'Putative MYND finger domain protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(128090, NULL, 'G3DSA:2.30.30.100:FF:000053', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm2', NULL, NULL, NULL, NULL, NULL, 4),
(128091, NULL, 'G3DSA:1.10.2020.10:FF:000001', NULL, NULL, 'Uronate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(128092, NULL, 'G3DSA:3.90.25.10:FF:000032', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128093, NULL, 'G3DSA:1.20.920.10:FF:000017', NULL, NULL, 'Bromodomain and WD repeat domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(128094, NULL, 'G3DSA:1.25.40.10:FF:001205', NULL, NULL, 'Pentatricopeptide repeat domain 3', NULL, NULL, NULL, NULL, NULL, 4),
(128095, NULL, 'G3DSA:1.10.238.10:FF:000001', NULL, NULL, 'Calmodulin 1', NULL, NULL, NULL, NULL, NULL, 4),
(128096, NULL, 'G3DSA:1.10.405.10:FF:000019', NULL, NULL, 'Guanosine nucleotide diphosphate dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(128097, NULL, 'G3DSA:3.30.160.60:FF:006326', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128098, NULL, 'G3DSA:3.90.228.10:FF:000043', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(128099, NULL, 'G3DSA:1.20.900.10:FF:000022', NULL, NULL, 'protein ECT2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(128100, NULL, 'G3DSA:1.10.287.110:FF:000044', NULL, NULL, 'DnaJ (Hsp40) homolog, subfamily C, member 1', NULL, NULL, NULL, NULL, NULL, 4),
(128101, NULL, 'G3DSA:3.40.190.10:FF:000948', NULL, NULL, 'ABC transporter permease fused to pyrimidine biosynthesis enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(128102, NULL, 'G3DSA:3.30.1490.40:FF:000010', NULL, NULL, 'Smy2p', NULL, NULL, NULL, NULL, NULL, 4),
(128103, NULL, 'G3DSA:3.30.70.330:FF:001284', NULL, NULL, 'RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(128104, NULL, 'G3DSA:1.10.238.10:FF:000131', NULL, NULL, 'Dystrophin, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(128105, NULL, 'G3DSA:1.10.1040.10:FF:000098', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)] 1', NULL, NULL, NULL, NULL, NULL, 4),
(128106, NULL, 'G3DSA:3.40.50.300:FF:002887', NULL, NULL, 'Si:ch211-197g15.6', NULL, NULL, NULL, NULL, NULL, 4),
(128107, NULL, 'G3DSA:1.50.40.10:FF:000287', NULL, NULL, 'Mitochondrial carrier protein MTM1', NULL, NULL, NULL, NULL, NULL, 4),
(128108, NULL, 'G3DSA:3.20.20.70:FF:000654', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128109, NULL, 'G3DSA:2.70.150.10:FF:000224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128110, NULL, 'G3DSA:2.60.40.10:FF:002274', NULL, NULL, 'CD4', NULL, NULL, NULL, NULL, NULL, 4),
(128111, NULL, 'G3DSA:3.30.160.60:FF:003572', NULL, NULL, 'Zinc finger protein 639', NULL, NULL, NULL, NULL, NULL, 4),
(128112, NULL, 'G3DSA:1.10.510.10:FF:003911', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128113, NULL, 'G3DSA:2.30.30.140:FF:000166', NULL, NULL, 'Probable ATP-dependent RNA helicase spindle-E', NULL, NULL, NULL, NULL, NULL, 4),
(128114, NULL, 'G3DSA:1.10.20.10:FF:000074', NULL, NULL, 'dr1-associated corepressor', NULL, NULL, NULL, NULL, NULL, 4),
(128115, NULL, 'G3DSA:3.40.50.300:FF:001364', NULL, NULL, 'Circadian clock protein kinase KaiC', NULL, NULL, NULL, NULL, NULL, 4),
(128116, NULL, 'G3DSA:2.60.120.310:FF:000002', NULL, NULL, 'DBH-like monooxygenase protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(128117, NULL, 'G3DSA:2.10.25.10:FF:000335', NULL, NULL, 'protocadherin Fat 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(128118, NULL, 'G3DSA:3.40.50.1980:FF:000040', NULL, NULL, 'ABC transporter substrate-binding protein-iron transport', NULL, NULL, NULL, NULL, NULL, 4),
(128119, NULL, 'G3DSA:3.20.20.70:FF:000171', NULL, NULL, 'Ribulose-phosphate 3-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(128120, NULL, 'G3DSA:3.40.50.1110:FF:000133', NULL, NULL, 'O-ACyltransferase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(128121, NULL, 'G3DSA:2.60.40.10:FF:005163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128122, NULL, 'G3DSA:3.90.190.10:FF:000353', NULL, NULL, 'Tyrosine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(128123, NULL, 'G3DSA:1.20.1250.20:FF:000428', NULL, NULL, 'Solute carrier family 2 (Facilitated glucose transporter), member 6', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(128124, NULL, 'G3DSA:3.60.140.10:FF:000014', NULL, NULL, 'Polyphenol oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(128125, NULL, 'G3DSA:3.30.230.130:FF:000063', NULL, NULL, 'Cullin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(128126, NULL, 'G3DSA:1.10.246.20:FF:000012', NULL, NULL, 'Os08g0523600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(128127, NULL, 'G3DSA:2.130.10.10:FF:003336', NULL, NULL, 'YALI0E28226p', NULL, NULL, NULL, NULL, NULL, 4),
(128128, NULL, 'G3DSA:3.40.640.10:FF:000377', NULL, NULL, 'Kynureninase', NULL, NULL, NULL, NULL, NULL, 4),
(128129, NULL, 'G3DSA:3.80.10.10:FF:000532', NULL, NULL, '18w protein', NULL, NULL, NULL, NULL, NULL, 4),
(128130, NULL, 'G3DSA:3.90.1410.10:FF:000016', NULL, NULL, 'Lysine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(128131, NULL, 'G3DSA:1.20.1250.20:FF:000092', NULL, NULL, 'Feline leukemia virus subgroup C receptor-related protein 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(128132, NULL, 'G3DSA:3.40.50.10190:FF:000248', NULL, NULL, 'YALI0E31273p', NULL, NULL, NULL, NULL, NULL, 4),
(128133, NULL, 'G3DSA:3.40.50.2000:FF:000872', NULL, NULL, 'Glycogen [starch] synthase', NULL, NULL, NULL, NULL, NULL, 4),
(128134, NULL, 'G3DSA:2.130.10.10:FF:003679', NULL, NULL, 'IntraFlagellar Transport Associated', NULL, NULL, NULL, NULL, NULL, 4),
(128135, NULL, 'G3DSA:1.10.800.10:FF:000011', NULL, NULL, 'Tyrosine 3-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(128136, NULL, 'G3DSA:3.80.10.10:FF:002561', NULL, NULL, 'At1g77550', NULL, NULL, NULL, NULL, NULL, 4),
(128137, NULL, 'G3DSA:3.30.160.60:FF:004191', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128138, NULL, 'G3DSA:3.30.70.1290:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128139, NULL, 'G3DSA:1.10.418.10:FF:000100', NULL, NULL, 'Kinesin-like protein KIN-14H', NULL, NULL, NULL, NULL, NULL, 4),
(128140, NULL, 'G3DSA:3.30.160.60:FF:001785', NULL, NULL, 'Zinc finger protein 425', NULL, NULL, NULL, NULL, NULL, 4),
(128141, NULL, 'G3DSA:3.40.50.150:FF:000110', NULL, NULL, 'methyltransferase-like protein 13 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(128142, NULL, 'G3DSA:1.20.1070.10:FF:000569', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128143, NULL, 'G3DSA:2.30.29.30:FF:000276', NULL, NULL, 'pleckstrin homology domain-containing family H member 3', NULL, NULL, NULL, NULL, NULL, 4),
(128144, NULL, 'G3DSA:1.25.40.10:FF:000379', NULL, NULL, 'Tetratricopeptide repeat domain 30B', NULL, NULL, NULL, NULL, NULL, 4),
(128145, NULL, 'G3DSA:3.40.50.150:FF:000453', NULL, NULL, 'Histidine N-alpha-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(128146, NULL, 'G3DSA:3.40.50.720:FF:000298', NULL, NULL, 'Voltage-gated potassium channel Kch', NULL, NULL, NULL, NULL, NULL, 4),
(128147, NULL, 'G3DSA:3.40.50.200:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128148, NULL, 'G3DSA:1.20.1280.50:FF:000136', NULL, NULL, 'F-box/WD repeat-containing protein sel-10', NULL, NULL, NULL, NULL, NULL, 4),
(128149, NULL, 'G3DSA:1.10.287.2900:FF:000005', NULL, NULL, 'Mic14p', NULL, NULL, NULL, NULL, NULL, 4),
(128150, NULL, 'G3DSA:1.25.10.10:FF:001496', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(128151, NULL, 'G3DSA:3.50.50.60:FF:000899', NULL, NULL, 'Flavin-containing monooxygenase FMO GS-OX-like 8', NULL, NULL, NULL, NULL, NULL, 4),
(128152, NULL, 'G3DSA:1.20.5.690:FF:000008', NULL, NULL, 'Importin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(128153, NULL, 'G3DSA:1.10.10.60:FF:000021', NULL, NULL, 'CDC5 cell division cycle 5-like', NULL, NULL, NULL, NULL, NULL, 4),
(128154, NULL, 'G3DSA:3.30.70.80:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128155, NULL, 'G3DSA:4.10.170.10:FF:000001', NULL, NULL, 'Cellular tumor antigen p53', NULL, NULL, NULL, NULL, NULL, 4),
(128156, NULL, 'G3DSA:3.30.920.10:FF:000007', NULL, NULL, 'Iron-sulfur cluster assembly protein CyaY', NULL, NULL, NULL, NULL, NULL, 4),
(128157, NULL, 'G3DSA:2.30.29.30:FF:000372', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(128158, NULL, 'G3DSA:2.60.120.200:FF:000424', NULL, NULL, 'AGAP004993-PA', NULL, NULL, NULL, NULL, NULL, 4),
(128159, NULL, 'G3DSA:1.10.565.10:FF:000160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128160, NULL, 'G3DSA:3.40.449.10:FF:000011', NULL, NULL, 'Phosphoenolpyruvate carboxykinase [ATP]', NULL, NULL, NULL, NULL, NULL, 4),
(128161, NULL, 'G3DSA:3.40.50.300:FF:000419', NULL, NULL, 'Probable helicase with zinc finger domain', NULL, NULL, NULL, NULL, NULL, 4),
(128162, NULL, 'G3DSA:2.10.25.10:FF:001280', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128163, NULL, 'G3DSA:2.60.120.370:FF:000008', NULL, NULL, 'Putative sugar isomerase involved in processing of exogenous sialic acid', NULL, NULL, NULL, NULL, NULL, 4),
(128164, NULL, 'G3DSA:1.25.40.10:FF:003914', NULL, NULL, 'Cell division cycle protein 16 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(128165, NULL, 'G3DSA:3.40.120.10:FF:000012', NULL, NULL, 'Phosphoglucomutase, alpha-D-glucose phosphate-specific', NULL, NULL, NULL, NULL, NULL, 4),
(128166, NULL, 'G3DSA:1.20.5.110:FF:000071', NULL, NULL, 'pH-gated potassium channel KcsA', NULL, NULL, NULL, NULL, NULL, 4),
(128167, NULL, 'G3DSA:2.60.40.10:FF:001577', NULL, NULL, 'Fasciclin 2, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(128168, NULL, 'G3DSA:1.20.1070.10:FF:001721', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128169, NULL, 'G3DSA:3.30.30.30:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128170, NULL, 'G3DSA:3.40.50.12230:FF:000006', NULL, NULL, '10-formyltetrahydrofolate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(128171, NULL, 'G3DSA:3.40.50.12660:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128172, NULL, 'G3DSA:1.20.1250.20:FF:001373', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(128173, NULL, 'G3DSA:3.40.1350.10:FF:000040', NULL, NULL, 'Uncharacterized protein C824.03c, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(128174, NULL, 'G3DSA:3.30.70.330:FF:002817', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128175, NULL, 'G3DSA:1.10.3060.10:FF:000009', NULL, NULL, 'Protein translocase subunit SecA 2', NULL, NULL, NULL, NULL, NULL, 4),
(128176, NULL, 'G3DSA:3.40.30.10:FF:000647', NULL, NULL, 'Phosducin-like protein (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(128177, NULL, 'G3DSA:3.30.710.10:FF:000172', NULL, NULL, 'BTB/POZ domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(128178, NULL, 'G3DSA:3.30.9.10:FF:000065', NULL, NULL, 'FAD-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(128179, NULL, 'G3DSA:1.20.58.60:FF:000164', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(128180, NULL, 'G3DSA:3.30.70.330:FF:000339', NULL, NULL, 'RNA binding protein Jsn1', NULL, NULL, NULL, NULL, NULL, 4),
(128181, NULL, 'G3DSA:3.40.50.300:FF:004702', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128182, NULL, 'G3DSA:3.30.450.90:FF:000017', NULL, NULL, 'Twitching motility pilus retraction protein', NULL, NULL, NULL, NULL, NULL, 4),
(128183, NULL, 'G3DSA:3.40.50.1110:FF:000049', NULL, NULL, 'Protein CBG16394', NULL, NULL, NULL, NULL, NULL, 4),
(128184, NULL, 'G3DSA:3.30.420.40:FF:000658', NULL, NULL, 'Actin-like protein 6A', NULL, NULL, NULL, NULL, NULL, 4),
(128185, NULL, 'G3DSA:1.20.80.10:FF:000004', NULL, NULL, 'Protein-tyrosine kinase 2-beta isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(128186, NULL, 'G3DSA:3.40.50.1240:FF:000060', NULL, NULL, 'Bifunctional RNase H/acid phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(128187, NULL, 'G3DSA:2.130.10.10:FF:005236', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128188, NULL, 'G3DSA:2.170.150.80:FF:000002', NULL, NULL, 'Nac domain-containing protein 86', NULL, NULL, NULL, NULL, NULL, 4),
(128189, NULL, 'G3DSA:2.20.25.80:FF:000013', NULL, NULL, 'Probable WRKY transcription factor 70', NULL, NULL, NULL, NULL, NULL, 4),
(128190, NULL, 'G3DSA:3.40.50.10890:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(128191, NULL, 'G3DSA:3.40.50.150:FF:000902', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128192, NULL, 'G3DSA:1.25.40.20:FF:000045', NULL, NULL, 'Ankyrin repeat and BTB/POZ domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(128193, NULL, 'G3DSA:2.60.260.20:FF:000159', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128194, NULL, 'G3DSA:3.40.50.2000:FF:001047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128195, NULL, 'G3DSA:3.30.160.60:FF:002723', NULL, NULL, 'Zinc finger protein 597', NULL, NULL, NULL, NULL, NULL, 4),
(128196, NULL, 'G3DSA:1.10.510.10:FF:004316', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128197, NULL, 'G3DSA:1.10.3260.10:FF:000007', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(128198, NULL, 'G3DSA:2.40.30.110:FF:000014', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(128199, NULL, 'G3DSA:1.10.4020.10:FF:000001', NULL, NULL, 'zinc finger protein 263 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(128200, NULL, 'G3DSA:3.30.810.10:FF:000022', NULL, NULL, 'Phosphatidylinositol-4-phosphate 5-kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(128201, NULL, 'G3DSA:3.40.50.150:FF:000009', NULL, NULL, '23S rRNA (Uracil(1939)-C(5))-methyltransferase RlmD', NULL, NULL, NULL, NULL, NULL, 4),
(128202, NULL, 'G3DSA:3.40.50.300:FF:007215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128203, NULL, 'G3DSA:1.10.720.30:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128204, NULL, 'G3DSA:1.25.10.10:FF:000540', NULL, NULL, 'Importin-5', NULL, NULL, NULL, NULL, NULL, 4),
(128205, NULL, 'G3DSA:3.90.1150.10:FF:000294', NULL, NULL, 'Glycine cleavage system P protein', NULL, NULL, NULL, NULL, NULL, 4),
(128206, NULL, 'G3DSA:3.30.420.360:FF:000001', NULL, NULL, 'Carbamoyltransferase HypF', NULL, NULL, NULL, NULL, NULL, 4),
(128207, NULL, 'G3DSA:3.40.850.10:FF:000174', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(128208, NULL, 'G3DSA:3.40.50.10480:FF:000003', NULL, NULL, 'Ribosome biogenesis protein BRX1', NULL, NULL, NULL, NULL, NULL, 4),
(128209, NULL, 'G3DSA:3.40.50.11660:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128210, NULL, 'G3DSA:3.10.580.10:FF:000114', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(128211, NULL, 'G3DSA:3.40.30.10:FF:000086', NULL, NULL, 'Glutathione S-transferase theta-1', NULL, NULL, NULL, NULL, NULL, 4),
(128212, NULL, 'G3DSA:1.20.120.1900:FF:000052', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(128213, NULL, 'G3DSA:3.40.20.10:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128214, NULL, 'G3DSA:1.20.58.60:FF:000725', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128215, NULL, 'G3DSA:1.20.1250.20:FF:000884', NULL, NULL, 'MFS transporter of unkown specificity', NULL, NULL, NULL, NULL, NULL, 4),
(128216, NULL, 'G3DSA:3.30.70.270:FF:000068', NULL, NULL, 'Putative diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(128217, NULL, 'G3DSA:3.40.50.300:FF:006939', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128218, NULL, 'G3DSA:1.10.510.10:FF:001096', NULL, NULL, 'Raf homolog serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(128219, NULL, 'G3DSA:4.10.1110.10:FF:000011', NULL, NULL, 'AN1-type zinc finger protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(128220, NULL, 'G3DSA:3.20.20.100:FF:000173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128221, NULL, 'G3DSA:3.50.70.10:FF:000003', NULL, NULL, 'Altered inheritance of mitochondria protein 46, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(128222, NULL, 'G3DSA:4.10.1080.10:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128223, NULL, 'G3DSA:3.40.50.300:FF:001925', NULL, NULL, 'DNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(128224, NULL, 'G3DSA:3.30.500.10:FF:000015', NULL, NULL, 'RT1 class I, M6, gene 1', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(128225, NULL, 'G3DSA:2.30.30.190:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128226, NULL, 'G3DSA:2.20.25.30:FF:000009', NULL, NULL, '50S ribosomal protein L37e', NULL, NULL, NULL, NULL, NULL, 4),
(128227, NULL, 'G3DSA:1.20.1070.10:FF:001058', NULL, NULL, 'Olfactory receptor family 51 subfamily B member 4', NULL, NULL, NULL, NULL, NULL, 4),
(128228, NULL, 'G3DSA:2.20.25.10:FF:000003', NULL, NULL, 'Alkylphosphonate utilization protein PhnA', NULL, NULL, NULL, NULL, NULL, 4),
(128229, NULL, 'G3DSA:3.90.1100.10:FF:000015', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(128230, NULL, 'G3DSA:3.30.230.70:FF:000130', NULL, NULL, 'Exosome complex component rrp46', NULL, NULL, NULL, NULL, NULL, 4),
(128231, NULL, 'G3DSA:3.30.160.60:FF:005500', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128232, NULL, 'G3DSA:3.30.470.10:FF:000017', NULL, NULL, 'Branched-chain amino acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(128233, NULL, 'G3DSA:2.130.10.10:FF:000032', NULL, NULL, 'F-box/WD repeat-containing protein 7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(128234, NULL, 'G3DSA:1.25.40.20:FF:001438', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128235, NULL, 'G3DSA:2.80.10.50:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128236, NULL, 'G3DSA:3.30.70.330:FF:002694', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128237, NULL, 'G3DSA:2.20.25.10:FF:000133', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128238, NULL, 'G3DSA:3.30.572.10:FF:000029', NULL, NULL, 'Os11g0615250 protein', NULL, NULL, NULL, NULL, NULL, 4),
(128239, NULL, 'G3DSA:3.40.50.300:FF:008064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128240, NULL, 'G3DSA:1.20.940.10:FF:000013', NULL, NULL, 'Pre-mRNA-splicing factor 18', NULL, NULL, NULL, NULL, NULL, 4),
(128241, NULL, 'G3DSA:3.40.50.300:FF:000083', NULL, NULL, 'ATP-dependent RNA helicase DOB1', NULL, NULL, NULL, NULL, NULL, 4),
(128242, NULL, 'G3DSA:3.20.20.140:FF:000409', NULL, NULL, 'TatD related DNase', NULL, NULL, NULL, NULL, NULL, 4),
(128243, NULL, 'G3DSA:3.10.490.20:FF:000015', NULL, NULL, 'Axonemal dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(128244, NULL, 'G3DSA:1.20.142.10:FF:000024', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(128245, NULL, 'G3DSA:1.10.730.10:FF:000016', NULL, NULL, 'Arginine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(128246, NULL, 'G3DSA:1.10.630.10:FF:000183', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(128247, NULL, 'G3DSA:3.40.50.720:FF:001607', NULL, NULL, 'Ubiquitin activating enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(128248, NULL, 'G3DSA:3.50.30.30:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128249, NULL, 'G3DSA:2.40.10.120:FF:000024', NULL, NULL, 'Adhesion and penetration protein autotransporter', NULL, NULL, NULL, NULL, NULL, 4),
(128250, NULL, 'G3DSA:3.30.40.10:FF:001413', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128251, NULL, 'G3DSA:3.40.50.1110:FF:000150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128252, NULL, 'G3DSA:3.30.200.20:FF:001838', NULL, NULL, 'eIF-2-alpha kinase GCN2', NULL, NULL, NULL, NULL, NULL, 4),
(128253, NULL, 'G3DSA:3.10.110.10:FF:000203', NULL, NULL, 'Chromosome 15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(128254, NULL, 'G3DSA:3.30.60.270:FF:000004', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(128255, NULL, 'G3DSA:1.10.3210.10:FF:000055', NULL, NULL, 'HD domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(128256, NULL, 'G3DSA:3.40.50.300:FF:002544', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(128257, NULL, 'G3DSA:3.40.950.10:FF:000007', NULL, NULL, 'Putative cytosolic Fe-S cluster assembly factor NAR1', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(128258, NULL, 'G3DSA:2.60.120.290:FF:000170', NULL, NULL, 'Cubilin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(128259, NULL, 'G3DSA:4.10.1240.10:FF:000009', NULL, NULL, 'Glucagon receptor', NULL, NULL, NULL, NULL, NULL, 4),
(128260, NULL, 'G3DSA:1.25.40.420:FF:000031', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(128261, NULL, 'G3DSA:1.10.10.1600:FF:000001', NULL, NULL, 'DNA polymerase III subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(128262, NULL, 'G3DSA:2.60.40.10:FF:002757', NULL, NULL, 'Cd8 beta', NULL, NULL, NULL, NULL, NULL, 4),
(128263, NULL, 'G3DSA:3.50.50.60:FF:001051', NULL, NULL, 'D-amino acid dehydrogenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(128264, NULL, 'G3DSA:2.60.40.10:FF:004191', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128265, NULL, 'G3DSA:1.10.601.10:FF:000003', NULL, NULL, 'RNA polymerase sigma factor SigA', NULL, NULL, NULL, NULL, NULL, 4),
(128266, NULL, 'G3DSA:1.20.5.320:FF:000027', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128267, NULL, 'G3DSA:2.60.40.1820:FF:000005', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(128268, NULL, 'G3DSA:3.30.1960.10:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128269, NULL, 'G3DSA:3.40.50.2300:FF:001148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128270, NULL, 'G3DSA:3.40.190.10:FF:000387', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(128271, NULL, 'G3DSA:3.40.50.300:FF:007575', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128272, NULL, 'G3DSA:3.40.50.300:FF:003393', NULL, NULL, 'GD15502', NULL, NULL, NULL, NULL, NULL, 4),
(128273, NULL, 'G3DSA:3.40.50.150:FF:001521', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128274, NULL, 'G3DSA:3.40.395.10:FF:000014', NULL, NULL, 'Ulp1 protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(128275, NULL, 'G3DSA:3.30.300.90:FF:000001', NULL, NULL, 'Transcriptional regulator BolA', NULL, NULL, NULL, NULL, NULL, 4),
(128276, NULL, 'G3DSA:3.50.50.60:FF:000562', NULL, NULL, 'FAD-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(128277, NULL, 'G3DSA:3.60.20.10:FF:000191', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128278, NULL, 'G3DSA:3.40.50.20:FF:000090', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128279, NULL, 'G3DSA:1.25.40.10:FF:003122', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g46050, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(128280, NULL, 'G3DSA:3.10.430.100:FF:000014', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(128281, NULL, 'G3DSA:1.20.1070.10:FF:000209', NULL, NULL, 'p2Y purinoceptor 6', NULL, NULL, NULL, NULL, NULL, 4),
(128282, NULL, 'G3DSA:3.30.200.20:FF:002114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128283, NULL, 'G3DSA:1.25.40.470:FF:000017', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(128284, NULL, 'G3DSA:3.30.160.60:FF:003342', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128285, NULL, 'G3DSA:1.20.1560.10:FF:000865', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128286, NULL, 'G3DSA:1.25.40.10:FF:004875', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(128287, NULL, 'G3DSA:3.30.300.10:FF:000034', NULL, NULL, 'S-adenosylmethionine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(128288, NULL, 'G3DSA:3.40.50.150:FF:001864', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128289, NULL, 'G3DSA:3.90.1420.10:FF:000062', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128290, NULL, 'G3DSA:3.75.10.10:FF:000005', NULL, NULL, 'Glycine amidinotransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(128291, NULL, 'G3DSA:1.10.510.10:FF:001793', NULL, NULL, 'Putative serine/threonine-protein kinase ZK507.1', NULL, NULL, NULL, NULL, NULL, 4),
(128292, NULL, 'G3DSA:1.10.287.110:FF:000156', NULL, NULL, 'Unplaced genomic scaffold supercont1.57, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(128293, NULL, 'G3DSA:1.10.10.60:FF:000897', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128294, NULL, 'G3DSA:2.10.220.10:FF:000182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128295, NULL, 'G3DSA:3.40.50.300:FF:006035', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(128296, NULL, 'G3DSA:3.40.50.360:FF:000061', NULL, NULL, 'Flavodoxin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(128297, NULL, 'G3DSA:3.40.630.30:FF:000540', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128298, NULL, 'G3DSA:3.30.420.10:FF:000082', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(128299, NULL, 'G3DSA:2.60.120.260:FF:000060', NULL, NULL, 'Probable beta-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(128300, NULL, 'G3DSA:3.40.720.10:FF:000170', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128301, NULL, 'G3DSA:2.60.40.10:FF:005051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128302, NULL, 'G3DSA:1.10.472.80:FF:000139', NULL, NULL, 'Plant adhesion molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(128303, NULL, 'G3DSA:3.30.200.20:FF:001501', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128304, NULL, 'G3DSA:3.30.70.330:FF:002256', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128305, NULL, 'G3DSA:3.20.20.100:FF:000077', NULL, NULL, 'Alcohol dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(128306, NULL, 'G3DSA:3.40.50.300:FF:002336', NULL, NULL, 'Histone-lysine N-methyltransferase Su(var)3-9', NULL, NULL, NULL, NULL, NULL, 4),
(128307, NULL, 'G3DSA:3.30.420.40:FF:000630', NULL, NULL, 'Hexokinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(128308, NULL, 'G3DSA:3.10.20.90:FF:000610', NULL, NULL, 'Sorting nexin-31', NULL, NULL, NULL, NULL, NULL, 4),
(128309, NULL, 'G3DSA:3.80.10.10:FF:004146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128310, NULL, 'G3DSA:3.60.15.10:FF:000246', NULL, NULL, 'ElaC ribonuclease Z 1', NULL, NULL, NULL, NULL, NULL, 4),
(128311, NULL, 'G3DSA:3.40.50.150:FF:000240', NULL, NULL, 'Type I restriction-modification system, M subunit', NULL, NULL, NULL, NULL, NULL, 4),
(128312, NULL, 'G3DSA:1.25.40.20:FF:001225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128313, NULL, 'G3DSA:1.10.8.60:FF:000273', NULL, NULL, 'AAA family ATPase putative', NULL, NULL, NULL, NULL, NULL, 4),
(128314, NULL, 'G3DSA:3.40.50.10420:FF:000014', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(128315, NULL, 'G3DSA:2.10.80.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128316, NULL, 'G3DSA:2.130.10.10:FF:000240', NULL, NULL, 'THO complex subunit 6 homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(128317, NULL, 'G3DSA:2.40.50.140:FF:001067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128318, NULL, 'G3DSA:3.30.50.10:FF:000059', NULL, NULL, 'Similar to transcription factor Zn, GATA', NULL, NULL, NULL, NULL, NULL, 4),
(128319, NULL, 'G3DSA:1.25.10.10:FF:000091', NULL, NULL, 'Catenin, beta like 1', NULL, NULL, NULL, NULL, NULL, 4),
(128320, NULL, 'G3DSA:1.10.840.10:FF:000036', NULL, NULL, 'YALI0F32043p', NULL, NULL, NULL, NULL, NULL, 4),
(128321, NULL, 'G3DSA:1.10.510.10:FF:000264', NULL, NULL, 'dual specificity tyrosine-phosphorylation-regulated kinase 1B isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(128322, NULL, 'G3DSA:3.40.710.10:FF:000147', NULL, NULL, '1A family penicillin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(128323, NULL, 'G3DSA:1.20.1270.420:FF:000001', NULL, NULL, 'Serine/threonine-protein kinase TBK1', NULL, NULL, NULL, NULL, NULL, 4),
(128324, NULL, 'G3DSA:3.40.250.10:FF:000206', NULL, NULL, 'Putative dual specificity protein phosphatase 10', NULL, NULL, NULL, NULL, NULL, 4),
(128325, NULL, 'G3DSA:3.30.465.10:FF:000067', NULL, NULL, 'Probable aldehyde oxidase gad-3', NULL, NULL, NULL, NULL, NULL, 4),
(128326, NULL, 'G3DSA:2.30.29.30:FF:000164', NULL, NULL, 'Putative E3 ubiquitin-protein ligase MYLIP', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(128327, NULL, 'G3DSA:2.130.10.10:FF:003466', NULL, NULL, 'Alkaline phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(128328, NULL, 'G3DSA:3.30.200.20:FF:000984', NULL, NULL, 'Putative cdc2-related kinase', NULL, NULL, NULL, NULL, NULL, 4),
(128329, NULL, 'G3DSA:1.10.10.10:FF:000028', NULL, NULL, 'Fumarate/nitrate reduction transcriptional regulator Fnr', NULL, NULL, NULL, NULL, NULL, 4),
(128330, NULL, 'G3DSA:2.10.50.10:FF:000079', NULL, NULL, 'tumor necrosis factor receptor superfamily member 3', NULL, NULL, NULL, NULL, NULL, 4),
(128331, NULL, 'G3DSA:3.40.50.300:FF:007119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128332, NULL, 'G3DSA:1.10.506.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128333, NULL, 'G3DSA:3.30.160.60:FF:005596', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128334, NULL, 'G3DSA:3.30.160.60:FF:001897', NULL, NULL, 'Zinc finger and BTB domain containing 11', NULL, NULL, NULL, NULL, NULL, 4),
(128335, NULL, 'G3DSA:2.130.10.10:FF:001419', NULL, NULL, 'Actin-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(128336, NULL, 'G3DSA:2.130.10.10:FF:005607', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(128337, NULL, 'G3DSA:2.60.40.1730:FF:000079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128338, NULL, 'G3DSA:3.40.390.10:FF:000267', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128339, NULL, 'G3DSA:4.10.410.10:FF:000020', NULL, NULL, 'Collagen, type VI, alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(128340, NULL, 'G3DSA:3.40.50.10130:FF:000028', NULL, NULL, 'YALI0C14960p', NULL, NULL, NULL, NULL, NULL, 4),
(128341, NULL, 'G3DSA:3.10.20.590:FF:000001', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(128342, NULL, 'G3DSA:1.20.58.200:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128343, NULL, 'G3DSA:1.25.10.10:FF:000995', NULL, NULL, 'Condensin-2 complex subunit D3', NULL, NULL, NULL, NULL, NULL, 4),
(128344, NULL, 'G3DSA:3.40.50.300:FF:000195', NULL, NULL, 'ATP-dependent zinc metalloprotease FTSH 11', NULL, NULL, NULL, NULL, NULL, 4),
(128345, NULL, 'G3DSA:1.10.510.10:FF:003350', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128346, NULL, 'G3DSA:3.40.50.720:FF:000669', NULL, NULL, 'SUMO-activating enzyme subunit', NULL, NULL, NULL, NULL, NULL, 4),
(128347, NULL, 'G3DSA:1.20.142.10:FF:000018', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(128348, NULL, 'G3DSA:1.20.5.3600:FF:000003', NULL, NULL, 'Related to nuclear pore protein NUP57', NULL, NULL, NULL, NULL, NULL, 4),
(128349, NULL, 'G3DSA:1.10.1410.10:FF:000036', NULL, NULL, 'Nuclear poly(A) polymerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(128350, NULL, 'G3DSA:3.30.70.1660:FF:000025', NULL, NULL, 'Peptide chain release factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(128351, NULL, 'G3DSA:3.30.450.50:FF:000034', NULL, NULL, 'Longin-type vesicle-associated membrane protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(128352, NULL, 'G3DSA:1.10.238.10:FF:000344', NULL, NULL, 'Protein S100-A8', NULL, NULL, NULL, NULL, NULL, 4),
(128353, NULL, 'G3DSA:3.40.366.10:FF:000054', NULL, NULL, 'Malonyl CoA-acyl carrier protein transacylase', NULL, NULL, NULL, NULL, NULL, 4),
(128354, NULL, 'G3DSA:2.60.120.10:FF:000213', NULL, NULL, 'Malonyl-CoA decarboxylase (MCD), putative', NULL, NULL, NULL, NULL, NULL, 4),
(128355, NULL, 'G3DSA:2.60.40.10:FF:004640', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128356, NULL, 'G3DSA:2.10.25.10:FF:001504', NULL, NULL, 'Laminin subunit alpha-1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(128357, NULL, 'G3DSA:1.20.1070.10:FF:000541', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128358, NULL, 'G3DSA:2.40.50.140:FF:000561', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(128359, NULL, 'G3DSA:3.30.420.10:FF:000183', NULL, NULL, 'Putative phage transposase', NULL, NULL, NULL, NULL, NULL, 4),
(128360, NULL, 'G3DSA:3.40.630.30:FF:000641', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(128361, NULL, 'G3DSA:1.10.510.10:FF:001888', NULL, NULL, 'Putative cyclin-dependent protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(128362, NULL, 'G3DSA:3.30.505.10:FF:000116', NULL, NULL, 'SH2 domain-containing protein 4B', NULL, NULL, NULL, NULL, NULL, 4),
(128363, NULL, 'G3DSA:2.60.120.740:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128364, NULL, 'G3DSA:1.10.510.10:FF:000365', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase At1g17230', NULL, NULL, NULL, NULL, NULL, 4),
(128365, NULL, 'G3DSA:2.60.120.970:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128366, NULL, 'G3DSA:2.30.42.10:FF:000239', NULL, NULL, 'Golgi reassembly-stacking protein 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(128367, NULL, 'G3DSA:1.50.40.10:FF:000416', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128368, NULL, 'G3DSA:4.10.1000.10:FF:000019', NULL, NULL, 'cleavage and polyadenylation specificity factor subunit 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(128369, NULL, 'G3DSA:3.30.1850.10:FF:000001', NULL, NULL, 'LOG family protein YgdH', NULL, NULL, NULL, NULL, NULL, 4),
(128370, NULL, 'G3DSA:2.60.40.10:FF:000149', NULL, NULL, 'neural cell adhesion molecule 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(128371, NULL, 'G3DSA:3.40.50.300:FF:004798', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128372, NULL, 'G3DSA:1.10.1070.11:FF:000033', NULL, NULL, 'Serine/threonine-protein kinase MEC1', NULL, NULL, NULL, NULL, NULL, 4),
(128373, NULL, 'G3DSA:3.40.50.10810:FF:000035', NULL, NULL, 'DsDNA-dependent ATPase (Rad54b)', NULL, NULL, NULL, NULL, NULL, 4),
(128374, NULL, 'G3DSA:1.10.230.10:FF:000006', NULL, NULL, 'Citrate synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(128375, NULL, 'G3DSA:3.80.10.10:FF:001504', NULL, NULL, 'AGAP012425-PA', NULL, NULL, NULL, NULL, NULL, 4),
(128376, NULL, 'G3DSA:2.120.10.80:FF:000070', NULL, NULL, 'kelch-like protein 8 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(128377, NULL, 'G3DSA:3.40.50.1820:FF:001335', NULL, NULL, '3-oxoadipate enol-lactonase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(128378, NULL, 'G3DSA:3.30.160.60:FF:003134', NULL, NULL, 'Zinc finger protein 790', NULL, NULL, NULL, NULL, NULL, 4),
(128379, NULL, 'G3DSA:1.10.357.10:FF:000087', NULL, NULL, 'HTH-type transcriptional regulator BetI', NULL, NULL, NULL, NULL, NULL, 4),
(128380, NULL, 'G3DSA:1.10.220.30:FF:000040', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(128381, NULL, 'G3DSA:3.40.50.800:FF:000007', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(128382, NULL, 'G3DSA:3.30.1150.10:FF:000004', NULL, NULL, 'TonB-dependent receptor', NULL, NULL, NULL, NULL, NULL, 4),
(128383, NULL, 'G3DSA:2.40.50.100:FF:000009', NULL, NULL, 'Acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(128384, NULL, 'G3DSA:3.30.60.20:FF:000001', NULL, NULL, 'Protein unc-13 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(128385, NULL, 'G3DSA:3.80.10.10:FF:003062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128386, NULL, 'G3DSA:3.90.280.10:FF:000017', NULL, NULL, 'PEBP-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(128387, NULL, 'G3DSA:3.40.47.10:FF:000287', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128388, NULL, 'G3DSA:3.40.50.1970:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128389, NULL, 'G3DSA:3.90.660.10:FF:000114', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128390, NULL, 'G3DSA:3.30.40.10:FF:002374', NULL, NULL, 'Chromatin modification-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(128391, NULL, 'G3DSA:2.30.42.10:FF:000470', NULL, NULL, 'Putative serine protease HhoA', NULL, NULL, NULL, NULL, NULL, 4),
(128392, NULL, 'G3DSA:3.40.50.300:FF:000206', NULL, NULL, 'Ras-related protein Rab-3C', NULL, NULL, NULL, NULL, NULL, 4),
(128393, NULL, 'G3DSA:3.30.70.260:FF:000071', NULL, NULL, 'GTP pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(128394, NULL, 'G3DSA:1.10.472.80:FF:000038', NULL, NULL, 'TBC1 domain family member 5', NULL, NULL, NULL, NULL, NULL, 4),
(128395, NULL, 'G3DSA:3.40.640.10:FF:000017', NULL, NULL, 'Glutamate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(128396, NULL, 'G3DSA:3.55.20.10:FF:000001', NULL, NULL, 'Protein-L-isoaspartate O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(128397, NULL, 'G3DSA:3.60.40.10:FF:000310', NULL, NULL, 'Os11g0242200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(128398, NULL, 'G3DSA:1.25.40.10:FF:002745', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128399, NULL, 'G3DSA:1.10.555.10:FF:000249', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128400, NULL, 'G3DSA:1.25.40.10:FF:001317', NULL, NULL, 'Anaphase-promoting complex subunit CDC27', NULL, NULL, NULL, NULL, NULL, 4),
(128401, NULL, 'G3DSA:3.40.50.12670:FF:000003', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(128402, NULL, 'G3DSA:3.40.630.10:FF:000303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128403, NULL, 'G3DSA:1.20.1250.20:FF:000996', NULL, NULL, 'Sugar transporter', NULL, NULL, NULL, NULL, NULL, 4),
(128404, NULL, 'G3DSA:2.60.40.10:FF:002066', NULL, NULL, 'Turtle, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(128405, NULL, 'G3DSA:3.40.50.300:FF:005321', NULL, NULL, 'Si:ch211-113e8.9', NULL, NULL, NULL, NULL, NULL, 4),
(128406, NULL, 'G3DSA:1.25.10.10:FF:003070', NULL, NULL, 'Armadillo repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(128407, NULL, 'G3DSA:1.10.560.10:FF:000104', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128408, NULL, 'G3DSA:2.40.240.10:FF:000030', NULL, NULL, 'Putative glutaminyl-trna synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(128409, NULL, 'G3DSA:2.40.10.10:FF:000502', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128410, NULL, 'G3DSA:3.30.70.1230:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128411, NULL, 'G3DSA:3.80.10.10:FF:004377', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128412, NULL, 'G3DSA:3.40.50.1000:FF:000229', NULL, NULL, 'NLI interacting factor-like phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(128413, NULL, 'G3DSA:1.10.1780.10:FF:000018', NULL, NULL, 'Chaperone protein ClpB', NULL, NULL, NULL, NULL, NULL, 4),
(128414, NULL, 'G3DSA:2.10.25.10:FF:000791', NULL, NULL, 'Uninflatable, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(128415, NULL, 'G3DSA:1.25.40.10:FF:003465', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g52850, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(128416, NULL, 'G3DSA:2.40.50.140:FF:000662', NULL, NULL, 'DNA-directed RNA polymerase III subunit,putative', NULL, NULL, NULL, NULL, NULL, 4),
(128417, NULL, 'G3DSA:1.10.10.10:FF:000129', NULL, NULL, 'Helix-turn-helix transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(128418, NULL, 'G3DSA:2.60.40.10:FF:005371', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128419, NULL, 'G3DSA:1.20.5.390:FF:000008', NULL, NULL, 'Inhibitor of kappa light polypeptide gene enhancer in B-cells, kinase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(128420, NULL, 'G3DSA:3.40.50.1820:FF:000829', NULL, NULL, 'Alpha/beta-hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(128421, NULL, 'G3DSA:1.50.40.10:FF:000079', NULL, NULL, 'Mitochondrial carrier protein RIM2', NULL, NULL, NULL, NULL, NULL, 4),
(128422, NULL, 'G3DSA:3.40.50.2300:FF:001047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128423, NULL, 'G3DSA:1.25.10.10:FF:002440', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128424, NULL, 'G3DSA:3.40.50.720:FF:002226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128425, NULL, 'G3DSA:3.30.160.60:FF:001998', NULL, NULL, 'Transcription factor IIIA', NULL, NULL, NULL, NULL, NULL, 4),
(128426, NULL, 'G3DSA:3.30.70.100:FF:000063', NULL, NULL, 'N-terminal EF-hand calcium-binding protein 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(128427, NULL, 'G3DSA:2.170.270.10:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(128428, NULL, 'G3DSA:3.40.190.10:FF:000286', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(128429, NULL, 'G3DSA:1.10.246.170:FF:000002', NULL, NULL, 'AEL162Wp', NULL, NULL, NULL, NULL, NULL, 4),
(128430, NULL, 'G3DSA:1.20.1270.60:FF:000071', NULL, NULL, 'Uncharacterized protein, isoform U', NULL, NULL, NULL, NULL, NULL, 4),
(128431, NULL, 'G3DSA:3.40.50.11260:FF:000030', NULL, NULL, 'Heat shock protein', NULL, NULL, NULL, NULL, NULL, 4),
(128432, NULL, 'G3DSA:3.30.497.10:FF:000051', NULL, NULL, 'Serine protease inhibitor (serpin) 12', NULL, NULL, NULL, NULL, NULL, 4),
(128433, NULL, 'G3DSA:3.30.1520.10:FF:000027', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(128434, NULL, 'G3DSA:3.30.160.60:FF:002162', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM69', NULL, NULL, NULL, NULL, NULL, 4),
(128435, NULL, 'G3DSA:3.30.70.330:FF:001053', NULL, NULL, 'Protein CBG12231', NULL, NULL, NULL, NULL, NULL, 4),
(128436, NULL, 'G3DSA:3.40.800.20:FF:000011', NULL, NULL, 'Histone deacetylase HOS3', NULL, NULL, NULL, NULL, NULL, 4),
(128437, NULL, 'G3DSA:2.60.40.10:FF:004432', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128438, NULL, 'G3DSA:2.80.10.50:FF:000012', NULL, NULL, 'Protein O-mannosyl-transferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(128439, NULL, 'G3DSA:3.20.20.190:FF:000160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128440, NULL, 'G3DSA:3.60.110.10:FF:000057', NULL, NULL, 'Nit1p', NULL, NULL, NULL, NULL, NULL, 4),
(128441, NULL, 'G3DSA:2.60.40.60:FF:001108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128442, NULL, 'G3DSA:1.10.246.190:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128443, NULL, 'G3DSA:1.20.1740.10:FF:000171', NULL, NULL, 'Amino acid transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(128444, NULL, 'G3DSA:3.80.10.10:FF:000189', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(128445, NULL, 'G3DSA:2.30.29.30:FF:000484', NULL, NULL, 'Transcription initiation factor TFIIH subunit', NULL, NULL, NULL, NULL, NULL, 4),
(128446, NULL, 'G3DSA:1.25.40.720:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128447, NULL, 'G3DSA:3.90.1600.10:FF:000059', NULL, NULL, 'REV3 like, DNA directed polymerase zeta catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(128448, NULL, 'G3DSA:3.30.70.270:FF:000169', NULL, NULL, 'Putative diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(128449, NULL, 'G3DSA:2.130.10.10:FF:002038', NULL, NULL, 'Transcriptional corepressor LEUNIG', NULL, NULL, NULL, NULL, NULL, 4),
(128450, NULL, 'G3DSA:3.40.50.620:FF:000285', NULL, NULL, 'Leucyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(128451, NULL, 'G3DSA:3.30.200.20:FF:001176', NULL, NULL, 'WGS project CABT00000000 data, contig 2.13', NULL, NULL, NULL, NULL, NULL, 4),
(128452, NULL, 'G3DSA:3.30.200.20:FF:000557', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', NULL, NULL, NULL, NULL, NULL, 4),
(128453, NULL, 'G3DSA:1.25.40.10:FF:004302', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(128454, NULL, 'G3DSA:2.130.10.10:FF:005815', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128455, NULL, 'G3DSA:3.90.1750.10:FF:000042', NULL, NULL, 'E3 ubiquitin-protein ligase HECTD1', NULL, NULL, NULL, NULL, NULL, 4),
(128456, NULL, 'G3DSA:3.20.20.70:FF:000087', NULL, NULL, 'Anaerobic ribonucleoside-triphosphate reductase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(128457, NULL, 'G3DSA:3.40.1190.20:FF:000153', NULL, NULL, 'PfkB-type carbohydrate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(128458, NULL, 'G3DSA:3.30.160.100:FF:000009', NULL, NULL, 'Ribosome hibernation promoting factor', NULL, NULL, NULL, NULL, NULL, 4),
(128459, NULL, 'G3DSA:1.10.287.1490:FF:000065', NULL, NULL, 'Nuclear mitotic apparatus protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(128460, NULL, 'G3DSA:1.10.196.10:FF:000010', NULL, NULL, 'regulator of G-protein signaling 10 isoform X2', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(128461, NULL, 'G3DSA:2.10.25.10:FF:000886', NULL, NULL, 'LDL receptor protein 1, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(128462, NULL, 'G3DSA:3.90.550.10:FF:000353', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(128463, NULL, 'G3DSA:3.40.50.1000:FF:000128', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(128464, NULL, 'G3DSA:3.40.367.20:FF:000014', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(128465, NULL, 'G3DSA:1.25.40.10:FF:001109', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g31850, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(128466, NULL, 'G3DSA:2.60.120.1680:FF:000002', NULL, NULL, 'Polyprotein ORF1ab', NULL, NULL, NULL, NULL, NULL, 4),
(128467, NULL, 'G3DSA:3.60.40.10:FF:000102', NULL, NULL, 'Protein phosphatase PPM3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(128468, NULL, 'G3DSA:1.20.58.60:FF:000372', NULL, NULL, 'nesprin-2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(128469, NULL, 'G3DSA:3.90.76.10:FF:000054', NULL, NULL, 'Peptide ABC transporter, peptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(128470, NULL, 'G3DSA:3.30.70.330:FF:001637', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase-like 4', NULL, NULL, NULL, NULL, NULL, 4),
(128471, NULL, 'G3DSA:1.10.472.10:FF:000500', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128472, NULL, 'G3DSA:4.10.400.10:FF:000323', NULL, NULL, 'Complement component C9', NULL, NULL, NULL, NULL, NULL, 4),
(128473, NULL, 'G3DSA:2.60.40.10:FF:000037', NULL, NULL, 'Unc-5 netrin receptor C', NULL, NULL, NULL, NULL, NULL, 4),
(128474, NULL, 'G3DSA:2.40.50.100:FF:000122', NULL, NULL, 'Exosome complex exonuclease RRP4', NULL, NULL, NULL, NULL, NULL, 4),
(128475, NULL, 'G3DSA:3.10.450.60:FF:000002', NULL, NULL, 'Lipoxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(128476, NULL, 'G3DSA:1.10.540.10:FF:000092', NULL, NULL, 'Acyl-CoA dehydrogenase FadE32', NULL, NULL, NULL, NULL, NULL, 4),
(128477, NULL, 'G3DSA:3.90.70.200:FF:000017', NULL, NULL, 'Paf1 complex component', NULL, NULL, NULL, NULL, NULL, 4),
(128478, NULL, 'G3DSA:3.40.50.150:FF:001066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128479, NULL, 'G3DSA:3.40.30.10:FF:000439', NULL, NULL, 'Electron carrier/ oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(128480, NULL, 'G3DSA:1.10.8.100:FF:000014', NULL, NULL, 'RNA polymerase specificity factor', NULL, NULL, NULL, NULL, NULL, 4),
(128481, NULL, 'G3DSA:3.40.50.300:FF:003972', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128482, NULL, 'G3DSA:1.20.1070.10:FF:001513', NULL, NULL, 'Oxytocin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(128483, NULL, 'G3DSA:2.70.98.20:FF:000009', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(128484, NULL, 'G3DSA:3.90.640.10:FF:000006', NULL, NULL, 'Actin-related protein 3 (ARP3)', NULL, NULL, NULL, NULL, NULL, 4),
(128485, NULL, 'G3DSA:3.40.50.2300:FF:000428', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(128486, NULL, 'G3DSA:3.30.40.10:FF:001879', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128487, NULL, 'G3DSA:1.25.10.10:FF:001821', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128488, NULL, 'G3DSA:2.160.20.10:FF:000267', NULL, NULL, 'Pectin lyase-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(128489, NULL, 'G3DSA:3.40.309.10:FF:000079', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(128490, NULL, 'G3DSA:1.10.510.10:FF:003018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128491, NULL, 'G3DSA:2.60.40.10:FF:001785', NULL, NULL, 'Basement membrane proteoglycan', NULL, NULL, NULL, NULL, NULL, 4),
(128492, NULL, 'G3DSA:3.80.10.10:FF:003174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128493, NULL, 'G3DSA:1.25.40.20:FF:000253', NULL, NULL, 'Serine/threonine-protein phosphatase 6 regulatory ankyrin repeat subunit A', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(128494, NULL, 'G3DSA:1.20.190.20:FF:000008', NULL, NULL, 'F-box protein GID2', NULL, NULL, NULL, NULL, NULL, 4),
(128495, NULL, 'G3DSA:2.30.30.140:FF:000036', NULL, NULL, 'PWWP domain-containing protein 2A', NULL, NULL, NULL, NULL, NULL, 4),
(128496, NULL, 'G3DSA:1.50.10.20:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128497, NULL, 'G3DSA:1.10.287.370:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128498, NULL, 'G3DSA:2.130.10.10:FF:002370', NULL, NULL, 'Axonemal Inner Arm I1 Intermediate Chain Dynein', NULL, NULL, NULL, NULL, NULL, 4),
(128499, NULL, 'G3DSA:1.10.630.10:FF:000211', NULL, NULL, 'CYtochrome P450 family', NULL, NULL, NULL, NULL, NULL, 4),
(128500, NULL, 'G3DSA:3.30.40.10:FF:000345', NULL, NULL, 'Vacuolar protein sorting-associated protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(128501, NULL, 'G3DSA:3.40.50.720:FF:000877', NULL, NULL, 'NAD(P)-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(128502, NULL, 'G3DSA:3.20.10.10:FF:000023', NULL, NULL, 'Branched-chain amino acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(128503, NULL, 'G3DSA:1.10.510.10:FF:000601', NULL, NULL, 'Atypical/RIO/RIO2 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(128504, NULL, 'G3DSA:1.10.630.10:FF:000762', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128505, NULL, 'G3DSA:2.70.98.40:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128506, NULL, 'G3DSA:3.30.460.10:FF:000096', NULL, NULL, 'Tailor, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(128507, NULL, 'G3DSA:1.10.287.70:FF:000183', NULL, NULL, 'KCNN (Potassium K ChaNNel, calcium activated)-Like', NULL, NULL, NULL, NULL, NULL, 4),
(128508, NULL, 'G3DSA:1.20.5.340:FF:000022', NULL, NULL, 'Rabaptin, RAB GTPase-binding effector protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(128509, NULL, 'G3DSA:3.40.50.261:FF:000032', NULL, NULL, 'ATP-citrate synthase subunit alpha chain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(128510, NULL, 'G3DSA:3.40.50.2000:FF:000428', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(128511, NULL, 'G3DSA:1.25.10.10:FF:001945', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128512, NULL, 'G3DSA:3.30.450.40:FF:000126', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(128513, NULL, 'G3DSA:3.40.630.30:FF:000309', NULL, NULL, 'Increased DNA methylation 1', NULL, NULL, NULL, NULL, NULL, 4),
(128514, NULL, 'G3DSA:3.30.160.60:FF:000374', NULL, NULL, 'Zinc finger protein 208', NULL, NULL, NULL, NULL, NULL, 4),
(128515, NULL, 'G3DSA:3.10.100.10:FF:000377', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128516, NULL, 'G3DSA:3.30.260.10:FF:000108', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128517, NULL, 'G3DSA:1.10.220.10:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128518, NULL, 'G3DSA:1.10.287.1130:FF:000002', NULL, NULL, 'cx9C motif-containing protein 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(128519, NULL, 'G3DSA:2.130.10.10:FF:005484', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128520, NULL, 'G3DSA:1.10.287.130:FF:000038', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(128521, NULL, 'G3DSA:3.20.20.380:FF:000009', NULL, NULL, 'Copper homeostasis protein CutC', NULL, NULL, NULL, NULL, NULL, 4),
(128522, NULL, 'G3DSA:2.30.30.380:FF:000007', NULL, NULL, 'RanBP-type and C3HC4-type zinc finger-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(128523, NULL, 'G3DSA:3.80.10.10:FF:002909', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128524, NULL, 'G3DSA:3.40.50.720:FF:001506', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128525, NULL, 'G3DSA:3.30.830.10:FF:000225', NULL, NULL, 'Mitochondrial presequence protease', NULL, NULL, NULL, NULL, NULL, 4),
(128526, NULL, 'G3DSA:3.20.20.360:FF:000003', NULL, NULL, 'Malate synthase G', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(128527, NULL, 'G3DSA:3.90.1290.10:FF:000023', NULL, NULL, 'microtubule-actin cross-linking factor 1 isoform X12', NULL, NULL, NULL, NULL, NULL, 4),
(128528, NULL, 'G3DSA:3.30.420.10:FF:000306', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(128529, NULL, 'G3DSA:3.90.70.10:FF:000007', NULL, NULL, 'Probable ubiquitin carboxyl-terminal hydrolase FAF-X', NULL, NULL, NULL, NULL, NULL, 4),
(128530, NULL, 'G3DSA:3.40.50.300:FF:006147', NULL, NULL, 'Uncharacterized ATP-dependent helicase MG140', NULL, NULL, NULL, NULL, NULL, 4),
(128531, NULL, 'G3DSA:1.20.120.350:FF:000125', NULL, NULL, 'Protein CBR-SHW-1', NULL, NULL, NULL, NULL, NULL, 4),
(128532, NULL, 'G3DSA:2.30.30.360:FF:000001', NULL, NULL, 'Myosin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(128533, NULL, 'G3DSA:1.10.10.160:FF:000030', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(128534, NULL, 'G3DSA:1.20.1250.20:FF:000187', NULL, NULL, 'Solute carrier family 16 member 11', NULL, NULL, NULL, NULL, NULL, 4),
(128535, NULL, 'G3DSA:1.10.510.10:FF:003799', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128536, NULL, 'G3DSA:1.10.167.10:FF:000033', NULL, NULL, 'CRE-EAT-16 protein', NULL, NULL, NULL, NULL, NULL, 4),
(128537, NULL, 'G3DSA:3.30.230.10:FF:000270', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(128538, NULL, 'G3DSA:3.40.50.1820:FF:001543', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128539, NULL, 'G3DSA:2.60.200.20:FF:000279', NULL, NULL, 'Probable serine/threonine-protein kinase fhkB', NULL, NULL, NULL, NULL, NULL, 4),
(128540, NULL, 'G3DSA:3.40.50.300:FF:008300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128541, NULL, 'G3DSA:3.40.50.1820:FF:000262', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(128542, NULL, 'G3DSA:3.90.550.50:FF:000106', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(128543, NULL, 'G3DSA:3.40.1110.10:FF:000044', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(128544, NULL, 'G3DSA:1.10.860.10:FF:000020', NULL, NULL, 'Replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(128545, NULL, 'G3DSA:3.80.10.10:FF:003415', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128546, NULL, 'G3DSA:3.40.50.2300:FF:000855', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128547, NULL, 'G3DSA:1.20.1560.10:FF:000185', NULL, NULL, 'ABC transporter ATP-binding protein/permease', NULL, NULL, NULL, NULL, NULL, 4),
(128548, NULL, 'G3DSA:2.60.40.10:FF:005157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128549, NULL, 'G3DSA:1.25.40.10:FF:001773', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g36730', NULL, NULL, NULL, NULL, NULL, 4),
(128550, NULL, 'G3DSA:2.40.50.140:FF:001179', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128551, NULL, 'G3DSA:1.10.287.1150:FF:000008', NULL, NULL, 'Oxoglutarate dehydrogenase (Succinyl-transferring), E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(128552, NULL, 'G3DSA:3.40.50.10180:FF:000003', NULL, NULL, 'GLYCTK isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(128553, NULL, 'G3DSA:3.30.900.10:FF:000012', NULL, NULL, 'Hop1p', NULL, NULL, NULL, NULL, NULL, 4),
(128554, NULL, 'G3DSA:1.10.510.10:FF:004075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128555, NULL, 'G3DSA:3.80.10.10:FF:003758', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128556, NULL, 'G3DSA:2.160.20.10:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128557, NULL, 'G3DSA:1.20.1070.10:FF:000996', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128558, NULL, 'G3DSA:1.10.3330.10:FF:000002', NULL, NULL, 'Uric acid degradation bifunctional protein TTL', NULL, NULL, NULL, NULL, NULL, 4),
(128559, NULL, 'G3DSA:3.40.50.300:FF:007007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128560, NULL, 'G3DSA:3.10.50.10:FF:000009', NULL, NULL, 'CTS2p putative chitinase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(128561, NULL, 'G3DSA:4.10.365.10:FF:000010', NULL, NULL, 'Cyclin-dependent kinase inhibitor 1', NULL, NULL, NULL, NULL, NULL, 4),
(128562, NULL, 'G3DSA:3.30.230.10:FF:000371', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128563, NULL, 'G3DSA:2.70.220.10:FF:000005', NULL, NULL, 'Putative phosphatidylglycerol/phosphatidylinositol transfer protein DDB_G0282107', NULL, NULL, NULL, NULL, NULL, 4),
(128564, NULL, 'G3DSA:3.30.450.60:FF:000008', NULL, NULL, 'Coatomer subunit zeta-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(128565, NULL, 'G3DSA:1.20.58.670:FF:000002', NULL, NULL, 'Exocyst complex component', NULL, NULL, NULL, NULL, NULL, 4),
(128566, NULL, 'G3DSA:3.40.50.2300:FF:001131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128567, NULL, 'G3DSA:4.10.1000.40:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128568, NULL, 'G3DSA:1.10.510.10:FF:002630', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128569, NULL, 'G3DSA:1.20.1250.20:FF:002233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128570, NULL, 'G3DSA:1.50.40.10:FF:000192', NULL, NULL, 'Mitochondrial Carrier (MC) Family', NULL, NULL, NULL, NULL, NULL, 4),
(128571, NULL, 'G3DSA:1.25.10.10:FF:001737', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128572, NULL, 'G3DSA:2.40.50.120:FF:000004', NULL, NULL, 'WAP, Kazal, immunoglobulin, Kunitz and NTR domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(128573, NULL, 'G3DSA:1.20.1560.10:FF:000640', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128574, NULL, 'G3DSA:3.60.21.10:FF:000390', NULL, NULL, 'Protein phosphatase 5, catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(128575, NULL, 'G3DSA:3.80.10.10:FF:000083', NULL, NULL, 'Leiomodin 1', NULL, NULL, NULL, NULL, NULL, 4),
(128576, NULL, 'G3DSA:1.10.630.10:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128577, NULL, 'G3DSA:2.10.25.10:FF:000678', NULL, NULL, 'Uromodulin', NULL, NULL, NULL, NULL, NULL, 4),
(128578, NULL, 'G3DSA:3.60.21.10:FF:000070', NULL, NULL, '5`-nucleotidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(128579, NULL, 'G3DSA:3.50.50.60:FF:001416', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128580, NULL, 'G3DSA:2.40.50.140:FF:001281', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128581, NULL, 'G3DSA:2.70.98.90:FF:000002', NULL, NULL, 'Membrane protein insertase YidC', NULL, NULL, NULL, NULL, NULL, 4),
(128582, NULL, 'G3DSA:1.20.1250.10:FF:000089', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128583, NULL, 'G3DSA:3.30.70.1560:FF:000001', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(128584, NULL, 'G3DSA:3.40.850.10:FF:000527', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128585, NULL, 'G3DSA:3.90.180.10:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128586, NULL, 'G3DSA:3.80.10.10:FF:004034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128587, NULL, 'G3DSA:1.25.10.10:FF:002013', NULL, NULL, 'Splicing factor 3B subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(128588, NULL, 'G3DSA:1.10.510.10:FF:001337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128589, NULL, 'G3DSA:3.30.1490.480:FF:000010', NULL, NULL, 'Endolytic murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(128590, NULL, 'G3DSA:3.40.50.410:FF:000239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128591, NULL, 'G3DSA:3.30.1780.10:FF:000006', NULL, NULL, 'Proline utilization protein PrnX, putative', NULL, NULL, NULL, NULL, NULL, 4),
(128592, NULL, 'G3DSA:3.40.1280.10:FF:000045', NULL, NULL, 'Apicoplast RNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(128593, NULL, 'G3DSA:3.30.700.20:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128594, NULL, 'G3DSA:2.70.50.40:FF:000006', NULL, NULL, 'Retinal protein, putative', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(128595, NULL, 'G3DSA:1.25.10.10:FF:000309', NULL, NULL, 'NOP9 nucleolar protein', NULL, NULL, NULL, NULL, NULL, 4),
(128596, NULL, 'G3DSA:1.10.287.130:FF:000151', NULL, NULL, 'Sensor histidine kinase KdpD', NULL, NULL, NULL, NULL, NULL, 4),
(128597, NULL, 'G3DSA:3.40.50.1000:FF:000460', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128598, NULL, 'G3DSA:3.40.50.300:FF:007783', NULL, NULL, '26S protease regulatory subunit 6B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(128599, NULL, 'G3DSA:1.10.10.10:FF:001765', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128600, NULL, 'G3DSA:3.90.190.10:FF:000269', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128601, NULL, 'G3DSA:3.40.850.10:FF:000286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128602, NULL, 'G3DSA:1.20.1600.10:FF:000015', NULL, NULL, 'Outer membrane efflux protein', NULL, NULL, NULL, NULL, NULL, 4),
(128603, NULL, 'G3DSA:3.40.50.2000:FF:000771', NULL, NULL, 'Glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(128604, NULL, 'G3DSA:1.10.150.50:FF:000034', NULL, NULL, 'ankyrin repeat and SAM domain-containing protein 4B', NULL, NULL, NULL, NULL, NULL, 4),
(128605, NULL, 'G3DSA:3.40.50.1820:FF:001200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128606, NULL, 'G3DSA:2.130.10.30:FF:000122', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128607, NULL, 'G3DSA:2.130.10.10:FF:003095', NULL, NULL, 'WD repeat domain 90', NULL, NULL, NULL, NULL, NULL, 4),
(128608, NULL, 'G3DSA:3.10.20.30:FF:000064', NULL, NULL, 'SDHB isoform 7', NULL, NULL, NULL, NULL, NULL, 4),
(128609, NULL, 'G3DSA:3.40.50.300:FF:006046', NULL, NULL, 'DNA polymerase theta', NULL, NULL, NULL, NULL, NULL, 4),
(128610, NULL, 'G3DSA:1.10.220.160:FF:000008', NULL, NULL, 'Down and out, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(128611, NULL, 'G3DSA:2.30.30.790:FF:000012', NULL, NULL, 'Related to 50S ribosomal protein L19', NULL, NULL, NULL, NULL, NULL, 4),
(128612, NULL, 'G3DSA:1.10.150.50:FF:000169', NULL, NULL, 'Protein Smaug homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(128613, NULL, 'G3DSA:2.60.40.10:FF:000380', NULL, NULL, 'obscurin isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(128614, NULL, 'G3DSA:3.40.50.1400:FF:000035', NULL, NULL, 'Ferrochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(128615, NULL, 'G3DSA:3.30.565.10:FF:000108', NULL, NULL, 'Putative heat shock protein HSP 90-beta 2', NULL, NULL, NULL, NULL, NULL, 4),
(128616, NULL, 'G3DSA:3.30.200.20:FF:002002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128617, NULL, 'G3DSA:1.10.630.10:FF:000554', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128618, NULL, 'G3DSA:3.90.550.20:FF:000002', NULL, NULL, 'Initiation-specific alpha-1,6-mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(128619, NULL, 'G3DSA:1.50.10.20:FF:000024', NULL, NULL, 'Geranylgeranyl transferase type-2 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(128620, NULL, 'G3DSA:3.10.50.40:FF:000102', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(128621, NULL, 'G3DSA:3.40.50.300:FF:007327', NULL, NULL, 'Os05g0563100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(128622, NULL, 'G3DSA:2.30.29.30:FF:000725', NULL, NULL, 'Target of rapamycin complex 2 subunit MAPKAP1', NULL, NULL, NULL, NULL, NULL, 4),
(128623, NULL, 'G3DSA:4.10.400.10:FF:000082', NULL, NULL, 'Transmembrane serine protease 6', NULL, NULL, NULL, NULL, NULL, 4),
(128624, NULL, 'G3DSA:2.10.90.10:FF:000076', NULL, NULL, 'Interleukin 17c', NULL, NULL, NULL, NULL, NULL, 4),
(128625, NULL, 'G3DSA:1.10.238.10:FF:000799', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(128626, NULL, 'G3DSA:3.30.160.60:FF:005388', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128627, NULL, 'G3DSA:1.50.40.10:FF:000315', NULL, NULL, 'AaceriACR260Wp', NULL, NULL, NULL, NULL, NULL, 4),
(128628, NULL, 'G3DSA:3.30.565.10:FF:000440', NULL, NULL, 'Signal-transducing histidine kinase homolog', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(128629, NULL, 'G3DSA:3.10.290.10:FF:000025', NULL, NULL, '30S ribosomal subunit S4', NULL, NULL, NULL, NULL, NULL, 4),
(128630, NULL, 'G3DSA:1.10.30.10:FF:000030', NULL, NULL, 'HMG domain-containing protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(128631, NULL, 'G3DSA:2.60.40.10:FF:005955', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128632, NULL, 'G3DSA:3.40.720.10:FF:000086', NULL, NULL, 'CRE-SUL-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(128633, NULL, 'G3DSA:1.10.10.60:FF:001089', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128634, NULL, 'G3DSA:2.10.70.10:FF:000187', NULL, NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(128635, NULL, 'G3DSA:3.30.460.10:FF:000180', NULL, NULL, 'DNA polymerase sigma-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(128636, NULL, 'G3DSA:3.30.200.20:FF:000080', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(128637, NULL, 'G3DSA:4.10.60.10:FF:000120', NULL, NULL, 'Zinc knuckle (CCHC-type) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(128638, NULL, 'G3DSA:1.20.1540.10:FF:000077', NULL, NULL, 'Rhomboid family intramembrane serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(128639, NULL, 'G3DSA:2.30.29.30:FF:001001', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(128640, NULL, 'G3DSA:2.40.50.690:FF:000017', NULL, NULL, 'Mitotic control protein dis3', NULL, NULL, NULL, NULL, NULL, 4),
(128641, NULL, 'G3DSA:3.10.580.10:FF:000002', NULL, NULL, 'Magnesium/cobalt efflux protein CorC', NULL, NULL, NULL, NULL, NULL, 4),
(128642, NULL, 'G3DSA:1.20.58.90:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128643, NULL, 'G3DSA:1.20.58.60:FF:000259', NULL, NULL, 'Spectrin beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(128644, NULL, 'G3DSA:3.90.45.10:FF:000027', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(128645, NULL, 'G3DSA:3.40.1110.10:FF:000387', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128646, NULL, 'G3DSA:3.30.720.50:FF:000009', NULL, NULL, 'E3 ubiquitin-protein ligase HUWE1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(128647, NULL, 'G3DSA:1.10.238.10:FF:001199', NULL, NULL, 'Phosphatidylserine decarboxylase proenzyme 2', NULL, NULL, NULL, NULL, NULL, 4),
(128648, NULL, 'G3DSA:3.90.1430.10:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128649, NULL, 'G3DSA:1.10.8.60:FF:000481', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128650, NULL, 'G3DSA:3.40.50.1100:FF:000147', NULL, NULL, 'Cystathionine beta-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(128651, NULL, 'G3DSA:2.130.10.10:FF:003550', NULL, NULL, 'Anaphase-promoting complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(128652, NULL, 'G3DSA:2.40.30.30:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128653, NULL, 'G3DSA:1.10.10.1320:FF:000007', NULL, NULL, 'Putative transmembrane anti-sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(128654, NULL, 'G3DSA:3.40.30.10:FF:000198', NULL, NULL, 'Glutathione S-transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(128655, NULL, 'G3DSA:1.10.510.10:FF:002973', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128656, NULL, 'G3DSA:3.30.450.20:FF:000255', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(128657, NULL, 'G3DSA:3.40.50.10490:FF:000091', NULL, NULL, 'Iron dicitrate transport regulator FecR', NULL, NULL, NULL, NULL, NULL, 4),
(128658, NULL, 'G3DSA:2.130.10.10:FF:001650', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(128659, NULL, 'G3DSA:1.10.390.10:FF:000046', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(128660, NULL, 'G3DSA:3.30.450.20:FF:000036', NULL, NULL, 'Putative LOV domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(128661, NULL, 'G3DSA:3.80.10.10:FF:000987', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(128662, NULL, 'G3DSA:2.60.40.10:FF:000048', NULL, NULL, 'receptor-type tyrosine-protein phosphatase U isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(128663, NULL, 'G3DSA:4.10.900.10:FF:000007', NULL, NULL, 'Cadherin 22', NULL, NULL, NULL, NULL, NULL, 4),
(128664, NULL, 'G3DSA:1.25.10.10:FF:002917', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(128665, NULL, 'G3DSA:2.120.10.30:FF:000448', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128666, NULL, 'G3DSA:3.90.190.10:FF:000145', NULL, NULL, 'receptor-type tyrosine-protein phosphatase epsilon-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(128667, NULL, 'G3DSA:3.30.450.20:FF:000379', NULL, NULL, 'Sensory box histidine kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(128668, NULL, 'G3DSA:1.10.405.20:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128669, NULL, 'G3DSA:2.10.60.10:FF:000029', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(128670, NULL, 'G3DSA:3.30.70.330:FF:002918', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128671, NULL, 'G3DSA:2.20.28.10:FF:000055', NULL, NULL, 'Uncharacterized MCM-type protein MJ1489', NULL, NULL, NULL, NULL, NULL, 4),
(128672, NULL, 'G3DSA:3.20.20.80:FF:000640', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128673, NULL, 'G3DSA:1.25.40.80:FF:000017', NULL, NULL, 'Cryptochrome DASH', NULL, NULL, NULL, NULL, NULL, 4),
(128674, NULL, 'G3DSA:1.25.40.10:FF:000137', NULL, NULL, 'Pre-mRNA-splicing factor syf1', NULL, NULL, NULL, NULL, NULL, 4),
(128675, NULL, 'G3DSA:3.40.47.10:FF:000079', NULL, NULL, 'Acetyl-CoA acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(128676, NULL, 'G3DSA:2.60.120.200:FF:000536', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(128677, NULL, 'G3DSA:1.10.400.10:FF:000031', NULL, NULL, 'Guanine nucleotide-binding protein alpha-10 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(128678, NULL, 'G3DSA:1.20.120.1150:FF:000012', NULL, NULL, 'Serine/threonine-protein phosphatase 2A activator', NULL, NULL, NULL, NULL, NULL, 4),
(128679, NULL, 'G3DSA:2.60.40.10:FF:003926', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128680, NULL, 'G3DSA:1.20.1720.10:FF:000063', NULL, NULL, 'MFS multidrug transporter, putative (AFU_orthologue AFUA_2G05840)', NULL, NULL, NULL, NULL, NULL, 4),
(128681, NULL, 'G3DSA:1.20.91.20:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128682, NULL, 'G3DSA:3.30.870.10:FF:000014', NULL, NULL, 'Cardiolipin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(128683, NULL, 'G3DSA:2.60.40.1930:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128684, NULL, 'G3DSA:3.30.930.10:FF:000183', NULL, NULL, 'Phenylalanine--tRNA ligase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(128685, NULL, 'G3DSA:2.60.40.1910:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128686, NULL, 'G3DSA:2.130.10.10:FF:002611', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128687, NULL, 'G3DSA:3.40.50.300:FF:004910', NULL, NULL, 'GTP-binding nuclear protein Ran', NULL, NULL, NULL, NULL, NULL, 4),
(128688, NULL, 'G3DSA:2.170.190.11:FF:000013', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(128689, NULL, 'G3DSA:3.60.40.10:FF:000208', NULL, NULL, 'Stage II sporulation protein E', NULL, NULL, NULL, NULL, NULL, 4),
(128690, NULL, 'G3DSA:2.60.40.10:FF:004202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128691, NULL, 'G3DSA:2.60.40.10:FF:001009', NULL, NULL, 'Interleukin-12 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(128692, NULL, 'G3DSA:3.40.50.300:FF:000307', NULL, NULL, 'Phosphoribulokinase', NULL, NULL, NULL, NULL, NULL, 4),
(128693, NULL, 'G3DSA:1.20.90.10:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128694, NULL, 'G3DSA:1.20.1070.10:FF:000198', NULL, NULL, 'Prostaglandin I2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(128695, NULL, 'G3DSA:1.20.190.50:FF:000006', NULL, NULL, 'Nuclear pore complex protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(128696, NULL, 'G3DSA:3.30.56.30:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128697, NULL, 'G3DSA:2.70.98.40:FF:000004', NULL, NULL, 'Alpha,alpha-trehalose glucohydrolase TreA/Ath1', NULL, NULL, NULL, NULL, NULL, 4),
(128698, NULL, 'G3DSA:2.60.40.10:FF:005612', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128699, NULL, 'G3DSA:3.40.50.300:FF:001717', NULL, NULL, 'ATPase family AAA domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(128700, NULL, 'G3DSA:3.40.50.720:FF:001849', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128701, NULL, 'G3DSA:3.30.160.60:FF:006225', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128702, NULL, 'G3DSA:3.90.199.10:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128703, NULL, 'G3DSA:3.40.50.300:FF:004017', NULL, NULL, 'DRS1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(128704, NULL, 'G3DSA:3.30.70.100:FF:000164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128705, NULL, 'G3DSA:1.10.1420.10:FF:000205', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128706, NULL, 'G3DSA:3.40.50.300:FF:003617', NULL, NULL, 'Guanylate-binding family protein', NULL, NULL, NULL, NULL, NULL, 4),
(128707, NULL, 'G3DSA:2.60.40.10:FF:002302', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(128708, NULL, 'G3DSA:1.20.1110.10:FF:000157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128709, NULL, 'G3DSA:3.20.20.140:FF:000061', NULL, NULL, 'Adenine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(128710, NULL, 'G3DSA:2.30.110.10:FF:000079', NULL, NULL, 'Nitroreductase family deazaflavin-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(128711, NULL, 'G3DSA:3.40.50.300:FF:005427', NULL, NULL, 'DEAQ box RNA-dependent ATPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(128712, NULL, 'G3DSA:1.20.1270.60:FF:000172', NULL, NULL, 'Protein kinase C and casein kinase substrate in neurons 3', NULL, NULL, NULL, NULL, NULL, 4),
(128713, NULL, 'G3DSA:3.30.160.60:FF:005949', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128714, NULL, 'G3DSA:1.10.10.10:FF:000360', NULL, NULL, 'Transcription factor Dp-1, a', NULL, NULL, NULL, NULL, NULL, 4),
(128715, NULL, 'G3DSA:3.40.50.1240:FF:000161', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128716, NULL, 'G3DSA:1.10.8.60:FF:000379', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(128717, NULL, 'G3DSA:3.30.2170.10:FF:000005', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128718, NULL, 'G3DSA:2.40.10.10:FF:000047', NULL, NULL, 'Trypsin eta', NULL, NULL, NULL, NULL, NULL, 4),
(128719, NULL, 'G3DSA:2.30.30.40:FF:000569', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128720, NULL, 'G3DSA:3.30.160.60:FF:002515', NULL, NULL, 'Zinc finger protein 143', NULL, NULL, NULL, NULL, NULL, 4),
(128721, NULL, 'G3DSA:3.30.479.30:FF:000015', NULL, NULL, 'Flotillin-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(128722, NULL, 'G3DSA:3.30.160.60:FF:000037', NULL, NULL, 'B-cell lymphoma/leukemia 11A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(128723, NULL, 'G3DSA:1.20.1070.10:FF:001390', NULL, NULL, 'Protein CBG05486', NULL, NULL, NULL, NULL, NULL, 4),
(128724, NULL, 'G3DSA:3.20.20.140:FF:000292', NULL, NULL, 'Phosphotransferase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(128725, NULL, 'G3DSA:3.10.450.10:FF:000021', NULL, NULL, 'Retinoic acid receptor responder (tazarotene-induced) 1', NULL, NULL, NULL, NULL, NULL, 4),
(128726, NULL, 'G3DSA:2.170.190.11:FF:000018', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(128727, NULL, 'G3DSA:4.10.110.10:FF:000003', NULL, NULL, 'Maltase-glucoamylase, intestinal', NULL, NULL, NULL, NULL, NULL, 4),
(128728, NULL, 'G3DSA:3.40.50.720:FF:001046', NULL, NULL, 'D-aspartate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(128729, NULL, 'G3DSA:1.10.555.10:FF:000007', NULL, NULL, 'rho GTPase-activating protein 7 isoform X2', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(128730, NULL, 'G3DSA:2.40.70.10:FF:000495', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128731, NULL, 'G3DSA:3.20.20.80:FF:000539', NULL, NULL, 'Chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(128732, NULL, 'G3DSA:1.10.510.10:FF:003693', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128733, NULL, 'G3DSA:1.25.40.330:FF:000009', NULL, NULL, 'Adenylyl cyclase-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(128734, NULL, 'G3DSA:3.80.10.10:FF:002685', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(128735, NULL, 'G3DSA:3.30.1120.10:FF:000047', NULL, NULL, 'Iduronate-sulfatase or arylsulfatase A', NULL, NULL, NULL, NULL, NULL, 4),
(128736, NULL, 'G3DSA:2.60.40.1180:FF:000004', NULL, NULL, 'neutral alpha-glucosidase AB isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(128737, NULL, 'G3DSA:3.30.2350.10:FF:000093', NULL, NULL, 'TruB pseudouridine (psi) synthase family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(128738, NULL, 'G3DSA:2.130.10.10:FF:003230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128739, NULL, 'G3DSA:3.30.930.10:FF:000396', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128740, NULL, 'G3DSA:1.20.870.10:FF:000024', NULL, NULL, 'Rap guanine nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(128741, NULL, 'G3DSA:1.20.900.10:FF:000128', NULL, NULL, 'Son of sevenless 1', NULL, NULL, NULL, NULL, NULL, 4),
(128742, NULL, 'G3DSA:3.30.160.60:FF:004308', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128743, NULL, 'G3DSA:1.10.246.130:FF:000013', NULL, NULL, 'Putative gamma-glutamyltranspeptidase GgtB', NULL, NULL, NULL, NULL, NULL, 4),
(128744, NULL, 'G3DSA:3.30.1060.10:FF:000008', NULL, NULL, 'Peptide methionine sulfoxide reductase MsrA', NULL, NULL, NULL, NULL, NULL, 4),
(128745, NULL, 'G3DSA:2.10.110.10:FF:000292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128746, NULL, 'G3DSA:2.10.109.10:FF:000007', NULL, NULL, 'Chloroplast thylakoidal processing peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(128747, NULL, 'G3DSA:1.25.10.10:FF:001372', NULL, NULL, 'Armadillo-type protein', NULL, NULL, NULL, NULL, NULL, 4),
(128748, NULL, 'G3DSA:3.50.50.60:FF:000775', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(128749, NULL, 'G3DSA:1.20.1730.10:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128750, NULL, 'G3DSA:3.50.50.60:FF:001287', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128751, NULL, 'G3DSA:1.20.1250.20:FF:002098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128752, NULL, 'G3DSA:1.20.1280.50:FF:000012', NULL, NULL, 'F-box only protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(128753, NULL, 'G3DSA:3.90.770.10:FF:000004', NULL, NULL, '3-hydroxy-3-methylglutaryl coenzyme A reductase', NULL, NULL, NULL, NULL, NULL, 4),
(128754, NULL, 'G3DSA:1.25.40.10:FF:002397', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(128755, NULL, 'G3DSA:2.40.37.10:FF:000075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128756, NULL, 'G3DSA:1.25.40.10:FF:001885', NULL, NULL, 'TeTratriCopeptide repeat domain protein related', NULL, NULL, NULL, NULL, NULL, 4),
(128757, NULL, 'G3DSA:3.40.50.300:FF:007900', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(128758, NULL, 'G3DSA:3.40.50.10490:FF:000107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128759, NULL, 'G3DSA:3.40.850.10:FF:000073', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(128760, NULL, 'G3DSA:3.90.730.10:FF:000002', NULL, NULL, 'Ribonuclease I', NULL, NULL, NULL, NULL, NULL, 4),
(128761, NULL, 'G3DSA:3.40.50.720:FF:002569', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128762, NULL, 'G3DSA:4.10.1240.10:FF:000015', NULL, NULL, 'Vasoactive intestinal polypeptide receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(128763, NULL, 'G3DSA:2.70.150.10:FF:000011', NULL, NULL, 'Plasma membrane ATPase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(128764, NULL, 'G3DSA:3.30.70.890:FF:000035', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(128765, NULL, 'G3DSA:3.30.160.60:FF:004415', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128766, NULL, 'G3DSA:1.10.1780.10:FF:000013', NULL, NULL, 'ClpB protein', NULL, NULL, NULL, NULL, NULL, 4),
(128767, NULL, 'G3DSA:2.70.130.10:FF:000004', NULL, NULL, 'Insulin-like growth factor 2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(128768, NULL, 'G3DSA:3.10.105.10:FF:000124', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128769, NULL, 'G3DSA:4.10.280.10:FF:000094', NULL, NULL, 'Blast:Carbohydrate-responsive element-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(128770, NULL, 'G3DSA:3.40.50.80:FF:000074', NULL, NULL, 'Plasma membrane ferric-chelate reductase (Fre2), putative', NULL, NULL, NULL, NULL, NULL, 4),
(128771, NULL, 'G3DSA:2.60.40.60:FF:000939', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128772, NULL, 'G3DSA:3.40.80.10:FF:000038', NULL, NULL, 'Peptidoglycan recognition protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(128773, NULL, 'G3DSA:1.20.5.2210:FF:000002', NULL, NULL, 'ATP synthase subunit 4 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(128774, NULL, 'G3DSA:2.60.120.620:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128775, NULL, 'G3DSA:3.20.70.20:FF:000024', NULL, NULL, 'Anaerobic ribonucleoside triphosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(128776, NULL, 'G3DSA:2.60.40.10:FF:004882', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128777, NULL, 'G3DSA:2.130.10.10:FF:005461', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128778, NULL, 'G3DSA:1.20.90.10:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128779, NULL, 'G3DSA:1.10.510.10:FF:003586', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128780, NULL, 'G3DSA:2.40.50.140:FF:000903', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128781, NULL, 'G3DSA:3.20.20.70:FF:000643', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128782, NULL, 'G3DSA:3.30.160.810:FF:000003', NULL, NULL, '50S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(128783, NULL, 'G3DSA:1.10.510.10:FF:004210', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128784, NULL, 'G3DSA:1.10.30.10:FF:000131', NULL, NULL, 'HMG box protein, putative (AFU_orthologue AFUA_1G10040)', NULL, NULL, NULL, NULL, NULL, 4),
(128785, NULL, 'G3DSA:1.25.40.20:FF:000258', NULL, NULL, 'centaurin-gamma-1A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(128786, NULL, 'G3DSA:3.40.50.150:FF:001178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128787, NULL, 'G3DSA:2.60.120.260:FF:000195', NULL, NULL, 'C-type LECtin', NULL, NULL, NULL, NULL, NULL, 4),
(128788, NULL, 'G3DSA:3.40.50.300:FF:001375', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(128789, NULL, 'G3DSA:1.20.1070.10:FF:000777', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128790, NULL, 'G3DSA:3.90.550.10:FF:000123', NULL, NULL, 'Cell wall biosynthesis glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(128791, NULL, 'G3DSA:3.30.70.330:FF:000783', NULL, NULL, 'Glorund, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(128792, NULL, 'G3DSA:3.30.160.60:FF:000144', NULL, NULL, 'zinc finger protein 181 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(128793, NULL, 'G3DSA:1.20.140.150:FF:000041', NULL, NULL, 'Transmembrane protein 202', NULL, NULL, NULL, NULL, NULL, 4),
(128794, NULL, 'G3DSA:3.50.50.60:FF:001394', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128795, NULL, 'G3DSA:1.10.10.60:FF:000234', NULL, NULL, 'ISWI chromatin-remodeling complex ATPase ISW2', NULL, NULL, NULL, NULL, NULL, 4),
(128796, NULL, 'G3DSA:3.30.200.20:FF:001844', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128797, NULL, 'G3DSA:1.50.10.10:FF:000139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(128798, NULL, 'G3DSA:3.30.160.60:FF:001661', NULL, NULL, 'Zinc finger and SCAN domain-containing 26', NULL, NULL, NULL, NULL, NULL, 4),
(128799, NULL, 'G3DSA:1.20.1070.10:FF:001401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128800, NULL, 'G3DSA:3.30.60.30:FF:000228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128801, NULL, 'G3DSA:2.60.40.2950:FF:000001', NULL, NULL, 'Thioester-containing protein 2, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(128802, NULL, 'G3DSA:1.10.630.10:FF:000767', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128803, NULL, 'G3DSA:2.20.100.10:FF:000075', NULL, NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 17', NULL, NULL, NULL, NULL, NULL, 4),
(128804, NULL, 'G3DSA:3.40.50.10190:FF:000124', NULL, NULL, 'DNA topoisomerase 2-binding protein 1-A', NULL, NULL, NULL, NULL, NULL, 4),
(128805, NULL, 'G3DSA:2.60.120.330:FF:000019', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128806, NULL, 'G3DSA:1.25.40.20:FF:000472', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128807, NULL, 'G3DSA:3.40.50.300:FF:004129', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(128808, NULL, 'G3DSA:3.40.50.10190:FF:000231', NULL, NULL, 'YALI0B17006p', NULL, NULL, NULL, NULL, NULL, 4),
(128809, NULL, 'G3DSA:2.60.40.420:FF:000054', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(128810, NULL, 'G3DSA:1.25.40.180:FF:000150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128811, NULL, 'G3DSA:3.10.50.30:FF:000010', NULL, NULL, 'Transcription elongation factor GreA', NULL, NULL, NULL, NULL, NULL, 4),
(128812, NULL, 'G3DSA:3.30.70.330:FF:002014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128813, NULL, 'G3DSA:1.20.58.90:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128814, NULL, 'G3DSA:1.10.510.10:FF:000713', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(128815, NULL, 'G3DSA:3.30.1490.20:FF:000038', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(128816, NULL, 'G3DSA:2.60.40.60:FF:000035', NULL, NULL, 'Protocadherin Fat 3', NULL, NULL, NULL, NULL, NULL, 4),
(128817, NULL, 'G3DSA:2.60.120.310:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128818, NULL, 'G3DSA:2.60.120.920:FF:000090', NULL, NULL, 'Si:ch211-214c20.1', NULL, NULL, NULL, NULL, NULL, 4),
(128819, NULL, 'G3DSA:1.20.5.650:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128820, NULL, 'G3DSA:3.90.245.10:FF:000009', NULL, NULL, 'Inosine-uridine preferring nucleoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(128821, NULL, 'G3DSA:2.20.100.10:FF:000182', NULL, NULL, 'Thrombospondin type-1 domain-containing protein 7A', NULL, NULL, NULL, NULL, NULL, 4),
(128822, NULL, 'G3DSA:2.60.40.10:FF:000604', NULL, NULL, 'immunoglobulin superfamily member 3', NULL, NULL, NULL, NULL, NULL, 4),
(128823, NULL, 'G3DSA:3.40.50.11500:FF:000017', NULL, NULL, 'DENN (AEX-3) domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(128824, NULL, 'G3DSA:1.25.40.20:FF:000365', NULL, NULL, 'Start control protein cdc10', NULL, NULL, NULL, NULL, NULL, 4),
(128825, NULL, 'G3DSA:3.60.15.10:FF:000010', NULL, NULL, 'DNA cross-link repair 1A', NULL, NULL, NULL, NULL, NULL, 4),
(128826, NULL, 'G3DSA:3.20.20.70:FF:000862', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128827, NULL, 'G3DSA:1.20.58.70:FF:000032', NULL, NULL, 'DIABLO isoform 9', NULL, NULL, NULL, NULL, NULL, 4),
(128828, NULL, 'G3DSA:1.10.10.60:FF:000341', NULL, NULL, 'Zinc finger homeobox 2', NULL, NULL, NULL, NULL, NULL, 4),
(128829, NULL, 'G3DSA:1.10.506.10:FF:000041', NULL, NULL, 'Ras GTPase-activating-like protein IQG1', NULL, NULL, NULL, NULL, NULL, 4),
(128830, NULL, 'G3DSA:3.40.30.10:FF:000434', NULL, NULL, 'ThioredoXin Domain Containing protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(128831, NULL, 'G3DSA:1.25.10.10:FF:003188', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(128832, NULL, 'G3DSA:1.20.1080.10:FF:000047', NULL, NULL, 'Formate/nitrite transporter', NULL, NULL, NULL, NULL, NULL, 4),
(128833, NULL, 'G3DSA:3.10.20.90:FF:000054', NULL, NULL, 'Ubiquitin-like protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(128834, NULL, 'G3DSA:1.20.120.720:FF:000039', NULL, NULL, 'Chitin synthase 8', NULL, NULL, NULL, NULL, NULL, 4),
(128835, NULL, 'G3DSA:6.10.140.2220:FF:000065', NULL, NULL, 'SET domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(128836, NULL, 'G3DSA:3.30.160.60:FF:002510', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128837, NULL, 'G3DSA:1.25.40.10:FF:003813', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128838, NULL, 'G3DSA:3.60.40.10:FF:000315', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128839, NULL, 'G3DSA:1.10.8.270:FF:000014', NULL, NULL, 'Putative TBC1 domain family member 2B', NULL, NULL, NULL, NULL, NULL, 4),
(128840, NULL, 'G3DSA:1.10.287.470:FF:000016', NULL, NULL, 'Efflux transporter, RND family, MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(128841, NULL, 'G3DSA:3.40.570.10:FF:000028', NULL, NULL, 'AGAP004948-PA', NULL, NULL, NULL, NULL, NULL, 4),
(128842, NULL, 'G3DSA:3.30.160.60:FF:002858', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128843, NULL, 'G3DSA:1.25.40.10:FF:000036', NULL, NULL, 'interferon-induced protein with tetratricopeptide repeats 5', NULL, NULL, NULL, NULL, NULL, 4),
(128844, NULL, 'G3DSA:2.120.10.30:FF:000100', NULL, NULL, 'NHL repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(128845, NULL, 'G3DSA:3.90.79.10:FF:000212', NULL, NULL, 'Nucleoside diphosphate-linked moiety X motif 13', NULL, NULL, NULL, NULL, NULL, 4),
(128846, NULL, 'G3DSA:3.30.70.330:FF:000676', NULL, NULL, 'U2 snRNP auxiliary factor large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(128847, NULL, 'G3DSA:2.40.10.170:FF:000005', NULL, NULL, 'ATP synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(128848, NULL, 'G3DSA:3.40.50.150:FF:001285', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128849, NULL, 'G3DSA:3.40.50.1820:FF:001223', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128850, NULL, 'G3DSA:1.20.58.390:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128851, NULL, 'G3DSA:2.10.50.10:FF:000074', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 5', NULL, NULL, NULL, NULL, NULL, 4),
(128852, NULL, 'G3DSA:3.30.70.330:FF:000564', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(128853, NULL, 'G3DSA:3.30.420.40:FF:000181', NULL, NULL, 'Plasmid segregation protein ParM', NULL, NULL, NULL, NULL, NULL, 4),
(128854, NULL, 'G3DSA:3.40.50.2300:FF:001592', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128855, NULL, 'G3DSA:1.10.1200.270:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128856, NULL, 'G3DSA:2.60.120.10:FF:000556', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128857, NULL, 'G3DSA:3.40.605.10:FF:000003', NULL, NULL, 'Methylmalonate-semialdehyde dehydrogenase [acylating]', NULL, NULL, NULL, NULL, NULL, 4),
(128858, NULL, 'G3DSA:3.90.190.10:FF:000488', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128859, NULL, 'G3DSA:3.50.50.60:FF:000668', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128860, NULL, 'G3DSA:1.25.50.20:FF:000079', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(128861, NULL, 'G3DSA:2.60.40.10:FF:003477', NULL, NULL, 'Guanine nucleotide exchange factor UNC-73A', NULL, NULL, NULL, NULL, NULL, 4),
(128862, NULL, 'G3DSA:3.40.50.300:FF:005990', NULL, NULL, 'cell cycle checkpoint protein RAD17', NULL, NULL, NULL, NULL, NULL, 4),
(128863, NULL, 'G3DSA:1.20.120.610:FF:000006', NULL, NULL, 'ATP synthase subunit c', NULL, NULL, NULL, NULL, NULL, 4),
(128864, NULL, 'G3DSA:2.30.180.10:FF:000145', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128865, NULL, 'G3DSA:3.40.1390.30:FF:000019', NULL, NULL, 'GTP cyclohydrolase 1 type 2 homolog', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(128866, NULL, 'G3DSA:3.40.50.300:FF:002679', NULL, NULL, 'Ste6p', NULL, NULL, NULL, NULL, NULL, 4),
(128867, NULL, 'G3DSA:2.60.120.620:FF:000095', NULL, NULL, 'Prolyl 4-hydroxylase alpha subunit 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(128868, NULL, 'G3DSA:3.90.190.10:FF:000033', NULL, NULL, 'receptor-type tyrosine-protein phosphatase C isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(128869, NULL, 'G3DSA:1.10.10.10:FF:001641', NULL, NULL, 'YALI0B16280p', NULL, NULL, NULL, NULL, NULL, 4),
(128870, NULL, 'G3DSA:1.25.10.10:FF:001265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128871, NULL, 'G3DSA:3.90.1480.20:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128872, NULL, 'G3DSA:3.30.70.330:FF:001076', NULL, NULL, 'RNA-binding protein CP29B chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(128873, NULL, 'G3DSA:3.40.50.150:FF:000796', NULL, NULL, 'Protein CBG04220', NULL, NULL, NULL, NULL, NULL, 4),
(128874, NULL, 'G3DSA:3.10.105.10:FF:000017', NULL, NULL, 'Oligopeptide ABC transporter, periplasmic oligopeptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(128875, NULL, 'G3DSA:1.25.40.20:FF:001669', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128876, NULL, 'G3DSA:1.10.10.10:FF:002041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128877, NULL, 'G3DSA:3.80.10.10:FF:000324', NULL, NULL, 'Protein phosphatase 1 regulatory subunit 37', NULL, NULL, NULL, NULL, NULL, 4),
(128878, NULL, 'G3DSA:2.130.10.10:FF:005591', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128879, NULL, 'G3DSA:2.40.50.140:FF:000898', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128880, NULL, 'G3DSA:3.30.1360.10:FF:000048', NULL, NULL, 'DNA-directed RNA polymerases II IV and V subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(128881, NULL, 'G3DSA:1.20.1730.10:FF:000013', NULL, NULL, 'sodium/myo-inositol cotransporter isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(128882, NULL, 'G3DSA:1.10.10.60:FF:000919', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128883, NULL, 'G3DSA:2.60.120.200:FF:000761', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128884, NULL, 'G3DSA:3.30.930.10:FF:000289', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(128885, NULL, 'G3DSA:3.80.10.10:FF:004135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128886, NULL, 'G3DSA:3.30.1330.30:FF:000086', NULL, NULL, 'Ribosomal protein S12', NULL, NULL, NULL, NULL, NULL, 4),
(128887, NULL, 'G3DSA:1.25.40.70:FF:000026', NULL, NULL, 'Phosphatidylinositol 3-kinase piki-1', NULL, NULL, NULL, NULL, NULL, 4),
(128888, NULL, 'G3DSA:2.120.10.30:FF:000555', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128889, NULL, 'G3DSA:3.90.550.10:FF:000016', NULL, NULL, 'LARGE xylosyl- and glucuronyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(128890, NULL, 'G3DSA:3.40.50.1820:FF:000481', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(128891, NULL, 'G3DSA:3.30.360.10:FF:000032', NULL, NULL, 'GDH/6PGL endoplasmic bifunctional protein', NULL, NULL, NULL, NULL, NULL, 4),
(128892, NULL, 'G3DSA:2.30.30.30:FF:000004', NULL, NULL, '50S ribosomal protein L24', NULL, NULL, NULL, NULL, NULL, 4),
(128893, NULL, 'G3DSA:1.20.120.850:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128894, NULL, 'G3DSA:3.40.50.300:FF:005534', NULL, NULL, 'RAB40C, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(128895, NULL, 'G3DSA:2.60.40.10:FF:002061', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(128896, NULL, 'G3DSA:3.30.9.10:FF:000273', NULL, NULL, 'D-Amino acid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(128897, NULL, 'G3DSA:3.70.10.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128898, NULL, 'G3DSA:3.40.50.720:FF:002563', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(128899, NULL, 'G3DSA:3.30.300.10:FF:000039', NULL, NULL, 'Methionine S-adenosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(128900, NULL, 'G3DSA:3.40.50.720:FF:000197', NULL, NULL, 'Bifunctional polymyxin resistance protein ArnA', NULL, NULL, NULL, NULL, NULL, 4),
(128901, NULL, 'G3DSA:3.30.200.20:FF:000321', NULL, NULL, 'serine/threonine-protein kinase N3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(128902, NULL, 'G3DSA:1.25.40.10:FF:005252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128903, NULL, 'G3DSA:1.20.1250.20:FF:000659', NULL, NULL, 'Unplaced genomic scaffold supercont2.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(128904, NULL, 'G3DSA:3.40.50.1400:FF:000012', NULL, NULL, 'Ferrochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(128905, NULL, 'G3DSA:3.30.70.330:FF:002930', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128906, NULL, 'G3DSA:3.90.70.10:FF:000794', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128907, NULL, 'G3DSA:3.30.60.20:FF:000113', NULL, NULL, 'Kinase suppressor of ras 1', NULL, NULL, NULL, NULL, NULL, 4),
(128908, NULL, 'G3DSA:3.40.50.300:FF:007895', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128909, NULL, 'G3DSA:3.40.50.300:FF:002224', NULL, NULL, 'V-type ATP synthase alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(128910, NULL, 'G3DSA:3.30.70.980:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128911, NULL, 'G3DSA:1.50.10.10:FF:000240', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(128912, NULL, 'G3DSA:3.20.20.80:FF:000409', NULL, NULL, 'Beta-glucosidase 11', NULL, NULL, NULL, NULL, NULL, 4),
(128913, NULL, 'G3DSA:3.40.250.10:FF:000100', NULL, NULL, 'Rhodanese-like/PpiC domain-containing protein 12, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(128914, NULL, 'G3DSA:2.60.40.420:FF:000166', NULL, NULL, 'Coagulation factor V', NULL, NULL, NULL, NULL, NULL, 4),
(128915, NULL, 'G3DSA:2.60.120.620:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128916, NULL, 'G3DSA:2.80.10.50:FF:000248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128917, NULL, 'G3DSA:2.40.10.10:FF:000154', NULL, NULL, 'Family with sequence similarity 111 member A', NULL, NULL, NULL, NULL, NULL, 4),
(128918, NULL, 'G3DSA:3.40.1350.10:FF:000034', NULL, NULL, 'tRNA-splicing endonuclease subunit Sen2', NULL, NULL, NULL, NULL, NULL, 4),
(128919, NULL, 'G3DSA:1.10.420.10:FF:000049', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(128920, NULL, 'G3DSA:3.40.1110.10:FF:000488', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128921, NULL, 'G3DSA:1.20.1070.10:FF:000092', NULL, NULL, 'Galanin receptor type 2', NULL, NULL, NULL, NULL, NULL, 4),
(128922, NULL, 'G3DSA:4.10.60.10:FF:000221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128923, NULL, 'G3DSA:1.10.20.10:FF:000310', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128924, NULL, 'G3DSA:3.40.630.30:FF:000085', NULL, NULL, 'Putative N-acetyltransferase complex ARD1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(128925, NULL, 'G3DSA:1.20.1560.10:FF:000634', NULL, NULL, 'p-glycoprotein-2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(128926, NULL, 'G3DSA:3.40.950.10:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128927, NULL, 'G3DSA:1.10.510.10:FF:001332', NULL, NULL, 'Serine/threonine-protein kinase Nek1', NULL, NULL, NULL, NULL, NULL, 4),
(128928, NULL, 'G3DSA:1.25.10.10:FF:002676', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128929, NULL, 'G3DSA:3.40.50.2300:FF:001603', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128930, NULL, 'G3DSA:3.40.190.10:FF:000842', NULL, NULL, 'Polar amino acid uptake family ABC transporter, periplasmic substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(128931, NULL, 'G3DSA:3.10.50.40:FF:000125', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(128932, NULL, 'G3DSA:2.130.10.10:FF:003915', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128933, NULL, 'G3DSA:3.40.1190.10:FF:000032', NULL, NULL, 'UDP-N-acetylmuramoyl-L-alanyl-D-glutamate--2,6-diaminopimelate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(128934, NULL, 'G3DSA:2.60.120.200:FF:000216', NULL, NULL, 'Blast:Protein eyes shut', NULL, NULL, NULL, NULL, NULL, 4),
(128935, NULL, 'G3DSA:1.10.10.1760:FF:000010', NULL, NULL, 'Ribosomal protein L36e, putative', NULL, NULL, NULL, NULL, NULL, 4),
(128936, NULL, 'G3DSA:3.30.420.40:FF:000866', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128937, NULL, 'G3DSA:2.170.150.10:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128938, NULL, 'G3DSA:3.30.70.141:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128939, NULL, 'G3DSA:2.10.220.10:FF:000070', NULL, NULL, 'Erb-b2 receptor tyrosine kinase 3b', NULL, NULL, NULL, NULL, NULL, 4),
(128940, NULL, 'G3DSA:3.40.50.720:FF:000646', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(128941, NULL, 'G3DSA:3.40.190.10:FF:000954', NULL, NULL, 'Peptide/opine/nickel uptake family ABC transporter, periplasmic substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(128942, NULL, 'G3DSA:3.30.930.10:FF:000284', NULL, NULL, 'Proline--tRNA ligase cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(128943, NULL, 'G3DSA:3.30.160.60:FF:006332', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128944, NULL, 'G3DSA:1.25.40.20:FF:001770', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128945, NULL, 'G3DSA:1.10.10.1760:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128946, NULL, 'G3DSA:3.40.190.290:FF:000103', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(128947, NULL, 'G3DSA:3.90.1750.10:FF:000047', NULL, NULL, 'HECT, C2 and WW domain-containing E3 ubiquitin protein ligase 1', NULL, NULL, NULL, NULL, NULL, 4),
(128948, NULL, 'G3DSA:1.10.150.20:FF:000166', NULL, NULL, 'DNA-directed RNA polymerase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(128949, NULL, 'G3DSA:3.20.20.140:FF:000162', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(128950, NULL, 'G3DSA:3.30.70.340:FF:000005', NULL, NULL, 'Carboxypeptidase A', NULL, NULL, NULL, NULL, NULL, 4),
(128951, NULL, 'G3DSA:3.30.70.330:FF:001632', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128952, NULL, 'G3DSA:3.30.450.60:FF:000020', NULL, NULL, 'Coatomer subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(128953, NULL, 'G3DSA:3.40.1370.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128954, NULL, 'G3DSA:1.20.1280.50:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128955, NULL, 'G3DSA:1.10.10.10:FF:001085', NULL, NULL, 'transcription factor protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(128956, NULL, 'G3DSA:1.25.40.10:FF:004763', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128957, NULL, 'G3DSA:1.10.1580.10:FF:000014', NULL, NULL, 'GTP-binding proteins, putative, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(128958, NULL, 'G3DSA:1.10.10.2010:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128959, NULL, 'G3DSA:3.40.50.300:FF:000751', NULL, NULL, 'Rab family GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(128960, NULL, 'G3DSA:3.40.50.300:FF:001370', NULL, NULL, 'p-GlycoProtein related', NULL, NULL, NULL, NULL, NULL, 4),
(128961, NULL, 'G3DSA:2.20.25.80:FF:000007', NULL, NULL, 'WRKY transcription factor 22', NULL, NULL, NULL, NULL, NULL, 4),
(128962, NULL, 'G3DSA:3.10.430.100:FF:000008', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(128963, NULL, 'G3DSA:2.10.25.10:FF:000094', NULL, NULL, 'Laminin subunit alpha-2', NULL, NULL, NULL, NULL, NULL, 4),
(128964, NULL, 'G3DSA:1.10.3730.20:FF:000075', NULL, NULL, 'Uncharacterized transporter HI_0878', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(128965, NULL, 'G3DSA:3.30.160.60:FF:001442', NULL, NULL, 'zinc finger protein 696', NULL, NULL, NULL, NULL, NULL, 4),
(128966, NULL, 'G3DSA:3.30.200.20:FF:001277', NULL, NULL, 'Protein kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(128967, NULL, 'G3DSA:1.10.287.70:FF:000632', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128968, NULL, 'G3DSA:3.10.20.90:FF:000958', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128969, NULL, 'G3DSA:2.60.40.10:FF:001661', NULL, NULL, 'Down syndrome cell adhesion molecule 3, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(128970, NULL, 'G3DSA:3.30.40.10:FF:000682', NULL, NULL, 'E3 ubiquitin-protein ligase HRD1', NULL, NULL, NULL, NULL, NULL, 4),
(128971, NULL, 'G3DSA:3.50.50.60:FF:001175', NULL, NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(128972, NULL, 'G3DSA:2.30.27.10:FF:000002', NULL, NULL, 'Attachment protein G3P', NULL, NULL, NULL, NULL, NULL, 4),
(128973, NULL, 'G3DSA:3.40.50.300:FF:001263', NULL, NULL, 'ADP-ribosylation factor 2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(128974, NULL, 'G3DSA:1.10.8.60:FF:000250', NULL, NULL, 'Replication factor C subunit 4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(128975, NULL, 'G3DSA:3.30.160.60:FF:002061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128976, NULL, 'G3DSA:3.90.228.10:FF:000037', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(128977, NULL, 'G3DSA:2.130.10.10:FF:000352', NULL, NULL, 'WD repeat-containing protein DWA2', NULL, NULL, NULL, NULL, NULL, 4),
(128978, NULL, 'G3DSA:2.130.10.10:FF:004972', NULL, NULL, 'Cell division cycle protein cdt2', NULL, NULL, NULL, NULL, NULL, 4),
(128979, NULL, 'G3DSA:3.60.90.10:FF:000026', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(128980, NULL, 'G3DSA:3.80.20.20:FF:000030', NULL, NULL, 'LD35811p', NULL, NULL, NULL, NULL, NULL, 4),
(128981, NULL, 'G3DSA:3.40.50.12650:FF:000020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(128982, NULL, 'G3DSA:3.30.1960.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128983, NULL, 'G3DSA:2.30.39.10:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128984, NULL, 'G3DSA:3.40.250.10:FF:000229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(128985, NULL, 'G3DSA:1.20.1250.20:FF:002340', NULL, NULL, 'Synaptic vesicle protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(128986, NULL, 'G3DSA:3.30.160.60:FF:005820', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128987, NULL, 'G3DSA:3.30.160.60:FF:000149', NULL, NULL, 'Zinc finger protein 569', NULL, NULL, NULL, NULL, NULL, 4),
(128988, NULL, 'G3DSA:2.30.180.10:FF:000140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128989, NULL, 'G3DSA:3.30.365.10:FF:000003', NULL, NULL, 'Aldehyde oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(128990, NULL, 'G3DSA:3.90.1520.10:FF:000002', NULL, NULL, 'Guanylate cyclase soluble subunit alpha-3 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(128991, NULL, 'G3DSA:3.40.50.720:FF:001265', NULL, NULL, 'Altronate oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(128992, NULL, 'G3DSA:3.30.70.270:FF:000181', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128993, NULL, 'G3DSA:4.10.830.10:FF:000001', NULL, NULL, '30S ribosomal protein S14 type Z', NULL, NULL, NULL, NULL, NULL, 4),
(128994, NULL, 'G3DSA:3.10.20.90:FF:000273', NULL, NULL, 'Wide awake, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(128995, NULL, 'G3DSA:2.160.20.70:FF:000026', NULL, NULL, 'TuBulin folding Cofactor C homolog', NULL, NULL, NULL, NULL, NULL, 4),
(128996, NULL, 'G3DSA:3.40.50.10700:FF:000002', NULL, NULL, 'D-aminoacyl-tRNA deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(128997, NULL, 'G3DSA:3.30.160.60:FF:005713', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(128998, NULL, 'G3DSA:3.100.10.10:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(128999, NULL, 'G3DSA:2.60.120.10:FF:000337', NULL, NULL, 'Germin-like protein subfamily 1 member 8', NULL, NULL, NULL, NULL, NULL, 4),
(129000, NULL, 'G3DSA:1.10.730.20:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129001, NULL, 'G3DSA:2.40.10.10:FF:000603', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129002, NULL, 'G3DSA:3.40.50.720:FF:000989', NULL, NULL, 'Short-chain dehydrogenase/reductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(129003, NULL, 'G3DSA:1.10.10.60:FF:001302', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129004, NULL, 'G3DSA:2.130.10.10:FF:001206', NULL, NULL, 'Polyadenylation factor I', NULL, NULL, NULL, NULL, NULL, 4),
(129005, NULL, 'G3DSA:3.20.20.80:FF:000180', NULL, NULL, 'Glycoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(129006, NULL, 'G3DSA:1.20.1270.10:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129007, NULL, 'G3DSA:1.10.168.10:FF:000001', NULL, NULL, 'phosducin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(129008, NULL, 'G3DSA:1.10.8.60:FF:000143', NULL, NULL, 'DNA replication factor C subunit Rfc2', NULL, NULL, NULL, NULL, NULL, 4),
(129009, NULL, 'G3DSA:3.30.450.20:FF:000143', NULL, NULL, 'Unplaced genomic scaffold supercont2.18, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(129010, NULL, 'G3DSA:3.40.50.620:FF:000386', NULL, NULL, 'Nicotinamide-nucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(129011, NULL, 'G3DSA:1.10.246.10:FF:000003', NULL, NULL, 'Serum albumin', NULL, NULL, NULL, NULL, NULL, 4),
(129012, NULL, 'G3DSA:3.30.56.30:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129013, NULL, 'G3DSA:2.130.10.10:FF:001313', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129014, NULL, 'G3DSA:1.10.630.10:FF:000312', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129015, NULL, 'G3DSA:3.40.5.120:FF:000006', NULL, NULL, 'Brahma, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(129016, NULL, 'G3DSA:3.40.950.10:FF:000013', NULL, NULL, 'Hydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129017, NULL, 'G3DSA:2.10.110.10:FF:000297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129018, NULL, 'G3DSA:3.90.226.10:FF:000089', NULL, NULL, 'Membrane-bound serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(129019, NULL, 'G3DSA:2.40.10.10:FF:000042', NULL, NULL, 'Kallikrein 1-related peptidase C9', NULL, NULL, NULL, NULL, NULL, 4),
(129020, NULL, 'G3DSA:3.40.50.300:FF:001712', NULL, NULL, 'ATP-binding cassette protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(129021, NULL, 'G3DSA:3.40.50.620:FF:000734', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129022, NULL, 'G3DSA:3.40.50.1820:FF:001442', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129023, NULL, 'G3DSA:3.30.40.10:FF:001643', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129024, NULL, 'G3DSA:1.25.40.340:FF:000001', NULL, NULL, 'Dihydroxyacetone kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(129025, NULL, 'G3DSA:3.30.460.10:FF:000073', NULL, NULL, 'ATPase synthesis protein 25, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(129026, NULL, 'G3DSA:1.20.1440.100:FF:000006', NULL, NULL, 'HAD-IB family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(129027, NULL, 'G3DSA:2.60.40.10:FF:005713', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129028, NULL, 'G3DSA:1.25.40.10:FF:001093', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g34400', NULL, NULL, NULL, NULL, NULL, 4),
(129029, NULL, 'G3DSA:3.40.50.300:FF:005315', NULL, NULL, 'DRL1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(129030, NULL, 'G3DSA:2.10.25.10:FF:000436', NULL, NULL, 'matrilin-2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(129031, NULL, 'G3DSA:3.20.10.10:FF:000046', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(129032, NULL, 'G3DSA:3.40.140.10:FF:000108', NULL, NULL, 'Splicing factor Prp8, putative', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(129033, NULL, 'G3DSA:3.40.50.720:FF:001613', NULL, NULL, '3-ketodihydrosphingosine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(129034, NULL, 'G3DSA:3.30.160.60:FF:002403', NULL, NULL, 'zinc finger protein 420', NULL, NULL, NULL, NULL, NULL, 4),
(129035, NULL, 'G3DSA:2.30.30.190:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129036, NULL, 'G3DSA:2.60.40.640:FF:000007', NULL, NULL, 'Arrestin domain-containing protein 3 mRNA', NULL, NULL, NULL, NULL, NULL, 4),
(129037, NULL, 'G3DSA:3.90.1140.10:FF:000012', NULL, NULL, 'A-kinase anchoring protein 18 gamma', NULL, NULL, NULL, NULL, NULL, 4),
(129038, NULL, 'G3DSA:3.30.70.330:FF:002469', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129039, NULL, 'G3DSA:3.40.50.1010:FF:000221', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129040, NULL, 'G3DSA:3.60.40.10:FF:000203', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129041, NULL, 'G3DSA:3.30.40.10:FF:001986', NULL, NULL, 'TNF receptor-associated factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129042, NULL, 'G3DSA:1.20.1250.20:FF:000760', NULL, NULL, 'Beta-alanine transporter', NULL, NULL, NULL, NULL, NULL, 4),
(129043, NULL, 'G3DSA:2.10.25.10:FF:001403', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129044, NULL, 'G3DSA:1.10.238.10:FF:000687', NULL, NULL, 'EF hand family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(129045, NULL, 'G3DSA:3.40.50.140:FF:000012', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(129046, NULL, 'G3DSA:3.40.50.1480:FF:000002', NULL, NULL, 'Adenosylhomocysteinase', NULL, NULL, NULL, NULL, NULL, 4),
(129047, NULL, 'G3DSA:1.20.1250.20:FF:001160', NULL, NULL, 'MFS sugar transporte, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129048, NULL, 'G3DSA:2.70.130.10:FF:000009', NULL, NULL, 'Insulin-like growth factor 2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(129049, NULL, 'G3DSA:4.10.1110.10:FF:000005', NULL, NULL, 'Zinc finger AN1-type containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(129050, NULL, 'G3DSA:1.20.1050.120:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129051, NULL, 'G3DSA:3.40.850.10:FF:000522', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(129052, NULL, 'G3DSA:3.40.50.80:FF:000181', NULL, NULL, 'Ferric reductase NAD binding domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(129053, NULL, 'G3DSA:1.10.600.10:FF:000142', NULL, NULL, 'Os04g0612000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(129054, NULL, 'G3DSA:2.60.40.60:FF:000254', NULL, NULL, 'Dachsous cadherin-related 1', NULL, NULL, NULL, NULL, NULL, 4),
(129055, NULL, 'G3DSA:2.60.40.10:FF:001442', NULL, NULL, 'von Willebrand factor A domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(129056, NULL, 'G3DSA:1.20.1560.10:FF:000871', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129057, NULL, 'G3DSA:3.30.1490.180:FF:000038', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(129058, NULL, 'G3DSA:3.40.50.300:FF:000644', NULL, NULL, 'GpmB, Fructose-2,6-bisphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(129059, NULL, 'G3DSA:3.40.50.2300:FF:000187', NULL, NULL, 'Biodegradative arginine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(129060, NULL, 'G3DSA:3.30.160.20:FF:000036', NULL, NULL, 'Double-stranded RNA-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(129061, NULL, 'G3DSA:2.130.10.10:FF:001656', NULL, NULL, 'WD_domain_-_G-beta_repeat /Utp13_specific_WD40_associated_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(129062, NULL, 'G3DSA:2.60.40.420:FF:000161', NULL, NULL, 'Ubiquinol oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(129063, NULL, 'G3DSA:2.40.37.10:FF:000070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129064, NULL, 'G3DSA:4.10.1080.10:FF:000013', NULL, NULL, 'Cartilage oligomeric matrix protein', NULL, NULL, NULL, NULL, NULL, 4),
(129065, NULL, 'G3DSA:1.20.1560.10:FF:000741', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(129066, NULL, 'G3DSA:2.130.10.10:FF:000245', NULL, NULL, 'WD repeat-containing protein 70', NULL, NULL, NULL, NULL, NULL, 4),
(129067, NULL, 'G3DSA:3.90.70.10:FF:000687', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129068, NULL, 'G3DSA:1.20.1270.420:FF:000006', NULL, NULL, 'ikappaB kinase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(129069, NULL, 'G3DSA:3.90.1410.10:FF:000005', NULL, NULL, 'Ribulose-1,5 bisphosphate carboxylase/oxygenase large subunit N-methyltransferase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(129070, NULL, 'G3DSA:1.10.8.60:FF:000593', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129071, NULL, 'G3DSA:3.10.450.60:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129072, NULL, 'G3DSA:3.40.910.10:FF:000016', NULL, NULL, 'Deoxyhypusine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(129073, NULL, 'G3DSA:3.40.190.10:FF:000050', NULL, NULL, 'Sulfonate ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(129074, NULL, 'G3DSA:3.90.190.10:FF:000140', NULL, NULL, 'Unplaced genomic scaffold supercont2.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(129075, NULL, 'G3DSA:3.40.50.2300:FF:000535', NULL, NULL, 'Transcriptional regulator, LacI family', NULL, NULL, NULL, NULL, NULL, 4),
(129076, NULL, 'G3DSA:3.40.50.20:FF:000084', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129077, NULL, 'G3DSA:1.20.5.50:FF:000010', NULL, NULL, 'Cell division protein ZapA', NULL, NULL, NULL, NULL, NULL, 4),
(129078, NULL, 'G3DSA:3.50.30.20:FF:000015', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129079, NULL, 'G3DSA:3.90.550.10:FF:000128', NULL, NULL, 'Glycosyl transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(129080, NULL, 'G3DSA:3.30.110.200:FF:000001', NULL, NULL, 'Diguanylate cyclase/phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(129081, NULL, 'G3DSA:1.25.10.10:FF:001153', NULL, NULL, 'RIC8', NULL, NULL, NULL, NULL, NULL, 4),
(129082, NULL, 'G3DSA:3.20.20.330:FF:000028', NULL, NULL, '5-methyltetrahydrofolate:homocysteine methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129083, NULL, 'G3DSA:3.30.430.20:FF:000029', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 42', NULL, NULL, NULL, NULL, NULL, 4),
(129084, NULL, 'G3DSA:2.30.29.30:FF:001007', NULL, NULL, 'EAP30/Vps36 family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129085, NULL, 'G3DSA:3.30.70.80:FF:000047', NULL, NULL, 'Fervidolysin', NULL, NULL, NULL, NULL, NULL, 4),
(129086, NULL, 'G3DSA:2.40.50.90:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129087, NULL, 'G3DSA:3.40.190.10:FF:000393', NULL, NULL, 'Peptide/nickel transport system substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(129088, NULL, 'G3DSA:2.70.98.20:FF:000021', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(129089, NULL, 'G3DSA:1.10.510.10:FF:003698', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129090, NULL, 'G3DSA:1.20.920.10:FF:000130', NULL, NULL, 'PolyBRoMo domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(129091, NULL, 'G3DSA:1.20.58.340:FF:000033', NULL, NULL, 'Magnesium and cobalt transport protein CorA, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129092, NULL, 'G3DSA:3.90.660.10:FF:000119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129093, NULL, 'G3DSA:1.10.1450.10:FF:000134', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(129094, NULL, 'G3DSA:3.80.10.10:FF:002792', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129095, NULL, 'G3DSA:3.40.190.10:FF:000735', NULL, NULL, 'Pca operon transcriptional activator PcaQ', NULL, NULL, NULL, NULL, NULL, 4),
(129096, NULL, 'G3DSA:1.10.10.10:FF:002046', NULL, NULL, 'DNA-directed RNA polymerase III subunit rpc3', NULL, NULL, NULL, NULL, NULL, 4),
(129097, NULL, 'G3DSA:1.20.1250.20:FF:001721', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(129098, NULL, 'G3DSA:2.60.40.10:FF:000481', NULL, NULL, 'Leucine-rich repeat neuronal protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(129099, NULL, 'G3DSA:3.40.50.11580:FF:000002', NULL, NULL, 'Replicase polyprotein 1ab', NULL, NULL, NULL, NULL, NULL, 4),
(129100, NULL, 'G3DSA:3.30.160.60:FF:005365', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129101, NULL, 'G3DSA:3.30.160.60:FF:001094', NULL, NULL, 'Zinc finger and BTB domain containing 22', NULL, NULL, NULL, NULL, NULL, 4),
(129102, NULL, 'G3DSA:2.10.25.10:FF:000566', NULL, NULL, 'delta and Notch-like epidermal growth factor-related receptor', NULL, NULL, NULL, NULL, NULL, 4),
(129103, NULL, 'G3DSA:3.30.70.330:FF:000671', NULL, NULL, 'Splicing factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(129104, NULL, 'G3DSA:3.40.50.300:FF:007788', NULL, NULL, 'Ras, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129105, NULL, 'G3DSA:1.10.238.10:FF:001176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129106, NULL, 'G3DSA:1.20.1250.10:FF:000083', NULL, NULL, 'Interferon kappa', NULL, NULL, NULL, NULL, NULL, 4),
(129107, NULL, 'G3DSA:3.40.50.300:FF:006602', NULL, NULL, 'Zgc:194443', NULL, NULL, NULL, NULL, NULL, 4),
(129108, NULL, 'G3DSA:3.30.70.1230:FF:000144', NULL, NULL, 'Adenylate cyclase 3', NULL, NULL, NULL, NULL, NULL, 4),
(129109, NULL, 'G3DSA:4.10.1220.10:FF:000002', NULL, NULL, 'Transmembrane serine protease 7', NULL, NULL, NULL, NULL, NULL, 4),
(129110, NULL, 'G3DSA:1.25.40.10:FF:002846', NULL, NULL, 'Mitochondrial group I intron splicing factor CCM1', NULL, NULL, NULL, NULL, NULL, 4),
(129111, NULL, 'G3DSA:1.25.10.10:FF:000883', NULL, NULL, 'BNR1p Formin', NULL, NULL, NULL, NULL, NULL, 4),
(129112, NULL, 'G3DSA:1.25.10.10:FF:000208', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(129113, NULL, 'G3DSA:1.10.510.10:FF:001770', NULL, NULL, 'Protein CBG24817', NULL, NULL, NULL, NULL, NULL, 4),
(129114, NULL, 'G3DSA:2.40.128.620:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129115, NULL, 'G3DSA:1.10.630.10:FF:000655', NULL, NULL, 'Os01g0227400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(129116, NULL, 'G3DSA:1.10.510.10:FF:001225', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(129117, NULL, 'G3DSA:1.10.630.10:FF:000531', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129118, NULL, 'G3DSA:1.10.150.50:FF:000057', NULL, NULL, 'Arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(129119, NULL, 'G3DSA:3.80.10.10:FF:001381', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129120, NULL, 'G3DSA:3.30.1490.480:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129121, NULL, 'G3DSA:3.40.50.1010:FF:000002', NULL, NULL, 'Exonuclease 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129122, NULL, 'G3DSA:3.30.450.40:FF:000019', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(129123, NULL, 'G3DSA:2.10.25.10:FF:001055', NULL, NULL, 'Wall-associated receptor kinase-like 8', NULL, NULL, NULL, NULL, NULL, 4),
(129124, NULL, 'G3DSA:3.10.350.10:FF:000069', NULL, NULL, 'Putative cell wall hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(129125, NULL, 'G3DSA:3.40.50.10140:FF:000019', NULL, NULL, '18w protein', NULL, NULL, NULL, NULL, NULL, 4),
(129126, NULL, 'G3DSA:3.30.530.20:FF:000200', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129127, NULL, 'G3DSA:3.20.110.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129128, NULL, 'G3DSA:2.40.30.70:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129129, NULL, 'G3DSA:2.20.25.30:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129130, NULL, 'G3DSA:3.30.200.20:FF:001625', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129131, NULL, 'G3DSA:3.40.50.300:FF:001931', NULL, NULL, 'Blast:Carbohydrate sulfotransferase 4', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(129132, NULL, 'G3DSA:3.30.40.10:FF:002262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129133, NULL, 'G3DSA:2.10.25.10:FF:000779', NULL, NULL, 'Eyes shut homolog', NULL, NULL, NULL, NULL, NULL, 4),
(129134, NULL, 'G3DSA:3.40.50.300:FF:002331', NULL, NULL, 'ATP-dependent RNA helicase MSS116, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(129135, NULL, 'G3DSA:1.10.1740.10:FF:000016', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(129136, NULL, 'G3DSA:3.40.50.150:FF:000228', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase C', NULL, NULL, NULL, NULL, NULL, 4),
(129137, NULL, 'G3DSA:1.20.920.30:FF:000012', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129138, NULL, 'G3DSA:1.10.555.10:FF:000137', NULL, NULL, 'rho GTPase-activating protein 18 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(129139, NULL, 'G3DSA:4.10.1000.10:FF:000014', NULL, NULL, 'Zinc finger CCCH domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(129140, NULL, 'G3DSA:3.40.50.410:FF:000003', NULL, NULL, 'Collagen type VI alpha 3 chain', NULL, NULL, NULL, NULL, NULL, 4),
(129141, NULL, 'G3DSA:1.10.565.10:FF:000183', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(129142, NULL, 'G3DSA:1.25.10.10:FF:001714', NULL, NULL, 'Nuclear condensing complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(129143, NULL, 'G3DSA:3.30.710.10:FF:000519', NULL, NULL, 'GH14381p', NULL, NULL, NULL, NULL, NULL, 4),
(129144, NULL, 'G3DSA:3.30.70.330:FF:001744', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129145, NULL, 'G3DSA:3.40.50.300:FF:006041', NULL, NULL, 'Excision repair cross-complementing rodent repair deficiency, complementation group 2', NULL, NULL, NULL, NULL, NULL, 4),
(129146, NULL, 'G3DSA:3.40.50.10880:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129147, NULL, 'G3DSA:3.90.70.10:FF:000119', NULL, NULL, 'Ubiquitin specific peptidase 36', NULL, NULL, NULL, NULL, NULL, 4),
(129148, NULL, 'G3DSA:3.20.20.80:FF:000303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129149, NULL, 'G3DSA:1.10.150.20:FF:000278', NULL, NULL, 'FA core complex-associated protein 24', NULL, NULL, NULL, NULL, NULL, 4),
(129150, NULL, 'G3DSA:2.60.120.290:FF:000063', NULL, NULL, 'LDL receptor related protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(129151, NULL, 'G3DSA:2.60.120.260:FF:000644', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129152, NULL, 'G3DSA:2.50.20.10:FF:000019', NULL, NULL, 'Sigma-E factor regulatory protein RseB', NULL, NULL, NULL, NULL, NULL, 4),
(129153, NULL, 'G3DSA:3.40.50.720:FF:000776', NULL, NULL, 'Multi-functional enzyme with acyl-CoA-reductase activity ACRA1', NULL, NULL, NULL, NULL, NULL, 4),
(129154, NULL, 'G3DSA:1.10.8.530:FF:000002', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(129155, NULL, 'G3DSA:2.130.10.10:FF:001425', NULL, NULL, 'Damaged DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(129156, NULL, 'G3DSA:1.10.3720.10:FF:000026', NULL, NULL, 'Phosphate transport system permease protein PstA', NULL, NULL, NULL, NULL, NULL, 4),
(129157, NULL, 'G3DSA:2.60.120.590:FF:000046', NULL, NULL, 'DNA oxidative demethylase ALKBH2', NULL, NULL, NULL, NULL, NULL, 4),
(129158, NULL, 'G3DSA:2.130.10.10:FF:005708', NULL, NULL, 'Putative CPSF-domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(129159, NULL, 'G3DSA:2.20.28.10:FF:000050', NULL, NULL, 'DNA replication licensing factor MCM4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(129160, NULL, 'G3DSA:3.40.50.1460:FF:000007', NULL, NULL, 'Caspase-1', NULL, NULL, NULL, NULL, NULL, 4),
(129161, NULL, 'G3DSA:2.60.120.10:FF:000106', NULL, NULL, 'Nucleoside diphosphate kinase 7', NULL, NULL, NULL, NULL, NULL, 4),
(129162, NULL, 'G3DSA:3.30.300.20:FF:000025', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(129163, NULL, 'G3DSA:3.40.50.1440:FF:000013', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(129164, NULL, 'G3DSA:3.40.50.150:FF:000341', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase K/L', NULL, NULL, NULL, NULL, NULL, 4),
(129165, NULL, 'G3DSA:3.30.200.20:FF:000877', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(129166, NULL, 'G3DSA:1.20.1560.10:FF:000073', NULL, NULL, 'ATP binding cassette subfamily B member 8', NULL, NULL, NULL, NULL, NULL, 4),
(129167, NULL, 'G3DSA:2.60.40.150:FF:000748', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129168, NULL, 'G3DSA:1.20.1280.50:FF:000248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129169, NULL, 'G3DSA:3.20.20.70:FF:000194', NULL, NULL, 'Oxaloacetate decarboxylase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(129170, NULL, 'G3DSA:1.25.40.10:FF:002161', NULL, NULL, 'ER organization and biogenesis-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129171, NULL, 'G3DSA:3.40.50.2300:FF:001154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129172, NULL, 'G3DSA:1.10.1520.10:FF:000022', NULL, NULL, 'Unplaced genomic scaffold supercont2.5, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(129173, NULL, 'G3DSA:1.20.1250.20:FF:000316', NULL, NULL, 'Solute carrier family 15, member 5', NULL, NULL, NULL, NULL, NULL, 4),
(129174, NULL, 'G3DSA:1.10.510.10:FF:002405', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129175, NULL, 'G3DSA:2.30.30.1020:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129176, NULL, 'G3DSA:3.30.160.60:FF:006220', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129177, NULL, 'G3DSA:1.10.472.80:FF:000240', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129178, NULL, 'G3DSA:3.40.50.2300:FF:000642', NULL, NULL, 'Arsenate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(129179, NULL, 'G3DSA:3.30.1740.10:FF:000015', NULL, NULL, 'PARP-type zinc finger-containing protein C2A9.07c', NULL, NULL, NULL, NULL, NULL, 4),
(129180, NULL, 'G3DSA:3.30.40.10:FF:000570', NULL, NULL, 'Os11g0144800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(129181, NULL, 'G3DSA:2.30.30.140:FF:000042', NULL, NULL, 'male-specific lethal 3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(129182, NULL, 'G3DSA:1.25.10.10:FF:001720', NULL, NULL, 'Armadillo repeat-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(129183, NULL, 'G3DSA:3.10.20.90:FF:000503', NULL, NULL, 'Steroid 5 alpha reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129184, NULL, 'G3DSA:1.10.10.2480:FF:000001', NULL, NULL, 'Translation initiation factor IF-2', NULL, NULL, NULL, NULL, NULL, 4),
(129185, NULL, 'G3DSA:3.40.50.360:FF:000055', NULL, NULL, 'FMN-dependent NADH-azoreductase 2', NULL, NULL, NULL, NULL, NULL, 4),
(129186, NULL, 'G3DSA:2.40.50.140:FF:000555', NULL, NULL, 'Methionyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(129187, NULL, 'G3DSA:3.40.630.30:FF:000534', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(129188, NULL, 'G3DSA:3.30.565.10:FF:000333', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(129189, NULL, 'G3DSA:3.40.47.10:FF:000293', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129190, NULL, 'G3DSA:3.30.360.10:FF:000144', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129191, NULL, 'G3DSA:3.30.30.30:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129192, NULL, 'G3DSA:1.20.1310.10:FF:000026', NULL, NULL, 'Cullin 1', NULL, NULL, NULL, NULL, NULL, 4),
(129193, NULL, 'G3DSA:1.25.40.10:FF:002852', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(129194, NULL, 'G3DSA:3.30.505.10:FF:000122', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(129195, NULL, 'G3DSA:2.60.40.60:FF:000597', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129196, NULL, 'G3DSA:2.60.120.430:FF:000032', NULL, NULL, 'Chondroitin sulfate ABC exolyase', NULL, NULL, NULL, NULL, NULL, 4),
(129197, NULL, 'G3DSA:2.30.30.40:FF:000119', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(129198, NULL, 'G3DSA:1.10.3130.10:FF:000009', NULL, NULL, 'Serine O-acetyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(129199, NULL, 'G3DSA:3.30.450.50:FF:000028', NULL, NULL, 'Yeast SEC homolog', NULL, NULL, NULL, NULL, NULL, 4),
(129200, NULL, 'G3DSA:3.90.1150.10:FF:000417', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(129201, NULL, 'G3DSA:3.40.50.1000:FF:000016', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(129202, NULL, 'G3DSA:3.50.30.30:FF:000001', NULL, NULL, 'Vacuolar-sorting receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(129203, NULL, 'G3DSA:3.40.50.280:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129204, NULL, 'G3DSA:2.30.42.60:FF:000001', NULL, NULL, 'Probable periplasmic serine endoprotease DegP-like', NULL, NULL, NULL, NULL, NULL, 4),
(129205, NULL, 'G3DSA:1.25.40.10:FF:003690', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(129206, NULL, 'G3DSA:1.20.58.340:FF:000027', NULL, NULL, 'CorA family metal ion transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(129207, NULL, 'G3DSA:3.40.50.300:FF:005422', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129208, NULL, 'G3DSA:3.40.50.150:FF:001757', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129209, NULL, 'G3DSA:3.40.33.10:FF:000120', NULL, NULL, 'LOC100135358 protein', NULL, NULL, NULL, NULL, NULL, 4),
(129210, NULL, 'G3DSA:4.10.400.10:FF:000087', NULL, NULL, 'low-density lipoprotein receptor class A domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(129211, NULL, 'G3DSA:3.40.50.2000:FF:000327', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129212, NULL, 'G3DSA:3.10.20.120:FF:000001', NULL, NULL, 'Enterotoxin type A', NULL, NULL, NULL, NULL, NULL, 4),
(129213, NULL, 'G3DSA:3.40.50.720:FF:000085', NULL, NULL, 'Dihydroflavonol reductase', NULL, NULL, NULL, NULL, NULL, 4),
(129214, NULL, 'G3DSA:3.10.129.10:FF:000128', NULL, NULL, 'Acyl-CoA thioester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(129215, NULL, 'G3DSA:3.90.10.10:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129216, NULL, 'G3DSA:3.40.50.11260:FF:000024', NULL, NULL, 'Chaperone protein HtpG', NULL, NULL, NULL, NULL, NULL, 4),
(129217, NULL, 'G3DSA:2.90.10.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129218, NULL, 'G3DSA:1.10.800.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129219, NULL, 'G3DSA:3.30.200.20:FF:001389', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129220, NULL, 'G3DSA:2.60.40.60:FF:000703', NULL, NULL, 'Cdh-4', NULL, NULL, NULL, NULL, NULL, 4),
(129221, NULL, 'G3DSA:3.30.160.60:FF:005495', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129222, NULL, 'G3DSA:1.25.40.10:FF:003358', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At3g16890, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(129223, NULL, 'G3DSA:3.30.930.10:FF:000053', NULL, NULL, 'Phenylalanyl-tRNA synthetase mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(129224, NULL, 'G3DSA:3.80.10.10:FF:002117', NULL, NULL, 'Nodulin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(129225, NULL, 'G3DSA:3.30.160.60:FF:006113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129226, NULL, 'G3DSA:1.20.1560.10:FF:000180', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(129227, NULL, 'G3DSA:3.80.10.10:FF:002342', NULL, NULL, 'Leucine rich repeat containing 29, isoform CRA_c', NULL, NULL, NULL, NULL, NULL, 4),
(129228, NULL, 'G3DSA:3.30.2160.10:FF:000050', NULL, NULL, 'E3 ubiquitin-protein ligase UBR5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(129229, NULL, 'G3DSA:1.20.1280.290:FF:000082', NULL, NULL, 'L-cystine transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129230, NULL, 'G3DSA:3.40.50.10140:FF:000025', NULL, NULL, 'Disease resistance protein (TIR-NBS-LRR class)', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(129231, NULL, 'G3DSA:3.30.160.60:FF:003347', NULL, NULL, 'Zinc finger protein 169', NULL, NULL, NULL, NULL, NULL, 4),
(129232, NULL, 'G3DSA:4.10.1000.10:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129233, NULL, 'G3DSA:1.25.10.10:FF:000192', NULL, NULL, 'Interferon related developmental regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(129234, NULL, 'G3DSA:1.10.10.1050:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129235, NULL, 'G3DSA:3.90.1490.10:FF:000004', NULL, NULL, 'ATP binding L-PSP endoribonuclease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(129236, NULL, 'G3DSA:3.30.70.330:FF:000221', NULL, NULL, 'calcipressin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(129237, NULL, 'G3DSA:3.30.450.30:FF:000022', NULL, NULL, 'Related to Dynein light chain 2B, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(129238, NULL, 'G3DSA:3.40.50.300:FF:003281', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129239, NULL, 'G3DSA:3.30.40.10:FF:000457', NULL, NULL, 'RING-H2 finger protein ATL3', NULL, NULL, NULL, NULL, NULL, 4),
(129240, NULL, 'G3DSA:1.20.150.20:FF:000006', NULL, NULL, 'Mitochondrial F1F0 ATP synthase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(129241, NULL, 'G3DSA:2.60.40.10:FF:004207', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129242, NULL, 'G3DSA:1.10.8.60:FF:000374', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(129243, NULL, 'G3DSA:1.20.1110.10:FF:000045', NULL, NULL, 'ATPase 4 plasma membrane-type', NULL, NULL, NULL, NULL, NULL, 4),
(129244, NULL, 'G3DSA:3.20.20.190:FF:000059', NULL, NULL, 'Glycerophosphodiester phosphodiesterase domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(129245, NULL, 'G3DSA:3.40.50.300:FF:007552', NULL, NULL, 'SMC domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(129246, NULL, 'G3DSA:3.30.160.60:FF:001217', NULL, NULL, 'zinc finger protein 319', NULL, NULL, NULL, NULL, NULL, 4),
(129247, NULL, 'G3DSA:3.20.20.190:FF:000166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129248, NULL, 'G3DSA:1.10.287.110:FF:000049', NULL, NULL, 'DnaJ homolog subfamily C member 12', NULL, NULL, NULL, NULL, NULL, 4),
(129249, NULL, 'G3DSA:2.130.10.10:FF:005023', NULL, NULL, 'Uncharacterized WD repeat-containing protein C343.17c', NULL, NULL, NULL, NULL, NULL, 4),
(129250, NULL, 'G3DSA:3.40.50.10810:FF:000142', NULL, NULL, 'RAD54B DNA helicase splice variant', NULL, NULL, NULL, NULL, NULL, 4),
(129251, NULL, 'G3DSA:1.20.1110.10:FF:000152', NULL, NULL, 'Putative proton motive ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(129252, NULL, 'G3DSA:2.70.98.10:FF:000012', NULL, NULL, 'Aldose 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(129253, NULL, 'G3DSA:1.10.260.40:FF:000039', NULL, NULL, 'LacI family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(129254, NULL, 'G3DSA:3.90.70.10:FF:000451', NULL, NULL, 'Calpain 10', NULL, NULL, NULL, NULL, NULL, 4),
(129255, NULL, 'G3DSA:1.25.10.10:FF:002226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129256, NULL, 'G3DSA:1.20.1070.10:FF:000440', NULL, NULL, 'NeuroPeptide Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(129257, NULL, 'G3DSA:3.30.70.1230:FF:000037', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(129258, NULL, 'G3DSA:1.20.5.170:FF:000297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129259, NULL, 'G3DSA:1.20.5.110:FF:000318', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129260, NULL, 'G3DSA:3.60.21.10:FF:000283', NULL, NULL, 'Debranching enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129261, NULL, 'G3DSA:4.10.400.10:FF:000194', NULL, NULL, 'Ecdysone-inducible gene E1', NULL, NULL, NULL, NULL, NULL, 4),
(129262, NULL, 'G3DSA:3.40.50.2300:FF:000299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129263, NULL, 'G3DSA:1.50.40.10:FF:000309', NULL, NULL, 'Mitochondrial glycine transporter', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(129264, NULL, 'G3DSA:1.10.10.60:FF:000577', NULL, NULL, 'Homeobox-leucine zipper protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(129265, NULL, 'G3DSA:1.10.10.10:FF:000135', NULL, NULL, 'forkhead box protein G1', NULL, NULL, NULL, NULL, NULL, 4),
(129266, NULL, 'G3DSA:3.30.70.100:FF:000169', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129267, NULL, 'G3DSA:3.30.1490.300:FF:000001', NULL, NULL, 'Type 4 fimbrial biogenesis protein PilM', NULL, NULL, NULL, NULL, NULL, 4),
(129268, NULL, 'G3DSA:2.60.40.10:FF:005843', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129269, NULL, 'G3DSA:2.30.29.30:FF:000271', NULL, NULL, 'pleckstrin homology domain-containing family M member 3', NULL, NULL, NULL, NULL, NULL, 4),
(129270, NULL, 'G3DSA:3.40.47.10:FF:000186', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 3', NULL, NULL, NULL, NULL, NULL, 4),
(129271, NULL, 'G3DSA:3.40.50.300:FF:003168', NULL, NULL, 'Putative RNA guanylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(129272, NULL, 'G3DSA:3.30.160.60:FF:002622', NULL, NULL, 'Zinc finger protein 1026', NULL, NULL, NULL, NULL, NULL, 4),
(129273, NULL, 'G3DSA:3.40.50.720:FF:001490', NULL, NULL, 'Uncharacterized cyclodeaminase', NULL, NULL, NULL, NULL, NULL, 4),
(129274, NULL, 'G3DSA:3.60.20.10:FF:000084', NULL, NULL, 'Class II glutamine amidotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(129275, NULL, 'G3DSA:2.60.34.10:FF:000096', NULL, NULL, 'ER-located HSP110/SSE-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(129276, NULL, 'G3DSA:2.70.98.30:FF:000018', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(129277, NULL, 'G3DSA:2.130.10.30:FF:000015', NULL, NULL, 'alsin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(129278, NULL, 'G3DSA:3.60.40.10:FF:000097', NULL, NULL, 'Blast:Protein phosphatase 1H', NULL, NULL, NULL, NULL, NULL, 4),
(129279, NULL, 'G3DSA:1.20.5.170:FF:000173', NULL, NULL, 'Slo1p', NULL, NULL, NULL, NULL, NULL, 4),
(129280, NULL, 'G3DSA:2.10.70.10:FF:000305', NULL, NULL, 'Complement factor B-like protease', NULL, NULL, NULL, NULL, NULL, 4),
(129281, NULL, 'G3DSA:2.130.10.10:FF:000133', NULL, NULL, 'Serine-threonine kinase receptor-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(129282, NULL, 'G3DSA:1.25.40.20:FF:001326', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129283, NULL, 'G3DSA:1.10.510.10:FF:000371', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(129284, NULL, 'G3DSA:3.30.230.70:FF:000023', NULL, NULL, 'exosome complex component MTR3', NULL, NULL, NULL, NULL, NULL, 4),
(129285, NULL, 'G3DSA:1.10.20.10:FF:000181', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129286, NULL, 'G3DSA:1.25.10.10:FF:001951', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(129287, NULL, 'G3DSA:3.40.50.620:FF:000509', NULL, NULL, 'Putative arginine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(129288, NULL, 'G3DSA:3.30.40.10:FF:002368', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(129289, NULL, 'G3DSA:2.40.50.140:FF:001174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129290, NULL, 'G3DSA:3.30.300.30:FF:000141', NULL, NULL, 'HC-toxin synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(129291, NULL, 'G3DSA:2.70.98.40:FF:000009', NULL, NULL, 'Glycoside hydrolase family 65 protein', NULL, NULL, NULL, NULL, NULL, 4),
(129292, NULL, 'G3DSA:1.10.150.60:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129293, NULL, 'G3DSA:2.130.10.10:FF:004298', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(129294, NULL, 'G3DSA:3.90.190.10:FF:000376', NULL, NULL, 'Protein-tyrosine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(129295, NULL, 'G3DSA:3.10.110.10:FF:000310', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129296, NULL, 'G3DSA:3.40.1800.20:FF:000004', NULL, NULL, 'Zinc finger protein 234-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(129297, NULL, 'G3DSA:1.10.238.10:FF:001069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(129298, NULL, 'G3DSA:3.40.50.2000:FF:000434', NULL, NULL, 'Alpha,alpha-trehalose-phosphate synthase [UDP-forming] A', NULL, NULL, NULL, NULL, NULL, 4),
(129299, NULL, 'G3DSA:2.120.10.30:FF:000212', NULL, NULL, 'low-density lipoprotein receptor-related protein 1B-like', NULL, NULL, NULL, NULL, NULL, 4),
(129300, NULL, 'G3DSA:2.40.50.140:FF:000774', NULL, NULL, 'Probable replication factor A 73 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(129301, NULL, 'G3DSA:1.25.40.10:FF:002054', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g15820 family', NULL, NULL, NULL, NULL, NULL, 4),
(129302, NULL, 'G3DSA:1.25.10.10:FF:000989', NULL, NULL, 'Protein CLASP-1', NULL, NULL, NULL, NULL, NULL, 4),
(129303, NULL, 'G3DSA:3.40.50.12780:FF:000148', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(129304, NULL, 'G3DSA:3.40.1110.10:FF:000151', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(129305, NULL, 'G3DSA:3.40.800.20:FF:000016', NULL, NULL, 'Histone deacetylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(129306, NULL, 'G3DSA:3.40.50.150:FF:001072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129307, NULL, 'G3DSA:3.40.50.300:FF:004697', NULL, NULL, 'Atlastin-1', NULL, NULL, NULL, NULL, NULL, 4),
(129308, NULL, 'G3DSA:2.130.10.10:FF:003786', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129309, NULL, 'G3DSA:1.25.40.10:FF:001542', NULL, NULL, 'Pentatricopeptide repeat protein PPR868-14', NULL, NULL, NULL, NULL, NULL, 4),
(129310, NULL, 'G3DSA:3.80.10.10:FF:004247', NULL, NULL, 'Protein CBG22476', NULL, NULL, NULL, NULL, NULL, 4),
(129311, NULL, 'G3DSA:3.80.10.10:FF:000195', NULL, NULL, 'Toll-like receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(129312, NULL, 'G3DSA:2.70.150.10:FF:000117', NULL, NULL, 'Probable cation-transporting P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(129313, NULL, 'G3DSA:2.60.40.10:FF:000043', NULL, NULL, 'roundabout homolog 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(129314, NULL, 'G3DSA:1.10.10.60:FF:000122', NULL, NULL, 'Zinc finger E-box binding homeobox 1', NULL, NULL, NULL, NULL, NULL, 4),
(129315, NULL, 'G3DSA:3.30.200.20:FF:001732', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129316, NULL, 'G3DSA:3.30.830.10:FF:000012', NULL, NULL, 'Protease 3', NULL, NULL, NULL, NULL, NULL, 4),
(129317, NULL, 'G3DSA:2.130.10.10:FF:004859', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129318, NULL, 'G3DSA:3.30.750.24:FF:000165', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129319, NULL, 'G3DSA:3.40.1190.20:FF:000159', NULL, NULL, 'Bud site selection protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129320, NULL, 'G3DSA:2.60.20.10:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129321, NULL, 'G3DSA:3.40.20.10:FF:000141', NULL, NULL, 'Gelsolin-related protein of 125 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(129322, NULL, 'G3DSA:3.30.70.270:FF:000299', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129323, NULL, 'G3DSA:1.20.1070.10:FF:000889', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(129324, NULL, 'G3DSA:3.90.280.10:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129325, NULL, 'G3DSA:2.130.10.10:FF:003567', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129326, NULL, 'G3DSA:3.30.160.60:FF:005601', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129327, NULL, 'G3DSA:2.130.10.10:FF:000588', NULL, NULL, 'WD repeat and SOCS box-containing 1, isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(129328, NULL, 'G3DSA:2.30.230.10:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129329, NULL, 'G3DSA:2.170.150.20:FF:000012', NULL, NULL, 'Peptide methionine sulfoxide reductase MsrB', NULL, NULL, NULL, NULL, NULL, 4),
(129330, NULL, 'G3DSA:1.10.287.110:FF:000381', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129331, NULL, 'G3DSA:2.10.250.10:FF:000015', NULL, NULL, 'Calreticulin family protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(129332, NULL, 'G3DSA:3.30.160.60:FF:004983', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129333, NULL, 'G3DSA:3.40.630.30:FF:000298', NULL, NULL, 'Acetyltransferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(129334, NULL, 'G3DSA:4.10.280.10:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129335, NULL, 'G3DSA:3.40.850.10:FF:000415', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129336, NULL, 'G3DSA:3.10.20.90:FF:000267', NULL, NULL, 'Blast:Serine/threonine-protein kinase TBK1', NULL, NULL, NULL, NULL, NULL, 4),
(129337, NULL, 'G3DSA:3.80.10.10:FF:002229', NULL, NULL, 'F-box and leucine rich repeat protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(129338, NULL, 'G3DSA:1.20.1560.10:FF:000292', NULL, NULL, 'p-GlycoProtein related', NULL, NULL, NULL, NULL, NULL, 4),
(129339, NULL, 'G3DSA:3.30.70.260:FF:000172', NULL, NULL, 'Aspartate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(129340, NULL, 'G3DSA:3.40.50.300:FF:000987', NULL, NULL, 'DEAD/DEAH box RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(129341, NULL, 'G3DSA:3.40.50.200:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129342, NULL, 'G3DSA:3.40.50.12500:FF:000003', NULL, NULL, 'Hydantoin racemase (Dcg1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(129343, NULL, 'G3DSA:1.10.3380.10:FF:000056', NULL, NULL, 'Putative U5 small nuclear ribonucleoprotein 200 kDa helicase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(129344, NULL, 'G3DSA:1.10.10.720:FF:000001', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(129345, NULL, 'G3DSA:1.10.10.10:FF:001877', NULL, NULL, 'Integrating conjugative element relaxase, PFGI-1 class', NULL, NULL, NULL, NULL, NULL, 4),
(129346, NULL, 'G3DSA:1.10.8.60:FF:000486', NULL, NULL, 'Peroxisomal biogenesis factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(129347, NULL, 'G3DSA:3.30.1490.190:FF:000029', NULL, NULL, 'Ferric uptake regulator, Fur family', NULL, NULL, NULL, NULL, NULL, 4),
(129348, NULL, 'G3DSA:1.10.287.130:FF:000263', NULL, NULL, 'Sensor histidine kinase, copper metabolism, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129349, NULL, 'G3DSA:1.10.287.70:FF:000407', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129350, NULL, 'G3DSA:3.40.50.300:FF:001824', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(129351, NULL, 'G3DSA:1.10.3060.10:FF:000003', NULL, NULL, 'Protein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(129352, NULL, 'G3DSA:2.30.29.30:FF:000956', NULL, NULL, 'Exocyst complex component 8', NULL, NULL, NULL, NULL, NULL, 4),
(129353, NULL, 'G3DSA:3.90.480.20:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129354, NULL, 'G3DSA:3.40.50.300:FF:008171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129355, NULL, 'G3DSA:1.10.630.10:FF:000424', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129356, NULL, 'G3DSA:2.70.50.40:FF:000001', NULL, NULL, 'protein unc-119 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(129357, NULL, 'G3DSA:3.30.70.100:FF:000057', NULL, NULL, 'Diguanylate cyclase/phosphodiesterase domain 2 (EAL)', NULL, NULL, NULL, NULL, NULL, 4),
(129358, NULL, 'G3DSA:3.30.559.10:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129359, NULL, 'G3DSA:1.10.150.20:FF:000059', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(129360, NULL, 'G3DSA:2.60.40.790:FF:000018', NULL, NULL, 'Heat shock protein Hsp20', NULL, NULL, NULL, NULL, NULL, 4),
(129361, NULL, 'G3DSA:1.20.1070.10:FF:002126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129362, NULL, 'G3DSA:1.10.132.20:FF:000006', NULL, NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(129363, NULL, 'G3DSA:2.130.10.10:FF:004404', NULL, NULL, 'Pleiotropic regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(129364, NULL, 'G3DSA:2.60.40.10:FF:003819', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(129365, NULL, 'G3DSA:3.40.50.720:FF:001501', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(129366, NULL, 'G3DSA:2.60.120.740:FF:000018', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(129367, NULL, 'G3DSA:1.10.10.60:FF:001291', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129368, NULL, 'G3DSA:1.25.40.120:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129369, NULL, 'G3DSA:1.25.40.720:FF:000019', NULL, NULL, 'Liquid facets-Related, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(129370, NULL, 'G3DSA:1.10.1040.10:FF:000092', NULL, NULL, '2-dehydropantoate 2-reductase family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129371, NULL, 'G3DSA:3.30.420.110:FF:000044', NULL, NULL, 'MSH (MutS Homolog) family', NULL, NULL, NULL, NULL, NULL, 4),
(129372, NULL, 'G3DSA:3.20.20.370:FF:000012', NULL, NULL, 'YdjC chitooligosaccharide deacetylase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(129373, NULL, 'G3DSA:1.20.200.10:FF:000002', NULL, NULL, 'Argininosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(129374, NULL, 'G3DSA:3.30.450.20:FF:000486', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(129375, NULL, 'G3DSA:3.40.50.11530:FF:000015', NULL, NULL, 'Interleukin 17 receptor A1b', NULL, NULL, NULL, NULL, NULL, 4),
(129376, NULL, 'G3DSA:1.10.225.10:FF:000022', NULL, NULL, 'Saposin-related', NULL, NULL, NULL, NULL, NULL, 4),
(129377, NULL, 'G3DSA:3.40.50.720:FF:001158', NULL, NULL, 'ThiF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(129378, NULL, 'G3DSA:3.30.450.260:FF:000005', NULL, NULL, 'Soluble guanylate cyclase 89Da', NULL, NULL, NULL, NULL, NULL, 4),
(129379, NULL, 'G3DSA:1.10.510.10:FF:004423', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129380, NULL, 'G3DSA:2.20.70.10:FF:000097', NULL, NULL, 'Dystrophin-1', NULL, NULL, NULL, NULL, NULL, 4),
(129381, NULL, 'G3DSA:1.25.40.10:FF:001104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129382, NULL, 'G3DSA:3.30.160.60:FF:000930', NULL, NULL, 'Zinc finger protein 335', NULL, NULL, NULL, NULL, NULL, 4),
(129383, NULL, 'G3DSA:3.30.710.10:FF:000413', NULL, NULL, 'Potassium voltage-gated channel, shaker-related subfamily, member 7', NULL, NULL, NULL, NULL, NULL, 4),
(129384, NULL, 'G3DSA:3.20.20.70:FF:000412', NULL, NULL, '1-(5-phosphoribosyl)-5-[(5-phosphoribosylamino)methylideneamino] imidazole-4-carboxamide isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(129385, NULL, 'G3DSA:2.60.40.10:FF:003134', NULL, NULL, 'Solute carrier family 35 member C2', NULL, NULL, NULL, NULL, NULL, 4),
(129386, NULL, 'G3DSA:2.60.200.40:FF:000049', NULL, NULL, 'Diacylglycerol kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129387, NULL, 'G3DSA:3.40.970.10:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129388, NULL, 'G3DSA:3.90.640.10:FF:000231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129389, NULL, 'G3DSA:3.40.50.1440:FF:000125', NULL, NULL, 'Tubulin alpha-8 chain', NULL, NULL, NULL, NULL, NULL, 4),
(129390, NULL, 'G3DSA:3.30.200.20:FF:000771', NULL, NULL, 'AGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(129391, NULL, 'G3DSA:2.60.40.10:FF:002858', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129392, NULL, 'G3DSA:1.20.1050.10:FF:000219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129393, NULL, 'G3DSA:3.40.710.10:FF:000017', NULL, NULL, 'Stage V sporulation protein D', NULL, NULL, NULL, NULL, NULL, 4),
(129394, NULL, 'G3DSA:1.10.287.2620:FF:000016', NULL, NULL, 'dynein heavy chain 6, axonemal isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(129395, NULL, 'G3DSA:2.130.10.10:FF:001549', NULL, NULL, 'NACHT and WD repeat domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(129396, NULL, 'G3DSA:1.10.630.10:FF:000548', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129397, NULL, 'G3DSA:2.130.10.10:FF:003443', NULL, NULL, 'Intraflagellar transport protein osm-1', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(129398, NULL, 'G3DSA:3.10.20.90:FF:000722', NULL, NULL, 'Fimbrin', NULL, NULL, NULL, NULL, NULL, 4),
(129399, NULL, 'G3DSA:1.25.10.10:FF:000315', NULL, NULL, 'Sister chromatid cohesion protein', NULL, NULL, NULL, NULL, NULL, 4),
(129400, NULL, 'G3DSA:1.10.238.10:FF:000119', NULL, NULL, 'TBC1 domain family member 9', NULL, NULL, NULL, NULL, NULL, 4),
(129401, NULL, 'G3DSA:1.50.10.20:FF:000018', NULL, NULL, 'Geranylgeranyl transferase type-2 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(129402, NULL, 'G3DSA:3.90.420.10:FF:000012', NULL, NULL, 'Sulfite dehydrogenase molybdopterin-binding subunit SorA', NULL, NULL, NULL, NULL, NULL, 4),
(129403, NULL, 'G3DSA:3.80.10.10:FF:000431', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(129404, NULL, 'G3DSA:2.60.120.290:FF:000187', NULL, NULL, 'AGAP005526-PA', NULL, NULL, NULL, NULL, NULL, 4),
(129405, NULL, 'G3DSA:1.10.3430.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129406, NULL, 'G3DSA:3.30.230.10:FF:000264', NULL, NULL, 'Ribonuclease P protein component', NULL, NULL, NULL, NULL, NULL, 4),
(129407, NULL, 'G3DSA:1.10.510.10:FF:000152', NULL, NULL, 'kalirin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(129408, NULL, 'G3DSA:3.40.50.300:FF:001948', NULL, NULL, 'ATP-dependent RNA helicase DBP5', NULL, NULL, NULL, NULL, NULL, 4),
(129409, NULL, 'G3DSA:3.30.470.20:FF:000251', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(129410, NULL, 'G3DSA:3.40.50.12670:FF:000008', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(129411, NULL, 'G3DSA:3.20.20.140:FF:000398', NULL, NULL, 'Chlorohydrolase, conjectural', NULL, NULL, NULL, NULL, NULL, 4),
(129412, NULL, 'G3DSA:1.20.920.20:FF:000026', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(129413, NULL, 'G3DSA:1.20.120.640:FF:000004', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129414, NULL, 'G3DSA:3.30.160.60:FF:003926', NULL, NULL, 'transcription factor Ouib', NULL, NULL, NULL, NULL, NULL, 4),
(129415, NULL, 'G3DSA:3.40.50.11980:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129416, NULL, 'G3DSA:1.20.120.350:FF:000018', NULL, NULL, 'Potassium voltage-gated channel subfamily B member', NULL, NULL, NULL, NULL, NULL, 4),
(129417, NULL, 'G3DSA:3.30.1920.10:FF:000001', NULL, NULL, 'Mu phage baseplate assembly protein GpP', NULL, NULL, NULL, NULL, NULL, 4),
(129418, NULL, 'G3DSA:1.10.8.10:FF:000044', NULL, NULL, 'UBX domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(129419, NULL, 'G3DSA:2.60.40.10:FF:005264', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129420, NULL, 'G3DSA:2.60.200.20:FF:000043', NULL, NULL, 'FHA domain containing protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(129421, NULL, 'G3DSA:3.40.390.10:FF:000155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129422, NULL, 'G3DSA:3.30.70.330:FF:001525', NULL, NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(129423, NULL, 'G3DSA:3.30.2130.10:FF:000003', NULL, NULL, 'Cytosolic arginine sensor for mTORC1 subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(129424, NULL, 'G3DSA:3.40.50.720:FF:002119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129425, NULL, 'G3DSA:1.10.10.10:FF:001192', NULL, NULL, 'Forkhead box protein F1', NULL, NULL, NULL, NULL, NULL, 4),
(129426, NULL, 'G3DSA:1.20.58.60:FF:000484', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(129427, NULL, 'G3DSA:2.40.50.40:FF:000036', NULL, NULL, 'Interleukin-8', NULL, NULL, NULL, NULL, NULL, 4),
(129428, NULL, 'G3DSA:2.115.10.20:FF:000008', NULL, NULL, 'Extracellular endo-inulinase', NULL, NULL, NULL, NULL, NULL, 4),
(129429, NULL, 'G3DSA:1.20.1070.10:FF:001507', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129430, NULL, 'G3DSA:3.40.50.300:FF:003842', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(129431, NULL, 'G3DSA:1.20.58.200:FF:000002', NULL, NULL, 'Putative translin', NULL, NULL, NULL, NULL, NULL, 4),
(129432, NULL, 'G3DSA:1.20.120.1750:FF:000102', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(129433, NULL, 'G3DSA:3.40.50.620:FF:000841', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129434, NULL, 'G3DSA:3.40.50.880:FF:000104', NULL, NULL, 'Catalase', NULL, NULL, NULL, NULL, NULL, 4),
(129435, NULL, 'G3DSA:3.40.50.10190:FF:000355', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129436, NULL, 'G3DSA:3.20.20.150:FF:000058', NULL, NULL, 'Protein arginine N-methyltransferase 5', NULL, NULL, NULL, NULL, NULL, 4),
(129437, NULL, 'G3DSA:1.10.10.10:FF:001534', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129438, NULL, 'G3DSA:1.10.3080.10:FF:000016', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(129439, NULL, 'G3DSA:2.30.30.100:FF:000058', NULL, NULL, 'Small nuclear ribonucleoprotein Sm D3', NULL, NULL, NULL, NULL, NULL, 4),
(129440, NULL, 'G3DSA:1.25.40.10:FF:002958', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129441, NULL, 'G3DSA:2.30.30.40:FF:000013', NULL, NULL, 'Alkylphosphonate utilization protein PhnA', NULL, NULL, NULL, NULL, NULL, 4),
(129442, NULL, 'G3DSA:2.60.40.10:FF:002173', NULL, NULL, 'TRADV8 protein', NULL, NULL, NULL, NULL, NULL, 4),
(129443, NULL, 'G3DSA:3.40.30.10:FF:000327', NULL, NULL, 'C-type cytochrome biogenesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(129444, NULL, 'G3DSA:3.40.720.10:FF:000193', NULL, NULL, 'Putative ethanolamine phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(129445, NULL, 'G3DSA:3.40.50.720:FF:002451', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129446, NULL, 'G3DSA:3.30.70.330:FF:001183', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(129447, NULL, 'G3DSA:3.40.630.30:FF:000410', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129448, NULL, 'G3DSA:1.10.437.10:FF:000014', NULL, NULL, 'Bcl-2-like protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(129449, NULL, 'G3DSA:1.10.8.1220:FF:000005', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129450, NULL, 'G3DSA:3.40.190.10:FF:000499', NULL, NULL, 'GM24642', NULL, NULL, NULL, NULL, NULL, 4),
(129451, NULL, 'G3DSA:1.10.287.370:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129452, NULL, 'G3DSA:3.90.650.10:FF:000057', NULL, NULL, 'Selenide, water dikinase', NULL, NULL, NULL, NULL, NULL, 4),
(129453, NULL, 'G3DSA:1.25.40.10:FF:000828', NULL, NULL, 'Pentatricopeptide repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(129454, NULL, 'G3DSA:2.60.40.1150:FF:000006', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(129455, NULL, 'G3DSA:1.25.40.10:FF:003234', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g15720', NULL, NULL, NULL, NULL, NULL, 4),
(129456, NULL, 'G3DSA:1.20.120.790:FF:000021', NULL, NULL, 'Chaperone protein HtpG', NULL, NULL, NULL, NULL, NULL, 4),
(129457, NULL, 'G3DSA:3.20.20.70:FF:000070', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(129458, NULL, 'G3DSA:3.40.718.10:FF:000029', NULL, NULL, 'Isocitrate dehydrogenase [NAD] subunit alpha, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(129459, NULL, 'G3DSA:2.40.50.140:FF:001050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129460, NULL, 'G3DSA:3.40.1170.60:FF:000023', NULL, NULL, 'DNA repair protein REV1', NULL, NULL, NULL, NULL, NULL, 4),
(129461, NULL, 'G3DSA:1.10.510.10:FF:002282', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129462, NULL, 'G3DSA:2.60.40.10:FF:001897', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129463, NULL, 'G3DSA:4.10.410.10:FF:000037', NULL, NULL, 'Protein CBR-MLT-11', NULL, NULL, NULL, NULL, NULL, 4),
(129464, NULL, 'G3DSA:3.90.1200.10:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(129465, NULL, 'G3DSA:3.30.1120.30:FF:000042', NULL, NULL, 'Serine/threonine-protein kinase plk-3', NULL, NULL, NULL, NULL, NULL, 4),
(129466, NULL, 'G3DSA:1.20.140.40:FF:000051', NULL, NULL, 'Probable pectinesterase/pectinesterase inhibitor 40', NULL, NULL, NULL, NULL, NULL, 4),
(129467, NULL, 'G3DSA:1.20.810.10:FF:000032', NULL, NULL, 'Cytochrome b6-f complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(129468, NULL, 'G3DSA:1.10.533.10:FF:000064', NULL, NULL, 'NLR family pyrin domain containing 12', NULL, NULL, NULL, NULL, NULL, 4),
(129469, NULL, 'G3DSA:2.40.10.10:FF:000497', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129470, NULL, 'G3DSA:2.40.30.10:FF:000262', NULL, NULL, 'tRNA-specific 2-thiouridylase MnmA', NULL, NULL, NULL, NULL, NULL, 4),
(129471, NULL, 'G3DSA:1.10.472.10:FF:000495', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129472, NULL, 'G3DSA:2.60.120.920:FF:000207', NULL, NULL, 'E3 ubiquitin-protein ligase NEURL1B-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(129473, NULL, 'G3DSA:3.40.50.150:FF:001633', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129474, NULL, 'G3DSA:3.40.50.300:FF:005877', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129475, NULL, 'G3DSA:1.20.5.190:FF:000179', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129476, NULL, 'G3DSA:3.30.420.40:FF:000978', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129477, NULL, 'G3DSA:3.40.850.10:FF:000179', NULL, NULL, 'KIF27 isoform 6', NULL, NULL, NULL, NULL, NULL, 4),
(129478, NULL, 'G3DSA:1.10.600.10:FF:000035', NULL, NULL, 'Ent-copalyl diphosphate synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(129479, NULL, 'G3DSA:3.80.10.10:FF:003865', NULL, NULL, 'Glucose-repressible alcohol dehydrogenase transcriptional effector', NULL, NULL, NULL, NULL, NULL, 4),
(129480, NULL, 'G3DSA:3.40.50.720:FF:002338', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129481, NULL, 'G3DSA:1.25.10.10:FF:003406', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129482, NULL, 'G3DSA:3.30.40.10:FF:001750', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129483, NULL, 'G3DSA:3.40.120.10:FF:000113', NULL, NULL, 'Phosphoglucosamine mutase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(129484, NULL, 'G3DSA:1.10.238.10:FF:000451', NULL, NULL, 'Blast:Pyrazinamidase/nicotinamidase', NULL, NULL, NULL, NULL, NULL, 4),
(129485, NULL, 'G3DSA:3.30.450.210:FF:000001', NULL, NULL, 'Sensor histidine kinase CpxA', NULL, NULL, NULL, NULL, NULL, 4),
(129486, NULL, 'G3DSA:2.40.50.690:FF:000023', NULL, NULL, 'Exoribonuclease II', NULL, NULL, NULL, NULL, NULL, 4),
(129487, NULL, 'G3DSA:3.20.20.60:FF:000078', NULL, NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(129488, NULL, 'G3DSA:4.10.280.110:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129489, NULL, 'G3DSA:3.40.50.1820:FF:000711', NULL, NULL, 'Lipase', NULL, NULL, NULL, NULL, NULL, 4),
(129490, NULL, 'G3DSA:1.20.5.690:FF:000003', NULL, NULL, 'Importin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(129491, NULL, 'G3DSA:3.80.10.10:FF:004141', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129492, NULL, 'G3DSA:2.60.40.420:FF:000273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129493, NULL, 'G3DSA:3.40.50.1010:FF:000114', NULL, NULL, 'rRNA-processing protein FCF1', NULL, NULL, NULL, NULL, NULL, 4),
(129494, NULL, 'G3DSA:3.30.260.10:FF:000092', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129495, NULL, 'G3DSA:2.60.40.10:FF:005949', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129496, NULL, 'G3DSA:1.25.40.10:FF:003919', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129497, NULL, 'G3DSA:2.60.40.60:FF:000142', NULL, NULL, 'Cadherin 23', NULL, NULL, NULL, NULL, NULL, 4),
(129498, NULL, 'G3DSA:2.60.40.10:FF:001554', NULL, NULL, 'B-cell antigen receptor complex-associated protein beta chain', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(129499, NULL, 'G3DSA:3.10.650.10:FF:000002', NULL, NULL, 'Binding-protein-dependent transport systems inner membrane component', NULL, NULL, NULL, NULL, NULL, 4),
(129500, NULL, 'G3DSA:2.30.30.490:FF:000017', NULL, NULL, 'Bromo-adjacent homology (BAH) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(129501, NULL, 'G3DSA:3.90.79.10:FF:000100', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(129502, NULL, 'G3DSA:1.20.272.10:FF:000005', NULL, NULL, 'Replication factor C subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(129503, NULL, 'G3DSA:2.30.180.10:FF:000033', NULL, NULL, 'Stabilin 1', NULL, NULL, NULL, NULL, NULL, 4),
(129504, NULL, 'G3DSA:3.30.450.20:FF:000249', NULL, NULL, 'Serine phosphatase RsbU (Regulator of sigma subunit)', NULL, NULL, NULL, NULL, NULL, 4),
(129505, NULL, 'G3DSA:3.90.199.10:FF:000007', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(129506, NULL, 'G3DSA:1.10.640.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129507, NULL, 'G3DSA:1.10.10.10:FF:001771', NULL, NULL, 'ORC1-type DNA replication protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(129508, NULL, 'G3DSA:1.20.1070.10:FF:000546', NULL, NULL, 'DOPamine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(129509, NULL, 'G3DSA:3.30.930.10:FF:000177', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(129510, NULL, 'G3DSA:3.30.420.40:FF:000074', NULL, NULL, 'Heat shock protein family A (Hsp70) member 12A', NULL, NULL, NULL, NULL, NULL, 4),
(129511, NULL, 'G3DSA:3.20.20.100:FF:000072', NULL, NULL, 'Aldose reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129512, NULL, 'G3DSA:1.10.510.10:FF:003243', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129513, NULL, 'G3DSA:3.40.50.300:FF:006838', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129514, NULL, 'G3DSA:2.30.42.10:FF:000245', NULL, NULL, 'Sip1', NULL, NULL, NULL, NULL, NULL, 4),
(129515, NULL, 'G3DSA:3.40.1090.10:FF:000103', NULL, NULL, 'Patatin', NULL, NULL, NULL, NULL, NULL, 4),
(129516, NULL, 'G3DSA:3.30.70.3340:FF:000001', NULL, NULL, 'Sulfite reductase, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(129517, NULL, 'G3DSA:3.30.420.140:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129518, NULL, 'G3DSA:3.40.50.1000:FF:000235', NULL, NULL, 'Haloacid dehalogenase-like hydrolase (HAD) superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(129519, NULL, 'G3DSA:3.60.21.10:FF:000406', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(129520, NULL, 'G3DSA:1.10.238.10:FF:000232', NULL, NULL, 'Centrin-2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129521, NULL, 'G3DSA:1.25.10.10:FF:002569', NULL, NULL, 'Sister chromatid cohesion protein', NULL, NULL, NULL, NULL, NULL, 4),
(129522, NULL, 'G3DSA:3.40.50.1820:FF:000930', NULL, NULL, 'Os11g0431700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(129523, NULL, 'G3DSA:1.50.40.10:FF:000528', NULL, NULL, 'Solute carrier family 25 (mitochondrial carrier; phosphate carrier), member 24, like', NULL, NULL, NULL, NULL, NULL, 4),
(129524, NULL, 'G3DSA:1.25.40.20:FF:000022', NULL, NULL, 'protein TANC2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(129525, NULL, 'G3DSA:2.170.270.10:FF:000063', NULL, NULL, 'SET domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129526, NULL, 'G3DSA:3.10.20.90:FF:000161', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(129527, NULL, 'G3DSA:3.30.1540.20:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129528, NULL, 'G3DSA:3.30.420.10:FF:000531', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129529, NULL, 'G3DSA:1.10.405.20:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129530, NULL, 'G3DSA:2.60.120.10:FF:000449', NULL, NULL, 'Phosphomannose isomerase type I', NULL, NULL, NULL, NULL, NULL, 4),
(129531, NULL, 'G3DSA:3.10.20.230:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(129532, NULL, 'G3DSA:2.60.120.340:FF:000005', NULL, NULL, 'nucleoplasmin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(129533, NULL, 'G3DSA:3.40.50.300:FF:003404', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(129534, NULL, 'G3DSA:1.10.357.140:FF:000013', NULL, NULL, 'Protoheme IX farnesyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(129535, NULL, 'G3DSA:3.90.70.10:FF:000232', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129536, NULL, 'G3DSA:2.60.40.10:FF:004988', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129537, NULL, 'G3DSA:3.30.70.330:FF:002705', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129538, NULL, 'G3DSA:2.60.40.10:FF:002515', NULL, NULL, 'Alpha-amylase', NULL, NULL, NULL, NULL, NULL, 4),
(129539, NULL, 'G3DSA:3.30.505.10:FF:000228', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129540, NULL, 'G3DSA:3.20.20.80:FF:000292', NULL, NULL, 'Lactase-like a', NULL, NULL, NULL, NULL, NULL, 4),
(129541, NULL, 'G3DSA:3.20.20.70:FF:000755', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129542, NULL, 'G3DSA:1.10.510.10:FF:003462', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129543, NULL, 'G3DSA:2.60.40.10:FF:005388', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129544, NULL, 'G3DSA:3.30.160.60:FF:003128', NULL, NULL, 'zinc finger protein 213-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(129545, NULL, 'G3DSA:2.60.120.650:FF:000093', NULL, NULL, 'Uncharacterized protein AT4g21430', NULL, NULL, NULL, NULL, NULL, 4),
(129546, NULL, 'G3DSA:1.25.40.10:FF:000143', NULL, NULL, 'E3 ubiquitin-protein ligase TTC3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(129547, NULL, 'G3DSA:3.40.50.300:FF:005079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129548, NULL, 'G3DSA:3.90.1410.10:FF:000117', NULL, NULL, 'SET domain-containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(129549, NULL, 'G3DSA:3.40.605.10:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129550, NULL, 'G3DSA:3.30.499.10:FF:000016', NULL, NULL, 'Homoaconitase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(129551, NULL, 'G3DSA:3.40.50.10190:FF:000012', NULL, NULL, 'X-ray repair cross complementing 1', NULL, NULL, NULL, NULL, NULL, 4),
(129552, NULL, 'G3DSA:3.30.760.10:FF:000017', NULL, NULL, 'Eukaryotic translation initiation factor 4E-1', NULL, NULL, NULL, NULL, NULL, 4),
(129553, NULL, 'G3DSA:3.60.10.10:FF:000269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129554, NULL, 'G3DSA:3.30.1780.10:FF:000012', NULL, NULL, 'Ketimine reductase mu-crystallin', NULL, NULL, NULL, NULL, NULL, 4),
(129555, NULL, 'G3DSA:3.90.550.50:FF:000112', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(129556, NULL, 'G3DSA:1.10.3260.10:FF:000002', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(129557, NULL, 'G3DSA:3.40.30.10:FF:000080', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(129558, NULL, 'G3DSA:1.25.40.10:FF:003577', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 15', NULL, NULL, NULL, NULL, NULL, 4),
(129559, NULL, 'G3DSA:3.40.50.10480:FF:000009', NULL, NULL, 'Ribosome biogenesis protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129560, NULL, 'G3DSA:3.40.630.30:FF:000192', NULL, NULL, 'Putative N-acetyltransferase C9.02c', NULL, NULL, NULL, NULL, NULL, 4),
(129561, NULL, 'G3DSA:2.10.110.10:FF:000185', NULL, NULL, 'Homeobox protein ceh-14', NULL, NULL, NULL, NULL, NULL, 4),
(129562, NULL, 'G3DSA:3.40.50.1820:FF:000037', NULL, NULL, 'Lysosomal thioesterase PPT2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(129563, NULL, 'G3DSA:3.30.40.10:FF:000238', NULL, NULL, 'PHD finger family protein', NULL, NULL, NULL, NULL, NULL, 4),
(129564, NULL, 'G3DSA:1.25.40.10:FF:004870', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g39710', NULL, NULL, NULL, NULL, NULL, 4),
(129565, NULL, 'G3DSA:3.30.450.90:FF:000012', NULL, NULL, 'P-type conjugative transfer ATPase TrbB', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(129566, NULL, 'G3DSA:2.40.20.10:FF:000104', NULL, NULL, 'Putative macrophage stimulating 1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(129567, NULL, 'G3DSA:3.40.50.1820:FF:001330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129568, NULL, 'G3DSA:2.130.10.10:FF:002263', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(129569, NULL, 'G3DSA:3.30.420.40:FF:001035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129570, NULL, 'G3DSA:1.10.1410.10:FF:000031', NULL, NULL, 'Poly(A) polymerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129571, NULL, 'G3DSA:3.40.50.620:FF:000622', NULL, NULL, 'Transport protein (Probable substrate cationic amino acids)', NULL, NULL, NULL, NULL, NULL, 4),
(129572, NULL, 'G3DSA:3.30.470.20:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129573, NULL, 'G3DSA:3.30.60.20:FF:000006', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(129574, NULL, 'G3DSA:1.10.4160.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129575, NULL, 'G3DSA:3.40.30.10:FF:000580', NULL, NULL, 'Thiol:disulfide interchange protein DsbD', NULL, NULL, NULL, NULL, NULL, 4),
(129576, NULL, 'G3DSA:3.20.20.140:FF:000342', NULL, NULL, 'Resiniferatoxin-binding, phosphotriesterase-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(129577, NULL, 'G3DSA:2.30.30.140:FF:000334', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129578, NULL, 'G3DSA:3.60.40.10:FF:000063', NULL, NULL, 'Probable protein phosphatase 2C 12', NULL, NULL, NULL, NULL, NULL, 4),
(129579, NULL, 'G3DSA:2.60.40.10:FF:003741', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129580, NULL, 'G3DSA:1.10.630.10:FF:000138', NULL, NULL, 'Os10g0167200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(129581, NULL, 'G3DSA:2.60.120.260:FF:000296', NULL, NULL, 'Coagulation factor V', NULL, NULL, NULL, NULL, NULL, 4),
(129582, NULL, 'G3DSA:2.130.10.10:FF:003752', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129583, NULL, 'G3DSA:1.10.287.70:FF:000661', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129584, NULL, 'G3DSA:3.10.400.20:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129585, NULL, 'G3DSA:3.40.309.10:FF:000057', NULL, NULL, 'ALdehyde deHydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(129586, NULL, 'G3DSA:3.80.10.10:FF:002196', NULL, NULL, 'Toll-like receptor 5b', NULL, NULL, NULL, NULL, NULL, 4),
(129587, NULL, 'G3DSA:3.30.160.60:FF:006450', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129588, NULL, 'G3DSA:1.20.1070.10:FF:000934', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129589, NULL, 'G3DSA:1.20.58.60:FF:000815', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129590, NULL, 'G3DSA:2.60.120.10:FF:000348', NULL, NULL, 'Nucleotide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(129591, NULL, 'G3DSA:1.10.3450.40:FF:000003', NULL, NULL, 'Signal recognition particle subunit SRP68,putative', NULL, NULL, NULL, NULL, NULL, 4),
(129592, NULL, 'G3DSA:1.10.3080.10:FF:000033', NULL, NULL, 'Chloride channel, voltage-sensitive 1', NULL, NULL, NULL, NULL, NULL, 4),
(129593, NULL, 'G3DSA:3.40.50.2300:FF:001007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129594, NULL, 'G3DSA:1.10.150.50:FF:000107', NULL, NULL, 'MAPKKK cascade protein kinase regulator Ste50 (AFU_orthologue AFUA_2G17130)', NULL, NULL, NULL, NULL, NULL, 4),
(129595, NULL, 'G3DSA:3.40.50.620:FF:000858', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129596, NULL, 'G3DSA:3.40.1170.60:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129597, NULL, 'G3DSA:3.40.50.10190:FF:000225', NULL, NULL, 'AGAP003213-PA', NULL, NULL, NULL, NULL, NULL, 4),
(129598, NULL, 'G3DSA:1.10.238.10:FF:001047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(129599, NULL, 'G3DSA:2.40.40.20:FF:000035', NULL, NULL, 'DMSO reductase', NULL, NULL, NULL, NULL, NULL, 4),
(129600, NULL, 'G3DSA:1.10.510.10:FF:003743', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129601, NULL, 'G3DSA:1.25.40.10:FF:003487', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At1g13800', NULL, NULL, NULL, NULL, NULL, 4),
(129602, NULL, 'G3DSA:1.20.1280.50:FF:000113', NULL, NULL, 'F-box domain containing protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(129603, NULL, 'G3DSA:1.10.260.40:FF:000079', NULL, NULL, 'Virulence-associated protein I', NULL, NULL, NULL, NULL, NULL, 4),
(129604, NULL, 'G3DSA:2.40.160.20:FF:000021', NULL, NULL, 'Lipid A deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(129605, NULL, 'G3DSA:2.40.50.140:FF:001252', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129606, NULL, 'G3DSA:1.10.510.10:FF:003097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129607, NULL, 'G3DSA:3.50.50.60:FF:000197', NULL, NULL, 'Polyamine oxidase FMS1', NULL, NULL, NULL, NULL, NULL, 4),
(129608, NULL, 'G3DSA:3.30.160.60:FF:003218', NULL, NULL, 'Serendipity locus protein delta', NULL, NULL, NULL, NULL, NULL, 4),
(129609, NULL, 'G3DSA:3.30.70.1560:FF:000006', NULL, NULL, 'RNA pseudouridylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(129610, NULL, 'G3DSA:3.40.50.12780:FF:000143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129611, NULL, 'G3DSA:3.40.50.10490:FF:000164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129612, NULL, 'G3DSA:2.110.10.10:FF:000010', NULL, NULL, 'vitronectin', NULL, NULL, NULL, NULL, NULL, 4),
(129613, NULL, 'G3DSA:2.60.40.1730:FF:000006', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(129614, NULL, 'G3DSA:1.20.1070.10:FF:000288', NULL, NULL, 'Muscarinic acetylcholine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(129615, NULL, 'G3DSA:3.40.50.200:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129616, NULL, 'G3DSA:3.40.50.2000:FF:000518', NULL, NULL, 'Processive diacylglycerol beta-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(129617, NULL, 'G3DSA:4.10.170.10:FF:000006', NULL, NULL, 'Serine/threonine kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(129618, NULL, 'G3DSA:3.40.720.10:FF:000355', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129619, NULL, 'G3DSA:3.50.50.60:FF:000876', NULL, NULL, 'FAD-dependent oxidoreductase domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(129620, NULL, 'G3DSA:2.60.20.10:FF:000013', NULL, NULL, 'Crystallin beta-gamma domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(129621, NULL, 'G3DSA:3.40.50.300:FF:007322', NULL, NULL, 'Putative DNA mismatch repair ATPase Msh3', NULL, NULL, NULL, NULL, NULL, 4),
(129622, NULL, 'G3DSA:2.60.210.10:FF:000001', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(129623, NULL, 'G3DSA:3.30.70.330:FF:002020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129624, NULL, 'G3DSA:1.20.58.400:FF:000040', NULL, NULL, 'Vesicle transport through interaction with t-SNAREs 1B', NULL, NULL, NULL, NULL, NULL, 4),
(129625, NULL, 'G3DSA:3.40.50.720:FF:001052', NULL, NULL, 'Glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(129626, NULL, 'G3DSA:1.10.1450.10:FF:000140', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(129627, NULL, 'G3DSA:1.10.560.10:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129628, NULL, 'G3DSA:1.25.40.20:FF:001399', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129629, NULL, 'G3DSA:2.60.40.10:FF:005865', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129630, NULL, 'G3DSA:2.130.10.10:FF:005517', NULL, NULL, 'Protein CBR-ELPC-2', NULL, NULL, NULL, NULL, NULL, 4),
(129631, NULL, 'G3DSA:3.40.50.720:FF:002187', NULL, NULL, 'Os05g0595100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(129632, NULL, 'G3DSA:3.40.50.300:FF:006220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(129633, NULL, 'G3DSA:3.40.720.10:FF:000029', NULL, NULL, 'ectonucleotide pyrophosphatase/phosphodiesterase family member 6', NULL, NULL, NULL, NULL, NULL, 4),
(129634, NULL, 'G3DSA:3.90.180.10:FF:000162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129635, NULL, 'G3DSA:1.20.1560.10:FF:000842', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129636, NULL, 'G3DSA:2.70.98.40:FF:000010', NULL, NULL, 'Putative glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(129637, NULL, 'G3DSA:1.25.10.10:FF:001535', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(129638, NULL, 'G3DSA:3.30.420.10:FF:000329', NULL, NULL, 'Exonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(129639, NULL, 'G3DSA:1.20.5.340:FF:000027', NULL, NULL, 'myosin-11 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(129640, NULL, 'G3DSA:2.60.260.20:FF:000041', NULL, NULL, 'HSP40/DnaJ peptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(129641, NULL, 'G3DSA:2.60.40.60:FF:000889', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129642, NULL, 'G3DSA:1.10.167.10:FF:000038', NULL, NULL, 'Regulator of G-protein signaling rgs-7', NULL, NULL, NULL, NULL, NULL, 4),
(129643, NULL, 'G3DSA:2.60.40.10:FF:004876', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129644, NULL, 'G3DSA:3.30.750.170:FF:000001', NULL, NULL, 'Peptidase S41', NULL, NULL, NULL, NULL, NULL, 4),
(129645, NULL, 'G3DSA:1.10.3090.10:FF:000005', NULL, NULL, 'Bifunctional uridylyltransferase/uridylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(129646, NULL, 'G3DSA:3.30.70.270:FF:000063', NULL, NULL, 'Zinc knuckle domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(129647, NULL, 'G3DSA:4.10.520.10:FF:000017', NULL, NULL, 'Integration host factor alpha-subunit', NULL, NULL, NULL, NULL, NULL, 4),
(129648, NULL, 'G3DSA:3.30.70.260:FF:000060', NULL, NULL, 'ACT domain repeat 6', NULL, NULL, NULL, NULL, NULL, 4),
(129649, NULL, 'G3DSA:1.25.10.10:FF:000433', NULL, NULL, 'Nuclear cohesin complex subunit (Psc3), putative', NULL, NULL, NULL, NULL, NULL, 4),
(129650, NULL, 'G3DSA:4.10.240.10:FF:000035', NULL, NULL, 'C6 transcription factor, putative (AFU_orthologue AFUA_4G12570)', NULL, NULL, NULL, NULL, NULL, 4),
(129651, NULL, 'G3DSA:2.60.40.10:FF:003095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129652, NULL, 'G3DSA:2.40.30.10:FF:000060', NULL, NULL, 'elongation factor 1-alpha isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(129653, NULL, 'G3DSA:3.40.850.10:FF:000393', NULL, NULL, 'Unconventional myosin 29D short isoform', NULL, NULL, NULL, NULL, NULL, 4),
(129654, NULL, 'G3DSA:3.30.70.330:FF:001031', NULL, NULL, 'Nop8p', NULL, NULL, NULL, NULL, NULL, 4),
(129655, NULL, 'G3DSA:3.40.50.300:FF:002151', NULL, NULL, 'SNF2 domain-containing protein CLASSY 3', NULL, NULL, NULL, NULL, NULL, 4),
(129656, NULL, 'G3DSA:1.25.10.10:FF:001861', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(129657, NULL, 'G3DSA:3.30.565.10:FF:000041', NULL, NULL, 'Sensor histidine kinase DcuS', NULL, NULL, NULL, NULL, NULL, 4),
(129658, NULL, 'G3DSA:3.30.1640.10:FF:000002', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(129659, NULL, 'G3DSA:1.25.40.10:FF:001363', NULL, NULL, 'Pentatricopeptide repeat-containing protein ATP4 homolog, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(129660, NULL, 'G3DSA:1.10.820.10:FF:000001', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(129661, NULL, 'G3DSA:1.25.40.10:FF:004004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129662, NULL, 'G3DSA:3.90.810.10:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129663, NULL, 'G3DSA:1.10.630.10:FF:000817', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129664, NULL, 'G3DSA:2.130.10.10:FF:003426', NULL, NULL, 'Protein GFS12', NULL, NULL, NULL, NULL, NULL, 4),
(129665, NULL, 'G3DSA:3.30.230.10:FF:000146', NULL, NULL, 'Elongation factor 2 putative', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(129666, NULL, 'G3DSA:3.30.200.20:FF:000647', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(129667, NULL, 'G3DSA:3.40.50.1010:FF:000210', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129668, NULL, 'G3DSA:2.130.10.10:FF:005197', NULL, NULL, 'SOF1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(129669, NULL, 'G3DSA:3.10.120.10:FF:000041', NULL, NULL, 'Acyl-lipid omega-13 desaturase', NULL, NULL, NULL, NULL, NULL, 4),
(129670, NULL, 'G3DSA:3.30.420.40:FF:000231', NULL, NULL, 'Heat shock protein family A (Hsp70) member 2', NULL, NULL, NULL, NULL, NULL, 4),
(129671, NULL, 'G3DSA:1.10.530.10:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129672, NULL, 'G3DSA:2.130.10.10:FF:001509', NULL, NULL, 'Protein NEDD1', NULL, NULL, NULL, NULL, NULL, 4),
(129673, NULL, 'G3DSA:1.20.1250.20:FF:001171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129674, NULL, 'G3DSA:1.25.40.1030:FF:000019', NULL, NULL, 'AGAP011214-PA', NULL, NULL, NULL, NULL, NULL, 4),
(129675, NULL, 'G3DSA:2.130.10.10:FF:004854', NULL, NULL, 'Protein CBG07276', NULL, NULL, NULL, NULL, NULL, 4),
(129676, NULL, 'G3DSA:3.30.1640.30:FF:000008', NULL, NULL, 'Serine protease grass', NULL, NULL, NULL, NULL, NULL, 4),
(129677, NULL, 'G3DSA:1.10.10.10:FF:001416', NULL, NULL, 'Transcriptional regulator, GntR family', NULL, NULL, NULL, NULL, NULL, 4),
(129678, NULL, 'G3DSA:3.30.40.10:FF:001323', NULL, NULL, 'Zinc finger family protein', NULL, NULL, NULL, NULL, NULL, 4),
(129679, NULL, 'G3DSA:3.30.365.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129680, NULL, 'G3DSA:2.60.120.380:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129681, NULL, 'G3DSA:3.80.10.10:FF:004287', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129682, NULL, 'G3DSA:1.10.8.720:FF:000014', NULL, NULL, 'Putative dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(129683, NULL, 'G3DSA:3.40.50.300:FF:007794', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129684, NULL, 'G3DSA:3.30.70.100:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129685, NULL, 'G3DSA:2.60.120.200:FF:000385', NULL, NULL, 'AGAP003873-PA', NULL, NULL, NULL, NULL, NULL, 4),
(129686, NULL, 'G3DSA:3.40.50.2000:FF:000198', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(129687, NULL, 'G3DSA:3.40.50.300:FF:000060', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(129688, NULL, 'G3DSA:1.10.220.20:FF:000008', NULL, NULL, 'BRag/Iqsec/Schizo related Arf GEF family member', NULL, NULL, NULL, NULL, NULL, 4),
(129689, NULL, 'G3DSA:3.30.160.60:FF:006124', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129690, NULL, 'G3DSA:2.60.120.10:FF:000202', NULL, NULL, '5-deoxy-glucuronate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(129691, NULL, 'G3DSA:1.10.3170.10:FF:000006', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(129692, NULL, 'G3DSA:2.10.90.10:FF:000014', NULL, NULL, 'Noggin', NULL, NULL, NULL, NULL, NULL, 4),
(129693, NULL, 'G3DSA:2.30.39.10:FF:000102', NULL, NULL, 'Serpin-Z1', NULL, NULL, NULL, NULL, NULL, 4),
(129694, NULL, 'G3DSA:2.60.120.10:FF:000674', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129695, NULL, 'G3DSA:3.30.70.330:FF:001710', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129696, NULL, 'G3DSA:3.30.160.60:FF:003544', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129697, NULL, 'G3DSA:3.40.50.300:FF:005377', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129698, NULL, 'G3DSA:1.10.287.70:FF:000368', NULL, NULL, 'Voltage-gated Ca2+ channel, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(129699, NULL, 'G3DSA:3.20.20.140:FF:000016', NULL, NULL, 'Adenine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(129700, NULL, 'G3DSA:1.10.10.790:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129701, NULL, 'G3DSA:1.10.10.10:FF:000899', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(129702, NULL, 'G3DSA:2.60.40.10:FF:003448', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129703, NULL, 'G3DSA:3.10.50.40:FF:000131', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(129704, NULL, 'G3DSA:1.50.40.10:FF:000017', NULL, NULL, 'Solute carrier family 25 member 22a', NULL, NULL, NULL, NULL, NULL, 4),
(129705, NULL, 'G3DSA:3.40.50.150:FF:001774', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129706, NULL, 'G3DSA:3.40.190.80:FF:000014', NULL, NULL, 'CysQ protein', NULL, NULL, NULL, NULL, NULL, 4),
(129707, NULL, 'G3DSA:2.60.120.200:FF:000059', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(129708, NULL, 'G3DSA:2.60.40.10:FF:005539', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129709, NULL, 'G3DSA:2.10.25.10:FF:001105', NULL, NULL, 'Fbn3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(129710, NULL, 'G3DSA:3.20.20.80:FF:000685', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129711, NULL, 'G3DSA:2.60.40.10:FF:000222', NULL, NULL, 'Myomesin 1', NULL, NULL, NULL, NULL, NULL, 4),
(129712, NULL, 'G3DSA:3.30.40.10:FF:000660', NULL, NULL, 'RING/U-box superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(129713, NULL, 'G3DSA:1.25.40.20:FF:001692', NULL, NULL, 'Calmodulin-binding transcription activator 5', NULL, NULL, NULL, NULL, NULL, 4),
(129714, NULL, 'G3DSA:1.10.510.10:FF:002315', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129715, NULL, 'G3DSA:3.40.30.10:FF:000254', NULL, NULL, 'DUF255 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(129716, NULL, 'G3DSA:2.60.120.330:FF:000165', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129717, NULL, 'G3DSA:3.90.190.10:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129718, NULL, 'G3DSA:3.60.10.10:FF:000409', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(129719, NULL, 'G3DSA:3.30.160.60:FF:004033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129720, NULL, 'G3DSA:1.10.510.10:FF:001326', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(129721, NULL, 'G3DSA:3.20.20.120:FF:000010', NULL, NULL, 'Dipeptide epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(129722, NULL, 'G3DSA:1.25.10.10:FF:000107', NULL, NULL, 'Importin-13', NULL, NULL, NULL, NULL, NULL, 4),
(129723, NULL, 'G3DSA:2.60.40.200:FF:000016', NULL, NULL, 'Extracellular superoxide dismutase [Cu-Zn] 3', NULL, NULL, NULL, NULL, NULL, 4),
(129724, NULL, 'G3DSA:3.40.190.10:FF:000100', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(129725, NULL, 'G3DSA:4.10.1000.10:FF:000059', NULL, NULL, 'Putative zinc finger CCCH domain-containing protein 48', NULL, NULL, NULL, NULL, NULL, 4),
(129726, NULL, 'G3DSA:3.80.10.10:FF:000751', NULL, NULL, 'Si:dkey-16p6.1', NULL, NULL, NULL, NULL, NULL, 4),
(129727, NULL, 'G3DSA:3.40.50.1110:FF:000094', NULL, NULL, 'YALI0B07227p', NULL, NULL, NULL, NULL, NULL, 4),
(129728, NULL, 'G3DSA:3.40.50.150:FF:001509', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129729, NULL, 'G3DSA:2.30.30.140:FF:000008', NULL, NULL, 'Bromodomain containing 1, isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(129730, NULL, 'G3DSA:2.60.40.10:FF:005186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129731, NULL, 'G3DSA:3.90.1410.10:FF:000011', NULL, NULL, 'Transcription factor, E2F and DP-related', NULL, NULL, NULL, NULL, NULL, 4),
(129732, NULL, 'G3DSA:2.60.40.10:FF:002959', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(129733, NULL, 'G3DSA:4.10.1060.10:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129734, NULL, 'G3DSA:3.40.1170.10:FF:000031', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(129735, NULL, 'G3DSA:1.10.437.10:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129736, NULL, 'G3DSA:3.30.310.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(129737, NULL, 'G3DSA:3.30.160.60:FF:005635', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129738, NULL, 'G3DSA:2.60.40.60:FF:000304', NULL, NULL, 'Dachsous cadherin-related 2', NULL, NULL, NULL, NULL, NULL, 4),
(129739, NULL, 'G3DSA:3.90.640.90:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129740, NULL, 'G3DSA:2.40.50.700:FF:000004', NULL, NULL, 'Exosome complex exonuclease RRP44 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(129741, NULL, 'G3DSA:1.20.1510.10:FF:000098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129742, NULL, 'G3DSA:1.10.510.10:FF:003417', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129743, NULL, 'G3DSA:2.60.120.920:FF:000128', NULL, NULL, 'Neuralized-like protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(129744, NULL, 'G3DSA:1.25.40.20:FF:000590', NULL, NULL, 'Protein CBG13985', NULL, NULL, NULL, NULL, NULL, 4),
(129745, NULL, 'G3DSA:1.10.285.10:FF:000003', NULL, NULL, 'Glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(129746, NULL, 'G3DSA:2.30.29.30:FF:000669', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129747, NULL, 'G3DSA:1.10.630.10:FF:000290', NULL, NULL, 'Cytochrome P-450 IIC5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129748, NULL, 'G3DSA:2.70.160.11:FF:000046', NULL, NULL, 'PRotein arginine MethylTransferase', NULL, NULL, NULL, NULL, NULL, 4),
(129749, NULL, 'G3DSA:3.30.450.60:FF:000065', NULL, NULL, 'Mu-adaptin 4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129750, NULL, 'G3DSA:2.130.10.10:FF:003073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129751, NULL, 'G3DSA:2.60.120.200:FF:000738', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129752, NULL, 'G3DSA:2.30.29.30:FF:000462', NULL, NULL, 'TeNSin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(129753, NULL, 'G3DSA:3.80.10.10:FF:002842', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129754, NULL, 'G3DSA:3.40.190.10:FF:000685', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129755, NULL, 'G3DSA:3.40.20.10:FF:000017', NULL, NULL, 'Supervillin', NULL, NULL, NULL, NULL, NULL, 4),
(129756, NULL, 'G3DSA:3.90.105.20:FF:000002', NULL, NULL, 'Ribosome assembly factor mrt4', NULL, NULL, NULL, NULL, NULL, 4),
(129757, NULL, 'G3DSA:1.20.920.10:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129758, NULL, 'G3DSA:3.30.450.50:FF:000062', NULL, NULL, 'Vesicle-associated membrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129759, NULL, 'G3DSA:3.40.50.300:FF:004888', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129760, NULL, 'G3DSA:3.30.450.20:FF:000665', NULL, NULL, 'Glr3986 protein', NULL, NULL, NULL, NULL, NULL, 4),
(129761, NULL, 'G3DSA:1.25.40.20:FF:000090', NULL, NULL, 'inhibitor of Bruton tyrosine kinase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(129762, NULL, 'G3DSA:1.25.40.10:FF:005106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129763, NULL, 'G3DSA:1.20.58.60:FF:000462', NULL, NULL, 'AGAP004440-PA', NULL, NULL, NULL, NULL, NULL, 4),
(129764, NULL, 'G3DSA:1.10.630.10:FF:000790', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129765, NULL, 'G3DSA:2.130.10.10:FF:005843', NULL, NULL, 'Apoptotic protease-activating factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(129766, NULL, 'G3DSA:3.40.50.300:FF:007468', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129767, NULL, 'G3DSA:3.30.200.20:FF:001636', NULL, NULL, 'AFR372Wp', NULL, NULL, NULL, NULL, NULL, 4),
(129768, NULL, 'G3DSA:3.50.50.60:FF:001040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129769, NULL, 'G3DSA:3.10.20.90:FF:000211', NULL, NULL, 'Polyubiquitin 9', NULL, NULL, NULL, NULL, NULL, 4),
(129770, NULL, 'G3DSA:1.20.1270.60:FF:000318', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129771, NULL, 'G3DSA:3.40.630.30:FF:000242', NULL, NULL, 'Acetyltransferase, GNAT family protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(129772, NULL, 'G3DSA:3.30.1490.20:FF:000061', NULL, NULL, 'Trifunctional purine biosynthetic protein adenosine-3', NULL, NULL, NULL, NULL, NULL, 4),
(129773, NULL, 'G3DSA:2.30.42.10:FF:000329', NULL, NULL, 'Carboxy-terminal processing protease', NULL, NULL, NULL, NULL, NULL, 4),
(129774, NULL, 'G3DSA:3.30.160.60:FF:005135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129775, NULL, 'G3DSA:3.30.420.10:FF:000481', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129776, NULL, 'G3DSA:1.10.510.10:FF:001826', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129777, NULL, 'G3DSA:2.60.120.970:FF:000003', NULL, NULL, 'Growth differentiation factor 11', NULL, NULL, NULL, NULL, NULL, 4),
(129778, NULL, 'G3DSA:1.20.1560.10:FF:000516', NULL, NULL, 'Multidrug resistance-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(129779, NULL, 'G3DSA:3.30.70.890:FF:000041', NULL, NULL, 'Diphosphomevalonate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(129780, NULL, 'G3DSA:3.40.850.10:FF:000067', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(129781, NULL, 'G3DSA:3.30.70.330:FF:001238', NULL, NULL, 'Likely mitochondrial ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(129782, NULL, 'G3DSA:1.10.472.10:FF:000152', NULL, NULL, 'Cyclin T 13', NULL, NULL, NULL, NULL, NULL, 4),
(129783, NULL, 'G3DSA:3.50.50.60:FF:001186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129784, NULL, 'G3DSA:3.90.1280.20:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129785, NULL, 'G3DSA:3.40.640.10:FF:000467', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129786, NULL, 'G3DSA:3.40.220.10:FF:000036', NULL, NULL, 'Cytosolic leucyl aminopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129787, NULL, 'G3DSA:3.40.50.720:FF:000916', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(129788, NULL, 'G3DSA:1.10.418.10:FF:000010', NULL, NULL, 'Plastin-3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(129789, NULL, 'G3DSA:3.30.70.330:FF:002812', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129790, NULL, 'G3DSA:3.80.10.10:FF:001061', NULL, NULL, 'F-box and leucine-rich repeat protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(129791, NULL, 'G3DSA:2.60.40.10:FF:001824', NULL, NULL, 'Leukocyte-associated immunoglobulin-like receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(129792, NULL, 'G3DSA:1.10.287.2620:FF:000005', NULL, NULL, 'Dynein heavy chain 1, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(129793, NULL, 'G3DSA:3.30.160.60:FF:001919', NULL, NULL, 'Replication initiator 1', NULL, NULL, NULL, NULL, NULL, 4),
(129794, NULL, 'G3DSA:1.10.418.20:FF:000013', NULL, NULL, 'Related to protease ULP2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(129795, NULL, 'G3DSA:3.30.160.60:FF:001599', NULL, NULL, 'ZFP69 zinc finger protein B', NULL, NULL, NULL, NULL, NULL, 4),
(129796, NULL, 'G3DSA:2.130.10.10:FF:000200', NULL, NULL, 'U3 small nucleolar RNA-associated protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(129797, NULL, 'G3DSA:3.30.1240.10:FF:000039', NULL, NULL, 'Cof-type HAD-IIB family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(129798, NULL, 'G3DSA:3.30.505.10:FF:000032', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(129799, NULL, 'G3DSA:1.10.1280.10:FF:000014', NULL, NULL, 'hemocyanin A-type, units Ode to Odg-like', NULL, NULL, NULL, NULL, NULL, 4),
(129800, NULL, 'G3DSA:2.60.40.10:FF:002313', NULL, NULL, 'T cell receptor alpha variable 18', NULL, NULL, NULL, NULL, NULL, 4),
(129801, NULL, 'G3DSA:2.60.40.10:FF:004084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129802, NULL, 'G3DSA:3.30.920.10:FF:000002', NULL, NULL, 'Frataxin, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(129803, NULL, 'G3DSA:3.30.2130.30:FF:000043', NULL, NULL, 'Probable tRNA sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(129804, NULL, 'G3DSA:3.30.70.850:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(129805, NULL, 'G3DSA:3.40.50.720:FF:001405', NULL, NULL, 'NAD-dependent epimerase/dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(129806, NULL, 'G3DSA:2.60.40.420:FF:000262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129807, NULL, 'G3DSA:3.40.50.300:FF:000560', NULL, NULL, 'CLP protease regulatory subunit CLPX3 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(129808, NULL, 'G3DSA:2.160.10.10:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129809, NULL, 'G3DSA:3.40.50.300:FF:007529', NULL, NULL, 'AGAP008714-PA', NULL, NULL, NULL, NULL, NULL, 4),
(129810, NULL, 'G3DSA:1.10.287.2610:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129811, NULL, 'G3DSA:3.40.50.1000:FF:000027', NULL, NULL, 'ATPase copper transporting beta', NULL, NULL, NULL, NULL, NULL, 4),
(129812, NULL, 'G3DSA:4.10.400.10:FF:000216', NULL, NULL, 'Terribly reduced optic lobes, isoform AN', NULL, NULL, NULL, NULL, NULL, 4),
(129813, NULL, 'G3DSA:3.40.50.720:FF:000416', NULL, NULL, 'Multifunctional mycocerosic acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(129814, NULL, 'G3DSA:3.60.40.10:FF:000237', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129815, NULL, 'G3DSA:3.40.50.300:FF:005405', NULL, NULL, 'ADP-ribosylation factor 2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(129816, NULL, 'G3DSA:3.40.50.720:FF:000596', NULL, NULL, '2,3-diaminopropionate biosynthesis protein SbnB', NULL, NULL, NULL, NULL, NULL, 4),
(129817, NULL, 'G3DSA:1.10.8.1310:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129818, NULL, 'G3DSA:1.25.10.10:FF:002350', NULL, NULL, 'Nucleotide exchange factor SIL1', NULL, NULL, NULL, NULL, NULL, 4),
(129819, NULL, 'G3DSA:3.10.50.30:FF:000009', NULL, NULL, 'Transcription elongation factor GreA', NULL, NULL, NULL, NULL, NULL, 4),
(129820, NULL, 'G3DSA:1.20.1720.10:FF:000018', NULL, NULL, 'Putative MFS multidrug transporter', NULL, NULL, NULL, NULL, NULL, 4),
(129821, NULL, 'G3DSA:2.60.40.10:FF:001178', NULL, NULL, 'Sallimus, isoform Q', NULL, NULL, NULL, NULL, NULL, 4),
(129822, NULL, 'G3DSA:2.60.40.790:FF:000030', NULL, NULL, 'Co-chaperone protein p23-2', NULL, NULL, NULL, NULL, NULL, 4),
(129823, NULL, 'G3DSA:3.30.160.60:FF:003870', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129824, NULL, 'G3DSA:1.50.40.10:FF:000343', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129825, NULL, 'G3DSA:1.10.3720.10:FF:000150', NULL, NULL, 'Molybdenum ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(129826, NULL, 'G3DSA:1.20.1250.20:FF:002334', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129827, NULL, 'G3DSA:2.60.120.200:FF:000559', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129828, NULL, 'G3DSA:3.40.50.620:FF:000684', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129829, NULL, 'G3DSA:2.10.25.10:FF:000088', NULL, NULL, 'Prolow-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(129830, NULL, 'G3DSA:1.10.287.3490:FF:000002', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 11', NULL, NULL, NULL, NULL, NULL, 4),
(129831, NULL, 'G3DSA:3.30.70.380:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129832, NULL, 'G3DSA:1.20.1560.10:FF:000781', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129833, NULL, 'G3DSA:3.30.420.110:FF:000050', NULL, NULL, 'Mismatch repair ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(129834, NULL, 'G3DSA:1.20.1070.10:FF:000760', NULL, NULL, 'Adhesion G protein-coupled receptor G4', NULL, NULL, NULL, NULL, NULL, 4),
(129835, NULL, 'G3DSA:3.90.1150.10:FF:000384', NULL, NULL, 'Uncharacterized HTH-type transcriptional regulator YisV', NULL, NULL, NULL, NULL, NULL, 4),
(129836, NULL, 'G3DSA:3.30.70.600:FF:000027', NULL, NULL, '40S ribosomal protein S20-1', NULL, NULL, NULL, NULL, NULL, 4),
(129837, NULL, 'G3DSA:1.10.8.10:FF:000241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(129838, NULL, 'G3DSA:3.40.50.1820:FF:000447', NULL, NULL, 'Polyhydroxyalkanoic acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(129839, NULL, 'G3DSA:3.30.160.20:FF:000093', NULL, NULL, 'Mrpl3p', NULL, NULL, NULL, NULL, NULL, 4),
(129840, NULL, 'G3DSA:3.30.200.20:FF:001283', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129841, NULL, 'G3DSA:2.20.100.10:FF:000199', NULL, NULL, 'Thrombospondin type 1 domain containing 7A', NULL, NULL, NULL, NULL, NULL, 4),
(129842, NULL, 'G3DSA:1.25.10.10:FF:003452', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129843, NULL, 'G3DSA:2.130.10.10:FF:001835', NULL, NULL, 'AGAP005915-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(129844, NULL, 'G3DSA:3.30.460.10:FF:000129', NULL, NULL, 'Putative DNA polymerase X', NULL, NULL, NULL, NULL, NULL, 4),
(129845, NULL, 'G3DSA:1.20.5.650:FF:000002', NULL, NULL, 'Cyclin/Brf1-like TBP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(129846, NULL, 'G3DSA:2.60.120.10:FF:000174', NULL, NULL, 'Cyclic nucleotide-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(129847, NULL, 'G3DSA:1.10.630.10:FF:000610', NULL, NULL, 'Cytochrome P450 1A2', NULL, NULL, NULL, NULL, NULL, 4),
(129848, NULL, 'G3DSA:1.20.1640.10:FF:000051', NULL, NULL, 'PaTched Related family', NULL, NULL, NULL, NULL, NULL, 4),
(129849, NULL, 'G3DSA:3.40.1340.10:FF:000005', NULL, NULL, 'Putative DNA-directed RNA polymerases II', NULL, NULL, NULL, NULL, NULL, 4),
(129850, NULL, 'G3DSA:3.10.20.90:FF:000183', NULL, NULL, 'Ubiquitin domain-containing protein DSK2b', NULL, NULL, NULL, NULL, NULL, 4),
(129851, NULL, 'G3DSA:2.60.40.10:FF:003948', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129852, NULL, 'G3DSA:3.40.1110.10:FF:000229', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129853, NULL, 'G3DSA:1.10.10.1760:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129854, NULL, 'G3DSA:4.10.1240.50:FF:000004', NULL, NULL, 'arginine-glutamic acid dipeptide repeats protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(129855, NULL, 'G3DSA:2.130.10.10:FF:002937', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129856, NULL, 'G3DSA:3.40.50.360:FF:000084', NULL, NULL, 'Low temperature-responsive protein', NULL, NULL, NULL, NULL, NULL, 4),
(129857, NULL, 'G3DSA:3.30.40.140:FF:000006', NULL, NULL, 'FHA domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129858, NULL, 'G3DSA:1.20.58.1070:FF:000008', NULL, NULL, 'Gem-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(129859, NULL, 'G3DSA:2.10.25.10:FF:000734', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129860, NULL, 'G3DSA:3.90.260.10:FF:000050', NULL, NULL, 'DNA repair protein xp-C / rad4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129861, NULL, 'G3DSA:1.20.1310.10:FF:000150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129862, NULL, 'G3DSA:1.10.287.70:FF:000722', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129863, NULL, 'G3DSA:1.10.510.10:FF:000045', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(129864, NULL, 'G3DSA:3.40.50.300:FF:003786', NULL, NULL, 'Zgc:172091 protein', NULL, NULL, NULL, NULL, NULL, 4),
(129865, NULL, 'G3DSA:4.10.280.10:FF:000127', NULL, NULL, 'Helix-loop-helix protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(129866, NULL, 'G3DSA:3.30.70.1230:FF:000110', NULL, NULL, 'Adenylate/guanylate cyclase catalytic domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(129867, NULL, 'G3DSA:1.10.730.20:FF:000031', NULL, NULL, 'Isoleucyl tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129868, NULL, 'G3DSA:1.10.472.80:FF:000212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129869, NULL, 'G3DSA:3.40.50.150:FF:001156', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129870, NULL, 'G3DSA:3.90.1170.40:FF:000017', NULL, NULL, 'Molybdopterin converting factor, large subunit', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(129871, NULL, 'G3DSA:3.40.50.300:FF:001662', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129872, NULL, 'G3DSA:1.20.58.390:FF:000261', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129873, NULL, 'G3DSA:3.30.160.60:FF:004533', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129874, NULL, 'G3DSA:2.30.130.10:FF:000035', NULL, NULL, 'Glutamate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(129875, NULL, 'G3DSA:1.10.1200.120:FF:000002', NULL, NULL, 'Large-conductance mechanosensitive channel', NULL, NULL, NULL, NULL, NULL, 4),
(129876, NULL, 'G3DSA:2.40.50.140:FF:000437', NULL, NULL, '26S protease regulatory subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129877, NULL, 'G3DSA:1.20.1110.10:FF:000230', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129878, NULL, 'G3DSA:2.120.10.80:FF:000429', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(129879, NULL, 'G3DSA:3.40.50.2300:FF:000518', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(129880, NULL, 'G3DSA:1.25.40.20:FF:001192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129881, NULL, 'G3DSA:2.30.42.10:FF:000655', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129882, NULL, 'G3DSA:2.10.220.10:FF:000024', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(129883, NULL, 'G3DSA:6.10.140.2220:FF:000036', NULL, NULL, 'SET domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(129884, NULL, 'G3DSA:2.130.10.10:FF:000700', NULL, NULL, 'Sperm-associated antigen 9a', NULL, NULL, NULL, NULL, NULL, 4),
(129885, NULL, 'G3DSA:2.70.50.30:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129886, NULL, 'G3DSA:1.10.1200.10:FF:000155', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(129887, NULL, 'G3DSA:1.25.40.10:FF:003341', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(129888, NULL, 'G3DSA:2.60.40.60:FF:001086', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129889, NULL, 'G3DSA:3.40.50.300:FF:004303', NULL, NULL, 'Probable gluconokinase', NULL, NULL, NULL, NULL, NULL, 4),
(129890, NULL, 'G3DSA:3.30.530.20:FF:000020', NULL, NULL, 'homeobox-leucine zipper protein ATHB-15', NULL, NULL, NULL, NULL, NULL, 4),
(129891, NULL, 'G3DSA:3.80.10.10:FF:002516', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129892, NULL, 'G3DSA:3.40.50.300:FF:007940', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129893, NULL, 'G3DSA:3.40.50.300:FF:005731', NULL, NULL, 'Os03g0743800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(129894, NULL, 'G3DSA:1.10.8.430:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129895, NULL, 'G3DSA:2.70.130.10:FF:000122', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129896, NULL, 'G3DSA:3.90.1170.30:FF:000014', NULL, NULL, 'Thymidine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(129897, NULL, 'G3DSA:3.30.200.20:FF:001136', NULL, NULL, 'At3g62220', NULL, NULL, NULL, NULL, NULL, 4),
(129898, NULL, 'G3DSA:3.30.420.10:FF:000155', NULL, NULL, 'Transposon Tf2-4 polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(129899, NULL, 'G3DSA:2.70.170.10:FF:000040', NULL, NULL, 'Cholinergic receptor nicotinic gamma subunit', NULL, NULL, NULL, NULL, NULL, 4),
(129900, NULL, 'G3DSA:1.10.150.50:FF:000080', NULL, NULL, 'Eph receptor tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(129901, NULL, 'G3DSA:3.30.200.20:FF:002564', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129902, NULL, 'G3DSA:1.10.10.10:FF:000927', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(129903, NULL, 'G3DSA:3.90.1170.20:FF:000011', NULL, NULL, 'Nicotinate-mononucleotide pyrophosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(129904, NULL, 'G3DSA:1.20.58.1060:FF:000005', NULL, NULL, 'Plectin b', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(129905, NULL, 'G3DSA:3.30.70.330:FF:003094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129906, NULL, 'G3DSA:1.10.10.60:FF:001263', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129907, NULL, 'G3DSA:1.10.405.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129908, NULL, 'G3DSA:1.20.1070.10:FF:000788', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129909, NULL, 'G3DSA:3.30.300.20:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129910, NULL, 'G3DSA:1.20.1070.10:FF:001070', NULL, NULL, 'Melatonin receptor type 1A', NULL, NULL, NULL, NULL, NULL, 4),
(129911, NULL, 'G3DSA:1.10.510.10:FF:001591', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129912, NULL, 'G3DSA:3.40.50.790:FF:000010', NULL, NULL, '50S ribosomal protein L1', NULL, NULL, NULL, NULL, NULL, 4),
(129913, NULL, 'G3DSA:2.10.70.10:FF:000131', NULL, NULL, 'Complement factor H-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(129914, NULL, 'G3DSA:1.20.1070.10:FF:000608', NULL, NULL, 'NeuroPeptide Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(129915, NULL, 'G3DSA:3.30.200.20:FF:000973', NULL, NULL, 'Kinase, CMGC CDK', NULL, NULL, NULL, NULL, NULL, 4),
(129916, NULL, 'G3DSA:3.40.50.2300:FF:000844', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129917, NULL, 'G3DSA:3.30.1490.100:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129918, NULL, 'G3DSA:1.10.510.10:FF:003125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129919, NULL, 'G3DSA:2.60.220.50:FF:000137', NULL, NULL, 'Adhesion G protein-coupled receptor G1', NULL, NULL, NULL, NULL, NULL, 4),
(129920, NULL, 'G3DSA:3.30.300.30:FF:000068', NULL, NULL, 'Nonribosomal peptide synthase SidE', NULL, NULL, NULL, NULL, NULL, 4),
(129921, NULL, 'G3DSA:3.40.50.12550:FF:000012', NULL, NULL, 'ThiF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(129922, NULL, 'G3DSA:3.40.50.1000:FF:000353', NULL, NULL, 'GM26347', NULL, NULL, NULL, NULL, NULL, 4),
(129923, NULL, 'G3DSA:3.40.50.720:FF:000742', NULL, NULL, 'probable bifunctional methylenetetrahydrofolate dehydrogenase/cyclohydrolase 2', NULL, NULL, NULL, NULL, NULL, 4),
(129924, NULL, 'G3DSA:1.10.340.30:FF:000077', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129925, NULL, 'G3DSA:3.40.710.10:FF:000057', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(129926, NULL, 'G3DSA:3.30.160.60:FF:000610', NULL, NULL, 'B-box zinc finger protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(129927, NULL, 'G3DSA:1.20.1560.10:FF:000163', NULL, NULL, 'ABC transporter B family protein', NULL, NULL, NULL, NULL, NULL, 4),
(129928, NULL, 'G3DSA:3.40.50.1820:FF:000773', NULL, NULL, 'Uncharacterized_conserved_protein_(DUF2305)/Alpha /beta_hydrolase_family_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(129929, NULL, 'G3DSA:2.40.10.10:FF:000204', NULL, NULL, 'Membrane-associated serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(129930, NULL, 'G3DSA:3.40.1360.10:FF:000040', NULL, NULL, 'Spo11p', NULL, NULL, NULL, NULL, NULL, 4),
(129931, NULL, 'G3DSA:3.40.50.200:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129932, NULL, 'G3DSA:3.40.50.410:FF:000267', NULL, NULL, 'Collagen, type XII, alpha 1b', NULL, NULL, NULL, NULL, NULL, 4),
(129933, NULL, 'G3DSA:3.30.200.20:FF:001462', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(129934, NULL, 'G3DSA:3.10.105.10:FF:000028', NULL, NULL, 'ABC transporter, periplasmic substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(129935, NULL, 'G3DSA:2.60.40.10:FF:005365', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129936, NULL, 'G3DSA:3.30.1330.20:FF:000021', NULL, NULL, 'Cell division protein FtsZ', NULL, NULL, NULL, NULL, NULL, 4),
(129937, NULL, 'G3DSA:2.60.40.10:FF:001796', NULL, NULL, 'Dpr-interacting protein gamma', NULL, NULL, NULL, NULL, NULL, 4),
(129938, NULL, 'G3DSA:3.40.50.10190:FF:000164', NULL, NULL, 'PAX transcription activation domain interacting protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(129939, NULL, 'G3DSA:3.80.10.10:FF:001414', NULL, NULL, 'Leucine_Rich_Repeat/Leucine_rich_repeat_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(129940, NULL, 'G3DSA:3.30.70.3320:FF:000001', NULL, NULL, 'Fatty acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(129941, NULL, 'G3DSA:2.40.37.10:FF:000064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129942, NULL, 'G3DSA:1.20.1250.20:FF:000389', NULL, NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(129943, NULL, 'G3DSA:1.25.10.10:FF:002024', NULL, NULL, 'YALI0B20724p', NULL, NULL, NULL, NULL, NULL, 4),
(129944, NULL, 'G3DSA:1.10.10.10:FF:002052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129945, NULL, 'G3DSA:2.40.50.140:FF:000763', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129946, NULL, 'G3DSA:3.30.160.60:FF:004207', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129947, NULL, 'G3DSA:1.10.510.10:FF:002023', NULL, NULL, 'Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(129948, NULL, 'G3DSA:3.80.10.10:FF:000925', NULL, NULL, 'F-box protein At5g67140', NULL, NULL, NULL, NULL, NULL, 4),
(129949, NULL, 'G3DSA:3.90.190.10:FF:000426', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129950, NULL, 'G3DSA:2.10.25.10:FF:000908', NULL, NULL, 'low-density lipoprotein receptor-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(129951, NULL, 'G3DSA:3.30.160.60:FF:003718', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129952, NULL, 'G3DSA:3.40.50.720:FF:001231', NULL, NULL, 'Glyoxylate/hydroxypyruvate reductase HPR3 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(129953, NULL, 'G3DSA:2.40.50.90:FF:000186', NULL, NULL, 'AT14886p', NULL, NULL, NULL, NULL, NULL, 4),
(129954, NULL, 'G3DSA:3.30.160.60:FF:005461', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129955, NULL, 'G3DSA:2.60.40.10:FF:002021', NULL, NULL, 'Jitterbug, isoform N', NULL, NULL, NULL, NULL, NULL, 4),
(129956, NULL, 'G3DSA:1.25.40.10:FF:000261', NULL, NULL, 'protein fem-1 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(129957, NULL, 'G3DSA:3.40.50.11610:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129958, NULL, 'G3DSA:1.10.287.110:FF:000055', NULL, NULL, 'DnaJ subfamily C member 7', NULL, NULL, NULL, NULL, NULL, 4),
(129959, NULL, 'G3DSA:3.30.390.30:FF:000051', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(129960, NULL, 'G3DSA:4.10.410.10:FF:000014', NULL, NULL, 'Serine peptidase inhibitor, Kunitz type, 2', NULL, NULL, NULL, NULL, NULL, 4),
(129961, NULL, 'G3DSA:2.10.50.10:FF:000129', NULL, NULL, 'Tumor necrosis factor receptor superfamily, member 1a', NULL, NULL, NULL, NULL, NULL, 4),
(129962, NULL, 'G3DSA:3.30.70.1730:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129963, NULL, 'G3DSA:3.30.1330.30:FF:000024', NULL, NULL, 'Putative tRNA/rRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(129964, NULL, 'G3DSA:3.40.50.150:FF:000200', NULL, NULL, 'Citrate synthase lysine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(129965, NULL, 'G3DSA:3.30.1330.40:FF:000027', NULL, NULL, 'Endoribonuclease L-PSP', NULL, NULL, NULL, NULL, NULL, 4),
(129966, NULL, 'G3DSA:3.80.10.10:FF:002696', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129967, NULL, 'G3DSA:1.20.1270.60:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129968, NULL, 'G3DSA:1.10.510.10:FF:004232', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129969, NULL, 'G3DSA:3.30.2140.20:FF:000012', NULL, NULL, 'Uncharacterized acetyltransferase YvcN', NULL, NULL, NULL, NULL, NULL, 4),
(129970, NULL, 'G3DSA:1.10.10.10:FF:001742', NULL, NULL, 'Bifunctional ligase/repressor BirA', NULL, NULL, NULL, NULL, NULL, 4),
(129971, NULL, 'G3DSA:1.20.810.10:FF:000037', NULL, NULL, 'Cytochrome b/b6 domain', NULL, NULL, NULL, NULL, NULL, 4),
(129972, NULL, 'G3DSA:1.25.40.20:FF:000264', NULL, NULL, 'Fem-1 homolog B', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(129973, NULL, 'G3DSA:4.10.410.20:FF:000017', NULL, NULL, 'poly(U)-specific endoribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(129974, NULL, 'G3DSA:3.30.200.20:FF:000001', NULL, NULL, 'Ephrin type-A receptor 5', NULL, NULL, NULL, NULL, NULL, 4),
(129975, NULL, 'G3DSA:2.40.50.140:FF:001073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129976, NULL, 'G3DSA:3.40.50.1100:FF:000265', NULL, NULL, 'Serine/threonine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(129977, NULL, 'G3DSA:1.25.40.10:FF:002498', NULL, NULL, 'Prolyl 4-hydroxylase alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(129978, NULL, 'G3DSA:3.40.50.300:FF:007614', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129979, NULL, 'G3DSA:3.30.200.160:FF:000004', NULL, NULL, 'Os01g0528000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(129980, NULL, 'G3DSA:1.10.600.10:FF:000136', NULL, NULL, 'Terpenoid synthases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(129981, NULL, 'G3DSA:3.40.33.10:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129982, NULL, 'G3DSA:3.40.50.150:FF:001482', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129983, NULL, 'G3DSA:3.90.1750.20:FF:000005', NULL, NULL, 'Serine recombinase', NULL, NULL, NULL, NULL, NULL, 4),
(129984, NULL, 'G3DSA:1.20.920.10:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129985, NULL, 'G3DSA:1.10.1420.10:FF:000020', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(129986, NULL, 'G3DSA:3.40.50.2300:FF:001333', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129987, NULL, 'G3DSA:1.20.1270.10:FF:000062', NULL, NULL, 'Glucose-regulated protein', NULL, NULL, NULL, NULL, NULL, 4),
(129988, NULL, 'G3DSA:1.10.20.10:FF:000107', NULL, NULL, 'Chromatin accessibility complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(129989, NULL, 'G3DSA:1.20.1740.10:FF:000227', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(129990, NULL, 'G3DSA:3.30.1360.120:FF:000014', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(129991, NULL, 'G3DSA:1.20.1250.20:FF:000182', NULL, NULL, 'Sucrose transporter SUC2', NULL, NULL, NULL, NULL, NULL, 4),
(129992, NULL, 'G3DSA:3.90.1750.10:FF:000002', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(129993, NULL, 'G3DSA:3.40.1110.10:FF:000022', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(129994, NULL, 'G3DSA:1.10.510.10:FF:001798', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(129995, NULL, 'G3DSA:2.30.180.10:FF:000100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129996, NULL, 'G3DSA:2.60.40.10:FF:004230', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(129997, NULL, 'G3DSA:3.30.710.10:FF:000256', NULL, NULL, 'SKP1-like_protein', NULL, NULL, NULL, NULL, NULL, 4),
(129998, NULL, 'G3DSA:3.30.160.60:FF:001745', NULL, NULL, 'Zinc finger protein 658', NULL, NULL, NULL, NULL, NULL, 4),
(129999, NULL, 'G3DSA:1.25.10.10:FF:002996', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130000, NULL, 'G3DSA:3.60.130.10:FF:000047', NULL, NULL, 'Gamma Butyrobetaine Hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(130001, NULL, 'G3DSA:2.130.10.10:FF:001920', NULL, NULL, 'Transducin-like enhancer protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(130002, NULL, 'G3DSA:3.40.30.10:FF:000400', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(130003, NULL, 'G3DSA:3.20.20.150:FF:000053', NULL, NULL, 'Hydroxypyruvate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(130004, NULL, 'G3DSA:1.20.1560.10:FF:000663', NULL, NULL, 'ATP-binding cassette transporter, subfamily B, member 21, group MDR/PGP protein PpABCB21', NULL, NULL, NULL, NULL, NULL, 4),
(130005, NULL, 'G3DSA:1.20.58.1360:FF:000005', NULL, NULL, 'F-box and leucine-rich repeat protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(130006, NULL, 'G3DSA:2.60.40.10:FF:001296', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(130007, NULL, 'G3DSA:1.20.1070.10:FF:000642', NULL, NULL, 'GD11003', NULL, NULL, NULL, NULL, NULL, 4),
(130008, NULL, 'G3DSA:3.60.40.10:FF:000355', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130009, NULL, 'G3DSA:3.30.70.330:FF:002784', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130010, NULL, 'G3DSA:1.25.10.10:FF:002232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130011, NULL, 'G3DSA:2.40.128.260:FF:000002', NULL, NULL, 'Type IV secretion system protein VirB10', NULL, NULL, NULL, NULL, NULL, 4),
(130012, NULL, 'G3DSA:1.20.58.80:FF:000001', NULL, NULL, 'PTS system, lactose-specific IIa component', NULL, NULL, NULL, NULL, NULL, 4),
(130013, NULL, 'G3DSA:3.30.360.10:FF:000037', NULL, NULL, '4-hydroxy-tetrahydrodipicolinate reductase 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(130014, NULL, 'G3DSA:3.40.710.10:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130015, NULL, 'G3DSA:1.10.510.10:FF:003389', NULL, NULL, 'AGAP001933-PA', NULL, NULL, NULL, NULL, NULL, 4),
(130016, NULL, 'G3DSA:3.20.20.80:FF:000831', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130017, NULL, 'G3DSA:3.30.200.20:FF:001018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130018, NULL, 'G3DSA:3.20.20.140:FF:000050', NULL, NULL, 'Adenosine/AMP deaminase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(130019, NULL, 'G3DSA:3.30.40.10:FF:000659', NULL, NULL, 'Peroxisome assembly protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(130020, NULL, 'G3DSA:3.90.245.10:FF:000037', NULL, NULL, 'Putative inosine-uridine preferring nucleoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(130021, NULL, 'G3DSA:1.10.506.10:FF:000001', NULL, NULL, 'Ras GTPase-activating protein nGAP isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(130022, NULL, 'G3DSA:1.10.238.10:FF:000237', NULL, NULL, 'Calcium-binding protein CML38', NULL, NULL, NULL, NULL, NULL, 4),
(130023, NULL, 'G3DSA:3.30.300.70:FF:000001', NULL, NULL, 'Ribosome maturation factor RimP', NULL, NULL, NULL, NULL, NULL, 4),
(130024, NULL, 'G3DSA:3.30.60.90:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130025, NULL, 'G3DSA:3.30.160.60:FF:003398', NULL, NULL, 'AGAP000062-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(130026, NULL, 'G3DSA:2.60.40.10:FF:004112', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130027, NULL, 'G3DSA:3.30.70.250:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130028, NULL, 'G3DSA:3.30.2410.10:FF:000047', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(130029, NULL, 'G3DSA:1.10.8.60:FF:000323', NULL, NULL, 'Putative vesicular transport protein (CDC48 homologue)', NULL, NULL, NULL, NULL, NULL, 4),
(130030, NULL, 'G3DSA:2.60.220.50:FF:000076', NULL, NULL, 'Latrophilin-like protein LAT-2', NULL, NULL, NULL, NULL, NULL, 4),
(130031, NULL, 'G3DSA:3.80.10.10:FF:000779', NULL, NULL, 'Probable inactive serine/threonine-protein kinase DDB_G0278909', NULL, NULL, NULL, NULL, NULL, 4),
(130032, NULL, 'G3DSA:3.80.10.10:FF:002488', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130033, NULL, 'G3DSA:3.40.120.10:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130034, NULL, 'G3DSA:1.20.58.390:FF:000143', NULL, NULL, '5-hydroxytryptamine receptor 3D', NULL, NULL, NULL, NULL, NULL, 4),
(130035, NULL, 'G3DSA:2.60.40.150:FF:000220', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(130036, NULL, 'G3DSA:1.25.40.10:FF:001750', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130037, NULL, 'G3DSA:2.10.25.10:FF:000942', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(130038, NULL, 'G3DSA:1.25.40.20:FF:001753', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130039, NULL, 'G3DSA:1.10.3730.20:FF:000007', NULL, NULL, 'Multidrug ABC transporter', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(130040, NULL, 'G3DSA:3.30.70.240:FF:000020', NULL, NULL, 'Translation factor GUF1 homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(130041, NULL, 'G3DSA:1.20.5.170:FF:000128', NULL, NULL, 'Citron rho-interacting serine/threonine kinase b', NULL, NULL, NULL, NULL, NULL, 4),
(130042, NULL, 'G3DSA:1.10.8.60:FF:000380', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(130043, NULL, 'G3DSA:3.70.10.10:FF:000066', NULL, NULL, 'Rad9-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(130044, NULL, 'G3DSA:1.25.10.10:FF:000141', NULL, NULL, 'rap1 GTPase-GDP dissociation stimulator 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(130045, NULL, 'G3DSA:3.40.50.300:FF:007176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130046, NULL, 'G3DSA:3.40.630.10:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130047, NULL, 'G3DSA:1.20.5.110:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130048, NULL, 'G3DSA:3.40.1390.30:FF:000020', NULL, NULL, 'Metal-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(130049, NULL, 'G3DSA:1.10.565.10:FF:000132', NULL, NULL, 'uncharacterized protein LOC100187213', NULL, NULL, NULL, NULL, NULL, 4),
(130050, NULL, 'G3DSA:1.10.510.10:FF:004440', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130051, NULL, 'G3DSA:1.20.1250.20:FF:000743', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(130052, NULL, 'G3DSA:2.60.210.10:FF:000086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130053, NULL, 'G3DSA:3.40.50.300:FF:006512', NULL, NULL, 'ATP-dependent RNA helicase DDX3X', NULL, NULL, NULL, NULL, NULL, 4),
(130054, NULL, 'G3DSA:3.30.1330.40:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130055, NULL, 'G3DSA:3.50.30.30:FF:000153', NULL, NULL, 'Gll4423 protein', NULL, NULL, NULL, NULL, NULL, 4),
(130056, NULL, 'G3DSA:1.10.10.440:FF:000024', NULL, NULL, 'Pre-mRNA-processing protein 40A', NULL, NULL, NULL, NULL, NULL, 4),
(130057, NULL, 'G3DSA:3.40.980.10:FF:000020', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(130058, NULL, 'G3DSA:2.20.100.10:FF:000171', NULL, NULL, 'Thrombospondin type 1 domain containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(130059, NULL, 'G3DSA:1.20.58.60:FF:000580', NULL, NULL, 'Plectin', NULL, NULL, NULL, NULL, NULL, 4),
(130060, NULL, 'G3DSA:1.20.5.350:FF:000002', NULL, NULL, 'troponin I, fast skeletal muscle', NULL, NULL, NULL, NULL, NULL, 4),
(130061, NULL, 'G3DSA:2.130.10.10:FF:003365', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130062, NULL, 'G3DSA:1.25.10.10:FF:003159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130063, NULL, 'G3DSA:1.10.220.70:FF:000001', NULL, NULL, 'Ethanolamine ammonia-lyase heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(130064, NULL, 'G3DSA:1.10.10.10:FF:001708', NULL, NULL, 'Probable nitrogen assimilation transcriptional activator', NULL, NULL, NULL, NULL, NULL, 4),
(130065, NULL, 'G3DSA:1.10.630.10:FF:000525', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130066, NULL, 'G3DSA:3.40.630.30:FF:000208', NULL, NULL, 'Acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(130067, NULL, 'G3DSA:3.30.70.1730:FF:000018', NULL, NULL, '50S ribosomal protein L10', NULL, NULL, NULL, NULL, NULL, 4),
(130068, NULL, 'G3DSA:3.30.200.20:FF:001075', NULL, NULL, 'Snf1-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(130069, NULL, 'G3DSA:2.40.50.140:FF:000881', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130070, NULL, 'G3DSA:1.20.1070.10:FF:001305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130071, NULL, 'G3DSA:2.40.70.10:FF:000152', NULL, NULL, 'Protease', NULL, NULL, NULL, NULL, NULL, 4),
(130072, NULL, 'G3DSA:2.60.40.10:FF:005247', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130073, NULL, 'G3DSA:3.50.50.60:FF:000489', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(130074, NULL, 'G3DSA:3.40.50.2300:FF:000636', NULL, NULL, 'GLutamate Receptor family (AMPA)', NULL, NULL, NULL, NULL, NULL, 4),
(130075, NULL, 'G3DSA:1.10.287.950:FF:000014', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(130076, NULL, 'G3DSA:3.80.10.10:FF:003005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130077, NULL, 'G3DSA:1.10.555.10:FF:000160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130078, NULL, 'G3DSA:2.60.120.10:FF:000056', NULL, NULL, 'Acireductone dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(130079, NULL, 'G3DSA:3.50.50.60:FF:000112', NULL, NULL, 'FAD-dependent oxidoreductase domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(130080, NULL, 'G3DSA:2.130.10.10:FF:001274', NULL, NULL, 'WD_domain_-_G-beta_repeat/Utp21_specific_WD40_ass ociated_putative_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(130081, NULL, 'G3DSA:3.90.45.10:FF:000016', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(130082, NULL, 'G3DSA:3.40.50.720:FF:002333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130083, NULL, 'G3DSA:1.10.287.600:FF:000022', NULL, NULL, 'Alpha tubulin,putative', NULL, NULL, NULL, NULL, NULL, 4),
(130084, NULL, 'G3DSA:3.90.70.10:FF:000501', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 36', NULL, NULL, NULL, NULL, NULL, 4),
(130085, NULL, 'G3DSA:3.40.50.150:FF:001274', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130086, NULL, 'G3DSA:3.40.50.1100:FF:000057', NULL, NULL, 'Threonine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(130087, NULL, 'G3DSA:3.40.50.800:FF:000114', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(130088, NULL, 'G3DSA:3.40.20.10:FF:000164', NULL, NULL, 'ABR105Cp', NULL, NULL, NULL, NULL, NULL, 4),
(130089, NULL, 'G3DSA:1.20.120.350:FF:000001', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(130090, NULL, 'G3DSA:3.60.21.10:FF:000024', NULL, NULL, 'Vacuolar protein sorting-associated protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(130091, NULL, 'G3DSA:1.20.120.360:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130092, NULL, 'G3DSA:3.30.160.60:FF:001953', NULL, NULL, 'Zinc finger protein 221', NULL, NULL, NULL, NULL, NULL, 4),
(130093, NULL, 'G3DSA:3.10.129.10:FF:000235', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(130094, NULL, 'G3DSA:1.25.40.10:FF:003195', NULL, NULL, 'YALI0A15686p', NULL, NULL, NULL, NULL, NULL, 4),
(130095, NULL, 'G3DSA:1.10.287.1490:FF:000020', NULL, NULL, 'TBC1 domain family member 2B isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(130096, NULL, 'G3DSA:2.10.25.10:FF:001398', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130097, NULL, 'G3DSA:3.40.50.720:FF:002479', NULL, NULL, 'Putative enoyl-CoA hydratase/Enoyl-CoA isomerase/3-hydroxyacyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(130098, NULL, 'G3DSA:1.25.40.10:FF:003515', NULL, NULL, 'Histone demethylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130099, NULL, 'G3DSA:1.20.1410.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130100, NULL, 'G3DSA:3.30.1240.10:FF:000073', NULL, NULL, 'Hydrolase (HAD superfamily)', NULL, NULL, NULL, NULL, NULL, 4),
(130101, NULL, 'G3DSA:3.30.1330.120:FF:000002', NULL, NULL, 'Aconitate decarboxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(130102, NULL, 'G3DSA:2.60.120.10:FF:000320', NULL, NULL, 'Oxalate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(130103, NULL, 'G3DSA:1.10.3520.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130104, NULL, 'G3DSA:3.40.50.450:FF:000054', NULL, NULL, 'Phosphofructokinase, platelet', NULL, NULL, NULL, NULL, NULL, 4),
(130105, NULL, 'G3DSA:3.60.20.10:FF:000146', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130106, NULL, 'G3DSA:3.30.70.330:FF:002458', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(130107, NULL, 'G3DSA:3.40.50.1820:FF:000947', NULL, NULL, 'Alpha/beta hydrolase family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130108, NULL, 'G3DSA:3.80.10.10:FF:003859', NULL, NULL, 'AGAP012385-PA', NULL, NULL, NULL, NULL, NULL, 4),
(130109, NULL, 'G3DSA:3.40.50.1000:FF:000061', NULL, NULL, 'Histidine biosynthesis bifunctional protein HisB', NULL, NULL, NULL, NULL, NULL, 4),
(130110, NULL, 'G3DSA:3.30.160.60:FF:006006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130111, NULL, 'G3DSA:3.40.50.720:FF:000388', NULL, NULL, 'Cinnamoyl-CoA reductase-like SNL6', NULL, NULL, NULL, NULL, NULL, 4),
(130112, NULL, 'G3DSA:3.30.420.610:FF:000020', NULL, NULL, 'Maternal effect protein oskar', NULL, NULL, NULL, NULL, NULL, 4),
(130113, NULL, 'G3DSA:3.50.50.60:FF:000697', NULL, NULL, 'Blr3003 protein', NULL, NULL, NULL, NULL, NULL, 4),
(130114, NULL, 'G3DSA:2.60.40.10:FF:000104', NULL, NULL, 'Down syndrome cell adhesion molecule b', NULL, NULL, NULL, NULL, NULL, 4),
(130115, NULL, 'G3DSA:1.20.1740.10:FF:000053', NULL, NULL, 'Cationic amino acid transporter 3', NULL, NULL, NULL, NULL, NULL, 4),
(130116, NULL, 'G3DSA:3.20.20.140:FF:000196', NULL, NULL, 'Ribonuclease P protein component 3', NULL, NULL, NULL, NULL, NULL, 4),
(130117, NULL, 'G3DSA:3.40.50.1010:FF:000064', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(130118, NULL, 'G3DSA:1.25.40.10:FF:000935', NULL, NULL, 'Predicted TPR repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(130119, NULL, 'G3DSA:3.40.50.300:FF:005905', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(130120, NULL, 'G3DSA:3.30.230.80:FF:000032', NULL, NULL, 'Heat shock protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130121, NULL, 'G3DSA:1.10.30.10:FF:000136', NULL, NULL, 'HMG1/2 (High mobility group) box-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(130122, NULL, 'G3DSA:1.10.510.10:FF:001208', NULL, NULL, 'Cyclin dependent kinase 20', NULL, NULL, NULL, NULL, NULL, 4),
(130123, NULL, 'G3DSA:1.25.40.10:FF:002060', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g04810, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(130124, NULL, 'G3DSA:1.20.58.60:FF:000669', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130125, NULL, 'G3DSA:1.20.5.370:FF:000008', NULL, NULL, 'Myosin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(130126, NULL, 'G3DSA:3.50.50.60:FF:001006', NULL, NULL, 'AMine oXidase family', NULL, NULL, NULL, NULL, NULL, 4),
(130127, NULL, 'G3DSA:3.40.50.150:FF:001627', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130128, NULL, 'G3DSA:1.10.287.70:FF:000161', NULL, NULL, 'Intermediate conductance calcium-activated potassium channel protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(130129, NULL, 'G3DSA:3.40.50.410:FF:000093', NULL, NULL, 'Transcription initiation factor TFIIH subunit', NULL, NULL, NULL, NULL, NULL, 4),
(130130, NULL, 'G3DSA:3.90.940.40:FF:000004', NULL, NULL, 'Protein CHLORORESPIRATORY REDUCTION 7 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(130131, NULL, 'G3DSA:4.10.910.10:FF:000007', NULL, NULL, '37S ribosomal protein subunit sws2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(130132, NULL, 'G3DSA:1.10.10.10:FF:001355', NULL, NULL, 'Telomere repeat-binding factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(130133, NULL, 'G3DSA:1.25.40.10:FF:000699', NULL, NULL, 'Pentatricopeptide repeat domain 2, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(130134, NULL, 'G3DSA:1.10.1740.10:FF:000033', NULL, NULL, 'Probable sigma-70 factor, ECF subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(130135, NULL, 'G3DSA:1.20.1720.10:FF:000052', NULL, NULL, 'Bcr/CflA family efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(130136, NULL, 'G3DSA:1.20.1310.10:FF:000032', NULL, NULL, 'Anaphase-promoting complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(130137, NULL, 'G3DSA:1.20.1560.10:FF:000455', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130138, NULL, 'G3DSA:1.20.1310.20:FF:000035', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(130139, NULL, 'G3DSA:1.25.40.1030:FF:000020', NULL, NULL, 'Yeast SEC homolog', NULL, NULL, NULL, NULL, NULL, 4),
(130140, NULL, 'G3DSA:3.20.20.370:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130141, NULL, 'G3DSA:2.30.31.10:FF:000012', NULL, NULL, 'Transcriptional Coactivator p15-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(130142, NULL, 'G3DSA:1.20.1070.10:FF:000434', NULL, NULL, 'Lysophosphatidic acid receptor 5a', NULL, NULL, NULL, NULL, NULL, 4),
(130143, NULL, 'G3DSA:3.40.50.1820:FF:000239', NULL, NULL, 'Peptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130144, NULL, 'G3DSA:2.60.40.10:FF:000161', NULL, NULL, 'Leucine rich repeats and immunoglobulin like domains 2', NULL, NULL, NULL, NULL, NULL, 4),
(130145, NULL, 'G3DSA:3.20.20.60:FF:000027', NULL, NULL, 'Pyruvate kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(130146, NULL, 'G3DSA:2.130.10.10:FF:003573', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130147, NULL, 'G3DSA:1.25.10.10:FF:001361', NULL, NULL, 'Apoptosis inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(130148, NULL, 'G3DSA:1.10.238.10:FF:000030', NULL, NULL, 'DCN1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(130149, NULL, 'G3DSA:2.30.30.30:FF:000122', NULL, NULL, '60S ribosomal protein L14-1', NULL, NULL, NULL, NULL, NULL, 4),
(130150, NULL, 'G3DSA:3.40.50.720:FF:002069', NULL, NULL, 'Carbonyl reductase 4', NULL, NULL, NULL, NULL, NULL, 4),
(130151, NULL, 'G3DSA:1.20.5.170:FF:000246', NULL, NULL, 'UPF0612 protein C569.003', NULL, NULL, NULL, NULL, NULL, 4),
(130152, NULL, 'G3DSA:1.25.40.170:FF:000006', NULL, NULL, 'Smaug', NULL, NULL, NULL, NULL, NULL, 4),
(130153, NULL, 'G3DSA:1.25.40.180:FF:000009', NULL, NULL, 'programmed cell death protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(130154, NULL, 'G3DSA:2.40.50.140:FF:000937', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130155, NULL, 'G3DSA:3.80.10.10:FF:002724', NULL, NULL, 'Probable inactive leucine-rich repeat receptor-like protein kinase At3g03770', NULL, NULL, NULL, NULL, NULL, 4),
(130156, NULL, 'G3DSA:3.30.70.330:FF:000867', NULL, NULL, 'RNA-binding protein squid', NULL, NULL, NULL, NULL, NULL, 4),
(130157, NULL, 'G3DSA:1.10.530.10:FF:000046', NULL, NULL, 'Lytic murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(130158, NULL, 'G3DSA:3.40.720.10:FF:000063', NULL, NULL, 'Alkaline phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(130159, NULL, 'G3DSA:1.20.140.10:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130160, NULL, 'G3DSA:3.30.420.10:FF:000363', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130161, NULL, 'G3DSA:3.30.40.10:FF:001969', NULL, NULL, 'Putative E3 ubiquitin-protein ligase UBR7-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(130162, NULL, 'G3DSA:1.20.1070.10:FF:001423', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(130163, NULL, 'G3DSA:1.10.510.10:FF:001944', NULL, NULL, 'Salt-inducible kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(130164, NULL, 'G3DSA:2.30.30.40:FF:000125', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(130165, NULL, 'G3DSA:1.10.8.10:FF:000095', NULL, NULL, 'Uncharacterized protein, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(130166, NULL, 'G3DSA:3.30.40.10:FF:000188', NULL, NULL, 'RING finger and CHY zinc finger domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(130167, NULL, 'G3DSA:3.30.70.260:FF:000026', NULL, NULL, 'Homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(130168, NULL, 'G3DSA:1.25.40.470:FF:000063', NULL, NULL, 'AGAP010418-PA', NULL, NULL, NULL, NULL, NULL, 4),
(130169, NULL, 'G3DSA:3.30.160.60:FF:005753', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130170, NULL, 'G3DSA:3.40.1110.10:FF:000314', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130171, NULL, 'G3DSA:1.25.40.120:FF:000042', NULL, NULL, 'Geranylgeranyl transferase type-2 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(130172, NULL, 'G3DSA:2.130.10.10:FF:005017', NULL, NULL, 'WD repeat domain 90', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(130173, NULL, 'G3DSA:3.80.10.10:FF:000690', NULL, NULL, 'F-box/LRR-repeat protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(130174, NULL, 'G3DSA:3.30.70.100:FF:000118', NULL, NULL, 'Ssr2857 protein', NULL, NULL, NULL, NULL, NULL, 4),
(130175, NULL, 'G3DSA:1.20.1110.10:FF:000051', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(130176, NULL, 'G3DSA:3.80.10.10:FF:000633', NULL, NULL, 'Blast:Protein slit', NULL, NULL, NULL, NULL, NULL, 4),
(130177, NULL, 'G3DSA:3.40.50.300:FF:001454', NULL, NULL, 'Dynein heavy chain 12, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(130178, NULL, 'G3DSA:3.40.50.300:FF:007440', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130179, NULL, 'G3DSA:3.30.2080.10:FF:000004', NULL, NULL, 'Carbohydrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(130180, NULL, 'G3DSA:2.30.42.10:FF:000447', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130181, NULL, 'G3DSA:1.10.10.10:FF:001916', NULL, NULL, 'MarR family transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(130182, NULL, 'G3DSA:3.40.1500.10:FF:000012', NULL, NULL, 'Oxygen-dependent coproporphyrinogen-III oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(130183, NULL, 'G3DSA:3.30.110.10:FF:000019', NULL, NULL, 'Probable mitochondrial translation initiation factor', NULL, NULL, NULL, NULL, NULL, 4),
(130184, NULL, 'G3DSA:3.40.50.300:FF:003606', NULL, NULL, 'ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(130185, NULL, 'G3DSA:2.60.40.10:FF:005039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130186, NULL, 'G3DSA:1.20.1070.10:FF:002087', NULL, NULL, 'RE24343p', NULL, NULL, NULL, NULL, NULL, 4),
(130187, NULL, 'G3DSA:2.80.10.50:FF:000102', NULL, NULL, 'Ryanodine receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(130188, NULL, 'G3DSA:3.30.160.380:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130189, NULL, 'G3DSA:1.20.1110.10:FF:000022', NULL, NULL, 'copper-transporting ATPase 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(130190, NULL, 'G3DSA:1.10.3720.10:FF:000032', NULL, NULL, 'General amino acid ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(130191, NULL, 'G3DSA:3.30.160.60:FF:003662', NULL, NULL, 'GM15530', NULL, NULL, NULL, NULL, NULL, 4),
(130192, NULL, 'G3DSA:3.30.60.30:FF:000144', NULL, NULL, 'follistatin-related protein 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(130193, NULL, 'G3DSA:3.20.20.70:FF:000648', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130194, NULL, 'G3DSA:3.40.50.2300:FF:001507', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130195, NULL, 'G3DSA:2.130.10.10:FF:004180', NULL, NULL, 'WD-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130196, NULL, 'G3DSA:2.60.40.10:FF:003595', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130197, NULL, 'G3DSA:3.90.1150.80:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130198, NULL, 'G3DSA:1.20.1250.20:FF:002188', NULL, NULL, 'Solute carrier family 2, facilitated glucose transporter member 4', NULL, NULL, NULL, NULL, NULL, 4),
(130199, NULL, 'G3DSA:3.20.20.220:FF:000040', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(130200, NULL, 'G3DSA:2.60.34.10:FF:000101', NULL, NULL, 'Heat shock protein belonging to the HSP70 family', NULL, NULL, NULL, NULL, NULL, 4),
(130201, NULL, 'G3DSA:3.60.21.10:FF:000232', NULL, NULL, 'Serine/threonine phosphatase type 1', NULL, NULL, NULL, NULL, NULL, 4),
(130202, NULL, 'G3DSA:1.20.920.10:FF:000074', NULL, NULL, 'Chromatin structure-remodeling complex subunit RSC4', NULL, NULL, NULL, NULL, NULL, 4),
(130203, NULL, 'G3DSA:1.20.58.1220:FF:000014', NULL, NULL, 'Putative exocyst complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(130204, NULL, 'G3DSA:3.60.20.10:FF:000180', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130205, NULL, 'G3DSA:2.130.10.10:FF:003926', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130206, NULL, 'G3DSA:1.20.1280.290:FF:000065', NULL, NULL, 'LOC100036889 protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(130207, NULL, 'G3DSA:3.90.230.10:FF:000014', NULL, NULL, 'Aminopeptidase P family protein', NULL, NULL, NULL, NULL, NULL, 4),
(130208, NULL, 'G3DSA:1.25.40.470:FF:000006', NULL, NULL, 'WD repeat-containing protein 19 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(130209, NULL, 'G3DSA:3.40.30.10:FF:000462', NULL, NULL, 'Thioredoxin 3', NULL, NULL, NULL, NULL, NULL, 4),
(130210, NULL, 'G3DSA:3.20.70.20:FF:000013', NULL, NULL, 'YjjI family glycine radical enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(130211, NULL, 'G3DSA:2.60.120.10:FF:000466', NULL, NULL, 'Gll3853 protein', NULL, NULL, NULL, NULL, NULL, 4),
(130212, NULL, 'G3DSA:1.20.1250.20:FF:000390', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(130213, NULL, 'G3DSA:1.10.238.10:FF:001165', NULL, NULL, 'Putative calmodulin-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(130214, NULL, 'G3DSA:3.30.900.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130215, NULL, 'G3DSA:1.25.40.480:FF:000009', NULL, NULL, 'Fance protein', NULL, NULL, NULL, NULL, NULL, 4),
(130216, NULL, 'G3DSA:1.10.510.10:FF:003625', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130217, NULL, 'G3DSA:2.30.29.30:FF:000815', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130218, NULL, 'G3DSA:2.30.110.10:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130219, NULL, 'G3DSA:1.10.101.10:FF:000016', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(130220, NULL, 'G3DSA:3.30.160.60:FF:005814', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130221, NULL, 'G3DSA:2.40.10.10:FF:000412', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130222, NULL, 'G3DSA:2.30.30.140:FF:000216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130223, NULL, 'G3DSA:3.30.1370.210:FF:000015', NULL, NULL, 'putative ATP-dependent RNA helicase DHX57', NULL, NULL, NULL, NULL, NULL, 4),
(130224, NULL, 'G3DSA:1.25.10.10:FF:003160', NULL, NULL, 'Ubiquitin-binding serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(130225, NULL, 'G3DSA:3.40.50.720:FF:000888', NULL, NULL, 'Myo-inositol-1-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(130226, NULL, 'G3DSA:3.40.50.1820:FF:000739', NULL, NULL, 'Protein CBG14567', NULL, NULL, NULL, NULL, NULL, 4),
(130227, NULL, 'G3DSA:3.20.20.140:FF:000460', NULL, NULL, 'Periplasmic amidohydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(130228, NULL, 'G3DSA:1.20.58.1210:FF:000011', NULL, NULL, 'Exocyst complex component 8', NULL, NULL, NULL, NULL, NULL, 4),
(130229, NULL, 'G3DSA:3.30.70.330:FF:002666', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130230, NULL, 'G3DSA:1.10.287.130:FF:000241', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(130231, NULL, 'G3DSA:1.20.58.80:FF:000063', NULL, NULL, 'Ubiquitin Specific Protease', NULL, NULL, NULL, NULL, NULL, 4),
(130232, NULL, 'G3DSA:3.30.200.20:FF:001428', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130233, NULL, 'G3DSA:2.60.120.290:FF:000193', NULL, NULL, 'AGAP005526-PA', NULL, NULL, NULL, NULL, NULL, 4),
(130234, NULL, 'G3DSA:3.40.630.30:FF:000360', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130235, NULL, 'G3DSA:1.10.10.2360:FF:000004', NULL, NULL, 'Nuclear pore complex protein Nup98-Nup96', NULL, NULL, NULL, NULL, NULL, 4),
(130236, NULL, 'G3DSA:2.60.120.1440:FF:000003', NULL, NULL, 'Sigma factor regulatory protein, FecR/PupR family', NULL, NULL, NULL, NULL, NULL, 4),
(130237, NULL, 'G3DSA:3.90.640.10:FF:000181', NULL, NULL, 'AaceriACR184Cp', NULL, NULL, NULL, NULL, NULL, 4),
(130238, NULL, 'G3DSA:2.60.40.10:FF:003656', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130239, NULL, 'G3DSA:2.60.120.10:FF:000820', NULL, NULL, 'ADR385Wp', NULL, NULL, NULL, NULL, NULL, 4),
(130240, NULL, 'G3DSA:3.20.20.80:FF:000067', NULL, NULL, 'Glucan 1,3-beta-glucosidase A', NULL, NULL, NULL, NULL, NULL, 4),
(130241, NULL, 'G3DSA:3.80.10.10:FF:000897', NULL, NULL, 'Leucine Rich Repeat family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(130242, NULL, 'G3DSA:3.30.160.60:FF:001392', NULL, NULL, 'zinc finger protein 34 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(130243, NULL, 'G3DSA:1.25.40.20:FF:000382', NULL, NULL, 'Ankyrin repeat domain-containing protein 42', NULL, NULL, NULL, NULL, NULL, 4),
(130244, NULL, 'G3DSA:3.30.810.10:FF:000027', NULL, NULL, 'Phosphatidylinositol-5-phosphate 4-kinase, type II, alpha a', NULL, NULL, NULL, NULL, NULL, 4),
(130245, NULL, 'G3DSA:3.30.9.10:FF:000216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130246, NULL, 'G3DSA:3.30.200.20:FF:000765', NULL, NULL, 'Cdc7 kinase, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(130247, NULL, 'G3DSA:2.60.120.970:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130248, NULL, 'G3DSA:3.80.10.10:FF:004169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130249, NULL, 'G3DSA:3.40.50.150:FF:000700', NULL, NULL, 'Methyltransferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(130250, NULL, 'G3DSA:3.40.50.300:FF:002117', NULL, NULL, 'Axonemal dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(130251, NULL, 'G3DSA:3.40.50.150:FF:001835', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130252, NULL, 'G3DSA:2.40.50.140:FF:000729', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130253, NULL, 'G3DSA:2.70.98.20:FF:000032', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(130254, NULL, 'G3DSA:2.60.40.10:FF:000722', NULL, NULL, 'Tenascin R', NULL, NULL, NULL, NULL, NULL, 4),
(130255, NULL, 'G3DSA:3.20.20.70:FF:000064', NULL, NULL, 'Thiamine-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(130256, NULL, 'G3DSA:1.20.5.700:FF:000006', NULL, NULL, 'Cytochrome b6-f complex iron-sulfur subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(130257, NULL, 'G3DSA:3.30.300.160:FF:000004', NULL, NULL, 'Type II secretory pathway ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(130258, NULL, 'G3DSA:2.130.10.10:FF:001156', NULL, NULL, 'Syntaxin-binding protein 5 isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(130259, NULL, 'G3DSA:3.30.160.60:FF:000110', NULL, NULL, 'Zinc finger protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(130260, NULL, 'G3DSA:2.60.15.10:FF:000029', NULL, NULL, 'ATP synthase epsilon chain', NULL, NULL, NULL, NULL, NULL, 4),
(130261, NULL, 'G3DSA:2.70.150.10:FF:000123', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(130262, NULL, 'G3DSA:3.40.605.10:FF:000104', NULL, NULL, 'ALdehyde deHydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(130263, NULL, 'G3DSA:2.60.120.470:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130264, NULL, 'G3DSA:3.30.300.150:FF:000001', NULL, NULL, 'DNA polymerase III subunit gamma/tau', NULL, NULL, NULL, NULL, NULL, 4),
(130265, NULL, 'G3DSA:1.20.5.710:FF:000009', NULL, NULL, 'Ribosomal protein L12-B', NULL, NULL, NULL, NULL, NULL, 4),
(130266, NULL, 'G3DSA:2.60.120.380:FF:000039', NULL, NULL, 'Putative calpain', NULL, NULL, NULL, NULL, NULL, 4),
(130267, NULL, 'G3DSA:3.30.70.330:FF:001531', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130268, NULL, 'G3DSA:4.10.280.10:FF:000099', NULL, NULL, 'Myc-family transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(130269, NULL, 'G3DSA:3.40.50.1440:FF:000018', NULL, NULL, 'Tubulin beta chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130270, NULL, 'G3DSA:2.40.50.1070:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130271, NULL, 'G3DSA:3.40.20.10:FF:000135', NULL, NULL, 'Twinfilin-2', NULL, NULL, NULL, NULL, NULL, 4),
(130272, NULL, 'G3DSA:3.80.10.10:FF:000279', NULL, NULL, 'Oligodendrocyte-myelin glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(130273, NULL, 'G3DSA:3.30.70.360:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130274, NULL, 'G3DSA:3.30.70.1230:FF:000082', NULL, NULL, 'Adenylate cyclase type 6', NULL, NULL, NULL, NULL, NULL, 4),
(130275, NULL, 'G3DSA:3.40.50.740:FF:000017', NULL, NULL, 'NADH-quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(130276, NULL, 'G3DSA:2.30.110.10:FF:000034', NULL, NULL, 'BnaC05g47660D protein', NULL, NULL, NULL, NULL, NULL, 4),
(130277, NULL, 'G3DSA:1.25.40.20:FF:001871', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130278, NULL, 'G3DSA:1.20.5.170:FF:000280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130279, NULL, 'G3DSA:1.20.5.110:FF:000335', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130280, NULL, 'G3DSA:1.10.390.10:FF:000102', NULL, NULL, 'RE34731p', NULL, NULL, NULL, NULL, NULL, 4),
(130281, NULL, 'G3DSA:3.80.10.10:FF:000425', NULL, NULL, 'Leucine-rich repeat-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(130282, NULL, 'G3DSA:3.30.930.10:FF:000093', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(130283, NULL, 'G3DSA:1.10.357.20:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130284, NULL, 'G3DSA:3.30.200.20:FF:001670', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130285, NULL, 'G3DSA:3.90.1530.10:FF:000019', NULL, NULL, 'Plasmid partitioning protein', NULL, NULL, NULL, NULL, NULL, 4),
(130286, NULL, 'G3DSA:3.40.47.10:FF:000169', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase', NULL, NULL, NULL, NULL, NULL, 4),
(130287, NULL, 'G3DSA:1.20.1050.10:FF:000079', NULL, NULL, 'Glutathione S-transferase Gst', NULL, NULL, NULL, NULL, NULL, 4),
(130288, NULL, 'G3DSA:1.20.1610.10:FF:000015', NULL, NULL, 'Putative alpha-1,2-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(130289, NULL, 'G3DSA:3.30.40.10:FF:001205', NULL, NULL, 'GM18390', NULL, NULL, NULL, NULL, NULL, 4),
(130290, NULL, 'G3DSA:1.25.40.10:FF:002998', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g60960, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(130291, NULL, 'G3DSA:3.30.160.60:FF:005343', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130292, NULL, 'G3DSA:1.20.1250.10:FF:000145', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130293, NULL, 'G3DSA:2.70.98.30:FF:000035', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(130294, NULL, 'G3DSA:3.30.470.10:FF:000012', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(130295, NULL, 'G3DSA:3.30.160.20:FF:000059', NULL, NULL, 'DExH-box ATP-dependent RNA helicase DExH3', NULL, NULL, NULL, NULL, NULL, 4),
(130296, NULL, 'G3DSA:1.25.40.10:FF:005140', NULL, NULL, 'DnaJ domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(130297, NULL, 'G3DSA:2.60.40.10:FF:003241', NULL, NULL, 'CD244 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(130298, NULL, 'G3DSA:3.80.10.10:FF:002224', NULL, NULL, 'Protein CBG17991', NULL, NULL, NULL, NULL, NULL, 4),
(130299, NULL, 'G3DSA:3.30.160.60:FF:005961', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130300, NULL, 'G3DSA:2.30.29.30:FF:000962', NULL, NULL, 'Sterol 3-beta-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(130301, NULL, 'G3DSA:3.90.70.10:FF:000878', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130302, NULL, 'G3DSA:2.60.40.10:FF:002521', NULL, NULL, 'Fibroblast growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(130303, NULL, 'G3DSA:1.10.8.10:FF:000207', NULL, NULL, 'UV excision repair RAD23 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130304, NULL, 'G3DSA:1.10.720.30:FF:000038', NULL, NULL, 'Myocardin related transcription factor Ba', NULL, NULL, NULL, NULL, NULL, 4),
(130305, NULL, 'G3DSA:3.40.50.12650:FF:000042', NULL, NULL, 'Artemis-related DNA-crosslink repair exonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(130306, NULL, 'G3DSA:2.20.28.230:FF:000001', NULL, NULL, 'Interleukin 15 receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(130307, NULL, 'G3DSA:3.30.390.10:FF:000011', NULL, NULL, 'Mandelate racemase/muconate lactonizing enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(130308, NULL, 'G3DSA:3.40.50.300:FF:003494', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(130309, NULL, 'G3DSA:1.20.1740.10:FF:000261', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130310, NULL, 'G3DSA:3.30.1370.10:FF:000077', NULL, NULL, 'vigilin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(130311, NULL, 'G3DSA:2.40.50.150:FF:000002', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(130312, NULL, 'G3DSA:3.90.190.10:FF:000016', NULL, NULL, 'receptor-type tyrosine-protein phosphatase gamma isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(130313, NULL, 'G3DSA:3.10.129.10:FF:000089', NULL, NULL, 'Putative esterase F42H10.6', NULL, NULL, NULL, NULL, NULL, 4),
(130314, NULL, 'G3DSA:2.170.150.80:FF:000030', NULL, NULL, 'NAC domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(130315, NULL, 'G3DSA:3.40.850.10:FF:000275', NULL, NULL, 'Myosin IK', NULL, NULL, NULL, NULL, NULL, 4),
(130316, NULL, 'G3DSA:1.10.533.10:FF:000114', NULL, NULL, 'Caspase Dronc', NULL, NULL, NULL, NULL, NULL, 4),
(130317, NULL, 'G3DSA:1.25.10.10:FF:001922', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130318, NULL, 'G3DSA:3.30.390.30:FF:000017', NULL, NULL, 'Mycothione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(130319, NULL, 'G3DSA:3.40.50.300:FF:001954', NULL, NULL, 'DEAD box helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130320, NULL, 'G3DSA:2.130.10.10:FF:001420', NULL, NULL, 'Small nucleolar ribonucleoprotein complex subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130321, NULL, 'G3DSA:3.40.1190.20:FF:000097', NULL, NULL, 'Hydroxymethylpyrimidine phosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(130322, NULL, 'G3DSA:3.30.70.1450:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130323, NULL, 'G3DSA:1.10.10.60:FF:001145', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130324, NULL, 'G3DSA:3.40.50.620:FF:000892', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(130325, NULL, 'G3DSA:3.80.10.10:FF:004433', NULL, NULL, 'Leucine-rich repeat receptor protein kinase EMS1', NULL, NULL, NULL, NULL, NULL, 4),
(130326, NULL, 'G3DSA:3.30.980.10:FF:000039', NULL, NULL, 'Alanyl-tRNA editing protein AlaX-S', NULL, NULL, NULL, NULL, NULL, 4),
(130327, NULL, 'G3DSA:1.25.40.10:FF:003925', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130328, NULL, 'G3DSA:3.30.40.10:FF:000952', NULL, NULL, 'Ubiquitin ligase E3 alpha, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130329, NULL, 'G3DSA:2.10.25.10:FF:000381', NULL, NULL, 'Low-density lipoprotein receptor-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(130330, NULL, 'G3DSA:1.20.58.2220:FF:000005', NULL, NULL, 'Formin 1', NULL, NULL, NULL, NULL, NULL, 4),
(130331, NULL, 'G3DSA:2.60.220.30:FF:000013', NULL, NULL, 'Unc-5 family C-terminal like', NULL, NULL, NULL, NULL, NULL, 4),
(130332, NULL, 'G3DSA:2.30.29.30:FF:001125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130333, NULL, 'G3DSA:1.10.555.10:FF:000159', NULL, NULL, 'T cell activation RhoGTPase-activating protein a', NULL, NULL, NULL, NULL, NULL, 4),
(130334, NULL, 'G3DSA:3.40.50.1820:FF:000891', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130335, NULL, 'G3DSA:1.50.40.10:FF:000135', NULL, NULL, 'Adenine nucleotide transporter', NULL, NULL, NULL, NULL, NULL, 4),
(130336, NULL, 'G3DSA:3.20.20.140:FF:000308', NULL, NULL, 'AMP deaminase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130337, NULL, 'G3DSA:2.60.220.50:FF:000019', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(130338, NULL, 'G3DSA:3.40.50.720:FF:000624', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(130339, NULL, 'G3DSA:1.20.1740.10:FF:000109', NULL, NULL, 'Na(+)-linked D-alanine glycine permease', NULL, NULL, NULL, NULL, NULL, 4),
(130340, NULL, 'G3DSA:3.40.50.300:FF:008311', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(130341, NULL, 'G3DSA:3.40.630.30:FF:000450', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(130342, NULL, 'G3DSA:3.90.850.10:FF:000016', NULL, NULL, '2-keto-4-pentenoate hydratase/2-oxohepta-3-ene-1,7-dioic acid hydratase (Catechol pathway)', NULL, NULL, NULL, NULL, NULL, 4),
(130343, NULL, 'G3DSA:1.10.4040.10:FF:000002', NULL, NULL, 'Penicillinase repressor BlaI', NULL, NULL, NULL, NULL, NULL, 4),
(130344, NULL, 'G3DSA:1.10.3810.10:FF:000005', NULL, NULL, 'Penicillin-binding protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(130345, NULL, 'G3DSA:1.10.600.10:FF:000018', NULL, NULL, 'Probable geranylgeranyl-diphosphate geranylgeranyltransferase (AL-2)', NULL, NULL, NULL, NULL, NULL, 4),
(130346, NULL, 'G3DSA:3.40.50.300:FF:001807', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(130347, NULL, 'G3DSA:2.130.10.10:FF:003308', NULL, NULL, 'Protein CBR-ELPC-2', NULL, NULL, NULL, NULL, NULL, 4),
(130348, NULL, 'G3DSA:3.30.40.10:FF:000598', NULL, NULL, 'E3 SUMO-protein ligase PIAS, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130349, NULL, 'G3DSA:1.10.1040.50:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130350, NULL, 'G3DSA:1.20.120.160:FF:000034', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(130351, NULL, 'G3DSA:1.10.520.10:FF:000017', NULL, NULL, 'Os01g0293900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(130352, NULL, 'G3DSA:4.10.410.10:FF:000043', NULL, NULL, 'CRE-MLT-11 protein', NULL, NULL, NULL, NULL, NULL, 4),
(130353, NULL, 'G3DSA:2.130.10.10:FF:001627', NULL, NULL, 'WD repeat-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130354, NULL, 'G3DSA:1.20.1270.60:FF:000262', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(130355, NULL, 'G3DSA:3.40.50.1820:FF:001144', NULL, NULL, 'Liver carboxylesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(130356, NULL, 'G3DSA:1.25.40.10:FF:001716', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g37230', NULL, NULL, NULL, NULL, NULL, 4),
(130357, NULL, 'G3DSA:1.10.630.10:FF:000464', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130358, NULL, 'G3DSA:2.60.40.10:FF:003802', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130359, NULL, 'G3DSA:2.40.50.140:FF:001044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130360, NULL, 'G3DSA:3.30.160.810:FF:000008', NULL, NULL, '50S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(130361, NULL, 'G3DSA:1.10.441.10:FF:000007', NULL, NULL, 'Mannose-6-phosphate isomerase type 1', NULL, NULL, NULL, NULL, NULL, 4),
(130362, NULL, 'G3DSA:1.10.150.50:FF:000079', NULL, NULL, 'transcription factor CP2-like protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(130363, NULL, 'G3DSA:3.10.50.40:FF:000046', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase NIMA-interacting 4', NULL, NULL, NULL, NULL, NULL, 4),
(130364, NULL, 'G3DSA:3.40.50.1220:FF:000037', NULL, NULL, 'Transcriptional regulatory protein sir2b', NULL, NULL, NULL, NULL, NULL, 4),
(130365, NULL, 'G3DSA:3.30.70.1230:FF:000172', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(130366, NULL, 'G3DSA:3.30.420.40:FF:000113', NULL, NULL, 'Heat shock 70 kDa protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(130367, NULL, 'G3DSA:2.60.40.150:FF:000012', NULL, NULL, 'Kinase C alpha type', NULL, NULL, NULL, NULL, NULL, 4),
(130368, NULL, 'G3DSA:2.10.70.10:FF:000013', NULL, NULL, 'Collagen, type I, alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(130369, NULL, 'G3DSA:1.25.40.20:FF:001719', NULL, NULL, 'Death-associated protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(130370, NULL, 'G3DSA:1.10.20.120:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130371, NULL, 'G3DSA:1.10.8.60:FF:000115', NULL, NULL, 'N-ethylmaleimide-sensitive fusion protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130372, NULL, 'G3DSA:2.10.25.10:FF:000588', NULL, NULL, 'Notch homolog 4, [Drosophila]', NULL, NULL, NULL, NULL, NULL, 4),
(130373, NULL, 'G3DSA:3.40.50.300:FF:006102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(130374, NULL, 'G3DSA:1.20.1250.20:FF:000861', NULL, NULL, 'Integral membrane transport protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130375, NULL, 'G3DSA:3.40.50.300:FF:007294', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130376, NULL, 'G3DSA:2.60.40.290:FF:000003', NULL, NULL, 'Secreted cellulose binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(130377, NULL, 'G3DSA:3.30.1120.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130378, NULL, 'G3DSA:2.40.50.1020:FF:000023', NULL, NULL, 'Putative response regulator of the competence regulon, ComE response regulator of sakacin A production', NULL, NULL, NULL, NULL, NULL, 4),
(130379, NULL, 'G3DSA:3.30.710.10:FF:000374', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130380, NULL, 'G3DSA:3.40.630.30:FF:000096', NULL, NULL, 'Mycothiol acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(130381, NULL, 'G3DSA:1.20.120.1080:FF:000025', NULL, NULL, 'Dosage compensation regulator', NULL, NULL, NULL, NULL, NULL, 4),
(130382, NULL, 'G3DSA:2.170.300.10:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130383, NULL, 'G3DSA:1.20.1250.20:FF:000709', NULL, NULL, 'Dityrosine transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(130384, NULL, 'G3DSA:2.60.40.10:FF:005394', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130385, NULL, 'G3DSA:3.10.20.90:FF:000065', NULL, NULL, 'Cordon-bleu WH2 repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(130386, NULL, 'G3DSA:3.30.160.60:FF:002116', NULL, NULL, 'Zinc finger protein 571', NULL, NULL, NULL, NULL, NULL, 4),
(130387, NULL, 'G3DSA:1.25.10.10:FF:003367', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130388, NULL, 'G3DSA:1.10.640.10:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130389, NULL, 'G3DSA:1.10.275.10:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130390, NULL, 'G3DSA:1.20.1270.290:FF:000001', NULL, NULL, 'MLLT3, super elongation complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(130391, NULL, 'G3DSA:1.10.3730.10:FF:000004', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(130392, NULL, 'G3DSA:1.20.1730.10:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130393, NULL, 'G3DSA:3.40.50.150:FF:000346', NULL, NULL, 'Phospholipid N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(130394, NULL, 'G3DSA:3.30.160.60:FF:004325', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130395, NULL, 'G3DSA:1.10.3860.10:FF:000008', NULL, NULL, 'Amino acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(130396, NULL, 'G3DSA:2.180.10.10:FF:000001', NULL, NULL, 'Teneurin transmembrane protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(130397, NULL, 'G3DSA:1.10.1620.20:FF:000004', NULL, NULL, 'Related to atp synthase epsilon chain, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(130398, NULL, 'G3DSA:1.10.287.130:FF:000095', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(130399, NULL, 'G3DSA:3.40.50.10860:FF:000033', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(130400, NULL, 'G3DSA:2.60.120.920:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130401, NULL, 'G3DSA:1.10.20.140:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130402, NULL, 'G3DSA:1.10.287.70:FF:000514', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130403, NULL, 'G3DSA:2.60.40.10:FF:001650', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(130404, NULL, 'G3DSA:3.80.10.10:FF:004079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130405, NULL, 'G3DSA:2.130.10.10:FF:001717', NULL, NULL, 'Angio-associated migratory cell protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130406, NULL, 'G3DSA:3.15.20.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(130407, NULL, 'G3DSA:2.60.40.60:FF:000012', NULL, NULL, 'Cadherin 24', NULL, NULL, NULL, NULL, NULL, 4),
(130408, NULL, 'G3DSA:3.40.1110.10:FF:000168', NULL, NULL, 'Cation transport ATPase, E1-E2 family', NULL, NULL, NULL, NULL, NULL, 4),
(130409, NULL, 'G3DSA:1.25.40.10:FF:003307', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g22830', NULL, NULL, NULL, NULL, NULL, 4),
(130410, NULL, 'G3DSA:1.10.1090.10:FF:000005', NULL, NULL, 'Ubiquinol-cytochrome c reductase complex 14kD subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130411, NULL, 'G3DSA:1.10.1750.10:FF:000005', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(130412, NULL, 'G3DSA:3.90.730.10:FF:000007', NULL, NULL, 'Ribonuclease T2', NULL, NULL, NULL, NULL, NULL, 4),
(130413, NULL, 'G3DSA:2.40.50.140:FF:001134', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130414, NULL, 'G3DSA:2.130.10.10:FF:003218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130415, NULL, 'G3DSA:2.40.50.140:FF:001191', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130416, NULL, 'G3DSA:3.40.50.12710:FF:000021', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7', NULL, NULL, NULL, NULL, NULL, 4),
(130417, NULL, 'G3DSA:3.40.50.410:FF:000149', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(130418, NULL, 'G3DSA:2.30.29.70:FF:000007', NULL, NULL, 'Proteasome complex subunit Rpn13 ubiquitin receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130419, NULL, 'G3DSA:3.90.810.10:FF:000008', NULL, NULL, 'wiskott-Aldrich syndrome protein', NULL, NULL, NULL, NULL, NULL, 4),
(130420, NULL, 'G3DSA:3.30.559.10:FF:000274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130421, NULL, 'G3DSA:1.25.40.10:FF:001155', NULL, NULL, 'Pentatricopeptide repeat protein PPR1106-17', NULL, NULL, NULL, NULL, NULL, 4),
(130422, NULL, 'G3DSA:3.30.200.20:FF:000855', NULL, NULL, 'Protein CBG11187', NULL, NULL, NULL, NULL, NULL, 4),
(130423, NULL, 'G3DSA:3.40.50.300:FF:006012', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(130424, NULL, 'G3DSA:2.10.25.10:FF:000324', NULL, NULL, 'Fibulin 2', NULL, NULL, NULL, NULL, NULL, 4),
(130425, NULL, 'G3DSA:2.130.10.10:FF:001774', NULL, NULL, 'Connector of kinase to AP-1, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(130426, NULL, 'G3DSA:3.30.420.40:FF:000023', NULL, NULL, 'Guanosine-5''-triphosphate,3''-diphosphate pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(130427, NULL, 'G3DSA:2.60.120.290:FF:000046', NULL, NULL, 'Attractin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(130428, NULL, 'G3DSA:1.25.40.10:FF:004589', NULL, NULL, 'Pentatricopeptide repeat-containing protein 4, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(130429, NULL, 'G3DSA:2.60.120.200:FF:000593', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130430, NULL, 'G3DSA:3.40.1190.20:FF:000209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130431, NULL, 'G3DSA:3.40.50.300:FF:006720', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130432, NULL, 'G3DSA:2.60.40.150:FF:000630', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130433, NULL, 'G3DSA:3.30.365.10:FF:000026', NULL, NULL, 'Xanthine dehydrogenase, molybdenum binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(130434, NULL, 'G3DSA:2.40.10.230:FF:000001', NULL, NULL, 'H/ACA ribonucleoprotein complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(130435, NULL, 'G3DSA:2.30.29.30:FF:000877', NULL, NULL, 'Pleckstrin homology domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(130436, NULL, 'G3DSA:1.10.8.480:FF:000010', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(130437, NULL, 'G3DSA:3.30.70.330:FF:002548', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130438, NULL, 'G3DSA:3.40.50.10380:FF:000013', NULL, NULL, 'Malic enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(130439, NULL, 'G3DSA:2.130.10.10:FF:003808', NULL, NULL, 'SVP1-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(130440, NULL, 'G3DSA:3.30.200.20:FF:001198', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(130441, NULL, 'G3DSA:1.20.1560.10:FF:000371', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130442, NULL, 'G3DSA:2.60.40.60:FF:000512', NULL, NULL, 'CaDHerin family', NULL, NULL, NULL, NULL, NULL, 4),
(130443, NULL, 'G3DSA:2.60.60.20:FF:000024', NULL, NULL, 'Lipoprotein lipase', NULL, NULL, NULL, NULL, NULL, 4),
(130444, NULL, 'G3DSA:2.60.120.10:FF:000410', NULL, NULL, 'cGMP-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(130445, NULL, 'G3DSA:2.40.10.240:FF:000004', NULL, NULL, 'S-adenosylmethionine:tRNA ribosyltransferase-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(130446, NULL, 'G3DSA:1.10.560.10:FF:000020', NULL, NULL, 'T-complex protein theta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(130447, NULL, 'G3DSA:3.40.1050.10:FF:000022', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(130448, NULL, 'G3DSA:3.40.50.300:FF:005815', NULL, NULL, 'Dethiobiotin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(130449, NULL, 'G3DSA:3.30.70.330:FF:001446', NULL, NULL, 'GD20965', NULL, NULL, NULL, NULL, NULL, 4),
(130450, NULL, 'G3DSA:2.10.230.10:FF:000025', NULL, NULL, 'dnaJ homolog subfamily A member 4 isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(130451, NULL, 'G3DSA:3.90.190.10:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130452, NULL, 'G3DSA:1.20.1250.20:FF:002216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130453, NULL, 'G3DSA:3.20.20.80:FF:000477', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130454, NULL, 'G3DSA:3.30.70.330:FF:001502', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(130455, NULL, 'G3DSA:3.30.559.10:FF:000156', NULL, NULL, 'Lovastatin nonaketide synthase, polyketide synthase component', NULL, NULL, NULL, NULL, NULL, 4),
(130456, NULL, 'G3DSA:1.20.1050.10:FF:000287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130457, NULL, 'G3DSA:1.20.1720.10:FF:000136', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130458, NULL, 'G3DSA:3.40.50.720:FF:000534', NULL, NULL, 'mRNA, clone: RTFL01-28-L12', NULL, NULL, NULL, NULL, NULL, 4),
(130459, NULL, 'G3DSA:2.60.40.10:FF:000014', NULL, NULL, 'H-2 class I histocompatibility antigen, alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(130460, NULL, 'G3DSA:1.10.1240.10:FF:000006', NULL, NULL, 'Methanol-5-hydroxybenzimidazolylcobamide methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(130461, NULL, 'G3DSA:3.40.50.720:FF:000478', NULL, NULL, 'Dehydrogenase/reductase SDR family member 7', NULL, NULL, NULL, NULL, NULL, 4),
(130462, NULL, 'G3DSA:3.30.160.20:FF:000031', NULL, NULL, 'Endoribonuclease Dicer-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(130463, NULL, 'G3DSA:2.20.25.10:FF:000032', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(130464, NULL, 'G3DSA:3.30.160.60:FF:005843', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130465, NULL, 'G3DSA:3.30.450.20:FF:000457', NULL, NULL, 'GAF sensor signal transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(130466, NULL, 'G3DSA:1.20.1250.20:FF:000597', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130467, NULL, 'G3DSA:1.10.630.10:FF:000672', NULL, NULL, 'Cytochrome P450, family 2, subfamily AA, polypeptide 12', NULL, NULL, NULL, NULL, NULL, 4),
(130468, NULL, 'G3DSA:3.40.50.150:FF:001566', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130469, NULL, 'G3DSA:3.30.200.20:FF:001254', NULL, NULL, 'AGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(130470, NULL, 'G3DSA:1.10.10.1100:FF:000014', NULL, NULL, 'BFD domain protein (2Fe-2S)-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(130471, NULL, 'G3DSA:1.10.10.10:FF:001271', NULL, NULL, 'RpiR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(130472, NULL, 'G3DSA:3.90.550.50:FF:000230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130473, NULL, 'G3DSA:1.10.287.3240:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130474, NULL, 'G3DSA:3.40.50.620:FF:000920', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(130475, NULL, 'G3DSA:1.25.40.10:FF:001508', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(130476, NULL, 'G3DSA:3.60.20.30:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130477, NULL, 'G3DSA:3.40.20.10:FF:000074', NULL, NULL, 'Protein transport protein Sec24A', NULL, NULL, NULL, NULL, NULL, 4),
(130478, NULL, 'G3DSA:3.80.10.10:FF:001206', NULL, NULL, 'GD21911', NULL, NULL, NULL, NULL, NULL, 4),
(130479, NULL, 'G3DSA:1.20.58.1700:FF:000001', NULL, NULL, 'DUR1,2p Urea amidolyase', NULL, NULL, NULL, NULL, NULL, 4),
(130480, NULL, 'G3DSA:2.10.25.10:FF:000796', NULL, NULL, 'Crumbs cell polarity complex component 2b', NULL, NULL, NULL, NULL, NULL, 4),
(130481, NULL, 'G3DSA:1.10.510.10:FF:003209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130482, NULL, 'G3DSA:1.10.220.10:FF:000062', NULL, NULL, 'Annexin A1', NULL, NULL, NULL, NULL, NULL, 4),
(130483, NULL, 'G3DSA:2.10.25.10:FF:000650', NULL, NULL, 'fibropellin-1-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(130484, NULL, 'G3DSA:3.30.300.110:FF:000012', NULL, NULL, 'tRNA 4-demethylwyosine(37)-methyltransferase Taw21', NULL, NULL, NULL, NULL, NULL, 4),
(130485, NULL, 'G3DSA:2.60.40.150:FF:000074', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(130486, NULL, 'G3DSA:1.25.40.180:FF:000189', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130487, NULL, 'G3DSA:2.60.40.10:FF:005450', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130488, NULL, 'G3DSA:1.20.5.170:FF:000162', NULL, NULL, 'SPeCtrin', NULL, NULL, NULL, NULL, NULL, 4),
(130489, NULL, 'G3DSA:3.90.79.10:FF:000105', NULL, NULL, 'ADP-ribose pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(130490, NULL, 'G3DSA:2.10.25.10:FF:000852', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(130491, NULL, 'G3DSA:2.40.170.20:FF:000050', NULL, NULL, 'Iron(III) compound receptor', NULL, NULL, NULL, NULL, NULL, 4),
(130492, NULL, 'G3DSA:2.130.10.10:FF:000138', NULL, NULL, 'Enhancer of mRNA-decapping protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(130493, NULL, 'G3DSA:2.30.29.30:FF:000254', NULL, NULL, 'Ran-specific GTPase-activating protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(130494, NULL, 'G3DSA:3.40.430.10:FF:000018', NULL, NULL, 'Dihydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(130495, NULL, 'G3DSA:3.40.50.800:FF:000053', NULL, NULL, 'Neosin, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(130496, NULL, 'G3DSA:2.60.40.10:FF:002105', NULL, NULL, 'V-set and immunoglobulin domain containing 10 like', NULL, NULL, NULL, NULL, NULL, 4),
(130497, NULL, 'G3DSA:1.25.40.10:FF:005314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130498, NULL, 'G3DSA:3.40.190.10:FF:000893', NULL, NULL, 'Transcriptional activator GpuR', NULL, NULL, NULL, NULL, NULL, 4),
(130499, NULL, 'G3DSA:3.30.160.60:FF:005253', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130500, NULL, 'G3DSA:3.30.160.60:FF:005197', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130501, NULL, 'G3DSA:3.20.20.70:FF:000148', NULL, NULL, 'tRNA-dihydrouridine(20) synthase [NAD(P)+]-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(130502, NULL, 'G3DSA:2.60.40.150:FF:000130', NULL, NULL, 'synaptotagmin-4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(130503, NULL, 'G3DSA:3.40.50.300:FF:003668', NULL, NULL, 'Dynein heavy chain 9, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(130504, NULL, 'G3DSA:2.60.120.230:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130505, NULL, 'G3DSA:1.10.510.10:FF:002107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130506, NULL, 'G3DSA:3.30.70.141:FF:000025', NULL, NULL, 'Nucleoside diphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(130507, NULL, 'G3DSA:3.40.190.80:FF:000071', NULL, NULL, 'Inositol monophosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(130508, NULL, 'G3DSA:1.10.1420.10:FF:000104', NULL, NULL, 'DNA mismatch repair protein Msh3', NULL, NULL, NULL, NULL, NULL, 4),
(130509, NULL, 'G3DSA:3.40.30.10:FF:000046', NULL, NULL, 'GSH-dependent disulfide bond oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(130510, NULL, 'G3DSA:1.20.1730.10:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130511, NULL, 'G3DSA:1.20.1250.20:FF:001114', NULL, NULL, 'Major Facilitator Superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(130512, NULL, 'G3DSA:1.10.287.660:FF:000017', NULL, NULL, 'Tryptophan-rich protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130513, NULL, 'G3DSA:3.20.20.210:FF:000003', NULL, NULL, '5-methyltetrahydropteroyltriglutamate--homocysteine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(130514, NULL, 'G3DSA:3.30.1370.10:FF:000195', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(130515, NULL, 'G3DSA:1.10.10.60:FF:000127', NULL, NULL, 'homeobox protein aristaless-like 4', NULL, NULL, NULL, NULL, NULL, 4),
(130516, NULL, 'G3DSA:1.10.287.130:FF:000033', NULL, NULL, 'Sporulation initiation phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(130517, NULL, 'G3DSA:1.10.540.10:FF:000108', NULL, NULL, 'Acyl-CoA dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130518, NULL, 'G3DSA:3.40.1350.10:FF:000011', NULL, NULL, 'tRNA-splicing endonuclease subunit Sen2', NULL, NULL, NULL, NULL, NULL, 4),
(130519, NULL, 'G3DSA:1.25.40.10:FF:000789', NULL, NULL, 'NEDD8-activating enzyme E1 catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(130520, NULL, 'G3DSA:1.20.58.60:FF:000872', NULL, NULL, 'Spectrin, beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(130521, NULL, 'G3DSA:3.40.605.10:FF:000133', NULL, NULL, 'Aldehyde dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130522, NULL, 'G3DSA:2.10.25.10:FF:000173', NULL, NULL, 'Neurogenic locus notch protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(130523, NULL, 'G3DSA:3.40.50.300:FF:001577', NULL, NULL, 'ABC bile acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(130524, NULL, 'G3DSA:3.40.50.300:FF:007737', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130525, NULL, 'G3DSA:2.30.29.30:FF:000933', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130526, NULL, 'G3DSA:3.40.50.80:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130527, NULL, 'G3DSA:3.40.50.2300:FF:001541', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130528, NULL, 'G3DSA:1.20.1270.10:FF:000028', NULL, NULL, 'Heat shock 70 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(130529, NULL, 'G3DSA:3.20.20.220:FF:000006', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(130530, NULL, 'G3DSA:1.20.1070.10:FF:001013', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(130531, NULL, 'G3DSA:3.40.1440.60:FF:000005', NULL, NULL, 'Primosomal protein N''', NULL, NULL, NULL, NULL, NULL, 4),
(130532, NULL, 'G3DSA:2.60.120.290:FF:000254', NULL, NULL, 'Cubilin-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(130533, NULL, 'G3DSA:3.30.70.100:FF:000034', NULL, NULL, 'Cyclic diguanylate phosphodiesterase (EAL) domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(130534, NULL, 'G3DSA:3.40.1110.10:FF:000230', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(130535, NULL, 'G3DSA:2.60.40.1080:FF:000002', NULL, NULL, 'nuclear pore membrane glycoprotein 210-like', NULL, NULL, NULL, NULL, NULL, 4),
(130536, NULL, 'G3DSA:2.60.40.10:FF:005601', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130537, NULL, 'G3DSA:1.10.238.10:FF:001255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130538, NULL, 'G3DSA:3.40.50.360:FF:000027', NULL, NULL, 'Arsenical resistance protein ArsH', NULL, NULL, NULL, NULL, NULL, 4),
(130539, NULL, 'G3DSA:4.10.400.10:FF:000132', NULL, NULL, 'Low-density lipoprotein receptor-related protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(130540, NULL, 'G3DSA:1.25.40.10:FF:003751', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g31850, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(130541, NULL, 'G3DSA:1.10.287.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130542, NULL, 'G3DSA:2.60.120.430:FF:000015', NULL, NULL, 'Putative receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(130543, NULL, 'G3DSA:2.40.128.200:FF:000001', NULL, NULL, 'C-type lysozyme inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(130544, NULL, 'G3DSA:3.80.10.10:FF:001004', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase TDR isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(130545, NULL, 'G3DSA:3.30.160.60:FF:000407', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(130546, NULL, 'G3DSA:3.30.360.20:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130547, NULL, 'G3DSA:2.30.30.100:FF:000047', NULL, NULL, 'Small nuclear ribonucleoprotein SmB, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130548, NULL, 'G3DSA:3.40.50.300:FF:006597', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130549, NULL, 'G3DSA:1.50.40.10:FF:000427', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130550, NULL, 'G3DSA:4.10.1000.10:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130551, NULL, 'G3DSA:3.30.160.60:FF:003426', NULL, NULL, 'PR domain zinc finger protein 13-like', NULL, NULL, NULL, NULL, NULL, 4),
(130552, NULL, 'G3DSA:1.25.40.10:FF:001571', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(130553, NULL, 'G3DSA:2.130.10.10:FF:004000', NULL, NULL, 'Chromosome 21, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(130554, NULL, 'G3DSA:3.30.60.30:FF:000021', NULL, NULL, 'reversion-inducing cysteine-rich protein with Kazal motifs isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(130555, NULL, 'G3DSA:2.30.39.10:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130556, NULL, 'G3DSA:2.30.30.140:FF:000126', NULL, NULL, 'tudor domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(130557, NULL, 'G3DSA:1.20.1560.10:FF:000573', NULL, NULL, 'ABC transporter H family member 4', NULL, NULL, NULL, NULL, NULL, 4),
(130558, NULL, 'G3DSA:2.160.20.70:FF:000043', NULL, NULL, 'Adenylyl cyclase-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(130559, NULL, 'G3DSA:1.25.40.10:FF:003223', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g26782, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(130560, NULL, 'G3DSA:3.30.70.980:FF:000011', NULL, NULL, 'Putative transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(130561, NULL, 'G3DSA:1.10.8.10:FF:000325', NULL, NULL, 'Baculoviral IAP repeat containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(130562, NULL, 'G3DSA:2.130.10.10:FF:001919', NULL, NULL, 'Seven WD repeats, AN11 family', NULL, NULL, NULL, NULL, NULL, 4),
(130563, NULL, 'G3DSA:1.10.760.10:FF:000001', NULL, NULL, 'Cytochrome c iso-1', NULL, NULL, NULL, NULL, NULL, 4),
(130564, NULL, 'G3DSA:1.10.3260.10:FF:000013', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(130565, NULL, 'G3DSA:1.10.10.60:FF:000892', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130566, NULL, 'G3DSA:1.20.1110.10:FF:000112', NULL, NULL, 'Plasma membrane calcium-transporting ATPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(130567, NULL, 'G3DSA:3.30.160.20:FF:000177', NULL, NULL, 'Endoribonuclease Dicer', NULL, NULL, NULL, NULL, NULL, 4),
(130568, NULL, 'G3DSA:3.90.1240.10:FF:000003', NULL, NULL, 'Botulinum neurotoxin type C', NULL, NULL, NULL, NULL, NULL, 4),
(130569, NULL, 'G3DSA:3.40.50.300:FF:004034', NULL, NULL, 'AGAP011982-PA', NULL, NULL, NULL, NULL, NULL, 4),
(130570, NULL, 'G3DSA:2.130.10.10:FF:003544', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130571, NULL, 'G3DSA:3.80.10.10:FF:002634', NULL, NULL, 'Slit homolog 1b (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(130572, NULL, 'G3DSA:1.20.5.110:FF:000127', NULL, NULL, 'Syntaxin-121', NULL, NULL, NULL, NULL, NULL, 4),
(130573, NULL, 'G3DSA:1.20.1280.50:FF:000170', NULL, NULL, 'F-box protein At3g44326', NULL, NULL, NULL, NULL, NULL, 4),
(130574, NULL, 'G3DSA:3.10.100.10:FF:000040', NULL, NULL, 'Secretory phospholipase A2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(130575, NULL, 'G3DSA:3.10.560.10:FF:000001', NULL, NULL, 'Group 4 capsule (G4C) polysaccharide, YmcB', NULL, NULL, NULL, NULL, NULL, 4),
(130576, NULL, 'G3DSA:2.10.90.10:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130577, NULL, 'G3DSA:1.10.840.10:FF:000002', NULL, NULL, 'Rap guanine nucleotide exchange factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(130578, NULL, 'G3DSA:2.130.10.10:FF:001364', NULL, NULL, 'Protein HIRA', NULL, NULL, NULL, NULL, NULL, 4),
(130579, NULL, 'G3DSA:1.25.10.10:FF:001327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130580, NULL, 'G3DSA:1.10.238.10:FF:000153', NULL, NULL, 'TBC1 domain family member 8 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(130581, NULL, 'G3DSA:3.20.20.140:FF:000078', NULL, NULL, 'Inactive deaminase YBR284W', NULL, NULL, NULL, NULL, NULL, 4),
(130582, NULL, 'G3DSA:4.10.280.10:FF:000245', NULL, NULL, 'Transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130583, NULL, 'G3DSA:1.25.40.70:FF:000054', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(130584, NULL, 'G3DSA:1.50.10.10:FF:000077', NULL, NULL, 'Sga1p', NULL, NULL, NULL, NULL, NULL, 4),
(130585, NULL, 'G3DSA:2.80.10.50:FF:000041', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(130586, NULL, 'G3DSA:3.20.20.70:FF:000441', NULL, NULL, 'NADPH dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130587, NULL, 'G3DSA:2.30.30.140:FF:000065', NULL, NULL, 'tudor domain-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(130588, NULL, 'G3DSA:3.40.50.300:FF:003994', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(130589, NULL, 'G3DSA:1.25.40.180:FF:000245', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130590, NULL, 'G3DSA:2.130.10.10:FF:005725', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130591, NULL, 'G3DSA:2.130.10.10:FF:005107', NULL, NULL, 'MIP10235p', NULL, NULL, NULL, NULL, NULL, 4),
(130592, NULL, 'G3DSA:3.40.50.300:FF:003724', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(130593, NULL, 'G3DSA:3.50.50.60:FF:001129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130594, NULL, 'G3DSA:3.60.20.40:FF:000014', NULL, NULL, 'Gamma-glutamyltranspeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(130595, NULL, 'G3DSA:1.10.150.20:FF:000273', NULL, NULL, 'Meiotic 9', NULL, NULL, NULL, NULL, NULL, 4),
(130596, NULL, 'G3DSA:3.30.505.10:FF:000150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130597, NULL, 'G3DSA:1.10.357.70:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130598, NULL, 'G3DSA:2.30.30.380:FF:000030', NULL, NULL, 'Ubiquitin thioesterase trabid', NULL, NULL, NULL, NULL, NULL, 4),
(130599, NULL, 'G3DSA:1.25.40.10:FF:003279', NULL, NULL, 'pre-mRNA-splicing factor SYF1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(130600, NULL, 'G3DSA:3.80.10.10:FF:000689', NULL, NULL, 'Leucine rich repeats and death domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(130601, NULL, 'G3DSA:3.30.530.20:FF:000082', NULL, NULL, 'START domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(130602, NULL, 'G3DSA:2.60.120.1190:FF:000001', NULL, NULL, 'Discoidin domain receptor tyrosine kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(130603, NULL, 'G3DSA:2.60.40.1080:FF:000007', NULL, NULL, 'Nuclear Pore complex Protein', NULL, NULL, NULL, NULL, NULL, 4),
(130604, NULL, 'G3DSA:3.30.497.10:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130605, NULL, 'G3DSA:3.40.50.2020:FF:000092', NULL, NULL, 'Adenine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(130606, NULL, 'G3DSA:3.40.50.10190:FF:000080', NULL, NULL, 'S-M checkpoint control protein rad4', NULL, NULL, NULL, NULL, NULL, 4),
(130607, NULL, 'G3DSA:3.40.1370.10:FF:000041', NULL, NULL, 'RM4, ribosomal protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(130608, NULL, 'G3DSA:1.20.120.310:FF:000006', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(130609, NULL, 'G3DSA:3.60.20.10:FF:000269', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130610, NULL, 'G3DSA:3.30.200.20:FF:001518', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130611, NULL, 'G3DSA:1.10.630.10:FF:000609', NULL, NULL, 'Os03g0367101 protein', NULL, NULL, NULL, NULL, NULL, 4),
(130612, NULL, 'G3DSA:3.40.630.30:FF:000124', NULL, NULL, 'N-acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130613, NULL, 'G3DSA:3.40.718.10:FF:000024', NULL, NULL, 'Isocitrate dehydrogenase (NADP(+)) 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(130614, NULL, 'G3DSA:3.80.10.10:FF:004495', NULL, NULL, 'Stkq', NULL, NULL, NULL, NULL, NULL, 4),
(130615, NULL, 'G3DSA:2.20.28.290:FF:000002', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(130616, NULL, 'G3DSA:2.130.10.10:FF:003634', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130617, NULL, 'G3DSA:3.50.30.30:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130618, NULL, 'G3DSA:3.30.260.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130619, NULL, 'G3DSA:3.30.1460.20:FF:000025', NULL, NULL, 'Actin-related protein 2/3 complex subunit 2B', NULL, NULL, NULL, NULL, NULL, 4),
(130620, NULL, 'G3DSA:3.40.1380.20:FF:000016', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(130621, NULL, 'G3DSA:1.20.120.1910:FF:000021', NULL, NULL, 'Cysteinyl-tRNA synthetase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(130622, NULL, 'G3DSA:3.40.50.2300:FF:001069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130623, NULL, 'G3DSA:3.40.1380.10:FF:000013', NULL, NULL, 'ATP synthase F1, gamma subunit', NULL, NULL, NULL, NULL, NULL, 4),
(130624, NULL, 'G3DSA:1.10.840.10:FF:000007', NULL, NULL, 'SH2 domain containing 3C (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(130625, NULL, 'G3DSA:3.40.50.880:FF:000003', NULL, NULL, 'Anthranilate synthase component II', NULL, NULL, NULL, NULL, NULL, 4),
(130626, NULL, 'G3DSA:1.50.40.10:FF:000051', NULL, NULL, 'Mitochondrial carnitine/acylcarnitine carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(130627, NULL, 'G3DSA:3.90.1210.10:FF:000001', NULL, NULL, 'Flagella basal body P-ring formation protein FlgA', NULL, NULL, NULL, NULL, NULL, 4),
(130628, NULL, 'G3DSA:3.30.160.60:FF:003628', NULL, NULL, 'GM11232', NULL, NULL, NULL, NULL, NULL, 4),
(130629, NULL, 'G3DSA:3.20.90.10:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130630, NULL, 'G3DSA:3.40.50.620:FF:000504', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(130631, NULL, 'G3DSA:1.25.40.510:FF:000007', NULL, NULL, 'Glutamic acid-rich protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(130632, NULL, 'G3DSA:3.30.1150.10:FF:000009', NULL, NULL, 'Protein TonB', NULL, NULL, NULL, NULL, NULL, 4),
(130633, NULL, 'G3DSA:3.80.10.10:FF:002078', NULL, NULL, 'Neuronal leucine rich repeat-4', NULL, NULL, NULL, NULL, NULL, 4),
(130634, NULL, 'G3DSA:2.10.220.10:FF:000114', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(130635, NULL, 'G3DSA:3.30.40.10:FF:000452', NULL, NULL, 'Histone acetyltransferase HAC1', NULL, NULL, NULL, NULL, NULL, 4),
(130636, NULL, 'G3DSA:3.40.50.300:FF:008103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130637, NULL, 'G3DSA:1.10.20.10:FF:000080', NULL, NULL, 'transcription initiation factor TFIID subunit 11 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(130638, NULL, 'G3DSA:3.40.630.30:FF:000511', NULL, NULL, 'Glucosamine 6-phosphate N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(130639, NULL, 'G3DSA:1.10.150.50:FF:000225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130640, NULL, 'G3DSA:3.40.50.150:FF:001392', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130641, NULL, 'G3DSA:3.40.50.10490:FF:000046', NULL, NULL, '40S ribosomal protein SA', NULL, NULL, NULL, NULL, NULL, 4),
(130642, NULL, 'G3DSA:3.40.50.1010:FF:000272', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130643, NULL, 'G3DSA:1.10.287.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130644, NULL, 'G3DSA:3.40.50.10190:FF:000107', NULL, NULL, 'RNA polymerase II subunit A domain phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(130645, NULL, 'G3DSA:2.40.110.10:FF:000043', NULL, NULL, 'Acyl CoA DeHydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(130646, NULL, 'G3DSA:1.25.40.10:FF:003425', NULL, NULL, 'Tetratricopeptide repeat domain 21B', NULL, NULL, NULL, NULL, NULL, 4),
(130647, NULL, 'G3DSA:3.30.160.60:FF:003336', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(130648, NULL, 'G3DSA:3.40.50.1100:FF:000001', NULL, NULL, 'Tryptophan synthase beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(130649, NULL, 'G3DSA:2.60.40.1230:FF:000013', NULL, NULL, 'ADP-ribosylation factor-binding protein GGA1', NULL, NULL, NULL, NULL, NULL, 4),
(130650, NULL, 'G3DSA:3.40.50.2300:FF:001417', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130651, NULL, 'G3DSA:3.30.479.20:FF:000068', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(130652, NULL, 'G3DSA:3.40.850.10:FF:000477', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(130653, NULL, 'G3DSA:2.20.25.10:FF:000037', NULL, NULL, 'Transcription initiation factor IIB', NULL, NULL, NULL, NULL, NULL, 4),
(130654, NULL, 'G3DSA:2.70.170.10:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130655, NULL, 'G3DSA:3.30.70.890:FF:000012', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(130656, NULL, 'G3DSA:3.30.930.10:FF:000328', NULL, NULL, 'Lipoate-protein ligase B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130657, NULL, 'G3DSA:1.10.8.10:FF:000179', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(130658, NULL, 'G3DSA:1.20.58.60:FF:000546', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130659, NULL, 'G3DSA:3.40.50.300:FF:005293', NULL, NULL, 'G5-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(130660, NULL, 'G3DSA:1.25.40.10:FF:004999', NULL, NULL, 'Genomes uncoupled1', NULL, NULL, NULL, NULL, NULL, 4),
(130661, NULL, 'G3DSA:1.25.40.500:FF:000004', NULL, NULL, 'Transcription initiation factor TFIID subunit', NULL, NULL, NULL, NULL, NULL, 4),
(130662, NULL, 'G3DSA:3.40.50.200:FF:000114', NULL, NULL, 'Os06g0163500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(130663, NULL, 'G3DSA:3.40.1110.10:FF:000286', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130664, NULL, 'G3DSA:3.40.50.10190:FF:000310', NULL, NULL, 'Nbs', NULL, NULL, NULL, NULL, NULL, 4),
(130665, NULL, 'G3DSA:2.80.10.50:FF:000046', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(130666, NULL, 'G3DSA:2.30.30.490:FF:000063', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(130667, NULL, 'G3DSA:3.30.420.10:FF:000447', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130668, NULL, 'G3DSA:1.20.920.10:FF:000158', NULL, NULL, 'Lex-1', NULL, NULL, NULL, NULL, NULL, 4),
(130669, NULL, 'G3DSA:1.20.58.60:FF:000254', NULL, NULL, 'VAB-10B protein', NULL, NULL, NULL, NULL, NULL, 4),
(130670, NULL, 'G3DSA:3.40.630.10:FF:000320', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(130671, NULL, 'G3DSA:3.40.570.10:FF:000023', NULL, NULL, 'MIP05340p', NULL, NULL, NULL, NULL, NULL, 4),
(130672, NULL, 'G3DSA:3.40.720.10:FF:000147', NULL, NULL, 'Arylsulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(130673, NULL, 'G3DSA:3.40.50.300:FF:004360', NULL, NULL, 'Uncharacterized ABC transporter ATP-binding protein HI_0354', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(130674, NULL, 'G3DSA:3.40.50.300:FF:007086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130675, NULL, 'G3DSA:3.30.710.10:FF:000166', NULL, NULL, 'BTB/POZ domain-containing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(130676, NULL, 'G3DSA:1.10.565.10:FF:000188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130677, NULL, 'G3DSA:3.40.50.10490:FF:000102', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130678, NULL, 'G3DSA:3.40.630.30:FF:000034', NULL, NULL, 'N-alpha-acetyltransferase 20', NULL, NULL, NULL, NULL, NULL, 4),
(130679, NULL, 'G3DSA:1.25.40.10:FF:003077', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(130680, NULL, 'G3DSA:3.40.390.10:FF:000256', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130681, NULL, 'G3DSA:1.10.1520.10:FF:000084', NULL, NULL, 'Endoribonuclease dcr-1', NULL, NULL, NULL, NULL, NULL, 4),
(130682, NULL, 'G3DSA:3.40.20.10:FF:000079', NULL, NULL, 'Secretory 24CD, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(130683, NULL, 'G3DSA:2.30.180.10:FF:000038', NULL, NULL, 'fasciclin-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(130684, NULL, 'G3DSA:3.30.70.330:FF:000659', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130685, NULL, 'G3DSA:3.10.20.90:FF:000621', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130686, NULL, 'G3DSA:2.10.60.10:FF:000074', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(130687, NULL, 'G3DSA:2.170.16.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130688, NULL, 'G3DSA:1.25.40.820:FF:000038', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(130689, NULL, 'G3DSA:1.25.10.10:FF:003249', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(130690, NULL, 'G3DSA:2.10.25.10:FF:000824', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(130691, NULL, 'G3DSA:2.130.10.10:FF:005635', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', NULL, NULL, NULL, NULL, NULL, 4),
(130692, NULL, 'G3DSA:1.20.1250.20:FF:001053', NULL, NULL, 'Sugar transporter', NULL, NULL, NULL, NULL, NULL, 4),
(130693, NULL, 'G3DSA:4.10.410.10:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130694, NULL, 'G3DSA:3.10.20.90:FF:000003', NULL, NULL, 'Polyubiquitin 10', NULL, NULL, NULL, NULL, NULL, 4),
(130695, NULL, 'G3DSA:3.40.50.200:FF:000058', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(130696, NULL, 'G3DSA:3.60.10.10:FF:000353', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(130697, NULL, 'G3DSA:1.25.40.10:FF:003369', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(130698, NULL, 'G3DSA:3.30.40.10:FF:000396', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(130699, NULL, 'G3DSA:3.80.10.10:FF:001330', NULL, NULL, 'Leucine-rich repeat-containing 29', NULL, NULL, NULL, NULL, NULL, 4),
(130700, NULL, 'G3DSA:3.40.50.1820:FF:000683', NULL, NULL, 'Putative esterase', NULL, NULL, NULL, NULL, NULL, 4),
(130701, NULL, 'G3DSA:3.40.630.30:FF:000652', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(130702, NULL, 'G3DSA:3.30.930.10:FF:000238', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(130703, NULL, 'G3DSA:3.40.50.12780:FF:000227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130704, NULL, 'G3DSA:2.60.40.10:FF:001616', NULL, NULL, 'Sortilin related receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(130705, NULL, 'G3DSA:3.90.70.80:FF:000062', NULL, NULL, 'ubiquitin thioesterase OTU1', NULL, NULL, NULL, NULL, NULL, 4),
(130706, NULL, 'G3DSA:3.30.420.40:FF:001097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130707, NULL, 'G3DSA:2.60.120.260:FF:000178', NULL, NULL, 'Secreted protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(130708, NULL, 'G3DSA:3.65.10.20:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130709, NULL, 'G3DSA:1.20.1070.10:FF:000698', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(130710, NULL, 'G3DSA:2.130.10.10:FF:002055', NULL, NULL, 'EG:63B12.7 protein', NULL, NULL, NULL, NULL, NULL, 4),
(130711, NULL, 'G3DSA:1.20.1270.60:FF:000060', NULL, NULL, 'Actin polymerization protein Bzz1', NULL, NULL, NULL, NULL, NULL, 4),
(130712, NULL, 'G3DSA:3.90.20.20:FF:000024', NULL, NULL, 'Protein GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(130713, NULL, 'G3DSA:3.40.50.10470:FF:000040', NULL, NULL, 'Related to translation initiation factor GCD7', NULL, NULL, NULL, NULL, NULL, 4),
(130714, NULL, 'G3DSA:3.80.10.10:FF:000190', NULL, NULL, 'Receptor-like kinase TMK4', NULL, NULL, NULL, NULL, NULL, 4),
(130715, NULL, 'G3DSA:1.20.120.550:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130716, NULL, 'G3DSA:3.60.21.10:FF:000440', NULL, NULL, 'Mre11, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130717, NULL, 'G3DSA:1.10.30.10:FF:000052', NULL, NULL, 'Non-histone chromosomal protein 6 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(130718, NULL, 'G3DSA:1.10.10.10:FF:001473', NULL, NULL, 'Interferon regulatory factor 8', NULL, NULL, NULL, NULL, NULL, 4),
(130719, NULL, 'G3DSA:2.60.40.1730:FF:000096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130720, NULL, 'G3DSA:3.30.780.10:FF:000058', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(130721, NULL, 'G3DSA:2.10.50.10:FF:000006', NULL, NULL, 'Signal peptide, CUB domain and EGF like domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(130722, NULL, 'G3DSA:3.30.342.10:FF:000052', NULL, NULL, 'DNA polymerase epsilon catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(130723, NULL, 'G3DSA:3.30.160.60:FF:003954', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130724, NULL, 'G3DSA:3.40.30.10:FF:000664', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130725, NULL, 'G3DSA:3.40.50.620:FF:000830', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(130726, NULL, 'G3DSA:2.130.10.10:FF:003960', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130727, NULL, 'G3DSA:2.40.420.20:FF:000002', NULL, NULL, 'Multidrug resistance protein MdtE', NULL, NULL, NULL, NULL, NULL, 4),
(130728, NULL, 'G3DSA:3.90.1150.160:FF:000006', NULL, NULL, 'Glutamate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(130729, NULL, 'G3DSA:3.40.50.620:FF:000774', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130730, NULL, 'G3DSA:3.40.50.300:FF:005669', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(130731, NULL, 'G3DSA:1.10.1200.10:FF:000032', NULL, NULL, 'Acyl carrier protein MbtL', NULL, NULL, NULL, NULL, NULL, 4),
(130732, NULL, 'G3DSA:2.60.40.1090:FF:000005', NULL, NULL, 'Type 1 fimbrial protein', NULL, NULL, NULL, NULL, NULL, 4),
(130733, NULL, 'G3DSA:1.10.287.470:FF:000084', NULL, NULL, 'Efflux pump, RND family, membrane fusion lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(130734, NULL, 'G3DSA:3.20.20.80:FF:000567', NULL, NULL, 'Glutamate carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130735, NULL, 'G3DSA:1.10.1040.10:FF:000058', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(P)+]', NULL, NULL, NULL, NULL, NULL, 4),
(130736, NULL, 'G3DSA:2.60.40.10:FF:001088', NULL, NULL, 'Macrophage colony-stimulating factor 1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(130737, NULL, 'G3DSA:2.130.10.10:FF:003718', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130738, NULL, 'G3DSA:2.40.290.10:FF:000022', NULL, NULL, 'Putative KU70 protein', NULL, NULL, NULL, NULL, NULL, 4),
(130739, NULL, 'G3DSA:1.25.40.10:FF:003695', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130740, NULL, 'G3DSA:3.40.50.300:FF:001398', NULL, NULL, 'Replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(130741, NULL, 'G3DSA:3.40.140.10:FF:000120', NULL, NULL, 'Mov34/MPN/PAD-1 family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(130742, NULL, 'G3DSA:3.20.20.70:FF:000564', NULL, NULL, 'Bll6350 protein', NULL, NULL, NULL, NULL, NULL, 4),
(130743, NULL, 'G3DSA:1.25.40.20:FF:000207', NULL, NULL, 'Calmodulin-binding transcription activator 1', NULL, NULL, NULL, NULL, NULL, 4),
(130744, NULL, 'G3DSA:1.10.10.10:FF:001181', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(130745, NULL, 'G3DSA:3.90.1290.10:FF:000045', NULL, NULL, 'VAB-10A protein', NULL, NULL, NULL, NULL, NULL, 4),
(130746, NULL, 'G3DSA:2.30.29.30:FF:001243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130747, NULL, 'G3DSA:3.30.9.10:FF:000250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130748, NULL, 'G3DSA:1.10.10.410:FF:000009', NULL, NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit B, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(130749, NULL, 'G3DSA:1.10.630.10:FF:000582', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130750, NULL, 'G3DSA:3.80.10.10:FF:002639', NULL, NULL, 'F-box/LRR-repeat protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(130751, NULL, 'G3DSA:3.30.160.60:FF:002324', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130752, NULL, 'G3DSA:3.60.10.10:FF:000117', NULL, NULL, 'Inositol polyphosphate 5-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(130753, NULL, 'G3DSA:3.30.450.20:FF:000278', NULL, NULL, 'PAS domain-containing sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(130754, NULL, 'G3DSA:2.60.40.3510:FF:000012', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(130755, NULL, 'G3DSA:1.20.1070.10:FF:000850', NULL, NULL, 'Muscarinic acetylcholine receptor gar-2', NULL, NULL, NULL, NULL, NULL, 4),
(130756, NULL, 'G3DSA:1.10.290.10:FF:000010', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(130757, NULL, 'G3DSA:2.130.10.10:FF:001892', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(130758, NULL, 'G3DSA:2.60.120.290:FF:000164', NULL, NULL, 'Cubilin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(130759, NULL, 'G3DSA:3.60.10.10:FF:000297', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(130760, NULL, 'G3DSA:2.60.40.1510:FF:000030', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(130761, NULL, 'G3DSA:3.40.630.30:FF:000326', NULL, NULL, 'Putative acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(130762, NULL, 'G3DSA:4.10.240.10:FF:000119', NULL, NULL, 'Probable sucrose utilization protein SUC1', NULL, NULL, NULL, NULL, NULL, 4),
(130763, NULL, 'G3DSA:3.40.50.800:FF:000058', NULL, NULL, 'Threonyl-tRNA synthetase, cytoplasmic, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130764, NULL, 'G3DSA:1.20.120.1080:FF:000143', NULL, NULL, 'ATP-dependent RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130765, NULL, 'G3DSA:1.50.40.10:FF:000253', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(130766, NULL, 'G3DSA:1.50.10.10:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130767, NULL, 'G3DSA:1.10.132.70:FF:000010', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(130768, NULL, 'G3DSA:1.10.510.10:FF:004322', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130769, NULL, 'G3DSA:2.20.25.240:FF:000002', NULL, NULL, 'FLYWCH zinc finger transcription factor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(130770, NULL, 'G3DSA:2.40.240.10:FF:000047', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(130771, NULL, 'G3DSA:3.40.50.1820:FF:001700', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(130772, NULL, 'G3DSA:2.60.40.10:FF:001739', NULL, NULL, 'Ig gamma-2A chain C region', NULL, NULL, NULL, NULL, NULL, 4),
(130773, NULL, 'G3DSA:3.30.70.1230:FF:000048', NULL, NULL, 'Phospholipid-transporting ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130774, NULL, 'G3DSA:1.25.40.10:FF:005022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(130775, NULL, 'G3DSA:3.30.420.10:FF:000071', NULL, NULL, 'DNA polymerase-3 subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(130776, NULL, 'G3DSA:3.30.160.860:FF:000001', NULL, NULL, 'IpI internal head protein', NULL, NULL, NULL, NULL, NULL, 4),
(130777, NULL, 'G3DSA:1.20.58.60:FF:000198', NULL, NULL, 'Uncharacterized protein, isoform I', NULL, NULL, NULL, NULL, NULL, 4),
(130778, NULL, 'G3DSA:1.10.150.240:FF:000078', NULL, NULL, 'Putative 2-deoxyglucose-6-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(130779, NULL, 'G3DSA:3.30.450.60:FF:000003', NULL, NULL, 'Coatomer subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(130780, NULL, 'G3DSA:1.20.58.1100:FF:000006', NULL, NULL, 'Unc-13 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(130781, NULL, 'G3DSA:3.30.1330.30:FF:000114', NULL, NULL, 'Peptide chain release factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(130782, NULL, 'G3DSA:3.90.70.10:FF:000350', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(130783, NULL, 'G3DSA:1.25.40.180:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130784, NULL, 'G3DSA:2.30.40.10:FF:000055', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(130785, NULL, 'G3DSA:1.20.1250.40:FF:000013', NULL, NULL, 'RNA_polymerase_Rpb4', NULL, NULL, NULL, NULL, NULL, 4),
(130786, NULL, 'G3DSA:3.60.10.10:FF:000027', NULL, NULL, 'Type IV inositol polyphosphate 5-phosphatase 7', NULL, NULL, NULL, NULL, NULL, 4),
(130787, NULL, 'G3DSA:3.40.50.1110:FF:000004', NULL, NULL, 'Platelet-activating factor acetylhydrolase IB subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(130788, NULL, 'G3DSA:3.30.70.2970:FF:000002', NULL, NULL, 'interleukin-1 receptor-associated kinase 1-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(130789, NULL, 'G3DSA:2.60.40.10:FF:000599', NULL, NULL, 'obscurin isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(130790, NULL, 'G3DSA:3.80.10.10:FF:000835', NULL, NULL, 'Protein phosphatase type 1 regulator-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(130791, NULL, 'G3DSA:1.10.540.10:FF:000018', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(130792, NULL, 'G3DSA:2.130.10.10:FF:003157', NULL, NULL, 'U3 small nucleolar RNA-associated protein 4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(130793, NULL, 'G3DSA:2.30.29.30:FF:000259', NULL, NULL, 'TBC1 domain family member 8', NULL, NULL, NULL, NULL, NULL, 4),
(130794, NULL, 'G3DSA:3.90.830.10:FF:000015', NULL, NULL, 'SEC1 family transport protein SLY1', NULL, NULL, NULL, NULL, NULL, 4),
(130795, NULL, 'G3DSA:3.40.50.10190:FF:000254', NULL, NULL, 'YALI0B15576p', NULL, NULL, NULL, NULL, NULL, 4),
(130796, NULL, 'G3DSA:2.60.40.10:FF:005455', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130797, NULL, 'G3DSA:3.40.720.10:FF:000237', NULL, NULL, 'Phosphoglycerate mutase, 2,3-bisphosphoglycerate-independent, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130798, NULL, 'G3DSA:1.20.58.390:FF:000025', NULL, NULL, 'Cholinergic receptor nicotinic beta 3 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(130799, NULL, 'G3DSA:1.10.287.70:FF:000453', NULL, NULL, 'Potassium inwardly-rectifying channel', NULL, NULL, NULL, NULL, NULL, 4),
(130800, NULL, 'G3DSA:3.30.9.10:FF:000071', NULL, NULL, 'Sarcosine oxidase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(130801, NULL, 'G3DSA:1.20.1250.20:FF:000890', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(130802, NULL, 'G3DSA:3.40.50.300:FF:002235', NULL, NULL, 'Guanylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(130803, NULL, 'G3DSA:2.60.120.10:FF:000264', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(130804, NULL, 'G3DSA:1.20.58.1000:FF:000004', NULL, NULL, 'Copper-sensing transcriptional repressor CsoR', NULL, NULL, NULL, NULL, NULL, 4),
(130805, NULL, 'G3DSA:3.20.20.10:FF:000030', NULL, NULL, 'Alanine racemase', NULL, NULL, NULL, NULL, NULL, 4),
(130806, NULL, 'G3DSA:1.10.510.10:FF:003451', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130807, NULL, 'G3DSA:3.10.250.10:FF:000045', NULL, NULL, 'neurotrypsin-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(130808, NULL, 'G3DSA:1.10.3210.10:FF:000010', NULL, NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(130809, NULL, 'G3DSA:3.40.50.300:FF:005523', NULL, NULL, 'Repair helicase UvrD', NULL, NULL, NULL, NULL, NULL, 4),
(130810, NULL, 'G3DSA:3.30.420.10:FF:000716', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130811, NULL, 'G3DSA:1.25.40.10:FF:003841', NULL, NULL, 'Pentatricopeptide repeat-containing protein 8, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(130812, NULL, 'G3DSA:4.10.400.10:FF:000042', NULL, NULL, 'Corin, serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(130813, NULL, 'G3DSA:1.10.287.110:FF:000206', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(130814, NULL, 'G3DSA:2.60.120.10:FF:000590', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130815, NULL, 'G3DSA:2.10.25.10:FF:000465', NULL, NULL, 'Axotactin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(130816, NULL, 'G3DSA:1.10.730.20:FF:000002', NULL, NULL, 'isoleucine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(130817, NULL, 'G3DSA:1.20.1280.50:FF:000260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130818, NULL, 'G3DSA:3.40.50.300:FF:000144', NULL, NULL, 'ATP-binding cassette sub-family E member 1', NULL, NULL, NULL, NULL, NULL, 4),
(130819, NULL, 'G3DSA:3.40.50.300:FF:005995', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(130820, NULL, 'G3DSA:3.40.50.300:FF:000088', NULL, NULL, 'Ras-related C3 botulinum toxin substrate 1', NULL, NULL, NULL, NULL, NULL, 4),
(130821, NULL, 'G3DSA:3.80.10.10:FF:000841', NULL, NULL, 'Toll-like receptor 5', NULL, NULL, NULL, NULL, NULL, 4),
(130822, NULL, 'G3DSA:3.10.50.40:FF:000041', NULL, NULL, 'FK506-binding nuclear protein', NULL, NULL, NULL, NULL, NULL, 4),
(130823, NULL, 'G3DSA:3.30.200.20:FF:000939', NULL, NULL, 'Fructosamine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(130824, NULL, 'G3DSA:2.60.40.10:FF:005629', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130825, NULL, 'G3DSA:2.60.120.200:FF:000677', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130826, NULL, 'G3DSA:2.30.29.30:FF:000585', NULL, NULL, 'target of rapamycin complex 2 subunit MAPKAP1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(130827, NULL, 'G3DSA:3.50.50.60:FF:001096', NULL, NULL, 'Flavin-dependent monoxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(130828, NULL, 'G3DSA:3.40.605.10:FF:000043', NULL, NULL, 'Succinate-semialdehyde dehydrogenase [NADP+]', NULL, NULL, NULL, NULL, NULL, 4),
(130829, NULL, 'G3DSA:2.30.30.100:FF:000137', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm2', NULL, NULL, NULL, NULL, NULL, 4),
(130830, NULL, 'G3DSA:1.25.40.10:FF:004297', NULL, NULL, 'ACL160Cp', NULL, NULL, NULL, NULL, NULL, 4),
(130831, NULL, 'G3DSA:2.30.180.10:FF:000010', NULL, NULL, 'Fasciclin-like arabinogalactan protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(130832, NULL, 'G3DSA:3.30.470.20:FF:000077', NULL, NULL, 'Glutathione biosynthesis bifunctional protein GshAB', NULL, NULL, NULL, NULL, NULL, 4),
(130833, NULL, 'G3DSA:1.10.10.10:FF:001563', NULL, NULL, 'ESCRT-II subunit protein', NULL, NULL, NULL, NULL, NULL, 4),
(130834, NULL, 'G3DSA:2.30.42.10:FF:000565', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130835, NULL, 'G3DSA:3.60.15.10:FF:000196', NULL, NULL, 'Protein artemis', NULL, NULL, NULL, NULL, NULL, 4),
(130836, NULL, 'G3DSA:3.40.50.2000:FF:000754', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130837, NULL, 'G3DSA:3.40.50.980:FF:000033', NULL, NULL, 'Nonribosomal peptide synthase inpB', NULL, NULL, NULL, NULL, NULL, 4),
(130838, NULL, 'G3DSA:3.30.40.10:FF:001233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130839, NULL, 'G3DSA:3.40.50.1820:FF:001228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130840, NULL, 'G3DSA:3.40.50.11350:FF:000017', NULL, NULL, 'O-fucosyltransferase 23', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(130841, NULL, 'G3DSA:3.30.930.10:FF:000154', NULL, NULL, 'Aspartate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(130842, NULL, 'G3DSA:1.20.1420.10:FF:000006', NULL, NULL, 'Talin 2', NULL, NULL, NULL, NULL, NULL, 4),
(130843, NULL, 'G3DSA:1.10.10.350:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130844, NULL, 'G3DSA:4.10.760.10:FF:000001', NULL, NULL, 'Agouti-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(130845, NULL, 'G3DSA:3.90.228.10:FF:000014', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(130846, NULL, 'G3DSA:3.40.50.720:FF:000186', NULL, NULL, 'Acetaldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(130847, NULL, 'G3DSA:1.25.40.570:FF:000036', NULL, NULL, 'PCI_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(130848, NULL, 'G3DSA:3.40.50.11340:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130849, NULL, 'G3DSA:3.20.20.190:FF:000014', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(130850, NULL, 'G3DSA:3.40.1190.20:FF:000007', NULL, NULL, 'Pyridoxal kinase', NULL, NULL, NULL, NULL, NULL, 4),
(130851, NULL, 'G3DSA:1.10.510.10:FF:000163', NULL, NULL, '3-phosphoinositide-dependent protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(130852, NULL, 'G3DSA:1.20.1250.20:FF:000889', NULL, NULL, '3-phenylpropionic acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(130853, NULL, 'G3DSA:1.10.10.10:FF:001506', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(130854, NULL, 'G3DSA:2.60.40.10:FF:001942', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(130855, NULL, 'G3DSA:3.40.50.300:FF:005467', NULL, NULL, 'PDR-like ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(130856, NULL, 'G3DSA:3.20.20.70:FF:000238', NULL, NULL, 'Tryptophan synthase alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(130857, NULL, 'G3DSA:3.30.70.330:FF:001154', NULL, NULL, 'GD23003', NULL, NULL, NULL, NULL, NULL, 4),
(130858, NULL, 'G3DSA:3.20.20.80:FF:000769', NULL, NULL, 'Chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130859, NULL, 'G3DSA:2.60.40.10:FF:000306', NULL, NULL, 'fibronectin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(130860, NULL, 'G3DSA:3.90.70.10:FF:000024', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 2', NULL, NULL, NULL, NULL, NULL, 4),
(130861, NULL, 'G3DSA:2.30.39.10:FF:000041', NULL, NULL, 'Serpin-Z1', NULL, NULL, NULL, NULL, NULL, 4),
(130862, NULL, 'G3DSA:3.40.50.300:FF:003814', NULL, NULL, 'DNA helicase related protein', NULL, NULL, NULL, NULL, NULL, 4),
(130863, NULL, 'G3DSA:1.20.1250.20:FF:000945', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(130864, NULL, 'G3DSA:3.90.640.10:FF:000096', NULL, NULL, 'Heat shock 70 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(130865, NULL, 'G3DSA:2.30.29.30:FF:000546', NULL, NULL, 'target of rapamycin complex 2 subunit MAPKAP1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(130866, NULL, 'G3DSA:1.20.1070.10:FF:001631', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(130867, NULL, 'G3DSA:1.20.920.10:FF:000012', NULL, NULL, 'zinc finger MYND domain-containing protein 11 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(130868, NULL, 'G3DSA:1.25.40.720:FF:000008', NULL, NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(130869, NULL, 'G3DSA:3.50.50.60:FF:000966', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130870, NULL, 'G3DSA:3.10.20.90:FF:000391', NULL, NULL, 'Heavy chain, Unconventional Myosin', NULL, NULL, NULL, NULL, NULL, 4),
(130871, NULL, 'G3DSA:1.25.40.700:FF:000002', NULL, NULL, 'Nup133', NULL, NULL, NULL, NULL, NULL, 4),
(130872, NULL, 'G3DSA:3.30.310.130:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130873, NULL, 'G3DSA:3.40.50.720:FF:002277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(130874, NULL, 'G3DSA:2.130.10.10:FF:005489', NULL, NULL, 'WD repeat domain 3', NULL, NULL, NULL, NULL, NULL, 4),
(130875, NULL, 'G3DSA:3.90.550.10:FF:000027', NULL, NULL, 'Cellulose synthase-like protein D4', NULL, NULL, NULL, NULL, NULL, 4),
(130876, NULL, 'G3DSA:1.10.8.10:FF:000033', NULL, NULL, 'Next to BRCA1 gene 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(130877, NULL, 'G3DSA:2.60.40.640:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130878, NULL, 'G3DSA:2.60.40.10:FF:005742', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130879, NULL, 'G3DSA:4.10.280.10:FF:000009', NULL, NULL, 'Transcription factor HES-1', NULL, NULL, NULL, NULL, NULL, 4),
(130880, NULL, 'G3DSA:2.10.25.10:FF:000408', NULL, NULL, 'Cartilage matrix protein', NULL, NULL, NULL, NULL, NULL, 4),
(130881, NULL, 'G3DSA:3.30.9.10:FF:000008', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(130882, NULL, 'G3DSA:1.10.167.10:FF:000010', NULL, NULL, 'Rho guanine nucleotide exchange factor (GEF) 11', NULL, NULL, NULL, NULL, NULL, 4),
(130883, NULL, 'G3DSA:2.40.50.90:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130884, NULL, 'G3DSA:2.40.50.90:FF:000068', NULL, NULL, 'GM14014p', NULL, NULL, NULL, NULL, NULL, 4),
(130885, NULL, 'G3DSA:3.90.228.20:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130886, NULL, 'G3DSA:3.30.460.10:FF:000045', NULL, NULL, 'Ribosomal silencing factor RsfS', NULL, NULL, NULL, NULL, NULL, 4),
(130887, NULL, 'G3DSA:3.30.40.10:FF:001031', NULL, NULL, 'Recombination activating gene 1', NULL, NULL, NULL, NULL, NULL, 4),
(130888, NULL, 'G3DSA:2.40.128.20:FF:000008', NULL, NULL, 'Major urinary protein', NULL, NULL, NULL, NULL, NULL, 4),
(130889, NULL, 'G3DSA:3.10.620.30:FF:000012', NULL, NULL, 'Coiled-coil domain-containing protein lobo', NULL, NULL, NULL, NULL, NULL, 4),
(130890, NULL, 'G3DSA:3.40.50.300:FF:001869', NULL, NULL, 'Small GTP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(130891, NULL, 'G3DSA:1.20.1270.60:FF:000234', NULL, NULL, 'YALI0E13904p', NULL, NULL, NULL, NULL, NULL, 4),
(130892, NULL, 'G3DSA:3.40.50.12470:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130893, NULL, 'G3DSA:1.20.1280.50:FF:000203', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(130894, NULL, 'G3DSA:1.10.246.190:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130895, NULL, 'G3DSA:1.20.1050.10:FF:000197', NULL, NULL, 'Glutathione transferase37', NULL, NULL, NULL, NULL, NULL, 4),
(130896, NULL, 'G3DSA:1.10.630.10:FF:000380', NULL, NULL, 'Cytochrome P450 monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130897, NULL, 'G3DSA:3.40.50.300:FF:001780', NULL, NULL, 'Putative ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(130898, NULL, 'G3DSA:3.60.40.10:FF:000029', NULL, NULL, 'Protein phosphatase, Mg2+/Mn2+-dependent, 1G', NULL, NULL, NULL, NULL, NULL, 4),
(130899, NULL, 'G3DSA:2.60.120.200:FF:000531', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(130900, NULL, 'G3DSA:3.80.10.10:FF:000307', NULL, NULL, 'Leucine-rich repeats and death domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(130901, NULL, 'G3DSA:3.40.50.1010:FF:000182', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130902, NULL, 'G3DSA:3.40.50.410:FF:000211', NULL, NULL, 'von Willebrand factor', NULL, NULL, NULL, NULL, NULL, 4),
(130903, NULL, 'G3DSA:3.40.50.300:FF:003871', NULL, NULL, 'DExH-box ATP-dependent RNA helicase DExH18 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(130904, NULL, 'G3DSA:3.30.420.10:FF:000301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130905, NULL, 'G3DSA:1.10.510.10:FF:003827', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130906, NULL, 'G3DSA:3.30.1330.30:FF:000108', NULL, NULL, 'Growth arrest and DNA damage-inducible beta', NULL, NULL, NULL, NULL, NULL, 4),
(130907, NULL, 'G3DSA:1.25.40.20:FF:000180', NULL, NULL, 'Ankyrin repeat and zinc finger domain containing 1', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(130908, NULL, 'G3DSA:3.20.20.80:FF:000393', NULL, NULL, 'Chitinase-like 5', NULL, NULL, NULL, NULL, NULL, 4),
(130909, NULL, 'G3DSA:1.25.40.180:FF:000335', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130910, NULL, 'G3DSA:2.170.300.10:FF:000027', NULL, NULL, 'Multiple epidermal growth factor-like domains 6', NULL, NULL, NULL, NULL, NULL, 4),
(130911, NULL, 'G3DSA:1.25.40.710:FF:000005', NULL, NULL, 'Tripeptidyl peptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(130912, NULL, 'G3DSA:3.40.30.10:FF:000338', NULL, NULL, 'Disulfide-isomerase 5-4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(130913, NULL, 'G3DSA:3.40.50.10190:FF:000309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130914, NULL, 'G3DSA:2.30.40.10:FF:000139', NULL, NULL, 'Bll5570 protein', NULL, NULL, NULL, NULL, NULL, 4),
(130915, NULL, 'G3DSA:1.10.630.10:FF:000048', NULL, NULL, '3-epi-6-deoxocathasterone 23-monooxygenase CYP90D1', NULL, NULL, NULL, NULL, NULL, 4),
(130916, NULL, 'G3DSA:2.60.40.10:FF:005781', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130917, NULL, 'G3DSA:1.10.10.10:FF:000253', NULL, NULL, 'AT-rich interactive domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(130918, NULL, 'G3DSA:2.60.40.820:FF:000056', NULL, NULL, 'Eomesodermin', NULL, NULL, NULL, NULL, NULL, 4),
(130919, NULL, 'G3DSA:1.20.1070.10:FF:000844', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(130920, NULL, 'G3DSA:1.10.510.10:FF:000106', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(130921, NULL, 'G3DSA:3.30.160.60:FF:003780', NULL, NULL, 'AGAP007883-PA', NULL, NULL, NULL, NULL, NULL, 4),
(130922, NULL, 'G3DSA:2.60.40.3170:FF:000011', NULL, NULL, 'Tripeptidyl-peptidase 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(130923, NULL, 'G3DSA:1.20.90.10:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130924, NULL, 'G3DSA:2.60.40.1180:FF:000032', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(130925, NULL, 'G3DSA:1.20.1250.20:FF:000474', NULL, NULL, 'Sugar transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130926, NULL, 'G3DSA:1.10.510.10:FF:003597', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130927, NULL, 'G3DSA:3.20.20.80:FF:000623', NULL, NULL, 'Glucan 1,3-beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(130928, NULL, 'G3DSA:1.20.1070.10:FF:000316', NULL, NULL, 'Bradykinin receptor B1', NULL, NULL, NULL, NULL, NULL, 4),
(130929, NULL, 'G3DSA:2.30.26.10:FF:000005', NULL, NULL, 'Dihydroorotate dehydrogenase (fumarate)', NULL, NULL, NULL, NULL, NULL, 4),
(130930, NULL, 'G3DSA:3.40.50.300:FF:002561', NULL, NULL, 'Protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(130931, NULL, 'G3DSA:2.30.30.380:FF:000029', NULL, NULL, 'Protein transport protein Sec24-like At4g32640', NULL, NULL, NULL, NULL, NULL, 4),
(130932, NULL, 'G3DSA:3.20.20.70:FF:000620', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130933, NULL, 'G3DSA:3.20.20.60:FF:000090', NULL, NULL, 'GD12403', NULL, NULL, NULL, NULL, NULL, 4),
(130934, NULL, 'G3DSA:2.40.20.10:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130935, NULL, 'G3DSA:1.10.8.480:FF:000009', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(130936, NULL, 'G3DSA:1.10.150.50:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130937, NULL, 'G3DSA:1.25.40.20:FF:001427', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130938, NULL, 'G3DSA:3.30.70.100:FF:000181', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130939, NULL, 'G3DSA:3.40.50.620:FF:000358', NULL, NULL, 'Cysteinyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130940, NULL, 'G3DSA:1.20.58.740:FF:000001', NULL, NULL, 'dedicator of cytokinesis protein 9 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(130941, NULL, 'G3DSA:3.80.10.10:FF:004348', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(130942, NULL, 'G3DSA:2.40.50.140:FF:001218', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130943, NULL, 'G3DSA:2.60.120.330:FF:000103', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(130944, NULL, 'G3DSA:3.40.30.10:FF:000136', NULL, NULL, 'methionine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(130945, NULL, 'G3DSA:1.25.40.20:FF:000410', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(130946, NULL, 'G3DSA:1.10.8.60:FF:000531', NULL, NULL, 'Cell division control protein 48', NULL, NULL, NULL, NULL, NULL, 4),
(130947, NULL, 'G3DSA:3.30.40.10:FF:000867', NULL, NULL, 'Pre-mRNA-splicing factor SAD1', NULL, NULL, NULL, NULL, NULL, 4),
(130948, NULL, 'G3DSA:3.30.160.60:FF:000380', NULL, NULL, 'zinc finger protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(130949, NULL, 'G3DSA:3.40.50.300:FF:002033', NULL, NULL, 'tRNA delta(2)-isopentenylpyrophosphate transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130950, NULL, 'G3DSA:3.40.50.2000:FF:001064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130951, NULL, 'G3DSA:3.30.1490.120:FF:000003', NULL, NULL, 'DNA-directed RNA polymerase I subunit RPA43', NULL, NULL, NULL, NULL, NULL, 4),
(130952, NULL, 'G3DSA:2.30.30.40:FF:000243', NULL, NULL, 'Non-receptor tyrosine-protein kinase TNK1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(130953, NULL, 'G3DSA:3.80.10.10:FF:003331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130954, NULL, 'G3DSA:3.30.70.330:FF:001115', NULL, NULL, 'RNP domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(130955, NULL, 'G3DSA:3.80.10.10:FF:000509', NULL, NULL, 'Tonsoku like, DNA repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(130956, NULL, 'G3DSA:3.10.580.10:FF:000182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130957, NULL, 'G3DSA:1.10.1200.10:FF:000071', NULL, NULL, 'Nonribosomal peptide synthase GliP2', NULL, NULL, NULL, NULL, NULL, 4),
(130958, NULL, 'G3DSA:2.60.40.3180:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130959, NULL, 'G3DSA:2.40.30.10:FF:000503', NULL, NULL, 'Ferredoxin:NADP oxidoreductase, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(130960, NULL, 'G3DSA:2.130.10.10:FF:003691', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130961, NULL, 'G3DSA:3.30.420.10:FF:000245', NULL, NULL, 'RNA exonuclease 4 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(130962, NULL, 'G3DSA:1.10.10.2670:FF:000002', NULL, NULL, 'RNA polymerase II elongation factor ELL2', NULL, NULL, NULL, NULL, NULL, 4),
(130963, NULL, 'G3DSA:2.60.120.820:FF:000008', NULL, NULL, 'E3 ubiquitin-protein ligase rpm-1', NULL, NULL, NULL, NULL, NULL, 4),
(130964, NULL, 'G3DSA:3.90.180.10:FF:000072', NULL, NULL, 'Crystallin zeta', NULL, NULL, NULL, NULL, NULL, 4),
(130965, NULL, 'G3DSA:3.10.110.10:FF:000299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130966, NULL, 'G3DSA:3.30.70.270:FF:000147', NULL, NULL, 'DNA polymerase Y family protein', NULL, NULL, NULL, NULL, NULL, 4),
(130967, NULL, 'G3DSA:3.40.50.720:FF:002097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130968, NULL, 'G3DSA:3.90.79.10:FF:000021', NULL, NULL, 'ADP-ribose pyrophosphatase, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(130969, NULL, 'G3DSA:3.40.50.300:FF:006304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130970, NULL, 'G3DSA:3.30.160.60:FF:002032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130971, NULL, 'G3DSA:3.30.70.330:FF:000749', NULL, NULL, 'eukaryotic translation initiation factor 4B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(130972, NULL, 'G3DSA:3.30.160.60:FF:004123', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130973, NULL, 'G3DSA:3.40.1190.10:FF:000004', NULL, NULL, 'Dihydrofolate synthase/folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(130974, NULL, 'G3DSA:2.70.170.10:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130975, NULL, 'G3DSA:2.60.40.10:FF:003325', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130976, NULL, 'G3DSA:3.30.760.10:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130977, NULL, 'G3DSA:2.40.50.960:FF:000003', NULL, NULL, 'ACD shelterin complex subunit and telomerase recruitment factor', NULL, NULL, NULL, NULL, NULL, 4),
(130978, NULL, 'G3DSA:3.40.50.10140:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130979, NULL, 'G3DSA:3.30.1520.10:FF:000078', NULL, NULL, 'Sorting nexin-17 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(130980, NULL, 'G3DSA:3.40.50.620:FF:000448', NULL, NULL, 'DUF218 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(130981, NULL, 'G3DSA:3.30.160.60:FF:002408', NULL, NULL, 'myeloid zinc finger 1', NULL, NULL, NULL, NULL, NULL, 4),
(130982, NULL, 'G3DSA:3.30.420.40:FF:000315', NULL, NULL, 'Actin-related protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(130983, NULL, 'G3DSA:3.40.50.2000:FF:000698', NULL, NULL, 'ADP-heptose:LPS heptosyltransferase II', NULL, NULL, NULL, NULL, NULL, 4),
(130984, NULL, 'G3DSA:1.20.1250.20:FF:000417', NULL, NULL, 'Organic cation/carnitine transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(130985, NULL, 'G3DSA:3.40.50.1820:FF:000357', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(130986, NULL, 'G3DSA:3.20.20.70:FF:000093', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(130987, NULL, 'G3DSA:3.90.79.20:FF:000024', NULL, NULL, 'Peroxisomal NADH pyrophosphatase NUDT12', NULL, NULL, NULL, NULL, NULL, 4),
(130988, NULL, 'G3DSA:1.50.40.10:FF:000197', NULL, NULL, 'Ugo1p', NULL, NULL, NULL, NULL, NULL, 4),
(130989, NULL, 'G3DSA:3.40.50.150:FF:001656', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130990, NULL, 'G3DSA:3.30.70.260:FF:000144', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(130991, NULL, 'G3DSA:1.20.1690.20:FF:000001', NULL, NULL, 'CP', NULL, NULL, NULL, NULL, NULL, 4),
(130992, NULL, 'G3DSA:3.100.10.10:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(130993, NULL, 'G3DSA:3.30.450.20:FF:000547', NULL, NULL, 'ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(130994, NULL, 'G3DSA:1.25.40.10:FF:005224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130995, NULL, 'G3DSA:3.40.50.10090:FF:000049', NULL, NULL, 'Putative uroporphyrinogen-III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(130996, NULL, 'G3DSA:1.20.900.10:FF:000067', NULL, NULL, 'Rho guanyl nucleotide exchange factor, putative (AFU_orthologue AFUA_5G11890)', NULL, NULL, NULL, NULL, NULL, 4),
(130997, NULL, 'G3DSA:1.10.560.10:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(130998, NULL, 'G3DSA:3.20.10.10:FF:000001', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(130999, NULL, 'G3DSA:1.20.58.60:FF:000585', NULL, NULL, 'Plectin', NULL, NULL, NULL, NULL, NULL, 4),
(131000, NULL, 'G3DSA:3.20.20.140:FF:000224', NULL, NULL, 'Amidohydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(131001, NULL, 'G3DSA:2.170.120.40:FF:000005', NULL, NULL, 'CdaA regulatory protein CdaR', NULL, NULL, NULL, NULL, NULL, 4),
(131002, NULL, 'G3DSA:1.25.40.10:FF:001278', NULL, NULL, 'pentatricopeptide repeat-containing protein At4g21065-like', NULL, NULL, NULL, NULL, NULL, 4),
(131003, NULL, 'G3DSA:3.60.40.10:FF:000181', NULL, NULL, 'Protein phosphatase 1K, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(131004, NULL, 'G3DSA:1.10.10.60:FF:001061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131005, NULL, 'G3DSA:2.170.120.30:FF:000002', NULL, NULL, 'YbbR-like domain-containing protein ybbR', NULL, NULL, NULL, NULL, NULL, 4),
(131006, NULL, 'G3DSA:1.10.287.1490:FF:000082', NULL, NULL, 'Ift-81', NULL, NULL, NULL, NULL, NULL, 4),
(131007, NULL, 'G3DSA:3.40.30.10:FF:001266', NULL, NULL, 'Thioredoxin domain containing 5', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(131008, NULL, 'G3DSA:3.40.50.720:FF:001170', NULL, NULL, 'CurH', NULL, NULL, NULL, NULL, NULL, 4),
(131009, NULL, 'G3DSA:3.30.70.2740:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131010, NULL, 'G3DSA:3.40.50.1820:FF:000975', NULL, NULL, 'Alpha/beta hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(131011, NULL, 'G3DSA:3.40.50.720:FF:000708', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(131012, NULL, 'G3DSA:1.10.555.10:FF:000075', NULL, NULL, 'Rho GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(131013, NULL, 'G3DSA:3.20.20.70:FF:000710', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131014, NULL, 'G3DSA:2.30.29.30:FF:001041', NULL, NULL, 'ArfGAP with GTPase domain, ankyrin repeat and PH domain 2', NULL, NULL, NULL, NULL, NULL, 4),
(131015, NULL, 'G3DSA:1.10.1000.11:FF:000006', NULL, NULL, 'HOPM interactor 7', NULL, NULL, NULL, NULL, NULL, 4),
(131016, NULL, 'G3DSA:2.130.10.10:FF:005490', NULL, NULL, 'Nuclear pre-mRNA splicing factor, component of splicing factor 3b', NULL, NULL, NULL, NULL, NULL, 4),
(131017, NULL, 'G3DSA:3.40.50.2300:FF:001125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131018, NULL, 'G3DSA:1.10.510.10:FF:002523', NULL, NULL, 'Probable serine/threonine-protein kinase DDB_G0280111', NULL, NULL, NULL, NULL, NULL, 4),
(131019, NULL, 'G3DSA:3.40.50.300:FF:000324', NULL, NULL, 'pre-mRNA-splicing factor ATP-dependent RNA helicase DHX15', NULL, NULL, NULL, NULL, NULL, 4),
(131020, NULL, 'G3DSA:3.30.160.60:FF:001684', NULL, NULL, 'zinc finger protein 33B-like', NULL, NULL, NULL, NULL, NULL, 4),
(131021, NULL, 'G3DSA:1.25.40.20:FF:001484', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131022, NULL, 'G3DSA:2.130.10.10:FF:001690', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(131023, NULL, 'G3DSA:2.60.40.1180:FF:000122', NULL, NULL, 'Alpha-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(131024, NULL, 'G3DSA:1.10.132.20:FF:000017', NULL, NULL, 'Ribosome-recycling factor chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(131025, NULL, 'G3DSA:1.25.10.10:FF:000017', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(131026, NULL, 'G3DSA:1.20.910.10:FF:000039', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(131027, NULL, 'G3DSA:1.20.58.340:FF:000004', NULL, NULL, 'Magnesium transport protein CorA', NULL, NULL, NULL, NULL, NULL, 4),
(131028, NULL, 'G3DSA:3.40.50.2300:FF:001272', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131029, NULL, 'G3DSA:1.10.510.10:FF:001091', NULL, NULL, 'STE family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(131030, NULL, 'G3DSA:3.30.70.260:FF:000088', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(131031, NULL, 'G3DSA:1.10.472.80:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131032, NULL, 'G3DSA:2.10.220.10:FF:000108', NULL, NULL, 'Fraser extracellular matrix complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(131033, NULL, 'G3DSA:3.80.10.10:FF:001622', NULL, NULL, 'Leucine-rich repeat-containing protein egg-6', NULL, NULL, NULL, NULL, NULL, 4),
(131034, NULL, 'G3DSA:3.40.30.10:FF:000810', NULL, NULL, 'Glutathione S-transferase epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(131035, NULL, 'G3DSA:1.25.10.10:FF:001743', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131036, NULL, 'G3DSA:3.40.33.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131037, NULL, 'G3DSA:3.30.70.250:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131038, NULL, 'G3DSA:1.10.1710.10:FF:000003', NULL, NULL, 'RNA chaperone ProQ', NULL, NULL, NULL, NULL, NULL, 4),
(131039, NULL, 'G3DSA:3.40.470.10:FF:000021', NULL, NULL, 'Type-4 uracil-DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(131040, NULL, 'G3DSA:3.30.160.60:FF:004090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(131041, NULL, 'G3DSA:1.25.40.10:FF:002728', NULL, NULL, 'YALI0D23573p', NULL, NULL, NULL, NULL, NULL, 4),
(131042, NULL, 'G3DSA:2.60.40.60:FF:000153', NULL, NULL, 'Dachsous cadherin-related 2', NULL, NULL, NULL, NULL, NULL, 4),
(131043, NULL, 'G3DSA:3.80.10.10:FF:001999', NULL, NULL, 'Receptor like protein 45', NULL, NULL, NULL, NULL, NULL, 4),
(131044, NULL, 'G3DSA:1.20.1740.10:FF:000025', NULL, NULL, 'High-affinity methionine permease', NULL, NULL, NULL, NULL, NULL, 4),
(131045, NULL, 'G3DSA:2.20.70.10:FF:000198', NULL, NULL, 'transcriptional coactivator YAP1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(131046, NULL, 'G3DSA:3.90.190.10:FF:000460', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131047, NULL, 'G3DSA:3.40.50.10090:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131048, NULL, 'G3DSA:3.90.190.10:FF:000218', NULL, NULL, 'Protein tyrosine phosphatase A', NULL, NULL, NULL, NULL, NULL, 4),
(131049, NULL, 'G3DSA:3.30.70.1820:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131050, NULL, 'G3DSA:2.40.160.120:FF:000053', NULL, NULL, 'Oxysterol binding protein 9, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131051, NULL, 'G3DSA:3.40.50.2000:FF:000934', NULL, NULL, 'Macrolide glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(131052, NULL, 'G3DSA:2.130.10.10:FF:005961', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131053, NULL, 'G3DSA:2.130.10.30:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131054, NULL, 'G3DSA:3.30.200.20:FF:001962', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131055, NULL, 'G3DSA:1.20.5.1430:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131056, NULL, 'G3DSA:3.30.160.60:FF:005427', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131057, NULL, 'G3DSA:3.30.2170.10:FF:000011', NULL, NULL, 'Endonuclease V protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(131058, NULL, 'G3DSA:3.30.505.10:FF:000240', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131059, NULL, 'G3DSA:1.10.287.110:FF:000173', NULL, NULL, 'DnaJ domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(131060, NULL, 'G3DSA:3.50.50.60:FF:001422', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(131061, NULL, 'G3DSA:3.10.20.310:FF:000024', NULL, NULL, 'Outer membrane protein assembly factor BamA', NULL, NULL, NULL, NULL, NULL, 4),
(131062, NULL, 'G3DSA:1.10.150.20:FF:000267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131063, NULL, 'G3DSA:2.130.10.10:FF:000110', NULL, NULL, 'striatin-3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(131064, NULL, 'G3DSA:1.20.1250.20:FF:002183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131065, NULL, 'G3DSA:3.40.50.300:FF:007378', NULL, NULL, 'AFR093Wp', NULL, NULL, NULL, NULL, NULL, 4),
(131066, NULL, 'G3DSA:3.40.50.2000:FF:001007', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(131067, NULL, 'G3DSA:2.40.30.20:FF:000001', NULL, NULL, 'ATP synthase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(131068, NULL, 'G3DSA:2.60.120.1540:FF:000005', NULL, NULL, 'C3 and PZP like, alpha-2-macroglobulin domain containing 8', NULL, NULL, NULL, NULL, NULL, 4),
(131069, NULL, 'G3DSA:3.90.190.10:FF:000550', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131070, NULL, 'G3DSA:1.20.5.110:FF:000043', NULL, NULL, 'Protein transport protein sec9', NULL, NULL, NULL, NULL, NULL, 4),
(131071, NULL, 'G3DSA:3.30.160.60:FF:000290', NULL, NULL, 'Zinc finger protein 697 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(131072, NULL, 'G3DSA:1.10.8.60:FF:000295', NULL, NULL, 'Peroxisomal biogenesis factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(131073, NULL, 'G3DSA:1.25.40.10:FF:003280', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g14730', NULL, NULL, NULL, NULL, NULL, 4),
(131074, NULL, 'G3DSA:1.10.472.80:FF:000009', NULL, NULL, 'TBC1 domain family member 13', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(131075, NULL, 'G3DSA:1.10.8.60:FF:000385', NULL, NULL, 'Probable stage V sporulation protein K-putative ATPase of the AAA family', NULL, NULL, NULL, NULL, NULL, 4),
(131076, NULL, 'G3DSA:2.60.40.150:FF:000304', NULL, NULL, 'C2 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(131077, NULL, 'G3DSA:3.90.550.10:FF:000679', NULL, NULL, 'Fringe-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(131078, NULL, 'G3DSA:3.40.50.720:FF:001023', NULL, NULL, 'Glyceraldehyde 3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(131079, NULL, 'G3DSA:1.25.40.20:FF:001899', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131080, NULL, 'G3DSA:2.60.40.10:FF:003269', NULL, NULL, 'Interleukin 13 receptor, alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(131081, NULL, 'G3DSA:1.10.472.80:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131082, NULL, 'G3DSA:1.10.555.10:FF:000036', NULL, NULL, 'T-cell activation Rho GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(131083, NULL, 'G3DSA:3.30.160.60:FF:000048', NULL, NULL, 'GLI family zinc finger 3', NULL, NULL, NULL, NULL, NULL, 4),
(131084, NULL, 'G3DSA:1.25.40.10:FF:004858', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131085, NULL, 'G3DSA:2.130.10.10:FF:001072', NULL, NULL, 'Transcription factor unc-37', NULL, NULL, NULL, NULL, NULL, 4),
(131086, NULL, 'G3DSA:2.130.10.10:FF:001448', NULL, NULL, 'WD domain, G-beta repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(131087, NULL, 'G3DSA:3.40.120.10:FF:000034', NULL, NULL, 'Phosphomannomutase', NULL, NULL, NULL, NULL, NULL, 4),
(131088, NULL, 'G3DSA:2.60.40.770:FF:000018', NULL, NULL, 'Putative phosphatidylglycerol/phosphatidylinositol transfer protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(131089, NULL, 'G3DSA:3.40.50.720:FF:000950', NULL, NULL, 'C-terminal binding protein AN', NULL, NULL, NULL, NULL, NULL, 4),
(131090, NULL, 'G3DSA:2.60.120.330:FF:000047', NULL, NULL, 'Similar to oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(131091, NULL, 'G3DSA:1.10.20.10:FF:000315', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131092, NULL, 'G3DSA:3.40.710.10:FF:000118', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(131093, NULL, 'G3DSA:1.10.8.60:FF:000441', NULL, NULL, 'Peroxisome biogenesis protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(131094, NULL, 'G3DSA:1.10.555.10:FF:000221', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131095, NULL, 'G3DSA:2.40.50.100:FF:000127', NULL, NULL, 'Sugar ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(131096, NULL, 'G3DSA:3.40.50.2300:FF:001182', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131097, NULL, 'G3DSA:1.25.40.10:FF:001481', NULL, NULL, 'Os01g0176300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(131098, NULL, 'G3DSA:2.60.300.12:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131099, NULL, 'G3DSA:3.30.70.330:FF:002992', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131100, NULL, 'G3DSA:1.25.40.10:FF:001424', NULL, NULL, 'Shc1p', NULL, NULL, NULL, NULL, NULL, 4),
(131101, NULL, 'G3DSA:1.20.970.10:FF:000015', NULL, NULL, 'Anthranilate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(131102, NULL, 'G3DSA:3.10.450.10:FF:000026', NULL, NULL, 'CST8 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(131103, NULL, 'G3DSA:3.40.1110.10:FF:000084', NULL, NULL, 'Probable copper-transporting ATPase HMA5', NULL, NULL, NULL, NULL, NULL, 4),
(131104, NULL, 'G3DSA:3.40.710.10:FF:000175', NULL, NULL, '6-aminohexanoate-dimer hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(131105, NULL, 'G3DSA:3.90.190.10:FF:000308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131106, NULL, 'G3DSA:1.10.287.130:FF:000179', NULL, NULL, 'GAF sensor signal transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(131107, NULL, 'G3DSA:2.60.40.10:FF:004758', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131108, NULL, 'G3DSA:3.40.50.140:FF:000017', NULL, NULL, 'DNA topoisomerase (TopA)', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(131109, NULL, 'G3DSA:1.25.40.20:FF:000500', NULL, NULL, 'ankyrin repeat and KH domain-containing protein 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(131110, NULL, 'G3DSA:3.40.250.10:FF:000038', NULL, NULL, 'Rhodanese-like domain-containing protein 9, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(131111, NULL, 'G3DSA:3.40.50.620:FF:000919', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(131112, NULL, 'G3DSA:3.40.50.150:FF:000262', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(131113, NULL, 'G3DSA:2.60.40.10:FF:001324', NULL, NULL, 'Cell surface glycoprotein MUC18', NULL, NULL, NULL, NULL, NULL, 4),
(131114, NULL, 'G3DSA:3.40.30.10:FF:000900', NULL, NULL, 'UBX domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(131115, NULL, 'G3DSA:3.30.1130.10:FF:000008', NULL, NULL, 'GTP cyclohydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(131116, NULL, 'G3DSA:3.10.580.10:FF:000215', NULL, NULL, 'Voltage-gated chloride channel, CBS domain pair-containing, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131117, NULL, 'G3DSA:2.130.10.10:FF:005343', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131118, NULL, 'G3DSA:3.20.20.140:FF:000134', NULL, NULL, 'Inactive deaminase YBR284W', NULL, NULL, NULL, NULL, NULL, 4),
(131119, NULL, 'G3DSA:3.20.20.80:FF:000713', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131120, NULL, 'G3DSA:3.60.40.10:FF:000271', NULL, NULL, 'Protein phosphatase PTC7-like protein fig', NULL, NULL, NULL, NULL, NULL, 4),
(131121, NULL, 'G3DSA:3.30.160.60:FF:001537', NULL, NULL, 'Tramtrack, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(131122, NULL, 'G3DSA:3.20.20.80:FF:000770', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(131123, NULL, 'G3DSA:3.80.10.10:FF:003421', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131124, NULL, 'G3DSA:1.10.1370.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131125, NULL, 'G3DSA:2.10.25.10:FF:001521', NULL, NULL, 'Fibulin 1', NULL, NULL, NULL, NULL, NULL, 4),
(131126, NULL, 'G3DSA:3.10.110.10:FF:000012', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 variant 2', NULL, NULL, NULL, NULL, NULL, 4),
(131127, NULL, 'G3DSA:3.90.1150.10:FF:000176', NULL, NULL, '4-aminobutyrate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(131128, NULL, 'G3DSA:1.20.120.350:FF:000029', NULL, NULL, 'Potassium voltage-gated channel subfamily S member 2', NULL, NULL, NULL, NULL, NULL, 4),
(131129, NULL, 'G3DSA:3.40.1690.20:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131130, NULL, 'G3DSA:2.30.90.10:FF:000002', NULL, NULL, 'GM14327', NULL, NULL, NULL, NULL, NULL, 4),
(131131, NULL, 'G3DSA:3.90.228.10:FF:000071', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(131132, NULL, 'G3DSA:1.10.3500.10:FF:000021', NULL, NULL, 'Transcription elongation factor Spt6', NULL, NULL, NULL, NULL, NULL, 4),
(131133, NULL, 'G3DSA:3.30.40.10:FF:001087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131134, NULL, 'G3DSA:2.40.270.10:FF:000021', NULL, NULL, 'Late expression factor 8', NULL, NULL, NULL, NULL, NULL, 4),
(131135, NULL, 'G3DSA:2.130.10.10:FF:004938', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131136, NULL, 'G3DSA:3.30.1150.10:FF:000010', NULL, NULL, 'Energy transducer TonB', NULL, NULL, NULL, NULL, NULL, 4),
(131137, NULL, 'G3DSA:2.40.50.360:FF:000008', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(131138, NULL, 'G3DSA:3.40.50.2300:FF:001215', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131139, NULL, 'G3DSA:2.10.70.10:FF:000193', NULL, NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(131140, NULL, 'G3DSA:3.40.33.10:FF:000143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(131141, NULL, 'G3DSA:1.25.40.1040:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131142, NULL, 'G3DSA:3.40.50.300:FF:000234', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(131143, NULL, 'G3DSA:1.10.287.370:FF:000054', NULL, NULL, 'Prefoldin subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(131144, NULL, 'G3DSA:3.30.160.60:FF:001627', NULL, NULL, 'Zinc finger protein 655', NULL, NULL, NULL, NULL, NULL, 4),
(131145, NULL, 'G3DSA:2.60.40.1730:FF:000040', NULL, NULL, 'Protein CBG20905', NULL, NULL, NULL, NULL, NULL, 4),
(131146, NULL, 'G3DSA:3.30.1740.20:FF:000007', NULL, NULL, '40S ribosomal protein S26', NULL, NULL, NULL, NULL, NULL, 4),
(131147, NULL, 'G3DSA:3.30.1370.110:FF:000013', NULL, NULL, 'Endonuclease MutS2', NULL, NULL, NULL, NULL, NULL, 4),
(131148, NULL, 'G3DSA:3.30.1370.120:FF:000016', NULL, NULL, 'Type II secretion system protein D', NULL, NULL, NULL, NULL, NULL, 4),
(131149, NULL, 'G3DSA:1.10.8.10:FF:000090', NULL, NULL, 'Si:dkey-19e4.5', NULL, NULL, NULL, NULL, NULL, 4),
(131150, NULL, 'G3DSA:3.90.1720.10:FF:000028', NULL, NULL, 'Secreted antigen GbpB/SagA/PcsB peptidoglycan hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(131151, NULL, 'G3DSA:3.40.1800.20:FF:000027', NULL, NULL, 'Dorsal interacting protein 1, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(131152, NULL, 'G3DSA:3.40.50.720:FF:001731', NULL, NULL, '4-hydroxy-tetrahydrodipicolinate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(131153, NULL, 'G3DSA:4.10.1240.10:FF:000043', NULL, NULL, 'Parathyroid hormone 1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(131154, NULL, 'G3DSA:3.30.1740.10:FF:000004', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(131155, NULL, 'G3DSA:1.25.40.10:FF:005168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131156, NULL, 'G3DSA:3.20.20.80:FF:000803', NULL, NULL, 'Glutamate carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131157, NULL, 'G3DSA:3.30.565.10:FF:000125', NULL, NULL, 'Phytochrome', NULL, NULL, NULL, NULL, NULL, 4),
(131158, NULL, 'G3DSA:3.40.50.300:FF:005613', NULL, NULL, 'Dynein heavy chain 14, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(131159, NULL, 'G3DSA:3.40.50.1460:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131160, NULL, 'G3DSA:1.20.1560.10:FF:000281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131161, NULL, 'G3DSA:2.40.420.20:FF:000058', NULL, NULL, 'Acriflavin resistance protein E', NULL, NULL, NULL, NULL, NULL, 4),
(131162, NULL, 'G3DSA:1.50.10.100:FF:000003', NULL, NULL, 'Secreted protein', NULL, NULL, NULL, NULL, NULL, 4),
(131163, NULL, 'G3DSA:3.40.250.10:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131164, NULL, 'G3DSA:3.40.50.150:FF:001712', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131165, NULL, 'G3DSA:1.10.510.10:FF:001742', NULL, NULL, 'MAP kinase kinase kinase win1', NULL, NULL, NULL, NULL, NULL, 4),
(131166, NULL, 'G3DSA:3.20.20.70:FF:000800', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131167, NULL, 'G3DSA:3.90.1800.10:FF:000029', NULL, NULL, 'Zgc:66298 protein', NULL, NULL, NULL, NULL, NULL, 4),
(131168, NULL, 'G3DSA:3.30.450.40:FF:000143', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(131169, NULL, 'G3DSA:3.40.50.720:FF:000860', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(131170, NULL, 'G3DSA:3.40.50.2300:FF:000962', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131171, NULL, 'G3DSA:3.30.1660.10:FF:000003', NULL, NULL, 'DUF1471 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(131172, NULL, 'G3DSA:3.40.50.720:FF:001203', NULL, NULL, 'NADH-ubiquinone oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(131173, NULL, 'G3DSA:3.10.20.30:FF:000070', NULL, NULL, 'Protein FeSII', NULL, NULL, NULL, NULL, NULL, 4),
(131174, NULL, 'G3DSA:2.130.10.10:FF:000054', NULL, NULL, 'Putative WD repeat-containing protein 48', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(131175, NULL, 'G3DSA:3.80.10.10:FF:002926', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131176, NULL, 'G3DSA:2.130.10.10:FF:000144', NULL, NULL, 'DDB1- and CUL4-associated factor 8', NULL, NULL, NULL, NULL, NULL, 4),
(131177, NULL, 'G3DSA:3.40.50.720:FF:001113', NULL, NULL, 'Erythronate-4-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(131178, NULL, 'G3DSA:3.40.190.10:FF:000977', NULL, NULL, 'Putative binding protein HI_0213', NULL, NULL, NULL, NULL, NULL, 4),
(131179, NULL, 'G3DSA:1.20.1560.10:FF:000932', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131180, NULL, 'G3DSA:4.10.280.10:FF:000071', NULL, NULL, 'spermatogenesis- and oogenesis-specific basic helix-loop-helix-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(131181, NULL, 'G3DSA:3.40.1110.10:FF:000140', NULL, NULL, 'Copper-translocating P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(131182, NULL, 'G3DSA:2.130.10.10:FF:005433', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131183, NULL, 'G3DSA:3.30.300.30:FF:000129', NULL, NULL, 'AMP-binding enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131184, NULL, 'G3DSA:3.30.1370.240:FF:000001', NULL, NULL, 'phenylalanine--tRNA ligase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(131185, NULL, 'G3DSA:1.20.1260.100:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131186, NULL, 'G3DSA:3.80.10.10:FF:002550', NULL, NULL, 'Protein CBG01587', NULL, NULL, NULL, NULL, NULL, 4),
(131187, NULL, 'G3DSA:3.30.1370.100:FF:000010', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(131188, NULL, 'G3DSA:2.150.10.10:FF:000008', NULL, NULL, 'Adhesin', NULL, NULL, NULL, NULL, NULL, 4),
(131189, NULL, 'G3DSA:1.20.58.340:FF:000061', NULL, NULL, 'Mitochondrial inner membrane magnesium transporter MRS2', NULL, NULL, NULL, NULL, NULL, 4),
(131190, NULL, 'G3DSA:3.40.50.300:FF:001870', NULL, NULL, 'SNF2 family helicase/ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131191, NULL, 'G3DSA:3.30.160.60:FF:001717', NULL, NULL, 'Zinc finger and SCAN domain containing 5A', NULL, NULL, NULL, NULL, NULL, 4),
(131192, NULL, 'G3DSA:4.10.280.10:FF:000161', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(131193, NULL, 'G3DSA:1.25.10.10:FF:001653', NULL, NULL, 'sister chromatid cohesion protein PDS5 homolog A-B-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(131194, NULL, 'G3DSA:3.30.70.330:FF:003155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131195, NULL, 'G3DSA:3.40.190.10:FF:000269', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(131196, NULL, 'G3DSA:1.25.10.10:FF:001035', NULL, NULL, 'Binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(131197, NULL, 'G3DSA:3.40.50.300:FF:003578', NULL, NULL, 'Gluconokinase', NULL, NULL, NULL, NULL, NULL, 4),
(131198, NULL, 'G3DSA:3.80.10.10:FF:002308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131199, NULL, 'G3DSA:3.40.50.10130:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131200, NULL, 'G3DSA:1.25.40.90:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131201, NULL, 'G3DSA:1.10.8.10:FF:000123', NULL, NULL, 'Related to DSK2-ubiquitin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(131202, NULL, 'G3DSA:2.130.10.10:FF:003488', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131203, NULL, 'G3DSA:1.10.1900.50:FF:000001', NULL, NULL, 'NLR family CARD domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(131204, NULL, 'G3DSA:1.25.40.10:FF:005078', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(131205, NULL, 'G3DSA:2.120.10.30:FF:000111', NULL, NULL, 'EGF-like domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(131206, NULL, 'G3DSA:1.10.132.10:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131207, NULL, 'G3DSA:1.10.8.60:FF:000351', NULL, NULL, 'Lon protease homolog', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(131208, NULL, 'G3DSA:3.40.50.10140:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131209, NULL, 'G3DSA:3.40.50.10810:FF:000041', NULL, NULL, 'Chromatin remodeling protein', NULL, NULL, NULL, NULL, NULL, 4),
(131210, NULL, 'G3DSA:1.10.10.60:FF:000043', NULL, NULL, 'Hepatocyte nuclear factor 1-beta', NULL, NULL, NULL, NULL, NULL, 4),
(131211, NULL, 'G3DSA:1.10.287.3240:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131212, NULL, 'G3DSA:1.10.510.10:FF:001652', NULL, NULL, 'SR protein kinase, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(131213, NULL, 'G3DSA:3.40.50.300:FF:005580', NULL, NULL, 'SNF2 histone linker PHD RING helicase, E3 ubiquitin protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(131214, NULL, 'G3DSA:2.40.30.130:FF:000014', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(131215, NULL, 'G3DSA:3.40.50.2000:FF:000844', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131216, NULL, 'G3DSA:2.60.40.10:FF:003179', NULL, NULL, 'GM15804', NULL, NULL, NULL, NULL, NULL, 4),
(131217, NULL, 'G3DSA:3.50.50.60:FF:001332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131218, NULL, 'G3DSA:1.10.287.70:FF:000784', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131219, NULL, 'G3DSA:3.40.1180.10:FF:000032', NULL, NULL, 'Alkyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(131220, NULL, 'G3DSA:3.30.200.20:FF:001344', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131221, NULL, 'G3DSA:3.30.750.24:FF:000148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131222, NULL, 'G3DSA:1.10.1740.10:FF:000038', NULL, NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(131223, NULL, 'G3DSA:1.20.1740.10:FF:000137', NULL, NULL, 'Protein CBR-AAT-4', NULL, NULL, NULL, NULL, NULL, 4),
(131224, NULL, 'G3DSA:2.40.30.180:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131225, NULL, 'G3DSA:3.10.490.20:FF:000032', NULL, NULL, 'Cytoplasmic dynein 2 heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(131226, NULL, 'G3DSA:3.10.580.10:FF:000148', NULL, NULL, 'Os04g0644800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(131227, NULL, 'G3DSA:3.40.50.300:FF:000436', NULL, NULL, 'ATP binding cassette subfamily A member 9', NULL, NULL, NULL, NULL, NULL, 4),
(131228, NULL, 'G3DSA:1.20.58.60:FF:000759', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131229, NULL, 'G3DSA:2.30.30.230:FF:000007', NULL, NULL, 'Fumarylacetoacetase', NULL, NULL, NULL, NULL, NULL, 4),
(131230, NULL, 'G3DSA:3.20.20.80:FF:000483', NULL, NULL, 'Maltase A2', NULL, NULL, NULL, NULL, NULL, 4),
(131231, NULL, 'G3DSA:3.40.50.1820:FF:000863', NULL, NULL, 'GPI inositol-deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(131232, NULL, 'G3DSA:1.25.40.10:FF:003605', NULL, NULL, 'SET and MYND domain containing, class 4, member 1, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(131233, NULL, 'G3DSA:3.40.50.1000:FF:000151', NULL, NULL, 'Copper-translocating P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(131234, NULL, 'G3DSA:3.40.50.880:FF:000121', NULL, NULL, 'Glutamine amidotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(131235, NULL, 'G3DSA:1.25.40.10:FF:003543', NULL, NULL, 'AAA ATPase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(131236, NULL, 'G3DSA:3.40.50.300:FF:005175', NULL, NULL, 'Cytidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(131237, NULL, 'G3DSA:3.10.110.10:FF:000220', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(131238, NULL, 'G3DSA:3.20.10.10:FF:000057', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(131239, NULL, 'G3DSA:1.10.520.10:FF:000012', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(131240, NULL, 'G3DSA:3.20.20.220:FF:000012', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(131241, NULL, 'G3DSA:2.60.40.10:FF:001594', NULL, NULL, 'Immunoglobulin heavy variable 9-4', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(131242, NULL, 'G3DSA:3.40.50.10380:FF:000007', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(131243, NULL, 'G3DSA:2.40.10.10:FF:000002', NULL, NULL, 'Transmembrane protease serine', NULL, NULL, NULL, NULL, NULL, 4),
(131244, NULL, 'G3DSA:3.40.50.1460:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131245, NULL, 'G3DSA:1.10.630.10:FF:000615', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131246, NULL, 'G3DSA:3.30.300.160:FF:000009', NULL, NULL, 'General secretion pathway protein E', NULL, NULL, NULL, NULL, NULL, 4),
(131247, NULL, 'G3DSA:3.40.50.1010:FF:000154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131248, NULL, 'G3DSA:1.10.287.3280:FF:000001', NULL, NULL, 'DNA damage-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(131249, NULL, 'G3DSA:1.10.510.10:FF:001596', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131250, NULL, 'G3DSA:1.10.4050.10:FF:000003', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(131251, NULL, 'G3DSA:4.10.400.10:FF:000340', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131252, NULL, 'G3DSA:3.40.50.800:FF:000092', NULL, NULL, 'Threonyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(131253, NULL, 'G3DSA:3.30.160.60:FF:000615', NULL, NULL, 'Zinc finger protein 536', NULL, NULL, NULL, NULL, NULL, 4),
(131254, NULL, 'G3DSA:1.50.40.10:FF:000219', NULL, NULL, 'Putative mitochondrial carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(131255, NULL, 'G3DSA:1.20.1070.10:FF:002109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131256, NULL, 'G3DSA:2.130.10.10:FF:001572', NULL, NULL, 'Zgc:171857', NULL, NULL, NULL, NULL, NULL, 4),
(131257, NULL, 'G3DSA:2.30.30.380:FF:000024', NULL, NULL, 'Vacuolar protein sorting protein (Vps36), putative', NULL, NULL, NULL, NULL, NULL, 4),
(131258, NULL, 'G3DSA:3.90.640.10:FF:000186', NULL, NULL, 'Actin7-2 (Actin-related protein)', NULL, NULL, NULL, NULL, NULL, 4),
(131259, NULL, 'G3DSA:3.30.70.1230:FF:000115', NULL, NULL, 'Soluble guanylate cyclase gcy-35', NULL, NULL, NULL, NULL, NULL, 4),
(131260, NULL, 'G3DSA:3.80.10.10:FF:004343', NULL, NULL, 'Protein phosphatase 2C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131261, NULL, 'G3DSA:3.20.20.70:FF:000480', NULL, NULL, 'Lipoyl synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(131262, NULL, 'G3DSA:3.40.50.740:FF:000012', NULL, NULL, 'NADH dehydrogenase [ubiquinone] iron-sulfur protein 1 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(131263, NULL, 'G3DSA:1.25.10.10:FF:003036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131264, NULL, 'G3DSA:1.10.10.60:FF:000133', NULL, NULL, 'zinc fingers and homeoboxes protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(131265, NULL, 'G3DSA:3.30.70.270:FF:000265', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131266, NULL, 'G3DSA:3.40.50.2300:FF:000288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131267, NULL, 'G3DSA:3.30.590.20:FF:000001', NULL, NULL, 'Glutamate--cysteine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(131268, NULL, 'G3DSA:1.10.10.2330:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131269, NULL, 'G3DSA:3.90.1200.10:FF:000028', NULL, NULL, 'Homoserine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(131270, NULL, 'G3DSA:3.40.190.10:FF:000887', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131271, NULL, 'G3DSA:3.30.9.10:FF:000211', NULL, NULL, 'Dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(131272, NULL, 'G3DSA:3.80.10.10:FF:002640', NULL, NULL, 'F-box family protein', NULL, NULL, NULL, NULL, NULL, 4),
(131273, NULL, 'G3DSA:3.90.1150.10:FF:000389', NULL, NULL, 'Cc2-5', NULL, NULL, NULL, NULL, NULL, 4),
(131274, NULL, 'G3DSA:3.60.21.10:FF:000322', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131275, NULL, 'G3DSA:3.40.50.300:FF:006164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(131276, NULL, 'G3DSA:2.10.25.10:FF:000706', NULL, NULL, 'Heparan sulfate proteoglycan 2', NULL, NULL, NULL, NULL, NULL, 4),
(131277, NULL, 'G3DSA:3.60.10.10:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131278, NULL, 'G3DSA:1.10.10.10:FF:001686', NULL, NULL, 'Exopolysaccharide II synthesis transcriptional activator ExpG', NULL, NULL, NULL, NULL, NULL, 4),
(131279, NULL, 'G3DSA:3.30.420.40:FF:000967', NULL, NULL, 'ADR128Cp', NULL, NULL, NULL, NULL, NULL, 4),
(131280, NULL, 'G3DSA:1.20.5.170:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131281, NULL, 'G3DSA:1.10.472.80:FF:000010', NULL, NULL, 'Putative TBC1 domain family member 5', NULL, NULL, NULL, NULL, NULL, 4),
(131282, NULL, 'G3DSA:3.40.50.300:FF:007524', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131283, NULL, 'G3DSA:3.40.50.150:FF:000144', NULL, NULL, 'Putative methyltransferase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(131284, NULL, 'G3DSA:2.30.30.140:FF:000183', NULL, NULL, 'GD19236', NULL, NULL, NULL, NULL, NULL, 4),
(131285, NULL, 'G3DSA:1.10.10.10:FF:001911', NULL, NULL, 'Protein let-99', NULL, NULL, NULL, NULL, NULL, 4),
(131286, NULL, 'G3DSA:1.25.40.10:FF:005308', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(131287, NULL, 'G3DSA:2.60.40.10:FF:000071', NULL, NULL, 'Plexin A2', NULL, NULL, NULL, NULL, NULL, 4),
(131288, NULL, 'G3DSA:3.10.450.350:FF:000019', NULL, NULL, 'Family M23 zinc metallopeptidase with OapA domain', NULL, NULL, NULL, NULL, NULL, 4),
(131289, NULL, 'G3DSA:2.40.50.140:FF:000639', NULL, NULL, 'ATP-dependent DNA helicase RecG', NULL, NULL, NULL, NULL, NULL, 4),
(131290, NULL, 'G3DSA:1.20.1250.20:FF:000507', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(131291, NULL, 'G3DSA:2.20.28.10:FF:000010', NULL, NULL, 'Anaerobic nitric oxide reductase flavorubredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(131292, NULL, 'G3DSA:3.60.90.10:FF:000004', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(131293, NULL, 'G3DSA:3.40.50.300:FF:001538', NULL, NULL, 'Adenylate kinase 8', NULL, NULL, NULL, NULL, NULL, 4),
(131294, NULL, 'G3DSA:1.10.20.10:FF:000102', NULL, NULL, 'Histone H3-like centromeric protein CSE4', NULL, NULL, NULL, NULL, NULL, 4),
(131295, NULL, 'G3DSA:3.80.10.10:FF:004017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131296, NULL, 'G3DSA:3.30.160.20:FF:000183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131297, NULL, 'G3DSA:3.30.1360.120:FF:000019', NULL, NULL, 'Sarcosine oxidase gamma subunit', NULL, NULL, NULL, NULL, NULL, 4),
(131298, NULL, 'G3DSA:1.10.3380.10:FF:000022', NULL, NULL, 'Putative RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(131299, NULL, 'G3DSA:1.25.10.10:FF:000231', NULL, NULL, 'serine/threonine-protein kinase ULK4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(131300, NULL, 'G3DSA:2.130.10.10:FF:003696', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131301, NULL, 'G3DSA:3.90.190.10:FF:000336', NULL, NULL, 'Tyrosine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(131302, NULL, 'G3DSA:3.20.20.80:FF:000062', NULL, NULL, 'Klotho', NULL, NULL, NULL, NULL, NULL, 4),
(131303, NULL, 'G3DSA:3.40.390.10:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131304, NULL, 'G3DSA:1.25.40.420:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131305, NULL, 'G3DSA:3.40.50.300:FF:004040', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NUBP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(131306, NULL, 'G3DSA:2.40.50.140:FF:001196', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131307, NULL, 'G3DSA:1.20.1280.50:FF:000057', NULL, NULL, 'F-box only protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(131308, NULL, 'G3DSA:2.60.120.260:FF:000498', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(131309, NULL, 'G3DSA:1.20.1270.10:FF:000067', NULL, NULL, 'Bip', NULL, NULL, NULL, NULL, NULL, 4),
(131310, NULL, 'G3DSA:3.20.20.140:FF:000140', NULL, NULL, 'hydrolase TatD family protein', NULL, NULL, NULL, NULL, NULL, 4),
(131311, NULL, 'G3DSA:3.50.50.100:FF:000003', NULL, NULL, 'Apoptosis-inducing factor, mitochondrion-associated, 2', NULL, NULL, NULL, NULL, NULL, 4),
(131312, NULL, 'G3DSA:4.10.400.10:FF:000014', NULL, NULL, 'Relaxin family peptide receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(131313, NULL, 'G3DSA:3.30.200.20:FF:000006', NULL, NULL, 'TRAF2 and NCK-interacting protein kinase isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(131314, NULL, 'G3DSA:1.10.1040.10:FF:000064', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(131315, NULL, 'G3DSA:2.60.40.10:FF:001268', NULL, NULL, 'Blast:Protein CEPU-1', NULL, NULL, NULL, NULL, NULL, 4),
(131316, NULL, 'G3DSA:2.60.40.10:FF:003943', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131317, NULL, 'G3DSA:3.40.50.300:FF:008081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131318, NULL, 'G3DSA:3.30.870.10:FF:000031', NULL, NULL, 'Tyrosyl-DNA phosphodiesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(131319, NULL, 'G3DSA:3.30.10.20:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131320, NULL, 'G3DSA:1.10.101.10:FF:000044', NULL, NULL, 'Putative serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(131321, NULL, 'G3DSA:3.30.200.160:FF:000009', NULL, NULL, 'RNA polymerase III transcription factor IIIC subunit', NULL, NULL, NULL, NULL, NULL, 4),
(131322, NULL, 'G3DSA:2.60.120.200:FF:000183', NULL, NULL, 'Protein eyes shut homolog', NULL, NULL, NULL, NULL, NULL, 4),
(131323, NULL, 'G3DSA:2.30.29.170:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131324, NULL, 'G3DSA:1.10.472.80:FF:000061', NULL, NULL, 'GTPase-activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131325, NULL, 'G3DSA:3.90.228.20:FF:000012', NULL, NULL, 'Phosphoenolpyruvate carboxykinase [GTP]', NULL, NULL, NULL, NULL, NULL, 4),
(131326, NULL, 'G3DSA:1.10.510.10:FF:003945', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131327, NULL, 'G3DSA:1.25.40.410:FF:000011', NULL, NULL, 'DOCK-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131328, NULL, 'G3DSA:2.30.170.20:FF:000007', NULL, NULL, '60S ribosomal protein L24', NULL, NULL, NULL, NULL, NULL, 4),
(131329, NULL, 'G3DSA:1.10.245.10:FF:000001', NULL, NULL, 'SWI/SNF-related matrix-associated regulator of chromatin subfamily D member 3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(131330, NULL, 'G3DSA:1.25.40.420:FF:000014', NULL, NULL, 'kelch repeat and BTB domain-containing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(131331, NULL, 'G3DSA:3.40.50.620:FF:000482', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(131332, NULL, 'G3DSA:3.30.9.10:FF:000306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131333, NULL, 'G3DSA:3.40.50.360:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131334, NULL, 'G3DSA:3.30.420.40:FF:000107', NULL, NULL, 'Heat shock 70 kDa protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(131335, NULL, 'G3DSA:3.40.50.620:FF:000594', NULL, NULL, '(6-4) photolyase', NULL, NULL, NULL, NULL, NULL, 4),
(131336, NULL, 'G3DSA:3.40.50.720:FF:000686', NULL, NULL, '3 beta-hydroxysteroid dehydrogenase/Delta 5-->4-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(131337, NULL, 'G3DSA:1.10.287.470:FF:000090', NULL, NULL, 'Multidrug resistance efflux pump, RND family, membrane fusion protein EmrA', NULL, NULL, NULL, NULL, NULL, 4),
(131338, NULL, 'G3DSA:2.60.300.12:FF:000016', NULL, NULL, 'Iron-sulfur assembly protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131339, NULL, 'G3DSA:1.50.40.10:FF:000545', NULL, NULL, 'Mitochondrial carrier-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(131340, NULL, 'G3DSA:3.40.250.10:FF:000128', NULL, NULL, 'Thiosulfate sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(131341, NULL, 'G3DSA:4.10.1000.10:FF:000115', NULL, NULL, 'Zinc finger CCCH domain-containing protein 3 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(131342, NULL, 'G3DSA:3.20.80.10:FF:000005', NULL, NULL, 'Transcriptional regulator, effector binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(131343, NULL, 'G3DSA:2.60.120.290:FF:000041', NULL, NULL, 'Kremen protein', NULL, NULL, NULL, NULL, NULL, 4),
(131344, NULL, 'G3DSA:3.40.710.10:FF:000113', NULL, NULL, 'Cell division protein/Peptidoglycan synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(131345, NULL, 'G3DSA:2.30.180.10:FF:000044', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(131346, NULL, 'G3DSA:2.40.50.700:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131347, NULL, 'G3DSA:3.30.70.330:FF:000098', NULL, NULL, 'TAR DNA-binding protein 43', NULL, NULL, NULL, NULL, NULL, 4),
(131348, NULL, 'G3DSA:1.25.40.570:FF:000031', NULL, NULL, 'Proteasome regulatory subunit putative', NULL, NULL, NULL, NULL, NULL, 4),
(131349, NULL, 'G3DSA:1.10.472.80:FF:000268', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131350, NULL, 'G3DSA:3.20.20.80:FF:000157', NULL, NULL, 'Alpha-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(131351, NULL, 'G3DSA:2.130.10.10:FF:004213', NULL, NULL, 'Hypothetical WD40 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(131352, NULL, 'G3DSA:1.20.1110.10:FF:000174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131353, NULL, 'G3DSA:2.30.42.10:FF:000599', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131354, NULL, 'G3DSA:1.10.472.80:FF:000217', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131355, NULL, 'G3DSA:3.40.50.300:FF:007592', NULL, NULL, 'ATP-dependent RNA helicase dbp6', NULL, NULL, NULL, NULL, NULL, 4),
(131356, NULL, 'G3DSA:3.40.50.2300:FF:001277', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131357, NULL, 'G3DSA:1.25.40.20:FF:000062', NULL, NULL, 'ankyrin repeat domain-containing protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(131358, NULL, 'G3DSA:3.90.79.10:FF:000111', NULL, NULL, 'Hydrolase, NUDIX family protein', NULL, NULL, NULL, NULL, NULL, 4),
(131359, NULL, 'G3DSA:2.30.110.10:FF:000096', NULL, NULL, 'Putative oxidoreductase, MmyF', NULL, NULL, NULL, NULL, NULL, 4),
(131360, NULL, 'G3DSA:3.30.60.220:FF:000001', NULL, NULL, 'Probable ATP-dependent RNA helicase DDX59', NULL, NULL, NULL, NULL, NULL, 4),
(131361, NULL, 'G3DSA:2.10.50.10:FF:000045', NULL, NULL, 'Cysteine repeat modular protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(131362, NULL, 'G3DSA:1.20.1560.10:FF:000786', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131363, NULL, 'G3DSA:1.10.287.1490:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131364, NULL, 'G3DSA:3.40.50.300:FF:001690', NULL, NULL, 'tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(131365, NULL, 'G3DSA:2.30.30.490:FF:000006', NULL, NULL, 'DNA (cytosine-5)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(131366, NULL, 'G3DSA:1.10.510.10:FF:001854', NULL, NULL, 'Protein_kinase_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(131367, NULL, 'G3DSA:1.10.238.110:FF:000006', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(131368, NULL, 'G3DSA:1.10.10.160:FF:000007', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(131369, NULL, 'G3DSA:2.30.42.10:FF:000099', NULL, NULL, 'Phosphatidylinositol-3,4,5-trisphosphate dependent Rac exchange factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(131370, NULL, 'G3DSA:3.30.70.330:FF:000839', NULL, NULL, 'Multiple RNA-binding domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(131371, NULL, 'G3DSA:1.20.1250.20:FF:001401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131372, NULL, 'G3DSA:3.40.50.1220:FF:000099', NULL, NULL, '2-hydroxyphytanoyl-CoA lyase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131373, NULL, 'G3DSA:3.30.70.3030:FF:000009', NULL, NULL, 'U3 small nucleolar RNA-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(131374, NULL, 'G3DSA:3.30.70.330:FF:000991', NULL, NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(131375, NULL, 'G3DSA:1.10.565.10:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131376, NULL, 'G3DSA:3.40.630.10:FF:000112', NULL, NULL, 'Carboxypeptidase Q', NULL, NULL, NULL, NULL, NULL, 4),
(131377, NULL, 'G3DSA:1.10.238.100:FF:000003', NULL, NULL, 'Transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(131378, NULL, 'G3DSA:3.40.30.10:FF:000905', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(131379, NULL, 'G3DSA:3.40.1190.20:FF:000187', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131380, NULL, 'G3DSA:2.130.10.10:FF:001358', NULL, NULL, 'Retinoblastoma-binding-like protein E', NULL, NULL, NULL, NULL, NULL, 4),
(131381, NULL, 'G3DSA:1.20.1410.10:FF:000039', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(131382, NULL, 'G3DSA:1.10.10.140:FF:000001', NULL, NULL, 'Cytochrome c oxidase subunit 6B1', NULL, NULL, NULL, NULL, NULL, 4),
(131383, NULL, 'G3DSA:3.40.50.2000:FF:000642', NULL, NULL, 'Mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(131384, NULL, 'G3DSA:1.20.5.300:FF:000004', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(131385, NULL, 'G3DSA:3.40.50.2000:FF:001131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131386, NULL, 'G3DSA:1.10.1520.10:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131387, NULL, 'G3DSA:3.30.450.60:FF:000093', NULL, NULL, 'AP complex subunit sigma', NULL, NULL, NULL, NULL, NULL, 4),
(131388, NULL, 'G3DSA:3.40.50.300:FF:003876', NULL, NULL, 'RecA/RadA recombinase', NULL, NULL, NULL, NULL, NULL, 4),
(131389, NULL, 'G3DSA:1.20.120.350:FF:000142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131390, NULL, 'G3DSA:1.10.510.10:FF:002956', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131391, NULL, 'G3DSA:3.30.460.10:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131392, NULL, 'G3DSA:1.10.287.70:FF:000492', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(131393, NULL, 'G3DSA:1.25.40.10:FF:001514', NULL, NULL, 'Leucine Rich Repeat domain protein (AFU_orthologue AFUA_7G02000)', NULL, NULL, NULL, NULL, NULL, 4),
(131394, NULL, 'G3DSA:2.60.40.150:FF:000310', NULL, NULL, 'AGAP005288-PA', NULL, NULL, NULL, NULL, NULL, 4),
(131395, NULL, 'G3DSA:3.40.50.2300:FF:001070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131396, NULL, 'G3DSA:3.40.50.300:FF:001785', NULL, NULL, 'Early gene transcription factor VETF small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(131397, NULL, 'G3DSA:1.10.1580.10:FF:000003', NULL, NULL, 'Ribosome biogenesis GTPase A', NULL, NULL, NULL, NULL, NULL, 4),
(131398, NULL, 'G3DSA:2.30.31.50:FF:000001', NULL, NULL, 'ErpC', NULL, NULL, NULL, NULL, NULL, 4),
(131399, NULL, 'G3DSA:1.20.1070.10:FF:001075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131400, NULL, 'G3DSA:3.20.20.70:FF:000154', NULL, NULL, 'Probable nitronate monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(131401, NULL, 'G3DSA:3.60.15.10:FF:000229', NULL, NULL, 'Ribonuclease Z', NULL, NULL, NULL, NULL, NULL, 4),
(131402, NULL, 'G3DSA:1.25.40.790:FF:000012', NULL, NULL, 'Domain_of_uncharacterized_function_(DUF3819)/CCR4 -Not_complex_component_-_Not1_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(131403, NULL, 'G3DSA:1.10.10.1940:FF:000002', NULL, NULL, 'PHAryngeal gland Toxin-related', NULL, NULL, NULL, NULL, NULL, 4),
(131404, NULL, 'G3DSA:1.10.860.10:FF:000003', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(131405, NULL, 'G3DSA:1.10.150.50:FF:000231', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(131406, NULL, 'G3DSA:3.30.160.60:FF:004005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131407, NULL, 'G3DSA:2.30.30.490:FF:000057', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(131408, NULL, 'G3DSA:1.10.555.10:FF:000215', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131409, NULL, 'G3DSA:3.40.50.1820:FF:001060', NULL, NULL, 'Triacylglycerol lipase', NULL, NULL, NULL, NULL, NULL, 4),
(131410, NULL, 'G3DSA:1.10.630.10:FF:000520', NULL, NULL, 'Os10g0172100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(131411, NULL, 'G3DSA:1.25.40.20:FF:001517', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131412, NULL, 'G3DSA:2.30.30.210:FF:000001', NULL, NULL, 'Ribonuclease P protein subunit p29', NULL, NULL, NULL, NULL, NULL, 4),
(131413, NULL, 'G3DSA:3.30.1360.40:FF:000006', NULL, NULL, 'Arginine repressor', NULL, NULL, NULL, NULL, NULL, 4),
(131414, NULL, 'G3DSA:3.20.20.60:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131415, NULL, 'G3DSA:3.60.20.10:FF:000056', NULL, NULL, 'NAD(P)H-dependent glutamate synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131416, NULL, 'G3DSA:2.60.60.20:FF:000018', NULL, NULL, 'Lipoxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(131417, NULL, 'G3DSA:3.30.2310.20:FF:000014', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(131418, NULL, 'G3DSA:2.40.50.140:FF:000965', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131419, NULL, 'G3DSA:3.90.1100.10:FF:000032', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(131420, NULL, 'G3DSA:3.80.10.10:FF:004438', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(131421, NULL, 'G3DSA:2.30.30.140:FF:000132', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(131422, NULL, 'G3DSA:1.25.40.10:FF:005281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131423, NULL, 'G3DSA:2.10.25.10:FF:000644', NULL, NULL, 'Uromodulin', NULL, NULL, NULL, NULL, NULL, 4),
(131424, NULL, 'G3DSA:3.90.640.10:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131425, NULL, 'G3DSA:3.30.1360.30:FF:000003', NULL, NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit E', NULL, NULL, NULL, NULL, NULL, 4),
(131426, NULL, 'G3DSA:1.20.140.10:FF:000093', NULL, NULL, 'Very long chain acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(131427, NULL, 'G3DSA:2.30.30.100:FF:000199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131428, NULL, 'G3DSA:2.10.25.10:FF:000583', NULL, NULL, 'Os02g0633066 protein', NULL, NULL, NULL, NULL, NULL, 4),
(131429, NULL, 'G3DSA:1.50.40.10:FF:000107', NULL, NULL, 'Mitochondrial dicarboxylate carrier', NULL, NULL, NULL, NULL, NULL, 4),
(131430, NULL, 'G3DSA:2.10.50.10:FF:000096', NULL, NULL, 'Hematopoietic death receptor', NULL, NULL, NULL, NULL, NULL, 4),
(131431, NULL, 'G3DSA:1.20.144.10:FF:000101', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(131432, NULL, 'G3DSA:3.40.50.200:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131433, NULL, 'G3DSA:1.25.40.10:FF:003717', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131434, NULL, 'G3DSA:3.40.50.300:FF:005349', NULL, NULL, 'endoribonuclease Dicer', NULL, NULL, NULL, NULL, NULL, 4),
(131435, NULL, 'G3DSA:3.90.1720.10:FF:000023', NULL, NULL, 'NLP/P60 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(131436, NULL, 'G3DSA:3.40.1380.10:FF:000007', NULL, NULL, 'ATP synthase gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(131437, NULL, 'G3DSA:3.40.50.1010:FF:000266', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131438, NULL, 'G3DSA:3.40.50.720:FF:000068', NULL, NULL, 'Sorbitol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(131439, NULL, 'G3DSA:2.60.40.4370:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131440, NULL, 'G3DSA:3.40.50.10470:FF:000034', NULL, NULL, 'Unplaced genomic scaffold supercont1.24, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(131441, NULL, 'G3DSA:3.40.50.300:FF:005287', NULL, NULL, 'Elongator complex protein 5', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(131442, NULL, 'G3DSA:3.30.65.10:FF:000003', NULL, NULL, 'DNA topoisomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(131443, NULL, 'G3DSA:1.25.40.10:FF:003431', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g62670, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(131444, NULL, 'G3DSA:3.40.50.2000:FF:000288', NULL, NULL, 'ALG11p Alpha-1,2-mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(131445, NULL, 'G3DSA:1.20.1070.10:FF:000518', NULL, NULL, 'G-protein coupled receptor daf-38', NULL, NULL, NULL, NULL, NULL, 4),
(131446, NULL, 'G3DSA:3.30.1360.170:FF:000006', NULL, NULL, 'Thymidylate synthase ThyX', NULL, NULL, NULL, NULL, NULL, 4),
(131447, NULL, 'G3DSA:3.40.30.50:FF:000002', NULL, NULL, 'Selenoprotein M', NULL, NULL, NULL, NULL, NULL, 4),
(131448, NULL, 'G3DSA:3.30.160.60:FF:002240', NULL, NULL, 'Zinc finger protein 26-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(131449, NULL, 'G3DSA:3.30.310.80:FF:000038', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(131450, NULL, 'G3DSA:3.40.50.1820:FF:001352', NULL, NULL, 'Dihydromonacolin L-[lovastatin nonaketide synthase] thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(131451, NULL, 'G3DSA:3.30.1360.180:FF:000009', NULL, NULL, 'Putative ectonucleotide pyrophosphatase/phosphodiesterase, [includes: alkaline phosphodiesterase (Ec 3.1.4.1) nucleotide pyrophosphatase (Ec 3.6.1.9)]', NULL, NULL, NULL, NULL, NULL, 4),
(131452, NULL, 'G3DSA:2.130.10.10:FF:002061', NULL, NULL, 'Putative beta propeller protein', NULL, NULL, NULL, NULL, NULL, 4),
(131453, NULL, 'G3DSA:3.30.980.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131454, NULL, 'G3DSA:3.30.230.80:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131455, NULL, 'G3DSA:1.10.3730.20:FF:000002', NULL, NULL, 'Probable 4-amino-4-deoxy-L-arabinose-phosphoundecaprenol flippase subunit ArnE', NULL, NULL, NULL, NULL, NULL, 4),
(131456, NULL, 'G3DSA:2.60.40.10:FF:001526', NULL, NULL, 'Alpha-L-iduronidase', NULL, NULL, NULL, NULL, NULL, 4),
(131457, NULL, 'G3DSA:2.130.10.10:FF:005287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131458, NULL, 'G3DSA:1.25.40.1040:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131459, NULL, 'G3DSA:3.30.40.10:FF:001121', NULL, NULL, 'TRAF6', NULL, NULL, NULL, NULL, NULL, 4),
(131460, NULL, 'G3DSA:2.30.42.10:FF:000453', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131461, NULL, 'G3DSA:3.40.50.150:FF:001504', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131462, NULL, 'G3DSA:3.30.420.40:FF:000321', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(131463, NULL, 'G3DSA:2.10.70.10:FF:000221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131464, NULL, 'G3DSA:1.20.1270.280:FF:000003', NULL, NULL, 'Dynein axonemal heavy chain 17', NULL, NULL, NULL, NULL, NULL, 4),
(131465, NULL, 'G3DSA:3.80.10.10:FF:002426', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131466, NULL, 'G3DSA:2.60.34.20:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131467, NULL, 'G3DSA:3.30.420.10:FF:000453', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131468, NULL, 'G3DSA:1.10.441.10:FF:000002', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(131469, NULL, 'G3DSA:1.20.140.10:FF:000042', NULL, NULL, 'Acyl-CoA dehydrogenase FadE10', NULL, NULL, NULL, NULL, NULL, 4),
(131470, NULL, 'G3DSA:3.30.70.1230:FF:000054', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(131471, NULL, 'G3DSA:2.10.25.10:FF:001100', NULL, NULL, 'Transmembrane cell adhesion receptor mua-3', NULL, NULL, NULL, NULL, NULL, 4),
(131472, NULL, 'G3DSA:1.20.920.10:FF:000164', NULL, NULL, 'Pbrm-1', NULL, NULL, NULL, NULL, NULL, 4),
(131473, NULL, 'G3DSA:3.40.50.11660:FF:000026', NULL, NULL, 'Alpha3-fucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(131474, NULL, 'G3DSA:3.40.50.150:FF:000987', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(131475, NULL, 'G3DSA:1.50.10.10:FF:000217', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(131476, NULL, 'G3DSA:3.40.50.300:FF:002802', NULL, NULL, 'Helicase in mitochondria', NULL, NULL, NULL, NULL, NULL, 4),
(131477, NULL, 'G3DSA:3.10.20.90:FF:000301', NULL, NULL, 'Small ubiquitin-related modifier 1', NULL, NULL, NULL, NULL, NULL, 4),
(131478, NULL, 'G3DSA:3.30.1390.30:FF:000005', NULL, NULL, 'Peptidoglycan D,D-transpeptidase MrdA', NULL, NULL, NULL, NULL, NULL, 4),
(131479, NULL, 'G3DSA:3.40.720.10:FF:000153', NULL, NULL, 'Heparan N-sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(131480, NULL, 'G3DSA:1.20.1270.280:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131481, NULL, 'G3DSA:3.30.160.60:FF:003393', NULL, NULL, 'Zinc finger protein 347', NULL, NULL, NULL, NULL, NULL, 4),
(131482, NULL, 'G3DSA:2.10.25.20:FF:000001', NULL, NULL, 'Fiber', NULL, NULL, NULL, NULL, NULL, 4),
(131483, NULL, 'G3DSA:3.30.830.10:FF:000034', NULL, NULL, 'presequence protease 1, chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(131484, NULL, 'G3DSA:1.10.8.10:FF:000185', NULL, NULL, 'Tdpt-1', NULL, NULL, NULL, NULL, NULL, 4),
(131485, NULL, 'G3DSA:3.80.10.10:FF:002718', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(131486, NULL, 'G3DSA:3.40.50.150:FF:001779', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131487, NULL, 'G3DSA:1.20.5.740:FF:000001', NULL, NULL, 'nudC domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(131488, NULL, 'G3DSA:3.30.505.10:FF:000037', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(131489, NULL, 'G3DSA:1.10.1280.10:FF:000019', NULL, NULL, 'Grixazone synthase', NULL, NULL, NULL, NULL, NULL, 4),
(131490, NULL, 'G3DSA:3.90.870.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131491, NULL, 'G3DSA:1.10.8.60:FF:000413', NULL, NULL, 'Sigma-54-dependent transcriptional response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(131492, NULL, 'G3DSA:3.60.40.10:FF:000068', NULL, NULL, 'Protein phosphatase 2C 29 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(131493, NULL, 'G3DSA:3.30.1390.20:FF:000002', NULL, NULL, '60S ribosomal protein L7', NULL, NULL, NULL, NULL, NULL, 4),
(131494, NULL, 'G3DSA:3.40.50.1100:FF:000181', NULL, NULL, 'Threonine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(131495, NULL, 'G3DSA:2.130.10.10:FF:001779', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131496, NULL, 'G3DSA:1.10.238.10:FF:000035', NULL, NULL, 'Calcium and integrin-binding family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(131497, NULL, 'G3DSA:1.25.40.10:FF:005229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131498, NULL, 'G3DSA:1.10.287.1250:FF:000004', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(131499, NULL, 'G3DSA:3.40.630.30:FF:000332', NULL, NULL, 'Toxin resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(131500, NULL, 'G3DSA:2.30.30.40:FF:000041', NULL, NULL, 'Intersectin 1', NULL, NULL, NULL, NULL, NULL, 4),
(131501, NULL, 'G3DSA:3.40.50.10190:FF:000220', NULL, NULL, 'DNA repair protein XRCC1', NULL, NULL, NULL, NULL, NULL, 4),
(131502, NULL, 'G3DSA:1.10.287.1260:FF:000007', NULL, NULL, 'Small conductance mechanosensitive ion channel', NULL, NULL, NULL, NULL, NULL, 4),
(131503, NULL, 'G3DSA:1.10.10.1200:FF:000005', NULL, NULL, 'Necdin homolog (Mouse)', NULL, NULL, NULL, NULL, NULL, 4),
(131504, NULL, 'G3DSA:2.40.50.90:FF:000096', NULL, NULL, 'Qin', NULL, NULL, NULL, NULL, NULL, 4),
(131505, NULL, 'G3DSA:3.30.1490.430:FF:000006', NULL, NULL, 'mRNA-capping enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(131506, NULL, 'G3DSA:3.40.50.2000:FF:000693', NULL, NULL, 'UDP-glucoronosyl and UDP-glucosyl transferase family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131507, NULL, 'G3DSA:1.25.40.10:FF:001918', NULL, NULL, 'Intraflagellar transport protein 56', NULL, NULL, NULL, NULL, NULL, 4),
(131508, NULL, 'G3DSA:3.40.930.10:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(131509, NULL, 'G3DSA:2.10.25.10:FF:000532', NULL, NULL, 'Multiple epidermal growth factor-like domains 8', NULL, NULL, NULL, NULL, NULL, 4),
(131510, NULL, 'G3DSA:3.90.550.10:FF:000145', NULL, NULL, 'Cellulose synthase-like protein H1', NULL, NULL, NULL, NULL, NULL, 4),
(131511, NULL, 'G3DSA:3.80.10.10:FF:001066', NULL, NULL, 'Leucine-rich repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(131512, NULL, 'G3DSA:3.50.50.60:FF:000871', NULL, NULL, 'Digeranylgeranylglycerophospholipid reductase', NULL, NULL, NULL, NULL, NULL, 4),
(131513, NULL, 'G3DSA:3.40.50.150:FF:001830', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131514, NULL, 'G3DSA:3.20.20.140:FF:000252', NULL, NULL, 'WGS project CABT00000000 data, contig 2.6', NULL, NULL, NULL, NULL, NULL, 4),
(131515, NULL, 'G3DSA:3.40.30.10:FF:000670', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(131516, NULL, 'G3DSA:3.40.250.10:FF:000066', NULL, NULL, 'MercaptoPyruvate SulfurTransferase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(131517, NULL, 'G3DSA:3.40.50.300:FF:005675', NULL, NULL, 'Dynein-1-beta heavy chain, flagellar inner arm I1 complex', NULL, NULL, NULL, NULL, NULL, 4),
(131518, NULL, 'G3DSA:4.10.400.10:FF:000126', NULL, NULL, 'low-density lipoprotein receptor class A domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(131519, NULL, 'G3DSA:3.30.160.60:FF:000115', NULL, NULL, 'Zinc finger and BTB domain containing 7C', NULL, NULL, NULL, NULL, NULL, 4),
(131520, NULL, 'G3DSA:2.60.120.200:FF:000475', NULL, NULL, 'Laminin subunit alpha-1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(131521, NULL, 'G3DSA:3.30.70.890:FF:000046', NULL, NULL, 'GHMP kinase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(131522, NULL, 'G3DSA:1.10.510.10:FF:003653', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131523, NULL, 'G3DSA:3.30.930.10:FF:000244', NULL, NULL, 'Phenylalanine-tRNA ligase, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(131524, NULL, 'G3DSA:2.60.40.10:FF:000520', NULL, NULL, 'ephrin type-B receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(131525, NULL, 'G3DSA:3.30.420.610:FF:000014', NULL, NULL, 'Tudor domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(131526, NULL, 'G3DSA:3.30.160.60:FF:001397', NULL, NULL, 'Datilografo, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(131527, NULL, 'G3DSA:3.30.710.10:FF:000379', NULL, NULL, 'SD03430p', NULL, NULL, NULL, NULL, NULL, 4),
(131528, NULL, 'G3DSA:2.60.120.10:FF:000258', NULL, NULL, '3-hydroxyanthranilate 3,4-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(131529, NULL, 'G3DSA:2.60.40.1770:FF:000001', NULL, NULL, 'Ephrin type-A receptor 5', NULL, NULL, NULL, NULL, NULL, 4),
(131530, NULL, 'G3DSA:3.30.300.30:FF:000124', NULL, NULL, 'Acetyl-CoA synthetase (Acetate-CoA ligase) amino-end. (AcsA-3)', NULL, NULL, NULL, NULL, NULL, 4),
(131531, NULL, 'G3DSA:1.20.5.1500:FF:000008', NULL, NULL, 'Testis-specific Y-encoded-like protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(131532, NULL, 'G3DSA:1.10.287.1240:FF:000001', NULL, NULL, 'Exodeoxyribonuclease I', NULL, NULL, NULL, NULL, NULL, 4),
(131533, NULL, 'G3DSA:2.60.40.10:FF:000166', NULL, NULL, 'E3 ubiquitin-protein ligase MYCBP2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(131534, NULL, 'G3DSA:1.50.40.10:FF:000433', NULL, NULL, 'Solute carrier family 25 member 11', NULL, NULL, NULL, NULL, NULL, 4),
(131535, NULL, 'G3DSA:1.10.510.10:FF:000522', NULL, NULL, 'L-type lectin-domain containing receptor kinase IX.1', NULL, NULL, NULL, NULL, NULL, 4),
(131536, NULL, 'G3DSA:2.60.120.920:FF:000005', NULL, NULL, 'Putative E3 ubiquitin-protein ligase NEURL1B', NULL, NULL, NULL, NULL, NULL, 4),
(131537, NULL, 'G3DSA:1.20.58.400:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131538, NULL, 'G3DSA:3.40.630.30:FF:000040', NULL, NULL, 'N-acetyltransferase 9 (putative)', NULL, NULL, NULL, NULL, NULL, 4),
(131539, NULL, 'G3DSA:1.10.510.10:FF:003833', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131540, NULL, 'G3DSA:1.20.1560.10:FF:000718', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(131541, NULL, 'G3DSA:1.10.3380.10:FF:000073', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(131542, NULL, 'G3DSA:2.10.25.10:FF:000257', NULL, NULL, 'Fibulin-1', NULL, NULL, NULL, NULL, NULL, 4),
(131543, NULL, 'G3DSA:1.10.287.130:FF:000246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131544, NULL, 'G3DSA:1.10.1040.50:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131545, NULL, 'G3DSA:3.20.20.140:FF:000432', NULL, NULL, 'AMP deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(131546, NULL, 'G3DSA:1.10.437.10:FF:000043', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(131547, NULL, 'G3DSA:1.10.1420.10:FF:000110', NULL, NULL, 'DNA mismatch repair protein Msh2', NULL, NULL, NULL, NULL, NULL, 4),
(131548, NULL, 'G3DSA:3.20.10.10:FF:000006', NULL, NULL, 'Branched-chain amino acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(131549, NULL, 'G3DSA:3.40.50.720:FF:000394', NULL, NULL, 'GDP-L-fucose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(131550, NULL, 'G3DSA:3.40.430.10:FF:000052', NULL, NULL, 'Riboflavin biosynthesis protein RibD', NULL, NULL, NULL, NULL, NULL, 4),
(131551, NULL, 'G3DSA:3.90.700.10:FF:000011', NULL, NULL, 'Putative FAD-binding dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(131552, NULL, 'G3DSA:2.60.40.10:FF:004966', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131553, NULL, 'G3DSA:3.40.850.10:FF:000483', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131554, NULL, 'G3DSA:3.90.245.10:FF:000032', NULL, NULL, 'AT5g18860/F17K4_110', NULL, NULL, NULL, NULL, NULL, 4),
(131555, NULL, 'G3DSA:3.40.50.300:FF:007266', NULL, NULL, 'RAB20, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(131556, NULL, 'G3DSA:3.30.420.10:FF:000683', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131557, NULL, 'G3DSA:1.10.8.870:FF:000003', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(131558, NULL, 'G3DSA:1.25.40.10:FF:003482', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(131559, NULL, 'G3DSA:1.20.120.550:FF:000033', NULL, NULL, 'Arachidonate 5-lipoxygenase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(131560, NULL, 'G3DSA:1.25.40.20:FF:000174', NULL, NULL, 'Espin', NULL, NULL, NULL, NULL, NULL, 4),
(131561, NULL, 'G3DSA:3.40.1110.10:FF:000292', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131562, NULL, 'G3DSA:2.60.40.10:FF:005242', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131563, NULL, 'G3DSA:2.30.40.10:FF:000049', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(131564, NULL, 'G3DSA:1.10.510.10:FF:003092', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131565, NULL, 'G3DSA:2.10.25.10:FF:000818', NULL, NULL, 'Neurogenic locus notch homolog protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(131566, NULL, 'G3DSA:2.60.40.10:FF:005860', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131567, NULL, 'G3DSA:2.30.40.10:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131568, NULL, 'G3DSA:3.30.420.10:FF:000065', NULL, NULL, 'Protein RRP6-like 2 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(131569, NULL, 'G3DSA:3.40.50.360:FF:000140', NULL, NULL, 'NAD(P)H-dependent FAD/FMN reductase GTNG_3158', NULL, NULL, NULL, NULL, NULL, 4),
(131570, NULL, 'G3DSA:1.10.3710.10:FF:000003', NULL, NULL, 'ATPase, AAA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(131571, NULL, 'G3DSA:2.130.10.30:FF:000088', NULL, NULL, 'Regulator of chromosome condensation 1/beta-lactamase-inhibitor protein II', NULL, NULL, NULL, NULL, NULL, 4),
(131572, NULL, 'G3DSA:1.20.1270.60:FF:000054', NULL, NULL, 'Proline-serine-threonine phosphatase interacting protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(131573, NULL, 'G3DSA:2.10.25.10:FF:000206', NULL, NULL, 'Slit guidance ligand 3', NULL, NULL, NULL, NULL, NULL, 4),
(131574, NULL, 'G3DSA:3.30.30.170:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(131575, NULL, 'G3DSA:1.10.287.70:FF:000666', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131576, NULL, 'G3DSA:1.25.10.10:FF:001187', NULL, NULL, 'cilia- and flagella-associated protein 69 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(131577, NULL, 'G3DSA:3.20.20.70:FF:000328', NULL, NULL, 'Triosephosphate isomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(131578, NULL, 'G3DSA:1.10.510.10:FF:001528', NULL, NULL, 'Probable bifunctional tRNA threonylcarbamoyladenosine biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(131579, NULL, 'G3DSA:3.40.50.1700:FF:000029', NULL, NULL, 'Beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(131580, NULL, 'G3DSA:3.30.160.60:FF:000520', NULL, NULL, 'zinc finger protein 629 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(131581, NULL, 'G3DSA:3.30.160.60:FF:002291', NULL, NULL, 'Zinc finger protein 648', NULL, NULL, NULL, NULL, NULL, 4),
(131582, NULL, 'G3DSA:1.10.8.60:FF:000290', NULL, NULL, 'Replication factor C small subunit protein', NULL, NULL, NULL, NULL, NULL, 4),
(131583, NULL, 'G3DSA:3.30.40.10:FF:000665', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(131584, NULL, 'G3DSA:3.30.9.10:FF:000014', NULL, NULL, 'L-2-hydroxyglutarate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(131585, NULL, 'G3DSA:1.20.120.1130:FF:000006', NULL, NULL, 'Vacuolar protein sorting-associated protein 28 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(131586, NULL, 'G3DSA:3.40.50.620:FF:000156', NULL, NULL, 'Phosphopantetheine adenylyltransferase 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(131587, NULL, 'G3DSA:1.10.3860.10:FF:000036', NULL, NULL, 'Proton/sodium:glutamate symporter DAACS family', NULL, NULL, NULL, NULL, NULL, 4),
(131588, NULL, 'G3DSA:3.40.50.300:FF:001959', NULL, NULL, 'Putative dynein beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(131589, NULL, 'G3DSA:3.40.50.410:FF:000177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131590, NULL, 'G3DSA:3.30.530.20:FF:000104', NULL, NULL, 'START domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(131591, NULL, 'G3DSA:2.120.10.80:FF:000396', NULL, NULL, 'F-box/kelch-repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(131592, NULL, 'G3DSA:1.10.630.10:FF:000492', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131593, NULL, 'G3DSA:3.40.30.10:FF:000052', NULL, NULL, 'Thiol:disulfide interchange protein', NULL, NULL, NULL, NULL, NULL, 4),
(131594, NULL, 'G3DSA:1.20.58.1610:FF:000013', NULL, NULL, 'NADH-quinone oxidoreductase subunit A 2', NULL, NULL, NULL, NULL, NULL, 4),
(131595, NULL, 'G3DSA:1.20.1250.20:FF:000737', NULL, NULL, 'Major facilitator superfamily transporter', NULL, NULL, NULL, NULL, NULL, 4),
(131596, NULL, 'G3DSA:3.40.50.620:FF:000768', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(131597, NULL, 'G3DSA:1.10.287.370:FF:000026', NULL, NULL, 'Bud site selection protein', NULL, NULL, NULL, NULL, NULL, 4),
(131598, NULL, 'G3DSA:3.30.70.1470:FF:000007', NULL, NULL, 'Non-catalytic caspase homolog csp-3', NULL, NULL, NULL, NULL, NULL, 4),
(131599, NULL, 'G3DSA:1.25.40.20:FF:000612', NULL, NULL, 'Ankyrin repeat domain 2', NULL, NULL, NULL, NULL, NULL, 4),
(131600, NULL, 'G3DSA:3.40.50.150:FF:000470', NULL, NULL, 'mRNA capping enzyme-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(131601, NULL, 'G3DSA:3.40.630.150:FF:000005', NULL, NULL, 'Malonyl-coa decarboxylase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(131602, NULL, 'G3DSA:3.30.70.330:FF:003127', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131603, NULL, 'G3DSA:3.20.20.80:FF:000775', NULL, NULL, 'Putative secreted beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(131604, NULL, 'G3DSA:3.15.20.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131605, NULL, 'G3DSA:1.10.287.470:FF:000056', NULL, NULL, 'Efflux transporter, RND family, MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(131606, NULL, 'G3DSA:2.10.90.10:FF:000042', NULL, NULL, 'Cerberus 1 homolog (Xenopus laevis)', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(131607, NULL, 'G3DSA:3.40.140.10:FF:000030', NULL, NULL, 'Cytidine and dCMP deaminase domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(131608, NULL, 'G3DSA:3.60.21.10:FF:000081', NULL, NULL, 'Metallophosphoesterase 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(131609, NULL, 'G3DSA:3.40.630.30:FF:000039', NULL, NULL, 'Probable N-acetyltransferase 16', NULL, NULL, NULL, NULL, NULL, 4),
(131610, NULL, 'G3DSA:1.20.58.60:FF:000467', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131611, NULL, 'G3DSA:3.40.30.10:FF:000344', NULL, NULL, 'Calsequestrin', NULL, NULL, NULL, NULL, NULL, 4),
(131612, NULL, 'G3DSA:3.40.50.410:FF:000262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131613, NULL, 'G3DSA:3.30.70.660:FF:000062', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(131614, NULL, 'G3DSA:2.60.40.60:FF:000220', NULL, NULL, 'neural-cadherin isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(131615, NULL, 'G3DSA:3.40.50.1820:FF:000571', NULL, NULL, 'Epoxide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(131616, NULL, 'G3DSA:3.40.50.300:FF:001246', NULL, NULL, 'ATPase family AAA domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(131617, NULL, 'G3DSA:2.20.28.200:FF:000009', NULL, NULL, 'GG17292', NULL, NULL, NULL, NULL, NULL, 4),
(131618, NULL, 'G3DSA:3.40.1110.10:FF:000353', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131619, NULL, 'G3DSA:3.10.250.10:FF:000051', NULL, NULL, 'Si:dkey-242e21.3', NULL, NULL, NULL, NULL, NULL, 4),
(131620, NULL, 'G3DSA:1.10.510.10:FF:003445', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131621, NULL, 'G3DSA:3.90.640.90:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131622, NULL, 'G3DSA:3.20.20.70:FF:000772', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131623, NULL, 'G3DSA:1.25.10.10:FF:003328', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131624, NULL, 'G3DSA:3.90.650.10:FF:000029', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(131625, NULL, 'G3DSA:2.10.70.10:FF:000041', NULL, NULL, 'Complement factor H', NULL, NULL, NULL, NULL, NULL, 4),
(131626, NULL, 'G3DSA:2.30.30.190:FF:000006', NULL, NULL, 'Putative ubiquitin carboxyl-terminal hydrolase CYLD', NULL, NULL, NULL, NULL, NULL, 4),
(131627, NULL, 'G3DSA:3.30.160.60:FF:003549', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131628, NULL, 'G3DSA:1.10.10.10:FF:000894', NULL, NULL, 'Caffeic acid O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(131629, NULL, 'G3DSA:3.40.50.300:FF:003376', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131630, NULL, 'G3DSA:2.60.40.4070:FF:000011', NULL, NULL, 'Basal-body rod modification protein FlgD', NULL, NULL, NULL, NULL, NULL, 4),
(131631, NULL, 'G3DSA:4.10.60.10:FF:000199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131632, NULL, 'G3DSA:3.40.50.300:FF:002241', NULL, NULL, 'Arsenical pump-driving ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(131633, NULL, 'G3DSA:1.10.533.10:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131634, NULL, 'G3DSA:2.130.10.10:FF:005219', NULL, NULL, 'Proteasomal ATPase associated factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(131635, NULL, 'G3DSA:1.20.5.110:FF:000099', NULL, NULL, 'SNARE protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131636, NULL, 'G3DSA:1.10.390.10:FF:000080', NULL, NULL, 'Aminopeptidase N', NULL, NULL, NULL, NULL, NULL, 4),
(131637, NULL, 'G3DSA:3.40.50.1100:FF:000113', NULL, NULL, '1-aminocyclopropane-1-carboxylate deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(131638, NULL, 'G3DSA:2.10.25.10:FF:001072', NULL, NULL, 'Notch receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(131639, NULL, 'G3DSA:2.60.40.10:FF:003393', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131640, NULL, 'G3DSA:1.25.40.20:FF:001068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(131641, NULL, 'G3DSA:3.30.60.30:FF:000200', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(131642, NULL, 'G3DSA:3.50.50.60:FF:000545', NULL, NULL, 'FAD monooxygenase, PheA/TfdB family', NULL, NULL, NULL, NULL, NULL, 4),
(131643, NULL, 'G3DSA:1.20.1270.60:FF:000228', NULL, NULL, 'Protein kinase C and casein kinase substrate in neurons protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(131644, NULL, 'G3DSA:3.40.50.620:FF:000717', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(131645, NULL, 'G3DSA:2.60.120.200:FF:000683', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131646, NULL, 'G3DSA:3.10.250.10:FF:000101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131647, NULL, 'G3DSA:3.30.70.330:FF:002790', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131648, NULL, 'G3DSA:1.10.10.10:FF:001394', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(131649, NULL, 'G3DSA:3.40.140.10:FF:000125', NULL, NULL, 'Hypothetical_protein', NULL, NULL, NULL, NULL, NULL, 4),
(131650, NULL, 'G3DSA:3.40.50.300:FF:000150', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(131651, NULL, 'G3DSA:3.30.60.90:FF:000016', NULL, NULL, 'Refractory to sigma P', NULL, NULL, NULL, NULL, NULL, 4),
(131652, NULL, 'G3DSA:1.10.10.790:FF:000022', NULL, NULL, 'RNA binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131653, NULL, 'G3DSA:2.60.40.60:FF:000799', NULL, NULL, 'Desmocollin 3', NULL, NULL, NULL, NULL, NULL, 4),
(131654, NULL, 'G3DSA:3.40.50.10240:FF:000027', NULL, NULL, 'Thiamin pyrophosphokinase 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(131655, NULL, 'G3DSA:3.40.1180.10:FF:000026', NULL, NULL, 'Isoprenyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(131656, NULL, 'G3DSA:3.30.40.10:FF:000991', NULL, NULL, 'E3 ubiquitin-protein ligase RBX1', NULL, NULL, NULL, NULL, NULL, 4),
(131657, NULL, 'G3DSA:2.10.220.10:FF:000081', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(131658, NULL, 'G3DSA:2.10.25.10:FF:000414', NULL, NULL, 'von Willebrand factor', NULL, NULL, NULL, NULL, NULL, 4),
(131659, NULL, 'G3DSA:1.10.510.10:FF:002310', NULL, NULL, 'Serine/threonine protein kinase, putative (AFU_orthologue AFUA_5G07950)', NULL, NULL, NULL, NULL, NULL, 4),
(131660, NULL, 'G3DSA:2.130.10.10:FF:005545', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131661, NULL, 'G3DSA:3.30.420.10:FF:000571', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131662, NULL, 'G3DSA:2.60.40.10:FF:003117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131663, NULL, 'G3DSA:1.10.238.10:FF:000878', NULL, NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit B'''' subunit alpha, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131664, NULL, 'G3DSA:3.40.720.10:FF:000327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131665, NULL, 'G3DSA:3.40.50.720:FF:001175', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(131666, NULL, 'G3DSA:1.20.5.100:FF:000012', NULL, NULL, 'CYtochrome C', NULL, NULL, NULL, NULL, NULL, 4),
(131667, NULL, 'G3DSA:3.40.50.2000:FF:000849', NULL, NULL, 'Glr3757 protein', NULL, NULL, NULL, NULL, NULL, 4),
(131668, NULL, 'G3DSA:3.40.50.1110:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131669, NULL, 'G3DSA:1.25.40.10:FF:002588', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(131670, NULL, 'G3DSA:1.10.510.10:FF:001416', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131671, NULL, 'G3DSA:1.10.10.10:FF:001068', NULL, NULL, 'Cullin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(131672, NULL, 'G3DSA:2.60.110.10:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131673, NULL, 'G3DSA:1.25.40.10:FF:001065', NULL, NULL, 'Putative Heat shock protein STI', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(131674, NULL, 'G3DSA:3.40.720.10:FF:000232', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(131675, NULL, 'G3DSA:1.20.1260.100:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131676, NULL, 'G3DSA:3.30.160.60:FF:004117', NULL, NULL, 'AGAP001646-PA', NULL, NULL, NULL, NULL, NULL, 4),
(131677, NULL, 'G3DSA:1.25.40.10:FF:001694', NULL, NULL, 'putative pentatricopeptide repeat-containing protein At2g01510 isoform X7', NULL, NULL, NULL, NULL, NULL, 4),
(131678, NULL, 'G3DSA:3.30.160.60:FF:002414', NULL, NULL, 'Zinc finger protein 610', NULL, NULL, NULL, NULL, NULL, 4),
(131679, NULL, 'G3DSA:3.40.950.10:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131680, NULL, 'G3DSA:3.90.640.10:FF:000214', NULL, NULL, 'Heat shock protein 70 homolog lhs1', NULL, NULL, NULL, NULL, NULL, 4),
(131681, NULL, 'G3DSA:3.40.50.11340:FF:000020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(131682, NULL, 'G3DSA:3.40.50.11350:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131683, NULL, 'G3DSA:2.30.30.180:FF:000003', NULL, NULL, 'Ribosome maturation factor RimP', NULL, NULL, NULL, NULL, NULL, 4),
(131684, NULL, 'G3DSA:1.25.40.20:FF:001697', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(131685, NULL, 'G3DSA:2.30.40.10:FF:000050', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(131686, NULL, 'G3DSA:3.80.10.10:FF:002544', NULL, NULL, 'protein NLRC3', NULL, NULL, NULL, NULL, NULL, 4),
(131687, NULL, 'G3DSA:1.25.40.10:FF:003156', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g03540', NULL, NULL, NULL, NULL, NULL, 4),
(131688, NULL, 'G3DSA:1.10.150.200:FF:000004', NULL, NULL, 'Maltooligosyltrehalose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(131689, NULL, 'G3DSA:3.90.25.10:FF:000009', NULL, NULL, 'dTDP-glucose 4,6-dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(131690, NULL, 'G3DSA:2.60.220.50:FF:000132', NULL, NULL, 'Adhesion G protein-coupled receptor E2', NULL, NULL, NULL, NULL, NULL, 4),
(131691, NULL, 'G3DSA:3.90.25.10:FF:000066', NULL, NULL, 'NmrA-like negative transcriptional regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131692, NULL, 'G3DSA:1.10.555.10:FF:000103', NULL, NULL, 'RhoGAP domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(131693, NULL, 'G3DSA:3.40.720.10:FF:000271', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131694, NULL, 'G3DSA:1.10.8.10:FF:000246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131695, NULL, 'G3DSA:3.40.190.10:FF:000595', NULL, NULL, 'Transferrin', NULL, NULL, NULL, NULL, NULL, 4),
(131696, NULL, 'G3DSA:3.40.50.410:FF:000357', NULL, NULL, 'Vwa2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(131697, NULL, 'G3DSA:3.30.9.10:FF:000183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131698, NULL, 'G3DSA:1.25.40.10:FF:005016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131699, NULL, 'G3DSA:1.25.40.10:FF:003835', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131700, NULL, 'G3DSA:2.60.200.20:FF:000060', NULL, NULL, 'Probable serine/threonine-protein kinase DDB_G0280133', NULL, NULL, NULL, NULL, NULL, 4),
(131701, NULL, 'G3DSA:3.40.50.1820:FF:001026', NULL, NULL, 'KAT8 regulatory NSL complex subunit 3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(131702, NULL, 'G3DSA:3.80.10.10:FF:002932', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131703, NULL, 'G3DSA:2.60.40.150:FF:000422', NULL, NULL, 'Bud/polarization protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131704, NULL, 'G3DSA:3.40.220.10:FF:000031', NULL, NULL, 'Macro domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(131705, NULL, 'G3DSA:3.20.20.140:FF:000426', NULL, NULL, 'Protein trpH, mRNA', NULL, NULL, NULL, NULL, NULL, 4),
(131706, NULL, 'G3DSA:2.40.10.10:FF:000620', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131707, NULL, 'G3DSA:1.20.1560.10:FF:000511', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(131708, NULL, 'G3DSA:2.60.120.200:FF:000407', NULL, NULL, 'LAMinin related. See also lmb', NULL, NULL, NULL, NULL, NULL, 4),
(131709, NULL, 'G3DSA:2.60.120.260:FF:000386', NULL, NULL, 'Ephrin receptor like protein', NULL, NULL, NULL, NULL, NULL, 4),
(131710, NULL, 'G3DSA:2.30.29.30:FF:000793', NULL, NULL, 'CARMIL (Capping, ARp2/3, Myosin I Linker protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(131711, NULL, 'G3DSA:3.100.10.10:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131712, NULL, 'G3DSA:1.10.630.10:FF:000166', NULL, NULL, 'cytochrome P450 315a1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(131713, NULL, 'G3DSA:3.30.420.10:FF:000514', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131714, NULL, 'G3DSA:1.20.920.10:FF:000225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131715, NULL, 'G3DSA:1.25.40.10:FF:005073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131716, NULL, 'G3DSA:3.40.1090.10:FF:000120', NULL, NULL, 'Patatin', NULL, NULL, NULL, NULL, NULL, 4),
(131717, NULL, 'G3DSA:1.20.1070.10:FF:000962', NULL, NULL, 'Pituitary adenylate cyclase-activating peptide', NULL, NULL, NULL, NULL, NULL, 4),
(131718, NULL, 'G3DSA:1.20.120.1080:FF:000064', NULL, NULL, 'ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(131719, NULL, 'G3DSA:3.20.20.80:FF:000511', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131720, NULL, 'G3DSA:3.40.50.720:FF:000568', NULL, NULL, 'Polysaccharide biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(131721, NULL, 'G3DSA:2.60.120.200:FF:000295', NULL, NULL, 'NeuReXin related', NULL, NULL, NULL, NULL, NULL, 4),
(131722, NULL, 'G3DSA:2.30.30.140:FF:000250', NULL, NULL, 'Metal-response element-binding transcription factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(131723, NULL, 'G3DSA:3.30.450.20:FF:000334', NULL, NULL, 'PAS domain-containing sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(131724, NULL, 'G3DSA:1.25.40.10:FF:001418', NULL, NULL, 'Separin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131725, NULL, 'G3DSA:1.20.990.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131726, NULL, 'G3DSA:1.10.630.10:FF:000054', NULL, NULL, 'Cytochrome P450 84A1', NULL, NULL, NULL, NULL, NULL, 4),
(131727, NULL, 'G3DSA:3.40.50.300:FF:004101', NULL, NULL, 'Helicase with zinc finger domain 2', NULL, NULL, NULL, NULL, NULL, 4),
(131728, NULL, 'G3DSA:1.10.486.10:FF:000066', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(131729, NULL, 'G3DSA:2.30.30.490:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131730, NULL, 'G3DSA:1.10.238.20:FF:000038', NULL, NULL, 'AGAP000580-PA', NULL, NULL, NULL, NULL, NULL, 4),
(131731, NULL, 'G3DSA:3.30.160.60:FF:005904', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131732, NULL, 'G3DSA:2.40.30.70:FF:000004', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(131733, NULL, 'G3DSA:3.40.50.1820:FF:000296', NULL, NULL, 'Probable esterase afoC', NULL, NULL, NULL, NULL, NULL, 4),
(131734, NULL, 'G3DSA:3.40.50.300:FF:007816', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131735, NULL, 'G3DSA:2.60.120.620:FF:000134', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(131736, NULL, 'G3DSA:1.10.3080.10:FF:000038', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(131737, NULL, 'G3DSA:3.80.10.10:FF:002191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131738, NULL, 'G3DSA:3.80.10.10:FF:003207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131739, NULL, 'G3DSA:1.10.287.810:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131740, NULL, 'G3DSA:1.10.20.10:FF:000220', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131741, NULL, 'G3DSA:3.30.760.10:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(131742, NULL, 'G3DSA:3.40.1480.10:FF:000009', NULL, NULL, 'Glycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(131743, NULL, 'G3DSA:3.65.10.20:FF:000003', NULL, NULL, 'RNA terminal phosphate cyclase domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(131744, NULL, 'G3DSA:2.60.40.420:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131745, NULL, 'G3DSA:3.40.50.410:FF:000205', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(131746, NULL, 'G3DSA:3.40.50.10490:FF:000080', NULL, NULL, 'Uncharacterized HTH-type transcriptional regulator YbbH', NULL, NULL, NULL, NULL, NULL, 4),
(131747, NULL, 'G3DSA:3.30.499.10:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131748, NULL, 'G3DSA:3.40.850.10:FF:000157', NULL, NULL, 'Kinesin family member 27', NULL, NULL, NULL, NULL, NULL, 4),
(131749, NULL, 'G3DSA:1.10.1370.40:FF:000007', NULL, NULL, 'Oligopeptidase A', NULL, NULL, NULL, NULL, NULL, 4),
(131750, NULL, 'G3DSA:1.25.40.180:FF:000133', NULL, NULL, 'Eukaryotic translation initiation factor 5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131751, NULL, 'G3DSA:2.20.100.10:FF:000058', NULL, NULL, 'Thrombospondin type 1 domain containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(131752, NULL, 'G3DSA:3.30.70.330:FF:001362', NULL, NULL, 'RNA binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131753, NULL, 'G3DSA:2.40.20.10:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131754, NULL, 'G3DSA:1.10.3500.10:FF:000015', NULL, NULL, 'S1 RNA binding domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(131755, NULL, 'G3DSA:1.10.1370.30:FF:000004', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(131756, NULL, 'G3DSA:3.40.50.300:FF:005725', NULL, NULL, 'ATP-dependent DNA helicase Dna2', NULL, NULL, NULL, NULL, NULL, 4),
(131757, NULL, 'G3DSA:3.40.50.720:FF:002535', NULL, NULL, 'LRRGT00043', NULL, NULL, NULL, NULL, NULL, 4),
(131758, NULL, 'G3DSA:2.130.10.10:FF:005495', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131759, NULL, 'G3DSA:2.10.25.10:FF:000083', NULL, NULL, 'Laminin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(131760, NULL, 'G3DSA:3.30.160.60:FF:001689', NULL, NULL, 'zinc finger protein 407', NULL, NULL, NULL, NULL, NULL, 4),
(131761, NULL, 'G3DSA:3.10.450.10:FF:000032', NULL, NULL, 'MGC116429 protein', NULL, NULL, NULL, NULL, NULL, 4),
(131762, NULL, 'G3DSA:2.130.10.10:FF:006001', NULL, NULL, 'Spliceosomal protein sap, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131763, NULL, 'G3DSA:3.30.420.10:FF:000391', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131764, NULL, 'G3DSA:3.10.20.90:FF:000121', NULL, NULL, 'unconventional myosin-IXa isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(131765, NULL, 'G3DSA:2.60.40.1180:FF:000127', NULL, NULL, 'Calpain-like cysteine peptidase, Clan CA, family C2', NULL, NULL, NULL, NULL, NULL, 4),
(131766, NULL, 'G3DSA:1.20.120.850:FF:000022', NULL, NULL, 'SNF2 family N-terminal domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(131767, NULL, 'G3DSA:3.30.200.20:FF:001760', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131768, NULL, 'G3DSA:2.60.120.820:FF:000014', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(131769, NULL, 'G3DSA:3.40.50.150:FF:000026', NULL, NULL, 'Polyamine aminopropyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(131770, NULL, 'G3DSA:1.20.1560.10:FF:000606', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131771, NULL, 'G3DSA:3.40.630.30:FF:000152', NULL, NULL, 'Uncharacterized N-acetyltransferase MT2743', NULL, NULL, NULL, NULL, NULL, 4),
(131772, NULL, 'G3DSA:3.40.50.1360:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131773, NULL, 'G3DSA:1.20.870.10:FF:000041', NULL, NULL, 'Ras guanine nucleotide exchange factor L', NULL, NULL, NULL, NULL, NULL, 4),
(131774, NULL, 'G3DSA:3.40.50.300:FF:004270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(131775, NULL, 'G3DSA:1.25.40.90:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131776, NULL, 'G3DSA:3.40.50.2300:FF:001631', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131777, NULL, 'G3DSA:2.130.10.10:FF:003196', NULL, NULL, 'NLE (NUC135) domain/WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131778, NULL, 'G3DSA:3.80.10.10:FF:002752', NULL, NULL, 'F-box only protein 39-like', NULL, NULL, NULL, NULL, NULL, 4),
(131779, NULL, 'G3DSA:3.30.310.10:FF:000006', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(131780, NULL, 'G3DSA:3.20.20.80:FF:000718', NULL, NULL, '1,3-beta-glucanosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(131781, NULL, 'G3DSA:3.30.420.10:FF:000239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131782, NULL, 'G3DSA:2.130.10.10:FF:003421', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(131783, NULL, 'G3DSA:3.30.160.60:FF:005287', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131784, NULL, 'G3DSA:2.40.30.60:FF:000001', NULL, NULL, 'Ribosome maturation factor RimM', NULL, NULL, NULL, NULL, NULL, 4),
(131785, NULL, 'G3DSA:3.90.70.10:FF:000030', NULL, NULL, 'U4/U6.U5 tri-snRNP-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(131786, NULL, 'G3DSA:3.40.50.1260:FF:000032', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(131787, NULL, 'G3DSA:3.40.50.2000:FF:001070', NULL, NULL, 'Putative galacturonosyltransferase-like 9', NULL, NULL, NULL, NULL, NULL, 4),
(131788, NULL, 'G3DSA:2.170.140.10:FF:000048', NULL, NULL, 'Mucin 68E', NULL, NULL, NULL, NULL, NULL, 4),
(131789, NULL, 'G3DSA:2.60.120.970:FF:000031', NULL, NULL, 'growth/differentiation factor 11', NULL, NULL, NULL, NULL, NULL, 4),
(131790, NULL, 'G3DSA:3.90.1410.10:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131791, NULL, 'G3DSA:3.30.160.60:FF:001425', NULL, NULL, 'Zinc finger protein 331', NULL, NULL, NULL, NULL, NULL, 4),
(131792, NULL, 'G3DSA:1.10.8.60:FF:000525', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131793, NULL, 'G3DSA:2.10.25.10:FF:000178', NULL, NULL, 'vacuolar-sorting receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(131794, NULL, 'G3DSA:3.20.20.140:FF:000139', NULL, NULL, 'Histidinol-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(131795, NULL, 'G3DSA:1.10.287.3440:FF:000004', NULL, NULL, 'Biosynthetic arginine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(131796, NULL, 'G3DSA:3.90.190.10:FF:000224', NULL, NULL, 'receptor Tyrosine phosphatase-like', NULL, NULL, NULL, NULL, NULL, 4),
(131797, NULL, 'G3DSA:1.25.10.10:FF:001237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131798, NULL, 'G3DSA:3.80.10.10:FF:000515', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(131799, NULL, 'G3DSA:3.40.50.300:FF:008598', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(131800, NULL, 'G3DSA:3.30.70.330:FF:000013', NULL, NULL, 'CUGBP Elav-like family member 1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(131801, NULL, 'G3DSA:3.40.50.300:FF:002061', NULL, NULL, 'RecQ family DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(131802, NULL, 'G3DSA:1.20.90.10:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131803, NULL, 'G3DSA:1.20.1250.20:FF:000687', NULL, NULL, 'Major facilitator family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(131804, NULL, 'G3DSA:2.60.120.330:FF:000042', NULL, NULL, 'Flavanone 3-dioxygenase 3', NULL, NULL, NULL, NULL, NULL, 4),
(131805, NULL, 'G3DSA:2.70.150.10:FF:000241', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(131806, NULL, 'G3DSA:1.10.150.50:FF:000135', NULL, NULL, 'Protein matrimony', NULL, NULL, NULL, NULL, NULL, 4),
(131807, NULL, 'G3DSA:3.30.40.10:FF:000839', NULL, NULL, 'Ring finger protein 212', NULL, NULL, NULL, NULL, NULL, 4),
(131808, NULL, 'G3DSA:1.10.1130.10:FF:000003', NULL, NULL, 'Fumarate reductase flavoprotein subunit', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(131809, NULL, 'G3DSA:3.40.50.2000:FF:001013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131810, NULL, 'G3DSA:1.20.1070.10:FF:000586', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(131811, NULL, 'G3DSA:3.40.50.1370:FF:000065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131812, NULL, 'G3DSA:2.40.100.10:FF:000014', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase cyp65', NULL, NULL, NULL, NULL, NULL, 4),
(131813, NULL, 'G3DSA:3.30.70.340:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131814, NULL, 'G3DSA:3.40.630.30:FF:000270', NULL, NULL, 'N-terminal acetyltransferase complex ARD1 subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131815, NULL, 'G3DSA:3.40.50.300:FF:003663', NULL, NULL, 'Replication-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(131816, NULL, 'G3DSA:1.10.8.60:FF:000059', NULL, NULL, 'peroxisome biogenesis factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(131817, NULL, 'G3DSA:3.40.50.300:FF:004601', NULL, NULL, 'Helicase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(131818, NULL, 'G3DSA:1.20.1270.60:FF:000149', NULL, NULL, 'GH04442p', NULL, NULL, NULL, NULL, NULL, 4),
(131819, NULL, 'G3DSA:3.80.10.10:FF:003949', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131820, NULL, 'G3DSA:3.40.1360.10:FF:000012', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(131821, NULL, 'G3DSA:1.10.10.10:FF:000051', NULL, NULL, 'Fur family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(131822, NULL, 'G3DSA:1.10.10.60:FF:000779', NULL, NULL, 'Ladybird homeobox 2', NULL, NULL, NULL, NULL, NULL, 4),
(131823, NULL, 'G3DSA:1.10.132.20:FF:000023', NULL, NULL, 'Ribosome-recycling factor chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(131824, NULL, 'G3DSA:3.30.160.60:FF:001189', NULL, NULL, 'Zinc finger protein 222', NULL, NULL, NULL, NULL, NULL, 4),
(131825, NULL, 'G3DSA:1.20.5.1430:FF:000015', NULL, NULL, 'Microtubule-associated protein RP/EB family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(131826, NULL, 'G3DSA:1.10.132.30:FF:000026', NULL, NULL, 'RNA polymerase I largest subunit', NULL, NULL, NULL, NULL, NULL, 4),
(131827, NULL, 'G3DSA:1.10.238.10:FF:000889', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131828, NULL, 'G3DSA:2.30.29.30:FF:000759', NULL, NULL, 'ArfGAP with GTPase domain, ankyrin repeat and PH domain 2', NULL, NULL, NULL, NULL, NULL, 4),
(131829, NULL, 'G3DSA:1.20.5.170:FF:000095', NULL, NULL, 'Transcription factor SPN1', NULL, NULL, NULL, NULL, NULL, 4),
(131830, NULL, 'G3DSA:3.10.580.10:FF:000036', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(131831, NULL, 'G3DSA:2.30.29.30:FF:001035', NULL, NULL, 'Rho guanine nucleotide exchange factor 17, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131832, NULL, 'G3DSA:1.10.510.10:FF:003327', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131833, NULL, 'G3DSA:2.20.25.630:FF:000001', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(131834, NULL, 'G3DSA:3.30.1440.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131835, NULL, 'G3DSA:2.60.40.60:FF:000102', NULL, NULL, 'Dachsous cadherin-related 1b', NULL, NULL, NULL, NULL, NULL, 4),
(131836, NULL, 'G3DSA:1.20.1250.20:FF:000676', NULL, NULL, 'Putative sugar transporter', NULL, NULL, NULL, NULL, NULL, 4),
(131837, NULL, 'G3DSA:3.10.450.350:FF:000020', NULL, NULL, 'Uncharacterized metalloprotease HI_0409', NULL, NULL, NULL, NULL, NULL, 4),
(131838, NULL, 'G3DSA:3.30.930.10:FF:000036', NULL, NULL, 'phenylalanine--tRNA ligase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(131839, NULL, 'G3DSA:1.25.40.10:FF:001626', NULL, NULL, 'Os03g0216400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(131840, NULL, 'G3DSA:3.30.160.20:FF:000244', NULL, NULL, 'RNA interference promoting factor', NULL, NULL, NULL, NULL, NULL, 4),
(131841, NULL, 'G3DSA:3.20.20.140:FF:000218', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(131842, NULL, 'G3DSA:3.30.60.30:FF:000026', NULL, NULL, 'Insulin-like growth factor-binding protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(131843, NULL, 'G3DSA:1.10.260.30:FF:000014', NULL, NULL, 'Signal recognition particle protein', NULL, NULL, NULL, NULL, NULL, 4),
(131844, NULL, 'G3DSA:1.20.910.10:FF:000045', NULL, NULL, 'Heme oxygenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(131845, NULL, 'G3DSA:1.10.418.70:FF:000005', NULL, NULL, 'IFT complex B', NULL, NULL, NULL, NULL, NULL, 4),
(131846, NULL, 'G3DSA:1.10.287.130:FF:000185', NULL, NULL, 'Bacteriophytochrome protein', NULL, NULL, NULL, NULL, NULL, 4),
(131847, NULL, 'G3DSA:3.20.20.190:FF:000126', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131848, NULL, 'G3DSA:2.130.10.10:FF:001684', NULL, NULL, 'WD domain, G-beta repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(131849, NULL, 'G3DSA:2.60.40.10:FF:003617', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131850, NULL, 'G3DSA:3.40.50.10130:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131851, NULL, 'G3DSA:3.30.450.20:FF:000345', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131852, NULL, 'G3DSA:1.10.418.60:FF:000002', NULL, NULL, 'Nuf2 family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(131853, NULL, 'G3DSA:1.10.260.40:FF:000017', NULL, NULL, 'DNA-binding transcriptional regulator SfsB', NULL, NULL, NULL, NULL, NULL, 4),
(131854, NULL, 'G3DSA:2.10.110.10:FF:000168', NULL, NULL, 'LIM Zinc finger domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(131855, NULL, 'G3DSA:3.30.70.330:FF:001328', NULL, NULL, 'Nuclear cap-binding protein subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(131856, NULL, 'G3DSA:3.20.20.70:FF:000233', NULL, NULL, 'NAD(P)H-dependent glutamate synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131857, NULL, 'G3DSA:2.40.50.140:FF:001078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131858, NULL, 'G3DSA:1.50.40.10:FF:000045', NULL, NULL, 'peroxisomal membrane protein PMP34 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(131859, NULL, 'G3DSA:1.10.405.10:FF:000036', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(131860, NULL, 'G3DSA:1.10.10.10:FF:001618', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131861, NULL, 'G3DSA:3.40.1190.20:FF:000119', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(131862, NULL, 'G3DSA:4.10.410.20:FF:000012', NULL, NULL, 'Poly(U)-specific endoribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(131863, NULL, 'G3DSA:2.10.25.10:FF:000291', NULL, NULL, 'Transmembrane matrix receptor MUP-4', NULL, NULL, NULL, NULL, NULL, 4),
(131864, NULL, 'G3DSA:3.30.60.20:FF:000023', NULL, NULL, 'RAS guanyl-releasing protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(131865, NULL, 'G3DSA:3.40.50.2300:FF:001620', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131866, NULL, 'G3DSA:1.20.58.90:FF:000009', NULL, NULL, 'Tubulin-specific chaperone A', NULL, NULL, NULL, NULL, NULL, 4),
(131867, NULL, 'G3DSA:2.70.150.10:FF:000033', NULL, NULL, 'Potassium-transporting ATPase ATP-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(131868, NULL, 'G3DSA:3.30.43.40:FF:000001', NULL, NULL, 'Pre-mRNA-processing-splicing factor 8', NULL, NULL, NULL, NULL, NULL, 4),
(131869, NULL, 'G3DSA:2.40.50.140:FF:000971', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131870, NULL, 'G3DSA:3.40.367.20:FF:000048', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(131871, NULL, 'G3DSA:2.60.120.10:FF:000707', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(131872, NULL, 'G3DSA:3.40.630.30:FF:000118', NULL, NULL, 'N-acetyltransferase family 8 member 3', NULL, NULL, NULL, NULL, NULL, 4),
(131873, NULL, 'G3DSA:1.25.40.70:FF:000048', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', NULL, NULL, NULL, NULL, NULL, 4),
(131874, NULL, 'G3DSA:2.60.40.1940:FF:000007', NULL, NULL, 'Murinoglobulin-1', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(131875, NULL, 'G3DSA:1.25.40.10:FF:005230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131876, NULL, 'G3DSA:1.20.5.5260:FF:000001', NULL, NULL, 'Two-component-system connector protein AriR', NULL, NULL, NULL, NULL, NULL, 4),
(131877, NULL, 'G3DSA:3.30.70.260:FF:000150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131878, NULL, 'G3DSA:2.40.10.10:FF:000699', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131879, NULL, 'G3DSA:3.10.250.10:FF:000112', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131880, NULL, 'G3DSA:2.40.10.230:FF:000006', NULL, NULL, 'H/ACA ribonucleoprotein complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(131881, NULL, 'G3DSA:1.20.5.170:FF:000038', NULL, NULL, 'Short coiled-coil protein a', NULL, NULL, NULL, NULL, NULL, 4),
(131882, NULL, 'G3DSA:3.30.160.60:FF:005079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131883, NULL, 'G3DSA:3.40.30.10:FF:000405', NULL, NULL, 'Thioredoxin 2', NULL, NULL, NULL, NULL, NULL, 4),
(131884, NULL, 'G3DSA:3.40.50.2000:FF:000928', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(131885, NULL, 'G3DSA:1.25.10.10:FF:000113', NULL, NULL, 'Beta-adaptin-like protein A', NULL, NULL, NULL, NULL, NULL, 4),
(131886, NULL, 'G3DSA:2.60.120.920:FF:000044', NULL, NULL, 'Tripartite motif-containing protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(131887, NULL, 'G3DSA:2.60.40.1930:FF:000004', NULL, NULL, 'Complement C4-A', NULL, NULL, NULL, NULL, NULL, 4),
(131888, NULL, 'G3DSA:3.40.50.10190:FF:000192', NULL, NULL, 'Protein CBG13622', NULL, NULL, NULL, NULL, NULL, 4),
(131889, NULL, 'G3DSA:3.30.70.330:FF:001087', NULL, NULL, 'RNA recognition motif domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(131890, NULL, 'G3DSA:3.90.320.10:FF:000044', NULL, NULL, 'DNA replication ATP-dependent helicase/nuclease DNA2', NULL, NULL, NULL, NULL, NULL, 4),
(131891, NULL, 'G3DSA:3.30.9.10:FF:000126', NULL, NULL, 'tRNA 5-methylaminomethyl-2-thiouridine biosynthesis bifunctional protein MnmC', NULL, NULL, NULL, NULL, NULL, 4),
(131892, NULL, 'G3DSA:3.90.190.10:FF:000454', NULL, NULL, 'Protein-tyrosine phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131893, NULL, 'G3DSA:2.20.100.10:FF:000047', NULL, NULL, 'Thrombospondin type 1 domain containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(131894, NULL, 'G3DSA:3.30.40.10:FF:002189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131895, NULL, 'G3DSA:1.50.10.10:FF:000156', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(131896, NULL, 'G3DSA:1.10.472.30:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131897, NULL, 'G3DSA:2.60.40.3210:FF:000012', NULL, NULL, 'deleted in malignant brain tumors 1 protein-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(131898, NULL, 'G3DSA:3.30.1140.32:FF:000006', NULL, NULL, '30S ribosomal protein S3', NULL, NULL, NULL, NULL, NULL, 4),
(131899, NULL, 'G3DSA:3.40.30.10:FF:000164', NULL, NULL, 'Thioredoxin domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(131900, NULL, 'G3DSA:1.20.58.340:FF:000055', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(131901, NULL, 'G3DSA:3.40.50.620:FF:000364', NULL, NULL, 'Putative isoleucyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(131902, NULL, 'G3DSA:1.25.10.10:FF:003480', NULL, NULL, 'eIF-2-alpha kinase activator GCN1', NULL, NULL, NULL, NULL, NULL, 4),
(131903, NULL, 'G3DSA:1.25.40.20:FF:001629', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131904, NULL, 'G3DSA:2.60.40.4100:FF:000026', NULL, NULL, 'ZP3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(131905, NULL, 'G3DSA:2.60.40.1090:FF:000044', NULL, NULL, 'Probable fimbrial subunit CupB1', NULL, NULL, NULL, NULL, NULL, 4),
(131906, NULL, 'G3DSA:2.60.40.150:FF:000102', NULL, NULL, 'Synaptotagmin-2 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(131907, NULL, 'G3DSA:1.25.40.20:FF:001686', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(131908, NULL, 'G3DSA:1.10.472.30:FF:000006', NULL, NULL, 'Transcription elongation factor S-II', NULL, NULL, NULL, NULL, NULL, 4),
(131909, NULL, 'G3DSA:2.60.40.1480:FF:000004', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(131910, NULL, 'G3DSA:3.50.30.30:FF:000029', NULL, NULL, 'Glutamate carboxypeptidase Tre2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131911, NULL, 'G3DSA:4.10.1000.10:FF:000087', NULL, NULL, 'Zinc finger CCCH domain-containing protein 33', NULL, NULL, NULL, NULL, NULL, 4),
(131912, NULL, 'G3DSA:3.40.50.300:FF:002027', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(131913, NULL, 'G3DSA:2.60.40.1470:FF:000001', NULL, NULL, 'DNA polymerase delta-interacting protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(131914, NULL, 'G3DSA:3.20.20.60:FF:000117', NULL, NULL, '2,4-dihydroxyhept-2-ene-1,7-dioic acid aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(131915, NULL, 'G3DSA:3.30.160.60:FF:002083', NULL, NULL, 'zinc finger protein 606', NULL, NULL, NULL, NULL, NULL, 4),
(131916, NULL, 'G3DSA:1.20.5.5270:FF:000004', NULL, NULL, 'Lon protease', NULL, NULL, NULL, NULL, NULL, 4),
(131917, NULL, 'G3DSA:3.40.50.720:FF:000798', NULL, NULL, '2-hydroxyacid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(131918, NULL, 'G3DSA:1.25.10.10:FF:001866', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131919, NULL, 'G3DSA:3.20.20.140:FF:000370', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131920, NULL, 'G3DSA:3.40.1380.20:FF:000044', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(131921, NULL, 'G3DSA:2.30.30.140:FF:000306', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(131922, NULL, 'G3DSA:1.10.287.110:FF:000122', NULL, NULL, 'DnaJ domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(131923, NULL, 'G3DSA:3.30.300.20:FF:000003', NULL, NULL, 'GTPase Era', NULL, NULL, NULL, NULL, NULL, 4),
(131924, NULL, 'G3DSA:3.50.50.60:FF:000753', NULL, NULL, 'Alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(131925, NULL, 'G3DSA:1.10.287.370:FF:000060', NULL, NULL, 'Prefoldin, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(131926, NULL, 'G3DSA:1.20.120.850:FF:000033', NULL, NULL, 'RAD54 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(131927, NULL, 'G3DSA:3.30.2290.10:FF:000014', NULL, NULL, 'TldD protein, part of TldE/TldD proteolytic complex', NULL, NULL, NULL, NULL, NULL, 4),
(131928, NULL, 'G3DSA:3.30.310.130:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131929, NULL, 'G3DSA:1.10.287.130:FF:000128', NULL, NULL, 'Sensory box sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(131930, NULL, 'G3DSA:1.25.40.10:FF:004499', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131931, NULL, 'G3DSA:3.40.50.2300:FF:000726', NULL, NULL, 'Heme response regulator HssR', NULL, NULL, NULL, NULL, NULL, 4),
(131932, NULL, 'G3DSA:3.40.50.360:FF:000139', NULL, NULL, 'Quinone oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(131933, NULL, 'G3DSA:3.80.10.10:FF:000392', NULL, NULL, 'centrosomal protein of 97 kDa isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(131934, NULL, 'G3DSA:2.40.270.10:FF:000015', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(131935, NULL, 'G3DSA:1.10.150.110:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131936, NULL, 'G3DSA:2.60.120.10:FF:000146', NULL, NULL, 'Cupin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131937, NULL, 'G3DSA:2.60.40.60:FF:000720', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(131938, NULL, 'G3DSA:3.30.160.60:FF:003842', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131939, NULL, 'G3DSA:2.130.10.10:FF:006012', NULL, NULL, 'Probable U3 small nucleolar RNA-associated protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(131940, NULL, 'G3DSA:3.30.70.1170:FF:000007', NULL, NULL, 'Putative 28S rRNA (Cytosine-C(5))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(131941, NULL, 'G3DSA:1.25.10.10:FF:002142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131942, NULL, 'G3DSA:3.40.50.300:FF:005793', NULL, NULL, 'Discs, large homolog 4', NULL, NULL, NULL, NULL, NULL, 4),
(131943, NULL, 'G3DSA:1.10.10.10:FF:001894', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(131944, NULL, 'G3DSA:1.10.1200.120:FF:000007', NULL, NULL, 'Large-conductance mechanosensitive channel', NULL, NULL, NULL, NULL, NULL, 4),
(131945, NULL, 'G3DSA:3.40.1110.10:FF:000078', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(131946, NULL, 'G3DSA:1.25.40.10:FF:003217', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g10910, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(131947, NULL, 'G3DSA:3.30.60.90:FF:000027', NULL, NULL, 'Related to ADA2-general transcriptional adaptor or co-activator', NULL, NULL, NULL, NULL, NULL, 4),
(131948, NULL, 'G3DSA:3.30.40.10:FF:001093', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(131949, NULL, 'G3DSA:2.130.10.10:FF:001807', NULL, NULL, 'p21-activated protein kinase-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(131950, NULL, 'G3DSA:2.120.10.80:FF:000103', NULL, NULL, 'F-box/kelch-repeat protein At5g42360', NULL, NULL, NULL, NULL, NULL, 4),
(131951, NULL, 'G3DSA:3.40.50.300:FF:002302', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(131952, NULL, 'G3DSA:3.30.160.60:FF:001863', NULL, NULL, 'zinc finger protein 407', NULL, NULL, NULL, NULL, NULL, 4),
(131953, NULL, 'G3DSA:3.40.50.10190:FF:000315', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(131954, NULL, 'G3DSA:2.60.40.2300:FF:000014', NULL, NULL, 'Ceramidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131955, NULL, 'G3DSA:3.30.230.10:FF:000348', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(131956, NULL, 'G3DSA:1.20.1560.10:FF:000494', NULL, NULL, 'Os01g0911300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(131957, NULL, 'G3DSA:2.30.29.30:FF:000872', NULL, NULL, 'LOC100124981 protein', NULL, NULL, NULL, NULL, NULL, 4),
(131958, NULL, 'G3DSA:2.30.29.30:FF:000198', NULL, NULL, 'Myotubularin related protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(131959, NULL, 'G3DSA:1.20.120.1770:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131960, NULL, 'G3DSA:3.40.50.450:FF:000015', NULL, NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(131961, NULL, 'G3DSA:3.30.420.270:FF:000024', NULL, NULL, 'Transport energizing protein, ExbD/TolR family', NULL, NULL, NULL, NULL, NULL, 4),
(131962, NULL, 'G3DSA:3.40.50.300:FF:003584', NULL, NULL, 'GD25570', NULL, NULL, NULL, NULL, NULL, 4),
(131963, NULL, 'G3DSA:1.10.2000.10:FF:000084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131964, NULL, 'G3DSA:3.30.1310.10:FF:000011', NULL, NULL, 'Nucleoid-associated protein D6716_02630', NULL, NULL, NULL, NULL, NULL, 4),
(131965, NULL, 'G3DSA:1.10.533.10:FF:000081', NULL, NULL, 'Apoptotic protease-activating factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(131966, NULL, 'G3DSA:2.60.40.1290:FF:000003', NULL, NULL, 'Cell wall surface anchor family protein', NULL, NULL, NULL, NULL, NULL, 4),
(131967, NULL, 'G3DSA:1.20.5.1200:FF:000008', NULL, NULL, 'Cellular retinaldehyde binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(131968, NULL, 'G3DSA:2.170.16.10:FF:000037', NULL, NULL, 'Large helicase-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(131969, NULL, 'G3DSA:2.60.40.10:FF:005360', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131970, NULL, 'G3DSA:2.40.10.240:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131971, NULL, 'G3DSA:3.10.350.10:FF:000047', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(131972, NULL, 'G3DSA:3.10.450.580:FF:000004', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 6', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(131973, NULL, 'G3DSA:2.60.40.790:FF:000035', NULL, NULL, '22.0 kDa heat shock protein', NULL, NULL, NULL, NULL, NULL, 4),
(131974, NULL, 'G3DSA:1.10.8.60:FF:000172', NULL, NULL, 'Nuclear valosin-containing protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(131975, NULL, 'G3DSA:2.30.29.30:FF:001310', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(131976, NULL, 'G3DSA:1.20.1260.100:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131977, NULL, 'G3DSA:3.40.50.300:FF:005736', NULL, NULL, 'Ciliary dynein heavy chain 11', NULL, NULL, NULL, NULL, NULL, 4),
(131978, NULL, 'G3DSA:3.40.50.1780:FF:000002', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor nar1', NULL, NULL, NULL, NULL, NULL, 4),
(131979, NULL, 'G3DSA:3.30.160.60:FF:000054', NULL, NULL, 'Zinc finger protein 711', NULL, NULL, NULL, NULL, NULL, 4),
(131980, NULL, 'G3DSA:1.10.10.790:FF:000011', NULL, NULL, 'Splicing factor, suppressor of white-apricot', NULL, NULL, NULL, NULL, NULL, 4),
(131981, NULL, 'G3DSA:2.30.30.1020:FF:000013', NULL, NULL, 'CCR4-NOT transcriptional complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(131982, NULL, 'G3DSA:1.20.120.1240:FF:000039', NULL, NULL, 'Protein CBG20134', NULL, NULL, NULL, NULL, NULL, 4),
(131983, NULL, 'G3DSA:1.20.1250.20:FF:000951', NULL, NULL, 'AmpG protein, beta-lactamase induction signal transducer', NULL, NULL, NULL, NULL, NULL, 4),
(131984, NULL, 'G3DSA:2.130.10.10:FF:001066', NULL, NULL, 'WD repeat domain 90', NULL, NULL, NULL, NULL, NULL, 4),
(131985, NULL, 'G3DSA:3.10.620.30:FF:000017', NULL, NULL, 'Centrosomal protein of 76 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(131986, NULL, 'G3DSA:1.25.40.20:FF:001809', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131987, NULL, 'G3DSA:1.10.630.10:FF:000407', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(131988, NULL, 'G3DSA:3.30.70.330:FF:001441', NULL, NULL, 'Bruno 2, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(131989, NULL, 'G3DSA:3.30.565.10:FF:000131', NULL, NULL, 'Sensor histidine kinase/response regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(131990, NULL, 'G3DSA:3.90.550.20:FF:000036', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(131991, NULL, 'G3DSA:1.20.1050.10:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131992, NULL, 'G3DSA:3.40.50.300:FF:001864', NULL, NULL, 'DNA repair protein RAD16', NULL, NULL, NULL, NULL, NULL, 4),
(131993, NULL, 'G3DSA:3.30.40.10:FF:001036', NULL, NULL, 'Lysine-specific demethylase 5B', NULL, NULL, NULL, NULL, NULL, 4),
(131994, NULL, 'G3DSA:2.60.120.920:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(131995, NULL, 'G3DSA:3.30.70.330:FF:000547', NULL, NULL, 'Serine/arginine-rich splicing factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(131996, NULL, 'G3DSA:3.40.720.10:FF:000119', NULL, NULL, 'GM20960', NULL, NULL, NULL, NULL, NULL, 4),
(131997, NULL, 'G3DSA:3.40.50.2020:FF:000114', NULL, NULL, 'Orotate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(131998, NULL, 'G3DSA:3.30.160.60:FF:002206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(131999, NULL, 'G3DSA:1.20.1250.20:FF:000058', NULL, NULL, 'ascorbate transporter, chloroplastic isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(132000, NULL, 'G3DSA:1.20.120.1760:FF:000021', NULL, NULL, 'CDP-diacylglycerol--inositol 3-phosphatidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(132001, NULL, 'G3DSA:2.60.40.2840:FF:000002', NULL, NULL, 'Tax1-binding protein 1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(132002, NULL, 'G3DSA:4.10.900.10:FF:000030', NULL, NULL, 'Cadherin 19, type 2', NULL, NULL, NULL, NULL, NULL, 4),
(132003, NULL, 'G3DSA:1.20.1250.20:FF:000619', NULL, NULL, 'Unplaced genomic scaffold supercont2.3, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(132004, NULL, 'G3DSA:1.10.132.70:FF:000009', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(132005, NULL, 'G3DSA:3.10.50.40:FF:000136', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(132006, NULL, 'G3DSA:3.40.50.2300:FF:001002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132007, NULL, 'G3DSA:1.25.10.10:FF:001248', NULL, NULL, 'Adenomatous polyposis coli protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132008, NULL, 'G3DSA:3.80.10.10:FF:000953', NULL, NULL, 'Leucine-rich repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(132009, NULL, 'G3DSA:3.30.200.20:FF:001131', NULL, NULL, 'Protein CBG00447', NULL, NULL, NULL, NULL, NULL, 4),
(132010, NULL, 'G3DSA:3.40.50.1400:FF:000001', NULL, NULL, 'Ferrochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(132011, NULL, 'G3DSA:2.60.120.970:FF:000042', NULL, NULL, 'AGAP011934-PA', NULL, NULL, NULL, NULL, NULL, 4),
(132012, NULL, 'G3DSA:1.10.390.10:FF:000012', NULL, NULL, 'Thermolysin', NULL, NULL, NULL, NULL, NULL, 4),
(132013, NULL, 'G3DSA:3.10.20.90:FF:000008', NULL, NULL, 'Ubiquitin-40S ribosomal protein S27a', NULL, NULL, NULL, NULL, NULL, 4),
(132014, NULL, 'G3DSA:1.10.10.10:FF:001411', NULL, NULL, 'Transcriptional regulator, ArsR family', NULL, NULL, NULL, NULL, NULL, 4),
(132015, NULL, 'G3DSA:3.30.160.60:FF:003488', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132016, NULL, 'G3DSA:1.20.1250.10:FF:000055', NULL, NULL, 'Predicted gene 13275', NULL, NULL, NULL, NULL, NULL, 4),
(132017, NULL, 'G3DSA:3.40.1010.10:FF:000014', NULL, NULL, 'Uroporphyrinogen-III C-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(132018, NULL, 'G3DSA:3.30.559.10:FF:000089', NULL, NULL, 'Putative carnitine/choline acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(132019, NULL, 'G3DSA:3.10.20.310:FF:000030', NULL, NULL, 'Outer membrane protein assembly factor', NULL, NULL, NULL, NULL, NULL, 4),
(132020, NULL, 'G3DSA:1.20.120.20:FF:000044', NULL, NULL, 'Tail tape measure protein gp18', NULL, NULL, NULL, NULL, NULL, 4),
(132021, NULL, 'G3DSA:1.10.1200.270:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132022, NULL, 'G3DSA:3.40.50.80:FF:000057', NULL, NULL, 'FAD-binding domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(132023, NULL, 'G3DSA:3.60.21.60:FF:000022', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(132024, NULL, 'G3DSA:1.10.510.10:FF:004108', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132025, NULL, 'G3DSA:2.60.40.10:FF:005921', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132026, NULL, 'G3DSA:3.60.10.10:FF:000241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132027, NULL, 'G3DSA:1.10.10.60:FF:001055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132028, NULL, 'G3DSA:3.40.605.10:FF:000071', NULL, NULL, '2-aminomuconic acid semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(132029, NULL, 'G3DSA:1.25.40.10:FF:001806', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(132030, NULL, 'G3DSA:3.90.550.10:FF:000033', NULL, NULL, 'Exostosin-like glycosyltransferase 3', NULL, NULL, NULL, NULL, NULL, 4),
(132031, NULL, 'G3DSA:3.40.50.1820:FF:001234', NULL, NULL, 'Protein phosphatase methylesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(132032, NULL, 'G3DSA:1.50.40.10:FF:000225', NULL, NULL, 'Mitochondrial ornithine transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(132033, NULL, 'G3DSA:1.20.5.990:FF:000014', NULL, NULL, 'Kenny, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(132034, NULL, 'G3DSA:2.40.50.40:FF:000019', NULL, NULL, 'C-C motif chemokine 27', NULL, NULL, NULL, NULL, NULL, 4),
(132035, NULL, 'G3DSA:3.60.20.10:FF:000062', NULL, NULL, 'Proteasome subunit alpha type', NULL, NULL, NULL, NULL, NULL, 4),
(132036, NULL, 'G3DSA:4.10.400.10:FF:000334', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132037, NULL, 'G3DSA:1.20.58.190:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132038, NULL, 'G3DSA:1.20.1070.10:FF:000928', NULL, NULL, 'Predicted gene 5127', NULL, NULL, NULL, NULL, NULL, 4),
(132039, NULL, 'G3DSA:2.60.40.1120:FF:000031', NULL, NULL, 'Colicin I receptor', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(132040, NULL, 'G3DSA:2.60.40.10:FF:001588', NULL, NULL, 'Neuregulin 2a', NULL, NULL, NULL, NULL, NULL, 4),
(132041, NULL, 'G3DSA:1.10.540.10:FF:000013', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(132042, NULL, 'G3DSA:3.40.50.1000:FF:000145', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(132043, NULL, 'G3DSA:1.10.10.60:FF:001229', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132044, NULL, 'G3DSA:3.80.10.10:FF:000066', NULL, NULL, 'Nuclear RNA export factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(132045, NULL, 'G3DSA:3.40.50.200:FF:000182', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(132046, NULL, 'G3DSA:3.40.50.1000:FF:000201', NULL, NULL, 'Piso0_001792 protein', NULL, NULL, NULL, NULL, NULL, 4),
(132047, NULL, 'G3DSA:2.40.50.140:FF:000696', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132048, NULL, 'G3DSA:3.30.1490.180:FF:000004', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(132049, NULL, 'G3DSA:3.10.580.10:FF:000154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132050, NULL, 'G3DSA:3.40.50.300:FF:000442', NULL, NULL, 'NACHT, LRR and PYD domains-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(132051, NULL, 'G3DSA:2.10.25.10:FF:001313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132052, NULL, 'G3DSA:1.10.510.10:FF:000511', NULL, NULL, 'Serine/threonine-protein kinase Chk1', NULL, NULL, NULL, NULL, NULL, 4),
(132053, NULL, 'G3DSA:3.30.1370.110:FF:000018', NULL, NULL, 'SMR domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(132054, NULL, 'G3DSA:1.20.1740.10:FF:000087', NULL, NULL, 'Proline permease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132055, NULL, 'G3DSA:3.90.226.10:FF:000111', NULL, NULL, 'Serine protease SPPA, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(132056, NULL, 'G3DSA:3.30.1490.190:FF:000007', NULL, NULL, 'Fur family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(132057, NULL, 'G3DSA:3.40.1030.10:FF:000015', NULL, NULL, 'Bifunctional protein TrpGD', NULL, NULL, NULL, NULL, NULL, 4),
(132058, NULL, 'G3DSA:1.20.1740.10:FF:000143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132059, NULL, 'G3DSA:3.60.40.10:FF:000057', NULL, NULL, 'Phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(132060, NULL, 'G3DSA:2.60.40.10:FF:003735', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132061, NULL, 'G3DSA:1.20.1070.10:FF:000294', NULL, NULL, 'Glucose-dependent insulinotropic receptor', NULL, NULL, NULL, NULL, NULL, 4),
(132062, NULL, 'G3DSA:2.60.20.10:FF:000007', NULL, NULL, 'Crystallin gamma N', NULL, NULL, NULL, NULL, NULL, 4),
(132063, NULL, 'G3DSA:3.30.200.20:FF:001316', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132064, NULL, 'G3DSA:3.90.190.10:FF:000286', NULL, NULL, 'Tyrosine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(132065, NULL, 'G3DSA:2.40.30.10:FF:000003', NULL, NULL, 'Elongation factor 1-alpha', NULL, NULL, NULL, NULL, NULL, 4),
(132066, NULL, 'G3DSA:2.40.30.20:FF:000006', NULL, NULL, 'Riboflavin synthase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(132067, NULL, 'G3DSA:3.30.40.10:FF:000328', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(132068, NULL, 'G3DSA:3.30.505.10:FF:000026', NULL, NULL, 'adapter molecule crk isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(132069, NULL, 'G3DSA:1.10.1280.10:FF:000008', NULL, NULL, 'Protein CBR-TYR-2', NULL, NULL, NULL, NULL, NULL, 4),
(132070, NULL, 'G3DSA:2.130.10.10:FF:001622', NULL, NULL, 'Dynein intermediate chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132071, NULL, 'G3DSA:1.10.520.10:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132072, NULL, 'G3DSA:2.40.30.30:FF:000009', NULL, NULL, 'Riboflavin biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(132073, NULL, 'G3DSA:1.25.40.10:FF:003493', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g12100, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(132074, NULL, 'G3DSA:1.10.510.10:FF:001708', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(132075, NULL, 'G3DSA:3.40.50.1010:FF:000204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132076, NULL, 'G3DSA:3.40.1010.10:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132077, NULL, 'G3DSA:3.40.50.300:FF:006799', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132078, NULL, 'G3DSA:3.30.70.330:FF:000985', NULL, NULL, 'YGR250C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(132079, NULL, 'G3DSA:1.25.40.10:FF:001357', NULL, NULL, 'Cell division cycle 27, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(132080, NULL, 'G3DSA:3.40.50.1820:FF:000913', NULL, NULL, 'Uncharacterized serine carboxypeptidase C08H9.1', NULL, NULL, NULL, NULL, NULL, 4),
(132081, NULL, 'G3DSA:3.20.10.10:FF:000063', NULL, NULL, 'Aminotransferase, class IV family protein', NULL, NULL, NULL, NULL, NULL, 4),
(132082, NULL, 'G3DSA:1.20.58.60:FF:000809', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132083, NULL, 'G3DSA:3.40.50.150:FF:000138', NULL, NULL, 'BCDIN3 domain containing RNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(132084, NULL, 'G3DSA:3.40.50.2000:FF:001069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132085, NULL, 'G3DSA:3.40.50.720:FF:000629', NULL, NULL, 'UDP-glucose 4-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(132086, NULL, 'G3DSA:3.60.110.10:FF:000046', NULL, NULL, 'YIL165C', NULL, NULL, NULL, NULL, NULL, 4),
(132087, NULL, 'G3DSA:1.10.150.20:FF:000149', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(132088, NULL, 'G3DSA:2.130.10.10:FF:005837', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132089, NULL, 'G3DSA:1.10.565.10:FF:000042', NULL, NULL, 'Nuclear receptor subfamily 1, group H, member 5', NULL, NULL, NULL, NULL, NULL, 4),
(132090, NULL, 'G3DSA:3.90.1750.10:FF:000064', NULL, NULL, 'E3 ubiquitin-protein ligase HACE1', NULL, NULL, NULL, NULL, NULL, 4),
(132091, NULL, 'G3DSA:1.10.357.140:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132092, NULL, 'G3DSA:3.40.850.10:FF:000449', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132093, NULL, 'G3DSA:1.25.40.120:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132094, NULL, 'G3DSA:3.90.1200.10:FF:000034', NULL, NULL, 'hydroxylysine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(132095, NULL, 'G3DSA:1.10.560.10:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132096, NULL, 'G3DSA:3.40.50.1440:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132097, NULL, 'G3DSA:3.60.10.10:FF:000229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132098, NULL, 'G3DSA:3.60.21.10:FF:000316', NULL, NULL, 'Putative integral membrane protein, with calcineurin-like phosphoesterase domain', NULL, NULL, NULL, NULL, NULL, 4),
(132099, NULL, 'G3DSA:3.30.420.10:FF:000273', NULL, NULL, 'DNA polymerase 3', NULL, NULL, NULL, NULL, NULL, 4),
(132100, NULL, 'G3DSA:2.60.40.10:FF:001537', NULL, NULL, 'Fasciclin 2, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(132101, NULL, 'G3DSA:3.30.160.60:FF:005399', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132102, NULL, 'G3DSA:2.130.10.10:FF:001566', NULL, NULL, 'WD_domain_-_G-beta_repeat_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(132103, NULL, 'G3DSA:1.25.40.20:FF:001309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132104, NULL, 'G3DSA:3.40.50.2300:FF:001064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132105, NULL, 'G3DSA:3.90.226.10:FF:000004', NULL, NULL, 'Methylcrotonoyl-CoA carboxylase beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(132106, NULL, 'G3DSA:1.20.120.160:FF:000028', NULL, NULL, 'Chemotaxis protein CheA', NULL, NULL, NULL, NULL, NULL, 4),
(132107, NULL, 'G3DSA:3.30.160.20:FF:000126', NULL, NULL, 'RF-1 domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(132108, NULL, 'G3DSA:1.10.287.70:FF:000604', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132109, NULL, 'G3DSA:2.60.40.10:FF:001644', NULL, NULL, 'Eph receptor tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(132110, NULL, 'G3DSA:3.90.190.10:FF:000393', NULL, NULL, 'TeNSin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(132111, NULL, 'G3DSA:3.40.50.300:FF:005169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132112, NULL, 'G3DSA:2.130.10.30:FF:000094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132113, NULL, 'G3DSA:3.30.70.260:FF:000149', NULL, NULL, 'Tyrosine/tryptophan monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132114, NULL, 'G3DSA:1.10.510.10:FF:000404', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(132115, NULL, 'G3DSA:3.40.50.20:FF:000056', NULL, NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(132116, NULL, 'G3DSA:3.40.50.1820:FF:000857', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(132117, NULL, 'G3DSA:1.10.630.10:FF:000458', NULL, NULL, 'Cyp2d34 protein', NULL, NULL, NULL, NULL, NULL, 4),
(132118, NULL, 'G3DSA:3.40.50.2000:FF:001125', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(132119, NULL, 'G3DSA:1.50.40.10:FF:000551', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132120, NULL, 'G3DSA:3.40.800.20:FF:000033', NULL, NULL, 'Histone deacetylase HOS3', NULL, NULL, NULL, NULL, NULL, 4),
(132121, NULL, 'G3DSA:3.40.50.150:FF:000998', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132122, NULL, 'G3DSA:3.40.50.300:FF:007474', NULL, NULL, 'Ribose ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(132123, NULL, 'G3DSA:3.40.532.10:FF:000002', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(132124, NULL, 'G3DSA:3.30.160.60:FF:006242', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132125, NULL, 'G3DSA:1.10.220.10:FF:000011', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(132126, NULL, 'G3DSA:3.40.50.150:FF:001780', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132127, NULL, 'G3DSA:1.10.10.10:FF:001057', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(132128, NULL, 'G3DSA:1.25.10.10:FF:001574', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132129, NULL, 'G3DSA:3.20.20.100:FF:000055', NULL, NULL, 'Putative oxidoreductase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(132130, NULL, 'G3DSA:3.30.30.30:FF:000024', NULL, NULL, '105/110 kDa heat shock protein/ nucleotide-binding domain', NULL, NULL, NULL, NULL, NULL, 4),
(132131, NULL, 'G3DSA:1.25.40.420:FF:000008', NULL, NULL, 'BTB/POZ domain-containing protein POB1', NULL, NULL, NULL, NULL, NULL, 4),
(132132, NULL, 'G3DSA:1.25.40.400:FF:000002', NULL, NULL, 'Transcriptional regulator, MutR family', NULL, NULL, NULL, NULL, NULL, 4),
(132133, NULL, 'G3DSA:3.30.505.10:FF:000245', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132134, NULL, 'G3DSA:3.30.1340.30:FF:000002', NULL, NULL, 'LysM domain/BON superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(132135, NULL, 'G3DSA:2.20.25.690:FF:000002', NULL, NULL, 'Tripeptidyl peptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(132136, NULL, 'G3DSA:3.40.50.300:FF:005495', NULL, NULL, 'Septin 7', NULL, NULL, NULL, NULL, NULL, 4),
(132137, NULL, 'G3DSA:3.20.20.470:FF:000002', NULL, NULL, 'Dextransucrase', NULL, NULL, NULL, NULL, NULL, 4),
(132138, NULL, 'G3DSA:1.10.10.10:FF:001950', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132139, NULL, 'G3DSA:1.10.287.1490:FF:000104', NULL, NULL, 'GRIP1-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(132140, NULL, 'G3DSA:2.130.10.10:FF:003606', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(132141, NULL, 'G3DSA:3.40.50.620:FF:000706', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(132142, NULL, 'G3DSA:1.10.510.10:FF:000230', NULL, NULL, 'protein-tyrosine kinase 2-beta isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(132143, NULL, 'G3DSA:3.90.70.10:FF:000029', NULL, NULL, 'ubiquitin carboxyl-terminal hydrolase 48 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(132144, NULL, 'G3DSA:3.40.50.300:FF:003819', NULL, NULL, 'Hsp70 subfamily B suppressor 1', NULL, NULL, NULL, NULL, NULL, 4),
(132145, NULL, 'G3DSA:1.25.40.410:FF:000005', NULL, NULL, 'Uncharacterized protein, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(132146, NULL, 'G3DSA:4.10.400.10:FF:000008', NULL, NULL, 'Low density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(132147, NULL, 'G3DSA:3.30.450.380:FF:000007', NULL, NULL, 'Type VI secretion protein', NULL, NULL, NULL, NULL, NULL, 4),
(132148, NULL, 'G3DSA:3.40.50.300:FF:007530', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132149, NULL, 'G3DSA:1.10.630.10:FF:000402', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132150, NULL, 'G3DSA:3.20.20.70:FF:000272', NULL, NULL, 'Glycerol uptake operon antiterminator regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(132151, NULL, 'G3DSA:1.10.437.10:FF:000054', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(132152, NULL, 'G3DSA:3.30.2410.10:FF:000013', NULL, NULL, 'Apoptosis-resistant E3 ubiquitin protein ligase 1', NULL, NULL, NULL, NULL, NULL, 4),
(132153, NULL, 'G3DSA:2.130.10.10:FF:001515', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(132154, NULL, 'G3DSA:3.30.70.850:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132155, NULL, 'G3DSA:3.20.80.10:FF:000011', NULL, NULL, 'Heme-binding-like protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(132156, NULL, 'G3DSA:2.60.40.10:FF:002431', NULL, NULL, 'Si:ch211-222k6.3', NULL, NULL, NULL, NULL, NULL, 4),
(132157, NULL, 'G3DSA:3.20.20.80:FF:000275', NULL, NULL, 'Mannan endo-1,4-beta-mannosidase. Glycosyl Hydrolase family 5', NULL, NULL, NULL, NULL, NULL, 4),
(132158, NULL, 'G3DSA:3.70.10.10:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132159, NULL, 'G3DSA:2.60.40.10:FF:005129', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132160, NULL, 'G3DSA:2.40.50.140:FF:000589', NULL, NULL, 'Single-stranded DNA-binding protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(132161, NULL, 'G3DSA:1.25.40.10:FF:004853', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(132162, NULL, 'G3DSA:3.30.200.20:FF:001423', NULL, NULL, 'Cell division protein kinase 6', NULL, NULL, NULL, NULL, NULL, 4),
(132163, NULL, 'G3DSA:1.25.40.210:FF:000007', NULL, NULL, 'Telomeric repeat-binding factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(132164, NULL, 'G3DSA:1.10.287.110:FF:000201', NULL, NULL, 'Heat shock protein binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(132165, NULL, 'G3DSA:1.10.10.160:FF:000064', NULL, NULL, 'UvrD/REP helicase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(132166, NULL, 'G3DSA:3.30.200.20:FF:001642', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132167, NULL, 'G3DSA:3.30.230.10:FF:000298', NULL, NULL, 'ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132168, NULL, 'G3DSA:3.80.10.10:FF:000285', NULL, NULL, 'F-box/LRR-repeat protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(132169, NULL, 'G3DSA:3.40.50.300:FF:001802', NULL, NULL, 'Uridine-cytidine kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(132170, NULL, 'G3DSA:1.10.287.70:FF:000374', NULL, NULL, 'Ion_transport_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(132171, NULL, 'G3DSA:3.40.50.360:FF:000151', NULL, NULL, 'AGAP008256-PA', NULL, NULL, NULL, NULL, NULL, 4),
(132172, NULL, 'G3DSA:1.10.1380.10:FF:000016', NULL, NULL, 'BcDNA.GH07188', NULL, NULL, NULL, NULL, NULL, 4),
(132173, NULL, 'G3DSA:2.40.50.140:FF:001213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132174, NULL, 'G3DSA:3.40.710.10:FF:000170', NULL, NULL, 'Penicillin-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(132175, NULL, 'G3DSA:3.60.21.10:FF:000204', NULL, NULL, 'Metallo-dependent phosphatase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(132176, NULL, 'G3DSA:3.40.850.10:FF:000505', NULL, NULL, 'Putative kinesin', NULL, NULL, NULL, NULL, NULL, 4),
(132177, NULL, 'G3DSA:2.30.30.40:FF:000035', NULL, NULL, 'SH3 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(132178, NULL, 'G3DSA:1.20.1250.20:FF:001699', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(132179, NULL, 'G3DSA:3.30.70.270:FF:000271', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132180, NULL, 'G3DSA:3.30.460.10:FF:000163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132181, NULL, 'G3DSA:1.10.8.60:FF:000177', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(132182, NULL, 'G3DSA:3.40.50.720:FF:002193', NULL, NULL, 'Nedd8-activating enzyme E1 regulatory subunit-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(132183, NULL, 'G3DSA:1.10.510.10:FF:003384', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132184, NULL, 'G3DSA:2.130.10.10:FF:002004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132185, NULL, 'G3DSA:2.30.29.30:FF:000580', NULL, NULL, 'Exocyst complex component', NULL, NULL, NULL, NULL, NULL, 4),
(132186, NULL, 'G3DSA:3.60.40.10:FF:000276', NULL, NULL, 'Protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(132187, NULL, 'G3DSA:3.40.50.720:FF:001523', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132188, NULL, 'G3DSA:3.30.450.20:FF:000671', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132189, NULL, 'G3DSA:2.10.25.10:FF:000526', NULL, NULL, 'Dumpy, isoform J', NULL, NULL, NULL, NULL, NULL, 4),
(132190, NULL, 'G3DSA:3.30.450.20:FF:000519', NULL, NULL, 'Sll0779 protein', NULL, NULL, NULL, NULL, NULL, 4),
(132191, NULL, 'G3DSA:1.10.472.80:FF:000274', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132192, NULL, 'G3DSA:1.25.40.20:FF:001635', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132193, NULL, 'G3DSA:2.60.40.1730:FF:000045', NULL, NULL, 'Transcription initiation factor TFIID subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(132194, NULL, 'G3DSA:2.40.50.40:FF:000126', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(132195, NULL, 'G3DSA:3.40.50.300:FF:007316', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132196, NULL, 'G3DSA:3.50.30.30:FF:000035', NULL, NULL, 'Signal peptide peptidase like 2C', NULL, NULL, NULL, NULL, NULL, 4),
(132197, NULL, 'G3DSA:1.10.8.60:FF:000407', NULL, NULL, 'RuvB-like helicase 1', NULL, NULL, NULL, NULL, NULL, 4),
(132198, NULL, 'G3DSA:3.90.190.10:FF:000342', NULL, NULL, 'Possible dual specificity protein phosphatase 3 (AFU_orthologue AFUA_1G13040)', NULL, NULL, NULL, NULL, NULL, 4),
(132199, NULL, 'G3DSA:3.40.50.150:FF:001717', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132200, NULL, 'G3DSA:2.40.50.100:FF:000032', NULL, NULL, 'sn-glycerol-3-phosphate import ATP-binding protein UgpC', NULL, NULL, NULL, NULL, NULL, 4),
(132201, NULL, 'G3DSA:1.25.10.10:FF:000225', NULL, NULL, 'Nipped-B protein', NULL, NULL, NULL, NULL, NULL, 4),
(132202, NULL, 'G3DSA:1.20.58.400:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132203, NULL, 'G3DSA:4.10.270.10:FF:000008', NULL, NULL, 'CRE-LET-75 protein', NULL, NULL, NULL, NULL, NULL, 4),
(132204, NULL, 'G3DSA:3.30.1620.10:FF:000001', NULL, NULL, 'Ribonucleoside-triphosphate reductase, adenosylcobalamin-dependent', NULL, NULL, NULL, NULL, NULL, 4),
(132205, NULL, 'G3DSA:2.60.40.10:FF:001970', NULL, NULL, 'Jitterbug, isoform N', NULL, NULL, NULL, NULL, NULL, 4),
(132206, NULL, 'G3DSA:3.40.250.10:FF:000246', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(132207, NULL, 'G3DSA:2.60.110.10:FF:000022', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(132208, NULL, 'G3DSA:1.10.472.80:FF:000004', NULL, NULL, 'Small G protein signaling modulator 1', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(132209, NULL, 'G3DSA:1.10.510.10:FF:000281', NULL, NULL, 'Cyclin-dependent kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(132210, NULL, 'G3DSA:3.30.40.10:FF:000654', NULL, NULL, 'RING-H2 finger protein ATL33', NULL, NULL, NULL, NULL, NULL, 4),
(132211, NULL, 'G3DSA:3.40.190.80:FF:000008', NULL, NULL, 'Sedoheptulose-1,7-bisphosphatase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(132212, NULL, 'G3DSA:3.30.40.10:FF:001115', NULL, NULL, 'PHD finger protein EHD3 isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(132213, NULL, 'G3DSA:1.25.40.10:FF:001632', NULL, NULL, 'Os02g0550400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(132214, NULL, 'G3DSA:1.25.40.20:FF:000623', NULL, NULL, 'Ankyrin repeat-containing protein ITN1', NULL, NULL, NULL, NULL, NULL, 4),
(132215, NULL, 'G3DSA:3.40.50.620:FF:000476', NULL, NULL, 'Asparagine synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132216, NULL, 'G3DSA:3.20.20.190:FF:000132', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132217, NULL, 'G3DSA:3.30.160.60:FF:005348', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132218, NULL, 'G3DSA:1.10.287.660:FF:000012', NULL, NULL, 'Vacuolar protein-sorting protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132219, NULL, 'G3DSA:2.60.120.200:FF:000177', NULL, NULL, 'Wing blister, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(132220, NULL, 'G3DSA:3.30.160.20:FF:000238', NULL, NULL, 'Spliced leader RNA PSE-promoter transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132221, NULL, 'G3DSA:3.40.50.300:FF:007586', NULL, NULL, 'Uncharacterized protein YfjK', NULL, NULL, NULL, NULL, NULL, 4),
(132222, NULL, 'G3DSA:1.25.40.10:FF:004212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132223, NULL, 'G3DSA:1.10.220.20:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132224, NULL, 'G3DSA:1.10.220.30:FF:000017', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(132225, NULL, 'G3DSA:2.40.50.120:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132226, NULL, 'G3DSA:2.60.40.3210:FF:000017', NULL, NULL, 'Si:ch211-14a17.7', NULL, NULL, NULL, NULL, NULL, 4),
(132227, NULL, 'G3DSA:1.20.1280.50:FF:000265', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(132228, NULL, 'G3DSA:2.60.40.10:FF:005803', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132229, NULL, 'G3DSA:1.20.1070.10:FF:000524', NULL, NULL, 'Tyramine receptor tyra-2', NULL, NULL, NULL, NULL, NULL, 4),
(132230, NULL, 'G3DSA:1.10.10.10:FF:000101', NULL, NULL, 'DNA-binding response OmpR family regulator', NULL, NULL, NULL, NULL, NULL, 4),
(132231, NULL, 'G3DSA:1.10.10.60:FF:000251', NULL, NULL, 'Zinc finger protein 541', NULL, NULL, NULL, NULL, NULL, 4),
(132232, NULL, 'G3DSA:3.20.20.105:FF:000021', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(132233, NULL, 'G3DSA:1.10.1410.10:FF:000053', NULL, NULL, 'Nrap protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132234, NULL, 'G3DSA:3.60.20.10:FF:000174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132235, NULL, 'G3DSA:2.60.40.10:FF:005747', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132236, NULL, 'G3DSA:3.40.1340.10:FF:000011', NULL, NULL, 'DNA-directed RNA polymerase II/III subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132237, NULL, 'G3DSA:3.40.50.300:FF:007535', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(132238, NULL, 'G3DSA:3.80.10.10:FF:004225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132239, NULL, 'G3DSA:3.30.428.10:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132240, NULL, 'G3DSA:1.20.1560.10:FF:000775', NULL, NULL, 'ATP-binding cassette transporter, subfamily C, member 1, group MRP protein PpABCC1', NULL, NULL, NULL, NULL, NULL, 4),
(132241, NULL, 'G3DSA:2.60.120.10:FF:000522', NULL, NULL, 'Blr1670 protein', NULL, NULL, NULL, NULL, NULL, 4),
(132242, NULL, 'G3DSA:3.40.50.1000:FF:000033', NULL, NULL, 'Sugar phosphatase YfbT', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(132243, NULL, 'G3DSA:3.30.160.60:FF:004966', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132244, NULL, 'G3DSA:3.40.430.10:FF:000013', NULL, NULL, 'Dihydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(132245, NULL, 'G3DSA:3.40.50.2300:FF:000277', NULL, NULL, 'Response regulator receiver domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(132246, NULL, 'G3DSA:2.60.40.10:FF:006023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132247, NULL, 'G3DSA:1.10.287.70:FF:000048', NULL, NULL, 'Cytochrome c oxidase subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(132248, NULL, 'G3DSA:2.60.40.10:FF:002100', NULL, NULL, 'Fibronectin type III domain containing 8', NULL, NULL, NULL, NULL, NULL, 4),
(132249, NULL, 'G3DSA:1.10.3210.10:FF:000072', NULL, NULL, 'Metal dependent phosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(132250, NULL, 'G3DSA:2.60.120.10:FF:000180', NULL, NULL, 'Potassium voltage-gated channel subfamily H member 6', NULL, NULL, NULL, NULL, NULL, 4),
(132251, NULL, 'G3DSA:2.60.40.10:FF:001818', NULL, NULL, 'Tyrosine-protein phosphatase 69D', NULL, NULL, NULL, NULL, NULL, 4),
(132252, NULL, 'G3DSA:3.90.190.10:FF:000398', NULL, NULL, 'Protein-tyrosine-phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132253, NULL, 'G3DSA:1.10.150.390:FF:000010', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(132254, NULL, 'G3DSA:3.90.1750.20:FF:000011', NULL, NULL, 'Recombinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(132255, NULL, 'G3DSA:1.10.630.10:FF:000784', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132256, NULL, 'G3DSA:3.30.1490.20:FF:000055', NULL, NULL, 'Succinate-CoA ligase, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(132257, NULL, 'G3DSA:1.10.150.50:FF:000074', NULL, NULL, 'Stromal interaction molecule', NULL, NULL, NULL, NULL, NULL, 4),
(132258, NULL, 'G3DSA:3.30.70.330:FF:002964', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132259, NULL, 'G3DSA:2.60.40.10:FF:004224', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132260, NULL, 'G3DSA:3.20.20.190:FF:000076', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(132261, NULL, 'G3DSA:3.30.70.1730:FF:000046', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(132262, NULL, 'G3DSA:1.10.10.1200:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132263, NULL, 'G3DSA:2.40.10.10:FF:000171', NULL, NULL, 'trypsin-1', NULL, NULL, NULL, NULL, NULL, 4),
(132264, NULL, 'G3DSA:3.50.50.60:FF:001034', NULL, NULL, 'Probable lysine-specific histone demethylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(132265, NULL, 'G3DSA:3.40.50.720:FF:001411', NULL, NULL, '3-hydroxyisobutyrate dehydrogenase, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132266, NULL, 'G3DSA:2.60.40.550:FF:000003', NULL, NULL, 'Ecotin family (I11)', NULL, NULL, NULL, NULL, NULL, 4),
(132267, NULL, 'G3DSA:2.130.10.10:FF:002589', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(132268, NULL, 'G3DSA:1.25.40.10:FF:001576', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g42920, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(132269, NULL, 'G3DSA:3.80.10.10:FF:002376', NULL, NULL, 'Protein CBR-EGG-6', NULL, NULL, NULL, NULL, NULL, 4),
(132270, NULL, 'G3DSA:2.60.40.10:FF:004117', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132271, NULL, 'G3DSA:3.40.33.10:FF:000204', NULL, NULL, 'Protein CBR-SCL-22', NULL, NULL, NULL, NULL, NULL, 4),
(132272, NULL, 'G3DSA:1.25.40.10:FF:001183', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(132273, NULL, 'G3DSA:2.60.40.10:FF:001476', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(132274, NULL, 'G3DSA:1.10.510.10:FF:001534', NULL, NULL, 'Putative WAK-related receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(132275, NULL, 'G3DSA:2.60.120.200:FF:000795', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(132276, NULL, 'G3DSA:3.30.70.1430:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132277, NULL, 'G3DSA:3.30.530.20:FF:000110', NULL, NULL, 'S-norcoclaurine synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(132278, NULL, 'G3DSA:1.20.1420.10:FF:000001', NULL, NULL, 'Talin 2', NULL, NULL, NULL, NULL, NULL, 4),
(132279, NULL, 'G3DSA:3.40.50.1360:FF:000056', NULL, NULL, '6-phosphogluconolactonase', NULL, NULL, NULL, NULL, NULL, 4),
(132280, NULL, 'G3DSA:1.25.10.10:FF:001681', NULL, NULL, 'Synembryn-A', NULL, NULL, NULL, NULL, NULL, 4),
(132281, NULL, 'G3DSA:1.25.40.10:FF:002200', NULL, NULL, 'CCR4-NOT transcription complex subunit 10', NULL, NULL, NULL, NULL, NULL, 4),
(132282, NULL, 'G3DSA:2.102.10.10:FF:000033', NULL, NULL, 'Similar to rieske domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(132283, NULL, 'G3DSA:1.10.510.10:FF:001860', NULL, NULL, 'Probable serine/threonine-protein kinase DDB_G0280133', NULL, NULL, NULL, NULL, NULL, 4),
(132284, NULL, 'G3DSA:1.20.1270.280:FF:000060', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(132285, NULL, 'G3DSA:1.20.1250.20:FF:000917', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(132286, NULL, 'G3DSA:3.40.190.10:FF:000769', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(132287, NULL, 'G3DSA:2.60.120.200:FF:000744', NULL, NULL, 'Beta-agarase B', NULL, NULL, NULL, NULL, NULL, 4),
(132288, NULL, 'G3DSA:2.30.110.10:FF:000006', NULL, NULL, 'PPOX class F420-dependent enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(132289, NULL, 'G3DSA:1.10.287.70:FF:000099', NULL, NULL, 'glutamate receptor 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(132290, NULL, 'G3DSA:3.40.50.1370:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132291, NULL, 'G3DSA:3.40.190.10:FF:000477', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(132292, NULL, 'G3DSA:2.40.10.170:FF:000022', NULL, NULL, 'ATP synthase subunit beta, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(132293, NULL, 'G3DSA:3.40.1190.20:FF:000069', NULL, NULL, 'Ribokinase', NULL, NULL, NULL, NULL, NULL, 4),
(132294, NULL, 'G3DSA:1.20.1270.10:FF:000056', NULL, NULL, 'Putative Hsp70 family ATPase KAR2', NULL, NULL, NULL, NULL, NULL, 4),
(132295, NULL, 'G3DSA:3.40.50.2300:FF:001513', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132296, NULL, 'G3DSA:3.30.710.10:FF:000492', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132297, NULL, 'G3DSA:3.30.300.20:FF:000008', NULL, NULL, '30S ribosomal protein S3, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(132298, NULL, 'G3DSA:2.130.10.10:FF:000262', NULL, NULL, 'Tubby like protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(132299, NULL, 'G3DSA:1.20.1560.10:FF:000724', NULL, NULL, 'Half-ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132300, NULL, 'G3DSA:3.40.50.1460:FF:000081', NULL, NULL, 'Zgc:194469', NULL, NULL, NULL, NULL, NULL, 4),
(132301, NULL, 'G3DSA:3.30.40.10:FF:000098', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(132302, NULL, 'G3DSA:2.40.420.20:FF:000053', NULL, NULL, 'Efflux transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(132303, NULL, 'G3DSA:3.30.160.60:FF:001925', NULL, NULL, 'ZNF595 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(132304, NULL, 'G3DSA:3.80.10.10:FF:000577', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(132305, NULL, 'G3DSA:1.25.40.20:FF:001579', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132306, NULL, 'G3DSA:1.20.1730.10:FF:000047', NULL, NULL, 'Putative sodium/solute symporter', NULL, NULL, NULL, NULL, NULL, 4),
(132307, NULL, 'G3DSA:1.20.140.10:FF:000036', NULL, NULL, 'Acyl-CoA dehydrogenase FadE29', NULL, NULL, NULL, NULL, NULL, 4),
(132308, NULL, 'G3DSA:3.80.10.10:FF:000919', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase PEPR1', NULL, NULL, NULL, NULL, NULL, 4),
(132309, NULL, 'G3DSA:3.40.50.2000:FF:000636', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(132310, NULL, 'G3DSA:1.10.150.50:FF:000023', NULL, NULL, 'Epidermal growth factor receptor kinase substrate 8', NULL, NULL, NULL, NULL, NULL, 4),
(132311, NULL, 'G3DSA:3.30.200.20:FF:001193', NULL, NULL, 'Putative tyrosine-protein kinase Wsck', NULL, NULL, NULL, NULL, NULL, 4),
(132312, NULL, 'G3DSA:1.10.150.60:FF:000026', NULL, NULL, 'SWI/SNF chromatin-remodeling complex subunit sol1', NULL, NULL, NULL, NULL, NULL, 4),
(132313, NULL, 'G3DSA:3.40.50.410:FF:000183', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(132314, NULL, 'G3DSA:3.40.33.10:FF:000148', NULL, NULL, 'AGAP006737-PA', NULL, NULL, NULL, NULL, NULL, 4),
(132315, NULL, 'G3DSA:3.30.1360.170:FF:000012', NULL, NULL, 'Flavin-dependent thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(132316, NULL, 'G3DSA:2.40.50.140:FF:000757', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132317, NULL, 'G3DSA:1.20.1280.50:FF:000046', NULL, NULL, 'F-box protein 43', NULL, NULL, NULL, NULL, NULL, 4),
(132318, NULL, 'G3DSA:1.20.1600.10:FF:000043', NULL, NULL, 'Outer membrane efflux protein', NULL, NULL, NULL, NULL, NULL, 4),
(132319, NULL, 'G3DSA:3.90.170.10:FF:000009', NULL, NULL, 'Adenylosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(132320, NULL, 'G3DSA:2.60.40.2840:FF:000007', NULL, NULL, 'E3 ubiquitin-protein ligase HECW2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(132321, NULL, 'G3DSA:3.30.300.10:FF:000005', NULL, NULL, 'S-adenosylmethionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(132322, NULL, 'G3DSA:2.130.10.10:FF:003483', NULL, NULL, 'Histidine kinase/response regulator hybrid protein', NULL, NULL, NULL, NULL, NULL, 4),
(132323, NULL, 'G3DSA:3.30.160.60:FF:005129', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132324, NULL, 'G3DSA:3.30.200.20:FF:000967', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(132325, NULL, 'G3DSA:3.40.50.1010:FF:000036', NULL, NULL, 'Endonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132326, NULL, 'G3DSA:3.40.50.10190:FF:000085', NULL, NULL, 'Pebble, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(132327, NULL, 'G3DSA:1.20.58.400:FF:000039', NULL, NULL, 'Chromosome 16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(132328, NULL, 'G3DSA:2.40.10.10:FF:000120', NULL, NULL, 'Putative serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(132329, NULL, 'G3DSA:3.30.1360.180:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132330, NULL, 'G3DSA:1.20.1560.10:FF:000376', NULL, NULL, 'ABC-type multidrug transport system, ATPase and permease components', NULL, NULL, NULL, NULL, NULL, 4),
(132331, NULL, 'G3DSA:3.40.50.300:FF:000116', NULL, NULL, 'probable global transcription activator SNF2L2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(132332, NULL, 'G3DSA:1.10.10.750:FF:000027', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(132333, NULL, 'G3DSA:2.60.40.10:FF:000514', NULL, NULL, 'Collagen alpha-1(XIV) chain isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(132334, NULL, 'G3DSA:1.25.40.10:FF:004797', NULL, NULL, 'Paf1 complex component', NULL, NULL, NULL, NULL, NULL, 4),
(132335, NULL, 'G3DSA:3.40.50.12550:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132336, NULL, 'G3DSA:3.40.50.720:FF:000736', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132337, NULL, 'G3DSA:3.30.300.20:FF:000059', NULL, NULL, 'Probable transcription termination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(132338, NULL, 'G3DSA:3.30.450.20:FF:000626', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(132339, NULL, 'G3DSA:3.30.160.60:FF:005674', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132340, NULL, 'G3DSA:1.10.260.30:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132341, NULL, 'G3DSA:3.30.70.330:FF:000980', NULL, NULL, 'RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(132342, NULL, 'G3DSA:2.60.200.30:FF:000006', NULL, NULL, 'probable NAD kinase 1', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(132343, NULL, 'G3DSA:2.60.120.10:FF:000028', NULL, NULL, 'Pirin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(132344, NULL, 'G3DSA:1.10.510.10:FF:001585', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132345, NULL, 'G3DSA:3.30.300.10:FF:000056', NULL, NULL, 'S-adenosylmethionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(132346, NULL, 'G3DSA:3.40.250.10:FF:000072', NULL, NULL, 'mRNA, clone: RTFL01-06-I08', NULL, NULL, NULL, NULL, NULL, 4),
(132347, NULL, 'G3DSA:1.25.40.10:FF:001306', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g28690, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(132348, NULL, 'G3DSA:2.60.120.200:FF:000469', NULL, NULL, 'Cadherin-4', NULL, NULL, NULL, NULL, NULL, 4),
(132349, NULL, 'G3DSA:3.30.160.60:FF:006130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132350, NULL, 'G3DSA:1.25.10.10:FF:001804', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(132351, NULL, 'G3DSA:1.25.10.10:FF:001748', NULL, NULL, 'Rotatin', NULL, NULL, NULL, NULL, NULL, 4),
(132352, NULL, 'G3DSA:1.10.260.100:FF:000038', NULL, NULL, 'Hsc70-interacting protein 2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(132353, NULL, 'G3DSA:2.60.200.40:FF:000009', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(132354, NULL, 'G3DSA:1.20.1250.20:FF:000176', NULL, NULL, 'Major facilitator superfamily domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(132355, NULL, 'G3DSA:1.10.3730.20:FF:000041', NULL, NULL, 'EamA family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(132356, NULL, 'G3DSA:1.25.40.180:FF:000240', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132357, NULL, 'G3DSA:3.40.1210.10:FF:000001', NULL, NULL, '5''/3''-nucleotidase SurE', NULL, NULL, NULL, NULL, NULL, 4),
(132358, NULL, 'G3DSA:3.40.1110.10:FF:000016', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(132359, NULL, 'G3DSA:3.40.50.2300:FF:000496', NULL, NULL, 'LacI family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(132360, NULL, 'G3DSA:3.40.50.2300:FF:001120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132361, NULL, 'G3DSA:3.40.33.10:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132362, NULL, 'G3DSA:3.80.10.10:FF:002483', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132363, NULL, 'G3DSA:1.10.3380.10:FF:000016', NULL, NULL, 'Translocation protein SEC63', NULL, NULL, NULL, NULL, NULL, 4),
(132364, NULL, 'G3DSA:3.40.1810.10:FF:000030', NULL, NULL, 'Agamous-like MADS-box protein AGL13', NULL, NULL, NULL, NULL, NULL, 4),
(132365, NULL, 'G3DSA:1.20.120.350:FF:000153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132366, NULL, 'G3DSA:2.10.220.10:FF:000030', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(132367, NULL, 'G3DSA:3.40.50.300:FF:004039', NULL, NULL, 'ATP synthase subunit alpha, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(132368, NULL, 'G3DSA:1.10.238.10:FF:000996', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132369, NULL, 'G3DSA:2.20.100.10:FF:000165', NULL, NULL, 'CCN family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(132370, NULL, 'G3DSA:1.10.510.10:FF:002080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132371, NULL, 'G3DSA:1.20.58.1610:FF:000007', NULL, NULL, 'NADH-quinone oxidoreductase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(132372, NULL, 'G3DSA:2.130.10.10:FF:000610', NULL, NULL, 'Autophagy-related protein 18c', NULL, NULL, NULL, NULL, NULL, 4),
(132373, NULL, 'G3DSA:3.30.160.60:FF:001184', NULL, NULL, 'zinc finger protein 574', NULL, NULL, NULL, NULL, NULL, 4),
(132374, NULL, 'G3DSA:3.80.10.10:FF:000397', NULL, NULL, 'Transforming growth factor beta activator LRRC32', NULL, NULL, NULL, NULL, NULL, 4),
(132375, NULL, 'G3DSA:4.10.280.10:FF:000133', NULL, NULL, 'BHLH transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(132376, NULL, 'G3DSA:3.30.70.330:FF:001323', NULL, NULL, 'RNA-binding protein 27, putative', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(132377, NULL, 'G3DSA:3.90.550.10:FF:000151', NULL, NULL, 'O antigen biosynthesis rhamnosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(132378, NULL, 'G3DSA:1.25.40.10:FF:002936', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(132379, NULL, 'G3DSA:2.70.130.10:FF:000032', NULL, NULL, 'Lysosomal enzyme receptor protein', NULL, NULL, NULL, NULL, NULL, 4),
(132380, NULL, 'G3DSA:3.40.190.10:FF:000825', NULL, NULL, 'Glutamate receptor, ionotropic, AMPA 4', NULL, NULL, NULL, NULL, NULL, 4),
(132381, NULL, 'G3DSA:3.20.20.80:FF:000270', NULL, NULL, 'Oligo-1,6-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(132382, NULL, 'G3DSA:3.30.160.60:FF:000172', NULL, NULL, 'Zinc finger and SCAN domain containing 21', NULL, NULL, NULL, NULL, NULL, 4),
(132383, NULL, 'G3DSA:3.30.930.10:FF:000031', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(132384, NULL, 'G3DSA:1.25.10.10:FF:001529', NULL, NULL, 'YALI0F08165p', NULL, NULL, NULL, NULL, NULL, 4),
(132385, NULL, 'G3DSA:2.60.40.10:FF:003954', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132386, NULL, 'G3DSA:2.30.29.30:FF:000754', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(132387, NULL, 'G3DSA:1.25.40.10:FF:001924', NULL, NULL, 'Pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(132388, NULL, 'G3DSA:1.20.1300.20:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132389, NULL, 'G3DSA:3.40.50.2000:FF:000962', NULL, NULL, 'OSJNBb0056F09.12 protein', NULL, NULL, NULL, NULL, NULL, 4),
(132390, NULL, 'G3DSA:3.80.10.10:FF:002432', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132391, NULL, 'G3DSA:3.50.50.60:FF:001360', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132392, NULL, 'G3DSA:2.130.10.10:FF:001841', NULL, NULL, 'Transducin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(132393, NULL, 'G3DSA:3.30.499.10:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132394, NULL, 'G3DSA:1.10.8.60:FF:000233', NULL, NULL, 'Peroxisome assembly factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132395, NULL, 'G3DSA:1.25.40.20:FF:001186', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(132396, NULL, 'G3DSA:1.10.287.70:FF:000609', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132397, NULL, 'G3DSA:1.20.1250.20:FF:000395', NULL, NULL, 'Carboxylic acid transporter protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(132398, NULL, 'G3DSA:4.10.900.10:FF:000029', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(132399, NULL, 'G3DSA:3.30.160.60:FF:005455', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132400, NULL, 'G3DSA:3.40.1190.20:FF:000237', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132401, NULL, 'G3DSA:3.50.50.60:FF:001208', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(132402, NULL, 'G3DSA:2.130.10.10:FF:001280', NULL, NULL, 'WD repeat-containing protein 55 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(132403, NULL, 'G3DSA:3.10.580.10:FF:000210', NULL, NULL, 'Putative transport integral membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(132404, NULL, 'G3DSA:3.20.20.60:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132405, NULL, 'G3DSA:3.40.50.10190:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132406, NULL, 'G3DSA:3.40.50.10420:FF:000042', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(132407, NULL, 'G3DSA:1.10.510.10:FF:001186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132408, NULL, 'G3DSA:3.40.1110.10:FF:000235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132409, NULL, 'G3DSA:1.20.1300.10:FF:000003', NULL, NULL, 'Fumarate reductase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(132410, NULL, 'G3DSA:1.20.1560.10:FF:000157', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(132411, NULL, 'G3DSA:2.60.40.10:FF:001532', NULL, NULL, 'Immunoglobulin heavy variable 1-3', NULL, NULL, NULL, NULL, NULL, 4),
(132412, NULL, 'G3DSA:3.40.50.300:FF:005057', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132413, NULL, 'G3DSA:3.40.50.2300:FF:001390', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132414, NULL, 'G3DSA:3.90.320.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132415, NULL, 'G3DSA:2.30.230.10:FF:000009', NULL, NULL, 'Vitellogenin-1', NULL, NULL, NULL, NULL, NULL, 4),
(132416, NULL, 'G3DSA:3.90.190.10:FF:000516', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132417, NULL, 'G3DSA:3.10.105.10:FF:000034', NULL, NULL, 'Oligopeptide ABC transporter, periplasmic oligopeptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(132418, NULL, 'G3DSA:3.40.50.300:FF:001746', NULL, NULL, 'ATP-dependent DNA helicase recQ', NULL, NULL, NULL, NULL, NULL, 4),
(132419, NULL, 'G3DSA:1.10.630.10:FF:000346', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(132420, NULL, 'G3DSA:2.130.10.10:FF:005551', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132421, NULL, 'G3DSA:3.30.200.20:FF:001810', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132422, NULL, 'G3DSA:1.20.5.110:FF:000048', NULL, NULL, 'Protein transport protein SEC9', NULL, NULL, NULL, NULL, NULL, 4),
(132423, NULL, 'G3DSA:2.60.120.330:FF:000081', NULL, NULL, 'Os08g0249900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(132424, NULL, 'G3DSA:3.40.50.720:FF:000955', NULL, NULL, 'Oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(132425, NULL, 'G3DSA:3.30.450.20:FF:000227', NULL, NULL, 'AGC protein kinase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(132426, NULL, 'G3DSA:3.40.1160.10:FF:000025', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(132427, NULL, 'G3DSA:1.20.58.90:FF:000004', NULL, NULL, 'Syntaxin 10', NULL, NULL, NULL, NULL, NULL, 4),
(132428, NULL, 'G3DSA:3.30.70.660:FF:000056', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(132429, NULL, 'G3DSA:3.30.70.330:FF:002778', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132430, NULL, 'G3DSA:3.30.70.330:FF:000654', NULL, NULL, 'Ribosomal protein L23', NULL, NULL, NULL, NULL, NULL, 4),
(132431, NULL, 'G3DSA:3.40.50.12710:FF:000026', NULL, NULL, 'Gll2384 protein', NULL, NULL, NULL, NULL, NULL, 4),
(132432, NULL, 'G3DSA:2.10.50.10:FF:000040', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 14', NULL, NULL, NULL, NULL, NULL, 4),
(132433, NULL, 'G3DSA:1.20.1070.10:FF:000636', NULL, NULL, 'Proctolin receptor, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(132434, NULL, 'G3DSA:3.30.70.330:FF:000598', NULL, NULL, 'Oligouridylate-binding protein 1C', NULL, NULL, NULL, NULL, NULL, 4),
(132435, NULL, 'G3DSA:3.10.290.10:FF:000053', NULL, NULL, 'Uncharacterized RNA pseudouridine synthase jhp_0682', NULL, NULL, NULL, NULL, NULL, 4),
(132436, NULL, 'G3DSA:2.60.40.10:FF:005573', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132437, NULL, 'G3DSA:1.20.1250.20:FF:001406', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132438, NULL, 'G3DSA:1.10.510.10:FF:001298', NULL, NULL, 'STE20-like kinase', NULL, NULL, NULL, NULL, NULL, 4),
(132439, NULL, 'G3DSA:2.80.10.50:FF:000220', NULL, NULL, 'protein O-mannosyl-transferase 1-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(132440, NULL, 'G3DSA:2.10.90.10:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132441, NULL, 'G3DSA:1.10.418.10:FF:000015', NULL, NULL, 'Parvin beta', NULL, NULL, NULL, NULL, NULL, 4),
(132442, NULL, 'G3DSA:2.130.10.10:FF:001914', NULL, NULL, 'DNA damage-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(132443, NULL, 'G3DSA:3.30.70.1620:FF:000013', NULL, NULL, 'Structural maintenance of chromosomes protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(132444, NULL, 'G3DSA:3.40.50.720:FF:002428', NULL, NULL, 'Myo-inositol-1-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(132445, NULL, 'G3DSA:3.30.160.60:FF:001419', NULL, NULL, 'Zinc finger protein 581', NULL, NULL, NULL, NULL, NULL, 4),
(132446, NULL, 'G3DSA:3.10.290.10:FF:000047', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(132447, NULL, 'G3DSA:3.40.50.300:FF:007709', NULL, NULL, 'Glycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(132448, NULL, 'G3DSA:6.10.140.2220:FF:000031', NULL, NULL, 'SET (Trithorax/polycomb) domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(132449, NULL, 'G3DSA:1.10.287.600:FF:000016', NULL, NULL, 'Tubulin gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(132450, NULL, 'G3DSA:3.40.1810.10:FF:000081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132451, NULL, 'G3DSA:3.30.160.380:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132452, NULL, 'G3DSA:3.30.470.20:FF:000228', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(132453, NULL, 'G3DSA:3.90.25.10:FF:000015', NULL, NULL, 'SDR family oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(132454, NULL, 'G3DSA:3.40.50.1100:FF:000063', NULL, NULL, 'Putative cysteine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(132455, NULL, 'G3DSA:1.20.58.90:FF:000010', NULL, NULL, 'Tubulin-specific chaperone A', NULL, NULL, NULL, NULL, NULL, 4),
(132456, NULL, 'G3DSA:1.10.555.10:FF:000154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132457, NULL, 'G3DSA:3.40.50.1110:FF:000009', NULL, NULL, 'GDSL esterase/lipase At1g09390', NULL, NULL, NULL, NULL, NULL, 4),
(132458, NULL, 'G3DSA:3.30.200.110:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132459, NULL, 'G3DSA:1.25.40.10:FF:001071', NULL, NULL, 'pre-mRNA-splicing factor SYF1-like', NULL, NULL, NULL, NULL, NULL, 4),
(132460, NULL, 'G3DSA:2.60.40.60:FF:000164', NULL, NULL, 'cadherin-23 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(132461, NULL, 'G3DSA:3.40.50.1110:FF:000066', NULL, NULL, 'Lipolytic enzyme, G-D-S-L family', NULL, NULL, NULL, NULL, NULL, 4),
(132462, NULL, 'G3DSA:3.30.1330.30:FF:000052', NULL, NULL, '23S rRNA (guanosine-2''-O-)-methyltransferase RlmB', NULL, NULL, NULL, NULL, NULL, 4),
(132463, NULL, 'G3DSA:2.60.120.10:FF:000702', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132464, NULL, 'G3DSA:2.60.40.1930:FF:000009', NULL, NULL, 'Complement C3', NULL, NULL, NULL, NULL, NULL, 4),
(132465, NULL, 'G3DSA:3.30.1330.40:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132466, NULL, 'G3DSA:3.90.650.10:FF:000035', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(132467, NULL, 'G3DSA:3.40.50.1100:FF:000006', NULL, NULL, 'Cysteine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(132468, NULL, 'G3DSA:2.30.29.30:FF:000703', NULL, NULL, 'Sorting nexin-17 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(132469, NULL, 'G3DSA:3.50.50.60:FF:001214', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(132470, NULL, 'G3DSA:1.10.275.10:FF:000003', NULL, NULL, 'Adenylosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(132471, NULL, 'G3DSA:3.40.630.20:FF:000003', NULL, NULL, 'Pyrrolidone-carboxylate peptidase isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(132472, NULL, 'G3DSA:1.20.5.110:FF:000161', NULL, NULL, 'Syntaxin 1A/ snare domain', NULL, NULL, NULL, NULL, NULL, 4),
(132473, NULL, 'G3DSA:3.30.420.10:FF:000565', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132474, NULL, 'G3DSA:2.60.40.10:FF:003443', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132475, NULL, 'G3DSA:3.10.20.90:FF:000071', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(132476, NULL, 'G3DSA:3.30.160.60:FF:000166', NULL, NULL, 'Zinc finger and BTB domain-containing 49', NULL, NULL, NULL, NULL, NULL, 4),
(132477, NULL, 'G3DSA:3.30.70.2740:FF:000012', NULL, NULL, 'D-lactate dehydrogenase (Dld)', NULL, NULL, NULL, NULL, NULL, 4),
(132478, NULL, 'G3DSA:1.20.120.1080:FF:000019', NULL, NULL, 'ATP-dependent RNA helicase DHX8', NULL, NULL, NULL, NULL, NULL, 4),
(132479, NULL, 'G3DSA:1.10.1450.10:FF:000050', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(132480, NULL, 'G3DSA:3.30.200.20:FF:000299', NULL, NULL, 'Receptor-like serine/threonine-protein kinase ALE2', NULL, NULL, NULL, NULL, NULL, 4),
(132481, NULL, 'G3DSA:1.20.1070.10:FF:002093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132482, NULL, 'G3DSA:3.40.1160.10:FF:000019', NULL, NULL, 'Uridylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(132483, NULL, 'G3DSA:1.20.900.10:FF:000005', NULL, NULL, 'Ras-specific guanine nucleotide-releasing factor 1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(132484, NULL, 'G3DSA:1.20.1070.10:FF:001311', NULL, NULL, 'G-protein coupled receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132485, NULL, 'G3DSA:3.30.930.10:FF:000323', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132486, NULL, 'G3DSA:1.25.40.10:FF:005286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132487, NULL, 'G3DSA:1.10.510.10:FF:004114', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132488, NULL, 'G3DSA:2.130.10.10:FF:003078', NULL, NULL, 'Guanine nucleotide-binding protein subunit beta, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132489, NULL, 'G3DSA:2.20.28.60:FF:000002', NULL, NULL, 'Citrate synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(132490, NULL, 'G3DSA:3.30.70.340:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132491, NULL, 'G3DSA:3.30.160.60:FF:001751', NULL, NULL, 'Zinc finger protein 599', NULL, NULL, NULL, NULL, NULL, 4),
(132492, NULL, 'G3DSA:2.60.40.2140:FF:000005', NULL, NULL, '3-glucan binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(132493, NULL, 'G3DSA:3.50.30.30:FF:000147', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(132494, NULL, 'G3DSA:1.20.120.1070:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132495, NULL, 'G3DSA:1.50.10.10:FF:000049', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(132496, NULL, 'G3DSA:2.130.10.10:FF:005225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132497, NULL, 'G3DSA:2.130.10.10:FF:005169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132498, NULL, 'G3DSA:2.60.120.40:FF:000014', NULL, NULL, 'Tumor necrosis factor ligand superfamily member', NULL, NULL, NULL, NULL, NULL, 4),
(132499, NULL, 'G3DSA:1.25.10.10:FF:001243', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(132500, NULL, 'G3DSA:1.20.58.60:FF:000574', NULL, NULL, 'ACTN4 isoform 9', NULL, NULL, NULL, NULL, NULL, 4),
(132501, NULL, 'G3DSA:1.25.40.20:FF:001747', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132502, NULL, 'G3DSA:1.10.8.10:FF:000353', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132503, NULL, 'G3DSA:2.30.140.10:FF:000002', NULL, NULL, 'Polyamine aminopropyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(132504, NULL, 'G3DSA:3.30.70.590:FF:000012', NULL, NULL, 'Poly(A) polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(132505, NULL, 'G3DSA:3.80.10.10:FF:000684', NULL, NULL, 'Transforming growth factor beta activator LRRC33', NULL, NULL, NULL, NULL, NULL, 4),
(132506, NULL, 'G3DSA:1.10.390.10:FF:000074', NULL, NULL, 'Aminopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132507, NULL, 'G3DSA:3.40.50.10190:FF:000046', NULL, NULL, 'PAX interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(132508, NULL, 'G3DSA:3.30.70.1180:FF:000016', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(132509, NULL, 'G3DSA:3.40.30.10:FF:000018', NULL, NULL, 'Glutaredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(132510, NULL, 'G3DSA:1.10.510.10:FF:001259', NULL, NULL, 'Eukaryotic initiation factor 2alpha kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(132511, NULL, 'G3DSA:3.40.50.1820:FF:000565', NULL, NULL, 'Alpha/beta-Hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(132512, NULL, 'G3DSA:3.40.50.2300:FF:000838', NULL, NULL, 'Vomeronasal 2, receptor 18', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(132513, NULL, 'G3DSA:1.10.418.20:FF:000018', NULL, NULL, 'SUMO-specific peptidase 6b', NULL, NULL, NULL, NULL, NULL, 4),
(132514, NULL, 'G3DSA:2.80.10.50:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132515, NULL, 'G3DSA:1.10.10.790:FF:000016', NULL, NULL, 'Suppressor of white-apricot, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(132516, NULL, 'G3DSA:1.10.1200.10:FF:000127', NULL, NULL, 'Enniatin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(132517, NULL, 'G3DSA:1.10.132.70:FF:000015', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(132518, NULL, 'G3DSA:2.30.180.10:FF:000162', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132519, NULL, 'G3DSA:3.30.420.10:FF:000621', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132520, NULL, 'G3DSA:2.30.30.140:FF:000244', NULL, NULL, 'ARID (AT-rich Interactive Domain-containing protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(132521, NULL, 'G3DSA:3.40.50.1260:FF:000026', NULL, NULL, 'Phosphoglycerate kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(132522, NULL, 'G3DSA:4.10.900.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132523, NULL, 'G3DSA:3.40.1110.10:FF:000308', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132524, NULL, 'G3DSA:3.30.70.1170:FF:000013', NULL, NULL, 'Putative 28S rRNA (Cytosine-C(5))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(132525, NULL, 'G3DSA:3.40.50.2020:FF:000119', NULL, NULL, 'Phosphoribosyl pyrophosphate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(132526, NULL, 'G3DSA:2.60.40.10:FF:003387', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132527, NULL, 'G3DSA:3.60.40.10:FF:000349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132528, NULL, 'G3DSA:2.10.25.10:FF:001021', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(132529, NULL, 'G3DSA:1.25.10.10:FF:003373', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(132530, NULL, 'G3DSA:3.30.710.10:FF:000048', NULL, NULL, 'zinc finger and BTB domain-containing protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(132531, NULL, 'G3DSA:1.10.132.60:FF:000012', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(132532, NULL, 'G3DSA:1.10.390.10:FF:000017', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(132533, NULL, 'G3DSA:3.40.1160.10:FF:000064', NULL, NULL, 'Acetylglutamate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(132534, NULL, 'G3DSA:3.30.40.210:FF:000016', NULL, NULL, 'Transcription elongation factor SPT4', NULL, NULL, NULL, NULL, NULL, 4),
(132535, NULL, 'G3DSA:1.20.120.350:FF:000147', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132536, NULL, 'G3DSA:2.130.10.10:FF:005282', NULL, NULL, 'Flagellar associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(132537, NULL, 'G3DSA:2.60.40.1480:FF:000009', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(132538, NULL, 'G3DSA:1.10.10.1460:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132539, NULL, 'G3DSA:2.60.200.40:FF:000015', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(132540, NULL, 'G3DSA:3.30.160.60:FF:005966', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132541, NULL, 'G3DSA:1.20.1250.20:FF:002194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132542, NULL, 'G3DSA:3.40.50.300:FF:005843', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132543, NULL, 'G3DSA:3.40.50.1820:FF:001869', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132544, NULL, 'G3DSA:1.10.630.10:FF:000172', NULL, NULL, 'Cytochrome P450 130', NULL, NULL, NULL, NULL, NULL, 4),
(132545, NULL, 'G3DSA:3.40.50.450:FF:000060', NULL, NULL, 'Rossmann fold nucleotide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(132546, NULL, 'G3DSA:3.90.180.10:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132547, NULL, 'G3DSA:1.20.120.850:FF:000027', NULL, NULL, 'DNA repair and recombination protein RAD54', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(132548, NULL, 'G3DSA:3.30.1240.10:FF:000067', NULL, NULL, 'Putative phosphatase MG265', NULL, NULL, NULL, NULL, NULL, 4),
(132549, NULL, 'G3DSA:1.10.10.1450:FF:000001', NULL, NULL, 'SETMAR isoform 5', NULL, NULL, NULL, NULL, NULL, 4),
(132550, NULL, 'G3DSA:3.80.10.10:FF:001122', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase ERECTA', NULL, NULL, NULL, NULL, NULL, 4),
(132551, NULL, 'G3DSA:1.10.287.110:FF:000414', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(132552, NULL, 'G3DSA:1.20.1280.50:FF:000052', NULL, NULL, 'F-box protein (Pof7), putative', NULL, NULL, NULL, NULL, NULL, 4),
(132553, NULL, 'G3DSA:2.60.120.620:FF:000128', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(132554, NULL, 'G3DSA:3.40.1190.20:FF:000182', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132555, NULL, 'G3DSA:1.25.10.10:FF:002030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132556, NULL, 'G3DSA:3.30.160.60:FF:001476', NULL, NULL, 'Zinc finger protein 516', NULL, NULL, NULL, NULL, NULL, 4),
(132557, NULL, 'G3DSA:1.20.1730.10:FF:000086', NULL, NULL, 'Solute carrier family 5 (sodium/glucose cotransporter), member 1', NULL, NULL, NULL, NULL, NULL, 4),
(132558, NULL, 'G3DSA:2.10.25.10:FF:000296', NULL, NULL, 'Sushi, nidogen and EGF like domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(132559, NULL, 'G3DSA:3.40.50.300:FF:007861', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132560, NULL, 'G3DSA:2.30.30.140:FF:000188', NULL, NULL, 'Tapas, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(132561, NULL, 'G3DSA:2.60.40.2580:FF:000002', NULL, NULL, 'Minor fimbrium subunit Mfa1', NULL, NULL, NULL, NULL, NULL, 4),
(132562, NULL, 'G3DSA:1.25.40.10:FF:003105', NULL, NULL, 'peptidyl-prolyl cis-trans isomerase D', NULL, NULL, NULL, NULL, NULL, 4),
(132563, NULL, 'G3DSA:3.40.50.2300:FF:001625', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132564, NULL, 'G3DSA:3.40.50.2300:FF:000788', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132565, NULL, 'G3DSA:1.10.287.70:FF:000155', NULL, NULL, 'potassium channel subfamily K member 16', NULL, NULL, NULL, NULL, NULL, 4),
(132566, NULL, 'G3DSA:4.10.280.10:FF:000240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132567, NULL, 'G3DSA:1.20.1250.20:FF:000569', NULL, NULL, 'Transmembrane transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132568, NULL, 'G3DSA:3.30.160.60:FF:003656', NULL, NULL, 'AGAP011758-PA', NULL, NULL, NULL, NULL, NULL, 4),
(132569, NULL, 'G3DSA:3.30.160.60:FF:002201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132570, NULL, 'G3DSA:1.10.150.50:FF:000017', NULL, NULL, 'Liprin-beta-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(132571, NULL, 'G3DSA:1.20.120.350:FF:000203', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132572, NULL, 'G3DSA:2.20.100.10:FF:000053', NULL, NULL, 'ADAMTS-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(132573, NULL, 'G3DSA:3.30.200.20:FF:001754', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132574, NULL, 'G3DSA:3.90.870.10:FF:000017', NULL, NULL, 'Threonylcarbamoyl-AMP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(132575, NULL, 'G3DSA:1.20.58.60:FF:000793', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132576, NULL, 'G3DSA:3.30.160.60:FF:005747', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132577, NULL, 'G3DSA:3.30.450.20:FF:000452', NULL, NULL, 'Voltage-dependent calcium channel subunit alpha-2/delta-3', NULL, NULL, NULL, NULL, NULL, 4),
(132578, NULL, 'G3DSA:3.30.70.330:FF:000873', NULL, NULL, 'Putative RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(132579, NULL, 'G3DSA:2.60.200.30:FF:000012', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(132580, NULL, 'G3DSA:3.50.50.60:FF:001253', NULL, NULL, 'Os04g0692800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(132581, NULL, 'G3DSA:1.25.40.90:FF:000094', NULL, NULL, 'Putative clathrin assembly protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(132582, NULL, 'G3DSA:3.40.50.80:FF:000164', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(132583, NULL, 'G3DSA:1.25.40.470:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132584, NULL, 'G3DSA:3.90.470.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132585, NULL, 'G3DSA:3.30.300.160:FF:000010', NULL, NULL, 'General secretion pathway protein E', NULL, NULL, NULL, NULL, NULL, 4),
(132586, NULL, 'G3DSA:2.70.98.30:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132587, NULL, 'G3DSA:3.40.1110.10:FF:000460', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132588, NULL, 'G3DSA:3.80.10.10:FF:002870', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(132589, NULL, 'G3DSA:2.60.40.10:FF:005534', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132590, NULL, 'G3DSA:1.25.40.10:FF:005342', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132591, NULL, 'G3DSA:1.25.10.10:FF:001355', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132592, NULL, 'G3DSA:1.25.10.10:FF:001973', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(132593, NULL, 'G3DSA:2.60.40.60:FF:000271', NULL, NULL, 'Cadherin-related 23', NULL, NULL, NULL, NULL, NULL, 4),
(132594, NULL, 'G3DSA:2.60.40.420:FF:000144', NULL, NULL, 'Ephrin', NULL, NULL, NULL, NULL, NULL, 4),
(132595, NULL, 'G3DSA:3.50.50.60:FF:000758', NULL, NULL, 'Fumarate reductase flavoprotein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(132596, NULL, 'G3DSA:1.10.472.30:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132597, NULL, 'G3DSA:3.30.1490.20:FF:000004', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(132598, NULL, 'G3DSA:3.40.1000.30:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132599, NULL, 'G3DSA:2.30.29.30:FF:000810', NULL, NULL, 'Rho GTPase-activating protein (RhoGAP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(132600, NULL, 'G3DSA:1.25.70.10:FF:000004', NULL, NULL, 'Transcription termination factor mterf4, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(132601, NULL, 'G3DSA:1.10.510.10:FF:001478', NULL, NULL, 'Os02g0106900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(132602, NULL, 'G3DSA:3.40.390.30:FF:000003', NULL, NULL, 'YBEY isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(132603, NULL, 'G3DSA:1.10.238.10:FF:000029', NULL, NULL, 'Signal transducer and transcription activator 6', NULL, NULL, NULL, NULL, NULL, 4),
(132604, NULL, 'G3DSA:2.30.120.10:FF:000001', NULL, NULL, 'Acyl-homoserine lactone acylase QuiP', NULL, NULL, NULL, NULL, NULL, 4),
(132605, NULL, 'G3DSA:3.40.50.720:FF:002541', NULL, NULL, 'Lysine-ketoglutarate reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132606, NULL, 'G3DSA:1.20.1560.10:FF:000449', NULL, NULL, 'ATP-binding cassette transporter, subfamily B, member 19, group MDR/PGP protein PpABCB19', NULL, NULL, NULL, NULL, NULL, 4),
(132607, NULL, 'G3DSA:3.40.930.10:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132608, NULL, 'G3DSA:1.10.287.70:FF:000716', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132609, NULL, 'G3DSA:3.90.20.20:FF:000029', NULL, NULL, 'Protein GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(132610, NULL, 'G3DSA:3.30.40.10:FF:001328', NULL, NULL, 'Nucleic acid binding', NULL, NULL, NULL, NULL, NULL, 4),
(132611, NULL, 'G3DSA:1.20.1050.10:FF:000309', NULL, NULL, 'Glutathione s-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(132612, NULL, 'G3DSA:3.40.50.300:FF:001572', NULL, NULL, 'ESX-1 secretion system protein eccCa1', NULL, NULL, NULL, NULL, NULL, 4),
(132613, NULL, 'G3DSA:1.20.5.110:FF:000009', NULL, NULL, 'Synaptosomal-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(132614, NULL, 'G3DSA:3.20.20.70:FF:000502', NULL, NULL, 'Radical SAM domain protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(132615, NULL, 'G3DSA:1.10.287.1150:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132616, NULL, 'G3DSA:1.25.40.180:FF:000184', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132617, NULL, 'G3DSA:3.40.50.300:FF:004152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132618, NULL, 'G3DSA:3.20.20.80:FF:000505', NULL, NULL, 'Beta-1,4-endoglucanase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(132619, NULL, 'G3DSA:2.120.10.80:FF:000289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132620, NULL, 'G3DSA:3.20.20.80:FF:000562', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132621, NULL, 'G3DSA:3.80.10.10:FF:003213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132622, NULL, 'G3DSA:3.30.200.20:FF:001024', NULL, NULL, 'Protein kinase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(132623, NULL, 'G3DSA:2.30.39.10:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132624, NULL, 'G3DSA:3.90.1580.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132625, NULL, 'G3DSA:1.25.40.180:FF:000127', NULL, NULL, 'Polyadenylate-binding protein-interacting protein 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132626, NULL, 'G3DSA:1.20.5.100:FF:000006', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(132627, NULL, 'G3DSA:1.20.58.60:FF:000810', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132628, NULL, 'G3DSA:3.60.90.10:FF:000009', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(132629, NULL, 'G3DSA:3.30.70.330:FF:002958', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132630, NULL, 'G3DSA:1.25.40.10:FF:003723', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(132631, NULL, 'G3DSA:1.25.10.10:FF:003154', NULL, NULL, 'Thiamin pyrophosphokinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(132632, NULL, 'G3DSA:3.40.50.1820:FF:000801', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(132633, NULL, 'G3DSA:4.10.400.10:FF:000160', NULL, NULL, 'Low-density lipoprotein receptor-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(132634, NULL, 'G3DSA:3.10.450.350:FF:000014', NULL, NULL, 'Cell wall endopeptidase family M23/M37', NULL, NULL, NULL, NULL, NULL, 4),
(132635, NULL, 'G3DSA:1.10.510.10:FF:003619', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132636, NULL, 'G3DSA:1.10.238.10:FF:000361', NULL, NULL, 'Sodium/calcium exchanger NCL2', NULL, NULL, NULL, NULL, NULL, 4),
(132637, NULL, 'G3DSA:1.10.510.10:FF:003333', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132638, NULL, 'G3DSA:2.130.10.10:FF:003932', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132639, NULL, 'G3DSA:2.10.70.10:FF:000215', NULL, NULL, 'Protein lev-9', NULL, NULL, NULL, NULL, NULL, 4),
(132640, NULL, 'G3DSA:1.20.1070.10:FF:000816', NULL, NULL, 'Serpentine receptor class alpha-13', NULL, NULL, NULL, NULL, NULL, 4),
(132641, NULL, 'G3DSA:1.25.10.10:FF:003098', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(132642, NULL, 'G3DSA:3.60.130.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132643, NULL, 'G3DSA:1.20.1250.20:FF:000682', NULL, NULL, 'Probable MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(132644, NULL, 'G3DSA:3.80.10.10:FF:004517', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132645, NULL, 'G3DSA:2.30.29.30:FF:000467', NULL, NULL, 'Blown fuse, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(132646, NULL, 'G3DSA:1.10.3580.10:FF:000003', NULL, NULL, 'BnaA04g10520D protein', NULL, NULL, NULL, NULL, NULL, 4),
(132647, NULL, 'G3DSA:1.10.1200.10:FF:000060', NULL, NULL, 'Nonribosomal peptide synthase GliP', NULL, NULL, NULL, NULL, NULL, 4),
(132648, NULL, 'G3DSA:1.20.1280.290:FF:000059', NULL, NULL, 'Cystinosin-like', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(132649, NULL, 'G3DSA:3.10.129.10:FF:000095', NULL, NULL, 'Acyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(132650, NULL, 'G3DSA:1.10.510.10:FF:003277', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132651, NULL, 'G3DSA:1.10.533.10:FF:000030', NULL, NULL, 'Interleukin-1 receptor-associated kinase-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(132652, NULL, 'G3DSA:2.60.120.10:FF:000814', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132653, NULL, 'G3DSA:3.40.30.10:FF:000456', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(132654, NULL, 'G3DSA:1.25.40.20:FF:000730', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(132655, NULL, 'G3DSA:3.40.1360.10:FF:000006', NULL, NULL, 'Ribonuclease M5', NULL, NULL, NULL, NULL, NULL, 4),
(132656, NULL, 'G3DSA:1.10.472.10:FF:000585', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132657, NULL, 'G3DSA:1.25.10.10:FF:002878', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(132658, NULL, 'G3DSA:3.40.50.1820:FF:001021', NULL, NULL, 'GPI inositol-deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(132659, NULL, 'G3DSA:2.30.29.30:FF:000809', NULL, NULL, 'Putative peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(132660, NULL, 'G3DSA:1.10.285.20:FF:000001', NULL, NULL, 'Protein-glutamate O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(132661, NULL, 'G3DSA:3.20.70.20:FF:000007', NULL, NULL, 'Vitamin B12-dependent ribonucleotide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(132662, NULL, 'G3DSA:1.20.1740.10:FF:000255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132663, NULL, 'G3DSA:3.30.40.10:FF:001109', NULL, NULL, 'Ring finger domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(132664, NULL, 'G3DSA:3.40.50.300:FF:003258', NULL, NULL, 'Elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(132665, NULL, 'G3DSA:1.20.1740.10:FF:000199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132666, NULL, 'G3DSA:1.20.5.300:FF:000010', NULL, NULL, 'Striatin Pro11', NULL, NULL, NULL, NULL, NULL, 4),
(132667, NULL, 'G3DSA:3.30.40.10:FF:000547', NULL, NULL, 'Chromatin modification-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(132668, NULL, 'G3DSA:1.10.630.10:FF:000733', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132669, NULL, 'G3DSA:2.30.31.10:FF:000017', NULL, NULL, 'RNA polymerase II transcriptional coactivator KIWI', NULL, NULL, NULL, NULL, NULL, 4),
(132670, NULL, 'G3DSA:1.20.120.350:FF:000260', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132671, NULL, 'G3DSA:1.20.1440.200:FF:000002', NULL, NULL, 'Vacuolar protein sorting-associated protein 28 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(132672, NULL, 'G3DSA:3.40.50.300:FF:002353', NULL, NULL, 'Type I restriction-modification system endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(132673, NULL, 'G3DSA:3.90.190.10:FF:000067', NULL, NULL, 'Phosphatase domain-containing, paladin 1', NULL, NULL, NULL, NULL, NULL, 4),
(132674, NULL, 'G3DSA:2.40.50.140:FF:001140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132675, NULL, 'G3DSA:3.30.470.10:FF:000006', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(132676, NULL, 'G3DSA:3.30.1490.10:FF:000001', NULL, NULL, '30S ribosomal protein S8', NULL, NULL, NULL, NULL, NULL, 4),
(132677, NULL, 'G3DSA:4.10.1000.10:FF:000093', NULL, NULL, 'Key regulator in ER unfolded protein response', NULL, NULL, NULL, NULL, NULL, 4),
(132678, NULL, 'G3DSA:1.20.1070.10:FF:001131', NULL, NULL, 'Rhodopsin, GQ-coupled', NULL, NULL, NULL, NULL, NULL, 4),
(132679, NULL, 'G3DSA:1.10.720.30:FF:000044', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(132680, NULL, 'G3DSA:2.60.40.1730:FF:000118', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132681, NULL, 'G3DSA:3.40.50.2020:FF:000120', NULL, NULL, 'Uridine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(132682, NULL, 'G3DSA:3.30.559.10:FF:000038', NULL, NULL, 'Nonribosomal siderophore peptide synthase SidC', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(132683, NULL, 'G3DSA:3.30.342.10:FF:000057', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(132684, NULL, 'G3DSA:3.40.20.10:FF:000012', NULL, NULL, 'Twinfilin-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(132685, NULL, 'G3DSA:3.90.320.10:FF:000050', NULL, NULL, 'CRISPR-associated exonuclease Cas4', NULL, NULL, NULL, NULL, NULL, 4),
(132686, NULL, 'G3DSA:3.40.30.10:FF:000170', NULL, NULL, 'Chloride intracellular channel 3', NULL, NULL, NULL, NULL, NULL, 4),
(132687, NULL, 'G3DSA:3.30.420.40:FF:000849', NULL, NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(132688, NULL, 'G3DSA:1.10.10.10:FF:001568', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(132689, NULL, 'G3DSA:1.10.8.870:FF:000008', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(132690, NULL, 'G3DSA:3.30.160.60:FF:002532', NULL, NULL, 'Zinc finger protein 473', NULL, NULL, NULL, NULL, NULL, 4),
(132691, NULL, 'G3DSA:3.30.390.10:FF:000005', NULL, NULL, 'o-succinylbenzoate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(132692, NULL, 'G3DSA:2.30.130.10:FF:000007', NULL, NULL, 'Glutamate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(132693, NULL, 'G3DSA:1.10.565.10:FF:000216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132694, NULL, 'G3DSA:2.60.40.10:FF:005753', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132695, NULL, 'G3DSA:3.30.342.10:FF:000018', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(132696, NULL, 'G3DSA:2.40.10.10:FF:000064', NULL, NULL, 'Hepatocyte growth factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(132697, NULL, 'G3DSA:3.30.470.20:FF:000009', NULL, NULL, 'tubulin polyglutamylase TTLL5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(132698, NULL, 'G3DSA:1.20.120.20:FF:000038', NULL, NULL, 'Apolipophorin-3', NULL, NULL, NULL, NULL, NULL, 4),
(132699, NULL, 'G3DSA:1.10.1200.270:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132700, NULL, 'G3DSA:2.60.40.10:FF:002083', NULL, NULL, 'Protein CBR-UNC-22', NULL, NULL, NULL, NULL, NULL, 4),
(132701, NULL, 'G3DSA:1.20.120.1750:FF:000012', NULL, NULL, 'ranBP-type and C3HC4-type zinc finger-containing protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(132702, NULL, 'G3DSA:1.25.40.10:FF:000053', NULL, NULL, 'Tetratricopeptide repeat domain 17', NULL, NULL, NULL, NULL, NULL, 4),
(132703, NULL, 'G3DSA:3.40.50.720:FF:002209', NULL, NULL, 'DeHydrogenases, Short chain', NULL, NULL, NULL, NULL, NULL, 4),
(132704, NULL, 'G3DSA:3.40.50.10330:FF:000054', NULL, NULL, 'ceramide kinase', NULL, NULL, NULL, NULL, NULL, 4),
(132705, NULL, 'G3DSA:3.30.160.60:FF:004331', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132706, NULL, 'G3DSA:1.10.630.10:FF:000059', NULL, NULL, 'Cytochrome P450 monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(132707, NULL, 'G3DSA:3.30.1140.60:FF:000001', NULL, NULL, 'F-actin-capping protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(132708, NULL, 'G3DSA:1.20.120.1760:FF:000015', NULL, NULL, 'CDP-alcohol phosphatidyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(132709, NULL, 'G3DSA:1.20.1250.20:FF:000625', NULL, NULL, 'Related to TNA1-high affinity nicotinic acid plasma membrane permease', NULL, NULL, NULL, NULL, NULL, 4),
(132710, NULL, 'G3DSA:3.40.50.300:FF:001459', NULL, NULL, 'ATPase ASNA1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(132711, NULL, 'G3DSA:2.60.40.10:FF:001083', NULL, NULL, 'T cell receptor gamma constant 2', NULL, NULL, NULL, NULL, NULL, 4),
(132712, NULL, 'G3DSA:1.10.10.400:FF:000001', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(132713, NULL, 'G3DSA:1.20.1560.10:FF:000668', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132714, NULL, 'G3DSA:1.20.5.110:FF:000341', NULL, NULL, 'Synaptobrevin', NULL, NULL, NULL, NULL, NULL, 4),
(132715, NULL, 'G3DSA:2.60.120.430:FF:000010', NULL, NULL, 'Di-glucose binding protein with Leucine-rich repeat domain', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(132716, NULL, 'G3DSA:2.170.300.10:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132717, NULL, 'G3DSA:3.60.10.10:FF:000292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132718, NULL, 'G3DSA:2.130.10.10:FF:001392', NULL, NULL, 'Damaged DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(132719, NULL, 'G3DSA:3.40.1190.20:FF:000125', NULL, NULL, 'Pyridoxal kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(132720, NULL, 'G3DSA:1.25.10.10:FF:001299', NULL, NULL, 'Protein CBG08524', NULL, NULL, NULL, NULL, NULL, 4),
(132721, NULL, 'G3DSA:3.10.250.10:FF:000106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132722, NULL, 'G3DSA:1.25.40.20:FF:000056', NULL, NULL, 'Death associated protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(132723, NULL, 'G3DSA:2.10.110.10:FF:000275', NULL, NULL, 'LIM and senescent cell antigen-like-containing domain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(132724, NULL, 'G3DSA:3.30.2350.10:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132725, NULL, 'G3DSA:1.20.1070.10:FF:000855', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(132726, NULL, 'G3DSA:3.90.70.10:FF:000142', NULL, NULL, 'Cysteine proteinase-like', NULL, NULL, NULL, NULL, NULL, 4),
(132727, NULL, 'G3DSA:3.40.50.300:FF:003932', NULL, NULL, 'DNA polymerase III subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(132728, NULL, 'G3DSA:1.25.40.20:FF:000112', NULL, NULL, 'synphilin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(132729, NULL, 'G3DSA:3.40.50.10490:FF:000074', NULL, NULL, 'RpiR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(132730, NULL, 'G3DSA:3.40.50.150:FF:001448', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132731, NULL, 'G3DSA:3.30.1330.30:FF:000119', NULL, NULL, '23S rRNA (guanosine-2''-O-)-methyltransferase RlmB', NULL, NULL, NULL, NULL, NULL, 4),
(132732, NULL, 'G3DSA:3.30.450.20:FF:000339', NULL, NULL, 'Methyl-accepting chemotaxis transmembrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(132733, NULL, 'G3DSA:3.30.9.10:FF:000076', NULL, NULL, 'FAD-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(132734, NULL, 'G3DSA:2.10.60.10:FF:000046', NULL, NULL, 'RIKEN cDNA 1810065E05 gene', NULL, NULL, NULL, NULL, NULL, 4),
(132735, NULL, 'G3DSA:1.25.10.10:FF:002991', NULL, NULL, 'AP-3 complex subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(132736, NULL, 'G3DSA:1.10.1520.10:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132737, NULL, 'G3DSA:2.130.10.10:FF:003191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132738, NULL, 'G3DSA:3.30.420.40:FF:001069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132739, NULL, 'G3DSA:2.60.120.970:FF:000093', NULL, NULL, 'AGAP000342-PA', NULL, NULL, NULL, NULL, NULL, 4),
(132740, NULL, 'G3DSA:1.10.8.60:FF:000121', NULL, NULL, 'DnaA regulatory inactivator Hda', NULL, NULL, NULL, NULL, NULL, 4),
(132741, NULL, 'G3DSA:2.40.128.20:FF:000019', NULL, NULL, 'LiPocalin-Related protein', NULL, NULL, NULL, NULL, NULL, 4),
(132742, NULL, 'G3DSA:3.30.70.330:FF:002672', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132743, NULL, 'G3DSA:2.130.10.10:FF:006006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132744, NULL, 'G3DSA:3.80.10.10:FF:000627', NULL, NULL, 'Probable leucine-rich repeat receptor-like protein kinase At2g33170', NULL, NULL, NULL, NULL, NULL, 4),
(132745, NULL, 'G3DSA:1.10.418.70:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132746, NULL, 'G3DSA:1.20.120.1770:FF:000018', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(132747, NULL, 'G3DSA:1.10.10.10:FF:000045', NULL, NULL, 'ROK family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(132748, NULL, 'G3DSA:1.10.506.10:FF:000063', NULL, NULL, 'Ras GTPase-activating protein gap-1', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(132749, NULL, 'G3DSA:3.40.50.150:FF:001487', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132750, NULL, 'G3DSA:4.10.240.10:FF:000063', NULL, NULL, 'AaceriADR404Cp', NULL, NULL, NULL, NULL, NULL, 4),
(132751, NULL, 'G3DSA:3.30.1370.210:FF:000009', NULL, NULL, 'Zinc finger CCCH domain-containing protein 66', NULL, NULL, NULL, NULL, NULL, 4),
(132752, NULL, 'G3DSA:1.25.40.10:FF:003049', NULL, NULL, 'YALI0C19426p', NULL, NULL, NULL, NULL, NULL, 4),
(132753, NULL, 'G3DSA:2.60.120.10:FF:000415', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132754, NULL, 'G3DSA:2.60.120.10:FF:000472', NULL, NULL, 'cAMP-dependent protein kinase type II-alpha regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(132755, NULL, 'G3DSA:3.30.450.20:FF:000396', NULL, NULL, 'PAS domain containing serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(132756, NULL, 'G3DSA:3.40.50.300:FF:005787', NULL, NULL, 'Os06g0120732 protein', NULL, NULL, NULL, NULL, NULL, 4),
(132757, NULL, 'G3DSA:3.40.50.620:FF:000712', NULL, NULL, 'Nicotinamide-nucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(132758, NULL, 'G3DSA:3.30.160.60:FF:003550', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132759, NULL, 'G3DSA:2.130.10.10:FF:001279', NULL, NULL, 'Protein HIRA', NULL, NULL, NULL, NULL, NULL, 4),
(132760, NULL, 'G3DSA:3.90.70.80:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132761, NULL, 'G3DSA:1.10.10.160:FF:000058', NULL, NULL, 'ADR113Wp', NULL, NULL, NULL, NULL, NULL, 4),
(132762, NULL, 'G3DSA:3.30.2290.10:FF:000020', NULL, NULL, 'Predicted Zn-dependent protease', NULL, NULL, NULL, NULL, NULL, 4),
(132763, NULL, 'G3DSA:3.40.50.360:FF:000145', NULL, NULL, 'Ribosyldihydronicotinamide dehydrogenase [quinone]', NULL, NULL, NULL, NULL, NULL, 4),
(132764, NULL, 'G3DSA:3.30.160.60:FF:003836', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132765, NULL, 'G3DSA:3.30.70.330:FF:001654', NULL, NULL, 'YALI0B00616p', NULL, NULL, NULL, NULL, NULL, 4),
(132766, NULL, 'G3DSA:1.10.8.430:FF:000012', NULL, NULL, 'Disease resistance protein RGA5', NULL, NULL, NULL, NULL, NULL, 4),
(132767, NULL, 'G3DSA:3.40.50.10320:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132768, NULL, 'G3DSA:2.30.29.30:FF:001361', NULL, NULL, 'Myosin-M heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(132769, NULL, 'G3DSA:1.10.10.10:FF:001063', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(132770, NULL, 'G3DSA:3.30.40.10:FF:000946', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(132771, NULL, 'G3DSA:1.20.920.10:FF:000219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132772, NULL, 'G3DSA:3.40.50.620:FF:000656', NULL, NULL, 'Asparagine synthetase domain-containing protein C4F6.11c', NULL, NULL, NULL, NULL, NULL, 4),
(132773, NULL, 'G3DSA:3.40.1380.20:FF:000050', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(132774, NULL, 'G3DSA:3.40.50.10330:FF:000015', NULL, NULL, 'acylglycerol kinase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(132775, NULL, 'G3DSA:1.10.510.10:FF:003951', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132776, NULL, 'G3DSA:1.10.10.10:FF:001349', NULL, NULL, 'Transcriptional regulator, Crp/Fnr family', NULL, NULL, NULL, NULL, NULL, 4),
(132777, NULL, 'G3DSA:2.60.120.290:FF:000097', NULL, NULL, 'SOL-1 related protein', NULL, NULL, NULL, NULL, NULL, 4),
(132778, NULL, 'G3DSA:3.40.50.300:FF:007822', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(132779, NULL, 'G3DSA:1.10.10.10:FF:000787', NULL, NULL, 'Methylated-DNA--protein-cysteine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(132780, NULL, 'G3DSA:3.40.50.300:FF:003371', NULL, NULL, 'Related to ATP-binding multidrug cassette transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(132781, NULL, 'G3DSA:3.30.1120.10:FF:000013', NULL, NULL, 'Arylsulfatase A', NULL, NULL, NULL, NULL, NULL, 4),
(132782, NULL, 'G3DSA:1.50.10.20:FF:000108', NULL, NULL, 'CAAX farnesyl transferase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(132783, NULL, 'G3DSA:2.60.40.10:FF:005298', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132784, NULL, 'G3DSA:3.90.550.50:FF:000022', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(132785, NULL, 'G3DSA:1.20.1250.10:FF:000061', NULL, NULL, 'Prolactin-2B1', NULL, NULL, NULL, NULL, NULL, 4),
(132786, NULL, 'G3DSA:3.20.20.80:FF:000269', NULL, NULL, 'Probable glucan endo-1,6-beta-glucosidase B', NULL, NULL, NULL, NULL, NULL, 4),
(132787, NULL, 'G3DSA:3.20.20.70:FF:000446', NULL, NULL, 'Heme chaperone HemW', NULL, NULL, NULL, NULL, NULL, 4),
(132788, NULL, 'G3DSA:3.80.10.10:FF:001302', NULL, NULL, 'Tonsoku-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(132789, NULL, 'G3DSA:3.60.10.10:FF:000235', NULL, NULL, 'Putative transcriptional effector ccr4-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(132790, NULL, 'G3DSA:3.40.50.720:FF:002485', NULL, NULL, 'SUMO-activating enzyme subunit', NULL, NULL, NULL, NULL, NULL, 4),
(132791, NULL, 'G3DSA:1.20.1070.10:FF:000075', NULL, NULL, 'orexin receptor type 2', NULL, NULL, NULL, NULL, NULL, 4),
(132792, NULL, 'G3DSA:3.30.9.10:FF:000132', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(132793, NULL, 'G3DSA:1.10.1520.10:FF:000056', NULL, NULL, 'Putative RNase III', NULL, NULL, NULL, NULL, NULL, 4),
(132794, NULL, 'G3DSA:3.40.1310.20:FF:000006', NULL, NULL, 'Initiator protein NS1', NULL, NULL, NULL, NULL, NULL, 4),
(132795, NULL, 'G3DSA:3.40.390.10:FF:000189', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132796, NULL, 'G3DSA:1.20.1270.330:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132797, NULL, 'G3DSA:3.40.850.10:FF:000269', NULL, NULL, 'Kinesin family member 13A', NULL, NULL, NULL, NULL, NULL, 4),
(132798, NULL, 'G3DSA:3.20.20.80:FF:000449', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132799, NULL, 'G3DSA:2.130.10.10:FF:002696', NULL, NULL, 'Epg-6', NULL, NULL, NULL, NULL, NULL, 4),
(132800, NULL, 'G3DSA:3.30.40.10:FF:001441', NULL, NULL, 'RNA binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(132801, NULL, 'G3DSA:3.40.50.10190:FF:000102', NULL, NULL, 'Rad9p', NULL, NULL, NULL, NULL, NULL, 4),
(132802, NULL, 'G3DSA:3.30.750.44:FF:000013', NULL, NULL, 'Carboxyl-terminal protease', NULL, NULL, NULL, NULL, NULL, 4),
(132803, NULL, 'G3DSA:3.30.70.3020:FF:000001', NULL, NULL, 'U3 small nucleolar RNA-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(132804, NULL, 'G3DSA:1.20.58.60:FF:000754', NULL, NULL, 'Si:ch211-165e15.1', NULL, NULL, NULL, NULL, NULL, 4),
(132805, NULL, 'G3DSA:3.30.930.10:FF:000362', NULL, NULL, 'Phenylalanyl-tRNA synthetase alpha chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132806, NULL, 'G3DSA:1.20.1170.10:FF:000003', NULL, NULL, 'E3 ubiquitin protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(132807, NULL, 'G3DSA:1.20.245.10:FF:000004', NULL, NULL, 'Linolenate 9R-lipoxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(132808, NULL, 'G3DSA:1.10.510.10:FF:003771', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132809, NULL, 'G3DSA:3.30.420.10:FF:000508', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132810, NULL, 'G3DSA:2.170.150.80:FF:000024', NULL, NULL, 'At1g64105', NULL, NULL, NULL, NULL, NULL, 4),
(132811, NULL, 'G3DSA:3.40.50.300:FF:007642', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132812, NULL, 'G3DSA:3.90.1290.10:FF:000040', NULL, NULL, 'VAB-10A protein', NULL, NULL, NULL, NULL, NULL, 4),
(132813, NULL, 'G3DSA:2.130.10.10:FF:003713', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132814, NULL, 'G3DSA:1.10.287.410:FF:000004', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(132815, NULL, 'G3DSA:3.30.70.1230:FF:000166', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(132816, NULL, 'G3DSA:1.20.5.170:FF:000044', NULL, NULL, 'cAMP-responsive element-binding protein-like 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(132817, NULL, 'G3DSA:3.60.21.10:FF:000030', NULL, NULL, 'Trifunctional nucleotide phosphoesterase protein YfkN', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(132818, NULL, 'G3DSA:3.40.50.12760:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132819, NULL, 'G3DSA:4.10.280.50:FF:000004', NULL, NULL, 'Glutamate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(132820, NULL, 'G3DSA:2.30.110.10:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132821, NULL, 'G3DSA:1.20.1070.10:FF:000693', NULL, NULL, '5-hydroxytryptamine receptor 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(132822, NULL, 'G3DSA:1.10.3450.40:FF:000008', NULL, NULL, 'Signal recognition particle 68 kDa protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132823, NULL, 'G3DSA:2.40.50.1070:FF:000015', NULL, NULL, 'tRNA (Uracil-5-)-methyltransferase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(132824, NULL, 'G3DSA:1.10.10.60:FF:001268', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132825, NULL, 'G3DSA:1.10.8.10:FF:000297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132826, NULL, 'G3DSA:3.90.640.10:FF:000208', NULL, NULL, 'Actin-related protein 5-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(132827, NULL, 'G3DSA:3.40.50.150:FF:001268', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132828, NULL, 'G3DSA:3.30.710.10:FF:000380', NULL, NULL, 'LD01876p', NULL, NULL, NULL, NULL, NULL, 4),
(132829, NULL, 'G3DSA:3.30.70.330:FF:001093', NULL, NULL, 'THO complex subunit 4D', NULL, NULL, NULL, NULL, NULL, 4),
(132830, NULL, 'G3DSA:1.10.630.10:FF:000677', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132831, NULL, 'G3DSA:1.10.1370.40:FF:000002', NULL, NULL, 'Mitochondrial intermediate peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(132832, NULL, 'G3DSA:3.10.20.90:FF:000413', NULL, NULL, 'Ubiquitin_family_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(132833, NULL, 'G3DSA:1.10.287.400:FF:000001', NULL, NULL, 'Argininosuccinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(132834, NULL, 'G3DSA:2.60.40.420:FF:000088', NULL, NULL, 'Multicopper oxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132835, NULL, 'G3DSA:3.30.1120.10:FF:000070', NULL, NULL, 'N-acetylgalactosamine-6-sulfatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132836, NULL, 'G3DSA:2.40.50.1060:FF:000012', NULL, NULL, 'YALI0F06182p', NULL, NULL, NULL, NULL, NULL, 4),
(132837, NULL, 'G3DSA:3.30.160.60:FF:000402', NULL, NULL, 'IKAROS family zinc finger 5', NULL, NULL, NULL, NULL, NULL, 4),
(132838, NULL, 'G3DSA:3.30.70.100:FF:000203', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132839, NULL, 'G3DSA:3.30.70.330:FF:001036', NULL, NULL, 'Putative rna-binding protein fus', NULL, NULL, NULL, NULL, NULL, 4),
(132840, NULL, 'G3DSA:1.50.10.10:FF:000162', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(132841, NULL, 'G3DSA:1.10.10.10:FF:001681', NULL, NULL, 'Interferon regulatory factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(132842, NULL, 'G3DSA:3.40.50.12780:FF:000019', NULL, NULL, 'Long-chain fatty acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(132843, NULL, 'G3DSA:1.10.260.30:FF:000020', NULL, NULL, 'Signal recognition particle 54 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(132844, NULL, 'G3DSA:3.30.930.10:FF:000087', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(132845, NULL, 'G3DSA:1.50.10.10:FF:000105', NULL, NULL, 'Glycoside hydrolase family 95', NULL, NULL, NULL, NULL, NULL, 4),
(132846, NULL, 'G3DSA:1.25.40.20:FF:000331', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(132847, NULL, 'G3DSA:1.10.10.10:FF:001624', NULL, NULL, 'Transcription factor E', NULL, NULL, NULL, NULL, NULL, 4),
(132848, NULL, 'G3DSA:3.90.640.10:FF:000265', NULL, NULL, 'Heat shock protein, Hsp70 family', NULL, NULL, NULL, NULL, NULL, 4),
(132849, NULL, 'G3DSA:3.80.10.10:FF:000807', NULL, NULL, 'PRELP isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(132850, NULL, 'G3DSA:1.10.4160.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132851, NULL, 'G3DSA:2.40.50.140:FF:000645', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(132852, NULL, 'G3DSA:1.10.600.10:FF:000069', NULL, NULL, 'Farnesyl diphosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(132853, NULL, 'G3DSA:3.90.850.10:FF:000022', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(132854, NULL, 'G3DSA:3.40.630.30:FF:000444', NULL, NULL, 'Nat4p', NULL, NULL, NULL, NULL, NULL, 4),
(132855, NULL, 'G3DSA:2.60.40.1930:FF:000010', NULL, NULL, 'C3 and PZP like, alpha-2-macroglobulin domain containing 8', NULL, NULL, NULL, NULL, NULL, 4),
(132856, NULL, 'G3DSA:3.40.1440.10:FF:000007', NULL, NULL, 'I-TevI homing endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(132857, NULL, 'G3DSA:3.40.50.1240:FF:000200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132858, NULL, 'G3DSA:2.130.10.10:FF:003314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132859, NULL, 'G3DSA:3.40.50.1110:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132860, NULL, 'G3DSA:3.10.490.20:FF:000037', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(132861, NULL, 'G3DSA:2.60.40.10:FF:001863', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(132862, NULL, 'G3DSA:3.10.200.10:FF:000008', NULL, NULL, 'Carbonic anhydrase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132863, NULL, 'G3DSA:3.40.50.1820:FF:000745', NULL, NULL, 'Serine protease K12H4.7-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(132864, NULL, 'G3DSA:2.20.110.10:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132865, NULL, 'G3DSA:3.40.50.1010:FF:000148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132866, NULL, 'G3DSA:3.30.1120.30:FF:000019', NULL, NULL, 'PLK/PLK1 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(132867, NULL, 'G3DSA:3.60.110.10:FF:000097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132868, NULL, 'G3DSA:3.40.50.300:FF:007081', NULL, NULL, 'Ras-related protein RabU', NULL, NULL, NULL, NULL, NULL, 4),
(132869, NULL, 'G3DSA:3.30.160.60:FF:004112', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132870, NULL, 'G3DSA:3.30.230.10:FF:000354', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132871, NULL, 'G3DSA:1.20.120.1240:FF:000028', NULL, NULL, 'Dynamin 1', NULL, NULL, NULL, NULL, NULL, 4),
(132872, NULL, 'G3DSA:1.10.10.1410:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132873, NULL, 'G3DSA:3.10.20.90:FF:000306', NULL, NULL, 'Putative ubiquitin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(132874, NULL, 'G3DSA:1.20.1560.10:FF:000893', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132875, NULL, 'G3DSA:1.20.1250.20:FF:000614', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(132876, NULL, 'G3DSA:3.30.70.330:FF:001452', NULL, NULL, 'RNA Binding Motif protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(132877, NULL, 'G3DSA:3.65.10.20:FF:000008', NULL, NULL, 'RNA 3''-terminal phosphate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(132878, NULL, 'G3DSA:3.40.50.300:FF:005809', NULL, NULL, 'Bifunctional dethiobiotin synthetase/adenosylmethionine-8-amino-7-oxononanoate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(132879, NULL, 'G3DSA:3.65.10.10:FF:000005', NULL, NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(132880, NULL, 'G3DSA:1.10.10.1420:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132881, NULL, 'G3DSA:1.10.10.2670:FF:000013', NULL, NULL, 'ATP-dependent Clp protease adaptor protein ClpS', NULL, NULL, NULL, NULL, NULL, 4),
(132882, NULL, 'G3DSA:3.40.50.720:FF:000484', NULL, NULL, 'Pentafunctional AROM polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(132883, NULL, 'G3DSA:1.10.8.480:FF:000004', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(132884, NULL, 'G3DSA:3.40.20.10:FF:000068', NULL, NULL, 'TWF1p Twinfilin', NULL, NULL, NULL, NULL, NULL, 4),
(132885, NULL, 'G3DSA:1.50.40.10:FF:000231', NULL, NULL, 'Mitochondrial RNA-splicing protein MRS3', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(132886, NULL, 'G3DSA:3.30.160.60:FF:005882', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132887, NULL, 'G3DSA:3.10.580.10:FF:000204', NULL, NULL, 'Hemolysin', NULL, NULL, NULL, NULL, NULL, 4),
(132888, NULL, 'G3DSA:3.40.630.30:FF:000337', NULL, NULL, 'L-2,4-diaminobutyric acid acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(132889, NULL, 'G3DSA:1.20.900.10:FF:000078', NULL, NULL, 'Guanine nucleotide exchange factor UNC-73B', NULL, NULL, NULL, NULL, NULL, 4),
(132890, NULL, 'G3DSA:2.30.29.30:FF:000883', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132891, NULL, 'G3DSA:2.60.120.1000:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(132892, NULL, 'G3DSA:3.30.9.10:FF:000104', NULL, NULL, 'Putative transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(132893, NULL, 'G3DSA:3.40.850.10:FF:000488', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(132894, NULL, 'G3DSA:1.20.120.1530:FF:000008', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(132895, NULL, 'G3DSA:1.10.10.1100:FF:000020', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(132896, NULL, 'G3DSA:1.10.150.50:FF:000012', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(132897, NULL, 'G3DSA:1.10.10.2660:FF:000010', NULL, NULL, 'SUMO-activating enzyme subunit', NULL, NULL, NULL, NULL, NULL, 4),
(132898, NULL, 'G3DSA:2.130.10.10:FF:004320', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132899, NULL, 'G3DSA:3.40.50.300:FF:007373', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132900, NULL, 'G3DSA:2.10.25.10:FF:000167', NULL, NULL, 'neurexin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(132901, NULL, 'G3DSA:3.30.200.20:FF:001215', NULL, NULL, 'Cyclin dependent kinase like 2', NULL, NULL, NULL, NULL, NULL, 4),
(132902, NULL, 'G3DSA:1.10.1660.20:FF:000001', NULL, NULL, 'Excisionase', NULL, NULL, NULL, NULL, NULL, 4),
(132903, NULL, 'G3DSA:3.30.9.10:FF:000093', NULL, NULL, 'FAD monooxygenase, PheA/TfdB family', NULL, NULL, NULL, NULL, NULL, 4),
(132904, NULL, 'G3DSA:1.25.40.10:FF:000795', NULL, NULL, 'Tetratricopeptide repeat protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(132905, NULL, 'G3DSA:3.30.1150.10:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132906, NULL, 'G3DSA:3.90.640.10:FF:000293', NULL, NULL, 'Heat shock protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132907, NULL, 'G3DSA:2.60.120.620:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132908, NULL, 'G3DSA:2.130.10.10:FF:001723', NULL, NULL, 'Dynein intermediate chain 3, ciliary', NULL, NULL, NULL, NULL, NULL, 4),
(132909, NULL, 'G3DSA:3.40.50.2000:FF:000939', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(132910, NULL, 'G3DSA:3.30.40.10:FF:000429', NULL, NULL, 'E3 ubiquitin-protein ligase RNF13', NULL, NULL, NULL, NULL, NULL, 4),
(132911, NULL, 'G3DSA:4.10.1240.10:FF:000054', NULL, NULL, 'Adenylate cyclase-activating polypeptide 1 (pituitary) receptor type I', NULL, NULL, NULL, NULL, NULL, 4),
(132912, NULL, 'G3DSA:3.60.40.10:FF:000158', NULL, NULL, 'Protein phosphatase, Mg2+/Mn2+ dependent, 1D', NULL, NULL, NULL, NULL, NULL, 4),
(132913, NULL, 'G3DSA:3.30.450.20:FF:000418', NULL, NULL, 'Sensory box sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(132914, NULL, 'G3DSA:1.20.1250.20:FF:001120', NULL, NULL, 'MFS multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132915, NULL, 'G3DSA:3.30.70.330:FF:000946', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(132916, NULL, 'G3DSA:2.130.10.10:FF:005422', NULL, NULL, 'ADR293Cp', NULL, NULL, NULL, NULL, NULL, 4),
(132917, NULL, 'G3DSA:2.30.29.30:FF:001400', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132918, NULL, 'G3DSA:2.60.120.200:FF:000290', NULL, NULL, 'CNE1p Calnexin', NULL, NULL, NULL, NULL, NULL, 4),
(132919, NULL, 'G3DSA:3.80.10.10:FF:000493', NULL, NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At5g63710', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(132920, NULL, 'G3DSA:1.10.630.10:FF:000722', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132921, NULL, 'G3DSA:1.25.40.10:FF:003066', NULL, NULL, 'YALI0B00528p', NULL, NULL, NULL, NULL, NULL, 4),
(132922, NULL, 'G3DSA:2.70.130.10:FF:000043', NULL, NULL, 'Insulin like growth factor 2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(132923, NULL, 'G3DSA:2.10.220.10:FF:000103', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(132924, NULL, 'G3DSA:1.10.510.10:FF:001068', NULL, NULL, 'G2-specific protein kinase nimA', NULL, NULL, NULL, NULL, NULL, 4),
(132925, NULL, 'G3DSA:3.40.1110.10:FF:000117', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(132926, NULL, 'G3DSA:1.10.8.470:FF:000001', NULL, NULL, 'GTP-binding protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(132927, NULL, 'G3DSA:3.20.80.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132928, NULL, 'G3DSA:2.60.40.1180:FF:000043', NULL, NULL, 'Isoamylase 3, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(132929, NULL, 'G3DSA:1.25.10.10:FF:000967', NULL, NULL, 'Armadillo/beta-catenin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(132930, NULL, 'G3DSA:3.40.50.720:FF:001001', NULL, NULL, 'NADP-dependent 3-hydroxy acid dehydrogenase YdfG', NULL, NULL, NULL, NULL, NULL, 4),
(132931, NULL, 'G3DSA:3.50.50.60:FF:000938', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(132932, NULL, 'G3DSA:1.10.1370.10:FF:000038', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(132933, NULL, 'G3DSA:3.20.20.140:FF:000437', NULL, NULL, 'Non-ATP-dependent L-selective hydantoinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132934, NULL, 'G3DSA:3.30.160.60:FF:001178', NULL, NULL, 'zinc finger protein 287', NULL, NULL, NULL, NULL, NULL, 4),
(132935, NULL, 'G3DSA:3.10.310.40:FF:000008', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(132936, NULL, 'G3DSA:1.10.275.60:FF:000001', NULL, NULL, 'Adenylosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(132937, NULL, 'G3DSA:1.20.1420.30:FF:000097', NULL, NULL, 'Potassium-dependent sodium-calcium exchanger, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132938, NULL, 'G3DSA:3.30.40.10:FF:000755', NULL, NULL, 'RING-H2 finger protein ATL57', NULL, NULL, NULL, NULL, NULL, 4),
(132939, NULL, 'G3DSA:3.40.50.2000:FF:001075', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(132940, NULL, 'G3DSA:3.40.50.800:FF:000047', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(132941, NULL, 'G3DSA:2.60.120.520:FF:000003', NULL, NULL, '4-deoxy-L-threo-5-hexosulose-uronate ketol-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(132942, NULL, 'G3DSA:1.10.565.10:FF:000036', NULL, NULL, 'Nuclear hormone receptor FTZ-F1 beta', NULL, NULL, NULL, NULL, NULL, 4),
(132943, NULL, 'G3DSA:3.80.10.10:FF:003090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132944, NULL, 'G3DSA:1.10.10.10:FF:001793', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(132945, NULL, 'G3DSA:3.40.50.12780:FF:000238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132946, NULL, 'G3DSA:2.60.120.920:FF:000033', NULL, NULL, 'Si:dkeyp-100h4.1', NULL, NULL, NULL, NULL, NULL, 4),
(132947, NULL, 'G3DSA:1.10.510.10:FF:001394', NULL, NULL, 'Calmodulin-binding receptor kinase CaMRLK', NULL, NULL, NULL, NULL, NULL, 4),
(132948, NULL, 'G3DSA:1.20.1730.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132949, NULL, 'G3DSA:1.20.1280.50:FF:000164', NULL, NULL, 'uncharacterized protein LOC106571384 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(132950, NULL, 'G3DSA:3.40.720.10:FF:000260', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(132951, NULL, 'G3DSA:1.10.10.10:FF:001804', NULL, NULL, 'Transcriptional regulator (IclR family)', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(132952, NULL, 'G3DSA:3.40.50.300:FF:003039', NULL, NULL, 'Nicotinamide-nucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(132953, NULL, 'G3DSA:2.60.40.10:FF:001392', NULL, NULL, 'Interleukin 23 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(132954, NULL, 'G3DSA:2.30.30.570:FF:000002', NULL, NULL, 'Major vault protein-alpha', NULL, NULL, NULL, NULL, NULL, 4),
(132955, NULL, 'G3DSA:1.20.58.1120:FF:000035', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132956, NULL, 'G3DSA:3.30.930.10:FF:000025', NULL, NULL, 'Aspartate--ammonia ligase', NULL, NULL, NULL, NULL, NULL, 4),
(132957, NULL, 'G3DSA:3.50.50.60:FF:001444', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(132958, NULL, 'G3DSA:1.10.555.10:FF:000064', NULL, NULL, 'Rho GTPase activating protein at 15B, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(132959, NULL, 'G3DSA:3.30.160.60:FF:003639', NULL, NULL, 'C2H2 and C2HC zinc fingers superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(132960, NULL, 'G3DSA:1.20.1050.10:FF:000293', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132961, NULL, 'G3DSA:1.10.472.10:FF:000669', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132962, NULL, 'G3DSA:3.40.50.300:FF:007417', NULL, NULL, 'p-glycoprotein/multidrug resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(132963, NULL, 'G3DSA:2.60.40.10:FF:005770', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132964, NULL, 'G3DSA:2.170.180.11:FF:000001', NULL, NULL, 'G-protein coupled receptor Mth', NULL, NULL, NULL, NULL, NULL, 4),
(132965, NULL, 'G3DSA:3.40.50.410:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132966, NULL, 'G3DSA:1.10.472.80:FF:000280', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132967, NULL, 'G3DSA:1.25.10.10:FF:003238', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(132968, NULL, 'G3DSA:2.10.90.10:FF:000126', NULL, NULL, 'Growth/differentiation factor 8', NULL, NULL, NULL, NULL, NULL, 4),
(132969, NULL, 'G3DSA:3.30.420.10:FF:000576', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(132970, NULL, 'G3DSA:2.140.10.30:FF:000003', NULL, NULL, 'Probable dipeptidyl peptidase 4', NULL, NULL, NULL, NULL, NULL, 4),
(132971, NULL, 'G3DSA:3.90.70.10:FF:000035', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 3', NULL, NULL, NULL, NULL, NULL, 4),
(132972, NULL, 'G3DSA:3.30.160.60:FF:001824', NULL, NULL, 'zinc finger protein 628', NULL, NULL, NULL, NULL, NULL, 4),
(132973, NULL, 'G3DSA:3.40.50.360:FF:000033', NULL, NULL, 'Nitric oxide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(132974, NULL, 'G3DSA:3.80.10.10:FF:002937', NULL, NULL, 'CLL4A clavata1-like receptor S/T protein kinase protein', NULL, NULL, NULL, NULL, NULL, 4),
(132975, NULL, 'G3DSA:2.30.30.1020:FF:000002', NULL, NULL, 'CCR4-NOT transcription complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(132976, NULL, 'G3DSA:3.60.21.60:FF:000011', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(132977, NULL, 'G3DSA:1.20.1250.20:FF:000940', NULL, NULL, 'MFS sugar transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132978, NULL, 'G3DSA:3.40.50.300:FF:002246', NULL, NULL, 'DEAD box helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(132979, NULL, 'G3DSA:3.80.10.10:FF:001010', NULL, NULL, 'S-phase kinase-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(132980, NULL, 'G3DSA:3.40.50.1820:FF:000661', NULL, NULL, 'Putative phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(132981, NULL, 'G3DSA:3.40.50.10130:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132982, NULL, 'G3DSA:2.130.10.10:FF:002988', NULL, NULL, 'WD40-repeat-containing domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(132983, NULL, 'G3DSA:3.30.200.20:FF:001541', NULL, NULL, 'Nonspecific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(132984, NULL, 'G3DSA:1.20.58.60:FF:000557', NULL, NULL, 'Spectrin beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(132985, NULL, 'G3DSA:3.30.465.10:FF:000039', NULL, NULL, 'CBS domain membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(132986, NULL, 'G3DSA:2.120.10.30:FF:000398', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132987, NULL, 'G3DSA:3.60.150.10:FF:000009', NULL, NULL, 'Chorismate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(132988, NULL, 'G3DSA:3.40.50.200:FF:000125', NULL, NULL, 'Os01g0795400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(132989, NULL, 'G3DSA:1.20.970.10:FF:000026', NULL, NULL, 'Anthranilate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(132990, NULL, 'G3DSA:2.170.16.10:FF:000026', NULL, NULL, 'MCM / cell division control protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(132991, NULL, 'G3DSA:1.20.1560.10:FF:000258', NULL, NULL, 'Putative abc a-pheromone efflux pump protein', NULL, NULL, NULL, NULL, NULL, 4),
(132992, NULL, 'G3DSA:3.40.50.10140:FF:000059', NULL, NULL, 'Disease resistance protein (TIR-NBS class)', NULL, NULL, NULL, NULL, NULL, 4),
(132993, NULL, 'G3DSA:3.30.200.20:FF:002030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132994, NULL, 'G3DSA:3.40.50.300:FF:007743', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132995, NULL, 'G3DSA:3.50.30.30:FF:000057', NULL, NULL, 'Protein CBG07640', NULL, NULL, NULL, NULL, NULL, 4),
(132996, NULL, 'G3DSA:3.40.250.10:FF:000252', NULL, NULL, 'Tyrosine-protein phosphatase 2', NULL, NULL, NULL, NULL, NULL, 4),
(132997, NULL, 'G3DSA:1.10.3730.20:FF:000030', NULL, NULL, 'Putative multidrug transporter EmrE', NULL, NULL, NULL, NULL, NULL, 4),
(132998, NULL, 'G3DSA:3.50.50.60:FF:001091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(132999, NULL, 'G3DSA:3.40.50.720:FF:001310', NULL, NULL, 'Trk system potassium uptake protein trkA', NULL, NULL, NULL, NULL, NULL, 4),
(133000, NULL, 'G3DSA:1.20.58.60:FF:000866', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133001, NULL, 'G3DSA:1.20.1560.10:FF:000567', NULL, NULL, 'Protein CBR-HMT-1', NULL, NULL, NULL, NULL, NULL, 4),
(133002, NULL, 'G3DSA:3.10.170.20:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133003, NULL, 'G3DSA:3.80.10.10:FF:004192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133004, NULL, 'G3DSA:3.40.50.1820:FF:000970', NULL, NULL, 'Chlorophyllase I', NULL, NULL, NULL, NULL, NULL, 4),
(133005, NULL, 'G3DSA:3.40.50.1010:FF:000261', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133006, NULL, 'G3DSA:2.30.29.30:FF:000557', NULL, NULL, 'FERM domain (Protein4.1-ezrin-radixin-moesin) family', NULL, NULL, NULL, NULL, NULL, 4),
(133007, NULL, 'G3DSA:3.40.50.300:FF:004500', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(133008, NULL, 'G3DSA:3.40.630.30:FF:000028', NULL, NULL, 'N-alpha-acetyltransferase 60 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(133009, NULL, 'G3DSA:3.20.20.80:FF:000590', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133010, NULL, 'G3DSA:3.30.930.10:FF:000351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133011, NULL, 'G3DSA:2.60.120.10:FF:000253', NULL, NULL, 'Cyclic nucleotide-gated potassium channel', NULL, NULL, NULL, NULL, NULL, 4),
(133012, NULL, 'G3DSA:2.60.120.10:FF:000623', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133013, NULL, 'G3DSA:3.80.10.10:FF:000167', NULL, NULL, 'epiphycan', NULL, NULL, NULL, NULL, NULL, 4),
(133014, NULL, 'G3DSA:2.30.110.10:FF:000040', NULL, NULL, 'Deazaflavin-dependent nitroreductase', NULL, NULL, NULL, NULL, NULL, 4),
(133015, NULL, 'G3DSA:3.20.20.80:FF:000808', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133016, NULL, 'G3DSA:4.10.280.10:FF:000239', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133017, NULL, 'G3DSA:2.130.10.10:FF:005629', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133018, NULL, 'G3DSA:3.60.20.40:FF:000008', NULL, NULL, 'Gamma-glutamyltranspeptidase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(133019, NULL, 'G3DSA:3.40.630.20:FF:000025', NULL, NULL, 'Pyroglutamyl-peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(133020, NULL, 'G3DSA:3.30.160.60:FF:003965', NULL, NULL, 'Hermaphrodite, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(133021, NULL, 'G3DSA:2.130.10.10:FF:001386', NULL, NULL, 'U3 small nucleolar RNA-associated protein 12,putative', NULL, NULL, NULL, NULL, NULL, 4),
(133022, NULL, 'G3DSA:2.60.40.10:FF:001419', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(133023, NULL, 'G3DSA:1.10.510.10:FF:002220', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(133024, NULL, 'G3DSA:1.10.1200.10:FF:000043', NULL, NULL, 'Polyketide synthase Pks13', NULL, NULL, NULL, NULL, NULL, 4),
(133025, NULL, 'G3DSA:3.30.70.330:FF:001143', NULL, NULL, 'la protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(133026, NULL, 'G3DSA:2.60.120.330:FF:000070', NULL, NULL, '2-oxoglutarate (2OG) and Fe(II)-dependent oxygenase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(133027, NULL, 'G3DSA:1.10.8.10:FF:000319', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(133028, NULL, 'G3DSA:3.20.20.70:FF:000805', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133029, NULL, 'G3DSA:1.10.8.60:FF:000183', NULL, NULL, 'Replication factor C, subunit 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(133030, NULL, 'G3DSA:1.10.10.250:FF:000006', NULL, NULL, '50S ribosomal protein L11', NULL, NULL, NULL, NULL, NULL, 4),
(133031, NULL, 'G3DSA:2.60.40.10:FF:005444', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133032, NULL, 'G3DSA:3.90.1750.10:FF:000070', NULL, NULL, 'Hect domain and RLD 3', NULL, NULL, NULL, NULL, NULL, 4),
(133033, NULL, 'G3DSA:1.50.10.10:FF:000083', NULL, NULL, 'Non-lysosomal glucosylceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(133034, NULL, 'G3DSA:2.120.10.30:FF:000122', NULL, NULL, 'Signal peptide protein', NULL, NULL, NULL, NULL, NULL, 4),
(133035, NULL, 'G3DSA:3.40.710.10:FF:000169', NULL, NULL, 'Cell division protein FtsI [Peptidoglycan synthetase]', NULL, NULL, NULL, NULL, NULL, 4),
(133036, NULL, 'G3DSA:3.40.50.300:FF:001757', NULL, NULL, 'Adenylate kinase 9', NULL, NULL, NULL, NULL, NULL, 4),
(133037, NULL, 'G3DSA:1.10.10.350:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133038, NULL, 'G3DSA:3.90.830.10:FF:000004', NULL, NULL, 'vacuolar protein sorting-associated protein 33B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(133039, NULL, 'G3DSA:2.70.160.11:FF:000097', NULL, NULL, 'TPR domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(133040, NULL, 'G3DSA:3.90.190.10:FF:000185', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133041, NULL, 'G3DSA:3.20.20.10:FF:000041', NULL, NULL, 'Predicted amino acid aldolase or racemase', NULL, NULL, NULL, NULL, NULL, 4),
(133042, NULL, 'G3DSA:3.10.580.10:FF:000160', NULL, NULL, 'AMP-activated protein kinase, gamma regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(133043, NULL, 'G3DSA:3.40.50.10190:FF:000293', NULL, NULL, 'Probable DNA polymerase III polC-type', NULL, NULL, NULL, NULL, NULL, 4),
(133044, NULL, 'G3DSA:3.80.10.10:FF:002628', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133045, NULL, 'G3DSA:1.50.10.20:FF:000086', NULL, NULL, 'Ubiquitin domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(133046, NULL, 'G3DSA:3.40.190.80:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133047, NULL, 'G3DSA:3.40.33.10:FF:000182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133048, NULL, 'G3DSA:2.60.40.10:FF:003499', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133049, NULL, 'G3DSA:3.30.420.10:FF:000267', NULL, NULL, 'Putative ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(133050, NULL, 'G3DSA:3.30.70.1230:FF:000059', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(133051, NULL, 'G3DSA:1.25.10.20:FF:000015', NULL, NULL, 'Putative vitellogenin 2', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(133052, NULL, 'G3DSA:1.10.560.10:FF:000014', NULL, NULL, '60 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(133053, NULL, 'G3DSA:2.40.50.100:FF:000150', NULL, NULL, 'Acetyl-CoA carboxylase/pyruvate carboxylase fusion protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(133054, NULL, 'G3DSA:1.20.1250.40:FF:000024', NULL, NULL, 'DNA-directed RNA polymerases IV and V subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(133055, NULL, 'G3DSA:2.60.40.1770:FF:000006', NULL, NULL, 'Eph receptor A2 a', NULL, NULL, NULL, NULL, NULL, 4),
(133056, NULL, 'G3DSA:1.10.3370.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133057, NULL, 'G3DSA:1.10.630.10:FF:000385', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(133058, NULL, 'G3DSA:3.30.160.60:FF:000413', NULL, NULL, 'PR domain zinc finger protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(133059, NULL, 'G3DSA:1.10.150.650:FF:000015', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133060, NULL, 'G3DSA:3.80.10.10:FF:000846', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133061, NULL, 'G3DSA:2.130.10.10:FF:003168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133062, NULL, 'G3DSA:1.25.10.10:FF:000012', NULL, NULL, 'Dishevelled associated activator of morphogenesis 2', NULL, NULL, NULL, NULL, NULL, 4),
(133063, NULL, 'G3DSA:1.25.40.510:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133064, NULL, 'G3DSA:3.90.190.10:FF:000555', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133065, NULL, 'G3DSA:3.60.110.10:FF:000035', NULL, NULL, 'Glutamine-dependent NAD(+) synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(133066, NULL, 'G3DSA:3.40.1180.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133067, NULL, 'G3DSA:1.10.8.870:FF:000014', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(133068, NULL, 'G3DSA:3.50.50.60:FF:000955', NULL, NULL, 'FAD-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(133069, NULL, 'G3DSA:2.10.220.10:FF:000120', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(133070, NULL, 'G3DSA:3.30.450.40:FF:000300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133071, NULL, 'G3DSA:3.30.930.10:FF:000334', NULL, NULL, 'Seryl tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(133072, NULL, 'G3DSA:2.60.40.2840:FF:000013', NULL, NULL, 'Phosphatidylethanolamine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(133073, NULL, 'G3DSA:3.30.70.20:FF:000001', NULL, NULL, 'Photosystem I iron-sulfur center', NULL, NULL, NULL, NULL, NULL, 4),
(133074, NULL, 'G3DSA:3.40.50.300:FF:005591', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133075, NULL, 'G3DSA:1.20.5.170:FF:000151', NULL, NULL, 'Putative Cyclic AMP-dependent transcription factor ATF-3', NULL, NULL, NULL, NULL, NULL, 4),
(133076, NULL, 'G3DSA:1.20.120.1630:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133077, NULL, 'G3DSA:1.10.10.10:FF:002001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133078, NULL, 'G3DSA:2.40.100.10:FF:000121', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(133079, NULL, 'G3DSA:3.40.50.2000:FF:001092', NULL, NULL, 'UDP-glycosyltransferase 73D1', NULL, NULL, NULL, NULL, NULL, 4),
(133080, NULL, 'G3DSA:3.40.50.720:FF:001208', NULL, NULL, 'Short chain dehydrogenase/reductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(133081, NULL, 'G3DSA:3.30.40.10:FF:002346', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133082, NULL, 'G3DSA:3.30.460.90:FF:000001', NULL, NULL, 'protein mab-21-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(133083, NULL, 'G3DSA:3.40.1380.20:FF:000022', NULL, NULL, 'Pyruvate kinase PyKII', NULL, NULL, NULL, NULL, NULL, 4),
(133084, NULL, 'G3DSA:3.30.800.10:FF:000004', NULL, NULL, '1-phosphatidylinositol 3-phosphate 5-kinase isoform X1', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(133085, NULL, 'G3DSA:1.10.150.50:FF:000219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133086, NULL, 'G3DSA:1.10.540.10:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133087, NULL, 'G3DSA:3.80.10.10:FF:004219', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133088, NULL, 'G3DSA:2.60.40.10:FF:005461', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133089, NULL, 'G3DSA:1.10.8.60:FF:000536', NULL, NULL, 'ATP-dependent protease ClpE', NULL, NULL, NULL, NULL, NULL, 4),
(133090, NULL, 'G3DSA:3.30.2320.30:FF:000001', NULL, NULL, 'V-type proton atpase subunit e 1', NULL, NULL, NULL, NULL, NULL, 4),
(133091, NULL, 'G3DSA:1.10.1520.10:FF:000090', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133092, NULL, 'G3DSA:3.40.50.2300:FF:000569', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(133093, NULL, 'G3DSA:3.30.70.330:FF:002863', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133094, NULL, 'G3DSA:1.10.10.650:FF:000019', NULL, NULL, 'SUPT6H,-like protein to suppressor of ty 6', NULL, NULL, NULL, NULL, NULL, 4),
(133095, NULL, 'G3DSA:3.90.20.20:FF:000018', NULL, NULL, 'GrpE protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(133096, NULL, 'G3DSA:2.60.120.830:FF:000006', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(133097, NULL, 'G3DSA:3.30.70.260:FF:000138', NULL, NULL, 'Prephenate dehydratase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(133098, NULL, 'G3DSA:2.60.40.10:FF:003662', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133099, NULL, 'G3DSA:3.40.720.10:FF:000243', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133100, NULL, 'G3DSA:1.20.1070.10:FF:000176', NULL, NULL, 'N-arachidonyl glycine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(133101, NULL, 'G3DSA:1.20.1250.40:FF:000007', NULL, NULL, 'DNA-directed RNA polymerase II subunit RPB4', NULL, NULL, NULL, NULL, NULL, 4),
(133102, NULL, 'G3DSA:1.10.2000.10:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133103, NULL, 'G3DSA:3.30.160.60:FF:002004', NULL, NULL, 'Zinc finger protein 473', NULL, NULL, NULL, NULL, NULL, 4),
(133104, NULL, 'G3DSA:3.20.20.10:FF:000024', NULL, NULL, 'Pyridoxal phosphate homeostasis protein', NULL, NULL, NULL, NULL, NULL, 4),
(133105, NULL, 'G3DSA:3.30.40.10:FF:001244', NULL, NULL, 'Binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(133106, NULL, 'G3DSA:2.60.220.50:FF:000188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133107, NULL, 'G3DSA:2.60.120.820:FF:000003', NULL, NULL, 'E3 ubiquitin-protein ligase MYCBP2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(133108, NULL, 'G3DSA:1.10.3370.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133109, NULL, 'G3DSA:2.60.110.10:FF:000016', NULL, NULL, 'Os09g0498300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(133110, NULL, 'G3DSA:2.40.128.180:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133111, NULL, 'G3DSA:1.25.40.70:FF:000060', NULL, NULL, 'Phosphatidylinositol 4-kinase stt4', NULL, NULL, NULL, NULL, NULL, 4),
(133112, NULL, 'G3DSA:2.10.25.10:FF:000830', NULL, NULL, 'Protein eyes shut homolog', NULL, NULL, NULL, NULL, NULL, 4),
(133113, NULL, 'G3DSA:3.30.160.60:FF:003286', NULL, NULL, 'Paternally-expressed gene 3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(133114, NULL, 'G3DSA:1.10.287.70:FF:000582', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133115, NULL, 'G3DSA:1.10.472.10:FF:000686', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133116, NULL, 'G3DSA:2.130.10.10:FF:003505', NULL, NULL, 'AGAP000686-PA', NULL, NULL, NULL, NULL, NULL, 4),
(133117, NULL, 'G3DSA:3.30.2230.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133118, NULL, 'G3DSA:3.10.105.10:FF:000051', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(133119, NULL, 'G3DSA:3.40.20.10:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(133120, NULL, 'G3DSA:3.30.710.10:FF:000486', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133121, NULL, 'G3DSA:1.25.10.10:FF:003255', NULL, NULL, 'Protein CELLULOSE SYNTHASE INTERACTIVE 3', NULL, NULL, NULL, NULL, NULL, 4),
(133122, NULL, 'G3DSA:2.30.29.30:FF:000574', NULL, NULL, 'Rho1 guanine nucleotide exchange factor TUS1', NULL, NULL, NULL, NULL, NULL, 4),
(133123, NULL, 'G3DSA:1.20.120.1080:FF:000137', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133124, NULL, 'G3DSA:3.40.50.720:FF:000175', NULL, NULL, 'UDP-glucose 4-epimerase Gal10', NULL, NULL, NULL, NULL, NULL, 4),
(133125, NULL, 'G3DSA:2.60.40.10:FF:000301', NULL, NULL, 'Sidekick cell adhesion molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(133126, NULL, 'G3DSA:1.10.490.160:FF:000006', NULL, NULL, 'Protein CBR-LIPL-6', NULL, NULL, NULL, NULL, NULL, 4),
(133127, NULL, 'G3DSA:3.80.10.10:FF:002954', NULL, NULL, 'Disease resistance protein RPP13', NULL, NULL, NULL, NULL, NULL, 4),
(133128, NULL, 'G3DSA:1.25.40.10:FF:001519', NULL, NULL, 'Motility protein FimV', NULL, NULL, NULL, NULL, NULL, 4),
(133129, NULL, 'G3DSA:1.20.1160.20:FF:000023', NULL, NULL, 'Regulator of telomere elongation helicase 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(133130, NULL, 'G3DSA:2.10.25.10:FF:001010', NULL, NULL, 'Nimrod C3', NULL, NULL, NULL, NULL, NULL, 4),
(133131, NULL, 'G3DSA:3.40.50.300:FF:002600', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133132, NULL, 'G3DSA:1.10.10.10:FF:001484', NULL, NULL, 'Selenocysteine-specific translation elongation factor SelB', NULL, NULL, NULL, NULL, NULL, 4),
(133133, NULL, 'G3DSA:1.10.10.1100:FF:000003', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(133134, NULL, 'G3DSA:2.60.40.1090:FF:000016', NULL, NULL, 'Long polar fimbrial protein LpfE', NULL, NULL, NULL, NULL, NULL, 4),
(133135, NULL, 'G3DSA:1.10.10.10:FF:001821', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133136, NULL, 'G3DSA:1.25.40.10:FF:005218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133137, NULL, 'G3DSA:1.20.1250.20:FF:000923', NULL, NULL, 'Biotin transporter', NULL, NULL, NULL, NULL, NULL, 4),
(133138, NULL, 'G3DSA:1.20.1690.10:FF:000003', NULL, NULL, 'V-type proton ATPase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(133139, NULL, 'G3DSA:2.60.40.1080:FF:000013', NULL, NULL, 'Kappa-carrageenase', NULL, NULL, NULL, NULL, NULL, 4),
(133140, NULL, 'G3DSA:2.130.10.10:FF:003831', NULL, NULL, 'Protein HIR', NULL, NULL, NULL, NULL, NULL, 4),
(133141, NULL, 'G3DSA:2.10.25.10:FF:000184', NULL, NULL, 'nephronectin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(133142, NULL, 'G3DSA:1.10.10.10:FF:000202', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(133143, NULL, 'G3DSA:3.30.70.330:FF:003043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133144, NULL, 'G3DSA:3.40.50.1820:FF:000644', NULL, NULL, 'Acyl-protein thioesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(133145, NULL, 'G3DSA:3.20.20.20:FF:000027', NULL, NULL, 'Dihydropteroate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(133146, NULL, 'G3DSA:3.60.21.10:FF:000092', NULL, NULL, 'Sphingomyelin phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(133147, NULL, 'G3DSA:3.40.50.11350:FF:000012', NULL, NULL, 'Galactoside 2-alpha-L-fucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(133148, NULL, 'G3DSA:2.60.120.620:FF:000033', NULL, NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(133149, NULL, 'G3DSA:1.25.40.10:FF:003419', NULL, NULL, 'Pentatricopeptide repeat-containing protein DOT4, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(133150, NULL, 'G3DSA:2.60.120.290:FF:000243', NULL, NULL, 'Corticotropin-releasing factor-binding protein-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(133151, NULL, 'G3DSA:1.25.40.10:FF:000778', NULL, NULL, 'Protein SGT1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(133152, NULL, 'G3DSA:1.10.20.10:FF:000130', NULL, NULL, 'Nuclear transcription factor Y subunit B-4', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(133153, NULL, 'G3DSA:3.40.50.200:FF:000108', NULL, NULL, 'Clan SB, family S8, subtilisin-like serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(133154, NULL, 'G3DSA:3.50.50.60:FF:001135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133155, NULL, 'G3DSA:3.40.30.10:FF:000349', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(133156, NULL, 'G3DSA:3.40.1190.10:FF:000009', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(133157, NULL, 'G3DSA:3.30.160.60:FF:001487', NULL, NULL, 'zinc finger protein 527 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(133158, NULL, 'G3DSA:3.30.40.10:FF:000738', NULL, NULL, 'Lysine-specific demethylase rbr-2 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(133159, NULL, 'G3DSA:3.40.50.2000:FF:000956', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133160, NULL, 'G3DSA:3.90.550.10:FF:000038', NULL, NULL, 'protein O-linked-mannose beta-1,2-N-acetylglucosaminyltransferase 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(133161, NULL, 'G3DSA:1.20.1250.20:FF:001103', NULL, NULL, 'Os07g0190650 protein', NULL, NULL, NULL, NULL, NULL, 4),
(133162, NULL, 'G3DSA:3.20.20.220:FF:000017', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(133163, NULL, 'G3DSA:1.10.510.10:FF:003176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133164, NULL, 'G3DSA:3.40.50.2300:FF:001075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133165, NULL, 'G3DSA:3.30.160.60:FF:000059', NULL, NULL, 'U1 small nuclear ribonucleoprotein C', NULL, NULL, NULL, NULL, NULL, 4),
(133166, NULL, 'G3DSA:1.10.287.10:FF:000036', NULL, NULL, 'Fcp-1', NULL, NULL, NULL, NULL, NULL, 4),
(133167, NULL, 'G3DSA:2.10.25.10:FF:000493', NULL, NULL, 'von Willebrand factor', NULL, NULL, NULL, NULL, NULL, 4),
(133168, NULL, 'G3DSA:1.20.1540.10:FF:000049', NULL, NULL, 'Rhomboid family intramembrane serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(133169, NULL, 'G3DSA:3.30.160.60:FF:005186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133170, NULL, 'G3DSA:2.130.10.10:FF:004011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133171, NULL, 'G3DSA:3.30.200.20:FF:001232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133172, NULL, 'G3DSA:1.10.12.10:FF:000038', NULL, NULL, 'Putative enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(133173, NULL, 'G3DSA:1.25.10.10:FF:001456', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133174, NULL, 'G3DSA:1.10.287.110:FF:000330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133175, NULL, 'G3DSA:2.60.120.10:FF:000606', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(133176, NULL, 'G3DSA:3.20.20.80:FF:000573', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133177, NULL, 'G3DSA:2.60.40.150:FF:000107', NULL, NULL, 'Synaptotagmin-like 5, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(133178, NULL, 'G3DSA:3.80.10.10:FF:004545', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133179, NULL, 'G3DSA:3.30.160.60:FF:003948', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133180, NULL, 'G3DSA:1.10.10.10:FF:001467', NULL, NULL, 'Transcriptional regulator, AsnC family', NULL, NULL, NULL, NULL, NULL, 4),
(133181, NULL, 'G3DSA:2.170.270.10:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133182, NULL, 'G3DSA:3.20.20.70:FF:000570', NULL, NULL, 'Inosine-5''-monophosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(133183, NULL, 'G3DSA:2.60.120.10:FF:000270', NULL, NULL, 'Transcriptional regulator, HTH_3 family', NULL, NULL, NULL, NULL, NULL, 4),
(133184, NULL, 'G3DSA:3.60.20.40:FF:000025', NULL, NULL, 'Gamma-glutamyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(133185, NULL, 'G3DSA:1.50.40.10:FF:000601', NULL, NULL, 'Aspartate/glutamate carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(133186, NULL, 'G3DSA:3.40.630.20:FF:000008', NULL, NULL, 'Pyroglutamyl-peptidase 1', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(133187, NULL, 'G3DSA:3.50.50.60:FF:000629', NULL, NULL, 'Dihydrolipoyl dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(133188, NULL, 'G3DSA:3.40.630.10:FF:000005', NULL, NULL, 'Succinyl-diaminopimelate desuccinylase', NULL, NULL, NULL, NULL, NULL, 4),
(133189, NULL, 'G3DSA:1.10.1200.10:FF:000026', NULL, NULL, 'Nonribosomal peptide synthase Pes1', NULL, NULL, NULL, NULL, NULL, 4),
(133190, NULL, 'G3DSA:1.10.287.70:FF:000138', NULL, NULL, 'Two-pore potassium channel 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(133191, NULL, 'G3DSA:3.60.20.10:FF:000258', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133192, NULL, 'G3DSA:3.50.30.30:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133193, NULL, 'G3DSA:1.10.287.110:FF:000004', NULL, NULL, 'DnaJ (Hsp40) homolog, subfamily B, member 14', NULL, NULL, NULL, NULL, NULL, 4),
(133194, NULL, 'G3DSA:3.40.30.10:FF:000142', NULL, NULL, 'Elongation factor 1 gamma', NULL, NULL, NULL, NULL, NULL, 4),
(133195, NULL, 'G3DSA:3.40.50.300:FF:000122', NULL, NULL, 'Cytoplasmic dynein 1 heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(133196, NULL, 'G3DSA:3.40.50.300:FF:007389', NULL, NULL, 'Si:ch211-207c7.2', NULL, NULL, NULL, NULL, NULL, 4),
(133197, NULL, 'G3DSA:1.20.1270.10:FF:000039', NULL, NULL, 'Heat shock 70 kDa protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(133198, NULL, 'G3DSA:1.25.40.20:FF:000522', NULL, NULL, 'Ankyrin repeat domain-containing protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(133199, NULL, 'G3DSA:1.10.287.70:FF:000447', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133200, NULL, 'G3DSA:3.40.50.1100:FF:000214', NULL, NULL, 'Threonine synthase like 2', NULL, NULL, NULL, NULL, NULL, 4),
(133201, NULL, 'G3DSA:1.10.10.10:FF:000978', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(133202, NULL, 'G3DSA:1.25.70.10:FF:000021', NULL, NULL, 'PTAC15', NULL, NULL, NULL, NULL, NULL, 4),
(133203, NULL, 'G3DSA:3.30.499.10:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133204, NULL, 'G3DSA:1.10.510.10:FF:000303', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(133205, NULL, 'G3DSA:2.40.70.10:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133206, NULL, 'G3DSA:3.80.10.10:FF:002645', NULL, NULL, 'Receptor like protein 39', NULL, NULL, NULL, NULL, NULL, 4),
(133207, NULL, 'G3DSA:3.20.20.190:FF:000019', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(133208, NULL, 'G3DSA:1.20.58.100:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133209, NULL, 'G3DSA:1.10.510.10:FF:001747', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133210, NULL, 'G3DSA:2.60.120.230:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133211, NULL, 'G3DSA:3.20.20.70:FF:000261', NULL, NULL, 'L-lactate dehydrogenase (Cytochrome)', NULL, NULL, NULL, NULL, NULL, 4),
(133212, NULL, 'G3DSA:3.40.140.100:FF:000008', NULL, NULL, 'AuTophaGy (Yeast Atg homolog)', NULL, NULL, NULL, NULL, NULL, 4),
(133213, NULL, 'G3DSA:1.20.1110.10:FF:000101', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(133214, NULL, 'G3DSA:1.20.5.110:FF:000138', NULL, NULL, 'Structural maintenance of chromosomes', NULL, NULL, NULL, NULL, NULL, 4),
(133215, NULL, 'G3DSA:3.30.1600.10:FF:000005', NULL, NULL, 'NAD-dependent protein deacylase sirtuin-5, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(133216, NULL, 'G3DSA:2.60.120.1000:FF:000006', NULL, NULL, 'collagen alpha-1(XXVII) chain isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(133217, NULL, 'G3DSA:3.50.50.60:FF:001118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133218, NULL, 'G3DSA:3.40.50.1820:FF:000189', NULL, NULL, 'Esterase yjfP', NULL, NULL, NULL, NULL, NULL, 4),
(133219, NULL, 'G3DSA:1.10.10.750:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133220, NULL, 'G3DSA:1.10.555.10:FF:000047', NULL, NULL, 'rho GTPase-activating protein 190 isoform X3', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(133221, NULL, 'G3DSA:2.10.25.10:FF:000476', NULL, NULL, 'nephronectin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(133222, NULL, 'G3DSA:1.10.418.60:FF:000013', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133223, NULL, 'G3DSA:3.40.50.1360:FF:000017', NULL, NULL, '6-phosphogluconolactonase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(133224, NULL, 'G3DSA:3.20.20.80:FF:000264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133225, NULL, 'G3DSA:1.25.40.10:FF:003212', NULL, NULL, 'TPR repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(133226, NULL, 'G3DSA:1.10.287.100:FF:000001', NULL, NULL, 'Transcription initiation factor IIA subunit', NULL, NULL, NULL, NULL, NULL, 4),
(133227, NULL, 'G3DSA:3.30.450.20:FF:000098', NULL, NULL, 'Sensor histidine kinase ResE', NULL, NULL, NULL, NULL, NULL, 4),
(133228, NULL, 'G3DSA:1.25.40.10:FF:000210', NULL, NULL, 'Hsp70/Hsp90 organizing protein', NULL, NULL, NULL, NULL, NULL, 4),
(133229, NULL, 'G3DSA:3.40.1170.60:FF:000001', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(133230, NULL, 'G3DSA:1.25.40.20:FF:000213', NULL, NULL, 'APSES transcription factor (MbpA)', NULL, NULL, NULL, NULL, NULL, 4),
(133231, NULL, 'G3DSA:3.30.930.10:FF:000008', NULL, NULL, 'Glycine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(133232, NULL, 'G3DSA:3.30.160.60:FF:000430', NULL, NULL, 'zinc finger protein 596 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(133233, NULL, 'G3DSA:1.10.8.60:FF:000227', NULL, NULL, 'ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(133234, NULL, 'G3DSA:1.10.268.10:FF:000014', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(133235, NULL, 'G3DSA:3.90.830.10:FF:000021', NULL, NULL, 'Vacuolar protein-sorting-associated protein 33 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(133236, NULL, 'G3DSA:1.20.1250.20:FF:002059', NULL, NULL, 'Os03g0823100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(133237, NULL, 'G3DSA:1.10.287.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133238, NULL, 'G3DSA:2.60.120.200:FF:000508', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(133239, NULL, 'G3DSA:1.25.40.10:FF:005292', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133240, NULL, 'G3DSA:2.10.90.10:FF:000143', NULL, NULL, 'transforming growth factor beta superfamily signaling ligand isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(133241, NULL, 'G3DSA:3.10.310.20:FF:000002', NULL, NULL, 'Prune homolog 2 with BCH domain', NULL, NULL, NULL, NULL, NULL, 4),
(133242, NULL, 'G3DSA:1.25.40.10:FF:001930', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(133243, NULL, 'G3DSA:1.20.1300.20:FF:000012', NULL, NULL, 'Ubiquitin thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(133244, NULL, 'G3DSA:3.30.30.30:FF:000013', NULL, NULL, 'Heat shock 70 kDa protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(133245, NULL, 'G3DSA:2.60.40.3500:FF:000003', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(133246, NULL, 'G3DSA:1.20.58.730:FF:000003', NULL, NULL, 'Protein zwilch homolog', NULL, NULL, NULL, NULL, NULL, 4),
(133247, NULL, 'G3DSA:3.40.50.720:FF:000467', NULL, NULL, 'Steroid dehydrogenase 4', NULL, NULL, NULL, NULL, NULL, 4),
(133248, NULL, 'G3DSA:3.40.50.2000:FF:000069', NULL, NULL, 'Alpha-(1-6)-phosphatidylinositol monomannoside mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(133249, NULL, 'G3DSA:1.10.10.10:FF:001158', NULL, NULL, 'Transcriptional regulator, Crp/Fnr family', NULL, NULL, NULL, NULL, NULL, 4),
(133250, NULL, 'G3DSA:3.30.160.60:FF:003741', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133251, NULL, 'G3DSA:3.40.50.1000:FF:000302', NULL, NULL, 'Na+/K+ ATPase alpha subunit isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(133252, NULL, 'G3DSA:3.30.412.10:FF:000001', NULL, NULL, 'Aerolysin', NULL, NULL, NULL, NULL, NULL, 4),
(133253, NULL, 'G3DSA:1.25.40.10:FF:003392', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g36980, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(133254, NULL, 'G3DSA:1.10.8.770:FF:000001', NULL, NULL, 'Methylenetetrahydrofolate dehydrogenase (NADP+ dependent) 1 like', NULL, NULL, NULL, NULL, NULL, 4),
(133255, NULL, 'G3DSA:2.60.40.10:FF:001745', NULL, NULL, 'Platelet and endothelial cell adhesion molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(133256, NULL, 'G3DSA:3.10.20.310:FF:000002', NULL, NULL, 'Outer membrane protein assembly factor BamA', NULL, NULL, NULL, NULL, NULL, 4),
(133257, NULL, 'G3DSA:1.20.120.50:FF:000002', NULL, NULL, 'Methyl-accepting chemotaxis sensory transducer', NULL, NULL, NULL, NULL, NULL, 4),
(133258, NULL, 'G3DSA:2.60.120.260:FF:000493', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133259, NULL, 'G3DSA:1.20.58.740:FF:000006', NULL, NULL, 'Blast:Dedicator of cytokinesis protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(133260, NULL, 'G3DSA:3.30.230.10:FF:000197', NULL, NULL, 'Mlh1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(133261, NULL, 'G3DSA:3.30.200.20:FF:000698', NULL, NULL, 'Myoblast growth factor receptor egl-15', NULL, NULL, NULL, NULL, NULL, 4),
(133262, NULL, 'G3DSA:1.25.40.180:FF:000195', NULL, NULL, 'YALI0D16313p', NULL, NULL, NULL, NULL, NULL, 4),
(133263, NULL, 'G3DSA:3.40.50.12780:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133264, NULL, 'G3DSA:3.30.1520.10:FF:000089', NULL, NULL, 'neutrophil cytosolic factor 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(133265, NULL, 'G3DSA:3.40.30.10:FF:000703', NULL, NULL, 'Thioredoxin domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(133266, NULL, 'G3DSA:3.40.50.2020:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133267, NULL, 'G3DSA:3.30.70.330:FF:002880', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133268, NULL, 'G3DSA:3.40.50.300:FF:004045', NULL, NULL, 'Dicer-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(133269, NULL, 'G3DSA:1.25.40.10:FF:003083', NULL, NULL, 'AaceriAFR663Wp', NULL, NULL, NULL, NULL, NULL, 4),
(133270, NULL, 'G3DSA:1.10.150.250:FF:000002', NULL, NULL, 'Succinate dehydrogenase assembly factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(133271, NULL, 'G3DSA:2.40.50.140:FF:000488', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133272, NULL, 'G3DSA:1.20.120.1210:FF:000002', NULL, NULL, 'T3SS2 effector VopL nucleation of actin polymerization', NULL, NULL, NULL, NULL, NULL, 4),
(133273, NULL, 'G3DSA:2.170.16.10:FF:000009', NULL, NULL, 'Pre-mRNA splicing factor (Prp8)', NULL, NULL, NULL, NULL, NULL, 4),
(133274, NULL, 'G3DSA:1.10.2000.10:FF:000062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133275, NULL, 'G3DSA:3.30.160.60:FF:002021', NULL, NULL, 'Transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(133276, NULL, 'G3DSA:3.80.10.10:FF:002084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133277, NULL, 'G3DSA:3.40.50.300:FF:001892', NULL, NULL, 'Putative dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(133278, NULL, 'G3DSA:3.30.160.60:FF:002330', NULL, NULL, 'PR domain zinc finger protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(133279, NULL, 'G3DSA:3.80.10.10:FF:002393', NULL, NULL, 'YALI0C14740p', NULL, NULL, NULL, NULL, NULL, 4),
(133280, NULL, 'G3DSA:2.10.60.10:FF:000080', NULL, NULL, 'Serine/threonine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(133281, NULL, 'G3DSA:4.10.410.10:FF:000110', NULL, NULL, 'Kunitz-type serine protease inhibitor BmKTT-1', NULL, NULL, NULL, NULL, NULL, 4),
(133282, NULL, 'G3DSA:3.40.50.10140:FF:000076', NULL, NULL, 'TIR-domain containing adaptor inducing INF-beta', NULL, NULL, NULL, NULL, NULL, 4),
(133283, NULL, 'G3DSA:3.40.50.150:FF:001695', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133284, NULL, 'G3DSA:1.25.40.10:FF:002110', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g15820, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(133285, NULL, 'G3DSA:3.10.170.20:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133286, NULL, 'G3DSA:2.40.50.740:FF:000004', NULL, NULL, '40S ribosomal protein S4', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(133287, NULL, 'G3DSA:2.60.120.200:FF:000817', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(133288, NULL, 'G3DSA:2.60.40.3510:FF:000006', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(133289, NULL, 'G3DSA:1.20.5.110:FF:000240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133290, NULL, 'G3DSA:3.40.50.200:FF:000081', NULL, NULL, 'Extracellular serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(133291, NULL, 'G3DSA:3.40.50.620:FF:000807', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133292, NULL, 'G3DSA:1.25.40.10:FF:001621', NULL, NULL, 'Trafficking protein particle complex 12', NULL, NULL, NULL, NULL, NULL, 4),
(133293, NULL, 'G3DSA:3.30.1460.20:FF:000019', NULL, NULL, 'Arp2/3 complex 34 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(133294, NULL, 'G3DSA:1.20.1560.10:FF:000904', NULL, NULL, 'Os05g0548300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(133295, NULL, 'G3DSA:1.20.120.1220:FF:000005', NULL, NULL, 'Prepilin peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(133296, NULL, 'G3DSA:3.40.50.10380:FF:000035', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(133297, NULL, 'G3DSA:3.30.160.60:FF:001841', NULL, NULL, 'Zinc finger protein 646', NULL, NULL, NULL, NULL, NULL, 4),
(133298, NULL, 'G3DSA:1.10.533.10:FF:000002', NULL, NULL, 'Ankyrin-3 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(133299, NULL, 'G3DSA:1.25.40.20:FF:001624', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133300, NULL, 'G3DSA:2.30.42.10:FF:000397', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133301, NULL, 'G3DSA:3.30.1490.220:FF:000005', NULL, NULL, 'Inositol-tetrakisphosphate 1-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(133302, NULL, 'G3DSA:1.10.1060.10:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133303, NULL, 'G3DSA:2.30.110.10:FF:000023', NULL, NULL, 'Putative flavoprotein oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(133304, NULL, 'G3DSA:3.30.460.10:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133305, NULL, 'G3DSA:2.130.10.10:FF:005646', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133306, NULL, 'G3DSA:3.40.50.300:FF:005473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133307, NULL, 'G3DSA:3.80.10.10:FF:002971', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133308, NULL, 'G3DSA:2.60.40.1090:FF:000033', NULL, NULL, 'Fimbrial-like adhesin protein', NULL, NULL, NULL, NULL, NULL, 4),
(133309, NULL, 'G3DSA:3.40.50.620:FF:000572', NULL, NULL, 'Os12g0181200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(133310, NULL, 'G3DSA:2.10.10.10:FF:000026', NULL, NULL, 'Matrix metallopeptidase 9', NULL, NULL, NULL, NULL, NULL, 4),
(133311, NULL, 'G3DSA:1.10.287.110:FF:000212', NULL, NULL, 'Chaperone protein dnaJ 13', NULL, NULL, NULL, NULL, NULL, 4),
(133312, NULL, 'G3DSA:1.20.140.10:FF:000031', NULL, NULL, 'Acyl-CoA dehydrogenase FadE1', NULL, NULL, NULL, NULL, NULL, 4),
(133313, NULL, 'G3DSA:2.170.270.10:FF:000012', NULL, NULL, 'PR domain zinc finger protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(133314, NULL, 'G3DSA:2.60.40.640:FF:000030', NULL, NULL, 'Intracellular protein transport protein (Sat1)', NULL, NULL, NULL, NULL, NULL, 4),
(133315, NULL, 'G3DSA:1.20.1250.20:FF:000794', NULL, NULL, 'Allantoate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(133316, NULL, 'G3DSA:1.20.1250.20:FF:001412', NULL, NULL, 'Predicted arabinose efflux permease, MFS family', NULL, NULL, NULL, NULL, NULL, 4),
(133317, NULL, 'G3DSA:2.40.30.10:FF:000301', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(133318, NULL, 'G3DSA:3.30.70.990:FF:000003', NULL, NULL, 'UPF0234 protein MIP_06774', NULL, NULL, NULL, NULL, NULL, 4),
(133319, NULL, 'G3DSA:3.30.390.70:FF:000001', NULL, NULL, 'Type III secretion system effector SifA', NULL, NULL, NULL, NULL, NULL, 4),
(133320, NULL, 'G3DSA:1.25.40.20:FF:001169', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(133321, NULL, 'G3DSA:2.80.10.50:FF:000170', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(133322, NULL, 'G3DSA:3.40.850.10:FF:000264', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(133323, NULL, 'G3DSA:2.40.10.10:FF:000300', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133324, NULL, 'G3DSA:1.25.40.20:FF:001596', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(133325, NULL, 'G3DSA:2.10.50.10:FF:000034', NULL, NULL, 'TNF receptor superfamily member 25', NULL, NULL, NULL, NULL, NULL, 4),
(133326, NULL, 'G3DSA:3.30.390.30:FF:000028', NULL, NULL, 'Rubredoxin-NAD(+) reductase', NULL, NULL, NULL, NULL, NULL, 4),
(133327, NULL, 'G3DSA:1.10.10.350:FF:000019', NULL, NULL, 'Glutamate--tRNA ligase 1', NULL, NULL, NULL, NULL, NULL, 4),
(133328, NULL, 'G3DSA:1.20.1090.10:FF:000059', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(133329, NULL, 'G3DSA:2.10.60.10:FF:000063', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(133330, NULL, 'G3DSA:3.10.50.40:FF:000035', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(133331, NULL, 'G3DSA:1.25.40.180:FF:000341', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133332, NULL, 'G3DSA:3.40.1110.10:FF:000297', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133333, NULL, 'G3DSA:3.40.50.2020:FF:000125', NULL, NULL, 'Hypoxanthine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(133334, NULL, 'G3DSA:2.130.10.10:FF:002420', NULL, NULL, 'Guanine nucleotide-binding protein subunit beta-like protein 1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(133335, NULL, 'G3DSA:2.60.40.1230:FF:000002', NULL, NULL, 'AP-1 complex subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(133336, NULL, 'G3DSA:1.10.150.110:FF:000011', NULL, NULL, 'Hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(133337, NULL, 'G3DSA:1.10.1050.10:FF:000008', NULL, NULL, '30S ribosomal protein S4', NULL, NULL, NULL, NULL, NULL, 4),
(133338, NULL, 'G3DSA:1.10.20.10:FF:000012', NULL, NULL, 'Histone H4', NULL, NULL, NULL, NULL, NULL, 4),
(133339, NULL, 'G3DSA:3.40.33.10:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133340, NULL, 'G3DSA:3.30.420.510:FF:000012', NULL, NULL, 'Pantothenate kinase subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(133341, NULL, 'G3DSA:3.10.280.10:FF:000030', NULL, NULL, 'Complement C1q binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(133342, NULL, 'G3DSA:3.60.10.10:FF:000432', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133343, NULL, 'G3DSA:3.80.10.10:FF:000358', NULL, NULL, 'F-box/LRR-repeat protein 17 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(133344, NULL, 'G3DSA:3.10.620.30:FF:000006', NULL, NULL, 'Transglutaminase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(133345, NULL, 'G3DSA:4.10.400.10:FF:000036', NULL, NULL, 'Sortilin related receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(133346, NULL, 'G3DSA:3.30.160.60:FF:001369', NULL, NULL, 'pH-response transcription factor pacC/RIM101', NULL, NULL, NULL, NULL, NULL, 4),
(133347, NULL, 'G3DSA:2.30.29.30:FF:001254', NULL, NULL, 'Neurobeachin/beige protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(133348, NULL, 'G3DSA:3.90.660.10:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133349, NULL, 'G3DSA:3.30.200.20:FF:001439', NULL, NULL, 'Os04g0134501 protein', NULL, NULL, NULL, NULL, NULL, 4),
(133350, NULL, 'G3DSA:1.10.287.10:FF:000019', NULL, NULL, 'Ataxin-3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(133351, NULL, 'G3DSA:3.40.50.1820:FF:000559', NULL, NULL, 'Hydrolase, alpha/beta fold family domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(133352, NULL, 'G3DSA:3.30.930.10:FF:000216', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(133353, NULL, 'G3DSA:3.80.10.10:FF:000829', NULL, NULL, 'H0305E08.2 protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(133354, NULL, 'G3DSA:3.30.70.360:FF:000067', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133355, NULL, 'G3DSA:3.50.50.60:FF:000972', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133356, NULL, 'G3DSA:2.60.120.290:FF:000125', NULL, NULL, 'AGAP005526-PA', NULL, NULL, NULL, NULL, NULL, 4),
(133357, NULL, 'G3DSA:3.30.70.330:FF:000755', NULL, NULL, 'RNA-binding protein 8A', NULL, NULL, NULL, NULL, NULL, 4),
(133358, NULL, 'G3DSA:1.25.10.10:FF:001765', NULL, NULL, 'YALI0E29909p', NULL, NULL, NULL, NULL, NULL, 4),
(133359, NULL, 'G3DSA:3.30.2090.10:FF:000027', NULL, NULL, 'Acriflavine resistance protein B', NULL, NULL, NULL, NULL, NULL, 4),
(133360, NULL, 'G3DSA:3.30.460.10:FF:000051', NULL, NULL, 'DNA2/NAM7 helicase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(133361, NULL, 'G3DSA:1.10.510.10:FF:004120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133362, NULL, 'G3DSA:2.60.120.200:FF:000626', NULL, NULL, 'MAM and LDL-receptor class A domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(133363, NULL, 'G3DSA:2.10.50.10:FF:000135', NULL, NULL, 'TNF receptor superfamily member 10d', NULL, NULL, NULL, NULL, NULL, 4),
(133364, NULL, 'G3DSA:3.40.50.300:FF:005618', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133365, NULL, 'G3DSA:3.50.7.10:FF:000089', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133366, NULL, 'G3DSA:2.30.39.10:FF:000035', NULL, NULL, 'Serine protease inhibitor (serpin) 16', NULL, NULL, NULL, NULL, NULL, 4),
(133367, NULL, 'G3DSA:3.40.50.300:FF:005574', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133368, NULL, 'G3DSA:3.50.20.20:FF:000008', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133369, NULL, 'G3DSA:1.10.287.70:FF:000790', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133370, NULL, 'G3DSA:2.30.30.140:FF:000205', NULL, NULL, 'Lysine-specific demethylase 4C', NULL, NULL, NULL, NULL, NULL, 4),
(133371, NULL, 'G3DSA:2.60.40.10:FF:003870', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133372, NULL, 'G3DSA:1.10.238.160:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133373, NULL, 'G3DSA:3.30.800.10:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133374, NULL, 'G3DSA:3.10.129.10:FF:000078', NULL, NULL, 'Beta-hydroxyacyl-(Acyl-carrier-protein) dehydratase FabZ', NULL, NULL, NULL, NULL, NULL, 4),
(133375, NULL, 'G3DSA:3.30.760.10:FF:000079', NULL, NULL, 'Eukaryotic initiation factor 4E family protein', NULL, NULL, NULL, NULL, NULL, 4),
(133376, NULL, 'G3DSA:3.40.50.300:FF:005944', NULL, NULL, 'ATP-dependent helicase HrpB', NULL, NULL, NULL, NULL, NULL, 4),
(133377, NULL, 'G3DSA:3.30.450.20:FF:000553', NULL, NULL, 'Sensor histidine kinase PilS, PAS domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(133378, NULL, 'G3DSA:3.30.70.100:FF:000006', NULL, NULL, 'Antibiotic biosynthesis monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(133379, NULL, 'G3DSA:1.10.20.10:FF:000113', NULL, NULL, 'Transcription initiation factor TFIID subunit 13', NULL, NULL, NULL, NULL, NULL, 4),
(133380, NULL, 'G3DSA:1.10.510.10:FF:003294', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133381, NULL, 'G3DSA:3.30.70.330:FF:001109', NULL, NULL, 'UBP1-associated protein 2C isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(133382, NULL, 'G3DSA:3.40.50.2300:FF:001103', NULL, NULL, 'Extracellular calcium-sensing receptor', NULL, NULL, NULL, NULL, NULL, 4),
(133383, NULL, 'G3DSA:2.60.40.10:FF:001936', NULL, NULL, 'KETtiN (Drosophila actin-binding) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(133384, NULL, 'G3DSA:2.30.30.40:FF:000400', NULL, NULL, 'Peripheral-type benzodiazepine receptor-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(133385, NULL, 'G3DSA:1.10.10.10:FF:001512', NULL, NULL, 'non-structural maintenance of chromosomes element 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(133386, NULL, 'G3DSA:1.20.970.10:FF:000043', NULL, NULL, 'Thymidine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(133387, NULL, 'G3DSA:1.20.1250.20:FF:000159', NULL, NULL, 'Solute carrier family 22 member 17', NULL, NULL, NULL, NULL, NULL, 4),
(133388, NULL, 'G3DSA:3.40.50.1820:FF:001133', NULL, NULL, '2210023G05Rik protein', NULL, NULL, NULL, NULL, NULL, 4),
(133389, NULL, 'G3DSA:3.20.20.70:FF:000244', NULL, NULL, 'tRNA-dihydrouridine(20) synthase [NAD(P)+]-like isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(133390, NULL, 'G3DSA:2.120.10.90:FF:000016', NULL, NULL, 'DNA topoisomerase (ATP-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4),
(133391, NULL, 'G3DSA:1.10.287.130:FF:000218', NULL, NULL, 'Ethylene response sensor 1', NULL, NULL, NULL, NULL, NULL, 4),
(133392, NULL, 'G3DSA:3.80.10.10:FF:002292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133393, NULL, 'G3DSA:3.30.40.10:FF:001227', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(133394, NULL, 'G3DSA:1.20.1270.60:FF:000341', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133395, NULL, 'G3DSA:1.10.720.30:FF:000027', NULL, NULL, 'E3 SUMO-protein ligase SIZ1', NULL, NULL, NULL, NULL, NULL, 4),
(133396, NULL, 'G3DSA:1.10.1520.10:FF:000073', NULL, NULL, 'Ribonuclease-III-like-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(133397, NULL, 'G3DSA:2.30.30.140:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133398, NULL, 'G3DSA:3.40.605.10:FF:000037', NULL, NULL, 'NADP-dependent fatty aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(133399, NULL, 'G3DSA:1.10.510.10:FF:000112', NULL, NULL, 'Putative dual specificity tyrosine-phosphorylation-regulated kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(133400, NULL, 'G3DSA:1.20.1250.20:FF:002076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133401, NULL, 'G3DSA:1.20.1250.20:FF:000838', NULL, NULL, 'Battenin', NULL, NULL, NULL, NULL, NULL, 4),
(133402, NULL, 'G3DSA:1.20.5.110:FF:000256', NULL, NULL, 'YALI0E11825p', NULL, NULL, NULL, NULL, NULL, 4),
(133403, NULL, 'G3DSA:3.30.65.10:FF:000014', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(133404, NULL, 'G3DSA:3.20.20.80:FF:000247', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(133405, NULL, 'G3DSA:3.40.1690.10:FF:000003', NULL, NULL, 'Flagellar biosynthesis protein FlhB', NULL, NULL, NULL, NULL, NULL, 4),
(133406, NULL, 'G3DSA:1.25.10.10:FF:001086', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(133407, NULL, 'G3DSA:3.40.50.2000:FF:000277', NULL, NULL, 'Glucosyltransferase 3', NULL, NULL, NULL, NULL, NULL, 4),
(133408, NULL, 'G3DSA:1.20.1600.10:FF:000054', NULL, NULL, 'Type I secretion outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(133409, NULL, 'G3DSA:3.30.70.330:FF:001098', NULL, NULL, 'Nuclear cap-binding protein subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(133410, NULL, 'G3DSA:2.60.40.3170:FF:000005', NULL, NULL, 'Related to Tripeptidyl-peptidase II', NULL, NULL, NULL, NULL, NULL, 4),
(133411, NULL, 'G3DSA:1.10.510.10:FF:003546', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133412, NULL, 'G3DSA:1.25.40.10:FF:005336', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133413, NULL, 'G3DSA:3.30.390.10:FF:000022', NULL, NULL, 'Enolase 4', NULL, NULL, NULL, NULL, NULL, 4),
(133414, NULL, 'G3DSA:1.20.1270.370:FF:000002', NULL, NULL, 'Lactoyl-CoA dehydratase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(133415, NULL, 'G3DSA:1.20.920.10:FF:000107', NULL, NULL, 'Transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(133416, NULL, 'G3DSA:1.20.900.10:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133417, NULL, 'G3DSA:3.30.420.10:FF:000458', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133418, NULL, 'G3DSA:3.30.70.3400:FF:000002', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(133419, NULL, 'G3DSA:3.30.190.20:FF:000027', NULL, NULL, 'Ribosomal protein L10a', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(133420, NULL, 'G3DSA:2.30.29.30:FF:000439', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(133421, NULL, 'G3DSA:3.40.50.10330:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133422, NULL, 'G3DSA:2.40.160.120:FF:000002', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(133423, NULL, 'G3DSA:3.30.420.40:FF:000956', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(133424, NULL, 'G3DSA:1.10.1370.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133425, NULL, 'G3DSA:2.10.70.10:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133426, NULL, 'G3DSA:3.40.50.10090:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133427, NULL, 'G3DSA:3.40.50.2300:FF:001530', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133428, NULL, 'G3DSA:2.60.40.10:FF:001728', NULL, NULL, 'Plexin-A1', NULL, NULL, NULL, NULL, NULL, 4),
(133429, NULL, 'G3DSA:3.40.50.800:FF:000064', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(133430, NULL, 'G3DSA:3.30.70.2050:FF:000002', NULL, NULL, 'Nitrous oxide reductase accessory protein', NULL, NULL, NULL, NULL, NULL, 4),
(133431, NULL, 'G3DSA:3.90.228.10:FF:000065', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(133432, NULL, 'G3DSA:1.20.1250.20:FF:000468', NULL, NULL, 'Os11g0620400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(133433, NULL, 'G3DSA:3.40.50.11730:FF:000002', NULL, NULL, 'Peroxisome assembly protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(133434, NULL, 'G3DSA:1.20.1070.10:FF:000838', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133435, NULL, 'G3DSA:3.40.50.300:FF:001566', NULL, NULL, 'Dynein heavy chain domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(133436, NULL, 'G3DSA:1.10.565.10:FF:000019', NULL, NULL, 'Nuclear receptor subfamily 2 group E member 1', NULL, NULL, NULL, NULL, NULL, 4),
(133437, NULL, 'G3DSA:3.40.50.300:FF:007934', NULL, NULL, 'Dicer-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(133438, NULL, 'G3DSA:3.10.580.10:FF:000058', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(133439, NULL, 'G3DSA:1.10.8.10:FF:000128', NULL, NULL, 'Ubiquitin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(133440, NULL, 'G3DSA:1.20.120.290:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133441, NULL, 'G3DSA:3.30.559.10:FF:000145', NULL, NULL, 'Peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(133442, NULL, 'G3DSA:2.60.120.290:FF:000226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133443, NULL, 'G3DSA:1.10.600.10:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133444, NULL, 'G3DSA:3.30.160.60:FF:003078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133445, NULL, 'G3DSA:1.50.10.10:FF:000212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133446, NULL, 'G3DSA:3.40.50.2000:FF:000395', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(133447, NULL, 'G3DSA:2.10.110.20:FF:000002', NULL, NULL, 'lysine-specific demethylase 6A isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(133448, NULL, 'G3DSA:2.130.10.10:FF:001695', NULL, NULL, 'WD domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(133449, NULL, 'G3DSA:1.10.1790.10:FF:000002', NULL, NULL, 'Cryptic beta-glucoside bgl operon antiterminator', NULL, NULL, NULL, NULL, NULL, 4),
(133450, NULL, 'G3DSA:3.40.50.2300:FF:001412', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133451, NULL, 'G3DSA:2.130.10.10:FF:005438', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133452, NULL, 'G3DSA:3.40.50.1390:FF:000020', NULL, NULL, 'DNA recombinase', NULL, NULL, NULL, NULL, NULL, 4),
(133453, NULL, 'G3DSA:3.40.50.10380:FF:000018', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(133454, NULL, 'G3DSA:1.10.510.10:FF:003193', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(133455, NULL, 'G3DSA:2.30.29.30:FF:001046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133456, NULL, 'G3DSA:3.40.430.10:FF:000041', NULL, NULL, 'Riboflavin biosynthesis protein RibD', NULL, NULL, NULL, NULL, NULL, 4),
(133457, NULL, 'G3DSA:1.10.132.70:FF:000021', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(133458, NULL, 'G3DSA:1.10.167.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133459, NULL, 'G3DSA:1.20.920.10:FF:000169', NULL, NULL, 'Polybromo 1,-like', NULL, NULL, NULL, NULL, NULL, 4),
(133460, NULL, 'G3DSA:3.30.70.1180:FF:000022', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(133461, NULL, 'G3DSA:3.40.50.300:FF:001875', NULL, NULL, 'RAB15, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(133462, NULL, 'G3DSA:1.20.910.10:FF:000034', NULL, NULL, 'Uncharacterized protein C530.07c', NULL, NULL, NULL, NULL, NULL, 4),
(133463, NULL, 'G3DSA:3.30.160.60:FF:005539', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133464, NULL, 'G3DSA:3.20.20.140:FF:000471', NULL, NULL, '2-amino-3-carboxymuconate-6-semialdehyde decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(133465, NULL, 'G3DSA:1.25.40.10:FF:003420', NULL, NULL, 'Heat shock protein DnaJ domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(133466, NULL, 'G3DSA:3.40.50.300:FF:006080', NULL, NULL, 'Protein CBR-GSA-1', NULL, NULL, NULL, NULL, NULL, 4),
(133467, NULL, 'G3DSA:3.40.50.620:FF:000881', NULL, NULL, 'Tryptophan--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(133468, NULL, 'G3DSA:3.40.1190.10:FF:000010', NULL, NULL, 'Dihydrofolate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(133469, NULL, 'G3DSA:2.10.25.10:FF:000622', NULL, NULL, 'Laminin-like protein epi-1', NULL, NULL, NULL, NULL, NULL, 4),
(133470, NULL, 'G3DSA:3.40.50.10420:FF:000053', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(133471, NULL, 'G3DSA:1.20.5.110:FF:000155', NULL, NULL, 'Vesicle-associated membrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(133472, NULL, 'G3DSA:2.60.120.200:FF:000582', NULL, NULL, 'Laminin subunit alpha 5', NULL, NULL, NULL, NULL, NULL, 4),
(133473, NULL, 'G3DSA:1.20.5.2050:FF:000004', NULL, NULL, 'Transcription factor with AP2 domain(S) (AP2-G)', NULL, NULL, NULL, NULL, NULL, 4),
(133474, NULL, 'G3DSA:3.90.640.10:FF:000158', NULL, NULL, 'ARP1 actin related protein 1 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(133475, NULL, 'G3DSA:3.90.810.10:FF:000019', NULL, NULL, 'Serine/threonine-protein kinase PAK', NULL, NULL, NULL, NULL, NULL, 4),
(133476, NULL, 'G3DSA:3.40.50.300:FF:003820', NULL, NULL, 'Elongation factor 1-alpha', NULL, NULL, NULL, NULL, NULL, 4),
(133477, NULL, 'G3DSA:3.30.1360.170:FF:000017', NULL, NULL, 'Thymidylate synthase complementing protein ThyX', NULL, NULL, NULL, NULL, NULL, 4),
(133478, NULL, 'G3DSA:3.40.50.620:FF:000779', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133479, NULL, 'G3DSA:1.20.900.10:FF:000095', NULL, NULL, 'Rho GTPase-activating protein 20', NULL, NULL, NULL, NULL, NULL, 4),
(133480, NULL, 'G3DSA:3.40.1110.10:FF:000089', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(133481, NULL, 'G3DSA:4.10.400.10:FF:000345', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133482, NULL, 'G3DSA:3.40.1110.10:FF:000090', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(133483, NULL, 'G3DSA:2.10.110.30:FF:000005', NULL, NULL, 'E3 ubiquitin-protein ligase ubr-1', NULL, NULL, NULL, NULL, NULL, 4),
(133484, NULL, 'G3DSA:2.10.110.10:FF:000359', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133485, NULL, 'G3DSA:1.10.510.10:FF:000320', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(133486, NULL, 'G3DSA:1.25.40.10:FF:001593', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(133487, NULL, 'G3DSA:1.20.1130.10:FF:000001', NULL, NULL, 'Photosystem I P700 chlorophyll a apoprotein A2', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(133488, NULL, 'G3DSA:1.10.630.10:FF:000705', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133489, NULL, 'G3DSA:1.25.40.10:FF:001475', NULL, NULL, 'Selenium-binding protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(133490, NULL, 'G3DSA:1.10.150.50:FF:000192', NULL, NULL, 'Putative sh3 and multiple ankyrin repeat 3', NULL, NULL, NULL, NULL, NULL, 4),
(133491, NULL, 'G3DSA:1.25.40.20:FF:001478', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133492, NULL, 'G3DSA:3.30.1600.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133493, NULL, 'G3DSA:2.130.10.10:FF:001706', NULL, NULL, 'Rho guanine nucleotide exchange factor 17', NULL, NULL, NULL, NULL, NULL, 4),
(133494, NULL, 'G3DSA:3.30.300.110:FF:000017', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133495, NULL, 'G3DSA:1.10.1200.270:FF:000035', NULL, NULL, 'Salicylate/benzoate carboxyl methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(133496, NULL, 'G3DSA:1.20.1070.10:FF:000159', NULL, NULL, 'C-X-C chemokine receptor type 3', NULL, NULL, NULL, NULL, NULL, 4),
(133497, NULL, 'G3DSA:1.20.930.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133498, NULL, 'G3DSA:2.40.50.140:FF:001123', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133499, NULL, 'G3DSA:2.30.30.140:FF:000093', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(133500, NULL, 'G3DSA:3.40.50.300:FF:000037', NULL, NULL, '26S protease regulatory subunit 6A', NULL, NULL, NULL, NULL, NULL, 4),
(133501, NULL, 'G3DSA:1.10.238.10:FF:000979', NULL, NULL, 'CAMK/CDPK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(133502, NULL, 'G3DSA:3.90.870.50:FF:000001', NULL, NULL, 'Carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(133503, NULL, 'G3DSA:2.40.30.10:FF:000200', NULL, NULL, 'Ferric reductase like transmembrane component protein', NULL, NULL, NULL, NULL, NULL, 4),
(133504, NULL, 'G3DSA:1.10.510.10:FF:002102', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(133505, NULL, 'G3DSA:3.60.10.10:FF:000095', NULL, NULL, 'RNA-editing complex protein MP100', NULL, NULL, NULL, NULL, NULL, 4),
(133506, NULL, 'G3DSA:2.10.25.10:FF:000829', NULL, NULL, 'Crumbs homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(133507, NULL, 'G3DSA:1.25.40.10:FF:001166', NULL, NULL, 'Os07g0239600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(133508, NULL, 'G3DSA:1.25.10.10:FF:003446', NULL, NULL, 'eIF-2-alpha kinase activator gcn1', NULL, NULL, NULL, NULL, NULL, 4),
(133509, NULL, 'G3DSA:1.25.40.20:FF:001848', NULL, NULL, 'C.Elegans Chromodomain protein', NULL, NULL, NULL, NULL, NULL, 4),
(133510, NULL, 'G3DSA:2.60.120.40:FF:000020', NULL, NULL, 'complement C1q tumor necrosis factor-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(133511, NULL, 'G3DSA:3.40.50.300:FF:005164', NULL, NULL, 'Lipoprotein-releasing system ATP-binding protein LolD 1', NULL, NULL, NULL, NULL, NULL, 4),
(133512, NULL, 'G3DSA:3.80.30.30:FF:000005', NULL, NULL, 'DNA repair photolyase', NULL, NULL, NULL, NULL, NULL, 4),
(133513, NULL, 'G3DSA:2.20.100.10:FF:000148', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs gon-1', NULL, NULL, NULL, NULL, NULL, 4),
(133514, NULL, 'G3DSA:3.80.10.10:FF:004399', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133515, NULL, 'G3DSA:2.90.10.10:FF:000011', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(133516, NULL, 'G3DSA:1.25.40.10:FF:003627', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g23020', NULL, NULL, NULL, NULL, NULL, 4),
(133517, NULL, 'G3DSA:2.130.10.10:FF:003640', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133518, NULL, 'G3DSA:3.30.70.330:FF:001570', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133519, NULL, 'G3DSA:3.40.30.10:FF:000804', NULL, NULL, 'Glutathione S-transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(133520, NULL, 'G3DSA:3.40.1160.10:FF:000036', NULL, NULL, 'Glutamate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(133521, NULL, 'G3DSA:3.30.200.20:FF:001911', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(133522, NULL, 'G3DSA:1.10.3860.10:FF:000031', NULL, NULL, 'Amino acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(133523, NULL, 'G3DSA:2.60.40.60:FF:000400', NULL, NULL, 'cadherin EGF LAG seven-pass G-type receptor 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(133524, NULL, 'G3DSA:2.40.170.20:FF:000061', NULL, NULL, 'Ferripyoverdine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(133525, NULL, 'G3DSA:3.40.470.10:FF:000015', NULL, NULL, 'Uracil-DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(133526, NULL, 'G3DSA:3.30.160.20:FF:000188', NULL, NULL, 'Ribonuclease 3 1', NULL, NULL, NULL, NULL, NULL, 4),
(133527, NULL, 'G3DSA:1.50.10.10:FF:000066', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(133528, NULL, 'G3DSA:3.40.50.10190:FF:000304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133529, NULL, 'G3DSA:2.130.10.10:FF:005540', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133530, NULL, 'G3DSA:3.30.420.210:FF:000012', NULL, NULL, 'Plant UBX domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(133531, NULL, 'G3DSA:1.20.58.60:FF:000349', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(133532, NULL, 'G3DSA:3.40.50.1820:FF:000453', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(133533, NULL, 'G3DSA:1.10.510.10:FF:001955', NULL, NULL, 'Putative serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(133534, NULL, 'G3DSA:1.10.8.10:FF:000336', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133535, NULL, 'G3DSA:1.10.510.10:FF:003855', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133536, NULL, 'G3DSA:3.40.33.10:FF:000047', NULL, NULL, 'Antares, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(133537, NULL, 'G3DSA:1.20.1250.20:FF:000732', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(133538, NULL, 'G3DSA:3.40.50.300:FF:000801', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(133539, NULL, 'G3DSA:1.10.275.10:FF:000008', NULL, NULL, 'Histidine ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(133540, NULL, 'G3DSA:2.40.50.140:FF:001005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133541, NULL, 'G3DSA:2.10.25.10:FF:000049', NULL, NULL, 'Fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(133542, NULL, 'G3DSA:3.40.50.2000:FF:001103', NULL, NULL, 'UDP-glycosyltransferase 88A1', NULL, NULL, NULL, NULL, NULL, 4),
(133543, NULL, 'G3DSA:2.130.10.30:FF:000066', NULL, NULL, 'Putative receptor protein kinase CRINKLY4', NULL, NULL, NULL, NULL, NULL, 4),
(133544, NULL, 'G3DSA:1.10.287.70:FF:000481', NULL, NULL, 'Potassium channel subfamily K member', NULL, NULL, NULL, NULL, NULL, 4),
(133545, NULL, 'G3DSA:1.50.10.20:FF:000069', NULL, NULL, 'Protein farnesyltransferase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(133546, NULL, 'G3DSA:4.10.410.10:FF:000082', NULL, NULL, 'Tissue factor pathway inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(133547, NULL, 'G3DSA:3.50.50.60:FF:001326', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133548, NULL, 'G3DSA:4.10.60.10:FF:000030', NULL, NULL, 'Branchpoint-bridging protein', NULL, NULL, NULL, NULL, NULL, 4),
(133549, NULL, 'G3DSA:1.10.287.70:FF:000239', NULL, NULL, 'TWiK family of potassium channels', NULL, NULL, NULL, NULL, NULL, 4),
(133550, NULL, 'G3DSA:2.30.30.870:FF:000002', NULL, NULL, 'Protein pelota homolog', NULL, NULL, NULL, NULL, NULL, 4),
(133551, NULL, 'G3DSA:3.90.79.20:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133552, NULL, 'G3DSA:1.25.40.10:FF:001284', NULL, NULL, 'Tetratricopeptide repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(133553, NULL, 'G3DSA:2.60.40.10:FF:001375', NULL, NULL, 'Obscurin-like protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(133554, NULL, 'G3DSA:1.10.8.60:FF:000435', NULL, NULL, 'Peroxisome biogenesis factor 1, putative', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(133555, NULL, 'G3DSA:3.80.10.10:FF:002499', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133556, NULL, 'G3DSA:3.40.50.150:FF:000060', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(133557, NULL, 'G3DSA:3.90.1200.10:FF:000023', NULL, NULL, 'Aminoglycoside phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(133558, NULL, 'G3DSA:1.20.120.540:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133559, NULL, 'G3DSA:3.30.420.10:FF:000604', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133560, NULL, 'G3DSA:2.20.110.10:FF:000076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133561, NULL, 'G3DSA:2.40.290.10:FF:000033', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(133562, NULL, 'G3DSA:1.25.40.20:FF:001287', NULL, NULL, 'Os09g0334900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(133563, NULL, 'G3DSA:3.40.250.10:FF:000044', NULL, NULL, 'Rhodanese-like domain-containing protein 4, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(133564, NULL, 'G3DSA:1.10.555.10:FF:000081', NULL, NULL, 'Rho GTPase Activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(133565, NULL, 'G3DSA:3.40.1170.10:FF:000008', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(133566, NULL, 'G3DSA:1.10.472.10:FF:000101', NULL, NULL, 'Cyclin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(133567, NULL, 'G3DSA:1.20.58.1120:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133568, NULL, 'G3DSA:3.40.120.10:FF:000040', NULL, NULL, 'Phosphoglucomutase A', NULL, NULL, NULL, NULL, NULL, 4),
(133569, NULL, 'G3DSA:2.60.120.650:FF:000177', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133570, NULL, 'G3DSA:1.20.120.550:FF:000005', NULL, NULL, 'Inorganic phosphate transporter 1-6', NULL, NULL, NULL, NULL, NULL, 4),
(133571, NULL, 'G3DSA:2.10.90.10:FF:000109', NULL, NULL, 'Nodal homolog 2-A', NULL, NULL, NULL, NULL, NULL, 4),
(133572, NULL, 'G3DSA:2.130.10.10:FF:000060', NULL, NULL, 'WD repeat-containing protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(133573, NULL, 'G3DSA:2.60.40.10:FF:004033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133574, NULL, 'G3DSA:2.60.40.3210:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133575, NULL, 'G3DSA:1.50.40.10:FF:000146', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(133576, NULL, 'G3DSA:2.60.40.10:FF:001627', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(133577, NULL, 'G3DSA:2.30.31.10:FF:000023', NULL, NULL, 'RNA polymerase II transcriptional coactivator KELP', NULL, NULL, NULL, NULL, NULL, 4),
(133578, NULL, 'G3DSA:3.10.490.10:FF:000040', NULL, NULL, 'Gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(133579, NULL, 'G3DSA:2.40.20.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133580, NULL, 'G3DSA:1.20.1070.10:FF:000367', NULL, NULL, 'Serotonin receptor 5-HT2 subtype', NULL, NULL, NULL, NULL, NULL, 4),
(133581, NULL, 'G3DSA:1.10.555.10:FF:000182', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133582, NULL, 'G3DSA:3.30.470.20:FF:000189', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133583, NULL, 'G3DSA:3.40.50.20:FF:000045', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(133584, NULL, 'G3DSA:3.40.50.300:FF:007726', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133585, NULL, 'G3DSA:3.40.50.1820:FF:000868', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(133586, NULL, 'G3DSA:3.40.50.2000:FF:000586', NULL, NULL, 'Glycogen synthase', NULL, NULL, NULL, NULL, NULL, 4),
(133587, NULL, 'G3DSA:1.25.40.10:FF:003184', NULL, NULL, 'TPR repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(133588, NULL, 'G3DSA:3.40.50.150:FF:001594', NULL, NULL, 'Leucine carboxyl methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(133589, NULL, 'G3DSA:3.30.450.20:FF:000289', NULL, NULL, 'Sensory box histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(133590, NULL, 'G3DSA:2.40.50.150:FF:000041', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(133591, NULL, 'G3DSA:2.130.10.10:FF:001594', NULL, NULL, 'Coiled-coil protein/ WD40 domain', NULL, NULL, NULL, NULL, NULL, 4),
(133592, NULL, 'G3DSA:3.30.70.2850:FF:000028', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(133593, NULL, 'G3DSA:1.10.630.10:FF:000593', NULL, NULL, 'Os09g0441600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(133594, NULL, 'G3DSA:1.25.40.10:FF:000401', NULL, NULL, 'Cytochrome c oxidase assembly factor 7', NULL, NULL, NULL, NULL, NULL, 4),
(133595, NULL, 'G3DSA:3.40.50.2300:FF:001221', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133596, NULL, 'G3DSA:3.30.40.210:FF:000011', NULL, NULL, 'Transcription initiation protein SPT4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(133597, NULL, 'G3DSA:3.30.200.20:FF:001086', NULL, NULL, 'Kinase, CMGC CDK', NULL, NULL, NULL, NULL, NULL, 4),
(133598, NULL, 'G3DSA:3.30.1370.110:FF:000007', NULL, NULL, 'Endonuclease MutS2', NULL, NULL, NULL, NULL, NULL, 4),
(133599, NULL, 'G3DSA:3.30.40.10:FF:000873', NULL, NULL, 'E3 ubiquitin-protein ligase SGR9, amyloplastic', NULL, NULL, NULL, NULL, NULL, 4),
(133600, NULL, 'G3DSA:3.10.450.350:FF:000008', NULL, NULL, 'Cell wall endopeptidase family M23/M37', NULL, NULL, NULL, NULL, NULL, 4),
(133601, NULL, 'G3DSA:3.40.1110.10:FF:000191', NULL, NULL, 'Membrane H(+)-ATPase1', NULL, NULL, NULL, NULL, NULL, 4),
(133602, NULL, 'G3DSA:3.30.505.10:FF:000144', NULL, NULL, 'SH2 domain protein 2A', NULL, NULL, NULL, NULL, NULL, 4),
(133603, NULL, 'G3DSA:3.30.450.20:FF:000435', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133604, NULL, 'G3DSA:2.150.10.10:FF:000014', NULL, NULL, 'Immunoglobulin-binding protein EibD', NULL, NULL, NULL, NULL, NULL, 4),
(133605, NULL, 'G3DSA:3.30.1370.100:FF:000004', NULL, NULL, 'DNA mismatch repair endonuclease MutL', NULL, NULL, NULL, NULL, NULL, 4),
(133606, NULL, 'G3DSA:3.30.70.330:FF:001660', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133607, NULL, 'G3DSA:3.30.160.60:FF:001633', NULL, NULL, 'GDNF inducible zinc finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(133608, NULL, 'G3DSA:1.25.40.20:FF:001832', NULL, NULL, 'Kinase, NEK-frag', NULL, NULL, NULL, NULL, NULL, 4),
(133609, NULL, 'G3DSA:1.25.40.20:FF:000404', NULL, NULL, 'Ankyrin repeat-containing protein At5g02620', NULL, NULL, NULL, NULL, NULL, 4),
(133610, NULL, 'G3DSA:3.30.479.20:FF:000046', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(133611, NULL, 'G3DSA:2.60.40.3180:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133612, NULL, 'G3DSA:3.40.630.30:FF:000129', NULL, NULL, 'Acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(133613, NULL, 'G3DSA:3.60.21.10:FF:000103', NULL, NULL, 'Unplaced genomic scaffold supercont1.18, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(133614, NULL, 'G3DSA:2.60.40.10:FF:000290', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(133615, NULL, 'G3DSA:2.130.10.10:FF:005394', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133616, NULL, 'G3DSA:3.20.20.80:FF:000455', NULL, NULL, 'Beta-galactosidase 8 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(133617, NULL, 'G3DSA:3.40.50.300:FF:005265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133618, NULL, 'G3DSA:1.25.40.120:FF:000019', NULL, NULL, 'Geranylgeranyl transferase type-2 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(133619, NULL, 'G3DSA:3.30.70.1230:FF:000205', NULL, NULL, 'Adenylyl cyclase class-3/4/guanylyl cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(133620, NULL, 'G3DSA:1.25.40.20:FF:001742', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133621, NULL, 'G3DSA:1.20.1250.20:FF:000586', NULL, NULL, 'Sialic acid-transport membrane protein nanT', NULL, NULL, NULL, NULL, NULL, 4),
(133622, NULL, 'G3DSA:2.60.40.10:FF:005427', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(133623, NULL, 'G3DSA:3.20.20.70:FF:000452', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133624, NULL, 'G3DSA:3.80.10.10:FF:003016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133625, NULL, 'G3DSA:2.10.220.10:FF:000092', NULL, NULL, 'Epidermal growth factor receptor a (erythroblastic leukemia viral (v-erb-b) oncogene homolog, avian)', NULL, NULL, NULL, NULL, NULL, 4),
(133626, NULL, 'G3DSA:1.10.10.250:FF:000023', NULL, NULL, '50S ribosomal protein L11-2/L11-3', NULL, NULL, NULL, NULL, NULL, 4),
(133627, NULL, 'G3DSA:3.40.1110.10:FF:000443', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133628, NULL, 'G3DSA:3.40.50.10490:FF:000068', NULL, NULL, 'MurR/RpiR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(133629, NULL, 'G3DSA:1.25.10.10:FF:001338', NULL, NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(133630, NULL, 'G3DSA:3.30.420.10:FF:000352', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133631, NULL, 'G3DSA:1.20.920.10:FF:000063', NULL, NULL, 'histone acetyltransferase KAT2A', NULL, NULL, NULL, NULL, NULL, 4),
(133632, NULL, 'G3DSA:2.130.10.10:FF:004112', NULL, NULL, 'Aladin-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(133633, NULL, 'G3DSA:3.30.70.2580:FF:000003', NULL, NULL, 'tRNA (Guanine(37)-N(1))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(133634, NULL, 'G3DSA:2.60.120.330:FF:000053', NULL, NULL, 'Unplaced genomic scaffold supercont1.31, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(133635, NULL, 'G3DSA:3.40.630.30:FF:000371', NULL, NULL, 'Acyl-CoA N-acyltransferases (NAT) superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(133636, NULL, 'G3DSA:3.40.190.10:FF:000926', NULL, NULL, 'SMN (Human Survival Motor Neuron gene) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(133637, NULL, 'G3DSA:2.40.50.140:FF:000960', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133638, NULL, 'G3DSA:3.40.50.740:FF:000040', NULL, NULL, 'Dimethyl sulfoxide reductase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(133639, NULL, 'G3DSA:1.20.1270.60:FF:000239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133640, NULL, 'G3DSA:3.10.20.90:FF:000340', NULL, NULL, 'Polyubiquitin containing 7 ubiquitin monomers', NULL, NULL, NULL, NULL, NULL, 4),
(133641, NULL, 'G3DSA:2.130.10.10:FF:003494', NULL, NULL, 'Serine/threonine-protein kinase VPS15', NULL, NULL, NULL, NULL, NULL, 4),
(133642, NULL, 'G3DSA:2.60.40.1180:FF:000026', NULL, NULL, 'Solute carrier family 3 (amino acid transporter heavy chain), member 1', NULL, NULL, NULL, NULL, NULL, 4),
(133643, NULL, 'G3DSA:3.30.70.1020:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133644, NULL, 'G3DSA:1.20.1250.20:FF:000277', NULL, NULL, 'Solute carrier family 16 member 4', NULL, NULL, NULL, NULL, NULL, 4),
(133645, NULL, 'G3DSA:2.30.30.490:FF:000068', NULL, NULL, 'Putative pre-initiation complex subunit cdc6 aaa+ superfamily atpase', NULL, NULL, NULL, NULL, NULL, 4),
(133646, NULL, 'G3DSA:1.10.287.370:FF:000048', NULL, NULL, 'Prefoldin subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(133647, NULL, 'G3DSA:3.40.50.1910:FF:000036', NULL, NULL, 'Protein transport protein sec1', NULL, NULL, NULL, NULL, NULL, 4),
(133648, NULL, 'G3DSA:1.10.510.10:FF:000421', NULL, NULL, 'Serine/threonine-protein kinase PAK 6', NULL, NULL, NULL, NULL, NULL, 4),
(133649, NULL, 'G3DSA:1.20.1740.10:FF:000132', NULL, NULL, 'Nitrogen-sensing and cell-morphology modulator, general aminoacid permease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(133650, NULL, 'G3DSA:3.30.1330.30:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133651, NULL, 'G3DSA:2.60.40.10:FF:005118', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133652, NULL, 'G3DSA:2.40.50.140:FF:000297', NULL, NULL, 'Protein BREAST CANCER SUSCEPTIBILITY 2 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(133653, NULL, 'G3DSA:3.30.200.20:FF:001350', NULL, NULL, 'Rho-associated kinase, putative', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(133654, NULL, 'G3DSA:1.10.1420.10:FF:000115', NULL, NULL, 'DNA mismatch repair protein MSH3', NULL, NULL, NULL, NULL, NULL, 4),
(133655, NULL, 'G3DSA:3.40.720.10:FF:000142', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133656, NULL, 'G3DSA:3.40.50.300:FF:003365', NULL, NULL, 'DNA repair protein RecN', NULL, NULL, NULL, NULL, NULL, 4),
(133657, NULL, 'G3DSA:2.130.10.10:FF:002212', NULL, NULL, 'Elongator complex protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(133658, NULL, 'G3DSA:3.20.10.10:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133659, NULL, 'G3DSA:3.40.50.2020:FF:000024', NULL, NULL, 'Putative phosphoribosyl pyrophosphate synthase-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(133660, NULL, 'G3DSA:3.20.20.140:FF:000128', NULL, NULL, 'TatD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(133661, NULL, 'G3DSA:2.40.128.20:FF:000036', NULL, NULL, 'Luciferase', NULL, NULL, NULL, NULL, NULL, 4),
(133662, NULL, 'G3DSA:3.90.80.10:FF:000007', NULL, NULL, 'Inorganic pyrophosphatase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(133663, NULL, 'G3DSA:1.10.520.10:FF:000040', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(133664, NULL, 'G3DSA:3.20.80.10:FF:000016', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(133665, NULL, 'G3DSA:1.20.120.150:FF:000008', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(133666, NULL, 'G3DSA:1.10.10.60:FF:000869', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133667, NULL, 'G3DSA:1.25.40.10:FF:003274', NULL, NULL, 'TPR repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(133668, NULL, 'G3DSA:3.30.310.50:FF:000001', NULL, NULL, 'Phosphoglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(133669, NULL, 'G3DSA:2.130.10.10:FF:003185', NULL, NULL, 'NLE (NUC135) domain/WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(133670, NULL, 'G3DSA:1.10.238.150:FF:000001', NULL, NULL, 'Dishevelled associated activator of morphogenesis 1', NULL, NULL, NULL, NULL, NULL, 4),
(133671, NULL, 'G3DSA:2.30.39.10:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133672, NULL, 'G3DSA:1.25.10.10:FF:001647', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133673, NULL, 'G3DSA:3.90.1150.10:FF:000479', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133674, NULL, 'G3DSA:1.10.10.10:FF:001276', NULL, NULL, 'ETS class transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(133675, NULL, 'G3DSA:1.20.1250.20:FF:002267', NULL, NULL, 'Os01g0142800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(133676, NULL, 'G3DSA:1.25.40.180:FF:000077', NULL, NULL, 'Unplaced genomic scaffold supercont2.8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(133677, NULL, 'G3DSA:3.40.50.300:FF:003926', NULL, NULL, 'Septin 14', NULL, NULL, NULL, NULL, NULL, 4),
(133678, NULL, 'G3DSA:3.40.50.300:FF:005826', NULL, NULL, 'tRNA dimethylallyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(133679, NULL, 'G3DSA:1.20.5.4770:FF:000011', NULL, NULL, 'Zinc finger A20 and AN1 domain-containing stress-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(133680, NULL, 'G3DSA:3.30.70.240:FF:000031', NULL, NULL, 'Mitochondrial elongation factor G2', NULL, NULL, NULL, NULL, NULL, 4),
(133681, NULL, 'G3DSA:3.40.50.300:FF:003674', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133682, NULL, 'G3DSA:3.30.40.10:FF:001126', NULL, NULL, 'G protein-coupled receptor', NULL, NULL, NULL, NULL, NULL, 4),
(133683, NULL, 'G3DSA:3.40.50.2300:FF:001176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133684, NULL, 'G3DSA:1.20.1250.20:FF:002177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133685, NULL, 'G3DSA:4.10.240.10:FF:000147', NULL, NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(133686, NULL, 'G3DSA:1.10.10.800:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(133687, NULL, 'G3DSA:3.40.720.10:FF:000361', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133688, NULL, 'G3DSA:3.40.50.300:FF:001774', NULL, NULL, 'ATPase component of energizing module ofqueuosine-regulated ECF transporter', NULL, NULL, NULL, NULL, NULL, 4),
(133689, NULL, 'G3DSA:1.20.970.10:FF:000009', NULL, NULL, 'Anthranilate phosphoribosyltransferase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(133690, NULL, 'G3DSA:3.40.50.720:FF:002299', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(133691, NULL, 'G3DSA:2.60.40.10:FF:003527', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133692, NULL, 'G3DSA:3.50.50.60:FF:001236', NULL, NULL, 'Os06g0203400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(133693, NULL, 'G3DSA:3.40.50.1370:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133694, NULL, 'G3DSA:3.30.70.340:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133695, NULL, 'G3DSA:3.40.50.1460:FF:000047', NULL, NULL, 'Caspase Nc-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(133696, NULL, 'G3DSA:3.20.20.60:FF:000140', NULL, NULL, 'Citrate lyase subunit beta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(133697, NULL, 'G3DSA:1.20.1110.10:FF:000090', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(133698, NULL, 'G3DSA:3.90.1720.10:FF:000034', NULL, NULL, 'Probable cell wall associated hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(133699, NULL, 'G3DSA:2.40.50.140:FF:000858', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133700, NULL, 'G3DSA:3.90.290.10:FF:000001', NULL, NULL, 'Latent-transforming growth factor beta-binding protein 3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(133701, NULL, 'G3DSA:3.30.70.260:FF:000037', NULL, NULL, 'Acetoin utilization protein AcuB', NULL, NULL, NULL, NULL, NULL, 4),
(133702, NULL, 'G3DSA:3.20.20.80:FF:000146', NULL, NULL, 'Maltodextrin glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(133703, NULL, 'G3DSA:3.40.50.1440:FF:000041', NULL, NULL, 'Tubulin gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(133704, NULL, 'G3DSA:3.40.50.300:FF:002701', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133705, NULL, 'G3DSA:3.40.50.300:FF:000240', NULL, NULL, 'ABC transporter B family member 20', NULL, NULL, NULL, NULL, NULL, 4),
(133706, NULL, 'G3DSA:3.30.470.20:FF:000099', NULL, NULL, 'Inositol-tetrakisphosphate 1-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(133707, NULL, 'G3DSA:1.20.1560.10:FF:000584', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133708, NULL, 'G3DSA:1.10.10.10:FF:001585', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133709, NULL, 'G3DSA:2.60.40.10:FF:003218', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133710, NULL, 'G3DSA:3.40.50.150:FF:001706', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133711, NULL, 'G3DSA:1.10.472.80:FF:000072', NULL, NULL, 'TBC domain-containing protein C23D3.03c', NULL, NULL, NULL, NULL, NULL, 4),
(133712, NULL, 'G3DSA:2.130.10.10:FF:005085', NULL, NULL, 'Utp4p', NULL, NULL, NULL, NULL, NULL, 4),
(133713, NULL, 'G3DSA:1.10.8.10:FF:000084', NULL, NULL, 'E3 ubiquitin-protein ligase XIAP', NULL, NULL, NULL, NULL, NULL, 4),
(133714, NULL, 'G3DSA:4.10.1240.10:FF:000037', NULL, NULL, 'Latrophilin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(133715, NULL, 'G3DSA:3.20.20.70:FF:000143', NULL, NULL, 'EF-P beta-lysylation protein EpmB', NULL, NULL, NULL, NULL, NULL, 4),
(133716, NULL, 'G3DSA:2.30.40.10:FF:000027', NULL, NULL, 'Guanine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(133717, NULL, 'G3DSA:1.10.150.550:FF:000002', NULL, NULL, 'Nucleoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(133718, NULL, 'G3DSA:1.10.1280.10:FF:000020', NULL, NULL, 'Tyrosinase', NULL, NULL, NULL, NULL, NULL, 4),
(133719, NULL, 'G3DSA:2.40.40.20:FF:000029', NULL, NULL, 'NADH-quinone oxidoreductase subunit G', NULL, NULL, NULL, NULL, NULL, 4),
(133720, NULL, 'G3DSA:1.10.510.10:FF:003737', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(133721, NULL, 'G3DSA:1.20.5.110:FF:000346', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133722, NULL, 'G3DSA:3.20.20.140:FF:000336', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133723, NULL, 'G3DSA:3.40.50.450:FF:000026', NULL, NULL, 'Lysine decarboxylase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(133724, NULL, 'G3DSA:3.40.50.150:FF:000043', NULL, NULL, 'probable methyltransferase PMT3', NULL, NULL, NULL, NULL, NULL, 4),
(133725, NULL, 'G3DSA:3.30.70.100:FF:000085', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(133726, NULL, 'G3DSA:2.60.120.200:FF:000391', NULL, NULL, 'Lectin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(133727, NULL, 'G3DSA:2.60.40.10:FF:005871', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133728, NULL, 'G3DSA:4.10.280.10:FF:000138', NULL, NULL, 'Basic helix-loop-helix (BHLH) DNA-binding superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(133729, NULL, 'G3DSA:3.80.10.10:FF:004293', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133730, NULL, 'G3DSA:1.20.58.480:FF:000001', NULL, NULL, 'Tryptophan 2,3-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(133731, NULL, 'G3DSA:3.40.50.10330:FF:000043', NULL, NULL, 'Ceramide kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(133732, NULL, 'G3DSA:3.50.50.60:FF:000837', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133733, NULL, 'G3DSA:1.20.58.60:FF:000765', NULL, NULL, 'AGAP009554-PA', NULL, NULL, NULL, NULL, NULL, 4),
(133734, NULL, 'G3DSA:3.40.1190.20:FF:000086', NULL, NULL, 'Fructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(133735, NULL, 'G3DSA:3.40.50.460:FF:000029', NULL, NULL, 'Phosphofructokinase, platelet b', NULL, NULL, NULL, NULL, NULL, 4),
(133736, NULL, 'G3DSA:1.10.580.10:FF:000015', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(133737, NULL, 'G3DSA:2.10.220.10:FF:000002', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(133738, NULL, 'G3DSA:2.130.10.10:FF:003269', NULL, NULL, 'YALI0B01078p', NULL, NULL, NULL, NULL, NULL, 4),
(133739, NULL, 'G3DSA:2.40.160.20:FF:000015', NULL, NULL, 'WGS project CABT00000000 data, contig 2.20', NULL, NULL, NULL, NULL, NULL, 4),
(133740, NULL, 'G3DSA:2.60.120.380:FF:000034', NULL, NULL, 'Putative calpain', NULL, NULL, NULL, NULL, NULL, 4),
(133741, NULL, 'G3DSA:2.60.120.680:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133742, NULL, 'G3DSA:2.130.10.10:FF:000998', NULL, NULL, 'VPS10 homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(133743, NULL, 'G3DSA:1.20.1280.50:FF:000063', NULL, NULL, 'F-box domain containing protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(133744, NULL, 'G3DSA:3.40.50.1010:FF:000160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133745, NULL, 'G3DSA:3.30.230.130:FF:000001', NULL, NULL, 'Cullin 4A', NULL, NULL, NULL, NULL, NULL, 4),
(133746, NULL, 'G3DSA:2.10.25.10:FF:000268', NULL, NULL, 'nephronectin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(133747, NULL, 'G3DSA:3.10.400.20:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133748, NULL, 'G3DSA:2.60.40.4100:FF:000009', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(133749, NULL, 'G3DSA:1.25.10.10:FF:002035', NULL, NULL, 'Armadillo/beta-catenin-like repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(133750, NULL, 'G3DSA:3.40.50.1360:FF:000051', NULL, NULL, 'Probable 6-phosphogluconolactonase', NULL, NULL, NULL, NULL, NULL, 4),
(133751, NULL, 'G3DSA:3.90.870.10:FF:000012', NULL, NULL, '3,4-dihydroxy-2-butanone 4-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(133752, NULL, 'G3DSA:1.10.10.2520:FF:000002', NULL, NULL, 'Cell wall hydrolase CwlJ', NULL, NULL, NULL, NULL, NULL, 4),
(133753, NULL, 'G3DSA:1.25.40.20:FF:000899', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(133754, NULL, 'G3DSA:3.60.10.10:FF:000078', NULL, NULL, 'Endonuclease/exonuclease/phosphatase family protein, putative', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(133755, NULL, 'G3DSA:3.40.50.1000:FF:000050', NULL, NULL, 'Ubiquitin-like domain-containing CTD phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(133756, NULL, 'G3DSA:3.30.160.60:FF:005781', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133757, NULL, 'G3DSA:1.25.40.10:FF:003644', NULL, NULL, 'Tetratricopeptide repeat protein 37', NULL, NULL, NULL, NULL, NULL, 4),
(133758, NULL, 'G3DSA:2.30.29.30:FF:000349', NULL, NULL, 'Transcription factor SipA3', NULL, NULL, NULL, NULL, NULL, 4),
(133759, NULL, 'G3DSA:1.10.3860.10:FF:000014', NULL, NULL, 'Amino acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(133760, NULL, 'G3DSA:3.90.70.10:FF:000260', NULL, NULL, 'Cathepsin L', NULL, NULL, NULL, NULL, NULL, 4),
(133761, NULL, 'G3DSA:3.40.50.1010:FF:000053', NULL, NULL, 'Protein MKT1', NULL, NULL, NULL, NULL, NULL, 4),
(133762, NULL, 'G3DSA:2.40.30.10:FF:000110', NULL, NULL, 'Elongation factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(133763, NULL, 'G3DSA:3.100.10.10:FF:000029', NULL, NULL, '60S ribosomal protein L18, putative', NULL, NULL, NULL, NULL, NULL, 4),
(133764, NULL, 'G3DSA:1.20.1720.10:FF:000029', NULL, NULL, 'Multidrug resistance membrane efflux protein emrB', NULL, NULL, NULL, NULL, NULL, 4),
(133765, NULL, 'G3DSA:2.60.40.10:FF:003089', NULL, NULL, 'Cell adhesion molecule, putative', NULL, NULL, NULL, NULL, NULL, 4),
(133766, NULL, 'G3DSA:1.20.1560.10:FF:000792', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133767, NULL, 'G3DSA:3.40.1190.20:FF:000193', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133768, NULL, 'G3DSA:3.60.21.10:FF:000002', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(133769, NULL, 'G3DSA:2.30.29.30:FF:000456', NULL, NULL, 'Type II inositol-3,4-bisphosphate 4-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(133770, NULL, 'G3DSA:3.30.1240.10:FF:000062', NULL, NULL, 'Cof-type HAD-IIB family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(133771, NULL, 'G3DSA:3.10.20.90:FF:000205', NULL, NULL, '2''-5''-oligoadenylate synthase-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(133772, NULL, 'G3DSA:3.40.50.300:FF:002145', NULL, NULL, 'ABC transporter (MsbA subfamily)', NULL, NULL, NULL, NULL, NULL, 4),
(133773, NULL, 'G3DSA:3.60.20.10:FF:000157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133774, NULL, 'G3DSA:3.30.70.330:FF:001553', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133775, NULL, 'G3DSA:1.20.1250.20:FF:001221', NULL, NULL, 'Multidrug resistance protein B', NULL, NULL, NULL, NULL, NULL, 4),
(133776, NULL, 'G3DSA:3.30.70.270:FF:000259', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133777, NULL, 'G3DSA:3.30.2130.30:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133778, NULL, 'G3DSA:3.40.50.300:FF:003466', NULL, NULL, 'ATPase, AAA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(133779, NULL, 'G3DSA:3.40.50.2000:FF:000850', NULL, NULL, 'Cell wall alpha-1,3-glucan synthase mok14', NULL, NULL, NULL, NULL, NULL, 4),
(133780, NULL, 'G3DSA:3.40.50.300:FF:005720', NULL, NULL, 'Endoribonuclease dcr-1', NULL, NULL, NULL, NULL, NULL, 4),
(133781, NULL, 'G3DSA:2.60.40.10:FF:005236', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133782, NULL, 'G3DSA:1.25.40.10:FF:000896', NULL, NULL, 'SEL1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(133783, NULL, 'G3DSA:3.40.50.2020:FF:000041', NULL, NULL, 'Hypoxanthine-guanine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(133784, NULL, 'G3DSA:1.20.1740.10:FF:000250', NULL, NULL, 'Glycoprotein-associated amino acid transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(133785, NULL, 'G3DSA:2.10.25.10:FF:000066', NULL, NULL, 'FAT atypical cadherin 4', NULL, NULL, NULL, NULL, NULL, 4),
(133786, NULL, 'G3DSA:3.80.10.10:FF:002729', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', NULL, NULL, NULL, NULL, NULL, 4),
(133787, NULL, 'G3DSA:3.30.160.20:FF:000233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133788, NULL, 'G3DSA:2.130.10.10:FF:003067', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit TRM82', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(133789, NULL, 'G3DSA:3.50.50.60:FF:001017', NULL, NULL, 'Heterodisulfide reductase, subunit A/methylviologen reducing hydrogenase, subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(133790, NULL, 'G3DSA:3.90.1280.20:FF:000008', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(133791, NULL, 'G3DSA:2.130.10.10:FF:003376', NULL, NULL, 'Bromodomain and WD repeat-containing DDB_G0285837', NULL, NULL, NULL, NULL, NULL, 4),
(133792, NULL, 'G3DSA:1.25.10.10:FF:001911', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133793, NULL, 'G3DSA:1.10.260.40:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133794, NULL, 'G3DSA:1.10.8.60:FF:000082', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(133795, NULL, 'G3DSA:3.30.70.1730:FF:000029', NULL, NULL, '50S ribosomal protein L10', NULL, NULL, NULL, NULL, NULL, 4),
(133796, NULL, 'G3DSA:3.30.2140.20:FF:000006', NULL, NULL, 'Arylamine N-acetyltransferase 4', NULL, NULL, NULL, NULL, NULL, 4),
(133797, NULL, 'G3DSA:3.40.630.30:FF:000236', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(133798, NULL, 'G3DSA:1.10.510.10:FF:002321', NULL, NULL, 'Serine/threonine protein kinase-54', NULL, NULL, NULL, NULL, NULL, 4),
(133799, NULL, 'G3DSA:1.10.238.110:FF:000012', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(133800, NULL, 'G3DSA:3.40.50.1950:FF:000014', NULL, NULL, 'Flavin prenyltransferase UbiX', NULL, NULL, NULL, NULL, NULL, 4),
(133801, NULL, 'G3DSA:3.80.10.10:FF:002836', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133802, NULL, 'G3DSA:3.10.450.580:FF:000021', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(133803, NULL, 'G3DSA:2.60.40.10:FF:005343', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133804, NULL, 'G3DSA:3.30.530.20:FF:000031', NULL, NULL, 'StAR-related lipid transfer protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(133805, NULL, 'G3DSA:3.30.160.60:FF:002122', NULL, NULL, 'Rgm1p', NULL, NULL, NULL, NULL, NULL, 4),
(133806, NULL, 'G3DSA:1.20.1070.10:FF:000940', NULL, NULL, 'Olfactory receptor family 1 subfamily L member 1', NULL, NULL, NULL, NULL, NULL, 4),
(133807, NULL, 'G3DSA:1.10.287.70:FF:000711', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133808, NULL, 'G3DSA:3.40.50.300:FF:003775', NULL, NULL, 'Circularly permutated Ras protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(133809, NULL, 'G3DSA:1.10.3210.10:FF:000100', NULL, NULL, 'GTP pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(133810, NULL, 'G3DSA:2.30.30.140:FF:000340', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133811, NULL, 'G3DSA:2.30.29.30:FF:000675', NULL, NULL, 'Protein expanded', NULL, NULL, NULL, NULL, NULL, 4),
(133812, NULL, 'G3DSA:3.40.50.300:FF:005383', NULL, NULL, 'Dynein heavy chain 11', NULL, NULL, NULL, NULL, NULL, 4),
(133813, NULL, 'G3DSA:3.90.70.10:FF:000153', NULL, NULL, 'NHLP family bacteriocin export ABC transporter peptidase/permease/ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(133814, NULL, 'G3DSA:1.50.10.160:FF:000009', NULL, NULL, 'P(E)-nerolidol/(E,E)-geranyl linalool synthase', NULL, NULL, NULL, NULL, NULL, 4),
(133815, NULL, 'G3DSA:3.40.50.300:FF:000228', NULL, NULL, 'dynamin-related protein 1E', NULL, NULL, NULL, NULL, NULL, 4),
(133816, NULL, 'G3DSA:1.20.1560.10:FF:000803', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133817, NULL, 'G3DSA:2.60.120.180:FF:000002', NULL, NULL, 'Endo-1,4-beta-xylanase A', NULL, NULL, NULL, NULL, NULL, 4),
(133818, NULL, 'G3DSA:2.10.90.10:FF:000008', NULL, NULL, 'Bone morphogenetic protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(133819, NULL, 'G3DSA:3.40.50.1110:FF:000111', NULL, NULL, 'Putative O-antigen related protein', NULL, NULL, NULL, NULL, NULL, 4),
(133820, NULL, 'G3DSA:3.40.50.410:FF:000290', NULL, NULL, 'X-ray repair cross-complementing protein 5-like Protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(133821, NULL, 'G3DSA:3.10.200.10:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133822, NULL, 'G3DSA:1.10.150.510:FF:000007', NULL, NULL, 'Receptor activity modifying protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(133823, NULL, 'G3DSA:2.30.30.140:FF:000014', NULL, NULL, 'Metal-response element-binding transcription factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(133824, NULL, 'G3DSA:1.50.10.150:FF:000006', NULL, NULL, 'C4-dicarboxylate transporter/malic acid transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(133825, NULL, 'G3DSA:1.25.10.10:FF:000130', NULL, NULL, 'Exportin 4', NULL, NULL, NULL, NULL, NULL, 4),
(133826, NULL, 'G3DSA:1.20.1070.10:FF:001120', NULL, NULL, 'Angiotensin II receptor, type 2', NULL, NULL, NULL, NULL, NULL, 4),
(133827, NULL, 'G3DSA:3.30.70.2890:FF:000001', NULL, NULL, 'Factor of DNA methylation 2', NULL, NULL, NULL, NULL, NULL, 4),
(133828, NULL, 'G3DSA:3.30.160.60:FF:003538', NULL, NULL, 'Si:ch73-221f6.3', NULL, NULL, NULL, NULL, NULL, 4),
(133829, NULL, 'G3DSA:1.10.1040.50:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133830, NULL, 'G3DSA:2.40.50.90:FF:000197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133831, NULL, 'G3DSA:1.25.50.20:FF:000023', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(133832, NULL, 'G3DSA:3.30.160.60:FF:001942', NULL, NULL, 'IKAROS family zinc finger 4', NULL, NULL, NULL, NULL, NULL, 4),
(133833, NULL, 'G3DSA:1.10.260.80:FF:000001', NULL, NULL, 'Haloacid dehalogenase-like hydrolase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(133834, NULL, 'G3DSA:2.60.40.10:FF:003628', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133835, NULL, 'G3DSA:1.10.510.10:FF:002012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133836, NULL, 'G3DSA:3.40.30.10:FF:000248', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(133837, NULL, 'G3DSA:3.90.190.10:FF:000437', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133838, NULL, 'G3DSA:1.10.10.790:FF:000027', NULL, NULL, 'Surp module, putative', NULL, NULL, NULL, NULL, NULL, 4),
(133839, NULL, 'G3DSA:1.25.40.10:FF:003167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133840, NULL, 'G3DSA:1.25.40.10:FF:001727', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(133841, NULL, 'G3DSA:1.20.58.1610:FF:000002', NULL, NULL, 'NADH-quinone oxidoreductase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(133842, NULL, 'G3DSA:2.130.10.10:FF:000779', NULL, NULL, 'WD repeat protein 68', NULL, NULL, NULL, NULL, NULL, 4),
(133843, NULL, 'G3DSA:2.130.10.10:FF:005630', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133844, NULL, 'G3DSA:1.10.10.10:FF:001703', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(133845, NULL, 'G3DSA:3.40.250.10:FF:000151', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133846, NULL, 'G3DSA:3.40.50.200:FF:000007', NULL, NULL, 'Subtilisin-like serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(133847, NULL, 'G3DSA:2.60.40.60:FF:000080', NULL, NULL, 'FAT atypical cadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(133848, NULL, 'G3DSA:2.30.29.30:FF:000984', NULL, NULL, 'Vacuolar protein sorting protein (Vps36), putative', NULL, NULL, NULL, NULL, NULL, 4),
(133849, NULL, 'G3DSA:3.30.300.20:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133850, NULL, 'G3DSA:1.20.58.1070:FF:000014', NULL, NULL, 'Gem-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(133851, NULL, 'G3DSA:3.90.180.10:FF:000049', NULL, NULL, 'NADPH-dependent oxidoreductase 2-alkenal reductase', NULL, NULL, NULL, NULL, NULL, 4),
(133852, NULL, 'G3DSA:3.40.720.10:FF:000035', NULL, NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase 4 (Putative)', NULL, NULL, NULL, NULL, NULL, 4),
(133853, NULL, 'G3DSA:2.130.10.130:FF:000011', NULL, NULL, 'Glycosylphosphatidylinositol specific phospholipase D1', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(133854, NULL, 'G3DSA:3.30.470.20:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133855, NULL, 'G3DSA:2.10.50.10:FF:000118', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133856, NULL, 'G3DSA:1.10.101.10:FF:000038', NULL, NULL, 'Amidase', NULL, NULL, NULL, NULL, NULL, 4),
(133857, NULL, 'G3DSA:3.30.450.20:FF:000643', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(133858, NULL, 'G3DSA:3.40.50.790:FF:000021', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133859, NULL, 'G3DSA:3.90.76.10:FF:000020', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(133860, NULL, 'G3DSA:3.30.200.20:FF:000962', NULL, NULL, 'probable L-type lectin-domain containing receptor kinase S.5', NULL, NULL, NULL, NULL, NULL, 4),
(133861, NULL, 'G3DSA:2.20.70.10:FF:000288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133862, NULL, 'G3DSA:3.40.50.720:FF:000383', NULL, NULL, 'SDR family oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(133863, NULL, 'G3DSA:2.60.40.2700:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133864, NULL, 'G3DSA:3.30.2130.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133865, NULL, 'G3DSA:2.60.40.10:FF:005562', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133866, NULL, 'G3DSA:2.60.120.260:FF:000599', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133867, NULL, 'G3DSA:1.25.40.10:FF:004948', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133868, NULL, 'G3DSA:1.25.40.850:FF:000002', NULL, NULL, 'Vacuolar protein sorting-associated protein 33A', NULL, NULL, NULL, NULL, NULL, 4),
(133869, NULL, 'G3DSA:3.30.460.10:FF:000135', NULL, NULL, 'Protein CBG18550', NULL, NULL, NULL, NULL, NULL, 4),
(133870, NULL, 'G3DSA:1.10.10.60:FF:000768', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133871, NULL, 'G3DSA:2.60.40.10:FF:001291', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(133872, NULL, 'G3DSA:1.25.40.860:FF:000005', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(133873, NULL, 'G3DSA:1.20.5.110:FF:000037', NULL, NULL, 'Putative syntaxin-71-like', NULL, NULL, NULL, NULL, NULL, 4),
(133874, NULL, 'G3DSA:2.30.110.50:FF:000001', NULL, NULL, 'Rhs element Vgr protein', NULL, NULL, NULL, NULL, NULL, 4),
(133875, NULL, 'G3DSA:1.10.4030.10:FF:000002', NULL, NULL, 'Chaperone SurA', NULL, NULL, NULL, NULL, NULL, 4),
(133876, NULL, 'G3DSA:3.40.50.410:FF:000071', NULL, NULL, 'ATP-dependent DNA helicase II subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(133877, NULL, 'G3DSA:1.10.1200.10:FF:000161', NULL, NULL, 'NonRibosomal Peptide Synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(133878, NULL, 'G3DSA:3.80.10.10:FF:003000', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133879, NULL, 'G3DSA:1.10.8.60:FF:000312', NULL, NULL, 'ATPase family associated with various cellular activities (AAA)', NULL, NULL, NULL, NULL, NULL, 4),
(133880, NULL, 'G3DSA:2.10.25.10:FF:000392', NULL, NULL, 'neurogenic locus notch homolog protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(133881, NULL, 'G3DSA:1.10.287.70:FF:000346', NULL, NULL, 'GM20581', NULL, NULL, NULL, NULL, NULL, 4),
(133882, NULL, 'G3DSA:2.60.40.2880:FF:000002', NULL, NULL, 'Putative membrane protein mmpS5', NULL, NULL, NULL, NULL, NULL, 4),
(133883, NULL, 'G3DSA:2.40.50.1060:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133884, NULL, 'G3DSA:2.60.40.10:FF:004241', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133885, NULL, 'G3DSA:3.40.50.2300:FF:001322', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133886, NULL, 'G3DSA:1.20.1250.20:FF:000378', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(133887, NULL, 'G3DSA:3.30.40.10:FF:001143', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(133888, NULL, 'G3DSA:1.10.10.10:FF:001692', NULL, NULL, 'Heat shock transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(133889, NULL, 'G3DSA:1.10.1750.10:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133890, NULL, 'G3DSA:2.60.120.290:FF:000035', NULL, NULL, 'Discoidin, CUB and LCCL domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(133891, NULL, 'G3DSA:3.30.160.20:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133892, NULL, 'G3DSA:3.30.50.10:FF:000149', NULL, NULL, 'Estrogen receptor alpha', NULL, NULL, NULL, NULL, NULL, 4),
(133893, NULL, 'G3DSA:1.20.80.10:FF:000066', NULL, NULL, 'Golgi resident protein GCP60', NULL, NULL, NULL, NULL, NULL, 4),
(133894, NULL, 'G3DSA:2.130.10.10:FF:003595', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133895, NULL, 'G3DSA:3.40.50.720:FF:000692', NULL, NULL, 'Quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(133896, NULL, 'G3DSA:1.10.565.10:FF:000137', NULL, NULL, 'RAR related orphan receptor C', NULL, NULL, NULL, NULL, NULL, 4),
(133897, NULL, 'G3DSA:1.10.4160.10:FF:000028', NULL, NULL, 'Uracil transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(133898, NULL, 'G3DSA:3.90.180.10:FF:000139', NULL, NULL, 'Quinone oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(133899, NULL, 'G3DSA:2.40.50.1070:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133900, NULL, 'G3DSA:1.20.1250.20:FF:001002', NULL, NULL, 'Solute carrier family 22 member 10', NULL, NULL, NULL, NULL, NULL, 4),
(133901, NULL, 'G3DSA:1.10.8.10:FF:000230', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133902, NULL, 'G3DSA:3.40.630.30:FF:000455', NULL, NULL, 'GCN5-related N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(133903, NULL, 'G3DSA:3.40.50.2300:FF:000833', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133904, NULL, 'G3DSA:1.10.275.10:FF:000020', NULL, NULL, 'Adenylosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(133905, NULL, 'G3DSA:3.40.50.410:FF:000380', NULL, NULL, 'Collagen alpha 3 chain type VI', NULL, NULL, NULL, NULL, NULL, 4),
(133906, NULL, 'G3DSA:3.30.830.10:FF:000040', NULL, NULL, 'Stromal processing peptidase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(133907, NULL, 'G3DSA:3.20.20.190:FF:000093', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(133908, NULL, 'G3DSA:2.10.10.10:FF:000009', NULL, NULL, 'Epididymal sperm-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(133909, NULL, 'G3DSA:3.40.50.150:FF:000150', NULL, NULL, 'methyltransferase-like protein 13 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(133910, NULL, 'G3DSA:3.30.160.60:FF:003847', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133911, NULL, 'G3DSA:3.30.70.330:FF:001025', NULL, NULL, 'Tag-262 protein', NULL, NULL, NULL, NULL, NULL, 4),
(133912, NULL, 'G3DSA:2.110.10.10:FF:000004', NULL, NULL, '72 kDa type IV collagenase', NULL, NULL, NULL, NULL, NULL, 4),
(133913, NULL, 'G3DSA:3.40.1110.10:FF:000342', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133914, NULL, 'G3DSA:3.10.20.90:FF:000424', NULL, NULL, 'Autophagy protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(133915, NULL, 'G3DSA:1.10.510.10:FF:001293', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(133916, NULL, 'G3DSA:3.90.1150.10:FF:000378', NULL, NULL, 'Glycine cleavage system P protein', NULL, NULL, NULL, NULL, NULL, 4),
(133917, NULL, 'G3DSA:3.30.40.10:FF:000980', NULL, NULL, 'Transcriptional regulator of yeast form adherence 3', NULL, NULL, NULL, NULL, NULL, 4),
(133918, NULL, 'G3DSA:1.20.58.2220:FF:000033', NULL, NULL, 'CYtoKinesis defect', NULL, NULL, NULL, NULL, NULL, 4),
(133919, NULL, 'G3DSA:2.60.40.10:FF:001184', NULL, NULL, 'Ephrin type-A receptor 6', NULL, NULL, NULL, NULL, NULL, 4),
(133920, NULL, 'G3DSA:3.40.50.620:FF:000690', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(133921, NULL, 'G3DSA:3.40.50.1260:FF:000021', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(133922, NULL, 'G3DSA:3.30.160.60:FF:003864', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133923, NULL, 'G3DSA:3.90.1480.20:FF:000006', NULL, NULL, 'ST3 beta-galactoside alpha-2,3-sialyltransferase 5', NULL, NULL, NULL, NULL, NULL, 4),
(133924, NULL, 'G3DSA:1.10.560.10:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133925, NULL, 'G3DSA:1.10.10.10:FF:001719', NULL, NULL, 'Disease resistance protein RGA4', NULL, NULL, NULL, NULL, NULL, 4),
(133926, NULL, 'G3DSA:1.25.10.10:FF:001546', NULL, NULL, 'Cell differentiation family, Rcd1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(133927, NULL, 'G3DSA:2.130.10.10:FF:000503', NULL, NULL, 'Glucose repression regulatory protein TUP1', NULL, NULL, NULL, NULL, NULL, 4),
(133928, NULL, 'G3DSA:3.40.920.10:FF:000016', NULL, NULL, 'Sulfite reductase [NADPH] flavoprotein component, putative', NULL, NULL, NULL, NULL, NULL, 4),
(133929, NULL, 'G3DSA:2.130.10.10:FF:001487', NULL, NULL, 'WD repeat-containing protein 48 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(133930, NULL, 'G3DSA:1.10.10.10:FF:001383', NULL, NULL, 'Forkhead box O4', NULL, NULL, NULL, NULL, NULL, 4),
(133931, NULL, 'G3DSA:1.20.1560.10:FF:000483', NULL, NULL, 'ABC transporter (ATP-binding protein) homolog ygaD', NULL, NULL, NULL, NULL, NULL, 4),
(133932, NULL, 'G3DSA:2.40.10.380:FF:000001', NULL, NULL, 'Tail sheath monomer', NULL, NULL, NULL, NULL, NULL, 4),
(133933, NULL, 'G3DSA:1.50.40.10:FF:000337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133934, NULL, 'G3DSA:3.30.70.330:FF:001334', NULL, NULL, 'Protein CBR-UNC-26', NULL, NULL, NULL, NULL, NULL, 4),
(133935, NULL, 'G3DSA:2.60.40.10:FF:002324', NULL, NULL, 'Lachesin', NULL, NULL, NULL, NULL, NULL, 4),
(133936, NULL, 'G3DSA:3.40.930.10:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133937, NULL, 'G3DSA:1.25.40.950:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133938, NULL, 'G3DSA:3.40.50.150:FF:001678', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133939, NULL, 'G3DSA:2.130.10.10:FF:003286', NULL, NULL, 'phospholipase A-2-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(133940, NULL, 'G3DSA:3.40.50.300:FF:007491', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133941, NULL, 'G3DSA:3.90.25.10:FF:000077', NULL, NULL, 'GDP-mannose 4,6 dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(133942, NULL, 'G3DSA:1.10.287.130:FF:000235', NULL, NULL, 'Regulatory components of sensory transduction system', NULL, NULL, NULL, NULL, NULL, 4),
(133943, NULL, 'G3DSA:2.60.120.920:FF:000151', NULL, NULL, 'Si:dkey-269o24.1', NULL, NULL, NULL, NULL, NULL, 4),
(133944, NULL, 'G3DSA:3.40.50.300:FF:007827', NULL, NULL, 'ABC transporter G family member 34', NULL, NULL, NULL, NULL, NULL, 4),
(133945, NULL, 'G3DSA:3.40.50.10140:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133946, NULL, 'G3DSA:3.40.50.300:FF:002510', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(133947, NULL, 'G3DSA:3.20.20.120:FF:000021', NULL, NULL, 'Dipeptide epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(133948, NULL, 'G3DSA:3.40.50.1700:FF:000046', NULL, NULL, 'Glucan 1,4-beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(133949, NULL, 'G3DSA:1.10.10.10:FF:001922', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133950, NULL, 'G3DSA:3.40.800.20:FF:000050', NULL, NULL, 'Histone deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(133951, NULL, 'G3DSA:2.60.40.10:FF:005326', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133952, NULL, 'G3DSA:3.30.160.60:FF:002105', NULL, NULL, 'zinc finger protein 62 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(133953, NULL, 'G3DSA:3.10.260.10:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133954, NULL, 'G3DSA:3.50.30.30:FF:000158', NULL, NULL, 'Glutamate carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(133955, NULL, 'G3DSA:2.130.10.10:FF:002111', NULL, NULL, 'Lethal (3) 72Dn, isoform B', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(133956, NULL, 'G3DSA:2.40.30.10:FF:000071', NULL, NULL, 'Elongation factor Tu', NULL, NULL, NULL, NULL, NULL, 4),
(133957, NULL, 'G3DSA:3.40.50.150:FF:001785', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133958, NULL, 'G3DSA:2.60.220.30:FF:000002', NULL, NULL, 'Ankyrin-3 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(133959, NULL, 'G3DSA:3.30.70.1230:FF:000104', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(133960, NULL, 'G3DSA:1.20.58.60:FF:000456', NULL, NULL, 'Dystrophin', NULL, NULL, NULL, NULL, NULL, 4),
(133961, NULL, 'G3DSA:3.90.79.20:FF:000018', NULL, NULL, 'NADH diphosphatase (Pyrophosphatase), putative', NULL, NULL, NULL, NULL, NULL, 4),
(133962, NULL, 'G3DSA:1.20.5.170:FF:000252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133963, NULL, 'G3DSA:3.40.50.10330:FF:000026', NULL, NULL, 'NAD+ kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(133964, NULL, 'G3DSA:3.30.559.30:FF:000100', NULL, NULL, 'Hydroxamate-type ferrichrome siderophore peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(133965, NULL, 'G3DSA:1.25.40.1030:FF:000008', NULL, NULL, 'Protein transport protein sec16', NULL, NULL, NULL, NULL, NULL, 4),
(133966, NULL, 'G3DSA:3.40.50.10310:FF:000020', NULL, NULL, 'Creatininase', NULL, NULL, NULL, NULL, NULL, 4),
(133967, NULL, 'G3DSA:3.30.70.330:FF:003133', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133968, NULL, 'G3DSA:2.130.10.10:FF:005293', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133969, NULL, 'G3DSA:3.30.420.10:FF:000503', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133970, NULL, 'G3DSA:3.30.390.30:FF:000045', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(133971, NULL, 'G3DSA:1.10.510.10:FF:003428', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133972, NULL, 'G3DSA:3.30.160.60:FF:004011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133973, NULL, 'G3DSA:2.10.70.10:FF:000120', NULL, NULL, 'Coagulation factor XIII B chain', NULL, NULL, NULL, NULL, NULL, 4),
(133974, NULL, 'G3DSA:1.10.8.720:FF:000003', NULL, NULL, 'Cytoplasmic dynein heavy chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(133975, NULL, 'G3DSA:3.40.50.10610:FF:000003', NULL, NULL, 'Curli production assembly/transport component CsgG', NULL, NULL, NULL, NULL, NULL, 4),
(133976, NULL, 'G3DSA:3.40.50.150:FF:001605', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133977, NULL, 'G3DSA:2.60.220.50:FF:000008', NULL, NULL, 'Adhesion G-protein coupled receptor D1', NULL, NULL, NULL, NULL, NULL, 4),
(133978, NULL, 'G3DSA:2.60.40.10:FF:003319', NULL, NULL, 'Immunoglobulin superfamily member 3', NULL, NULL, NULL, NULL, NULL, 4),
(133979, NULL, 'G3DSA:3.40.50.300:FF:001982', NULL, NULL, 'Serine protease/ABC transporter B family protein tagC', NULL, NULL, NULL, NULL, NULL, 4),
(133980, NULL, 'G3DSA:2.40.50.140:FF:000959', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(133981, NULL, 'G3DSA:1.10.390.10:FF:000085', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133982, NULL, 'G3DSA:3.30.310.10:FF:000040', NULL, NULL, 'TATA box binding protein (TBP)-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(133983, NULL, 'G3DSA:3.40.50.1820:FF:000099', NULL, NULL, 'Homoserine O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(133984, NULL, 'G3DSA:1.20.1070.10:FF:000631', NULL, NULL, 'Dopamine receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(133985, NULL, 'G3DSA:1.20.920.10:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(133986, NULL, 'G3DSA:3.90.45.10:FF:000005', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(133987, NULL, 'G3DSA:2.40.128.110:FF:000002', NULL, NULL, 'Polyisoprenoid-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(133988, NULL, 'G3DSA:3.20.20.140:FF:000027', NULL, NULL, 'putative deoxyribonuclease TATDN2', NULL, NULL, NULL, NULL, NULL, 4),
(133989, NULL, 'G3DSA:3.10.400.10:FF:000001', NULL, NULL, 'bifunctional 3''-phosphoadenosine 5''-phosphosulfate synthase 1', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(133990, NULL, 'G3DSA:1.10.8.10:FF:000235', NULL, NULL, 'Plant UBX domain-containing protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(133991, NULL, 'G3DSA:3.30.70.330:FF:001244', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(133992, NULL, 'G3DSA:3.40.50.300:FF:002162', NULL, NULL, 'Thymidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(133993, NULL, 'G3DSA:1.50.10.10:FF:000167', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(133994, NULL, 'G3DSA:2.60.120.10:FF:000045', NULL, NULL, 'Cysteine dioxygenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(133995, NULL, 'G3DSA:3.30.160.20:FF:000087', NULL, NULL, 'Staufen, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(133996, NULL, 'G3DSA:1.10.540.10:FF:000041', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(133997, NULL, 'G3DSA:3.40.50.300:FF:005692', NULL, NULL, 'RNA guanylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(133998, NULL, 'G3DSA:1.10.287.70:FF:000672', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(133999, NULL, 'G3DSA:1.10.390.10:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134000, NULL, 'G3DSA:1.25.40.660:FF:000024', NULL, NULL, 'Vacuolar protein sorting35 putative', NULL, NULL, NULL, NULL, NULL, 4),
(134001, NULL, 'G3DSA:3.40.50.360:FF:000134', NULL, NULL, 'Putative reductase', NULL, NULL, NULL, NULL, NULL, 4),
(134002, NULL, 'G3DSA:4.10.640.10:FF:000003', NULL, NULL, '30S ribosomal protein S18', NULL, NULL, NULL, NULL, NULL, 4),
(134003, NULL, 'G3DSA:1.10.565.10:FF:000121', NULL, NULL, 'Nuclear receptor', NULL, NULL, NULL, NULL, NULL, 4),
(134004, NULL, 'G3DSA:1.10.3080.10:FF:000044', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(134005, NULL, 'G3DSA:3.30.365.10:FF:000054', NULL, NULL, 'xanthine dehydrogenase/oxidase-like', NULL, NULL, NULL, NULL, NULL, 4),
(134006, NULL, 'G3DSA:3.10.20.90:FF:000222', NULL, NULL, 'Polyubiquitin 5', NULL, NULL, NULL, NULL, NULL, 4),
(134007, NULL, 'G3DSA:2.10.25.10:FF:000605', NULL, NULL, 'Crumbs cell polarity complex component 2', NULL, NULL, NULL, NULL, NULL, 4),
(134008, NULL, 'G3DSA:3.40.1190.20:FF:000114', NULL, NULL, 'ADP-dependent (S)-NAD(P)H-hydrate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(134009, NULL, 'G3DSA:3.90.105.20:FF:000013', NULL, NULL, 'Ribosome assembly factor mrt4', NULL, NULL, NULL, NULL, NULL, 4),
(134010, NULL, 'G3DSA:3.60.40.10:FF:000383', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134011, NULL, 'G3DSA:3.30.70.940:FF:000011', NULL, NULL, 'Transcription elongation factor SPT5', NULL, NULL, NULL, NULL, NULL, 4),
(134012, NULL, 'G3DSA:3.30.1330.40:FF:000050', NULL, NULL, 'Diphthine--ammonia ligase', NULL, NULL, NULL, NULL, NULL, 4),
(134013, NULL, 'G3DSA:1.20.140.10:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134014, NULL, 'G3DSA:1.20.58.390:FF:000300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134015, NULL, 'G3DSA:3.60.21.10:FF:000221', NULL, NULL, 'Sphingomyelin phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(134016, NULL, 'G3DSA:3.40.50.790:FF:000004', NULL, NULL, 'Ribosomal L1 domain-containing 1-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(134017, NULL, 'G3DSA:3.40.720.10:FF:000018', NULL, NULL, 'Putative GPI ethanolamine phosphate transferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(134018, NULL, 'G3DSA:3.30.160.60:FF:004230', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134019, NULL, 'G3DSA:1.10.238.20:FF:000044', NULL, NULL, 'General odorant-binding protein 57c', NULL, NULL, NULL, NULL, NULL, 4),
(134020, NULL, 'G3DSA:2.130.10.10:FF:005854', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(134021, NULL, 'G3DSA:2.30.30.380:FF:000035', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(134022, NULL, 'G3DSA:1.10.287.70:FF:000801', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134023, NULL, 'G3DSA:3.40.710.10:FF:000063', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(134024, NULL, 'G3DSA:1.10.10.60:FF:000987', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134025, NULL, 'G3DSA:3.10.440.10:FF:000003', NULL, NULL, '60S ribosomal subunit protein L31, putative', NULL, NULL, NULL, NULL, NULL, 4),
(134026, NULL, 'G3DSA:1.20.920.10:FF:000181', NULL, NULL, 'Bromodomain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(134027, NULL, 'G3DSA:3.80.10.10:FF:000931', NULL, NULL, 'MDIS1-interacting receptor like kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(134028, NULL, 'G3DSA:3.30.310.10:FF:000023', NULL, NULL, 'TATA-box-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(134029, NULL, 'G3DSA:3.40.50.150:FF:001459', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134030, NULL, 'G3DSA:1.10.510.10:FF:003647', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134031, NULL, 'G3DSA:3.30.1330.20:FF:000015', NULL, NULL, 'Cell division protein FtsZ', NULL, NULL, NULL, NULL, NULL, 4),
(134032, NULL, 'G3DSA:3.30.9.10:FF:000194', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(134033, NULL, 'G3DSA:2.20.25.10:FF:000060', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(134034, NULL, 'G3DSA:3.30.1330.30:FF:000018', NULL, NULL, 'growth arrest and DNA damage-inducible protein GADD45 gamma', NULL, NULL, NULL, NULL, NULL, 4),
(134035, NULL, 'G3DSA:1.20.1050.10:FF:000068', NULL, NULL, 'Putative GST6 protein', NULL, NULL, NULL, NULL, NULL, 4),
(134036, NULL, 'G3DSA:2.40.50.140:FF:001106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134037, NULL, 'G3DSA:3.30.559.10:FF:000246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134038, NULL, 'G3DSA:3.30.1370.210:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134039, NULL, 'G3DSA:3.30.70.330:FF:001008', NULL, NULL, 'Unplaced genomic scaffold supercont2.9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(134040, NULL, 'G3DSA:1.20.1270.60:FF:000150', NULL, NULL, 'Arp2/3 complex-activating protein ricka, putative', NULL, NULL, NULL, NULL, NULL, 4),
(134041, NULL, 'G3DSA:2.60.40.10:FF:003409', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134042, NULL, 'G3DSA:4.10.1000.10:FF:000065', NULL, NULL, 'Cysteine three histidine 1', NULL, NULL, NULL, NULL, NULL, 4),
(134043, NULL, 'G3DSA:3.30.160.60:FF:001739', NULL, NULL, 'zinc finger protein 133 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(134044, NULL, 'G3DSA:3.30.70.330:FF:001227', NULL, NULL, 'glycine-rich RNA-binding protein 4, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(134045, NULL, 'G3DSA:3.80.10.10:FF:001201', NULL, NULL, 'mRNA_export_factor_MEX67', NULL, NULL, NULL, NULL, NULL, 4),
(134046, NULL, 'G3DSA:3.40.50.10190:FF:000203', NULL, NULL, 'Replication factor C subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(134047, NULL, 'G3DSA:2.40.50.700:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134048, NULL, 'G3DSA:3.40.630.30:FF:000253', NULL, NULL, 'GD19407', NULL, NULL, NULL, NULL, NULL, 4),
(134049, NULL, 'G3DSA:2.110.10.10:FF:000021', NULL, NULL, 'Matrix metallopeptidase 19', NULL, NULL, NULL, NULL, NULL, 4),
(134050, NULL, 'G3DSA:3.80.10.10:FF:004309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134051, NULL, 'G3DSA:2.60.40.10:FF:005545', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134052, NULL, 'G3DSA:2.40.40.20:FF:000024', NULL, NULL, 'AAA family ATPase, CDC48 subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(134053, NULL, 'G3DSA:3.40.50.150:FF:001824', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134054, NULL, 'G3DSA:1.10.472.80:FF:000206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134055, NULL, 'G3DSA:2.40.40.10:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134056, NULL, 'G3DSA:3.30.70.1320:FF:000013', NULL, NULL, 'Efflux pump membrane transporter', NULL, NULL, NULL, NULL, NULL, 4),
(134057, NULL, 'G3DSA:1.10.287.110:FF:000313', NULL, NULL, 'YALI0C05819p', NULL, NULL, NULL, NULL, NULL, 4),
(134058, NULL, 'G3DSA:1.10.238.10:FF:000041', NULL, NULL, 'DCN1-like protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(134059, NULL, 'G3DSA:3.30.559.30:FF:000010', NULL, NULL, 'Nonribosomal peptide synthase Pes1', NULL, NULL, NULL, NULL, NULL, 4),
(134060, NULL, 'G3DSA:2.60.40.10:FF:006034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134061, NULL, 'G3DSA:3.30.420.10:FF:000161', NULL, NULL, 'Protein RISC-INTERACTING CLEARING 3''-5'' EXORIBONUCLEASE 2', NULL, NULL, NULL, NULL, NULL, 4),
(134062, NULL, 'G3DSA:3.10.580.10:FF:000075', NULL, NULL, 'CBS domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(134063, NULL, 'G3DSA:1.20.120.1080:FF:000053', NULL, NULL, 'ATP-dependent helicase hrpA', NULL, NULL, NULL, NULL, NULL, 4),
(134064, NULL, 'G3DSA:2.30.30.140:FF:000121', NULL, NULL, 'Pre-mRNA-splicing factor 38B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(134065, NULL, 'G3DSA:1.25.10.10:FF:003339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134066, NULL, 'G3DSA:2.130.10.10:FF:003741', NULL, NULL, 'KIN14B-interacting protein At4g14310', NULL, NULL, NULL, NULL, NULL, 4),
(134067, NULL, 'G3DSA:2.40.50.40:FF:000098', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(134068, NULL, 'G3DSA:2.30.29.30:FF:000658', NULL, NULL, 'SHC-transforming protein homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(134069, NULL, 'G3DSA:1.10.510.10:FF:003956', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134070, NULL, 'G3DSA:1.10.240.10:FF:000001', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(134071, NULL, 'G3DSA:3.30.70.140:FF:000001', NULL, NULL, 'Aspartate carbamoyltransferase regulatory chain', NULL, NULL, NULL, NULL, NULL, 4),
(134072, NULL, 'G3DSA:3.90.180.10:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134073, NULL, 'G3DSA:3.30.70.150:FF:000004', NULL, NULL, 'Ribulose bisphosphate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(134074, NULL, 'G3DSA:1.20.1250.20:FF:002295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134075, NULL, 'G3DSA:3.40.50.800:FF:000081', NULL, NULL, 'Prolyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(134076, NULL, 'G3DSA:1.10.238.10:FF:000260', NULL, NULL, 'Protein S100-A13', NULL, NULL, NULL, NULL, NULL, 4),
(134077, NULL, 'G3DSA:3.40.30.10:FF:000613', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134078, NULL, 'G3DSA:3.30.429.10:FF:000006', NULL, NULL, '5-carboxymethyl-2-hydroxymuconate delta isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(134079, NULL, 'G3DSA:4.10.240.10:FF:000029', NULL, NULL, 'Transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(134080, NULL, 'G3DSA:3.40.50.300:FF:003556', NULL, NULL, 'NRAS proto-oncogene, GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(134081, NULL, 'G3DSA:1.10.510.10:FF:000213', NULL, NULL, 'STE20-related kinase adapter protein alpha isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(134082, NULL, 'G3DSA:3.10.20.90:FF:000531', NULL, NULL, 'Autophagy-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(134083, NULL, 'G3DSA:3.40.50.620:FF:000555', NULL, NULL, 'YALI0D25564p', NULL, NULL, NULL, NULL, NULL, 4),
(134084, NULL, 'G3DSA:1.20.1070.10:FF:001103', NULL, NULL, 'Encephalopsin', NULL, NULL, NULL, NULL, NULL, 4),
(134085, NULL, 'G3DSA:3.40.50.300:FF:007518', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(134086, NULL, 'G3DSA:1.25.40.10:FF:004010', NULL, NULL, 'Coatomer protein complex, subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(134087, NULL, 'G3DSA:3.20.20.190:FF:000121', NULL, NULL, 'FI16509p1', NULL, NULL, NULL, NULL, NULL, 4),
(134088, NULL, 'G3DSA:1.10.150.850:FF:000002', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(134089, NULL, 'G3DSA:1.10.510.10:FF:003086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134090, NULL, 'G3DSA:2.30.42.10:FF:000649', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134091, NULL, 'G3DSA:3.80.10.10:FF:001420', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(134092, NULL, 'G3DSA:1.20.58.60:FF:000782', NULL, NULL, 'Dystonin', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(134093, NULL, 'G3DSA:3.40.630.30:FF:000562', NULL, NULL, 'Gll0241 protein', NULL, NULL, NULL, NULL, NULL, 4),
(134094, NULL, 'G3DSA:3.40.30.10:FF:000265', NULL, NULL, 'Glutathione S-transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(134095, NULL, 'G3DSA:3.40.50.300:FF:003247', NULL, NULL, 'ATP-dependent Clp protease ATP-binding subunit clpX-like, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(134096, NULL, 'G3DSA:3.40.630.30:FF:000601', NULL, NULL, 'Glucosamine-phosphate N-acetyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(134097, NULL, 'G3DSA:3.30.505.10:FF:000043', NULL, NULL, 'SH3 domain binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(134098, NULL, 'G3DSA:1.10.1280.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134099, NULL, 'G3DSA:3.40.5.50:FF:000006', NULL, NULL, 'AGAP010018-PA', NULL, NULL, NULL, NULL, NULL, 4),
(134100, NULL, 'G3DSA:3.30.40.10:FF:001008', NULL, NULL, 'Chromatin modification-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(134101, NULL, 'G3DSA:3.20.20.140:FF:000246', NULL, NULL, 'Cytosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(134102, NULL, 'G3DSA:3.30.420.10:FF:000470', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134103, NULL, 'G3DSA:3.40.50.1390:FF:000003', NULL, NULL, 'DNA resolvase', NULL, NULL, NULL, NULL, NULL, 4),
(134104, NULL, 'G3DSA:3.90.105.10:FF:000010', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(134105, NULL, 'G3DSA:1.10.510.10:FF:003395', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134106, NULL, 'G3DSA:2.60.40.10:FF:001493', NULL, NULL, 'KETtiN (Drosophila actin-binding) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(134107, NULL, 'G3DSA:3.40.50.1820:FF:000560', NULL, NULL, 'Glutactin', NULL, NULL, NULL, NULL, NULL, 4),
(134108, NULL, 'G3DSA:1.20.58.150:FF:000009', NULL, NULL, 'Putative clathrin assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(134109, NULL, 'G3DSA:3.80.10.10:FF:000622', NULL, NULL, 'NLR family, pyrin domain containing 1B, PWK/PhJ specific, allele 1', NULL, NULL, NULL, NULL, NULL, 4),
(134110, NULL, 'G3DSA:1.10.238.10:FF:000602', NULL, NULL, 'Calcium-binding protein CML24', NULL, NULL, NULL, NULL, NULL, 4),
(134111, NULL, 'G3DSA:3.80.10.10:FF:001111', NULL, NULL, 'Leucine rich repeat and phosphatase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(134112, NULL, 'G3DSA:1.20.1560.10:FF:000713', NULL, NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 8', NULL, NULL, NULL, NULL, NULL, 4),
(134113, NULL, 'G3DSA:1.20.1070.10:FF:001210', NULL, NULL, 'Olfactory receptor 51J1', NULL, NULL, NULL, NULL, NULL, 4),
(134114, NULL, 'G3DSA:1.20.1070.10:FF:002194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134115, NULL, 'G3DSA:1.20.58.2140:FF:000009', NULL, NULL, 'DNA-binding protein translin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(134116, NULL, 'G3DSA:3.20.20.80:FF:000825', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134117, NULL, 'G3DSA:1.20.120.1760:FF:000026', NULL, NULL, 'ethanolaminephosphotransferase 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(134118, NULL, 'G3DSA:1.25.40.20:FF:000067', NULL, NULL, 'ankyrin repeat domain-containing protein 17 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(134119, NULL, 'G3DSA:3.40.50.360:FF:000117', NULL, NULL, 'Rubredoxin:oxygen/nitric oxide oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(134120, NULL, 'G3DSA:1.20.1070.10:FF:000592', NULL, NULL, 'Platelet-activating factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(134121, NULL, 'G3DSA:2.10.25.10:FF:000521', NULL, NULL, 'Neurogenic locus notch protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(134122, NULL, 'G3DSA:3.30.450.20:FF:000660', NULL, NULL, 'Diguanylate cyclase with PAS/PAC sensor', NULL, NULL, NULL, NULL, NULL, 4),
(134123, NULL, 'G3DSA:2.170.210.10:FF:000003', NULL, NULL, 'DNA repair protein XRCC4', NULL, NULL, NULL, NULL, NULL, 4),
(134124, NULL, 'G3DSA:3.30.160.60:FF:000323', NULL, NULL, 'zinc finger protein AEBP2', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(134125, NULL, 'G3DSA:3.30.160.60:FF:005646', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134126, NULL, 'G3DSA:2.30.29.30:FF:001153', NULL, NULL, 'Ras association (RalGDS/AF-6) and pleckstrin homology domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(134127, NULL, 'G3DSA:1.25.40.10:FF:002695', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134128, NULL, 'G3DSA:3.30.420.10:FF:000722', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134129, NULL, 'G3DSA:2.60.120.200:FF:000733', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134130, NULL, 'G3DSA:1.20.1410.10:FF:000040', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(134131, NULL, 'G3DSA:3.60.40.10:FF:000361', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(134132, NULL, 'G3DSA:4.10.410.10:FF:000065', NULL, NULL, 'Hedgehog interacting protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(134133, NULL, 'G3DSA:3.30.160.380:FF:000008', NULL, NULL, 'DsRNA-specific nuclease dicer and related ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(134134, NULL, 'G3DSA:2.40.50.150:FF:000024', NULL, NULL, 'DNA-directed RNA polymerase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(134135, NULL, 'G3DSA:3.40.50.300:FF:007597', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(134136, NULL, 'G3DSA:2.30.42.10:FF:000088', NULL, NULL, 'MAGUK p55 subfamily member 5', NULL, NULL, NULL, NULL, NULL, 4),
(134137, NULL, 'G3DSA:3.40.50.12160:FF:000030', NULL, NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(134138, NULL, 'G3DSA:1.25.10.70:FF:000007', NULL, NULL, 'Nup188p', NULL, NULL, NULL, NULL, NULL, 4),
(134139, NULL, 'G3DSA:1.10.10.10:FF:001613', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134140, NULL, 'G3DSA:1.10.3730.10:FF:000010', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(134141, NULL, 'G3DSA:2.60.40.10:FF:003544', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134142, NULL, 'G3DSA:3.40.50.300:FF:001667', NULL, NULL, 'Rab family gtpase', NULL, NULL, NULL, NULL, NULL, 4),
(134143, NULL, 'G3DSA:2.130.10.10:FF:005068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134144, NULL, 'G3DSA:3.30.1490.20:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134145, NULL, 'G3DSA:3.20.20.70:FF:000345', NULL, NULL, 'Orotidine 5''-phosphate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(134146, NULL, 'G3DSA:3.40.50.2300:FF:001305', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134147, NULL, 'G3DSA:2.40.160.210:FF:000001', NULL, NULL, 'Acyl-CoA thioesterase II', NULL, NULL, NULL, NULL, NULL, 4),
(134148, NULL, 'G3DSA:3.90.640.90:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134149, NULL, 'G3DSA:3.30.70.940:FF:000027', NULL, NULL, 'KOW motif family protein', NULL, NULL, NULL, NULL, NULL, 4),
(134150, NULL, 'G3DSA:3.40.50.150:FF:001369', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134151, NULL, 'G3DSA:1.25.40.10:FF:003313', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g37170', NULL, NULL, NULL, NULL, NULL, 4),
(134152, NULL, 'G3DSA:1.25.40.270:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134153, NULL, 'G3DSA:3.40.50.2300:FF:001092', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134154, NULL, 'G3DSA:1.25.10.50:FF:000001', NULL, NULL, 'DNA mismatch repair protein HSM3', NULL, NULL, NULL, NULL, NULL, 4),
(134155, NULL, 'G3DSA:2.60.120.10:FF:000062', NULL, NULL, 'Lysophospholipase NTE1', NULL, NULL, NULL, NULL, NULL, 4),
(134156, NULL, 'G3DSA:3.40.50.300:FF:007608', NULL, NULL, 'ABC Transporter family', NULL, NULL, NULL, NULL, NULL, 4),
(134157, NULL, 'G3DSA:2.60.40.1390:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134158, NULL, 'G3DSA:2.130.10.10:FF:001268', NULL, NULL, 'Protein ROOT INITIATION DEFECTIVE 3', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(134159, NULL, 'G3DSA:1.20.120.20:FF:000027', NULL, NULL, 'Elastin microfibril interfacer 1', NULL, NULL, NULL, NULL, NULL, 4),
(134160, NULL, 'G3DSA:1.25.40.10:FF:001711', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g31400, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(134161, NULL, 'G3DSA:3.40.50.720:FF:002384', NULL, NULL, 'Probable oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(134162, NULL, 'G3DSA:2.60.40.10:FF:002015', NULL, NULL, 'Jitterbug, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(134163, NULL, 'G3DSA:3.40.710.10:FF:000085', NULL, NULL, 'Penicillin-binding protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(134164, NULL, 'G3DSA:3.90.1420.10:FF:000011', NULL, NULL, 'Plastid transcriptionally active 14', NULL, NULL, NULL, NULL, NULL, 4),
(134165, NULL, 'G3DSA:3.20.20.105:FF:000010', NULL, NULL, 'Queuine tRNA-ribosyltransferase accessory subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(134166, NULL, 'G3DSA:1.25.10.10:FF:001563', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134167, NULL, 'G3DSA:1.25.40.250:FF:000002', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit K', NULL, NULL, NULL, NULL, NULL, 4),
(134168, NULL, 'G3DSA:1.20.1250.20:FF:000693', NULL, NULL, 'AmpG permease', NULL, NULL, NULL, NULL, NULL, 4),
(134169, NULL, 'G3DSA:1.20.58.2220:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134170, NULL, 'G3DSA:1.20.1070.10:FF:000737', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134171, NULL, 'G3DSA:1.20.1070.10:FF:000485', NULL, NULL, 'alpha-2A adrenergic receptor', NULL, NULL, NULL, NULL, NULL, 4),
(134172, NULL, 'G3DSA:3.40.50.720:FF:002529', NULL, NULL, 'Methylenetetrahydrofolate dehydrogenase (NADP+ dependent) 1 like', NULL, NULL, NULL, NULL, NULL, 4),
(134173, NULL, 'G3DSA:1.10.510.10:FF:001938', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134174, NULL, 'G3DSA:1.10.10.200:FF:000008', NULL, NULL, 'Probable transcriptional regulatory protein HP_0162', NULL, NULL, NULL, NULL, NULL, 4),
(134175, NULL, 'G3DSA:3.30.60.30:FF:000150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134176, NULL, 'G3DSA:3.90.190.10:FF:000095', NULL, NULL, 'Unplaced genomic scaffold supercont1.9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(134177, NULL, 'G3DSA:1.25.40.10:FF:003728', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134178, NULL, 'G3DSA:3.30.342.10:FF:000029', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(134179, NULL, 'G3DSA:3.40.50.300:FF:007182', NULL, NULL, 'Shikimate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(134180, NULL, 'G3DSA:3.80.10.10:FF:002494', NULL, NULL, 'GPR insulin like receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(134181, NULL, 'G3DSA:1.20.140.10:FF:000132', NULL, NULL, 'Acyl-CoA dehydrogenase short chain', NULL, NULL, NULL, NULL, NULL, 4),
(134182, NULL, 'G3DSA:1.10.630.10:FF:000469', NULL, NULL, 'Putative cytochrome P450 superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(134183, NULL, 'G3DSA:3.40.50.150:FF:001476', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134184, NULL, 'G3DSA:3.30.365.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134185, NULL, 'G3DSA:1.10.3380.10:FF:000011', NULL, NULL, 'Translocation protein SEC63', NULL, NULL, NULL, NULL, NULL, 4),
(134186, NULL, 'G3DSA:2.40.50.140:FF:001022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134187, NULL, 'G3DSA:2.60.40.10:FF:005197', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134188, NULL, 'G3DSA:1.20.120.450:FF:000003', NULL, NULL, 'TIGR03084 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(134189, NULL, 'G3DSA:1.10.10.10:FF:000995', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(134190, NULL, 'G3DSA:2.130.10.30:FF:000083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134191, NULL, 'G3DSA:2.120.10.80:FF:000120', NULL, NULL, 'kelch domain-containing protein 8B', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(134192, NULL, 'G3DSA:2.60.40.420:FF:000239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134193, NULL, 'G3DSA:1.10.287.70:FF:000565', NULL, NULL, 'Voltage-gated Ca2+ channel, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(134194, NULL, 'G3DSA:2.60.40.60:FF:000063', NULL, NULL, 'protocadherin-15 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(134195, NULL, 'G3DSA:3.30.200.20:FF:001125', NULL, NULL, 'Serine/threonine receptor-like kinase NFP', NULL, NULL, NULL, NULL, NULL, 4),
(134196, NULL, 'G3DSA:1.10.287.70:FF:000256', NULL, NULL, 'TWiK family of potassium channels', NULL, NULL, NULL, NULL, NULL, 4),
(134197, NULL, 'G3DSA:2.130.10.10:FF:003415', NULL, NULL, 'eukaryotic translation initiation factor 2-alpha kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(134198, NULL, 'G3DSA:2.60.40.10:FF:001829', NULL, NULL, 'Interleukin-21 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(134199, NULL, 'G3DSA:3.90.640.10:FF:000057', NULL, NULL, 'Actin-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(134200, NULL, 'G3DSA:3.90.1200.10:FF:000006', NULL, NULL, 'Protein-ribulosamine 3-kinase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(134201, NULL, 'G3DSA:3.30.70.330:FF:002099', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134202, NULL, 'G3DSA:3.40.50.300:FF:003921', NULL, NULL, 'GD15936', NULL, NULL, NULL, NULL, NULL, 4),
(134203, NULL, 'G3DSA:3.40.720.10:FF:000125', NULL, NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(134204, NULL, 'G3DSA:1.10.10.1940:FF:000007', NULL, NULL, 'PHAryngeal gland Toxin-related', NULL, NULL, NULL, NULL, NULL, 4),
(134205, NULL, 'G3DSA:3.10.20.30:FF:000103', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134206, NULL, 'G3DSA:1.10.10.10:FF:000888', NULL, NULL, 'Anaphase-promoting complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(134207, NULL, 'G3DSA:3.40.50.620:FF:000471', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(134208, NULL, 'G3DSA:2.60.120.620:FF:000140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134209, NULL, 'G3DSA:3.30.710.10:FF:000368', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134210, NULL, 'G3DSA:1.10.287.470:FF:000062', NULL, NULL, 'RND family efflux transporter, MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(134211, NULL, 'G3DSA:2.40.290.10:FF:000016', NULL, NULL, 'Protein Ku', NULL, NULL, NULL, NULL, NULL, 4),
(134212, NULL, 'G3DSA:2.130.10.10:FF:003522', NULL, NULL, 'Elongator complex protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(134213, NULL, 'G3DSA:3.90.520.10:FF:000003', NULL, NULL, 'Mothers against decapentaplegic homolog', NULL, NULL, NULL, NULL, NULL, 4),
(134214, NULL, 'G3DSA:1.50.40.10:FF:000028', NULL, NULL, 'Solute carrier family 25 member 33', NULL, NULL, NULL, NULL, NULL, 4),
(134215, NULL, 'G3DSA:1.25.40.10:FF:004729', NULL, NULL, 'Crooked neck protein-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(134216, NULL, 'G3DSA:4.10.280.10:FF:000048', NULL, NULL, 'DNA-binding protein inhibitor ID-4', NULL, NULL, NULL, NULL, NULL, 4),
(134217, NULL, 'G3DSA:2.60.40.10:FF:000110', NULL, NULL, 'Ephrin type-B receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(134218, NULL, 'G3DSA:3.90.550.10:FF:000302', NULL, NULL, 'YALI0B09669p', NULL, NULL, NULL, NULL, NULL, 4),
(134219, NULL, 'G3DSA:3.40.50.620:FF:000780', NULL, NULL, 'Choline-phosphate cytidylyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(134220, NULL, 'G3DSA:1.25.40.10:FF:005191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134221, NULL, 'G3DSA:1.10.10.540:FF:000003', NULL, NULL, 'UV excision repair protein RAD23', NULL, NULL, NULL, NULL, NULL, 4),
(134222, NULL, 'G3DSA:3.40.50.300:FF:005719', NULL, NULL, 'Dicer Related Helicase', NULL, NULL, NULL, NULL, NULL, 4),
(134223, NULL, 'G3DSA:3.90.1290.10:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134224, NULL, 'G3DSA:1.25.40.120:FF:000093', NULL, NULL, 'Rab geranylgeranyl transferase like protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(134225, NULL, 'G3DSA:1.10.10.60:FF:001257', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134226, NULL, 'G3DSA:2.102.10.10:FF:000022', NULL, NULL, 'Rieske Fe-S domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(134227, NULL, 'G3DSA:3.10.20.360:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134228, NULL, 'G3DSA:1.20.58.60:FF:000675', NULL, NULL, 'Nesprin-1', NULL, NULL, NULL, NULL, NULL, 4),
(134229, NULL, 'G3DSA:2.130.10.10:FF:003724', NULL, NULL, 'Actin-related protein 2/3 complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(134230, NULL, 'G3DSA:1.20.58.1440:FF:000001', NULL, NULL, 'Dsl1p', NULL, NULL, NULL, NULL, NULL, 4),
(134231, NULL, 'G3DSA:1.10.510.10:FF:001523', NULL, NULL, 'MAP kinase-activated protein kinase mak-1', NULL, NULL, NULL, NULL, NULL, 4),
(134232, NULL, 'G3DSA:3.30.530.20:FF:000115', NULL, NULL, 'StAR-related lipid transfer protein 7, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(134233, NULL, 'G3DSA:3.40.50.10190:FF:000170', NULL, NULL, 'Protein CBG13622', NULL, NULL, NULL, NULL, NULL, 4),
(134234, NULL, 'G3DSA:3.30.200.20:FF:000130', NULL, NULL, 'STE20-related kinase adapter protein alpha', NULL, NULL, NULL, NULL, NULL, 4),
(134235, NULL, 'G3DSA:3.80.10.10:FF:000728', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(134236, NULL, 'G3DSA:1.20.1270.50:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134237, NULL, 'G3DSA:3.30.2290.10:FF:000008', NULL, NULL, 'Peptidase U62 modulator of DNA gyrase', NULL, NULL, NULL, NULL, NULL, 4),
(134238, NULL, 'G3DSA:3.30.1330.30:FF:000153', NULL, NULL, 'Protein pelota homolog', NULL, NULL, NULL, NULL, NULL, 4),
(134239, NULL, 'G3DSA:3.30.70.330:FF:003026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134240, NULL, 'G3DSA:3.30.450.20:FF:000328', NULL, NULL, 'Accessory colonization factor AcfB', NULL, NULL, NULL, NULL, NULL, 4),
(134241, NULL, 'G3DSA:2.130.10.10:FF:001577', NULL, NULL, 'WGS project CABT00000000 data, contig 2.26', NULL, NULL, NULL, NULL, NULL, 4),
(134242, NULL, 'G3DSA:3.40.30.10:FF:000720', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(134243, NULL, 'G3DSA:1.25.10.10:FF:003474', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134244, NULL, 'G3DSA:4.10.240.10:FF:000164', NULL, NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(134245, NULL, 'G3DSA:1.10.510.10:FF:003069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134246, NULL, 'G3DSA:2.60.120.920:FF:000016', NULL, NULL, 'neuralized-like protein 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(134247, NULL, 'G3DSA:3.40.50.1820:FF:001032', NULL, NULL, 'Acetyl xylan esterase-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(134248, NULL, 'G3DSA:1.10.510.10:FF:002091', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134249, NULL, 'G3DSA:2.60.40.10:FF:003292', NULL, NULL, 'Netrin receptor unc-5', NULL, NULL, NULL, NULL, NULL, 4),
(134250, NULL, 'G3DSA:3.30.930.10:FF:000109', NULL, NULL, 'Seryl-tRNA synthetase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(134251, NULL, 'G3DSA:3.40.50.300:FF:001976', NULL, NULL, 'Replication factor c protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(134252, NULL, 'G3DSA:1.25.40.10:FF:003509', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(134253, NULL, 'G3DSA:3.30.40.10:FF:001452', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(134254, NULL, 'G3DSA:3.40.1360.10:FF:000017', NULL, NULL, 'Meiotic recombination protein SPO11, variant 2', NULL, NULL, NULL, NULL, NULL, 4),
(134255, NULL, 'G3DSA:1.10.630.10:FF:000576', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134256, NULL, 'G3DSA:1.50.10.10:FF:000173', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(134257, NULL, 'G3DSA:1.25.40.10:FF:001604', NULL, NULL, 'Coatomer subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(134258, NULL, 'G3DSA:2.60.120.970:FF:000025', NULL, NULL, 'Transforming growth factor beta', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(134259, NULL, 'G3DSA:3.30.160.60:FF:005450', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134260, NULL, 'G3DSA:3.30.70.100:FF:000124', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134261, NULL, 'G3DSA:3.40.50.10490:FF:000153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134262, NULL, 'G3DSA:3.30.160.60:FF:003757', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134263, NULL, 'G3DSA:1.20.120.350:FF:000052', NULL, NULL, 'polycystic kidney disease 2-like 1 protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(134264, NULL, 'G3DSA:3.40.20.10:FF:000113', NULL, NULL, 'Si:dkey-40c11.2', NULL, NULL, NULL, NULL, NULL, 4),
(134265, NULL, 'G3DSA:3.30.980.10:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134266, NULL, 'G3DSA:1.20.1610.10:FF:000021', NULL, NULL, 'Putative alpha-1,2-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(134267, NULL, 'G3DSA:3.80.10.10:FF:004528', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134268, NULL, 'G3DSA:3.40.50.300:FF:001448', NULL, NULL, 'Glutamine ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(134269, NULL, 'G3DSA:1.20.140.160:FF:000004', NULL, NULL, 'RNA polymerase sigma factor SigB', NULL, NULL, NULL, NULL, NULL, 4),
(134270, NULL, 'G3DSA:3.80.10.10:FF:002746', NULL, NULL, 'F-box protein At5g07670', NULL, NULL, NULL, NULL, NULL, 4),
(134271, NULL, 'G3DSA:1.20.58.150:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134272, NULL, 'G3DSA:1.25.10.10:FF:002867', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(134273, NULL, 'G3DSA:3.60.10.10:FF:000224', NULL, NULL, 'Putative inositol-1,4,5-trisphosphate (IP3) 5-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(134274, NULL, 'G3DSA:1.50.40.10:FF:000141', NULL, NULL, 'Mitochondrial carrier protein MTM1', NULL, NULL, NULL, NULL, NULL, 4),
(134275, NULL, 'G3DSA:2.60.40.10:FF:001599', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(134276, NULL, 'G3DSA:3.10.580.10:FF:000159', NULL, NULL, 'AMP-activated protein kinase, gamma regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(134277, NULL, 'G3DSA:1.25.40.1030:FF:000014', NULL, NULL, 'Protein transport protein SEC31', NULL, NULL, NULL, NULL, NULL, 4),
(134278, NULL, 'G3DSA:3.30.160.60:FF:000104', NULL, NULL, 'Transcriptional repressor protein YY1', NULL, NULL, NULL, NULL, NULL, 4),
(134279, NULL, 'G3DSA:3.40.630.30:FF:000146', NULL, NULL, 'GNAT transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(134280, NULL, 'G3DSA:3.40.50.1010:FF:000159', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134281, NULL, 'G3DSA:2.60.40.10:FF:005904', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134282, NULL, 'G3DSA:1.25.40.470:FF:000085', NULL, NULL, 'Intraflagellar transport protein 122 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(134283, NULL, 'G3DSA:2.60.120.10:FF:000371', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(134284, NULL, 'G3DSA:1.25.40.1040:FF:000017', NULL, NULL, 'Unplaced genomic scaffold supercont1.217, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(134285, NULL, 'G3DSA:2.60.40.150:FF:000214', NULL, NULL, 'Toll-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(134286, NULL, 'G3DSA:1.20.1250.20:FF:001311', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134287, NULL, 'G3DSA:2.60.120.330:FF:000160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134288, NULL, 'G3DSA:2.30.30.380:FF:000052', NULL, NULL, 'Novel protein containing Zn-finger in Ran binding protein and others domain and 2 GRF zinc finger domains', NULL, NULL, NULL, NULL, NULL, 4),
(134289, NULL, 'G3DSA:2.60.20.10:FF:000002', NULL, NULL, 'Crystallin, beta B2', NULL, NULL, NULL, NULL, NULL, 4),
(134290, NULL, 'G3DSA:3.60.40.10:FF:000248', NULL, NULL, 'Stage II sporulation E family protein', NULL, NULL, NULL, NULL, NULL, 4),
(134291, NULL, 'G3DSA:1.10.630.10:FF:000267', NULL, NULL, 'Cytochrome P450 family 39 subfamily A member 1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(134292, NULL, 'G3DSA:3.20.20.80:FF:000680', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(134293, NULL, 'G3DSA:3.10.129.10:FF:000286', NULL, NULL, 'Polyketide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(134294, NULL, 'G3DSA:3.20.20.140:FF:000353', NULL, NULL, 'Dihydropyrimidinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(134295, NULL, 'G3DSA:3.40.1170.10:FF:000003', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(134296, NULL, 'G3DSA:2.130.10.10:FF:002797', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134297, NULL, 'G3DSA:3.30.70.890:FF:000063', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(134298, NULL, 'G3DSA:3.30.9.10:FF:000121', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(134299, NULL, 'G3DSA:3.30.505.10:FF:000060', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(134300, NULL, 'G3DSA:2.40.50.120:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134301, NULL, 'G3DSA:1.10.472.140:FF:000003', NULL, NULL, 'Retinoblastoma-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(134302, NULL, 'G3DSA:4.10.1000.10:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134303, NULL, 'G3DSA:3.65.10.20:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134304, NULL, 'G3DSA:2.40.50.140:FF:001241', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134305, NULL, 'G3DSA:1.10.510.10:FF:003872', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134306, NULL, 'G3DSA:3.10.20.90:FF:000115', NULL, NULL, 'tubulin-specific chaperone cofactor E-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(134307, NULL, 'G3DSA:3.20.20.60:FF:000033', NULL, NULL, 'CoA ester lyase', NULL, NULL, NULL, NULL, NULL, 4),
(134308, NULL, 'G3DSA:3.20.20.80:FF:000348', NULL, NULL, 'Beta-(1-3)-glucosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(134309, NULL, 'G3DSA:3.10.450.350:FF:000003', NULL, NULL, 'Cell envelope opacity-associated proteinA', NULL, NULL, NULL, NULL, NULL, 4),
(134310, NULL, 'G3DSA:3.30.930.10:FF:000098', NULL, NULL, 'Phenylalanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(134311, NULL, 'G3DSA:2.40.128.20:FF:000053', NULL, NULL, 'Alpha-1-microglobulin/bikunin, like', NULL, NULL, NULL, NULL, NULL, 4),
(134312, NULL, 'G3DSA:3.20.20.80:FF:000039', NULL, NULL, 'Glucosidase, alpha neutral C', NULL, NULL, NULL, NULL, NULL, 4),
(134313, NULL, 'G3DSA:3.30.160.60:FF:003196', NULL, NULL, 'Zinc finger protein 561', NULL, NULL, NULL, NULL, NULL, 4),
(134314, NULL, 'G3DSA:2.70.160.11:FF:000018', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(134315, NULL, 'G3DSA:1.20.1560.10:FF:000477', NULL, NULL, 'Iron ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(134316, NULL, 'G3DSA:1.20.1280.50:FF:000080', NULL, NULL, 'F-box protein SKIP1', NULL, NULL, NULL, NULL, NULL, 4),
(134317, NULL, 'G3DSA:1.20.1270.10:FF:000051', NULL, NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(134318, NULL, 'G3DSA:3.40.50.1010:FF:000070', NULL, NULL, 'Ribonuclease VapC', NULL, NULL, NULL, NULL, NULL, 4),
(134319, NULL, 'G3DSA:3.90.320.10:FF:000038', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(134320, NULL, 'G3DSA:1.25.40.800:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134321, NULL, 'G3DSA:1.10.1370.30:FF:000010', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(134322, NULL, 'G3DSA:3.30.470.20:FF:000184', NULL, NULL, 'Biotin carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(134323, NULL, 'G3DSA:1.25.40.10:FF:000986', NULL, NULL, 'Os07g0203900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(134324, NULL, 'G3DSA:3.20.20.70:FF:000036', NULL, NULL, 'Lipoyl synthase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(134325, NULL, 'G3DSA:2.30.30.490:FF:000085', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(134326, NULL, 'G3DSA:3.90.640.10:FF:000276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134327, NULL, 'G3DSA:1.20.5.4980:FF:000001', NULL, NULL, 'Centromere protein X', NULL, NULL, NULL, NULL, NULL, 4),
(134328, NULL, 'G3DSA:3.80.10.10:FF:000476', NULL, NULL, 'Si:dkey-279j5.1', NULL, NULL, NULL, NULL, NULL, 4),
(134329, NULL, 'G3DSA:3.40.50.2300:FF:000001', NULL, NULL, 'DNA-binding response regulator PhoB', NULL, NULL, NULL, NULL, NULL, 4),
(134330, NULL, 'G3DSA:2.10.25.10:FF:000740', NULL, NULL, 'Low-density lipoprotein receptor domain class A', NULL, NULL, NULL, NULL, NULL, 4),
(134331, NULL, 'G3DSA:3.40.250.10:FF:000061', NULL, NULL, 'Rhodanese-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(134332, NULL, 'G3DSA:1.10.287.70:FF:000037', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(134333, NULL, 'G3DSA:3.40.50.720:FF:000731', NULL, NULL, 'N-acetyl-gamma-glutamyl-phosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(134334, NULL, 'G3DSA:1.20.1250.20:FF:001530', NULL, NULL, 'Membrane-associated transporter protein', NULL, NULL, NULL, NULL, NULL, 4),
(134335, NULL, 'G3DSA:1.25.10.10:FF:001782', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(134336, NULL, 'G3DSA:4.10.970.10:FF:000011', NULL, NULL, 'Cku-70', NULL, NULL, NULL, NULL, NULL, 4),
(134337, NULL, 'G3DSA:3.30.160.60:FF:001740', NULL, NULL, 'zinc finger protein 596 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(134338, NULL, 'G3DSA:1.20.120.1910:FF:000015', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(134339, NULL, 'G3DSA:2.10.109.10:FF:000069', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(134340, NULL, 'G3DSA:2.60.40.10:FF:000200', NULL, NULL, 'cell adhesion molecule 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(134341, NULL, 'G3DSA:3.20.20.80:FF:000371', NULL, NULL, 'Glucosylceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(134342, NULL, 'G3DSA:4.10.270.10:FF:000003', NULL, NULL, 'IQ motif containing GTPase activating protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(134343, NULL, 'G3DSA:3.40.718.10:FF:000075', NULL, NULL, 'Isopropylmalate dehydrogenase1', NULL, NULL, NULL, NULL, NULL, 4),
(134344, NULL, 'G3DSA:1.20.1560.10:FF:000819', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134345, NULL, 'G3DSA:3.40.50.300:FF:001903', NULL, NULL, 'Obg-like ATPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(134346, NULL, 'G3DSA:3.30.70.3270:FF:000014', NULL, NULL, 'NADH dehydrogenase subunit I (NuoI)', NULL, NULL, NULL, NULL, NULL, 4),
(134347, NULL, 'G3DSA:3.40.720.10:FF:000344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134348, NULL, 'G3DSA:3.40.50.300:FF:003691', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(134349, NULL, 'G3DSA:3.40.50.10190:FF:000057', NULL, NULL, 'Transcription coactivator', NULL, NULL, NULL, NULL, NULL, 4),
(134350, NULL, 'G3DSA:4.10.280.10:FF:000032', NULL, NULL, 'Transcription factor bHLH123 family', NULL, NULL, NULL, NULL, NULL, 4),
(134351, NULL, 'G3DSA:2.60.120.970:FF:000115', NULL, NULL, 'transforming growth factor beta superfamily signaling ligand isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(134352, NULL, 'G3DSA:2.130.10.10:FF:001504', NULL, NULL, 'Polyadenylation factor subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(134353, NULL, 'G3DSA:1.10.510.10:FF:001377', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(134354, NULL, 'G3DSA:3.20.20.70:FF:000126', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(134355, NULL, 'G3DSA:2.130.10.30:FF:000173', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134356, NULL, 'G3DSA:3.40.50.300:FF:003449', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134357, NULL, 'G3DSA:3.10.50.40:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134358, NULL, 'G3DSA:1.10.630.10:FF:000503', NULL, NULL, 'Pentalenene oxygenase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(134359, NULL, 'G3DSA:3.80.10.10:FF:002275', NULL, NULL, 'Centrosomal protein of 97 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(134360, NULL, 'G3DSA:3.50.50.60:FF:001219', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(134361, NULL, 'G3DSA:3.40.1110.10:FF:000336', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134362, NULL, 'G3DSA:3.30.200.20:FF:001434', NULL, NULL, 'Homoserine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(134363, NULL, 'G3DSA:1.10.150.120:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134364, NULL, 'G3DSA:3.20.20.60:FF:000123', NULL, NULL, 'Malate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(134365, NULL, 'G3DSA:1.20.1110.10:FF:000073', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(134366, NULL, 'G3DSA:1.20.1250.10:FF:000139', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134367, NULL, 'G3DSA:2.10.25.10:FF:000627', NULL, NULL, 'Brevican core protein', NULL, NULL, NULL, NULL, NULL, 4),
(134368, NULL, 'G3DSA:3.30.160.20:FF:000008', NULL, NULL, 'interleukin enhancer-binding factor 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(134369, NULL, 'G3DSA:1.10.150.50:FF:000118', NULL, NULL, 'Protein CBR-TAG-97', NULL, NULL, NULL, NULL, NULL, 4),
(134370, NULL, 'G3DSA:2.60.200.40:FF:000004', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(134371, NULL, 'G3DSA:1.20.1250.20:FF:000384', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(134372, NULL, 'G3DSA:2.60.40.1730:FF:000017', NULL, NULL, 'aminopeptidase RNPEPL1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(134373, NULL, 'G3DSA:3.50.50.60:FF:001461', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134374, NULL, 'G3DSA:3.30.450.20:FF:000637', NULL, NULL, 'Sensor histidine kinase response regulator, PAS and PAS domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(134375, NULL, 'G3DSA:2.60.120.10:FF:000713', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134376, NULL, 'G3DSA:1.10.510.10:FF:004125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134377, NULL, 'G3DSA:1.10.437.10:FF:000059', NULL, NULL, 'BH3 interacting domain death agonist', NULL, NULL, NULL, NULL, NULL, 4),
(134378, NULL, 'G3DSA:2.30.29.30:FF:000765', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134379, NULL, 'G3DSA:3.40.50.300:FF:007288', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(134380, NULL, 'G3DSA:3.40.50.1820:FF:001251', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(134381, NULL, 'G3DSA:2.30.30.140:FF:000323', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134382, NULL, 'G3DSA:2.60.40.10:FF:005652', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134383, NULL, 'G3DSA:1.25.40.10:FF:003622', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g74600, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(134384, NULL, 'G3DSA:3.30.450.60:FF:000059', NULL, NULL, 'AP complex subunit sigma', NULL, NULL, NULL, NULL, NULL, 4),
(134385, NULL, 'G3DSA:4.10.400.10:FF:000261', NULL, NULL, 'LDL receptor protein 1, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(134386, NULL, 'G3DSA:3.40.50.300:FF:005490', NULL, NULL, 'Type III restriction enzyme, res subunit', NULL, NULL, NULL, NULL, NULL, 4),
(134387, NULL, 'G3DSA:3.30.70.360:FF:000062', NULL, NULL, 'N-carbamyl-L-amino acid amidohydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(134388, NULL, 'G3DSA:3.40.190.10:FF:000797', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(134389, NULL, 'G3DSA:1.20.120.850:FF:000016', NULL, NULL, 'Putative helicase swr1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(134390, NULL, 'G3DSA:3.90.660.10:FF:000075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134391, NULL, 'G3DSA:2.30.29.170:FF:000009', NULL, NULL, 'EF-hand domain (C-terminal)-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(134392, NULL, 'G3DSA:1.10.510.10:FF:001832', NULL, NULL, 'CSNK1A1 isoform 9', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(134393, NULL, 'G3DSA:2.10.90.10:FF:000025', NULL, NULL, 'vascular endothelial growth factor C', NULL, NULL, NULL, NULL, NULL, 4),
(134394, NULL, 'G3DSA:2.40.100.10:FF:000020', NULL, NULL, 'E3 SUMO-protein ligase RanBP2', NULL, NULL, NULL, NULL, NULL, 4),
(134395, NULL, 'G3DSA:3.40.1110.10:FF:000426', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134396, NULL, 'G3DSA:1.10.150.110:FF:000016', NULL, NULL, 'DNA-directed DNA/RNA polymerase mu', NULL, NULL, NULL, NULL, NULL, 4),
(134397, NULL, 'G3DSA:2.40.50.140:FF:001128', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134398, NULL, 'G3DSA:3.40.50.300:FF:005248', NULL, NULL, 'Gluconokinase', NULL, NULL, NULL, NULL, NULL, 4),
(134399, NULL, 'G3DSA:3.40.50.2000:FF:000479', NULL, NULL, 'UDP-glycosyltransferase 76F2', NULL, NULL, NULL, NULL, NULL, 4),
(134400, NULL, 'G3DSA:3.30.160.60:FF:005865', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134401, NULL, 'G3DSA:1.10.260.30:FF:000008', NULL, NULL, 'Signal recognition particle 54 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(134402, NULL, 'G3DSA:1.20.1270.60:FF:000256', NULL, NULL, 'Rho-GTPase-activating protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(134403, NULL, 'G3DSA:3.30.160.60:FF:002431', NULL, NULL, 'Zinc finger protein 787', NULL, NULL, NULL, NULL, NULL, 4),
(134404, NULL, 'G3DSA:1.20.1560.10:FF:000348', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(134405, NULL, 'G3DSA:1.20.1250.10:FF:000049', NULL, NULL, 'Interferon gamma', NULL, NULL, NULL, NULL, NULL, 4),
(134406, NULL, 'G3DSA:3.40.50.12710:FF:000015', NULL, NULL, 'ORF416', NULL, NULL, NULL, NULL, NULL, 4),
(134407, NULL, 'G3DSA:2.120.10.30:FF:000021', NULL, NULL, 'Sortilin-related receptor isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(134408, NULL, 'G3DSA:2.30.29.150:FF:000003', NULL, NULL, 'FACT complex subunit SPT16', NULL, NULL, NULL, NULL, NULL, 4),
(134409, NULL, 'G3DSA:1.10.510.10:FF:001629', NULL, NULL, 'Putative serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(134410, NULL, 'G3DSA:3.90.1170.40:FF:000006', NULL, NULL, 'Molybdenum cofactor biosynthesis protein MoaE', NULL, NULL, NULL, NULL, NULL, 4),
(134411, NULL, 'G3DSA:1.10.640.10:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134412, NULL, 'G3DSA:3.30.160.60:FF:001594', NULL, NULL, 'ras-responsive element-binding protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(134413, NULL, 'G3DSA:1.10.390.10:FF:000006', NULL, NULL, 'Puromycin-sensitive aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(134414, NULL, 'G3DSA:3.90.1170.30:FF:000003', NULL, NULL, 'Thymidine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(134415, NULL, 'G3DSA:3.10.280.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134416, NULL, 'G3DSA:1.10.520.10:FF:000023', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(134417, NULL, 'G3DSA:3.10.129.10:FF:000196', NULL, NULL, 'Acyl-CoA thioester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(134418, NULL, 'G3DSA:2.30.30.280:FF:000005', NULL, NULL, 'tRNA-specific 2-thiouridylase MnmA', NULL, NULL, NULL, NULL, NULL, 4),
(134419, NULL, 'G3DSA:1.25.10.10:FF:001872', NULL, NULL, 'Pumilio domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(134420, NULL, 'G3DSA:2.60.40.10:FF:003853', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134421, NULL, 'G3DSA:3.30.70.3170:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134422, NULL, 'G3DSA:4.10.400.10:FF:000019', NULL, NULL, 'Low density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(134423, NULL, 'G3DSA:3.30.70.3160:FF:000003', NULL, NULL, 'Probable tRNA pseudouridine synthase D', NULL, NULL, NULL, NULL, NULL, 4),
(134424, NULL, 'G3DSA:3.80.10.10:FF:002185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134425, NULL, 'G3DSA:3.30.450.50:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134426, NULL, 'G3DSA:3.30.300.30:FF:000096', NULL, NULL, 'Nonribosomal peptide synthase GliP2', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(134427, NULL, 'G3DSA:3.40.50.720:FF:001080', NULL, NULL, 'Thiamine biosynthesis protein ThiF', NULL, NULL, NULL, NULL, NULL, 4),
(134428, NULL, 'G3DSA:2.60.120.10:FF:000152', NULL, NULL, 'BnaA05g35160D protein', NULL, NULL, NULL, NULL, NULL, 4),
(134429, NULL, 'G3DSA:3.30.160.60:FF:005556', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134430, NULL, 'G3DSA:1.10.3090.10:FF:000016', NULL, NULL, 'Putative tRNA nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(134431, NULL, 'G3DSA:3.40.50.720:FF:000276', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(134432, NULL, 'G3DSA:2.60.120.200:FF:000587', NULL, NULL, 'EGF-like-domain, multiple 6', NULL, NULL, NULL, NULL, NULL, 4),
(134433, NULL, 'G3DSA:2.40.50.90:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134434, NULL, 'G3DSA:1.10.20.120:FF:000014', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(134435, NULL, 'G3DSA:1.10.287.1060:FF:000009', NULL, NULL, 'ESAT-6-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(134436, NULL, 'G3DSA:2.60.40.10:FF:003398', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134437, NULL, 'G3DSA:2.10.25.10:FF:000375', NULL, NULL, 'Slit guidance ligand 3', NULL, NULL, NULL, NULL, NULL, 4),
(134438, NULL, 'G3DSA:1.25.40.180:FF:000116', NULL, NULL, 'Putative eukaryotic initiation factor 4a', NULL, NULL, NULL, NULL, NULL, 4),
(134439, NULL, 'G3DSA:3.30.70.330:FF:000862', NULL, NULL, 'RNA-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(134440, NULL, 'G3DSA:1.25.40.10:FF:001368', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g37320 family', NULL, NULL, NULL, NULL, NULL, 4),
(134441, NULL, 'G3DSA:2.60.40.2300:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134442, NULL, 'G3DSA:1.10.287.40:FF:000005', NULL, NULL, 'Seryl-tRNA synthetase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(134443, NULL, 'G3DSA:3.30.930.10:FF:000132', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(134444, NULL, 'G3DSA:1.10.150.50:FF:000085', NULL, NULL, 'Liprin-beta', NULL, NULL, NULL, NULL, NULL, 4),
(134445, NULL, 'G3DSA:3.30.160.60:FF:001285', NULL, NULL, 'zinc finger protein 574', NULL, NULL, NULL, NULL, NULL, 4),
(134446, NULL, 'G3DSA:1.10.8.60:FF:000328', NULL, NULL, 'AAA family cell division control-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(134447, NULL, 'G3DSA:1.20.120.350:FF:000271', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134448, NULL, 'G3DSA:2.60.40.10:FF:004016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134449, NULL, 'G3DSA:1.10.555.10:FF:000165', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134450, NULL, 'G3DSA:3.90.810.10:FF:000014', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(134451, NULL, 'G3DSA:1.20.930.10:FF:000018', NULL, NULL, 'Protein iws1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(134452, NULL, 'G3DSA:3.40.50.10190:FF:000276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134453, NULL, 'G3DSA:2.30.29.30:FF:000911', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(134454, NULL, 'G3DSA:3.40.50.620:FF:000577', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134455, NULL, 'G3DSA:3.30.200.20:FF:000849', NULL, NULL, 'Os06g0692600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(134456, NULL, 'G3DSA:1.25.40.10:FF:001391', NULL, NULL, 'Tetratricopeptide repeat protein 21B', NULL, NULL, NULL, NULL, NULL, 4),
(134457, NULL, 'G3DSA:1.25.40.20:FF:001394', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(134458, NULL, 'G3DSA:3.30.160.60:FF:002212', NULL, NULL, 'Zinc finger protein 672', NULL, NULL, NULL, NULL, NULL, 4),
(134459, NULL, 'G3DSA:1.10.60.10:FF:000003', NULL, NULL, 'HTH-type transcriptional regulator MntR', NULL, NULL, NULL, NULL, NULL, 4),
(134460, NULL, 'G3DSA:4.10.1060.10:FF:000057', NULL, NULL, 'Ubiquitin thioesterase zranb1-B', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(134461, NULL, 'G3DSA:1.25.40.90:FF:000083', NULL, NULL, 'ENTH/VHS family protein', NULL, NULL, NULL, NULL, NULL, 4),
(134462, NULL, 'G3DSA:3.80.10.10:FF:002527', NULL, NULL, 'Leucine rich repeats and immunoglobulin like domains 2', NULL, NULL, NULL, NULL, NULL, 4),
(134463, NULL, 'G3DSA:2.130.10.10:FF:001471', NULL, NULL, 'Zinc finger protein 106', NULL, NULL, NULL, NULL, NULL, 4),
(134464, NULL, 'G3DSA:2.30.310.10:FF:000004', NULL, NULL, 'Fibronectin-binding protein A', NULL, NULL, NULL, NULL, NULL, 4),
(134465, NULL, 'G3DSA:3.40.50.2300:FF:000939', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134466, NULL, 'G3DSA:3.30.390.80:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134467, NULL, 'G3DSA:1.10.287.1040:FF:000003', NULL, NULL, 'Exodeoxyribonuclease 7 small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(134468, NULL, 'G3DSA:3.80.10.10:FF:001190', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(134469, NULL, 'G3DSA:3.10.450.40:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134470, NULL, 'G3DSA:3.30.390.60:FF:000003', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(134471, NULL, 'G3DSA:1.20.5.110:FF:000239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134472, NULL, 'G3DSA:3.90.380.10:FF:000014', NULL, NULL, 'Possible dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(134473, NULL, 'G3DSA:3.30.1330.80:FF:000011', NULL, NULL, 'Alpha-acetolactate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(134474, NULL, 'G3DSA:2.60.40.60:FF:001058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134475, NULL, 'G3DSA:3.10.20.30:FF:000013', NULL, NULL, 'Adrenodoxin, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(134476, NULL, 'G3DSA:2.60.120.590:FF:000018', NULL, NULL, 'ALKylated DNA repair protein AlkB homolog', NULL, NULL, NULL, NULL, NULL, 4),
(134477, NULL, 'G3DSA:3.40.50.620:FF:000886', NULL, NULL, 'Valyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(134478, NULL, 'G3DSA:3.40.50.410:FF:000155', NULL, NULL, 'Collagen, type VI, alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(134479, NULL, 'G3DSA:1.25.40.10:FF:001149', NULL, NULL, 'Blast:Protein crooked neck', NULL, NULL, NULL, NULL, NULL, 4),
(134480, NULL, 'G3DSA:1.20.1730.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134481, NULL, 'G3DSA:2.60.40.10:FF:003763', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134482, NULL, 'G3DSA:3.70.10.10:FF:000105', NULL, NULL, 'Checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(134483, NULL, 'G3DSA:1.20.1560.10:FF:000039', NULL, NULL, 'Cysteine/glutathione ABC transporter permease/ATP-binding protein CydD', NULL, NULL, NULL, NULL, NULL, 4),
(134484, NULL, 'G3DSA:2.130.10.10:FF:005214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134485, NULL, 'G3DSA:3.10.420.10:FF:000002', NULL, NULL, 'Protein-export protein SecB', NULL, NULL, NULL, NULL, NULL, 4),
(134486, NULL, 'G3DSA:3.40.50.720:FF:000618', NULL, NULL, 'SUMO-activating enzyme subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(134487, NULL, 'G3DSA:3.30.160.60:FF:001408', NULL, NULL, 'Zinc finger protein 260', NULL, NULL, NULL, NULL, NULL, 4),
(134488, NULL, 'G3DSA:3.70.10.10:FF:000015', NULL, NULL, 'DNA polymerase sliding clamp', NULL, NULL, NULL, NULL, NULL, 4),
(134489, NULL, 'G3DSA:3.60.40.10:FF:000052', NULL, NULL, 'Probable protein phosphatase 2C 34', NULL, NULL, NULL, NULL, NULL, 4),
(134490, NULL, 'G3DSA:2.10.70.10:FF:000226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134491, NULL, 'G3DSA:2.10.220.10:FF:000221', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(134492, NULL, 'G3DSA:1.25.40.10:FF:001059', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(134493, NULL, 'G3DSA:1.10.287.1490:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(134494, NULL, 'G3DSA:2.10.25.10:FF:000936', NULL, NULL, 'Zonadhesin', NULL, NULL, NULL, NULL, NULL, 4),
(134495, NULL, 'G3DSA:2.60.200.30:FF:000001', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(134496, NULL, 'G3DSA:2.40.40.20:FF:000046', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(134497, NULL, 'G3DSA:3.30.70.330:FF:002879', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134498, NULL, 'G3DSA:2.30.170.20:FF:000018', NULL, NULL, '60S ribosomal protein L24, putative', NULL, NULL, NULL, NULL, NULL, 4),
(134499, NULL, 'G3DSA:1.10.287.130:FF:000089', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(134500, NULL, 'G3DSA:3.40.50.720:FF:000837', NULL, NULL, 'Putative hydroxyacid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(134501, NULL, 'G3DSA:3.30.160.60:FF:005337', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134502, NULL, 'G3DSA:3.40.50.720:FF:000585', NULL, NULL, 'Alanine dehydrogenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(134503, NULL, 'G3DSA:3.40.50.12160:FF:000007', NULL, NULL, 'Ribosomal protein S12 methylthiotransferase RimO', NULL, NULL, NULL, NULL, NULL, 4),
(134504, NULL, 'G3DSA:2.10.25.10:FF:000594', NULL, NULL, 'cadherin-related tumor suppressor', NULL, NULL, NULL, NULL, NULL, 4),
(134505, NULL, 'G3DSA:3.40.630.70:FF:000001', NULL, NULL, 'Leucyl/phenylalanyl-tRNA--protein transferase', NULL, NULL, NULL, NULL, NULL, 4),
(134506, NULL, 'G3DSA:1.10.8.60:FF:000109', NULL, NULL, 'Cell division control protein 48 homolog C', NULL, NULL, NULL, NULL, NULL, 4),
(134507, NULL, 'G3DSA:2.10.25.10:FF:001212', NULL, NULL, 'AGAP003873-PA', NULL, NULL, NULL, NULL, NULL, 4),
(134508, NULL, 'G3DSA:3.40.250.10:FF:000167', NULL, NULL, 'Molybdopterin biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(134509, NULL, 'G3DSA:3.40.50.720:FF:000927', NULL, NULL, 'DeHydrogenases, Short chain', NULL, NULL, NULL, NULL, NULL, 4),
(134510, NULL, 'G3DSA:1.25.50.20:FF:000040', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(134511, NULL, 'G3DSA:3.30.70.330:FF:002969', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134512, NULL, 'G3DSA:2.10.70.10:FF:000136', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(134513, NULL, 'G3DSA:3.40.1160.10:FF:000053', NULL, NULL, 'Glutamate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(134514, NULL, 'G3DSA:1.10.630.10:FF:000470', NULL, NULL, 'Cytochrome P450 family 87 subfamily A polypeptide 2', NULL, NULL, NULL, NULL, NULL, 4),
(134515, NULL, 'G3DSA:2.130.10.10:FF:005523', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134516, NULL, 'G3DSA:3.40.50.2000:FF:001120', NULL, NULL, 'Trehalose-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(134517, NULL, 'G3DSA:2.60.120.290:FF:000142', NULL, NULL, 'C-type LECtin', NULL, NULL, NULL, NULL, NULL, 4),
(134518, NULL, 'G3DSA:1.20.5.100:FF:000017', NULL, NULL, 'Ubiquinol:cytochrome c oxidoreductase cytochrome c1', NULL, NULL, NULL, NULL, NULL, 4),
(134519, NULL, 'G3DSA:1.20.120.1510:FF:000002', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(134520, NULL, 'G3DSA:1.10.3730.20:FF:000013', NULL, NULL, 'EamA family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(134521, NULL, 'G3DSA:3.40.50.2300:FF:000378', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134522, NULL, 'G3DSA:2.10.25.10:FF:000285', NULL, NULL, 'cadherin EGF LAG seven-pass G-type receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(134523, NULL, 'G3DSA:3.40.1110.10:FF:000207', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(134524, NULL, 'G3DSA:3.40.50.2300:FF:000687', NULL, NULL, 'Vomeronasal 2, receptor 76', NULL, NULL, NULL, NULL, NULL, 4),
(134525, NULL, 'G3DSA:2.20.28.10:FF:000004', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(134526, NULL, 'G3DSA:3.40.50.300:FF:004163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(134527, NULL, 'G3DSA:2.40.50.140:FF:001095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134528, NULL, 'G3DSA:3.40.50.300:FF:004995', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134529, NULL, 'G3DSA:3.30.60.90:FF:000033', NULL, NULL, 'Discontinuous actin hexagon', NULL, NULL, NULL, NULL, NULL, 4),
(134530, NULL, 'G3DSA:1.20.1050.20:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134531, NULL, 'G3DSA:1.10.8.60:FF:000418', NULL, NULL, 'Replication factor C subunit', NULL, NULL, NULL, NULL, NULL, 4),
(134532, NULL, 'G3DSA:1.10.630.10:FF:000812', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134533, NULL, 'G3DSA:3.90.190.10:FF:000331', NULL, NULL, 'Endostyle specific protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(134534, NULL, 'G3DSA:3.10.580.10:FF:000053', NULL, NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(134535, NULL, 'G3DSA:3.50.50.60:FF:000747', NULL, NULL, 'Rab proteins geranylgeranyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(134536, NULL, 'G3DSA:1.20.58.2130:FF:000006', NULL, NULL, 'DNA replication regulator sld3', NULL, NULL, NULL, NULL, NULL, 4),
(134537, NULL, 'G3DSA:1.10.630.10:FF:000161', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(134538, NULL, 'G3DSA:2.60.120.200:FF:000497', NULL, NULL, 'Laminin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(134539, NULL, 'G3DSA:3.40.430.10:FF:000024', NULL, NULL, 'Dihydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(134540, NULL, 'G3DSA:2.130.10.10:FF:001813', NULL, NULL, 'WD domain, G-beta repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(134541, NULL, 'G3DSA:3.10.20.310:FF:000007', NULL, NULL, 'Outer membrane protein, OMP85 family', NULL, NULL, NULL, NULL, NULL, 4),
(134542, NULL, 'G3DSA:1.25.40.180:FF:000088', NULL, NULL, 'Eukaryotic translation initiation factor 4G2, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(134543, NULL, 'G3DSA:1.25.40.10:FF:005213', NULL, NULL, 'Clustered mitochondria protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(134544, NULL, 'G3DSA:3.40.50.1950:FF:000008', NULL, NULL, 'Indolepyruvate oxidoreductase subunit IorA', NULL, NULL, NULL, NULL, NULL, 4),
(134545, NULL, 'G3DSA:3.40.50.10330:FF:000037', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(134546, NULL, 'G3DSA:2.60.120.10:FF:000404', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(134547, NULL, 'G3DSA:3.40.1190.20:FF:000092', NULL, NULL, 'Fructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(134548, NULL, 'G3DSA:2.130.10.10:FF:004798', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134549, NULL, 'G3DSA:3.40.50.620:FF:000914', NULL, NULL, 'Glutaminyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(134550, NULL, 'G3DSA:3.30.420.10:FF:000374', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134551, NULL, 'G3DSA:1.20.920.10:FF:000085', NULL, NULL, 'GD21428', NULL, NULL, NULL, NULL, NULL, 4),
(134552, NULL, 'G3DSA:3.40.50.2000:FF:000951', NULL, NULL, 'Os07g0489950 protein', NULL, NULL, NULL, NULL, NULL, 4),
(134553, NULL, 'G3DSA:3.30.40.10:FF:000862', NULL, NULL, 'RUN and FYVE domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(134554, NULL, 'G3DSA:1.25.40.470:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134555, NULL, 'G3DSA:1.25.40.1040:FF:000034', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(134556, NULL, 'G3DSA:1.20.1730.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134557, NULL, 'G3DSA:2.40.20.10:FF:000025', NULL, NULL, 'Plasminogen', NULL, NULL, NULL, NULL, NULL, 4),
(134558, NULL, 'G3DSA:1.20.1270.90:FF:000001', NULL, NULL, 'Gram-positive signal peptide protein, YSIRK family', NULL, NULL, NULL, NULL, NULL, 4),
(134559, NULL, 'G3DSA:1.20.900.10:FF:000090', NULL, NULL, 'YALI0F13673p', NULL, NULL, NULL, NULL, NULL, 4),
(134560, NULL, 'G3DSA:2.10.25.10:FF:001797', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(134561, NULL, 'G3DSA:1.20.120.550:FF:000016', NULL, NULL, 'Microsomal glutathione S-transferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(134562, NULL, 'G3DSA:2.130.10.10:FF:003180', NULL, NULL, 'Protein CBG03683', NULL, NULL, NULL, NULL, NULL, 4),
(134563, NULL, 'G3DSA:3.80.10.10:FF:002735', NULL, NULL, 'Pollen receptor-like kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(134564, NULL, 'G3DSA:3.40.50.150:FF:001572', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134565, NULL, 'G3DSA:3.30.559.30:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134566, NULL, 'G3DSA:3.40.20.10:FF:000080', NULL, NULL, 'Kinase c and casein kinase substrate in neurons protein', NULL, NULL, NULL, NULL, NULL, 4),
(134567, NULL, 'G3DSA:3.80.10.10:FF:001212', NULL, NULL, 'Protein toll', NULL, NULL, NULL, NULL, NULL, 4),
(134568, NULL, 'G3DSA:1.25.40.20:FF:000415', NULL, NULL, 'KiDINs220 (Vertebrate scaffold protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(134569, NULL, 'G3DSA:3.40.190.10:FF:000792', NULL, NULL, 'ABC-type dipeptide/oligopeptide transport system, periplasmic component', NULL, NULL, NULL, NULL, NULL, 4),
(134570, NULL, 'G3DSA:1.20.1560.10:FF:000365', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(134571, NULL, 'G3DSA:3.40.50.2300:FF:000934', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134572, NULL, 'G3DSA:3.30.160.60:FF:003746', NULL, NULL, 'Zinc finger protein 208-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(134573, NULL, 'G3DSA:2.60.15.10:FF:000018', NULL, NULL, 'ATP synthase epsilon chain', NULL, NULL, NULL, NULL, NULL, 4),
(134574, NULL, 'G3DSA:3.30.70.1230:FF:000071', NULL, NULL, 'Adenylate cyclase (ATP pyrophosphate-lyase), putative', NULL, NULL, NULL, NULL, NULL, 4),
(134575, NULL, 'G3DSA:3.30.160.60:FF:002223', NULL, NULL, 'zinc finger protein 516 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(134576, NULL, 'G3DSA:3.60.10.10:FF:000084', NULL, NULL, 'Inositol-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(134577, NULL, 'G3DSA:3.40.50.10190:FF:000169', NULL, NULL, 'Protein CBG13622', NULL, NULL, NULL, NULL, NULL, 4),
(134578, NULL, 'G3DSA:1.25.40.1030:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134579, NULL, 'G3DSA:2.150.10.10:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134580, NULL, 'G3DSA:1.10.287.3240:FF:000034', NULL, NULL, 'V-type ATPase, D subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(134581, NULL, 'G3DSA:1.20.1070.10:FF:001007', NULL, NULL, 'Olfactory receptor 1349', NULL, NULL, NULL, NULL, NULL, 4),
(134582, NULL, 'G3DSA:3.90.320.10:FF:000027', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(134583, NULL, 'G3DSA:3.40.30.10:FF:000147', NULL, NULL, 'Thioredoxin domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(134584, NULL, 'G3DSA:1.25.40.20:FF:000320', NULL, NULL, 'Leucine-rich repeat kinase, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(134585, NULL, 'G3DSA:2.60.40.10:FF:005337', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134586, NULL, 'G3DSA:3.30.70.330:FF:001019', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit G', NULL, NULL, NULL, NULL, NULL, 4),
(134587, NULL, 'G3DSA:2.60.40.10:FF:002111', NULL, NULL, 'Titin', NULL, NULL, NULL, NULL, NULL, 4),
(134588, NULL, 'G3DSA:3.40.1830.10:FF:000003', NULL, NULL, 'Aminopeptidase protein', NULL, NULL, NULL, NULL, NULL, 4),
(134589, NULL, 'G3DSA:3.40.50.300:FF:002044', NULL, NULL, 'Heat shock protein 101', NULL, NULL, NULL, NULL, NULL, 4),
(134590, NULL, 'G3DSA:2.60.40.60:FF:000996', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134591, NULL, 'G3DSA:1.10.8.10:FF:000117', NULL, NULL, 'UBX domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(134592, NULL, 'G3DSA:1.25.40.10:FF:001935', NULL, NULL, 'Tetratricopeptide repeat (TPR)-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(134593, NULL, 'G3DSA:4.10.280.10:FF:000037', NULL, NULL, 'max-like protein X isoform X2', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(134594, NULL, 'G3DSA:3.20.20.10:FF:000029', NULL, NULL, 'Alanine racemase', NULL, NULL, NULL, NULL, NULL, 4),
(134595, NULL, 'G3DSA:3.90.550.10:FF:000162', NULL, NULL, 'Cellulose synthase-like B6', NULL, NULL, NULL, NULL, NULL, 4),
(134596, NULL, 'G3DSA:3.40.50.300:FF:007850', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(134597, NULL, 'G3DSA:2.70.150.10:FF:000050', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(134598, NULL, 'G3DSA:3.40.50.10490:FF:000057', NULL, NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', NULL, NULL, NULL, NULL, NULL, 4),
(134599, NULL, 'G3DSA:3.40.50.300:FF:005821', NULL, NULL, 'ATP-dependent DNA helicase RecQ family protein', NULL, NULL, NULL, NULL, NULL, 4),
(134600, NULL, 'G3DSA:2.30.29.30:FF:000776', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134601, NULL, 'G3DSA:2.130.10.10:FF:005315', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134602, NULL, 'G3DSA:1.50.40.10:FF:000124', NULL, NULL, 'Solute carrier family 25 member 36', NULL, NULL, NULL, NULL, NULL, 4),
(134603, NULL, 'G3DSA:2.60.40.60:FF:000411', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134604, NULL, 'G3DSA:1.25.40.20:FF:001843', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(134605, NULL, 'G3DSA:3.40.50.720:FF:000377', NULL, NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(134606, NULL, 'G3DSA:2.40.50.140:FF:000853', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134607, NULL, 'G3DSA:3.40.470.10:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134608, NULL, 'G3DSA:2.60.120.200:FF:000492', NULL, NULL, 'Growth arrest-specific 6', NULL, NULL, NULL, NULL, NULL, 4),
(134609, NULL, 'G3DSA:3.30.200.20:FF:001097', NULL, NULL, 'Dual specificity protein kinase FUZ7', NULL, NULL, NULL, NULL, NULL, 4),
(134610, NULL, 'G3DSA:1.20.58.60:FF:000338', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(134611, NULL, 'G3DSA:2.70.130.10:FF:000150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134612, NULL, 'G3DSA:3.40.30.10:FF:000473', NULL, NULL, 'Glutathione S-transferase Mu 1', NULL, NULL, NULL, NULL, NULL, 4),
(134613, NULL, 'G3DSA:1.10.533.10:FF:000007', NULL, NULL, 'death domain-containing protein CRADD isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(134614, NULL, 'G3DSA:1.20.1110.10:FF:000106', NULL, NULL, 'E1-E2 ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(134615, NULL, 'G3DSA:1.20.58.150:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134616, NULL, 'G3DSA:1.10.238.10:FF:000052', NULL, NULL, 'Guanylate cyclase activator 1A', NULL, NULL, NULL, NULL, NULL, 4),
(134617, NULL, 'G3DSA:1.10.238.20:FF:000055', NULL, NULL, 'General odorant-binding protein 69', NULL, NULL, NULL, NULL, NULL, 4),
(134618, NULL, 'G3DSA:3.50.50.60:FF:001242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134619, NULL, 'G3DSA:1.20.990.10:FF:000033', NULL, NULL, 'NADPH oxidoreductase A', NULL, NULL, NULL, NULL, NULL, 4),
(134620, NULL, 'G3DSA:3.40.91.10:FF:000001', NULL, NULL, 'SgraIR restriction enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(134621, NULL, 'G3DSA:1.20.5.110:FF:000245', NULL, NULL, 'Syntaxin 5-1', NULL, NULL, NULL, NULL, NULL, 4),
(134622, NULL, 'G3DSA:1.25.40.10:FF:001609', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(134623, NULL, 'G3DSA:3.30.70.1170:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134624, NULL, 'G3DSA:3.90.870.10:FF:000006', NULL, NULL, 'Putative threonylcarbamoyl-AMP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(134625, NULL, 'G3DSA:3.40.50.10470:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134626, NULL, 'G3DSA:3.40.50.720:FF:000591', NULL, NULL, 'Glucose-6-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(134627, NULL, 'G3DSA:3.30.1460.50:FF:000011', NULL, NULL, 'Autophagocytosis associated protein, c-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(134628, NULL, 'G3DSA:3.60.20.40:FF:000020', NULL, NULL, 'Si:ch73-59p9.2', NULL, NULL, NULL, NULL, NULL, 4),
(134629, NULL, 'G3DSA:3.80.10.10:FF:002409', NULL, NULL, 'SLIT 2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(134630, NULL, 'G3DSA:3.40.50.410:FF:000065', NULL, NULL, 'Complement C2', NULL, NULL, NULL, NULL, NULL, 4),
(134631, NULL, 'G3DSA:3.50.50.60:FF:001337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134632, NULL, 'G3DSA:3.40.50.10190:FF:000074', NULL, NULL, 'DNA repair protein Rtt107', NULL, NULL, NULL, NULL, NULL, 4),
(134633, NULL, 'G3DSA:3.30.479.20:FF:000057', NULL, NULL, 'Elongation factor Ts 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(134634, NULL, 'G3DSA:3.80.10.10:FF:000695', NULL, NULL, 'leucine-rich melanocyte differentiation-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(134635, NULL, 'G3DSA:3.40.50.1820:FF:000537', NULL, NULL, 'Ves G 1 allergen, putative', NULL, NULL, NULL, NULL, NULL, 4),
(134636, NULL, 'G3DSA:3.65.10.20:FF:000020', NULL, NULL, 'RNA cyclase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(134637, NULL, 'G3DSA:2.60.120.330:FF:000058', NULL, NULL, 'Oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(134638, NULL, 'G3DSA:1.10.8.10:FF:000331', NULL, NULL, 'Ubiquitin-specific peptidase 28', NULL, NULL, NULL, NULL, NULL, 4),
(134639, NULL, 'G3DSA:3.40.1110.10:FF:000319', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134640, NULL, 'G3DSA:1.20.1610.10:FF:000004', NULL, NULL, 'Alpha-1,2-mannosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(134641, NULL, 'G3DSA:1.20.140.10:FF:000121', NULL, NULL, 'Ribosomal protein L15', NULL, NULL, NULL, NULL, NULL, 4),
(134642, NULL, 'G3DSA:3.40.140.100:FF:000020', NULL, NULL, 'ThiF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(134643, NULL, 'G3DSA:3.20.20.80:FF:000578', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134644, NULL, 'G3DSA:1.25.40.10:FF:001840', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134645, NULL, 'G3DSA:2.30.29.30:FF:000990', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134646, NULL, 'G3DSA:1.10.510.10:FF:000073', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(134647, NULL, 'G3DSA:3.40.50.300:FF:005596', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(134648, NULL, 'G3DSA:3.40.50.10140:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134649, NULL, 'G3DSA:3.30.160.60:FF:002009', NULL, NULL, 'FEZ family zinc finger 2', NULL, NULL, NULL, NULL, NULL, 4),
(134650, NULL, 'G3DSA:1.20.1250.20:FF:000816', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(134651, NULL, 'G3DSA:3.40.50.300:FF:005607', NULL, NULL, 'Si:dkey-11m19.5', NULL, NULL, NULL, NULL, NULL, 4),
(134652, NULL, 'G3DSA:3.30.160.60:FF:000183', NULL, NULL, 'E3 ubiquitin-protein ligase ZFP91', NULL, NULL, NULL, NULL, NULL, 4),
(134653, NULL, 'G3DSA:2.10.70.10:FF:000007', NULL, NULL, 'Fibronectin 1', NULL, NULL, NULL, NULL, NULL, 4),
(134654, NULL, 'G3DSA:3.30.40.10:FF:001800', NULL, NULL, 'Putative peroxisomal biogenesis factor 10', NULL, NULL, NULL, NULL, NULL, 4),
(134655, NULL, 'G3DSA:3.40.50.300:FF:003781', NULL, NULL, 'GTPase, IMAP family member 7', NULL, NULL, NULL, NULL, NULL, 4),
(134656, NULL, 'G3DSA:1.10.510.10:FF:003541', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134657, NULL, 'G3DSA:1.10.238.10:FF:001249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134658, NULL, 'G3DSA:3.30.420.270:FF:000007', NULL, NULL, 'Biopolymer transport protein ExbD', NULL, NULL, NULL, NULL, NULL, 4),
(134659, NULL, 'G3DSA:1.20.1560.10:FF:000691', NULL, NULL, 'Protein CBG17574', NULL, NULL, NULL, NULL, NULL, 4),
(134660, NULL, 'G3DSA:3.60.20.10:FF:000270', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134661, NULL, 'G3DSA:3.30.70.330:FF:002868', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(134662, NULL, 'G3DSA:3.40.50.300:FF:007619', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134663, NULL, 'G3DSA:1.10.1670.10:FF:000078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134664, NULL, 'G3DSA:1.10.3730.20:FF:000018', NULL, NULL, 'NIPA protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(134665, NULL, 'G3DSA:2.60.120.920:FF:000140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134666, NULL, 'G3DSA:2.30.39.10:FF:000046', NULL, NULL, 'Serine protease inhibitor 28Dc', NULL, NULL, NULL, NULL, NULL, 4),
(134667, NULL, 'G3DSA:3.20.20.70:FF:000249', NULL, NULL, 'Lipoyl synthase, apicoplast', NULL, NULL, NULL, NULL, NULL, 4),
(134668, NULL, 'G3DSA:3.30.160.60:FF:005096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134669, NULL, 'G3DSA:1.10.720.30:FF:000016', NULL, NULL, 'MEF2-activating motif and SAP domain-containing transcriptional regulator isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(134670, NULL, 'G3DSA:2.10.70.10:FF:000119', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(134671, NULL, 'G3DSA:3.30.780.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134672, NULL, 'G3DSA:2.30.40.10:FF:000128', NULL, NULL, 'Guanine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(134673, NULL, 'G3DSA:3.40.720.10:FF:000248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134674, NULL, 'G3DSA:2.70.70.10:FF:000078', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(134675, NULL, 'G3DSA:2.10.25.10:FF:000953', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(134676, NULL, 'G3DSA:3.80.10.10:FF:002398', NULL, NULL, 'Putative leucine-rich repeat domain, L domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(134677, NULL, 'G3DSA:3.40.720.10:FF:000136', NULL, NULL, 'Phosphoglycerol transferase', NULL, NULL, NULL, NULL, NULL, 4),
(134678, NULL, 'G3DSA:2.60.40.2440:FF:000011', NULL, NULL, 'Protein phosphatase 1 regulatory subunit 3G', NULL, NULL, NULL, NULL, NULL, 4),
(134679, NULL, 'G3DSA:1.10.287.950:FF:000003', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(134680, NULL, 'G3DSA:1.25.40.10:FF:003285', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(134681, NULL, 'G3DSA:1.20.1270.60:FF:000251', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(134682, NULL, 'G3DSA:1.10.510.10:FF:001175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134683, NULL, 'G3DSA:3.30.390.30:FF:000039', NULL, NULL, 'Bis-gamma-glutamylcystine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(134684, NULL, 'G3DSA:2.20.25.10:FF:000071', NULL, NULL, 'Peptide-N4-(N-acetyl-beta-glucosaminyl)asparagine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(134685, NULL, 'G3DSA:3.30.420.10:FF:000711', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134686, NULL, 'G3DSA:1.20.58.830:FF:000022', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(134687, NULL, 'G3DSA:3.30.1520.10:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134688, NULL, 'G3DSA:1.10.510.10:FF:001287', NULL, NULL, 'Os10g0200000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(134689, NULL, 'G3DSA:3.30.1370.70:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134690, NULL, 'G3DSA:3.10.620.30:FF:000001', NULL, NULL, 'peptide-N(4)-(N-acetyl-beta- glucosaminyl)asparagine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(134691, NULL, 'G3DSA:2.130.10.10:FF:001942', NULL, NULL, 'Retinoblastoma-binding protein homolog 5', NULL, NULL, NULL, NULL, NULL, 4),
(134692, NULL, 'G3DSA:2.40.10.10:FF:000311', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134693, NULL, 'G3DSA:3.30.60.90:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134694, NULL, 'G3DSA:1.10.287.370:FF:000043', NULL, NULL, 'Prefoldin subunit 3', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(134695, NULL, 'G3DSA:2.40.50.90:FF:000079', NULL, NULL, 'ID821', NULL, NULL, NULL, NULL, NULL, 4),
(134696, NULL, 'G3DSA:3.30.1330.30:FF:000029', NULL, NULL, 'tRNA/rRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(134697, NULL, 'G3DSA:2.130.10.10:FF:001830', NULL, NULL, 'GM15299', NULL, NULL, NULL, NULL, NULL, 4),
(134698, NULL, 'G3DSA:3.30.40.10:FF:000536', NULL, NULL, 'CCR4-NOT transcription complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(134699, NULL, 'G3DSA:2.30.30.140:FF:000227', NULL, NULL, 'Tapas, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(134700, NULL, 'G3DSA:3.30.1370.210:FF:000026', NULL, NULL, 'ziinc finger protein Ci-ZF(C3H)-7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(134701, NULL, 'G3DSA:3.30.2270.10:FF:000002', NULL, NULL, 'Sarcosine oxidase subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(134702, NULL, 'G3DSA:1.20.5.110:FF:000133', NULL, NULL, 'Putative synaptobrevin-type transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(134703, NULL, 'G3DSA:2.60.200.20:FF:000200', NULL, NULL, 'Serine/threonine-protein kinase Chk2', NULL, NULL, NULL, NULL, NULL, 4),
(134704, NULL, 'G3DSA:1.10.510.10:FF:003636', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134705, NULL, 'G3DSA:3.40.50.300:FF:000015', NULL, NULL, 'chromodomain-helicase-DNA-binding protein 9 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(134706, NULL, 'G3DSA:3.10.290.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134707, NULL, 'G3DSA:3.30.1120.10:FF:000002', NULL, NULL, 'Arylsulfatase family member J', NULL, NULL, NULL, NULL, NULL, 4),
(134708, NULL, 'G3DSA:3.30.710.10:FF:000458', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134709, NULL, 'G3DSA:1.10.510.10:FF:004030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134710, NULL, 'G3DSA:1.20.120.980:FF:000010', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(134711, NULL, 'G3DSA:1.25.40.10:FF:004696', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134712, NULL, 'G3DSA:1.20.1310.20:FF:000063', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(134713, NULL, 'G3DSA:3.50.50.60:FF:001130', NULL, NULL, 'FAD-dependent pyridine nucleotide-disulfide oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(134714, NULL, 'G3DSA:3.30.40.10:FF:000957', NULL, NULL, 'TNF-receptor-associated factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(134715, NULL, 'G3DSA:3.40.1110.10:FF:000224', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(134716, NULL, 'G3DSA:2.60.120.290:FF:000248', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(134717, NULL, 'G3DSA:1.25.40.10:FF:003190', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g19191, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(134718, NULL, 'G3DSA:3.40.50.2020:FF:000035', NULL, NULL, 'Hypoxanthine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(134719, NULL, 'G3DSA:3.30.1120.30:FF:000008', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(134720, NULL, 'G3DSA:3.60.21.10:FF:000108', NULL, NULL, 'Calcineurin-like metallo-phosphoesterase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(134721, NULL, 'G3DSA:3.90.70.80:FF:000056', NULL, NULL, 'OTU domain-containing protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(134722, NULL, 'G3DSA:3.40.50.150:FF:000402', NULL, NULL, 'Ribosomal RNA-processing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(134723, NULL, 'G3DSA:3.30.70.940:FF:000022', NULL, NULL, 'Transcription antitermination protein RfaH', NULL, NULL, NULL, NULL, NULL, 4),
(134724, NULL, 'G3DSA:3.30.420.40:FF:000012', NULL, NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(134725, NULL, 'G3DSA:3.90.660.10:FF:000069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134726, NULL, 'G3DSA:3.40.50.790:FF:000015', NULL, NULL, 'Related to 50S ribosomal protein L1', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(134727, NULL, 'G3DSA:3.40.50.12710:FF:000010', NULL, NULL, 'Class I SAM-dependent methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(134728, NULL, 'G3DSA:2.60.40.10:FF:001852', NULL, NULL, 'B-cell antigen receptor complex-associated protein alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(134729, NULL, 'G3DSA:3.40.50.300:FF:002370', NULL, NULL, 'Torsin family 3, member A', NULL, NULL, NULL, NULL, NULL, 4),
(134730, NULL, 'G3DSA:3.40.50.12780:FF:000087', NULL, NULL, 'Acetyl-CoA synthase', NULL, NULL, NULL, NULL, NULL, 4),
(134731, NULL, 'G3DSA:1.10.1420.10:FF:000031', NULL, NULL, 'DNA mismatch repair protein MSH2', NULL, NULL, NULL, NULL, NULL, 4),
(134732, NULL, 'G3DSA:3.30.470.20:FF:000088', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(134733, NULL, 'G3DSA:3.40.50.720:FF:002417', NULL, NULL, 'Delta-1-pyrroline-5-carboxylate synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(134734, NULL, 'G3DSA:2.10.25.10:FF:000274', NULL, NULL, 'Crumbs cell polarity complex component 1', NULL, NULL, NULL, NULL, NULL, 4),
(134735, NULL, 'G3DSA:2.60.40.10:FF:003634', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134736, NULL, 'G3DSA:3.90.1260.10:FF:000004', NULL, NULL, 'Argininosuccinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(134737, NULL, 'G3DSA:3.40.50.450:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134738, NULL, 'G3DSA:3.90.850.10:FF:000011', NULL, NULL, 'Fumarylacetoacetase', NULL, NULL, NULL, NULL, NULL, 4),
(134739, NULL, 'G3DSA:3.40.50.720:FF:001220', NULL, NULL, 'D-beta-hydroxybutyrate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(134740, NULL, 'G3DSA:3.40.50.300:FF:003567', NULL, NULL, 'Pre-mRNA cleavage complex II Clp1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(134741, NULL, 'G3DSA:1.10.580.10:FF:000021', NULL, NULL, 'Citryl-CoA lyase', NULL, NULL, NULL, NULL, NULL, 4),
(134742, NULL, 'G3DSA:3.30.420.60:FF:000018', NULL, NULL, 'Protein pelota homolog', NULL, NULL, NULL, NULL, NULL, 4),
(134743, NULL, 'G3DSA:3.30.30.30:FF:000002', NULL, NULL, 'Heat shock 70 kDa protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(134744, NULL, 'G3DSA:1.10.10.10:FF:001265', NULL, NULL, 'Rap guanine nucleotide exchange factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(134745, NULL, 'G3DSA:1.10.287.2720:FF:000007', NULL, NULL, 'Oxysterol binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(134746, NULL, 'G3DSA:1.25.40.120:FF:000014', NULL, NULL, 'Geranylgeranyl transferase type-2 subunit alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(134747, NULL, 'G3DSA:3.30.160.60:FF:005758', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134748, NULL, 'G3DSA:3.30.450.20:FF:000542', NULL, NULL, 'Sensory histidine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(134749, NULL, 'G3DSA:1.10.8.60:FF:000188', NULL, NULL, 'Unplaced genomic scaffold supercont1.133, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(134750, NULL, 'G3DSA:1.25.40.10:FF:005325', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134751, NULL, 'G3DSA:3.70.10.10:FF:000004', NULL, NULL, 'Cell cycle checkpoint protein RAD1', NULL, NULL, NULL, NULL, NULL, 4),
(134752, NULL, 'G3DSA:2.130.10.10:FF:005192', NULL, NULL, 'WD repeat-containing protein 38', NULL, NULL, NULL, NULL, NULL, 4),
(134753, NULL, 'G3DSA:3.30.2130.30:FF:000048', NULL, NULL, 'Probable tRNA sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(134754, NULL, 'G3DSA:3.40.50.300:FF:000032', NULL, NULL, 'Export ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(134755, NULL, 'G3DSA:1.20.1250.20:FF:002278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134756, NULL, 'G3DSA:3.30.160.60:FF:000211', NULL, NULL, 'PR domain zinc finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(134757, NULL, 'G3DSA:1.20.5.170:FF:000139', NULL, NULL, 'Arr1p', NULL, NULL, NULL, NULL, NULL, 4),
(134758, NULL, 'G3DSA:3.40.50.150:FF:000161', NULL, NULL, 'Methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(134759, NULL, 'G3DSA:3.30.160.60:FF:004140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(134760, NULL, 'G3DSA:3.50.30.30:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134761, NULL, 'G3DSA:3.30.40.10:FF:000974', NULL, NULL, 'Tnf receptor-associated factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(134762, NULL, 'G3DSA:3.50.20.20:FF:000003', NULL, NULL, 'sex-regulated protein janus-B', NULL, NULL, NULL, NULL, NULL, 4),
(134763, NULL, 'G3DSA:3.30.160.60:FF:006034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134764, NULL, 'G3DSA:1.10.630.10:FF:000262', NULL, NULL, 'Isotrichodermin C-15 hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(134765, NULL, 'G3DSA:1.20.120.160:FF:000006', NULL, NULL, 'Chemotaxis protein CheA', NULL, NULL, NULL, NULL, NULL, 4),
(134766, NULL, 'G3DSA:3.50.50.60:FF:001225', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(134767, NULL, 'G3DSA:1.20.120.350:FF:000063', NULL, NULL, 'Calcium channel subunit Cch1', NULL, NULL, NULL, NULL, NULL, 4),
(134768, NULL, 'G3DSA:3.40.50.1260:FF:000015', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(134769, NULL, 'G3DSA:1.10.238.110:FF:000023', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(134770, NULL, 'G3DSA:1.20.990.10:FF:000016', NULL, NULL, 'NADPH-dependent diflavin oxidoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(134771, NULL, 'G3DSA:3.40.50.1700:FF:000052', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(134772, NULL, 'G3DSA:3.30.160.60:FF:003634', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134773, NULL, 'G3DSA:3.40.50.11040:FF:000014', NULL, NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', NULL, NULL, NULL, NULL, NULL, 4),
(134774, NULL, 'G3DSA:2.60.40.10:FF:005449', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134775, NULL, 'G3DSA:1.20.120.150:FF:000003', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(134776, NULL, 'G3DSA:2.130.10.10:FF:001263', NULL, NULL, 'U4/U6 small nuclear ribonucleoprotein Prp4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(134777, NULL, 'G3DSA:1.25.10.10:FF:001900', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(134778, NULL, 'G3DSA:3.40.720.10:FF:000350', NULL, NULL, 'Sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(134779, NULL, 'G3DSA:3.80.10.10:FF:000818', NULL, NULL, 'NLR family CARD domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(134780, NULL, 'G3DSA:1.10.10.60:FF:000976', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134781, NULL, 'G3DSA:3.90.25.10:FF:000083', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(134782, NULL, 'G3DSA:1.10.45.10:FF:000007', NULL, NULL, 'Cholesterol oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(134783, NULL, 'G3DSA:2.130.10.10:FF:003628', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(134784, NULL, 'G3DSA:3.40.30.10:FF:000035', NULL, NULL, 'hematopoietic prostaglandin D synthase', NULL, NULL, NULL, NULL, NULL, 4),
(134785, NULL, 'G3DSA:3.40.50.1820:FF:000554', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(134786, NULL, 'G3DSA:1.20.1300.10:FF:000020', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(134787, NULL, 'G3DSA:1.10.20.10:FF:000023', NULL, NULL, 'transcription initiation protein SPT3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(134788, NULL, 'G3DSA:3.40.50.970:FF:000098', NULL, NULL, 'Sulfite reductase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(134789, NULL, 'G3DSA:3.60.20.10:FF:000039', NULL, NULL, 'Asparagine synthetase [glutamine-hydrolyzing]', NULL, NULL, NULL, NULL, NULL, 4),
(134790, NULL, 'G3DSA:1.10.8.10:FF:000229', NULL, NULL, 'UBA/TS-N domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(134791, NULL, 'G3DSA:1.20.1070.10:FF:000283', NULL, NULL, 'Purinergic receptor P2Y11', NULL, NULL, NULL, NULL, NULL, 4),
(134792, NULL, 'G3DSA:3.90.640.10:FF:000074', NULL, NULL, 'Stress-seventy subfamily Q protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(134793, NULL, 'G3DSA:3.40.50.300:FF:005579', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(134794, NULL, 'G3DSA:2.130.10.10:FF:000987', NULL, NULL, 'Unplaced genomic scaffold supercont1.16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(134795, NULL, 'G3DSA:3.30.420.10:FF:000357', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134796, NULL, 'G3DSA:1.10.510.10:FF:000090', NULL, NULL, 'Dual specificity mitogen-activated protein kinase kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(134797, NULL, 'G3DSA:3.40.50.300:FF:005933', NULL, NULL, 'Atp/GTP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(134798, NULL, 'G3DSA:3.20.20.140:FF:000123', NULL, NULL, 'Probable N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(134799, NULL, 'G3DSA:2.170.270.10:FF:000001', NULL, NULL, 'Putative histone-lysine N-methyltransferase EZH2', NULL, NULL, NULL, NULL, NULL, 4),
(134800, NULL, 'G3DSA:2.10.70.10:FF:000024', NULL, NULL, 'Sushi repeat-containing protein SRPX', NULL, NULL, NULL, NULL, NULL, 4),
(134801, NULL, 'G3DSA:1.20.920.10:FF:000208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134802, NULL, 'G3DSA:3.40.20.10:FF:000107', NULL, NULL, 'Villin-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(134803, NULL, 'G3DSA:1.10.8.10:FF:000089', NULL, NULL, 'Tyrosyl-DNA phosphodiesterase 2', NULL, NULL, NULL, NULL, NULL, 4),
(134804, NULL, 'G3DSA:2.40.20.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134805, NULL, 'G3DSA:3.40.50.720:FF:001315', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(134806, NULL, 'G3DSA:1.25.10.10:FF:001445', NULL, NULL, 'UVSB', NULL, NULL, NULL, NULL, NULL, 4),
(134807, NULL, 'G3DSA:2.30.29.30:FF:001170', NULL, NULL, 'uncharacterized protein LOC100187308 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(134808, NULL, 'G3DSA:1.20.58.60:FF:000776', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134809, NULL, 'G3DSA:3.30.70.660:FF:000045', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(134810, NULL, 'G3DSA:1.20.900.10:FF:000073', NULL, NULL, 'Putative RhoGEF group protein', NULL, NULL, NULL, NULL, NULL, 4),
(134811, NULL, 'G3DSA:1.20.920.10:FF:000068', NULL, NULL, 'Histone acetyltransferase GCN5', NULL, NULL, NULL, NULL, NULL, 4),
(134812, NULL, 'G3DSA:3.40.1690.10:FF:000014', NULL, NULL, 'Type III secretion protein', NULL, NULL, NULL, NULL, NULL, 4),
(134813, NULL, 'G3DSA:1.10.510.10:FF:003524', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134814, NULL, 'G3DSA:3.10.580.10:FF:000165', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(134815, NULL, 'G3DSA:3.20.20.80:FF:000792', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134816, NULL, 'G3DSA:3.30.930.10:FF:000227', NULL, NULL, 'Pyrrolysyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(134817, NULL, 'G3DSA:3.30.420.40:FF:000124', NULL, NULL, 'Carbamoyltransferase HypF', NULL, NULL, NULL, NULL, NULL, 4),
(134818, NULL, 'G3DSA:3.50.50.60:FF:000848', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134819, NULL, 'G3DSA:3.30.60.30:FF:000060', NULL, NULL, 'Protein CBG17314', NULL, NULL, NULL, NULL, NULL, 4),
(134820, NULL, 'G3DSA:3.40.50.2300:FF:001423', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134821, NULL, 'G3DSA:1.10.10.60:FF:001252', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134822, NULL, 'G3DSA:3.40.1690.20:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134823, NULL, 'G3DSA:2.60.300.12:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134824, NULL, 'G3DSA:3.30.160.60:FF:001829', NULL, NULL, 'Zinc finger protein 296', NULL, NULL, NULL, NULL, NULL, 4),
(134825, NULL, 'G3DSA:1.25.10.10:FF:003345', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134826, NULL, 'G3DSA:3.10.20.600:FF:000004', NULL, NULL, 'Putative oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(134827, NULL, 'G3DSA:3.30.160.60:FF:002111', NULL, NULL, 'Zinc finger protein 260', NULL, NULL, NULL, NULL, NULL, 4),
(134828, NULL, 'G3DSA:2.130.10.10:FF:003387', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134829, NULL, 'G3DSA:2.130.10.10:FF:002201', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(134830, NULL, 'G3DSA:3.40.50.300:FF:007833', NULL, NULL, 'Chromosome 12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(134831, NULL, 'G3DSA:2.40.40.20:FF:000030', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(134832, NULL, 'G3DSA:2.60.40.4280:FF:000001', NULL, NULL, 'Hydralysin-1', NULL, NULL, NULL, NULL, NULL, 4),
(134833, NULL, 'G3DSA:1.10.533.10:FF:000221', NULL, NULL, 'E3 ubiquitin-protein ligase HERC2', NULL, NULL, NULL, NULL, NULL, 4),
(134834, NULL, 'G3DSA:2.10.25.10:FF:000386', NULL, NULL, 'matrilin-4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(134835, NULL, 'G3DSA:2.170.210.10:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134836, NULL, 'G3DSA:3.40.630.30:FF:000023', NULL, NULL, 'protein O-GlcNAcase', NULL, NULL, NULL, NULL, NULL, 4),
(134837, NULL, 'G3DSA:1.20.1260.10:FF:000078', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(134838, NULL, 'G3DSA:1.10.10.10:FF:001832', NULL, NULL, 'AGAP009060-PA', NULL, NULL, NULL, NULL, NULL, 4),
(134839, NULL, 'G3DSA:3.30.200.110:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134840, NULL, 'G3DSA:3.30.559.10:FF:000229', NULL, NULL, 'Hydroxamate-type ferrichrome siderophore peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(134841, NULL, 'G3DSA:1.10.287.130:FF:000229', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(134842, NULL, 'G3DSA:1.10.10.440:FF:000052', NULL, NULL, 'TransCription Elongation Regulator homolog', NULL, NULL, NULL, NULL, NULL, 4),
(134843, NULL, 'G3DSA:1.10.510.10:FF:003962', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134844, NULL, 'G3DSA:2.10.220.10:FF:000013', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(134845, NULL, 'G3DSA:3.40.50.720:FF:002294', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(134846, NULL, 'G3DSA:2.60.120.970:FF:000008', NULL, NULL, 'Bone morphogenetic protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(134847, NULL, 'G3DSA:3.30.70.330:FF:001233', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(134848, NULL, 'G3DSA:2.60.40.1180:FF:000150', NULL, NULL, 'Alpha-glucosidase II, catalytic subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(134849, NULL, 'G3DSA:3.80.10.10:FF:004326', NULL, NULL, 'Protein TORNADO 1', NULL, NULL, NULL, NULL, NULL, 4),
(134850, NULL, 'G3DSA:3.40.50.800:FF:000075', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(134851, NULL, 'G3DSA:3.30.70.270:FF:000248', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134852, NULL, 'G3DSA:3.30.200.100:FF:000003', NULL, NULL, 'RNA polymerase subunit sigma', NULL, NULL, NULL, NULL, NULL, 4),
(134853, NULL, 'G3DSA:3.40.50.300:FF:004410', NULL, NULL, 'Adp-ribosylation factor-like protein 6-like isoform x3', NULL, NULL, NULL, NULL, NULL, 4),
(134854, NULL, 'G3DSA:2.130.10.10:FF:001925', NULL, NULL, 'WD domain, G-beta repeat/BING4CT (NUC141) domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(134855, NULL, 'G3DSA:3.40.50.620:FF:000791', NULL, NULL, 'Cryptochrome circadian regulator 2', NULL, NULL, NULL, NULL, NULL, 4),
(134856, NULL, 'G3DSA:3.40.50.300:FF:003679', NULL, NULL, 'F-box DNA helicase 1', NULL, NULL, NULL, NULL, NULL, 4),
(134857, NULL, 'G3DSA:3.40.630.20:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134858, NULL, 'G3DSA:1.10.10.10:FF:001377', NULL, NULL, 'Acetylserotonin O-methyltransferase 3', NULL, NULL, NULL, NULL, NULL, 4),
(134859, NULL, 'G3DSA:1.20.1250.20:FF:000479', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(134860, NULL, 'G3DSA:2.60.40.10:FF:005551', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134861, NULL, 'G3DSA:6.10.30.50:FF:000002', NULL, NULL, 'BNR1p Formin', NULL, NULL, NULL, NULL, NULL, 4),
(134862, NULL, 'G3DSA:1.10.357.30:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134863, NULL, 'G3DSA:1.20.5.110:FF:000150', NULL, NULL, 'EhSyntaxin I, putative', NULL, NULL, NULL, NULL, NULL, 4),
(134864, NULL, 'G3DSA:3.30.70.330:FF:003150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134865, NULL, 'G3DSA:1.10.357.20:FF:000011', NULL, NULL, 'Solute carrier family 41 member 3', NULL, NULL, NULL, NULL, NULL, 4),
(134866, NULL, 'G3DSA:1.20.5.170:FF:000235', NULL, NULL, 'Tropomyosin', NULL, NULL, NULL, NULL, NULL, 4),
(134867, NULL, 'G3DSA:3.40.50.300:FF:008013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134868, NULL, 'G3DSA:3.90.830.10:FF:000009', NULL, NULL, 'Vacuolar sorting protein', NULL, NULL, NULL, NULL, NULL, 4),
(134869, NULL, 'G3DSA:3.90.190.10:FF:000078', NULL, NULL, 'Protein tyrosine phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(134870, NULL, 'G3DSA:3.80.10.10:FF:000274', NULL, NULL, 'NLR family CARD domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(134871, NULL, 'G3DSA:1.25.10.10:FF:003362', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(134872, NULL, 'G3DSA:2.30.29.30:FF:000097', NULL, NULL, 'Putative mRNA-decapping enzyme 1A', NULL, NULL, NULL, NULL, NULL, 4),
(134873, NULL, 'G3DSA:3.30.2230.10:FF:000005', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 26', NULL, NULL, NULL, NULL, NULL, 4),
(134874, NULL, 'G3DSA:3.20.20.70:FF:000019', NULL, NULL, 'Delta-aminolevulinic acid dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(134875, NULL, 'G3DSA:3.90.105.20:FF:000007', NULL, NULL, 'Ribosome assembly factor mrt4', NULL, NULL, NULL, NULL, NULL, 4),
(134876, NULL, 'G3DSA:3.20.20.60:FF:000016', NULL, NULL, 'Isocitrate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(134877, NULL, 'G3DSA:1.20.80.10:FF:000055', NULL, NULL, 'FERM, ARHGEF and pleckstrin domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(134878, NULL, 'G3DSA:3.30.342.10:FF:000046', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(134879, NULL, 'G3DSA:2.10.25.10:FF:000841', NULL, NULL, 'GM15007', NULL, NULL, NULL, NULL, NULL, 4),
(134880, NULL, 'G3DSA:3.40.720.10:FF:000024', NULL, NULL, 'Sulfatase YdeN', NULL, NULL, NULL, NULL, NULL, 4),
(134881, NULL, 'G3DSA:1.10.287.950:FF:000020', NULL, NULL, 'Heme-based aerotactic transducer HemAT', NULL, NULL, NULL, NULL, NULL, 4),
(134882, NULL, 'G3DSA:3.30.160.60:FF:003297', NULL, NULL, 'Si:ch211-266d19.4', NULL, NULL, NULL, NULL, NULL, 4),
(134883, NULL, 'G3DSA:1.25.40.20:FF:001276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134884, NULL, 'G3DSA:2.60.40.10:FF:004140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134885, NULL, 'G3DSA:3.90.380.10:FF:000019', NULL, NULL, 'Neverland', NULL, NULL, NULL, NULL, NULL, 4),
(134886, NULL, 'G3DSA:3.90.80.10:FF:000002', NULL, NULL, 'Soluble inorganic pyrophosphatase 4', NULL, NULL, NULL, NULL, NULL, 4),
(134887, NULL, 'G3DSA:1.25.40.10:FF:003173', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At3g15200', NULL, NULL, NULL, NULL, NULL, 4),
(134888, NULL, 'G3DSA:3.40.50.1820:FF:001043', NULL, NULL, 'Serine carboxypeptidase-like 45', NULL, NULL, NULL, NULL, NULL, 4),
(134889, NULL, 'G3DSA:3.30.70.250:FF:000012', NULL, NULL, 'Malonyl CoA-acyl carrier protein transacylase', NULL, NULL, NULL, NULL, NULL, 4),
(134890, NULL, 'G3DSA:3.30.70.100:FF:000012', NULL, NULL, 'Acylphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(134891, NULL, 'G3DSA:1.10.390.10:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134892, NULL, 'G3DSA:3.30.230.130:FF:000012', NULL, NULL, 'Cullin-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(134893, NULL, 'G3DSA:3.80.10.10:FF:004197', NULL, NULL, 'Toll-like receptor', NULL, NULL, NULL, NULL, NULL, 4),
(134894, NULL, 'G3DSA:2.130.10.10:FF:005641', NULL, NULL, 'Protein GFS12', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(134895, NULL, 'G3DSA:2.60.40.10:FF:003651', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134896, NULL, 'G3DSA:2.60.40.10:FF:003297', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134897, NULL, 'G3DSA:3.30.160.60:FF:003960', NULL, NULL, 'GM16127', NULL, NULL, NULL, NULL, NULL, 4),
(134898, NULL, 'G3DSA:1.10.565.10:FF:000008', NULL, NULL, 'Nuclear receptor subfamily 4 group A member 1', NULL, NULL, NULL, NULL, NULL, 4),
(134899, NULL, 'G3DSA:1.10.540.10:FF:000024', NULL, NULL, 'Acyl-CoA dehydrogenase FadE1', NULL, NULL, NULL, NULL, NULL, 4),
(134900, NULL, 'G3DSA:1.20.1720.10:FF:000125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134901, NULL, 'G3DSA:3.40.50.300:FF:003808', NULL, NULL, 'ATP-dependent Zn protease', NULL, NULL, NULL, NULL, NULL, 4),
(134902, NULL, 'G3DSA:1.20.120.1080:FF:000047', NULL, NULL, 'Pre-mRNA splicing factor ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(134903, NULL, 'G3DSA:3.40.50.300:FF:003904', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(134904, NULL, 'G3DSA:2.40.50.140:FF:000836', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134905, NULL, 'G3DSA:1.10.10.1800:FF:000005', NULL, NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', NULL, NULL, NULL, NULL, NULL, 4),
(134906, NULL, 'G3DSA:2.30.30.140:FF:000115', NULL, NULL, 'Tudor/PWWP/MBT superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(134907, NULL, 'G3DSA:3.10.400.20:FF:000021', NULL, NULL, 'Translation initiation factor SUI1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(134908, NULL, 'G3DSA:1.20.120.1910:FF:000004', NULL, NULL, 'Cysteinyl-tRNA synthetase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(134909, NULL, 'G3DSA:1.20.1070.10:FF:000827', NULL, NULL, 'Odorant receptor, family H, subfamily 130, member 1', NULL, NULL, NULL, NULL, NULL, 4),
(134910, NULL, 'G3DSA:2.60.40.10:FF:001397', NULL, NULL, 'Sidestep, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(134911, NULL, 'G3DSA:1.20.1250.20:FF:000833', NULL, NULL, 'GM21103', NULL, NULL, NULL, NULL, NULL, 4),
(134912, NULL, 'G3DSA:3.40.50.40:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134913, NULL, 'G3DSA:3.40.30.10:FF:000361', NULL, NULL, 'Selenium binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(134914, NULL, 'G3DSA:2.60.120.200:FF:000166', NULL, NULL, 'neurexin-1 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(134915, NULL, 'G3DSA:3.90.520.10:FF:000008', NULL, NULL, 'Dwarfin sma', NULL, NULL, NULL, NULL, NULL, 4),
(134916, NULL, 'G3DSA:2.30.29.30:FF:000664', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(134917, NULL, 'G3DSA:1.25.10.10:FF:001771', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134918, NULL, 'G3DSA:1.10.472.80:FF:000190', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134919, NULL, 'G3DSA:2.20.100.10:FF:000255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134920, NULL, 'G3DSA:3.30.160.60:FF:005551', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134921, NULL, 'G3DSA:1.10.510.10:FF:001624', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134922, NULL, 'G3DSA:6.10.250.3260:FF:000005', NULL, NULL, 'Component of cytosolic 80S ribosome and 60S large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(134923, NULL, 'G3DSA:3.40.50.620:FF:000465', NULL, NULL, 'Nicotinic acid mononucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(134924, NULL, 'G3DSA:2.60.220.50:FF:000098', NULL, NULL, 'Adhesion G protein-coupled receptor D2', NULL, NULL, NULL, NULL, NULL, 4),
(134925, NULL, 'G3DSA:1.25.40.10:FF:001273', NULL, NULL, 'GM26429', NULL, NULL, NULL, NULL, NULL, 4),
(134926, NULL, 'G3DSA:1.10.720.30:FF:000033', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(134927, NULL, 'G3DSA:1.10.486.10:FF:000049', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(134928, NULL, 'G3DSA:1.20.120.1920:FF:000007', NULL, NULL, 'Ubiquitin associated protein 1', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(134929, NULL, 'G3DSA:2.40.50.140:FF:001016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134930, NULL, 'G3DSA:3.30.70.2190:FF:000004', NULL, NULL, 'FAD-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(134931, NULL, 'G3DSA:2.170.120.30:FF:000007', NULL, NULL, 'YbbR-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(134932, NULL, 'G3DSA:2.60.120.10:FF:000051', NULL, NULL, 'dTDP-4-dehydrorhamnose 3,5-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(134933, NULL, 'G3DSA:1.50.10.10:FF:000190', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(134934, NULL, 'G3DSA:1.10.287.820:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134935, NULL, 'G3DSA:3.90.580.10:FF:000001', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(134936, NULL, 'G3DSA:3.40.1110.10:FF:000196', NULL, NULL, 'Copper-(Or silver)-translocating P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(134937, NULL, 'G3DSA:1.10.510.10:FF:003299', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134938, NULL, 'G3DSA:3.30.1490.20:FF:000072', NULL, NULL, 'Tubulin tyrosine ligase protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(134939, NULL, 'G3DSA:3.80.10.10:FF:003224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134940, NULL, 'G3DSA:3.30.450.20:FF:000188', NULL, NULL, 'Heme-regulated cyclic AMP phosphodiesterase (Direct oxygen sensor protein)', NULL, NULL, NULL, NULL, NULL, 4),
(134941, NULL, 'G3DSA:3.30.9.10:FF:000227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134942, NULL, 'G3DSA:4.10.410.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134943, NULL, 'G3DSA:3.90.1530.10:FF:000014', NULL, NULL, 'ParB domain protein nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(134944, NULL, 'G3DSA:1.25.40.20:FF:000303', NULL, NULL, 'Ankyrin repeat and SOCS box containing 8', NULL, NULL, NULL, NULL, NULL, 4),
(134945, NULL, 'G3DSA:1.25.40.10:FF:000997', NULL, NULL, 'Related to peroxisomal targeting signal receptor', NULL, NULL, NULL, NULL, NULL, 4),
(134946, NULL, 'G3DSA:2.60.40.10:FF:006040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134947, NULL, 'G3DSA:1.10.600.10:FF:000097', NULL, NULL, 'Ent-kaurene synthase B, chloroplast, putative', NULL, NULL, NULL, NULL, NULL, 4),
(134948, NULL, 'G3DSA:1.10.510.10:FF:002113', NULL, NULL, 'BUB protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(134949, NULL, 'G3DSA:1.10.150.170:FF:000006', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase H', NULL, NULL, NULL, NULL, NULL, 4),
(134950, NULL, 'G3DSA:1.25.40.20:FF:001489', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134951, NULL, 'G3DSA:1.20.1250.20:FF:001322', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(134952, NULL, 'G3DSA:2.30.30.380:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134953, NULL, 'G3DSA:1.10.510.10:FF:001837', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(134954, NULL, 'G3DSA:1.20.58.830:FF:000005', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(134955, NULL, 'G3DSA:1.25.40.10:FF:000300', NULL, NULL, 'Tetratricopeptide repeat domain 8', NULL, NULL, NULL, NULL, NULL, 4),
(134956, NULL, 'G3DSA:1.10.1520.10:FF:000078', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(134957, NULL, 'G3DSA:1.10.287.810:FF:000006', NULL, NULL, 'mitochondrial import inner membrane translocase subunit Tim10 B', NULL, NULL, NULL, NULL, NULL, 4),
(134958, NULL, 'G3DSA:1.20.120.1900:FF:000001', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(134959, NULL, 'G3DSA:1.25.40.10:FF:001486', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(134960, NULL, 'G3DSA:2.60.40.10:FF:000312', NULL, NULL, 'Alpha-2-macroglobulin like 1', NULL, NULL, NULL, NULL, NULL, 4),
(134961, NULL, 'G3DSA:1.10.12.10:FF:000033', NULL, NULL, 'Enoyl CoA hydratase (PaaF-3)', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(134962, NULL, 'G3DSA:3.30.70.1070:FF:000011', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(134963, NULL, 'G3DSA:2.30.130.10:FF:000024', NULL, NULL, 'RNA-guided pseudouridylation complex pseudouridine synthase subunit Cbf5', NULL, NULL, NULL, NULL, NULL, 4),
(134964, NULL, 'G3DSA:3.30.450.60:FF:000076', NULL, NULL, 'AP complex subunit sigma', NULL, NULL, NULL, NULL, NULL, 4),
(134965, NULL, 'G3DSA:3.15.10.20:FF:000005', NULL, NULL, 'Hch1p', NULL, NULL, NULL, NULL, NULL, 4),
(134966, NULL, 'G3DSA:3.30.390.30:FF:000040', NULL, NULL, 'NADH-rubredoxin oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(134967, NULL, 'G3DSA:3.50.30.30:FF:000052', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(134968, NULL, 'G3DSA:3.40.50.12160:FF:000024', NULL, NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(134969, NULL, 'G3DSA:3.30.450.20:FF:000654', NULL, NULL, 'Sensory box sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(134970, NULL, 'G3DSA:3.30.710.10:FF:000475', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(134971, NULL, 'G3DSA:1.20.5.170:FF:000027', NULL, NULL, 'Tripartite motif-containing 46, isoform CRA_c', NULL, NULL, NULL, NULL, NULL, 4),
(134972, NULL, 'G3DSA:1.25.10.10:FF:001658', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134973, NULL, 'G3DSA:2.60.120.200:FF:000727', NULL, NULL, 'Uncharacterized protein P4H10.19c', NULL, NULL, NULL, NULL, NULL, 4),
(134974, NULL, 'G3DSA:3.90.190.10:FF:000533', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134975, NULL, 'G3DSA:2.130.10.10:FF:002898', NULL, NULL, 'Uncharacterized WD repeat-containing protein C26H5.03', NULL, NULL, NULL, NULL, NULL, 4),
(134976, NULL, 'G3DSA:2.130.10.10:FF:003516', NULL, NULL, 'WD repeat domain 90', NULL, NULL, NULL, NULL, NULL, 4),
(134977, NULL, 'G3DSA:3.60.21.10:FF:000125', NULL, NULL, 'Serine/threonine protein phosphatase type 5', NULL, NULL, NULL, NULL, NULL, 4),
(134978, NULL, 'G3DSA:3.40.630.70:FF:000006', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(134979, NULL, 'G3DSA:1.20.140.10:FF:000019', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(134980, NULL, 'G3DSA:2.130.10.10:FF:001375', NULL, NULL, 'Neurobeachin-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(134981, NULL, 'G3DSA:2.60.40.10:FF:001408', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(134982, NULL, 'G3DSA:2.40.128.20:FF:000047', NULL, NULL, 'Lipocalin-type prostaglandin D synthase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(134983, NULL, 'G3DSA:1.50.10.100:FF:000008', NULL, NULL, 'Heparin-sulfate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(134984, NULL, 'G3DSA:1.20.1250.20:FF:000266', NULL, NULL, 'MFS multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(134985, NULL, 'G3DSA:1.10.287.70:FF:000458', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134986, NULL, 'G3DSA:2.60.40.3510:FF:000017', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(134987, NULL, 'G3DSA:1.20.1270.280:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134988, NULL, 'G3DSA:2.130.10.10:FF:005074', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(134989, NULL, 'G3DSA:3.30.420.10:FF:000144', NULL, NULL, 'Ribonuclease H', NULL, NULL, NULL, NULL, NULL, 4),
(134990, NULL, 'G3DSA:3.90.70.80:FF:000039', NULL, NULL, 'Extracellular OTU-like cysteine protease, putative (AFU_orthologue AFUA_5G11300)', NULL, NULL, NULL, NULL, NULL, 4),
(134991, NULL, 'G3DSA:1.10.630.10:FF:000374', NULL, NULL, '9-divinyl ether synthase', NULL, NULL, NULL, NULL, NULL, 4),
(134992, NULL, 'G3DSA:3.30.1330.80:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134993, NULL, 'G3DSA:1.20.1510.10:FF:000087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(134994, NULL, 'G3DSA:3.30.70.2850:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(134995, NULL, 'G3DSA:3.30.200.20:FF:001546', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(134996, NULL, 'G3DSA:1.10.287.70:FF:000363', NULL, NULL, 'Ionotropic receptor 48c', NULL, NULL, NULL, NULL, NULL, 4),
(134997, NULL, 'G3DSA:2.60.40.10:FF:001835', NULL, NULL, 'Cytokine receptor common subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(134998, NULL, 'G3DSA:3.30.70.1390:FF:000006', NULL, NULL, 'Cyclic GMP-binding protein C', NULL, NULL, NULL, NULL, NULL, 4),
(134999, NULL, 'G3DSA:3.30.420.40:FF:001086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135000, NULL, 'G3DSA:1.25.40.10:FF:002211', NULL, NULL, 'F20D22.10 protein', NULL, NULL, NULL, NULL, NULL, 4),
(135001, NULL, 'G3DSA:1.20.1050.80:FF:000015', NULL, NULL, 'Vacuolar sorting protein', NULL, NULL, NULL, NULL, NULL, 4),
(135002, NULL, 'G3DSA:1.10.260.30:FF:000003', NULL, NULL, 'Signal recognition particle 54 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(135003, NULL, 'G3DSA:1.25.10.10:FF:000034', NULL, NULL, 'AT-rich interactive domain-containing protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(135004, NULL, 'G3DSA:3.30.1330.90:FF:000019', NULL, NULL, 'Probable L-serine dehydratase, alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(135005, NULL, 'G3DSA:2.40.50.150:FF:000030', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(135006, NULL, 'G3DSA:2.130.10.130:FF:000022', NULL, NULL, 'integrin alpha-PS1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(135007, NULL, 'G3DSA:3.40.50.200:FF:000002', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(135008, NULL, 'G3DSA:2.170.16.10:FF:000021', NULL, NULL, 'Replication factor C small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(135009, NULL, 'G3DSA:3.40.50.12470:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135010, NULL, 'G3DSA:3.40.50.1820:FF:000088', NULL, NULL, 'SERAC1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(135011, NULL, 'G3DSA:2.10.25.10:FF:000515', NULL, NULL, 'latent-transforming growth factor beta-binding protein 1 isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(135012, NULL, 'G3DSA:1.10.1420.10:FF:000014', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(135013, NULL, 'G3DSA:3.40.920.10:FF:000005', NULL, NULL, '2-oxoglutarate ferredoxin oxidoreductase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(135014, NULL, 'G3DSA:1.20.1070.10:FF:000491', NULL, NULL, 'Protein CBR-CFZ-2', NULL, NULL, NULL, NULL, NULL, 4),
(135015, NULL, 'G3DSA:1.25.40.10:FF:003740', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135016, NULL, 'G3DSA:3.40.50.300:FF:001089', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(135017, NULL, 'G3DSA:3.20.20.80:FF:000354', NULL, NULL, 'Alpha-amylase', NULL, NULL, NULL, NULL, NULL, 4),
(135018, NULL, 'G3DSA:3.40.50.620:FF:000673', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(135019, NULL, 'G3DSA:3.40.50.1820:FF:000992', NULL, NULL, 'Thioesterase PikA5', NULL, NULL, NULL, NULL, NULL, 4),
(135020, NULL, 'G3DSA:1.20.1740.10:FF:000008', NULL, NULL, 'large neutral amino acids transporter small subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(135021, NULL, 'G3DSA:3.30.300.20:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135022, NULL, 'G3DSA:4.10.400.10:FF:000143', NULL, NULL, 'low-density lipoprotein receptor-related protein 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(135023, NULL, 'G3DSA:3.40.50.2300:FF:000693', NULL, NULL, 'Glutamate receptor 1.2', NULL, NULL, NULL, NULL, NULL, 4),
(135024, NULL, 'G3DSA:1.10.510.10:FF:001736', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(135025, NULL, 'G3DSA:1.10.40.30:FF:000025', NULL, NULL, 'Aspartate ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(135026, NULL, 'G3DSA:1.20.1560.10:FF:000820', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135027, NULL, 'G3DSA:2.40.50.140:FF:000398', NULL, NULL, 'Ribosomal protein S1-like1', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(135028, NULL, 'G3DSA:1.25.40.800:FF:000004', NULL, NULL, 'NOT family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135029, NULL, 'G3DSA:1.10.150.50:FF:000091', NULL, NULL, 'polycomb protein Sfmbt isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(135030, NULL, 'G3DSA:3.40.250.10:FF:000162', NULL, NULL, 'Protein-tyrosine-phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135031, NULL, 'G3DSA:3.40.50.720:FF:000832', NULL, NULL, 'Similar to D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(135032, NULL, 'G3DSA:1.20.1110.10:FF:000202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135033, NULL, 'G3DSA:2.60.40.150:FF:000799', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135034, NULL, 'G3DSA:1.25.40.10:FF:003408', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(135035, NULL, 'G3DSA:2.60.40.10:FF:001740', NULL, NULL, 'NPHS1, nephrin', NULL, NULL, NULL, NULL, NULL, 4),
(135036, NULL, 'G3DSA:3.90.215.10:FF:000013', NULL, NULL, 'Fibrinogen-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(135037, NULL, 'G3DSA:3.40.50.300:FF:006889', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135038, NULL, 'G3DSA:3.40.630.60:FF:000003', NULL, NULL, 'Ornithine decarboxylase antizyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(135039, NULL, 'G3DSA:1.10.10.350:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135040, NULL, 'G3DSA:3.40.50.150:FF:001807', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135041, NULL, 'G3DSA:3.20.20.70:FF:000351', NULL, NULL, 'IMPDH2 isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(135042, NULL, 'G3DSA:1.20.58.60:FF:000097', NULL, NULL, 'microtubule-actin cross-linking factor 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(135043, NULL, 'G3DSA:3.40.50.2300:FF:001210', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135044, NULL, 'G3DSA:3.10.20.90:FF:000216', NULL, NULL, 'Regulator of G-protein signaling 14', NULL, NULL, NULL, NULL, NULL, 4),
(135045, NULL, 'G3DSA:1.10.3210.10:FF:000004', NULL, NULL, 'Guanosine-5''-triphosphate,3''-diphosphate pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(135046, NULL, 'G3DSA:3.40.50.2000:FF:000597', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135047, NULL, 'G3DSA:2.60.120.260:FF:000594', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135048, NULL, 'G3DSA:2.60.40.10:FF:001509', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(135049, NULL, 'G3DSA:2.40.50.790:FF:000002', NULL, NULL, 'Tudor, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(135050, NULL, 'G3DSA:4.10.240.10:FF:000158', NULL, NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(135051, NULL, 'G3DSA:3.20.20.60:FF:000128', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(135052, NULL, 'G3DSA:1.10.238.10:FF:000501', NULL, NULL, 'Calcium-binding protein 4a', NULL, NULL, NULL, NULL, NULL, 4),
(135053, NULL, 'G3DSA:3.40.850.10:FF:000466', NULL, NULL, 'Kinesin motor domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(135054, NULL, 'G3DSA:3.40.630.30:FF:000247', NULL, NULL, 'RNA cytidine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(135055, NULL, 'G3DSA:4.10.240.10:FF:000046', NULL, NULL, 'Transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(135056, NULL, 'G3DSA:3.40.50.300:FF:007283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135057, NULL, 'G3DSA:3.40.50.300:FF:007395', NULL, NULL, 'mRNA cleavage and polyadenylation factor clp1', NULL, NULL, NULL, NULL, NULL, 4),
(135058, NULL, 'G3DSA:1.20.1560.10:FF:000915', NULL, NULL, 'ATP-binding cassette transporter, subfamily B, member 6, group TAP protein PpABCB6', NULL, NULL, NULL, NULL, NULL, 4),
(135059, NULL, 'G3DSA:2.30.29.30:FF:000905', NULL, NULL, 'Insulin receptor substrate 1', NULL, NULL, NULL, NULL, NULL, 4),
(135060, NULL, 'G3DSA:3.40.430.10:FF:000029', NULL, NULL, 'Bifunctional dihydrofolate reductase-thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(135061, NULL, 'G3DSA:1.10.8.60:FF:000216', NULL, NULL, 'Spermatogenesis associated 5', NULL, NULL, NULL, NULL, NULL, 4),
(135062, NULL, 'G3DSA:3.30.70.330:FF:002986', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135063, NULL, 'G3DSA:2.60.40.150:FF:000001', NULL, NULL, 'Regulating synaptic membrane exocytosis 3, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(135064, NULL, 'G3DSA:1.10.8.60:FF:000104', NULL, NULL, 'DNA polymerase epsilon subunit', NULL, NULL, NULL, NULL, NULL, 4),
(135065, NULL, 'G3DSA:2.30.30.810:FF:000001', NULL, NULL, 'DNA repair protein crb2', NULL, NULL, NULL, NULL, NULL, 4),
(135066, NULL, 'G3DSA:3.40.50.150:FF:000610', NULL, NULL, 'Nucleolar protein NOP2', NULL, NULL, NULL, NULL, NULL, 4),
(135067, NULL, 'G3DSA:2.60.120.10:FF:000500', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135068, NULL, 'G3DSA:1.10.3380.20:FF:000008', NULL, NULL, 'DNA polymerase theta', NULL, NULL, NULL, NULL, NULL, 4),
(135069, NULL, 'G3DSA:3.30.160.20:FF:000115', NULL, NULL, 'Peptide chain release factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(135070, NULL, 'G3DSA:3.90.640.10:FF:000282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135071, NULL, 'G3DSA:3.30.530.20:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135072, NULL, 'G3DSA:4.10.860.120:FF:000020', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(135073, NULL, 'G3DSA:1.25.40.20:FF:001388', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135074, NULL, 'G3DSA:3.40.33.10:FF:000058', NULL, NULL, 'peptidase inhibitor 16 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(135075, NULL, 'G3DSA:3.90.1170.40:FF:000023', NULL, NULL, 'Molybdenum cofactor biosynthesis protein D/E', NULL, NULL, NULL, NULL, NULL, 4),
(135076, NULL, 'G3DSA:3.40.50.410:FF:000048', NULL, NULL, 'von Willebrand factor A domain-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(135077, NULL, 'G3DSA:1.10.3380.10:FF:000005', NULL, NULL, 'Pre-mRNA splicing helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135078, NULL, 'G3DSA:1.10.640.10:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135079, NULL, 'G3DSA:3.80.10.10:FF:002168', NULL, NULL, 'Leucine rich repeat containing 41', NULL, NULL, NULL, NULL, NULL, 4),
(135080, NULL, 'G3DSA:1.10.10.200:FF:000014', NULL, NULL, 'Putative transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(135081, NULL, 'G3DSA:3.40.50.300:FF:007507', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135082, NULL, 'G3DSA:3.40.50.1460:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135083, NULL, 'G3DSA:1.10.3080.10:FF:000061', NULL, NULL, 'Chloride channel protein EriC', NULL, NULL, NULL, NULL, NULL, 4),
(135084, NULL, 'G3DSA:3.10.580.10:FF:000070', NULL, NULL, 'Cyclin and CBS domain divalent metal cation transport mediator 4', NULL, NULL, NULL, NULL, NULL, 4),
(135085, NULL, 'G3DSA:1.10.630.10:FF:000475', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135086, NULL, 'G3DSA:1.20.1250.20:FF:001081', NULL, NULL, 'Inositol transporter 4', NULL, NULL, NULL, NULL, NULL, 4),
(135087, NULL, 'G3DSA:1.10.10.10:FF:001826', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135088, NULL, 'G3DSA:2.130.10.10:FF:001476', NULL, NULL, 'Dynein intermediate chain 3, ciliary', NULL, NULL, NULL, NULL, NULL, 4),
(135089, NULL, 'G3DSA:3.40.50.300:FF:006310', NULL, NULL, 'Elongation factor like GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(135090, NULL, 'G3DSA:3.30.300.30:FF:000079', NULL, NULL, 'Peptide synthetase Nrp', NULL, NULL, NULL, NULL, NULL, 4),
(135091, NULL, 'G3DSA:3.30.40.10:FF:001025', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135092, NULL, 'G3DSA:3.90.1150.10:FF:000468', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135093, NULL, 'G3DSA:1.10.510.10:FF:000899', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(135094, NULL, 'G3DSA:3.80.10.10:FF:004534', NULL, NULL, 'F-box/leucine rich repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135095, NULL, 'G3DSA:3.50.50.60:FF:000854', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(135096, NULL, 'G3DSA:3.40.1380.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135097, NULL, 'G3DSA:3.40.50.1820:FF:000880', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135098, NULL, 'G3DSA:1.50.40.10:FF:000354', NULL, NULL, 'Solute carrier family 25 member 33', NULL, NULL, NULL, NULL, NULL, 4),
(135099, NULL, 'G3DSA:1.25.10.10:FF:001451', NULL, NULL, 'Protein CELLULOSE SYNTHASE INTERACTIVE 3', NULL, NULL, NULL, NULL, NULL, 4),
(135100, NULL, 'G3DSA:1.10.510.10:FF:003754', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135101, NULL, 'G3DSA:3.30.365.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135102, NULL, 'G3DSA:1.20.970.40:FF:000001', NULL, NULL, 'Mesothelin', NULL, NULL, NULL, NULL, NULL, 4),
(135103, NULL, 'G3DSA:3.40.1380.20:FF:000033', NULL, NULL, 'GD12403', NULL, NULL, NULL, NULL, NULL, 4),
(135104, NULL, 'G3DSA:1.10.287.110:FF:000111', NULL, NULL, 'Heat shock protein DnaJ homologue Pfj2', NULL, NULL, NULL, NULL, NULL, 4),
(135105, NULL, 'G3DSA:3.20.20.105:FF:000004', NULL, NULL, 'Queuine tRNA-ribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(135106, NULL, 'G3DSA:3.40.50.200:FF:000103', NULL, NULL, 'Alkaline serine protease AorO, putative (AFU_orthologue AFUA_6G10250)', NULL, NULL, NULL, NULL, NULL, 4),
(135107, NULL, 'G3DSA:1.25.40.10:FF:002003', NULL, NULL, 'Os02g0555100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(135108, NULL, 'G3DSA:2.60.120.10:FF:000275', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(135109, NULL, 'G3DSA:1.10.8.480:FF:000015', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(135110, NULL, 'G3DSA:3.30.930.10:FF:000115', NULL, NULL, 'Phenylalanine-tRNA ligase, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(135111, NULL, 'G3DSA:3.90.70.10:FF:000400', NULL, NULL, 'SPbeta prophage-derived sublancin-168-processing and transport ATP-binding protein SunT', NULL, NULL, NULL, NULL, NULL, 4),
(135112, NULL, 'G3DSA:1.20.1070.10:FF:000277', NULL, NULL, 'Muscarinic acetylcholine receptor A-type', NULL, NULL, NULL, NULL, NULL, 4),
(135113, NULL, 'G3DSA:1.10.520.10:FF:000028', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(135114, NULL, 'G3DSA:3.40.50.2300:FF:000485', NULL, NULL, 'Chemotaxis protein CheC--inhibitor of MCP methylation', NULL, NULL, NULL, NULL, NULL, 4),
(135115, NULL, 'G3DSA:3.30.160.60:FF:001268', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(135116, NULL, 'G3DSA:3.20.20.190:FF:000008', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(135117, NULL, 'G3DSA:2.60.40.10:FF:005096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135118, NULL, 'G3DSA:3.40.50.2000:FF:000485', NULL, NULL, 'Alpha-1,3/1,6-mannosyltransferase alg-2', NULL, NULL, NULL, NULL, NULL, 4),
(135119, NULL, 'G3DSA:1.10.275.60:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135120, NULL, 'G3DSA:3.80.10.10:FF:001100', NULL, NULL, 'relaxin receptor 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(135121, NULL, 'G3DSA:3.30.160.60:FF:005871', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135122, NULL, 'G3DSA:3.30.200.20:FF:001451', NULL, NULL, 'Myosin heavy chain kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(135123, NULL, 'G3DSA:1.10.287.130:FF:000117', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(135124, NULL, 'G3DSA:1.10.10.10:FF:000989', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(135125, NULL, 'G3DSA:2.170.180.11:FF:000006', NULL, NULL, 'Methuselah-like 8, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(135126, NULL, 'G3DSA:3.30.460.10:FF:000039', NULL, NULL, 'Ribosomal silencing factor RsfS', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(135127, NULL, 'G3DSA:3.40.50.1010:FF:000283', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135128, NULL, 'G3DSA:1.20.1270.60:FF:000133', NULL, NULL, 'SLIT-ROBO Rho GTPase-activating protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(135129, NULL, 'G3DSA:3.20.20.80:FF:000466', NULL, NULL, 'Beta-1,3-exoglucosidase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(135130, NULL, 'G3DSA:3.40.220.10:FF:000008', NULL, NULL, 'Orf1a polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(135131, NULL, 'G3DSA:1.10.10.1150:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135132, NULL, 'G3DSA:3.10.280.10:FF:000018', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(135133, NULL, 'G3DSA:2.60.40.10:FF:003538', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135134, NULL, 'G3DSA:3.60.10.10:FF:000319', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135135, NULL, 'G3DSA:1.50.40.10:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135136, NULL, 'G3DSA:3.20.20.70:FF:000463', NULL, NULL, 'Pentafunctional AROM polypeptide, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135137, NULL, 'G3DSA:2.60.120.1300:FF:000001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135138, NULL, 'G3DSA:3.30.310.130:FF:000031', NULL, NULL, 'FI06413p', NULL, NULL, NULL, NULL, NULL, 4),
(135139, NULL, 'G3DSA:2.130.10.10:FF:003730', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135140, NULL, 'G3DSA:3.70.10.10:FF:000122', NULL, NULL, 'Checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(135141, NULL, 'G3DSA:3.40.50.10240:FF:000016', NULL, NULL, 'Thiamin pyrophosphokinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(135142, NULL, 'G3DSA:3.30.420.10:FF:000262', NULL, NULL, 'Gag-Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(135143, NULL, 'G3DSA:3.30.70.1230:FF:000183', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135144, NULL, 'G3DSA:3.90.1460.10:FF:000002', NULL, NULL, 'General transcription factor II-I isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(135145, NULL, 'G3DSA:3.40.50.1820:FF:000981', NULL, NULL, 'Protein ABHD8', NULL, NULL, NULL, NULL, NULL, 4),
(135146, NULL, 'G3DSA:1.20.1740.10:FF:000019', NULL, NULL, 'Tryptophan permease TnaB', NULL, NULL, NULL, NULL, NULL, 4),
(135147, NULL, 'G3DSA:2.60.40.3120:FF:000007', NULL, NULL, 'Zinc carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135148, NULL, 'G3DSA:1.10.10.10:FF:001147', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135149, NULL, 'G3DSA:1.20.930.40:FF:000004', NULL, NULL, 'N-acetylated alpha-linked acidic dipeptidase like 2', NULL, NULL, NULL, NULL, NULL, 4),
(135150, NULL, 'G3DSA:3.90.640.10:FF:000169', NULL, NULL, 'Heat shock protein family A (Hsp70) member 13', NULL, NULL, NULL, NULL, NULL, 4),
(135151, NULL, 'G3DSA:2.60.120.200:FF:000615', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135152, NULL, 'G3DSA:3.80.10.10:FF:002853', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135153, NULL, 'G3DSA:3.60.21.10:FF:000013', NULL, NULL, 'Bis(5''-nucleosyl)-tetraphosphatase, symmetrical', NULL, NULL, NULL, NULL, NULL, 4),
(135154, NULL, 'G3DSA:3.20.20.80:FF:000707', NULL, NULL, 'Beta-mannosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135155, NULL, 'G3DSA:3.20.20.80:FF:000365', NULL, NULL, 'Putative glucosylceramidase/O-glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(135156, NULL, 'G3DSA:3.30.710.10:FF:000363', NULL, NULL, 'BTB/POZ domain-containing protein At3g09030', NULL, NULL, NULL, NULL, NULL, 4),
(135157, NULL, 'G3DSA:3.90.1750.10:FF:000103', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135158, NULL, 'G3DSA:3.10.20.90:FF:000430', NULL, NULL, 'Ubiquitin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(135159, NULL, 'G3DSA:3.30.460.10:FF:000028', NULL, NULL, 'DNA nucleotidylexotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(135160, NULL, 'G3DSA:3.40.50.720:FF:000944', NULL, NULL, 'Sterol-4alpha-carboxylate 3-dehydrogenase (Decarboxylating)', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(135161, NULL, 'G3DSA:3.30.160.60:FF:001734', NULL, NULL, 'Zinc finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135162, NULL, 'G3DSA:3.40.50.150:FF:001684', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135163, NULL, 'G3DSA:3.80.10.10:FF:002623', NULL, NULL, 'Disease resistance protein (TIR-NBS-LRR class)', NULL, NULL, NULL, NULL, NULL, 4),
(135164, NULL, 'G3DSA:1.20.58.60:FF:000877', NULL, NULL, 'Kalirin RhoGEF kinase a', NULL, NULL, NULL, NULL, NULL, 4),
(135165, NULL, 'G3DSA:3.60.10.10:FF:000196', NULL, NULL, 'Endonuclease/exonuclease/phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135166, NULL, 'G3DSA:1.10.418.20:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135167, NULL, 'G3DSA:3.80.10.10:FF:000482', NULL, NULL, 'Transforming growth factor beta activator LRRC32', NULL, NULL, NULL, NULL, NULL, 4),
(135168, NULL, 'G3DSA:3.40.630.30:FF:000461', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135169, NULL, 'G3DSA:3.40.50.300:FF:001555', NULL, NULL, 'Putative ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(135170, NULL, 'G3DSA:1.20.1300.10:FF:000014', NULL, NULL, 'Succinate dehydrogenase subunit 3-1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(135171, NULL, 'G3DSA:3.90.470.40:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135172, NULL, 'G3DSA:3.10.590.10:FF:000008', NULL, NULL, 'Ubiquinol-cytochrome C reductase', NULL, NULL, NULL, NULL, NULL, 4),
(135173, NULL, 'G3DSA:3.30.40.10:FF:002099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135174, NULL, 'G3DSA:1.20.5.100:FF:000034', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(135175, NULL, 'G3DSA:3.80.10.10:FF:000824', NULL, NULL, 'Receptor-like protein kinase HSL1 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(135176, NULL, 'G3DSA:1.20.1300.20:FF:000017', NULL, NULL, 'Os02g0521500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(135177, NULL, 'G3DSA:1.10.510.10:FF:001383', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(135178, NULL, 'G3DSA:1.20.58.530:FF:000022', NULL, NULL, 'Myosin heavy chain, muscle', NULL, NULL, NULL, NULL, NULL, 4),
(135179, NULL, 'G3DSA:1.20.1050.10:FF:000169', NULL, NULL, 'Glutathione S-transferase epsilon class 6', NULL, NULL, NULL, NULL, NULL, 4),
(135180, NULL, 'G3DSA:2.130.10.10:FF:000402', NULL, NULL, 'Cleavage and polyadenylation specificity factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(135181, NULL, 'G3DSA:3.20.20.70:FF:000704', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135182, NULL, 'G3DSA:3.30.190.20:FF:000038', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135183, NULL, 'G3DSA:1.20.1070.10:FF:000619', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135184, NULL, 'G3DSA:3.40.50.300:FF:007384', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135185, NULL, 'G3DSA:1.25.10.10:FF:001119', NULL, NULL, 'Cilia- and flagella-associated protein 69', NULL, NULL, NULL, NULL, NULL, 4),
(135186, NULL, 'G3DSA:2.60.40.10:FF:002223', NULL, NULL, 'KETtiN (Drosophila actin-binding) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(135187, NULL, 'G3DSA:1.20.1270.50:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135188, NULL, 'G3DSA:1.10.510.10:FF:000202', NULL, NULL, 'Dual specificity testis-specific protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(135189, NULL, 'G3DSA:1.10.510.10:FF:002231', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135190, NULL, 'G3DSA:1.20.140.10:FF:000008', NULL, NULL, 'acyl-CoA dehydrogenase family member 9, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(135191, NULL, 'G3DSA:3.40.50.12160:FF:000013', NULL, NULL, 'Radical SAM protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135192, NULL, 'G3DSA:3.40.50.12710:FF:000009', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7', NULL, NULL, NULL, NULL, NULL, 4),
(135193, NULL, 'G3DSA:1.25.40.120:FF:000008', NULL, NULL, 'Protein farnesyltransferase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(135194, NULL, 'G3DSA:3.30.160.60:FF:003533', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135195, NULL, 'G3DSA:2.60.120.200:FF:000374', NULL, NULL, 'Peptide-N4-(N-acetyl-beta-glucosaminyl)asparagine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(135196, NULL, 'G3DSA:3.40.30.90:FF:000002', NULL, NULL, 'Eukaryotic translation elongation factor 1 epsilon-1', NULL, NULL, NULL, NULL, NULL, 4),
(135197, NULL, 'G3DSA:1.10.1040.10:FF:000047', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(135198, NULL, 'G3DSA:3.40.605.10:FF:000048', NULL, NULL, 'Probable aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(135199, NULL, 'G3DSA:3.40.50.300:FF:000127', NULL, NULL, 'Ribose import ATP-binding protein RbsA', NULL, NULL, NULL, NULL, NULL, 4),
(135200, NULL, 'G3DSA:3.40.50.10380:FF:000030', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(135201, NULL, 'G3DSA:3.40.1110.10:FF:000432', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135202, NULL, 'G3DSA:3.40.50.720:FF:000259', NULL, NULL, 'Sepiapterin reductase', NULL, NULL, NULL, NULL, NULL, 4),
(135203, NULL, 'G3DSA:4.10.280.10:FF:000155', NULL, NULL, 'Upstream stimulatory factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(135204, NULL, 'G3DSA:1.20.1070.10:FF:002177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135205, NULL, 'G3DSA:3.20.20.140:FF:000347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135206, NULL, 'G3DSA:2.80.10.50:FF:000203', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135207, NULL, 'G3DSA:3.40.50.300:FF:007406', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135208, NULL, 'G3DSA:1.25.40.10:FF:005084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135209, NULL, 'G3DSA:1.25.40.10:FF:001385', NULL, NULL, 'Os01g0299150 protein', NULL, NULL, NULL, NULL, NULL, 4),
(135210, NULL, 'G3DSA:2.10.90.10:FF:000121', NULL, NULL, 'Protein trunk', NULL, NULL, NULL, NULL, NULL, 4),
(135211, NULL, 'G3DSA:2.60.120.200:FF:000716', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135212, NULL, 'G3DSA:1.20.1070.10:FF:001215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135213, NULL, 'G3DSA:3.40.50.10090:FF:000044', NULL, NULL, 'Putative uroporphyrinogen III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(135214, NULL, 'G3DSA:3.30.160.60:FF:005663', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135215, NULL, 'G3DSA:1.25.40.10:FF:003526', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135216, NULL, 'G3DSA:1.20.1410.10:FF:000023', NULL, NULL, 'YALI0F30195p', NULL, NULL, NULL, NULL, NULL, 4),
(135217, NULL, 'G3DSA:2.60.120.290:FF:000136', NULL, NULL, 'GD12774', NULL, NULL, NULL, NULL, NULL, 4),
(135218, NULL, 'G3DSA:1.10.510.10:FF:000101', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(135219, NULL, 'G3DSA:2.60.40.10:FF:001947', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135220, NULL, 'G3DSA:6.10.140.2220:FF:000014', NULL, NULL, 'Programmed cell death 2', NULL, NULL, NULL, NULL, NULL, 4),
(135221, NULL, 'G3DSA:2.40.160.20:FF:000032', NULL, NULL, 'Putative outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(135222, NULL, 'G3DSA:3.40.50.1360:FF:000028', NULL, NULL, 'Glucosamine-6-phosphate deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(135223, NULL, 'G3DSA:3.40.710.10:FF:000068', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(135224, NULL, 'G3DSA:1.10.555.10:FF:000171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135225, NULL, 'G3DSA:2.40.33.10:FF:000004', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(135226, NULL, 'G3DSA:3.90.360.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135227, NULL, 'G3DSA:3.30.420.510:FF:000001', NULL, NULL, 'pantothenate kinase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(135228, NULL, 'G3DSA:2.60.120.380:FF:000051', NULL, NULL, 'Serine/threonine-protein kinase 4 homolog B', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(135229, NULL, 'G3DSA:3.80.10.10:FF:004298', NULL, NULL, 'Leucine rich repeat containing G protein-coupled receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(135230, NULL, 'G3DSA:2.60.40.10:FF:003746', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135231, NULL, 'G3DSA:2.30.42.10:FF:000296', NULL, NULL, 'Rho GTPase activating protein at 19D, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(135232, NULL, 'G3DSA:2.60.40.10:FF:004022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135233, NULL, 'G3DSA:1.10.510.10:FF:002001', NULL, NULL, 'Protein CBG00206', NULL, NULL, NULL, NULL, NULL, 4),
(135234, NULL, 'G3DSA:1.10.10.350:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135235, NULL, 'G3DSA:3.20.20.70:FF:000362', NULL, NULL, 'Phosphoribosylanthranilate isomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(135236, NULL, 'G3DSA:3.80.10.10:FF:000723', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(135237, NULL, 'G3DSA:3.40.50.12780:FF:000199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135238, NULL, 'G3DSA:1.20.1730.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135239, NULL, 'G3DSA:3.30.9.10:FF:000115', NULL, NULL, 'Oxidoreductase, FAD dependent', NULL, NULL, NULL, NULL, NULL, 4),
(135240, NULL, 'G3DSA:1.25.40.20:FF:001377', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135241, NULL, 'G3DSA:3.20.20.80:FF:000820', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135242, NULL, 'G3DSA:3.40.50.300:FF:001993', NULL, NULL, 'DNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135243, NULL, 'G3DSA:3.40.50.300:FF:003455', NULL, NULL, 'Nuclear vcp-like-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(135244, NULL, 'G3DSA:3.30.710.10:FF:000464', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135245, NULL, 'G3DSA:1.10.287.70:FF:000469', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135246, NULL, 'G3DSA:3.90.470.20:FF:000001', NULL, NULL, 'Holo-[acyl-carrier-protein] synthase', NULL, NULL, NULL, NULL, NULL, 4),
(135247, NULL, 'G3DSA:1.25.50.20:FF:000034', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(135248, NULL, 'G3DSA:1.10.8.60:FF:000093', NULL, NULL, 'Fidgetin like 2', NULL, NULL, NULL, NULL, NULL, 4),
(135249, NULL, 'G3DSA:3.30.420.10:FF:000582', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135250, NULL, 'G3DSA:2.60.40.10:FF:000323', NULL, NULL, 'Immunoglobulin superfamily member 9B', NULL, NULL, NULL, NULL, NULL, 4),
(135251, NULL, 'G3DSA:1.25.40.10:FF:001374', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(135252, NULL, 'G3DSA:1.10.510.10:FF:001725', NULL, NULL, 'Kinase like protein', NULL, NULL, NULL, NULL, NULL, 4),
(135253, NULL, 'G3DSA:2.60.40.2440:FF:000005', NULL, NULL, 'Protein phosphatase 1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(135254, NULL, 'G3DSA:2.60.40.10:FF:001285', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(135255, NULL, 'G3DSA:1.20.1070.10:FF:000378', NULL, NULL, 'CG18208-like amine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(135256, NULL, 'G3DSA:3.30.70.330:FF:000856', NULL, NULL, '60S ribosomal protein L23', NULL, NULL, NULL, NULL, NULL, 4),
(135257, NULL, 'G3DSA:1.10.10.2910:FF:000001', NULL, NULL, 'Metallopeptidase ImmA', NULL, NULL, NULL, NULL, NULL, 4),
(135258, NULL, 'G3DSA:4.10.400.10:FF:000244', NULL, NULL, 'Serine protease nudel', NULL, NULL, NULL, NULL, NULL, 4),
(135259, NULL, 'G3DSA:3.30.70.330:FF:003032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135260, NULL, 'G3DSA:2.10.25.10:FF:000723', NULL, NULL, 'neurogenic locus notch homolog protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(135261, NULL, 'G3DSA:3.60.40.10:FF:000265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135262, NULL, 'G3DSA:3.40.50.300:FF:003893', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(135263, NULL, 'G3DSA:2.60.40.3850:FF:000001', NULL, NULL, 'Interleukin-3 receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(135264, NULL, 'G3DSA:3.40.50.300:FF:004511', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(135265, NULL, 'G3DSA:2.30.29.30:FF:000563', NULL, NULL, 'Phosphatidylinositol3,4-bisphosphate 4-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(135266, NULL, 'G3DSA:3.30.160.20:FF:000098', NULL, NULL, '30S small subunit ribosomal protein S5', NULL, NULL, NULL, NULL, NULL, 4),
(135267, NULL, 'G3DSA:3.10.20.90:FF:000110', NULL, NULL, 'GA-binding protein alpha chain isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(135268, NULL, 'G3DSA:3.30.70.330:FF:001132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135269, NULL, 'G3DSA:2.130.10.10:FF:003836', NULL, NULL, 'ADR108Cp', NULL, NULL, NULL, NULL, NULL, 4),
(135270, NULL, 'G3DSA:2.60.40.150:FF:000231', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135271, NULL, 'G3DSA:2.10.50.10:FF:000124', NULL, NULL, 'Death receptor 6', NULL, NULL, NULL, NULL, NULL, 4),
(135272, NULL, 'G3DSA:3.30.70.360:FF:000045', NULL, NULL, 'Novel protein aminoacylase 1 family 2 ACY1L2 (Homo sapiens), putative', NULL, NULL, NULL, NULL, NULL, 4),
(135273, NULL, 'G3DSA:1.10.287.40:FF:000011', NULL, NULL, 'Serine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(135274, NULL, 'G3DSA:1.10.3290.20:FF:000001', NULL, NULL, 'Avirulence protein', NULL, NULL, NULL, NULL, NULL, 4),
(135275, NULL, 'G3DSA:2.40.50.120:FF:000049', NULL, NULL, 'TIMP metallopeptidase inhibitor 2b', NULL, NULL, NULL, NULL, NULL, 4),
(135276, NULL, 'G3DSA:3.30.200.20:FF:001338', NULL, NULL, 'Heme regulated eukaryotic translation initiation factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(135277, NULL, 'G3DSA:1.10.287.70:FF:000571', NULL, NULL, 'Inward rectifier potassium channel 2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(135278, NULL, 'G3DSA:1.10.1200.10:FF:000144', NULL, NULL, 'Novobiocin biosynthesis protein H', NULL, NULL, NULL, NULL, NULL, 4),
(135279, NULL, 'G3DSA:3.30.200.20:FF:001108', NULL, NULL, 'Kinase, AGC MAST', NULL, NULL, NULL, NULL, NULL, 4),
(135280, NULL, 'G3DSA:1.20.1250.20:FF:001204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135281, NULL, 'G3DSA:3.40.50.2000:FF:000496', NULL, NULL, 'Glycosyltransferase 9 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(135282, NULL, 'G3DSA:3.40.50.150:FF:001364', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135283, NULL, 'G3DSA:3.40.50.2000:FF:001114', NULL, NULL, 'UDP-glycosyltransferase 90A1', NULL, NULL, NULL, NULL, NULL, 4),
(135284, NULL, 'G3DSA:1.25.40.70:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135285, NULL, 'G3DSA:2.40.30.10:FF:000211', NULL, NULL, 'Elongation factor 1-alpha, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135286, NULL, 'G3DSA:2.30.29.110:FF:000003', NULL, NULL, 'Inositol polyphosphate-5-phosphatase B', NULL, NULL, NULL, NULL, NULL, 4),
(135287, NULL, 'G3DSA:3.40.50.10190:FF:000282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135288, NULL, 'G3DSA:1.25.40.10:FF:000879', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(135289, NULL, 'G3DSA:1.10.20.10:FF:000231', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135290, NULL, 'G3DSA:3.40.50.2000:FF:000838', NULL, NULL, 'Protein CBR-SPR-1', NULL, NULL, NULL, NULL, NULL, 4),
(135291, NULL, 'G3DSA:3.40.250.10:FF:000263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135292, NULL, 'G3DSA:3.50.50.60:FF:000399', NULL, NULL, 'FAD-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(135293, NULL, 'G3DSA:2.60.40.840:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135294, NULL, 'G3DSA:1.10.10.10:FF:001927', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135295, NULL, 'G3DSA:2.40.50.140:FF:001224', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(135296, NULL, 'G3DSA:3.30.450.20:FF:000093', NULL, NULL, 'Histidine kinase A two component receptor', NULL, NULL, NULL, NULL, NULL, 4),
(135297, NULL, 'G3DSA:1.20.140.50:FF:000003', NULL, NULL, 'GH16790', NULL, NULL, NULL, NULL, NULL, 4),
(135298, NULL, 'G3DSA:2.60.40.10:FF:003185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135299, NULL, 'G3DSA:1.10.150.50:FF:000214', NULL, NULL, 'B cell linker', NULL, NULL, NULL, NULL, NULL, 4),
(135300, NULL, 'G3DSA:3.30.160.60:FF:003179', NULL, NULL, 'Zinc finger protein 404', NULL, NULL, NULL, NULL, NULL, 4),
(135301, NULL, 'G3DSA:3.40.50.720:FF:001107', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(135302, NULL, 'G3DSA:2.40.50.140:FF:000948', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135303, NULL, 'G3DSA:3.30.70.330:FF:002756', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135304, NULL, 'G3DSA:3.10.129.10:FF:000179', NULL, NULL, '1,4-dihydroxy-2-naphthoyl-CoA hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(135305, NULL, 'G3DSA:3.30.950.10:FF:000015', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase I', NULL, NULL, NULL, NULL, NULL, 4),
(135306, NULL, 'G3DSA:2.80.10.50:FF:000080', NULL, NULL, 'Dolichyl-phosphate-mannose-protein mannosyltransferase 6', NULL, NULL, NULL, NULL, NULL, 4),
(135307, NULL, 'G3DSA:3.40.50.2300:FF:001209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135308, NULL, 'G3DSA:3.40.710.10:FF:000181', NULL, NULL, 'Penicillin-binding protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(135309, NULL, 'G3DSA:3.40.630.30:FF:000141', NULL, NULL, 'Acetyltransferase, GNAT family family', NULL, NULL, NULL, NULL, NULL, 4),
(135310, NULL, 'G3DSA:1.20.1250.20:FF:000928', NULL, NULL, 'Major facilitator superfamily MFS_1', NULL, NULL, NULL, NULL, NULL, 4),
(135311, NULL, 'G3DSA:1.20.1070.10:FF:000939', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135312, NULL, 'G3DSA:3.30.70.260:FF:000127', NULL, NULL, 'Tyrosine hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(135313, NULL, 'G3DSA:1.10.101.10:FF:000027', NULL, NULL, 'Carboxy-terminal processing protease', NULL, NULL, NULL, NULL, NULL, 4),
(135314, NULL, 'G3DSA:3.50.50.100:FF:000020', NULL, NULL, 'NADH dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(135315, NULL, 'G3DSA:1.20.1560.10:FF:000926', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135316, NULL, 'G3DSA:1.25.40.180:FF:000329', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135317, NULL, 'G3DSA:3.40.850.10:FF:000365', NULL, NULL, 'Myosin IHb', NULL, NULL, NULL, NULL, NULL, 4),
(135318, NULL, 'G3DSA:3.40.1160.10:FF:000047', NULL, NULL, 'Acetylglutamate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(135319, NULL, 'G3DSA:3.40.50.720:FF:002389', NULL, NULL, 'S or R-dihydroxypropanesulfonate-2-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(135320, NULL, 'G3DSA:4.10.1060.10:FF:000063', NULL, NULL, 'Zinc finger Ran-binding domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(135321, NULL, 'G3DSA:2.20.100.10:FF:000137', NULL, NULL, 'SPONdin (Extracellular matrix glycoprotein) family', NULL, NULL, NULL, NULL, NULL, 4),
(135322, NULL, 'G3DSA:3.30.300.110:FF:000006', NULL, NULL, 'Met-10+ like-protein/Methyltransferase small domain/Methyltransferase domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135323, NULL, 'G3DSA:3.30.1360.120:FF:000042', NULL, NULL, 'Sarcosine oxidase, alpha subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(135324, NULL, 'G3DSA:1.10.287.500:FF:000003', NULL, NULL, 'Protein phosphatase CheZ', NULL, NULL, NULL, NULL, NULL, 4),
(135325, NULL, 'G3DSA:3.90.190.10:FF:000544', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135326, NULL, 'G3DSA:1.25.10.10:FF:001557', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135327, NULL, 'G3DSA:1.20.58.390:FF:000053', NULL, NULL, 'Neuronal acetylcholine receptor subunit alpha-9', NULL, NULL, NULL, NULL, NULL, 4),
(135328, NULL, 'G3DSA:3.30.160.60:FF:000306', NULL, NULL, 'Zinc finger and AT-hook domain containing', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(135329, NULL, 'G3DSA:3.80.10.10:FF:000369', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', NULL, NULL, NULL, NULL, NULL, 4),
(135330, NULL, 'G3DSA:2.130.10.10:FF:005427', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135331, NULL, 'G3DSA:1.25.10.20:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135332, NULL, 'G3DSA:1.10.560.10:FF:000025', NULL, NULL, 'T-complex protein 1 subunit zeta isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(135333, NULL, 'G3DSA:3.40.50.2300:FF:001311', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135334, NULL, 'G3DSA:1.10.220.20:FF:000003', NULL, NULL, 'Cytohesin 1', NULL, NULL, NULL, NULL, NULL, 4),
(135335, NULL, 'G3DSA:1.25.10.10:FF:003457', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135336, NULL, 'G3DSA:1.25.10.10:FF:000023', NULL, NULL, 'AP-3 complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(135337, NULL, 'G3DSA:2.40.50.100:FF:000043', NULL, NULL, 'Multidrug resistance protein MdtN', NULL, NULL, NULL, NULL, NULL, 4),
(135338, NULL, 'G3DSA:3.40.50.300:FF:007945', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135339, NULL, 'G3DSA:3.40.50.1820:FF:000649', NULL, NULL, 'Lipase A, lysosomal acid, cholesterol esterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135340, NULL, 'G3DSA:3.40.190.80:FF:000076', NULL, NULL, 'Fructose-1,6-bisphosphatase class 1', NULL, NULL, NULL, NULL, NULL, 4),
(135341, NULL, 'G3DSA:1.10.287.660:FF:000023', NULL, NULL, 'Tail-anchored protein insertion receptor WRB', NULL, NULL, NULL, NULL, NULL, 4),
(135342, NULL, 'G3DSA:1.10.8.60:FF:000205', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(135343, NULL, 'G3DSA:1.10.10.10:FF:001720', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(135344, NULL, 'G3DSA:3.30.160.380:FF:000003', NULL, NULL, 'Endoribonuclease dcr-1', NULL, NULL, NULL, NULL, NULL, 4),
(135345, NULL, 'G3DSA:3.30.930.10:FF:000126', NULL, NULL, 'Phenylalanine-tRNA ligase, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(135346, NULL, 'G3DSA:2.130.10.10:FF:003275', NULL, NULL, 'Wdr1p', NULL, NULL, NULL, NULL, NULL, 4),
(135347, NULL, 'G3DSA:2.10.220.10:FF:000125', NULL, NULL, 'R-spondin 1', NULL, NULL, NULL, NULL, NULL, 4),
(135348, NULL, 'G3DSA:2.60.40.1730:FF:000034', NULL, NULL, 'Chromosome 9 open reading frame 3', NULL, NULL, NULL, NULL, NULL, 4),
(135349, NULL, 'G3DSA:3.40.50.1110:FF:000083', NULL, NULL, 'Phospholipase B1', NULL, NULL, NULL, NULL, NULL, 4),
(135350, NULL, 'G3DSA:1.10.220.30:FF:000006', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(135351, NULL, 'G3DSA:3.40.50.300:FF:008221', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(135352, NULL, 'G3DSA:2.60.120.10:FF:000730', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135353, NULL, 'G3DSA:2.30.310.10:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135354, NULL, 'G3DSA:3.30.200.20:FF:001440', NULL, NULL, 'STK38L isoform 10', NULL, NULL, NULL, NULL, NULL, 4),
(135355, NULL, 'G3DSA:3.40.50.11090:FF:000001', NULL, NULL, 'Sll5048 protein', NULL, NULL, NULL, NULL, NULL, 4),
(135356, NULL, 'G3DSA:2.10.90.10:FF:000019', NULL, NULL, 'Sclerostin domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(135357, NULL, 'G3DSA:1.20.1070.10:FF:000732', NULL, NULL, 'Adhesion G protein-coupled receptor L3', NULL, NULL, NULL, NULL, NULL, 4),
(135358, NULL, 'G3DSA:2.60.40.640:FF:000041', NULL, NULL, 'SPO23p protein', NULL, NULL, NULL, NULL, NULL, 4),
(135359, NULL, 'G3DSA:3.30.70.100:FF:000107', NULL, NULL, 'Acylphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(135360, NULL, 'G3DSA:2.90.10.30:FF:000006', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(135361, NULL, 'G3DSA:2.130.10.10:FF:002999', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135362, NULL, 'G3DSA:3.15.10.10:FF:000002', NULL, NULL, 'Cholesteryl ester transfer protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(135363, NULL, 'G3DSA:3.40.50.720:FF:000489', NULL, NULL, 'N(5)-(Carboxyethyl)ornithine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(135364, NULL, 'G3DSA:3.30.160.60:FF:001279', NULL, NULL, 'zinc finger and BTB domain-containing protein 32', NULL, NULL, NULL, NULL, NULL, 4),
(135365, NULL, 'G3DSA:2.60.40.3110:FF:000004', NULL, NULL, 'Protein CsuD', NULL, NULL, NULL, NULL, NULL, 4),
(135366, NULL, 'G3DSA:1.25.40.90:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135367, NULL, 'G3DSA:2.30.29.30:FF:000782', NULL, NULL, 'Rho guanine nucleotide exchange factor (GEF) 10', NULL, NULL, NULL, NULL, NULL, 4),
(135368, NULL, 'G3DSA:3.40.50.300:FF:005484', NULL, NULL, 'Putative ABC transport ATP-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(135369, NULL, 'G3DSA:3.30.160.390:FF:000006', NULL, NULL, 'Site-specific recombinase, phage integrase family domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(135370, NULL, 'G3DSA:3.40.50.1100:FF:000080', NULL, NULL, 'Diaminopropionate ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(135371, NULL, 'G3DSA:1.20.1250.20:FF:000367', NULL, NULL, 'Major facilitator superfamily domain containing 4B', NULL, NULL, NULL, NULL, NULL, 4),
(135372, NULL, 'G3DSA:2.60.220.50:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135373, NULL, 'G3DSA:1.25.40.1040:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135374, NULL, 'G3DSA:3.40.50.300:FF:002038', NULL, NULL, 'tRNA modification GTPase MnmE', NULL, NULL, NULL, NULL, NULL, 4),
(135375, NULL, 'G3DSA:3.40.190.10:FF:000786', NULL, NULL, 'Dipeptide ABC superfamily ATP binding cassette transporter, binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(135376, NULL, 'G3DSA:1.10.10.10:FF:001259', NULL, NULL, 'Manganese transport system membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(135377, NULL, 'G3DSA:1.20.120.850:FF:000005', NULL, NULL, 'Helicase arip4 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(135378, NULL, 'G3DSA:1.20.120.550:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135379, NULL, 'G3DSA:3.40.50.300:FF:006321', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135380, NULL, 'G3DSA:1.20.900.10:FF:000084', NULL, NULL, 'Kalirin RhoGEF kinase a', NULL, NULL, NULL, NULL, NULL, 4),
(135381, NULL, 'G3DSA:3.65.10.10:FF:000011', NULL, NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(135382, NULL, 'G3DSA:3.30.160.60:FF:003752', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135383, NULL, 'G3DSA:3.40.50.620:FF:000908', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135384, NULL, 'G3DSA:1.20.120.1080:FF:000148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135385, NULL, 'G3DSA:1.25.40.1030:FF:000025', NULL, NULL, 'SEC16 homolog B, endoplasmic reticulum export factor', NULL, NULL, NULL, NULL, NULL, 4),
(135386, NULL, 'G3DSA:1.10.8.720:FF:000020', NULL, NULL, 'Glutathione S-transferase class-mu 26 kDa isozyme', NULL, NULL, NULL, NULL, NULL, 4),
(135387, NULL, 'G3DSA:1.25.40.10:FF:001941', NULL, NULL, 'RNA polymerase-associated protein CTR9', NULL, NULL, NULL, NULL, NULL, 4),
(135388, NULL, 'G3DSA:3.80.10.10:FF:002741', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135389, NULL, 'G3DSA:3.40.50.300:FF:003573', NULL, NULL, 'Zinc transport system ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(135390, NULL, 'G3DSA:1.20.1610.10:FF:000010', NULL, NULL, 'Putative conserved exported protein', NULL, NULL, NULL, NULL, NULL, 4),
(135391, NULL, 'G3DSA:3.40.50.720:FF:001102', NULL, NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(135392, NULL, 'G3DSA:2.60.120.200:FF:000379', NULL, NULL, 'Terribly reduced optic lobes, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(135393, NULL, 'G3DSA:1.20.1730.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135394, NULL, 'G3DSA:3.40.50.2000:FF:000945', NULL, NULL, 'Sterol 3beta-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(135395, NULL, 'G3DSA:3.30.420.10:FF:000368', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135396, NULL, 'G3DSA:1.20.920.10:FF:000079', NULL, NULL, 'Unplaced genomic scaffold supercont1.199, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(135397, NULL, 'G3DSA:3.30.70.890:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135398, NULL, 'G3DSA:1.20.1630.10:FF:000005', NULL, NULL, 'Putative dimethyl sulfoxide reductase membrane subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(135399, NULL, 'G3DSA:2.30.30.140:FF:000328', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(135400, NULL, 'G3DSA:2.60.120.920:FF:000027', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM50', NULL, NULL, NULL, NULL, NULL, 4),
(135401, NULL, 'G3DSA:3.90.1110.10:FF:000010', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(135402, NULL, 'G3DSA:2.130.10.10:FF:005298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135403, NULL, 'G3DSA:3.80.10.10:FF:000594', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', NULL, NULL, NULL, NULL, NULL, 4),
(135404, NULL, 'G3DSA:3.90.640.10:FF:000287', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(135405, NULL, 'G3DSA:3.40.50.10930:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135406, NULL, 'G3DSA:1.25.40.20:FF:000421', NULL, NULL, 'Glycerophosphocholine phosphodiesterase GDE1', NULL, NULL, NULL, NULL, NULL, 4),
(135407, NULL, 'G3DSA:3.40.50.10190:FF:000175', NULL, NULL, 'DNA ligase 4', NULL, NULL, NULL, NULL, NULL, 4),
(135408, NULL, 'G3DSA:3.40.50.10490:FF:000158', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135409, NULL, 'G3DSA:3.90.850.10:FF:000005', NULL, NULL, 'FAA hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(135410, NULL, 'G3DSA:1.20.1560.10:FF:000359', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135411, NULL, 'G3DSA:1.20.58.150:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135412, NULL, 'G3DSA:3.40.1110.10:FF:000218', NULL, NULL, 'Heavy metal translocating P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(135413, NULL, 'G3DSA:2.130.10.10:FF:003174', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135414, NULL, 'G3DSA:1.10.150.50:FF:000113', NULL, NULL, 'DNA-binding protein D-ETS-6', NULL, NULL, NULL, NULL, NULL, 4),
(135415, NULL, 'G3DSA:3.10.105.10:FF:000062', NULL, NULL, 'Peptide transport periplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(135416, NULL, 'G3DSA:2.60.40.10:FF:005438', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135417, NULL, 'G3DSA:1.25.40.20:FF:000314', NULL, NULL, 'Ankyrin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(135418, NULL, 'G3DSA:1.20.1560.10:FF:000466', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(135419, NULL, 'G3DSA:1.10.8.10:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135420, NULL, 'G3DSA:1.10.510.10:FF:001495', NULL, NULL, 'Serine/threonine protein kinase Chk2,putative', NULL, NULL, NULL, NULL, NULL, 4),
(135421, NULL, 'G3DSA:1.10.472.140:FF:000008', NULL, NULL, 'Retinoblastoma-related protein2', NULL, NULL, NULL, NULL, NULL, 4),
(135422, NULL, 'G3DSA:3.10.20.770:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135423, NULL, 'G3DSA:2.40.50.360:FF:000003', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(135424, NULL, 'G3DSA:2.130.10.10:FF:003281', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135425, NULL, 'G3DSA:3.40.50.10190:FF:000068', NULL, NULL, 'Replication factor C subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(135426, NULL, 'G3DSA:3.40.50.2300:FF:000928', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135427, NULL, 'G3DSA:3.30.40.10:FF:000856', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(135428, NULL, 'G3DSA:3.65.10.20:FF:000014', NULL, NULL, 'RNA terminal phosphate cyclase like 1', NULL, NULL, NULL, NULL, NULL, 4),
(135429, NULL, 'G3DSA:3.30.160.60:FF:002217', NULL, NULL, 'RB-associated KRAB zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(135430, NULL, 'G3DSA:3.30.479.20:FF:000063', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(135431, NULL, 'G3DSA:1.25.10.10:FF:003463', NULL, NULL, 'GCN (Yeast General Control Nondrepressible) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(135432, NULL, 'G3DSA:1.10.287.70:FF:000806', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135433, NULL, 'G3DSA:1.25.40.180:FF:000094', NULL, NULL, 'Nonsense-mediated mRNA decay protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(135434, NULL, 'G3DSA:1.50.10.10:FF:000184', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(135435, NULL, 'G3DSA:1.20.1250.20:FF:000608', NULL, NULL, 'EmrB/QacA family drug resistance transporter', NULL, NULL, NULL, NULL, NULL, 4),
(135436, NULL, 'G3DSA:3.30.160.60:FF:001616', NULL, NULL, 'zinc finger protein 408 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(135437, NULL, 'G3DSA:1.10.472.130:FF:000005', NULL, NULL, 'Dynein axonemal heavy chain 7', NULL, NULL, NULL, NULL, NULL, 4),
(135438, NULL, 'G3DSA:1.10.10.250:FF:000012', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(135439, NULL, 'G3DSA:3.90.1530.10:FF:000008', NULL, NULL, '12-oxophytodienoate reductase 3', NULL, NULL, NULL, NULL, NULL, 4),
(135440, NULL, 'G3DSA:3.10.20.310:FF:000013', NULL, NULL, 'Outer envelope protein 80 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(135441, NULL, 'G3DSA:1.25.40.10:FF:005207', NULL, NULL, 'Tetratricopeptide repeat protein 21B-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(135442, NULL, 'G3DSA:1.10.3090.10:FF:000011', NULL, NULL, 'tRNA nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(135443, NULL, 'G3DSA:1.10.1200.10:FF:000037', NULL, NULL, 'CurA', NULL, NULL, NULL, NULL, NULL, 4),
(135444, NULL, 'G3DSA:3.40.50.410:FF:000059', NULL, NULL, 'Calcium-activated chloride channel regulator 2', NULL, NULL, NULL, NULL, NULL, 4),
(135445, NULL, 'G3DSA:3.30.200.20:FF:001900', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135446, NULL, 'G3DSA:2.130.10.10:FF:004697', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135447, NULL, 'G3DSA:2.60.40.1770:FF:000012', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135448, NULL, 'G3DSA:2.60.40.10:FF:001167', NULL, NULL, 'Roundabout 2, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(135449, NULL, 'G3DSA:2.10.109.10:FF:000058', NULL, NULL, 'Mitochondrial inner membrane signal peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(135450, NULL, 'G3DSA:1.20.58.60:FF:000658', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135451, NULL, 'G3DSA:3.40.50.720:FF:001091', NULL, NULL, 'Short chain dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(135452, NULL, 'G3DSA:3.40.470.10:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135453, NULL, 'G3DSA:1.25.40.10:FF:004488', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(135454, NULL, 'G3DSA:3.40.1810.10:FF:000002', NULL, NULL, 'Serum response factor b', NULL, NULL, NULL, NULL, NULL, 4),
(135455, NULL, 'G3DSA:1.20.1070.10:FF:000833', NULL, NULL, 'RYamide receptor, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(135456, NULL, 'G3DSA:2.170.120.30:FF:000013', NULL, NULL, 'Diadenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(135457, NULL, 'G3DSA:3.30.420.10:FF:000475', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135458, NULL, 'G3DSA:3.20.20.80:FF:000702', NULL, NULL, 'Glucosylceramidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135459, NULL, 'G3DSA:3.40.50.1820:FF:001037', NULL, NULL, 'Triacylglycerol lipase 1', NULL, NULL, NULL, NULL, NULL, 4),
(135460, NULL, 'G3DSA:3.30.390.130:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(135461, NULL, 'G3DSA:1.10.2000.10:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135462, NULL, 'G3DSA:3.20.20.10:FF:000035', NULL, NULL, 'Pyridoxal phosphate homeostasis protein', NULL, NULL, NULL, NULL, NULL, 4),
(135463, NULL, 'G3DSA:1.10.10.10:FF:001366', NULL, NULL, 'Vacuolar protein sorting protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135464, NULL, 'G3DSA:3.30.860.10:FF:000002', NULL, NULL, '40S ribosomal protein S15', NULL, NULL, NULL, NULL, NULL, 4),
(135465, NULL, 'G3DSA:2.60.40.10:FF:003640', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135466, NULL, 'G3DSA:3.40.50.300:FF:007951', NULL, NULL, 'AFR371Wp', NULL, NULL, NULL, NULL, NULL, 4),
(135467, NULL, 'G3DSA:3.30.70.330:FF:001351', NULL, NULL, 'FOG-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(135468, NULL, 'G3DSA:2.102.10.10:FF:000005', NULL, NULL, '3-phenylpropionate/cinnamic acid dioxygenase ferredoxin subunit', NULL, NULL, NULL, NULL, NULL, 4),
(135469, NULL, 'G3DSA:3.40.50.1100:FF:000203', NULL, NULL, 'Cbs-1', NULL, NULL, NULL, NULL, NULL, 4),
(135470, NULL, 'G3DSA:2.10.25.10:FF:000280', NULL, NULL, 'Laminin subunit beta 4', NULL, NULL, NULL, NULL, NULL, 4),
(135471, NULL, 'G3DSA:1.20.58.60:FF:000670', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135472, NULL, 'G3DSA:3.30.70.3270:FF:000019', NULL, NULL, 'Proton-translocating NADH-quinone oxidoreductase, I subunit', NULL, NULL, NULL, NULL, NULL, 4),
(135473, NULL, 'G3DSA:1.10.10.2660:FF:000004', NULL, NULL, 'Ubiquitin activating enzyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(135474, NULL, 'G3DSA:3.90.25.10:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135475, NULL, 'G3DSA:2.60.120.620:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135476, NULL, 'G3DSA:1.10.275.10:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135477, NULL, 'G3DSA:3.40.50.1700:FF:000063', NULL, NULL, 'Probable beta-glucosidase O', NULL, NULL, NULL, NULL, NULL, 4),
(135478, NULL, 'G3DSA:3.20.20.20:FF:000038', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135479, NULL, 'G3DSA:1.10.1300.10:FF:000096', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135480, NULL, 'G3DSA:3.40.50.300:FF:007844', NULL, NULL, 'Si:dkey-118k5.3', NULL, NULL, NULL, NULL, NULL, 4),
(135481, NULL, 'G3DSA:3.90.190.10:FF:000084', NULL, NULL, 'Tyrosine phospatase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(135482, NULL, 'G3DSA:2.40.40.20:FF:000041', NULL, NULL, 'Peroxisome biosynthesis protein (PAS1/Peroxin-1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(135483, NULL, 'G3DSA:2.60.120.10:FF:000831', NULL, NULL, 'Transcriptional regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135484, NULL, 'G3DSA:3.30.70.330:FF:002981', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135485, NULL, 'G3DSA:3.30.160.60:FF:001498', NULL, NULL, 'Zinc finger protein 404', NULL, NULL, NULL, NULL, NULL, 4),
(135486, NULL, 'G3DSA:3.50.80.20:FF:000001', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase dacB', NULL, NULL, NULL, NULL, NULL, 4),
(135487, NULL, 'G3DSA:3.20.20.120:FF:000004', NULL, NULL, 'D-galactonate dehydratase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(135488, NULL, 'G3DSA:3.40.30.10:FF:000153', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(135489, NULL, 'G3DSA:2.30.30.490:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135490, NULL, 'G3DSA:1.10.510.10:FF:003642', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135491, NULL, 'G3DSA:3.40.50.300:FF:000021', NULL, NULL, 'Lon protease homolog', NULL, NULL, NULL, NULL, NULL, 4),
(135492, NULL, 'G3DSA:3.40.50.720:FF:002518', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135493, NULL, 'G3DSA:2.60.120.620:FF:000044', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135494, NULL, 'G3DSA:1.20.1270.60:FF:000138', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(135495, NULL, 'G3DSA:3.90.320.10:FF:000033', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(135496, NULL, 'G3DSA:1.20.920.10:FF:000186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135497, NULL, 'G3DSA:2.40.20.10:FF:000031', NULL, NULL, 'Plasminogen', NULL, NULL, NULL, NULL, NULL, 4),
(135498, NULL, 'G3DSA:2.170.120.20:FF:000010', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(135499, NULL, 'G3DSA:3.30.930.10:FF:000345', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135500, NULL, 'G3DSA:1.10.10.2670:FF:000007', NULL, NULL, 'E3 ubiquitin-protein ligase UBR1', NULL, NULL, NULL, NULL, NULL, 4),
(135501, NULL, 'G3DSA:1.10.720.30:FF:000022', NULL, NULL, 'DNA-(apurinic or apyrimidinic site) lyase', NULL, NULL, NULL, NULL, NULL, 4),
(135502, NULL, 'G3DSA:2.10.70.10:FF:000125', NULL, NULL, 'Gamma-aminobutyric acid (GABA) B receptor, 1a', NULL, NULL, NULL, NULL, NULL, 4),
(135503, NULL, 'G3DSA:1.20.5.2440:FF:000003', NULL, NULL, 'Nuclear fallout, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(135504, NULL, 'G3DSA:1.20.58.60:FF:000439', NULL, NULL, 'AGAP009554-PA', NULL, NULL, NULL, NULL, NULL, 4),
(135505, NULL, 'G3DSA:1.50.40.10:FF:000023', NULL, NULL, 'peroxisomal membrane protein PMP34 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(135506, NULL, 'G3DSA:1.20.5.110:FF:000032', NULL, NULL, 'Ras association domain family member 5', NULL, NULL, NULL, NULL, NULL, 4),
(135507, NULL, 'G3DSA:3.10.250.10:FF:000073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135508, NULL, 'G3DSA:1.10.510.10:FF:002799', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(135509, NULL, 'G3DSA:1.10.510.10:FF:003535', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135510, NULL, 'G3DSA:3.40.50.720:FF:002288', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(135511, NULL, 'G3DSA:1.25.10.10:FF:003356', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135512, NULL, 'G3DSA:1.25.40.550:FF:000002', NULL, NULL, 'AAR2 protein family', NULL, NULL, NULL, NULL, NULL, 4),
(135513, NULL, 'G3DSA:3.40.30.10:FF:000260', NULL, NULL, 'Mitochondrial ribosomal protein L44', NULL, NULL, NULL, NULL, NULL, 4),
(135514, NULL, 'G3DSA:1.20.1250.20:FF:000822', NULL, NULL, 'Probable plastidic glucose transporter 3', NULL, NULL, NULL, NULL, NULL, 4),
(135515, NULL, 'G3DSA:1.20.1250.20:FF:000934', NULL, NULL, 'Allantoate permease', NULL, NULL, NULL, NULL, NULL, 4),
(135516, NULL, 'G3DSA:1.20.1560.10:FF:000685', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135517, NULL, 'G3DSA:2.60.40.10:FF:002010', NULL, NULL, 'Cilia and flagella associated protein 65', NULL, NULL, NULL, NULL, NULL, 4),
(135518, NULL, 'G3DSA:3.30.413.10:FF:000009', NULL, NULL, 'Sulfite reductase [ferredoxin]', NULL, NULL, NULL, NULL, NULL, 4),
(135519, NULL, 'G3DSA:1.20.1070.10:FF:000496', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135520, NULL, 'G3DSA:1.25.40.570:FF:000008', NULL, NULL, 'COP9 signalosome complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(135521, NULL, 'G3DSA:2.130.10.10:FF:001824', NULL, NULL, 'Coatomer subunit beta''', NULL, NULL, NULL, NULL, NULL, 4),
(135522, NULL, 'G3DSA:3.40.50.300:FF:007165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135523, NULL, 'G3DSA:3.30.60.90:FF:000044', NULL, NULL, 'E3 ubiquitin-protein ligase KCMF1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135524, NULL, 'G3DSA:1.10.630.10:FF:000823', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135525, NULL, 'G3DSA:1.10.3370.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135526, NULL, 'G3DSA:3.30.450.20:FF:000199', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(135527, NULL, 'G3DSA:2.60.40.10:FF:001386', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase gamma', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(135528, NULL, 'G3DSA:3.30.420.270:FF:000013', NULL, NULL, 'Biopolymer transporter ExbD', NULL, NULL, NULL, NULL, NULL, 4),
(135529, NULL, 'G3DSA:3.30.450.20:FF:000087', NULL, NULL, 'White collar 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(135530, NULL, 'G3DSA:2.60.40.60:FF:000310', NULL, NULL, 'Protocadherin alpha 11', NULL, NULL, NULL, NULL, NULL, 4),
(135531, NULL, 'G3DSA:2.30.42.10:FF:000537', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135532, NULL, 'G3DSA:3.40.50.410:FF:000166', NULL, NULL, 'Collagen, type VI, alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(135533, NULL, 'G3DSA:3.90.1260.10:FF:000010', NULL, NULL, 'Argininosuccinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(135534, NULL, 'G3DSA:1.20.1070.10:FF:001108', NULL, NULL, 'G-protein coupled receptor-like protein Q2/3L', NULL, NULL, NULL, NULL, NULL, 4),
(135535, NULL, 'G3DSA:3.30.40.10:FF:000749', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(135536, NULL, 'G3DSA:3.40.50.410:FF:000278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135537, NULL, 'G3DSA:3.30.420.10:FF:000149', NULL, NULL, 'Polynucleotidyl transferase, ribonuclease H-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(135538, NULL, 'G3DSA:2.60.220.50:FF:000087', NULL, NULL, 'Adhesion G protein-coupled receptor B3', NULL, NULL, NULL, NULL, NULL, 4),
(135539, NULL, 'G3DSA:3.30.70.330:FF:002655', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135540, NULL, 'G3DSA:2.10.25.10:FF:001111', NULL, NULL, 'Coagulation factor VII', NULL, NULL, NULL, NULL, NULL, 4),
(135541, NULL, 'G3DSA:2.60.40.10:FF:005657', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135542, NULL, 'G3DSA:1.25.40.560:FF:000005', NULL, NULL, 'Ubiquitin thioesterase zranb1-B', NULL, NULL, NULL, NULL, NULL, 4),
(135543, NULL, 'G3DSA:3.40.50.12710:FF:000004', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7', NULL, NULL, NULL, NULL, NULL, 4),
(135544, NULL, 'G3DSA:3.20.20.140:FF:000229', NULL, NULL, 'TatD_related_DNase_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(135545, NULL, 'G3DSA:3.40.50.12700:FF:000001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135546, NULL, 'G3DSA:1.10.510.10:FF:001388', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(135547, NULL, 'G3DSA:3.40.1110.10:FF:000437', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135548, NULL, 'G3DSA:1.10.10.10:FF:000062', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(135549, NULL, 'G3DSA:2.60.40.10:FF:001846', NULL, NULL, 'Uncharacterized protein, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(135550, NULL, 'G3DSA:3.60.40.10:FF:000366', NULL, NULL, 'Putative integral membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(135551, NULL, 'G3DSA:2.60.120.10:FF:000505', NULL, NULL, 'Glr1099 protein', NULL, NULL, NULL, NULL, NULL, 4),
(135552, NULL, 'G3DSA:3.20.20.70:FF:000811', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135553, NULL, 'G3DSA:3.30.160.60:FF:005657', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135554, NULL, 'G3DSA:2.10.50.10:FF:000023', NULL, NULL, 'Ectodysplasin A receptor', NULL, NULL, NULL, NULL, NULL, 4),
(135555, NULL, 'G3DSA:3.40.50.300:FF:000133', NULL, NULL, 'Spermidine/putrescine import ATP-binding protein PotA', NULL, NULL, NULL, NULL, NULL, 4),
(135556, NULL, 'G3DSA:1.10.10.10:FF:001478', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC3', NULL, NULL, NULL, NULL, NULL, 4),
(135557, NULL, 'G3DSA:2.60.120.200:FF:000486', NULL, NULL, 'Thrombospondin A', NULL, NULL, NULL, NULL, NULL, 4),
(135558, NULL, 'G3DSA:1.25.10.10:FF:003137', NULL, NULL, 'Telomere repeats-binding bouquet formation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(135559, NULL, 'G3DSA:3.40.50.1820:FF:000762', NULL, NULL, 'Vegetative-specific protein H5', NULL, NULL, NULL, NULL, NULL, 4),
(135560, NULL, 'G3DSA:4.10.1290.10:FF:000001', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 13B', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(135561, NULL, 'G3DSA:1.20.1070.10:FF:000507', NULL, NULL, 'Adrenoceptor beta 3a', NULL, NULL, NULL, NULL, NULL, 4),
(135562, NULL, 'G3DSA:3.30.2290.10:FF:000003', NULL, NULL, 'Zinc-dependent protease, TldD/PmbA family', NULL, NULL, NULL, NULL, NULL, 4),
(135563, NULL, 'G3DSA:1.10.287.470:FF:000067', NULL, NULL, 'Heterocyst specific ABC-transporter, membrane fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(135564, NULL, 'G3DSA:3.20.20.80:FF:000584', NULL, NULL, 'Alpha-L-fucosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135565, NULL, 'G3DSA:3.60.21.10:FF:000114', NULL, NULL, 'Sia1p', NULL, NULL, NULL, NULL, NULL, 4),
(135566, NULL, 'G3DSA:3.40.710.10:FF:000080', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(135567, NULL, 'G3DSA:3.30.1370.210:FF:000032', NULL, NULL, 'Muscleblind like splicing regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(135568, NULL, 'G3DSA:1.20.5.110:FF:000251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135569, NULL, 'G3DSA:3.30.40.10:FF:000963', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(135570, NULL, 'G3DSA:4.10.990.10:FF:000001', NULL, NULL, '50S ribosomal protein L15', NULL, NULL, NULL, NULL, NULL, 4),
(135571, NULL, 'G3DSA:1.10.533.10:FF:000013', NULL, NULL, 'Apoptosis-associated speck-like protein containing a CARD', NULL, NULL, NULL, NULL, NULL, 4),
(135572, NULL, 'G3DSA:2.40.50.140:FF:000847', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135573, NULL, 'G3DSA:1.10.10.10:FF:002102', NULL, NULL, 'RNA polymerase III subunit RPC82 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(135574, NULL, 'G3DSA:3.40.190.10:FF:000679', NULL, NULL, 'Glutamate receptor 1.1', NULL, NULL, NULL, NULL, NULL, 4),
(135575, NULL, 'G3DSA:1.10.510.10:FF:001169', NULL, NULL, 'Lectin-domain containing receptor kinase A4.2', NULL, NULL, NULL, NULL, NULL, 4),
(135576, NULL, 'G3DSA:3.40.50.300:FF:004404', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(135577, NULL, 'G3DSA:3.40.50.2300:FF:000709', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135578, NULL, 'G3DSA:1.20.1740.10:FF:000238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135579, NULL, 'G3DSA:3.90.1480.20:FF:000001', NULL, NULL, 'ST8 alpha-N-acetyl-neuraminide alpha-2,8-sialyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(135580, NULL, 'G3DSA:3.20.20.80:FF:000814', NULL, NULL, 'SD02860p', NULL, NULL, NULL, NULL, NULL, 4),
(135581, NULL, 'G3DSA:3.30.160.60:FF:003971', NULL, NULL, 'Zinc finger E-box-binding homeobox 2a', NULL, NULL, NULL, NULL, NULL, 4),
(135582, NULL, 'G3DSA:1.10.10.930:FF:000002', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(135583, NULL, 'G3DSA:3.30.420.10:FF:000705', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135584, NULL, 'G3DSA:3.30.1330.20:FF:000032', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(135585, NULL, 'G3DSA:2.150.10.10:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135586, NULL, 'G3DSA:4.10.280.10:FF:000150', NULL, NULL, 'Mesoderm posterior protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(135587, NULL, 'G3DSA:1.20.990.10:FF:000027', NULL, NULL, '5-methyltetrahydrofolate-homocysteine methyltransferase reductase', NULL, NULL, NULL, NULL, NULL, 4),
(135588, NULL, 'G3DSA:3.40.50.2300:FF:000698', NULL, NULL, 'GLutamate Receptor family (AMPA)', NULL, NULL, NULL, NULL, NULL, 4),
(135589, NULL, 'G3DSA:3.30.420.40:FF:000130', NULL, NULL, 'Chromatin remodeling complex subunit (Arp9)', NULL, NULL, NULL, NULL, NULL, 4),
(135590, NULL, 'G3DSA:1.10.287.3240:FF:000028', NULL, NULL, 'V-type ATP synthase subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(135591, NULL, 'G3DSA:3.30.160.60:FF:000200', NULL, NULL, 'zinc finger protein 510 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(135592, NULL, 'G3DSA:3.30.1490.20:FF:000083', NULL, NULL, 'ATP domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(135593, NULL, 'G3DSA:3.30.450.60:FF:000071', NULL, NULL, 'AP complex subunit sigma', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(135594, NULL, 'G3DSA:2.30.40.10:FF:000134', NULL, NULL, 'Guanine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(135595, NULL, 'G3DSA:3.30.160.60:FF:001386', NULL, NULL, 'Zinc finger protein 212', NULL, NULL, NULL, NULL, NULL, 4),
(135596, NULL, 'G3DSA:1.25.40.10:FF:003072', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(135597, NULL, 'G3DSA:3.30.1330.30:FF:000035', NULL, NULL, 'TrmH family RNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(135598, NULL, 'G3DSA:3.30.9.10:FF:000003', NULL, NULL, 'Glycine oxidase ThiO', NULL, NULL, NULL, NULL, NULL, 4),
(135599, NULL, 'G3DSA:2.60.120.920:FF:000134', NULL, NULL, 'SPRY domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135600, NULL, 'G3DSA:1.25.40.10:FF:005089', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135601, NULL, 'G3DSA:3.50.50.60:FF:001343', NULL, NULL, 'Ubiquinone biosynthesis monooxgenase', NULL, NULL, NULL, NULL, NULL, 4),
(135602, NULL, 'G3DSA:3.40.50.1820:FF:000329', NULL, NULL, 'Haloalkane dehalogenase', NULL, NULL, NULL, NULL, NULL, 4),
(135603, NULL, 'G3DSA:2.10.260.10:FF:000004', NULL, NULL, 'Antitoxin ChpS', NULL, NULL, NULL, NULL, NULL, 4),
(135604, NULL, 'G3DSA:3.40.50.150:FF:001471', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135605, NULL, 'G3DSA:3.40.30.10:FF:000372', NULL, NULL, 'Thiol:disulfide interchange protein dsbD', NULL, NULL, NULL, NULL, NULL, 4),
(135606, NULL, 'G3DSA:1.10.720.60:FF:000002', NULL, NULL, 'Enolase-phosphatase E1', NULL, NULL, NULL, NULL, NULL, 4),
(135607, NULL, 'G3DSA:1.10.390.10:FF:000001', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(135608, NULL, 'G3DSA:3.30.930.10:FF:000233', NULL, NULL, 'Phenylalanine--tRNA ligase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(135609, NULL, 'G3DSA:3.40.50.300:FF:007625', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135610, NULL, 'G3DSA:3.30.1330.40:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135611, NULL, 'G3DSA:1.20.1110.10:FF:000207', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135612, NULL, 'G3DSA:1.10.3730.20:FF:000024', NULL, NULL, 'Unplaced genomic scaffold supercont2.15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(135613, NULL, 'G3DSA:3.50.30.30:FF:000170', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135614, NULL, 'G3DSA:3.90.76.10:FF:000003', NULL, NULL, 'Glutathione ABC transporter substrate-binding protein GsiB', NULL, NULL, NULL, NULL, NULL, 4),
(135615, NULL, 'G3DSA:3.40.50.300:FF:005585', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135616, NULL, 'G3DSA:1.20.120.1080:FF:000036', NULL, NULL, 'ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(135617, NULL, 'G3DSA:3.30.160.60:FF:006040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135618, NULL, 'G3DSA:3.30.30.170:FF:000002', NULL, NULL, 'Eukaryotic translation initiation factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(135619, NULL, 'G3DSA:3.30.1240.10:FF:000045', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(135620, NULL, 'G3DSA:2.60.40.10:FF:000430', NULL, NULL, 'Sallimus, isoform P', NULL, NULL, NULL, NULL, NULL, 4),
(135621, NULL, 'G3DSA:4.10.910.10:FF:000002', NULL, NULL, '40S ribosomal protein S18', NULL, NULL, NULL, NULL, NULL, 4),
(135622, NULL, 'G3DSA:2.60.40.10:FF:004949', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135623, NULL, 'G3DSA:2.130.10.10:FF:005528', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135624, NULL, 'G3DSA:3.40.50.300:FF:005927', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135625, NULL, 'G3DSA:1.10.238.110:FF:000017', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(135626, NULL, 'G3DSA:1.20.1070.10:FF:002076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135627, NULL, 'G3DSA:3.30.930.10:FF:000340', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(135628, NULL, 'G3DSA:3.30.70.2000:FF:000004', NULL, NULL, 'Insomniac, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(135629, NULL, 'G3DSA:3.40.50.720:FF:001214', NULL, NULL, 'Conserved hypothetical mitochondrial protein', NULL, NULL, NULL, NULL, NULL, 4),
(135630, NULL, 'G3DSA:3.50.50.60:FF:001231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135631, NULL, 'G3DSA:2.40.30.330:FF:000001', NULL, NULL, 'Protein CLP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(135632, NULL, 'G3DSA:1.10.8.60:FF:000194', NULL, NULL, 'PTS-dependent dihydroxyacetone kinase operon regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(135633, NULL, 'G3DSA:3.90.1440.10:FF:000001', NULL, NULL, 'Preprotein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(135634, NULL, 'G3DSA:2.130.10.10:FF:001257', NULL, NULL, 'WD repeat-containing protein PAC11', NULL, NULL, NULL, NULL, NULL, 4),
(135635, NULL, 'G3DSA:2.130.10.10:FF:005186', NULL, NULL, 'Ribosome biogenesis protein WDR12 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(135636, NULL, 'G3DSA:1.25.40.20:FF:000191', NULL, NULL, 'E3 ubiquitin-protein ligase MIB1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(135637, NULL, 'G3DSA:3.40.1180.10:FF:000043', NULL, NULL, 'Alkyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(135638, NULL, 'G3DSA:3.50.50.60:FF:000961', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135639, NULL, 'G3DSA:3.40.1190.20:FF:000198', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135640, NULL, 'G3DSA:3.40.50.11340:FF:000003', NULL, NULL, 'Galactoside 2-alpha-L-fucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(135641, NULL, 'G3DSA:1.25.40.10:FF:001048', NULL, NULL, 'Putative intraflagellar transport protein IFT88', NULL, NULL, NULL, NULL, NULL, 4),
(135642, NULL, 'G3DSA:3.40.50.300:FF:000026', NULL, NULL, 'ATP synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(135643, NULL, 'G3DSA:3.40.50.2000:FF:000833', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135644, NULL, 'G3DSA:2.60.40.10:FF:005219', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135645, NULL, 'G3DSA:3.30.450.20:FF:000536', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135646, NULL, 'G3DSA:3.40.50.11350:FF:000006', NULL, NULL, 'Calcium ion binding', NULL, NULL, NULL, NULL, NULL, 4),
(135647, NULL, 'G3DSA:3.40.50.300:FF:001656', NULL, NULL, 'Rab11B GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135648, NULL, 'G3DSA:1.20.58.830:FF:000011', NULL, NULL, 'Erythrocyte-binding antigen 175', NULL, NULL, NULL, NULL, NULL, 4),
(135649, NULL, 'G3DSA:1.10.8.60:FF:000542', NULL, NULL, 'N-ethylmaleimide-sensitive factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(135650, NULL, 'G3DSA:3.40.50.1820:FF:000548', NULL, NULL, 'Lipase', NULL, NULL, NULL, NULL, NULL, 4),
(135651, NULL, 'G3DSA:3.40.1810.10:FF:000007', NULL, NULL, 'Transcription factor, MADS-box', NULL, NULL, NULL, NULL, NULL, 4),
(135652, NULL, 'G3DSA:3.40.50.300:FF:004062', NULL, NULL, 'Peroxin-1', NULL, NULL, NULL, NULL, NULL, 4),
(135653, NULL, 'G3DSA:3.30.160.60:FF:001728', NULL, NULL, 'Zinc finger protein 560', NULL, NULL, NULL, NULL, NULL, 4),
(135654, NULL, 'G3DSA:2.60.40.2300:FF:000003', NULL, NULL, 'Neutral ceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(135655, NULL, 'G3DSA:2.10.25.10:FF:001004', NULL, NULL, 'Delta/notch like EGF repeat containing', NULL, NULL, NULL, NULL, NULL, 4),
(135656, NULL, 'G3DSA:3.40.50.800:FF:000069', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(135657, NULL, 'G3DSA:2.60.120.970:FF:000014', NULL, NULL, 'growth/differentiation factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(135658, NULL, 'G3DSA:2.60.40.2310:FF:000006', NULL, NULL, 'Subtilisin-like protease SBT1.2', NULL, NULL, NULL, NULL, NULL, 4),
(135659, NULL, 'G3DSA:3.40.50.150:FF:000503', NULL, NULL, 'Spermidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(135660, NULL, 'G3DSA:3.30.40.10:FF:001020', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(135661, NULL, 'G3DSA:3.40.1690.20:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135662, NULL, 'G3DSA:3.80.10.10:FF:003230', NULL, NULL, 'NLR family, pyrin domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(135663, NULL, 'G3DSA:3.30.450.20:FF:000194', NULL, NULL, 'Cell wall metabolism sensor histidine kinase WalK', NULL, NULL, NULL, NULL, NULL, 4),
(135664, NULL, 'G3DSA:1.25.10.10:FF:003351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135665, NULL, 'G3DSA:3.40.50.1260:FF:000009', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(135666, NULL, 'G3DSA:3.40.50.2300:FF:001081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135667, NULL, 'G3DSA:2.60.40.10:FF:003084', NULL, NULL, 'leukocyte immune-type receptor 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(135668, NULL, 'G3DSA:1.10.3860.10:FF:000019', NULL, NULL, 'Proton/glutamate symporter', NULL, NULL, NULL, NULL, NULL, 4),
(135669, NULL, 'G3DSA:3.30.160.60:FF:004134', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135670, NULL, 'G3DSA:2.130.10.10:FF:004005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135671, NULL, 'G3DSA:2.40.50.140:FF:001229', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135672, NULL, 'G3DSA:3.40.1690.10:FF:000020', NULL, NULL, 'FlhB domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(135673, NULL, 'G3DSA:3.30.70.330:FF:003037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135674, NULL, 'G3DSA:3.20.20.300:FF:000087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135675, NULL, 'G3DSA:3.30.160.60:FF:001835', NULL, NULL, 'Ras responsive element binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(135676, NULL, 'G3DSA:1.25.40.10:FF:005319', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135677, NULL, 'G3DSA:2.60.40.10:FF:000082', NULL, NULL, 'receptor-type tyrosine-protein phosphatase delta isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(135678, NULL, 'G3DSA:1.10.150.810:FF:000007', NULL, NULL, 'DNA polymerase kappa', NULL, NULL, NULL, NULL, NULL, 4),
(135679, NULL, 'G3DSA:1.10.630.10:FF:000256', NULL, NULL, 'Os03g0249600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(135680, NULL, 'G3DSA:2.130.10.10:FF:003393', NULL, NULL, 'Tbc-19', NULL, NULL, NULL, NULL, NULL, 4),
(135681, NULL, 'G3DSA:2.130.10.10:FF:003729', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135682, NULL, 'G3DSA:3.40.50.720:FF:000938', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(135683, NULL, 'G3DSA:1.20.1560.10:FF:000247', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135684, NULL, 'G3DSA:3.30.40.10:FF:000968', NULL, NULL, 'E3 ubiquitin-protein ligase RMA2', NULL, NULL, NULL, NULL, NULL, 4),
(135685, NULL, 'G3DSA:2.60.120.290:FF:000237', NULL, NULL, 'CUB domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(135686, NULL, 'G3DSA:3.30.40.10:FF:000744', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(135687, NULL, 'G3DSA:3.40.50.620:FF:000678', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135688, NULL, 'G3DSA:2.40.270.10:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135689, NULL, 'G3DSA:3.40.50.300:FF:003792', NULL, NULL, 'Rho-related GTP-binding protein Rho6', NULL, NULL, NULL, NULL, NULL, 4),
(135690, NULL, 'G3DSA:1.20.1280.170:FF:000006', NULL, NULL, 'Exocyst complex component EXO70', NULL, NULL, NULL, NULL, NULL, 4),
(135691, NULL, 'G3DSA:2.60.40.1090:FF:000022', NULL, NULL, 'Fimbrial protein StiA', NULL, NULL, NULL, NULL, NULL, 4),
(135692, NULL, 'G3DSA:3.30.1370.50:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135693, NULL, 'G3DSA:1.10.10.60:FF:001246', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135694, NULL, 'G3DSA:3.90.640.10:FF:000068', NULL, NULL, 'Chaperone protein HscA homolog', NULL, NULL, NULL, NULL, NULL, 4),
(135695, NULL, 'G3DSA:3.10.290.10:FF:000070', NULL, NULL, 'cDNA clone:002-120-H01, full insert sequence', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(135696, NULL, 'G3DSA:1.10.540.10:FF:000030', NULL, NULL, 'Acyl-CoA dehydrogenase FadE29', NULL, NULL, NULL, NULL, NULL, 4),
(135697, NULL, 'G3DSA:2.10.70.10:FF:000018', NULL, NULL, 'Fibronectin 1', NULL, NULL, NULL, NULL, NULL, 4),
(135698, NULL, 'G3DSA:3.40.50.80:FF:000248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135699, NULL, 'G3DSA:1.10.565.10:FF:000014', NULL, NULL, 'Oxysterols receptor LXR-alpha isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(135700, NULL, 'G3DSA:1.25.40.180:FF:000217', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135701, NULL, 'G3DSA:1.20.58.180:FF:000001', NULL, NULL, 'Glycine--tRNA ligase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(135702, NULL, 'G3DSA:2.60.120.200:FF:000598', NULL, NULL, 'Laminin, alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(135703, NULL, 'G3DSA:3.30.70.1230:FF:000200', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(135704, NULL, 'G3DSA:3.40.1110.10:FF:000106', NULL, NULL, 'P-type cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(135705, NULL, 'G3DSA:3.40.50.720:FF:001321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135706, NULL, 'G3DSA:1.20.1250.20:FF:000827', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(135707, NULL, 'G3DSA:1.20.120.1220:FF:000011', NULL, NULL, 'Type 4 prepilin-like proteins leader peptide-processing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(135708, NULL, 'G3DSA:2.10.25.10:FF:000728', NULL, NULL, 'Laminin subunit gamma 1', NULL, NULL, NULL, NULL, NULL, 4),
(135709, NULL, 'G3DSA:3.80.10.10:FF:002960', NULL, NULL, 'CLL4B clavata1-like receptor S/T protein kinase protein', NULL, NULL, NULL, NULL, NULL, 4),
(135710, NULL, 'G3DSA:3.40.140.10:FF:000041', NULL, NULL, 'Cytidine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(135711, NULL, 'G3DSA:3.30.70.330:FF:000957', NULL, NULL, 'RNA-binding protein rnp-1', NULL, NULL, NULL, NULL, NULL, 4),
(135712, NULL, 'G3DSA:1.20.58.190:FF:000004', NULL, NULL, 'Recombination hotspot-binding protein (Translin)', NULL, NULL, NULL, NULL, NULL, 4),
(135713, NULL, 'G3DSA:1.10.287.70:FF:000576', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135714, NULL, 'G3DSA:2.60.40.10:FF:003426', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135715, NULL, 'G3DSA:3.40.50.300:FF:000700', NULL, NULL, 'ATP-dependent DNA helicase DinG', NULL, NULL, NULL, NULL, NULL, 4),
(135716, NULL, 'G3DSA:1.25.40.180:FF:000324', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135717, NULL, 'G3DSA:2.20.100.10:FF:000249', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135718, NULL, 'G3DSA:3.10.400.20:FF:000015', NULL, NULL, 'Translation machinery-associated protein 20', NULL, NULL, NULL, NULL, NULL, 4),
(135719, NULL, 'G3DSA:1.10.510.10:FF:001618', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(135720, NULL, 'G3DSA:2.30.30.140:FF:000109', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(135721, NULL, 'G3DSA:1.25.10.10:FF:001097', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(135722, NULL, 'G3DSA:3.40.50.1240:FF:000003', NULL, NULL, '2,3-bisphosphoglycerate-dependent phosphoglycerate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(135723, NULL, 'G3DSA:1.10.630.10:FF:000604', NULL, NULL, 'Cytochrome P450, family 2, subfamily AA, polypeptide 7', NULL, NULL, NULL, NULL, NULL, 4),
(135724, NULL, 'G3DSA:2.60.40.420:FF:000228', NULL, NULL, 'Laccase-1', NULL, NULL, NULL, NULL, NULL, 4),
(135725, NULL, 'G3DSA:1.20.990.10:FF:000022', NULL, NULL, 'Sulfite reductase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(135726, NULL, 'G3DSA:3.10.400.10:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135727, NULL, 'G3DSA:2.40.50.90:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135728, NULL, 'G3DSA:3.30.800.10:FF:000010', NULL, NULL, 'Putative 1-phosphatidylinositol-3-phosphate 5-kinase FAB1C', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(135729, NULL, 'G3DSA:2.130.10.10:FF:001605', NULL, NULL, 'Ribosome biogenesis protein BOP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(135730, NULL, 'G3DSA:3.30.1330.30:FF:000030', NULL, NULL, 'Growth arrest and DNA damage-inducible protein GADD45 alpha', NULL, NULL, NULL, NULL, NULL, 4),
(135731, NULL, 'G3DSA:1.10.640.10:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135732, NULL, 'G3DSA:3.30.160.60:FF:000205', NULL, NULL, 'Putative Krueppel-like factor 10', NULL, NULL, NULL, NULL, NULL, 4),
(135733, NULL, 'G3DSA:3.80.10.10:FF:000268', NULL, NULL, 'Tubulin-specific chaperone E', NULL, NULL, NULL, NULL, NULL, 4),
(135734, NULL, 'G3DSA:3.50.50.60:FF:001124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135735, NULL, 'G3DSA:2.30.29.30:FF:000670', NULL, NULL, 'Histone chaperone Rttp106-like, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135736, NULL, 'G3DSA:3.70.10.10:FF:000010', NULL, NULL, 'Checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(135737, NULL, 'G3DSA:1.25.40.10:FF:003521', NULL, NULL, 'Protein TONSOKU', NULL, NULL, NULL, NULL, NULL, 4),
(135738, NULL, 'G3DSA:3.60.20.10:FF:000264', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135739, NULL, 'G3DSA:3.60.40.10:FF:000147', NULL, NULL, 'Protein phosphatase 2C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135740, NULL, 'G3DSA:3.30.70.330:FF:000738', NULL, NULL, 'RNA-binding motif protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(135741, NULL, 'G3DSA:3.40.630.10:FF:000489', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(135742, NULL, 'G3DSA:1.25.10.10:FF:001990', NULL, NULL, 'Putative pumilio/PUF RNA binding protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(135743, NULL, 'G3DSA:3.40.50.10140:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135744, NULL, 'G3DSA:2.130.10.10:FF:000301', NULL, NULL, 'WD40 repeat-containing protein SMU1', NULL, NULL, NULL, NULL, NULL, 4),
(135745, NULL, 'G3DSA:2.40.240.130:FF:000007', NULL, NULL, 'Axin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(135746, NULL, 'G3DSA:1.25.40.20:FF:001618', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135747, NULL, 'G3DSA:2.60.40.150:FF:000113', NULL, NULL, 'activating signal cointegrator 1 complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(135748, NULL, 'G3DSA:2.30.39.10:FF:000052', NULL, NULL, 'Serpin peptidase inhibitor, clade F (alpha-2 antiplasmin, pigment epithelium-derived factor), member 1', NULL, NULL, NULL, NULL, NULL, 4),
(135749, NULL, 'G3DSA:3.30.1950.10:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135750, NULL, 'G3DSA:3.30.70.330:FF:002874', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135751, NULL, 'G3DSA:3.40.50.12780:FF:000098', NULL, NULL, 'Long-chain-fatty-acid--CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(135752, NULL, 'G3DSA:2.60.120.10:FF:000612', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135753, NULL, 'G3DSA:3.80.10.10:FF:004539', NULL, NULL, 'RE49158p', NULL, NULL, NULL, NULL, NULL, 4),
(135754, NULL, 'G3DSA:3.40.50.2000:FF:001002', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(135755, NULL, 'G3DSA:3.40.50.620:FF:000459', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 2-A', NULL, NULL, NULL, NULL, NULL, 4),
(135756, NULL, 'G3DSA:3.90.190.10:FF:000207', NULL, NULL, 'Leucine rich repeat and phosphatase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(135757, NULL, 'G3DSA:3.30.780.10:FF:000075', NULL, NULL, 'Cleavage stimulating factor 64', NULL, NULL, NULL, NULL, NULL, 4),
(135758, NULL, 'G3DSA:2.10.10.40:FF:000001', NULL, NULL, 'Capsid vertex protein', NULL, NULL, NULL, NULL, NULL, 4),
(135759, NULL, 'G3DSA:1.10.510.10:FF:001276', NULL, NULL, 'NEK4 isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(135760, NULL, 'G3DSA:1.10.555.10:FF:000070', NULL, NULL, 'Phosphatidylinositol 3-kinase regulatory subunit alpha-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(135761, NULL, 'G3DSA:3.30.160.60:FF:001509', NULL, NULL, 'Zinc finger protein 616', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(135762, NULL, 'G3DSA:2.10.220.10:FF:000007', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(135763, NULL, 'G3DSA:3.20.20.70:FF:000025', NULL, NULL, 'Triosephosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(135764, NULL, 'G3DSA:3.40.140.100:FF:000014', NULL, NULL, 'Ubiquitin-like modifier-activating enzyme ATG7', NULL, NULL, NULL, NULL, NULL, 4),
(135765, NULL, 'G3DSA:1.25.40.10:FF:001615', NULL, NULL, 'Os05g0457700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(135766, NULL, 'G3DSA:3.40.50.2000:FF:000726', NULL, NULL, 'UDP-Glycosyltransferase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(135767, NULL, 'G3DSA:3.30.200.20:FF:001226', NULL, NULL, 'Protein kinase-like (PK-like)', NULL, NULL, NULL, NULL, NULL, 4),
(135768, NULL, 'G3DSA:3.40.50.1820:FF:000767', NULL, NULL, 'Alpha/Beta hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(135769, NULL, 'G3DSA:3.40.50.410:FF:000054', NULL, NULL, 'von Willebrand factor A domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(135770, NULL, 'G3DSA:2.30.330.10:FF:000011', NULL, NULL, 'Flagellar motor switch protein FliN', NULL, NULL, NULL, NULL, NULL, 4),
(135771, NULL, 'G3DSA:1.20.1740.10:FF:000233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135772, NULL, 'G3DSA:1.20.120.1920:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135773, NULL, 'G3DSA:1.25.40.10:FF:001492', NULL, NULL, 'Tetratricopeptide repeat domain 21B', NULL, NULL, NULL, NULL, NULL, 4),
(135774, NULL, 'G3DSA:3.30.160.20:FF:000109', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(135775, NULL, 'G3DSA:3.40.1110.10:FF:000325', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(135776, NULL, 'G3DSA:2.60.120.330:FF:000171', NULL, NULL, 'Os02g0630300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(135777, NULL, 'G3DSA:2.40.10.10:FF:000210', NULL, NULL, 'trypsin alpha-3', NULL, NULL, NULL, NULL, NULL, 4),
(135778, NULL, 'G3DSA:2.10.90.10:FF:000020', NULL, NULL, 'bone morphogenetic protein 8B', NULL, NULL, NULL, NULL, NULL, 4),
(135779, NULL, 'G3DSA:3.80.10.10:FF:001898', NULL, NULL, 'Nuclear pore complex protein NUP107', NULL, NULL, NULL, NULL, NULL, 4),
(135780, NULL, 'G3DSA:1.25.10.10:FF:001439', NULL, NULL, 'Unc-45 homolog A (C. elegans)', NULL, NULL, NULL, NULL, NULL, 4),
(135781, NULL, 'G3DSA:3.30.530.20:FF:000014', NULL, NULL, 'stAR-related lipid transfer protein 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(135782, NULL, 'G3DSA:3.20.20.60:FF:000022', NULL, NULL, 'CoA ester lyase', NULL, NULL, NULL, NULL, NULL, 4),
(135783, NULL, 'G3DSA:1.20.80.10:FF:000049', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135784, NULL, 'G3DSA:1.25.40.20:FF:001495', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135785, NULL, 'G3DSA:1.20.120.1910:FF:000010', NULL, NULL, 'Cysteinyl-tRNA synthetase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(135786, NULL, 'G3DSA:3.30.1680.10:FF:000010', NULL, NULL, 'semaphorin-4F isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(135787, NULL, 'G3DSA:3.30.200.20:FF:001007', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(135788, NULL, 'G3DSA:3.30.160.60:FF:000082', NULL, NULL, 'Putative zinc finger E-box-binding homeobox 2', NULL, NULL, NULL, NULL, NULL, 4),
(135789, NULL, 'G3DSA:1.20.1080.10:FF:000098', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135790, NULL, 'G3DSA:2.60.40.10:FF:000211', NULL, NULL, 'Obscurin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(135791, NULL, 'G3DSA:1.10.486.10:FF:000055', NULL, NULL, 'AaceriAFR093Wp', NULL, NULL, NULL, NULL, NULL, 4),
(135792, NULL, 'G3DSA:2.130.10.10:FF:001931', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135793, NULL, 'G3DSA:3.40.50.300:FF:005366', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(135794, NULL, 'G3DSA:3.60.20.10:FF:000045', NULL, NULL, 'Glutamine amidotransferase DUG3', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(135795, NULL, 'G3DSA:3.40.50.450:FF:000043', NULL, NULL, 'ATP-dependent 6-phosphofructokinase, platelet type', NULL, NULL, NULL, NULL, NULL, 4),
(135796, NULL, 'G3DSA:3.80.10.10:FF:000487', NULL, NULL, 'F-box and leucine-rich repeat protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(135797, NULL, 'G3DSA:1.25.40.20:FF:001837', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(135798, NULL, 'G3DSA:2.170.210.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135799, NULL, 'G3DSA:2.60.120.290:FF:000018', NULL, NULL, 'cubilin', NULL, NULL, NULL, NULL, NULL, 4),
(135800, NULL, 'G3DSA:1.10.580.10:FF:000032', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(135801, NULL, 'G3DSA:1.20.1250.20:FF:000485', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(135802, NULL, 'G3DSA:3.40.50.410:FF:000273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135803, NULL, 'G3DSA:1.50.40.10:FF:000130', NULL, NULL, 'Putative ADP/ATP carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(135804, NULL, 'G3DSA:3.30.40.10:FF:002329', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135805, NULL, 'G3DSA:1.10.630.10:FF:000037', NULL, NULL, 'Cytochrome P450 9', NULL, NULL, NULL, NULL, NULL, 4),
(135806, NULL, 'G3DSA:3.90.550.10:FF:000061', NULL, NULL, 'Cellulose synthase catalytic subunit [UDP-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(135807, NULL, 'G3DSA:3.40.50.460:FF:000046', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(135808, NULL, 'G3DSA:3.50.50.60:FF:001450', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135809, NULL, 'G3DSA:1.25.40.10:FF:001834', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g39952, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(135810, NULL, 'G3DSA:3.30.160.60:FF:001493', NULL, NULL, 'zinc finger protein 664', NULL, NULL, NULL, NULL, NULL, 4),
(135811, NULL, 'G3DSA:3.90.1260.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135812, NULL, 'G3DSA:3.10.580.10:FF:000171', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(135813, NULL, 'G3DSA:1.25.40.10:FF:005196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135814, NULL, 'G3DSA:3.90.1170.30:FF:000008', NULL, NULL, 'Pyrimidine-nucleoside phosphorylase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(135815, NULL, 'G3DSA:2.20.25.350:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135816, NULL, 'G3DSA:1.10.357.70:FF:000003', NULL, NULL, 'exocyst complex component 3-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(135817, NULL, 'G3DSA:3.30.300.30:FF:000091', NULL, NULL, 'Probable acyl-activating enzyme 18, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(135818, NULL, 'G3DSA:2.60.40.10:FF:003645', NULL, NULL, 'Cytokine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(135819, NULL, 'G3DSA:2.10.25.10:FF:000509', NULL, NULL, 'Latent transforming growth factor beta binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(135820, NULL, 'G3DSA:1.10.3370.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135821, NULL, 'G3DSA:3.40.50.2000:FF:000378', NULL, NULL, 'Glycogen phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(135822, NULL, 'G3DSA:4.10.950.10:FF:000004', NULL, NULL, '60S ribosomal protein L2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(135823, NULL, 'G3DSA:4.10.280.10:FF:000043', NULL, NULL, 'Helix-loop-helix DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(135824, NULL, 'G3DSA:2.60.300.12:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135825, NULL, 'G3DSA:3.40.50.720:FF:001540', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135826, NULL, 'G3DSA:3.30.460.10:FF:000146', NULL, NULL, 'Terminal uridylyl transferase 4', NULL, NULL, NULL, NULL, NULL, 4),
(135827, NULL, 'G3DSA:2.130.10.10:FF:005309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(135828, NULL, 'G3DSA:3.40.33.10:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135829, NULL, 'G3DSA:1.10.357.30:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135830, NULL, 'G3DSA:1.20.5.110:FF:000144', NULL, NULL, 'CRE-SYX-17 protein', NULL, NULL, NULL, NULL, NULL, 4),
(135831, NULL, 'G3DSA:1.10.287.70:FF:000357', NULL, NULL, 'Calcium channel protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135832, NULL, 'G3DSA:3.40.1410.10:FF:000039', NULL, NULL, 'Transcriptional regulator, GntR family', NULL, NULL, NULL, NULL, NULL, 4),
(135833, NULL, 'G3DSA:3.10.310.40:FF:000014', NULL, NULL, 'Alanine--tRNA ligase, cytoplasmic-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(135834, NULL, 'G3DSA:1.20.1560.10:FF:000808', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135835, NULL, 'G3DSA:3.40.20.10:FF:000091', NULL, NULL, 'Map kinase phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(135836, NULL, 'G3DSA:2.60.120.1000:FF:000012', NULL, NULL, 'Si:dkey-61l1.4', NULL, NULL, NULL, NULL, NULL, 4),
(135837, NULL, 'G3DSA:3.30.70.660:FF:000039', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(135838, NULL, 'G3DSA:3.40.50.300:FF:005708', NULL, NULL, 'Bifunctional shikimate kinase/3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(135839, NULL, 'G3DSA:1.25.40.470:FF:000074', NULL, NULL, 'Intraflagellar transport protein 122 homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(135840, NULL, 'G3DSA:3.30.160.60:FF:005764', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135841, NULL, 'G3DSA:2.60.120.260:FF:000588', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135842, NULL, 'G3DSA:3.30.710.10:FF:000469', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135843, NULL, 'G3DSA:1.10.472.80:FF:000201', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135844, NULL, 'G3DSA:1.10.287.1490:FF:000014', NULL, NULL, 'AGAP008095-PA', NULL, NULL, NULL, NULL, NULL, 4),
(135845, NULL, 'G3DSA:1.25.10.10:FF:001664', NULL, NULL, 'Calcium-binding protein 39-like', NULL, NULL, NULL, NULL, NULL, 4),
(135846, NULL, 'G3DSA:3.20.20.100:FF:000139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135847, NULL, 'G3DSA:1.10.510.10:FF:001843', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135848, NULL, 'G3DSA:3.30.390.30:FF:000034', NULL, NULL, 'Pyridine nucleotide-disulfide oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(135849, NULL, 'G3DSA:2.130.10.10:FF:001369', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135850, NULL, 'G3DSA:2.60.40.10:FF:003971', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135851, NULL, 'G3DSA:2.30.130.10:FF:000030', NULL, NULL, 'Glutamate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(135852, NULL, 'G3DSA:1.10.630.10:FF:000368', NULL, NULL, 'Cytochrome P450 monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(135853, NULL, 'G3DSA:1.20.1410.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135854, NULL, 'G3DSA:1.10.357.90:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135855, NULL, 'G3DSA:3.30.70.240:FF:000014', NULL, NULL, 'Elongation factor Tu, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135856, NULL, 'G3DSA:3.40.50.300:FF:003909', NULL, NULL, 'GD17397', NULL, NULL, NULL, NULL, NULL, 4),
(135857, NULL, 'G3DSA:3.30.70.330:FF:001800', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135858, NULL, 'G3DSA:1.25.40.10:FF:004937', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135859, NULL, 'G3DSA:3.20.20.70:FF:000250', NULL, NULL, 'GTP 3'',8-cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(135860, NULL, 'G3DSA:1.20.5.460:FF:000007', NULL, NULL, 'Peptidylprolyl isomerase like 2', NULL, NULL, NULL, NULL, NULL, 4),
(135861, NULL, 'G3DSA:1.10.12.10:FF:000027', NULL, NULL, 'Chromodomain protein, Y-like', NULL, NULL, NULL, NULL, NULL, 4),
(135862, NULL, 'G3DSA:3.10.450.490:FF:000005', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(135863, NULL, 'G3DSA:3.30.70.250:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135864, NULL, 'G3DSA:3.90.550.10:FF:000510', NULL, NULL, 'LARGE xylosyl- and glucuronyltransferase 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(135865, NULL, 'G3DSA:3.30.450.20:FF:000648', NULL, NULL, 'Sensory histidine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(135866, NULL, 'G3DSA:3.40.50.2300:FF:001204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135867, NULL, 'G3DSA:3.30.40.10:FF:001132', NULL, NULL, 'Multicopy suppressor of chk1 protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(135868, NULL, 'G3DSA:3.80.10.10:FF:000936', NULL, NULL, 'Platelet glycoprotein V', NULL, NULL, NULL, NULL, NULL, 4),
(135869, NULL, 'G3DSA:3.10.280.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135870, NULL, 'G3DSA:3.80.10.10:FF:003011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135871, NULL, 'G3DSA:3.40.710.10:FF:000186', NULL, NULL, 'Golvesin', NULL, NULL, NULL, NULL, NULL, 4),
(135872, NULL, 'G3DSA:6.10.250.3250:FF:000002', NULL, NULL, 'Component of cytosolic 80S ribosome and 60S large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(135873, NULL, 'G3DSA:3.60.10.10:FF:000325', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135874, NULL, 'G3DSA:1.10.40.30:FF:000019', NULL, NULL, 'Fumarate hydratase class II', NULL, NULL, NULL, NULL, NULL, 4),
(135875, NULL, 'G3DSA:3.40.50.300:FF:001768', NULL, NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 10, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(135876, NULL, 'G3DSA:3.30.160.60:FF:004022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135877, NULL, 'G3DSA:1.20.5.2700:FF:000003', NULL, NULL, 'NAD(P)H-quinone oxidoreductase subunit 5, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(135878, NULL, 'G3DSA:3.30.160.60:FF:001947', NULL, NULL, 'Zinc finger protein 605', NULL, NULL, NULL, NULL, NULL, 4),
(135879, NULL, 'G3DSA:1.10.8.60:FF:000430', NULL, NULL, 'AAA family ATPase peroxin 1', NULL, NULL, NULL, NULL, NULL, 4),
(135880, NULL, 'G3DSA:3.40.50.2300:FF:001193', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135881, NULL, 'G3DSA:3.30.310.80:FF:000027', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(135882, NULL, 'G3DSA:3.40.50.720:FF:000826', NULL, NULL, 'Probable dehydrogenase/reductase', NULL, NULL, NULL, NULL, NULL, 4),
(135883, NULL, 'G3DSA:3.30.505.10:FF:000161', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type', NULL, NULL, NULL, NULL, NULL, 4),
(135884, NULL, 'G3DSA:2.130.10.30:FF:000178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135885, NULL, 'G3DSA:1.20.58.340:FF:000072', NULL, NULL, 'Cation transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135886, NULL, 'G3DSA:3.30.160.60:FF:005219', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135887, NULL, 'G3DSA:2.60.40.3510:FF:000023', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(135888, NULL, 'G3DSA:3.40.250.10:FF:000156', NULL, NULL, 'Rhodanese domain protein / beta-lactamase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(135889, NULL, 'G3DSA:2.10.10.100:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135890, NULL, 'G3DSA:1.50.40.10:FF:000461', NULL, NULL, 'Solute carrier family 25 member 32a', NULL, NULL, NULL, NULL, NULL, 4),
(135891, NULL, 'G3DSA:2.40.50.140:FF:001117', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135892, NULL, 'G3DSA:1.20.58.1310:FF:000002', NULL, NULL, 'Rop guanine nucleotide exchange factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(135893, NULL, 'G3DSA:3.40.50.620:FF:000566', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135894, NULL, 'G3DSA:1.10.510.10:FF:000314', NULL, NULL, 'Serine threonine-protein kinase mak', NULL, NULL, NULL, NULL, NULL, 4),
(135895, NULL, 'G3DSA:3.90.1260.10:FF:000009', NULL, NULL, 'Putative carbamoyl-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(135896, NULL, 'G3DSA:3.30.60.300:FF:000002', NULL, NULL, '60S ribosomal protein L10', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(135897, NULL, 'G3DSA:1.20.1560.10:FF:000814', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135898, NULL, 'G3DSA:1.20.1260.140:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135899, NULL, 'G3DSA:3.40.50.720:FF:000719', NULL, NULL, 'Alanine dehydrogenase, truncation', NULL, NULL, NULL, NULL, NULL, 4),
(135900, NULL, 'G3DSA:3.40.50.300:FF:000245', NULL, NULL, 'C-1-tetrahydrofolate synthase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(135901, NULL, 'G3DSA:3.40.30.10:FF:000821', NULL, NULL, 'Protein disulfide isomerase-like 1-2', NULL, NULL, NULL, NULL, NULL, 4),
(135902, NULL, 'G3DSA:3.30.342.10:FF:000041', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(135903, NULL, 'G3DSA:3.30.160.60:FF:005545', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135904, NULL, 'G3DSA:1.20.1250.20:FF:000373', NULL, NULL, 'Vacuolar basic amino acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(135905, NULL, 'G3DSA:3.40.50.300:FF:007496', NULL, NULL, 'Helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135906, NULL, 'G3DSA:3.30.428.10:FF:000049', NULL, NULL, 'Aprataxin', NULL, NULL, NULL, NULL, NULL, 4),
(135907, NULL, 'G3DSA:1.25.40.10:FF:001267', NULL, NULL, 'Tetratricopeptide repeat protein 30 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(135908, NULL, 'G3DSA:3.30.70.2190:FF:000010', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(135909, NULL, 'G3DSA:3.40.50.360:FF:000016', NULL, NULL, 'Sulfite reductase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(135910, NULL, 'G3DSA:2.60.40.840:FF:000005', NULL, NULL, 'Arrestin domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(135911, NULL, 'G3DSA:3.60.40.10:FF:000260', NULL, NULL, 'Tap-1', NULL, NULL, NULL, NULL, NULL, 4),
(135912, NULL, 'G3DSA:3.30.300.30:FF:000085', NULL, NULL, 'AMP-binding_enzyme/AMP-binding_enzyme_C-terminal_ domain/Ankyrin_repeats_(3_copies)/Ankyrin_repeat/Ankyrin_re peats_(Many_copies)_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(135913, NULL, 'G3DSA:4.10.400.10:FF:000137', NULL, NULL, 'Uncharacterized protein, isoform AA', NULL, NULL, NULL, NULL, NULL, 4),
(135914, NULL, 'G3DSA:2.60.40.10:FF:000205', NULL, NULL, 'Cell adhesion associated, oncogene regulated', NULL, NULL, NULL, NULL, NULL, 4),
(135915, NULL, 'G3DSA:3.90.190.10:FF:000432', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135916, NULL, 'G3DSA:2.30.29.30:FF:001052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135917, NULL, 'G3DSA:2.60.40.10:FF:003639', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135918, NULL, 'G3DSA:2.60.120.10:FF:000163', NULL, NULL, 'Putative cupin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(135919, NULL, 'G3DSA:3.40.250.10:FF:000049', NULL, NULL, 'Phage shock protein E', NULL, NULL, NULL, NULL, NULL, 4),
(135920, NULL, 'G3DSA:3.30.300.20:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135921, NULL, 'G3DSA:1.20.930.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135922, NULL, 'G3DSA:3.80.10.10:FF:004540', NULL, NULL, 'Os08g0193500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(135923, NULL, 'G3DSA:2.60.40.10:FF:003864', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135924, NULL, 'G3DSA:3.20.20.190:FF:000109', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135925, NULL, 'G3DSA:3.30.200.20:FF:001445', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135926, NULL, 'G3DSA:1.10.150.120:FF:000008', NULL, NULL, 'Probable aldehyde oxidase gad-3', NULL, NULL, NULL, NULL, NULL, 4),
(135927, NULL, 'G3DSA:3.40.50.2300:FF:000586', NULL, NULL, 'Gluconate utilization system gnt-I transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(135928, NULL, 'G3DSA:1.10.150.110:FF:000005', NULL, NULL, 'DNA polymerase POL4', NULL, NULL, NULL, NULL, NULL, 4),
(135929, NULL, 'G3DSA:3.40.50.2300:FF:000479', NULL, NULL, 'Two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(135930, NULL, 'G3DSA:1.10.472.80:FF:000077', NULL, NULL, 'TBC1 domain family member', NULL, NULL, NULL, NULL, NULL, 4),
(135931, NULL, 'G3DSA:2.30.42.10:FF:000189', NULL, NULL, 'Big bang, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(135932, NULL, 'G3DSA:1.10.8.60:FF:000317', NULL, NULL, 'AAA-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(135933, NULL, 'G3DSA:3.90.660.10:FF:000064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135934, NULL, 'G3DSA:3.30.200.20:FF:001552', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135935, NULL, 'G3DSA:3.30.1640.10:FF:000013', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(135936, NULL, 'G3DSA:3.40.50.2020:FF:000030', NULL, NULL, 'Ribose-phosphate pyrophosphokinase II', NULL, NULL, NULL, NULL, NULL, 4),
(135937, NULL, 'G3DSA:1.10.472.80:FF:000184', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135938, NULL, 'G3DSA:3.40.50.300:FF:005372', NULL, NULL, 'mRNA cleavage and polyadenylation factor CLP1', NULL, NULL, NULL, NULL, NULL, 4),
(135939, NULL, 'G3DSA:1.20.1050.80:FF:000021', NULL, NULL, 'Vacuolar sorting protein 9 (VPS9) domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(135940, NULL, 'G3DSA:1.20.5.440:FF:000001', NULL, NULL, 'ATP synthase epsilon chain', NULL, NULL, NULL, NULL, NULL, 4),
(135941, NULL, 'G3DSA:3.40.50.300:FF:007513', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135942, NULL, 'G3DSA:1.10.287.660:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135943, NULL, 'G3DSA:2.130.10.10:FF:003842', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135944, NULL, 'G3DSA:3.30.160.60:FF:005326', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135945, NULL, 'G3DSA:3.40.50.300:FF:007277', NULL, NULL, 'Si:ch211-197g15.6', NULL, NULL, NULL, NULL, NULL, 4),
(135946, NULL, 'G3DSA:3.60.40.10:FF:000153', NULL, NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(135947, NULL, 'G3DSA:2.10.25.10:FF:000835', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(135948, NULL, 'G3DSA:2.60.40.10:FF:001498', NULL, NULL, 'immunoglobulin superfamily member 22', NULL, NULL, NULL, NULL, NULL, 4),
(135949, NULL, 'G3DSA:3.40.430.10:FF:000035', NULL, NULL, 'RibD domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(135950, NULL, 'G3DSA:3.40.50.800:FF:000070', NULL, NULL, 'Polymerase (DNA directed), gamma 2, accessory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(135951, NULL, 'G3DSA:3.30.70.330:FF:003144', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135952, NULL, 'G3DSA:3.40.30.10:FF:000602', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(135953, NULL, 'G3DSA:3.40.50.2000:FF:001108', NULL, NULL, 'Soluble starch synthase', NULL, NULL, NULL, NULL, NULL, 4),
(135954, NULL, 'G3DSA:3.30.40.10:FF:001019', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(135955, NULL, 'G3DSA:3.10.580.10:FF:000064', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(135956, NULL, 'G3DSA:3.40.50.300:FF:000352', NULL, NULL, 'ATP-dependent zinc metalloprotease FTSH 7, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(135957, NULL, 'G3DSA:1.25.40.10:FF:003633', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g62370', NULL, NULL, NULL, NULL, NULL, 4),
(135958, NULL, 'G3DSA:1.10.268.10:FF:000003', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(135959, NULL, 'G3DSA:1.10.630.10:FF:000711', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135960, NULL, 'G3DSA:3.30.590.20:FF:000012', NULL, NULL, 'Putative glutamate--cysteine ligase 2', NULL, NULL, NULL, NULL, NULL, 4),
(135961, NULL, 'G3DSA:2.130.10.10:FF:001712', NULL, NULL, 'Sema domain, immunoglobulin domain (Ig), short basic domain, secreted, (semaphorin) 3H', NULL, NULL, NULL, NULL, NULL, 4),
(135962, NULL, 'G3DSA:3.30.160.60:FF:005438', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(135963, NULL, 'G3DSA:3.90.380.10:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135964, NULL, 'G3DSA:3.30.160.60:FF:000531', NULL, NULL, 'Zinc finger protein 827', NULL, NULL, NULL, NULL, NULL, 4),
(135965, NULL, 'G3DSA:4.10.400.10:FF:000250', NULL, NULL, 'Lipophorin receptor 2, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(135966, NULL, 'G3DSA:3.40.850.10:FF:000472', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(135967, NULL, 'G3DSA:1.10.10.60:FF:001139', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135968, NULL, 'G3DSA:3.40.50.1460:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135969, NULL, 'G3DSA:3.30.1640.30:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135970, NULL, 'G3DSA:3.80.10.10:FF:002286', NULL, NULL, 'Fgr38p', NULL, NULL, NULL, NULL, NULL, 4),
(135971, NULL, 'G3DSA:1.10.287.70:FF:000683', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135972, NULL, 'G3DSA:2.130.10.10:FF:002100', NULL, NULL, 'Unplaced genomic scaffold supercont1.23, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(135973, NULL, 'G3DSA:3.30.160.20:FF:000216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135974, NULL, 'G3DSA:3.90.190.10:FF:000319', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(135975, NULL, 'G3DSA:1.10.268.20:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(135976, NULL, 'G3DSA:2.60.40.10:FF:001515', NULL, NULL, 'Colony stimulating factor 2 receptor alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(135977, NULL, 'G3DSA:3.30.450.20:FF:000429', NULL, NULL, 'Sensor histidine kinase, PAS, PAS and PAS domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(135978, NULL, 'G3DSA:1.25.40.10:FF:001380', NULL, NULL, 'TPR repeat-containing protein ZIP4', NULL, NULL, NULL, NULL, NULL, 4),
(135979, NULL, 'G3DSA:3.80.10.10:FF:002067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135980, NULL, 'G3DSA:1.20.1560.10:FF:000921', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135981, NULL, 'G3DSA:1.20.1250.10:FF:000038', NULL, NULL, 'Interleukin 24', NULL, NULL, NULL, NULL, NULL, 4),
(135982, NULL, 'G3DSA:1.20.1600.10:FF:000060', NULL, NULL, 'Outer membrane efflux protein', NULL, NULL, NULL, NULL, NULL, 4),
(135983, NULL, 'G3DSA:3.40.50.1820:FF:000874', NULL, NULL, 'Putative esterase KAI2', NULL, NULL, NULL, NULL, NULL, 4),
(135984, NULL, 'G3DSA:1.10.287.110:FF:000105', NULL, NULL, 'Chaperone DnaJ-domain superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(135985, NULL, 'G3DSA:1.10.510.10:FF:001950', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(135986, NULL, 'G3DSA:2.60.40.10:FF:001734', NULL, NULL, 'Nonclassical MHC class I molecule, alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(135987, NULL, 'G3DSA:3.40.1380.20:FF:000027', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(135988, NULL, 'G3DSA:3.40.50.300:FF:005259', NULL, NULL, 'Ras-related protein Rab-39B', NULL, NULL, NULL, NULL, NULL, 4),
(135989, NULL, 'G3DSA:3.30.200.20:FF:000838', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(135990, NULL, 'G3DSA:1.25.40.20:FF:001383', NULL, NULL, 'ANKYRIN', NULL, NULL, NULL, NULL, NULL, 4),
(135991, NULL, 'G3DSA:1.20.1250.20:FF:000592', NULL, NULL, 'Phosphate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(135992, NULL, 'G3DSA:3.40.50.10380:FF:000024', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(135993, NULL, 'G3DSA:3.40.50.150:FF:000054', NULL, NULL, 'Catechol O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(135994, NULL, 'G3DSA:1.10.8.60:FF:000087', NULL, NULL, '26S protease regulatory subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(135995, NULL, 'G3DSA:3.40.190.10:FF:000909', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(135996, NULL, 'G3DSA:3.40.50.300:FF:008114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(135997, NULL, 'G3DSA:2.130.10.10:FF:005753', NULL, NULL, 'F-box/WD repeat-containing protein A', NULL, NULL, NULL, NULL, NULL, 4),
(135998, NULL, 'G3DSA:2.30.29.30:FF:000338', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(135999, NULL, 'G3DSA:3.30.70.330:FF:000963', NULL, NULL, 'NMD pathway component', NULL, NULL, NULL, NULL, NULL, 4),
(136000, NULL, 'G3DSA:1.25.40.10:FF:001379', NULL, NULL, 'Selenium-binding protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(136001, NULL, 'G3DSA:3.40.50.620:FF:000785', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136002, NULL, 'G3DSA:3.40.1380.10:FF:000024', NULL, NULL, 'ATP synthase gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(136003, NULL, 'G3DSA:1.10.3210.10:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136004, NULL, 'G3DSA:2.60.40.10:FF:003752', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136005, NULL, 'G3DSA:1.25.40.10:FF:003414', NULL, NULL, 'PPR repeat family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136006, NULL, 'G3DSA:1.25.40.10:FF:002796', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(136007, NULL, 'G3DSA:1.20.120.1630:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136008, NULL, 'G3DSA:3.40.50.720:FF:000607', NULL, NULL, 'Inositol-3-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(136009, NULL, 'G3DSA:2.10.25.10:FF:000616', NULL, NULL, 'neurexin-1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(136010, NULL, 'G3DSA:1.10.10.10:FF:000410', NULL, NULL, 'ADA regulatory protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136011, NULL, 'G3DSA:3.40.33.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136012, NULL, 'G3DSA:3.10.20.30:FF:000002', NULL, NULL, 'GTP pyrophosphokinase (RelA/SpoT)', NULL, NULL, NULL, NULL, NULL, 4),
(136013, NULL, 'G3DSA:3.30.1370.110:FF:000002', NULL, NULL, 'CCCH zinc finger and SMR domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(136014, NULL, 'G3DSA:3.40.50.150:FF:001813', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136015, NULL, 'G3DSA:2.120.10.90:FF:000022', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(136016, NULL, 'G3DSA:2.130.10.10:FF:001482', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(136017, NULL, 'G3DSA:1.10.630.10:FF:000481', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136018, NULL, 'G3DSA:3.30.200.20:FF:001333', NULL, NULL, 'Protein kinase, putative (AFU_orthologue AFUA_7G00740)', NULL, NULL, NULL, NULL, NULL, 4),
(136019, NULL, 'G3DSA:1.10.287.70:FF:000464', NULL, NULL, 'Potassium voltage-gated channel subfamily H member 8', NULL, NULL, NULL, NULL, NULL, 4),
(136020, NULL, 'G3DSA:2.40.270.10:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136021, NULL, 'G3DSA:3.40.50.200:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136022, NULL, 'G3DSA:3.40.50.1360:FF:000034', NULL, NULL, '6-phosphogluconolactonase', NULL, NULL, NULL, NULL, NULL, 4),
(136023, NULL, 'G3DSA:2.40.33.10:FF:000010', NULL, NULL, 'Pyruvate kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(136024, NULL, 'G3DSA:1.20.910.10:FF:000028', NULL, NULL, 'Rop guanine nucleotide exchange factor 7', NULL, NULL, NULL, NULL, NULL, 4),
(136025, NULL, 'G3DSA:3.40.50.1910:FF:000019', NULL, NULL, 'Carnation, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(136026, NULL, 'G3DSA:3.40.50.300:FF:001881', NULL, NULL, 'Structural maintenance of chromosomes protein', NULL, NULL, NULL, NULL, NULL, 4),
(136027, NULL, 'G3DSA:3.30.2140.20:FF:000001', NULL, NULL, 'Arylamine N-acetyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(136028, NULL, 'G3DSA:3.40.30.10:FF:000041', NULL, NULL, 'Maleylacetoacetate isomerase isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(136029, NULL, 'G3DSA:1.20.120.350:FF:000170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136030, NULL, 'G3DSA:3.20.80.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(136031, NULL, 'G3DSA:2.40.50.140:FF:000499', NULL, NULL, 'Glycerol-3-phosphate ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(136032, NULL, 'G3DSA:2.60.120.200:FF:000609', NULL, NULL, 'Protein crumbs-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(136033, NULL, 'G3DSA:1.10.510.10:FF:001731', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136034, NULL, 'G3DSA:1.20.1250.20:FF:002284', NULL, NULL, 'Os01g0311300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(136035, NULL, 'G3DSA:2.30.30.140:FF:000222', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(136036, NULL, 'G3DSA:3.20.20.140:FF:000454', NULL, NULL, 'Guanine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(136037, NULL, 'G3DSA:3.40.1280.10:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136038, NULL, 'G3DSA:3.30.710.10:FF:000357', NULL, NULL, 'BTB and CNC homology 1, basic leucine zipper transcription factor 1 b', NULL, NULL, NULL, NULL, NULL, 4),
(136039, NULL, 'G3DSA:3.30.460.10:FF:000034', NULL, NULL, 'CCA tRNA nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(136040, NULL, 'G3DSA:2.60.120.200:FF:000267', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor', NULL, NULL, NULL, NULL, NULL, 4),
(136041, NULL, 'G3DSA:3.90.1200.10:FF:000017', NULL, NULL, 'Aminoglycoside phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(136042, NULL, 'G3DSA:3.50.40.10:FF:000001', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(136043, NULL, 'G3DSA:3.90.230.10:FF:000020', NULL, NULL, 'FACT complex subunit SPT16', NULL, NULL, NULL, NULL, NULL, 4),
(136044, NULL, 'G3DSA:3.30.900.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136045, NULL, 'G3DSA:2.40.50.40:FF:000093', NULL, NULL, 'C-C motif chemokine', NULL, NULL, NULL, NULL, NULL, 4),
(136046, NULL, 'G3DSA:1.10.287.1090:FF:000001', NULL, NULL, 'major centromere autoantigen B', NULL, NULL, NULL, NULL, NULL, 4),
(136047, NULL, 'G3DSA:1.20.120.1080:FF:000042', NULL, NULL, 'probable ATP-dependent RNA helicase kurz', NULL, NULL, NULL, NULL, NULL, 4),
(136048, NULL, 'G3DSA:3.30.420.10:FF:000256', NULL, NULL, 'Conserved protein of uncharacterized function, possible transposase remnant', NULL, NULL, NULL, NULL, NULL, 4),
(136049, NULL, 'G3DSA:1.20.930.40:FF:000010', NULL, NULL, 'VPS70p protein', NULL, NULL, NULL, NULL, NULL, 4),
(136050, NULL, 'G3DSA:3.40.50.300:FF:003803', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136051, NULL, 'G3DSA:1.10.3860.10:FF:000025', NULL, NULL, 'Amino acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(136052, NULL, 'G3DSA:3.80.10.10:FF:002847', NULL, NULL, 'Leucine rich repeat containing 15', NULL, NULL, NULL, NULL, NULL, 4),
(136053, NULL, 'G3DSA:3.90.640.10:FF:000175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136054, NULL, 'G3DSA:2.60.40.10:FF:001953', NULL, NULL, 'V-set and transmembrane domain containing 4b', NULL, NULL, NULL, NULL, NULL, 4),
(136055, NULL, 'G3DSA:1.25.50.20:FF:000028', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(136056, NULL, 'G3DSA:1.10.1620.20:FF:000010', NULL, NULL, 'ATP synthase subunit epsilon, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(136057, NULL, 'G3DSA:1.50.10.20:FF:000075', NULL, NULL, 'Protein farnesyltransferase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(136058, NULL, 'G3DSA:3.80.10.10:FF:003123', NULL, NULL, 'Distal membrane arm assembly complex 2', NULL, NULL, NULL, NULL, NULL, 4),
(136059, NULL, 'G3DSA:1.10.287.90:FF:000003', NULL, NULL, 'Cytochrome C oxidase subunit II', NULL, NULL, NULL, NULL, NULL, 4),
(136060, NULL, 'G3DSA:1.50.10.10:FF:000072', NULL, NULL, 'Lanthionine synthetase C family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136061, NULL, 'G3DSA:3.40.50.20:FF:000039', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(136062, NULL, 'G3DSA:1.20.1560.10:FF:000578', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(136063, NULL, 'G3DSA:1.20.58.400:FF:000017', NULL, NULL, 'Vesicle transport through interaction with t-SNAREs homolog 1A', NULL, NULL, NULL, NULL, NULL, 4),
(136064, NULL, 'G3DSA:6.10.140.2220:FF:000008', NULL, NULL, 'Deformed epidermal autoregulatory factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(136065, NULL, 'G3DSA:1.25.40.20:FF:000202', NULL, NULL, 'Protein fem-1 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(136066, NULL, 'G3DSA:1.20.1050.10:FF:000276', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(136067, NULL, 'G3DSA:3.30.160.60:FF:004241', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136068, NULL, 'G3DSA:1.50.10.160:FF:000004', NULL, NULL, 'Type B diterpene cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(136069, NULL, 'G3DSA:3.40.605.10:FF:000054', NULL, NULL, 'Aldehyde dehydrogenase family 1 member A3', NULL, NULL, NULL, NULL, NULL, 4),
(136070, NULL, 'G3DSA:1.10.357.30:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136071, NULL, 'G3DSA:3.30.70.940:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136072, NULL, 'G3DSA:4.10.240.10:FF:000153', NULL, NULL, 'Lys144p', NULL, NULL, NULL, NULL, NULL, 4),
(136073, NULL, 'G3DSA:1.20.930.60:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136074, NULL, 'G3DSA:3.40.190.10:FF:000898', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(136075, NULL, 'G3DSA:3.80.10.10:FF:000717', NULL, NULL, 'Os02g0136900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(136076, NULL, 'G3DSA:1.25.40.10:FF:003178', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(136077, NULL, 'G3DSA:3.60.21.10:FF:000007', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(136078, NULL, 'G3DSA:2.60.40.1390:FF:000005', NULL, NULL, 'Meiosis-specific transcription factor NDT80', NULL, NULL, NULL, NULL, NULL, 4),
(136079, NULL, 'G3DSA:1.10.630.10:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136080, NULL, 'G3DSA:3.10.20.90:FF:000323', NULL, NULL, 'Nuclear protein localization protein 4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(136081, NULL, 'G3DSA:3.40.50.740:FF:000023', NULL, NULL, 'Dimethyl sulfoxide reductase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(136082, NULL, 'G3DSA:3.20.20.80:FF:000472', NULL, NULL, 'Glycoside hydrolase, family 35', NULL, NULL, NULL, NULL, NULL, 4),
(136083, NULL, 'G3DSA:3.30.190.20:FF:000044', NULL, NULL, '39S ribosomal protein L1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(136084, NULL, 'G3DSA:1.10.287.470:FF:000073', NULL, NULL, 'Efflux pump, RND family, membrane fusion lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(136085, NULL, 'G3DSA:1.50.40.10:FF:000242', NULL, NULL, 'Putative mitochondrial carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(136086, NULL, 'G3DSA:1.50.10.150:FF:000001', NULL, NULL, 'S-type anion channel SLAH3', NULL, NULL, NULL, NULL, NULL, 4),
(136087, NULL, 'G3DSA:3.60.10.10:FF:000089', NULL, NULL, 'Exodeoxyribonuclease III, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136088, NULL, 'G3DSA:1.25.40.20:FF:001725', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136089, NULL, 'G3DSA:1.10.510.10:FF:003748', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136090, NULL, 'G3DSA:1.10.8.480:FF:000021', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(136091, NULL, 'G3DSA:2.60.40.150:FF:000006', NULL, NULL, 'Synaptotagmin-like 5, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(136092, NULL, 'G3DSA:3.90.70.10:FF:000052', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(136093, NULL, 'G3DSA:1.25.40.10:FF:005090', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At1g12700, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(136094, NULL, 'G3DSA:3.40.1190.20:FF:000215', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136095, NULL, 'G3DSA:1.20.140.10:FF:000014', NULL, NULL, 'Cytochrome c-552', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(136096, NULL, 'G3DSA:3.40.50.300:FF:007058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136097, NULL, 'G3DSA:1.20.1740.10:FF:000126', NULL, NULL, 'Amino acid transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(136098, NULL, 'G3DSA:1.10.1750.10:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136099, NULL, 'G3DSA:3.40.50.300:FF:005478', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136100, NULL, 'G3DSA:3.30.160.60:FF:000312', NULL, NULL, 'Zinc finger and BTB domain-containing 47', NULL, NULL, NULL, NULL, NULL, 4),
(136101, NULL, 'G3DSA:1.25.40.10:FF:001722', NULL, NULL, 'pentatricopeptide repeat-containing protein At4g01030, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(136102, NULL, 'G3DSA:1.20.920.10:FF:000080', NULL, NULL, 'Histone-lysine N-methyltransferase trithorax', NULL, NULL, NULL, NULL, NULL, 4),
(136103, NULL, 'G3DSA:2.10.50.10:FF:000017', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 10B', NULL, NULL, NULL, NULL, NULL, 4),
(136104, NULL, 'G3DSA:3.40.50.1820:FF:001150', NULL, NULL, 'Lipoxygenase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(136105, NULL, 'G3DSA:3.40.50.1240:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136106, NULL, 'G3DSA:3.30.40.10:FF:001351', NULL, NULL, 'Pre-mRNA-splicing factor CWC24', NULL, NULL, NULL, NULL, NULL, 4),
(136107, NULL, 'G3DSA:1.10.1040.10:FF:000053', NULL, NULL, '3-hydroxyacyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(136108, NULL, 'G3DSA:2.30.110.10:FF:000028', NULL, NULL, 'PPOX class F420-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(136109, NULL, 'G3DSA:3.40.50.300:FF:001549', NULL, NULL, 'SUV3p ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(136110, NULL, 'G3DSA:3.90.180.10:FF:000038', NULL, NULL, 'Ast1p', NULL, NULL, NULL, NULL, NULL, 4),
(136111, NULL, 'G3DSA:1.20.1280.50:FF:000181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136112, NULL, 'G3DSA:3.40.630.30:FF:000354', NULL, NULL, 'AGAP003264-PA', NULL, NULL, NULL, NULL, NULL, 4),
(136113, NULL, 'G3DSA:1.10.510.10:FF:004024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136114, NULL, 'G3DSA:3.40.1110.10:FF:000095', NULL, NULL, 'Calcium-transporting ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136115, NULL, 'G3DSA:1.10.287.70:FF:000245', NULL, NULL, 'Voltage-gated sodium channel Nav2.1', NULL, NULL, NULL, NULL, NULL, 4),
(136116, NULL, 'G3DSA:3.30.720.190:FF:000001', NULL, NULL, 'PlyCB', NULL, NULL, NULL, NULL, NULL, 4),
(136117, NULL, 'G3DSA:2.40.290.10:FF:000027', NULL, NULL, 'ATP-dependent DNA helicase II subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(136118, NULL, 'G3DSA:2.60.220.50:FF:000093', NULL, NULL, 'Starry night', NULL, NULL, NULL, NULL, NULL, 4),
(136119, NULL, 'G3DSA:1.20.58.1120:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136120, NULL, 'G3DSA:1.10.510.10:FF:003187', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136121, NULL, 'G3DSA:1.10.520.10:FF:000034', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(136122, NULL, 'G3DSA:6.10.140.2200:FF:000002', NULL, NULL, 'cbp/p300-interacting transactivator 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(136123, NULL, 'G3DSA:1.20.58.2170:FF:000001', NULL, NULL, 'Death domain-associated protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(136124, NULL, 'G3DSA:3.10.50.40:FF:000052', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(136125, NULL, 'G3DSA:3.40.50.1010:FF:000171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136126, NULL, 'G3DSA:3.40.50.1000:FF:000510', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(136127, NULL, 'G3DSA:3.80.10.10:FF:000375', NULL, NULL, 'Piriformospora indica-insensitive protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(136128, NULL, 'G3DSA:1.20.1270.60:FF:000245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136129, NULL, 'G3DSA:2.60.40.10:FF:003533', NULL, NULL, 'Titin, tandem duplicate 1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(136130, NULL, 'G3DSA:3.40.50.300:FF:003348', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136131, NULL, 'G3DSA:2.30.42.10:FF:000644', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136132, NULL, 'G3DSA:1.20.58.60:FF:000883', NULL, NULL, 'Spectrin alpha, non-erythrocytic 1', NULL, NULL, NULL, NULL, NULL, 4),
(136133, NULL, 'G3DSA:1.20.1250.20:FF:001210', NULL, NULL, 'Sodium-dependent phosphate transport protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(136134, NULL, 'G3DSA:3.40.390.10:FF:000099', NULL, NULL, 'GM23611', NULL, NULL, NULL, NULL, NULL, 4),
(136135, NULL, 'G3DSA:3.40.50.150:FF:001690', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136136, NULL, 'G3DSA:3.80.10.10:FF:000830', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(136137, NULL, 'G3DSA:1.25.40.10:FF:003291', NULL, NULL, 'Vacuolar protein sorting-associated protein 11 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(136138, NULL, 'G3DSA:3.60.21.10:FF:000120', NULL, NULL, '3'',5''-cyclic adenosine monophosphate phosphodiesterase CpdA', NULL, NULL, NULL, NULL, NULL, 4),
(136139, NULL, 'G3DSA:3.30.9.10:FF:000222', NULL, NULL, 'NAD dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136140, NULL, 'G3DSA:1.20.1070.10:FF:000726', NULL, NULL, 'Protein CBG03354', NULL, NULL, NULL, NULL, NULL, 4),
(136141, NULL, 'G3DSA:3.10.20.90:FF:000104', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type', NULL, NULL, NULL, NULL, NULL, 4),
(136142, NULL, 'G3DSA:2.60.40.10:FF:002116', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(136143, NULL, 'G3DSA:1.10.340.70:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136144, NULL, 'G3DSA:3.20.20.80:FF:000691', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(136145, NULL, 'G3DSA:1.20.58.2190:FF:000007', NULL, NULL, 'Ubiquitin-associated (UBA)/TS-N domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(136146, NULL, 'G3DSA:2.60.40.10:FF:005663', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136147, NULL, 'G3DSA:3.40.50.720:FF:002176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136148, NULL, 'G3DSA:1.20.1070.10:FF:000384', NULL, NULL, 'Prostaglandin E receptor 1a (subtype EP1)', NULL, NULL, NULL, NULL, NULL, 4),
(136149, NULL, 'G3DSA:3.30.70.260:FF:000133', NULL, NULL, 'Lysine-sensitive aspartokinase III', NULL, NULL, NULL, NULL, NULL, 4),
(136150, NULL, 'G3DSA:1.25.40.250:FF:000013', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit K', NULL, NULL, NULL, NULL, NULL, 4),
(136151, NULL, 'G3DSA:2.40.50.140:FF:000954', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136152, NULL, 'G3DSA:3.40.50.1010:FF:000058', NULL, NULL, 'Flap endonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(136153, NULL, 'G3DSA:1.10.3370.10:FF:000050', NULL, NULL, 'Sec61 alpha subunit putative', NULL, NULL, NULL, NULL, NULL, 4),
(136154, NULL, 'G3DSA:3.40.630.30:FF:000135', NULL, NULL, 'RNA cytidine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(136155, NULL, 'G3DSA:1.25.40.70:FF:000065', NULL, NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(136156, NULL, 'G3DSA:2.60.120.10:FF:000382', NULL, NULL, '(S)-2-hydroxypropylphosphonic acid epoxidase', NULL, NULL, NULL, NULL, NULL, 4),
(136157, NULL, 'G3DSA:1.20.1070.10:FF:001002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136158, NULL, 'G3DSA:2.10.50.10:FF:000130', NULL, NULL, 'Tumor necrosis factor receptor superfamily, member 1a', NULL, NULL, NULL, NULL, NULL, 4),
(136159, NULL, 'G3DSA:1.10.150.50:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136160, NULL, 'G3DSA:3.60.40.10:FF:000259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136161, NULL, 'G3DSA:1.50.40.10:FF:000129', NULL, NULL, 'Peroxisomal membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(136162, NULL, 'G3DSA:2.30.30.40:FF:000052', NULL, NULL, 'Ubiquitin-associated and SH3 domain-containing protein B', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(136163, NULL, 'G3DSA:3.30.70.330:FF:001126', NULL, NULL, 'Nucleolin', NULL, NULL, NULL, NULL, NULL, 4),
(136164, NULL, 'G3DSA:1.25.10.10:FF:002968', NULL, NULL, 'Importin 4', NULL, NULL, NULL, NULL, NULL, 4),
(136165, NULL, 'G3DSA:2.60.40.1730:FF:000028', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(136166, NULL, 'G3DSA:3.80.10.10:FF:004427', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136167, NULL, 'G3DSA:1.10.10.10:FF:001714', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(136168, NULL, 'G3DSA:3.90.1410.10:FF:000050', NULL, NULL, 'SET domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(136169, NULL, 'G3DSA:2.130.10.10:FF:005079', NULL, NULL, 'WD repeat protein iqw1', NULL, NULL, NULL, NULL, NULL, 4),
(136170, NULL, 'G3DSA:3.40.50.150:FF:001577', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136171, NULL, 'G3DSA:3.90.190.10:FF:000538', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136172, NULL, 'G3DSA:1.10.10.10:FF:001591', NULL, NULL, '6-hydroxytryprostatin B O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(136173, NULL, 'G3DSA:3.40.50.1700:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136174, NULL, 'G3DSA:1.10.455.10:FF:000011', NULL, NULL, '30S ribosomal protein S7', NULL, NULL, NULL, NULL, NULL, 4),
(136175, NULL, 'G3DSA:3.40.50.150:FF:001358', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136176, NULL, 'G3DSA:3.30.70.100:FF:000113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136177, NULL, 'G3DSA:3.30.40.10:FF:000637', NULL, NULL, 'NOSIP domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(136178, NULL, 'G3DSA:1.25.40.10:FF:001503', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g33170', NULL, NULL, NULL, NULL, NULL, 4),
(136179, NULL, 'G3DSA:1.10.10.10:FF:001933', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136180, NULL, 'G3DSA:3.20.20.70:FF:000137', NULL, NULL, 'Tagatose 1,6-diphosphate aldolase 2', NULL, NULL, NULL, NULL, NULL, 4),
(136181, NULL, 'G3DSA:3.40.50.620:FF:000347', NULL, NULL, 'FMN adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(136182, NULL, 'G3DSA:3.30.930.10:FF:000339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136183, NULL, 'G3DSA:4.10.800.30:FF:000005', NULL, NULL, 'AGAP002302-PA', NULL, NULL, NULL, NULL, NULL, 4),
(136184, NULL, 'G3DSA:3.80.10.10:FF:004085', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(136185, NULL, 'G3DSA:1.10.533.10:FF:000120', NULL, NULL, 'B-cell lymphoma/leukemia 10-like', NULL, NULL, NULL, NULL, NULL, 4),
(136186, NULL, 'G3DSA:3.30.420.10:FF:000037', NULL, NULL, 'epithelial splicing regulatory protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(136187, NULL, 'G3DSA:3.40.50.970:FF:000199', NULL, NULL, '2-hydroxyphytanoyl-CoA lyase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136188, NULL, 'G3DSA:3.20.20.60:FF:000134', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(136189, NULL, 'G3DSA:3.40.50.1820:FF:000655', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(136190, NULL, 'G3DSA:3.40.190.80:FF:000082', NULL, NULL, 'Fructose-1,6-bisphosphatase/inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(136191, NULL, 'G3DSA:1.10.510.10:FF:003529', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136192, NULL, 'G3DSA:1.10.560.10:FF:000031', NULL, NULL, '60 kDa heat shock protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(136193, NULL, 'G3DSA:4.10.1250.10:FF:000004', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(136194, NULL, 'G3DSA:2.60.120.200:FF:000722', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(136195, NULL, 'G3DSA:1.25.10.10:FF:003244', NULL, NULL, 'Serine/threonine-protein kinase ATR-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(136196, NULL, 'G3DSA:1.25.40.10:FF:003852', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(136197, NULL, 'G3DSA:2.40.50.120:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136198, NULL, 'G3DSA:3.30.9.10:FF:000109', NULL, NULL, 'Pyridine nucleotide-disulfide oxidoreductase/Thi4 family/FAD dependent oxidoreductase/NAD(P)-binding Rossmann-like domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136199, NULL, 'G3DSA:2.60.120.260:FF:000369', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(136200, NULL, 'G3DSA:4.10.800.20:FF:000002', NULL, NULL, 'AMP deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(136201, NULL, 'G3DSA:1.20.1250.20:FF:000715', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(136202, NULL, 'G3DSA:3.40.50.300:FF:003680', NULL, NULL, 'DEAD/DEAH box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(136203, NULL, 'G3DSA:3.30.10.30:FF:000006', NULL, NULL, 'Dual-specificity tyrosine phosphorylation-regulated kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(136204, NULL, 'G3DSA:3.40.50.10090:FF:000038', NULL, NULL, 'Uroporphyrinogen-III synthase HemD', NULL, NULL, NULL, NULL, NULL, 4),
(136205, NULL, 'G3DSA:3.40.920.10:FF:000011', NULL, NULL, '2-oxoacid ferredoxin oxidoreductase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(136206, NULL, 'G3DSA:2.130.10.10:FF:003623', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(136207, NULL, 'G3DSA:1.20.1070.10:FF:000945', NULL, NULL, 'Olr1366 protein', NULL, NULL, NULL, NULL, NULL, 4),
(136208, NULL, 'G3DSA:1.10.565.10:FF:000126', NULL, NULL, 'Protein CBG26996', NULL, NULL, NULL, NULL, NULL, 4),
(136209, NULL, 'G3DSA:2.60.40.10:FF:001279', NULL, NULL, 'OX-2 membrane glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(136210, NULL, 'G3DSA:4.10.400.10:FF:000031', NULL, NULL, 'Low-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(136211, NULL, 'G3DSA:1.25.10.20:FF:000032', NULL, NULL, 'Hemolymph clottable protein', NULL, NULL, NULL, NULL, NULL, 4),
(136212, NULL, 'G3DSA:1.10.101.10:FF:000033', NULL, NULL, 'Gamma-D-glutamyl-L-diamino acid endopeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(136213, NULL, 'G3DSA:2.102.10.10:FF:000011', NULL, NULL, 'Carnitine monooxygenase oxygenase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(136214, NULL, 'G3DSA:3.40.50.720:FF:002395', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136215, NULL, 'G3DSA:2.30.30.490:FF:000074', NULL, NULL, 'DNA (cytosine-5)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(136216, NULL, 'G3DSA:3.60.130.10:FF:000019', NULL, NULL, 'TauD/TfdA family dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(136217, NULL, 'G3DSA:3.40.50.1820:FF:000436', NULL, NULL, 'Extracelular serine carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136218, NULL, 'G3DSA:3.90.215.10:FF:000007', NULL, NULL, 'Fibrinogen-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(136219, NULL, 'G3DSA:3.40.50.300:FF:007390', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136220, NULL, 'G3DSA:3.30.160.60:FF:003185', NULL, NULL, 'Lame duck, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(136221, NULL, 'G3DSA:3.40.850.10:FF:000359', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(136222, NULL, 'G3DSA:1.10.45.10:FF:000002', NULL, NULL, 'Alkylglycerone-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(136223, NULL, 'G3DSA:3.30.40.10:FF:000295', NULL, NULL, 'Zinc finger, FYVE domain-containing 26', NULL, NULL, NULL, NULL, NULL, 4),
(136224, NULL, 'G3DSA:3.20.20.70:FF:000356', NULL, NULL, 'Ribonucleotide reductase of class III (Anaerobic), activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(136225, NULL, 'G3DSA:3.30.950.10:FF:000009', NULL, NULL, 'Tetrapyrrole methylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136226, NULL, 'G3DSA:3.20.20.80:FF:000359', NULL, NULL, 'Glucosidase, beta, acid 3 (Cytosolic) (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(136227, NULL, 'G3DSA:3.30.470.20:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136228, NULL, 'G3DSA:2.60.120.380:FF:000045', NULL, NULL, 'Serine protease halolysin', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(136229, NULL, 'G3DSA:1.10.10.10:FF:001372', NULL, NULL, 'Ferric uptake regulation protein', NULL, NULL, NULL, NULL, NULL, 4),
(136230, NULL, 'G3DSA:3.90.190.10:FF:000196', NULL, NULL, 'Dual specificity protein phosphatase putative', NULL, NULL, NULL, NULL, NULL, 4),
(136231, NULL, 'G3DSA:3.30.760.10:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136232, NULL, 'G3DSA:3.40.50.300:FF:007732', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136233, NULL, 'G3DSA:1.10.20.70:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136234, NULL, 'G3DSA:3.10.590.10:FF:000014', NULL, NULL, 'Thymocyte nuclear protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(136235, NULL, 'G3DSA:3.30.1330.30:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136236, NULL, 'G3DSA:1.10.540.10:FF:000142', NULL, NULL, 'Bll6377 protein', NULL, NULL, NULL, NULL, NULL, 4),
(136237, NULL, 'G3DSA:3.30.160.60:FF:003527', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(136238, NULL, 'G3DSA:1.10.10.750:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136239, NULL, 'G3DSA:3.30.70.330:FF:001345', NULL, NULL, 'Protein CBG14639', NULL, NULL, NULL, NULL, NULL, 4),
(136240, NULL, 'G3DSA:2.40.50.140:FF:001230', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136241, NULL, 'G3DSA:1.20.58.60:FF:000664', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136242, NULL, 'G3DSA:1.10.510.10:FF:003861', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136243, NULL, 'G3DSA:2.120.10.30:FF:000499', NULL, NULL, 'Hemomucin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136244, NULL, 'G3DSA:3.30.10.20:FF:000003', NULL, NULL, 'Serine/threonine protein kinase PrkC', NULL, NULL, NULL, NULL, NULL, 4),
(136245, NULL, 'G3DSA:1.20.1070.10:FF:001221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136246, NULL, 'G3DSA:3.30.70.1730:FF:000024', NULL, NULL, '60S acidic ribosomal protein P0', NULL, NULL, NULL, NULL, NULL, 4),
(136247, NULL, 'G3DSA:2.40.128.20:FF:000042', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(136248, NULL, 'G3DSA:3.30.420.40:FF:001092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136249, NULL, 'G3DSA:1.20.1270.60:FF:000026', NULL, NULL, 'FCH and double SH3 domains protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(136250, NULL, 'G3DSA:1.10.1200.10:FF:000150', NULL, NULL, 'Acyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(136251, NULL, 'G3DSA:1.20.5.170:FF:000263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136252, NULL, 'G3DSA:3.40.50.720:FF:001568', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(136253, NULL, 'G3DSA:3.30.70.1880:FF:000001', NULL, NULL, 'Membrane associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(136254, NULL, 'G3DSA:1.20.1070.10:FF:001440', NULL, NULL, 'Olfactory receptor E6', NULL, NULL, NULL, NULL, NULL, 4),
(136255, NULL, 'G3DSA:2.60.120.650:FF:000008', NULL, NULL, 'Probable JmjC domain-containing histone demethylation protein 2C', NULL, NULL, NULL, NULL, NULL, 4),
(136256, NULL, 'G3DSA:2.60.40.10:FF:000498', NULL, NULL, 'Down syndrome cell adhesion molecule, isoform J', NULL, NULL, NULL, NULL, NULL, 4),
(136257, NULL, 'G3DSA:2.40.30.170:FF:000015', NULL, NULL, 'Efflux transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(136258, NULL, 'G3DSA:1.20.5.110:FF:000352', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136259, NULL, 'G3DSA:3.30.300.160:FF:000021', NULL, NULL, 'T2aSS secretion system assembly ATPase GspE', NULL, NULL, NULL, NULL, NULL, 4),
(136260, NULL, 'G3DSA:3.40.50.300:FF:006849', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NUBP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(136261, NULL, 'G3DSA:3.40.50.261:FF:000021', NULL, NULL, 'Acetyl-CoA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(136262, NULL, 'G3DSA:3.30.450.150:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136263, NULL, 'G3DSA:1.10.287.70:FF:000705', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136264, NULL, 'G3DSA:3.30.160.60:FF:001083', NULL, NULL, 'Zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(136265, NULL, 'G3DSA:4.10.280.10:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136266, NULL, 'G3DSA:2.40.70.10:FF:000489', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136267, NULL, 'G3DSA:3.30.200.20:FF:002255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136268, NULL, 'G3DSA:1.50.10.10:FF:000178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136269, NULL, 'G3DSA:3.10.490.10:FF:000017', NULL, NULL, 'Gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(136270, NULL, 'G3DSA:2.120.10.30:FF:000190', NULL, NULL, 'Nhl repeat-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136271, NULL, 'G3DSA:3.80.10.10:FF:002679', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(136272, NULL, 'G3DSA:1.20.1250.20:FF:001654', NULL, NULL, 'Major facilitator superfamily MFS_1', NULL, NULL, NULL, NULL, NULL, 4),
(136273, NULL, 'G3DSA:3.90.1290.10:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136274, NULL, 'G3DSA:1.10.150.20:FF:000048', NULL, NULL, 'Fanconi anemia, complementation group M', NULL, NULL, NULL, NULL, NULL, 4),
(136275, NULL, 'G3DSA:2.70.98.10:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136276, NULL, 'G3DSA:1.20.120.850:FF:000011', NULL, NULL, 'DNA repair and recombination protein RAD54', NULL, NULL, NULL, NULL, NULL, 4),
(136277, NULL, 'G3DSA:3.40.50.150:FF:001139', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136278, NULL, 'G3DSA:2.60.40.10:FF:000059', NULL, NULL, 'Ephrin type-A receptor 6', NULL, NULL, NULL, NULL, NULL, 4),
(136279, NULL, 'G3DSA:1.10.580.10:FF:000009', NULL, NULL, 'ATP-citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(136280, NULL, 'G3DSA:3.30.1520.10:FF:000038', NULL, NULL, 'sorting nexin-24', NULL, NULL, NULL, NULL, NULL, 4),
(136281, NULL, 'G3DSA:2.60.40.60:FF:001069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136282, NULL, 'G3DSA:1.25.40.10:FF:001407', NULL, NULL, 'Pentatricopeptide (PPR) repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(136283, NULL, 'G3DSA:1.20.120.230:FF:000033', NULL, NULL, 'CRE-DEB-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(136284, NULL, 'G3DSA:3.80.10.10:FF:002207', NULL, NULL, 'MHC class II transactivator', NULL, NULL, NULL, NULL, NULL, 4),
(136285, NULL, 'G3DSA:2.40.70.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136286, NULL, 'G3DSA:3.30.70.330:FF:001547', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136287, NULL, 'G3DSA:1.20.272.10:FF:000016', NULL, NULL, 'Replication factor C subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(136288, NULL, 'G3DSA:2.130.10.10:FF:006023', NULL, NULL, 'Probable elongator complex protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(136289, NULL, 'G3DSA:3.40.47.10:FF:000101', NULL, NULL, 'Beta-ketoacyl synthase', NULL, NULL, NULL, NULL, NULL, 4),
(136290, NULL, 'G3DSA:3.30.70.3000:FF:000006', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(136291, NULL, 'G3DSA:3.30.70.330:FF:001986', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136292, NULL, 'G3DSA:1.25.40.10:FF:000418', NULL, NULL, 'Tetratricopeptide repeat protein 30A', NULL, NULL, NULL, NULL, NULL, 4),
(136293, NULL, 'G3DSA:1.25.40.180:FF:000144', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136294, NULL, 'G3DSA:1.20.920.10:FF:000203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136295, NULL, 'G3DSA:3.30.160.60:FF:004842', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(136296, NULL, 'G3DSA:3.30.70.330:FF:002975', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136297, NULL, 'G3DSA:3.100.10.10:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136298, NULL, 'G3DSA:3.30.1600.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136299, NULL, 'G3DSA:3.90.79.20:FF:000007', NULL, NULL, 'NADH pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(136300, NULL, 'G3DSA:3.40.50.300:FF:003623', NULL, NULL, 'Helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136301, NULL, 'G3DSA:3.30.300.130:FF:000006', NULL, NULL, 'NifU-like protein 3, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(136302, NULL, 'G3DSA:1.10.3500.10:FF:000004', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(136303, NULL, 'G3DSA:1.50.40.10:FF:000326', NULL, NULL, 'Mitochondrial folate transporter/carrier', NULL, NULL, NULL, NULL, NULL, 4),
(136304, NULL, 'G3DSA:3.40.140.10:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136305, NULL, 'G3DSA:1.10.10.10:FF:000270', NULL, NULL, 'Non-structural maintenance of chromosomes element 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(136306, NULL, 'G3DSA:2.60.40.10:FF:001015', NULL, NULL, 'tyrosine-protein phosphatase Lar isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(136307, NULL, 'G3DSA:3.40.50.720:FF:000579', NULL, NULL, 'NADP oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(136308, NULL, 'G3DSA:2.130.10.10:FF:003909', NULL, NULL, 'Putative suppressive immunomodulating factor', NULL, NULL, NULL, NULL, NULL, 4),
(136309, NULL, 'G3DSA:1.20.120.1960:FF:000002', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(136310, NULL, 'G3DSA:3.30.160.60:FF:000508', NULL, NULL, 'Myeloid zinc finger 1', NULL, NULL, NULL, NULL, NULL, 4),
(136311, NULL, 'G3DSA:2.30.29.30:FF:000506', NULL, NULL, 'OPY1p protein', NULL, NULL, NULL, NULL, NULL, 4),
(136312, NULL, 'G3DSA:3.40.50.300:FF:004612', NULL, NULL, 'V-type proton ATPase catalytic subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(136313, NULL, 'G3DSA:3.30.160.60:FF:006287', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136314, NULL, 'G3DSA:1.20.58.2220:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136315, NULL, 'G3DSA:1.10.100.10:FF:000008', NULL, NULL, 'probable insulin-like peptide 7', NULL, NULL, NULL, NULL, NULL, 4),
(136316, NULL, 'G3DSA:2.60.40.10:FF:001487', NULL, NULL, 'Signaling lymphocytic activation molecule', NULL, NULL, NULL, NULL, NULL, 4),
(136317, NULL, 'G3DSA:1.10.238.10:FF:001210', NULL, NULL, 'Putative centrin', NULL, NULL, NULL, NULL, NULL, 4),
(136318, NULL, 'G3DSA:3.40.30.10:FF:000737', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136319, NULL, 'G3DSA:3.40.50.720:FF:000107', NULL, NULL, 'inositol-3-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(136320, NULL, 'G3DSA:3.30.160.60:FF:003853', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136321, NULL, 'G3DSA:3.20.70.20:FF:000030', NULL, NULL, 'Formate acetyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(136322, NULL, 'G3DSA:1.10.560.10:FF:000065', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(136323, NULL, 'G3DSA:2.30.29.240:FF:000002', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(136324, NULL, 'G3DSA:3.40.50.1010:FF:000047', NULL, NULL, 'Blast:Telomerase-binding protein EST1A', NULL, NULL, NULL, NULL, NULL, 4),
(136325, NULL, 'G3DSA:3.30.200.20:FF:001299', NULL, NULL, 'Myosin heavy chain kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(136326, NULL, 'G3DSA:1.10.510.10:FF:003108', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136327, NULL, 'G3DSA:2.60.40.4100:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136328, NULL, 'G3DSA:3.30.200.20:FF:000810', NULL, NULL, 'L-type lectin-domain containing receptor kinase S.6', NULL, NULL, NULL, NULL, NULL, 4),
(136329, NULL, 'G3DSA:4.10.400.10:FF:000233', NULL, NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein-like Protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(136330, NULL, 'G3DSA:3.30.70.3030:FF:000021', NULL, NULL, 'Nucleolar protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(136331, NULL, 'G3DSA:4.10.1240.30:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136332, NULL, 'G3DSA:1.25.40.10:FF:001879', NULL, NULL, 'Tetratricopeptide repeat protein 36 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(136333, NULL, 'G3DSA:1.10.472.80:FF:000049', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(136334, NULL, 'G3DSA:3.40.50.300:FF:004079', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(136335, NULL, 'G3DSA:3.30.160.60:FF:002072', NULL, NULL, 'Zinc finger protein 134', NULL, NULL, NULL, NULL, NULL, 4),
(136336, NULL, 'G3DSA:3.40.50.620:FF:000375', NULL, NULL, 'Putative tyrosyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(136337, NULL, 'G3DSA:1.50.10.20:FF:000035', NULL, NULL, 'Protein farnesyltransferase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(136338, NULL, 'G3DSA:3.90.1170.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136339, NULL, 'G3DSA:1.10.1740.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136340, NULL, 'G3DSA:1.10.510.10:FF:002271', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136341, NULL, 'G3DSA:1.10.8.60:FF:000132', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(136342, NULL, 'G3DSA:3.10.350.10:FF:000007', NULL, NULL, 'Probable L,D-transpeptidase YcfS', NULL, NULL, NULL, NULL, NULL, 4),
(136343, NULL, 'G3DSA:2.60.120.10:FF:000511', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136344, NULL, 'G3DSA:3.10.20.410:FF:000009', NULL, NULL, 'Probable fimbrial usher protein', NULL, NULL, NULL, NULL, NULL, 4),
(136345, NULL, 'G3DSA:1.25.40.20:FF:000308', NULL, NULL, 'Oxysterol-binding family protein', NULL, NULL, NULL, NULL, NULL, 4),
(136346, NULL, 'G3DSA:3.40.50.10190:FF:000181', NULL, NULL, 'LIGase', NULL, NULL, NULL, NULL, NULL, 4),
(136347, NULL, 'G3DSA:1.10.510.10:FF:000354', NULL, NULL, 'Serine/threonine-protein kinase Chk2', NULL, NULL, NULL, NULL, NULL, 4),
(136348, NULL, 'G3DSA:1.20.1230.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136349, NULL, 'G3DSA:3.90.190.10:FF:000443', NULL, NULL, 'Protein CBG22503', NULL, NULL, NULL, NULL, NULL, 4),
(136350, NULL, 'G3DSA:2.60.34.10:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136351, NULL, 'G3DSA:2.20.100.10:FF:000036', NULL, NULL, 'Connective tissue growth factor (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(136352, NULL, 'G3DSA:1.10.240.10:FF:000018', NULL, NULL, 'Tryptophan--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(136353, NULL, 'G3DSA:1.25.10.10:FF:001698', NULL, NULL, 'Sister chromatid cohesion protein', NULL, NULL, NULL, NULL, NULL, 4),
(136354, NULL, 'G3DSA:1.10.274.30:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136355, NULL, 'G3DSA:3.30.1360.10:FF:000003', NULL, NULL, 'DNA-directed RNA polymerase II subunit RPB11', NULL, NULL, NULL, NULL, NULL, 4),
(136356, NULL, 'G3DSA:2.60.40.10:FF:002004', NULL, NULL, 'Transmembrane and immunoglobulin domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(136357, NULL, 'G3DSA:2.40.50.120:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136358, NULL, 'G3DSA:3.30.40.10:FF:001632', NULL, NULL, 'Structure-specific endonuclease subunit SLX1', NULL, NULL, NULL, NULL, NULL, 4),
(136359, NULL, 'G3DSA:3.40.50.300:FF:001206', NULL, NULL, 'DNA repair helicase rad15', NULL, NULL, NULL, NULL, NULL, 4),
(136360, NULL, 'G3DSA:3.40.50.1820:FF:001745', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(136361, NULL, 'G3DSA:3.30.450.40:FF:000216', NULL, NULL, 'Pca regulon regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(136362, NULL, 'G3DSA:3.30.710.10:FF:000391', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136363, NULL, 'G3DSA:1.20.120.1750:FF:000057', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(136364, NULL, 'G3DSA:2.60.40.150:FF:000175', NULL, NULL, 'C2 calcium dependent domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(136365, NULL, 'G3DSA:3.40.630.30:FF:000079', NULL, NULL, 'glycine N-acyltransferase-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(136366, NULL, 'G3DSA:1.25.40.10:FF:002835', NULL, NULL, 'Anaphase-promoting complex subunit 3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(136367, NULL, 'G3DSA:3.40.50.150:FF:000363', NULL, NULL, 'Methyltransferase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(136368, NULL, 'G3DSA:3.30.70.1730:FF:000035', NULL, NULL, '50S ribosomal protein L10', NULL, NULL, NULL, NULL, NULL, 4),
(136369, NULL, 'G3DSA:3.30.1490.20:FF:000077', NULL, NULL, 'Synapsin2', NULL, NULL, NULL, NULL, NULL, 4),
(136370, NULL, 'G3DSA:3.30.70.1320:FF:000002', NULL, NULL, 'Multidrug resistance protein MdtB', NULL, NULL, NULL, NULL, NULL, 4),
(136371, NULL, 'G3DSA:2.10.25.10:FF:000425', NULL, NULL, 'Eyes shut homolog', NULL, NULL, NULL, NULL, NULL, 4),
(136372, NULL, 'G3DSA:3.30.1330.30:FF:000041', NULL, NULL, '60S ribosomal protein L7-3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136373, NULL, 'G3DSA:3.80.10.10:FF:000442', NULL, NULL, 'tropomodulin-2 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(136374, NULL, 'G3DSA:1.10.150.240:FF:000033', NULL, NULL, 'Haloacid dehalogenase/epoxide hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(136375, NULL, 'G3DSA:1.20.58.340:FF:000044', NULL, NULL, 'Magnesium and cobalt transport protein CorA, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136376, NULL, 'G3DSA:2.40.110.10:FF:000083', NULL, NULL, 'Blr0120 protein', NULL, NULL, NULL, NULL, NULL, 4),
(136377, NULL, 'G3DSA:3.40.50.1860:FF:000009', NULL, NULL, 'Glutamate racemase', NULL, NULL, NULL, NULL, NULL, 4),
(136378, NULL, 'G3DSA:1.10.840.10:FF:000047', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(136379, NULL, 'G3DSA:3.90.1750.20:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136380, NULL, 'G3DSA:2.130.10.10:FF:003117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136381, NULL, 'G3DSA:2.40.50.140:FF:000600', NULL, NULL, 'Os05g0110950 protein', NULL, NULL, NULL, NULL, NULL, 4),
(136382, NULL, 'G3DSA:2.30.29.30:FF:000153', NULL, NULL, 'amyloid beta A4 precursor protein-binding family B member 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(136383, NULL, 'G3DSA:3.40.640.10:FF:000158', NULL, NULL, 'Glycine dehydrogenase (decarboxylating)', NULL, NULL, NULL, NULL, NULL, 4),
(136384, NULL, 'G3DSA:3.40.50.300:FF:006057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136385, NULL, 'G3DSA:1.20.1480.20:FF:000002', NULL, NULL, 'Microtubule-associated serine/threonine-protein kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(136386, NULL, 'G3DSA:3.30.160.60:FF:002864', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136387, NULL, 'G3DSA:3.30.750.44:FF:000002', NULL, NULL, 'carboxyl-terminal-processing peptidase 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(136388, NULL, 'G3DSA:1.10.533.10:FF:000070', NULL, NULL, 'Caspase 10', NULL, NULL, NULL, NULL, NULL, 4),
(136389, NULL, 'G3DSA:2.60.40.420:FF:000099', NULL, NULL, 'Cytochrome c oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(136390, NULL, 'G3DSA:1.10.630.10:FF:000301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136391, NULL, 'G3DSA:2.130.10.10:FF:003589', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136392, NULL, 'G3DSA:1.10.1420.10:FF:000003', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(136393, NULL, 'G3DSA:2.60.40.10:FF:004393', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136394, NULL, 'G3DSA:3.30.200.20:FF:000490', NULL, NULL, 'AGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(136395, NULL, 'G3DSA:3.10.20.70:FF:000042', NULL, NULL, 'ATP:guanido phosphotransferase, Nterminal domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(136396, NULL, 'G3DSA:1.20.1250.20:FF:000226', NULL, NULL, 'Vesicular GLUtamate transporter', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(136397, NULL, 'G3DSA:4.10.280.20:FF:000001', NULL, NULL, 'stannin', NULL, NULL, NULL, NULL, NULL, 4),
(136398, NULL, 'G3DSA:2.130.10.10:FF:002280', NULL, NULL, 'Thoc6, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(136399, NULL, 'G3DSA:3.40.50.10140:FF:000008', NULL, NULL, 'Toll-like receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(136400, NULL, 'G3DSA:3.40.50.1100:FF:000102', NULL, NULL, 'Si:ch73-263o4.4', NULL, NULL, NULL, NULL, NULL, 4),
(136401, NULL, 'G3DSA:1.20.1560.10:FF:000146', NULL, NULL, 'p-GlycoProtein related', NULL, NULL, NULL, NULL, NULL, 4),
(136402, NULL, 'G3DSA:1.25.40.10:FF:003324', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(136403, NULL, 'G3DSA:1.20.1270.420:FF:000012', NULL, NULL, 'Inhibitor of nuclear factor kappa B kinase subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(136404, NULL, 'G3DSA:3.30.780.10:FF:000013', NULL, NULL, 'Translation machinery-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(136405, NULL, 'G3DSA:3.30.559.10:FF:000257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136406, NULL, 'G3DSA:2.130.10.10:FF:001291', NULL, NULL, 'Periodic tryptophan protein 2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(136407, NULL, 'G3DSA:3.40.50.1000:FF:000370', NULL, NULL, 'Haloacid dehalogenase-like hydrolase/HAD-hyrolase-like, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136408, NULL, 'G3DSA:3.40.50.300:FF:000717', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(136409, NULL, 'G3DSA:3.30.450.20:FF:000210', NULL, NULL, 'Sensory box/GGDEF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(136410, NULL, 'G3DSA:3.30.70.330:FF:000558', NULL, NULL, 'Serine/arginine-rich SC35-like splicing factor SCL30', NULL, NULL, NULL, NULL, NULL, 4),
(136411, NULL, 'G3DSA:3.10.100.10:FF:000287', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136412, NULL, 'G3DSA:3.80.10.10:FF:001370', NULL, NULL, 'Kinase family with leucine-rich repeat domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(136413, NULL, 'G3DSA:3.40.630.10:FF:000073', NULL, NULL, 'Zinc metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(136414, NULL, 'G3DSA:3.10.20.90:FF:000048', NULL, NULL, 'Ras association domain family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(136415, NULL, 'G3DSA:2.40.10.10:FF:000160', NULL, NULL, 'Protease Do-like 7', NULL, NULL, NULL, NULL, NULL, 4),
(136416, NULL, 'G3DSA:2.30.40.10:FF:000010', NULL, NULL, 'Imidazolonepropionase', NULL, NULL, NULL, NULL, NULL, 4),
(136417, NULL, 'G3DSA:1.20.1740.10:FF:000244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136418, NULL, 'G3DSA:3.60.21.10:FF:000480', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(136419, NULL, 'G3DSA:2.30.42.10:FF:000172', NULL, NULL, 'Caspase recruitment domain family member 14', NULL, NULL, NULL, NULL, NULL, 4),
(136420, NULL, 'G3DSA:3.90.190.10:FF:000090', NULL, NULL, 'Dual specificity phosphatase catalytic domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(136421, NULL, 'G3DSA:1.10.10.60:FF:001280', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136422, NULL, 'G3DSA:3.30.420.10:FF:000172', NULL, NULL, 'DNA polymerase I-like protein B', NULL, NULL, NULL, NULL, NULL, 4),
(136423, NULL, 'G3DSA:1.10.420.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136424, NULL, 'G3DSA:2.60.120.290:FF:000029', NULL, NULL, 'seizure 6-like protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(136425, NULL, 'G3DSA:3.30.300.10:FF:000045', NULL, NULL, 'GMP synthase [glutamine-hydrolyzing] subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(136426, NULL, 'G3DSA:3.30.70.1620:FF:000002', NULL, NULL, 'Structural maintenance of chromosomes 3', NULL, NULL, NULL, NULL, NULL, 4),
(136427, NULL, 'G3DSA:1.10.472.10:FF:000309', NULL, NULL, 'Transcription factor IIIB 90 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(136428, NULL, 'G3DSA:3.30.1360.120:FF:000031', NULL, NULL, 'Protein CBG22093', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(136429, NULL, 'G3DSA:3.40.225.10:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136430, NULL, 'G3DSA:2.60.40.60:FF:000613', NULL, NULL, 'Cadherin 26, tandem duplicate 1', NULL, NULL, NULL, NULL, NULL, 4),
(136431, NULL, 'G3DSA:3.10.450.580:FF:000015', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(136432, NULL, 'G3DSA:3.10.290.10:FF:000036', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(136433, NULL, 'G3DSA:1.10.1060.10:FF:000020', NULL, NULL, 'Pyridine nucleotide-disulfide oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(136434, NULL, 'G3DSA:3.70.10.10:FF:000083', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(136435, NULL, 'G3DSA:2.60.40.1170:FF:000102', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136436, NULL, 'G3DSA:1.20.1280.290:FF:000048', NULL, NULL, 'Seven transmembrane protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(136437, NULL, 'G3DSA:1.25.10.10:FF:003143', NULL, NULL, 'Protein aardvark', NULL, NULL, NULL, NULL, NULL, 4),
(136438, NULL, 'G3DSA:1.10.510.10:FF:003260', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136439, NULL, 'G3DSA:3.60.40.10:FF:000372', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136440, NULL, 'G3DSA:3.40.50.360:FF:000128', NULL, NULL, 'NAD(P)H:quinone oxidoreductase, type IV', NULL, NULL, NULL, NULL, NULL, 4),
(136441, NULL, 'G3DSA:3.30.70.330:FF:002503', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136442, NULL, 'G3DSA:2.160.20.10:FF:000177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136443, NULL, 'G3DSA:3.30.70.330:FF:002183', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136444, NULL, 'G3DSA:3.40.50.300:FF:007838', NULL, NULL, 'Os11g0649100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(136445, NULL, 'G3DSA:3.40.50.1240:FF:000150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136446, NULL, 'G3DSA:3.50.50.60:FF:000360', NULL, NULL, 'FAD-dependent oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(136447, NULL, 'G3DSA:2.130.10.10:FF:002128', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(136448, NULL, 'G3DSA:3.40.50.1820:FF:000756', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136449, NULL, 'G3DSA:3.40.50.10790:FF:000001', NULL, NULL, 'Adenosyl-chloride synthase', NULL, NULL, NULL, NULL, NULL, 4),
(136450, NULL, 'G3DSA:3.40.710.10:FF:000074', NULL, NULL, 'Probable esterase/lipase lipP', NULL, NULL, NULL, NULL, NULL, 4),
(136451, NULL, 'G3DSA:3.40.50.200:FF:000013', NULL, NULL, 'Tripeptidyl-peptidase 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(136452, NULL, 'G3DSA:3.40.50.2000:FF:000361', NULL, NULL, 'Glycosyl transferase, group 1 family', NULL, NULL, NULL, NULL, NULL, 4),
(136453, NULL, 'G3DSA:3.40.190.290:FF:000036', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(136454, NULL, 'G3DSA:2.30.29.30:FF:000978', NULL, NULL, 'Dynamin-2A', NULL, NULL, NULL, NULL, NULL, 4),
(136455, NULL, 'G3DSA:1.20.1730.10:FF:000007', NULL, NULL, 'Sodium-coupled monocarboxylate transporter 2', NULL, NULL, NULL, NULL, NULL, 4),
(136456, NULL, 'G3DSA:3.60.10.10:FF:000252', NULL, NULL, 'Putative transmembrane endonuclease/exonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(136457, NULL, 'G3DSA:3.40.605.10:FF:000060', NULL, NULL, 'Geranial dehydrogenase GeoB', NULL, NULL, NULL, NULL, NULL, 4),
(136458, NULL, 'G3DSA:1.25.10.10:FF:001198', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(136459, NULL, 'G3DSA:3.80.10.10:FF:001431', NULL, NULL, 'Toll-like receptor 22', NULL, NULL, NULL, NULL, NULL, 4),
(136460, NULL, 'G3DSA:3.40.50.300:FF:005068', NULL, NULL, 'RAB38, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(136461, NULL, 'G3DSA:3.40.50.1820:FF:001245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136462, NULL, 'G3DSA:1.20.58.60:FF:000006', NULL, NULL, 'Spectrin alpha chain, non-erythrocytic 1', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(136463, NULL, 'G3DSA:1.25.40.20:FF:001236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136464, NULL, 'G3DSA:3.40.50.1240:FF:000211', NULL, NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(136465, NULL, 'G3DSA:2.40.10.120:FF:000013', NULL, NULL, 'Pro-apoptotic serine protease NMA111', NULL, NULL, NULL, NULL, NULL, 4),
(136466, NULL, 'G3DSA:1.20.1090.10:FF:000042', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(136467, NULL, 'G3DSA:1.20.1270.60:FF:000161', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(136468, NULL, 'G3DSA:1.25.40.20:FF:000747', NULL, NULL, 'Notch receptor protein', NULL, NULL, NULL, NULL, NULL, 4),
(136469, NULL, 'G3DSA:3.40.50.80:FF:000068', NULL, NULL, 'Iron ABC transporter ATP-binding protein/permease IrtA', NULL, NULL, NULL, NULL, NULL, 4),
(136470, NULL, 'G3DSA:2.40.37.10:FF:000081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136471, NULL, 'G3DSA:3.40.50.10490:FF:000001', NULL, NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', NULL, NULL, NULL, NULL, NULL, 4),
(136472, NULL, 'G3DSA:3.80.10.10:FF:003668', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136473, NULL, 'G3DSA:1.10.472.10:FF:000461', NULL, NULL, 'Origin recognition complex subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(136474, NULL, 'G3DSA:3.40.630.30:FF:000551', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136475, NULL, 'G3DSA:3.10.20.90:FF:000520', NULL, NULL, 'Polycomb complex protein BMI-1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(136476, NULL, 'G3DSA:2.10.25.10:FF:000925', NULL, NULL, 'Delta like non-canonical Notch ligand 1', NULL, NULL, NULL, NULL, NULL, 4),
(136477, NULL, 'G3DSA:2.170.190.11:FF:000024', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(136478, NULL, 'G3DSA:2.10.25.10:FF:001414', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136479, NULL, 'G3DSA:1.20.1560.10:FF:000207', NULL, NULL, 'ABC transporter B family member 15-like', NULL, NULL, NULL, NULL, NULL, 4),
(136480, NULL, 'G3DSA:1.10.10.10:FF:002035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136481, NULL, 'G3DSA:6.10.140.2150:FF:000004', NULL, NULL, 'Sphinganine-1-phosphate aldolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136482, NULL, 'G3DSA:3.40.50.300:FF:007013', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(136483, NULL, 'G3DSA:3.50.80.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136484, NULL, 'G3DSA:2.60.40.10:FF:004713', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136485, NULL, 'G3DSA:2.130.10.10:FF:005534', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136486, NULL, 'G3DSA:2.40.10.10:FF:000660', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136487, NULL, 'G3DSA:1.10.510.10:FF:002771', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136488, NULL, 'G3DSA:2.60.40.10:FF:004893', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136489, NULL, 'G3DSA:3.30.160.60:FF:000155', NULL, NULL, 'zinc finger protein 133 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(136490, NULL, 'G3DSA:3.40.50.720:FF:002024', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(136491, NULL, 'G3DSA:3.30.2350.10:FF:000031', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(136492, NULL, 'G3DSA:1.20.210.10:FF:000025', NULL, NULL, 'Cytochrome c oxidase subunit CcoN', NULL, NULL, NULL, NULL, NULL, 4),
(136493, NULL, 'G3DSA:3.10.100.10:FF:000315', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136494, NULL, 'G3DSA:1.25.40.20:FF:000247', NULL, NULL, 'E3 ubiquitin-protein ligase mind-bomb', NULL, NULL, NULL, NULL, NULL, 4),
(136495, NULL, 'G3DSA:1.25.10.10:FF:000450', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(136496, NULL, 'G3DSA:3.40.50.300:FF:007485', NULL, NULL, 'Probable ATP-dependent helicase MJ0942', NULL, NULL, NULL, NULL, NULL, 4),
(136497, NULL, 'G3DSA:3.40.350.10:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136498, NULL, 'G3DSA:1.25.40.10:FF:005269', NULL, NULL, 'UTX (Ubiquitously transcribed TPR on X) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(136499, NULL, 'G3DSA:3.30.200.20:FF:000338', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(136500, NULL, 'G3DSA:1.10.220.60:FF:000009', NULL, NULL, 'AGAP003540-PA', NULL, NULL, NULL, NULL, NULL, 4),
(136501, NULL, 'G3DSA:1.10.10.430:FF:000004', NULL, NULL, 'Alphabet, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(136502, NULL, 'G3DSA:3.30.310.80:FF:000050', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(136503, NULL, 'G3DSA:2.130.10.10:FF:002780', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit TRM82', NULL, NULL, NULL, NULL, NULL, 4),
(136504, NULL, 'G3DSA:3.80.10.10:FF:003168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136505, NULL, 'G3DSA:2.120.10.80:FF:000272', NULL, NULL, 'Kelch like family member 17', NULL, NULL, NULL, NULL, NULL, 4),
(136506, NULL, 'G3DSA:2.40.50.140:FF:000100', NULL, NULL, 'Cell wall biogenesis protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(136507, NULL, 'G3DSA:3.40.50.1980:FF:000079', NULL, NULL, 'Iron(III) dicitrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(136508, NULL, 'G3DSA:3.40.50.300:FF:001706', NULL, NULL, 'tRNA dimethylallyltransferase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(136509, NULL, 'G3DSA:3.50.50.60:FF:001169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136510, NULL, 'G3DSA:3.40.850.10:FF:000084', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(136511, NULL, 'G3DSA:3.30.200.20:FF:001619', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 14', NULL, NULL, NULL, NULL, NULL, 4),
(136512, NULL, 'G3DSA:3.30.1490.20:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136513, NULL, 'G3DSA:1.10.418.10:FF:000139', NULL, NULL, 'Leucine-rich Repeats (LRR) and Calponin Homology (CH) domain homolog', NULL, NULL, NULL, NULL, NULL, 4),
(136514, NULL, 'G3DSA:3.50.50.60:FF:000421', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(136515, NULL, 'G3DSA:3.30.40.10:FF:002149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136516, NULL, 'G3DSA:3.10.50.40:FF:000147', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(136517, NULL, 'G3DSA:3.30.160.60:FF:005770', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136518, NULL, 'G3DSA:1.10.10.10:FF:000770', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(136519, NULL, 'G3DSA:3.40.50.720:FF:002496', NULL, NULL, 'Potassium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(136520, NULL, 'G3DSA:2.130.10.10:FF:001611', NULL, NULL, 'WD repeat protein (AFU_orthologue AFUA_3G06910)', NULL, NULL, NULL, NULL, NULL, 4),
(136521, NULL, 'G3DSA:3.30.70.860:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136522, NULL, 'G3DSA:3.40.1030.10:FF:000004', NULL, NULL, 'Glycosyl transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(136523, NULL, 'G3DSA:3.30.70.3290:FF:000020', NULL, NULL, 'Probable polyketide synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(136524, NULL, 'G3DSA:3.30.160.60:FF:002925', NULL, NULL, 'Zinc finger protein YGR067C', NULL, NULL, NULL, NULL, NULL, 4),
(136525, NULL, 'G3DSA:2.60.120.10:FF:000039', NULL, NULL, 'cAMP-dependent protein kinase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(136526, NULL, 'G3DSA:2.130.10.10:FF:002600', NULL, NULL, 'Semaphorin-5A', NULL, NULL, NULL, NULL, NULL, 4),
(136527, NULL, 'G3DSA:1.20.58.90:FF:000021', NULL, NULL, 'Centrosomal protein 57, like 1', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(136528, NULL, 'G3DSA:3.10.250.10:FF:000062', NULL, NULL, 'RIKEN cDNA 5830411N06 gene', NULL, NULL, NULL, NULL, NULL, 4),
(136529, NULL, 'G3DSA:1.25.10.10:FF:000742', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(136530, NULL, 'G3DSA:1.10.3720.10:FF:000015', NULL, NULL, 'Sulfate ABC transporter, permease CysW', NULL, NULL, NULL, NULL, NULL, 4),
(136531, NULL, 'G3DSA:3.30.1370.10:FF:000240', NULL, NULL, 'Heterogeneous nuclear RibonucleoProtein (HnRNP) K homolog', NULL, NULL, NULL, NULL, NULL, 4),
(136532, NULL, 'G3DSA:3.40.1110.10:FF:000005', NULL, NULL, 'Plasma membrane ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(136533, NULL, 'G3DSA:3.30.560.10:FF:000002', NULL, NULL, 'Versicolorin B synthase', NULL, NULL, NULL, NULL, NULL, 4),
(136534, NULL, 'G3DSA:2.80.10.70:FF:000007', NULL, NULL, 'Predicted gene 28079', NULL, NULL, NULL, NULL, NULL, 4),
(136535, NULL, 'G3DSA:2.60.120.200:FF:000222', NULL, NULL, 'Laminin-like protein epi-1', NULL, NULL, NULL, NULL, NULL, 4),
(136536, NULL, 'G3DSA:1.20.58.60:FF:000506', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136537, NULL, 'G3DSA:1.25.40.10:FF:003824', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136538, NULL, 'G3DSA:2.60.40.1120:FF:000048', NULL, NULL, 'Transporter, outer membrane receptor (OMR) family', NULL, NULL, NULL, NULL, NULL, 4),
(136539, NULL, 'G3DSA:3.90.226.10:FF:000100', NULL, NULL, 'Peptidase S49', NULL, NULL, NULL, NULL, NULL, 4),
(136540, NULL, 'G3DSA:3.30.428.10:FF:000021', NULL, NULL, 'CWF19-like protein 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(136541, NULL, 'G3DSA:1.25.10.10:FF:002507', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136542, NULL, 'G3DSA:1.20.1250.20:FF:001715', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136543, NULL, 'G3DSA:3.80.10.10:FF:001870', NULL, NULL, 'Tubulin folding cofactor E', NULL, NULL, NULL, NULL, NULL, 4),
(136544, NULL, 'G3DSA:3.40.50.150:FF:001611', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136545, NULL, 'G3DSA:2.120.10.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136546, NULL, 'G3DSA:1.10.287.1490:FF:000003', NULL, NULL, 'Epidermal growth factor receptor pathway substrate 15', NULL, NULL, NULL, NULL, NULL, 4),
(136547, NULL, 'G3DSA:2.60.40.10:FF:005410', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136548, NULL, 'G3DSA:2.60.40.1120:FF:000020', NULL, NULL, 'Silver, isoform N', NULL, NULL, NULL, NULL, NULL, 4),
(136549, NULL, 'G3DSA:3.40.50.300:FF:000689', NULL, NULL, 'ATP binding cassette subfamily A member 12', NULL, NULL, NULL, NULL, NULL, 4),
(136550, NULL, 'G3DSA:2.40.110.20:FF:000001', NULL, NULL, 'Acyl-CoA dehydrogenase AidB', NULL, NULL, NULL, NULL, NULL, 4),
(136551, NULL, 'G3DSA:2.30.30.760:FF:000003', NULL, NULL, 'Flagella basal body P-ring formation protein FlgA', NULL, NULL, NULL, NULL, NULL, 4),
(136552, NULL, 'G3DSA:3.90.226.10:FF:000128', NULL, NULL, 'Putative enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(136553, NULL, 'G3DSA:3.20.20.80:FF:000230', NULL, NULL, 'Galactosidase beta 1', NULL, NULL, NULL, NULL, NULL, 4),
(136554, NULL, 'G3DSA:2.80.10.50:FF:000001', NULL, NULL, 'Fibroblast growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(136555, NULL, 'G3DSA:1.10.510.10:FF:003760', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136556, NULL, 'G3DSA:3.40.50.1820:FF:001392', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136557, NULL, 'G3DSA:3.80.20.20:FF:000064', NULL, NULL, 'Cell surface GPI-anchored protein ECM33', NULL, NULL, NULL, NULL, NULL, 4),
(136558, NULL, 'G3DSA:1.10.3450.20:FF:000008', NULL, NULL, 'Nuclear pore complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(136559, NULL, 'G3DSA:1.10.510.10:FF:002332', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136560, NULL, 'G3DSA:2.60.120.200:FF:000694', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136561, NULL, 'G3DSA:2.60.120.590:FF:000029', NULL, NULL, 'Methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(136562, NULL, 'G3DSA:1.10.260.40:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136563, NULL, 'G3DSA:2.40.50.140:FF:000280', NULL, NULL, 'rRNA biogenesis protein RRP5', NULL, NULL, NULL, NULL, NULL, 4),
(136564, NULL, 'G3DSA:2.120.10.30:FF:000038', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(136565, NULL, 'G3DSA:2.40.160.20:FF:000004', NULL, NULL, 'Outer membrane protein H1', NULL, NULL, NULL, NULL, NULL, 4),
(136566, NULL, 'G3DSA:1.10.760.10:FF:000046', NULL, NULL, 'Cytochrome c peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(136567, NULL, 'G3DSA:2.60.40.10:FF:000970', NULL, NULL, 'Plexin B3', NULL, NULL, NULL, NULL, NULL, 4),
(136568, NULL, 'G3DSA:3.40.50.460:FF:000012', NULL, NULL, 'Diphosphate-fructose-6-phosphate 1-phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(136569, NULL, 'G3DSA:1.10.10.390:FF:000003', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(136570, NULL, 'G3DSA:1.25.40.90:FF:000015', NULL, NULL, 'Pre-mRNA cleavage complex 2 protein Pcf11', NULL, NULL, NULL, NULL, NULL, 4),
(136571, NULL, 'G3DSA:3.40.50.300:FF:003270', NULL, NULL, 'GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136572, NULL, 'G3DSA:3.30.70.330:FF:001194', NULL, NULL, 'Enhancer binding protein-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136573, NULL, 'G3DSA:3.90.650.10:FF:000018', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(136574, NULL, 'G3DSA:1.25.40.10:FF:001054', NULL, NULL, 'BnaA07g00700D protein', NULL, NULL, NULL, NULL, NULL, 4),
(136575, NULL, 'G3DSA:1.50.10.10:FF:000206', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(136576, NULL, 'G3DSA:1.10.560.10:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136577, NULL, 'G3DSA:2.20.70.10:FF:000119', NULL, NULL, 'WW_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(136578, NULL, 'G3DSA:2.40.240.20:FF:000005', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4),
(136579, NULL, 'G3DSA:3.30.1490.80:FF:000016', NULL, NULL, 'Glutathione synthetase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(136580, NULL, 'G3DSA:1.20.120.790:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136581, NULL, 'G3DSA:3.40.50.12230:FF:000017', NULL, NULL, 'Formyl transferase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(136582, NULL, 'G3DSA:1.20.930.10:FF:000001', NULL, NULL, 'IWS1, SUPT6H interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(136583, NULL, 'G3DSA:3.30.450.50:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136584, NULL, 'G3DSA:1.20.920.10:FF:000175', NULL, NULL, 'Bromodomain-containing 2b', NULL, NULL, NULL, NULL, NULL, 4),
(136585, NULL, 'G3DSA:1.25.40.10:FF:005241', NULL, NULL, 'Protein TONSOKU', NULL, NULL, NULL, NULL, NULL, 4),
(136586, NULL, 'G3DSA:1.10.10.60:FF:000291', NULL, NULL, 'ALX homeobox protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(136587, NULL, 'G3DSA:3.30.420.10:FF:000464', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136588, NULL, 'G3DSA:1.10.10.10:FF:001107', NULL, NULL, 'Multidrug resistance operon repressor MexR', NULL, NULL, NULL, NULL, NULL, 4),
(136589, NULL, 'G3DSA:1.20.58.2050:FF:000010', NULL, NULL, 'Probable DNA replication complex GINS protein PSF3', NULL, NULL, NULL, NULL, NULL, 4),
(136590, NULL, 'G3DSA:1.20.1310.10:FF:000015', NULL, NULL, 'Cullin 5', NULL, NULL, NULL, NULL, NULL, 4),
(136591, NULL, 'G3DSA:1.20.140.10:FF:000109', NULL, NULL, 'Short/branched chain specific acyl-CoA dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(136592, NULL, 'G3DSA:3.10.150.10:FF:000026', NULL, NULL, 'Beta sliding clamp', NULL, NULL, NULL, NULL, NULL, 4),
(136593, NULL, 'G3DSA:2.60.40.60:FF:000260', NULL, NULL, 'Cadherin related family member 4', NULL, NULL, NULL, NULL, NULL, 4),
(136594, NULL, 'G3DSA:3.90.1640.10:FF:000011', NULL, NULL, 'Exopolyphosphatase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(136595, NULL, 'G3DSA:3.30.450.20:FF:000502', NULL, NULL, 'GAF domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(136596, NULL, 'G3DSA:3.30.160.60:FF:005798', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136597, NULL, 'G3DSA:3.40.630.10:FF:000365', NULL, NULL, 'Glutamate carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136598, NULL, 'G3DSA:1.10.238.10:FF:000693', NULL, NULL, 'EF-hand domain-containing family member B', NULL, NULL, NULL, NULL, NULL, 4),
(136599, NULL, 'G3DSA:1.10.8.590:FF:000003', NULL, NULL, 'tRNA (cytidine/uridine-2''-O-)-methyltransferase TrmJ', NULL, NULL, NULL, NULL, NULL, 4),
(136600, NULL, 'G3DSA:1.25.40.10:FF:004313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136601, NULL, 'G3DSA:3.40.30.10:FF:001226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136602, NULL, 'G3DSA:1.20.58.1480:FF:000030', NULL, NULL, 'Lon protease homolog', NULL, NULL, NULL, NULL, NULL, 4),
(136603, NULL, 'G3DSA:1.25.10.10:FF:001226', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(136604, NULL, 'G3DSA:2.30.30.40:FF:000108', NULL, NULL, 'Vav guanine nucleotide exchange factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(136605, NULL, 'G3DSA:3.40.50.1000:FF:000662', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136606, NULL, 'G3DSA:3.30.200.20:FF:000310', NULL, NULL, 'serine/threonine-protein kinase Nek2', NULL, NULL, NULL, NULL, NULL, 4),
(136607, NULL, 'G3DSA:1.10.472.130:FF:000096', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(136608, NULL, 'G3DSA:3.40.50.300:FF:003123', NULL, NULL, 'ATP-dependent DNA helicase homolog RECG, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(136609, NULL, 'G3DSA:3.30.60.20:FF:000124', NULL, NULL, 'Serine/threonine-protein kinase pakD', NULL, NULL, NULL, NULL, NULL, 4),
(136610, NULL, 'G3DSA:3.30.420.40:FF:000540', NULL, NULL, 'Actin-like protein C08B11.6', NULL, NULL, NULL, NULL, NULL, 4),
(136611, NULL, 'G3DSA:1.20.1560.10:FF:000679', NULL, NULL, 'Serine protease/ABC transporter B family protein tagC', NULL, NULL, NULL, NULL, NULL, 4),
(136612, NULL, 'G3DSA:2.10.25.10:FF:000133', NULL, NULL, 'Fibrillin 3', NULL, NULL, NULL, NULL, NULL, 4),
(136613, NULL, 'G3DSA:1.10.1300.10:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136614, NULL, 'G3DSA:3.30.70.260:FF:000189', NULL, NULL, 'ACT domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(136615, NULL, 'G3DSA:1.25.40.10:FF:003032', NULL, NULL, 'Crooked neck protein, putative / cell cycle protein', NULL, NULL, NULL, NULL, NULL, 4),
(136616, NULL, 'G3DSA:3.40.190.10:FF:000729', NULL, NULL, 'Ionotropic receptor IR68a', NULL, NULL, NULL, NULL, NULL, 4),
(136617, NULL, 'G3DSA:2.40.50.140:FF:000128', NULL, NULL, '50S ribosomal protein L2', NULL, NULL, NULL, NULL, NULL, 4),
(136618, NULL, 'G3DSA:3.10.310.10:FF:000033', NULL, NULL, 'Diaminopimelate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(136619, NULL, 'G3DSA:3.30.40.10:FF:001340', NULL, NULL, 'PHD and RING finger domain-containing protein 1 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(136620, NULL, 'G3DSA:1.25.40.10:FF:004752', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136621, NULL, 'G3DSA:2.10.25.10:FF:001061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136622, NULL, 'G3DSA:3.30.750.140:FF:000003', NULL, NULL, 'Type III secretion system needle length determinant', NULL, NULL, NULL, NULL, NULL, 4),
(136623, NULL, 'G3DSA:2.60.120.650:FF:000160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136624, NULL, 'G3DSA:2.130.10.10:FF:003409', NULL, NULL, 'Beta-alanine-activating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(136625, NULL, 'G3DSA:2.60.120.620:FF:000084', NULL, NULL, 'RE09701p', NULL, NULL, NULL, NULL, NULL, 4),
(136626, NULL, 'G3DSA:1.20.5.420:FF:000029', NULL, NULL, 'Type III export protein PscE', NULL, NULL, NULL, NULL, NULL, 4),
(136627, NULL, 'G3DSA:3.90.1150.10:FF:000075', NULL, NULL, 'Cystathionine gamma-synthase/O-acetylhomoserine thiolyase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(136628, NULL, 'G3DSA:3.20.20.150:FF:000036', NULL, NULL, 'Xylose isomerase-type TIM barrel domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(136629, NULL, 'G3DSA:3.30.70.330:FF:002475', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136630, NULL, 'G3DSA:3.20.20.80:FF:000522', NULL, NULL, 'Endoglucanase H', NULL, NULL, NULL, NULL, NULL, 4),
(136631, NULL, 'G3DSA:3.10.110.10:FF:000113', NULL, NULL, 'Protein ELC', NULL, NULL, NULL, NULL, NULL, 4),
(136632, NULL, 'G3DSA:1.20.90.10:FF:000016', NULL, NULL, 'Phospholipase A(2)', NULL, NULL, NULL, NULL, NULL, 4),
(136633, NULL, 'G3DSA:3.30.160.60:FF:006107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136634, NULL, 'G3DSA:1.50.40.10:FF:000034', NULL, NULL, 'Mitochondrial 2-oxodicarboxylate carrier', NULL, NULL, NULL, NULL, NULL, 4),
(136635, NULL, 'G3DSA:1.10.3080.10:FF:000050', NULL, NULL, 'Os01g0704700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(136636, NULL, 'G3DSA:3.40.50.150:FF:001791', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136637, NULL, 'G3DSA:2.170.130.10:FF:000070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136638, NULL, 'G3DSA:3.60.40.10:FF:000080', NULL, NULL, 'Protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(136639, NULL, 'G3DSA:3.30.54.20:FF:000003', NULL, NULL, 'Threonine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(136640, NULL, 'G3DSA:1.25.40.570:FF:000019', NULL, NULL, 'Proteasome regulatory non-ATPase subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(136641, NULL, 'G3DSA:3.90.1030.10:FF:000009', NULL, NULL, '39S ribosomal protein L17, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(136642, NULL, 'G3DSA:1.10.287.110:FF:000307', NULL, NULL, 'Chaperone protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136643, NULL, 'G3DSA:1.10.287.10:FF:000002', NULL, NULL, '30S ribosomal protein S15', NULL, NULL, NULL, NULL, NULL, 4),
(136644, NULL, 'G3DSA:2.60.40.820:FF:000011', NULL, NULL, 'T-box transcription factor TBX21', NULL, NULL, NULL, NULL, NULL, 4),
(136645, NULL, 'G3DSA:3.40.50.300:FF:002634', NULL, NULL, 'Small GTP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(136646, NULL, 'G3DSA:3.30.70.270:FF:000107', NULL, NULL, 'GGDEF domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(136647, NULL, 'G3DSA:1.10.238.10:FF:000254', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(136648, NULL, 'G3DSA:1.20.5.420:FF:000001', NULL, NULL, 'Vacuolar protein sorting-associated protein VTA1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(136649, NULL, 'G3DSA:2.60.40.10:FF:003432', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136650, NULL, 'G3DSA:1.10.510.10:FF:001282', NULL, NULL, 'PEK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(136651, NULL, 'G3DSA:3.30.160.60:FF:000947', NULL, NULL, 'zinc finger protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(136652, NULL, 'G3DSA:3.40.220.10:FF:000019', NULL, NULL, 'Replicase polyprotein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(136653, NULL, 'G3DSA:2.40.40.20:FF:000018', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(136654, NULL, 'G3DSA:3.30.160.60:FF:001436', NULL, NULL, 'zinc finger protein 777', NULL, NULL, NULL, NULL, NULL, 4),
(136655, NULL, 'G3DSA:3.90.226.10:FF:000280', NULL, NULL, 'Im:7138837 protein', NULL, NULL, NULL, NULL, NULL, 4),
(136656, NULL, 'G3DSA:2.60.120.260:FF:000133', NULL, NULL, 'SUN domain protein5', NULL, NULL, NULL, NULL, NULL, 4),
(136657, NULL, 'G3DSA:1.25.10.10:FF:002687', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136658, NULL, 'G3DSA:1.25.40.490:FF:000001', NULL, NULL, 'Fanconi anemia, complementation group F', NULL, NULL, NULL, NULL, NULL, 4),
(136659, NULL, 'G3DSA:2.40.50.100:FF:000228', NULL, NULL, 'Sll0180 protein', NULL, NULL, NULL, NULL, NULL, 4),
(136660, NULL, 'G3DSA:3.30.70.330:FF:000266', NULL, NULL, 'Ras GTPase-activating protein-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(136661, NULL, 'G3DSA:3.80.10.10:FF:001723', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(136662, NULL, 'G3DSA:1.20.1250.20:FF:000698', NULL, NULL, 'Sorbitol transporter', NULL, NULL, NULL, NULL, NULL, 4),
(136663, NULL, 'G3DSA:2.30.30.40:FF:000260', NULL, NULL, 'neutrophil cytosol factor 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(136664, NULL, 'G3DSA:3.40.50.2300:FF:001642', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136665, NULL, 'G3DSA:2.130.10.10:FF:004045', NULL, NULL, 'Uncharacterized WD repeat-containing protein C63.06', NULL, NULL, NULL, NULL, NULL, 4),
(136666, NULL, 'G3DSA:2.30.30.140:FF:000025', NULL, NULL, 'Lethal(3)malignant brain tumor-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(136667, NULL, 'G3DSA:1.25.40.10:FF:000570', NULL, NULL, 'Hsp70/Hsp90 organizing protein', NULL, NULL, NULL, NULL, NULL, 4),
(136668, NULL, 'G3DSA:3.30.200.20:FF:001799', NULL, NULL, 'Kinase suppressor of Ras 2', NULL, NULL, NULL, NULL, NULL, 4),
(136669, NULL, 'G3DSA:3.40.50.300:FF:007305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136670, NULL, 'G3DSA:3.30.200.20:FF:001771', NULL, NULL, 'Rol-3', NULL, NULL, NULL, NULL, NULL, 4),
(136671, NULL, 'G3DSA:2.60.40.150:FF:000203', NULL, NULL, 'Calcium-dependent lipid-binding (CaLB domain) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(136672, NULL, 'G3DSA:2.40.10.10:FF:000513', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136673, NULL, 'G3DSA:1.10.150.20:FF:000109', NULL, NULL, 'tRNA-specific adenosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(136674, NULL, 'G3DSA:3.90.70.10:FF:000602', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(136675, NULL, 'G3DSA:1.20.58.930:FF:000007', NULL, NULL, 'Arginine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(136676, NULL, 'G3DSA:1.10.286.10:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136677, NULL, 'G3DSA:3.50.30.50:FF:000001', NULL, NULL, 'Kynurenine formamidase', NULL, NULL, NULL, NULL, NULL, 4),
(136678, NULL, 'G3DSA:1.20.1070.10:FF:000451', NULL, NULL, 'SERotonin/octopamine receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(136679, NULL, 'G3DSA:1.20.870.10:FF:000030', NULL, NULL, 'Ras guanine nucleotide exchange factor A', NULL, NULL, NULL, NULL, NULL, 4),
(136680, NULL, 'G3DSA:1.10.472.140:FF:000014', NULL, NULL, 'Retinoblastoma-like 2 (p130)', NULL, NULL, NULL, NULL, NULL, 4),
(136681, NULL, 'G3DSA:3.30.40.10:FF:000704', NULL, NULL, 'Zinc finger family protein', NULL, NULL, NULL, NULL, NULL, 4),
(136682, NULL, 'G3DSA:1.20.190.50:FF:000017', NULL, NULL, 'Nucleoporin nup107', NULL, NULL, NULL, NULL, NULL, 4),
(136683, NULL, 'G3DSA:3.40.50.300:FF:003915', NULL, NULL, '6-phosphofructo-2-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(136684, NULL, 'G3DSA:3.10.20.90:FF:000020', NULL, NULL, 'ubiquitin carboxyl-terminal hydrolase 15 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(136685, NULL, 'G3DSA:1.25.40.70:FF:000037', NULL, NULL, 'Phosphatidylinositol 3-kinase VPS34', NULL, NULL, NULL, NULL, NULL, 4),
(136686, NULL, 'G3DSA:3.40.630.10:FF:000101', NULL, NULL, 'N-acetylated alpha-linked acidic dipeptidase like 1', NULL, NULL, NULL, NULL, NULL, 4),
(136687, NULL, 'G3DSA:1.25.40.10:FF:000070', NULL, NULL, 'zinc finger CCCH domain-containing protein 7B', NULL, NULL, NULL, NULL, NULL, 4),
(136688, NULL, 'G3DSA:2.30.40.10:FF:000038', NULL, NULL, 'Formylmethanofuran dehydrogenase, subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(136689, NULL, 'G3DSA:1.20.5.110:FF:000060', NULL, NULL, 'SNARE complex subunit (Syn8)', NULL, NULL, NULL, NULL, NULL, 4),
(136690, NULL, 'G3DSA:4.10.60.10:FF:000210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136691, NULL, 'G3DSA:1.20.1070.10:FF:001732', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(136692, NULL, 'G3DSA:3.30.70.330:FF:001694', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136693, NULL, 'G3DSA:3.30.30.30:FF:000064', NULL, NULL, 'Heat shock protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136694, NULL, 'G3DSA:3.55.40.20:FF:000011', NULL, NULL, 'Superoxide dismutase [Fe]', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(136695, NULL, 'G3DSA:2.10.25.10:FF:001561', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136696, NULL, 'G3DSA:3.90.1860.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136697, NULL, 'G3DSA:3.30.420.10:FF:000672', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136698, NULL, 'G3DSA:3.30.200.20:FF:002108', NULL, NULL, 'Protein-serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(136699, NULL, 'G3DSA:3.40.630.30:FF:000051', NULL, NULL, 'N-alpha-acetyltransferase MAK3 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(136700, NULL, 'G3DSA:1.20.1560.10:FF:000707', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136701, NULL, 'G3DSA:1.20.1070.10:FF:002188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136702, NULL, 'G3DSA:1.25.10.10:FF:001670', NULL, NULL, 'Transport and golgi organization 6 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(136703, NULL, 'G3DSA:3.10.20.90:FF:000492', NULL, NULL, 'AFaDin (Actin filament binding protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(136704, NULL, 'G3DSA:3.40.50.300:FF:003331', NULL, NULL, 'Rap GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(136705, NULL, 'G3DSA:2.30.180.10:FF:000055', NULL, NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(136706, NULL, 'G3DSA:3.30.730.10:FF:000010', NULL, NULL, 'AP2-EREBP transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(136707, NULL, 'G3DSA:3.90.70.10:FF:000069', NULL, NULL, 'Calpain 7', NULL, NULL, NULL, NULL, NULL, 4),
(136708, NULL, 'G3DSA:3.90.550.10:FF:000398', NULL, NULL, 'Killer toxin-resistance protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136709, NULL, 'G3DSA:1.25.40.10:FF:000126', NULL, NULL, 'Anaphase promoting complex subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(136710, NULL, 'G3DSA:1.10.8.60:FF:000424', NULL, NULL, 'Replication factor C subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(136711, NULL, 'G3DSA:2.70.150.10:FF:000286', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(136712, NULL, 'G3DSA:2.60.120.650:FF:000188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136713, NULL, 'G3DSA:1.10.510.10:FF:002299', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136714, NULL, 'G3DSA:2.40.70.10:FF:000197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136715, NULL, 'G3DSA:3.30.450.30:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136716, NULL, 'G3DSA:1.10.555.10:FF:000204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136717, NULL, 'G3DSA:1.20.1370.30:FF:000002', NULL, NULL, 'Malic enzyme 2, NAD(+)-dependent, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(136718, NULL, 'G3DSA:1.10.287.70:FF:000413', NULL, NULL, 'Putative ion channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(136719, NULL, 'G3DSA:3.80.10.10:FF:002387', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136720, NULL, 'G3DSA:2.60.40.10:FF:005202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136721, NULL, 'G3DSA:3.80.10.10:FF:001398', NULL, NULL, 'Os08g0446200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(136722, NULL, 'G3DSA:3.60.21.10:FF:000069', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(136723, NULL, 'G3DSA:3.30.2410.10:FF:000002', NULL, NULL, 'E3 ubiquitin-protein ligase HECW2', NULL, NULL, NULL, NULL, NULL, 4),
(136724, NULL, 'G3DSA:1.10.10.10:FF:001607', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(136725, NULL, 'G3DSA:2.40.70.10:FF:000309', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136726, NULL, 'G3DSA:2.120.10.30:FF:000482', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136727, NULL, 'G3DSA:2.60.120.200:FF:000194', NULL, NULL, 'Crumbs cell polarity complex component 2', NULL, NULL, NULL, NULL, NULL, 4),
(136728, NULL, 'G3DSA:3.40.50.1000:FF:000870', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(136729, NULL, 'G3DSA:2.130.10.10:FF:003617', NULL, NULL, 'WD-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136730, NULL, 'G3DSA:3.40.50.2300:FF:000592', NULL, NULL, 'Sensor histidine kinase RcsC', NULL, NULL, NULL, NULL, NULL, 4),
(136731, NULL, 'G3DSA:3.30.2330.10:FF:000001', NULL, NULL, 'Arginine biosynthesis bifunctional protein ArgJ, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(136732, NULL, 'G3DSA:3.20.20.140:FF:000151', NULL, NULL, 'TatD related DNase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136733, NULL, 'G3DSA:3.20.20.80:FF:000730', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136734, NULL, 'G3DSA:4.10.410.10:FF:000059', NULL, NULL, 'Collagen, type VI, alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(136735, NULL, 'G3DSA:3.40.640.10:FF:000130', NULL, NULL, '8-amino-7-oxononanoate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(136736, NULL, 'G3DSA:3.30.200.20:FF:002547', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136737, NULL, 'G3DSA:3.30.40.10:FF:000143', NULL, NULL, 'Regulator of gluconeogenesis Rmd5', NULL, NULL, NULL, NULL, NULL, 4),
(136738, NULL, 'G3DSA:1.20.1250.20:FF:001362', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136739, NULL, 'G3DSA:3.40.190.10:FF:000701', NULL, NULL, '4-amino-5-hydroxymethyl-2-methylpyrimidine phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(136740, NULL, 'G3DSA:3.50.50.60:FF:000652', NULL, NULL, 'FAD-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(136741, NULL, 'G3DSA:3.30.465.10:FF:000022', NULL, NULL, 'Glycolate oxidase, subunit GlcD', NULL, NULL, NULL, NULL, NULL, 4),
(136742, NULL, 'G3DSA:2.60.40.10:FF:001307', NULL, NULL, 'Stretchin-Mlck, isoform V', NULL, NULL, NULL, NULL, NULL, 4),
(136743, NULL, 'G3DSA:3.40.50.300:FF:002926', NULL, NULL, 'ATP-dependent RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136744, NULL, 'G3DSA:3.30.160.60:FF:006315', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136745, NULL, 'G3DSA:3.40.50.300:FF:008266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136746, NULL, 'G3DSA:2.20.28.20:FF:000002', NULL, NULL, 'Methionyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(136747, NULL, 'G3DSA:3.40.250.10:FF:000055', NULL, NULL, 'Ubiquitin C-terminal hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136748, NULL, 'G3DSA:3.40.33.10:FF:000070', NULL, NULL, 'GM10906', NULL, NULL, NULL, NULL, NULL, 4),
(136749, NULL, 'G3DSA:1.10.10.10:FF:000618', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(136750, NULL, 'G3DSA:3.40.50.1480:FF:000019', NULL, NULL, 'Adenosylhomocysteinase', NULL, NULL, NULL, NULL, NULL, 4),
(136751, NULL, 'G3DSA:3.30.70.330:FF:000058', NULL, NULL, 'RNA-binding motif protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(136752, NULL, 'G3DSA:1.50.40.10:FF:000298', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(136753, NULL, 'G3DSA:1.10.10.60:FF:001100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136754, NULL, 'G3DSA:3.30.40.10:FF:002121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136755, NULL, 'G3DSA:1.10.510.10:FF:000646', NULL, NULL, 'SRSF protein kinase 2 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(136756, NULL, 'G3DSA:4.10.1000.10:FF:000076', NULL, NULL, 'Zinc finger CCCH domain-containing protein 62', NULL, NULL, NULL, NULL, NULL, 4),
(136757, NULL, 'G3DSA:3.90.70.10:FF:000810', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136758, NULL, 'G3DSA:3.60.15.10:FF:000095', NULL, NULL, 'Metallo-hydrolase/oxidoreductase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(136759, NULL, 'G3DSA:3.80.10.10:FF:000734', NULL, NULL, 'Receptor-like protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(136760, NULL, 'G3DSA:3.30.160.60:FF:002364', NULL, NULL, 'zinc finger protein ZIC 3', NULL, NULL, NULL, NULL, NULL, 4),
(136761, NULL, 'G3DSA:1.20.58.530:FF:000011', NULL, NULL, 'unconventional myosin-XVIIIa isoform X2', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(136762, NULL, 'G3DSA:2.130.10.120:FF:000025', NULL, NULL, 'Prolyl endopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(136763, NULL, 'G3DSA:2.60.40.10:FF:002976', NULL, NULL, 'Inositol/phosphatidylinositol phosphatase,putative', NULL, NULL, NULL, NULL, NULL, 4),
(136764, NULL, 'G3DSA:3.30.1740.10:FF:000021', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(136765, NULL, 'G3DSA:3.40.50.1460:FF:000013', NULL, NULL, 'CASP8 and FADD like apoptosis regulator', NULL, NULL, NULL, NULL, NULL, 4),
(136766, NULL, 'G3DSA:1.10.3630.10:FF:000008', NULL, NULL, 'Golgi phosphoprotein 3 (coat-protein)', NULL, NULL, NULL, NULL, NULL, 4),
(136767, NULL, 'G3DSA:3.40.50.300:FF:004051', NULL, NULL, 'Transmembrane GTPase Marf', NULL, NULL, NULL, NULL, NULL, 4),
(136768, NULL, 'G3DSA:3.30.497.10:FF:000096', NULL, NULL, 'Serine protease inhibitor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(136769, NULL, 'G3DSA:4.10.240.10:FF:000170', NULL, NULL, 'Zcf27p', NULL, NULL, NULL, NULL, NULL, 4),
(136770, NULL, 'G3DSA:3.40.50.620:FF:000083', NULL, NULL, 'Methionine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(136771, NULL, 'G3DSA:3.30.160.20:FF:000222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136772, NULL, 'G3DSA:3.40.50.2300:FF:000209', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(136773, NULL, 'G3DSA:1.10.630.10:FF:000273', NULL, NULL, 'Erythromycin C-12 hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(136774, NULL, 'G3DSA:1.20.1250.20:FF:001946', NULL, NULL, 'Xylose transporter', NULL, NULL, NULL, NULL, NULL, 4),
(136775, NULL, 'G3DSA:1.20.200.10:FF:000019', NULL, NULL, 'Argininosuccinate lyase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(136776, NULL, 'G3DSA:3.30.230.10:FF:000281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136777, NULL, 'G3DSA:1.20.1250.20:FF:000518', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(136778, NULL, 'G3DSA:2.60.40.200:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136779, NULL, 'G3DSA:2.40.70.10:FF:000461', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136780, NULL, 'G3DSA:3.40.50.150:FF:000863', NULL, NULL, 'tRNA (adenine(58)-N(1))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(136781, NULL, 'G3DSA:2.60.120.590:FF:000001', NULL, NULL, 'FTO, alpha-ketoglutarate dependent dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(136782, NULL, 'G3DSA:2.70.170.10:FF:000085', NULL, NULL, 'Probable ligand-gated ion channel 46', NULL, NULL, NULL, NULL, NULL, 4),
(136783, NULL, 'G3DSA:1.20.58.60:FF:000153', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(136784, NULL, 'G3DSA:3.30.40.10:FF:001924', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136785, NULL, 'G3DSA:2.10.25.10:FF:001353', NULL, NULL, 'Integrin, beta-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(136786, NULL, 'G3DSA:3.90.550.10:FF:000134', NULL, NULL, 'Glycosyl transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(136787, NULL, 'G3DSA:1.20.5.340:FF:000044', NULL, NULL, 'MIA SH3 domain ER export factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(136788, NULL, 'G3DSA:1.10.510.10:FF:002563', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136789, NULL, 'G3DSA:2.60.40.10:FF:004921', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136790, NULL, 'G3DSA:3.40.140.10:FF:000226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136791, NULL, 'G3DSA:3.30.420.40:FF:000832', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136792, NULL, 'G3DSA:3.40.50.300:FF:004579', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(136793, NULL, 'G3DSA:3.30.200.20:FF:001827', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(136794, NULL, 'G3DSA:1.10.20.10:FF:000208', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136795, NULL, 'G3DSA:2.60.200.10:FF:000012', NULL, NULL, 'Interferon regulatory factor 3', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(136796, NULL, 'G3DSA:2.60.40.10:FF:000470', NULL, NULL, 'SLAM family member 7', NULL, NULL, NULL, NULL, NULL, 4),
(136797, NULL, 'G3DSA:2.130.10.10:FF:000655', NULL, NULL, 'Protein transport protein SEC13', NULL, NULL, NULL, NULL, NULL, 4),
(136798, NULL, 'G3DSA:1.25.40.10:FF:001907', NULL, NULL, 'U1 small nuclear ribonucleoprotein component, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136799, NULL, 'G3DSA:3.30.710.10:FF:000211', NULL, NULL, 'S-phase kinase-associated protein 1A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136800, NULL, 'G3DSA:2.30.36.70:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136801, NULL, 'G3DSA:3.40.850.10:FF:000112', NULL, NULL, 'Kinesin-8, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136802, NULL, 'G3DSA:2.70.150.10:FF:000022', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(136803, NULL, 'G3DSA:3.30.70.330:FF:001486', NULL, NULL, 'POU domain, class 4, transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(136804, NULL, 'G3DSA:3.30.2350.10:FF:000059', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(136805, NULL, 'G3DSA:3.40.50.150:FF:001111', NULL, NULL, 'Uncharacterized protein B11B23.180', NULL, NULL, NULL, NULL, NULL, 4),
(136806, NULL, 'G3DSA:2.30.29.30:FF:000006', NULL, NULL, 'Pleckstrin homology like domain family B member 1', NULL, NULL, NULL, NULL, NULL, 4),
(136807, NULL, 'G3DSA:1.10.472.10:FF:000489', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136808, NULL, 'G3DSA:3.40.50.1360:FF:000040', NULL, NULL, '6-phosphogluconolactonase', NULL, NULL, NULL, NULL, NULL, 4),
(136809, NULL, 'G3DSA:1.10.1420.10:FF:000183', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(136810, NULL, 'G3DSA:2.10.220.10:FF:000069', NULL, NULL, 'Fraser extracellular matrix complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(136811, NULL, 'G3DSA:3.30.530.20:FF:000003', NULL, NULL, 'Collagen type IV alpha-3-binding protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(136812, NULL, 'G3DSA:1.10.510.10:FF:001635', NULL, NULL, 'Protein CBR-IKKE-1', NULL, NULL, NULL, NULL, NULL, 4),
(136813, NULL, 'G3DSA:1.10.150.340:FF:000006', NULL, NULL, '5''-nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(136814, NULL, 'G3DSA:3.40.50.720:FF:000079', NULL, NULL, 'Glucose-6-phosphate 1-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(136815, NULL, 'G3DSA:2.130.10.30:FF:000077', NULL, NULL, 'Highwire, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(136816, NULL, 'G3DSA:3.40.50.2000:FF:000861', NULL, NULL, 'Alpha-1,3/1,6-mannosyltransferase ALG2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(136817, NULL, 'G3DSA:3.40.640.10:FF:000219', NULL, NULL, 'Aminotransferase PigE', NULL, NULL, NULL, NULL, NULL, 4),
(136818, NULL, 'G3DSA:3.40.50.1980:FF:000107', NULL, NULL, 'Histidinol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(136819, NULL, 'G3DSA:3.40.50.10470:FF:000023', NULL, NULL, 'Translation initiation factor EIF-2b alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(136820, NULL, 'G3DSA:3.30.230.10:FF:000337', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(136821, NULL, 'G3DSA:3.30.540.10:FF:000091', NULL, NULL, 'Os05g0438600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(136822, NULL, 'G3DSA:1.10.10.820:FF:000031', NULL, NULL, 'Chitin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(136823, NULL, 'G3DSA:1.10.10.60:FF:000583', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136824, NULL, 'G3DSA:2.60.40.180:FF:000010', NULL, NULL, 'Hydroxyisourate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(136825, NULL, 'G3DSA:1.10.238.10:FF:000546', NULL, NULL, 'Calcium-binding protein CBP', NULL, NULL, NULL, NULL, NULL, 4),
(136826, NULL, 'G3DSA:2.130.10.10:FF:005326', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136827, NULL, 'G3DSA:3.90.980.20:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136828, NULL, 'G3DSA:3.30.200.20:FF:001119', NULL, NULL, 'Myosin light chain kinase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(136829, NULL, 'G3DSA:2.60.40.10:FF:004213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136830, NULL, 'G3DSA:2.40.30.130:FF:000031', NULL, NULL, 'Alanyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(136831, NULL, 'G3DSA:3.40.50.2300:FF:000361', NULL, NULL, 'Two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(136832, NULL, 'G3DSA:1.20.1250.20:FF:002351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136833, NULL, 'G3DSA:1.20.1280.290:FF:000020', NULL, NULL, 'Bidirectional sugar transporter SWEET', NULL, NULL, NULL, NULL, NULL, 4),
(136834, NULL, 'G3DSA:2.20.110.10:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136835, NULL, 'G3DSA:1.20.1420.30:FF:000063', NULL, NULL, 'Sodium/potassium/calcium exchanger 4', NULL, NULL, NULL, NULL, NULL, 4),
(136836, NULL, 'G3DSA:1.10.3130.10:FF:000015', NULL, NULL, 'Serine acetyltransferase, plasmid', NULL, NULL, NULL, NULL, NULL, 4),
(136837, NULL, 'G3DSA:2.60.40.10:FF:001195', NULL, NULL, 'PKHD1 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(136838, NULL, 'G3DSA:1.10.10.60:FF:000644', NULL, NULL, 'MYB transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(136839, NULL, 'G3DSA:2.30.30.140:FF:000317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136840, NULL, 'G3DSA:1.20.58.190:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136841, NULL, 'G3DSA:2.130.10.10:FF:004337', NULL, NULL, 'SEC12-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(136842, NULL, 'G3DSA:4.10.110.10:FF:000014', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(136843, NULL, 'G3DSA:2.60.120.200:FF:000430', NULL, NULL, 'Si:ch211-274f20.2', NULL, NULL, NULL, NULL, NULL, 4),
(136844, NULL, 'G3DSA:2.60.40.10:FF:005910', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136845, NULL, 'G3DSA:3.40.50.300:FF:005040', NULL, NULL, 'DEAH (Asp-Glu-Ala-His) box helicase 15', NULL, NULL, NULL, NULL, NULL, 4),
(136846, NULL, 'G3DSA:2.40.50.140:FF:000072', NULL, NULL, 'SOSS complex subunit B2', NULL, NULL, NULL, NULL, NULL, 4),
(136847, NULL, 'G3DSA:2.60.40.60:FF:001041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136848, NULL, 'G3DSA:3.40.50.300:FF:006788', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136849, NULL, 'G3DSA:3.10.400.20:FF:000009', NULL, NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(136850, NULL, 'G3DSA:3.30.160.60:FF:003353', NULL, NULL, 'zinc finger protein 180 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(136851, NULL, 'G3DSA:3.30.190.20:FF:000050', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(136852, NULL, 'G3DSA:3.40.190.10:FF:000437', NULL, NULL, 'Transferrin', NULL, NULL, NULL, NULL, NULL, 4),
(136853, NULL, 'G3DSA:2.40.100.10:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136854, NULL, 'G3DSA:1.20.1070.10:FF:000743', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(136855, NULL, 'G3DSA:2.170.150.10:FF:000009', NULL, NULL, 'Translationally-controlled tumor protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(136856, NULL, 'G3DSA:3.30.500.10:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136857, NULL, 'G3DSA:3.40.30.10:FF:001081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136858, NULL, 'G3DSA:2.60.120.10:FF:000011', NULL, NULL, 'Potassium channel, voltage-gated eag-related subfamily H, member 7', NULL, NULL, NULL, NULL, NULL, 4),
(136859, NULL, 'G3DSA:1.10.287.70:FF:000677', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136860, NULL, 'G3DSA:2.60.40.10:FF:003140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136861, NULL, 'G3DSA:3.30.1330.20:FF:000004', NULL, NULL, 'Cell division protein FtsZ', NULL, NULL, NULL, NULL, NULL, 4),
(136862, NULL, 'G3DSA:3.40.50.12780:FF:000126', NULL, NULL, 'Nonribosomal peptide synthetase 8', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(136863, NULL, 'G3DSA:1.20.1250.10:FF:000044', NULL, NULL, 'Interferon kappa', NULL, NULL, NULL, NULL, NULL, 4),
(136864, NULL, 'G3DSA:1.10.1670.40:FF:000002', NULL, NULL, 'Base excision DNA repair protein, HhH-GPD family', NULL, NULL, NULL, NULL, NULL, 4),
(136865, NULL, 'G3DSA:1.10.510.10:FF:001051', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(136866, NULL, 'G3DSA:3.40.50.1000:FF:000718', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136867, NULL, 'G3DSA:3.40.50.300:FF:001145', NULL, NULL, 'Putative dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(136868, NULL, 'G3DSA:3.40.190.10:FF:000376', NULL, NULL, 'Alkaline phosphatase L', NULL, NULL, NULL, NULL, NULL, 4),
(136869, NULL, 'G3DSA:3.20.110.10:FF:000027', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(136870, NULL, 'G3DSA:2.60.40.10:FF:003965', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136871, NULL, 'G3DSA:2.40.50.150:FF:000018', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(136872, NULL, 'G3DSA:3.30.70.1020:FF:000002', NULL, NULL, 'Trehalose-6-phosphate synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(136873, NULL, 'G3DSA:1.25.10.10:FF:002395', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136874, NULL, 'G3DSA:1.10.1450.10:FF:000123', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(136875, NULL, 'G3DSA:2.60.40.10:FF:000531', NULL, NULL, 'Immunoglobulin superfamily member 9B', NULL, NULL, NULL, NULL, NULL, 4),
(136876, NULL, 'G3DSA:3.40.50.880:FF:000110', NULL, NULL, 'Catalase', NULL, NULL, NULL, NULL, NULL, 4),
(136877, NULL, 'G3DSA:3.40.47.10:FF:000068', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 3', NULL, NULL, NULL, NULL, NULL, 4),
(136878, NULL, 'G3DSA:3.80.10.10:FF:000942', NULL, NULL, 'Disease resistance protein Pik-2', NULL, NULL, NULL, NULL, NULL, 4),
(136879, NULL, 'G3DSA:2.40.50.140:FF:000780', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136880, NULL, 'G3DSA:1.20.1280.290:FF:000109', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(136881, NULL, 'G3DSA:3.30.160.60:FF:001144', NULL, NULL, 'zinc finger protein 646', NULL, NULL, NULL, NULL, NULL, 4),
(136882, NULL, 'G3DSA:3.30.70.1230:FF:000239', NULL, NULL, 'Soluble adenylyl cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(136883, NULL, 'G3DSA:3.30.565.10:FF:000350', NULL, NULL, 'Phytochrome', NULL, NULL, NULL, NULL, NULL, 4),
(136884, NULL, 'G3DSA:2.170.270.10:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136885, NULL, 'G3DSA:1.25.10.10:FF:003204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136886, NULL, 'G3DSA:2.10.25.10:FF:000633', NULL, NULL, 'cubilin', NULL, NULL, NULL, NULL, NULL, 4),
(136887, NULL, 'G3DSA:1.20.120.140:FF:000039', NULL, NULL, 'Signal recognition particle receptor FtsY', NULL, NULL, NULL, NULL, NULL, 4),
(136888, NULL, 'G3DSA:1.25.40.10:FF:004521', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136889, NULL, 'G3DSA:3.40.390.10:FF:000149', NULL, NULL, 'Carbohydrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(136890, NULL, 'G3DSA:3.30.70.330:FF:000766', NULL, NULL, 'CUGBP Elav family member 6', NULL, NULL, NULL, NULL, NULL, 4),
(136891, NULL, 'G3DSA:1.10.274.30:FF:000001', NULL, NULL, 'Mortality factor 4-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(136892, NULL, 'G3DSA:2.170.270.10:FF:000080', NULL, NULL, 'SET (Trithorax/polycomb) domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(136893, NULL, 'G3DSA:3.40.50.1440:FF:000119', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(136894, NULL, 'G3DSA:1.25.40.720:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136895, NULL, 'G3DSA:3.10.590.10:FF:000020', NULL, NULL, 'ATP-dependent RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136896, NULL, 'G3DSA:2.130.10.10:FF:005826', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(136897, NULL, 'G3DSA:3.30.450.40:FF:000008', NULL, NULL, 'GAF domain-containing proteins', NULL, NULL, NULL, NULL, NULL, 4),
(136898, NULL, 'G3DSA:2.60.40.420:FF:000127', NULL, NULL, 'Extracellular dihydrogeodin oxidase/laccase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136899, NULL, 'G3DSA:3.40.850.10:FF:000376', NULL, NULL, 'Unconventional myosin class XV', NULL, NULL, NULL, NULL, NULL, 4),
(136900, NULL, 'G3DSA:3.90.1150.10:FF:000136', NULL, NULL, 'Serine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(136901, NULL, 'G3DSA:1.20.920.20:FF:000032', NULL, NULL, 'Dynein heavy chain 9, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(136902, NULL, 'G3DSA:2.40.220.10:FF:000001', NULL, NULL, 'Sialidase A', NULL, NULL, NULL, NULL, NULL, 4),
(136903, NULL, 'G3DSA:1.20.1250.20:FF:002290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136904, NULL, 'G3DSA:3.40.190.10:FF:000229', NULL, NULL, 'Phosphate ABC transporter, phosphate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(136905, NULL, 'G3DSA:3.60.60.30:FF:000002', NULL, NULL, 'Phospholipase B-like', NULL, NULL, NULL, NULL, NULL, 4),
(136906, NULL, 'G3DSA:1.20.1060.10:FF:000006', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(136907, NULL, 'G3DSA:1.25.10.10:FF:001018', NULL, NULL, 'Protein CBG14894', NULL, NULL, NULL, NULL, NULL, 4),
(136908, NULL, 'G3DSA:1.20.1110.10:FF:000067', NULL, NULL, 'Probable cation-transporting ATPase exp7', NULL, NULL, NULL, NULL, NULL, 4),
(136909, NULL, 'G3DSA:3.30.160.60:FF:003089', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136910, NULL, 'G3DSA:3.10.110.10:FF:000052', NULL, NULL, 'Putative e3 ubiquitin-protein ligase rnf25', NULL, NULL, NULL, NULL, NULL, 4),
(136911, NULL, 'G3DSA:2.60.120.290:FF:000001', NULL, NULL, 'CUB and sushi domain-containing protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(136912, NULL, 'G3DSA:2.70.98.110:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136913, NULL, 'G3DSA:3.30.160.60:FF:000739', NULL, NULL, 'Zgc:171418 protein', NULL, NULL, NULL, NULL, NULL, 4),
(136914, NULL, 'G3DSA:3.30.450.20:FF:000002', NULL, NULL, 'LOV domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(136915, NULL, 'G3DSA:3.30.530.20:FF:000211', NULL, NULL, 'F-box/WD repeat-containing protein A-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(136916, NULL, 'G3DSA:2.60.40.150:FF:000675', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136917, NULL, 'G3DSA:1.25.40.10:FF:002335', NULL, NULL, 'Glutamine-rich protein23', NULL, NULL, NULL, NULL, NULL, 4),
(136918, NULL, 'G3DSA:1.10.287.2620:FF:000022', NULL, NULL, 'Dynein heavy chain 6, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(136919, NULL, 'G3DSA:3.40.50.300:FF:008474', NULL, NULL, 'Multidrug resistance-associated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136920, NULL, 'G3DSA:3.90.640.10:FF:000225', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(136921, NULL, 'G3DSA:1.10.150.110:FF:000022', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(136922, NULL, 'G3DSA:2.60.40.10:FF:004421', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136923, NULL, 'G3DSA:1.50.40.10:FF:000534', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136924, NULL, 'G3DSA:1.20.120.1240:FF:000051', NULL, NULL, 'Dynamin GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136925, NULL, 'G3DSA:4.10.900.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136926, NULL, 'G3DSA:2.40.50.140:FF:000628', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(136927, NULL, 'G3DSA:3.90.1150.10:FF:000283', NULL, NULL, 'Aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(136928, NULL, 'G3DSA:3.30.200.20:FF:001327', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(136929, NULL, 'G3DSA:3.40.50.300:FF:005540', NULL, NULL, 'Meiotic recombination protein DMC1', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(136930, NULL, 'G3DSA:2.130.10.10:FF:000594', NULL, NULL, 'Small nucleolar ribonucleoprotein complex subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136931, NULL, 'G3DSA:3.80.10.10:FF:000381', NULL, NULL, 'Ubiquitin ligase complex F-box protein GRR1', NULL, NULL, NULL, NULL, NULL, 4),
(136932, NULL, 'G3DSA:3.30.230.10:FF:000129', NULL, NULL, 'Mlh2p', NULL, NULL, NULL, NULL, NULL, 4),
(136933, NULL, 'G3DSA:1.10.730.10:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136934, NULL, 'G3DSA:1.10.10.60:FF:000791', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136935, NULL, 'G3DSA:2.60.40.10:FF:005702', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136936, NULL, 'G3DSA:3.30.160.60:FF:005859', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136937, NULL, 'G3DSA:3.40.50.300:FF:000217', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(136938, NULL, 'G3DSA:2.130.10.10:FF:004545', NULL, NULL, 'AGR367Cp', NULL, NULL, NULL, NULL, NULL, 4),
(136939, NULL, 'G3DSA:3.30.70.660:FF:000073', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(136940, NULL, 'G3DSA:3.30.70.890:FF:000057', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(136941, NULL, 'G3DSA:3.40.532.10:FF:000019', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(136942, NULL, 'G3DSA:3.40.50.1000:FF:000162', NULL, NULL, 'HAD-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(136943, NULL, 'G3DSA:3.30.830.10:FF:000074', NULL, NULL, 'Axl1p', NULL, NULL, NULL, NULL, NULL, 4),
(136944, NULL, 'G3DSA:1.20.120.350:FF:000164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136945, NULL, 'G3DSA:1.10.135.10:FF:000004', NULL, NULL, 'Creatine kinase, flagellar', NULL, NULL, NULL, NULL, NULL, 4),
(136946, NULL, 'G3DSA:3.40.50.2000:FF:000209', NULL, NULL, 'UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase GtfA subunit', NULL, NULL, NULL, NULL, NULL, 4),
(136947, NULL, 'G3DSA:1.10.10.10:FF:001046', NULL, NULL, 'DNA topoisomerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136948, NULL, 'G3DSA:1.20.58.60:FF:000214', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(136949, NULL, 'G3DSA:1.10.8.1220:FF:000011', NULL, NULL, 'Axonemal dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(136950, NULL, 'G3DSA:3.80.10.10:FF:004124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136951, NULL, 'G3DSA:1.20.1070.10:FF:000951', NULL, NULL, 'Mitochondrial pyruvate carrier', NULL, NULL, NULL, NULL, NULL, 4),
(136952, NULL, 'G3DSA:3.30.1140.32:FF:000017', NULL, NULL, '30S ribosomal protein S3', NULL, NULL, NULL, NULL, NULL, 4),
(136953, NULL, 'G3DSA:3.90.226.10:FF:000072', NULL, NULL, 'Enoyl-CoA hydratase domain-containing protein 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(136954, NULL, 'G3DSA:2.60.120.40:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136955, NULL, 'G3DSA:2.10.250.10:FF:000009', NULL, NULL, 'Calreticulin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(136956, NULL, 'G3DSA:3.40.50.2000:FF:000153', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(136957, NULL, 'G3DSA:1.20.1250.20:FF:001423', NULL, NULL, 'MFS transporter of unkown specificity (AFU_orthologue AFUA_1G11350)', NULL, NULL, NULL, NULL, NULL, 4),
(136958, NULL, 'G3DSA:3.30.56.10:FF:000044', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(136959, NULL, 'G3DSA:1.20.1250.20:FF:002143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136960, NULL, 'G3DSA:2.60.120.260:FF:000341', NULL, NULL, 'Sperm-associated antigen 4', NULL, NULL, NULL, NULL, NULL, 4),
(136961, NULL, 'G3DSA:1.25.40.990:FF:000061', NULL, NULL, 'Si:zfos-452g4.1', NULL, NULL, NULL, NULL, NULL, 4),
(136962, NULL, 'G3DSA:2.10.90.10:FF:000031', NULL, NULL, 'placenta growth factor isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(136963, NULL, 'G3DSA:3.30.210.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(136964, NULL, 'G3DSA:3.30.420.40:FF:000068', NULL, NULL, 'Ectonucleoside triphosphate diphosphohydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(136965, NULL, 'G3DSA:2.60.40.790:FF:000159', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136966, NULL, 'G3DSA:1.20.58.390:FF:000098', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(136967, NULL, 'G3DSA:3.30.160.60:FF:001644', NULL, NULL, 'Zinc finger protein 574', NULL, NULL, NULL, NULL, NULL, 4),
(136968, NULL, 'G3DSA:1.25.40.20:FF:000539', NULL, NULL, 'Suppressor of ty', NULL, NULL, NULL, NULL, NULL, 4),
(136969, NULL, 'G3DSA:3.40.50.1820:FF:001453', NULL, NULL, 'Esterase/lipase/thioesterase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(136970, NULL, 'G3DSA:1.10.8.10:FF:000050', NULL, NULL, 'Related to AMFR protein', NULL, NULL, NULL, NULL, NULL, 4),
(136971, NULL, 'G3DSA:3.40.50.150:FF:001583', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136972, NULL, 'G3DSA:3.40.800.20:FF:000022', NULL, NULL, 'Histone deacetylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(136973, NULL, 'G3DSA:3.90.290.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136974, NULL, 'G3DSA:3.90.950.10:FF:000035', NULL, NULL, 'Probable inosine/xanthosine triphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(136975, NULL, 'G3DSA:3.40.50.2300:FF:000945', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136976, NULL, 'G3DSA:1.20.1070.10:FF:001468', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(136977, NULL, 'G3DSA:1.20.120.1900:FF:000063', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(136978, NULL, 'G3DSA:1.10.460.10:FF:000029', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(136979, NULL, 'G3DSA:3.30.70.330:FF:002003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136980, NULL, 'G3DSA:3.40.50.1000:FF:000218', NULL, NULL, 'Copper-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(136981, NULL, 'G3DSA:1.20.120.330:FF:000006', NULL, NULL, 'Programmed cell death protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(136982, NULL, 'G3DSA:3.40.50.300:FF:008002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136983, NULL, 'G3DSA:1.20.1070.10:FF:001671', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136984, NULL, 'G3DSA:1.25.10.10:FF:002187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136985, NULL, 'G3DSA:2.40.50.140:FF:000572', NULL, NULL, 'Exosome complex exonuclease RRP40, putative', NULL, NULL, NULL, NULL, NULL, 4),
(136986, NULL, 'G3DSA:1.10.287.130:FF:000140', NULL, NULL, 'Sensor histidine kinase, PAS and GAF domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(136987, NULL, 'G3DSA:1.10.10.1180:FF:000004', NULL, NULL, 'Inner nuclear membrane protein Man1', NULL, NULL, NULL, NULL, NULL, 4),
(136988, NULL, 'G3DSA:3.30.70.870:FF:000046', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(136989, NULL, 'G3DSA:3.60.21.10:FF:000333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136990, NULL, 'G3DSA:3.40.366.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136991, NULL, 'G3DSA:1.10.287.110:FF:000246', NULL, NULL, 'DNaJ domain (Prokaryotic heat shock protein)', NULL, NULL, NULL, NULL, NULL, 4),
(136992, NULL, 'G3DSA:1.20.1070.10:FF:000390', NULL, NULL, 'Novopsin-1', NULL, NULL, NULL, NULL, NULL, 4),
(136993, NULL, 'G3DSA:3.30.160.60:FF:004634', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(136994, NULL, 'G3DSA:2.60.120.310:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(136995, NULL, 'G3DSA:3.40.190.10:FF:000640', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(136996, NULL, 'G3DSA:4.10.320.10:FF:000024', NULL, NULL, 'Acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(136997, NULL, 'G3DSA:3.90.550.10:FF:000718', NULL, NULL, 'Glycosyltransferase involved in cell wall biogenesis', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(136998, NULL, 'G3DSA:2.10.110.10:FF:000179', NULL, NULL, 'Calponin homology and LIM domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(136999, NULL, 'G3DSA:3.10.450.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137000, NULL, 'G3DSA:2.40.50.140:FF:001089', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137001, NULL, 'G3DSA:2.10.25.10:FF:000897', NULL, NULL, 'Faulty attraction, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(137002, NULL, 'G3DSA:2.130.10.10:FF:001111', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(137003, NULL, 'G3DSA:3.30.260.10:FF:000018', NULL, NULL, 'Heat shock protein 60', NULL, NULL, NULL, NULL, NULL, 4),
(137004, NULL, 'G3DSA:3.30.60.30:FF:000245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137005, NULL, 'G3DSA:3.80.10.10:FF:002887', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137006, NULL, 'G3DSA:1.20.120.1100:FF:000003', NULL, NULL, 'Fatty Acid/Retinol binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(137007, NULL, 'G3DSA:2.60.40.10:FF:002476', NULL, NULL, 'Protein tyrosine phosphatase, receptor type C', NULL, NULL, NULL, NULL, NULL, 4),
(137008, NULL, 'G3DSA:3.90.1150.10:FF:000400', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137009, NULL, 'G3DSA:3.30.2130.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137010, NULL, 'G3DSA:3.40.50.300:FF:002426', NULL, NULL, 'ADP-ribosylation factor-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(137011, NULL, 'G3DSA:3.10.20.90:FF:000992', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137012, NULL, 'G3DSA:1.10.510.10:FF:000707', NULL, NULL, 'CAMK/CAMKL/CHK1 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(137013, NULL, 'G3DSA:3.40.50.720:FF:002524', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137014, NULL, 'G3DSA:1.25.10.10:FF:000242', NULL, NULL, 'Cullin-associated NEDD8-dissociated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(137015, NULL, 'G3DSA:1.25.40.190:FF:000001', NULL, NULL, 'Actin-related protein 2/3 complex subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(137016, NULL, 'G3DSA:3.30.70.330:FF:001339', NULL, NULL, 'Cellular nucleic acid binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137017, NULL, 'G3DSA:3.30.200.20:FF:002047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137018, NULL, 'G3DSA:1.20.1540.10:FF:000032', NULL, NULL, 'inactive rhomboid protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(137019, NULL, 'G3DSA:1.25.40.20:FF:000691', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137020, NULL, 'G3DSA:1.10.20.10:FF:000355', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137021, NULL, 'G3DSA:3.30.565.10:FF:000086', NULL, NULL, 'Type IV pilus sensor protein PilS', NULL, NULL, NULL, NULL, NULL, 4),
(137022, NULL, 'G3DSA:3.20.20.220:FF:000085', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(137023, NULL, 'G3DSA:3.30.450.90:FF:000006', NULL, NULL, 'P-type DNA transfer ATPase VirB11', NULL, NULL, NULL, NULL, NULL, 4),
(137024, NULL, 'G3DSA:2.40.50.100:FF:000167', NULL, NULL, 'Cytochrome f', NULL, NULL, NULL, NULL, NULL, 4),
(137025, NULL, 'G3DSA:3.30.160.60:FF:002425', NULL, NULL, 'Zinc finger protein STAMENLESS 1', NULL, NULL, NULL, NULL, NULL, 4),
(137026, NULL, 'G3DSA:3.30.420.580:FF:000005', NULL, NULL, 'Probable actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(137027, NULL, 'G3DSA:1.20.1050.20:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137028, NULL, 'G3DSA:1.10.3470.10:FF:000006', NULL, NULL, 'Metal ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(137029, NULL, 'G3DSA:3.20.20.80:FF:000022', NULL, NULL, 'Beta-glucosidase 11', NULL, NULL, NULL, NULL, NULL, 4),
(137030, NULL, 'G3DSA:3.90.70.10:FF:000569', NULL, NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(137031, NULL, 'G3DSA:3.30.70.100:FF:000074', NULL, NULL, 'P-type cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(137032, NULL, 'G3DSA:2.60.40.10:FF:000267', NULL, NULL, 'Sidekick cell adhesion molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(137033, NULL, 'G3DSA:3.80.10.10:FF:002179', NULL, NULL, 'ROP-interactive CRIB motif-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(137034, NULL, 'G3DSA:1.20.140.150:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137035, NULL, 'G3DSA:3.30.160.880:FF:000001', NULL, NULL, 'Cell division protein ZapA', NULL, NULL, NULL, NULL, NULL, 4),
(137036, NULL, 'G3DSA:1.10.418.40:FF:000007', NULL, NULL, 'Beclin-1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(137037, NULL, 'G3DSA:3.30.710.10:FF:000008', NULL, NULL, 'Speckle-type POZ protein-like a', NULL, NULL, NULL, NULL, NULL, 4),
(137038, NULL, 'G3DSA:1.25.10.10:FF:000950', NULL, NULL, 'Tubulin-folding cofactor D', NULL, NULL, NULL, NULL, NULL, 4),
(137039, NULL, 'G3DSA:3.90.660.10:FF:000024', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(137040, NULL, 'G3DSA:1.25.40.180:FF:000352', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137041, NULL, 'G3DSA:1.20.58.610:FF:000001', NULL, NULL, 'Hsp90 co-chaperone Cdc37-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(137042, NULL, 'G3DSA:1.10.238.10:FF:000754', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(137043, NULL, 'G3DSA:3.30.160.60:FF:005034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137044, NULL, 'G3DSA:1.10.287.70:FF:000205', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha-1S', NULL, NULL, NULL, NULL, NULL, 4),
(137045, NULL, 'G3DSA:1.20.5.100:FF:000023', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(137046, NULL, 'G3DSA:3.40.50.720:FF:000315', NULL, NULL, '(+)-neomenthol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(137047, NULL, 'G3DSA:3.30.1060.10:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137048, NULL, 'G3DSA:2.30.30.100:FF:000064', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm4', NULL, NULL, NULL, NULL, NULL, 4),
(137049, NULL, 'G3DSA:3.90.930.12:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137050, NULL, 'G3DSA:1.10.510.10:FF:003316', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137051, NULL, 'G3DSA:3.90.740.10:FF:000025', NULL, NULL, 'Valine--tRNA ligase, chloroplastic/mitochondrial 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(137052, NULL, 'G3DSA:3.40.50.300:FF:004820', NULL, NULL, 'TBP-associated factor A', NULL, NULL, NULL, NULL, NULL, 4),
(137053, NULL, 'G3DSA:3.40.950.10:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137054, NULL, 'G3DSA:3.30.310.50:FF:000035', NULL, NULL, 'Phosphohexomutase (Phosphoglucomutase / phosphomannomutase)', NULL, NULL, NULL, NULL, NULL, 4),
(137055, NULL, 'G3DSA:3.30.160.60:FF:004781', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137056, NULL, 'G3DSA:3.80.10.10:FF:001662', NULL, NULL, 'Immunoglobulin superfamily, member 10', NULL, NULL, NULL, NULL, NULL, 4),
(137057, NULL, 'G3DSA:1.20.140.10:FF:000020', NULL, NULL, 'Long-chain specific acyl-CoA dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(137058, NULL, 'G3DSA:3.30.40.10:FF:000643', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(137059, NULL, 'G3DSA:3.70.10.10:FF:000111', NULL, NULL, 'DNA repair protein rad9', NULL, NULL, NULL, NULL, NULL, 4),
(137060, NULL, 'G3DSA:2.10.25.10:FF:000072', NULL, NULL, 'Low-density lipoprotein receptor-related protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(137061, NULL, 'G3DSA:2.10.70.10:FF:000232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137062, NULL, 'G3DSA:1.10.510.10:FF:000854', NULL, NULL, 'Protein CBG12201', NULL, NULL, NULL, NULL, NULL, 4),
(137063, NULL, 'G3DSA:1.25.40.10:FF:003616', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137064, NULL, 'G3DSA:4.10.400.10:FF:000025', NULL, NULL, 'Very low density lipoprotein receptor', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(137065, NULL, 'G3DSA:2.40.170.20:FF:000038', NULL, NULL, 'SusC/RagA family TonB-linked outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(137066, NULL, 'G3DSA:3.40.120.10:FF:000074', NULL, NULL, 'Phosphoglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(137067, NULL, 'G3DSA:1.10.150.50:FF:000124', NULL, NULL, 'AGAP009560-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(137068, NULL, 'G3DSA:3.30.870.10:FF:000104', NULL, NULL, 'Phosphatidylcholine-hydrolyzing phospholipase D (PLD) family', NULL, NULL, NULL, NULL, NULL, 4),
(137069, NULL, 'G3DSA:1.10.510.10:FF:002916', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137070, NULL, 'G3DSA:1.25.40.20:FF:001091', NULL, NULL, 'Serine/threonine-protein kinase NEK', NULL, NULL, NULL, NULL, NULL, 4),
(137071, NULL, 'G3DSA:3.90.230.10:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137072, NULL, 'G3DSA:3.30.1010.10:FF:000016', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', NULL, NULL, NULL, NULL, NULL, 4),
(137073, NULL, 'G3DSA:3.90.190.10:FF:000235', NULL, NULL, 'Protein-tyrosine-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(137074, NULL, 'G3DSA:3.40.50.150:FF:000655', NULL, NULL, 'Protein CBG03740', NULL, NULL, NULL, NULL, NULL, 4),
(137075, NULL, 'G3DSA:3.40.50.300:FF:002050', NULL, NULL, 'ABC transporter, class F', NULL, NULL, NULL, NULL, NULL, 4),
(137076, NULL, 'G3DSA:2.60.120.620:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137077, NULL, 'G3DSA:1.10.630.10:FF:000773', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137078, NULL, 'G3DSA:1.20.120.610:FF:000023', NULL, NULL, 'AGAP010692-PA', NULL, NULL, NULL, NULL, NULL, 4),
(137079, NULL, 'G3DSA:1.10.287.3700:FF:000003', NULL, NULL, 'Pab1p-dependent poly(A) ribonuclease subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137080, NULL, 'G3DSA:3.40.50.620:FF:000583', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137081, NULL, 'G3DSA:2.40.30.10:FF:000335', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137082, NULL, 'G3DSA:3.30.160.60:FF:005298', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137083, NULL, 'G3DSA:1.10.510.10:FF:000146', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase IOS1', NULL, NULL, NULL, NULL, NULL, 4),
(137084, NULL, 'G3DSA:2.60.40.10:FF:004685', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137085, NULL, 'G3DSA:2.60.40.60:FF:000844', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137086, NULL, 'G3DSA:3.40.1110.10:FF:000477', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137087, NULL, 'G3DSA:1.20.58.400:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137088, NULL, 'G3DSA:1.10.10.10:FF:000118', NULL, NULL, '40S ribosomal protein S19', NULL, NULL, NULL, NULL, NULL, 4),
(137089, NULL, 'G3DSA:1.10.238.10:FF:000193', NULL, NULL, 'EF-hand calcium-binding domain-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(137090, NULL, 'G3DSA:1.10.150.20:FF:000020', NULL, NULL, 'DNA-directed RNA polymerase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(137091, NULL, 'G3DSA:3.30.110.20:FF:000011', NULL, NULL, 'RNase MRP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(137092, NULL, 'G3DSA:3.30.160.60:FF:002572', NULL, NULL, 'Tripartite motif-containing protein 49', NULL, NULL, NULL, NULL, NULL, 4),
(137093, NULL, 'G3DSA:2.120.10.30:FF:000538', NULL, NULL, 'Flagellum-adhesion glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(137094, NULL, 'G3DSA:2.30.30.380:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137095, NULL, 'G3DSA:3.40.630.10:FF:000281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137096, NULL, 'G3DSA:3.10.20.90:FF:000256', NULL, NULL, 'Small ubiquitin-related modifier', NULL, NULL, NULL, NULL, NULL, 4),
(137097, NULL, 'G3DSA:2.60.120.260:FF:000402', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(137098, NULL, 'G3DSA:1.20.58.60:FF:000237', NULL, NULL, 'Spectrin repeat containing nuclear envelope family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(137099, NULL, 'G3DSA:1.10.510.10:FF:004305', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137100, NULL, 'G3DSA:1.10.8.270:FF:000172', NULL, NULL, 'Small GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(137101, NULL, 'G3DSA:1.20.58.390:FF:000334', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137102, NULL, 'G3DSA:2.40.160.110:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137103, NULL, 'G3DSA:3.30.420.10:FF:000380', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137104, NULL, 'G3DSA:1.10.530.10:FF:000029', NULL, NULL, 'Resuscitation-promoting factor RpfA', NULL, NULL, NULL, NULL, NULL, 4),
(137105, NULL, 'G3DSA:1.20.1070.10:FF:002008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137106, NULL, 'G3DSA:1.10.10.60:FF:000083', NULL, NULL, 'BEL1-like homeodomain protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(137107, NULL, 'G3DSA:1.20.1070.10:FF:001968', NULL, NULL, 'Zgc:85942 protein', NULL, NULL, NULL, NULL, NULL, 4),
(137108, NULL, 'G3DSA:1.20.120.1530:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137109, NULL, 'G3DSA:3.60.20.10:FF:000106', NULL, NULL, 'Asparagine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(137110, NULL, 'G3DSA:3.40.50.150:FF:001083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137111, NULL, 'G3DSA:1.10.1420.10:FF:000211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137112, NULL, 'G3DSA:1.20.1600.10:FF:000026', NULL, NULL, 'Multidrug resistance protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137113, NULL, 'G3DSA:2.20.70.10:FF:000035', NULL, NULL, 'Salvador homolog 1 (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(137114, NULL, 'G3DSA:1.20.5.340:FF:000128', NULL, NULL, 'Myosin-2 heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(137115, NULL, 'G3DSA:1.25.40.1040:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137116, NULL, 'G3DSA:3.30.1510.10:FF:000009', NULL, NULL, 'Formate--tetrahydrofolate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(137117, NULL, 'G3DSA:2.40.30.30:FF:000021', NULL, NULL, 'Riboflavin kinase', NULL, NULL, NULL, NULL, NULL, 4),
(137118, NULL, 'G3DSA:3.30.930.10:FF:000019', NULL, NULL, 'Threonine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(137119, NULL, 'G3DSA:3.50.50.60:FF:001438', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137120, NULL, 'G3DSA:3.40.50.300:FF:006760', NULL, NULL, 'Iron (II) transporter (FeoB-2) part 1, conjectural, authentic frameshift', NULL, NULL, NULL, NULL, NULL, 4),
(137121, NULL, 'G3DSA:1.10.238.10:FF:000046', NULL, NULL, 'intersectin-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(137122, NULL, 'G3DSA:3.90.550.50:FF:000123', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(137123, NULL, 'G3DSA:1.10.150.60:FF:000009', NULL, NULL, 'AT-rich interactive domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(137124, NULL, 'G3DSA:1.10.8.720:FF:000059', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(137125, NULL, 'G3DSA:2.60.40.10:FF:003201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137126, NULL, 'G3DSA:3.40.50.300:FF:000925', NULL, NULL, 'DNA mismatch repair protein MSH2', NULL, NULL, NULL, NULL, NULL, 4),
(137127, NULL, 'G3DSA:1.10.20.10:FF:000147', NULL, NULL, 'Histone H3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137128, NULL, 'G3DSA:1.25.40.10:FF:003116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137129, NULL, 'G3DSA:3.10.450.50:FF:000027', NULL, NULL, 'Nuclear transport factor 2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(137130, NULL, 'G3DSA:3.80.10.10:FF:003404', NULL, NULL, 'Dynein assembly factor 1, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(137131, NULL, 'G3DSA:3.40.630.30:FF:000287', NULL, NULL, 'N(alpha)-acetyltransferase 60, NatF catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(137132, NULL, 'G3DSA:2.60.40.10:FF:003196', NULL, NULL, 'Immunoglobulin-like domain-containing receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(137133, NULL, 'G3DSA:3.90.1640.10:FF:000039', NULL, NULL, 'Mutant prune', NULL, NULL, NULL, NULL, NULL, 4),
(137134, NULL, 'G3DSA:3.40.1080.10:FF:000007', NULL, NULL, 'Acetate CoA-transferase YdiF', NULL, NULL, NULL, NULL, NULL, 4),
(137135, NULL, 'G3DSA:2.130.10.10:FF:002072', NULL, NULL, 'WD domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(137136, NULL, 'G3DSA:1.10.472.10:FF:000517', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(137137, NULL, 'G3DSA:3.40.50.2300:FF:001378', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137138, NULL, 'G3DSA:3.30.70.260:FF:000161', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(137139, NULL, 'G3DSA:3.10.20.90:FF:000784', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(137140, NULL, 'G3DSA:2.40.30.130:FF:000054', NULL, NULL, 'AGAP006997-PA', NULL, NULL, NULL, NULL, NULL, 4),
(137141, NULL, 'G3DSA:1.25.10.10:FF:001962', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(137142, NULL, 'G3DSA:1.20.920.10:FF:000091', NULL, NULL, 'DNA-binding bromodomain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(137143, NULL, 'G3DSA:2.30.31.10:FF:000028', NULL, NULL, 'Putative RNA polymerase II transcriptional coactivator', NULL, NULL, NULL, NULL, NULL, 4),
(137144, NULL, 'G3DSA:3.60.21.10:FF:000272', NULL, NULL, 'Cytochrome c-554', NULL, NULL, NULL, NULL, NULL, 4),
(137145, NULL, 'G3DSA:3.10.330.20:FF:000009', NULL, NULL, 'tRNA (adenine(58)-N(1))-methyltransferase catalytic subunit TRM61', NULL, NULL, NULL, NULL, NULL, 4),
(137146, NULL, 'G3DSA:3.30.200.20:FF:000107', NULL, NULL, 'Putative activated CDC42 kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(137147, NULL, 'G3DSA:3.30.70.330:FF:002391', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137148, NULL, 'G3DSA:3.30.420.390:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137149, NULL, 'G3DSA:3.40.190.10:FF:000937', NULL, NULL, 'Os02g0478525 protein', NULL, NULL, NULL, NULL, NULL, 4),
(137150, NULL, 'G3DSA:3.30.420.40:FF:000771', NULL, NULL, 'Actin-related protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(137151, NULL, 'G3DSA:3.10.580.10:FF:000047', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(137152, NULL, 'G3DSA:3.40.50.12280:FF:000010', NULL, NULL, 'NAD(P)H-quinone oxidoreductase subunit K, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(137153, NULL, 'G3DSA:3.80.10.10:FF:003876', NULL, NULL, 'Insulin like growth factor binding protein acid labile subunit', NULL, NULL, NULL, NULL, NULL, 4),
(137154, NULL, 'G3DSA:3.60.40.10:FF:000164', NULL, NULL, 'Response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(137155, NULL, 'G3DSA:1.25.40.20:FF:001028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137156, NULL, 'G3DSA:2.30.30.140:FF:000233', NULL, NULL, 'Qin', NULL, NULL, NULL, NULL, NULL, 4),
(137157, NULL, 'G3DSA:1.25.40.20:FF:000955', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137158, NULL, 'G3DSA:3.90.228.10:FF:000054', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(137159, NULL, 'G3DSA:2.60.40.60:FF:000405', NULL, NULL, 'Si:ch211-186j3.6', NULL, NULL, NULL, NULL, NULL, 4),
(137160, NULL, 'G3DSA:2.30.30.30:FF:000162', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(137161, NULL, 'G3DSA:1.10.150.40:FF:000003', NULL, NULL, 'Barrier-to-autointegration factor B', NULL, NULL, NULL, NULL, NULL, 4),
(137162, NULL, 'G3DSA:3.90.70.10:FF:000838', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137163, NULL, 'G3DSA:1.10.8.270:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137164, NULL, 'G3DSA:2.170.150.80:FF:000013', NULL, NULL, 'BnaC01g09890D protein', NULL, NULL, NULL, NULL, NULL, 4),
(137165, NULL, 'G3DSA:3.30.1150.10:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(137166, NULL, 'G3DSA:3.30.160.60:FF:001228', NULL, NULL, 'Zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(137167, NULL, 'G3DSA:3.30.110.170:FF:000003', NULL, NULL, 'Interleukin-1 receptor-associated kinase 1-binding protein 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(137168, NULL, 'G3DSA:3.90.550.50:FF:000067', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(137169, NULL, 'G3DSA:3.30.160.60:FF:000891', NULL, NULL, 'Zinc finger protein 142', NULL, NULL, NULL, NULL, NULL, 4),
(137170, NULL, 'G3DSA:3.20.20.140:FF:000443', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(137171, NULL, 'G3DSA:3.30.1490.150:FF:000001', NULL, NULL, 'AMME syndrome candidate gene 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(137172, NULL, 'G3DSA:3.20.20.140:FF:000387', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137173, NULL, 'G3DSA:2.60.40.10:FF:004185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137174, NULL, 'G3DSA:2.60.40.150:FF:000411', NULL, NULL, 'Putative ca2+-dependent phospholipid-binding protein synaptotagmin', NULL, NULL, NULL, NULL, NULL, 4),
(137175, NULL, 'G3DSA:1.10.437.10:FF:000003', NULL, NULL, 'Bcl-2-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(137176, NULL, 'G3DSA:3.40.50.150:FF:000571', NULL, NULL, 'Methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137177, NULL, 'G3DSA:3.40.850.10:FF:000168', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(137178, NULL, 'G3DSA:3.40.630.30:FF:000343', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137179, NULL, 'G3DSA:1.10.510.10:FF:003052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137180, NULL, 'G3DSA:3.30.9.10:FF:000087', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(137181, NULL, 'G3DSA:1.10.510.10:FF:001074', NULL, NULL, 'Putative serine/threonine-protein kinase Nek3', NULL, NULL, NULL, NULL, NULL, 4),
(137182, NULL, 'G3DSA:1.10.357.10:FF:000002', NULL, NULL, 'Nucleoid occlusion factor SlmA', NULL, NULL, NULL, NULL, NULL, 4),
(137183, NULL, 'G3DSA:3.30.420.10:FF:000756', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137184, NULL, 'G3DSA:1.25.40.10:FF:001790', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At2g01510', NULL, NULL, NULL, NULL, NULL, 4),
(137185, NULL, 'G3DSA:3.30.160.60:FF:003589', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137186, NULL, 'G3DSA:3.30.70.590:FF:000001', NULL, NULL, 'Putative poly(A) polymerase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(137187, NULL, 'G3DSA:3.40.50.11040:FF:000003', NULL, NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', NULL, NULL, NULL, NULL, NULL, 4),
(137188, NULL, 'G3DSA:3.10.20.90:FF:000312', NULL, NULL, 'E3 ubiquitin-protein ligase UPL5', NULL, NULL, NULL, NULL, NULL, 4),
(137189, NULL, 'G3DSA:2.10.25.10:FF:001206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137190, NULL, 'G3DSA:1.20.1270.280:FF:000043', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(137191, NULL, 'G3DSA:1.25.10.10:FF:000181', NULL, NULL, 'Nipped-B protein', NULL, NULL, NULL, NULL, NULL, 4),
(137192, NULL, 'G3DSA:1.10.150.50:FF:000208', NULL, NULL, 'Fli-1 proto-oncogene, ETS transcription factor a', NULL, NULL, NULL, NULL, NULL, 4),
(137193, NULL, 'G3DSA:1.10.1370.30:FF:000044', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(137194, NULL, 'G3DSA:1.10.10.10:FF:000326', NULL, NULL, 'DEP domain-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(137195, NULL, 'G3DSA:3.10.50.10:FF:000043', NULL, NULL, 'Di-N-acetylchitobiase', NULL, NULL, NULL, NULL, NULL, 4),
(137196, NULL, 'G3DSA:2.10.25.10:FF:001589', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137197, NULL, 'G3DSA:3.80.10.10:FF:002943', NULL, NULL, 'Receptor protein-tyrosine kinase CEPR2', NULL, NULL, NULL, NULL, NULL, 4),
(137198, NULL, 'G3DSA:1.20.1070.10:FF:002160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(137199, NULL, 'G3DSA:3.30.450.40:FF:000160', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(137200, NULL, 'G3DSA:3.40.960.10:FF:000002', NULL, NULL, 'DNA helicase related protein', NULL, NULL, NULL, NULL, NULL, 4),
(137201, NULL, 'G3DSA:3.40.50.1820:FF:000048', NULL, NULL, 'Protein phosphatase methylesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(137202, NULL, 'G3DSA:3.30.160.60:FF:005562', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137203, NULL, 'G3DSA:3.40.1110.10:FF:000393', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137204, NULL, 'G3DSA:2.60.40.10:FF:004977', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137205, NULL, 'G3DSA:2.60.40.60:FF:000788', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137206, NULL, 'G3DSA:1.10.357.30:FF:000008', NULL, NULL, 'Exocyst complex component SEC15', NULL, NULL, NULL, NULL, NULL, 4),
(137207, NULL, 'G3DSA:3.40.50.300:FF:004343', NULL, NULL, 'ABC transporter releated protein', NULL, NULL, NULL, NULL, NULL, 4),
(137208, NULL, 'G3DSA:3.40.190.10:FF:000584', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(137209, NULL, 'G3DSA:3.30.420.80:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137210, NULL, 'G3DSA:3.40.50.300:FF:002903', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(137211, NULL, 'G3DSA:1.25.10.10:FF:001170', NULL, NULL, 'Protein SWEETIE', NULL, NULL, NULL, NULL, NULL, 4),
(137212, NULL, 'G3DSA:1.20.5.170:FF:000055', NULL, NULL, 'CCAAT/enhancer-binding protein gamma', NULL, NULL, NULL, NULL, NULL, 4),
(137213, NULL, 'G3DSA:1.25.40.10:FF:005005', NULL, NULL, 'Tetratricopeptide repeat domain 28', NULL, NULL, NULL, NULL, NULL, 4),
(137214, NULL, 'G3DSA:1.10.3710.10:FF:000014', NULL, NULL, 'ATPase WRNIP1', NULL, NULL, NULL, NULL, NULL, 4),
(137215, NULL, 'G3DSA:2.40.340.10:FF:000009', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(137216, NULL, 'G3DSA:1.20.144.10:FF:000141', NULL, NULL, 'Probable diacylglycerol pyrophosphate phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(137217, NULL, 'G3DSA:2.60.40.10:FF:005141', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137218, NULL, 'G3DSA:2.70.10.10:FF:000001', NULL, NULL, 'Hirudin variant-1', NULL, NULL, NULL, NULL, NULL, 4),
(137219, NULL, 'G3DSA:3.80.10.10:FF:002415', NULL, NULL, 'Si:ch211-236p5.2', NULL, NULL, NULL, NULL, NULL, 4),
(137220, NULL, 'G3DSA:3.30.70.20:FF:000097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137221, NULL, 'G3DSA:1.20.1530.20:FF:000063', NULL, NULL, 'Sodium/hydrogen exchanger family-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(137222, NULL, 'G3DSA:3.90.1150.10:FF:000344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137223, NULL, 'G3DSA:1.10.287.110:FF:000190', NULL, NULL, 'DnaJ domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137224, NULL, 'G3DSA:3.90.1420.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137225, NULL, 'G3DSA:2.40.50.100:FF:000144', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(137226, NULL, 'G3DSA:3.40.50.10130:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137227, NULL, 'G3DSA:3.30.160.60:FF:003117', NULL, NULL, 'Si:ch73-120g24.4', NULL, NULL, NULL, NULL, NULL, 4),
(137228, NULL, 'G3DSA:2.120.10.80:FF:000356', NULL, NULL, 'Peptidase S8 and S53 subtilisin kexin sedolisin', NULL, NULL, NULL, NULL, NULL, 4),
(137229, NULL, 'G3DSA:3.40.50.2020:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137230, NULL, 'G3DSA:2.60.40.150:FF:000759', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137231, NULL, 'G3DSA:3.90.25.10:FF:000026', NULL, NULL, 'GDP-mannose 4,6-dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(137232, NULL, 'G3DSA:2.40.10.10:FF:000249', NULL, NULL, 'Zgc:100868', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(137233, NULL, 'G3DSA:3.30.470.30:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137234, NULL, 'G3DSA:3.40.50.720:FF:001799', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137235, NULL, 'G3DSA:3.30.160.60:FF:000716', NULL, NULL, 'MDS1 and EVI1 complex locus protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(137236, NULL, 'G3DSA:3.30.160.60:FF:001291', NULL, NULL, 'Zinc finger protein 354C', NULL, NULL, NULL, NULL, NULL, 4),
(137237, NULL, 'G3DSA:2.40.50.1000:FF:000005', NULL, NULL, '30S ribosomal protein S17', NULL, NULL, NULL, NULL, NULL, 4),
(137238, NULL, 'G3DSA:3.50.50.60:FF:000152', NULL, NULL, 'Oxidative stress-induced growth inhibitor 1', NULL, NULL, NULL, NULL, NULL, 4),
(137239, NULL, 'G3DSA:2.10.22.10:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137240, NULL, 'G3DSA:3.20.20.80:FF:000314', NULL, NULL, 'Alpha amylase catalytic region', NULL, NULL, NULL, NULL, NULL, 4),
(137241, NULL, 'G3DSA:3.30.830.10:FF:000135', NULL, NULL, 'Metallo-peptidase, Clan ME, Family M16', NULL, NULL, NULL, NULL, NULL, 4),
(137242, NULL, 'G3DSA:3.30.870.10:FF:000076', NULL, NULL, 'Phospholipase D, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137243, NULL, 'G3DSA:3.30.70.2750:FF:000004', NULL, NULL, 'V-type ATP synthase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(137244, NULL, 'G3DSA:1.10.10.10:FF:000798', NULL, NULL, 'Protein nirG', NULL, NULL, NULL, NULL, NULL, 4),
(137245, NULL, 'G3DSA:1.10.510.10:FF:000938', NULL, NULL, 'eIF-2-alpha kinase GCN2', NULL, NULL, NULL, NULL, NULL, 4),
(137246, NULL, 'G3DSA:3.15.20.10:FF:000008', NULL, NULL, 'Cholesteryl ester transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(137247, NULL, 'G3DSA:2.10.90.10:FF:000059', NULL, NULL, 'CRE-TIG-2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(137248, NULL, 'G3DSA:3.40.50.300:FF:003415', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(137249, NULL, 'G3DSA:3.40.50.880:FF:000166', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(137250, NULL, 'G3DSA:1.10.287.130:FF:000196', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(137251, NULL, 'G3DSA:3.40.190.10:FF:000201', NULL, NULL, 'HTH-type transcriptional regulator xapR', NULL, NULL, NULL, NULL, NULL, 4),
(137252, NULL, 'G3DSA:3.30.70.330:FF:001755', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137253, NULL, 'G3DSA:1.25.40.10:FF:002127', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g21705, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(137254, NULL, 'G3DSA:1.10.390.10:FF:000057', NULL, NULL, 'Transcription initiation factor TFIID subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(137255, NULL, 'G3DSA:3.30.750.24:FF:000047', NULL, NULL, 'Prestin-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(137256, NULL, 'G3DSA:3.90.226.10:FF:000336', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(137257, NULL, 'G3DSA:1.25.40.10:FF:003908', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137258, NULL, 'G3DSA:3.40.50.620:FF:000611', NULL, NULL, 'Arginyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(137259, NULL, 'G3DSA:2.130.10.10:FF:000094', NULL, NULL, 'WD repeat-containing protein 61', NULL, NULL, NULL, NULL, NULL, 4),
(137260, NULL, 'G3DSA:2.10.70.10:FF:000176', NULL, NULL, 'C-type LECtin', NULL, NULL, NULL, NULL, NULL, 4),
(137261, NULL, 'G3DSA:2.10.50.10:FF:000169', NULL, NULL, 'Neurotrophin receptor-associated death domain', NULL, NULL, NULL, NULL, NULL, 4),
(137262, NULL, 'G3DSA:3.40.50.360:FF:000100', NULL, NULL, 'NADPH-dependent diflavin oxidoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(137263, NULL, 'G3DSA:3.30.559.10:FF:000049', NULL, NULL, 'Choline O-acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137264, NULL, 'G3DSA:2.130.10.130:FF:000062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137265, NULL, 'G3DSA:1.10.533.10:FF:000159', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(137266, NULL, 'G3DSA:2.30.29.30:FF:001350', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(137267, NULL, 'G3DSA:3.10.129.10:FF:000162', NULL, NULL, 'PaaI family thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(137268, NULL, 'G3DSA:1.50.40.10:FF:000118', NULL, NULL, 'Mitochondrial glycine transporter', NULL, NULL, NULL, NULL, NULL, 4),
(137269, NULL, 'G3DSA:3.80.10.10:FF:002095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137270, NULL, 'G3DSA:3.30.1370.70:FF:000004', NULL, NULL, 'HIRA-interacting protein 5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137271, NULL, 'G3DSA:3.40.50.1440:FF:000030', NULL, NULL, 'tubulin beta chain isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(137272, NULL, 'G3DSA:1.20.1580.10:FF:000001', NULL, NULL, 'UvrABC system protein A', NULL, NULL, NULL, NULL, NULL, 4),
(137273, NULL, 'G3DSA:3.40.50.150:FF:000947', NULL, NULL, 'Trans-aconitate 3-methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137274, NULL, 'G3DSA:2.30.29.30:FF:000714', NULL, NULL, 'Growth factor receptor-bound protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(137275, NULL, 'G3DSA:1.10.287.370:FF:000037', NULL, NULL, 'Prefoldin subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(137276, NULL, 'G3DSA:3.40.50.300:FF:000009', NULL, NULL, 'CTP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(137277, NULL, 'G3DSA:2.130.10.10:FF:003325', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137278, NULL, 'G3DSA:3.80.10.10:FF:001459', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(137279, NULL, 'G3DSA:1.10.150.670:FF:000021', NULL, NULL, 'crossover junction endonuclease MUS81', NULL, NULL, NULL, NULL, NULL, 4),
(137280, NULL, 'G3DSA:1.20.1250.20:FF:000018', NULL, NULL, 'MFS transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(137281, NULL, 'G3DSA:2.40.50.690:FF:000034', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(137282, NULL, 'G3DSA:3.30.1370.110:FF:000030', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(137283, NULL, 'G3DSA:3.30.390.150:FF:000002', NULL, NULL, 'BRICHOS domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(137284, NULL, 'G3DSA:1.10.287.4070:FF:000002', NULL, NULL, 'Nucleolar protein 56', NULL, NULL, NULL, NULL, NULL, 4),
(137285, NULL, 'G3DSA:1.25.40.10:FF:003588', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(137286, NULL, 'G3DSA:3.30.450.20:FF:000238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137287, NULL, 'G3DSA:2.60.40.1910:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137288, NULL, 'G3DSA:3.30.160.60:FF:004578', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137289, NULL, 'G3DSA:3.40.30.10:FF:001142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137290, NULL, 'G3DSA:3.40.1280.10:FF:000051', NULL, NULL, 'RNA methyltransferase trmh family putative', NULL, NULL, NULL, NULL, NULL, 4),
(137291, NULL, 'G3DSA:2.60.260.20:FF:000086', NULL, NULL, 'Chaperone protein DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(137292, NULL, 'G3DSA:3.10.450.240:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137293, NULL, 'G3DSA:1.10.510.10:FF:000562', NULL, NULL, 'Serine/threonine-protein kinase bur1', NULL, NULL, NULL, NULL, NULL, 4),
(137294, NULL, 'G3DSA:4.10.60.10:FF:000182', NULL, NULL, 'Ribosomal L28e protein family', NULL, NULL, NULL, NULL, NULL, 4),
(137295, NULL, 'G3DSA:3.30.565.10:FF:000142', NULL, NULL, 'Pkp1p', NULL, NULL, NULL, NULL, NULL, 4),
(137296, NULL, 'G3DSA:3.80.10.10:FF:004040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137297, NULL, 'G3DSA:1.20.1050.10:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137298, NULL, 'G3DSA:2.40.100.10:FF:000110', NULL, NULL, 'Cyclophilin-type peptidyl-prolyl cis-trans isomerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137299, NULL, 'G3DSA:2.40.10.480:FF:000008', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(137300, NULL, 'G3DSA:1.10.340.30:FF:000032', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(137301, NULL, 'G3DSA:3.30.300.30:FF:000023', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(137302, NULL, 'G3DSA:1.20.1250.20:FF:001923', NULL, NULL, 'AGAP000046-PA', NULL, NULL, NULL, NULL, NULL, 4),
(137303, NULL, 'G3DSA:3.30.160.60:FF:002780', NULL, NULL, 'Protein CBR-EOR-1', NULL, NULL, NULL, NULL, NULL, 4),
(137304, NULL, 'G3DSA:1.20.142.10:FF:000007', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(137305, NULL, 'G3DSA:2.60.260.20:FF:000114', NULL, NULL, 'DNAJB1 isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(137306, NULL, 'G3DSA:2.60.40.10:FF:002268', NULL, NULL, 'Myotactin form A', NULL, NULL, NULL, NULL, NULL, 4),
(137307, NULL, 'G3DSA:1.10.730.10:FF:000073', NULL, NULL, 'Isoleucine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(137308, NULL, 'G3DSA:3.40.50.150:FF:000099', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', NULL, NULL, NULL, NULL, NULL, 4),
(137309, NULL, 'G3DSA:1.10.287.690:FF:000015', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(137310, NULL, 'G3DSA:1.10.8.870:FF:000020', NULL, NULL, 'Aerobic glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(137311, NULL, 'G3DSA:1.10.287.110:FF:000038', NULL, NULL, 'DnaJ protein ERDJ2A', NULL, NULL, NULL, NULL, NULL, 4),
(137312, NULL, 'G3DSA:2.60.40.150:FF:000091', NULL, NULL, 'Extended synaptotagmin 2', NULL, NULL, NULL, NULL, NULL, 4),
(137313, NULL, 'G3DSA:3.40.50.150:FF:000155', NULL, NULL, 'Probable methyltransferase-like protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(137314, NULL, 'G3DSA:3.50.50.60:FF:000949', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137315, NULL, 'G3DSA:2.30.42.10:FF:000256', NULL, NULL, 'Protease Do-like 9', NULL, NULL, NULL, NULL, NULL, 4),
(137316, NULL, 'G3DSA:1.20.1250.20:FF:000434', NULL, NULL, 'Blast:Monocarboxylate transporter 4', NULL, NULL, NULL, NULL, NULL, 4),
(137317, NULL, 'G3DSA:3.40.30.10:FF:000029', NULL, NULL, 'protein disulfide-isomerase A5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(137318, NULL, 'G3DSA:3.30.70.330:FF:001278', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(137319, NULL, 'G3DSA:3.30.160.60:FF:002633', NULL, NULL, 'Zinc finger protein 57', NULL, NULL, NULL, NULL, NULL, 4),
(137320, NULL, 'G3DSA:1.10.8.10:FF:000286', NULL, NULL, 'Vacuolar protein sorting-associated protein 13D', NULL, NULL, NULL, NULL, NULL, 4),
(137321, NULL, 'G3DSA:3.20.20.70:FF:000457', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137322, NULL, 'G3DSA:3.40.50.10420:FF:000025', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(137323, NULL, 'G3DSA:2.10.80.10:FF:000002', NULL, NULL, 'prokineticin-2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(137324, NULL, 'G3DSA:3.30.2130.30:FF:000003', NULL, NULL, 'Probable tRNA sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(137325, NULL, 'G3DSA:1.20.1250.20:FF:002379', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(137326, NULL, 'G3DSA:1.10.287.4280:FF:000003', NULL, NULL, 'Transcription factor COE2', NULL, NULL, NULL, NULL, NULL, 4),
(137327, NULL, 'G3DSA:3.90.940.10:FF:000006', NULL, NULL, 'DNA-directed RNA polymerase subunit I, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137328, NULL, 'G3DSA:3.30.465.10:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137329, NULL, 'G3DSA:2.60.120.200:FF:000514', NULL, NULL, 'Beta-glycan assembly-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(137330, NULL, 'G3DSA:1.50.10.20:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137331, NULL, 'G3DSA:3.40.50.720:FF:000787', NULL, NULL, 'L-2-aminoadipate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(137332, NULL, 'G3DSA:1.25.40.10:FF:004044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(137333, NULL, 'G3DSA:3.40.50.12780:FF:000070', NULL, NULL, 'YOR093C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(137334, NULL, 'G3DSA:3.10.170.20:FF:000007', NULL, NULL, 'Leishmanolysin-like peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(137335, NULL, 'G3DSA:3.90.1100.10:FF:000009', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(137336, NULL, 'G3DSA:3.40.1810.10:FF:000070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137337, NULL, 'G3DSA:3.40.1000.50:FF:000020', NULL, NULL, 'Transcription regulator', NULL, NULL, NULL, NULL, NULL, 4),
(137338, NULL, 'G3DSA:3.30.70.330:FF:002767', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137339, NULL, 'G3DSA:3.40.50.150:FF:001875', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137340, NULL, 'G3DSA:3.30.830.10:FF:000130', NULL, NULL, 'Protease, insulinase family/protease, insulinase family', NULL, NULL, NULL, NULL, NULL, 4),
(137341, NULL, 'G3DSA:2.60.40.60:FF:000821', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137342, NULL, 'G3DSA:3.40.50.300:FF:006288', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(137343, NULL, 'G3DSA:3.30.160.60:FF:004573', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137344, NULL, 'G3DSA:3.30.70.2130:FF:000003', NULL, NULL, 'Phosphoglycerate mutase, 2,3-bisphosphoglycerate-independent, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137345, NULL, 'G3DSA:1.10.472.10:FF:000253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137346, NULL, 'G3DSA:1.10.287.70:FF:000060', NULL, NULL, 'Sodium leak channel non-selective protein', NULL, NULL, NULL, NULL, NULL, 4),
(137347, NULL, 'G3DSA:2.60.120.200:FF:000019', NULL, NULL, 'MAM domain containing glycosylphosphatidylinositol anchor 2', NULL, NULL, NULL, NULL, NULL, 4),
(137348, NULL, 'G3DSA:1.25.40.20:FF:001444', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137349, NULL, 'G3DSA:3.30.420.40:FF:000299', NULL, NULL, 'Actin-related protein 3C', NULL, NULL, NULL, NULL, NULL, 4),
(137350, NULL, 'G3DSA:3.10.100.10:FF:000023', NULL, NULL, 'Macrophage mannose receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(137351, NULL, 'G3DSA:3.30.2260.10:FF:000001', NULL, NULL, 'Enhancer of rudimentary homolog', NULL, NULL, NULL, NULL, NULL, 4),
(137352, NULL, 'G3DSA:3.20.20.80:FF:000258', NULL, NULL, 'Endo-1,4-beta-xylanase A', NULL, NULL, NULL, NULL, NULL, 4),
(137353, NULL, 'G3DSA:2.60.40.150:FF:000383', NULL, NULL, 'Helicase', NULL, NULL, NULL, NULL, NULL, 4),
(137354, NULL, 'G3DSA:2.30.30.10:FF:000004', NULL, NULL, 'Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(137355, NULL, 'G3DSA:3.30.420.80:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137356, NULL, 'G3DSA:3.40.367.20:FF:000008', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(137357, NULL, 'G3DSA:2.40.30.30:FF:000026', NULL, NULL, 'Riboflavin biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(137358, NULL, 'G3DSA:3.30.2340.10:FF:000002', NULL, NULL, 'tRNA pseudouridine synthase D', NULL, NULL, NULL, NULL, NULL, 4),
(137359, NULL, 'G3DSA:1.10.565.10:FF:000025', NULL, NULL, 'Nuclear receptor subfamily 1 group I member 3', NULL, NULL, NULL, NULL, NULL, 4),
(137360, NULL, 'G3DSA:2.60.200.20:FF:000138', NULL, NULL, 'Adenylyl cyclase class-3/4/guanylyl cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(137361, NULL, 'G3DSA:2.160.10.10:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137362, NULL, 'G3DSA:2.60.40.10:FF:006074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137363, NULL, 'G3DSA:3.40.50.2000:FF:001086', NULL, NULL, 'Soluble starch synthase', NULL, NULL, NULL, NULL, NULL, 4),
(137364, NULL, 'G3DSA:3.40.50.300:FF:003831', NULL, NULL, 'DNA helicase INO80', NULL, NULL, NULL, NULL, NULL, 4),
(137365, NULL, 'G3DSA:1.10.30.10:FF:000092', NULL, NULL, 'High mobility group B protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(137366, NULL, 'G3DSA:3.40.630.20:FF:000014', NULL, NULL, 'Pyroglutamyl-peptidase I', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(137367, NULL, 'G3DSA:1.10.287.110:FF:000010', NULL, NULL, 'Molecular chaperone DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(137368, NULL, 'G3DSA:3.90.70.10:FF:000041', NULL, NULL, 'Inactive ubiquitin carboxyl-terminal hydrolase 53', NULL, NULL, NULL, NULL, NULL, 4),
(137369, NULL, 'G3DSA:3.90.640.10:FF:000017', NULL, NULL, 'Actin-related protein 10 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(137370, NULL, 'G3DSA:3.30.70.270:FF:000254', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137371, NULL, 'G3DSA:1.10.1450.10:FF:000095', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(137372, NULL, 'G3DSA:2.40.10.10:FF:000688', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137373, NULL, 'G3DSA:1.25.40.180:FF:000228', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137374, NULL, 'G3DSA:3.80.10.10:FF:000150', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(137375, NULL, 'G3DSA:1.25.40.530:FF:000002', NULL, NULL, 'Unconventional myosin-VIIa', NULL, NULL, NULL, NULL, NULL, 4),
(137376, NULL, 'G3DSA:2.60.40.150:FF:000467', NULL, NULL, 'Phosphatidylserine decarboxylase proenzyme 2', NULL, NULL, NULL, NULL, NULL, 4),
(137377, NULL, 'G3DSA:1.25.40.10:FF:000334', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(137378, NULL, 'G3DSA:1.25.40.20:FF:001500', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137379, NULL, 'G3DSA:2.40.70.10:FF:000225', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(137380, NULL, 'G3DSA:1.10.510.10:FF:002068', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137381, NULL, 'G3DSA:1.10.287.130:FF:000016', NULL, NULL, 'Aerobic respiration control sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(137382, NULL, 'G3DSA:3.30.505.10:FF:000133', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(137383, NULL, 'G3DSA:3.30.505.10:FF:000077', NULL, NULL, 'Tyrosine-protein kinase Lck', NULL, NULL, NULL, NULL, NULL, 4),
(137384, NULL, 'G3DSA:3.30.1600.10:FF:000011', NULL, NULL, 'NAD-dependent protein deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(137385, NULL, 'G3DSA:1.10.10.10:FF:001815', NULL, NULL, 'Catabolite gene activator', NULL, NULL, NULL, NULL, NULL, 4),
(137386, NULL, 'G3DSA:1.20.1280.50:FF:000097', NULL, NULL, 'Mitochondria-associated F-box protein', NULL, NULL, NULL, NULL, NULL, 4),
(137387, NULL, 'G3DSA:1.10.510.10:FF:002416', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137388, NULL, 'G3DSA:1.10.287.130:FF:000201', NULL, NULL, 'Phosphate regulon sensor protein PhoR (SphS)', NULL, NULL, NULL, NULL, NULL, 4),
(137389, NULL, 'G3DSA:2.10.110.10:FF:000090', NULL, NULL, 'LIM domain kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(137390, NULL, 'G3DSA:3.30.230.10:FF:000106', NULL, NULL, 'Ribonuclease P protein component', NULL, NULL, NULL, NULL, NULL, 4),
(137391, NULL, 'G3DSA:2.30.30.140:FF:000289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137392, NULL, 'G3DSA:3.20.20.210:FF:000020', NULL, NULL, 'Uroporphyrinogen decarboxylase 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(137393, NULL, 'G3DSA:3.80.10.10:FF:003399', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(137394, NULL, 'G3DSA:2.170.140.10:FF:000008', NULL, NULL, 'Gasp, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(137395, NULL, 'G3DSA:1.10.238.10:FF:000018', NULL, NULL, 'Actinin, alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(137396, NULL, 'G3DSA:2.130.10.10:FF:001583', NULL, NULL, 'Autophagy-related protein 18a', NULL, NULL, NULL, NULL, NULL, 4),
(137397, NULL, 'G3DSA:3.30.60.30:FF:000184', NULL, NULL, 'Follistatin-like 3 (secreted glycoprotein)', NULL, NULL, NULL, NULL, NULL, 4),
(137398, NULL, 'G3DSA:3.40.50.10130:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137399, NULL, 'G3DSA:2.60.120.330:FF:000210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137400, NULL, 'G3DSA:3.30.160.60:FF:003645', NULL, NULL, 'LD40944p', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(137401, NULL, 'G3DSA:1.10.472.10:FF:000197', NULL, NULL, 'Transcription initiation factor IIB', NULL, NULL, NULL, NULL, NULL, 4),
(137402, NULL, 'G3DSA:1.10.10.10:FF:001490', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137403, NULL, 'G3DSA:3.60.10.10:FF:000336', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137404, NULL, 'G3DSA:1.10.287.3510:FF:000008', NULL, NULL, 'NADH dehydrogenase subunit 4L', NULL, NULL, NULL, NULL, NULL, 4),
(137405, NULL, 'G3DSA:2.60.40.820:FF:000039', NULL, NULL, 'Protein CBR-WHT-8', NULL, NULL, NULL, NULL, NULL, 4),
(137406, NULL, 'G3DSA:2.60.40.1180:FF:000195', NULL, NULL, 'Alpha-amylase SusG', NULL, NULL, NULL, NULL, NULL, 4),
(137407, NULL, 'G3DSA:3.30.40.10:FF:001901', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137408, NULL, 'G3DSA:3.80.10.10:FF:004332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137409, NULL, 'G3DSA:3.40.50.360:FF:000044', NULL, NULL, 'Protein NrdI', NULL, NULL, NULL, NULL, NULL, 4),
(137410, NULL, 'G3DSA:1.10.238.10:FF:001002', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(137411, NULL, 'G3DSA:3.90.180.10:FF:000122', NULL, NULL, 'Lovastatin nonaketide synthase, enoyl reductase component', NULL, NULL, NULL, NULL, NULL, 4),
(137412, NULL, 'G3DSA:3.40.710.10:FF:000102', NULL, NULL, 'Membrane carboxypeptidase/penicillin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(137413, NULL, 'G3DSA:3.30.2380.10:FF:000004', NULL, NULL, 'EKC/KEOPS complex subunit CGI121', NULL, NULL, NULL, NULL, NULL, 4),
(137414, NULL, 'G3DSA:1.25.40.420:FF:000025', NULL, NULL, 'Leucine-zipper-like transcription regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(137415, NULL, 'G3DSA:3.80.10.10:FF:003932', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(137416, NULL, 'G3DSA:3.30.70.330:FF:002211', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137417, NULL, 'G3DSA:1.10.533.10:FF:000215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137418, NULL, 'G3DSA:1.20.1070.10:FF:000479', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(137419, NULL, 'G3DSA:3.30.70.330:FF:002239', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137420, NULL, 'G3DSA:3.30.1520.10:FF:000010', NULL, NULL, 'PX domain-containing protein kinase-like protein isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(137421, NULL, 'G3DSA:1.25.40.10:FF:002099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137422, NULL, 'G3DSA:2.60.120.260:FF:000397', NULL, NULL, 'E3 ubiquitin-protein ligase HERC2', NULL, NULL, NULL, NULL, NULL, 4),
(137423, NULL, 'G3DSA:3.30.70.980:FF:000051', NULL, NULL, 'Mitochondrion protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137424, NULL, 'G3DSA:1.20.1740.10:FF:000160', NULL, NULL, 'Amino acid permease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(137425, NULL, 'G3DSA:3.30.710.10:FF:000508', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(137426, NULL, 'G3DSA:3.30.70.330:FF:001839', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137427, NULL, 'G3DSA:3.30.420.110:FF:000033', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(137428, NULL, 'G3DSA:3.30.230.10:FF:000073', NULL, NULL, 'DNA gyrase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(137429, NULL, 'G3DSA:1.10.287.70:FF:000144', NULL, NULL, 'Calcium-activated potassium channel slo-1', NULL, NULL, NULL, NULL, NULL, 4),
(137430, NULL, 'G3DSA:2.60.40.4060:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137431, NULL, 'G3DSA:2.60.40.10:FF:005146', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137432, NULL, 'G3DSA:3.90.640.10:FF:000080', NULL, NULL, 'Actin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137433, NULL, 'G3DSA:2.40.50.140:FF:000364', NULL, NULL, 'Putative Aspartyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(137434, NULL, 'G3DSA:3.30.60.30:FF:000037', NULL, NULL, 'Ovomucoid', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(137435, NULL, 'G3DSA:1.10.3080.10:FF:000078', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(137436, NULL, 'G3DSA:3.40.50.1000:FF:000426', NULL, NULL, 'GD13364', NULL, NULL, NULL, NULL, NULL, 4),
(137437, NULL, 'G3DSA:1.10.10.10:FF:000854', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(137438, NULL, 'G3DSA:3.40.250.10:FF:000111', NULL, NULL, 'Si:dkey-175m17.7', NULL, NULL, NULL, NULL, NULL, 4),
(137439, NULL, 'G3DSA:3.40.50.300:FF:008502', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137440, NULL, 'G3DSA:3.30.70.240:FF:000003', NULL, NULL, 'Translation elongation factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(137441, NULL, 'G3DSA:3.80.10.10:FF:000526', NULL, NULL, 'Thyroid stimulating hormone receptor', NULL, NULL, NULL, NULL, NULL, 4),
(137442, NULL, 'G3DSA:3.40.630.10:FF:000129', NULL, NULL, 'Putative aminoacyl-histidine dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(137443, NULL, 'G3DSA:3.80.10.10:FF:002948', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137444, NULL, 'G3DSA:3.20.20.80:FF:000786', NULL, NULL, 'Glycosyl hydrolase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(137445, NULL, 'G3DSA:2.30.30.30:FF:000015', NULL, NULL, 'E3 ubiquitin-protein ligase HERC2', NULL, NULL, NULL, NULL, NULL, 4),
(137446, NULL, 'G3DSA:1.25.70.10:FF:000015', NULL, NULL, 'Mitochondrial transcription termination factor family protein', NULL, NULL, NULL, NULL, NULL, 4),
(137447, NULL, 'G3DSA:2.130.10.10:FF:003033', NULL, NULL, 'Protein NEDD1', NULL, NULL, NULL, NULL, NULL, 4),
(137448, NULL, 'G3DSA:1.25.40.20:FF:000516', NULL, NULL, 'Ankyrin repeat-containing protein C6C3.08', NULL, NULL, NULL, NULL, NULL, 4),
(137449, NULL, 'G3DSA:2.30.39.10:FF:000001', NULL, NULL, 'Serpin family B member 2', NULL, NULL, NULL, NULL, NULL, 4),
(137450, NULL, 'G3DSA:3.40.50.1820:FF:000464', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(137451, NULL, 'G3DSA:3.40.50.300:FF:006557', NULL, NULL, 'Thymidine kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(137452, NULL, 'G3DSA:3.30.710.10:FF:000003', NULL, NULL, 'BTB/POZ domain-containing protein KCTD6 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(137453, NULL, 'G3DSA:1.25.40.10:FF:002751', NULL, NULL, 'Est1p', NULL, NULL, NULL, NULL, NULL, 4),
(137454, NULL, 'G3DSA:2.10.70.80:FF:000005', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(137455, NULL, 'G3DSA:2.20.70.10:FF:000271', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(137456, NULL, 'G3DSA:1.20.140.10:FF:000025', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(137457, NULL, 'G3DSA:3.30.40.10:FF:001716', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(137458, NULL, 'G3DSA:1.20.1440.100:FF:000017', NULL, NULL, 'Gll3211 protein', NULL, NULL, NULL, NULL, NULL, 4),
(137459, NULL, 'G3DSA:2.60.40.1180:FF:000228', NULL, NULL, 'Alpha-galactosidase mel1', NULL, NULL, NULL, NULL, NULL, 4),
(137460, NULL, 'G3DSA:3.30.70.80:FF:000036', NULL, NULL, 'Peptidase S8/S53 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(137461, NULL, 'G3DSA:1.20.120.330:FF:000001', NULL, NULL, 'focal adhesion kinase 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(137462, NULL, 'G3DSA:3.80.10.10:FF:001931', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137463, NULL, 'G3DSA:3.40.50.300:FF:006613', NULL, NULL, 'Os11g0303400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(137464, NULL, 'G3DSA:1.10.1520.10:FF:000067', NULL, NULL, 'Ribonuclease 3 1', NULL, NULL, NULL, NULL, NULL, 4),
(137465, NULL, 'G3DSA:2.60.120.260:FF:000110', NULL, NULL, 'Peptide-N(4)-(N-acetyl-beta-glucosaminyl)asparagine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(137466, NULL, 'G3DSA:3.10.660.10:FF:000020', NULL, NULL, 'DnaJ homolog subfamily C member 24-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(137467, NULL, 'G3DSA:3.55.50.60:FF:000001', NULL, NULL, 'DotD', NULL, NULL, NULL, NULL, NULL, 4),
(137468, NULL, 'G3DSA:3.40.50.300:FF:007069', NULL, NULL, 'AFR389Cp', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(137469, NULL, 'G3DSA:3.90.660.10:FF:000108', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137470, NULL, 'G3DSA:3.40.50.2020:FF:000131', NULL, NULL, 'Hypoxanthine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(137471, NULL, 'G3DSA:2.60.120.650:FF:000244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137472, NULL, 'G3DSA:2.60.40.1930:FF:000021', NULL, NULL, 'Thioester-containing protein 4, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(137473, NULL, 'G3DSA:3.90.190.10:FF:000527', NULL, NULL, 'Receptor tyrosine phosphatase type r2b, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137474, NULL, 'G3DSA:3.30.9.10:FF:000290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137475, NULL, 'G3DSA:2.70.170.10:FF:000293', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137476, NULL, 'G3DSA:2.40.30.10:FF:000251', NULL, NULL, 'Ferric reduction oxidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(137477, NULL, 'G3DSA:3.40.50.11660:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137478, NULL, 'G3DSA:3.10.20.90:FF:000604', NULL, NULL, 'Polyubiquitin 8', NULL, NULL, NULL, NULL, NULL, 4),
(137479, NULL, 'G3DSA:3.40.50.10860:FF:000050', NULL, NULL, 'Bifunctional protein FolD 2', NULL, NULL, NULL, NULL, NULL, 4),
(137480, NULL, 'G3DSA:3.10.20.90:FF:000548', NULL, NULL, 'protein DDI1 homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(137481, NULL, 'G3DSA:3.30.160.60:FF:005118', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137482, NULL, 'G3DSA:1.10.1520.10:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137483, NULL, 'G3DSA:1.25.40.20:FF:001175', NULL, NULL, 'LOW QUALITY PROTEIN: kinase D-interacting substrate of 220 kDa B-like', NULL, NULL, NULL, NULL, NULL, 4),
(137484, NULL, 'G3DSA:2.60.120.970:FF:000082', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(137485, NULL, 'G3DSA:2.30.30.40:FF:000552', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137486, NULL, 'G3DSA:2.10.110.10:FF:000207', NULL, NULL, 'GM16078', NULL, NULL, NULL, NULL, NULL, 4),
(137487, NULL, 'G3DSA:3.40.50.2020:FF:000075', NULL, NULL, 'Adenine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(137488, NULL, 'G3DSA:3.40.50.1000:FF:000393', NULL, NULL, 'WGS project CABT00000000 data, contig 2.7', NULL, NULL, NULL, NULL, NULL, 4),
(137489, NULL, 'G3DSA:3.30.420.40:FF:000568', NULL, NULL, 'Glycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(137490, NULL, 'G3DSA:1.20.1050.80:FF:000009', NULL, NULL, 'VPS9 domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137491, NULL, 'G3DSA:3.40.630.30:FF:000635', NULL, NULL, 'Acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137492, NULL, 'G3DSA:3.80.10.10:FF:004096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137493, NULL, 'G3DSA:2.60.34.20:FF:000003', NULL, NULL, 'AAR2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(137494, NULL, 'G3DSA:2.130.10.10:FF:000919', NULL, NULL, 'Actin-related protein 2/3 complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(137495, NULL, 'G3DSA:3.10.28.10:FF:000008', NULL, NULL, 'Homothallism endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(137496, NULL, 'G3DSA:1.20.1050.10:FF:000208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137497, NULL, 'G3DSA:3.40.50.620:FF:000139', NULL, NULL, 'Multidrug MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(137498, NULL, 'G3DSA:2.10.50.30:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137499, NULL, 'G3DSA:1.10.10.60:FF:000908', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137500, NULL, 'G3DSA:1.25.40.20:FF:000663', NULL, NULL, 'Ankyrin repeat, SAM and basic leucine zipper domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(137501, NULL, 'G3DSA:3.30.1390.20:FF:000013', NULL, NULL, 'Rlp7p', NULL, NULL, NULL, NULL, NULL, 4),
(137502, NULL, 'G3DSA:2.80.10.50:FF:000265', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(137503, NULL, 'G3DSA:3.30.430.20:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137504, NULL, 'G3DSA:3.50.30.30:FF:000046', NULL, NULL, 'Subtilisin-like protease SBT2.5', NULL, NULL, NULL, NULL, NULL, 4),
(137505, NULL, 'G3DSA:6.10.140.2220:FF:000076', NULL, NULL, 'SET and MYND domain containing 1a', NULL, NULL, NULL, NULL, NULL, 4),
(137506, NULL, 'G3DSA:3.30.70.270:FF:000023', NULL, NULL, 'Pol', NULL, NULL, NULL, NULL, NULL, 4),
(137507, NULL, 'G3DSA:1.10.8.270:FF:000025', NULL, NULL, 'TBC1 domain family member 15-like', NULL, NULL, NULL, NULL, NULL, 4),
(137508, NULL, 'G3DSA:2.60.40.10:FF:003016', NULL, NULL, 'AGAP009947-PA', NULL, NULL, NULL, NULL, NULL, 4),
(137509, NULL, 'G3DSA:1.25.10.10:FF:001759', NULL, NULL, 'Protein Mo25', NULL, NULL, NULL, NULL, NULL, 4),
(137510, NULL, 'G3DSA:1.10.510.10:FF:004013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137511, NULL, 'G3DSA:3.40.50.720:FF:001276', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(137512, NULL, 'G3DSA:2.60.40.10:FF:002504', NULL, NULL, 'Unc-40 protein', NULL, NULL, NULL, NULL, NULL, 4),
(137513, NULL, 'G3DSA:2.30.30.40:FF:000024', NULL, NULL, 'Intersectin 1', NULL, NULL, NULL, NULL, NULL, 4),
(137514, NULL, 'G3DSA:3.30.870.10:FF:000020', NULL, NULL, 'Tyrosyl-DNA phosphodiesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(137515, NULL, 'G3DSA:3.30.160.60:FF:003937', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137516, NULL, 'G3DSA:3.40.30.10:FF:000501', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(137517, NULL, 'G3DSA:2.10.50.10:FF:000085', NULL, NULL, 'Nerve growth factor receptor b', NULL, NULL, NULL, NULL, NULL, 4),
(137518, NULL, 'G3DSA:2.60.120.10:FF:000483', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137519, NULL, 'G3DSA:3.30.160.60:FF:003561', NULL, NULL, 'Zinc finger protein 529', NULL, NULL, NULL, NULL, NULL, 4),
(137520, NULL, 'G3DSA:1.20.58.70:FF:000043', NULL, NULL, 'Syntaxin, Qa-SNARE family', NULL, NULL, NULL, NULL, NULL, 4),
(137521, NULL, 'G3DSA:3.40.50.300:FF:004848', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(137522, NULL, 'G3DSA:1.25.40.10:FF:001115', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(137523, NULL, 'G3DSA:3.40.30.10:FF:000445', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(137524, NULL, 'G3DSA:3.30.470.20:FF:000240', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(137525, NULL, 'G3DSA:3.40.50.300:FF:004904', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137526, NULL, 'G3DSA:1.10.150.250:FF:000007', NULL, NULL, 'Succinate dehydrogenase assembly factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(137527, NULL, 'G3DSA:1.25.40.10:FF:004460', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137528, NULL, 'G3DSA:1.25.40.10:FF:004836', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137529, NULL, 'G3DSA:3.20.20.100:FF:000038', NULL, NULL, 'Aldo/keto reductase', NULL, NULL, NULL, NULL, NULL, 4),
(137530, NULL, 'G3DSA:1.10.510.10:FF:003344', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137531, NULL, 'G3DSA:3.80.10.10:FF:003584', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137532, NULL, 'G3DSA:3.20.20.100:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137533, NULL, 'G3DSA:3.30.70.330:FF:002683', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137534, NULL, 'G3DSA:1.10.225.10:FF:000011', NULL, NULL, 'Pulmonary surfactant-associated protein B', NULL, NULL, NULL, NULL, NULL, 4),
(137535, NULL, 'G3DSA:3.40.50.620:FF:000667', NULL, NULL, 'RE41093p', NULL, NULL, NULL, NULL, NULL, 4),
(137536, NULL, 'G3DSA:1.20.140.40:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137537, NULL, 'G3DSA:1.20.58.90:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(137538, NULL, 'G3DSA:2.60.40.10:FF:001779', NULL, NULL, 'Cell adhesion molecule L1-like b', NULL, NULL, NULL, NULL, NULL, 4),
(137539, NULL, 'G3DSA:1.25.40.10:FF:001587', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g04860', NULL, NULL, NULL, NULL, NULL, 4),
(137540, NULL, 'G3DSA:1.20.58.830:FF:000039', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(137541, NULL, 'G3DSA:1.10.510.10:FF:000415', NULL, NULL, 'CMGC/CDK/CRK7 protein kinase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(137542, NULL, 'G3DSA:1.25.10.10:FF:000473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137543, NULL, 'G3DSA:1.20.1540.10:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137544, NULL, 'G3DSA:1.10.10.10:FF:000034', NULL, NULL, 'GTP-sensing transcriptional pleiotropic repressor CodY', NULL, NULL, NULL, NULL, NULL, 4),
(137545, NULL, 'G3DSA:3.60.140.10:FF:000003', NULL, NULL, 'Polyphenol oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(137546, NULL, 'G3DSA:3.40.50.150:FF:000386', NULL, NULL, 'DNA (Cytosine-5)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(137547, NULL, 'G3DSA:1.20.1070.10:FF:000535', NULL, NULL, 'Olfactory receptor 1290', NULL, NULL, NULL, NULL, NULL, 4),
(137548, NULL, 'G3DSA:1.20.1080.10:FF:000036', NULL, NULL, 'Probable nitrite transporter', NULL, NULL, NULL, NULL, NULL, 4),
(137549, NULL, 'G3DSA:3.90.320.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137550, NULL, 'G3DSA:3.80.10.10:FF:003112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137551, NULL, 'G3DSA:3.50.50.60:FF:000005', NULL, NULL, 'Rab GDP dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(137552, NULL, 'G3DSA:1.50.40.10:FF:000562', NULL, NULL, 'Mitochondrial carrier protein, putative (AFU_orthologue AFUA_1G09980)', NULL, NULL, NULL, NULL, NULL, 4),
(137553, NULL, 'G3DSA:3.40.33.10:FF:000159', NULL, NULL, 'Predicted extracellular protein', NULL, NULL, NULL, NULL, NULL, 4),
(137554, NULL, 'G3DSA:1.25.10.10:FF:002923', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137555, NULL, 'G3DSA:1.10.287.2250:FF:000006', NULL, NULL, 'Cysteine protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137556, NULL, 'G3DSA:3.40.50.720:FF:002440', NULL, NULL, '3-hydroxyisobutyrate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(137557, NULL, 'G3DSA:1.20.120.160:FF:000017', NULL, NULL, 'Aerobic respiration control sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(137558, NULL, 'G3DSA:1.10.8.100:FF:000020', NULL, NULL, 'Probable ribosomal RNA small subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(137559, NULL, 'G3DSA:3.90.190.10:FF:000151', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase S', NULL, NULL, NULL, NULL, NULL, 4),
(137560, NULL, 'G3DSA:3.40.50.12780:FF:000103', NULL, NULL, '2-succinylbenzoate--CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(137561, NULL, 'G3DSA:3.30.60.20:FF:000040', NULL, NULL, 'Actin polymerization protein Bzz1', NULL, NULL, NULL, NULL, NULL, 4),
(137562, NULL, 'G3DSA:3.40.1620.10:FF:000004', NULL, NULL, 'Antitoxin', NULL, NULL, NULL, NULL, NULL, 4),
(137563, NULL, 'G3DSA:2.30.42.10:FF:000200', NULL, NULL, 'Uncharacterized protein, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(137564, NULL, 'G3DSA:2.130.10.10:FF:002364', NULL, NULL, 'Transcriptional corepressor LEUNIG_HOMOLOG', NULL, NULL, NULL, NULL, NULL, 4),
(137565, NULL, 'G3DSA:3.40.390.10:FF:000273', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137566, NULL, 'G3DSA:3.40.1700.10:FF:000005', NULL, NULL, 'Diadenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(137567, NULL, 'G3DSA:3.30.160.60:FF:003084', NULL, NULL, 'Zinc finger protein 1009', NULL, NULL, NULL, NULL, NULL, 4),
(137568, NULL, 'G3DSA:2.60.120.10:FF:000803', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137569, NULL, 'G3DSA:2.30.30.40:FF:000496', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(137570, NULL, 'G3DSA:3.40.50.300:FF:000633', NULL, NULL, 'ABC transporter A family member 7', NULL, NULL, NULL, NULL, NULL, 4),
(137571, NULL, 'G3DSA:1.10.20.10:FF:000063', NULL, NULL, 'Centromere protein S', NULL, NULL, NULL, NULL, NULL, 4),
(137572, NULL, 'G3DSA:3.30.70.60:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137573, NULL, 'G3DSA:1.10.555.10:FF:000199', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137574, NULL, 'G3DSA:3.30.40.10:FF:000087', NULL, NULL, 'General transcription factor IIE subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(137575, NULL, 'G3DSA:1.20.1050.130:FF:000005', NULL, NULL, 'Glutamate--tRNA ligase cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(137576, NULL, 'G3DSA:3.20.20.70:FF:000401', NULL, NULL, 'Deoxyribose-phosphate aldolase (putative)', NULL, NULL, NULL, NULL, NULL, 4),
(137577, NULL, 'G3DSA:2.30.110.10:FF:000017', NULL, NULL, 'Flavin-dependent monooxygenase, reductase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(137578, NULL, 'G3DSA:3.40.50.1980:FF:000051', NULL, NULL, 'Iron-hydroxamate ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(137579, NULL, 'G3DSA:1.10.287.1490:FF:000059', NULL, NULL, 'Myocilin', NULL, NULL, NULL, NULL, NULL, 4),
(137580, NULL, 'G3DSA:2.60.40.150:FF:000703', NULL, NULL, 'Serine/threonine-protein kinase gad8', NULL, NULL, NULL, NULL, NULL, 4),
(137581, NULL, 'G3DSA:3.30.870.10:FF:000109', NULL, NULL, 'Phospholipase D', NULL, NULL, NULL, NULL, NULL, 4),
(137582, NULL, 'G3DSA:3.30.200.20:FF:000782', NULL, NULL, 'Insulin receptor a', NULL, NULL, NULL, NULL, NULL, 4),
(137583, NULL, 'G3DSA:1.20.1090.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137584, NULL, 'G3DSA:1.25.40.10:FF:004605', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137585, NULL, 'G3DSA:3.40.50.300:FF:002870', NULL, NULL, 'SNF2 family helicase/ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137586, NULL, 'G3DSA:2.130.10.10:FF:005798', NULL, NULL, 'Type II inositol polyphosphate 5-phosphatase 15', NULL, NULL, NULL, NULL, NULL, 4),
(137587, NULL, 'G3DSA:3.90.70.10:FF:000277', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 9', NULL, NULL, NULL, NULL, NULL, 4),
(137588, NULL, 'G3DSA:2.10.25.10:FF:000717', NULL, NULL, 'Merozoite surface protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(137589, NULL, 'G3DSA:3.40.1190.20:FF:000226', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137590, NULL, 'G3DSA:2.40.70.10:FF:000517', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137591, NULL, 'G3DSA:1.10.730.10:FF:000157', NULL, NULL, 'Leucine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(137592, NULL, 'G3DSA:3.30.160.60:FF:000071', NULL, NULL, 'Putative zinc finger protein 143', NULL, NULL, NULL, NULL, NULL, 4),
(137593, NULL, 'G3DSA:2.60.40.60:FF:000552', NULL, NULL, 'Cadherin-related hmr-1', NULL, NULL, NULL, NULL, NULL, 4),
(137594, NULL, 'G3DSA:3.40.50.720:FF:002108', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(137595, NULL, 'G3DSA:3.10.300.10:FF:000004', NULL, NULL, 'Putative 3-methyladenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(137596, NULL, 'G3DSA:2.170.270.10:FF:000164', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(137597, NULL, 'G3DSA:3.30.1010.10:FF:000011', NULL, NULL, 'serine/threonine-protein kinase ATR', NULL, NULL, NULL, NULL, NULL, 4),
(137598, NULL, 'G3DSA:3.30.950.10:FF:000021', NULL, NULL, 'Uroporphyrin-III C-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(137599, NULL, 'G3DSA:2.40.10.10:FF:000396', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137600, NULL, 'G3DSA:3.30.160.60:FF:004342', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137601, NULL, 'G3DSA:3.60.10.10:FF:000044', NULL, NULL, 'Type IV inositol polyphosphate 5-phosphatase 11', NULL, NULL, NULL, NULL, NULL, 4),
(137602, NULL, 'G3DSA:3.30.70.270:FF:000310', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137603, NULL, 'G3DSA:3.90.70.10:FF:000333', NULL, NULL, 'Protein CBG02822', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(137604, NULL, 'G3DSA:3.40.50.1370:FF:000014', NULL, NULL, 'N-acetylornithine carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(137605, NULL, 'G3DSA:2.120.10.80:FF:000300', NULL, NULL, 'Multiple epidermal growth factor-like domains protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(137606, NULL, 'G3DSA:2.130.10.10:FF:002628', NULL, NULL, 'Excision repair cross-complementation group 8', NULL, NULL, NULL, NULL, NULL, 4),
(137607, NULL, 'G3DSA:3.90.1600.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137608, NULL, 'G3DSA:3.30.565.10:FF:000378', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137609, NULL, 'G3DSA:1.10.10.10:FF:001782', NULL, NULL, 'Protein CBR-EFL-2', NULL, NULL, NULL, NULL, NULL, 4),
(137610, NULL, 'G3DSA:3.40.1170.60:FF:000012', NULL, NULL, 'Putative DNA-directed polymerase kappa', NULL, NULL, NULL, NULL, NULL, 4),
(137611, NULL, 'G3DSA:3.30.1120.30:FF:000031', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(137612, NULL, 'G3DSA:2.40.50.140:FF:000656', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(137613, NULL, 'G3DSA:3.30.200.20:FF:002339', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(137614, NULL, 'G3DSA:1.10.10.990:FF:000003', NULL, NULL, 'RecBCD enzyme subunit RecC', NULL, NULL, NULL, NULL, NULL, 4),
(137615, NULL, 'G3DSA:3.40.50.1110:FF:000167', NULL, NULL, 'Phospholipase B1', NULL, NULL, NULL, NULL, NULL, 4),
(137616, NULL, 'G3DSA:1.20.1250.20:FF:000165', NULL, NULL, 'Solute carrier family 22 member 3', NULL, NULL, NULL, NULL, NULL, 4),
(137617, NULL, 'G3DSA:3.30.160.60:FF:002717', NULL, NULL, 'Zinc finger protein 217', NULL, NULL, NULL, NULL, NULL, 4),
(137618, NULL, 'G3DSA:1.20.1070.10:FF:001940', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(137619, NULL, 'G3DSA:1.20.1070.10:FF:000007', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(137620, NULL, 'G3DSA:1.10.238.10:FF:000985', NULL, NULL, 'Mitochondrial Rho GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(137621, NULL, 'G3DSA:3.40.50.300:FF:002718', NULL, NULL, 'Unplaced genomic scaffold supercont1.38, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(137622, NULL, 'G3DSA:1.10.287.70:FF:000621', NULL, NULL, 'Protein CBR-KQT-2', NULL, NULL, NULL, NULL, NULL, 4),
(137623, NULL, 'G3DSA:3.40.50.1820:FF:000520', NULL, NULL, 'Thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(137624, NULL, 'G3DSA:1.25.40.10:FF:004549', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137625, NULL, 'G3DSA:1.25.10.10:FF:002979', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137626, NULL, 'G3DSA:3.40.50.1440:FF:000058', NULL, NULL, 'Cell division protein FtsZ', NULL, NULL, NULL, NULL, NULL, 4),
(137627, NULL, 'G3DSA:3.40.50.20:FF:000073', NULL, NULL, 'Lysine biosynthesis enzyme LysX', NULL, NULL, NULL, NULL, NULL, 4),
(137628, NULL, 'G3DSA:2.120.10.30:FF:000274', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(137629, NULL, 'G3DSA:2.60.40.10:FF:002184', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(137630, NULL, 'G3DSA:3.40.50.300:FF:000397', NULL, NULL, 'Probable ATP-dependent RNA helicase DDX4', NULL, NULL, NULL, NULL, NULL, 4),
(137631, NULL, 'G3DSA:1.10.510.10:FF:002832', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137632, NULL, 'G3DSA:2.60.40.10:FF:005938', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137633, NULL, 'G3DSA:1.10.510.10:FF:004272', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137634, NULL, 'G3DSA:2.10.50.10:FF:000141', NULL, NULL, 'CD27 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(137635, NULL, 'G3DSA:3.80.10.10:FF:003640', NULL, NULL, 'Os08g0203400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(137636, NULL, 'G3DSA:3.40.50.720:FF:000023', NULL, NULL, 'Ketol-acid reductoisomerase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(137637, NULL, 'G3DSA:2.60.120.10:FF:000747', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137638, NULL, 'G3DSA:3.40.50.1000:FF:000134', NULL, NULL, 'Glycerol-3-phosphate 2-O-acyltransferase 6', NULL, NULL, NULL, NULL, NULL, 4),
(137639, NULL, 'G3DSA:1.10.10.10:FF:000562', NULL, NULL, 'Unplaced genomic scaffold supercont1.16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(137640, NULL, 'G3DSA:3.40.50.300:FF:005776', NULL, NULL, 'Adenylyl cyclase class-3/4/guanylyl cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(137641, NULL, 'G3DSA:2.60.40.10:FF:000559', NULL, NULL, 'Uncharacterized protein, isoform J', NULL, NULL, NULL, NULL, NULL, 4),
(137642, NULL, 'G3DSA:3.40.395.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137643, NULL, 'G3DSA:1.20.1250.10:FF:000105', NULL, NULL, 'Leptin', NULL, NULL, NULL, NULL, NULL, 4),
(137644, NULL, 'G3DSA:3.40.50.10190:FF:000001', NULL, NULL, 'Replication factor C subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(137645, NULL, 'G3DSA:3.30.70.1660:FF:000019', NULL, NULL, 'Mitochondrial translation release factor', NULL, NULL, NULL, NULL, NULL, 4),
(137646, NULL, 'G3DSA:3.30.40.10:FF:000412', NULL, NULL, 'Putative lysine-specific demethylase 5b', NULL, NULL, NULL, NULL, NULL, 4),
(137647, NULL, 'G3DSA:3.30.470.30:FF:000006', NULL, NULL, 'Cap methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(137648, NULL, 'G3DSA:1.25.40.20:FF:000808', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137649, NULL, 'G3DSA:3.30.420.40:FF:001024', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(137650, NULL, 'G3DSA:2.120.10.30:FF:000307', NULL, NULL, 'Peptidylglycine alpha-amidating monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(137651, NULL, 'G3DSA:3.10.100.10:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137652, NULL, 'G3DSA:3.40.50.620:FF:000291', NULL, NULL, 'Probable nicotinate-nucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(137653, NULL, 'G3DSA:1.10.110.10:FF:000014', NULL, NULL, 'Protein ARABIDOPSIS THALIANA ANTHER 7', NULL, NULL, NULL, NULL, NULL, 4),
(137654, NULL, 'G3DSA:3.30.230.130:FF:000080', NULL, NULL, 'Anaphase-promoting complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(137655, NULL, 'G3DSA:3.40.630.30:FF:000579', NULL, NULL, 'Protein GTLF3B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137656, NULL, 'G3DSA:1.10.510.10:FF:003288', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137657, NULL, 'G3DSA:1.20.120.290:FF:000005', NULL, NULL, 'ECA1 (ER-TYPE CA2+-ATPASE 1)', NULL, NULL, NULL, NULL, NULL, 4),
(137658, NULL, 'G3DSA:3.30.420.40:FF:000624', NULL, NULL, 'Nucleoside triphosphate diphosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(137659, NULL, 'G3DSA:3.30.160.60:FF:002156', NULL, NULL, 'REgulator of Fusion', NULL, NULL, NULL, NULL, NULL, 4),
(137660, NULL, 'G3DSA:1.25.40.10:FF:000862', NULL, NULL, 'Tetratricopeptide repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(137661, NULL, 'G3DSA:3.40.50.300:FF:002342', NULL, NULL, 'ATP-dependent DNA helicase UvrD', NULL, NULL, NULL, NULL, NULL, 4),
(137662, NULL, 'G3DSA:3.30.200.20:FF:002491', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(137663, NULL, 'G3DSA:1.10.3430.10:FF:000004', NULL, NULL, 'Ammonium transporter', NULL, NULL, NULL, NULL, NULL, 4),
(137664, NULL, 'G3DSA:1.10.3480.10:FF:000007', NULL, NULL, 'Nitrate reductase delta subunit (NarJ)', NULL, NULL, NULL, NULL, NULL, 4),
(137665, NULL, 'G3DSA:1.20.1270.460:FF:000001', NULL, NULL, 'protein lin-7 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(137666, NULL, 'G3DSA:3.40.50.11850:FF:000004', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(137667, NULL, 'G3DSA:1.10.1900.40:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137668, NULL, 'G3DSA:3.40.50.2000:FF:000389', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(137669, NULL, 'G3DSA:1.10.274.30:FF:000006', NULL, NULL, 'Eaf3p', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(137670, NULL, 'G3DSA:3.30.200.20:FF:000254', NULL, NULL, 'Serine/threonine-protein kinase cot-1', NULL, NULL, NULL, NULL, NULL, 4),
(137671, NULL, 'G3DSA:3.30.70.1230:FF:000155', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(137672, NULL, 'G3DSA:3.90.1150.10:FF:000428', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(137673, NULL, 'G3DSA:3.90.550.10:FF:000050', NULL, NULL, 'hyaluronan synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(137674, NULL, 'G3DSA:3.30.310.210:FF:000004', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137675, NULL, 'G3DSA:2.60.210.10:FF:000069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137676, NULL, 'G3DSA:1.20.1020.10:FF:000004', NULL, NULL, 'BTB/POZ and TAZ domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(137677, NULL, 'G3DSA:3.20.20.300:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137678, NULL, 'G3DSA:3.40.140.10:FF:000142', NULL, NULL, 'Sulfur carrier protein FdhD', NULL, NULL, NULL, NULL, NULL, 4),
(137679, NULL, 'G3DSA:1.20.1250.20:FF:000726', NULL, NULL, 'DUF895 domain membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(137680, NULL, 'G3DSA:3.30.420.210:FF:000006', NULL, NULL, 'UBX domain protein 2A', NULL, NULL, NULL, NULL, NULL, 4),
(137681, NULL, 'G3DSA:1.10.510.10:FF:003849', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137682, NULL, 'G3DSA:3.30.420.40:FF:000804', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137683, NULL, 'G3DSA:1.20.1440.230:FF:000005', NULL, NULL, '[Fe] hydrogenase, HymB subunit', NULL, NULL, NULL, NULL, NULL, 4),
(137684, NULL, 'G3DSA:4.10.240.10:FF:000198', NULL, NULL, 'Uncharacterized transcriptional regulatory protein C139.03', NULL, NULL, NULL, NULL, NULL, 4),
(137685, NULL, 'G3DSA:3.50.50.60:FF:000713', NULL, NULL, 'FAD-dependent urate hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(137686, NULL, 'G3DSA:3.40.50.300:FF:002398', NULL, NULL, 'Trehalose 2-sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(137687, NULL, 'G3DSA:3.40.50.300:FF:001414', NULL, NULL, 'Terminase DNA packaging enzyme large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(137688, NULL, 'G3DSA:3.30.1180.20:FF:000003', NULL, NULL, 'triokinase/FMN cyclase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(137689, NULL, 'G3DSA:3.40.50.720:FF:001512', NULL, NULL, '3-oxoacyl-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(137690, NULL, 'G3DSA:1.25.10.10:FF:000506', NULL, NULL, 'armadillo repeat-containing protein 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(137691, NULL, 'G3DSA:2.130.10.10:FF:000886', NULL, NULL, 'lipopolysaccharide-responsive and beige-like anchor protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(137692, NULL, 'G3DSA:1.20.950.20:FF:000005', NULL, NULL, 'Putative cytochrome b561', NULL, NULL, NULL, NULL, NULL, 4),
(137693, NULL, 'G3DSA:3.30.70.1450:FF:000018', NULL, NULL, 'Potassium transporter TrkA', NULL, NULL, NULL, NULL, NULL, 4),
(137694, NULL, 'G3DSA:3.30.830.10:FF:000219', NULL, NULL, 'Os01g0711100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(137695, NULL, 'G3DSA:1.25.10.10:FF:000978', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(137696, NULL, 'G3DSA:1.10.472.130:FF:000073', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(137697, NULL, 'G3DSA:3.90.190.20:FF:000064', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(137698, NULL, 'G3DSA:1.10.132.70:FF:000026', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(137699, NULL, 'G3DSA:1.20.1560.10:FF:000062', NULL, NULL, 'ABC transporter B family member 6', NULL, NULL, NULL, NULL, NULL, 4),
(137700, NULL, 'G3DSA:3.50.50.60:FF:000657', NULL, NULL, 'Worm AIF (Apoptosis inducing factor) Homolog', NULL, NULL, NULL, NULL, NULL, 4),
(137701, NULL, 'G3DSA:2.130.10.10:FF:003292', NULL, NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', NULL, NULL, NULL, NULL, NULL, 4),
(137702, NULL, 'G3DSA:1.10.640.10:FF:000043', NULL, NULL, 'Protein CBG06977', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(137703, NULL, 'G3DSA:3.40.50.1820:FF:001537', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137704, NULL, 'G3DSA:3.40.50.1100:FF:000074', NULL, NULL, 'Pyridoxal-phosphate dependent protein', NULL, NULL, NULL, NULL, NULL, 4),
(137705, NULL, 'G3DSA:1.25.10.10:FF:002890', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137706, NULL, 'G3DSA:1.10.275.10:FF:000014', NULL, NULL, 'Os03g0824900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(137707, NULL, 'G3DSA:3.40.50.410:FF:000374', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137708, NULL, 'G3DSA:1.10.510.10:FF:001719', NULL, NULL, 'MAP kinase-activated protein kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(137709, NULL, 'G3DSA:2.60.40.2030:FF:000017', NULL, NULL, 'Adhesion G protein-coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(137710, NULL, 'G3DSA:2.10.25.10:FF:000341', NULL, NULL, 'Fibulin 2', NULL, NULL, NULL, NULL, NULL, 4),
(137711, NULL, 'G3DSA:3.30.160.60:FF:004865', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137712, NULL, 'G3DSA:1.25.40.10:FF:001823', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g58590', NULL, NULL, NULL, NULL, NULL, 4),
(137713, NULL, 'G3DSA:2.30.29.30:FF:000237', NULL, NULL, 'pleckstrin homology domain-containing family O member 1', NULL, NULL, NULL, NULL, NULL, 4),
(137714, NULL, 'G3DSA:3.30.200.20:FF:002524', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137715, NULL, 'G3DSA:3.30.572.10:FF:000018', NULL, NULL, 'Bifunctional dihydrofolate reductase-thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(137716, NULL, 'G3DSA:3.40.50.300:FF:007777', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137717, NULL, 'G3DSA:3.50.50.60:FF:000860', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137718, NULL, 'G3DSA:1.25.40.10:FF:003532', NULL, NULL, 'Pre-rRNA processing protein RRP5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137719, NULL, 'G3DSA:2.40.50.580:FF:000001', NULL, NULL, 'Sugar fermentation stimulation protein A', NULL, NULL, NULL, NULL, NULL, 4),
(137720, NULL, 'G3DSA:2.40.160.50:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137721, NULL, 'G3DSA:3.80.10.10:FF:001167', NULL, NULL, 'Chaoptin', NULL, NULL, NULL, NULL, NULL, 4),
(137722, NULL, 'G3DSA:3.40.50.1820:FF:001009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137723, NULL, 'G3DSA:3.40.50.1820:FF:000700', NULL, NULL, 'Putative phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(137724, NULL, 'G3DSA:3.40.50.300:FF:005304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137725, NULL, 'G3DSA:3.40.50.720:FF:000495', NULL, NULL, '3 hydroxysteroid dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137726, NULL, 'G3DSA:1.20.1560.10:FF:000590', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137727, NULL, 'G3DSA:3.40.50.1820:FF:001684', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137728, NULL, 'G3DSA:1.25.10.10:FF:002215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137729, NULL, 'G3DSA:2.130.10.10:FF:004629', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137730, NULL, 'G3DSA:2.40.50.710:FF:000001', NULL, NULL, 'Major envelope glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(137731, NULL, 'G3DSA:3.20.19.10:FF:000009', NULL, NULL, 'Aconitate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(137732, NULL, 'G3DSA:1.25.10.10:FF:003199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137733, NULL, 'G3DSA:1.10.472.10:FF:000484', NULL, NULL, 'Retinoblastoma-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(137734, NULL, 'G3DSA:3.40.1670.10:FF:000007', NULL, NULL, 'UbiD-like decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(137735, NULL, 'G3DSA:1.20.1070.10:FF:001699', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137736, NULL, 'G3DSA:1.10.10.60:FF:000728', NULL, NULL, 'Transcription factor protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(137737, NULL, 'G3DSA:2.40.50.730:FF:000007', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(137738, NULL, 'G3DSA:3.40.50.10810:FF:000260', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(137739, NULL, 'G3DSA:3.30.70.100:FF:000158', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137740, NULL, 'G3DSA:2.30.30.1020:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137741, NULL, 'G3DSA:3.40.50.300:FF:001229', NULL, NULL, 'MAGUK p55 subfamily member 4', NULL, NULL, NULL, NULL, NULL, 4),
(137742, NULL, 'G3DSA:3.40.50.720:FF:000551', NULL, NULL, 'D-aspartate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(137743, NULL, 'G3DSA:3.40.50.2300:FF:000653', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(137744, NULL, 'G3DSA:3.40.50.2300:FF:000092', NULL, NULL, 'Fructose-like phosphotransferase enzyme IIB component 1', NULL, NULL, NULL, NULL, NULL, 4),
(137745, NULL, 'G3DSA:1.10.238.10:FF:000462', NULL, NULL, 'reticulocalbin-2', NULL, NULL, NULL, NULL, NULL, 4),
(137746, NULL, 'G3DSA:1.10.238.10:FF:000838', NULL, NULL, 'Calmodulin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137747, NULL, 'G3DSA:3.30.1640.10:FF:000081', NULL, NULL, 'DNA replication licensing factor Mcm2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(137748, NULL, 'G3DSA:2.60.40.10:FF:000615', NULL, NULL, 'collagen alpha-1(XIV) chain isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(137749, NULL, 'G3DSA:2.40.10.10:FF:000305', NULL, NULL, 'Glandular kallikrein', NULL, NULL, NULL, NULL, NULL, 4),
(137750, NULL, 'G3DSA:1.10.8.10:FF:000342', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137751, NULL, 'G3DSA:3.40.50.300:FF:003359', NULL, NULL, 'Rad50, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(137752, NULL, 'G3DSA:1.10.418.10:FF:000083', NULL, NULL, 'kinesin-like protein KIN-14J isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(137753, NULL, 'G3DSA:3.40.50.200:FF:000193', NULL, NULL, 'Prohormone convertase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137754, NULL, 'G3DSA:3.30.230.120:FF:000015', NULL, NULL, 'Blr5970 protein', NULL, NULL, NULL, NULL, NULL, 4),
(137755, NULL, 'G3DSA:1.25.40.10:FF:002571', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g08210', NULL, NULL, NULL, NULL, NULL, 4),
(137756, NULL, 'G3DSA:3.40.50.10800:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137757, NULL, 'G3DSA:3.30.160.20:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137758, NULL, 'G3DSA:2.30.33.40:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137759, NULL, 'G3DSA:3.30.160.60:FF:000447', NULL, NULL, 'Zinc finger and AT-hook domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(137760, NULL, 'G3DSA:2.130.10.10:FF:000739', NULL, NULL, 'Putative U5 snrnp-specific protein', NULL, NULL, NULL, NULL, NULL, 4),
(137761, NULL, 'G3DSA:2.60.40.420:FF:000043', NULL, NULL, 'Blue copper oxidase CueO', NULL, NULL, NULL, NULL, NULL, 4),
(137762, NULL, 'G3DSA:1.25.40.20:FF:001736', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(137763, NULL, 'G3DSA:2.10.25.10:FF:000009', NULL, NULL, 'Low-density lipoprotein receptor isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(137764, NULL, 'G3DSA:3.10.180.10:FF:000090', NULL, NULL, '4-hydroxyphenylpyruvic acid dioxgenase', NULL, NULL, NULL, NULL, NULL, 4),
(137765, NULL, 'G3DSA:2.130.10.10:FF:004253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137766, NULL, 'G3DSA:2.60.120.260:FF:000633', NULL, NULL, 'Glycoside hydrolase family 3 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(137767, NULL, 'G3DSA:3.90.550.10:FF:000426', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(137768, NULL, 'G3DSA:1.10.418.20:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137769, NULL, 'G3DSA:2.60.60.20:FF:000002', NULL, NULL, 'Arachidonate 5-lipoxygenase a', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(137770, NULL, 'G3DSA:3.30.420.510:FF:000029', NULL, NULL, 'Type II pantothenate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(137771, NULL, 'G3DSA:2.120.10.30:FF:000510', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137772, NULL, 'G3DSA:1.10.460.10:FF:000001', NULL, NULL, 'DNA topoisomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(137773, NULL, 'G3DSA:3.30.565.10:FF:000434', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', NULL, NULL, NULL, NULL, NULL, 4),
(137774, NULL, 'G3DSA:3.40.850.10:FF:000404', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(137775, NULL, 'G3DSA:3.30.160.60:FF:005270', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137776, NULL, 'G3DSA:3.30.200.20:FF:000074', NULL, NULL, 'cyclin-dependent kinase 12 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(137777, NULL, 'G3DSA:2.130.10.10:FF:004814', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(137778, NULL, 'G3DSA:2.40.10.10:FF:000452', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137779, NULL, 'G3DSA:3.40.50.300:FF:005271', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137780, NULL, 'G3DSA:2.10.25.10:FF:001645', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137781, NULL, 'G3DSA:2.130.10.10:FF:000363', NULL, NULL, 'DDB1- and CUL4-associated factor 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(137782, NULL, 'G3DSA:3.20.20.150:FF:000013', NULL, NULL, 'Fructoselysine 3-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(137783, NULL, 'G3DSA:3.30.70.1020:FF:000007', NULL, NULL, 'Trehalose 6-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(137784, NULL, 'G3DSA:1.20.1560.10:FF:000623', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(137785, NULL, 'G3DSA:2.60.40.60:FF:000496', NULL, NULL, 'Cadherin 3', NULL, NULL, NULL, NULL, NULL, 4),
(137786, NULL, 'G3DSA:1.10.10.10:FF:001579', NULL, NULL, 'MurR/RpiR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(137787, NULL, 'G3DSA:3.40.190.10:FF:000292', NULL, NULL, 'GLutamate Receptor family (AMPA)', NULL, NULL, NULL, NULL, NULL, 4),
(137788, NULL, 'G3DSA:3.50.7.10:FF:000072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137789, NULL, 'G3DSA:1.20.5.930:FF:000007', NULL, NULL, 'Integrin alpha L', NULL, NULL, NULL, NULL, NULL, 4),
(137790, NULL, 'G3DSA:3.30.40.10:FF:001429', NULL, NULL, 'Tnf receptor-associated factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(137791, NULL, 'G3DSA:1.10.10.60:FF:000875', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137792, NULL, 'G3DSA:3.30.70.141:FF:000008', NULL, NULL, 'nucleoside diphosphate kinase homolog 5', NULL, NULL, NULL, NULL, NULL, 4),
(137793, NULL, 'G3DSA:1.20.1070.10:FF:001176', NULL, NULL, 'G-protein coupled receptor GRL101-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(137794, NULL, 'G3DSA:3.40.50.2000:FF:000625', NULL, NULL, 'Glycogen [starch] synthase', NULL, NULL, NULL, NULL, NULL, 4),
(137795, NULL, 'G3DSA:3.40.50.2300:FF:000597', NULL, NULL, 'Response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(137796, NULL, 'G3DSA:2.60.40.10:FF:004505', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137797, NULL, 'G3DSA:2.130.10.10:FF:005034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137798, NULL, 'G3DSA:2.60.40.10:FF:004449', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137799, NULL, 'G3DSA:1.25.40.10:FF:002419', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(137800, NULL, 'G3DSA:3.30.1330.30:FF:000097', NULL, NULL, 'RNA methyltransferase, TrmH family, group 3', NULL, NULL, NULL, NULL, NULL, 4),
(137801, NULL, 'G3DSA:3.30.70.330:FF:000030', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein d0 isoform', NULL, NULL, NULL, NULL, NULL, 4),
(137802, NULL, 'G3DSA:2.130.10.10:FF:004106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(137803, NULL, 'G3DSA:1.10.3120.10:FF:000014', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(137804, NULL, 'G3DSA:1.10.287.600:FF:000005', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(137805, NULL, 'G3DSA:1.10.220.150:FF:000056', NULL, NULL, 'YALI0D07524p', NULL, NULL, NULL, NULL, NULL, 4),
(137806, NULL, 'G3DSA:2.30.40.10:FF:000033', NULL, NULL, 'Related to guanine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(137807, NULL, 'G3DSA:1.25.50.20:FF:000017', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(137808, NULL, 'G3DSA:1.20.140.100:FF:000026', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(137809, NULL, 'G3DSA:3.40.50.150:FF:000419', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(137810, NULL, 'G3DSA:2.130.10.10:FF:005742', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137811, NULL, 'G3DSA:2.120.10.80:FF:000064', NULL, NULL, 'Kelch-like family member 31', NULL, NULL, NULL, NULL, NULL, 4),
(137812, NULL, 'G3DSA:2.160.20.10:FF:000205', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(137813, NULL, 'G3DSA:2.40.100.10:FF:000054', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase D', NULL, NULL, NULL, NULL, NULL, 4),
(137814, NULL, 'G3DSA:3.30.160.60:FF:001936', NULL, NULL, 'Zinc finger protein 565', NULL, NULL, NULL, NULL, NULL, 4),
(137815, NULL, 'G3DSA:3.10.110.10:FF:000321', NULL, NULL, 'ubiquitin-conjugating enzyme E2 G1', NULL, NULL, NULL, NULL, NULL, 4),
(137816, NULL, 'G3DSA:3.40.50.300:FF:005124', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(137817, NULL, 'G3DSA:3.40.50.2300:FF:001581', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137818, NULL, 'G3DSA:3.40.50.2000:FF:000445', NULL, NULL, 'UDP-glucoronosyl and UDP-glucosyl transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(137819, NULL, 'G3DSA:3.30.470.110:FF:000003', NULL, NULL, 'ATP-citrate synthase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(137820, NULL, 'G3DSA:3.10.110.10:FF:000136', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(137821, NULL, 'G3DSA:1.10.8.60:FF:000508', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137822, NULL, 'G3DSA:3.40.50.11350:FF:000040', NULL, NULL, 'L-Fucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(137823, NULL, 'G3DSA:3.30.40.10:FF:002357', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(137824, NULL, 'G3DSA:3.90.1150.10:FF:000052', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(137825, NULL, 'G3DSA:3.30.1240.10:FF:000056', NULL, NULL, 'Cof-type HAD-IIB family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(137826, NULL, 'G3DSA:1.25.40.10:FF:000098', NULL, NULL, 'Squamous cell carcinoma antigen recognized by T-cells 3', NULL, NULL, NULL, NULL, NULL, 4),
(137827, NULL, 'G3DSA:1.10.418.10:FF:000116', NULL, NULL, 'Sperm flagellar protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(137828, NULL, 'G3DSA:3.30.70.1230:FF:000211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137829, NULL, 'G3DSA:1.10.287.110:FF:000482', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137830, NULL, 'G3DSA:1.10.1070.11:FF:000027', NULL, NULL, 'Putative Phosphatidylinositol 4-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(137831, NULL, 'G3DSA:1.10.400.10:FF:000025', NULL, NULL, 'Guanine nucleotide-binding protein alpha-11 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(137832, NULL, 'G3DSA:3.30.450.20:FF:000441', NULL, NULL, 'Signal-transducing histidine kinase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(137833, NULL, 'G3DSA:3.90.79.10:FF:000089', NULL, NULL, 'CoA pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(137834, NULL, 'G3DSA:6.10.140.2220:FF:000020', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(137835, NULL, 'G3DSA:2.30.29.30:FF:000422', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(137836, NULL, 'G3DSA:3.30.160.60:FF:006231', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137837, NULL, 'G3DSA:3.40.50.300:FF:008182', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(137838, NULL, 'G3DSA:1.10.10.60:FF:000352', NULL, NULL, 'Site-specific DNA recombinase', NULL, NULL, NULL, NULL, NULL, 4),
(137839, NULL, 'G3DSA:3.30.2310.20:FF:000003', NULL, NULL, 'Type II toxin-antitoxin system YafQ family toxin', NULL, NULL, NULL, NULL, NULL, 4),
(137840, NULL, 'G3DSA:3.70.10.10:FF:000139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137841, NULL, 'G3DSA:3.60.20.10:FF:000073', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(137842, NULL, 'G3DSA:1.20.120.350:FF:000248', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137843, NULL, 'G3DSA:3.30.450.70:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137844, NULL, 'G3DSA:3.40.309.10:FF:000012', NULL, NULL, 'Betaine aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(137845, NULL, 'G3DSA:3.40.50.300:FF:000453', NULL, NULL, 'Probable helicase with zinc finger domain', NULL, NULL, NULL, NULL, NULL, 4),
(137846, NULL, 'G3DSA:1.20.120.720:FF:000028', NULL, NULL, 'Myosin IE heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(137847, NULL, 'G3DSA:3.40.50.300:FF:008558', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(137848, NULL, 'G3DSA:2.130.10.10:FF:003797', NULL, NULL, 'WD40-repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(137849, NULL, 'G3DSA:3.30.200.20:FF:001035', NULL, NULL, 'Myosin light chain kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137850, NULL, 'G3DSA:3.40.50.300:FF:005832', NULL, NULL, 'Type I secretion system ATPase subunit HlyB family', NULL, NULL, NULL, NULL, NULL, 4),
(137851, NULL, 'G3DSA:3.40.50.150:FF:001403', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137852, NULL, 'G3DSA:3.30.30.30:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137853, NULL, 'G3DSA:1.25.40.10:FF:002043', NULL, NULL, 'Tetratricopeptide repeat domain 21B', NULL, NULL, NULL, NULL, NULL, 4),
(137854, NULL, 'G3DSA:2.60.40.60:FF:000349', NULL, NULL, 'Cadherin 5', NULL, NULL, NULL, NULL, NULL, 4),
(137855, NULL, 'G3DSA:3.40.50.880:FF:000082', NULL, NULL, 'Biotin:apoprotein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(137856, NULL, 'G3DSA:3.30.160.20:FF:000227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137857, NULL, 'G3DSA:1.25.40.10:FF:002604', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g71420', NULL, NULL, NULL, NULL, NULL, 4),
(137858, NULL, 'G3DSA:3.20.80.10:FF:000022', NULL, NULL, 'Heme-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(137859, NULL, 'G3DSA:1.20.1260.60:FF:000008', NULL, NULL, 'Regulator of Vps4 activity in the MVB pathway protein', NULL, NULL, NULL, NULL, NULL, 4),
(137860, NULL, 'G3DSA:1.10.510.10:FF:004069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137861, NULL, 'G3DSA:3.40.640.10:FF:000214', NULL, NULL, 'CAI-1 autoinducer synthase', NULL, NULL, NULL, NULL, NULL, 4),
(137862, NULL, 'G3DSA:3.80.10.10:FF:002151', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(137863, NULL, 'G3DSA:1.10.472.80:FF:000285', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137864, NULL, 'G3DSA:2.60.40.10:FF:003488', NULL, NULL, 'Outer capsid protein lambda-2', NULL, NULL, NULL, NULL, NULL, 4),
(137865, NULL, 'G3DSA:3.50.50.60:FF:000096', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(137866, NULL, 'G3DSA:3.30.230.70:FF:000012', NULL, NULL, 'exosome complex component RRP46', NULL, NULL, NULL, NULL, NULL, 4),
(137867, NULL, 'G3DSA:3.40.50.10810:FF:000108', NULL, NULL, 'Helicase superfamily, c-terminal domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(137868, NULL, 'G3DSA:3.30.40.10:FF:001396', NULL, NULL, 'Putative histone-lysine n-methyltransferase 2c-like isoform x6', NULL, NULL, NULL, NULL, NULL, 4),
(137869, NULL, 'G3DSA:3.30.160.60:FF:004286', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(137870, NULL, 'G3DSA:2.60.40.10:FF:000762', NULL, NULL, 'transcription factor collier isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(137871, NULL, 'G3DSA:3.40.50.300:FF:004287', NULL, NULL, 'AGAP009547-PA', NULL, NULL, NULL, NULL, NULL, 4),
(137872, NULL, 'G3DSA:1.10.510.10:FF:001343', NULL, NULL, 'L-type lectin-domain containing receptor kinase I.3', NULL, NULL, NULL, NULL, NULL, 4),
(137873, NULL, 'G3DSA:2.20.28.10:FF:000061', NULL, NULL, 'Minichromosome maintenance protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(137874, NULL, 'G3DSA:1.10.418.10:FF:000263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137875, NULL, 'G3DSA:4.10.280.10:FF:000228', NULL, NULL, 'Transcription factor bHLH95', NULL, NULL, NULL, NULL, NULL, 4),
(137876, NULL, 'G3DSA:1.20.1250.20:FF:001507', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137877, NULL, 'G3DSA:2.30.18.10:FF:000003', NULL, NULL, 'Transcription initiation factor IIA subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(137878, NULL, 'G3DSA:3.30.450.60:FF:000082', NULL, NULL, 'AP complex subunit sigma', NULL, NULL, NULL, NULL, NULL, 4),
(137879, NULL, 'G3DSA:3.30.1490.190:FF:000018', NULL, NULL, 'Fur family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(137880, NULL, 'G3DSA:2.10.25.10:FF:001830', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137881, NULL, 'G3DSA:3.40.50.300:FF:003887', NULL, NULL, 'Signal recognition particle receptor subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(137882, NULL, 'G3DSA:3.40.50.300:FF:001561', NULL, NULL, 'ras-related protein Rab-6B isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(137883, NULL, 'G3DSA:2.70.150.10:FF:000106', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(137884, NULL, 'G3DSA:2.130.10.10:FF:004781', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137885, NULL, 'G3DSA:2.10.90.10:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137886, NULL, 'G3DSA:3.40.190.10:FF:000145', NULL, NULL, 'Peptide/nickel ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(137887, NULL, 'G3DSA:3.40.800.20:FF:000027', NULL, NULL, 'HDA14', NULL, NULL, NULL, NULL, NULL, 4),
(137888, NULL, 'G3DSA:3.40.630.10:FF:000337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137889, NULL, 'G3DSA:3.30.160.60:FF:004786', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137890, NULL, 'G3DSA:3.30.70.100:FF:000079', NULL, NULL, 'Probable decarboxylase tpcK', NULL, NULL, NULL, NULL, NULL, 4),
(137891, NULL, 'G3DSA:1.10.30.10:FF:000176', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(137892, NULL, 'G3DSA:3.30.160.60:FF:005354', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137893, NULL, 'G3DSA:1.10.150.80:FF:000015', NULL, NULL, 'Putative ribonuclease D', NULL, NULL, NULL, NULL, NULL, 4),
(137894, NULL, 'G3DSA:1.20.1270.60:FF:000037', NULL, NULL, 'Proline-serine-threonine phosphatase interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(137895, NULL, 'G3DSA:2.110.10.10:FF:000049', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(137896, NULL, 'G3DSA:1.20.5.110:FF:000296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137897, NULL, 'G3DSA:2.40.160.20:FF:000009', NULL, NULL, 'Major outer membrane protein OMP-1S', NULL, NULL, NULL, NULL, NULL, 4),
(137898, NULL, 'G3DSA:1.20.120.1900:FF:000086', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(137899, NULL, 'G3DSA:3.60.21.10:FF:000417', NULL, NULL, 'Serine/threonine phosphatase type 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137900, NULL, 'G3DSA:1.25.40.340:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137901, NULL, 'G3DSA:3.40.20.10:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137902, NULL, 'G3DSA:3.30.200.20:FF:001743', NULL, NULL, 'Uncharacterized protein sll1119', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(137903, NULL, 'G3DSA:3.30.1490.190:FF:000013', NULL, NULL, 'Fur family nickel uptake regulator', NULL, NULL, NULL, NULL, NULL, 4),
(137904, NULL, 'G3DSA:3.40.1090.10:FF:000036', NULL, NULL, 'Patatin-like phospholipase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(137905, NULL, 'G3DSA:1.10.1300.10:FF:000051', NULL, NULL, 'cAMP-specific phosphodiesterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137906, NULL, 'G3DSA:3.40.50.720:FF:001624', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137907, NULL, 'G3DSA:2.60.120.380:FF:000028', NULL, NULL, 'Microbial collagenase', NULL, NULL, NULL, NULL, NULL, 4),
(137908, NULL, 'G3DSA:3.40.50.1360:FF:000045', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(137909, NULL, 'G3DSA:1.10.10.60:FF:000667', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(137910, NULL, 'G3DSA:3.40.47.10:FF:000096', NULL, NULL, 'Acetyl-CoA C-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(137911, NULL, 'G3DSA:2.60.40.1120:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137912, NULL, 'G3DSA:3.80.20.20:FF:000041', NULL, NULL, 'AGAP009262-PA', NULL, NULL, NULL, NULL, NULL, 4),
(137913, NULL, 'G3DSA:1.20.1250.20:FF:001598', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137914, NULL, 'G3DSA:3.30.1140.60:FF:000018', NULL, NULL, 'F-actin-capping protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(137915, NULL, 'G3DSA:1.20.58.60:FF:000181', NULL, NULL, 'Spectrin repeat containing, nuclear envelope 1a', NULL, NULL, NULL, NULL, NULL, 4),
(137916, NULL, 'G3DSA:3.30.200.20:FF:002311', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137917, NULL, 'G3DSA:1.20.1110.10:FF:000011', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(137918, NULL, 'G3DSA:2.70.98.10:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137919, NULL, 'G3DSA:1.10.167.10:FF:000050', NULL, NULL, 'Regulator of G protein signaling domain protein (AFU_orthologue AFUA_6G06860)', NULL, NULL, NULL, NULL, NULL, 4),
(137920, NULL, 'G3DSA:3.20.20.80:FF:000106', NULL, NULL, 'Glycosyl hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137921, NULL, 'G3DSA:3.40.50.300:FF:003146', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(137922, NULL, 'G3DSA:1.25.10.10:FF:000326', NULL, NULL, 'V-type proton ATPase subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(137923, NULL, 'G3DSA:3.10.450.40:FF:000030', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(137924, NULL, 'G3DSA:2.130.10.10:FF:005950', NULL, NULL, 'Gll1931 protein', NULL, NULL, NULL, NULL, NULL, 4),
(137925, NULL, 'G3DSA:4.10.530.10:FF:000001', NULL, NULL, 'angiopoietin-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(137926, NULL, 'G3DSA:3.30.560.10:FF:000007', NULL, NULL, 'Glucose-methanol-choline oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(137927, NULL, 'G3DSA:3.40.1030.10:FF:000009', NULL, NULL, 'Anthranilate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(137928, NULL, 'G3DSA:3.30.70.330:FF:002059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137929, NULL, 'G3DSA:3.30.500.10:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137930, NULL, 'G3DSA:1.20.5.1890:FF:000001', NULL, NULL, 'Envelope glycoprotein B', NULL, NULL, NULL, NULL, NULL, 4),
(137931, NULL, 'G3DSA:3.30.1560.10:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137932, NULL, 'G3DSA:3.30.1370.10:FF:000245', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(137933, NULL, 'G3DSA:3.40.50.1010:FF:000103', NULL, NULL, 'PilT protein domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(137934, NULL, 'G3DSA:1.10.510.10:FF:002208', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137935, NULL, 'G3DSA:3.30.230.70:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137936, NULL, 'G3DSA:3.40.50.12650:FF:000031', NULL, NULL, 'DNA cross-link repair protein pso2/snm1, putative', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(137937, NULL, 'G3DSA:2.60.40.10:FF:003729', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137938, NULL, 'G3DSA:1.10.287.950:FF:000054', NULL, NULL, 'Methyl-accepting chemotaxis protein CtpH', NULL, NULL, NULL, NULL, NULL, 4),
(137939, NULL, 'G3DSA:3.30.260.10:FF:000081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137940, NULL, 'G3DSA:3.60.10.10:FF:000128', NULL, NULL, 'Inositol/phosphatidylinositol phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137941, NULL, 'G3DSA:1.20.1070.10:FF:000395', NULL, NULL, 'G-protein coupled receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(137942, NULL, 'G3DSA:3.30.160.60:FF:003325', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137943, NULL, 'G3DSA:3.90.226.10:FF:000156', NULL, NULL, 'Putative enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(137944, NULL, 'G3DSA:1.10.10.10:FF:001170', NULL, NULL, 'HTH-type transcriptional repressor glcR', NULL, NULL, NULL, NULL, NULL, 4),
(137945, NULL, 'G3DSA:3.40.50.620:FF:000431', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(137946, NULL, 'G3DSA:3.30.1480.10:FF:000006', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(137947, NULL, 'G3DSA:3.40.50.300:FF:000392', NULL, NULL, 'Zinc import ATP-binding protein ZnuC', NULL, NULL, NULL, NULL, NULL, 4),
(137948, NULL, 'G3DSA:1.10.1450.10:FF:000179', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(137949, NULL, 'G3DSA:1.10.8.60:FF:000076', NULL, NULL, 'Stage V sporulation protein K', NULL, NULL, NULL, NULL, NULL, 4),
(137950, NULL, 'G3DSA:3.40.50.150:FF:001616', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137951, NULL, 'G3DSA:3.30.750.190:FF:000001', NULL, NULL, '3-hydroxyadipyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(137952, NULL, 'G3DSA:2.10.25.10:FF:001358', NULL, NULL, 'Neuregulin 1 type IIIa isoform', NULL, NULL, NULL, NULL, NULL, 4),
(137953, NULL, 'G3DSA:2.60.200.10:FF:000017', NULL, NULL, 'Interferon regulatory factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(137954, NULL, 'G3DSA:3.30.1140.40:FF:000012', NULL, NULL, 'Dynein light chain Tctex-type, putative', NULL, NULL, NULL, NULL, NULL, 4),
(137955, NULL, 'G3DSA:3.30.160.60:FF:006343', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137956, NULL, 'G3DSA:1.10.238.10:FF:001154', NULL, NULL, 'GTPase-activating protein gyp2', NULL, NULL, NULL, NULL, NULL, 4),
(137957, NULL, 'G3DSA:3.40.50.1000:FF:000246', NULL, NULL, 'Bifunctional polynucleotide phosphatase/kinase', NULL, NULL, NULL, NULL, NULL, 4),
(137958, NULL, 'G3DSA:3.30.60.190:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137959, NULL, 'G3DSA:2.170.130.10:FF:000042', NULL, NULL, 'Transferrin-binding protein 1 Tbp1', NULL, NULL, NULL, NULL, NULL, 4),
(137960, NULL, 'G3DSA:2.60.40.1120:FF:000076', NULL, NULL, 'Carboxypeptidase Z', NULL, NULL, NULL, NULL, NULL, 4),
(137961, NULL, 'G3DSA:1.20.120.1900:FF:000035', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(137962, NULL, 'G3DSA:3.80.10.10:FF:003724', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137963, NULL, 'G3DSA:1.10.3520.10:FF:000011', NULL, NULL, 'Glycolipid transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(137964, NULL, 'G3DSA:1.25.40.20:FF:000803', NULL, NULL, 'Transient receptor potential cation channel protein painless', NULL, NULL, NULL, NULL, NULL, 4),
(137965, NULL, 'G3DSA:2.160.20.10:FF:000233', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(137966, NULL, 'G3DSA:1.20.58.1180:FF:000002', NULL, NULL, 'Mrpl35p', NULL, NULL, NULL, NULL, NULL, 4),
(137967, NULL, 'G3DSA:1.20.1560.10:FF:000270', NULL, NULL, 'HlyB/MsbA family ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(137968, NULL, 'G3DSA:3.30.70.330:FF:002447', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137969, NULL, 'G3DSA:3.40.50.1980:FF:000023', NULL, NULL, 'Iron ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(137970, NULL, 'G3DSA:3.30.540.10:FF:000063', NULL, NULL, 'Sedoheptulose-1,7-bisphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(137971, NULL, 'G3DSA:3.40.50.300:FF:004556', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(137972, NULL, 'G3DSA:2.60.120.200:FF:000278', NULL, NULL, 'Kon-tiki, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(137973, NULL, 'G3DSA:3.30.200.20:FF:000754', NULL, NULL, 'Tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(137974, NULL, 'G3DSA:2.60.40.1760:FF:000009', NULL, NULL, 'Sugar hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(137975, NULL, 'G3DSA:1.20.58.400:FF:000028', NULL, NULL, 'Snare region anchored in the vesicle membrane C-terminus-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(137976, NULL, 'G3DSA:3.30.230.10:FF:000253', NULL, NULL, 'Lon protease homolog 2, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(137977, NULL, 'G3DSA:3.30.428.10:FF:000077', NULL, NULL, 'Putative galactose-1-phosphate uridylyltransferase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(137978, NULL, 'G3DSA:1.10.540.10:FF:000058', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(137979, NULL, 'G3DSA:3.30.70.330:FF:000261', NULL, NULL, 'RNA-binding motif protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(137980, NULL, 'G3DSA:2.60.40.60:FF:000557', NULL, NULL, 'Cadherin-related hmr-1', NULL, NULL, NULL, NULL, NULL, 4),
(137981, NULL, 'G3DSA:3.40.20.10:FF:000175', NULL, NULL, 'Uncharacterized protein C4.03c', NULL, NULL, NULL, NULL, NULL, 4),
(137982, NULL, 'G3DSA:3.40.50.1820:FF:000380', NULL, NULL, 'Alpha/beta fold hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(137983, NULL, 'G3DSA:3.90.230.10:FF:000003', NULL, NULL, 'Methionine aminopeptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(137984, NULL, 'G3DSA:2.130.10.10:FF:000678', NULL, NULL, 'Putative UV-damaged DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(137985, NULL, 'G3DSA:2.60.120.260:FF:000509', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137986, NULL, 'G3DSA:3.30.160.60:FF:000571', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137987, NULL, 'G3DSA:2.130.10.10:FF:001616', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(137988, NULL, 'G3DSA:3.30.420.40:FF:000484', NULL, NULL, 'Actin related protein T3', NULL, NULL, NULL, NULL, NULL, 4),
(137989, NULL, 'G3DSA:2.20.20.20:FF:000001', NULL, NULL, 'Baseplate wedge subunit and tail pin', NULL, NULL, NULL, NULL, NULL, 4),
(137990, NULL, 'G3DSA:1.10.20.10:FF:000091', NULL, NULL, 'Histone H2A', NULL, NULL, NULL, NULL, NULL, 4),
(137991, NULL, 'G3DSA:3.30.1680.10:FF:000055', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(137992, NULL, 'G3DSA:3.40.50.850:FF:000011', NULL, NULL, 'Pyrazinamidase/nicotinamidase PncA', NULL, NULL, NULL, NULL, NULL, 4),
(137993, NULL, 'G3DSA:3.10.100.10:FF:000343', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(137994, NULL, 'G3DSA:1.10.8.10:FF:000022', NULL, NULL, '50S ribosomal protein L3 glutamine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(137995, NULL, 'G3DSA:3.30.420.40:FF:001001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(137996, NULL, 'G3DSA:3.80.10.10:FF:001746', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(137997, NULL, 'G3DSA:3.40.50.300:FF:002578', NULL, NULL, 'Amino acid ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(137998, NULL, 'G3DSA:3.40.50.300:FF:005916', NULL, NULL, 'ABC transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(137999, NULL, 'G3DSA:2.60.40.60:FF:001125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138000, NULL, 'G3DSA:3.40.50.300:FF:000341', NULL, NULL, 'High-affinity branched-chain amino acid transport ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(138001, NULL, 'G3DSA:3.30.2130.10:FF:000025', NULL, NULL, 'GATS isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(138002, NULL, 'G3DSA:3.50.4.10:FF:000026', NULL, NULL, 'Merozoite adhesive erythrocytic binding protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(138003, NULL, 'G3DSA:1.25.40.10:FF:005297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138004, NULL, 'G3DSA:2.40.10.10:FF:000536', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138005, NULL, 'G3DSA:3.40.50.2300:FF:001114', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(138006, NULL, 'G3DSA:3.40.190.10:FF:000353', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(138007, NULL, 'G3DSA:3.40.47.10:FF:000045', NULL, NULL, 'Hydroxymethylglutaryl-CoA synthase', NULL, NULL, NULL, NULL, NULL, 4),
(138008, NULL, 'G3DSA:2.60.120.380:FF:000079', NULL, NULL, 'Calcium-dependent cysteine protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138009, NULL, 'G3DSA:3.30.420.210:FF:000001', NULL, NULL, 'NSFL1 (P97) cofactor (P47)', NULL, NULL, NULL, NULL, NULL, 4),
(138010, NULL, 'G3DSA:3.40.1370.10:FF:000018', NULL, NULL, 'Mitochondrial 54S ribosomal protein YmL6', NULL, NULL, NULL, NULL, NULL, 4),
(138011, NULL, 'G3DSA:3.40.50.11260:FF:000013', NULL, NULL, 'Chaperone protein HtpG', NULL, NULL, NULL, NULL, NULL, 4),
(138012, NULL, 'G3DSA:2.40.50.40:FF:000025', NULL, NULL, 'C-C motif chemokine', NULL, NULL, NULL, NULL, NULL, 4),
(138013, NULL, 'G3DSA:2.170.270.10:FF:000052', NULL, NULL, 'SET and MYND domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(138014, NULL, 'G3DSA:3.40.50.1820:FF:001801', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138015, NULL, 'G3DSA:1.25.40.10:FF:000154', NULL, NULL, 'Aspartyl/asparaginyl beta-hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(138016, NULL, 'G3DSA:2.30.30.140:FF:000020', NULL, NULL, 'RNA polymerase-associated protein RapA', NULL, NULL, NULL, NULL, NULL, 4),
(138017, NULL, 'G3DSA:3.30.1380.10:FF:000010', NULL, NULL, 'D-alanyl-D-alanine dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(138018, NULL, 'G3DSA:1.25.10.10:FF:001754', NULL, NULL, 'Protein VAC14-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(138019, NULL, 'G3DSA:1.10.418.30:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138020, NULL, 'G3DSA:1.20.1070.10:FF:001816', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138021, NULL, 'G3DSA:1.50.10.160:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138022, NULL, 'G3DSA:3.40.50.1980:FF:000074', NULL, NULL, 'Adhesion protein', NULL, NULL, NULL, NULL, NULL, 4),
(138023, NULL, 'G3DSA:1.20.1070.10:FF:001704', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138024, NULL, 'G3DSA:1.20.58.60:FF:000029', NULL, NULL, 'utrophin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(138025, NULL, 'G3DSA:1.10.472.80:FF:000173', NULL, NULL, 'GTPase-activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138026, NULL, 'G3DSA:1.10.287.110:FF:000302', NULL, NULL, 'Zgc:163044 protein', NULL, NULL, NULL, NULL, NULL, 4),
(138027, NULL, 'G3DSA:2.40.50.140:FF:000544', NULL, NULL, 'Breast cancer 2, early onset', NULL, NULL, NULL, NULL, NULL, 4),
(138028, NULL, 'G3DSA:3.80.10.10:FF:000386', NULL, NULL, 'Disease resistance protein RPS4', NULL, NULL, NULL, NULL, NULL, 4),
(138029, NULL, 'G3DSA:3.10.20.230:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(138030, NULL, 'G3DSA:2.30.29.30:FF:000681', NULL, NULL, 'GTP exchange factor for ARFs 1', NULL, NULL, NULL, NULL, NULL, 4),
(138031, NULL, 'G3DSA:3.40.50.300:FF:001701', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(138032, NULL, 'G3DSA:3.30.420.10:FF:000048', NULL, NULL, 'CCR4-associated factor 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138033, NULL, 'G3DSA:3.40.50.300:FF:006001', NULL, NULL, 'Peroxisomal biogenesis factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(138034, NULL, 'G3DSA:3.30.40.10:FF:000227', NULL, NULL, 'RING finger protein 214 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(138035, NULL, 'G3DSA:2.40.50.140:FF:001033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138036, NULL, 'G3DSA:3.30.50.10:FF:000025', NULL, NULL, 'GATA transcription factor', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(138037, NULL, 'G3DSA:1.10.220.20:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138038, NULL, 'G3DSA:2.60.120.290:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138039, NULL, 'G3DSA:3.40.50.200:FF:000069', NULL, NULL, 'Clan SB, family S8, subtilisin-like serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(138040, NULL, 'G3DSA:3.30.460.10:FF:000062', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(138041, NULL, 'G3DSA:1.20.1250.20:FF:001390', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138042, NULL, 'G3DSA:2.60.40.10:FF:002532', NULL, NULL, 'Basigin, isoform J', NULL, NULL, NULL, NULL, NULL, 4),
(138043, NULL, 'G3DSA:2.30.42.10:FF:000048', NULL, NULL, 'disks large homolog 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(138044, NULL, 'G3DSA:3.30.760.10:FF:000006', NULL, NULL, 'Eukaryotic translation initiation factor 4E family member 1c', NULL, NULL, NULL, NULL, NULL, 4),
(138045, NULL, 'G3DSA:3.30.40.10:FF:000648', NULL, NULL, 'RING finger domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138046, NULL, 'G3DSA:1.20.210.10:FF:000020', NULL, NULL, 'Cytochrome c oxidase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(138047, NULL, 'G3DSA:3.30.413.10:FF:000032', NULL, NULL, 'Anaerobic sulfite reductase subunit c', NULL, NULL, NULL, NULL, NULL, 4),
(138048, NULL, 'G3DSA:3.30.420.40:FF:001052', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(138049, NULL, 'G3DSA:2.30.29.30:FF:000029', NULL, NULL, 'Insulin receptor substrate 1', NULL, NULL, NULL, NULL, NULL, 4),
(138050, NULL, 'G3DSA:3.40.390.10:FF:000301', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138051, NULL, 'G3DSA:3.30.420.40:FF:000063', NULL, NULL, 'N-acetylmannosamine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(138052, NULL, 'G3DSA:2.10.25.10:FF:000369', NULL, NULL, 'Multiple epidermal growth factor-like domains protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(138053, NULL, 'G3DSA:3.40.50.2300:FF:001165', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138054, NULL, 'G3DSA:4.10.410.10:FF:000054', NULL, NULL, 'Protein CBR-MEC-1', NULL, NULL, NULL, NULL, NULL, 4),
(138055, NULL, 'G3DSA:2.130.10.10:FF:004101', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(138056, NULL, 'G3DSA:2.60.40.150:FF:000670', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138057, NULL, 'G3DSA:3.90.230.10:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138058, NULL, 'G3DSA:4.10.400.10:FF:000109', NULL, NULL, 'Transmembrane serine protease 7', NULL, NULL, NULL, NULL, NULL, 4),
(138059, NULL, 'G3DSA:3.40.50.670:FF:000013', NULL, NULL, 'DNA gyrase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(138060, NULL, 'G3DSA:1.25.10.10:FF:002243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138061, NULL, 'G3DSA:3.40.50.300:FF:005012', NULL, NULL, 'Adenylate dimethylallyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(138062, NULL, 'G3DSA:2.160.20.80:FF:000001', NULL, NULL, 'Synaptic vesicle glycoprotein 2A', NULL, NULL, NULL, NULL, NULL, 4),
(138063, NULL, 'G3DSA:1.10.246.90:FF:000010', NULL, NULL, 'U4/U6 small nuclear ribonucleoprotein Prp31', NULL, NULL, NULL, NULL, NULL, 4),
(138064, NULL, 'G3DSA:1.10.510.10:FF:000410', NULL, NULL, 'Probable PHO85-cyclin-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(138065, NULL, 'G3DSA:3.10.20.90:FF:000576', NULL, NULL, 'RB1-inducible coiled-coil protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(138066, NULL, 'G3DSA:2.30.130.30:FF:000002', NULL, NULL, 'Activating signal cointegrator 1', NULL, NULL, NULL, NULL, NULL, 4),
(138067, NULL, 'G3DSA:1.10.1040.10:FF:000013', NULL, NULL, 'Ketol-acid reductoisomerase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(138068, NULL, 'G3DSA:3.80.10.10:FF:003612', NULL, NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', NULL, NULL, NULL, NULL, NULL, 4),
(138069, NULL, 'G3DSA:3.40.630.10:FF:000388', NULL, NULL, 'Zn-dependent exopeptidase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(138070, NULL, 'G3DSA:3.40.50.11380:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138071, NULL, 'G3DSA:1.20.58.60:FF:000130', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(138072, NULL, 'G3DSA:1.10.10.750:FF:000038', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(138073, NULL, 'G3DSA:1.10.10.60:FF:000616', NULL, NULL, 'BAP', NULL, NULL, NULL, NULL, NULL, 4),
(138074, NULL, 'G3DSA:1.25.10.10:FF:001703', NULL, NULL, 'Coatomer subunit beta, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138075, NULL, 'G3DSA:3.10.110.10:FF:000057', NULL, NULL, 'eukaryotic translation initiation factor 2-alpha kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(138076, NULL, 'G3DSA:1.20.1070.10:FF:001755', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138077, NULL, 'G3DSA:2.60.40.10:FF:000183', NULL, NULL, 'Myelin-oligodendrocyte glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(138078, NULL, 'G3DSA:1.50.40.10:FF:000450', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138079, NULL, 'G3DSA:1.10.630.10:FF:000357', NULL, NULL, 'Cyp2c37-prov protein', NULL, NULL, NULL, NULL, NULL, 4),
(138080, NULL, 'G3DSA:1.25.40.10:FF:004336', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(138081, NULL, 'G3DSA:2.130.10.10:FF:004489', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138082, NULL, 'G3DSA:3.30.200.20:FF:000866', NULL, NULL, 'Death-associated protein kinase dapk-1', NULL, NULL, NULL, NULL, NULL, 4),
(138083, NULL, 'G3DSA:3.10.590.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138084, NULL, 'G3DSA:1.10.10.10:FF:001574', NULL, NULL, 'Ferric uptake regulation protein', NULL, NULL, NULL, NULL, NULL, 4),
(138085, NULL, 'G3DSA:3.40.50.1980:FF:000135', NULL, NULL, 'Histidinol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(138086, NULL, 'G3DSA:3.40.50.300:FF:005512', NULL, NULL, 'IcmO', NULL, NULL, NULL, NULL, NULL, 4),
(138087, NULL, 'G3DSA:3.40.366.10:FF:000020', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(138088, NULL, 'G3DSA:3.80.10.10:FF:001307', NULL, NULL, 'EIN3-binding F-box domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(138089, NULL, 'G3DSA:1.10.1520.10:FF:000011', NULL, NULL, 'Ribonuclease III domain-containing protein RNC1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(138090, NULL, 'G3DSA:3.40.50.2000:FF:000737', NULL, NULL, '2-hydroxyacylsphingosine 1-beta-galactosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(138091, NULL, 'G3DSA:3.30.310.80:FF:000055', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(138092, NULL, 'G3DSA:2.130.10.120:FF:000002', NULL, NULL, 'prolyl endopeptidase-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(138093, NULL, 'G3DSA:3.30.9.10:FF:000295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138094, NULL, 'G3DSA:3.40.50.410:FF:000014', NULL, NULL, 'von Willebrand and RING finger domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(138095, NULL, 'G3DSA:3.30.70.1410:FF:000001', NULL, NULL, 'Hydrolase (HAD superfamily)', NULL, NULL, NULL, NULL, NULL, 4),
(138096, NULL, 'G3DSA:2.10.110.10:FF:000174', NULL, NULL, 'Calpain family cysteine protease', NULL, NULL, NULL, NULL, NULL, 4),
(138097, NULL, 'G3DSA:1.20.58.1070:FF:000020', NULL, NULL, 'Gem nuclear organelle associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(138098, NULL, 'G3DSA:2.40.50.140:FF:001084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138099, NULL, 'G3DSA:2.130.10.10:FF:000627', NULL, NULL, 'Bromodomain and WD repeat domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(138100, NULL, 'G3DSA:3.40.525.10:FF:000031', NULL, NULL, 'Protein CBR-CGR-1', NULL, NULL, NULL, NULL, NULL, 4),
(138101, NULL, 'G3DSA:2.160.20.10:FF:000121', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(138102, NULL, 'G3DSA:1.10.460.10:FF:000006', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(138103, NULL, 'G3DSA:1.25.40.20:FF:000011', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(138104, NULL, 'G3DSA:3.30.160.60:FF:002369', NULL, NULL, 'C2H2 type zinc finger domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(138105, NULL, 'G3DSA:3.40.50.10050:FF:000009', NULL, NULL, 'Probable translation initiation factor IF-2', NULL, NULL, NULL, NULL, NULL, 4),
(138106, NULL, 'G3DSA:1.10.510.10:FF:003996', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138107, NULL, 'G3DSA:2.60.40.10:FF:001543', NULL, NULL, 'Interleukin 18 receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(138108, NULL, 'G3DSA:2.170.150.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138109, NULL, 'G3DSA:1.10.540.10:FF:000007', NULL, NULL, 'Isovaleryl-CoA dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(138110, NULL, 'G3DSA:4.10.410.10:FF:000003', NULL, NULL, 'amyloid-like protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(138111, NULL, 'G3DSA:3.40.50.720:FF:000635', NULL, NULL, 'NADP-dependent malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(138112, NULL, 'G3DSA:3.40.50.300:FF:001330', NULL, NULL, 'Mitochondrial Rho GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(138113, NULL, 'G3DSA:1.20.58.1100:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138114, NULL, 'G3DSA:3.40.50.12100:FF:000001', NULL, NULL, 'Stimulator of interferon genes protein', NULL, NULL, NULL, NULL, NULL, 4),
(138115, NULL, 'G3DSA:1.10.238.10:FF:000698', NULL, NULL, 'EF-hand domain pair, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138116, NULL, 'G3DSA:2.60.120.260:FF:000610', NULL, NULL, 'Putative secreted protein', NULL, NULL, NULL, NULL, NULL, 4),
(138117, NULL, 'G3DSA:2.30.29.30:FF:000181', NULL, NULL, 'Arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(138118, NULL, 'G3DSA:3.30.70.1230:FF:000003', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(138119, NULL, 'G3DSA:3.10.20.440:FF:000001', NULL, NULL, 'Sarcosine oxidase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(138120, NULL, 'G3DSA:1.10.8.60:FF:000008', NULL, NULL, '26S protease regulatory subunit 10B', NULL, NULL, NULL, NULL, NULL, 4),
(138121, NULL, 'G3DSA:3.60.21.10:FF:000485', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(138122, NULL, 'G3DSA:3.80.10.10:FF:003663', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138123, NULL, 'G3DSA:2.10.25.10:FF:000869', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(138124, NULL, 'G3DSA:2.10.25.10:FF:001437', NULL, NULL, 'Heparan sulfate proteoglycan 2', NULL, NULL, NULL, NULL, NULL, 4),
(138125, NULL, 'G3DSA:3.30.160.60:FF:005242', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138126, NULL, 'G3DSA:3.90.980.20:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138127, NULL, 'G3DSA:3.40.630.10:FF:000449', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138128, NULL, 'G3DSA:3.40.190.10:FF:000432', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(138129, NULL, 'G3DSA:1.10.10.60:FF:001105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138130, NULL, 'G3DSA:2.60.40.150:FF:000147', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(138131, NULL, 'G3DSA:1.25.40.10:FF:002863', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g01990, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(138132, NULL, 'G3DSA:3.40.366.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138133, NULL, 'G3DSA:3.40.50.300:FF:004495', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(138134, NULL, 'G3DSA:2.60.40.60:FF:000636', NULL, NULL, 'AGAP002828-PA', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(138135, NULL, 'G3DSA:3.80.10.10:FF:003371', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138136, NULL, 'G3DSA:2.60.40.10:FF:004218', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138137, NULL, 'G3DSA:3.40.1190.10:FF:000021', NULL, NULL, 'UDP-N-acetylmuramoyl-L-alanyl-D-glutamate--2,6-diaminopimelate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(138138, NULL, 'G3DSA:3.40.50.720:FF:002260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138139, NULL, 'G3DSA:3.10.20.90:FF:000076', NULL, NULL, 'Krev interaction trapped protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(138140, NULL, 'G3DSA:3.40.1110.10:FF:000241', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138141, NULL, 'G3DSA:1.20.58.2220:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138142, NULL, 'G3DSA:1.10.238.10:FF:001215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138143, NULL, 'G3DSA:3.40.50.300:FF:007541', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138144, NULL, 'G3DSA:1.20.5.110:FF:000228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138145, NULL, 'G3DSA:1.25.10.10:FF:000394', NULL, NULL, 'general vesicular transport factor p115', NULL, NULL, NULL, NULL, NULL, 4),
(138146, NULL, 'G3DSA:3.40.50.300:FF:005063', NULL, NULL, 'Dynamin-related protein 4C', NULL, NULL, NULL, NULL, NULL, 4),
(138147, NULL, 'G3DSA:3.40.850.10:FF:000432', NULL, NULL, 'Kinesin family member 13B', NULL, NULL, NULL, NULL, NULL, 4),
(138148, NULL, 'G3DSA:2.40.10.10:FF:000165', NULL, NULL, 'Trypsin-like serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(138149, NULL, 'G3DSA:1.25.40.10:FF:001531', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g16835, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(138150, NULL, 'G3DSA:3.80.10.10:FF:001807', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138151, NULL, 'G3DSA:3.30.160.60:FF:000503', NULL, NULL, 'Zinc finger protein 276', NULL, NULL, NULL, NULL, NULL, 4),
(138152, NULL, 'G3DSA:4.10.60.10:FF:000266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138153, NULL, 'G3DSA:3.40.50.300:FF:003207', NULL, NULL, 'ATLastiN (Endoplasmic reticulum GTPase) related', NULL, NULL, NULL, NULL, NULL, 4),
(138154, NULL, 'G3DSA:1.20.58.390:FF:000154', NULL, NULL, 'CBN-LEV-8 protein', NULL, NULL, NULL, NULL, NULL, 4),
(138155, NULL, 'G3DSA:3.40.120.10:FF:000079', NULL, NULL, 'Phosphoglucomutase-1', NULL, NULL, NULL, NULL, NULL, 4),
(138156, NULL, 'G3DSA:3.30.470.20:FF:000116', NULL, NULL, 'Tubulin polyglutamylase ttll-4', NULL, NULL, NULL, NULL, NULL, 4),
(138157, NULL, 'G3DSA:3.40.50.720:FF:001984', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138158, NULL, 'G3DSA:3.30.200.20:FF:001855', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138159, NULL, 'G3DSA:1.10.760.10:FF:000102', NULL, NULL, 'Cytochrome c-1', NULL, NULL, NULL, NULL, NULL, 4),
(138160, NULL, 'G3DSA:1.25.40.660:FF:000018', NULL, NULL, 'Vacuolar protein sorting-associated protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(138161, NULL, 'G3DSA:2.60.40.10:FF:001190', NULL, NULL, 'Titin b', NULL, NULL, NULL, NULL, NULL, 4),
(138162, NULL, 'G3DSA:1.10.287.210:FF:000006', NULL, NULL, 'SAGA-associated factor 11', NULL, NULL, NULL, NULL, NULL, 4),
(138163, NULL, 'G3DSA:2.60.40.10:FF:000907', NULL, NULL, 'Platelet-derived growth factor receptor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(138164, NULL, 'G3DSA:1.20.1070.10:FF:001316', NULL, NULL, 'Calcitonin receptor-like b', NULL, NULL, NULL, NULL, NULL, 4),
(138165, NULL, 'G3DSA:3.40.33.10:FF:000154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138166, NULL, 'G3DSA:2.130.10.10:FF:005006', NULL, NULL, 'TNF receptor-associated factor 7', NULL, NULL, NULL, NULL, NULL, 4),
(138167, NULL, 'G3DSA:2.70.170.10:FF:000080', NULL, NULL, 'Acetylcholine receptor subunit alpha-type unc-63', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(138168, NULL, 'G3DSA:1.10.1540.10:FF:000006', NULL, NULL, '40S ribosomal protein S4-3', NULL, NULL, NULL, NULL, NULL, 4),
(138169, NULL, 'G3DSA:3.30.565.10:FF:000294', NULL, NULL, 'pyruvate dehydrogenase (Acetyl-transferring) kinase isozyme 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(138170, NULL, 'G3DSA:2.40.10.10:FF:000457', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138171, NULL, 'G3DSA:3.40.50.1820:FF:001740', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138172, NULL, 'G3DSA:3.20.20.220:FF:000080', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(138173, NULL, 'G3DSA:3.40.50.2300:FF:000176', NULL, NULL, 'metabotropic glutamate receptor 7', NULL, NULL, NULL, NULL, NULL, 4),
(138174, NULL, 'G3DSA:3.30.710.10:FF:000216', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(138175, NULL, 'G3DSA:3.30.300.180:FF:000004', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(138176, NULL, 'G3DSA:2.60.40.10:FF:003960', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138177, NULL, 'G3DSA:2.60.40.1180:FF:000015', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(138178, NULL, 'G3DSA:3.10.20.90:FF:000525', NULL, NULL, 'Ubiquitin-like protein 1-40S ribosomal protein S27a', NULL, NULL, NULL, NULL, NULL, 4),
(138179, NULL, 'G3DSA:3.40.50.2000:FF:000237', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(138180, NULL, 'G3DSA:2.60.40.150:FF:000198', NULL, NULL, 'Phosphatidylserine decarboxylase proenzyme 2', NULL, NULL, NULL, NULL, NULL, 4),
(138181, NULL, 'G3DSA:3.20.20.80:FF:000606', NULL, NULL, 'Os08g0518800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(138182, NULL, 'G3DSA:3.20.20.60:FF:000067', NULL, NULL, 'GG21066', NULL, NULL, NULL, NULL, NULL, 4),
(138183, NULL, 'G3DSA:2.40.420.20:FF:000047', NULL, NULL, 'Acriflavin resistance protein AcrE', NULL, NULL, NULL, NULL, NULL, 4),
(138184, NULL, 'G3DSA:1.10.510.10:FF:002708', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138185, NULL, 'G3DSA:1.10.150.20:FF:000025', NULL, NULL, 'DNA repair protein REV1', NULL, NULL, NULL, NULL, NULL, 4),
(138186, NULL, 'G3DSA:3.40.50.11500:FF:000006', NULL, NULL, 'SET binding factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(138187, NULL, 'G3DSA:3.30.160.60:FF:001060', NULL, NULL, 'Zinc finger protein OZF', NULL, NULL, NULL, NULL, NULL, 4),
(138188, NULL, 'G3DSA:2.130.10.10:FF:002595', NULL, NULL, 'F-box and WD repeat domain-containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(138189, NULL, 'G3DSA:2.60.120.260:FF:000661', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(138190, NULL, 'G3DSA:3.30.63.10:FF:000004', NULL, NULL, 'peripheral plasma membrane protein CASK isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(138191, NULL, 'G3DSA:1.25.10.10:FF:002159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138192, NULL, 'G3DSA:3.40.5.90:FF:000001', NULL, NULL, 'CDGSH iron-sulfur domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(138193, NULL, 'G3DSA:1.25.40.10:FF:002812', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138194, NULL, 'G3DSA:1.10.150.390:FF:000004', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(138195, NULL, 'G3DSA:2.100.10.50:FF:000011', NULL, NULL, 'Multivesicular body subunit 12B', NULL, NULL, NULL, NULL, NULL, 4),
(138196, NULL, 'G3DSA:1.10.10.60:FF:001156', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138197, NULL, 'G3DSA:1.25.40.10:FF:003768', NULL, NULL, 'RNA polymerase I-specific transcription initiation factor rrn11', NULL, NULL, NULL, NULL, NULL, 4),
(138198, NULL, 'G3DSA:2.30.29.30:FF:000922', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138199, NULL, 'G3DSA:2.60.40.690:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138200, NULL, 'G3DSA:1.20.58.1030:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(138201, NULL, 'G3DSA:3.40.390.10:FF:000060', NULL, NULL, 'Mitochondrial intermediate peptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138202, NULL, 'G3DSA:2.40.50.150:FF:000013', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(138203, NULL, 'G3DSA:3.30.450.20:FF:000154', NULL, NULL, 'Probable diguanylate cyclase DgcE', NULL, NULL, NULL, NULL, NULL, 4),
(138204, NULL, 'G3DSA:2.40.30.10:FF:000127', NULL, NULL, 'tRNA-specific 2-thiouridylase MnmA', NULL, NULL, NULL, NULL, NULL, 4),
(138205, NULL, 'G3DSA:3.30.200.20:FF:001243', NULL, NULL, 'Probable inactive L-type lectin-domain containing receptor kinase III.1', NULL, NULL, NULL, NULL, NULL, 4),
(138206, NULL, 'G3DSA:1.10.238.10:FF:000198', NULL, NULL, 'Polcalcin Phl p 7', NULL, NULL, NULL, NULL, NULL, 4),
(138207, NULL, 'G3DSA:3.40.50.10260:FF:000022', NULL, NULL, 'Bifunctional NAD(P)H-hydrate repair enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(138208, NULL, 'G3DSA:3.30.530.20:FF:000155', NULL, NULL, 'Coenzyme Q-binding protein COQ10, mitochondrial-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(138209, NULL, 'G3DSA:3.40.50.150:FF:001263', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138210, NULL, 'G3DSA:3.30.559.10:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138211, NULL, 'G3DSA:3.30.110.20:FF:000016', NULL, NULL, 'Rpp20, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(138212, NULL, 'G3DSA:1.10.10.10:FF:001523', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(138213, NULL, 'G3DSA:1.10.287.70:FF:000380', NULL, NULL, 'TOK potassium channel', NULL, NULL, NULL, NULL, NULL, 4),
(138214, NULL, 'G3DSA:2.60.40.1460:FF:000009', NULL, NULL, 'Integrin alpha 4', NULL, NULL, NULL, NULL, NULL, 4),
(138215, NULL, 'G3DSA:3.40.630.30:FF:000556', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138216, NULL, 'G3DSA:3.90.350.10:FF:000001', NULL, NULL, 'IS4 family transposase', NULL, NULL, NULL, NULL, NULL, 4),
(138217, NULL, 'G3DSA:3.30.70.330:FF:000182', NULL, NULL, 'RNA-binding motif protein 28', NULL, NULL, NULL, NULL, NULL, 4),
(138218, NULL, 'G3DSA:3.30.450.20:FF:000446', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(138219, NULL, 'G3DSA:1.10.510.10:FF:001579', NULL, NULL, 'Cell division cycle 7 homolog (S. cerevisiae)', NULL, NULL, NULL, NULL, NULL, 4),
(138220, NULL, 'G3DSA:3.10.20.90:FF:000817', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138221, NULL, 'G3DSA:3.40.850.10:FF:000140', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(138222, NULL, 'G3DSA:2.120.10.30:FF:000515', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(138223, NULL, 'G3DSA:3.40.50.720:FF:000523', NULL, NULL, 'Cinnamoyl-CoA reductase-like SNL6 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(138224, NULL, 'G3DSA:3.30.1490.20:FF:000049', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(138225, NULL, 'G3DSA:3.30.60.30:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138226, NULL, 'G3DSA:1.10.630.10:FF:000778', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138227, NULL, 'G3DSA:3.30.1370.10:FF:000184', NULL, NULL, 'KH homology domain-containing protein 4-like', NULL, NULL, NULL, NULL, NULL, 4),
(138228, NULL, 'G3DSA:3.40.50.2300:FF:000625', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138229, NULL, 'G3DSA:2.70.20.10:FF:000030', NULL, NULL, 'DNA topoisomerase III', NULL, NULL, NULL, NULL, NULL, 4),
(138230, NULL, 'G3DSA:1.20.120.1750:FF:000113', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(138231, NULL, 'G3DSA:1.25.40.20:FF:001860', NULL, NULL, 'NAD-dependent deacetylase sir2B', NULL, NULL, NULL, NULL, NULL, 4),
(138232, NULL, 'G3DSA:3.30.565.10:FF:000322', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(138233, NULL, 'G3DSA:3.30.70.330:FF:000974', NULL, NULL, 'Rim4p', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(138234, NULL, 'G3DSA:3.30.70.330:FF:002508', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138235, NULL, 'G3DSA:1.20.1250.20:FF:001682', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138236, NULL, 'G3DSA:3.30.360.10:FF:000077', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(138237, NULL, 'G3DSA:1.20.1070.10:FF:001412', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138238, NULL, 'G3DSA:2.130.10.10:FF:000599', NULL, NULL, 'Eukaryotic translation initiation factor 2A', NULL, NULL, NULL, NULL, NULL, 4),
(138239, NULL, 'G3DSA:2.60.120.720:FF:000001', NULL, NULL, 'Spike protein P1', NULL, NULL, NULL, NULL, NULL, 4),
(138240, NULL, 'G3DSA:3.30.530.20:FF:000059', NULL, NULL, 'SRPBCC family protein', NULL, NULL, NULL, NULL, NULL, 4),
(138241, NULL, 'G3DSA:3.40.50.300:FF:006181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138242, NULL, 'G3DSA:3.30.1330.20:FF:000009', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(138243, NULL, 'G3DSA:3.10.20.90:FF:000868', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138244, NULL, 'G3DSA:3.90.150.10:FF:000002', NULL, NULL, 'Variant surface glycoprotein 1125.4239', NULL, NULL, NULL, NULL, NULL, 4),
(138245, NULL, 'G3DSA:2.120.10.30:FF:000566', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138246, NULL, 'G3DSA:1.10.3470.10:FF:000029', NULL, NULL, 'Fe(3+)-hydroxamate ABC transporter permease FhuB', NULL, NULL, NULL, NULL, NULL, 4),
(138247, NULL, 'G3DSA:3.40.395.10:FF:000048', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(138248, NULL, 'G3DSA:2.60.120.740:FF:000007', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(138249, NULL, 'G3DSA:3.90.550.10:FF:000550', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(138250, NULL, 'G3DSA:3.40.1230.10:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138251, NULL, 'G3DSA:2.60.40.1170:FF:000097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138252, NULL, 'G3DSA:3.40.190.290:FF:000013', NULL, NULL, 'HTH-type transcriptional regulator SinR', NULL, NULL, NULL, NULL, NULL, 4),
(138253, NULL, 'G3DSA:2.120.10.90:FF:000005', NULL, NULL, 'DNA topoisomerase 4 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(138254, NULL, 'G3DSA:1.10.510.10:FF:002147', NULL, NULL, 'AGAP006960-PA', NULL, NULL, NULL, NULL, NULL, 4),
(138255, NULL, 'G3DSA:3.90.550.50:FF:000207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138256, NULL, 'G3DSA:3.90.190.10:FF:000387', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138257, NULL, 'G3DSA:1.20.1110.10:FF:000062', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(138258, NULL, 'G3DSA:3.40.50.1820:FF:000228', NULL, NULL, 'Alpha/beta-Hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(138259, NULL, 'G3DSA:2.30.29.30:FF:000973', NULL, NULL, 'Myotubularin-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(138260, NULL, 'G3DSA:1.20.120.140:FF:000034', NULL, NULL, 'Signal recognition particle receptor FtsY', NULL, NULL, NULL, NULL, NULL, 4),
(138261, NULL, 'G3DSA:3.30.160.60:FF:005854', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138262, NULL, 'G3DSA:3.20.20.70:FF:000688', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138263, NULL, 'G3DSA:2.130.10.10:FF:000386', NULL, NULL, 'Plexin D1', NULL, NULL, NULL, NULL, NULL, 4),
(138264, NULL, 'G3DSA:3.40.50.10810:FF:000232', NULL, NULL, 'Type III restriction enzyme, res subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(138265, NULL, 'G3DSA:1.10.1000.11:FF:000017', NULL, NULL, 'Arf guanine nucleotide exchange factor SYT1', NULL, NULL, NULL, NULL, NULL, 4),
(138266, NULL, 'G3DSA:3.30.70.330:FF:001250', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138267, NULL, 'G3DSA:2.30.29.30:FF:000630', NULL, NULL, 'GD20635', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(138268, NULL, 'G3DSA:3.40.30.10:FF:000001', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(138269, NULL, 'G3DSA:2.70.150.10:FF:000258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138270, NULL, 'G3DSA:1.10.3260.10:FF:000024', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(138271, NULL, 'G3DSA:1.10.287.110:FF:000370', NULL, NULL, 'Putative chaperone protein DNAj', NULL, NULL, NULL, NULL, NULL, 4),
(138272, NULL, 'G3DSA:1.10.510.10:FF:000298', NULL, NULL, 'Adenine nucleotide alpha hydrolase-like domain kinase', NULL, NULL, NULL, NULL, NULL, 4),
(138273, NULL, 'G3DSA:1.10.1040.10:FF:000081', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(138274, NULL, 'G3DSA:1.10.150.20:FF:000076', NULL, NULL, 'DNA repair endonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138275, NULL, 'G3DSA:3.30.70.330:FF:000761', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138276, NULL, 'G3DSA:1.20.1250.20:FF:001631', NULL, NULL, 'YALI0E00616p', NULL, NULL, NULL, NULL, NULL, 4),
(138277, NULL, 'G3DSA:3.90.70.10:FF:000254', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(138278, NULL, 'G3DSA:2.30.30.100:FF:000036', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm3', NULL, NULL, NULL, NULL, NULL, 4),
(138279, NULL, 'G3DSA:3.20.20.450:FF:000013', NULL, NULL, 'Membrane-anchored cyclic-di-GMP phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(138280, NULL, 'G3DSA:3.40.50.720:FF:000343', NULL, NULL, 'Altronate oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(138281, NULL, 'G3DSA:3.40.1350.60:FF:000009', NULL, NULL, 'Sugar fermentation stimulation protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(138282, NULL, 'G3DSA:1.20.920.20:FF:000037', NULL, NULL, 'Flagellar outer dynein arm heavy chain gamma', NULL, NULL, NULL, NULL, NULL, 4),
(138283, NULL, 'G3DSA:1.10.10.60:FF:000588', NULL, NULL, 'Transcription factor MYB36', NULL, NULL, NULL, NULL, NULL, 4),
(138284, NULL, 'G3DSA:3.30.260.10:FF:000013', NULL, NULL, 'T-complex protein 1 subunit theta', NULL, NULL, NULL, NULL, NULL, 4),
(138285, NULL, 'G3DSA:1.10.238.10:FF:001266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138286, NULL, 'G3DSA:1.20.1250.20:FF:000221', NULL, NULL, 'solute carrier family 2, facilitated glucose transporter member 6', NULL, NULL, NULL, NULL, NULL, 4),
(138287, NULL, 'G3DSA:1.10.10.10:FF:000146', NULL, NULL, 'PCI domain-containing protein 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(138288, NULL, 'G3DSA:2.60.40.10:FF:005758', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138289, NULL, 'G3DSA:3.30.450.20:FF:000497', NULL, NULL, 'Sensor histidine kinase, PAS, PAS, PAS and PAS domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(138290, NULL, 'G3DSA:2.30.39.10:FF:000029', NULL, NULL, 'SeRPin', NULL, NULL, NULL, NULL, NULL, 4),
(138291, NULL, 'G3DSA:3.80.10.10:FF:003320', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138292, NULL, 'G3DSA:4.10.400.10:FF:000177', NULL, NULL, 'Terribly reduced optic lobes, isoform AH', NULL, NULL, NULL, NULL, NULL, 4),
(138293, NULL, 'G3DSA:3.40.50.1240:FF:000094', NULL, NULL, 'Acid phosphatase 1, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(138294, NULL, 'G3DSA:2.40.70.10:FF:000192', NULL, NULL, 'Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(138295, NULL, 'G3DSA:3.30.160.60:FF:003033', NULL, NULL, 'Draculin-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(138296, NULL, 'G3DSA:2.60.120.200:FF:000750', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138297, NULL, 'G3DSA:3.40.50.300:FF:001622', NULL, NULL, 'Dynein, axonemal, heavy chain 14', NULL, NULL, NULL, NULL, NULL, 4),
(138298, NULL, 'G3DSA:3.30.559.10:FF:000252', NULL, NULL, 'Nonribosomal peptide synthetase asqK', NULL, NULL, NULL, NULL, NULL, 4),
(138299, NULL, 'G3DSA:3.20.100.30:FF:000004', NULL, NULL, 'Vacuolar transporter chaperone, putative', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(138300, NULL, 'G3DSA:1.10.8.680:FF:000002', NULL, NULL, 'AGAP002392-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(138301, NULL, 'G3DSA:1.10.135.10:FF:000009', NULL, NULL, 'Arginine kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138302, NULL, 'G3DSA:2.60.40.10:FF:002420', NULL, NULL, 'Obscurin-like 1b', NULL, NULL, NULL, NULL, NULL, 4),
(138303, NULL, 'G3DSA:3.30.200.20:FF:002199', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(138304, NULL, 'G3DSA:2.30.42.10:FF:000436', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138305, NULL, 'G3DSA:3.40.50.1820:FF:001689', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(138306, NULL, 'G3DSA:3.20.20.300:FF:000047', NULL, NULL, 'Beta-hexosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(138307, NULL, 'G3DSA:3.40.50.300:FF:006905', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(138308, NULL, 'G3DSA:2.60.40.10:FF:002448', NULL, NULL, 'MPL proto-oncogene, thrombopoietin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(138309, NULL, 'G3DSA:3.30.160.60:FF:005803', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138310, NULL, 'G3DSA:1.10.150.240:FF:000117', NULL, NULL, 'Hydrolase, CbbY/CbbZ/GpH/YieH family', NULL, NULL, NULL, NULL, NULL, 4),
(138311, NULL, 'G3DSA:3.40.30.10:FF:000973', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138312, NULL, 'G3DSA:1.25.40.10:FF:002071', NULL, NULL, 'Tola protein homolog1', NULL, NULL, NULL, NULL, NULL, 4),
(138313, NULL, 'G3DSA:3.10.580.10:FF:000199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138314, NULL, 'G3DSA:2.60.98.20:FF:000004', NULL, NULL, 'Flagellar hook protein FlgE', NULL, NULL, NULL, NULL, NULL, 4),
(138315, NULL, 'G3DSA:1.25.40.10:FF:001582', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g16010', NULL, NULL, NULL, NULL, NULL, 4),
(138316, NULL, 'G3DSA:3.30.565.10:FF:000373', NULL, NULL, 'Hybrid sensory kinase', NULL, NULL, NULL, NULL, NULL, 4),
(138317, NULL, 'G3DSA:3.40.50.300:FF:002139', NULL, NULL, 'GTP-binding protein YPT10', NULL, NULL, NULL, NULL, NULL, 4),
(138318, NULL, 'G3DSA:3.40.850.10:FF:000320', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(138319, NULL, 'G3DSA:2.60.120.40:FF:000059', NULL, NULL, 'Multimerin 2', NULL, NULL, NULL, NULL, NULL, 4),
(138320, NULL, 'G3DSA:2.60.40.420:FF:000251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138321, NULL, 'G3DSA:1.10.510.10:FF:002939', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138322, NULL, 'G3DSA:3.40.50.300:FF:004899', NULL, NULL, 'Ras-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138323, NULL, 'G3DSA:1.20.1250.20:FF:000850', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138324, NULL, 'G3DSA:1.20.120.1750:FF:000029', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(138325, NULL, 'G3DSA:1.25.10.10:FF:001142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138326, NULL, 'G3DSA:2.40.50.430:FF:000007', NULL, NULL, 'Putative DNA polymerase delta subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(138327, NULL, 'G3DSA:3.30.1360.60:FF:000001', NULL, NULL, 'PTS system glucose-specific IIBC component PtsG', NULL, NULL, NULL, NULL, NULL, 4),
(138328, NULL, 'G3DSA:3.40.50.2000:FF:000176', NULL, NULL, 'UDP glucuronosyltransferase 1 family, polypeptide A7', NULL, NULL, NULL, NULL, NULL, 4),
(138329, NULL, 'G3DSA:3.30.160.60:FF:001852', NULL, NULL, 'Zinc finger protein 136', NULL, NULL, NULL, NULL, NULL, 4),
(138330, NULL, 'G3DSA:1.10.472.10:FF:000697', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138331, NULL, 'G3DSA:4.10.60.10:FF:000154', NULL, NULL, 'Replication protein A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(138332, NULL, 'G3DSA:1.25.10.10:FF:000618', NULL, NULL, 'Sister chromatid cohesion protein PDS5 B', NULL, NULL, NULL, NULL, NULL, 4),
(138333, NULL, 'G3DSA:1.20.5.190:FF:000033', NULL, NULL, 'IQ motif containing GTPase activating protein 3', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(138334, NULL, 'G3DSA:3.40.190.10:FF:000061', NULL, NULL, 'Glutamate receptor, ionotropic kainate', NULL, NULL, NULL, NULL, NULL, 4),
(138335, NULL, 'G3DSA:3.30.60.20:FF:000147', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(138336, NULL, 'G3DSA:3.30.60.20:FF:000091', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(138337, NULL, 'G3DSA:1.10.510.10:FF:001315', NULL, NULL, 'Putative calcium/calmodulin-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(138338, NULL, 'G3DSA:3.40.50.720:FF:001916', NULL, NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(138339, NULL, 'G3DSA:3.30.200.20:FF:001030', NULL, NULL, 'Kinase, AGC AKT', NULL, NULL, NULL, NULL, NULL, 4),
(138340, NULL, 'G3DSA:3.80.10.10:FF:004101', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(138341, NULL, 'G3DSA:3.30.780.10:FF:000041', NULL, NULL, 'Translation initiation factor SUI1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(138342, NULL, 'G3DSA:1.20.58.390:FF:000042', NULL, NULL, '5-hydroxytryptamine receptor 3C', NULL, NULL, NULL, NULL, NULL, 4),
(138343, NULL, 'G3DSA:1.20.1270.60:FF:000329', NULL, NULL, 'Sorting nexin-41', NULL, NULL, NULL, NULL, NULL, 4),
(138344, NULL, 'G3DSA:1.25.40.990:FF:000033', NULL, NULL, 'protein xmas-2', NULL, NULL, NULL, NULL, NULL, 4),
(138345, NULL, 'G3DSA:1.20.5.1930:FF:000002', NULL, NULL, 'Sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(138346, NULL, 'G3DSA:1.10.238.10:FF:000777', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138347, NULL, 'G3DSA:2.130.10.10:FF:005118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138348, NULL, 'G3DSA:2.60.40.60:FF:000265', NULL, NULL, 'Cadherin 12', NULL, NULL, NULL, NULL, NULL, 4),
(138349, NULL, 'G3DSA:2.130.10.10:FF:001908', NULL, NULL, 'WD repeat protein (AFU_orthologue AFUA_6G12600)', NULL, NULL, NULL, NULL, NULL, 4),
(138350, NULL, 'G3DSA:2.30.30.490:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138351, NULL, 'G3DSA:3.90.70.10:FF:000546', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(138352, NULL, 'G3DSA:2.60.120.260:FF:000161', NULL, NULL, 'Probable allantoicase', NULL, NULL, NULL, NULL, NULL, 4),
(138353, NULL, 'G3DSA:1.25.40.10:FF:002312', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g10690', NULL, NULL, NULL, NULL, NULL, 4),
(138354, NULL, 'G3DSA:1.20.1070.10:FF:001204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138355, NULL, 'G3DSA:3.40.570.10:FF:000006', NULL, NULL, 'ectonucleotide pyrophosphatase/phosphodiesterase family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(138356, NULL, 'G3DSA:3.30.160.60:FF:002948', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138357, NULL, 'G3DSA:2.60.120.200:FF:000306', NULL, NULL, 'Laminin-like protein epi-1', NULL, NULL, NULL, NULL, NULL, 4),
(138358, NULL, 'G3DSA:2.60.40.150:FF:000208', NULL, NULL, 'Protein BONZAI 2', NULL, NULL, NULL, NULL, NULL, 4),
(138359, NULL, 'G3DSA:3.20.20.80:FF:000674', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(138360, NULL, 'G3DSA:1.10.730.10:FF:000050', NULL, NULL, 'Isoleucine-tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138361, NULL, 'G3DSA:3.40.80.10:FF:000004', NULL, NULL, 'Peptidoglycan recognition protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(138362, NULL, 'G3DSA:2.60.40.1260:FF:000005', NULL, NULL, 'CRE-LMN-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(138363, NULL, 'G3DSA:2.60.260.20:FF:000081', NULL, NULL, 'Chaperone protein dnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(138364, NULL, 'G3DSA:3.30.160.60:FF:006259', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138365, NULL, 'G3DSA:3.40.50.300:FF:007018', NULL, NULL, 'Uncharacterized protein MG268', NULL, NULL, NULL, NULL, NULL, 4),
(138366, NULL, 'G3DSA:1.10.510.10:FF:000798', NULL, NULL, 'caM kinase-like vesicle-associated protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(138367, NULL, 'G3DSA:2.60.40.10:FF:002499', NULL, NULL, 'ImpL2, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(138368, NULL, 'G3DSA:1.20.58.1120:FF:000063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138369, NULL, 'G3DSA:2.60.40.1180:FF:000083', NULL, NULL, 'Putative calpain-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(138370, NULL, 'G3DSA:1.20.1070.10:FF:000687', NULL, NULL, 'Si:ch73-379f7.4', NULL, NULL, NULL, NULL, NULL, 4),
(138371, NULL, 'G3DSA:1.20.5.120:FF:000006', NULL, NULL, 'Protein CBG13260', NULL, NULL, NULL, NULL, NULL, 4),
(138372, NULL, 'G3DSA:1.10.510.10:FF:004064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138373, NULL, 'G3DSA:1.10.630.10:FF:000806', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138374, NULL, 'G3DSA:3.30.2350.20:FF:000005', NULL, NULL, 'pseudouridylate synthase 7 homolog-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(138375, NULL, 'G3DSA:2.30.30.790:FF:000023', NULL, NULL, 'Mitochondrial ribosomal protein, putative (AFU_orthologue AFUA_5G09490)', NULL, NULL, NULL, NULL, NULL, 4),
(138376, NULL, 'G3DSA:3.40.640.10:FF:000394', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138377, NULL, 'G3DSA:3.40.50.1400:FF:000046', NULL, NULL, 'Ferrochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(138378, NULL, 'G3DSA:3.30.930.10:FF:000199', NULL, NULL, 'Octanoyltransferase LipM', NULL, NULL, NULL, NULL, NULL, 4),
(138379, NULL, 'G3DSA:3.40.50.300:FF:001673', NULL, NULL, 'Probable helicase MAGATAMA 3', NULL, NULL, NULL, NULL, NULL, 4),
(138380, NULL, 'G3DSA:2.60.40.640:FF:000018', NULL, NULL, 'HECT-type ubiquitin ligase-interacting protein creD', NULL, NULL, NULL, NULL, NULL, 4),
(138381, NULL, 'G3DSA:2.40.330.10:FF:000003', NULL, NULL, 'B3 domain-containing transcription factor FUS3', NULL, NULL, NULL, NULL, NULL, 4),
(138382, NULL, 'G3DSA:3.80.10.10:FF:000414', NULL, NULL, 'Nuclear RNA export factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(138383, NULL, 'G3DSA:1.25.40.90:FF:000043', NULL, NULL, 'Protein NRD1', NULL, NULL, NULL, NULL, NULL, 4),
(138384, NULL, 'G3DSA:2.60.40.10:FF:003437', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138385, NULL, 'G3DSA:1.10.533.10:FF:000103', NULL, NULL, 'MALT1 paracaspase', NULL, NULL, NULL, NULL, NULL, 4),
(138386, NULL, 'G3DSA:3.30.40.10:FF:001284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138387, NULL, 'G3DSA:1.25.70.10:FF:000010', NULL, NULL, 'Transcription termination factor MTEF1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(138388, NULL, 'G3DSA:1.20.5.1030:FF:000002', NULL, NULL, 'Protein translocase subunit SecE', NULL, NULL, NULL, NULL, NULL, 4),
(138389, NULL, 'G3DSA:3.20.70.20:FF:000002', NULL, NULL, 'Autonomous glycyl radical cofactor', NULL, NULL, NULL, NULL, NULL, 4),
(138390, NULL, 'G3DSA:3.40.50.1000:FF:000538', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138391, NULL, 'G3DSA:3.40.50.300:FF:008322', NULL, NULL, 'ABC transporter AbcH.3', NULL, NULL, NULL, NULL, NULL, 4),
(138392, NULL, 'G3DSA:3.40.50.1820:FF:000672', NULL, NULL, 'Alpha/beta_hydrolase_family/alpha /beta_hydrolase_fold_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(138393, NULL, 'G3DSA:6.10.140.2220:FF:000025', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(138394, NULL, 'G3DSA:3.20.20.140:FF:000095', NULL, NULL, 'DNA polymerase III subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(138395, NULL, 'G3DSA:2.60.120.330:FF:000154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138396, NULL, 'G3DSA:2.30.29.30:FF:001198', NULL, NULL, 'Arf-GAP with dual PH domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(138397, NULL, 'G3DSA:2.60.120.260:FF:000217', NULL, NULL, 'Netrin 5', NULL, NULL, NULL, NULL, NULL, 4),
(138398, NULL, 'G3DSA:3.30.160.60:FF:000863', NULL, NULL, 'fez family zinc finger protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(138399, NULL, 'G3DSA:1.20.1280.50:FF:000153', NULL, NULL, 'F-box/LRR-repeat protein 4', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(138400, NULL, 'G3DSA:2.20.100.10:FF:000221', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(138401, NULL, 'G3DSA:3.90.1410.10:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138402, NULL, 'G3DSA:2.60.120.920:FF:000168', NULL, NULL, 'Mediterranean fever', NULL, NULL, NULL, NULL, NULL, 4),
(138403, NULL, 'G3DSA:1.20.1250.20:FF:002019', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(138404, NULL, 'G3DSA:1.10.510.10:FF:004221', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138405, NULL, 'G3DSA:3.10.350.10:FF:000002', NULL, NULL, 'Oxidation resistance protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(138406, NULL, 'G3DSA:2.60.40.10:FF:004865', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138407, NULL, 'G3DSA:1.25.10.10:FF:000894', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(138408, NULL, 'G3DSA:3.30.70.580:FF:000060', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(138409, NULL, 'G3DSA:2.60.40.3330:FF:000003', NULL, NULL, 'Transthyretin-like protein 52', NULL, NULL, NULL, NULL, NULL, 4),
(138410, NULL, 'G3DSA:1.10.1450.10:FF:000151', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(138411, NULL, 'G3DSA:3.30.565.10:FF:000030', NULL, NULL, 'Ethylene receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(138412, NULL, 'G3DSA:3.30.710.10:FF:000155', NULL, NULL, 'Longitudinals lacking protein, isoforms F/I/K/T', NULL, NULL, NULL, NULL, NULL, 4),
(138413, NULL, 'G3DSA:3.30.70.330:FF:001542', NULL, NULL, 'RH03791p', NULL, NULL, NULL, NULL, NULL, 4),
(138414, NULL, 'G3DSA:2.130.10.10:FF:005450', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138415, NULL, 'G3DSA:2.60.40.10:FF:004741', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138416, NULL, 'G3DSA:3.90.180.10:FF:000173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138417, NULL, 'G3DSA:1.10.10.10:FF:001231', NULL, NULL, 'RNA polymerase III subunit C3', NULL, NULL, NULL, NULL, NULL, 4),
(138418, NULL, 'G3DSA:2.130.10.10:FF:001055', NULL, NULL, 'Ribosome assembly protein 4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138419, NULL, 'G3DSA:3.30.160.60:FF:001700', NULL, NULL, 'Zinc finger protein 677', NULL, NULL, NULL, NULL, NULL, 4),
(138420, NULL, 'G3DSA:3.90.550.10:FF:000662', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(138421, NULL, 'G3DSA:1.20.1560.10:FF:000331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138422, NULL, 'G3DSA:4.10.1240.10:FF:000026', NULL, NULL, 'Blast:Peroxidasin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(138423, NULL, 'G3DSA:3.20.20.80:FF:000045', NULL, NULL, 'Glucosidase II alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(138424, NULL, 'G3DSA:2.20.25.10:FF:000048', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(138425, NULL, 'G3DSA:3.20.20.70:FF:000396', NULL, NULL, 'Probable oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(138426, NULL, 'G3DSA:2.130.10.10:FF:001167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138427, NULL, 'G3DSA:2.70.150.10:FF:000078', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(138428, NULL, 'G3DSA:3.30.9.10:FF:000082', NULL, NULL, 'D-amino acid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(138429, NULL, 'G3DSA:2.60.40.60:FF:001064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138430, NULL, 'G3DSA:1.10.20.10:FF:000332', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138431, NULL, 'G3DSA:3.40.50.1820:FF:001397', NULL, NULL, 'Putative esterase/lipase 1', NULL, NULL, NULL, NULL, NULL, 4),
(138432, NULL, 'G3DSA:2.60.40.180:FF:000015', NULL, NULL, '5-hydroxyisourate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(138433, NULL, 'G3DSA:3.30.40.10:FF:002065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138434, NULL, 'G3DSA:2.80.10.50:FF:000057', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(138435, NULL, 'G3DSA:3.40.50.10190:FF:000214', NULL, NULL, 'Breast cancer type 1 susceptibility protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(138436, NULL, 'G3DSA:3.90.1150.210:FF:000027', NULL, NULL, 'F-actin-capping protein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(138437, NULL, 'G3DSA:3.40.50.150:FF:000711', NULL, NULL, 'Yersiniabactin polyketide/non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(138438, NULL, 'G3DSA:3.40.50.300:FF:008446', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138439, NULL, 'G3DSA:3.90.1150.10:FF:000491', NULL, NULL, 'Putative cystathionine gamma-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(138440, NULL, 'G3DSA:1.20.1090.10:FF:000014', NULL, NULL, 'Alcohol dehydrogenase, iron-dependent', NULL, NULL, NULL, NULL, NULL, 4),
(138441, NULL, 'G3DSA:3.30.1120.90:FF:000003', NULL, NULL, 'Nucleosome assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(138442, NULL, 'G3DSA:1.10.442.10:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138443, NULL, 'G3DSA:2.10.22.10:FF:000003', NULL, NULL, 'Cysteine rich transmembrane BMP regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(138444, NULL, 'G3DSA:2.120.10.80:FF:000295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138445, NULL, 'G3DSA:3.30.420.40:FF:000776', NULL, NULL, 'Hydantoin utilization protein A', NULL, NULL, NULL, NULL, NULL, 4),
(138446, NULL, 'G3DSA:1.10.2000.10:FF:000073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138447, NULL, 'G3DSA:3.40.50.150:FF:000599', NULL, NULL, 'Protein arginine N-methyltransferase 7', NULL, NULL, NULL, NULL, NULL, 4),
(138448, NULL, 'G3DSA:4.10.640.10:FF:000043', NULL, NULL, '28S ribosomal protein S18b, mitochondrial-like', NULL, NULL, NULL, NULL, NULL, 4),
(138449, NULL, 'G3DSA:2.60.320.20:FF:000001', NULL, NULL, 'Envelope glycoprotein E2', NULL, NULL, NULL, NULL, NULL, 4),
(138450, NULL, 'G3DSA:3.30.160.60:FF:005011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138451, NULL, 'G3DSA:3.40.190.290:FF:000064', NULL, NULL, 'Transcriptional regulator LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(138452, NULL, 'G3DSA:1.25.40.10:FF:002520', NULL, NULL, 'DNA-binding SARP family transcriptional activator', NULL, NULL, NULL, NULL, NULL, 4),
(138453, NULL, 'G3DSA:1.20.58.60:FF:000681', NULL, NULL, 'Microtubule-actin crosslinking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(138454, NULL, 'G3DSA:3.40.350.10:FF:000063', NULL, NULL, 'xaa-Pro aminopeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(138455, NULL, 'G3DSA:2.60.40.10:FF:002712', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(138456, NULL, 'G3DSA:3.10.100.10:FF:000282', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138457, NULL, 'G3DSA:1.10.8.720:FF:000054', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(138458, NULL, 'G3DSA:2.40.50.690:FF:000006', NULL, NULL, 'Exosome complex exonuclease RRP44 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(138459, NULL, 'G3DSA:3.40.50.2300:FF:000889', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138460, NULL, 'G3DSA:1.20.1560.10:FF:000882', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138461, NULL, 'G3DSA:2.60.40.60:FF:000057', NULL, NULL, 'protocadherin-15 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(138462, NULL, 'G3DSA:3.90.470.20:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138463, NULL, 'G3DSA:3.40.140.10:FF:000249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138464, NULL, 'G3DSA:1.10.10.60:FF:001044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138465, NULL, 'G3DSA:1.10.510.10:FF:000910', NULL, NULL, 'Wall-associated receptor kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(138466, NULL, 'G3DSA:3.40.50.720:FF:001063', NULL, NULL, 'NADH:ubiquinone oxidoreductase subunit A9', NULL, NULL, NULL, NULL, NULL, 4),
(138467, NULL, 'G3DSA:1.25.10.10:FF:002131', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(138468, NULL, 'G3DSA:2.30.29.30:FF:001378', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138469, NULL, 'G3DSA:3.10.270.10:FF:000001', NULL, NULL, 'Uricase', NULL, NULL, NULL, NULL, NULL, 4),
(138470, NULL, 'G3DSA:1.10.10.820:FF:000003', NULL, NULL, 'unconventional myosin-IXa isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(138471, NULL, 'G3DSA:3.40.50.1820:FF:001768', NULL, NULL, 'Lipase', NULL, NULL, NULL, NULL, NULL, 4),
(138472, NULL, 'G3DSA:2.130.10.10:FF:003937', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138473, NULL, 'G3DSA:1.10.10.750:FF:000010', NULL, NULL, 'EVI5-like protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(138474, NULL, 'G3DSA:1.25.10.10:FF:001967', NULL, NULL, 'Serine/threonine-protein kinase VPS15', NULL, NULL, NULL, NULL, NULL, 4),
(138475, NULL, 'G3DSA:1.25.40.10:FF:001874', NULL, NULL, 'Uncharacterized protein yjr088c homologue, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138476, NULL, 'G3DSA:1.10.555.10:FF:000148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138477, NULL, 'G3DSA:1.10.1420.10:FF:000059', NULL, NULL, 'MutS homolog 3 (E. coli)', NULL, NULL, NULL, NULL, NULL, 4),
(138478, NULL, 'G3DSA:3.30.479.30:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138479, NULL, 'G3DSA:1.10.150.90:FF:000001', NULL, NULL, 'Gag polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(138480, NULL, 'G3DSA:3.30.160.60:FF:003729', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138481, NULL, 'G3DSA:1.20.58.1220:FF:000003', NULL, NULL, 'Exocyst 84, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(138482, NULL, 'G3DSA:2.60.40.10:FF:003229', NULL, NULL, 'T-cell surface antigen CD2', NULL, NULL, NULL, NULL, NULL, 4),
(138483, NULL, 'G3DSA:3.30.40.10:FF:002273', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(138484, NULL, 'G3DSA:2.10.90.10:FF:000087', NULL, NULL, 'Bone morphogenetic protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(138485, NULL, 'G3DSA:1.10.150.50:FF:000068', NULL, NULL, 'Ephrin type-B receptor 6', NULL, NULL, NULL, NULL, NULL, 4),
(138486, NULL, 'G3DSA:3.90.1150.10:FF:000159', NULL, NULL, 'Glycine dehydrogenase (decarboxylating)', NULL, NULL, NULL, NULL, NULL, 4),
(138487, NULL, 'G3DSA:3.30.200.20:FF:001294', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138488, NULL, 'G3DSA:3.40.50.300:FF:000684', NULL, NULL, 'Elongation factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(138489, NULL, 'G3DSA:3.40.50.150:FF:001375', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138490, NULL, 'G3DSA:1.10.10.10:FF:001731', NULL, NULL, 'Two component transcriptional regulator, winged helix family', NULL, NULL, NULL, NULL, NULL, 4),
(138491, NULL, 'G3DSA:3.40.50.1110:FF:000015', NULL, NULL, 'GDSL family lipase', NULL, NULL, NULL, NULL, NULL, 4),
(138492, NULL, 'G3DSA:3.90.79.10:FF:000302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138493, NULL, 'G3DSA:3.90.70.10:FF:000833', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138494, NULL, 'G3DSA:1.10.1170.10:FF:000017', NULL, NULL, 'Death-associated inhibitor of apoptosis 1', NULL, NULL, NULL, NULL, NULL, 4),
(138495, NULL, 'G3DSA:3.30.559.30:FF:000027', NULL, NULL, 'Nonribosomal peptide synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(138496, NULL, 'G3DSA:3.30.559.10:FF:000021', NULL, NULL, 'O-acyltransferase WSD1', NULL, NULL, NULL, NULL, NULL, 4),
(138497, NULL, 'G3DSA:3.40.1810.10:FF:000075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138498, NULL, 'G3DSA:2.40.110.10:FF:000060', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(138499, NULL, 'G3DSA:1.25.40.10:FF:005185', NULL, NULL, 'Clathrin and VPS domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(138500, NULL, 'G3DSA:3.40.50.2300:FF:000737', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(138501, NULL, 'G3DSA:3.40.640.10:FF:000506', NULL, NULL, 'Putative diaminobutyrate-pyruvate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(138502, NULL, 'G3DSA:2.60.120.10:FF:000808', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138503, NULL, 'G3DSA:2.40.50.90:FF:000051', NULL, NULL, 'Unplaced genomic scaffold supercont1.17, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(138504, NULL, 'G3DSA:3.40.50.1220:FF:000048', NULL, NULL, 'Electron-transfer-flavoprotein, alpha polypeptide, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138505, NULL, 'G3DSA:1.20.120.1150:FF:000001', NULL, NULL, 'Serine/threonine-protein phosphatase 2A activator', NULL, NULL, NULL, NULL, NULL, 4),
(138506, NULL, 'G3DSA:1.10.1450.10:FF:000067', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(138507, NULL, 'G3DSA:2.40.170.20:FF:000117', NULL, NULL, 'SusC homolog', NULL, NULL, NULL, NULL, NULL, 4),
(138508, NULL, 'G3DSA:2.40.50.90:FF:000107', NULL, NULL, 'Transcription factor (Snd1/p100), putative', NULL, NULL, NULL, NULL, NULL, 4),
(138509, NULL, 'G3DSA:3.30.70.330:FF:000822', NULL, NULL, 'Ribosome biogenesis (Nop4), putative', NULL, NULL, NULL, NULL, NULL, 4),
(138510, NULL, 'G3DSA:2.20.100.10:FF:000160', NULL, NULL, 'spondin-1', NULL, NULL, NULL, NULL, NULL, 4),
(138511, NULL, 'G3DSA:3.40.50.300:FF:001122', NULL, NULL, 'AAA-ATPase ASD, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(138512, NULL, 'G3DSA:2.10.25.10:FF:001729', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138513, NULL, 'G3DSA:2.130.10.10:FF:000447', NULL, NULL, 'Denticleless protein homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(138514, NULL, 'G3DSA:3.90.70.10:FF:000193', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(138515, NULL, 'G3DSA:2.130.10.10:FF:003584', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(138516, NULL, 'G3DSA:1.20.1310.10:FF:000043', NULL, NULL, 'Cullin-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138517, NULL, 'G3DSA:1.20.1640.10:FF:000096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138518, NULL, 'G3DSA:3.40.1550.10:FF:000004', NULL, NULL, 'CheC-like family protein', NULL, NULL, NULL, NULL, NULL, 4),
(138519, NULL, 'G3DSA:1.10.565.10:FF:000109', NULL, NULL, 'Nuclear receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138520, NULL, 'G3DSA:3.40.630.10:FF:000157', NULL, NULL, 'Dipeptidase B, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(138521, NULL, 'G3DSA:1.20.5.590:FF:000001', NULL, NULL, 'Protein phosphatase CheZ', NULL, NULL, NULL, NULL, NULL, 4),
(138522, NULL, 'G3DSA:2.10.25.10:FF:000577', NULL, NULL, 'Dumpy, isoform P', NULL, NULL, NULL, NULL, NULL, 4),
(138523, NULL, 'G3DSA:1.20.1250.20:FF:001238', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(138524, NULL, 'G3DSA:1.20.1250.20:FF:001182', NULL, NULL, 'Jen2p', NULL, NULL, NULL, NULL, NULL, 4),
(138525, NULL, 'G3DSA:3.10.105.10:FF:000039', NULL, NULL, 'Probable glycine betaine-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(138526, NULL, 'G3DSA:2.60.120.650:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138527, NULL, 'G3DSA:3.40.33.10:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138528, NULL, 'G3DSA:3.30.160.60:FF:003145', NULL, NULL, 'CG14655', NULL, NULL, NULL, NULL, NULL, 4),
(138529, NULL, 'G3DSA:2.30.29.30:FF:000473', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(138530, NULL, 'G3DSA:3.30.160.60:FF:000683', NULL, NULL, 'Zinc finger protein 252', NULL, NULL, NULL, NULL, NULL, 4),
(138531, NULL, 'G3DSA:2.60.40.10:FF:005989', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138532, NULL, 'G3DSA:3.10.280.10:FF:000007', NULL, NULL, 'Regulatory protein SUAPRGA1', NULL, NULL, NULL, NULL, NULL, 4),
(138533, NULL, 'G3DSA:3.60.70.12:FF:000011', NULL, NULL, 'Arginine biosynthesis bifunctional protein ArgJ 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(138534, NULL, 'G3DSA:3.30.70.1710:FF:000001', NULL, NULL, 'Ethanolamine utilization protein EutM', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(138535, NULL, 'G3DSA:3.40.50.720:FF:001804', NULL, NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(138536, NULL, 'G3DSA:1.20.120.230:FF:000010', NULL, NULL, 'Vinculin a', NULL, NULL, NULL, NULL, NULL, 4),
(138537, NULL, 'G3DSA:1.10.510.10:FF:001427', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(138538, NULL, 'G3DSA:3.40.50.1970:FF:000037', NULL, NULL, 'Probable iron-containing alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(138539, NULL, 'G3DSA:3.40.50.300:FF:006973', NULL, NULL, 'Polynucleotide 5''-hydroxyl-kinase NOL9-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(138540, NULL, 'G3DSA:3.30.497.10:FF:000040', NULL, NULL, 'Serpin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138541, NULL, 'G3DSA:3.40.50.970:FF:000160', NULL, NULL, 'Sulfite reductase (NADPH) subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(138542, NULL, 'G3DSA:3.40.50.410:FF:000082', NULL, NULL, 'Collagen type VI alpha 5 chain', NULL, NULL, NULL, NULL, NULL, 4),
(138543, NULL, 'G3DSA:2.60.40.640:FF:000086', NULL, NULL, 'Putative arrestin-related trafficking adapter SPBC839.02', NULL, NULL, NULL, NULL, NULL, 4),
(138544, NULL, 'G3DSA:3.40.50.720:FF:001692', NULL, NULL, 'Os06g0299200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(138545, NULL, 'G3DSA:3.30.70.1400:FF:000015', NULL, NULL, 'sarcosine dehydrogenase, mitochondrial-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(138546, NULL, 'G3DSA:3.40.50.880:FF:000189', NULL, NULL, 'Carbamoyl-phosphate synthase small chain', NULL, NULL, NULL, NULL, NULL, 4),
(138547, NULL, 'G3DSA:3.30.450.30:FF:000062', NULL, NULL, 'AGAP013030-PA', NULL, NULL, NULL, NULL, NULL, 4),
(138548, NULL, 'G3DSA:2.30.30.40:FF:000136', NULL, NULL, 'Rho GTPase activating protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(138549, NULL, 'G3DSA:2.40.50.1070:FF:000009', NULL, NULL, '23S rRNA m(5)U-1939 methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(138550, NULL, 'G3DSA:1.20.58.60:FF:000361', NULL, NULL, 'Spectrin, beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(138551, NULL, 'G3DSA:3.30.1330.30:FF:000125', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(138552, NULL, 'G3DSA:1.25.10.10:FF:003148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138553, NULL, 'G3DSA:3.30.70.330:FF:001042', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138554, NULL, 'G3DSA:1.10.580.10:FF:000004', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(138555, NULL, 'G3DSA:2.60.120.260:FF:000285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138556, NULL, 'G3DSA:1.10.150.20:FF:000317', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(138557, NULL, 'G3DSA:3.80.10.10:FF:003904', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138558, NULL, 'G3DSA:1.20.1560.10:FF:000674', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(138559, NULL, 'G3DSA:2.60.120.420:FF:000001', NULL, NULL, 'Outer capsid protein mu-1', NULL, NULL, NULL, NULL, NULL, 4),
(138560, NULL, 'G3DSA:2.60.40.10:FF:005646', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138561, NULL, 'G3DSA:3.40.1050.10:FF:000011', NULL, NULL, 'Beta-carbonic anhydrase 1', NULL, NULL, NULL, NULL, NULL, 4),
(138562, NULL, 'G3DSA:1.10.10.60:FF:000436', NULL, NULL, 'Intermediate neuroblasts defective', NULL, NULL, NULL, NULL, NULL, 4),
(138563, NULL, 'G3DSA:1.20.5.340:FF:000067', NULL, NULL, 'Kinesin family member C1', NULL, NULL, NULL, NULL, NULL, 4),
(138564, NULL, 'G3DSA:2.30.29.30:FF:000130', NULL, NULL, 'neural Wiskott-Aldrich syndrome protein', NULL, NULL, NULL, NULL, NULL, 4),
(138565, NULL, 'G3DSA:3.40.50.1820:FF:001189', NULL, NULL, 'Prolylcarboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138566, NULL, 'G3DSA:1.10.10.60:FF:000700', NULL, NULL, 'Transcriptional regulator, AraC/XylS family', NULL, NULL, NULL, NULL, NULL, 4),
(138567, NULL, 'G3DSA:3.90.810.10:FF:000020', NULL, NULL, 'WASP (Actin cytoskeleton modulator) homolog', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(138568, NULL, 'G3DSA:3.40.50.150:FF:000835', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(138569, NULL, 'G3DSA:2.20.70.10:FF:000012', NULL, NULL, 'transcriptional coactivator YAP1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(138570, NULL, 'G3DSA:3.40.50.2000:FF:000529', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(138571, NULL, 'G3DSA:2.130.10.10:FF:004601', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138572, NULL, 'G3DSA:2.60.450.20:FF:000005', NULL, NULL, 'Lyst-interacting protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138573, NULL, 'G3DSA:1.20.1250.20:FF:002087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138574, NULL, 'G3DSA:2.60.40.2660:FF:000004', NULL, NULL, 'Ankyrin', NULL, NULL, NULL, NULL, NULL, 4),
(138575, NULL, 'G3DSA:1.20.1720.10:FF:000097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138576, NULL, 'G3DSA:3.80.10.10:FF:001515', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(138577, NULL, 'G3DSA:3.40.50.300:FF:000892', NULL, NULL, 'probable ATP-dependent RNA helicase DDX49', NULL, NULL, NULL, NULL, NULL, 4),
(138578, NULL, 'G3DSA:3.40.140.10:FF:000193', NULL, NULL, 'CysO-cysteine peptidase protein', NULL, NULL, NULL, NULL, NULL, 4),
(138579, NULL, 'G3DSA:4.10.400.10:FF:000289', NULL, NULL, 'GM17661', NULL, NULL, NULL, NULL, NULL, 4),
(138580, NULL, 'G3DSA:3.30.870.10:FF:000048', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(138581, NULL, 'G3DSA:3.40.50.980:FF:000050', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(138582, NULL, 'G3DSA:3.30.1360.120:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138583, NULL, 'G3DSA:2.120.10.30:FF:000358', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138584, NULL, 'G3DSA:2.40.50.140:FF:000252', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC8', NULL, NULL, NULL, NULL, NULL, 4),
(138585, NULL, 'G3DSA:3.30.40.10:FF:001216', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(138586, NULL, 'G3DSA:3.30.70.100:FF:000130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138587, NULL, 'G3DSA:3.50.50.60:FF:000365', NULL, NULL, 'L-lysine N6-monooxygenase MbtG', NULL, NULL, NULL, NULL, NULL, 4),
(138588, NULL, 'G3DSA:1.10.510.10:FF:000674', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138589, NULL, 'G3DSA:2.60.40.1660:FF:000013', NULL, NULL, 'GD20124', NULL, NULL, NULL, NULL, NULL, 4),
(138590, NULL, 'G3DSA:2.30.42.10:FF:000548', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138591, NULL, 'G3DSA:1.25.40.20:FF:000724', NULL, NULL, 'Rel', NULL, NULL, NULL, NULL, NULL, 4),
(138592, NULL, 'G3DSA:3.40.1000.30:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138593, NULL, 'G3DSA:2.60.40.10:FF:001431', NULL, NULL, 'phosphatidylinositol phosphatase PTPRQ isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(138594, NULL, 'G3DSA:1.25.40.20:FF:001000', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138595, NULL, 'G3DSA:3.20.180.20:FF:000006', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(138596, NULL, 'G3DSA:3.90.660.10:FF:000103', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138597, NULL, 'G3DSA:1.10.1270.10:FF:000002', NULL, NULL, 'Trp operon repressor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(138598, NULL, 'G3DSA:1.10.238.10:FF:000810', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138599, NULL, 'G3DSA:3.30.420.40:FF:000512', NULL, NULL, 'Actin related protein 10 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(138600, NULL, 'G3DSA:1.25.40.180:FF:000296', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138601, NULL, 'G3DSA:3.40.50.300:FF:002347', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(138602, NULL, 'G3DSA:2.10.109.10:FF:000018', NULL, NULL, 'Mitochondrial inner membrane protease subunit', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(138603, NULL, 'G3DSA:2.60.40.10:FF:000003', NULL, NULL, 'Titin isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(138604, NULL, 'G3DSA:3.40.30.10:FF:000861', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138605, NULL, 'G3DSA:3.30.160.60:FF:002869', NULL, NULL, 'Comb gap splice variant cg14', NULL, NULL, NULL, NULL, NULL, 4),
(138606, NULL, 'G3DSA:1.10.8.240:FF:000005', NULL, NULL, '2-phospho-L-lactate transferase', NULL, NULL, NULL, NULL, NULL, 4),
(138607, NULL, 'G3DSA:2.130.10.10:FF:000835', NULL, NULL, 'RNA polymerase II Elongator subunit', NULL, NULL, NULL, NULL, NULL, 4),
(138608, NULL, 'G3DSA:2.130.10.10:FF:003241', NULL, NULL, 'LD47550p', NULL, NULL, NULL, NULL, NULL, 4),
(138609, NULL, 'G3DSA:3.40.50.720:FF:000843', NULL, NULL, 'D-arabinitol dehydrogenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(138610, NULL, 'G3DSA:1.10.3450.40:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138611, NULL, 'G3DSA:1.25.10.10:FF:000686', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(138612, NULL, 'G3DSA:1.10.287.70:FF:000149', NULL, NULL, 'Cyclic nucleotide-gated cation channel beta-1', NULL, NULL, NULL, NULL, NULL, 4),
(138613, NULL, 'G3DSA:2.170.150.80:FF:000018', NULL, NULL, 'Os02g0286000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(138614, NULL, 'G3DSA:3.40.50.720:FF:001416', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(138615, NULL, 'G3DSA:1.10.20.120:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138616, NULL, 'G3DSA:1.10.220.10:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138617, NULL, 'G3DSA:1.20.1070.10:FF:001524', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138618, NULL, 'G3DSA:1.25.40.770:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138619, NULL, 'G3DSA:2.130.10.10:FF:003320', NULL, NULL, 'Elongator subunit', NULL, NULL, NULL, NULL, NULL, 4),
(138620, NULL, 'G3DSA:1.25.10.10:FF:001350', NULL, NULL, 'ER chaperone/ER translocation nucleotide exchange factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138621, NULL, 'G3DSA:3.40.50.300:FF:003707', NULL, NULL, 'ATP-dependent DNA helicase CHL1', NULL, NULL, NULL, NULL, NULL, 4),
(138622, NULL, 'G3DSA:3.90.70.80:FF:000073', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(138623, NULL, 'G3DSA:2.60.120.200:FF:000227', NULL, NULL, 'Concanavalin-A', NULL, NULL, NULL, NULL, NULL, 4),
(138624, NULL, 'G3DSA:1.25.40.10:FF:000446', NULL, NULL, 'Pre-mRNA-splicing factor syf1', NULL, NULL, NULL, NULL, NULL, 4),
(138625, NULL, 'G3DSA:2.70.170.10:FF:000141', NULL, NULL, 'gamma-aminobutyric acid receptor subunit beta-3-like', NULL, NULL, NULL, NULL, NULL, 4),
(138626, NULL, 'G3DSA:3.30.1360.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138627, NULL, 'G3DSA:3.10.20.90:FF:000284', NULL, NULL, 'Ubiquitin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(138628, NULL, 'G3DSA:3.30.505.10:FF:000189', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138629, NULL, 'G3DSA:2.40.128.80:FF:000003', NULL, NULL, 'Cathepsin C', NULL, NULL, NULL, NULL, NULL, 4),
(138630, NULL, 'G3DSA:3.30.200.20:FF:001647', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138631, NULL, 'G3DSA:1.10.10.10:FF:000793', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(138632, NULL, 'G3DSA:2.130.10.10:FF:000711', NULL, NULL, 'Zinc finger protein 106', NULL, NULL, NULL, NULL, NULL, 4),
(138633, NULL, 'G3DSA:3.10.28.10:FF:000036', NULL, NULL, 'Uncharacterized cox1 intron-2 37.2 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(138634, NULL, 'G3DSA:3.60.15.10:FF:000212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138635, NULL, 'G3DSA:3.30.60.30:FF:000189', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(138636, NULL, 'G3DSA:3.40.630.30:FF:000495', NULL, NULL, 'UDP-N-acetylmuramoylpentapeptide-lysine N(6)-alanyltransferase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(138637, NULL, 'G3DSA:3.40.50.2300:FF:000384', NULL, NULL, 'Ionotropic receptor 25a', NULL, NULL, NULL, NULL, NULL, 4),
(138638, NULL, 'G3DSA:1.10.287.1880:FF:000002', NULL, NULL, 'Blast:Protein zwilch', NULL, NULL, NULL, NULL, NULL, 4),
(138639, NULL, 'G3DSA:3.40.50.170:FF:000021', NULL, NULL, 'Phosphoribosylglycinamide formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(138640, NULL, 'G3DSA:1.10.2020.20:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138641, NULL, 'G3DSA:3.40.710.10:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138642, NULL, 'G3DSA:1.10.472.10:FF:000192', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(138643, NULL, 'G3DSA:1.10.472.80:FF:000105', NULL, NULL, 'GTPase-activating protein GYP6', NULL, NULL, NULL, NULL, NULL, 4),
(138644, NULL, 'G3DSA:3.90.70.10:FF:000754', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(138645, NULL, 'G3DSA:3.30.160.60:FF:004106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138646, NULL, 'G3DSA:1.20.140.40:FF:000091', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138647, NULL, 'G3DSA:3.90.79.10:FF:000061', NULL, NULL, '7,8-dihydro-8-oxoguanine-triphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(138648, NULL, 'G3DSA:3.30.70.330:FF:002267', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138649, NULL, 'G3DSA:3.30.50.10:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138650, NULL, 'G3DSA:3.80.10.10:FF:000678', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(138651, NULL, 'G3DSA:1.10.530.10:FF:000001', NULL, NULL, 'Lysozyme C', NULL, NULL, NULL, NULL, NULL, 4),
(138652, NULL, 'G3DSA:3.40.50.150:FF:000094', NULL, NULL, 'Carnosine N-methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(138653, NULL, 'G3DSA:3.90.190.10:FF:000499', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138654, NULL, 'G3DSA:1.10.4160.10:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138655, NULL, 'G3DSA:1.20.1250.20:FF:001570', NULL, NULL, 'Transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(138656, NULL, 'G3DSA:3.90.1110.10:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138657, NULL, 'G3DSA:3.40.50.720:FF:000282', NULL, NULL, 'Glyoxylate reductase protein', NULL, NULL, NULL, NULL, NULL, 4),
(138658, NULL, 'G3DSA:3.10.20.90:FF:000464', NULL, NULL, 'Os10g0200000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(138659, NULL, 'G3DSA:3.10.150.10:FF:000003', NULL, NULL, 'Beta sliding clamp', NULL, NULL, NULL, NULL, NULL, 4),
(138660, NULL, 'G3DSA:3.40.50.300:FF:005220', NULL, NULL, 'Rab_B05 protein', NULL, NULL, NULL, NULL, NULL, 4),
(138661, NULL, 'G3DSA:3.30.420.110:FF:000061', NULL, NULL, 'DNA mismatch repair protein MSH3', NULL, NULL, NULL, NULL, NULL, 4),
(138662, NULL, 'G3DSA:1.20.1070.10:FF:000423', NULL, NULL, 'NeuroPeptide Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(138663, NULL, 'G3DSA:3.10.110.10:FF:000349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138664, NULL, 'G3DSA:3.30.420.40:FF:000855', NULL, NULL, 'Xylulokinase homolog (H. influenzae)', NULL, NULL, NULL, NULL, NULL, 4),
(138665, NULL, 'G3DSA:2.60.40.10:FF:001251', NULL, NULL, 'usherin', NULL, NULL, NULL, NULL, NULL, 4),
(138666, NULL, 'G3DSA:3.30.160.60:FF:006135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138667, NULL, 'G3DSA:1.20.900.10:FF:000117', NULL, NULL, 'Rac guanine nucleotide exchange factor B', NULL, NULL, NULL, NULL, NULL, 4),
(138668, NULL, 'G3DSA:3.30.930.10:FF:000435', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138669, NULL, 'G3DSA:1.10.3720.10:FF:000043', NULL, NULL, 'Putrescine ABC transporter permease PotH', NULL, NULL, NULL, NULL, NULL, 4),
(138670, NULL, 'G3DSA:2.130.10.10:FF:001408', NULL, NULL, 'FI01301p', NULL, NULL, NULL, NULL, NULL, 4),
(138671, NULL, 'G3DSA:2.60.40.10:FF:000975', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(138672, NULL, 'G3DSA:3.80.10.10:FF:004388', NULL, NULL, 'Si:ch211-11p18.6', NULL, NULL, NULL, NULL, NULL, 4),
(138673, NULL, 'G3DSA:3.40.30.10:FF:001249', NULL, NULL, 'NADH-ubiquinone oxidoreductase 24 kDa subunit homolog C11E3.12, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(138674, NULL, 'G3DSA:3.30.519.10:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138675, NULL, 'G3DSA:3.30.160.60:FF:001588', NULL, NULL, 'Zinc finger protein 82 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(138676, NULL, 'G3DSA:3.10.310.10:FF:000005', NULL, NULL, 'Proline racemase', NULL, NULL, NULL, NULL, NULL, 4),
(138677, NULL, 'G3DSA:1.20.1530.20:FF:000040', NULL, NULL, 'Solute carrier family 10, member 4', NULL, NULL, NULL, NULL, NULL, 4),
(138678, NULL, 'G3DSA:3.30.160.190:FF:000002', NULL, NULL, 'NADH dehydrogenase [ubiquinone] iron-sulfur protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(138679, NULL, 'G3DSA:3.40.1390.30:FF:000008', NULL, NULL, 'NGG1 interacting factor Nif3', NULL, NULL, NULL, NULL, NULL, 4),
(138680, NULL, 'G3DSA:1.10.510.10:FF:002540', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase kinase', NULL, NULL, NULL, NULL, NULL, 4),
(138681, NULL, 'G3DSA:3.90.176.10:FF:000011', NULL, NULL, 'C3 family ADP-ribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(138682, NULL, 'G3DSA:3.40.50.300:FF:008530', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138683, NULL, 'G3DSA:1.10.760.10:FF:000069', NULL, NULL, 'Cytochrome C', NULL, NULL, NULL, NULL, NULL, 4),
(138684, NULL, 'G3DSA:3.40.50.300:FF:007693', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(138685, NULL, 'G3DSA:3.40.50.2300:FF:001518', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138686, NULL, 'G3DSA:3.30.160.20:FF:000014', NULL, NULL, 'double-stranded RNA-binding protein Staufen homolog 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(138687, NULL, 'G3DSA:2.60.120.590:FF:000024', NULL, NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(138688, NULL, 'G3DSA:1.25.50.20:FF:000068', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(138689, NULL, 'G3DSA:3.40.850.10:FF:000056', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(138690, NULL, 'G3DSA:3.40.50.2000:FF:001081', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(138691, NULL, 'G3DSA:3.80.10.10:FF:003163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138692, NULL, 'G3DSA:2.120.10.30:FF:000015', NULL, NULL, 'Low-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(138693, NULL, 'G3DSA:1.25.40.10:FF:005117', NULL, NULL, 'DnaJ homolog subfamily C member 7 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(138694, NULL, 'G3DSA:3.90.226.10:FF:000105', NULL, NULL, 'Possible enoyl-CoA hydratase echA9', NULL, NULL, NULL, NULL, NULL, 4),
(138695, NULL, 'G3DSA:3.30.2410.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138696, NULL, 'G3DSA:3.30.70.370:FF:000014', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(138697, NULL, 'G3DSA:2.80.10.50:FF:000237', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(138698, NULL, 'G3DSA:1.25.50.10:FF:000008', NULL, NULL, 'Aminopeptidase N', NULL, NULL, NULL, NULL, NULL, 4),
(138699, NULL, 'G3DSA:2.130.10.10:FF:005793', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', NULL, NULL, NULL, NULL, NULL, 4),
(138700, NULL, 'G3DSA:2.60.120.260:FF:000009', NULL, NULL, 'SUN domain-containing protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(138701, NULL, 'G3DSA:3.40.1500.10:FF:000001', NULL, NULL, 'Oxygen-dependent coproporphyrinogen-III oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(138702, NULL, 'G3DSA:3.40.50.10090:FF:000010', NULL, NULL, 'Uroporphyrinogen-III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(138703, NULL, 'G3DSA:2.40.30.10:FF:000520', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(138704, NULL, 'G3DSA:3.40.50.150:FF:001055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138705, NULL, 'G3DSA:3.30.40.10:FF:000199', NULL, NULL, 'Bromodomain adjacent to zinc finger domain 2B', NULL, NULL, NULL, NULL, NULL, 4),
(138706, NULL, 'G3DSA:1.10.630.10:FF:000065', NULL, NULL, 'Cytochrome P450 family 7 subfamily B member 1', NULL, NULL, NULL, NULL, NULL, 4),
(138707, NULL, 'G3DSA:3.30.40.10:FF:001952', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138708, NULL, 'G3DSA:3.40.50.740:FF:000006', NULL, NULL, 'NADH-quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(138709, NULL, 'G3DSA:2.20.70.70:FF:000002', NULL, NULL, 'Penicillin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(138710, NULL, 'G3DSA:1.10.238.10:FF:000485', NULL, NULL, 'Probable calcium-binding protein CML44', NULL, NULL, NULL, NULL, NULL, 4),
(138711, NULL, 'G3DSA:3.90.550.10:FF:000218', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(138712, NULL, 'G3DSA:1.20.1260.10:FF:000050', NULL, NULL, 'Diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(138713, NULL, 'G3DSA:3.40.1480.10:FF:000004', NULL, NULL, 'MOFRL family protein', NULL, NULL, NULL, NULL, NULL, 4),
(138714, NULL, 'G3DSA:1.10.510.10:FF:002591', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138715, NULL, 'G3DSA:2.130.10.10:FF:000043', NULL, NULL, 'pre-mRNA-processing factor 19', NULL, NULL, NULL, NULL, NULL, 4),
(138716, NULL, 'G3DSA:1.20.1310.10:FF:000167', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138717, NULL, 'G3DSA:1.20.1560.10:FF:000887', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138718, NULL, 'G3DSA:3.30.160.60:FF:002656', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138719, NULL, 'G3DSA:2.40.10.250:FF:000001', NULL, NULL, 'Orf1a polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(138720, NULL, 'G3DSA:1.20.1250.20:FF:001070', NULL, NULL, 'Yin, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(138721, NULL, 'G3DSA:2.60.40.10:FF:002212', NULL, NULL, 'Interference hedgehog', NULL, NULL, NULL, NULL, NULL, 4),
(138722, NULL, 'G3DSA:3.80.10.10:FF:000122', NULL, NULL, 'F-box/LRR-repeat protein 7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(138723, NULL, 'G3DSA:3.40.1000.70:FF:000003', NULL, NULL, 'Possible lipoprotein LpqQ', NULL, NULL, NULL, NULL, NULL, 4),
(138724, NULL, 'G3DSA:3.40.50.2300:FF:000389', NULL, NULL, 'Two-component response regulator ORR9', NULL, NULL, NULL, NULL, NULL, 4),
(138725, NULL, 'G3DSA:3.90.79.10:FF:000010', NULL, NULL, 'GDP-mannose pyrophosphatase NudK', NULL, NULL, NULL, NULL, NULL, 4),
(138726, NULL, 'G3DSA:3.40.50.300:FF:001965', NULL, NULL, 'ATP-dependent DNA helicase UvrD', NULL, NULL, NULL, NULL, NULL, 4),
(138727, NULL, 'G3DSA:1.20.80.10:FF:000015', NULL, NULL, 'FERM domain-containing protein 6 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(138728, NULL, 'G3DSA:1.10.238.10:FF:000541', NULL, NULL, 'CRE-STA-2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(138729, NULL, 'G3DSA:3.30.40.10:FF:001896', NULL, NULL, 'RING/U-box superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(138730, NULL, 'G3DSA:1.10.1240.40:FF:000009', NULL, NULL, 'Emsy N Terminus (ENT)/ plant Tudor-like domains-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(138731, NULL, 'G3DSA:2.10.25.10:FF:000689', NULL, NULL, 'Netrin G2', NULL, NULL, NULL, NULL, NULL, 4),
(138732, NULL, 'G3DSA:3.30.590.10:FF:000043', NULL, NULL, 'Creatine kinase, brain b', NULL, NULL, NULL, NULL, NULL, 4),
(138733, NULL, 'G3DSA:2.30.30.40:FF:000316', NULL, NULL, 'Myosin tail region-interacting protein MTI1', NULL, NULL, NULL, NULL, NULL, 4),
(138734, NULL, 'G3DSA:2.120.10.30:FF:000246', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(138735, NULL, 'G3DSA:3.40.50.2300:FF:000445', NULL, NULL, 'Glutamate receptor, ionotropic, N-methyl D-aspartate 2D, b', NULL, NULL, NULL, NULL, NULL, 4),
(138736, NULL, 'G3DSA:3.30.200.20:FF:000170', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(138737, NULL, 'G3DSA:2.60.40.10:FF:002156', NULL, NULL, 'Beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(138738, NULL, 'G3DSA:2.40.240.10:FF:000064', NULL, NULL, 'Glutamine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(138739, NULL, 'G3DSA:3.60.40.10:FF:000113', NULL, NULL, 'Serine/threonine phosphoprotein phosphatase Stp1', NULL, NULL, NULL, NULL, NULL, 4),
(138740, NULL, 'G3DSA:3.40.50.1970:FF:000014', NULL, NULL, 'Ethanolamine utilization protein EutG', NULL, NULL, NULL, NULL, NULL, 4),
(138741, NULL, 'G3DSA:2.30.29.30:FF:000361', NULL, NULL, 'TBC1 domain family member 1 isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(138742, NULL, 'G3DSA:2.40.50.140:FF:000752', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138743, NULL, 'G3DSA:1.20.140.150:FF:000136', NULL, NULL, 'Transmembrane protein 114', NULL, NULL, NULL, NULL, NULL, 4),
(138744, NULL, 'G3DSA:3.30.160.60:FF:002712', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138745, NULL, 'G3DSA:3.30.565.10:FF:000530', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138746, NULL, 'G3DSA:2.120.10.30:FF:000302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138747, NULL, 'G3DSA:4.10.1240.50:FF:000015', NULL, NULL, 'ELM2 domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(138748, NULL, 'G3DSA:2.30.42.10:FF:000380', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138749, NULL, 'G3DSA:2.130.10.30:FF:000105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138750, NULL, 'G3DSA:3.30.420.40:FF:000332', NULL, NULL, 'Unplaced genomic scaffold supercont2.11, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(138751, NULL, 'G3DSA:1.25.40.650:FF:000004', NULL, NULL, 'Penicillin-binding protein activator LpoA', NULL, NULL, NULL, NULL, NULL, 4),
(138752, NULL, 'G3DSA:1.10.510.10:FF:001130', NULL, NULL, 'Serine/threonine-protein kinase KDX1', NULL, NULL, NULL, NULL, NULL, 4),
(138753, NULL, 'G3DSA:3.20.20.70:FF:000053', NULL, NULL, 'Glutamate synthase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(138754, NULL, 'G3DSA:3.80.10.10:FF:001690', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase PXC2', NULL, NULL, NULL, NULL, NULL, 4),
(138755, NULL, 'G3DSA:1.10.630.10:FF:000621', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138756, NULL, 'G3DSA:1.20.1640.10:FF:000040', NULL, NULL, 'Export membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(138757, NULL, 'G3DSA:2.60.40.10:FF:001700', NULL, NULL, 'Immunoglobulin lambda variable 8-61', NULL, NULL, NULL, NULL, NULL, 4),
(138758, NULL, 'G3DSA:2.130.10.10:FF:004314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138759, NULL, 'G3DSA:2.40.50.100:FF:000195', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(138760, NULL, 'G3DSA:3.40.50.720:FF:000051', NULL, NULL, 'STEAP2 metalloreductase', NULL, NULL, NULL, NULL, NULL, 4),
(138761, NULL, 'G3DSA:3.30.559.70:FF:000016', NULL, NULL, 'Protein CBG16408', NULL, NULL, NULL, NULL, NULL, 4),
(138762, NULL, 'G3DSA:3.90.190.10:FF:000179', NULL, NULL, 'Phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138763, NULL, 'G3DSA:2.120.10.30:FF:000297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138764, NULL, 'G3DSA:1.10.10.10:FF:001787', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(138765, NULL, 'G3DSA:3.40.50.300:FF:005332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138766, NULL, 'G3DSA:3.40.50.720:FF:000899', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(138767, NULL, 'G3DSA:1.10.510.10:FF:003788', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138768, NULL, 'G3DSA:2.60.40.10:FF:000391', NULL, NULL, 'TEK receptor tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(138769, NULL, 'G3DSA:2.30.30.380:FF:000018', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(138770, NULL, 'G3DSA:2.60.40.10:FF:004680', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(138771, NULL, 'G3DSA:3.30.342.10:FF:000001', NULL, NULL, 'DNA polymerase epsilon catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(138772, NULL, 'G3DSA:3.40.50.1820:FF:000964', NULL, NULL, 'Phospholipase ABHD3', NULL, NULL, NULL, NULL, NULL, 4),
(138773, NULL, 'G3DSA:2.60.40.10:FF:005966', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138774, NULL, 'G3DSA:1.10.3720.10:FF:000223', NULL, NULL, 'Sugar ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(138775, NULL, 'G3DSA:3.30.70.600:FF:000010', NULL, NULL, '39S ribosomal protein L48, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(138776, NULL, 'G3DSA:1.20.1740.10:FF:000036', NULL, NULL, 'Solute carrier family 7 member 13', NULL, NULL, NULL, NULL, NULL, 4),
(138777, NULL, 'G3DSA:1.20.1070.10:FF:001547', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138778, NULL, 'G3DSA:3.30.160.60:FF:006023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138779, NULL, 'G3DSA:3.30.70.270:FF:000315', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138780, NULL, 'G3DSA:1.10.472.10:FF:000129', NULL, NULL, 'Tryptophan synthase', NULL, NULL, NULL, NULL, NULL, 4),
(138781, NULL, 'G3DSA:3.30.1130.10:FF:000019', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(138782, NULL, 'G3DSA:3.40.50.1010:FF:000199', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138783, NULL, 'G3DSA:3.20.20.80:FF:000382', NULL, NULL, 'AGAP001200-PA', NULL, NULL, NULL, NULL, NULL, 4),
(138784, NULL, 'G3DSA:3.10.180.10:FF:000062', NULL, NULL, '4-hydroxyphenylpyruvate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(138785, NULL, 'G3DSA:3.30.160.710:FF:000001', NULL, NULL, 'Hemagglutination activity domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(138786, NULL, 'G3DSA:3.30.160.20:FF:000019', NULL, NULL, 'RISC-loading complex subunit TARBP2', NULL, NULL, NULL, NULL, NULL, 4),
(138787, NULL, 'G3DSA:3.90.640.10:FF:000192', NULL, NULL, 'Actin-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(138788, NULL, 'G3DSA:3.40.50.1440:FF:000086', NULL, NULL, 'Tubulin gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(138789, NULL, 'G3DSA:3.30.40.10:FF:000435', NULL, NULL, 'Tripartite motif containing 71, E3 ubiquitin protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(138790, NULL, 'G3DSA:3.80.10.10:FF:004444', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138791, NULL, 'G3DSA:1.20.1720.10:FF:000041', NULL, NULL, 'Multidrug resistance protein D', NULL, NULL, NULL, NULL, NULL, 4),
(138792, NULL, 'G3DSA:1.10.287.410:FF:000010', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(138793, NULL, 'G3DSA:3.40.50.970:FF:000221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138794, NULL, 'G3DSA:1.25.40.20:FF:001523', NULL, NULL, 'Protein 21.1', NULL, NULL, NULL, NULL, NULL, 4),
(138795, NULL, 'G3DSA:3.40.50.300:FF:001061', NULL, NULL, 'Glutathione import ATP-binding protein GsiA', NULL, NULL, NULL, NULL, NULL, 4),
(138796, NULL, 'G3DSA:1.10.510.10:FF:002484', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138797, NULL, 'G3DSA:3.40.50.970:FF:000165', NULL, NULL, '2-oxoglutarate:ferredoxin oxidoreductase, thiamin diphosphate-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(138798, NULL, 'G3DSA:3.40.50.2300:FF:000501', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(138799, NULL, 'G3DSA:1.25.40.10:FF:002599', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(138800, NULL, 'G3DSA:2.60.40.760:FF:000004', NULL, NULL, 'Swollenin like protein', NULL, NULL, NULL, NULL, NULL, 4),
(138801, NULL, 'G3DSA:2.60.40.10:FF:001751', NULL, NULL, 'HMCN2 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(138802, NULL, 'G3DSA:1.10.630.10:FF:000565', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138803, NULL, 'G3DSA:1.20.1050.10:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138804, NULL, 'G3DSA:1.25.40.20:FF:001416', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(138805, NULL, 'G3DSA:3.40.710.10:FF:000107', NULL, NULL, 'Penicillin-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138806, NULL, 'G3DSA:3.60.15.10:FF:000156', NULL, NULL, 'Ribonuclease Z, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138807, NULL, 'G3DSA:3.80.10.10:FF:004337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138808, NULL, 'G3DSA:1.20.58.120:FF:000006', NULL, NULL, 'BAG family molecular chaperone regulator 3', NULL, NULL, NULL, NULL, NULL, 4),
(138809, NULL, 'G3DSA:3.30.70.20:FF:000029', NULL, NULL, 'Formate dehydrogenase iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4),
(138810, NULL, 'G3DSA:3.30.70.330:FF:001834', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138811, NULL, 'G3DSA:3.40.50.150:FF:001032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138812, NULL, 'G3DSA:3.40.50.300:FF:005276', NULL, NULL, 'Interferon induced protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(138813, NULL, 'G3DSA:2.130.10.10:FF:001459', NULL, NULL, 'Nuclear pore complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(138814, NULL, 'G3DSA:1.20.1070.10:FF:000243', NULL, NULL, 'G protein-coupled receptor 20', NULL, NULL, NULL, NULL, NULL, 4),
(138815, NULL, 'G3DSA:1.20.1070.10:FF:000979', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138816, NULL, 'G3DSA:2.30.42.10:FF:000228', NULL, NULL, 'Rab3 interacting molecule, isoform R', NULL, NULL, NULL, NULL, NULL, 4),
(138817, NULL, 'G3DSA:1.20.120.980:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138818, NULL, 'G3DSA:3.40.50.300:FF:001858', NULL, NULL, 'DExH-box ATP-dependent RNA helicase DExH17', NULL, NULL, NULL, NULL, NULL, 4),
(138819, NULL, 'G3DSA:3.40.50.360:FF:000095', NULL, NULL, 'NADPH-dependent FMN reductase Lot6, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138820, NULL, 'G3DSA:3.30.465.10:FF:000045', NULL, NULL, '2-hydroxy-acid oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(138821, NULL, 'G3DSA:3.30.70.1660:FF:000014', NULL, NULL, 'Peptide chain release factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(138822, NULL, 'G3DSA:3.10.20.870:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138823, NULL, 'G3DSA:3.30.1380.20:FF:000007', NULL, NULL, 'Trafficking protein particle complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(138824, NULL, 'G3DSA:3.40.1280.10:FF:000112', NULL, NULL, 'Methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(138825, NULL, 'G3DSA:1.20.120.1760:FF:000066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138826, NULL, 'G3DSA:1.20.940.10:FF:000002', NULL, NULL, 'Pre-mRNA processing factor 18', NULL, NULL, NULL, NULL, NULL, 4),
(138827, NULL, 'G3DSA:3.10.20.30:FF:000081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138828, NULL, 'G3DSA:3.90.640.10:FF:000085', NULL, NULL, 'Actin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138829, NULL, 'G3DSA:2.60.200.20:FF:000133', NULL, NULL, 'Probable E3 ubiquitin-protein ligase dma1', NULL, NULL, NULL, NULL, NULL, 4),
(138830, NULL, 'G3DSA:2.130.10.10:FF:002460', NULL, NULL, 'Protein CBG01041', NULL, NULL, NULL, NULL, NULL, 4),
(138831, NULL, 'G3DSA:3.30.70.330:FF:002216', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138832, NULL, 'G3DSA:1.10.150.20:FF:000312', NULL, NULL, 'DNA polymerase iota', NULL, NULL, NULL, NULL, NULL, 4),
(138833, NULL, 'G3DSA:1.20.1250.20:FF:001862', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138834, NULL, 'G3DSA:3.90.215.10:FF:000024', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(138835, NULL, 'G3DSA:3.30.870.10:FF:000025', NULL, NULL, 'Phospholipase D delta', NULL, NULL, NULL, NULL, NULL, 4),
(138836, NULL, 'G3DSA:1.20.1250.20:FF:001974', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138837, NULL, 'G3DSA:3.50.50.60:FF:000028', NULL, NULL, 'Thioredoxin reductase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(138838, NULL, 'G3DSA:4.10.470.20:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(138839, NULL, 'G3DSA:3.40.50.1820:FF:000172', NULL, NULL, 'Epoxide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(138840, NULL, 'G3DSA:2.40.33.10:FF:000044', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(138841, NULL, 'G3DSA:3.10.10.10:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138842, NULL, 'G3DSA:3.50.50.60:FF:001489', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(138843, NULL, 'G3DSA:3.40.50.720:FF:001248', NULL, NULL, 'NADPH-adrenodoxin reductase', NULL, NULL, NULL, NULL, NULL, 4),
(138844, NULL, 'G3DSA:1.20.1070.10:FF:000187', NULL, NULL, 'G-protein coupled receptor 15', NULL, NULL, NULL, NULL, NULL, 4),
(138845, NULL, 'G3DSA:3.90.1800.10:FF:000018', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(138846, NULL, 'G3DSA:4.10.860.10:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138847, NULL, 'G3DSA:2.130.10.10:FF:001403', NULL, NULL, 'Unplaced genomic scaffold supercont1.17, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(138848, NULL, 'G3DSA:2.60.40.60:FF:000900', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138849, NULL, 'G3DSA:1.25.40.10:FF:000626', NULL, NULL, 'Serine/threonine protein phosphatase 5', NULL, NULL, NULL, NULL, NULL, 4),
(138850, NULL, 'G3DSA:3.20.20.70:FF:000160', NULL, NULL, 'Probable galactinol--sucrose galactosyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(138851, NULL, 'G3DSA:3.40.50.300:FF:008261', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138852, NULL, 'G3DSA:3.30.1140.32:FF:000012', NULL, NULL, '30S ribosomal protein S3', NULL, NULL, NULL, NULL, NULL, 4),
(138853, NULL, 'G3DSA:3.40.50.10810:FF:000052', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(138854, NULL, 'G3DSA:3.40.440.10:FF:000002', NULL, NULL, 'Adenylosuccinate synthetase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(138855, NULL, 'G3DSA:2.60.200.20:FF:000189', NULL, NULL, 'Aprataxin and PNK-like factor', NULL, NULL, NULL, NULL, NULL, 4),
(138856, NULL, 'G3DSA:1.25.10.10:FF:000006', NULL, NULL, 'CLIP-associating protein 1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(138857, NULL, 'G3DSA:3.80.10.10:FF:000173', NULL, NULL, 'PH domain and leucine rich repeat protein phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(138858, NULL, 'G3DSA:2.60.120.1540:FF:000016', NULL, NULL, 'Thiolester containing protein I', NULL, NULL, NULL, NULL, NULL, 4),
(138859, NULL, 'G3DSA:3.30.160.60:FF:001296', NULL, NULL, 'Zinc finger protein 582', NULL, NULL, NULL, NULL, NULL, 4),
(138860, NULL, 'G3DSA:1.25.40.20:FF:000163', NULL, NULL, 'Fem-1 homolog c (C.elegans)', NULL, NULL, NULL, NULL, NULL, 4),
(138861, NULL, 'G3DSA:1.10.510.10:FF:003844', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138862, NULL, 'G3DSA:3.40.30.10:FF:000529', NULL, NULL, 'Peroxiredoxin 1', NULL, NULL, NULL, NULL, NULL, 4),
(138863, NULL, 'G3DSA:2.60.40.10:FF:001695', NULL, NULL, 'Erythroblast membrane associated protein (Scianna blood group)', NULL, NULL, NULL, NULL, NULL, 4),
(138864, NULL, 'G3DSA:1.25.40.10:FF:000738', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(138865, NULL, 'G3DSA:3.90.228.10:FF:000003', NULL, NULL, 'TCDD-inducible poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(138866, NULL, 'G3DSA:3.30.70.1450:FF:000013', NULL, NULL, 'Trk system potassium transporter TrkA', NULL, NULL, NULL, NULL, NULL, 4),
(138867, NULL, 'G3DSA:3.80.10.10:FF:003084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138868, NULL, 'G3DSA:3.90.148.10:FF:000002', NULL, NULL, 'DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(138869, NULL, 'G3DSA:3.40.50.300:FF:001914', NULL, NULL, 'YML133C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(138870, NULL, 'G3DSA:1.10.8.60:FF:000396', NULL, NULL, 'DnaA regulatory inactivator Hda', NULL, NULL, NULL, NULL, NULL, 4),
(138871, NULL, 'G3DSA:1.10.630.10:FF:000514', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(138872, NULL, 'G3DSA:2.60.120.10:FF:000247', NULL, NULL, 'Putative transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(138873, NULL, 'G3DSA:1.10.510.10:FF:002439', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138874, NULL, 'G3DSA:3.40.30.10:FF:000681', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138875, NULL, 'G3DSA:1.10.238.10:FF:000434', NULL, NULL, 'GD13508', NULL, NULL, NULL, NULL, NULL, 4),
(138876, NULL, 'G3DSA:1.20.1250.20:FF:000513', NULL, NULL, 'Probable MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(138877, NULL, 'G3DSA:1.20.5.190:FF:000038', NULL, NULL, 'calmodulin-binding transcription activator 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(138878, NULL, 'G3DSA:3.30.365.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138879, NULL, 'G3DSA:3.40.50.720:FF:001299', NULL, NULL, 'Sepiapterin reductase', NULL, NULL, NULL, NULL, NULL, 4),
(138880, NULL, 'G3DSA:1.25.10.10:FF:002367', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138881, NULL, 'G3DSA:3.90.780.10:FF:000027', NULL, NULL, 'Alkaline phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(138882, NULL, 'G3DSA:3.40.50.1820:FF:001532', NULL, NULL, 'Oleoyl-ACP hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(138883, NULL, 'G3DSA:1.10.10.440:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138884, NULL, 'G3DSA:3.40.50.740:FF:000057', NULL, NULL, 'NADH-quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(138885, NULL, 'G3DSA:2.60.470.10:FF:000003', NULL, NULL, 'Amiloride-sensitive sodium channel subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(138886, NULL, 'G3DSA:1.10.12.10:FF:000044', NULL, NULL, 'Enoyl-CoA hydratase/carnithine racemase', NULL, NULL, NULL, NULL, NULL, 4),
(138887, NULL, 'G3DSA:3.30.70.20:FF:000092', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138888, NULL, 'G3DSA:1.20.5.1160:FF:000018', NULL, NULL, 'nestin', NULL, NULL, NULL, NULL, NULL, 4),
(138889, NULL, 'G3DSA:1.20.58.70:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138890, NULL, 'G3DSA:3.30.300.30:FF:000051', NULL, NULL, 'O-succinylbenzoic acid--CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(138891, NULL, 'G3DSA:3.30.420.40:FF:000276', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(138892, NULL, 'G3DSA:2.60.34.20:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138893, NULL, 'G3DSA:2.40.160.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138894, NULL, 'G3DSA:1.10.10.60:FF:000032', NULL, NULL, 'Zinc finger and SCAN domain-containing 20', NULL, NULL, NULL, NULL, NULL, 4),
(138895, NULL, 'G3DSA:2.60.40.2610:FF:000006', NULL, NULL, 'Fimbrial biogenesis outer membrane usher protein', NULL, NULL, NULL, NULL, NULL, 4),
(138896, NULL, 'G3DSA:3.40.50.1000:FF:000038', NULL, NULL, 'Fructose-1-phosphate/6-phosphogluconate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(138897, NULL, 'G3DSA:1.10.340.30:FF:000060', NULL, NULL, 'Endonuclease III homolog', NULL, NULL, NULL, NULL, NULL, 4),
(138898, NULL, 'G3DSA:1.25.40.10:FF:004049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138899, NULL, 'G3DSA:3.30.160.60:FF:005511', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138900, NULL, 'G3DSA:3.30.950.10:FF:000026', NULL, NULL, 'Precorrin-6Y C5,15-methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138901, NULL, 'G3DSA:3.30.457.60:FF:000024', NULL, NULL, 'Mitotic arrest deficient 1-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(138902, NULL, 'G3DSA:3.40.50.300:FF:001173', NULL, NULL, 'signal recognition particle receptor subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(138903, NULL, 'G3DSA:1.10.8.60:FF:000340', NULL, NULL, 'Replication factor C small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(138904, NULL, 'G3DSA:3.30.200.20:FF:001479', NULL, NULL, 'Protein roller-3', NULL, NULL, NULL, NULL, NULL, 4),
(138905, NULL, 'G3DSA:3.30.160.60:FF:000840', NULL, NULL, 'PR domain zinc finger protein 4', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(138906, NULL, 'G3DSA:3.10.129.10:FF:000038', NULL, NULL, 'Acyl-CoA thioester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(138907, NULL, 'G3DSA:1.10.510.10:FF:001023', NULL, NULL, 'Os07g0541700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(138908, NULL, 'G3DSA:3.40.50.300:FF:008210', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(138909, NULL, 'G3DSA:1.20.120.680:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138910, NULL, 'G3DSA:3.90.1140.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138911, NULL, 'G3DSA:3.30.160.60:FF:006079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138912, NULL, 'G3DSA:1.20.1310.10:FF:000223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138913, NULL, 'G3DSA:2.60.40.150:FF:000708', NULL, NULL, 'Phosphatidylinositol 3-kinase class, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138914, NULL, 'G3DSA:3.30.230.130:FF:000052', NULL, NULL, 'Cullin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(138915, NULL, 'G3DSA:1.10.600.10:FF:000001', NULL, NULL, 'Geranylgeranyl diphosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(138916, NULL, 'G3DSA:2.30.180.10:FF:000050', NULL, NULL, 'YLR001C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(138917, NULL, 'G3DSA:3.40.50.1010:FF:000255', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138918, NULL, 'G3DSA:3.90.70.10:FF:000485', NULL, NULL, 'Cysteine protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138919, NULL, 'G3DSA:1.20.1540.10:FF:000111', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(138920, NULL, 'G3DSA:2.30.42.10:FF:000205', NULL, NULL, 'SpoIVB peptidase 42 kDa isoform', NULL, NULL, NULL, NULL, NULL, 4),
(138921, NULL, 'G3DSA:3.40.50.150:FF:000886', NULL, NULL, 'Protein-L-isoaspartate O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(138922, NULL, 'G3DSA:2.10.220.10:FF:000193', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(138923, NULL, 'G3DSA:3.60.21.10:FF:000193', NULL, NULL, 'Double-strand break repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(138924, NULL, 'G3DSA:2.30.30.40:FF:000491', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(138925, NULL, 'G3DSA:1.10.20.120:FF:000003', NULL, NULL, 'Ribonuclease H2 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(138926, NULL, 'G3DSA:3.30.930.10:FF:000194', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase gcn-2', NULL, NULL, NULL, NULL, NULL, 4),
(138927, NULL, 'G3DSA:1.20.1070.10:FF:000131', NULL, NULL, 'alpha-2A adrenergic receptor', NULL, NULL, NULL, NULL, NULL, 4),
(138928, NULL, 'G3DSA:1.10.1240.20:FF:000003', NULL, NULL, 'Lytic murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(138929, NULL, 'G3DSA:1.10.10.10:FF:000438', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(138930, NULL, 'G3DSA:1.20.120.1320:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138931, NULL, 'G3DSA:2.130.10.10:FF:002864', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', NULL, NULL, NULL, NULL, NULL, 4),
(138932, NULL, 'G3DSA:1.10.1670.10:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138933, NULL, 'G3DSA:1.10.8.270:FF:000104', NULL, NULL, 'Rab-GTPase-TBC_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(138934, NULL, 'G3DSA:3.60.20.10:FF:000230', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138935, NULL, 'G3DSA:1.20.1080.10:FF:000013', NULL, NULL, 'Aquaporin NIP2-1', NULL, NULL, NULL, NULL, NULL, 4),
(138936, NULL, 'G3DSA:1.20.58.70:FF:000066', NULL, NULL, 't-SNARE family protein', NULL, NULL, NULL, NULL, NULL, 4),
(138937, NULL, 'G3DSA:1.10.400.10:FF:000020', NULL, NULL, 'Guanine nucleotide-binding protein G(o) subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(138938, NULL, 'G3DSA:1.20.120.420:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138939, NULL, 'G3DSA:1.10.472.10:FF:000641', NULL, NULL, 'Cyclin A', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(138940, NULL, 'G3DSA:1.20.120.720:FF:000005', NULL, NULL, 'unconventional myosin-VI isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(138941, NULL, 'G3DSA:1.10.220.150:FF:000051', NULL, NULL, 'ADP-ribosylation factor GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(138942, NULL, 'G3DSA:2.40.100.10:FF:000115', NULL, NULL, 'Probable peptidyl-prolyl cis-trans isomerase sll0227', NULL, NULL, NULL, NULL, NULL, 4),
(138943, NULL, 'G3DSA:3.40.50.300:FF:004787', NULL, NULL, 'ATP-binding cassette sub-family A member 3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(138944, NULL, 'G3DSA:3.30.40.10:FF:002352', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(138945, NULL, 'G3DSA:2.40.100.10:FF:000059', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(138946, NULL, 'G3DSA:3.40.1390.30:FF:000003', NULL, NULL, 'Nif3-like dinuclear metal center protein', NULL, NULL, NULL, NULL, NULL, 4),
(138947, NULL, 'G3DSA:3.30.750.24:FF:000024', NULL, NULL, 'Sulfate permease 2', NULL, NULL, NULL, NULL, NULL, 4),
(138948, NULL, 'G3DSA:1.10.8.50:FF:000011', NULL, NULL, 'Ribosomal protein S13', NULL, NULL, NULL, NULL, NULL, 4),
(138949, NULL, 'G3DSA:2.60.40.60:FF:000344', NULL, NULL, 'Cadherin 2', NULL, NULL, NULL, NULL, NULL, 4),
(138950, NULL, 'G3DSA:3.80.10.10:FF:000234', NULL, NULL, 'Probable inactive receptor kinase RLK902', NULL, NULL, NULL, NULL, NULL, 4),
(138951, NULL, 'G3DSA:3.30.70.330:FF:000530', NULL, NULL, 'Polyadenylate-binding protein-interacting protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(138952, NULL, 'G3DSA:3.40.50.10470:FF:000028', NULL, NULL, 'Methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(138953, NULL, 'G3DSA:3.30.519.10:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138954, NULL, 'G3DSA:3.80.10.10:FF:000178', NULL, NULL, 'protein AMN1 homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(138955, NULL, 'G3DSA:1.20.1560.10:FF:000831', NULL, NULL, 'Protein CBG12969', NULL, NULL, NULL, NULL, NULL, 4),
(138956, NULL, 'G3DSA:1.10.3370.10:FF:000010', NULL, NULL, 'Protein transport protein SEC61 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(138957, NULL, 'G3DSA:3.90.132.10:FF:000005', NULL, NULL, 'Leishmanolysin metalloprotease M8', NULL, NULL, NULL, NULL, NULL, 4),
(138958, NULL, 'G3DSA:3.80.30.20:FF:000002', NULL, NULL, 'threonylcarbamoyladenosine tRNA methylthiotransferase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(138959, NULL, 'G3DSA:2.130.10.10:FF:000155', NULL, NULL, 'Autophagy-related protein 16-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(138960, NULL, 'G3DSA:2.10.25.10:FF:001145', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(138961, NULL, 'G3DSA:3.30.70.850:FF:000012', NULL, NULL, 'Subtilisin-related protease SPC2', NULL, NULL, NULL, NULL, NULL, 4),
(138962, NULL, 'G3DSA:3.40.50.720:FF:002316', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138963, NULL, 'G3DSA:3.20.20.10:FF:000018', NULL, NULL, 'Pyridoxal phosphate homeostasis protein', NULL, NULL, NULL, NULL, NULL, 4),
(138964, NULL, 'G3DSA:3.40.50.150:FF:000650', NULL, NULL, 'Polyketide synthase RzxC', NULL, NULL, NULL, NULL, NULL, 4),
(138965, NULL, 'G3DSA:3.40.190.10:FF:000140', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(138966, NULL, 'G3DSA:3.40.640.10:FF:000006', NULL, NULL, '5-aminolevulinate synthase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(138967, NULL, 'G3DSA:3.90.280.10:FF:000006', NULL, NULL, 'protein D3', NULL, NULL, NULL, NULL, NULL, 4),
(138968, NULL, 'G3DSA:3.90.79.10:FF:000122', NULL, NULL, 'Nudix hydrolase 21', NULL, NULL, NULL, NULL, NULL, 4),
(138969, NULL, 'G3DSA:1.10.10.2330:FF:000001', NULL, NULL, 'phenylalanine--tRNA ligase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(138970, NULL, 'G3DSA:3.40.50.1760:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138971, NULL, 'G3DSA:3.40.50.150:FF:000594', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(138972, NULL, 'G3DSA:1.20.1070.10:FF:000182', NULL, NULL, 'gastrin/cholecystokinin type B receptor', NULL, NULL, NULL, NULL, NULL, 4),
(138973, NULL, 'G3DSA:2.10.25.10:FF:001089', NULL, NULL, 'AGAP007849-PA', NULL, NULL, NULL, NULL, NULL, 4),
(138974, NULL, 'G3DSA:3.90.79.10:FF:000066', NULL, NULL, 'DDP1p Polyphosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(138975, NULL, 'G3DSA:3.30.200.20:FF:000282', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase FEI 1', NULL, NULL, NULL, NULL, NULL, 4),
(138976, NULL, 'G3DSA:3.30.2310.20:FF:000008', NULL, NULL, 'Toxin', NULL, NULL, NULL, NULL, NULL, 4),
(138977, NULL, 'G3DSA:1.25.40.10:FF:001290', NULL, NULL, 'Os12g0233200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(138978, NULL, 'G3DSA:1.10.720.30:FF:000050', NULL, NULL, 'SAP domain-containing ribonucleoprotein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(138979, NULL, 'G3DSA:3.10.450.50:FF:000095', NULL, NULL, 'NTF2-related export protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(138980, NULL, 'G3DSA:1.20.1540.10:FF:000055', NULL, NULL, 'Rhomboid family intramembrane serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(138981, NULL, 'G3DSA:3.40.190.10:FF:000084', NULL, NULL, 'glutamate receptor ionotropic, NMDA 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(138982, NULL, 'G3DSA:3.30.420.40:FF:000220', NULL, NULL, 'D-ribulose kinase', NULL, NULL, NULL, NULL, NULL, 4),
(138983, NULL, 'G3DSA:3.90.930.12:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138984, NULL, 'G3DSA:3.40.630.150:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138985, NULL, 'G3DSA:3.40.1190.20:FF:000018', NULL, NULL, 'Ketohexokinase', NULL, NULL, NULL, NULL, NULL, 4),
(138986, NULL, 'G3DSA:2.60.40.420:FF:000071', NULL, NULL, 'Conidial pigment biosynthesis oxidase Abr1/brown 1', NULL, NULL, NULL, NULL, NULL, 4),
(138987, NULL, 'G3DSA:3.30.420.40:FF:000271', NULL, NULL, 'actin-related protein 3B isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(138988, NULL, 'G3DSA:3.90.70.10:FF:000777', NULL, NULL, 'Ubiquitin-specific peptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(138989, NULL, 'G3DSA:3.30.1150.10:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138990, NULL, 'G3DSA:1.20.1050.80:FF:000004', NULL, NULL, 'ankyrin repeat domain-containing protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(138991, NULL, 'G3DSA:2.60.40.60:FF:000288', NULL, NULL, 'cadherin-12 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(138992, NULL, 'G3DSA:3.30.160.60:FF:000391', NULL, NULL, 'zinc finger protein 652 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(138993, NULL, 'G3DSA:3.40.50.300:FF:000509', NULL, NULL, 'ADP-ribosylation factor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(138994, NULL, 'G3DSA:3.40.50.300:FF:004843', NULL, NULL, 'DNA polymerase III subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(138995, NULL, 'G3DSA:3.40.50.1780:FF:000019', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', NULL, NULL, NULL, NULL, NULL, 4),
(138996, NULL, 'G3DSA:1.20.58.70:FF:000122', NULL, NULL, 'Probable syntaxin-7B', NULL, NULL, NULL, NULL, NULL, 4),
(138997, NULL, 'G3DSA:3.40.50.150:FF:000942', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(138998, NULL, 'G3DSA:3.10.110.10:FF:000344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(138999, NULL, 'G3DSA:3.90.550.50:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139000, NULL, 'G3DSA:3.30.200.20:FF:000630', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139001, NULL, 'G3DSA:3.80.10.10:FF:002090', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(139002, NULL, 'G3DSA:1.10.510.10:FF:000915', NULL, NULL, 'Serine/threonine-protein kinase ATG1', NULL, NULL, NULL, NULL, NULL, 4),
(139003, NULL, 'G3DSA:3.30.750.24:FF:000075', NULL, NULL, 'GD11313', NULL, NULL, NULL, NULL, NULL, 4),
(139004, NULL, 'G3DSA:1.10.8.270:FF:000048', NULL, NULL, 'Rab GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(139005, NULL, 'G3DSA:1.10.220.100:FF:000002', NULL, NULL, 'Yeast Enhancer of DeCapping homolog', NULL, NULL, NULL, NULL, NULL, 4),
(139006, NULL, 'G3DSA:2.130.10.10:FF:003825', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139007, NULL, 'G3DSA:1.20.1310.10:FF:000228', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139008, NULL, 'G3DSA:1.10.510.10:FF:003440', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139009, NULL, 'G3DSA:3.40.50.300:FF:003882', NULL, NULL, 'Tyrosine-protein kinase ptk', NULL, NULL, NULL, NULL, NULL, 4),
(139010, NULL, 'G3DSA:3.75.10.10:FF:000016', NULL, NULL, 'Amidinotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139011, NULL, 'G3DSA:3.90.190.10:FF:000230', NULL, NULL, 'Dual specificity protein phosphatase 12', NULL, NULL, NULL, NULL, NULL, 4),
(139012, NULL, 'G3DSA:3.40.50.300:FF:006636', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139013, NULL, 'G3DSA:1.10.510.10:FF:000966', NULL, NULL, 'Serine/threonine-protein kinase 3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139014, NULL, 'G3DSA:1.10.10.60:FF:000144', NULL, NULL, 'homeobox-leucine zipper protein ATHB-6-like', NULL, NULL, NULL, NULL, NULL, 4),
(139015, NULL, 'G3DSA:1.10.510.10:FF:001135', NULL, NULL, 'Protein CBG16501', NULL, NULL, NULL, NULL, NULL, 4),
(139016, NULL, 'G3DSA:1.10.510.10:FF:000567', NULL, NULL, 'cGMP-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(139017, NULL, 'G3DSA:1.10.230.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139018, NULL, 'G3DSA:3.30.160.60:FF:003201', NULL, NULL, 'Zinc finger protein 212', NULL, NULL, NULL, NULL, NULL, 4),
(139019, NULL, 'G3DSA:2.40.40.10:FF:000009', NULL, NULL, 'Allergenic cerato-platanin Asp F13 (AFU_orthologue AFUA_2G12630)', NULL, NULL, NULL, NULL, NULL, 4),
(139020, NULL, 'G3DSA:3.60.21.50:FF:000025', NULL, NULL, 'DNA polymerase delta small subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139021, NULL, 'G3DSA:1.20.58.310:FF:000001', NULL, NULL, 'Polyphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(139022, NULL, 'G3DSA:2.60.40.10:FF:005062', NULL, NULL, 'Gelation factor', NULL, NULL, NULL, NULL, NULL, 4),
(139023, NULL, 'G3DSA:1.10.510.10:FF:000859', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(139024, NULL, 'G3DSA:3.50.50.60:FF:001085', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(139025, NULL, 'G3DSA:3.50.50.60:FF:000180', NULL, NULL, 'Glutamate synthase 1 [NADH] chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(139026, NULL, 'G3DSA:3.30.1010.10:FF:000039', NULL, NULL, 'Related to PIK1-phosphatidylinositol 4-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(139027, NULL, 'G3DSA:1.25.40.10:FF:002251', NULL, NULL, 'Intraflagellar transport particle protein IFT88', NULL, NULL, NULL, NULL, NULL, 4),
(139028, NULL, 'G3DSA:3.40.50.150:FF:000543', NULL, NULL, 'Class I SAM-dependent methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(139029, NULL, 'G3DSA:3.40.47.10:FF:000276', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139030, NULL, 'G3DSA:3.40.50.300:FF:000953', NULL, NULL, 'GTPase Der', NULL, NULL, NULL, NULL, NULL, 4),
(139031, NULL, 'G3DSA:3.90.190.10:FF:000123', NULL, NULL, 'Similar to protein tyrosine/serine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(139032, NULL, 'G3DSA:3.40.50.300:FF:000661', NULL, NULL, 'calmodulin-interacting protein 111 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(139033, NULL, 'G3DSA:3.60.21.10:FF:000209', NULL, NULL, '2'',3''-cyclic-nucleotide 2''-phosphodiesterase / 3''-nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(139034, NULL, 'G3DSA:1.25.40.440:FF:000003', NULL, NULL, 'Nuclear pore complex protein Nup155', NULL, NULL, NULL, NULL, NULL, 4),
(139035, NULL, 'G3DSA:3.30.200.20:FF:000231', NULL, NULL, 'Cyclin-dependent kinase B2,2', NULL, NULL, NULL, NULL, NULL, 4),
(139036, NULL, 'G3DSA:1.10.510.10:FF:004277', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139037, NULL, 'G3DSA:3.20.110.10:FF:000004', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(139038, NULL, 'G3DSA:3.20.20.140:FF:000319', NULL, NULL, 'Metal-dependent phosphoesterase, PHP family protein', NULL, NULL, NULL, NULL, NULL, 4),
(139039, NULL, 'G3DSA:3.50.50.60:FF:000073', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(139040, NULL, 'G3DSA:2.60.40.10:FF:004573', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139041, NULL, 'G3DSA:3.30.160.60:FF:004281', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139042, NULL, 'G3DSA:3.30.160.60:FF:001352', NULL, NULL, 'ras-responsive element-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(139043, NULL, 'G3DSA:1.20.1260.60:FF:000003', NULL, NULL, 'IST1-like protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(139044, NULL, 'G3DSA:1.20.144.10:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139045, NULL, 'G3DSA:3.30.1330.30:FF:000069', NULL, NULL, 'Pelota protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139046, NULL, 'G3DSA:3.40.50.300:FF:007193', NULL, NULL, 'Gluconokinase', NULL, NULL, NULL, NULL, NULL, 4),
(139047, NULL, 'G3DSA:2.130.10.10:FF:005618', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139048, NULL, 'G3DSA:1.10.530.10:FF:000057', NULL, NULL, 'Endolysin', NULL, NULL, NULL, NULL, NULL, 4),
(139049, NULL, 'G3DSA:3.90.70.110:FF:000001', NULL, NULL, 'Non-structural polyprotein P1234', NULL, NULL, NULL, NULL, NULL, 4),
(139050, NULL, 'G3DSA:3.30.160.60:FF:006074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139051, NULL, 'G3DSA:3.30.930.10:FF:000250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139052, NULL, 'G3DSA:1.10.510.10:FF:001927', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(139053, NULL, 'G3DSA:3.50.50.60:FF:000865', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139054, NULL, 'G3DSA:1.20.1250.20:FF:002082', NULL, NULL, 'Os03g0197200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(139055, NULL, 'G3DSA:3.40.190.10:FF:000696', NULL, NULL, 'Bicarbonate-binding protein CmpA', NULL, NULL, NULL, NULL, NULL, 4),
(139056, NULL, 'G3DSA:1.25.10.10:FF:001462', NULL, NULL, 'Telomere repeat binding bouquet formation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(139057, NULL, 'G3DSA:3.30.160.60:FF:000239', NULL, NULL, 'C2H2 type zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(139058, NULL, 'G3DSA:1.10.3720.10:FF:000228', NULL, NULL, 'Arginine transport system permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(139059, NULL, 'G3DSA:1.10.1370.30:FF:000049', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(139060, NULL, 'G3DSA:2.60.40.10:FF:000638', NULL, NULL, 'von Willebrand factor A domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(139061, NULL, 'G3DSA:2.60.260.20:FF:000018', NULL, NULL, 'Mitochondrial protein import protein MAS5', NULL, NULL, NULL, NULL, NULL, 4),
(139062, NULL, 'G3DSA:1.10.150.20:FF:000256', NULL, NULL, 'GEN1 Holliday junction resolvase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(139063, NULL, 'G3DSA:3.40.50.720:FF:001304', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(139064, NULL, 'G3DSA:2.70.150.10:FF:000134', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(139065, NULL, 'G3DSA:1.10.510.10:FF:000174', NULL, NULL, 'Serine/threonine-protein kinase PDIK1L', NULL, NULL, NULL, NULL, NULL, 4),
(139066, NULL, 'G3DSA:3.40.50.300:FF:003483', NULL, NULL, 'WHiTe (Drosophila) related ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(139067, NULL, 'G3DSA:3.55.50.30:FF:000014', NULL, NULL, 'Putative anti-sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(139068, NULL, 'G3DSA:3.40.50.300:FF:008497', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139069, NULL, 'G3DSA:1.25.40.10:FF:002195', NULL, NULL, 'Conserved Edge Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(139070, NULL, 'G3DSA:2.130.10.10:FF:003084', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(139071, NULL, 'G3DSA:1.25.40.20:FF:000567', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139072, NULL, 'G3DSA:1.20.1280.50:FF:000102', NULL, NULL, 'Putative a receptor for ubiquitination targets', NULL, NULL, NULL, NULL, NULL, 4),
(139073, NULL, 'G3DSA:1.10.1070.11:FF:000022', NULL, NULL, 'Phosphatidylinositol 4-kinase stt4', NULL, NULL, NULL, NULL, NULL, 4),
(139074, NULL, 'G3DSA:3.60.15.10:FF:000100', NULL, NULL, 'Possible bifunctional enzyme: 2-hydroxyhepta-2,4-diene-1,7-dioate isomerase + cyclase/dehydrase', NULL, NULL, NULL, NULL, NULL, 4),
(139075, NULL, 'G3DSA:1.10.10.440:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139076, NULL, 'G3DSA:3.30.200.20:FF:001535', NULL, NULL, 'Serine/threonine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(139077, NULL, 'G3DSA:3.30.200.20:FF:002024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139078, NULL, 'G3DSA:1.25.10.10:FF:000118', NULL, NULL, 'Integrator complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(139079, NULL, 'G3DSA:1.25.40.10:FF:002543', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g62670, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(139080, NULL, 'G3DSA:1.25.10.10:FF:000973', NULL, NULL, 'WD domain, G-beta repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(139081, NULL, 'G3DSA:4.10.1000.10:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139082, NULL, 'G3DSA:3.40.50.300:FF:008154', NULL, NULL, 'Nuclear calmodulin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(139083, NULL, 'G3DSA:3.30.70.420:FF:000001', NULL, NULL, '3-hydroxy-3-methylglutaryl coenzyme A reductase', NULL, NULL, NULL, NULL, NULL, 4),
(139084, NULL, 'G3DSA:3.50.50.60:FF:001141', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(139085, NULL, 'G3DSA:1.25.40.1030:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139086, NULL, 'G3DSA:1.10.8.60:FF:000284', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(139087, NULL, 'G3DSA:3.90.550.10:FF:000370', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(139088, NULL, 'G3DSA:3.30.420.10:FF:000677', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139089, NULL, 'G3DSA:1.25.40.20:FF:000168', NULL, NULL, 'Myosin XVI', NULL, NULL, NULL, NULL, NULL, 4),
(139090, NULL, 'G3DSA:1.20.120.980:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139091, NULL, 'G3DSA:1.10.472.10:FF:000692', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139092, NULL, 'G3DSA:2.60.120.10:FF:000303', NULL, NULL, 'Homogentisate 1,2-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(139093, NULL, 'G3DSA:1.20.120.720:FF:000056', NULL, NULL, 'Myosin-4', NULL, NULL, NULL, NULL, NULL, 4),
(139094, NULL, 'G3DSA:1.10.10.60:FF:000324', NULL, NULL, 'Transcription factor MYB3R-2', NULL, NULL, NULL, NULL, NULL, 4),
(139095, NULL, 'G3DSA:2.10.25.10:FF:001706', NULL, NULL, 'Multiple EGF-like-domains 8', NULL, NULL, NULL, NULL, NULL, 4),
(139096, NULL, 'G3DSA:3.30.830.10:FF:000214', NULL, NULL, 'Mitochondrial presequence protease', NULL, NULL, NULL, NULL, NULL, 4),
(139097, NULL, 'G3DSA:1.20.1080.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139098, NULL, 'G3DSA:1.20.1250.20:FF:002031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139099, NULL, 'G3DSA:2.40.20.10:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139100, NULL, 'G3DSA:1.25.10.10:FF:001411', NULL, NULL, 'Unplaced genomic scaffold supercont2.21, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(139101, NULL, 'G3DSA:2.60.40.60:FF:000905', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139102, NULL, 'G3DSA:3.20.10.10:FF:000012', NULL, NULL, '4-amino-4-deoxychorismate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(139103, NULL, 'G3DSA:3.40.309.10:FF:000040', NULL, NULL, 'Probable aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(139104, NULL, 'G3DSA:2.60.60.20:FF:000007', NULL, NULL, 'Lipoxygenase homology domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(139105, NULL, 'G3DSA:3.40.50.720:FF:001355', NULL, NULL, 'Uncharacterized protein CaJ7.0123', NULL, NULL, NULL, NULL, NULL, 4),
(139106, NULL, 'G3DSA:3.80.10.10:FF:002027', NULL, NULL, 'NEPN protein', NULL, NULL, NULL, NULL, NULL, 4),
(139107, NULL, 'G3DSA:2.60.40.1490:FF:000001', NULL, NULL, 'Histone chaperone ASF1', NULL, NULL, NULL, NULL, NULL, 4),
(139108, NULL, 'G3DSA:2.60.40.10:FF:000239', NULL, NULL, 'BDNF/NT-3 growth factors receptor', NULL, NULL, NULL, NULL, NULL, 4),
(139109, NULL, 'G3DSA:3.60.15.10:FF:000151', NULL, NULL, 'Unplaced genomic scaffold supercont2.13, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(139110, NULL, 'G3DSA:1.10.472.10:FF:000017', NULL, NULL, 'Putative cyclin-c', NULL, NULL, NULL, NULL, NULL, 4),
(139111, NULL, 'G3DSA:1.25.10.10:FF:002423', NULL, NULL, 'Cytosolic regulator of adenylyl cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(139112, NULL, 'G3DSA:3.20.20.190:FF:000025', NULL, NULL, 'Glycerophosphoryl diester phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(139113, NULL, 'G3DSA:3.40.140.10:FF:000081', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit F', NULL, NULL, NULL, NULL, NULL, 4),
(139114, NULL, 'G3DSA:1.20.5.500:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139115, NULL, 'G3DSA:1.25.40.10:FF:001795', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g25360', NULL, NULL, NULL, NULL, NULL, 4),
(139116, NULL, 'G3DSA:3.80.10.10:FF:001538', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139117, NULL, 'G3DSA:1.20.1640.10:FF:000091', NULL, NULL, 'Acyltrehalose exporter MmpL10', NULL, NULL, NULL, NULL, NULL, 4),
(139118, NULL, 'G3DSA:2.130.10.10:FF:000947', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(139119, NULL, 'G3DSA:2.130.10.10:FF:004258', NULL, NULL, 'Actin-interacting protein 1-2', NULL, NULL, NULL, NULL, NULL, 4),
(139120, NULL, 'G3DSA:3.40.50.2000:FF:000417', NULL, NULL, 'Putative UDP-glucuronosyltransferase ugt-56', NULL, NULL, NULL, NULL, NULL, 4),
(139121, NULL, 'G3DSA:1.25.40.20:FF:001528', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(139122, NULL, 'G3DSA:1.10.418.20:FF:000024', NULL, NULL, 'Ubiquitin-like-specific protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139123, NULL, 'G3DSA:3.30.200.20:FF:001586', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139124, NULL, 'G3DSA:3.40.50.12280:FF:000015', NULL, NULL, 'Photosystem II CP47 reaction center protein', NULL, NULL, NULL, NULL, NULL, 4),
(139125, NULL, 'G3DSA:1.20.58.760:FF:000018', NULL, NULL, 'Putative mitochondrial Mitochondrial ATP-dependent zinc metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(139126, NULL, 'G3DSA:3.40.50.2300:FF:001457', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139127, NULL, 'G3DSA:3.30.230.70:FF:000040', NULL, NULL, 'EXOSome (Multiexonuclease complex) component', NULL, NULL, NULL, NULL, NULL, 4),
(139128, NULL, 'G3DSA:1.20.1560.10:FF:000090', NULL, NULL, 'p-GlycoProtein related', NULL, NULL, NULL, NULL, NULL, 4),
(139129, NULL, 'G3DSA:1.10.8.100:FF:000025', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(139130, NULL, 'G3DSA:3.40.250.10:FF:000139', NULL, NULL, 'Related to CYS4-Cystathionine beta-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(139131, NULL, 'G3DSA:3.40.50.1820:FF:001476', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139132, NULL, 'G3DSA:1.10.10.60:FF:000936', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139133, NULL, 'G3DSA:2.130.10.10:FF:003769', NULL, NULL, 'COP-II coat subunit, nucleoporin', NULL, NULL, NULL, NULL, NULL, 4),
(139134, NULL, 'G3DSA:1.25.40.10:FF:002594', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(139135, NULL, 'G3DSA:3.50.7.10:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(139136, NULL, 'G3DSA:3.30.70.890:FF:000052', NULL, NULL, 'Phosphomevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(139137, NULL, 'G3DSA:2.10.70.10:FF:000108', NULL, NULL, 'Coagulation factor XIII B chain', NULL, NULL, NULL, NULL, NULL, 4),
(139138, NULL, 'G3DSA:3.30.200.20:FF:000574', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139139, NULL, 'G3DSA:3.10.110.10:FF:000288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139140, NULL, 'G3DSA:2.70.70.10:FF:000038', NULL, NULL, 'Murein DD-endopeptidase MepM/ murein hydrolase activator NlpD', NULL, NULL, NULL, NULL, NULL, 4),
(139141, NULL, 'G3DSA:2.60.40.150:FF:000259', NULL, NULL, 'Phosphatidyl inositol kinase (PIK-A)', NULL, NULL, NULL, NULL, NULL, 4),
(139142, NULL, 'G3DSA:1.10.730.10:FF:000005', NULL, NULL, 'Methionine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(139143, NULL, 'G3DSA:1.10.10.60:FF:000375', NULL, NULL, 'Ventral anterior homeobox 1', NULL, NULL, NULL, NULL, NULL, 4),
(139144, NULL, 'G3DSA:1.20.120.790:FF:000037', NULL, NULL, 'TNF receptor associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(139145, NULL, 'G3DSA:3.30.160.60:FF:004550', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139146, NULL, 'G3DSA:3.40.120.10:FF:000023', NULL, NULL, 'Phosphoacetylglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(139147, NULL, 'G3DSA:3.40.50.2300:FF:000097', NULL, NULL, 'Branched-chain amino acid ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(139148, NULL, 'G3DSA:3.30.70.330:FF:000710', NULL, NULL, 'Glycine-rich RNA-binding protein RZ1A', NULL, NULL, NULL, NULL, NULL, 4),
(139149, NULL, 'G3DSA:1.20.58.1070:FF:000025', NULL, NULL, 'Gem-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(139150, NULL, 'G3DSA:2.130.10.10:FF:004606', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139151, NULL, 'G3DSA:2.130.10.10:FF:000335', NULL, NULL, 'F-box/WD repeat-containing protein 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(139152, NULL, 'G3DSA:2.60.40.150:FF:000315', NULL, NULL, 'Phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(139153, NULL, 'G3DSA:3.90.70.10:FF:000597', NULL, NULL, 'Protein CBG24565', NULL, NULL, NULL, NULL, NULL, 4),
(139154, NULL, 'G3DSA:3.30.160.60:FF:005062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139155, NULL, 'G3DSA:1.25.40.530:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139156, NULL, 'G3DSA:3.30.160.60:FF:004494', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139157, NULL, 'G3DSA:3.20.20.80:FF:000781', NULL, NULL, 'Alpha-L-fucosidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(139158, NULL, 'G3DSA:1.20.58.520:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139159, NULL, 'G3DSA:2.40.10.10:FF:000244', NULL, NULL, 'GM24079', NULL, NULL, NULL, NULL, NULL, 4),
(139160, NULL, 'G3DSA:1.10.10.10:FF:002063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139161, NULL, 'G3DSA:2.40.10.10:FF:000188', NULL, NULL, 'Si:dkeyp-93a5.2', NULL, NULL, NULL, NULL, NULL, 4),
(139162, NULL, 'G3DSA:3.30.1370.10:FF:000060', NULL, NULL, 'Far upstream element binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(139163, NULL, 'G3DSA:1.20.5.4770:FF:000005', NULL, NULL, 'tumor necrosis factor alpha-induced protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(139164, NULL, 'G3DSA:3.40.50.410:FF:000306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139165, NULL, 'G3DSA:2.170.120.12:FF:000032', NULL, NULL, 'RNA polymerase Rpb3/Rpb11 dimerisation domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(139166, NULL, 'G3DSA:3.90.1310.10:FF:000031', NULL, NULL, 'Peptidoglycan glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(139167, NULL, 'G3DSA:1.25.40.10:FF:003829', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139168, NULL, 'G3DSA:3.90.1410.10:FF:000027', NULL, NULL, 'SET domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(139169, NULL, 'G3DSA:3.40.140.10:FF:000018', NULL, NULL, 'histone H2A deubiquitinase MYSM1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(139170, NULL, 'G3DSA:3.40.50.2300:FF:000153', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(139171, NULL, 'G3DSA:3.40.50.2000:FF:000125', NULL, NULL, 'Putative alpha-glucosyl-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(139172, NULL, 'G3DSA:3.30.160.60:FF:002420', NULL, NULL, 'Zinc finger and BTB domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(139173, NULL, 'G3DSA:3.40.718.10:FF:000007', NULL, NULL, 'Isocitrate dehydrogenase [NADP]', NULL, NULL, NULL, NULL, NULL, 4),
(139174, NULL, 'G3DSA:2.60.40.1180:FF:000190', NULL, NULL, 'Alpha-galactosidase A', NULL, NULL, NULL, NULL, NULL, 4),
(139175, NULL, 'G3DSA:2.60.40.10:FF:004005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139176, NULL, 'G3DSA:3.30.40.10:FF:001660', NULL, NULL, 'MIB (MIndBomb) ubiquitin ligase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(139177, NULL, 'G3DSA:3.30.830.10:FF:000158', NULL, NULL, 'A-factor-processing enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139178, NULL, 'G3DSA:3.40.50.80:FF:000220', NULL, NULL, 'Uncharacterized FAD-binding protein C17H9.12c', NULL, NULL, NULL, NULL, NULL, 4),
(139179, NULL, 'G3DSA:3.30.210.10:FF:000010', NULL, NULL, 'Repair DNA polymerase X', NULL, NULL, NULL, NULL, NULL, 4),
(139180, NULL, 'G3DSA:1.10.510.10:FF:001422', NULL, NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 205', NULL, NULL, NULL, NULL, NULL, 4),
(139181, NULL, 'G3DSA:1.25.10.10:FF:002659', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139182, NULL, 'G3DSA:2.60.40.10:FF:000683', NULL, NULL, 'ADAMTS like 1', NULL, NULL, NULL, NULL, NULL, 4),
(139183, NULL, 'G3DSA:1.10.533.10:FF:000154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139184, NULL, 'G3DSA:2.60.40.640:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139185, NULL, 'G3DSA:3.90.1150.10:FF:000260', NULL, NULL, 'Aminotransferase, class V family', NULL, NULL, NULL, NULL, NULL, 4),
(139186, NULL, 'G3DSA:3.10.50.40:FF:000142', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(139187, NULL, 'G3DSA:2.10.110.10:FF:000095', NULL, NULL, 'four and a half LIM domains protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(139188, NULL, 'G3DSA:2.160.10.10:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139189, NULL, 'G3DSA:2.60.120.10:FF:000539', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139190, NULL, 'G3DSA:2.60.40.60:FF:000849', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139191, NULL, 'G3DSA:3.30.70.370:FF:000019', NULL, NULL, 'Polymerase (DNA directed), theta', NULL, NULL, NULL, NULL, NULL, 4),
(139192, NULL, 'G3DSA:2.10.70.10:FF:000092', NULL, NULL, 'Hig-anchoring scaffold protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(139193, NULL, 'G3DSA:1.20.120.1750:FF:000136', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(139194, NULL, 'G3DSA:1.10.486.10:FF:000015', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(139195, NULL, 'G3DSA:1.25.40.10:FF:000177', NULL, NULL, 'Amyloid beta precursor protein binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(139196, NULL, 'G3DSA:1.10.510.10:FF:003496', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139197, NULL, 'G3DSA:1.20.1070.10:FF:001255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139198, NULL, 'G3DSA:3.30.450.20:FF:000233', NULL, NULL, 'PAS domain S-box protein', NULL, NULL, NULL, NULL, NULL, 4),
(139199, NULL, 'G3DSA:1.20.58.60:FF:000630', NULL, NULL, 'Spectrin repeat-containing, nuclear envelope 1b', NULL, NULL, NULL, NULL, NULL, 4),
(139200, NULL, 'G3DSA:3.40.50.12100:FF:000006', NULL, NULL, 'Stimulator of interferon genes protein-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(139201, NULL, 'G3DSA:3.90.79.10:FF:000297', NULL, NULL, 'DNA repair glycosylase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(139202, NULL, 'G3DSA:3.40.50.1820:FF:001240', NULL, NULL, 'Esterase', NULL, NULL, NULL, NULL, NULL, 4),
(139203, NULL, 'G3DSA:1.10.238.10:FF:000142', NULL, NULL, 'Secretagogin', NULL, NULL, NULL, NULL, NULL, 4),
(139204, NULL, 'G3DSA:3.80.10.10:FF:001291', NULL, NULL, 'RNI-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(139205, NULL, 'G3DSA:2.60.40.10:FF:004972', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139206, NULL, 'G3DSA:1.25.40.10:FF:004780', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139207, NULL, 'G3DSA:3.80.10.10:FF:003432', NULL, NULL, 'Leucine-rich repeat-containing 8 VRAC subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(139208, NULL, 'G3DSA:3.40.190.10:FF:000645', NULL, NULL, 'Peptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(139209, NULL, 'G3DSA:3.30.70.890:FF:000001', NULL, NULL, 'Galactokinase', NULL, NULL, NULL, NULL, NULL, 4),
(139210, NULL, 'G3DSA:2.60.120.20:FF:000020', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(139211, NULL, 'G3DSA:3.40.50.300:FF:005624', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(139212, NULL, 'G3DSA:2.40.50.880:FF:000001', NULL, NULL, '3''-5'' exoribonuclease CSL4', NULL, NULL, NULL, NULL, NULL, 4),
(139213, NULL, 'G3DSA:3.40.50.150:FF:001324', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139214, NULL, 'G3DSA:3.40.50.300:FF:005568', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139215, NULL, 'G3DSA:3.40.50.720:FF:001809', NULL, NULL, 'Narbonolide/10-deoxymethynolide synthase PikA1, modules 1 and 2', NULL, NULL, NULL, NULL, NULL, 4),
(139216, NULL, 'G3DSA:2.40.270.10:FF:000009', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(139217, NULL, 'G3DSA:4.10.240.30:FF:000001', NULL, NULL, 'Tumor necrosis factor alpha-induced protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(139218, NULL, 'G3DSA:3.40.605.10:FF:000144', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(139219, NULL, 'G3DSA:4.10.320.30:FF:000002', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(139220, NULL, 'G3DSA:3.40.50.2300:FF:001406', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139221, NULL, 'G3DSA:3.40.50.300:FF:004264', NULL, NULL, 'Glr1927 protein', NULL, NULL, NULL, NULL, NULL, 4),
(139222, NULL, 'G3DSA:2.10.25.10:FF:000077', NULL, NULL, 'Latent-transforming growth factor beta-binding protein 3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(139223, NULL, 'G3DSA:1.25.40.20:FF:000511', NULL, NULL, 'Ankyrin repeat domain-containing protein 54', NULL, NULL, NULL, NULL, NULL, 4),
(139224, NULL, 'G3DSA:3.40.225.10:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139225, NULL, 'G3DSA:1.25.50.10:FF:000003', NULL, NULL, 'M1 family aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(139226, NULL, 'G3DSA:3.10.450.580:FF:000010', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(139227, NULL, 'G3DSA:3.40.50.300:FF:004371', NULL, NULL, 'YALI0D21494p', NULL, NULL, NULL, NULL, NULL, 4),
(139228, NULL, 'G3DSA:2.120.10.30:FF:000010', NULL, NULL, 'Low density lipoprotein receptor-related protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(139229, NULL, 'G3DSA:1.20.1530.20:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139230, NULL, 'G3DSA:3.40.50.300:FF:007698', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(139231, NULL, 'G3DSA:3.90.1030.10:FF:000004', NULL, NULL, '50S ribosomal protein L17', NULL, NULL, NULL, NULL, NULL, 4),
(139232, NULL, 'G3DSA:3.40.50.1860:FF:000004', NULL, NULL, 'Aspartate racemase', NULL, NULL, NULL, NULL, NULL, 4),
(139233, NULL, 'G3DSA:2.70.130.10:FF:000083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139234, NULL, 'G3DSA:3.30.200.20:FF:000462', NULL, NULL, 'Calcium-dependent protein kinase 24', NULL, NULL, NULL, NULL, NULL, 4),
(139235, NULL, 'G3DSA:2.60.120.820:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(139236, NULL, 'G3DSA:2.10.110.10:FF:000151', NULL, NULL, 'Uncharacterized protein, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(139237, NULL, 'G3DSA:3.40.50.300:FF:001353', NULL, NULL, 'Nuclear GTPase, germinal center associated', NULL, NULL, NULL, NULL, NULL, 4),
(139238, NULL, 'G3DSA:3.40.50.720:FF:001012', NULL, NULL, 'Glycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(139239, NULL, 'G3DSA:3.80.10.10:FF:002651', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139240, NULL, 'G3DSA:1.10.533.10:FF:000210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139241, NULL, 'G3DSA:3.50.50.60:FF:000921', NULL, NULL, 'IP11909p', NULL, NULL, NULL, NULL, NULL, 4),
(139242, NULL, 'G3DSA:3.30.710.10:FF:000267', NULL, NULL, 'Regulator of chromosome condensation (RCC1) repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139243, NULL, 'G3DSA:2.60.120.200:FF:000519', NULL, NULL, 'Vesicular integral-membrane protein VIP36', NULL, NULL, NULL, NULL, NULL, 4),
(139244, NULL, 'G3DSA:3.90.1150.10:FF:000108', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(139245, NULL, 'G3DSA:3.50.4.10:FF:000003', NULL, NULL, 'Hepatocyte growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(139246, NULL, 'G3DSA:3.10.100.10:FF:000231', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139247, NULL, 'G3DSA:1.10.167.10:FF:000055', NULL, NULL, 'Probable inactive serine/threonine-protein kinase roco10', NULL, NULL, NULL, NULL, NULL, 4),
(139248, NULL, 'G3DSA:2.60.120.260:FF:000392', NULL, NULL, 'Beta-xylanase', NULL, NULL, NULL, NULL, NULL, 4),
(139249, NULL, 'G3DSA:1.10.510.10:FF:000062', NULL, NULL, 'peripheral plasma membrane protein CASK isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(139250, NULL, 'G3DSA:1.20.900.10:FF:000112', NULL, NULL, 'RH56938p', NULL, NULL, NULL, NULL, NULL, 4),
(139251, NULL, 'G3DSA:1.20.1070.10:FF:002036', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(139252, NULL, 'G3DSA:1.25.40.20:FF:000399', NULL, NULL, 'ankyrin repeat domain-containing protein 50', NULL, NULL, NULL, NULL, NULL, 4),
(139253, NULL, 'G3DSA:3.40.50.300:FF:002134', NULL, NULL, 'ABC transporter ATP-binding protein/permease wht-1', NULL, NULL, NULL, NULL, NULL, 4),
(139254, NULL, 'G3DSA:1.25.40.180:FF:000060', NULL, NULL, 'Putative CCR4-NOT transcription complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(139255, NULL, 'G3DSA:3.50.50.60:FF:001377', NULL, NULL, 'Choline dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139256, NULL, 'G3DSA:3.10.20.90:FF:000756', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139257, NULL, 'G3DSA:3.50.50.60:FF:001433', NULL, NULL, 'GDP dissociation inhibitor family protein', NULL, NULL, NULL, NULL, NULL, 4),
(139258, NULL, 'G3DSA:3.90.730.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139259, NULL, 'G3DSA:3.80.10.10:FF:000521', NULL, NULL, 'Os03g0724300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(139260, NULL, 'G3DSA:3.30.540.10:FF:000040', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(139261, NULL, 'G3DSA:3.30.160.60:FF:004218', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139262, NULL, 'G3DSA:3.30.200.20:FF:002316', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(139263, NULL, 'G3DSA:1.10.8.60:FF:000576', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139264, NULL, 'G3DSA:3.40.50.300:FF:004219', NULL, NULL, 'ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(139265, NULL, 'G3DSA:3.90.810.10:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139266, NULL, 'G3DSA:3.40.50.300:FF:000897', NULL, NULL, 'NLR family pyrin domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(139267, NULL, 'G3DSA:2.40.10.500:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139268, NULL, 'G3DSA:3.40.50.300:FF:007985', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139269, NULL, 'G3DSA:3.40.50.1100:FF:000282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(139270, NULL, 'G3DSA:1.10.600.10:FF:000125', NULL, NULL, 'Farnesyl pyrophosphate synthase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(139271, NULL, 'G3DSA:3.40.390.10:FF:000121', NULL, NULL, 'Matrix metalloproteinase-B', NULL, NULL, NULL, NULL, NULL, 4),
(139272, NULL, 'G3DSA:3.30.160.60:FF:002313', NULL, NULL, 'Tripartite motif containing 31', NULL, NULL, NULL, NULL, NULL, 4),
(139273, NULL, 'G3DSA:4.10.280.10:FF:000060', NULL, NULL, 'Scute protein', NULL, NULL, NULL, NULL, NULL, 4),
(139274, NULL, 'G3DSA:1.25.40.20:FF:000275', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(139275, NULL, 'G3DSA:3.40.190.10:FF:000932', NULL, NULL, 'Glutamate receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139276, NULL, 'G3DSA:3.30.300.130:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139277, NULL, 'G3DSA:3.40.605.10:FF:000088', NULL, NULL, 'Aldehyde dehydrogenase X, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(139278, NULL, 'G3DSA:3.30.160.60:FF:006366', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139279, NULL, 'G3DSA:1.25.10.10:FF:000349', NULL, NULL, 'Armadillo-domain containing rhoptry protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139280, NULL, 'G3DSA:2.130.10.10:FF:004837', NULL, NULL, 'Ribosomal large subunit assembly and maintenance-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139281, NULL, 'G3DSA:3.80.10.10:FF:002595', NULL, NULL, 'Adhesion G protein-coupled receptor A2', NULL, NULL, NULL, NULL, NULL, 4),
(139282, NULL, 'G3DSA:1.10.510.10:FF:004333', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139283, NULL, 'G3DSA:3.30.1430.10:FF:000003', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(139284, NULL, 'G3DSA:2.20.50.20:FF:000014', NULL, NULL, 'Vitellogenin', NULL, NULL, NULL, NULL, NULL, 4),
(139285, NULL, 'G3DSA:1.25.40.10:FF:000339', NULL, NULL, 'Proteinaceous RNase P 1, chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(139286, NULL, 'G3DSA:3.30.9.90:FF:000004', NULL, NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(139287, NULL, 'G3DSA:1.25.40.1040:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139288, NULL, 'G3DSA:2.130.10.10:FF:001116', NULL, NULL, 'GM10830', NULL, NULL, NULL, NULL, NULL, 4),
(139289, NULL, 'G3DSA:1.25.10.10:FF:000681', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(139290, NULL, 'G3DSA:2.40.50.40:FF:000002', NULL, NULL, 'C-C motif chemokine', NULL, NULL, NULL, NULL, NULL, 4),
(139291, NULL, 'G3DSA:3.40.50.80:FF:000040', NULL, NULL, 'Respiratory burst oxidase protein D', NULL, NULL, NULL, NULL, NULL, 4),
(139292, NULL, 'G3DSA:3.30.1510.10:FF:000004', NULL, NULL, 'C1-tetrahydrofolate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(139293, NULL, 'G3DSA:2.60.40.60:FF:001013', NULL, NULL, 'Pcdh1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(139294, NULL, 'G3DSA:1.25.40.190:FF:000006', NULL, NULL, 'Actin-related protein 2/3 complex subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(139295, NULL, 'G3DSA:3.40.50.2000:FF:000001', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(139296, NULL, 'G3DSA:3.30.70.330:FF:002559', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139297, NULL, 'G3DSA:2.70.150.10:FF:000027', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(139298, NULL, 'G3DSA:1.10.1390.10:FF:000005', NULL, NULL, 'Glucose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(139299, NULL, 'G3DSA:3.40.50.720:FF:000287', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(139300, NULL, 'G3DSA:1.10.30.10:FF:000097', NULL, NULL, 'Similar to transcription factor HMG', NULL, NULL, NULL, NULL, NULL, 4),
(139301, NULL, 'G3DSA:2.10.110.10:FF:000331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139302, NULL, 'G3DSA:1.20.1560.10:FF:000382', NULL, NULL, 'Beta-(1-->2)glucan export ATP-binding/permease protein NdvA', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(139303, NULL, 'G3DSA:3.30.200.20:FF:001878', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(139304, NULL, 'G3DSA:1.20.1070.10:FF:001199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139305, NULL, 'G3DSA:1.20.1250.20:FF:001575', NULL, NULL, 'Probable major facilitator superfamily (MFS) transporter', NULL, NULL, NULL, NULL, NULL, 4),
(139306, NULL, 'G3DSA:1.10.510.10:FF:001079', NULL, NULL, 'Unplaced genomic scaffold supercont2.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(139307, NULL, 'G3DSA:1.10.150.170:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139308, NULL, 'G3DSA:2.40.37.10:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139309, NULL, 'G3DSA:3.40.50.880:FF:000138', NULL, NULL, 'Catalase', NULL, NULL, NULL, NULL, NULL, 4),
(139310, NULL, 'G3DSA:3.40.190.10:FF:000589', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(139311, NULL, 'G3DSA:1.20.1270.10:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139312, NULL, 'G3DSA:3.30.70.330:FF:002891', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139313, NULL, 'G3DSA:2.60.40.10:FF:000407', NULL, NULL, 'angiopoietin-1 receptor isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(139314, NULL, 'G3DSA:3.40.50.10190:FF:000265', NULL, NULL, 'Putative dna topoisomerase 2-binding protein 1 isoform x1', NULL, NULL, NULL, NULL, NULL, 4),
(139315, NULL, 'G3DSA:3.30.565.10:FF:000081', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(139316, NULL, 'G3DSA:1.20.58.390:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139317, NULL, 'G3DSA:1.20.1070.10:FF:000799', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139318, NULL, 'G3DSA:3.40.50.620:FF:000875', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139319, NULL, 'G3DSA:2.160.10.10:FF:000064', NULL, NULL, 'UTP--glucose-1-phosphate uridylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(139320, NULL, 'G3DSA:3.90.228.10:FF:000059', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(139321, NULL, 'G3DSA:1.25.40.10:FF:002363', NULL, NULL, 'Os06g0611200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(139322, NULL, 'G3DSA:3.30.160.60:FF:005910', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139323, NULL, 'G3DSA:3.40.50.11210:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139324, NULL, 'G3DSA:3.30.70.330:FF:001199', NULL, NULL, 'RNA-binding protein TIA-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139325, NULL, 'G3DSA:3.10.170.20:FF:000002', NULL, NULL, 'Leishmanolysin like peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(139326, NULL, 'G3DSA:2.60.40.10:FF:006079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139327, NULL, 'G3DSA:3.40.50.2020:FF:000007', NULL, NULL, 'Ribose-phosphate pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(139328, NULL, 'G3DSA:3.30.160.60:FF:001695', NULL, NULL, 'Transcriptional activator/repressor GIS1', NULL, NULL, NULL, NULL, NULL, 4),
(139329, NULL, 'G3DSA:1.25.40.10:FF:002487', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g18940, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(139330, NULL, 'G3DSA:1.10.8.10:FF:000134', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(139331, NULL, 'G3DSA:2.60.40.1910:FF:000015', NULL, NULL, 'Aminopeptidase-like protein AC3.5', NULL, NULL, NULL, NULL, NULL, 4),
(139332, NULL, 'G3DSA:3.40.50.1820:FF:001184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139333, NULL, 'G3DSA:3.40.50.720:FF:001647', NULL, NULL, 'GalE family epimerase/dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(139334, NULL, 'G3DSA:3.20.20.10:FF:000069', NULL, NULL, 'Putative serine dehydratase domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(139335, NULL, 'G3DSA:1.10.533.10:FF:000098', NULL, NULL, 'Hematopoietic death receptor', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(139336, NULL, 'G3DSA:2.60.34.10:FF:000062', NULL, NULL, 'Heat shock 70 kDa protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(139337, NULL, 'G3DSA:2.40.160.200:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139338, NULL, 'G3DSA:3.40.50.300:FF:000841', NULL, NULL, 'Magnesium protoporphyrin chelatase', NULL, NULL, NULL, NULL, NULL, 4),
(139339, NULL, 'G3DSA:1.10.20.10:FF:000271', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139340, NULL, 'G3DSA:1.10.10.60:FF:000431', NULL, NULL, 'Set3C deacetylase complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(139341, NULL, 'G3DSA:2.60.40.420:FF:000020', NULL, NULL, 'Ephrin-B2', NULL, NULL, NULL, NULL, NULL, 4),
(139342, NULL, 'G3DSA:3.80.10.10:FF:001246', NULL, NULL, 'Receptor-like protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(139343, NULL, 'G3DSA:2.60.40.10:FF:002768', NULL, NULL, 'GM22869', NULL, NULL, NULL, NULL, NULL, 4),
(139344, NULL, 'G3DSA:3.40.640.10:FF:000282', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(139345, NULL, 'G3DSA:1.10.287.440:FF:000002', NULL, NULL, 'Phosphoribosylaminoimidazolecarboxamide formyltransferase/IMP cyclohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(139346, NULL, 'G3DSA:3.30.1680.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139347, NULL, 'G3DSA:3.40.850.10:FF:000163', NULL, NULL, 'Kinesin-like protein vab-8', NULL, NULL, NULL, NULL, NULL, 4),
(139348, NULL, 'G3DSA:2.130.10.10:FF:000442', NULL, NULL, 'striatin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(139349, NULL, 'G3DSA:3.10.50.40:FF:000086', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(139350, NULL, 'G3DSA:1.25.10.10:FF:002715', NULL, NULL, 'AGR166Wp', NULL, NULL, NULL, NULL, NULL, 4),
(139351, NULL, 'G3DSA:1.20.5.190:FF:000089', NULL, NULL, 'Unconventional myosin-XIX', NULL, NULL, NULL, NULL, NULL, 4),
(139352, NULL, 'G3DSA:3.30.70.270:FF:000102', NULL, NULL, 'Putative DNA polymerase eta', NULL, NULL, NULL, NULL, NULL, 4),
(139353, NULL, 'G3DSA:2.30.30.30:FF:000083', NULL, NULL, 'Transcription elongation factor SPT5', NULL, NULL, NULL, NULL, NULL, 4),
(139354, NULL, 'G3DSA:2.130.10.10:FF:003876', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit wuho', NULL, NULL, NULL, NULL, NULL, 4),
(139355, NULL, 'G3DSA:3.30.40.10:FF:001784', NULL, NULL, 'RING/U-box superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(139356, NULL, 'G3DSA:3.40.50.300:FF:004551', NULL, NULL, 'Probable serine/threonine-protein kinase qkgA', NULL, NULL, NULL, NULL, NULL, 4),
(139357, NULL, 'G3DSA:2.10.25.10:FF:001201', NULL, NULL, 'Netrin g1a', NULL, NULL, NULL, NULL, NULL, 4),
(139358, NULL, 'G3DSA:3.30.70.270:FF:000046', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(139359, NULL, 'G3DSA:3.40.50.1000:FF:000269', NULL, NULL, 'Related to alpha,alpha-trehalose-phosphate synthase, 115 KD subunit', NULL, NULL, NULL, NULL, NULL, 4),
(139360, NULL, 'G3DSA:3.40.630.10:FF:000505', NULL, NULL, 'Tfr2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(139361, NULL, 'G3DSA:2.130.10.10:FF:000099', NULL, NULL, 'syntaxin-binding protein 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(139362, NULL, 'G3DSA:2.30.30.40:FF:000428', NULL, NULL, 'Ras family guanine nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(139363, NULL, 'G3DSA:1.20.140.150:FF:000024', NULL, NULL, 'Transmembrane protein 178A', NULL, NULL, NULL, NULL, NULL, 4),
(139364, NULL, 'G3DSA:1.20.1060.20:FF:000015', NULL, NULL, 'Structural maintenance of chromosomes protein', NULL, NULL, NULL, NULL, NULL, 4),
(139365, NULL, 'G3DSA:2.60.40.60:FF:000052', NULL, NULL, 'FAT atypical cadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(139366, NULL, 'G3DSA:2.40.30.10:FF:000419', NULL, NULL, 'Uncharacterized GTP-binding protein P8A3.05', NULL, NULL, NULL, NULL, NULL, 4),
(139367, NULL, 'G3DSA:3.30.70.100:FF:000023', NULL, NULL, 'N-terminal EF-hand calcium binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(139368, NULL, 'G3DSA:2.10.109.10:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(139369, NULL, 'G3DSA:3.80.10.10:FF:003955', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RCH1', NULL, NULL, NULL, NULL, NULL, 4),
(139370, NULL, 'G3DSA:3.30.200.60:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139371, NULL, 'G3DSA:3.40.1110.10:FF:000185', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(139372, NULL, 'G3DSA:1.10.10.2830:FF:000005', NULL, NULL, 'DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(139373, NULL, 'G3DSA:3.40.47.10:FF:000040', NULL, NULL, 'Type III polyketide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(139374, NULL, 'G3DSA:3.30.40.10:FF:001840', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(139375, NULL, 'G3DSA:2.40.50.140:FF:000920', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139376, NULL, 'G3DSA:2.40.50.140:FF:000864', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139377, NULL, 'G3DSA:1.10.510.10:FF:000623', NULL, NULL, 'Dual specificity mitogen-activated protein kinase kinase hemipterous', NULL, NULL, NULL, NULL, NULL, 4),
(139378, NULL, 'G3DSA:3.40.30.10:FF:001018', NULL, NULL, 'Calsequestrin-1', NULL, NULL, NULL, NULL, NULL, 4),
(139379, NULL, 'G3DSA:3.30.200.40:FF:000001', NULL, NULL, 'm7GpppX diphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(139380, NULL, 'G3DSA:3.30.505.10:FF:000138', NULL, NULL, 'Dual specificity protein kinase shkE', NULL, NULL, NULL, NULL, NULL, 4),
(139381, NULL, 'G3DSA:1.25.40.10:FF:004960', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g15630, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(139382, NULL, 'G3DSA:2.40.50.100:FF:000083', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(139383, NULL, 'G3DSA:3.90.70.10:FF:000541', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(139384, NULL, 'G3DSA:2.60.40.150:FF:000439', NULL, NULL, 'Phosphatidylinositol 3-kinase piki-1', NULL, NULL, NULL, NULL, NULL, 4),
(139385, NULL, 'G3DSA:3.90.1720.10:FF:000017', NULL, NULL, 'BnaA03g55340D protein', NULL, NULL, NULL, NULL, NULL, 4),
(139386, NULL, 'G3DSA:1.10.10.60:FF:001049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139387, NULL, 'G3DSA:2.130.10.10:FF:001791', NULL, NULL, 'LLGL scribble cell polarity complex component 1', NULL, NULL, NULL, NULL, NULL, 4),
(139388, NULL, 'G3DSA:3.30.420.40:FF:000563', NULL, NULL, 'Heat shock protein 70F', NULL, NULL, NULL, NULL, NULL, 4),
(139389, NULL, 'G3DSA:3.30.930.10:FF:000143', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(139390, NULL, 'G3DSA:2.80.10.50:FF:000288', NULL, NULL, 'Aldos-2-ulose dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(139391, NULL, 'G3DSA:3.30.160.60:FF:004730', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139392, NULL, 'G3DSA:3.30.40.10:FF:002060', NULL, NULL, 'MIZ type Zn finger-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(139393, NULL, 'G3DSA:3.90.960.10:FF:000013', NULL, NULL, 'Aminoacyl-tRNA editing domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139394, NULL, 'G3DSA:3.60.10.10:FF:000016', NULL, NULL, 'Carbon catabolite repressor protein 4 1', NULL, NULL, NULL, NULL, NULL, 4),
(139395, NULL, 'G3DSA:1.10.10.10:FF:001282', NULL, NULL, 'HTH-type transcriptional repressor AseR', NULL, NULL, NULL, NULL, NULL, 4),
(139396, NULL, 'G3DSA:3.30.160.60:FF:003437', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139397, NULL, 'G3DSA:3.90.1640.10:FF:000016', NULL, NULL, 'Acidocalcisomal exopolyphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(139398, NULL, 'G3DSA:2.120.10.30:FF:000066', NULL, NULL, 'ABC transporter permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(139399, NULL, 'G3DSA:1.20.272.10:FF:000039', NULL, NULL, 'DNA polymerase III subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(139400, NULL, 'G3DSA:3.30.70.330:FF:001435', NULL, NULL, 'RNA binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139401, NULL, 'G3DSA:1.20.58.340:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(139402, NULL, 'G3DSA:3.40.1800.20:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139403, NULL, 'G3DSA:1.25.10.10:FF:002535', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139404, NULL, 'G3DSA:2.40.340.10:FF:000004', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(139405, NULL, 'G3DSA:2.30.29.30:FF:001142', NULL, NULL, 'Meiotic expression up-regulated protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(139406, NULL, 'G3DSA:3.20.20.70:FF:000845', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139407, NULL, 'G3DSA:2.30.30.100:FF:000148', NULL, NULL, 'Small nuclear ribonucleoprotein B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139408, NULL, 'G3DSA:2.40.20.10:FF:000014', NULL, NULL, 'Plasminogen', NULL, NULL, NULL, NULL, NULL, 4),
(139409, NULL, 'G3DSA:3.40.50.720:FF:000231', NULL, NULL, 'Estradiol 17-beta-dehydrogenase 8', NULL, NULL, NULL, NULL, NULL, 4),
(139410, NULL, 'G3DSA:3.40.50.300:FF:003590', NULL, NULL, 'Dephospho-CoA kinase', NULL, NULL, NULL, NULL, NULL, 4),
(139411, NULL, 'G3DSA:3.30.40.10:FF:000148', NULL, NULL, 'Kinesin-like protein KIN-7D, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(139412, NULL, 'G3DSA:3.10.110.10:FF:000001', NULL, NULL, 'Ubiquitin-conjugating enzyme 28, E2', NULL, NULL, NULL, NULL, NULL, 4),
(139413, NULL, 'G3DSA:3.30.70.330:FF:002615', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139414, NULL, 'G3DSA:3.30.1300.30:FF:000005', NULL, NULL, 'Type II secretion system protein I', NULL, NULL, NULL, NULL, NULL, 4),
(139415, NULL, 'G3DSA:3.30.360.10:FF:000054', NULL, NULL, 'Aspartate-semialdehyde dehydrogenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(139416, NULL, 'G3DSA:1.20.58.70:FF:000015', NULL, NULL, 'Syntaxin 11', NULL, NULL, NULL, NULL, NULL, 4),
(139417, NULL, 'G3DSA:3.50.50.100:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139418, NULL, 'G3DSA:3.40.50.10140:FF:000003', NULL, NULL, 'Toll-like receptor 7', NULL, NULL, NULL, NULL, NULL, 4),
(139419, NULL, 'G3DSA:2.130.10.10:FF:003533', NULL, NULL, 'Os04g0619700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(139420, NULL, 'G3DSA:2.60.40.10:FF:002948', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139421, NULL, 'G3DSA:3.30.40.10:FF:000204', NULL, NULL, 'E3 ubiquitin-protein ligase RNF146', NULL, NULL, NULL, NULL, NULL, 4),
(139422, NULL, 'G3DSA:3.90.550.50:FF:000146', NULL, NULL, 'Beta1,3-galactosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139423, NULL, 'G3DSA:3.30.1520.10:FF:000162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139424, NULL, 'G3DSA:2.30.29.30:FF:000866', NULL, NULL, 'YALI0B07623p', NULL, NULL, NULL, NULL, NULL, 4),
(139425, NULL, 'G3DSA:1.25.10.10:FF:002479', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139426, NULL, 'G3DSA:3.40.50.2300:FF:000333', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(139427, NULL, 'G3DSA:1.20.120.230:FF:000061', NULL, NULL, 'Vinculin-b', NULL, NULL, NULL, NULL, NULL, 4),
(139428, NULL, 'G3DSA:3.30.70.120:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139429, NULL, 'G3DSA:1.10.540.10:FF:000119', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(139430, NULL, 'G3DSA:1.10.10.60:FF:000088', NULL, NULL, 'DNA-binding transcriptional regulator NtrC', NULL, NULL, NULL, NULL, NULL, 4),
(139431, NULL, 'G3DSA:3.40.50.300:FF:006928', NULL, NULL, 'Molybdenum ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(139432, NULL, 'G3DSA:3.40.33.10:FF:000098', NULL, NULL, 'Golgi-associated plant pathogenesis-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(139433, NULL, 'G3DSA:3.40.50.300:FF:002639', NULL, NULL, 'ABC transporter G family protein', NULL, NULL, NULL, NULL, NULL, 4),
(139434, NULL, 'G3DSA:1.20.1050.10:FF:000129', NULL, NULL, 'Hematopoietic prostaglandin D synthase', NULL, NULL, NULL, NULL, NULL, 4),
(139435, NULL, 'G3DSA:3.30.710.10:FF:000503', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(139436, NULL, 'G3DSA:3.30.40.10:FF:001508', NULL, NULL, 'RING/FYVE/PHD zinc finger superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(139437, NULL, 'G3DSA:2.10.220.10:FF:000209', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(139438, NULL, 'G3DSA:3.40.390.10:FF:000245', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139439, NULL, 'G3DSA:3.30.70.330:FF:000474', NULL, NULL, 'Organelle RRM domain-containing protein 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(139440, NULL, 'G3DSA:3.40.850.10:FF:000325', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(139441, NULL, 'G3DSA:2.60.40.10:FF:005354', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139442, NULL, 'G3DSA:3.80.10.10:FF:003556', NULL, NULL, 'ELRR (Extracellular Leucine-Rich Repeat) ONly', NULL, NULL, NULL, NULL, NULL, 4),
(139443, NULL, 'G3DSA:3.20.20.100:FF:000162', NULL, NULL, 'MIP04347p', NULL, NULL, NULL, NULL, NULL, 4),
(139444, NULL, 'G3DSA:2.60.40.3980:FF:000001', NULL, NULL, 'EFF-1A', NULL, NULL, NULL, NULL, NULL, 4),
(139445, NULL, 'G3DSA:3.40.630.10:FF:000106', NULL, NULL, 'Carboxypeptidase A', NULL, NULL, NULL, NULL, NULL, 4),
(139446, NULL, 'G3DSA:3.30.60.30:FF:000032', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(139447, NULL, 'G3DSA:2.130.10.10:FF:002752', NULL, NULL, 'Glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(139448, NULL, 'G3DSA:3.30.70.330:FF:001778', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139449, NULL, 'G3DSA:3.40.50.300:FF:006529', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139450, NULL, 'G3DSA:3.40.228.10:FF:000020', NULL, NULL, 'NADH dehydrogenase I, G subunit', NULL, NULL, NULL, NULL, NULL, 4),
(139451, NULL, 'G3DSA:3.40.50.300:FF:006405', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139452, NULL, 'G3DSA:2.170.300.10:FF:000038', NULL, NULL, 'Multiple epidermal growth factor-like domains protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(139453, NULL, 'G3DSA:3.30.460.20:FF:000003', NULL, NULL, 'Magnesium transporter ALR1', NULL, NULL, NULL, NULL, NULL, 4),
(139454, NULL, 'G3DSA:3.30.310.130:FF:000014', NULL, NULL, 'Ubiquitin-like protease 2', NULL, NULL, NULL, NULL, NULL, 4),
(139455, NULL, 'G3DSA:1.25.40.120:FF:000025', NULL, NULL, 'Prenyltransferase alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139456, NULL, 'G3DSA:3.10.310.10:FF:000056', NULL, NULL, 'Diaminopimelate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(139457, NULL, 'G3DSA:1.10.10.440:FF:000041', NULL, NULL, 'TransCription Elongation Regulator homolog', NULL, NULL, NULL, NULL, NULL, 4),
(139458, NULL, 'G3DSA:3.30.160.60:FF:002077', NULL, NULL, 'LP19870p', NULL, NULL, NULL, NULL, NULL, 4),
(139459, NULL, 'G3DSA:3.40.50.2300:FF:000732', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139460, NULL, 'G3DSA:3.30.1310.10:FF:000005', NULL, NULL, 'Nucleoid-associated protein SPAR113_1167', NULL, NULL, NULL, NULL, NULL, 4),
(139461, NULL, 'G3DSA:1.10.8.10:FF:000078', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 27', NULL, NULL, NULL, NULL, NULL, 4),
(139462, NULL, 'G3DSA:3.40.50.1440:FF:000035', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(139463, NULL, 'G3DSA:3.40.390.10:FF:000065', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(139464, NULL, 'G3DSA:3.30.160.60:FF:000003', NULL, NULL, 'Zinc finger protein 3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(139465, NULL, 'G3DSA:3.90.180.10:FF:000061', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(139466, NULL, 'G3DSA:2.60.200.20:FF:000077', NULL, NULL, 'Forkhead box K, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(139467, NULL, 'G3DSA:3.40.50.300:FF:002078', NULL, NULL, 'Ras-related protein RabQ', NULL, NULL, NULL, NULL, NULL, 4),
(139468, NULL, 'G3DSA:2.130.10.10:FF:002572', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139469, NULL, 'G3DSA:1.10.565.10:FF:000093', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(139470, NULL, 'G3DSA:3.40.50.620:FF:000370', NULL, NULL, 'Tryptophanyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(139471, NULL, 'G3DSA:2.20.70.10:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139472, NULL, 'G3DSA:2.20.70.10:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139473, NULL, 'G3DSA:3.40.50.10090:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139474, NULL, 'G3DSA:3.30.70.1350:FF:000022', NULL, NULL, 'Cation efflux family protein', NULL, NULL, NULL, NULL, NULL, 4),
(139475, NULL, 'G3DSA:1.10.510.10:FF:004513', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139476, NULL, 'G3DSA:3.30.230.10:FF:000230', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(139477, NULL, 'G3DSA:3.80.10.10:FF:003376', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139478, NULL, 'G3DSA:2.60.120.920:FF:000117', NULL, NULL, 'Si:ch73-236c18.7', NULL, NULL, NULL, NULL, NULL, 4),
(139479, NULL, 'G3DSA:1.25.40.20:FF:000455', NULL, NULL, 'Ankyrin repeat domain 28, isoform CRA_c', NULL, NULL, NULL, NULL, NULL, 4),
(139480, NULL, 'G3DSA:1.10.510.10:FF:002192', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(139481, NULL, 'G3DSA:2.60.40.10:FF:002824', NULL, NULL, 'Myosin, light chain kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(139482, NULL, 'G3DSA:1.25.10.10:FF:002136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139483, NULL, 'G3DSA:3.10.100.10:FF:000175', NULL, NULL, 'Killer cell lectin-like receptor subfamily I member 1', NULL, NULL, NULL, NULL, NULL, 4),
(139484, NULL, 'G3DSA:2.40.50.140:FF:000521', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(139485, NULL, 'G3DSA:1.25.40.10:FF:000918', NULL, NULL, 'Bardet-Biedl syndrome 4, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(139486, NULL, 'G3DSA:2.60.40.10:FF:003224', NULL, NULL, '2 (Zwei) IG domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(139487, NULL, 'G3DSA:3.10.100.10:FF:000051', NULL, NULL, 'Lymphocyte antigen 75 variant', NULL, NULL, NULL, NULL, NULL, 4),
(139488, NULL, 'G3DSA:2.40.180.10:FF:000002', NULL, NULL, 'Catalase', NULL, NULL, NULL, NULL, NULL, 4),
(139489, NULL, 'G3DSA:2.60.120.650:FF:000183', NULL, NULL, 'Os12g0169500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(139490, NULL, 'G3DSA:3.90.470.20:FF:000041', NULL, NULL, 'L-aminoadipate-semialdehyde dehydrogenase-phosphopantetheinyl transferase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(139491, NULL, 'G3DSA:3.40.50.11690:FF:000001', NULL, NULL, 'Cell division protein FtsQ', NULL, NULL, NULL, NULL, NULL, 4),
(139492, NULL, 'G3DSA:3.30.870.10:FF:000099', NULL, NULL, 'Phospholipase D1-like protein (PLD1)', NULL, NULL, NULL, NULL, NULL, 4),
(139493, NULL, 'G3DSA:3.10.129.10:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139494, NULL, 'G3DSA:3.20.20.70:FF:000665', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139495, NULL, 'G3DSA:3.40.50.300:FF:006349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139496, NULL, 'G3DSA:3.10.330.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139497, NULL, 'G3DSA:3.40.50.720:FF:001068', NULL, NULL, 'Divinyl chlorophyllide a 8-vinyl-reductase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(139498, NULL, 'G3DSA:2.20.70.10:FF:000063', NULL, NULL, 'E3 ubiquitin-protein ligase NEDD4', NULL, NULL, NULL, NULL, NULL, 4),
(139499, NULL, 'G3DSA:2.60.120.10:FF:000359', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139500, NULL, 'G3DSA:2.60.120.260:FF:000554', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139501, NULL, 'G3DSA:1.10.510.10:FF:003552', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139502, NULL, 'G3DSA:3.20.190.10:FF:000015', NULL, NULL, 'Formamidopyrimidine-DNA glycosylase N-terminal domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(139503, NULL, 'G3DSA:1.25.40.10:FF:004628', NULL, NULL, 'GH21465p', NULL, NULL, NULL, NULL, NULL, 4),
(139504, NULL, 'G3DSA:1.10.560.10:FF:000121', NULL, NULL, 'T-complex protein 1 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(139505, NULL, 'G3DSA:3.30.70.3490:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139506, NULL, 'G3DSA:1.50.40.10:FF:000438', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139507, NULL, 'G3DSA:3.40.1120.10:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139508, NULL, 'G3DSA:3.30.260.10:FF:000069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139509, NULL, 'G3DSA:2.30.29.170:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139510, NULL, 'G3DSA:1.10.8.1310:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139511, NULL, 'G3DSA:2.60.120.10:FF:000691', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139512, NULL, 'G3DSA:2.60.120.200:FF:000014', NULL, NULL, 'neurexin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(139513, NULL, 'G3DSA:3.40.50.10190:FF:000321', NULL, NULL, 'AGAP002605-PA', NULL, NULL, NULL, NULL, NULL, 4),
(139514, NULL, 'G3DSA:2.60.40.1170:FF:000074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139515, NULL, 'G3DSA:1.10.30.10:FF:000153', NULL, NULL, 'HMG transcription factor SoxC', NULL, NULL, NULL, NULL, NULL, 4),
(139516, NULL, 'G3DSA:3.40.30.10:FF:000237', NULL, NULL, 'NADH dehydrogenase subunit E', NULL, NULL, NULL, NULL, NULL, 4),
(139517, NULL, 'G3DSA:3.40.50.20:FF:000005', NULL, NULL, 'acetyl-CoA carboxylase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(139518, NULL, 'G3DSA:2.60.40.10:FF:001987', NULL, NULL, 'Gelation factor', NULL, NULL, NULL, NULL, NULL, 4),
(139519, NULL, 'G3DSA:1.25.40.10:FF:004105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139520, NULL, 'G3DSA:1.25.40.10:FF:003268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139521, NULL, 'G3DSA:2.60.40.150:FF:000591', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(139522, NULL, 'G3DSA:3.10.20.90:FF:000812', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139523, NULL, 'G3DSA:3.30.1440.10:FF:000009', NULL, NULL, '50S ribosomal protein L5, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(139524, NULL, 'G3DSA:2.30.30.40:FF:000608', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(139525, NULL, 'G3DSA:3.40.1170.10:FF:000014', NULL, NULL, 'Mismatch repair protein MSH8, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139526, NULL, 'G3DSA:1.20.1310.20:FF:000052', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(139527, NULL, 'G3DSA:1.20.1280.50:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139528, NULL, 'G3DSA:3.40.50.150:FF:001667', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139529, NULL, 'G3DSA:3.90.640.10:FF:000141', NULL, NULL, 'Heat shock protein 70 homolog LHS1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139530, NULL, 'G3DSA:3.40.50.300:FF:006681', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139531, NULL, 'G3DSA:3.55.40.20:FF:000016', NULL, NULL, 'Mitochondrial 37S ribosomal protein RSM26', NULL, NULL, NULL, NULL, NULL, 4),
(139532, NULL, 'G3DSA:3.30.420.390:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139533, NULL, 'G3DSA:1.20.1250.20:FF:000406', NULL, NULL, 'Monocarboxylate transporter 2', NULL, NULL, NULL, NULL, NULL, 4),
(139534, NULL, 'G3DSA:3.40.1090.10:FF:000013', NULL, NULL, 'Lysophospholipase NTE1', NULL, NULL, NULL, NULL, NULL, 4),
(139535, NULL, 'G3DSA:2.30.29.30:FF:001086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139536, NULL, 'G3DSA:1.20.5.120:FF:000001', NULL, NULL, 'Proteasome activator complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(139537, NULL, 'G3DSA:2.60.40.10:FF:002263', NULL, NULL, 'CD166 antigen homolog A', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(139538, NULL, 'G3DSA:3.40.50.720:FF:002029', NULL, NULL, 'Molybdopterin synthase sulphurylase-like', NULL, NULL, NULL, NULL, NULL, 4),
(139539, NULL, 'G3DSA:2.60.40.10:FF:005697', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139540, NULL, 'G3DSA:2.70.160.11:FF:000029', NULL, NULL, 'Arginine N-methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139541, NULL, 'G3DSA:3.30.1360.10:FF:000008', NULL, NULL, 'RNA polymerase II core subunit', NULL, NULL, NULL, NULL, NULL, 4),
(139542, NULL, 'G3DSA:3.50.50.60:FF:001197', NULL, NULL, 'L-amino-acid oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(139543, NULL, 'G3DSA:2.10.25.10:FF:000420', NULL, NULL, 'Coagulation factor VII', NULL, NULL, NULL, NULL, NULL, 4),
(139544, NULL, 'G3DSA:3.30.497.10:FF:000091', NULL, NULL, 'Neuroserpin', NULL, NULL, NULL, NULL, NULL, 4),
(139545, NULL, 'G3DSA:3.30.70.330:FF:003060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139546, NULL, 'G3DSA:2.60.40.10:FF:004781', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139547, NULL, 'G3DSA:3.30.160.60:FF:003802', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139548, NULL, 'G3DSA:3.30.479.30:FF:000021', NULL, NULL, 'NPHS2 stomatin family member, podocin', NULL, NULL, NULL, NULL, NULL, 4),
(139549, NULL, 'G3DSA:3.40.50.720:FF:002136', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(139550, NULL, 'G3DSA:3.40.50.300:FF:004663', NULL, NULL, 'ATP-binding cassette transporter (ABC transporter) family C member 11', NULL, NULL, NULL, NULL, NULL, 4),
(139551, NULL, 'G3DSA:2.10.109.10:FF:000013', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(139552, NULL, 'G3DSA:3.50.50.60:FF:000781', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139553, NULL, 'G3DSA:3.40.350.10:FF:000023', NULL, NULL, 'Xaa-pro aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(139554, NULL, 'G3DSA:3.10.450.40:FF:000018', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(139555, NULL, 'G3DSA:2.130.10.10:FF:005938', NULL, NULL, 'Vacuolar protein sorting-associated protein 11 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(139556, NULL, 'G3DSA:1.20.1250.20:FF:002222', NULL, NULL, 'Solute carrier organic anion transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139557, NULL, 'G3DSA:3.40.50.720:FF:000528', NULL, NULL, 'Nucleoside-diphosphate-sugar epimerase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(139558, NULL, 'G3DSA:3.90.70.10:FF:000361', NULL, NULL, 'Cathepsin F', NULL, NULL, NULL, NULL, NULL, 4),
(139559, NULL, 'G3DSA:3.30.70.270:FF:000158', NULL, NULL, 'DNA damage repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139560, NULL, 'G3DSA:2.40.30.20:FF:000012', NULL, NULL, 'Riboflavin synthase alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(139561, NULL, 'G3DSA:3.40.50.1010:FF:000098', NULL, NULL, 'Ribonuclease VapC', NULL, NULL, NULL, NULL, NULL, 4),
(139562, NULL, 'G3DSA:3.40.50.720:FF:002092', NULL, NULL, 'Os04g0496000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(139563, NULL, 'G3DSA:3.40.47.10:FF:000152', NULL, NULL, '3-ketoacyl-CoA-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(139564, NULL, 'G3DSA:1.25.40.20:FF:000359', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(139565, NULL, 'G3DSA:2.130.10.10:FF:002179', NULL, NULL, 'Intraflagellar transport protein 122 homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(139566, NULL, 'G3DSA:1.20.5.510:FF:000005', NULL, NULL, 'Ubiquinol-cytochrome c reductase iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4),
(139567, NULL, 'G3DSA:1.10.246.110:FF:000001', NULL, NULL, 'ATP synthase-coupling factor 6, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(139568, NULL, 'G3DSA:3.40.190.10:FF:000308', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(139569, NULL, 'G3DSA:1.25.40.10:FF:001458', NULL, NULL, 'Pentatricopeptide repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(139570, NULL, 'G3DSA:3.40.50.10190:FF:000130', NULL, NULL, 'DNA repair protein REV1', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(139571, NULL, 'G3DSA:2.60.60.20:FF:000030', NULL, NULL, 'Lipoxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(139572, NULL, 'G3DSA:3.90.1150.10:FF:000496', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139573, NULL, 'G3DSA:3.30.40.10:FF:002037', NULL, NULL, 'ERAD-associated E3 ubiquitin-protein ligase hrd1', NULL, NULL, NULL, NULL, NULL, 4),
(139574, NULL, 'G3DSA:3.10.100.10:FF:000236', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139575, NULL, 'G3DSA:2.60.40.420:FF:000048', NULL, NULL, 'Early nodulin-like protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(139576, NULL, 'G3DSA:3.40.190.10:FF:000297', NULL, NULL, 'Glutamate receptor IIC', NULL, NULL, NULL, NULL, NULL, 4),
(139577, NULL, 'G3DSA:1.20.890.10:FF:000025', NULL, NULL, 'ADP-ribosylation factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139578, NULL, 'G3DSA:1.10.20.10:FF:000304', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139579, NULL, 'G3DSA:2.60.40.10:FF:000610', NULL, NULL, 'Tenascin C', NULL, NULL, NULL, NULL, NULL, 4),
(139580, NULL, 'G3DSA:2.40.50.140:FF:000212', NULL, NULL, 'Ribosomal protein S1-like1', NULL, NULL, NULL, NULL, NULL, 4),
(139581, NULL, 'G3DSA:3.40.50.1000:FF:000578', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139582, NULL, 'G3DSA:1.10.3900.10:FF:000001', NULL, NULL, 'Cell division protein ZapD', NULL, NULL, NULL, NULL, NULL, 4),
(139583, NULL, 'G3DSA:2.130.10.10:FF:002712', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(139584, NULL, 'G3DSA:2.60.40.10:FF:003836', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139585, NULL, 'G3DSA:1.10.238.200:FF:000005', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(139586, NULL, 'G3DSA:1.10.10.10:FF:000702', NULL, NULL, 'Regulatory protein RecX', NULL, NULL, NULL, NULL, NULL, 4),
(139587, NULL, 'G3DSA:3.40.50.300:FF:007889', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139588, NULL, 'G3DSA:1.10.246.130:FF:000007', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(139589, NULL, 'G3DSA:3.40.50.1000:FF:000139', NULL, NULL, 'Mitochondrial import inner membrane translocase subunit TIM50', NULL, NULL, NULL, NULL, NULL, 4),
(139590, NULL, 'G3DSA:2.10.160.10:FF:000002', NULL, NULL, 'vascular endothelial growth factor B', NULL, NULL, NULL, NULL, NULL, 4),
(139591, NULL, 'G3DSA:1.10.287.110:FF:000297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139592, NULL, 'G3DSA:3.30.1640.10:FF:000053', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(139593, NULL, 'G3DSA:1.10.10.60:FF:000240', NULL, NULL, 'Zinc fingers and homeoboxes protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(139594, NULL, 'G3DSA:3.30.200.20:FF:001850', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139595, NULL, 'G3DSA:3.30.450.40:FF:000267', NULL, NULL, 'AGAP012811-PA', NULL, NULL, NULL, NULL, NULL, 4),
(139596, NULL, 'G3DSA:3.40.50.720:FF:001517', NULL, NULL, 'UDP-glucose 4-epimerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139597, NULL, 'G3DSA:3.40.50.720:FF:001147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139598, NULL, 'G3DSA:3.90.1010.10:FF:000014', NULL, NULL, 'NifU-like N-terminal domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(139599, NULL, 'G3DSA:1.20.1280.20:FF:000003', NULL, NULL, 'Chaperone protein TorD', NULL, NULL, NULL, NULL, NULL, 4),
(139600, NULL, 'G3DSA:1.10.220.10:FF:000056', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(139601, NULL, 'G3DSA:3.20.20.60:FF:000095', NULL, NULL, 'Isocitrate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(139602, NULL, 'G3DSA:3.40.50.300:FF:000285', NULL, NULL, 'Sporulation initiation inhibitor Soj', NULL, NULL, NULL, NULL, NULL, 4),
(139603, NULL, 'G3DSA:3.30.470.30:FF:000001', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(139604, NULL, 'G3DSA:1.25.40.10:FF:000469', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(139605, NULL, 'G3DSA:3.30.160.60:FF:005247', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(139606, NULL, 'G3DSA:3.30.160.60:FF:004893', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139607, NULL, 'G3DSA:2.30.180.10:FF:000151', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139608, NULL, 'G3DSA:1.10.132.60:FF:000001', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(139609, NULL, 'G3DSA:3.40.1550.10:FF:000009', NULL, NULL, 'Flagellar motor switch protein FliM', NULL, NULL, NULL, NULL, NULL, 4),
(139610, NULL, 'G3DSA:1.25.40.10:FF:000839', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(139611, NULL, 'G3DSA:3.90.70.10:FF:000198', NULL, NULL, 'Cysteine proteinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(139612, NULL, 'G3DSA:3.40.50.300:FF:003202', NULL, NULL, 'RecBCD enzyme subunit RecD', NULL, NULL, NULL, NULL, NULL, 4),
(139613, NULL, 'G3DSA:3.60.10.10:FF:000140', NULL, NULL, 'Protein CBR-OCRL-1', NULL, NULL, NULL, NULL, NULL, 4),
(139614, NULL, 'G3DSA:1.25.10.10:FF:002575', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139615, NULL, 'G3DSA:3.90.1490.10:FF:000015', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(139616, NULL, 'G3DSA:3.40.630.30:FF:000663', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(139617, NULL, 'G3DSA:2.130.10.10:FF:004157', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(139618, NULL, 'G3DSA:3.80.10.10:FF:001639', NULL, NULL, 'Toll-like receptor 12', NULL, NULL, NULL, NULL, NULL, 4),
(139619, NULL, 'G3DSA:1.10.260.40:FF:000028', NULL, NULL, 'Secretion protein EspR', NULL, NULL, NULL, NULL, NULL, 4),
(139620, NULL, 'G3DSA:2.40.30.10:FF:000155', NULL, NULL, 'NADPH--cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(139621, NULL, 'G3DSA:3.40.50.300:FF:000768', NULL, NULL, 'Probable mitochondrial chaperone bcs1', NULL, NULL, NULL, NULL, NULL, 4),
(139622, NULL, 'G3DSA:1.10.510.10:FF:001231', NULL, NULL, 'SAPK/ERK kinase', NULL, NULL, NULL, NULL, NULL, 4),
(139623, NULL, 'G3DSA:1.10.472.10:FF:000040', NULL, NULL, 'D6-type cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(139624, NULL, 'G3DSA:1.25.40.450:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139625, NULL, 'G3DSA:3.30.230.80:FF:000009', NULL, NULL, 'Molecular chaperone HtpG', NULL, NULL, NULL, NULL, NULL, 4),
(139626, NULL, 'G3DSA:3.40.50.1100:FF:000153', NULL, NULL, 'Cysteine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(139627, NULL, 'G3DSA:2.60.40.1830:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139628, NULL, 'G3DSA:3.30.70.330:FF:002924', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139629, NULL, 'G3DSA:2.60.40.150:FF:000607', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(139630, NULL, 'G3DSA:3.40.50.300:FF:002685', NULL, NULL, 'RAB33A, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(139631, NULL, 'G3DSA:3.10.20.90:FF:000632', NULL, NULL, 'UBA/TS-N domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(139632, NULL, 'G3DSA:1.10.2020.20:FF:000009', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(139633, NULL, 'G3DSA:2.30.31.30:FF:000001', NULL, NULL, 'Replicase polyprotein 1ab', NULL, NULL, NULL, NULL, NULL, 4),
(139634, NULL, 'G3DSA:3.30.450.20:FF:000261', NULL, NULL, 'Diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(139635, NULL, 'G3DSA:3.40.630.10:FF:000444', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139636, NULL, 'G3DSA:1.25.40.430:FF:000011', NULL, NULL, 'Mitotic checkpoint serine/threonine-protein kinase bub-1', NULL, NULL, NULL, NULL, NULL, 4),
(139637, NULL, 'G3DSA:3.90.1290.10:FF:000034', NULL, NULL, 'Microtubule-actin cross-linking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(139638, NULL, 'G3DSA:3.40.50.10490:FF:000113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139639, NULL, 'G3DSA:3.30.70.1440:FF:000004', NULL, NULL, 'Efflux pump membrane transporter', NULL, NULL, NULL, NULL, NULL, 4),
(139640, NULL, 'G3DSA:2.60.40.10:FF:002055', NULL, NULL, 'Immunoglobulin superfamily member 6', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(139641, NULL, 'G3DSA:3.60.120.10:FF:000024', NULL, NULL, 'Salicylate biosynthesis isochorismate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(139642, NULL, 'G3DSA:3.30.420.140:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139643, NULL, 'G3DSA:1.10.510.10:FF:004457', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139644, NULL, 'G3DSA:3.30.420.10:FF:000060', NULL, NULL, 'Ribonuclease D', NULL, NULL, NULL, NULL, NULL, 4),
(139645, NULL, 'G3DSA:1.10.238.10:FF:000333', NULL, NULL, 'Myosin A tail domain interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(139646, NULL, 'G3DSA:3.60.40.10:FF:000321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139647, NULL, 'G3DSA:2.40.50.90:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139648, NULL, 'G3DSA:3.30.360.10:FF:000133', NULL, NULL, 'Bifunctional aspartate kinase/homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(139649, NULL, 'G3DSA:3.30.450.20:FF:000570', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(139650, NULL, 'G3DSA:2.60.120.200:FF:000643', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139651, NULL, 'G3DSA:2.60.40.1510:FF:000007', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(139652, NULL, 'G3DSA:4.10.1000.30:FF:000003', NULL, NULL, 'zinc finger CCCH domain-containing protein 14 isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(139653, NULL, 'G3DSA:2.60.120.10:FF:000562', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139654, NULL, 'G3DSA:1.10.340.30:FF:000009', NULL, NULL, 'DNA-3-methyladenine glycosylase I', NULL, NULL, NULL, NULL, NULL, 4),
(139655, NULL, 'G3DSA:2.60.40.10:FF:003044', NULL, NULL, 'Probable beta-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(139656, NULL, 'G3DSA:3.40.190.290:FF:000087', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(139657, NULL, 'G3DSA:1.10.486.10:FF:000010', NULL, NULL, 'ATP-dependent DNA helicase Rep', NULL, NULL, NULL, NULL, NULL, 4),
(139658, NULL, 'G3DSA:3.10.350.10:FF:000058', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(139659, NULL, 'G3DSA:2.20.28.10:FF:000049', NULL, NULL, 'Putative dna replication licensing factor mcm4 component', NULL, NULL, NULL, NULL, NULL, 4),
(139660, NULL, 'G3DSA:3.30.160.60:FF:002504', NULL, NULL, 'zinc finger protein 821 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(139661, NULL, 'G3DSA:3.30.1240.10:FF:000005', NULL, NULL, 'Cof family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(139662, NULL, 'G3DSA:3.40.1810.10:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139663, NULL, 'G3DSA:2.90.10.10:FF:000039', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase SD2-5', NULL, NULL, NULL, NULL, NULL, 4),
(139664, NULL, 'G3DSA:1.25.10.10:FF:000658', NULL, NULL, 'Protein VAC14-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(139665, NULL, 'G3DSA:3.40.570.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139666, NULL, 'G3DSA:3.80.10.10:FF:003617', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139667, NULL, 'G3DSA:3.40.930.10:FF:000017', NULL, NULL, 'Solute carrier family 4, sodium borate transporter, member 11', NULL, NULL, NULL, NULL, NULL, 4),
(139668, NULL, 'G3DSA:3.40.50.300:FF:004028', NULL, NULL, 'ATP-dependent RNA helicase DRS1', NULL, NULL, NULL, NULL, NULL, 4),
(139669, NULL, 'G3DSA:1.10.287.740:FF:000002', NULL, NULL, 'Photosystem II reaction center protein Z', NULL, NULL, NULL, NULL, NULL, 4),
(139670, NULL, 'G3DSA:3.40.50.300:FF:003191', NULL, NULL, 'ATP-binding cassette (ABC) transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139671, NULL, 'G3DSA:3.30.160.60:FF:002493', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(139672, NULL, 'G3DSA:3.10.20.90:FF:000941', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139673, NULL, 'G3DSA:2.60.40.10:FF:001919', NULL, NULL, 'Platelet endothelial cell adhesion molecule', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(139674, NULL, 'G3DSA:1.10.287.70:FF:000273', NULL, NULL, 'potassium voltage-gated channel subfamily KQT member 2-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(139675, NULL, 'G3DSA:2.40.30.270:FF:000011', NULL, NULL, 'DNA replication helicase Dna2', NULL, NULL, NULL, NULL, NULL, 4),
(139676, NULL, 'G3DSA:1.10.620.20:FF:000005', NULL, NULL, 'Ribonucleoside-diphosphate reductase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(139677, NULL, 'G3DSA:3.40.50.2000:FF:000310', NULL, NULL, 'Glycosyl transferase CpoA', NULL, NULL, NULL, NULL, NULL, 4),
(139678, NULL, 'G3DSA:3.40.630.30:FF:000500', NULL, NULL, 'Acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(139679, NULL, 'G3DSA:3.80.10.10:FF:001482', NULL, NULL, 'F box and leucine-rich-repeat gene 4', NULL, NULL, NULL, NULL, NULL, 4),
(139680, NULL, 'G3DSA:3.30.70.330:FF:000137', NULL, NULL, 'pre-mRNA-splicing factor RBM22', NULL, NULL, NULL, NULL, NULL, 4),
(139681, NULL, 'G3DSA:2.130.10.10:FF:000251', NULL, NULL, 'Dynein axonemal intermediate chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(139682, NULL, 'G3DSA:3.40.50.1820:FF:000705', NULL, NULL, 'CDA peptide synthetase III', NULL, NULL, NULL, NULL, NULL, 4),
(139683, NULL, 'G3DSA:3.30.160.60:FF:006236', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139684, NULL, 'G3DSA:1.25.10.10:FF:000219', NULL, NULL, 'Importin subunit beta-2', NULL, NULL, NULL, NULL, NULL, 4),
(139685, NULL, 'G3DSA:1.20.5.190:FF:000061', NULL, NULL, 'Myosin C', NULL, NULL, NULL, NULL, NULL, 4),
(139686, NULL, 'G3DSA:2.40.10.10:FF:000272', NULL, NULL, 'GG11998', NULL, NULL, NULL, NULL, NULL, 4),
(139687, NULL, 'G3DSA:1.10.1200.240:FF:000004', NULL, NULL, 'LSU ribosomal protein L19E', NULL, NULL, NULL, NULL, NULL, 4),
(139688, NULL, 'G3DSA:1.20.1250.20:FF:001266', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(139689, NULL, 'G3DSA:2.60.40.10:FF:002408', NULL, NULL, 'Blast:Protein amalgam', NULL, NULL, NULL, NULL, NULL, 4),
(139690, NULL, 'G3DSA:2.120.10.30:FF:000089', NULL, NULL, 'Calcium-dependent phosphotriesterase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(139691, NULL, 'G3DSA:2.60.120.970:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139692, NULL, 'G3DSA:2.130.10.10:FF:004949', NULL, NULL, 'DDB1- and CUL4-associated factor 11 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(139693, NULL, 'G3DSA:3.40.50.880:FF:000014', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139694, NULL, 'G3DSA:1.20.120.340:FF:000015', NULL, NULL, 'Flagellar secretion chaperone FliS', NULL, NULL, NULL, NULL, NULL, 4),
(139695, NULL, 'G3DSA:1.20.1560.10:FF:000730', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139696, NULL, 'G3DSA:2.60.120.200:FF:000334', NULL, NULL, 'LAMinin related. See also lmb', NULL, NULL, NULL, NULL, NULL, 4),
(139697, NULL, 'G3DSA:2.30.30.40:FF:000029', NULL, NULL, 'myc box-dependent-interacting protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(139698, NULL, 'G3DSA:2.40.50.120:FF:000010', NULL, NULL, 'secreted frizzled-related protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(139699, NULL, 'G3DSA:1.20.59.10:FF:000011', NULL, NULL, 'Chorismate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(139700, NULL, 'G3DSA:3.40.1440.60:FF:000011', NULL, NULL, 'Primosomal protein N''', NULL, NULL, NULL, NULL, NULL, 4),
(139701, NULL, 'G3DSA:3.30.1360.10:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139702, NULL, 'G3DSA:1.10.238.10:FF:001322', NULL, NULL, 'Ras homolog family member T1', NULL, NULL, NULL, NULL, NULL, 4),
(139703, NULL, 'G3DSA:3.40.1090.10:FF:000081', NULL, NULL, 'Bll5745 protein', NULL, NULL, NULL, NULL, NULL, 4),
(139704, NULL, 'G3DSA:2.40.110.10:FF:000032', NULL, NULL, 'Acyl-CoA dehydrogenase FADE21', NULL, NULL, NULL, NULL, NULL, 4),
(139705, NULL, 'G3DSA:3.40.50.150:FF:001723', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139706, NULL, 'G3DSA:1.25.40.20:FF:001787', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(139707, NULL, 'G3DSA:3.40.50.720:FF:002445', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139708, NULL, 'G3DSA:3.30.1370.10:FF:000189', NULL, NULL, 'Putative UPF0469 protein', NULL, NULL, NULL, NULL, NULL, 4),
(139709, NULL, 'G3DSA:3.90.190.10:FF:000494', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139710, NULL, 'G3DSA:3.30.450.380:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139711, NULL, 'G3DSA:3.90.550.10:FF:000477', NULL, NULL, 'CMP-KDO synthetase-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(139712, NULL, 'G3DSA:2.120.10.80:FF:000204', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(139713, NULL, 'G3DSA:3.10.20.30:FF:000058', NULL, NULL, 'Threonine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(139714, NULL, 'G3DSA:1.10.1020.10:FF:000006', NULL, NULL, 'Mu phage DNA adenine methylase Dam family', NULL, NULL, NULL, NULL, NULL, 4),
(139715, NULL, 'G3DSA:1.10.10.1730:FF:000001', NULL, NULL, 'Folliculin', NULL, NULL, NULL, NULL, NULL, 4),
(139716, NULL, 'G3DSA:2.40.10.10:FF:000581', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139717, NULL, 'G3DSA:2.130.10.10:FF:003477', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139718, NULL, 'G3DSA:3.30.420.40:FF:000439', NULL, NULL, 'Actin', NULL, NULL, NULL, NULL, NULL, 4),
(139719, NULL, 'G3DSA:1.20.920.30:FF:000001', NULL, NULL, 'Cytoplasmic dynein heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(139720, NULL, 'G3DSA:3.40.50.720:FF:001956', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139721, NULL, 'G3DSA:2.60.40.60:FF:000029', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(139722, NULL, 'G3DSA:3.30.559.30:FF:000055', NULL, NULL, 'Peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(139723, NULL, 'G3DSA:3.90.1410.10:FF:000106', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(139724, NULL, 'G3DSA:3.80.10.10:FF:000330', NULL, NULL, 'Receptor protein-tyrosine kinase CEPR1', NULL, NULL, NULL, NULL, NULL, 4),
(139725, NULL, 'G3DSA:2.60.40.10:FF:003353', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139726, NULL, 'G3DSA:3.90.70.10:FF:000670', NULL, NULL, 'Putative ubiquitin hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(139727, NULL, 'G3DSA:3.40.50.12650:FF:000019', NULL, NULL, 'Os01g0783400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(139728, NULL, 'G3DSA:2.10.25.10:FF:000004', NULL, NULL, 'Neurogenic locus notch 1', NULL, NULL, NULL, NULL, NULL, 4),
(139729, NULL, 'G3DSA:3.90.1410.10:FF:000095', NULL, NULL, 'Lysine N-methylase', NULL, NULL, NULL, NULL, NULL, 4),
(139730, NULL, 'G3DSA:3.30.1330.30:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139731, NULL, 'G3DSA:2.60.40.10:FF:002864', NULL, NULL, 'LOC100127716 protein', NULL, NULL, NULL, NULL, NULL, 4),
(139732, NULL, 'G3DSA:1.10.640.10:FF:000015', NULL, NULL, 'DUal OXidase', NULL, NULL, NULL, NULL, NULL, 4),
(139733, NULL, 'G3DSA:2.110.10.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139734, NULL, 'G3DSA:3.30.2020.30:FF:000017', NULL, NULL, 'Uncharacterized protein CaJ7.0511', NULL, NULL, NULL, NULL, NULL, 4),
(139735, NULL, 'G3DSA:3.90.1200.10:FF:000040', NULL, NULL, 'Possible macrolide 2-phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(139736, NULL, 'G3DSA:3.40.50.1820:FF:001796', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139737, NULL, 'G3DSA:1.10.357.140:FF:000002', NULL, NULL, '4-hydroxybenzoate octaprenyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(139738, NULL, 'G3DSA:3.90.226.10:FF:000212', NULL, NULL, 'ATP-dependent Clp protease proteolytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(139739, NULL, 'G3DSA:3.20.20.80:FF:000281', NULL, NULL, 'Alpha-L-fucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(139740, NULL, 'G3DSA:3.20.20.70:FF:000744', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(139741, NULL, 'G3DSA:2.30.30.30:FF:000139', NULL, NULL, 'Ribosomal protein L14', NULL, NULL, NULL, NULL, NULL, 4),
(139742, NULL, 'G3DSA:2.130.10.10:FF:002049', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(139743, NULL, 'G3DSA:3.30.70.330:FF:001626', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139744, NULL, 'G3DSA:1.20.144.10:FF:000045', NULL, NULL, 'RE35738p', NULL, NULL, NULL, NULL, NULL, 4),
(139745, NULL, 'G3DSA:2.60.120.260:FF:000184', NULL, NULL, 'Membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(139746, NULL, 'G3DSA:2.130.10.10:FF:004966', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139747, NULL, 'G3DSA:3.30.450.60:FF:000014', NULL, NULL, 'Coatomer subunit zeta-2', NULL, NULL, NULL, NULL, NULL, 4),
(139748, NULL, 'G3DSA:2.170.150.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139749, NULL, 'G3DSA:3.30.70.2510:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139750, NULL, 'G3DSA:1.10.287.70:FF:000773', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139751, NULL, 'G3DSA:3.30.530.20:FF:000099', NULL, NULL, 'Homeobox-leucine zipper protein HDG8', NULL, NULL, NULL, NULL, NULL, 4),
(139752, NULL, 'G3DSA:2.80.10.50:FF:000052', NULL, NULL, 'Interleukin 33', NULL, NULL, NULL, NULL, NULL, 4),
(139753, NULL, 'G3DSA:1.10.238.10:FF:001159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139754, NULL, 'G3DSA:3.30.420.40:FF:000748', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139755, NULL, 'G3DSA:3.90.1750.10:FF:000053', NULL, NULL, 'Ubiquitin protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139756, NULL, 'G3DSA:3.40.50.150:FF:001740', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139757, NULL, 'G3DSA:3.40.190.10:FF:000960', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139758, NULL, 'G3DSA:2.130.10.10:FF:004096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139759, NULL, 'G3DSA:1.20.272.10:FF:000084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139760, NULL, 'G3DSA:1.25.40.10:FF:003375', NULL, NULL, 'TPR repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139761, NULL, 'G3DSA:3.30.200.20:FF:002367', NULL, NULL, 'Kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(139762, NULL, 'G3DSA:2.130.10.10:FF:002488', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139763, NULL, 'G3DSA:1.10.760.10:FF:000097', NULL, NULL, 'Lupanine 17-hydroxylase [cytochrome c]', NULL, NULL, NULL, NULL, NULL, 4),
(139764, NULL, 'G3DSA:2.60.40.1530:FF:000002', NULL, NULL, 'integrin alpha-V isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(139765, NULL, 'G3DSA:3.30.9.10:FF:000267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139766, NULL, 'G3DSA:3.40.710.10:FF:000023', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase DacF', NULL, NULL, NULL, NULL, NULL, 4),
(139767, NULL, 'G3DSA:3.40.50.10580:FF:000005', NULL, NULL, 'V-type proton ATPase subunit F', NULL, NULL, NULL, NULL, NULL, 4),
(139768, NULL, 'G3DSA:2.30.42.10:FF:000604', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139769, NULL, 'G3DSA:3.80.10.10:FF:002319', NULL, NULL, 'F-box domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(139770, NULL, 'G3DSA:3.40.190.80:FF:000048', NULL, NULL, 'Putative fructose-1,6-bisphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(139771, NULL, 'G3DSA:3.40.50.200:FF:000064', NULL, NULL, 'Extracellular serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(139772, NULL, 'G3DSA:3.40.50.300:FF:006737', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(139773, NULL, 'G3DSA:4.10.1000.10:FF:000008', NULL, NULL, 'zinc finger CCCH domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(139774, NULL, 'G3DSA:2.40.70.10:FF:000129', NULL, NULL, 'Aspartic proteinase A1', NULL, NULL, NULL, NULL, NULL, 4),
(139775, NULL, 'G3DSA:1.25.40.10:FF:001003', NULL, NULL, 'AGAP000499-PA', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(139776, NULL, 'G3DSA:3.30.70.330:FF:002132', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139777, NULL, 'G3DSA:3.40.50.300:FF:007434', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139778, NULL, 'G3DSA:2.70.98.10:FF:000029', NULL, NULL, 'Aldose 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(139779, NULL, 'G3DSA:1.20.1070.10:FF:000530', NULL, NULL, 'Putative olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(139780, NULL, 'G3DSA:1.20.58.60:FF:000057', NULL, NULL, 'Short stop, isoform N', NULL, NULL, NULL, NULL, NULL, 4),
(139781, NULL, 'G3DSA:2.30.230.10:FF:000015', NULL, NULL, 'Apolipophorin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(139782, NULL, 'G3DSA:1.10.150.240:FF:000084', NULL, NULL, 'Putative phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(139783, NULL, 'G3DSA:3.40.640.10:FF:000242', NULL, NULL, 'Perosamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(139784, NULL, 'G3DSA:3.40.50.300:FF:003511', NULL, NULL, 'RNA helicase, superfamily II', NULL, NULL, NULL, NULL, NULL, 4),
(139785, NULL, 'G3DSA:1.20.1070.10:FF:001709', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139786, NULL, 'G3DSA:3.30.300.20:FF:000014', NULL, NULL, 'probable ribosome-binding factor A, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(139787, NULL, 'G3DSA:3.40.50.300:FF:004680', NULL, NULL, 'MutS homolog 3', NULL, NULL, NULL, NULL, NULL, 4),
(139788, NULL, 'G3DSA:3.40.50.300:FF:002994', NULL, NULL, 'ATPase, AAA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(139789, NULL, 'G3DSA:3.30.1960.10:FF:000009', NULL, NULL, 'DUF207 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(139790, NULL, 'G3DSA:1.20.1250.20:FF:000777', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(139791, NULL, 'G3DSA:2.40.30.110:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139792, NULL, 'G3DSA:3.10.20.90:FF:000469', NULL, NULL, 'Polyubiquitin-C', NULL, NULL, NULL, NULL, NULL, 4),
(139793, NULL, 'G3DSA:2.160.20.10:FF:000065', NULL, NULL, 'GM01353p', NULL, NULL, NULL, NULL, NULL, 4),
(139794, NULL, 'G3DSA:1.10.510.10:FF:004518', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139795, NULL, 'G3DSA:1.20.1050.130:FF:000033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(139796, NULL, 'G3DSA:2.130.10.10:FF:005585', NULL, NULL, 'Roco6, ROCO family protein', NULL, NULL, NULL, NULL, NULL, 4),
(139797, NULL, 'G3DSA:3.30.50.10:FF:000048', NULL, NULL, 'GATA zinc finger domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(139798, NULL, 'G3DSA:3.30.40.10:FF:001391', NULL, NULL, 'TRAF6', NULL, NULL, NULL, NULL, NULL, 4),
(139799, NULL, 'G3DSA:1.20.1250.20:FF:000305', NULL, NULL, 'Drug resistance transporter, EmrB/QacA family', NULL, NULL, NULL, NULL, NULL, 4),
(139800, NULL, 'G3DSA:3.30.70.330:FF:002907', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139801, NULL, 'G3DSA:3.40.50.300:FF:006580', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139802, NULL, 'G3DSA:1.25.40.10:FF:002756', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139803, NULL, 'G3DSA:1.10.1900.10:FF:000017', NULL, NULL, 'YALI0B00616p', NULL, NULL, NULL, NULL, NULL, 4),
(139804, NULL, 'G3DSA:3.40.50.2000:FF:000440', NULL, NULL, 'ADP-heptose--lipooligosaccharide heptosyltransferase II', NULL, NULL, NULL, NULL, NULL, 4),
(139805, NULL, 'G3DSA:2.60.40.10:FF:002717', NULL, NULL, 'Type II inositol-1,4,5-trisphosphate 5-phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139806, NULL, 'G3DSA:1.50.40.10:FF:000394', NULL, NULL, 'Mitochondrial amino acid carrier', NULL, NULL, NULL, NULL, NULL, 4),
(139807, NULL, 'G3DSA:3.40.50.10190:FF:000113', NULL, NULL, 'DNA repair protein Rtt107', NULL, NULL, NULL, NULL, NULL, 4),
(139808, NULL, 'G3DSA:3.10.350.10:FF:000075', NULL, NULL, 'LysM peptidoglycan-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(139809, NULL, 'G3DSA:1.25.10.10:FF:001147', NULL, NULL, 'Exportin 6', NULL, NULL, NULL, NULL, NULL, 4),
(139810, NULL, 'G3DSA:3.30.200.20:FF:001748', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(139811, NULL, 'G3DSA:2.60.40.150:FF:000546', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(139812, NULL, 'G3DSA:3.30.740.10:FF:000016', NULL, NULL, 'Dynein light chain', NULL, NULL, NULL, NULL, NULL, 4),
(139813, NULL, 'G3DSA:1.20.58.1100:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139814, NULL, 'G3DSA:2.30.30.40:FF:000468', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139815, NULL, 'G3DSA:3.50.50.60:FF:001298', NULL, NULL, 'Thioredoxin reductase 1, mitochondrial-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(139816, NULL, 'G3DSA:3.40.50.150:FF:000251', NULL, NULL, 'Putative RNA methylase', NULL, NULL, NULL, NULL, NULL, 4),
(139817, NULL, 'G3DSA:2.30.180.10:FF:000134', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139818, NULL, 'G3DSA:2.20.25.10:FF:000043', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(139819, NULL, 'G3DSA:3.40.50.1820:FF:001296', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(139820, NULL, 'G3DSA:2.130.10.10:FF:000604', NULL, NULL, 'U3 snoRNA-associated small subunit rRNA processing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139821, NULL, 'G3DSA:3.60.90.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139822, NULL, 'G3DSA:1.25.40.20:FF:000831', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(139823, NULL, 'G3DSA:3.40.30.10:FF:000658', NULL, NULL, 'Thiol-disulfide oxidoreductase ResA', NULL, NULL, NULL, NULL, NULL, 4),
(139824, NULL, 'G3DSA:2.30.40.10:FF:000061', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(139825, NULL, 'G3DSA:3.90.79.10:FF:000229', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(139826, NULL, 'G3DSA:3.30.70.141:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139827, NULL, 'G3DSA:3.90.1480.20:FF:000046', NULL, NULL, 'Alpha-2,8-sialyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(139828, NULL, 'G3DSA:3.40.50.300:FF:001257', NULL, NULL, 'RAB20, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(139829, NULL, 'G3DSA:1.10.238.200:FF:000022', NULL, NULL, 'Defective in cullin neddylation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(139830, NULL, 'G3DSA:1.10.472.130:FF:000045', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139831, NULL, 'G3DSA:1.10.10.1340:FF:000007', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 31', NULL, NULL, NULL, NULL, NULL, 4),
(139832, NULL, 'G3DSA:2.10.25.10:FF:000785', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(139833, NULL, 'G3DSA:3.40.140.10:FF:000114', NULL, NULL, 'Cytidine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(139834, NULL, 'G3DSA:3.40.30.10:FF:000788', NULL, NULL, 'NADH dehydrogenase I, F subunit', NULL, NULL, NULL, NULL, NULL, 4),
(139835, NULL, 'G3DSA:2.60.40.10:FF:001436', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(139836, NULL, 'G3DSA:3.10.250.10:FF:000011', NULL, NULL, 'Scavenger receptor class A member 5', NULL, NULL, NULL, NULL, NULL, 4),
(139837, NULL, 'G3DSA:1.10.287.1490:FF:000054', NULL, NULL, 'Centrosomal protein of 72 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(139838, NULL, 'G3DSA:2.70.170.10:FF:000017', NULL, NULL, '5-hydroxytryptamine receptor 3A', NULL, NULL, NULL, NULL, NULL, 4),
(139839, NULL, 'G3DSA:1.10.150.80:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139840, NULL, 'G3DSA:3.80.10.10:FF:003747', NULL, NULL, 'Leucine-rich repeat neuronal protein 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(139841, NULL, 'G3DSA:1.10.506.10:FF:000035', NULL, NULL, 'Plexin b2a', NULL, NULL, NULL, NULL, NULL, 4),
(139842, NULL, 'G3DSA:2.30.29.30:FF:000265', NULL, NULL, 'BAG-associated GRAM protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(139843, NULL, 'G3DSA:1.10.630.10:FF:000222', NULL, NULL, 'Os08g0152400 protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(139844, NULL, 'G3DSA:2.130.10.10:FF:001223', NULL, NULL, 'WD repeat-containing protein 90', NULL, NULL, NULL, NULL, NULL, 4),
(139845, NULL, 'G3DSA:3.30.160.60:FF:001532', NULL, NULL, 'Zinc finger protein 483', NULL, NULL, NULL, NULL, NULL, 4),
(139846, NULL, 'G3DSA:3.40.50.10800:FF:000010', NULL, NULL, 'Quinolinate synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(139847, NULL, 'G3DSA:3.40.50.10990:FF:000010', NULL, NULL, 'Monofunctional riboflavin biosynthesis protein RIBA 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(139848, NULL, 'G3DSA:2.10.110.10:FF:000067', NULL, NULL, 'Uncharacterized protein, isoform Z', NULL, NULL, NULL, NULL, NULL, 4),
(139849, NULL, 'G3DSA:3.30.160.60:FF:002976', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139850, NULL, 'G3DSA:1.10.472.10:FF:000377', NULL, NULL, 'Cyclin t, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139851, NULL, 'G3DSA:1.10.533.10:FF:000182', NULL, NULL, 'Si:dkeyp-97b10.3', NULL, NULL, NULL, NULL, NULL, 4),
(139852, NULL, 'G3DSA:3.30.40.10:FF:001992', NULL, NULL, 'Uncharacterized protein C16C9.05', NULL, NULL, NULL, NULL, NULL, 4),
(139853, NULL, 'G3DSA:3.30.420.10:FF:000104', NULL, NULL, 'Werner Syndrome-like exonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(139854, NULL, 'G3DSA:1.10.510.10:FF:002203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139855, NULL, 'G3DSA:3.30.1370.10:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139856, NULL, 'G3DSA:1.20.120.1780:FF:000004', NULL, NULL, '4-hydroxybenzoate octaprenyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(139857, NULL, 'G3DSA:2.60.120.920:FF:000196', NULL, NULL, 'LOC567531 protein', NULL, NULL, NULL, NULL, NULL, 4),
(139858, NULL, 'G3DSA:3.40.50.300:FF:000785', NULL, NULL, 'DEAD/DEAH box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(139859, NULL, 'G3DSA:3.90.420.10:FF:000001', NULL, NULL, 'Protein-methionine-sulfoxide reductase catalytic subunit MsrP', NULL, NULL, NULL, NULL, NULL, 4),
(139860, NULL, 'G3DSA:3.30.530.20:FF:000071', NULL, NULL, 'START domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(139861, NULL, 'G3DSA:3.30.160.20:FF:000042', NULL, NULL, 'SON DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(139862, NULL, 'G3DSA:2.60.40.10:FF:002847', NULL, NULL, 'Protein CBG01857', NULL, NULL, NULL, NULL, NULL, 4),
(139863, NULL, 'G3DSA:2.60.40.10:FF:003336', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139864, NULL, 'G3DSA:2.60.40.10:FF:006107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139865, NULL, 'G3DSA:1.10.1320.10:FF:000018', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(139866, NULL, 'G3DSA:1.10.260.40:FF:000045', NULL, NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139867, NULL, 'G3DSA:3.40.50.300:FF:005309', NULL, NULL, 'ATP-dependent DNA helicase PIF1', NULL, NULL, NULL, NULL, NULL, 4),
(139868, NULL, 'G3DSA:1.10.150.60:FF:000032', NULL, NULL, 'ARID/BRIGHT DNA-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(139869, NULL, 'G3DSA:2.30.30.140:FF:000076', NULL, NULL, 'RING finger protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(139870, NULL, 'G3DSA:3.40.50.300:FF:001274', NULL, NULL, 'Cell division protein ZapE', NULL, NULL, NULL, NULL, NULL, 4),
(139871, NULL, 'G3DSA:3.90.70.10:FF:000018', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 32', NULL, NULL, NULL, NULL, NULL, 4),
(139872, NULL, 'G3DSA:3.40.47.10:FF:000309', NULL, NULL, 'Polyketide synthase/nonribosomal peptide synthetase hybrid RzxB', NULL, NULL, NULL, NULL, NULL, 4),
(139873, NULL, 'G3DSA:3.30.70.100:FF:000186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139874, NULL, 'G3DSA:2.130.10.80:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139875, NULL, 'G3DSA:2.60.40.10:FF:002072', NULL, NULL, 'Plexin A1a', NULL, NULL, NULL, NULL, NULL, 4),
(139876, NULL, 'G3DSA:1.10.1420.10:FF:000071', NULL, NULL, 'Mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(139877, NULL, 'G3DSA:3.40.850.10:FF:000516', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139878, NULL, 'G3DSA:3.40.50.2300:FF:001058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139879, NULL, 'G3DSA:2.20.70.10:FF:000220', NULL, NULL, 'WW domain-containing protein WWM1', NULL, NULL, NULL, NULL, NULL, 4),
(139880, NULL, 'G3DSA:2.40.50.90:FF:000152', NULL, NULL, 'Thermonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(139881, NULL, 'G3DSA:3.30.420.10:FF:000413', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139882, NULL, 'G3DSA:3.40.50.300:FF:000329', NULL, NULL, 'GTP-binding protein rhoA', NULL, NULL, NULL, NULL, NULL, 4),
(139883, NULL, 'G3DSA:2.60.40.10:FF:001127', NULL, NULL, 'Myosin, light chain kinase a', NULL, NULL, NULL, NULL, NULL, 4),
(139884, NULL, 'G3DSA:3.30.160.40:FF:000020', NULL, NULL, 'Hydroxymethylbilane synthase, b', NULL, NULL, NULL, NULL, NULL, 4),
(139885, NULL, 'G3DSA:1.20.1070.10:FF:001839', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(139886, NULL, 'G3DSA:1.20.920.10:FF:000124', NULL, NULL, 'YALI0D20702p', NULL, NULL, NULL, NULL, NULL, 4),
(139887, NULL, 'G3DSA:2.40.10.170:FF:000016', NULL, NULL, 'ATP synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(139888, NULL, 'G3DSA:1.10.287.70:FF:000756', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139889, NULL, 'G3DSA:2.60.40.640:FF:000013', NULL, NULL, 'Putative arrestin domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(139890, NULL, 'G3DSA:3.30.200.20:FF:001187', NULL, NULL, 'OSJNBa0042I15.25 protein', NULL, NULL, NULL, NULL, NULL, 4),
(139891, NULL, 'G3DSA:3.40.50.300:FF:008406', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139892, NULL, 'G3DSA:1.10.540.10:FF:000114', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(139893, NULL, 'G3DSA:3.80.10.10:FF:004236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139894, NULL, 'G3DSA:3.30.70.330:FF:002571', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139895, NULL, 'G3DSA:1.25.10.10:FF:002327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139896, NULL, 'G3DSA:3.10.100.10:FF:000366', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139897, NULL, 'G3DSA:3.80.10.10:FF:000313', NULL, NULL, 'Leucine rich repeat containing 14B', NULL, NULL, NULL, NULL, NULL, 4),
(139898, NULL, 'G3DSA:1.25.40.20:FF:001315', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139899, NULL, 'G3DSA:2.60.40.1510:FF:000024', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(139900, NULL, 'G3DSA:1.10.510.10:FF:003029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139901, NULL, 'G3DSA:3.80.10.10:FF:001139', NULL, NULL, 'Os08g0194350 protein', NULL, NULL, NULL, NULL, NULL, 4),
(139902, NULL, 'G3DSA:2.130.10.10:FF:004657', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139903, NULL, 'G3DSA:3.40.50.2300:FF:000541', NULL, NULL, 'Ornithine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(139904, NULL, 'G3DSA:1.10.10.60:FF:001212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139905, NULL, 'G3DSA:1.10.238.10:FF:000350', NULL, NULL, 'Calcium-binding EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(139906, NULL, 'G3DSA:3.40.50.300:FF:007917', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139907, NULL, 'G3DSA:3.30.430.20:FF:000035', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 25 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(139908, NULL, 'G3DSA:3.40.50.1980:FF:000028', NULL, NULL, 'High-affinity zinc uptake system protein znuA', NULL, NULL, NULL, NULL, NULL, 4),
(139909, NULL, 'G3DSA:1.10.1300.10:FF:000005', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(139910, NULL, 'G3DSA:3.20.20.70:FF:000289', NULL, NULL, '2-dehydro-3-deoxy-phosphogluconate/2-dehydro-3-deoxy-6-phosphogalactonate aldolase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(139911, NULL, 'G3DSA:1.10.510.10:FF:000697', NULL, NULL, 'G2-specific protein kinase nimA', NULL, NULL, NULL, NULL, NULL, 4),
(139912, NULL, 'G3DSA:3.40.710.10:FF:000006', NULL, NULL, 'Penicillin-binding protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(139913, NULL, 'G3DSA:1.20.58.390:FF:000238', NULL, NULL, 'Gamma-aminobutyric acid type A receptor alpha6 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(139914, NULL, 'G3DSA:1.10.10.10:FF:000950', NULL, NULL, 'Toxin co-regulated pilus biosynthesis protein P', NULL, NULL, NULL, NULL, NULL, 4),
(139915, NULL, 'G3DSA:2.70.98.10:FF:000046', NULL, NULL, 'Alpha-1,2-mannosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139916, NULL, 'G3DSA:3.40.30.10:FF:001277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139917, NULL, 'G3DSA:3.30.70.330:FF:002115', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139918, NULL, 'G3DSA:2.40.50.140:FF:000460', NULL, NULL, 'ATP-dependent DNA helicase RecG', NULL, NULL, NULL, NULL, NULL, 4),
(139919, NULL, 'G3DSA:2.30.29.90:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139920, NULL, 'G3DSA:1.20.1250.20:FF:001283', NULL, NULL, 'Uncharacterized MFS-type transporter YwoD', NULL, NULL, NULL, NULL, NULL, 4),
(139921, NULL, 'G3DSA:1.10.357.110:FF:000004', NULL, NULL, 'Vacuolar-sorting protein 53 long isoform', NULL, NULL, NULL, NULL, NULL, 4),
(139922, NULL, 'G3DSA:1.25.10.10:FF:001810', NULL, NULL, 'Regulatory associated protein of MTOR, complex 1', NULL, NULL, NULL, NULL, NULL, 4),
(139923, NULL, 'G3DSA:1.10.8.60:FF:000020', NULL, NULL, '26S protease regulatory subunit 6B', NULL, NULL, NULL, NULL, NULL, 4),
(139924, NULL, 'G3DSA:2.60.40.10:FF:000947', NULL, NULL, 'Carcinoembryonic antigen related cell adhesion molecule 16', NULL, NULL, NULL, NULL, NULL, 4),
(139925, NULL, 'G3DSA:3.40.50.300:FF:000638', NULL, NULL, 'Transmembrane GTPase Fzo1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139926, NULL, 'G3DSA:3.40.630.10:FF:000314', NULL, NULL, 'Carboxypeptidase T, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139927, NULL, 'G3DSA:1.10.510.10:FF:002383', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139928, NULL, 'G3DSA:3.30.428.10:FF:000072', NULL, NULL, 'Bis(5''-adenosyl)-triphosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139929, NULL, 'G3DSA:1.10.510.10:FF:001894', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(139930, NULL, 'G3DSA:1.20.58.60:FF:000849', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139931, NULL, 'G3DSA:2.130.10.10:FF:005130', NULL, NULL, 'Intraflagellar transport protein 122 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(139932, NULL, 'G3DSA:3.30.300.20:FF:000031', NULL, NULL, 'GTPase Era', NULL, NULL, NULL, NULL, NULL, 4),
(139933, NULL, 'G3DSA:3.30.1380.20:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139934, NULL, 'G3DSA:3.40.50.300:FF:005517', NULL, NULL, 'Meiotic recombination protein DMC1', NULL, NULL, NULL, NULL, NULL, 4),
(139935, NULL, 'G3DSA:3.40.50.1440:FF:000007', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(139936, NULL, 'G3DSA:2.160.20.10:FF:000048', NULL, NULL, 'tRNA nuclease CdiA', NULL, NULL, NULL, NULL, NULL, 4),
(139937, NULL, 'G3DSA:3.30.200.20:FF:001979', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139938, NULL, 'G3DSA:3.10.250.10:FF:000039', NULL, NULL, 'Multidomain scavenger receptor', NULL, NULL, NULL, NULL, NULL, 4),
(139939, NULL, 'G3DSA:3.30.43.10:FF:000014', NULL, NULL, 'L-gulonolactone oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(139940, NULL, 'G3DSA:3.40.1110.10:FF:000409', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139941, NULL, 'G3DSA:1.20.1250.20:FF:000322', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(139942, NULL, 'G3DSA:3.90.25.10:FF:000021', NULL, NULL, 'GDP-mannose 4,6-dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(139943, NULL, 'G3DSA:3.40.50.10880:FF:000005', NULL, NULL, 'DUF89-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(139944, NULL, 'G3DSA:1.10.510.10:FF:002411', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139945, NULL, 'G3DSA:2.60.40.150:FF:000754', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139946, NULL, 'G3DSA:1.25.40.570:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139947, NULL, 'G3DSA:1.10.630.10:FF:000430', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139948, NULL, 'G3DSA:3.90.20.20:FF:000035', NULL, NULL, 'Protein GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(139949, NULL, 'G3DSA:3.30.40.10:FF:000564', NULL, NULL, 'ERAD-associated E3 ubiquitin-protein ligase HRD1', NULL, NULL, NULL, NULL, NULL, 4),
(139950, NULL, 'G3DSA:3.30.830.10:FF:000107', NULL, NULL, 'Insulin-degrading enzyme homolog', NULL, NULL, NULL, NULL, NULL, 4),
(139951, NULL, 'G3DSA:3.40.50.2000:FF:000232', NULL, NULL, 'UDP-glycosyltransferase 76C1', NULL, NULL, NULL, NULL, NULL, 4),
(139952, NULL, 'G3DSA:3.30.200.20:FF:001395', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(139953, NULL, 'G3DSA:3.40.50.1240:FF:000071', NULL, NULL, 'Probable phosphoglycerate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(139954, NULL, 'G3DSA:3.30.40.10:FF:001183', NULL, NULL, 'Ring finger domain/Zinc finger, C3HC4 type (RING finger) containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139955, NULL, 'G3DSA:1.20.1110.10:FF:000146', NULL, NULL, 'Cation-transporting P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(139956, NULL, 'G3DSA:2.20.200.10:FF:000004', NULL, NULL, 'Multidrug resistance outer membrane protein MdtQ', NULL, NULL, NULL, NULL, NULL, 4),
(139957, NULL, 'G3DSA:3.40.50.11990:FF:000001', NULL, NULL, 'Cell division cycle 73', NULL, NULL, NULL, NULL, NULL, 4),
(139958, NULL, 'G3DSA:3.90.640.10:FF:000113', NULL, NULL, 'Actin-like ATPase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(139959, NULL, 'G3DSA:3.90.70.10:FF:000653', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(139960, NULL, 'G3DSA:3.40.50.150:FF:001431', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139961, NULL, 'G3DSA:3.30.160.60:FF:001796', NULL, NULL, 'Fanconi-associated nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(139962, NULL, 'G3DSA:3.90.660.20:FF:000016', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(139963, NULL, 'G3DSA:3.30.450.20:FF:000598', NULL, NULL, 'C4-dicarboxylate transport sensor protein DctB, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139964, NULL, 'G3DSA:1.25.40.10:FF:000710', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(139965, NULL, 'G3DSA:3.40.50.620:FF:000616', NULL, NULL, 'Glutamate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(139966, NULL, 'G3DSA:3.30.760.10:FF:000034', NULL, NULL, 'Eukaryotic translation initiation factor 4E, putative', NULL, NULL, NULL, NULL, NULL, 4),
(139967, NULL, 'G3DSA:3.10.20.90:FF:000969', NULL, NULL, 'Chromosome 12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(139968, NULL, 'G3DSA:3.80.10.10:FF:003539', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139969, NULL, 'G3DSA:3.40.50.10140:FF:000031', NULL, NULL, 'putative ST2L protein isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(139970, NULL, 'G3DSA:1.10.287.130:FF:000061', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(139971, NULL, 'G3DSA:1.10.800.10:FF:000022', NULL, NULL, 'Tyrosine hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(139972, NULL, 'G3DSA:3.40.850.10:FF:000308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139973, NULL, 'G3DSA:3.30.413.10:FF:000037', NULL, NULL, 'Anaerobic sulfite reductase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(139974, NULL, 'G3DSA:1.10.1450.10:FF:000044', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(139975, NULL, 'G3DSA:4.10.400.10:FF:000093', NULL, NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(139976, NULL, 'G3DSA:1.20.1110.10:FF:000247', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139977, NULL, 'G3DSA:1.10.750.20:FF:000009', NULL, NULL, 'Suppressor of cytokine signaling 1', NULL, NULL, NULL, NULL, NULL, 4),
(139978, NULL, 'G3DSA:3.30.70.330:FF:000215', NULL, NULL, 'ELAV-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(139979, NULL, 'G3DSA:1.10.30.50:FF:000002', NULL, NULL, 'DNA annealing helicase and endonuclease ZRANB3', NULL, NULL, NULL, NULL, NULL, 4),
(139980, NULL, 'G3DSA:3.40.1110.10:FF:000398', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(139981, NULL, 'G3DSA:1.25.10.10:FF:000630', NULL, NULL, 'DnaJ heat shock protein family (Hsp40) member C13', NULL, NULL, NULL, NULL, NULL, 4),
(139982, NULL, 'G3DSA:3.10.350.10:FF:000103', NULL, NULL, 'Membrane-bound lytic peptidoglycan transglycosylase D', NULL, NULL, NULL, NULL, NULL, 4),
(139983, NULL, 'G3DSA:2.60.40.420:FF:000150', NULL, NULL, 'Coagulation factor V', NULL, NULL, NULL, NULL, NULL, 4),
(139984, NULL, 'G3DSA:2.60.120.260:FF:000537', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139985, NULL, 'G3DSA:3.40.190.290:FF:000120', NULL, NULL, 'Uncharacterized HTH-type transcriptional regulator HI_0775', NULL, NULL, NULL, NULL, NULL, 4),
(139986, NULL, 'G3DSA:1.10.30.10:FF:000041', NULL, NULL, 'HMG box family protein', NULL, NULL, NULL, NULL, NULL, 4),
(139987, NULL, 'G3DSA:3.20.20.80:FF:000410', NULL, NULL, 'Klotho beta', NULL, NULL, NULL, NULL, NULL, 4),
(139988, NULL, 'G3DSA:1.10.287.1150:FF:000019', NULL, NULL, 'Alpha-ketoglutarate dehydrogenase E1', NULL, NULL, NULL, NULL, NULL, 4),
(139989, NULL, 'G3DSA:3.30.450.60:FF:000031', NULL, NULL, 'Signal recognition particle receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(139990, NULL, 'G3DSA:1.10.533.10:FF:000047', NULL, NULL, 'Nucleotide-binding oligomerization domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(139991, NULL, 'G3DSA:3.40.50.80:FF:000208', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(139992, NULL, 'G3DSA:3.40.50.300:FF:008070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139993, NULL, 'G3DSA:3.40.1370.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(139994, NULL, 'G3DSA:3.30.1370.10:FF:000009', NULL, NULL, 'RNA-binding protein PNO1', NULL, NULL, NULL, NULL, NULL, 4),
(139995, NULL, 'G3DSA:1.25.40.10:FF:002155', NULL, NULL, 'Transcription factor EMB1444', NULL, NULL, NULL, NULL, NULL, 4),
(139996, NULL, 'G3DSA:1.10.287.380:FF:000006', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(139997, NULL, 'G3DSA:2.170.270.10:FF:000057', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(139998, NULL, 'G3DSA:3.30.420.100:FF:000024', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(139999, NULL, 'G3DSA:2.90.10.10:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140000, NULL, 'G3DSA:2.40.50.140:FF:001168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140001, NULL, 'G3DSA:3.40.50.300:FF:000740', NULL, NULL, 'Putative GTP-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(140002, NULL, 'G3DSA:1.10.238.10:FF:000934', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140003, NULL, 'G3DSA:3.90.1150.10:FF:000215', NULL, NULL, 'Glycine dehydrogenase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(140004, NULL, 'G3DSA:3.40.50.1820:FF:000043', NULL, NULL, 'acylamino-acid-releasing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(140005, NULL, 'G3DSA:4.10.260.10:FF:000002', NULL, NULL, 'Regulator of G-protein signaling 6', NULL, NULL, NULL, NULL, NULL, 4),
(140006, NULL, 'G3DSA:1.20.1560.10:FF:000067', NULL, NULL, 'Multidrug resistance protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(140007, NULL, 'G3DSA:3.30.160.60:FF:001324', NULL, NULL, 'Zinc finger protein 664', NULL, NULL, NULL, NULL, NULL, 4),
(140008, NULL, 'G3DSA:3.80.10.10:FF:004045', NULL, NULL, 'Nischarin', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(140009, NULL, 'G3DSA:1.20.5.1160:FF:000013', NULL, NULL, 'Tropomyosin 1 (alpha)', NULL, NULL, NULL, NULL, NULL, 4),
(140010, NULL, 'G3DSA:2.160.10.10:FF:000019', NULL, NULL, 'YRDA protein yrdA', NULL, NULL, NULL, NULL, NULL, 4),
(140011, NULL, 'G3DSA:1.25.40.20:FF:001124', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(140012, NULL, 'G3DSA:2.130.10.10:FF:001431', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140013, NULL, 'G3DSA:3.30.450.20:FF:000126', NULL, NULL, 'Putative diguanylate cyclase YegE', NULL, NULL, NULL, NULL, NULL, 4),
(140014, NULL, 'G3DSA:3.30.565.10:FF:000119', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(140015, NULL, 'G3DSA:3.40.930.10:FF:000034', NULL, NULL, 'Anion/Bicarbonate TranSporter family', NULL, NULL, NULL, NULL, NULL, 4),
(140016, NULL, 'G3DSA:3.10.20.90:FF:000924', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140017, NULL, 'G3DSA:3.40.630.30:FF:000528', NULL, NULL, 'Tetratricopeptide repeat protein 21B-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(140018, NULL, 'G3DSA:1.10.510.10:FF:004209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140019, NULL, 'G3DSA:2.30.42.10:FF:000043', NULL, NULL, 'Syntenin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(140020, NULL, 'G3DSA:1.10.20.10:FF:000276', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140021, NULL, 'G3DSA:3.30.470.30:FF:000029', NULL, NULL, 'Mrna capping enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(140022, NULL, 'G3DSA:4.10.60.10:FF:000098', NULL, NULL, 'Cellular nucleic acid-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(140023, NULL, 'G3DSA:3.40.50.920:FF:000015', NULL, NULL, 'Pyruvate dehydrogenase E1 component subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(140024, NULL, 'G3DSA:1.25.10.10:FF:002119', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(140025, NULL, 'G3DSA:3.90.180.10:FF:000066', NULL, NULL, 'Putative quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(140026, NULL, 'G3DSA:2.70.150.10:FF:000090', NULL, NULL, 'Cadmium-translocating P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(140027, NULL, 'G3DSA:3.30.300.30:FF:000135', NULL, NULL, 'Nonribosomal peptide synthetase 6', NULL, NULL, NULL, NULL, NULL, 4),
(140028, NULL, 'G3DSA:1.10.1520.10:FF:000016', NULL, NULL, 'Endoribonuclease Dcr-1', NULL, NULL, NULL, NULL, NULL, 4),
(140029, NULL, 'G3DSA:3.90.79.10:FF:000190', NULL, NULL, 'NUDIX family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(140030, NULL, 'G3DSA:3.30.470.10:FF:000023', NULL, NULL, 'Branched-chain-amino-acid transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(140031, NULL, 'G3DSA:3.30.830.10:FF:000006', NULL, NULL, 'Putative insulin-degrading enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(140032, NULL, 'G3DSA:3.10.290.20:FF:000005', NULL, NULL, 'Ubiquitin-activating enzyme E1-like', NULL, NULL, NULL, NULL, NULL, 4),
(140033, NULL, 'G3DSA:2.40.10.10:FF:000401', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140034, NULL, 'G3DSA:1.10.472.10:FF:000068', NULL, NULL, 'Cyclin-L1-1 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(140035, NULL, 'G3DSA:3.90.226.10:FF:000196', NULL, NULL, 'Enoyl-CoA hydratase/isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(140036, NULL, 'G3DSA:1.25.40.10:FF:003892', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140037, NULL, 'G3DSA:2.30.230.10:FF:000032', NULL, NULL, 'von Willebrand factor type D domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(140038, NULL, 'G3DSA:3.40.50.300:FF:003174', NULL, NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(140039, NULL, 'G3DSA:3.40.50.2300:FF:001619', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140040, NULL, 'G3DSA:3.40.525.10:FF:000036', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(140041, NULL, 'G3DSA:1.20.1070.10:FF:001148', NULL, NULL, '5-hydroxytryptamine receptor 4', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(140042, NULL, 'G3DSA:3.30.70.330:FF:001418', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140043, NULL, 'G3DSA:1.10.10.10:FF:001175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140044, NULL, 'G3DSA:3.30.260.10:FF:000086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140045, NULL, 'G3DSA:3.40.50.10320:FF:000006', NULL, NULL, '4-oxalmesaconate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(140046, NULL, 'G3DSA:1.10.246.10:FF:000014', NULL, NULL, 'Serum albumin', NULL, NULL, NULL, NULL, NULL, 4),
(140047, NULL, 'G3DSA:3.40.50.620:FF:000824', NULL, NULL, 'Transcriptional regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(140048, NULL, 'G3DSA:2.10.25.10:FF:000313', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(140049, NULL, 'G3DSA:2.60.40.10:FF:000508', NULL, NULL, 'ephrin type-B receptor 6', NULL, NULL, NULL, NULL, NULL, 4),
(140050, NULL, 'G3DSA:1.25.10.10:FF:002428', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140051, NULL, 'G3DSA:3.90.1070.10:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140052, NULL, 'G3DSA:1.10.10.60:FF:000801', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140053, NULL, 'G3DSA:3.30.40.10:FF:000772', NULL, NULL, 'E3 ubiquitin-protein ligase rnf146', NULL, NULL, NULL, NULL, NULL, 4),
(140054, NULL, 'G3DSA:3.40.50.170:FF:000009', NULL, NULL, 'Phosphoribosylglycinamide formyltransferase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(140055, NULL, 'G3DSA:1.25.40.10:FF:003111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140056, NULL, 'G3DSA:3.20.20.80:FF:000101', NULL, NULL, 'Lysozyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(140057, NULL, 'G3DSA:1.25.40.10:FF:000502', NULL, NULL, 'Os03g0185200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(140058, NULL, 'G3DSA:1.25.40.20:FF:001332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140059, NULL, 'G3DSA:2.20.90.10:FF:000002', NULL, NULL, 'Vitellogenin-2', NULL, NULL, NULL, NULL, NULL, 4),
(140060, NULL, 'G3DSA:2.30.29.30:FF:001355', NULL, NULL, 'Serine/threonine-protein kinase ksg1', NULL, NULL, NULL, NULL, NULL, 4),
(140061, NULL, 'G3DSA:3.90.1520.10:FF:000013', NULL, NULL, 'Soluble guanylate cyclase gcy-37', NULL, NULL, NULL, NULL, NULL, 4),
(140062, NULL, 'G3DSA:1.20.1250.20:FF:000114', NULL, NULL, 'Inner membrane metabolite transporter yhjE', NULL, NULL, NULL, NULL, NULL, 4),
(140063, NULL, 'G3DSA:1.10.510.10:FF:003237', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140064, NULL, 'G3DSA:3.30.900.10:FF:000023', NULL, NULL, 'Mitotic spindle assembly checkpoint protein MAD2B', NULL, NULL, NULL, NULL, NULL, 4),
(140065, NULL, 'G3DSA:1.10.1740.140:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140066, NULL, 'G3DSA:2.10.70.100:FF:000003', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(140067, NULL, 'G3DSA:2.40.50.40:FF:000053', NULL, NULL, 'CX chemokine ligand 34b, duplicate 11', NULL, NULL, NULL, NULL, NULL, 4),
(140068, NULL, 'G3DSA:3.10.28.10:FF:000059', NULL, NULL, 'Vitamin B12-dependent ribonucleotide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(140069, NULL, 'G3DSA:2.60.120.330:FF:000098', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140070, NULL, 'G3DSA:3.40.1800.20:FF:000010', NULL, NULL, 'Transcription factor grauzone', NULL, NULL, NULL, NULL, NULL, 4),
(140071, NULL, 'G3DSA:1.10.418.10:FF:000223', NULL, NULL, 'PH domain-containing protein DDB_G0287875', NULL, NULL, NULL, NULL, NULL, 4),
(140072, NULL, 'G3DSA:3.40.50.300:FF:006945', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140073, NULL, 'G3DSA:2.60.120.620:FF:000016', NULL, NULL, 'Ectoine hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(140074, NULL, 'G3DSA:2.30.42.10:FF:000352', NULL, NULL, 'Periplasmic protease', NULL, NULL, NULL, NULL, NULL, 4),
(140075, NULL, 'G3DSA:3.30.40.10:FF:000463', NULL, NULL, 'E3 ubiquitin-protein ligase RNF185 isoform X2', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(140076, NULL, 'G3DSA:1.25.40.10:FF:000811', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(140077, NULL, 'G3DSA:3.90.1100.10:FF:000004', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(140078, NULL, 'G3DSA:3.20.20.80:FF:000090', NULL, NULL, 'Alpha-L-arabinofuranosidase A', NULL, NULL, NULL, NULL, NULL, 4),
(140079, NULL, 'G3DSA:3.90.550.10:FF:000685', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140080, NULL, 'G3DSA:3.60.90.10:FF:000015', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(140081, NULL, 'G3DSA:2.40.50.140:FF:000196', NULL, NULL, 'rRNA biogenesis protein RRP5', NULL, NULL, NULL, NULL, NULL, 4),
(140082, NULL, 'G3DSA:3.30.430.20:FF:000018', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 10', NULL, NULL, NULL, NULL, NULL, 4),
(140083, NULL, 'G3DSA:3.30.160.60:FF:000604', NULL, NULL, 'Histone H4 transcription factor-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(140084, NULL, 'G3DSA:1.10.10.850:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140085, NULL, 'G3DSA:3.30.565.10:FF:000018', NULL, NULL, 'Two-component sensor kinase EnvZ', NULL, NULL, NULL, NULL, NULL, 4),
(140086, NULL, 'G3DSA:3.30.9.10:FF:000059', NULL, NULL, 'Oxidoreductase, DadA family', NULL, NULL, NULL, NULL, NULL, 4),
(140087, NULL, 'G3DSA:3.30.1540.20:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140088, NULL, 'G3DSA:3.30.1120.30:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140089, NULL, 'G3DSA:3.20.20.70:FF:000553', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140090, NULL, 'G3DSA:3.30.70.330:FF:000446', NULL, NULL, 'Cyclic AMP-dependent transcription factor ATF-1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(140091, NULL, 'G3DSA:3.80.10.10:FF:002819', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140092, NULL, 'G3DSA:3.10.20.90:FF:000599', NULL, NULL, 'TuBulin folding Cofactor E homolog', NULL, NULL, NULL, NULL, NULL, 4),
(140093, NULL, 'G3DSA:1.10.10.10:FF:000247', NULL, NULL, 'HTH-type transcriptional regulator MetR', NULL, NULL, NULL, NULL, NULL, 4),
(140094, NULL, 'G3DSA:3.40.50.970:FF:000137', NULL, NULL, 'Sulfite reductase [NADPH] flavoprotein component, putative', NULL, NULL, NULL, NULL, NULL, 4),
(140095, NULL, 'G3DSA:1.20.1070.10:FF:000322', NULL, NULL, 'latrophilin Cirl isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(140096, NULL, 'G3DSA:1.10.287.110:FF:000375', NULL, NULL, 'Heat shock protein DnaJ domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(140097, NULL, 'G3DSA:2.60.40.2690:FF:000007', NULL, NULL, 'Zinc-finger of C2H2 type', NULL, NULL, NULL, NULL, NULL, 4),
(140098, NULL, 'G3DSA:3.40.50.300:FF:007226', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140099, NULL, 'G3DSA:3.40.50.280:FF:000014', NULL, NULL, 'Methylmalonyl-CoA mutase C-terminal domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(140100, NULL, 'G3DSA:1.10.510.10:FF:002984', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140101, NULL, 'G3DSA:3.30.2350.10:FF:000082', NULL, NULL, 'tRNA pseudouridine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(140102, NULL, 'G3DSA:2.60.40.1110:FF:000011', NULL, NULL, 'Phosphatidylinositol 3,4,5-trisphosphate 3-phosphatase and dual-specificity protein phosphatase PTEN', NULL, NULL, NULL, NULL, NULL, 4),
(140103, NULL, 'G3DSA:1.10.287.1130:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140104, NULL, 'G3DSA:2.60.40.10:FF:004764', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140105, NULL, 'G3DSA:3.40.350.10:FF:000040', NULL, NULL, 'Cytoplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(140106, NULL, 'G3DSA:3.30.930.10:FF:000379', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140107, NULL, 'G3DSA:3.30.565.10:FF:000327', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(140108, NULL, 'G3DSA:2.20.25.20:FF:000001', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(140109, NULL, 'G3DSA:1.25.10.10:FF:003047', NULL, NULL, 'Transportin MOS14', NULL, NULL, NULL, NULL, NULL, 4),
(140110, NULL, 'G3DSA:3.30.479.20:FF:000001', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(140111, NULL, 'G3DSA:3.40.50.620:FF:000515', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(140112, NULL, 'G3DSA:3.30.160.60:FF:002184', NULL, NULL, 'Zinc finger protein 668', NULL, NULL, NULL, NULL, NULL, 4),
(140113, NULL, 'G3DSA:1.10.1870.10:FF:000003', NULL, NULL, 'Lysine-ketoglutarate reductase/saccharopine dehydrogenase1', NULL, NULL, NULL, NULL, NULL, 4),
(140114, NULL, 'G3DSA:3.90.1200.10:FF:000068', NULL, NULL, 'Fructosamine-3-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(140115, NULL, 'G3DSA:2.30.110.10:FF:000068', NULL, NULL, 'Blr4240 protein', NULL, NULL, NULL, NULL, NULL, 4),
(140116, NULL, 'G3DSA:4.10.1130.10:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140117, NULL, 'G3DSA:3.10.110.10:FF:000181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140118, NULL, 'G3DSA:1.20.1730.10:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140119, NULL, 'G3DSA:2.10.25.10:FF:000768', NULL, NULL, 'Cadherin-related tumor suppressor', NULL, NULL, NULL, NULL, NULL, 4),
(140120, NULL, 'G3DSA:1.25.10.10:FF:000321', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(140121, NULL, 'G3DSA:1.25.40.10:FF:003936', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140122, NULL, 'G3DSA:3.30.160.60:FF:000498', NULL, NULL, 'Putative zinc finger protein 131', NULL, NULL, NULL, NULL, NULL, 4),
(140123, NULL, 'G3DSA:2.130.10.10:FF:000812', NULL, NULL, 'Plexin B2a', NULL, NULL, NULL, NULL, NULL, 4),
(140124, NULL, 'G3DSA:3.40.50.300:FF:002555', NULL, NULL, 'Membrane-associated sulfotransferase kil1', NULL, NULL, NULL, NULL, NULL, 4),
(140125, NULL, 'G3DSA:3.40.50.1820:FF:000144', NULL, NULL, 'Ndr family protein', NULL, NULL, NULL, NULL, NULL, 4),
(140126, NULL, 'G3DSA:3.40.50.620:FF:000263', NULL, NULL, 'Asparagine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(140127, NULL, 'G3DSA:1.10.20.10:FF:000175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140128, NULL, 'G3DSA:2.60.40.10:FF:004180', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140129, NULL, 'G3DSA:3.30.420.40:FF:000411', NULL, NULL, 'RNA polymerase II transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(140130, NULL, 'G3DSA:3.80.10.10:FF:004253', NULL, NULL, 'Relaxin family peptide receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(140131, NULL, 'G3DSA:3.30.420.40:FF:000091', NULL, NULL, 'Anhydro-N-acetylmuramic acid kinase', NULL, NULL, NULL, NULL, NULL, 4),
(140132, NULL, 'G3DSA:3.80.20.20:FF:000013', NULL, NULL, 'Erb-b2 receptor tyrosine kinase 3a', NULL, NULL, NULL, NULL, NULL, 4),
(140133, NULL, 'G3DSA:3.40.50.300:FF:006400', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140134, NULL, 'G3DSA:3.30.40.10:FF:001289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140135, NULL, 'G3DSA:1.10.510.10:FF:000011', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(140136, NULL, 'G3DSA:3.90.70.10:FF:000698', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140137, NULL, 'G3DSA:2.30.29.70:FF:000018', NULL, NULL, 'Uncharacterized protein C342.04', NULL, NULL, NULL, NULL, NULL, 4),
(140138, NULL, 'G3DSA:2.60.40.2130:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140139, NULL, 'G3DSA:1.25.40.10:FF:003684', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140140, NULL, 'G3DSA:3.90.1150.10:FF:000316', NULL, NULL, 'Neamine transaminase BtrB', NULL, NULL, NULL, NULL, NULL, 4),
(140141, NULL, 'G3DSA:2.60.40.60:FF:000001', NULL, NULL, 'Protocadherin alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(140142, NULL, 'G3DSA:1.10.510.10:FF:000466', NULL, NULL, 'MAP kinase kinase kinase18', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(140143, NULL, 'G3DSA:2.40.50.140:FF:001269', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140144, NULL, 'G3DSA:3.40.50.300:FF:005989', NULL, NULL, 'Katanin p60 ATPase-containing subunit A-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(140145, NULL, 'G3DSA:3.30.160.60:FF:004393', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140146, NULL, 'G3DSA:1.10.246.60:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140147, NULL, 'G3DSA:2.10.70.10:FF:000209', NULL, NULL, 'Complement regulatory membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(140148, NULL, 'G3DSA:1.10.1000.11:FF:000012', NULL, NULL, 'BRag/Iqsec/Schizo related Arf GEF family member', NULL, NULL, NULL, NULL, NULL, 4),
(140149, NULL, 'G3DSA:3.40.50.300:FF:003983', NULL, NULL, 'Putative replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(140150, NULL, 'G3DSA:3.40.50.12610:FF:000002', NULL, NULL, 'dolichyl-diphosphooligosaccharide--protein glycosyltransferase subunit STT3A', NULL, NULL, NULL, NULL, NULL, 4),
(140151, NULL, 'G3DSA:3.40.630.10:FF:000213', NULL, NULL, 'Succinyl-diaminopimelate desuccinylase', NULL, NULL, NULL, NULL, NULL, 4),
(140152, NULL, 'G3DSA:1.20.120.430:FF:000025', NULL, NULL, 'tRNA modification GTPase MnmE', NULL, NULL, NULL, NULL, NULL, 4),
(140153, NULL, 'G3DSA:1.25.10.10:FF:001602', NULL, NULL, 'Kinesin associated protein kap-1', NULL, NULL, NULL, NULL, NULL, 4),
(140154, NULL, 'G3DSA:3.40.630.30:FF:000219', NULL, NULL, 'Nat4p', NULL, NULL, NULL, NULL, NULL, 4),
(140155, NULL, 'G3DSA:3.80.10.10:FF:001274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140156, NULL, 'G3DSA:1.25.10.10:FF:002928', NULL, NULL, 'TORTIFOLIA1-like protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(140157, NULL, 'G3DSA:3.30.420.40:FF:000309', NULL, NULL, 'Mitochondrial type HSP70, putative', NULL, NULL, NULL, NULL, NULL, 4),
(140158, NULL, 'G3DSA:2.40.70.10:FF:000377', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140159, NULL, 'G3DSA:2.120.10.30:FF:000414', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140160, NULL, 'G3DSA:3.30.70.2520:FF:000002', NULL, NULL, 'FAD-linked oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(140161, NULL, 'G3DSA:2.60.120.650:FF:000076', NULL, NULL, 'Lysine-specific demethylase 6A isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(140162, NULL, 'G3DSA:1.10.10.10:FF:001630', NULL, NULL, 'Protein CBG20282', NULL, NULL, NULL, NULL, NULL, 4),
(140163, NULL, 'G3DSA:1.10.8.60:FF:000391', NULL, NULL, 'YALI0C00671p', NULL, NULL, NULL, NULL, NULL, 4),
(140164, NULL, 'G3DSA:1.10.8.60:FF:000492', NULL, NULL, 'ATPase, AAA superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(140165, NULL, 'G3DSA:2.120.10.30:FF:000459', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140166, NULL, 'G3DSA:3.40.50.2300:FF:001266', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140167, NULL, 'G3DSA:3.40.50.1220:FF:000060', NULL, NULL, '2-succinyl-5-enolpyruvyl-6-hydroxy-3-cyclohexene-1-carboxylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(140168, NULL, 'G3DSA:3.40.50.1000:FF:000802', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140169, NULL, 'G3DSA:4.10.60.10:FF:000131', NULL, NULL, 'ATP-dependent DNA helicase PIF1', NULL, NULL, NULL, NULL, NULL, 4),
(140170, NULL, 'G3DSA:3.40.970.10:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140171, NULL, 'G3DSA:1.10.10.10:FF:001675', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140172, NULL, 'G3DSA:1.20.1310.20:FF:000001', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(140173, NULL, 'G3DSA:3.40.50.300:FF:005883', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(140174, NULL, 'G3DSA:3.30.1130.10:FF:000014', NULL, NULL, 'Folic acid synthesis protein fol1', NULL, NULL, NULL, NULL, NULL, 4),
(140175, NULL, 'G3DSA:1.10.10.10:FF:000039', NULL, NULL, 'Friend leukemia integration 1 transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(140176, NULL, 'G3DSA:3.40.50.720:FF:001939', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(140177, NULL, 'G3DSA:3.10.129.10:FF:000010', NULL, NULL, 'Cytosolic acyl coenzyme A thioester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(140178, NULL, 'G3DSA:2.20.25.90:FF:000010', NULL, NULL, 'NADH-ubiquinone oxidoreductase-G iron-sulfur binding region', NULL, NULL, NULL, NULL, NULL, 4),
(140179, NULL, 'G3DSA:2.130.10.10:FF:004202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140180, NULL, 'G3DSA:3.40.1350.10:FF:000028', NULL, NULL, 'tRNA-splicing endonuclease subunit Sen34', NULL, NULL, NULL, NULL, NULL, 4),
(140181, NULL, 'G3DSA:2.40.30.10:FF:000464', NULL, NULL, 'Elongation factor SelB', NULL, NULL, NULL, NULL, NULL, 4),
(140182, NULL, 'G3DSA:3.30.160.60:FF:001015', NULL, NULL, 'Zinc finger protein 142', NULL, NULL, NULL, NULL, NULL, 4),
(140183, NULL, 'G3DSA:1.10.10.480:FF:000007', NULL, NULL, 'Diphosphate-fructose-6-phosphate 1-phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(140184, NULL, 'G3DSA:3.50.50.60:FF:000764', NULL, NULL, 'D-amino acid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(140185, NULL, 'G3DSA:1.10.510.10:FF:000730', NULL, NULL, 'Protein serine/threonine kinase-1', NULL, NULL, NULL, NULL, NULL, 4),
(140186, NULL, 'G3DSA:1.25.40.180:FF:000032', NULL, NULL, 'Nucleolar MIF4G domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(140187, NULL, 'G3DSA:1.20.120.1750:FF:000006', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(140188, NULL, 'G3DSA:1.10.510.10:FF:000275', NULL, NULL, 'SRSF protein kinase 2 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(140189, NULL, 'G3DSA:1.20.1050.50:FF:000001', NULL, NULL, 'Ammonia monooxygenase/methane monooxygenase, subunit C family protein', NULL, NULL, NULL, NULL, NULL, 4),
(140190, NULL, 'G3DSA:3.30.160.20:FF:000143', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(140191, NULL, 'G3DSA:3.40.50.10810:FF:000159', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140192, NULL, 'G3DSA:1.20.5.170:FF:000050', NULL, NULL, 'E3 ubiquitin-protein ligase RNF8', NULL, NULL, NULL, NULL, NULL, 4),
(140193, NULL, 'G3DSA:1.20.140.40:FF:000045', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(140194, NULL, 'G3DSA:1.20.1280.50:FF:000001', NULL, NULL, 'F-box/WD repeat-containing protein 11 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(140195, NULL, 'G3DSA:1.10.510.10:FF:002720', NULL, NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', NULL, NULL, NULL, NULL, NULL, 4),
(140196, NULL, 'G3DSA:2.60.40.770:FF:000024', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140197, NULL, 'G3DSA:3.30.40.10:FF:000255', NULL, NULL, 'Bromodomain adjacent to zinc finger domain protein 2A', NULL, NULL, NULL, NULL, NULL, 4),
(140198, NULL, 'G3DSA:3.40.50.720:FF:001164', NULL, NULL, 'Shikimate biosynthesis protein AroDE', NULL, NULL, NULL, NULL, NULL, 4),
(140199, NULL, 'G3DSA:3.40.50.2000:FF:000541', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140200, NULL, 'G3DSA:3.30.1370.20:FF:000001', NULL, NULL, 'Quinone-dependent D-lactate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(140201, NULL, 'G3DSA:2.60.120.1540:FF:000011', NULL, NULL, 'Thioester-containing protein 2, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(140202, NULL, 'G3DSA:3.80.10.10:FF:003848', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140203, NULL, 'G3DSA:3.10.20.230:FF:000028', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140204, NULL, 'G3DSA:2.30.30.30:FF:000038', NULL, NULL, 'Translation initiation factor 5A', NULL, NULL, NULL, NULL, NULL, 4),
(140205, NULL, 'G3DSA:3.20.20.100:FF:000066', NULL, NULL, 'Aldo/keto reductase', NULL, NULL, NULL, NULL, NULL, 4),
(140206, NULL, 'G3DSA:2.30.42.10:FF:000149', NULL, NULL, 'Periaxin', NULL, NULL, NULL, NULL, NULL, 4),
(140207, NULL, 'G3DSA:2.60.40.60:FF:000501', NULL, NULL, 'Desmocollin 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(140208, NULL, 'G3DSA:1.25.40.10:FF:004864', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(140209, NULL, 'G3DSA:1.20.5.340:FF:000123', NULL, NULL, 'Stromal interaction molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(140210, NULL, 'G3DSA:2.70.170.10:FF:000118', NULL, NULL, 'AGAP010057-PA', NULL, NULL, NULL, NULL, NULL, 4),
(140211, NULL, 'G3DSA:3.90.1420.10:FF:000051', NULL, NULL, 'Os01g0976450 protein', NULL, NULL, NULL, NULL, NULL, 4),
(140212, NULL, 'G3DSA:2.120.10.30:FF:000561', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140213, NULL, 'G3DSA:2.60.210.10:FF:000018', NULL, NULL, 'MATH_domain_containing_protein', NULL, NULL, NULL, NULL, NULL, 4),
(140214, NULL, 'G3DSA:1.10.287.110:FF:000167', NULL, NULL, 'TPR-repeat-containing chaperone protein DNAJ', NULL, NULL, NULL, NULL, NULL, 4),
(140215, NULL, 'G3DSA:3.30.1490.180:FF:000021', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(140216, NULL, 'G3DSA:2.60.34.10:FF:000017', NULL, NULL, 'Heat shock 70 kDa protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(140217, NULL, 'G3DSA:3.90.190.10:FF:000600', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140218, NULL, 'G3DSA:3.40.50.300:FF:005208', NULL, NULL, 'RAD57 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(140219, NULL, 'G3DSA:3.40.50.10130:FF:000039', NULL, NULL, 'DNA excision repair protein ERCC-1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(140220, NULL, 'G3DSA:2.60.40.420:FF:000256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140221, NULL, 'G3DSA:1.10.10.10:FF:000450', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(140222, NULL, 'G3DSA:3.30.497.10:FF:000175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140223, NULL, 'G3DSA:2.30.30.60:FF:000007', NULL, NULL, 'Mechanosensitive ion channel domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(140224, NULL, 'G3DSA:3.40.390.10:FF:000014', NULL, NULL, 'disintegrin and metalloproteinase domain-containing protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(140225, NULL, 'G3DSA:3.40.140.70:FF:000008', NULL, NULL, 'ubiquitin-like modifier-activating enzyme ATG7', NULL, NULL, NULL, NULL, NULL, 4),
(140226, NULL, 'G3DSA:3.60.21.10:FF:000412', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140227, NULL, 'G3DSA:1.10.132.10:FF:000008', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(140228, NULL, 'G3DSA:3.30.70.330:FF:001727', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140229, NULL, 'G3DSA:3.30.750.24:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140230, NULL, 'G3DSA:2.115.10.20:FF:000014', NULL, NULL, 'Sucrose-6-phosphate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(140231, NULL, 'G3DSA:2.60.40.10:FF:002656', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(140232, NULL, 'G3DSA:3.30.559.10:FF:000044', NULL, NULL, 'Phenolpthiocerol synthesis type-I polyketide synthase ppsE', NULL, NULL, NULL, NULL, NULL, 4),
(140233, NULL, 'G3DSA:3.40.50.10050:FF:000004', NULL, NULL, 'Translation initiation factor if-2', NULL, NULL, NULL, NULL, NULL, 4),
(140234, NULL, 'G3DSA:1.10.1670.10:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140235, NULL, 'G3DSA:3.10.100.10:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140236, NULL, 'G3DSA:3.40.50.300:FF:000846', NULL, NULL, 'ATPase family AAA domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(140237, NULL, 'G3DSA:3.10.20.90:FF:000863', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140238, NULL, 'G3DSA:3.40.50.620:FF:000307', NULL, NULL, 'FAD synthetase 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(140239, NULL, 'G3DSA:3.40.47.10:FF:000091', NULL, NULL, 'Probable polyketide synthase 32', NULL, NULL, NULL, NULL, NULL, 4),
(140240, NULL, 'G3DSA:2.60.40.10:FF:000138', NULL, NULL, 'filamin-B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(140241, NULL, 'G3DSA:3.40.30.10:FF:000996', NULL, NULL, 'Os06g0659500 protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(140242, NULL, 'G3DSA:4.10.240.10:FF:000102', NULL, NULL, 'C6 transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(140243, NULL, 'G3DSA:2.130.10.10:FF:001740', NULL, NULL, 'Anaphase-promoting complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(140244, NULL, 'G3DSA:3.40.33.10:FF:000002', NULL, NULL, 'Golgi-associated plant pathogenesis-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(140245, NULL, 'G3DSA:3.40.50.2300:FF:000440', NULL, NULL, 'Response regulator receiver domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(140246, NULL, 'G3DSA:3.40.50.720:FF:002344', NULL, NULL, 'Oxidoreductase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(140247, NULL, 'G3DSA:3.40.50.960:FF:000016', NULL, NULL, '6,7-dimethyl-8-ribityllumazine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(140248, NULL, 'G3DSA:2.60.40.10:FF:001228', NULL, NULL, 'Fibronectin type III domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(140249, NULL, 'G3DSA:3.40.1110.10:FF:000134', NULL, NULL, 'Cation transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(140250, NULL, 'G3DSA:1.10.510.10:FF:002175', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(140251, NULL, 'G3DSA:3.90.1150.10:FF:000524', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140252, NULL, 'G3DSA:3.40.50.1470:FF:000005', NULL, NULL, 'Peptidyl-tRNA hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(140253, NULL, 'G3DSA:3.40.50.1820:FF:000352', NULL, NULL, 'Conserved hypothetical membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(140254, NULL, 'G3DSA:3.30.230.10:FF:000360', NULL, NULL, 'Ribonuclease P protein component', NULL, NULL, NULL, NULL, NULL, 4),
(140255, NULL, 'G3DSA:1.10.10.10:FF:000141', NULL, NULL, 'vacuolar protein-sorting-associated protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(140256, NULL, 'G3DSA:3.30.160.60:FF:004758', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140257, NULL, 'G3DSA:3.40.1280.10:FF:000056', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4),
(140258, NULL, 'G3DSA:1.20.1070.10:FF:001648', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140259, NULL, 'G3DSA:3.40.367.20:FF:000003', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(140260, NULL, 'G3DSA:1.20.5.540:FF:000003', NULL, NULL, 'Acetyltransferase Atu2258', NULL, NULL, NULL, NULL, NULL, 4),
(140261, NULL, 'G3DSA:2.60.200.20:FF:000245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140262, NULL, 'G3DSA:3.30.420.380:FF:000001', NULL, NULL, 'DNA utilization protein HofM', NULL, NULL, NULL, NULL, NULL, 4),
(140263, NULL, 'G3DSA:2.130.10.30:FF:000009', NULL, NULL, 'Regulator of chromosome condensation 2', NULL, NULL, NULL, NULL, NULL, 4),
(140264, NULL, 'G3DSA:3.40.718.10:FF:000035', NULL, NULL, 'Isocitrate dehydrogenase 3 (NAD+) alpha', NULL, NULL, NULL, NULL, NULL, 4),
(140265, NULL, 'G3DSA:2.130.10.10:FF:002257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140266, NULL, 'G3DSA:1.10.287.2900:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140267, NULL, 'G3DSA:3.40.50.1580:FF:000032', NULL, NULL, 'Purine nucleoside phosphorylase lateral transfer candidate', NULL, NULL, NULL, NULL, NULL, 4),
(140268, NULL, 'G3DSA:3.30.40.10:FF:001744', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140269, NULL, 'G3DSA:1.10.287.4070:FF:000007', NULL, NULL, 'Putative trans-splicing factor', NULL, NULL, NULL, NULL, NULL, 4),
(140270, NULL, 'G3DSA:1.25.40.10:FF:003583', NULL, NULL, 'Heat shock 70kD protein binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(140271, NULL, 'G3DSA:2.30.29.30:FF:000849', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140272, NULL, 'G3DSA:2.60.40.60:FF:001120', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140273, NULL, 'G3DSA:1.25.40.10:FF:004201', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140274, NULL, 'G3DSA:2.30.42.10:FF:000104', NULL, NULL, 'harmonin isoform X2', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(140275, NULL, 'G3DSA:3.40.50.2000:FF:001058', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140276, NULL, 'G3DSA:2.40.10.10:FF:000137', NULL, NULL, 'GD22965', NULL, NULL, NULL, NULL, NULL, 4),
(140277, NULL, 'G3DSA:3.30.60.20:FF:000012', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(140278, NULL, 'G3DSA:3.50.50.60:FF:000101', NULL, NULL, 'lycopene epsilon cyclase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(140279, NULL, 'G3DSA:3.90.70.10:FF:000592', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140280, NULL, 'G3DSA:3.30.160.60:FF:003010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140281, NULL, 'G3DSA:4.10.1000.10:FF:000109', NULL, NULL, 'Zinc finger C-x8-C-x5-C-x3-H type family protein', NULL, NULL, NULL, NULL, NULL, 4),
(140282, NULL, 'G3DSA:3.60.15.10:FF:000027', NULL, NULL, 'DNA ligase 6', NULL, NULL, NULL, NULL, NULL, 4),
(140283, NULL, 'G3DSA:3.90.1410.10:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140284, NULL, 'G3DSA:3.40.50.1000:FF:000550', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140285, NULL, 'G3DSA:3.40.50.1820:FF:001324', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140286, NULL, 'G3DSA:1.10.287.70:FF:000548', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140287, NULL, 'G3DSA:3.40.50.1100:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140288, NULL, 'G3DSA:3.30.470.20:FF:000144', NULL, NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(140289, NULL, 'G3DSA:1.50.10.20:FF:000114', NULL, NULL, 'Geranylgeranyl transferase type-2 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(140290, NULL, 'G3DSA:3.30.160.60:FF:002605', NULL, NULL, 'Zinc finger protein 45', NULL, NULL, NULL, NULL, NULL, 4),
(140291, NULL, 'G3DSA:3.30.1360.70:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140292, NULL, 'G3DSA:3.30.160.60:FF:004449', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140293, NULL, 'G3DSA:2.70.98.10:FF:000107', NULL, NULL, 'Aldose 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(140294, NULL, 'G3DSA:3.40.640.10:FF:000450', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140295, NULL, 'G3DSA:2.10.25.10:FF:001173', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(140296, NULL, 'G3DSA:3.40.190.10:FF:000617', NULL, NULL, 'Hydroxymethylbilane synthase', NULL, NULL, NULL, NULL, NULL, 4),
(140297, NULL, 'G3DSA:2.40.50.140:FF:000651', NULL, NULL, 'Related to 30S ribosomal protein S17', NULL, NULL, NULL, NULL, NULL, 4),
(140298, NULL, 'G3DSA:3.30.40.10:FF:001891', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140299, NULL, 'G3DSA:2.60.40.10:FF:000402', NULL, NULL, 'Protein tyrosine kinase 7 (inactive)', NULL, NULL, NULL, NULL, NULL, 4),
(140300, NULL, 'G3DSA:3.30.565.10:FF:000221', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(140301, NULL, 'G3DSA:2.130.10.10:FF:002920', NULL, NULL, 'Uncharacterized WD repeat-containing protein C4F8.11', NULL, NULL, NULL, NULL, NULL, 4),
(140302, NULL, 'G3DSA:3.40.50.12240:FF:000003', NULL, NULL, 'V-type proton ATPase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(140303, NULL, 'G3DSA:3.30.200.20:FF:000422', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(140304, NULL, 'G3DSA:3.30.720.50:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140305, NULL, 'G3DSA:3.90.70.10:FF:000226', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(140306, NULL, 'G3DSA:1.25.40.10:FF:001430', NULL, NULL, 'Os01g0800400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(140307, NULL, 'G3DSA:1.20.1070.10:FF:001491', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140308, NULL, 'G3DSA:3.90.228.20:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140309, NULL, 'G3DSA:3.20.20.70:FF:000761', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(140310, NULL, 'G3DSA:1.20.1250.20:FF:001603', NULL, NULL, 'Sucrose transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(140311, NULL, 'G3DSA:2.10.25.10:FF:001482', NULL, NULL, 'slit homolog 2 protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(140312, NULL, 'G3DSA:2.40.160.120:FF:000047', NULL, NULL, 'Oxysterol-binding protein-related protein 3C', NULL, NULL, NULL, NULL, NULL, 4),
(140313, NULL, 'G3DSA:1.25.40.10:FF:002964', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140314, NULL, 'G3DSA:3.40.50.300:FF:006136', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(140315, NULL, 'G3DSA:3.40.50.12670:FF:000014', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(140316, NULL, 'G3DSA:3.40.50.11260:FF:000018', NULL, NULL, 'Molecular chaperone/ Grp94/Hsp90', NULL, NULL, NULL, NULL, NULL, 4),
(140317, NULL, 'G3DSA:2.60.40.150:FF:000046', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(140318, NULL, 'G3DSA:1.20.920.20:FF:000009', NULL, NULL, 'Putative dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(140319, NULL, 'G3DSA:3.40.50.10260:FF:000027', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(140320, NULL, 'G3DSA:2.30.42.10:FF:000560', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140321, NULL, 'G3DSA:2.130.10.10:FF:000150', NULL, NULL, 'Dmx-like 2, isoform CRA_c', NULL, NULL, NULL, NULL, NULL, 4),
(140322, NULL, 'G3DSA:1.10.600.10:FF:000041', NULL, NULL, 'Geranylgeranyl pyrophosphate synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(140323, NULL, 'G3DSA:2.70.130.10:FF:000088', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140324, NULL, 'G3DSA:3.30.450.40:FF:000137', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(140325, NULL, 'G3DSA:1.25.40.10:FF:000047', NULL, NULL, 'SMG5, nonsense mediated mRNA decay factor', NULL, NULL, NULL, NULL, NULL, 4),
(140326, NULL, 'G3DSA:2.120.10.60:FF:000002', NULL, NULL, 'Tricorn protease homolog', NULL, NULL, NULL, NULL, NULL, 4),
(140327, NULL, 'G3DSA:3.40.50.300:FF:003410', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140328, NULL, 'G3DSA:1.20.5.110:FF:000301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140329, NULL, 'G3DSA:1.10.472.10:FF:000169', NULL, NULL, 'CTD kinase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(140330, NULL, 'G3DSA:3.30.230.10:FF:000258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140331, NULL, 'G3DSA:2.40.70.10:FF:000068', NULL, NULL, 'Aspartic-type endopeptidase (OpsB)', NULL, NULL, NULL, NULL, NULL, 4),
(140332, NULL, 'G3DSA:1.20.1560.10:FF:000275', NULL, NULL, 'ATP-binding cassette, subfamily B', NULL, NULL, NULL, NULL, NULL, 4),
(140333, NULL, 'G3DSA:3.40.50.150:FF:000779', NULL, NULL, 'Methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(140334, NULL, 'G3DSA:2.40.50.140:FF:000549', NULL, NULL, '26S protease regulatory subunit 6B', NULL, NULL, NULL, NULL, NULL, 4),
(140335, NULL, 'G3DSA:3.40.50.1000:FF:000241', NULL, NULL, 'alpha,alpha-trehalose-phosphate synthase [UDP-forming] 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(140336, NULL, 'G3DSA:2.30.42.10:FF:000251', NULL, NULL, 'Shroom family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(140337, NULL, 'G3DSA:3.90.950.20:FF:000004', NULL, NULL, 'CinA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(140338, NULL, 'G3DSA:1.25.40.820:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140339, NULL, 'G3DSA:2.60.40.340:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140340, NULL, 'G3DSA:2.60.40.10:FF:005270', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140341, NULL, 'G3DSA:1.10.287.70:FF:000172', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(140342, NULL, 'G3DSA:3.40.50.980:FF:000027', NULL, NULL, 'Peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(140343, NULL, 'G3DSA:3.30.160.60:FF:001987', NULL, NULL, 'Transcription factor SFP1', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(140344, NULL, 'G3DSA:3.40.720.10:FF:000052', NULL, NULL, 'Phosphatidylglycerol specific phospholipase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(140345, NULL, 'G3DSA:2.60.200.20:FF:000026', NULL, NULL, 'Aprataxin and PNKP like factor', NULL, NULL, NULL, NULL, NULL, 4),
(140346, NULL, 'G3DSA:1.10.220.100:FF:000007', NULL, NULL, 'WD40, G-beta domain containing family protein, family', NULL, NULL, NULL, NULL, NULL, 4),
(140347, NULL, 'G3DSA:1.10.8.10:FF:000027', NULL, NULL, 'Trinucleotide repeat-containing gene 6C protein', NULL, NULL, NULL, NULL, NULL, 4),
(140348, NULL, 'G3DSA:1.20.120.350:FF:000035', NULL, NULL, 'Calcium-activated potassium channel slowpoke', NULL, NULL, NULL, NULL, NULL, 4),
(140349, NULL, 'G3DSA:1.20.140.150:FF:000075', NULL, NULL, 'STarGazin (Mammalian calcium channel) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(140350, NULL, 'G3DSA:2.160.20.10:FF:000256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140351, NULL, 'G3DSA:3.30.559.70:FF:000056', NULL, NULL, 'Zgc:154046', NULL, NULL, NULL, NULL, NULL, 4),
(140352, NULL, 'G3DSA:3.40.50.300:FF:001465', NULL, NULL, 'ABC multidrug transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(140353, NULL, 'G3DSA:3.30.720.210:FF:000007', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(140354, NULL, 'G3DSA:1.10.510.10:FF:003900', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140355, NULL, 'G3DSA:1.10.3720.10:FF:000167', NULL, NULL, 'Maltose/maltodextrin ABC transporter, permease protein MalG', NULL, NULL, NULL, NULL, NULL, 4),
(140356, NULL, 'G3DSA:3.40.50.720:FF:001725', NULL, NULL, 'Aspartate-semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(140357, NULL, 'G3DSA:2.60.120.560:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140358, NULL, 'G3DSA:1.25.40.10:FF:002256', NULL, NULL, 'protein SLOW GREEN 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(140359, NULL, 'G3DSA:2.60.120.10:FF:000354', NULL, NULL, 'Sodium/hydrogen exchanger 10-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(140360, NULL, 'G3DSA:1.10.1200.20:FF:000001', NULL, NULL, 'Colicin-E9 immunity protein', NULL, NULL, NULL, NULL, NULL, 4),
(140361, NULL, 'G3DSA:3.40.309.10:FF:000063', NULL, NULL, 'Aldehyde dehydrogenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(140362, NULL, 'G3DSA:1.20.1640.10:FF:000028', NULL, NULL, 'PaTched Related family', NULL, NULL, NULL, NULL, NULL, 4),
(140363, NULL, 'G3DSA:3.40.50.880:FF:000115', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(140364, NULL, 'G3DSA:1.10.442.10:FF:000004', NULL, NULL, 'COX4I1 isoform 13', NULL, NULL, NULL, NULL, NULL, 4),
(140365, NULL, 'G3DSA:3.90.470.20:FF:000069', NULL, NULL, 'L-aminoadipate-semialdehyde dehydrogenase-phosphopantetheinyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(140366, NULL, 'G3DSA:3.40.50.300:FF:004719', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140367, NULL, 'G3DSA:3.40.800.10:FF:000036', NULL, NULL, 'Agmatinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(140368, NULL, 'G3DSA:2.60.40.60:FF:000456', NULL, NULL, 'Cadherin 3', NULL, NULL, NULL, NULL, NULL, 4),
(140369, NULL, 'G3DSA:1.25.40.620:FF:000001', NULL, NULL, 'Tetrapyrrole-binding protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(140370, NULL, 'G3DSA:2.40.30.160:FF:000006', NULL, NULL, 'Protein CBG14872', NULL, NULL, NULL, NULL, NULL, 4),
(140371, NULL, 'G3DSA:2.10.70.10:FF:000283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140372, NULL, 'G3DSA:3.40.390.10:FF:000037', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(140373, NULL, 'G3DSA:2.60.40.2970:FF:000001', NULL, NULL, 'Neutral protease 2', NULL, NULL, NULL, NULL, NULL, 4),
(140374, NULL, 'G3DSA:2.40.100.10:FF:000003', NULL, NULL, 'Peptidylprolyl isomerase domain and WD repeat-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(140375, NULL, 'G3DSA:3.90.1200.10:FF:000085', NULL, NULL, 'Putative choline kinase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(140376, NULL, 'G3DSA:3.30.565.10:FF:000474', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140377, NULL, 'G3DSA:1.25.10.10:FF:000866', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140378, NULL, 'G3DSA:3.40.47.10:FF:000208', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140379, NULL, 'G3DSA:3.40.30.10:FF:000102', NULL, NULL, 'Glutathione S-transferase DHAR3 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(140380, NULL, 'G3DSA:3.10.490.20:FF:000026', NULL, NULL, 'Putative dynein heavy chain, cytosolic', NULL, NULL, NULL, NULL, NULL, 4),
(140381, NULL, 'G3DSA:1.25.40.20:FF:000270', NULL, NULL, 'Transient receptor potential cation channel subfamily V member 6', NULL, NULL, NULL, NULL, NULL, 4),
(140382, NULL, 'G3DSA:3.80.10.10:FF:001583', NULL, NULL, 'Leucine-rich repeat family protein isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(140383, NULL, 'G3DSA:2.60.40.770:FF:000001', NULL, NULL, 'NPC intracellular cholesterol transporter 2', NULL, NULL, NULL, NULL, NULL, 4),
(140384, NULL, 'G3DSA:2.40.50.140:FF:000313', NULL, NULL, 'ATP-dependent DNA helicase RecG', NULL, NULL, NULL, NULL, NULL, 4),
(140385, NULL, 'G3DSA:1.10.1420.10:FF:000099', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(140386, NULL, 'G3DSA:1.20.1250.20:FF:001058', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(140387, NULL, 'G3DSA:1.10.20.10:FF:000192', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140388, NULL, 'G3DSA:2.120.10.100:FF:000004', NULL, NULL, 'ATP diphosphohydrolase apyrase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(140389, NULL, 'G3DSA:2.40.128.330:FF:000006', NULL, NULL, 'Metal ion channel-Mg2+, Co2+ and Ni2', NULL, NULL, NULL, NULL, NULL, 4),
(140390, NULL, 'G3DSA:3.90.70.10:FF:000889', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140391, NULL, 'G3DSA:3.80.10.10:FF:003191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140392, NULL, 'G3DSA:2.60.40.1190:FF:000001', NULL, NULL, 'Heme binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(140393, NULL, 'G3DSA:3.30.200.20:FF:000653', NULL, NULL, 'L-type lectin-domain containing receptor kinase S.4', NULL, NULL, NULL, NULL, NULL, 4),
(140394, NULL, 'G3DSA:2.60.40.1400:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140395, NULL, 'G3DSA:1.20.1250.20:FF:000069', NULL, NULL, 'Solute carrier family 45 member 4', NULL, NULL, NULL, NULL, NULL, 4),
(140396, NULL, 'G3DSA:3.30.200.20:FF:000214', NULL, NULL, 'WAK1-OsWAK receptor-like cytoplasmic kinase (OsWAK-RLCK)', NULL, NULL, NULL, NULL, NULL, 4),
(140397, NULL, 'G3DSA:3.40.50.1820:FF:001425', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140398, NULL, 'G3DSA:3.60.15.10:FF:000105', NULL, NULL, 'Ribonuclease Z', NULL, NULL, NULL, NULL, NULL, 4),
(140399, NULL, 'G3DSA:1.20.5.290:FF:000001', NULL, NULL, 'Cardiac phospholamban', NULL, NULL, NULL, NULL, NULL, 4),
(140400, NULL, 'G3DSA:3.30.9.90:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140401, NULL, 'G3DSA:3.80.10.10:FF:001055', NULL, NULL, 'OSJNBb0076A22.12 protein', NULL, NULL, NULL, NULL, NULL, 4),
(140402, NULL, 'G3DSA:2.30.30.140:FF:000284', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(140403, NULL, 'G3DSA:1.25.10.10:FF:002474', NULL, NULL, 'Plakophilin 1a', NULL, NULL, NULL, NULL, NULL, 4),
(140404, NULL, 'G3DSA:2.130.10.10:FF:004421', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140405, NULL, 'G3DSA:3.30.1490.100:FF:000031', NULL, NULL, 'DNA polymerase eta', NULL, NULL, NULL, NULL, NULL, 4),
(140406, NULL, 'G3DSA:3.40.50.2000:FF:001030', NULL, NULL, 'UDP-N-acetylglucosamine transferase subunit ALG14', NULL, NULL, NULL, NULL, NULL, 4),
(140407, NULL, 'G3DSA:1.20.1250.20:FF:000985', NULL, NULL, 'OSJNBb0008G24.13-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(140408, NULL, 'G3DSA:1.10.3080.10:FF:000027', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(140409, NULL, 'G3DSA:3.20.20.10:FF:000086', NULL, NULL, 'Pyridoxal-dependent decarboxylase, C-terminal sheet domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(140410, NULL, 'G3DSA:3.40.190.10:FF:000409', NULL, NULL, 'Amino acid ABC transporter amino acid-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(140411, NULL, 'G3DSA:1.10.8.270:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140412, NULL, 'G3DSA:3.40.50.720:FF:002237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140413, NULL, 'G3DSA:3.20.20.370:FF:000023', NULL, NULL, 'Carbohydrate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(140414, NULL, 'G3DSA:3.40.50.11840:FF:000018', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(140415, NULL, 'G3DSA:1.10.287.1490:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140416, NULL, 'G3DSA:3.60.130.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140417, NULL, 'G3DSA:4.10.520.10:FF:000023', NULL, NULL, 'HNS-type DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(140418, NULL, 'G3DSA:2.40.240.10:FF:000013', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(140419, NULL, 'G3DSA:3.40.50.300:FF:000537', NULL, NULL, 'Bloom syndrome RecQ-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(140420, NULL, 'G3DSA:1.25.10.10:FF:001855', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(140421, NULL, 'G3DSA:3.30.1610.10:FF:000017', NULL, NULL, 'Nucleoporin 98', NULL, NULL, NULL, NULL, NULL, 4),
(140422, NULL, 'G3DSA:1.20.120.350:FF:000136', NULL, NULL, 'Potassium voltage-gated channel, subfamily G, member 4b', NULL, NULL, NULL, NULL, NULL, 4),
(140423, NULL, 'G3DSA:1.20.5.4820:FF:000015', NULL, NULL, 'myosin-IB isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(140424, NULL, 'G3DSA:1.20.900.10:FF:000033', NULL, NULL, 'Muscle M-line assembly protein unc-89-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(140425, NULL, 'G3DSA:1.20.1070.10:FF:001283', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(140426, NULL, 'G3DSA:3.30.40.10:FF:001845', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140427, NULL, 'G3DSA:1.25.40.790:FF:000006', NULL, NULL, 'NOT family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(140428, NULL, 'G3DSA:2.40.30.10:FF:000380', NULL, NULL, 'Elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(140429, NULL, 'G3DSA:2.130.10.10:FF:002813', NULL, NULL, 'Eukaryotic translation initiation factor 2A', NULL, NULL, NULL, NULL, NULL, 4),
(140430, NULL, 'G3DSA:2.20.110.10:FF:000014', NULL, NULL, 'MORN repeat-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(140431, NULL, 'G3DSA:3.90.70.10:FF:000462', NULL, NULL, 'Protein CBG06540', NULL, NULL, NULL, NULL, NULL, 4),
(140432, NULL, 'G3DSA:3.50.50.60:FF:001192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140433, NULL, 'G3DSA:3.30.160.60:FF:004213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140434, NULL, 'G3DSA:2.60.40.10:FF:000711', NULL, NULL, 'Nectin cell adhesion molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(140435, NULL, 'G3DSA:3.40.50.300:FF:004236', NULL, NULL, 'Switch 2', NULL, NULL, NULL, NULL, NULL, 4),
(140436, NULL, 'G3DSA:3.30.710.10:FF:000076', NULL, NULL, 'rho-related BTB domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(140437, NULL, 'G3DSA:2.60.40.2030:FF:000040', NULL, NULL, 'Fras1-related extracellular matrix protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(140438, NULL, 'G3DSA:3.30.70.330:FF:000901', NULL, NULL, 'Unplaced genomic scaffold supercont2.15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(140439, NULL, 'G3DSA:3.40.50.410:FF:000115', NULL, NULL, 'Retroelement pol polyprotein-like', NULL, NULL, NULL, NULL, NULL, 4),
(140440, NULL, 'G3DSA:2.70.98.10:FF:000001', NULL, NULL, 'Glucans biosynthesis protein G', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(140441, NULL, 'G3DSA:2.40.128.680:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140442, NULL, 'G3DSA:1.10.1200.10:FF:000088', NULL, NULL, 'Nonribosomal peptide synthase GliP2', NULL, NULL, NULL, NULL, NULL, 4),
(140443, NULL, 'G3DSA:2.60.40.10:FF:003252', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140444, NULL, 'G3DSA:1.10.287.370:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140445, NULL, 'G3DSA:3.80.10.10:FF:002100', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(140446, NULL, 'G3DSA:2.120.10.80:FF:000412', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140447, NULL, 'G3DSA:1.10.10.60:FF:000824', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140448, NULL, 'G3DSA:3.30.420.340:FF:000012', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4),
(140449, NULL, 'G3DSA:3.40.50.300:FF:008614', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140450, NULL, 'G3DSA:2.40.70.10:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140451, NULL, 'G3DSA:1.10.510.10:FF:004092', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140452, NULL, 'G3DSA:3.30.160.60:FF:002268', NULL, NULL, 'Zinc finger protein YPR022C', NULL, NULL, NULL, NULL, NULL, 4),
(140453, NULL, 'G3DSA:2.80.10.50:FF:000136', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(140454, NULL, 'G3DSA:3.40.50.880:FF:000222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140455, NULL, 'G3DSA:3.40.50.300:FF:008507', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140456, NULL, 'G3DSA:2.60.40.10:FF:003145', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140457, NULL, 'G3DSA:1.10.510.10:FF:004412', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140458, NULL, 'G3DSA:2.60.40.10:FF:005489', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140459, NULL, 'G3DSA:3.40.50.150:FF:001768', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140460, NULL, 'G3DSA:1.20.1250.20:FF:001491', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140461, NULL, 'G3DSA:3.30.70.1230:FF:000267', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140462, NULL, 'G3DSA:1.10.8.960:FF:000007', NULL, NULL, 'Glutamate--cysteine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(140463, NULL, 'G3DSA:1.20.1070.10:FF:001592', NULL, NULL, 'G protein-coupled receptor 141', NULL, NULL, NULL, NULL, NULL, 4),
(140464, NULL, 'G3DSA:1.10.1040.10:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140465, NULL, 'G3DSA:3.30.70.330:FF:002340', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140466, NULL, 'G3DSA:1.10.3210.10:FF:000044', NULL, NULL, 'Response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(140467, NULL, 'G3DSA:3.30.70.20:FF:000041', NULL, NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(140468, NULL, 'G3DSA:1.10.10.10:FF:000377', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(140469, NULL, 'G3DSA:3.30.160.60:FF:004522', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140470, NULL, 'G3DSA:2.10.220.10:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140471, NULL, 'G3DSA:3.60.21.10:FF:000165', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(140472, NULL, 'G3DSA:1.20.120.790:FF:000009', NULL, NULL, 'Endoplasmin', NULL, NULL, NULL, NULL, NULL, 4),
(140473, NULL, 'G3DSA:1.25.40.80:FF:000006', NULL, NULL, 'Cryptochrome 2', NULL, NULL, NULL, NULL, NULL, 4),
(140474, NULL, 'G3DSA:3.40.50.300:FF:000184', NULL, NULL, 'Peptide chain release factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(140475, NULL, 'G3DSA:2.130.10.10:FF:005686', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(140476, NULL, 'G3DSA:3.30.450.200:FF:000004', NULL, NULL, 'SET binding factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(140477, NULL, 'G3DSA:1.20.120.770:FF:000003', NULL, NULL, 'Amyloid-beta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(140478, NULL, 'G3DSA:1.20.1000.10:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140479, NULL, 'G3DSA:1.20.1250.20:FF:002014', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(140480, NULL, 'G3DSA:1.25.40.10:FF:002711', NULL, NULL, 'Transcriptional activator domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(140481, NULL, 'G3DSA:2.60.40.1180:FF:000088', NULL, NULL, 'Alpha,alpha-phosphotrehalase', NULL, NULL, NULL, NULL, NULL, 4),
(140482, NULL, 'G3DSA:1.10.10.60:FF:000459', NULL, NULL, 'Transcriptional regulator, TetR family', NULL, NULL, NULL, NULL, NULL, 4),
(140483, NULL, 'G3DSA:1.50.40.10:FF:000539', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140484, NULL, 'G3DSA:3.90.660.10:FF:000092', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140485, NULL, 'G3DSA:3.40.225.10:FF:000019', NULL, NULL, '3-hydroxy-2-methylpyridine-4,5-dicarboxylic acid decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(140486, NULL, 'G3DSA:2.60.40.10:FF:003937', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140487, NULL, 'G3DSA:1.20.1440.90:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140488, NULL, 'G3DSA:2.60.40.10:FF:001330', NULL, NULL, 'Fibronectin type III domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(140489, NULL, 'G3DSA:2.40.50.100:FF:000088', NULL, NULL, 'ABC sugar transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(140490, NULL, 'G3DSA:1.25.40.10:FF:001683', NULL, NULL, 'Selenium-binding protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(140491, NULL, 'G3DSA:3.30.200.160:FF:000015', NULL, NULL, 'Transcription factor tau subunit sfc1', NULL, NULL, NULL, NULL, NULL, 4),
(140492, NULL, 'G3DSA:1.25.40.10:FF:002172', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g32415, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(140493, NULL, 'G3DSA:1.10.10.60:FF:000329', NULL, NULL, 'Mix paired-like homeobox', NULL, NULL, NULL, NULL, NULL, 4),
(140494, NULL, 'G3DSA:3.40.50.1970:FF:000065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140495, NULL, 'G3DSA:1.10.340.30:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140496, NULL, 'G3DSA:3.40.50.920:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140497, NULL, 'G3DSA:2.40.50.140:FF:000420', NULL, NULL, 'Putative DNA replication factor', NULL, NULL, NULL, NULL, NULL, 4),
(140498, NULL, 'G3DSA:1.25.40.420:FF:000020', NULL, NULL, 'Kelch-like 6 (Drosophila) (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(140499, NULL, 'G3DSA:2.130.10.10:FF:002504', NULL, NULL, 'Beta-alanine-activating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(140500, NULL, 'G3DSA:3.30.2160.10:FF:000061', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140501, NULL, 'G3DSA:3.40.390.10:FF:000144', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(140502, NULL, 'G3DSA:1.20.1250.20:FF:001367', NULL, NULL, 'Major facilitator superfamily MFS_1', NULL, NULL, NULL, NULL, NULL, 4),
(140503, NULL, 'G3DSA:3.30.200.20:FF:002092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140504, NULL, 'G3DSA:3.30.70.260:FF:000054', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(140505, NULL, 'G3DSA:3.90.190.20:FF:000013', NULL, NULL, 'Bifunctional folylpolyglutamate synthase/dihydrofolate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(140506, NULL, 'G3DSA:3.40.50.300:FF:004455', NULL, NULL, 'DNA repair ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(140507, NULL, 'G3DSA:2.30.30.40:FF:000367', NULL, NULL, 'Variant sh3 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(140508, NULL, 'G3DSA:3.30.450.40:FF:000036', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(140509, NULL, 'G3DSA:1.10.10.10:FF:000910', NULL, NULL, 'LexA repressor', NULL, NULL, NULL, NULL, NULL, 4),
(140510, NULL, 'G3DSA:3.30.200.20:FF:001939', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140511, NULL, 'G3DSA:2.60.40.1670:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140512, NULL, 'G3DSA:3.10.180.10:FF:000011', NULL, NULL, 'Lactoylglutathione lyase', NULL, NULL, NULL, NULL, NULL, 4),
(140513, NULL, 'G3DSA:3.40.640.10:FF:000473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140514, NULL, 'G3DSA:3.30.40.10:FF:002245', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140515, NULL, 'G3DSA:2.60.40.10:FF:004556', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140516, NULL, 'G3DSA:3.40.640.10:FF:000034', NULL, NULL, 'Probable glycine dehydrogenase (decarboxylating) subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(140517, NULL, 'G3DSA:3.50.7.10:FF:000027', NULL, NULL, 'T-complex protein 1 subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(140518, NULL, 'G3DSA:4.10.80.100:FF:000003', NULL, NULL, 'Nucleoside diphosphate-linked moiety X motif 6', NULL, NULL, NULL, NULL, NULL, 4),
(140519, NULL, 'G3DSA:3.40.50.300:FF:003303', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(140520, NULL, 'G3DSA:3.30.20.10:FF:000001', NULL, NULL, 'Endochitinase (Chitinase)', NULL, NULL, NULL, NULL, NULL, 4),
(140521, NULL, 'G3DSA:3.10.10.10:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140522, NULL, 'G3DSA:1.10.287.110:FF:000066', NULL, NULL, 'DNAJ heat shock family protein', NULL, NULL, NULL, NULL, NULL, 4),
(140523, NULL, 'G3DSA:3.40.50.720:FF:001372', NULL, NULL, 'Putative NAD-dependent 2-hydroxyacid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(140524, NULL, 'G3DSA:1.25.40.20:FF:001079', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140525, NULL, 'G3DSA:1.10.418.10:FF:000004', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(140526, NULL, 'G3DSA:3.30.160.60:FF:003701', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140527, NULL, 'G3DSA:2.40.50.180:FF:000005', NULL, NULL, 'Chemotaxis protein CheW', NULL, NULL, NULL, NULL, NULL, 4),
(140528, NULL, 'G3DSA:3.40.140.10:FF:000013', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(140529, NULL, 'G3DSA:2.160.20.10:FF:000025', NULL, NULL, 'Probable rhamnogalacturonase B', NULL, NULL, NULL, NULL, NULL, 4),
(140530, NULL, 'G3DSA:3.90.1150.10:FF:000395', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140531, NULL, 'G3DSA:3.80.10.10:FF:000419', NULL, NULL, 'Slit homolog 2 (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(140532, NULL, 'G3DSA:1.20.1250.20:FF:002323', NULL, NULL, 'Protein NRT1/ PTR FAMILY 7.1', NULL, NULL, NULL, NULL, NULL, 4),
(140533, NULL, 'G3DSA:3.30.60.30:FF:000240', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140534, NULL, 'G3DSA:1.20.1420.30:FF:000035', NULL, NULL, 'ECM27p protein', NULL, NULL, NULL, NULL, NULL, 4),
(140535, NULL, 'G3DSA:3.40.50.300:FF:001049', NULL, NULL, 'ATP-dependent RNA helicase DQX1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(140536, NULL, 'G3DSA:2.40.20.10:FF:000082', NULL, NULL, 'Neurotrypsin', NULL, NULL, NULL, NULL, NULL, 4),
(140537, NULL, 'G3DSA:2.10.220.10:FF:000165', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(140538, NULL, 'G3DSA:3.60.40.10:FF:000220', NULL, NULL, 'Probable protein phosphatase 2C 62', NULL, NULL, NULL, NULL, NULL, 4),
(140539, NULL, 'G3DSA:1.10.472.10:FF:000624', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140540, NULL, 'G3DSA:3.90.640.70:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140541, NULL, 'G3DSA:3.60.20.10:FF:000213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140542, NULL, 'G3DSA:1.20.140.150:FF:000029', NULL, NULL, 'lens fiber membrane intrinsic protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(140543, NULL, 'G3DSA:3.30.160.60:FF:005141', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(140544, NULL, 'G3DSA:3.10.20.90:FF:000733', NULL, NULL, 'Putative rho guanine nucleotide exchange factor cdep', NULL, NULL, NULL, NULL, NULL, 4),
(140545, NULL, 'G3DSA:3.30.43.10:FF:000037', NULL, NULL, 'Cholesterol oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(140546, NULL, 'G3DSA:2.40.440.10:FF:000017', NULL, NULL, 'L,D-transpeptidase catalytic domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(140547, NULL, 'G3DSA:1.10.287.130:FF:000145', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(140548, NULL, 'G3DSA:3.90.78.10:FF:000002', NULL, NULL, 'UDP-N-acetylenolpyruvoylglucosamine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(140549, NULL, 'G3DSA:1.10.3200.20:FF:000001', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(140550, NULL, 'G3DSA:3.40.20.10:FF:000023', NULL, NULL, 'protein transport protein Sec24C isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(140551, NULL, 'G3DSA:3.10.120.10:FF:000018', NULL, NULL, 'Heme/steroid binding domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(140552, NULL, 'G3DSA:1.20.1280.50:FF:000237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140553, NULL, 'G3DSA:2.10.25.10:FF:001538', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(140554, NULL, 'G3DSA:1.10.3590.10:FF:000004', NULL, NULL, 'Acid-sensing ion channel 3', NULL, NULL, NULL, NULL, NULL, 4),
(140555, NULL, 'G3DSA:2.70.50.30:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140556, NULL, 'G3DSA:3.30.160.60:FF:000470', NULL, NULL, 'zinc finger protein 276', NULL, NULL, NULL, NULL, NULL, 4),
(140557, NULL, 'G3DSA:1.10.10.440:FF:000029', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(140558, NULL, 'G3DSA:3.90.640.90:FF:000007', NULL, NULL, 'BTG anti-proliferation factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(140559, NULL, 'G3DSA:3.30.200.20:FF:002103', NULL, NULL, 'AGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(140560, NULL, 'G3DSA:2.70.170.10:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140561, NULL, 'G3DSA:2.60.120.340:FF:000016', NULL, NULL, 'nucleophosmin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(140562, NULL, 'G3DSA:3.40.50.1100:FF:000254', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140563, NULL, 'G3DSA:3.40.50.2300:FF:001013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140564, NULL, 'G3DSA:3.40.190.10:FF:000252', NULL, NULL, 'ABC transporter substrate-binding protein component', NULL, NULL, NULL, NULL, NULL, 4),
(140565, NULL, 'G3DSA:1.20.1440.130:FF:000009', NULL, NULL, 'Vitamin K epoxide reductase complex, subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(140566, NULL, 'G3DSA:2.170.300.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140567, NULL, 'G3DSA:3.40.50.300:FF:000869', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(140568, NULL, 'G3DSA:3.30.160.60:FF:005938', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140569, NULL, 'G3DSA:3.50.50.60:FF:000573', NULL, NULL, 'Steroid monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(140570, NULL, 'G3DSA:2.30.42.10:FF:000020', NULL, NULL, 'partitioning defective 3 homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(140571, NULL, 'G3DSA:3.90.190.10:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140572, NULL, 'G3DSA:3.40.50.1820:FF:001088', NULL, NULL, 'Serine peptidase, family S28, putative (AFU_orthologue AFUA_4G03790)', NULL, NULL, NULL, NULL, NULL, 4),
(140573, NULL, 'G3DSA:3.10.580.10:FF:000103', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(140574, NULL, 'G3DSA:3.50.50.100:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140575, NULL, 'G3DSA:2.170.260.10:FF:000006', NULL, NULL, 'Dicer-like 103', NULL, NULL, NULL, NULL, NULL, 4),
(140576, NULL, 'G3DSA:2.60.40.10:FF:004550', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(140577, NULL, 'G3DSA:3.20.20.70:FF:000660', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140578, NULL, 'G3DSA:1.10.10.2840:FF:000002', NULL, NULL, 'Transcriptional activator protein', NULL, NULL, NULL, NULL, NULL, 4),
(140579, NULL, 'G3DSA:2.70.150.10:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140580, NULL, 'G3DSA:1.20.900.10:FF:000016', NULL, NULL, 'Rho guanine nucleotide exchange factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(140581, NULL, 'G3DSA:3.80.10.10:FF:004461', NULL, NULL, 'Phytosulfokine receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(140582, NULL, 'G3DSA:3.40.1190.20:FF:000030', NULL, NULL, 'Kinase, PfkB family', NULL, NULL, NULL, NULL, NULL, 4),
(140583, NULL, 'G3DSA:3.40.30.10:FF:001030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140584, NULL, 'G3DSA:2.10.25.10:FF:001381', NULL, NULL, 'CD248 molecule, endosialin a', NULL, NULL, NULL, NULL, NULL, 4),
(140585, NULL, 'G3DSA:3.40.50.2000:FF:000338', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(140586, NULL, 'G3DSA:1.25.10.10:FF:002344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140587, NULL, 'G3DSA:3.30.70.330:FF:001862', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140588, NULL, 'G3DSA:3.10.430.100:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140589, NULL, 'G3DSA:3.40.30.10:FF:000760', NULL, NULL, 'YALI0C03201p', NULL, NULL, NULL, NULL, NULL, 4),
(140590, NULL, 'G3DSA:3.40.720.10:FF:000288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140591, NULL, 'G3DSA:3.40.50.300:FF:001358', NULL, NULL, 'RAD51 paralog B', NULL, NULL, NULL, NULL, NULL, 4),
(140592, NULL, 'G3DSA:3.40.50.2300:FF:000524', NULL, NULL, 'AGAP002797-PB', NULL, NULL, NULL, NULL, NULL, 4),
(140593, NULL, 'G3DSA:3.90.550.50:FF:000011', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(140594, NULL, 'G3DSA:3.40.50.620:FF:000162', NULL, NULL, 'Deoxyribodipyrimidine photo-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(140595, NULL, 'G3DSA:1.25.40.20:FF:001540', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140596, NULL, 'G3DSA:3.30.160.60:FF:001301', NULL, NULL, 'Blast:Protein hunchback', NULL, NULL, NULL, NULL, NULL, 4),
(140597, NULL, 'G3DSA:3.40.50.720:FF:000422', NULL, NULL, 'UDP-galactopyranose mutase', NULL, NULL, NULL, NULL, NULL, 4),
(140598, NULL, 'G3DSA:2.40.30.10:FF:000363', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140599, NULL, 'G3DSA:1.25.40.10:FF:000238', NULL, NULL, 'Anaphase promoting complex subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(140600, NULL, 'G3DSA:1.20.1250.20:FF:002328', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140601, NULL, 'G3DSA:2.60.260.20:FF:000058', NULL, NULL, 'Apj1p', NULL, NULL, NULL, NULL, NULL, 4),
(140602, NULL, 'G3DSA:3.30.200.20:FF:002131', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(140603, NULL, 'G3DSA:3.90.70.40:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140604, NULL, 'G3DSA:3.30.230.10:FF:000022', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(140605, NULL, 'G3DSA:3.40.50.1820:FF:001116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140606, NULL, 'G3DSA:3.30.200.20:FF:000523', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(140607, NULL, 'G3DSA:2.30.30.40:FF:000440', NULL, NULL, 'Variant sh3 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(140608, NULL, 'G3DSA:3.90.660.10:FF:000131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140609, NULL, 'G3DSA:3.90.550.10:FF:000139', NULL, NULL, 'Chitin synthase 8', NULL, NULL, NULL, NULL, NULL, 4),
(140610, NULL, 'G3DSA:3.30.9.10:FF:000031', NULL, NULL, 'FAD dependent oxidoreductase superfamily', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(140611, NULL, 'G3DSA:2.40.50.230:FF:000003', NULL, NULL, 'Type IV secretion protein Rhs', NULL, NULL, NULL, NULL, NULL, 4),
(140612, NULL, 'G3DSA:1.25.40.10:FF:000733', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(140613, NULL, 'G3DSA:3.10.450.50:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140614, NULL, 'G3DSA:2.60.34.10:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140615, NULL, 'G3DSA:3.30.160.60:FF:002285', NULL, NULL, 'Zinc finger protein 597', NULL, NULL, NULL, NULL, NULL, 4),
(140616, NULL, 'G3DSA:3.30.1110.10:FF:000007', NULL, NULL, 'Adenosine kinase 2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(140617, NULL, 'G3DSA:3.30.200.20:FF:001142', NULL, NULL, 'Putative L-type lectin-domain containing receptor kinase S.7 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(140618, NULL, 'G3DSA:3.40.50.720:FF:001591', NULL, NULL, 'Anthocyanidin reductase', NULL, NULL, NULL, NULL, NULL, 4),
(140619, NULL, 'G3DSA:1.10.167.10:FF:000027', NULL, NULL, 'G protein-coupled receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(140620, NULL, 'G3DSA:3.30.70.20:FF:000046', NULL, NULL, 'Periplasmic [Fe] hydrogenase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(140621, NULL, 'G3DSA:2.60.120.10:FF:000663', NULL, NULL, 'Cyclic nucleotidebinding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(140622, NULL, 'G3DSA:3.30.2350.20:FF:000073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140623, NULL, 'G3DSA:1.10.472.10:FF:000629', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140624, NULL, 'G3DSA:3.60.15.10:FF:000235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140625, NULL, 'G3DSA:3.40.50.720:FF:000074', NULL, NULL, 'Retinol dehydrogenase type 1', NULL, NULL, NULL, NULL, NULL, 4),
(140626, NULL, 'G3DSA:2.10.110.10:FF:000319', NULL, NULL, 'LIM and senescent cell antigen-like-containing domain protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(140627, NULL, 'G3DSA:2.60.40.10:FF:002616', NULL, NULL, 'Calmodulin-binding transcription activator 2', NULL, NULL, NULL, NULL, NULL, 4),
(140628, NULL, 'G3DSA:1.25.10.10:FF:000557', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(140629, NULL, 'G3DSA:3.30.160.60:FF:006091', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140630, NULL, 'G3DSA:3.30.1380.20:FF:000058', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140631, NULL, 'G3DSA:1.20.1310.10:FF:000144', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140632, NULL, 'G3DSA:3.90.820.10:FF:000003', NULL, NULL, 'Antibiotic synthesis protein MbtH', NULL, NULL, NULL, NULL, NULL, 4),
(140633, NULL, 'G3DSA:2.60.120.200:FF:000082', NULL, NULL, 'Contactin associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(140634, NULL, 'G3DSA:3.30.540.30:FF:000001', NULL, NULL, 'Dipeptidyl peptidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(140635, NULL, 'G3DSA:1.10.418.40:FF:000002', NULL, NULL, 'Beclin 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(140636, NULL, 'G3DSA:2.10.25.10:FF:001196', NULL, NULL, 'GM15024', NULL, NULL, NULL, NULL, NULL, 4),
(140637, NULL, 'G3DSA:3.40.50.11660:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140638, NULL, 'G3DSA:1.10.620.20:FF:000045', NULL, NULL, 'Ribonucleoside-diphosphate reductase small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(140639, NULL, 'G3DSA:3.30.70.330:FF:002031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140640, NULL, 'G3DSA:2.40.30.180:FF:000001', NULL, NULL, 'ubiquitin-like modifier-activating enzyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(140641, NULL, 'G3DSA:2.130.10.10:FF:003685', NULL, NULL, 'F-box/WD repeat-containing protein 4-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(140642, NULL, 'G3DSA:1.10.150.780:FF:000009', NULL, NULL, 'Probable vacuolar protein sorting-associated protein 16 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(140643, NULL, 'G3DSA:3.90.1140.10:FF:000023', NULL, NULL, 'U6 snRNA phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(140644, NULL, 'G3DSA:1.10.286.20:FF:000008', NULL, NULL, 'Regulator of nucleoside diphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(140645, NULL, 'G3DSA:2.30.29.30:FF:000282', NULL, NULL, 'Connector enhancer of kinase suppressor of Ras 1 variant', NULL, NULL, NULL, NULL, NULL, 4),
(140646, NULL, 'G3DSA:3.40.50.2020:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140647, NULL, 'G3DSA:2.30.30.40:FF:000237', NULL, NULL, 'SH3 and cysteine rich domain 3', NULL, NULL, NULL, NULL, NULL, 4),
(140648, NULL, 'G3DSA:3.40.50.300:FF:002319', NULL, NULL, 'Cancer-related nucleoside-triphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(140649, NULL, 'G3DSA:2.60.40.150:FF:000490', NULL, NULL, 'Phosphatidylserine decarboxylase proenzyme 2', NULL, NULL, NULL, NULL, NULL, 4),
(140650, NULL, 'G3DSA:2.60.40.60:FF:000237', NULL, NULL, 'Cadherin related family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(140651, NULL, 'G3DSA:2.130.10.10:FF:003213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140652, NULL, 'G3DSA:2.40.37.10:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140653, NULL, 'G3DSA:3.90.1410.10:FF:000022', NULL, NULL, '[Cytochrome c]-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(140654, NULL, 'G3DSA:2.120.10.30:FF:000223', NULL, NULL, 'AkeP', NULL, NULL, NULL, NULL, NULL, 4),
(140655, NULL, 'G3DSA:3.30.200.20:FF:002468', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140656, NULL, 'G3DSA:3.40.50.1820:FF:000121', NULL, NULL, 'Carboxypeptidase D', NULL, NULL, NULL, NULL, NULL, 4),
(140657, NULL, 'G3DSA:2.60.40.10:FF:003561', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140658, NULL, 'G3DSA:3.40.50.300:FF:002454', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(140659, NULL, 'G3DSA:3.30.40.10:FF:001536', NULL, NULL, 'E3 ubiquitin-protein ligase LRSAM1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(140660, NULL, 'G3DSA:1.20.1070.10:FF:000428', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140661, NULL, 'G3DSA:3.30.70.1590:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140662, NULL, 'G3DSA:3.30.230.70:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140663, NULL, 'G3DSA:2.60.40.10:FF:002763', NULL, NULL, '2 (Zwei) IG domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(140664, NULL, 'G3DSA:1.10.3720.10:FF:000144', NULL, NULL, 'Probable permease of ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(140665, NULL, 'G3DSA:1.25.40.10:FF:004100', NULL, NULL, 'tetratricopeptide repeat protein 19, mitochondrial-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(140666, NULL, 'G3DSA:2.10.25.10:FF:000212', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(140667, NULL, 'G3DSA:1.20.58.60:FF:000602', NULL, NULL, 'Nesprin-1', NULL, NULL, NULL, NULL, NULL, 4),
(140668, NULL, 'G3DSA:3.40.50.300:FF:005411', NULL, NULL, 'Helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(140669, NULL, 'G3DSA:2.70.70.10:FF:000033', NULL, NULL, 'Periplasmic septal ring factor with murein hydrolase activity EnvCYibP CDS', NULL, NULL, NULL, NULL, NULL, 4),
(140670, NULL, 'G3DSA:3.40.50.720:FF:001748', NULL, NULL, 'Putative formaldehyde dehydrogenase AdhA', NULL, NULL, NULL, NULL, NULL, 4),
(140671, NULL, 'G3DSA:3.30.230.130:FF:000057', NULL, NULL, 'Cullin 4B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(140672, NULL, 'G3DSA:1.25.40.10:FF:003476', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g12100, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(140673, NULL, 'G3DSA:3.90.1300.10:FF:000025', NULL, NULL, 'Glutamyl-tRNA (Gln) amidotransferase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(140674, NULL, 'G3DSA:3.80.10.10:FF:003983', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140675, NULL, 'G3DSA:3.40.190.10:FF:000033', NULL, NULL, 'Maltodextrin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(140676, NULL, 'G3DSA:1.10.800.10:FF:000005', NULL, NULL, 'Tryptophan 5-hydroxylase 1', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(140677, NULL, 'G3DSA:3.20.20.100:FF:000167', NULL, NULL, 'Putative glutamate--cysteine ligase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(140678, NULL, 'G3DSA:2.10.25.10:FF:001757', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140679, NULL, 'G3DSA:1.20.1250.20:FF:000530', NULL, NULL, 'MFS multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(140680, NULL, 'G3DSA:3.80.10.10:FF:000094', NULL, NULL, 'protein C21orf2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(140681, NULL, 'G3DSA:2.120.10.10:FF:000009', NULL, NULL, 'Sialidase A', NULL, NULL, NULL, NULL, NULL, 4),
(140682, NULL, 'G3DSA:3.40.50.300:FF:007209', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140683, NULL, 'G3DSA:1.20.1560.10:FF:000859', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140684, NULL, 'G3DSA:1.25.40.10:FF:004965', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140685, NULL, 'G3DSA:1.20.5.1500:FF:000014', NULL, NULL, 'Suppressor of presenilin-2', NULL, NULL, NULL, NULL, NULL, 4),
(140686, NULL, 'G3DSA:3.60.130.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140687, NULL, 'G3DSA:3.40.50.10240:FF:000044', NULL, NULL, 'Thiamine pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(140688, NULL, 'G3DSA:1.20.272.40:FF:000008', NULL, NULL, 'ATP-dependent RNA helicase SUV3 homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(140689, NULL, 'G3DSA:1.10.10.2750:FF:000003', NULL, NULL, 'TBC1 domain family member', NULL, NULL, NULL, NULL, NULL, 4),
(140690, NULL, 'G3DSA:3.30.60.30:FF:000133', NULL, NULL, 'GD15911', NULL, NULL, NULL, NULL, NULL, 4),
(140691, NULL, 'G3DSA:3.40.50.12370:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140692, NULL, 'G3DSA:3.40.20.10:FF:000040', NULL, NULL, 'macrophage-capping protein-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(140693, NULL, 'G3DSA:3.30.470.30:FF:000046', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(140694, NULL, 'G3DSA:3.90.1150.10:FF:000288', NULL, NULL, 'dTDP-4-dehydro-6-deoxy-D-glucose 4-aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(140695, NULL, 'G3DSA:3.40.50.1820:FF:000251', NULL, NULL, 'Extracelular serine carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(140696, NULL, 'G3DSA:2.60.40.680:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140697, NULL, 'G3DSA:3.80.10.10:FF:002999', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140698, NULL, 'G3DSA:1.20.1070.10:FF:001064', NULL, NULL, 'Olfactory receptor 702', NULL, NULL, NULL, NULL, NULL, 4),
(140699, NULL, 'G3DSA:3.10.120.10:FF:000035', NULL, NULL, 'Cytochrome b5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(140700, NULL, 'G3DSA:1.10.3380.10:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140701, NULL, 'G3DSA:3.30.420.40:FF:000517', NULL, NULL, 'ROK family protein', NULL, NULL, NULL, NULL, NULL, 4),
(140702, NULL, 'G3DSA:1.10.238.10:FF:000911', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(140703, NULL, 'G3DSA:3.30.2080.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140704, NULL, 'G3DSA:2.60.220.50:FF:000160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140705, NULL, 'G3DSA:3.40.50.620:FF:000408', NULL, NULL, 'Bll5861 protein', NULL, NULL, NULL, NULL, NULL, 4),
(140706, NULL, 'G3DSA:3.30.40.10:FF:001317', NULL, NULL, 'BCL9 transcription coactivator', NULL, NULL, NULL, NULL, NULL, 4),
(140707, NULL, 'G3DSA:3.40.50.150:FF:001515', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140708, NULL, 'G3DSA:2.170.260.10:FF:000023', NULL, NULL, 'Minimal dicer', NULL, NULL, NULL, NULL, NULL, 4),
(140709, NULL, 'G3DSA:3.20.20.80:FF:000207', NULL, NULL, 'Glycoside hydrolase family 128 protein', NULL, NULL, NULL, NULL, NULL, 4),
(140710, NULL, 'G3DSA:3.10.100.10:FF:000152', NULL, NULL, 'C-type LECtin', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(140711, NULL, 'G3DSA:3.40.50.1000:FF:000786', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140712, NULL, 'G3DSA:3.40.50.300:FF:002538', NULL, NULL, 'ABC multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(140713, NULL, 'G3DSA:3.40.50.1000:FF:000477', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140714, NULL, 'G3DSA:1.10.220.30:FF:000034', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(140715, NULL, 'G3DSA:3.40.50.12780:FF:000047', NULL, NULL, 'Acetyl-CoA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(140716, NULL, 'G3DSA:1.25.40.10:FF:000694', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g50420', NULL, NULL, NULL, NULL, NULL, 4),
(140717, NULL, 'G3DSA:1.25.70.10:FF:000066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140718, NULL, 'G3DSA:1.20.1070.10:FF:000119', NULL, NULL, 'Prolactin releasing hormone receptor', NULL, NULL, NULL, NULL, NULL, 4),
(140719, NULL, 'G3DSA:2.130.10.10:FF:003432', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(140720, NULL, 'G3DSA:3.30.420.40:FF:000664', NULL, NULL, 'Luminal-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(140721, NULL, 'G3DSA:1.20.58.80:FF:000052', NULL, NULL, 'Katanin p60 ATPase-containing subunit A1', NULL, NULL, NULL, NULL, NULL, 4),
(140722, NULL, 'G3DSA:3.30.1520.10:FF:000134', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(140723, NULL, 'G3DSA:3.40.190.80:FF:000020', NULL, NULL, 'Fructose-1,6-bisphosphatase/inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(140724, NULL, 'G3DSA:2.60.60.20:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140725, NULL, 'G3DSA:3.30.70.141:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140726, NULL, 'G3DSA:3.40.47.10:FF:000197', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140727, NULL, 'G3DSA:3.30.470.10:FF:000040', NULL, NULL, 'Class IV aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(140728, NULL, 'G3DSA:3.30.420.40:FF:000883', NULL, NULL, 'Actin-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(140729, NULL, 'G3DSA:1.10.510.10:FF:003001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140730, NULL, 'G3DSA:1.20.58.220:FF:000002', NULL, NULL, 'Phosphate-specific transport system accessory protein PhoU', NULL, NULL, NULL, NULL, NULL, 4),
(140731, NULL, 'G3DSA:1.25.40.10:FF:004437', NULL, NULL, 'Pentatricopeptide repeat protein PPR868-14 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(140732, NULL, 'G3DSA:3.40.50.300:FF:006506', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140733, NULL, 'G3DSA:2.130.10.10:FF:002943', NULL, NULL, 'Protein HIRA', NULL, NULL, NULL, NULL, NULL, 4),
(140734, NULL, 'G3DSA:2.20.70.10:FF:000086', NULL, NULL, 'NEDD4-like E3 ubiquitin-protein ligase WWP1', NULL, NULL, NULL, NULL, NULL, 4),
(140735, NULL, 'G3DSA:2.60.40.10:FF:005854', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140736, NULL, 'G3DSA:3.30.160.60:FF:006467', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140737, NULL, 'G3DSA:2.60.120.200:FF:000418', NULL, NULL, 'Growth arrest-specific 6', NULL, NULL, NULL, NULL, NULL, 4),
(140738, NULL, 'G3DSA:2.40.50.140:FF:000004', NULL, NULL, 'Elongation factor P', NULL, NULL, NULL, NULL, NULL, 4),
(140739, NULL, 'G3DSA:3.30.450.200:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140740, NULL, 'G3DSA:3.30.70.270:FF:000203', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140741, NULL, 'G3DSA:1.25.40.10:FF:004280', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140742, NULL, 'G3DSA:1.25.40.10:FF:004656', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140743, NULL, 'G3DSA:3.30.890.10:FF:000015', NULL, NULL, 'Methyl-CpG-binding domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(140744, NULL, 'G3DSA:2.60.40.10:FF:002291', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140745, NULL, 'G3DSA:3.40.50.1000:FF:000825', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(140746, NULL, 'G3DSA:3.30.1010.10:FF:000140', NULL, NULL, 'Protein kinase rad3', NULL, NULL, NULL, NULL, NULL, 4),
(140747, NULL, 'G3DSA:1.20.142.10:FF:000030', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(140748, NULL, 'G3DSA:3.40.50.620:FF:000032', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(140749, NULL, 'G3DSA:3.30.40.10:FF:000356', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(140750, NULL, 'G3DSA:2.60.200.20:FF:000054', NULL, NULL, 'Putative coiled-coil proteincoiled-coil protein', NULL, NULL, NULL, NULL, NULL, 4),
(140751, NULL, 'G3DSA:1.10.405.10:FF:000008', NULL, NULL, 'Rab proteins geranylgeranyltransferase component', NULL, NULL, NULL, NULL, NULL, 4),
(140752, NULL, 'G3DSA:2.60.40.150:FF:000416', NULL, NULL, 'C2 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(140753, NULL, 'G3DSA:1.25.10.10:FF:002783', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140754, NULL, 'G3DSA:2.170.140.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140755, NULL, 'G3DSA:1.10.287.110:FF:000061', NULL, NULL, 'DnaJ (Hsp40) homolog, subfamily C, member 11b', NULL, NULL, NULL, NULL, NULL, 4),
(140756, NULL, 'G3DSA:3.10.490.20:FF:000009', NULL, NULL, 'Dynein heavy chain 4', NULL, NULL, NULL, NULL, NULL, 4),
(140757, NULL, 'G3DSA:1.20.58.240:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140758, NULL, 'G3DSA:2.60.40.790:FF:000007', NULL, NULL, '17.4 kDa class I heat shock protein', NULL, NULL, NULL, NULL, NULL, 4),
(140759, NULL, 'G3DSA:3.40.50.1580:FF:000055', NULL, NULL, 'Probable S-methyl-5''-thioinosine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(140760, NULL, 'G3DSA:1.20.140.10:FF:000076', NULL, NULL, 'Short-chain-specific acyl-CoA dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(140761, NULL, 'G3DSA:3.30.920.10:FF:000013', NULL, NULL, 'YALI0E15268p', NULL, NULL, NULL, NULL, NULL, 4),
(140762, NULL, 'G3DSA:3.40.50.10860:FF:000005', NULL, NULL, 'C-1-tetrahydrofolate synthase, cytoplasmic, putative', NULL, NULL, NULL, NULL, NULL, 4),
(140763, NULL, 'G3DSA:1.10.287.130:FF:000252', NULL, NULL, 'ATP-binding region ATPase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(140764, NULL, 'G3DSA:2.40.50.100:FF:000015', NULL, NULL, 'Dihydrolipoyllysine-residue succinyltransferase component of 2-oxoglutarate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(140765, NULL, 'G3DSA:3.40.50.920:FF:000038', NULL, NULL, 'Transketolase', NULL, NULL, NULL, NULL, NULL, 4),
(140766, NULL, 'G3DSA:1.25.50.20:FF:000096', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(140767, NULL, 'G3DSA:1.20.1460.10:FF:000003', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(140768, NULL, 'G3DSA:1.10.533.10:FF:000311', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140769, NULL, 'G3DSA:3.10.50.40:FF:000018', NULL, NULL, 'Aryl-hydrocarbon-interacting protein-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(140770, NULL, 'G3DSA:3.60.10.10:FF:000387', NULL, NULL, 'Extracellular endonuclease ExeM', NULL, NULL, NULL, NULL, NULL, 4),
(140771, NULL, 'G3DSA:3.10.20.90:FF:000840', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140772, NULL, 'G3DSA:1.20.58.60:FF:000821', NULL, NULL, 'Spectrin, beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(140773, NULL, 'G3DSA:1.20.1270.280:FF:000048', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(140774, NULL, 'G3DSA:1.10.30.10:FF:000029', NULL, NULL, 'nucleolar transcription factor 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(140775, NULL, 'G3DSA:3.40.309.10:FF:000068', NULL, NULL, 'Aldehyde dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(140776, NULL, 'G3DSA:1.25.40.20:FF:001101', NULL, NULL, 'Wide awake', NULL, NULL, NULL, NULL, NULL, 4),
(140777, NULL, 'G3DSA:1.10.472.10:FF:000596', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(140778, NULL, 'G3DSA:1.10.20.10:FF:000203', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140779, NULL, 'G3DSA:1.20.58.670:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140780, NULL, 'G3DSA:2.20.25.10:FF:000127', NULL, NULL, 'tRNA methyltransferase subunit 11-2', NULL, NULL, NULL, NULL, NULL, 4),
(140781, NULL, 'G3DSA:1.25.40.10:FF:004095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140782, NULL, 'G3DSA:1.25.40.10:FF:000385', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(140783, NULL, 'G3DSA:1.10.287.110:FF:000403', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140784, NULL, 'G3DSA:2.60.110.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140785, NULL, 'G3DSA:3.30.200.20:FF:000670', NULL, NULL, 'Serine/threonine protein kinase (Kin28)', NULL, NULL, NULL, NULL, NULL, 4),
(140786, NULL, 'G3DSA:3.30.70.330:FF:002823', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140787, NULL, 'G3DSA:3.30.160.60:FF:002049', NULL, NULL, 'Zinc finger protein 181 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(140788, NULL, 'G3DSA:2.60.40.10:FF:002633', NULL, NULL, 'Protein-tyrosine-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(140789, NULL, 'G3DSA:3.30.870.10:FF:000132', NULL, NULL, 'Phospholipase D family, member 6', NULL, NULL, NULL, NULL, NULL, 4),
(140790, NULL, 'G3DSA:3.30.420.40:FF:000208', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(140791, NULL, 'G3DSA:2.30.30.30:FF:000111', NULL, NULL, '50S ribosomal protein L2 (AFU_orthologue AFUA_4G12170)', NULL, NULL, NULL, NULL, NULL, 4),
(140792, NULL, 'G3DSA:1.10.10.10:FF:001866', NULL, NULL, 'Probable serine/threonine-protein kinase roco11', NULL, NULL, NULL, NULL, NULL, 4),
(140793, NULL, 'G3DSA:1.10.10.10:FF:000455', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(140794, NULL, 'G3DSA:3.40.50.300:FF:007125', NULL, NULL, 'ATP-dependent DNA helicase PIF6', NULL, NULL, NULL, NULL, NULL, 4),
(140795, NULL, 'G3DSA:3.40.30.10:FF:000866', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140796, NULL, 'G3DSA:3.30.160.60:FF:000267', NULL, NULL, 'Zinc finger and BTB domain-containing 49', NULL, NULL, NULL, NULL, NULL, 4),
(140797, NULL, 'G3DSA:3.40.1280.10:FF:000028', NULL, NULL, 'Putative tRNA (cytidine(34)-2''-O)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(140798, NULL, 'G3DSA:3.30.70.330:FF:002262', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140799, NULL, 'G3DSA:1.25.10.10:FF:003272', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140800, NULL, 'G3DSA:3.30.465.10:FF:000073', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140801, NULL, 'G3DSA:3.50.30.30:FF:000102', NULL, NULL, 'Probable secreted peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(140802, NULL, 'G3DSA:3.10.129.10:FF:000033', NULL, NULL, 'acyl-coenzyme A thioesterase 13', NULL, NULL, NULL, NULL, NULL, 4),
(140803, NULL, 'G3DSA:2.60.200.20:FF:000161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140804, NULL, 'G3DSA:3.10.100.10:FF:000383', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140805, NULL, 'G3DSA:1.25.40.10:FF:004881', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At1g69350, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(140806, NULL, 'G3DSA:3.20.20.100:FF:000083', NULL, NULL, 'Aryl-alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(140807, NULL, 'G3DSA:3.55.40.10:FF:000002', NULL, NULL, 'Type II secretion system protein H', NULL, NULL, NULL, NULL, NULL, 4),
(140808, NULL, 'G3DSA:3.30.160.60:FF:005702', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140809, NULL, 'G3DSA:3.90.110.10:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140810, NULL, 'G3DSA:2.60.120.260:FF:000054', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 1', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(140811, NULL, 'G3DSA:3.30.160.60:FF:000812', NULL, NULL, 'zinc finger protein 23 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(140812, NULL, 'G3DSA:1.25.40.860:FF:000022', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(140813, NULL, 'G3DSA:3.40.50.150:FF:000818', NULL, NULL, '8-demethylnovobiocic acid C(8)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(140814, NULL, 'G3DSA:3.75.10.10:FF:000011', NULL, NULL, 'Translation initiation factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(140815, NULL, 'G3DSA:2.30.42.10:FF:000144', NULL, NULL, 'Membrane associated guanylate kinase, WW and PDZ domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(140816, NULL, 'G3DSA:2.10.25.10:FF:000993', NULL, NULL, 'Heparan sulfate proteoglycan 2', NULL, NULL, NULL, NULL, NULL, 4),
(140817, NULL, 'G3DSA:3.40.50.300:FF:008159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140818, NULL, 'G3DSA:3.80.10.10:FF:003056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140819, NULL, 'G3DSA:3.80.10.10:FF:000785', NULL, NULL, 'F-box/LRR-repeat protein 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(140820, NULL, 'G3DSA:3.30.497.10:FF:000152', NULL, NULL, 'Serine (or cysteine) peptidase inhibitor, clade B, member 6e', NULL, NULL, NULL, NULL, NULL, 4),
(140821, NULL, 'G3DSA:1.10.555.10:FF:000255', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140822, NULL, 'G3DSA:3.80.10.10:FF:002022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140823, NULL, 'G3DSA:2.10.25.10:FF:001066', NULL, NULL, 'Matrilin 1', NULL, NULL, NULL, NULL, NULL, 4),
(140824, NULL, 'G3DSA:1.50.10.20:FF:000007', NULL, NULL, 'Protein farnesyltransferase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(140825, NULL, 'G3DSA:2.30.29.30:FF:000057', NULL, NULL, 'Fermitin family homolog 2 (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(140826, NULL, 'G3DSA:3.60.21.60:FF:000039', NULL, NULL, 'DNA polymerase alpha 70 kD subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(140827, NULL, 'G3DSA:2.60.40.10:FF:004106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140828, NULL, 'G3DSA:3.20.20.140:FF:000044', NULL, NULL, 'Polymerase/histidinol phosphatase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(140829, NULL, 'G3DSA:3.30.160.60:FF:001431', NULL, NULL, 'Putative zinc finger E-box-binding homeobox 2', NULL, NULL, NULL, NULL, NULL, 4),
(140830, NULL, 'G3DSA:3.80.10.10:FF:001510', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140831, NULL, 'G3DSA:1.10.150.240:FF:000061', NULL, NULL, 'Glycerol-1-phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(140832, NULL, 'G3DSA:3.30.40.10:FF:000671', NULL, NULL, 'Unplaced genomic scaffold supercont2.18, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(140833, NULL, 'G3DSA:3.40.50.11610:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140834, NULL, 'G3DSA:1.10.230.10:FF:000012', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(140835, NULL, 'G3DSA:3.40.50.1470:FF:000022', NULL, NULL, 'Peptidyl-tRNA hydrolase mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(140836, NULL, 'G3DSA:1.20.940.10:FF:000007', NULL, NULL, 'Protein transport protein (SEC31), putative', NULL, NULL, NULL, NULL, NULL, 4),
(140837, NULL, 'G3DSA:1.25.40.10:FF:000603', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(140838, NULL, 'G3DSA:1.10.510.10:FF:000691', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(140839, NULL, 'G3DSA:3.40.50.300:FF:004000', NULL, NULL, 'ATP-dependent helicase', NULL, NULL, NULL, NULL, NULL, 4),
(140840, NULL, 'G3DSA:3.30.2350.10:FF:000008', NULL, NULL, 'tRNA pseudouridine synthase C', NULL, NULL, NULL, NULL, NULL, 4),
(140841, NULL, 'G3DSA:3.30.710.10:FF:000424', NULL, NULL, 'Protein CBG11420', NULL, NULL, NULL, NULL, NULL, 4),
(140842, NULL, 'G3DSA:3.40.50.300:FF:006029', NULL, NULL, 'Dynamin 2', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(140843, NULL, 'G3DSA:3.30.70.330:FF:001643', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140844, NULL, 'G3DSA:1.20.58.60:FF:000473', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(140845, NULL, 'G3DSA:3.90.1300.10:FF:000008', NULL, NULL, 'Amidase AmiC', NULL, NULL, NULL, NULL, NULL, 4),
(140846, NULL, 'G3DSA:1.10.3720.10:FF:000127', NULL, NULL, 'Amino acid ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(140847, NULL, 'G3DSA:1.25.40.180:FF:000279', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140848, NULL, 'G3DSA:1.10.10.10:FF:001074', NULL, NULL, 'MurR/RpiR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(140849, NULL, 'G3DSA:3.40.50.300:FF:005888', NULL, NULL, 'ABC transporter E family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(140850, NULL, 'G3DSA:1.10.10.60:FF:000476', NULL, NULL, 'MYB-related transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(140851, NULL, 'G3DSA:1.10.287.470:FF:000005', NULL, NULL, 'Multidrug resistance protein MdtA', NULL, NULL, NULL, NULL, NULL, 4),
(140852, NULL, 'G3DSA:1.10.510.10:FF:004434', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140853, NULL, 'G3DSA:2.70.150.10:FF:000235', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140854, NULL, 'G3DSA:3.30.70.240:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140855, NULL, 'G3DSA:3.30.40.10:FF:001761', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(140856, NULL, 'G3DSA:1.10.506.10:FF:000052', NULL, NULL, 'GTPase activating protein involved in bud site selection, putative', NULL, NULL, NULL, NULL, NULL, 4),
(140857, NULL, 'G3DSA:2.30.40.10:FF:000089', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(140858, NULL, 'G3DSA:1.10.220.160:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140859, NULL, 'G3DSA:3.30.160.60:FF:002521', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140860, NULL, 'G3DSA:2.60.40.10:FF:003600', NULL, NULL, 'AGAP001769-PA', NULL, NULL, NULL, NULL, NULL, 4),
(140861, NULL, 'G3DSA:2.70.160.11:FF:000041', NULL, NULL, 'GM18100', NULL, NULL, NULL, NULL, NULL, 4),
(140862, NULL, 'G3DSA:1.10.10.10:FF:000938', NULL, NULL, 'Transcriptional regulator, IclR family', NULL, NULL, NULL, NULL, NULL, 4),
(140863, NULL, 'G3DSA:2.30.29.30:FF:000602', NULL, NULL, 'Syntrophin, alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(140864, NULL, 'G3DSA:3.40.50.1820:FF:001560', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140865, NULL, 'G3DSA:1.10.510.10:FF:000702', NULL, NULL, 'Serine/threonine-protein kinase Nek6', NULL, NULL, NULL, NULL, NULL, 4),
(140866, NULL, 'G3DSA:3.90.1750.10:FF:000036', NULL, NULL, 'E3 ubiquitin-protein ligase HECW2', NULL, NULL, NULL, NULL, NULL, 4),
(140867, NULL, 'G3DSA:3.40.50.620:FF:000723', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(140868, NULL, 'G3DSA:3.40.910.10:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140869, NULL, 'G3DSA:3.30.60.60:FF:000001', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(140870, NULL, 'G3DSA:2.60.40.10:FF:004634', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140871, NULL, 'G3DSA:3.50.50.60:FF:001309', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase, truncation', NULL, NULL, NULL, NULL, NULL, 4),
(140872, NULL, 'G3DSA:3.30.1370.10:FF:000116', NULL, NULL, 'RNA-binding KH domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(140873, NULL, 'G3DSA:3.40.190.10:FF:000488', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(140874, NULL, 'G3DSA:3.90.79.10:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140875, NULL, 'G3DSA:3.60.15.10:FF:000252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140876, NULL, 'G3DSA:3.40.50.2300:FF:001249', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(140877, NULL, 'G3DSA:3.40.50.300:FF:002763', NULL, NULL, 'Putative transcriptional regulatory protein NadR', NULL, NULL, NULL, NULL, NULL, 4),
(140878, NULL, 'G3DSA:3.40.50.300:FF:005091', NULL, NULL, 'Septin 6', NULL, NULL, NULL, NULL, NULL, 4),
(140879, NULL, 'G3DSA:3.40.50.150:FF:001167', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140880, NULL, 'G3DSA:1.10.510.10:FF:001686', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140881, NULL, 'G3DSA:3.30.420.40:FF:000192', NULL, NULL, 'Glucokinase', NULL, NULL, NULL, NULL, NULL, 4),
(140882, NULL, 'G3DSA:4.10.1060.10:FF:000001', NULL, NULL, 'Nuclear pore complex protein Nup153', NULL, NULL, NULL, NULL, NULL, 4),
(140883, NULL, 'G3DSA:2.130.10.10:FF:000234', NULL, NULL, 'WD repeat-containing protein LWD1', NULL, NULL, NULL, NULL, NULL, 4),
(140884, NULL, 'G3DSA:3.80.10.10:FF:004152', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(140885, NULL, 'G3DSA:3.40.50.1440:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140886, NULL, 'G3DSA:3.40.50.10190:FF:000366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140887, NULL, 'G3DSA:1.50.40.10:FF:000085', NULL, NULL, 'Tricarboxylate carrier, putative', NULL, NULL, NULL, NULL, NULL, 4),
(140888, NULL, 'G3DSA:3.90.660.20:FF:000010', NULL, NULL, 'Dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(140889, NULL, 'G3DSA:3.30.2410.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140890, NULL, 'G3DSA:1.10.340.40:FF:000001', NULL, NULL, 'Nuclear polyadenylated RNA-binding protein nab2', NULL, NULL, NULL, NULL, NULL, 4),
(140891, NULL, 'G3DSA:1.25.40.20:FF:001231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140892, NULL, 'G3DSA:2.130.10.10:FF:001324', NULL, NULL, 'Coatomer subunit alpha-1', NULL, NULL, NULL, NULL, NULL, 4),
(140893, NULL, 'G3DSA:2.60.40.10:FF:000739', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(140894, NULL, 'G3DSA:1.20.120.1750:FF:000080', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(140895, NULL, 'G3DSA:1.20.120.1150:FF:000006', NULL, NULL, 'Serine/threonine-protein phosphatase 2A activator', NULL, NULL, NULL, NULL, NULL, 4),
(140896, NULL, 'G3DSA:2.115.10.20:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140897, NULL, 'G3DSA:2.60.260.20:FF:000030', NULL, NULL, 'DNAJ heat shock family protein', NULL, NULL, NULL, NULL, NULL, 4),
(140898, NULL, 'G3DSA:3.10.20.90:FF:000172', NULL, NULL, 'Gamma-aminobutyric acid receptor-associated protein-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(140899, NULL, 'G3DSA:1.20.1310.10:FF:000127', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140900, NULL, 'G3DSA:1.10.510.10:FF:000961', NULL, NULL, 'Putative serine/threonine-protein kinase haspin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(140901, NULL, 'G3DSA:2.40.40.10:FF:000004', NULL, NULL, 'Expansin B3', NULL, NULL, NULL, NULL, NULL, 4),
(140902, NULL, 'G3DSA:1.20.58.390:FF:000250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140903, NULL, 'G3DSA:1.10.510.10:FF:001995', NULL, NULL, 'Kinase', NULL, NULL, NULL, NULL, NULL, 4),
(140904, NULL, 'G3DSA:2.60.40.10:FF:000582', NULL, NULL, 'T-lymphocyte activation antigen CD86', NULL, NULL, NULL, NULL, NULL, 4),
(140905, NULL, 'G3DSA:3.30.930.10:FF:000418', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(140906, NULL, 'G3DSA:2.40.150.20:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140907, NULL, 'G3DSA:3.40.50.300:FF:006361', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140908, NULL, 'G3DSA:1.20.1070.10:FF:000794', NULL, NULL, 'CG1056-like serotonin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(140909, NULL, 'G3DSA:1.20.1720.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140910, NULL, 'G3DSA:1.25.40.10:FF:002947', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(140911, NULL, 'G3DSA:1.10.10.60:FF:000223', NULL, NULL, 'Goosecoid homeobox 2', NULL, NULL, NULL, NULL, NULL, 4),
(140912, NULL, 'G3DSA:3.40.50.1820:FF:001341', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140913, NULL, 'G3DSA:3.30.750.24:FF:000070', NULL, NULL, 'SulP family sulfate permease', NULL, NULL, NULL, NULL, NULL, 4),
(140914, NULL, 'G3DSA:2.130.10.10:FF:003668', NULL, NULL, 'Related to yeast Vacuolar Protein Sorting factor', NULL, NULL, NULL, NULL, NULL, 4),
(140915, NULL, 'G3DSA:3.30.420.10:FF:000520', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140916, NULL, 'G3DSA:1.20.920.10:FF:000231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140917, NULL, 'G3DSA:3.30.497.10:FF:000045', NULL, NULL, 'Leukocyte elastase inhibitor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(140918, NULL, 'G3DSA:2.60.40.10:FF:005253', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140919, NULL, 'G3DSA:2.40.30.70:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140920, NULL, 'G3DSA:1.10.600.10:FF:000024', NULL, NULL, 'Ent-copalyl diphosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(140921, NULL, 'G3DSA:3.40.1440.10:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140922, NULL, 'G3DSA:1.25.40.10:FF:000278', NULL, NULL, 'Vacuolar protein sorting-associated protein 11 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(140923, NULL, 'G3DSA:1.25.10.10:FF:002558', NULL, NULL, 'AER377Cp', NULL, NULL, NULL, NULL, NULL, 4),
(140924, NULL, 'G3DSA:3.40.50.150:FF:001532', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140925, NULL, 'G3DSA:3.30.40.10:FF:000339', NULL, NULL, 'Cellulose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(140926, NULL, 'G3DSA:3.40.50.10810:FF:000237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140927, NULL, 'G3DSA:1.20.58.1250:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140928, NULL, 'G3DSA:2.40.50.140:FF:000235', NULL, NULL, 'Ribonuclease G', NULL, NULL, NULL, NULL, NULL, 4),
(140929, NULL, 'G3DSA:3.40.640.10:FF:000343', NULL, NULL, '8-amino-3,8-dideoxy-alpha-D-manno-octulosonate transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(140930, NULL, 'G3DSA:2.60.40.150:FF:000647', NULL, NULL, 'Copine VIII', NULL, NULL, NULL, NULL, NULL, 4),
(140931, NULL, 'G3DSA:3.90.640.10:FF:000220', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(140932, NULL, 'G3DSA:1.20.80.10:FF:000010', NULL, NULL, 'Acyl-CoA-binding domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(140933, NULL, 'G3DSA:1.10.287.70:FF:000200', NULL, NULL, 'Glutamate receptor 2.8', NULL, NULL, NULL, NULL, NULL, 4),
(140934, NULL, 'G3DSA:2.30.30.40:FF:000131', NULL, NULL, 'Guanine nucleotide exchange factor VAV2 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(140935, NULL, 'G3DSA:3.90.550.50:FF:000090', NULL, NULL, 'Protein CBG18324', NULL, NULL, NULL, NULL, NULL, 4),
(140936, NULL, 'G3DSA:3.30.230.70:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140937, NULL, 'G3DSA:1.20.58.480:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140938, NULL, 'G3DSA:1.10.510.10:FF:001214', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(140939, NULL, 'G3DSA:2.60.40.10:FF:005961', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140940, NULL, 'G3DSA:3.30.70.330:FF:000007', NULL, NULL, 'CUGBP Elav-like family member 4 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(140941, NULL, 'G3DSA:2.60.120.20:FF:000008', NULL, NULL, 'Capsid protein VP1', NULL, NULL, NULL, NULL, NULL, 4),
(140942, NULL, 'G3DSA:3.30.160.60:FF:003140', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140943, NULL, 'G3DSA:2.60.40.1170:FF:000006', NULL, NULL, 'Putative AP-3 complex subunit mu-2-like', NULL, NULL, NULL, NULL, NULL, 4),
(140944, NULL, 'G3DSA:4.10.1240.50:FF:000010', NULL, NULL, 'REST corepressor 3', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(140945, NULL, 'G3DSA:1.20.1070.10:FF:000900', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140946, NULL, 'G3DSA:1.10.10.10:FF:000686', NULL, NULL, 'Cell division control protein', NULL, NULL, NULL, NULL, NULL, 4),
(140947, NULL, 'G3DSA:3.40.309.10:FF:000085', NULL, NULL, 'Gamma-glutamyl phosphate reductase 2', NULL, NULL, NULL, NULL, NULL, 4),
(140948, NULL, 'G3DSA:3.40.50.300:FF:003758', NULL, NULL, 'Zgc:171695', NULL, NULL, NULL, NULL, NULL, 4),
(140949, NULL, 'G3DSA:3.30.559.10:FF:000072', NULL, NULL, 'Nonribosomal peptide synthase GliP2', NULL, NULL, NULL, NULL, NULL, 4),
(140950, NULL, 'G3DSA:3.40.50.720:FF:001708', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140951, NULL, 'G3DSA:3.30.160.60:FF:002740', NULL, NULL, 'Zinc finger and SCAN domain containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(140952, NULL, 'G3DSA:1.10.10.60:FF:000695', NULL, NULL, 'MYB transcription factor MYB48', NULL, NULL, NULL, NULL, NULL, 4),
(140953, NULL, 'G3DSA:3.30.559.70:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140954, NULL, 'G3DSA:3.30.160.60:FF:003229', NULL, NULL, 'PR/SET domain 15', NULL, NULL, NULL, NULL, NULL, 4),
(140955, NULL, 'G3DSA:3.80.10.10:FF:003308', NULL, NULL, 'Toll-like receptor 20, tandem duplicate 2', NULL, NULL, NULL, NULL, NULL, 4),
(140956, NULL, 'G3DSA:3.80.10.10:FF:003764', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140957, NULL, 'G3DSA:1.10.1410.10:FF:000042', NULL, NULL, 'Poly(A) polymerase/terminal uridylyl transferase, nucleotidyltransferase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(140958, NULL, 'G3DSA:2.170.130.10:FF:000002', NULL, NULL, 'Vitamin B12 transporter BtuB', NULL, NULL, NULL, NULL, NULL, 4),
(140959, NULL, 'G3DSA:2.40.70.10:FF:000484', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140960, NULL, 'G3DSA:3.30.160.60:FF:006427', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140961, NULL, 'G3DSA:1.10.10.580:FF:000021', NULL, NULL, 'Rec8 like protein-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(140962, NULL, 'G3DSA:3.40.850.10:FF:000533', NULL, NULL, 'Kinesin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(140963, NULL, 'G3DSA:3.80.10.10:FF:000077', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase ERL1', NULL, NULL, NULL, NULL, NULL, 4),
(140964, NULL, 'G3DSA:2.130.10.10:FF:005377', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140965, NULL, 'G3DSA:3.30.70.330:FF:002155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140966, NULL, 'G3DSA:1.20.58.60:FF:000366', NULL, NULL, 'SMAll', NULL, NULL, NULL, NULL, NULL, 4),
(140967, NULL, 'G3DSA:2.160.20.10:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140968, NULL, 'G3DSA:2.30.30.620:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140969, NULL, 'G3DSA:1.10.510.10:FF:003232', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(140970, NULL, 'G3DSA:3.40.30.10:FF:000557', NULL, NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(140971, NULL, 'G3DSA:4.10.60.10:FF:000103', NULL, NULL, 'RNA binding motif protein 4.1', NULL, NULL, NULL, NULL, NULL, 4),
(140972, NULL, 'G3DSA:1.20.1070.10:FF:001047', NULL, NULL, 'Protein CBG13756', NULL, NULL, NULL, NULL, NULL, 4),
(140973, NULL, 'G3DSA:1.25.10.10:FF:000905', NULL, NULL, 'Ste ste11 cdc15 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(140974, NULL, 'G3DSA:1.10.150.20:FF:000177', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(140975, NULL, 'G3DSA:3.30.40.10:FF:001975', NULL, NULL, 'At1g70910', NULL, NULL, NULL, NULL, NULL, 4),
(140976, NULL, 'G3DSA:3.90.76.10:FF:000048', NULL, NULL, 'Oligopeptide-binding protein oppA', NULL, NULL, NULL, NULL, NULL, 4),
(140977, NULL, 'G3DSA:3.40.50.1580:FF:000015', NULL, NULL, 'MTN2', NULL, NULL, NULL, NULL, NULL, 4),
(140978, NULL, 'G3DSA:1.10.1740.10:FF:000027', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(140979, NULL, 'G3DSA:2.130.10.10:FF:002252', NULL, NULL, 'U3 small nucleolar RNA-associated protein 18 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(140980, NULL, 'G3DSA:4.10.1000.10:FF:000025', NULL, NULL, 'Zinc finger matrin-type protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(140981, NULL, 'G3DSA:3.80.10.10:FF:001403', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140982, NULL, 'G3DSA:3.40.525.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140983, NULL, 'G3DSA:2.60.40.150:FF:000523', NULL, NULL, 'C2 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(140984, NULL, 'G3DSA:3.90.70.10:FF:000709', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140985, NULL, 'G3DSA:2.30.30.40:FF:000676', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140986, NULL, 'G3DSA:3.40.50.2300:FF:000310', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(140987, NULL, 'G3DSA:2.60.40.150:FF:000271', NULL, NULL, 'Misfire, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(140988, NULL, 'G3DSA:1.10.10.10:FF:001759', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140989, NULL, 'G3DSA:2.30.40.10:FF:000162', NULL, NULL, 'N-acetylgalactosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(140990, NULL, 'G3DSA:2.30.29.30:FF:000366', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(140991, NULL, 'G3DSA:3.30.1490.480:FF:000004', NULL, NULL, 'Endolytic murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(140992, NULL, 'G3DSA:3.40.50.150:FF:000548', NULL, NULL, 'tRNA/tmRNA (uracil-C(5))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(140993, NULL, 'G3DSA:3.40.250.10:FF:000004', NULL, NULL, 'M-phase inducer phosphatase 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(140994, NULL, 'G3DSA:3.40.50.300:FF:003382', NULL, NULL, 'Regulator of nonsense transcripts putative', NULL, NULL, NULL, NULL, NULL, 4),
(140995, NULL, 'G3DSA:1.20.1730.10:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140996, NULL, 'G3DSA:3.90.550.50:FF:000247', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(140997, NULL, 'G3DSA:1.25.40.10:FF:004173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(140998, NULL, 'G3DSA:2.130.10.10:FF:002960', NULL, NULL, 'WD40 repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(140999, NULL, 'G3DSA:2.70.170.10:FF:000248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141000, NULL, 'G3DSA:3.30.499.10:FF:000027', NULL, NULL, 'Aconitate hydratase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(141001, NULL, 'G3DSA:3.30.505.10:FF:000217', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141002, NULL, 'G3DSA:1.20.5.340:FF:000016', NULL, NULL, 'Rho-associated protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(141003, NULL, 'G3DSA:3.40.50.2000:FF:000102', NULL, NULL, 'Trehalose-6-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(141004, NULL, 'G3DSA:3.40.50.10330:FF:000099', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(141005, NULL, 'G3DSA:3.30.70.580:FF:000032', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(141006, NULL, 'G3DSA:1.20.120.350:FF:000119', NULL, NULL, 'Calcium channel, voltage-dependent, T type, alpha 1H subunit a', NULL, NULL, NULL, NULL, NULL, 4),
(141007, NULL, 'G3DSA:3.40.630.30:FF:000399', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141008, NULL, 'G3DSA:3.30.70.330:FF:002716', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141009, NULL, 'G3DSA:3.40.50.300:FF:008053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141010, NULL, 'G3DSA:3.40.190.10:FF:000724', NULL, NULL, 'Glutamate receptor 1.4', NULL, NULL, NULL, NULL, NULL, 4),
(141011, NULL, 'G3DSA:1.10.220.10:FF:000039', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(141012, NULL, 'G3DSA:3.30.70.1660:FF:000042', NULL, NULL, 'Peptide chain release factor 1, putative', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(141013, NULL, 'G3DSA:3.40.50.2300:FF:000996', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141014, NULL, 'G3DSA:3.30.70.360:FF:000005', NULL, NULL, 'Putative Aminoacylase-1', NULL, NULL, NULL, NULL, NULL, 4),
(141015, NULL, 'G3DSA:2.60.40.1510:FF:000047', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(141016, NULL, 'G3DSA:3.40.50.2300:FF:001614', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141017, NULL, 'G3DSA:1.50.10.20:FF:000030', NULL, NULL, 'Geranylgeranyl transferase type-2 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(141018, NULL, 'G3DSA:3.30.710.10:FF:000059', NULL, NULL, 'Zinc finger and BTB domain-containing protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(141019, NULL, 'G3DSA:2.70.98.10:FF:000023', NULL, NULL, 'Glucose-6-phosphate 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(141020, NULL, 'G3DSA:3.50.30.10:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141021, NULL, 'G3DSA:2.60.40.60:FF:000928', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141022, NULL, 'G3DSA:1.20.58.900:FF:000015', NULL, NULL, 'RUN and FYVE domain containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(141023, NULL, 'G3DSA:3.30.160.60:FF:001195', NULL, NULL, 'Zinc finger protein 239', NULL, NULL, NULL, NULL, NULL, 4),
(141024, NULL, 'G3DSA:2.130.10.10:FF:000942', NULL, NULL, 'Topless-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(141025, NULL, 'G3DSA:3.30.260.10:FF:000114', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141026, NULL, 'G3DSA:1.20.1050.10:FF:000231', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(141027, NULL, 'G3DSA:1.10.510.10:FF:000382', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(141028, NULL, 'G3DSA:1.20.1070.10:FF:001608', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(141029, NULL, 'G3DSA:2.160.20.10:FF:000172', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(141030, NULL, 'G3DSA:2.40.50.140:FF:001185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141031, NULL, 'G3DSA:1.10.510.10:FF:001000', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(141032, NULL, 'G3DSA:1.20.1530.20:FF:000023', NULL, NULL, 'Cation/H(+) antiporter 14', NULL, NULL, NULL, NULL, NULL, 4),
(141033, NULL, 'G3DSA:2.70.98.30:FF:000029', NULL, NULL, 'Lysosomal alpha-mannosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141034, NULL, 'G3DSA:1.10.1070.11:FF:000050', NULL, NULL, 'Phosphatidylinositol 3-kinase age-1', NULL, NULL, NULL, NULL, NULL, 4),
(141035, NULL, 'G3DSA:1.10.150.50:FF:000175', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(141036, NULL, 'G3DSA:1.20.58.760:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141037, NULL, 'G3DSA:2.60.120.10:FF:000770', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141038, NULL, 'G3DSA:2.130.10.10:FF:004197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141039, NULL, 'G3DSA:3.40.50.720:FF:000894', NULL, NULL, 'UDP-glucose 4-epimerase, truncation', NULL, NULL, NULL, NULL, NULL, 4),
(141040, NULL, 'G3DSA:3.30.160.20:FF:000250', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(141041, NULL, 'G3DSA:1.10.4190.10:FF:000002', NULL, NULL, 'Urease accessory protein UreF', NULL, NULL, NULL, NULL, NULL, 4),
(141042, NULL, 'G3DSA:1.25.40.10:FF:003004', NULL, NULL, 'Pre-mRNA-splicing factor clf1', NULL, NULL, NULL, NULL, NULL, 4),
(141043, NULL, 'G3DSA:1.25.40.10:FF:005134', NULL, NULL, 'Adenylyl cyclase class-3/4/guanylyl cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(141044, NULL, 'G3DSA:1.25.10.10:FF:001254', NULL, NULL, 'eIF-2-alpha kinase activator GCN1', NULL, NULL, NULL, NULL, NULL, 4),
(141045, NULL, 'G3DSA:3.40.140.10:FF:000086', NULL, NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(141046, NULL, 'G3DSA:1.20.5.320:FF:000010', NULL, NULL, 'Collagen type VI alpha 6 chain', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(141047, NULL, 'G3DSA:2.130.10.10:FF:004382', NULL, NULL, 'Anaphase-promoting complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(141048, NULL, 'G3DSA:3.30.930.10:FF:000042', NULL, NULL, 'probable proline--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(141049, NULL, 'G3DSA:3.30.160.60:FF:005955', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141050, NULL, 'G3DSA:1.20.58.1220:FF:000008', NULL, NULL, 'Exocyst complex component', NULL, NULL, NULL, NULL, NULL, 4),
(141051, NULL, 'G3DSA:1.20.1280.290:FF:000071', NULL, NULL, 'Lysosomal L-cystine transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(141052, NULL, 'G3DSA:2.40.30.270:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141053, NULL, 'G3DSA:3.30.1490.40:FF:000004', NULL, NULL, 'Zinc finger CCCH domain-containing protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(141054, NULL, 'G3DSA:3.10.20.90:FF:000368', NULL, NULL, 'Ubiquitin thioesterase OTU1', NULL, NULL, NULL, NULL, NULL, 4),
(141055, NULL, 'G3DSA:2.170.150.20:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141056, NULL, 'G3DSA:2.60.120.330:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141057, NULL, 'G3DSA:3.50.50.60:FF:000129', NULL, NULL, 'Kynurenine 3-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(141058, NULL, 'G3DSA:1.20.80.10:FF:000083', NULL, NULL, 'Myosin-G heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(141059, NULL, 'G3DSA:1.20.1250.20:FF:001474', NULL, NULL, 'Transporter', NULL, NULL, NULL, NULL, NULL, 4),
(141060, NULL, 'G3DSA:1.20.1250.20:FF:001289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141061, NULL, 'G3DSA:2.130.10.10:FF:005719', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141062, NULL, 'G3DSA:3.30.300.30:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141063, NULL, 'G3DSA:2.60.120.40:FF:000003', NULL, NULL, 'caprin-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(141064, NULL, 'G3DSA:1.20.91.20:FF:000004', NULL, NULL, 'Complement C5', NULL, NULL, NULL, NULL, NULL, 4),
(141065, NULL, 'G3DSA:3.60.21.10:FF:000384', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141066, NULL, 'G3DSA:1.20.5.260:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141067, NULL, 'G3DSA:1.10.533.10:FF:000075', NULL, NULL, 'Baculoviral IAP repeat containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(141068, NULL, 'G3DSA:1.10.150.20:FF:000071', NULL, NULL, 'Flap endonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(141069, NULL, 'G3DSA:1.25.10.10:FF:001939', NULL, NULL, 'YALI0E27049p', NULL, NULL, NULL, NULL, NULL, 4),
(141070, NULL, 'G3DSA:2.80.10.50:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141071, NULL, 'G3DSA:1.25.40.20:FF:000376', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(141072, NULL, 'G3DSA:1.25.40.80:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141073, NULL, 'G3DSA:3.30.720.10:FF:000009', NULL, NULL, 'Signal recognition particle subunit SRP9', NULL, NULL, NULL, NULL, NULL, 4),
(141074, NULL, 'G3DSA:2.120.10.80:FF:000188', NULL, NULL, 'AGAP008185-PA', NULL, NULL, NULL, NULL, NULL, 4),
(141075, NULL, 'G3DSA:3.90.650.10:FF:000046', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(141076, NULL, 'G3DSA:1.10.8.270:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141077, NULL, 'G3DSA:1.10.470.10:FF:000007', NULL, NULL, 'Variant surface glycoprotein (VSG, atypical), putative', NULL, NULL, NULL, NULL, NULL, 4),
(141078, NULL, 'G3DSA:1.10.530.10:FF:000052', NULL, NULL, 'Endochitinase PR4', NULL, NULL, NULL, NULL, NULL, 4),
(141079, NULL, 'G3DSA:1.10.10.60:FF:000931', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141080, NULL, 'G3DSA:3.40.50.720:FF:001855', NULL, NULL, 'Galactose epimerase, putative', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(141081, NULL, 'G3DSA:1.25.10.10:FF:000074', NULL, NULL, 'importin-5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(141082, NULL, 'G3DSA:1.10.1300.10:FF:000028', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(141083, NULL, 'G3DSA:1.20.1110.10:FF:000163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141084, NULL, 'G3DSA:3.40.50.10130:FF:000011', NULL, NULL, 'Crossover junction endonuclease MUS81', NULL, NULL, NULL, NULL, NULL, 4),
(141085, NULL, 'G3DSA:2.60.40.10:FF:005034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141086, NULL, 'G3DSA:1.20.1560.10:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141087, NULL, 'G3DSA:1.20.1250.20:FF:000294', NULL, NULL, 'MFS transporter of unkown specificity', NULL, NULL, NULL, NULL, NULL, 4),
(141088, NULL, 'G3DSA:4.10.830.40:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141089, NULL, 'G3DSA:1.10.287.1970:FF:000001', NULL, NULL, 'Alanine aminotransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(141090, NULL, 'G3DSA:3.40.50.300:FF:008429', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141091, NULL, 'G3DSA:1.25.40.10:FF:002386', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(141092, NULL, 'G3DSA:3.40.50.2020:FF:000108', NULL, NULL, 'Phosphoribosyl transferase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(141093, NULL, 'G3DSA:1.20.870.10:FF:000035', NULL, NULL, 'RAS, guanyl releasing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(141094, NULL, 'G3DSA:3.30.200.20:FF:001378', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141095, NULL, 'G3DSA:4.10.410.60:FF:000001', NULL, NULL, '50S ribosomal protein L35', NULL, NULL, NULL, NULL, NULL, 4),
(141096, NULL, 'G3DSA:3.30.450.30:FF:000011', NULL, NULL, 'Dynein light chain roadblock', NULL, NULL, NULL, NULL, NULL, 4),
(141097, NULL, 'G3DSA:2.130.10.30:FF:000026', NULL, NULL, 'RCC1-like G exchanging factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(141098, NULL, 'G3DSA:2.120.10.30:FF:000330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141099, NULL, 'G3DSA:3.80.10.10:FF:002128', NULL, NULL, 'NLR family CARD domain-containing 9', NULL, NULL, NULL, NULL, NULL, 4),
(141100, NULL, 'G3DSA:3.40.640.10:FF:000490', NULL, NULL, 'Aminotransferase tdiD', NULL, NULL, NULL, NULL, NULL, 4),
(141101, NULL, 'G3DSA:3.80.10.10:FF:002331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141102, NULL, 'G3DSA:3.30.1120.10:FF:000058', NULL, NULL, 'N-acetylgalactosamine-6-sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(141103, NULL, 'G3DSA:3.10.100.10:FF:000130', NULL, NULL, 'C-type lectin receptor-like tyrosine-protein kinase isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(141104, NULL, 'G3DSA:2.50.20.10:FF:000008', NULL, NULL, 'Outer-membrane lipoprotein carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(141105, NULL, 'G3DSA:3.90.740.10:FF:000076', NULL, NULL, 'ATP binding / aminoacyl-tRNA ligase/ nucleotide binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(141106, NULL, 'G3DSA:4.10.400.10:FF:000076', NULL, NULL, 'Low-density lipoprotein receptor-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(141107, NULL, 'G3DSA:3.10.129.10:FF:000139', NULL, NULL, 'HotDog domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(141108, NULL, 'G3DSA:3.80.10.10:FF:001038', NULL, NULL, 'Leucine-rich receptor-like kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(141109, NULL, 'G3DSA:2.10.25.10:FF:001302', NULL, NULL, 'AGAP003506-PA', NULL, NULL, NULL, NULL, NULL, 4),
(141110, NULL, 'G3DSA:3.30.750.24:FF:000176', NULL, NULL, 'Chloride anion exchanger', NULL, NULL, NULL, NULL, NULL, 4),
(141111, NULL, 'G3DSA:3.40.50.80:FF:000063', NULL, NULL, 'Ferredoxin--NADP reductase', NULL, NULL, NULL, NULL, NULL, 4),
(141112, NULL, 'G3DSA:2.60.40.10:FF:001200', NULL, NULL, 'Titin a', NULL, NULL, NULL, NULL, NULL, 4),
(141113, NULL, 'G3DSA:3.30.565.10:FF:000558', NULL, NULL, 'Putative heat shock protein HSP 90-alpha A4', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(141114, NULL, 'G3DSA:3.40.50.300:FF:005433', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141115, NULL, 'G3DSA:2.130.10.10:FF:004758', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141116, NULL, 'G3DSA:3.40.50.2300:FF:000069', NULL, NULL, 'Two-component system response regulator BasR', NULL, NULL, NULL, NULL, NULL, 4),
(141117, NULL, 'G3DSA:2.10.90.10:FF:000082', NULL, NULL, 'Cerberus', NULL, NULL, NULL, NULL, NULL, 4),
(141118, NULL, 'G3DSA:3.30.40.10:FF:002380', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(141119, NULL, 'G3DSA:1.20.144.10:FF:000085', NULL, NULL, 'Phosphatidate phosphatase PPAPDC1A', NULL, NULL, NULL, NULL, NULL, 4),
(141120, NULL, 'G3DSA:3.80.10.10:FF:003511', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(141121, NULL, 'G3DSA:2.60.40.60:FF:000372', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(141122, NULL, 'G3DSA:1.20.1260.10:FF:000022', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(141123, NULL, 'G3DSA:2.160.20.70:FF:000037', NULL, NULL, 'Tubulin specific chaperone D', NULL, NULL, NULL, NULL, NULL, 4),
(141124, NULL, 'G3DSA:2.130.10.10:FF:000487', NULL, NULL, 'Transducin beta like 2', NULL, NULL, NULL, NULL, NULL, 4),
(141125, NULL, 'G3DSA:1.20.120.160:FF:000040', NULL, NULL, 'Two component system histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(141126, NULL, 'G3DSA:3.30.70.330:FF:000210', NULL, NULL, 'RNA-binding protein with serine-rich domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(141127, NULL, 'G3DSA:1.20.120.720:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141128, NULL, 'G3DSA:1.25.40.10:FF:001082', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(141129, NULL, 'G3DSA:4.10.40.50:FF:000001', NULL, NULL, 'liver-expressed antimicrobial peptide 2', NULL, NULL, NULL, NULL, NULL, 4),
(141130, NULL, 'G3DSA:3.40.50.300:FF:001813', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(141131, NULL, 'G3DSA:3.90.550.10:FF:000246', NULL, NULL, 'Chitooligosaccharide synthase NodC', NULL, NULL, NULL, NULL, NULL, 4),
(141132, NULL, 'G3DSA:2.60.40.3210:FF:000006', NULL, NULL, 'Zona pellucida sperm-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(141133, NULL, 'G3DSA:1.20.5.370:FF:000014', NULL, NULL, 'Myosin-7', NULL, NULL, NULL, NULL, NULL, 4),
(141134, NULL, 'G3DSA:1.10.286.70:FF:000001', NULL, NULL, 'Uncharacterized protein B2O8.280', NULL, NULL, NULL, NULL, NULL, 4),
(141135, NULL, 'G3DSA:2.20.100.10:FF:000064', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 10 preproprotein', NULL, NULL, NULL, NULL, NULL, 4),
(141136, NULL, 'G3DSA:2.60.40.10:FF:000054', NULL, NULL, 'Contactin 1', NULL, NULL, NULL, NULL, NULL, 4),
(141137, NULL, 'G3DSA:3.30.70.2630:FF:000007', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(141138, NULL, 'G3DSA:3.30.110.30:FF:000008', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(141139, NULL, 'G3DSA:1.10.3380.30:FF:000022', NULL, NULL, 'ATP-dependent DNA helicase Hel308', NULL, NULL, NULL, NULL, NULL, 4),
(141140, NULL, 'G3DSA:2.70.130.10:FF:000127', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141141, NULL, 'G3DSA:3.40.50.10810:FF:000131', NULL, NULL, 'AGAP010699-PA', NULL, NULL, NULL, NULL, NULL, 4),
(141142, NULL, 'G3DSA:3.40.50.150:FF:000442', NULL, NULL, 'tRNA (Adenine22-N1)-methyltransferase TrmK', NULL, NULL, NULL, NULL, NULL, 4),
(141143, NULL, 'G3DSA:3.30.160.60:FF:004319', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141144, NULL, 'G3DSA:3.30.1010.10:FF:000067', NULL, NULL, 'Phosphatidylinositol4,5-bisphosphate 3-kinase catalytic subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141145, NULL, 'G3DSA:3.40.1660.10:FF:000001', NULL, NULL, 'Erythromycin esterase', NULL, NULL, NULL, NULL, NULL, 4),
(141146, NULL, 'G3DSA:3.10.450.100:FF:000001', NULL, NULL, 'Penicillin-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(141147, NULL, 'G3DSA:3.30.1490.70:FF:000002', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(141148, NULL, 'G3DSA:4.10.280.10:FF:000195', NULL, NULL, 'cDNA FLJ52911, highly similar to Max-like protein X', NULL, NULL, NULL, NULL, NULL, 4),
(141149, NULL, 'G3DSA:1.20.190.50:FF:000012', NULL, NULL, 'Nuclear pore complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(141150, NULL, 'G3DSA:2.30.30.140:FF:000177', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(141151, NULL, 'G3DSA:3.40.50.1240:FF:000155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141152, NULL, 'G3DSA:1.10.238.10:FF:000439', NULL, NULL, 'Troponin C type IIIb1', NULL, NULL, NULL, NULL, NULL, 4),
(141153, NULL, 'G3DSA:3.30.40.10:FF:002014', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(141154, NULL, 'G3DSA:3.30.200.20:FF:000198', NULL, NULL, 'Myosin light chain kinase, smooth muscle', NULL, NULL, NULL, NULL, NULL, 4),
(141155, NULL, 'G3DSA:1.10.510.10:FF:002304', NULL, NULL, 'Kinase-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(141156, NULL, 'G3DSA:1.10.238.10:FF:001058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141157, NULL, 'G3DSA:2.60.120.290:FF:000052', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(141158, NULL, 'G3DSA:3.30.110.10:FF:000002', NULL, NULL, 'Translation initiation factor IF-3', NULL, NULL, NULL, NULL, NULL, 4),
(141159, NULL, 'G3DSA:1.10.472.10:FF:000702', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141160, NULL, 'G3DSA:2.90.10.10:FF:000051', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase SD2-5', NULL, NULL, NULL, NULL, NULL, 4),
(141161, NULL, 'G3DSA:3.30.830.10:FF:000023', NULL, NULL, 'Mitochondrial processing peptidase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(141162, NULL, 'G3DSA:3.40.1390.20:FF:000011', NULL, NULL, 'Manganese-dependent inorganic pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(141163, NULL, 'G3DSA:2.60.40.10:FF:000363', NULL, NULL, 'neurofascin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(141164, NULL, 'G3DSA:2.60.40.10:FF:004325', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141165, NULL, 'G3DSA:3.30.70.2610:FF:000001', NULL, NULL, 'General transcription factor IIH subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(141166, NULL, 'G3DSA:3.40.190.10:FF:000853', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141167, NULL, 'G3DSA:3.60.40.10:FF:000304', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(141168, NULL, 'G3DSA:3.40.50.300:FF:004686', NULL, NULL, 'Recombination-defective, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(141169, NULL, 'G3DSA:2.60.40.60:FF:001081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141170, NULL, 'G3DSA:3.30.70.330:FF:000553', NULL, NULL, 'Splicing factor SRp54', NULL, NULL, NULL, NULL, NULL, 4),
(141171, NULL, 'G3DSA:2.10.25.10:FF:000684', NULL, NULL, 'EGF, latrophilin seven transmembrane domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(141172, NULL, 'G3DSA:1.10.1450.10:FF:000016', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(141173, NULL, 'G3DSA:3.90.550.10:FF:000555', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141174, NULL, 'G3DSA:2.30.29.30:FF:000260', NULL, NULL, 'Rho GTPase activating protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(141175, NULL, 'G3DSA:1.10.510.10:FF:000359', NULL, NULL, 'Mitogen-activated protein kinase 1, putative, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(141176, NULL, 'G3DSA:3.30.160.60:FF:000576', NULL, NULL, 'C2H2 transcription factor (AmdX)', NULL, NULL, NULL, NULL, NULL, 4),
(141177, NULL, 'G3DSA:3.30.830.10:FF:000242', NULL, NULL, 'Clan ME, family M16, insulinase-like metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(141178, NULL, 'G3DSA:2.60.40.60:FF:000681', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(141179, NULL, 'G3DSA:1.25.10.10:FF:000635', NULL, NULL, 'Importin beta-2 subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141180, NULL, 'G3DSA:1.20.1070.10:FF:002137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141181, NULL, 'G3DSA:2.30.22.10:FF:000002', NULL, NULL, 'GrpE protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(141182, NULL, 'G3DSA:3.40.50.10860:FF:000027', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(141183, NULL, 'G3DSA:3.20.20.300:FF:000019', NULL, NULL, 'Thermostable beta-glucosidase B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141184, NULL, 'G3DSA:3.40.50.2000:FF:000193', NULL, NULL, 'Protein RfbU', NULL, NULL, NULL, NULL, NULL, 4),
(141185, NULL, 'G3DSA:3.40.1110.10:FF:000050', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(141186, NULL, 'G3DSA:1.10.630.10:FF:000413', NULL, NULL, 'Os07g0451300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(141187, NULL, 'G3DSA:3.30.565.10:FF:000249', NULL, NULL, 'Signal-transducing protein, histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(141188, NULL, 'G3DSA:3.50.50.60:FF:000680', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141189, NULL, 'G3DSA:2.60.40.10:FF:004073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141190, NULL, 'G3DSA:3.90.190.10:FF:000022', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(141191, NULL, 'G3DSA:2.130.10.10:FF:004073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141192, NULL, 'G3DSA:3.30.1370.10:FF:000083', NULL, NULL, 'DEAD (Asp-Glu-Ala-Asp) box polypeptide 43', NULL, NULL, NULL, NULL, NULL, 4),
(141193, NULL, 'G3DSA:1.10.8.60:FF:000475', NULL, NULL, 'AAA ATPase, cell division control protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141194, NULL, 'G3DSA:1.25.40.10:FF:001767', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g15340, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(141195, NULL, 'G3DSA:3.30.200.20:FF:000759', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(141196, NULL, 'G3DSA:3.40.47.10:FF:000175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141197, NULL, 'G3DSA:1.20.1560.10:FF:000314', NULL, NULL, 'Heavy metal tolerance factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(141198, NULL, 'G3DSA:2.30.30.640:FF:000001', NULL, NULL, 'Glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(141199, NULL, 'G3DSA:3.30.160.60:FF:001560', NULL, NULL, 'zinc finger protein 853', NULL, NULL, NULL, NULL, NULL, 4),
(141200, NULL, 'G3DSA:3.30.450.20:FF:000042', NULL, NULL, 'hypoxia-inducible factor 3-alpha isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(141201, NULL, 'G3DSA:2.30.30.100:FF:000160', NULL, NULL, 'Protein CBR-LSM-3', NULL, NULL, NULL, NULL, NULL, 4),
(141202, NULL, 'G3DSA:1.20.1540.10:FF:000083', NULL, NULL, 'Rhomboid-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(141203, NULL, 'G3DSA:3.40.50.720:FF:000219', NULL, NULL, 'Cinnamoyl-CoA reductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(141204, NULL, 'G3DSA:3.40.50.300:FF:004472', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141205, NULL, 'G3DSA:2.30.29.30:FF:000821', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(141206, NULL, 'G3DSA:3.90.70.10:FF:000097', NULL, NULL, 'Ubiquitin specific peptidase 32', NULL, NULL, NULL, NULL, NULL, 4),
(141207, NULL, 'G3DSA:3.40.50.300:FF:000976', NULL, NULL, 'Translocase subunit secA chloroplastic-like', NULL, NULL, NULL, NULL, NULL, 4),
(141208, NULL, 'G3DSA:1.25.10.10:FF:000293', NULL, NULL, 'Lyase containing HEAT-repeat', NULL, NULL, NULL, NULL, NULL, 4),
(141209, NULL, 'G3DSA:1.20.5.110:FF:000329', NULL, NULL, 'Syntaxin-22', NULL, NULL, NULL, NULL, NULL, 4),
(141210, NULL, 'G3DSA:1.10.472.10:FF:000141', NULL, NULL, 'Transcription initiation factor IIB', NULL, NULL, NULL, NULL, NULL, 4),
(141211, NULL, 'G3DSA:1.10.3470.10:FF:000057', NULL, NULL, 'Probable ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(141212, NULL, 'G3DSA:3.30.1050.10:FF:000030', NULL, NULL, 'Non-specific lipid-transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(141213, NULL, 'G3DSA:1.10.238.10:FF:000097', NULL, NULL, 'Alpha-actinin, sarcomeric (F-actin cross linking protein)', NULL, NULL, NULL, NULL, NULL, 4),
(141214, NULL, 'G3DSA:3.30.160.60:FF:004994', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141215, NULL, 'G3DSA:1.10.510.10:FF:003687', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141216, NULL, 'G3DSA:3.30.420.40:FF:000872', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141217, NULL, 'G3DSA:1.25.40.10:FF:004645', NULL, NULL, 'Os05g0307200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(141218, NULL, 'G3DSA:1.10.10.60:FF:001173', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141219, NULL, 'G3DSA:2.10.230.10:FF:000019', NULL, NULL, 'DnaJ domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(141220, NULL, 'G3DSA:1.10.10.10:FF:000697', NULL, NULL, 'G protein-coupled receptor 155', NULL, NULL, NULL, NULL, NULL, 4),
(141221, NULL, 'G3DSA:3.30.160.60:FF:004314', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141222, NULL, 'G3DSA:3.40.190.10:FF:000836', NULL, NULL, 'Sugar ABC transporter, periplasmic sugar-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(141223, NULL, 'G3DSA:3.30.960.10:FF:000004', NULL, NULL, 'Eukaryotic peptide chain release factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(141224, NULL, 'G3DSA:1.10.238.20:FF:000004', NULL, NULL, 'Pheromone-binding protein Gp-9', NULL, NULL, NULL, NULL, NULL, 4),
(141225, NULL, 'G3DSA:1.20.1250.20:FF:001710', NULL, NULL, 'Organic cation/carnitine transporter 7', NULL, NULL, NULL, NULL, NULL, 4),
(141226, NULL, 'G3DSA:1.10.510.10:FF:004193', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141227, NULL, 'G3DSA:2.40.160.120:FF:000042', NULL, NULL, 'Oxysterol-binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(141228, NULL, 'G3DSA:3.80.10.10:FF:003303', NULL, NULL, 'Toll-9, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(141229, NULL, 'G3DSA:1.20.1070.10:FF:001384', NULL, NULL, 'LOC567796 protein', NULL, NULL, NULL, NULL, NULL, 4),
(141230, NULL, 'G3DSA:2.60.40.10:FF:001122', NULL, NULL, 'NPHS1, nephrin', NULL, NULL, NULL, NULL, NULL, 4),
(141231, NULL, 'G3DSA:4.10.280.10:FF:000088', NULL, NULL, 'HLH DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(141232, NULL, 'G3DSA:2.60.40.10:FF:004769', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141233, NULL, 'G3DSA:3.10.105.10:FF:000118', NULL, NULL, 'Oligopeptide ABC transporter, periplasmic oligopeptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(141234, NULL, 'G3DSA:1.25.40.10:FF:001891', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g36680, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(141235, NULL, 'G3DSA:3.30.1120.10:FF:000053', NULL, NULL, 'Arylsulfatase A', NULL, NULL, NULL, NULL, NULL, 4),
(141236, NULL, 'G3DSA:3.30.479.20:FF:000006', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(141237, NULL, 'G3DSA:1.25.40.20:FF:000371', NULL, NULL, 'G9a, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(141238, NULL, 'G3DSA:1.10.238.220:FF:000005', NULL, NULL, 'Protein CBG16342', NULL, NULL, NULL, NULL, NULL, 4),
(141239, NULL, 'G3DSA:1.20.870.10:FF:000018', NULL, NULL, 'Blast:Ral guanine nucleotide dissociation stimulator-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(141240, NULL, 'G3DSA:2.10.25.10:FF:000318', NULL, NULL, 'Eyes shut homolog', NULL, NULL, NULL, NULL, NULL, 4),
(141241, NULL, 'G3DSA:2.40.10.10:FF:000053', NULL, NULL, 'Neurotrypsin', NULL, NULL, NULL, NULL, NULL, 4),
(141242, NULL, 'G3DSA:2.130.10.10:FF:003224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141243, NULL, 'G3DSA:3.80.10.10:FF:003292', NULL, NULL, 'Toll-like receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(141244, NULL, 'G3DSA:3.40.640.10:FF:000265', NULL, NULL, 'Serine hydroxymethyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(141245, NULL, 'G3DSA:1.20.1250.10:FF:000072', NULL, NULL, 'Prolactin family 3, subfamily a, member 1', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(141246, NULL, 'G3DSA:3.40.50.300:FF:004135', NULL, NULL, 'Thymidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(141247, NULL, 'G3DSA:3.60.15.10:FF:000004', NULL, NULL, 'Probable L-ascorbate-6-phosphate lactonase UlaG', NULL, NULL, NULL, NULL, NULL, 4),
(141248, NULL, 'G3DSA:3.50.50.60:FF:000348', NULL, NULL, '2-polyprenyl-6-methoxyphenol hydroxylase-like oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(141249, NULL, 'G3DSA:1.20.1250.20:FF:001159', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141250, NULL, 'G3DSA:2.40.30.10:FF:000048', NULL, NULL, 'Ferredoxin--NADP reductase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(141251, NULL, 'G3DSA:3.40.50.300:FF:002999', NULL, NULL, 'Branched-chain amino acid ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(141252, NULL, 'G3DSA:1.25.40.10:FF:000946', NULL, NULL, 'Transcription factor tau 131 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(141253, NULL, 'G3DSA:2.120.10.80:FF:000199', NULL, NULL, 'F-box/kelch-repeat protein SKIP20', NULL, NULL, NULL, NULL, NULL, 4),
(141254, NULL, 'G3DSA:1.20.1730.10:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141255, NULL, 'G3DSA:3.30.200.20:FF:002362', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141256, NULL, 'G3DSA:4.10.1200.10:FF:000001', NULL, NULL, 'Respiratory nitrate reductase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(141257, NULL, 'G3DSA:3.20.20.140:FF:000286', NULL, NULL, 'Putative histidinol-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(141258, NULL, 'G3DSA:1.10.510.10:FF:002647', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141259, NULL, 'G3DSA:1.10.418.10:FF:000212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141260, NULL, 'G3DSA:3.40.50.1000:FF:000685', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141261, NULL, 'G3DSA:3.40.140.10:FF:000221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141262, NULL, 'G3DSA:2.40.30.10:FF:000487', NULL, NULL, 'Eukaryotic initiation factor', NULL, NULL, NULL, NULL, NULL, 4),
(141263, NULL, 'G3DSA:2.60.120.10:FF:000455', NULL, NULL, 'Potassium voltage-gated channel subfamily H member 8', NULL, NULL, NULL, NULL, NULL, 4),
(141264, NULL, 'G3DSA:3.10.20.90:FF:000155', NULL, NULL, 'Ubiquitin-like protein SMT3', NULL, NULL, NULL, NULL, NULL, 4),
(141265, NULL, 'G3DSA:1.25.40.180:FF:000037', NULL, NULL, 'Nonsense-mediated mRNA decay factor (Upf2)', NULL, NULL, NULL, NULL, NULL, 4),
(141266, NULL, 'G3DSA:3.40.630.10:FF:000180', NULL, NULL, 'Cytosolic carboxypeptidase-like protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(141267, NULL, 'G3DSA:3.40.50.80:FF:000080', NULL, NULL, 'NADPH oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(141268, NULL, 'G3DSA:1.25.10.10:FF:000765', NULL, NULL, 'Transportin 2', NULL, NULL, NULL, NULL, NULL, 4),
(141269, NULL, 'G3DSA:3.40.190.10:FF:000741', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141270, NULL, 'G3DSA:1.10.10.10:FF:001214', NULL, NULL, 'Response regulator receiver', NULL, NULL, NULL, NULL, NULL, 4),
(141271, NULL, 'G3DSA:3.30.70.890:FF:000029', NULL, NULL, 'Phosphomevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(141272, NULL, 'G3DSA:1.20.5.930:FF:000002', NULL, NULL, 'Integrin, alpha 9', NULL, NULL, NULL, NULL, NULL, 4),
(141273, NULL, 'G3DSA:1.20.1280.290:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141274, NULL, 'G3DSA:3.40.720.10:FF:000299', NULL, NULL, 'Sulfatase and phosphatidylinositolglycan class N domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(141275, NULL, 'G3DSA:3.30.70.870:FF:000023', NULL, NULL, 'Tetracycline resistance protein, GTP-binding elongation family', NULL, NULL, NULL, NULL, NULL, 4),
(141276, NULL, 'G3DSA:1.20.1270.60:FF:000088', NULL, NULL, 'Ivy1p', NULL, NULL, NULL, NULL, NULL, 4),
(141277, NULL, 'G3DSA:1.10.8.60:FF:000025', NULL, NULL, 'Katanin p60 ATPase-containing subunit A1', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(141278, NULL, 'G3DSA:3.30.930.10:FF:000295', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(141279, NULL, 'G3DSA:3.40.30.10:FF:001041', NULL, NULL, 'Peroxiredoxin, thioredoxin peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(141280, NULL, 'G3DSA:2.40.50.90:FF:000028', NULL, NULL, 'staphylococcal-like nuclease CAN2', NULL, NULL, NULL, NULL, NULL, 4),
(141281, NULL, 'G3DSA:3.40.630.30:FF:000186', NULL, NULL, 'N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(141282, NULL, 'G3DSA:3.30.40.10:FF:001525', NULL, NULL, 'abscission/NoCut checkpoint regulator', NULL, NULL, NULL, NULL, NULL, 4),
(141283, NULL, 'G3DSA:2.40.10.10:FF:000148', NULL, NULL, 'CLIP-domain serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(141284, NULL, 'G3DSA:2.130.10.10:FF:004961', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141285, NULL, 'G3DSA:3.40.50.300:FF:001381', NULL, NULL, 'Putative lipoprotein ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(141286, NULL, 'G3DSA:3.40.50.300:FF:005080', NULL, NULL, 'ADP-ribosylation factor family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141287, NULL, 'G3DSA:2.60.120.260:FF:000189', NULL, NULL, 'Teneurin-m-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(141288, NULL, 'G3DSA:2.10.25.10:FF:001746', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(141289, NULL, 'G3DSA:1.10.1450.10:FF:000128', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(141290, NULL, 'G3DSA:3.30.470.20:FF:000037', NULL, NULL, 'Phosphoribosylaminoimidazole carboxylase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(141291, NULL, 'G3DSA:3.40.50.300:FF:006956', NULL, NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 10, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(141292, NULL, 'G3DSA:2.70.170.10:FF:000012', NULL, NULL, 'Nicotinic acetylcholine receptor subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(141293, NULL, 'G3DSA:1.20.58.760:FF:000041', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(141294, NULL, 'G3DSA:3.90.70.10:FF:000693', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141295, NULL, 'G3DSA:3.40.50.150:FF:000678', NULL, NULL, 'Methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(141296, NULL, 'G3DSA:2.10.110.10:FF:000286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141297, NULL, 'G3DSA:3.30.160.40:FF:000025', NULL, NULL, 'Porphobilinogen deaminase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(141298, NULL, 'G3DSA:1.10.510.10:FF:002164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141299, NULL, 'G3DSA:3.40.50.170:FF:000004', NULL, NULL, 'Methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(141300, NULL, 'G3DSA:3.30.2350.10:FF:000087', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(141301, NULL, 'G3DSA:2.170.150.40:FF:000001', NULL, NULL, 'DUF427 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(141302, NULL, 'G3DSA:3.90.550.50:FF:000224', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(141303, NULL, 'G3DSA:3.30.40.10:FF:000699', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM31', NULL, NULL, NULL, NULL, NULL, 4),
(141304, NULL, 'G3DSA:3.40.50.10490:FF:000006', NULL, NULL, 'DnaA initiator-associating protein DiaA', NULL, NULL, NULL, NULL, NULL, 4),
(141305, NULL, 'G3DSA:3.90.950.10:FF:000007', NULL, NULL, 'dTTP/UTP pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(141306, NULL, 'G3DSA:3.40.50.620:FF:000268', NULL, NULL, 'Isoleucine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(141307, NULL, 'G3DSA:4.10.40.20:FF:000009', NULL, NULL, 'Insulin like growth factor binding protein like 1', NULL, NULL, NULL, NULL, NULL, 4),
(141308, NULL, 'G3DSA:1.25.40.10:FF:002503', NULL, NULL, 'hsp70-Hsp90 organizing protein 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(141309, NULL, 'G3DSA:1.20.960.30:FF:000003', NULL, NULL, 'Related to Nuclear receptor co-repressor/HDAC3 complex subunit TBLR1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(141310, NULL, 'G3DSA:4.10.1060.10:FF:000012', NULL, NULL, 'ubiquitin thioesterase ZRANB1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(141311, NULL, 'G3DSA:3.20.20.330:FF:000011', NULL, NULL, 'Methionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(141312, NULL, 'G3DSA:1.25.40.10:FF:003689', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(141313, NULL, 'G3DSA:2.60.40.60:FF:000945', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141314, NULL, 'G3DSA:3.30.497.10:FF:000068', NULL, NULL, 'Serpin-2 precursor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141315, NULL, 'G3DSA:1.10.1670.10:FF:000027', NULL, NULL, 'Endonuclease III homolog', NULL, NULL, NULL, NULL, NULL, 4),
(141316, NULL, 'G3DSA:3.10.450.10:FF:000015', NULL, NULL, 'Histidine-rich glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(141317, NULL, 'G3DSA:1.25.40.10:FF:003931', NULL, NULL, 'Coatomer subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(141318, NULL, 'G3DSA:3.30.1060.10:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141319, NULL, 'G3DSA:3.80.10.10:FF:002786', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141320, NULL, 'G3DSA:1.25.10.10:FF:001271', NULL, NULL, 'Sorting Of Apical Proteins', NULL, NULL, NULL, NULL, NULL, 4),
(141321, NULL, 'G3DSA:1.20.1250.20:FF:002115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141322, NULL, 'G3DSA:3.40.50.2000:FF:000316', NULL, NULL, 'Probable glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(141323, NULL, 'G3DSA:2.60.40.10:FF:002841', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(141324, NULL, 'G3DSA:3.30.70.270:FF:000170', NULL, NULL, 'Diguanylate cyclase/phosphodiesterase (GGDEF & EAL domain) with PAS/PAC sensor(S)', NULL, NULL, NULL, NULL, NULL, 4),
(141325, NULL, 'G3DSA:1.20.58.900:FF:000004', NULL, NULL, 'pleckstrin homology domain-containing family M member 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(141326, NULL, 'G3DSA:1.20.58.390:FF:000233', NULL, NULL, 'Protein CBR-LGC-39', NULL, NULL, NULL, NULL, NULL, 4),
(141327, NULL, 'G3DSA:2.60.120.430:FF:000021', NULL, NULL, 'MRLK2', NULL, NULL, NULL, NULL, NULL, 4),
(141328, NULL, 'G3DSA:3.40.50.150:FF:000239', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase H', NULL, NULL, NULL, NULL, NULL, 4),
(141329, NULL, 'G3DSA:2.30.30.100:FF:000165', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141330, NULL, 'G3DSA:3.30.70.330:FF:000570', NULL, NULL, 'ALKylated DNA repair protein AlkB homolog', NULL, NULL, NULL, NULL, NULL, 4),
(141331, NULL, 'G3DSA:3.40.50.720:FF:000214', NULL, NULL, 'L-xylulose reductase', NULL, NULL, NULL, NULL, NULL, 4),
(141332, NULL, 'G3DSA:3.30.70.330:FF:000682', NULL, NULL, 'Ras GTPase-activating protein-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(141333, NULL, 'G3DSA:1.10.730.10:FF:000033', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(141334, NULL, 'G3DSA:1.10.150.240:FF:000089', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(141335, NULL, 'G3DSA:1.20.120.1750:FF:000001', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(141336, NULL, 'G3DSA:2.130.10.10:FF:004522', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141337, NULL, 'G3DSA:3.90.1150.10:FF:000182', NULL, NULL, 'Cystathionine gamma-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(141338, NULL, 'G3DSA:3.40.50.300:FF:004927', NULL, NULL, 'Uncharacterized protein ABCG26', NULL, NULL, NULL, NULL, NULL, 4),
(141339, NULL, 'G3DSA:2.30.30.790:FF:000006', NULL, NULL, '50S ribosomal protein L19', NULL, NULL, NULL, NULL, NULL, 4),
(141340, NULL, 'G3DSA:2.120.10.30:FF:000454', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141341, NULL, 'G3DSA:1.20.58.60:FF:000501', NULL, NULL, 'Dystrophin, isoform K', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(141342, NULL, 'G3DSA:3.30.1520.10:FF:000145', NULL, NULL, 'Autophagy-related protein 20', NULL, NULL, NULL, NULL, NULL, 4),
(141343, NULL, 'G3DSA:3.40.50.1820:FF:001217', NULL, NULL, 'Lipase', NULL, NULL, NULL, NULL, NULL, 4),
(141344, NULL, 'G3DSA:3.50.30.20:FF:000009', NULL, NULL, 'CAD protein', NULL, NULL, NULL, NULL, NULL, 4),
(141345, NULL, 'G3DSA:1.10.10.10:FF:001995', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141346, NULL, 'G3DSA:3.30.160.60:FF:003016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141347, NULL, 'G3DSA:3.30.200.20:FF:000445', NULL, NULL, 'Receptor-like cytosolic serine/threonine-protein kinase RBK2', NULL, NULL, NULL, NULL, NULL, 4),
(141348, NULL, 'G3DSA:2.60.120.590:FF:000041', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(141349, NULL, 'G3DSA:3.40.950.10:FF:000024', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', NULL, NULL, NULL, NULL, NULL, 4),
(141350, NULL, 'G3DSA:3.40.50.2300:FF:001586', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141351, NULL, 'G3DSA:3.10.50.40:FF:000119', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(141352, NULL, 'G3DSA:1.10.555.10:FF:000120', NULL, NULL, 'Rho GTPase-activating protein gacN', NULL, NULL, NULL, NULL, NULL, 4),
(141353, NULL, 'G3DSA:3.40.50.2000:FF:000788', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141354, NULL, 'G3DSA:4.10.60.10:FF:000215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141355, NULL, 'G3DSA:3.40.50.300:FF:003516', NULL, NULL, 'Putative DNA polymerase III, delta prime subunit', NULL, NULL, NULL, NULL, NULL, 4),
(141356, NULL, 'G3DSA:1.25.10.10:FF:002682', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141357, NULL, 'G3DSA:1.25.50.20:FF:000085', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(141358, NULL, 'G3DSA:1.25.10.10:FF:002794', NULL, NULL, 'LOC443698 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141359, NULL, 'G3DSA:1.20.1050.10:FF:000091', NULL, NULL, 'Chloride intracellular channel exl-1', NULL, NULL, NULL, NULL, NULL, 4),
(141360, NULL, 'G3DSA:1.10.400.10:FF:000048', NULL, NULL, 'guanine nucleotide-binding protein G(K) subunit alpha-like', NULL, NULL, NULL, NULL, NULL, 4),
(141361, NULL, 'G3DSA:1.10.1200.270:FF:000007', NULL, NULL, 'Salicylate carboxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(141362, NULL, 'G3DSA:3.80.10.10:FF:004489', NULL, NULL, 'Leucine-rich repeat receptor-like tyrosine-protein kinase PXC3', NULL, NULL, NULL, NULL, NULL, 4),
(141363, NULL, 'G3DSA:1.20.920.50:FF:000001', NULL, NULL, 'Androgen-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(141364, NULL, 'G3DSA:3.90.1030.10:FF:000021', NULL, NULL, '50S ribosomal protein L17', NULL, NULL, NULL, NULL, NULL, 4),
(141365, NULL, 'G3DSA:2.40.50.140:FF:000105', NULL, NULL, 'Myeloid cell nuclear differentiation antigen', NULL, NULL, NULL, NULL, NULL, 4),
(141366, NULL, 'G3DSA:6.10.140.2150:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141367, NULL, 'G3DSA:3.30.360.110:FF:000001', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(141368, NULL, 'G3DSA:1.10.260.40:FF:000040', NULL, NULL, 'POU domain, class 6, transcription factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(141369, NULL, 'G3DSA:1.20.140.40:FF:000068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141370, NULL, 'G3DSA:3.40.50.150:FF:001184', NULL, NULL, 'CurJ', NULL, NULL, NULL, NULL, NULL, 4),
(141371, NULL, 'G3DSA:3.40.1190.20:FF:000041', NULL, NULL, 'Putative phosphomethylpyrimidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(141372, NULL, 'G3DSA:3.40.50.300:FF:003730', NULL, NULL, 'DEAH-box helicase 16', NULL, NULL, NULL, NULL, NULL, 4),
(141373, NULL, 'G3DSA:2.60.120.260:FF:000301', NULL, NULL, 'AGAP008739-PA', NULL, NULL, NULL, NULL, NULL, 4),
(141374, NULL, 'G3DSA:2.60.40.1860:FF:000005', NULL, NULL, 'Peptidyl arginine deiminase, type II', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(141375, NULL, 'G3DSA:3.40.50.300:FF:007092', NULL, NULL, 'Small GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141376, NULL, 'G3DSA:3.40.50.80:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141377, NULL, 'G3DSA:3.30.530.20:FF:000076', NULL, NULL, 'START domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(141378, NULL, 'G3DSA:3.30.40.10:FF:000811', NULL, NULL, 'RAD5p DNA helicase/Ubiquitin ligase', NULL, NULL, NULL, NULL, NULL, 4),
(141379, NULL, 'G3DSA:3.30.200.20:FF:000315', NULL, NULL, 'Calcium-dependent protein kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(141380, NULL, 'G3DSA:2.60.120.920:FF:000191', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(141381, NULL, 'G3DSA:3.40.50.300:FF:006052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141382, NULL, 'G3DSA:3.40.50.970:FF:000013', NULL, NULL, 'Pyruvate dehydrogenase E1 component subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(141383, NULL, 'G3DSA:2.60.120.260:FF:000077', NULL, NULL, 'Probable allantoicase', NULL, NULL, NULL, NULL, NULL, 4),
(141384, NULL, 'G3DSA:3.40.850.10:FF:000191', NULL, NULL, 'Bipolar kinesin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141385, NULL, 'G3DSA:1.25.40.10:FF:000463', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(141386, NULL, 'G3DSA:1.10.510.10:FF:001450', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(141387, NULL, 'G3DSA:2.60.120.620:FF:000089', NULL, NULL, 'Multifunctional dioxygenase ausE', NULL, NULL, NULL, NULL, NULL, 4),
(141388, NULL, 'G3DSA:1.10.3470.10:FF:000046', NULL, NULL, 'Manganese/zinc/iron transport system permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(141389, NULL, 'G3DSA:1.10.472.80:FF:000122', NULL, NULL, 'TBC1 domain family member 25', NULL, NULL, NULL, NULL, NULL, 4),
(141390, NULL, 'G3DSA:3.70.10.10:FF:000055', NULL, NULL, 'Cell cycle checkpoint control protein', NULL, NULL, NULL, NULL, NULL, 4),
(141391, NULL, 'G3DSA:3.30.230.10:FF:000365', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141392, NULL, 'G3DSA:1.10.510.10:FF:000814', NULL, NULL, 'PTI1-like tyrosine-protein kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(141393, NULL, 'G3DSA:2.60.120.650:FF:000115', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(141394, NULL, 'G3DSA:1.25.40.180:FF:000251', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141395, NULL, 'G3DSA:2.30.29.30:FF:001018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141396, NULL, 'G3DSA:2.130.10.10:FF:000470', NULL, NULL, 'Periodic tryptophan protein 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(141397, NULL, 'G3DSA:3.30.1360.70:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141398, NULL, 'G3DSA:2.20.100.10:FF:000081', NULL, NULL, 'Spondin-1', NULL, NULL, NULL, NULL, NULL, 4),
(141399, NULL, 'G3DSA:2.60.40.10:FF:000503', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(141400, NULL, 'G3DSA:3.30.70.330:FF:003099', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141401, NULL, 'G3DSA:2.130.10.10:FF:001667', NULL, NULL, 'Related to SOF1-involved in 18S pre-rRNA production', NULL, NULL, NULL, NULL, NULL, 4),
(141402, NULL, 'G3DSA:3.30.70.330:FF:002008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141403, NULL, 'G3DSA:3.10.20.90:FF:000947', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(141404, NULL, 'G3DSA:1.10.510.10:FF:002276', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141405, NULL, 'G3DSA:3.80.10.10:FF:004129', NULL, NULL, 'Tyrosine-sulfated glycopeptide receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(141406, NULL, 'G3DSA:2.120.10.30:FF:000083', NULL, NULL, 'Peptidyl-glycine alpha-amidating monooxygenase B', NULL, NULL, NULL, NULL, NULL, 4),
(141407, NULL, 'G3DSA:1.10.287.70:FF:000649', NULL, NULL, 'Potassium channel, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141408, NULL, 'G3DSA:1.10.2020.20:FF:000004', NULL, NULL, 'WGS project CABT00000000 data, contig 2.6', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(141409, NULL, 'G3DSA:3.40.50.300:FF:000745', NULL, NULL, 'Dynein cytoplasmic 2 heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(141410, NULL, 'G3DSA:1.10.20.10:FF:000299', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141411, NULL, 'G3DSA:3.30.70.1990:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141412, NULL, 'G3DSA:1.25.40.20:FF:001208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141413, NULL, 'G3DSA:2.30.39.10:FF:000097', NULL, NULL, 'AGAP006909-PA', NULL, NULL, NULL, NULL, NULL, 4),
(141414, NULL, 'G3DSA:3.30.540.10:FF:000012', NULL, NULL, 'Blast:Putative inositol monophosphatase 3', NULL, NULL, NULL, NULL, NULL, 4),
(141415, NULL, 'G3DSA:3.40.720.10:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141416, NULL, 'G3DSA:3.30.160.60:FF:001329', NULL, NULL, 'INSM transcriptional repressor 1', NULL, NULL, NULL, NULL, NULL, 4),
(141417, NULL, 'G3DSA:3.40.50.410:FF:000323', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(141418, NULL, 'G3DSA:1.20.58.60:FF:000490', NULL, NULL, 'Spectrin beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(141419, NULL, 'G3DSA:3.40.50.80:FF:000203', NULL, NULL, 'Ferric-chelate reductase/ oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(141420, NULL, 'G3DSA:2.30.180.10:FF:000139', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141421, NULL, 'G3DSA:3.10.290.70:FF:000003', NULL, NULL, '40S ribosomal protein S8', NULL, NULL, NULL, NULL, NULL, 4),
(141422, NULL, 'G3DSA:1.10.630.10:FF:000666', NULL, NULL, 'Os02g0502300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(141423, NULL, 'G3DSA:3.90.370.10:FF:000013', NULL, NULL, 'Tissue inhibitor of metalloproteinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141424, NULL, 'G3DSA:3.90.79.10:FF:000206', NULL, NULL, '39S mitochondrial ribosomal protein L46-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(141425, NULL, 'G3DSA:1.10.287.110:FF:000274', NULL, NULL, 'DnaJ domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(141426, NULL, 'G3DSA:3.60.21.10:FF:000305', NULL, NULL, 'Sphingomyelinase phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(141427, NULL, 'G3DSA:3.30.420.10:FF:000548', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141428, NULL, 'G3DSA:3.40.50.620:FF:000510', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141429, NULL, 'G3DSA:2.40.20.10:FF:000093', NULL, NULL, 'Putative macrophage stimulating 1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(141430, NULL, 'G3DSA:3.10.10.10:FF:000001', NULL, NULL, 'Gag-Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(141431, NULL, 'G3DSA:2.60.120.20:FF:000003', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(141432, NULL, 'G3DSA:3.40.50.300:FF:006389', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(141433, NULL, 'G3DSA:3.90.70.10:FF:000237', NULL, NULL, 'Dipeptidyl aminopeptidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(141434, NULL, 'G3DSA:3.30.830.10:FF:000231', NULL, NULL, 'Protease of the insulinase family', NULL, NULL, NULL, NULL, NULL, 4),
(141435, NULL, 'G3DSA:3.40.50.620:FF:000740', NULL, NULL, 'Universal stress protein A family protein C25B2.10', NULL, NULL, NULL, NULL, NULL, 4),
(141436, NULL, 'G3DSA:1.20.1730.10:FF:000002', NULL, NULL, 'Sodium/proline symporter', NULL, NULL, NULL, NULL, NULL, 4),
(141437, NULL, 'G3DSA:3.30.450.40:FF:000244', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(141438, NULL, 'G3DSA:3.40.50.2300:FF:000760', NULL, NULL, 'Glutamate receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(141439, NULL, 'G3DSA:3.90.180.10:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141440, NULL, 'G3DSA:1.10.10.10:FF:001091', NULL, NULL, 'Biofilm growth-associated repressor', NULL, NULL, NULL, NULL, NULL, 4),
(141441, NULL, 'G3DSA:3.30.930.10:FF:000278', NULL, NULL, 'Si:ch211-256m1.8', NULL, NULL, NULL, NULL, NULL, 4),
(141442, NULL, 'G3DSA:2.60.40.10:FF:004657', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(141443, NULL, 'G3DSA:3.40.50.1820:FF:000020', NULL, NULL, 'Lysophospholipase L2', NULL, NULL, NULL, NULL, NULL, 4),
(141444, NULL, 'G3DSA:1.25.10.10:FF:002108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141445, NULL, 'G3DSA:3.30.70.330:FF:002368', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141446, NULL, 'G3DSA:3.40.50.1820:FF:001791', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141447, NULL, 'G3DSA:2.40.50.140:FF:000095', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(141448, NULL, 'G3DSA:2.60.120.260:FF:000526', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141449, NULL, 'G3DSA:3.30.870.30:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141450, NULL, 'G3DSA:1.10.1580.10:FF:000020', NULL, NULL, 'GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141451, NULL, 'G3DSA:3.50.50.60:FF:000236', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(141452, NULL, 'G3DSA:1.20.58.390:FF:000019', NULL, NULL, 'Gamma-aminobutyric acid (GABA) A receptor, pi', NULL, NULL, NULL, NULL, NULL, 4),
(141453, NULL, 'G3DSA:1.20.1250.20:FF:001047', NULL, NULL, 'Riboflavin transporter RibJ', NULL, NULL, NULL, NULL, NULL, 4),
(141454, NULL, 'G3DSA:2.130.10.10:FF:000695', NULL, NULL, 'Lactonase, 7-bladed beta-propeller domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(141455, NULL, 'G3DSA:1.10.1410.40:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141456, NULL, 'G3DSA:3.10.20.90:FF:000964', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141457, NULL, 'G3DSA:1.25.40.10:FF:002380', NULL, NULL, 'Protein O-mannosyl-transferase TMTC2', NULL, NULL, NULL, NULL, NULL, 4),
(141458, NULL, 'G3DSA:3.10.180.10:FF:000039', NULL, NULL, 'Trihydroxytoluene oxygenase (AFU_orthologue AFUA_8G02470)', NULL, NULL, NULL, NULL, NULL, 4),
(141459, NULL, 'G3DSA:1.25.10.10:FF:000214', NULL, NULL, 'MAP3K epsilon protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(141460, NULL, 'G3DSA:3.30.40.10:FF:001637', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141461, NULL, 'G3DSA:2.120.10.80:FF:000087', NULL, NULL, 'Kelch repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(141462, NULL, 'G3DSA:3.30.160.60:FF:004426', NULL, NULL, 'CTCF', NULL, NULL, NULL, NULL, NULL, 4),
(141463, NULL, 'G3DSA:1.25.40.20:FF:000483', NULL, NULL, 'Ankyrin repeats (3 copies), putative', NULL, NULL, NULL, NULL, NULL, 4),
(141464, NULL, 'G3DSA:1.10.10.10:FF:000585', NULL, NULL, 'Response regulator receiver domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(141465, NULL, 'G3DSA:2.60.40.420:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141466, NULL, 'G3DSA:2.160.20.70:FF:000032', NULL, NULL, 'Probable septum site-determining protein MinC', NULL, NULL, NULL, NULL, NULL, 4),
(141467, NULL, 'G3DSA:3.30.710.10:FF:000312', NULL, NULL, 'BTB and MATH domain-containing protein 42', NULL, NULL, NULL, NULL, NULL, 4),
(141468, NULL, 'G3DSA:2.20.100.10:FF:000204', NULL, NULL, 'Complement factor properdin', NULL, NULL, NULL, NULL, NULL, 4),
(141469, NULL, 'G3DSA:2.130.10.10:FF:001307', NULL, NULL, 'elongator complex protein 2 isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(141470, NULL, 'G3DSA:3.40.50.1000:FF:000555', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141471, NULL, 'G3DSA:3.90.780.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141472, NULL, 'G3DSA:1.10.630.10:FF:000306', NULL, NULL, 'CYtochrome P450 family', NULL, NULL, NULL, NULL, NULL, 4),
(141473, NULL, 'G3DSA:3.40.50.720:FF:000652', NULL, NULL, 'Chromosome 12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(141474, NULL, 'G3DSA:1.20.1260.10:FF:000027', NULL, NULL, 'Ring oxydation complex/ phenylacetic acid degradation', NULL, NULL, NULL, NULL, NULL, 4),
(141475, NULL, 'G3DSA:2.130.10.10:FF:003112', NULL, NULL, 'Flagellar/basal body protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(141476, NULL, 'G3DSA:2.60.120.920:FF:000089', NULL, NULL, 'Dual specificity protein kinase splA', NULL, NULL, NULL, NULL, NULL, 4),
(141477, NULL, 'G3DSA:2.10.220.10:FF:000064', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(141478, NULL, 'G3DSA:3.40.50.300:FF:002218', NULL, NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', NULL, NULL, NULL, NULL, NULL, 4),
(141479, NULL, 'G3DSA:3.40.1370.10:FF:000035', NULL, NULL, '50S ribosomal protein L4', NULL, NULL, NULL, NULL, NULL, 4),
(141480, NULL, 'G3DSA:3.10.490.10:FF:000012', NULL, NULL, 'AIG2-like (Avirulence induced gene) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(141481, NULL, 'G3DSA:1.10.150.20:FF:000172', NULL, NULL, 'Meiotic recombination protein (Dmc1), putative (AFU_orthologue AFUA_7G02200)', NULL, NULL, NULL, NULL, NULL, 4),
(141482, NULL, 'G3DSA:3.90.110.10:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141483, NULL, 'G3DSA:2.60.40.10:FF:000475', NULL, NULL, 'myelin-associated glycoprotein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(141484, NULL, 'G3DSA:3.20.20.80:FF:000657', NULL, NULL, 'Beta-mannosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141485, NULL, 'G3DSA:3.30.160.60:FF:001088', NULL, NULL, 'Zinc finger protein 628', NULL, NULL, NULL, NULL, NULL, 4),
(141486, NULL, 'G3DSA:3.30.160.60:FF:005371', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141487, NULL, 'G3DSA:3.40.50.12240:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141488, NULL, 'G3DSA:3.40.718.10:FF:000030', NULL, NULL, 'Isocitrate dehydrogenase [NADP]', NULL, NULL, NULL, NULL, NULL, 4),
(141489, NULL, 'G3DSA:3.30.360.10:FF:000026', NULL, NULL, 'Putative aspartate-semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(141490, NULL, 'G3DSA:3.40.50.1820:FF:000149', NULL, NULL, 'Alpha/beta hydrolase fold', NULL, NULL, NULL, NULL, NULL, 4),
(141491, NULL, 'G3DSA:2.110.10.10:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141492, NULL, 'G3DSA:3.40.50.720:FF:001271', NULL, NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141493, NULL, 'G3DSA:1.20.1560.10:FF:000202', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(141494, NULL, 'G3DSA:3.40.50.300:FF:003067', NULL, NULL, 'Dephospho-CoA kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141495, NULL, 'G3DSA:3.10.129.10:FF:000246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141496, NULL, 'G3DSA:4.10.1000.10:FF:000020', NULL, NULL, 'Translation machinery-associated protein 46', NULL, NULL, NULL, NULL, NULL, 4),
(141497, NULL, 'G3DSA:2.130.10.10:FF:004281', NULL, NULL, 'Zgc:162420 protein', NULL, NULL, NULL, NULL, NULL, 4),
(141498, NULL, 'G3DSA:3.30.1380.20:FF:000030', NULL, NULL, 'Trafficking protein particle complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(141499, NULL, 'G3DSA:3.30.40.10:FF:001188', NULL, NULL, 'RING finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(141500, NULL, 'G3DSA:1.10.1410.20:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(141501, NULL, 'G3DSA:3.40.50.300:FF:005984', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(141502, NULL, 'G3DSA:1.20.1390.10:FF:000014', NULL, NULL, 'Putative cyclin-dependent protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(141503, NULL, 'G3DSA:1.10.3730.20:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141504, NULL, 'G3DSA:1.20.58.60:FF:000260', NULL, NULL, 'Kakapo', NULL, NULL, NULL, NULL, NULL, 4),
(141505, NULL, 'G3DSA:2.10.25.10:FF:001049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141506, NULL, 'G3DSA:1.20.1070.10:FF:000086', NULL, NULL, 'Dopamine D2 receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(141507, NULL, 'G3DSA:1.10.1900.40:FF:000004', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(141508, NULL, 'G3DSA:2.30.30.190:FF:000023', NULL, NULL, 'Nip100p', NULL, NULL, NULL, NULL, NULL, 4),
(141509, NULL, 'G3DSA:2.60.40.60:FF:000248', NULL, NULL, 'Protocadherin 10', NULL, NULL, NULL, NULL, NULL, 4),
(141510, NULL, 'G3DSA:3.40.50.300:FF:003163', NULL, NULL, 'Miro family protein', NULL, NULL, NULL, NULL, NULL, 4),
(141511, NULL, 'G3DSA:2.60.40.150:FF:000731', NULL, NULL, 'Calpain-5', NULL, NULL, NULL, NULL, NULL, 4),
(141512, NULL, 'G3DSA:2.60.40.340:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141513, NULL, 'G3DSA:3.40.190.10:FF:000044', NULL, NULL, 'Chorismate mutase/prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(141514, NULL, 'G3DSA:3.40.50.720:FF:001933', NULL, NULL, 'Nadh-ubiquinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(141515, NULL, 'G3DSA:2.130.10.10:FF:005933', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(141516, NULL, 'G3DSA:3.40.50.1100:FF:000046', NULL, NULL, 'THR4p Threonine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(141517, NULL, 'G3DSA:3.40.50.12650:FF:000014', NULL, NULL, 'DNA repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(141518, NULL, 'G3DSA:3.40.50.300:FF:008390', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(141519, NULL, 'G3DSA:2.40.70.10:FF:000045', NULL, NULL, 'Basic 7S globulin', NULL, NULL, NULL, NULL, NULL, 4),
(141520, NULL, 'G3DSA:3.40.350.10:FF:000046', NULL, NULL, 'Xaa-pro aminopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141521, NULL, 'G3DSA:3.90.76.10:FF:000060', NULL, NULL, 'Putative bifunctional protein [include methyl-accepting chemotaxis protein and an extracellular solute-binding protein]', NULL, NULL, NULL, NULL, NULL, 4),
(141522, NULL, 'G3DSA:3.90.190.10:FF:000027', NULL, NULL, 'Protein tyrosine phosphatase domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(141523, NULL, 'G3DSA:3.40.50.10440:FF:000003', NULL, NULL, 'Homodimeric dihydroxyacetone kinase', NULL, NULL, NULL, NULL, NULL, 4),
(141524, NULL, 'G3DSA:3.40.80.10:FF:000021', NULL, NULL, 'Putative N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(141525, NULL, 'G3DSA:2.40.70.10:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141526, NULL, 'G3DSA:3.90.550.10:FF:000241', NULL, NULL, 'Uncharacterized glycosyltransferase MT1564', NULL, NULL, NULL, NULL, NULL, 4),
(141527, NULL, 'G3DSA:1.25.40.10:FF:002279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141528, NULL, 'G3DSA:1.25.40.10:FF:000042', NULL, NULL, 'C-myc promoter-binding protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(141529, NULL, 'G3DSA:3.30.559.30:FF:000050', NULL, NULL, 'Nonribosomal peptide synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(141530, NULL, 'G3DSA:1.20.140.150:FF:000052', NULL, NULL, 'Sur7p', NULL, NULL, NULL, NULL, NULL, 4),
(141531, NULL, 'G3DSA:2.40.110.10:FF:000037', NULL, NULL, 'Acyl-CoA dehydrogenase FadE28', NULL, NULL, NULL, NULL, NULL, 4),
(141532, NULL, 'G3DSA:2.30.29.30:FF:000613', NULL, NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', NULL, NULL, NULL, NULL, NULL, 4),
(141533, NULL, 'G3DSA:3.30.160.60:FF:000262', NULL, NULL, 'PR domain zinc finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(141534, NULL, 'G3DSA:4.10.365.10:FF:000009', NULL, NULL, 'Cyclin-dependent kinase inhibitor 1A', NULL, NULL, NULL, NULL, NULL, 4),
(141535, NULL, 'G3DSA:2.20.25.90:FF:000016', NULL, NULL, 'Acetylene hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(141536, NULL, 'G3DSA:3.10.20.90:FF:000508', NULL, NULL, 'GM11836', NULL, NULL, NULL, NULL, NULL, 4),
(141537, NULL, 'G3DSA:2.10.70.10:FF:000075', NULL, NULL, 'Complement component C7', NULL, NULL, NULL, NULL, NULL, 4),
(141538, NULL, 'G3DSA:1.10.510.10:FF:002731', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141539, NULL, 'G3DSA:4.10.40.30:FF:000001', NULL, NULL, 'Cocaine-and amphetamine-regulated transcript protein', NULL, NULL, NULL, NULL, NULL, 4),
(141540, NULL, 'G3DSA:1.20.120.1910:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(141541, NULL, 'G3DSA:1.10.8.270:FF:000020', NULL, NULL, 'Putative TBC1 domain family member 25', NULL, NULL, NULL, NULL, NULL, 4),
(141542, NULL, 'G3DSA:1.10.287.770:FF:000005', NULL, NULL, 'Amiloride-sensitive sodium channel subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(141543, NULL, 'G3DSA:2.60.40.10:FF:001094', NULL, NULL, 'Cell surface glycoprotein MUC18', NULL, NULL, NULL, NULL, NULL, 4),
(141544, NULL, 'G3DSA:3.40.50.800:FF:000120', NULL, NULL, 'Glycyl tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(141545, NULL, 'G3DSA:2.130.10.10:FF:000239', NULL, NULL, 'DNA damage-binding protein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(141546, NULL, 'G3DSA:3.30.2020.30:FF:000012', NULL, NULL, 'Gamma-butyrobetaine hydroxylase subfamily, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141547, NULL, 'G3DSA:1.20.1280.20:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141548, NULL, 'G3DSA:3.40.50.300:FF:006473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141549, NULL, 'G3DSA:3.40.50.300:FF:001038', NULL, NULL, 'ABC transporter B family member 25', NULL, NULL, NULL, NULL, NULL, 4),
(141550, NULL, 'G3DSA:3.40.50.1460:FF:000120', NULL, NULL, 'Caspase, apoptotic cysteine protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141551, NULL, 'G3DSA:2.160.20.10:FF:000250', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(141552, NULL, 'G3DSA:3.40.630.30:FF:000539', NULL, NULL, 'Glycylpeptide N-tetradecanoyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(141553, NULL, 'G3DSA:1.10.510.10:FF:000831', NULL, NULL, 'cyclin-dependent kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(141554, NULL, 'G3DSA:3.90.1140.10:FF:000006', NULL, NULL, 'U6 snRNA phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(141555, NULL, 'G3DSA:3.40.50.140:FF:000006', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(141556, NULL, 'G3DSA:3.30.40.10:FF:002256', NULL, NULL, 'Nuclear receptor binding SET domain protein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(141557, NULL, 'G3DSA:3.40.30.10:FF:000310', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(141558, NULL, 'G3DSA:3.40.50.80:FF:000175', NULL, NULL, 'NADPH-dependent diflavin oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(141559, NULL, 'G3DSA:3.90.226.10:FF:000095', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(141560, NULL, 'G3DSA:3.20.20.390:FF:000001', NULL, NULL, 'Heptaprenylglyceryl phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(141561, NULL, 'G3DSA:2.120.10.30:FF:000206', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(141562, NULL, 'G3DSA:2.40.30.270:FF:000034', NULL, NULL, 'DNA replication ATP-dependent helicase/nuclease dna2', NULL, NULL, NULL, NULL, NULL, 4),
(141563, NULL, 'G3DSA:3.30.1490.20:FF:000021', NULL, NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(141564, NULL, 'G3DSA:3.90.1180.10:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141565, NULL, 'G3DSA:2.60.40.770:FF:000029', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(141566, NULL, 'G3DSA:3.30.1360.40:FF:000023', NULL, NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(141567, NULL, 'G3DSA:3.30.160.110:FF:000001', NULL, NULL, 'Siroheme synthase', NULL, NULL, NULL, NULL, NULL, 4),
(141568, NULL, 'G3DSA:3.30.450.20:FF:000137', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(141569, NULL, 'G3DSA:3.40.50.11500:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141570, NULL, 'G3DSA:3.40.1190.10:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141571, NULL, 'G3DSA:1.10.10.480:FF:000002', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(141572, NULL, 'G3DSA:1.10.620.20:FF:000028', NULL, NULL, 'Acyl-[acyl-carrier-protein] desaturase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(141573, NULL, 'G3DSA:3.30.420.40:FF:000175', NULL, NULL, 'Chromatin remodeling and histone acetyltransferase complexes subunit', NULL, NULL, NULL, NULL, NULL, 4),
(141574, NULL, 'G3DSA:1.10.150.340:FF:000001', NULL, NULL, 'Cytosolic 5-nucleotidase 3-like', NULL, NULL, NULL, NULL, NULL, 4),
(141575, NULL, 'G3DSA:3.80.10.10:FF:001375', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141576, NULL, 'G3DSA:1.10.510.10:FF:001219', NULL, NULL, 'serine/threonine-protein kinase greatwall isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(141577, NULL, 'G3DSA:3.30.420.10:FF:000099', NULL, NULL, 'ERI1 exoribonuclease 3 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(141578, NULL, 'G3DSA:1.20.59.10:FF:000016', NULL, NULL, 'Prephenate dehydratase / chorismate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(141579, NULL, 'G3DSA:1.25.40.10:FF:003459', NULL, NULL, 'Os07g0635800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(141580, NULL, 'G3DSA:3.40.50.1820:FF:001329', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(141581, NULL, 'G3DSA:1.10.1020.10:FF:000001', NULL, NULL, 'Site-specific DNA-methyltransferase (adenine-specific)', NULL, NULL, NULL, NULL, NULL, 4),
(141582, NULL, 'G3DSA:1.10.630.10:FF:000649', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141583, NULL, 'G3DSA:3.30.565.10:FF:000013', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(141584, NULL, 'G3DSA:3.30.70.330:FF:000665', NULL, NULL, 'Polyadenylate-binding protein-interacting protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(141585, NULL, 'G3DSA:1.10.420.10:FF:000032', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(141586, NULL, 'G3DSA:2.20.25.20:FF:000006', NULL, NULL, 'F-box only protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(141587, NULL, 'G3DSA:3.30.780.10:FF:000018', NULL, NULL, 'Translation machinery-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(141588, NULL, 'G3DSA:1.10.730.20:FF:000019', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(141589, NULL, 'G3DSA:1.25.10.10:FF:000877', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(141590, NULL, 'G3DSA:1.10.30.10:FF:000125', NULL, NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily E member 1', NULL, NULL, NULL, NULL, NULL, 4),
(141591, NULL, 'G3DSA:2.60.120.10:FF:000567', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(141592, NULL, 'G3DSA:3.40.50.720:FF:000091', NULL, NULL, 'Sorbitol-6-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(141593, NULL, 'G3DSA:3.30.70.1230:FF:000020', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(141594, NULL, 'G3DSA:2.60.200.40:FF:000032', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(141595, NULL, 'G3DSA:1.10.10.60:FF:000684', NULL, NULL, 'Homeodomain-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(141596, NULL, 'G3DSA:3.20.20.70:FF:000637', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141597, NULL, 'G3DSA:2.30.42.10:FF:000127', NULL, NULL, 'Pro-interleukin-16', NULL, NULL, NULL, NULL, NULL, 4),
(141598, NULL, 'G3DSA:3.80.20.20:FF:000024', NULL, NULL, 'Erb-b2 receptor tyrosine kinase 3b', NULL, NULL, NULL, NULL, NULL, 4),
(141599, NULL, 'G3DSA:3.40.50.1820:FF:000812', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(141600, NULL, 'G3DSA:3.30.420.150:FF:000022', NULL, NULL, 'Ppx/GppA phosphatase family-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(141601, NULL, 'G3DSA:1.10.10.10:FF:000242', NULL, NULL, 'E3 ubiquitin-protein ligase SHPRH isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(141602, NULL, 'G3DSA:3.100.10.10:FF:000063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141603, NULL, 'G3DSA:2.130.10.10:FF:001184', NULL, NULL, 'Unplaced genomic scaffold supercont2.6, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(141604, NULL, 'G3DSA:2.60.120.620:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(141605, NULL, 'G3DSA:3.30.160.60:FF:003246', NULL, NULL, 'paternally-expressed gene 3 protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(141606, NULL, 'G3DSA:3.20.20.80:FF:000174', NULL, NULL, 'YIR007W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(141607, NULL, 'G3DSA:2.60.40.420:FF:000155', NULL, NULL, 'Protein CBG16448', NULL, NULL, NULL, NULL, NULL, 4),
(141608, NULL, 'G3DSA:2.30.29.30:FF:000046', NULL, NULL, 'FERM, RhoGEF and pleckstrin domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(141609, NULL, 'G3DSA:1.20.1740.10:FF:000188', NULL, NULL, 'Amino acid transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141610, NULL, 'G3DSA:2.40.30.10:FF:000150', NULL, NULL, 'NADH-cytochrome b5 reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141611, NULL, 'G3DSA:3.40.50.1700:FF:000001', NULL, NULL, 'probable beta-D-xylosidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(141612, NULL, 'G3DSA:3.40.50.2300:FF:000193', NULL, NULL, 'Glutamate receptor ionotropic, NMDA 2B', NULL, NULL, NULL, NULL, NULL, 4),
(141613, NULL, 'G3DSA:1.10.10.60:FF:000228', NULL, NULL, 'Myb-related protein 308', NULL, NULL, NULL, NULL, NULL, 4),
(141614, NULL, 'G3DSA:2.60.40.150:FF:000068', NULL, NULL, 'multiple C2 and transmembrane domain-containing protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(141615, NULL, 'G3DSA:2.60.120.200:FF:000778', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(141616, NULL, 'G3DSA:3.40.50.720:FF:002552', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141617, NULL, 'G3DSA:2.60.120.260:FF:000638', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141618, NULL, 'G3DSA:1.10.150.20:FF:000284', NULL, NULL, 'Meiotic recombination protein DMC1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(141619, NULL, 'G3DSA:2.70.50.60:FF:000001', NULL, NULL, 'Sugar ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(141620, NULL, 'G3DSA:1.10.1900.10:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141621, NULL, 'G3DSA:1.10.238.10:FF:001283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141622, NULL, 'G3DSA:3.30.460.10:FF:000202', NULL, NULL, 'Poly(A) RNA polymerase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(141623, NULL, 'G3DSA:3.30.160.60:FF:006214', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141624, NULL, 'G3DSA:1.25.40.10:FF:003791', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141625, NULL, 'G3DSA:3.90.70.10:FF:000125', NULL, NULL, 'Ubiquitin C-terminal hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141626, NULL, 'G3DSA:2.160.20.10:FF:000042', NULL, NULL, 'Glycoside hydrolase family 28 protein', NULL, NULL, NULL, NULL, NULL, 4),
(141627, NULL, 'G3DSA:3.10.20.30:FF:000053', NULL, NULL, 'Molybdopterin synthase sulfur carrier subunit', NULL, NULL, NULL, NULL, NULL, 4),
(141628, NULL, 'G3DSA:3.40.50.1820:FF:001661', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(141629, NULL, 'G3DSA:1.20.1420.30:FF:000018', NULL, NULL, 'Sodium/potassium/calcium exchanger 2', NULL, NULL, NULL, NULL, NULL, 4),
(141630, NULL, 'G3DSA:3.40.50.10890:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141631, NULL, 'G3DSA:1.50.40.10:FF:000399', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141632, NULL, 'G3DSA:3.30.70.330:FF:001750', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141633, NULL, 'G3DSA:1.10.8.60:FF:000368', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141634, NULL, 'G3DSA:3.30.230.10:FF:000382', NULL, NULL, 'Mevalonate 3-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(141635, NULL, 'G3DSA:2.60.40.790:FF:000136', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141636, NULL, 'G3DSA:2.30.42.10:FF:000571', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141637, NULL, 'G3DSA:3.30.470.20:FF:000133', NULL, NULL, 'Probable tubulin--tyrosine ligase C12B10.04', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(141638, NULL, 'G3DSA:1.20.1280.50:FF:000254', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(141639, NULL, 'G3DSA:3.40.50.300:FF:003859', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(141640, NULL, 'G3DSA:1.25.40.20:FF:001652', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141641, NULL, 'G3DSA:3.40.50.1240:FF:000077', NULL, NULL, 'Glucosyl-3-phosphoglycerate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(141642, NULL, 'G3DSA:3.40.50.10810:FF:000136', NULL, NULL, 'SNF2 family N-terminal domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(141643, NULL, 'G3DSA:3.30.9.10:FF:000278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141644, NULL, 'G3DSA:1.20.1560.10:FF:000174', NULL, NULL, 'multidrug resistance protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(141645, NULL, 'G3DSA:1.50.10.10:FF:000010', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(141646, NULL, 'G3DSA:1.10.510.10:FF:000270', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(141647, NULL, 'G3DSA:2.20.28.10:FF:000044', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(141648, NULL, 'G3DSA:3.30.70.330:FF:000114', NULL, NULL, 'RNA-binding protein 10 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(141649, NULL, 'G3DSA:1.20.1420.10:FF:000012', NULL, NULL, 'Rhea, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(141650, NULL, 'G3DSA:2.60.40.10:FF:002403', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141651, NULL, 'G3DSA:2.40.50.140:FF:000448', NULL, NULL, 'rRNA biogenesis protein RRP5', NULL, NULL, NULL, NULL, NULL, 4),
(141652, NULL, 'G3DSA:3.20.20.70:FF:000188', NULL, NULL, 'Mycofactocin radical SAM maturase MftC', NULL, NULL, NULL, NULL, NULL, 4),
(141653, NULL, 'G3DSA:3.40.50.1000:FF:000342', NULL, NULL, 'Putative hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(141654, NULL, 'G3DSA:3.40.850.10:FF:000409', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(141655, NULL, 'G3DSA:3.60.21.10:FF:000176', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(141656, NULL, 'G3DSA:3.40.50.1220:FF:000071', NULL, NULL, 'Putative pyruvate/indole-pyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(141657, NULL, 'G3DSA:1.20.1070.10:FF:000114', NULL, NULL, 'Growth hormone releasing hormone receptor', NULL, NULL, NULL, NULL, NULL, 4),
(141658, NULL, 'G3DSA:2.60.120.10:FF:000112', NULL, NULL, 'Mannose-6-phosphate isomerase, class I', NULL, NULL, NULL, NULL, NULL, 4),
(141659, NULL, 'G3DSA:3.30.160.60:FF:004977', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141660, NULL, 'G3DSA:1.25.40.10:FF:001222', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(141661, NULL, 'G3DSA:1.10.565.10:FF:000177', NULL, NULL, 'Nuclear receptor subfamily 5, group A, member 1a', NULL, NULL, NULL, NULL, NULL, 4),
(141662, NULL, 'G3DSA:2.20.25.530:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141663, NULL, 'G3DSA:3.80.10.10:FF:000886', NULL, NULL, 'Leucine-rich Repeats (LRR) and Calponin Homology (CH) domain homolog', NULL, NULL, NULL, NULL, NULL, 4),
(141664, NULL, 'G3DSA:3.30.50.10:FF:000172', NULL, NULL, 'Protein CBG01321', NULL, NULL, NULL, NULL, NULL, 4),
(141665, NULL, 'G3DSA:1.10.3210.10:FF:000061', NULL, NULL, 'Metal dependent phosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(141666, NULL, 'G3DSA:3.30.160.60:FF:004657', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141667, NULL, 'G3DSA:3.30.450.40:FF:000031', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(141668, NULL, 'G3DSA:2.20.70.10:FF:000226', NULL, NULL, 'WW domain-containing protein A', NULL, NULL, NULL, NULL, NULL, 4),
(141669, NULL, 'G3DSA:2.170.150.20:FF:000006', NULL, NULL, 'Peptide-methionine (R)-S-oxide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(141670, NULL, 'G3DSA:3.40.630.10:FF:000096', NULL, NULL, 'M18 aspartyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(141671, NULL, 'G3DSA:1.20.1280.290:FF:000076', NULL, NULL, 'Sugar transporter SWEET', NULL, NULL, NULL, NULL, NULL, 4),
(141672, NULL, 'G3DSA:1.25.10.10:FF:003171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141673, NULL, 'G3DSA:1.20.920.30:FF:000006', NULL, NULL, 'Cytoplasmic dynein 2 heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(141674, NULL, 'G3DSA:2.120.10.10:FF:000004', NULL, NULL, 'Hemagglutinin-neuraminidase', NULL, NULL, NULL, NULL, NULL, 4),
(141675, NULL, 'G3DSA:1.20.144.10:FF:000068', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(141676, NULL, 'G3DSA:1.20.1070.10:FF:000215', NULL, NULL, 'G protein-coupled receptor 151', NULL, NULL, NULL, NULL, NULL, 4),
(141677, NULL, 'G3DSA:3.80.10.10:FF:003972', NULL, NULL, 'Si:dkey-286j17.4', NULL, NULL, NULL, NULL, NULL, 4),
(141678, NULL, 'G3DSA:3.30.200.20:FF:002440', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(141679, NULL, 'G3DSA:3.40.50.300:FF:001830', NULL, NULL, 'Cytidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(141680, NULL, 'G3DSA:3.40.50.2000:FF:000760', NULL, NULL, 'Glycosyltransferase (Type 1)', NULL, NULL, NULL, NULL, NULL, 4),
(141681, NULL, 'G3DSA:2.120.10.30:FF:000437', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141682, NULL, 'G3DSA:3.30.40.10:FF:001767', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141683, NULL, 'G3DSA:3.40.1350.10:FF:000039', NULL, NULL, 'Gut-2', NULL, NULL, NULL, NULL, NULL, 4),
(141684, NULL, 'G3DSA:2.60.40.150:FF:000170', NULL, NULL, 'Protein CELLULOSE SYNTHASE INTERACTIVE 1', NULL, NULL, NULL, NULL, NULL, 4),
(141685, NULL, 'G3DSA:3.40.50.2300:FF:000316', NULL, NULL, 'Two-component response regulator-like APRR1', NULL, NULL, NULL, NULL, NULL, 4),
(141686, NULL, 'G3DSA:1.20.1070.10:FF:001625', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141687, NULL, 'G3DSA:3.30.420.40:FF:000203', NULL, NULL, 'Actin-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(141688, NULL, 'G3DSA:2.130.10.30:FF:000133', NULL, NULL, 'ABR238Wp', NULL, NULL, NULL, NULL, NULL, 4),
(141689, NULL, 'G3DSA:3.30.420.140:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141690, NULL, 'G3DSA:2.60.40.10:FF:000846', NULL, NULL, 'Hyaluronan and proteoglycan link protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(141691, NULL, 'G3DSA:1.20.1050.10:FF:000101', NULL, NULL, 'Glutathione S-transferase Mu 4', NULL, NULL, NULL, NULL, NULL, 4),
(141692, NULL, 'G3DSA:2.70.50.80:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141693, NULL, 'G3DSA:3.40.30.10:FF:001058', NULL, NULL, 'Peroxiredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(141694, NULL, 'G3DSA:1.25.40.20:FF:001551', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141695, NULL, 'G3DSA:3.30.70.270:FF:000074', NULL, NULL, 'Diguanylate cyclase DosC', NULL, NULL, NULL, NULL, NULL, 4),
(141696, NULL, 'G3DSA:2.40.10.120:FF:000018', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(141697, NULL, 'G3DSA:3.30.430.20:FF:000012', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 25', NULL, NULL, NULL, NULL, NULL, 4),
(141698, NULL, 'G3DSA:3.10.20.90:FF:000593', NULL, NULL, 'Zgc:158659', NULL, NULL, NULL, NULL, NULL, 4),
(141699, NULL, 'G3DSA:3.80.10.10:FF:001824', NULL, NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g53440', NULL, NULL, NULL, NULL, NULL, 4),
(141700, NULL, 'G3DSA:3.30.230.70:FF:000017', NULL, NULL, 'Exosome complex component Rrp42', NULL, NULL, NULL, NULL, NULL, 4),
(141701, NULL, 'G3DSA:3.30.160.60:FF:004882', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141702, NULL, 'G3DSA:3.30.160.60:FF:003454', NULL, NULL, 'zinc finger protein 473 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(141703, NULL, 'G3DSA:2.130.10.10:FF:000127', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(141704, NULL, 'G3DSA:2.60.40.10:FF:005837', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(141705, NULL, 'G3DSA:2.130.10.10:FF:004410', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141706, NULL, 'G3DSA:3.40.50.720:FF:001484', NULL, NULL, 'uncharacterized protein LOC100179743', NULL, NULL, NULL, NULL, NULL, 4),
(141707, NULL, 'G3DSA:1.25.10.10:FF:002552', NULL, NULL, 'Os11g0638900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(141708, NULL, 'G3DSA:1.10.8.270:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141709, NULL, 'G3DSA:3.60.20.10:FF:000090', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(141710, NULL, 'G3DSA:3.40.630.10:FF:000421', NULL, NULL, 'Carboxypeptidase A', NULL, NULL, NULL, NULL, NULL, 4),
(141711, NULL, 'G3DSA:3.40.50.150:FF:000127', NULL, NULL, 'mRNA cap guanine-N7 methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(141712, NULL, 'G3DSA:2.60.40.2030:FF:000057', NULL, NULL, 'Extracellular nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(141713, NULL, 'G3DSA:3.80.10.10:FF:000206', NULL, NULL, 'leucine-rich repeat-containing protein 40', NULL, NULL, NULL, NULL, NULL, 4),
(141714, NULL, 'G3DSA:2.40.50.100:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141715, NULL, 'G3DSA:2.60.120.10:FF:000798', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141716, NULL, 'G3DSA:1.20.1250.20:FF:001614', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141717, NULL, 'G3DSA:3.40.1110.10:FF:000033', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(141718, NULL, 'G3DSA:3.30.230.10:FF:000157', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(141719, NULL, 'G3DSA:2.70.130.10:FF:000015', NULL, NULL, 'Insulin-like growth factor 2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(141720, NULL, 'G3DSA:3.30.70.100:FF:000175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141721, NULL, 'G3DSA:3.90.480.20:FF:000007', NULL, NULL, 'Ferredoxin--nitrite reductase', NULL, NULL, NULL, NULL, NULL, 4),
(141722, NULL, 'G3DSA:3.40.50.2000:FF:000333', NULL, NULL, 'GM14531', NULL, NULL, NULL, NULL, NULL, 4),
(141723, NULL, 'G3DSA:3.40.47.10:FF:000192', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase II', NULL, NULL, NULL, NULL, NULL, 4),
(141724, NULL, 'G3DSA:1.20.810.10:FF:000026', NULL, NULL, 'Cytochrome b/b6', NULL, NULL, NULL, NULL, NULL, 4),
(141725, NULL, 'G3DSA:1.10.10.10:FF:001310', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(141726, NULL, 'G3DSA:3.30.1640.10:FF:000064', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(141727, NULL, 'G3DSA:1.25.40.730:FF:000017', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(141728, NULL, 'G3DSA:1.20.272.10:FF:000011', NULL, NULL, 'Replication factor C subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(141729, NULL, 'G3DSA:3.40.630.30:FF:000427', NULL, NULL, 'Acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141730, NULL, 'G3DSA:3.40.50.2300:FF:001474', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141731, NULL, 'G3DSA:3.30.200.20:FF:000203', NULL, NULL, 'Calcium/calmodulin-dependent protein kinase type 1', NULL, NULL, NULL, NULL, NULL, 4),
(141732, NULL, 'G3DSA:3.30.70.330:FF:000322', NULL, NULL, 'CUGBP Elav-like family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(141733, NULL, 'G3DSA:2.170.130.20:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141734, NULL, 'G3DSA:3.30.450.20:FF:000025', NULL, NULL, 'Neuronal PAS domain protein 3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(141735, NULL, 'G3DSA:2.30.42.10:FF:000357', NULL, NULL, 'Lnx2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(141736, NULL, 'G3DSA:3.20.20.60:FF:000084', NULL, NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(141737, NULL, 'G3DSA:2.60.40.10:FF:003701', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141738, NULL, 'G3DSA:3.90.1490.10:FF:000010', NULL, NULL, 'DPH6 isoform 5', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(141739, NULL, 'G3DSA:3.90.260.10:FF:000022', NULL, NULL, 'DNA repair protein complementing XP-C cells homolog', NULL, NULL, NULL, NULL, NULL, 4),
(141740, NULL, 'G3DSA:1.10.560.10:FF:000093', NULL, NULL, '60 kDa chaperonin 4', NULL, NULL, NULL, NULL, NULL, 4),
(141741, NULL, 'G3DSA:3.30.70.330:FF:001851', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141742, NULL, 'G3DSA:2.30.30.40:FF:000344', NULL, NULL, 'Chemotaxis protein CheW', NULL, NULL, NULL, NULL, NULL, 4),
(141743, NULL, 'G3DSA:3.30.2130.10:FF:000008', NULL, NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141744, NULL, 'G3DSA:1.10.10.10:FF:001883', NULL, NULL, 'Lysine (K)-specific demethylase 1a', NULL, NULL, NULL, NULL, NULL, 4),
(141745, NULL, 'G3DSA:3.30.70.330:FF:002470', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141746, NULL, 'G3DSA:2.20.110.10:FF:000019', NULL, NULL, 'MORN repeat-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(141747, NULL, 'G3DSA:2.40.30.110:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141748, NULL, 'G3DSA:3.30.565.10:FF:000451', NULL, NULL, 'Sensor histidine kinase, PAS and GAF domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(141749, NULL, 'G3DSA:3.10.250.10:FF:000146', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141750, NULL, 'G3DSA:1.10.3110.10:FF:000008', NULL, NULL, 'Dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(141751, NULL, 'G3DSA:3.10.20.90:FF:000385', NULL, NULL, 'Sorting nexin-17 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(141752, NULL, 'G3DSA:3.30.200.20:FF:000091', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(141753, NULL, 'G3DSA:1.25.40.710:FF:000011', NULL, NULL, 'Tripeptidyl-peptidase 2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(141754, NULL, 'G3DSA:1.20.1250.20:FF:000541', NULL, NULL, 'Putative hexuronate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(141755, NULL, 'G3DSA:1.20.1280.70:FF:000001', NULL, NULL, 'Exodeoxyribonuclease I', NULL, NULL, NULL, NULL, NULL, 4),
(141756, NULL, 'G3DSA:3.10.129.10:FF:000134', NULL, NULL, 'Phenylacetic acid degradation protein', NULL, NULL, NULL, NULL, NULL, 4),
(141757, NULL, 'G3DSA:3.40.30.10:FF:000653', NULL, NULL, 'Thiol:disulfide interchange protein DsbA', NULL, NULL, NULL, NULL, NULL, 4),
(141758, NULL, 'G3DSA:2.130.10.10:FF:002156', NULL, NULL, 'Type I inositol polyphosphate 5-phosphatase 12', NULL, NULL, NULL, NULL, NULL, 4),
(141759, NULL, 'G3DSA:3.20.20.80:FF:000202', NULL, NULL, 'CHItinase-Like', NULL, NULL, NULL, NULL, NULL, 4),
(141760, NULL, 'G3DSA:1.20.120.1450:FF:000001', NULL, NULL, 'Heptaprenyl diphosphate synthase component I', NULL, NULL, NULL, NULL, NULL, 4),
(141761, NULL, 'G3DSA:2.70.98.10:FF:000006', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(141762, NULL, 'G3DSA:3.30.160.60:FF:001116', NULL, NULL, 'Zinc finger protein 562', NULL, NULL, NULL, NULL, NULL, 4),
(141763, NULL, 'G3DSA:3.30.70.330:FF:001519', NULL, NULL, 'U2 snRNP auxiliary factor large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(141764, NULL, 'G3DSA:3.30.1010.10:FF:000062', NULL, NULL, 'Phosphatidylinositol 4-kinase PIK1alpha', NULL, NULL, NULL, NULL, NULL, 4),
(141765, NULL, 'G3DSA:4.10.240.10:FF:000203', NULL, NULL, 'Stb5p', NULL, NULL, NULL, NULL, NULL, 4),
(141766, NULL, 'G3DSA:3.40.50.300:FF:001021', NULL, NULL, 'Probable ATP-dependent RNA helicase DDX20', NULL, NULL, NULL, NULL, NULL, 4),
(141767, NULL, 'G3DSA:1.20.1070.10:FF:000895', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141768, NULL, 'G3DSA:3.40.50.300:FF:005416', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(141769, NULL, 'G3DSA:1.10.10.1340:FF:000002', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 31', NULL, NULL, NULL, NULL, NULL, 4),
(141770, NULL, 'G3DSA:1.10.565.10:FF:000076', NULL, NULL, 'Nuclear hormone receptor family member nhr-67', NULL, NULL, NULL, NULL, NULL, 4),
(141771, NULL, 'G3DSA:2.120.10.80:FF:000328', NULL, NULL, 'Attractin-like 1', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(141772, NULL, 'G3DSA:3.90.400.10:FF:000011', NULL, NULL, 'CD98 heavy chain, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(141773, NULL, 'G3DSA:3.40.50.12780:FF:000154', NULL, NULL, 'Nonribosomal peptide synthase, putative (JCVI)', NULL, NULL, NULL, NULL, NULL, 4),
(141774, NULL, 'G3DSA:2.130.10.30:FF:000021', NULL, NULL, 'serine/threonine-protein kinase Nek9 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(141775, NULL, 'G3DSA:2.60.220.50:FF:000031', NULL, NULL, 'Starry night, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(141776, NULL, 'G3DSA:2.60.40.640:FF:000119', NULL, NULL, 'Arrestin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141777, NULL, 'G3DSA:2.40.10.10:FF:000036', NULL, NULL, 'Trypsin beta', NULL, NULL, NULL, NULL, NULL, 4),
(141778, NULL, 'G3DSA:1.20.1640.10:FF:000023', NULL, NULL, 'Protein-export membrane protein SecF', NULL, NULL, NULL, NULL, NULL, 4),
(141779, NULL, 'G3DSA:1.25.10.10:FF:000186', NULL, NULL, 'Importin 4', NULL, NULL, NULL, NULL, NULL, 4),
(141780, NULL, 'G3DSA:2.60.200.20:FF:000037', NULL, NULL, 'FHA domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(141781, NULL, 'G3DSA:3.40.50.150:FF:000335', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase J', NULL, NULL, NULL, NULL, NULL, 4),
(141782, NULL, 'G3DSA:1.25.40.20:FF:000932', NULL, NULL, 'Ankyrin repeats (Many copies), putative', NULL, NULL, NULL, NULL, NULL, 4),
(141783, NULL, 'G3DSA:3.40.1000.50:FF:000025', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(141784, NULL, 'G3DSA:3.40.50.1100:FF:000158', NULL, NULL, 'Cysteine synthase B protein', NULL, NULL, NULL, NULL, NULL, 4),
(141785, NULL, 'G3DSA:1.25.40.10:FF:000250', NULL, NULL, 'RNA polymerase II transcription elongation factor', NULL, NULL, NULL, NULL, NULL, 4),
(141786, NULL, 'G3DSA:1.20.58.1520:FF:000003', NULL, NULL, 'Coiled-coil domain-containing protein 87', NULL, NULL, NULL, NULL, NULL, 4),
(141787, NULL, 'G3DSA:1.20.1510.10:FF:000019', NULL, NULL, 'Metal tolerance protein C2', NULL, NULL, NULL, NULL, NULL, 4),
(141788, NULL, 'G3DSA:1.10.10.60:FF:001201', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141789, NULL, 'G3DSA:3.80.10.10:FF:001616', NULL, NULL, 'Os08g0195000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(141790, NULL, 'G3DSA:4.10.780.10:FF:000002', NULL, NULL, 'Pyruvate:ferredoxin (Flavodoxin) oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(141791, NULL, 'G3DSA:3.80.10.10:FF:002443', NULL, NULL, 'leucine-rich repeat-containing protein 40 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(141792, NULL, 'G3DSA:1.20.1250.20:FF:001738', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141793, NULL, 'G3DSA:2.130.10.10:FF:001212', NULL, NULL, 'Protein kinase (VPS15), putative', NULL, NULL, NULL, NULL, NULL, 4),
(141794, NULL, 'G3DSA:3.40.50.300:FF:000318', NULL, NULL, 'ATP-dependent RNA helicase DDX19B', NULL, NULL, NULL, NULL, NULL, 4),
(141795, NULL, 'G3DSA:3.30.70.270:FF:000282', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141796, NULL, 'G3DSA:2.30.30.370:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141797, NULL, 'G3DSA:1.20.120.1750:FF:000097', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(141798, NULL, 'G3DSA:6.20.250.70:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141799, NULL, 'G3DSA:3.30.710.10:FF:000407', NULL, NULL, 'Rho-related BTB domain-containing protein 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(141800, NULL, 'G3DSA:3.40.30.10:FF:001272', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(141801, NULL, 'G3DSA:2.130.10.10:FF:004730', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141802, NULL, 'G3DSA:1.20.1070.10:FF:001272', NULL, NULL, 'Growth hormone releasing hormone receptor', NULL, NULL, NULL, NULL, NULL, 4),
(141803, NULL, 'G3DSA:2.60.40.10:FF:003128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141804, NULL, 'G3DSA:3.30.70.3490:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(141805, NULL, 'G3DSA:3.30.420.40:FF:000984', NULL, NULL, 'Proton-dependent oligopeptide transport (POT) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(141806, NULL, 'G3DSA:2.60.40.1180:FF:000116', NULL, NULL, 'Alpha-mannosidase C', NULL, NULL, NULL, NULL, NULL, 4),
(141807, NULL, 'G3DSA:3.30.70.330:FF:002138', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141808, NULL, 'G3DSA:3.40.50.300:FF:008289', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(141809, NULL, 'G3DSA:3.90.1230.10:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141810, NULL, 'G3DSA:3.90.420.10:FF:000006', NULL, NULL, 'Sulfur dehydrogenase subunit SoxC', NULL, NULL, NULL, NULL, NULL, 4),
(141811, NULL, 'G3DSA:1.10.3430.10:FF:000055', NULL, NULL, 'Blr0608 protein', NULL, NULL, NULL, NULL, NULL, 4),
(141812, NULL, 'G3DSA:1.20.1250.20:FF:001822', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141813, NULL, 'G3DSA:3.90.550.10:FF:000342', NULL, NULL, 'Poly-beta-1,6-N-acetyl-D-glucosamine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(141814, NULL, 'G3DSA:2.170.130.10:FF:000019', NULL, NULL, 'Fe(III)-pyochelin outer membrane receptor', NULL, NULL, NULL, NULL, NULL, 4),
(141815, NULL, 'G3DSA:3.40.50.150:FF:001307', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141816, NULL, 'G3DSA:1.10.510.10:FF:004417', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141817, NULL, 'G3DSA:3.20.20.370:FF:000006', NULL, NULL, 'YdjC chitooligosaccharide deacetylase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(141818, NULL, 'G3DSA:3.10.20.90:FF:000716', NULL, NULL, 'Ubiquitin domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(141819, NULL, 'G3DSA:1.25.40.90:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141820, NULL, 'G3DSA:3.40.50.300:FF:004247', NULL, NULL, '3''-5'' exonuclease DinG', NULL, NULL, NULL, NULL, NULL, 4),
(141821, NULL, 'G3DSA:3.30.200.20:FF:002232', NULL, NULL, 'Cyclin-dependent kinase 14', NULL, NULL, NULL, NULL, NULL, 4),
(141822, NULL, 'G3DSA:1.10.1420.10:FF:000082', NULL, NULL, 'Msh2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(141823, NULL, 'G3DSA:3.30.70.330:FF:000238', NULL, NULL, 'SAFB-like transcription modulator isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(141824, NULL, 'G3DSA:3.60.10.10:FF:000151', NULL, NULL, 'Inositol phosphosphingolipid phospholipase C-Like', NULL, NULL, NULL, NULL, NULL, 4),
(141825, NULL, 'G3DSA:1.25.40.10:FF:001110', NULL, NULL, 'LuxR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(141826, NULL, 'G3DSA:3.40.50.300:FF:008401', NULL, NULL, 'Regulator of nonsense transcripts putative', NULL, NULL, NULL, NULL, NULL, 4),
(141827, NULL, 'G3DSA:1.10.30.50:FF:000013', NULL, NULL, '5-methylcytosine-specific restriction enzyme A', NULL, NULL, NULL, NULL, NULL, 4),
(141828, NULL, 'G3DSA:1.50.10.10:FF:000122', NULL, NULL, 'Six-hairpin glycosidase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(141829, NULL, 'G3DSA:3.30.160.60:FF:000924', NULL, NULL, 'IKAROS family zinc finger 5', NULL, NULL, NULL, NULL, NULL, 4),
(141830, NULL, 'G3DSA:1.10.600.10:FF:000029', NULL, NULL, 'Octaprenyl pyrophosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(141831, NULL, 'G3DSA:3.40.50.1440:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141832, NULL, 'G3DSA:1.10.510.10:FF:002517', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141833, NULL, 'G3DSA:1.10.510.10:FF:003136', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141834, NULL, 'G3DSA:3.40.50.10810:FF:000024', NULL, NULL, 'DNA annealing helicase and endonuclease ZRANB3', NULL, NULL, NULL, NULL, NULL, 4),
(141835, NULL, 'G3DSA:3.10.100.10:FF:000259', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141836, NULL, 'G3DSA:3.40.50.10190:FF:000006', NULL, NULL, 'Breast cancer type 1 susceptibility protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(141837, NULL, 'G3DSA:1.10.1200.10:FF:000099', NULL, NULL, 'CurA', NULL, NULL, NULL, NULL, NULL, 4),
(141838, NULL, 'G3DSA:1.25.40.10:FF:000834', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(141839, NULL, 'G3DSA:3.30.160.60:FF:001543', NULL, NULL, 'Zinc finger protein 334', NULL, NULL, NULL, NULL, NULL, 4),
(141840, NULL, 'G3DSA:1.20.1110.10:FF:000270', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141841, NULL, 'G3DSA:1.10.3020.10:FF:000001', NULL, NULL, 'Possible hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(141842, NULL, 'G3DSA:3.90.1010.10:FF:000019', NULL, NULL, 'Iron-sulfur cluster assembly enzyme b', NULL, NULL, NULL, NULL, NULL, 4),
(141843, NULL, 'G3DSA:3.40.50.300:FF:000993', NULL, NULL, 'probable ATP-dependent RNA helicase DDX49', NULL, NULL, NULL, NULL, NULL, 4),
(141844, NULL, 'G3DSA:2.40.50.40:FF:000042', NULL, NULL, 'Chromodomain-helicase-DNA-binding protein Mi-2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(141845, NULL, 'G3DSA:1.10.238.10:FF:000226', NULL, NULL, 'Serine/threonine-protein phosphatase with EF-hands', NULL, NULL, NULL, NULL, NULL, 4),
(141846, NULL, 'G3DSA:3.30.200.20:FF:000102', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(141847, NULL, 'G3DSA:1.10.287.1490:FF:000076', NULL, NULL, 'Outer dense fiber of sperm tails 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(141848, NULL, 'G3DSA:1.20.890.10:FF:000020', NULL, NULL, 'CBN-KIN-2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(141849, NULL, 'G3DSA:3.30.160.60:FF:001200', NULL, NULL, 'zinc finger protein 639', NULL, NULL, NULL, NULL, NULL, 4),
(141850, NULL, 'G3DSA:2.60.40.10:FF:002280', NULL, NULL, 'Myosin binding protein C, slow type', NULL, NULL, NULL, NULL, NULL, 4),
(141851, NULL, 'G3DSA:3.40.50.10190:FF:000349', NULL, NULL, 'BRCT-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(141852, NULL, 'G3DSA:2.60.120.380:FF:000096', NULL, NULL, 'Putative calpain-like cysteine protease A', NULL, NULL, NULL, NULL, NULL, 4),
(141853, NULL, 'G3DSA:3.30.160.60:FF:004769', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141854, NULL, 'G3DSA:1.10.20.10:FF:000309', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141855, NULL, 'G3DSA:3.80.10.10:FF:000998', NULL, NULL, 'Os06g0692100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(141856, NULL, 'G3DSA:1.10.150.80:FF:000032', NULL, NULL, 'Exosome complex exonuclease RRP6, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141857, NULL, 'G3DSA:2.60.120.340:FF:000011', NULL, NULL, 'Nucleophosmin/nucleoplasmin 3', NULL, NULL, NULL, NULL, NULL, 4),
(141858, NULL, 'G3DSA:1.25.40.10:FF:002734', NULL, NULL, 'Sll0314 protein', NULL, NULL, NULL, NULL, NULL, 4),
(141859, NULL, 'G3DSA:1.10.150.310:FF:000003', NULL, NULL, 'LD12377p', NULL, NULL, NULL, NULL, NULL, 4),
(141860, NULL, 'G3DSA:2.60.40.150:FF:000276', NULL, NULL, 'Blast:Dedicator of cytokinesis protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(141861, NULL, 'G3DSA:2.60.40.60:FF:000479', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141862, NULL, 'G3DSA:3.30.160.60:FF:000020', NULL, NULL, 'Zinc finger protein 14 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(141863, NULL, 'G3DSA:2.130.10.10:FF:005141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141864, NULL, 'G3DSA:2.30.30.90:FF:000005', NULL, NULL, 'DtxR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(141865, NULL, 'G3DSA:1.25.40.10:FF:004420', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141866, NULL, 'G3DSA:1.10.357.140:FF:000007', NULL, NULL, '1,4-dihydroxy-2-naphthoate octaprenyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(141867, NULL, 'G3DSA:1.10.246.130:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141868, NULL, 'G3DSA:3.30.200.20:FF:001726', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141869, NULL, 'G3DSA:3.90.1150.10:FF:000535', NULL, NULL, 'Putative acetylornithine/succinylornithine aminotransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(141870, NULL, 'G3DSA:2.40.50.110:FF:000001', NULL, NULL, 'Cholera enterotoxin subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(141871, NULL, 'G3DSA:3.80.10.10:FF:000105', NULL, NULL, 'S-phase kinase-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(141872, NULL, 'G3DSA:2.170.300.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141873, NULL, 'G3DSA:1.10.357.110:FF:000009', NULL, NULL, 'Vps53p', NULL, NULL, NULL, NULL, NULL, 4),
(141874, NULL, 'G3DSA:2.130.10.10:FF:004865', NULL, NULL, 'Chromosome 15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(141875, NULL, 'G3DSA:1.10.150.60:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141876, NULL, 'G3DSA:1.10.575.10:FF:000003', NULL, NULL, 'Single strand-specific nuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141877, NULL, 'G3DSA:3.30.420.10:FF:000649', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141878, NULL, 'G3DSA:3.40.50.1820:FF:000604', NULL, NULL, 'Esterase/lipase', NULL, NULL, NULL, NULL, NULL, 4),
(141879, NULL, 'G3DSA:3.30.160.60:FF:002392', NULL, NULL, 'Zinc finger protein 251', NULL, NULL, NULL, NULL, NULL, 4),
(141880, NULL, 'G3DSA:1.25.40.10:FF:000593', NULL, NULL, 'Protein KINESIN LIGHT CHAIN-RELATED 1', NULL, NULL, NULL, NULL, NULL, 4),
(141881, NULL, 'G3DSA:1.10.472.10:FF:000388', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141882, NULL, 'G3DSA:1.10.510.10:FF:000489', NULL, NULL, 'cyclin-dependent kinase 19 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(141883, NULL, 'G3DSA:1.10.533.10:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141884, NULL, 'G3DSA:3.80.10.10:FF:001959', NULL, NULL, 'Protein STRUBBELIG-RECEPTOR FAMILY 6 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(141885, NULL, 'G3DSA:3.40.50.1820:FF:000363', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(141886, NULL, 'G3DSA:3.30.760.10:FF:000023', NULL, NULL, 'Unplaced genomic scaffold supercont1.138, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(141887, NULL, 'G3DSA:3.20.20.70:FF:000749', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141888, NULL, 'G3DSA:2.10.25.10:FF:000105', NULL, NULL, 'laminin subunit gamma-1', NULL, NULL, NULL, NULL, NULL, 4),
(141889, NULL, 'G3DSA:3.80.10.10:FF:002235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141890, NULL, 'G3DSA:1.10.510.10:FF:001899', NULL, NULL, 'Discoidin domain receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141891, NULL, 'G3DSA:1.50.10.10:FF:000021', NULL, NULL, 'N-acylglucosamine 2-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(141892, NULL, 'G3DSA:3.30.700.10:FF:000002', NULL, NULL, 'Type 4 fimbrial biogenesis protein PilE', NULL, NULL, NULL, NULL, NULL, 4),
(141893, NULL, 'G3DSA:3.40.50.620:FF:000055', NULL, NULL, 'Asparagine synthetase [glutamine-hydrolyzing]', NULL, NULL, NULL, NULL, NULL, 4),
(141894, NULL, 'G3DSA:1.10.10.580:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141895, NULL, 'G3DSA:3.30.1740.20:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141896, NULL, 'G3DSA:1.10.238.10:FF:001075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141897, NULL, 'G3DSA:1.10.10.60:FF:000116', NULL, NULL, 'Cut-like homeobox 2b', NULL, NULL, NULL, NULL, NULL, 4),
(141898, NULL, 'G3DSA:3.40.50.300:FF:006501', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141899, NULL, 'G3DSA:3.40.190.10:FF:000275', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(141900, NULL, 'G3DSA:3.30.70.1290:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141901, NULL, 'G3DSA:3.30.420.110:FF:000038', NULL, NULL, 'DNA mismatch repair protein mutS, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141902, NULL, 'G3DSA:3.30.420.10:FF:000205', NULL, NULL, 'DNA polymerase III epsilon subunit', NULL, NULL, NULL, NULL, NULL, 4),
(141903, NULL, 'G3DSA:3.90.230.10:FF:000071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141904, NULL, 'G3DSA:2.30.30.490:FF:000023', NULL, NULL, 'Egg-laying defective protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(141905, NULL, 'G3DSA:2.40.10.170:FF:000011', NULL, NULL, 'ATP synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(141906, NULL, 'G3DSA:1.10.220.150:FF:000005', NULL, NULL, 'Arf-GAP domain and FG repeat-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(141907, NULL, 'G3DSA:1.25.50.20:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141908, NULL, 'G3DSA:2.30.180.10:FF:000027', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(141909, NULL, 'G3DSA:1.10.238.10:FF:000569', NULL, NULL, 'Centrin 3', NULL, NULL, NULL, NULL, NULL, 4),
(141910, NULL, 'G3DSA:2.80.10.50:FF:000260', NULL, NULL, 'Beta-agarase AgaB34', NULL, NULL, NULL, NULL, NULL, 4),
(141911, NULL, 'G3DSA:1.10.1410.10:FF:000025', NULL, NULL, 'Putative Poly(A) polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(141912, NULL, 'G3DSA:3.30.70.330:FF:002576', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141913, NULL, 'G3DSA:1.10.300.10:FF:000001', NULL, NULL, 'Adenylosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(141914, NULL, 'G3DSA:1.10.533.10:FF:000058', NULL, NULL, 'death domain-containing protein CRADD isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(141915, NULL, 'G3DSA:3.60.20.10:FF:000202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141916, NULL, 'G3DSA:3.30.40.10:FF:001868', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141917, NULL, 'G3DSA:3.40.30.10:FF:000552', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141918, NULL, 'G3DSA:3.90.70.10:FF:000445', NULL, NULL, 'Putative ubiquitin-hydrolase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(141919, NULL, 'G3DSA:3.40.120.10:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141920, NULL, 'G3DSA:2.60.120.260:FF:000318', NULL, NULL, 'Putative lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(141921, NULL, 'G3DSA:3.10.350.10:FF:000070', NULL, NULL, 'Gamma-D-glutamyl-L-diamino acid endopeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(141922, NULL, 'G3DSA:3.40.50.10140:FF:000020', NULL, NULL, 'Blast:Protein toll', NULL, NULL, NULL, NULL, NULL, 4),
(141923, NULL, 'G3DSA:1.20.1250.20:FF:000642', NULL, NULL, 'Multi-drug resistance efflux pump', NULL, NULL, NULL, NULL, NULL, 4),
(141924, NULL, 'G3DSA:2.40.30.130:FF:000008', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(141925, NULL, 'G3DSA:3.60.21.10:FF:000277', NULL, NULL, 'Uncharacterized protein F44B9.9', NULL, NULL, NULL, NULL, NULL, 4),
(141926, NULL, 'G3DSA:3.30.420.40:FF:001029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141927, NULL, 'G3DSA:3.90.650.10:FF:000063', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(141928, NULL, 'G3DSA:2.10.25.10:FF:001515', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141929, NULL, 'G3DSA:2.10.25.10:FF:001297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141930, NULL, 'G3DSA:2.10.110.10:FF:000314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141931, NULL, 'G3DSA:3.30.160.60:FF:000363', NULL, NULL, 'Zinc finger protein 239', NULL, NULL, NULL, NULL, NULL, 4),
(141932, NULL, 'G3DSA:3.30.40.10:FF:002144', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(141933, NULL, 'G3DSA:1.20.58.60:FF:000613', NULL, NULL, 'Nesprin-2', NULL, NULL, NULL, NULL, NULL, 4),
(141934, NULL, 'G3DSA:1.10.760.10:FF:000092', NULL, NULL, 'Putative SCO1/SenC family protein/methylamine utilization protein MauG', NULL, NULL, NULL, NULL, NULL, 4),
(141935, NULL, 'G3DSA:3.30.200.20:FF:000546', NULL, NULL, 'MAP kinase-activated protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(141936, NULL, 'G3DSA:3.30.450.30:FF:000039', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(141937, NULL, 'G3DSA:3.30.40.10:FF:000244', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(141938, NULL, 'G3DSA:1.20.1250.10:FF:000100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141939, NULL, 'G3DSA:3.10.580.20:FF:000005', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(141940, NULL, 'G3DSA:2.60.40.10:FF:001560', NULL, NULL, 'palladin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(141941, NULL, 'G3DSA:2.70.98.30:FF:000001', NULL, NULL, 'alpha-mannosidase 2C1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(141942, NULL, 'G3DSA:3.50.50.60:FF:000444', NULL, NULL, 'Putative GMC-type oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(141943, NULL, 'G3DSA:1.10.10.430:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141944, NULL, 'G3DSA:3.30.40.10:FF:000120', NULL, NULL, 'ligand of Numb protein X 2', NULL, NULL, NULL, NULL, NULL, 4),
(141945, NULL, 'G3DSA:3.30.1540.20:FF:000014', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(141946, NULL, 'G3DSA:3.30.420.40:FF:000641', NULL, NULL, 'Heat shock 70 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(141947, NULL, 'G3DSA:1.10.510.10:FF:001107', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(141948, NULL, 'G3DSA:2.60.260.20:FF:000142', NULL, NULL, 'DnAJ-like protein slr0093', NULL, NULL, NULL, NULL, NULL, 4),
(141949, NULL, 'G3DSA:3.30.505.10:FF:000234', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141950, NULL, 'G3DSA:1.25.10.10:FF:000422', NULL, NULL, 'Stambha A, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(141951, NULL, 'G3DSA:2.130.10.10:FF:002735', NULL, NULL, 'Ribosome biogenesis protein WDR12 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(141952, NULL, 'G3DSA:2.10.110.10:FF:000191', NULL, NULL, 'LIM domain kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(141953, NULL, 'G3DSA:3.80.10.10:FF:001263', NULL, NULL, 'Insulin-like growth factor-binding protein complex acid labile subunit', NULL, NULL, NULL, NULL, NULL, 4),
(141954, NULL, 'G3DSA:1.10.10.2030:FF:000001', NULL, NULL, 'DNA/RNA-binding protein KIN17, putative', NULL, NULL, NULL, NULL, NULL, 4),
(141955, NULL, 'G3DSA:1.25.10.10:FF:002451', NULL, NULL, 'AFL147Cp', NULL, NULL, NULL, NULL, NULL, 4),
(141956, NULL, 'G3DSA:1.10.287.470:FF:000022', NULL, NULL, 'Membrane fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(141957, NULL, 'G3DSA:3.40.50.2000:FF:000097', NULL, NULL, 'alpha-1,3/1,6-mannosyltransferase ALG2', NULL, NULL, NULL, NULL, NULL, 4),
(141958, NULL, 'G3DSA:3.40.50.720:FF:002001', NULL, NULL, 'NADH:ubiquinone oxidoreductase 39 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(141959, NULL, 'G3DSA:1.20.190.40:FF:000003', NULL, NULL, 'Major DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(141960, NULL, 'G3DSA:1.25.40.320:FF:000001', NULL, NULL, 'Leukotriene A(4) hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(141961, NULL, 'G3DSA:3.30.710.10:FF:000284', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(141962, NULL, 'G3DSA:2.60.120.650:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141963, NULL, 'G3DSA:1.20.1000.10:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141964, NULL, 'G3DSA:1.20.1250.20:FF:001261', NULL, NULL, 'Tetracycline resistance determinant tetV', NULL, NULL, NULL, NULL, NULL, 4),
(141965, NULL, 'G3DSA:2.60.40.10:FF:002509', NULL, NULL, 'Unc-5, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(141966, NULL, 'G3DSA:3.30.160.60:FF:003797', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(141967, NULL, 'G3DSA:1.25.10.10:FF:001041', NULL, NULL, 'Protein phosphatase PP2A regulatory subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(141968, NULL, 'G3DSA:3.40.50.720:FF:002125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141969, NULL, 'G3DSA:1.20.1560.10:FF:000410', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141970, NULL, 'G3DSA:3.30.160.60:FF:002971', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(141971, NULL, 'G3DSA:3.30.360.10:FF:000138', NULL, NULL, 'Glucose-6-phosphate 1-dehydrogenase 4 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(141972, NULL, 'G3DSA:2.130.10.10:FF:003893', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(141973, NULL, 'G3DSA:3.40.50.720:FF:001383', NULL, NULL, 'C-terminal-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(141974, NULL, 'G3DSA:3.40.50.450:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141975, NULL, 'G3DSA:3.30.200.20:FF:001956', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(141976, NULL, 'G3DSA:3.10.450.40:FF:000007', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(141977, NULL, 'G3DSA:1.10.10.10:FF:001102', NULL, NULL, 'Transcriptional regulator, MarR family', NULL, NULL, NULL, NULL, NULL, 4),
(141978, NULL, 'G3DSA:3.30.70.1230:FF:000262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141979, NULL, 'G3DSA:1.20.1270.60:FF:000296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141980, NULL, 'G3DSA:1.10.10.1050:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141981, NULL, 'G3DSA:4.10.1000.10:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141982, NULL, 'G3DSA:1.20.1070.10:FF:001833', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(141983, NULL, 'G3DSA:1.25.40.10:FF:003240', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(141984, NULL, 'G3DSA:2.30.30.40:FF:000445', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(141985, NULL, 'G3DSA:3.30.470.30:FF:000023', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(141986, NULL, 'G3DSA:1.20.58.60:FF:000052', NULL, NULL, 'dystonin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(141987, NULL, 'G3DSA:4.10.1060.10:FF:000006', NULL, NULL, 'ubiquitin thioesterase ZRANB1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(141988, NULL, 'G3DSA:3.40.50.300:FF:003275', NULL, NULL, 'ras-related C3 botulinum toxin substrate 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(141989, NULL, 'G3DSA:3.40.50.300:FF:006844', NULL, NULL, 'DNA repair protein rhp55', NULL, NULL, NULL, NULL, NULL, 4),
(141990, NULL, 'G3DSA:3.40.390.10:FF:000161', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(141991, NULL, 'G3DSA:1.10.10.10:FF:000826', NULL, NULL, 'LuxR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(141992, NULL, 'G3DSA:4.10.280.10:FF:000200', NULL, NULL, 'Hms1p', NULL, NULL, NULL, NULL, NULL, 4),
(141993, NULL, 'G3DSA:3.40.50.2300:FF:000417', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(141994, NULL, 'G3DSA:3.40.50.1010:FF:000120', NULL, NULL, 'NYN domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(141995, NULL, 'G3DSA:3.30.420.40:FF:000080', NULL, NULL, 'Actin, alpha skeletal muscle', NULL, NULL, NULL, NULL, NULL, 4),
(141996, NULL, 'G3DSA:3.30.200.20:FF:002356', NULL, NULL, 'Mitogen-activated protein kinase 11', NULL, NULL, NULL, NULL, NULL, 4),
(141997, NULL, 'G3DSA:3.30.2160.10:FF:000044', NULL, NULL, 'YALI0A20372p', NULL, NULL, NULL, NULL, NULL, 4),
(141998, NULL, 'G3DSA:3.50.50.60:FF:000320', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(141999, NULL, 'G3DSA:3.30.479.20:FF:000012', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(142000, NULL, 'G3DSA:1.10.640.10:FF:000026', NULL, NULL, 'Protein CBG17660', NULL, NULL, NULL, NULL, NULL, 4),
(142001, NULL, 'G3DSA:3.30.1490.80:FF:000011', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(142002, NULL, 'G3DSA:2.40.50.90:FF:000130', NULL, NULL, 'Transcription factor, Tudor domain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142003, NULL, 'G3DSA:1.20.20.10:FF:000006', NULL, NULL, 'ATP synthase subunit 9, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(142004, NULL, 'G3DSA:3.40.50.300:FF:007120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142005, NULL, 'G3DSA:2.60.40.60:FF:000136', NULL, NULL, 'Neural-cadherin', NULL, NULL, NULL, NULL, NULL, 4),
(142006, NULL, 'G3DSA:3.80.10.10:FF:003871', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(142007, NULL, 'G3DSA:1.10.10.2740:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142008, NULL, 'G3DSA:2.40.70.10:FF:000253', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142009, NULL, 'G3DSA:3.30.160.60:FF:004073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142010, NULL, 'G3DSA:3.20.20.150:FF:000064', NULL, NULL, 'Protein CBG19664', NULL, NULL, NULL, NULL, NULL, 4),
(142011, NULL, 'G3DSA:2.60.40.10:FF:003460', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142012, NULL, 'G3DSA:3.50.50.60:FF:001293', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142013, NULL, 'G3DSA:2.70.70.10:FF:000010', NULL, NULL, 'M23 family peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(142014, NULL, 'G3DSA:3.80.10.10:FF:002578', NULL, NULL, 'NLR family CARD domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(142015, NULL, 'G3DSA:1.10.472.10:FF:000045', NULL, NULL, 'Transcription initiation factor IIB', NULL, NULL, NULL, NULL, NULL, 4),
(142016, NULL, 'G3DSA:3.30.710.10:FF:000183', NULL, NULL, 'Ankyrin repeat and BTB/POZ domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(142017, NULL, 'G3DSA:2.60.40.10:FF:001116', NULL, NULL, 'Titin novex-3', NULL, NULL, NULL, NULL, NULL, 4),
(142018, NULL, 'G3DSA:3.90.470.20:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142019, NULL, 'G3DSA:3.40.1190.20:FF:000142', NULL, NULL, 'Uncharacterized sugar kinase', NULL, NULL, NULL, NULL, NULL, 4),
(142020, NULL, 'G3DSA:1.10.10.10:FF:001315', NULL, NULL, 'Transcriptional activator domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(142021, NULL, 'G3DSA:2.40.10.10:FF:000480', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142022, NULL, 'G3DSA:3.30.160.60:FF:003696', NULL, NULL, 'Zinc finger protein 527', NULL, NULL, NULL, NULL, NULL, 4),
(142023, NULL, 'G3DSA:2.60.120.200:FF:000435', NULL, NULL, 'AGAP004456-PA', NULL, NULL, NULL, NULL, NULL, 4),
(142024, NULL, 'G3DSA:3.30.160.60:FF:006444', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142025, NULL, 'G3DSA:1.25.40.10:FF:004651', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142026, NULL, 'G3DSA:3.40.50.300:FF:006265', NULL, NULL, 'SNF2 superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(142027, NULL, 'G3DSA:3.80.10.10:FF:001162', NULL, NULL, 'Leucine rich repeat containing 15', NULL, NULL, NULL, NULL, NULL, 4),
(142028, NULL, 'G3DSA:2.60.40.2500:FF:000001', NULL, NULL, 'Protein virB9', NULL, NULL, NULL, NULL, NULL, 4),
(142029, NULL, 'G3DSA:4.10.60.10:FF:000007', NULL, NULL, 'Protein lin-28 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(142030, NULL, 'G3DSA:1.10.287.110:FF:000398', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142031, NULL, 'G3DSA:1.10.510.10:FF:000606', NULL, NULL, 'Wall-associated receptor kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(142032, NULL, 'G3DSA:1.10.10.10:FF:000803', NULL, NULL, 'Putative cation uptake regulator', NULL, NULL, NULL, NULL, NULL, 4),
(142033, NULL, 'G3DSA:2.60.40.1170:FF:000001', NULL, NULL, 'AP-1 complex subunit mu-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(142034, NULL, 'G3DSA:3.40.50.2000:FF:000889', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142035, NULL, 'G3DSA:3.40.50.2300:FF:001485', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142036, NULL, 'G3DSA:3.30.559.10:FF:000061', NULL, NULL, 'Diacylglycerol O-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(142037, NULL, 'G3DSA:3.40.30.10:FF:000097', NULL, NULL, 'NADH dehydrogenase [ubiquinone] flavoprotein 2', NULL, NULL, NULL, NULL, NULL, 4),
(142038, NULL, 'G3DSA:3.40.50.620:FF:000274', NULL, NULL, 'Universal stress protein MT3220', NULL, NULL, NULL, NULL, NULL, 4),
(142039, NULL, 'G3DSA:3.40.395.10:FF:000020', NULL, NULL, 'Peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(142040, NULL, 'G3DSA:2.60.40.10:FF:002639', NULL, NULL, 'Neuronal immunoglobulin domain-containing protein rig-3', NULL, NULL, NULL, NULL, NULL, 4),
(142041, NULL, 'G3DSA:2.130.10.10:FF:004860', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(142042, NULL, 'G3DSA:3.30.70.330:FF:000457', NULL, NULL, 'RNA binding protein MSSP-2', NULL, NULL, NULL, NULL, NULL, 4),
(142043, NULL, 'G3DSA:3.40.50.300:FF:000970', NULL, NULL, 'Ras-related protein Rab-6', NULL, NULL, NULL, NULL, NULL, 4),
(142044, NULL, 'G3DSA:1.20.58.760:FF:000035', NULL, NULL, 'ATP-dependent zinc metalloprotease FTSH 6 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(142045, NULL, 'G3DSA:3.80.10.10:FF:000543', NULL, NULL, 'Transforming growth factor beta activator LRRC33', NULL, NULL, NULL, NULL, NULL, 4),
(142046, NULL, 'G3DSA:1.25.10.10:FF:000427', NULL, NULL, 'Ataxin-10 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(142047, NULL, 'G3DSA:3.30.160.60:FF:002173', NULL, NULL, 'GM13856', NULL, NULL, NULL, NULL, NULL, 4),
(142048, NULL, 'G3DSA:3.40.50.2000:FF:000996', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142049, NULL, 'G3DSA:3.30.70.3490:FF:000012', NULL, NULL, 'Oxysterol-binding protein homolog 4', NULL, NULL, NULL, NULL, NULL, 4),
(142050, NULL, 'G3DSA:3.30.230.10:FF:000152', NULL, NULL, '114 kDa U5 small nuclear ribonucleoprotein component', NULL, NULL, NULL, NULL, NULL, 4),
(142051, NULL, 'G3DSA:1.25.40.10:FF:003009', NULL, NULL, 'YALI0C19426p', NULL, NULL, NULL, NULL, NULL, 4),
(142052, NULL, 'G3DSA:2.130.10.10:FF:001083', NULL, NULL, 'Autophagy-related protein 18a isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(142053, NULL, 'G3DSA:2.70.98.60:FF:000004', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(142054, NULL, 'G3DSA:2.130.10.10:FF:000571', NULL, NULL, 'Regulatory-associated protein of TOR 2', NULL, NULL, NULL, NULL, NULL, 4),
(142055, NULL, 'G3DSA:1.10.630.10:FF:000082', NULL, NULL, 'Cytochrome P450 family 20 subfamily A member 1', NULL, NULL, NULL, NULL, NULL, 4),
(142056, NULL, 'G3DSA:3.40.50.300:FF:001482', NULL, NULL, 'Phosphonates import ATP-binding protein PhnC', NULL, NULL, NULL, NULL, NULL, 4),
(142057, NULL, 'G3DSA:1.25.40.20:FF:001888', NULL, NULL, 'Ankyrin 2, isoform X', NULL, NULL, NULL, NULL, NULL, 4),
(142058, NULL, 'G3DSA:1.25.40.10:FF:000255', NULL, NULL, 'Pentatricopeptide repeat-containing protein 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(142059, NULL, 'G3DSA:1.25.40.470:FF:000023', NULL, NULL, 'WD repeat-containing protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(142060, NULL, 'G3DSA:1.20.120.1880:FF:000012', NULL, NULL, 'Nuclear pore complex protein Nup155', NULL, NULL, NULL, NULL, NULL, 4),
(142061, NULL, 'G3DSA:2.60.120.650:FF:000109', NULL, NULL, 'Lysine-specific demethylase rbr-2', NULL, NULL, NULL, NULL, NULL, 4),
(142062, NULL, 'G3DSA:1.10.3470.10:FF:000052', NULL, NULL, 'Iron ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(142063, NULL, 'G3DSA:3.40.50.720:FF:000427', NULL, NULL, 'Shikimate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(142064, NULL, 'G3DSA:1.20.1560.10:FF:000522', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(142065, NULL, 'G3DSA:1.10.10.60:FF:000560', NULL, NULL, 'Probable transposase', NULL, NULL, NULL, NULL, NULL, 4),
(142066, NULL, 'G3DSA:2.60.120.10:FF:000775', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142067, NULL, 'G3DSA:2.20.25.100:FF:000005', NULL, NULL, '40S ribosomal protein S27', NULL, NULL, NULL, NULL, NULL, 4),
(142068, NULL, 'G3DSA:1.25.40.10:FF:004544', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142069, NULL, 'G3DSA:1.20.5.110:FF:000195', NULL, NULL, 'Qb-SNARE_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(142070, NULL, 'G3DSA:1.25.10.10:FF:002895', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(142071, NULL, 'G3DSA:1.20.5.190:FF:000162', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142072, NULL, 'G3DSA:3.30.40.10:FF:000805', NULL, NULL, 'Bassoon presynaptic cytomatrix protein', NULL, NULL, NULL, NULL, NULL, 4),
(142073, NULL, 'G3DSA:3.10.20.90:FF:000739', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(142074, NULL, 'G3DSA:2.60.260.20:FF:000035', NULL, NULL, 'Heat shock protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(142075, NULL, 'G3DSA:3.90.400.10:FF:000016', NULL, NULL, 'Maltase A2', NULL, NULL, NULL, NULL, NULL, 4),
(142076, NULL, 'G3DSA:3.40.50.300:FF:002898', NULL, NULL, 'Protein CBG21524', NULL, NULL, NULL, NULL, NULL, 4),
(142077, NULL, 'G3DSA:2.40.30.10:FF:000386', NULL, NULL, 'GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(142078, NULL, 'G3DSA:3.40.50.12780:FF:000042', NULL, NULL, 'Possible fatty-acid-CoA ligase fadD1', NULL, NULL, NULL, NULL, NULL, 4),
(142079, NULL, 'G3DSA:1.20.58.1520:FF:000008', NULL, NULL, 'SPD-1', NULL, NULL, NULL, NULL, NULL, 4),
(142080, NULL, 'G3DSA:2.40.10.10:FF:000373', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142081, NULL, 'G3DSA:2.60.40.10:FF:006006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142082, NULL, 'G3DSA:2.60.120.200:FF:000542', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(142083, NULL, 'G3DSA:3.40.640.10:FF:000366', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(142084, NULL, 'G3DSA:1.10.1760.20:FF:000003', NULL, NULL, 'Riboflavin transporter', NULL, NULL, NULL, NULL, NULL, 4),
(142085, NULL, 'G3DSA:1.10.510.10:FF:002748', NULL, NULL, 'Chromosome 15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(142086, NULL, 'G3DSA:2.80.10.50:FF:000029', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(142087, NULL, 'G3DSA:3.20.20.70:FF:000429', NULL, NULL, 'Hydroxyacid oxidase 2 (long chain)', NULL, NULL, NULL, NULL, NULL, 4),
(142088, NULL, 'G3DSA:1.10.20.10:FF:000198', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142089, NULL, 'G3DSA:3.30.70.330:FF:002711', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142090, NULL, 'G3DSA:1.10.510.10:FF:001444', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142091, NULL, 'G3DSA:3.40.640.10:FF:000259', NULL, NULL, 'UDP-4-amino-4,6-dideoxy-N-acetyl-beta-L-altrosamine transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(142092, NULL, 'G3DSA:2.70.160.11:FF:000052', NULL, NULL, 'Protein arginine N-methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(142093, NULL, 'G3DSA:1.25.40.10:FF:001559', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g56690, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(142094, NULL, 'G3DSA:3.30.2160.10:FF:000067', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(142095, NULL, 'G3DSA:3.40.50.410:FF:000222', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(142096, NULL, 'G3DSA:1.20.1250.20:FF:000081', NULL, NULL, 'Lactose permease', NULL, NULL, NULL, NULL, NULL, 4),
(142097, NULL, 'G3DSA:2.60.220.50:FF:000036', NULL, NULL, 'Adhesion G protein-coupled receptor L4', NULL, NULL, NULL, NULL, NULL, 4),
(142098, NULL, 'G3DSA:3.20.20.70:FF:000536', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142099, NULL, 'G3DSA:3.30.1370.10:FF:000088', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(142100, NULL, 'G3DSA:1.10.510.10:FF:001551', NULL, NULL, 'TANK-binding kinase 1 transcript variant X1', NULL, NULL, NULL, NULL, NULL, 4),
(142101, NULL, 'G3DSA:3.40.50.10330:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142102, NULL, 'G3DSA:3.30.70.580:FF:000037', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(142103, NULL, 'G3DSA:1.25.40.10:FF:000362', NULL, NULL, 'Nephrocystin-3', NULL, NULL, NULL, NULL, NULL, 4),
(142104, NULL, 'G3DSA:1.25.10.10:FF:003412', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142105, NULL, 'G3DSA:1.20.1560.10:FF:000415', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142106, NULL, 'G3DSA:3.30.710.10:FF:000290', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(142107, NULL, 'G3DSA:2.20.70.10:FF:000080', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(142108, NULL, 'G3DSA:3.30.70.330:FF:000890', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(142109, NULL, 'G3DSA:3.30.40.10:FF:000912', NULL, NULL, 'RING-variant_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(142110, NULL, 'G3DSA:1.20.120.350:FF:000243', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142111, NULL, 'G3DSA:1.20.58.80:FF:000035', NULL, NULL, 'MIT domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(142112, NULL, 'G3DSA:1.10.8.720:FF:000071', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(142113, NULL, 'G3DSA:3.40.1110.10:FF:000269', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142114, NULL, 'G3DSA:3.30.56.10:FF:000016', NULL, NULL, 'Phenylalanine-tRNA ligase, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(142115, NULL, 'G3DSA:2.120.10.80:FF:000305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142116, NULL, 'G3DSA:1.25.40.320:FF:000006', NULL, NULL, 'Leukotriene A(4) hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(142117, NULL, 'G3DSA:3.30.200.20:FF:001951', NULL, NULL, 'AGR334Wp', NULL, NULL, NULL, NULL, NULL, 4),
(142118, NULL, 'G3DSA:1.20.1070.10:FF:000552', NULL, NULL, 'Olfactory receptor family 4 subfamily C member 3', NULL, NULL, NULL, NULL, NULL, 4),
(142119, NULL, 'G3DSA:1.10.10.60:FF:000453', NULL, NULL, 'Unplaced genomic scaffold supercont1.84, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(142120, NULL, 'G3DSA:1.20.5.110:FF:000200', NULL, NULL, 'Syntaxin 11-1', NULL, NULL, NULL, NULL, NULL, 4),
(142121, NULL, 'G3DSA:1.10.441.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142122, NULL, 'G3DSA:1.20.1270.60:FF:000189', NULL, NULL, 'Dip13 beta, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142123, NULL, 'G3DSA:3.50.7.10:FF:000004', NULL, NULL, 'T-complex protein 1 subunit zeta', NULL, NULL, NULL, NULL, NULL, 4),
(142124, NULL, 'G3DSA:1.10.405.10:FF:000025', NULL, NULL, 'Putative bifunctional amine oxidase DDB_G0291301', NULL, NULL, NULL, NULL, NULL, 4),
(142125, NULL, 'G3DSA:2.60.40.10:FF:004078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142126, NULL, 'G3DSA:2.60.40.150:FF:000299', NULL, NULL, 'RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142127, NULL, 'G3DSA:1.20.1250.20:FF:000878', NULL, NULL, 'Drug resistance transporter, EmrB/QacA subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(142128, NULL, 'G3DSA:3.40.50.1580:FF:000038', NULL, NULL, 'Purine nucleoside phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(142129, NULL, 'G3DSA:3.10.129.10:FF:000111', NULL, NULL, 'Fatty acid synthase beta subunit aflB', NULL, NULL, NULL, NULL, NULL, 4),
(142130, NULL, 'G3DSA:2.30.30.100:FF:000171', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm3', NULL, NULL, NULL, NULL, NULL, 4),
(142131, NULL, 'G3DSA:3.40.220.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142132, NULL, 'G3DSA:1.10.510.10:FF:003479', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142133, NULL, 'G3DSA:1.10.220.160:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142134, NULL, 'G3DSA:3.20.20.190:FF:000042', NULL, NULL, 'Glycerophosphodiester phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(142135, NULL, 'G3DSA:3.30.160.60:FF:002280', NULL, NULL, 'Zinc finger protein 669', NULL, NULL, NULL, NULL, NULL, 4),
(142136, NULL, 'G3DSA:1.25.40.20:FF:000039', NULL, NULL, 'Ankyrin repeat domain-containing protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(142137, NULL, 'G3DSA:1.10.30.10:FF:000024', NULL, NULL, 'Histone-lysine N-methyltransferase NSD2', NULL, NULL, NULL, NULL, NULL, 4),
(142138, NULL, 'G3DSA:3.40.50.980:FF:000022', NULL, NULL, 'Nonribosomal peptide synthetase 8', NULL, NULL, NULL, NULL, NULL, 4),
(142139, NULL, 'G3DSA:1.25.40.10:FF:001778', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(142140, NULL, 'G3DSA:3.30.200.20:FF:002463', NULL, NULL, 'Tubulin gamma-2 chain', NULL, NULL, NULL, NULL, NULL, 4),
(142141, NULL, 'G3DSA:3.40.50.300:FF:007221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(142142, NULL, 'G3DSA:1.20.1250.20:FF:001502', NULL, NULL, 'Xylose/H+ symporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142143, NULL, 'G3DSA:3.90.45.10:FF:000033', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(142144, NULL, 'G3DSA:1.20.58.900:FF:000010', NULL, NULL, 'FYVE and coiled-coil domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(142145, NULL, 'G3DSA:2.40.30.10:FF:000256', NULL, NULL, 'Siderophore-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(142146, NULL, 'G3DSA:3.40.50.10860:FF:000022', NULL, NULL, 'Methylenetetrahydrofolate dehydrogenase (NAD+), putative', NULL, NULL, NULL, NULL, NULL, 4),
(142147, NULL, 'G3DSA:1.25.70.10:FF:000089', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142148, NULL, 'G3DSA:1.25.40.10:FF:001211', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(142149, NULL, 'G3DSA:1.10.4200.10:FF:000009', NULL, NULL, 'CITG protein', NULL, NULL, NULL, NULL, NULL, 4),
(142150, NULL, 'G3DSA:3.30.710.10:FF:000520', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142151, NULL, 'G3DSA:3.30.70.3040:FF:000012', NULL, NULL, 'Cell division ATP-binding protein FtsE', NULL, NULL, NULL, NULL, NULL, 4),
(142152, NULL, 'G3DSA:1.25.10.10:FF:001046', NULL, NULL, 'WGS project CABT00000000 data, contig 2.4', NULL, NULL, NULL, NULL, NULL, 4),
(142153, NULL, 'G3DSA:3.50.50.60:FF:000449', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(142154, NULL, 'G3DSA:3.90.190.20:FF:000036', NULL, NULL, 'Putative folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(142155, NULL, 'G3DSA:3.30.1520.10:FF:000139', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(142156, NULL, 'G3DSA:1.20.5.110:FF:000088', NULL, NULL, 'AGAP005543-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(142157, NULL, 'G3DSA:1.25.10.10:FF:000534', NULL, NULL, 'HEAT repeat containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(142158, NULL, 'G3DSA:3.40.50.11660:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142159, NULL, 'G3DSA:3.40.50.1000:FF:000347', NULL, NULL, 'HAD hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(142160, NULL, 'G3DSA:2.40.30.10:FF:000279', NULL, NULL, 'Protein CBG08008', NULL, NULL, NULL, NULL, NULL, 4),
(142161, NULL, 'G3DSA:3.40.50.150:FF:001408', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142162, NULL, 'G3DSA:1.20.120.620:FF:000009', NULL, NULL, 'Two-component sensor KdpD', NULL, NULL, NULL, NULL, NULL, 4),
(142163, NULL, 'G3DSA:1.10.10.60:FF:001072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142164, NULL, 'G3DSA:3.50.50.60:FF:001068', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(142165, NULL, 'G3DSA:1.10.225.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142166, NULL, 'G3DSA:2.70.170.10:FF:000006', NULL, NULL, 'Cholinergic receptor nicotinic beta 2 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(142167, NULL, 'G3DSA:3.10.20.90:FF:000609', NULL, NULL, 'Neutrophil cytosolic factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(142168, NULL, 'G3DSA:1.25.40.770:FF:000006', NULL, NULL, 'Unplaced genomic scaffold supercont1.10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(142169, NULL, 'G3DSA:2.60.40.60:FF:000361', NULL, NULL, 'Protocadherin Fat', NULL, NULL, NULL, NULL, NULL, 4),
(142170, NULL, 'G3DSA:3.80.10.10:FF:001954', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(142171, NULL, 'G3DSA:3.30.160.60:FF:000256', NULL, NULL, 'PLAG1 like zinc finger 2', NULL, NULL, NULL, NULL, NULL, 4),
(142172, NULL, 'G3DSA:2.130.10.10:FF:000464', NULL, NULL, 'Ribosome assembly protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(142173, NULL, 'G3DSA:1.20.1070.10:FF:001171', NULL, NULL, 'Adhesion G protein-coupled receptor L3', NULL, NULL, NULL, NULL, NULL, 4),
(142174, NULL, 'G3DSA:3.40.50.11980:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(142175, NULL, 'G3DSA:3.40.1190.20:FF:000035', NULL, NULL, 'Pyridoxal kinase', NULL, NULL, NULL, NULL, NULL, 4),
(142176, NULL, 'G3DSA:1.10.8.60:FF:000031', NULL, NULL, 'vesicle-fusing ATPase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(142177, NULL, 'G3DSA:3.30.70.330:FF:001295', NULL, NULL, 'Glycine-rich RNA-binding protein RZ1B', NULL, NULL, NULL, NULL, NULL, 4),
(142178, NULL, 'G3DSA:1.10.3810.10:FF:000022', NULL, NULL, 'Glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(142179, NULL, 'G3DSA:1.10.10.10:FF:001422', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(142180, NULL, 'G3DSA:2.40.30.130:FF:000003', NULL, NULL, 'alanyl-tRNA editing protein Aarsd1', NULL, NULL, NULL, NULL, NULL, 4),
(142181, NULL, 'G3DSA:2.30.30.20:FF:000001', NULL, NULL, 'Aspartate carbamoyltransferase regulatory chain', NULL, NULL, NULL, NULL, NULL, 4),
(142182, NULL, 'G3DSA:3.90.980.20:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142183, NULL, 'G3DSA:1.10.287.70:FF:000065', NULL, NULL, 'sodium leak channel non-selective protein', NULL, NULL, NULL, NULL, NULL, 4),
(142184, NULL, 'G3DSA:1.10.3430.10:FF:000032', NULL, NULL, 'Ammonium transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142185, NULL, 'G3DSA:3.30.60.30:FF:000116', NULL, NULL, 'Serine protease inhibitor, Kazal-type family protein', NULL, NULL, NULL, NULL, NULL, 4),
(142186, NULL, 'G3DSA:2.10.25.10:FF:000217', NULL, NULL, 'SCO-spondin', NULL, NULL, NULL, NULL, NULL, 4),
(142187, NULL, 'G3DSA:1.25.70.10:FF:000083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142188, NULL, 'G3DSA:1.10.286.20:FF:000003', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(142189, NULL, 'G3DSA:3.10.100.10:FF:000135', NULL, NULL, 'GM16651', NULL, NULL, NULL, NULL, NULL, 4),
(142190, NULL, 'G3DSA:3.40.50.1240:FF:000054', NULL, NULL, 'Putative phosphomutase', NULL, NULL, NULL, NULL, NULL, 4),
(142191, NULL, 'G3DSA:3.30.470.20:FF:000245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142192, NULL, 'G3DSA:2.60.40.10:FF:002740', NULL, NULL, 'Chitin binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(142193, NULL, 'G3DSA:3.40.50.1820:FF:000599', NULL, NULL, 'Chromosome 23, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(142194, NULL, 'G3DSA:1.25.40.20:FF:000584', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142195, NULL, 'G3DSA:3.40.50.720:FF:001832', NULL, NULL, 'Calcium-activated potassium channel slowpoke-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(142196, NULL, 'G3DSA:1.25.40.10:FF:002178', NULL, NULL, 'Tetratricopeptide repeat domain 21A', NULL, NULL, NULL, NULL, NULL, 4),
(142197, NULL, 'G3DSA:2.30.140.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142198, NULL, 'G3DSA:3.30.40.10:FF:001424', NULL, NULL, 'RING finger protein 37', NULL, NULL, NULL, NULL, NULL, 4),
(142199, NULL, 'G3DSA:1.20.1250.20:FF:000193', NULL, NULL, 'Solute carrier family 45 member 3', NULL, NULL, NULL, NULL, NULL, 4),
(142200, NULL, 'G3DSA:3.40.50.620:FF:000167', NULL, NULL, 'Choline-phosphate cytidylyltransferase B', NULL, NULL, NULL, NULL, NULL, 4),
(142201, NULL, 'G3DSA:3.30.450.20:FF:000362', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(142202, NULL, 'G3DSA:3.30.200.20:FF:000439', NULL, NULL, 'Tribbles pseudokinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(142203, NULL, 'G3DSA:1.10.730.10:FF:000027', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(142204, NULL, 'G3DSA:2.60.40.1180:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142205, NULL, 'G3DSA:1.20.1560.10:FF:000303', NULL, NULL, 'ABC transporter PGP-2', NULL, NULL, NULL, NULL, NULL, 4),
(142206, NULL, 'G3DSA:1.10.238.10:FF:000794', NULL, NULL, 'Reticulocalbin 1', NULL, NULL, NULL, NULL, NULL, 4),
(142207, NULL, 'G3DSA:1.20.58.60:FF:000714', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142208, NULL, 'G3DSA:2.10.110.10:FF:000078', NULL, NULL, 'Protein DA1-related 1', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(142209, NULL, 'G3DSA:2.130.10.10:FF:005135', NULL, NULL, 'WD-repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(142210, NULL, 'G3DSA:1.25.10.10:FF:003300', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(142211, NULL, 'G3DSA:1.25.10.10:FF:000990', NULL, NULL, 'AGAP006942-PA', NULL, NULL, NULL, NULL, NULL, 4),
(142212, NULL, 'G3DSA:1.10.533.10:FF:000283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142213, NULL, 'G3DSA:3.40.50.720:FF:000208', NULL, NULL, 'Prephenate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(142214, NULL, 'G3DSA:2.30.22.10:FF:000013', NULL, NULL, 'Protein GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(142215, NULL, 'G3DSA:2.30.30.40:FF:000007', NULL, NULL, 'nebulin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(142216, NULL, 'G3DSA:1.25.10.10:FF:002900', NULL, NULL, 'Protein CBG21459', NULL, NULL, NULL, NULL, NULL, 4),
(142217, NULL, 'G3DSA:1.10.10.10:FF:001208', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(142218, NULL, 'G3DSA:1.10.1450.10:FF:000027', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(142219, NULL, 'G3DSA:3.40.50.300:FF:002893', NULL, NULL, 'Rab_B04 protein', NULL, NULL, NULL, NULL, NULL, 4),
(142220, NULL, 'G3DSA:1.50.40.10:FF:000293', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142221, NULL, 'G3DSA:3.30.1370.10:FF:000200', NULL, NULL, 'Vigilin 1', NULL, NULL, NULL, NULL, NULL, 4),
(142222, NULL, 'G3DSA:1.10.510.10:FF:002063', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142223, NULL, 'G3DSA:1.10.287.1970:FF:000006', NULL, NULL, 'Alanine aminotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142224, NULL, 'G3DSA:3.90.780.10:FF:000044', NULL, NULL, 'YALI0D13640p', NULL, NULL, NULL, NULL, NULL, 4),
(142225, NULL, 'G3DSA:3.40.50.1820:FF:001785', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(142226, NULL, 'G3DSA:2.170.130.20:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142227, NULL, 'G3DSA:3.30.40.10:FF:000800', NULL, NULL, 'Slx8p', NULL, NULL, NULL, NULL, NULL, 4),
(142228, NULL, 'G3DSA:1.20.1070.10:FF:002132', NULL, NULL, 'Smoothend-like protein protein', NULL, NULL, NULL, NULL, NULL, 4),
(142229, NULL, 'G3DSA:2.60.40.10:FF:000716', NULL, NULL, 'T-cell-specific surface glycoprotein CD28', NULL, NULL, NULL, NULL, NULL, 4),
(142230, NULL, 'G3DSA:2.60.40.60:FF:000580', NULL, NULL, 'Cadherin 1, type 1', NULL, NULL, NULL, NULL, NULL, 4),
(142231, NULL, 'G3DSA:2.60.40.790:FF:000024', NULL, NULL, 'heat shock protein beta-1', NULL, NULL, NULL, NULL, NULL, 4),
(142232, NULL, 'G3DSA:3.30.890.10:FF:000004', NULL, NULL, 'Methyl-CpG-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(142233, NULL, 'G3DSA:2.170.150.20:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142234, NULL, 'G3DSA:1.25.10.10:FF:001838', NULL, NULL, 'Dynein, axonemal, assembly factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(142235, NULL, 'G3DSA:3.30.450.20:FF:000250', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(142236, NULL, 'G3DSA:3.40.50.150:FF:000447', NULL, NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(142237, NULL, 'G3DSA:1.10.10.10:FF:001203', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(142238, NULL, 'G3DSA:1.20.1070.10:FF:001856', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142239, NULL, 'G3DSA:1.25.40.10:FF:002627', NULL, NULL, 'Intraflagellar transport protein 88 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(142240, NULL, 'G3DSA:3.40.50.450:FF:000094', NULL, NULL, 'ATP-dependent 6-phosphofructokinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(142241, NULL, 'G3DSA:1.10.10.60:FF:000015', NULL, NULL, 'Transcription factor RAX3', NULL, NULL, NULL, NULL, NULL, 4),
(142242, NULL, 'G3DSA:1.10.472.10:FF:000146', NULL, NULL, 'Bur2p', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(142243, NULL, 'G3DSA:2.130.10.10:FF:005242', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(142244, NULL, 'G3DSA:3.40.50.300:FF:005641', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142245, NULL, 'G3DSA:2.70.150.10:FF:000230', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(142246, NULL, 'G3DSA:2.130.10.10:FF:002836', NULL, NULL, 'Protein TSSC1', NULL, NULL, NULL, NULL, NULL, 4),
(142247, NULL, 'G3DSA:2.20.70.10:FF:000203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142248, NULL, 'G3DSA:1.10.238.10:FF:000125', NULL, NULL, 'Reticulocalbin 2', NULL, NULL, NULL, NULL, NULL, 4),
(142249, NULL, 'G3DSA:3.40.50.300:FF:001605', NULL, NULL, 'Bacitracin ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(142250, NULL, 'G3DSA:3.30.450.70:FF:000023', NULL, NULL, 'Synbindin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142251, NULL, 'G3DSA:3.30.160.60:FF:005039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142252, NULL, 'G3DSA:1.10.10.60:FF:000690', NULL, NULL, 'Transcriptional regulator, AraC/XylS family', NULL, NULL, NULL, NULL, NULL, 4),
(142253, NULL, 'G3DSA:3.40.50.2300:FF:001030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142254, NULL, 'G3DSA:3.30.70.330:FF:000002', NULL, NULL, '50S ribosomal protein L23, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(142255, NULL, 'G3DSA:2.60.120.330:FF:000238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142256, NULL, 'G3DSA:1.20.5.370:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142257, NULL, 'G3DSA:1.10.510.10:FF:001006', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(142258, NULL, 'G3DSA:1.10.10.10:FF:000933', NULL, NULL, 'Blast:AT-rich interactive domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(142259, NULL, 'G3DSA:3.60.15.10:FF:000128', NULL, NULL, 'Unplaced genomic scaffold supercont2.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(142260, NULL, 'G3DSA:3.30.559.10:FF:000173', NULL, NULL, 'Nonribosomal peptide synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(142261, NULL, 'G3DSA:3.40.50.2300:FF:001373', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142262, NULL, 'G3DSA:1.10.246.20:FF:000006', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 15', NULL, NULL, NULL, NULL, NULL, 4),
(142263, NULL, 'G3DSA:1.20.120.1880:FF:000017', NULL, NULL, 'Nucleoporin 155', NULL, NULL, NULL, NULL, NULL, 4),
(142264, NULL, 'G3DSA:1.20.58.60:FF:000158', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(142265, NULL, 'G3DSA:3.40.1810.10:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142266, NULL, 'G3DSA:3.30.70.330:FF:000345', NULL, NULL, 'Serine/arginine-rich splicing factor 9', NULL, NULL, NULL, NULL, NULL, 4),
(142267, NULL, 'G3DSA:3.30.750.24:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142268, NULL, 'G3DSA:3.40.30.10:FF:000990', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142269, NULL, 'G3DSA:3.30.160.60:FF:004527', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142270, NULL, 'G3DSA:2.50.20.10:FF:000002', NULL, NULL, 'Outer-membrane lipoprotein LolB', NULL, NULL, NULL, NULL, NULL, 4),
(142271, NULL, 'G3DSA:3.80.10.10:FF:003516', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142272, NULL, 'G3DSA:3.90.550.10:FF:000578', NULL, NULL, 'UDP-N-acetylglucosamine-pyrophosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(142273, NULL, 'G3DSA:3.40.50.300:FF:000077', NULL, NULL, 'Probable DNA repair helicase RAD25', NULL, NULL, NULL, NULL, NULL, 4),
(142274, NULL, 'G3DSA:2.60.40.60:FF:001092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142275, NULL, 'G3DSA:2.30.29.30:FF:000052', NULL, NULL, 'Sprouty-related, EVH1 domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(142276, NULL, 'G3DSA:3.40.120.10:FF:000006', NULL, NULL, 'Phosphoglucomutase PgmA', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(142277, NULL, 'G3DSA:3.40.50.2300:FF:000754', NULL, NULL, 'Chromosome-Segregation and RNAi deficient', NULL, NULL, NULL, NULL, NULL, 4),
(142278, NULL, 'G3DSA:2.40.20.10:FF:000087', NULL, NULL, 'Muscle, skeletal, receptor tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(142279, NULL, 'G3DSA:3.90.70.10:FF:000338', NULL, NULL, 'Cathepsin 7', NULL, NULL, NULL, NULL, NULL, 4),
(142280, NULL, 'G3DSA:2.40.50.140:FF:000443', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(142281, NULL, 'G3DSA:3.40.309.10:FF:000080', NULL, NULL, 'Succinate-semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(142282, NULL, 'G3DSA:2.30.29.30:FF:001226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142283, NULL, 'G3DSA:2.10.25.10:FF:001622', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(142284, NULL, 'G3DSA:1.10.8.810:FF:000002', NULL, NULL, 'Daxx-like protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(142285, NULL, 'G3DSA:2.10.70.10:FF:000288', NULL, NULL, 'Mannan binding lectin serine peptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(142286, NULL, 'G3DSA:3.40.50.300:FF:006260', NULL, NULL, 'Swi/snf family helicase_2', NULL, NULL, NULL, NULL, NULL, 4),
(142287, NULL, 'G3DSA:2.10.25.10:FF:000998', NULL, NULL, 'Latent-transforming growth factor beta-binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(142288, NULL, 'G3DSA:2.60.40.60:FF:000473', NULL, NULL, 'cadherin EGF LAG seven-pass G-type receptor 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(142289, NULL, 'G3DSA:3.60.20.10:FF:000101', NULL, NULL, 'Proteasome subunit alpha type', NULL, NULL, NULL, NULL, NULL, 4),
(142290, NULL, 'G3DSA:1.10.3520.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142291, NULL, 'G3DSA:2.60.40.10:FF:004320', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142292, NULL, 'G3DSA:2.160.20.80:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142293, NULL, 'G3DSA:3.40.50.10710:FF:000005', NULL, NULL, 'Ribonuclease J', NULL, NULL, NULL, NULL, NULL, 4),
(142294, NULL, 'G3DSA:1.20.1110.10:FF:000258', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142295, NULL, 'G3DSA:3.30.720.50:FF:000010', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(142296, NULL, 'G3DSA:3.40.50.200:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142297, NULL, 'G3DSA:2.60.40.10:FF:003696', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142298, NULL, 'G3DSA:1.25.40.10:FF:001666', NULL, NULL, 'Crooked neck protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142299, NULL, 'G3DSA:2.10.25.10:FF:001274', NULL, NULL, 'slit homolog 2 protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(142300, NULL, 'G3DSA:3.30.565.10:FF:000457', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142301, NULL, 'G3DSA:3.90.1480.20:FF:000057', NULL, NULL, 'ST3 beta-galactoside alpha-2,3-sialyltransferase 3b', NULL, NULL, NULL, NULL, NULL, 4),
(142302, NULL, 'G3DSA:3.40.850.10:FF:000303', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(142303, NULL, 'G3DSA:1.10.730.10:FF:000022', NULL, NULL, 'Methionyl-tRNA synthetase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(142304, NULL, 'G3DSA:1.10.630.10:FF:000205', NULL, NULL, 'Cyp6w1, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(142305, NULL, 'G3DSA:2.130.10.10:FF:002151', NULL, NULL, 'Sortilin-related VPS10 domain-containing receptor 3b', NULL, NULL, NULL, NULL, NULL, 4),
(142306, NULL, 'G3DSA:1.10.168.20:FF:000004', NULL, NULL, '40S ribosomal protein S8', NULL, NULL, NULL, NULL, NULL, 4),
(142307, NULL, 'G3DSA:3.30.160.60:FF:004185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142308, NULL, 'G3DSA:2.60.220.50:FF:000143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142309, NULL, 'G3DSA:3.40.50.300:FF:006821', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142310, NULL, 'G3DSA:3.30.160.60:FF:004078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(142311, NULL, 'G3DSA:4.10.60.10:FF:000002', NULL, NULL, 'cellular nucleic acid-binding protein-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(142312, NULL, 'G3DSA:2.60.40.630:FF:000004', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(142313, NULL, 'G3DSA:2.130.10.10:FF:001875', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(142314, NULL, 'G3DSA:3.30.420.40:FF:000647', NULL, NULL, 'Actin-related protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(142315, NULL, 'G3DSA:3.30.160.60:FF:001779', NULL, NULL, 'Zinc finger and SCAN domain containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(142316, NULL, 'G3DSA:3.40.50.300:FF:002550', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(142317, NULL, 'G3DSA:3.30.500.10:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142318, NULL, 'G3DSA:2.40.70.10:FF:000276', NULL, NULL, 'Putative aspartic endopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(142319, NULL, 'G3DSA:1.25.40.20:FF:001096', NULL, NULL, 'E3 ubiquitin-protein ligase MIB2-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(142320, NULL, 'G3DSA:3.30.559.70:FF:000033', NULL, NULL, 'Carnitine O-palmitoyltransferase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(142321, NULL, 'G3DSA:3.30.1050.10:FF:000053', NULL, NULL, 'Sterol carrier protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(142322, NULL, 'G3DSA:3.10.110.10:FF:000080', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 R1', NULL, NULL, NULL, NULL, NULL, 4),
(142323, NULL, 'G3DSA:3.30.300.130:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142324, NULL, 'G3DSA:3.40.50.2000:FF:000092', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(142325, NULL, 'G3DSA:2.130.10.10:FF:003792', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142326, NULL, 'G3DSA:3.40.50.300:FF:000296', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(142327, NULL, 'G3DSA:1.20.59.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142328, NULL, 'G3DSA:1.25.40.10:FF:002048', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(142329, NULL, 'G3DSA:3.90.226.10:FF:000313', NULL, NULL, 'EnoylCoA hydratase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142330, NULL, 'G3DSA:1.10.510.10:FF:003131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142331, NULL, 'G3DSA:1.10.510.10:FF:002855', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(142332, NULL, 'G3DSA:3.40.190.10:FF:000516', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(142333, NULL, 'G3DSA:3.10.290.20:FF:000022', NULL, NULL, 'Ubiquitin-activating enzyme E1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142334, NULL, 'G3DSA:2.30.29.30:FF:000607', NULL, NULL, 'RTT106p Histone chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(142335, NULL, 'G3DSA:3.30.2020.30:FF:000006', NULL, NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(142336, NULL, 'G3DSA:3.40.50.300:FF:001044', NULL, NULL, 'Extra-large guanine nucleotide-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(142337, NULL, 'G3DSA:2.40.30.110:FF:000008', NULL, NULL, 'Sarcosine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(142338, NULL, 'G3DSA:3.30.160.60:FF:000475', NULL, NULL, 'zinc finger protein 32 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(142339, NULL, 'G3DSA:1.10.2000.10:FF:000005', NULL, NULL, 'secreted frizzled-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(142340, NULL, 'G3DSA:1.10.472.10:FF:000601', NULL, NULL, 'Cyclin-B1-4', NULL, NULL, NULL, NULL, NULL, 4),
(142341, NULL, 'G3DSA:2.70.50.30:FF:000009', NULL, NULL, 'RHO protein GDP dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(142342, NULL, 'G3DSA:3.40.50.2300:FF:001480', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142343, NULL, 'G3DSA:3.40.50.1100:FF:000259', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(142344, NULL, 'G3DSA:3.30.450.30:FF:000016', NULL, NULL, 'Profilin', NULL, NULL, NULL, NULL, NULL, 4),
(142345, NULL, 'G3DSA:2.130.10.10:FF:002499', NULL, NULL, 'Intraflagellar transport protein 122 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(142346, NULL, 'G3DSA:3.90.260.10:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142347, NULL, 'G3DSA:1.20.120.310:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142348, NULL, 'G3DSA:1.10.579.10:FF:000012', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(142349, NULL, 'G3DSA:3.30.160.60:FF:001223', NULL, NULL, 'Zinc finger protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(142350, NULL, 'G3DSA:1.10.418.10:FF:000111', NULL, NULL, 'Fimbrin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142351, NULL, 'G3DSA:2.130.10.10:FF:001190', NULL, NULL, 'DDB1 and CUL4 associated factor 12', NULL, NULL, NULL, NULL, NULL, 4),
(142352, NULL, 'G3DSA:3.50.50.60:FF:000556', NULL, NULL, 'Pyridine nucleotide-disulfide oxidoreductase/Thi4 family/FAD dependent oxidoreductase/NAD(P)-binding Rossmann-like domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142353, NULL, 'G3DSA:1.10.8.10:FF:000151', NULL, NULL, 'UBA/TS-N domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(142354, NULL, 'G3DSA:3.30.1360.120:FF:000008', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(142355, NULL, 'G3DSA:1.10.3170.10:FF:000012', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(142356, NULL, 'G3DSA:1.10.950.10:FF:000010', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(142357, NULL, 'G3DSA:3.30.1360.100:FF:000002', NULL, NULL, 'Type II secretion system protein M', NULL, NULL, NULL, NULL, NULL, 4),
(142358, NULL, 'G3DSA:3.30.160.60:FF:005146', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142359, NULL, 'G3DSA:3.30.810.10:FF:000016', NULL, NULL, 'Phosphatidylinositol phosphate kinase alpha', NULL, NULL, NULL, NULL, NULL, 4),
(142360, NULL, 'G3DSA:1.20.1110.10:FF:000039', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(142361, NULL, 'G3DSA:3.90.70.10:FF:000468', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142362, NULL, 'G3DSA:2.130.10.10:FF:005927', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(142363, NULL, 'G3DSA:3.30.160.60:FF:000599', NULL, NULL, 'ras-responsive element-binding protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(142364, NULL, 'G3DSA:3.10.450.50:FF:000004', NULL, NULL, 'Nuclear RNA export factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(142365, NULL, 'G3DSA:1.20.1530.20:FF:000012', NULL, NULL, 'sodium/hydrogen exchanger 9B2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(142366, NULL, 'G3DSA:3.10.580.10:FF:000120', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(142367, NULL, 'G3DSA:3.40.850.10:FF:000180', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(142368, NULL, 'G3DSA:3.40.50.300:FF:008058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142369, NULL, 'G3DSA:1.10.510.10:FF:000483', NULL, NULL, 'Cell division cycle 7-related protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(142370, NULL, 'G3DSA:3.40.50.300:FF:007569', NULL, NULL, 'RAD3-like DNA-binding helicase protein', NULL, NULL, NULL, NULL, NULL, 4),
(142371, NULL, 'G3DSA:3.30.160.60:FF:000823', NULL, NULL, 'replication initiator 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(142372, NULL, 'G3DSA:3.50.30.10:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142373, NULL, 'G3DSA:2.60.260.20:FF:000165', NULL, NULL, 'DnaJ homolog 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(142374, NULL, 'G3DSA:2.130.10.10:FF:000026', NULL, NULL, 'cytoplasmic dynein 1 intermediate chain 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(142375, NULL, 'G3DSA:2.60.200.20:FF:000150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142376, NULL, 'G3DSA:1.20.144.10:FF:000062', NULL, NULL, 'Phosphatase PAP2 family protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(142377, NULL, 'G3DSA:3.90.740.10:FF:000053', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(142378, NULL, 'G3DSA:3.30.70.1660:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142379, NULL, 'G3DSA:1.20.1250.20:FF:001497', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142380, NULL, 'G3DSA:2.30.38.10:FF:000010', NULL, NULL, 'Long-chain fatty acid--CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(142381, NULL, 'G3DSA:3.30.60.270:FF:000010', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(142382, NULL, 'G3DSA:2.60.40.10:FF:001223', NULL, NULL, 'Sidekick cell adhesion molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(142383, NULL, 'G3DSA:1.10.287.2250:FF:000001', NULL, NULL, 'Cathepsin F', NULL, NULL, NULL, NULL, NULL, 4),
(142384, NULL, 'G3DSA:2.40.10.10:FF:000261', NULL, NULL, 'Transmembrane serine protease 5', NULL, NULL, NULL, NULL, NULL, 4),
(142385, NULL, 'G3DSA:1.20.1250.20:FF:001845', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142386, NULL, 'G3DSA:2.60.40.10:FF:000823', NULL, NULL, 'Tyrosine-protein phosphatase 10D', NULL, NULL, NULL, NULL, NULL, 4),
(142387, NULL, 'G3DSA:2.110.10.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142388, NULL, 'G3DSA:3.40.50.300:FF:000425', NULL, NULL, 'Probable ABC transporter, ATP-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(142389, NULL, 'G3DSA:1.10.510.10:FF:002170', NULL, NULL, 'Probable serine/threonine-protein kinase MARK-A', NULL, NULL, NULL, NULL, NULL, 4),
(142390, NULL, 'G3DSA:2.40.100.10:FF:000082', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(142391, NULL, 'G3DSA:3.30.565.10:FF:000007', NULL, NULL, 'Mitochondrial pyruvate dehydrogenase kinase isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(142392, NULL, 'G3DSA:3.90.1150.10:FF:000423', NULL, NULL, 'Cobalamin biosynthetic protein CobC', NULL, NULL, NULL, NULL, NULL, 4),
(142393, NULL, 'G3DSA:3.80.10.10:FF:001499', NULL, NULL, 'Leucine-rich repeat-containing protein 70', NULL, NULL, NULL, NULL, NULL, 4),
(142394, NULL, 'G3DSA:3.30.540.10:FF:000023', NULL, NULL, 'Protein CBR-TAG-231', NULL, NULL, NULL, NULL, NULL, 4),
(142395, NULL, 'G3DSA:2.40.30.270:FF:000028', NULL, NULL, 'DNA replication helicase DNA2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142396, NULL, 'G3DSA:2.130.10.10:FF:004753', NULL, NULL, 'Ribosome biogenesis protein nsa1', NULL, NULL, NULL, NULL, NULL, 4),
(142397, NULL, 'G3DSA:2.130.10.10:FF:001532', NULL, NULL, 'Small nucleolar ribonucleoprotein complex subunit (Pwp2), putative', NULL, NULL, NULL, NULL, NULL, 4),
(142398, NULL, 'G3DSA:3.30.420.40:FF:000304', NULL, NULL, 'Type 4 fimbrial biogenesis protein PilM', NULL, NULL, NULL, NULL, NULL, 4),
(142399, NULL, 'G3DSA:3.40.50.300:FF:004348', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(142400, NULL, 'G3DSA:3.80.10.10:FF:002123', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(142401, NULL, 'G3DSA:3.80.10.10:FF:002336', NULL, NULL, 'Putative leucine-rich repeat receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(142402, NULL, 'G3DSA:1.10.260.100:FF:000004', NULL, NULL, 'Putative stress-induced-phosphoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(142403, NULL, 'G3DSA:2.20.25.20:FF:000012', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(142404, NULL, 'G3DSA:3.90.1100.10:FF:000021', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(142405, NULL, 'G3DSA:3.40.50.1460:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142406, NULL, 'G3DSA:1.10.472.80:FF:000257', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142407, NULL, 'G3DSA:2.40.128.630:FF:000006', NULL, NULL, 'Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(142408, NULL, 'G3DSA:2.60.120.260:FF:000532', NULL, NULL, 'Putative secreted beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(142409, NULL, 'G3DSA:3.60.140.10:FF:000008', NULL, NULL, 'Polyphenol oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(142410, NULL, 'G3DSA:1.20.120.330:FF:000029', NULL, NULL, 'Aminoglycoside 6-adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(142411, NULL, 'G3DSA:3.50.50.60:FF:001517', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142412, NULL, 'G3DSA:2.30.30.60:FF:000002', NULL, NULL, 'Mechanosensitive ion channel family protein', NULL, NULL, NULL, NULL, NULL, 4),
(142413, NULL, 'G3DSA:3.80.10.10:FF:001847', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(142414, NULL, 'G3DSA:1.10.220.150:FF:000028', NULL, NULL, 'ADP-ribosylation factor GTPase activating protein 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142415, NULL, 'G3DSA:2.70.170.10:FF:000113', NULL, NULL, 'Gamma-aminobutyric acid type A receptor pi subunit', NULL, NULL, NULL, NULL, NULL, 4),
(142416, NULL, 'G3DSA:1.20.140.100:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142417, NULL, 'G3DSA:3.30.70.330:FF:003088', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142418, NULL, 'G3DSA:3.30.830.10:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142419, NULL, 'G3DSA:3.40.50.2000:FF:000108', NULL, NULL, 'UDP-glycosyltransferase 83A1', NULL, NULL, NULL, NULL, NULL, 4),
(142420, NULL, 'G3DSA:1.25.10.10:FF:002114', NULL, NULL, 'Formin-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(142421, NULL, 'G3DSA:1.10.20.10:FF:000068', NULL, NULL, 'Nuclear factor Y transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(142422, NULL, 'G3DSA:2.10.70.10:FF:000069', NULL, NULL, 'Complement component receptor type 1', NULL, NULL, NULL, NULL, NULL, 4),
(142423, NULL, 'G3DSA:1.20.1250.20:FF:000086', NULL, NULL, 'ascorbate transporter, chloroplastic isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(142424, NULL, 'G3DSA:3.30.870.10:FF:000121', NULL, NULL, 'Cardiolipin synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(142425, NULL, 'G3DSA:2.60.40.10:FF:000262', NULL, NULL, 'MAM domain containing glycosylphosphatidylinositol anchor 1', NULL, NULL, NULL, NULL, NULL, 4),
(142426, NULL, 'G3DSA:3.40.50.10890:FF:000014', NULL, NULL, 'Integrator complex subunit 11', NULL, NULL, NULL, NULL, NULL, 4),
(142427, NULL, 'G3DSA:3.30.450.40:FF:000132', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(142428, NULL, 'G3DSA:3.30.300.30:FF:000028', NULL, NULL, 'AMP-dependent synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(142429, NULL, 'G3DSA:2.70.50.50:FF:000004', NULL, NULL, 'Chitin binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(142430, NULL, 'G3DSA:3.90.1300.10:FF:000002', NULL, NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit A, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(142431, NULL, 'G3DSA:3.30.1360.10:FF:000031', NULL, NULL, 'DNA-directed RNA polymerase RPB3', NULL, NULL, NULL, NULL, NULL, 4),
(142432, NULL, 'G3DSA:3.30.160.60:FF:003460', NULL, NULL, 'Early growth response protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(142433, NULL, 'G3DSA:1.10.1900.10:FF:000006', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(142434, NULL, 'G3DSA:1.10.510.10:FF:001787', NULL, NULL, 'Kitb', NULL, NULL, NULL, NULL, NULL, 4),
(142435, NULL, 'G3DSA:2.130.10.10:FF:002948', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142436, NULL, 'G3DSA:3.30.565.10:FF:000226', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(142437, NULL, 'G3DSA:3.30.160.60:FF:006096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142438, NULL, 'G3DSA:3.20.20.70:FF:000300', NULL, NULL, 'GTP 3'',8-cyclase 2', NULL, NULL, NULL, NULL, NULL, 4),
(142439, NULL, 'G3DSA:1.25.40.10:FF:000598', NULL, NULL, 'pentatricopeptide repeat-containing protein At1g20230 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(142440, NULL, 'G3DSA:3.30.50.10:FF:000065', NULL, NULL, 'GATA transcription factor LreA', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(142441, NULL, 'G3DSA:1.10.10.10:FF:001990', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142442, NULL, 'G3DSA:3.40.50.970:FF:000036', NULL, NULL, '2-oxoglutarate dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(142443, NULL, 'G3DSA:3.30.420.10:FF:000200', NULL, NULL, 'Protein CBG10739', NULL, NULL, NULL, NULL, NULL, 4),
(142444, NULL, 'G3DSA:3.40.50.1980:FF:000152', NULL, NULL, 'Iron ABC transporter, periplasmic substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(142445, NULL, 'G3DSA:3.90.550.10:FF:000454', NULL, NULL, 'Slr1537 protein', NULL, NULL, NULL, NULL, NULL, 4),
(142446, NULL, 'G3DSA:3.30.200.20:FF:000883', NULL, NULL, 'OSJNBb0096E05.1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(142447, NULL, 'G3DSA:2.30.30.40:FF:000451', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(142448, NULL, 'G3DSA:3.90.660.10:FF:000120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142449, NULL, 'G3DSA:1.25.40.20:FF:000707', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(142450, NULL, 'G3DSA:1.20.1050.10:FF:000096', NULL, NULL, 'TCHQD class glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(142451, NULL, 'G3DSA:2.60.120.200:FF:000087', NULL, NULL, 'Laminin subunit alpha 4', NULL, NULL, NULL, NULL, NULL, 4),
(142452, NULL, 'G3DSA:1.10.260.100:FF:000010', NULL, NULL, 'Hsp70/Hsp90 organizing protein', NULL, NULL, NULL, NULL, NULL, 4),
(142453, NULL, 'G3DSA:3.30.450.200:FF:000009', NULL, NULL, 'Receptor Mediated Endocytosis', NULL, NULL, NULL, NULL, NULL, 4),
(142454, NULL, 'G3DSA:3.40.50.1240:FF:000178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142455, NULL, 'G3DSA:3.90.640.10:FF:000012', NULL, NULL, 'Hypoxia up-regulated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(142456, NULL, 'G3DSA:3.30.200.20:FF:002120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142457, NULL, 'G3DSA:2.60.120.590:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142458, NULL, 'G3DSA:1.10.3210.10:FF:000049', NULL, NULL, 'Inositol oxygenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(142459, NULL, 'G3DSA:3.30.160.60:FF:002509', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142460, NULL, 'G3DSA:2.70.240.10:FF:000001', NULL, NULL, 'Alpha-hemolysin', NULL, NULL, NULL, NULL, NULL, 4),
(142461, NULL, 'G3DSA:1.25.40.10:FF:002739', NULL, NULL, 'Peptidase family C50-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(142462, NULL, 'G3DSA:1.20.1050.140:FF:000002', NULL, NULL, 'H(2):CoB-CoM heterodisulfide,ferredoxin reductase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(142463, NULL, 'G3DSA:3.40.640.10:FF:000023', NULL, NULL, 'Transcriptional regulator, GntR family', NULL, NULL, NULL, NULL, NULL, 4),
(142464, NULL, 'G3DSA:2.60.40.10:FF:005045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142465, NULL, 'G3DSA:3.30.1120.130:FF:000003', NULL, NULL, 'Probable serine/threonine-protein kinase zyg-1', NULL, NULL, NULL, NULL, NULL, 4),
(142466, NULL, 'G3DSA:3.40.1280.30:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142467, NULL, 'G3DSA:3.90.600.20:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142468, NULL, 'G3DSA:3.50.50.60:FF:000106', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(142469, NULL, 'G3DSA:2.60.40.10:FF:002392', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(142470, NULL, 'G3DSA:1.10.287.70:FF:000520', NULL, NULL, 'Phosphomevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(142471, NULL, 'G3DSA:2.10.25.10:FF:000892', NULL, NULL, 'Putative wall-associated kinase', NULL, NULL, NULL, NULL, NULL, 4),
(142472, NULL, 'G3DSA:2.10.220.10:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142473, NULL, 'G3DSA:1.10.238.10:FF:000338', NULL, NULL, 'Probable calcium-binding protein CML35', NULL, NULL, NULL, NULL, NULL, 4),
(142474, NULL, 'G3DSA:1.10.510.10:FF:003024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(142475, NULL, 'G3DSA:3.40.50.300:FF:000189', NULL, NULL, 'Member of ras oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(142476, NULL, 'G3DSA:3.40.50.150:FF:000919', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142477, NULL, 'G3DSA:2.60.40.380:FF:000002', NULL, NULL, 'Alkaline phosphatase D', NULL, NULL, NULL, NULL, NULL, 4),
(142478, NULL, 'G3DSA:3.40.50.10810:FF:000029', NULL, NULL, 'ERCC excision repair 6-like, spindle assembly checkpoint helicase', NULL, NULL, NULL, NULL, NULL, 4),
(142479, NULL, 'G3DSA:3.30.70.20:FF:000069', NULL, NULL, 'DNA-directed RNA polymerase II subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142480, NULL, 'G3DSA:1.20.1050.10:FF:000107', NULL, NULL, 'Glutathione S-transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(142481, NULL, 'G3DSA:2.60.40.10:FF:004533', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142482, NULL, 'G3DSA:1.10.510.10:FF:002512', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142483, NULL, 'G3DSA:1.10.287.110:FF:000162', NULL, NULL, 'Chaperone protein dnaJ C76, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(142484, NULL, 'G3DSA:1.20.1420.30:FF:000012', NULL, NULL, 'Vacuolar cation/proton exchanger', NULL, NULL, NULL, NULL, NULL, 4),
(142485, NULL, 'G3DSA:2.130.10.10:FF:000818', NULL, NULL, 'WD domain', NULL, NULL, NULL, NULL, NULL, 4),
(142486, NULL, 'G3DSA:3.40.50.2000:FF:000653', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(142487, NULL, 'G3DSA:3.30.160.60:FF:000368', NULL, NULL, 'Krueppel-like factor 15', NULL, NULL, NULL, NULL, NULL, 4),
(142488, NULL, 'G3DSA:1.10.10.10:FF:000354', NULL, NULL, 'COP9 signalosome complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(142489, NULL, 'G3DSA:3.30.70.1230:FF:000256', NULL, NULL, 'Adenylyl cyclase class-3/4/guanylyl cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(142490, NULL, 'G3DSA:3.40.50.1220:FF:000065', NULL, NULL, 'Sir2 family transcriptional regulator putative', NULL, NULL, NULL, NULL, NULL, 4),
(142491, NULL, 'G3DSA:1.20.1250.20:FF:001839', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142492, NULL, 'G3DSA:2.60.200.20:FF:000262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142493, NULL, 'G3DSA:3.90.660.10:FF:000007', NULL, NULL, 'Lysine-specific histone demethylase 1B', NULL, NULL, NULL, NULL, NULL, 4),
(142494, NULL, 'G3DSA:1.20.120.730:FF:000025', NULL, NULL, 'Protein transport protein Sec24A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142495, NULL, 'G3DSA:2.30.30.30:FF:000116', NULL, NULL, '5''-3'' exoribonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(142496, NULL, 'G3DSA:1.10.10.60:FF:000796', NULL, NULL, 'Homeobox and leucine zipper encoding a', NULL, NULL, NULL, NULL, NULL, 4),
(142497, NULL, 'G3DSA:1.10.196.10:FF:000004', NULL, NULL, 'regulator of G-protein signaling 12 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(142498, NULL, 'G3DSA:1.10.238.10:FF:001182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142499, NULL, 'G3DSA:3.90.550.10:FF:000347', NULL, NULL, 'Minor teichoic acid biosynthesis protein GgaA', NULL, NULL, NULL, NULL, NULL, 4),
(142500, NULL, 'G3DSA:3.40.30.10:FF:000765', NULL, NULL, 'Thiol-disulfide isomerase or thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(142501, NULL, 'G3DSA:3.30.70.330:FF:002363', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142502, NULL, 'G3DSA:3.90.70.80:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142503, NULL, 'G3DSA:3.40.50.300:FF:004478', NULL, NULL, 'ABC transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(142504, NULL, 'G3DSA:2.60.40.1730:FF:000085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142505, NULL, 'G3DSA:3.30.450.40:FF:000025', NULL, NULL, 'Stage V sporulation protein T', NULL, NULL, NULL, NULL, NULL, 4),
(142506, NULL, 'G3DSA:3.40.50.300:FF:006714', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(142507, NULL, 'G3DSA:3.40.50.150:FF:000234', NULL, NULL, 'Probable RNA methyltransferase At5g51130', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(142508, NULL, 'G3DSA:3.10.180.10:FF:000022', NULL, NULL, '4-hydroxyphenylpyruvate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(142509, NULL, 'G3DSA:1.20.1310.20:FF:000029', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(142510, NULL, 'G3DSA:3.30.460.10:FF:000197', NULL, NULL, 'ATPase synthesis protein 25, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(142511, NULL, 'G3DSA:3.30.160.60:FF:002841', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(142512, NULL, 'G3DSA:3.50.30.40:FF:000004', NULL, NULL, 'D-arabino-3-hexulose 6-phosphate formaldehyde lyase', NULL, NULL, NULL, NULL, NULL, 4),
(142513, NULL, 'G3DSA:1.20.5.900:FF:000004', NULL, NULL, 'T-cell surface glycoprotein CD4', NULL, NULL, NULL, NULL, NULL, 4),
(142514, NULL, 'G3DSA:2.70.98.20:FF:000015', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(142515, NULL, 'G3DSA:3.40.50.720:FF:001720', NULL, NULL, 'D-glycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(142516, NULL, 'G3DSA:3.40.190.10:FF:000168', NULL, NULL, 'ABC transporter, substrate-binding protein, family 3', NULL, NULL, NULL, NULL, NULL, 4),
(142517, NULL, 'G3DSA:3.40.50.300:FF:002443', NULL, NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(142518, NULL, 'G3DSA:3.40.250.10:FF:000212', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(142519, NULL, 'G3DSA:3.90.70.80:FF:000101', NULL, NULL, 'Cysteine proteinases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(142520, NULL, 'G3DSA:3.55.50.30:FF:000031', NULL, NULL, 'Fec operon regulator FecR', NULL, NULL, NULL, NULL, NULL, 4),
(142521, NULL, 'G3DSA:1.20.1070.10:FF:000108', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(142522, NULL, 'G3DSA:1.25.40.730:FF:000011', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(142523, NULL, 'G3DSA:2.130.10.10:FF:002044', NULL, NULL, 'Pre-mRNA cleavage and polyadenylation factor (CPF) complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(142524, NULL, 'G3DSA:2.30.29.30:FF:000158', NULL, NULL, 'FYVE, RhoGEF and PH domain containing 6', NULL, NULL, NULL, NULL, NULL, 4),
(142525, NULL, 'G3DSA:1.10.8.60:FF:000267', NULL, NULL, 'AAA family ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142526, NULL, 'G3DSA:1.20.1250.20:FF:001608', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142527, NULL, 'G3DSA:1.25.40.10:FF:004196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142528, NULL, 'G3DSA:1.10.510.10:FF:000258', NULL, NULL, 'Probable serine/threonine-protein kinase PBL8', NULL, NULL, NULL, NULL, NULL, 4),
(142529, NULL, 'G3DSA:1.25.10.10:FF:000085', NULL, NULL, 'Wings apart-like protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(142530, NULL, 'G3DSA:1.10.10.10:FF:001658', NULL, NULL, 'Protein CSN12 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(142531, NULL, 'G3DSA:3.40.50.2300:FF:000529', NULL, NULL, 'Gamma-aminobutyric acid type B receptor subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(142532, NULL, 'G3DSA:2.40.50.100:FF:000116', NULL, NULL, 'sn-glycerol-3-phosphate import ATP-binding protein UgpC', NULL, NULL, NULL, NULL, NULL, 4),
(142533, NULL, 'G3DSA:2.40.170.20:FF:000033', NULL, NULL, 'TonB-dependent siderophore receptor', NULL, NULL, NULL, NULL, NULL, 4),
(142534, NULL, 'G3DSA:3.30.70.330:FF:000906', NULL, NULL, 'Nuclear cap-binding protein subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(142535, NULL, 'G3DSA:1.20.120.1240:FF:000056', NULL, NULL, 'Dynamin-related protein,putative', NULL, NULL, NULL, NULL, NULL, 4),
(142536, NULL, 'G3DSA:2.40.50.90:FF:000023', NULL, NULL, 'Tudor domain containing 6', NULL, NULL, NULL, NULL, NULL, 4),
(142537, NULL, 'G3DSA:3.40.50.300:FF:004803', NULL, NULL, '6-phosphofructo-2-kinase/fructose-2, 6-bisphosphatase 2', NULL, NULL, NULL, NULL, NULL, 4),
(142538, NULL, 'G3DSA:3.40.630.10:FF:000197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(142539, NULL, 'G3DSA:2.60.40.150:FF:000063', NULL, NULL, 'Copine 4', NULL, NULL, NULL, NULL, NULL, 4),
(142540, NULL, 'G3DSA:1.20.5.390:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142541, NULL, 'G3DSA:1.10.8.270:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142542, NULL, 'G3DSA:3.40.50.410:FF:000110', NULL, NULL, 'Protein CBR-DIG-1', NULL, NULL, NULL, NULL, NULL, 4),
(142543, NULL, 'G3DSA:3.80.10.10:FF:000993', NULL, NULL, 'Dia2p', NULL, NULL, NULL, NULL, NULL, 4),
(142544, NULL, 'G3DSA:2.40.30.10:FF:000043', NULL, NULL, 'dual oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(142545, NULL, 'G3DSA:3.90.480.10:FF:000010', NULL, NULL, 'Sulfite reductase', NULL, NULL, NULL, NULL, NULL, 4),
(142546, NULL, 'G3DSA:3.30.200.20:FF:000658', NULL, NULL, 'Ethanolamine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(142547, NULL, 'G3DSA:3.90.190.10:FF:000252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142548, NULL, 'G3DSA:3.10.450.50:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142549, NULL, 'G3DSA:2.10.110.10:FF:000308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142550, NULL, 'G3DSA:1.10.150.50:FF:000040', NULL, NULL, 'Phosphatidylcholine:ceramide cholinephosphotransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(142551, NULL, 'G3DSA:2.60.40.10:FF:004426', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142552, NULL, 'G3DSA:3.40.50.261:FF:000026', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(142553, NULL, 'G3DSA:1.10.510.10:FF:000590', NULL, NULL, 'PR5-like receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(142554, NULL, 'G3DSA:3.50.50.60:FF:000337', NULL, NULL, 'GDP dissociation inhibitor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142555, NULL, 'G3DSA:1.20.1280.50:FF:000029', NULL, NULL, 'F-box only protein 30', NULL, NULL, NULL, NULL, NULL, 4),
(142556, NULL, 'G3DSA:3.50.50.60:FF:000213', NULL, NULL, 'FAD-containing monooxygenase EthA', NULL, NULL, NULL, NULL, NULL, 4),
(142557, NULL, 'G3DSA:2.60.40.10:FF:004314', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142558, NULL, 'G3DSA:3.40.50.300:FF:000532', NULL, NULL, 'ABC transporter G family member 34', NULL, NULL, NULL, NULL, NULL, 4),
(142559, NULL, 'G3DSA:1.10.540.10:FF:000086', NULL, NULL, 'Flavin-dependent monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(142560, NULL, 'G3DSA:3.40.50.2000:FF:000546', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142561, NULL, 'G3DSA:2.160.20.10:FF:000273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142562, NULL, 'G3DSA:1.25.40.10:FF:001323', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g33680', NULL, NULL, NULL, NULL, NULL, 4),
(142563, NULL, 'G3DSA:3.40.50.1820:FF:001436', NULL, NULL, 'Phospholipase A2, group VII (platelet-activating factor acetylhydrolase, plasma)', NULL, NULL, NULL, NULL, NULL, 4),
(142564, NULL, 'G3DSA:1.25.40.20:FF:001545', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142565, NULL, 'G3DSA:2.130.10.10:FF:004174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142566, NULL, 'G3DSA:2.60.40.10:FF:003589', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142567, NULL, 'G3DSA:3.30.470.20:FF:000032', NULL, NULL, 'tubulin monoglycylase TTLL3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(142568, NULL, 'G3DSA:1.10.760.10:FF:000086', NULL, NULL, 'Cytochrome c551 peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(142569, NULL, 'G3DSA:1.20.1250.20:FF:001154', NULL, NULL, 'Putative inorganic phosphate cotransporter-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(142570, NULL, 'G3DSA:1.10.720.30:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142571, NULL, 'G3DSA:3.30.2080.10:FF:000010', NULL, NULL, 'Glycoside hydrolase family 92 protein', NULL, NULL, NULL, NULL, NULL, 4),
(142572, NULL, 'G3DSA:2.60.40.10:FF:000155', NULL, NULL, 'complement C3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(142573, NULL, 'G3DSA:3.30.230.80:FF:000026', NULL, NULL, 'Heat shock protein 90C', NULL, NULL, NULL, NULL, NULL, 4),
(142574, NULL, 'G3DSA:1.10.10.60:FF:000807', NULL, NULL, 'Telomeric repeat-binding factor 2-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(142575, NULL, 'G3DSA:3.30.1010.10:FF:000056', NULL, NULL, 'Phosphatidylinositol 4-kinase alpha, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142576, NULL, 'G3DSA:3.30.40.10:FF:000351', NULL, NULL, 'Mitochondrial ubiquitin ligase activator of NFKB 1', NULL, NULL, NULL, NULL, NULL, 4),
(142577, NULL, 'G3DSA:3.40.50.720:FF:000995', NULL, NULL, 'GM19262', NULL, NULL, NULL, NULL, NULL, 4),
(142578, NULL, 'G3DSA:1.20.1640.10:FF:000017', NULL, NULL, 'Patched domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(142579, NULL, 'G3DSA:3.30.70.330:FF:002582', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142580, NULL, 'G3DSA:3.40.50.300:FF:003966', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(142581, NULL, 'G3DSA:2.30.29.30:FF:000490', NULL, NULL, 'Pleckstrin homology domain containing O2', NULL, NULL, NULL, NULL, NULL, 4),
(142582, NULL, 'G3DSA:3.90.1150.10:FF:000529', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142583, NULL, 'G3DSA:3.40.50.12230:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142584, NULL, 'G3DSA:2.70.130.10:FF:000116', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142585, NULL, 'G3DSA:3.30.200.20:FF:000990', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(142586, NULL, 'G3DSA:4.10.240.10:FF:000097', NULL, NULL, 'C6 zinc finger domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(142587, NULL, 'G3DSA:1.20.1560.10:FF:000758', NULL, NULL, 'HlyB/MsbA family ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(142588, NULL, 'G3DSA:1.10.238.10:FF:001070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142589, NULL, 'G3DSA:3.90.550.10:FF:000235', NULL, NULL, 'Beta-1,4-galactosyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(142590, NULL, 'G3DSA:3.40.367.20:FF:000020', NULL, NULL, 'Hexokinase-1', NULL, NULL, NULL, NULL, NULL, 4),
(142591, NULL, 'G3DSA:1.10.510.10:FF:000039', NULL, NULL, 'Focal adhesion kinase, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(142592, NULL, 'G3DSA:1.10.8.100:FF:000008', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(142593, NULL, 'G3DSA:3.30.70.270:FF:000175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142594, NULL, 'G3DSA:1.10.287.1490:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142595, NULL, 'G3DSA:3.30.200.20:FF:002007', NULL, NULL, 'Eukaryotic translation initiation factor 2 alpha kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(142596, NULL, 'G3DSA:3.80.10.10:FF:001830', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142597, NULL, 'G3DSA:3.40.50.800:FF:000013', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(142598, NULL, 'G3DSA:2.120.10.30:FF:000431', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142599, NULL, 'G3DSA:3.40.50.2300:FF:000861', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142600, NULL, 'G3DSA:1.20.1260.10:FF:000033', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(142601, NULL, 'G3DSA:3.30.60.60:FF:000007', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(142602, NULL, 'G3DSA:1.10.238.10:FF:000670', NULL, NULL, 'N-terminal EF-hand calcium binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(142603, NULL, 'G3DSA:3.80.10.10:FF:002230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142604, NULL, 'G3DSA:4.10.1240.30:FF:000004', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(142605, NULL, 'G3DSA:3.40.50.300:FF:005192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142606, NULL, 'G3DSA:3.30.200.20:FF:000097', NULL, NULL, 'Probable serine/threonine-protein kinase nek1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(142607, NULL, 'G3DSA:2.40.70.10:FF:000146', NULL, NULL, 'Aspartic protease', NULL, NULL, NULL, NULL, NULL, 4),
(142608, NULL, 'G3DSA:2.10.60.10:FF:000012', NULL, NULL, 'Anti-Muellerian hormone type-2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(142609, NULL, 'G3DSA:1.20.1540.10:FF:000072', NULL, NULL, 'RHOMBOID-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(142610, NULL, 'G3DSA:1.25.40.720:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142611, NULL, 'G3DSA:3.30.230.70:FF:000147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142612, NULL, 'G3DSA:3.30.70.1110:FF:000001', NULL, NULL, 'Chemotaxis protein CheA', NULL, NULL, NULL, NULL, NULL, 4),
(142613, NULL, 'G3DSA:3.30.160.100:FF:000015', NULL, NULL, 'Ribosomal associated cold shock response protein YfiA', NULL, NULL, NULL, NULL, NULL, 4),
(142614, NULL, 'G3DSA:3.30.40.10:FF:001076', NULL, NULL, 'E3 ubiquitin-protein ligase MSL2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(142615, NULL, 'G3DSA:1.10.472.10:FF:000276', NULL, NULL, 'CYCLIN B15', NULL, NULL, NULL, NULL, NULL, 4),
(142616, NULL, 'G3DSA:1.25.10.10:FF:002007', NULL, NULL, 'Uncharacterized protein B24H17.130', NULL, NULL, NULL, NULL, NULL, 4),
(142617, NULL, 'G3DSA:1.20.1250.20:FF:002227', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142618, NULL, 'G3DSA:1.10.132.10:FF:000003', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(142619, NULL, 'G3DSA:3.40.50.720:FF:002232', NULL, NULL, '2-hydroxyacid dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142620, NULL, 'G3DSA:2.60.40.60:FF:000922', NULL, NULL, 'Protocadherin 18', NULL, NULL, NULL, NULL, NULL, 4),
(142621, NULL, 'G3DSA:3.40.366.10:FF:000048', NULL, NULL, 'Fatty acid synthase beta subunit aflB', NULL, NULL, NULL, NULL, NULL, 4),
(142622, NULL, 'G3DSA:2.10.25.10:FF:001510', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142623, NULL, 'G3DSA:2.60.120.260:FF:000425', NULL, NULL, 'Reelin', NULL, NULL, NULL, NULL, NULL, 4),
(142624, NULL, 'G3DSA:3.90.1420.10:FF:000056', NULL, NULL, 'Lysine N-methylase', NULL, NULL, NULL, NULL, NULL, 4),
(142625, NULL, 'G3DSA:2.30.29.30:FF:000501', NULL, NULL, 'EG:23E12.2, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(142626, NULL, 'G3DSA:3.40.50.300:FF:005203', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(142627, NULL, 'G3DSA:3.10.20.90:FF:001009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142628, NULL, 'G3DSA:1.10.10.160:FF:000024', NULL, NULL, 'Exodeoxyribonuclease V, gamma subunit', NULL, NULL, NULL, NULL, NULL, 4),
(142629, NULL, 'G3DSA:3.30.420.10:FF:000312', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142630, NULL, 'G3DSA:1.20.920.10:FF:000023', NULL, NULL, 'Bromodomain adjacent to zinc finger domain protein 2B', NULL, NULL, NULL, NULL, NULL, 4),
(142631, NULL, 'G3DSA:2.60.120.200:FF:000323', NULL, NULL, 'cadherin EGF LAG seven-pass G-type receptor 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(142632, NULL, 'G3DSA:3.30.20.10:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142633, NULL, 'G3DSA:3.40.50.300:FF:006153', NULL, NULL, 'ATP-binding cassette, sub-family B (MDR/TAP), member 11b', NULL, NULL, NULL, NULL, NULL, 4),
(142634, NULL, 'G3DSA:1.25.40.10:FF:004757', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142635, NULL, 'G3DSA:3.30.710.10:FF:000071', NULL, NULL, 'Kelch-like family member 24', NULL, NULL, NULL, NULL, NULL, 4),
(142636, NULL, 'G3DSA:2.60.40.10:FF:000374', NULL, NULL, 'Protein tyrosine phosphatase, receptor type, H', NULL, NULL, NULL, NULL, NULL, 4),
(142637, NULL, 'G3DSA:3.30.890.10:FF:000010', NULL, NULL, 'Methyl-CpG-binding-domain-like, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(142638, NULL, 'G3DSA:3.30.565.10:FF:000114', NULL, NULL, 'Two-component system sensor molecule', NULL, NULL, NULL, NULL, NULL, 4),
(142639, NULL, 'G3DSA:2.170.130.10:FF:000025', NULL, NULL, 'TonB-dependent siderophore receptor', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(142640, NULL, 'G3DSA:3.10.50.10:FF:000015', NULL, NULL, 'Chitotriosidase-1', NULL, NULL, NULL, NULL, NULL, 4),
(142641, NULL, 'G3DSA:3.10.20.90:FF:000380', NULL, NULL, 'Plant UBX domain-containing protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(142642, NULL, 'G3DSA:3.30.50.10:FF:000177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142643, NULL, 'G3DSA:1.25.40.10:FF:000486', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(142644, NULL, 'G3DSA:3.30.40.10:FF:000019', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(142645, NULL, 'G3DSA:1.10.220.10:FF:000051', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(142646, NULL, 'G3DSA:1.10.510.10:FF:004081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142647, NULL, 'G3DSA:2.30.110.10:FF:000085', NULL, NULL, 'Flavin reductase domain protein FMN-binding', NULL, NULL, NULL, NULL, NULL, 4),
(142648, NULL, 'G3DSA:3.40.640.10:FF:000478', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142649, NULL, 'G3DSA:3.90.1010.10:FF:000025', NULL, NULL, 'Nitrogen-fixing NifU domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(142650, NULL, 'G3DSA:3.40.50.1000:FF:000797', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142651, NULL, 'G3DSA:2.40.50.140:FF:000336', NULL, NULL, 'Membrane-bound serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(142652, NULL, 'G3DSA:3.80.10.10:FF:003409', NULL, NULL, 'EIN3-binding F-box protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(142653, NULL, 'G3DSA:1.25.40.20:FF:001107', NULL, NULL, 'Putative ubiquitin ligase protein mib2', NULL, NULL, NULL, NULL, NULL, 4),
(142654, NULL, 'G3DSA:3.40.50.300:FF:007676', NULL, NULL, 'Os01g0691600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(142655, NULL, 'G3DSA:2.60.40.150:FF:000624', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(142656, NULL, 'G3DSA:3.90.70.200:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142657, NULL, 'G3DSA:1.20.1070.10:FF:000327', NULL, NULL, 'Vasopressin V1a receptor', NULL, NULL, NULL, NULL, NULL, 4),
(142658, NULL, 'G3DSA:2.60.200.10:FF:000040', NULL, NULL, 'Mothers against decapentaplegic homolog', NULL, NULL, NULL, NULL, NULL, 4),
(142659, NULL, 'G3DSA:1.10.30.50:FF:000007', NULL, NULL, 'HNH endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(142660, NULL, 'G3DSA:1.10.357.150:FF:000016', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(142661, NULL, 'G3DSA:2.60.120.330:FF:000002', NULL, NULL, '1-aminocyclopropane-1-carboxylate oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(142662, NULL, 'G3DSA:2.30.30.40:FF:000575', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(142663, NULL, 'G3DSA:1.10.472.80:FF:000021', NULL, NULL, 'GTPase activating protein (Gyp2)', NULL, NULL, NULL, NULL, NULL, 4),
(142664, NULL, 'G3DSA:3.80.10.10:FF:004028', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(142665, NULL, 'G3DSA:1.10.1420.10:FF:000076', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(142666, NULL, 'G3DSA:3.40.50.1000:FF:000454', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(142667, NULL, 'G3DSA:4.10.80.40:FF:000001', NULL, NULL, 'Succinate dehydrogenase flavoprotein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(142668, NULL, 'G3DSA:3.10.100.10:FF:000360', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142669, NULL, 'G3DSA:1.20.1070.10:FF:001620', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142670, NULL, 'G3DSA:3.90.1290.10:FF:000017', NULL, NULL, 'Microtubule-actin crosslinking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(142671, NULL, 'G3DSA:1.20.1250.20:FF:000535', NULL, NULL, 'Sucrose transport protein SUT5', NULL, NULL, NULL, NULL, NULL, 4),
(142672, NULL, 'G3DSA:1.50.10.10:FF:000015', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(142673, NULL, 'G3DSA:1.25.40.10:FF:005033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(142674, NULL, 'G3DSA:2.60.40.1170:FF:000107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142675, NULL, 'G3DSA:3.20.20.80:FF:000415', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142676, NULL, 'G3DSA:1.10.287.70:FF:000301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142677, NULL, 'G3DSA:3.80.10.10:FF:003180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142678, NULL, 'G3DSA:1.20.920.30:FF:000029', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(142679, NULL, 'G3DSA:3.30.70.980:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142680, NULL, 'G3DSA:4.10.520.10:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142681, NULL, 'G3DSA:3.30.559.10:FF:000280', NULL, NULL, 'Carnitine O-palmitoyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142682, NULL, 'G3DSA:1.10.10.10:FF:000478', NULL, NULL, 'SET domain and mariner transposase fusion gene', NULL, NULL, NULL, NULL, NULL, 4),
(142683, NULL, 'G3DSA:3.90.1150.10:FF:000187', NULL, NULL, 'Probable L-tyrosine/L-aspartate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(142684, NULL, 'G3DSA:3.60.21.10:FF:000064', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(142685, NULL, 'G3DSA:3.30.9.10:FF:000166', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(142686, NULL, 'G3DSA:3.90.190.10:FF:000595', NULL, NULL, 'Phosphatase and tensin homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(142687, NULL, 'G3DSA:1.10.510.10:FF:002624', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142688, NULL, 'G3DSA:3.90.180.10:FF:000190', NULL, NULL, 'Alcohol dehydrogenase-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(142689, NULL, 'G3DSA:4.10.400.10:FF:000317', NULL, NULL, 'Sortilin-related receptor, L(DLR class) A repeats-containing', NULL, NULL, NULL, NULL, NULL, 4),
(142690, NULL, 'G3DSA:3.30.160.60:FF:002965', NULL, NULL, 'AGAP007915-PA', NULL, NULL, NULL, NULL, NULL, 4),
(142691, NULL, 'G3DSA:3.40.800.10:FF:000013', NULL, NULL, 'Agmatinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142692, NULL, 'G3DSA:3.30.1490.190:FF:000030', NULL, NULL, 'Fe2+/Zn2+ uptake regulation protein', NULL, NULL, NULL, NULL, NULL, 4),
(142693, NULL, 'G3DSA:1.20.272.40:FF:000003', NULL, NULL, 'ATP-dependent RNA helicase SUV3L, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(142694, NULL, 'G3DSA:3.40.50.300:FF:007114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142695, NULL, 'G3DSA:3.40.1280.10:FF:000039', NULL, NULL, '23S rRNA methyltransferase TsnR', NULL, NULL, NULL, NULL, NULL, 4),
(142696, NULL, 'G3DSA:2.60.40.10:FF:001335', NULL, NULL, 'Sallimus, isoform Q', NULL, NULL, NULL, NULL, NULL, 4),
(142697, NULL, 'G3DSA:3.40.30.10:FF:000889', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142698, NULL, 'G3DSA:3.40.640.10:FF:000135', NULL, NULL, 'Transcriptional regulator PtsJ', NULL, NULL, NULL, NULL, NULL, 4),
(142699, NULL, 'G3DSA:2.30.42.10:FF:000121', NULL, NULL, 'Tax1-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(142700, NULL, 'G3DSA:3.40.50.620:FF:000403', NULL, NULL, 'Probable nicotinate-nucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(142701, NULL, 'G3DSA:3.30.160.60:FF:003241', NULL, NULL, 'Topi', NULL, NULL, NULL, NULL, NULL, 4),
(142702, NULL, 'G3DSA:1.50.10.20:FF:000131', NULL, NULL, 'Protein farnesyltransferase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(142703, NULL, 'G3DSA:1.25.10.10:FF:001389', NULL, NULL, 'Importin 8', NULL, NULL, NULL, NULL, NULL, 4),
(142704, NULL, 'G3DSA:2.60.40.1120:FF:000008', NULL, NULL, 'Carboxypeptidase D', NULL, NULL, NULL, NULL, NULL, 4),
(142705, NULL, 'G3DSA:2.30.30.30:FF:000010', NULL, NULL, 'Elongation factor P', NULL, NULL, NULL, NULL, NULL, 4),
(142706, NULL, 'G3DSA:1.10.150.780:FF:000003', NULL, NULL, 'Vacuolar protein sorting-associated protein 16, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142707, NULL, 'G3DSA:3.90.640.10:FF:000118', NULL, NULL, 'Actin, gamma 2, smooth muscle, enteric', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(142708, NULL, 'G3DSA:3.30.505.10:FF:000009', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(142709, NULL, 'G3DSA:1.25.40.10:FF:004072', NULL, NULL, 'Protein high chlorophyll fluorescent 107', NULL, NULL, NULL, NULL, NULL, 4),
(142710, NULL, 'G3DSA:3.20.20.80:FF:000073', NULL, NULL, 'Alpha-1,3-glucan synthase Ags2', NULL, NULL, NULL, NULL, NULL, 4),
(142711, NULL, 'G3DSA:3.60.120.10:FF:000013', NULL, NULL, 'Anthranilate synthase component I', NULL, NULL, NULL, NULL, NULL, 4),
(142712, NULL, 'G3DSA:3.10.450.40:FF:000013', NULL, NULL, 'Bacillolysin', NULL, NULL, NULL, NULL, NULL, 4),
(142713, NULL, 'G3DSA:1.10.1870.10:FF:000008', NULL, NULL, 'Probable saccharopine dehydrogenase [NADP(+), L-glutamate-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(142714, NULL, 'G3DSA:3.90.1600.10:FF:000042', NULL, NULL, 'DNA polymerase epsilon catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(142715, NULL, 'G3DSA:1.20.58.390:FF:000126', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(142716, NULL, 'G3DSA:3.30.160.60:FF:006219', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142717, NULL, 'G3DSA:1.10.287.130:FF:000044', NULL, NULL, 'LAO/AO transport system ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(142718, NULL, 'G3DSA:3.10.120.10:FF:000030', NULL, NULL, 'Fatty acid 2-hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(142719, NULL, 'G3DSA:3.30.70.3490:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142720, NULL, 'G3DSA:3.40.30.10:FF:001165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142721, NULL, 'G3DSA:2.130.10.10:FF:005478', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142722, NULL, 'G3DSA:3.30.420.40:FF:000416', NULL, NULL, 'Acetate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(142723, NULL, 'G3DSA:3.40.50.1820:FF:000256', NULL, NULL, 'Poly(ethylene terephthalate) hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(142724, NULL, 'G3DSA:2.70.170.10:FF:000225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142725, NULL, 'G3DSA:3.40.50.11820:FF:000001', NULL, NULL, 'Glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(142726, NULL, 'G3DSA:1.25.40.10:FF:003796', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142727, NULL, 'G3DSA:2.60.120.650:FF:000216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142728, NULL, 'G3DSA:1.20.58.60:FF:000607', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(142729, NULL, 'G3DSA:3.90.226.10:FF:000201', NULL, NULL, 'Carboxyl-terminal-processing peptidase 1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(142730, NULL, 'G3DSA:1.10.510.10:FF:002967', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142731, NULL, 'G3DSA:3.10.129.10:FF:000241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142732, NULL, 'G3DSA:1.25.10.10:FF:002788', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142733, NULL, 'G3DSA:3.80.10.10:FF:003741', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142734, NULL, 'G3DSA:1.25.40.20:FF:000820', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(142735, NULL, 'G3DSA:2.60.40.10:FF:002971', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142736, NULL, 'G3DSA:2.20.110.10:FF:000025', NULL, NULL, 'MORN repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142737, NULL, 'G3DSA:1.10.1670.10:FF:000010', NULL, NULL, 'DNA-3-methyladenine glycosylase II', NULL, NULL, NULL, NULL, NULL, 4),
(142738, NULL, 'G3DSA:3.80.10.10:FF:000318', NULL, NULL, 'transforming growth factor beta activator LRRC32', NULL, NULL, NULL, NULL, NULL, 4),
(142739, NULL, 'G3DSA:1.10.10.1320:FF:000013', NULL, NULL, 'Transcriptional activator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142740, NULL, 'G3DSA:2.60.40.640:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142741, NULL, 'G3DSA:3.30.310.260:FF:000002', NULL, NULL, 'Zgc:158858', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(142742, NULL, 'G3DSA:3.90.1150.170:FF:000003', NULL, NULL, 'Glutamate decarboxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(142743, NULL, 'G3DSA:3.60.110.10:FF:000063', NULL, NULL, 'N-carbamoylputrescine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(142744, NULL, 'G3DSA:1.20.58.1970:FF:000008', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(142745, NULL, 'G3DSA:3.80.10.10:FF:001611', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142746, NULL, 'G3DSA:1.10.620.20:FF:000022', NULL, NULL, 'Phenol hydroxylase component', NULL, NULL, NULL, NULL, NULL, 4),
(142747, NULL, 'G3DSA:1.10.238.10:FF:000917', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142748, NULL, 'G3DSA:2.60.120.920:FF:000084', NULL, NULL, 'SPRY_domain/HECT-domain_(Ubiquitin-transferase)_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(142749, NULL, 'G3DSA:1.25.10.10:FF:003064', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(142750, NULL, 'G3DSA:3.30.1520.10:FF:000033', NULL, NULL, 'Sorting nexin 25', NULL, NULL, NULL, NULL, NULL, 4),
(142751, NULL, 'G3DSA:2.60.120.10:FF:000668', NULL, NULL, 'Auxin-binding protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(142752, NULL, 'G3DSA:3.10.100.10:FF:000028', NULL, NULL, 'integral membrane protein DGCR2/IDD isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(142753, NULL, 'G3DSA:3.40.50.300:FF:007333', NULL, NULL, 'Ras-related protein RabK3', NULL, NULL, NULL, NULL, NULL, 4),
(142754, NULL, 'G3DSA:2.130.10.10:FF:001768', NULL, NULL, 'Gid7p', NULL, NULL, NULL, NULL, NULL, 4),
(142755, NULL, 'G3DSA:2.130.10.10:FF:003005', NULL, NULL, 'Transducin', NULL, NULL, NULL, NULL, NULL, 4),
(142756, NULL, 'G3DSA:2.30.42.10:FF:000464', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142757, NULL, 'G3DSA:3.40.50.150:FF:001291', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142758, NULL, 'G3DSA:1.20.1070.10:FF:001963', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142759, NULL, 'G3DSA:2.30.30.40:FF:000232', NULL, NULL, 'RIMS-binding protein 3A-like', NULL, NULL, NULL, NULL, NULL, 4),
(142760, NULL, 'G3DSA:3.40.50.920:FF:000032', NULL, NULL, 'Pyruvate flavodoxin/ferredoxin oxidoreductase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(142761, NULL, 'G3DSA:3.90.1140.10:FF:000029', NULL, NULL, 'A-kinase anchor protein 7 isoform gamma', NULL, NULL, NULL, NULL, NULL, 4),
(142762, NULL, 'G3DSA:2.60.40.1140:FF:000003', NULL, NULL, 'Collagen adhesin', NULL, NULL, NULL, NULL, NULL, 4),
(142763, NULL, 'G3DSA:3.40.50.1010:FF:000238', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142764, NULL, 'G3DSA:3.30.420.40:FF:000198', NULL, NULL, 'Actin like 8', NULL, NULL, NULL, NULL, NULL, 4),
(142765, NULL, 'G3DSA:1.10.357.10:FF:000070', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(142766, NULL, 'G3DSA:4.10.60.10:FF:000238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142767, NULL, 'G3DSA:1.20.1270.60:FF:000301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142768, NULL, 'G3DSA:3.40.50.1400:FF:000029', NULL, NULL, 'Protein CBG20458', NULL, NULL, NULL, NULL, NULL, 4),
(142769, NULL, 'G3DSA:2.130.10.10:FF:002605', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142770, NULL, 'G3DSA:1.25.40.10:FF:004414', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142771, NULL, 'G3DSA:2.30.29.30:FF:001119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142772, NULL, 'G3DSA:3.30.70.330:FF:001963', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142773, NULL, 'G3DSA:3.40.50.1110:FF:000032', NULL, NULL, 'GDSL-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(142774, NULL, 'G3DSA:3.30.160.60:FF:000711', NULL, NULL, 'zinc finger protein 697', NULL, NULL, NULL, NULL, NULL, 4),
(142775, NULL, 'G3DSA:3.30.530.20:FF:000183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142776, NULL, 'G3DSA:1.25.40.10:FF:000941', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g15300', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(142777, NULL, 'G3DSA:2.60.40.790:FF:000131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142778, NULL, 'G3DSA:1.20.58.60:FF:000265', NULL, NULL, 'Microtubule-actin cross-linking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(142779, NULL, 'G3DSA:3.40.850.10:FF:000292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142780, NULL, 'G3DSA:3.30.70.580:FF:000043', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(142781, NULL, 'G3DSA:2.170.270.10:FF:000187', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(142782, NULL, 'G3DSA:3.30.160.60:FF:004421', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142783, NULL, 'G3DSA:1.20.120.630:FF:000001', NULL, NULL, 'ATP-dependent DNA helicase RecG', NULL, NULL, NULL, NULL, NULL, 4),
(142784, NULL, 'G3DSA:3.40.50.300:FF:006372', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142785, NULL, 'G3DSA:2.130.10.10:FF:005697', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(142786, NULL, 'G3DSA:3.20.20.80:FF:000758', NULL, NULL, 'Iduronidase alpha-L-', NULL, NULL, NULL, NULL, NULL, 4),
(142787, NULL, 'G3DSA:4.10.1170.10:FF:000003', NULL, NULL, 'MAP kinase-activated protein kinase mak-1', NULL, NULL, NULL, NULL, NULL, 4),
(142788, NULL, 'G3DSA:3.40.50.300:FF:006496', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142789, NULL, 'G3DSA:1.50.40.10:FF:000186', NULL, NULL, 'YPR011Cp-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(142790, NULL, 'G3DSA:1.10.510.10:FF:003928', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142791, NULL, 'G3DSA:3.30.60.10:FF:000003', NULL, NULL, 'Class IV chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(142792, NULL, 'G3DSA:3.30.420.10:FF:000655', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142793, NULL, 'G3DSA:3.30.465.10:FF:000062', NULL, NULL, 'POSSIBLE OXIDOREDUCTASE', NULL, NULL, NULL, NULL, NULL, 4),
(142794, NULL, 'G3DSA:1.20.58.60:FF:000046', NULL, NULL, 'Spectrin alpha chain, non-erythrocytic 1', NULL, NULL, NULL, NULL, NULL, 4),
(142795, NULL, 'G3DSA:2.40.30.160:FF:000001', NULL, NULL, 'tRNA-modifying protein YgfZ', NULL, NULL, NULL, NULL, NULL, 4),
(142796, NULL, 'G3DSA:3.10.10.10:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142797, NULL, 'G3DSA:1.20.90.10:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142798, NULL, 'G3DSA:2.40.70.10:FF:000040', NULL, NULL, 'aspartyl protease AED3', NULL, NULL, NULL, NULL, NULL, 4),
(142799, NULL, 'G3DSA:3.40.50.300:FF:002786', NULL, NULL, 'Uncharacterized conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(142800, NULL, 'G3DSA:2.60.40.150:FF:000282', NULL, NULL, 'Rho GTPase-activating protein syd-1', NULL, NULL, NULL, NULL, NULL, 4),
(142801, NULL, 'G3DSA:3.20.20.140:FF:000179', NULL, NULL, 'WGS project CABT00000000 data, contig 2.98', NULL, NULL, NULL, NULL, NULL, 4),
(142802, NULL, 'G3DSA:2.30.29.30:FF:001338', NULL, NULL, 'G protein-coupled receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(142803, NULL, 'G3DSA:3.30.870.10:FF:000008', NULL, NULL, 'CDP-diacylglycerol--serine O-phosphatidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(142804, NULL, 'G3DSA:3.30.2060.10:FF:000008', NULL, NULL, 'Penicillin-binding protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(142805, NULL, 'G3DSA:3.40.710.10:FF:000130', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(142806, NULL, 'G3DSA:3.40.50.1970:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142807, NULL, 'G3DSA:3.40.50.720:FF:001377', NULL, NULL, 'Putative NAD-dependent 2-hydroxyacid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(142808, NULL, 'G3DSA:3.30.900.10:FF:000006', NULL, NULL, 'HORMA domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(142809, NULL, 'G3DSA:3.30.230.10:FF:000045', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(142810, NULL, 'G3DSA:1.10.730.10:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(142811, NULL, 'G3DSA:3.80.10.10:FF:000650', NULL, NULL, 'Protein kinase A regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(142812, NULL, 'G3DSA:2.130.10.10:FF:002387', NULL, NULL, 'WD-40 repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(142813, NULL, 'G3DSA:3.30.60.30:FF:000009', NULL, NULL, 'Follistatin a', NULL, NULL, NULL, NULL, NULL, 4),
(142814, NULL, 'G3DSA:3.90.1430.10:FF:000006', NULL, NULL, '114 kDa U5 small nuclear ribonucleoprotein component', NULL, NULL, NULL, NULL, NULL, 4),
(142815, NULL, 'G3DSA:3.40.1620.60:FF:000002', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 10', NULL, NULL, NULL, NULL, NULL, 4),
(142816, NULL, 'G3DSA:1.25.40.10:FF:000609', NULL, NULL, 'Small glutamine-rich tetratricopeptide repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(142817, NULL, 'G3DSA:3.40.50.300:FF:002662', NULL, NULL, 'tRNA dimethylallyltransferase 9', NULL, NULL, NULL, NULL, NULL, 4),
(142818, NULL, 'G3DSA:2.130.10.10:FF:001987', NULL, NULL, 'WD repeat domain 60', NULL, NULL, NULL, NULL, NULL, 4),
(142819, NULL, 'G3DSA:3.30.420.40:FF:000759', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142820, NULL, 'G3DSA:4.10.60.10:FF:000114', NULL, NULL, 'Zinc knuckle domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(142821, NULL, 'G3DSA:2.130.10.10:FF:002729', NULL, NULL, 'Protein ROOT INITIATION DEFECTIVE 3', NULL, NULL, NULL, NULL, NULL, 4),
(142822, NULL, 'G3DSA:1.25.40.20:FF:000146', NULL, NULL, 'Ankyrin repeat and SOCS box containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(142823, NULL, 'G3DSA:2.60.40.10:FF:001678', NULL, NULL, 'filamin-A isoform X8', NULL, NULL, NULL, NULL, NULL, 4),
(142824, NULL, 'G3DSA:3.60.10.10:FF:000145', NULL, NULL, 'Endonuclease/Exonuclease/phosphatase family prote in', NULL, NULL, NULL, NULL, NULL, 4),
(142825, NULL, 'G3DSA:2.170.300.10:FF:000061', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(142826, NULL, 'G3DSA:3.80.10.10:FF:003067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142827, NULL, 'G3DSA:3.40.30.10:FF:000546', NULL, NULL, 'thioredoxin domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(142828, NULL, 'G3DSA:3.30.40.10:FF:001531', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142829, NULL, 'G3DSA:1.10.10.440:FF:000018', NULL, NULL, 'pre-mRNA-processing factor 40 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(142830, NULL, 'G3DSA:1.10.645.10:FF:000003', NULL, NULL, 'NAD(P)H-quinone oxidoreductase subunit H, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(142831, NULL, 'G3DSA:3.40.50.10470:FF:000006', NULL, NULL, 'Methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(142832, NULL, 'G3DSA:3.40.50.300:FF:003062', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(142833, NULL, 'G3DSA:1.10.510.10:FF:004204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142834, NULL, 'G3DSA:3.80.10.10:FF:004360', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142835, NULL, 'G3DSA:1.25.40.790:FF:000001', NULL, NULL, 'Ccr4-not transcription complex subunit 1 isoform', NULL, NULL, NULL, NULL, NULL, 4),
(142836, NULL, 'G3DSA:1.25.40.20:FF:000910', NULL, NULL, 'Calmodulin-binding transcription activator 2', NULL, NULL, NULL, NULL, NULL, 4),
(142837, NULL, 'G3DSA:1.10.730.10:FF:000235', NULL, NULL, 'Methionine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(142838, NULL, 'G3DSA:3.80.10.10:FF:003831', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142839, NULL, 'G3DSA:3.40.50.880:FF:000065', NULL, NULL, 'Carbamoyl-phosphate synthase small chain', NULL, NULL, NULL, NULL, NULL, 4),
(142840, NULL, 'G3DSA:1.10.10.60:FF:000661', NULL, NULL, 'Transcription repressor MYB5', NULL, NULL, NULL, NULL, NULL, 4),
(142841, NULL, 'G3DSA:1.25.10.10:FF:002524', NULL, NULL, 'Si:dkey-21e13.3', NULL, NULL, NULL, NULL, NULL, 4),
(142842, NULL, 'G3DSA:1.25.40.320:FF:000012', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(142843, NULL, 'G3DSA:3.30.70.330:FF:002492', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142844, NULL, 'G3DSA:1.10.10.820:FF:000014', NULL, NULL, 'unconventional myosin-XIX isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(142845, NULL, 'G3DSA:3.40.50.300:FF:008457', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142846, NULL, 'G3DSA:3.10.196.10:FF:000002', NULL, NULL, 'Methionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(142847, NULL, 'G3DSA:3.40.50.1820:FF:001375', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142848, NULL, 'G3DSA:3.80.20.20:FF:000047', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(142849, NULL, 'G3DSA:1.25.40.10:FF:002026', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(142850, NULL, 'G3DSA:3.20.200.10:FF:000017', NULL, NULL, 'Alpha-protein kinase vwkA', NULL, NULL, NULL, NULL, NULL, 4),
(142851, NULL, 'G3DSA:3.40.50.300:FF:005231', NULL, NULL, 'Bifunctional heparan sulfate N-deacetylase/N-sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(142852, NULL, 'G3DSA:2.160.20.10:FF:000340', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142853, NULL, 'G3DSA:2.40.50.140:FF:000263', NULL, NULL, 'Ribosomal protein S1-like1', NULL, NULL, NULL, NULL, NULL, 4),
(142854, NULL, 'G3DSA:1.20.1250.20:FF:002160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142855, NULL, 'G3DSA:2.60.40.10:FF:003302', NULL, NULL, 'Leukemia inhibitory factor receptor alpha b', NULL, NULL, NULL, NULL, NULL, 4),
(142856, NULL, 'G3DSA:2.60.120.340:FF:000022', NULL, NULL, 'DNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142857, NULL, 'G3DSA:1.10.555.10:FF:000013', NULL, NULL, 'SLIT-ROBO Rho GTPase activating protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(142858, NULL, 'G3DSA:2.60.40.150:FF:000512', NULL, NULL, 'Calpain 6', NULL, NULL, NULL, NULL, NULL, 4),
(142859, NULL, 'G3DSA:3.30.230.70:FF:000057', NULL, NULL, '3''exoribonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142860, NULL, 'G3DSA:3.40.50.1910:FF:000002', NULL, NULL, 'Sec1 family domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(142861, NULL, 'G3DSA:1.20.920.30:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142862, NULL, 'G3DSA:1.20.1270.70:FF:000001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142863, NULL, 'G3DSA:3.90.550.50:FF:000168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142864, NULL, 'G3DSA:2.120.10.30:FF:000347', NULL, NULL, 'Tol-Pal system protein TolB', NULL, NULL, NULL, NULL, NULL, 4),
(142865, NULL, 'G3DSA:3.40.50.410:FF:000121', NULL, NULL, 'Midasin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142866, NULL, 'G3DSA:3.40.50.1820:FF:000273', NULL, NULL, 'Dual specificity phosphatase catalytic domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(142867, NULL, 'G3DSA:2.10.110.10:FF:000342', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142868, NULL, 'G3DSA:3.30.160.60:FF:000464', NULL, NULL, 'Zinc finger and SCAN domain containing 25', NULL, NULL, NULL, NULL, NULL, 4),
(142869, NULL, 'G3DSA:3.10.20.90:FF:000683', NULL, NULL, 'NFATC2-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(142870, NULL, 'G3DSA:3.30.980.10:FF:000011', NULL, NULL, 'Alanyl-tRNA synthetase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(142871, NULL, 'G3DSA:3.90.950.10:FF:000052', NULL, NULL, 'Guanine nucleotide exchange factor SPIKE 1', NULL, NULL, NULL, NULL, NULL, 4),
(142872, NULL, 'G3DSA:3.40.50.300:FF:004242', NULL, NULL, 'Replication factor C small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(142873, NULL, 'G3DSA:3.30.160.60:FF:001127', NULL, NULL, 'Zinc finger protein 142', NULL, NULL, NULL, NULL, NULL, 4),
(142874, NULL, 'G3DSA:3.80.30.20:FF:000019', NULL, NULL, 'tRNA methylthiotransferase YqeV', NULL, NULL, NULL, NULL, NULL, 4),
(142875, NULL, 'G3DSA:3.40.1090.10:FF:000143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(142876, NULL, 'G3DSA:2.10.25.10:FF:001370', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142877, NULL, 'G3DSA:3.90.550.10:FF:000589', NULL, NULL, 'Glycosyltransferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(142878, NULL, 'G3DSA:1.10.238.10:FF:000384', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(142879, NULL, 'G3DSA:2.60.40.10:FF:004730', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142880, NULL, 'G3DSA:2.30.30.40:FF:000097', NULL, NULL, 'Putative src kinase-associated phosphoprotein 2', NULL, NULL, NULL, NULL, NULL, 4),
(142881, NULL, 'G3DSA:2.70.130.10:FF:000094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142882, NULL, 'G3DSA:2.20.70.10:FF:000136', NULL, NULL, 'Pre-mRNA-processing protein 40A', NULL, NULL, NULL, NULL, NULL, 4),
(142883, NULL, 'G3DSA:2.60.200.20:FF:000032', NULL, NULL, 'FHA domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(142884, NULL, 'G3DSA:3.30.160.60:FF:000138', NULL, NULL, 'Zinc finger and BTB domain containing 7C', NULL, NULL, NULL, NULL, NULL, 4),
(142885, NULL, 'G3DSA:3.30.2350.20:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142886, NULL, 'G3DSA:3.90.1150.10:FF:000445', NULL, NULL, 'Aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(142887, NULL, 'G3DSA:1.10.1140.10:FF:000004', NULL, NULL, 'V-type ATP synthase alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(142888, NULL, 'G3DSA:2.60.40.1510:FF:000058', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(142889, NULL, 'G3DSA:1.20.210.10:FF:000008', NULL, NULL, 'Nitric oxide reductase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(142890, NULL, 'G3DSA:3.10.20.740:FF:000007', NULL, NULL, 'NADH-ubiquinone oxidoreductase 75 kDa subunit, mitochondrial isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(142891, NULL, 'G3DSA:2.40.10.10:FF:000643', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142892, NULL, 'G3DSA:3.10.20.720:FF:000001', NULL, NULL, 'Inner kinetochore subunit CHL4', NULL, NULL, NULL, NULL, NULL, 4),
(142893, NULL, 'G3DSA:1.10.510.10:FF:002754', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(142894, NULL, 'G3DSA:3.40.50.720:FF:002041', NULL, NULL, 'BC089597 protein', NULL, NULL, NULL, NULL, NULL, 4),
(142895, NULL, 'G3DSA:1.20.930.40:FF:000027', NULL, NULL, 'AER157Cp', NULL, NULL, NULL, NULL, NULL, 4),
(142896, NULL, 'G3DSA:3.40.30.10:FF:001243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142897, NULL, 'G3DSA:1.20.930.20:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142898, NULL, 'G3DSA:3.30.60.190:FF:000008', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(142899, NULL, 'G3DSA:3.90.1150.10:FF:000119', NULL, NULL, 'Ddc, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(142900, NULL, 'G3DSA:2.70.170.10:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142901, NULL, 'G3DSA:1.20.5.110:FF:000189', NULL, NULL, 'AT4G17730 protein', NULL, NULL, NULL, NULL, NULL, 4),
(142902, NULL, 'G3DSA:2.130.10.10:FF:002763', NULL, NULL, 'WD repeat domain phosphoinositide interacting protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142903, NULL, 'G3DSA:1.10.1780.10:FF:000007', NULL, NULL, 'Chaperone protein ClpB', NULL, NULL, NULL, NULL, NULL, 4),
(142904, NULL, 'G3DSA:1.20.1070.10:FF:001923', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142905, NULL, 'G3DSA:3.90.550.10:FF:000117', NULL, NULL, 'Glycosyltransferase family 34 protein', NULL, NULL, NULL, NULL, NULL, 4),
(142906, NULL, 'G3DSA:3.20.180.20:FF:000028', NULL, NULL, 'Dynein heavy chain, cytosolic, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142907, NULL, 'G3DSA:1.20.120.350:FF:000086', NULL, NULL, 'Potassium voltage-gated channel subfamily KQT member 1', NULL, NULL, NULL, NULL, NULL, 4),
(142908, NULL, 'G3DSA:2.70.150.10:FF:000005', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(142909, NULL, 'G3DSA:3.40.350.10:FF:000074', NULL, NULL, 'Aminopeptidase P1, putative', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(142910, NULL, 'G3DSA:3.30.1010.10:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142911, NULL, 'G3DSA:2.10.25.10:FF:000116', NULL, NULL, 'pro-neuregulin-2, membrane-bound isoform', NULL, NULL, NULL, NULL, NULL, 4),
(142912, NULL, 'G3DSA:1.10.3430.10:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142913, NULL, 'G3DSA:2.30.42.10:FF:000481', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142914, NULL, 'G3DSA:3.20.20.10:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142915, NULL, 'G3DSA:2.30.29.30:FF:000023', NULL, NULL, 'Kinesin family member 1B', NULL, NULL, NULL, NULL, NULL, 4),
(142916, NULL, 'G3DSA:3.40.190.10:FF:000246', NULL, NULL, '4-amino-5-hydroxymethyl-2-methylpyrimidine phosphate synthase THI13', NULL, NULL, NULL, NULL, NULL, 4),
(142917, NULL, 'G3DSA:3.30.1560.10:FF:000001', NULL, NULL, 'Protein mago nashi homolog', NULL, NULL, NULL, NULL, NULL, 4),
(142918, NULL, 'G3DSA:3.30.40.10:FF:001469', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142919, NULL, 'G3DSA:3.90.1140.10:FF:000001', NULL, NULL, 'Ubiquitin-associated and SH3 domain-containing protein B', NULL, NULL, NULL, NULL, NULL, 4),
(142920, NULL, 'G3DSA:2.60.40.10:FF:000661', NULL, NULL, 'receptor-type tyrosine-protein kinase FLT3', NULL, NULL, NULL, NULL, NULL, 4),
(142921, NULL, 'G3DSA:1.10.1300.10:FF:000039', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(142922, NULL, 'G3DSA:1.10.10.10:FF:000753', NULL, NULL, 'Vacuolar sorting protein', NULL, NULL, NULL, NULL, NULL, 4),
(142923, NULL, 'G3DSA:3.40.50.720:FF:000096', NULL, NULL, 'tRNA cyclic N6-threonylcarbamoyladenosine(37) synthase TcdA', NULL, NULL, NULL, NULL, NULL, 4),
(142924, NULL, 'G3DSA:2.10.110.10:FF:000016', NULL, NULL, 'LIM domain only 3', NULL, NULL, NULL, NULL, NULL, 4),
(142925, NULL, 'G3DSA:3.50.50.60:FF:000404', NULL, NULL, 'Glucose-methanol-choline (Gmc) oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(142926, NULL, 'G3DSA:2.120.10.80:FF:000255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142927, NULL, 'G3DSA:3.30.160.60:FF:002908', NULL, NULL, 'Zinc finger protein 304', NULL, NULL, NULL, NULL, NULL, 4),
(142928, NULL, 'G3DSA:3.60.20.10:FF:000207', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142929, NULL, 'G3DSA:3.30.160.60:FF:004679', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142930, NULL, 'G3DSA:3.90.640.10:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142931, NULL, 'G3DSA:3.40.50.1970:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142932, NULL, 'G3DSA:3.40.50.2300:FF:000344', NULL, NULL, 'Glutamate ionotropic receptor NMDA type subunit 2A', NULL, NULL, NULL, NULL, NULL, 4),
(142933, NULL, 'G3DSA:2.170.120.12:FF:000010', NULL, NULL, 'Related to RPB3-DNA-directed RNA polymerase II chain', NULL, NULL, NULL, NULL, NULL, 4),
(142934, NULL, 'G3DSA:3.40.5.10:FF:000011', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(142935, NULL, 'G3DSA:3.40.50.300:FF:006366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142936, NULL, 'G3DSA:3.30.519.10:FF:000002', NULL, NULL, 'Guanosine nucleotide diphosphate dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(142937, NULL, 'G3DSA:3.10.310.10:FF:000050', NULL, NULL, 'Proline racemase', NULL, NULL, NULL, NULL, NULL, 4),
(142938, NULL, 'G3DSA:3.80.10.10:FF:002050', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(142939, NULL, 'G3DSA:3.30.420.40:FF:000377', NULL, NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(142940, NULL, 'G3DSA:2.10.70.10:FF:000277', NULL, NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(142941, NULL, 'G3DSA:2.60.40.1180:FF:000094', NULL, NULL, 'Alpha-mannosidase D', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(142942, NULL, 'G3DSA:2.60.120.260:FF:000150', NULL, NULL, 'Anaphase-promoting complex subunit 10', NULL, NULL, NULL, NULL, NULL, 4),
(142943, NULL, 'G3DSA:3.60.21.10:FF:000171', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(142944, NULL, 'G3DSA:3.30.930.10:FF:000300', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(142945, NULL, 'G3DSA:3.80.10.10:FF:003977', NULL, NULL, 'Protein DIA2', NULL, NULL, NULL, NULL, NULL, 4),
(142946, NULL, 'G3DSA:1.10.220.160:FF:000014', NULL, NULL, 'GM24661', NULL, NULL, NULL, NULL, NULL, 4),
(142947, NULL, 'G3DSA:1.10.238.10:FF:000737', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142948, NULL, 'G3DSA:1.25.40.990:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142949, NULL, 'G3DSA:1.10.10.60:FF:000335', NULL, NULL, 'DNA-directed RNA polymerase subunit N, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142950, NULL, 'G3DSA:2.60.40.1170:FF:000091', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142951, NULL, 'G3DSA:1.10.150.530:FF:000013', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase Cfr', NULL, NULL, NULL, NULL, NULL, 4),
(142952, NULL, 'G3DSA:3.30.40.10:FF:002312', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142953, NULL, 'G3DSA:2.30.30.30:FF:000061', NULL, NULL, 'Transcription elongation factor SPT5', NULL, NULL, NULL, NULL, NULL, 4),
(142954, NULL, 'G3DSA:3.30.60.30:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142955, NULL, 'G3DSA:3.30.1370.10:FF:000138', NULL, NULL, 'KH type 1 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(142956, NULL, 'G3DSA:1.10.220.150:FF:000011', NULL, NULL, 'Arf-GAP with dual PH domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(142957, NULL, 'G3DSA:3.30.420.230:FF:000001', NULL, NULL, 'Pre-mRNA-processing-splicing factor 8', NULL, NULL, NULL, NULL, NULL, 4),
(142958, NULL, 'G3DSA:1.20.1250.20:FF:002008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142959, NULL, 'G3DSA:3.90.930.12:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142960, NULL, 'G3DSA:3.40.50.1000:FF:000527', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142961, NULL, 'G3DSA:3.90.226.10:FF:000263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142962, NULL, 'G3DSA:3.30.60.20:FF:000107', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(142963, NULL, 'G3DSA:1.10.472.10:FF:000298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142964, NULL, 'G3DSA:3.40.50.2300:FF:000670', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142965, NULL, 'G3DSA:3.40.50.80:FF:000231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142966, NULL, 'G3DSA:3.30.160.60:FF:001453', NULL, NULL, 'POZ-, AT hook-, and zinc finger-containing protein 1 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(142967, NULL, 'G3DSA:2.60.120.700:FF:000001', NULL, NULL, 'Putative aspergillopepsin', NULL, NULL, NULL, NULL, NULL, 4),
(142968, NULL, 'G3DSA:1.20.1080.10:FF:000053', NULL, NULL, 'Aquaporin, glycerol transport activity', NULL, NULL, NULL, NULL, NULL, 4),
(142969, NULL, 'G3DSA:3.30.70.240:FF:000048', NULL, NULL, 'Elongation factor 2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(142970, NULL, 'G3DSA:1.25.40.90:FF:000032', NULL, NULL, 'CTD kinase subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(142971, NULL, 'G3DSA:2.70.20.10:FF:000018', NULL, NULL, 'DNA topoisomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(142972, NULL, 'G3DSA:3.50.50.60:FF:000051', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(142973, NULL, 'G3DSA:3.40.50.10810:FF:000125', NULL, NULL, 'Helicase, Snf2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(142974, NULL, 'G3DSA:2.130.10.10:FF:004062', NULL, NULL, 'Eukaryotic translation initiation factor 2A', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(142975, NULL, 'G3DSA:3.30.40.10:FF:000221', NULL, NULL, 'E3 ubiquitin-protein ligase FANCL isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(142976, NULL, 'G3DSA:3.30.70.330:FF:000249', NULL, NULL, 'Pre-mRNA-splicing factor CWC2, variant', NULL, NULL, NULL, NULL, NULL, 4),
(142977, NULL, 'G3DSA:2.130.10.120:FF:000008', NULL, NULL, 'Prolyl oligopeptidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(142978, NULL, 'G3DSA:1.10.1200.10:FF:000094', NULL, NULL, 'Nonribosomal peptide synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142979, NULL, 'G3DSA:3.40.630.30:FF:000388', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(142980, NULL, 'G3DSA:3.30.160.60:FF:002555', NULL, NULL, 'B-cell CLL/lymphoma 6 member B protein', NULL, NULL, NULL, NULL, NULL, 4),
(142981, NULL, 'G3DSA:3.30.870.10:FF:000149', NULL, NULL, 'Phospholipase D superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(142982, NULL, 'G3DSA:1.20.120.790:FF:000015', NULL, NULL, '90 kDa heat shock protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142983, NULL, 'G3DSA:3.80.10.10:FF:002988', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142984, NULL, 'G3DSA:3.90.550.10:FF:000443', NULL, NULL, 'Glycosyl transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(142985, NULL, 'G3DSA:3.30.70.330:FF:001177', NULL, NULL, 'Putative RNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(142986, NULL, 'G3DSA:3.90.1310.10:FF:000008', NULL, NULL, 'Penicillin-binding protein, transpeptidase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(142987, NULL, 'G3DSA:1.25.40.10:FF:002705', NULL, NULL, 'TPR-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(142988, NULL, 'G3DSA:1.10.357.10:FF:000047', NULL, NULL, 'Transcriptional regulator, TetR family', NULL, NULL, NULL, NULL, NULL, 4),
(142989, NULL, 'G3DSA:3.30.60.20:FF:000080', NULL, NULL, 'Serine/threonine-protein kinase dkf-1', NULL, NULL, NULL, NULL, NULL, 4),
(142990, NULL, 'G3DSA:2.60.120.400:FF:000001', NULL, NULL, 'Fucose-binding lectin PA-IIL', NULL, NULL, NULL, NULL, NULL, 4),
(142991, NULL, 'G3DSA:2.60.40.10:FF:000868', NULL, NULL, 'Plexin D1', NULL, NULL, NULL, NULL, NULL, 4),
(142992, NULL, 'G3DSA:3.90.290.10:FF:000018', NULL, NULL, 'latent-transforming growth factor beta-binding protein 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(142993, NULL, 'G3DSA:3.10.20.90:FF:000357', NULL, NULL, 'STE20/SPS1-related proline-alanine-rich protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(142994, NULL, 'G3DSA:1.10.287.110:FF:000229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142995, NULL, 'G3DSA:3.30.70.330:FF:000721', NULL, NULL, 'Nuclear polyadenylated RNA-binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(142996, NULL, 'G3DSA:3.90.79.10:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142997, NULL, 'G3DSA:1.10.510.10:FF:004406', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(142998, NULL, 'G3DSA:3.40.630.10:FF:000382', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(142999, NULL, 'G3DSA:2.10.220.10:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143000, NULL, 'G3DSA:2.130.10.10:FF:000346', NULL, NULL, 'Sema-1a, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(143001, NULL, 'G3DSA:1.20.5.170:FF:000100', NULL, NULL, 'ATP-dependent helicase BRM', NULL, NULL, NULL, NULL, NULL, 4),
(143002, NULL, 'G3DSA:3.90.15.10:FF:000014', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(143003, NULL, 'G3DSA:2.60.40.60:FF:000243', NULL, NULL, 'Cadherin 16, KSP-cadherin', NULL, NULL, NULL, NULL, NULL, 4),
(143004, NULL, 'G3DSA:2.130.10.10:FF:005989', NULL, NULL, 'JNK-interacting protein 3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(143005, NULL, 'G3DSA:3.50.50.60:FF:000730', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(143006, NULL, 'G3DSA:2.10.10.20:FF:000012', NULL, NULL, 'Chitinase ChiA', NULL, NULL, NULL, NULL, NULL, 4),
(143007, NULL, 'G3DSA:2.60.120.310:FF:000007', NULL, NULL, 'MOXD1 homolog 2', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(143008, NULL, 'G3DSA:3.30.710.10:FF:000082', NULL, NULL, 'zinc finger and BTB domain-containing protein 24 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(143009, NULL, 'G3DSA:2.160.10.10:FF:000042', NULL, NULL, 'Translation initiation factor eIF2B subunit', NULL, NULL, NULL, NULL, NULL, 4),
(143010, NULL, 'G3DSA:1.10.472.10:FF:000618', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143011, NULL, 'G3DSA:2.60.34.10:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143012, NULL, 'G3DSA:4.10.365.10:FF:000004', NULL, NULL, 'Cyclin-dependent kinase inhibitor 4', NULL, NULL, NULL, NULL, NULL, 4),
(143013, NULL, 'G3DSA:3.40.50.12390:FF:000003', NULL, NULL, '5''-3'' exoribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(143014, NULL, 'G3DSA:1.10.287.630:FF:000003', NULL, NULL, 'Cyclic nucleotide-gated ion channel 1', NULL, NULL, NULL, NULL, NULL, 4),
(143015, NULL, 'G3DSA:3.10.380.20:FF:000001', NULL, NULL, '16S rRNA endonuclease CdiA', NULL, NULL, NULL, NULL, NULL, 4),
(143016, NULL, 'G3DSA:2.60.40.10:FF:000189', NULL, NULL, 'Neogenin isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(143017, NULL, 'G3DSA:2.60.40.10:FF:002459', NULL, NULL, 'Phosphatase family protein (AFU_orthologue AFUA_5G07860)', NULL, NULL, NULL, NULL, NULL, 4),
(143018, NULL, 'G3DSA:3.90.70.10:FF:000086', NULL, NULL, 'Cysteine proteinase falcipain 2a', NULL, NULL, NULL, NULL, NULL, 4),
(143019, NULL, 'G3DSA:2.130.10.10:FF:002437', NULL, NULL, 'Pre-mRNA-splicing factor RSE1', NULL, NULL, NULL, NULL, NULL, 4),
(143020, NULL, 'G3DSA:3.60.15.10:FF:000111', NULL, NULL, 'MBL fold metallo-hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(143021, NULL, 'G3DSA:3.40.50.300:FF:003140', NULL, NULL, 'Polynucleotide kinase 3-phosphatase putative', NULL, NULL, NULL, NULL, NULL, 4),
(143022, NULL, 'G3DSA:3.30.40.10:FF:000160', NULL, NULL, 'Ring finger protein 141', NULL, NULL, NULL, NULL, NULL, 4),
(143023, NULL, 'G3DSA:1.10.418.10:FF:000156', NULL, NULL, 'Fimbrin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143024, NULL, 'G3DSA:1.20.120.530:FF:000016', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(143025, NULL, 'G3DSA:1.25.40.10:FF:003015', NULL, NULL, 'Bardet-Biedl syndrome 4', NULL, NULL, NULL, NULL, NULL, 4),
(143026, NULL, 'G3DSA:1.20.120.520:FF:000013', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(143027, NULL, 'G3DSA:1.10.472.10:FF:000091', NULL, NULL, 'putative cyclin-B3-1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(143028, NULL, 'G3DSA:3.30.497.10:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143029, NULL, 'G3DSA:3.60.15.10:FF:000257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143030, NULL, 'G3DSA:3.30.70.3490:FF:000006', NULL, NULL, 'Oxysterol-binding protein-related protein 1C', NULL, NULL, NULL, NULL, NULL, 4),
(143031, NULL, 'G3DSA:3.30.565.10:FF:000480', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143032, NULL, 'G3DSA:1.10.30.10:FF:000018', NULL, NULL, 'High mobility group protein B2', NULL, NULL, NULL, NULL, NULL, 4),
(143033, NULL, 'G3DSA:3.40.640.10:FF:000321', NULL, NULL, 'Serine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(143034, NULL, 'G3DSA:2.60.40.2030:FF:000034', NULL, NULL, 'Adhesion G-protein-coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(143035, NULL, 'G3DSA:2.10.25.10:FF:001044', NULL, NULL, 'Protein lin-12', NULL, NULL, NULL, NULL, NULL, 4),
(143036, NULL, 'G3DSA:2.60.40.10:FF:004404', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143037, NULL, 'G3DSA:3.30.505.10:FF:000178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143038, NULL, 'G3DSA:3.40.50.300:FF:002797', NULL, NULL, 'Uridine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(143039, NULL, 'G3DSA:1.10.287.70:FF:000222', NULL, NULL, 'Voltage-gated Ion Channel (VIC) Superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(143040, NULL, 'G3DSA:3.40.50.2000:FF:000670', NULL, NULL, 'Alpha-1,3/1,6-mannosyltransferase ALG2', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(143041, NULL, 'G3DSA:3.30.70.920:FF:000038', NULL, NULL, 'Uncharacterized HTH-type transcriptional regulator PH0140', NULL, NULL, NULL, NULL, NULL, 4),
(143042, NULL, 'G3DSA:1.10.8.270:FF:000008', NULL, NULL, 'Putative TBC1 domain family member 14', NULL, NULL, NULL, NULL, NULL, 4),
(143043, NULL, 'G3DSA:3.40.50.150:FF:001009', NULL, NULL, 'tRNA wybutosine-synthesizing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(143044, NULL, 'G3DSA:3.40.140.10:FF:000148', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(143045, NULL, 'G3DSA:2.40.50.90:FF:000101', NULL, NULL, 'Probable staphylococcal-like nuclease CAN4', NULL, NULL, NULL, NULL, NULL, 4),
(143046, NULL, 'G3DSA:3.30.870.10:FF:000003', NULL, NULL, 'Cardiolipin synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(143047, NULL, 'G3DSA:1.10.510.10:FF:002815', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143048, NULL, 'G3DSA:3.40.30.10:FF:000754', NULL, NULL, 'Putative 28S ribosomal protein S25, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(143049, NULL, 'G3DSA:3.40.50.12090:FF:000003', NULL, NULL, 'Precursor of the S-layer proteins', NULL, NULL, NULL, NULL, NULL, 4),
(143050, NULL, 'G3DSA:2.130.10.10:FF:004680', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143051, NULL, 'G3DSA:3.40.50.720:FF:000124', NULL, NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(143052, NULL, 'G3DSA:3.90.1030.10:FF:000026', NULL, NULL, '50S ribosomal protein L17', NULL, NULL, NULL, NULL, NULL, 4),
(143053, NULL, 'G3DSA:2.30.29.30:FF:000523', NULL, NULL, 'Protostome-specific GEF, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(143054, NULL, 'G3DSA:3.40.50.300:FF:002943', NULL, NULL, 'DNA polymerase III subunit epsilon protein', NULL, NULL, NULL, NULL, NULL, 4),
(143055, NULL, 'G3DSA:2.30.22.10:FF:000007', NULL, NULL, 'Protein GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(143056, NULL, 'G3DSA:1.10.8.80:FF:000008', NULL, NULL, 'Putative moxR protein', NULL, NULL, NULL, NULL, NULL, 4),
(143057, NULL, 'G3DSA:3.40.50.80:FF:000085', NULL, NULL, 'Iron-uptake factor', NULL, NULL, NULL, NULL, NULL, 4),
(143058, NULL, 'G3DSA:2.60.40.10:FF:000368', NULL, NULL, 'kalirin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(143059, NULL, 'G3DSA:3.40.50.12120:FF:000001', NULL, NULL, 'Proteasome biogenesis-associated', NULL, NULL, NULL, NULL, NULL, 4),
(143060, NULL, 'G3DSA:3.30.160.60:FF:004179', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143061, NULL, 'G3DSA:3.40.50.790:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143062, NULL, 'G3DSA:3.30.160.60:FF:002055', NULL, NULL, 'INSM transcriptional repressor 1', NULL, NULL, NULL, NULL, NULL, 4),
(143063, NULL, 'G3DSA:3.40.50.2000:FF:000344', NULL, NULL, 'Glycosyl transferase group 1', NULL, NULL, NULL, NULL, NULL, 4),
(143064, NULL, 'G3DSA:3.40.190.290:FF:000053', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(143065, NULL, 'G3DSA:2.60.40.10:FF:002813', NULL, NULL, 'Neural cell adhesion molecule L1', NULL, NULL, NULL, NULL, NULL, 4),
(143066, NULL, 'G3DSA:2.10.25.10:FF:001723', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143067, NULL, 'G3DSA:3.30.450.20:FF:000047', NULL, NULL, 'SIM bHLH transcription factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(143068, NULL, 'G3DSA:2.20.25.10:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143069, NULL, 'G3DSA:3.30.1490.100:FF:000020', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(143070, NULL, 'G3DSA:3.30.40.10:FF:001295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143071, NULL, 'G3DSA:2.120.10.30:FF:000173', NULL, NULL, 'NHL (Ring finger b-box coiled coil) domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(143072, NULL, 'G3DSA:3.40.50.10810:FF:000097', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(143073, NULL, 'G3DSA:3.40.50.620:FF:000392', NULL, NULL, 'Sensor histidine kinase KdpD', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(143074, NULL, 'G3DSA:3.40.50.620:FF:000212', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(143075, NULL, 'G3DSA:3.40.640.10:FF:000528', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143076, NULL, 'G3DSA:3.30.710.10:FF:000109', NULL, NULL, 'zinc finger and BTB domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(143077, NULL, 'G3DSA:3.40.50.720:FF:001877', NULL, NULL, 'Damino acid oxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143078, NULL, 'G3DSA:3.10.350.10:FF:000024', NULL, NULL, 'Hypothetical exported protein', NULL, NULL, NULL, NULL, NULL, 4),
(143079, NULL, 'G3DSA:1.10.300.10:FF:000006', NULL, NULL, 'Adenylosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(143080, NULL, 'G3DSA:3.30.56.30:FF:000005', NULL, NULL, 'signal recognition particle 19 kDa protein-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(143081, NULL, 'G3DSA:3.30.565.10:FF:000541', NULL, NULL, 'Glr1767 protein', NULL, NULL, NULL, NULL, NULL, 4),
(143082, NULL, 'G3DSA:3.90.550.10:FF:000089', NULL, NULL, 'Cellulose synthase-like protein D4', NULL, NULL, NULL, NULL, NULL, 4),
(143083, NULL, 'G3DSA:1.10.510.10:FF:000337', NULL, NULL, 'Serine/threonine-protein kinase SBK1', NULL, NULL, NULL, NULL, NULL, 4),
(143084, NULL, 'G3DSA:3.30.930.10:FF:000385', NULL, NULL, 'Biotin--protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(143085, NULL, 'G3DSA:1.25.40.10:FF:004622', NULL, NULL, 'General transcription factor 3C polypeptide 3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(143086, NULL, 'G3DSA:1.20.1070.10:FF:001862', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143087, NULL, 'G3DSA:3.90.1600.10:FF:000020', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(143088, NULL, 'G3DSA:1.20.870.10:FF:000013', NULL, NULL, 'rap guanine nucleotide exchange factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(143089, NULL, 'G3DSA:3.30.160.60:FF:000638', NULL, NULL, 'Zinc finger protein 184', NULL, NULL, NULL, NULL, NULL, 4),
(143090, NULL, 'G3DSA:3.40.830.10:FF:000004', NULL, NULL, 'YJR008W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(143091, NULL, 'G3DSA:1.25.40.10:FF:000109', NULL, NULL, 'Cell division coordinator CpoB', NULL, NULL, NULL, NULL, NULL, 4),
(143092, NULL, 'G3DSA:1.20.144.10:FF:000096', NULL, NULL, 'phospholipid phosphatase 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(143093, NULL, 'G3DSA:3.10.150.10:FF:000009', NULL, NULL, 'Beta sliding clamp', NULL, NULL, NULL, NULL, NULL, 4),
(143094, NULL, 'G3DSA:2.40.30.10:FF:000526', NULL, NULL, 'Eukaryotic translation initiation factor 5B, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(143095, NULL, 'G3DSA:1.20.1310.10:FF:000178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143096, NULL, 'G3DSA:3.30.40.10:FF:001941', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143097, NULL, 'G3DSA:2.10.25.10:FF:001544', NULL, NULL, 'Chymotrypsin inhibitor Ani s 6', NULL, NULL, NULL, NULL, NULL, 4),
(143098, NULL, 'G3DSA:1.25.10.10:FF:000607', NULL, NULL, 'Protein CLASP-2', NULL, NULL, NULL, NULL, NULL, 4),
(143099, NULL, 'G3DSA:1.20.140.80:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143100, NULL, 'G3DSA:3.30.70.330:FF:001677', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143101, NULL, 'G3DSA:2.130.10.10:FF:004915', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(143102, NULL, 'G3DSA:2.40.30.10:FF:000234', NULL, NULL, 'U5 small nuclear ribonucleoprotein component, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143103, NULL, 'G3DSA:2.60.40.60:FF:000743', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(143104, NULL, 'G3DSA:3.90.1110.10:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143105, NULL, 'G3DSA:3.30.530.20:FF:000048', NULL, NULL, 'Sreptomyces cyclase/dehydrase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(143106, NULL, 'G3DSA:3.40.50.620:FF:000066', NULL, NULL, 'valine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(143107, NULL, 'G3DSA:3.10.110.10:FF:000243', NULL, NULL, 'UBiquitin Conjugating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(143108, NULL, 'G3DSA:3.30.1370.50:FF:000010', NULL, NULL, 'Shuttle craft, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(143109, NULL, 'G3DSA:1.20.58.390:FF:000109', NULL, NULL, 'AcetylCholine Receptor', NULL, NULL, NULL, NULL, NULL, 4),
(143110, NULL, 'G3DSA:3.40.50.300:FF:004388', NULL, NULL, 'DNA packaging ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(143111, NULL, 'G3DSA:1.10.238.270:FF:000003', NULL, NULL, 'Odorant-binding protein 47b', NULL, NULL, NULL, NULL, NULL, 4),
(143112, NULL, 'G3DSA:2.30.30.40:FF:000390', NULL, NULL, 'ITSN (Intersectin) family', NULL, NULL, NULL, NULL, NULL, 4),
(143113, NULL, 'G3DSA:3.80.10.10:FF:003770', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143114, NULL, 'G3DSA:3.90.660.10:FF:000125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143115, NULL, 'G3DSA:3.40.50.720:FF:001585', NULL, NULL, 'Short-chain dehydrogenase/reductase family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143116, NULL, 'G3DSA:2.70.170.10:FF:000068', NULL, NULL, 'LOW QUALITY PROTEIN: 5-hydroxytryptamine receptor 3C-like', NULL, NULL, NULL, NULL, NULL, 4),
(143117, NULL, 'G3DSA:1.25.40.10:FF:004089', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g20710, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(143118, NULL, 'G3DSA:3.90.70.10:FF:000440', NULL, NULL, 'Calpain-like cysteine peptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143119, NULL, 'G3DSA:3.10.20.70:FF:000025', NULL, NULL, 'Glutamine synthetase catalytic region', NULL, NULL, NULL, NULL, NULL, 4),
(143120, NULL, 'G3DSA:1.10.10.60:FF:000009', NULL, NULL, 'transcription factor MYB1R1', NULL, NULL, NULL, NULL, NULL, 4),
(143121, NULL, 'G3DSA:1.20.120.230:FF:000050', NULL, NULL, 'Breast cancer anti-estrogen resistance protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(143122, NULL, 'G3DSA:3.30.160.60:FF:000817', NULL, NULL, 'zinc finger protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(143123, NULL, 'G3DSA:1.10.8.60:FF:000587', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143124, NULL, 'G3DSA:3.30.540.10:FF:000017', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(143125, NULL, 'G3DSA:2.60.40.1670:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143126, NULL, 'G3DSA:3.30.1520.10:FF:000055', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(143127, NULL, 'G3DSA:3.40.630.10:FF:000056', NULL, NULL, 'Zinc carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(143128, NULL, 'G3DSA:3.40.50.300:FF:007968', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(143129, NULL, 'G3DSA:3.30.200.20:FF:000181', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(143130, NULL, 'G3DSA:1.25.40.180:FF:000161', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(143131, NULL, 'G3DSA:3.80.10.10:FF:000133', NULL, NULL, 'prolargin', NULL, NULL, NULL, NULL, NULL, 4),
(143132, NULL, 'G3DSA:3.90.70.10:FF:000732', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143133, NULL, 'G3DSA:6.10.300.40:FF:000002', NULL, NULL, 'Proteasome 26S subunit, non-ATPase 4a', NULL, NULL, NULL, NULL, NULL, 4),
(143134, NULL, 'G3DSA:3.20.20.70:FF:000856', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143135, NULL, 'G3DSA:3.30.160.60:FF:004825', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143136, NULL, 'G3DSA:1.25.40.60:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143137, NULL, 'G3DSA:3.90.1100.10:FF:000055', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(143138, NULL, 'G3DSA:2.60.40.640:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143139, NULL, 'G3DSA:2.60.40.1660:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143140, NULL, 'G3DSA:1.10.1060.10:FF:000003', NULL, NULL, 'Succinate dehydrogenase iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(143141, NULL, 'G3DSA:1.25.40.10:FF:004443', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g08305', NULL, NULL, NULL, NULL, NULL, 4),
(143142, NULL, 'G3DSA:1.25.40.10:FF:001981', NULL, NULL, 'EMB2261 putative', NULL, NULL, NULL, NULL, NULL, 4),
(143143, NULL, 'G3DSA:4.10.80.40:FF:000006', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] flavoprotein subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(143144, NULL, 'G3DSA:2.120.10.10:FF:000015', NULL, NULL, 'Hemagglutinin-neuraminidase', NULL, NULL, NULL, NULL, NULL, 4),
(143145, NULL, 'G3DSA:1.20.58.80:FF:000029', NULL, NULL, 'GM15315', NULL, NULL, NULL, NULL, NULL, 4),
(143146, NULL, 'G3DSA:3.40.50.2000:FF:000018', NULL, NULL, 'UDP-N-acetylglucosamine--N-acetylmuramyl-(pentapeptide) pyrophosphoryl-undecaprenol N-acetylglucosamine transferase', NULL, NULL, NULL, NULL, NULL, 4),
(143147, NULL, 'G3DSA:2.160.20.10:FF:000194', NULL, NULL, 'Preneck appendage protein', NULL, NULL, NULL, NULL, NULL, 4),
(143148, NULL, 'G3DSA:2.130.10.10:FF:004354', NULL, NULL, 'Autophagy-related protein 16-1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(143149, NULL, 'G3DSA:3.40.30.10:FF:000428', NULL, NULL, 'Protein disulfide-isomerase A4', NULL, NULL, NULL, NULL, NULL, 4),
(143150, NULL, 'G3DSA:1.20.272.40:FF:000014', NULL, NULL, 'ATP-dependent RNA helicase SUPV3L1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(143151, NULL, 'G3DSA:3.30.70.330:FF:002520', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143152, NULL, 'G3DSA:2.40.100.10:FF:000155', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(143153, NULL, 'G3DSA:2.40.320.10:FF:000020', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 18', NULL, NULL, NULL, NULL, NULL, 4),
(143154, NULL, 'G3DSA:2.130.10.10:FF:002145', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(143155, NULL, 'G3DSA:3.20.20.80:FF:000213', NULL, NULL, 'Arabinogalactan endo-beta-1,4-galactanase', NULL, NULL, NULL, NULL, NULL, 4),
(143156, NULL, 'G3DSA:3.50.50.60:FF:000343', NULL, NULL, 'FAD/NAD(P)-binding oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(143157, NULL, 'G3DSA:3.30.780.10:FF:000030', NULL, NULL, 'Mitochondrial large ribosomal subunit L49, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143158, NULL, 'G3DSA:3.80.10.10:FF:001853', NULL, NULL, 'YALI0B18759p', NULL, NULL, NULL, NULL, NULL, 4),
(143159, NULL, 'G3DSA:1.10.510.10:FF:001152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143160, NULL, 'G3DSA:3.40.30.10:FF:001064', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(143161, NULL, 'G3DSA:1.20.120.1630:FF:000004', NULL, NULL, '7-dehydrocholesterol reductase', NULL, NULL, NULL, NULL, NULL, 4),
(143162, NULL, 'G3DSA:3.30.420.40:FF:000670', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143163, NULL, 'G3DSA:1.25.40.10:FF:003807', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143164, NULL, 'G3DSA:1.25.40.20:FF:000882', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(143165, NULL, 'G3DSA:1.20.1070.10:FF:000142', NULL, NULL, 'G protein-coupled receptor 55', NULL, NULL, NULL, NULL, NULL, 4),
(143166, NULL, 'G3DSA:1.10.510.10:FF:000663', NULL, NULL, 'Mixed lineage kinase domain-like pseudokinase', NULL, NULL, NULL, NULL, NULL, 4),
(143167, NULL, 'G3DSA:2.40.10.350:FF:000014', NULL, NULL, 'Cell shape-determining protein MreC', NULL, NULL, NULL, NULL, NULL, 4),
(143168, NULL, 'G3DSA:3.40.50.300:FF:004096', NULL, NULL, 'Multidrug resistance protein (SpaB)', NULL, NULL, NULL, NULL, NULL, 4),
(143169, NULL, 'G3DSA:1.20.1090.10:FF:000025', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(143170, NULL, 'G3DSA:3.40.50.300:FF:002325', NULL, NULL, 'Hydrogenase maturation GTPase HydF', NULL, NULL, NULL, NULL, NULL, 4),
(143171, NULL, 'G3DSA:3.20.20.70:FF:000210', NULL, NULL, '2-nitropropane dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(143172, NULL, 'G3DSA:1.10.760.10:FF:000063', NULL, NULL, 'PQQ-dependent dehydrogenase, methanol/ethanol family', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(143173, NULL, 'G3DSA:2.130.10.10:FF:001010', NULL, NULL, 'Chromatin assembly factor 1 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(143174, NULL, 'G3DSA:3.30.160.60:FF:002381', NULL, NULL, 'Putative spalt protein', NULL, NULL, NULL, NULL, NULL, 4),
(143175, NULL, 'G3DSA:1.10.150.240:FF:000050', NULL, NULL, 'Phosphoglycolate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(143176, NULL, 'G3DSA:3.40.50.300:FF:000998', NULL, NULL, 'Thymidine kinase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(143177, NULL, 'G3DSA:3.30.565.10:FF:000187', NULL, NULL, 'Mlh1, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(143178, NULL, 'G3DSA:3.10.20.690:FF:000003', NULL, NULL, 'DNA gyrase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(143179, NULL, 'G3DSA:3.30.70.330:FF:002166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143180, NULL, 'G3DSA:3.90.550.10:FF:000617', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143181, NULL, 'G3DSA:1.10.150.20:FF:000211', NULL, NULL, 'Rad10p', NULL, NULL, NULL, NULL, NULL, 4),
(143182, NULL, 'G3DSA:1.20.58.480:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143183, NULL, 'G3DSA:1.20.58.70:FF:000026', NULL, NULL, 'Syntaxin-132', NULL, NULL, NULL, NULL, NULL, 4),
(143184, NULL, 'G3DSA:2.60.200.20:FF:000178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143185, NULL, 'G3DSA:3.30.200.20:FF:001928', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143186, NULL, 'G3DSA:1.20.58.60:FF:000023', NULL, NULL, 'Kalirin RhoGEF kinase b', NULL, NULL, NULL, NULL, NULL, 4),
(143187, NULL, 'G3DSA:3.40.1390.10:FF:000008', NULL, NULL, 'UDP-3-O-acylglucosamine N-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(143188, NULL, 'G3DSA:1.20.58.390:FF:000289', NULL, NULL, 'Cholinergic receptor, nicotinic, alpha polypeptide 9', NULL, NULL, NULL, NULL, NULL, 4),
(143189, NULL, 'G3DSA:2.30.30.40:FF:000417', NULL, NULL, 'Neutrophil cytosolic factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(143190, NULL, 'G3DSA:3.20.110.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143191, NULL, 'G3DSA:2.60.120.260:FF:000442', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143192, NULL, 'G3DSA:1.10.1040.10:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143193, NULL, 'G3DSA:3.40.50.150:FF:000846', NULL, NULL, 'tRNA (Guanine-N-7) methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(143194, NULL, 'G3DSA:1.25.10.10:FF:002378', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143195, NULL, 'G3DSA:1.20.120.1760:FF:000077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143196, NULL, 'G3DSA:1.20.1000.10:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143197, NULL, 'G3DSA:3.30.70.1230:FF:000138', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(143198, NULL, 'G3DSA:3.50.50.60:FF:000904', NULL, NULL, 'Oxidoreductase PigB', NULL, NULL, NULL, NULL, NULL, 4),
(143199, NULL, 'G3DSA:3.30.200.20:FF:000029', NULL, NULL, 'Serine/threonine-protein kinase TAO2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143200, NULL, 'G3DSA:1.20.120.1750:FF:000074', NULL, NULL, 'E3 ubiquitin-protein ligase parkin', NULL, NULL, NULL, NULL, NULL, 4),
(143201, NULL, 'G3DSA:3.40.850.10:FF:000213', NULL, NULL, 'Probable Chs8-Chitin Synthase 8', NULL, NULL, NULL, NULL, NULL, 4),
(143202, NULL, 'G3DSA:3.30.70.20:FF:000052', NULL, NULL, 'NADH-ubiquinone oxidoreductase-G iron-sulfur binding region', NULL, NULL, NULL, NULL, NULL, 4),
(143203, NULL, 'G3DSA:3.40.1260.10:FF:000004', NULL, NULL, 'Sulfurtransferase TusC', NULL, NULL, NULL, NULL, NULL, 4),
(143204, NULL, 'G3DSA:2.10.25.10:FF:000442', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(143205, NULL, 'G3DSA:3.40.50.300:FF:001223', NULL, NULL, 'X-ray repair cross complementing 3', NULL, NULL, NULL, NULL, NULL, 4),
(143206, NULL, 'G3DSA:3.40.50.1820:FF:001728', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(143207, NULL, 'G3DSA:3.40.50.300:FF:006866', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143208, NULL, 'G3DSA:3.30.420.40:FF:000877', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143209, NULL, 'G3DSA:3.40.1260.20:FF:000007', NULL, NULL, 'Ribonuclease G', NULL, NULL, NULL, NULL, NULL, 4),
(143210, NULL, 'G3DSA:2.40.30.170:FF:000032', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(143211, NULL, 'G3DSA:2.30.30.40:FF:000597', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143212, NULL, 'G3DSA:3.30.70.3400:FF:000019', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(143213, NULL, 'G3DSA:1.25.40.10:FF:000727', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(143214, NULL, 'G3DSA:2.40.390.10:FF:000001', NULL, NULL, 'Hydantoinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143215, NULL, 'G3DSA:3.40.640.10:FF:000293', NULL, NULL, 'Pyridoxal dependent decarboxylase domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(143216, NULL, 'G3DSA:3.40.50.300:FF:000734', NULL, NULL, 'ATPase family, AAA domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(143217, NULL, 'G3DSA:1.10.472.10:FF:000326', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143218, NULL, 'G3DSA:3.40.720.10:FF:000294', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143219, NULL, 'G3DSA:4.10.60.10:FF:000047', NULL, NULL, 'Glycine-rich RNA-binding protein RZ1C', NULL, NULL, NULL, NULL, NULL, 4),
(143220, NULL, 'G3DSA:2.60.40.10:FF:004258', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143221, NULL, 'G3DSA:1.10.490.10:FF:000020', NULL, NULL, 'Globin-coupled sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(143222, NULL, 'G3DSA:2.30.180.10:FF:000185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143223, NULL, 'G3DSA:2.170.150.20:FF:000001', NULL, NULL, 'Peptide methionine sulfoxide reductase MsrB', NULL, NULL, NULL, NULL, NULL, 4),
(143224, NULL, 'G3DSA:3.30.160.60:FF:000790', NULL, NULL, 'flt3-interacting zinc finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(143225, NULL, 'G3DSA:3.40.630.10:FF:000410', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143226, NULL, 'G3DSA:3.30.70.330:FF:000575', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein H3', NULL, NULL, NULL, NULL, NULL, 4),
(143227, NULL, 'G3DSA:1.10.506.10:FF:000086', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(143228, NULL, 'G3DSA:1.10.132.60:FF:000035', NULL, NULL, 'DNA polymerase epsilon, catalytic subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(143229, NULL, 'G3DSA:3.50.50.60:FF:001478', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(143230, NULL, 'G3DSA:1.10.555.10:FF:000098', NULL, NULL, 'Related to BEM2-GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(143231, NULL, 'G3DSA:3.40.50.720:FF:001259', NULL, NULL, 'UDP-galactose 4-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(143232, NULL, 'G3DSA:3.30.2300.10:FF:000011', NULL, NULL, 'THUMP domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(143233, NULL, 'G3DSA:3.30.830.10:FF:000175', NULL, NULL, 'Axl1p', NULL, NULL, NULL, NULL, NULL, 4),
(143234, NULL, 'G3DSA:3.30.465.10:FF:000123', NULL, NULL, 'Hemolysin protein', NULL, NULL, NULL, NULL, NULL, 4),
(143235, NULL, 'G3DSA:3.30.470.30:FF:000052', NULL, NULL, 'ATP-dependent DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(143236, NULL, 'G3DSA:2.160.20.10:FF:000014', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(143237, NULL, 'G3DSA:1.10.10.60:FF:000189', NULL, NULL, 'Homeobox protein engrailed-like', NULL, NULL, NULL, NULL, NULL, 4),
(143238, NULL, 'G3DSA:3.10.129.10:FF:000027', NULL, NULL, 'Uncharacterized acyl-CoA thioester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(143239, NULL, 'G3DSA:3.15.10.30:FF:000002', NULL, NULL, 'GL26314', NULL, NULL, NULL, NULL, NULL, 4),
(143240, NULL, 'G3DSA:2.10.25.10:FF:001605', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(143241, NULL, 'G3DSA:3.30.50.10:FF:000071', NULL, NULL, 'GATA transcription factor 28', NULL, NULL, NULL, NULL, NULL, 4),
(143242, NULL, 'G3DSA:3.30.70.330:FF:001738', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143243, NULL, 'G3DSA:3.30.70.330:FF:002312', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143244, NULL, 'G3DSA:3.30.160.60:FF:002942', NULL, NULL, 'Protein teashirt', NULL, NULL, NULL, NULL, NULL, 4),
(143245, NULL, 'G3DSA:1.20.58.60:FF:000523', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143246, NULL, 'G3DSA:1.25.10.10:FF:000580', NULL, NULL, 'Protein peg1', NULL, NULL, NULL, NULL, NULL, 4),
(143247, NULL, 'G3DSA:3.40.50.300:FF:008165', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(143248, NULL, 'G3DSA:1.10.10.10:FF:000461', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(143249, NULL, 'G3DSA:2.60.120.200:FF:000093', NULL, NULL, 'Laminin subunit alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(143250, NULL, 'G3DSA:2.130.10.10:FF:000285', NULL, NULL, 'WD repeat and FYVE domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(143251, NULL, 'G3DSA:3.40.30.10:FF:000928', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(143252, NULL, 'G3DSA:3.90.100.10:FF:000005', NULL, NULL, 'Ornithine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(143253, NULL, 'G3DSA:1.25.10.10:FF:000079', NULL, NULL, 'transportin-3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(143254, NULL, 'G3DSA:1.25.40.10:FF:001216', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(143255, NULL, 'G3DSA:1.25.40.20:FF:001219', NULL, NULL, 'SI:dZ87I4.2 (Novel glutaminase)', NULL, NULL, NULL, NULL, NULL, 4),
(143256, NULL, 'G3DSA:1.25.10.10:FF:002816', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143257, NULL, 'G3DSA:3.40.50.300:FF:002825', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(143258, NULL, 'G3DSA:3.40.50.12440:FF:000007', NULL, NULL, 'Nitrate reductase alpha subunit (NarG)', NULL, NULL, NULL, NULL, NULL, 4),
(143259, NULL, 'G3DSA:3.30.1330.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143260, NULL, 'G3DSA:2.30.30.1020:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143261, NULL, 'G3DSA:3.40.30.10:FF:000872', NULL, NULL, 'Glutaredoxin-3', NULL, NULL, NULL, NULL, NULL, 4),
(143262, NULL, 'G3DSA:1.10.340.70:FF:000010', NULL, NULL, 'YALI0E13376p', NULL, NULL, NULL, NULL, NULL, 4),
(143263, NULL, 'G3DSA:1.20.1280.50:FF:000198', NULL, NULL, 'F-box/WD repeat-containing protein A-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(143264, NULL, 'G3DSA:2.40.70.10:FF:000298', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143265, NULL, 'G3DSA:3.30.60.20:FF:000046', NULL, NULL, 'Rho GTPase-activating protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(143266, NULL, 'G3DSA:1.10.510.10:FF:001360', NULL, NULL, 'Heptose kinase', NULL, NULL, NULL, NULL, NULL, 4),
(143267, NULL, 'G3DSA:2.130.10.10:FF:004028', NULL, NULL, 'Nucleolar protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143268, NULL, 'G3DSA:1.25.70.10:FF:000055', NULL, NULL, 'Transcription termination factor 5, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(143269, NULL, 'G3DSA:3.90.1800.10:FF:000001', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(143270, NULL, 'G3DSA:3.30.1330.20:FF:000049', NULL, NULL, 'Beta-tubulin 2', NULL, NULL, NULL, NULL, NULL, 4),
(143271, NULL, 'G3DSA:3.10.180.10:FF:000016', NULL, NULL, 'Methylmalonyl-CoA epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(143272, NULL, 'G3DSA:1.10.8.960:FF:000002', NULL, NULL, 'Glutamate-cysteine ligase Gcs1', NULL, NULL, NULL, NULL, NULL, 4),
(143273, NULL, 'G3DSA:3.10.100.10:FF:000006', NULL, NULL, 'Layilin b', NULL, NULL, NULL, NULL, NULL, 4),
(143274, NULL, 'G3DSA:1.10.10.60:FF:000953', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143275, NULL, 'G3DSA:1.25.40.10:FF:003779', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(143276, NULL, 'G3DSA:2.60.40.10:FF:002931', NULL, NULL, 'GH04611p', NULL, NULL, NULL, NULL, NULL, 4),
(143277, NULL, 'G3DSA:3.40.50.1580:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143278, NULL, 'G3DSA:1.25.40.10:FF:004830', NULL, NULL, 'Crooked neck protein-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(143279, NULL, 'G3DSA:1.10.443.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143280, NULL, 'G3DSA:3.30.300.30:FF:000040', NULL, NULL, 'GG11281', NULL, NULL, NULL, NULL, NULL, 4),
(143281, NULL, 'G3DSA:4.10.1000.10:FF:000031', NULL, NULL, 'Cleavage and polyadenylation specific factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(143282, NULL, 'G3DSA:1.10.10.10:FF:002018', NULL, NULL, 'Putative MarR-family regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(143283, NULL, 'G3DSA:2.70.40.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143284, NULL, 'G3DSA:2.60.120.260:FF:000650', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143285, NULL, 'G3DSA:1.10.3730.20:FF:000064', NULL, NULL, 'solute carrier family 35 member G1', NULL, NULL, NULL, NULL, NULL, 4),
(143286, NULL, 'G3DSA:3.30.750.210:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143287, NULL, 'G3DSA:3.90.550.10:FF:000409', NULL, NULL, 'SPbeta prophage-derived glycosyltransferase SunS', NULL, NULL, NULL, NULL, NULL, 4),
(143288, NULL, 'G3DSA:1.20.1070.10:FF:001777', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143289, NULL, 'G3DSA:3.40.50.300:FF:004534', NULL, NULL, 'DEAD-box ATP-dependent RNA helicase 5', NULL, NULL, NULL, NULL, NULL, 4),
(143290, NULL, 'G3DSA:3.40.50.11070:FF:000001', NULL, NULL, 'Protein STE5', NULL, NULL, NULL, NULL, NULL, 4),
(143291, NULL, 'G3DSA:2.70.170.10:FF:000186', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(143292, NULL, 'G3DSA:1.10.150.220:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143293, NULL, 'G3DSA:1.25.40.10:FF:000227', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g13880', NULL, NULL, NULL, NULL, NULL, 4),
(143294, NULL, 'G3DSA:3.40.850.10:FF:000421', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143295, NULL, 'G3DSA:3.40.50.300:FF:007030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143296, NULL, 'G3DSA:1.10.238.10:FF:000092', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(143297, NULL, 'G3DSA:3.40.50.1820:FF:001762', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143298, NULL, 'G3DSA:1.10.472.10:FF:000652', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143299, NULL, 'G3DSA:1.20.144.10:FF:000124', NULL, NULL, 'Phosphatidate phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143300, NULL, 'G3DSA:3.40.50.720:FF:001759', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143301, NULL, 'G3DSA:3.30.160.60:FF:005489', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143302, NULL, 'G3DSA:3.30.200.20:FF:002390', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143303, NULL, 'G3DSA:4.10.60.10:FF:000255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143304, NULL, 'G3DSA:1.10.150.240:FF:000016', NULL, NULL, 'Phosphoenolpyruvate and 6-phosphogluconate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(143305, NULL, 'G3DSA:2.40.110.10:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143306, NULL, 'G3DSA:3.10.100.10:FF:000332', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143307, NULL, 'G3DSA:1.20.140.40:FF:000079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143308, NULL, 'G3DSA:3.30.70.20:FF:000018', NULL, NULL, 'Cytochrome c nitrite reductase, Fe-S protein', NULL, NULL, NULL, NULL, NULL, 4),
(143309, NULL, 'G3DSA:3.30.40.10:FF:001615', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(143310, NULL, 'G3DSA:3.30.750.24:FF:000007', NULL, NULL, 'Prestin', NULL, NULL, NULL, NULL, NULL, 4),
(143311, NULL, 'G3DSA:1.20.1160.11:FF:000004', NULL, NULL, 'Paired amphipathic helix protein Sin3a', NULL, NULL, NULL, NULL, NULL, 4),
(143312, NULL, 'G3DSA:1.10.10.60:FF:000482', NULL, NULL, 'Homeobox protein TOS8', NULL, NULL, NULL, NULL, NULL, 4),
(143313, NULL, 'G3DSA:3.40.50.2300:FF:000052', NULL, NULL, 'DNA-binding response regulator YycF', NULL, NULL, NULL, NULL, NULL, 4),
(143314, NULL, 'G3DSA:1.20.120.730:FF:000019', NULL, NULL, 'SEC24 homolog B, COPII coat complex component', NULL, NULL, NULL, NULL, NULL, 4),
(143315, NULL, 'G3DSA:2.30.30.40:FF:000389', NULL, NULL, 'RAS p21 protein activator (GTPase activating protein) 1a', NULL, NULL, NULL, NULL, NULL, 4),
(143316, NULL, 'G3DSA:3.40.50.12430:FF:000004', NULL, NULL, 'Birt-Hogg-Dube', NULL, NULL, NULL, NULL, NULL, 4),
(143317, NULL, 'G3DSA:1.20.5.190:FF:000140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143318, NULL, 'G3DSA:1.20.1250.20:FF:000209', NULL, NULL, 'Transporter, MFS superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(143319, NULL, 'G3DSA:3.30.497.10:FF:000107', NULL, NULL, 'Serpin-2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143320, NULL, 'G3DSA:3.40.50.1820:FF:001083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143321, NULL, 'G3DSA:3.20.20.20:FF:000010', NULL, NULL, 'Dihydropteroate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(143322, NULL, 'G3DSA:3.30.70.610:FF:000002', NULL, NULL, 'Quinone-dependent D-lactate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(143323, NULL, 'G3DSA:1.20.5.1700:FF:000006', NULL, NULL, 'Bone marrow stromal antigen 2', NULL, NULL, NULL, NULL, NULL, 4),
(143324, NULL, 'G3DSA:2.40.50.100:FF:000066', NULL, NULL, 'Glycine cleavage system H protein', NULL, NULL, NULL, NULL, NULL, 4),
(143325, NULL, 'G3DSA:3.30.420.40:FF:000523', NULL, NULL, 'Actin-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(143326, NULL, 'G3DSA:1.10.274.10:FF:000006', NULL, NULL, 'Phosphotransferase system, fructose-specific EI/HPr/EIIA components', NULL, NULL, NULL, NULL, NULL, 4),
(143327, NULL, 'G3DSA:3.30.200.20:FF:000355', NULL, NULL, 'Nik related kinase', NULL, NULL, NULL, NULL, NULL, 4),
(143328, NULL, 'G3DSA:1.20.1070.10:FF:001098', NULL, NULL, 'G-protein coupled receptor GRL101-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(143329, NULL, 'G3DSA:2.60.40.10:FF:004584', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143330, NULL, 'G3DSA:3.40.50.300:FF:000526', NULL, NULL, 'DExH-box ATP-dependent RNA helicase DExH3', NULL, NULL, NULL, NULL, NULL, 4),
(143331, NULL, 'G3DSA:3.40.718.10:FF:000001', NULL, NULL, 'Isocitrate dehydrogenase [NAD] subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(143332, NULL, 'G3DSA:3.40.1360.10:FF:000068', NULL, NULL, 'Topoisomerase-like enzyme2', NULL, NULL, NULL, NULL, NULL, 4),
(143333, NULL, 'G3DSA:2.120.10.80:FF:000401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143334, NULL, 'G3DSA:3.90.550.10:FF:000561', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143335, NULL, 'G3DSA:3.30.70.3290:FF:000003', NULL, NULL, 'Fatty acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(143336, NULL, 'G3DSA:3.80.10.10:FF:001561', NULL, NULL, 'Tubulin folding cofactor E', NULL, NULL, NULL, NULL, NULL, 4),
(143337, NULL, 'G3DSA:2.40.100.10:FF:000037', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(143338, NULL, 'G3DSA:3.30.1370.10:FF:000223', NULL, NULL, 'KRR1 small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4),
(143339, NULL, 'G3DSA:3.10.110.10:FF:000361', NULL, NULL, 'Protein IMPACT homolog', NULL, NULL, NULL, NULL, NULL, 4),
(143340, NULL, 'G3DSA:2.60.40.10:FF:001150', NULL, NULL, 'Intercellular adhesion molecule 5', NULL, NULL, NULL, NULL, NULL, 4),
(143341, NULL, 'G3DSA:1.10.510.10:FF:000955', NULL, NULL, 'YDL025C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(143342, NULL, 'G3DSA:3.40.190.10:FF:000538', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(143343, NULL, 'G3DSA:3.30.70.330:FF:001795', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143344, NULL, 'G3DSA:3.10.110.10:FF:000304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143345, NULL, 'G3DSA:3.90.1720.30:FF:000006', NULL, NULL, 'Glycosyl hydrolase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(143346, NULL, 'G3DSA:3.30.530.20:FF:000166', NULL, NULL, 'Polyketide cyclase/dehydrase and lipid transport superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(143347, NULL, 'G3DSA:3.40.50.11660:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143348, NULL, 'G3DSA:2.170.130.10:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143349, NULL, 'G3DSA:3.40.50.720:FF:002102', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(143350, NULL, 'G3DSA:3.30.160.60:FF:006478', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143351, NULL, 'G3DSA:1.20.1070.10:FF:001362', NULL, NULL, 'Neuropeptide FF receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143352, NULL, 'G3DSA:3.40.140.10:FF:000182', NULL, NULL, 'YALI0D26884p', NULL, NULL, NULL, NULL, NULL, 4),
(143353, NULL, 'G3DSA:3.40.50.80:FF:000113', NULL, NULL, 'NADPH-dependent FMN/FAD containing oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(143354, NULL, 'G3DSA:2.60.210.10:FF:000029', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(143355, NULL, 'G3DSA:1.20.58.60:FF:000315', NULL, NULL, 'Spectrin beta chain, non-erythrocytic', NULL, NULL, NULL, NULL, NULL, 4),
(143356, NULL, 'G3DSA:3.40.50.620:FF:000420', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(143357, NULL, 'G3DSA:3.40.50.300:FF:000408', NULL, NULL, 'Shikimate kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(143358, NULL, 'G3DSA:3.30.70.270:FF:000124', NULL, NULL, 'DNA repair protein REV1', NULL, NULL, NULL, NULL, NULL, 4),
(143359, NULL, 'G3DSA:1.10.10.60:FF:000217', NULL, NULL, 'Transcriptional regulator, AraC family', NULL, NULL, NULL, NULL, NULL, 4),
(143360, NULL, 'G3DSA:1.10.150.20:FF:000126', NULL, NULL, 'DNA repair protein RAD51 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(143361, NULL, 'G3DSA:1.10.560.10:FF:000048', NULL, NULL, '60 kDa chaperonin 1', NULL, NULL, NULL, NULL, NULL, 4),
(143362, NULL, 'G3DSA:1.10.3720.10:FF:000178', NULL, NULL, '2-aminoethylphosphonate transport system permease protein phnU', NULL, NULL, NULL, NULL, NULL, 4),
(143363, NULL, 'G3DSA:2.40.50.140:FF:000229', NULL, NULL, 'Woronin body major protein', NULL, NULL, NULL, NULL, NULL, 4),
(143364, NULL, 'G3DSA:3.40.50.300:FF:002617', NULL, NULL, 'Elongator complex protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(143365, NULL, 'G3DSA:3.30.1590.10:FF:000003', NULL, NULL, 'Maltooligosyl trehalose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(143366, NULL, 'G3DSA:3.30.160.60:FF:002616', NULL, NULL, 'Deformed wings', NULL, NULL, NULL, NULL, NULL, 4),
(143367, NULL, 'G3DSA:3.40.50.10810:FF:000243', NULL, NULL, 'ERCC excision repair 6, chromatin-remodeling factor', NULL, NULL, NULL, NULL, NULL, 4),
(143368, NULL, 'G3DSA:2.40.110.10:FF:000009', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(143369, NULL, 'G3DSA:3.40.50.170:FF:000032', NULL, NULL, 'Methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(143370, NULL, 'G3DSA:3.80.10.10:FF:001706', NULL, NULL, 'Chaoptin', NULL, NULL, NULL, NULL, NULL, 4),
(143371, NULL, 'G3DSA:3.40.50.150:FF:001010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143372, NULL, 'G3DSA:2.130.10.10:FF:000493', NULL, NULL, 'Nucleoporin SEH1', NULL, NULL, NULL, NULL, NULL, 4),
(143373, NULL, 'G3DSA:1.10.533.10:FF:000261', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143374, NULL, 'G3DSA:3.40.50.2000:FF:000552', NULL, NULL, 'Asparagine Linked Glycosylation (ALG) homolog, Nematode', NULL, NULL, NULL, NULL, NULL, 4),
(143375, NULL, 'G3DSA:2.130.10.10:FF:000964', NULL, NULL, 'WD repeat domain phosphoinositide-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(143376, NULL, 'G3DSA:3.40.250.10:FF:000010', NULL, NULL, 'Phage shock protein PspE', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(143377, NULL, 'G3DSA:3.30.590.10:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143378, NULL, 'G3DSA:2.30.30.40:FF:000182', NULL, NULL, 'Tyrosine-protein kinase Fyn', NULL, NULL, NULL, NULL, NULL, 4),
(143379, NULL, 'G3DSA:2.60.40.2240:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143380, NULL, 'G3DSA:2.60.40.2220:FF:000001', NULL, NULL, 'Alpha-mannosidase 2C1', NULL, NULL, NULL, NULL, NULL, 4),
(143381, NULL, 'G3DSA:3.30.70.120:FF:000012', NULL, NULL, 'DUF190 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(143382, NULL, 'G3DSA:2.30.29.30:FF:000315', NULL, NULL, 'pleckstrin homology domain-containing family M member 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(143383, NULL, 'G3DSA:2.10.25.10:FF:001662', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143384, NULL, 'G3DSA:1.10.238.10:FF:001108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143385, NULL, 'G3DSA:2.60.40.150:FF:000366', NULL, NULL, 'Putative U5 small nuclear ribonucleoprotein 200 kDa helicase', NULL, NULL, NULL, NULL, NULL, 4),
(143386, NULL, 'G3DSA:1.10.510.10:FF:002254', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143387, NULL, 'G3DSA:3.60.15.10:FF:000050', NULL, NULL, 'Metallo-beta-lactamase type 2', NULL, NULL, NULL, NULL, NULL, 4),
(143388, NULL, 'G3DSA:3.30.70.870:FF:000001', NULL, NULL, 'Elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(143389, NULL, 'G3DSA:1.10.530.40:FF:000004', NULL, NULL, 'Lysozyme', NULL, NULL, NULL, NULL, NULL, 4),
(143390, NULL, 'G3DSA:3.80.10.10:FF:001768', NULL, NULL, 'NACHT, LRR and PYD domains-containing protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(143391, NULL, 'G3DSA:2.170.270.10:FF:000237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143392, NULL, 'G3DSA:3.20.20.100:FF:000032', NULL, NULL, 'Hyperkinetic, isoform I', NULL, NULL, NULL, NULL, NULL, 4),
(143393, NULL, 'G3DSA:2.130.10.10:FF:000228', NULL, NULL, 'COMPASS-like H3K4 histone methylase component WDR5A', NULL, NULL, NULL, NULL, NULL, 4),
(143394, NULL, 'G3DSA:2.20.70.10:FF:000170', NULL, NULL, 'Rho GTPase-activating protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(143395, NULL, 'G3DSA:1.10.10.60:FF:000274', NULL, NULL, 'Homeobox-leucine zipper protein HOX24', NULL, NULL, NULL, NULL, NULL, 4),
(143396, NULL, 'G3DSA:1.10.150.20:FF:000183', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(143397, NULL, 'G3DSA:2.60.120.650:FF:000143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143398, NULL, 'G3DSA:3.30.70.330:FF:000603', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(143399, NULL, 'G3DSA:3.30.70.330:FF:001385', NULL, NULL, 'Multiple RNA-binding domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(143400, NULL, 'G3DSA:2.130.10.10:FF:004707', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143401, NULL, 'G3DSA:3.40.390.10:FF:000048', NULL, NULL, 'Zinc metalloproteinase', NULL, NULL, NULL, NULL, NULL, 4),
(143402, NULL, 'G3DSA:3.80.10.10:FF:001089', NULL, NULL, 'Protein NLRC5', NULL, NULL, NULL, NULL, NULL, 4),
(143403, NULL, 'G3DSA:1.20.140.140:FF:000004', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(143404, NULL, 'G3DSA:1.10.730.10:FF:000056', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(143405, NULL, 'G3DSA:3.60.21.10:FF:000378', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143406, NULL, 'G3DSA:2.60.40.60:FF:000389', NULL, NULL, 'Protocadherin Fat', NULL, NULL, NULL, NULL, NULL, 4),
(143407, NULL, 'G3DSA:1.25.40.10:FF:002644', NULL, NULL, 'Signal recognition particle subunit srp72', NULL, NULL, NULL, NULL, NULL, 4),
(143408, NULL, 'G3DSA:3.30.450.20:FF:000401', NULL, NULL, 'Aryl hydrocarbon receptor nuclear translocator type 1b', NULL, NULL, NULL, NULL, NULL, 4),
(143409, NULL, 'G3DSA:2.40.30.10:FF:000498', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(143410, NULL, 'G3DSA:3.20.20.120:FF:000038', NULL, NULL, 'Hydrophobic dipeptide epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(143411, NULL, 'G3DSA:2.20.70.10:FF:000018', NULL, NULL, 'DGCR8 microprocessor complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(143412, NULL, 'G3DSA:1.20.140.150:FF:000007', NULL, NULL, 'transmembrane protein 178B', NULL, NULL, NULL, NULL, NULL, 4),
(143413, NULL, 'G3DSA:1.20.1250.20:FF:001671', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(143414, NULL, 'G3DSA:1.20.1070.10:FF:001569', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143415, NULL, 'G3DSA:3.30.40.10:FF:001823', NULL, NULL, 'SWI/SNF family DNA-dependent ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143416, NULL, 'G3DSA:3.40.190.10:FF:000067', NULL, NULL, 'Cystine ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(143417, NULL, 'G3DSA:1.10.1300.10:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143418, NULL, 'G3DSA:3.10.450.10:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143419, NULL, 'G3DSA:1.20.120.230:FF:000016', NULL, NULL, 'Catenin alpha like 1', NULL, NULL, NULL, NULL, NULL, 4),
(143420, NULL, 'G3DSA:3.40.50.1000:FF:000561', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143421, NULL, 'G3DSA:3.80.10.10:FF:003359', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143422, NULL, 'G3DSA:2.60.120.920:FF:000067', NULL, NULL, 'ATP-dependent RNA helicase DDX1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143423, NULL, 'G3DSA:1.10.10.2660:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143424, NULL, 'G3DSA:1.10.472.170:FF:000012', NULL, NULL, 'Transcription initiation factor IIB-2', NULL, NULL, NULL, NULL, NULL, 4),
(143425, NULL, 'G3DSA:3.30.230.10:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143426, NULL, 'G3DSA:1.25.40.10:FF:002526', NULL, NULL, 'Putative peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(143427, NULL, 'G3DSA:1.20.140.100:FF:000043', NULL, NULL, 'Dynein heavy chain 4', NULL, NULL, NULL, NULL, NULL, 4),
(143428, NULL, 'G3DSA:1.25.40.20:FF:000438', NULL, NULL, 'Ankyrin repeat domain 31', NULL, NULL, NULL, NULL, NULL, 4),
(143429, NULL, 'G3DSA:1.20.210.10:FF:000042', NULL, NULL, 'Putative COX1/OXI3 intron 2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(143430, NULL, 'G3DSA:2.60.40.150:FF:000484', NULL, NULL, 'Copine, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143431, NULL, 'G3DSA:3.40.50.2300:FF:001564', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143432, NULL, 'G3DSA:4.10.400.10:FF:000188', NULL, NULL, 'Low-density lipoprotein receptor-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(143433, NULL, 'G3DSA:3.10.310.10:FF:000016', NULL, NULL, 'Diaminopimelate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(143434, NULL, 'G3DSA:3.20.190.20:FF:000001', NULL, NULL, 'Serine protease DegP', NULL, NULL, NULL, NULL, NULL, 4),
(143435, NULL, 'G3DSA:3.80.10.10:FF:002016', NULL, NULL, 'Leucine-rich repeat-containing 15', NULL, NULL, NULL, NULL, NULL, 4),
(143436, NULL, 'G3DSA:3.10.310.20:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143437, NULL, 'G3DSA:3.40.190.10:FF:000746', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143438, NULL, 'G3DSA:1.25.40.10:FF:000435', NULL, NULL, 'Pentatricopeptide repeat-containing protein MRL1, chloroplastic isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(143439, NULL, 'G3DSA:1.20.58.900:FF:000009', NULL, NULL, 'Small G protein signaling modulator 3', NULL, NULL, NULL, NULL, NULL, 4),
(143440, NULL, 'G3DSA:3.90.1150.10:FF:000092', NULL, NULL, 'Capsular polysaccharide biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(143441, NULL, 'G3DSA:1.20.5.190:FF:000139', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143442, NULL, 'G3DSA:2.130.10.10:FF:001009', NULL, NULL, 'Small nucleolar ribonucleoprotein complex subunit, putative', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(143443, NULL, 'G3DSA:2.60.120.200:FF:000031', NULL, NULL, 'NtA agrin', NULL, NULL, NULL, NULL, NULL, 4),
(143444, NULL, 'G3DSA:3.90.226.10:FF:000229', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(143445, NULL, 'G3DSA:1.25.40.10:FF:004235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143446, NULL, 'G3DSA:2.60.40.1170:FF:000057', NULL, NULL, 'Clathrin adaptor complexes medium subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(143447, NULL, 'G3DSA:1.20.1070.10:FF:001570', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(143448, NULL, 'G3DSA:3.10.180.10:FF:000045', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(143449, NULL, 'G3DSA:1.10.10.60:FF:000835', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143450, NULL, 'G3DSA:3.40.50.970:FF:000148', NULL, NULL, 'Pyruvate dehydrogenase E1 component subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(143451, NULL, 'G3DSA:3.90.70.30:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143452, NULL, 'G3DSA:3.30.160.60:FF:001245', NULL, NULL, 'zinc finger protein 48', NULL, NULL, NULL, NULL, NULL, 4),
(143453, NULL, 'G3DSA:3.40.50.300:FF:008575', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143454, NULL, 'G3DSA:1.20.120.220:FF:000013', NULL, NULL, 'ATP synthase F0 subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(143455, NULL, 'G3DSA:1.10.730.10:FF:000117', NULL, NULL, 'Mitochondrial probable methionyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(143456, NULL, 'G3DSA:3.40.50.11530:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143457, NULL, 'G3DSA:3.90.1410.10:FF:000157', NULL, NULL, 'N-lysine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(143458, NULL, 'G3DSA:1.10.560.10:FF:000082', NULL, NULL, 'McKusick-Kaufman syndrome', NULL, NULL, NULL, NULL, NULL, 4),
(143459, NULL, 'G3DSA:1.10.1370.10:FF:000021', NULL, NULL, 'Thimet oligopeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(143460, NULL, 'G3DSA:3.20.20.80:FF:000421', NULL, NULL, 'Glucosylceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(143461, NULL, 'G3DSA:3.40.50.1000:FF:000319', NULL, NULL, 'Haloacid dehalogenase family hydrolase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(143462, NULL, 'G3DSA:3.40.50.2020:FF:000058', NULL, NULL, 'Orotidine-5-phosphate decarboxylase/orotate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(143463, NULL, 'G3DSA:1.10.437.10:FF:000020', NULL, NULL, 'BCL2 like 10', NULL, NULL, NULL, NULL, NULL, 4),
(143464, NULL, 'G3DSA:1.10.1370.30:FF:000027', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(143465, NULL, 'G3DSA:3.30.160.60:FF:003044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143466, NULL, 'G3DSA:3.30.420.40:FF:000170', NULL, NULL, 'D-xylulose kinase', NULL, NULL, NULL, NULL, NULL, 4),
(143467, NULL, 'G3DSA:3.40.850.10:FF:000185', NULL, NULL, 'Kinesin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143468, NULL, 'G3DSA:1.10.472.10:FF:000444', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143469, NULL, 'G3DSA:1.10.418.10:FF:000038', NULL, NULL, 'LIM and calponin homology domains-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(143470, NULL, 'G3DSA:2.60.120.200:FF:000800', NULL, NULL, 'Putative L-type lectin-domain containing receptor kinase V.2', NULL, NULL, NULL, NULL, NULL, 4),
(143471, NULL, 'G3DSA:3.40.50.1240:FF:000048', NULL, NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(143472, NULL, 'G3DSA:3.90.640.10:FF:000124', NULL, NULL, 'Heat shock protein 70 putative', NULL, NULL, NULL, NULL, NULL, 4),
(143473, NULL, 'G3DSA:3.40.30.10:FF:001125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143474, NULL, 'G3DSA:3.80.10.10:FF:001914', NULL, NULL, 'Polycystin-1', NULL, NULL, NULL, NULL, NULL, 4),
(143475, NULL, 'G3DSA:1.25.10.10:FF:001304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(143476, NULL, 'G3DSA:1.25.10.10:FF:003013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143477, NULL, 'G3DSA:1.10.4200.10:FF:000004', NULL, NULL, 'Probable 2-(5''''-triphosphoribosyl)-3''-dephosphocoenzyme-A synthase', NULL, NULL, NULL, NULL, NULL, 4),
(143478, NULL, 'G3DSA:1.10.520.10:FF:000074', NULL, NULL, 'L-ascorbate peroxidase 2 cytosolic', NULL, NULL, NULL, NULL, NULL, 4),
(143479, NULL, 'G3DSA:3.40.50.2000:FF:000052', NULL, NULL, 'Alpha-1,3-glucan synthase Ags2', NULL, NULL, NULL, NULL, NULL, 4),
(143480, NULL, 'G3DSA:2.120.10.80:FF:000137', NULL, NULL, 'Kelch protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143481, NULL, 'G3DSA:2.30.30.40:FF:000625', NULL, NULL, 'Src like adaptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(143482, NULL, 'G3DSA:3.40.190.10:FF:000128', NULL, NULL, 'Taurine ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(143483, NULL, 'G3DSA:3.30.70.330:FF:000103', NULL, NULL, 'Polyadenylate-binding protein RBP47B', NULL, NULL, NULL, NULL, NULL, 4),
(143484, NULL, 'G3DSA:3.40.190.10:FF:000185', NULL, NULL, 'Iron ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(143485, NULL, 'G3DSA:3.40.50.300:FF:003022', NULL, NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily A containing DEAD/H box 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(143486, NULL, 'G3DSA:1.10.1870.10:FF:000014', NULL, NULL, 'Lysine-ketoglutarate reductase/saccharopine dehydrogenase bifunctional enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(143487, NULL, 'G3DSA:3.10.450.80:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143488, NULL, 'G3DSA:3.10.110.10:FF:000097', NULL, NULL, 'Gir2p', NULL, NULL, NULL, NULL, NULL, 4),
(143489, NULL, 'G3DSA:1.20.1080.10:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143490, NULL, 'G3DSA:1.10.940.10:FF:000009', NULL, NULL, 'Antitermination NusB domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(143491, NULL, 'G3DSA:3.20.20.70:FF:000795', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143492, NULL, 'G3DSA:1.10.150.20:FF:000065', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(143493, NULL, 'G3DSA:1.20.1250.20:FF:001637', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143494, NULL, 'G3DSA:2.70.70.10:FF:000055', NULL, NULL, 'Peptidase M23', NULL, NULL, NULL, NULL, NULL, 4),
(143495, NULL, 'G3DSA:3.40.190.10:FF:000331', NULL, NULL, 'Extracellular solute-binding protein family 5', NULL, NULL, NULL, NULL, NULL, 4),
(143496, NULL, 'G3DSA:1.10.1450.10:FF:000022', NULL, NULL, 'Tetraspanin 32', NULL, NULL, NULL, NULL, NULL, 4),
(143497, NULL, 'G3DSA:2.10.25.10:FF:001252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143498, NULL, 'G3DSA:1.10.8.270:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143499, NULL, 'G3DSA:3.30.565.10:FF:000507', NULL, NULL, 'Sensor histidine kinase, GAF domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(143500, NULL, 'G3DSA:2.60.260.20:FF:000187', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(143501, NULL, 'G3DSA:2.130.10.10:FF:005051', NULL, NULL, 'General transcription factor IIIC subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(143502, NULL, 'G3DSA:3.60.10.10:FF:000061', NULL, NULL, 'Type I inositol polyphosphate 5-phosphatase 2', NULL, NULL, NULL, NULL, NULL, 4),
(143503, NULL, 'G3DSA:1.20.80.10:FF:000032', NULL, NULL, 'FERM domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(143504, NULL, 'G3DSA:1.10.730.10:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143505, NULL, 'G3DSA:3.30.70.330:FF:000367', NULL, NULL, 'glycine-rich RNA-binding protein RZ1C', NULL, NULL, NULL, NULL, NULL, 4),
(143506, NULL, 'G3DSA:2.130.10.10:FF:000846', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1 homolog', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(143507, NULL, 'G3DSA:3.40.50.720:FF:001905', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(143508, NULL, 'G3DSA:2.40.70.10:FF:000034', NULL, NULL, 'Aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(143509, NULL, 'G3DSA:3.40.50.150:FF:000493', NULL, NULL, 'tRNA (uracil(54)-C(5))-methyltransferase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(143510, NULL, 'G3DSA:1.20.1070.10:FF:001159', NULL, NULL, 'Apelin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(143511, NULL, 'G3DSA:3.30.1360.120:FF:000076', NULL, NULL, 'tRNA modification GTPase TrmE', NULL, NULL, NULL, NULL, NULL, 4),
(143512, NULL, 'G3DSA:3.40.50.1240:FF:000195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143513, NULL, 'G3DSA:1.20.1050.10:FF:000225', NULL, NULL, 'Glutathione S-transferase 1, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(143514, NULL, 'G3DSA:2.130.10.10:FF:002645', NULL, NULL, 'VID27-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(143515, NULL, 'G3DSA:2.30.30.40:FF:000535', NULL, NULL, 'YALI0F19778p', NULL, NULL, NULL, NULL, NULL, 4),
(143516, NULL, 'G3DSA:3.40.50.2300:FF:000170', NULL, NULL, 'Response regulator receiver domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(143517, NULL, 'G3DSA:3.40.50.1440:FF:000075', NULL, NULL, 'Protein misato', NULL, NULL, NULL, NULL, NULL, 4),
(143518, NULL, 'G3DSA:2.160.20.10:FF:000222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143519, NULL, 'G3DSA:1.20.120.20:FF:000010', NULL, NULL, 'Apolipoprotein E', NULL, NULL, NULL, NULL, NULL, 4),
(143520, NULL, 'G3DSA:2.40.70.10:FF:000091', NULL, NULL, 'GG22202', NULL, NULL, NULL, NULL, NULL, 4),
(143521, NULL, 'G3DSA:3.30.200.20:FF:000501', NULL, NULL, 'Obscurin isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(143522, NULL, 'G3DSA:3.30.160.60:FF:000582', NULL, NULL, 'zinc finger protein 821 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(143523, NULL, 'G3DSA:1.10.418.10:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143524, NULL, 'G3DSA:3.40.50.300:FF:003640', NULL, NULL, 'GTPase, IMAP family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(143525, NULL, 'G3DSA:1.10.400.10:FF:000008', NULL, NULL, 'Guanine nucleotide-binding protein alpha-1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(143526, NULL, 'G3DSA:1.20.1530.20:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143527, NULL, 'G3DSA:2.60.40.10:FF:001032', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', NULL, NULL, NULL, NULL, NULL, 4),
(143528, NULL, 'G3DSA:2.60.40.10:FF:000576', NULL, NULL, 'Myosin-binding protein C, cardiac-type', NULL, NULL, NULL, NULL, NULL, 4),
(143529, NULL, 'G3DSA:1.10.10.10:FF:000427', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(143530, NULL, 'G3DSA:2.60.120.260:FF:000032', NULL, NULL, 'Sperm associated antigen 4 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(143531, NULL, 'G3DSA:3.30.160.60:FF:004472', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143532, NULL, 'G3DSA:3.30.710.10:FF:000317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143533, NULL, 'G3DSA:4.10.60.30:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143534, NULL, 'G3DSA:1.10.10.60:FF:000689', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(143535, NULL, 'G3DSA:3.40.30.10:FF:001182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143536, NULL, 'G3DSA:1.25.10.10:FF:002496', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143537, NULL, 'G3DSA:3.40.50.970:FF:000058', NULL, NULL, 'Putative pyruvate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(143538, NULL, 'G3DSA:3.40.50.720:FF:001198', NULL, NULL, 'GM21301', NULL, NULL, NULL, NULL, NULL, 4),
(143539, NULL, 'G3DSA:3.80.10.10:FF:001971', NULL, NULL, 'Leucine rich repeat containing 30', NULL, NULL, NULL, NULL, NULL, 4),
(143540, NULL, 'G3DSA:1.10.1040.10:FF:000002', NULL, NULL, '6-phosphogluconate dehydrogenase, decarboxylating', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(143541, NULL, 'G3DSA:3.40.50.150:FF:001217', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143542, NULL, 'G3DSA:3.20.20.80:FF:000331', NULL, NULL, 'Alpha-L-fucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(143543, NULL, 'G3DSA:2.10.50.10:FF:000068', NULL, NULL, 'Cysteine repeat modular protein 4 PbCRM4', NULL, NULL, NULL, NULL, NULL, 4),
(143544, NULL, 'G3DSA:1.10.510.10:FF:003889', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143545, NULL, 'G3DSA:3.20.20.30:FF:000013', NULL, NULL, 'Putative F420-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(143546, NULL, 'G3DSA:3.80.10.10:FF:003505', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143547, NULL, 'G3DSA:2.160.20.10:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143548, NULL, 'G3DSA:1.25.10.10:FF:000080', NULL, NULL, 'lisH domain and HEAT repeat-containing protein KIAA1468 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(143549, NULL, 'G3DSA:2.10.25.10:FF:001459', NULL, NULL, 'Laminin subunit alpha-1', NULL, NULL, NULL, NULL, NULL, 4),
(143550, NULL, 'G3DSA:1.10.238.10:FF:000445', NULL, NULL, 'Phosphatidylserine decarboxylase proenzyme 2', NULL, NULL, NULL, NULL, NULL, 4),
(143551, NULL, 'G3DSA:3.10.450.50:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143552, NULL, 'G3DSA:1.10.630.10:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143553, NULL, 'G3DSA:1.20.1730.10:FF:000024', NULL, NULL, 'Blast:Sodium-coupled monocarboxylate transporter 2', NULL, NULL, NULL, NULL, NULL, 4),
(143554, NULL, 'G3DSA:3.40.50.880:FF:000211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143555, NULL, 'G3DSA:1.50.40.10:FF:000489', NULL, NULL, 'Mitochondrial glycine transporter', NULL, NULL, NULL, NULL, NULL, 4),
(143556, NULL, 'G3DSA:1.10.40.30:FF:000002', NULL, NULL, 'Fumarate hydratase class II', NULL, NULL, NULL, NULL, NULL, 4),
(143557, NULL, 'G3DSA:3.30.70.330:FF:002048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143558, NULL, 'G3DSA:2.10.25.10:FF:000234', NULL, NULL, 'tomoregulin-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(143559, NULL, 'G3DSA:3.30.160.60:FF:000672', NULL, NULL, 'Zinc finger protein 430', NULL, NULL, NULL, NULL, NULL, 4),
(143560, NULL, 'G3DSA:3.30.230.130:FF:000035', NULL, NULL, 'Cullin_family /Cullin_protein_neddylation_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(143561, NULL, 'G3DSA:3.40.50.620:FF:000184', NULL, NULL, 'Putative isoleucyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(143562, NULL, 'G3DSA:3.30.200.20:FF:000708', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(143563, NULL, 'G3DSA:1.10.20.10:FF:000046', NULL, NULL, 'transcription initiation factor TFIID subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(143564, NULL, 'G3DSA:1.10.510.10:FF:000545', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(143565, NULL, 'G3DSA:2.120.10.30:FF:000139', NULL, NULL, 'SMP-30/Gluconolaconase/LRE domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(143566, NULL, 'G3DSA:3.30.420.40:FF:001041', NULL, NULL, 'Heat shock protein family A (Hsp70) member 9', NULL, NULL, NULL, NULL, NULL, 4),
(143567, NULL, 'G3DSA:2.60.40.150:FF:000720', NULL, NULL, 'Serine/threonine-protein kinase sck1', NULL, NULL, NULL, NULL, NULL, 4),
(143568, NULL, 'G3DSA:3.40.50.300:FF:005085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143569, NULL, 'G3DSA:1.25.40.20:FF:001253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143570, NULL, 'G3DSA:1.25.10.10:FF:000287', NULL, NULL, 'Exportin-4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(143571, NULL, 'G3DSA:3.40.50.1970:FF:000060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143572, NULL, 'G3DSA:2.130.10.10:FF:004236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143573, NULL, 'G3DSA:1.10.490.10:FF:000019', NULL, NULL, 'YNL234W-like protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(143574, NULL, 'G3DSA:1.10.8.60:FF:000469', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143575, NULL, 'G3DSA:2.40.50.90:FF:000040', NULL, NULL, 'Tudor domain containing 6', NULL, NULL, NULL, NULL, NULL, 4),
(143576, NULL, 'G3DSA:2.10.110.10:FF:000134', NULL, NULL, 'Lrg1p', NULL, NULL, NULL, NULL, NULL, 4),
(143577, NULL, 'G3DSA:3.30.1680.10:FF:000033', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(143578, NULL, 'G3DSA:4.10.60.10:FF:000108', NULL, NULL, 'Similar to zinc knuckle domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(143579, NULL, 'G3DSA:3.90.550.10:FF:000297', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(143580, NULL, 'G3DSA:1.20.58.1780:FF:000013', NULL, NULL, 'Nuclear pore complex protein (NUP155), putative', NULL, NULL, NULL, NULL, NULL, 4),
(143581, NULL, 'G3DSA:2.60.40.10:FF:002785', NULL, NULL, 'Myotactin form A', NULL, NULL, NULL, NULL, NULL, 4),
(143582, NULL, 'G3DSA:2.60.120.260:FF:000503', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143583, NULL, 'G3DSA:3.30.160.60:FF:002881', NULL, NULL, 'Reduced expression 2', NULL, NULL, NULL, NULL, NULL, 4),
(143584, NULL, 'G3DSA:2.60.40.10:FF:002167', NULL, NULL, 'Transglutaminase, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(143585, NULL, 'G3DSA:2.60.40.10:FF:004994', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143586, NULL, 'G3DSA:2.60.40.60:FF:000535', NULL, NULL, 'Cadherin-89D', NULL, NULL, NULL, NULL, NULL, 4),
(143587, NULL, 'G3DSA:1.25.10.10:FF:000641', NULL, NULL, 'RING zinc finger protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(143588, NULL, 'G3DSA:3.40.50.2300:FF:000018', NULL, NULL, 'DNA-binding transcriptional regulator NtrC', NULL, NULL, NULL, NULL, NULL, 4),
(143589, NULL, 'G3DSA:3.30.1370.100:FF:000038', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(143590, NULL, 'G3DSA:3.30.565.10:FF:000395', NULL, NULL, 'Two-component system sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(143591, NULL, 'G3DSA:3.30.750.24:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143592, NULL, 'G3DSA:3.30.710.10:FF:000110', NULL, NULL, 'Regulatory protein NPR3', NULL, NULL, NULL, NULL, NULL, 4),
(143593, NULL, 'G3DSA:1.10.150.360:FF:000001', NULL, NULL, 'Protein her-1', NULL, NULL, NULL, NULL, NULL, 4),
(143594, NULL, 'G3DSA:3.30.200.20:FF:000147', NULL, NULL, 'probable serine/threonine protein kinase IREH1', NULL, NULL, NULL, NULL, NULL, 4),
(143595, NULL, 'G3DSA:1.25.40.10:FF:005050', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(143596, NULL, 'G3DSA:2.100.10.30:FF:000011', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 40', NULL, NULL, NULL, NULL, NULL, 4),
(143597, NULL, 'G3DSA:3.30.300.30:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143598, NULL, 'G3DSA:2.120.10.30:FF:000381', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143599, NULL, 'G3DSA:1.10.10.520:FF:000014', NULL, NULL, 'Ubiquitin-activating enzyme E1-like', NULL, NULL, NULL, NULL, NULL, 4),
(143600, NULL, 'G3DSA:1.10.238.10:FF:000592', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(143601, NULL, 'G3DSA:2.40.320.10:FF:000019', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 18', NULL, NULL, NULL, NULL, NULL, 4),
(143602, NULL, 'G3DSA:3.90.1290.10:FF:000068', NULL, NULL, 'Dspa protein', NULL, NULL, NULL, NULL, NULL, 4),
(143603, NULL, 'G3DSA:2.130.10.30:FF:000032', NULL, NULL, 'Serine/threonine-protein kinase Nek8', NULL, NULL, NULL, NULL, NULL, 4),
(143604, NULL, 'G3DSA:3.10.10.10:FF:000024', NULL, NULL, 'Transposon Ty3-G Gag-Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(143605, NULL, 'G3DSA:3.10.100.10:FF:000124', NULL, NULL, 'Lectin-46Ca', NULL, NULL, NULL, NULL, NULL, 4),
(143606, NULL, 'G3DSA:3.30.160.60:FF:002263', NULL, NULL, 'Nrg1p', NULL, NULL, NULL, NULL, NULL, 4),
(143607, NULL, 'G3DSA:3.30.470.20:FF:000110', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(143608, NULL, 'G3DSA:2.120.10.30:FF:000229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143609, NULL, 'G3DSA:2.40.30.10:FF:000026', NULL, NULL, 'Eukaryotic translation initiation factor 5B', NULL, NULL, NULL, NULL, NULL, 4),
(143610, NULL, 'G3DSA:1.20.1250.20:FF:000243', NULL, NULL, 'Probable L-galactonate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(143611, NULL, 'G3DSA:2.130.10.10:FF:003983', NULL, NULL, 'Vacuolar protein sorting-associated protein 11 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(143612, NULL, 'G3DSA:3.80.10.10:FF:001353', NULL, NULL, 'Receptor-like protein kinase 2 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(143613, NULL, 'G3DSA:3.40.30.10:FF:001035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143614, NULL, 'G3DSA:2.60.40.10:FF:004376', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143615, NULL, 'G3DSA:1.10.510.10:FF:000455', NULL, NULL, 'protein spire homolog 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(143616, NULL, 'G3DSA:2.10.110.10:FF:000224', NULL, NULL, 'transcription factor protein', NULL, NULL, NULL, NULL, NULL, 4),
(143617, NULL, 'G3DSA:3.40.640.10:FF:000175', NULL, NULL, 'YLL058W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(143618, NULL, 'G3DSA:3.40.50.150:FF:000964', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143619, NULL, 'G3DSA:1.20.1070.10:FF:000024', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(143620, NULL, 'G3DSA:1.25.10.10:FF:002850', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143621, NULL, 'G3DSA:1.20.120.80:FF:000011', NULL, NULL, 'Cytochrome c oxidase subunit III', NULL, NULL, NULL, NULL, NULL, 4),
(143622, NULL, 'G3DSA:1.10.510.10:FF:002607', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143623, NULL, 'G3DSA:3.30.420.40:FF:000731', NULL, NULL, 'Actin-related protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(143624, NULL, 'G3DSA:1.20.5.4820:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143625, NULL, 'G3DSA:4.10.280.10:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143626, NULL, 'G3DSA:2.40.50.180:FF:000016', NULL, NULL, 'Chemotaxis protein CheW', NULL, NULL, NULL, NULL, NULL, 4),
(143627, NULL, 'G3DSA:3.30.40.10:FF:002020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143628, NULL, 'G3DSA:3.30.43.10:FF:000048', NULL, NULL, 'D-lactate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(143629, NULL, 'G3DSA:1.20.58.160:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143630, NULL, 'G3DSA:1.10.1670.10:FF:000004', NULL, NULL, 'DNA glycosylase/AP lyase ROS1', NULL, NULL, NULL, NULL, NULL, 4),
(143631, NULL, 'G3DSA:1.20.58.1880:FF:000009', NULL, NULL, 'Nuclear receptor corepressor 1', NULL, NULL, NULL, NULL, NULL, 4),
(143632, NULL, 'G3DSA:3.40.350.10:FF:000017', NULL, NULL, 'FACT complex subunit SPT16', NULL, NULL, NULL, NULL, NULL, 4),
(143633, NULL, 'G3DSA:3.40.1000.50:FF:000003', NULL, NULL, 'Repressor of RNA polymerase III transcription MAF1', NULL, NULL, NULL, NULL, NULL, 4),
(143634, NULL, 'G3DSA:1.10.238.20:FF:000010', NULL, NULL, 'Odorant-binding protein 56e', NULL, NULL, NULL, NULL, NULL, 4),
(143635, NULL, 'G3DSA:3.40.50.300:FF:005759', NULL, NULL, 'UvrD/REP helicase N-terminal domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(143636, NULL, 'G3DSA:3.30.830.10:FF:000293', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143637, NULL, 'G3DSA:3.40.140.10:FF:000266', NULL, NULL, 'Cytidine/deoxycytidylate deaminase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(143638, NULL, 'G3DSA:4.10.400.10:FF:000278', NULL, NULL, 'LDL receptor protein 1, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(143639, NULL, 'G3DSA:3.30.530.50:FF:000001', NULL, NULL, 'Outer membrane protein assembly factor BamC', NULL, NULL, NULL, NULL, NULL, 4),
(143640, NULL, 'G3DSA:2.160.20.10:FF:000278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143641, NULL, 'G3DSA:3.10.110.10:FF:000158', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 C', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(143642, NULL, 'G3DSA:2.130.10.10:FF:004270', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(143643, NULL, 'G3DSA:3.90.1150.10:FF:000030', NULL, NULL, 'UDP-4-amino-4-deoxy-L-arabinose--oxoglutarate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(143644, NULL, 'G3DSA:2.60.40.60:FF:001024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143645, NULL, 'G3DSA:1.10.510.10:FF:001118', NULL, NULL, 'Tyrosine-protein kinase PR2', NULL, NULL, NULL, NULL, NULL, 4),
(143646, NULL, 'G3DSA:3.40.50.80:FF:000023', NULL, NULL, 'Putative ferric-chelate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(143647, NULL, 'G3DSA:1.20.1250.10:FF:000122', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143648, NULL, 'G3DSA:3.40.395.10:FF:000008', NULL, NULL, 'Ulp1 protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(143649, NULL, 'G3DSA:3.30.200.20:FF:001693', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143650, NULL, 'G3DSA:3.30.559.10:FF:000212', NULL, NULL, 'Carnitine palmitoyltransferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(143651, NULL, 'G3DSA:3.10.100.10:FF:000186', NULL, NULL, 'Mannose receptor, C type 1b', NULL, NULL, NULL, NULL, NULL, 4),
(143652, NULL, 'G3DSA:1.10.940.10:FF:000010', NULL, NULL, 'Transcription antitermination protein NusB', NULL, NULL, NULL, NULL, NULL, 4),
(143653, NULL, 'G3DSA:1.10.238.220:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143654, NULL, 'G3DSA:3.40.50.1000:FF:000735', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143655, NULL, 'G3DSA:1.10.1200.80:FF:000007', NULL, NULL, 'tRNA-dihydrouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(143656, NULL, 'G3DSA:2.60.40.10:FF:002577', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(143657, NULL, 'G3DSA:3.30.457.50:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143658, NULL, 'G3DSA:1.10.510.10:FF:004294', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143659, NULL, 'G3DSA:2.102.10.10:FF:000056', NULL, NULL, 'Cytochrome b/b6 complex, iron-sulfur cluster-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(143660, NULL, 'G3DSA:3.40.367.20:FF:000025', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(143661, NULL, 'G3DSA:1.10.730.10:FF:000090', NULL, NULL, 'Methionine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(143662, NULL, 'G3DSA:3.90.550.10:FF:000651', NULL, NULL, 'Glycosyltransferases', NULL, NULL, NULL, NULL, NULL, 4),
(143663, NULL, 'G3DSA:1.20.1070.10:FF:001485', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(143664, NULL, 'G3DSA:3.30.160.60:FF:004264', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143665, NULL, 'G3DSA:1.10.1410.10:FF:000076', NULL, NULL, 'U Six snRNA Interacting Protein', NULL, NULL, NULL, NULL, NULL, 4),
(143666, NULL, 'G3DSA:2.60.40.10:FF:000397', NULL, NULL, 'angiopoietin-1 receptor isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(143667, NULL, 'G3DSA:1.10.10.60:FF:000190', NULL, NULL, 'Melibiose operon regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(143668, NULL, 'G3DSA:3.40.50.1780:FF:000036', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', NULL, NULL, NULL, NULL, NULL, 4),
(143669, NULL, 'G3DSA:3.60.110.10:FF:000102', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143670, NULL, 'G3DSA:3.30.160.60:FF:004943', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143671, NULL, 'G3DSA:1.20.1640.10:FF:000079', NULL, NULL, 'Putative multidrug resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(143672, NULL, 'G3DSA:1.10.287.110:FF:000347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143673, NULL, 'G3DSA:3.10.20.90:FF:000149', NULL, NULL, 'microtubule-associated proteins 1A/1B light chain 3C', NULL, NULL, NULL, NULL, NULL, 4),
(143674, NULL, 'G3DSA:3.40.630.10:FF:000174', NULL, NULL, 'Arginine utilization protein RocB', NULL, NULL, NULL, NULL, NULL, 4),
(143675, NULL, 'G3DSA:1.10.472.10:FF:000562', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(143676, NULL, 'G3DSA:2.60.120.780:FF:000013', NULL, NULL, 'YALI0E23342p', NULL, NULL, NULL, NULL, NULL, 4),
(143677, NULL, 'G3DSA:3.40.50.300:FF:003522', NULL, NULL, 'RAD51-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(143678, NULL, 'G3DSA:3.40.50.1760:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143679, NULL, 'G3DSA:3.30.450.20:FF:000311', NULL, NULL, 'Nitrogen fixation regulatory protein, NifL', NULL, NULL, NULL, NULL, NULL, 4),
(143680, NULL, 'G3DSA:1.20.950.20:FF:000022', NULL, NULL, 'Periplasmically oriented, membrane-bound [NiFe]-hydrogenase b-type cytochrome subunit', NULL, NULL, NULL, NULL, NULL, 4),
(143681, NULL, 'G3DSA:3.20.20.70:FF:000002', NULL, NULL, 'Transaldolase', NULL, NULL, NULL, NULL, NULL, 4),
(143682, NULL, 'G3DSA:3.40.50.720:FF:001962', NULL, NULL, 'Uncharacterized oxidoreductase C16H5.14c', NULL, NULL, NULL, NULL, NULL, 4),
(143683, NULL, 'G3DSA:1.25.40.180:FF:000043', NULL, NULL, 'MIF4G domain-containing protein / MA3 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(143684, NULL, 'G3DSA:3.40.50.300:FF:000291', NULL, NULL, 'ATP-dependent RNA helicase SrmB', NULL, NULL, NULL, NULL, NULL, 4),
(143685, NULL, 'G3DSA:3.90.1680.10:FF:000002', NULL, NULL, 'YMR114C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(143686, NULL, 'G3DSA:1.10.260.170:FF:000008', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', NULL, NULL, NULL, NULL, NULL, 4),
(143687, NULL, 'G3DSA:2.60.40.10:FF:004292', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143688, NULL, 'G3DSA:3.20.20.80:FF:000005', NULL, NULL, 'Glucan endo-1,3-beta-glucosidase 14', NULL, NULL, NULL, NULL, NULL, 4),
(143689, NULL, 'G3DSA:3.40.50.150:FF:000728', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(143690, NULL, 'G3DSA:3.30.160.60:FF:003162', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143691, NULL, 'G3DSA:1.10.150.60:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143692, NULL, 'G3DSA:1.10.20.140:FF:000003', NULL, NULL, 'tRNA dimethylallyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(143693, NULL, 'G3DSA:2.130.10.10:FF:002706', NULL, NULL, 'YALI0E06633p', NULL, NULL, NULL, NULL, NULL, 4),
(143694, NULL, 'G3DSA:1.20.1560.10:FF:000308', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(143695, NULL, 'G3DSA:1.10.472.130:FF:000056', NULL, NULL, 'Dynein heavy chain 6', NULL, NULL, NULL, NULL, NULL, 4),
(143696, NULL, 'G3DSA:3.40.50.300:FF:001431', NULL, NULL, 'Dephospho-CoA kinase', NULL, NULL, NULL, NULL, NULL, 4),
(143697, NULL, 'G3DSA:3.40.50.2000:FF:000462', NULL, NULL, 'Os02g0467700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(143698, NULL, 'G3DSA:1.10.472.10:FF:000360', NULL, NULL, 'Transcription factor TFIIB cyclin-related', NULL, NULL, NULL, NULL, NULL, 4),
(143699, NULL, 'G3DSA:2.60.120.200:FF:000328', NULL, NULL, 'Protein CBG09099', NULL, NULL, NULL, NULL, NULL, 4),
(143700, NULL, 'G3DSA:3.30.70.330:FF:002604', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143701, NULL, 'G3DSA:3.30.70.330:FF:000513', NULL, NULL, 'Splicing factor, proline-and glutamine-rich', NULL, NULL, NULL, NULL, NULL, 4),
(143702, NULL, 'G3DSA:3.40.980.10:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143703, NULL, 'G3DSA:2.130.10.10:FF:002229', NULL, NULL, 'NACHT and WD domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(143704, NULL, 'G3DSA:3.60.15.10:FF:000049', NULL, NULL, 'tRNase Z TRZ1', NULL, NULL, NULL, NULL, NULL, 4),
(143705, NULL, 'G3DSA:3.30.200.20:FF:002507', NULL, NULL, 'Protein kinase N1', NULL, NULL, NULL, NULL, NULL, 4),
(143706, NULL, 'G3DSA:3.40.50.300:FF:004826', NULL, NULL, 'SWF/SNF family helicase', NULL, NULL, NULL, NULL, NULL, 4),
(143707, NULL, 'G3DSA:1.10.238.10:FF:000529', NULL, NULL, 'Solute carrier family 25 member 13', NULL, NULL, NULL, NULL, NULL, 4),
(143708, NULL, 'G3DSA:3.40.1160.10:FF:000002', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(143709, NULL, 'G3DSA:1.25.40.10:FF:004061', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(143710, NULL, 'G3DSA:3.30.200.60:FF:000018', NULL, NULL, 'OTU deubiquitinase, ubiquitin aldehyde-binding 1b', NULL, NULL, NULL, NULL, NULL, 4),
(143711, NULL, 'G3DSA:3.40.140.10:FF:000064', NULL, NULL, 'Nuclear protein localization protein 4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143712, NULL, 'G3DSA:1.10.10.10:FF:000489', NULL, NULL, 'Putative peroxisomal membrane anchor protein', NULL, NULL, NULL, NULL, NULL, 4),
(143713, NULL, 'G3DSA:2.130.10.10:FF:004646', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143714, NULL, 'G3DSA:2.60.40.10:FF:003038', NULL, NULL, 'AGAP006350-PA', NULL, NULL, NULL, NULL, NULL, 4),
(143715, NULL, 'G3DSA:3.30.420.110:FF:000016', NULL, NULL, 'DNA mismatch repair protein MSH2', NULL, NULL, NULL, NULL, NULL, 4),
(143716, NULL, 'G3DSA:3.30.1330.60:FF:000038', NULL, NULL, 'Flagellar motor protein MotB', NULL, NULL, NULL, NULL, NULL, 4),
(143717, NULL, 'G3DSA:1.10.1080.10:FF:000004', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(143718, NULL, 'G3DSA:1.20.58.2220:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143719, NULL, 'G3DSA:3.30.565.10:FF:000272', NULL, NULL, 'Mlh2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(143720, NULL, 'G3DSA:3.30.420.100:FF:000013', NULL, NULL, '60S ribosomal protein L5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(143721, NULL, 'G3DSA:3.75.10.10:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143722, NULL, 'G3DSA:3.90.180.10:FF:000105', NULL, NULL, '6-hydroxycylohex-1-en-1-carbonyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(143723, NULL, 'G3DSA:3.30.70.330:FF:001300', NULL, NULL, 'RNA-binding motif protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(143724, NULL, 'G3DSA:3.30.70.3490:FF:000063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143725, NULL, 'G3DSA:3.50.50.60:FF:000461', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(143726, NULL, 'G3DSA:1.10.486.10:FF:000004', NULL, NULL, 'PCNA-interacting partner isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(143727, NULL, 'G3DSA:3.40.50.720:FF:000332', NULL, NULL, 'Galactitol-1-phosphate 5-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(143728, NULL, 'G3DSA:3.40.190.10:FF:000628', NULL, NULL, 'Glutamate receptor U1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143729, NULL, 'G3DSA:2.120.10.30:FF:000616', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143730, NULL, 'G3DSA:3.40.50.150:FF:001420', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143731, NULL, 'G3DSA:3.30.200.20:FF:000416', NULL, NULL, 'AGC/AKT protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(143732, NULL, 'G3DSA:3.60.120.10:FF:000018', NULL, NULL, 'Para-aminobenzoate synthase, component I, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143733, NULL, 'G3DSA:1.10.238.10:FF:000855', NULL, NULL, 'Defective in cullin neddylation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(143734, NULL, 'G3DSA:3.40.109.10:FF:000047', NULL, NULL, 'Probable NAD(P)H nitroreductase PigM', NULL, NULL, NULL, NULL, NULL, 4),
(143735, NULL, 'G3DSA:3.30.160.60:FF:003898', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143736, NULL, 'G3DSA:1.10.10.10:FF:000017', NULL, NULL, 'transcription factor RFX3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(143737, NULL, 'G3DSA:3.30.200.20:FF:001052', NULL, NULL, 'BnaA09g28440D protein', NULL, NULL, NULL, NULL, NULL, 4),
(143738, NULL, 'G3DSA:2.30.29.30:FF:001187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143739, NULL, 'G3DSA:1.25.10.10:FF:000490', NULL, NULL, 'CRM1p Major karyopherin', NULL, NULL, NULL, NULL, NULL, 4),
(143740, NULL, 'G3DSA:1.20.1250.20:FF:000327', NULL, NULL, 'Transporter, MFS superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(143741, NULL, 'G3DSA:3.40.50.1820:FF:001318', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143742, NULL, 'G3DSA:1.10.510.10:FF:000808', NULL, NULL, 'Serine/threonine kinase 31', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(143743, NULL, 'G3DSA:2.60.40.10:FF:004668', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143744, NULL, 'G3DSA:1.25.10.10:FF:002581', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143745, NULL, 'G3DSA:2.60.40.10:FF:000930', NULL, NULL, 'immunoglobulin superfamily DCC subclass member 3', NULL, NULL, NULL, NULL, NULL, 4),
(143746, NULL, 'G3DSA:3.20.20.300:FF:000002', NULL, NULL, 'Probable beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(143747, NULL, 'G3DSA:2.40.30.10:FF:000318', NULL, NULL, 'Probable mitochondrial tRNA-specific 2-thiouridylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(143748, NULL, 'G3DSA:1.10.10.10:FF:001001', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(143749, NULL, 'G3DSA:3.30.160.60:FF:005989', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143750, NULL, 'G3DSA:1.20.1050.130:FF:000022', NULL, NULL, 'Glutathione S-transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143751, NULL, 'G3DSA:3.40.50.10810:FF:000182', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(143752, NULL, 'G3DSA:3.30.160.60:FF:001335', NULL, NULL, 'zinc finger protein 592 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(143753, NULL, 'G3DSA:3.20.140.10:FF:000017', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(143754, NULL, 'G3DSA:3.30.160.60:FF:000846', NULL, NULL, 'Zinc finger protein 624', NULL, NULL, NULL, NULL, NULL, 4),
(143755, NULL, 'G3DSA:2.130.10.10:FF:003016', NULL, NULL, 'U3 small nucleolar RNA-associated protein 15-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(143756, NULL, 'G3DSA:2.60.120.920:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143757, NULL, 'G3DSA:3.40.1810.10:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143758, NULL, 'G3DSA:3.90.1410.10:FF:000073', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(143759, NULL, 'G3DSA:3.30.70.330:FF:000160', NULL, NULL, 'Transformer-2 protein homolog beta', NULL, NULL, NULL, NULL, NULL, 4),
(143760, NULL, 'G3DSA:1.25.40.450:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143761, NULL, 'G3DSA:2.10.220.10:FF:000199', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5a', NULL, NULL, NULL, NULL, NULL, 4),
(143762, NULL, 'G3DSA:3.30.70.270:FF:000001', NULL, NULL, 'Diguanylate cyclase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(143763, NULL, 'G3DSA:1.25.40.540:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143764, NULL, 'G3DSA:2.70.150.10:FF:000269', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(143765, NULL, 'G3DSA:1.10.3210.10:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143766, NULL, 'G3DSA:3.30.160.60:FF:004887', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143767, NULL, 'G3DSA:1.25.10.10:FF:001597', NULL, NULL, 'Karyopherin (Importin) alpha, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143768, NULL, 'G3DSA:3.90.79.10:FF:000049', NULL, NULL, 'Peroxisomal coenzyme A diphosphatase NUDT7', NULL, NULL, NULL, NULL, NULL, 4),
(143769, NULL, 'G3DSA:1.25.10.10:FF:000815', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(143770, NULL, 'G3DSA:1.10.510.10:FF:004524', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143771, NULL, 'G3DSA:3.30.1360.70:FF:000015', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(143772, NULL, 'G3DSA:2.40.10.10:FF:000435', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143773, NULL, 'G3DSA:1.20.5.780:FF:000013', NULL, NULL, 'FXYD domain-containing ion transport regulator', NULL, NULL, NULL, NULL, NULL, 4),
(143774, NULL, 'G3DSA:3.40.50.300:FF:002089', NULL, NULL, 'Adenylate kinase isoenzyme 6 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(143775, NULL, 'G3DSA:1.20.1070.10:FF:001659', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(143776, NULL, 'G3DSA:1.10.10.60:FF:000392', NULL, NULL, 'sigma-54-dependent Fis family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(143777, NULL, 'G3DSA:2.80.10.50:FF:000187', NULL, NULL, 'Mannose receptor C type 2', NULL, NULL, NULL, NULL, NULL, 4),
(143778, NULL, 'G3DSA:2.60.40.10:FF:004522', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143779, NULL, 'G3DSA:3.40.190.10:FF:000038', NULL, NULL, 'Putative glutamate receptor ionotropic NMDA 2B', NULL, NULL, NULL, NULL, NULL, 4),
(143780, NULL, 'G3DSA:1.20.58.390:FF:000227', NULL, NULL, 'Glycine receptor alpha chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143781, NULL, 'G3DSA:3.90.110.10:FF:000011', NULL, NULL, 'L-lactate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(143782, NULL, 'G3DSA:2.70.150.10:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143783, NULL, 'G3DSA:1.10.510.10:FF:000399', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(143784, NULL, 'G3DSA:3.30.160.60:FF:004741', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143785, NULL, 'G3DSA:1.20.1250.20:FF:001429', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143786, NULL, 'G3DSA:3.50.7.10:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143787, NULL, 'G3DSA:2.10.25.10:FF:001162', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(143788, NULL, 'G3DSA:2.60.40.60:FF:000951', NULL, NULL, 'Cad74A isoform A family protein', NULL, NULL, NULL, NULL, NULL, 4),
(143789, NULL, 'G3DSA:1.10.10.10:FF:000961', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(143790, NULL, 'G3DSA:2.60.40.10:FF:003510', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143791, NULL, 'G3DSA:3.30.497.10:FF:000023', NULL, NULL, 'Serpin B6', NULL, NULL, NULL, NULL, NULL, 4),
(143792, NULL, 'G3DSA:1.10.472.10:FF:000034', NULL, NULL, 'D2/4-type cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(143793, NULL, 'G3DSA:2.40.70.10:FF:000118', NULL, NULL, 'Eukaryotic aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(143794, NULL, 'G3DSA:3.30.450.30:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143795, NULL, 'G3DSA:1.10.510.10:FF:000253', NULL, NULL, 'MAP kinase kinase Ste7', NULL, NULL, NULL, NULL, NULL, 4),
(143796, NULL, 'G3DSA:3.30.430.20:FF:000046', NULL, NULL, 'Cysteine-rich repeat secretory protein 55', NULL, NULL, NULL, NULL, NULL, 4),
(143797, NULL, 'G3DSA:3.40.50.300:FF:002409', NULL, NULL, 'Probable GTP-binding protein EngB', NULL, NULL, NULL, NULL, NULL, 4),
(143798, NULL, 'G3DSA:1.10.220.150:FF:000039', NULL, NULL, 'ADP-ribosylation factor GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143799, NULL, 'G3DSA:3.40.50.150:FF:001190', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143800, NULL, 'G3DSA:3.30.710.10:FF:000025', NULL, NULL, 'B-cell lymphoma 6 protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(143801, NULL, 'G3DSA:3.30.40.10:FF:000103', NULL, NULL, 'Inhibitor of growth protein', NULL, NULL, NULL, NULL, NULL, 4),
(143802, NULL, 'G3DSA:3.90.660.10:FF:000041', NULL, NULL, 'Putative polyamine oxidase 5 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(143803, NULL, 'G3DSA:3.30.450.40:FF:000087', NULL, NULL, 'Phosphoserine phosphatase RsbP', NULL, NULL, NULL, NULL, NULL, 4),
(143804, NULL, 'G3DSA:2.10.25.10:FF:001752', NULL, NULL, 'Adhesion G protein-coupled receptor L4', NULL, NULL, NULL, NULL, NULL, 4),
(143805, NULL, 'G3DSA:2.120.10.80:FF:000047', NULL, NULL, 'V(D)J recombination-activating protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(143806, NULL, 'G3DSA:3.10.100.10:FF:000416', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143807, NULL, 'G3DSA:2.30.29.30:FF:000405', NULL, NULL, 'RHO1 GDP-GTP exchange protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(143808, NULL, 'G3DSA:1.10.8.270:FF:000065', NULL, NULL, 'GTPase activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(143809, NULL, 'G3DSA:2.60.40.420:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(143810, NULL, 'G3DSA:3.10.180.10:FF:000106', NULL, NULL, '4-hydroxyphenylpyruvate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(143811, NULL, 'G3DSA:2.40.100.10:FF:000071', NULL, NULL, 'Putative cyclophilin 13', NULL, NULL, NULL, NULL, NULL, 4),
(143812, NULL, 'G3DSA:2.170.40.20:FF:000001', NULL, NULL, 'Envelope glycoprotein gp160', NULL, NULL, NULL, NULL, NULL, 4),
(143813, NULL, 'G3DSA:2.40.70.10:FF:000388', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143814, NULL, 'G3DSA:3.40.50.300:FF:008047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143815, NULL, 'G3DSA:3.60.21.10:FF:000255', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(143816, NULL, 'G3DSA:3.80.10.10:FF:003713', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143817, NULL, 'G3DSA:3.30.70.270:FF:000332', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143818, NULL, 'G3DSA:3.40.140.10:FF:000092', NULL, NULL, 'Cytidine deaminase family enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(143819, NULL, 'G3DSA:3.80.10.10:FF:003893', NULL, NULL, 'Os05g0170300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(143820, NULL, 'G3DSA:3.30.40.10:FF:000249', NULL, NULL, 'E3 ubiquitin-protein ligase RNF216 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(143821, NULL, 'G3DSA:3.10.180.10:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143822, NULL, 'G3DSA:1.10.540.10:FF:000081', NULL, NULL, 'Acyl-CoA dehydrogenase short/branched chain', NULL, NULL, NULL, NULL, NULL, 4),
(143823, NULL, 'G3DSA:2.60.40.10:FF:005511', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143824, NULL, 'G3DSA:2.30.29.30:FF:001333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143825, NULL, 'G3DSA:1.20.1250.20:FF:002042', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(143826, NULL, 'G3DSA:3.30.870.10:FF:000183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143827, NULL, 'G3DSA:1.25.40.20:FF:000972', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143828, NULL, 'G3DSA:2.30.30.30:FF:000145', NULL, NULL, 'Eukaryotic translation initiation factor 5A', NULL, NULL, NULL, NULL, NULL, 4),
(143829, NULL, 'G3DSA:3.40.640.10:FF:000236', NULL, NULL, 'Alanine aminotransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(143830, NULL, 'G3DSA:3.30.420.40:FF:000259', NULL, NULL, 'Actin-like protein arp-6', NULL, NULL, NULL, NULL, NULL, 4),
(143831, NULL, 'G3DSA:2.60.40.10:FF:001240', NULL, NULL, 'Sialic acid binding Ig-like lectin E', NULL, NULL, NULL, NULL, NULL, 4),
(143832, NULL, 'G3DSA:3.30.70.330:FF:002082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143833, NULL, 'G3DSA:2.130.10.10:FF:003342', NULL, NULL, 'Myosin heavy chain kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(143834, NULL, 'G3DSA:3.40.640.10:FF:000383', NULL, NULL, 'Aspartate aminotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143835, NULL, 'G3DSA:3.40.50.300:FF:006395', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143836, NULL, 'G3DSA:1.20.58.60:FF:000107', NULL, NULL, 'Short stop, isoform K', NULL, NULL, NULL, NULL, NULL, 4),
(143837, NULL, 'G3DSA:1.20.1420.30:FF:000080', NULL, NULL, 'Ca(2+)/H(+) antiporter', NULL, NULL, NULL, NULL, NULL, 4),
(143838, NULL, 'G3DSA:3.40.50.620:FF:000009', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(143839, NULL, 'G3DSA:1.10.10.10:FF:000635', NULL, NULL, 'Frv operon regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(143840, NULL, 'G3DSA:2.10.25.160:FF:000003', NULL, NULL, 'Progranulin', NULL, NULL, NULL, NULL, NULL, 4),
(143841, NULL, 'G3DSA:3.30.200.20:FF:002417', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143842, NULL, 'G3DSA:3.40.50.12650:FF:000008', NULL, NULL, 'DNA cross-link repair protein pso2/snm1', NULL, NULL, NULL, NULL, NULL, 4),
(143843, NULL, 'G3DSA:3.40.630.30:FF:000596', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(143844, NULL, 'G3DSA:3.40.50.1820:FF:000211', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(143845, NULL, 'G3DSA:3.40.50.1970:FF:000031', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(143846, NULL, 'G3DSA:3.40.50.920:FF:000004', NULL, NULL, '2-oxoisovalerate dehydrogenase subunit beta 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(143847, NULL, 'G3DSA:3.30.70.330:FF:000283', NULL, NULL, 'U2 snRNP auxiliary factor large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(143848, NULL, 'G3DSA:1.10.10.10:FF:000871', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(143849, NULL, 'G3DSA:1.25.10.10:FF:000495', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143850, NULL, 'G3DSA:1.20.930.80:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143851, NULL, 'G3DSA:3.40.50.1980:FF:000034', NULL, NULL, 'Ferric enterobactin transporter binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(143852, NULL, 'G3DSA:3.30.40.10:FF:001407', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143853, NULL, 'G3DSA:3.30.559.30:FF:000044', NULL, NULL, 'Nonribosomal peptide synthetase 7', NULL, NULL, NULL, NULL, NULL, 4),
(143854, NULL, 'G3DSA:2.40.37.10:FF:000007', NULL, NULL, 'Diaminopimelate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(143855, NULL, 'G3DSA:1.10.510.10:FF:003035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143856, NULL, 'G3DSA:1.10.238.10:FF:000299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143857, NULL, 'G3DSA:1.20.5.190:FF:000050', NULL, NULL, 'Myosin VIIb', NULL, NULL, NULL, NULL, NULL, 4),
(143858, NULL, 'G3DSA:2.20.20.110:FF:000011', NULL, NULL, 'DNA repair protein rhp41', NULL, NULL, NULL, NULL, NULL, 4),
(143859, NULL, 'G3DSA:1.10.455.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143860, NULL, 'G3DSA:3.30.40.10:FF:000305', NULL, NULL, 'RING finger protein 112', NULL, NULL, NULL, NULL, NULL, 4),
(143861, NULL, 'G3DSA:3.30.160.60:FF:004915', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143862, NULL, 'G3DSA:1.20.1070.10:FF:001805', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143863, NULL, 'G3DSA:1.25.40.20:FF:001045', NULL, NULL, 'Protein ACCELERATED CELL DEATH 6', NULL, NULL, NULL, NULL, NULL, 4),
(143864, NULL, 'G3DSA:2.130.10.130:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143865, NULL, 'G3DSA:1.20.120.980:FF:000038', NULL, NULL, 'AGAP003641-PA', NULL, NULL, NULL, NULL, NULL, 4),
(143866, NULL, 'G3DSA:3.40.50.1820:FF:001644', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(143867, NULL, 'G3DSA:1.20.1070.10:FF:000226', NULL, NULL, 'Probable G-protein coupled receptor 152', NULL, NULL, NULL, NULL, NULL, 4),
(143868, NULL, 'G3DSA:3.30.160.60:FF:006181', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143869, NULL, 'G3DSA:3.40.50.2060:FF:000019', NULL, NULL, 'Putative syntaxin binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(143870, NULL, 'G3DSA:2.30.30.550:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143871, NULL, 'G3DSA:1.20.120.1080:FF:000087', NULL, NULL, 'Nucleic acid helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143872, NULL, 'G3DSA:1.25.10.10:FF:003305', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(143873, NULL, 'G3DSA:1.20.1050.130:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143874, NULL, 'G3DSA:1.20.120.560:FF:000002', NULL, NULL, 'programmed cell death 6-interacting protein-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(143875, NULL, 'G3DSA:3.20.20.100:FF:000116', NULL, NULL, 'Aldehyde reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143876, NULL, 'G3DSA:3.10.350.10:FF:000081', NULL, NULL, 'Cell wall hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(143877, NULL, 'G3DSA:2.20.70.10:FF:000254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(143878, NULL, 'G3DSA:1.20.1390.10:FF:000008', NULL, NULL, 'RNA Binding Motif protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(143879, NULL, 'G3DSA:2.20.70.10:FF:000052', NULL, NULL, 'pre-mRNA-processing factor 40 homolog B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(143880, NULL, 'G3DSA:3.10.20.90:FF:000475', NULL, NULL, 'Midnolin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(143881, NULL, 'G3DSA:3.30.470.140:FF:000001', NULL, NULL, 'mRNA-capping enzyme catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(143882, NULL, 'G3DSA:3.30.30.30:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143883, NULL, 'G3DSA:3.40.50.300:FF:001307', NULL, NULL, 'Primosomal protein N''', NULL, NULL, NULL, NULL, NULL, 4),
(143884, NULL, 'G3DSA:3.40.630.10:FF:000348', NULL, NULL, 'Glutamate carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143885, NULL, 'G3DSA:1.10.10.60:FF:001206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143886, NULL, 'G3DSA:1.20.1070.10:FF:002025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143887, NULL, 'G3DSA:1.25.40.10:FF:004712', NULL, NULL, 'AGAP012369-PA', NULL, NULL, NULL, NULL, NULL, 4),
(143888, NULL, 'G3DSA:2.60.40.10:FF:004612', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143889, NULL, 'G3DSA:3.40.1110.10:FF:000376', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143890, NULL, 'G3DSA:3.30.70.20:FF:000136', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143891, NULL, 'G3DSA:2.30.40.10:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143892, NULL, 'G3DSA:3.40.50.300:FF:006248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143893, NULL, 'G3DSA:3.30.505.10:FF:000094', NULL, NULL, 'Cytokine-inducible SH2-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(143894, NULL, 'G3DSA:1.10.287.110:FF:000437', NULL, NULL, 'Chaperone protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143895, NULL, 'G3DSA:3.10.20.90:FF:000565', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(143896, NULL, 'G3DSA:2.30.29.30:FF:000400', NULL, NULL, 'docking protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(143897, NULL, 'G3DSA:4.10.60.10:FF:000137', NULL, NULL, 'Zinc knuckle domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(143898, NULL, 'G3DSA:2.60.40.150:FF:000248', NULL, NULL, 'U5 small nuclear ribonucleoprotein helicase', NULL, NULL, NULL, NULL, NULL, 4),
(143899, NULL, 'G3DSA:2.60.40.10:FF:002870', NULL, NULL, 'Mast/stem cell growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(143900, NULL, 'G3DSA:3.90.70.10:FF:000294', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(143901, NULL, 'G3DSA:3.10.450.40:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143902, NULL, 'G3DSA:1.10.357.110:FF:000010', NULL, NULL, 'Vps53-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(143903, NULL, 'G3DSA:2.60.40.10:FF:005596', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143904, NULL, 'G3DSA:1.25.40.10:FF:004914', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143905, NULL, 'G3DSA:3.40.50.150:FF:000554', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(143906, NULL, 'G3DSA:2.30.30.40:FF:000333', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(143907, NULL, 'G3DSA:1.25.40.10:FF:000643', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(143908, NULL, 'G3DSA:1.20.272.10:FF:000090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143909, NULL, 'G3DSA:3.40.50.1380:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143910, NULL, 'G3DSA:3.40.390.10:FF:000312', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143911, NULL, 'G3DSA:3.10.450.50:FF:000044', NULL, NULL, 'UBA/TS-N domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(143912, NULL, 'G3DSA:3.40.50.1000:FF:000645', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(143913, NULL, 'G3DSA:3.30.60.20:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143914, NULL, 'G3DSA:3.40.50.1370:FF:000031', NULL, NULL, 'Aspartate carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(143915, NULL, 'G3DSA:1.25.40.20:FF:000646', NULL, NULL, 'SH3 and multiple ankyrin repeat domains 2', NULL, NULL, NULL, NULL, NULL, 4),
(143916, NULL, 'G3DSA:1.10.510.10:FF:002669', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143917, NULL, 'G3DSA:3.60.140.10:FF:000020', NULL, NULL, 'Polyphenol oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(143918, NULL, 'G3DSA:2.20.100.10:FF:000114', NULL, NULL, 'Unc-5, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(143919, NULL, 'G3DSA:1.20.140.40:FF:000023', NULL, NULL, 'Pectinesterase inhibitor 9', NULL, NULL, NULL, NULL, NULL, 4),
(143920, NULL, 'G3DSA:2.60.40.10:FF:002667', NULL, NULL, 'Protein-tyrosine-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(143921, NULL, 'G3DSA:2.60.120.970:FF:000065', NULL, NULL, 'Southpaw', NULL, NULL, NULL, NULL, NULL, 4),
(143922, NULL, 'G3DSA:2.30.42.10:FF:000363', NULL, NULL, 'Periplasmic serine endoprotease DegP-like', NULL, NULL, NULL, NULL, NULL, 4),
(143923, NULL, 'G3DSA:3.80.20.20:FF:000018', NULL, NULL, 'Insulin-like receptor', NULL, NULL, NULL, NULL, NULL, 4),
(143924, NULL, 'G3DSA:3.80.10.10:FF:001145', NULL, NULL, 'Leucine-rich repeat and sterile alpha motif-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(143925, NULL, 'G3DSA:2.10.50.30:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143926, NULL, 'G3DSA:3.80.10.10:FF:003567', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143927, NULL, 'G3DSA:1.10.238.10:FF:000945', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143928, NULL, 'G3DSA:3.30.470.160:FF:000007', NULL, NULL, 'Histone deacetylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(143929, NULL, 'G3DSA:3.30.60.30:FF:000167', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(143930, NULL, 'G3DSA:2.40.50.140:FF:000145', NULL, NULL, '30S ribosomal protein S28e', NULL, NULL, NULL, NULL, NULL, 4),
(143931, NULL, 'G3DSA:1.25.40.10:FF:001132', NULL, NULL, 'Os03g0168550 protein', NULL, NULL, NULL, NULL, NULL, 4),
(143932, NULL, 'G3DSA:1.10.510.10:FF:002872', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143933, NULL, 'G3DSA:3.30.160.60:FF:000902', NULL, NULL, 'Zinc finger protein 445', NULL, NULL, NULL, NULL, NULL, 4),
(143934, NULL, 'G3DSA:2.70.40.10:FF:000019', NULL, NULL, 'Deoxyuridine 5''-triphosphate nucleotidohydrolase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(143935, NULL, 'G3DSA:3.30.70.330:FF:002430', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143936, NULL, 'G3DSA:1.25.40.20:FF:001135', NULL, NULL, 'Ankyrin_repeats_(Many_copies)/Ankyrin_repeats_(3_ copies)/Zinc_finger_-_C3HC4_type_(RING_finger )_containing_protein_-_putativ', NULL, NULL, NULL, NULL, NULL, 4),
(143937, NULL, 'G3DSA:3.40.50.300:FF:006743', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143938, NULL, 'G3DSA:2.130.10.10:FF:001982', NULL, NULL, 'RBBP4 isoform 19', NULL, NULL, NULL, NULL, NULL, 4),
(143939, NULL, 'G3DSA:2.170.270.10:FF:000029', NULL, NULL, 'Histone-lysine N-methyltransferase SETDB2', NULL, NULL, NULL, NULL, NULL, 4),
(143940, NULL, 'G3DSA:2.60.450.20:FF:000016', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(143941, NULL, 'G3DSA:3.30.750.24:FF:000064', NULL, NULL, 'Sulfate permease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(143942, NULL, 'G3DSA:3.30.420.40:FF:000169', NULL, NULL, 'Actin 3', NULL, NULL, NULL, NULL, NULL, 4),
(143943, NULL, 'G3DSA:2.60.450.10:FF:000013', NULL, NULL, 'LPS-assembly protein LptD', NULL, NULL, NULL, NULL, NULL, 4),
(143944, NULL, 'G3DSA:3.40.50.1000:FF:000117', NULL, NULL, 'Cytosolic purine 5-nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(143945, NULL, 'G3DSA:1.10.10.10:FF:000545', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(143946, NULL, 'G3DSA:2.130.10.10:FF:001217', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(143947, NULL, 'G3DSA:1.10.510.10:FF:003361', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143948, NULL, 'G3DSA:2.60.40.1120:FF:000003', NULL, NULL, 'Outer membrane protein Omp121', NULL, NULL, NULL, NULL, NULL, 4),
(143949, NULL, 'G3DSA:1.10.238.10:FF:000327', NULL, NULL, 'Calmodulin-like protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(143950, NULL, 'G3DSA:2.40.50.40:FF:000103', NULL, NULL, 'Chemokine (C-X-C motif) ligand 18b', NULL, NULL, NULL, NULL, NULL, 4),
(143951, NULL, 'G3DSA:1.10.287.380:FF:000001', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(143952, NULL, 'G3DSA:3.90.1750.10:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143953, NULL, 'G3DSA:3.80.10.10:FF:003623', NULL, NULL, 'Leucine rich repeat containing G protein-coupled receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(143954, NULL, 'G3DSA:2.40.50.40:FF:000047', NULL, NULL, 'Chromator, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(143955, NULL, 'G3DSA:3.10.490.10:FF:000057', NULL, NULL, 'Glutathione-specific gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(143956, NULL, 'G3DSA:3.30.479.30:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143957, NULL, 'G3DSA:1.10.260.40:FF:000051', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(143958, NULL, 'G3DSA:1.10.1650.10:FF:000003', NULL, NULL, '50S ribosomal protein L19e', NULL, NULL, NULL, NULL, NULL, 4),
(143959, NULL, 'G3DSA:2.40.50.140:FF:000055', NULL, NULL, 'Cold shock domain containing E1, RNA-binding', NULL, NULL, NULL, NULL, NULL, 4),
(143960, NULL, 'G3DSA:3.30.559.10:FF:000066', NULL, NULL, 'Nonribosomal peptide synthetase 7', NULL, NULL, NULL, NULL, NULL, 4),
(143961, NULL, 'G3DSA:1.10.238.10:FF:001311', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143962, NULL, 'G3DSA:1.20.1250.20:FF:000035', NULL, NULL, 'Dipeptide permease D', NULL, NULL, NULL, NULL, NULL, 4),
(143963, NULL, 'G3DSA:3.30.250.20:FF:000004', NULL, NULL, 'L1 transposable element', NULL, NULL, NULL, NULL, NULL, 4),
(143964, NULL, 'G3DSA:1.10.510.10:FF:002725', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143965, NULL, 'G3DSA:3.40.309.10:FF:000091', NULL, NULL, 'Aldehyde dehydrogenase 4 family member A1', NULL, NULL, NULL, NULL, NULL, 4),
(143966, NULL, 'G3DSA:2.40.160.10:FF:000046', NULL, NULL, 'Probable porin', NULL, NULL, NULL, NULL, NULL, 4),
(143967, NULL, 'G3DSA:3.30.500.10:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143968, NULL, 'G3DSA:1.10.287.70:FF:000306', NULL, NULL, 'potassium channel subfamily K member 5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(143969, NULL, 'G3DSA:1.10.1300.10:FF:000011', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(143970, NULL, 'G3DSA:3.40.33.10:FF:000199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143971, NULL, 'G3DSA:3.40.50.10810:FF:000187', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(143972, NULL, 'G3DSA:3.30.430.20:FF:000041', NULL, NULL, 'Putative cysteine-rich receptor-like protein kinase 9', NULL, NULL, NULL, NULL, NULL, 4),
(143973, NULL, 'G3DSA:3.40.525.10:FF:000042', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(143974, NULL, 'G3DSA:2.60.40.10:FF:002723', NULL, NULL, 'Protein CBR-UNC-22', NULL, NULL, NULL, NULL, NULL, 4),
(143975, NULL, 'G3DSA:1.10.510.10:FF:002377', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143976, NULL, 'G3DSA:3.30.420.40:FF:001102', NULL, NULL, 'Protein CBG00489', NULL, NULL, NULL, NULL, NULL, 4),
(143977, NULL, 'G3DSA:2.40.50.140:FF:000706', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143978, NULL, 'G3DSA:3.30.160.60:FF:003252', NULL, NULL, 'Si:dkeyp-82b4.6', NULL, NULL, NULL, NULL, NULL, 4),
(143979, NULL, 'G3DSA:3.30.250.10:FF:000001', NULL, NULL, 'Protein RecA', NULL, NULL, NULL, NULL, NULL, 4),
(143980, NULL, 'G3DSA:1.10.1420.10:FF:000048', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(143981, NULL, 'G3DSA:2.40.30.10:FF:000144', NULL, NULL, 'Eukaryotic release factor 3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143982, NULL, 'G3DSA:3.10.105.10:FF:000085', NULL, NULL, 'Oligopeptide transport system binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(143983, NULL, 'G3DSA:1.20.58.60:FF:000731', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143984, NULL, 'G3DSA:2.130.10.10:FF:002847', NULL, NULL, 'Ribosome assembly protein RRB1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(143985, NULL, 'G3DSA:3.40.50.1000:FF:000084', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(143986, NULL, 'G3DSA:1.25.40.20:FF:000702', NULL, NULL, 'Putative ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(143987, NULL, 'G3DSA:1.25.10.10:FF:001889', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(143988, NULL, 'G3DSA:2.60.120.260:FF:000088', NULL, NULL, 'Beta-galactosidase A', NULL, NULL, NULL, NULL, NULL, 4),
(143989, NULL, 'G3DSA:3.40.50.10330:FF:000077', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(143990, NULL, 'G3DSA:1.20.5.780:FF:000018', NULL, NULL, 'FXYD domain-containing ion transport regulator', NULL, NULL, NULL, NULL, NULL, 4),
(143991, NULL, 'G3DSA:1.20.58.60:FF:000080', NULL, NULL, 'Spectrin alpha chain, non-erythrocytic 1', NULL, NULL, NULL, NULL, NULL, 4),
(143992, NULL, 'G3DSA:2.30.30.40:FF:000474', NULL, NULL, 'SLIT-ROBO Rho GTPase-activating protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(143993, NULL, 'G3DSA:3.30.230.70:FF:000091', NULL, NULL, 'Exosome complex component RRP45B', NULL, NULL, NULL, NULL, NULL, 4),
(143994, NULL, 'G3DSA:2.40.70.10:FF:000444', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143995, NULL, 'G3DSA:2.60.40.10:FF:004494', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(143996, NULL, 'G3DSA:3.10.450.240:FF:000009', NULL, NULL, 'Protein MBA1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(143997, NULL, 'G3DSA:3.30.1380.20:FF:000024', NULL, NULL, 'Trafficking protein particle complex 5', NULL, NULL, NULL, NULL, NULL, 4),
(143998, NULL, 'G3DSA:3.10.450.220:FF:000003', NULL, NULL, '60S ribosome subunit biogenesis protein NIP7 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(143999, NULL, 'G3DSA:3.40.50.300:FF:004450', NULL, NULL, 'Helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(144000, NULL, 'G3DSA:3.40.630.10:FF:000438', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144001, NULL, 'G3DSA:2.40.70.10:FF:000534', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144002, NULL, 'G3DSA:1.25.10.10:FF:001799', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(144003, NULL, 'G3DSA:2.70.150.10:FF:000185', NULL, NULL, 'Cation transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(144004, NULL, 'G3DSA:1.10.1670.10:FF:000033', NULL, NULL, 'Endonuclease III homolog', NULL, NULL, NULL, NULL, NULL, 4),
(144005, NULL, 'G3DSA:1.20.58.70:FF:000083', NULL, NULL, 't-SNARE', NULL, NULL, NULL, NULL, NULL, 4),
(144006, NULL, 'G3DSA:1.20.58.60:FF:000170', NULL, NULL, 'Dystrophin', NULL, NULL, NULL, NULL, NULL, 4),
(144007, NULL, 'G3DSA:2.70.150.10:FF:000095', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(144008, NULL, 'G3DSA:3.80.10.10:FF:000217', NULL, NULL, 'fibromodulin', NULL, NULL, NULL, NULL, NULL, 4),
(144009, NULL, 'G3DSA:1.20.5.190:FF:000078', NULL, NULL, 'Abnormal spindle microtubule assembly', NULL, NULL, NULL, NULL, NULL, 4),
(144010, NULL, 'G3DSA:3.40.50.11670:FF:000001', NULL, NULL, 'DNA replication regulator family protein', NULL, NULL, NULL, NULL, NULL, 4),
(144011, NULL, 'G3DSA:1.20.1070.10:FF:001715', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144012, NULL, 'G3DSA:1.20.5.170:FF:000072', NULL, NULL, 'Putative chromatin structure-remodeling complex subunit snf21', NULL, NULL, NULL, NULL, NULL, 4),
(144013, NULL, 'G3DSA:3.20.20.100:FF:000206', NULL, NULL, 'Os05g0456200 protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(144014, NULL, 'G3DSA:1.25.40.10:FF:000019', NULL, NULL, 'UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase 110 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(144015, NULL, 'G3DSA:3.40.50.1820:FF:000065', NULL, NULL, 'Phospholipase A1-II 3', NULL, NULL, NULL, NULL, NULL, 4),
(144016, NULL, 'G3DSA:2.60.40.10:FF:002049', NULL, NULL, 'Mesocentin', NULL, NULL, NULL, NULL, NULL, 4),
(144017, NULL, 'G3DSA:3.30.2350.10:FF:000014', NULL, NULL, 'PUS4p Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(144018, NULL, 'G3DSA:3.30.450.40:FF:000289', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(144019, NULL, 'G3DSA:3.30.230.10:FF:000415', NULL, NULL, 'DNA mismatch repair protein pms1', NULL, NULL, NULL, NULL, NULL, 4),
(144020, NULL, 'G3DSA:1.20.58.80:FF:000086', NULL, NULL, 'Protein CBR-XPC-1', NULL, NULL, NULL, NULL, NULL, 4),
(144021, NULL, 'G3DSA:3.40.30.10:FF:001007', NULL, NULL, 'Glutaredoxin NrdH', NULL, NULL, NULL, NULL, NULL, 4),
(144022, NULL, 'G3DSA:2.30.42.10:FF:000273', NULL, NULL, 'Par-3 family cell polarity regulator', NULL, NULL, NULL, NULL, NULL, 4),
(144023, NULL, 'G3DSA:3.40.50.1820:FF:000155', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(144024, NULL, 'G3DSA:2.40.160.210:FF:000018', NULL, NULL, 'Acyl-CoA thioesterase (AFU_orthologue AFUA_1G12060)', NULL, NULL, NULL, NULL, NULL, 4),
(144025, NULL, 'G3DSA:2.130.10.10:FF:005579', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(144026, NULL, 'G3DSA:1.20.5.340:FF:000089', NULL, NULL, 'Myosin-2 heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(144027, NULL, 'G3DSA:1.20.1250.20:FF:000125', NULL, NULL, 'Sugar efflux transporter SetB', NULL, NULL, NULL, NULL, NULL, 4),
(144028, NULL, 'G3DSA:2.30.180.10:FF:000128', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144029, NULL, 'G3DSA:3.90.25.10:FF:000043', NULL, NULL, 'Tissue-specific transplantation antigen P35B', NULL, NULL, NULL, NULL, NULL, 4),
(144030, NULL, 'G3DSA:2.30.130.40:FF:000016', NULL, NULL, 'ATP-dependent protease La (LON) domain-containing protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(144031, NULL, 'G3DSA:3.90.79.10:FF:000252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144032, NULL, 'G3DSA:3.40.50.150:FF:001425', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144033, NULL, 'G3DSA:2.40.10.10:FF:000289', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144034, NULL, 'G3DSA:2.40.50.140:FF:000673', NULL, NULL, 'Replication protein A, subunit RPA32', NULL, NULL, NULL, NULL, NULL, 4),
(144035, NULL, 'G3DSA:3.40.50.720:FF:001967', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144036, NULL, 'G3DSA:3.40.50.300:FF:003432', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(144037, NULL, 'G3DSA:2.60.40.150:FF:000776', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144038, NULL, 'G3DSA:1.25.10.10:FF:002288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144039, NULL, 'G3DSA:3.40.449.10:FF:000005', NULL, NULL, 'Phosphoenolpyruvate carboxykinase [GTP]', NULL, NULL, NULL, NULL, NULL, 4),
(144040, NULL, 'G3DSA:3.40.50.1980:FF:000124', NULL, NULL, 'Iron(III) dicitrate-binding periplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(144041, NULL, 'G3DSA:4.10.410.10:FF:000099', NULL, NULL, 'Collagen type XXVIII alpha 1 chain', NULL, NULL, NULL, NULL, NULL, 4),
(144042, NULL, 'G3DSA:3.30.70.2510:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144043, NULL, 'G3DSA:3.10.100.10:FF:000242', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144044, NULL, 'G3DSA:2.60.40.10:FF:003033', NULL, NULL, 'Carcinoembryonic antigen-related cell adhesion molecule', NULL, NULL, NULL, NULL, NULL, 4),
(144045, NULL, 'G3DSA:1.10.8.10:FF:000269', NULL, NULL, 'Unc-23', NULL, NULL, NULL, NULL, NULL, 4),
(144046, NULL, 'G3DSA:1.10.506.10:FF:000029', NULL, NULL, 'probable Ras GTPase-activating protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(144047, NULL, 'G3DSA:3.30.70.330:FF:001587', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144048, NULL, 'G3DSA:3.30.870.10:FF:000093', NULL, NULL, 'Phospholipase D C', NULL, NULL, NULL, NULL, NULL, 4),
(144049, NULL, 'G3DSA:1.50.10.20:FF:000136', NULL, NULL, 'Dammarenediol II synthase', NULL, NULL, NULL, NULL, NULL, 4),
(144050, NULL, 'G3DSA:3.30.160.60:FF:004556', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144051, NULL, 'G3DSA:3.30.428.10:FF:000004', NULL, NULL, 'aprataxin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(144052, NULL, 'G3DSA:1.10.1040.10:FF:000030', NULL, NULL, 'Ketol-acid reductoisomerase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(144053, NULL, 'G3DSA:2.130.10.10:FF:004562', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144054, NULL, 'G3DSA:2.60.40.1180:FF:000178', NULL, NULL, 'O-GlcNAcase BT_4395', NULL, NULL, NULL, NULL, NULL, 4),
(144055, NULL, 'G3DSA:3.30.830.10:FF:000113', NULL, NULL, 'Peptidase, insulinase family', NULL, NULL, NULL, NULL, NULL, 4),
(144056, NULL, 'G3DSA:3.50.50.100:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144057, NULL, 'G3DSA:3.30.310.50:FF:000018', NULL, NULL, 'Phosphoglucomutase/phosphomannomutase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(144058, NULL, 'G3DSA:1.10.287.1770:FF:000003', NULL, NULL, 'Ferrous iron transport protein B', NULL, NULL, NULL, NULL, NULL, 4),
(144059, NULL, 'G3DSA:2.60.40.60:FF:000804', NULL, NULL, 'Si:ch211-186j3.6', NULL, NULL, NULL, NULL, NULL, 4),
(144060, NULL, 'G3DSA:1.20.1070.10:FF:001154', NULL, NULL, 'C-X-C chemokine receptor type 1', NULL, NULL, NULL, NULL, NULL, 4),
(144061, NULL, 'G3DSA:3.30.390.50:FF:000034', NULL, NULL, 'AGAP006221-PA', NULL, NULL, NULL, NULL, NULL, 4),
(144062, NULL, 'G3DSA:3.30.830.10:FF:000057', NULL, NULL, 'Pitrilysin-like metalloprotease', NULL, NULL, NULL, NULL, NULL, 4),
(144063, NULL, 'G3DSA:3.40.190.10:FF:000600', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144064, NULL, 'G3DSA:1.10.10.60:FF:000419', NULL, NULL, 'Homeobox protein Hox-D4', NULL, NULL, NULL, NULL, NULL, 4),
(144065, NULL, 'G3DSA:3.90.180.10:FF:000015', NULL, NULL, 'Fatty acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(144066, NULL, 'G3DSA:1.20.58.1040:FF:000022', NULL, NULL, '1,3-beta-glucanosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(144067, NULL, 'G3DSA:1.20.81.30:FF:000001', NULL, NULL, 'Type II secretion system protein F', NULL, NULL, NULL, NULL, NULL, 4),
(144068, NULL, 'G3DSA:2.60.40.790:FF:000086', NULL, NULL, 'CG9617', NULL, NULL, NULL, NULL, NULL, 4),
(144069, NULL, 'G3DSA:2.30.29.30:FF:000113', NULL, NULL, 'FYVE, RhoGEF and PH domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(144070, NULL, 'G3DSA:3.40.366.10:FF:000003', NULL, NULL, 'Fatty acid synthase subunit beta dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(144071, NULL, 'G3DSA:1.25.40.10:FF:004353', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(144072, NULL, 'G3DSA:3.30.160.60:FF:006208', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144073, NULL, 'G3DSA:3.30.43.10:FF:000020', NULL, NULL, 'FAD-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(144074, NULL, 'G3DSA:3.40.50.1240:FF:000133', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144075, NULL, 'G3DSA:1.25.40.20:FF:000556', NULL, NULL, 'Protein fem-1 homolog CG6966', NULL, NULL, NULL, NULL, NULL, 4),
(144076, NULL, 'G3DSA:1.20.1560.10:FF:000224', NULL, NULL, 'ABC transporter ABCC.6, putative', NULL, NULL, NULL, NULL, NULL, 4),
(144077, NULL, 'G3DSA:1.20.1070.10:FF:000052', NULL, NULL, 'Adhesion G-protein coupled receptor G6', NULL, NULL, NULL, NULL, NULL, 4),
(144078, NULL, 'G3DSA:2.120.10.30:FF:000055', NULL, NULL, 'Protein STRICTOSIDINE SYNTHASE-LIKE 11', NULL, NULL, NULL, NULL, NULL, 4),
(144079, NULL, 'G3DSA:1.20.120.910:FF:000006', NULL, NULL, 'Conjugal transfer protein TraR', NULL, NULL, NULL, NULL, NULL, 4),
(144080, NULL, 'G3DSA:3.40.50.1000:FF:000443', NULL, NULL, 'Trehalose 6-phosphate phosphatase RA3', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(144081, NULL, 'G3DSA:1.50.10.130:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144082, NULL, 'G3DSA:1.10.357.50:FF:000003', NULL, NULL, 'Exocyst complex component SEC6', NULL, NULL, NULL, NULL, NULL, 4),
(144083, NULL, 'G3DSA:1.25.40.10:FF:000553', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(144084, NULL, 'G3DSA:3.30.310.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144085, NULL, 'G3DSA:3.40.50.670:FF:000002', NULL, NULL, 'DNA gyrase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(144086, NULL, 'G3DSA:3.30.740.10:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144087, NULL, 'G3DSA:1.20.1110.10:FF:000197', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144088, NULL, 'G3DSA:1.25.40.10:FF:002262', NULL, NULL, 'TPR repeat-containing protein ZIP4', NULL, NULL, NULL, NULL, NULL, 4),
(144089, NULL, 'G3DSA:3.90.1150.10:FF:000322', NULL, NULL, 'Serine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(144090, NULL, 'G3DSA:3.30.70.370:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144091, NULL, 'G3DSA:3.90.105.10:FF:000027', NULL, NULL, 'Molybdenum cofactor biosynthesis protein MoeA2', NULL, NULL, NULL, NULL, NULL, 4),
(144092, NULL, 'G3DSA:3.40.50.2000:FF:000226', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(144093, NULL, 'G3DSA:3.40.50.150:FF:001858', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144094, NULL, 'G3DSA:3.30.40.10:FF:000721', NULL, NULL, 'Os12g0527800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(144095, NULL, 'G3DSA:1.25.10.10:FF:000669', NULL, NULL, 'Armadillo repeat-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(144096, NULL, 'G3DSA:2.60.40.10:FF:006091', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144097, NULL, 'G3DSA:2.30.42.10:FF:000037', NULL, NULL, 'Periplasmic serine endoprotease DegP-like', NULL, NULL, NULL, NULL, NULL, 4),
(144098, NULL, 'G3DSA:3.10.290.70:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144099, NULL, 'G3DSA:1.20.5.30:FF:000004', NULL, NULL, 'Matrilin 3', NULL, NULL, NULL, NULL, NULL, 4),
(144100, NULL, 'G3DSA:1.20.120.900:FF:000003', NULL, NULL, 'Peroxisomal membrane protein import receptor PEX19', NULL, NULL, NULL, NULL, NULL, 4),
(144101, NULL, 'G3DSA:2.70.170.10:FF:000304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144102, NULL, 'G3DSA:3.40.50.300:FF:002179', NULL, NULL, 'ATP-dependent DNA helicase Q1', NULL, NULL, NULL, NULL, NULL, 4),
(144103, NULL, 'G3DSA:1.10.1030.10:FF:000001', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(144104, NULL, 'G3DSA:3.20.20.70:FF:000295', NULL, NULL, 'Deoxyribose-phosphate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(144105, NULL, 'G3DSA:3.80.10.10:FF:003477', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(144106, NULL, 'G3DSA:1.25.10.10:FF:003221', NULL, NULL, 'Protein zyg-11 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(144107, NULL, 'G3DSA:3.30.420.80:FF:000007', NULL, NULL, '30S ribosomal protein S11', NULL, NULL, NULL, NULL, NULL, 4),
(144108, NULL, 'G3DSA:2.60.40.150:FF:000158', NULL, NULL, 'extended synaptotagmin-2 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(144109, NULL, 'G3DSA:3.30.70.330:FF:000805', NULL, NULL, 'Flowering time control protein FPA', NULL, NULL, NULL, NULL, NULL, 4),
(144110, NULL, 'G3DSA:1.10.10.10:FF:001124', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(144111, NULL, 'G3DSA:3.40.366.10:FF:000060', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(144112, NULL, 'G3DSA:3.50.4.10:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144113, NULL, 'G3DSA:3.10.50.10:FF:000026', NULL, NULL, 'AGAP005337-PA', NULL, NULL, NULL, NULL, NULL, 4),
(144114, NULL, 'G3DSA:1.20.1060.10:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(144115, NULL, 'G3DSA:2.60.120.200:FF:000300', NULL, NULL, 'Terribly reduced optic lobes, isoform B', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(144116, NULL, 'G3DSA:1.25.40.10:FF:000025', NULL, NULL, 'Unc-45 myosin chaperone B', NULL, NULL, NULL, NULL, NULL, 4),
(144117, NULL, 'G3DSA:1.20.120.1380:FF:000002', NULL, NULL, 'Flagellar biosynthesis regulator FlhF', NULL, NULL, NULL, NULL, NULL, 4),
(144118, NULL, 'G3DSA:1.10.287.110:FF:000263', NULL, NULL, 'Chaperone DnaJ-domain superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(144119, NULL, 'G3DSA:3.30.450.20:FF:000603', NULL, NULL, 'voltage-dependent calcium channel subunit alpha-2/delta-1', NULL, NULL, NULL, NULL, NULL, 4),
(144120, NULL, 'G3DSA:1.20.1060.20:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144121, NULL, 'G3DSA:3.40.50.2300:FF:000198', NULL, NULL, 'D-allose-binding periplasmic protein (ALBP)', NULL, NULL, NULL, NULL, NULL, 4),
(144122, NULL, 'G3DSA:1.25.40.10:FF:000497', NULL, NULL, 'Tetratricopeptide repeat domain 37', NULL, NULL, NULL, NULL, NULL, 4),
(144123, NULL, 'G3DSA:3.30.70.330:FF:001593', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144124, NULL, 'G3DSA:2.130.10.10:FF:005809', NULL, NULL, 'Intraflagellar transport protein 140 homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(144125, NULL, 'G3DSA:2.60.40.10:FF:002493', NULL, NULL, 'T cell receptor alpha variable 29/delta variable 5 (gene/pseudogene)', NULL, NULL, NULL, NULL, NULL, 4),
(144126, NULL, 'G3DSA:1.20.5.20:FF:000001', NULL, NULL, 'apolipoprotein A-I', NULL, NULL, NULL, NULL, NULL, 4),
(144127, NULL, 'G3DSA:1.10.533.10:FF:000199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144128, NULL, 'G3DSA:1.10.274.100:FF:000014', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(144129, NULL, 'G3DSA:2.130.10.10:FF:004505', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144130, NULL, 'G3DSA:2.40.70.10:FF:000208', NULL, NULL, 'Plasmepsin VI', NULL, NULL, NULL, NULL, NULL, 4),
(144131, NULL, 'G3DSA:3.80.10.10:FF:004202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144132, NULL, 'G3DSA:3.40.390.10:FF:000166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144133, NULL, 'G3DSA:1.10.533.10:FF:000053', NULL, NULL, 'Apoptosis-associated speck-like protein containing a CARD', NULL, NULL, NULL, NULL, NULL, 4),
(144134, NULL, 'G3DSA:1.10.275.40:FF:000012', NULL, NULL, 'Helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(144135, NULL, 'G3DSA:2.60.40.10:FF:002869', NULL, NULL, 'Platelet-derived growth factor receptor, beta polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(144136, NULL, 'G3DSA:3.30.70.580:FF:000009', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(144137, NULL, 'G3DSA:3.90.1150.10:FF:000361', NULL, NULL, 'DegT/DnrJ/EryC1/StrS family aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(144138, NULL, 'G3DSA:2.40.170.20:FF:000078', NULL, NULL, 'TonB-dependent siderophore receptor', NULL, NULL, NULL, NULL, NULL, 4),
(144139, NULL, 'G3DSA:3.30.460.10:FF:000101', NULL, NULL, 'DUF455 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(144140, NULL, 'G3DSA:2.120.10.30:FF:000583', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(144141, NULL, 'G3DSA:3.40.50.10260:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144142, NULL, 'G3DSA:3.40.50.12780:FF:000053', NULL, NULL, 'Fatty-acid--CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(144143, NULL, 'G3DSA:3.30.200.20:FF:002215', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144144, NULL, 'G3DSA:2.60.40.150:FF:000692', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(144145, NULL, 'G3DSA:2.60.40.10:FF:001886', NULL, NULL, 'FiLamiN (Actin binding protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(144146, NULL, 'G3DSA:3.30.160.60:FF:000756', NULL, NULL, 'C2H2 transcription factor RfeC', NULL, NULL, NULL, NULL, NULL, 4),
(144147, NULL, 'G3DSA:3.30.565.10:FF:000069', NULL, NULL, 'Probable histidine kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(144148, NULL, 'G3DSA:3.40.50.300:FF:001723', NULL, NULL, 'Guanine nucleotide-binding protein G(f) subunit alpha', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(144149, NULL, 'G3DSA:3.40.50.1000:FF:000819', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144150, NULL, 'G3DSA:1.10.472.10:FF:000118', NULL, NULL, 'Cyclin g', NULL, NULL, NULL, NULL, NULL, 4),
(144151, NULL, 'G3DSA:2.170.140.10:FF:000025', NULL, NULL, 'peritrophin-1', NULL, NULL, NULL, NULL, NULL, 4),
(144152, NULL, 'G3DSA:1.20.1250.20:FF:001199', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(144153, NULL, 'G3DSA:2.40.30.10:FF:000088', NULL, NULL, 'Translation elongation factor EF-1, subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(144154, NULL, 'G3DSA:1.10.472.10:FF:000175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144155, NULL, 'G3DSA:2.30.30.40:FF:000507', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(144156, NULL, 'G3DSA:3.30.70.1040:FF:000002', NULL, NULL, 'Dystroglycan, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(144157, NULL, 'G3DSA:3.40.50.10420:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144158, NULL, 'G3DSA:2.160.10.10:FF:000126', NULL, NULL, 'Serine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(144159, NULL, 'G3DSA:3.40.50.300:FF:007232', NULL, NULL, 'RAS-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(144160, NULL, 'G3DSA:3.40.50.150:FF:000077', NULL, NULL, 'HemK methyltransferase family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(144161, NULL, 'G3DSA:1.25.10.10:FF:000725', NULL, NULL, 'Tubulin folding cofactor D', NULL, NULL, NULL, NULL, NULL, 4),
(144162, NULL, 'G3DSA:1.20.1050.10:FF:000051', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(144163, NULL, 'G3DSA:2.130.10.10:FF:002471', NULL, NULL, 'WD-40 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(144164, NULL, 'G3DSA:3.30.70.2170:FF:000004', NULL, NULL, 'V-type ATP synthase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(144165, NULL, 'G3DSA:3.30.70.560:FF:000003', NULL, NULL, 'Folate synthesis bifunctional protein', NULL, NULL, NULL, NULL, NULL, 4),
(144166, NULL, 'G3DSA:3.30.40.10:FF:001177', NULL, NULL, 'RING-H2 finger protein ATL60', NULL, NULL, NULL, NULL, NULL, 4),
(144167, NULL, 'G3DSA:1.10.418.40:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144168, NULL, 'G3DSA:2.20.28.10:FF:000038', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(144169, NULL, 'G3DSA:1.10.10.10:FF:001978', NULL, NULL, 'Interferon regulatory factor 9', NULL, NULL, NULL, NULL, NULL, 4),
(144170, NULL, 'G3DSA:3.40.50.720:FF:000242', NULL, NULL, 'Glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(144171, NULL, 'G3DSA:1.10.238.10:FF:000771', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144172, NULL, 'G3DSA:3.30.70.1050:FF:000005', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(144173, NULL, 'G3DSA:3.40.30.10:FF:001120', NULL, NULL, 'CEBPA: CCAAT/enhancer-binding protein alpha, putative', NULL, NULL, NULL, NULL, NULL, 4),
(144174, NULL, 'G3DSA:1.10.238.10:FF:000619', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144175, NULL, 'G3DSA:1.25.10.10:FF:002434', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144176, NULL, 'G3DSA:1.25.40.10:FF:003987', NULL, NULL, 'AimR transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(144177, NULL, 'G3DSA:2.60.120.10:FF:000438', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(144178, NULL, 'G3DSA:3.30.540.10:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144179, NULL, 'G3DSA:1.25.40.10:FF:004151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144180, NULL, 'G3DSA:1.10.357.140:FF:000024', NULL, NULL, 'Uncharacterized protein B19A17.050', NULL, NULL, NULL, NULL, NULL, 4),
(144181, NULL, 'G3DSA:3.30.540.10:FF:000046', NULL, NULL, 'Inositol monophosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(144182, NULL, 'G3DSA:1.20.120.1900:FF:000046', NULL, NULL, 'Chromosome 15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(144183, NULL, 'G3DSA:3.30.1640.10:FF:000058', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(144184, NULL, 'G3DSA:3.30.56.10:FF:000027', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(144185, NULL, 'G3DSA:2.70.98.10:FF:000057', NULL, NULL, 'Aldose 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(144186, NULL, 'G3DSA:1.10.1630.10:FF:000002', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(144187, NULL, 'G3DSA:3.30.160.60:FF:004180', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144188, NULL, 'G3DSA:3.30.70.580:FF:000066', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(144189, NULL, 'G3DSA:3.30.230.70:FF:000118', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(144190, NULL, 'G3DSA:3.40.50.300:FF:003106', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(144191, NULL, 'G3DSA:3.90.1030.20:FF:000001', NULL, NULL, 'DNA polymerase delta 3, accessory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(144192, NULL, 'G3DSA:3.40.1090.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144193, NULL, 'G3DSA:3.40.50.2300:FF:000434', NULL, NULL, 'CELF35-1', NULL, NULL, NULL, NULL, NULL, 4),
(144194, NULL, 'G3DSA:3.10.20.90:FF:000711', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144195, NULL, 'G3DSA:6.10.250.3320:FF:000001', NULL, NULL, 'neuroendocrine convertase 1', NULL, NULL, NULL, NULL, NULL, 4),
(144196, NULL, 'G3DSA:2.40.10.10:FF:000087', NULL, NULL, 'Kallikrein 8 (Neuropsin/ovasin)', NULL, NULL, NULL, NULL, NULL, 4),
(144197, NULL, 'G3DSA:1.50.10.20:FF:000052', NULL, NULL, 'Ent-kaurene synthase', NULL, NULL, NULL, NULL, NULL, 4),
(144198, NULL, 'G3DSA:3.30.230.10:FF:000056', NULL, NULL, 'GAL1p Galactokinase', NULL, NULL, NULL, NULL, NULL, 4),
(144199, NULL, 'G3DSA:2.130.10.10:FF:002319', NULL, NULL, 'WD repeat-containing protein 63', NULL, NULL, NULL, NULL, NULL, 4),
(144200, NULL, 'G3DSA:2.40.10.10:FF:000558', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144201, NULL, 'G3DSA:3.30.40.10:FF:000250', NULL, NULL, 'E3 ubiquitin-protein ligase MIB2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(144202, NULL, 'G3DSA:3.90.1150.10:FF:000029', NULL, NULL, '5-aminolevulinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(144203, NULL, 'G3DSA:3.40.50.1820:FF:000301', NULL, NULL, 'Related to triacylglycerol lipase', NULL, NULL, NULL, NULL, NULL, 4),
(144204, NULL, 'G3DSA:2.130.10.10:FF:002673', NULL, NULL, 'Nuclear Pore complex Protein', NULL, NULL, NULL, NULL, NULL, 4),
(144205, NULL, 'G3DSA:1.10.630.10:FF:000756', NULL, NULL, 'Cytochrome P450, family 2, subfamily j, polypeptide 12', NULL, NULL, NULL, NULL, NULL, 4),
(144206, NULL, 'G3DSA:3.40.720.10:FF:000378', NULL, NULL, 'Acid phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(144207, NULL, 'G3DSA:2.60.40.60:FF:000861', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144208, NULL, 'G3DSA:2.40.50.140:FF:001275', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144209, NULL, 'G3DSA:1.10.287.70:FF:000312', NULL, NULL, 'Channel voltage-gated Shaker protein Potassium', NULL, NULL, NULL, NULL, NULL, 4),
(144210, NULL, 'G3DSA:2.60.260.20:FF:000007', NULL, NULL, 'dnaJ homolog subfamily B member 5', NULL, NULL, NULL, NULL, NULL, 4),
(144211, NULL, 'G3DSA:3.60.15.10:FF:000139', NULL, NULL, 'Ribonuclease Z', NULL, NULL, NULL, NULL, NULL, 4),
(144212, NULL, 'G3DSA:3.40.390.10:FF:000020', NULL, NULL, 'Stromelysin-3 preproprotein', NULL, NULL, NULL, NULL, NULL, 4),
(144213, NULL, 'G3DSA:3.40.50.1000:FF:000589', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144214, NULL, 'G3DSA:2.40.50.140:FF:000347', NULL, NULL, 'Proteasome regulatory ATPase subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(144215, NULL, 'G3DSA:1.20.120.1910:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144216, NULL, 'G3DSA:3.30.200.20:FF:001400', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(144217, NULL, 'G3DSA:2.60.120.650:FF:000025', NULL, NULL, 'Lysine-specific demethylase 8', NULL, NULL, NULL, NULL, NULL, 4),
(144218, NULL, 'G3DSA:3.80.10.10:FF:000043', NULL, NULL, 'Leucine-rich repeat transmembrane protein FLRT3', NULL, NULL, NULL, NULL, NULL, 4),
(144219, NULL, 'G3DSA:3.40.630.10:FF:000264', NULL, NULL, 'Peptide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(144220, NULL, 'G3DSA:1.20.1260.80:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144221, NULL, 'G3DSA:3.90.550.10:FF:000499', NULL, NULL, 'Putative alpha-1,3-mannosyltransferase MNN14', NULL, NULL, NULL, NULL, NULL, 4),
(144222, NULL, 'G3DSA:2.40.30.10:FF:000470', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144223, NULL, 'G3DSA:1.25.40.10:FF:002149', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(144224, NULL, 'G3DSA:2.170.270.10:FF:000119', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(144225, NULL, 'G3DSA:3.40.50.280:FF:000008', NULL, NULL, 'Methionine synthase (MetH)', NULL, NULL, NULL, NULL, NULL, 4),
(144226, NULL, 'G3DSA:3.30.420.40:FF:000933', NULL, NULL, 'Heat shock protein, Hsp70 family', NULL, NULL, NULL, NULL, NULL, 4),
(144227, NULL, 'G3DSA:2.10.110.10:FF:000196', NULL, NULL, 'Paxillin', NULL, NULL, NULL, NULL, NULL, 4),
(144228, NULL, 'G3DSA:1.20.1600.10:FF:000009', NULL, NULL, 'Multidrug resistance outer membrane protein MdtQ', NULL, NULL, NULL, NULL, NULL, 4),
(144229, NULL, 'G3DSA:3.40.30.10:FF:001209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144230, NULL, 'G3DSA:1.20.1440.340:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144231, NULL, 'G3DSA:3.90.260.10:FF:000016', NULL, NULL, 'DNA repair protein RAD4', NULL, NULL, NULL, NULL, NULL, 4),
(144232, NULL, 'G3DSA:2.40.70.10:FF:000360', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144233, NULL, 'G3DSA:1.20.58.390:FF:000317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144234, NULL, 'G3DSA:3.40.50.300:FF:004742', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(144235, NULL, 'G3DSA:2.60.40.3440:FF:000002', NULL, NULL, 'Probable exported protein', NULL, NULL, NULL, NULL, NULL, 4),
(144236, NULL, 'G3DSA:1.25.40.10:FF:003133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144237, NULL, 'G3DSA:2.60.120.620:FF:000067', NULL, NULL, 'Uncharacterized PKHD-type hydroxylase At1g22950', NULL, NULL, NULL, NULL, NULL, 4),
(144238, NULL, 'G3DSA:3.30.230.70:FF:000175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144239, NULL, 'G3DSA:3.30.200.20:FF:000563', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(144240, NULL, 'G3DSA:3.30.200.20:FF:002182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144241, NULL, 'G3DSA:3.10.28.10:FF:000053', NULL, NULL, 'DNA topoisomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(144242, NULL, 'G3DSA:2.10.25.10:FF:000032', NULL, NULL, 'signal peptide, CUB and EGF-like domain-containing protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(144243, NULL, 'G3DSA:2.10.110.10:FF:000050', NULL, NULL, 'Four and a half LIM domains protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(144244, NULL, 'G3DSA:3.30.160.60:FF:002465', NULL, NULL, 'paternally-expressed gene 3 protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(144245, NULL, 'G3DSA:1.25.40.370:FF:000004', NULL, NULL, 'Apaf-1 related killer DARK', NULL, NULL, NULL, NULL, NULL, 4),
(144246, NULL, 'G3DSA:2.20.130.20:FF:000001', NULL, NULL, 'Complement C3', NULL, NULL, NULL, NULL, NULL, 4),
(144247, NULL, 'G3DSA:2.30.29.30:FF:001097', NULL, NULL, 'Os08g0404400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(144248, NULL, 'G3DSA:3.30.160.270:FF:000009', NULL, NULL, '2-isopropylmalate synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(144249, NULL, 'G3DSA:3.90.226.10:FF:000027', NULL, NULL, 'Probable 3-hydroxyisobutyryl-CoA hydrolase 2', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(144250, NULL, 'G3DSA:3.30.760.10:FF:000028', NULL, NULL, 'Eukaryotic translation initiation factor 4E type', NULL, NULL, NULL, NULL, NULL, 4),
(144251, NULL, 'G3DSA:1.20.1520.10:FF:000008', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(144252, NULL, 'G3DSA:3.40.50.620:FF:000302', NULL, NULL, 'tRNA-specific 2-thiouridylase MnmA', NULL, NULL, NULL, NULL, NULL, 4),
(144253, NULL, 'G3DSA:3.40.50.300:FF:002651', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(144254, NULL, 'G3DSA:1.10.10.10:FF:000719', NULL, NULL, 'RNA polymerase sigma factor SigX', NULL, NULL, NULL, NULL, NULL, 4),
(144255, NULL, 'G3DSA:1.10.10.10:FF:000399', NULL, NULL, 'AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(144256, NULL, 'G3DSA:1.25.40.420:FF:000042', NULL, NULL, 'Protein CBR-BATH-43', NULL, NULL, NULL, NULL, NULL, 4),
(144257, NULL, 'G3DSA:1.20.140.150:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144258, NULL, 'G3DSA:3.30.160.60:FF:005899', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144259, NULL, 'G3DSA:3.40.309.10:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144260, NULL, 'G3DSA:3.10.100.10:FF:000096', NULL, NULL, 'C-type lectin domain family 2 member B', NULL, NULL, NULL, NULL, NULL, 4),
(144261, NULL, 'G3DSA:3.30.310.40:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144262, NULL, 'G3DSA:3.30.300.130:FF:000023', NULL, NULL, 'Fe-S cluster assembly protein NifU, putative', NULL, NULL, NULL, NULL, NULL, 4),
(144263, NULL, 'G3DSA:1.50.40.10:FF:000517', NULL, NULL, 'Mitochondrial carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(144264, NULL, 'G3DSA:3.10.20.90:FF:000239', NULL, NULL, 'Small ubiquitin-related modifier 1', NULL, NULL, NULL, NULL, NULL, 4),
(144265, NULL, 'G3DSA:3.30.450.270:FF:000002', NULL, NULL, 'Sensor histidine kinase/response regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(144266, NULL, 'G3DSA:3.40.120.10:FF:000091', NULL, NULL, 'Phosphoglucomutase/phosphomannomutase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(144267, NULL, 'G3DSA:1.20.1250.20:FF:001816', NULL, NULL, 'Glr0912 protein', NULL, NULL, NULL, NULL, NULL, 4),
(144268, NULL, 'G3DSA:2.60.260.20:FF:000064', NULL, NULL, 'DNAJ domain-containing protein Mas5', NULL, NULL, NULL, NULL, NULL, 4),
(144269, NULL, 'G3DSA:2.60.120.260:FF:000234', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 2', NULL, NULL, NULL, NULL, NULL, 4),
(144270, NULL, 'G3DSA:3.30.70.330:FF:002374', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144271, NULL, 'G3DSA:2.60.40.10:FF:001234', NULL, NULL, 'Colony stimulating factor 3 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(144272, NULL, 'G3DSA:2.40.10.10:FF:000704', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144273, NULL, 'G3DSA:3.90.70.10:FF:000529', NULL, NULL, 'Putative ubiquitin hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(144274, NULL, 'G3DSA:2.40.50.770:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144275, NULL, 'G3DSA:3.90.740.10:FF:000042', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(144276, NULL, 'G3DSA:1.10.3720.10:FF:000094', NULL, NULL, 'Ectoine/hydroxyectoine ABC transporter permease subunit EhuC', NULL, NULL, NULL, NULL, NULL, 4),
(144277, NULL, 'G3DSA:3.30.160.60:FF:001009', NULL, NULL, 'Zinc finger protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(144278, NULL, 'G3DSA:2.60.40.10:FF:000958', NULL, NULL, 'Interleukin-13 receptor subunit alpha-2', NULL, NULL, NULL, NULL, NULL, 4),
(144279, NULL, 'G3DSA:3.30.420.40:FF:000462', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144280, NULL, 'G3DSA:3.10.450.10:FF:000083', NULL, NULL, 'Kininogen 2', NULL, NULL, NULL, NULL, NULL, 4),
(144281, NULL, 'G3DSA:3.30.360.10:FF:000099', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(144282, NULL, 'G3DSA:1.25.40.10:FF:003897', NULL, NULL, 'Os12g0256900 protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(144283, NULL, 'G3DSA:3.30.497.10:FF:000079', NULL, NULL, 'Serine protease inhibitor (serpin) 4', NULL, NULL, NULL, NULL, NULL, 4),
(144284, NULL, 'G3DSA:1.10.510.10:FF:000871', NULL, NULL, 'Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(144285, NULL, 'G3DSA:3.40.50.300:FF:000796', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NUBP2', NULL, NULL, NULL, NULL, NULL, 4),
(144286, NULL, 'G3DSA:3.30.70.60:FF:000007', NULL, NULL, '37S ribosomal protein Mrp17', NULL, NULL, NULL, NULL, NULL, 4),
(144287, NULL, 'G3DSA:1.20.120.730:FF:000020', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(144288, NULL, 'G3DSA:3.40.50.300:FF:006451', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144289, NULL, 'G3DSA:3.30.40.10:FF:002104', NULL, NULL, 'Mst2 complex subunit nto1', NULL, NULL, NULL, NULL, NULL, 4),
(144290, NULL, 'G3DSA:1.10.472.10:FF:000208', NULL, NULL, 'Cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(144291, NULL, 'G3DSA:2.40.50.140:FF:000201', NULL, NULL, 'TRM2p tRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(144292, NULL, 'G3DSA:1.10.510.10:FF:000629', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(144293, NULL, 'G3DSA:3.40.640.10:FF:000091', NULL, NULL, 'Diaminobutyrate--2-oxoglutarate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(144294, NULL, 'G3DSA:3.40.50.150:FF:000695', NULL, NULL, 'Methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(144295, NULL, 'G3DSA:3.40.50.970:FF:000210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144296, NULL, 'G3DSA:1.25.40.20:FF:001337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144297, NULL, 'G3DSA:3.30.559.70:FF:000005', NULL, NULL, 'Carnitine O-palmitoyltransferase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(144298, NULL, 'G3DSA:2.60.40.10:FF:003797', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144299, NULL, 'G3DSA:3.40.50.300:FF:004539', NULL, NULL, 'AAA family ATPase peroxin 1', NULL, NULL, NULL, NULL, NULL, 4),
(144300, NULL, 'G3DSA:3.40.47.10:FF:000231', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144301, NULL, 'G3DSA:3.30.1010.10:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144302, NULL, 'G3DSA:1.25.40.10:FF:002442', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g49740', NULL, NULL, NULL, NULL, NULL, 4),
(144303, NULL, 'G3DSA:3.40.50.150:FF:000880', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144304, NULL, 'G3DSA:3.40.50.11320:FF:000003', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(144305, NULL, 'G3DSA:3.50.50.60:FF:001276', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(144306, NULL, 'G3DSA:3.10.20.90:FF:000857', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144307, NULL, 'G3DSA:1.10.510.10:FF:004468', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144308, NULL, 'G3DSA:1.25.10.10:FF:000164', NULL, NULL, 'Testis-expressed sequence 10 protein', NULL, NULL, NULL, NULL, NULL, 4),
(144309, NULL, 'G3DSA:1.25.40.10:FF:002913', NULL, NULL, 'Os02g0680500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(144310, NULL, 'G3DSA:3.30.2090.10:FF:000010', NULL, NULL, 'Transporter, AcrB/D/F family', NULL, NULL, NULL, NULL, NULL, 4),
(144311, NULL, 'G3DSA:3.60.21.10:FF:000199', NULL, NULL, 'Protein CBG20631', NULL, NULL, NULL, NULL, NULL, 4),
(144312, NULL, 'G3DSA:1.10.10.10:FF:000343', NULL, NULL, 'Ets at 65A, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(144313, NULL, 'G3DSA:3.40.50.150:FF:000638', NULL, NULL, 'tRNA (Cytosine-5-)-methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(144314, NULL, 'G3DSA:2.60.40.10:FF:004814', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144315, NULL, 'G3DSA:3.40.50.300:FF:008339', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(144316, NULL, 'G3DSA:1.20.1250.20:FF:001963', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(144317, NULL, 'G3DSA:3.40.47.10:FF:000028', NULL, NULL, '3-ketoacyl-CoA synthase', NULL, NULL, NULL, NULL, NULL, 4),
(144318, NULL, 'G3DSA:3.30.1010.10:FF:000033', NULL, NULL, 'Putative phosphatidylinositol 3-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(144319, NULL, 'G3DSA:3.30.1360.10:FF:000020', NULL, NULL, 'RH25219p', NULL, NULL, NULL, NULL, NULL, 4),
(144320, NULL, 'G3DSA:1.10.510.10:FF:002580', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144321, NULL, 'G3DSA:3.40.50.300:FF:001015', NULL, NULL, 'ADP-ribosylation factor-like protein 8B', NULL, NULL, NULL, NULL, NULL, 4),
(144322, NULL, 'G3DSA:2.30.30.40:FF:000187', NULL, NULL, 'Neutrophil cytosolic factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(144323, NULL, 'G3DSA:1.10.510.10:FF:002670', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144324, NULL, 'G3DSA:3.30.565.10:FF:000215', NULL, NULL, 'Sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(144325, NULL, 'G3DSA:3.40.1160.10:FF:000087', NULL, NULL, 'Amino-acid acetyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(144326, NULL, 'G3DSA:1.20.140.150:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144327, NULL, 'G3DSA:2.60.40.10:FF:004904', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144328, NULL, 'G3DSA:3.30.40.10:FF:001885', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144329, NULL, 'G3DSA:2.110.10.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144330, NULL, 'G3DSA:3.40.50.300:FF:004652', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(144331, NULL, 'G3DSA:1.20.1530.20:FF:000080', NULL, NULL, 'Arsenic oxyanion-translocation pump', NULL, NULL, NULL, NULL, NULL, 4),
(144332, NULL, 'G3DSA:2.60.40.790:FF:000119', NULL, NULL, 'Sgt1p', NULL, NULL, NULL, NULL, NULL, 4),
(144333, NULL, 'G3DSA:3.30.40.10:FF:002161', NULL, NULL, 'Structure-specific endonuclease subunit SLX1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(144334, NULL, 'G3DSA:2.30.29.30:FF:000080', NULL, NULL, 'Arf-GAP with dual PH domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(144335, NULL, 'G3DSA:1.20.890.10:FF:000014', NULL, NULL, 'Protein dpy-30', NULL, NULL, NULL, NULL, NULL, 4),
(144336, NULL, 'G3DSA:3.40.720.10:FF:000001', NULL, NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(144337, NULL, 'G3DSA:3.90.550.10:FF:000735', NULL, NULL, 'Os01g0264100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(144338, NULL, 'G3DSA:2.40.50.140:FF:000999', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144339, NULL, 'G3DSA:2.40.50.100:FF:000184', NULL, NULL, 'RND family efflux transporter MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(144340, NULL, 'G3DSA:1.10.510.10:FF:002338', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144341, NULL, 'G3DSA:3.90.1150.220:FF:000013', NULL, NULL, 'Non-structural maintenance of chromosomes element 1 homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(144342, NULL, 'G3DSA:3.30.200.20:FF:002272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144343, NULL, 'G3DSA:3.90.1180.10:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144344, NULL, 'G3DSA:3.30.720.200:FF:000010', NULL, NULL, 'Glycyl-tRNA synthetase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(144345, NULL, 'G3DSA:1.20.1310.10:FF:000094', NULL, NULL, 'Cullin-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(144346, NULL, 'G3DSA:1.10.150.280:FF:000005', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(144347, NULL, 'G3DSA:1.10.20.10:FF:000169', NULL, NULL, 'Histone H4', NULL, NULL, NULL, NULL, NULL, 4),
(144348, NULL, 'G3DSA:3.40.50.720:FF:002131', NULL, NULL, 'mRNA clone with similarity to L-glycerol-3-phosphate:NAD oxidoreductase and albumin gene sequences', NULL, NULL, NULL, NULL, NULL, 4),
(144349, NULL, 'G3DSA:3.30.420.40:FF:000405', NULL, NULL, 'ARP1 actin related protein 1 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(144350, NULL, 'G3DSA:3.30.1050.10:FF:000007', NULL, NULL, 'SCP-2 family sterol carrier protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(144351, NULL, 'G3DSA:2.120.10.80:FF:000373', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144352, NULL, 'G3DSA:3.30.200.20:FF:000473', NULL, NULL, 'Calcium-dependent protein kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(144353, NULL, 'G3DSA:3.40.390.10:FF:000110', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(144354, NULL, 'G3DSA:3.90.1150.210:FF:000010', NULL, NULL, 'F-actin-capping protein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(144355, NULL, 'G3DSA:3.55.50.30:FF:000003', NULL, NULL, 'Fe(3+) dicitrate transport protein FecA', NULL, NULL, NULL, NULL, NULL, 4),
(144356, NULL, 'G3DSA:1.10.3470.10:FF:000023', NULL, NULL, 'Iron ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(144357, NULL, 'G3DSA:2.30.30.940:FF:000006', NULL, NULL, 'ATP-dependent RecD-like DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(144358, NULL, 'G3DSA:2.30.30.210:FF:000024', NULL, NULL, 'Ribonuclease P protein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(144359, NULL, 'G3DSA:3.40.850.10:FF:000005', NULL, NULL, 'Myosin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(144360, NULL, 'G3DSA:2.70.170.10:FF:000271', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144361, NULL, 'G3DSA:1.25.10.10:FF:000579', NULL, NULL, 'Serine/threonine kinase like domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(144362, NULL, 'G3DSA:3.40.50.300:FF:000942', NULL, NULL, 'Ras-related and estrogen-regulated growth inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(144363, NULL, 'G3DSA:3.30.50.10:FF:000076', NULL, NULL, 'Similar to transcription factor Zn, GATA', NULL, NULL, NULL, NULL, NULL, 4),
(144364, NULL, 'G3DSA:1.10.20.10:FF:000372', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144365, NULL, 'G3DSA:3.50.50.60:FF:000258', NULL, NULL, 'Flavin-binding monooxygenase-like protein (AFU_orthologue AFUA_6G01900)', NULL, NULL, NULL, NULL, NULL, 4),
(144366, NULL, 'G3DSA:3.10.20.420:FF:000001', NULL, NULL, 'Bypass-of-forespore protein C', NULL, NULL, NULL, NULL, NULL, 4),
(144367, NULL, 'G3DSA:1.10.30.10:FF:000198', NULL, NULL, 'PHDfinger domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(144368, NULL, 'G3DSA:3.10.20.90:FF:000767', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144369, NULL, 'G3DSA:1.10.510.10:FF:000781', NULL, NULL, 'Protein kinase dsk1', NULL, NULL, NULL, NULL, NULL, 4),
(144370, NULL, 'G3DSA:3.30.70.330:FF:002284', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144371, NULL, 'G3DSA:3.40.50.300:FF:001072', NULL, NULL, 'Rab family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(144372, NULL, 'G3DSA:3.90.70.10:FF:000586', NULL, NULL, 'PAN2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(144373, NULL, 'G3DSA:1.20.1250.20:FF:001345', NULL, NULL, 'Sialin', NULL, NULL, NULL, NULL, NULL, 4),
(144374, NULL, 'G3DSA:3.30.160.60:FF:005051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144375, NULL, 'G3DSA:3.40.50.1000:FF:000499', NULL, NULL, 'Cleavage and polyadenylation factor 6-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(144376, NULL, 'G3DSA:1.25.10.10:FF:000782', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(144377, NULL, 'G3DSA:3.40.50.1100:FF:000288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144378, NULL, 'G3DSA:3.40.50.300:FF:004449', NULL, NULL, 'ORC1-type DNA replication protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(144379, NULL, 'G3DSA:3.40.47.10:FF:000141', NULL, NULL, 'Putative 3-oxoacyl-(Acyl-carrier-protein) synthase III', NULL, NULL, NULL, NULL, NULL, 4),
(144380, NULL, 'G3DSA:2.10.25.10:FF:001807', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144381, NULL, 'G3DSA:3.40.50.880:FF:000149', NULL, NULL, 'Imidazole glycerol phosphate synthase subunit HisH', NULL, NULL, NULL, NULL, NULL, 4),
(144382, NULL, 'G3DSA:2.60.40.790:FF:000176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144383, NULL, 'G3DSA:3.30.720.50:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(144384, NULL, 'G3DSA:2.60.120.20:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144385, NULL, 'G3DSA:3.10.290.10:FF:000019', NULL, NULL, '40S ribosomal protein S4', NULL, NULL, NULL, NULL, NULL, 4),
(144386, NULL, 'G3DSA:1.10.238.10:FF:001081', NULL, NULL, 'DCN1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(144387, NULL, 'G3DSA:2.60.120.260:FF:000324', NULL, NULL, 'Glycoside hydrolase family 3 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(144388, NULL, 'G3DSA:3.90.70.10:FF:000439', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144389, NULL, 'G3DSA:1.20.5.1140:FF:000001', NULL, NULL, '6-deoxyerythronolide-B synthase EryA2, modules 3 and 4', NULL, NULL, NULL, NULL, NULL, 4),
(144390, NULL, 'G3DSA:3.30.70.660:FF:000090', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(144391, NULL, 'G3DSA:2.60.40.60:FF:001114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144392, NULL, 'G3DSA:3.40.190.290:FF:000019', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(144393, NULL, 'G3DSA:3.90.470.20:FF:000029', NULL, NULL, '4phosphopantetheinyl transferase EC 278 CDS', NULL, NULL, NULL, NULL, NULL, 4),
(144394, NULL, 'G3DSA:3.40.50.300:FF:008249', NULL, NULL, 'Dynein, axonemal, heavy chain 11', NULL, NULL, NULL, NULL, NULL, 4),
(144395, NULL, 'G3DSA:3.40.800.20:FF:000005', NULL, NULL, 'histone deacetylase 6', NULL, NULL, NULL, NULL, NULL, 4),
(144396, NULL, 'G3DSA:1.20.1250.20:FF:002126', NULL, NULL, 'AGAP007755-PA', NULL, NULL, NULL, NULL, NULL, 4),
(144397, NULL, 'G3DSA:2.60.40.10:FF:003887', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144398, NULL, 'G3DSA:3.80.10.10:FF:001476', NULL, NULL, 'Toll-like receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(144399, NULL, 'G3DSA:2.60.120.40:FF:000037', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(144400, NULL, 'G3DSA:1.25.10.10:FF:002614', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144401, NULL, 'G3DSA:2.40.30.270:FF:000005', NULL, NULL, 'Probable RNA helicase SDE3', NULL, NULL, NULL, NULL, NULL, 4),
(144402, NULL, 'G3DSA:1.20.5.1160:FF:000007', NULL, NULL, 'Lamin B1', NULL, NULL, NULL, NULL, NULL, 4),
(144403, NULL, 'G3DSA:3.30.450.40:FF:000290', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(144404, NULL, 'G3DSA:2.30.29.30:FF:000731', NULL, NULL, 'Pleckstrin homology domain containing A2', NULL, NULL, NULL, NULL, NULL, 4),
(144405, NULL, 'G3DSA:2.70.98.10:FF:000113', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(144406, NULL, 'G3DSA:2.130.10.10:FF:004472', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144407, NULL, 'G3DSA:2.40.20.10:FF:000059', NULL, NULL, 'HCG2029799, isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(144408, NULL, 'G3DSA:3.40.190.10:FF:000454', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(144409, NULL, 'G3DSA:3.40.800.10:FF:000002', NULL, NULL, 'Agmatinase', NULL, NULL, NULL, NULL, NULL, 4),
(144410, NULL, 'G3DSA:3.40.50.2000:FF:000136', NULL, NULL, 'Glycosyl transferase, group 1', NULL, NULL, NULL, NULL, NULL, 4),
(144411, NULL, 'G3DSA:3.90.470.10:FF:000026', NULL, NULL, 'Mitochondrial Ribosomal Protein, Large', NULL, NULL, NULL, NULL, NULL, 4),
(144412, NULL, 'G3DSA:2.60.40.340:FF:000007', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(144413, NULL, 'G3DSA:3.40.50.410:FF:000031', NULL, NULL, 'X-ray repair cross-complementing protein 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(144414, NULL, 'G3DSA:1.20.58.760:FF:000012', NULL, NULL, 'probable inactive ATP-dependent zinc metalloprotease FTSHI 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(144415, NULL, 'G3DSA:2.40.50.100:FF:000094', NULL, NULL, 'sn-glycerol-3-phosphate ABC transporter ATP-binding protein UgpC', NULL, NULL, NULL, NULL, NULL, 4),
(144416, NULL, 'G3DSA:2.60.40.1910:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(144417, NULL, 'G3DSA:3.40.50.1820:FF:001285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144418, NULL, 'G3DSA:2.60.15.10:FF:000001', NULL, NULL, 'ATP synthase epsilon chain', NULL, NULL, NULL, NULL, NULL, 4),
(144419, NULL, 'G3DSA:3.80.10.10:FF:002460', NULL, NULL, 'Leucine rich repeats and death domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(144420, NULL, 'G3DSA:2.130.10.10:FF:000672', NULL, NULL, 'Os05g0519500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(144421, NULL, 'G3DSA:3.30.559.70:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144422, NULL, 'G3DSA:3.30.420.60:FF:000001', NULL, NULL, 'Eukaryotic peptide chain release factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(144423, NULL, 'G3DSA:3.30.720.210:FF:000013', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(144424, NULL, 'G3DSA:2.20.80.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144425, NULL, 'G3DSA:1.10.510.10:FF:001034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144426, NULL, 'G3DSA:3.40.47.10:FF:000085', NULL, NULL, '2-heptyl-4(1H)-quinolone synthase subunit PqsC', NULL, NULL, NULL, NULL, NULL, 4),
(144427, NULL, 'G3DSA:2.60.40.60:FF:000187', NULL, NULL, 'Cadherin 16', NULL, NULL, NULL, NULL, NULL, 4),
(144428, NULL, 'G3DSA:2.90.10.10:FF:000028', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(144429, NULL, 'G3DSA:3.40.50.11610:FF:000005', NULL, NULL, 'Probable 2-oxoglutarate dehydrogenase E1 component DHKTD1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(144430, NULL, 'G3DSA:3.30.160.60:FF:001161', NULL, NULL, 'zinc finger protein 397 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(144431, NULL, 'G3DSA:1.20.1050.10:FF:000141', NULL, NULL, 'Os01g0370600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(144432, NULL, 'G3DSA:2.120.10.30:FF:000201', NULL, NULL, 'Low-density lipoprotein receptor-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(144433, NULL, 'G3DSA:3.30.200.20:FF:000383', NULL, NULL, 'Slowpoke binding protein, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(144434, NULL, 'G3DSA:1.20.58.60:FF:000400', NULL, NULL, 'SPeCtrin', NULL, NULL, NULL, NULL, NULL, 4),
(144435, NULL, 'G3DSA:3.40.50.300:FF:001162', NULL, NULL, 'ATP-dependent RNA helicase DQX1', NULL, NULL, NULL, NULL, NULL, 4),
(144436, NULL, 'G3DSA:3.30.2160.10:FF:000038', NULL, NULL, 'E3 ubiquitin-protein ligase UPL1', NULL, NULL, NULL, NULL, NULL, 4),
(144437, NULL, 'G3DSA:2.10.109.10:FF:000035', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(144438, NULL, 'G3DSA:3.30.160.60:FF:005612', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144439, NULL, 'G3DSA:1.20.1270.280:FF:000026', NULL, NULL, 'Dynein alpha chain, flagellar outer arm', NULL, NULL, NULL, NULL, NULL, 4),
(144440, NULL, 'G3DSA:3.40.50.300:FF:001105', NULL, NULL, 'Orf1ab polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(144441, NULL, 'G3DSA:3.30.40.10:FF:001738', NULL, NULL, 'Lysine-specific demethylase rbr-2', NULL, NULL, NULL, NULL, NULL, 4),
(144442, NULL, 'G3DSA:1.20.1250.20:FF:001906', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144443, NULL, 'G3DSA:2.60.40.60:FF:000658', NULL, NULL, 'Cadherin 16', NULL, NULL, NULL, NULL, NULL, 4),
(144444, NULL, 'G3DSA:3.30.40.10:FF:001795', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144445, NULL, 'G3DSA:3.90.780.10:FF:000016', NULL, NULL, 'Sulfur oxidation protein SoxB', NULL, NULL, NULL, NULL, NULL, 4),
(144446, NULL, 'G3DSA:3.50.50.60:FF:000314', NULL, NULL, 'Baeyer-Villiger monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(144447, NULL, 'G3DSA:1.25.40.10:FF:002970', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(144448, NULL, 'G3DSA:2.170.190.11:FF:000007', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(144449, NULL, 'G3DSA:3.90.1420.10:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(144450, NULL, 'G3DSA:3.30.450.40:FF:000233', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(144451, NULL, 'G3DSA:2.30.29.30:FF:000170', NULL, NULL, 'Arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(144452, NULL, 'G3DSA:1.20.50.20:FF:000005', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(144453, NULL, 'G3DSA:3.40.50.300:FF:004596', NULL, NULL, 'Large T antigen', NULL, NULL, NULL, NULL, NULL, 4),
(144454, NULL, 'G3DSA:1.20.1510.10:FF:000036', NULL, NULL, 'Cation diffusion facilitator family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(144455, NULL, 'G3DSA:2.180.10.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144456, NULL, 'G3DSA:3.30.50.10:FF:000132', NULL, NULL, 'C2C2-GATA transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(144457, NULL, 'G3DSA:1.10.1450.10:FF:000106', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(144458, NULL, 'G3DSA:3.30.160.60:FF:004595', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144459, NULL, 'G3DSA:1.20.1250.20:FF:001873', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144460, NULL, 'G3DSA:2.170.8.10:FF:000002', NULL, NULL, 'phosphoenolpyruvate carboxykinase, cytosolic [GTP]', NULL, NULL, NULL, NULL, NULL, 4),
(144461, NULL, 'G3DSA:1.20.120.1240:FF:000011', NULL, NULL, 'Dynamin-2A', NULL, NULL, NULL, NULL, NULL, 4),
(144462, NULL, 'G3DSA:2.10.25.10:FF:001336', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144463, NULL, 'G3DSA:3.90.1150.10:FF:000209', NULL, NULL, 'CAI-1 autoinducer synthase', NULL, NULL, NULL, NULL, NULL, 4),
(144464, NULL, 'G3DSA:2.60.40.10:FF:000453', NULL, NULL, 'Chitin biosynthesis protein CHS5', NULL, NULL, NULL, NULL, NULL, 4),
(144465, NULL, 'G3DSA:1.10.238.10:FF:001024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144466, NULL, 'G3DSA:3.40.50.2300:FF:000254', NULL, NULL, 'Chemotaxis protein CheV', NULL, NULL, NULL, NULL, NULL, 4),
(144467, NULL, 'G3DSA:1.20.1250.20:FF:001255', NULL, NULL, 'Sugar (Glycoside-Pentoside-Hexuronide) transporter', NULL, NULL, NULL, NULL, NULL, 4),
(144468, NULL, 'G3DSA:1.10.510.10:FF:004378', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144469, NULL, 'G3DSA:3.90.550.10:FF:000645', NULL, NULL, 'Cellulose synthase A catalytic subunit 8 [UDP-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(144470, NULL, 'G3DSA:3.40.140.10:FF:000209', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(144471, NULL, 'G3DSA:3.40.50.1820:FF:001846', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(144472, NULL, 'G3DSA:3.90.70.10:FF:000496', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144473, NULL, 'G3DSA:3.90.480.20:FF:000002', NULL, NULL, 'Sulfite reductase', NULL, NULL, NULL, NULL, NULL, 4),
(144474, NULL, 'G3DSA:3.30.40.10:FF:002048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144475, NULL, 'G3DSA:2.70.50.40:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144476, NULL, 'G3DSA:3.30.50.10:FF:000042', NULL, NULL, 'Nuclear hormone receptor HR96', NULL, NULL, NULL, NULL, NULL, 4),
(144477, NULL, 'G3DSA:3.40.50.300:FF:000852', NULL, NULL, 'Heparan-sulfate 6-O-sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(144478, NULL, 'G3DSA:1.10.20.10:FF:000282', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144479, NULL, 'G3DSA:2.130.10.10:FF:000762', NULL, NULL, 'Splicing factor 3B subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(144480, NULL, 'G3DSA:3.40.50.720:FF:001821', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144481, NULL, 'G3DSA:3.40.50.970:FF:000120', NULL, NULL, 'Pyruvate dehydrogenase (Ferredoxin/flavodoxin-dependent)', NULL, NULL, NULL, NULL, NULL, 4),
(144482, NULL, 'G3DSA:1.10.287.70:FF:000599', NULL, NULL, 'Potassium voltage-gated channel, subfamily H (eag-related), member 3', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(144483, NULL, 'G3DSA:1.10.1320.10:FF:000012', NULL, NULL, 'DNA-directed RNA polymerase 3 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(144484, NULL, 'G3DSA:2.120.10.80:FF:000406', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144485, NULL, 'G3DSA:2.30.230.10:FF:000037', NULL, NULL, 'Vitellogenin 1', NULL, NULL, NULL, NULL, NULL, 4),
(144486, NULL, 'G3DSA:3.40.50.300:FF:008491', NULL, NULL, 'ATP binding cassette subfamily B member 4', NULL, NULL, NULL, NULL, NULL, 4),
(144487, NULL, 'G3DSA:1.20.1110.10:FF:000253', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144488, NULL, 'G3DSA:1.10.10.60:FF:000751', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(144489, NULL, 'G3DSA:2.40.10.10:FF:000143', NULL, NULL, 'Serine protease PepA', NULL, NULL, NULL, NULL, NULL, 4),
(144490, NULL, 'G3DSA:3.30.160.60:FF:002611', NULL, NULL, 'Ras-responsive element-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(144491, NULL, 'G3DSA:1.25.40.10:FF:002352', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(144492, NULL, 'G3DSA:1.10.10.60:FF:000509', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(144493, NULL, 'G3DSA:2.60.40.60:FF:000097', NULL, NULL, 'cadherin-12 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(144494, NULL, 'G3DSA:3.30.300.10:FF:000028', NULL, NULL, 'S-adenosylmethionine synthetase 2', NULL, NULL, NULL, NULL, NULL, 4),
(144495, NULL, 'G3DSA:1.10.238.10:FF:000535', NULL, NULL, 'Calcium uptake protein 1 homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(144496, NULL, 'G3DSA:2.60.40.1400:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144497, NULL, 'G3DSA:1.10.238.10:FF:001103', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(144498, NULL, 'G3DSA:3.40.367.20:FF:000031', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(144499, NULL, 'G3DSA:2.60.40.10:FF:001060', NULL, NULL, 'Sallimus, isoform Q', NULL, NULL, NULL, NULL, NULL, 4),
(144500, NULL, 'G3DSA:1.10.472.170:FF:000017', NULL, NULL, 'BRF1 homolog, subunit of RNA polymerase III transcription initiation factor IIIB (S. cerevisiae) (Predicted), isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(144501, NULL, 'G3DSA:3.30.70.270:FF:000214', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144502, NULL, 'G3DSA:1.10.10.10:FF:000225', NULL, NULL, 'Positive transcription regulator EvgA', NULL, NULL, NULL, NULL, NULL, 4),
(144503, NULL, 'G3DSA:3.40.309.10:FF:000113', NULL, NULL, 'Aldehyde dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(144504, NULL, 'G3DSA:1.20.1070.10:FF:000878', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(144505, NULL, 'G3DSA:3.80.10.10:FF:003775', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144506, NULL, 'G3DSA:3.90.226.10:FF:000061', NULL, NULL, 'Methylglutaconyl-CoA hydratase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(144507, NULL, 'G3DSA:1.20.58.1880:FF:000015', NULL, NULL, 'AGAP001029-PA', NULL, NULL, NULL, NULL, NULL, 4),
(144508, NULL, 'G3DSA:1.25.10.10:FF:000282', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(144509, NULL, 'G3DSA:2.160.20.10:FF:000284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144510, NULL, 'G3DSA:1.10.1420.10:FF:000161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144511, NULL, 'G3DSA:3.10.129.10:FF:000263', NULL, NULL, 'Acyl-CoA thioesterase 11a', NULL, NULL, NULL, NULL, NULL, 4),
(144512, NULL, 'G3DSA:2.40.180.10:FF:000019', NULL, NULL, 'Catalase', NULL, NULL, NULL, NULL, NULL, 4),
(144513, NULL, 'G3DSA:1.10.575.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144514, NULL, 'G3DSA:1.10.640.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144515, NULL, 'G3DSA:3.60.21.10:FF:000373', NULL, NULL, 'Serine/threonine protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(144516, NULL, 'G3DSA:3.30.1520.20:FF:000002', NULL, NULL, 'Exodeoxyribonuclease I', NULL, NULL, NULL, NULL, NULL, 4),
(144517, NULL, 'G3DSA:1.20.1310.10:FF:000173', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144518, NULL, 'G3DSA:3.30.70.330:FF:002610', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144519, NULL, 'G3DSA:2.130.10.10:FF:004264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144520, NULL, 'G3DSA:3.40.50.300:FF:006810', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144521, NULL, 'G3DSA:2.130.10.10:FF:002235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144522, NULL, 'G3DSA:2.60.40.10:FF:004348', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144523, NULL, 'G3DSA:3.40.50.300:FF:006861', NULL, NULL, 'ABC transporter, ATP-binding/permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(144524, NULL, 'G3DSA:3.40.50.1000:FF:000729', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144525, NULL, 'G3DSA:3.40.30.10:FF:001187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144526, NULL, 'G3DSA:2.20.100.10:FF:000030', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 3', NULL, NULL, NULL, NULL, NULL, 4),
(144527, NULL, 'G3DSA:3.40.50.720:FF:001580', NULL, NULL, 'WbnF', NULL, NULL, NULL, NULL, NULL, 4),
(144528, NULL, 'G3DSA:2.30.30.40:FF:000266', NULL, NULL, 'SLIT-ROBO Rho GTPase-activating protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(144529, NULL, 'G3DSA:3.90.1600.10:FF:000025', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(144530, NULL, 'G3DSA:1.50.10.20:FF:000142', NULL, NULL, 'Squalene cyclase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(144531, NULL, 'G3DSA:3.80.10.10:FF:002252', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(144532, NULL, 'G3DSA:3.40.50.300:FF:003084', NULL, NULL, 'Cell cycle-associated GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(144533, NULL, 'G3DSA:2.70.98.10:FF:000091', NULL, NULL, 'AGAP008154-PA', NULL, NULL, NULL, NULL, NULL, 4),
(144534, NULL, 'G3DSA:2.40.70.10:FF:000124', NULL, NULL, 'Transposon Tf2-8 polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(144535, NULL, 'G3DSA:3.30.160.60:FF:002706', NULL, NULL, 'Zinc finger protein 682', NULL, NULL, NULL, NULL, NULL, 4),
(144536, NULL, 'G3DSA:1.10.472.10:FF:000028', NULL, NULL, 'Cyclin-T1-5 like', NULL, NULL, NULL, NULL, NULL, 4),
(144537, NULL, 'G3DSA:2.60.40.10:FF:004286', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144538, NULL, 'G3DSA:3.30.40.10:FF:001946', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144539, NULL, 'G3DSA:3.30.200.20:FF:000703', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(144540, NULL, 'G3DSA:1.10.268.10:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144541, NULL, 'G3DSA:1.20.1250.20:FF:000119', NULL, NULL, 'MFS monosaccharide transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(144542, NULL, 'G3DSA:1.10.510.10:FF:002585', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144543, NULL, 'G3DSA:2.40.70.10:FF:000450', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144544, NULL, 'G3DSA:3.30.200.20:FF:000057', NULL, NULL, 'Serine/threonine-protein kinase DCLK1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(144545, NULL, 'G3DSA:1.20.120.1240:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144546, NULL, 'G3DSA:2.60.120.650:FF:000053', NULL, NULL, '2-oxoglutarate (2OG) and Fe(II)-dependent oxygenase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(144547, NULL, 'G3DSA:1.20.120.220:FF:000018', NULL, NULL, 'ATPase protein', NULL, NULL, NULL, NULL, NULL, 4),
(144548, NULL, 'G3DSA:2.40.30.170:FF:000060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144549, NULL, 'G3DSA:1.10.3720.10:FF:000173', NULL, NULL, 'Putative ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(144550, NULL, 'G3DSA:1.20.1070.10:FF:001867', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(144551, NULL, 'G3DSA:3.80.10.10:FF:000009', NULL, NULL, 'F-actin-uncapping protein LRRC16A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(144552, NULL, 'G3DSA:2.170.270.10:FF:000147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144553, NULL, 'G3DSA:2.70.150.10:FF:000207', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(144554, NULL, 'G3DSA:2.60.40.10:FF:002257', NULL, NULL, 'CLUMA_CG019509, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(144555, NULL, 'G3DSA:3.40.50.2000:FF:000900', NULL, NULL, 'Putative colanic acid biosynthesis glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(144556, NULL, 'G3DSA:2.70.170.10:FF:000158', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(144557, NULL, 'G3DSA:3.90.70.10:FF:000316', NULL, NULL, 'Putative cysteine peptidase, Clan CA, family C19', NULL, NULL, NULL, NULL, NULL, 4),
(144558, NULL, 'G3DSA:1.10.238.10:FF:000440', NULL, NULL, 'Probable calcium-binding protein CML31', NULL, NULL, NULL, NULL, NULL, 4),
(144559, NULL, 'G3DSA:1.10.10.10:FF:000276', NULL, NULL, 'heterochromatin protein 1-binding protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(144560, NULL, 'G3DSA:3.90.550.10:FF:000319', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(144561, NULL, 'G3DSA:1.25.40.10:FF:002880', NULL, NULL, 'U3 small nucleolar RNA-associated protein 6 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(144562, NULL, 'G3DSA:1.10.3210.10:FF:000089', NULL, NULL, 'HD superfamily hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(144563, NULL, 'G3DSA:1.10.472.10:FF:000416', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(144564, NULL, 'G3DSA:1.20.144.10:FF:000040', NULL, NULL, 'Probable diacylglycerol pyrophosphate phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(144565, NULL, 'G3DSA:1.25.40.10:FF:001986', NULL, NULL, 'Pentatricopeptide repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(144566, NULL, 'G3DSA:2.130.10.10:FF:005787', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(144567, NULL, 'G3DSA:1.10.510.10:FF:003102', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144568, NULL, 'G3DSA:3.40.50.1820:FF:000003', NULL, NULL, 'Dipeptidyl peptidase 4', NULL, NULL, NULL, NULL, NULL, 4),
(144569, NULL, 'G3DSA:3.30.565.10:FF:000417', NULL, NULL, 'GAF domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(144570, NULL, 'G3DSA:3.40.850.10:FF:000218', NULL, NULL, 'Kinesin-like protein costa', NULL, NULL, NULL, NULL, NULL, 4),
(144571, NULL, 'G3DSA:1.25.40.10:FF:002649', NULL, NULL, 'Coatomer subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(144572, NULL, 'G3DSA:2.60.40.10:FF:001801', NULL, NULL, 'Sidestep, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(144573, NULL, 'G3DSA:1.10.600.10:FF:000046', NULL, NULL, 'Squalene synthase HpnC', NULL, NULL, NULL, NULL, NULL, 4),
(144574, NULL, 'G3DSA:3.40.50.261:FF:000009', NULL, NULL, 'Protein lysine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(144575, NULL, 'G3DSA:1.25.40.20:FF:000792', NULL, NULL, 'Ankyrin repeats (3 copies), putative', NULL, NULL, NULL, NULL, NULL, 4),
(144576, NULL, 'G3DSA:1.10.510.10:FF:000461', NULL, NULL, 'Interleukin 1 receptor associated kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(144577, NULL, 'G3DSA:1.10.3460.10:FF:000023', NULL, NULL, 'Chlorophyll a-b binding protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(144578, NULL, 'G3DSA:2.30.30.40:FF:000215', NULL, NULL, 'MAGUK p55 subfamily member 3', NULL, NULL, NULL, NULL, NULL, 4),
(144579, NULL, 'G3DSA:2.60.40.10:FF:002162', NULL, NULL, 'filamin-A isoform X10', NULL, NULL, NULL, NULL, NULL, 4),
(144580, NULL, 'G3DSA:2.30.30.40:FF:000592', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144581, NULL, 'G3DSA:1.20.1250.20:FF:001761', NULL, NULL, 'Sodium:galactoside symporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(144582, NULL, 'G3DSA:3.30.200.20:FF:002148', NULL, NULL, 'MOK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(144583, NULL, 'G3DSA:3.40.50.1820:FF:001577', NULL, NULL, 'Os07g0665801 protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(144584, NULL, 'G3DSA:1.10.238.10:FF:000209', NULL, NULL, 'Ninein like', NULL, NULL, NULL, NULL, NULL, 4),
(144585, NULL, 'G3DSA:1.20.120.1760:FF:000072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144586, NULL, 'G3DSA:1.20.1310.10:FF:000122', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144587, NULL, 'G3DSA:3.30.230.70:FF:000113', NULL, NULL, 'Exosome complex component mtr3', NULL, NULL, NULL, NULL, NULL, 4),
(144588, NULL, 'G3DSA:3.40.190.290:FF:000081', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(144589, NULL, 'G3DSA:3.20.20.220:FF:000063', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(144590, NULL, 'G3DSA:1.25.10.10:FF:002322', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144591, NULL, 'G3DSA:2.120.10.30:FF:000145', NULL, NULL, 'Low-density lipoprotein receptor-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(144592, NULL, 'G3DSA:1.10.510.10:FF:001124', NULL, NULL, 'Receptor-like serine/threonine-protein kinase SD1-6', NULL, NULL, NULL, NULL, NULL, 4),
(144593, NULL, 'G3DSA:3.10.110.10:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144594, NULL, 'G3DSA:2.60.40.10:FF:000924', NULL, NULL, 'TAP binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(144595, NULL, 'G3DSA:1.10.238.10:FF:000586', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144596, NULL, 'G3DSA:1.10.3720.10:FF:000122', NULL, NULL, 'Oligopeptide ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(144597, NULL, 'G3DSA:3.20.20.150:FF:000081', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(144598, NULL, 'G3DSA:3.10.260.30:FF:000001', NULL, NULL, 'Regulatory protein SWI6', NULL, NULL, NULL, NULL, NULL, 4),
(144599, NULL, 'G3DSA:3.30.70.330:FF:002222', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144600, NULL, 'G3DSA:1.20.1280.290:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144601, NULL, 'G3DSA:3.30.70.330:FF:001828', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144602, NULL, 'G3DSA:3.40.50.720:FF:001254', NULL, NULL, 'Alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(144603, NULL, 'G3DSA:3.90.70.80:FF:000005', NULL, NULL, 'OTU domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(144604, NULL, 'G3DSA:3.30.1330.60:FF:000044', NULL, NULL, 'Sortase system OmpA family protein PdsO', NULL, NULL, NULL, NULL, NULL, 4),
(144605, NULL, 'G3DSA:1.20.1420.30:FF:000102', NULL, NULL, 'Potassium-dependent sodium-calcium exchanger, putative', NULL, NULL, NULL, NULL, NULL, 4),
(144606, NULL, 'G3DSA:3.30.360.10:FF:000009', NULL, NULL, '4-hydroxy-tetrahydrodipicolinate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(144607, NULL, 'G3DSA:2.60.40.10:FF:002903', NULL, NULL, 'Fc receptor like 3', NULL, NULL, NULL, NULL, NULL, 4),
(144608, NULL, 'G3DSA:3.40.1140.10:FF:000001', NULL, NULL, 'Chromosome partition protein MukB', NULL, NULL, NULL, NULL, NULL, 4),
(144609, NULL, 'G3DSA:2.40.70.10:FF:000175', NULL, NULL, 'Eukaryotic aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(144610, NULL, 'G3DSA:1.10.3210.10:FF:000038', NULL, NULL, 'Cyanamide hydratase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(144611, NULL, 'G3DSA:2.60.410.10:FF:000005', NULL, NULL, 'Penicillin-binding protein 3/D-alanyl-D-alanine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(144612, NULL, 'G3DSA:1.20.1000.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144613, NULL, 'G3DSA:3.30.200.20:FF:001485', NULL, NULL, 'AGC/NDR protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(144614, NULL, 'G3DSA:2.130.10.10:FF:000902', NULL, NULL, 'Nuclear distribution protein PAC1', NULL, NULL, NULL, NULL, NULL, 4),
(144615, NULL, 'G3DSA:1.10.10.10:FF:000955', NULL, NULL, 'Heat Shock Factor', NULL, NULL, NULL, NULL, NULL, 4),
(144616, NULL, 'G3DSA:2.120.10.80:FF:000053', NULL, NULL, 'Kelch domain-containing protein 8B', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(144617, NULL, 'G3DSA:3.80.10.10:FF:003449', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144618, NULL, 'G3DSA:2.60.40.150:FF:000714', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(144619, NULL, 'G3DSA:3.40.630.30:FF:000618', NULL, NULL, 'Aminoglycoside N6''-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(144620, NULL, 'G3DSA:3.40.50.150:FF:000369', NULL, NULL, 'Leucine carboxyl methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(144621, NULL, 'G3DSA:3.30.40.10:FF:001267', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(144622, NULL, 'G3DSA:3.90.70.10:FF:000642', NULL, NULL, 'Putative calpain-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(144623, NULL, 'G3DSA:3.40.50.2300:FF:000546', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(144624, NULL, 'G3DSA:1.10.10.60:FF:000830', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144625, NULL, 'G3DSA:1.10.1070.11:FF:000016', NULL, NULL, 'PIK1p Phosphatidylinositol 4-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(144626, NULL, 'G3DSA:2.70.40.10:FF:000025', NULL, NULL, 'Deoxyuridine 5''-triphosphate nucleotidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(144627, NULL, 'G3DSA:3.40.50.300:FF:005967', NULL, NULL, 'Guanine nucleotide-binding protein (G protein), alpha-activating activity polypeptide, olfactory type', NULL, NULL, NULL, NULL, NULL, 4),
(144628, NULL, 'G3DSA:1.25.40.10:FF:000525', NULL, NULL, 'Pentatricopeptide (PPR) repeat-containing protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(144629, NULL, 'G3DSA:1.10.238.10:FF:000861', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144630, NULL, 'G3DSA:3.30.70.330:FF:002317', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144631, NULL, 'G3DSA:3.10.110.10:FF:000271', NULL, NULL, 'Ubiquitin-conjugating enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(144632, NULL, 'G3DSA:2.130.10.10:FF:000841', NULL, NULL, 'Putative CPSF (Cleavage and polyadenylation specific factor), subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(144633, NULL, 'G3DSA:3.60.20.10:FF:000005', NULL, NULL, 'Proteasome subunit beta type-2', NULL, NULL, NULL, NULL, NULL, 4),
(144634, NULL, 'G3DSA:2.60.120.290:FF:000102', NULL, NULL, 'Suppressor of lurcher protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(144635, NULL, 'G3DSA:3.90.920.10:FF:000022', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(144636, NULL, 'G3DSA:2.10.25.10:FF:001600', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144637, NULL, 'G3DSA:3.40.50.970:FF:000064', NULL, NULL, '1-deoxy-D-xylulose 5-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(144638, NULL, 'G3DSA:2.130.10.10:FF:004652', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144639, NULL, 'G3DSA:3.30.160.60:FF:004056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144640, NULL, 'G3DSA:3.40.30.10:FF:000956', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144641, NULL, 'G3DSA:3.40.50.300:FF:004770', NULL, NULL, 'Ras family protein', NULL, NULL, NULL, NULL, NULL, 4),
(144642, NULL, 'G3DSA:3.40.50.1240:FF:000217', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144643, NULL, 'G3DSA:3.40.50.300:FF:001167', NULL, NULL, 'DNA replication protein', NULL, NULL, NULL, NULL, NULL, 4),
(144644, NULL, 'G3DSA:2.60.40.10:FF:002369', NULL, NULL, 'Coiled-coil domain-containing 141', NULL, NULL, NULL, NULL, NULL, 4),
(144645, NULL, 'G3DSA:2.60.40.60:FF:000619', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144646, NULL, 'G3DSA:3.30.565.10:FF:000305', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(144647, NULL, 'G3DSA:3.40.50.300:FF:004618', NULL, NULL, 'ABC transporter B family member 9', NULL, NULL, NULL, NULL, NULL, 4),
(144648, NULL, 'G3DSA:1.20.120.420:FF:000011', NULL, NULL, 'Ribose 1,5-bisphosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(144649, NULL, 'G3DSA:3.30.70.600:FF:000004', NULL, NULL, '30S ribosomal protein S10', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(144650, NULL, 'G3DSA:4.10.320.10:FF:000013', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(144651, NULL, 'G3DSA:1.10.287.110:FF:000139', NULL, NULL, 'Chaperone protein dnaJ 20', NULL, NULL, NULL, NULL, NULL, 4),
(144652, NULL, 'G3DSA:1.25.10.10:FF:002373', NULL, NULL, 'HD protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(144653, NULL, 'G3DSA:2.60.120.260:FF:000447', NULL, NULL, 'F-box protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(144654, NULL, 'G3DSA:3.40.190.10:FF:000415', NULL, NULL, 'HTH-type transcriptional regulator ClcR', NULL, NULL, NULL, NULL, NULL, 4),
(144655, NULL, 'G3DSA:1.10.510.10:FF:002490', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(144656, NULL, 'G3DSA:3.30.40.10:FF:001997', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144657, NULL, 'G3DSA:3.90.110.10:FF:000005', NULL, NULL, 'L-lactate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(144658, NULL, 'G3DSA:3.30.160.60:FF:004735', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144659, NULL, 'G3DSA:1.10.340.30:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144660, NULL, 'G3DSA:3.30.300.30:FF:000045', NULL, NULL, 'Propionate--CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(144661, NULL, 'G3DSA:3.30.70.330:FF:001733', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144662, NULL, 'G3DSA:3.30.1520.10:FF:000050', NULL, NULL, 'Related to Protein scd2/ral3', NULL, NULL, NULL, NULL, NULL, 4),
(144663, NULL, 'G3DSA:3.40.50.300:FF:008608', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144664, NULL, 'G3DSA:3.40.50.1820:FF:001526', NULL, NULL, 'S-formylglutathione hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(144665, NULL, 'G3DSA:1.10.10.440:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144666, NULL, 'G3DSA:1.20.120.430:FF:000014', NULL, NULL, 'tRNA modification GTPase trmE', NULL, NULL, NULL, NULL, NULL, 4),
(144667, NULL, 'G3DSA:2.60.120.560:FF:000026', NULL, NULL, 'galactocerebrosidase', NULL, NULL, NULL, NULL, NULL, 4),
(144668, NULL, 'G3DSA:3.30.1490.100:FF:000025', NULL, NULL, 'Related to DNA polymerase kappa', NULL, NULL, NULL, NULL, NULL, 4),
(144669, NULL, 'G3DSA:2.130.10.10:FF:006029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144670, NULL, 'G3DSA:3.40.50.1000:FF:000376', NULL, NULL, 'Putative glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(144671, NULL, 'G3DSA:1.20.1280.290:FF:000042', NULL, NULL, 'Sugar transporter SemiSWEET', NULL, NULL, NULL, NULL, NULL, 4),
(144672, NULL, 'G3DSA:3.20.100.10:FF:000009', NULL, NULL, 'mRNA triphosphatase CET1', NULL, NULL, NULL, NULL, NULL, 4),
(144673, NULL, 'G3DSA:2.40.50.140:FF:000414', NULL, NULL, 'Single-stranded DNA-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(144674, NULL, 'G3DSA:1.20.1420.30:FF:000041', NULL, NULL, 'Na/Ca eXchangers', NULL, NULL, NULL, NULL, NULL, 4),
(144675, NULL, 'G3DSA:1.25.10.10:FF:000809', NULL, NULL, '89B helicase', NULL, NULL, NULL, NULL, NULL, 4),
(144676, NULL, 'G3DSA:1.25.40.690:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144677, NULL, 'G3DSA:2.60.40.10:FF:004674', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144678, NULL, 'G3DSA:3.30.70.330:FF:001879', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144679, NULL, 'G3DSA:1.20.1560.10:FF:000140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144680, NULL, 'G3DSA:3.40.50.300:FF:002527', NULL, NULL, 'DNA-directed DNA polymerase theta, putative', NULL, NULL, NULL, NULL, NULL, 4),
(144681, NULL, 'G3DSA:2.40.33.10:FF:000038', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(144682, NULL, 'G3DSA:3.30.420.140:FF:000002', NULL, NULL, 'Putative pre-16S rRNA nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(144683, NULL, 'G3DSA:3.30.420.150:FF:000005', NULL, NULL, 'NTPase, isoform C', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(144684, NULL, 'G3DSA:3.80.10.10:FF:002201', NULL, NULL, 'Toll-like receptor 21', NULL, NULL, NULL, NULL, NULL, 4),
(144685, NULL, 'G3DSA:2.60.40.10:FF:002583', NULL, NULL, 'CRE-UNC-22 protein', NULL, NULL, NULL, NULL, NULL, 4),
(144686, NULL, 'G3DSA:3.80.10.10:FF:001858', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144687, NULL, 'G3DSA:1.20.1070.10:FF:000344', NULL, NULL, 'Serpentine Receptor, class V', NULL, NULL, NULL, NULL, NULL, 4),
(144688, NULL, 'G3DSA:3.40.50.10190:FF:000023', NULL, NULL, 'DNA topoisomerase II binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(144689, NULL, 'G3DSA:1.10.287.110:FF:000353', NULL, NULL, 'Chaperone protein DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(144690, NULL, 'G3DSA:3.90.1150.10:FF:000501', NULL, NULL, 'Glycine cleavage system P protein', NULL, NULL, NULL, NULL, NULL, 4),
(144691, NULL, 'G3DSA:2.10.220.10:FF:000047', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 6', NULL, NULL, NULL, NULL, NULL, 4),
(144692, NULL, 'G3DSA:2.120.10.30:FF:000403', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144693, NULL, 'G3DSA:1.10.940.10:FF:000004', NULL, NULL, 'Transcription antitermination protein NusB', NULL, NULL, NULL, NULL, NULL, 4),
(144694, NULL, 'G3DSA:3.40.47.10:FF:000107', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 3', NULL, NULL, NULL, NULL, NULL, 4),
(144695, NULL, 'G3DSA:1.10.1660.10:FF:000004', NULL, NULL, 'Zn(II)-responsive transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(144696, NULL, 'G3DSA:2.60.40.10:FF:000812', NULL, NULL, 'Terribly reduced optic lobes, isoform AN', NULL, NULL, NULL, NULL, NULL, 4),
(144697, NULL, 'G3DSA:3.40.50.300:FF:005107', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(144698, NULL, 'G3DSA:1.10.10.10:FF:000904', NULL, NULL, 'RrF2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(144699, NULL, 'G3DSA:3.60.21.10:FF:000047', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(144700, NULL, 'G3DSA:3.90.930.12:FF:000008', NULL, NULL, '50S ribosomal protein L6', NULL, NULL, NULL, NULL, NULL, 4),
(144701, NULL, 'G3DSA:1.10.1070.11:FF:000067', NULL, NULL, 'AGAP003967-PA', NULL, NULL, NULL, NULL, NULL, 4),
(144702, NULL, 'G3DSA:1.10.510.10:FF:001236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144703, NULL, 'G3DSA:3.90.740.10:FF:000036', NULL, NULL, 'Isoleucyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(144704, NULL, 'G3DSA:1.20.58.70:FF:000116', NULL, NULL, 'Syntaxin', NULL, NULL, NULL, NULL, NULL, 4),
(144705, NULL, 'G3DSA:1.10.238.10:FF:000939', NULL, NULL, 'Calcium-binding EF-hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(144706, NULL, 'G3DSA:2.40.160.50:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144707, NULL, 'G3DSA:1.10.238.10:FF:000647', NULL, NULL, 'Calcium-binding protein CML38', NULL, NULL, NULL, NULL, NULL, 4),
(144708, NULL, 'G3DSA:3.40.30.10:FF:000698', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(144709, NULL, 'G3DSA:3.30.40.10:FF:001790', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144710, NULL, 'G3DSA:3.40.50.80:FF:000141', NULL, NULL, 'Ferric reduction oxidase 8, mitochondrial isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(144711, NULL, 'G3DSA:2.40.50.140:FF:000139', NULL, NULL, 'DNA ligase B', NULL, NULL, NULL, NULL, NULL, 4),
(144712, NULL, 'G3DSA:2.40.100.10:FF:000065', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase 4', NULL, NULL, NULL, NULL, NULL, 4),
(144713, NULL, 'G3DSA:1.10.10.10:FF:000629', NULL, NULL, 'Transcription factor E2F/dimerization partner', NULL, NULL, NULL, NULL, NULL, 4),
(144714, NULL, 'G3DSA:3.60.60.10:FF:000002', NULL, NULL, 'N-acylsphingosine amidohydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(144715, NULL, 'G3DSA:1.20.1070.10:FF:000232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144716, NULL, 'G3DSA:2.130.10.10:FF:004438', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(144717, NULL, 'G3DSA:2.60.120.970:FF:000059', NULL, NULL, 'Univin', NULL, NULL, NULL, NULL, NULL, 4),
(144718, NULL, 'G3DSA:1.10.540.10:FF:000075', NULL, NULL, 'Acyl-CoA dehydrogenase MmgC', NULL, NULL, NULL, NULL, NULL, 4),
(144719, NULL, 'G3DSA:2.130.10.10:FF:001976', NULL, NULL, 'Ribosome biogenesis protein ENP2', NULL, NULL, NULL, NULL, NULL, 4),
(144720, NULL, 'G3DSA:3.40.50.300:FF:003016', NULL, NULL, 'DEAH-box helicase 9', NULL, NULL, NULL, NULL, NULL, 4),
(144721, NULL, 'G3DSA:3.80.10.10:FF:001763', NULL, NULL, 'Protein toll', NULL, NULL, NULL, NULL, NULL, 4),
(144722, NULL, 'G3DSA:2.40.50.90:FF:000045', NULL, NULL, 'Putative nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(144723, NULL, 'G3DSA:3.30.1680.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144724, NULL, 'G3DSA:2.30.30.40:FF:000092', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(144725, NULL, 'G3DSA:1.10.238.10:FF:000709', NULL, NULL, 'calumenin-B', NULL, NULL, NULL, NULL, NULL, 4),
(144726, NULL, 'G3DSA:1.10.10.60:FF:000537', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(144727, NULL, 'G3DSA:3.10.20.10:FF:000024', NULL, NULL, '60S ribosomal protein L18a', NULL, NULL, NULL, NULL, NULL, 4),
(144728, NULL, 'G3DSA:1.10.8.100:FF:000031', NULL, NULL, 'Mitochondrial transcription factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(144729, NULL, 'G3DSA:3.30.1370.10:FF:000228', NULL, NULL, 'KRR1 small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4),
(144730, NULL, 'G3DSA:3.90.1150.10:FF:000440', NULL, NULL, 'Taurine--pyruvate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(144731, NULL, 'G3DSA:3.30.519.10:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144732, NULL, 'G3DSA:1.25.10.10:FF:002294', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144733, NULL, 'G3DSA:1.20.120.720:FF:000011', NULL, NULL, 'Myosin 2', NULL, NULL, NULL, NULL, NULL, 4),
(144734, NULL, 'G3DSA:2.60.40.420:FF:000121', NULL, NULL, 'At4g39830', NULL, NULL, NULL, NULL, NULL, 4),
(144735, NULL, 'G3DSA:3.30.450.20:FF:000103', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(144736, NULL, 'G3DSA:3.30.200.20:FF:002423', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144737, NULL, 'G3DSA:3.50.50.60:FF:000174', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(144738, NULL, 'G3DSA:3.30.1370.10:FF:000133', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(144739, NULL, 'G3DSA:3.30.160.40:FF:000008', NULL, NULL, 'Porphobilinogen deaminase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(144740, NULL, 'G3DSA:3.40.50.150:FF:001212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144741, NULL, 'G3DSA:2.40.30.10:FF:000357', NULL, NULL, 'Translation elongation factor EF-1 alpha/Tu, putative', NULL, NULL, NULL, NULL, NULL, 4),
(144742, NULL, 'G3DSA:3.40.50.720:FF:001754', NULL, NULL, 'Geraniol dehydrogenase GeoA', NULL, NULL, NULL, NULL, NULL, 4),
(144743, NULL, 'G3DSA:3.30.505.10:FF:000088', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(144744, NULL, 'G3DSA:2.60.40.10:FF:000863', NULL, NULL, 'immunoglobulin superfamily member 8', NULL, NULL, NULL, NULL, NULL, 4),
(144745, NULL, 'G3DSA:2.60.40.10:FF:004174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144746, NULL, 'G3DSA:3.30.40.230:FF:000005', NULL, NULL, 'Glycine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(144747, NULL, 'G3DSA:3.40.50.300:FF:006922', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144748, NULL, 'G3DSA:3.40.50.300:FF:002595', NULL, NULL, 'BMA-SPAS-1, isoform d', NULL, NULL, NULL, NULL, NULL, 4),
(144749, NULL, 'G3DSA:3.90.1300.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144750, NULL, 'G3DSA:1.25.40.10:FF:002150', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(144751, NULL, 'G3DSA:3.40.50.720:FF:001703', NULL, NULL, 'Phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(144752, NULL, 'G3DSA:1.10.510.10:FF:000865', NULL, NULL, 'ESAT-6 secretion machinery protein EssB', NULL, NULL, NULL, NULL, NULL, 4),
(144753, NULL, 'G3DSA:3.80.10.10:FF:002140', NULL, NULL, 'tropomodulin-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(144754, NULL, 'G3DSA:1.10.420.10:FF:000009', NULL, NULL, 'Ascorbate peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(144755, NULL, 'G3DSA:3.30.420.40:FF:000607', NULL, NULL, 'Chaperone protein DnaK', NULL, NULL, NULL, NULL, NULL, 4),
(144756, NULL, 'G3DSA:2.60.40.10:FF:000571', NULL, NULL, 'Neurocan core protein', NULL, NULL, NULL, NULL, NULL, 4),
(144757, NULL, 'G3DSA:1.20.120.730:FF:000014', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(144758, NULL, 'G3DSA:3.30.450.40:FF:000109', NULL, NULL, 'Stage II sporulation protein E', NULL, NULL, NULL, NULL, NULL, 4),
(144759, NULL, 'G3DSA:2.70.210.12:FF:000001', NULL, NULL, 'GTPase Obg', NULL, NULL, NULL, NULL, NULL, 4),
(144760, NULL, 'G3DSA:3.30.200.20:FF:002474', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(144761, NULL, 'G3DSA:1.10.510.10:FF:002759', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144762, NULL, 'G3DSA:1.10.472.10:FF:000293', NULL, NULL, 'Cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(144763, NULL, 'G3DSA:3.70.10.10:FF:000089', NULL, NULL, 'Mitotic and DNA damage checkpoint protein hus1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(144764, NULL, 'G3DSA:1.10.30.10:FF:000108', NULL, NULL, 'High mobility group protein-like tdp-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(144765, NULL, 'G3DSA:3.30.70.20:FF:000142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144766, NULL, 'G3DSA:2.30.29.30:FF:001327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144767, NULL, 'G3DSA:1.20.1070.10:FF:002031', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(144768, NULL, 'G3DSA:1.10.10.10:FF:001040', NULL, NULL, 'Glycine cleavage operon activator', NULL, NULL, NULL, NULL, NULL, 4),
(144769, NULL, 'G3DSA:2.130.10.10:FF:003775', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144770, NULL, 'G3DSA:2.60.40.10:FF:000245', NULL, NULL, 'protein turtle homolog B isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(144771, NULL, 'G3DSA:1.10.8.270:FF:000003', NULL, NULL, 'Ecotropic viral integration site 5', NULL, NULL, NULL, NULL, NULL, 4),
(144772, NULL, 'G3DSA:3.50.50.60:FF:000820', NULL, NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(144773, NULL, 'G3DSA:3.40.50.720:FF:001349', NULL, NULL, 'tRNA threonylcarbamoyladenosine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(144774, NULL, 'G3DSA:2.60.200.20:FF:000234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144775, NULL, 'G3DSA:3.30.1120.10:FF:000036', NULL, NULL, 'Arylsulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(144776, NULL, 'G3DSA:2.60.120.650:FF:000227', NULL, NULL, 'Bifunctional lysine-specific demethylase and histidyl-hydroxylase NO66', NULL, NULL, NULL, NULL, NULL, 4),
(144777, NULL, 'G3DSA:1.20.1070.10:FF:001693', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(144778, NULL, 'G3DSA:1.10.30.10:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144779, NULL, 'G3DSA:3.30.70.330:FF:000631', NULL, NULL, 'Glycine-rich RNA-binding protein 3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(144780, NULL, 'G3DSA:3.30.70.270:FF:000091', NULL, NULL, 'DNA repair protein REV1', NULL, NULL, NULL, NULL, NULL, 4),
(144781, NULL, 'G3DSA:1.20.1080.10:FF:000058', NULL, NULL, 'Probable aquaporin SIP2-1', NULL, NULL, NULL, NULL, NULL, 4),
(144782, NULL, 'G3DSA:3.30.50.10:FF:000104', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(144783, NULL, 'G3DSA:3.30.160.60:FF:004623', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144784, NULL, 'G3DSA:1.20.1250.40:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144785, NULL, 'G3DSA:3.40.1090.10:FF:000019', NULL, NULL, 'Patatin-like phospholipase domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(144786, NULL, 'G3DSA:1.10.510.10:FF:000247', NULL, NULL, 'Myosin IIIA', NULL, NULL, NULL, NULL, NULL, 4),
(144787, NULL, 'G3DSA:3.90.70.10:FF:000384', NULL, NULL, 'Cathepsin La', NULL, NULL, NULL, NULL, NULL, 4),
(144788, NULL, 'G3DSA:1.20.120.980:FF:000044', NULL, NULL, 'Prolylcarboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(144789, NULL, 'G3DSA:2.40.50.180:FF:000011', NULL, NULL, 'Putative chemotaxis protein CheV', NULL, NULL, NULL, NULL, NULL, 4),
(144790, NULL, 'G3DSA:3.90.640.10:FF:000040', NULL, NULL, 'Actin-like protein ARP6', NULL, NULL, NULL, NULL, NULL, 4),
(144791, NULL, 'G3DSA:1.10.472.10:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144792, NULL, 'G3DSA:1.10.20.10:FF:000170', NULL, NULL, 'Histone H2A', NULL, NULL, NULL, NULL, NULL, 4),
(144793, NULL, 'G3DSA:1.10.287.770:FF:000022', NULL, NULL, 'CD3 antigen delta polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(144794, NULL, 'G3DSA:1.25.40.10:FF:004274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144795, NULL, 'G3DSA:3.40.50.1820:FF:001638', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144796, NULL, 'G3DSA:2.60.40.10:FF:004786', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144797, NULL, 'G3DSA:3.40.50.10110:FF:000005', NULL, NULL, 'DNA polymerase III chi subunit', NULL, NULL, NULL, NULL, NULL, 4),
(144798, NULL, 'G3DSA:1.25.40.10:FF:000351', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(144799, NULL, 'G3DSA:2.40.70.10:FF:000528', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144800, NULL, 'G3DSA:3.40.309.10:FF:000034', NULL, NULL, 'Aldehyde dehydrogenase, dimeric NADP-preferring', NULL, NULL, NULL, NULL, NULL, 4),
(144801, NULL, 'G3DSA:3.30.559.30:FF:000078', NULL, NULL, 'MFS transporter/NRPS-like enzyme, putative (JCVI)', NULL, NULL, NULL, NULL, NULL, 4),
(144802, NULL, 'G3DSA:3.80.10.10:FF:003275', NULL, NULL, 'Toll-like receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(144803, NULL, 'G3DSA:2.60.34.10:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144804, NULL, 'G3DSA:1.25.40.20:FF:000354', NULL, NULL, 'Leucine-rich repeat kinase, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(144805, NULL, 'G3DSA:3.80.10.10:FF:000869', NULL, NULL, 'Leucine-rich repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(144806, NULL, 'G3DSA:3.30.40.10:FF:000311', NULL, NULL, 'E3 ubiquitin-protein ligase SINAT5-like', NULL, NULL, NULL, NULL, NULL, 4),
(144807, NULL, 'G3DSA:3.40.50.460:FF:000001', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(144808, NULL, 'G3DSA:3.40.50.1580:FF:000010', NULL, NULL, 'Purine nucleoside phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(144809, NULL, 'G3DSA:1.25.40.1050:FF:000003', NULL, NULL, '5''-3'' exoribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(144810, NULL, 'G3DSA:1.25.40.10:FF:000963', NULL, NULL, 'Programmed cell death protein pre-rrna processing protein rrp5', NULL, NULL, NULL, NULL, NULL, 4),
(144811, NULL, 'G3DSA:3.30.1550.10:FF:000001', NULL, NULL, '50S ribosomal protein L11', NULL, NULL, NULL, NULL, NULL, 4),
(144812, NULL, 'G3DSA:3.40.50.300:FF:004118', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(144813, NULL, 'G3DSA:1.10.510.10:FF:003041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144814, NULL, 'G3DSA:3.40.50.300:FF:006782', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144815, NULL, 'G3DSA:1.25.40.20:FF:000966', NULL, NULL, 'Putative calmodulin-binding transcription activator', NULL, NULL, NULL, NULL, NULL, 4),
(144816, NULL, 'G3DSA:3.80.10.10:FF:001358', NULL, NULL, 'Receptor like protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(144817, NULL, 'G3DSA:3.40.50.880:FF:000037', NULL, NULL, 'DJ-1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(144818, NULL, 'G3DSA:3.40.140.10:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(144819, NULL, 'G3DSA:3.40.50.620:FF:000414', NULL, NULL, 'Isoleucine--tRNA ligase, cytoplasmic-like', NULL, NULL, NULL, NULL, NULL, 4),
(144820, NULL, 'G3DSA:1.25.40.10:FF:004566', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144821, NULL, 'G3DSA:3.30.160.60:FF:006422', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144822, NULL, 'G3DSA:3.10.20.90:FF:000913', NULL, NULL, 'Serine/threonine-protein kinase phg2', NULL, NULL, NULL, NULL, NULL, 4),
(144823, NULL, 'G3DSA:1.20.20.10:FF:000028', NULL, NULL, 'ATP synthase subunit c', NULL, NULL, NULL, NULL, NULL, 4),
(144824, NULL, 'G3DSA:1.20.1250.20:FF:001968', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144825, NULL, 'G3DSA:3.10.250.10:FF:000129', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144826, NULL, 'G3DSA:3.90.76.10:FF:000037', NULL, NULL, 'ABC transporter substrate-binding protein-oligopeptide transport', NULL, NULL, NULL, NULL, NULL, 4),
(144827, NULL, 'G3DSA:3.30.160.60:FF:003600', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144828, NULL, 'G3DSA:4.10.410.40:FF:000001', NULL, NULL, 'Phage major tail protein', NULL, NULL, NULL, NULL, NULL, 4),
(144829, NULL, 'G3DSA:2.130.10.10:FF:004590', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144830, NULL, 'G3DSA:3.90.1150.10:FF:000114', NULL, NULL, 'Serine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(144831, NULL, 'G3DSA:3.40.50.150:FF:000195', NULL, NULL, 'Methyltransferase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(144832, NULL, 'G3DSA:1.10.3720.10:FF:000234', NULL, NULL, 'Phosphonate ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(144833, NULL, 'G3DSA:3.40.50.280:FF:000003', NULL, NULL, 'Dimethylamine methyltransferase corrinoid protein', NULL, NULL, NULL, NULL, NULL, 4),
(144834, NULL, 'G3DSA:3.30.830.10:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144835, NULL, 'G3DSA:2.60.120.200:FF:000115', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(144836, NULL, 'G3DSA:2.60.120.260:FF:000094', NULL, NULL, 'Cyclic di-GMP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(144837, NULL, 'G3DSA:1.25.40.20:FF:001129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144838, NULL, 'G3DSA:2.60.40.150:FF:000602', NULL, NULL, 'Si:rp71-17i16.5', NULL, NULL, NULL, NULL, NULL, 4),
(144839, NULL, 'G3DSA:3.70.10.10:FF:000038', NULL, NULL, 'DNA polymerase sliding clamp 1', NULL, NULL, NULL, NULL, NULL, 4),
(144840, NULL, 'G3DSA:3.40.50.300:FF:008367', NULL, NULL, 'GTPase Era', NULL, NULL, NULL, NULL, NULL, 4),
(144841, NULL, 'G3DSA:3.40.640.10:FF:000326', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144842, NULL, 'G3DSA:1.20.1050.10:FF:000023', NULL, NULL, 'Probable glutathione S-transferase GSTU6', NULL, NULL, NULL, NULL, NULL, 4),
(144843, NULL, 'G3DSA:3.30.160.60:FF:004348', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144844, NULL, 'G3DSA:3.30.40.10:FF:000362', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM56', NULL, NULL, NULL, NULL, NULL, 4),
(144845, NULL, 'G3DSA:3.40.50.1580:FF:000061', NULL, NULL, 'Purine nucleoside phosphorylase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(144846, NULL, 'G3DSA:3.40.50.11710:FF:000002', NULL, NULL, 'Cyclo(L-tyrosyl-L-tyrosyl) synthase', NULL, NULL, NULL, NULL, NULL, 4),
(144847, NULL, 'G3DSA:3.40.50.200:FF:000199', NULL, NULL, 'Peptidase S8 and S53 subtilisin kexin sedolisin', NULL, NULL, NULL, NULL, NULL, 4),
(144848, NULL, 'G3DSA:3.40.50.300:FF:007884', NULL, NULL, 'Uncharacterized protein ABCC16', NULL, NULL, NULL, NULL, NULL, 4),
(144849, NULL, 'G3DSA:3.90.550.50:FF:000045', NULL, NULL, 'Glycoprotein-N-acetylgalactosamine 3-beta-galactosyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(144850, NULL, 'G3DSA:2.40.50.140:FF:000061', NULL, NULL, 'ATP-dependent RNA helicase DHX8', NULL, NULL, NULL, NULL, NULL, 4),
(144851, NULL, 'G3DSA:3.40.50.200:FF:000148', NULL, NULL, 'Tripeptidyl peptidase I', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(144852, NULL, 'G3DSA:3.40.50.1100:FF:000029', NULL, NULL, 'Cysteine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(144853, NULL, 'G3DSA:3.40.50.1240:FF:000043', NULL, NULL, 'Phosphoglycerate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(144854, NULL, 'G3DSA:1.25.40.10:FF:000637', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(144855, NULL, 'G3DSA:3.30.428.10:FF:000009', NULL, NULL, 'Galactose-1-phosphate uridylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(144856, NULL, 'G3DSA:1.25.40.20:FF:000915', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144857, NULL, 'G3DSA:3.40.50.150:FF:000318', NULL, NULL, 'tRNA (adenine(58)-N(1))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(144858, NULL, 'G3DSA:3.30.160.60:FF:002139', NULL, NULL, 'Zinc finger protein 655', NULL, NULL, NULL, NULL, NULL, 4),
(144859, NULL, 'G3DSA:2.60.120.10:FF:000697', NULL, NULL, 'Acireductone dioxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(144860, NULL, 'G3DSA:3.30.70.1660:FF:000008', NULL, NULL, 'Peptide chain release factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(144861, NULL, 'G3DSA:3.40.225.10:FF:000002', NULL, NULL, 'alpha-adducin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(144862, NULL, 'G3DSA:3.40.630.10:FF:000500', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(144863, NULL, 'G3DSA:2.120.10.80:FF:000345', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144864, NULL, 'G3DSA:1.20.5.190:FF:000084', NULL, NULL, 'Abnormal spindle microtubule assembly', NULL, NULL, NULL, NULL, NULL, 4),
(144865, NULL, 'G3DSA:1.10.10.10:FF:000551', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(144866, NULL, 'G3DSA:1.20.5.170:FF:000105', NULL, NULL, 'AP-1-like transcription factor YAP4', NULL, NULL, NULL, NULL, NULL, 4),
(144867, NULL, 'G3DSA:1.10.287.630:FF:000008', NULL, NULL, 'Cyclic nucleotide-gated ion channel 11', NULL, NULL, NULL, NULL, NULL, 4),
(144868, NULL, 'G3DSA:3.50.50.60:FF:000202', NULL, NULL, 'Sarcosine dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(144869, NULL, 'G3DSA:2.170.140.10:FF:000031', NULL, NULL, 'Chitinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(144870, NULL, 'G3DSA:3.40.50.300:FF:002853', NULL, NULL, 'Protein-tyrosine sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(144871, NULL, 'G3DSA:2.40.160.110:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144872, NULL, 'G3DSA:2.170.270.10:FF:000035', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(144873, NULL, 'G3DSA:1.10.620.20:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144874, NULL, 'G3DSA:2.130.10.10:FF:002853', NULL, NULL, 'Nuclear pore protein seh1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(144875, NULL, 'G3DSA:2.130.10.10:FF:000548', NULL, NULL, 'Protein TRANSPARENT TESTA GLABRA 1', NULL, NULL, NULL, NULL, NULL, 4),
(144876, NULL, 'G3DSA:1.25.10.10:FF:003311', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(144877, NULL, 'G3DSA:2.40.170.20:FF:000016', NULL, NULL, 'Iron-regulated outer membrane virulence protein', NULL, NULL, NULL, NULL, NULL, 4),
(144878, NULL, 'G3DSA:3.30.1360.200:FF:000010', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(144879, NULL, 'G3DSA:1.10.730.10:FF:000112', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(144880, NULL, 'G3DSA:3.30.70.330:FF:000923', NULL, NULL, 'RNA-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(144881, NULL, 'G3DSA:1.20.1070.10:FF:001367', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144882, NULL, 'G3DSA:3.90.1140.10:FF:000057', NULL, NULL, '2'',3''-cyclic-nucleotide 3''-phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(144883, NULL, 'G3DSA:3.80.10.10:FF:000223', NULL, NULL, 'Leucine-rich repeat-containing 8 VRAC subunit A', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(144884, NULL, 'G3DSA:3.30.160.60:FF:006473', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144885, NULL, 'G3DSA:3.40.50.300:FF:004444', NULL, NULL, 'Cytoplasmic dynein 1b light intermediate chain, D1bLIC', NULL, NULL, NULL, NULL, NULL, 4),
(144886, NULL, 'G3DSA:2.40.160.120:FF:000025', NULL, NULL, 'Oxysterol-binding protein/PH domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(144887, NULL, 'G3DSA:3.40.50.1820:FF:001077', NULL, NULL, 'Acylamino-acid-releasing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(144888, NULL, 'G3DSA:3.40.50.300:FF:008160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144889, NULL, 'G3DSA:2.40.30.10:FF:000178', NULL, NULL, 'Elongation factor Tu homologue', NULL, NULL, NULL, NULL, NULL, 4),
(144890, NULL, 'G3DSA:3.40.50.720:FF:002243', NULL, NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase NAD-binding', NULL, NULL, NULL, NULL, NULL, 4),
(144891, NULL, 'G3DSA:1.25.40.10:FF:000912', NULL, NULL, 'Pentatricopeptide repeat protein PPR986-12', NULL, NULL, NULL, NULL, NULL, 4),
(144892, NULL, 'G3DSA:2.10.110.10:FF:000106', NULL, NULL, 'F-actin-monooxygenase MICAL1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(144893, NULL, 'G3DSA:3.30.1360.210:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144894, NULL, 'G3DSA:3.30.160.60:FF:004909', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144895, NULL, 'G3DSA:2.30.29.220:FF:000002', NULL, NULL, 'FACT complex subunit SSRP1', NULL, NULL, NULL, NULL, NULL, 4),
(144896, NULL, 'G3DSA:3.80.10.10:FF:001684', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(144897, NULL, 'G3DSA:1.25.10.10:FF:002822', NULL, NULL, 'Protein HEATR9', NULL, NULL, NULL, NULL, NULL, 4),
(144898, NULL, 'G3DSA:3.50.50.60:FF:000253', NULL, NULL, 'NAD(P)H-dependent glutamate synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(144899, NULL, 'G3DSA:2.10.110.10:FF:000252', NULL, NULL, 'Ci-Fhl1/2/3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(144900, NULL, 'G3DSA:1.10.510.10:FF:002198', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144901, NULL, 'G3DSA:1.20.1160.11:FF:000009', NULL, NULL, 'F3I6.18 protein', NULL, NULL, NULL, NULL, NULL, 4),
(144902, NULL, 'G3DSA:3.40.1410.10:FF:000011', NULL, NULL, 'Phosphonate metabolism transcriptional regulator PhnF', NULL, NULL, NULL, NULL, NULL, 4),
(144903, NULL, 'G3DSA:3.40.390.10:FF:000222', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144904, NULL, 'G3DSA:3.30.70.330:FF:000305', NULL, NULL, 'speckle targeted PIP5K1A-regulated poly(A) polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(144905, NULL, 'G3DSA:3.10.20.90:FF:000655', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144906, NULL, 'G3DSA:3.10.450.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144907, NULL, 'G3DSA:1.10.510.10:FF:000573', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(144908, NULL, 'G3DSA:1.20.1070.10:FF:001772', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144909, NULL, 'G3DSA:2.30.30.40:FF:000327', NULL, NULL, 'CIN85 and CD2AP related, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(144910, NULL, 'G3DSA:3.30.160.60:FF:002757', NULL, NULL, 'Zinc finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(144911, NULL, 'G3DSA:3.30.160.60:FF:006068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144912, NULL, 'G3DSA:3.40.50.150:FF:000936', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144913, NULL, 'G3DSA:1.20.1310.10:FF:000234', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144914, NULL, 'G3DSA:3.30.70.270:FF:000040', NULL, NULL, 'DNA repair protein REV1', NULL, NULL, NULL, NULL, NULL, 4),
(144915, NULL, 'G3DSA:3.55.50.30:FF:000008', NULL, NULL, 'Putative anti-sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(144916, NULL, 'G3DSA:1.20.58.60:FF:000113', NULL, NULL, 'A-kinase anchor protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(144917, NULL, 'G3DSA:2.30.29.240:FF:000008', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(144918, NULL, 'G3DSA:3.40.50.1820:FF:000503', NULL, NULL, 'Alpha/beta fold hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(144919, NULL, 'G3DSA:2.30.29.230:FF:000005', NULL, NULL, 'RabGAP/TBC domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(144920, NULL, 'G3DSA:3.40.50.920:FF:000010', NULL, NULL, 'Pyruvate ferredoxin oxidoreductase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(144921, NULL, 'G3DSA:1.25.10.10:FF:000574', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(144922, NULL, 'G3DSA:2.40.50.100:FF:000189', NULL, NULL, 'Probable cation efflux system (CzcB-like)', NULL, NULL, NULL, NULL, NULL, 4),
(144923, NULL, 'G3DSA:3.40.630.30:FF:000686', NULL, NULL, 'Putative acyl-CoA N-acyltransferase (NAT) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(144924, NULL, 'G3DSA:3.10.129.10:FF:000212', NULL, NULL, 'Acyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(144925, NULL, 'G3DSA:1.20.5.470:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144926, NULL, 'G3DSA:2.60.40.790:FF:000092', NULL, NULL, 'SHQ1 isoform 5', NULL, NULL, NULL, NULL, NULL, 4),
(144927, NULL, 'G3DSA:3.40.630.10:FF:000051', NULL, NULL, 'Peptidase M28', NULL, NULL, NULL, NULL, NULL, 4),
(144928, NULL, 'G3DSA:1.10.10.60:FF:000425', NULL, NULL, 'Homeobox and leucine zipper encoding a', NULL, NULL, NULL, NULL, NULL, 4),
(144929, NULL, 'G3DSA:1.10.150.240:FF:000055', NULL, NULL, 'HAD hydrolase, family IA', NULL, NULL, NULL, NULL, NULL, 4),
(144930, NULL, 'G3DSA:3.90.226.10:FF:000353', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144931, NULL, 'G3DSA:3.90.120.10:FF:000012', NULL, NULL, 'Probable BsuMI modification methylase subunit YdiO', NULL, NULL, NULL, NULL, NULL, 4),
(144932, NULL, 'G3DSA:2.60.40.10:FF:001352', NULL, NULL, 'MAM domain containing glycosylphosphatidylinositol anchor 1', NULL, NULL, NULL, NULL, NULL, 4),
(144933, NULL, 'G3DSA:1.25.40.840:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144934, NULL, 'G3DSA:3.60.40.10:FF:000299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144935, NULL, 'G3DSA:2.60.40.1180:FF:000184', NULL, NULL, 'Alpha-amylase', NULL, NULL, NULL, NULL, NULL, 4),
(144936, NULL, 'G3DSA:1.10.510.10:FF:000753', NULL, NULL, 'CAMK/CAMKL protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(144937, NULL, 'G3DSA:2.60.120.40:FF:000065', NULL, NULL, 'Myeloid-specific peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(144938, NULL, 'G3DSA:2.160.20.60:FF:000012', NULL, NULL, 'Ferredoxin-glutamate synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(144939, NULL, 'G3DSA:2.60.120.10:FF:000646', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144940, NULL, 'G3DSA:1.25.10.10:FF:002760', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144941, NULL, 'G3DSA:3.30.1330.40:FF:000004', NULL, NULL, 'Translation initiation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(144942, NULL, 'G3DSA:3.40.640.10:FF:000118', NULL, NULL, 'Acetylornithine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(144943, NULL, 'G3DSA:4.10.800.10:FF:000027', NULL, NULL, 'Thyroglobulin', NULL, NULL, NULL, NULL, NULL, 4),
(144944, NULL, 'G3DSA:2.120.10.80:FF:000019', NULL, NULL, 'Kelch-like family member 17', NULL, NULL, NULL, NULL, NULL, 4),
(144945, NULL, 'G3DSA:1.25.40.20:FF:000562', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(144946, NULL, 'G3DSA:3.40.225.10:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144947, NULL, 'G3DSA:3.10.20.90:FF:000981', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144948, NULL, 'G3DSA:2.130.10.10:FF:000341', NULL, NULL, 'WD repeat-containing protein 81 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(144949, NULL, 'G3DSA:2.60.40.10:FF:004056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144950, NULL, 'G3DSA:3.30.1300.10:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(144951, NULL, 'G3DSA:2.60.40.10:FF:000784', NULL, NULL, 'Striated muscle preferentially expressed protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(144952, NULL, 'G3DSA:3.30.230.10:FF:000005', NULL, NULL, 'DNA gyrase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(144953, NULL, 'G3DSA:3.90.190.20:FF:000047', NULL, NULL, 'Folyl-polyglutamate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(144954, NULL, 'G3DSA:3.40.50.10860:FF:000056', NULL, NULL, 'Bifunctional protein FolD', NULL, NULL, NULL, NULL, NULL, 4),
(144955, NULL, 'G3DSA:3.40.50.12780:FF:000002', NULL, NULL, 'Disco interacting protein 2 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(144956, NULL, 'G3DSA:2.130.10.10:FF:001330', NULL, NULL, 'Protein CYPRO4', NULL, NULL, NULL, NULL, NULL, 4),
(144957, NULL, 'G3DSA:3.50.7.10:FF:000050', NULL, NULL, 'Bardet-Biedl syndrome 12', NULL, NULL, NULL, NULL, NULL, 4),
(144958, NULL, 'G3DSA:3.30.200.20:FF:000411', NULL, NULL, 'Pti1 kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(144959, NULL, 'G3DSA:1.10.274.100:FF:000020', NULL, NULL, 'DNA-directed RNA polymerase subunit beta''', NULL, NULL, NULL, NULL, NULL, 4),
(144960, NULL, 'G3DSA:3.40.5.60:FF:000003', NULL, NULL, 'DNA replication complex GINS protein SLD5', NULL, NULL, NULL, NULL, NULL, 4),
(144961, NULL, 'G3DSA:3.30.420.40:FF:000675', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(144962, NULL, 'G3DSA:1.20.58.1380:FF:000011', NULL, NULL, 'Npp-15', NULL, NULL, NULL, NULL, NULL, 4),
(144963, NULL, 'G3DSA:3.40.50.720:FF:001815', NULL, NULL, 'Lovastatin diketide synthase LovF', NULL, NULL, NULL, NULL, NULL, 4),
(144964, NULL, 'G3DSA:2.60.40.10:FF:000745', NULL, NULL, 'Myomesin 3', NULL, NULL, NULL, NULL, NULL, 4),
(144965, NULL, 'G3DSA:3.30.70.330:FF:002840', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144966, NULL, 'G3DSA:2.160.10.10:FF:000070', NULL, NULL, 'UDP-N-acetylbacillosamine N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(144967, NULL, 'G3DSA:3.80.10.10:FF:001297', NULL, NULL, 'Uncharacterized protein AT4g34280', NULL, NULL, NULL, NULL, NULL, 4),
(144968, NULL, 'G3DSA:3.40.50.150:FF:001330', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144969, NULL, 'G3DSA:3.10.120.10:FF:000013', NULL, NULL, 'Neudesin', NULL, NULL, NULL, NULL, NULL, 4),
(144970, NULL, 'G3DSA:3.90.190.10:FF:000044', NULL, NULL, 'Dual specificity protein phosphatase 8', NULL, NULL, NULL, NULL, NULL, 4),
(144971, NULL, 'G3DSA:3.30.60.20:FF:000085', NULL, NULL, 'Rap Guanine nucleotide Exchange Factor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(144972, NULL, 'G3DSA:2.130.10.10:FF:002465', NULL, NULL, 'Os03g0735100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(144973, NULL, 'G3DSA:3.40.50.720:FF:001872', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144974, NULL, 'G3DSA:2.40.10.10:FF:000345', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144975, NULL, 'G3DSA:1.10.455.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144976, NULL, 'G3DSA:2.40.10.10:FF:000295', NULL, NULL, 'Inactive serine protease PAMR1', NULL, NULL, NULL, NULL, NULL, 4),
(144977, NULL, 'G3DSA:1.10.10.10:FF:000517', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144978, NULL, 'G3DSA:3.40.50.2020:FF:000182', NULL, NULL, 'Ribose-phosphate pyrophosphokinase 2 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(144979, NULL, 'G3DSA:2.130.10.10:FF:002527', NULL, NULL, 'Putative SecA-type chloroplast protein transport factor', NULL, NULL, NULL, NULL, NULL, 4),
(144980, NULL, 'G3DSA:3.40.50.1820:FF:001818', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144981, NULL, 'G3DSA:2.130.10.10:FF:004556', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144982, NULL, 'G3DSA:2.10.25.10:FF:000026', NULL, NULL, 'Teneurin transmembrane protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(144983, NULL, 'G3DSA:1.20.5.490:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144984, NULL, 'G3DSA:3.30.60.30:FF:000088', NULL, NULL, 'Protein CBG17314', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(144985, NULL, 'G3DSA:1.10.10.160:FF:000041', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(144986, NULL, 'G3DSA:2.60.260.20:FF:000131', NULL, NULL, 'Chaperone protein DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(144987, NULL, 'G3DSA:3.30.160.60:FF:004505', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144988, NULL, 'G3DSA:2.60.120.10:FF:000489', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144989, NULL, 'G3DSA:1.20.1510.10:FF:000042', NULL, NULL, 'Metal tolerance protein B', NULL, NULL, NULL, NULL, NULL, 4),
(144990, NULL, 'G3DSA:1.25.10.10:FF:002081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144991, NULL, 'G3DSA:1.10.510.10:FF:004384', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(144992, NULL, 'G3DSA:3.50.50.60:FF:001484', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(144993, NULL, 'G3DSA:1.25.10.10:FF:000523', NULL, NULL, 'Protein phosphatase PP2A regulatory subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(144994, NULL, 'G3DSA:3.50.30.30:FF:000097', NULL, NULL, 'Vacuolar sorting receptor', NULL, NULL, NULL, NULL, NULL, 4),
(144995, NULL, 'G3DSA:3.30.70.330:FF:000811', NULL, NULL, 'Os07g0663300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(144996, NULL, 'G3DSA:2.10.110.10:FF:000044', NULL, NULL, 'Rho GTPase activator Rga', NULL, NULL, NULL, NULL, NULL, 4),
(144997, NULL, 'G3DSA:3.30.160.60:FF:002471', NULL, NULL, 'Zinc finger protein 311', NULL, NULL, NULL, NULL, NULL, 4),
(144998, NULL, 'G3DSA:2.130.10.10:FF:000436', NULL, NULL, 'Regulator of MON1-CCZ1 complex', NULL, NULL, NULL, NULL, NULL, 4),
(144999, NULL, 'G3DSA:3.30.450.40:FF:000227', NULL, NULL, 'PAS domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(145000, NULL, 'G3DSA:3.30.505.10:FF:000268', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145001, NULL, 'G3DSA:1.25.40.10:FF:002357', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(145002, NULL, 'G3DSA:1.10.220.10:FF:000034', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(145003, NULL, 'G3DSA:3.90.950.10:FF:000024', NULL, NULL, 'dITP/XTP pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(145004, NULL, 'G3DSA:1.10.10.60:FF:000330', NULL, NULL, 'LIM homeobox transcription factor 1 alpha', NULL, NULL, NULL, NULL, NULL, 4),
(145005, NULL, 'G3DSA:2.60.40.10:FF:006085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145006, NULL, 'G3DSA:3.40.50.2300:FF:001356', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145007, NULL, 'G3DSA:2.30.30.40:FF:000653', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145008, NULL, 'G3DSA:3.30.1360.40:FF:000040', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(145009, NULL, 'G3DSA:2.30.42.10:FF:000150', NULL, NULL, 'Membrane associated guanylate kinase, WW and PDZ domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(145010, NULL, 'G3DSA:3.30.1320.10:FF:000017', NULL, NULL, '30S ribosomal protein S16-1, chloroplastic isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(145011, NULL, 'G3DSA:3.40.50.12350:FF:000014', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(145012, NULL, 'G3DSA:1.25.40.820:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145013, NULL, 'G3DSA:1.20.58.390:FF:000087', NULL, NULL, 'GABA-gated ion channel', NULL, NULL, NULL, NULL, NULL, 4),
(145014, NULL, 'G3DSA:1.50.10.130:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145015, NULL, 'G3DSA:2.40.70.10:FF:000354', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145016, NULL, 'G3DSA:3.40.50.150:FF:000756', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145017, NULL, 'G3DSA:3.30.420.40:FF:000046', NULL, NULL, 'Chaperone protein HscA', NULL, NULL, NULL, NULL, NULL, 4),
(145018, NULL, 'G3DSA:3.30.160.60:FF:004174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145019, NULL, 'G3DSA:3.40.50.620:FF:000240', NULL, NULL, 'Methionine--tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(145020, NULL, 'G3DSA:3.30.70.980:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145021, NULL, 'G3DSA:3.30.2130.30:FF:000020', NULL, NULL, 'RNA-binding protein, containing THUMP domain', NULL, NULL, NULL, NULL, NULL, 4),
(145022, NULL, 'G3DSA:3.40.50.150:FF:000436', NULL, NULL, 'Thiopurine S-methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(145023, NULL, 'G3DSA:2.60.40.150:FF:000653', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(145024, NULL, 'G3DSA:2.60.40.10:FF:000458', NULL, NULL, 'Molecular chaperone FimC', NULL, NULL, NULL, NULL, NULL, 4),
(145025, NULL, 'G3DSA:3.90.190.10:FF:000578', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(145026, NULL, 'G3DSA:3.30.497.10:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145027, NULL, 'G3DSA:3.30.1330.50:FF:000007', NULL, NULL, '2-C-methyl-D-erythritol 2,4-cyclodiphosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(145028, NULL, 'G3DSA:2.160.20.70:FF:000015', NULL, NULL, 'BnaA04g27540D protein', NULL, NULL, NULL, NULL, NULL, 4),
(145029, NULL, 'G3DSA:2.40.50.120:FF:000015', NULL, NULL, 'Procollagen C-endopeptidase enhancer 2', NULL, NULL, NULL, NULL, NULL, 4),
(145030, NULL, 'G3DSA:3.40.190.10:FF:000870', NULL, NULL, 'Glutamine-binding periplasmic protein/glutamine transport system permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(145031, NULL, 'G3DSA:2.130.10.10:FF:004764', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145032, NULL, 'G3DSA:1.20.1070.10:FF:001480', NULL, NULL, 'AGAP008237-PA', NULL, NULL, NULL, NULL, NULL, 4),
(145033, NULL, 'G3DSA:2.40.37.20:FF:000005', NULL, NULL, 'Uncharacterized protein MT1457', NULL, NULL, NULL, NULL, NULL, 4),
(145034, NULL, 'G3DSA:1.20.1250.20:FF:001676', NULL, NULL, 'Deoxyribose-phosphate aldolase, putative (AFU_orthologue AFUA_3G06590)', NULL, NULL, NULL, NULL, NULL, 4),
(145035, NULL, 'G3DSA:3.30.70.330:FF:001946', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145036, NULL, 'G3DSA:2.10.25.10:FF:001813', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145037, NULL, 'G3DSA:3.40.50.720:FF:000444', NULL, NULL, 'L-idonate 5-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(145038, NULL, 'G3DSA:3.40.50.2300:FF:000900', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145039, NULL, 'G3DSA:1.10.357.140:FF:000030', NULL, NULL, 'Digeranylgeranylglyceryl phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(145040, NULL, 'G3DSA:3.40.50.2000:FF:000024', NULL, NULL, 'Trehalose-6-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(145041, NULL, 'G3DSA:1.10.472.130:FF:000051', NULL, NULL, 'Dynein heavy chain 5, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(145042, NULL, 'G3DSA:3.30.230.10:FF:000062', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(145043, NULL, 'G3DSA:3.30.70.330:FF:002104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145044, NULL, 'G3DSA:3.30.830.10:FF:000259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145045, NULL, 'G3DSA:1.25.10.10:FF:000248', NULL, NULL, 'MAP3K epsilon protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(145046, NULL, 'G3DSA:3.40.50.300:FF:001521', NULL, NULL, 'Iron-sulfur cluster carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(145047, NULL, 'G3DSA:3.30.160.60:FF:000958', NULL, NULL, 'Odd skipped', NULL, NULL, NULL, NULL, NULL, 4),
(145048, NULL, 'G3DSA:2.160.20.10:FF:000312', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145049, NULL, 'G3DSA:3.40.50.10490:FF:000023', NULL, NULL, 'Glucose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(145050, NULL, 'G3DSA:1.10.1070.11:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145051, NULL, 'G3DSA:3.40.640.10:FF:000231', NULL, NULL, 'Aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(145052, NULL, 'G3DSA:1.20.140.150:FF:000131', NULL, NULL, 'Transmembrane protein 114', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(145053, NULL, 'G3DSA:3.30.160.60:FF:004269', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145054, NULL, 'G3DSA:3.90.550.50:FF:000084', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(145055, NULL, 'G3DSA:1.10.472.10:FF:000124', NULL, NULL, 'Cyclin homologue', NULL, NULL, NULL, NULL, NULL, 4),
(145056, NULL, 'G3DSA:1.10.418.10:FF:000246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145057, NULL, 'G3DSA:3.40.50.1000:FF:000651', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145058, NULL, 'G3DSA:1.20.1270.20:FF:000003', NULL, NULL, 'Hydroxylamine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(145059, NULL, 'G3DSA:1.10.10.570:FF:000012', NULL, NULL, 'AaceriAGL318Wp', NULL, NULL, NULL, NULL, NULL, 4),
(145060, NULL, 'G3DSA:3.30.40.10:FF:001379', NULL, NULL, 'GM26809', NULL, NULL, NULL, NULL, NULL, 4),
(145061, NULL, 'G3DSA:1.10.418.10:FF:000066', NULL, NULL, 'plastin-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(145062, NULL, 'G3DSA:3.60.15.10:FF:000201', NULL, NULL, 'CPSF3L protein', NULL, NULL, NULL, NULL, NULL, 4),
(145063, NULL, 'G3DSA:1.10.10.10:FF:000837', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(145064, NULL, 'G3DSA:2.120.10.80:FF:000171', NULL, NULL, 'F-box/kelch-repeat protein At1g51550', NULL, NULL, NULL, NULL, NULL, 4),
(145065, NULL, 'G3DSA:1.10.10.10:FF:000725', NULL, NULL, 'DNA repair protein Nse1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(145066, NULL, 'G3DSA:2.40.37.10:FF:000002', NULL, NULL, 'Alanine racemase', NULL, NULL, NULL, NULL, NULL, 4),
(145067, NULL, 'G3DSA:2.30.33.40:FF:000008', NULL, NULL, '10 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(145068, NULL, 'G3DSA:3.80.10.10:FF:003269', NULL, NULL, 'Toll, putative', NULL, NULL, NULL, NULL, NULL, 4),
(145069, NULL, 'G3DSA:2.60.40.1170:FF:000029', NULL, NULL, 'AP-1 complex subunit mu-2', NULL, NULL, NULL, NULL, NULL, 4),
(145070, NULL, 'G3DSA:1.25.10.10:FF:002529', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145071, NULL, 'G3DSA:1.10.287.230:FF:000001', NULL, NULL, 'Nuclear export protein', NULL, NULL, NULL, NULL, NULL, 4),
(145072, NULL, 'G3DSA:3.50.4.10:FF:000009', NULL, NULL, 'GG11699', NULL, NULL, NULL, NULL, NULL, 4),
(145073, NULL, 'G3DSA:1.25.10.10:FF:001512', NULL, NULL, 'Armadillo repeat protein (AFU_orthologue AFUA_1G07050)', NULL, NULL, NULL, NULL, NULL, 4),
(145074, NULL, 'G3DSA:1.25.40.20:FF:000348', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(145075, NULL, 'G3DSA:1.20.1250.20:FF:002132', NULL, NULL, 'Organic anion transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(145076, NULL, 'G3DSA:1.10.510.10:FF:003602', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145077, NULL, 'G3DSA:2.130.10.10:FF:005899', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145078, NULL, 'G3DSA:3.40.50.300:FF:004736', NULL, NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase PRP16', NULL, NULL, NULL, NULL, NULL, 4),
(145079, NULL, 'G3DSA:1.20.1250.20:FF:001581', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(145080, NULL, 'G3DSA:3.40.50.1580:FF:000009', NULL, NULL, 'Uridine phosphorylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(145081, NULL, 'G3DSA:3.60.110.10:FF:000080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145082, NULL, 'G3DSA:3.40.50.300:FF:006456', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145083, NULL, 'G3DSA:3.30.200.20:FF:002502', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145084, NULL, 'G3DSA:3.90.79.10:FF:000139', NULL, NULL, 'Putative nudix hydrolase 2', NULL, NULL, NULL, NULL, NULL, 4),
(145085, NULL, 'G3DSA:1.20.5.110:FF:000279', NULL, NULL, 'Ubiquitin-conjugating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(145086, NULL, 'G3DSA:2.130.10.10:FF:004831', NULL, NULL, 'U3 small nucleolar RNA-associated protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(145087, NULL, 'G3DSA:3.30.750.24:FF:000069', NULL, NULL, 'Sodium-independent anion transporter', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(145088, NULL, 'G3DSA:3.90.79.10:FF:000291', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(145089, NULL, 'G3DSA:3.30.40.10:FF:000036', NULL, NULL, 'nucleosome-remodeling factor subunit BPTF isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(145090, NULL, 'G3DSA:3.90.1640.10:FF:000022', NULL, NULL, 'Inorganic pyrophosphatase, manganese-dependent', NULL, NULL, NULL, NULL, NULL, 4),
(145091, NULL, 'G3DSA:1.10.10.10:FF:001332', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(145092, NULL, 'G3DSA:3.30.160.60:FF:002583', NULL, NULL, 'Zinc finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(145093, NULL, 'G3DSA:3.30.710.10:FF:000430', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145094, NULL, 'G3DSA:3.40.47.10:FF:000225', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145095, NULL, 'G3DSA:3.60.20.10:FF:000123', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(145096, NULL, 'G3DSA:1.25.40.190:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145097, NULL, 'G3DSA:2.60.120.650:FF:000019', NULL, NULL, 'Bifunctional peptidase and arginyl-hydroxylase JMJD5', NULL, NULL, NULL, NULL, NULL, 4),
(145098, NULL, 'G3DSA:1.10.510.10:FF:004176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145099, NULL, 'G3DSA:3.30.70.330:FF:002161', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145100, NULL, 'G3DSA:3.40.640.10:FF:000495', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(145101, NULL, 'G3DSA:3.30.230.10:FF:000123', NULL, NULL, 'Galactokinase', NULL, NULL, NULL, NULL, NULL, 4),
(145102, NULL, 'G3DSA:3.30.70.330:FF:000070', NULL, NULL, 'Epithelial splicing regulatory protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(145103, NULL, 'G3DSA:3.40.50.1000:FF:000494', NULL, NULL, 'bifunctional polynucleotide phosphatase/kinase', NULL, NULL, NULL, NULL, NULL, 4),
(145104, NULL, 'G3DSA:3.80.10.10:FF:003483', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145105, NULL, 'G3DSA:2.40.50.140:FF:000353', NULL, NULL, 'Mitochondrial ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(145106, NULL, 'G3DSA:3.40.50.150:FF:000644', NULL, NULL, 'FBL isoform 7', NULL, NULL, NULL, NULL, NULL, 4),
(145107, NULL, 'G3DSA:3.90.226.10:FF:000173', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(145108, NULL, 'G3DSA:2.60.120.260:FF:000329', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145109, NULL, 'G3DSA:3.40.50.1000:FF:000437', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145110, NULL, 'G3DSA:3.10.20.70:FF:000020', NULL, NULL, 'Glutamine synthetase protein', NULL, NULL, NULL, NULL, NULL, 4),
(145111, NULL, 'G3DSA:3.40.50.720:FF:001462', NULL, NULL, 'UDP-glucose/GDP-mannose dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(145112, NULL, 'G3DSA:3.10.20.90:FF:000705', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145113, NULL, 'G3DSA:1.10.8.60:FF:000582', NULL, NULL, 'ORC1-type DNA replication protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(145114, NULL, 'G3DSA:2.40.50.860:FF:000001', NULL, NULL, 'Cell division control protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(145115, NULL, 'G3DSA:1.10.1610.10:FF:000001', NULL, NULL, 'Nicotinate-nucleotide--dimethylbenzimidazole phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(145116, NULL, 'G3DSA:3.40.390.10:FF:000172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145117, NULL, 'G3DSA:3.90.1150.10:FF:000035', NULL, NULL, 'Adenosylmethionine-8-amino-7-oxononanoate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(145118, NULL, 'G3DSA:1.10.287.110:FF:000257', NULL, NULL, 'Chaperone DnaJ-domain superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(145119, NULL, 'G3DSA:3.30.160.60:FF:005163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145120, NULL, 'G3DSA:1.25.40.10:FF:003959', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145121, NULL, 'G3DSA:3.60.40.10:FF:000001', NULL, NULL, 'protein phosphatase 1B isoform X1', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(145122, NULL, 'G3DSA:3.30.160.60:FF:004382', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145123, NULL, 'G3DSA:1.25.10.10:FF:002586', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145124, NULL, 'G3DSA:1.10.10.10:FF:000337', NULL, NULL, 'Methylated-DNA--protein-cysteine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(145125, NULL, 'G3DSA:2.10.90.10:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145126, NULL, 'G3DSA:2.40.50.140:FF:000914', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145127, NULL, 'G3DSA:3.90.79.10:FF:000128', NULL, NULL, 'WGS project CABT00000000 data, contig 2.8', NULL, NULL, NULL, NULL, NULL, 4),
(145128, NULL, 'G3DSA:1.25.40.20:FF:000680', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145129, NULL, 'G3DSA:2.60.40.1730:FF:000068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145130, NULL, 'G3DSA:2.60.120.10:FF:000764', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145131, NULL, 'G3DSA:3.10.129.10:FF:000145', NULL, NULL, 'Peroxisomal hydratase-dehydrogenase-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(145132, NULL, 'G3DSA:1.25.10.10:FF:000456', NULL, NULL, 'Importin-7, putative', NULL, NULL, NULL, NULL, NULL, 4),
(145133, NULL, 'G3DSA:4.10.240.10:FF:000012', NULL, NULL, 'C6 transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(145134, NULL, 'G3DSA:2.40.10.10:FF:000356', NULL, NULL, 'Mannose-binding lectin associated serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(145135, NULL, 'G3DSA:2.130.10.10:FF:002347', NULL, NULL, 'Cleavage and polyadenylation specificity factor subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(145136, NULL, 'G3DSA:3.80.10.10:FF:002134', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(145137, NULL, 'G3DSA:3.10.100.10:FF:000068', NULL, NULL, 'CG4115', NULL, NULL, NULL, NULL, NULL, 4),
(145138, NULL, 'G3DSA:3.40.30.120:FF:000002', NULL, NULL, '2-polyprenyl-6-methoxyphenol hydroxylase and related FAD-dependent oxidoreductases', NULL, NULL, NULL, NULL, NULL, 4),
(145139, NULL, 'G3DSA:3.30.470.20:FF:000054', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(145140, NULL, 'G3DSA:3.30.70.330:FF:002722', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145141, NULL, 'G3DSA:3.30.160.60:FF:002824', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145142, NULL, 'G3DSA:3.30.1230.20:FF:000013', NULL, NULL, '40S ribosomal protein S21', NULL, NULL, NULL, NULL, NULL, 4),
(145143, NULL, 'G3DSA:3.40.50.1000:FF:000617', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145144, NULL, 'G3DSA:3.30.70.420:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145145, NULL, 'G3DSA:3.30.497.10:FF:000085', NULL, NULL, 'Serine protease inhibitor 28Dc', NULL, NULL, NULL, NULL, NULL, 4),
(145146, NULL, 'G3DSA:1.10.510.10:FF:002046', NULL, NULL, 'piRNA biogenesis factor prde-1', NULL, NULL, NULL, NULL, NULL, 4),
(145147, NULL, 'G3DSA:3.30.559.70:FF:000011', NULL, NULL, 'Choline O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(145148, NULL, 'G3DSA:3.40.50.300:FF:000616', NULL, NULL, 'GPN-loop GTPase 3', NULL, NULL, NULL, NULL, NULL, 4),
(145149, NULL, 'G3DSA:3.40.50.300:FF:003308', NULL, NULL, 'Integral membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(145150, NULL, 'G3DSA:3.30.160.60:FF:000969', NULL, NULL, 'Zinc finger protein 407', NULL, NULL, NULL, NULL, NULL, 4),
(145151, NULL, 'G3DSA:1.20.1060.20:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145152, NULL, 'G3DSA:3.30.1520.10:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145153, NULL, 'G3DSA:3.30.70.60:FF:000013', NULL, NULL, 'Mitochondrial ribosomal protein S6-2', NULL, NULL, NULL, NULL, NULL, 4),
(145154, NULL, 'G3DSA:2.30.42.10:FF:000503', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145155, NULL, 'G3DSA:3.40.50.1100:FF:000237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(145156, NULL, 'G3DSA:3.40.50.12780:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145157, NULL, 'G3DSA:3.40.390.10:FF:000290', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145158, NULL, 'G3DSA:1.20.1440.160:FF:000001', NULL, NULL, 'Tumor necrosis factor alpha-induced protein 8-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(145159, NULL, 'G3DSA:3.30.40.10:FF:002110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145160, NULL, 'G3DSA:3.10.25.10:FF:000013', NULL, NULL, 'Methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(145161, NULL, 'G3DSA:3.90.1420.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145162, NULL, 'G3DSA:1.10.1140.10:FF:000009', NULL, NULL, 'Vacuolar ATP synthase catalytic subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(145163, NULL, 'G3DSA:1.10.238.10:FF:001316', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145164, NULL, 'G3DSA:2.40.50.100:FF:000190', NULL, NULL, 'Putative RND efflux membrane fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(145165, NULL, 'G3DSA:3.40.50.300:FF:002645', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(145166, NULL, 'G3DSA:3.30.200.20:FF:000237', NULL, NULL, 'Serine/threonine-protein kinase SAPK2', NULL, NULL, NULL, NULL, NULL, 4),
(145167, NULL, 'G3DSA:2.60.40.1510:FF:000053', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(145168, NULL, 'G3DSA:1.25.10.10:FF:002940', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145169, NULL, 'G3DSA:3.30.565.10:FF:000485', NULL, NULL, 'Os09g0551900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(145170, NULL, 'G3DSA:3.90.180.10:FF:000010', NULL, NULL, 'Enoyl-[acyl-carrier-protein] reductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(145171, NULL, 'G3DSA:1.25.10.10:FF:003103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145172, NULL, 'G3DSA:3.30.70.20:FF:000108', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145173, NULL, 'G3DSA:3.90.550.10:FF:000387', NULL, NULL, 'Putative cellulose synthase A catalytic subunit 11 [UDP-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(145174, NULL, 'G3DSA:2.60.260.20:FF:000013', NULL, NULL, 'DnaJ subfamily B member 11', NULL, NULL, NULL, NULL, NULL, 4),
(145175, NULL, 'G3DSA:2.30.29.30:FF:001092', NULL, NULL, 'Si:dkey-172j4.3', NULL, NULL, NULL, NULL, NULL, 4),
(145176, NULL, 'G3DSA:1.20.5.420:FF:000023', NULL, NULL, 'Putative conserved secreted 15 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(145177, NULL, 'G3DSA:2.90.10.10:FF:000034', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase CES101 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(145178, NULL, 'G3DSA:3.80.10.10:FF:000335', NULL, NULL, 'mimecan', NULL, NULL, NULL, NULL, NULL, 4),
(145179, NULL, 'G3DSA:3.30.830.10:FF:000326', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145180, NULL, 'G3DSA:2.60.40.10:FF:000537', NULL, NULL, 'immunoglobulin superfamily member 10', NULL, NULL, NULL, NULL, NULL, 4),
(145181, NULL, 'G3DSA:3.20.20.150:FF:000030', NULL, NULL, 'putative hydroxypyruvate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(145182, NULL, 'G3DSA:3.30.420.10:FF:000739', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145183, NULL, 'G3DSA:3.30.1360.10:FF:000014', NULL, NULL, 'DNA-directed RNA polymerase II subunit RPB3', NULL, NULL, NULL, NULL, NULL, 4),
(145184, NULL, 'G3DSA:1.20.1280.290:FF:000008', NULL, NULL, 'PQ-loop repeat-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(145185, NULL, 'G3DSA:3.40.50.300:FF:004944', NULL, NULL, 'Polynucleotide 5''-hydroxyl-kinase nol9', NULL, NULL, NULL, NULL, NULL, 4),
(145186, NULL, 'G3DSA:3.40.50.300:FF:007350', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145187, NULL, 'G3DSA:1.25.40.620:FF:000006', NULL, NULL, 'Sll1380 protein', NULL, NULL, NULL, NULL, NULL, 4),
(145188, NULL, 'G3DSA:2.160.20.10:FF:000019', NULL, NULL, 'polygalacturonase At1g48100', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(145189, NULL, 'G3DSA:2.130.10.10:FF:002965', NULL, NULL, 'Putative WD-repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(145190, NULL, 'G3DSA:1.20.58.1080:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(145191, NULL, 'G3DSA:1.10.10.580:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145192, NULL, 'G3DSA:1.20.58.70:FF:000021', NULL, NULL, 'SNARE complex subunit (Tlg2)', NULL, NULL, NULL, NULL, NULL, 4),
(145193, NULL, 'G3DSA:2.60.40.10:FF:004409', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145194, NULL, 'G3DSA:3.40.50.300:FF:001510', NULL, NULL, 'ABC transporter G family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(145195, NULL, 'G3DSA:1.20.1440.170:FF:000004', NULL, NULL, 'Protein_of_uncharacterized_function_(DUF2962)_-_p utative', NULL, NULL, NULL, NULL, NULL, 4),
(145196, NULL, 'G3DSA:1.10.10.10:FF:000394', NULL, NULL, 'Homologous-pairing protein 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(145197, NULL, 'G3DSA:2.60.40.10:FF:004466', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145198, NULL, 'G3DSA:1.25.40.10:FF:002436', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(145199, NULL, 'G3DSA:2.30.42.10:FF:000161', NULL, NULL, 'Synaptojanin-2-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(145200, NULL, 'G3DSA:3.30.200.20:FF:000675', NULL, NULL, 'Choline kinase', NULL, NULL, NULL, NULL, NULL, 4),
(145201, NULL, 'G3DSA:2.120.10.80:FF:000227', NULL, NULL, 'Kelch like family member 18, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(145202, NULL, 'G3DSA:3.40.50.10900:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145203, NULL, 'G3DSA:1.20.1440.180:FF:000007', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(145204, NULL, 'G3DSA:3.40.30.10:FF:001069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145205, NULL, 'G3DSA:3.40.50.1240:FF:000138', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145206, NULL, 'G3DSA:2.130.10.10:FF:004146', NULL, NULL, 'Actin-related protein 2/3 complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(145207, NULL, 'G3DSA:3.20.20.70:FF:000497', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145208, NULL, 'G3DSA:1.20.1250.20:FF:000333', NULL, NULL, 'Folate transporter 2', NULL, NULL, NULL, NULL, NULL, 4),
(145209, NULL, 'G3DSA:3.30.470.30:FF:000057', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(145210, NULL, 'G3DSA:3.30.420.40:FF:000057', NULL, NULL, 'Ectonucleoside triphosphate diphosphohydrolase 4', NULL, NULL, NULL, NULL, NULL, 4),
(145211, NULL, 'G3DSA:1.10.150.870:FF:000002', NULL, NULL, 'Error-prone DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(145212, NULL, 'G3DSA:1.10.287.110:FF:000465', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145213, NULL, 'G3DSA:1.25.40.10:FF:000284', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(145214, NULL, 'G3DSA:3.40.50.720:FF:000978', NULL, NULL, 'Protein CBG20301', NULL, NULL, NULL, NULL, NULL, 4),
(145215, NULL, 'G3DSA:1.10.510.10:FF:001028', NULL, NULL, 'Serine/threonine-protein kinase RIO1', NULL, NULL, NULL, NULL, NULL, 4),
(145216, NULL, 'G3DSA:1.10.400.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145217, NULL, 'G3DSA:1.10.472.10:FF:000534', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145218, NULL, 'G3DSA:3.40.190.10:FF:000802', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145219, NULL, 'G3DSA:3.90.470.10:FF:000032', NULL, NULL, 'Mitochondrial large ribosomal subunit', NULL, NULL, NULL, NULL, NULL, 4),
(145220, NULL, 'G3DSA:3.40.109.10:FF:000053', NULL, NULL, 'Nitroreductase', NULL, NULL, NULL, NULL, NULL, 4),
(145221, NULL, 'G3DSA:1.25.10.10:FF:002608', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(145222, NULL, 'G3DSA:2.130.10.10:FF:002027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(145223, NULL, 'G3DSA:2.40.50.140:FF:000173', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(145224, NULL, 'G3DSA:2.60.120.260:FF:000560', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145225, NULL, 'G3DSA:3.40.50.300:FF:008255', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein U-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(145226, NULL, 'G3DSA:1.20.1560.10:FF:000101', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(145227, NULL, 'G3DSA:3.40.462.20:FF:000005', NULL, NULL, 'Putative FAD-dependent oxygenase EncM', NULL, NULL, NULL, NULL, NULL, 4),
(145228, NULL, 'G3DSA:3.30.70.330:FF:002402', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145229, NULL, 'G3DSA:2.30.230.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145230, NULL, 'G3DSA:3.30.70.2760:FF:000001', NULL, NULL, 'Metal-dependent phosphohydrolase HD domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(145231, NULL, 'G3DSA:3.40.462.10:FF:000002', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(145232, NULL, 'G3DSA:2.20.80.10:FF:000018', NULL, NULL, 'Vitellogenin-1', NULL, NULL, NULL, NULL, NULL, 4),
(145233, NULL, 'G3DSA:3.30.70.3490:FF:000001', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(145234, NULL, 'G3DSA:3.90.470.20:FF:000035', NULL, NULL, 'L-aminoadipate-semialdehyde dehydrogenase-phosphopantetheinyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(145235, NULL, 'G3DSA:1.20.5.1000:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145236, NULL, 'G3DSA:3.30.450.20:FF:000688', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(145237, NULL, 'G3DSA:3.40.50.1440:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145238, NULL, 'G3DSA:1.10.1080.10:FF:000010', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(145239, NULL, 'G3DSA:2.30.29.30:FF:001299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145240, NULL, 'G3DSA:3.10.100.10:FF:000181', NULL, NULL, 'C-type LECtin', NULL, NULL, NULL, NULL, NULL, 4),
(145241, NULL, 'G3DSA:1.25.40.10:FF:001008', NULL, NULL, 'Coatomer subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(145242, NULL, 'G3DSA:1.20.1050.10:FF:000135', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(145243, NULL, 'G3DSA:3.30.200.20:FF:002266', NULL, NULL, 'CDK inhibitory kinase', NULL, NULL, NULL, NULL, NULL, 4),
(145244, NULL, 'G3DSA:2.60.40.1400:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145245, NULL, 'G3DSA:2.30.30.210:FF:000018', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(145246, NULL, 'G3DSA:3.40.50.2300:FF:000260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145247, NULL, 'G3DSA:2.60.40.10:FF:002611', NULL, NULL, 'Papain family cysteine protease', NULL, NULL, NULL, NULL, NULL, 4),
(145248, NULL, 'G3DSA:3.80.10.10:FF:004000', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(145249, NULL, 'G3DSA:2.30.30.40:FF:000479', NULL, NULL, 'Scaffold protein CheW associated with MCPs of class 44H', NULL, NULL, NULL, NULL, NULL, 4),
(145250, NULL, 'G3DSA:3.40.50.970:FF:000114', NULL, NULL, 'Indolepyruvate ferredoxin oxidoreductase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(145251, NULL, 'G3DSA:1.10.3430.10:FF:000021', NULL, NULL, 'RH (Rhesus) antigen Related', NULL, NULL, NULL, NULL, NULL, 4),
(145252, NULL, 'G3DSA:3.30.200.20:FF:002209', NULL, NULL, 'GH15507p', NULL, NULL, NULL, NULL, NULL, 4),
(145253, NULL, 'G3DSA:3.30.70.330:FF:000423', NULL, NULL, 'Ribonucleoprotein A, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(145254, NULL, 'G3DSA:3.30.190.20:FF:000004', NULL, NULL, '39S ribosomal protein L1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(145255, NULL, 'G3DSA:2.60.40.10:FF:005303', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145256, NULL, 'G3DSA:3.40.850.10:FF:000331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(145257, NULL, 'G3DSA:1.10.340.30:FF:000015', NULL, NULL, '3-methyladenine DNA glycosylase/8-oxoguanine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(145258, NULL, 'G3DSA:2.130.10.10:FF:001341', NULL, NULL, 'Regulator of ribosome biogenesis', NULL, NULL, NULL, NULL, NULL, 4),
(145259, NULL, 'G3DSA:3.90.79.10:FF:000280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145260, NULL, 'G3DSA:1.20.1070.10:FF:002143', NULL, NULL, 'Cadherin, EGF LAG seven-pass G-type receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(145261, NULL, 'G3DSA:2.60.40.1180:FF:000206', NULL, NULL, 'Alpha-L-fucosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(145262, NULL, 'G3DSA:3.40.50.1820:FF:001852', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145263, NULL, 'G3DSA:3.80.10.10:FF:003562', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(145264, NULL, 'G3DSA:1.25.40.10:FF:004774', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145265, NULL, 'G3DSA:1.25.40.10:FF:002700', NULL, NULL, 'TPR repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(145266, NULL, 'G3DSA:1.25.10.10:FF:000731', NULL, NULL, 'Suppressor of tub2', NULL, NULL, NULL, NULL, NULL, 4),
(145267, NULL, 'G3DSA:1.10.10.370:FF:000003', NULL, NULL, 'Siroheme-sulfite reductase gamma subunit homolog', NULL, NULL, NULL, NULL, NULL, 4),
(145268, NULL, 'G3DSA:2.60.40.60:FF:000445', NULL, NULL, 'GG17179', NULL, NULL, NULL, NULL, NULL, 4),
(145269, NULL, 'G3DSA:2.130.10.10:FF:002701', NULL, NULL, 'Pre-rRNA-processing protein IPI3', NULL, NULL, NULL, NULL, NULL, 4),
(145270, NULL, 'G3DSA:3.20.20.70:FF:000851', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145271, NULL, 'G3DSA:3.10.50.10:FF:000032', NULL, NULL, 'Chitinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(145272, NULL, 'G3DSA:3.30.160.60:FF:005697', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145273, NULL, 'G3DSA:2.40.70.10:FF:000562', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145274, NULL, 'G3DSA:3.30.70.80:FF:000019', NULL, NULL, 'Subtilisin-like protease SBT3.3', NULL, NULL, NULL, NULL, NULL, 4),
(145275, NULL, 'G3DSA:2.40.290.30:FF:000005', NULL, NULL, 'GM26574', NULL, NULL, NULL, NULL, NULL, 4),
(145276, NULL, 'G3DSA:3.40.1280.10:FF:000011', NULL, NULL, 'putative methyltransferase C9orf114 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(145277, NULL, 'G3DSA:1.10.420.10:FF:000010', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(145278, NULL, 'G3DSA:3.10.20.30:FF:000098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145279, NULL, 'G3DSA:3.40.50.300:FF:004326', NULL, NULL, 'Os10g0163220 protein', NULL, NULL, NULL, NULL, NULL, 4),
(145280, NULL, 'G3DSA:1.10.730.10:FF:000230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145281, NULL, 'G3DSA:3.40.50.2300:FF:000108', NULL, NULL, 'DNA-binding response OmpR family regulator', NULL, NULL, NULL, NULL, NULL, 4),
(145282, NULL, 'G3DSA:1.20.1070.10:FF:001249', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(145283, NULL, 'G3DSA:3.40.50.1440:FF:000108', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(145284, NULL, 'G3DSA:3.30.40.10:FF:001559', NULL, NULL, 'Vacuolar membrane protein pep18, putative', NULL, NULL, NULL, NULL, NULL, 4),
(145285, NULL, 'G3DSA:6.10.250.3370:FF:000004', NULL, NULL, 'NTP-dependent putrebactin synthetase PubC', NULL, NULL, NULL, NULL, NULL, 4),
(145286, NULL, 'G3DSA:2.120.10.30:FF:000471', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(145287, NULL, 'G3DSA:2.60.40.10:FF:003151', NULL, NULL, 'AGAP011650-PA', NULL, NULL, NULL, NULL, NULL, 4),
(145288, NULL, 'G3DSA:3.30.559.10:FF:000100', NULL, NULL, 'Nonribosomal peptide synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(145289, NULL, 'G3DSA:1.20.120.230:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145290, NULL, 'G3DSA:3.30.70.330:FF:002609', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145291, NULL, 'G3DSA:3.50.50.60:FF:000135', NULL, NULL, 'L-lysine 6-monooxygenase IucD', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(145292, NULL, 'G3DSA:3.30.70.330:FF:000081', NULL, NULL, 'Cleavage and polyadenylation specificity factor subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(145293, NULL, 'G3DSA:1.10.472.10:FF:000354', NULL, NULL, 'G2/mitotic-specific cyclin 1/2', NULL, NULL, NULL, NULL, NULL, 4),
(145294, NULL, 'G3DSA:4.10.60.10:FF:000075', NULL, NULL, 'CCHC-type zinc finger protein CG3800', NULL, NULL, NULL, NULL, NULL, 4),
(145295, NULL, 'G3DSA:3.40.50.10810:FF:000069', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(145296, NULL, 'G3DSA:3.10.100.10:FF:000388', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145297, NULL, 'G3DSA:1.20.1250.20:FF:001468', NULL, NULL, 'Nitrate/nitrite transporter NrtP', NULL, NULL, NULL, NULL, NULL, 4),
(145298, NULL, 'G3DSA:1.10.287.890:FF:000007', NULL, NULL, 'Os07g0190150 protein', NULL, NULL, NULL, NULL, NULL, 4),
(145299, NULL, 'G3DSA:3.40.1280.30:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145300, NULL, 'G3DSA:3.30.160.60:FF:003100', NULL, NULL, 'zinc finger protein 444 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(145301, NULL, 'G3DSA:2.60.40.10:FF:002818', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145302, NULL, 'G3DSA:2.60.40.10:FF:002875', NULL, NULL, 'MPL proto-oncogene, thrombopoietin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(145303, NULL, 'G3DSA:2.40.160.40:FF:000004', NULL, NULL, 'Putative outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(145304, NULL, 'G3DSA:1.25.40.10:FF:001340', NULL, NULL, 'rRNA biogenesis protein RRP5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(145305, NULL, 'G3DSA:3.40.50.300:FF:006535', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(145306, NULL, 'G3DSA:3.30.200.20:FF:002541', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(145307, NULL, 'G3DSA:3.40.50.1820:FF:001291', NULL, NULL, 'Putative steryl acetyl hydrolase mug81', NULL, NULL, NULL, NULL, NULL, 4),
(145308, NULL, 'G3DSA:1.20.144.10:FF:000091', NULL, NULL, 'RfiA', NULL, NULL, NULL, NULL, NULL, 4),
(145309, NULL, 'G3DSA:3.40.50.720:FF:002310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145310, NULL, 'G3DSA:3.40.190.10:FF:000241', NULL, NULL, 'Glutamate receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(145311, NULL, 'G3DSA:2.10.25.10:FF:001549', NULL, NULL, 'Putative per-hexamer repeat protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(145312, NULL, 'G3DSA:3.40.50.300:FF:003101', NULL, NULL, 'Guanylate binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(145313, NULL, 'G3DSA:3.30.60.20:FF:000102', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(145314, NULL, 'G3DSA:1.20.144.10:FF:000034', NULL, NULL, 'Dihydrosphingosine-1-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(145315, NULL, 'G3DSA:1.10.510.10:FF:002664', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145316, NULL, 'G3DSA:2.40.160.50:FF:000007', NULL, NULL, 'Outer envelope protein 80, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(145317, NULL, 'G3DSA:1.25.40.20:FF:001343', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145318, NULL, 'G3DSA:3.40.30.10:FF:000636', NULL, NULL, 'Peroxiredoxin-like 2C', NULL, NULL, NULL, NULL, NULL, 4),
(145319, NULL, 'G3DSA:3.40.30.10:FF:001204', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(145320, NULL, 'G3DSA:3.30.160.60:FF:005404', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145321, NULL, 'G3DSA:1.20.58.60:FF:000231', NULL, NULL, 'Spectrin repeat containing, nuclear envelope 1a', NULL, NULL, NULL, NULL, NULL, 4),
(145322, NULL, 'G3DSA:3.40.47.10:FF:000146', NULL, NULL, 'Orsellinic acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(145323, NULL, 'G3DSA:1.10.10.10:FF:000219', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(145324, NULL, 'G3DSA:3.30.70.330:FF:000362', NULL, NULL, 'GBP2p Poly(A+) RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(145325, NULL, 'G3DSA:1.20.1280.290:FF:000003', NULL, NULL, 'Bidirectional sugar transporter SWEET', NULL, NULL, NULL, NULL, NULL, 4),
(145326, NULL, 'G3DSA:3.40.50.1000:FF:000089', NULL, NULL, 'NIF domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(145327, NULL, 'G3DSA:3.30.1540.20:FF:000003', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(145328, NULL, 'G3DSA:3.30.559.70:FF:000067', NULL, NULL, 'Carnitine acyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(145329, NULL, 'G3DSA:1.10.150.80:FF:000009', NULL, NULL, '3''-5'' exonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(145330, NULL, 'G3DSA:3.40.50.720:FF:000006', NULL, NULL, 'Bifunctional protein FolD', NULL, NULL, NULL, NULL, NULL, 4),
(145331, NULL, 'G3DSA:3.30.720.210:FF:000018', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(145332, NULL, 'G3DSA:3.80.10.10:FF:001701', NULL, NULL, 'LRR receptor kinase SERK2', NULL, NULL, NULL, NULL, NULL, 4),
(145333, NULL, 'G3DSA:1.25.40.20:FF:000904', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145334, NULL, 'G3DSA:1.50.40.10:FF:000169', NULL, NULL, 'Mitochondrial carrier protein (Pet8), putative', NULL, NULL, NULL, NULL, NULL, 4),
(145335, NULL, 'G3DSA:3.80.10.10:FF:001645', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145336, NULL, 'G3DSA:3.40.1410.10:FF:000005', NULL, NULL, 'HTH-type transcriptional regulator frlR', NULL, NULL, NULL, NULL, NULL, 4),
(145337, NULL, 'G3DSA:1.25.40.20:FF:000848', NULL, NULL, 'Kinase, NEK-frag', NULL, NULL, NULL, NULL, NULL, 4),
(145338, NULL, 'G3DSA:3.30.160.60:FF:001133', NULL, NULL, 'Zinc finger and BTB domain containing 41', NULL, NULL, NULL, NULL, NULL, 4),
(145339, NULL, 'G3DSA:3.40.50.300:FF:000386', NULL, NULL, 'Regulator of nonsense transcripts 1', NULL, NULL, NULL, NULL, NULL, 4),
(145340, NULL, 'G3DSA:1.20.1070.10:FF:000350', NULL, NULL, 'Frizzled', NULL, NULL, NULL, NULL, NULL, 4),
(145341, NULL, 'G3DSA:2.10.25.10:FF:001257', NULL, NULL, 'Protein CBG11506', NULL, NULL, NULL, NULL, NULL, 4),
(145342, NULL, 'G3DSA:3.40.50.1380:FF:000006', NULL, NULL, 'Methylglyoxal synthase', NULL, NULL, NULL, NULL, NULL, 4),
(145343, NULL, 'G3DSA:3.80.10.10:FF:003825', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145344, NULL, 'G3DSA:3.10.580.10:FF:000098', NULL, NULL, 'KpsF/GutQ family sugar-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(145345, NULL, 'G3DSA:3.80.10.10:FF:003769', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(145346, NULL, 'G3DSA:2.60.40.10:FF:003679', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145347, NULL, 'G3DSA:3.90.226.10:FF:000055', NULL, NULL, 'ATP-dependent Clp protease proteolytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(145348, NULL, 'G3DSA:3.40.630.10:FF:000343', NULL, NULL, 'Si:ch1073-459j12.1', NULL, NULL, NULL, NULL, NULL, 4),
(145349, NULL, 'G3DSA:2.70.98.10:FF:000052', NULL, NULL, 'Glucose-6-phosphate 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(145350, NULL, 'G3DSA:3.30.420.40:FF:000383', NULL, NULL, 'tRNA (Adenosine(37)-N6)-threonylcarbamoyltransferase complex dimerization subunit type 1 TsaB', NULL, NULL, NULL, NULL, NULL, 4),
(145351, NULL, 'G3DSA:1.10.439.10:FF:000002', NULL, NULL, 'Putative penicillin acylase (Penicillin amidase) (Penicillin amidohydrolase)', NULL, NULL, NULL, NULL, NULL, 4),
(145352, NULL, 'G3DSA:1.25.40.10:FF:000845', NULL, NULL, 'pentatricopeptide repeat-containing protein At1g20230 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(145353, NULL, 'G3DSA:3.30.70.330:FF:002109', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145354, NULL, 'G3DSA:1.25.40.10:FF:004156', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(145355, NULL, 'G3DSA:1.25.40.20:FF:001461', NULL, NULL, 'Palmitoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(145356, NULL, 'G3DSA:1.10.1070.11:FF:000073', NULL, NULL, 'Dual specificity protein phosphatase PHS1', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(145357, NULL, 'G3DSA:3.30.500.10:FF:000004', NULL, NULL, 'Retinoic acid early-inducible protein 1-beta', NULL, NULL, NULL, NULL, NULL, 4),
(145358, NULL, 'G3DSA:3.40.50.300:FF:005225', NULL, NULL, 'Minichromosome maintenance domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(145359, NULL, 'G3DSA:3.50.50.60:FF:000410', NULL, NULL, 'Flavocytochrome C sulfide dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(145360, NULL, 'G3DSA:1.20.120.520:FF:000007', NULL, NULL, 'Hemerythrin domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(145361, NULL, 'G3DSA:3.30.70.330:FF:001885', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145362, NULL, 'G3DSA:3.30.160.90:FF:000001', NULL, NULL, 'Vitamin B12-dependent ribonucleotide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(145363, NULL, 'G3DSA:3.30.70.270:FF:000208', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145364, NULL, 'G3DSA:3.40.50.300:FF:002533', NULL, NULL, 'Large subunit GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(145365, NULL, 'G3DSA:2.40.160.10:FF:000018', NULL, NULL, 'Mitochondrial import receptor subunit tom40', NULL, NULL, NULL, NULL, NULL, 4),
(145366, NULL, 'G3DSA:3.30.420.10:FF:000003', NULL, NULL, 'Oligoribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(145367, NULL, 'G3DSA:2.30.30.40:FF:000209', NULL, NULL, 'Abl interactor 2', NULL, NULL, NULL, NULL, NULL, 4),
(145368, NULL, 'G3DSA:1.10.460.10:FF:000012', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(145369, NULL, 'G3DSA:1.10.10.820:FF:000008', NULL, NULL, 'Zipper, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(145370, NULL, 'G3DSA:1.10.600.10:FF:000052', NULL, NULL, 'Farnesyl pyrophosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(145371, NULL, 'G3DSA:3.30.1460.20:FF:000002', NULL, NULL, 'Arp2/3 complex 34 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(145372, NULL, 'G3DSA:1.10.3460.10:FF:000017', NULL, NULL, 'Fucoxanthin chl a/c light-harvesting protein', NULL, NULL, NULL, NULL, NULL, 4),
(145373, NULL, 'G3DSA:3.40.350.10:FF:000068', NULL, NULL, 'FACT complex subunit SPT16', NULL, NULL, NULL, NULL, NULL, 4),
(145374, NULL, 'G3DSA:1.20.1260.20:FF:000002', NULL, NULL, 'Hypothetical alanine and glycine rich protein', NULL, NULL, NULL, NULL, NULL, 4),
(145375, NULL, 'G3DSA:3.40.50.720:FF:001467', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(145376, NULL, 'G3DSA:3.80.10.10:FF:000015', NULL, NULL, 'Leucine rich repeat containing 38', NULL, NULL, NULL, NULL, NULL, 4),
(145377, NULL, 'G3DSA:1.20.120.1900:FF:000041', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(145378, NULL, 'G3DSA:3.40.50.720:FF:002035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145379, NULL, 'G3DSA:3.30.160.60:FF:002763', NULL, NULL, 'Zinc finger protein 646', NULL, NULL, NULL, NULL, NULL, 4),
(145380, NULL, 'G3DSA:2.170.270.10:FF:000153', NULL, NULL, 'PR domain-containing 11', NULL, NULL, NULL, NULL, NULL, 4),
(145381, NULL, 'G3DSA:1.20.58.60:FF:000282', NULL, NULL, 'Spectrin beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(145382, NULL, 'G3DSA:3.30.200.20:FF:000063', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(145383, NULL, 'G3DSA:1.20.920.10:FF:000040', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(145384, NULL, 'G3DSA:1.20.1070.10:FF:001603', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(145385, NULL, 'G3DSA:1.10.510.10:FF:002602', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145386, NULL, 'G3DSA:3.30.565.10:FF:000367', NULL, NULL, 'PAS domain-containing hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(145387, NULL, 'G3DSA:3.30.50.10:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145388, NULL, 'G3DSA:1.25.40.10:FF:000519', NULL, NULL, 'pre-mRNA-splicing factor SYF1', NULL, NULL, NULL, NULL, NULL, 4),
(145389, NULL, 'G3DSA:1.20.1250.20:FF:000451', NULL, NULL, 'MFS sugar transporter, putative', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(145390, NULL, 'G3DSA:2.30.29.230:FF:000011', NULL, NULL, 'GTPase-activating protein GYP7', NULL, NULL, NULL, NULL, NULL, 4),
(145391, NULL, 'G3DSA:3.40.50.300:FF:006804', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145392, NULL, 'G3DSA:2.170.270.10:FF:000097', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(145393, NULL, 'G3DSA:3.30.160.60:FF:000458', NULL, NULL, 'pH-response transcription factor pacC/RIM101', NULL, NULL, NULL, NULL, NULL, 4),
(145394, NULL, 'G3DSA:1.20.1090.10:FF:000019', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(145395, NULL, 'G3DSA:3.80.10.10:FF:004500', NULL, NULL, 'Leucine-rich repeat receptor-like tyrosine-protein kinase PXC3', NULL, NULL, NULL, NULL, NULL, 4),
(145396, NULL, 'G3DSA:3.90.550.10:FF:000269', NULL, NULL, '2-C-methyl-D-erythritol 4-phosphate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(145397, NULL, 'G3DSA:3.20.20.300:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145398, NULL, 'G3DSA:3.40.30.10:FF:000687', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(145399, NULL, 'G3DSA:3.40.50.450:FF:000077', NULL, NULL, 'ATP-dependent 6-phosphofructokinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(145400, NULL, 'G3DSA:1.20.1070.10:FF:001980', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(145401, NULL, 'G3DSA:3.40.50.620:FF:000425', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(145402, NULL, 'G3DSA:3.30.420.40:FF:000338', NULL, NULL, 'Acetate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(145403, NULL, 'G3DSA:3.30.70.330:FF:000036', NULL, NULL, 'polypyrimidine tract-binding protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(145404, NULL, 'G3DSA:3.40.50.10800:FF:000004', NULL, NULL, 'Quinolinate synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(145405, NULL, 'G3DSA:3.30.70.330:FF:001941', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145406, NULL, 'G3DSA:3.40.50.10810:FF:000007', NULL, NULL, 'Chromodomain-helicase-DNA-binding protein 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(145407, NULL, 'G3DSA:3.40.190.10:FF:000207', NULL, NULL, 'Glutamine ABC transporter substrate-binding protein GlnH', NULL, NULL, NULL, NULL, NULL, 4),
(145408, NULL, 'G3DSA:2.130.10.10:FF:000728', NULL, NULL, 'WD repeat and HMG-box DNA-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(145409, NULL, 'G3DSA:2.60.34.10:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145410, NULL, 'G3DSA:1.20.920.30:FF:000046', NULL, NULL, 'Si:dkey-11m19.5', NULL, NULL, NULL, NULL, NULL, 4),
(145411, NULL, 'G3DSA:3.20.100.10:FF:000015', NULL, NULL, 'mRNA-capping enzyme subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(145412, NULL, 'G3DSA:3.40.50.1370:FF:000003', NULL, NULL, 'Ornithine carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(145413, NULL, 'G3DSA:1.10.246.90:FF:000004', NULL, NULL, 'Nucleolar protein 58', NULL, NULL, NULL, NULL, NULL, 4),
(145414, NULL, 'G3DSA:2.60.40.150:FF:000664', NULL, NULL, 'Copine, putative', NULL, NULL, NULL, NULL, NULL, 4),
(145415, NULL, 'G3DSA:3.30.160.60:FF:002549', NULL, NULL, 'Si:ch73-92e7.4', NULL, NULL, NULL, NULL, NULL, 4),
(145416, NULL, 'G3DSA:1.20.58.60:FF:000175', NULL, NULL, 'dystrophin, isoforms A/C/F/G/H isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(145417, NULL, 'G3DSA:1.10.10.60:FF:000717', NULL, NULL, 'Putative acetoin operon transcriptional activator', NULL, NULL, NULL, NULL, NULL, 4),
(145418, NULL, 'G3DSA:2.40.10.10:FF:000682', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145419, NULL, 'G3DSA:3.30.230.70:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145420, NULL, 'G3DSA:2.120.10.30:FF:000291', NULL, NULL, 'AGAP007095-PA', NULL, NULL, NULL, NULL, NULL, 4),
(145421, NULL, 'G3DSA:1.20.920.20:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145422, NULL, 'G3DSA:1.20.1250.20:FF:001811', NULL, NULL, 'Solute carrier family 45 member 1', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(145423, NULL, 'G3DSA:2.60.410.10:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145424, NULL, 'G3DSA:3.40.50.670:FF:000007', NULL, NULL, 'DNA gyrase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(145425, NULL, 'G3DSA:3.30.1240.10:FF:000011', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(145426, NULL, 'G3DSA:2.160.20.10:FF:000076', NULL, NULL, 'F-box domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(145427, NULL, 'G3DSA:2.60.120.200:FF:000121', NULL, NULL, 'Terribly reduced optic lobes, isoform AF', NULL, NULL, NULL, NULL, NULL, 4),
(145428, NULL, 'G3DSA:2.60.40.790:FF:000114', NULL, NULL, 'Protein CBG09701', NULL, NULL, NULL, NULL, NULL, 4),
(145429, NULL, 'G3DSA:3.30.310.50:FF:000046', NULL, NULL, 'Phosphoglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(145430, NULL, 'G3DSA:1.20.120.80:FF:000016', NULL, NULL, 'Cytochrome c oxidase subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(145431, NULL, 'G3DSA:1.10.287.110:FF:000196', NULL, NULL, 'DnaJ heat shock protein family (Hsp40) member B12b', NULL, NULL, NULL, NULL, NULL, 4),
(145432, NULL, 'G3DSA:3.30.360.10:FF:000127', NULL, NULL, 'Glucose-6-phosphate 1-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(145433, NULL, 'G3DSA:1.25.40.990:FF:000038', NULL, NULL, 'GM16907', NULL, NULL, NULL, NULL, NULL, 4),
(145434, NULL, 'G3DSA:3.30.830.10:FF:000091', NULL, NULL, 'Probable zinc protease PqqL', NULL, NULL, NULL, NULL, NULL, 4),
(145435, NULL, 'G3DSA:1.10.510.10:FF:004463', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145436, NULL, 'G3DSA:1.25.10.10:FF:002316', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(145437, NULL, 'G3DSA:3.20.20.70:FF:000738', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145438, NULL, 'G3DSA:3.30.750.200:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145439, NULL, 'G3DSA:2.60.40.10:FF:000806', NULL, NULL, 'Matrix remodeling associated 8', NULL, NULL, NULL, NULL, NULL, 4),
(145440, NULL, 'G3DSA:2.180.10.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145441, NULL, 'G3DSA:3.40.50.1820:FF:001583', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145442, NULL, 'G3DSA:1.25.10.10:FF:002086', NULL, NULL, 'Protein VAC14 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(145443, NULL, 'G3DSA:3.60.15.10:FF:000263', NULL, NULL, 'ElaC ribonuclease Z 2', NULL, NULL, NULL, NULL, NULL, 4),
(145444, NULL, 'G3DSA:2.10.25.10:FF:001038', NULL, NULL, 'Protein cueball', NULL, NULL, NULL, NULL, NULL, 4),
(145445, NULL, 'G3DSA:3.30.70.920:FF:000044', NULL, NULL, 'Transcription regulator, Lrp/AsnC family', NULL, NULL, NULL, NULL, NULL, 4),
(145446, NULL, 'G3DSA:1.20.120.950:FF:000001', NULL, NULL, 'Archaeal structural protein', NULL, NULL, NULL, NULL, NULL, 4),
(145447, NULL, 'G3DSA:3.10.20.70:FF:000019', NULL, NULL, 'Glutamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(145448, NULL, 'G3DSA:2.120.10.10:FF:000021', NULL, NULL, 'Neuraminidase', NULL, NULL, NULL, NULL, NULL, 4),
(145449, NULL, 'G3DSA:2.60.120.650:FF:000233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145450, NULL, 'G3DSA:3.90.1300.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145451, NULL, 'G3DSA:2.40.70.10:FF:000293', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145452, NULL, 'G3DSA:1.20.120.430:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145453, NULL, 'G3DSA:3.30.565.10:FF:000148', NULL, NULL, 'Stage II sporulation protein E', NULL, NULL, NULL, NULL, NULL, 4),
(145454, NULL, 'G3DSA:1.25.40.10:FF:002762', NULL, NULL, 'YALI0A07821p', NULL, NULL, NULL, NULL, NULL, 4),
(145455, NULL, 'G3DSA:3.30.200.20:FF:002154', NULL, NULL, 'TrkA', NULL, NULL, NULL, NULL, NULL, 4),
(145456, NULL, 'G3DSA:3.30.230.10:FF:000410', NULL, NULL, 'DNA repair protein RadA', NULL, NULL, NULL, NULL, NULL, 4),
(145457, NULL, 'G3DSA:3.30.420.40:FF:000490', NULL, NULL, 'Actin-like ATPase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(145458, NULL, 'G3DSA:3.30.200.20:FF:000911', NULL, NULL, 'Protein CBR-KSR-1', NULL, NULL, NULL, NULL, NULL, 4),
(145459, NULL, 'G3DSA:1.10.510.10:FF:000129', NULL, NULL, 'cysteine-rich receptor-like protein kinase 10', NULL, NULL, NULL, NULL, NULL, 4),
(145460, NULL, 'G3DSA:3.80.10.10:FF:002994', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145461, NULL, 'G3DSA:1.10.400.10:FF:000071', NULL, NULL, 'Guanine nucleotide-binding protein alpha-2 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(145462, NULL, 'G3DSA:3.40.630.10:FF:000236', NULL, NULL, 'Probable aspartoacylase', NULL, NULL, NULL, NULL, NULL, 4),
(145463, NULL, 'G3DSA:3.30.1320.10:FF:000012', NULL, NULL, '37S ribosomal protein S16', NULL, NULL, NULL, NULL, NULL, 4),
(145464, NULL, 'G3DSA:2.60.40.60:FF:000737', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145465, NULL, 'G3DSA:3.40.190.10:FF:000533', NULL, NULL, 'Hydroxymethylbilane synthase', NULL, NULL, NULL, NULL, NULL, 4),
(145466, NULL, 'G3DSA:3.40.50.300:FF:006574', NULL, NULL, 'ATP-dependent DNA helicase-like PIF8', NULL, NULL, NULL, NULL, NULL, 4),
(145467, NULL, 'G3DSA:2.40.50.140:FF:000701', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145468, NULL, 'G3DSA:2.120.10.30:FF:000521', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145469, NULL, 'G3DSA:3.30.565.10:FF:000423', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(145470, NULL, 'G3DSA:3.30.40.10:FF:001733', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145471, NULL, 'G3DSA:2.40.70.10:FF:000242', NULL, NULL, 'Acid protease', NULL, NULL, NULL, NULL, NULL, 4),
(145472, NULL, 'G3DSA:3.30.160.60:FF:000346', NULL, NULL, 'zinc finger and BTB domain-containing protein 17 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(145473, NULL, 'G3DSA:1.10.10.10:FF:001973', NULL, NULL, 'Putative HTH-type transcriptional regulator aq_268', NULL, NULL, NULL, NULL, NULL, 4),
(145474, NULL, 'G3DSA:3.30.450.40:FF:000059', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(145475, NULL, 'G3DSA:1.10.510.10:FF:002372', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145476, NULL, 'G3DSA:3.10.100.10:FF:000444', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145477, NULL, 'G3DSA:3.40.50.300:FF:002584', NULL, NULL, 'Helicase in mitochondria', NULL, NULL, NULL, NULL, NULL, 4),
(145478, NULL, 'G3DSA:3.40.50.720:FF:001793', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(145479, NULL, 'G3DSA:3.10.20.90:FF:000363', NULL, NULL, 'Ubiquitin regulatory X', NULL, NULL, NULL, NULL, NULL, 4),
(145480, NULL, 'G3DSA:2.40.50.140:FF:000471', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(145481, NULL, 'G3DSA:3.30.450.30:FF:000056', NULL, NULL, 'MglB protein', NULL, NULL, NULL, NULL, NULL, 4),
(145482, NULL, 'G3DSA:3.40.630.30:FF:000394', NULL, NULL, 'Putative N-acetyltransferase YjaB', NULL, NULL, NULL, NULL, NULL, 4),
(145483, NULL, 'G3DSA:3.30.420.40:FF:000557', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(145484, NULL, 'G3DSA:1.10.300.10:FF:000012', NULL, NULL, 'Adenylosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(145485, NULL, 'G3DSA:3.90.550.10:FF:000325', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(145486, NULL, 'G3DSA:3.30.160.60:FF:001240', NULL, NULL, 'zinc finger and BTB domain-containing protein 7A', NULL, NULL, NULL, NULL, NULL, 4),
(145487, NULL, 'G3DSA:2.60.40.10:FF:005011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145488, NULL, 'G3DSA:3.30.450.20:FF:000053', NULL, NULL, 'Sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(145489, NULL, 'G3DSA:2.60.40.10:FF:002370', NULL, NULL, 'Collagen alpha-3(VI) chain', NULL, NULL, NULL, NULL, NULL, 4),
(145490, NULL, 'G3DSA:3.40.50.620:FF:000206', NULL, NULL, 'Universal stress protein family protein', NULL, NULL, NULL, NULL, NULL, 4),
(145491, NULL, 'G3DSA:1.10.357.10:FF:000053', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(145492, NULL, 'G3DSA:3.40.50.10810:FF:000119', NULL, NULL, 'CSB (Cockayne Syndrome B) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(145493, NULL, 'G3DSA:3.40.50.2300:FF:000552', NULL, NULL, 'Avr9/Cf-9 rapidly elicited protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(145494, NULL, 'G3DSA:3.30.70.980:FF:000034', NULL, NULL, 'Probable transcriptional regulatory protein Tnap_0248', NULL, NULL, NULL, NULL, NULL, 4),
(145495, NULL, 'G3DSA:3.30.40.10:FF:000373', NULL, NULL, 'Tripartite motif-containing protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(145496, NULL, 'G3DSA:3.90.920.10:FF:000016', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(145497, NULL, 'G3DSA:3.40.30.10:FF:000962', NULL, NULL, 'Iodothyronine deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(145498, NULL, 'G3DSA:3.40.50.880:FF:000071', NULL, NULL, 'Peptidase E', NULL, NULL, NULL, NULL, NULL, 4),
(145499, NULL, 'G3DSA:1.25.40.10:FF:000901', NULL, NULL, 'DnaJ homolog subfamily C member 7', NULL, NULL, NULL, NULL, NULL, 4),
(145500, NULL, 'G3DSA:1.20.1080.10:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145501, NULL, 'G3DSA:3.30.470.30:FF:000091', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(145502, NULL, 'G3DSA:3.60.40.10:FF:000006', NULL, NULL, 'Pyruvate dehyrogenase phosphatase catalytic subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(145503, NULL, 'G3DSA:3.90.640.10:FF:000034', NULL, NULL, 'Actin-related protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(145504, NULL, 'G3DSA:2.130.10.10:FF:004500', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145505, NULL, 'G3DSA:3.30.160.60:FF:004617', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145506, NULL, 'G3DSA:3.30.70.330:FF:000255', NULL, NULL, 'Regulator of nonsense transcripts UPF3', NULL, NULL, NULL, NULL, NULL, 4),
(145507, NULL, 'G3DSA:3.30.9.10:FF:000149', NULL, NULL, 'D-amino acid oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(145508, NULL, 'G3DSA:2.10.70.10:FF:000159', NULL, NULL, 'Furrowed, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(145509, NULL, 'G3DSA:1.20.58.60:FF:000405', NULL, NULL, 'Spectrin repeat containing nuclear envelope protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(145510, NULL, 'G3DSA:3.40.30.10:FF:000748', NULL, NULL, 'All0195 protein', NULL, NULL, NULL, NULL, NULL, 4),
(145511, NULL, 'G3DSA:1.10.238.10:FF:000597', NULL, NULL, 'Putative mitochondrial carrier isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(145512, NULL, 'G3DSA:1.10.10.60:FF:000543', NULL, NULL, 'Homeobox and leucine zipper encoding a', NULL, NULL, NULL, NULL, NULL, 4),
(145513, NULL, 'G3DSA:2.10.25.10:FF:000875', NULL, NULL, 'Vacuolar-sorting receptor 6', NULL, NULL, NULL, NULL, NULL, 4),
(145514, NULL, 'G3DSA:3.40.980.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145515, NULL, 'G3DSA:1.10.238.10:FF:000653', NULL, NULL, 'EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(145516, NULL, 'G3DSA:3.40.50.300:FF:005113', NULL, NULL, 'Translocase of chloroplast', NULL, NULL, NULL, NULL, NULL, 4),
(145517, NULL, 'G3DSA:1.20.1270.10:FF:000005', NULL, NULL, 'heat shock cognate 70 kDa protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(145518, NULL, 'G3DSA:2.60.210.10:FF:000063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145519, NULL, 'G3DSA:2.60.40.10:FF:004168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145520, NULL, 'G3DSA:1.20.144.10:FF:000039', NULL, NULL, 'PhosphoLipid PhosPhatase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(145521, NULL, 'G3DSA:3.20.20.220:FF:000074', NULL, NULL, 'Methylenetetrahydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(145522, NULL, 'G3DSA:2.30.29.30:FF:000231', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(145523, NULL, 'G3DSA:1.10.10.60:FF:000195', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(145524, NULL, 'G3DSA:1.10.287.70:FF:000104', NULL, NULL, 'Two pore calcium channel protein 2', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(145525, NULL, 'G3DSA:1.20.1230.10:FF:000003', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(145526, NULL, 'G3DSA:3.40.50.800:FF:000030', NULL, NULL, 'Histidine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(145527, NULL, 'G3DSA:3.40.50.720:FF:000118', NULL, NULL, 'Glutamate synthase small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(145528, NULL, 'G3DSA:1.10.510.10:FF:002821', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145529, NULL, 'G3DSA:1.10.532.10:FF:000005', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(145530, NULL, 'G3DSA:1.20.1270.20:FF:000008', NULL, NULL, 'Hybrid-cluster protein', NULL, NULL, NULL, NULL, NULL, 4),
(145531, NULL, 'G3DSA:1.10.510.10:FF:001242', NULL, NULL, 'Leucine-rich repeat serine/threonine-protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(145532, NULL, 'G3DSA:2.30.180.10:FF:000179', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145533, NULL, 'G3DSA:1.10.132.60:FF:000029', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(145534, NULL, 'G3DSA:3.30.2160.10:FF:000033', NULL, NULL, 'Ubiquitin protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(145535, NULL, 'G3DSA:3.80.10.10:FF:001471', NULL, NULL, 'Pollen-specific leucine-rich repeat extensin-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(145536, NULL, 'G3DSA:1.25.10.10:FF:001012', NULL, NULL, 'Pre-rRNA-processing protein ipi1', NULL, NULL, NULL, NULL, NULL, 4),
(145537, NULL, 'G3DSA:2.130.10.10:FF:000880', NULL, NULL, 'U3 small nucleolar RNA-associated protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(145538, NULL, 'G3DSA:2.40.70.10:FF:000186', NULL, NULL, 'Os06g0119600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(145539, NULL, 'G3DSA:2.30.29.30:FF:000175', NULL, NULL, 'switch-associated protein 70 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(145540, NULL, 'G3DSA:3.40.50.1460:FF:000030', NULL, NULL, 'GM15423', NULL, NULL, NULL, NULL, NULL, 4),
(145541, NULL, 'G3DSA:3.30.200.20:FF:000916', NULL, NULL, 'Putative Serine/threonine-protein kinase pim-3', NULL, NULL, NULL, NULL, NULL, 4),
(145542, NULL, 'G3DSA:2.60.120.200:FF:000126', NULL, NULL, 'usherin', NULL, NULL, NULL, NULL, NULL, 4),
(145543, NULL, 'G3DSA:3.40.50.980:FF:000056', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(145544, NULL, 'G3DSA:3.30.40.10:FF:001059', NULL, NULL, 'RING-H2 finger protein ATL22', NULL, NULL, NULL, NULL, NULL, 4),
(145545, NULL, 'G3DSA:3.40.50.2300:FF:000226', NULL, NULL, 'Sigma-54-dependent Fis family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(145546, NULL, 'G3DSA:2.60.120.1560:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(145547, NULL, 'G3DSA:3.90.70.10:FF:000434', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145548, NULL, 'G3DSA:3.90.550.10:FF:000763', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(145549, NULL, 'G3DSA:3.30.160.60:FF:004680', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145550, NULL, 'G3DSA:2.60.220.50:FF:000053', NULL, NULL, 'Adhesion G protein-coupled receptor G3', NULL, NULL, NULL, NULL, NULL, 4),
(145551, NULL, 'G3DSA:3.30.160.60:FF:000677', NULL, NULL, 'zinc finger protein 76 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(145552, NULL, 'G3DSA:3.40.366.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145553, NULL, 'G3DSA:3.40.50.1580:FF:000004', NULL, NULL, 'Purine nucleoside phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(145554, NULL, 'G3DSA:4.10.80.160:FF:000004', NULL, NULL, 'Unplaced genomic scaffold supercont2.8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(145555, NULL, 'G3DSA:2.60.40.10:FF:002993', NULL, NULL, 'AGAP003656-PB', NULL, NULL, NULL, NULL, NULL, 4),
(145556, NULL, 'G3DSA:3.50.50.60:FF:000522', NULL, NULL, 'Oleate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(145557, NULL, 'G3DSA:1.10.287.110:FF:000089', NULL, NULL, 'Related to DnaJ homolog subfamily C member 3', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(145558, NULL, 'G3DSA:2.130.10.10:FF:004444', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145559, NULL, 'G3DSA:3.40.109.10:FF:000019', NULL, NULL, '5,6-dimethylbenzimidazole synthase', NULL, NULL, NULL, NULL, NULL, 4),
(145560, NULL, 'G3DSA:1.10.533.10:FF:000266', NULL, NULL, 'Baculoviral IAP repeat containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(145561, NULL, 'G3DSA:1.10.1450.10:FF:000168', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(145562, NULL, 'G3DSA:3.90.550.10:FF:000437', NULL, NULL, 'Galactosylgalactosylxylosylprotein 3-beta-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(145563, NULL, 'G3DSA:3.30.565.10:FF:000535', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(145564, NULL, 'G3DSA:2.60.120.560:FF:000032', NULL, NULL, 'Putative invertase', NULL, NULL, NULL, NULL, NULL, 4),
(145565, NULL, 'G3DSA:2.60.200.20:FF:000184', NULL, NULL, 'FHA domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(145566, NULL, 'G3DSA:1.25.10.10:FF:000843', NULL, NULL, 'Vacuole morphology and inheritance protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(145567, NULL, 'G3DSA:3.30.1370.50:FF:000004', NULL, NULL, 'NFKB repressing factor', NULL, NULL, NULL, NULL, NULL, 4),
(145568, NULL, 'G3DSA:3.40.50.300:FF:000167', NULL, NULL, 'Cell division control protein 42 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(145569, NULL, 'G3DSA:3.40.50.300:FF:008098', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(145570, NULL, 'G3DSA:3.10.110.10:FF:000237', NULL, NULL, 'Ubiquitin-conjugating enzyme E2-21.2 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(145571, NULL, 'G3DSA:1.25.40.10:FF:000345', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(145572, NULL, 'G3DSA:3.10.20.30:FF:000036', NULL, NULL, 'Naphthalene 1,2-dioxygenase reductase component', NULL, NULL, NULL, NULL, NULL, 4),
(145573, NULL, 'G3DSA:1.10.790.10:FF:000003', NULL, NULL, 'Prion protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(145574, NULL, 'G3DSA:3.90.70.10:FF:000092', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(145575, NULL, 'G3DSA:2.40.160.50:FF:000002', NULL, NULL, 'sorting and assembly machinery component 50 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(145576, NULL, 'G3DSA:3.90.550.10:FF:000095', NULL, NULL, 'Glycosyltransferase family protein 64 protein C5', NULL, NULL, NULL, NULL, NULL, 4),
(145577, NULL, 'G3DSA:3.90.79.10:FF:000173', NULL, NULL, 'Macaca fascicularis brain cDNA clone: QtrA-18315, similar to human fibroblast growth factor 2 (basic) (FGF2), mRNA, RefSeq: NM_002006.3', NULL, NULL, NULL, NULL, NULL, 4),
(145578, NULL, 'G3DSA:1.25.40.10:FF:003774', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145579, NULL, 'G3DSA:3.40.50.170:FF:000026', NULL, NULL, 'Phosphoribosylglycinamide formyltransferase protein', NULL, NULL, NULL, NULL, NULL, 4),
(145580, NULL, 'G3DSA:1.20.5.730:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145581, NULL, 'G3DSA:1.20.58.1880:FF:000004', NULL, NULL, 'nuclear receptor corepressor 1 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(145582, NULL, 'G3DSA:3.30.70.330:FF:000581', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein A0', NULL, NULL, NULL, NULL, NULL, 4),
(145583, NULL, 'G3DSA:3.30.160.40:FF:000014', NULL, NULL, 'Probable porphobilinogen deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(145584, NULL, 'G3DSA:3.30.565.10:FF:000193', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(145585, NULL, 'G3DSA:1.10.490.10:FF:000014', NULL, NULL, 'Hemoglobin subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(145586, NULL, 'G3DSA:3.40.640.10:FF:000113', NULL, NULL, 'Probable glycine dehydrogenase (decarboxylating) subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(145587, NULL, 'G3DSA:3.40.50.300:FF:002589', NULL, NULL, 'Putative AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(145588, NULL, 'G3DSA:1.20.1560.10:FF:000106', NULL, NULL, 'Yersiniabactin ABC transporter ATP-binding/permease protein YbtP', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(145589, NULL, 'G3DSA:1.25.40.10:FF:001868', NULL, NULL, 'Adenylyl cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(145590, NULL, 'G3DSA:1.20.1640.10:FF:000107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145591, NULL, 'G3DSA:1.20.870.10:FF:000007', NULL, NULL, 'Ras-GEF domain-containing family member 1B', NULL, NULL, NULL, NULL, NULL, 4),
(145592, NULL, 'G3DSA:3.10.20.10:FF:000030', NULL, NULL, '60S ribosomal protein L18a', NULL, NULL, NULL, NULL, NULL, 4),
(145593, NULL, 'G3DSA:2.70.150.10:FF:000264', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(145594, NULL, 'G3DSA:1.10.420.10:FF:000015', NULL, NULL, 'Cytochrome c peroxidase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(145595, NULL, 'G3DSA:2.60.40.10:FF:002375', NULL, NULL, 'Sushi, nidogen and EGF-like domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(145596, NULL, 'G3DSA:1.25.10.10:FF:002642', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145597, NULL, 'G3DSA:2.40.30.130:FF:000037', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(145598, NULL, 'G3DSA:2.60.40.60:FF:000956', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145599, NULL, 'G3DSA:3.40.50.880:FF:000183', NULL, NULL, 'Glutamine amidotransferase class-I, putative', NULL, NULL, NULL, NULL, NULL, 4),
(145600, NULL, 'G3DSA:3.40.1260.10:FF:000010', NULL, NULL, 'DsrE family protein', NULL, NULL, NULL, NULL, NULL, 4),
(145601, NULL, 'G3DSA:1.25.40.10:FF:002144', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(145602, NULL, 'G3DSA:3.40.1380.20:FF:000067', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(145603, NULL, 'G3DSA:3.40.50.80:FF:000091', NULL, NULL, 'NADPH oxidase 4', NULL, NULL, NULL, NULL, NULL, 4),
(145604, NULL, 'G3DSA:1.25.40.20:FF:000909', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145605, NULL, 'G3DSA:1.25.40.10:FF:001975', NULL, NULL, 'Tetratricopeptide-like helical', NULL, NULL, NULL, NULL, NULL, 4),
(145606, NULL, 'G3DSA:2.130.10.10:FF:000554', NULL, NULL, 'Vacuolar protein sorting-associated protein 41 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(145607, NULL, 'G3DSA:2.10.25.10:FF:001583', NULL, NULL, 'Thrombospondin 4', NULL, NULL, NULL, NULL, NULL, 4),
(145608, NULL, 'G3DSA:1.10.287.110:FF:000145', NULL, NULL, 'Chaperone protein dnaJ 20, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(145609, NULL, 'G3DSA:3.30.830.10:FF:000265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145610, NULL, 'G3DSA:1.20.1250.20:FF:002300', NULL, NULL, 'AFR602Wp', NULL, NULL, NULL, NULL, NULL, 4),
(145611, NULL, 'G3DSA:1.20.120.1080:FF:000002', NULL, NULL, 'Putative ATP-dependent RNA helicase DHX36', NULL, NULL, NULL, NULL, NULL, 4),
(145612, NULL, 'G3DSA:2.60.40.60:FF:000782', NULL, NULL, 'Cadherin 24, type 2a', NULL, NULL, NULL, NULL, NULL, 4),
(145613, NULL, 'G3DSA:1.10.1200.80:FF:000002', NULL, NULL, 'tRNA-dihydrouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(145614, NULL, 'G3DSA:1.25.40.680:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145615, NULL, 'G3DSA:3.30.160.60:FF:006416', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145616, NULL, 'G3DSA:1.25.40.470:FF:000040', NULL, NULL, 'Intraflagellar transport protein osm-1', NULL, NULL, NULL, NULL, NULL, 4),
(145617, NULL, 'G3DSA:3.90.76.10:FF:000043', NULL, NULL, 'Peptide ABC transporter, periplasmic peptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(145618, NULL, 'G3DSA:2.60.40.1450:FF:000012', NULL, NULL, 'Transcription factor cbf12', NULL, NULL, NULL, NULL, NULL, 4),
(145619, NULL, 'G3DSA:2.70.170.10:FF:000147', NULL, NULL, '5-hydroxytryptamine receptor 3D', NULL, NULL, NULL, NULL, NULL, 4),
(145620, NULL, 'G3DSA:2.160.20.10:FF:000020', NULL, NULL, 'SHC SH2 domain-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(145621, NULL, 'G3DSA:3.40.640.10:FF:000405', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(145622, NULL, 'G3DSA:1.10.150.670:FF:000004', NULL, NULL, 'Crossover junction endonuclease EME1', NULL, NULL, NULL, NULL, NULL, 4),
(145623, NULL, 'G3DSA:1.25.10.10:FF:000169', NULL, NULL, 'protein VAC14 homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(145624, NULL, 'G3DSA:3.30.70.141:FF:000002', NULL, NULL, 'Nucleoside diphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(145625, NULL, 'G3DSA:2.40.10.10:FF:000019', NULL, NULL, 'Anionic trypsin', NULL, NULL, NULL, NULL, NULL, 4),
(145626, NULL, 'G3DSA:1.10.287.1490:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145627, NULL, 'G3DSA:3.40.50.1820:FF:001695', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(145628, NULL, 'G3DSA:3.30.450.20:FF:000160', NULL, NULL, 'PAS domain containing repressor 1', NULL, NULL, NULL, NULL, NULL, 4),
(145629, NULL, 'G3DSA:3.40.50.980:FF:000005', NULL, NULL, 'Acyl-CoA synthetase family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(145630, NULL, 'G3DSA:1.10.418.10:FF:000072', NULL, NULL, 'microtubule-associated protein RP/EB family member 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(145631, NULL, 'G3DSA:2.130.10.30:FF:000150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145632, NULL, 'G3DSA:1.10.472.10:FF:000236', NULL, NULL, 'Cyclin, N-terminal domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(145633, NULL, 'G3DSA:3.30.160.60:FF:000784', NULL, NULL, 'Zinc finger protein 180', NULL, NULL, NULL, NULL, NULL, 4),
(145634, NULL, 'G3DSA:3.40.50.970:FF:000002', NULL, NULL, '2-oxoglutarate dehydrogenase, E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(145635, NULL, 'G3DSA:3.30.70.240:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145636, NULL, 'G3DSA:2.60.40.720:FF:000003', NULL, NULL, 'Cellular tumor antigen p53', NULL, NULL, NULL, NULL, NULL, 4),
(145637, NULL, 'G3DSA:3.40.1000.50:FF:000008', NULL, NULL, 'Maf1 regulator', NULL, NULL, NULL, NULL, NULL, 4),
(145638, NULL, 'G3DSA:3.40.50.2000:FF:000911', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145639, NULL, 'G3DSA:3.30.70.330:FF:000311', NULL, NULL, 'polyadenylate-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(145640, NULL, 'G3DSA:3.40.50.300:FF:008373', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(145641, NULL, 'G3DSA:3.10.20.90:FF:000649', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145642, NULL, 'G3DSA:2.60.260.20:FF:000069', NULL, NULL, 'Molecular chaperone DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(145643, NULL, 'G3DSA:2.60.40.790:FF:000058', NULL, NULL, 'CS domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(145644, NULL, 'G3DSA:3.40.640.10:FF:000057', NULL, NULL, 'Phosphoserine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(145645, NULL, 'G3DSA:2.60.40.1460:FF:000015', NULL, NULL, 'Integrin alpha 3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(145646, NULL, 'G3DSA:1.20.1250.20:FF:001755', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145647, NULL, 'G3DSA:1.20.1250.20:FF:002244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145648, NULL, 'G3DSA:3.30.450.40:FF:000166', NULL, NULL, 'GGDEF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(145649, NULL, 'G3DSA:1.20.1560.10:FF:000432', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(145650, NULL, 'G3DSA:3.40.190.290:FF:000137', NULL, NULL, 'Transcriptional regulator lysR family', NULL, NULL, NULL, NULL, NULL, 4),
(145651, NULL, 'G3DSA:3.30.200.20:FF:001934', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145652, NULL, 'G3DSA:2.60.40.60:FF:000563', NULL, NULL, 'Cadherin 5', NULL, NULL, NULL, NULL, NULL, 4),
(145653, NULL, 'G3DSA:2.40.160.120:FF:000019', NULL, NULL, 'Oxysterol binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(145654, NULL, 'G3DSA:3.90.1150.10:FF:000327', NULL, NULL, 'Aminotransferase class I and II', NULL, NULL, NULL, NULL, NULL, 4),
(145655, NULL, 'G3DSA:1.25.40.10:FF:000289', NULL, NULL, 'RNA polymerase-associated protein CTR9 homolog', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(145656, NULL, 'G3DSA:1.10.150.20:FF:000205', NULL, NULL, 'GH27547p', NULL, NULL, NULL, NULL, NULL, 4),
(145657, NULL, 'G3DSA:3.30.450.40:FF:000115', NULL, NULL, 'Transcriptional regulator, IclR family', NULL, NULL, NULL, NULL, NULL, 4),
(145658, NULL, 'G3DSA:1.20.58.480:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145659, NULL, 'G3DSA:1.10.510.10:FF:002546', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(145660, NULL, 'G3DSA:1.10.240.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145661, NULL, 'G3DSA:2.40.160.110:FF:000016', NULL, NULL, 'FI04419p', NULL, NULL, NULL, NULL, NULL, 4),
(145662, NULL, 'G3DSA:2.10.25.10:FF:001364', NULL, NULL, 'Wall-associated receptor kinase-like 8', NULL, NULL, NULL, NULL, NULL, 4),
(145663, NULL, 'G3DSA:3.30.200.20:FF:000175', NULL, NULL, 'Serine/threonine-protein kinase 17B', NULL, NULL, NULL, NULL, NULL, 4),
(145664, NULL, 'G3DSA:3.30.1360.210:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145665, NULL, 'G3DSA:3.30.1330.50:FF:000002', NULL, NULL, '2-C-methyl-D-erythritol 2,4-cyclodiphosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(145666, NULL, 'G3DSA:2.40.30.170:FF:000026', NULL, NULL, 'HlyD family secretion protein', NULL, NULL, NULL, NULL, NULL, 4),
(145667, NULL, 'G3DSA:2.60.40.1660:FF:000018', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit beta-1', NULL, NULL, NULL, NULL, NULL, 4),
(145668, NULL, 'G3DSA:3.30.40.10:FF:001677', NULL, NULL, 'Hrdl-1', NULL, NULL, NULL, NULL, NULL, 4),
(145669, NULL, 'G3DSA:3.90.1100.10:FF:000049', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(145670, NULL, 'G3DSA:3.30.420.40:FF:000613', NULL, NULL, 'Actin-related protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(145671, NULL, 'G3DSA:3.50.50.60:FF:000814', NULL, NULL, 'FAD-dependent pyridine nucleotide-disulfide oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(145672, NULL, 'G3DSA:1.20.1070.10:FF:001985', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(145673, NULL, 'G3DSA:1.25.40.10:FF:002470', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(145674, NULL, 'G3DSA:1.25.10.10:FF:000787', NULL, NULL, 'TATA-binding protein-associated factor BTAF1', NULL, NULL, NULL, NULL, NULL, 4),
(145675, NULL, 'G3DSA:2.60.200.20:FF:000240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145676, NULL, 'G3DSA:1.10.20.10:FF:000377', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145677, NULL, 'G3DSA:2.40.10.10:FF:000637', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145678, NULL, 'G3DSA:3.30.1360.200:FF:000004', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(145679, NULL, 'G3DSA:3.30.200.20:FF:002480', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145680, NULL, 'G3DSA:1.20.1530.20:FF:000046', NULL, NULL, 'Cation/H(+) antiporter 28', NULL, NULL, NULL, NULL, NULL, 4),
(145681, NULL, 'G3DSA:2.60.40.60:FF:001119', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(145682, NULL, 'G3DSA:3.40.50.11020:FF:000003', NULL, NULL, 'Replicase polyprotein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(145683, NULL, 'G3DSA:1.10.10.60:FF:000594', NULL, NULL, 'Pre-mRNA-splicing factor CEF1', NULL, NULL, NULL, NULL, NULL, 4),
(145684, NULL, 'G3DSA:3.40.50.970:FF:000053', NULL, NULL, 'Acetolactate synthase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(145685, NULL, 'G3DSA:3.40.50.300:FF:007878', NULL, NULL, 'Si:dkey-11m19.5', NULL, NULL, NULL, NULL, NULL, 4),
(145686, NULL, 'G3DSA:3.40.50.2000:FF:000350', NULL, NULL, 'UDP-GlcNAc:PI a1-6 GlcNAc-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(145687, NULL, 'G3DSA:3.90.190.10:FF:000050', NULL, NULL, 'Dual specificity phosphatase 16 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(145688, NULL, 'G3DSA:1.10.20.10:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(145689, NULL, 'G3DSA:3.50.50.60:FF:000466', NULL, NULL, 'L-ornithine N(5)-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(145690, NULL, 'G3DSA:1.20.1050.10:FF:000017', NULL, NULL, 'Maleylacetoacetate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(145691, NULL, 'G3DSA:1.20.58.390:FF:000199', NULL, NULL, 'Ligand-gated ion channel', NULL, NULL, NULL, NULL, NULL, 4),
(145692, NULL, 'G3DSA:3.40.50.300:FF:001280', NULL, NULL, 'Related to 6-phosphofructo-2-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(145693, NULL, 'G3DSA:2.120.10.80:FF:000339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145694, NULL, 'G3DSA:3.30.530.20:FF:000161', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(145695, NULL, 'G3DSA:3.90.190.20:FF:000053', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(145696, NULL, 'G3DSA:3.30.40.10:FF:002166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145697, NULL, 'G3DSA:3.40.50.300:FF:001010', NULL, NULL, 'ABC multidrug transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(145698, NULL, 'G3DSA:2.60.40.10:FF:004909', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145699, NULL, 'G3DSA:3.30.200.20:FF:002210', NULL, NULL, 'Tribbles pseudokinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(145700, NULL, 'G3DSA:3.40.190.10:FF:000426', NULL, NULL, 'HTH-type transcriptional regulator IlvY', NULL, NULL, NULL, NULL, NULL, 4),
(145701, NULL, 'G3DSA:3.40.50.300:FF:004657', NULL, NULL, 'Protein transport protein HofB homolog', NULL, NULL, NULL, NULL, NULL, 4),
(145702, NULL, 'G3DSA:3.30.1370.10:FF:000054', NULL, NULL, 'Fragile X mental retardation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(145703, NULL, 'G3DSA:2.120.10.30:FF:000353', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145704, NULL, 'G3DSA:3.40.50.300:FF:000791', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NBP35', NULL, NULL, NULL, NULL, NULL, 4),
(145705, NULL, 'G3DSA:3.90.70.10:FF:000378', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145706, NULL, 'G3DSA:1.25.10.10:FF:001063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145707, NULL, 'G3DSA:1.10.238.10:FF:000378', NULL, NULL, 'Protein S100-A9', NULL, NULL, NULL, NULL, NULL, 4),
(145708, NULL, 'G3DSA:3.90.226.10:FF:000347', NULL, NULL, 'Propionyl-CoA carboxylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(145709, NULL, 'G3DSA:1.10.287.950:FF:000048', NULL, NULL, 'Heme-based aerotactic transducer HemAT', NULL, NULL, NULL, NULL, NULL, 4),
(145710, NULL, 'G3DSA:3.30.60.190:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145711, NULL, 'G3DSA:2.160.20.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145712, NULL, 'G3DSA:1.20.1250.20:FF:001137', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(145713, NULL, 'G3DSA:1.25.10.10:FF:000517', NULL, NULL, 'Condensin-2 complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(145714, NULL, 'G3DSA:3.30.200.20:FF:001985', NULL, NULL, 'Os04g0563600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(145715, NULL, 'G3DSA:1.10.510.10:FF:002933', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145716, NULL, 'G3DSA:2.40.50.120:FF:000021', NULL, NULL, 'ADAMTS like 5', NULL, NULL, NULL, NULL, NULL, 4),
(145717, NULL, 'G3DSA:1.10.340.70:FF:000004', NULL, NULL, 'Retrovirus-related Pol polyprotein from transposon 297-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(145718, NULL, 'G3DSA:2.160.20.70:FF:000009', NULL, NULL, 'Tubulin-folding cofactor C', NULL, NULL, NULL, NULL, NULL, 4),
(145719, NULL, 'G3DSA:3.40.50.300:FF:004949', NULL, NULL, 'LIP1/RABL3-like protein, Ras superfamily GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(145720, NULL, 'G3DSA:2.30.30.100:FF:000081', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm8p', NULL, NULL, NULL, NULL, NULL, 4),
(145721, NULL, 'G3DSA:2.60.260.20:FF:000182', NULL, NULL, 'Chaperone protein dnaJ A6 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(145722, NULL, 'G3DSA:2.130.10.10:FF:003988', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145723, NULL, 'G3DSA:2.30.29.30:FF:001209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145724, NULL, 'G3DSA:2.130.10.10:FF:000279', NULL, NULL, 'POC1 centriolar protein homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(145725, NULL, 'G3DSA:3.30.160.60:FF:005112', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145726, NULL, 'G3DSA:3.40.50.2000:FF:000170', NULL, NULL, 'Probable glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(145727, NULL, 'G3DSA:1.25.70.10:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145728, NULL, 'G3DSA:3.40.50.1820:FF:000621', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(145729, NULL, 'G3DSA:2.130.10.10:FF:001858', NULL, NULL, 'Blast:Phosphoinositide 3-kinase regulatory subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(145730, NULL, 'G3DSA:1.10.3630.10:FF:000002', NULL, NULL, 'Vacuolar sorting-associated 74 protein', NULL, NULL, NULL, NULL, NULL, 4),
(145731, NULL, 'G3DSA:1.25.40.20:FF:001130', NULL, NULL, 'Potassium channel AKT2/3', NULL, NULL, NULL, NULL, NULL, 4),
(145732, NULL, 'G3DSA:1.10.510.10:FF:002877', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145733, NULL, 'G3DSA:2.60.120.260:FF:000116', NULL, NULL, 'Beta-galactosidase 17', NULL, NULL, NULL, NULL, NULL, 4),
(145734, NULL, 'G3DSA:3.40.50.150:FF:000762', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(145735, NULL, 'G3DSA:3.30.420.40:FF:000669', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145736, NULL, 'G3DSA:3.90.70.10:FF:000647', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145737, NULL, 'G3DSA:3.80.10.10:FF:004051', NULL, NULL, 'Leucine-rich repeats and immunoglobulin-like domains 2', NULL, NULL, NULL, NULL, NULL, 4),
(145738, NULL, 'G3DSA:1.25.40.10:FF:001649', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(145739, NULL, 'G3DSA:2.60.120.330:FF:000199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145740, NULL, 'G3DSA:3.30.250.20:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145741, NULL, 'G3DSA:3.30.40.10:FF:000042', NULL, NULL, 'protein AF-10 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(145742, NULL, 'G3DSA:3.30.420.100:FF:000018', NULL, NULL, 'Structural constituent of ribosome', NULL, NULL, NULL, NULL, NULL, 4),
(145743, NULL, 'G3DSA:3.40.50.11660:FF:000003', NULL, NULL, 'Alpha-(1,4)-fucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(145744, NULL, 'G3DSA:3.90.70.10:FF:000608', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145745, NULL, 'G3DSA:3.30.40.10:FF:002222', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(145746, NULL, 'G3DSA:3.40.50.720:FF:000337', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(145747, NULL, 'G3DSA:2.40.50.140:FF:000027', NULL, NULL, '26S protease regulatory subunit 10B', NULL, NULL, NULL, NULL, NULL, 4),
(145748, NULL, 'G3DSA:3.30.40.10:FF:000081', NULL, NULL, 'Zinc finger MYND domain-containing protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(145749, NULL, 'G3DSA:1.20.1050.60:FF:000009', NULL, NULL, 'Alpha-1,2-mannosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(145750, NULL, 'G3DSA:3.30.830.10:FF:000208', NULL, NULL, 'Insulin degrading enzyme-like zinc peptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(145751, NULL, 'G3DSA:3.40.50.300:FF:002819', NULL, NULL, 'BRCA1 interacting protein C-terminal helicase 1', NULL, NULL, NULL, NULL, NULL, 4),
(145752, NULL, 'G3DSA:1.10.238.10:FF:000827', NULL, NULL, 'Calcium-binding EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(145753, NULL, 'G3DSA:2.40.30.10:FF:000352', NULL, NULL, 'Putative tRNA-methyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(145754, NULL, 'G3DSA:3.40.50.300:FF:000728', NULL, NULL, 'ADP-ribosylation factor-like protein 5', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(145755, NULL, 'G3DSA:2.70.170.10:FF:000192', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(145756, NULL, 'G3DSA:3.40.50.300:FF:000678', NULL, NULL, 'Rho GTPase Rho4', NULL, NULL, NULL, NULL, NULL, 4),
(145757, NULL, 'G3DSA:2.30.30.490:FF:000040', NULL, NULL, 'DNA methyltransferase Dim-2', NULL, NULL, NULL, NULL, NULL, 4),
(145758, NULL, 'G3DSA:3.30.40.10:FF:002172', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(145759, NULL, 'G3DSA:3.80.10.10:FF:001976', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145760, NULL, 'G3DSA:4.10.800.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145761, NULL, 'G3DSA:2.160.20.60:FF:000006', NULL, NULL, 'Ferredoxin-dependent glutamate synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(145762, NULL, 'G3DSA:3.30.200.20:FF:000349', NULL, NULL, 'Anti-Muellerian hormone type-2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(145763, NULL, 'G3DSA:1.25.40.90:FF:000037', NULL, NULL, 'Enhancer of ag-4 2', NULL, NULL, NULL, NULL, NULL, 4),
(145764, NULL, 'G3DSA:3.40.50.920:FF:000009', NULL, NULL, '2-oxoglutarate ferredoxin oxidoreductase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(145765, NULL, 'G3DSA:1.20.1390.10:FF:000003', NULL, NULL, 'U4/U6 small nuclear ribonucleoprotein Prp3', NULL, NULL, NULL, NULL, NULL, 4),
(145766, NULL, 'G3DSA:2.40.50.430:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145767, NULL, 'G3DSA:3.30.1490.80:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145768, NULL, 'G3DSA:1.10.510.10:FF:000803', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(145769, NULL, 'G3DSA:4.10.60.10:FF:000261', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145770, NULL, 'G3DSA:3.40.570.10:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145771, NULL, 'G3DSA:3.30.710.10:FF:000104', NULL, NULL, 'zinc finger and BTB domain-containing protein 39', NULL, NULL, NULL, NULL, NULL, 4),
(145772, NULL, 'G3DSA:3.40.50.2300:FF:000046', NULL, NULL, 'Galactose ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(145773, NULL, 'G3DSA:2.10.25.160:FF:000008', NULL, NULL, 'Granulin b', NULL, NULL, NULL, NULL, NULL, 4),
(145774, NULL, 'G3DSA:3.30.2300.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145775, NULL, 'G3DSA:1.20.1250.20:FF:001463', NULL, NULL, 'Proton-dependent oligopeptide transport family protein', NULL, NULL, NULL, NULL, NULL, 4),
(145776, NULL, 'G3DSA:1.10.220.10:FF:000028', NULL, NULL, 'Annexin D4', NULL, NULL, NULL, NULL, NULL, 4),
(145777, NULL, 'G3DSA:2.60.40.420:FF:000200', NULL, NULL, 'AGAP008732-PA', NULL, NULL, NULL, NULL, NULL, 4),
(145778, NULL, 'G3DSA:3.50.50.60:FF:000702', NULL, NULL, 'OSJNBa0084K11.8-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(145779, NULL, 'G3DSA:1.20.1160.11:FF:000010', NULL, NULL, 'Os05g0588700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(145780, NULL, 'G3DSA:1.10.287.680:FF:000001', NULL, NULL, 'UPF0304 protein YfbU', NULL, NULL, NULL, NULL, NULL, 4),
(145781, NULL, 'G3DSA:3.20.20.140:FF:000201', NULL, NULL, 'Dihydroorotase', NULL, NULL, NULL, NULL, NULL, 4),
(145782, NULL, 'G3DSA:2.40.10.10:FF:000351', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145783, NULL, 'G3DSA:1.25.10.30:FF:000001', NULL, NULL, 'Inositol 1,4,5-trisphosphate receptor, type 2', NULL, NULL, NULL, NULL, NULL, 4),
(145784, NULL, 'G3DSA:3.90.950.10:FF:000018', NULL, NULL, 'dTTP/UTP pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(145785, NULL, 'G3DSA:3.90.1150.10:FF:000097', NULL, NULL, 'Glycine cleavage system P protein', NULL, NULL, NULL, NULL, NULL, 4),
(145786, NULL, 'G3DSA:1.10.510.10:FF:002990', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145787, NULL, 'G3DSA:1.25.40.10:FF:004448', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g66345, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(145788, NULL, 'G3DSA:2.60.40.10:FF:002549', NULL, NULL, 'Myotactin form A', NULL, NULL, NULL, NULL, NULL, 4),
(145789, NULL, 'G3DSA:1.20.1000.10:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145790, NULL, 'G3DSA:1.20.1530.20:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145791, NULL, 'G3DSA:3.30.420.40:FF:000725', NULL, NULL, 'AaceriACR184Cp', NULL, NULL, NULL, NULL, NULL, 4),
(145792, NULL, 'G3DSA:3.10.25.10:FF:000018', NULL, NULL, 'Methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(145793, NULL, 'G3DSA:3.40.50.2020:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145794, NULL, 'G3DSA:3.30.1390.20:FF:000019', NULL, NULL, '50S ribosomal protein L30', NULL, NULL, NULL, NULL, NULL, 4),
(145795, NULL, 'G3DSA:3.30.450.70:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145796, NULL, 'G3DSA:3.40.50.2300:FF:001569', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145797, NULL, 'G3DSA:3.30.40.10:FF:001497', NULL, NULL, 'FI16849p1', NULL, NULL, NULL, NULL, NULL, 4),
(145798, NULL, 'G3DSA:3.40.640.10:FF:000444', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145799, NULL, 'G3DSA:1.25.40.10:FF:002318', NULL, NULL, 'Os07g0662700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(145800, NULL, 'G3DSA:3.40.50.300:FF:008603', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145801, NULL, 'G3DSA:2.130.10.10:FF:003134', NULL, NULL, 'Ubiquitin-binding SDF ubiquitin ligase complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(145802, NULL, 'G3DSA:2.60.40.150:FF:000372', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', NULL, NULL, NULL, NULL, NULL, 4),
(145803, NULL, 'G3DSA:3.30.160.60:FF:002257', NULL, NULL, 'Zinc finger protein 540', NULL, NULL, NULL, NULL, NULL, 4),
(145804, NULL, 'G3DSA:3.40.50.300:FF:001403', NULL, NULL, 'Polyprotein P1234', NULL, NULL, NULL, NULL, NULL, 4),
(145805, NULL, 'G3DSA:3.30.559.10:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145806, NULL, 'G3DSA:1.10.3610.10:FF:000001', NULL, NULL, 'Nucleoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(145807, NULL, 'G3DSA:1.10.3730.20:FF:000058', NULL, NULL, 'EamA-like transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(145808, NULL, 'G3DSA:3.90.120.10:FF:000006', NULL, NULL, 'DNA (Cytosine-5)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(145809, NULL, 'G3DSA:3.40.630.30:FF:000101', NULL, NULL, 'N-alpha-acetyltransferase 10', NULL, NULL, NULL, NULL, NULL, 4),
(145810, NULL, 'G3DSA:2.130.10.10:FF:001004', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(145811, NULL, 'G3DSA:3.40.50.620:FF:000133', NULL, NULL, 'Isoleucyl-tRNA synthetase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(145812, NULL, 'G3DSA:3.40.50.620:FF:000190', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(145813, NULL, 'G3DSA:3.40.190.10:FF:000752', NULL, NULL, 'Bifunctional periplasmic substrate binding protein/cytoplasmic diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(145814, NULL, 'G3DSA:1.20.1250.20:FF:002250', NULL, NULL, 'Battenin', NULL, NULL, NULL, NULL, NULL, 4),
(145815, NULL, 'G3DSA:3.30.70.330:FF:002110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145816, NULL, 'G3DSA:3.40.50.300:FF:006243', NULL, NULL, 'SNF2 superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(145817, NULL, 'G3DSA:1.10.287.890:FF:000002', NULL, NULL, 'Adenylate isopentenyltransferase 5, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(145818, NULL, 'G3DSA:1.25.40.10:FF:001014', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(145819, NULL, 'G3DSA:3.30.420.110:FF:000078', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(145820, NULL, 'G3DSA:2.60.40.10:FF:001026', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(145821, NULL, 'G3DSA:1.10.8.1130:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(145822, NULL, 'G3DSA:3.90.550.10:FF:000656', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145823, NULL, 'G3DSA:3.80.10.10:FF:002701', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', NULL, NULL, NULL, NULL, NULL, 4),
(145824, NULL, 'G3DSA:3.10.20.310:FF:000047', NULL, NULL, 'Translocation and assembly module subunit TamA', NULL, NULL, NULL, NULL, NULL, 4),
(145825, NULL, 'G3DSA:1.25.40.20:FF:001017', NULL, NULL, 'Os05g0427600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(145826, NULL, 'G3DSA:2.130.10.10:FF:004770', NULL, NULL, 'AGAP000479-PA', NULL, NULL, NULL, NULL, NULL, 4),
(145827, NULL, 'G3DSA:3.10.20.90:FF:000918', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145828, NULL, 'G3DSA:3.30.160.60:FF:000964', NULL, NULL, 'zinc finger protein 507', NULL, NULL, NULL, NULL, NULL, 4),
(145829, NULL, 'G3DSA:2.160.20.10:FF:000306', NULL, NULL, 'Protein CBR-DRE-1', NULL, NULL, NULL, NULL, NULL, 4),
(145830, NULL, 'G3DSA:1.10.1070.11:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145831, NULL, 'G3DSA:2.130.10.10:FF:004882', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145832, NULL, 'G3DSA:2.120.10.80:FF:000165', NULL, NULL, 'Epithiospecifier protein', NULL, NULL, NULL, NULL, NULL, 4),
(145833, NULL, 'G3DSA:3.90.70.10:FF:000760', NULL, NULL, 'Ubiquitin-specific peptidase 2a', NULL, NULL, NULL, NULL, NULL, 4),
(145834, NULL, 'G3DSA:1.10.10.10:FF:000843', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(145835, NULL, 'G3DSA:1.10.418.10:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145836, NULL, 'G3DSA:3.30.60.30:FF:000195', NULL, NULL, 'GEO13384p1', NULL, NULL, NULL, NULL, NULL, 4),
(145837, NULL, 'G3DSA:2.60.40.60:FF:000119', NULL, NULL, 'neural-cadherin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(145838, NULL, 'G3DSA:3.30.160.60:FF:004387', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145839, NULL, 'G3DSA:3.40.50.150:FF:000487', NULL, NULL, 'tRNA wybutosine-synthesizing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(145840, NULL, 'G3DSA:1.10.472.10:FF:000528', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145841, NULL, 'G3DSA:3.10.450.10:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145842, NULL, 'G3DSA:1.20.140.100:FF:000037', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(145843, NULL, 'G3DSA:3.30.160.60:FF:001801', NULL, NULL, 'Zinc finger protein 574', NULL, NULL, NULL, NULL, NULL, 4),
(145844, NULL, 'G3DSA:1.10.10.60:FF:000268', NULL, NULL, 'Transcription factor MYB86', NULL, NULL, NULL, NULL, NULL, 4),
(145845, NULL, 'G3DSA:2.130.10.10:FF:000498', NULL, NULL, 'Striatin 3', NULL, NULL, NULL, NULL, NULL, 4),
(145846, NULL, 'G3DSA:3.40.50.300:FF:008547', NULL, NULL, 'Mitochondrial GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(145847, NULL, 'G3DSA:2.10.25.10:FF:001656', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145848, NULL, 'G3DSA:1.20.5.340:FF:000117', NULL, NULL, 'Transcriptional repressor tup11', NULL, NULL, NULL, NULL, NULL, 4),
(145849, NULL, 'G3DSA:2.130.10.10:FF:004713', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145850, NULL, 'G3DSA:1.25.40.10:FF:002650', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145851, NULL, 'G3DSA:3.30.420.40:FF:000905', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(145852, NULL, 'G3DSA:2.60.40.60:FF:000395', NULL, NULL, 'Dachsous, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(145853, NULL, 'G3DSA:2.60.40.10:FF:004792', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145854, NULL, 'G3DSA:3.90.1150.10:FF:000153', NULL, NULL, 'Glycine dehydrogenase (decarboxylating)', NULL, NULL, NULL, NULL, NULL, 4),
(145855, NULL, 'G3DSA:1.10.150.910:FF:000003', NULL, NULL, 'DNA damage-binding protein 1a', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(145856, NULL, 'G3DSA:2.60.260.20:FF:000125', NULL, NULL, 'Chaperone protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(145857, NULL, 'G3DSA:3.40.50.11660:FF:000060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145858, NULL, 'G3DSA:3.30.565.10:FF:000479', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145859, NULL, 'G3DSA:2.40.10.10:FF:000463', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145860, NULL, 'G3DSA:1.10.630.10:FF:000115', NULL, NULL, 'Cytochrome P450 monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(145861, NULL, 'G3DSA:2.20.25.10:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145862, NULL, 'G3DSA:3.40.190.10:FF:000191', NULL, NULL, 'Lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(145863, NULL, 'G3DSA:1.10.2000.10:FF:000022', NULL, NULL, 'Smoothened, frizzled class receptor', NULL, NULL, NULL, NULL, NULL, 4),
(145864, NULL, 'G3DSA:1.10.150.220:FF:000004', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(145865, NULL, 'G3DSA:3.40.50.261:FF:000004', NULL, NULL, 'ATP-citrate synthase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(145866, NULL, 'G3DSA:1.10.287.110:FF:000471', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145867, NULL, 'G3DSA:1.10.238.10:FF:000086', NULL, NULL, 'calcium-dependent protein kinase SK5', NULL, NULL, NULL, NULL, NULL, 4),
(145868, NULL, 'G3DSA:3.40.718.10:FF:000052', NULL, NULL, 'Isocitrate dehydrogenase 3 (NAD+) gamma', NULL, NULL, NULL, NULL, NULL, 4),
(145869, NULL, 'G3DSA:1.10.8.270:FF:000093', NULL, NULL, 'Rab GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(145870, NULL, 'G3DSA:1.20.1090.10:FF:000020', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(145871, NULL, 'G3DSA:3.30.70.3190:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145872, NULL, 'G3DSA:3.40.50.2000:FF:000400', NULL, NULL, 'GDP-mannose-dependent alpha-(1-6)-phosphatidylinositol dimannoside mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(145873, NULL, 'G3DSA:3.30.160.60:FF:000907', NULL, NULL, 'Zinc finger protein 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(145874, NULL, 'G3DSA:3.40.50.300:FF:000908', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(145875, NULL, 'G3DSA:1.10.20.10:FF:000338', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145876, NULL, 'G3DSA:3.30.40.10:FF:001385', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(145877, NULL, 'G3DSA:1.25.40.1010:FF:000008', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(145878, NULL, 'G3DSA:3.20.20.220:FF:000068', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(145879, NULL, 'G3DSA:1.20.1290.10:FF:000001', NULL, NULL, 'Sestrin 1', NULL, NULL, NULL, NULL, NULL, 4),
(145880, NULL, 'G3DSA:1.10.510.10:FF:004058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145881, NULL, 'G3DSA:3.30.200.20:FF:000681', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(145882, NULL, 'G3DSA:1.20.1370.10:FF:000002', NULL, NULL, 'Hemocyanin subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(145883, NULL, 'G3DSA:3.60.15.10:FF:000044', NULL, NULL, 'Hydroxyacylglutathione hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(145884, NULL, 'G3DSA:3.30.200.20:FF:000624', NULL, NULL, 'Mitogen-activated protein kinase kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(145885, NULL, 'G3DSA:3.10.20.90:FF:000975', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145886, NULL, 'G3DSA:3.40.50.300:FF:001515', NULL, NULL, 'ATP-dependent RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(145887, NULL, 'G3DSA:1.10.8.720:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145888, NULL, 'G3DSA:3.40.350.10:FF:000012', NULL, NULL, 'Xaa-Pro aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(145889, NULL, 'G3DSA:2.40.380.10:FF:000001', NULL, NULL, 'Probable ribonuclease FAU-1', NULL, NULL, NULL, NULL, NULL, 4),
(145890, NULL, 'G3DSA:3.30.830.10:FF:000321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145891, NULL, 'G3DSA:3.40.50.80:FF:000107', NULL, NULL, 'AGAP003772-PA', NULL, NULL, NULL, NULL, NULL, 4),
(145892, NULL, 'G3DSA:2.60.40.10:FF:004735', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145893, NULL, 'G3DSA:3.80.10.10:FF:003270', NULL, NULL, 'Toll-like receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(145894, NULL, 'G3DSA:3.40.50.720:FF:000450', NULL, NULL, 'mRNA, clone: RTFL01-03-A18', NULL, NULL, NULL, NULL, NULL, 4),
(145895, NULL, 'G3DSA:1.10.510.10:FF:000747', NULL, NULL, 'Serine/threonine-protein kinase GRIK2', NULL, NULL, NULL, NULL, NULL, 4),
(145896, NULL, 'G3DSA:3.30.530.20:FF:000054', NULL, NULL, 'StAR-related lipid transfer protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(145897, NULL, 'G3DSA:2.60.40.10:FF:001301', NULL, NULL, 'Coagulation factor XIII A chain', NULL, NULL, NULL, NULL, NULL, 4),
(145898, NULL, 'G3DSA:3.30.780.10:FF:000035', NULL, NULL, 'Eukaryotic Initiation Factor', NULL, NULL, NULL, NULL, NULL, 4),
(145899, NULL, 'G3DSA:3.30.1370.10:FF:000015', NULL, NULL, 'Far upstream element-binding protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(145900, NULL, 'G3DSA:1.20.1250.20:FF:000968', NULL, NULL, 'GM19873', NULL, NULL, NULL, NULL, NULL, 4),
(145901, NULL, 'G3DSA:3.40.50.300:FF:000498', NULL, NULL, 'Eukaryotic initiation factor 4A-III', NULL, NULL, NULL, NULL, NULL, 4),
(145902, NULL, 'G3DSA:3.30.160.60:FF:004674', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145903, NULL, 'G3DSA:3.10.129.10:FF:000151', NULL, NULL, 'Acyl-[acyl-carrier-protein] hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(145904, NULL, 'G3DSA:1.10.10.60:FF:000829', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145905, NULL, 'G3DSA:1.10.10.60:FF:000487', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(145906, NULL, 'G3DSA:2.60.120.10:FF:000758', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145907, NULL, 'G3DSA:3.40.50.300:FF:007243', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(145908, NULL, 'G3DSA:3.30.70.870:FF:000006', NULL, NULL, 'Elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(145909, NULL, 'G3DSA:1.20.1440.180:FF:000013', NULL, NULL, 'Probable serine/threonine-protein kinase irlE', NULL, NULL, NULL, NULL, NULL, 4),
(145910, NULL, 'G3DSA:3.30.70.860:FF:000003', NULL, NULL, 'UPF0234 protein YBT020_06460', NULL, NULL, NULL, NULL, NULL, 4),
(145911, NULL, 'G3DSA:1.20.5.190:FF:000145', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145912, NULL, 'G3DSA:1.10.400.10:FF:000014', NULL, NULL, 'G-protein alpha subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(145913, NULL, 'G3DSA:2.60.40.150:FF:000097', NULL, NULL, 'copine-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(145914, NULL, 'G3DSA:1.10.520.10:FF:000068', NULL, NULL, 'Catalase/peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(145915, NULL, 'G3DSA:2.130.10.10:FF:004152', NULL, NULL, 'AER035Wp', NULL, NULL, NULL, NULL, NULL, 4),
(145916, NULL, 'G3DSA:2.60.40.150:FF:000153', NULL, NULL, 'Synaptotagmin 16', NULL, NULL, NULL, NULL, NULL, 4),
(145917, NULL, 'G3DSA:1.20.5.1700:FF:000001', NULL, NULL, 'Transforming acidic coiled-coil-containing protein 1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(145918, NULL, 'G3DSA:1.20.1540.10:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145919, NULL, 'G3DSA:1.10.3080.10:FF:000089', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(145920, NULL, 'G3DSA:3.30.2350.10:FF:000019', NULL, NULL, 'Mitochondrial mRNA pseudouridine synthase RPUSD3', NULL, NULL, NULL, NULL, NULL, 4),
(145921, NULL, 'G3DSA:1.20.1250.20:FF:000007', NULL, NULL, 'Glycerol-3-phosphate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(145922, NULL, 'G3DSA:1.25.40.10:FF:000671', NULL, NULL, 'rRNA biogenesis protein RRP5', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(145923, NULL, 'G3DSA:3.30.160.60:FF:002818', NULL, NULL, 'Potential zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(145924, NULL, 'G3DSA:3.10.100.10:FF:000118', NULL, NULL, 'C-type lectin domain family 4 member E', NULL, NULL, NULL, NULL, NULL, 4),
(145925, NULL, 'G3DSA:2.60.450.20:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145926, NULL, 'G3DSA:2.30.42.10:FF:000211', NULL, NULL, 'Na(+)/H(+) exchange regulatory cofactor NHE-RF3', NULL, NULL, NULL, NULL, NULL, 4),
(145927, NULL, 'G3DSA:2.130.10.10:FF:002353', NULL, NULL, 'PSF2m', NULL, NULL, NULL, NULL, NULL, 4),
(145928, NULL, 'G3DSA:3.30.420.150:FF:000011', NULL, NULL, 'Exopolyphosphatase 2', NULL, NULL, NULL, NULL, NULL, 4),
(145929, NULL, 'G3DSA:1.20.1250.10:FF:000004', NULL, NULL, 'Kit ligand', NULL, NULL, NULL, NULL, NULL, 4),
(145930, NULL, 'G3DSA:3.40.140.10:FF:000187', NULL, NULL, 'Cytosine deaminase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(145931, NULL, 'G3DSA:1.25.40.10:FF:002088', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(145932, NULL, 'G3DSA:2.60.210.10:FF:000024', NULL, NULL, 'BTB and MATH domain-containing protein 42', NULL, NULL, NULL, NULL, NULL, 4),
(145933, NULL, 'G3DSA:3.30.160.60:FF:002875', NULL, NULL, 'Zinc finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(145934, NULL, 'G3DSA:1.25.40.10:FF:004229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145935, NULL, 'G3DSA:2.30.130.40:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145936, NULL, 'G3DSA:3.30.70.330:FF:000816', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein Q', NULL, NULL, NULL, NULL, NULL, 4),
(145937, NULL, 'G3DSA:2.40.70.10:FF:000236', NULL, NULL, 'FI01813p', NULL, NULL, NULL, NULL, NULL, 4),
(145938, NULL, 'G3DSA:3.90.70.10:FF:000827', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145939, NULL, 'G3DSA:1.20.20.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145940, NULL, 'G3DSA:1.25.40.10:FF:003667', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145941, NULL, 'G3DSA:2.130.10.10:FF:002639', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145942, NULL, 'G3DSA:2.60.120.200:FF:000452', NULL, NULL, 'BEACH domain-containing protein lvsE', NULL, NULL, NULL, NULL, NULL, 4),
(145943, NULL, 'G3DSA:1.10.3660.10:FF:000004', NULL, NULL, 'Prephenate dehydrogenase [NADP(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(145944, NULL, 'G3DSA:3.80.10.10:FF:001920', NULL, NULL, 'Disease resistance protein (TIR-NBS-LRR class)', NULL, NULL, NULL, NULL, NULL, 4),
(145945, NULL, 'G3DSA:4.10.320.10:FF:000007', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(145946, NULL, 'G3DSA:3.30.70.330:FF:001997', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145947, NULL, 'G3DSA:1.20.1330.10:FF:000005', NULL, NULL, 'Flagellin', NULL, NULL, NULL, NULL, NULL, 4),
(145948, NULL, 'G3DSA:1.10.1410.10:FF:000008', NULL, NULL, 'speckle targeted PIP5K1A-regulated poly(A) polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(145949, NULL, 'G3DSA:1.10.730.10:FF:000168', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(145950, NULL, 'G3DSA:2.10.25.10:FF:000240', NULL, NULL, 'Vitamin K-dependent protein S', NULL, NULL, NULL, NULL, NULL, 4),
(145951, NULL, 'G3DSA:3.40.50.300:FF:002297', NULL, NULL, 'ATP-dependent helicase ULS1', NULL, NULL, NULL, NULL, NULL, 4),
(145952, NULL, 'G3DSA:2.60.40.150:FF:000771', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145953, NULL, 'G3DSA:1.10.510.40:FF:000003', NULL, NULL, 'Siderophore biosynthesis protein, IucA/IucC family', NULL, NULL, NULL, NULL, NULL, 4),
(145954, NULL, 'G3DSA:3.20.20.70:FF:000789', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145955, NULL, 'G3DSA:3.30.40.10:FF:000603', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(145956, NULL, 'G3DSA:3.90.550.50:FF:000202', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(145957, NULL, 'G3DSA:3.30.420.40:FF:000164', NULL, NULL, 'Actin cytoplasmic 1', NULL, NULL, NULL, NULL, NULL, 4),
(145958, NULL, 'G3DSA:2.130.10.110:FF:000005', NULL, NULL, 'Clathrin heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(145959, NULL, 'G3DSA:3.40.50.300:FF:004950', NULL, NULL, 'Bifunctional heparan sulfate N-deacetylase/N-sulfotransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(145960, NULL, 'G3DSA:4.10.60.10:FF:000081', NULL, NULL, 'Protein lin-28', NULL, NULL, NULL, NULL, NULL, 4),
(145961, NULL, 'G3DSA:2.10.110.10:FF:000218', NULL, NULL, 'Four and a half LIM domains protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(145962, NULL, 'G3DSA:2.120.10.30:FF:000408', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145963, NULL, 'G3DSA:3.30.230.10:FF:000174', NULL, NULL, 'DNA repair protein RadA', NULL, NULL, NULL, NULL, NULL, 4),
(145964, NULL, 'G3DSA:3.40.50.1980:FF:000129', NULL, NULL, 'Histidinol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(145965, NULL, 'G3DSA:3.40.50.1820:FF:000060', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(145966, NULL, 'G3DSA:1.25.40.20:FF:000674', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145967, NULL, 'G3DSA:1.10.10.10:FF:001967', NULL, NULL, 'Transcription regulator, ArsR family', NULL, NULL, NULL, NULL, NULL, 4),
(145968, NULL, 'G3DSA:3.30.200.20:FF:001698', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145969, NULL, 'G3DSA:2.130.10.10:FF:002297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145970, NULL, 'G3DSA:1.25.10.10:FF:002934', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145971, NULL, 'G3DSA:3.40.50.1000:FF:000325', NULL, NULL, 'p-nitrophenylphosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(145972, NULL, 'G3DSA:3.30.470.20:FF:000161', NULL, NULL, 'Eukaryotic glutathione synthase', NULL, NULL, NULL, NULL, NULL, 4),
(145973, NULL, 'G3DSA:2.40.50.140:FF:000465', NULL, NULL, 'Exosome complex exonuclease RRP4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(145974, NULL, 'G3DSA:3.30.160.60:FF:003038', NULL, NULL, 'Zinc finger protein 711-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(145975, NULL, 'G3DSA:2.120.10.30:FF:000465', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145976, NULL, 'G3DSA:3.30.70.330:FF:001379', NULL, NULL, 'RNA recognition motif-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(145977, NULL, 'G3DSA:1.20.1250.20:FF:000120', NULL, NULL, 'Solute carrier family 45, member 1', NULL, NULL, NULL, NULL, NULL, 4),
(145978, NULL, 'G3DSA:1.25.40.10:FF:004381', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(145979, NULL, 'G3DSA:1.20.1070.10:FF:001710', NULL, NULL, 'CCAP', NULL, NULL, NULL, NULL, NULL, 4),
(145980, NULL, 'G3DSA:1.20.120.430:FF:000019', NULL, NULL, 'tRNA modification GTPase TrmE', NULL, NULL, NULL, NULL, NULL, 4),
(145981, NULL, 'G3DSA:2.60.40.60:FF:000451', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(145982, NULL, 'G3DSA:1.10.287.70:FF:000430', NULL, NULL, 'Two-pore potassium channel 4', NULL, NULL, NULL, NULL, NULL, 4),
(145983, NULL, 'G3DSA:3.30.750.24:FF:000131', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(145984, NULL, 'G3DSA:3.90.226.10:FF:000235', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(145985, NULL, 'G3DSA:1.25.10.10:FF:000405', NULL, NULL, 'Pumilio homolog 24', NULL, NULL, NULL, NULL, NULL, 4),
(145986, NULL, 'G3DSA:2.160.20.10:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145987, NULL, 'G3DSA:3.90.1300.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145988, NULL, 'G3DSA:1.10.510.10:FF:004171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145989, NULL, 'G3DSA:3.40.462.20:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(145990, NULL, 'G3DSA:3.30.870.10:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145991, NULL, 'G3DSA:1.25.40.10:FF:004561', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(145992, NULL, 'G3DSA:3.40.50.300:FF:006187', NULL, NULL, 'Protein CBG01006', NULL, NULL, NULL, NULL, NULL, 4),
(145993, NULL, 'G3DSA:3.20.20.140:FF:000488', NULL, NULL, 'Gll3395 protein', NULL, NULL, NULL, NULL, NULL, 4),
(145994, NULL, 'G3DSA:3.40.50.300:FF:002971', NULL, NULL, 'Os03g0282700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(145995, NULL, 'G3DSA:3.30.710.10:FF:000323', NULL, NULL, 'YALI0D10087p', NULL, NULL, NULL, NULL, NULL, 4),
(145996, NULL, 'G3DSA:3.30.70.330:FF:002054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(145997, NULL, 'G3DSA:3.30.420.10:FF:000222', NULL, NULL, 'Polynucleotidyl transferase, ribonuclease H-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(145998, NULL, 'G3DSA:1.50.40.10:FF:000495', NULL, NULL, 'Mitochondrial carrier', NULL, NULL, NULL, NULL, NULL, 4),
(145999, NULL, 'G3DSA:3.40.50.1440:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146000, NULL, 'G3DSA:2.130.10.10:FF:002914', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146001, NULL, 'G3DSA:1.20.1730.10:FF:000030', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(146002, NULL, 'G3DSA:1.20.1420.30:FF:000046', NULL, NULL, 'Vacuolar calcium ion transporter', NULL, NULL, NULL, NULL, NULL, 4),
(146003, NULL, 'G3DSA:3.40.50.620:FF:000532', NULL, NULL, 'GTP binding', NULL, NULL, NULL, NULL, NULL, 4),
(146004, NULL, 'G3DSA:3.30.160.60:FF:003370', NULL, NULL, 'Zinc finger protein 169', NULL, NULL, NULL, NULL, NULL, 4),
(146005, NULL, 'G3DSA:1.10.510.10:FF:003895', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146006, NULL, 'G3DSA:1.10.3720.10:FF:000116', NULL, NULL, 'Oligopeptide transport system permease protein OppC', NULL, NULL, NULL, NULL, NULL, 4),
(146007, NULL, 'G3DSA:2.60.200.20:FF:000239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146008, NULL, 'G3DSA:2.30.30.40:FF:000541', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146009, NULL, 'G3DSA:3.30.160.60:FF:006186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146010, NULL, 'G3DSA:3.40.1280.10:FF:000062', NULL, NULL, '23S rRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(146011, NULL, 'G3DSA:1.10.3430.10:FF:000015', NULL, NULL, 'Ammonium transporter', NULL, NULL, NULL, NULL, NULL, 4),
(146012, NULL, 'G3DSA:3.30.70.330:FF:000075', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein H1 (H)', NULL, NULL, NULL, NULL, NULL, 4),
(146013, NULL, 'G3DSA:3.30.420.40:FF:000782', NULL, NULL, 'Arp9p', NULL, NULL, NULL, NULL, NULL, 4),
(146014, NULL, 'G3DSA:1.10.10.570:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146015, NULL, 'G3DSA:3.40.50.1000:FF:000763', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146016, NULL, 'G3DSA:3.10.100.10:FF:000337', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146017, NULL, 'G3DSA:3.20.140.10:FF:000012', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(146018, NULL, 'G3DSA:3.40.50.12780:FF:000171', NULL, NULL, 'Putative long-chain fatty-acid-CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(146019, NULL, 'G3DSA:2.60.40.10:FF:002605', NULL, NULL, 'Terribly reduced optic lobes, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(146020, NULL, 'G3DSA:1.10.357.10:FF:000008', NULL, NULL, 'Transcriptional regulator, TetR family', NULL, NULL, NULL, NULL, NULL, 4),
(146021, NULL, 'G3DSA:1.20.1070.10:FF:000018', NULL, NULL, 'Rhodopsin', NULL, NULL, NULL, NULL, NULL, 4),
(146022, NULL, 'G3DSA:3.80.10.10:FF:003157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146023, NULL, 'G3DSA:1.10.8.80:FF:000003', NULL, NULL, 'Transcriptional regulator moxR1', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(146024, NULL, 'G3DSA:1.10.10.580:FF:000009', NULL, NULL, 'Sister chromatid cohesion protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(146025, NULL, 'G3DSA:2.60.40.1400:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146026, NULL, 'G3DSA:3.40.640.10:FF:000388', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(146027, NULL, 'G3DSA:2.60.40.10:FF:003100', NULL, NULL, 'Immunoglobulin heavy chain precursor', NULL, NULL, NULL, NULL, NULL, 4),
(146028, NULL, 'G3DSA:2.40.110.10:FF:000015', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(146029, NULL, 'G3DSA:2.10.25.10:FF:000021', NULL, NULL, 'Teneurin transmembrane protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(146030, NULL, 'G3DSA:3.40.50.720:FF:002361', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146031, NULL, 'G3DSA:1.25.40.10:FF:000233', NULL, NULL, 'Tetratricopeptide repeat domain 26', NULL, NULL, NULL, NULL, NULL, 4),
(146032, NULL, 'G3DSA:1.20.1200.10:FF:000001', NULL, NULL, 'Cob(I)yrinic acid a,c-diamide adenosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(146033, NULL, 'G3DSA:3.30.1330.10:FF:000018', NULL, NULL, 'selenide, water dikinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(146034, NULL, 'G3DSA:2.40.50.100:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146035, NULL, 'G3DSA:3.40.640.10:FF:000169', NULL, NULL, 'L-lysine 6-aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(146036, NULL, 'G3DSA:3.10.100.10:FF:000394', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146037, NULL, 'G3DSA:1.20.1070.10:FF:001654', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146038, NULL, 'G3DSA:3.90.176.10:FF:000005', NULL, NULL, 'ADP-ribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(146039, NULL, 'G3DSA:2.60.120.200:FF:000233', NULL, NULL, 'Hemagglutinin A', NULL, NULL, NULL, NULL, NULL, 4),
(146040, NULL, 'G3DSA:1.20.90.10:FF:000010', NULL, NULL, 'Protein interacting with cyclin A1', NULL, NULL, NULL, NULL, NULL, 4),
(146041, NULL, 'G3DSA:1.10.10.10:FF:000663', NULL, NULL, 'Ferric uptake regulator family protein', NULL, NULL, NULL, NULL, NULL, 4),
(146042, NULL, 'G3DSA:3.40.50.12350:FF:000008', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(146043, NULL, 'G3DSA:1.20.200.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146044, NULL, 'G3DSA:3.40.50.10490:FF:000130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146045, NULL, 'G3DSA:2.60.40.10:FF:001245', NULL, NULL, 'vascular endothelial growth factor receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(146046, NULL, 'G3DSA:3.30.40.10:FF:001907', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146047, NULL, 'G3DSA:3.40.1360.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146048, NULL, 'G3DSA:2.60.40.820:FF:000033', NULL, NULL, 'T, brachyury homolog, gene 2', NULL, NULL, NULL, NULL, NULL, 4),
(146049, NULL, 'G3DSA:3.30.190.20:FF:000010', NULL, NULL, '50S ribosomal protein L1, mitochondrial,putative', NULL, NULL, NULL, NULL, NULL, 4),
(146050, NULL, 'G3DSA:2.130.10.10:FF:002971', NULL, NULL, 'Protein HIR2', NULL, NULL, NULL, NULL, NULL, 4),
(146051, NULL, 'G3DSA:1.50.40.10:FF:000276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146052, NULL, 'G3DSA:1.25.40.10:FF:004504', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g66345, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(146053, NULL, 'G3DSA:3.40.30.10:FF:001131', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(146054, NULL, 'G3DSA:2.60.120.10:FF:000197', NULL, NULL, 'Transcriptional regulator AraC family', NULL, NULL, NULL, NULL, NULL, 4),
(146055, NULL, 'G3DSA:1.10.10.10:FF:001006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146056, NULL, 'G3DSA:3.30.70.2820:FF:000008', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(146057, NULL, 'G3DSA:1.10.287.160:FF:000019', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(146058, NULL, 'G3DSA:3.40.1090.10:FF:000137', NULL, NULL, 'Patatin', NULL, NULL, NULL, NULL, NULL, 4),
(146059, NULL, 'G3DSA:3.40.50.300:FF:006748', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(146060, NULL, 'G3DSA:2.60.40.10:FF:002662', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(146061, NULL, 'G3DSA:3.20.20.210:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146062, NULL, 'G3DSA:3.40.1280.10:FF:000005', NULL, NULL, '23S rRNA (guanosine-2''-O-)-methyltransferase RlmB', NULL, NULL, NULL, NULL, NULL, 4),
(146063, NULL, 'G3DSA:2.40.70.10:FF:000416', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146064, NULL, 'G3DSA:1.20.1310.10:FF:000116', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146065, NULL, 'G3DSA:1.10.510.10:FF:002259', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146066, NULL, 'G3DSA:2.60.40.150:FF:000658', NULL, NULL, 'Copine 8', NULL, NULL, NULL, NULL, NULL, 4),
(146067, NULL, 'G3DSA:1.10.3430.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146068, NULL, 'G3DSA:3.40.50.300:FF:003314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146069, NULL, 'G3DSA:1.20.140.40:FF:000085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146070, NULL, 'G3DSA:1.20.810.10:FF:000009', NULL, NULL, 'Cytochrome b', NULL, NULL, NULL, NULL, NULL, 4),
(146071, NULL, 'G3DSA:3.90.1600.10:FF:000019', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(146072, NULL, 'G3DSA:3.30.160.60:FF:002476', NULL, NULL, 'Ras responsive element binding protein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(146073, NULL, 'G3DSA:3.10.120.10:FF:000007', NULL, NULL, 'Sulfite oxidase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(146074, NULL, 'G3DSA:3.20.20.20:FF:000004', NULL, NULL, 'Dihydropteroate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(146075, NULL, 'G3DSA:1.20.1440.170:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146076, NULL, 'G3DSA:1.10.238.10:FF:000940', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146077, NULL, 'G3DSA:2.40.30.10:FF:000239', NULL, NULL, 'Elongation factor 1-alpha, putative (TuF-2)', NULL, NULL, NULL, NULL, NULL, 4),
(146078, NULL, 'G3DSA:3.20.20.30:FF:000007', NULL, NULL, 'Monooxygenase, mmyo', NULL, NULL, NULL, NULL, NULL, 4),
(146079, NULL, 'G3DSA:3.40.50.300:FF:002477', NULL, NULL, 'Putative replication factor C, subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(146080, NULL, 'G3DSA:3.10.20.90:FF:000470', NULL, NULL, 'Protein CBG12265', NULL, NULL, NULL, NULL, NULL, 4),
(146081, NULL, 'G3DSA:2.60.40.1510:FF:000002', NULL, NULL, 'integrin alpha-6 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(146082, NULL, 'G3DSA:3.30.70.2800:FF:000002', NULL, NULL, 'Diedel 3, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(146083, NULL, 'G3DSA:1.10.287.4070:FF:000013', NULL, NULL, 'NOSIC domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(146084, NULL, 'G3DSA:2.60.120.260:FF:000155', NULL, NULL, 'Probable beta-glucosidase H', NULL, NULL, NULL, NULL, NULL, 4),
(146085, NULL, 'G3DSA:1.10.287.130:FF:000010', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(146086, NULL, 'G3DSA:2.30.42.10:FF:000155', NULL, NULL, 'membrane-associated guanylate kinase, WW and PDZ domain-containing protein 2 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(146087, NULL, 'G3DSA:1.25.40.10:FF:000851', NULL, NULL, 'Pentatricopeptide repeat-containing protein103', NULL, NULL, NULL, NULL, NULL, 4),
(146088, NULL, 'G3DSA:2.40.30.10:FF:000296', NULL, NULL, 'NADPH-cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(146089, NULL, 'G3DSA:3.80.10.10:FF:003718', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146090, NULL, 'G3DSA:1.20.58.1120:FF:000012', NULL, NULL, 'Dynein, axonemal, heavy chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(146091, NULL, 'G3DSA:1.10.510.10:FF:003153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146092, NULL, 'G3DSA:1.25.40.20:FF:000854', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(146093, NULL, 'G3DSA:1.20.1270.60:FF:000211', NULL, NULL, 'Bridging integrator 1b', NULL, NULL, NULL, NULL, NULL, 4),
(146094, NULL, 'G3DSA:3.40.50.300:FF:007024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146095, NULL, 'G3DSA:3.30.40.10:FF:000480', NULL, NULL, 'Peroxisome biogenesis factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(146096, NULL, 'G3DSA:2.130.10.10:FF:002078', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(146097, NULL, 'G3DSA:1.20.140.40:FF:000028', NULL, NULL, 'Os02g0688200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(146098, NULL, 'G3DSA:3.90.1600.10:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146099, NULL, 'G3DSA:3.80.10.10:FF:000341', NULL, NULL, 'volume-regulated anion channel subunit LRRC8D', NULL, NULL, NULL, NULL, NULL, 4),
(146100, NULL, 'G3DSA:1.10.1420.10:FF:000166', NULL, NULL, 'MutS protein homolog 5-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(146101, NULL, 'G3DSA:3.30.1510.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146102, NULL, 'G3DSA:3.90.1150.10:FF:000024', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(146103, NULL, 'G3DSA:3.90.550.10:FF:000168', NULL, NULL, '8-amino-3,8-dideoxy-manno-octulosonate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(146104, NULL, 'G3DSA:1.20.5.340:FF:000078', NULL, NULL, 'Rho kinase', NULL, NULL, NULL, NULL, NULL, 4),
(146105, NULL, 'G3DSA:1.10.510.10:FF:002703', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146106, NULL, 'G3DSA:4.10.400.10:FF:000284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146107, NULL, 'G3DSA:3.30.160.60:FF:005410', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146108, NULL, 'G3DSA:1.20.1070.10:FF:000400', NULL, NULL, 'Melanopsin-B', NULL, NULL, NULL, NULL, NULL, 4),
(146109, NULL, 'G3DSA:2.70.150.10:FF:000056', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(146110, NULL, 'G3DSA:3.10.20.90:FF:000778', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146111, NULL, 'G3DSA:2.120.10.30:FF:000252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146112, NULL, 'G3DSA:2.20.70.10:FF:000041', NULL, NULL, 'WW and C2 domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(146113, NULL, 'G3DSA:2.40.30.130:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146114, NULL, 'G3DSA:2.60.15.10:FF:000012', NULL, NULL, 'ATP synthase epsilon chain', NULL, NULL, NULL, NULL, NULL, 4),
(146115, NULL, 'G3DSA:1.10.510.10:FF:001601', NULL, NULL, 'Cell division protein kinase 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(146116, NULL, 'G3DSA:1.10.1370.30:FF:000050', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(146117, NULL, 'G3DSA:2.60.40.10:FF:004825', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146118, NULL, 'G3DSA:1.10.10.60:FF:000723', NULL, NULL, 'Vent homeobox 2', NULL, NULL, NULL, NULL, NULL, 4),
(146119, NULL, 'G3DSA:3.40.50.300:FF:000931', NULL, NULL, 'DExH-box ATP-dependent RNA helicase DExH1', NULL, NULL, NULL, NULL, NULL, 4),
(146120, NULL, 'G3DSA:1.10.10.10:FF:000169', NULL, NULL, 'Transcriptional regulator, Fur family', NULL, NULL, NULL, NULL, NULL, 4),
(146121, NULL, 'G3DSA:2.40.37.10:FF:000030', NULL, NULL, 'Biosynthetic arginine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(146122, NULL, 'G3DSA:3.10.110.10:FF:000164', NULL, NULL, 'Ubiquitin-conjugating enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(146123, NULL, 'G3DSA:3.30.40.10:FF:001374', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(146124, NULL, 'G3DSA:3.90.226.10:FF:000049', NULL, NULL, 'Enoyl-CoA delta isomerase 3', NULL, NULL, NULL, NULL, NULL, 4),
(146125, NULL, 'G3DSA:3.40.50.620:FF:000324', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(146126, NULL, 'G3DSA:3.40.50.970:FF:000171', NULL, NULL, '2-oxoisovalerate dehydrogenase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(146127, NULL, 'G3DSA:3.40.850.10:FF:000016', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(146128, NULL, 'G3DSA:1.25.40.10:FF:002447', NULL, NULL, 'Pentatricopeptide repeat-containing protein DOT4, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(146129, NULL, 'G3DSA:2.120.10.80:FF:000160', NULL, NULL, 'Kelch domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(146130, NULL, 'G3DSA:2.60.40.150:FF:000563', NULL, NULL, 'Esyt-2', NULL, NULL, NULL, NULL, NULL, 4),
(146131, NULL, 'G3DSA:3.30.720.210:FF:000024', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(146132, NULL, 'G3DSA:2.20.80.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146133, NULL, 'G3DSA:1.10.600.10:FF:000102', NULL, NULL, 'copal-8-ol diphosphate hydratase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(146134, NULL, 'G3DSA:3.40.50.970:FF:000215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146135, NULL, 'G3DSA:1.20.120.980:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146136, NULL, 'G3DSA:3.40.50.300:FF:008362', NULL, NULL, 'Signal recognition particle alpha', NULL, NULL, NULL, NULL, NULL, 4),
(146137, NULL, 'G3DSA:3.40.640.10:FF:000416', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(146138, NULL, 'G3DSA:3.40.50.1970:FF:000008', NULL, NULL, 'Alcohol dehydrogenase YqhD', NULL, NULL, NULL, NULL, NULL, 4),
(146139, NULL, 'G3DSA:1.10.10.570:FF:000001', NULL, NULL, 'vacuolar protein-sorting-associated protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(146140, NULL, 'G3DSA:3.80.10.10:FF:002145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146141, NULL, 'G3DSA:2.30.30.40:FF:000159', NULL, NULL, 'MAGUK p55 subfamily member 7', NULL, NULL, NULL, NULL, NULL, 4),
(146142, NULL, 'G3DSA:3.30.590.50:FF:000004', NULL, NULL, 'Glutamate-cysteine ligase Gcs1', NULL, NULL, NULL, NULL, NULL, 4),
(146143, NULL, 'G3DSA:1.10.510.10:FF:000449', NULL, NULL, 'Calcium/calmodulin-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(146144, NULL, 'G3DSA:1.20.1310.10:FF:000066', NULL, NULL, 'Cullin-like protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(146145, NULL, 'G3DSA:3.40.50.80:FF:000017', NULL, NULL, 'Dihydroorotate dehydrogenase B (NAD(+)), electron transfer subunit', NULL, NULL, NULL, NULL, NULL, 4),
(146146, NULL, 'G3DSA:1.10.1070.11:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146147, NULL, 'G3DSA:3.90.1140.10:FF:000052', NULL, NULL, 'U6 snRNA phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(146148, NULL, 'G3DSA:1.10.3080.10:FF:000084', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(146149, NULL, 'G3DSA:1.10.10.580:FF:000004', NULL, NULL, 'Double-strand-break repair protein rad21', NULL, NULL, NULL, NULL, NULL, 4),
(146150, NULL, 'G3DSA:2.60.40.10:FF:000447', NULL, NULL, 'fibronectin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(146151, NULL, 'G3DSA:1.10.287.690:FF:000026', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(146152, NULL, 'G3DSA:1.20.5.170:FF:000212', NULL, NULL, 'GTPase activator protein', NULL, NULL, NULL, NULL, NULL, 4),
(146153, NULL, 'G3DSA:3.90.79.10:FF:000055', NULL, NULL, 'U8 snoRNA-decapping enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(146154, NULL, 'G3DSA:1.25.40.10:FF:004690', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(146155, NULL, 'G3DSA:2.30.30.30:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146156, NULL, 'G3DSA:1.20.144.10:FF:000028', NULL, NULL, 'Glucose-6-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(146157, NULL, 'G3DSA:3.30.457.60:FF:000018', NULL, NULL, 'Mitotic spindle assembly checkpoint protein MAD1', NULL, NULL, NULL, NULL, NULL, 4),
(146158, NULL, 'G3DSA:3.80.10.10:FF:001802', NULL, NULL, 'Mimecan', NULL, NULL, NULL, NULL, NULL, 4),
(146159, NULL, 'G3DSA:3.60.40.10:FF:000012', NULL, NULL, 'Regulator of RpoS', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(146160, NULL, 'G3DSA:3.30.70.330:FF:002071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146161, NULL, 'G3DSA:3.30.200.20:FF:000259', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(146162, NULL, 'G3DSA:1.25.10.10:FF:002945', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146163, NULL, 'G3DSA:3.10.180.10:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146164, NULL, 'G3DSA:3.90.70.10:FF:000518', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 4', NULL, NULL, NULL, NULL, NULL, 4),
(146165, NULL, 'G3DSA:3.40.50.10470:FF:000057', NULL, NULL, 'Eukaryotic Initiation Factor', NULL, NULL, NULL, NULL, NULL, 4),
(146166, NULL, 'G3DSA:2.40.50.140:FF:000358', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(146167, NULL, 'G3DSA:3.40.50.300:FF:006754', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(146168, NULL, 'G3DSA:1.10.8.270:FF:000059', NULL, NULL, 'Unplaced genomic scaffold supercont2.12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(146169, NULL, 'G3DSA:3.30.710.10:FF:000340', NULL, NULL, 'Zinc finger protein ZNF-U69274', NULL, NULL, NULL, NULL, NULL, 4),
(146170, NULL, 'G3DSA:3.30.1010.10:FF:000022', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(146171, NULL, 'G3DSA:3.30.900.10:FF:000040', NULL, NULL, 'Mitotic spindle assembly checkpoint protein MAD2B', NULL, NULL, NULL, NULL, NULL, 4),
(146172, NULL, 'G3DSA:1.20.1640.10:FF:000085', NULL, NULL, 'Transmembrane transport protein mmpL13a', NULL, NULL, NULL, NULL, NULL, 4),
(146173, NULL, 'G3DSA:2.40.10.10:FF:000429', NULL, NULL, 'Male accessory gland protein', NULL, NULL, NULL, NULL, NULL, 4),
(146174, NULL, 'G3DSA:1.10.420.10:FF:000004', NULL, NULL, 'Catalase-peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(146175, NULL, 'G3DSA:2.60.120.260:FF:000245', NULL, NULL, 'Glycoside hydrolase family 2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(146176, NULL, 'G3DSA:1.20.1250.20:FF:000131', NULL, NULL, 'Probable anion transporter 3, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(146177, NULL, 'G3DSA:3.10.20.90:FF:000099', NULL, NULL, 'Polycomb group RING finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(146178, NULL, 'G3DSA:3.40.50.1100:FF:000299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146179, NULL, 'G3DSA:3.80.10.10:FF:003247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146180, NULL, 'G3DSA:2.60.40.60:FF:001018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146181, NULL, 'G3DSA:2.130.10.10:FF:002549', NULL, NULL, 'Bromodomain and WD repeat domain-containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(146182, NULL, 'G3DSA:2.130.10.10:FF:005894', NULL, NULL, 'Probable inactive protein kinase DDB_G0270444', NULL, NULL, NULL, NULL, NULL, 4),
(146183, NULL, 'G3DSA:1.25.10.10:FF:001001', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(146184, NULL, 'G3DSA:3.30.60.30:FF:000178', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(146185, NULL, 'G3DSA:2.130.10.10:FF:004466', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146186, NULL, 'G3DSA:3.30.200.20:FF:001687', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146187, NULL, 'G3DSA:1.20.1440.170:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146188, NULL, 'G3DSA:3.40.50.300:FF:001111', NULL, NULL, 'neuron navigator 2 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(146189, NULL, 'G3DSA:3.40.50.1000:FF:000741', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146190, NULL, 'G3DSA:3.30.830.10:FF:000287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146191, NULL, 'G3DSA:3.90.1150.10:FF:000350', NULL, NULL, 'dTDP-3-amino-3,4,6-trideoxy-alpha-D-glucose transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(146192, NULL, 'G3DSA:3.40.309.10:FF:000006', NULL, NULL, 'Gamma-glutamyl phosphate reductase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(146193, NULL, 'G3DSA:1.25.40.10:FF:004701', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146194, NULL, 'G3DSA:1.25.10.10:FF:000821', NULL, NULL, 'Heatr1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(146195, NULL, 'G3DSA:2.40.290.30:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146196, NULL, 'G3DSA:3.30.40.10:FF:000272', NULL, NULL, 'transcription intermediary factor 1-beta', NULL, NULL, NULL, NULL, NULL, 4),
(146197, NULL, 'G3DSA:3.80.10.10:FF:003926', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146198, NULL, 'G3DSA:2.130.10.10:FF:000088', NULL, NULL, 'Hepatocyte growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(146199, NULL, 'G3DSA:1.10.150.190:FF:000006', NULL, NULL, 'Translation initiation factor 2 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(146200, NULL, 'G3DSA:1.10.10.60:FF:000077', NULL, NULL, 'MYB transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(146201, NULL, 'G3DSA:1.10.220.150:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146202, NULL, 'G3DSA:2.60.40.2070:FF:000001', NULL, NULL, 'Fimbrial outer membrane usher protein', NULL, NULL, NULL, NULL, NULL, 4),
(146203, NULL, 'G3DSA:1.20.1440.180:FF:000018', NULL, NULL, 'Serine/threonine-protein kinase/endoribonuclease IRE1a', NULL, NULL, NULL, NULL, NULL, 4),
(146204, NULL, 'G3DSA:3.30.160.60:FF:001032', NULL, NULL, 'zinc finger and BTB domain-containing protein 17 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(146205, NULL, 'G3DSA:1.10.1420.10:FF:000054', NULL, NULL, 'DNA mismatch repair protein Msh2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(146206, NULL, 'G3DSA:1.10.287.3510:FF:000014', NULL, NULL, 'NADH-ubiquinone oxidoreductase chain 4L', NULL, NULL, NULL, NULL, NULL, 4),
(146207, NULL, 'G3DSA:2.60.40.60:FF:000664', NULL, NULL, 'protocadherin-11 X-linked', NULL, NULL, NULL, NULL, NULL, 4),
(146208, NULL, 'G3DSA:3.10.290.10:FF:000087', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(146209, NULL, 'G3DSA:2.30.29.30:FF:001193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146210, NULL, 'G3DSA:3.90.70.10:FF:000209', NULL, NULL, 'Protein CBR-TRA-3', NULL, NULL, NULL, NULL, NULL, 4),
(146211, NULL, 'G3DSA:3.90.550.10:FF:000538', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(146212, NULL, 'G3DSA:2.70.170.10:FF:000309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146213, NULL, 'G3DSA:3.30.160.60:FF:004584', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146214, NULL, 'G3DSA:2.60.260.20:FF:000092', NULL, NULL, 'DNaJ domain (Prokaryotic heat shock protein)', NULL, NULL, NULL, NULL, NULL, 4),
(146215, NULL, 'G3DSA:3.30.70.960:FF:000005', NULL, NULL, 'transmembrane protease serine 7', NULL, NULL, NULL, NULL, NULL, 4),
(146216, NULL, 'G3DSA:3.30.565.10:FF:000266', NULL, NULL, 'Nitrogen regulation protein/Sensor Histidine Kinase NtrY', NULL, NULL, NULL, NULL, NULL, 4),
(146217, NULL, 'G3DSA:1.25.40.10:FF:003875', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(146218, NULL, 'G3DSA:3.30.710.10:FF:000031', NULL, NULL, 'BTB/POZ domain-containing protein KCTD16', NULL, NULL, NULL, NULL, NULL, 4),
(146219, NULL, 'G3DSA:2.60.40.790:FF:000108', NULL, NULL, 'Heat shock protein 22A', NULL, NULL, NULL, NULL, NULL, 4),
(146220, NULL, 'G3DSA:3.40.640.10:FF:000096', NULL, NULL, 'Molybdenum cofactor sulfurase', NULL, NULL, NULL, NULL, NULL, 4),
(146221, NULL, 'G3DSA:2.10.25.10:FF:000959', NULL, NULL, 'Dumpy, isoform R', NULL, NULL, NULL, NULL, NULL, 4),
(146222, NULL, 'G3DSA:3.30.505.10:FF:000083', NULL, NULL, 'Ras GTPase-activating protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(146223, NULL, 'G3DSA:2.10.25.10:FF:001465', NULL, NULL, 'Mannan-binding lectin serine peptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(146224, NULL, 'G3DSA:3.90.1420.10:FF:000034', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(146225, NULL, 'G3DSA:1.10.3720.10:FF:000066', NULL, NULL, 'Glycine betaine/carnitine/choline/L-proline ABC transporter permease ProZ', NULL, NULL, NULL, NULL, NULL, 4),
(146226, NULL, 'G3DSA:2.40.340.10:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146227, NULL, 'G3DSA:2.60.40.420:FF:000211', NULL, NULL, 'L-ascorbate oxidase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(146228, NULL, 'G3DSA:3.40.50.300:FF:006119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146229, NULL, 'G3DSA:3.30.2010.10:FF:000022', NULL, NULL, 'Peptidase, M48 family', NULL, NULL, NULL, NULL, NULL, 4),
(146230, NULL, 'G3DSA:3.30.70.660:FF:000022', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(146231, NULL, 'G3DSA:2.60.200.20:FF:000127', NULL, NULL, 'Uncharacterized protein C3H7.13', NULL, NULL, NULL, NULL, NULL, 4),
(146232, NULL, 'G3DSA:1.10.1670.10:FF:000072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146233, NULL, 'G3DSA:3.40.850.10:FF:000342', NULL, NULL, 'Putative kinesin', NULL, NULL, NULL, NULL, NULL, 4),
(146234, NULL, 'G3DSA:1.20.1510.10:FF:000047', NULL, NULL, 'Cation efflux family protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(146235, NULL, 'G3DSA:3.40.228.10:FF:000014', NULL, NULL, 'NADH-quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(146236, NULL, 'G3DSA:1.20.1070.10:FF:002154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146237, NULL, 'G3DSA:2.160.20.10:FF:000082', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(146238, NULL, 'G3DSA:3.40.50.300:FF:000594', NULL, NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(146239, NULL, 'G3DSA:3.30.70.330:FF:001598', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146240, NULL, 'G3DSA:2.120.10.30:FF:000622', NULL, NULL, 'NHL repeat-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(146241, NULL, 'G3DSA:2.60.40.10:FF:003999', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146242, NULL, 'G3DSA:3.30.70.3490:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146243, NULL, 'G3DSA:3.30.420.80:FF:000018', NULL, NULL, '40S ribosomal protein S14', NULL, NULL, NULL, NULL, NULL, 4),
(146244, NULL, 'G3DSA:3.30.40.10:FF:002200', NULL, NULL, 'Meiosis-specific protein hop1', NULL, NULL, NULL, NULL, NULL, 4),
(146245, NULL, 'G3DSA:2.60.40.10:FF:002364', NULL, NULL, 'Protein CBG19196', NULL, NULL, NULL, NULL, NULL, 4),
(146246, NULL, 'G3DSA:1.10.510.10:FF:000775', NULL, NULL, 'CMGC/CDK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(146247, NULL, 'G3DSA:3.40.50.150:FF:000425', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase H', NULL, NULL, NULL, NULL, NULL, 4),
(146248, NULL, 'G3DSA:3.40.50.300:FF:005017', NULL, NULL, 'tRNA delta(2)-isopentenylpyrophosphate transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(146249, NULL, 'G3DSA:3.60.15.10:FF:000162', NULL, NULL, 'DNA repair protein, putative (AFU_orthologue AFUA_1G04570)', NULL, NULL, NULL, NULL, NULL, 4),
(146250, NULL, 'G3DSA:3.40.50.300:FF:002376', NULL, NULL, '6-phosphofructo-2-kinase/fructose-2', NULL, NULL, NULL, NULL, NULL, 4),
(146251, NULL, 'G3DSA:1.25.40.20:FF:001141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146252, NULL, 'G3DSA:4.10.60.10:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146253, NULL, 'G3DSA:3.30.420.60:FF:000012', NULL, NULL, 'Protein pelota homolog', NULL, NULL, NULL, NULL, NULL, 4),
(146254, NULL, 'G3DSA:1.10.472.10:FF:000186', NULL, NULL, 'Cyclin D', NULL, NULL, NULL, NULL, NULL, 4),
(146255, NULL, 'G3DSA:3.80.10.10:FF:004062', NULL, NULL, 'Leucine-rich repeats and IQ motif containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(146256, NULL, 'G3DSA:2.60.34.10:FF:000034', NULL, NULL, 'Heat shock 70 kDa protein 16 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(146257, NULL, 'G3DSA:2.30.29.30:FF:000091', NULL, NULL, 'kalirin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(146258, NULL, 'G3DSA:1.10.510.10:FF:002366', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(146259, NULL, 'G3DSA:3.40.640.10:FF:000107', NULL, NULL, 'Kynureninase', NULL, NULL, NULL, NULL, NULL, 4),
(146260, NULL, 'G3DSA:3.80.10.10:FF:001791', NULL, NULL, 'F-box/LRR-repeat protein 20 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(146261, NULL, 'G3DSA:1.25.40.10:FF:004364', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(146262, NULL, 'G3DSA:1.10.238.10:FF:000642', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146263, NULL, 'G3DSA:1.10.357.50:FF:000014', NULL, NULL, 'Protein unc-13 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(146264, NULL, 'G3DSA:3.30.70.60:FF:000002', NULL, NULL, '30S ribosomal protein S6', NULL, NULL, NULL, NULL, NULL, 4),
(146265, NULL, 'G3DSA:2.130.10.10:FF:002342', NULL, NULL, 'Os01g0551900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(146266, NULL, 'G3DSA:1.10.30.10:FF:000069', NULL, NULL, 'CBL-interacting protein kinase 33', NULL, NULL, NULL, NULL, NULL, 4),
(146267, NULL, 'G3DSA:3.40.390.10:FF:000306', NULL, NULL, 'NEPrilysin metallopeptidase family', NULL, NULL, NULL, NULL, NULL, 4),
(146268, NULL, 'G3DSA:1.10.418.10:FF:000061', NULL, NULL, 'Spermatogenesis associated 4', NULL, NULL, NULL, NULL, NULL, 4),
(146269, NULL, 'G3DSA:3.80.10.10:FF:003573', NULL, NULL, 'RE59904p', NULL, NULL, NULL, NULL, NULL, 4),
(146270, NULL, 'G3DSA:3.30.420.40:FF:000602', NULL, NULL, 'Actin-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(146271, NULL, 'G3DSA:3.10.129.10:FF:000156', NULL, NULL, 'YALI0E28853p', NULL, NULL, NULL, NULL, NULL, 4),
(146272, NULL, 'G3DSA:3.40.50.150:FF:000734', NULL, NULL, 'NOP2 nucleolar protein homolog (yeast)', NULL, NULL, NULL, NULL, NULL, 4),
(146273, NULL, 'G3DSA:2.30.30.40:FF:000529', NULL, NULL, 'Epidermal growth factor receptor kinase substrate 8', NULL, NULL, NULL, NULL, NULL, 4),
(146274, NULL, 'G3DSA:1.10.510.10:FF:004148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146275, NULL, 'G3DSA:3.30.160.60:FF:006175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146276, NULL, 'G3DSA:1.25.10.10:FF:002619', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146277, NULL, 'G3DSA:3.30.870.10:FF:000054', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(146278, NULL, 'G3DSA:3.40.50.2000:FF:000147', NULL, NULL, 'UDP-N-acetylglucosamine transferase subunit ALG13-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(146279, NULL, 'G3DSA:3.30.70.330:FF:001609', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146280, NULL, 'G3DSA:1.20.120.20:FF:000004', NULL, NULL, 'Apolipoprotein A-IV', NULL, NULL, NULL, NULL, NULL, 4),
(146281, NULL, 'G3DSA:2.60.40.1210:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146282, NULL, 'G3DSA:3.30.160.60:FF:002813', NULL, NULL, 'Transcription factor IIIA', NULL, NULL, NULL, NULL, NULL, 4),
(146283, NULL, 'G3DSA:3.30.200.20:FF:002530', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146284, NULL, 'G3DSA:1.20.1080.10:FF:000002', NULL, NULL, 'Probable aquaporin TIP1-1', NULL, NULL, NULL, NULL, NULL, 4),
(146285, NULL, 'G3DSA:2.60.40.10:FF:006080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146286, NULL, 'G3DSA:3.90.470.10:FF:000021', NULL, NULL, 'Related to 50S ribosomal protein L22', NULL, NULL, NULL, NULL, NULL, 4),
(146287, NULL, 'G3DSA:1.20.58.120:FF:000012', NULL, NULL, 'SNL1p Ribosome-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(146288, NULL, 'G3DSA:2.30.29.30:FF:000102', NULL, NULL, 'FYVE, RhoGEF and PH domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(146289, NULL, 'G3DSA:3.40.5.70:FF:000001', NULL, NULL, 'DNA-packaging protein FI', NULL, NULL, NULL, NULL, NULL, 4),
(146290, NULL, 'G3DSA:2.130.10.10:FF:004803', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146291, NULL, 'G3DSA:3.40.50.300:FF:006428', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146292, NULL, 'G3DSA:3.30.40.10:FF:001727', NULL, NULL, 'Regulator Ustilago maydis 1 protein (Rum1)', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(146293, NULL, 'G3DSA:1.10.506.10:FF:000018', NULL, NULL, 'Plexin B2', NULL, NULL, NULL, NULL, NULL, 4),
(146294, NULL, 'G3DSA:3.30.1360.120:FF:000082', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(146295, NULL, 'G3DSA:1.20.272.10:FF:000067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146296, NULL, 'G3DSA:2.60.210.10:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146297, NULL, 'G3DSA:1.20.120.30:FF:000007', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(146298, NULL, 'G3DSA:1.10.287.380:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146299, NULL, 'G3DSA:2.130.10.10:FF:000751', NULL, NULL, '40S ribosomal processing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(146300, NULL, 'G3DSA:3.30.70.330:FF:000507', NULL, NULL, 'serine/arginine-rich splicing factor 1B', NULL, NULL, NULL, NULL, NULL, 4),
(146301, NULL, 'G3DSA:3.40.50.720:FF:001810', NULL, NULL, 'CurJ', NULL, NULL, NULL, NULL, NULL, 4),
(146302, NULL, 'G3DSA:3.30.420.10:FF:000121', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(146303, NULL, 'G3DSA:1.20.1070.10:FF:001665', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146304, NULL, 'G3DSA:3.30.1370.10:FF:000043', NULL, NULL, 'KH domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(146305, NULL, 'G3DSA:3.40.50.720:FF:000045', NULL, NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(146306, NULL, 'G3DSA:2.130.10.10:FF:001240', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(146307, NULL, 'G3DSA:1.10.150.240:FF:000128', NULL, NULL, 'HAD-superfamily hydrolase, subfamily IA, variant 3', NULL, NULL, NULL, NULL, NULL, 4),
(146308, NULL, 'G3DSA:3.30.910.20:FF:000015', NULL, NULL, 'Outer membrane protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(146309, NULL, 'G3DSA:3.80.10.10:FF:000700', NULL, NULL, 'Leucine-rich repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(146310, NULL, 'G3DSA:1.25.10.10:FF:000158', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(146311, NULL, 'G3DSA:1.10.510.10:FF:003046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146312, NULL, 'G3DSA:3.30.30.10:FF:000018', NULL, NULL, 'Defensin NsD7', NULL, NULL, NULL, NULL, NULL, 4),
(146313, NULL, 'G3DSA:3.40.190.10:FF:000134', NULL, NULL, 'Nickel-binding periplasmic protein NikA', NULL, NULL, NULL, NULL, NULL, 4),
(146314, NULL, 'G3DSA:3.30.160.60:FF:000868', NULL, NULL, 'putative histone-lysine N-methyltransferase PRDM6', NULL, NULL, NULL, NULL, NULL, 4),
(146315, NULL, 'G3DSA:1.20.1050.10:FF:000028', NULL, NULL, 'Prostaglandin E synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(146316, NULL, 'G3DSA:1.10.510.10:FF:000096', NULL, NULL, 'cGMP-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(146317, NULL, 'G3DSA:3.90.470.20:FF:000024', NULL, NULL, 'Siderophore biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(146318, NULL, 'G3DSA:2.60.40.3530:FF:000001', NULL, NULL, 'Early E3 18.5 kDa glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(146319, NULL, 'G3DSA:2.180.10.10:FF:000018', NULL, NULL, 'Protein rhsD', NULL, NULL, NULL, NULL, NULL, 4),
(146320, NULL, 'G3DSA:3.80.10.10:FF:000021', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(146321, NULL, 'G3DSA:3.30.559.10:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146322, NULL, 'G3DSA:3.10.100.10:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146323, NULL, 'G3DSA:2.60.40.10:FF:000773', NULL, NULL, 'obscurin isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(146324, NULL, 'G3DSA:3.40.50.10810:FF:000176', NULL, NULL, 'SNF2 superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(146325, NULL, 'G3DSA:3.30.160.60:FF:000559', NULL, NULL, 'zinc finger protein 462 isoform X1', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(146326, NULL, 'G3DSA:3.50.50.60:FF:000146', NULL, NULL, 'Mitochondrial translation optimization protein (Mto1)', NULL, NULL, NULL, NULL, NULL, 4),
(146327, NULL, 'G3DSA:2.60.120.260:FF:000571', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(146328, NULL, 'G3DSA:2.60.120.10:FF:000399', NULL, NULL, 'Si:ch211-161h7.4', NULL, NULL, NULL, NULL, NULL, 4),
(146329, NULL, 'G3DSA:3.30.160.60:FF:000189', NULL, NULL, 'zinc finger protein 133 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(146330, NULL, 'G3DSA:3.30.420.40:FF:000809', NULL, NULL, 'SWI/SNF and RSC complexes subunit arp9', NULL, NULL, NULL, NULL, NULL, 4),
(146331, NULL, 'G3DSA:3.30.70.1230:FF:000189', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(146332, NULL, 'G3DSA:1.25.10.10:FF:002636', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(146333, NULL, 'G3DSA:1.20.1250.20:FF:001766', NULL, NULL, 'Putative nitrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(146334, NULL, 'G3DSA:3.30.70.330:FF:002424', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146335, NULL, 'G3DSA:1.10.287.690:FF:000009', NULL, NULL, 'DNA polymerase epsilon catalytic subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(146336, NULL, 'G3DSA:3.90.1460.10:FF:000008', NULL, NULL, 'General transcription factor II-I repeat domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(146337, NULL, 'G3DSA:1.10.3210.10:FF:000128', NULL, NULL, 'Exopolyphosphatase Ppx', NULL, NULL, NULL, NULL, NULL, 4),
(146338, NULL, 'G3DSA:3.90.940.10:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146339, NULL, 'G3DSA:2.60.260.20:FF:000120', NULL, NULL, 'dnaJ homolog subfamily A member 2', NULL, NULL, NULL, NULL, NULL, 4),
(146340, NULL, 'G3DSA:3.60.21.10:FF:000249', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(146341, NULL, 'G3DSA:3.90.470.10:FF:000004', NULL, NULL, '50S ribosomal protein L22, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(146342, NULL, 'G3DSA:3.40.50.1220:FF:000104', NULL, NULL, 'Putative 2-hydroxyacyl-CoA lyase', NULL, NULL, NULL, NULL, NULL, 4),
(146343, NULL, 'G3DSA:3.40.50.1780:FF:000025', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(146344, NULL, 'G3DSA:1.20.1020.10:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146345, NULL, 'G3DSA:3.30.70.330:FF:001918', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146346, NULL, 'G3DSA:2.20.20.100:FF:000002', NULL, NULL, 'Autoinducer 2 sensor kinase/phosphatase LuxQ', NULL, NULL, NULL, NULL, NULL, 4),
(146347, NULL, 'G3DSA:1.25.40.10:FF:002138', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(146348, NULL, 'G3DSA:1.10.455.10:FF:000028', NULL, NULL, 'Ribosomal protein S7 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(146349, NULL, 'G3DSA:3.30.70.330:FF:000524', NULL, NULL, 'RNA-binding motif protein 38', NULL, NULL, NULL, NULL, NULL, 4),
(146350, NULL, 'G3DSA:1.10.238.10:FF:000951', NULL, NULL, 'Calcineurin subunit B type 2', NULL, NULL, NULL, NULL, NULL, 4),
(146351, NULL, 'G3DSA:3.40.980.10:FF:000037', NULL, NULL, 'CinA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(146352, NULL, 'G3DSA:2.60.40.60:FF:000294', NULL, NULL, 'Protocadherin alpha subfamily C, 2', NULL, NULL, NULL, NULL, NULL, 4),
(146353, NULL, 'G3DSA:2.40.50.140:FF:000151', NULL, NULL, 'Asparagine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(146354, NULL, 'G3DSA:3.90.70.10:FF:000491', NULL, NULL, 'Senescence-specific cysteine protease SAG39', NULL, NULL, NULL, NULL, NULL, 4),
(146355, NULL, 'G3DSA:3.30.540.10:FF:000068', NULL, NULL, 'Fructose-1,6-bisphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(146356, NULL, 'G3DSA:2.20.20.110:FF:000005', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(146357, NULL, 'G3DSA:3.90.550.10:FF:000640', NULL, NULL, 'Asparagine Linked Glycosylation (ALG) homolog, Nematode', NULL, NULL, NULL, NULL, NULL, 4),
(146358, NULL, 'G3DSA:2.40.160.210:FF:000024', NULL, NULL, 'ACL122Wp', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(146359, NULL, 'G3DSA:3.10.20.90:FF:000571', NULL, NULL, 'ELongin B', NULL, NULL, NULL, NULL, NULL, 4),
(146360, NULL, 'G3DSA:3.50.7.10:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146361, NULL, 'G3DSA:2.130.10.10:FF:002196', NULL, NULL, 'Protein will die slowly-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(146362, NULL, 'G3DSA:2.10.25.10:FF:001139', NULL, NULL, 'Dumpy, isoform AA', NULL, NULL, NULL, NULL, NULL, 4),
(146363, NULL, 'G3DSA:3.30.230.10:FF:000067', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(146364, NULL, 'G3DSA:1.10.287.1080:FF:000004', NULL, NULL, 'dCTP pyrophosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(146365, NULL, 'G3DSA:3.40.50.620:FF:000015', NULL, NULL, 'NH(3)-dependent NAD(+) synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(146366, NULL, 'G3DSA:3.40.630.10:FF:000461', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146367, NULL, 'G3DSA:2.70.130.10:FF:000173', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146368, NULL, 'G3DSA:2.10.25.10:FF:001095', NULL, NULL, 'Stabilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(146369, NULL, 'G3DSA:2.60.40.60:FF:000338', NULL, NULL, 'Protocadherin-15', NULL, NULL, NULL, NULL, NULL, 4),
(146370, NULL, 'G3DSA:3.30.200.20:FF:000052', NULL, NULL, 'Serine/threonine-protein kinase RIO2', NULL, NULL, NULL, NULL, NULL, 4),
(146371, NULL, 'G3DSA:3.90.1150.10:FF:000333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146372, NULL, 'G3DSA:3.10.450.40:FF:000035', NULL, NULL, 'Hemagglutinin/proteinase', NULL, NULL, NULL, NULL, NULL, 4),
(146373, NULL, 'G3DSA:3.10.28.10:FF:000031', NULL, NULL, 'Intron-encoded endonuclease I-SceI', NULL, NULL, NULL, NULL, NULL, 4),
(146374, NULL, 'G3DSA:2.20.70.10:FF:000248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146375, NULL, 'G3DSA:2.60.120.200:FF:000025', NULL, NULL, 'Xyloglucan endotransglucosylase/hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(146376, NULL, 'G3DSA:3.10.450.50:FF:000038', NULL, NULL, 'Nuclear RNA export factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(146377, NULL, 'G3DSA:3.30.60.20:FF:000158', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(146378, NULL, 'G3DSA:1.20.1270.10:FF:000011', NULL, NULL, 'stress-70 protein, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(146379, NULL, 'G3DSA:1.20.1560.10:FF:000112', NULL, NULL, 'ATP binding cassette subfamily C member 5', NULL, NULL, NULL, NULL, NULL, 4),
(146380, NULL, 'G3DSA:3.10.110.10:FF:000147', NULL, NULL, 'Putative ubiquitin-conjugating enzyme E2 25', NULL, NULL, NULL, NULL, NULL, 4),
(146381, NULL, 'G3DSA:1.25.10.10:FF:000793', NULL, NULL, 'Protein CBR-DAF-15', NULL, NULL, NULL, NULL, NULL, 4),
(146382, NULL, 'G3DSA:3.90.1150.10:FF:000041', NULL, NULL, 'Low-specificity L-threonine aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(146383, NULL, 'G3DSA:1.10.287.1490:FF:000037', NULL, NULL, 'Elastin microfibril interfacer 3', NULL, NULL, NULL, NULL, NULL, 4),
(146384, NULL, 'G3DSA:1.10.1660.10:FF:000009', NULL, NULL, 'HTH-type transcriptional regulator ycgE', NULL, NULL, NULL, NULL, NULL, 4),
(146385, NULL, 'G3DSA:3.30.160.60:FF:005101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146386, NULL, 'G3DSA:2.60.40.790:FF:000081', NULL, NULL, 'Phosphatase-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(146387, NULL, 'G3DSA:3.40.50.300:FF:004972', NULL, NULL, 'Gluconokinase', NULL, NULL, NULL, NULL, NULL, 4),
(146388, NULL, 'G3DSA:3.30.70.960:FF:000022', NULL, NULL, 'Mucin 16', NULL, NULL, NULL, NULL, NULL, 4),
(146389, NULL, 'G3DSA:2.30.30.550:FF:000007', NULL, NULL, 'Major vault protein', NULL, NULL, NULL, NULL, NULL, 4),
(146390, NULL, 'G3DSA:2.30.30.100:FF:000204', NULL, NULL, 'Probable U6 snRNA-associated Sm-like protein LSm3', NULL, NULL, NULL, NULL, NULL, 4),
(146391, NULL, 'G3DSA:3.30.450.40:FF:000093', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(146392, NULL, 'G3DSA:1.20.5.340:FF:000095', NULL, NULL, 'Rabaptin, RAB GTPase-binding effector protein 2', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(146393, NULL, 'G3DSA:1.10.3430.10:FF:000010', NULL, NULL, 'Ammonium transporter', NULL, NULL, NULL, NULL, NULL, 4),
(146394, NULL, 'G3DSA:1.10.1450.10:FF:000174', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(146395, NULL, 'G3DSA:1.10.400.10:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146396, NULL, 'G3DSA:1.10.340.30:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146397, NULL, 'G3DSA:3.30.450.30:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146398, NULL, 'G3DSA:3.30.390.50:FF:000023', NULL, NULL, 'Carbon monoxide dehydrogenase, medium subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(146399, NULL, 'G3DSA:1.10.10.10:FF:002086', NULL, NULL, 'Interferon regulatory factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(146400, NULL, 'G3DSA:1.20.1510.10:FF:000064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146401, NULL, 'G3DSA:3.90.780.10:FF:000005', NULL, NULL, 'Putative 5''-nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(146402, NULL, 'G3DSA:3.40.50.300:FF:000459', NULL, NULL, 'ras-related protein Rab-37 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(146403, NULL, 'G3DSA:3.50.50.60:FF:000472', NULL, NULL, 'Putative glycine oxidase ThiO', NULL, NULL, NULL, NULL, NULL, 4),
(146404, NULL, 'G3DSA:3.30.420.40:FF:000591', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146405, NULL, 'G3DSA:1.20.1270.60:FF:000110', NULL, NULL, 'Sorting nexin', NULL, NULL, NULL, NULL, NULL, 4),
(146406, NULL, 'G3DSA:3.80.10.10:FF:003264', NULL, NULL, 'Disease resistance protein RPS2', NULL, NULL, NULL, NULL, NULL, 4),
(146407, NULL, 'G3DSA:2.60.40.180:FF:000004', NULL, NULL, '5-hydroxyisourate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(146408, NULL, 'G3DSA:1.25.40.10:FF:000295', NULL, NULL, 'serine/threonine-protein phosphatase 5', NULL, NULL, NULL, NULL, NULL, 4),
(146409, NULL, 'G3DSA:1.10.287.70:FF:000110', NULL, NULL, 'Potassium channel subfamily K member', NULL, NULL, NULL, NULL, NULL, 4),
(146410, NULL, 'G3DSA:3.30.760.10:FF:000051', NULL, NULL, 'Eukaryotic translation initiation factor 4E type 1B', NULL, NULL, NULL, NULL, NULL, 4),
(146411, NULL, 'G3DSA:1.25.40.10:FF:002464', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g71420', NULL, NULL, NULL, NULL, NULL, 4),
(146412, NULL, 'G3DSA:3.10.100.10:FF:000219', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146413, NULL, 'G3DSA:3.40.50.12780:FF:000064', NULL, NULL, 'Probable medium chain fatty-acid-CoA ligase fadD14', NULL, NULL, NULL, NULL, NULL, 4),
(146414, NULL, 'G3DSA:3.30.160.60:FF:001402', NULL, NULL, 'Zinc finger protein 473', NULL, NULL, NULL, NULL, NULL, 4),
(146415, NULL, 'G3DSA:3.30.70.980:FF:000028', NULL, NULL, 'Probable transcriptional regulatory protein ERS082928_00922', NULL, NULL, NULL, NULL, NULL, 4),
(146416, NULL, 'G3DSA:3.80.10.10:FF:001465', NULL, NULL, 'Leucine-rich repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(146417, NULL, 'G3DSA:2.70.20.50:FF:000002', NULL, NULL, 'Matrix protein', NULL, NULL, NULL, NULL, NULL, 4),
(146418, NULL, 'G3DSA:3.40.50.880:FF:000144', NULL, NULL, 'DJ-1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(146419, NULL, 'G3DSA:3.40.850.10:FF:000033', NULL, NULL, 'Kinesin-like protein KIN-12E', NULL, NULL, NULL, NULL, NULL, 4),
(146420, NULL, 'G3DSA:1.25.40.20:FF:000859', NULL, NULL, 'LOW QUALITY PROTEIN: kinase D-interacting substrate of 220 kDa B-like', NULL, NULL, NULL, NULL, NULL, 4),
(146421, NULL, 'G3DSA:2.60.40.150:FF:000237', NULL, NULL, 'Synaptotagmin 15', NULL, NULL, NULL, NULL, NULL, 4),
(146422, NULL, 'G3DSA:3.40.190.10:FF:000090', NULL, NULL, 'Glycine betaine transporter periplasmic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(146423, NULL, 'G3DSA:3.30.70.1730:FF:000001', NULL, NULL, '50S ribosomal protein L10', NULL, NULL, NULL, NULL, NULL, 4),
(146424, NULL, 'G3DSA:1.10.357.50:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146425, NULL, 'G3DSA:1.10.418.10:FF:000268', NULL, NULL, 'Protein hook homolog', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(146426, NULL, 'G3DSA:3.30.590.50:FF:000021', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(146427, NULL, 'G3DSA:1.20.1070.10:FF:001991', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146428, NULL, 'G3DSA:3.30.160.60:FF:004921', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146429, NULL, 'G3DSA:3.40.50.80:FF:000034', NULL, NULL, 'Respiratory burst oxidase homolog protein B', NULL, NULL, NULL, NULL, NULL, 4),
(146430, NULL, 'G3DSA:3.50.50.100:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146431, NULL, 'G3DSA:1.10.150.20:FF:000132', NULL, NULL, 'Exonuclease-1, H3TH domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(146432, NULL, 'G3DSA:2.40.50.140:FF:000049', NULL, NULL, '26S protease regulatory subunit 6B', NULL, NULL, NULL, NULL, NULL, 4),
(146433, NULL, 'G3DSA:3.40.630.10:FF:000135', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(146434, NULL, 'G3DSA:1.10.287.110:FF:000358', NULL, NULL, 'Chloroplast DnaJ-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(146435, NULL, 'G3DSA:1.10.10.10:FF:000539', NULL, NULL, '40S ribosomal protein S10, putative', NULL, NULL, NULL, NULL, NULL, 4),
(146436, NULL, 'G3DSA:2.40.70.10:FF:000231', NULL, NULL, 'Sap98p', NULL, NULL, NULL, NULL, NULL, 4),
(146437, NULL, 'G3DSA:2.40.40.20:FF:000069', NULL, NULL, 'NADPH-Fe(3+) oxidoreductase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(146438, NULL, 'G3DSA:1.10.30.10:FF:000086', NULL, NULL, 'Protein CBG16280', NULL, NULL, NULL, NULL, NULL, 4),
(146439, NULL, 'G3DSA:1.10.1180.10:FF:000001', NULL, NULL, 'DNA transposition protein (GpB)', NULL, NULL, NULL, NULL, NULL, 4),
(146440, NULL, 'G3DSA:3.30.200.20:FF:002513', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146441, NULL, 'G3DSA:2.60.120.200:FF:000351', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(146442, NULL, 'G3DSA:3.40.50.1980:FF:000130', NULL, NULL, 'Putative histidinol dehydrogenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(146443, NULL, 'G3DSA:2.40.50.140:FF:000712', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146444, NULL, 'G3DSA:3.40.50.1000:FF:000639', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146445, NULL, 'G3DSA:1.25.40.10:FF:002773', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146446, NULL, 'G3DSA:1.50.10.130:FF:000012', NULL, NULL, 'Tricyclene synthase 1e20, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(146447, NULL, 'G3DSA:1.10.1450.10:FF:000089', NULL, NULL, 'TetraSPanin family', NULL, NULL, NULL, NULL, NULL, 4),
(146448, NULL, 'G3DSA:1.20.1640.10:FF:000068', NULL, NULL, 'RND multidrug efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(146449, NULL, 'G3DSA:2.30.30.40:FF:000294', NULL, NULL, 'Chemotaxis protein CheW', NULL, NULL, NULL, NULL, NULL, 4),
(146450, NULL, 'G3DSA:2.30.30.940:FF:000001', NULL, NULL, 'ATP-dependent RecD-like DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(146451, NULL, 'G3DSA:2.40.10.10:FF:000564', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146452, NULL, 'G3DSA:3.30.70.370:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146453, NULL, 'G3DSA:3.30.390.50:FF:000006', NULL, NULL, 'FAD binding domain in molybdopterin dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(146454, NULL, 'G3DSA:2.60.40.10:FF:004281', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146455, NULL, 'G3DSA:3.40.1080.10:FF:000018', NULL, NULL, 'CoA transferase CarA2', NULL, NULL, NULL, NULL, NULL, 4),
(146456, NULL, 'G3DSA:3.90.550.10:FF:000494', NULL, NULL, 'Glycosyltransferases', NULL, NULL, NULL, NULL, NULL, 4),
(146457, NULL, 'G3DSA:2.130.10.10:FF:000734', NULL, NULL, 'Protein RAE1', NULL, NULL, NULL, NULL, NULL, 4),
(146458, NULL, 'G3DSA:3.10.50.10:FF:000037', NULL, NULL, 'Chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(146459, NULL, 'G3DSA:3.40.50.1000:FF:000432', NULL, NULL, 'Polynucleotide kinase 3''-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(146460, NULL, 'G3DSA:3.30.420.100:FF:000007', NULL, NULL, 'Ribosomal L18p/L5e family protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(146461, NULL, 'G3DSA:1.50.40.10:FF:000377', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146462, NULL, 'G3DSA:3.40.50.720:FF:000028', NULL, NULL, 'NAD(P) transhydrogenase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(146463, NULL, 'G3DSA:2.30.42.10:FF:000060', NULL, NULL, 'Connector enhancer of kinase suppressor of Ras 2', NULL, NULL, NULL, NULL, NULL, 4),
(146464, NULL, 'G3DSA:2.30.29.150:FF:000009', NULL, NULL, 'Nucleosome binding factor SPN, SPT16 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(146465, NULL, 'G3DSA:3.50.50.60:FF:000163', NULL, NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(146466, NULL, 'G3DSA:3.40.50.1380:FF:000028', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(146467, NULL, 'G3DSA:3.30.200.20:FF:002204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146468, NULL, 'G3DSA:2.60.40.1300:FF:000001', NULL, NULL, 'Putative DD-carboxypeptidase TP_0574', NULL, NULL, NULL, NULL, NULL, 4),
(146469, NULL, 'G3DSA:2.40.160.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146470, NULL, 'G3DSA:3.40.50.10810:FF:000193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146471, NULL, 'G3DSA:1.25.40.20:FF:000298', NULL, NULL, 'ArfGAP with GTPase domain, ankyrin repeat and PH domain 2', NULL, NULL, NULL, NULL, NULL, 4),
(146472, NULL, 'G3DSA:1.25.10.10:FF:000484', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(146473, NULL, 'G3DSA:1.25.40.10:FF:001958', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(146474, NULL, 'G3DSA:1.10.10.10:FF:000848', NULL, NULL, 'Regulatory protein RecX', NULL, NULL, NULL, NULL, NULL, 4),
(146475, NULL, 'G3DSA:1.25.40.180:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146476, NULL, 'G3DSA:1.10.8.270:FF:000194', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(146477, NULL, 'G3DSA:3.40.525.10:FF:000019', NULL, NULL, 'RhoGAP GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(146478, NULL, 'G3DSA:1.10.20.10:FF:000158', NULL, NULL, 'Histone-like_transcription_factor_(CBF/NF-Y)_and_ archaeal_histone/Core_histone_H2A/H2B/H3/H4_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(146479, NULL, 'G3DSA:2.30.30.100:FF:000221', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm8', NULL, NULL, NULL, NULL, NULL, 4),
(146480, NULL, 'G3DSA:2.60.40.150:FF:000254', NULL, NULL, 'protein unc-13 homolog D isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(146481, NULL, 'G3DSA:3.20.20.70:FF:000727', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146482, NULL, 'G3DSA:3.30.160.60:FF:002667', NULL, NULL, 'Si:dkey-1b17.7 protein', NULL, NULL, NULL, NULL, NULL, 4),
(146483, NULL, 'G3DSA:3.30.420.40:FF:000826', NULL, NULL, 'Actin-related protein 5-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(146484, NULL, 'G3DSA:2.40.70.10:FF:000540', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146485, NULL, 'G3DSA:2.130.10.10:FF:000425', NULL, NULL, 'Cytoplasmic dynein 1 intermediate chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(146486, NULL, 'G3DSA:1.10.10.60:FF:000414', NULL, NULL, 'Transcription factor RAX3', NULL, NULL, NULL, NULL, NULL, 4),
(146487, NULL, 'G3DSA:1.20.120.1200:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146488, NULL, 'G3DSA:2.170.130.10:FF:000047', NULL, NULL, 'SusC/RagA family TonB-linked outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(146489, NULL, 'G3DSA:3.80.10.10:FF:003909', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146490, NULL, 'G3DSA:3.90.550.10:FF:000185', NULL, NULL, 'Glycosyl transferase, group 2', NULL, NULL, NULL, NULL, NULL, 4),
(146491, NULL, 'G3DSA:3.30.40.10:FF:001683', NULL, NULL, 'RUN and FYVE domain-containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(146492, NULL, 'G3DSA:1.25.40.10:FF:003858', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(146493, NULL, 'G3DSA:3.40.50.1820:FF:001824', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(146494, NULL, 'G3DSA:3.40.50.1000:FF:000078', NULL, NULL, 'Bifunctional polynucleotide phosphatase/kinase', NULL, NULL, NULL, NULL, NULL, 4),
(146495, NULL, 'G3DSA:3.30.420.80:FF:000035', NULL, NULL, 'Mitochondrial ribosomal protein L18, putative', NULL, NULL, NULL, NULL, NULL, 4),
(146496, NULL, 'G3DSA:3.30.160.60:FF:004567', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146497, NULL, 'G3DSA:2.120.10.30:FF:000605', NULL, NULL, 'Dipeptidyl aminopeptidase BIII', NULL, NULL, NULL, NULL, NULL, 4),
(146498, NULL, 'G3DSA:3.10.330.20:FF:000015', NULL, NULL, 'tRNA (adenine(58)-N(1))-methyltransferase catalytic subunit TRMT61A', NULL, NULL, NULL, NULL, NULL, 4),
(146499, NULL, 'G3DSA:2.30.130.30:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146500, NULL, 'G3DSA:4.10.400.10:FF:000267', NULL, NULL, 'LDL receptor protein 1, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(146501, NULL, 'G3DSA:3.40.50.720:FF:002153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146502, NULL, 'G3DSA:1.10.8.210:FF:000002', NULL, NULL, 'Siroheme synthase', NULL, NULL, NULL, NULL, NULL, 4),
(146503, NULL, 'G3DSA:2.40.37.20:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146504, NULL, 'G3DSA:1.10.10.10:FF:000332', NULL, NULL, 'DEP domain-containing mTOR-interacting protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(146505, NULL, 'G3DSA:2.70.150.10:FF:000191', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(146506, NULL, 'G3DSA:3.30.70.330:FF:001935', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146507, NULL, 'G3DSA:2.10.25.10:FF:001802', NULL, NULL, 'Low density lipoprotein receptor-related protein 1Aa', NULL, NULL, NULL, NULL, NULL, 4),
(146508, NULL, 'G3DSA:3.40.30.10:FF:000479', NULL, NULL, 'Thioredoxin domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(146509, NULL, 'G3DSA:3.30.200.20:FF:000922', NULL, NULL, 'Serine/threonine-protein kinase-like protein At1g28390', NULL, NULL, NULL, NULL, NULL, 4),
(146510, NULL, 'G3DSA:2.60.40.1900:FF:000001', NULL, NULL, 'Beta-microseminoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(146511, NULL, 'G3DSA:1.10.510.10:FF:002692', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146512, NULL, 'G3DSA:2.40.37.10:FF:000013', NULL, NULL, 'Carboxynorspermidine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(146513, NULL, 'G3DSA:1.10.3090.10:FF:000039', NULL, NULL, 'Bifunctional uridylyltransferase/uridylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(146514, NULL, 'G3DSA:2.40.50.40:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146515, NULL, 'G3DSA:1.20.58.70:FF:000077', NULL, NULL, 'YALI0E33165p', NULL, NULL, NULL, NULL, NULL, 4),
(146516, NULL, 'G3DSA:2.60.260.20:FF:000075', NULL, NULL, 'Chaperone protein DNAj, putative', NULL, NULL, NULL, NULL, NULL, 4),
(146517, NULL, 'G3DSA:2.60.40.10:FF:004842', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146518, NULL, 'G3DSA:3.40.50.300:FF:000947', NULL, NULL, 'DNA repair protein RAD50', NULL, NULL, NULL, NULL, NULL, 4),
(146519, NULL, 'G3DSA:3.10.330.10:FF:000012', NULL, NULL, 'AAA family ATPase, CDC48 subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(146520, NULL, 'G3DSA:3.30.360.10:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146521, NULL, 'G3DSA:2.40.50.730:FF:000029', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(146522, NULL, 'G3DSA:3.40.50.2000:FF:000602', NULL, NULL, 'Glycosyltransferase family protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(146523, NULL, 'G3DSA:1.25.40.10:FF:004038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146524, NULL, 'G3DSA:3.40.50.2300:FF:000232', NULL, NULL, 'Response regulator GraR', NULL, NULL, NULL, NULL, NULL, 4),
(146525, NULL, 'G3DSA:1.10.472.10:FF:000539', NULL, NULL, 'Cyclin-B1-4', NULL, NULL, NULL, NULL, NULL, 4),
(146526, NULL, 'G3DSA:3.40.50.620:FF:000341', NULL, NULL, 'Deoxyribodipyrimidine photolyase single-strand-specific', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(146527, NULL, 'G3DSA:3.30.200.20:FF:000613', NULL, NULL, 'Fibrillarin-like rRNA/tRNA 2''-O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(146528, NULL, 'G3DSA:1.20.1070.10:FF:001811', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(146529, NULL, 'G3DSA:3.30.200.20:FF:000361', NULL, NULL, 'Dual specificity testis-specific protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(146530, NULL, 'G3DSA:3.20.20.70:FF:000598', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146531, NULL, 'G3DSA:2.40.70.10:FF:000438', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146532, NULL, 'G3DSA:3.60.21.50:FF:000019', NULL, NULL, 'Polymerase (DNA directed), delta 2, accessory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(146533, NULL, 'G3DSA:3.30.230.10:FF:000112', NULL, NULL, 'Eukaryotic translation elongation factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(146534, NULL, 'G3DSA:1.20.1110.10:FF:000129', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146535, NULL, 'G3DSA:2.60.34.10:FF:000051', NULL, NULL, 'Heat shock protein70', NULL, NULL, NULL, NULL, NULL, 4),
(146536, NULL, 'G3DSA:1.25.40.10:FF:004347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146537, NULL, 'G3DSA:1.20.58.60:FF:000074', NULL, NULL, 'dystonin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(146538, NULL, 'G3DSA:1.10.287.110:FF:000460', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146539, NULL, 'G3DSA:1.10.10.10:FF:000641', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(146540, NULL, 'G3DSA:3.30.160.60:FF:004258', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146541, NULL, 'G3DSA:1.10.532.10:FF:000011', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(146542, NULL, 'G3DSA:3.30.565.10:FF:000412', NULL, NULL, 'HAMP domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(146543, NULL, 'G3DSA:1.10.150.670:FF:000010', NULL, NULL, 'GD16537', NULL, NULL, NULL, NULL, NULL, 4),
(146544, NULL, 'G3DSA:1.25.10.10:FF:002075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146545, NULL, 'G3DSA:3.30.420.40:FF:000265', NULL, NULL, 'Actin-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(146546, NULL, 'G3DSA:2.60.40.10:FF:002690', NULL, NULL, 'AGAP003610-PA', NULL, NULL, NULL, NULL, NULL, 4),
(146547, NULL, 'G3DSA:3.40.1490.10:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146548, NULL, 'G3DSA:3.80.10.10:FF:003590', NULL, NULL, 'Flagellar associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(146549, NULL, 'G3DSA:4.10.320.10:FF:000002', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(146550, NULL, 'G3DSA:3.40.50.220:FF:000002', NULL, NULL, 'Ornithine decarboxylase, constitutive', NULL, NULL, NULL, NULL, NULL, 4),
(146551, NULL, 'G3DSA:1.10.510.10:FF:003501', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146552, NULL, 'G3DSA:3.10.660.10:FF:000014', NULL, NULL, 'GG10921', NULL, NULL, NULL, NULL, NULL, 4),
(146553, NULL, 'G3DSA:1.20.5.110:FF:000110', NULL, NULL, 'Sulfate permease family', NULL, NULL, NULL, NULL, NULL, 4),
(146554, NULL, 'G3DSA:3.40.50.2300:FF:000147', NULL, NULL, 'Atrial natriuretic peptide receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(146555, NULL, 'G3DSA:3.30.160.60:FF:006158', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146556, NULL, 'G3DSA:1.20.1510.10:FF:000081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146557, NULL, 'G3DSA:2.20.70.10:FF:000265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146558, NULL, 'G3DSA:3.30.450.40:FF:000076', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(146559, NULL, 'G3DSA:1.20.1530.20:FF:000085', NULL, NULL, 'Sodium/bile acid cotransporter 7-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(146560, NULL, 'G3DSA:1.20.120.20:FF:000021', NULL, NULL, 'Apolipoprotein E', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(146561, NULL, 'G3DSA:3.40.50.150:FF:000279', NULL, NULL, 'Methyltransferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(146562, NULL, 'G3DSA:3.30.870.10:FF:000071', NULL, NULL, 'Tyrosyl-DNA phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(146563, NULL, 'G3DSA:3.50.50.60:FF:000601', NULL, NULL, '2-octaprenyl-3-methyl-6-methoxy-1,4-benzoquinol hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(146564, NULL, 'G3DSA:1.10.510.10:FF:002883', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(146565, NULL, 'G3DSA:2.60.120.650:FF:000238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146566, NULL, 'G3DSA:1.20.1270.280:FF:000077', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(146567, NULL, 'G3DSA:1.20.1050.130:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146568, NULL, 'G3DSA:2.10.110.10:FF:000145', NULL, NULL, 'Cysteine and glycine-rich protein', NULL, NULL, NULL, NULL, NULL, 4),
(146569, NULL, 'G3DSA:2.10.70.80:FF:000011', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(146570, NULL, 'G3DSA:3.30.1360.120:FF:000065', NULL, NULL, 'Dimethylglycine dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(146571, NULL, 'G3DSA:3.30.70.20:FF:000131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146572, NULL, 'G3DSA:3.30.70.1050:FF:000011', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(146573, NULL, 'G3DSA:3.40.50.720:FF:000236', NULL, NULL, 'Bifunctional dTDP-4-dehydrorhamnose 3,5-epimerase/dTDP-4-dehydrorhamnose reductase', NULL, NULL, NULL, NULL, NULL, 4),
(146574, NULL, 'G3DSA:3.90.1410.10:FF:000078', NULL, NULL, 'SET domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(146575, NULL, 'G3DSA:1.20.58.340:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146576, NULL, 'G3DSA:1.10.340.30:FF:000043', NULL, NULL, 'N-glycosylase/DNA lyase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(146577, NULL, 'G3DSA:3.30.420.40:FF:000147', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(146578, NULL, 'G3DSA:1.10.400.10:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146579, NULL, 'G3DSA:1.10.533.10:FF:000148', NULL, NULL, 'CASP2 and RIPK1 domain containing adaptor with death domain', NULL, NULL, NULL, NULL, NULL, 4),
(146580, NULL, 'G3DSA:1.20.1070.10:FF:001682', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(146581, NULL, 'G3DSA:3.30.450.30:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146582, NULL, 'G3DSA:2.40.10.10:FF:000238', NULL, NULL, 'Kallikrein related peptidase 13', NULL, NULL, NULL, NULL, NULL, 4),
(146583, NULL, 'G3DSA:1.25.10.10:FF:002721', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146584, NULL, 'G3DSA:3.30.40.10:FF:001598', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(146585, NULL, 'G3DSA:3.40.190.10:FF:000117', NULL, NULL, 'Glutamate receptor, ionotropic kainate', NULL, NULL, NULL, NULL, NULL, 4),
(146586, NULL, 'G3DSA:3.40.50.300:FF:001302', NULL, NULL, 'DNA replication ATP-dependent helicase/nuclease DNA2', NULL, NULL, NULL, NULL, NULL, 4),
(146587, NULL, 'G3DSA:1.20.1050.10:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146588, NULL, 'G3DSA:2.30.180.10:FF:000117', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146589, NULL, 'G3DSA:1.20.58.1040:FF:000016', NULL, NULL, '1,3-beta-glucanosyltransferase GAS2', NULL, NULL, NULL, NULL, NULL, 4),
(146590, NULL, 'G3DSA:2.60.40.10:FF:000790', NULL, NULL, 'HLA class II histocompatibility antigen, DM alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(146591, NULL, 'G3DSA:3.30.200.20:FF:002485', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146592, NULL, 'G3DSA:3.30.310.40:FF:000009', NULL, NULL, 'Putative 8-oxoguanine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(146593, NULL, 'G3DSA:1.25.10.10:FF:000719', NULL, NULL, 'Karyopherin/importin that interacts with the nuclear pore complex', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(146594, NULL, 'G3DSA:2.60.40.10:FF:000902', NULL, NULL, 'MER proto-oncogene, tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(146595, NULL, 'G3DSA:3.30.450.20:FF:000070', NULL, NULL, 'Two-component system sensor histidine kinase CreC', NULL, NULL, NULL, NULL, NULL, 4),
(146596, NULL, 'G3DSA:1.20.1050.10:FF:000045', NULL, NULL, 'Glutathione S-transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(146597, NULL, 'G3DSA:2.40.10.10:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146598, NULL, 'G3DSA:3.90.79.10:FF:000246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146599, NULL, 'G3DSA:3.30.70.330:FF:002733', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146600, NULL, 'G3DSA:3.50.50.100:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146601, NULL, 'G3DSA:3.40.50.1820:FF:001178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146602, NULL, 'G3DSA:3.40.50.300:FF:004955', NULL, NULL, 'GPN-loop GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(146603, NULL, 'G3DSA:3.30.160.60:FF:003510', NULL, NULL, 'GM10229', NULL, NULL, NULL, NULL, NULL, 4),
(146604, NULL, 'G3DSA:1.25.40.10:FF:002801', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(146605, NULL, 'G3DSA:3.90.1480.20:FF:000029', NULL, NULL, 'ST3 beta-galactoside alpha-2,3-sialyltransferase 1,-like', NULL, NULL, NULL, NULL, NULL, 4),
(146606, NULL, 'G3DSA:3.30.160.60:FF:002459', NULL, NULL, 'myeloid zinc finger 1 isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(146607, NULL, 'G3DSA:3.30.200.20:FF:002058', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(146608, NULL, 'G3DSA:1.10.730.10:FF:000106', NULL, NULL, 'Methionine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(146609, NULL, 'G3DSA:3.30.160.60:FF:003887', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146610, NULL, 'G3DSA:1.10.510.10:FF:003400', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146611, NULL, 'G3DSA:3.40.190.10:FF:000651', NULL, NULL, 'ABC transporter substrate-binding protein-oligopeptide transport', NULL, NULL, NULL, NULL, NULL, 4),
(146612, NULL, 'G3DSA:3.30.70.660:FF:000005', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(146613, NULL, 'G3DSA:2.40.340.10:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146614, NULL, 'G3DSA:3.40.50.720:FF:001439', NULL, NULL, 'CD38 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(146615, NULL, 'G3DSA:3.30.70.580:FF:000015', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(146616, NULL, 'G3DSA:3.50.50.60:FF:000500', NULL, NULL, 'D-amino acid oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(146617, NULL, 'G3DSA:1.10.287.80:FF:000028', NULL, NULL, 'Probable lysine-specific histone demethylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(146618, NULL, 'G3DSA:3.30.50.10:FF:000020', NULL, NULL, 'Zinc finger transcription factor Trps1', NULL, NULL, NULL, NULL, NULL, 4),
(146619, NULL, 'G3DSA:1.10.275.40:FF:000006', NULL, NULL, 'Excision repair cross-complementation group 2', NULL, NULL, NULL, NULL, NULL, 4),
(146620, NULL, 'G3DSA:3.100.10.10:FF:000001', NULL, NULL, '60S ribosomal protein L18', NULL, NULL, NULL, NULL, NULL, 4),
(146621, NULL, 'G3DSA:2.10.25.10:FF:001448', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146622, NULL, 'G3DSA:3.90.105.10:FF:000033', NULL, NULL, 'Molybdenum cofactor biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(146623, NULL, 'G3DSA:1.20.1000.10:FF:000008', NULL, NULL, 'Guanylate-binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(146624, NULL, 'G3DSA:1.20.58.900:FF:000032', NULL, NULL, 'FYVE and coiled-coil domain-containing 1a', NULL, NULL, NULL, NULL, NULL, 4),
(146625, NULL, 'G3DSA:2.60.40.10:FF:002347', NULL, NULL, 'Protein sidekick homolog', NULL, NULL, NULL, NULL, NULL, 4),
(146626, NULL, 'G3DSA:2.30.30.40:FF:000614', NULL, NULL, 'SH3 and multiple ankyrin repeat domains 3', NULL, NULL, NULL, NULL, NULL, 4),
(146627, NULL, 'G3DSA:1.20.1020.10:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(146628, NULL, 'G3DSA:2.120.10.80:FF:000351', NULL, NULL, 'Attractin-like 1a', NULL, NULL, NULL, NULL, NULL, 4),
(146629, NULL, 'G3DSA:3.40.50.1220:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146630, NULL, 'G3DSA:3.40.50.1000:FF:000286', NULL, NULL, 'NLI_interacting_factor-like_phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(146631, NULL, 'G3DSA:1.50.40.10:FF:000568', NULL, NULL, 'Mitochondrial energy transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(146632, NULL, 'G3DSA:3.30.70.330:FF:000171', NULL, NULL, 'Meiosis regulator and mRNA stability factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(146633, NULL, 'G3DSA:3.50.4.10:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146634, NULL, 'G3DSA:3.40.50.1010:FF:000289', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146635, NULL, 'G3DSA:1.25.40.20:FF:000977', NULL, NULL, 'Ankyrin repeat domain 55', NULL, NULL, NULL, NULL, NULL, 4),
(146636, NULL, 'G3DSA:1.10.275.30:FF:000003', NULL, NULL, 'ATP-dependent DNA helicase Saci_0192', NULL, NULL, NULL, NULL, NULL, 4),
(146637, NULL, 'G3DSA:2.160.20.10:FF:000211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146638, NULL, 'G3DSA:3.40.50.300:FF:004854', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(146639, NULL, 'G3DSA:1.20.1540.10:FF:000021', NULL, NULL, 'UBA domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(146640, NULL, 'G3DSA:2.60.200.20:FF:000099', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(146641, NULL, 'G3DSA:3.40.50.1240:FF:000127', NULL, NULL, 'Uncharacterized protein, isoform J', NULL, NULL, NULL, NULL, NULL, 4),
(146642, NULL, 'G3DSA:3.90.190.10:FF:000201', NULL, NULL, 'Tyrosine-protein phosphatase cdc-14', NULL, NULL, NULL, NULL, NULL, 4),
(146643, NULL, 'G3DSA:3.30.210.10:FF:000004', NULL, NULL, 'DNA-directed DNA/RNA polymerase mu', NULL, NULL, NULL, NULL, NULL, 4),
(146644, NULL, 'G3DSA:3.40.50.300:FF:008553', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(146645, NULL, 'G3DSA:3.40.50.300:FF:002393', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(146646, NULL, 'G3DSA:2.40.50.140:FF:000504', NULL, NULL, 'RNA m5u methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(146647, NULL, 'G3DSA:3.40.50.2000:FF:000131', NULL, NULL, 'Trehalose-6-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(146648, NULL, 'G3DSA:3.90.550.50:FF:000039', NULL, NULL, 'WGS project CABT00000000 data, contig 2.9', NULL, NULL, NULL, NULL, NULL, 4),
(146649, NULL, 'G3DSA:3.40.630.30:FF:000585', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146650, NULL, 'G3DSA:1.25.40.540:FF:000027', NULL, NULL, 'Uncharacterized protein C63.05', NULL, NULL, NULL, NULL, NULL, 4),
(146651, NULL, 'G3DSA:3.10.20.90:FF:000554', NULL, NULL, 'NADPH oxidase activator 1', NULL, NULL, NULL, NULL, NULL, 4),
(146652, NULL, 'G3DSA:3.90.260.10:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146653, NULL, 'G3DSA:3.40.30.10:FF:000288', NULL, NULL, 'Tryparedoxin 1a', NULL, NULL, NULL, NULL, NULL, 4),
(146654, NULL, 'G3DSA:1.20.1560.10:FF:000230', NULL, NULL, 'AGAP008437-PA', NULL, NULL, NULL, NULL, NULL, 4),
(146655, NULL, 'G3DSA:2.60.40.2170:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146656, NULL, 'G3DSA:3.40.140.10:FF:000069', NULL, NULL, 'Cytidine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(146657, NULL, 'G3DSA:1.10.1370.10:FF:000010', NULL, NULL, 'Protein CBG00366', NULL, NULL, NULL, NULL, NULL, 4),
(146658, NULL, 'G3DSA:1.10.238.10:FF:000625', NULL, NULL, 'Putative calmodulin-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(146659, NULL, 'G3DSA:1.25.40.10:FF:004246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146660, NULL, 'G3DSA:2.60.120.10:FF:000753', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146661, NULL, 'G3DSA:1.25.40.530:FF:000024', NULL, NULL, 'Myosin XVB', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(146662, NULL, 'G3DSA:1.10.1600.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146663, NULL, 'G3DSA:3.40.50.2300:FF:001676', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146664, NULL, 'G3DSA:1.25.40.10:FF:000547', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(146665, NULL, 'G3DSA:3.90.226.10:FF:000151', NULL, NULL, 'Probable enoyl-CoA hydratase/isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(146666, NULL, 'G3DSA:3.30.830.10:FF:000315', NULL, NULL, 'Mitochondrial Processing Peptidase Alpha', NULL, NULL, NULL, NULL, NULL, 4),
(146667, NULL, 'G3DSA:3.90.70.10:FF:000389', NULL, NULL, 'Cysteine proteinases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(146668, NULL, 'G3DSA:1.25.40.10:FF:004673', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(146669, NULL, 'G3DSA:3.30.565.10:FF:000384', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(146670, NULL, 'G3DSA:1.10.4180.10:FF:000001', NULL, NULL, 'Transcription factor floricaula/leafy', NULL, NULL, NULL, NULL, NULL, 4),
(146671, NULL, 'G3DSA:3.30.450.190:FF:000006', NULL, NULL, 'GTR1p Cytoplasmic GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(146672, NULL, 'G3DSA:3.80.10.10:FF:003691', NULL, NULL, 'SYM-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(146673, NULL, 'G3DSA:1.10.238.10:FF:001131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146674, NULL, 'G3DSA:3.30.160.60:FF:000970', NULL, NULL, 'zinc finger protein 333 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(146675, NULL, 'G3DSA:3.40.30.10:FF:000496', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146676, NULL, 'G3DSA:3.40.30.10:FF:001114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146677, NULL, 'G3DSA:2.60.40.10:FF:005899', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146678, NULL, 'G3DSA:3.40.190.10:FF:000342', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(146679, NULL, 'G3DSA:3.90.780.10:FF:000022', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(146680, NULL, 'G3DSA:4.10.280.10:FF:000178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146681, NULL, 'G3DSA:1.20.58.60:FF:000091', NULL, NULL, 'dystrophin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(146682, NULL, 'G3DSA:1.10.940.10:FF:000032', NULL, NULL, 'Transcription antitermination protein NusB', NULL, NULL, NULL, NULL, NULL, 4),
(146683, NULL, 'G3DSA:1.10.3930.10:FF:000003', NULL, NULL, 'Arginine deiminase', NULL, NULL, NULL, NULL, NULL, 4),
(146684, NULL, 'G3DSA:1.10.510.10:FF:002675', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146685, NULL, 'G3DSA:3.40.50.300:FF:006299', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(146686, NULL, 'G3DSA:3.40.50.300:FF:006900', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146687, NULL, 'G3DSA:1.25.40.20:FF:000770', NULL, NULL, 'Ankyrin repeat-containing protein ITN1', NULL, NULL, NULL, NULL, NULL, 4),
(146688, NULL, 'G3DSA:3.90.1150.210:FF:000004', NULL, NULL, 'F-actin-capping protein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(146689, NULL, 'G3DSA:3.30.1010.10:FF:000005', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(146690, NULL, 'G3DSA:2.60.120.260:FF:000262', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(146691, NULL, 'G3DSA:1.25.40.10:FF:003993', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146692, NULL, 'G3DSA:1.25.40.10:FF:000856', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(146693, NULL, 'G3DSA:1.20.58.70:FF:000094', NULL, NULL, 'AGAP008756-PA', NULL, NULL, NULL, NULL, NULL, 4),
(146694, NULL, 'G3DSA:1.20.58.830:FF:000045', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(146695, NULL, 'G3DSA:1.10.472.130:FF:000028', NULL, NULL, 'GM14172', NULL, NULL, NULL, NULL, NULL, 4),
(146696, NULL, 'G3DSA:1.25.40.10:FF:000340', NULL, NULL, 'Cyclic nucleotide-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(146697, NULL, 'G3DSA:3.40.50.1820:FF:001279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146698, NULL, 'G3DSA:2.70.98.10:FF:000063', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(146699, NULL, 'G3DSA:3.40.50.300:FF:002494', NULL, NULL, 'AFG1 family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(146700, NULL, 'G3DSA:3.50.50.60:FF:000264', NULL, NULL, 'Ferrodoxin reductase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(146701, NULL, 'G3DSA:3.30.160.60:FF:000661', NULL, NULL, 'paternally-expressed gene 3 protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(146702, NULL, 'G3DSA:3.30.200.20:FF:000260', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', NULL, NULL, NULL, NULL, NULL, 4),
(146703, NULL, 'G3DSA:3.30.565.10:FF:000075', NULL, NULL, 'MORC family CW-type zinc finger protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(146704, NULL, 'G3DSA:2.130.10.10:FF:001122', NULL, NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(146705, NULL, 'G3DSA:2.40.50.140:FF:000813', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146706, NULL, 'G3DSA:1.10.630.10:FF:000121', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(146707, NULL, 'G3DSA:2.60.40.60:FF:000973', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146708, NULL, 'G3DSA:2.130.10.10:FF:006057', NULL, NULL, 'LOC100145488 protein', NULL, NULL, NULL, NULL, NULL, 4),
(146709, NULL, 'G3DSA:2.60.40.10:FF:003162', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146710, NULL, 'G3DSA:2.60.40.10:FF:002246', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(146711, NULL, 'G3DSA:2.60.260.20:FF:000119', NULL, NULL, 'Chaperone protein DNAj, putative', NULL, NULL, NULL, NULL, NULL, 4),
(146712, NULL, 'G3DSA:2.40.30.10:FF:000094', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(146713, NULL, 'G3DSA:3.90.550.10:FF:000729', NULL, NULL, 'Ceramide glucosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(146714, NULL, 'G3DSA:3.40.50.300:FF:006237', NULL, NULL, 'Helicase swr1', NULL, NULL, NULL, NULL, NULL, 4),
(146715, NULL, 'G3DSA:3.30.1050.10:FF:000013', NULL, NULL, 'Metallo-beta-lactamase superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(146716, NULL, 'G3DSA:3.40.350.10:FF:000006', NULL, NULL, 'FACT complex subunit SPT16', NULL, NULL, NULL, NULL, NULL, 4),
(146717, NULL, 'G3DSA:3.30.420.40:FF:000248', NULL, NULL, 'Actin-related protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(146718, NULL, 'G3DSA:2.60.40.60:FF:000546', NULL, NULL, 'Cadherin 17, LI cadherin (liver-intestine)', NULL, NULL, NULL, NULL, NULL, 4),
(146719, NULL, 'G3DSA:1.20.970.30:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146720, NULL, 'G3DSA:3.80.20.20:FF:000070', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(146721, NULL, 'G3DSA:3.30.70.360:FF:000022', NULL, NULL, 'Hippurate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(146722, NULL, 'G3DSA:3.30.870.10:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146723, NULL, 'G3DSA:1.10.238.10:FF:000524', NULL, NULL, 'Mitochondrial Rho GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(146724, NULL, 'G3DSA:1.20.970.20:FF:000001', NULL, NULL, 'Surface composition regulator', NULL, NULL, NULL, NULL, NULL, 4),
(146725, NULL, 'G3DSA:3.40.109.10:FF:000042', NULL, NULL, 'Nitroreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(146726, NULL, 'G3DSA:3.10.110.10:FF:000029', NULL, NULL, 'Ubiquitin conjugating enzyme E2 D3', NULL, NULL, NULL, NULL, NULL, 4),
(146727, NULL, 'G3DSA:2.10.109.10:FF:000030', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(146728, NULL, 'G3DSA:1.10.1410.10:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(146729, NULL, 'G3DSA:3.80.10.10:FF:002600', NULL, NULL, 'Leucine rich repeats and calponin homology domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(146730, NULL, 'G3DSA:3.40.47.10:FF:000135', NULL, NULL, 'Beta-ketoacyl synthase', NULL, NULL, NULL, NULL, NULL, 4),
(146731, NULL, 'G3DSA:3.80.10.10:FF:001982', NULL, NULL, 'AT5g40470/K21I16_20', NULL, NULL, NULL, NULL, NULL, 4),
(146732, NULL, 'G3DSA:3.30.110.20:FF:000022', NULL, NULL, 'AGR216Wp', NULL, NULL, NULL, NULL, NULL, 4),
(146733, NULL, 'G3DSA:2.120.10.30:FF:000061', NULL, NULL, 'teneurin-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(146734, NULL, 'G3DSA:3.30.70.370:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146735, NULL, 'G3DSA:3.90.1150.10:FF:000007', NULL, NULL, 'Glycine dehydrogenase (decarboxylating), mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(146736, NULL, 'G3DSA:2.40.30.10:FF:000346', NULL, NULL, 'U5 snRNP GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(146737, NULL, 'G3DSA:1.20.120.350:FF:000198', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146738, NULL, 'G3DSA:1.10.3380.30:FF:000005', NULL, NULL, 'Ski2 like RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(146739, NULL, 'G3DSA:3.40.50.300:FF:004646', NULL, NULL, 'Methyl coenzyme M reductase system, component A2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(146740, NULL, 'G3DSA:2.60.40.60:FF:000855', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146741, NULL, 'G3DSA:3.30.230.120:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146742, NULL, 'G3DSA:3.60.40.10:FF:000130', NULL, NULL, 'Related to PTC7-type 2C protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(146743, NULL, 'G3DSA:1.10.10.10:FF:000186', NULL, NULL, 'AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(146744, NULL, 'G3DSA:3.90.1150.220:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146745, NULL, 'G3DSA:2.60.40.10:FF:002555', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(146746, NULL, 'G3DSA:1.10.3380.20:FF:000002', NULL, NULL, 'helicase POLQ-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(146747, NULL, 'G3DSA:3.30.1640.10:FF:000036', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(146748, NULL, 'G3DSA:2.40.50.100:FF:000178', NULL, NULL, 'Acetoin dehydrogenase complex, E2 component, dihydrolipoamide acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(146749, NULL, 'G3DSA:3.30.1370.10:FF:000161', NULL, NULL, 'RNA-binding protein rnc1', NULL, NULL, NULL, NULL, NULL, 4),
(146750, NULL, 'G3DSA:1.25.40.20:FF:001023', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(146751, NULL, 'G3DSA:2.40.160.20:FF:000038', NULL, NULL, 'Outer membrane protein P5', NULL, NULL, NULL, NULL, NULL, 4),
(146752, NULL, 'G3DSA:3.10.20.90:FF:000762', NULL, NULL, 'Ras-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(146753, NULL, 'G3DSA:1.10.238.10:FF:000833', NULL, NULL, 'YALI0A20518p', NULL, NULL, NULL, NULL, NULL, 4),
(146754, NULL, 'G3DSA:2.120.10.30:FF:000268', NULL, NULL, 'Lipoprotein receptor', NULL, NULL, NULL, NULL, NULL, 4),
(146755, NULL, 'G3DSA:2.130.10.10:FF:003140', NULL, NULL, 'Intraflagellar transport 140', NULL, NULL, NULL, NULL, NULL, 4),
(146756, NULL, 'G3DSA:3.40.50.300:FF:002185', NULL, NULL, 'DNA mismatch repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(146757, NULL, 'G3DSA:1.25.40.280:FF:000005', NULL, NULL, 'pH-response regulator protein palC', NULL, NULL, NULL, NULL, NULL, 4),
(146758, NULL, 'G3DSA:1.25.10.10:FF:000467', NULL, NULL, 'Beta-catenin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(146759, NULL, 'G3DSA:2.20.100.10:FF:000002', NULL, NULL, 'Unc-5 netrin receptor C', NULL, NULL, NULL, NULL, NULL, 4),
(146760, NULL, 'G3DSA:3.90.190.10:FF:000100', NULL, NULL, 'Phosphatase domain-containing paladin 1b', NULL, NULL, NULL, NULL, NULL, 4),
(146761, NULL, 'G3DSA:1.20.89.10:FF:000001', NULL, NULL, 'Nitrogenase molybdenum-iron protein beta chain', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(146762, NULL, 'G3DSA:3.40.50.1820:FF:000514', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(146763, NULL, 'G3DSA:2.40.160.10:FF:000035', NULL, NULL, 'OpdB proline porin', NULL, NULL, NULL, NULL, NULL, 4),
(146764, NULL, 'G3DSA:1.20.1250.20:FF:001457', NULL, NULL, 'Major facilitator superfamily MFS_1', NULL, NULL, NULL, NULL, NULL, 4),
(146765, NULL, 'G3DSA:1.25.40.10:FF:001020', NULL, NULL, 'Protein HLB1', NULL, NULL, NULL, NULL, NULL, 4),
(146766, NULL, 'G3DSA:2.60.40.1120:FF:000071', NULL, NULL, 'Putative ferric aerobactin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(146767, NULL, 'G3DSA:3.30.460.80:FF:000009', NULL, NULL, 'NADH-quinone oxidoreductase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(146768, NULL, 'G3DSA:2.30.29.30:FF:000220', NULL, NULL, 'methylosome subunit pICln isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(146769, NULL, 'G3DSA:3.40.390.10:FF:000115', NULL, NULL, 'Matrix metallopeptidase 30', NULL, NULL, NULL, NULL, NULL, 4),
(146770, NULL, 'G3DSA:3.40.50.1370:FF:000008', NULL, NULL, 'Ornithine carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(146771, NULL, 'G3DSA:3.80.10.10:FF:001673', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase EFR', NULL, NULL, NULL, NULL, NULL, 4),
(146772, NULL, 'G3DSA:3.30.160.60:FF:004713', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146773, NULL, 'G3DSA:2.30.130.40:FF:000027', NULL, NULL, 'Lon protease', NULL, NULL, NULL, NULL, NULL, 4),
(146774, NULL, 'G3DSA:3.30.465.10:FF:000011', NULL, NULL, 'Alkylglycerone-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(146775, NULL, 'G3DSA:3.30.70.1450:FF:000024', NULL, NULL, 'Chloride transporter, ClC family', NULL, NULL, NULL, NULL, NULL, 4),
(146776, NULL, 'G3DSA:1.10.10.60:FF:001111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146777, NULL, 'G3DSA:3.90.550.10:FF:000286', NULL, NULL, 'PGL/p-HBAD biosynthesis glycosyltransferase BCG_2978', NULL, NULL, NULL, NULL, NULL, 4),
(146778, NULL, 'G3DSA:3.40.50.300:FF:001066', NULL, NULL, 'DNA helicase INO80-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(146779, NULL, 'G3DSA:3.30.200.60:FF:000013', NULL, NULL, 'Ubiquitin thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(146780, NULL, 'G3DSA:1.25.10.10:FF:000512', NULL, NULL, 'Pumilio homology domain family member 6', NULL, NULL, NULL, NULL, NULL, 4),
(146781, NULL, 'G3DSA:3.40.50.720:FF:002254', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(146782, NULL, 'G3DSA:3.30.70.2010:FF:000001', NULL, NULL, '2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-succinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(146783, NULL, 'G3DSA:2.60.40.10:FF:002038', NULL, NULL, 'Basement membrane proteoglycan', NULL, NULL, NULL, NULL, NULL, 4),
(146784, NULL, 'G3DSA:3.10.129.10:FF:000201', NULL, NULL, 'Fluoroacetyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(146785, NULL, 'G3DSA:1.20.58.2010:FF:000009', NULL, NULL, 'Rop guanine nucleotide exchange factor 7', NULL, NULL, NULL, NULL, NULL, 4),
(146786, NULL, 'G3DSA:3.30.200.20:FF:000276', NULL, NULL, 'Receptor tyrosine-protein kinase erbB-3', NULL, NULL, NULL, NULL, NULL, 4),
(146787, NULL, 'G3DSA:3.40.50.300:FF:006445', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146788, NULL, 'G3DSA:3.40.1350.100:FF:000002', NULL, NULL, 'Protein TIC 22-like, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(146789, NULL, 'G3DSA:2.60.120.260:FF:000228', NULL, NULL, 'E3 ubiquitin-protein ligase rpm-1', NULL, NULL, NULL, NULL, NULL, 4),
(146790, NULL, 'G3DSA:3.90.70.10:FF:000535', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146791, NULL, 'G3DSA:3.40.47.10:FF:000034', NULL, NULL, 'Acetyl-CoA acetyltransferase, cytosolic', NULL, NULL, NULL, NULL, NULL, 4),
(146792, NULL, 'G3DSA:2.60.40.10:FF:004707', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146793, NULL, 'G3DSA:3.30.2350.20:FF:000028', NULL, NULL, 'tRNA pseudouridine synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(146794, NULL, 'G3DSA:3.20.20.100:FF:000021', NULL, NULL, 'Hypothetical oxidoreductase YdbC', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(146795, NULL, 'G3DSA:3.30.160.60:FF:002768', NULL, NULL, 'Zinc finger protein 408', NULL, NULL, NULL, NULL, NULL, 4),
(146796, NULL, 'G3DSA:2.170.140.10:FF:000003', NULL, NULL, 'Tequila, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(146797, NULL, 'G3DSA:3.40.50.1820:FF:001487', NULL, NULL, 'LIPaSe related', NULL, NULL, NULL, NULL, NULL, 4),
(146798, NULL, 'G3DSA:3.90.920.10:FF:000011', NULL, NULL, 'DNA primase small subunit PriS', NULL, NULL, NULL, NULL, NULL, 4),
(146799, NULL, 'G3DSA:2.60.40.10:FF:002908', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146800, NULL, 'G3DSA:3.40.50.300:FF:001420', NULL, NULL, 'ADP-ribosylation factor 4a', NULL, NULL, NULL, NULL, NULL, 4),
(146801, NULL, 'G3DSA:1.10.10.10:FF:000540', NULL, NULL, 'DNA-binding transcriptional activator BglJ', NULL, NULL, NULL, NULL, NULL, 4),
(146802, NULL, 'G3DSA:3.10.180.10:FF:000084', NULL, NULL, '4-hydroxyphenylpyruvate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(146803, NULL, 'G3DSA:3.40.30.10:FF:000951', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146804, NULL, 'G3DSA:3.30.420.40:FF:000456', NULL, NULL, 'Actin related protein', NULL, NULL, NULL, NULL, NULL, 4),
(146805, NULL, 'G3DSA:3.40.50.300:FF:002746', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(146806, NULL, 'G3DSA:3.40.50.1820:FF:000205', NULL, NULL, 'Non-haem bromoperoxidase BPO-A2', NULL, NULL, NULL, NULL, NULL, 4),
(146807, NULL, 'G3DSA:2.170.300.10:FF:000010', NULL, NULL, 'Scavenger receptor class F member 2', NULL, NULL, NULL, NULL, NULL, 4),
(146808, NULL, 'G3DSA:1.10.110.10:FF:000020', NULL, NULL, 'Trypsin inhibitor CMe', NULL, NULL, NULL, NULL, NULL, 4),
(146809, NULL, 'G3DSA:3.40.50.2300:FF:000041', NULL, NULL, 'Low molecular weight protein-tyrosine-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(146810, NULL, 'G3DSA:1.25.40.20:FF:000197', NULL, NULL, 'protein fem-1 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(146811, NULL, 'G3DSA:3.30.70.330:FF:000480', NULL, NULL, 'Fne, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(146812, NULL, 'G3DSA:1.20.120.180:FF:000006', NULL, NULL, 'Proteasome activator complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(146813, NULL, 'G3DSA:2.130.10.10:FF:000217', NULL, NULL, 'Lysosomal trafficking regulator', NULL, NULL, NULL, NULL, NULL, 4),
(146814, NULL, 'G3DSA:3.30.230.70:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146815, NULL, 'G3DSA:1.25.40.20:FF:000668', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146816, NULL, 'G3DSA:1.25.40.10:FF:000194', NULL, NULL, 'Tetratricopeptide repeat domain 5', NULL, NULL, NULL, NULL, NULL, 4),
(146817, NULL, 'G3DSA:3.50.50.60:FF:000707', NULL, NULL, 'Tryptophan halogenase', NULL, NULL, NULL, NULL, NULL, 4),
(146818, NULL, 'G3DSA:3.30.420.40:FF:000810', NULL, NULL, 'SWI/SNF and RSC complexes subunit arp9', NULL, NULL, NULL, NULL, NULL, 4),
(146819, NULL, 'G3DSA:1.20.1250.20:FF:001867', NULL, NULL, 'Siderophore iron transporter mirA', NULL, NULL, NULL, NULL, NULL, 4),
(146820, NULL, 'G3DSA:1.10.238.10:FF:000316', NULL, NULL, 'Calcium-binding EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(146821, NULL, 'G3DSA:3.55.40.20:FF:000022', NULL, NULL, 'Superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(146822, NULL, 'G3DSA:2.160.20.10:FF:000109', NULL, NULL, 'Hemagglutination activity domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(146823, NULL, 'G3DSA:3.30.420.40:FF:000911', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146824, NULL, 'G3DSA:3.40.1360.10:FF:000057', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(146825, NULL, 'G3DSA:3.40.630.10:FF:000270', NULL, NULL, 'Peptide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(146826, NULL, 'G3DSA:3.40.30.10:FF:000597', NULL, NULL, 'Thioredoxin-like protein CXXS1', NULL, NULL, NULL, NULL, NULL, 4),
(146827, NULL, 'G3DSA:3.30.70.330:FF:001817', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146828, NULL, 'G3DSA:2.130.10.10:FF:004775', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(146829, NULL, 'G3DSA:3.30.70.330:FF:002323', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146830, NULL, 'G3DSA:1.10.510.10:FF:002574', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146831, NULL, 'G3DSA:2.60.40.10:FF:004808', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146832, NULL, 'G3DSA:3.30.1320.10:FF:000006', NULL, NULL, '30S ribosomal protein S16', NULL, NULL, NULL, NULL, NULL, 4),
(146833, NULL, 'G3DSA:3.30.497.10:FF:000028', NULL, NULL, 'Serine proteinase inhibitor 2', NULL, NULL, NULL, NULL, NULL, 4),
(146834, NULL, 'G3DSA:3.60.21.10:FF:000148', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(146835, NULL, 'G3DSA:2.160.20.60:FF:000001', NULL, NULL, 'Glutamate synthase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(146836, NULL, 'G3DSA:3.30.40.10:FF:000154', NULL, NULL, 'PHD finger protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(146837, NULL, 'G3DSA:3.30.230.10:FF:000213', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(146838, NULL, 'G3DSA:2.10.25.10:FF:000976', NULL, NULL, 'Low-density lipoprotein RecePtor related', NULL, NULL, NULL, NULL, NULL, 4),
(146839, NULL, 'G3DSA:2.40.50.730:FF:000013', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(146840, NULL, 'G3DSA:3.40.50.12780:FF:000210', NULL, NULL, 'Folliculin-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(146841, NULL, 'G3DSA:3.40.50.2300:FF:000131', NULL, NULL, 'Piwi-like RNA-mediated gene silencing 1', NULL, NULL, NULL, NULL, NULL, 4),
(146842, NULL, 'G3DSA:3.30.1330.20:FF:000038', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(146843, NULL, 'G3DSA:1.20.1250.10:FF:000010', NULL, NULL, 'Macrophage colony-stimulating factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(146844, NULL, 'G3DSA:2.40.160.90:FF:000002', NULL, NULL, 'Transferrin-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(146845, NULL, 'G3DSA:1.20.1250.20:FF:000013', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(146846, NULL, 'G3DSA:1.20.1520.10:FF:000003', NULL, NULL, 'GM24123', NULL, NULL, NULL, NULL, NULL, 4),
(146847, NULL, 'G3DSA:3.40.50.10860:FF:000067', NULL, NULL, 'Bifunctional protein FolD', NULL, NULL, NULL, NULL, NULL, 4),
(146848, NULL, 'G3DSA:3.40.50.1820:FF:001588', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146849, NULL, 'G3DSA:3.10.20.90:FF:000806', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146850, NULL, 'G3DSA:3.30.200.20:FF:002176', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(146851, NULL, 'G3DSA:1.25.40.10:FF:002094', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(146852, NULL, 'G3DSA:1.10.3430.10:FF:000009', NULL, NULL, 'Blood group Rh(D) polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(146853, NULL, 'G3DSA:3.90.1310.10:FF:000014', NULL, NULL, 'Penicillin-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(146854, NULL, 'G3DSA:3.40.50.300:FF:003320', NULL, NULL, 'Rho family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(146855, NULL, 'G3DSA:3.30.1330.10:FF:000035', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(146856, NULL, 'G3DSA:3.70.10.10:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146857, NULL, 'G3DSA:3.90.190.20:FF:000058', NULL, NULL, 'Bifunctional folylpolyglutamate synthase/dihydrofolate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(146858, NULL, 'G3DSA:1.25.10.10:FF:000366', NULL, NULL, 'DnaJ homolog subfamily C GRV2', NULL, NULL, NULL, NULL, NULL, 4),
(146859, NULL, 'G3DSA:3.40.50.300:FF:004545', NULL, NULL, 'ATP synthase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(146860, NULL, 'G3DSA:2.60.40.1400:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146861, NULL, 'G3DSA:2.30.42.10:FF:000413', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146862, NULL, 'G3DSA:3.40.1410.10:FF:000016', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(146863, NULL, 'G3DSA:3.30.50.10:FF:000126', NULL, NULL, 'Steroid hormone receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(146864, NULL, 'G3DSA:1.25.10.10:FF:002827', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146865, NULL, 'G3DSA:1.20.1280.290:FF:000031', NULL, NULL, 'Mannose-P-dolichol utilization defect 1', NULL, NULL, NULL, NULL, NULL, 4),
(146866, NULL, 'G3DSA:1.20.900.10:FF:000050', NULL, NULL, 'Guanine nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(146867, NULL, 'G3DSA:3.30.450.40:FF:000284', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(146868, NULL, 'G3DSA:1.20.1420.30:FF:000052', NULL, NULL, 'Potassium-dependent sodium-calcium exchanger, putative', NULL, NULL, NULL, NULL, NULL, 4),
(146869, NULL, 'G3DSA:3.30.40.10:FF:001582', NULL, NULL, 'E3 ubiquitin-protein ligase RMA3', NULL, NULL, NULL, NULL, NULL, 4),
(146870, NULL, 'G3DSA:3.60.21.10:FF:000457', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(146871, NULL, 'G3DSA:1.10.10.60:FF:000515', NULL, NULL, 'Transcription factor MYB7', NULL, NULL, NULL, NULL, NULL, 4),
(146872, NULL, 'G3DSA:1.10.10.60:FF:001021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146873, NULL, 'G3DSA:3.30.465.10:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146874, NULL, 'G3DSA:2.60.40.790:FF:000182', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146875, NULL, 'G3DSA:3.40.50.720:FF:000500', NULL, NULL, 'Blast:Retinol dehydrogenase 14', NULL, NULL, NULL, NULL, NULL, 4),
(146876, NULL, 'G3DSA:1.10.150.20:FF:000194', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(146877, NULL, 'G3DSA:2.40.20.10:FF:000065', NULL, NULL, 'Hepatocyte growth factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(146878, NULL, 'G3DSA:2.120.10.30:FF:000504', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146879, NULL, 'G3DSA:3.40.190.10:FF:000460', NULL, NULL, 'Glutamate receptor 2.8', NULL, NULL, NULL, NULL, NULL, 4),
(146880, NULL, 'G3DSA:3.30.70.330:FF:002632', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146881, NULL, 'G3DSA:3.40.50.1820:FF:001633', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(146882, NULL, 'G3DSA:2.60.120.1190:FF:000018', NULL, NULL, 'Discoidin domain receptor tyrosine kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(146883, NULL, 'G3DSA:1.10.8.270:FF:000076', NULL, NULL, 'Rab GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(146884, NULL, 'G3DSA:2.40.10.10:FF:000446', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146885, NULL, 'G3DSA:2.30.240.10:FF:000004', NULL, NULL, 'At1g55265', NULL, NULL, NULL, NULL, NULL, 4),
(146886, NULL, 'G3DSA:1.10.1070.11:FF:000078', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(146887, NULL, 'G3DSA:1.10.730.10:FF:000095', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(146888, NULL, 'G3DSA:1.20.1250.20:FF:001912', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146889, NULL, 'G3DSA:3.30.200.20:FF:000731', NULL, NULL, 'Glycogen synthase kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(146890, NULL, 'G3DSA:3.90.1170.50:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146891, NULL, 'G3DSA:3.40.390.10:FF:000071', NULL, NULL, 'Zinc metalloproteinase', NULL, NULL, NULL, NULL, NULL, 4),
(146892, NULL, 'G3DSA:3.30.40.10:FF:000300', NULL, NULL, 'Bromodomain adjacent to zinc finger domain protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(146893, NULL, 'G3DSA:3.40.50.300:FF:004293', NULL, NULL, 'Dephospho-CoA kinase', NULL, NULL, NULL, NULL, NULL, 4),
(146894, NULL, 'G3DSA:1.20.1250.20:FF:001558', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(146895, NULL, 'G3DSA:4.10.1000.10:FF:000042', NULL, NULL, 'Gar2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(146896, NULL, 'G3DSA:1.10.510.10:FF:001040', NULL, NULL, 'Related to SSK2-MAP kinase kinase kinase of the high osmolarity signal transduction pathway', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(146897, NULL, 'G3DSA:2.130.10.10:FF:002566', NULL, NULL, 'Transcriptional corepressor (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(146898, NULL, 'G3DSA:1.25.10.10:FF:000057', NULL, NULL, 'Exportin-2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(146899, NULL, 'G3DSA:3.40.50.300:FF:003011', NULL, NULL, 'DNA repair helicase', NULL, NULL, NULL, NULL, NULL, 4),
(146900, NULL, 'G3DSA:1.25.40.10:FF:002655', NULL, NULL, 'Cleavage stimulation factor subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(146901, NULL, 'G3DSA:3.40.640.10:FF:000208', NULL, NULL, 'Decarboxylase, group II', NULL, NULL, NULL, NULL, NULL, 4),
(146902, NULL, 'G3DSA:3.30.60.20:FF:000057', NULL, NULL, 'Ras association domain family member 5', NULL, NULL, NULL, NULL, NULL, 4),
(146903, NULL, 'G3DSA:2.130.10.110:FF:000011', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(146904, NULL, 'G3DSA:2.60.40.150:FF:000355', NULL, NULL, 'Protein CBR-SNT-7', NULL, NULL, NULL, NULL, NULL, 4),
(146905, NULL, 'G3DSA:2.70.170.10:FF:000265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146906, NULL, 'G3DSA:3.90.70.10:FF:000283', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(146907, NULL, 'G3DSA:3.20.20.100:FF:000111', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(146908, NULL, 'G3DSA:2.60.40.10:FF:000756', NULL, NULL, 'Interleukin 1 receptor accessory protein', NULL, NULL, NULL, NULL, NULL, 4),
(146909, NULL, 'G3DSA:3.40.1090.10:FF:000064', NULL, NULL, 'Patatin', NULL, NULL, NULL, NULL, NULL, 4),
(146910, NULL, 'G3DSA:1.20.58.390:FF:000177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146911, NULL, 'G3DSA:1.20.1070.10:FF:001339', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(146912, NULL, 'G3DSA:2.60.120.200:FF:000160', NULL, NULL, 'Laminin subunit alpha-3', NULL, NULL, NULL, NULL, NULL, 4),
(146913, NULL, 'G3DSA:2.60.40.1170:FF:000068', NULL, NULL, 'Adaptor complex subunit medium chain 3', NULL, NULL, NULL, NULL, NULL, 4),
(146914, NULL, 'G3DSA:2.110.10.10:FF:000044', NULL, NULL, 'LOC100127856 protein', NULL, NULL, NULL, NULL, NULL, 4),
(146915, NULL, 'G3DSA:1.10.287.3990:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146916, NULL, 'G3DSA:1.25.10.10:FF:002266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146917, NULL, 'G3DSA:3.90.79.10:FF:000038', NULL, NULL, 'Tudor-interacting repair regulator protein', NULL, NULL, NULL, NULL, NULL, 4),
(146918, NULL, 'G3DSA:2.30.30.40:FF:000193', NULL, NULL, 'Rho guanine nucleotide exchange factor 38', NULL, NULL, NULL, NULL, NULL, 4),
(146919, NULL, 'G3DSA:1.10.443.10:FF:000012', NULL, NULL, 'Phage integrase family', NULL, NULL, NULL, NULL, NULL, 4),
(146920, NULL, 'G3DSA:3.30.1550.10:FF:000006', NULL, NULL, '50S ribosomal protein L11', NULL, NULL, NULL, NULL, NULL, 4),
(146921, NULL, 'G3DSA:1.10.510.10:FF:004474', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146922, NULL, 'G3DSA:1.25.40.1050:FF:000008', NULL, NULL, '5''-3'' exoribonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(146923, NULL, 'G3DSA:3.40.800.10:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146924, NULL, 'G3DSA:3.40.50.300:FF:008036', NULL, NULL, 'Lon protease homolog', NULL, NULL, NULL, NULL, NULL, 4),
(146925, NULL, 'G3DSA:1.10.10.60:FF:000206', NULL, NULL, 'transcription termination factor 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(146926, NULL, 'G3DSA:3.30.260.10:FF:000041', NULL, NULL, 'CG8258', NULL, NULL, NULL, NULL, NULL, 4),
(146927, NULL, 'G3DSA:2.40.150.20:FF:000009', NULL, NULL, '50S ribosomal protein L14', NULL, NULL, NULL, NULL, NULL, 4),
(146928, NULL, 'G3DSA:1.10.238.10:FF:001030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146929, NULL, 'G3DSA:3.40.30.10:FF:000849', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(146930, NULL, 'G3DSA:2.60.40.10:FF:003061', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(146931, NULL, 'G3DSA:3.40.50.2300:FF:000911', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146932, NULL, 'G3DSA:1.10.10.10:FF:001012', NULL, NULL, 'PCI domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(146933, NULL, 'G3DSA:3.40.1280.10:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146934, NULL, 'G3DSA:1.20.58.1030:FF:000013', NULL, NULL, 'DNA replication complex GINS protein PSF1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(146935, NULL, 'G3DSA:3.90.70.10:FF:000844', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(146936, NULL, 'G3DSA:1.25.40.10:FF:002565', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(146937, NULL, 'G3DSA:2.60.40.10:FF:000801', NULL, NULL, 'Tenascin-X', NULL, NULL, NULL, NULL, NULL, 4),
(146938, NULL, 'G3DSA:3.40.50.300:FF:005118', NULL, NULL, 'Conserved component of ABC transporter for natural amino acids', NULL, NULL, NULL, NULL, NULL, 4),
(146939, NULL, 'G3DSA:1.10.150.60:FF:000003', NULL, NULL, 'AT-rich interactive domain-containing protein 4B', NULL, NULL, NULL, NULL, NULL, 4),
(146940, NULL, 'G3DSA:3.40.50.2300:FF:000602', NULL, NULL, 'C4-dicarboxylate transport transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(146941, NULL, 'G3DSA:2.40.100.10:FF:000060', NULL, NULL, 'Probable peptidyl-prolyl cis-trans isomerase B', NULL, NULL, NULL, NULL, NULL, 4),
(146942, NULL, 'G3DSA:3.40.630.40:FF:000020', NULL, NULL, 'Cell wall hydrolase/autolysin', NULL, NULL, NULL, NULL, NULL, 4),
(146943, NULL, 'G3DSA:2.20.70.10:FF:000057', NULL, NULL, 'FERM and PDZ domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(146944, NULL, 'G3DSA:3.10.450.10:FF:000077', NULL, NULL, 'Kininogen 2', NULL, NULL, NULL, NULL, NULL, 4),
(146945, NULL, 'G3DSA:2.30.29.30:FF:000074', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(146946, NULL, 'G3DSA:3.40.50.300:FF:008345', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(146947, NULL, 'G3DSA:3.90.550.50:FF:000073', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(146948, NULL, 'G3DSA:2.60.40.1180:FF:000173', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(146949, NULL, 'G3DSA:3.30.40.10:FF:001492', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146950, NULL, 'G3DSA:1.10.3120.10:FF:000008', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(146951, NULL, 'G3DSA:2.130.10.10:FF:004820', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146952, NULL, 'G3DSA:3.30.1330.60:FF:000033', NULL, NULL, 'DUF3868 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(146953, NULL, 'G3DSA:2.60.120.20:FF:000025', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(146954, NULL, 'G3DSA:1.10.510.10:FF:004165', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146955, NULL, 'G3DSA:2.10.25.10:FF:001791', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146956, NULL, 'G3DSA:1.10.3210.10:FF:000027', NULL, NULL, 'Urea hydro-lyase/cyanamide hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(146957, NULL, 'G3DSA:2.60.200.20:FF:000083', NULL, NULL, 'AFaDin (Actin filament binding protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(146958, NULL, 'G3DSA:3.40.50.150:FF:001240', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146959, NULL, 'G3DSA:2.60.40.150:FF:000445', NULL, NULL, 'GTPase activating protein involved in bud site selection, putative', NULL, NULL, NULL, NULL, NULL, 4),
(146960, NULL, 'G3DSA:3.40.800.20:FF:000056', NULL, NULL, 'Mannose-6-phosphate isomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(146961, NULL, 'G3DSA:3.20.20.120:FF:000027', NULL, NULL, 'Mandelate racemase/muconate lactonizing protein', NULL, NULL, NULL, NULL, NULL, 4),
(146962, NULL, 'G3DSA:3.40.50.720:FF:001782', NULL, NULL, 'Acetohydroxy acid isomeroreductase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(146963, NULL, 'G3DSA:1.10.287.550:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146964, NULL, 'G3DSA:3.30.750.24:FF:000092', NULL, NULL, 'Putative anti-sigma factor antagonist TM_1081', NULL, NULL, NULL, NULL, NULL, 4),
(146965, NULL, 'G3DSA:1.20.1560.10:FF:000949', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146966, NULL, 'G3DSA:1.20.1440.370:FF:000002', NULL, NULL, 'Multifunctional virulence effector protein DrrA', NULL, NULL, NULL, NULL, NULL, 4),
(146967, NULL, 'G3DSA:3.30.200.20:FF:000158', NULL, NULL, 'Serine/threonine-protein kinase 32A', NULL, NULL, NULL, NULL, NULL, 4),
(146968, NULL, 'G3DSA:2.60.40.150:FF:000029', NULL, NULL, 'Intersectin 1', NULL, NULL, NULL, NULL, NULL, 4),
(146969, NULL, 'G3DSA:3.60.21.10:FF:000367', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(146970, NULL, 'G3DSA:1.10.8.1190:FF:000002', NULL, NULL, 'ORF1ab polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(146971, NULL, 'G3DSA:3.30.565.10:FF:000518', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146972, NULL, 'G3DSA:3.40.50.880:FF:000059', NULL, NULL, '4-methyl-5(B-hydroxyethyl)-thiazole monophosphate biosynthesis enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(146973, NULL, 'G3DSA:3.90.1110.10:FF:000016', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(146974, NULL, 'G3DSA:3.30.160.60:FF:004792', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146975, NULL, 'G3DSA:3.30.70.270:FF:000220', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146976, NULL, 'G3DSA:1.20.1250.20:FF:001648', NULL, NULL, 'MFS peptide transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(146977, NULL, 'G3DSA:3.40.50.1000:FF:000640', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146978, NULL, 'G3DSA:1.20.58.390:FF:000278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146979, NULL, 'G3DSA:1.10.510.10:FF:000983', NULL, NULL, 'Fibroblast growth factor receptor homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(146980, NULL, 'G3DSA:1.25.10.10:FF:000922', NULL, NULL, 'HEAT repeat domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(146981, NULL, 'G3DSA:2.60.120.10:FF:000298', NULL, NULL, 'Cyclic Nucleotide Gated channel', NULL, NULL, NULL, NULL, NULL, 4),
(146982, NULL, 'G3DSA:3.40.50.10900:FF:000006', NULL, NULL, 'Proteasome assembly chaperone 2', NULL, NULL, NULL, NULL, NULL, 4),
(146983, NULL, 'G3DSA:1.10.510.10:FF:004249', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146984, NULL, 'G3DSA:2.130.10.10:FF:004904', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146985, NULL, 'G3DSA:3.30.230.70:FF:000063', NULL, NULL, 'Exosome complex component RRP45B', NULL, NULL, NULL, NULL, NULL, 4),
(146986, NULL, 'G3DSA:3.40.50.300:FF:004085', NULL, NULL, 'F-box only protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(146987, NULL, 'G3DSA:1.20.58.1880:FF:000021', NULL, NULL, 'Chromatin complexes subunit BAP18', NULL, NULL, NULL, NULL, NULL, 4),
(146988, NULL, 'G3DSA:1.20.58.480:FF:000007', NULL, NULL, 'Tryptophan 2,3-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(146989, NULL, 'G3DSA:1.25.40.10:FF:002548', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g46050, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(146990, NULL, 'G3DSA:1.10.10.10:FF:001849', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(146991, NULL, 'G3DSA:2.60.40.10:FF:004247', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(146992, NULL, 'G3DSA:3.40.50.1100:FF:000198', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(146993, NULL, 'G3DSA:3.40.50.150:FF:000526', NULL, NULL, 'FtsJ-like methyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(146994, NULL, 'G3DSA:3.40.50.300:FF:003090', NULL, NULL, 'GTP-binding protein, Ras family protein', NULL, NULL, NULL, NULL, NULL, 4),
(146995, NULL, 'G3DSA:2.130.10.10:FF:000633', NULL, NULL, 'Small nucleolar ribonucleoprotein complex subunit Utp15, putative', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(146996, NULL, 'G3DSA:3.40.190.10:FF:000196', NULL, NULL, 'Amino acid ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(146997, NULL, 'G3DSA:1.25.10.10:FF:000276', NULL, NULL, 'Regulatory-associated protein of mTOR isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(146998, NULL, 'G3DSA:3.90.1530.30:FF:000008', NULL, NULL, 'Probable plasmid partitioning protein, ParB1', NULL, NULL, NULL, NULL, NULL, 4),
(146999, NULL, 'G3DSA:1.10.560.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147000, NULL, 'G3DSA:3.40.30.10:FF:001086', NULL, NULL, 'Glutaredoxin/malate transporter fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(147001, NULL, 'G3DSA:3.30.200.20:FF:002305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147002, NULL, 'G3DSA:2.60.40.420:FF:000003', NULL, NULL, 'Blue copper', NULL, NULL, NULL, NULL, NULL, 4),
(147003, NULL, 'G3DSA:3.20.20.220:FF:000057', NULL, NULL, 'Methylenetetrahydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(147004, NULL, 'G3DSA:3.90.1290.10:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147005, NULL, 'G3DSA:2.130.10.30:FF:000043', NULL, NULL, 'Guanidine nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(147006, NULL, 'G3DSA:1.25.10.10:FF:000383', NULL, NULL, 'armadillo repeat-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(147007, NULL, 'G3DSA:2.40.180.10:FF:000025', NULL, NULL, 'Catalase-related peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(147008, NULL, 'G3DSA:2.60.120.260:FF:000346', NULL, NULL, 'Alpha-1,3-mannosyl-glycoprotein 4-beta-N-acetylglucosaminyltransferase C', NULL, NULL, NULL, NULL, NULL, 4),
(147009, NULL, 'G3DSA:3.90.70.10:FF:000299', NULL, NULL, 'Os03g0192800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(147010, NULL, 'G3DSA:3.30.200.20:FF:002412', NULL, NULL, 'Cullin-associated NEDD8-dissociated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(147011, NULL, 'G3DSA:1.20.1070.10:FF:001917', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147012, NULL, 'G3DSA:1.10.3470.10:FF:000001', NULL, NULL, 'Vitamin B12 ABC transporter permease BtuC', NULL, NULL, NULL, NULL, NULL, 4),
(147013, NULL, 'G3DSA:3.30.530.20:FF:000037', NULL, NULL, 'Coenzyme Q-binding protein COQ10, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(147014, NULL, 'G3DSA:1.20.140.150:FF:000092', NULL, NULL, 'Claudin domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(147015, NULL, 'G3DSA:3.90.1170.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147016, NULL, 'G3DSA:1.10.10.60:FF:000622', NULL, NULL, 'DNA-binding transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(147017, NULL, 'G3DSA:2.60.40.10:FF:004926', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147018, NULL, 'G3DSA:3.90.550.10:FF:000639', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147019, NULL, 'G3DSA:3.10.310.10:FF:000011', NULL, NULL, 'Diaminopimelate epimerase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(147020, NULL, 'G3DSA:1.20.120.430:FF:000008', NULL, NULL, 'tRNA modification GTPase MnmE', NULL, NULL, NULL, NULL, NULL, 4),
(147021, NULL, 'G3DSA:2.130.10.10:FF:004691', NULL, NULL, 'Ribosome biogenesis protein BOP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(147022, NULL, 'G3DSA:2.30.29.30:FF:001294', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147023, NULL, 'G3DSA:1.10.510.10:FF:004356', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147024, NULL, 'G3DSA:3.40.190.290:FF:000042', NULL, NULL, 'ArgP/LysG family DNA-binding transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(147025, NULL, 'G3DSA:3.10.110.10:FF:000265', NULL, NULL, 'Ubiquitin-conjugating enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(147026, NULL, 'G3DSA:2.30.29.30:FF:000310', NULL, NULL, 'FACT complex subunit POB3', NULL, NULL, NULL, NULL, NULL, 4),
(147027, NULL, 'G3DSA:2.60.40.1760:FF:000015', NULL, NULL, 'Glucosidase, putative', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(147028, NULL, 'G3DSA:1.10.287.1490:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147029, NULL, 'G3DSA:2.10.25.10:FF:001690', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147030, NULL, 'G3DSA:3.90.1150.10:FF:000125', NULL, NULL, 'Putative serine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(147031, NULL, 'G3DSA:1.10.630.10:FF:000031', NULL, NULL, 'cholesterol 24-hydroxylase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(147032, NULL, 'G3DSA:3.30.460.20:FF:000008', NULL, NULL, 'Cobalt/magnesium transport protein CorA', NULL, NULL, NULL, NULL, NULL, 4),
(147033, NULL, 'G3DSA:2.40.160.50:FF:000030', NULL, NULL, 'Slr1661 protein', NULL, NULL, NULL, NULL, NULL, 4),
(147034, NULL, 'G3DSA:1.20.1070.10:FF:002053', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(147035, NULL, 'G3DSA:3.80.30.20:FF:000025', NULL, NULL, 'Radical SAM domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(147036, NULL, 'G3DSA:1.10.1450.10:FF:000090', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(147037, NULL, 'G3DSA:2.70.170.10:FF:000164', NULL, NULL, 'Neurotransmitter gated ion channel, putative', NULL, NULL, NULL, NULL, NULL, 4),
(147038, NULL, 'G3DSA:2.130.10.10:FF:001032', NULL, NULL, 'SNRNP40 isoform 5', NULL, NULL, NULL, NULL, NULL, 4),
(147039, NULL, 'G3DSA:2.40.10.350:FF:000003', NULL, NULL, 'Cell shape-determining protein MreC', NULL, NULL, NULL, NULL, NULL, 4),
(147040, NULL, 'G3DSA:2.70.150.10:FF:000157', NULL, NULL, 'Os01g0869100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(147041, NULL, 'G3DSA:1.20.120.420:FF:000005', NULL, NULL, 'Methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(147042, NULL, 'G3DSA:3.40.50.720:FF:001681', NULL, NULL, 'Oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(147043, NULL, 'G3DSA:2.130.10.10:FF:000526', NULL, NULL, 'Protein transport protein SEC31', NULL, NULL, NULL, NULL, NULL, 4),
(147044, NULL, 'G3DSA:3.80.10.10:FF:003674', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147045, NULL, 'G3DSA:3.30.750.24:FF:000103', NULL, NULL, 'Sulfate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(147046, NULL, 'G3DSA:3.30.379.10:FF:000007', NULL, NULL, 'Alpha-glucuronidase A', NULL, NULL, NULL, NULL, NULL, 4),
(147047, NULL, 'G3DSA:1.25.40.20:FF:000753', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147048, NULL, 'G3DSA:1.10.510.10:FF:001978', NULL, NULL, 'Kinase, CMGC CDK', NULL, NULL, NULL, NULL, NULL, 4),
(147049, NULL, 'G3DSA:3.40.30.10:FF:001193', NULL, NULL, 'Iodothyronine deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(147050, NULL, 'G3DSA:3.30.50.10:FF:000019', NULL, NULL, 'Nuclear receptor subfamily 2 group E member', NULL, NULL, NULL, NULL, NULL, 4),
(147051, NULL, 'G3DSA:2.60.40.10:FF:000981', NULL, NULL, 'Titin a', NULL, NULL, NULL, NULL, NULL, 4),
(147052, NULL, 'G3DSA:2.10.110.10:FF:000336', NULL, NULL, 'Metalloprotease', NULL, NULL, NULL, NULL, NULL, 4),
(147053, NULL, 'G3DSA:3.90.550.50:FF:000174', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(147054, NULL, 'G3DSA:3.30.40.10:FF:001789', NULL, NULL, 'PHD and RING finger domain-containing protein C126.07c', NULL, NULL, NULL, NULL, NULL, 4),
(147055, NULL, 'G3DSA:3.30.70.330:FF:000406', NULL, NULL, 'Related to Nucleolar protein NOP4', NULL, NULL, NULL, NULL, NULL, 4),
(147056, NULL, 'G3DSA:3.30.559.10:FF:000105', NULL, NULL, 'Transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(147057, NULL, 'G3DSA:1.25.40.10:FF:000750', NULL, NULL, 'Fanconi anemia group G protein', NULL, NULL, NULL, NULL, NULL, 4),
(147058, NULL, 'G3DSA:3.40.50.1820:FF:000430', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(147059, NULL, 'G3DSA:2.60.40.10:FF:000874', NULL, NULL, 'Inducible T-cell costimulator', NULL, NULL, NULL, NULL, NULL, 4),
(147060, NULL, 'G3DSA:3.30.70.260:FF:000110', NULL, NULL, 'Acetolactate synthase, small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(147061, NULL, 'G3DSA:4.10.60.10:FF:000070', NULL, NULL, 'Splicing factor, arginine/serine-rich 7', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(147062, NULL, 'G3DSA:2.10.110.10:FF:000229', NULL, NULL, 'LIM-domain containing phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(147063, NULL, 'G3DSA:3.40.50.2000:FF:000355', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(147064, NULL, 'G3DSA:1.20.1060.10:FF:000001', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(147065, NULL, 'G3DSA:2.40.70.10:FF:000539', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147066, NULL, 'G3DSA:3.30.160.60:FF:004359', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147067, NULL, 'G3DSA:3.30.70.270:FF:000113', NULL, NULL, 'DNA polymerase eta', NULL, NULL, NULL, NULL, NULL, 4),
(147068, NULL, 'G3DSA:3.40.50.300:FF:002628', NULL, NULL, 'Cytoplasmic dynein 2 light intermediate chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(147069, NULL, 'G3DSA:1.10.150.530:FF:000007', NULL, NULL, '23S rRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(147070, NULL, 'G3DSA:1.10.390.30:FF:000001', NULL, NULL, 'TRPM8 channel-associated factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(147071, NULL, 'G3DSA:3.30.2340.10:FF:000007', NULL, NULL, 'tRNA pseudouridine synthase D', NULL, NULL, NULL, NULL, NULL, 4),
(147072, NULL, 'G3DSA:2.60.40.10:FF:000346', NULL, NULL, 'Tenascin C', NULL, NULL, NULL, NULL, NULL, 4),
(147073, NULL, 'G3DSA:3.30.260.10:FF:000024', NULL, NULL, 'Chaperonin 60 subunit alpha 2 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(147074, NULL, 'G3DSA:3.90.230.10:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147075, NULL, 'G3DSA:3.40.50.80:FF:000225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147076, NULL, 'G3DSA:1.10.390.40:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147077, NULL, 'G3DSA:2.30.42.10:FF:000166', NULL, NULL, 'Na(+)/H(+) exchange regulatory cofactor NHE-RF3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(147078, NULL, 'G3DSA:3.30.160.60:FF:004466', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147079, NULL, 'G3DSA:3.80.10.10:FF:003455', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147080, NULL, 'G3DSA:3.40.50.300:FF:008137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147081, NULL, 'G3DSA:3.20.20.450:FF:000002', NULL, NULL, 'Cyclic di-GMP phosphodiesterase YhjH', NULL, NULL, NULL, NULL, NULL, 4),
(147082, NULL, 'G3DSA:2.30.30.40:FF:000058', NULL, NULL, 'Disks large homolog 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(147083, NULL, 'G3DSA:3.30.420.40:FF:000720', NULL, NULL, 'Endoplasmic reticulum chaperone BiP', NULL, NULL, NULL, NULL, NULL, 4),
(147084, NULL, 'G3DSA:3.10.110.10:FF:000372', NULL, NULL, 'Putative ATP-dependent RNA helicase ucp12', NULL, NULL, NULL, NULL, NULL, 4),
(147085, NULL, 'G3DSA:3.40.5.10:FF:000005', NULL, NULL, '39S ribosomal protein L9, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(147086, NULL, 'G3DSA:2.40.30.230:FF:000005', NULL, NULL, 'Regulator of nonsense transcripts 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(147087, NULL, 'G3DSA:3.80.10.10:FF:002044', NULL, NULL, 'Insulin-like growth factor-binding protein acid labile subunit', NULL, NULL, NULL, NULL, NULL, 4),
(147088, NULL, 'G3DSA:3.40.850.10:FF:000224', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(147089, NULL, 'G3DSA:3.40.50.300:FF:007035', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147090, NULL, 'G3DSA:3.40.50.300:FF:001212', NULL, NULL, 'ATP-dependent dethiobiotin synthetase BioD', NULL, NULL, NULL, NULL, NULL, 4),
(147091, NULL, 'G3DSA:3.40.50.1000:FF:000842', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147092, NULL, 'G3DSA:3.30.70.3250:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147093, NULL, 'G3DSA:3.30.1330.90:FF:000002', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(147094, NULL, 'G3DSA:2.60.40.10:FF:004617', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147095, NULL, 'G3DSA:3.40.50.300:FF:000723', NULL, NULL, 'Guanylate-binding family protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(147096, NULL, 'G3DSA:3.40.50.11610:FF:000011', NULL, NULL, 'Oxoglutarate dehydrogenase (Succinyl-transferring), E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(147097, NULL, 'G3DSA:2.160.10.10:FF:000036', NULL, NULL, 'Acetyltransferase, CYSE/LACA/LPXA/NODL', NULL, NULL, NULL, NULL, NULL, 4),
(147098, NULL, 'G3DSA:2.40.30.220:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147099, NULL, 'G3DSA:2.30.170.40:FF:000013', NULL, NULL, '39S ribosomal protein L28, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(147100, NULL, 'G3DSA:3.30.60.30:FF:000077', NULL, NULL, 'AGAP006282-PA', NULL, NULL, NULL, NULL, NULL, 4),
(147101, NULL, 'G3DSA:2.70.20.10:FF:000024', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(147102, NULL, 'G3DSA:2.40.70.10:FF:000337', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147103, NULL, 'G3DSA:3.30.160.60:FF:004157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147104, NULL, 'G3DSA:3.40.50.300:FF:000493', NULL, NULL, 'Guanine nucleotide-binding protein-like 3-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(147105, NULL, 'G3DSA:3.10.450.50:FF:000072', NULL, NULL, 'Nuclear transport factor 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(147106, NULL, 'G3DSA:1.10.8.60:FF:000458', NULL, NULL, 'Peroxisome biogenesis protein peroxin 1 (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(147107, NULL, 'G3DSA:2.40.100.10:FF:000161', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(147108, NULL, 'G3DSA:2.10.25.10:FF:001701', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147109, NULL, 'G3DSA:3.80.10.10:FF:003146', NULL, NULL, 'Preferentially expressed antigen in melanoma', NULL, NULL, NULL, NULL, NULL, 4),
(147110, NULL, 'G3DSA:3.40.190.10:FF:000089', NULL, NULL, 'Thiamine ABC transporter substrate binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(147111, NULL, 'G3DSA:2.60.200.20:FF:000228', NULL, NULL, 'Protein CBG04097', NULL, NULL, NULL, NULL, NULL, 4),
(147112, NULL, 'G3DSA:1.25.40.10:FF:002239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147113, NULL, 'G3DSA:3.90.70.10:FF:000619', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147114, NULL, 'G3DSA:1.25.40.10:FF:004263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147115, NULL, 'G3DSA:2.170.120.20:FF:000016', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(147116, NULL, 'G3DSA:1.10.1600.10:FF:000034', NULL, NULL, 'ATP dependent DNA ligase 1', NULL, NULL, NULL, NULL, NULL, 4),
(147117, NULL, 'G3DSA:3.30.70.1350:FF:000011', NULL, NULL, 'Unplaced genomic scaffold supercont1.174, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(147118, NULL, 'G3DSA:1.10.760.10:FF:000024', NULL, NULL, 'Di-heme cytochrome C peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(147119, NULL, 'G3DSA:1.20.58.1480:FF:000024', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(147120, NULL, 'G3DSA:2.40.100.10:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147121, NULL, 'G3DSA:1.10.472.10:FF:000085', NULL, NULL, 'Pho80p cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(147122, NULL, 'G3DSA:2.30.30.30:FF:000055', NULL, NULL, '50S ribosomal protein L2', NULL, NULL, NULL, NULL, NULL, 4),
(147123, NULL, 'G3DSA:2.60.40.60:FF:000765', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(147124, NULL, 'G3DSA:2.60.120.260:FF:000453', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147125, NULL, 'G3DSA:1.10.12.70:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147126, NULL, 'G3DSA:2.20.70.10:FF:000142', NULL, NULL, 'TransCription Elongation Regulator homolog', NULL, NULL, NULL, NULL, NULL, 4),
(147127, NULL, 'G3DSA:1.10.60.40:FF:000001', NULL, NULL, 'Alkaline phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(147128, NULL, 'G3DSA:2.60.490.10:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(147129, NULL, 'G3DSA:3.40.532.10:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147130, NULL, 'G3DSA:3.40.50.11380:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147131, NULL, 'G3DSA:1.20.1070.10:FF:000501', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(147132, NULL, 'G3DSA:3.40.140.10:FF:000159', NULL, NULL, 'Histone H2A deubiquitinase MYSM1', NULL, NULL, NULL, NULL, NULL, 4),
(147133, NULL, 'G3DSA:3.40.190.10:FF:000561', NULL, NULL, 'HTH-type transcriptional regulator PhcA', NULL, NULL, NULL, NULL, NULL, 4),
(147134, NULL, 'G3DSA:3.60.21.10:FF:000474', NULL, NULL, 'Meiotic recombination 11', NULL, NULL, NULL, NULL, NULL, 4),
(147135, NULL, 'G3DSA:1.10.10.10:FF:000068', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(147136, NULL, 'G3DSA:1.10.340.70:FF:000015', NULL, NULL, 'Pro-Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(147137, NULL, 'G3DSA:3.40.50.300:FF:004764', NULL, NULL, 'tRNA modification GTPase TrmE', NULL, NULL, NULL, NULL, NULL, 4),
(147138, NULL, 'G3DSA:3.40.50.2300:FF:000338', NULL, NULL, 'Branched-chain amino acid ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(147139, NULL, 'G3DSA:2.30.30.100:FF:000120', NULL, NULL, 'U7 snRNA-associated Sm protein LSm11', NULL, NULL, NULL, NULL, NULL, 4),
(147140, NULL, 'G3DSA:3.40.50.2000:FF:000029', NULL, NULL, 'Sterol 3-beta-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(147141, NULL, 'G3DSA:3.30.830.10:FF:000186', NULL, NULL, 'Mitochondrial-processing peptidase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(147142, NULL, 'G3DSA:3.30.200.20:FF:000467', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(147143, NULL, 'G3DSA:2.60.40.150:FF:000338', NULL, NULL, 'U5 small nuclear ribonucleoprotein helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(147144, NULL, 'G3DSA:1.25.10.10:FF:000585', NULL, NULL, '26S proteasome regulatory non-ATPase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(147145, NULL, 'G3DSA:3.30.470.30:FF:000063', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(147146, NULL, 'G3DSA:1.25.40.10:FF:004802', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147147, NULL, 'G3DSA:3.40.50.11370:FF:000006', NULL, NULL, 'Inositol 1,3,4-trisphosphate 5/6-kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(147148, NULL, 'G3DSA:2.130.10.10:FF:005995', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147149, NULL, 'G3DSA:2.60.120.10:FF:000837', NULL, NULL, 'Cyclic nucleotide-gated cation channel subunit A-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(147150, NULL, 'G3DSA:1.20.210.10:FF:000014', NULL, NULL, 'Probable intron-encoded endonuclease aI4', NULL, NULL, NULL, NULL, NULL, 4),
(147151, NULL, 'G3DSA:3.40.50.150:FF:000296', NULL, NULL, 'Putative methyltransferase DDB_G0268948', NULL, NULL, NULL, NULL, NULL, 4),
(147152, NULL, 'G3DSA:2.120.10.80:FF:000261', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147153, NULL, 'G3DSA:1.25.40.10:FF:004482', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147154, NULL, 'G3DSA:3.20.20.100:FF:000004', NULL, NULL, 'Oxidoreductase, aldo/keto reductase', NULL, NULL, NULL, NULL, NULL, 4),
(147155, NULL, 'G3DSA:2.60.40.10:FF:000655', NULL, NULL, 'brother of CDO isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(147156, NULL, 'G3DSA:3.40.50.1000:FF:000533', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147157, NULL, 'G3DSA:3.30.1010.10:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147158, NULL, 'G3DSA:3.40.50.970:FF:000070', NULL, NULL, '2-oxoglutarate dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(147159, NULL, 'G3DSA:3.30.160.60:FF:001610', NULL, NULL, 'transcription factor IIIA', NULL, NULL, NULL, NULL, NULL, 4),
(147160, NULL, 'G3DSA:1.20.58.460:FF:000001', NULL, NULL, 'O-GlcNAcase NagJ', NULL, NULL, NULL, NULL, NULL, 4),
(147161, NULL, 'G3DSA:3.30.60.20:FF:000074', NULL, NULL, 'Thymidine kinase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(147162, NULL, 'G3DSA:3.40.50.1820:FF:001369', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147163, NULL, 'G3DSA:1.10.1420.10:FF:000155', NULL, NULL, 'Protein CBR-MSH-2', NULL, NULL, NULL, NULL, NULL, 4),
(147164, NULL, 'G3DSA:2.40.30.10:FF:000228', NULL, NULL, 'NADPH-dependent diflavin oxidoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(147165, NULL, 'G3DSA:3.30.470.20:FF:000060', NULL, NULL, 'Putative alpha-L-glutamate ligase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(147166, NULL, 'G3DSA:1.10.472.10:FF:000315', NULL, NULL, 'RNA polymerase II holoenzyme cyclin-like subunit', NULL, NULL, NULL, NULL, NULL, 4),
(147167, NULL, 'G3DSA:3.40.50.11060:FF:000003', NULL, NULL, 'GTP-binding protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(147168, NULL, 'G3DSA:3.30.1010.10:FF:000123', NULL, NULL, 'Frap1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(147169, NULL, 'G3DSA:2.30.30.40:FF:000530', NULL, NULL, 'BAR domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(147170, NULL, 'G3DSA:2.160.20.10:FF:000334', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147171, NULL, 'G3DSA:2.40.50.140:FF:000257', NULL, NULL, 'Replication protein A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(147172, NULL, 'G3DSA:2.60.40.150:FF:000669', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147173, NULL, 'G3DSA:2.130.10.10:FF:004365', NULL, NULL, 'Gbp protein', NULL, NULL, NULL, NULL, NULL, 4),
(147174, NULL, 'G3DSA:1.25.10.10:FF:002530', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147175, NULL, 'G3DSA:3.30.1300.10:FF:000005', NULL, NULL, 'Pantothenate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(147176, NULL, 'G3DSA:3.60.60.10:FF:000013', NULL, NULL, 'Choloylglycine hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(147177, NULL, 'G3DSA:2.60.120.260:FF:000144', NULL, NULL, 'Probable beta-galactosidase C', NULL, NULL, NULL, NULL, NULL, 4),
(147178, NULL, 'G3DSA:3.40.50.1820:FF:001739', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147179, NULL, 'G3DSA:3.40.50.300:FF:004394', NULL, NULL, 'bifunctional heparan sulfate N-deacetylase/N-sulfotransferase 4', NULL, NULL, NULL, NULL, NULL, 4),
(147180, NULL, 'G3DSA:3.20.20.80:FF:000224', NULL, NULL, 'Chitinase A', NULL, NULL, NULL, NULL, NULL, 4),
(147181, NULL, 'G3DSA:3.40.47.10:FF:000253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147182, NULL, 'G3DSA:3.40.50.720:FF:000130', NULL, NULL, 'SDR family NAD(P)-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(147183, NULL, 'G3DSA:1.20.210.10:FF:000019', NULL, NULL, 'Nitric oxide reductase large subunit-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(147184, NULL, 'G3DSA:1.10.238.10:FF:001221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147185, NULL, 'G3DSA:2.40.10.10:FF:000654', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147186, NULL, 'G3DSA:1.10.10.10:FF:000287', NULL, NULL, 'Phosphonate utilization transcriptional regulator PhnR', NULL, NULL, NULL, NULL, NULL, 4),
(147187, NULL, 'G3DSA:3.30.420.10:FF:000498', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147188, NULL, 'G3DSA:2.130.10.10:FF:004674', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147189, NULL, 'G3DSA:2.30.29.30:FF:001277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147190, NULL, 'G3DSA:2.30.30.1150:FF:000018', NULL, NULL, 'RING/FYVE/PHD zinc finger superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(147191, NULL, 'G3DSA:3.40.50.300:FF:002937', NULL, NULL, 'ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(147192, NULL, 'G3DSA:2.60.40.2320:FF:000003', NULL, NULL, 'Type I pullulanase', NULL, NULL, NULL, NULL, NULL, 4),
(147193, NULL, 'G3DSA:2.30.29.30:FF:000001', NULL, NULL, 'Erythrocyte membrane protein band 4.1', NULL, NULL, NULL, NULL, NULL, 4),
(147194, NULL, 'G3DSA:2.10.110.10:FF:000027', NULL, NULL, 'lipoma-preferred partner isoform X1', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(147195, NULL, 'G3DSA:2.20.25.10:FF:000088', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(147196, NULL, 'G3DSA:3.30.710.10:FF:000115', NULL, NULL, 'Kelch protein K13', NULL, NULL, NULL, NULL, NULL, 4),
(147197, NULL, 'G3DSA:3.10.100.10:FF:000309', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147198, NULL, 'G3DSA:1.10.510.10:FF:002467', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147199, NULL, 'G3DSA:3.30.160.60:FF:003050', NULL, NULL, 'Potential zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(147200, NULL, 'G3DSA:1.25.40.20:FF:000769', NULL, NULL, 'Ankyrin repeat domain 11', NULL, NULL, NULL, NULL, NULL, 4),
(147201, NULL, 'G3DSA:1.20.1070.10:FF:000029', NULL, NULL, 'Frizzled class receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(147202, NULL, 'G3DSA:1.10.1420.10:FF:000138', NULL, NULL, 'MutS domain III protein', NULL, NULL, NULL, NULL, NULL, 4),
(147203, NULL, 'G3DSA:3.40.50.1000:FF:000516', NULL, NULL, 'ATPase 2, plasma membrane-type', NULL, NULL, NULL, NULL, NULL, 4),
(147204, NULL, 'G3DSA:1.25.40.10:FF:000441', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(147205, NULL, 'G3DSA:1.20.1540.10:FF:000004', NULL, NULL, 'Transmembrane protein 115', NULL, NULL, NULL, NULL, NULL, 4),
(147206, NULL, 'G3DSA:3.90.70.10:FF:000726', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147207, NULL, 'G3DSA:3.40.850.10:FF:000134', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(147208, NULL, 'G3DSA:3.10.100.10:FF:000074', NULL, NULL, 'C-type lectin domain family 1 member A', NULL, NULL, NULL, NULL, NULL, 4),
(147209, NULL, 'G3DSA:2.120.10.30:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147210, NULL, 'G3DSA:3.10.20.90:FF:000907', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147211, NULL, 'G3DSA:3.60.10.10:FF:000302', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147212, NULL, 'G3DSA:3.30.830.10:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147213, NULL, 'G3DSA:1.10.510.10:FF:002809', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(147214, NULL, 'G3DSA:2.40.50.140:FF:000274', NULL, NULL, 'Mitochondrial RNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(147215, NULL, 'G3DSA:2.60.40.10:FF:001037', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(147216, NULL, 'G3DSA:1.10.720.60:FF:000008', NULL, NULL, 'Enolase-phosphatase E1', NULL, NULL, NULL, NULL, NULL, 4),
(147217, NULL, 'G3DSA:1.20.1280.140:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147218, NULL, 'G3DSA:3.30.1520.10:FF:000061', NULL, NULL, 'Sorting nexin 1', NULL, NULL, NULL, NULL, NULL, 4),
(147219, NULL, 'G3DSA:1.20.930.20:FF:000010', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(147220, NULL, 'G3DSA:2.120.10.30:FF:000370', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147221, NULL, 'G3DSA:3.80.10.10:FF:003365', NULL, NULL, 'GH16156p', NULL, NULL, NULL, NULL, NULL, 4),
(147222, NULL, 'G3DSA:2.60.40.1120:FF:000054', NULL, NULL, 'nodal modulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(147223, NULL, 'G3DSA:3.40.50.300:FF:006872', NULL, NULL, 'Probable replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(147224, NULL, 'G3DSA:1.20.140.80:FF:000006', NULL, NULL, 'Transcription factor Dp-1, a', NULL, NULL, NULL, NULL, NULL, 4),
(147225, NULL, 'G3DSA:3.90.226.10:FF:000050', NULL, NULL, 'ATP-dependent Clp protease proteolytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(147226, NULL, 'G3DSA:3.40.50.1820:FF:001734', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147227, NULL, 'G3DSA:3.90.1110.10:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147228, NULL, 'G3DSA:3.40.1000.10:FF:000019', NULL, NULL, 'Hemochromatosis type 2', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(147229, NULL, 'G3DSA:1.10.720.40:FF:000002', NULL, NULL, 'Thymopoietin isoform alpha', NULL, NULL, NULL, NULL, NULL, 4),
(147230, NULL, 'G3DSA:1.25.10.10:FF:002165', NULL, NULL, 'Utp20p', NULL, NULL, NULL, NULL, NULL, 4),
(147231, NULL, 'G3DSA:2.60.120.260:FF:000363', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147232, NULL, 'G3DSA:2.60.40.10:FF:005798', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147233, NULL, 'G3DSA:3.40.50.300:FF:006344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147234, NULL, 'G3DSA:1.10.510.10:FF:004266', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147235, NULL, 'G3DSA:3.30.505.10:FF:000184', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147236, NULL, 'G3DSA:2.60.40.10:FF:000565', NULL, NULL, 'Matrix metalloproteinase-23', NULL, NULL, NULL, NULL, NULL, 4),
(147237, NULL, 'G3DSA:3.30.465.10:FF:000090', NULL, NULL, 'FAD binding oxidoreductase CpoX1', NULL, NULL, NULL, NULL, NULL, 4),
(147238, NULL, 'G3DSA:3.30.710.10:FF:000222', NULL, NULL, 'Lola-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(147239, NULL, 'G3DSA:3.10.129.10:FF:000050', NULL, NULL, 'Acyl-CoA thioester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(147240, NULL, 'G3DSA:1.20.140.90:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147241, NULL, 'G3DSA:3.30.160.60:FF:004483', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147242, NULL, 'G3DSA:3.40.309.10:FF:000124', NULL, NULL, 'Aldehyde dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(147243, NULL, 'G3DSA:3.90.1600.10:FF:000014', NULL, NULL, 'DNA polymerase epsilon catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(147244, NULL, 'G3DSA:1.10.10.10:FF:000764', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(147245, NULL, 'G3DSA:2.130.10.10:FF:004921', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147246, NULL, 'G3DSA:3.40.50.1000:FF:000168', NULL, NULL, 'D,D-heptose 1,7-bisphosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(147247, NULL, 'G3DSA:3.40.640.10:FF:000287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147248, NULL, 'G3DSA:3.30.160.60:FF:002919', NULL, NULL, 'Zinc finger protein 45', NULL, NULL, NULL, NULL, NULL, 4),
(147249, NULL, 'G3DSA:1.20.140.150:FF:000119', NULL, NULL, 'uncharacterized protein LOC100181662', NULL, NULL, NULL, NULL, NULL, 4),
(147250, NULL, 'G3DSA:1.25.40.10:FF:004128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147251, NULL, 'G3DSA:3.30.40.10:FF:001935', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147252, NULL, 'G3DSA:2.120.10.10:FF:000026', NULL, NULL, 'VPS10 domain-containing receptor SorCS1', NULL, NULL, NULL, NULL, NULL, 4),
(147253, NULL, 'G3DSA:2.120.10.80:FF:000042', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(147254, NULL, 'G3DSA:2.170.120.12:FF:000021', NULL, NULL, 'DNA-directed RNA polymerase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(147255, NULL, 'G3DSA:3.30.497.10:FF:000135', NULL, NULL, 'Secreted salivary gland peptide, putative', NULL, NULL, NULL, NULL, NULL, 4),
(147256, NULL, 'G3DSA:3.30.160.60:FF:002577', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147257, NULL, 'G3DSA:1.20.1070.10:FF:000136', NULL, NULL, 'Adhesion G protein-coupled receptor E5', NULL, NULL, NULL, NULL, NULL, 4),
(147258, NULL, 'G3DSA:4.10.800.10:FF:000005', NULL, NULL, 'Putative insulin-like growth factor-binding protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(147259, NULL, 'G3DSA:3.30.559.30:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147260, NULL, 'G3DSA:1.20.5.2020:FF:000001', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(147261, NULL, 'G3DSA:2.80.10.50:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147262, NULL, 'G3DSA:2.40.50.140:FF:000622', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(147263, NULL, 'G3DSA:3.40.50.2300:FF:000703', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(147264, NULL, 'G3DSA:3.10.129.110:FF:000020', NULL, NULL, 'Probable polyketide synthase 37', NULL, NULL, NULL, NULL, NULL, 4),
(147265, NULL, 'G3DSA:1.10.1070.11:FF:000005', NULL, NULL, 'Phosphatidylinositol 4-kinase, catalytic, alpha', NULL, NULL, NULL, NULL, NULL, 4),
(147266, NULL, 'G3DSA:3.40.50.300:FF:004399', NULL, NULL, 'Ras-related protein Rab-34', NULL, NULL, NULL, NULL, NULL, 4),
(147267, NULL, 'G3DSA:2.60.120.650:FF:000031', NULL, NULL, 'lysine-specific demethylase 5C isoform X10', NULL, NULL, NULL, NULL, NULL, 4),
(147268, NULL, 'G3DSA:3.30.70.3190:FF:000001', NULL, NULL, 'tRNA pseudouridine synthase Pus10', NULL, NULL, NULL, NULL, NULL, 4),
(147269, NULL, 'G3DSA:3.90.70.10:FF:000636', NULL, NULL, 'Cathepsin F', NULL, NULL, NULL, NULL, NULL, 4),
(147270, NULL, 'G3DSA:2.120.10.80:FF:000266', NULL, NULL, 'F-box/Kelch repeat-containing F-box family protein', NULL, NULL, NULL, NULL, NULL, 4),
(147271, NULL, 'G3DSA:3.30.1370.130:FF:000002', NULL, NULL, 'DNA transporter HofQ', NULL, NULL, NULL, NULL, NULL, 4),
(147272, NULL, 'G3DSA:3.30.70.240:FF:000037', NULL, NULL, 'Shwachman-Bodian-Diamond syndrome protein', NULL, NULL, NULL, NULL, NULL, 4),
(147273, NULL, 'G3DSA:3.40.50.720:FF:001990', NULL, NULL, 'Short-chain dehydrogenase/reductase SDR', NULL, NULL, NULL, NULL, NULL, 4),
(147274, NULL, 'G3DSA:2.130.10.10:FF:000650', NULL, NULL, 'WD repeat-containing protein WRAP73', NULL, NULL, NULL, NULL, NULL, 4),
(147275, NULL, 'G3DSA:1.10.150.240:FF:000044', NULL, NULL, 'Phosphoglycolate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(147276, NULL, 'G3DSA:3.30.160.60:FF:002684', NULL, NULL, 'ZFP28 zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(147277, NULL, 'G3DSA:2.40.320.10:FF:000014', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(147278, NULL, 'G3DSA:1.25.10.10:FF:002384', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147279, NULL, 'G3DSA:3.40.50.150:FF:000189', NULL, NULL, 'tRNA (adenine(58)-N(1))-methyltransferase catalytic subunit TRM61', NULL, NULL, NULL, NULL, NULL, 4),
(147280, NULL, 'G3DSA:3.60.21.10:FF:000339', NULL, NULL, 'Purple acid phosphatase 3', NULL, NULL, NULL, NULL, NULL, 4),
(147281, NULL, 'G3DSA:2.130.10.10:FF:004360', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147282, NULL, 'G3DSA:3.30.70.270:FF:000130', NULL, NULL, 'Diguanylate cyclase/phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(147283, NULL, 'G3DSA:3.30.70.330:FF:002514', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147284, NULL, 'G3DSA:1.20.58.60:FF:000203', NULL, NULL, 'Uncharacterized protein, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(147285, NULL, 'G3DSA:3.30.70.330:FF:002172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147286, NULL, 'G3DSA:3.10.20.90:FF:000346', NULL, NULL, 'BolA family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(147287, NULL, 'G3DSA:2.130.10.10:FF:004702', NULL, NULL, 'cDNA FLJ57184, highly similar to Bromodomain and WD repeat domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(147288, NULL, 'G3DSA:3.90.1640.20:FF:000008', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147289, NULL, 'G3DSA:3.30.2300.10:FF:000005', NULL, NULL, 'Protein CBG06641', NULL, NULL, NULL, NULL, NULL, 4),
(147290, NULL, 'G3DSA:2.160.20.10:FF:000008', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(147291, NULL, 'G3DSA:2.60.120.650:FF:000154', NULL, NULL, 'Lid2 complex component jmj3', NULL, NULL, NULL, NULL, NULL, 4),
(147292, NULL, 'G3DSA:1.20.5.170:FF:000111', NULL, NULL, 'CCAAT/enhancer-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(147293, NULL, 'G3DSA:2.10.220.10:FF:000148', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(147294, NULL, 'G3DSA:3.90.1640.10:FF:000005', NULL, NULL, 'Cyclic-di-AMP phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(147295, NULL, 'G3DSA:1.10.510.10:FF:004047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147296, NULL, 'G3DSA:2.130.10.10:FF:005978', NULL, NULL, 'Protein CBG20406', NULL, NULL, NULL, NULL, NULL, 4),
(147297, NULL, 'G3DSA:3.30.559.30:FF:000095', NULL, NULL, 'HC-toxin synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(147298, NULL, 'G3DSA:3.10.100.10:FF:000293', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147299, NULL, 'G3DSA:3.30.750.24:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147300, NULL, 'G3DSA:1.20.20.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147301, NULL, 'G3DSA:2.20.20.160:FF:000003', NULL, NULL, 'Protein giant-lens', NULL, NULL, NULL, NULL, NULL, 4),
(147302, NULL, 'G3DSA:3.40.630.30:FF:000377', NULL, NULL, 'N-terminal acetyltransferase complex ARD1 subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(147303, NULL, 'G3DSA:4.10.800.10:FF:000022', NULL, NULL, 'Insulin-like growth factor-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(147304, NULL, 'G3DSA:3.40.50.1820:FF:000413', NULL, NULL, 'carboxylesterase 1E', NULL, NULL, NULL, NULL, NULL, 4),
(147305, NULL, 'G3DSA:2.170.120.12:FF:000004', NULL, NULL, 'RNA polymerase I subunit 43', NULL, NULL, NULL, NULL, NULL, 4),
(147306, NULL, 'G3DSA:1.25.40.280:FF:000022', NULL, NULL, 'Signal recognition particle subunit SRP68', NULL, NULL, NULL, NULL, NULL, 4),
(147307, NULL, 'G3DSA:3.30.230.70:FF:000068', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(147308, NULL, 'G3DSA:1.20.1050.10:FF:000253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147309, NULL, 'G3DSA:3.30.559.10:FF:000122', NULL, NULL, 'PKS-NRPS hybrid synthetase psoA', NULL, NULL, NULL, NULL, NULL, 4),
(147310, NULL, 'G3DSA:3.40.50.300:FF:006653', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147311, NULL, 'G3DSA:1.20.920.30:FF:000063', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147312, NULL, 'G3DSA:3.30.420.40:FF:000355', NULL, NULL, 'tRNA (Adenosine(37)-N6)-threonylcarbamoyltransferase complex dimerization subunit type 1 TsaB', NULL, NULL, NULL, NULL, NULL, 4),
(147313, NULL, 'G3DSA:1.20.920.20:FF:000060', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(147314, NULL, 'G3DSA:4.10.60.10:FF:000053', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(147315, NULL, 'G3DSA:2.60.120.260:FF:000127', NULL, NULL, 'Allantoicase', NULL, NULL, NULL, NULL, NULL, 4),
(147316, NULL, 'G3DSA:2.60.120.340:FF:000033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147317, NULL, 'G3DSA:1.20.1160.11:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147318, NULL, 'G3DSA:1.25.10.30:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147319, NULL, 'G3DSA:3.40.50.1820:FF:000104', NULL, NULL, 'Alpha/beta hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(147320, NULL, 'G3DSA:3.30.70.1230:FF:000099', NULL, NULL, 'Adenylate cyclase EC 4611', NULL, NULL, NULL, NULL, NULL, 4),
(147321, NULL, 'G3DSA:3.30.70.330:FF:000608', NULL, NULL, 'RNA binding motif protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(147322, NULL, 'G3DSA:3.30.40.10:FF:000047', NULL, NULL, 'Roquin-2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(147323, NULL, 'G3DSA:2.40.110.10:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147324, NULL, 'G3DSA:2.60.40.820:FF:000005', NULL, NULL, 'T-box transcription factor TBX5', NULL, NULL, NULL, NULL, NULL, 4),
(147325, NULL, 'G3DSA:3.40.250.10:FF:000021', NULL, NULL, 'M-phase inducer phosphatase cdc-25.2', NULL, NULL, NULL, NULL, NULL, 4),
(147326, NULL, 'G3DSA:1.25.10.10:FF:000613', NULL, NULL, 'Condensin-2 complex subunit D3', NULL, NULL, NULL, NULL, NULL, 4),
(147327, NULL, 'G3DSA:2.160.20.10:FF:000227', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(147328, NULL, 'G3DSA:3.40.50.300:FF:007142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(147329, NULL, 'G3DSA:3.90.226.10:FF:000134', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(147330, NULL, 'G3DSA:3.80.10.10:FF:000127', NULL, NULL, 'protein phosphatase 1 regulatory subunit 7 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(147331, NULL, 'G3DSA:3.10.10.10:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147332, NULL, 'G3DSA:2.70.170.10:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147333, NULL, 'G3DSA:1.20.120.1750:FF:000170', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(147334, NULL, 'G3DSA:2.160.20.10:FF:000317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147335, NULL, 'G3DSA:3.10.250.10:FF:000096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147336, NULL, 'G3DSA:2.130.10.10:FF:005669', NULL, NULL, 'F-box/WD repeat-containing protein A', NULL, NULL, NULL, NULL, NULL, 4),
(147337, NULL, 'G3DSA:1.10.400.10:FF:000003', NULL, NULL, 'Guanine nucleotide-binding protein G(S) subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(147338, NULL, 'G3DSA:1.10.1170.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147339, NULL, 'G3DSA:2.30.30.40:FF:000075', NULL, NULL, 'phosphatidylinositol 3-kinase regulatory subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(147340, NULL, 'G3DSA:3.40.50.150:FF:000498', NULL, NULL, 'Methyltransferase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(147341, NULL, 'G3DSA:3.30.1140.40:FF:000001', NULL, NULL, 'Dynein light chain Tctex-type 1', NULL, NULL, NULL, NULL, NULL, 4),
(147342, NULL, 'G3DSA:3.30.160.60:FF:002358', NULL, NULL, 'RB associated KRAB zinc finger', NULL, NULL, NULL, NULL, NULL, 4),
(147343, NULL, 'G3DSA:2.60.120.260:FF:000037', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(147344, NULL, 'G3DSA:3.80.10.10:FF:003039', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(147345, NULL, 'G3DSA:3.30.710.10:FF:000132', NULL, NULL, 'BTB/POZ domain and ankyrin repeat-containing protein NH5.2', NULL, NULL, NULL, NULL, NULL, 4),
(147346, NULL, 'G3DSA:1.10.510.10:FF:003310', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147347, NULL, 'G3DSA:3.40.50.80:FF:000118', NULL, NULL, 'Ferric-chelate reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(147348, NULL, 'G3DSA:1.20.120.140:FF:000028', NULL, NULL, 'Signal recognition particle receptor FtsY', NULL, NULL, NULL, NULL, NULL, 4),
(147349, NULL, 'G3DSA:2.60.40.10:FF:002139', NULL, NULL, 'Gamma interferon receptor', NULL, NULL, NULL, NULL, NULL, 4),
(147350, NULL, 'G3DSA:1.10.238.10:FF:000726', NULL, NULL, 'Reticulocalbin-2', NULL, NULL, NULL, NULL, NULL, 4),
(147351, NULL, 'G3DSA:3.40.850.10:FF:000117', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(147352, NULL, 'G3DSA:2.40.50.140:FF:000403', NULL, NULL, 'Translation initiation factor 2 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(147353, NULL, 'G3DSA:3.30.200.20:FF:002384', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147354, NULL, 'G3DSA:3.90.950.10:FF:000030', NULL, NULL, 'Bifunctional phosphopantetheine adenylyltransferase/NTP phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(147355, NULL, 'G3DSA:2.30.30.40:FF:000384', NULL, NULL, 'Alpha-(1,6)-fucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(147356, NULL, 'G3DSA:1.25.40.10:FF:000424', NULL, NULL, 'Type VII secretion AAA-ATPase EccA', NULL, NULL, NULL, NULL, NULL, 4),
(147357, NULL, 'G3DSA:2.60.40.150:FF:000815', NULL, NULL, 'Misfire, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(147358, NULL, 'G3DSA:2.30.42.10:FF:000312', NULL, NULL, 'Glutamate receptor interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(147359, NULL, 'G3DSA:3.30.2160.10:FF:000016', NULL, NULL, 'E3 ubiquitin-protein ligase HACE1', NULL, NULL, NULL, NULL, NULL, 4),
(147360, NULL, 'G3DSA:2.130.10.10:FF:002448', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(147361, NULL, 'G3DSA:3.40.50.300:FF:002847', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147362, NULL, 'G3DSA:2.160.10.10:FF:000053', NULL, NULL, 'Probable translation initiation factor eIF-2B subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(147363, NULL, 'G3DSA:3.10.310.10:FF:000027', NULL, NULL, 'Probable phenazine biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(147364, NULL, 'G3DSA:2.130.10.10:FF:002757', NULL, NULL, 'Transcriptional regulator STERILE APETALA', NULL, NULL, NULL, NULL, NULL, 4),
(147365, NULL, 'G3DSA:3.10.450.320:FF:000005', NULL, NULL, 'Mitochondrial import inner membrane translocase subunit Tim21', NULL, NULL, NULL, NULL, NULL, 4),
(147366, NULL, 'G3DSA:2.70.20.10:FF:000007', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(147367, NULL, 'G3DSA:2.30.30.40:FF:000423', NULL, NULL, 'Protein kinase C and casein kinase substrate in neurons 2', NULL, NULL, NULL, NULL, NULL, 4),
(147368, NULL, 'G3DSA:2.130.10.10:FF:001959', NULL, NULL, 'Os11g0187100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(147369, NULL, 'G3DSA:3.40.50.1000:FF:000387', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147370, NULL, 'G3DSA:2.60.120.200:FF:000042', NULL, NULL, 'Neuropilin', NULL, NULL, NULL, NULL, NULL, 4),
(147371, NULL, 'G3DSA:3.10.28.10:FF:000014', NULL, NULL, 'V-type proton ATPase catalytic subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(147372, NULL, 'G3DSA:1.20.5.190:FF:000117', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147373, NULL, 'G3DSA:3.90.70.10:FF:000417', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147374, NULL, 'G3DSA:1.20.1090.10:FF:000031', NULL, NULL, 'Iron alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(147375, NULL, 'G3DSA:3.40.50.1980:FF:000085', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(147376, NULL, 'G3DSA:1.10.10.10:FF:001130', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(147377, NULL, 'G3DSA:3.30.40.10:FF:002301', NULL, NULL, 'Protein CBG05712', NULL, NULL, NULL, NULL, NULL, 4),
(147378, NULL, 'G3DSA:1.20.120.230:FF:000027', NULL, NULL, 'Talin 2b', NULL, NULL, NULL, NULL, NULL, 4),
(147379, NULL, 'G3DSA:2.30.42.10:FF:000621', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147380, NULL, 'G3DSA:2.30.30.30:FF:000072', NULL, NULL, 'KOW motif domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(147381, NULL, 'G3DSA:3.30.200.20:FF:002075', NULL, NULL, 'Serine/threonine-protein kinase PknB', NULL, NULL, NULL, NULL, NULL, 4),
(147382, NULL, 'G3DSA:3.40.50.1820:FF:001515', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147383, NULL, 'G3DSA:3.40.630.10:FF:000371', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147384, NULL, 'G3DSA:3.40.50.300:FF:002292', NULL, NULL, 'Helicase SWR1', NULL, NULL, NULL, NULL, NULL, 4),
(147385, NULL, 'G3DSA:3.30.830.10:FF:000079', NULL, NULL, 'Coenzyme PQQ synthesis protein F', NULL, NULL, NULL, NULL, NULL, 4),
(147386, NULL, 'G3DSA:1.10.238.10:FF:000417', NULL, NULL, 'Calcium-binding EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(147387, NULL, 'G3DSA:3.80.10.10:FF:003348', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147388, NULL, 'G3DSA:3.30.710.10:FF:000441', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147389, NULL, 'G3DSA:3.30.1490.100:FF:000014', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(147390, NULL, 'G3DSA:1.25.10.10:FF:002182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147391, NULL, 'G3DSA:2.10.25.10:FF:001555', NULL, NULL, 'Wall-associated receptor kinase-like 17', NULL, NULL, NULL, NULL, NULL, 4),
(147392, NULL, 'G3DSA:3.30.565.10:FF:000182', NULL, NULL, 'Sensor histidine kinase KinD', NULL, NULL, NULL, NULL, NULL, 4),
(147393, NULL, 'G3DSA:3.30.1330.40:FF:000010', NULL, NULL, 'Diphthine--ammonia ligase', NULL, NULL, NULL, NULL, NULL, 4),
(147394, NULL, 'G3DSA:4.10.60.10:FF:000160', NULL, NULL, 'Replication protein A subunit', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(147395, NULL, 'G3DSA:1.20.58.60:FF:000001', NULL, NULL, 'Microtubule-actin cross-linking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(147396, NULL, 'G3DSA:3.40.50.1820:FF:001717', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147397, NULL, 'G3DSA:3.20.20.140:FF:000100', NULL, NULL, '2-pyrone-4,6-dicarboxylate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(147398, NULL, 'G3DSA:1.10.510.10:FF:004491', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147399, NULL, 'G3DSA:1.25.40.10:FF:000076', NULL, NULL, 'calcineurin-binding protein cabin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(147400, NULL, 'G3DSA:2.60.40.60:FF:000748', NULL, NULL, 'Cdh-4', NULL, NULL, NULL, NULL, NULL, 4),
(147401, NULL, 'G3DSA:3.40.190.10:FF:000544', NULL, NULL, 'Ionotropic receptor 93a', NULL, NULL, NULL, NULL, NULL, 4),
(147402, NULL, 'G3DSA:3.30.730.10:FF:000004', NULL, NULL, 'AP2-like ethylene-responsive transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(147403, NULL, 'G3DSA:3.30.505.10:FF:000167', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147404, NULL, 'G3DSA:3.40.630.10:FF:000045', NULL, NULL, 'Transferrin receptor protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(147405, NULL, 'G3DSA:3.30.160.60:FF:004612', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147406, NULL, 'G3DSA:3.30.420.40:FF:000574', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(147407, NULL, 'G3DSA:2.40.30.10:FF:000195', NULL, NULL, 'DUal OXidase', NULL, NULL, NULL, NULL, NULL, 4),
(147408, NULL, 'G3DSA:3.40.50.1580:FF:000072', NULL, NULL, 'Inosine guanosine and xanthosine phosphorylase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(147409, NULL, 'G3DSA:3.30.200.20:FF:000506', NULL, NULL, 'SH3 domain binding kinase family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(147410, NULL, 'G3DSA:1.20.120.1750:FF:000035', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(147411, NULL, 'G3DSA:1.20.5.170:FF:000021', NULL, NULL, 'Cyclic AMP-dependent transcription factor ATF-4', NULL, NULL, NULL, NULL, NULL, 4),
(147412, NULL, 'G3DSA:3.30.160.360:FF:000014', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(147413, NULL, 'G3DSA:3.50.50.60:FF:000062', NULL, NULL, 'FAD-dependent 2-octaprenylphenol hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(147414, NULL, 'G3DSA:2.60.40.10:FF:002925', NULL, NULL, 'HERV-H LTR-associating 2a, tandem duplicate 2', NULL, NULL, NULL, NULL, NULL, 4),
(147415, NULL, 'G3DSA:3.40.50.300:FF:006563', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147416, NULL, 'G3DSA:1.10.357.10:FF:000036', NULL, NULL, 'TetR/AcrR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(147417, NULL, 'G3DSA:3.30.1330.20:FF:000055', NULL, NULL, 'Tubulin gamma-2 chain', NULL, NULL, NULL, NULL, NULL, 4),
(147418, NULL, 'G3DSA:3.40.190.10:FF:000016', NULL, NULL, 'Lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(147419, NULL, 'G3DSA:3.40.50.150:FF:000857', NULL, NULL, 'Modification methylase', NULL, NULL, NULL, NULL, NULL, 4),
(147420, NULL, 'G3DSA:3.30.70.330:FF:000064', NULL, NULL, 'Differentiation 1 negative regulator', NULL, NULL, NULL, NULL, NULL, 4),
(147421, NULL, 'G3DSA:3.30.390.10:FF:000028', NULL, NULL, 'Enolase', NULL, NULL, NULL, NULL, NULL, 4),
(147422, NULL, 'G3DSA:2.130.10.120:FF:000019', NULL, NULL, 'Prolyl oligopeptidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(147423, NULL, 'G3DSA:3.30.450.20:FF:000171', NULL, NULL, 'Protein CBR-AHA-1', NULL, NULL, NULL, NULL, NULL, 4),
(147424, NULL, 'G3DSA:3.80.10.10:FF:001875', NULL, NULL, 'Uncharacterized protein LGR3', NULL, NULL, NULL, NULL, NULL, 4),
(147425, NULL, 'G3DSA:3.40.50.300:FF:002286', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(147426, NULL, 'G3DSA:3.30.40.10:FF:002323', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147427, NULL, 'G3DSA:3.10.20.70:FF:000014', NULL, NULL, 'Glutamine synthetase type I', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(147428, NULL, 'G3DSA:1.10.357.10:FF:000042', NULL, NULL, 'TetR family HTH-type transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(147429, NULL, 'G3DSA:1.10.238.10:FF:000187', NULL, NULL, 'Programmed cell death protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(147430, NULL, 'G3DSA:2.60.40.10:FF:002454', NULL, NULL, 'KETtiN (Drosophila actin-binding) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(147431, NULL, 'G3DSA:3.30.160.60:FF:002886', NULL, NULL, 'Zinc finger protein 197', NULL, NULL, NULL, NULL, NULL, 4),
(147432, NULL, 'G3DSA:3.40.50.300:FF:000577', NULL, NULL, 'lymphoid-specific helicase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(147433, NULL, 'G3DSA:3.90.930.12:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147434, NULL, 'G3DSA:1.10.472.10:FF:000231', NULL, NULL, 'Cyclin, N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(147435, NULL, 'G3DSA:2.70.150.10:FF:000292', NULL, NULL, 'Putative phospholipid-transporting ATPase C24B11.12c', NULL, NULL, NULL, NULL, NULL, 4),
(147436, NULL, 'G3DSA:2.130.10.110:FF:000016', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(147437, NULL, 'G3DSA:3.40.120.10:FF:000068', NULL, NULL, 'Phosphomannomutase/phosphoglucomutase', NULL, NULL, NULL, NULL, NULL, 4),
(147438, NULL, 'G3DSA:3.30.1330.60:FF:000016', NULL, NULL, 'Outer membrane protein OmpA', NULL, NULL, NULL, NULL, NULL, 4),
(147439, NULL, 'G3DSA:3.40.30.10:FF:001013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147440, NULL, 'G3DSA:3.40.630.60:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147441, NULL, 'G3DSA:1.20.5.190:FF:000027', NULL, NULL, 'Myosin IXA', NULL, NULL, NULL, NULL, NULL, 4),
(147442, NULL, 'G3DSA:2.70.70.10:FF:000050', NULL, NULL, 'Peptidase, M23 family', NULL, NULL, NULL, NULL, NULL, 4),
(147443, NULL, 'G3DSA:3.40.50.720:FF:001765', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147444, NULL, 'G3DSA:3.30.50.10:FF:000109', NULL, NULL, 'NURR1', NULL, NULL, NULL, NULL, NULL, 4),
(147445, NULL, 'G3DSA:1.10.3260.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147446, NULL, 'G3DSA:2.40.10.10:FF:000671', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147447, NULL, 'G3DSA:3.40.50.360:FF:000010', NULL, NULL, 'FMN-dependent NADH-azoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(147448, NULL, 'G3DSA:3.90.980.20:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147449, NULL, 'G3DSA:1.25.40.70:FF:000088', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(147450, NULL, 'G3DSA:3.40.630.10:FF:000152', NULL, NULL, 'aspartyl aminopeptidase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(147451, NULL, 'G3DSA:1.20.144.10:FF:000118', NULL, NULL, 'Glucose-6-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(147452, NULL, 'G3DSA:1.20.1070.10:FF:001575', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147453, NULL, 'G3DSA:1.10.260.60:FF:000006', NULL, NULL, 'DOT1-like, histone H3 methyltransferase (S. cerevisiae)', NULL, NULL, NULL, NULL, NULL, 4),
(147454, NULL, 'G3DSA:2.70.150.10:FF:000179', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(147455, NULL, 'G3DSA:2.60.120.650:FF:000137', NULL, NULL, 'Lysine-specific demethylase 7 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(147456, NULL, 'G3DSA:1.10.287.920:FF:000005', NULL, NULL, 'Alpha-factor pheromone receptor', NULL, NULL, NULL, NULL, NULL, 4),
(147457, NULL, 'G3DSA:2.10.90.10:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147458, NULL, 'G3DSA:3.30.750.24:FF:000013', NULL, NULL, 'Solute carrier family 26 member 11', NULL, NULL, NULL, NULL, NULL, 4),
(147459, NULL, 'G3DSA:1.10.10.60:FF:000532', NULL, NULL, 'C. Elegans Homeobox', NULL, NULL, NULL, NULL, NULL, 4),
(147460, NULL, 'G3DSA:1.10.150.130:FF:000011', NULL, NULL, 'Tyrosine recombinase XerS', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(147461, NULL, 'G3DSA:3.90.132.10:FF:000028', NULL, NULL, 'GP63-like', NULL, NULL, NULL, NULL, NULL, 4),
(147462, NULL, 'G3DSA:3.40.50.2000:FF:000810', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147463, NULL, 'G3DSA:2.60.40.10:FF:002780', NULL, NULL, 'Wrapper protein', NULL, NULL, NULL, NULL, NULL, 4),
(147464, NULL, 'G3DSA:1.10.1670.10:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147465, NULL, 'G3DSA:3.30.450.40:FF:000177', NULL, NULL, 'Probable HTH-type transcriptional regulator ArcR', NULL, NULL, NULL, NULL, NULL, 4),
(147466, NULL, 'G3DSA:1.10.260.50:FF:000003', NULL, NULL, 'Probable cysteine desulfurase iscS', NULL, NULL, NULL, NULL, NULL, 4),
(147467, NULL, 'G3DSA:3.80.10.10:FF:002061', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147468, NULL, 'G3DSA:1.20.1420.30:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147469, NULL, 'G3DSA:2.60.11.10:FF:000009', NULL, NULL, 'Cytochrome c oxidase subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(147470, NULL, 'G3DSA:3.40.50.150:FF:001004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147471, NULL, 'G3DSA:3.30.200.20:FF:002159', NULL, NULL, 'C-ros-like receptor', NULL, NULL, NULL, NULL, NULL, 4),
(147472, NULL, 'G3DSA:3.30.160.60:FF:006265', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147473, NULL, 'G3DSA:3.30.160.60:FF:003611', NULL, NULL, 'Zinc finger protein 644a', NULL, NULL, NULL, NULL, NULL, 4),
(147474, NULL, 'G3DSA:3.80.10.10:FF:001347', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase GSO2', NULL, NULL, NULL, NULL, NULL, 4),
(147475, NULL, 'G3DSA:3.30.160.60:FF:002993', NULL, NULL, 'Blast:Transcription factor grauzone', NULL, NULL, NULL, NULL, NULL, 4),
(147476, NULL, 'G3DSA:3.10.129.10:FF:000072', NULL, NULL, 'PaaI family thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(147477, NULL, 'G3DSA:1.20.1250.20:FF:001783', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147478, NULL, 'G3DSA:3.30.540.10:FF:000085', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(147479, NULL, 'G3DSA:1.20.5.870:FF:000001', NULL, NULL, 'Calcium-gated potassium channel MthK', NULL, NULL, NULL, NULL, NULL, 4),
(147480, NULL, 'G3DSA:3.40.50.300:FF:005034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147481, NULL, 'G3DSA:2.120.10.30:FF:000476', NULL, NULL, 'NHL repeat-containing protein 2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(147482, NULL, 'G3DSA:3.40.640.10:FF:000181', NULL, NULL, 'cystathionine gamma-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(147483, NULL, 'G3DSA:1.10.238.10:FF:000732', NULL, NULL, 'GEO12020p1', NULL, NULL, NULL, NULL, NULL, 4),
(147484, NULL, 'G3DSA:2.40.100.10:FF:000144', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(147485, NULL, 'G3DSA:1.25.70.10:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147486, NULL, 'G3DSA:2.60.410.10:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147487, NULL, 'G3DSA:1.20.140.140:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147488, NULL, 'G3DSA:3.30.230.10:FF:000331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147489, NULL, 'G3DSA:1.10.490.10:FF:000025', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147490, NULL, 'G3DSA:1.20.58.390:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147491, NULL, 'G3DSA:3.40.30.10:FF:000395', NULL, NULL, 'Glutathione S-transferase, C-terminal domain containing protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(147492, NULL, 'G3DSA:2.40.70.10:FF:000315', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147493, NULL, 'G3DSA:3.90.980.10:FF:000003', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(147494, NULL, 'G3DSA:2.30.29.180:FF:000001', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 37', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(147495, NULL, 'G3DSA:1.10.510.10:FF:002776', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147496, NULL, 'G3DSA:2.40.30.10:FF:000447', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147497, NULL, 'G3DSA:1.20.920.20:FF:000054', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(147498, NULL, 'G3DSA:2.60.40.10:FF:001144', NULL, NULL, 'lachesin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(147499, NULL, 'G3DSA:3.40.30.10:FF:001232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147500, NULL, 'G3DSA:2.60.120.1320:FF:000001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147501, NULL, 'G3DSA:3.40.50.720:FF:002170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147502, NULL, 'G3DSA:1.10.287.2480:FF:000002', NULL, NULL, 'Fusion glycoprotein F0', NULL, NULL, NULL, NULL, NULL, 4),
(147503, NULL, 'G3DSA:3.30.160.60:FF:006484', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147504, NULL, 'G3DSA:1.20.1250.60:FF:000002', NULL, NULL, 'Interferon lambda-4', NULL, NULL, NULL, NULL, NULL, 4),
(147505, NULL, 'G3DSA:2.30.36.70:FF:000012', NULL, NULL, 'Actin-related protein 3, putative arp3', NULL, NULL, NULL, NULL, NULL, 4),
(147506, NULL, 'G3DSA:1.10.510.10:FF:002557', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(147507, NULL, 'G3DSA:2.20.100.10:FF:000120', NULL, NULL, 'Thrombospondin, type I, domain-containing 7Ab', NULL, NULL, NULL, NULL, NULL, 4),
(147508, NULL, 'G3DSA:3.40.50.10470:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147509, NULL, 'G3DSA:3.40.50.1220:FF:000020', NULL, NULL, 'Nad-dependent histone deacetylase sir2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(147510, NULL, 'G3DSA:1.20.920.30:FF:000057', NULL, NULL, 'AGAP010790-PA', NULL, NULL, NULL, NULL, NULL, 4),
(147511, NULL, 'G3DSA:1.25.10.10:FF:001996', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147512, NULL, 'G3DSA:1.10.730.10:FF:000213', NULL, NULL, 'Protein CBR-LARS-2', NULL, NULL, NULL, NULL, NULL, 4),
(147513, NULL, 'G3DSA:2.130.10.10:FF:002089', NULL, NULL, 'WD repeat-containing protein 11 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(147514, NULL, 'G3DSA:2.20.28.120:FF:000007', NULL, NULL, '50S ribosomal protein L33', NULL, NULL, NULL, NULL, NULL, 4),
(147515, NULL, 'G3DSA:3.30.40.10:FF:001918', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147516, NULL, 'G3DSA:3.30.2350.10:FF:000053', NULL, NULL, 'Os02g0274650 protein', NULL, NULL, NULL, NULL, NULL, 4),
(147517, NULL, 'G3DSA:3.30.420.40:FF:000349', NULL, NULL, 'Heat shock protein 70 putative', NULL, NULL, NULL, NULL, NULL, 4),
(147518, NULL, 'G3DSA:3.40.800.10:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147519, NULL, 'G3DSA:3.60.10.10:FF:000100', NULL, NULL, 'Unplaced genomic scaffold supercont2.12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(147520, NULL, 'G3DSA:3.90.550.50:FF:000157', NULL, NULL, 'Beta-1,3-galactosyltransferase brn-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(147521, NULL, 'G3DSA:3.10.105.10:FF:000079', NULL, NULL, 'Putative ABC transporter, substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(147522, NULL, 'G3DSA:1.20.1250.20:FF:000041', NULL, NULL, 'Uncharacterized MFS-type transporter YcaD', NULL, NULL, NULL, NULL, NULL, 4),
(147523, NULL, 'G3DSA:3.80.20.20:FF:000069', NULL, NULL, 'ErbB-3 R1', NULL, NULL, NULL, NULL, NULL, 4),
(147524, NULL, 'G3DSA:1.10.533.10:FF:000255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147525, NULL, 'G3DSA:2.60.200.10:FF:000006', NULL, NULL, 'Expansion, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(147526, NULL, 'G3DSA:3.90.70.10:FF:000861', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147527, NULL, 'G3DSA:3.10.20.10:FF:000002', NULL, NULL, '60S ribosomal protein L18a', NULL, NULL, NULL, NULL, NULL, 4),
(147528, NULL, 'G3DSA:3.10.100.10:FF:000326', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(147529, NULL, 'G3DSA:2.60.40.10:FF:000891', NULL, NULL, 'Titin a', NULL, NULL, NULL, NULL, NULL, 4),
(147530, NULL, 'G3DSA:3.10.20.90:FF:000880', NULL, NULL, 'Carbohydrate sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(147531, NULL, 'G3DSA:1.20.5.190:FF:000134', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147532, NULL, 'G3DSA:1.20.1270.350:FF:000002', NULL, NULL, 'Myoblast city, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(147533, NULL, 'G3DSA:3.30.160.40:FF:000003', NULL, NULL, 'porphobilinogen deaminase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(147534, NULL, 'G3DSA:1.10.510.10:FF:000652', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(147535, NULL, 'G3DSA:2.60.200.20:FF:000009', NULL, NULL, 'bifunctional polynucleotide phosphatase/kinase', NULL, NULL, NULL, NULL, NULL, 4),
(147536, NULL, 'G3DSA:2.130.10.10:FF:000649', NULL, NULL, 'Compass component swd1', NULL, NULL, NULL, NULL, NULL, 4),
(147537, NULL, 'G3DSA:2.30.29.30:FF:001384', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147538, NULL, 'G3DSA:3.30.160.60:FF:003302', NULL, NULL, 'Zgc:171673', NULL, NULL, NULL, NULL, NULL, 4),
(147539, NULL, 'G3DSA:3.40.50.150:FF:001223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147540, NULL, 'G3DSA:2.40.160.110:FF:000011', NULL, NULL, 'Lysosome-associated membrane glycoprotein 2', NULL, NULL, NULL, NULL, NULL, 4),
(147541, NULL, 'G3DSA:1.20.1250.70:FF:000005', NULL, NULL, 'Interleukin', NULL, NULL, NULL, NULL, NULL, 4),
(147542, NULL, 'G3DSA:2.60.40.10:FF:002673', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147543, NULL, 'G3DSA:3.30.559.10:FF:000015', NULL, NULL, 'Spermidine hydroxycinnamoyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(147544, NULL, 'G3DSA:1.10.3720.10:FF:000184', NULL, NULL, 'Nitrate ABC transporter permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(147545, NULL, 'G3DSA:2.20.28.40:FF:000002', NULL, NULL, 'H/ACA ribonucleoprotein complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(147546, NULL, 'G3DSA:1.20.58.60:FF:000220', NULL, NULL, 'Alpha spectrin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(147547, NULL, 'G3DSA:3.40.1280.10:FF:000073', NULL, NULL, 'tRNA/rRNA methyltransferase (SpoU)', NULL, NULL, NULL, NULL, NULL, 4),
(147548, NULL, 'G3DSA:2.130.10.10:FF:004343', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147549, NULL, 'G3DSA:2.10.25.10:FF:001774', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147550, NULL, 'G3DSA:3.30.70.1450:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147551, NULL, 'G3DSA:2.130.10.10:FF:002903', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1', NULL, NULL, NULL, NULL, NULL, 4),
(147552, NULL, 'G3DSA:1.10.3460.10:FF:000028', NULL, NULL, 'Fucoxanthin chl a/c light-harvesting protein', NULL, NULL, NULL, NULL, NULL, 4),
(147553, NULL, 'G3DSA:3.40.630.10:FF:000354', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147554, NULL, 'G3DSA:3.30.70.330:FF:002407', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147555, NULL, 'G3DSA:3.90.960.10:FF:000002', NULL, NULL, 'Cys-tRNA(Pro)/Cys-tRNA(Cys) deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(147556, NULL, 'G3DSA:3.30.70.330:FF:001789', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147557, NULL, 'G3DSA:3.40.50.10900:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147558, NULL, 'G3DSA:1.25.40.10:FF:004572', NULL, NULL, 'Tetratricopeptide repeat protein 17-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(147559, NULL, 'G3DSA:3.20.20.140:FF:000477', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147560, NULL, 'G3DSA:2.60.120.200:FF:000244', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(147561, NULL, 'G3DSA:3.30.160.60:FF:004831', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147562, NULL, 'G3DSA:2.30.30.40:FF:000277', NULL, NULL, 'Actin-binding protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(147563, NULL, 'G3DSA:3.90.79.10:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147564, NULL, 'G3DSA:1.10.287.4070:FF:000024', NULL, NULL, 'GM14238p', NULL, NULL, NULL, NULL, NULL, 4),
(147565, NULL, 'G3DSA:3.30.70.330:FF:000373', NULL, NULL, 'RNA-binding protein 39 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(147566, NULL, 'G3DSA:1.10.510.10:FF:000904', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(147567, NULL, 'G3DSA:3.30.465.10:FF:000016', NULL, NULL, 'probable D-lactate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(147568, NULL, 'G3DSA:2.20.70.10:FF:000164', NULL, NULL, 'WW_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(147569, NULL, 'G3DSA:2.130.10.10:FF:002651', NULL, NULL, 'ER membrane protein complex subunit 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(147570, NULL, 'G3DSA:3.40.630.40:FF:000003', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase AmiB', NULL, NULL, NULL, NULL, NULL, 4),
(147571, NULL, 'G3DSA:3.10.129.110:FF:000014', NULL, NULL, 'Polyketide synthase, putative (JCVI)', NULL, NULL, NULL, NULL, NULL, 4),
(147572, NULL, 'G3DSA:3.40.50.1240:FF:000026', NULL, NULL, 'Putative fructose-2,6-bisphosphatase TIGAR', NULL, NULL, NULL, NULL, NULL, 4),
(147573, NULL, 'G3DSA:2.30.29.230:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147574, NULL, 'G3DSA:1.10.510.10:FF:002248', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147575, NULL, 'G3DSA:3.10.180.10:FF:000067', NULL, NULL, 'Anthracycline biosynthesis protein DauV', NULL, NULL, NULL, NULL, NULL, 4),
(147576, NULL, 'G3DSA:1.10.287.950:FF:000037', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(147577, NULL, 'G3DSA:2.60.40.10:FF:004578', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147578, NULL, 'G3DSA:2.60.40.1400:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147579, NULL, 'G3DSA:1.10.287.140:FF:000002', NULL, NULL, 'Glutamate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(147580, NULL, 'G3DSA:3.40.50.300:FF:003325', NULL, NULL, 'Thymidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(147581, NULL, 'G3DSA:2.40.10.10:FF:000339', NULL, NULL, 'Complement component 1, r subcomponent', NULL, NULL, NULL, NULL, NULL, 4),
(147582, NULL, 'G3DSA:3.40.50.1000:FF:000864', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147583, NULL, 'G3DSA:3.30.70.120:FF:000006', NULL, NULL, 'GTP cyclohydrolase 1 type 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(147584, NULL, 'G3DSA:3.40.50.300:FF:006670', NULL, NULL, 'Os01g0540300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(147585, NULL, 'G3DSA:3.40.190.290:FF:000058', NULL, NULL, 'Oxidative stress response regulatory protein OxyS', NULL, NULL, NULL, NULL, NULL, 4),
(147586, NULL, 'G3DSA:3.30.420.40:FF:000372', NULL, NULL, 'Putative fimbrial assembly protein PilM', NULL, NULL, NULL, NULL, NULL, 4),
(147587, NULL, 'G3DSA:3.30.46.10:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147588, NULL, 'G3DSA:3.60.15.10:FF:000072', NULL, NULL, 'Cleavage and polyadenylation specificity factor subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(147589, NULL, 'G3DSA:3.40.1090.10:FF:000148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147590, NULL, 'G3DSA:2.60.40.150:FF:000580', NULL, NULL, 'Synaptotagmin 1c', NULL, NULL, NULL, NULL, NULL, 4),
(147591, NULL, 'G3DSA:3.20.20.30:FF:000018', NULL, NULL, 'POSSIBLE OXIDOREDUCTASE', NULL, NULL, NULL, NULL, NULL, 4),
(147592, NULL, 'G3DSA:3.40.50.1820:FF:001408', NULL, NULL, 'Monoglyceride lipase', NULL, NULL, NULL, NULL, NULL, 4),
(147593, NULL, 'G3DSA:1.20.85.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147594, NULL, 'G3DSA:1.20.1050.10:FF:000270', NULL, NULL, 'Predicted gene 20441', NULL, NULL, NULL, NULL, NULL, 4),
(147595, NULL, 'G3DSA:3.40.50.300:FF:001291', NULL, NULL, 'Probable ATP-dependent RNA helicase DDX58', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(147596, NULL, 'G3DSA:2.60.40.10:FF:004269', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147597, NULL, 'G3DSA:2.40.10.10:FF:000648', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147598, NULL, 'G3DSA:1.25.40.20:FF:001702', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147599, NULL, 'G3DSA:1.20.1310.10:FF:000184', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147600, NULL, 'G3DSA:3.30.2350.20:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147601, NULL, 'G3DSA:3.30.590.10:FF:000015', NULL, NULL, 'Glutamine synthetase, type I', NULL, NULL, NULL, NULL, NULL, 4),
(147602, NULL, 'G3DSA:3.30.420.40:FF:000681', NULL, NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(147603, NULL, 'G3DSA:1.20.5.470:FF:000004', NULL, NULL, 'Argininosuccinate synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(147604, NULL, 'G3DSA:1.10.730.10:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147605, NULL, 'G3DSA:3.30.40.10:FF:001609', NULL, NULL, 'PHD finger family protein', NULL, NULL, NULL, NULL, NULL, 4),
(147606, NULL, 'G3DSA:1.20.1070.10:FF:001356', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147607, NULL, 'G3DSA:2.60.40.820:FF:000022', NULL, NULL, 'T-box transcription factor TBX2', NULL, NULL, NULL, NULL, NULL, 4),
(147608, NULL, 'G3DSA:3.40.50.300:FF:008452', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147609, NULL, 'G3DSA:1.10.472.10:FF:000646', NULL, NULL, 'Cyclin H', NULL, NULL, NULL, NULL, NULL, 4),
(147610, NULL, 'G3DSA:1.25.10.10:FF:002491', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147611, NULL, 'G3DSA:3.90.1150.10:FF:000142', NULL, NULL, 'Histidinol-phosphate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(147612, NULL, 'G3DSA:1.10.630.10:FF:000014', NULL, NULL, 'Abscisic acid 8', NULL, NULL, NULL, NULL, NULL, 4),
(147613, NULL, 'G3DSA:3.40.50.2000:FF:000046', NULL, NULL, 'alpha,alpha-trehalose-phosphate synthase [UDP-forming] 1', NULL, NULL, NULL, NULL, NULL, 4),
(147614, NULL, 'G3DSA:3.10.110.10:FF:000046', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 Z', NULL, NULL, NULL, NULL, NULL, 4),
(147615, NULL, 'G3DSA:3.10.350.10:FF:000030', NULL, NULL, 'Peptidoglycan-binding LysM domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(147616, NULL, 'G3DSA:1.20.58.860:FF:000020', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(147617, NULL, 'G3DSA:3.40.50.11030:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147618, NULL, 'G3DSA:1.10.1410.10:FF:000109', NULL, NULL, 'Protein CBG04590', NULL, NULL, NULL, NULL, NULL, 4),
(147619, NULL, 'G3DSA:3.30.160.60:FF:004718', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147620, NULL, 'G3DSA:1.20.58.1480:FF:000002', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(147621, NULL, 'G3DSA:3.30.460.80:FF:000004', NULL, NULL, 'NAD(P)H-quinone oxidoreductase subunit J, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(147622, NULL, 'G3DSA:3.30.50.10:FF:000003', NULL, NULL, 'Nuclear orphan receptor ROR-beta', NULL, NULL, NULL, NULL, NULL, 4),
(147623, NULL, 'G3DSA:3.30.200.210:FF:000002', NULL, NULL, 'NADH-ubiquinone oxidoreductase 75 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(147624, NULL, 'G3DSA:1.20.1070.10:FF:002070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147625, NULL, 'G3DSA:1.25.10.10:FF:000692', NULL, NULL, 'Arm repeat containing protein homolog-like', NULL, NULL, NULL, NULL, NULL, 4),
(147626, NULL, 'G3DSA:1.10.1370.10:FF:000015', NULL, NULL, 'Protein CBG01792', NULL, NULL, NULL, NULL, NULL, 4),
(147627, NULL, 'G3DSA:1.25.10.10:FF:001310', NULL, NULL, 'WAPL (Wings apart-like protein regulation of heterochromatin) protein', NULL, NULL, NULL, NULL, NULL, 4),
(147628, NULL, 'G3DSA:3.40.50.300:FF:000268', NULL, NULL, 'ATP-dependent Clp protease, ATP-binding subunit ClpA', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(147629, NULL, 'G3DSA:2.60.40.10:FF:000672', NULL, NULL, 'Titin a', NULL, NULL, NULL, NULL, NULL, 4),
(147630, NULL, 'G3DSA:3.30.40.10:FF:002290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147631, NULL, 'G3DSA:1.10.1450.10:FF:000073', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(147632, NULL, 'G3DSA:3.40.50.720:FF:001456', NULL, NULL, 'Ornithine cyclodeaminase', NULL, NULL, NULL, NULL, NULL, 4),
(147633, NULL, 'G3DSA:1.25.40.20:FF:001051', NULL, NULL, 'Ankyrin repeat domain-containing protein 27-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(147634, NULL, 'G3DSA:2.130.10.10:FF:000397', NULL, NULL, 'Autophagy-related protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(147635, NULL, 'G3DSA:2.130.10.10:FF:001015', NULL, NULL, 'DIP2p Nucleolar protein', NULL, NULL, NULL, NULL, NULL, 4),
(147636, NULL, 'G3DSA:1.10.287.380:FF:000023', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(147637, NULL, 'G3DSA:2.30.29.240:FF:000019', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(147638, NULL, 'G3DSA:3.30.70.330:FF:000300', NULL, NULL, 'Interferon-induced protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(147639, NULL, 'G3DSA:2.70.170.10:FF:000181', NULL, NULL, 'Neuronal acetylcholine receptor subunit alpha-3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(147640, NULL, 'G3DSA:1.10.8.20:FF:000002', NULL, NULL, 'tyrosine-protein phosphatase non-receptor type 9', NULL, NULL, NULL, NULL, NULL, 4),
(147641, NULL, 'G3DSA:3.40.50.300:FF:008581', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147642, NULL, 'G3DSA:2.30.180.10:FF:000078', NULL, NULL, 'BIGH3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(147643, NULL, 'G3DSA:3.40.50.1440:FF:000081', NULL, NULL, 'Beta tubulin,putative', NULL, NULL, NULL, NULL, NULL, 4),
(147644, NULL, 'G3DSA:3.40.1740.10:FF:000002', NULL, NULL, 'UPF0301 protein A5636_14805', NULL, NULL, NULL, NULL, NULL, 4),
(147645, NULL, 'G3DSA:1.10.10.520:FF:000008', NULL, NULL, 'SUMO-activating enzyme subunit', NULL, NULL, NULL, NULL, NULL, 4),
(147646, NULL, 'G3DSA:3.30.40.10:FF:000502', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(147647, NULL, 'G3DSA:3.40.50.2300:FF:001558', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147648, NULL, 'G3DSA:1.20.1740.10:FF:000210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147649, NULL, 'G3DSA:2.40.70.10:FF:000085', NULL, NULL, 'Aspartic-type endopeptidase (CtsD), putative', NULL, NULL, NULL, NULL, NULL, 4),
(147650, NULL, 'G3DSA:1.10.510.10:FF:000668', NULL, NULL, 'Phosphoenolpyruvate carboxylase kinase', NULL, NULL, NULL, NULL, NULL, 4),
(147651, NULL, 'G3DSA:3.40.190.10:FF:000235', NULL, NULL, 'Phosphate-binding protein PstS', NULL, NULL, NULL, NULL, NULL, 4),
(147652, NULL, 'G3DSA:3.30.70.920:FF:000016', NULL, NULL, 'AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(147653, NULL, 'G3DSA:1.25.40.20:FF:000775', NULL, NULL, 'Cell-cycle-regulation transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(147654, NULL, 'G3DSA:1.10.10.60:FF:000841', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147655, NULL, 'G3DSA:3.90.650.10:FF:000012', NULL, NULL, 'Thiamine-monophosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(147656, NULL, 'G3DSA:1.20.1560.10:FF:000005', NULL, NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 9', NULL, NULL, NULL, NULL, NULL, 4),
(147657, NULL, 'G3DSA:1.10.20.10:FF:000259', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147658, NULL, 'G3DSA:2.100.10.30:FF:000005', NULL, NULL, 'Demilune cell and parotid protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(147659, NULL, 'G3DSA:2.10.25.10:FF:001246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147660, NULL, 'G3DSA:1.20.140.140:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147661, NULL, 'G3DSA:3.30.160.60:FF:004376', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(147662, NULL, 'G3DSA:2.130.10.10:FF:005776', NULL, NULL, 'Bromodomain and WD repeat-containing DDB_G0285837', NULL, NULL, NULL, NULL, NULL, 4),
(147663, NULL, 'G3DSA:2.10.110.10:FF:000230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147664, NULL, 'G3DSA:3.30.160.60:FF:005180', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147665, NULL, 'G3DSA:2.70.150.10:FF:000073', NULL, NULL, 'P-type ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(147666, NULL, 'G3DSA:3.50.50.60:FF:000371', NULL, NULL, 'FAD-dependent monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(147667, NULL, 'G3DSA:1.10.10.60:FF:000638', NULL, NULL, 'Sigma-54-dependent Fis family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(147668, NULL, 'G3DSA:3.90.950.10:FF:000029', NULL, NULL, 'Maf-like protein yhdE', NULL, NULL, NULL, NULL, NULL, 4),
(147669, NULL, 'G3DSA:3.30.200.20:FF:000815', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(147670, NULL, 'G3DSA:1.20.1250.20:FF:002036', NULL, NULL, 'Os04g0679000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(147671, NULL, 'G3DSA:4.10.1240.10:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147672, NULL, 'G3DSA:1.25.40.10:FF:000772', NULL, NULL, 'Tetratricopeptide repeat/TPR repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(147673, NULL, 'G3DSA:2.30.30.100:FF:000013', NULL, NULL, 'Small nuclear ribonucleoprotein E', NULL, NULL, NULL, NULL, NULL, 4),
(147674, NULL, 'G3DSA:2.170.270.10:FF:000142', NULL, NULL, 'SET domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(147675, NULL, 'G3DSA:3.30.830.10:FF:000080', NULL, NULL, 'Pitrilysin-like metalloprotease', NULL, NULL, NULL, NULL, NULL, 4),
(147676, NULL, 'G3DSA:2.130.10.10:FF:003977', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(147677, NULL, 'G3DSA:3.30.160.60:FF:001138', NULL, NULL, 'zinc finger protein 407 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(147678, NULL, 'G3DSA:3.50.7.10:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147679, NULL, 'G3DSA:1.20.1280.290:FF:000014', NULL, NULL, 'Bidirectional sugar transporter SWEET', NULL, NULL, NULL, NULL, NULL, 4),
(147680, NULL, 'G3DSA:3.40.50.150:FF:000841', NULL, NULL, 'Cephalosporin hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(147681, NULL, 'G3DSA:3.30.200.20:FF:001996', NULL, NULL, 'Probable serine/threonine-protein kinase ndrA', NULL, NULL, NULL, NULL, NULL, 4),
(147682, NULL, 'G3DSA:1.10.510.10:FF:002922', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 4-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(147683, NULL, 'G3DSA:2.60.40.790:FF:000209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147684, NULL, 'G3DSA:3.30.70.330:FF:000715', NULL, NULL, 'Eukaryotic translation initiation factor 4Bb', NULL, NULL, NULL, NULL, NULL, 4),
(147685, NULL, 'G3DSA:1.10.238.10:FF:001114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147686, NULL, 'G3DSA:1.20.120.80:FF:000005', NULL, NULL, 'Cytochrome C oxidase subunit III', NULL, NULL, NULL, NULL, NULL, 4),
(147687, NULL, 'G3DSA:3.90.70.80:FF:000022', NULL, NULL, 'OTU2p protein', NULL, NULL, NULL, NULL, NULL, 4),
(147688, NULL, 'G3DSA:3.80.10.10:FF:003820', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147689, NULL, 'G3DSA:1.10.510.10:FF:000197', NULL, NULL, 'LIM domain kinase 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(147690, NULL, 'G3DSA:3.60.20.40:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147691, NULL, 'G3DSA:1.10.10.60:FF:001004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147692, NULL, 'G3DSA:1.20.58.60:FF:000310', NULL, NULL, 'Spectrin beta chain, non-erythrocytic', NULL, NULL, NULL, NULL, NULL, 4),
(147693, NULL, 'G3DSA:1.10.10.60:FF:000386', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(147694, NULL, 'G3DSA:3.40.190.10:FF:000325', NULL, NULL, 'Membrane-bound lytic murein transglycosylase F', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(147695, NULL, 'G3DSA:3.40.50.2000:FF:000501', NULL, NULL, 'UDP-N-acetylglucosamine 2-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(147696, NULL, 'G3DSA:3.10.25.10:FF:000007', NULL, NULL, 'Methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(147697, NULL, 'G3DSA:3.30.450.20:FF:000204', NULL, NULL, 'Protein FimX', NULL, NULL, NULL, NULL, NULL, 4),
(147698, NULL, 'G3DSA:1.10.10.10:FF:000742', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(147699, NULL, 'G3DSA:1.10.8.750:FF:000001', NULL, NULL, 'Putative phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(147700, NULL, 'G3DSA:2.70.98.10:FF:000080', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(147701, NULL, 'G3DSA:2.10.110.10:FF:000140', NULL, NULL, 'Cysteine and glycine-rich protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(147702, NULL, 'G3DSA:3.90.360.10:FF:000001', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(147703, NULL, 'G3DSA:1.10.760.10:FF:000018', NULL, NULL, 'Cytochrome c1, heme protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(147704, NULL, 'G3DSA:3.40.30.10:FF:001119', NULL, NULL, 'Glutathione s-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(147705, NULL, 'G3DSA:2.130.10.10:FF:000543', NULL, NULL, 'WD repeat-containing protein 48 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(147706, NULL, 'G3DSA:1.10.510.10:FF:000539', NULL, NULL, 'eIF-2-alpha kinase GCN2', NULL, NULL, NULL, NULL, NULL, 4),
(147707, NULL, 'G3DSA:4.10.60.10:FF:000159', NULL, NULL, 'Terminal uridylyl transferase 4', NULL, NULL, NULL, NULL, NULL, 4),
(147708, NULL, 'G3DSA:3.90.120.10:FF:000017', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147709, NULL, 'G3DSA:3.40.50.2020:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147710, NULL, 'G3DSA:3.30.60.190:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147711, NULL, 'G3DSA:3.30.70.330:FF:000154', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(147712, NULL, 'G3DSA:3.40.640.10:FF:000433', NULL, NULL, 'Glutamine--scyllo-inositol transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(147713, NULL, 'G3DSA:1.25.40.10:FF:002329', NULL, NULL, 'Bardet-Biedl syndrome 4', NULL, NULL, NULL, NULL, NULL, 4),
(147714, NULL, 'G3DSA:3.40.50.1240:FF:000099', NULL, NULL, 'Uncharacterized protein At3g52155, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(147715, NULL, 'G3DSA:3.30.40.10:FF:001828', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147716, NULL, 'G3DSA:3.30.200.20:FF:001001', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(147717, NULL, 'G3DSA:3.30.310.50:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147718, NULL, 'G3DSA:3.90.1170.10:FF:000008', NULL, NULL, '50S ribosomal protein L10e', NULL, NULL, NULL, NULL, NULL, 4),
(147719, NULL, 'G3DSA:2.60.40.60:FF:000529', NULL, NULL, 'Dachsous cadherin-related 1a', NULL, NULL, NULL, NULL, NULL, 4),
(147720, NULL, 'G3DSA:2.60.40.10:FF:004943', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147721, NULL, 'G3DSA:3.40.50.300:FF:008468', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147722, NULL, 'G3DSA:2.60.40.60:FF:000771', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147723, NULL, 'G3DSA:3.30.70.330:FF:001699', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147724, NULL, 'G3DSA:1.25.10.10:FF:000944', NULL, NULL, 'Adaptin-related protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(147725, NULL, 'G3DSA:2.40.160.50:FF:000013', NULL, NULL, 'Putative Tob55', NULL, NULL, NULL, NULL, NULL, 4),
(147726, NULL, 'G3DSA:3.90.550.10:FF:000084', NULL, NULL, 'Glycosyltransferases', NULL, NULL, NULL, NULL, NULL, 4),
(147727, NULL, 'G3DSA:1.10.150.20:FF:000014', NULL, NULL, 'Polymerase (DNA directed), eta', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(147728, NULL, 'G3DSA:1.20.5.340:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147729, NULL, 'G3DSA:2.30.29.30:FF:000203', NULL, NULL, 'PH domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(147730, NULL, 'G3DSA:2.30.30.100:FF:000103', NULL, NULL, 'Bifunctional protein BirA: biotin operon repressor + biotin--[acetyl-CoA-carboxylase] synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(147731, NULL, 'G3DSA:2.60.210.10:FF:000035', NULL, NULL, 'TNF receptor-associated factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(147732, NULL, 'G3DSA:1.20.1070.10:FF:001884', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147733, NULL, 'G3DSA:2.40.30.10:FF:000341', NULL, NULL, 'Elongation factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(147734, NULL, 'G3DSA:1.10.10.60:FF:000167', NULL, NULL, 'Homeobox protein engrailed-like', NULL, NULL, NULL, NULL, NULL, 4),
(147735, NULL, 'G3DSA:3.40.47.10:FF:000118', NULL, NULL, '3-hydroxy-3-methylglutaryl coenzyme A synthase', NULL, NULL, NULL, NULL, NULL, 4),
(147736, NULL, 'G3DSA:1.10.10.10:FF:000433', NULL, NULL, 'DNA-binding protein RFX8-like isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(147737, NULL, 'G3DSA:3.40.50.720:FF:001546', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147738, NULL, 'G3DSA:1.25.10.10:FF:001220', NULL, NULL, 'SEC7-like guanine nucleotide exchange family protein', NULL, NULL, NULL, NULL, NULL, 4),
(147739, NULL, 'G3DSA:1.20.1070.10:FF:000030', NULL, NULL, 'trace amine-associated receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(147740, NULL, 'G3DSA:1.25.40.10:FF:001857', NULL, NULL, 'Coatomer subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(147741, NULL, 'G3DSA:3.40.50.2300:FF:001648', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147742, NULL, 'G3DSA:3.30.1370.10:FF:000026', NULL, NULL, 'Insulin-like growth factor 2 mRNA-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(147743, NULL, 'G3DSA:3.40.35.10:FF:000001', NULL, NULL, 'PTS system mannose-specific EIIAB component', NULL, NULL, NULL, NULL, NULL, 4),
(147744, NULL, 'G3DSA:3.40.50.150:FF:000970', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147745, NULL, 'G3DSA:3.90.79.10:FF:000274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147746, NULL, 'G3DSA:3.30.160.60:FF:002920', NULL, NULL, 'Hunchback-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(147747, NULL, 'G3DSA:3.40.50.300:FF:004871', NULL, NULL, 'YALI0E32857p', NULL, NULL, NULL, NULL, NULL, 4),
(147748, NULL, 'G3DSA:3.40.50.10810:FF:000075', NULL, NULL, 'Protein CHROMATIN REMODELING 5', NULL, NULL, NULL, NULL, NULL, 4),
(147749, NULL, 'G3DSA:3.90.1150.10:FF:000232', NULL, NULL, 'Aminotransferase class III-fold pyridoxal phosphate-dependent enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(147750, NULL, 'G3DSA:3.40.140.10:FF:000176', NULL, NULL, 'COP9 signalosome subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(147751, NULL, 'G3DSA:3.40.390.10:FF:000200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147752, NULL, 'G3DSA:2.60.40.10:FF:004691', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147753, NULL, 'G3DSA:3.40.50.300:FF:004629', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(147754, NULL, 'G3DSA:2.40.50.730:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147755, NULL, 'G3DSA:2.60.120.40:FF:000060', NULL, NULL, 'Multimerin 2', NULL, NULL, NULL, NULL, NULL, 4),
(147756, NULL, 'G3DSA:2.120.10.80:FF:000244', NULL, NULL, 'Acyl-CoA-binding domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(147757, NULL, 'G3DSA:3.30.1640.10:FF:000019', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(147758, NULL, 'G3DSA:1.20.5.1700:FF:000012', NULL, NULL, 'Zgc:111960 protein', NULL, NULL, NULL, NULL, NULL, 4),
(147759, NULL, 'G3DSA:1.20.5.1160:FF:000030', NULL, NULL, 'Keratin, type I cytoskeletal 20', NULL, NULL, NULL, NULL, NULL, 4),
(147760, NULL, 'G3DSA:2.130.10.10:FF:004449', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(147761, NULL, 'G3DSA:2.130.10.10:FF:000852', NULL, NULL, 'Chromatin assembly factor 1 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(147762, NULL, 'G3DSA:3.30.200.20:FF:002053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147763, NULL, 'G3DSA:3.30.40.10:FF:002071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147764, NULL, 'G3DSA:3.30.160.60:FF:000885', NULL, NULL, 'Zinc finger protein 691', NULL, NULL, NULL, NULL, NULL, 4),
(147765, NULL, 'G3DSA:3.20.180.20:FF:000023', NULL, NULL, 'Dynein gamma chain, flagellar outer arm', NULL, NULL, NULL, NULL, NULL, 4),
(147766, NULL, 'G3DSA:3.40.50.300:FF:000829', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(147767, NULL, 'G3DSA:2.60.40.10:FF:004163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147768, NULL, 'G3DSA:3.40.640.10:FF:000523', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147769, NULL, 'G3DSA:3.40.50.720:FF:000152', NULL, NULL, 'Aspartate-semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(147770, NULL, 'G3DSA:1.20.1720.10:FF:000102', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147771, NULL, 'G3DSA:2.60.40.1360:FF:000018', NULL, NULL, 'Lysosomal alpha-mannosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(147772, NULL, 'G3DSA:3.40.50.720:FF:001911', NULL, NULL, 'UDP galactopyranose mutase', NULL, NULL, NULL, NULL, NULL, 4),
(147773, NULL, 'G3DSA:3.90.550.10:FF:000393', NULL, NULL, 'Glycoside transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(147774, NULL, 'G3DSA:2.60.40.10:FF:004382', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147775, NULL, 'G3DSA:4.10.860.10:FF:000020', NULL, NULL, 'GM12568', NULL, NULL, NULL, NULL, NULL, 4),
(147776, NULL, 'G3DSA:3.10.390.10:FF:000004', NULL, NULL, 'Deformed epidermal autoregulatory factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(147777, NULL, 'G3DSA:3.80.10.10:FF:001656', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147778, NULL, 'G3DSA:3.40.50.720:FF:000129', NULL, NULL, 'D-mannonate oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(147779, NULL, 'G3DSA:3.30.200.20:FF:001777', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147780, NULL, 'G3DSA:3.40.50.720:FF:000461', NULL, NULL, 'Putative Dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(147781, NULL, 'G3DSA:1.10.472.100:FF:000002', NULL, NULL, 'Presenilin', NULL, NULL, NULL, NULL, NULL, 4),
(147782, NULL, 'G3DSA:3.30.70.20:FF:000024', NULL, NULL, 'Ferredoxin-type protein NapF', NULL, NULL, NULL, NULL, NULL, 4),
(147783, NULL, 'G3DSA:3.30.450.190:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147784, NULL, 'G3DSA:1.10.150.20:FF:000233', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(147785, NULL, 'G3DSA:1.10.472.10:FF:000540', NULL, NULL, 'Cdk activating kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(147786, NULL, 'G3DSA:1.10.287.110:FF:000459', NULL, NULL, 'Chaperone protein DnaJ 1', NULL, NULL, NULL, NULL, NULL, 4),
(147787, NULL, 'G3DSA:1.10.150.530:FF:000024', NULL, NULL, 'Probable dual-specificity RNA methyltransferase RlmN', NULL, NULL, NULL, NULL, NULL, 4),
(147788, NULL, 'G3DSA:2.130.10.10:FF:000178', NULL, NULL, 'WD repeat domain 3', NULL, NULL, NULL, NULL, NULL, 4),
(147789, NULL, 'G3DSA:3.30.1240.10:FF:000022', NULL, NULL, 'Haloacid dehalogenase-like hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(147790, NULL, 'G3DSA:1.25.40.980:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147791, NULL, 'G3DSA:1.10.150.20:FF:000323', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147792, NULL, 'G3DSA:2.60.40.10:FF:004472', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147793, NULL, 'G3DSA:1.10.238.10:FF:000496', NULL, NULL, 'Light chain for Myo1p', NULL, NULL, NULL, NULL, NULL, 4),
(147794, NULL, 'G3DSA:2.60.40.10:FF:004724', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147795, NULL, 'G3DSA:3.50.50.60:FF:000039', NULL, NULL, 'Sulfide:quinone oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(147796, NULL, 'G3DSA:1.10.238.10:FF:000748', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(147797, NULL, 'G3DSA:3.30.565.10:FF:000159', NULL, NULL, 'Two-component system sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(147798, NULL, 'G3DSA:3.10.110.10:FF:000355', NULL, NULL, 'Ubiquitin protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(147799, NULL, 'G3DSA:3.50.50.60:FF:000590', NULL, NULL, 'Flavocytochrome c', NULL, NULL, NULL, NULL, NULL, 4),
(147800, NULL, 'G3DSA:2.60.40.60:FF:000439', NULL, NULL, 'Dachsous, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(147801, NULL, 'G3DSA:3.30.428.10:FF:000043', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147802, NULL, 'G3DSA:3.30.565.10:FF:000491', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147803, NULL, 'G3DSA:3.30.160.60:FF:000666', NULL, NULL, 'RB-associated KRAB zinc finger protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(147804, NULL, 'G3DSA:3.10.20.90:FF:000677', NULL, NULL, 'UBX domain-containing protein 11-like', NULL, NULL, NULL, NULL, NULL, 4),
(147805, NULL, 'G3DSA:3.30.160.60:FF:004685', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147806, NULL, 'G3DSA:1.10.472.10:FF:000450', NULL, NULL, 'Cyclin-H', NULL, NULL, NULL, NULL, NULL, 4),
(147807, NULL, 'G3DSA:3.80.10.10:FF:001908', NULL, NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(147808, NULL, 'G3DSA:3.50.50.60:FF:000281', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(147809, NULL, 'G3DSA:1.10.510.10:FF:000758', NULL, NULL, 'Probable serine/threonine-protein kinase DDB_G0292350', NULL, NULL, NULL, NULL, NULL, 4),
(147810, NULL, 'G3DSA:2.60.40.640:FF:000069', NULL, NULL, 'Arrestin domain-containing protein B', NULL, NULL, NULL, NULL, NULL, 4),
(147811, NULL, 'G3DSA:3.10.260.20:FF:000003', NULL, NULL, 'SKI family transcriptional corepressor 1 homolog-B-like', NULL, NULL, NULL, NULL, NULL, 4),
(147812, NULL, 'G3DSA:3.30.160.60:FF:001251', NULL, NULL, 'zinc finger and BTB domain-containing protein 38', NULL, NULL, NULL, NULL, NULL, 4),
(147813, NULL, 'G3DSA:1.20.58.1780:FF:000007', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(147814, NULL, 'G3DSA:3.80.10.10:FF:001566', NULL, NULL, 'NACHT, LRR and PYD domains-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(147815, NULL, 'G3DSA:1.25.40.180:FF:000301', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147816, NULL, 'G3DSA:3.40.350.10:FF:000080', NULL, NULL, 'Creatinase', NULL, NULL, NULL, NULL, NULL, 4),
(147817, NULL, 'G3DSA:2.60.40.60:FF:000990', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147818, NULL, 'G3DSA:1.20.1290.10:FF:000012', NULL, NULL, 'Sestrin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(147819, NULL, 'G3DSA:3.90.1150.10:FF:000451', NULL, NULL, 'Aspartate aminotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(147820, NULL, 'G3DSA:1.20.1540.10:FF:000026', NULL, NULL, 'Rhomboid-like protein 14, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(147821, NULL, 'G3DSA:2.10.10.20:FF:000001', NULL, NULL, 'Secreted chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(147822, NULL, 'G3DSA:3.40.50.150:FF:000751', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase G', NULL, NULL, NULL, NULL, NULL, 4),
(147823, NULL, 'G3DSA:1.10.1070.20:FF:000001', NULL, NULL, 'Serine/threonine-protein kinase toxin HipA', NULL, NULL, NULL, NULL, NULL, 4),
(147824, NULL, 'G3DSA:3.10.20.90:FF:000986', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147825, NULL, 'G3DSA:1.10.760.10:FF:000041', NULL, NULL, 'Cytochrome c peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(147826, NULL, 'G3DSA:1.10.3970.10:FF:000005', NULL, NULL, 'BSD domain-containing protein C22A12.14c', NULL, NULL, NULL, NULL, NULL, 4),
(147827, NULL, 'G3DSA:3.80.10.10:FF:003910', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(147828, NULL, 'G3DSA:1.10.20.10:FF:000349', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147829, NULL, 'G3DSA:3.30.160.60:FF:000975', NULL, NULL, 'PLAG1 like zinc finger 2', NULL, NULL, NULL, NULL, NULL, 4),
(147830, NULL, 'G3DSA:3.40.50.150:FF:000509', NULL, NULL, 'Probable dna methylase', NULL, NULL, NULL, NULL, NULL, 4),
(147831, NULL, 'G3DSA:2.60.120.260:FF:000352', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147832, NULL, 'G3DSA:2.30.29.30:FF:001395', NULL, NULL, 'FERM domain-containing protein B', NULL, NULL, NULL, NULL, NULL, 4),
(147833, NULL, 'G3DSA:1.20.1070.10:FF:001446', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147834, NULL, 'G3DSA:1.10.150.20:FF:000104', NULL, NULL, 'Unplaced genomic scaffold supercont1.24, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(147835, NULL, 'G3DSA:1.10.510.10:FF:004255', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147836, NULL, 'G3DSA:1.20.58.390:FF:000284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147837, NULL, 'G3DSA:3.30.710.10:FF:000233', NULL, NULL, 'Bric-a-brac', NULL, NULL, NULL, NULL, NULL, 4),
(147838, NULL, 'G3DSA:1.10.8.490:FF:000001', NULL, NULL, 'Cell death protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(147839, NULL, 'G3DSA:3.90.1170.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147840, NULL, 'G3DSA:2.130.10.10:FF:001133', NULL, NULL, 'WD40 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(147841, NULL, 'G3DSA:3.80.20.20:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147842, NULL, 'G3DSA:1.10.287.110:FF:000448', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147843, NULL, 'G3DSA:3.30.70.330:FF:000940', NULL, NULL, 'Putative polypyrimidine tract binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(147844, NULL, 'G3DSA:2.60.40.60:FF:001030', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147845, NULL, 'G3DSA:3.30.420.40:FF:000916', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147846, NULL, 'G3DSA:3.40.50.150:FF:001133', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147847, NULL, 'G3DSA:1.20.5.340:FF:000090', NULL, NULL, 'Viral A-type inclusion protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(147848, NULL, 'G3DSA:3.40.140.10:FF:000272', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147849, NULL, 'G3DSA:2.60.40.10:FF:002678', NULL, NULL, 'Putative Defective proboscis extension response', NULL, NULL, NULL, NULL, NULL, 4),
(147850, NULL, 'G3DSA:3.60.15.10:FF:000055', NULL, NULL, 'Cleavage and polyadenylation specificity factor protein', NULL, NULL, NULL, NULL, NULL, 4),
(147851, NULL, 'G3DSA:3.20.20.80:FF:000011', NULL, NULL, 'Cytosolic beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(147852, NULL, 'G3DSA:2.40.70.10:FF:000545', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147853, NULL, 'G3DSA:1.10.8.710:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147854, NULL, 'G3DSA:3.30.160.60:FF:005888', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147855, NULL, 'G3DSA:3.30.160.60:FF:006394', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147856, NULL, 'G3DSA:2.130.10.10:FF:004359', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147857, NULL, 'G3DSA:3.30.200.20:FF:000692', NULL, NULL, 'CAMK/CAMK1 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(147858, NULL, 'G3DSA:1.10.510.10:FF:000556', NULL, NULL, 'Lymphokine-activated killer T-cell-originated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(147859, NULL, 'G3DSA:3.40.50.150:FF:000627', NULL, NULL, 'Amine N-MethylTransferase', NULL, NULL, NULL, NULL, NULL, 4),
(147860, NULL, 'G3DSA:1.20.120.1200:FF:000022', NULL, NULL, 'NADH-ubiquinone oxidoreductase chain 6', NULL, NULL, NULL, NULL, NULL, 4),
(147861, NULL, 'G3DSA:2.30.30.560:FF:000005', NULL, NULL, 'Major vault protein-like protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(147862, NULL, 'G3DSA:3.30.230.10:FF:000191', NULL, NULL, 'DNA repair protein RadA', NULL, NULL, NULL, NULL, NULL, 4),
(147863, NULL, 'G3DSA:2.30.30.550:FF:000002', NULL, NULL, 'Major vault protein', NULL, NULL, NULL, NULL, NULL, 4),
(147864, NULL, 'G3DSA:3.40.830.10:FF:000009', NULL, NULL, '4,5-DOPA dioxygenase extradiol-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(147865, NULL, 'G3DSA:2.60.120.1000:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147866, NULL, 'G3DSA:1.25.40.10:FF:002554', NULL, NULL, 'Tetratricopeptide repeat protein 21B', NULL, NULL, NULL, NULL, NULL, 4),
(147867, NULL, 'G3DSA:1.10.1370.30:FF:000038', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(147868, NULL, 'G3DSA:3.30.230.10:FF:000202', NULL, NULL, 'Type 2 DNA topoisomerase 6 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(147869, NULL, 'G3DSA:3.80.20.20:FF:000092', NULL, NULL, 'Meiotic expression up-regulated protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(147870, NULL, 'G3DSA:3.30.160.60:FF:006405', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147871, NULL, 'G3DSA:1.25.40.10:FF:003982', NULL, NULL, 'Tetratricopeptide repeat protein 10, tpr10, putative', NULL, NULL, NULL, NULL, NULL, 4),
(147872, NULL, 'G3DSA:3.90.1510.10:FF:000001', NULL, NULL, 'Glycerate kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(147873, NULL, 'G3DSA:1.10.730.10:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147874, NULL, 'G3DSA:3.30.160.60:FF:000992', NULL, NULL, 'Zinc finger protein 320', NULL, NULL, NULL, NULL, NULL, 4),
(147875, NULL, 'G3DSA:3.30.497.10:FF:000017', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(147876, NULL, 'G3DSA:2.130.10.10:FF:004910', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147877, NULL, 'G3DSA:2.40.160.50:FF:000024', NULL, NULL, 'ShlB family hemolysin secretion/activation protein', NULL, NULL, NULL, NULL, NULL, 4),
(147878, NULL, 'G3DSA:1.25.40.20:FF:001360', NULL, NULL, 'DNA-binding protein rfxank, putative', NULL, NULL, NULL, NULL, NULL, 4),
(147879, NULL, 'G3DSA:3.40.850.10:FF:000123', NULL, NULL, 'Putative kinesin', NULL, NULL, NULL, NULL, NULL, 4),
(147880, NULL, 'G3DSA:2.60.40.10:FF:004932', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147881, NULL, 'G3DSA:3.30.420.40:FF:000821', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(147882, NULL, 'G3DSA:2.30.30.100:FF:000002', NULL, NULL, 'Small nuclear ribonucleoprotein Sm D3', NULL, NULL, NULL, NULL, NULL, 4),
(147883, NULL, 'G3DSA:1.10.1370.10:FF:000032', NULL, NULL, 'Metalloprotease', NULL, NULL, NULL, NULL, NULL, 4),
(147884, NULL, 'G3DSA:1.20.1250.20:FF:001547', NULL, NULL, 'Major facilitator superfamily domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(147885, NULL, 'G3DSA:1.10.1600.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147886, NULL, 'G3DSA:1.10.238.10:FF:000956', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147887, NULL, 'G3DSA:1.10.10.60:FF:000184', NULL, NULL, 'Chromodomain helicase DNA binding protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(147888, NULL, 'G3DSA:1.10.8.270:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147889, NULL, 'G3DSA:2.40.50.140:FF:000156', NULL, NULL, 'DNA-directed RNA polymerase II subunit', NULL, NULL, NULL, NULL, NULL, 4),
(147890, NULL, 'G3DSA:3.30.450.190:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147891, NULL, 'G3DSA:2.40.100.10:FF:000048', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(147892, NULL, 'G3DSA:2.40.33.40:FF:000002', NULL, NULL, 'Hypothetical PTS enzyme III glucitol', NULL, NULL, NULL, NULL, NULL, 4),
(147893, NULL, 'G3DSA:3.80.10.10:FF:003680', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147894, NULL, 'G3DSA:3.90.470.10:FF:000009', NULL, NULL, '39S ribosomal protein L22, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(147895, NULL, 'G3DSA:3.80.10.10:FF:003354', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147896, NULL, 'G3DSA:2.120.10.80:FF:000148', NULL, NULL, 'Muskelin, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(147897, NULL, 'G3DSA:1.20.120.180:FF:000001', NULL, NULL, 'Proteasome activator complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(147898, NULL, 'G3DSA:2.40.30.10:FF:000099', NULL, NULL, 'NADPH-dependent diflavin oxidoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(147899, NULL, 'G3DSA:2.40.30.10:FF:000436', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147900, NULL, 'G3DSA:2.60.40.420:FF:000104', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147901, NULL, 'G3DSA:3.30.160.60:FF:006489', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147902, NULL, 'G3DSA:3.40.640.10:FF:000309', NULL, NULL, 'Histidinol-phosphate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(147903, NULL, 'G3DSA:3.30.530.20:FF:000138', NULL, NULL, 'Phosphatidylinositol transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(147904, NULL, 'G3DSA:3.10.20.90:FF:000885', NULL, NULL, 'LOC563577 protein', NULL, NULL, NULL, NULL, NULL, 4),
(147905, NULL, 'G3DSA:1.25.10.10:FF:002631', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147906, NULL, 'G3DSA:3.30.160.60:FF:005303', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147907, NULL, 'G3DSA:3.20.20.70:FF:000379', NULL, NULL, 'Related to tRNA dihydrouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(147908, NULL, 'G3DSA:3.60.21.10:FF:000468', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(147909, NULL, 'G3DSA:1.25.10.10:FF:000377', NULL, NULL, 'Polyubiquitin binding protein (Doa1/Ufd3)', NULL, NULL, NULL, NULL, NULL, 4),
(147910, NULL, 'G3DSA:2.30.180.10:FF:000095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147911, NULL, 'G3DSA:3.20.80.10:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147912, NULL, 'G3DSA:2.170.140.10:FF:000014', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(147913, NULL, 'G3DSA:3.30.40.10:FF:002082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147914, NULL, 'G3DSA:2.130.10.10:FF:002656', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147915, NULL, 'G3DSA:1.10.20.10:FF:000248', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147916, NULL, 'G3DSA:1.10.8.60:FF:000559', NULL, NULL, 'AFR371Wp', NULL, NULL, NULL, NULL, NULL, 4),
(147917, NULL, 'G3DSA:3.40.50.300:FF:004186', NULL, NULL, 'RAS-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(147918, NULL, 'G3DSA:1.20.120.350:FF:000193', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147919, NULL, 'G3DSA:3.40.50.1000:FF:000634', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147920, NULL, 'G3DSA:1.20.1250.20:FF:000024', NULL, NULL, 'Nitrite extrusion protein NarK', NULL, NULL, NULL, NULL, NULL, 4),
(147921, NULL, 'G3DSA:3.40.50.1820:FF:001268', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(147922, NULL, 'G3DSA:2.40.50.730:FF:000024', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(147923, NULL, 'G3DSA:2.60.40.10:FF:000554', NULL, NULL, 'collagen alpha-1(XII) chain isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(147924, NULL, 'G3DSA:1.25.40.180:FF:000200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147925, NULL, 'G3DSA:1.10.10.10:FF:000646', NULL, NULL, 'Transcriptional regulator, AsnC family', NULL, NULL, NULL, NULL, NULL, 4),
(147926, NULL, 'G3DSA:3.40.50.300:FF:000487', NULL, NULL, 'Formate--tetrahydrofolate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(147927, NULL, 'G3DSA:3.40.50.300:FF:002948', NULL, NULL, 'DNA replication ATP-dependent helicase/nuclease DNA2', NULL, NULL, NULL, NULL, NULL, 4),
(147928, NULL, 'G3DSA:1.10.150.20:FF:000093', NULL, NULL, 'Holliday junction ATP-dependent DNA helicase RuvA', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(147929, NULL, 'G3DSA:3.30.200.20:FF:001794', NULL, NULL, 'MRLK6', NULL, NULL, NULL, NULL, NULL, 4),
(147930, NULL, 'G3DSA:2.120.10.80:FF:000362', NULL, NULL, 'Acyl-CoA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(147931, NULL, 'G3DSA:2.40.70.10:FF:000219', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147932, NULL, 'G3DSA:1.20.1250.10:FF:000021', NULL, NULL, 'Granulocyte colony-stimulating factor', NULL, NULL, NULL, NULL, NULL, 4),
(147933, NULL, 'G3DSA:3.40.50.300:FF:008564', NULL, NULL, 'Mating factor M secretion protein mam1', NULL, NULL, NULL, NULL, NULL, 4),
(147934, NULL, 'G3DSA:2.70.160.11:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147935, NULL, 'G3DSA:1.20.5.420:FF:000006', NULL, NULL, 'Minichromosome maintenance 10 replication initiation factor', NULL, NULL, NULL, NULL, NULL, 4),
(147936, NULL, 'G3DSA:3.40.50.300:FF:007041', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147937, NULL, 'G3DSA:1.25.10.10:FF:000714', NULL, NULL, 'Nipped-B protein', NULL, NULL, NULL, NULL, NULL, 4),
(147938, NULL, 'G3DSA:1.20.144.10:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147939, NULL, 'G3DSA:2.40.160.210:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147940, NULL, 'G3DSA:1.10.510.10:FF:002905', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147941, NULL, 'G3DSA:3.30.750.70:FF:000006', NULL, NULL, '4-hydroxybutyrate CoA transferase', NULL, NULL, NULL, NULL, NULL, 4),
(147942, NULL, 'G3DSA:3.10.110.10:FF:000366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147943, NULL, 'G3DSA:2.130.10.10:FF:002982', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147944, NULL, 'G3DSA:3.40.140.10:FF:000058', NULL, NULL, 'Phage tail protein', NULL, NULL, NULL, NULL, NULL, 4),
(147945, NULL, 'G3DSA:1.25.40.10:FF:000216', NULL, NULL, 'MAU2 chromatid cohesion factor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(147946, NULL, 'G3DSA:2.130.10.10:FF:000195', NULL, NULL, 'Zinc finger protein 106', NULL, NULL, NULL, NULL, NULL, 4),
(147947, NULL, 'G3DSA:2.70.98.110:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147948, NULL, 'G3DSA:3.30.428.10:FF:000026', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(147949, NULL, 'G3DSA:3.30.40.10:FF:001576', NULL, NULL, 'Ubiquitin conjugating enzyme interacting protein, putative (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(147950, NULL, 'G3DSA:3.40.50.2300:FF:000125', NULL, NULL, 'Vomeronasal 2, receptor 88', NULL, NULL, NULL, NULL, NULL, 4),
(147951, NULL, 'G3DSA:3.40.50.2300:FF:000237', NULL, NULL, 'Arsenate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(147952, NULL, 'G3DSA:1.10.238.10:FF:000277', NULL, NULL, 'Mitochondrial Rho GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(147953, NULL, 'G3DSA:2.10.110.10:FF:000235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147954, NULL, 'G3DSA:2.60.40.150:FF:000361', NULL, NULL, 'C2 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(147955, NULL, 'G3DSA:2.10.110.10:FF:000123', NULL, NULL, 'Rho GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(147956, NULL, 'G3DSA:3.30.310.80:FF:000004', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(147957, NULL, 'G3DSA:2.30.30.40:FF:000524', NULL, NULL, 'Si:ch211-25d12.7', NULL, NULL, NULL, NULL, NULL, 4),
(147958, NULL, 'G3DSA:2.60.40.10:FF:002892', NULL, NULL, 'Alpha-1-B glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(147959, NULL, 'G3DSA:3.30.40.10:FF:001688', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147960, NULL, 'G3DSA:3.30.40.10:FF:000070', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(147961, NULL, 'G3DSA:2.60.40.60:FF:000299', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147962, NULL, 'G3DSA:2.60.120.260:FF:000138', NULL, NULL, 'Probable beta-galactosidase B', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(147963, NULL, 'G3DSA:3.80.10.10:FF:001437', NULL, NULL, 'Toll-4', NULL, NULL, NULL, NULL, NULL, 4),
(147964, NULL, 'G3DSA:3.40.50.1100:FF:000097', NULL, NULL, 'L-serine ammonia-lyase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(147965, NULL, 'G3DSA:2.130.10.10:FF:002561', NULL, NULL, 'RIC1 homolog, RAB6A GEF complex partner 1', NULL, NULL, NULL, NULL, NULL, 4),
(147966, NULL, 'G3DSA:3.20.20.100:FF:000010', NULL, NULL, 'NADPH-dependent aldo-keto reductase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(147967, NULL, 'G3DSA:1.10.287.1080:FF:000009', NULL, NULL, 'Nucleotide pyrophosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(147968, NULL, 'G3DSA:2.60.120.260:FF:000026', NULL, NULL, 'proprotein convertase subtilisin/kexin type 7', NULL, NULL, NULL, NULL, NULL, 4),
(147969, NULL, 'G3DSA:2.30.30.110:FF:000005', NULL, NULL, 'Endoribonuclease toxin ChpB', NULL, NULL, NULL, NULL, NULL, 4),
(147970, NULL, 'G3DSA:2.30.29.30:FF:001069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147971, NULL, 'G3DSA:3.40.30.10:FF:000844', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(147972, NULL, 'G3DSA:1.20.1250.20:FF:000350', NULL, NULL, 'Putative MFS superfamily transporter', NULL, NULL, NULL, NULL, NULL, 4),
(147973, NULL, 'G3DSA:3.40.33.10:FF:000188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147974, NULL, 'G3DSA:3.40.50.300:FF:006552', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147975, NULL, 'G3DSA:3.40.50.300:FF:002741', NULL, NULL, 'Cms1 ribosomal small subunit homolog', NULL, NULL, NULL, NULL, NULL, 4),
(147976, NULL, 'G3DSA:3.30.465.10:FF:000112', NULL, NULL, 'Isoamyl alcohol oxidase, putative (AFU_orthologue AFUA_1G01180)', NULL, NULL, NULL, NULL, NULL, 4),
(147977, NULL, 'G3DSA:1.10.150.240:FF:000038', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(147978, NULL, 'G3DSA:2.30.30.100:FF:000114', NULL, NULL, 'Small nuclear ribonucleoprotein G', NULL, NULL, NULL, NULL, NULL, 4),
(147979, NULL, 'G3DSA:3.90.1660.10:FF:000001', NULL, NULL, 'Coenzyme F420:L-glutamate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(147980, NULL, 'G3DSA:1.25.10.10:FF:000591', NULL, NULL, 'Importin alpha re-exporter', NULL, NULL, NULL, NULL, NULL, 4),
(147981, NULL, 'G3DSA:3.30.70.1600:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147982, NULL, 'G3DSA:1.25.40.10:FF:000093', NULL, NULL, 'cell division cycle protein 23 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(147983, NULL, 'G3DSA:1.20.140.20:FF:000011', NULL, NULL, '[Pyruvate dehydrogenase (acetyl-transferring)] kinase isozyme 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(147984, NULL, 'G3DSA:3.30.460.10:FF:000011', NULL, NULL, 'interleukin enhancer-binding factor 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(147985, NULL, 'G3DSA:2.60.40.10:FF:003994', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147986, NULL, 'G3DSA:1.10.730.10:FF:000084', NULL, NULL, 'Leucyl-tRNA synthetase b', NULL, NULL, NULL, NULL, NULL, 4),
(147987, NULL, 'G3DSA:3.10.450.10:FF:000066', NULL, NULL, 'Cystatin domain-containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(147988, NULL, 'G3DSA:3.40.50.150:FF:000953', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(147989, NULL, 'G3DSA:3.40.50.720:FF:001675', NULL, NULL, 'Erythronate-4-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(147990, NULL, 'G3DSA:1.25.10.10:FF:002743', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147991, NULL, 'G3DSA:1.10.10.60:FF:000296', NULL, NULL, 'Scarecrow, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(147992, NULL, 'G3DSA:3.30.830.10:FF:000068', NULL, NULL, 'Cytochrome b-c1 complex subunit 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(147993, NULL, 'G3DSA:1.20.58.1040:FF:000005', NULL, NULL, '1,3-beta-glucanosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(147994, NULL, 'G3DSA:2.60.40.150:FF:000456', NULL, NULL, 'SYTF', NULL, NULL, NULL, NULL, NULL, 4),
(147995, NULL, 'G3DSA:2.130.10.10:FF:000318', NULL, NULL, 'WD repeat-containing protein pop3', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(147996, NULL, 'G3DSA:3.40.50.300:FF:008238', NULL, NULL, 'Small nuclear ribonucleoprotein, U5 200kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(147997, NULL, 'G3DSA:3.30.200.20:FF:002406', NULL, NULL, 'Inactive serine/threonine-protein kinase/endoribonuclease IRE1-like', NULL, NULL, NULL, NULL, NULL, 4),
(147998, NULL, 'G3DSA:2.60.120.330:FF:000188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(147999, NULL, 'G3DSA:4.10.410.10:FF:000088', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(148000, NULL, 'G3DSA:3.30.160.60:FF:004365', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148001, NULL, 'G3DSA:3.20.140.10:FF:000023', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(148002, NULL, 'G3DSA:1.10.3290.10:FF:000009', NULL, NULL, 'Protein adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(148003, NULL, 'G3DSA:3.30.460.20:FF:000014', NULL, NULL, 'Magnesium and cobalt transporter CorA', NULL, NULL, NULL, NULL, NULL, 4),
(148004, NULL, 'G3DSA:1.10.472.10:FF:000337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148005, NULL, 'G3DSA:2.20.70.10:FF:000260', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(148006, NULL, 'G3DSA:1.20.1070.10:FF:000035', NULL, NULL, 'C-C chemokine receptor type 6', NULL, NULL, NULL, NULL, NULL, 4),
(148007, NULL, 'G3DSA:2.40.30.130:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148008, NULL, 'G3DSA:3.40.50.300:FF:004298', NULL, NULL, 'ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148009, NULL, 'G3DSA:1.20.140.40:FF:000017', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(148010, NULL, 'G3DSA:1.20.58.1030:FF:000002', NULL, NULL, 'DNA replication complex GINS protein SLD5', NULL, NULL, NULL, NULL, NULL, 4),
(148011, NULL, 'G3DSA:2.40.50.140:FF:000044', NULL, NULL, '26S protease regulatory subunit 8', NULL, NULL, NULL, NULL, NULL, 4),
(148012, NULL, 'G3DSA:3.90.1410.10:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148013, NULL, 'G3DSA:3.40.190.10:FF:000095', NULL, NULL, 'Lactotransferrin', NULL, NULL, NULL, NULL, NULL, 4),
(148014, NULL, 'G3DSA:2.30.30.40:FF:000619', NULL, NULL, 'Rho GTPase-activating protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(148015, NULL, 'G3DSA:3.90.70.10:FF:000737', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148016, NULL, 'G3DSA:3.40.50.300:FF:002836', NULL, NULL, 'ATP-dependent Clp protease ATP-binding subunit ClpX', NULL, NULL, NULL, NULL, NULL, 4),
(148017, NULL, 'G3DSA:1.10.510.10:FF:002810', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148018, NULL, 'G3DSA:3.40.50.10810:FF:000215', NULL, NULL, 'Protein CBG05712', NULL, NULL, NULL, NULL, NULL, 4),
(148019, NULL, 'G3DSA:1.10.10.10:FF:000534', NULL, NULL, 'Metallo-hydrolase/oxidoreductase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(148020, NULL, 'G3DSA:3.20.180.20:FF:000040', NULL, NULL, 'Dynein heavy chain 4', NULL, NULL, NULL, NULL, NULL, 4),
(148021, NULL, 'G3DSA:3.30.260.10:FF:000030', NULL, NULL, 'Probable CCT6-component of chaperonin-containing T-complex (Zeta subunit)', NULL, NULL, NULL, NULL, NULL, 4),
(148022, NULL, 'G3DSA:2.70.170.10:FF:000063', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(148023, NULL, 'G3DSA:1.25.40.990:FF:000016', NULL, NULL, 'Si:zfos-452g4.1', NULL, NULL, NULL, NULL, NULL, 4),
(148024, NULL, 'G3DSA:1.25.40.10:FF:004920', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148025, NULL, 'G3DSA:3.90.1150.10:FF:000131', NULL, NULL, 'Glycine dehydrogenase [decarboxylating], mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(148026, NULL, 'G3DSA:1.10.287.830:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148027, NULL, 'G3DSA:3.40.50.1820:FF:001835', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(148028, NULL, 'G3DSA:1.10.533.10:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(148029, NULL, 'G3DSA:2.140.10.10:FF:000003', NULL, NULL, 'Methanol dehydrogenase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(148030, NULL, 'G3DSA:1.10.1450.10:FF:000084', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(148031, NULL, 'G3DSA:3.30.460.20:FF:000031', NULL, NULL, 'Putative metal ion transporter C27B12.12c', NULL, NULL, NULL, NULL, NULL, 4),
(148032, NULL, 'G3DSA:3.30.2070.10:FF:000003', NULL, NULL, 'Formate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(148033, NULL, 'G3DSA:3.30.710.10:FF:000121', NULL, NULL, 'BTB/POZ domain-containing protein KCTD11', NULL, NULL, NULL, NULL, NULL, 4),
(148034, NULL, 'G3DSA:1.10.275.40:FF:000017', NULL, NULL, 'Nucleotide excision repair protein ERCC2', NULL, NULL, NULL, NULL, NULL, 4),
(148035, NULL, 'G3DSA:3.100.10.10:FF:000012', NULL, NULL, 'Mitochondrial ribosomal protein L15', NULL, NULL, NULL, NULL, NULL, 4),
(148036, NULL, 'G3DSA:2.60.40.60:FF:000866', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148037, NULL, 'G3DSA:1.10.10.10:FF:000293', NULL, NULL, 'Tigger transposable element-derived protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(148038, NULL, 'G3DSA:2.60.120.260:FF:000240', NULL, NULL, 'Probable E3 ubiquitin-protein ligase HERC2', NULL, NULL, NULL, NULL, NULL, 4),
(148039, NULL, 'G3DSA:3.30.1490.100:FF:000008', NULL, NULL, 'DNA polymerase V subunit', NULL, NULL, NULL, NULL, NULL, 4),
(148040, NULL, 'G3DSA:1.10.510.10:FF:004367', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148041, NULL, 'G3DSA:2.60.40.1170:FF:000063', NULL, NULL, 'AdaPtin, Mu/medium chain (Clathrin associated complex)', NULL, NULL, NULL, NULL, NULL, 4),
(148042, NULL, 'G3DSA:2.60.40.60:FF:001142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148043, NULL, 'G3DSA:3.90.550.10:FF:000292', NULL, NULL, 'Family 2 glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(148044, NULL, 'G3DSA:2.60.260.20:FF:000108', NULL, NULL, 'Cobalamin ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(148045, NULL, 'G3DSA:1.10.10.60:FF:000307', NULL, NULL, 'Eyegone, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(148046, NULL, 'G3DSA:3.80.10.10:FF:003707', NULL, NULL, 'Putative leucine-rich repeat-containing protein DDB_G0281931', NULL, NULL, NULL, NULL, NULL, 4),
(148047, NULL, 'G3DSA:2.30.42.10:FF:000306', NULL, NULL, 'GRASP65 homolog protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(148048, NULL, 'G3DSA:3.30.870.10:FF:000177', NULL, NULL, 'Mitochondrial cardiolipin hydrolase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(148049, NULL, 'G3DSA:1.10.287.980:FF:000001', NULL, NULL, 'Cytochrome b6-f complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(148050, NULL, 'G3DSA:2.10.25.10:FF:001667', NULL, NULL, 'Eosinophil peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(148051, NULL, 'G3DSA:3.30.70.3290:FF:000008', NULL, NULL, 'Yersiniabactin polyketide/non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(148052, NULL, 'G3DSA:3.30.565.10:FF:000064', NULL, NULL, 'Phytochrome', NULL, NULL, NULL, NULL, NULL, 4),
(148053, NULL, 'G3DSA:1.10.110.10:FF:000008', NULL, NULL, 'BnaCnng36210D protein', NULL, NULL, NULL, NULL, NULL, 4),
(148054, NULL, 'G3DSA:2.170.120.12:FF:000015', NULL, NULL, 'DNA-directed RNA polymerase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(148055, NULL, 'G3DSA:2.130.10.130:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148056, NULL, 'G3DSA:3.40.190.10:FF:000662', NULL, NULL, 'Bacterial extracellular solute-binding protein, family 5', NULL, NULL, NULL, NULL, NULL, 4),
(148057, NULL, 'G3DSA:1.10.287.690:FF:000021', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(148058, NULL, 'G3DSA:2.60.40.1180:FF:000066', NULL, NULL, 'Alpha,alpha-phosphotrehalase', NULL, NULL, NULL, NULL, NULL, 4),
(148059, NULL, 'G3DSA:3.30.540.10:FF:000080', NULL, NULL, 'Ammonium transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(148060, NULL, 'G3DSA:1.10.357.10:FF:000019', NULL, NULL, 'LuxR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(148061, NULL, 'G3DSA:1.20.120.1750:FF:000147', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(148062, NULL, 'G3DSA:3.10.450.50:FF:000050', NULL, NULL, 'Benzoate 1,2-dioxygenase small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(148063, NULL, 'G3DSA:3.30.200.20:FF:001917', NULL, NULL, 'Ribosomal protein S6 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(148064, NULL, 'G3DSA:1.20.5.1160:FF:000041', NULL, NULL, 'Neurofilament heavy polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(148065, NULL, 'G3DSA:2.60.40.10:FF:006068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148066, NULL, 'G3DSA:2.30.30.850:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148067, NULL, 'G3DSA:2.40.110.10:FF:000088', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(148068, NULL, 'G3DSA:1.20.82.10:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148069, NULL, 'G3DSA:2.130.10.10:FF:003050', NULL, NULL, 'WD-40 repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(148070, NULL, 'G3DSA:3.20.140.10:FF:000040', NULL, NULL, 'NAPRTase', NULL, NULL, NULL, NULL, NULL, 4),
(148071, NULL, 'G3DSA:3.40.50.720:FF:002501', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148072, NULL, 'G3DSA:1.10.3720.10:FF:000189', NULL, NULL, 'ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(148073, NULL, 'G3DSA:2.130.10.10:FF:000644', NULL, NULL, 'Rrp9p', NULL, NULL, NULL, NULL, NULL, 4),
(148074, NULL, 'G3DSA:1.25.40.90:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148075, NULL, 'G3DSA:3.40.50.10190:FF:000299', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(148076, NULL, 'G3DSA:1.10.510.10:FF:000444', NULL, NULL, 'probable L-type lectin-domain containing receptor kinase S.5', NULL, NULL, NULL, NULL, NULL, 4),
(148077, NULL, 'G3DSA:3.30.420.10:FF:000014', NULL, NULL, 'Piwi-like RNA-mediated gene silencing 1', NULL, NULL, NULL, NULL, NULL, 4),
(148078, NULL, 'G3DSA:1.10.3460.10:FF:000040', NULL, NULL, 'Pt17531-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(148079, NULL, 'G3DSA:3.90.190.20:FF:000070', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(148080, NULL, 'G3DSA:1.20.1310.10:FF:000105', NULL, NULL, 'Protein CBG17039', NULL, NULL, NULL, NULL, NULL, 4),
(148081, NULL, 'G3DSA:3.40.630.10:FF:000258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148082, NULL, 'G3DSA:3.30.160.60:FF:000880', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(148083, NULL, 'G3DSA:1.50.40.10:FF:000484', NULL, NULL, 'mitochondrial dicarboxylate carrier-like', NULL, NULL, NULL, NULL, NULL, 4),
(148084, NULL, 'G3DSA:3.30.497.10:FF:000129', NULL, NULL, 'Serpin peptidase inhibitor, clade E (nexin, plasminogen activator inhibitor type 1), member 2', NULL, NULL, NULL, NULL, NULL, 4),
(148085, NULL, 'G3DSA:3.90.226.10:FF:000044', NULL, NULL, 'Retinol-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(148086, NULL, 'G3DSA:3.40.50.300:FF:006198', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(148087, NULL, 'G3DSA:3.40.50.300:FF:001313', NULL, NULL, 'Helicase with zinc finger domain 2', NULL, NULL, NULL, NULL, NULL, 4),
(148088, NULL, 'G3DSA:1.10.1660.10:FF:000021', NULL, NULL, 'Transcriptional regulator, MerR family', NULL, NULL, NULL, NULL, NULL, 4),
(148089, NULL, 'G3DSA:3.90.1150.10:FF:000243', NULL, NULL, 'Transcriptional regulator, GntR family', NULL, NULL, NULL, NULL, NULL, 4),
(148090, NULL, 'G3DSA:3.10.10.10:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148091, NULL, 'G3DSA:3.10.100.10:FF:000422', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148092, NULL, 'G3DSA:3.40.309.10:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148093, NULL, 'G3DSA:2.70.130.10:FF:000066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148094, NULL, 'G3DSA:1.10.150.20:FF:000121', NULL, NULL, 'DNA-directed RNA polymerase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(148095, NULL, 'G3DSA:2.60.40.10:FF:005888', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148096, NULL, 'G3DSA:3.40.50.720:FF:000601', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(148097, NULL, 'G3DSA:2.60.40.10:FF:001043', NULL, NULL, 'TAP binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(148098, NULL, 'G3DSA:3.20.20.100:FF:000122', NULL, NULL, 'L-galactose dehydrogenase isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(148099, NULL, 'G3DSA:3.40.50.1980:FF:000091', NULL, NULL, 'Periplasmic solute binding family protein', NULL, NULL, NULL, NULL, NULL, 4),
(148100, NULL, 'G3DSA:3.90.70.10:FF:000288', NULL, NULL, 'Gamete and mating-type specific protein A', NULL, NULL, NULL, NULL, NULL, 4),
(148101, NULL, 'G3DSA:1.10.3720.10:FF:000105', NULL, NULL, 'Lactose transport system permease protein LacF', NULL, NULL, NULL, NULL, NULL, 4),
(148102, NULL, 'G3DSA:3.30.40.10:FF:001593', NULL, NULL, 'PHd Finger family', NULL, NULL, NULL, NULL, NULL, 4),
(148103, NULL, 'G3DSA:1.10.12.70:FF:000005', NULL, NULL, 'Germinal center kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(148104, NULL, 'G3DSA:1.25.40.20:FF:001146', NULL, NULL, 'Putative E3 ubiquitin-protein ligase XBAT35', NULL, NULL, NULL, NULL, NULL, 4),
(148105, NULL, 'G3DSA:1.20.1050.10:FF:000040', NULL, NULL, 'chloride intracellular channel exc-4', NULL, NULL, NULL, NULL, NULL, 4),
(148106, NULL, 'G3DSA:3.30.60.20:FF:000068', NULL, NULL, 'Serine/threonine-protein kinase D2', NULL, NULL, NULL, NULL, NULL, 4),
(148107, NULL, 'G3DSA:3.30.160.60:FF:004477', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148108, NULL, 'G3DSA:3.30.200.20:FF:002069', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148109, NULL, 'G3DSA:3.90.550.10:FF:000533', NULL, NULL, 'Glycosyl transferase, group 2 family', NULL, NULL, NULL, NULL, NULL, 4),
(148110, NULL, 'G3DSA:2.60.40.10:FF:004039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148111, NULL, 'G3DSA:3.10.100.10:FF:000197', NULL, NULL, 'Adhesion G-protein coupled receptor D1', NULL, NULL, NULL, NULL, NULL, 4),
(148112, NULL, 'G3DSA:3.90.870.30:FF:000001', NULL, NULL, 'Carbamoyltransferase HypF', NULL, NULL, NULL, NULL, NULL, 4),
(148113, NULL, 'G3DSA:3.30.160.60:FF:000554', NULL, NULL, 'protein indeterminate-domain 12-like', NULL, NULL, NULL, NULL, NULL, 4),
(148114, NULL, 'G3DSA:2.130.10.10:FF:002218', NULL, NULL, 'AT18160p', NULL, NULL, NULL, NULL, NULL, 4),
(148115, NULL, 'G3DSA:3.40.50.300:FF:006338', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148116, NULL, 'G3DSA:1.10.472.10:FF:000107', NULL, NULL, 'Cyclin-D5-1', NULL, NULL, NULL, NULL, NULL, 4),
(148117, NULL, 'G3DSA:2.60.40.10:FF:002471', NULL, NULL, 'Os10g0200000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(148118, NULL, 'G3DSA:3.40.50.620:FF:000122', NULL, NULL, 'Glutamate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(148119, NULL, 'G3DSA:1.10.1170.10:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148120, NULL, 'G3DSA:2.30.42.10:FF:000402', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148121, NULL, 'G3DSA:3.20.20.80:FF:000123', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(148122, NULL, 'G3DSA:3.30.230.70:FF:000085', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(148123, NULL, 'G3DSA:2.60.200.20:FF:000088', NULL, NULL, 'PROBABLE CONSERVED TRANSMEMBRANE ATP-BINDING PROTEIN ABC TRANSPORTER', NULL, NULL, NULL, NULL, NULL, 4),
(148124, NULL, 'G3DSA:2.30.130.40:FF:000022', NULL, NULL, 'Lon protease', NULL, NULL, NULL, NULL, NULL, 4),
(148125, NULL, 'G3DSA:3.40.50.300:FF:002269', NULL, NULL, 'ABC transporter B family member 7', NULL, NULL, NULL, NULL, NULL, 4),
(148126, NULL, 'G3DSA:1.10.287.90:FF:000009', NULL, NULL, 'Cytochrome c oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(148127, NULL, 'G3DSA:3.80.20.20:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148128, NULL, 'G3DSA:1.10.287.70:FF:000003', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(148129, NULL, 'G3DSA:2.70.150.10:FF:000275', NULL, NULL, 'Cation-transporting ATPase 5', NULL, NULL, NULL, NULL, NULL, 4),
(148130, NULL, 'G3DSA:3.30.420.40:FF:000793', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148131, NULL, 'G3DSA:1.20.1540.10:FF:000010', NULL, NULL, 'Rhomboid-like protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(148132, NULL, 'G3DSA:4.10.640.40:FF:000001', NULL, NULL, 'Cytoplasmic polyadenylation element-binding 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(148133, NULL, 'G3DSA:2.130.10.10:FF:004573', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148134, NULL, 'G3DSA:3.30.450.40:FF:000295', NULL, NULL, 'Acetoin catabolism regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(148135, NULL, 'G3DSA:1.20.1270.60:FF:000003', NULL, NULL, 'arfaptin-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(148136, NULL, 'G3DSA:3.40.50.1820:FF:000071', NULL, NULL, 'Embryogenesis-associated protein EMB8', NULL, NULL, NULL, NULL, NULL, 4),
(148137, NULL, 'G3DSA:1.10.4100.10:FF:000002', NULL, NULL, 'Aconitate decarboxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(148138, NULL, 'G3DSA:1.10.287.80:FF:000006', NULL, NULL, 'ATP synthase gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(148139, NULL, 'G3DSA:1.20.5.1300:FF:000004', NULL, NULL, 'Histidinol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(148140, NULL, 'G3DSA:3.30.70.330:FF:000047', NULL, NULL, 'Differentiation 1 negative regulator', NULL, NULL, NULL, NULL, NULL, 4),
(148141, NULL, 'G3DSA:3.30.160.60:FF:001037', NULL, NULL, 'zinc finger protein 566 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(148142, NULL, 'G3DSA:3.40.50.300:FF:004753', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(148143, NULL, 'G3DSA:3.40.50.720:FF:000040', NULL, NULL, 'UDP-glucose 4-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(148144, NULL, 'G3DSA:1.25.40.10:FF:000328', NULL, NULL, 'protein CTR9 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(148145, NULL, 'G3DSA:3.40.50.1000:FF:000297', NULL, NULL, 'BnaAnng05460D protein', NULL, NULL, NULL, NULL, NULL, 4),
(148146, NULL, 'G3DSA:1.20.1250.20:FF:001452', NULL, NULL, 'Amino acid/peptide transporter', NULL, NULL, NULL, NULL, NULL, 4),
(148147, NULL, 'G3DSA:3.30.70.330:FF:000614', NULL, NULL, 'Mrp20p', NULL, NULL, NULL, NULL, NULL, 4),
(148148, NULL, 'G3DSA:3.10.110.10:FF:000254', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(148149, NULL, 'G3DSA:1.25.10.10:FF:003002', NULL, NULL, 'Tubulin-specific chaperone d', NULL, NULL, NULL, NULL, NULL, 4),
(148150, NULL, 'G3DSA:3.40.50.2000:FF:000254', NULL, NULL, 'Trehalose 6-P phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(148151, NULL, 'G3DSA:3.50.50.60:FF:000511', NULL, NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(148152, NULL, 'G3DSA:2.60.120.560:FF:000009', NULL, NULL, 'Beta-fructofuranosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148153, NULL, 'G3DSA:1.25.10.10:FF:002390', NULL, NULL, 'Nipped-B-like protein pqn-85', NULL, NULL, NULL, NULL, NULL, 4),
(148154, NULL, 'G3DSA:1.10.10.60:FF:000633', NULL, NULL, 'TCP pilus virulence regulatory protein ToxT', NULL, NULL, NULL, NULL, NULL, 4),
(148155, NULL, 'G3DSA:3.90.79.10:FF:000162', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(148156, NULL, 'G3DSA:3.40.50.720:FF:001658', NULL, NULL, 'Os06g0299200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(148157, NULL, 'G3DSA:1.25.10.10:FF:002726', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148158, NULL, 'G3DSA:1.10.418.10:FF:000049', NULL, NULL, 'Rho guanine nucleotide exchange factor 7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(148159, NULL, 'G3DSA:3.40.50.1820:FF:001509', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148160, NULL, 'G3DSA:1.25.40.10:FF:002228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148161, NULL, 'G3DSA:2.60.40.150:FF:000809', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(148162, NULL, 'G3DSA:1.25.10.10:FF:000826', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148163, NULL, 'G3DSA:2.30.29.30:FF:000321', NULL, NULL, 'Oxysterol-binding protein-related protein 1C', NULL, NULL, NULL, NULL, NULL, 4),
(148164, NULL, 'G3DSA:3.40.50.620:FF:000105', NULL, NULL, 'Isoleucine--tRNA ligase cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(148165, NULL, 'G3DSA:1.10.10.10:FF:000860', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(148166, NULL, 'G3DSA:1.25.40.10:FF:004257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148167, NULL, 'G3DSA:1.20.1310.10:FF:000189', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148168, NULL, 'G3DSA:1.10.287.80:FF:000023', NULL, NULL, 'ATP synthase gamma chain, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(148169, NULL, 'G3DSA:2.30.30.40:FF:000636', NULL, NULL, 'Si:dkey-40c11.2', NULL, NULL, NULL, NULL, NULL, 4),
(148170, NULL, 'G3DSA:3.30.200.20:FF:002165', NULL, NULL, 'Os11g0664100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(148171, NULL, 'G3DSA:3.30.1390.20:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148172, NULL, 'G3DSA:3.40.190.10:FF:000336', NULL, NULL, 'Unplaced genomic scaffold supercont1.18, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(148173, NULL, 'G3DSA:3.30.200.20:FF:000271', NULL, NULL, 'MAPK/MAK/MRK overlapping kinase', NULL, NULL, NULL, NULL, NULL, 4),
(148174, NULL, 'G3DSA:2.40.10.10:FF:000199', NULL, NULL, 'Trypsin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148175, NULL, 'G3DSA:3.30.160.60:FF:002448', NULL, NULL, 'Zinc finger protein 430', NULL, NULL, NULL, NULL, NULL, 4),
(148176, NULL, 'G3DSA:1.10.1170.10:FF:000034', NULL, NULL, 'X-linked inhibitor of apoptosis', NULL, NULL, NULL, NULL, NULL, 4),
(148177, NULL, 'G3DSA:1.10.287.90:FF:000026', NULL, NULL, 'Cytochrome c oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(148178, NULL, 'G3DSA:2.40.50.140:FF:000370', NULL, NULL, 'Eukaryotic translation initiation factor 1A', NULL, NULL, NULL, NULL, NULL, 4),
(148179, NULL, 'G3DSA:3.40.50.1980:FF:000118', NULL, NULL, 'Iron(III) dicitrate-binding periplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(148180, NULL, 'G3DSA:3.40.50.2300:FF:000142', NULL, NULL, 'Two-component system response regulator RstA', NULL, NULL, NULL, NULL, NULL, 4),
(148181, NULL, 'G3DSA:3.30.50.10:FF:000008', NULL, NULL, 'estrogen-related receptor gamma isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(148182, NULL, 'G3DSA:1.10.287.70:FF:000020', NULL, NULL, 'Potassium channel, voltage-gated eag-related subfamily H, member 7', NULL, NULL, NULL, NULL, NULL, 4),
(148183, NULL, 'G3DSA:1.10.10.60:FF:000279', NULL, NULL, 'Sugar-binding transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(148184, NULL, 'G3DSA:1.20.1070.10:FF:000361', NULL, NULL, 'Dopamine receptor D4', NULL, NULL, NULL, NULL, NULL, 4),
(148185, NULL, 'G3DSA:2.60.40.10:FF:004606', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148186, NULL, 'G3DSA:3.40.50.300:FF:002499', NULL, NULL, 'Deoxynucleotide monophosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(148187, NULL, 'G3DSA:1.20.1250.20:FF:001659', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148188, NULL, 'G3DSA:1.10.10.10:FF:000197', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(148189, NULL, 'G3DSA:1.10.1410.10:FF:000087', NULL, NULL, 'Nucleolar protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(148190, NULL, 'G3DSA:3.40.50.300:FF:000824', NULL, NULL, 'Iron ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(148191, NULL, 'G3DSA:3.40.50.10260:FF:000005', NULL, NULL, 'NAD(P)H-hydrate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(148192, NULL, 'G3DSA:3.30.70.330:FF:002205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148193, NULL, 'G3DSA:2.60.40.150:FF:000782', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148194, NULL, 'G3DSA:2.10.50.30:FF:000017', NULL, NULL, 'Vomeronasal 2 receptor, 31', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(148195, NULL, 'G3DSA:3.30.200.20:FF:001889', NULL, NULL, 'Proline-rich receptor-like protein kinase PERK1', NULL, NULL, NULL, NULL, NULL, 4),
(148196, NULL, 'G3DSA:2.160.10.10:FF:000047', NULL, NULL, 'Glucose-1-phosphate adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(148197, NULL, 'G3DSA:2.130.10.10:FF:005984', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148198, NULL, 'G3DSA:3.30.590.10:FF:000032', NULL, NULL, 'Glutamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(148199, NULL, 'G3DSA:3.30.70.330:FF:002301', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148200, NULL, 'G3DSA:3.30.160.60:FF:006377', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148201, NULL, 'G3DSA:1.20.120.1750:FF:000164', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(148202, NULL, 'G3DSA:1.10.510.10:FF:002782', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(148203, NULL, 'G3DSA:2.60.40.1180:FF:000049', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(148204, NULL, 'G3DSA:4.10.70.10:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148205, NULL, 'G3DSA:3.10.20.90:FF:000559', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148206, NULL, 'G3DSA:1.20.58.60:FF:000422', NULL, NULL, 'AGAP007562-PA', NULL, NULL, NULL, NULL, NULL, 4),
(148207, NULL, 'G3DSA:2.60.40.1170:FF:000046', NULL, NULL, 'AP-1 complex subunit mu-2', NULL, NULL, NULL, NULL, NULL, 4),
(148208, NULL, 'G3DSA:1.10.10.60:FF:001122', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148209, NULL, 'G3DSA:1.20.1070.10:FF:001463', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(148210, NULL, 'G3DSA:3.40.50.80:FF:000124', NULL, NULL, 'Ferric-chelate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(148211, NULL, 'G3DSA:3.90.230.10:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148212, NULL, 'G3DSA:3.40.30.10:FF:000389', NULL, NULL, 'Possible conserved membrane or secreted protein', NULL, NULL, NULL, NULL, NULL, 4),
(148213, NULL, 'G3DSA:3.40.50.150:FF:001116', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148214, NULL, 'G3DSA:2.10.25.10:FF:001460', NULL, NULL, 'Laminin subunit alpha-1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(148215, NULL, 'G3DSA:3.10.20.10:FF:000007', NULL, NULL, 'DNA fragmentation factor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(148216, NULL, 'G3DSA:2.120.10.80:FF:000036', NULL, NULL, 'Attractin like 1', NULL, NULL, NULL, NULL, NULL, 4),
(148217, NULL, 'G3DSA:1.25.10.10:FF:000265', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(148218, NULL, 'G3DSA:2.120.10.30:FF:000257', NULL, NULL, 'Sortilin-related receptor, L(DLR class) A repeats containing', NULL, NULL, NULL, NULL, NULL, 4),
(148219, NULL, 'G3DSA:2.60.40.10:FF:000880', NULL, NULL, 'Vascular endothelial growth factor receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(148220, NULL, 'G3DSA:2.40.70.10:FF:000096', NULL, NULL, 'Basic 7S globulin', NULL, NULL, NULL, NULL, NULL, 4),
(148221, NULL, 'G3DSA:3.30.40.10:FF:002205', NULL, NULL, 'E3 ubiquitin-protein ligase mind-bomb-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(148222, NULL, 'G3DSA:3.40.47.10:FF:000242', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148223, NULL, 'G3DSA:1.20.1250.20:FF:001098', NULL, NULL, 'Transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(148224, NULL, 'G3DSA:1.20.1280.50:FF:000187', NULL, NULL, 'F-box/WD repeat-containing protein 4-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(148225, NULL, 'G3DSA:1.10.8.710:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148226, NULL, 'G3DSA:3.40.50.880:FF:000060', NULL, NULL, 'Peptidase E', NULL, NULL, NULL, NULL, NULL, 4),
(148227, NULL, 'G3DSA:3.30.1370.10:FF:000150', NULL, NULL, 'Drosophila dodeca-satellite protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(148228, NULL, 'G3DSA:3.30.40.10:FF:000053', NULL, NULL, 'protein AF-10 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(148229, NULL, 'G3DSA:1.10.510.10:FF:000882', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 17', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(148230, NULL, 'G3DSA:3.30.40.10:FF:001929', NULL, NULL, 'MARCH (Membrane-Associated Ring finger (C3HC4)) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(148231, NULL, 'G3DSA:2.130.10.10:FF:002544', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(148232, NULL, 'G3DSA:1.10.8.720:FF:000037', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(148233, NULL, 'G3DSA:3.30.70.330:FF:002076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148234, NULL, 'G3DSA:3.30.450.20:FF:000412', NULL, NULL, 'Hybrid signal transduction histidine kinase B', NULL, NULL, NULL, NULL, NULL, 4),
(148235, NULL, 'G3DSA:3.40.30.10:FF:000827', NULL, NULL, 'Protein disulfide isomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(148236, NULL, 'G3DSA:2.70.170.10:FF:000287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148237, NULL, 'G3DSA:3.40.190.10:FF:000550', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(148238, NULL, 'G3DSA:1.10.10.10:FF:001023', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(148239, NULL, 'G3DSA:3.30.160.60:FF:004606', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148240, NULL, 'G3DSA:3.10.620.10:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148241, NULL, 'G3DSA:3.30.310.40:FF:000021', NULL, NULL, '8-oxoguanine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(148242, NULL, 'G3DSA:2.170.270.10:FF:000018', NULL, NULL, 'PR domain zinc finger protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(148243, NULL, 'G3DSA:3.30.160.60:FF:003988', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148244, NULL, 'G3DSA:3.90.70.10:FF:000075', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase creB', NULL, NULL, NULL, NULL, NULL, 4),
(148245, NULL, 'G3DSA:3.30.390.50:FF:000028', NULL, NULL, 'Putative lipoate-protein ligase A', NULL, NULL, NULL, NULL, NULL, 4),
(148246, NULL, 'G3DSA:2.60.200.20:FF:000217', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(148247, NULL, 'G3DSA:3.90.180.10:FF:000021', NULL, NULL, 'Galactitol-1-phosphate 5-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(148248, NULL, 'G3DSA:3.30.70.20:FF:000119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148249, NULL, 'G3DSA:3.80.10.10:FF:002977', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148250, NULL, 'G3DSA:3.40.50.300:FF:004427', NULL, NULL, 'Small GTPase superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(148251, NULL, 'G3DSA:3.30.1370.50:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148252, NULL, 'G3DSA:3.30.160.360:FF:000008', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(148253, NULL, 'G3DSA:1.25.10.10:FF:002176', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(148254, NULL, 'G3DSA:3.30.420.40:FF:000580', NULL, NULL, 'Actin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148255, NULL, 'G3DSA:3.30.565.10:FF:000176', NULL, NULL, 'PAS domain-containing sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(148256, NULL, 'G3DSA:1.10.510.10:FF:002355', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148257, NULL, 'G3DSA:3.40.50.300:FF:001190', NULL, NULL, 'GTP-binding protein ERG', NULL, NULL, NULL, NULL, NULL, 4),
(148258, NULL, 'G3DSA:1.10.150.570:FF:000002', NULL, NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme GidA', NULL, NULL, NULL, NULL, NULL, 4),
(148259, NULL, 'G3DSA:3.30.160.60:FF:000762', NULL, NULL, 'Zinc finger and BTB domain-containing 14', NULL, NULL, NULL, NULL, NULL, 4),
(148260, NULL, 'G3DSA:1.10.10.440:FF:000069', NULL, NULL, 'WW domain-containing protein ZK1098.1', NULL, NULL, NULL, NULL, NULL, 4),
(148261, NULL, 'G3DSA:3.40.50.2300:FF:001199', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148262, NULL, 'G3DSA:3.20.20.70:FF:000828', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148263, NULL, 'G3DSA:2.60.40.150:FF:000810', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(148264, NULL, 'G3DSA:1.10.10.10:FF:002119', NULL, NULL, 'Uncharacterized HTH-type transcriptional regulator HI_0224', NULL, NULL, NULL, NULL, NULL, 4),
(148265, NULL, 'G3DSA:1.10.472.10:FF:000225', NULL, NULL, 'CyCliN K', NULL, NULL, NULL, NULL, NULL, 4),
(148266, NULL, 'G3DSA:3.30.40.10:FF:000620', NULL, NULL, 'Tripartite motif-containing 38, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(148267, NULL, 'G3DSA:3.30.470.30:FF:000080', NULL, NULL, 'mRNA-capping enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(148268, NULL, 'G3DSA:2.60.40.1360:FF:000013', NULL, NULL, 'Alpha-mannosidase C', NULL, NULL, NULL, NULL, NULL, 4),
(148269, NULL, 'G3DSA:1.10.760.10:FF:000035', NULL, NULL, 'Cytochrome C Snr1', NULL, NULL, NULL, NULL, NULL, 4),
(148270, NULL, 'G3DSA:1.25.40.20:FF:000657', NULL, NULL, 'Ankyrin repeat and SOCS box-containing 2b', NULL, NULL, NULL, NULL, NULL, 4),
(148271, NULL, 'G3DSA:2.30.29.30:FF:000107', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type 13', NULL, NULL, NULL, NULL, NULL, 4),
(148272, NULL, 'G3DSA:1.20.1110.10:FF:000096', NULL, NULL, 'Na+/K+ ATPase alpha subunit isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(148273, NULL, 'G3DSA:1.20.140.90:FF:000004', NULL, NULL, 'Malonyl-CoA decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(148274, NULL, 'G3DSA:1.20.1070.10:FF:000153', NULL, NULL, 'Neuropeptide FF receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(148275, NULL, 'G3DSA:3.80.10.10:FF:003578', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148276, NULL, 'G3DSA:2.130.10.10:FF:000857', NULL, NULL, 'WD-40 repeat-containing protein MSI4', NULL, NULL, NULL, NULL, NULL, 4),
(148277, NULL, 'G3DSA:2.60.40.1210:FF:000002', NULL, NULL, 'MOXD1 homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(148278, NULL, 'G3DSA:2.130.10.10:FF:000756', NULL, NULL, 'striatin-4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(148279, NULL, 'G3DSA:3.40.50.2000:FF:000703', NULL, NULL, 'Phosphatidylinositol N-acetylglucosaminyltransferase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(148280, NULL, 'G3DSA:3.40.190.10:FF:000123', NULL, NULL, 'HIS1p ATP phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(148281, NULL, 'G3DSA:1.20.1250.20:FF:001901', NULL, NULL, 'Protein NRT1/ PTR FAMILY 8.3', NULL, NULL, NULL, NULL, NULL, 4),
(148282, NULL, 'G3DSA:2.40.50.140:FF:000605', NULL, NULL, 'Ribosomal protein S12 methylthiotransferase RimO', NULL, NULL, NULL, NULL, NULL, 4),
(148283, NULL, 'G3DSA:1.20.1560.10:FF:000117', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(148284, NULL, 'G3DSA:2.70.20.10:FF:000013', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(148285, NULL, 'G3DSA:6.20.10.30:FF:000005', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(148286, NULL, 'G3DSA:3.50.50.60:FF:000056', NULL, NULL, 'Dihydropyrimidine dehydrogenase [NADP(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(148287, NULL, 'G3DSA:1.20.1250.20:FF:001890', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148288, NULL, 'G3DSA:1.20.140.80:FF:000001', NULL, NULL, 'Transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(148289, NULL, 'G3DSA:1.10.238.180:FF:000004', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(148290, NULL, 'G3DSA:2.60.40.60:FF:000754', NULL, NULL, 'Hedgehog protein', NULL, NULL, NULL, NULL, NULL, 4),
(148291, NULL, 'G3DSA:1.25.10.10:FF:001080', NULL, NULL, 'Armadillo repeat only 4', NULL, NULL, NULL, NULL, NULL, 4),
(148292, NULL, 'G3DSA:3.40.630.10:FF:000146', NULL, NULL, 'Peptidase M28', NULL, NULL, NULL, NULL, NULL, 4),
(148293, NULL, 'G3DSA:1.10.10.60:FF:000846', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148294, NULL, 'G3DSA:3.40.50.1820:FF:000200', NULL, NULL, 'Serine protease 16', NULL, NULL, NULL, NULL, NULL, 4),
(148295, NULL, 'G3DSA:3.40.50.300:FF:001201', NULL, NULL, 'ATP-dependent DNA helicase UvrD2', NULL, NULL, NULL, NULL, NULL, 4),
(148296, NULL, 'G3DSA:1.10.510.10:FF:003979', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148297, NULL, 'G3DSA:3.90.226.10:FF:000252', NULL, NULL, 'Methylcrotonoyl-CoA carboxylase beta chain, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(148298, NULL, 'G3DSA:3.30.360.10:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148299, NULL, 'G3DSA:2.60.120.200:FF:000250', NULL, NULL, 'Fat-like cadherin-related tumor suppressor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(148300, NULL, 'G3DSA:1.20.58.1780:FF:000002', NULL, NULL, 'Nuclear pore complex protein NUP155', NULL, NULL, NULL, NULL, NULL, 4),
(148301, NULL, 'G3DSA:3.40.630.10:FF:000466', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148302, NULL, 'G3DSA:2.30.30.30:FF:000066', NULL, NULL, '60S ribosomal protein L14, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148303, NULL, 'G3DSA:1.10.1820.10:FF:000011', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(148304, NULL, 'G3DSA:2.30.30.40:FF:000069', NULL, NULL, 'MAGUK p55 subfamily member 6', NULL, NULL, NULL, NULL, NULL, 4),
(148305, NULL, 'G3DSA:2.60.40.60:FF:000653', NULL, NULL, 'Cadherin-89D', NULL, NULL, NULL, NULL, NULL, 4),
(148306, NULL, 'G3DSA:2.60.200.20:FF:000116', NULL, NULL, 'Forkhead-associated (FHA) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(148307, NULL, 'G3DSA:3.30.160.60:FF:002791', NULL, NULL, 'zinc finger protein 672', NULL, NULL, NULL, NULL, NULL, 4),
(148308, NULL, 'G3DSA:3.30.70.1450:FF:000035', NULL, NULL, 'Glutathione-regulated potassium-efflux system protein', NULL, NULL, NULL, NULL, NULL, 4),
(148309, NULL, 'G3DSA:2.60.40.60:FF:000327', NULL, NULL, 'Protocadherin beta-17', NULL, NULL, NULL, NULL, NULL, 4),
(148310, NULL, 'G3DSA:3.30.70.330:FF:000491', NULL, NULL, 'protein alan shepard isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(148311, NULL, 'G3DSA:3.40.50.720:FF:000135', NULL, NULL, 'UDP-glucuronic acid decarboxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(148312, NULL, 'G3DSA:2.130.10.10:FF:004135', NULL, NULL, 'LLGL scribble cell polarity complex component 2', NULL, NULL, NULL, NULL, NULL, 4),
(148313, NULL, 'G3DSA:1.20.58.2010:FF:000004', NULL, NULL, 'Rop guanine nucleotide exchange factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(148314, NULL, 'G3DSA:1.10.3720.10:FF:000077', NULL, NULL, 'Sugar ABC transporter, permease protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148315, NULL, 'G3DSA:3.30.519.10:FF:000013', NULL, NULL, 'GDP dissociation inhibitor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148316, NULL, 'G3DSA:3.40.50.11320:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148317, NULL, 'G3DSA:3.40.50.10810:FF:000092', NULL, NULL, 'Protein CHROMATIN REMODELING 4', NULL, NULL, NULL, NULL, NULL, 4),
(148318, NULL, 'G3DSA:2.130.10.10:FF:004455', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148319, NULL, 'G3DSA:1.10.238.10:FF:000294', NULL, NULL, 'Calcyphosin', NULL, NULL, NULL, NULL, NULL, 4),
(148320, NULL, 'G3DSA:3.30.200.20:FF:002070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148321, NULL, 'G3DSA:2.30.29.30:FF:000208', NULL, NULL, 'Pleckstrin 2', NULL, NULL, NULL, NULL, NULL, 4),
(148322, NULL, 'G3DSA:2.60.120.200:FF:000036', NULL, NULL, 'Calsyntenin 1', NULL, NULL, NULL, NULL, NULL, 4),
(148323, NULL, 'G3DSA:2.70.40.10:FF:000008', NULL, NULL, 'Deoxyuridine 5''-triphosphate nucleotidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(148324, NULL, 'G3DSA:3.30.70.920:FF:000033', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(148325, NULL, 'G3DSA:3.80.10.10:FF:001454', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(148326, NULL, 'G3DSA:3.40.190.10:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148327, NULL, 'G3DSA:2.60.40.10:FF:004477', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148328, NULL, 'G3DSA:3.30.70.270:FF:000017', NULL, NULL, 'Predicted diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(148329, NULL, 'G3DSA:1.25.40.10:FF:000654', NULL, NULL, 'Calcineurin-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(148330, NULL, 'G3DSA:3.30.200.20:FF:000832', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(148331, NULL, 'G3DSA:3.40.50.1440:FF:000064', NULL, NULL, 'Delta tubulin', NULL, NULL, NULL, NULL, NULL, 4),
(148332, NULL, 'G3DSA:1.20.58.410:FF:000003', NULL, NULL, 'High chlorophyll fluorescent 109', NULL, NULL, NULL, NULL, NULL, 4),
(148333, NULL, 'G3DSA:3.90.930.12:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148334, NULL, 'G3DSA:3.40.50.300:FF:005141', NULL, NULL, 'ATP-binding cassette transporter, subfamily G, member 28, group WBC protein PpABCG28', NULL, NULL, NULL, NULL, NULL, 4),
(148335, NULL, 'G3DSA:1.10.533.10:FF:000249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148336, NULL, 'G3DSA:1.10.510.10:FF:002456', NULL, NULL, 'Probable serine/threonine-protein kinase fnkB', NULL, NULL, NULL, NULL, NULL, 4),
(148337, NULL, 'G3DSA:3.60.20.10:FF:000022', NULL, NULL, 'Proteasome subunit alpha type', NULL, NULL, NULL, NULL, NULL, 4),
(148338, NULL, 'G3DSA:3.30.870.10:FF:000059', NULL, NULL, 'Cardiolipin synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148339, NULL, 'G3DSA:2.60.40.10:FF:004157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148340, NULL, 'G3DSA:2.160.20.10:FF:000087', NULL, NULL, 'GG17321', NULL, NULL, NULL, NULL, NULL, 4),
(148341, NULL, 'G3DSA:3.40.640.10:FF:000074', NULL, NULL, 'Aromatic amino acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(148342, NULL, 'G3DSA:3.40.50.300:FF:002724', NULL, NULL, 'HAlF transporter (PGP related)', NULL, NULL, NULL, NULL, NULL, 4),
(148343, NULL, 'G3DSA:3.40.50.1820:FF:001723', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148344, NULL, 'G3DSA:3.40.50.300:FF:000583', NULL, NULL, 'Adenylate kinase isoenzyme 5', NULL, NULL, NULL, NULL, NULL, 4),
(148345, NULL, 'G3DSA:2.120.10.30:FF:000049', NULL, NULL, 'LDL receptor related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(148346, NULL, 'G3DSA:3.80.10.10:FF:001881', NULL, NULL, 'AGAP009688-PA', NULL, NULL, NULL, NULL, NULL, 4),
(148347, NULL, 'G3DSA:3.80.10.10:FF:003915', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase GSO1', NULL, NULL, NULL, NULL, NULL, 4),
(148348, NULL, 'G3DSA:3.10.110.10:FF:000248', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(148349, NULL, 'G3DSA:2.40.160.110:FF:000005', NULL, NULL, 'Lysosome-associated membrane glycoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(148350, NULL, 'G3DSA:3.80.10.10:FF:000144', NULL, NULL, 'F-box and leucine-rich repeat protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(148351, NULL, 'G3DSA:3.30.910.20:FF:000010', NULL, NULL, 'Outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(148352, NULL, 'G3DSA:3.30.750.24:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148353, NULL, 'G3DSA:3.30.160.60:FF:005320', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148354, NULL, 'G3DSA:3.40.50.10470:FF:000068', NULL, NULL, 'Initiation factor 2 subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148355, NULL, 'G3DSA:1.25.10.10:FF:003114', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(148356, NULL, 'G3DSA:3.40.350.10:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148357, NULL, 'G3DSA:3.80.10.10:FF:003803', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148358, NULL, 'G3DSA:3.30.70.330:FF:000502', NULL, NULL, 'Pre-mRNA-splicing factor cwc2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148359, NULL, 'G3DSA:3.40.50.300:FF:006765', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148360, NULL, 'G3DSA:3.10.390.10:FF:000010', NULL, NULL, 'CBN-TAG-347 protein', NULL, NULL, NULL, NULL, NULL, 4),
(148361, NULL, 'G3DSA:1.10.1410.10:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148362, NULL, 'G3DSA:1.20.930.80:FF:000005', NULL, NULL, 'DNA primase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(148363, NULL, 'G3DSA:3.90.550.10:FF:000078', NULL, NULL, 'glycosyltransferase 8 domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(148364, NULL, 'G3DSA:3.40.50.20:FF:000022', NULL, NULL, 'Formate-dependent phosphoribosylglycinamide formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(148365, NULL, 'G3DSA:3.30.160.60:FF:004932', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148366, NULL, 'G3DSA:1.10.238.10:FF:000389', NULL, NULL, 'Flagellar pocket-related cytoskeletal protein', NULL, NULL, NULL, NULL, NULL, 4),
(148367, NULL, 'G3DSA:3.40.50.1000:FF:000185', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(148368, NULL, 'G3DSA:1.20.144.10:FF:000023', NULL, NULL, 'Lipid phosphate phosphatase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(148369, NULL, 'G3DSA:1.10.220.150:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148370, NULL, 'G3DSA:1.10.150.20:FF:000008', NULL, NULL, 'DNA repair protein RAD51 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(148371, NULL, 'G3DSA:1.10.472.10:FF:000433', NULL, NULL, 'YALI0C13926p', NULL, NULL, NULL, NULL, NULL, 4),
(148372, NULL, 'G3DSA:3.90.1100.10:FF:000066', NULL, NULL, 'DNA polymerase epsilon catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(148373, NULL, 'G3DSA:1.20.120.810:FF:000004', NULL, NULL, 'Vinculin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(148374, NULL, 'G3DSA:3.30.160.60:FF:000649', NULL, NULL, 'Zinc finger protein 710', NULL, NULL, NULL, NULL, NULL, 4),
(148375, NULL, 'G3DSA:3.90.70.10:FF:000855', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148376, NULL, 'G3DSA:3.30.160.60:FF:006490', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148377, NULL, 'G3DSA:3.40.50.1910:FF:000013', NULL, NULL, 'Vacuolar sorting protein', NULL, NULL, NULL, NULL, NULL, 4),
(148378, NULL, 'G3DSA:3.40.50.970:FF:000182', NULL, NULL, '2-oxoglutarate dehydrogenase, E1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(148379, NULL, 'G3DSA:2.130.10.10:FF:004808', NULL, NULL, 'WD repeat-containing protein 41', NULL, NULL, NULL, NULL, NULL, 4),
(148380, NULL, 'G3DSA:2.40.160.120:FF:000008', NULL, NULL, 'Oxysterol binding protein (Osh1)', NULL, NULL, NULL, NULL, NULL, 4),
(148381, NULL, 'G3DSA:1.20.58.390:FF:000188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148382, NULL, 'G3DSA:3.10.20.340:FF:000005', NULL, NULL, 'Arginine biosynthesis bifunctional protein ArgJ', NULL, NULL, NULL, NULL, NULL, 4),
(148383, NULL, 'G3DSA:1.25.40.10:FF:004145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148384, NULL, 'G3DSA:1.10.238.10:FF:001007', NULL, NULL, 'Solute carrier family 25 (mitochondrial carrier; phosphate carrier), member 23a', NULL, NULL, NULL, NULL, NULL, 4),
(148385, NULL, 'G3DSA:3.10.450.50:FF:000049', NULL, NULL, 'Calcium/calmodulin dependent protein kinase II delta', NULL, NULL, NULL, NULL, NULL, 4),
(148386, NULL, 'G3DSA:3.30.160.60:FF:002678', NULL, NULL, 'Zinc finger protein 687', NULL, NULL, NULL, NULL, NULL, 4),
(148387, NULL, 'G3DSA:2.30.30.40:FF:000406', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(148388, NULL, 'G3DSA:1.10.490.10:FF:000031', NULL, NULL, 'Two-on-two hemoglobin-3', NULL, NULL, NULL, NULL, NULL, 4),
(148389, NULL, 'G3DSA:2.10.110.10:FF:000353', NULL, NULL, 'AGAP008979-PA', NULL, NULL, NULL, NULL, NULL, 4),
(148390, NULL, 'G3DSA:3.40.50.300:FF:000936', NULL, NULL, 'Arsenical pump-driving ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(148391, NULL, 'G3DSA:1.20.120.230:FF:000044', NULL, NULL, 'Talin', NULL, NULL, NULL, NULL, NULL, 4),
(148392, NULL, 'G3DSA:1.10.630.10:FF:000599', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148393, NULL, 'G3DSA:3.30.200.20:FF:002277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148394, NULL, 'G3DSA:1.20.1280.290:FF:000019', NULL, NULL, 'PQ-loop repeat family protein / transmembrane family protein', NULL, NULL, NULL, NULL, NULL, 4),
(148395, NULL, 'G3DSA:3.80.10.10:FF:001549', NULL, NULL, 'Si:ch211-76m11.5', NULL, NULL, NULL, NULL, NULL, 4),
(148396, NULL, 'G3DSA:3.10.180.10:FF:000073', NULL, NULL, '4-hydroxyphenylpyruvate dioxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(148397, NULL, 'G3DSA:3.30.420.40:FF:000467', NULL, NULL, 'Actin-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(148398, NULL, 'G3DSA:3.30.70.3400:FF:000008', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(148399, NULL, 'G3DSA:3.40.50.300:FF:006664', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148400, NULL, 'G3DSA:3.30.40.10:FF:000406', NULL, NULL, 'Transcription intermediary factor 1-beta', NULL, NULL, NULL, NULL, NULL, 4),
(148401, NULL, 'G3DSA:2.60.120.1030:FF:000009', NULL, NULL, 'mRNA cleavage and polyadenylation factor CLP1', NULL, NULL, NULL, NULL, NULL, 4),
(148402, NULL, 'G3DSA:3.20.20.300:FF:000064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148403, NULL, 'G3DSA:2.40.30.170:FF:000037', NULL, NULL, 'Efflux transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(148404, NULL, 'G3DSA:1.20.1540.10:FF:000009', NULL, NULL, 'Rhomboid domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(148405, NULL, 'G3DSA:3.30.390.110:FF:000013', NULL, NULL, 'Ribosomal L28e protein family', NULL, NULL, NULL, NULL, NULL, 4),
(148406, NULL, 'G3DSA:2.130.10.10:FF:002095', NULL, NULL, 'WGS project CAEQ00000000 data, annotated contig 84', NULL, NULL, NULL, NULL, NULL, 4),
(148407, NULL, 'G3DSA:3.90.1530.30:FF:000003', NULL, NULL, 'Putative ParB-like nuclease domain', NULL, NULL, NULL, NULL, NULL, 4),
(148408, NULL, 'G3DSA:3.40.50.720:FF:002046', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(148409, NULL, 'G3DSA:1.10.10.520:FF:000003', NULL, NULL, 'Ubiquitin-activating enzyme E1-like', NULL, NULL, NULL, NULL, NULL, 4),
(148410, NULL, 'G3DSA:3.40.50.300:FF:003230', NULL, NULL, 'Mismatch repair protein MSH3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148411, NULL, 'G3DSA:2.40.320.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148412, NULL, 'G3DSA:3.30.70.330:FF:002413', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148413, NULL, 'G3DSA:1.10.510.10:FF:003170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148414, NULL, 'G3DSA:3.40.50.1220:FF:000014', NULL, NULL, 'Acetolactate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(148415, NULL, 'G3DSA:3.40.190.10:FF:000903', NULL, NULL, 'Periplasmic substrate-binding histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(148416, NULL, 'G3DSA:3.90.940.10:FF:000001', NULL, NULL, 'DNA-directed RNA polymerase subunit omega', NULL, NULL, NULL, NULL, NULL, 4),
(148417, NULL, 'G3DSA:3.30.450.40:FF:000183', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(148418, NULL, 'G3DSA:1.20.58.860:FF:000003', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(148419, NULL, 'G3DSA:2.60.40.2030:FF:000012', NULL, NULL, 'Adhesion G-protein coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(148420, NULL, 'G3DSA:1.10.287.540:FF:000004', NULL, NULL, 'Calreticulin 3', NULL, NULL, NULL, NULL, NULL, 4),
(148421, NULL, 'G3DSA:3.90.1170.10:FF:000014', NULL, NULL, 'Apicoplast ribosomal protein L16', NULL, NULL, NULL, NULL, NULL, 4),
(148422, NULL, 'G3DSA:3.30.160.60:FF:002903', NULL, NULL, 'Protein CBR-SMA-9', NULL, NULL, NULL, NULL, NULL, 4),
(148423, NULL, 'G3DSA:2.40.170.20:FF:000084', NULL, NULL, 'Putative TonB-dependent outer membrane receptor protein', NULL, NULL, NULL, NULL, NULL, 4),
(148424, NULL, 'G3DSA:1.25.40.20:FF:000871', NULL, NULL, 'Ankyrin repeat and KH domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(148425, NULL, 'G3DSA:1.20.1310.10:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148426, NULL, 'G3DSA:2.60.120.1030:FF:000010', NULL, NULL, 'mRNA cleavage and polyadenylation factor CLP1', NULL, NULL, NULL, NULL, NULL, 4),
(148427, NULL, 'G3DSA:3.80.10.10:FF:004410', NULL, NULL, 'Leucine-rich repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(148428, NULL, 'G3DSA:3.30.70.330:FF:002531', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148429, NULL, 'G3DSA:3.40.1090.10:FF:000053', NULL, NULL, 'Lysophospholipase NTE1', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(148430, NULL, 'G3DSA:3.80.10.10:FF:003792', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148431, NULL, 'G3DSA:1.10.10.10:FF:000416', NULL, NULL, 'Vacuolar protein-sorting-associated protein 36', NULL, NULL, NULL, NULL, NULL, 4),
(148432, NULL, 'G3DSA:3.30.830.10:FF:000282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148433, NULL, 'G3DSA:2.10.25.10:FF:001780', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148434, NULL, 'G3DSA:3.40.630.10:FF:000360', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(148435, NULL, 'G3DSA:2.160.20.10:FF:000003', NULL, NULL, 'Pectin lyase F', NULL, NULL, NULL, NULL, NULL, 4),
(148436, NULL, 'G3DSA:1.25.10.10:FF:002277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148437, NULL, 'G3DSA:1.10.510.10:FF:003878', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148438, NULL, 'G3DSA:1.20.58.870:FF:000006', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(148439, NULL, 'G3DSA:2.130.10.10:FF:004247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148440, NULL, 'G3DSA:1.20.5.190:FF:000128', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148441, NULL, 'G3DSA:2.30.30.1190:FF:000002', NULL, NULL, 'probable E3 ubiquitin-protein ligase makorin-2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(148442, NULL, 'G3DSA:1.25.40.10:FF:004706', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148443, NULL, 'G3DSA:3.60.21.10:FF:000356', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148444, NULL, 'G3DSA:1.10.30.10:FF:000193', NULL, NULL, 'FACT complex subunit SSRP1', NULL, NULL, NULL, NULL, NULL, 4),
(148445, NULL, 'G3DSA:3.40.50.1000:FF:000746', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148446, NULL, 'G3DSA:1.20.1560.10:FF:000022', NULL, NULL, 'ATP-binding cassette sub-family B member 6, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(148447, NULL, 'G3DSA:2.60.40.10:FF:002807', NULL, NULL, 'Sensory AXon guidance', NULL, NULL, NULL, NULL, NULL, 4),
(148448, NULL, 'G3DSA:2.30.42.10:FF:000514', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148449, NULL, 'G3DSA:3.90.320.10:FF:000010', NULL, NULL, 'Exodeoxyribonuclease VIII', NULL, NULL, NULL, NULL, NULL, 4),
(148450, NULL, 'G3DSA:1.10.150.130:FF:000005', NULL, NULL, 'Prophage integrase IntS', NULL, NULL, NULL, NULL, NULL, 4),
(148451, NULL, 'G3DSA:1.20.58.160:FF:000001', NULL, NULL, 'TOM1-like protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(148452, NULL, 'G3DSA:3.40.50.720:FF:001771', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148453, NULL, 'G3DSA:4.10.860.10:FF:000003', NULL, NULL, 'YibL family ribosome-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(148454, NULL, 'G3DSA:2.40.180.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148455, NULL, 'G3DSA:1.25.40.10:FF:004027', NULL, NULL, 'Uncharacterized serine-rich protein C2F12.03c', NULL, NULL, NULL, NULL, NULL, 4),
(148456, NULL, 'G3DSA:1.10.260.40:FF:000101', NULL, NULL, 'Repressor protein cI', NULL, NULL, NULL, NULL, NULL, 4),
(148457, NULL, 'G3DSA:3.40.50.150:FF:000392', NULL, NULL, 'Protein-lysine N-methyltransferase Dere_GG24471', NULL, NULL, NULL, NULL, NULL, 4),
(148458, NULL, 'G3DSA:3.40.50.300:FF:003112', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(148459, NULL, 'G3DSA:3.40.50.300:FF:000375', NULL, NULL, 'Putative ATP-dependent RNA helicase DHX30', NULL, NULL, NULL, NULL, NULL, 4),
(148460, NULL, 'G3DSA:3.30.200.20:FF:000720', NULL, NULL, 'Protein kinase OspG', NULL, NULL, NULL, NULL, NULL, 4),
(148461, NULL, 'G3DSA:2.20.70.10:FF:000046', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(148462, NULL, 'G3DSA:3.10.110.10:FF:000153', NULL, NULL, 'eIF-2-alpha kinase GCN2', NULL, NULL, NULL, NULL, NULL, 4),
(148463, NULL, 'G3DSA:4.10.860.20:FF:000006', NULL, NULL, 'RABenoSyn (Trafficking protein) homolog', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(148464, NULL, 'G3DSA:2.40.160.100:FF:000002', NULL, NULL, 'Outer membrane channel OmpJ', NULL, NULL, NULL, NULL, NULL, 4),
(148465, NULL, 'G3DSA:3.10.330.10:FF:000023', NULL, NULL, 'Vesicle-fusing ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(148466, NULL, 'G3DSA:3.90.550.50:FF:000062', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(148467, NULL, 'G3DSA:3.30.160.60:FF:002892', NULL, NULL, 'PR domain zinc finger protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(148468, NULL, 'G3DSA:1.20.1080.10:FF:000081', NULL, NULL, 'AQuaPorin or aquaglyceroporin related', NULL, NULL, NULL, NULL, NULL, 4),
(148469, NULL, 'G3DSA:1.20.930.70:FF:000002', NULL, NULL, 'Fatty acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(148470, NULL, 'G3DSA:1.10.510.10:FF:004485', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148471, NULL, 'G3DSA:2.60.40.10:FF:004365', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148472, NULL, 'G3DSA:2.10.25.10:FF:001229', NULL, NULL, 'GM15452', NULL, NULL, NULL, NULL, NULL, 4),
(148473, NULL, 'G3DSA:3.40.640.10:FF:000186', NULL, NULL, 'Aminotransferase, class III', NULL, NULL, NULL, NULL, NULL, 4),
(148474, NULL, 'G3DSA:3.30.70.330:FF:000159', NULL, NULL, 'tRNA selenocysteine 1-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(148475, NULL, 'G3DSA:3.40.50.2300:FF:000029', NULL, NULL, 'Metabotropic glutamate receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(148476, NULL, 'G3DSA:3.30.70.20:FF:000007', NULL, NULL, 'Dimethyl sulfoxide reductase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(148477, NULL, 'G3DSA:3.10.330.20:FF:000026', NULL, NULL, 'tRNA (adenine(58)-N(1))-methyltransferase TrmI', NULL, NULL, NULL, NULL, NULL, 4),
(148478, NULL, 'G3DSA:1.10.486.10:FF:000032', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(148479, NULL, 'G3DSA:2.40.70.10:FF:000433', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148480, NULL, 'G3DSA:2.60.40.10:FF:000666', NULL, NULL, 'basement membrane-specific heparan sulfate proteoglycan core protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(148481, NULL, 'G3DSA:3.30.70.330:FF:001576', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148482, NULL, 'G3DSA:2.60.40.820:FF:000016', NULL, NULL, 'T-box transcription factor TBX2-A', NULL, NULL, NULL, NULL, NULL, 4),
(148483, NULL, 'G3DSA:1.20.1070.10:FF:001558', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148484, NULL, 'G3DSA:1.25.40.10:FF:004807', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148485, NULL, 'G3DSA:3.90.550.10:FF:000628', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148486, NULL, 'G3DSA:1.20.58.860:FF:000014', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(148487, NULL, 'G3DSA:2.130.10.10:FF:006046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148488, NULL, 'G3DSA:2.70.170.10:FF:000175', NULL, NULL, 'Si:ch211-256e16.10', NULL, NULL, NULL, NULL, NULL, 4),
(148489, NULL, 'G3DSA:1.50.40.10:FF:000579', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148490, NULL, 'G3DSA:3.30.160.60:FF:000099', NULL, NULL, 'Zinc finger protein 79', NULL, NULL, NULL, NULL, NULL, 4),
(148491, NULL, 'G3DSA:1.20.950.20:FF:000011', NULL, NULL, 'Nickel-dependent hydrogenase b-type cytochrome subunit', NULL, NULL, NULL, NULL, NULL, 4),
(148492, NULL, 'G3DSA:1.25.40.10:FF:004465', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148493, NULL, 'G3DSA:3.40.50.1820:FF:001829', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148494, NULL, 'G3DSA:1.10.418.10:FF:000280', NULL, NULL, 'Fimbrin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148495, NULL, 'G3DSA:3.40.50.1820:FF:000306', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(148496, NULL, 'G3DSA:1.10.630.10:FF:000020', NULL, NULL, 'Cytochrome P450 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(148497, NULL, 'G3DSA:3.40.1090.10:FF:000154', NULL, NULL, 'Phospholipase A2', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(148498, NULL, 'G3DSA:3.30.379.10:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148499, NULL, 'G3DSA:3.30.450.40:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148500, NULL, 'G3DSA:1.20.1560.10:FF:000011', NULL, NULL, 'Multidrug ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(148501, NULL, 'G3DSA:1.20.1000.10:FF:000003', NULL, NULL, 'Guanylate-binding family protein', NULL, NULL, NULL, NULL, NULL, 4),
(148502, NULL, 'G3DSA:2.70.130.10:FF:000167', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148503, NULL, 'G3DSA:2.60.120.260:FF:000470', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148504, NULL, 'G3DSA:3.30.450.40:FF:000306', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(148505, NULL, 'G3DSA:2.20.70.10:FF:000147', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(148506, NULL, 'G3DSA:2.60.40.2860:FF:000013', NULL, NULL, 'Transmission-blocking target antigen S230', NULL, NULL, NULL, NULL, NULL, 4),
(148507, NULL, 'G3DSA:3.30.160.60:FF:006282', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148508, NULL, 'G3DSA:3.30.1680.40:FF:000002', NULL, NULL, 'Variant surface glycoprotein (VSG), putative', NULL, NULL, NULL, NULL, NULL, 4),
(148509, NULL, 'G3DSA:1.10.150.20:FF:000216', NULL, NULL, 'DNA repair protein RAD51 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(148510, NULL, 'G3DSA:3.20.20.20:FF:000021', NULL, NULL, 'Dihydropteroate synthase-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(148511, NULL, 'G3DSA:1.10.20.10:FF:000366', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148512, NULL, 'G3DSA:3.40.50.1000:FF:000847', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148513, NULL, 'G3DSA:3.40.50.150:FF:000745', NULL, NULL, 'Protein CBG16658', NULL, NULL, NULL, NULL, NULL, 4),
(148514, NULL, 'G3DSA:2.130.10.10:FF:000745', NULL, NULL, 'Dynein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148515, NULL, 'G3DSA:3.40.50.1240:FF:000009', NULL, NULL, 'serine/threonine-protein phosphatase PGAM5, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(148516, NULL, 'G3DSA:3.40.50.10810:FF:000198', NULL, NULL, 'DNA repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148517, NULL, 'G3DSA:2.60.40.10:FF:004595', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148518, NULL, 'G3DSA:3.40.640.10:FF:000427', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(148519, NULL, 'G3DSA:2.60.40.10:FF:002566', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(148520, NULL, 'G3DSA:3.30.2320.10:FF:000001', NULL, NULL, 'Bacteriocin CFP29', NULL, NULL, NULL, NULL, NULL, 4),
(148521, NULL, 'G3DSA:1.10.940.10:FF:000021', NULL, NULL, 'Transcription antitermination protein NusB', NULL, NULL, NULL, NULL, NULL, 4),
(148522, NULL, 'G3DSA:3.30.300.130:FF:000001', NULL, NULL, 'NFU1 iron-sulfur cluster scaffold', NULL, NULL, NULL, NULL, NULL, 4),
(148523, NULL, 'G3DSA:2.70.150.10:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148524, NULL, 'G3DSA:1.20.1250.20:FF:001339', NULL, NULL, 'Monocarboxylate transporter-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(148525, NULL, 'G3DSA:1.20.1070.10:FF:001912', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(148526, NULL, 'G3DSA:2.130.10.10:FF:001021', NULL, NULL, 'Elongator acetyltransferase complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(148527, NULL, 'G3DSA:3.50.4.10:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148528, NULL, 'G3DSA:1.10.287.110:FF:000336', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148529, NULL, 'G3DSA:3.20.20.30:FF:000024', NULL, NULL, 'F420-dependent glucose-6-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(148530, NULL, 'G3DSA:3.30.230.10:FF:000314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148531, NULL, 'G3DSA:1.10.3720.10:FF:000088', NULL, NULL, 'Iron(III) ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(148532, NULL, 'G3DSA:2.30.30.940:FF:000012', NULL, NULL, 'Rcorf28', NULL, NULL, NULL, NULL, NULL, 4),
(148533, NULL, 'G3DSA:1.10.10.60:FF:000734', NULL, NULL, 'Homeobox protein Rhox5', NULL, NULL, NULL, NULL, NULL, 4),
(148534, NULL, 'G3DSA:2.60.40.150:FF:000574', NULL, NULL, 'YALI0F20724p', NULL, NULL, NULL, NULL, NULL, 4),
(148535, NULL, 'G3DSA:3.40.850.10:FF:000011', NULL, NULL, 'Kinesin family member 21A', NULL, NULL, NULL, NULL, NULL, 4),
(148536, NULL, 'G3DSA:1.25.40.840:FF:000005', NULL, NULL, 'CCR4-not transcription complex, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148537, NULL, 'G3DSA:1.10.10.60:FF:001010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148538, NULL, 'G3DSA:1.25.40.550:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148539, NULL, 'G3DSA:1.10.10.10:FF:000208', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(148540, NULL, 'G3DSA:1.20.1530.20:FF:000074', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(148541, NULL, 'G3DSA:1.10.8.790:FF:000001', NULL, NULL, 'RNA-dependent RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(148542, NULL, 'G3DSA:1.10.340.70:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148543, NULL, 'G3DSA:2.10.25.10:FF:001572', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148544, NULL, 'G3DSA:1.25.10.10:FF:000927', NULL, NULL, 'Importin alpha, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148545, NULL, 'G3DSA:2.60.40.10:FF:002920', NULL, NULL, 'Usher syndrome 2A (autosomal recessive, mild)', NULL, NULL, NULL, NULL, NULL, 4),
(148546, NULL, 'G3DSA:3.40.30.10:FF:001215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148547, NULL, 'G3DSA:3.90.79.10:FF:000257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148548, NULL, 'G3DSA:3.40.50.80:FF:000012', NULL, NULL, 'NADPH oxidase, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(148549, NULL, 'G3DSA:3.10.660.10:FF:000003', NULL, NULL, 'DNAJ heat shock N-terminal domain-containing protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(148550, NULL, 'G3DSA:3.40.50.1390:FF:000026', NULL, NULL, 'Partial ORF from ISC1904', NULL, NULL, NULL, NULL, NULL, 4),
(148551, NULL, 'G3DSA:1.10.3410.10:FF:000003', NULL, NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(148552, NULL, 'G3DSA:2.60.40.790:FF:000069', NULL, NULL, 'Protein lethal(2)essential for life', NULL, NULL, NULL, NULL, NULL, 4),
(148553, NULL, 'G3DSA:3.40.640.10:FF:000085', NULL, NULL, 'Cystathionine gamma-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(148554, NULL, 'G3DSA:3.40.630.10:FF:000028', NULL, NULL, 'Peptidase, M20/M25/M40 family', NULL, NULL, NULL, NULL, NULL, 4),
(148555, NULL, 'G3DSA:1.25.10.10:FF:001203', NULL, NULL, 'AP-3 complex subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(148556, NULL, 'G3DSA:1.25.40.530:FF:000013', NULL, NULL, 'Motor AXon guidance', NULL, NULL, NULL, NULL, NULL, 4),
(148557, NULL, 'G3DSA:1.20.920.30:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148558, NULL, 'G3DSA:3.40.50.2300:FF:001665', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148559, NULL, 'G3DSA:1.20.140.100:FF:000009', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148560, NULL, 'G3DSA:3.90.1310.10:FF:000003', NULL, NULL, 'Peptidoglycan D,D-transpeptidase FtsI', NULL, NULL, NULL, NULL, NULL, 4),
(148561, NULL, 'G3DSA:3.80.10.10:FF:001892', NULL, NULL, 'Tubulin folding cofactor E', NULL, NULL, NULL, NULL, NULL, 4),
(148562, NULL, 'G3DSA:3.30.70.330:FF:002177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148563, NULL, 'G3DSA:1.20.120.1750:FF:000052', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(148564, NULL, 'G3DSA:2.40.10.10:FF:000227', NULL, NULL, 'CG9649 protein', NULL, NULL, NULL, NULL, NULL, 4),
(148565, NULL, 'G3DSA:3.40.50.1380:FF:000023', NULL, NULL, 'Bifunctional purine biosynthesis protein PurH', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(148566, NULL, 'G3DSA:3.30.70.1350:FF:000005', NULL, NULL, 'Metal tolerance protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(148567, NULL, 'G3DSA:3.50.50.60:FF:000606', NULL, NULL, 'O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(148568, NULL, 'G3DSA:3.50.50.60:FF:000045', NULL, NULL, '3-phenylpropionate/cinnamic acid dioxygenase ferredoxin--NAD(+) reductase component', NULL, NULL, NULL, NULL, NULL, 4),
(148569, NULL, 'G3DSA:3.40.525.10:FF:000008', NULL, NULL, 'Phosphatidylinositol transfer protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(148570, NULL, 'G3DSA:1.20.120.1240:FF:000005', NULL, NULL, 'Dynamin-2 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(148571, NULL, 'G3DSA:1.20.1310.10:FF:000190', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148572, NULL, 'G3DSA:3.30.710.10:FF:000020', NULL, NULL, 'Potassium voltage-gated channel protein Shaw', NULL, NULL, NULL, NULL, NULL, 4),
(148573, NULL, 'G3DSA:3.30.200.20:FF:002518', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148574, NULL, 'G3DSA:1.20.120.30:FF:000002', NULL, NULL, 'Methyl-accepting chemotaxis protein I', NULL, NULL, NULL, NULL, NULL, 4),
(148575, NULL, 'G3DSA:3.30.420.40:FF:000708', NULL, NULL, 'N-acetylmuramic acid/N-acetylglucosamine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(148576, NULL, 'G3DSA:3.40.50.970:FF:000204', NULL, NULL, 'Pyruvate dehydrogenase E1 component subunit beta, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(148577, NULL, 'G3DSA:3.30.420.40:FF:000366', NULL, NULL, 'Putative actin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(148578, NULL, 'G3DSA:3.40.50.150:FF:001021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148579, NULL, 'G3DSA:2.30.30.40:FF:000283', NULL, NULL, 'NAP1-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(148580, NULL, 'G3DSA:3.40.50.720:FF:001563', NULL, NULL, '3-oxoacyl-(Acyl carrier protein) reductase', NULL, NULL, NULL, NULL, NULL, 4),
(148581, NULL, 'G3DSA:3.30.70.270:FF:000006', NULL, NULL, 'Gag-Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(148582, NULL, 'G3DSA:3.30.40.10:FF:002306', NULL, NULL, 'Titin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148583, NULL, 'G3DSA:3.30.470.20:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148584, NULL, 'G3DSA:3.40.1780.10:FF:000004', NULL, NULL, 'S-adenosylmethionine:tRNA ribosyltransferase-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(148585, NULL, 'G3DSA:1.10.357.50:FF:000020', NULL, NULL, 'SNARE-binding exocyst subunit', NULL, NULL, NULL, NULL, NULL, 4),
(148586, NULL, 'G3DSA:3.90.70.10:FF:000625', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148587, NULL, 'G3DSA:3.40.50.2000:FF:000142', NULL, NULL, 'L-arabinokinase', NULL, NULL, NULL, NULL, NULL, 4),
(148588, NULL, 'G3DSA:1.10.1070.11:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148589, NULL, 'G3DSA:3.20.20.100:FF:000009', NULL, NULL, 'Aldo-keto reductase family 1 member B1', NULL, NULL, NULL, NULL, NULL, 4),
(148590, NULL, 'G3DSA:3.30.200.20:FF:000821', NULL, NULL, 'Cdc2-related kinase 6, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148591, NULL, 'G3DSA:1.20.1270.220:FF:000008', NULL, NULL, 'Bromodomain-containing transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148592, NULL, 'G3DSA:1.20.58.1880:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148593, NULL, 'G3DSA:3.30.200.20:FF:000366', NULL, NULL, 'receptor-type tyrosine-protein kinase FLT3', NULL, NULL, NULL, NULL, NULL, 4),
(148594, NULL, 'G3DSA:3.30.1070.10:FF:000003', NULL, NULL, 'Cell division topological specificity factor', NULL, NULL, NULL, NULL, NULL, 4),
(148595, NULL, 'G3DSA:1.25.40.540:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148596, NULL, 'G3DSA:3.90.1150.50:FF:000002', NULL, NULL, 'CarD-like transcriptional regulator family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(148597, NULL, 'G3DSA:3.90.226.10:FF:000139', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(148598, NULL, 'G3DSA:3.40.228.10:FF:000003', NULL, NULL, 'Biotin sulfoxide reductase 2', NULL, NULL, NULL, NULL, NULL, 4),
(148599, NULL, 'G3DSA:3.30.565.10:FF:000165', NULL, NULL, 'Phosphate regulon sensor histidine kinase PhoR', NULL, NULL, NULL, NULL, NULL, 4),
(148600, NULL, 'G3DSA:3.40.30.10:FF:000939', NULL, NULL, 'Putative redox protein fmp46, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(148601, NULL, 'G3DSA:3.30.450.20:FF:000300', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(148602, NULL, 'G3DSA:3.30.70.330:FF:002290', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148603, NULL, 'G3DSA:1.10.238.10:FF:000283', NULL, NULL, 'Solute carrier family 25 (Mitochondrial aspartate/glutamate transporter), member 12/13', NULL, NULL, NULL, NULL, NULL, 4),
(148604, NULL, 'G3DSA:2.60.470.10:FF:000020', NULL, NULL, 'pickpocket protein 28', NULL, NULL, NULL, NULL, NULL, 4),
(148605, NULL, 'G3DSA:3.40.50.300:FF:004635', NULL, NULL, 'Translation factor GUF1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(148606, NULL, 'G3DSA:3.40.50.300:FF:004865', NULL, NULL, 'CTP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(148607, NULL, 'G3DSA:1.10.10.60:FF:000745', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(148608, NULL, 'G3DSA:1.10.730.10:FF:000207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148609, NULL, 'G3DSA:1.10.10.10:FF:000085', NULL, NULL, 'Vacuolar-sorting protein SNF8', NULL, NULL, NULL, NULL, NULL, 4),
(148610, NULL, 'G3DSA:3.50.7.10:FF:000066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148611, NULL, 'G3DSA:2.10.109.10:FF:000041', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(148612, NULL, 'G3DSA:4.10.400.10:FF:000368', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148613, NULL, 'G3DSA:3.80.10.10:FF:000026', NULL, NULL, 'U2 small nuclear ribonucleoprotein A', NULL, NULL, NULL, NULL, NULL, 4),
(148614, NULL, 'G3DSA:2.60.40.1120:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148615, NULL, 'G3DSA:1.10.3720.10:FF:000190', NULL, NULL, 'Sulfate ABC transporter permease protein CysW', NULL, NULL, NULL, NULL, NULL, 4),
(148616, NULL, 'G3DSA:3.30.160.60:FF:002914', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148617, NULL, 'G3DSA:1.10.8.600:FF:000001', NULL, NULL, 'DNA replication protein 16.7', NULL, NULL, NULL, NULL, NULL, 4),
(148618, NULL, 'G3DSA:3.30.40.10:FF:000165', NULL, NULL, 'E3 ubiquitin-protein ligase Arkadia isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(148619, NULL, 'G3DSA:3.40.50.300:FF:002735', NULL, NULL, 'ras-related protein Rap-2b isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(148620, NULL, 'G3DSA:3.30.70.330:FF:000390', NULL, NULL, 'dead end protein homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(148621, NULL, 'G3DSA:3.40.50.880:FF:000155', NULL, NULL, 'Carbamoyl-phosphate synthase small chain', NULL, NULL, NULL, NULL, NULL, 4),
(148622, NULL, 'G3DSA:3.40.50.1980:FF:000006', NULL, NULL, 'Zinc ABC transporter substrate-binding protein ZnuA', NULL, NULL, NULL, NULL, NULL, 4),
(148623, NULL, 'G3DSA:3.30.160.60:FF:004814', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148624, NULL, 'G3DSA:1.20.1070.10:FF:001890', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148625, NULL, 'G3DSA:3.30.70.330:FF:000732', NULL, NULL, 'RNA recognition water-stress protein1', NULL, NULL, NULL, NULL, NULL, 4),
(148626, NULL, 'G3DSA:3.10.129.10:FF:000055', NULL, NULL, 'ATP-binding Cassette (ABC) superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(148627, NULL, 'G3DSA:1.10.533.10:FF:000238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148628, NULL, 'G3DSA:3.40.50.620:FF:000217', NULL, NULL, 'Leucine--tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148629, NULL, 'G3DSA:3.30.70.260:FF:000003', NULL, NULL, 'GTP pyrophosphokinase RelA', NULL, NULL, NULL, NULL, NULL, 4),
(148630, NULL, 'G3DSA:1.20.1310.10:FF:000077', NULL, NULL, 'CRE-CUL-5 protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(148631, NULL, 'G3DSA:3.90.550.50:FF:000163', NULL, NULL, 'Tripeptidyl peptidase SED3 (AFU_orthologue AFUA_3G08930)', NULL, NULL, NULL, NULL, NULL, 4),
(148632, NULL, 'G3DSA:1.20.910.10:FF:000011', NULL, NULL, 'Aminopyrimidine aminohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(148633, NULL, 'G3DSA:3.40.50.1370:FF:000020', NULL, NULL, 'Acetylornithine carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(148634, NULL, 'G3DSA:3.30.559.10:FF:000010', NULL, NULL, 'carnitine O-palmitoyltransferase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(148635, NULL, 'G3DSA:2.40.50.140:FF:000482', NULL, NULL, 'Replication factor-A protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(148636, NULL, 'G3DSA:3.40.50.1820:FF:001498', NULL, NULL, 'Putative serine carboxypeptidase-like 53', NULL, NULL, NULL, NULL, NULL, 4),
(148637, NULL, 'G3DSA:3.30.1370.10:FF:000032', NULL, NULL, 'synaptic functional regulator FMR1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(148638, NULL, 'G3DSA:3.40.50.1970:FF:000003', NULL, NULL, 'Alcohol dehydrogenase, iron-containing', NULL, NULL, NULL, NULL, NULL, 4),
(148639, NULL, 'G3DSA:3.30.1010.10:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148640, NULL, 'G3DSA:3.30.160.60:FF:003055', NULL, NULL, 'Tripartite motif containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(148641, NULL, 'G3DSA:3.30.2350.20:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148642, NULL, 'G3DSA:1.10.132.110:FF:000002', NULL, NULL, 'Amyloid protein A', NULL, NULL, NULL, NULL, NULL, 4),
(148643, NULL, 'G3DSA:1.25.40.10:FF:002346', NULL, NULL, 'Pre-mRNA-splicing factor SYF1', NULL, NULL, NULL, NULL, NULL, 4),
(148644, NULL, 'G3DSA:1.10.472.10:FF:000663', NULL, NULL, 'Cyclin J-like', NULL, NULL, NULL, NULL, NULL, 4),
(148645, NULL, 'G3DSA:1.10.510.10:FF:000764', NULL, NULL, 'AGC/PDK1 protein kinase, variant 1', NULL, NULL, NULL, NULL, NULL, 4),
(148646, NULL, 'G3DSA:3.40.50.1000:FF:000308', NULL, NULL, 'Related to FCP1-TFIIF interacting component of CTD phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(148647, NULL, 'G3DSA:1.10.490.10:FF:000042', NULL, NULL, 'Heme-based aerotactic transducer HemAT', NULL, NULL, NULL, NULL, NULL, 4),
(148648, NULL, 'G3DSA:3.40.47.10:FF:000124', NULL, NULL, 'Possible lipid transfer protein or keto acyl-CoA thiolase Ltp4', NULL, NULL, NULL, NULL, NULL, 4),
(148649, NULL, 'G3DSA:4.10.60.10:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148650, NULL, 'G3DSA:2.60.40.10:FF:004718', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148651, NULL, 'G3DSA:3.40.50.720:FF:002400', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148652, NULL, 'G3DSA:2.40.10.10:FF:000665', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148653, NULL, 'G3DSA:2.120.10.30:FF:000162', NULL, NULL, 'LDL receptor related protein 5 like', NULL, NULL, NULL, NULL, NULL, 4),
(148654, NULL, 'G3DSA:2.30.30.30:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148655, NULL, 'G3DSA:1.10.287.920:FF:000011', NULL, NULL, 'AFR522Cp', NULL, NULL, NULL, NULL, NULL, 4),
(148656, NULL, 'G3DSA:2.70.150.10:FF:000067', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(148657, NULL, 'G3DSA:2.70.130.10:FF:000178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148658, NULL, 'G3DSA:3.30.2010.10:FF:000011', NULL, NULL, 'Putative beta-barrel assembly-enhancing protease', NULL, NULL, NULL, NULL, NULL, 4),
(148659, NULL, 'G3DSA:3.40.50.80:FF:000242', NULL, NULL, 'Sulfite reductase', NULL, NULL, NULL, NULL, NULL, 4),
(148660, NULL, 'G3DSA:1.10.4160.10:FF:000011', NULL, NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(148661, NULL, 'G3DSA:3.30.160.60:FF:004691', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148662, NULL, 'G3DSA:3.10.350.10:FF:000013', NULL, NULL, 'Peptidase, M23 family', NULL, NULL, NULL, NULL, NULL, 4),
(148663, NULL, 'G3DSA:2.60.40.10:FF:004820', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(148664, NULL, 'G3DSA:1.25.40.10:FF:001031', NULL, NULL, 'Pre-mRNA-splicing factor SYF1', NULL, NULL, NULL, NULL, NULL, 4),
(148665, NULL, 'G3DSA:1.25.40.10:FF:004600', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148666, NULL, 'G3DSA:1.10.287.70:FF:000115', NULL, NULL, 'Cation channel sperm-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(148667, NULL, 'G3DSA:3.40.850.10:FF:000241', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(148668, NULL, 'G3DSA:3.10.100.10:FF:000214', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148669, NULL, 'G3DSA:2.70.98.10:FF:000074', NULL, NULL, 'Aldose 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(148670, NULL, 'G3DSA:2.60.220.10:FF:000002', NULL, NULL, 'Chondroitin sulfate ABC lyase', NULL, NULL, NULL, NULL, NULL, 4),
(148671, NULL, 'G3DSA:3.40.390.10:FF:000104', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(148672, NULL, 'G3DSA:1.10.580.10:FF:000038', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(148673, NULL, 'G3DSA:3.80.10.10:FF:003472', NULL, NULL, 'Plekhe1 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148674, NULL, 'G3DSA:1.10.287.940:FF:000017', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(148675, NULL, 'G3DSA:3.40.50.1220:FF:000003', NULL, NULL, 'NAD-dependent protein deacylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(148676, NULL, 'G3DSA:1.10.150.530:FF:000018', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(148677, NULL, 'G3DSA:3.60.110.10:FF:000012', NULL, NULL, 'N-carbamoylputrescine amidohydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148678, NULL, 'G3DSA:1.25.40.20:FF:001034', NULL, NULL, 'Espin like', NULL, NULL, NULL, NULL, NULL, 4),
(148679, NULL, 'G3DSA:3.30.2350.10:FF:000036', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(148680, NULL, 'G3DSA:3.10.20.90:FF:000773', NULL, NULL, 'Partitioning defective 3-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(148681, NULL, 'G3DSA:1.25.70.10:FF:000044', NULL, NULL, 'uncharacterized protein LOC108087286', NULL, NULL, NULL, NULL, NULL, 4),
(148682, NULL, 'G3DSA:1.10.238.10:FF:001120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148683, NULL, 'G3DSA:3.90.550.10:FF:000741', NULL, NULL, 'Gll2192 protein', NULL, NULL, NULL, NULL, NULL, 4),
(148684, NULL, 'G3DSA:3.10.450.700:FF:000001', NULL, NULL, 'Purine-rich element binding protein A', NULL, NULL, NULL, NULL, NULL, 4),
(148685, NULL, 'G3DSA:2.70.160.11:FF:000001', NULL, NULL, 'Blast:Protein arginine N-methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(148686, NULL, 'G3DSA:2.20.100.10:FF:000013', NULL, NULL, 'Spondin 1a', NULL, NULL, NULL, NULL, NULL, 4),
(148687, NULL, 'G3DSA:3.40.50.620:FF:000010', NULL, NULL, 'Glutamine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(148688, NULL, 'G3DSA:1.25.40.20:FF:000758', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148689, NULL, 'G3DSA:1.10.418.10:FF:000167', NULL, NULL, 'Dixin', NULL, NULL, NULL, NULL, NULL, 4),
(148690, NULL, 'G3DSA:3.10.110.10:FF:000142', NULL, NULL, 'Ubiquitin-conjugating enzyme E2', NULL, NULL, NULL, NULL, NULL, 4),
(148691, NULL, 'G3DSA:4.10.860.10:FF:000014', NULL, NULL, 'ATP-dependent Clp protease ATP-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(148692, NULL, 'G3DSA:1.10.238.10:FF:000844', NULL, NULL, 'EF-hand domain pair/EF-hand domain/EF hand, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148693, NULL, 'G3DSA:3.30.497.10:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148694, NULL, 'G3DSA:2.120.10.80:FF:000250', NULL, NULL, 'Kelch domain-containing protein 8B', NULL, NULL, NULL, NULL, NULL, 4),
(148695, NULL, 'G3DSA:1.10.560.10:FF:000149', NULL, NULL, '60 kDa heat shock protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(148696, NULL, 'G3DSA:3.40.190.170:FF:000011', NULL, NULL, 'TRAP-type C4-dicarboxylate transport system, substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(148697, NULL, 'G3DSA:1.20.1250.20:FF:001660', NULL, NULL, 'YALI0F03751p', NULL, NULL, NULL, NULL, NULL, 4),
(148698, NULL, 'G3DSA:3.40.30.10:FF:001092', NULL, NULL, '40S ribosomal protein S8-1', NULL, NULL, NULL, NULL, NULL, 4),
(148699, NULL, 'G3DSA:1.20.1250.20:FF:002053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148700, NULL, 'G3DSA:1.10.1670.10:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148701, NULL, 'G3DSA:2.60.40.10:FF:003403', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148702, NULL, 'G3DSA:1.25.40.10:FF:000755', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(148703, NULL, 'G3DSA:2.30.280.10:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148704, NULL, 'G3DSA:3.20.20.150:FF:000007', NULL, NULL, 'Hydroxypyruvate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(148705, NULL, 'G3DSA:1.20.5.2480:FF:000004', NULL, NULL, 'Reticulon', NULL, NULL, NULL, NULL, NULL, 4),
(148706, NULL, 'G3DSA:1.20.210.10:FF:000003', NULL, NULL, 'Cytochrome c oxidase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(148707, NULL, 'G3DSA:3.40.50.970:FF:000081', NULL, NULL, 'Transketolase', NULL, NULL, NULL, NULL, NULL, 4),
(148708, NULL, 'G3DSA:1.20.272.10:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148709, NULL, 'G3DSA:2.60.210.10:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148710, NULL, 'G3DSA:3.30.30.10:FF:000007', NULL, NULL, 'Defensin-like protein 195', NULL, NULL, NULL, NULL, NULL, 4),
(148711, NULL, 'G3DSA:2.60.40.10:FF:000548', NULL, NULL, 'vascular endothelial growth factor receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(148712, NULL, 'G3DSA:3.30.590.50:FF:000010', NULL, NULL, 'Gamma-glutamylcysteine synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148713, NULL, 'G3DSA:2.40.70.10:FF:000551', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148714, NULL, 'G3DSA:1.10.730.10:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148715, NULL, 'G3DSA:1.20.5.340:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148716, NULL, 'G3DSA:3.40.50.300:FF:006327', NULL, NULL, 'ATPase family AAA domain-containing 2B', NULL, NULL, NULL, NULL, NULL, 4),
(148717, NULL, 'G3DSA:2.70.170.10:FF:000057', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(148718, NULL, 'G3DSA:3.30.160.60:FF:006388', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148719, NULL, 'G3DSA:2.30.29.30:FF:001389', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148720, NULL, 'G3DSA:1.10.150.20:FF:000110', NULL, NULL, 'Protein CBG20918', NULL, NULL, NULL, NULL, NULL, 4),
(148721, NULL, 'G3DSA:1.10.8.710:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148722, NULL, 'G3DSA:1.10.418.10:FF:000162', NULL, NULL, 'Serine/threonine-protein kinase pakD', NULL, NULL, NULL, NULL, NULL, 4),
(148723, NULL, 'G3DSA:3.40.50.170:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148724, NULL, 'G3DSA:3.50.50.60:FF:000831', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148725, NULL, 'G3DSA:3.10.20.770:FF:000010', NULL, NULL, 'Phosphatidylinositol-4,5-bisphosphate 3-kinase, catalytic subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(148726, NULL, 'G3DSA:1.25.40.10:FF:002453', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(148727, NULL, 'G3DSA:3.40.50.620:FF:000330', NULL, NULL, 'Glutamate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(148728, NULL, 'G3DSA:1.25.10.10:FF:002518', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 65 kDa regulatory subunit A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148729, NULL, 'G3DSA:1.10.287.110:FF:000454', NULL, NULL, 'FLJ00095 protein', NULL, NULL, NULL, NULL, NULL, 4),
(148730, NULL, 'G3DSA:3.30.1550.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148731, NULL, 'G3DSA:1.10.10.10:FF:000747', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(148732, NULL, 'G3DSA:3.30.200.20:FF:000591', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(148733, NULL, 'G3DSA:2.60.40.150:FF:000462', NULL, NULL, 'ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(148734, NULL, 'G3DSA:3.30.40.10:FF:001368', NULL, NULL, 'Jumonji domain containing 2B', NULL, NULL, NULL, NULL, NULL, 4),
(148735, NULL, 'G3DSA:3.60.15.10:FF:000061', NULL, NULL, 'Interstrand crosslink repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(148736, NULL, 'G3DSA:2.60.40.10:FF:002684', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(148737, NULL, 'G3DSA:3.40.640.10:FF:000315', NULL, NULL, 'Mitochondrial aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(148738, NULL, 'G3DSA:3.40.50.2300:FF:000350', NULL, NULL, 'Diguanylate cyclase response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(148739, NULL, 'G3DSA:1.25.10.10:FF:002951', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148740, NULL, 'G3DSA:2.60.40.10:FF:004819', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148741, NULL, 'G3DSA:3.90.70.10:FF:000850', NULL, NULL, 'AGAP000884-PA', NULL, NULL, NULL, NULL, NULL, 4),
(148742, NULL, 'G3DSA:3.90.1150.10:FF:000018', NULL, NULL, 'Histidine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(148743, NULL, 'G3DSA:2.130.10.10:FF:002662', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148744, NULL, 'G3DSA:3.30.40.10:FF:001475', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148745, NULL, 'G3DSA:1.20.120.350:FF:000187', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148746, NULL, 'G3DSA:2.120.10.80:FF:000249', NULL, NULL, 'Galactose oxidase/kelch repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(148747, NULL, 'G3DSA:2.60.40.420:FF:000110', NULL, NULL, 'VAB-2', NULL, NULL, NULL, NULL, NULL, 4),
(148748, NULL, 'G3DSA:1.10.238.10:FF:000962', NULL, NULL, 'Calmodulin 2', NULL, NULL, NULL, NULL, NULL, 4),
(148749, NULL, 'G3DSA:3.10.100.10:FF:000079', NULL, NULL, 'Oxidized low-density lipoprotein receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(148750, NULL, 'G3DSA:2.40.50.140:FF:000162', NULL, NULL, '30S ribosomal protein S1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(148751, NULL, 'G3DSA:1.20.1250.20:FF:000030', NULL, NULL, 'monocarboxylate transporter 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(148752, NULL, 'G3DSA:3.40.50.1000:FF:000628', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148753, NULL, 'G3DSA:1.10.20.10:FF:000254', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148754, NULL, 'G3DSA:3.30.420.40:FF:000922', NULL, NULL, 'Actin-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(148755, NULL, 'G3DSA:3.30.230.10:FF:000090', NULL, NULL, 'glucuronokinase 1-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(148756, NULL, 'G3DSA:3.40.50.80:FF:000130', NULL, NULL, 'Rieske_[2Fe-2S]_domain/Rieske-like_[2Fe-2S ]_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(148757, NULL, 'G3DSA:2.60.40.10:FF:001161', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(148758, NULL, 'G3DSA:2.60.210.10:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148759, NULL, 'G3DSA:2.60.40.1170:FF:000052', NULL, NULL, 'APM2p protein', NULL, NULL, NULL, NULL, NULL, 4),
(148760, NULL, 'G3DSA:3.90.470.10:FF:000015', NULL, NULL, '50S ribosomal protein L22', NULL, NULL, NULL, NULL, NULL, 4),
(148761, NULL, 'G3DSA:3.90.470.20:FF:000018', NULL, NULL, 'Holo-[acyl-carrier-protein] synthase', NULL, NULL, NULL, NULL, NULL, 4),
(148762, NULL, 'G3DSA:2.130.10.10:FF:003859', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148763, NULL, 'G3DSA:1.25.10.10:FF:002625', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(148764, NULL, 'G3DSA:1.10.1450.10:FF:000078', NULL, NULL, 'GD10451', NULL, NULL, NULL, NULL, NULL, 4),
(148765, NULL, 'G3DSA:3.30.420.40:FF:000815', NULL, NULL, 'nebramycin 5'' synthase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(148766, NULL, 'G3DSA:3.30.70.120:FF:000001', NULL, NULL, 'Nitrogen regulatory protein P-II', NULL, NULL, NULL, NULL, NULL, 4),
(148767, NULL, 'G3DSA:3.40.640.10:FF:000422', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148768, NULL, 'G3DSA:1.20.120.1200:FF:000016', NULL, NULL, 'NADH-quinone oxidoreductase subunit J', NULL, NULL, NULL, NULL, NULL, 4),
(148769, NULL, 'G3DSA:3.10.20.90:FF:000902', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148770, NULL, 'G3DSA:1.10.287.70:FF:000121', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(148771, NULL, 'G3DSA:1.25.40.10:FF:000199', NULL, NULL, 'Penicillin-binding protein activator LpoA', NULL, NULL, NULL, NULL, NULL, 4),
(148772, NULL, 'G3DSA:1.20.1300.10:FF:000037', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(148773, NULL, 'G3DSA:1.10.510.10:FF:002804', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148774, NULL, 'G3DSA:1.10.730.10:FF:000078', NULL, NULL, 'Methionine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(148775, NULL, 'G3DSA:3.30.497.10:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148776, NULL, 'G3DSA:1.10.418.10:FF:000055', NULL, NULL, 'MICAL-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(148777, NULL, 'G3DSA:2.130.10.10:FF:002336', NULL, NULL, 'Intraflagellar transport protein 80', NULL, NULL, NULL, NULL, NULL, 4),
(148778, NULL, 'G3DSA:3.90.70.10:FF:000743', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148779, NULL, 'G3DSA:1.10.287.1080:FF:000015', NULL, NULL, 'Nucleoside triphosphate pyrophosphohydrolase MazG', NULL, NULL, NULL, NULL, NULL, 4),
(148780, NULL, 'G3DSA:3.80.20.20:FF:000086', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(148781, NULL, 'G3DSA:3.40.50.300:FF:000818', NULL, NULL, 'pre-mRNA-splicing factor ATP-dependent RNA helicase DHX16', NULL, NULL, NULL, NULL, NULL, 4),
(148782, NULL, 'G3DSA:2.60.40.10:FF:002791', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148783, NULL, 'G3DSA:3.30.70.890:FF:000086', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(148784, NULL, 'G3DSA:3.10.100.10:FF:000091', NULL, NULL, 'C-type LECtin', NULL, NULL, NULL, NULL, NULL, 4),
(148785, NULL, 'G3DSA:1.20.58.530:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148786, NULL, 'G3DSA:3.40.50.2300:FF:000024', NULL, NULL, 'Vomeronasal 2, receptor 73', NULL, NULL, NULL, NULL, NULL, 4),
(148787, NULL, 'G3DSA:2.40.170.20:FF:000089', NULL, NULL, 'Vitamin B12 transporter BtuB', NULL, NULL, NULL, NULL, NULL, 4),
(148788, NULL, 'G3DSA:1.25.40.10:FF:002560', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148789, NULL, 'G3DSA:1.20.120.1750:FF:000158', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(148790, NULL, 'G3DSA:2.60.40.10:FF:002802', NULL, NULL, 'Immunoglobulin heavy constant delta', NULL, NULL, NULL, NULL, NULL, 4),
(148791, NULL, 'G3DSA:1.10.287.70:FF:000014', NULL, NULL, 'Voltage-dependent T-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(148792, NULL, 'G3DSA:1.10.720.60:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148793, NULL, 'G3DSA:1.10.1840.10:FF:000001', NULL, NULL, 'Replicase polyprotein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(148794, NULL, 'G3DSA:1.10.1170.10:FF:000040', NULL, NULL, 'Apoptosis 2 inhibitor-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(148795, NULL, 'G3DSA:2.40.340.10:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148796, NULL, 'G3DSA:3.10.450.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148797, NULL, 'G3DSA:3.90.550.10:FF:000746', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148798, NULL, 'G3DSA:3.90.1150.220:FF:000002', NULL, NULL, 'Non-structural maintenance of chromosomes element 1', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(148799, NULL, 'G3DSA:3.60.130.10:FF:000002', NULL, NULL, 'Alpha-ketoglutarate-dependent taurine dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(148800, NULL, 'G3DSA:2.40.50.730:FF:000018', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(148801, NULL, 'G3DSA:3.40.30.10:FF:000838', NULL, NULL, 'Protein disulfide-isomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(148802, NULL, 'G3DSA:1.10.357.50:FF:000008', NULL, NULL, 'Exocyst complex component 3-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(148803, NULL, 'G3DSA:1.20.5.2440:FF:000009', NULL, NULL, 'Rab11 family-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(148804, NULL, 'G3DSA:3.80.10.10:FF:001903', NULL, NULL, 'NLR family pyrin domain containing 11', NULL, NULL, NULL, NULL, NULL, 4),
(148805, NULL, 'G3DSA:1.25.40.10:FF:003869', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148806, NULL, 'G3DSA:1.20.1070.10:FF:001238', NULL, NULL, 'Putative cysteine-rich domain of the smoothened receptor', NULL, NULL, NULL, NULL, NULL, 4),
(148807, NULL, 'G3DSA:1.25.10.10:FF:000720', NULL, NULL, 'APL6p Beta3-like subunit', NULL, NULL, NULL, NULL, NULL, 4),
(148808, NULL, 'G3DSA:1.20.5.420:FF:000012', NULL, NULL, 'Small glutamine-rich tetratricopeptide repeat-containing protein alpha', NULL, NULL, NULL, NULL, NULL, 4),
(148809, NULL, 'G3DSA:2.130.10.10:FF:000419', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(148810, NULL, 'G3DSA:3.40.50.150:FF:000852', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148811, NULL, 'G3DSA:1.10.238.10:FF:000743', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148812, NULL, 'G3DSA:2.10.50.30:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148813, NULL, 'G3DSA:1.10.287.80:FF:000017', NULL, NULL, 'Transcription initiation factor TFIID subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(148814, NULL, 'G3DSA:2.60.40.60:FF:000086', NULL, NULL, 'Protocadherin 9', NULL, NULL, NULL, NULL, NULL, 4),
(148815, NULL, 'G3DSA:3.40.50.300:FF:000588', NULL, NULL, 'Endoribonuclease Dicer isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(148816, NULL, 'G3DSA:3.30.40.10:FF:001694', NULL, NULL, 'YALI0E30547p', NULL, NULL, NULL, NULL, NULL, 4),
(148817, NULL, 'G3DSA:1.10.20.10:FF:000361', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148818, NULL, 'G3DSA:3.40.120.10:FF:000057', NULL, NULL, 'Phosphomannomutase', NULL, NULL, NULL, NULL, NULL, 4),
(148819, NULL, 'G3DSA:2.60.40.60:FF:000198', NULL, NULL, 'Protocadherin Fat 2', NULL, NULL, NULL, NULL, NULL, 4),
(148820, NULL, 'G3DSA:3.60.130.20:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148821, NULL, 'G3DSA:2.70.98.110:FF:000007', NULL, NULL, 'Mannosyl-oligosaccharide glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(148822, NULL, 'G3DSA:2.130.10.10:FF:000189', NULL, NULL, 'Protein phosphatase PP2A regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(148823, NULL, 'G3DSA:2.10.110.10:FF:000022', NULL, NULL, 'prickle-like protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(148824, NULL, 'G3DSA:3.60.21.50:FF:000008', NULL, NULL, 'DNA polymerase delta 2, accessory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(148825, NULL, 'G3DSA:1.10.510.10:FF:000657', NULL, NULL, 'Putative inactive leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(148826, NULL, 'G3DSA:2.60.34.10:FF:000040', NULL, NULL, 'Heat shock protein 70, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148827, NULL, 'G3DSA:1.20.930.20:FF:000015', NULL, NULL, 'Mixed lineage kinase domain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(148828, NULL, 'G3DSA:3.20.180.20:FF:000034', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(148829, NULL, 'G3DSA:2.60.120.260:FF:000239', NULL, NULL, 'Netrin 5', NULL, NULL, NULL, NULL, NULL, 4),
(148830, NULL, 'G3DSA:3.40.50.300:FF:008570', NULL, NULL, 'Multidrug resistance protein ABC transporter family', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(148831, NULL, 'G3DSA:3.40.50.620:FF:000111', NULL, NULL, 'Mitochondrial isoleucyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(148832, NULL, 'G3DSA:1.10.287.1770:FF:000008', NULL, NULL, 'Ferrous iron transport protein B', NULL, NULL, NULL, NULL, NULL, 4),
(148833, NULL, 'G3DSA:2.60.40.640:FF:000058', NULL, NULL, 'Vacuolar sorting protein 26, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148834, NULL, 'G3DSA:3.40.50.1000:FF:000409', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148835, NULL, 'G3DSA:2.10.110.10:FF:000241', NULL, NULL, 'YALI0A18381p', NULL, NULL, NULL, NULL, NULL, 4),
(148836, NULL, 'G3DSA:2.30.42.10:FF:000071', NULL, NULL, 'harmonin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(148837, NULL, 'G3DSA:4.10.60.10:FF:000058', NULL, NULL, 'Cellular nucleic acid-binding protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(148838, NULL, 'G3DSA:3.30.200.20:FF:000372', NULL, NULL, 'L-type lectin-domain containing receptor kinase VIII.1', NULL, NULL, NULL, NULL, NULL, 4),
(148839, NULL, 'G3DSA:1.50.10.130:FF:000006', NULL, NULL, 'Terpene synthase 7', NULL, NULL, NULL, NULL, NULL, 4),
(148840, NULL, 'G3DSA:3.40.390.10:FF:000082', NULL, NULL, 'Neutral protease 2', NULL, NULL, NULL, NULL, NULL, 4),
(148841, NULL, 'G3DSA:3.90.650.10:FF:000001', NULL, NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(148842, NULL, 'G3DSA:3.40.50.620:FF:000116', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(148843, NULL, 'G3DSA:2.60.40.10:FF:006057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148844, NULL, 'G3DSA:1.10.510.10:FF:002793', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148845, NULL, 'G3DSA:2.10.25.10:FF:001566', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148846, NULL, 'G3DSA:2.40.70.10:FF:000332', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148847, NULL, 'G3DSA:3.30.428.10:FF:000032', NULL, NULL, 'ADP-glucose phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(148848, NULL, 'G3DSA:3.40.50.1820:FF:001274', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(148849, NULL, 'G3DSA:3.40.50.720:FF:001669', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(148850, NULL, 'G3DSA:1.10.540.10:FF:000159', NULL, NULL, 'Putative medium-chain specific acyl-CoA dehydrogenase, mitochondrial-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(148851, NULL, 'G3DSA:1.10.150.20:FF:000003', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(148852, NULL, 'G3DSA:2.40.30.10:FF:000442', NULL, NULL, 'Elongation factor Tu', NULL, NULL, NULL, NULL, NULL, 4),
(148853, NULL, 'G3DSA:1.10.30.10:FF:000075', NULL, NULL, 'Capicua transcriptional repressor a', NULL, NULL, NULL, NULL, NULL, 4),
(148854, NULL, 'G3DSA:1.50.40.10:FF:000478', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(148855, NULL, 'G3DSA:1.25.40.10:FF:000087', NULL, NULL, 'Nuclear autoantigenic sperm protein (Histone-binding)', NULL, NULL, NULL, NULL, NULL, 4),
(148856, NULL, 'G3DSA:1.20.1250.20:FF:001553', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(148857, NULL, 'G3DSA:3.40.50.1000:FF:000398', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(148858, NULL, 'G3DSA:3.30.460.20:FF:000020', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(148859, NULL, 'G3DSA:2.60.120.40:FF:000048', NULL, NULL, 'Adipolin', NULL, NULL, NULL, NULL, NULL, 4),
(148860, NULL, 'G3DSA:1.20.140.30:FF:000008', NULL, NULL, 'Putative MOB kinase activator-like 2B', NULL, NULL, NULL, NULL, NULL, 4),
(148861, NULL, 'G3DSA:3.30.1370.10:FF:000037', NULL, NULL, 'KH domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(148862, NULL, 'G3DSA:2.20.28.120:FF:000002', NULL, NULL, '50S ribosomal protein L33', NULL, NULL, NULL, NULL, NULL, 4),
(148863, NULL, 'G3DSA:3.30.160.60:FF:004371', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148864, NULL, 'G3DSA:1.25.10.10:FF:002737', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(148865, NULL, 'G3DSA:3.20.20.70:FF:000587', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148866, NULL, 'G3DSA:1.20.5.170:FF:000004', NULL, NULL, 'Keratin, type II cytoskeletal 5', NULL, NULL, NULL, NULL, NULL, 4),
(148867, NULL, 'G3DSA:1.25.40.10:FF:000317', NULL, NULL, 'Tetratricopeptide repeat protein 30A', NULL, NULL, NULL, NULL, NULL, 4),
(148868, NULL, 'G3DSA:3.30.230.10:FF:000101', NULL, NULL, 'Phosphomevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(148869, NULL, 'G3DSA:2.60.200.20:FF:000094', NULL, NULL, 'NAD-dependent protein deacylase sirtuin-5, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(148870, NULL, 'G3DSA:3.40.50.300:FF:002954', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(148871, NULL, 'G3DSA:1.10.10.60:FF:000178', NULL, NULL, 'hematopoietically-expressed homeobox protein HHEX', NULL, NULL, NULL, NULL, NULL, 4),
(148872, NULL, 'G3DSA:2.170.140.10:FF:000020', NULL, NULL, 'peritrophin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(148873, NULL, 'G3DSA:3.30.200.20:FF:001788', NULL, NULL, 'Eukaryotic translation initiation factor 2 alpha kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(148874, NULL, 'G3DSA:2.40.160.50:FF:000018', NULL, NULL, 'Outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(148875, NULL, 'G3DSA:3.40.640.10:FF:000534', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148876, NULL, 'G3DSA:3.40.50.300:FF:006546', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148877, NULL, 'G3DSA:2.70.170.10:FF:000276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148878, NULL, 'G3DSA:2.30.30.1150:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148879, NULL, 'G3DSA:3.30.200.20:FF:000602', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(148880, NULL, 'G3DSA:2.130.10.10:FF:002555', NULL, NULL, 'WD repeat domain 19', NULL, NULL, NULL, NULL, NULL, 4),
(148881, NULL, 'G3DSA:3.30.420.40:FF:000585', NULL, NULL, 'Actin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148882, NULL, 'G3DSA:1.20.81.30:FF:000006', NULL, NULL, 'Protein transport protein HofC homolog', NULL, NULL, NULL, NULL, NULL, 4),
(148883, NULL, 'G3DSA:2.30.180.10:FF:000196', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148884, NULL, 'G3DSA:1.25.40.10:FF:004358', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148885, NULL, 'G3DSA:3.40.50.10860:FF:000073', NULL, NULL, 'Bifunctional protein FolD 1 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(148886, NULL, 'G3DSA:1.10.357.10:FF:000025', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(148887, NULL, 'G3DSA:3.90.70.10:FF:000524', NULL, NULL, 'Unplaced genomic scaffold supercont1.10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(148888, NULL, 'G3DSA:3.40.50.2300:FF:000243', NULL, NULL, 'Metabotropic glutamate receptor 5', NULL, NULL, NULL, NULL, NULL, 4),
(148889, NULL, 'G3DSA:3.10.28.10:FF:000025', NULL, NULL, 'Probable intron-encoded endonuclease aI8', NULL, NULL, NULL, NULL, NULL, 4),
(148890, NULL, 'G3DSA:1.10.132.60:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148891, NULL, 'G3DSA:3.90.20.20:FF:000001', NULL, NULL, 'Protein GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(148892, NULL, 'G3DSA:1.10.1170.10:FF:000045', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(148893, NULL, 'G3DSA:1.25.40.10:FF:002672', NULL, NULL, 'Erythrocyte binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148894, NULL, 'G3DSA:3.50.50.60:FF:000612', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(148895, NULL, 'G3DSA:3.30.40.10:FF:000064', NULL, NULL, 'Histone-lysine N-methyltransferase 2C', NULL, NULL, NULL, NULL, NULL, 4),
(148896, NULL, 'G3DSA:3.30.160.60:FF:005202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148897, NULL, 'G3DSA:2.60.40.790:FF:000075', NULL, NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(148898, NULL, 'G3DSA:3.90.79.10:FF:000263', NULL, NULL, 'Nudix (nucleoside diphosphate linked moiety X)-type motif 15', NULL, NULL, NULL, NULL, NULL, 4),
(148899, NULL, 'G3DSA:3.40.50.720:FF:000360', NULL, NULL, 'Short chain dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(148900, NULL, 'G3DSA:3.30.830.10:FF:000181', NULL, NULL, 'Protease', NULL, NULL, NULL, NULL, NULL, 4),
(148901, NULL, 'G3DSA:3.100.10.10:FF:000006', NULL, NULL, '39S ribosomal protein L15, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(148902, NULL, 'G3DSA:3.30.565.10:FF:000406', NULL, NULL, 'Probable two-component sensor histidine kinase VicK', NULL, NULL, NULL, NULL, NULL, 4),
(148903, NULL, 'G3DSA:3.40.350.10:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148904, NULL, 'G3DSA:2.130.10.10:FF:002550', NULL, NULL, 'transducin beta-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(148905, NULL, 'G3DSA:3.40.50.1820:FF:001841', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148906, NULL, 'G3DSA:3.30.200.20:FF:000046', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(148907, NULL, 'G3DSA:1.20.120.1750:FF:000153', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(148908, NULL, 'G3DSA:1.10.150.20:FF:000222', NULL, NULL, 'RNA helicase, activating signal cointegrator 1', NULL, NULL, NULL, NULL, NULL, 4),
(148909, NULL, 'G3DSA:3.50.80.10:FF:000009', NULL, NULL, 'D-aminoacyl-tRNA deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(148910, NULL, 'G3DSA:2.10.25.10:FF:001673', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148911, NULL, 'G3DSA:3.30.70.3290:FF:000014', NULL, NULL, 'Polyketide synthase type I', NULL, NULL, NULL, NULL, NULL, 4),
(148912, NULL, 'G3DSA:1.10.287.1490:FF:000138', NULL, NULL, 'Viral A-type inclusion protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148913, NULL, 'G3DSA:3.40.50.1820:FF:001493', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148914, NULL, 'G3DSA:2.60.40.10:FF:004371', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148915, NULL, 'G3DSA:1.25.40.10:FF:002341', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148916, NULL, 'G3DSA:2.60.40.60:FF:000872', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148917, NULL, 'G3DSA:1.10.238.10:FF:000069', NULL, NULL, 'calcium-binding protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(148918, NULL, 'G3DSA:2.70.150.10:FF:000174', NULL, NULL, 'ATP2C2 isoform 14', NULL, NULL, NULL, NULL, NULL, 4),
(148919, NULL, 'G3DSA:1.25.10.10:FF:002406', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148920, NULL, 'G3DSA:2.40.50.140:FF:000381', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(148921, NULL, 'G3DSA:3.40.50.2300:FF:000462', NULL, NULL, 'Signal transduction histidine kinase CheA', NULL, NULL, NULL, NULL, NULL, 4),
(148922, NULL, 'G3DSA:3.40.50.10810:FF:000209', NULL, NULL, 'DNA repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148923, NULL, 'G3DSA:3.30.200.20:FF:001569', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148924, NULL, 'G3DSA:3.10.20.90:FF:000672', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148925, NULL, 'G3DSA:1.20.1250.20:FF:000142', NULL, NULL, 'probable anion transporter 3, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(148926, NULL, 'G3DSA:1.10.418.10:FF:000274', NULL, NULL, 'Utrophin', NULL, NULL, NULL, NULL, NULL, 4),
(148927, NULL, 'G3DSA:1.10.287.80:FF:000012', NULL, NULL, 'ATP synthase gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(148928, NULL, 'G3DSA:3.30.160.60:FF:001150', NULL, NULL, 'zinc finger protein 324A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(148929, NULL, 'G3DSA:1.25.40.970:FF:000004', NULL, NULL, 'histone-lysine N-methyltransferase SMYD3', NULL, NULL, NULL, NULL, NULL, 4),
(148930, NULL, 'G3DSA:3.30.70.330:FF:000053', NULL, NULL, 'Serine/arginine-rich splicing factor 1', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(148931, NULL, 'G3DSA:2.130.10.10:FF:002774', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148932, NULL, 'G3DSA:3.40.390.10:FF:000205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148933, NULL, 'G3DSA:1.20.5.1160:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148934, NULL, 'G3DSA:1.10.287.3550:FF:000003', NULL, NULL, 'Stromal interaction molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(148935, NULL, 'G3DSA:1.25.10.10:FF:002058', NULL, NULL, 'Ipo7 protein', NULL, NULL, NULL, NULL, NULL, 4),
(148936, NULL, 'G3DSA:3.80.10.10:FF:001229', NULL, NULL, 'Leucine-rich repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148937, NULL, 'G3DSA:2.60.40.10:FF:002465', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148938, NULL, 'G3DSA:3.30.460.20:FF:000025', NULL, NULL, 'Magnesium transport protein CorA', NULL, NULL, NULL, NULL, NULL, 4),
(148939, NULL, 'G3DSA:3.30.40.10:FF:001587', NULL, NULL, 'Remodeling and spacing factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(148940, NULL, 'G3DSA:1.20.58.1040:FF:000011', NULL, NULL, '1,3-beta-glucanosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(148941, NULL, 'G3DSA:3.10.100.10:FF:000321', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148942, NULL, 'G3DSA:1.20.1510.10:FF:000070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148943, NULL, 'G3DSA:2.120.10.30:FF:000611', NULL, NULL, 'DPP6 N-terminal domain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(148944, NULL, 'G3DSA:1.20.1250.20:FF:001665', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148945, NULL, 'G3DSA:3.40.50.300:FF:000369', NULL, NULL, 'GTP-binding nuclear protein', NULL, NULL, NULL, NULL, NULL, 4),
(148946, NULL, 'G3DSA:1.10.12.10:FF:000010', NULL, NULL, 'Enoyl-CoA hydratase EchA12', NULL, NULL, NULL, NULL, NULL, 4),
(148947, NULL, 'G3DSA:1.10.10.60:FF:000408', NULL, NULL, 'Sigma-54 dependent transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(148948, NULL, 'G3DSA:1.10.10.10:FF:000528', NULL, NULL, 'Transcriptional regulatory protein EmbR', NULL, NULL, NULL, NULL, NULL, 4),
(148949, NULL, 'G3DSA:2.40.10.10:FF:000547', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148950, NULL, 'G3DSA:3.40.630.90:FF:000001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148951, NULL, 'G3DSA:1.10.10.60:FF:000066', NULL, NULL, 'Paired mesoderm homeobox protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(148952, NULL, 'G3DSA:2.120.10.30:FF:000263', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(148953, NULL, 'G3DSA:3.40.50.720:FF:000253', NULL, NULL, 'Uncharacterized protein At5g02240', NULL, NULL, NULL, NULL, NULL, 4),
(148954, NULL, 'G3DSA:3.30.160.60:FF:002673', NULL, NULL, 'Zinc finger protein 407', NULL, NULL, NULL, NULL, NULL, 4),
(148955, NULL, 'G3DSA:1.20.1070.10:FF:001457', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(148956, NULL, 'G3DSA:2.60.40.10:FF:000767', NULL, NULL, 'Vascular endothelial growth factor receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(148957, NULL, 'G3DSA:2.10.10.20:FF:000006', NULL, NULL, 'Chitinase A1', NULL, NULL, NULL, NULL, NULL, 4),
(148958, NULL, 'G3DSA:1.25.10.10:FF:000259', NULL, NULL, 'interferon-related developmental regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(148959, NULL, 'G3DSA:3.30.160.60:FF:000874', NULL, NULL, 'zinc finger protein 235 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(148960, NULL, 'G3DSA:2.60.40.10:FF:004264', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148961, NULL, 'G3DSA:3.60.15.10:FF:000280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148962, NULL, 'G3DSA:3.40.50.150:FF:001341', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148963, NULL, 'G3DSA:2.170.8.10:FF:000007', NULL, NULL, 'Phosphoenolpyruvate carboxykinase [GTP]', NULL, NULL, NULL, NULL, NULL, 4),
(148964, NULL, 'G3DSA:3.30.70.1050:FF:000016', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(148965, NULL, 'G3DSA:3.30.70.2470:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148966, NULL, 'G3DSA:3.40.50.720:FF:001883', NULL, NULL, 'NADPH-dependent pterin aldehyde reductase', NULL, NULL, NULL, NULL, NULL, 4),
(148967, NULL, 'G3DSA:3.30.540.10:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148968, NULL, 'G3DSA:3.30.565.10:FF:000058', NULL, NULL, 'Sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(148969, NULL, 'G3DSA:1.10.3120.10:FF:000003', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(148970, NULL, 'G3DSA:1.10.275.40:FF:000023', NULL, NULL, 'ERCC2/XPD/Rad3-related DNA repair helicase', NULL, NULL, NULL, NULL, NULL, 4),
(148971, NULL, 'G3DSA:1.10.510.10:FF:002911', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148972, NULL, 'G3DSA:2.60.40.10:FF:003988', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148973, NULL, 'G3DSA:3.40.50.300:FF:003117', NULL, NULL, 'Putative ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(148974, NULL, 'G3DSA:3.30.70.2460:FF:000001', NULL, NULL, 'DNA repair protein Rad4 family', NULL, NULL, NULL, NULL, NULL, 4),
(148975, NULL, 'G3DSA:1.20.1250.20:FF:001772', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148976, NULL, 'G3DSA:3.30.160.60:FF:006383', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148977, NULL, 'G3DSA:1.10.8.10:FF:000100', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(148978, NULL, 'G3DSA:2.170.130.10:FF:000064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148979, NULL, 'G3DSA:3.40.50.300:FF:008244', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(148980, NULL, 'G3DSA:3.30.160.60:FF:000767', NULL, NULL, 'WW domain-binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(148981, NULL, 'G3DSA:3.30.420.10:FF:000020', NULL, NULL, 'Exodeoxyribonuclease X', NULL, NULL, NULL, NULL, NULL, 4),
(148982, NULL, 'G3DSA:3.40.50.2300:FF:000810', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148983, NULL, 'G3DSA:1.10.8.270:FF:000177', NULL, NULL, 'TBC1 domain family member 5 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(148984, NULL, 'G3DSA:3.30.46.10:FF:000009', NULL, NULL, 'Glycine N-methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(148985, NULL, 'G3DSA:1.10.510.10:FF:004373', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148986, NULL, 'G3DSA:3.30.70.370:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(148987, NULL, 'G3DSA:1.10.10.10:FF:000309', NULL, NULL, 'Transcriptional activatory protein CaiF', NULL, NULL, NULL, NULL, NULL, 4),
(148988, NULL, 'G3DSA:3.30.70.330:FF:000620', NULL, NULL, 'Interferon induced protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(148989, NULL, 'G3DSA:2.130.10.10:FF:000077', NULL, NULL, 'WD repeat domain 33', NULL, NULL, NULL, NULL, NULL, 4),
(148990, NULL, 'G3DSA:1.10.10.60:FF:000627', NULL, NULL, 'Transcriptional regulator AraC/XylS family', NULL, NULL, NULL, NULL, NULL, 4),
(148991, NULL, 'G3DSA:2.170.40.20:FF:000006', NULL, NULL, 'Envelope glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(148992, NULL, 'G3DSA:3.30.457.40:FF:000001', NULL, NULL, 'AT07283p', NULL, NULL, NULL, NULL, NULL, 4),
(148993, NULL, 'G3DSA:2.40.100.10:FF:000149', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(148994, NULL, 'G3DSA:2.30.40.10:FF:000004', NULL, NULL, 'Allantoinase', NULL, NULL, NULL, NULL, NULL, 4),
(148995, NULL, 'G3DSA:3.90.550.10:FF:000308', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(148996, NULL, 'G3DSA:3.40.50.300:FF:004747', NULL, NULL, 'Adenylate kinase isoenzyme 6-like isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(148997, NULL, 'G3DSA:3.30.457.50:FF:000004', NULL, NULL, 'Spc25p', NULL, NULL, NULL, NULL, NULL, 4),
(148998, NULL, 'G3DSA:1.20.1080.10:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(148999, NULL, 'G3DSA:3.90.79.10:FF:000156', NULL, NULL, 'ADP-ribose pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(149000, NULL, 'G3DSA:1.20.1310.10:FF:000195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149001, NULL, 'G3DSA:3.30.200.20:FF:001895', NULL, NULL, 'Protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(149002, NULL, 'G3DSA:1.10.10.10:FF:002097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149003, NULL, 'G3DSA:2.60.120.560:FF:000015', NULL, NULL, 'Glycosyl hydrolases family 32 superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(149004, NULL, 'G3DSA:3.40.50.2300:FF:000355', NULL, NULL, 'Transcription factor SKN7', NULL, NULL, NULL, NULL, NULL, 4),
(149005, NULL, 'G3DSA:3.40.50.300:FF:000476', NULL, NULL, 'RNA helicase aquarius', NULL, NULL, NULL, NULL, NULL, 4),
(149006, NULL, 'G3DSA:3.30.457.60:FF:000007', NULL, NULL, 'Mitotic spindle assembly checkpoint protein MAD1', NULL, NULL, NULL, NULL, NULL, 4),
(149007, NULL, 'G3DSA:2.30.130.110:FF:000001', NULL, NULL, 'Galactarate dehydratase (L-threo-forming)', NULL, NULL, NULL, NULL, NULL, 4),
(149008, NULL, 'G3DSA:3.30.160.60:FF:002454', NULL, NULL, 'PR domain containing 10', NULL, NULL, NULL, NULL, NULL, 4),
(149009, NULL, 'G3DSA:1.20.58.390:FF:000076', NULL, NULL, 'Glutamate-gated chloride channel, putative', NULL, NULL, NULL, NULL, NULL, 4),
(149010, NULL, 'G3DSA:3.10.150.10:FF:000032', NULL, NULL, 'Putative DNA polymerase III beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(149011, NULL, 'G3DSA:3.30.160.60:FF:001043', NULL, NULL, 'Zinc finger protein 462', NULL, NULL, NULL, NULL, NULL, 4),
(149012, NULL, 'G3DSA:3.10.20.30:FF:000019', NULL, NULL, 'NADH oxidoreductase hcr', NULL, NULL, NULL, NULL, NULL, 4),
(149013, NULL, 'G3DSA:1.10.472.10:FF:000545', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149014, NULL, 'G3DSA:3.10.110.10:FF:000260', NULL, NULL, 'UEV domain/Zinc finger, C3HC4 type (RING finger), putative', NULL, NULL, NULL, NULL, NULL, 4),
(149015, NULL, 'G3DSA:1.20.1250.20:FF:001446', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149016, NULL, 'G3DSA:3.40.50.300:FF:001100', NULL, NULL, 'intraflagellar transport protein 22 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(149017, NULL, 'G3DSA:3.80.20.20:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149018, NULL, 'G3DSA:3.20.20.300:FF:000070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149019, NULL, 'G3DSA:3.40.309.10:FF:000017', NULL, NULL, 'Aldehyde dehydrogenase B', NULL, NULL, NULL, NULL, NULL, 4),
(149020, NULL, 'G3DSA:3.30.160.60:FF:004590', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149021, NULL, 'G3DSA:1.20.58.420:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149022, NULL, 'G3DSA:3.40.50.10950:FF:000004', NULL, NULL, 'NADP-dependent malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(149023, NULL, 'G3DSA:1.20.120.980:FF:000027', NULL, NULL, 'Serine peptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(149024, NULL, 'G3DSA:3.30.310.80:FF:000010', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(149025, NULL, 'G3DSA:3.40.50.300:FF:005023', NULL, NULL, 'RAD51 paralog B', NULL, NULL, NULL, NULL, NULL, 4),
(149026, NULL, 'G3DSA:3.10.20.10:FF:000013', NULL, NULL, '60S ribosomal protein L18a', NULL, NULL, NULL, NULL, NULL, 4),
(149027, NULL, 'G3DSA:3.40.50.1820:FF:001167', NULL, NULL, '1-alkyl-2-acetylglycerophosphocholine esterase', NULL, NULL, NULL, NULL, NULL, 4),
(149028, NULL, 'G3DSA:1.10.8.710:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149029, NULL, 'G3DSA:3.10.50.40:FF:000069', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(149030, NULL, 'G3DSA:3.10.20.90:FF:000891', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149031, NULL, 'G3DSA:1.10.510.10:FF:000876', NULL, NULL, 'Receptor-like protein kinase FERONIA', NULL, NULL, NULL, NULL, NULL, 4),
(149032, NULL, 'G3DSA:3.40.50.150:FF:001122', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149033, NULL, 'G3DSA:3.30.40.10:FF:000401', NULL, NULL, 'lysine-specific demethylase 5C isoform X4', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(149034, NULL, 'G3DSA:2.70.150.10:FF:000281', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(149035, NULL, 'G3DSA:3.30.200.20:FF:000607', NULL, NULL, 'Nuclear receptor-binding protein 2a', NULL, NULL, NULL, NULL, NULL, 4),
(149036, NULL, 'G3DSA:1.25.40.20:FF:001152', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(149037, NULL, 'G3DSA:3.40.50.720:FF:001664', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(149038, NULL, 'G3DSA:3.40.47.10:FF:000023', NULL, NULL, 'Acetyl-CoA acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(149039, NULL, 'G3DSA:1.25.40.20:FF:000876', NULL, NULL, 'Protein phosphatase 1 regulatory subunit 12A', NULL, NULL, NULL, NULL, NULL, 4),
(149040, NULL, 'G3DSA:3.30.200.20:FF:000484', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(149041, NULL, 'G3DSA:3.90.226.10:FF:000257', NULL, NULL, 'Peptidase S41', NULL, NULL, NULL, NULL, NULL, 4),
(149042, NULL, 'G3DSA:1.25.40.10:FF:002234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149043, NULL, 'G3DSA:1.20.140.40:FF:000006', NULL, NULL, 'Pectinesterase inhibitor 3', NULL, NULL, NULL, NULL, NULL, 4),
(149044, NULL, 'G3DSA:3.40.50.10940:FF:000001', NULL, NULL, 'L-arabinose isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(149045, NULL, 'G3DSA:3.40.47.10:FF:000236', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149046, NULL, 'G3DSA:2.60.34.10:FF:000045', NULL, NULL, 'Heat shock protein 70, putative', NULL, NULL, NULL, NULL, NULL, 4),
(149047, NULL, 'G3DSA:1.25.10.10:FF:002513', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149048, NULL, 'G3DSA:1.10.510.10:FF:001500', NULL, NULL, 'CK1/CK1 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(149049, NULL, 'G3DSA:3.30.910.10:FF:000001', NULL, NULL, 'DNA damage-inducible protein I', NULL, NULL, NULL, NULL, NULL, 4),
(149050, NULL, 'G3DSA:3.30.910.20:FF:000004', NULL, NULL, 'Outer membrane chaperone Skp (OmpH)', NULL, NULL, NULL, NULL, NULL, 4),
(149051, NULL, 'G3DSA:2.130.10.10:FF:004348', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149052, NULL, 'G3DSA:3.30.1370.10:FF:000144', NULL, NULL, 'Drosophila dodeca-satellite protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(149053, NULL, 'G3DSA:1.20.144.10:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149054, NULL, 'G3DSA:1.10.150.20:FF:000115', NULL, NULL, 'DNA repair protein REV1', NULL, NULL, NULL, NULL, NULL, 4),
(149055, NULL, 'G3DSA:1.10.150.240:FF:000027', NULL, NULL, 'HAD superfamily hydrolase (TIGR01509 family)', NULL, NULL, NULL, NULL, NULL, 4),
(149056, NULL, 'G3DSA:1.25.10.10:FF:002732', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149057, NULL, 'G3DSA:3.40.50.1820:FF:001386', NULL, NULL, 'Esterase alnB', NULL, NULL, NULL, NULL, NULL, 4),
(149058, NULL, 'G3DSA:3.40.50.2000:FF:000260', NULL, NULL, 'Starch synthase, chloroplastic/amyloplastic', NULL, NULL, NULL, NULL, NULL, 4),
(149059, NULL, 'G3DSA:1.20.140.30:FF:000003', NULL, NULL, 'MOB kinase activator 2', NULL, NULL, NULL, NULL, NULL, 4),
(149060, NULL, 'G3DSA:3.30.70.330:FF:000272', NULL, NULL, 'Serine/arginine-rich splicing factor RS2Z32', NULL, NULL, NULL, NULL, NULL, 4),
(149061, NULL, 'G3DSA:3.40.50.880:FF:000054', NULL, NULL, 'Folate gamma-glutamyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(149062, NULL, 'G3DSA:2.10.25.10:FF:001454', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149063, NULL, 'G3DSA:3.30.70.330:FF:000401', NULL, NULL, '30S ribosomal protein 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(149064, NULL, 'G3DSA:1.20.140.150:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149065, NULL, 'G3DSA:2.60.40.10:FF:000329', NULL, NULL, 'Plexin A4', NULL, NULL, NULL, NULL, NULL, 4),
(149066, NULL, 'G3DSA:3.30.420.40:FF:000703', NULL, NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(149067, NULL, 'G3DSA:1.20.5.1300:FF:000010', NULL, NULL, 'Histidinol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(149068, NULL, 'G3DSA:3.30.160.60:FF:004819', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149069, NULL, 'G3DSA:3.90.1150.10:FF:000237', NULL, NULL, 'DegT/DnrJ/EryC1/StrS family aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(149070, NULL, 'G3DSA:2.130.10.10:FF:000296', NULL, NULL, 'WD repeat domain 11', NULL, NULL, NULL, NULL, NULL, 4),
(149071, NULL, 'G3DSA:3.90.550.10:FF:000527', NULL, NULL, '3-deoxy-manno-octulosonate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(149072, NULL, 'G3DSA:3.30.590.10:FF:000026', NULL, NULL, 'Creatine kinase B-type', NULL, NULL, NULL, NULL, NULL, 4),
(149073, NULL, 'G3DSA:3.10.50.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149074, NULL, 'G3DSA:1.20.58.390:FF:000295', NULL, NULL, 'Cholinergic receptor nicotinic gamma subunit', NULL, NULL, NULL, NULL, NULL, 4),
(149075, NULL, 'G3DSA:3.40.140.10:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149076, NULL, 'G3DSA:3.90.550.10:FF:000179', NULL, NULL, 'Phosphoglucomutase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(149077, NULL, 'G3DSA:3.50.50.60:FF:000157', NULL, NULL, 'NAD-dependent dihydropyrimidine dehydrogenase subunit PreT', NULL, NULL, NULL, NULL, NULL, 4),
(149078, NULL, 'G3DSA:1.10.1660.10:FF:000015', NULL, NULL, 'Transcriptional regulator, MerR family', NULL, NULL, NULL, NULL, NULL, 4),
(149079, NULL, 'G3DSA:2.130.10.10:FF:000638', NULL, NULL, 'U3 small nucleolar RNA-associated protein 4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(149080, NULL, 'G3DSA:1.20.1250.20:FF:001991', NULL, NULL, 'MFS polyamine transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(149081, NULL, 'G3DSA:3.40.50.2000:FF:000041', NULL, NULL, 'Glycogen [starch] synthase', NULL, NULL, NULL, NULL, NULL, 4),
(149082, NULL, 'G3DSA:3.30.1050.10:FF:000002', NULL, NULL, 'SCP2 domain-containing protein YhbT', NULL, NULL, NULL, NULL, NULL, 4),
(149083, NULL, 'G3DSA:2.130.10.10:FF:004567', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149084, NULL, 'G3DSA:3.30.200.20:FF:000265', NULL, NULL, 'Mitogen-activated protein kinase kinase 6', NULL, NULL, NULL, NULL, NULL, 4),
(149085, NULL, 'G3DSA:2.40.340.10:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149086, NULL, 'G3DSA:3.30.70.920:FF:000027', NULL, NULL, 'Transcriptional regulator, AsnC family', NULL, NULL, NULL, NULL, NULL, 4),
(149087, NULL, 'G3DSA:3.80.10.10:FF:001780', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149088, NULL, 'G3DSA:3.40.50.150:FF:000633', NULL, NULL, '3-demethylubiquinone-9 3-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(149089, NULL, 'G3DSA:1.10.3720.10:FF:000195', NULL, NULL, 'ABC transporter permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(149090, NULL, 'G3DSA:3.90.226.10:FF:000038', NULL, NULL, 'Retinol-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(149091, NULL, 'G3DSA:2.40.33.10:FF:000027', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(149092, NULL, 'G3DSA:3.40.50.300:FF:008463', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(149093, NULL, 'G3DSA:1.25.10.10:FF:000478', NULL, NULL, 'ARM-repeat/Tetratricopeptide repeat (TPR)-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(149094, NULL, 'G3DSA:1.20.58.1480:FF:000007', NULL, NULL, 'Lon protease homolog', NULL, NULL, NULL, NULL, NULL, 4),
(149095, NULL, 'G3DSA:3.50.50.60:FF:000505', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(149096, NULL, 'G3DSA:6.20.10.30:FF:000011', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(149097, NULL, 'G3DSA:2.120.10.30:FF:000044', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(149098, NULL, 'G3DSA:1.20.120.1630:FF:000010', NULL, NULL, 'Steroid alpha reductase family protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(149099, NULL, 'G3DSA:2.30.180.10:FF:000089', NULL, NULL, 'Transforming growth factor-beta-induced protein Ig-H3', NULL, NULL, NULL, NULL, NULL, 4),
(149100, NULL, 'G3DSA:3.30.160.60:FF:000548', NULL, NULL, 'Zinc finger protein 423', NULL, NULL, NULL, NULL, NULL, 4),
(149101, NULL, 'G3DSA:3.40.50.300:FF:005242', NULL, NULL, 'Septin AspA, putative', NULL, NULL, NULL, NULL, NULL, 4),
(149102, NULL, 'G3DSA:3.40.190.290:FF:000047', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(149103, NULL, 'G3DSA:3.30.50.10:FF:000014', NULL, NULL, 'Estrogen receptor beta', NULL, NULL, NULL, NULL, NULL, 4),
(149104, NULL, 'G3DSA:3.20.140.10:FF:000034', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(149105, NULL, 'G3DSA:3.40.50.720:FF:000034', NULL, NULL, 'Potassium channel subfamily T member 1', NULL, NULL, NULL, NULL, NULL, 4),
(149106, NULL, 'G3DSA:1.25.10.10:FF:001102', NULL, NULL, 'Tubulin-folding cofactor D', NULL, NULL, NULL, NULL, NULL, 4),
(149107, NULL, 'G3DSA:2.30.30.40:FF:000288', NULL, NULL, 'Calcium channel, voltage-dependent, beta 3b', NULL, NULL, NULL, NULL, NULL, 4),
(149108, NULL, 'G3DSA:3.40.50.300:FF:000695', NULL, NULL, 'Flagellar biosynthesis regulator FlhF', NULL, NULL, NULL, NULL, NULL, 4),
(149109, NULL, 'G3DSA:1.10.10.60:FF:000285', NULL, NULL, 'Homeobox protein', NULL, NULL, NULL, NULL, NULL, 4),
(149110, NULL, 'G3DSA:1.20.120.430:FF:000003', NULL, NULL, 'Related to GTPase MSS1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(149111, NULL, 'G3DSA:3.40.50.150:FF:000285', NULL, NULL, 'tRNA (cytosine(38)-C(5))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(149112, NULL, 'G3DSA:2.40.10.10:FF:000328', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149113, NULL, 'G3DSA:3.40.50.2300:FF:000136', NULL, NULL, 'PTS sugar transporter subunit IIB', NULL, NULL, NULL, NULL, NULL, 4),
(149114, NULL, 'G3DSA:3.30.565.10:FF:000277', NULL, NULL, 'Nitrogen fixation regulatory protein, NifL', NULL, NULL, NULL, NULL, NULL, 4),
(149115, NULL, 'G3DSA:3.30.200.20:FF:002171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149116, NULL, 'G3DSA:2.10.25.10:FF:000043', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(149117, NULL, 'G3DSA:3.30.50.10:FF:000121', NULL, NULL, 'Coup-like 1 transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(149118, NULL, 'G3DSA:1.20.1070.10:FF:001676', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149119, NULL, 'G3DSA:1.10.150.20:FF:000334', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4),
(149120, NULL, 'G3DSA:3.30.450.40:FF:000082', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(149121, NULL, 'G3DSA:1.20.1250.20:FF:001884', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149122, NULL, 'G3DSA:3.30.70.20:FF:000125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149123, NULL, 'G3DSA:3.30.70.330:FF:001688', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149124, NULL, 'G3DSA:3.30.70.330:FF:002306', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149125, NULL, 'G3DSA:1.10.340.30:FF:000037', NULL, NULL, 'Putative 8-oxoguanine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(149126, NULL, 'G3DSA:2.90.10.10:FF:000017', NULL, NULL, 'Putative receptor protein kinase ZmPK1', NULL, NULL, NULL, NULL, NULL, 4),
(149127, NULL, 'G3DSA:3.40.50.720:FF:001338', NULL, NULL, 'Insect-type dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(149128, NULL, 'G3DSA:3.40.532.10:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149129, NULL, 'G3DSA:1.10.510.10:FF:004479', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149130, NULL, 'G3DSA:2.60.40.60:FF:000760', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(149131, NULL, 'G3DSA:1.25.40.10:FF:000648', NULL, NULL, 'Signal recognition particle subunit SRP72', NULL, NULL, NULL, NULL, NULL, 4),
(149132, NULL, 'G3DSA:2.60.40.10:FF:004483', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(149133, NULL, 'G3DSA:3.30.870.10:FF:000065', NULL, NULL, 'Phospholipase D, putative', NULL, NULL, NULL, NULL, NULL, 4),
(149134, NULL, 'G3DSA:2.60.200.20:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149135, NULL, 'G3DSA:3.40.50.1980:FF:000096', NULL, NULL, 'Heme ABC superfamily ATP binding cassette transporter, binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(149136, NULL, 'G3DSA:1.20.58.2140:FF:000003', NULL, NULL, 'Translin', NULL, NULL, NULL, NULL, NULL, 4),
(149137, NULL, 'G3DSA:3.40.50.10810:FF:000086', NULL, NULL, 'CHD3-type chromatin-remodeling factor PICKLE', NULL, NULL, NULL, NULL, NULL, 4),
(149138, NULL, 'G3DSA:3.30.70.330:FF:000165', NULL, NULL, 'nuclear RNA export factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(149139, NULL, 'G3DSA:1.20.1560.10:FF:000123', NULL, NULL, 'Mini-chromosome maintenance complex-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(149140, NULL, 'G3DSA:3.30.1360.120:FF:000059', NULL, NULL, 'GTP-binding protein TrmE N-terminus-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(149141, NULL, 'G3DSA:3.30.470.30:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149142, NULL, 'G3DSA:1.10.760.10:FF:000029', NULL, NULL, 'Cytochrome c5', NULL, NULL, NULL, NULL, NULL, 4),
(149143, NULL, 'G3DSA:3.40.640.10:FF:000080', NULL, NULL, 'Aminotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(149144, NULL, 'G3DSA:2.130.10.10:FF:004129', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(149145, NULL, 'G3DSA:2.160.20.10:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149146, NULL, 'G3DSA:1.10.472.10:FF:000332', NULL, NULL, 'Putative ortholog of g2/mitotic-specific cyclin B3, 13 of 14', NULL, NULL, NULL, NULL, NULL, 4),
(149147, NULL, 'G3DSA:2.30.29.30:FF:000214', NULL, NULL, 'FACT complex subunit SSRP1', NULL, NULL, NULL, NULL, NULL, 4),
(149148, NULL, 'G3DSA:3.80.10.10:FF:001448', NULL, NULL, 'F-box/LRR protein', NULL, NULL, NULL, NULL, NULL, 4),
(149149, NULL, 'G3DSA:1.10.238.10:FF:000288', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(149150, NULL, 'G3DSA:3.40.50.300:FF:004528', NULL, NULL, 'ATP-dependent DEAD/H RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(149151, NULL, 'G3DSA:2.60.40.10:FF:004590', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149152, NULL, 'G3DSA:1.20.58.2220:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149153, NULL, 'G3DSA:3.40.50.1000:FF:000292', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(149154, NULL, 'G3DSA:1.25.40.280:FF:000011', NULL, NULL, 'pH-response regulator protein palA', NULL, NULL, NULL, NULL, NULL, 4),
(149155, NULL, 'G3DSA:3.90.640.10:FF:000051', NULL, NULL, 'Actin-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(149156, NULL, 'G3DSA:3.40.109.10:FF:000036', NULL, NULL, 'Oxygen-insensitive NAD(P)H nitroreductase', NULL, NULL, NULL, NULL, NULL, 4),
(149157, NULL, 'G3DSA:3.30.160.60:FF:004707', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149158, NULL, 'G3DSA:3.40.50.300:FF:006658', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149159, NULL, 'G3DSA:3.30.460.80:FF:000015', NULL, NULL, 'NADH-quinone oxidoreductase subunit B/C/D', NULL, NULL, NULL, NULL, NULL, 4),
(149160, NULL, 'G3DSA:3.30.565.10:FF:000283', NULL, NULL, 'Two-component system sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(149161, NULL, 'G3DSA:1.25.40.10:FF:002902', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149162, NULL, 'G3DSA:3.20.20.150:FF:000002', NULL, NULL, 'Xylose isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(149163, NULL, 'G3DSA:1.25.10.10:FF:002283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149164, NULL, 'G3DSA:2.60.40.60:FF:000647', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(149165, NULL, 'G3DSA:2.60.34.10:FF:000039', NULL, NULL, 'Heat shock protein 70, putative', NULL, NULL, NULL, NULL, NULL, 4),
(149166, NULL, 'G3DSA:1.10.3720.10:FF:000083', NULL, NULL, 'Amino acid ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(149167, NULL, 'G3DSA:1.10.560.10:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149168, NULL, 'G3DSA:3.30.40.10:FF:001817', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149169, NULL, 'G3DSA:2.40.320.10:FF:000025', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 18', NULL, NULL, NULL, NULL, NULL, 4),
(149170, NULL, 'G3DSA:3.30.30.10:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149171, NULL, 'G3DSA:3.40.50.1820:FF:001616', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149172, NULL, 'G3DSA:3.40.50.970:FF:000075', NULL, NULL, 'Oxoglutarate dehydrogenase (Succinyl-transferring), E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(149173, NULL, 'G3DSA:3.80.10.10:FF:000251', NULL, NULL, 'Ubiquitin ligase complex F-box protein GRR1', NULL, NULL, NULL, NULL, NULL, 4),
(149174, NULL, 'G3DSA:3.40.50.300:FF:001083', NULL, NULL, 'Chromosome transmission fidelity factor 18', NULL, NULL, NULL, NULL, NULL, 4),
(149175, NULL, 'G3DSA:1.20.58.1480:FF:000013', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(149176, NULL, 'G3DSA:2.10.25.10:FF:001128', NULL, NULL, 'von Willebrand factor D and EGF domains', NULL, NULL, NULL, NULL, NULL, 4),
(149177, NULL, 'G3DSA:1.20.1720.10:FF:000001', NULL, NULL, 'Putative multidrug resistance protein MdtD', NULL, NULL, NULL, NULL, NULL, 4),
(149178, NULL, 'G3DSA:1.10.10.60:FF:000852', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149179, NULL, 'G3DSA:3.40.47.10:FF:000017', NULL, NULL, 'Acetyl-CoA acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(149180, NULL, 'G3DSA:3.40.630.10:FF:000472', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(149181, NULL, 'G3DSA:1.10.1820.10:FF:000005', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(149182, NULL, 'G3DSA:1.10.238.10:FF:001232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149183, NULL, 'G3DSA:2.60.40.1360:FF:000007', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(149184, NULL, 'G3DSA:1.10.10.10:FF:000298', NULL, NULL, 'Response regulator (OmpR)', NULL, NULL, NULL, NULL, NULL, 4),
(149185, NULL, 'G3DSA:3.30.260.10:FF:000035', NULL, NULL, 'T-complex protein 1 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(149186, NULL, 'G3DSA:2.130.10.10:FF:000863', NULL, NULL, 'U4/U6 small nuclear ribonucleoprotein PRP4', NULL, NULL, NULL, NULL, NULL, 4),
(149187, NULL, 'G3DSA:3.40.50.720:FF:001670', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(149188, NULL, 'G3DSA:2.120.10.30:FF:000156', NULL, NULL, 'GM17661', NULL, NULL, NULL, NULL, NULL, 4),
(149189, NULL, 'G3DSA:2.30.42.10:FF:000520', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149190, NULL, 'G3DSA:2.60.40.10:FF:005101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149191, NULL, 'G3DSA:2.40.50.320:FF:000002', NULL, NULL, 'Type 4 fimbrial biogenesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(149192, NULL, 'G3DSA:3.80.10.10:FF:001774', NULL, NULL, 'F-box/LRR-repeat protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(149193, NULL, 'G3DSA:3.10.450.50:FF:000055', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(149194, NULL, 'G3DSA:3.40.50.300:FF:003224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149195, NULL, 'G3DSA:1.10.443.10:FF:000017', NULL, NULL, 'NifD element site-specific recombinase XisA', NULL, NULL, NULL, NULL, NULL, 4),
(149196, NULL, 'G3DSA:3.30.1680.10:FF:000027', NULL, NULL, 'Sema domain, immunoglobulin domain (Ig), transmembrane domain (TM) and short cytoplasmic domain, (semaphorin) 4Ga', NULL, NULL, NULL, NULL, NULL, 4),
(149197, NULL, 'G3DSA:1.10.510.10:FF:002349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(149198, NULL, 'G3DSA:1.25.40.20:FF:001601', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(149199, NULL, 'G3DSA:2.130.10.10:FF:000970', NULL, NULL, 'Nuclear pore complex component (Sc Seh1)', NULL, NULL, NULL, NULL, NULL, 4),
(149200, NULL, 'G3DSA:3.10.450.40:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149201, NULL, 'G3DSA:2.40.50.140:FF:000611', NULL, NULL, 'Replication protein A 32 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(149202, NULL, 'G3DSA:2.60.120.200:FF:000143', NULL, NULL, 'Crumbs, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(149203, NULL, 'G3DSA:2.60.40.10:FF:000099', NULL, NULL, 'Fibronectin 1', NULL, NULL, NULL, NULL, NULL, 4),
(149204, NULL, 'G3DSA:3.10.20.90:FF:000447', NULL, NULL, 'Large proline-rich protein bag6-A', NULL, NULL, NULL, NULL, NULL, 4),
(149205, NULL, 'G3DSA:2.60.40.790:FF:000187', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149206, NULL, 'G3DSA:3.80.10.10:FF:003702', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(149207, NULL, 'G3DSA:3.30.420.40:FF:000473', NULL, NULL, 'EryA, erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(149208, NULL, 'G3DSA:3.30.1370.50:FF:000021', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(149209, NULL, 'G3DSA:3.40.630.30:FF:000478', NULL, NULL, 'GCN5-related N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(149210, NULL, 'G3DSA:1.20.58.60:FF:000321', NULL, NULL, 'SMAll', NULL, NULL, NULL, NULL, NULL, 4),
(149211, NULL, 'G3DSA:2.40.50.100:FF:000173', NULL, NULL, 'ABC transporter, ATP binding protein (Glucose)', NULL, NULL, NULL, NULL, NULL, 4),
(149212, NULL, 'G3DSA:3.40.30.10:FF:001108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149213, NULL, 'G3DSA:3.40.50.1000:FF:000179', NULL, NULL, 'Hydrolase family protein / HAD-superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(149214, NULL, 'G3DSA:1.10.510.10:FF:002681', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149215, NULL, 'G3DSA:1.20.144.10:FF:000017', NULL, NULL, 'Diacylglycerol pyrophosphate phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(149216, NULL, 'G3DSA:2.60.40.1120:FF:000065', NULL, NULL, 'Putative cell surface-anchored phosphoesterase', NULL, NULL, NULL, NULL, NULL, 4),
(149217, NULL, 'G3DSA:2.40.30.170:FF:000043', NULL, NULL, 'RND transporter MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(149218, NULL, 'G3DSA:3.90.740.10:FF:000008', NULL, NULL, 'Valine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(149219, NULL, 'G3DSA:3.30.750.24:FF:000108', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(149220, NULL, 'G3DSA:2.10.25.10:FF:001235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149221, NULL, 'G3DSA:1.10.238.10:FF:000395', NULL, NULL, 'Calcium-dependent protein kinase 23', NULL, NULL, NULL, NULL, NULL, 4),
(149222, NULL, 'G3DSA:1.10.238.10:FF:001013', NULL, NULL, 'UBA domain-containing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(149223, NULL, 'G3DSA:2.60.40.60:FF:000428', NULL, NULL, 'Protocadherin 20', NULL, NULL, NULL, NULL, NULL, 4),
(149224, NULL, 'G3DSA:1.25.10.10:FF:000372', NULL, NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(149225, NULL, 'G3DSA:3.90.226.10:FF:000145', NULL, NULL, 'Carboxy-terminal processing protease', NULL, NULL, NULL, NULL, NULL, 4),
(149226, NULL, 'G3DSA:3.90.79.10:FF:000044', NULL, NULL, 'protein syndesmos isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(149227, NULL, 'G3DSA:1.20.120.980:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149228, NULL, 'G3DSA:3.40.630.10:FF:000359', NULL, NULL, 'Peptidase M20 domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(149229, NULL, 'G3DSA:1.20.120.230:FF:000038', NULL, NULL, 'Cas scaffold protein family member 4', NULL, NULL, NULL, NULL, NULL, 4),
(149230, NULL, 'G3DSA:3.80.10.10:FF:003921', NULL, NULL, 'AGAP011649-PA', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(149231, NULL, 'G3DSA:2.10.25.10:FF:001347', NULL, NULL, 'Laminin, gamma 3', NULL, NULL, NULL, NULL, NULL, 4),
(149232, NULL, 'G3DSA:3.30.160.60:FF:004926', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149233, NULL, 'G3DSA:2.60.40.10:FF:000992', NULL, NULL, 'Phosphoglucan phosphatase DSP4, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(149234, NULL, 'G3DSA:1.10.506.10:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149235, NULL, 'G3DSA:3.50.50.60:FF:000382', NULL, NULL, 'L-aspartate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(149236, NULL, 'G3DSA:3.80.10.10:FF:001555', NULL, NULL, 'Ubiquitin-like_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(149237, NULL, 'G3DSA:3.80.10.10:FF:001667', NULL, NULL, 'F-box/LRR-repeat protein 20 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(149238, NULL, 'G3DSA:3.40.50.880:FF:000161', NULL, NULL, 'Biotin--[acetyl-CoA-carboxylase] ligase', NULL, NULL, NULL, NULL, NULL, 4),
(149239, NULL, 'G3DSA:3.40.190.10:FF:000443', NULL, NULL, 'Phosphate ABC transporter, phosphate-binding component', NULL, NULL, NULL, NULL, NULL, 4),
(149240, NULL, 'G3DSA:1.20.58.70:FF:000088', NULL, NULL, 'AFL232Wp', NULL, NULL, NULL, NULL, NULL, 4),
(149241, NULL, 'G3DSA:3.40.190.10:FF:000224', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(149242, NULL, 'G3DSA:2.170.8.10:FF:000013', NULL, NULL, 'Phosphoenolpyruvate carboxykinase', NULL, NULL, NULL, NULL, NULL, 4),
(149243, NULL, 'G3DSA:1.25.40.10:FF:000980', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(149244, NULL, 'G3DSA:3.40.309.10:FF:000023', NULL, NULL, 'Aldehyde dehydrogenase 12', NULL, NULL, NULL, NULL, NULL, 4),
(149245, NULL, 'G3DSA:1.20.1560.10:FF:000016', NULL, NULL, 'ATP-binding cassette sub-family B member 8, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(149246, NULL, 'G3DSA:1.25.40.20:FF:000983', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149247, NULL, 'G3DSA:1.10.510.10:FF:001045', NULL, NULL, 'Serine/threonine-protein kinase SKY1', NULL, NULL, NULL, NULL, NULL, 4),
(149248, NULL, 'G3DSA:2.60.40.60:FF:001035', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(149249, NULL, 'G3DSA:1.20.1740.10:FF:000002', NULL, NULL, 'Putative solute carrier family 12 member 4', NULL, NULL, NULL, NULL, NULL, 4),
(149250, NULL, 'G3DSA:3.90.70.10:FF:000395', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 2', NULL, NULL, NULL, NULL, NULL, 4),
(149251, NULL, 'G3DSA:3.40.50.720:FF:001557', NULL, NULL, '3-ketodihydrosphingosine reductase TSC10', NULL, NULL, NULL, NULL, NULL, 4),
(149252, NULL, 'G3DSA:1.10.472.10:FF:000551', NULL, NULL, 'Cyclin, N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(149253, NULL, 'G3DSA:3.30.565.10:FF:000390', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(149254, NULL, 'G3DSA:1.20.1640.10:FF:000074', NULL, NULL, 'PaTched Related family', NULL, NULL, NULL, NULL, NULL, 4),
(149255, NULL, 'G3DSA:2.40.10.10:FF:000553', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149256, NULL, 'G3DSA:1.20.930.80:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149257, NULL, 'G3DSA:2.130.10.10:FF:004461', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(149258, NULL, 'G3DSA:2.40.50.770:FF:000002', NULL, NULL, 'recQ-mediated genome instability protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(149259, NULL, 'G3DSA:3.90.1750.10:FF:000098', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(149260, NULL, 'G3DSA:3.40.50.1820:FF:000998', NULL, NULL, 'GPI inositol-deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(149261, NULL, 'G3DSA:3.40.47.10:FF:000129', NULL, NULL, '3-hydroxy-3-methylglutaryl coenzyme A synthase', NULL, NULL, NULL, NULL, NULL, 4),
(149262, NULL, 'G3DSA:1.20.58.1880:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149263, NULL, 'G3DSA:3.30.519.10:FF:000007', NULL, NULL, 'Rab proteins geranylgeranyltransferase component A', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(149264, NULL, 'G3DSA:3.40.50.150:FF:000178', NULL, NULL, 'Anamorsin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(149265, NULL, 'G3DSA:3.40.50.1980:FF:000113', NULL, NULL, 'Periplasmic divalent manganese/zinc-binding lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(149266, NULL, 'G3DSA:3.30.950.30:FF:000004', NULL, NULL, 'Divergent AAA domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(149267, NULL, 'G3DSA:1.25.10.10:FF:000933', NULL, NULL, 'Symplekin', NULL, NULL, NULL, NULL, NULL, 4),
(149268, NULL, 'G3DSA:1.10.10.10:FF:000192', NULL, NULL, 'AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(149269, NULL, 'G3DSA:3.90.70.10:FF:000176', NULL, NULL, 'Ubiquitin-specific protease', NULL, NULL, NULL, NULL, NULL, 4),
(149270, NULL, 'G3DSA:1.20.58.60:FF:000102', NULL, NULL, 'utrophin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(149271, NULL, 'G3DSA:1.10.8.270:FF:000183', NULL, NULL, 'RabGAP/TBC domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(149272, NULL, 'G3DSA:1.10.510.10:FF:002462', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149273, NULL, 'G3DSA:3.90.1170.10:FF:000020', NULL, NULL, '39S ribosomal protein L16, mitochondrial-like', NULL, NULL, NULL, NULL, NULL, 4),
(149274, NULL, 'G3DSA:3.30.160.60:FF:001262', NULL, NULL, 'zinc finger protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(149275, NULL, 'G3DSA:2.130.10.120:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149276, NULL, 'G3DSA:3.40.1410.10:FF:000022', NULL, NULL, 'Transcriptional regulator, GntR family', NULL, NULL, NULL, NULL, NULL, 4),
(149277, NULL, 'G3DSA:1.10.287.40:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149278, NULL, 'G3DSA:3.30.230.70:FF:000080', NULL, NULL, 'Exosome complex component RRP42', NULL, NULL, NULL, NULL, NULL, 4),
(149279, NULL, 'G3DSA:2.60.40.2030:FF:000006', NULL, NULL, 'Fraser extracellular matrix complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(149280, NULL, 'G3DSA:3.50.50.60:FF:000270', NULL, NULL, 'FAD/NAD(P)-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(149281, NULL, 'G3DSA:1.10.1070.11:FF:000095', NULL, NULL, 'Phosphatidylinositol 3-kinase piki-1', NULL, NULL, NULL, NULL, NULL, 4),
(149282, NULL, 'G3DSA:3.40.50.720:FF:000141', NULL, NULL, 'tRNA threonylcarbamoyladenosine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(149283, NULL, 'G3DSA:3.30.160.60:FF:006057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149284, NULL, 'G3DSA:1.20.1050.10:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149285, NULL, 'G3DSA:3.10.110.10:FF:000035', NULL, NULL, 'SUMO-conjugating enzyme ubc9', NULL, NULL, NULL, NULL, NULL, 4),
(149286, NULL, 'G3DSA:3.10.129.10:FF:000280', NULL, NULL, 'Acyl-CoA thioesterase 9, tandem duplicate 1', NULL, NULL, NULL, NULL, NULL, 4),
(149287, NULL, 'G3DSA:3.90.1170.50:FF:000003', NULL, NULL, 'Aldehyde oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(149288, NULL, 'G3DSA:3.30.420.40:FF:000254', NULL, NULL, 'Heat shock protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(149289, NULL, 'G3DSA:3.30.200.20:FF:002064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149290, NULL, 'G3DSA:3.30.160.60:FF:000655', NULL, NULL, 'Zinc finger protein 462', NULL, NULL, NULL, NULL, NULL, 4),
(149291, NULL, 'G3DSA:3.40.630.30:FF:000697', NULL, NULL, 'RNA cytidine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(149292, NULL, 'G3DSA:3.30.1490.100:FF:000003', NULL, NULL, 'Polymerase (DNA directed) iota', NULL, NULL, NULL, NULL, NULL, 4),
(149293, NULL, 'G3DSA:1.10.1070.11:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149294, NULL, 'G3DSA:1.10.472.10:FF:000219', NULL, NULL, 'Cyclin-D5-1', NULL, NULL, NULL, NULL, NULL, 4),
(149295, NULL, 'G3DSA:1.10.10.60:FF:000740', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149296, NULL, 'G3DSA:1.20.1250.20:FF:000136', NULL, NULL, 'Major facilitator superfamily domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(149297, NULL, 'G3DSA:1.20.1540.10:FF:000015', NULL, NULL, 'RHOMBOID-like protein 10 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(149298, NULL, 'G3DSA:2.10.25.10:FF:000150', NULL, NULL, 'Fibulin-1', NULL, NULL, NULL, NULL, NULL, 4),
(149299, NULL, 'G3DSA:2.30.30.40:FF:000395', NULL, NULL, 'Chemotaxis protein CheA', NULL, NULL, NULL, NULL, NULL, 4),
(149300, NULL, 'G3DSA:2.120.10.80:FF:000143', NULL, NULL, 'Multistep regulator of cAMP-PKA signaling', NULL, NULL, NULL, NULL, NULL, 4),
(149301, NULL, 'G3DSA:2.60.40.150:FF:000804', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149302, NULL, 'G3DSA:3.40.50.300:FF:004860', NULL, NULL, 'MutS domain V domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(149303, NULL, 'G3DSA:3.10.20.90:FF:000666', NULL, NULL, 'NEDD8 protein', NULL, NULL, NULL, NULL, NULL, 4),
(149304, NULL, 'G3DSA:2.60.40.2020:FF:000003', NULL, NULL, 'Cysteine peptidase inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(149305, NULL, 'G3DSA:1.20.120.140:FF:000017', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(149306, NULL, 'G3DSA:1.20.1070.10:FF:001783', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149307, NULL, 'G3DSA:3.30.450.190:FF:000012', NULL, NULL, 'Unplaced genomic scaffold supercont1.38, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(149308, NULL, 'G3DSA:1.20.120.810:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149309, NULL, 'G3DSA:3.10.660.10:FF:000008', NULL, NULL, 'CSL zinc finger', NULL, NULL, NULL, NULL, NULL, 4),
(149310, NULL, 'G3DSA:3.90.550.10:FF:000634', NULL, NULL, 'Glycosyl transferase, group 2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(149311, NULL, 'G3DSA:2.60.40.10:FF:005320', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149312, NULL, 'G3DSA:1.20.58.70:FF:000105', NULL, NULL, 'Diablo, IAP-binding mitochondrial protein b', NULL, NULL, NULL, NULL, NULL, 4),
(149313, NULL, 'G3DSA:3.40.140.10:FF:000277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149314, NULL, 'G3DSA:2.30.42.10:FF:000301', NULL, NULL, 'PDZ and LIM domain protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(149315, NULL, 'G3DSA:3.30.360.10:FF:000088', NULL, NULL, 'Dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(149316, NULL, 'G3DSA:1.10.3720.10:FF:000206', NULL, NULL, 'Peptide ABC transporter permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(149317, NULL, 'G3DSA:3.30.160.60:FF:006276', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149318, NULL, 'G3DSA:2.70.170.10:FF:000169', NULL, NULL, 'Nicotinic acetylcholine receptor alpha 9 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(149319, NULL, 'G3DSA:1.25.40.10:FF:004471', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149320, NULL, 'G3DSA:3.20.20.100:FF:000015', NULL, NULL, 'Oxidoreductase, aldo/keto reductase family', NULL, NULL, NULL, NULL, NULL, 4),
(149321, NULL, 'G3DSA:3.90.290.10:FF:000029', NULL, NULL, 'Fibrillin-1', NULL, NULL, NULL, NULL, NULL, 4),
(149322, NULL, 'G3DSA:3.40.50.300:FF:006439', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149323, NULL, 'G3DSA:2.160.20.10:FF:000216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149324, NULL, 'G3DSA:1.20.1070.10:FF:001564', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149325, NULL, 'G3DSA:2.10.310.10:FF:000003', NULL, NULL, 'Serpin peptidase inhibitor 28', NULL, NULL, NULL, NULL, NULL, 4),
(149326, NULL, 'G3DSA:1.25.40.10:FF:004813', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149327, NULL, 'G3DSA:2.40.128.130:FF:000002', NULL, NULL, 'Putative outer membrane autotransporter', NULL, NULL, NULL, NULL, NULL, 4),
(149328, NULL, 'G3DSA:3.30.465.10:FF:000005', NULL, NULL, 'Integral membrane protein TerC', NULL, NULL, NULL, NULL, NULL, 4),
(149329, NULL, 'G3DSA:3.30.230.10:FF:000320', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(149330, NULL, 'G3DSA:2.20.70.10:FF:000153', NULL, NULL, 'Pre-mRNA-processing factor 40 homolog A-like Protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(149331, NULL, 'G3DSA:3.50.50.60:FF:001467', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149332, NULL, 'G3DSA:3.10.310.20:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149333, NULL, 'G3DSA:1.20.120.1900:FF:000018', NULL, NULL, 'Gamma-tubulin complex component 6 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(149334, NULL, 'G3DSA:1.20.1070.10:FF:001906', NULL, NULL, 'G protein-coupled receptor 85', NULL, NULL, NULL, NULL, NULL, 4),
(149335, NULL, 'G3DSA:1.50.40.10:FF:000585', NULL, NULL, 'Solute carrier family 25 member 47', NULL, NULL, NULL, NULL, NULL, 4),
(149336, NULL, 'G3DSA:3.40.50.300:FF:006097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149337, NULL, 'G3DSA:3.40.50.300:FF:002168', NULL, NULL, 'Dephospho-CoA kinase', NULL, NULL, NULL, NULL, NULL, 4),
(149338, NULL, 'G3DSA:1.10.472.10:FF:000096', NULL, NULL, 'G1/S-specific cyclin-D3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(149339, NULL, 'G3DSA:2.30.30.40:FF:000631', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149340, NULL, 'G3DSA:3.10.310.10:FF:000022', NULL, NULL, 'Diaminopimelate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(149341, NULL, 'G3DSA:1.20.1090.10:FF:000036', NULL, NULL, 'Glycerol-1-phosphate dehydrogenase [NAD(P)+]', NULL, NULL, NULL, NULL, NULL, 4),
(149342, NULL, 'G3DSA:1.25.10.10:FF:001788', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(149343, NULL, 'G3DSA:3.50.4.10:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149344, NULL, 'G3DSA:3.90.950.10:FF:000041', NULL, NULL, 'dTTP/UTP pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(149345, NULL, 'G3DSA:1.10.510.10:FF:000438', NULL, NULL, 'Tau tubulin kinase 2b', NULL, NULL, NULL, NULL, NULL, 4),
(149346, NULL, 'G3DSA:3.40.50.1440:FF:000069', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(149347, NULL, 'G3DSA:3.40.50.1820:FF:000312', NULL, NULL, 'Lipase H', NULL, NULL, NULL, NULL, NULL, 4),
(149348, NULL, 'G3DSA:1.25.40.530:FF:000007', NULL, NULL, 'Rho GTPase-activating protein 39', NULL, NULL, NULL, NULL, NULL, 4),
(149349, NULL, 'G3DSA:2.60.40.10:FF:002572', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(149350, NULL, 'G3DSA:3.30.160.60:FF:002347', NULL, NULL, 'Potential zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(149351, NULL, 'G3DSA:3.40.640.10:FF:000192', NULL, NULL, 'Perosamine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(149352, NULL, 'G3DSA:3.90.550.50:FF:000056', NULL, NULL, 'Beta 3-glucosyltransferase b', NULL, NULL, NULL, NULL, NULL, 4),
(149353, NULL, 'G3DSA:1.10.1420.10:FF:000037', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(149354, NULL, 'G3DSA:2.40.50.140:FF:000050', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(149355, NULL, 'G3DSA:3.60.10.10:FF:000201', NULL, NULL, 'DNA-(Apurinic or apyrimidinic site) lyase,putative', NULL, NULL, NULL, NULL, NULL, 4),
(149356, NULL, 'G3DSA:2.40.160.10:FF:000041', NULL, NULL, 'Outer membrane protein U porin OmpU', NULL, NULL, NULL, NULL, NULL, 4),
(149357, NULL, 'G3DSA:3.30.379.10:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149358, NULL, 'G3DSA:1.10.238.10:FF:000850', NULL, NULL, 'Calcium-binding protein CML37', NULL, NULL, NULL, NULL, NULL, 4),
(149359, NULL, 'G3DSA:3.60.15.10:FF:000173', NULL, NULL, 'ElaC ribonuclease Z 2', NULL, NULL, NULL, NULL, NULL, 4),
(149360, NULL, 'G3DSA:3.40.50.150:FF:000739', NULL, NULL, 'Guanidinoacetate N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(149361, NULL, 'G3DSA:3.10.330.10:FF:000017', NULL, NULL, 'Peroxisome biosynthesis protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(149362, NULL, 'G3DSA:3.30.1460.50:FF:000028', NULL, NULL, 'ATG10 autophagy related 10 homolog (S. cerevisiae)', NULL, NULL, NULL, NULL, NULL, 4),
(149363, NULL, 'G3DSA:2.60.40.150:FF:000681', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(149364, NULL, 'G3DSA:3.40.525.10:FF:000014', NULL, NULL, 'Ganglioside-induced differentiation-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(149365, NULL, 'G3DSA:1.10.357.10:FF:000031', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(149366, NULL, 'G3DSA:1.10.238.10:FF:000176', NULL, NULL, 'reticulocalbin-2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(149367, NULL, 'G3DSA:2.170.120.12:FF:000009', NULL, NULL, 'DNA-directed RNA polymerase II 36 kDa polypeptide A', NULL, NULL, NULL, NULL, NULL, 4),
(149368, NULL, 'G3DSA:1.10.1170.10:FF:000039', NULL, NULL, 'SBP (S-ribonuclease binding protein) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(149369, NULL, 'G3DSA:3.30.559.10:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149370, NULL, 'G3DSA:1.20.1070.10:FF:000041', NULL, NULL, 'Muscarinic acetylcholine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(149371, NULL, 'G3DSA:2.130.10.10:FF:002881', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(149372, NULL, 'G3DSA:3.40.50.2300:FF:001659', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149373, NULL, 'G3DSA:1.10.287.130:FF:000100', NULL, NULL, 'Sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(149374, NULL, 'G3DSA:3.30.70.330:FF:002525', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149375, NULL, 'G3DSA:1.20.58.60:FF:000208', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(149376, NULL, 'G3DSA:3.40.350.10:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149377, NULL, 'G3DSA:3.40.30.10:FF:001221', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(149378, NULL, 'G3DSA:3.40.50.150:FF:001015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149379, NULL, 'G3DSA:3.65.10.10:FF:000028', NULL, NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(149380, NULL, 'G3DSA:2.40.20.10:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149381, NULL, 'G3DSA:3.30.70.270:FF:000231', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149382, NULL, 'G3DSA:1.10.238.10:FF:000518', NULL, NULL, 'EF-hand superfamily Ca2+-modulated protein', NULL, NULL, NULL, NULL, NULL, 4),
(149383, NULL, 'G3DSA:1.20.5.170:FF:000010', NULL, NULL, 'Cyclic AMP-dependent transcription factor ATF-2', NULL, NULL, NULL, NULL, NULL, 4),
(149384, NULL, 'G3DSA:2.40.30.130:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149385, NULL, 'G3DSA:1.25.40.1040:FF:000011', NULL, NULL, 'Related to RNA14-component of pre-mRNA 3`-end processing factor CF I', NULL, NULL, NULL, NULL, NULL, 4),
(149386, NULL, 'G3DSA:2.30.29.30:FF:001176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149387, NULL, 'G3DSA:3.40.50.300:FF:002842', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(149388, NULL, 'G3DSA:2.60.120.1040:FF:000007', NULL, NULL, 'Protein CBG06449', NULL, NULL, NULL, NULL, NULL, 4),
(149389, NULL, 'G3DSA:1.25.40.10:FF:000429', NULL, NULL, 'Pre-mRNA-processing factor 6, putative', NULL, NULL, NULL, NULL, NULL, 4),
(149390, NULL, 'G3DSA:1.10.30.10:FF:000187', NULL, NULL, 'HMG', NULL, NULL, NULL, NULL, NULL, 4),
(149391, NULL, 'G3DSA:2.60.120.10:FF:000629', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149392, NULL, 'G3DSA:1.10.510.10:FF:000770', NULL, NULL, 'SRSF protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(149393, NULL, 'G3DSA:3.30.1330.60:FF:000027', NULL, NULL, 'OmpA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(149394, NULL, 'G3DSA:2.60.120.1020:FF:000001', NULL, NULL, 'Peptide-N(4)-(N-acetyl-beta-glucosaminyl)asparagine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(149395, NULL, 'G3DSA:3.30.420.10:FF:000599', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149396, NULL, 'G3DSA:2.130.10.10:FF:005877', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149397, NULL, 'G3DSA:2.40.70.10:FF:000326', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(149398, NULL, 'G3DSA:2.60.40.150:FF:000568', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149399, NULL, 'G3DSA:1.20.5.190:FF:000016', NULL, NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(149400, NULL, 'G3DSA:2.70.70.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149401, NULL, 'G3DSA:3.30.565.10:FF:000513', NULL, NULL, 'Histidine kinase sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(149402, NULL, 'G3DSA:1.10.510.10:FF:004480', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149403, NULL, 'G3DSA:3.80.10.10:FF:003808', NULL, NULL, 'F-box/LRR-repeat protein 16-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(149404, NULL, 'G3DSA:3.20.20.30:FF:000030', NULL, NULL, 'LLM class flavin-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(149405, NULL, 'G3DSA:1.25.10.10:FF:002389', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149406, NULL, 'G3DSA:2.170.270.10:FF:000243', NULL, NULL, 'Eukaryotic translation initiation factor 2 subunit 3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(149407, NULL, 'G3DSA:3.30.230.130:FF:000029', NULL, NULL, 'Cullin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(149408, NULL, 'G3DSA:3.20.20.70:FF:000699', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149409, NULL, 'G3DSA:2.30.42.10:FF:000065', NULL, NULL, 'syntenin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(149410, NULL, 'G3DSA:2.40.180.10:FF:000036', NULL, NULL, 'Catalase', NULL, NULL, NULL, NULL, NULL, 4),
(149411, NULL, 'G3DSA:3.30.200.20:FF:000714', NULL, NULL, 'Nitrogen permease regulator', NULL, NULL, NULL, NULL, NULL, 4),
(149412, NULL, 'G3DSA:2.60.120.1030:FF:000004', NULL, NULL, 'mRNA cleavage and polyadenylation factor CLP1', NULL, NULL, NULL, NULL, NULL, 4),
(149413, NULL, 'G3DSA:3.30.200.20:FF:000153', NULL, NULL, 'Calcium/calmodulin-dependent protein kinase type I', NULL, NULL, NULL, NULL, NULL, 4),
(149414, NULL, 'G3DSA:1.10.472.170:FF:000006', NULL, NULL, 'Os07g0504500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(149415, NULL, 'G3DSA:2.130.10.10:FF:002443', NULL, NULL, 'WD-40 repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(149416, NULL, 'G3DSA:3.10.28.10:FF:000019', NULL, NULL, 'Vitamin B12-dependent ribonucleotide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(149417, NULL, 'G3DSA:1.10.472.10:FF:000438', NULL, NULL, 'D-type cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(149418, NULL, 'G3DSA:1.25.40.10:FF:004139', NULL, NULL, 'MSHA biogenesis protein MshN', NULL, NULL, NULL, NULL, NULL, 4),
(149419, NULL, 'G3DSA:1.25.70.10:FF:000038', NULL, NULL, 'GM18334', NULL, NULL, NULL, NULL, NULL, 4),
(149420, NULL, 'G3DSA:3.40.47.10:FF:000130', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(149421, NULL, 'G3DSA:1.10.274.100:FF:000003', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(149422, NULL, 'G3DSA:3.30.450.40:FF:000188', NULL, NULL, 'GAF domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(149423, NULL, 'G3DSA:2.30.30.40:FF:000176', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(149424, NULL, 'G3DSA:1.10.10.60:FF:000397', NULL, NULL, 'Blast:Homeobox protein Hmx', NULL, NULL, NULL, NULL, NULL, 4),
(149425, NULL, 'G3DSA:1.20.1310.10:FF:000083', NULL, NULL, 'Protein CBR-CUL-2', NULL, NULL, NULL, NULL, NULL, 4),
(149426, NULL, 'G3DSA:3.40.50.150:FF:000397', NULL, NULL, 'Cytotoxin|haemolysin homologue TLYA', NULL, NULL, NULL, NULL, NULL, 4),
(149427, NULL, 'G3DSA:2.70.170.10:FF:000282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149428, NULL, 'G3DSA:3.10.129.10:FF:000061', NULL, NULL, 'Probable dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(149429, NULL, 'G3DSA:2.110.10.10:FF:000027', NULL, NULL, 'Protein CBG23191', NULL, NULL, NULL, NULL, NULL, 4),
(149430, NULL, 'G3DSA:3.40.50.300:FF:004641', NULL, NULL, 'Putative RNA helicase armi-like Protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(149431, NULL, 'G3DSA:3.40.1090.10:FF:000047', NULL, NULL, 'Patatin-like protein, PlpD', NULL, NULL, NULL, NULL, NULL, 4),
(149432, NULL, 'G3DSA:3.20.20.80:FF:000016', NULL, NULL, 'Maltase-glucoamylase, intestinal', NULL, NULL, NULL, NULL, NULL, 4),
(149433, NULL, 'G3DSA:3.10.100.10:FF:000208', NULL, NULL, 'Mannose-binding protein C', NULL, NULL, NULL, NULL, NULL, 4),
(149434, NULL, 'G3DSA:1.20.58.860:FF:000008', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(149435, NULL, 'G3DSA:3.30.200.20:FF:002283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149436, NULL, 'G3DSA:3.40.50.720:FF:002052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149437, NULL, 'G3DSA:1.25.10.10:FF:003120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149438, NULL, 'G3DSA:3.90.105.10:FF:000016', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(149439, NULL, 'G3DSA:3.60.150.10:FF:000003', NULL, NULL, 'Chorismate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(149440, NULL, 'G3DSA:2.40.50.140:FF:000830', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149441, NULL, 'G3DSA:1.10.720.60:FF:000019', NULL, NULL, 'Enolase-phosphatase E1', NULL, NULL, NULL, NULL, NULL, 4),
(149442, NULL, 'G3DSA:3.40.50.11370:FF:000001', NULL, NULL, 'Inositol-tetrakisphosphate 1-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(149443, NULL, 'G3DSA:3.40.630.10:FF:000253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149444, NULL, 'G3DSA:1.20.5.430:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149445, NULL, 'G3DSA:4.10.860.10:FF:000008', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(149446, NULL, 'G3DSA:3.40.50.720:FF:001776', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(149447, NULL, 'G3DSA:3.30.390.110:FF:000007', NULL, NULL, '60S ribosomal protein L28', NULL, NULL, NULL, NULL, NULL, 4),
(149448, NULL, 'G3DSA:3.30.559.10:FF:000004', NULL, NULL, 'Acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(149449, NULL, 'G3DSA:2.60.120.650:FF:000036', NULL, NULL, 'Lysine-specific demethylase rbr-2', NULL, NULL, NULL, NULL, NULL, 4),
(149450, NULL, 'G3DSA:3.30.70.270:FF:000012', NULL, NULL, 'DNA polymerase V subunit', NULL, NULL, NULL, NULL, NULL, 4),
(149451, NULL, 'G3DSA:3.40.50.300:FF:006771', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149452, NULL, 'G3DSA:3.30.40.10:FF:000171', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM39', NULL, NULL, NULL, NULL, NULL, 4),
(149453, NULL, 'G3DSA:3.80.10.10:FF:000032', NULL, NULL, 'Slit homolog 2 (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(149454, NULL, 'G3DSA:1.20.1280.290:FF:000025', NULL, NULL, 'MtN3-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(149455, NULL, 'G3DSA:3.30.1330.10:FF:000041', NULL, NULL, 'Selenide, water dikinase', NULL, NULL, NULL, NULL, NULL, 4),
(149456, NULL, 'G3DSA:1.25.40.20:FF:001040', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(149457, NULL, 'G3DSA:3.30.40.10:FF:000513', NULL, NULL, 'Transcriptional regulator (Cti6), putative', NULL, NULL, NULL, NULL, NULL, 4),
(149458, NULL, 'G3DSA:3.40.50.620:FF:000223', NULL, NULL, 'Sulfate adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(149459, NULL, 'G3DSA:1.25.40.10:FF:000761', NULL, NULL, 'pentatricopeptide repeat-containing protein 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(149460, NULL, 'G3DSA:2.120.10.30:FF:000375', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149461, NULL, 'G3DSA:1.10.287.940:FF:000023', NULL, NULL, 'p2X purinoceptor,putative', NULL, NULL, NULL, NULL, NULL, 4),
(149462, NULL, 'G3DSA:2.30.30.40:FF:000518', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(149463, NULL, 'G3DSA:3.40.50.620:FF:000004', NULL, NULL, 'tRNA-specific 2-thiouridylase MnmA', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(149464, NULL, 'G3DSA:2.10.50.30:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149465, NULL, 'G3DSA:2.40.10.10:FF:000098', NULL, NULL, 'Coagulation factor XII', NULL, NULL, NULL, NULL, NULL, 4),
(149466, NULL, 'G3DSA:3.30.160.60:FF:003403', NULL, NULL, 'CRE-ZTF-12 protein', NULL, NULL, NULL, NULL, NULL, 4),
(149467, NULL, 'G3DSA:1.10.287.280:FF:000004', NULL, NULL, 'DNA-dependent RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(149468, NULL, 'G3DSA:2.40.30.10:FF:000329', NULL, NULL, 'Dihydroorotate dehydrogenase electron transfer subunit', NULL, NULL, NULL, NULL, NULL, 4),
(149469, NULL, 'G3DSA:3.30.497.10:FF:000124', NULL, NULL, 'Uncharacterized serpin-like protein PAE0049', NULL, NULL, NULL, NULL, NULL, 4),
(149470, NULL, 'G3DSA:3.30.160.60:FF:002566', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149471, NULL, 'G3DSA:3.30.230.10:FF:000207', NULL, NULL, 'Ribonuclease P protein component', NULL, NULL, NULL, NULL, NULL, 4),
(149472, NULL, 'G3DSA:1.20.272.10:FF:000062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149473, NULL, 'G3DSA:1.10.1600.10:FF:000023', NULL, NULL, 'Cku-70', NULL, NULL, NULL, NULL, NULL, 4),
(149474, NULL, 'G3DSA:3.30.40.10:FF:001930', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149475, NULL, 'G3DSA:3.30.70.960:FF:000011', NULL, NULL, 'Transmembrane protease serine', NULL, NULL, NULL, NULL, NULL, 4),
(149476, NULL, 'G3DSA:3.40.630.40:FF:000014', NULL, NULL, 'N-formylglutamate amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(149477, NULL, 'G3DSA:3.30.2350.10:FF:000042', NULL, NULL, 'RNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(149478, NULL, 'G3DSA:1.25.10.10:FF:002844', NULL, NULL, 'HEAT repeat-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(149479, NULL, 'G3DSA:1.20.1070.10:FF:000260', NULL, NULL, 'Dopamine receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(149480, NULL, 'G3DSA:3.80.10.10:FF:003685', NULL, NULL, 'Protein CBG20033', NULL, NULL, NULL, NULL, NULL, 4),
(149481, NULL, 'G3DSA:1.25.40.20:FF:000764', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149482, NULL, 'G3DSA:3.30.750.24:FF:000002', NULL, NULL, 'Sulfate transporter 31', NULL, NULL, NULL, NULL, NULL, 4),
(149483, NULL, 'G3DSA:3.40.50.300:FF:002387', NULL, NULL, 'Small GTP-binding protein domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(149484, NULL, 'G3DSA:2.60.40.1180:FF:000167', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(149485, NULL, 'G3DSA:1.20.920.30:FF:000068', NULL, NULL, 'Dynein heavy chain domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(149486, NULL, 'G3DSA:3.30.70.330:FF:000384', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(149487, NULL, 'G3DSA:1.10.10.970:FF:000003', NULL, NULL, 'Phosphotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(149488, NULL, 'G3DSA:2.70.98.10:FF:000068', NULL, NULL, 'Putative alpha-1,2-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(149489, NULL, 'G3DSA:1.10.287.990:FF:000009', NULL, NULL, 'Putative superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(149490, NULL, 'G3DSA:2.40.30.330:FF:000018', NULL, NULL, 'mRNA cleavage and polyadenylation factor clp1', NULL, NULL, NULL, NULL, NULL, 4),
(149491, NULL, 'G3DSA:3.30.420.100:FF:000002', NULL, NULL, '60S ribosomal protein L5', NULL, NULL, NULL, NULL, NULL, 4),
(149492, NULL, 'G3DSA:3.30.160.60:FF:006495', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149493, NULL, 'G3DSA:1.20.120.1750:FF:000046', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(149494, NULL, 'G3DSA:1.20.120.1760:FF:000049', NULL, NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(149495, NULL, 'G3DSA:2.30.36.70:FF:000001', NULL, NULL, 'Actin, alpha skeletal muscle', NULL, NULL, NULL, NULL, NULL, 4),
(149496, NULL, 'G3DSA:3.30.710.10:FF:000014', NULL, NULL, 'Rho-related BTB domain-containing protein 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(149497, NULL, 'G3DSA:1.20.1530.20:FF:000068', NULL, NULL, 'Cation/H(+) antiporter 14', NULL, NULL, NULL, NULL, NULL, 4),
(149498, NULL, 'G3DSA:3.30.2010.10:FF:000005', NULL, NULL, 'CAAX prenyl protease', NULL, NULL, NULL, NULL, NULL, 4),
(149499, NULL, 'G3DSA:3.40.640.10:FF:000079', NULL, NULL, 'LPS biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(149500, NULL, 'G3DSA:3.30.1030.10:FF:000001', NULL, NULL, 'Methenyltetrahydromethanopterin cyclohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(149501, NULL, 'G3DSA:1.25.40.10:FF:004252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149502, NULL, 'G3DSA:2.160.20.10:FF:000093', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(149503, NULL, 'G3DSA:2.10.110.10:FF:000128', NULL, NULL, 'Pxl1p', NULL, NULL, NULL, NULL, NULL, 4),
(149504, NULL, 'G3DSA:4.10.60.10:FF:000171', NULL, NULL, 'WGS project CABT00000000 data, contig 2.31', NULL, NULL, NULL, NULL, NULL, 4),
(149505, NULL, 'G3DSA:3.40.30.10:FF:000945', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149506, NULL, 'G3DSA:3.30.160.60:FF:002785', NULL, NULL, 'DNA polymerase kappa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(149507, NULL, 'G3DSA:3.30.70.330:FF:001469', NULL, NULL, 'RNA-binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(149508, NULL, 'G3DSA:3.80.10.10:FF:003466', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149509, NULL, 'G3DSA:1.20.1310.10:FF:000206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149510, NULL, 'G3DSA:1.25.40.20:FF:000545', NULL, NULL, 'Serine/threonine-protein phosphatase 6 regulatory ankyrin repeat subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(149511, NULL, 'G3DSA:3.90.70.10:FF:000631', NULL, NULL, 'Calpain-like protease palB', NULL, NULL, NULL, NULL, NULL, 4),
(149512, NULL, 'G3DSA:3.30.2350.20:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149513, NULL, 'G3DSA:1.25.40.10:FF:003976', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149514, NULL, 'G3DSA:1.10.10.10:FF:000972', NULL, NULL, 'ORC1-type DNA replication protein', NULL, NULL, NULL, NULL, NULL, 4),
(149515, NULL, 'G3DSA:3.30.310.50:FF:000029', NULL, NULL, 'Phosphoacetylglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(149516, NULL, 'G3DSA:1.10.3180.10:FF:000001', NULL, NULL, 'Ethylene insensitive 3-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(149517, NULL, 'G3DSA:1.10.940.10:FF:000015', NULL, NULL, '16S rRNA methyltransferase B', NULL, NULL, NULL, NULL, NULL, 4),
(149518, NULL, 'G3DSA:3.40.50.12780:FF:000204', NULL, NULL, 'Long-chain-fatty-acid--luciferin-component ligase', NULL, NULL, NULL, NULL, NULL, 4),
(149519, NULL, 'G3DSA:3.10.100.10:FF:000085', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(149520, NULL, 'G3DSA:3.40.50.300:FF:006990', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149521, NULL, 'G3DSA:1.25.40.10:FF:000542', NULL, NULL, 'Pentatricopeptide repeat-containing protein MRL1, chloroplastic isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(149522, NULL, 'G3DSA:3.30.160.60:FF:003061', NULL, NULL, 'GD25683', NULL, NULL, NULL, NULL, NULL, 4),
(149523, NULL, 'G3DSA:3.40.50.300:FF:002729', NULL, NULL, '50S ribosome-binding GTPase/Dynamin family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(149524, NULL, 'G3DSA:3.30.160.60:FF:004820', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149525, NULL, 'G3DSA:2.40.10.10:FF:000659', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149526, NULL, 'G3DSA:3.30.420.40:FF:000692', NULL, NULL, 'Xylulokinase', NULL, NULL, NULL, NULL, NULL, 4),
(149527, NULL, 'G3DSA:1.10.110.10:FF:000003', NULL, NULL, 'pEARLI1-like lipid transfer protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(149528, NULL, 'G3DSA:1.20.140.150:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149529, NULL, 'G3DSA:1.10.533.10:FF:000244', NULL, NULL, 'Si:dkey-265e15.2', NULL, NULL, NULL, NULL, NULL, 4),
(149530, NULL, 'G3DSA:3.10.100.10:FF:000427', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(149531, NULL, 'G3DSA:2.70.40.10:FF:000014', NULL, NULL, 'dUTP pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(149532, NULL, 'G3DSA:4.10.640.10:FF:000026', NULL, NULL, '28S ribosomal protein S18a, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(149533, NULL, 'G3DSA:3.60.21.10:FF:000463', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(149534, NULL, 'G3DSA:1.10.10.10:FF:000079', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(149535, NULL, 'G3DSA:2.60.40.10:FF:002914', NULL, NULL, 'Protein sidekick homolog', NULL, NULL, NULL, NULL, NULL, 4),
(149536, NULL, 'G3DSA:3.30.1010.10:FF:000112', NULL, NULL, 'Serine/threonine-protein kinase tel1', NULL, NULL, NULL, NULL, NULL, 4),
(149537, NULL, 'G3DSA:2.80.10.50:FF:000198', NULL, NULL, 'Ryanodine receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(149538, NULL, 'G3DSA:1.10.510.10:FF:002568', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149539, NULL, 'G3DSA:2.60.40.150:FF:000349', NULL, NULL, 'Copine family protein', NULL, NULL, NULL, NULL, NULL, 4),
(149540, NULL, 'G3DSA:3.40.50.300:FF:003005', NULL, NULL, '26S protease regulatory subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(149541, NULL, 'G3DSA:1.10.10.440:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149542, NULL, 'G3DSA:2.170.300.10:FF:000004', NULL, NULL, 'Laminin subunit beta 1', NULL, NULL, NULL, NULL, NULL, 4),
(149543, NULL, 'G3DSA:3.80.10.10:FF:004303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149544, NULL, 'G3DSA:3.30.70.1450:FF:000030', NULL, NULL, 'Trk system potassium uptake protein CeoB', NULL, NULL, NULL, NULL, NULL, 4),
(149545, NULL, 'G3DSA:3.40.50.1000:FF:000853', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149546, NULL, 'G3DSA:3.30.60.20:FF:000063', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(149547, NULL, 'G3DSA:2.40.70.10:FF:000107', NULL, NULL, 'Pepsin-like aspartic protease A1', NULL, NULL, NULL, NULL, NULL, 4),
(149548, NULL, 'G3DSA:3.40.50.1820:FF:000869', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(149549, NULL, 'G3DSA:3.90.340.10:FF:000001', NULL, NULL, 'Nitric oxide synthase, endothelial', NULL, NULL, NULL, NULL, NULL, 4),
(149550, NULL, 'G3DSA:3.90.1170.50:FF:000004', NULL, NULL, 'Selenate reductase subunit YgfN', NULL, NULL, NULL, NULL, NULL, 4),
(149551, NULL, 'G3DSA:3.20.20.220:FF:000018', NULL, NULL, 'Methylenetetrahydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(149552, NULL, 'G3DSA:3.90.1580.10:FF:000006', NULL, NULL, 'Generic methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(149553, NULL, 'G3DSA:2.10.25.10:FF:000185', NULL, NULL, 'basement membrane-specific heparan sulfate proteoglycan core protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(149554, NULL, 'G3DSA:3.90.70.10:FF:000862', NULL, NULL, 'Protein CBG17827', NULL, NULL, NULL, NULL, NULL, 4),
(149555, NULL, 'G3DSA:3.30.559.30:FF:000117', NULL, NULL, 'Nonribosomal peptide synthetase easA', NULL, NULL, NULL, NULL, NULL, 4),
(149556, NULL, 'G3DSA:3.10.110.10:FF:000226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149557, NULL, 'G3DSA:3.30.160.20:FF:000043', NULL, NULL, '60S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(149558, NULL, 'G3DSA:1.20.5.340:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149559, NULL, 'G3DSA:3.30.160.60:FF:005911', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149560, NULL, 'G3DSA:1.10.630.10:FF:000094', NULL, NULL, 'cytochrome P450 2J6-like', NULL, NULL, NULL, NULL, NULL, 4),
(149561, NULL, 'G3DSA:1.25.10.10:FF:002480', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(149562, NULL, 'G3DSA:3.90.470.20:FF:000075', NULL, NULL, 'Glr2851 protein', NULL, NULL, NULL, NULL, NULL, 4),
(149563, NULL, 'G3DSA:4.10.400.10:FF:000346', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149564, NULL, 'G3DSA:3.40.50.300:FF:004725', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(149565, NULL, 'G3DSA:1.20.5.500:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149566, NULL, 'G3DSA:1.10.3460.10:FF:000029', NULL, NULL, 'Chlorophyll a-b binding protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(149567, NULL, 'G3DSA:2.30.30.210:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149568, NULL, 'G3DSA:3.40.367.20:FF:000037', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(149569, NULL, 'G3DSA:3.90.550.50:FF:000091', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(149570, NULL, 'G3DSA:2.60.40.10:FF:001128', NULL, NULL, 'Sallimus, isoform P', NULL, NULL, NULL, NULL, NULL, 4),
(149571, NULL, 'G3DSA:1.50.10.20:FF:000148', NULL, NULL, 'Ent-copalyl diphosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(149572, NULL, 'G3DSA:1.25.40.10:FF:004073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149573, NULL, 'G3DSA:1.20.272.50:FF:000001', NULL, NULL, 'DNA polymerase clamp loader subunit', NULL, NULL, NULL, NULL, NULL, 4),
(149574, NULL, 'G3DSA:3.60.20.40:FF:000026', NULL, NULL, 'Gamma-glutamyltransferase 5', NULL, NULL, NULL, NULL, NULL, 4),
(149575, NULL, 'G3DSA:3.40.50.2000:FF:000002', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(149576, NULL, 'G3DSA:3.40.50.150:FF:000476', NULL, NULL, 'Polyamine aminopropyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(149577, NULL, 'G3DSA:3.30.70.3400:FF:000003', NULL, NULL, 'Preprotein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(149578, NULL, 'G3DSA:2.60.40.10:FF:002589', NULL, NULL, 'FI06716p', NULL, NULL, NULL, NULL, NULL, 4),
(149579, NULL, 'G3DSA:1.10.490.10:FF:000003', NULL, NULL, 'Flavohemoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(149580, NULL, 'G3DSA:3.30.70.330:FF:002616', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149581, NULL, 'G3DSA:3.30.160.60:FF:002185', NULL, NULL, 'Histone H4 transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(149582, NULL, 'G3DSA:1.25.40.10:FF:002509', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149583, NULL, 'G3DSA:3.60.20.10:FF:000130', NULL, NULL, 'Proteasome subunit beta type 9', NULL, NULL, NULL, NULL, NULL, 4),
(149584, NULL, 'G3DSA:3.80.10.10:FF:000555', NULL, NULL, 'Leucine-rich repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(149585, NULL, 'G3DSA:1.10.287.110:FF:000359', NULL, NULL, 'Chaperone protein DnaJ 2', NULL, NULL, NULL, NULL, NULL, 4),
(149586, NULL, 'G3DSA:3.30.379.10:FF:000013', NULL, NULL, 'Beta-hexosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(149587, NULL, 'G3DSA:3.40.140.10:FF:000278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149588, NULL, 'G3DSA:3.40.30.10:FF:000058', NULL, NULL, 'Glutathione S-transferase, omega', NULL, NULL, NULL, NULL, NULL, 4),
(149589, NULL, 'G3DSA:1.20.1070.10:FF:001992', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149590, NULL, 'G3DSA:3.30.160.60:FF:003174', NULL, NULL, 'Zinc finger protein 490', NULL, NULL, NULL, NULL, NULL, 4),
(149591, NULL, 'G3DSA:1.10.510.10:FF:000467', NULL, NULL, 'Liguleless narrow1', NULL, NULL, NULL, NULL, NULL, 4),
(149592, NULL, 'G3DSA:1.20.1310.10:FF:000128', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149593, NULL, 'G3DSA:1.20.1640.10:FF:000001', NULL, NULL, 'Efflux pump membrane transporter', NULL, NULL, NULL, NULL, NULL, 4),
(149594, NULL, 'G3DSA:3.90.1100.10:FF:000038', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(149595, NULL, 'G3DSA:3.20.20.70:FF:000014', NULL, NULL, 'Probable dual-specificity RNA methyltransferase RlmN', NULL, NULL, NULL, NULL, NULL, 4),
(149596, NULL, 'G3DSA:1.10.472.10:FF:000574', NULL, NULL, 'Cyclin putative cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(149597, NULL, 'G3DSA:1.25.40.10:FF:005062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149598, NULL, 'G3DSA:3.40.1190.20:FF:000047', NULL, NULL, 'Hydroxyethylthiazole kinase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(149599, NULL, 'G3DSA:4.10.60.10:FF:000031', NULL, NULL, 'splicing factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(149600, NULL, 'G3DSA:3.30.1330.30:FF:000154', NULL, NULL, 'Eukaryotic peptide chain release factor subunit 1-2', NULL, NULL, NULL, NULL, NULL, 4),
(149601, NULL, 'G3DSA:3.30.110.10:FF:000003', NULL, NULL, 'Translation initiation factor IF-3', NULL, NULL, NULL, NULL, NULL, 4),
(149602, NULL, 'G3DSA:1.25.40.20:FF:001849', NULL, NULL, 'Protein CBR-MIB-1', NULL, NULL, NULL, NULL, NULL, 4),
(149603, NULL, 'G3DSA:3.30.1010.10:FF:000040', NULL, NULL, 'Phosphatidylinositol 3-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(149604, NULL, 'G3DSA:3.40.50.1820:FF:001858', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149605, NULL, 'G3DSA:3.40.50.300:FF:003736', NULL, NULL, 'MutS homolog 3 (E. coli)', NULL, NULL, NULL, NULL, NULL, 4),
(149606, NULL, 'G3DSA:3.90.920.10:FF:000028', NULL, NULL, 'DNA polymerase alpha subunit IV, putative', NULL, NULL, NULL, NULL, NULL, 4),
(149607, NULL, 'G3DSA:3.30.930.10:FF:000043', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(149608, NULL, 'G3DSA:3.30.200.20:FF:002368', NULL, NULL, 'AGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(149609, NULL, 'G3DSA:3.40.50.300:FF:000982', NULL, NULL, 'Inactive ATP-dependent zinc metalloprotease FTSHI 2 like', NULL, NULL, NULL, NULL, NULL, 4),
(149610, NULL, 'G3DSA:1.10.287.700:FF:000002', NULL, NULL, 'Gamma-synuclein', NULL, NULL, NULL, NULL, NULL, 4),
(149611, NULL, 'G3DSA:1.10.565.10:FF:000054', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(149612, NULL, 'G3DSA:1.20.1070.10:FF:001553', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149613, NULL, 'G3DSA:2.70.170.10:FF:000018', NULL, NULL, 'Gamma-aminobutyric acid (GABA-A) receptor, subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(149614, NULL, 'G3DSA:1.25.10.10:FF:001491', NULL, NULL, 'C11.1, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(149615, NULL, 'G3DSA:2.60.40.60:FF:000373', NULL, NULL, 'Ventral neural cadherin', NULL, NULL, NULL, NULL, NULL, 4),
(149616, NULL, 'G3DSA:3.40.30.10:FF:001047', NULL, NULL, 'Glutathione S-transferase kappa', NULL, NULL, NULL, NULL, NULL, 4),
(149617, NULL, 'G3DSA:1.25.40.10:FF:002948', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(149618, NULL, 'G3DSA:1.10.510.10:FF:004362', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149619, NULL, 'G3DSA:3.40.50.10240:FF:000005', NULL, NULL, 'Thiamine pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(149620, NULL, 'G3DSA:3.40.50.720:FF:000872', NULL, NULL, '3-oxoacyl-ACP reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(149621, NULL, 'G3DSA:1.10.8.270:FF:000077', NULL, NULL, 'Rab GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(149622, NULL, 'G3DSA:1.10.1200.10:FF:000105', NULL, NULL, 'HC-toxin synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(149623, NULL, 'G3DSA:1.20.144.10:FF:000046', NULL, NULL, 'PhosphoLipid Phosphatase Related homolog', NULL, NULL, NULL, NULL, NULL, 4),
(149624, NULL, 'G3DSA:3.20.140.10:FF:000029', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(149625, NULL, 'G3DSA:2.170.270.10:FF:000221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149626, NULL, 'G3DSA:2.130.10.10:FF:000476', NULL, NULL, 'Activating molecule in BECN1-regulated autophagy protein', NULL, NULL, NULL, NULL, NULL, 4),
(149627, NULL, 'G3DSA:3.40.50.10420:FF:000054', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(149628, NULL, 'G3DSA:1.20.1270.370:FF:000003', NULL, NULL, 'Subunit of oxygen-sensitive 2-hydroxyisocaproyl-CoA dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(149629, NULL, 'G3DSA:3.30.70.330:FF:000851', NULL, NULL, 'RNA-binding protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(149630, NULL, 'G3DSA:3.40.190.10:FF:000961', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(149631, NULL, 'G3DSA:3.30.200.20:FF:000131', NULL, NULL, 'Dual specificity protein kinase TTK', NULL, NULL, NULL, NULL, NULL, 4),
(149632, NULL, 'G3DSA:1.25.40.180:FF:000257', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149633, NULL, 'G3DSA:3.40.850.10:FF:000517', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149634, NULL, 'G3DSA:1.10.220.150:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149635, NULL, 'G3DSA:2.80.10.50:FF:000086', NULL, NULL, 'Calcium up-regulated protein A', NULL, NULL, NULL, NULL, NULL, 4),
(149636, NULL, 'G3DSA:2.60.40.10:FF:003106', NULL, NULL, 'Ig-like and fibronectin type-III domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(149637, NULL, 'G3DSA:1.10.238.10:FF:000867', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149638, NULL, 'G3DSA:3.50.50.60:FF:001462', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149639, NULL, 'G3DSA:2.60.40.10:FF:005023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149640, NULL, 'G3DSA:2.30.42.10:FF:000605', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149641, NULL, 'G3DSA:3.30.40.10:FF:002381', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(149642, NULL, 'G3DSA:2.30.29.30:FF:001255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149643, NULL, 'G3DSA:1.10.287.1490:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149644, NULL, 'G3DSA:2.30.42.10:FF:000285', NULL, NULL, 'Caspase recruitment domain family, member 11', NULL, NULL, NULL, NULL, NULL, 4),
(149645, NULL, 'G3DSA:2.10.25.10:FF:001174', NULL, NULL, 'NIDogen (Basement membrane protein)', NULL, NULL, NULL, NULL, NULL, 4),
(149646, NULL, 'G3DSA:3.20.20.80:FF:000343', NULL, NULL, 'Protein CBG22612', NULL, NULL, NULL, NULL, NULL, 4),
(149647, NULL, 'G3DSA:3.30.2020.30:FF:000018', NULL, NULL, 'ADR024Wp', NULL, NULL, NULL, NULL, NULL, 4),
(149648, NULL, 'G3DSA:3.40.50.300:FF:003383', NULL, NULL, 'UMP-CMP kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(149649, NULL, 'G3DSA:1.20.1280.50:FF:000182', NULL, NULL, 'Fbox domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(149650, NULL, 'G3DSA:1.10.3720.10:FF:000128', NULL, NULL, 'Molybdenum transport system permease', NULL, NULL, NULL, NULL, NULL, 4),
(149651, NULL, 'G3DSA:3.40.50.300:FF:002747', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(149652, NULL, 'G3DSA:3.75.10.10:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149653, NULL, 'G3DSA:2.40.400.10:FF:000004', NULL, NULL, 'Acetoacetate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(149654, NULL, 'G3DSA:1.25.40.20:FF:000540', NULL, NULL, 'GD22794', NULL, NULL, NULL, NULL, NULL, 4),
(149655, NULL, 'G3DSA:2.30.29.30:FF:000619', NULL, NULL, 'Phosphatidylinositol-3-phosphatase myotubularin-2', NULL, NULL, NULL, NULL, NULL, 4),
(149656, NULL, 'G3DSA:1.20.1070.10:FF:000564', NULL, NULL, 'GD11847', NULL, NULL, NULL, NULL, NULL, 4),
(149657, NULL, 'G3DSA:2.30.230.10:FF:000049', NULL, NULL, 'Vitellogenin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(149658, NULL, 'G3DSA:3.20.20.70:FF:000806', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149659, NULL, 'G3DSA:3.40.970.20:FF:000001', NULL, NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(149660, NULL, 'G3DSA:1.10.10.1620:FF:000002', NULL, NULL, 'Putative bifunctional amine oxidase DDB_G0291301', NULL, NULL, NULL, NULL, NULL, 4),
(149661, NULL, 'G3DSA:3.40.50.10810:FF:000081', NULL, NULL, 'DNA repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(149662, NULL, 'G3DSA:3.30.420.100:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149663, NULL, 'G3DSA:1.20.1480.30:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149664, NULL, 'G3DSA:2.60.220.50:FF:000060', NULL, NULL, 'Adhesion G protein-coupled receptor G1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(149665, NULL, 'G3DSA:3.80.10.10:FF:001983', NULL, NULL, 'Leucine-rich repeat protein lrrA', NULL, NULL, NULL, NULL, NULL, 4),
(149666, NULL, 'G3DSA:1.25.40.10:FF:003937', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149667, NULL, 'G3DSA:1.20.58.60:FF:000619', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149668, NULL, 'G3DSA:4.10.1000.10:FF:000009', NULL, NULL, 'probable helicase with zinc finger domain', NULL, NULL, NULL, NULL, NULL, 4),
(149669, NULL, 'G3DSA:3.20.20.100:FF:000067', NULL, NULL, 'Related to GCY1-galactose-induced protein of aldo/keto reductase family / uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149670, NULL, 'G3DSA:1.20.1050.10:FF:000029', NULL, NULL, 'Glutathione S-transferase DHAR3, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(149671, NULL, 'G3DSA:1.10.10.60:FF:000465', NULL, NULL, 'Sequence-specific DNA binding transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(149672, NULL, 'G3DSA:2.60.40.10:FF:002909', NULL, NULL, 'Basigin', NULL, NULL, NULL, NULL, NULL, 4),
(149673, NULL, 'G3DSA:2.130.10.10:FF:001432', NULL, NULL, 'SVP1-like protein 2, variant', NULL, NULL, NULL, NULL, NULL, 4),
(149674, NULL, 'G3DSA:2.30.30.40:FF:000373', NULL, NULL, 'Putative purine-binding chemotaxis protein Chew', NULL, NULL, NULL, NULL, NULL, 4),
(149675, NULL, 'G3DSA:1.10.8.60:FF:000245', NULL, NULL, 'Sigma-54 dependent response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(149676, NULL, 'G3DSA:1.10.1580.10:FF:000009', NULL, NULL, 'Mitochondrial GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(149677, NULL, 'G3DSA:2.60.40.150:FF:000316', NULL, NULL, 'Protein CBG05923', NULL, NULL, NULL, NULL, NULL, 4),
(149678, NULL, 'G3DSA:1.10.3380.10:FF:000028', NULL, NULL, 'DnaJ domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(149679, NULL, 'G3DSA:1.10.10.1940:FF:000008', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(149680, NULL, 'G3DSA:3.30.450.60:FF:000015', NULL, NULL, 'Signal recognition particle receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(149681, NULL, 'G3DSA:3.30.160.60:FF:005591', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149682, NULL, 'G3DSA:1.10.238.10:FF:001323', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149683, NULL, 'G3DSA:2.30.130.40:FF:000028', NULL, NULL, 'Lon protease homolog', NULL, NULL, NULL, NULL, NULL, 4),
(149684, NULL, 'G3DSA:3.40.390.10:FF:000150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149685, NULL, 'G3DSA:1.20.1720.10:FF:000002', NULL, NULL, 'Multidrug resistance protein B', NULL, NULL, NULL, NULL, NULL, 4),
(149686, NULL, 'G3DSA:3.40.50.1820:FF:000077', NULL, NULL, 'Abhydrolase domain containing 14B', NULL, NULL, NULL, NULL, NULL, 4),
(149687, NULL, 'G3DSA:3.80.10.10:FF:002972', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149688, NULL, 'G3DSA:3.30.465.10:FF:000074', NULL, NULL, 'D-lactate dehydrogenase [cytochrome] mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(149689, NULL, 'G3DSA:3.50.30.30:FF:000103', NULL, NULL, 'Peptidase S8 and S53 subtilisin kexin sedolisin', NULL, NULL, NULL, NULL, NULL, 4),
(149690, NULL, 'G3DSA:4.10.1060.10:FF:000018', NULL, NULL, 'E3 SUMO-protein ligase RanBP2', NULL, NULL, NULL, NULL, NULL, 4),
(149691, NULL, 'G3DSA:2.60.200.20:FF:000162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149692, NULL, 'G3DSA:3.40.50.720:FF:001861', NULL, NULL, 'Peroxisomal trans-2-enoyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(149693, NULL, 'G3DSA:2.30.30.140:FF:000138', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(149694, NULL, 'G3DSA:3.40.50.10190:FF:000294', NULL, NULL, 'Pol lambda-related class X DNA repair polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(149695, NULL, 'G3DSA:1.25.40.10:FF:004926', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149696, NULL, 'G3DSA:3.80.10.10:FF:003461', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(149697, NULL, 'G3DSA:1.20.960.30:FF:000009', NULL, NULL, 'WD40 repeat-containing protein HOS15', NULL, NULL, NULL, NULL, NULL, 4),
(149698, NULL, 'G3DSA:3.40.50.1000:FF:000011', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(149699, NULL, 'G3DSA:2.60.120.10:FF:000624', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149700, NULL, 'G3DSA:2.60.120.260:FF:000307', NULL, NULL, 'Netrin precursor', NULL, NULL, NULL, NULL, NULL, 4),
(149701, NULL, 'G3DSA:1.25.10.10:FF:000563', NULL, NULL, 'Vacuolar import and degradation protein', NULL, NULL, NULL, NULL, NULL, 4),
(149702, NULL, 'G3DSA:1.25.40.10:FF:001700', NULL, NULL, 'putative pentatricopeptide repeat-containing protein At5g08490 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(149703, NULL, 'G3DSA:2.40.128.90:FF:000001', NULL, NULL, 'Outer membrane protease', NULL, NULL, NULL, NULL, NULL, 4),
(149704, NULL, 'G3DSA:1.25.40.10:FF:004426', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149705, NULL, 'G3DSA:2.130.10.10:FF:002893', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149706, NULL, 'G3DSA:3.30.40.10:FF:000817', NULL, NULL, 'Blast:Histone-lysine N-methyltransferase 2C', NULL, NULL, NULL, NULL, NULL, 4),
(149707, NULL, 'G3DSA:3.40.50.2020:FF:000160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149708, NULL, 'G3DSA:3.90.20.20:FF:000036', NULL, NULL, 'Protein GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(149709, NULL, 'G3DSA:3.90.480.10:FF:000011', NULL, NULL, 'Sulfite reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(149710, NULL, 'G3DSA:3.80.10.10:FF:002472', NULL, NULL, 'RabGAP/TBC domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(149711, NULL, 'G3DSA:3.40.50.300:FF:004372', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(149712, NULL, 'G3DSA:2.20.90.10:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149713, NULL, 'G3DSA:3.90.1150.10:FF:000249', NULL, NULL, 'Ornithine aminotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(149714, NULL, 'G3DSA:2.40.70.10:FF:000310', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149715, NULL, 'G3DSA:3.40.50.300:FF:007098', NULL, NULL, 'Dephospho-CoA kinase', NULL, NULL, NULL, NULL, NULL, 4),
(149716, NULL, 'G3DSA:3.30.565.10:FF:000171', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(149717, NULL, 'G3DSA:1.10.8.430:FF:000001', NULL, NULL, 'Apoptotic protease-activating factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(149718, NULL, 'G3DSA:3.40.50.1260:FF:000010', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(149719, NULL, 'G3DSA:1.20.58.70:FF:000095', NULL, NULL, 'Syntaxin-22', NULL, NULL, NULL, NULL, NULL, 4),
(149720, NULL, 'G3DSA:2.120.10.30:FF:000623', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149721, NULL, 'G3DSA:3.30.1380.20:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149722, NULL, 'G3DSA:1.10.510.10:FF:001456', NULL, NULL, 'Protein kinase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(149723, NULL, 'G3DSA:3.40.570.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149724, NULL, 'G3DSA:2.40.170.20:FF:000062', NULL, NULL, 'TonB dependent receptor', NULL, NULL, NULL, NULL, NULL, 4),
(149725, NULL, 'G3DSA:3.30.420.40:FF:000653', NULL, NULL, 'Actin-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(149726, NULL, 'G3DSA:3.55.40.10:FF:000003', NULL, NULL, 'General secretion pathway protein H', NULL, NULL, NULL, NULL, NULL, 4),
(149727, NULL, 'G3DSA:1.20.1250.20:FF:001767', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149728, NULL, 'G3DSA:3.40.50.1110:FF:000044', NULL, NULL, 'Blast:Phospholipase B1, membrane-associated', NULL, NULL, NULL, NULL, NULL, 4),
(149729, NULL, 'G3DSA:1.25.40.10:FF:002156', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At1g56570', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(149730, NULL, 'G3DSA:3.40.50.300:FF:002808', NULL, NULL, 'Selenocysteine-specific elongation factor selB', NULL, NULL, NULL, NULL, NULL, 4),
(149731, NULL, 'G3DSA:3.40.50.300:FF:006642', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149732, NULL, 'G3DSA:3.30.160.60:FF:004955', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149733, NULL, 'G3DSA:2.60.40.10:FF:004034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149734, NULL, 'G3DSA:3.40.50.720:FF:000400', NULL, NULL, 'UDP-glucose 6-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(149735, NULL, 'G3DSA:3.10.170.20:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149736, NULL, 'G3DSA:2.120.10.80:FF:000385', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149737, NULL, 'G3DSA:3.90.1150.10:FF:000188', NULL, NULL, 'Dubious cystathionine gamma-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(149738, NULL, 'G3DSA:3.80.10.10:FF:003309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149739, NULL, 'G3DSA:3.40.50.300:FF:000510', NULL, NULL, 'ADP-ribosylation factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(149740, NULL, 'G3DSA:1.10.472.10:FF:000102', NULL, NULL, 'cyclin-C isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(149741, NULL, 'G3DSA:3.40.50.150:FF:000004', NULL, NULL, 'AdoMet-dependent rRNA methyltransferase SPB1', NULL, NULL, NULL, NULL, NULL, 4),
(149742, NULL, 'G3DSA:1.25.40.20:FF:000068', NULL, NULL, 'ankyrin repeat domain-containing protein 17 isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(149743, NULL, 'G3DSA:1.10.20.10:FF:000029', NULL, NULL, 'son of sevenless homolog 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(149744, NULL, 'G3DSA:3.20.20.100:FF:000128', NULL, NULL, 'NADP(+) coupled glycerol dehydrogenase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(149745, NULL, 'G3DSA:2.130.10.10:FF:004219', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 16', NULL, NULL, NULL, NULL, NULL, 4),
(149746, NULL, 'G3DSA:3.30.710.10:FF:000032', NULL, NULL, 'hypermethylated in cancer 2 protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(149747, NULL, 'G3DSA:2.20.25.10:FF:000077', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(149748, NULL, 'G3DSA:3.30.200.20:FF:001120', NULL, NULL, 'Putative DUF26-domain receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(149749, NULL, 'G3DSA:3.80.10.10:FF:004237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149750, NULL, 'G3DSA:3.30.2350.20:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149751, NULL, 'G3DSA:1.20.1530.20:FF:000029', NULL, NULL, 'K(+) efflux antiporter 6', NULL, NULL, NULL, NULL, NULL, 4),
(149752, NULL, 'G3DSA:2.60.120.200:FF:000043', NULL, NULL, 'Neuropilin', NULL, NULL, NULL, NULL, NULL, 4),
(149753, NULL, 'G3DSA:3.40.1360.10:FF:000018', NULL, NULL, 'Type II DNA topoisomerase VI subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(149754, NULL, 'G3DSA:2.60.40.2070:FF:000002', NULL, NULL, 'Fimbrial outer membrane usher protein', NULL, NULL, NULL, NULL, NULL, 4),
(149755, NULL, 'G3DSA:3.30.890.10:FF:000016', NULL, NULL, 'Methyl-CpG-binding domain protein 2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(149756, NULL, 'G3DSA:1.20.1250.20:FF:001828', NULL, NULL, 'Solute carrier family 16 member 4', NULL, NULL, NULL, NULL, NULL, 4),
(149757, NULL, 'G3DSA:3.10.450.50:FF:000056', NULL, NULL, 'WGS project CABT00000000 data, contig 2.12', NULL, NULL, NULL, NULL, NULL, 4),
(149758, NULL, 'G3DSA:2.40.50.140:FF:001202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149759, NULL, 'G3DSA:1.10.533.10:FF:000183', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(149760, NULL, 'G3DSA:3.40.50.880:FF:000195', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(149761, NULL, 'G3DSA:1.10.287.1490:FF:000088', NULL, NULL, 'Uso1p', NULL, NULL, NULL, NULL, NULL, 4),
(149762, NULL, 'G3DSA:2.60.120.780:FF:000020', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(149763, NULL, 'G3DSA:3.40.1800.20:FF:000011', NULL, NULL, 'transcription factor Sp2', NULL, NULL, NULL, NULL, NULL, 4),
(149764, NULL, 'G3DSA:3.30.70.1450:FF:000042', NULL, NULL, 'SLC13 family permease', NULL, NULL, NULL, NULL, NULL, 4),
(149765, NULL, 'G3DSA:3.30.1010.10:FF:000101', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(149766, NULL, 'G3DSA:1.20.20.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149767, NULL, 'G3DSA:3.10.290.20:FF:000006', NULL, NULL, 'NEDD8-activating enzyme E1 catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(149768, NULL, 'G3DSA:3.40.50.2300:FF:000002', NULL, NULL, 'DNA-binding response regulator PhoP', NULL, NULL, NULL, NULL, NULL, 4),
(149769, NULL, 'G3DSA:3.90.930.12:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149770, NULL, 'G3DSA:3.90.79.10:FF:000090', NULL, NULL, 'Hydrolase, NUDIX family protein', NULL, NULL, NULL, NULL, NULL, 4),
(149771, NULL, 'G3DSA:3.30.160.60:FF:001257', NULL, NULL, 'Zinc finger and BTB domain-containing 48', NULL, NULL, NULL, NULL, NULL, 4),
(149772, NULL, 'G3DSA:2.70.150.10:FF:000135', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(149773, NULL, 'G3DSA:1.10.530.10:FF:000058', NULL, NULL, 'Lysozyme g', NULL, NULL, NULL, NULL, NULL, 4),
(149774, NULL, 'G3DSA:1.10.150.910:FF:000015', NULL, NULL, 'DNA damage-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(149775, NULL, 'G3DSA:1.25.10.10:FF:001811', NULL, NULL, 'AaceriADR331Cp', NULL, NULL, NULL, NULL, NULL, 4),
(149776, NULL, 'G3DSA:1.25.40.20:FF:001349', NULL, NULL, 'Aberrant large forked product', NULL, NULL, NULL, NULL, NULL, 4),
(149777, NULL, 'G3DSA:2.30.29.70:FF:000019', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(149778, NULL, 'G3DSA:1.10.506.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149779, NULL, 'G3DSA:3.30.390.10:FF:000023', NULL, NULL, 'L-Ala-D/L-Glu epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(149780, NULL, 'G3DSA:2.60.40.10:FF:005995', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149781, NULL, 'G3DSA:1.20.200.10:FF:000020', NULL, NULL, 'Os03g0824900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(149782, NULL, 'G3DSA:3.90.1200.10:FF:000041', NULL, NULL, 'Homoserine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(149783, NULL, 'G3DSA:1.10.510.10:FF:003401', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149784, NULL, 'G3DSA:1.10.260.40:FF:000029', NULL, NULL, 'XRE family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(149785, NULL, 'G3DSA:2.60.120.820:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149786, NULL, 'G3DSA:3.40.50.80:FF:000209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149787, NULL, 'G3DSA:2.70.160.11:FF:000030', NULL, NULL, 'Arginine N-methyltransferase, type I', NULL, NULL, NULL, NULL, NULL, 4),
(149788, NULL, 'G3DSA:3.30.470.10:FF:000024', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(149789, NULL, 'G3DSA:3.30.930.10:FF:000104', NULL, NULL, 'histidine--tRNA ligase, cytoplasmic isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(149790, NULL, 'G3DSA:1.10.510.10:FF:002384', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149791, NULL, 'G3DSA:2.60.40.10:FF:004534', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149792, NULL, 'G3DSA:4.10.410.10:FF:000111', NULL, NULL, 'Boophilin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(149793, NULL, 'G3DSA:2.130.10.10:FF:005147', NULL, NULL, 'Vacuolar protein sorting-associated protein 11 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(149794, NULL, 'G3DSA:1.10.20.140:FF:000010', NULL, NULL, 'tRNA dimethylallyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(149795, NULL, 'G3DSA:3.90.190.10:FF:000556', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(149796, NULL, 'G3DSA:2.130.10.10:FF:002713', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(149797, NULL, 'G3DSA:3.30.70.270:FF:000159', NULL, NULL, 'Putative diguanylate cyclase YcdT', NULL, NULL, NULL, NULL, NULL, 4),
(149798, NULL, 'G3DSA:2.40.30.20:FF:000013', NULL, NULL, 'ATP synthase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(149799, NULL, 'G3DSA:3.40.1440.10:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149800, NULL, 'G3DSA:2.130.10.10:FF:002421', NULL, NULL, 'THO complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(149801, NULL, 'G3DSA:2.30.110.10:FF:000102', NULL, NULL, 'Putative flavin reductase', NULL, NULL, NULL, NULL, NULL, 4),
(149802, NULL, 'G3DSA:3.65.10.10:FF:000006', NULL, NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(149803, NULL, 'G3DSA:1.25.40.10:FF:002009', NULL, NULL, 'Pre-mRNA-processing factor 6-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(149804, NULL, 'G3DSA:2.120.10.80:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149805, NULL, 'G3DSA:1.10.150.50:FF:000237', NULL, NULL, 'Kinesin-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(149806, NULL, 'G3DSA:2.60.120.920:FF:000197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149807, NULL, 'G3DSA:1.25.10.70:FF:000002', NULL, NULL, 'Nucleoporin (Nup184), putative', NULL, NULL, NULL, NULL, NULL, 4),
(149808, NULL, 'G3DSA:3.80.10.10:FF:000055', NULL, NULL, 'Protein phosphatase 1 regulatory subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(149809, NULL, 'G3DSA:2.40.320.10:FF:000003', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(149810, NULL, 'G3DSA:2.60.40.1510:FF:000008', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(149811, NULL, 'G3DSA:1.10.472.10:FF:000602', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149812, NULL, 'G3DSA:3.40.50.300:FF:008407', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(149813, NULL, 'G3DSA:2.60.40.10:FF:004826', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149814, NULL, 'G3DSA:3.50.30.30:FF:000075', NULL, NULL, 'RNF13 isoform 14', NULL, NULL, NULL, NULL, NULL, 4),
(149815, NULL, 'G3DSA:3.30.365.10:FF:000010', NULL, NULL, 'Selenate reductase, molybdenum-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(149816, NULL, 'G3DSA:1.10.10.10:FF:000411', NULL, NULL, 'Ecdysone-induced protein 74EF isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(149817, NULL, 'G3DSA:2.160.20.10:FF:000318', NULL, NULL, 'F-box containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(149818, NULL, 'G3DSA:1.10.510.10:FF:003873', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149819, NULL, 'G3DSA:3.50.50.60:FF:000034', NULL, NULL, 'sulfide:quinone oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(149820, NULL, 'G3DSA:1.25.40.10:FF:000391', NULL, NULL, 'Tetratricopeptide repeat domain 12', NULL, NULL, NULL, NULL, NULL, 4),
(149821, NULL, 'G3DSA:3.10.110.10:FF:000165', NULL, NULL, 'ubiquitin-conjugating enzyme E2 A isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(149822, NULL, 'G3DSA:3.30.1370.100:FF:000022', NULL, NULL, 'MutL homolog 3 (E. coli)', NULL, NULL, NULL, NULL, NULL, 4),
(149823, NULL, 'G3DSA:1.25.40.20:FF:001057', NULL, NULL, 'Calcium transporter 2', NULL, NULL, NULL, NULL, NULL, 4),
(149824, NULL, 'G3DSA:1.20.1050.130:FF:000034', NULL, NULL, 'Probable glutamate--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(149825, NULL, 'G3DSA:1.10.287.10:FF:000054', NULL, NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(149826, NULL, 'G3DSA:1.20.1740.10:FF:000065', NULL, NULL, 'Amino acid permease', NULL, NULL, NULL, NULL, NULL, 4),
(149827, NULL, 'G3DSA:3.30.300.20:FF:000015', NULL, NULL, 'Ribosome-binding factor A', NULL, NULL, NULL, NULL, NULL, 4),
(149828, NULL, 'G3DSA:3.10.580.10:FF:000076', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(149829, NULL, 'G3DSA:1.10.530.10:FF:000030', NULL, NULL, 'Chitinase C', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(149830, NULL, 'G3DSA:2.60.120.200:FF:000335', NULL, NULL, 'Protein crumbs', NULL, NULL, NULL, NULL, NULL, 4),
(149831, NULL, 'G3DSA:3.60.15.10:FF:000241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149832, NULL, 'G3DSA:1.10.10.10:FF:000383', NULL, NULL, 'Histone H1', NULL, NULL, NULL, NULL, NULL, 4),
(149833, NULL, 'G3DSA:3.80.10.10:FF:002000', NULL, NULL, 'Nyctalopin', NULL, NULL, NULL, NULL, NULL, 4),
(149834, NULL, 'G3DSA:3.40.50.300:FF:001819', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149835, NULL, 'G3DSA:3.10.100.10:FF:000080', NULL, NULL, 'Killer cell lectin-like receptor subfamily F member 1', NULL, NULL, NULL, NULL, NULL, 4),
(149836, NULL, 'G3DSA:1.25.40.10:FF:004573', NULL, NULL, 'Bardet-Biedl syndrome 4 protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(149837, NULL, 'G3DSA:3.40.30.10:FF:000530', NULL, NULL, 'Peroxiredoxin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(149838, NULL, 'G3DSA:3.40.50.10540:FF:000005', NULL, NULL, 'succinate--hydroxymethylglutarate CoA-transferase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(149839, NULL, 'G3DSA:3.30.160.60:FF:002538', NULL, NULL, 'Mot3p', NULL, NULL, NULL, NULL, NULL, 4),
(149840, NULL, 'G3DSA:3.20.20.140:FF:000472', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149841, NULL, 'G3DSA:3.40.1280.10:FF:000017', NULL, NULL, 'rRNA methyltransferase 3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(149842, NULL, 'G3DSA:3.50.50.60:FF:000473', NULL, NULL, 'tRNA 5-methylaminomethyl-2-thiouridine biosynthesis bifunctional protein MnmC', NULL, NULL, NULL, NULL, NULL, 4),
(149843, NULL, 'G3DSA:3.30.40.10:FF:001806', NULL, NULL, 'Sister chromatid cohesion protein', NULL, NULL, NULL, NULL, NULL, 4),
(149844, NULL, 'G3DSA:3.20.20.70:FF:000514', NULL, NULL, 'Dihydroorotate dehydrogenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(149845, NULL, 'G3DSA:3.30.160.60:FF:003202', NULL, NULL, 'Zinc finger protein 217', NULL, NULL, NULL, NULL, NULL, 4),
(149846, NULL, 'G3DSA:3.40.710.10:FF:000007', NULL, NULL, 'D-alanyl-D-alanine endopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(149847, NULL, 'G3DSA:2.10.25.10:FF:001527', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(149848, NULL, 'G3DSA:2.60.120.430:FF:000027', NULL, NULL, 'Chondroitin sulfate ABC lyase', NULL, NULL, NULL, NULL, NULL, 4),
(149849, NULL, 'G3DSA:3.30.230.70:FF:000041', NULL, NULL, 'WGS project CABT00000000 data, contig 2.3', NULL, NULL, NULL, NULL, NULL, 4),
(149850, NULL, 'G3DSA:3.30.160.60:FF:000740', NULL, NULL, 'zinc finger protein 133 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(149851, NULL, 'G3DSA:3.30.70.330:FF:002296', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149852, NULL, 'G3DSA:3.30.70.560:FF:000010', NULL, NULL, 'Folic acid synthesis protein fol1', NULL, NULL, NULL, NULL, NULL, 4),
(149853, NULL, 'G3DSA:1.25.10.10:FF:002328', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149854, NULL, 'G3DSA:2.130.10.10:FF:004658', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149855, NULL, 'G3DSA:3.40.50.410:FF:000190', NULL, NULL, 'Circularly permutated Ras protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(149856, NULL, 'G3DSA:1.20.1070.10:FF:000272', NULL, NULL, 'G protein-coupled receptor 146', NULL, NULL, NULL, NULL, NULL, 4),
(149857, NULL, 'G3DSA:3.40.710.10:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149858, NULL, 'G3DSA:2.30.42.10:FF:000313', NULL, NULL, 'MAGI (Membrane Associated Guanylate kinase Inverted) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(149859, NULL, 'G3DSA:3.30.1370.10:FF:000061', NULL, NULL, 'High density lipoprotein binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(149860, NULL, 'G3DSA:3.40.309.10:FF:000041', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(149861, NULL, 'G3DSA:2.60.40.10:FF:000791', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(149862, NULL, 'G3DSA:1.10.132.20:FF:000001', NULL, NULL, 'Ribosome-recycling factor', NULL, NULL, NULL, NULL, NULL, 4),
(149863, NULL, 'G3DSA:2.40.30.10:FF:000217', NULL, NULL, 'NADPH oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(149864, NULL, 'G3DSA:3.40.50.300:FF:002455', NULL, NULL, 'F-box DNA helicase 1', NULL, NULL, NULL, NULL, NULL, 4),
(149865, NULL, 'G3DSA:1.10.1080.10:FF:000016', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(149866, NULL, 'G3DSA:3.40.50.620:FF:000016', NULL, NULL, 'Putative choline-phosphate cytidylyltransferase B', NULL, NULL, NULL, NULL, NULL, 4),
(149867, NULL, 'G3DSA:3.40.47.10:FF:000153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149868, NULL, 'G3DSA:3.30.200.20:FF:000923', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149869, NULL, 'G3DSA:2.10.109.10:FF:000047', NULL, NULL, 'Peptidase S26B, signal peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(149870, NULL, 'G3DSA:2.10.90.10:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149871, NULL, 'G3DSA:1.20.58.180:FF:000002', NULL, NULL, 'Glycine--tRNA ligase, chloroplastic/mitochondrial 2', NULL, NULL, NULL, NULL, NULL, 4),
(149872, NULL, 'G3DSA:2.60.40.60:FF:000726', NULL, NULL, 'Cadherin-4', NULL, NULL, NULL, NULL, NULL, 4),
(149873, NULL, 'G3DSA:2.60.210.10:FF:000070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149874, NULL, 'G3DSA:1.10.472.10:FF:000074', NULL, NULL, 'D3-type cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(149875, NULL, 'G3DSA:1.20.1270.60:FF:000274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149876, NULL, 'G3DSA:2.40.50.100:FF:000049', NULL, NULL, 'Auxiliary transport protein, membrane fusion protein family', NULL, NULL, NULL, NULL, NULL, 4),
(149877, NULL, 'G3DSA:3.40.50.1220:FF:000105', NULL, NULL, 'Putative indolepyruvate decarboxylase, isozyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(149878, NULL, 'G3DSA:1.20.5.190:FF:000123', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149879, NULL, 'G3DSA:1.20.140.100:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149880, NULL, 'G3DSA:2.10.250.10:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149881, NULL, 'G3DSA:3.40.50.300:FF:007126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149882, NULL, 'G3DSA:2.60.40.60:FF:000873', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149883, NULL, 'G3DSA:3.40.50.1820:FF:000369', NULL, NULL, 'LD47264p', NULL, NULL, NULL, NULL, NULL, 4),
(149884, NULL, 'G3DSA:3.30.565.10:FF:000463', NULL, NULL, 'Two component signal transduction system controlling the osmosenstive K+ channel histidine kinase KdpD', NULL, NULL, NULL, NULL, NULL, 4),
(149885, NULL, 'G3DSA:3.90.980.10:FF:000004', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(149886, NULL, 'G3DSA:2.60.40.640:FF:000047', NULL, NULL, 'pH-response regulator protein palF/RIM8', NULL, NULL, NULL, NULL, NULL, 4),
(149887, NULL, 'G3DSA:1.10.287.660:FF:000029', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(149888, NULL, 'G3DSA:1.10.10.60:FF:000757', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(149889, NULL, 'G3DSA:2.60.40.10:FF:000644', NULL, NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein', NULL, NULL, NULL, NULL, NULL, 4),
(149890, NULL, 'G3DSA:1.10.245.10:FF:000007', NULL, NULL, 'SWIB complex BAF60b domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(149891, NULL, 'G3DSA:3.80.10.10:FF:001544', NULL, NULL, 'Leucine-rich repeat-containing protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(149892, NULL, 'G3DSA:3.30.70.330:FF:002116', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149893, NULL, 'G3DSA:3.30.160.60:FF:005411', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149894, NULL, 'G3DSA:1.25.40.120:FF:000054', NULL, NULL, 'RAB geranylgeranyl transferase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(149895, NULL, 'G3DSA:3.30.70.141:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149896, NULL, 'G3DSA:2.60.260.20:FF:000019', NULL, NULL, 'DnaJ subfamily A member', NULL, NULL, NULL, NULL, NULL, 4),
(149897, NULL, 'G3DSA:3.40.630.10:FF:000186', NULL, NULL, 'Protein CBG15123', NULL, NULL, NULL, NULL, NULL, 4),
(149898, NULL, 'G3DSA:1.10.510.10:FF:001748', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(149899, NULL, 'G3DSA:1.20.58.390:FF:000239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149900, NULL, 'G3DSA:2.40.30.10:FF:000364', NULL, NULL, 'NADPH-dependent diflavin oxidoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(149901, NULL, 'G3DSA:3.30.70.580:FF:000049', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(149902, NULL, 'G3DSA:2.40.50.140:FF:000713', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149903, NULL, 'G3DSA:2.30.29.30:FF:000266', NULL, NULL, 'Capping protein, Arp2/3 and myosin-I linker protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(149904, NULL, 'G3DSA:3.40.50.720:FF:001209', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] reductase', NULL, NULL, NULL, NULL, NULL, 4),
(149905, NULL, 'G3DSA:2.40.70.10:FF:000282', NULL, NULL, 'Secretory aspartyl protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(149906, NULL, 'G3DSA:3.30.160.60:FF:004663', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149907, NULL, 'G3DSA:3.30.470.20:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149908, NULL, 'G3DSA:3.30.70.20:FF:000002', NULL, NULL, 'NADH-ubiquinone oxidoreductase 75 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(149909, NULL, 'G3DSA:3.90.190.10:FF:000264', NULL, NULL, 'Protein tyrosine phosphatase type IVA, member 3', NULL, NULL, NULL, NULL, NULL, 4),
(149910, NULL, 'G3DSA:2.60.40.10:FF:005462', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149911, NULL, 'G3DSA:1.20.1250.20:FF:000339', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(149912, NULL, 'G3DSA:1.20.120.1760:FF:000027', NULL, NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(149913, NULL, 'G3DSA:3.30.160.60:FF:002977', NULL, NULL, 'AGAP009066-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(149914, NULL, 'G3DSA:3.30.60.90:FF:000005', NULL, NULL, 'Putative E3 ubiquitin-protein ligase mib1', NULL, NULL, NULL, NULL, NULL, 4),
(149915, NULL, 'G3DSA:2.60.40.150:FF:000288', NULL, NULL, 'Copine-8', NULL, NULL, NULL, NULL, NULL, 4),
(149916, NULL, 'G3DSA:1.25.40.10:FF:000239', NULL, NULL, 'Transmembrane and TPR repeat-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(149917, NULL, 'G3DSA:2.20.70.10:FF:000092', NULL, NULL, 'WW domain-binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(149918, NULL, 'G3DSA:1.20.5.430:FF:000004', NULL, NULL, 'heat shock factor-binding protein 1-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(149919, NULL, 'G3DSA:3.30.200.20:FF:001412', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(149920, NULL, 'G3DSA:2.60.260.20:FF:000171', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(149921, NULL, 'G3DSA:1.25.40.10:FF:000211', NULL, NULL, 'tetratricopeptide repeat protein 30B', NULL, NULL, NULL, NULL, NULL, 4),
(149922, NULL, 'G3DSA:2.40.180.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149923, NULL, 'G3DSA:3.30.70.1230:FF:000240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149924, NULL, 'G3DSA:2.10.70.10:FF:000261', NULL, NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(149925, NULL, 'G3DSA:1.10.287.130:FF:000106', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(149926, NULL, 'G3DSA:3.40.50.1000:FF:000483', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149927, NULL, 'G3DSA:1.10.418.60:FF:000014', NULL, NULL, 'Probable kinetochore protein NUF2', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(149928, NULL, 'G3DSA:2.10.25.10:FF:001674', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149929, NULL, 'G3DSA:1.20.120.1200:FF:000028', NULL, NULL, 'ATP synthase subunit a', NULL, NULL, NULL, NULL, NULL, 4),
(149930, NULL, 'G3DSA:3.40.50.300:FF:008587', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149931, NULL, 'G3DSA:2.70.170.10:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149932, NULL, 'G3DSA:1.25.10.10:FF:001991', NULL, NULL, 'Exportin 5', NULL, NULL, NULL, NULL, NULL, 4),
(149933, NULL, 'G3DSA:2.60.40.10:FF:001280', NULL, NULL, 'V-set and immunoglobulin domain containing 2 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(149934, NULL, 'G3DSA:3.40.50.2000:FF:000474', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(149935, NULL, 'G3DSA:3.80.10.10:FF:002180', NULL, NULL, 'Tropomodulin-2', NULL, NULL, NULL, NULL, NULL, 4),
(149936, NULL, 'G3DSA:1.10.30.50:FF:000019', NULL, NULL, 'Slr2080 protein', NULL, NULL, NULL, NULL, NULL, 4),
(149937, NULL, 'G3DSA:3.30.390.30:FF:000001', NULL, NULL, 'Dihydrolipoyl dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(149938, NULL, 'G3DSA:3.40.50.300:FF:004664', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149939, NULL, 'G3DSA:3.30.420.40:FF:000361', NULL, NULL, 'MPA43p protein', NULL, NULL, NULL, NULL, NULL, 4),
(149940, NULL, 'G3DSA:3.40.630.150:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149941, NULL, 'G3DSA:1.10.510.10:FF:002945', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149942, NULL, 'G3DSA:1.25.40.10:FF:004134', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(149943, NULL, 'G3DSA:3.20.80.10:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149944, NULL, 'G3DSA:3.30.420.10:FF:000285', NULL, NULL, '3''-5''_exonuclease_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(149945, NULL, 'G3DSA:3.30.450.20:FF:000323', NULL, NULL, 'Sensory box histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(149946, NULL, 'G3DSA:1.20.5.350:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149947, NULL, 'G3DSA:3.40.50.150:FF:001432', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149948, NULL, 'G3DSA:3.40.50.1100:FF:000215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149949, NULL, 'G3DSA:3.40.190.10:FF:000522', NULL, NULL, 'Phosphate ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(149950, NULL, 'G3DSA:1.25.40.10:FF:002448', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g13040, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(149951, NULL, 'G3DSA:3.40.33.10:FF:000183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149952, NULL, 'G3DSA:1.10.1900.10:FF:000018', NULL, NULL, 'Polyadenylate-binding protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(149953, NULL, 'G3DSA:3.90.120.10:FF:000018', NULL, NULL, 'Modification methylase AplI', NULL, NULL, NULL, NULL, NULL, 4),
(149954, NULL, 'G3DSA:1.10.1040.50:FF:000003', NULL, NULL, 'Fatty acid oxidation complex subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(149955, NULL, 'G3DSA:2.30.30.140:FF:000110', NULL, NULL, 'Survival motor neuron-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(149956, NULL, 'G3DSA:3.30.40.10:FF:002234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149957, NULL, 'G3DSA:1.20.120.1780:FF:000005', NULL, NULL, 'Chlorophyll synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(149958, NULL, 'G3DSA:3.40.366.10:FF:000009', NULL, NULL, 'Fatty acid synthase Fas', NULL, NULL, NULL, NULL, NULL, 4),
(149959, NULL, 'G3DSA:3.30.420.40:FF:000592', NULL, NULL, 'Hexokinase domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(149960, NULL, 'G3DSA:1.25.70.10:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149961, NULL, 'G3DSA:1.20.1270.60:FF:000302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(149962, NULL, 'G3DSA:1.25.40.820:FF:000022', NULL, NULL, 'Putative RNA polymerase II subunit B1 CTD phosphatase rtr1', NULL, NULL, NULL, NULL, NULL, 4),
(149963, NULL, 'G3DSA:1.20.1540.10:FF:000084', NULL, NULL, 'Integral membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(149964, NULL, 'G3DSA:3.10.129.10:FF:000039', NULL, NULL, 'Beta-hydroxyacyl-ACP dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(149965, NULL, 'G3DSA:3.30.1330.60:FF:000022', NULL, NULL, 'Sodium-type flagellar protein MotY', NULL, NULL, NULL, NULL, NULL, 4),
(149966, NULL, 'G3DSA:3.30.465.10:FF:000135', NULL, NULL, 'Glycolate oxidase subunits GlcE and GlcF', NULL, NULL, NULL, NULL, NULL, 4),
(149967, NULL, 'G3DSA:1.10.510.10:FF:000759', NULL, NULL, 'CAMK/CAMKL/AMPK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(149968, NULL, 'G3DSA:3.40.50.1400:FF:000007', NULL, NULL, 'Ferrochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(149969, NULL, 'G3DSA:3.80.10.10:FF:002028', NULL, NULL, 'Si:ch211-11p18.6', NULL, NULL, NULL, NULL, NULL, 4),
(149970, NULL, 'G3DSA:2.30.30.100:FF:000205', NULL, NULL, 'Small nuclear ribonucleoprotein E', NULL, NULL, NULL, NULL, NULL, 4),
(149971, NULL, 'G3DSA:1.10.274.30:FF:000030', NULL, NULL, 'Protein CBG13706', NULL, NULL, NULL, NULL, NULL, 4),
(149972, NULL, 'G3DSA:1.20.1110.10:FF:000208', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149973, NULL, 'G3DSA:1.20.58.80:FF:000013', NULL, NULL, 'STAM-binding protein-like A', NULL, NULL, NULL, NULL, NULL, 4),
(149974, NULL, 'G3DSA:2.60.11.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149975, NULL, 'G3DSA:3.40.50.11350:FF:000029', NULL, NULL, 'Alpha-(1,6)-fucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(149976, NULL, 'G3DSA:1.25.10.10:FF:002300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149977, NULL, 'G3DSA:2.40.50.740:FF:000005', NULL, NULL, '30S ribosomal protein S4e', NULL, NULL, NULL, NULL, NULL, 4),
(149978, NULL, 'G3DSA:3.40.50.150:FF:000768', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149979, NULL, 'G3DSA:3.30.160.60:FF:000768', NULL, NULL, 'zinc finger homeobox protein 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(149980, NULL, 'G3DSA:3.80.10.10:FF:000847', NULL, NULL, 'NACHT, LRR and PYD domains-containing protein 12 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(149981, NULL, 'G3DSA:3.30.70.1230:FF:000268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149982, NULL, 'G3DSA:3.40.50.1820:FF:000577', NULL, NULL, 'Peptide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(149983, NULL, 'G3DSA:2.40.50.90:FF:000136', NULL, NULL, 'Tudor domain-containing protein 7A', NULL, NULL, NULL, NULL, NULL, 4),
(149984, NULL, 'G3DSA:3.40.1110.10:FF:000270', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(149985, NULL, 'G3DSA:3.30.230.10:FF:000394', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(149986, NULL, 'G3DSA:3.90.70.110:FF:000002', NULL, NULL, 'Polyprotein P1234', NULL, NULL, NULL, NULL, NULL, 4),
(149987, NULL, 'G3DSA:3.90.70.10:FF:000715', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(149988, NULL, 'G3DSA:1.20.58.60:FF:000058', NULL, NULL, 'Short stop, isoform K', NULL, NULL, NULL, NULL, NULL, 4),
(149989, NULL, 'G3DSA:3.40.630.10:FF:000006', NULL, NULL, 'N-acetyldiaminopimelate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(149990, NULL, 'G3DSA:3.90.550.10:FF:000039', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(149991, NULL, 'G3DSA:1.20.5.170:FF:000084', NULL, NULL, 'Mitotic spindle assembly checkpoint protein MAD1', NULL, NULL, NULL, NULL, NULL, 4),
(149992, NULL, 'G3DSA:3.30.200.20:FF:001620', NULL, NULL, 'Probable protein kinase yloP', NULL, NULL, NULL, NULL, NULL, 4),
(149993, NULL, 'G3DSA:3.40.50.300:FF:003444', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(149994, NULL, 'G3DSA:2.120.10.30:FF:000123', NULL, NULL, 'Chloroplast protein HCF243', NULL, NULL, NULL, NULL, NULL, 4),
(149995, NULL, 'G3DSA:1.20.1070.10:FF:001109', NULL, NULL, 'Neuropeptide FF receptor 2', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(149996, NULL, 'G3DSA:3.30.2080.10:FF:000016', NULL, NULL, 'Alpha-1,2-mannosidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(149997, NULL, 'G3DSA:3.30.160.60:FF:002477', NULL, NULL, 'Zinc finger protein 521', NULL, NULL, NULL, NULL, NULL, 4),
(149998, NULL, 'G3DSA:1.25.40.10:FF:005354', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(149999, NULL, 'G3DSA:1.20.1250.20:FF:001267', NULL, NULL, 'Solute carrier family 15 member 3', NULL, NULL, NULL, NULL, NULL, 4),
(150000, NULL, 'G3DSA:1.20.58.390:FF:000211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150001, NULL, 'G3DSA:3.40.850.10:FF:000225', NULL, NULL, 'Putative kinesin', NULL, NULL, NULL, NULL, NULL, 4),
(150002, NULL, 'G3DSA:3.30.40.10:FF:000525', NULL, NULL, 'PHD finger protein 24', NULL, NULL, NULL, NULL, NULL, 4),
(150003, NULL, 'G3DSA:1.25.40.20:FF:001821', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150004, NULL, 'G3DSA:3.10.120.10:FF:000019', NULL, NULL, 'Chitin synthase ChsE', NULL, NULL, NULL, NULL, NULL, 4),
(150005, NULL, 'G3DSA:3.40.50.1820:FF:001566', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150006, NULL, 'G3DSA:3.30.70.330:FF:001599', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150007, NULL, 'G3DSA:2.10.25.10:FF:000038', NULL, NULL, 'Fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(150008, NULL, 'G3DSA:3.30.1010.10:FF:000068', NULL, NULL, 'YALI0F20636p', NULL, NULL, NULL, NULL, NULL, 4),
(150009, NULL, 'G3DSA:1.20.1000.10:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150010, NULL, 'G3DSA:2.10.25.10:FF:001466', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(150011, NULL, 'G3DSA:1.10.472.10:FF:000282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150012, NULL, 'G3DSA:3.30.160.60:FF:001757', NULL, NULL, 'paternally-expressed gene 3 protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(150013, NULL, 'G3DSA:2.20.28.30:FF:000005', NULL, NULL, 'CHY zinc finger-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(150014, NULL, 'G3DSA:1.20.120.1240:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150015, NULL, 'G3DSA:3.30.70.100:FF:000187', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150016, NULL, 'G3DSA:3.40.50.300:FF:004872', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(150017, NULL, 'G3DSA:2.60.120.290:FF:000030', NULL, NULL, 'Seizure related 6 homolog like', NULL, NULL, NULL, NULL, NULL, 4),
(150018, NULL, 'G3DSA:3.40.50.720:FF:000580', NULL, NULL, 'Putative mitochondrial NADH-ubiquinone oxidoreductase complex I subunit,FT', NULL, NULL, NULL, NULL, NULL, 4),
(150019, NULL, 'G3DSA:1.10.3260.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150020, NULL, 'G3DSA:3.40.50.2300:FF:000266', NULL, NULL, 'Glutamate [NMDA] receptor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(150021, NULL, 'G3DSA:1.10.260.100:FF:000016', NULL, NULL, 'Stress-induced protein sti1', NULL, NULL, NULL, NULL, NULL, 4),
(150022, NULL, 'G3DSA:1.25.10.10:FF:001783', NULL, NULL, 'serine/threonine-protein phosphatase 4 regulatory subunit 4-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(150023, NULL, 'G3DSA:4.10.60.10:FF:000059', NULL, NULL, 'Gis2p', NULL, NULL, NULL, NULL, NULL, 4),
(150024, NULL, 'G3DSA:2.130.10.130:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150025, NULL, 'G3DSA:2.130.10.10:FF:000184', NULL, NULL, 'semaphorin-6C isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(150026, NULL, 'G3DSA:2.130.10.10:FF:003202', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150027, NULL, 'G3DSA:2.60.40.10:FF:002617', NULL, NULL, 'Protein tyrosine phosphatase receptor type K', NULL, NULL, NULL, NULL, NULL, 4),
(150028, NULL, 'G3DSA:1.25.10.10:FF:001047', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150029, NULL, 'G3DSA:3.40.50.720:FF:001389', NULL, NULL, 'UDP-N-acetyl-2-amino-2-deoxy-D-glucuronate oxidase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(150030, NULL, 'G3DSA:3.80.10.10:FF:004006', NULL, NULL, 'Protein CBR-MRPS-18A', NULL, NULL, NULL, NULL, NULL, 4),
(150031, NULL, 'G3DSA:3.40.50.11950:FF:000001', NULL, NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(150032, NULL, 'G3DSA:3.90.79.10:FF:000151', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(150033, NULL, 'G3DSA:2.40.10.10:FF:000626', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150034, NULL, 'G3DSA:3.30.230.10:FF:000130', NULL, NULL, 'Endopeptidase La', NULL, NULL, NULL, NULL, NULL, 4),
(150035, NULL, 'G3DSA:1.25.10.10:FF:002036', NULL, NULL, 'Armadillo/beta-catenin-like repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150036, NULL, 'G3DSA:1.10.10.10:FF:001900', NULL, NULL, 'O-methyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(150037, NULL, 'G3DSA:1.10.10.60:FF:000173', NULL, NULL, 'brain-specific homeobox protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(150038, NULL, 'G3DSA:3.10.129.10:FF:000191', NULL, NULL, 'Long-chain acyl-CoA thioesterase, BFIT_BACH family', NULL, NULL, NULL, NULL, NULL, 4),
(150039, NULL, 'G3DSA:3.90.1530.30:FF:000009', NULL, NULL, 'Partitioning protein', NULL, NULL, NULL, NULL, NULL, 4),
(150040, NULL, 'G3DSA:3.20.20.140:FF:000264', NULL, NULL, 'Periplasmic amidohydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(150041, NULL, 'G3DSA:1.20.1690.10:FF:000004', NULL, NULL, 'V-type proton ATPase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(150042, NULL, 'G3DSA:1.25.40.10:FF:000891', NULL, NULL, 'SGT1 and CS domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(150043, NULL, 'G3DSA:3.90.226.10:FF:000213', NULL, NULL, 'Enoyl-CoA hydratase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(150044, NULL, 'G3DSA:3.30.160.60:FF:001049', NULL, NULL, 'zinc finger protein 319', NULL, NULL, NULL, NULL, NULL, 4),
(150045, NULL, 'G3DSA:3.20.20.80:FF:000635', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150046, NULL, 'G3DSA:3.40.50.1460:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150047, NULL, 'G3DSA:1.10.1320.10:FF:000024', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(150048, NULL, 'G3DSA:3.40.50.150:FF:000504', NULL, NULL, 'Integral membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(150049, NULL, 'G3DSA:2.10.25.10:FF:001819', NULL, NULL, 'Protein CBG10218', NULL, NULL, NULL, NULL, NULL, 4),
(150050, NULL, 'G3DSA:1.10.3390.10:FF:000001', NULL, NULL, 'UPF0352 protein YejL', NULL, NULL, NULL, NULL, NULL, 4),
(150051, NULL, 'G3DSA:3.90.76.10:FF:000049', NULL, NULL, 'Putative substrate binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(150052, NULL, 'G3DSA:3.40.50.300:FF:001999', NULL, NULL, 'Rho-related BTB domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(150053, NULL, 'G3DSA:3.50.50.60:FF:000181', NULL, NULL, 'Pyridine nucleotide-disulfide oxidoreductase domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(150054, NULL, 'G3DSA:2.60.120.260:FF:000454', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(150055, NULL, 'G3DSA:3.40.50.150:FF:001724', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150056, NULL, 'G3DSA:3.40.50.450:FF:000004', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(150057, NULL, 'G3DSA:3.40.30.10:FF:000558', NULL, NULL, 'Major surface protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(150058, NULL, 'G3DSA:1.10.510.10:FF:000967', NULL, NULL, 'Protein CBG11274', NULL, NULL, NULL, NULL, NULL, 4),
(150059, NULL, 'G3DSA:1.20.120.2010:FF:000001', NULL, NULL, 'NGFI-A-binding protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(150060, NULL, 'G3DSA:3.30.70.600:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150061, NULL, 'G3DSA:3.80.10.10:FF:003809', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150062, NULL, 'G3DSA:3.40.50.300:FF:000010', NULL, NULL, 'Chaperone clpB 1, putative', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(150063, NULL, 'G3DSA:1.20.1250.20:FF:002256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150064, NULL, 'G3DSA:2.60.60.20:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150065, NULL, 'G3DSA:1.10.8.10:FF:000163', NULL, NULL, 'Ubiquitin-specific peptidase 28', NULL, NULL, NULL, NULL, NULL, 4),
(150066, NULL, 'G3DSA:3.40.50.2000:FF:001019', NULL, NULL, 'Alphaalpha-trehalose-phosphate synthase [UDP-forming] 5', NULL, NULL, NULL, NULL, NULL, 4),
(150067, NULL, 'G3DSA:3.90.1530.10:FF:000003', NULL, NULL, 'Sulfiredoxin chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(150068, NULL, 'G3DSA:3.40.50.1370:FF:000043', NULL, NULL, 'Ornithine carbamoyltransferase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(150069, NULL, 'G3DSA:2.60.40.1180:FF:000044', NULL, NULL, 'Alpha-glucosidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(150070, NULL, 'G3DSA:1.25.10.10:FF:001311', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150071, NULL, 'G3DSA:3.40.50.410:FF:000043', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(150072, NULL, 'G3DSA:3.30.160.60:FF:006428', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150073, NULL, 'G3DSA:3.90.550.50:FF:000152', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150074, NULL, 'G3DSA:1.10.287.370:FF:000066', NULL, NULL, 'Prefoldin subunit 5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150075, NULL, 'G3DSA:1.10.510.10:FF:002592', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150076, NULL, 'G3DSA:2.60.40.10:FF:004798', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150077, NULL, 'G3DSA:4.10.1240.30:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150078, NULL, 'G3DSA:3.40.50.1260:FF:000038', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(150079, NULL, 'G3DSA:3.30.40.10:FF:001453', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150080, NULL, 'G3DSA:3.30.200.20:FF:001884', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150081, NULL, 'G3DSA:3.30.450.20:FF:000615', NULL, NULL, 'Neuronal PAS domain-containing protein 4B', NULL, NULL, NULL, NULL, NULL, 4),
(150082, NULL, 'G3DSA:1.20.890.10:FF:000026', NULL, NULL, 'cAMP-dependent protein kinase type II-alpha regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(150083, NULL, 'G3DSA:3.30.70.330:FF:000351', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein 27C', NULL, NULL, NULL, NULL, NULL, 4),
(150084, NULL, 'G3DSA:1.10.1300.10:FF:000080', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(150085, NULL, 'G3DSA:3.30.160.60:FF:002685', NULL, NULL, 'Zinc finger protein 285', NULL, NULL, NULL, NULL, NULL, 4),
(150086, NULL, 'G3DSA:2.60.40.1450:FF:000001', NULL, NULL, 'Recombining binding protein suppressor of hairless', NULL, NULL, NULL, NULL, NULL, 4),
(150087, NULL, 'G3DSA:3.40.50.2000:FF:000502', NULL, NULL, 'N-acylglucosamine 2-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(150088, NULL, 'G3DSA:1.20.1070.10:FF:002037', NULL, NULL, 'GM02327p', NULL, NULL, NULL, NULL, NULL, 4),
(150089, NULL, 'G3DSA:1.20.1510.10:FF:000048', NULL, NULL, 'Cation-efflux pump FieF protein', NULL, NULL, NULL, NULL, NULL, 4),
(150090, NULL, 'G3DSA:3.20.20.70:FF:000161', NULL, NULL, 'Dual-specificity RNA methyltransferase RlmN', NULL, NULL, NULL, NULL, NULL, 4),
(150091, NULL, 'G3DSA:2.40.50.140:FF:000421', NULL, NULL, 'Replication protein A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(150092, NULL, 'G3DSA:3.60.21.10:FF:000446', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(150093, NULL, 'G3DSA:3.40.50.1000:FF:000775', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150094, NULL, 'G3DSA:1.25.40.10:FF:000183', NULL, NULL, 'ARM-repeat/Tetratricopeptide repeat (TPR)-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(150095, NULL, 'G3DSA:2.60.40.10:FF:003606', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150096, NULL, 'G3DSA:1.10.340.30:FF:000061', NULL, NULL, '8-oxoguanine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(150097, NULL, 'G3DSA:3.40.50.10490:FF:000086', NULL, NULL, 'Glucose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(150098, NULL, 'G3DSA:3.40.50.1000:FF:000511', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150099, NULL, 'G3DSA:2.120.10.100:FF:000005', NULL, NULL, 'Calcium-activated nucleotidase 1b', NULL, NULL, NULL, NULL, NULL, 4),
(150100, NULL, 'G3DSA:1.10.510.10:FF:002092', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150101, NULL, 'G3DSA:3.40.50.300:FF:008615', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150102, NULL, 'G3DSA:3.40.50.1860:FF:000010', NULL, NULL, 'Glutamate racemase', NULL, NULL, NULL, NULL, NULL, 4),
(150103, NULL, 'G3DSA:4.10.1240.50:FF:000016', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150104, NULL, 'G3DSA:1.50.10.130:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150105, NULL, 'G3DSA:3.40.50.300:FF:001027', NULL, NULL, 'dynamin-related protein 3A', NULL, NULL, NULL, NULL, NULL, 4),
(150106, NULL, 'G3DSA:2.130.10.10:FF:005355', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150107, NULL, 'G3DSA:3.20.20.100:FF:000100', NULL, NULL, 'Hypothetical protein LOC594893', NULL, NULL, NULL, NULL, NULL, 4),
(150108, NULL, 'G3DSA:3.30.160.60:FF:001549', NULL, NULL, 'Zinc finger protein 75a', NULL, NULL, NULL, NULL, NULL, 4),
(150109, NULL, 'G3DSA:3.30.300.30:FF:000052', NULL, NULL, 'Ss-alanyl conjugating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(150110, NULL, 'G3DSA:3.30.420.10:FF:000313', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150111, NULL, 'G3DSA:1.25.40.710:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150112, NULL, 'G3DSA:3.30.420.10:FF:000577', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150113, NULL, 'G3DSA:3.30.160.60:FF:004894', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150114, NULL, 'G3DSA:1.10.1420.10:FF:000088', NULL, NULL, 'Endonuclease MutS2', NULL, NULL, NULL, NULL, NULL, 4),
(150115, NULL, 'G3DSA:1.25.40.10:FF:002217', NULL, NULL, 'ER membrane protein complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(150116, NULL, 'G3DSA:2.130.10.10:FF:005939', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150117, NULL, 'G3DSA:3.50.7.10:FF:000005', NULL, NULL, 'T-complex protein 1 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(150118, NULL, 'G3DSA:1.20.1250.20:FF:000047', NULL, NULL, '3-phenylpropionic acid MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(150119, NULL, 'G3DSA:1.10.10.10:FF:001400', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC6', NULL, NULL, NULL, NULL, NULL, 4),
(150120, NULL, 'G3DSA:1.10.287.70:FF:000318', NULL, NULL, 'Cyclic nucleotide-gated potassium channel', NULL, NULL, NULL, NULL, NULL, 4),
(150121, NULL, 'G3DSA:3.40.720.10:FF:000013', NULL, NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(150122, NULL, 'G3DSA:3.40.50.970:FF:000042', NULL, NULL, 'Oxalyl-CoA decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(150123, NULL, 'G3DSA:3.30.559.10:FF:000078', NULL, NULL, 'Nonribosomal peptide synthetase DhbF', NULL, NULL, NULL, NULL, NULL, 4),
(150124, NULL, 'G3DSA:3.20.20.80:FF:000843', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150125, NULL, 'G3DSA:3.80.10.10:FF:000263', NULL, NULL, 'volume-regulated anion channel subunit LRRC8B', NULL, NULL, NULL, NULL, NULL, 4),
(150126, NULL, 'G3DSA:4.10.1240.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150127, NULL, 'G3DSA:1.20.920.10:FF:000024', NULL, NULL, 'Transcription intermediary factor 1-alpha', NULL, NULL, NULL, NULL, NULL, 4),
(150128, NULL, 'G3DSA:3.40.50.300:FF:006581', NULL, NULL, 'RAS (RAD and GEM)-like GTP binding 2', NULL, NULL, NULL, NULL, NULL, 4),
(150129, NULL, 'G3DSA:3.30.1490.100:FF:000032', NULL, NULL, 'DNA-directed DNA polymerase eta', NULL, NULL, NULL, NULL, NULL, 4),
(150130, NULL, 'G3DSA:3.30.559.70:FF:000017', NULL, NULL, 'Choline/Carnitine o-acyltransferase-like protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(150131, NULL, 'G3DSA:1.10.357.50:FF:000015', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150132, NULL, 'G3DSA:3.40.50.300:FF:003236', NULL, NULL, 'Protein brown', NULL, NULL, NULL, NULL, NULL, 4),
(150133, NULL, 'G3DSA:1.20.1250.20:FF:002195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150134, NULL, 'G3DSA:3.40.850.10:FF:000017', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(150135, NULL, 'G3DSA:3.40.50.2000:FF:000766', NULL, NULL, 'Glycosyltransferase family 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(150136, NULL, 'G3DSA:3.30.750.24:FF:000076', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(150137, NULL, 'G3DSA:3.20.20.80:FF:000135', NULL, NULL, 'Beta-galactosidase, putative, bgl35A', NULL, NULL, NULL, NULL, NULL, 4),
(150138, NULL, 'G3DSA:1.10.10.570:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150139, NULL, 'G3DSA:3.40.800.10:FF:000014', NULL, NULL, 'Arginase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(150140, NULL, 'G3DSA:2.130.10.10:FF:003410', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(150141, NULL, 'G3DSA:1.10.1410.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150142, NULL, 'G3DSA:3.40.50.20:FF:000006', NULL, NULL, 'Phosphoribosylamine--glycine ligase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(150143, NULL, 'G3DSA:3.40.220.10:FF:000020', NULL, NULL, 'Transcription factor bHLH140', NULL, NULL, NULL, NULL, NULL, 4),
(150144, NULL, 'G3DSA:2.60.40.10:FF:005231', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150145, NULL, 'G3DSA:3.10.105.10:FF:000012', NULL, NULL, 'Peptide/nickel transport system substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(150146, NULL, 'G3DSA:1.10.10.1020:FF:000002', NULL, NULL, 'RecBCD enzyme subunit RecD', NULL, NULL, NULL, NULL, NULL, 4),
(150147, NULL, 'G3DSA:3.40.1580.10:FF:000001', NULL, NULL, 'Similar to 1,3-beta-glucan biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(150148, NULL, 'G3DSA:3.10.330.10:FF:000029', NULL, NULL, 'Cell division control protein 48 homolog D', NULL, NULL, NULL, NULL, NULL, 4),
(150149, NULL, 'G3DSA:1.20.1050.10:FF:000181', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(150150, NULL, 'G3DSA:1.10.238.10:FF:000659', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150151, NULL, 'G3DSA:3.40.50.620:FF:000224', NULL, NULL, 'Leucine--tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150152, NULL, 'G3DSA:3.40.630.30:FF:000664', NULL, NULL, 'Elongator complex protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(150153, NULL, 'G3DSA:2.60.120.20:FF:000009', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(150154, NULL, 'G3DSA:3.40.50.720:FF:000372', NULL, NULL, 'Mycocerosic acid synthase-like polyketide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(150155, NULL, 'G3DSA:2.40.30.10:FF:000425', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150156, NULL, 'G3DSA:3.30.450.20:FF:000262', NULL, NULL, 'Methyl-accepting chemotaxis sensory transducer', NULL, NULL, NULL, NULL, NULL, 4),
(150157, NULL, 'G3DSA:3.10.450.100:FF:000002', NULL, NULL, 'Penicillin-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(150158, NULL, 'G3DSA:3.50.50.60:FF:000681', NULL, NULL, '2-octaprenyl-6-methoxyphenyl hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(150159, NULL, 'G3DSA:3.30.40.10:FF:000172', NULL, NULL, 'E3 ubiquitin-protein ligase RAD18', NULL, NULL, NULL, NULL, NULL, 4),
(150160, NULL, 'G3DSA:2.60.120.260:FF:000246', NULL, NULL, 'Cytosolic endo-beta-N-acetylglucosaminidase 1 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(150161, NULL, 'G3DSA:3.60.40.10:FF:000193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150162, NULL, 'G3DSA:2.30.30.40:FF:000581', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150163, NULL, 'G3DSA:3.30.200.160:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(150164, NULL, 'G3DSA:1.25.40.420:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150165, NULL, 'G3DSA:3.60.40.10:FF:000305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150166, NULL, 'G3DSA:3.40.50.10190:FF:000322', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150167, NULL, 'G3DSA:1.20.120.350:FF:000069', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(150168, NULL, 'G3DSA:3.40.50.200:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150169, NULL, 'G3DSA:3.30.830.10:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150170, NULL, 'G3DSA:2.40.20.10:FF:000099', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150171, NULL, 'G3DSA:3.40.50.1580:FF:000016', NULL, NULL, 'Nucleoside phosphorylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150172, NULL, 'G3DSA:2.60.40.10:FF:003045', NULL, NULL, 'Poliovirus receptor', NULL, NULL, NULL, NULL, NULL, 4),
(150173, NULL, 'G3DSA:3.40.50.720:FF:001653', NULL, NULL, 'NAD-dependent epimerase/dehydratase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(150174, NULL, 'G3DSA:2.10.50.10:FF:000170', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150175, NULL, 'G3DSA:1.20.1070.10:FF:001761', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150176, NULL, 'G3DSA:2.60.40.60:FF:000934', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150177, NULL, 'G3DSA:3.40.50.880:FF:000015', NULL, NULL, 'Protein DJ-1 homolog C', NULL, NULL, NULL, NULL, NULL, 4),
(150178, NULL, 'G3DSA:3.70.10.10:FF:000016', NULL, NULL, 'Checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(150179, NULL, 'G3DSA:3.80.10.10:FF:003961', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150180, NULL, 'G3DSA:3.40.50.300:FF:006934', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150181, NULL, 'G3DSA:2.110.10.10:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150182, NULL, 'G3DSA:4.10.640.10:FF:000009', NULL, NULL, 'Ribosomal protein S18', NULL, NULL, NULL, NULL, NULL, 4),
(150183, NULL, 'G3DSA:2.60.40.10:FF:005815', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150184, NULL, 'G3DSA:3.60.120.10:FF:000025', NULL, NULL, 'Isochorismate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(150185, NULL, 'G3DSA:2.20.70.10:FF:000120', NULL, NULL, 'mRNA cap guanine-N7 methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(150186, NULL, 'G3DSA:2.20.25.240:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150187, NULL, 'G3DSA:3.10.20.770:FF:000005', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(150188, NULL, 'G3DSA:1.25.40.10:FF:000683', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g49170, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(150189, NULL, 'G3DSA:3.90.70.10:FF:000098', NULL, NULL, 'Calpain, putative (Pcalp)', NULL, NULL, NULL, NULL, NULL, 4),
(150190, NULL, 'G3DSA:1.20.5.4010:FF:000003', NULL, NULL, 'protein quaking-B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(150191, NULL, 'G3DSA:3.30.160.60:FF:003702', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150192, NULL, 'G3DSA:3.10.20.90:FF:000633', NULL, NULL, 'Ubiquitin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(150193, NULL, 'G3DSA:1.20.1270.60:FF:000066', NULL, NULL, 'Metastasis suppressor protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(150194, NULL, 'G3DSA:1.20.58.60:FF:000119', NULL, NULL, 'nesprin-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(150195, NULL, 'G3DSA:3.40.50.300:FF:008115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150196, NULL, 'G3DSA:3.30.160.60:FF:005091', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150197, NULL, 'G3DSA:3.40.50.2000:FF:000974', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(150198, NULL, 'G3DSA:3.10.100.10:FF:000428', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150199, NULL, 'G3DSA:3.40.190.10:FF:000489', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(150200, NULL, 'G3DSA:3.30.70.330:FF:000407', NULL, NULL, 'Fusilli, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(150201, NULL, 'G3DSA:2.40.10.10:FF:000273', NULL, NULL, 'Serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(150202, NULL, 'G3DSA:3.40.850.10:FF:000489', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(150203, NULL, 'G3DSA:3.40.50.410:FF:000251', NULL, NULL, 'Cutl-23', NULL, NULL, NULL, NULL, NULL, 4),
(150204, NULL, 'G3DSA:3.80.10.10:FF:002680', NULL, NULL, 'Leucine-rich repeat transmembrane protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(150205, NULL, 'G3DSA:3.30.420.10:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150206, NULL, 'G3DSA:2.30.30.180:FF:000010', NULL, NULL, 'Ribosome maturation factor RimP', NULL, NULL, NULL, NULL, NULL, 4),
(150207, NULL, 'G3DSA:3.30.70.940:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150208, NULL, 'G3DSA:3.20.20.80:FF:000282', NULL, NULL, 'Alpha-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(150209, NULL, 'G3DSA:2.30.29.30:FF:000058', NULL, NULL, 'focal adhesion kinase 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(150210, NULL, 'G3DSA:3.30.70.260:FF:000010', NULL, NULL, 'GTP pyrophosphokinase RelA', NULL, NULL, NULL, NULL, NULL, 4),
(150211, NULL, 'G3DSA:3.30.2410.10:FF:000031', NULL, NULL, 'Hectd1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(150212, NULL, 'G3DSA:2.40.50.140:FF:000685', NULL, NULL, 'rRNA biogenesis protein RRP5', NULL, NULL, NULL, NULL, NULL, 4),
(150213, NULL, 'G3DSA:3.30.1330.40:FF:000011', NULL, NULL, 'Translation initiation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(150214, NULL, 'G3DSA:2.40.50.140:FF:000213', NULL, NULL, 'Ribonuclease R', NULL, NULL, NULL, NULL, NULL, 4),
(150215, NULL, 'G3DSA:2.170.270.10:FF:000193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150216, NULL, 'G3DSA:2.60.220.50:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150217, NULL, 'G3DSA:2.40.70.10:FF:000490', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150218, NULL, 'G3DSA:1.10.1600.10:FF:000006', NULL, NULL, 'ATP-dependent DNA helicase 2 subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(150219, NULL, 'G3DSA:3.40.50.300:FF:004164', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150220, NULL, 'G3DSA:1.20.1560.10:FF:000500', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150221, NULL, 'G3DSA:1.20.58.1610:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150222, NULL, 'G3DSA:1.10.357.10:FF:000059', NULL, NULL, 'Transcriptional regulator, TetR family', NULL, NULL, NULL, NULL, NULL, 4),
(150223, NULL, 'G3DSA:1.20.1250.20:FF:000547', NULL, NULL, 'Folate transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(150224, NULL, 'G3DSA:1.25.40.10:FF:004634', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(150225, NULL, 'G3DSA:3.40.50.720:FF:001709', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(150226, NULL, 'G3DSA:3.90.70.10:FF:000362', NULL, NULL, 'Os12g0148301 protein', NULL, NULL, NULL, NULL, NULL, 4),
(150227, NULL, 'G3DSA:3.30.160.100:FF:000021', NULL, NULL, 'Ribosome-associated factor Y', NULL, NULL, NULL, NULL, NULL, 4),
(150228, NULL, 'G3DSA:3.40.50.720:FF:002429', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150229, NULL, 'G3DSA:2.60.40.10:FF:000583', NULL, NULL, 'tyrosine-protein kinase receptor Tie-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(150230, NULL, 'G3DSA:3.40.30.10:FF:000822', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150231, NULL, 'G3DSA:1.20.920.30:FF:000035', NULL, NULL, 'Inner dynein arm I1 heavy chain 1-ALPHA', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(150232, NULL, 'G3DSA:3.40.50.300:FF:007598', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150233, NULL, 'G3DSA:3.30.200.20:FF:002137', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150234, NULL, 'G3DSA:3.90.550.10:FF:000511', NULL, NULL, 'Glycosyl transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(150235, NULL, 'G3DSA:1.25.40.10:FF:001200', NULL, NULL, 'Swa2p', NULL, NULL, NULL, NULL, NULL, 4),
(150236, NULL, 'G3DSA:1.20.140.10:FF:000110', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(150237, NULL, 'G3DSA:3.30.530.20:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150238, NULL, 'G3DSA:2.130.10.10:FF:002393', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(150239, NULL, 'G3DSA:1.10.10.60:FF:000696', NULL, NULL, 'Myb-related protein 306', NULL, NULL, NULL, NULL, NULL, 4),
(150240, NULL, 'G3DSA:2.60.40.150:FF:000788', NULL, NULL, 'Regulating synaptic membrane exocytosis 1a', NULL, NULL, NULL, NULL, NULL, 4),
(150241, NULL, 'G3DSA:3.30.160.60:FF:006372', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150242, NULL, 'G3DSA:3.40.190.10:FF:000730', NULL, NULL, 'Glutamate receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150243, NULL, 'G3DSA:3.30.2010.10:FF:000006', NULL, NULL, 'Beta-barrel assembly-enhancing protease', NULL, NULL, NULL, NULL, NULL, 4),
(150244, NULL, 'G3DSA:3.40.50.150:FF:001224', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150245, NULL, 'G3DSA:1.25.40.10:FF:003145', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(150246, NULL, 'G3DSA:3.30.160.60:FF:003966', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150247, NULL, 'G3DSA:3.90.25.10:FF:000055', NULL, NULL, 'NmrA-like family protein', NULL, NULL, NULL, NULL, NULL, 4),
(150248, NULL, 'G3DSA:2.30.180.10:FF:000084', NULL, NULL, 'Uncharacterized protein CaJ7.0034', NULL, NULL, NULL, NULL, NULL, 4),
(150249, NULL, 'G3DSA:3.30.70.920:FF:000022', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(150250, NULL, 'G3DSA:3.40.50.300:FF:008379', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150251, NULL, 'G3DSA:3.80.10.10:FF:001191', NULL, NULL, 'Receptor protein-tyrosine kinase CEPR2', NULL, NULL, NULL, NULL, NULL, 4),
(150252, NULL, 'G3DSA:3.40.50.1100:FF:000007', NULL, NULL, 'L-threonine dehydratase catabolic TdcB', NULL, NULL, NULL, NULL, NULL, 4),
(150253, NULL, 'G3DSA:3.40.50.1000:FF:000275', NULL, NULL, 'Unplaced genomic scaffold supercont1.16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(150254, NULL, 'G3DSA:3.40.50.300:FF:005653', NULL, NULL, 'Type III restriction enzyme, res subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(150255, NULL, 'G3DSA:3.30.505.10:FF:000162', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150256, NULL, 'G3DSA:1.10.540.10:FF:000087', NULL, NULL, 'Acyl-CoA dehydrogenase, short-chain specific', NULL, NULL, NULL, NULL, NULL, 4),
(150257, NULL, 'G3DSA:3.30.450.20:FF:000115', NULL, NULL, 'potassium voltage-gated channel subfamily H member 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(150258, NULL, 'G3DSA:1.25.40.10:FF:000739', NULL, NULL, 'Testis expressed 11', NULL, NULL, NULL, NULL, NULL, 4),
(150259, NULL, 'G3DSA:3.90.1150.10:FF:000396', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150260, NULL, 'G3DSA:3.40.50.300:FF:005389', NULL, NULL, 'Replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(150261, NULL, 'G3DSA:1.10.510.10:FF:003373', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150262, NULL, 'G3DSA:1.10.418.10:FF:000140', NULL, NULL, 'Dystonin', NULL, NULL, NULL, NULL, NULL, 4),
(150263, NULL, 'G3DSA:3.30.110.30:FF:000014', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(150264, NULL, 'G3DSA:1.10.510.10:FF:002445', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150265, NULL, 'G3DSA:3.40.50.12780:FF:000239', NULL, NULL, 'Uncharacterized protein C162.02c', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(150266, NULL, 'G3DSA:3.40.50.620:FF:000488', NULL, NULL, 'Valine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(150267, NULL, 'G3DSA:3.40.630.30:FF:000400', NULL, NULL, 'RNA cytidine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(150268, NULL, 'G3DSA:3.30.200.20:FF:002401', NULL, NULL, '3-phosphoinositide-dependent protein kinase B', NULL, NULL, NULL, NULL, NULL, 4),
(150269, NULL, 'G3DSA:1.50.40.10:FF:000439', NULL, NULL, 'Mitochondrial substrate carrier family protein', NULL, NULL, NULL, NULL, NULL, 4),
(150270, NULL, 'G3DSA:1.25.10.10:FF:001108', NULL, NULL, 'Chromosome 12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(150271, NULL, 'G3DSA:3.30.450.190:FF:000024', NULL, NULL, 'Rag-type gtp-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(150272, NULL, 'G3DSA:3.40.640.10:FF:000479', NULL, NULL, 'Ornithine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(150273, NULL, 'G3DSA:3.60.10.10:FF:000365', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150274, NULL, 'G3DSA:1.10.10.1580:FF:000001', NULL, NULL, 'interferon regulatory factor 2-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(150275, NULL, 'G3DSA:1.20.1070.10:FF:000856', NULL, NULL, 'KISS1 receptor b', NULL, NULL, NULL, NULL, NULL, 4),
(150276, NULL, 'G3DSA:1.10.10.10:FF:002120', NULL, NULL, 'Transcriptional regulator AsnC family', NULL, NULL, NULL, NULL, NULL, 4),
(150277, NULL, 'G3DSA:2.30.30.40:FF:000429', NULL, NULL, 'Purine-binding chemotaxis protein (CheW)', NULL, NULL, NULL, NULL, NULL, 4),
(150278, NULL, 'G3DSA:3.30.160.60:FF:001196', NULL, NULL, 'Zinc finger protein 770', NULL, NULL, NULL, NULL, NULL, 4),
(150279, NULL, 'G3DSA:4.10.410.20:FF:000001', NULL, NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(150280, NULL, 'G3DSA:3.10.310.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150281, NULL, 'G3DSA:3.10.260.10:FF:000001', NULL, NULL, 'APSES transcription factor (MbpA)', NULL, NULL, NULL, NULL, NULL, 4),
(150282, NULL, 'G3DSA:3.40.350.10:FF:000024', NULL, NULL, 'YFR006W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(150283, NULL, 'G3DSA:1.10.555.10:FF:000109', NULL, NULL, 'Rho GTPase-activating protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(150284, NULL, 'G3DSA:1.10.150.50:FF:000029', NULL, NULL, 'Ephrin type-A receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(150285, NULL, 'G3DSA:1.10.287.130:FF:000045', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(150286, NULL, 'G3DSA:1.20.140.40:FF:000029', NULL, NULL, 'Os03g0830800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(150287, NULL, 'G3DSA:3.90.1030.10:FF:000010', NULL, NULL, 'Mrpl8p', NULL, NULL, NULL, NULL, NULL, 4),
(150288, NULL, 'G3DSA:1.25.10.10:FF:003317', NULL, NULL, 'Probable ubiquitin fusion degradation protein C12B10.01c', NULL, NULL, NULL, NULL, NULL, 4),
(150289, NULL, 'G3DSA:1.20.1250.20:FF:001328', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(150290, NULL, 'G3DSA:3.30.160.60:FF:000268', NULL, NULL, 'zinc finger protein 484 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(150291, NULL, 'G3DSA:3.30.360.20:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150292, NULL, 'G3DSA:3.30.70.1440:FF:000005', NULL, NULL, 'Cation efflux system protein CusA', NULL, NULL, NULL, NULL, NULL, 4),
(150293, NULL, 'G3DSA:1.10.510.10:FF:001164', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150294, NULL, 'G3DSA:3.30.160.20:FF:000104', NULL, NULL, 'GD20369', NULL, NULL, NULL, NULL, NULL, 4),
(150295, NULL, 'G3DSA:6.10.250.3450:FF:000001', NULL, NULL, '60S ribosomal protein L35', NULL, NULL, NULL, NULL, NULL, 4),
(150296, NULL, 'G3DSA:3.10.20.80:FF:000012', NULL, NULL, 'AGAP012309-PA', NULL, NULL, NULL, NULL, NULL, 4),
(150297, NULL, 'G3DSA:2.120.10.30:FF:000595', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150298, NULL, 'G3DSA:2.10.25.10:FF:000538', NULL, NULL, 'netrin-G1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(150299, NULL, 'G3DSA:2.60.40.420:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150300, NULL, 'G3DSA:3.30.420.40:FF:000945', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150301, NULL, 'G3DSA:2.120.10.30:FF:000331', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150302, NULL, 'G3DSA:1.20.58.760:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150303, NULL, 'G3DSA:1.25.40.20:FF:001557', NULL, NULL, 'Ankyrin repeat domain 6', NULL, NULL, NULL, NULL, NULL, 4),
(150304, NULL, 'G3DSA:2.60.40.10:FF:001600', NULL, NULL, 'Neuromusculin, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(150305, NULL, 'G3DSA:3.90.550.10:FF:000247', NULL, NULL, 'Gamma subunit', NULL, NULL, NULL, NULL, NULL, 4),
(150306, NULL, 'G3DSA:1.10.630.10:FF:000414', NULL, NULL, 'Cholesterol side-chain cleavage enzyme, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(150307, NULL, 'G3DSA:1.25.10.10:FF:002800', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150308, NULL, 'G3DSA:1.20.1250.20:FF:000811', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150309, NULL, 'G3DSA:3.90.1110.10:FF:000011', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(150310, NULL, 'G3DSA:3.30.1120.10:FF:000014', NULL, NULL, 'Arylsulfatase family member H', NULL, NULL, NULL, NULL, NULL, 4),
(150311, NULL, 'G3DSA:1.20.1730.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150312, NULL, 'G3DSA:1.10.10.10:FF:000883', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(150313, NULL, 'G3DSA:1.10.287.90:FF:000004', NULL, NULL, 'Cytochrome c oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(150314, NULL, 'G3DSA:3.50.50.60:FF:000534', NULL, NULL, 'FAD/NAD(P)-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(150315, NULL, 'G3DSA:2.170.300.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150316, NULL, 'G3DSA:3.30.710.10:FF:000324', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150317, NULL, 'G3DSA:1.20.5.110:FF:000173', NULL, NULL, 'Putative syntaxin', NULL, NULL, NULL, NULL, NULL, 4),
(150318, NULL, 'G3DSA:3.40.50.1820:FF:001358', NULL, NULL, 'Protein bem46', NULL, NULL, NULL, NULL, NULL, 4),
(150319, NULL, 'G3DSA:3.40.47.10:FF:000214', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150320, NULL, 'G3DSA:1.20.5.650:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150321, NULL, 'G3DSA:3.40.250.10:FF:000168', NULL, NULL, 'Sulphate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(150322, NULL, 'G3DSA:3.30.160.60:FF:000829', NULL, NULL, 'zinc finger protein 510', NULL, NULL, NULL, NULL, NULL, 4),
(150323, NULL, 'G3DSA:2.130.10.10:FF:001201', NULL, NULL, 'UTP7p Nucleolar protein', NULL, NULL, NULL, NULL, NULL, 4),
(150324, NULL, 'G3DSA:3.40.630.10:FF:000506', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150325, NULL, 'G3DSA:3.30.1370.10:FF:000122', NULL, NULL, 'Scp160p', NULL, NULL, NULL, NULL, NULL, 4),
(150326, NULL, 'G3DSA:1.20.1420.10:FF:000018', NULL, NULL, 'Talin', NULL, NULL, NULL, NULL, NULL, 4),
(150327, NULL, 'G3DSA:2.170.140.10:FF:000037', NULL, NULL, 'RE16222p', NULL, NULL, NULL, NULL, NULL, 4),
(150328, NULL, 'G3DSA:3.30.40.10:FF:000025', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(150329, NULL, 'G3DSA:2.60.120.200:FF:000543', NULL, NULL, 'L-type lectin-domain containing receptor kinase IX.1', NULL, NULL, NULL, NULL, NULL, 4),
(150330, NULL, 'G3DSA:1.10.150.530:FF:000025', NULL, NULL, 'Radical SAM superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(150331, NULL, 'G3DSA:2.60.40.10:FF:002117', NULL, NULL, 'Twitchin', NULL, NULL, NULL, NULL, NULL, 4),
(150332, NULL, 'G3DSA:1.20.120.1750:FF:000142', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(150333, NULL, 'G3DSA:3.10.390.10:FF:000005', NULL, NULL, 'SP140 nuclear body protein', NULL, NULL, NULL, NULL, NULL, 4),
(150334, NULL, 'G3DSA:1.20.58.60:FF:000266', NULL, NULL, 'Muscle-specific protein 300 kDa, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(150335, NULL, 'G3DSA:1.25.10.10:FF:000855', NULL, NULL, 'Coatomer subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(150336, NULL, 'G3DSA:2.60.40.10:FF:004326', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150337, NULL, 'G3DSA:3.40.50.2300:FF:000474', NULL, NULL, 'Vomeronasal 2, receptor 82', NULL, NULL, NULL, NULL, NULL, 4),
(150338, NULL, 'G3DSA:1.20.1250.20:FF:001475', NULL, NULL, 'Uncharacterized protein, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(150339, NULL, 'G3DSA:3.20.20.190:FF:000054', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(150340, NULL, 'G3DSA:2.40.50.140:FF:001141', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150341, NULL, 'G3DSA:1.10.238.10:FF:001059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150342, NULL, 'G3DSA:3.40.50.1820:FF:000841', NULL, NULL, 'Palmitoyl-protein thioesterase-dolichyl pyrophosphate phosphatase fusion 1', NULL, NULL, NULL, NULL, NULL, 4),
(150343, NULL, 'G3DSA:3.30.1600.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150344, NULL, 'G3DSA:3.90.870.10:FF:000030', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150345, NULL, 'G3DSA:3.30.230.10:FF:000214', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(150346, NULL, 'G3DSA:3.20.10.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150347, NULL, 'G3DSA:3.30.540.10:FF:000024', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(150348, NULL, 'G3DSA:3.40.1090.10:FF:000042', NULL, NULL, 'Patatin-like phospholipase domain-containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(150349, NULL, 'G3DSA:1.10.510.10:FF:002653', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150350, NULL, 'G3DSA:2.60.40.1170:FF:000007', NULL, NULL, 'Coatomer subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(150351, NULL, 'G3DSA:1.10.580.10:FF:000033', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(150352, NULL, 'G3DSA:3.40.50.12780:FF:000211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150353, NULL, 'G3DSA:2.40.10.10:FF:000542', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150354, NULL, 'G3DSA:1.10.10.10:FF:000175', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(150355, NULL, 'G3DSA:2.60.120.330:FF:000031', NULL, NULL, '2-oxoglutarate (2OG) and Fe(II)-dependent oxygenase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(150356, NULL, 'G3DSA:2.10.25.10:FF:001319', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150357, NULL, 'G3DSA:3.40.50.12780:FF:000155', NULL, NULL, 'AMP-binding enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150358, NULL, 'G3DSA:1.20.1070.10:FF:000356', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150359, NULL, 'G3DSA:3.60.10.10:FF:000101', NULL, NULL, 'Endonuclease/exonuclease/phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(150360, NULL, 'G3DSA:1.25.40.10:FF:004657', NULL, NULL, 'Enhanced entry protein enhC, tetratricopeptide repeat family', NULL, NULL, NULL, NULL, NULL, 4),
(150361, NULL, 'G3DSA:3.20.20.80:FF:000551', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(150362, NULL, 'G3DSA:3.40.50.720:FF:002581', NULL, NULL, 'ThiF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(150363, NULL, 'G3DSA:3.30.230.10:FF:000158', NULL, NULL, 'Galactokinase', NULL, NULL, NULL, NULL, NULL, 4),
(150364, NULL, 'G3DSA:3.40.50.1820:FF:000341', NULL, NULL, 'Lipase/serine esterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150365, NULL, 'G3DSA:2.60.40.10:FF:001072', NULL, NULL, 'Immunoglobulin heavy variable V1-24', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(150366, NULL, 'G3DSA:1.10.418.10:FF:000224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150367, NULL, 'G3DSA:3.90.850.10:FF:000023', NULL, NULL, 'Possible bifunctional enzyme: 2-hydroxyhepta-2,4-diene-1,7-dioate isomerase + cyclase/dehydrase', NULL, NULL, NULL, NULL, NULL, 4),
(150368, NULL, 'G3DSA:1.10.418.10:FF:000168', NULL, NULL, 'Guanine exchange factor for Rac 30', NULL, NULL, NULL, NULL, NULL, 4),
(150369, NULL, 'G3DSA:1.10.10.60:FF:000201', NULL, NULL, 'MYB proto-oncogene like 2', NULL, NULL, NULL, NULL, NULL, 4),
(150370, NULL, 'G3DSA:1.25.10.10:FF:003048', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(150371, NULL, 'G3DSA:3.10.490.10:FF:000041', NULL, NULL, 'AIG2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(150372, NULL, 'G3DSA:1.10.1070.11:FF:000079', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(150373, NULL, 'G3DSA:1.10.286.20:FF:000009', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(150374, NULL, 'G3DSA:3.30.1060.10:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150375, NULL, 'G3DSA:3.90.640.10:FF:000254', NULL, NULL, 'Actin-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(150376, NULL, 'G3DSA:1.10.3450.40:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150377, NULL, 'G3DSA:2.130.10.10:FF:004922', NULL, NULL, 'Pre-rRNA-processing protein crb3/ipi3', NULL, NULL, NULL, NULL, NULL, 4),
(150378, NULL, 'G3DSA:3.10.110.10:FF:000081', NULL, NULL, 'E3 ubiquitin-protein ligase FANCL', NULL, NULL, NULL, NULL, NULL, 4),
(150379, NULL, 'G3DSA:1.10.1740.140:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150380, NULL, 'G3DSA:1.10.238.10:FF:000603', NULL, NULL, 'Calcium-binding protein CP1', NULL, NULL, NULL, NULL, NULL, 4),
(150381, NULL, 'G3DSA:3.40.50.300:FF:007334', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150382, NULL, 'G3DSA:1.10.630.10:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150383, NULL, 'G3DSA:3.40.50.720:FF:002053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150384, NULL, 'G3DSA:3.40.50.1820:FF:000285', NULL, NULL, 'Alpha/beta-Hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(150385, NULL, 'G3DSA:3.30.70.330:FF:000907', NULL, NULL, 'U2 splicing auxiliary factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150386, NULL, 'G3DSA:3.40.50.1360:FF:000006', NULL, NULL, 'Glucitol operon repressor', NULL, NULL, NULL, NULL, NULL, 4),
(150387, NULL, 'G3DSA:1.25.10.10:FF:002536', NULL, NULL, 'Armadillo repeat-containing protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(150388, NULL, 'G3DSA:3.90.190.10:FF:000348', NULL, NULL, 'Dual specificity protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(150389, NULL, 'G3DSA:3.40.50.300:FF:004580', NULL, NULL, 'ATP-dependent 3''-5'' DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(150390, NULL, 'G3DSA:2.40.160.20:FF:000033', NULL, NULL, 'Outer membrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150391, NULL, 'G3DSA:2.40.50.40:FF:000031', NULL, NULL, 'Heterochromatin protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(150392, NULL, 'G3DSA:3.40.630.190:FF:000001', NULL, NULL, 'LytR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(150393, NULL, 'G3DSA:1.10.8.60:FF:000037', NULL, NULL, 'Sigma-54-dependent Fis family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(150394, NULL, 'G3DSA:3.80.10.10:FF:003692', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150395, NULL, 'G3DSA:2.60.40.150:FF:000524', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(150396, NULL, 'G3DSA:1.25.40.20:FF:000332', NULL, NULL, 'Ankyrin repeat family A protein', NULL, NULL, NULL, NULL, NULL, 4),
(150397, NULL, 'G3DSA:3.40.850.10:FF:000461', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150398, NULL, 'G3DSA:2.60.120.10:FF:000416', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(150399, NULL, 'G3DSA:1.10.510.10:FF:002176', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(150400, NULL, 'G3DSA:4.10.240.10:FF:000103', NULL, NULL, 'WGS project CABT00000000 data, contig 2.54', NULL, NULL, NULL, NULL, NULL, 4),
(150401, NULL, 'G3DSA:1.20.5.110:FF:000257', NULL, NULL, 'Syntaxin 2', NULL, NULL, NULL, NULL, NULL, 4),
(150402, NULL, 'G3DSA:1.20.1560.10:FF:000528', NULL, NULL, 'ABC transporter B family member 15', NULL, NULL, NULL, NULL, NULL, 4),
(150403, NULL, 'G3DSA:3.40.50.300:FF:005092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150404, NULL, 'G3DSA:3.40.50.700:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150405, NULL, 'G3DSA:2.60.40.10:FF:005254', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150406, NULL, 'G3DSA:3.30.190.20:FF:000016', NULL, NULL, 'Ribosomal L1 domain-containing 1-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(150407, NULL, 'G3DSA:3.30.1520.10:FF:000062', NULL, NULL, 'Bud emergence protein', NULL, NULL, NULL, NULL, NULL, 4),
(150408, NULL, 'G3DSA:3.30.160.60:FF:002769', NULL, NULL, 'GM23757', NULL, NULL, NULL, NULL, NULL, 4),
(150409, NULL, 'G3DSA:1.10.510.10:FF:001664', NULL, NULL, 'CAMK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(150410, NULL, 'G3DSA:2.120.10.30:FF:000415', NULL, NULL, 'Low density lipoprotein receptor-related protein 1Aa', NULL, NULL, NULL, NULL, NULL, 4),
(150411, NULL, 'G3DSA:3.30.40.10:FF:001537', NULL, NULL, 'RING-finger domain protein, putative (AFU_orthologue AFUA_5G14845)', NULL, NULL, NULL, NULL, NULL, 4),
(150412, NULL, 'G3DSA:3.40.50.720:FF:001097', NULL, NULL, 'NADH dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(150413, NULL, 'G3DSA:1.20.1250.20:FF:001559', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(150414, NULL, 'G3DSA:2.120.10.30:FF:000359', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150415, NULL, 'G3DSA:3.30.450.40:FF:000273', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(150416, NULL, 'G3DSA:3.30.450.20:FF:000531', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150417, NULL, 'G3DSA:3.30.70.3490:FF:000018', NULL, NULL, 'Unplaced genomic scaffold supercont1.15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(150418, NULL, 'G3DSA:3.30.460.10:FF:000023', NULL, NULL, 'CCA tRNA nucleotidyltransferase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(150419, NULL, 'G3DSA:1.25.40.10:FF:004218', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(150420, NULL, 'G3DSA:1.20.910.10:FF:000023', NULL, NULL, 'TenA family transcriptional activator-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(150421, NULL, 'G3DSA:1.20.1280.150:FF:000001', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(150422, NULL, 'G3DSA:3.40.50.300:FF:006434', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150423, NULL, 'G3DSA:4.10.280.10:FF:000049', NULL, NULL, 'MAX isoform 16', NULL, NULL, NULL, NULL, NULL, 4),
(150424, NULL, 'G3DSA:2.40.50.140:FF:000921', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150425, NULL, 'G3DSA:2.30.29.30:FF:000474', NULL, NULL, 'AGC/RSK/RSKP90 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(150426, NULL, 'G3DSA:3.30.70.1230:FF:000032', NULL, NULL, 'Adenylyl cyclase 78C', NULL, NULL, NULL, NULL, NULL, 4),
(150427, NULL, 'G3DSA:1.10.760.10:FF:000075', NULL, NULL, 'Probable Methylamine utilization protein mauG', NULL, NULL, NULL, NULL, NULL, 4),
(150428, NULL, 'G3DSA:2.30.30.40:FF:000165', NULL, NULL, 'dynamin-binding protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(150429, NULL, 'G3DSA:2.30.29.230:FF:000017', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150430, NULL, 'G3DSA:1.10.287.70:FF:000234', NULL, NULL, 'TWiK family of potassium channels', NULL, NULL, NULL, NULL, NULL, 4),
(150431, NULL, 'G3DSA:2.130.10.10:FF:003141', NULL, NULL, 'Coatomer subunit alpha', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(150432, NULL, 'G3DSA:1.25.40.10:FF:002364', NULL, NULL, 'HCF152', NULL, NULL, NULL, NULL, NULL, 4),
(150433, NULL, 'G3DSA:2.130.10.10:FF:003085', NULL, NULL, 'mRNA export factor', NULL, NULL, NULL, NULL, NULL, 4),
(150434, NULL, 'G3DSA:3.30.420.40:FF:000445', NULL, NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(150435, NULL, 'G3DSA:1.10.630.10:FF:000678', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150436, NULL, 'G3DSA:2.60.40.10:FF:002325', NULL, NULL, 'Semaphorin 4D', NULL, NULL, NULL, NULL, NULL, 4),
(150437, NULL, 'G3DSA:3.90.132.10:FF:000006', NULL, NULL, 'GP63-like', NULL, NULL, NULL, NULL, NULL, 4),
(150438, NULL, 'G3DSA:3.30.920.10:FF:000014', NULL, NULL, 'Frataxin, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(150439, NULL, 'G3DSA:1.10.940.10:FF:000016', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase B', NULL, NULL, NULL, NULL, NULL, 4),
(150440, NULL, 'G3DSA:1.10.455.10:FF:000017', NULL, NULL, '40S ribosomal protein S5', NULL, NULL, NULL, NULL, NULL, 4),
(150441, NULL, 'G3DSA:3.40.50.300:FF:000302', NULL, NULL, 'ATP-binding cassette subfamily B member 5', NULL, NULL, NULL, NULL, NULL, 4),
(150442, NULL, 'G3DSA:3.30.1680.10:FF:000016', NULL, NULL, 'Putative Semaphorin-6B', NULL, NULL, NULL, NULL, NULL, 4),
(150443, NULL, 'G3DSA:3.30.900.10:FF:000007', NULL, NULL, 'Autophagy-related protein 13a', NULL, NULL, NULL, NULL, NULL, 4),
(150444, NULL, 'G3DSA:1.20.1250.60:FF:000003', NULL, NULL, 'Interferon lambda1', NULL, NULL, NULL, NULL, NULL, 4),
(150445, NULL, 'G3DSA:1.20.120.430:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150446, NULL, 'G3DSA:2.120.10.30:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150447, NULL, 'G3DSA:1.10.860.10:FF:000015', NULL, NULL, 'Putative replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(150448, NULL, 'G3DSA:1.20.1310.10:FF:000072', NULL, NULL, 'Cullin-like protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(150449, NULL, 'G3DSA:3.30.40.10:FF:000233', NULL, NULL, 'RING-H2 finger protein ATL54', NULL, NULL, NULL, NULL, NULL, 4),
(150450, NULL, 'G3DSA:1.10.8.1080:FF:000003', NULL, NULL, 'N-acetylmuramic acid 6-phosphate etherase', NULL, NULL, NULL, NULL, NULL, 4),
(150451, NULL, 'G3DSA:3.40.47.10:FF:000006', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase I', NULL, NULL, NULL, NULL, NULL, 4),
(150452, NULL, 'G3DSA:3.90.1480.20:FF:000007', NULL, NULL, 'Type 2 lactosamine alpha-2,3-sialyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(150453, NULL, 'G3DSA:3.40.50.2000:FF:000266', NULL, NULL, 'ALG2, alpha-1,3/1,6-mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(150454, NULL, 'G3DSA:3.30.70.270:FF:000131', NULL, NULL, 'Related to DNA repair protein MUS-42', NULL, NULL, NULL, NULL, NULL, 4),
(150455, NULL, 'G3DSA:3.40.50.300:FF:002539', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(150456, NULL, 'G3DSA:2.60.40.60:FF:001093', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150457, NULL, 'G3DSA:3.40.50.150:FF:001640', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150458, NULL, 'G3DSA:1.10.10.60:FF:001185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150459, NULL, 'G3DSA:1.25.40.10:FF:000003', NULL, NULL, 'kinesin light chain isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(150460, NULL, 'G3DSA:2.130.10.10:FF:001196', NULL, NULL, 'WD repeat protein (AFU_orthologue AFUA_1G12380)', NULL, NULL, NULL, NULL, NULL, 4),
(150461, NULL, 'G3DSA:2.130.10.10:FF:004427', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150462, NULL, 'G3DSA:3.30.200.20:FF:001648', NULL, NULL, 'Protein CBG05171', NULL, NULL, NULL, NULL, NULL, 4),
(150463, NULL, 'G3DSA:3.30.2140.20:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150464, NULL, 'G3DSA:3.30.70.330:FF:001571', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150465, NULL, 'G3DSA:1.10.10.2840:FF:000003', NULL, NULL, 'PucR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(150466, NULL, 'G3DSA:3.40.640.10:FF:000535', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150467, NULL, 'G3DSA:3.40.50.1820:FF:001589', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150468, NULL, 'G3DSA:3.30.470.20:FF:000061', NULL, NULL, 'D-alanine-D-alanine ligase family', NULL, NULL, NULL, NULL, NULL, 4),
(150469, NULL, 'G3DSA:3.40.50.11370:FF:000007', NULL, NULL, 'Inositol-tetrakisphosphate 1-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(150470, NULL, 'G3DSA:2.60.120.10:FF:000040', NULL, NULL, 'rap guanine nucleotide exchange factor 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(150471, NULL, 'G3DSA:2.60.120.200:FF:000127', NULL, NULL, 'Laminin subunit alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(150472, NULL, 'G3DSA:2.60.40.10:FF:005607', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150473, NULL, 'G3DSA:3.40.630.30:FF:000580', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150474, NULL, 'G3DSA:1.20.58.60:FF:000035', NULL, NULL, 'Spectrin alpha chain, non-erythrocytic 1', NULL, NULL, NULL, NULL, NULL, 4),
(150475, NULL, 'G3DSA:3.40.50.300:FF:005445', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150476, NULL, 'G3DSA:1.25.10.10:FF:002272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150477, NULL, 'G3DSA:2.60.40.10:FF:000408', NULL, NULL, 'Fibroblast growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(150478, NULL, 'G3DSA:3.30.160.60:FF:005208', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150479, NULL, 'G3DSA:1.25.40.10:FF:003353', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At3g16890, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(150480, NULL, 'G3DSA:1.25.40.90:FF:000100', NULL, NULL, '50S ribosome-binding GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(150481, NULL, 'G3DSA:3.80.10.10:FF:000763', NULL, NULL, 'cDNA clone:J023048C13, full insert sequence', NULL, NULL, NULL, NULL, NULL, 4),
(150482, NULL, 'G3DSA:2.30.30.100:FF:000177', NULL, NULL, 'Small nuclear ribonucleoprotein E', NULL, NULL, NULL, NULL, NULL, 4),
(150483, NULL, 'G3DSA:3.90.70.10:FF:000654', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150484, NULL, 'G3DSA:3.30.450.20:FF:000054', NULL, NULL, 'Trachealess, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(150485, NULL, 'G3DSA:3.30.70.2760:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150486, NULL, 'G3DSA:2.160.20.10:FF:000026', NULL, NULL, 'Exo-beta-1,3-glucanase Exg0', NULL, NULL, NULL, NULL, NULL, 4),
(150487, NULL, 'G3DSA:2.30.180.10:FF:000112', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150488, NULL, 'G3DSA:3.40.190.290:FF:000093', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(150489, NULL, 'G3DSA:3.90.245.10:FF:000021', NULL, NULL, 'Purine nucleosidase, putative (IunH-2)', NULL, NULL, NULL, NULL, NULL, 4),
(150490, NULL, 'G3DSA:3.80.10.10:FF:001275', NULL, NULL, 'Protein CBG01587', NULL, NULL, NULL, NULL, NULL, 4),
(150491, NULL, 'G3DSA:2.60.40.10:FF:002797', NULL, NULL, 'Interferon gamma receptor 2 (interferon gamma transducer 1), gene 2', NULL, NULL, NULL, NULL, NULL, 4),
(150492, NULL, 'G3DSA:2.30.29.30:FF:000530', NULL, NULL, 'Spermitin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(150493, NULL, 'G3DSA:2.30.22.10:FF:000014', NULL, NULL, 'Protein GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(150494, NULL, 'G3DSA:3.40.50.300:FF:001174', NULL, NULL, 'ABC transporter family protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(150495, NULL, 'G3DSA:2.60.40.10:FF:001336', NULL, NULL, 'V-set pre-B cell surrogate light chain 3', NULL, NULL, NULL, NULL, NULL, 4),
(150496, NULL, 'G3DSA:3.40.50.2300:FF:000558', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150497, NULL, 'G3DSA:3.50.4.10:FF:000032', NULL, NULL, 'NOmpA Homolog (Drosophila nompA: no mechanoreceptor potential A)', NULL, NULL, NULL, NULL, NULL, 4),
(150498, NULL, 'G3DSA:1.10.1900.40:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(150499, NULL, 'G3DSA:3.40.50.300:FF:001235', NULL, NULL, 'ATP binding cassette subfamily A member 7', NULL, NULL, NULL, NULL, NULL, 4),
(150500, NULL, 'G3DSA:3.30.1370.10:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150501, NULL, 'G3DSA:3.40.50.300:FF:000774', NULL, NULL, 'ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(150502, NULL, 'G3DSA:2.70.170.10:FF:000226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150503, NULL, 'G3DSA:2.40.330.10:FF:000004', NULL, NULL, 'B3 domain-containing transcription factor vrn1', NULL, NULL, NULL, NULL, NULL, 4),
(150504, NULL, 'G3DSA:1.20.1280.290:FF:000110', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(150505, NULL, 'G3DSA:3.30.710.10:FF:000296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150506, NULL, 'G3DSA:1.25.40.90:FF:000044', NULL, NULL, 'Putative clathrin assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(150507, NULL, 'G3DSA:1.20.1510.10:FF:000020', NULL, NULL, 'zinc transporter 10', NULL, NULL, NULL, NULL, NULL, 4),
(150508, NULL, 'G3DSA:2.90.10.10:FF:000012', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(150509, NULL, 'G3DSA:1.10.1170.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150510, NULL, 'G3DSA:3.40.50.11350:FF:000001', NULL, NULL, 'Alpha-(1,6)-fucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(150511, NULL, 'G3DSA:2.10.25.10:FF:000010', NULL, NULL, 'Pro-epidermal growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(150512, NULL, 'G3DSA:3.20.20.70:FF:000222', NULL, NULL, 'Raffinose synthase Sip1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(150513, NULL, 'G3DSA:2.40.250.10:FF:000003', NULL, NULL, 'BROther (Drosophila tx factor partner) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(150514, NULL, 'G3DSA:2.30.42.10:FF:000021', NULL, NULL, 'Glutamate receptor interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(150515, NULL, 'G3DSA:1.20.58.60:FF:000530', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150516, NULL, 'G3DSA:3.40.50.300:FF:002163', NULL, NULL, 'Replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(150517, NULL, 'G3DSA:1.50.10.130:FF:000001', NULL, NULL, 'Isoprene synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(150518, NULL, 'G3DSA:1.10.40.30:FF:000014', NULL, NULL, 'Argininosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(150519, NULL, 'G3DSA:2.60.220.50:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150520, NULL, 'G3DSA:3.30.1360.10:FF:000032', NULL, NULL, 'DNA-directed RNA polymerase II subunit RPB11', NULL, NULL, NULL, NULL, NULL, 4),
(150521, NULL, 'G3DSA:3.50.50.60:FF:000618', NULL, NULL, 'FAD/NAD(P)-binding oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(150522, NULL, 'G3DSA:3.40.50.10490:FF:000030', NULL, NULL, '30S ribosomal protein S2', NULL, NULL, NULL, NULL, NULL, 4),
(150523, NULL, 'G3DSA:2.60.200.10:FF:000041', NULL, NULL, 'BMP signal transducer Smad1', NULL, NULL, NULL, NULL, NULL, 4),
(150524, NULL, 'G3DSA:1.20.1250.20:FF:001183', NULL, NULL, 'Xyloside transporter XynT', NULL, NULL, NULL, NULL, NULL, 4),
(150525, NULL, 'G3DSA:2.40.30.10:FF:000448', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150526, NULL, 'G3DSA:3.30.200.20:FF:001704', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150527, NULL, 'G3DSA:2.20.28.120:FF:000008', NULL, NULL, 'Apicoplast ribosomal protein L33', NULL, NULL, NULL, NULL, NULL, 4),
(150528, NULL, 'G3DSA:4.10.520.10:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150529, NULL, 'G3DSA:3.80.10.10:FF:004506', NULL, NULL, 'Putative inactive leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(150530, NULL, 'G3DSA:2.40.30.10:FF:000072', NULL, NULL, 'translation initiation factor IF-2, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(150531, NULL, 'G3DSA:3.50.50.60:FF:001254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(150532, NULL, 'G3DSA:3.30.565.10:FF:000199', NULL, NULL, 'Signal transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(150533, NULL, 'G3DSA:2.130.10.10:FF:002505', NULL, NULL, 'Nucleoporin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150534, NULL, 'G3DSA:1.25.40.10:FF:002892', NULL, NULL, 'Leucine-rich PPR motif-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(150535, NULL, 'G3DSA:3.20.20.80:FF:000074', NULL, NULL, 'Hydrolase, hydrolyzing O-glycosyl compounds', NULL, NULL, NULL, NULL, NULL, 4),
(150536, NULL, 'G3DSA:3.30.1330.20:FF:000033', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(150537, NULL, 'G3DSA:1.25.40.10:FF:001728', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(150538, NULL, 'G3DSA:2.40.30.170:FF:000072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150539, NULL, 'G3DSA:3.30.420.40:FF:001081', NULL, NULL, 'Pantothenate kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(150540, NULL, 'G3DSA:3.30.1360.170:FF:000018', NULL, NULL, 'Flavin-dependent thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(150541, NULL, 'G3DSA:3.40.50.1440:FF:000148', NULL, NULL, 'Phage tubulin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(150542, NULL, 'G3DSA:3.40.50.300:FF:007070', NULL, NULL, 'Putative arsenical pump-driving ATPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(150543, NULL, 'G3DSA:3.90.180.10:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150544, NULL, 'G3DSA:1.10.10.10:FF:001428', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150545, NULL, 'G3DSA:2.40.50.90:FF:000052', NULL, NULL, 'Nuclease domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(150546, NULL, 'G3DSA:3.90.79.10:FF:000235', NULL, NULL, 'ADP-ribose pyrophosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150547, NULL, 'G3DSA:1.10.400.10:FF:000077', NULL, NULL, 'G-protein alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150548, NULL, 'G3DSA:1.10.10.10:FF:000939', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(150549, NULL, 'G3DSA:2.60.40.10:FF:000936', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(150550, NULL, 'G3DSA:2.30.30.100:FF:000121', NULL, NULL, 'Small nuclear ribonucleoprotein F', NULL, NULL, NULL, NULL, NULL, 4),
(150551, NULL, 'G3DSA:3.40.50.2300:FF:000182', NULL, NULL, 'RNA polymerase II subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(150552, NULL, 'G3DSA:3.40.50.720:FF:001889', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(150553, NULL, 'G3DSA:3.30.980.10:FF:000023', NULL, NULL, 'Threonyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(150554, NULL, 'G3DSA:3.40.50.1450:FF:000005', NULL, NULL, 'Hydrogenase maturation protease HycI', NULL, NULL, NULL, NULL, NULL, 4),
(150555, NULL, 'G3DSA:2.130.10.10:FF:004866', NULL, NULL, 'Ribosome biogenesis protein BOP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(150556, NULL, 'G3DSA:3.40.50.150:FF:001201', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150557, NULL, 'G3DSA:1.25.40.20:FF:001265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150558, NULL, 'G3DSA:1.10.10.60:FF:000673', NULL, NULL, 'Two-component system sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(150559, NULL, 'G3DSA:2.130.10.10:FF:000684', NULL, NULL, 'PRA1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(150560, NULL, 'G3DSA:1.20.1740.10:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150561, NULL, 'G3DSA:3.40.50.300:FF:004956', NULL, NULL, 'Multidrug resistance protein homolog, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150562, NULL, 'G3DSA:2.10.110.10:FF:000028', NULL, NULL, 'LIM domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(150563, NULL, 'G3DSA:2.40.10.10:FF:000065', NULL, NULL, 'Urokinase-type plasminogen activator', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(150564, NULL, 'G3DSA:2.40.50.140:FF:000449', NULL, NULL, 'Unplaced genomic scaffold supercont1.202, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(150565, NULL, 'G3DSA:2.20.28.10:FF:000022', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(150566, NULL, 'G3DSA:3.40.50.2300:FF:001194', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150567, NULL, 'G3DSA:3.60.90.10:FF:000016', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(150568, NULL, 'G3DSA:2.30.29.30:FF:000035', NULL, NULL, 'Disabled homolog 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(150569, NULL, 'G3DSA:1.10.600.10:FF:000058', NULL, NULL, 'Protein CBG02872', NULL, NULL, NULL, NULL, NULL, 4),
(150570, NULL, 'G3DSA:2.70.40.10:FF:000003', NULL, NULL, 'dCTP deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(150571, NULL, 'G3DSA:2.60.40.1260:FF:000006', NULL, NULL, 'Lamin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(150572, NULL, 'G3DSA:2.60.40.1150:FF:000001', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(150573, NULL, 'G3DSA:2.60.40.2860:FF:000025', NULL, NULL, 'Transmission-blocking target antigen Pfs230', NULL, NULL, NULL, NULL, NULL, 4),
(150574, NULL, 'G3DSA:1.20.5.110:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150575, NULL, 'G3DSA:3.30.780.10:FF:000042', NULL, NULL, 'Protein translation factor SUI1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(150576, NULL, 'G3DSA:3.40.30.10:FF:000322', NULL, NULL, 'Probable glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(150577, NULL, 'G3DSA:3.40.50.1390:FF:000021', NULL, NULL, 'Integrase', NULL, NULL, NULL, NULL, NULL, 4),
(150578, NULL, 'G3DSA:1.10.10.10:FF:002092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150579, NULL, 'G3DSA:2.60.40.10:FF:004742', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150580, NULL, 'G3DSA:3.40.50.200:FF:000042', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(150581, NULL, 'G3DSA:3.30.160.60:FF:001521', NULL, NULL, 'zinc finger protein 90 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(150582, NULL, 'G3DSA:2.170.120.20:FF:000011', NULL, NULL, 'Ribosomal protein L25, Ctc-form', NULL, NULL, NULL, NULL, NULL, 4),
(150583, NULL, 'G3DSA:3.90.226.10:FF:000005', NULL, NULL, 'Acetyl-CoA carboxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(150584, NULL, 'G3DSA:3.50.40.10:FF:000007', NULL, NULL, 'YALI0E22979p', NULL, NULL, NULL, NULL, NULL, 4),
(150585, NULL, 'G3DSA:2.20.70.10:FF:000209', NULL, NULL, 'WW domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150586, NULL, 'G3DSA:2.30.230.10:FF:000021', NULL, NULL, 'AGAP002032-PA', NULL, NULL, NULL, NULL, NULL, 4),
(150587, NULL, 'G3DSA:1.10.600.10:FF:000002', NULL, NULL, 'Octaprenyl diphosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(150588, NULL, 'G3DSA:3.30.160.60:FF:004394', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150589, NULL, 'G3DSA:2.60.40.60:FF:001098', NULL, NULL, 'Cadherin 22', NULL, NULL, NULL, NULL, NULL, 4),
(150590, NULL, 'G3DSA:3.40.30.10:FF:001278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150591, NULL, 'G3DSA:3.40.50.150:FF:000712', NULL, NULL, 'Phosphoethanolamine MethylTransferase', NULL, NULL, NULL, NULL, NULL, 4),
(150592, NULL, 'G3DSA:1.25.40.10:FF:003729', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g62370', NULL, NULL, NULL, NULL, NULL, 4),
(150593, NULL, 'G3DSA:1.10.1370.10:FF:000027', NULL, NULL, 'Thimet oligopeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(150594, NULL, 'G3DSA:3.10.20.90:FF:000925', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150595, NULL, 'G3DSA:2.10.110.10:FF:000180', NULL, NULL, 'GM16078', NULL, NULL, NULL, NULL, NULL, 4),
(150596, NULL, 'G3DSA:3.90.470.10:FF:000010', NULL, NULL, '60S ribosomal protein L17', NULL, NULL, NULL, NULL, NULL, 4),
(150597, NULL, 'G3DSA:3.30.160.60:FF:003882', NULL, NULL, 'GD15780', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(150598, NULL, 'G3DSA:3.30.420.140:FF:000014', NULL, NULL, 'Putative pre-16S rRNA nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(150599, NULL, 'G3DSA:2.10.25.10:FF:001443', NULL, NULL, 'Laminin subunit alpha-1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(150600, NULL, 'G3DSA:3.10.20.90:FF:000869', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150601, NULL, 'G3DSA:3.30.2090.10:FF:000022', NULL, NULL, 'Multidrug resistance protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150602, NULL, 'G3DSA:3.90.1150.10:FF:000160', NULL, NULL, 'Similar to aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(150603, NULL, 'G3DSA:1.10.640.10:FF:000004', NULL, NULL, 'Dual oxidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(150604, NULL, 'G3DSA:1.20.1250.20:FF:001975', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(150605, NULL, 'G3DSA:1.10.2000.10:FF:000006', NULL, NULL, 'Frizzled-3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(150606, NULL, 'G3DSA:3.30.450.20:FF:000059', NULL, NULL, 'PAS domain containing serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(150607, NULL, 'G3DSA:3.30.300.30:FF:000113', NULL, NULL, 'Nonribosomal peptide synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150608, NULL, 'G3DSA:3.40.50.150:FF:001168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150609, NULL, 'G3DSA:1.20.58.2220:FF:000051', NULL, NULL, 'Formin-like 2b', NULL, NULL, NULL, NULL, NULL, 4),
(150610, NULL, 'G3DSA:3.10.580.10:FF:000104', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(150611, NULL, 'G3DSA:3.20.140.10:FF:000001', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(150612, NULL, 'G3DSA:3.30.40.10:FF:000609', NULL, NULL, 'RING-H2 finger protein ATL1', NULL, NULL, NULL, NULL, NULL, 4),
(150613, NULL, 'G3DSA:1.20.5.170:FF:000292', NULL, NULL, 'JunB proto-oncogene, AP-1 transcription factor subunit a', NULL, NULL, NULL, NULL, NULL, 4),
(150614, NULL, 'G3DSA:1.10.510.10:FF:003581', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150615, NULL, 'G3DSA:2.60.40.60:FF:000642', NULL, NULL, 'AGAP004166-PA', NULL, NULL, NULL, NULL, NULL, 4),
(150616, NULL, 'G3DSA:3.30.70.330:FF:001099', NULL, NULL, 'Putative RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(150617, NULL, 'G3DSA:1.10.472.80:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150618, NULL, 'G3DSA:1.10.560.10:FF:000150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150619, NULL, 'G3DSA:1.10.8.60:FF:000453', NULL, NULL, 'Lon protease homolog 2, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(150620, NULL, 'G3DSA:3.20.10.10:FF:000013', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(150621, NULL, 'G3DSA:3.30.70.660:FF:000006', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(150622, NULL, 'G3DSA:1.10.287.130:FF:000253', NULL, NULL, 'Two component signal transduction system histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(150623, NULL, 'G3DSA:3.30.9.10:FF:000228', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150624, NULL, 'G3DSA:3.40.50.720:FF:001125', NULL, NULL, 'NAD-binding Rossmann fold oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(150625, NULL, 'G3DSA:3.40.50.300:FF:003175', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(150626, NULL, 'G3DSA:1.10.1450.10:FF:000028', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(150627, NULL, 'G3DSA:3.20.20.80:FF:000079', NULL, NULL, 'Alpha-amylase', NULL, NULL, NULL, NULL, NULL, 4),
(150628, NULL, 'G3DSA:1.25.10.10:FF:001608', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150629, NULL, 'G3DSA:1.20.1070.10:FF:001284', NULL, NULL, 'Serpentine Receptor, class TX', NULL, NULL, NULL, NULL, NULL, 4),
(150630, NULL, 'G3DSA:3.40.50.150:FF:001696', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(150631, NULL, 'G3DSA:3.40.1110.10:FF:000062', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(150632, NULL, 'G3DSA:3.10.20.410:FF:000010', NULL, NULL, 'Outer membrane usher protein SfmD', NULL, NULL, NULL, NULL, NULL, 4),
(150633, NULL, 'G3DSA:1.20.1250.20:FF:000311', NULL, NULL, 'Protein NRT1/ PTR FAMILY 5.8', NULL, NULL, NULL, NULL, NULL, 4),
(150634, NULL, 'G3DSA:3.90.105.10:FF:000011', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(150635, NULL, 'G3DSA:3.30.50.10:FF:000054', NULL, NULL, 'Transcription factor elt-1', NULL, NULL, NULL, NULL, NULL, 4),
(150636, NULL, 'G3DSA:1.10.520.10:FF:000001', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(150637, NULL, 'G3DSA:2.60.40.10:FF:003814', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150638, NULL, 'G3DSA:2.40.70.10:FF:000102', NULL, NULL, 'YALI0C10923p', NULL, NULL, NULL, NULL, NULL, 4),
(150639, NULL, 'G3DSA:1.25.10.10:FF:000647', NULL, NULL, 'Nucleolar protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(150640, NULL, 'G3DSA:3.40.190.10:FF:000253', NULL, NULL, 'Peptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(150641, NULL, 'G3DSA:3.50.50.80:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150642, NULL, 'G3DSA:3.30.200.20:FF:002340', NULL, NULL, 'Mitochondrial ribosomal protein L27', NULL, NULL, NULL, NULL, NULL, 4),
(150643, NULL, 'G3DSA:2.40.30.160:FF:000007', NULL, NULL, 'Putative transferase CAF17, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(150644, NULL, 'G3DSA:3.30.420.10:FF:000369', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150645, NULL, 'G3DSA:2.40.50.140:FF:000977', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150646, NULL, 'G3DSA:1.10.472.80:FF:000134', NULL, NULL, 'Rab GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150647, NULL, 'G3DSA:1.10.1200.270:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150648, NULL, 'G3DSA:2.40.70.10:FF:000574', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150649, NULL, 'G3DSA:3.30.497.10:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150650, NULL, 'G3DSA:2.130.10.10:FF:002685', NULL, NULL, 'WD-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150651, NULL, 'G3DSA:3.30.70.330:FF:000879', NULL, NULL, 'Splicing factor U2af large subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(150652, NULL, 'G3DSA:2.170.8.10:FF:000014', NULL, NULL, 'Phosphoenolpyruvate carboxykinase [GTP]', NULL, NULL, NULL, NULL, NULL, 4),
(150653, NULL, 'G3DSA:3.40.720.10:FF:000160', NULL, NULL, 'Arylsulfatase A', NULL, NULL, NULL, NULL, NULL, 4),
(150654, NULL, 'G3DSA:2.130.10.10:FF:002449', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(150655, NULL, 'G3DSA:1.10.1750.10:FF:000017', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(150656, NULL, 'G3DSA:3.30.1360.10:FF:000060', NULL, NULL, 'RNA polymerase Rpb3/Rpb11 dimerisation domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(150657, NULL, 'G3DSA:1.20.1260.10:FF:000039', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(150658, NULL, 'G3DSA:3.40.50.1240:FF:000116', NULL, NULL, 'Fructose-2,6-bisphosphatase TIGAR B', NULL, NULL, NULL, NULL, NULL, 4),
(150659, NULL, 'G3DSA:1.50.10.150:FF:000007', NULL, NULL, 'Sulfite efflux pump SSU1', NULL, NULL, NULL, NULL, NULL, 4),
(150660, NULL, 'G3DSA:1.10.1240.30:FF:000001', NULL, NULL, 'Phosphoserine phosphatase RsbU', NULL, NULL, NULL, NULL, NULL, 4),
(150661, NULL, 'G3DSA:2.130.10.10:FF:005411', NULL, NULL, 'BEACH domain-containing protein lvsB', NULL, NULL, NULL, NULL, NULL, 4),
(150662, NULL, 'G3DSA:3.50.50.60:FF:000326', NULL, NULL, 'Squalene monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(150663, NULL, 'G3DSA:1.20.140.150:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150664, NULL, 'G3DSA:3.100.10.10:FF:000064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(150665, NULL, 'G3DSA:3.40.140.10:FF:000250', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(150666, NULL, 'G3DSA:3.40.50.300:FF:003028', NULL, NULL, 'ATP-dependent DNA helicase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(150667, NULL, 'G3DSA:3.40.50.1000:FF:000567', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150668, NULL, 'G3DSA:3.30.60.20:FF:000029', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(150669, NULL, 'G3DSA:1.20.58.60:FF:000474', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(150670, NULL, 'G3DSA:3.30.559.10:FF:000286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150671, NULL, 'G3DSA:3.40.50.720:FF:002081', NULL, NULL, 'Os12g0534000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(150672, NULL, 'G3DSA:1.20.1250.20:FF:000255', NULL, NULL, 'Solute carrier family 29 member 4', NULL, NULL, NULL, NULL, NULL, 4),
(150673, NULL, 'G3DSA:2.60.40.10:FF:003337', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150674, NULL, 'G3DSA:3.90.1070.10:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150675, NULL, 'G3DSA:2.40.30.140:FF:000001', NULL, NULL, 'Cytoplasmic alpha-amylase', NULL, NULL, NULL, NULL, NULL, 4),
(150676, NULL, 'G3DSA:1.20.58.340:FF:000073', NULL, NULL, 'Cation transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150677, NULL, 'G3DSA:3.30.390.50:FF:000012', NULL, NULL, 'Carbon monoxide dehydrogenase medium chain', NULL, NULL, NULL, NULL, NULL, 4),
(150678, NULL, 'G3DSA:2.130.10.10:FF:003938', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150679, NULL, 'G3DSA:4.10.280.10:FF:000173', NULL, NULL, 'helix-loop-helix protein delilah', NULL, NULL, NULL, NULL, NULL, 4),
(150680, NULL, 'G3DSA:2.130.10.10:FF:001701', NULL, NULL, 'NACHT and WD repeat domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(150681, NULL, 'G3DSA:3.30.70.60:FF:000019', NULL, NULL, 'Fimbrial assembly protein PilO, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150682, NULL, 'G3DSA:2.130.10.10:FF:001516', NULL, NULL, 'Protein CFT1', NULL, NULL, NULL, NULL, NULL, 4),
(150683, NULL, 'G3DSA:3.30.760.10:FF:000012', NULL, NULL, 'Eukaryotic translation initiation factor 4E', NULL, NULL, NULL, NULL, NULL, 4),
(150684, NULL, 'G3DSA:1.10.560.10:FF:000094', NULL, NULL, '60 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(150685, NULL, 'G3DSA:1.10.20.10:FF:000237', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150686, NULL, 'G3DSA:3.80.10.10:FF:001691', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150687, NULL, 'G3DSA:3.40.50.720:FF:000164', NULL, NULL, 'Carbonyl reductase [NADPH] 1', NULL, NULL, NULL, NULL, NULL, 4),
(150688, NULL, 'G3DSA:2.60.120.10:FF:000388', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150689, NULL, 'G3DSA:1.20.58.60:FF:000327', NULL, NULL, 'Muscle-specific protein 300 kDa, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(150690, NULL, 'G3DSA:3.30.360.10:FF:000083', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase GAPCP1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(150691, NULL, 'G3DSA:1.10.3470.10:FF:000035', NULL, NULL, 'Iron chelate uptake ABC transporter, FeCT family, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(150692, NULL, 'G3DSA:3.20.20.70:FF:000694', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150693, NULL, 'G3DSA:2.60.120.200:FF:000599', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150694, NULL, 'G3DSA:2.60.40.770:FF:000002', NULL, NULL, 'putative phosphatidylglycerol/phosphatidylinositol transfer protein DDB_G0282179', NULL, NULL, NULL, NULL, NULL, 4),
(150695, NULL, 'G3DSA:3.40.50.10140:FF:000032', NULL, NULL, 'AGAP001590-PB', NULL, NULL, NULL, NULL, NULL, 4),
(150696, NULL, 'G3DSA:3.30.2290.10:FF:000026', NULL, NULL, 'Peptide maturation', NULL, NULL, NULL, NULL, NULL, 4),
(150697, NULL, 'G3DSA:3.40.50.300:FF:002691', NULL, NULL, 'ATPase, AAA family protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(150698, NULL, 'G3DSA:3.30.160.60:FF:003090', NULL, NULL, 'Az2', NULL, NULL, NULL, NULL, NULL, 4),
(150699, NULL, 'G3DSA:2.60.120.590:FF:000053', NULL, NULL, 'Fat mass and obesity associated', NULL, NULL, NULL, NULL, NULL, 4),
(150700, NULL, 'G3DSA:2.60.40.10:FF:003253', NULL, NULL, 'Si:ch211-141e20.2', NULL, NULL, NULL, NULL, NULL, 4),
(150701, NULL, 'G3DSA:3.40.30.10:FF:001250', NULL, NULL, '5'' nucleotidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150702, NULL, 'G3DSA:3.30.60.20:FF:000092', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(150703, NULL, 'G3DSA:1.10.555.10:FF:000020', NULL, NULL, 'protein FAM13B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(150704, NULL, 'G3DSA:3.40.30.10:FF:001194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150705, NULL, 'G3DSA:1.10.532.10:FF:000012', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(150706, NULL, 'G3DSA:2.70.160.11:FF:000058', NULL, NULL, 'Arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(150707, NULL, 'G3DSA:1.25.40.10:FF:004281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150708, NULL, 'G3DSA:3.40.50.300:FF:003091', NULL, NULL, 'Small GTPase EhRabX28, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150709, NULL, 'G3DSA:3.10.129.10:FF:000247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150710, NULL, 'G3DSA:2.60.40.10:FF:002853', NULL, NULL, 'IGLV2-33 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(150711, NULL, 'G3DSA:1.25.40.540:FF:000005', NULL, NULL, 'TOR signalling pathway regulator (TapA), putative', NULL, NULL, NULL, NULL, NULL, 4),
(150712, NULL, 'G3DSA:1.25.10.10:FF:000794', NULL, NULL, 'She4p', NULL, NULL, NULL, NULL, NULL, 4),
(150713, NULL, 'G3DSA:3.40.50.2300:FF:000974', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150714, NULL, 'G3DSA:3.40.50.300:FF:004517', NULL, NULL, 'putative helicase MOV-10 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(150715, NULL, 'G3DSA:3.30.497.10:FF:000006', NULL, NULL, 'Plasminogen activator inhibitor 1', NULL, NULL, NULL, NULL, NULL, 4),
(150716, NULL, 'G3DSA:3.30.200.20:FF:000395', NULL, NULL, 'Proline-rich receptor-like protein kinase PERK3', NULL, NULL, NULL, NULL, NULL, 4),
(150717, NULL, 'G3DSA:2.40.50.140:FF:000185', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(150718, NULL, 'G3DSA:3.40.630.30:FF:000164', NULL, NULL, 'Acetyltransferase GNAT family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150719, NULL, 'G3DSA:2.130.10.10:FF:000212', NULL, NULL, 'Proteasomal ATPase associated factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(150720, NULL, 'G3DSA:3.60.15.10:FF:000269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150721, NULL, 'G3DSA:3.40.50.880:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150722, NULL, 'G3DSA:3.90.70.10:FF:000598', NULL, NULL, 'Cathepsin C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150723, NULL, 'G3DSA:3.90.550.10:FF:000747', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150724, NULL, 'G3DSA:3.30.450.40:FF:000301', NULL, NULL, 'PAS sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(150725, NULL, 'G3DSA:3.30.40.10:FF:002026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150726, NULL, 'G3DSA:1.10.800.10:FF:000006', NULL, NULL, 'Phenylalanine 4-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(150727, NULL, 'G3DSA:3.80.10.10:FF:000347', NULL, NULL, 'Platelet glycoprotein Ib alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(150728, NULL, 'G3DSA:3.40.430.10:FF:000002', NULL, NULL, 'Dihydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(150729, NULL, 'G3DSA:3.30.70.330:FF:002824', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150730, NULL, 'G3DSA:1.10.3500.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150731, NULL, 'G3DSA:3.40.50.2000:FF:000210', NULL, NULL, 'Alpha-1,3/1,6-mannosyltransferase ALG2', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(150732, NULL, 'G3DSA:2.130.10.10:FF:000740', NULL, NULL, 'WD repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(150733, NULL, 'G3DSA:2.60.20.10:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150734, NULL, 'G3DSA:3.10.28.10:FF:000065', NULL, NULL, 'tRNA-splicing ligase RtcB', NULL, NULL, NULL, NULL, NULL, 4),
(150735, NULL, 'G3DSA:3.40.366.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150736, NULL, 'G3DSA:3.40.30.10:FF:000794', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(150737, NULL, 'G3DSA:2.60.40.790:FF:000188', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150738, NULL, 'G3DSA:3.40.50.1820:FF:001297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150739, NULL, 'G3DSA:3.90.850.10:FF:000028', NULL, NULL, 'FAA hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(150740, NULL, 'G3DSA:3.90.70.10:FF:000507', NULL, NULL, 'pro-cathepsin H-like', NULL, NULL, NULL, NULL, NULL, 4),
(150741, NULL, 'G3DSA:3.40.50.300:FF:008323', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150742, NULL, 'G3DSA:1.25.40.10:FF:000475', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g40410, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(150743, NULL, 'G3DSA:3.10.20.90:FF:000841', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150744, NULL, 'G3DSA:3.90.470.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150745, NULL, 'G3DSA:3.90.550.50:FF:000175', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(150746, NULL, 'G3DSA:1.10.3720.10:FF:000072', NULL, NULL, 'Amino acid ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(150747, NULL, 'G3DSA:3.40.30.10:FF:000266', NULL, NULL, 'Thioredoxin-related transmembrane protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(150748, NULL, 'G3DSA:3.40.50.300:FF:000246', NULL, NULL, 'Preprotein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(150749, NULL, 'G3DSA:2.130.10.10:FF:001140', NULL, NULL, 'Similar to WD repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(150750, NULL, 'G3DSA:4.10.60.10:FF:000267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150751, NULL, 'G3DSA:1.25.40.10:FF:005146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150752, NULL, 'G3DSA:2.60.40.60:FF:000165', NULL, NULL, 'FAT atypical cadherin 3', NULL, NULL, NULL, NULL, NULL, 4),
(150753, NULL, 'G3DSA:1.10.472.80:FF:000050', NULL, NULL, 'GTPase activating protein (Gyp3)', NULL, NULL, NULL, NULL, NULL, 4),
(150754, NULL, 'G3DSA:1.25.40.10:FF:002420', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(150755, NULL, 'G3DSA:3.30.40.10:FF:002173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150756, NULL, 'G3DSA:3.40.50.300:FF:003652', NULL, NULL, 'Uncharacterized protein LmxM_30_0480b_1', NULL, NULL, NULL, NULL, NULL, 4),
(150757, NULL, 'G3DSA:2.40.50.140:FF:000893', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150758, NULL, 'G3DSA:3.30.1490.80:FF:000040', NULL, NULL, 'Glutathione synthetase, putative (AFU_orthologue AFUA_5G06610)', NULL, NULL, NULL, NULL, NULL, 4),
(150759, NULL, 'G3DSA:1.20.1070.10:FF:001317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150760, NULL, 'G3DSA:2.130.10.10:FF:002977', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150761, NULL, 'G3DSA:1.10.510.10:FF:004446', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150762, NULL, 'G3DSA:3.30.9.10:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150763, NULL, 'G3DSA:1.10.510.10:FF:001720', NULL, NULL, 'MUT9-related serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(150764, NULL, 'G3DSA:3.30.70.270:FF:000075', NULL, NULL, 'Biofilm formation regulator HmsP', NULL, NULL, NULL, NULL, NULL, 4),
(150765, NULL, 'G3DSA:3.55.50.30:FF:000015', NULL, NULL, 'DUF4974 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(150766, NULL, 'G3DSA:1.10.287.100:FF:000002', NULL, NULL, 'Glucosidase YgjK', NULL, NULL, NULL, NULL, NULL, 4),
(150767, NULL, 'G3DSA:1.25.10.20:FF:000004', NULL, NULL, 'Apolipoprotein B', NULL, NULL, NULL, NULL, NULL, 4),
(150768, NULL, 'G3DSA:3.30.565.10:FF:000227', NULL, NULL, 'Probable two-component sensor', NULL, NULL, NULL, NULL, NULL, 4),
(150769, NULL, 'G3DSA:3.90.550.50:FF:000208', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(150770, NULL, 'G3DSA:3.90.550.10:FF:000011', NULL, NULL, '3-deoxy-manno-octulosonate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(150771, NULL, 'G3DSA:3.40.1170.10:FF:000043', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150772, NULL, 'G3DSA:1.25.40.20:FF:001321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150773, NULL, 'G3DSA:1.10.510.10:FF:000736', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(150774, NULL, 'G3DSA:3.90.228.20:FF:000001', NULL, NULL, 'Phosphoenolpyruvate carboxykinase (ATP)', NULL, NULL, NULL, NULL, NULL, 4),
(150775, NULL, 'G3DSA:2.70.170.10:FF:000198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150776, NULL, 'G3DSA:3.10.20.90:FF:000133', NULL, NULL, 'growth factor receptor-bound protein 14 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(150777, NULL, 'G3DSA:2.60.120.200:FF:000604', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150778, NULL, 'G3DSA:3.40.50.300:FF:001230', NULL, NULL, 'Phosphoribulokinase/uridine kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(150779, NULL, 'G3DSA:2.40.70.10:FF:000046', NULL, NULL, 'Aspartic proteinase PCS1', NULL, NULL, NULL, NULL, NULL, 4),
(150780, NULL, 'G3DSA:3.30.160.60:FF:000032', NULL, NULL, 'Krueppel-like factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(150781, NULL, 'G3DSA:1.25.10.10:FF:000119', NULL, NULL, 'Integrator complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(150782, NULL, 'G3DSA:3.40.1810.10:FF:000008', NULL, NULL, 'MADS-box transcription factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(150783, NULL, 'G3DSA:1.10.287.660:FF:000001', NULL, NULL, 'pre-mRNA-splicing factor ISY1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(150784, NULL, 'G3DSA:3.30.40.10:FF:001189', NULL, NULL, 'AGAP006749-PA', NULL, NULL, NULL, NULL, NULL, 4),
(150785, NULL, 'G3DSA:3.40.50.300:FF:006378', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150786, NULL, 'G3DSA:3.40.50.1820:FF:001302', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150787, NULL, 'G3DSA:1.10.238.10:FF:000598', NULL, NULL, 'Calmodulin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150788, NULL, 'G3DSA:3.30.420.40:FF:000389', NULL, NULL, 'Putative actin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(150789, NULL, 'G3DSA:1.10.274.100:FF:000026', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(150790, NULL, 'G3DSA:3.90.1410.10:FF:000056', NULL, NULL, 'CIA6', NULL, NULL, NULL, NULL, NULL, 4),
(150791, NULL, 'G3DSA:3.40.50.300:FF:007362', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150792, NULL, 'G3DSA:1.20.58.220:FF:000003', NULL, NULL, 'Inorganic phosphate transporter, sodium-dependent', NULL, NULL, NULL, NULL, NULL, 4),
(150793, NULL, 'G3DSA:3.70.10.10:FF:000140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150794, NULL, 'G3DSA:1.25.40.10:FF:001436', NULL, NULL, 'Si:ch211-166a6.5', NULL, NULL, NULL, NULL, NULL, 4),
(150795, NULL, 'G3DSA:1.10.287.110:FF:000275', NULL, NULL, 'Heat shock protein 40', NULL, NULL, NULL, NULL, NULL, 4),
(150796, NULL, 'G3DSA:2.110.10.10:FF:000022', NULL, NULL, 'Hemopexin', NULL, NULL, NULL, NULL, NULL, 4),
(150797, NULL, 'G3DSA:1.10.510.10:FF:003957', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150798, NULL, 'G3DSA:3.30.200.20:FF:000215', NULL, NULL, 'Cyclin-dependent kinase 2 (CDK2L)', NULL, NULL, NULL, NULL, NULL, 4),
(150799, NULL, 'G3DSA:2.30.42.10:FF:000493', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(150800, NULL, 'G3DSA:1.20.1270.10:FF:000012', NULL, NULL, 'Heat shock protein 105 kDa isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(150801, NULL, 'G3DSA:1.10.150.80:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150802, NULL, 'G3DSA:2.40.50.230:FF:000004', NULL, NULL, 'Baseplate assembly protein V', NULL, NULL, NULL, NULL, NULL, 4),
(150803, NULL, 'G3DSA:3.90.70.10:FF:000570', NULL, NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit pan2', NULL, NULL, NULL, NULL, NULL, 4),
(150804, NULL, 'G3DSA:3.10.310.70:FF:000001', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(150805, NULL, 'G3DSA:2.60.120.650:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150806, NULL, 'G3DSA:1.10.30.10:FF:000182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150807, NULL, 'G3DSA:2.70.70.10:FF:000067', NULL, NULL, 'Zinc metalloendopeptidase M23 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(150808, NULL, 'G3DSA:3.30.40.10:FF:001161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150809, NULL, 'G3DSA:2.40.50.100:FF:000196', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150810, NULL, 'G3DSA:1.20.1160.11:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150811, NULL, 'G3DSA:2.60.40.1670:FF:000011', NULL, NULL, 'Protein transport protein Sec24C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150812, NULL, 'G3DSA:2.40.50.120:FF:000027', NULL, NULL, 'Secreted Frizzled-Related Protein', NULL, NULL, NULL, NULL, NULL, 4),
(150813, NULL, 'G3DSA:1.10.287.70:FF:000381', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150814, NULL, 'G3DSA:3.90.180.10:FF:000027', NULL, NULL, 'Zinc-type alcohol dehydrogenase AdhD', NULL, NULL, NULL, NULL, NULL, 4),
(150815, NULL, 'G3DSA:3.30.160.60:FF:000824', NULL, NULL, 'Zinc finger protein 184', NULL, NULL, NULL, NULL, NULL, 4),
(150816, NULL, 'G3DSA:4.10.400.10:FF:000054', NULL, NULL, 'Corin, serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(150817, NULL, 'G3DSA:2.120.10.30:FF:000600', NULL, NULL, 'Gll1703 protein', NULL, NULL, NULL, NULL, NULL, 4),
(150818, NULL, 'G3DSA:3.60.21.10:FF:000093', NULL, NULL, 'Cell division cycle-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(150819, NULL, 'G3DSA:3.30.160.60:FF:002954', NULL, NULL, 'Zinc finger protein 408', NULL, NULL, NULL, NULL, NULL, 4),
(150820, NULL, 'G3DSA:2.60.40.150:FF:000760', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150821, NULL, 'G3DSA:3.30.70.330:FF:000082', NULL, NULL, '60S ribosomal protein L23a', NULL, NULL, NULL, NULL, NULL, 4),
(150822, NULL, 'G3DSA:1.10.357.10:FF:000054', NULL, NULL, 'Transcriptional regulator, TetR family', NULL, NULL, NULL, NULL, NULL, 4),
(150823, NULL, 'G3DSA:3.20.20.70:FF:000778', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150824, NULL, 'G3DSA:3.20.20.70:FF:000306', NULL, NULL, 'Lipoyl synthase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(150825, NULL, 'G3DSA:3.80.10.10:FF:003489', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150826, NULL, 'G3DSA:3.15.10.30:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150827, NULL, 'G3DSA:2.30.29.170:FF:000010', NULL, NULL, 'Rib72_protein-like_protein', NULL, NULL, NULL, NULL, NULL, 4),
(150828, NULL, 'G3DSA:1.25.40.20:FF:000568', NULL, NULL, 'HECT domain E3 ubiquitin protein ligase 1', NULL, NULL, NULL, NULL, NULL, 4),
(150829, NULL, 'G3DSA:1.10.10.10:FF:000467', NULL, NULL, 'Cyclic nucleotide-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(150830, NULL, 'G3DSA:3.90.550.10:FF:000516', NULL, NULL, 'Sll1995 protein', NULL, NULL, NULL, NULL, NULL, 4),
(150831, NULL, 'G3DSA:1.10.238.10:FF:000311', NULL, NULL, 'Follistatin-like 4', NULL, NULL, NULL, NULL, NULL, 4),
(150832, NULL, 'G3DSA:1.10.238.10:FF:001295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150833, NULL, 'G3DSA:1.10.12.70:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(150834, NULL, 'G3DSA:4.10.860.10:FF:000015', NULL, NULL, 'Calcyclin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(150835, NULL, 'G3DSA:1.10.510.10:FF:000231', NULL, NULL, 'Cyclin-dependent kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(150836, NULL, 'G3DSA:2.60.120.10:FF:000708', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150837, NULL, 'G3DSA:3.90.660.20:FF:000022', NULL, NULL, 'Pcyox1l protein', NULL, NULL, NULL, NULL, NULL, 4),
(150838, NULL, 'G3DSA:3.10.110.10:FF:000373', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150839, NULL, 'G3DSA:2.60.40.790:FF:000160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150840, NULL, 'G3DSA:1.25.40.20:FF:000624', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(150841, NULL, 'G3DSA:1.20.140.40:FF:000001', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(150842, NULL, 'G3DSA:1.20.1080.10:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150843, NULL, 'G3DSA:2.30.42.10:FF:000577', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150844, NULL, 'G3DSA:3.40.50.300:FF:002247', NULL, NULL, 'ATP-dependent RNA helicase DDX51', NULL, NULL, NULL, NULL, NULL, 4),
(150845, NULL, 'G3DSA:1.10.1030.10:FF:000013', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150846, NULL, 'G3DSA:3.30.160.60:FF:003466', NULL, NULL, 'Zinc finger protein 709', NULL, NULL, NULL, NULL, NULL, 4),
(150847, NULL, 'G3DSA:3.80.10.10:FF:003545', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150848, NULL, 'G3DSA:1.10.10.60:FF:000965', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150849, NULL, 'G3DSA:3.90.190.10:FF:000056', NULL, NULL, 'Dual specificity phosphatase 12', NULL, NULL, NULL, NULL, NULL, 4),
(150850, NULL, 'G3DSA:3.40.1690.20:FF:000012', NULL, NULL, 'AAA ATPase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(150851, NULL, 'G3DSA:3.40.50.12780:FF:000008', NULL, NULL, 'Long-chain fatty acid transport protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(150852, NULL, 'G3DSA:1.20.58.670:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150853, NULL, 'G3DSA:1.10.510.10:FF:000175', NULL, NULL, 'Myosin light chain kinase, smooth muscle', NULL, NULL, NULL, NULL, NULL, 4),
(150854, NULL, 'G3DSA:3.40.390.10:FF:000178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150855, NULL, 'G3DSA:1.25.10.10:FF:002828', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150856, NULL, 'G3DSA:1.20.120.350:FF:000013', NULL, NULL, 'Voltage-dependent N-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(150857, NULL, 'G3DSA:3.40.50.11500:FF:000007', NULL, NULL, 'DENN domain and WD repeat-containing protein SCD1', NULL, NULL, NULL, NULL, NULL, 4),
(150858, NULL, 'G3DSA:2.30.42.10:FF:000049', NULL, NULL, 'disks large homolog 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(150859, NULL, 'G3DSA:2.10.25.10:FF:000954', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150860, NULL, 'G3DSA:2.20.25.690:FF:000003', NULL, NULL, 'Tripeptidyl-peptidase II, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(150861, NULL, 'G3DSA:3.60.120.10:FF:000002', NULL, NULL, 'Isochorismate synthase MenF', NULL, NULL, NULL, NULL, NULL, 4),
(150862, NULL, 'G3DSA:1.20.1560.10:FF:000731', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150863, NULL, 'G3DSA:3.30.70.370:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150864, NULL, 'G3DSA:3.40.50.720:FF:002345', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(150865, NULL, 'G3DSA:2.40.50.150:FF:000042', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(150866, NULL, 'G3DSA:3.40.630.40:FF:000021', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(150867, NULL, 'G3DSA:3.20.20.150:FF:000065', NULL, NULL, 'Si:ch211-141o9.10', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(150868, NULL, 'G3DSA:3.60.10.10:FF:000281', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150869, NULL, 'G3DSA:1.20.1070.10:FF:000064', NULL, NULL, 'adhesion G protein-coupled receptor L4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(150870, NULL, 'G3DSA:1.50.10.10:FF:000022', NULL, NULL, 'LanC like 2', NULL, NULL, NULL, NULL, NULL, 4),
(150871, NULL, 'G3DSA:3.30.420.510:FF:000030', NULL, NULL, 'Pantothenate kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(150872, NULL, 'G3DSA:1.10.1040.10:FF:000042', NULL, NULL, 'Mannitol-1-phosphate 5-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(150873, NULL, 'G3DSA:1.25.40.10:FF:002712', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150874, NULL, 'G3DSA:3.40.50.300:FF:006086', NULL, NULL, 'Ras family protein', NULL, NULL, NULL, NULL, NULL, 4),
(150875, NULL, 'G3DSA:3.30.460.10:FF:000170', NULL, NULL, 'Bifunctional uridylyltransferase/uridylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(150876, NULL, 'G3DSA:3.30.420.40:FF:000097', NULL, NULL, 'tRNA threonylcarbamoyladenosine biosynthesis protein TsaB', NULL, NULL, NULL, NULL, NULL, 4),
(150877, NULL, 'G3DSA:3.40.50.1110:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150878, NULL, 'G3DSA:1.25.10.10:FF:001103', NULL, NULL, 'armadillo repeat-containing protein 8 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(150879, NULL, 'G3DSA:2.60.40.10:FF:000852', NULL, NULL, 'brother of CDO isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(150880, NULL, 'G3DSA:2.10.50.30:FF:000001', NULL, NULL, 'metabotropic glutamate receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(150881, NULL, 'G3DSA:2.60.40.60:FF:000081', NULL, NULL, 'protocadherin Fat 4', NULL, NULL, NULL, NULL, NULL, 4),
(150882, NULL, 'G3DSA:3.30.160.60:FF:005175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150883, NULL, 'G3DSA:1.25.40.10:FF:002656', NULL, NULL, 'Golgi to ER traffic protein 4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(150884, NULL, 'G3DSA:1.20.58.390:FF:000155', NULL, NULL, 'Nicotinic acetylcholine receptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(150885, NULL, 'G3DSA:1.10.246.90:FF:000011', NULL, NULL, 'Nucleolar protein NOP5/ snoRNA binding domain', NULL, NULL, NULL, NULL, NULL, 4),
(150886, NULL, 'G3DSA:2.130.10.10:FF:004719', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit trm82', NULL, NULL, NULL, NULL, NULL, 4),
(150887, NULL, 'G3DSA:2.20.70.10:FF:000176', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(150888, NULL, 'G3DSA:1.10.10.1320:FF:000002', NULL, NULL, 'Anti-sigma-L factor RslA', NULL, NULL, NULL, NULL, NULL, 4),
(150889, NULL, 'G3DSA:3.10.100.10:FF:000344', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150890, NULL, 'G3DSA:3.50.50.60:FF:001170', NULL, NULL, 'Monooxygenase, putative (AFU_orthologue AFUA_7G06960)', NULL, NULL, NULL, NULL, NULL, 4),
(150891, NULL, 'G3DSA:2.60.120.260:FF:000015', NULL, NULL, 'Netrin 1', NULL, NULL, NULL, NULL, NULL, 4),
(150892, NULL, 'G3DSA:2.40.30.10:FF:000156', NULL, NULL, 'Mitochondrial NADH-dependent fumarate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(150893, NULL, 'G3DSA:3.30.70.860:FF:000010', NULL, NULL, 'UPF0381 protein HI_0636', NULL, NULL, NULL, NULL, NULL, 4),
(150894, NULL, 'G3DSA:1.10.510.10:FF:001956', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150895, NULL, 'G3DSA:3.10.20.90:FF:000077', NULL, NULL, 'gamma-aminobutyric acid receptor-associated protein-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(150896, NULL, 'G3DSA:3.40.50.1820:FF:001830', NULL, NULL, 'Beta-hydroxypalmitic acid methyl ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(150897, NULL, 'G3DSA:3.30.40.10:FF:001245', NULL, NULL, 'Chromatin modification-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(150898, NULL, 'G3DSA:1.10.540.10:FF:000148', NULL, NULL, 'Acyl-coa oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(150899, NULL, 'G3DSA:1.20.272.10:FF:000068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(150900, NULL, 'G3DSA:3.30.30.10:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150901, NULL, 'G3DSA:3.40.920.10:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150902, NULL, 'G3DSA:2.60.120.970:FF:000043', NULL, NULL, 'Bone morphogenetic protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(150903, NULL, 'G3DSA:3.40.50.12610:FF:000003', NULL, NULL, 'Oligosaccharyl transferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(150904, NULL, 'G3DSA:3.30.70.340:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150905, NULL, 'G3DSA:3.80.10.10:FF:001308', NULL, NULL, 'EIN3-binding F-box domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(150906, NULL, 'G3DSA:1.10.287.70:FF:000049', NULL, NULL, 'Voltage-dependent sodium channel 2', NULL, NULL, NULL, NULL, NULL, 4),
(150907, NULL, 'G3DSA:3.40.390.10:FF:000234', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150908, NULL, 'G3DSA:2.130.10.10:FF:004630', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150909, NULL, 'G3DSA:1.10.533.10:FF:000267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150910, NULL, 'G3DSA:1.25.40.10:FF:000508', NULL, NULL, 'Zinc finger C3H1-type containing', NULL, NULL, NULL, NULL, NULL, 4),
(150911, NULL, 'G3DSA:3.30.70.120:FF:000018', NULL, NULL, 'CutA1 divalent ion tolerance protein', NULL, NULL, NULL, NULL, NULL, 4),
(150912, NULL, 'G3DSA:2.130.10.10:FF:000504', NULL, NULL, 'Nuclear pore protein (SEH1)', NULL, NULL, NULL, NULL, NULL, 4),
(150913, NULL, 'G3DSA:1.10.10.1340:FF:000008', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 31', NULL, NULL, NULL, NULL, NULL, 4),
(150914, NULL, 'G3DSA:3.40.50.300:FF:008290', NULL, NULL, 'CTP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(150915, NULL, 'G3DSA:3.40.50.300:FF:000690', NULL, NULL, 'GTPase HflX', NULL, NULL, NULL, NULL, NULL, 4),
(150916, NULL, 'G3DSA:1.10.1410.10:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150917, NULL, 'G3DSA:2.40.20.10:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150918, NULL, 'G3DSA:3.30.200.20:FF:001143', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(150919, NULL, 'G3DSA:3.40.50.720:FF:002401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150920, NULL, 'G3DSA:3.10.100.10:FF:000400', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150921, NULL, 'G3DSA:3.60.130.10:FF:000031', NULL, NULL, 'Alpha-ketoglutarate-dependent taurine dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(150922, NULL, 'G3DSA:1.20.58.860:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150923, NULL, 'G3DSA:1.20.1200.10:FF:000007', NULL, NULL, 'Cob(I)yrinic acid a,c-diamide adenosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(150924, NULL, 'G3DSA:4.10.410.10:FF:000083', NULL, NULL, 'Putative serine protease inhibitor 3', NULL, NULL, NULL, NULL, NULL, 4),
(150925, NULL, 'G3DSA:3.60.20.10:FF:000214', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150926, NULL, 'G3DSA:1.20.1070.10:FF:001845', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150927, NULL, 'G3DSA:2.60.40.380:FF:000008', NULL, NULL, 'Ca(2+)-dependent phospholipase D PhoD', NULL, NULL, NULL, NULL, NULL, 4),
(150928, NULL, 'G3DSA:3.90.260.10:FF:000028', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150929, NULL, 'G3DSA:1.50.10.20:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150930, NULL, 'G3DSA:1.10.510.10:FF:003137', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150931, NULL, 'G3DSA:1.10.287.70:FF:000526', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150932, NULL, 'G3DSA:2.30.30.40:FF:000457', NULL, NULL, 'Probable peroxisomal membrane protein PEX13', NULL, NULL, NULL, NULL, NULL, 4),
(150933, NULL, 'G3DSA:1.10.506.10:FF:000013', NULL, NULL, 'Plexin b1a', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(150934, NULL, 'G3DSA:3.40.50.300:FF:005209', NULL, NULL, 'Rab_B19 protein', NULL, NULL, NULL, NULL, NULL, 4),
(150935, NULL, 'G3DSA:3.30.200.20:FF:000631', NULL, NULL, 'Serine/threonine-protein kinase NEK', NULL, NULL, NULL, NULL, NULL, 4),
(150936, NULL, 'G3DSA:3.40.50.2300:FF:000502', NULL, NULL, 'Protein FimX', NULL, NULL, NULL, NULL, NULL, 4),
(150937, NULL, 'G3DSA:2.60.40.10:FF:003781', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150938, NULL, 'G3DSA:2.40.50.40:FF:000059', NULL, NULL, 'Chromatin remodeling factor CHD3 (PICKLE)', NULL, NULL, NULL, NULL, NULL, 4),
(150939, NULL, 'G3DSA:2.60.120.330:FF:000115', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150940, NULL, 'G3DSA:3.20.190.10:FF:000004', NULL, NULL, 'Putative Formamidopyrimidine-DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(150941, NULL, 'G3DSA:1.20.1280.50:FF:000002', NULL, NULL, 'F-box only protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(150942, NULL, 'G3DSA:3.50.50.60:FF:000765', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(150943, NULL, 'G3DSA:3.40.50.720:FF:000456', NULL, NULL, '3-ketodihydrosphingosine reductase tsc10', NULL, NULL, NULL, NULL, NULL, 4),
(150944, NULL, 'G3DSA:1.20.1250.20:FF:001744', NULL, NULL, 'Sodium-dependent glucose transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150945, NULL, 'G3DSA:1.10.357.140:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150946, NULL, 'G3DSA:3.40.140.10:FF:000194', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 14-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(150947, NULL, 'G3DSA:1.10.1670.10:FF:000016', NULL, NULL, 'Endonuclease III', NULL, NULL, NULL, NULL, NULL, 4),
(150948, NULL, 'G3DSA:2.30.180.10:FF:000168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150949, NULL, 'G3DSA:1.25.40.10:FF:000767', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(150950, NULL, 'G3DSA:3.40.50.300:FF:008031', NULL, NULL, 'Dynein heavy chain 9', NULL, NULL, NULL, NULL, NULL, 4),
(150951, NULL, 'G3DSA:1.20.1250.20:FF:002200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150952, NULL, 'G3DSA:3.40.50.2300:FF:001014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150953, NULL, 'G3DSA:3.40.190.10:FF:000814', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(150954, NULL, 'G3DSA:3.40.1410.10:FF:000051', NULL, NULL, 'GntR-family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(150955, NULL, 'G3DSA:3.80.30.20:FF:000003', NULL, NULL, 'CDK5 regulatory subunit-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(150956, NULL, 'G3DSA:3.40.1350.100:FF:000003', NULL, NULL, 'Protein TIC 22-like, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(150957, NULL, 'G3DSA:1.10.287.110:FF:000331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150958, NULL, 'G3DSA:3.40.50.300:FF:000538', NULL, NULL, 'ATPase family AAA domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(150959, NULL, 'G3DSA:3.30.70.330:FF:002532', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150960, NULL, 'G3DSA:3.30.160.60:FF:000537', NULL, NULL, 'Zinc finger with KRAB and SCAN domains 7', NULL, NULL, NULL, NULL, NULL, 4),
(150961, NULL, 'G3DSA:2.130.10.10:FF:002157', NULL, NULL, 'WD repeat-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150962, NULL, 'G3DSA:3.30.200.20:FF:000159', NULL, NULL, 'muscle, skeletal receptor tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(150963, NULL, 'G3DSA:3.40.20.10:FF:000001', NULL, NULL, 'Gelsolin', NULL, NULL, NULL, NULL, NULL, 4),
(150964, NULL, 'G3DSA:3.30.40.10:FF:001953', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150965, NULL, 'G3DSA:1.10.132.60:FF:000018', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(150966, NULL, 'G3DSA:3.40.50.620:FF:000196', NULL, NULL, 'YdcF family protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(150967, NULL, 'G3DSA:2.60.40.10:FF:002033', NULL, NULL, 'Mesocentin', NULL, NULL, NULL, NULL, NULL, 4),
(150968, NULL, 'G3DSA:3.40.50.720:FF:000636', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase 2, cytosolic', NULL, NULL, NULL, NULL, NULL, 4),
(150969, NULL, 'G3DSA:3.30.70.3450:FF:000001', NULL, NULL, 'Alkylglycerone-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(150970, NULL, 'G3DSA:1.20.1250.20:FF:000542', NULL, NULL, 'Sugar transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(150971, NULL, 'G3DSA:1.20.1070.10:FF:001789', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150972, NULL, 'G3DSA:3.30.200.20:FF:000687', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase GSO1', NULL, NULL, NULL, NULL, NULL, 4),
(150973, NULL, 'G3DSA:2.10.110.10:FF:000264', NULL, NULL, 'Ttx-3', NULL, NULL, NULL, NULL, NULL, 4),
(150974, NULL, 'G3DSA:1.20.1730.10:FF:000036', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(150975, NULL, 'G3DSA:3.40.50.200:FF:000098', NULL, NULL, 'Peptidase S8/S53 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(150976, NULL, 'G3DSA:2.60.40.10:FF:002561', NULL, NULL, 'KETtiN (Drosophila actin-binding) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(150977, NULL, 'G3DSA:2.60.40.60:FF:000457', NULL, NULL, 'Cadherin-related hmr-1', NULL, NULL, NULL, NULL, NULL, 4),
(150978, NULL, 'G3DSA:3.40.50.300:FF:004809', NULL, NULL, 'Translation initiation factor IF-2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(150979, NULL, 'G3DSA:3.40.1090.10:FF:000126', NULL, NULL, 'Os08g0376550 protein', NULL, NULL, NULL, NULL, NULL, 4),
(150980, NULL, 'G3DSA:1.50.10.20:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150981, NULL, 'G3DSA:3.10.450.40:FF:000019', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(150982, NULL, 'G3DSA:2.60.40.1110:FF:000012', NULL, NULL, 'TeNSin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(150983, NULL, 'G3DSA:1.20.1250.40:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150984, NULL, 'G3DSA:4.10.470.20:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(150985, NULL, 'G3DSA:3.10.350.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150986, NULL, 'G3DSA:3.40.50.1820:FF:001774', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(150987, NULL, 'G3DSA:2.60.40.10:FF:002089', NULL, NULL, 'Uncharacterized protein YeeJ', NULL, NULL, NULL, NULL, NULL, 4),
(150988, NULL, 'G3DSA:3.90.1150.10:FF:000013', NULL, NULL, 'Cystathionine beta-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(150989, NULL, 'G3DSA:3.30.750.24:FF:000137', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(150990, NULL, 'G3DSA:3.30.559.30:FF:000056', NULL, NULL, 'NonRibosomal Peptide Synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(150991, NULL, 'G3DSA:3.10.100.10:FF:000164', NULL, NULL, 'C-type LECtin', NULL, NULL, NULL, NULL, NULL, 4),
(150992, NULL, 'G3DSA:1.25.10.10:FF:003233', NULL, NULL, 'PIKK family atypical protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(150993, NULL, 'G3DSA:3.80.10.10:FF:002236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150994, NULL, 'G3DSA:4.10.520.10:FF:000001', NULL, NULL, 'DNA-binding protein HU', NULL, NULL, NULL, NULL, NULL, 4),
(150995, NULL, 'G3DSA:2.10.25.10:FF:000246', NULL, NULL, 'EGF-like repeat and discoidin I-like domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(150996, NULL, 'G3DSA:3.10.400.20:FF:000010', NULL, NULL, 'Tma64p', NULL, NULL, NULL, NULL, NULL, 4),
(150997, NULL, 'G3DSA:3.40.630.10:FF:000478', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(150998, NULL, 'G3DSA:2.60.40.2970:FF:000002', NULL, NULL, 'Neutral protease 2', NULL, NULL, NULL, NULL, NULL, 4),
(150999, NULL, 'G3DSA:3.30.430.20:FF:000024', NULL, NULL, 'L-type lectin-domain containing receptor kinase IX.1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(151000, NULL, 'G3DSA:3.80.10.10:FF:001836', NULL, NULL, 'Os06g0557400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(151001, NULL, 'G3DSA:3.40.50.10470:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151002, NULL, 'G3DSA:2.60.40.10:FF:002409', NULL, NULL, 'Malto-oligosyltrehalose trehalohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(151003, NULL, 'G3DSA:2.115.10.20:FF:000020', NULL, NULL, 'Glycosyl hydrolases family 32 protein', NULL, NULL, NULL, NULL, NULL, 4),
(151004, NULL, 'G3DSA:1.10.630.10:FF:000122', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(151005, NULL, 'G3DSA:3.40.350.10:FF:000108', NULL, NULL, 'Transporter', NULL, NULL, NULL, NULL, NULL, 4),
(151006, NULL, 'G3DSA:3.30.559.10:FF:000050', NULL, NULL, 'Nonribosomal peptide synthase SidD', NULL, NULL, NULL, NULL, NULL, 4),
(151007, NULL, 'G3DSA:3.30.70.330:FF:002908', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151008, NULL, 'G3DSA:3.30.565.10:FF:000519', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(151009, NULL, 'G3DSA:1.10.510.10:FF:003665', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151010, NULL, 'G3DSA:1.10.8.1120:FF:000004', NULL, NULL, 'Histone_RNA_hairpin-binding_protein_RNA-binding_domain_containing_protein', NULL, NULL, NULL, NULL, NULL, 4),
(151011, NULL, 'G3DSA:3.40.50.1970:FF:000043', NULL, NULL, 'NAD-dependent methanol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(151012, NULL, 'G3DSA:3.30.70.330:FF:002588', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151013, NULL, 'G3DSA:3.30.160.60:FF:004247', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151014, NULL, 'G3DSA:4.10.400.10:FF:000110', NULL, NULL, 'Low-density lipoprotein receptor-related protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(151015, NULL, 'G3DSA:2.60.120.200:FF:000312', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(151016, NULL, 'G3DSA:1.25.40.10:FF:004365', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151017, NULL, 'G3DSA:2.60.120.1020:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151018, NULL, 'G3DSA:3.40.50.300:FF:001522', NULL, NULL, 'Probable MIS1-C1-tetrahydrofolate synthase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(151019, NULL, 'G3DSA:3.50.50.60:FF:000242', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(151020, NULL, 'G3DSA:3.60.40.10:FF:000013', NULL, NULL, 'probable protein phosphatase 2C 5', NULL, NULL, NULL, NULL, NULL, 4),
(151021, NULL, 'G3DSA:3.30.160.60:FF:005355', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151022, NULL, 'G3DSA:3.80.10.10:FF:004001', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(151023, NULL, 'G3DSA:1.10.620.20:FF:000006', NULL, NULL, 'Acyl-ACP desaturase DesA', NULL, NULL, NULL, NULL, NULL, 4),
(151024, NULL, 'G3DSA:3.40.640.10:FF:000451', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151025, NULL, 'G3DSA:3.40.50.620:FF:000516', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(151026, NULL, 'G3DSA:2.80.10.50:FF:000114', NULL, NULL, 'CRE-EGL-17 protein', NULL, NULL, NULL, NULL, NULL, 4),
(151027, NULL, 'G3DSA:1.20.1560.10:FF:000495', NULL, NULL, 'Export ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(151028, NULL, 'G3DSA:1.10.238.10:FF:000367', NULL, NULL, 'Putative p25-alpha family protein', NULL, NULL, NULL, NULL, NULL, 4),
(151029, NULL, 'G3DSA:1.10.3430.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151030, NULL, 'G3DSA:2.60.40.10:FF:005523', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151031, NULL, 'G3DSA:3.40.50.80:FF:000097', NULL, NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(151032, NULL, 'G3DSA:3.10.10.10:FF:000007', NULL, NULL, 'Retrovirus-related Pol polyprotein from transposon 17.6-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(151033, NULL, 'G3DSA:1.10.3210.10:FF:000078', NULL, NULL, 'dGTP triphosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(151034, NULL, 'G3DSA:1.25.40.10:FF:003437', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(151035, NULL, 'G3DSA:3.40.50.80:FF:000153', NULL, NULL, '(methionine synthase) reductase', NULL, NULL, NULL, NULL, NULL, 4),
(151036, NULL, 'G3DSA:1.20.1070.10:FF:000300', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(151037, NULL, 'G3DSA:1.10.486.10:FF:000044', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(151038, NULL, 'G3DSA:2.60.40.10:FF:000088', NULL, NULL, 'Butyrophilin subfamily 1 member A1', NULL, NULL, NULL, NULL, NULL, 4),
(151039, NULL, 'G3DSA:3.40.50.720:FF:000080', NULL, NULL, 'Thiazole biosynthesis adenylyltransferase ThiF', NULL, NULL, NULL, NULL, NULL, 4),
(151040, NULL, 'G3DSA:3.40.50.10810:FF:000165', NULL, NULL, 'Excision repair cross-complementing rodent repair deficiency, complementation group 6 variant', NULL, NULL, NULL, NULL, NULL, 4),
(151041, NULL, 'G3DSA:3.40.50.300:FF:002955', NULL, NULL, 'Apaf-1 related killer DARK', NULL, NULL, NULL, NULL, NULL, 4),
(151042, NULL, 'G3DSA:3.40.50.1260:FF:000033', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(151043, NULL, 'G3DSA:3.30.342.10:FF:000030', NULL, NULL, 'DNA polymerase epsilon catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(151044, NULL, 'G3DSA:3.40.50.1000:FF:000039', NULL, NULL, 'Phosphoglycolate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(151045, NULL, 'G3DSA:3.30.200.20:FF:002429', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151046, NULL, 'G3DSA:3.40.50.300:FF:005361', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151047, NULL, 'G3DSA:2.130.10.10:FF:004158', NULL, NULL, 'WD-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151048, NULL, 'G3DSA:3.20.20.190:FF:000138', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151049, NULL, 'G3DSA:3.30.70.2250:FF:000001', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(151050, NULL, 'G3DSA:3.40.50.720:FF:001945', NULL, NULL, 'Short-chain dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151051, NULL, 'G3DSA:6.10.250.3360:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151052, NULL, 'G3DSA:2.130.10.10:FF:003702', NULL, NULL, 'Semaphorin 3C', NULL, NULL, NULL, NULL, NULL, 4),
(151053, NULL, 'G3DSA:3.50.20.20:FF:000009', NULL, NULL, 'Phosphohistidine phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(151054, NULL, 'G3DSA:2.20.25.10:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151055, NULL, 'G3DSA:3.30.160.60:FF:003410', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(151056, NULL, 'G3DSA:1.10.10.60:FF:000257', NULL, NULL, 'Zinc-finger homeodomain protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(151057, NULL, 'G3DSA:1.10.10.10:FF:000647', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(151058, NULL, 'G3DSA:1.20.80.10:FF:000044', NULL, NULL, 'Motor AXon guidance', NULL, NULL, NULL, NULL, NULL, 4),
(151059, NULL, 'G3DSA:3.30.1390.10:FF:000005', NULL, NULL, 'E3 ubiquitin-protein ligase UBR1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(151060, NULL, 'G3DSA:3.40.630.10:FF:000422', NULL, NULL, 'AGAP006210-PA', NULL, NULL, NULL, NULL, NULL, 4),
(151061, NULL, 'G3DSA:3.40.720.10:FF:000305', NULL, NULL, 'Iduronate-2-sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(151062, NULL, 'G3DSA:2.120.10.80:FF:000149', NULL, NULL, 'Multiple EGF like domains 8', NULL, NULL, NULL, NULL, NULL, 4),
(151063, NULL, 'G3DSA:3.40.80.10:FF:000033', NULL, NULL, 'Peptidoglycan recognition protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(151064, NULL, 'G3DSA:1.10.8.10:FF:000247', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(151065, NULL, 'G3DSA:1.50.40.10:FF:000411', NULL, NULL, 'Protein CBG20451', NULL, NULL, NULL, NULL, NULL, 4),
(151066, NULL, 'G3DSA:3.40.640.10:FF:000304', NULL, NULL, 'Aspartate aminotransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(151067, NULL, 'G3DSA:3.30.40.10:FF:000317', NULL, NULL, 'transcription initiation factor TFIID subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(151068, NULL, 'G3DSA:2.10.25.10:FF:001735', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(151069, NULL, 'G3DSA:3.40.50.920:FF:000016', NULL, NULL, 'Sulfite reductase [NADPH] flavoprotein component, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151070, NULL, 'G3DSA:2.60.120.260:FF:000538', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151071, NULL, 'G3DSA:3.40.50.10050:FF:000010', NULL, NULL, 'Translation initiation factor IF-2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151072, NULL, 'G3DSA:1.20.120.1910:FF:000033', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(151073, NULL, 'G3DSA:3.40.50.360:FF:000005', NULL, NULL, 'Protein NrdI', NULL, NULL, NULL, NULL, NULL, 4),
(151074, NULL, 'G3DSA:1.20.1420.30:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151075, NULL, 'G3DSA:1.20.1070.10:FF:000772', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(151076, NULL, 'G3DSA:3.10.20.10:FF:000036', NULL, NULL, '60S ribosomal protein L18a', NULL, NULL, NULL, NULL, NULL, 4),
(151077, NULL, 'G3DSA:2.30.40.10:FF:000067', NULL, NULL, '5-methylthioadenosine/S-adenosylhomocysteine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(151078, NULL, 'G3DSA:2.30.30.40:FF:000401', NULL, NULL, 'Calcium Channel, Beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(151079, NULL, 'G3DSA:3.30.40.10:FF:000520', NULL, NULL, 'E3 ubiquitin-protein ligase PDZRN3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(151080, NULL, 'G3DSA:2.60.120.560:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151081, NULL, 'G3DSA:3.30.70.20:FF:000058', NULL, NULL, 'Probable ferredoxin/ferredoxin--NADP reductase', NULL, NULL, NULL, NULL, NULL, 4),
(151082, NULL, 'G3DSA:3.40.50.300:FF:001994', NULL, NULL, 'Translation elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(151083, NULL, 'G3DSA:2.60.40.420:FF:000004', NULL, NULL, 'Cell division protein FtsP', NULL, NULL, NULL, NULL, NULL, 4),
(151084, NULL, 'G3DSA:3.30.70.330:FF:000587', NULL, NULL, 'Hephaestus, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(151085, NULL, 'G3DSA:3.40.140.10:FF:000047', NULL, NULL, 'Apolipoprotein B editing enzyme catalytic polypeptide-like 3H', NULL, NULL, NULL, NULL, NULL, 4),
(151086, NULL, 'G3DSA:3.30.1360.70:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151087, NULL, 'G3DSA:3.90.1310.10:FF:000015', NULL, NULL, 'Penicillin binding protein 2x', NULL, NULL, NULL, NULL, NULL, 4),
(151088, NULL, 'G3DSA:3.40.50.410:FF:000335', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151089, NULL, 'G3DSA:3.80.10.10:FF:002764', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151090, NULL, 'G3DSA:1.25.10.10:FF:000939', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151091, NULL, 'G3DSA:2.40.50.140:FF:000505', NULL, NULL, '26S protease regulatory subunit 6A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151092, NULL, 'G3DSA:3.30.420.40:FF:000861', NULL, NULL, 'Putative glycoprotease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(151093, NULL, 'G3DSA:3.30.160.60:FF:002393', NULL, NULL, 'Blast:Transcription factor grauzone', NULL, NULL, NULL, NULL, NULL, 4),
(151094, NULL, 'G3DSA:1.20.58.60:FF:000182', NULL, NULL, 'Spectrin repeat containing, nuclear envelope 1a', NULL, NULL, NULL, NULL, NULL, 4),
(151095, NULL, 'G3DSA:1.20.1080.10:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151096, NULL, 'G3DSA:2.60.40.10:FF:001780', NULL, NULL, 'Obscurin like 1', NULL, NULL, NULL, NULL, NULL, 4),
(151097, NULL, 'G3DSA:3.40.50.410:FF:000279', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(151098, NULL, 'G3DSA:1.20.1110.10:FF:000091', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(151099, NULL, 'G3DSA:3.90.79.10:FF:000179', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(151100, NULL, 'G3DSA:3.40.50.2000:FF:000682', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(151101, NULL, 'G3DSA:3.40.50.720:FF:001417', NULL, NULL, 'UDP-2-acetamido-2,6-beta-L-arabino-hexul-4-ose reductase', NULL, NULL, NULL, NULL, NULL, 4),
(151102, NULL, 'G3DSA:1.10.10.850:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151103, NULL, 'G3DSA:3.40.1110.10:FF:000298', NULL, NULL, 'Calcium transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(151104, NULL, 'G3DSA:3.40.718.10:FF:000036', NULL, NULL, '3-isopropylmalate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(151105, NULL, 'G3DSA:3.40.50.1820:FF:000572', NULL, NULL, 'Lipase', NULL, NULL, NULL, NULL, NULL, 4),
(151106, NULL, 'G3DSA:1.10.510.10:FF:001248', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(151107, NULL, 'G3DSA:1.20.5.340:FF:000073', NULL, NULL, 'AGAP000406-PA', NULL, NULL, NULL, NULL, NULL, 4),
(151108, NULL, 'G3DSA:3.40.1110.10:FF:000354', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151109, NULL, 'G3DSA:3.40.50.2300:FF:001519', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151110, NULL, 'G3DSA:3.40.190.10:FF:000197', NULL, NULL, 'Glutamine ABC transporter substrate-binding protein GlnH', NULL, NULL, NULL, NULL, NULL, 4),
(151111, NULL, 'G3DSA:3.30.70.330:FF:000115', NULL, NULL, 'eukaryotic translation initiation factor 4H', NULL, NULL, NULL, NULL, NULL, 4),
(151112, NULL, 'G3DSA:3.40.1210.10:FF:000007', NULL, NULL, 'ADL312Cp', NULL, NULL, NULL, NULL, NULL, 4),
(151113, NULL, 'G3DSA:3.40.640.10:FF:000248', NULL, NULL, 'Adenosylmethionine-8-amino-7-oxononanoate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(151114, NULL, 'G3DSA:3.30.230.130:FF:000018', NULL, NULL, 'Cul3p', NULL, NULL, NULL, NULL, NULL, 4),
(151115, NULL, 'G3DSA:3.40.50.360:FF:000152', NULL, NULL, 'NAD(P)H dehydrogenase (Quinone) FQR1', NULL, NULL, NULL, NULL, NULL, 4),
(151116, NULL, 'G3DSA:3.30.710.10:FF:000240', NULL, NULL, 'BTB and MATH domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(151117, NULL, 'G3DSA:3.30.70.330:FF:000790', NULL, NULL, 'Serine/arginine-rich splicing factor SR45a', NULL, NULL, NULL, NULL, NULL, 4),
(151118, NULL, 'G3DSA:3.90.1750.10:FF:000014', NULL, NULL, 'Putative Ubiquitin-protein ligase E3C', NULL, NULL, NULL, NULL, NULL, 4),
(151119, NULL, 'G3DSA:3.40.720.10:FF:000249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151120, NULL, 'G3DSA:1.10.510.10:FF:002940', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(151121, NULL, 'G3DSA:3.30.160.60:FF:005883', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151122, NULL, 'G3DSA:3.60.10.10:FF:000129', NULL, NULL, 'Protein angel', NULL, NULL, NULL, NULL, NULL, 4),
(151123, NULL, 'G3DSA:3.10.270.10:FF:000002', NULL, NULL, 'Uricase', NULL, NULL, NULL, NULL, NULL, 4),
(151124, NULL, 'G3DSA:1.20.120.1200:FF:000005', NULL, NULL, 'NADH-quinone oxidoreductase subunit J', NULL, NULL, NULL, NULL, NULL, 4),
(151125, NULL, 'G3DSA:1.20.5.190:FF:000062', NULL, NULL, 'IQ-domain 11', NULL, NULL, NULL, NULL, NULL, 4),
(151126, NULL, 'G3DSA:3.90.640.90:FF:000019', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(151127, NULL, 'G3DSA:3.40.50.300:FF:006850', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151128, NULL, 'G3DSA:2.40.37.10:FF:000019', NULL, NULL, 'Diaminopimelate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(151129, NULL, 'G3DSA:2.60.60.30:FF:000005', NULL, NULL, 'Tellurium resistance protein TerA', NULL, NULL, NULL, NULL, NULL, 4),
(151130, NULL, 'G3DSA:1.50.40.10:FF:000355', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(151131, NULL, 'G3DSA:1.10.1300.10:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151132, NULL, 'G3DSA:3.90.550.10:FF:000483', NULL, NULL, 'Glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(151133, NULL, 'G3DSA:3.30.40.10:FF:000464', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(151134, NULL, 'G3DSA:1.10.630.10:FF:000650', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151135, NULL, 'G3DSA:2.40.240.130:FF:000002', NULL, NULL, 'Axin 1', NULL, NULL, NULL, NULL, NULL, 4),
(151136, NULL, 'G3DSA:3.10.129.10:FF:000011', NULL, NULL, 'Acyl-coenzyme A thioesterase 11', NULL, NULL, NULL, NULL, NULL, 4),
(151137, NULL, 'G3DSA:1.10.10.830:FF:000001', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(151138, NULL, 'G3DSA:1.25.10.10:FF:002980', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151139, NULL, 'G3DSA:2.60.40.10:FF:000291', NULL, NULL, 'Neuroplastin b', NULL, NULL, NULL, NULL, NULL, 4),
(151140, NULL, 'G3DSA:3.40.309.10:FF:000102', NULL, NULL, 'Putative succinate semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(151141, NULL, 'G3DSA:1.10.10.10:FF:000703', NULL, NULL, 'Regulatory protein RecX', NULL, NULL, NULL, NULL, NULL, 4),
(151142, NULL, 'G3DSA:3.30.450.20:FF:000346', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(151143, NULL, 'G3DSA:1.10.150.20:FF:000138', NULL, NULL, 'DNA-dependent RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(151144, NULL, 'G3DSA:3.40.50.800:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151145, NULL, 'G3DSA:3.30.420.40:FF:000676', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(151146, NULL, 'G3DSA:2.30.29.30:FF:000327', NULL, NULL, 'Rho guanyl nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(151147, NULL, 'G3DSA:3.60.15.10:FF:000180', NULL, NULL, 'Ribonuclease Z', NULL, NULL, NULL, NULL, NULL, 4),
(151148, NULL, 'G3DSA:3.30.500.10:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151149, NULL, 'G3DSA:2.130.10.130:FF:000023', NULL, NULL, 'integrin alpha-PS2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(151150, NULL, 'G3DSA:3.40.50.1820:FF:000605', NULL, NULL, 'S-formylglutathione hydrolase FrmB', NULL, NULL, NULL, NULL, NULL, 4),
(151151, NULL, 'G3DSA:1.10.510.10:FF:002737', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151152, NULL, 'G3DSA:3.40.220.10:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151153, NULL, 'G3DSA:1.20.1050.10:FF:000265', NULL, NULL, 'Putative glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(151154, NULL, 'G3DSA:3.40.50.2300:FF:001486', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151155, NULL, 'G3DSA:2.130.10.10:FF:001960', NULL, NULL, 'WD40 repeat-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(151156, NULL, 'G3DSA:2.60.120.10:FF:000332', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(151157, NULL, 'G3DSA:3.30.1340.30:FF:000008', NULL, NULL, 'Probable osmotically inducible protein Y', NULL, NULL, NULL, NULL, NULL, 4),
(151158, NULL, 'G3DSA:2.130.10.10:FF:000976', NULL, NULL, 'Eukaryotic translation initiation factor 2A', NULL, NULL, NULL, NULL, NULL, 4),
(151159, NULL, 'G3DSA:1.10.510.10:FF:002209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151160, NULL, 'G3DSA:1.25.40.10:FF:003061', NULL, NULL, 'Pre-mRNA splicing factor putative', NULL, NULL, NULL, NULL, NULL, 4),
(151161, NULL, 'G3DSA:3.40.50.300:FF:005737', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151162, NULL, 'G3DSA:2.60.40.150:FF:000608', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(151163, NULL, 'G3DSA:3.30.1550.10:FF:000007', NULL, NULL, '50S ribosomal protein L11', NULL, NULL, NULL, NULL, NULL, 4),
(151164, NULL, 'G3DSA:3.30.310.80:FF:000016', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(151165, NULL, 'G3DSA:3.30.160.60:FF:006136', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151166, NULL, 'G3DSA:3.40.50.720:FF:001384', NULL, NULL, 'Probable polysaccharide biosynthesis protein EpsC', NULL, NULL, NULL, NULL, NULL, 4),
(151167, NULL, 'G3DSA:1.25.40.10:FF:000711', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(151168, NULL, 'G3DSA:3.30.70.890:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151169, NULL, 'G3DSA:2.20.25.20:FF:000018', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(151170, NULL, 'G3DSA:3.40.30.10:FF:000030', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(151171, NULL, 'G3DSA:3.40.50.300:FF:008087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151172, NULL, 'G3DSA:3.40.190.10:FF:000758', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(151173, NULL, 'G3DSA:2.30.30.380:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151174, NULL, 'G3DSA:2.160.20.10:FF:000262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151175, NULL, 'G3DSA:3.30.260.10:FF:000042', NULL, NULL, 'T-complex protein 1, epsilon subunit protein', NULL, NULL, NULL, NULL, NULL, 4),
(151176, NULL, 'G3DSA:3.80.10.10:FF:002056', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(151177, NULL, 'G3DSA:3.90.1380.10:FF:000002', NULL, NULL, 'Threonine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(151178, NULL, 'G3DSA:1.25.40.570:FF:000020', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit E', NULL, NULL, NULL, NULL, NULL, 4),
(151179, NULL, 'G3DSA:3.90.1460.10:FF:000003', NULL, NULL, 'general transcription factor II-I isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(151180, NULL, 'G3DSA:2.130.10.10:FF:001229', NULL, NULL, 'NACHT and WD repeat domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(151181, NULL, 'G3DSA:1.10.510.10:FF:003901', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151182, NULL, 'G3DSA:2.40.50.40:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151183, NULL, 'G3DSA:3.30.70.330:FF:001604', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151184, NULL, 'G3DSA:3.40.50.1700:FF:000007', NULL, NULL, 'Exo-1,4-beta-xylosidase xlnD', NULL, NULL, NULL, NULL, NULL, 4),
(151185, NULL, 'G3DSA:1.10.630.10:FF:000594', NULL, NULL, 'Os07g0293000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(151186, NULL, 'G3DSA:3.40.50.300:FF:001466', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(151187, NULL, 'G3DSA:3.30.930.10:FF:000312', NULL, NULL, 'Phenylalanyl-tRNA synthetase, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(151188, NULL, 'G3DSA:3.30.160.60:FF:001465', NULL, NULL, 'Zinc finger protein 560', NULL, NULL, NULL, NULL, NULL, 4),
(151189, NULL, 'G3DSA:2.30.29.30:FF:001311', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151190, NULL, 'G3DSA:1.20.120.1630:FF:000016', NULL, NULL, 'Phosphatidylethanolamine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(151191, NULL, 'G3DSA:3.40.850.10:FF:000309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151192, NULL, 'G3DSA:3.30.70.330:FF:001043', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151193, NULL, 'G3DSA:3.40.50.150:FF:000999', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151194, NULL, 'G3DSA:3.40.50.10490:FF:000114', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151195, NULL, 'G3DSA:3.40.50.1000:FF:000803', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151196, NULL, 'G3DSA:2.40.10.10:FF:000357', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151197, NULL, 'G3DSA:1.10.10.60:FF:001218', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151198, NULL, 'G3DSA:3.30.1420.10:FF:000003', NULL, NULL, 'Siroheme-sulfite reductase gamma subunit homolog', NULL, NULL, NULL, NULL, NULL, 4),
(151199, NULL, 'G3DSA:1.10.10.10:FF:001631', NULL, NULL, 'Helix-turn-helix transcriptional regulator, ArsR family', NULL, NULL, NULL, NULL, NULL, 4),
(151200, NULL, 'G3DSA:3.30.70.330:FF:000643', NULL, NULL, 'Splicing factor U2AF large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(151201, NULL, 'G3DSA:2.10.220.10:FF:000093', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(151202, NULL, 'G3DSA:2.130.10.10:FF:000268', NULL, NULL, 'polycomb group protein FIE1', NULL, NULL, NULL, NULL, NULL, 4),
(151203, NULL, 'G3DSA:2.60.200.20:FF:000246', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(151204, NULL, 'G3DSA:1.10.510.10:FF:002884', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151205, NULL, 'G3DSA:2.60.40.10:FF:001105', NULL, NULL, 'T-cell surface glycoprotein CD4', NULL, NULL, NULL, NULL, NULL, 4),
(151206, NULL, 'G3DSA:3.30.160.20:FF:000099', NULL, NULL, 'Unplaced genomic scaffold supercont1.38, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(151207, NULL, 'G3DSA:1.20.1690.10:FF:000009', NULL, NULL, 'V-type proton ATPase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(151208, NULL, 'G3DSA:3.30.420.40:FF:000709', NULL, NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(151209, NULL, 'G3DSA:2.60.40.820:FF:000040', NULL, NULL, 'Putative T-box protein 36', NULL, NULL, NULL, NULL, NULL, 4),
(151210, NULL, 'G3DSA:2.30.40.10:FF:000123', NULL, NULL, 'Imidazolonepropionase', NULL, NULL, NULL, NULL, NULL, 4),
(151211, NULL, 'G3DSA:2.30.42.10:FF:000105', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type 13', NULL, NULL, NULL, NULL, NULL, 4),
(151212, NULL, 'G3DSA:3.60.15.10:FF:000033', NULL, NULL, 'MBL fold metallo-hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(151213, NULL, 'G3DSA:2.60.40.150:FF:000232', NULL, NULL, 'U5 small nuclear ribonucleoprotein-specific protein', NULL, NULL, NULL, NULL, NULL, 4),
(151214, NULL, 'G3DSA:3.50.50.100:FF:000021', NULL, NULL, 'AMID-like mitochondrial oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151215, NULL, 'G3DSA:1.25.10.10:FF:001867', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151216, NULL, 'G3DSA:3.40.50.300:FF:001319', NULL, NULL, 'Site-determining protein', NULL, NULL, NULL, NULL, NULL, 4),
(151217, NULL, 'G3DSA:3.80.10.10:FF:003017', NULL, NULL, 'AGAP010289-PA', NULL, NULL, NULL, NULL, NULL, 4),
(151218, NULL, 'G3DSA:1.25.40.180:FF:000173', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151219, NULL, 'G3DSA:3.90.70.80:FF:000074', NULL, NULL, 'OTU deubiquitinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(151220, NULL, 'G3DSA:3.10.180.10:FF:000028', NULL, NULL, 'Glyoxalase/fosfomycin resistance/dioxygenase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(151221, NULL, 'G3DSA:4.10.1280.10:FF:000001', NULL, NULL, 'Botulinum neurotoxin type A', NULL, NULL, NULL, NULL, NULL, 4),
(151222, NULL, 'G3DSA:1.10.1420.10:FF:000116', NULL, NULL, 'DNA mismatch repair protein Msh2', NULL, NULL, NULL, NULL, NULL, 4),
(151223, NULL, 'G3DSA:2.130.10.10:FF:002213', NULL, NULL, 'BBS2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151224, NULL, 'G3DSA:2.60.40.720:FF:000009', NULL, NULL, 'Transcription factor cep-1', NULL, NULL, NULL, NULL, NULL, 4),
(151225, NULL, 'G3DSA:2.170.270.10:FF:000013', NULL, NULL, 'Histone-lysine N-methyltransferase SMYD1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(151226, NULL, 'G3DSA:1.10.4160.10:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151227, NULL, 'G3DSA:2.130.10.10:FF:002921', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(151228, NULL, 'G3DSA:2.60.120.260:FF:000162', NULL, NULL, 'Probable alpha-galactosidase D', NULL, NULL, NULL, NULL, NULL, 4),
(151229, NULL, 'G3DSA:3.30.470.20:FF:000145', NULL, NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(151230, NULL, 'G3DSA:2.170.300.10:FF:000011', NULL, NULL, 'cadherin EGF LAG seven-pass G-type receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(151231, NULL, 'G3DSA:3.90.80.10:FF:000008', NULL, NULL, 'Pyrophosphatase (inorganic) 2', NULL, NULL, NULL, NULL, NULL, 4),
(151232, NULL, 'G3DSA:3.80.10.10:FF:003725', NULL, NULL, 'Leucine-rich repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(151233, NULL, 'G3DSA:1.20.120.150:FF:000009', NULL, NULL, 'PIKK family atypical protein kinase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(151234, NULL, 'G3DSA:2.130.10.10:FF:005647', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151235, NULL, 'G3DSA:2.70.130.10:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151236, NULL, 'G3DSA:3.30.1540.20:FF:000015', NULL, NULL, 'DNA mismatch repair protein PMS1', NULL, NULL, NULL, NULL, NULL, 4),
(151237, NULL, 'G3DSA:3.40.50.300:FF:004669', NULL, NULL, 'ATP-dependent nuclease subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(151238, NULL, 'G3DSA:1.25.40.20:FF:000916', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(151239, NULL, 'G3DSA:1.10.287.1260:FF:000008', NULL, NULL, 'Mechanosensitive ion channel protein 3, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(151240, NULL, 'G3DSA:3.40.30.10:FF:000586', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(151241, NULL, 'G3DSA:1.25.40.10:FF:003561', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(151242, NULL, 'G3DSA:3.30.160.60:FF:005416', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151243, NULL, 'G3DSA:3.90.380.10:FF:000003', NULL, NULL, 'Carnitine monooxygenase oxygenase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(151244, NULL, 'G3DSA:3.20.20.140:FF:000348', NULL, NULL, 'Phosphotriesterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151245, NULL, 'G3DSA:1.20.58.60:FF:000243', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(151246, NULL, 'G3DSA:3.40.50.300:FF:005237', NULL, NULL, 'Dephospho-CoA kinase', NULL, NULL, NULL, NULL, NULL, 4),
(151247, NULL, 'G3DSA:2.130.10.10:FF:004282', NULL, NULL, 'Semaphorin 4A', NULL, NULL, NULL, NULL, NULL, 4),
(151248, NULL, 'G3DSA:3.90.176.10:FF:000012', NULL, NULL, 'NAD(P)(+)--arginine ADP-ribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(151249, NULL, 'G3DSA:3.30.70.330:FF:000374', NULL, NULL, 'Flowering time control protein FCA', NULL, NULL, NULL, NULL, NULL, 4),
(151250, NULL, 'G3DSA:3.30.160.60:FF:002662', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151251, NULL, 'G3DSA:3.40.800.10:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151252, NULL, 'G3DSA:3.90.70.10:FF:000367', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 20', NULL, NULL, NULL, NULL, NULL, 4),
(151253, NULL, 'G3DSA:1.10.510.10:FF:003749', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151254, NULL, 'G3DSA:2.40.30.20:FF:000018', NULL, NULL, 'Tail spike protein', NULL, NULL, NULL, NULL, NULL, 4),
(151255, NULL, 'G3DSA:3.60.20.10:FF:000074', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(151256, NULL, 'G3DSA:3.30.230.130:FF:000013', NULL, NULL, 'Anaphase-promoting complex subunit ApcB, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151257, NULL, 'G3DSA:1.10.287.1240:FF:000002', NULL, NULL, 'Exodeoxyribonuclease I', NULL, NULL, NULL, NULL, NULL, 4),
(151258, NULL, 'G3DSA:3.40.50.1820:FF:000925', NULL, NULL, 'Kynurenine formamidase', NULL, NULL, NULL, NULL, NULL, 4),
(151259, NULL, 'G3DSA:1.10.10.60:FF:000729', NULL, NULL, 'Msx-type homeobox protein', NULL, NULL, NULL, NULL, NULL, 4),
(151260, NULL, 'G3DSA:3.90.1140.10:FF:000007', NULL, NULL, 'Cyclic phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(151261, NULL, 'G3DSA:3.90.550.10:FF:000663', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase 17', NULL, NULL, NULL, NULL, NULL, 4),
(151262, NULL, 'G3DSA:1.10.357.120:FF:000002', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(151263, NULL, 'G3DSA:3.10.196.10:FF:000008', NULL, NULL, 'Methionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(151264, NULL, 'G3DSA:2.60.40.10:FF:001656', NULL, NULL, 'Calmodulin-binding transcription activator 5', NULL, NULL, NULL, NULL, NULL, 4),
(151265, NULL, 'G3DSA:3.40.50.300:FF:000454', NULL, NULL, 'Protein CLP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(151266, NULL, 'G3DSA:2.40.50.140:FF:000269', NULL, NULL, 'Single-stranded DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(151267, NULL, 'G3DSA:3.40.630.30:FF:000248', NULL, NULL, 'N-acetyltransferase 9-like protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(151268, NULL, 'G3DSA:1.25.40.1040:FF:000001', NULL, NULL, 'N-alpha-acetyltransferase 15, NatA auxiliary subunit', NULL, NULL, NULL, NULL, NULL, 4),
(151269, NULL, 'G3DSA:1.20.1250.10:FF:000134', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151270, NULL, 'G3DSA:3.30.470.10:FF:000001', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(151271, NULL, 'G3DSA:2.20.110.10:FF:000071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151272, NULL, 'G3DSA:2.40.100.10:FF:000015', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(151273, NULL, 'G3DSA:3.90.1200.10:FF:000046', NULL, NULL, 'Probable choline kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(151274, NULL, 'G3DSA:3.40.47.10:FF:000158', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151275, NULL, 'G3DSA:3.40.1350.150:FF:000001', NULL, NULL, 'tRNA splicing endonuclease subunit 54', NULL, NULL, NULL, NULL, NULL, 4),
(151276, NULL, 'G3DSA:3.30.200.20:FF:000075', NULL, NULL, 'Probable serine/threonine-protein kinase WNK1', NULL, NULL, NULL, NULL, NULL, 4),
(151277, NULL, 'G3DSA:1.20.920.10:FF:000052', NULL, NULL, 'Chromatin structure-remodeling complex subunit snf21', NULL, NULL, NULL, NULL, NULL, 4),
(151278, NULL, 'G3DSA:3.80.10.10:FF:004361', NULL, NULL, 'Si:dkey-22a18.2', NULL, NULL, NULL, NULL, NULL, 4),
(151279, NULL, 'G3DSA:3.80.10.10:FF:000027', NULL, NULL, 'PH domain and leucine rich repeat protein phosphatase 2', NULL, NULL, NULL, NULL, NULL, 4),
(151280, NULL, 'G3DSA:2.170.270.10:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151281, NULL, 'G3DSA:3.40.50.300:FF:002483', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151282, NULL, 'G3DSA:1.10.238.10:FF:000491', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151283, NULL, 'G3DSA:1.10.20.140:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151284, NULL, 'G3DSA:3.40.50.1000:FF:000747', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151285, NULL, 'G3DSA:3.40.50.1370:FF:000066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151286, NULL, 'G3DSA:3.40.630.10:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151287, NULL, 'G3DSA:1.10.357.140:FF:000008', NULL, NULL, '4-hydroxybenzoate octaprenyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(151288, NULL, 'G3DSA:3.30.565.10:FF:000486', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151289, NULL, 'G3DSA:1.20.1250.20:FF:002228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151290, NULL, 'G3DSA:2.130.10.10:FF:000971', NULL, NULL, 'COMPASS component SWD3', NULL, NULL, NULL, NULL, NULL, 4),
(151291, NULL, 'G3DSA:3.40.350.10:FF:000029', NULL, NULL, 'Aminopeptidase P', NULL, NULL, NULL, NULL, NULL, 4),
(151292, NULL, 'G3DSA:1.20.1270.50:FF:000001', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(151293, NULL, 'G3DSA:2.30.42.10:FF:000341', NULL, NULL, 'Zinc metalloprotease', NULL, NULL, NULL, NULL, NULL, 4),
(151294, NULL, 'G3DSA:2.130.10.10:FF:005271', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151295, NULL, 'G3DSA:3.30.420.10:FF:000341', NULL, NULL, 'Argonaute-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151296, NULL, 'G3DSA:3.60.40.10:FF:000069', NULL, NULL, 'Pyruvate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(151297, NULL, 'G3DSA:1.20.1260.10:FF:000011', NULL, NULL, 'Spore coat protein CotJC', NULL, NULL, NULL, NULL, NULL, 4),
(151298, NULL, 'G3DSA:3.40.50.1820:FF:001482', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151299, NULL, 'G3DSA:3.60.40.10:FF:000018', NULL, NULL, 'Integrin-linked kinase-associated serine/threonine phosphatase 2C', NULL, NULL, NULL, NULL, NULL, 4),
(151300, NULL, 'G3DSA:1.25.40.20:FF:001473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151301, NULL, 'G3DSA:3.30.505.10:FF:000038', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(151302, NULL, 'G3DSA:2.40.50.140:FF:000657', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151303, NULL, 'G3DSA:3.30.160.60:FF:004899', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151304, NULL, 'G3DSA:2.130.10.10:FF:002769', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(151305, NULL, 'G3DSA:2.30.29.30:FF:000322', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(151306, NULL, 'G3DSA:1.10.150.20:FF:000217', NULL, NULL, 'DNA repair and recombination protein RadA', NULL, NULL, NULL, NULL, NULL, 4),
(151307, NULL, 'G3DSA:1.10.565.10:FF:000110', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(151308, NULL, 'G3DSA:3.30.565.10:FF:000047', NULL, NULL, 'Phosphotransferase RcsD', NULL, NULL, NULL, NULL, NULL, 4),
(151309, NULL, 'G3DSA:3.40.50.2000:FF:000530', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(151310, NULL, 'G3DSA:3.30.1460.20:FF:000014', NULL, NULL, 'Arp2/3 complex 34 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(151311, NULL, 'G3DSA:3.30.470.30:FF:000007', NULL, NULL, 'DNA ligase B', NULL, NULL, NULL, NULL, NULL, 4),
(151312, NULL, 'G3DSA:3.10.450.50:FF:000033', NULL, NULL, 'SEC-C motif-containing protein,tetratricopeptide repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(151313, NULL, 'G3DSA:2.60.200.20:FF:000038', NULL, NULL, 'FHA domain-containing protein SNIP1', NULL, NULL, NULL, NULL, NULL, 4),
(151314, NULL, 'G3DSA:3.30.1050.10:FF:000042', NULL, NULL, 'stomatin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(151315, NULL, 'G3DSA:1.20.1070.10:FF:001497', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(151316, NULL, 'G3DSA:3.60.15.10:FF:000117', NULL, NULL, 'DNA cross-link repair 1A protein, variant', NULL, NULL, NULL, NULL, NULL, 4),
(151317, NULL, 'G3DSA:1.10.8.100:FF:000009', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(151318, NULL, 'G3DSA:2.60.40.10:FF:001605', NULL, NULL, 'B-cell receptor CD22', NULL, NULL, NULL, NULL, NULL, 4),
(151319, NULL, 'G3DSA:1.25.40.710:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151320, NULL, 'G3DSA:3.40.50.300:FF:001022', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(151321, NULL, 'G3DSA:1.20.920.30:FF:000007', NULL, NULL, 'Dynein axonemal heavy chain 10', NULL, NULL, NULL, NULL, NULL, 4),
(151322, NULL, 'G3DSA:1.10.8.60:FF:000189', NULL, NULL, 'AAA family ATPase, CDC48 subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(151323, NULL, 'G3DSA:1.10.10.1710:FF:000001', NULL, NULL, '(6-4) photolyase', NULL, NULL, NULL, NULL, NULL, 4),
(151324, NULL, 'G3DSA:3.30.565.10:FF:000435', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', NULL, NULL, NULL, NULL, NULL, 4),
(151325, NULL, 'G3DSA:3.40.50.1820:FF:000021', NULL, NULL, 'Lipase', NULL, NULL, NULL, NULL, NULL, 4),
(151326, NULL, 'G3DSA:3.40.50.800:FF:000121', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(151327, NULL, 'G3DSA:3.90.550.50:FF:000028', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(151328, NULL, 'G3DSA:3.90.780.10:FF:000051', NULL, NULL, '5'' nucleotidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151329, NULL, 'G3DSA:3.40.50.300:FF:006665', NULL, NULL, 'Septin homolog spn5', NULL, NULL, NULL, NULL, NULL, 4),
(151330, NULL, 'G3DSA:1.10.418.60:FF:000019', NULL, NULL, 'Kinetochore protein Nuf2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(151331, NULL, 'G3DSA:3.30.70.3310:FF:000004', NULL, NULL, 'neurogenic locus notch homolog protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(151332, NULL, 'G3DSA:1.20.920.10:FF:000001', NULL, NULL, 'Histone acetyltransferase p300', NULL, NULL, NULL, NULL, NULL, 4),
(151333, NULL, 'G3DSA:1.10.1370.30:FF:000005', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(151334, NULL, 'G3DSA:3.40.50.150:FF:001729', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151335, NULL, 'G3DSA:1.10.287.130:FF:000101', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(151336, NULL, 'G3DSA:3.40.50.880:FF:000190', NULL, NULL, 'Glutathione-independent glyoxalase DJ-1', NULL, NULL, NULL, NULL, NULL, 4),
(151337, NULL, 'G3DSA:1.10.405.40:FF:000001', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(151338, NULL, 'G3DSA:3.30.160.60:FF:003230', NULL, NULL, 'Zinc finger protein ZIC 3', NULL, NULL, NULL, NULL, NULL, 4),
(151339, NULL, 'G3DSA:3.80.10.10:FF:003837', NULL, NULL, 'Leucine-rich repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(151340, NULL, 'G3DSA:1.10.472.10:FF:000630', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151341, NULL, 'G3DSA:1.10.10.440:FF:000002', NULL, NULL, 'pre-mRNA-processing factor 40 homolog A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(151342, NULL, 'G3DSA:1.25.10.10:FF:000878', NULL, NULL, 'Serine/threonine-protein kinase ATR', NULL, NULL, NULL, NULL, NULL, 4),
(151343, NULL, 'G3DSA:3.30.160.60:FF:005467', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151344, NULL, 'G3DSA:3.30.230.10:FF:000366', NULL, NULL, 'Equilibrative Nucleoside Transporter', NULL, NULL, NULL, NULL, NULL, 4),
(151345, NULL, 'G3DSA:3.30.200.20:FF:000867', NULL, NULL, 'Possible serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(151346, NULL, 'G3DSA:3.10.180.10:FF:000023', NULL, NULL, 'Glyoxalase/bleomycin resistance/dioxygenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(151347, NULL, 'G3DSA:3.40.50.80:FF:000237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151348, NULL, 'G3DSA:3.40.50.2300:FF:000738', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One component system)', NULL, NULL, NULL, NULL, NULL, 4),
(151349, NULL, 'G3DSA:1.10.443.10:FF:000001', NULL, NULL, 'Tyrosine recombinase XerD', NULL, NULL, NULL, NULL, NULL, 4),
(151350, NULL, 'G3DSA:3.20.20.80:FF:000287', NULL, NULL, 'Maltooligosyl trehalose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(151351, NULL, 'G3DSA:3.40.50.10590:FF:000003', NULL, NULL, 'Leucine aminopeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(151352, NULL, 'G3DSA:3.60.21.10:FF:000177', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(151353, NULL, 'G3DSA:3.40.50.620:FF:000544', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151354, NULL, 'G3DSA:3.30.390.30:FF:000006', NULL, NULL, 'Nitrite reductase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(151355, NULL, 'G3DSA:3.40.50.300:FF:002871', NULL, NULL, 'Helicase SWR1', NULL, NULL, NULL, NULL, NULL, 4),
(151356, NULL, 'G3DSA:1.20.1050.10:FF:000153', NULL, NULL, 'Protein CBR-GST-15', NULL, NULL, NULL, NULL, NULL, 4),
(151357, NULL, 'G3DSA:1.10.238.10:FF:000339', NULL, NULL, 'Actin cytoskeleton-regulatory complex protein END3', NULL, NULL, NULL, NULL, NULL, 4),
(151358, NULL, 'G3DSA:3.30.160.60:FF:000684', NULL, NULL, 'Zinc finger protein 710', NULL, NULL, NULL, NULL, NULL, 4),
(151359, NULL, 'G3DSA:2.10.220.10:FF:000098', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(151360, NULL, 'G3DSA:2.30.30.30:FF:000067', NULL, NULL, '60S ribosomal protein L14 putative', NULL, NULL, NULL, NULL, NULL, 4),
(151361, NULL, 'G3DSA:1.25.40.10:FF:000655', NULL, NULL, 'Sec72p', NULL, NULL, NULL, NULL, NULL, 4),
(151362, NULL, 'G3DSA:3.40.50.300:FF:007542', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151363, NULL, 'G3DSA:3.30.70.330:FF:001784', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151364, NULL, 'G3DSA:1.20.1070.10:FF:000036', NULL, NULL, 'frizzled-3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(151365, NULL, 'G3DSA:3.40.1160.10:FF:000014', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(151366, NULL, 'G3DSA:3.30.70.330:FF:002352', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151367, NULL, 'G3DSA:1.20.1110.10:FF:000124', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151368, NULL, 'G3DSA:3.40.50.300:FF:007654', NULL, NULL, 'Gll3851 protein', NULL, NULL, NULL, NULL, NULL, 4),
(151369, NULL, 'G3DSA:3.60.10.10:FF:000421', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(151370, NULL, 'G3DSA:3.30.40.10:FF:000492', NULL, NULL, 'Tripartite motif containing 65', NULL, NULL, NULL, NULL, NULL, 4),
(151371, NULL, 'G3DSA:2.60.40.10:FF:005990', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151372, NULL, 'G3DSA:1.10.472.10:FF:000097', NULL, NULL, 'Pho85 cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(151373, NULL, 'G3DSA:3.40.1280.10:FF:000080', NULL, NULL, 'Uncharacterized tRNA/rRNA methyltransferase slr0955', NULL, NULL, NULL, NULL, NULL, 4),
(151374, NULL, 'G3DSA:3.30.519.10:FF:000008', NULL, NULL, 'Rab GDP dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(151375, NULL, 'G3DSA:2.60.120.650:FF:000245', NULL, NULL, 'Bifunctional lysine-specific demethylase and histidyl-hydroxylase NO66', NULL, NULL, NULL, NULL, NULL, 4),
(151376, NULL, 'G3DSA:3.40.630.30:FF:000669', NULL, NULL, 'Elongator complex protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(151377, NULL, 'G3DSA:3.10.20.810:FF:000001', NULL, NULL, 'Histidine biosynthesis bifunctional protein HisIE', NULL, NULL, NULL, NULL, NULL, 4),
(151378, NULL, 'G3DSA:1.25.40.10:FF:001144', NULL, NULL, 'Pre-mRNA-splicing factor SYF1', NULL, NULL, NULL, NULL, NULL, 4),
(151379, NULL, 'G3DSA:3.10.290.70:FF:000004', NULL, NULL, '40S ribosomal protein S8', NULL, NULL, NULL, NULL, NULL, 4),
(151380, NULL, 'G3DSA:1.25.40.10:FF:004921', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151381, NULL, 'G3DSA:3.10.450.50:FF:000084', NULL, NULL, 'Nuclear export factor 3, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(151382, NULL, 'G3DSA:3.40.50.970:FF:000014', NULL, NULL, '2-oxoglutarate dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(151383, NULL, 'G3DSA:3.40.50.720:FF:002261', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151384, NULL, 'G3DSA:2.170.120.12:FF:000016', NULL, NULL, 'RH25219p', NULL, NULL, NULL, NULL, NULL, 4),
(151385, NULL, 'G3DSA:1.25.40.180:FF:000313', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151386, NULL, 'G3DSA:1.10.510.10:FF:001900', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151387, NULL, 'G3DSA:2.30.130.40:FF:000005', NULL, NULL, 'LON peptidase N-terminal domain and ring finger 1', NULL, NULL, NULL, NULL, NULL, 4),
(151388, NULL, 'G3DSA:3.10.20.90:FF:000638', NULL, NULL, 'Microtubule-associated proteins 1A/1B light chain 3C-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(151389, NULL, 'G3DSA:3.40.1780.10:FF:000005', NULL, NULL, 'S-adenosylmethionine:tRNA ribosyltransferase-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(151390, NULL, 'G3DSA:3.30.365.10:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151391, NULL, 'G3DSA:3.40.50.300:FF:007103', NULL, NULL, 'Si:dkeyp-75b4.9', NULL, NULL, NULL, NULL, NULL, 4),
(151392, NULL, 'G3DSA:3.90.1420.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151393, NULL, 'G3DSA:1.10.10.60:FF:000960', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151394, NULL, 'G3DSA:3.30.465.10:FF:000051', NULL, NULL, 'FAD-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(151395, NULL, 'G3DSA:1.25.40.10:FF:001695', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g37170', NULL, NULL, NULL, NULL, NULL, 4),
(151396, NULL, 'G3DSA:2.40.10.10:FF:000649', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151397, NULL, 'G3DSA:3.30.200.20:FF:002492', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151398, NULL, 'G3DSA:1.25.40.20:FF:000012', NULL, NULL, 'ankyrin repeat domain-containing protein 17 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(151399, NULL, 'G3DSA:3.30.710.10:FF:000408', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151400, NULL, 'G3DSA:1.20.1250.20:FF:002020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151401, NULL, 'G3DSA:2.60.40.60:FF:000249', NULL, NULL, 'Starry night', NULL, NULL, NULL, NULL, NULL, 4),
(151402, NULL, 'G3DSA:3.80.10.10:FF:002848', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(151403, NULL, 'G3DSA:3.30.70.330:FF:000323', NULL, NULL, 'RNA binding protein MSSP-2', NULL, NULL, NULL, NULL, NULL, 4),
(151404, NULL, 'G3DSA:1.10.390.10:FF:000030', NULL, NULL, 'AGAP000129-PA', NULL, NULL, NULL, NULL, NULL, 4),
(151405, NULL, 'G3DSA:2.30.30.790:FF:000007', NULL, NULL, 'Mitochondrial ribosomal protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151406, NULL, 'G3DSA:3.30.450.40:FF:000065', NULL, NULL, 'Hydrogenase-4 transcriptional activator', NULL, NULL, NULL, NULL, NULL, 4),
(151407, NULL, 'G3DSA:3.40.1090.10:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151408, NULL, 'G3DSA:3.40.50.10890:FF:000003', NULL, NULL, 'Integrator complex subunit 9', NULL, NULL, NULL, NULL, NULL, 4),
(151409, NULL, 'G3DSA:2.60.200.20:FF:000190', NULL, NULL, 'SMAD/FHA domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(151410, NULL, 'G3DSA:3.30.1360.120:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151411, NULL, 'G3DSA:3.40.50.1170:FF:000011', NULL, NULL, 'Asparaginase/glutaminase', NULL, NULL, NULL, NULL, NULL, 4),
(151412, NULL, 'G3DSA:1.20.1250.20:FF:001031', NULL, NULL, 'AGL277Wp', NULL, NULL, NULL, NULL, NULL, 4),
(151413, NULL, 'G3DSA:3.10.20.90:FF:000217', NULL, NULL, 'Tubulin folding cofactor B', NULL, NULL, NULL, NULL, NULL, 4),
(151414, NULL, 'G3DSA:3.40.190.10:FF:000045', NULL, NULL, 'Putative glutamate receptor ionotropic NMDA 3A', NULL, NULL, NULL, NULL, NULL, 4),
(151415, NULL, 'G3DSA:3.90.180.10:FF:000022', NULL, NULL, 'NADP-dependent alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(151416, NULL, 'G3DSA:3.40.50.12660:FF:000001', NULL, NULL, 'Metacaspase-1', NULL, NULL, NULL, NULL, NULL, 4),
(151417, NULL, 'G3DSA:3.40.50.12390:FF:000009', NULL, NULL, '5''-3'' exoribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(151418, NULL, 'G3DSA:3.30.70.1230:FF:000184', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(151419, NULL, 'G3DSA:1.10.150.910:FF:000010', NULL, NULL, 'DNA damage-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(151420, NULL, 'G3DSA:3.40.50.1220:FF:000049', NULL, NULL, 'Electron transfer flavoprotein alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(151421, NULL, 'G3DSA:1.10.510.10:FF:001080', NULL, NULL, 'NIMA related kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(151422, NULL, 'G3DSA:1.10.287.70:FF:000442', NULL, NULL, 'Ionotropic receptor 68a, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(151423, NULL, 'G3DSA:3.90.640.10:FF:000102', NULL, NULL, 'Actin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151424, NULL, 'G3DSA:3.80.10.10:FF:001488', NULL, NULL, 'Receptor-like protein EIX1', NULL, NULL, NULL, NULL, NULL, 4),
(151425, NULL, 'G3DSA:1.20.1310.20:FF:000013', NULL, NULL, 'Erythrocyte binding ligand-1', NULL, NULL, NULL, NULL, NULL, 4),
(151426, NULL, 'G3DSA:2.40.30.270:FF:000017', NULL, NULL, 'YALI0B06897p', NULL, NULL, NULL, NULL, NULL, 4),
(151427, NULL, 'G3DSA:3.30.460.10:FF:000203', NULL, NULL, 'Gsl0787 protein', NULL, NULL, NULL, NULL, NULL, 4),
(151428, NULL, 'G3DSA:1.20.920.30:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151429, NULL, 'G3DSA:3.90.640.10:FF:000041', NULL, NULL, 'Actin-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(151430, NULL, 'G3DSA:3.80.10.10:FF:000078', NULL, NULL, 'Leiomodin 3', NULL, NULL, NULL, NULL, NULL, 4),
(151431, NULL, 'G3DSA:3.40.50.1370:FF:000015', NULL, NULL, 'ornithine carbamoyltransferase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(151432, NULL, 'G3DSA:3.30.40.10:FF:001801', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151433, NULL, 'G3DSA:3.50.7.10:FF:000033', NULL, NULL, 'T-complex protein 1 subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(151434, NULL, 'G3DSA:1.20.120.1080:FF:000014', NULL, NULL, 'Probable ATP-dependent RNA helicase DHX37', NULL, NULL, NULL, NULL, NULL, 4),
(151435, NULL, 'G3DSA:2.30.30.770:FF:000001', NULL, NULL, '60S ribosomal protein L27', NULL, NULL, NULL, NULL, NULL, 4),
(151436, NULL, 'G3DSA:1.20.1740.10:FF:000060', NULL, NULL, 'S-methylmethionine permease', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(151437, NULL, 'G3DSA:3.40.50.410:FF:000195', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(151438, NULL, 'G3DSA:3.30.40.10:FF:000441', NULL, NULL, 'Neuralized, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(151439, NULL, 'G3DSA:2.130.10.10:FF:002718', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151440, NULL, 'G3DSA:2.60.40.10:FF:005046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151441, NULL, 'G3DSA:1.20.1250.20:FF:002380', NULL, NULL, 'Facilitated trehalose transporter Tret1-2 homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(151442, NULL, 'G3DSA:2.130.10.10:FF:001308', NULL, NULL, 'Mitotic checkpoint protein BUB3', NULL, NULL, NULL, NULL, NULL, 4),
(151443, NULL, 'G3DSA:3.40.50.2300:FF:000890', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151444, NULL, 'G3DSA:1.10.510.10:FF:002440', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151445, NULL, 'G3DSA:1.10.8.270:FF:000054', NULL, NULL, 'GTPase-activating protein gyp3', NULL, NULL, NULL, NULL, NULL, 4),
(151446, NULL, 'G3DSA:2.40.170.20:FF:000067', NULL, NULL, 'TonB-dependent receptor', NULL, NULL, NULL, NULL, NULL, 4),
(151447, NULL, 'G3DSA:2.130.10.10:FF:004394', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151448, NULL, 'G3DSA:2.170.120.30:FF:000008', NULL, NULL, 'YbbR-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(151449, NULL, 'G3DSA:3.90.320.10:FF:000062', NULL, NULL, 'Bifunctional ATP-dependent DNA helicase/ssDNA endodeoxyribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(151450, NULL, 'G3DSA:3.40.30.10:FF:000182', NULL, NULL, 'Thioredoxin reductase', NULL, NULL, NULL, NULL, NULL, 4),
(151451, NULL, 'G3DSA:2.130.10.10:FF:004214', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(151452, NULL, 'G3DSA:3.30.420.150:FF:000023', NULL, NULL, 'Bifunctional 3-dehydroquinate synthase/phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(151453, NULL, 'G3DSA:3.80.10.10:FF:000971', NULL, NULL, 'Leucine-rich repeat serine/threonine-protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(151454, NULL, 'G3DSA:3.60.20.10:FF:000186', NULL, NULL, 'Acyl-homoserine lactone acylase PvdQ', NULL, NULL, NULL, NULL, NULL, 4),
(151455, NULL, 'G3DSA:2.60.40.10:FF:005759', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151456, NULL, 'G3DSA:1.25.10.10:FF:001316', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151457, NULL, 'G3DSA:1.10.472.10:FF:000597', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151458, NULL, 'G3DSA:2.60.40.10:FF:006035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151459, NULL, 'G3DSA:3.80.10.10:FF:004473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151460, NULL, 'G3DSA:1.10.287.70:FF:000493', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(151461, NULL, 'G3DSA:2.60.40.10:FF:003573', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151462, NULL, 'G3DSA:3.40.50.1460:FF:000042', NULL, NULL, 'HEAT repeat domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(151463, NULL, 'G3DSA:1.20.1070.10:FF:000536', NULL, NULL, 'Predicted novel alpha-adrenergic-like G-protein coupled receptor', NULL, NULL, NULL, NULL, NULL, 4),
(151464, NULL, 'G3DSA:2.10.110.10:FF:000236', NULL, NULL, 'Lim homeobox protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151465, NULL, 'G3DSA:3.30.1010.10:FF:000045', NULL, NULL, 'Ataxia telangiectasia mutated, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151466, NULL, 'G3DSA:3.40.50.1820:FF:000813', NULL, NULL, 'Pyoverdine synthetase D', NULL, NULL, NULL, NULL, NULL, 4),
(151467, NULL, 'G3DSA:1.20.960.30:FF:000004', NULL, NULL, 'Nuclear distribution protein PAC1', NULL, NULL, NULL, NULL, NULL, 4),
(151468, NULL, 'G3DSA:2.60.120.260:FF:000302', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(151469, NULL, 'G3DSA:1.10.1530.10:FF:000001', NULL, NULL, '2,3-diketo-L-gulonate reductase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(151470, NULL, 'G3DSA:1.10.1380.10:FF:000005', NULL, NULL, 'Kell blood group, metallo-endopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(151471, NULL, 'G3DSA:3.30.200.20:FF:000479', NULL, NULL, 'Putative inactive leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(151472, NULL, 'G3DSA:2.120.10.30:FF:000128', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(151473, NULL, 'G3DSA:3.40.50.300:FF:000858', NULL, NULL, 'Nickel import ATP-binding protein NikD', NULL, NULL, NULL, NULL, NULL, 4),
(151474, NULL, 'G3DSA:3.40.50.720:FF:002322', NULL, NULL, 'Probable 2-hydroxyacid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(151475, NULL, 'G3DSA:3.40.50.300:FF:000566', NULL, NULL, 'Signal recognition particle receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(151476, NULL, 'G3DSA:3.30.460.30:FF:000001', NULL, NULL, 'Glutamyl-tRNA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(151477, NULL, 'G3DSA:1.10.10.10:FF:001344', NULL, NULL, 'ESCRT-II subunit protein', NULL, NULL, NULL, NULL, NULL, 4),
(151478, NULL, 'G3DSA:3.90.740.10:FF:000054', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(151479, NULL, 'G3DSA:3.30.60.300:FF:000003', NULL, NULL, '60S ribosomal protein L10, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151480, NULL, 'G3DSA:1.10.10.10:FF:001687', NULL, NULL, 'Interferon regulatory factor like protein', NULL, NULL, NULL, NULL, NULL, 4),
(151481, NULL, 'G3DSA:2.60.120.200:FF:000571', NULL, NULL, 'Putative L-type lectin-domain containing receptor kinase V.8', NULL, NULL, NULL, NULL, NULL, 4),
(151482, NULL, 'G3DSA:1.10.10.10:FF:001636', NULL, NULL, 'Histone H1.2', NULL, NULL, NULL, NULL, NULL, 4),
(151483, NULL, 'G3DSA:3.30.70.330:FF:002740', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151484, NULL, 'G3DSA:3.30.60.30:FF:000038', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(151485, NULL, 'G3DSA:2.130.10.10:FF:001460', NULL, NULL, 'COMPASS-like H3K4 histone methylase component WDR5B', NULL, NULL, NULL, NULL, NULL, 4),
(151486, NULL, 'G3DSA:2.130.10.10:FF:002365', NULL, NULL, 'GM25543', NULL, NULL, NULL, NULL, NULL, 4),
(151487, NULL, 'G3DSA:2.60.40.10:FF:004478', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151488, NULL, 'G3DSA:3.40.50.300:FF:002371', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(151489, NULL, 'G3DSA:2.60.120.260:FF:000010', NULL, NULL, 'Laminin subunit beta 1', NULL, NULL, NULL, NULL, NULL, 4),
(151490, NULL, 'G3DSA:3.40.1500.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151491, NULL, 'G3DSA:2.20.110.10:FF:000003', NULL, NULL, 'Junctophilin', NULL, NULL, NULL, NULL, NULL, 4),
(151492, NULL, 'G3DSA:1.25.40.20:FF:001552', NULL, NULL, 'Os09g0343200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(151493, NULL, 'G3DSA:3.40.50.300:FF:006294', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(151494, NULL, 'G3DSA:1.20.1560.10:FF:000736', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151495, NULL, 'G3DSA:1.10.510.10:FF:000883', NULL, NULL, 'Tau TuBulin Kinase', NULL, NULL, NULL, NULL, NULL, 4),
(151496, NULL, 'G3DSA:1.25.40.10:FF:002504', NULL, NULL, 'SART-3/p110 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(151497, NULL, 'G3DSA:2.10.110.10:FF:000287', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(151498, NULL, 'G3DSA:3.60.20.10:FF:000135', NULL, NULL, 'Acyl-homoserine lactone acylase QuiP', NULL, NULL, NULL, NULL, NULL, 4),
(151499, NULL, 'G3DSA:3.20.70.20:FF:000019', NULL, NULL, 'Anaerobic ribonucleoside-triphosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(151500, NULL, 'G3DSA:3.60.10.10:FF:000360', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151501, NULL, 'G3DSA:1.25.10.10:FF:001367', NULL, NULL, 'Nuclear transport factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151502, NULL, 'G3DSA:3.30.40.10:FF:002257', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(151503, NULL, 'G3DSA:1.20.1070.10:FF:000087', NULL, NULL, 'prostaglandin E2 receptor EP3 subtype', NULL, NULL, NULL, NULL, NULL, 4),
(151504, NULL, 'G3DSA:3.50.50.60:FF:001338', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151505, NULL, 'G3DSA:1.10.287.110:FF:000095', NULL, NULL, 'DnaJ domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(151506, NULL, 'G3DSA:3.30.160.60:FF:001605', NULL, NULL, 'Zinc finger protein 646', NULL, NULL, NULL, NULL, NULL, 4),
(151507, NULL, 'G3DSA:1.20.1270.280:FF:000072', NULL, NULL, 'Dynein heavy chain 3', NULL, NULL, NULL, NULL, NULL, 4),
(151508, NULL, 'G3DSA:3.40.50.300:FF:004748', NULL, NULL, 'Os02g0684150 protein', NULL, NULL, NULL, NULL, NULL, 4),
(151509, NULL, 'G3DSA:3.30.930.10:FF:000099', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(151510, NULL, 'G3DSA:4.10.60.10:FF:000087', NULL, NULL, 'Protein CBG24470', NULL, NULL, NULL, NULL, NULL, 4),
(151511, NULL, 'G3DSA:2.40.30.60:FF:000002', NULL, NULL, '16S rRNA processing protein RimM family', NULL, NULL, NULL, NULL, NULL, 4),
(151512, NULL, 'G3DSA:3.90.79.10:FF:000027', NULL, NULL, 'nucleoside diphosphate-linked moiety X motif 6', NULL, NULL, NULL, NULL, NULL, 4),
(151513, NULL, 'G3DSA:3.30.420.40:FF:000917', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151514, NULL, 'G3DSA:3.30.70.330:FF:000435', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(151515, NULL, 'G3DSA:3.90.105.20:FF:000008', NULL, NULL, 'Ribosome assembly factor mrt4', NULL, NULL, NULL, NULL, NULL, 4),
(151516, NULL, 'G3DSA:3.90.660.10:FF:000053', NULL, NULL, 'Amine oxidase family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(151517, NULL, 'G3DSA:3.30.160.60:FF:001701', NULL, NULL, 'zinc finger protein 777', NULL, NULL, NULL, NULL, NULL, 4),
(151518, NULL, 'G3DSA:3.30.40.10:FF:000941', NULL, NULL, 'Ring finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151519, NULL, 'G3DSA:2.60.450.10:FF:000020', NULL, NULL, 'Lipopolysaccharide export system protein LptC', NULL, NULL, NULL, NULL, NULL, 4),
(151520, NULL, 'G3DSA:1.20.1420.10:FF:000013', NULL, NULL, 'Rhea, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(151521, NULL, 'G3DSA:2.40.100.10:FF:000083', NULL, NULL, 'Putative cyclophilin 8', NULL, NULL, NULL, NULL, NULL, 4),
(151522, NULL, 'G3DSA:2.60.220.50:FF:000065', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(151523, NULL, 'G3DSA:3.20.20.100:FF:000123', NULL, NULL, 'Aflatoxin B1 aldehyde reductase member 2', NULL, NULL, NULL, NULL, NULL, 4),
(151524, NULL, 'G3DSA:2.60.120.1440:FF:000009', NULL, NULL, 'Regulatory protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151525, NULL, 'G3DSA:3.10.110.10:FF:000350', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(151526, NULL, 'G3DSA:3.40.50.40:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151527, NULL, 'G3DSA:3.10.20.310:FF:000042', NULL, NULL, 'Outer membrane protein assembly factor BamA', NULL, NULL, NULL, NULL, NULL, 4),
(151528, NULL, 'G3DSA:3.30.160.60:FF:001313', NULL, NULL, 'Zinc finger protein 155', NULL, NULL, NULL, NULL, NULL, 4),
(151529, NULL, 'G3DSA:2.70.150.10:FF:000051', NULL, NULL, 'Phospholipid-transporting ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151530, NULL, 'G3DSA:2.40.50.140:FF:001146', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151531, NULL, 'G3DSA:3.90.550.50:FF:000096', NULL, NULL, 'GM18190', NULL, NULL, NULL, NULL, NULL, 4),
(151532, NULL, 'G3DSA:2.60.120.200:FF:000520', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151533, NULL, 'G3DSA:1.10.630.10:FF:000419', NULL, NULL, 'Cytochrome P450 monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151534, NULL, 'G3DSA:2.60.40.1930:FF:000022', NULL, NULL, 'Complement C4', NULL, NULL, NULL, NULL, NULL, 4),
(151535, NULL, 'G3DSA:3.60.15.10:FF:000056', NULL, NULL, 'integrator complex subunit 9', NULL, NULL, NULL, NULL, NULL, 4),
(151536, NULL, 'G3DSA:3.50.50.60:FF:001046', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] flavoprotein subunit 1 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(151537, NULL, 'G3DSA:3.90.190.10:FF:000180', NULL, NULL, 'Protein tyrosine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(151538, NULL, 'G3DSA:3.40.50.300:FF:008059', NULL, NULL, 'Arf-GAP with GTPase, ANK repeat and PH domain-containing protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(151539, NULL, 'G3DSA:1.20.1270.60:FF:000330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151540, NULL, 'G3DSA:3.40.50.11610:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151541, NULL, 'G3DSA:1.20.1280.50:FF:000007', NULL, NULL, 'F-box/LRR-repeat protein 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(151542, NULL, 'G3DSA:2.160.10.10:FF:000048', NULL, NULL, 'Serine acetyltransferase-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(151543, NULL, 'G3DSA:2.60.40.10:FF:003522', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151544, NULL, 'G3DSA:3.30.1010.10:FF:000096', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151545, NULL, 'G3DSA:3.40.47.10:FF:000237', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151546, NULL, 'G3DSA:3.90.470.20:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151547, NULL, 'G3DSA:3.90.70.40:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151548, NULL, 'G3DSA:3.40.50.300:FF:000807', NULL, NULL, 'galactosylceramide sulfotransferase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(151549, NULL, 'G3DSA:2.60.120.10:FF:000208', NULL, NULL, 'Catabolite gene activator', NULL, NULL, NULL, NULL, NULL, 4),
(151550, NULL, 'G3DSA:2.60.40.10:FF:000296', NULL, NULL, 'Tyrosine-protein kinase receptor TYRO3', NULL, NULL, NULL, NULL, NULL, 4),
(151551, NULL, 'G3DSA:1.10.10.60:FF:000229', NULL, NULL, 'Homeobox-leucine zipper protein HDG1', NULL, NULL, NULL, NULL, NULL, 4),
(151552, NULL, 'G3DSA:4.10.640.10:FF:000004', NULL, NULL, '30S ribosomal protein S18', NULL, NULL, NULL, NULL, NULL, 4),
(151553, NULL, 'G3DSA:2.130.10.10:FF:000920', NULL, NULL, 'WD repeat-containing protein 92', NULL, NULL, NULL, NULL, NULL, 4),
(151554, NULL, 'G3DSA:3.30.710.10:FF:000329', NULL, NULL, 'Rho-related BTB domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(151555, NULL, 'G3DSA:3.30.160.60:FF:004478', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151556, NULL, 'G3DSA:2.60.40.150:FF:000732', NULL, NULL, 'Putative U5 small nuclear ribonucleoprotein 200 kDa helicase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(151557, NULL, 'G3DSA:3.30.40.10:FF:002206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151558, NULL, 'G3DSA:1.10.10.60:FF:000049', NULL, NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily A member', NULL, NULL, NULL, NULL, NULL, 4),
(151559, NULL, 'G3DSA:1.20.58.760:FF:000024', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(151560, NULL, 'G3DSA:2.60.120.330:FF:000059', NULL, NULL, '1-aminocyclopropane-1-carboxylate oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(151561, NULL, 'G3DSA:3.40.50.80:FF:000125', NULL, NULL, 'Flavohemoglobin', NULL, NULL, NULL, NULL, NULL, 4),
(151562, NULL, 'G3DSA:2.60.120.200:FF:000419', NULL, NULL, 'Laminin, alpha 5', NULL, NULL, NULL, NULL, NULL, 4),
(151563, NULL, 'G3DSA:1.20.5.1160:FF:000042', NULL, NULL, 'Coiled-coil domain-containing 136b', NULL, NULL, NULL, NULL, NULL, 4),
(151564, NULL, 'G3DSA:1.10.1520.10:FF:000124', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(151565, NULL, 'G3DSA:3.20.20.70:FF:000458', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151566, NULL, 'G3DSA:1.10.246.140:FF:000005', NULL, NULL, 'Transcription and mRNA export factor ENY2', NULL, NULL, NULL, NULL, NULL, 4),
(151567, NULL, 'G3DSA:3.10.100.10:FF:000405', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151568, NULL, 'G3DSA:3.40.190.190:FF:000001', NULL, NULL, 'High affinity transport system protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(151569, NULL, 'G3DSA:1.25.40.20:FF:000124', NULL, NULL, 'NF-kappa-B inhibitor alpha isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(151570, NULL, 'G3DSA:3.40.30.10:FF:000974', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(151571, NULL, 'G3DSA:3.30.590.10:FF:000027', NULL, NULL, 'Glutamine synthetase III', NULL, NULL, NULL, NULL, NULL, 4),
(151572, NULL, 'G3DSA:3.40.50.970:FF:000126', NULL, NULL, 'Phosphonopyruvate decarboxylase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(151573, NULL, 'G3DSA:3.40.50.720:FF:002373', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151574, NULL, 'G3DSA:3.40.50.150:FF:000448', NULL, NULL, 'SAM-dependent methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(151575, NULL, 'G3DSA:3.30.160.60:FF:003910', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151576, NULL, 'G3DSA:3.90.190.10:FF:000028', NULL, NULL, 'Dual specificity phosphatase 10', NULL, NULL, NULL, NULL, NULL, 4),
(151577, NULL, 'G3DSA:3.40.50.300:FF:004169', NULL, NULL, 'Atlastin 3', NULL, NULL, NULL, NULL, NULL, 4),
(151578, NULL, 'G3DSA:3.30.420.40:FF:000125', NULL, NULL, 'Chaperone protein DnaK 1', NULL, NULL, NULL, NULL, NULL, 4),
(151579, NULL, 'G3DSA:3.80.10.10:FF:000527', NULL, NULL, 'Serine/threonine kinase 11 interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(151580, NULL, 'G3DSA:2.40.20.10:FF:000094', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(151581, NULL, 'G3DSA:3.40.50.150:FF:000499', NULL, NULL, 'rRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(151582, NULL, 'G3DSA:3.10.10.10:FF:000002', NULL, NULL, 'Retrovirus-related Pol polyprotein from transposon 17.6-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(151583, NULL, 'G3DSA:1.25.40.180:FF:000021', NULL, NULL, 'Nuclear cap binding protein subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(151584, NULL, 'G3DSA:1.10.1330.10:FF:000002', NULL, NULL, 'S8 family serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(151585, NULL, 'G3DSA:1.10.730.10:FF:000163', NULL, NULL, 'Methionine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(151586, NULL, 'G3DSA:3.40.50.1820:FF:000072', NULL, NULL, 'Serine carboxypeptidase-like 19', NULL, NULL, NULL, NULL, NULL, 4),
(151587, NULL, 'G3DSA:1.25.10.10:FF:000086', NULL, NULL, 'protein zyg-11 homolog B isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(151588, NULL, 'G3DSA:3.90.1150.10:FF:000244', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(151589, NULL, 'G3DSA:3.30.230.10:FF:000074', NULL, NULL, 'DNA mismatch repair protein (Pms1)', NULL, NULL, NULL, NULL, NULL, 4),
(151590, NULL, 'G3DSA:3.40.367.20:FF:000009', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(151591, NULL, 'G3DSA:1.10.287.70:FF:000150', NULL, NULL, 'Two pore potassium channel c', NULL, NULL, NULL, NULL, NULL, 4),
(151592, NULL, 'G3DSA:1.20.1070.10:FF:000980', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151593, NULL, 'G3DSA:1.10.472.10:FF:000546', NULL, NULL, 'Cyclin T2', NULL, NULL, NULL, NULL, NULL, 4),
(151594, NULL, 'G3DSA:2.60.40.420:FF:000156', NULL, NULL, 'Aspergillus niger contig An12c0160, genomic contig', NULL, NULL, NULL, NULL, NULL, 4),
(151595, NULL, 'G3DSA:3.30.310.40:FF:000004', NULL, NULL, 'Ogg1p', NULL, NULL, NULL, NULL, NULL, 4),
(151596, NULL, 'G3DSA:2.60.40.150:FF:000783', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(151597, NULL, 'G3DSA:2.10.25.10:FF:000302', NULL, NULL, 'latent-transforming growth factor beta-binding protein 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(151598, NULL, 'G3DSA:1.20.58.60:FF:000294', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(151599, NULL, 'G3DSA:3.90.550.10:FF:000275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151600, NULL, 'G3DSA:2.30.42.10:FF:000280', NULL, NULL, 'Big bang, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(151601, NULL, 'G3DSA:3.80.10.10:FF:002556', NULL, NULL, 'YALI0A17358p', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(151602, NULL, 'G3DSA:2.120.10.30:FF:000207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151603, NULL, 'G3DSA:3.40.50.1000:FF:000831', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151604, NULL, 'G3DSA:1.25.10.10:FF:000827', NULL, NULL, 'Importin alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151605, NULL, 'G3DSA:3.30.160.60:FF:000296', NULL, NULL, 'Zinc fingers and homeoboxes protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(151606, NULL, 'G3DSA:3.30.450.190:FF:000001', NULL, NULL, 'Ras-related GTP-binding protein C', NULL, NULL, NULL, NULL, NULL, 4),
(151607, NULL, 'G3DSA:3.30.70.260:FF:000066', NULL, NULL, 'Chorismate mutase/prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(151608, NULL, 'G3DSA:3.60.15.10:FF:000005', NULL, NULL, 'Cleavage and polyadenylation specificity factor subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(151609, NULL, 'G3DSA:1.25.40.10:FF:004842', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(151610, NULL, 'G3DSA:1.10.287.770:FF:000006', NULL, NULL, 'acid-sensing ion channel 2', NULL, NULL, NULL, NULL, NULL, 4),
(151611, NULL, 'G3DSA:3.40.50.1010:FF:000216', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151612, NULL, 'G3DSA:3.40.50.1460:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151613, NULL, 'G3DSA:1.20.1540.10:FF:000061', NULL, NULL, 'Rhomboid-6, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(151614, NULL, 'G3DSA:1.10.8.60:FF:000240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151615, NULL, 'G3DSA:3.30.420.10:FF:000633', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151616, NULL, 'G3DSA:1.20.144.10:FF:000102', NULL, NULL, 'Putative phosphatidate phosphatase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(151617, NULL, 'G3DSA:1.50.40.10:FF:000563', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151618, NULL, 'G3DSA:3.30.200.20:FF:000428', NULL, NULL, 'Inactive LRR receptor-like serine/threonine-protein kinase BIR2', NULL, NULL, NULL, NULL, NULL, 4),
(151619, NULL, 'G3DSA:3.40.50.1910:FF:000008', NULL, NULL, 'vacuolar protein sorting-associated protein 33A isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(151620, NULL, 'G3DSA:4.10.1000.40:FF:000001', NULL, NULL, 'zinc finger CCCH domain-containing protein 14 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(151621, NULL, 'G3DSA:3.40.50.620:FF:000252', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(151622, NULL, 'G3DSA:2.10.25.10:FF:000662', NULL, NULL, 'Eyes shut, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(151623, NULL, 'G3DSA:1.10.555.10:FF:000233', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151624, NULL, 'G3DSA:3.30.70.330:FF:002791', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151625, NULL, 'G3DSA:1.10.150.50:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151626, NULL, 'G3DSA:3.30.450.20:FF:000138', NULL, NULL, 'VWFA and cache domain-containing protein CG16868', NULL, NULL, NULL, NULL, NULL, 4),
(151627, NULL, 'G3DSA:1.10.510.10:FF:003345', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151628, NULL, 'G3DSA:1.10.260.100:FF:000011', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(151629, NULL, 'G3DSA:1.10.510.10:FF:000523', NULL, NULL, 'Serine/threonine-protein kinase PITSLRE', NULL, NULL, NULL, NULL, NULL, 4),
(151630, NULL, 'G3DSA:2.170.200.10:FF:000003', NULL, NULL, 'Regulatory protein E2', NULL, NULL, NULL, NULL, NULL, 4),
(151631, NULL, 'G3DSA:3.30.420.40:FF:000176', NULL, NULL, 'Chromatin remodeling complex subunit (Arp5)', NULL, NULL, NULL, NULL, NULL, 4),
(151632, NULL, 'G3DSA:3.40.190.10:FF:000606', NULL, NULL, 'Sll0224 protein', NULL, NULL, NULL, NULL, NULL, 4),
(151633, NULL, 'G3DSA:1.10.510.10:FF:000815', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151634, NULL, 'G3DSA:3.30.160.60:FF:005124', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(151635, NULL, 'G3DSA:3.50.50.60:FF:000557', NULL, NULL, 'Pyridine nucleotide-disulfide oxidoreductase/Thi4 family/FAD dependent oxidoreductase/NAD(P)-binding Rossmann-like domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151636, NULL, 'G3DSA:3.90.650.10:FF:000047', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(151637, NULL, 'G3DSA:1.10.8.1210:FF:000003', NULL, NULL, 'Glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(151638, NULL, 'G3DSA:3.40.50.1820:FF:000633', NULL, NULL, '2-oxoglutarate decarboxylase/hydro-lyase/magnesium ion-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(151639, NULL, 'G3DSA:3.40.50.720:FF:000248', NULL, NULL, 'Glucose 1-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(151640, NULL, 'G3DSA:1.10.510.10:FF:002889', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151641, NULL, 'G3DSA:2.30.30.490:FF:000007', NULL, NULL, 'bromo adjacent homology domain-containing 1 protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(151642, NULL, 'G3DSA:1.20.1070.10:FF:000648', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(151643, NULL, 'G3DSA:3.90.1410.10:FF:000051', NULL, NULL, 'SET (Trithorax/polycomb) domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(151644, NULL, 'G3DSA:3.50.30.30:FF:000108', NULL, NULL, 'AER157Cp', NULL, NULL, NULL, NULL, NULL, 4),
(151645, NULL, 'G3DSA:3.40.50.150:FF:000824', NULL, NULL, 'Transferase', NULL, NULL, NULL, NULL, NULL, 4),
(151646, NULL, 'G3DSA:2.40.10.10:FF:000306', NULL, NULL, 'IP19845p', NULL, NULL, NULL, NULL, NULL, 4),
(151647, NULL, 'G3DSA:3.40.50.1700:FF:000002', NULL, NULL, 'Glycosyl hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(151648, NULL, 'G3DSA:3.20.20.140:FF:000056', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(151649, NULL, 'G3DSA:1.10.10.60:FF:001005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151650, NULL, 'G3DSA:3.40.140.10:FF:000042', NULL, NULL, 'Mov34/MPN/PAD-1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(151651, NULL, 'G3DSA:3.40.50.720:FF:001833', NULL, NULL, 'Bone marrow stromal cell antigen 1', NULL, NULL, NULL, NULL, NULL, 4),
(151652, NULL, 'G3DSA:1.10.1410.10:FF:000003', NULL, NULL, 'non-canonical poly(A) RNA polymerase PAPD7', NULL, NULL, NULL, NULL, NULL, 4),
(151653, NULL, 'G3DSA:3.90.25.10:FF:000027', NULL, NULL, 'dTDP-glucose 4,6-dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(151654, NULL, 'G3DSA:2.130.10.10:FF:002426', NULL, NULL, 'Uncharacterized protein AT4g01860', NULL, NULL, NULL, NULL, NULL, 4),
(151655, NULL, 'G3DSA:3.40.50.300:FF:007093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151656, NULL, 'G3DSA:1.10.238.10:FF:000783', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151657, NULL, 'G3DSA:2.130.10.150:FF:000001', NULL, NULL, 'Acylamino-acid-releasing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(151658, NULL, 'G3DSA:3.30.1370.10:FF:000066', NULL, NULL, 'KH domain containing 4, pre-mRNA splicing factor', NULL, NULL, NULL, NULL, NULL, 4),
(151659, NULL, 'G3DSA:2.30.29.30:FF:000614', NULL, NULL, 'Guanine nucleotide exchange factor UNC-73A', NULL, NULL, NULL, NULL, NULL, 4),
(151660, NULL, 'G3DSA:3.90.79.10:FF:000207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151661, NULL, 'G3DSA:3.30.70.330:FF:002801', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151662, NULL, 'G3DSA:3.80.10.10:FF:000319', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(151663, NULL, 'G3DSA:1.10.238.10:FF:000839', NULL, NULL, 'Polcalcin Cup a 4', NULL, NULL, NULL, NULL, NULL, 4),
(151664, NULL, 'G3DSA:2.70.170.10:FF:000254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151665, NULL, 'G3DSA:2.60.40.10:FF:001364', NULL, NULL, 'Interleukin 23 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(151666, NULL, 'G3DSA:1.10.533.10:FF:000216', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 6', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(151667, NULL, 'G3DSA:1.20.1070.10:FF:002161', NULL, NULL, 'C1A receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151668, NULL, 'G3DSA:1.25.40.10:FF:001083', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(151669, NULL, 'G3DSA:3.40.50.300:FF:003388', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151670, NULL, 'G3DSA:2.130.10.10:FF:004574', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(151671, NULL, 'G3DSA:3.20.20.80:FF:000787', NULL, NULL, 'Membrane-bound maltase-glucoamylase', NULL, NULL, NULL, NULL, NULL, 4),
(151672, NULL, 'G3DSA:3.30.160.60:FF:005708', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151673, NULL, 'G3DSA:1.10.510.10:FF:001372', NULL, NULL, 'eIF-2 alpha kinase', NULL, NULL, NULL, NULL, NULL, 4),
(151674, NULL, 'G3DSA:3.20.19.10:FF:000010', NULL, NULL, 'Aconitate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(151675, NULL, 'G3DSA:3.30.70.330:FF:000615', NULL, NULL, 'Os09g0374500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(151676, NULL, 'G3DSA:3.40.720.10:FF:000300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151677, NULL, 'G3DSA:3.30.420.40:FF:000737', NULL, NULL, 'Actin-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(151678, NULL, 'G3DSA:2.170.210.10:FF:000009', NULL, NULL, 'Xrcc4-like factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(151679, NULL, 'G3DSA:1.25.40.20:FF:001765', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(151680, NULL, 'G3DSA:2.60.40.4370:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151681, NULL, 'G3DSA:2.60.40.10:FF:002792', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151682, NULL, 'G3DSA:1.25.40.10:FF:005034', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At1g12700, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(151683, NULL, 'G3DSA:2.70.160.11:FF:000053', NULL, NULL, 'Protein arginine N-methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(151684, NULL, 'G3DSA:3.40.850.10:FF:000169', NULL, NULL, 'Kinesin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151685, NULL, 'G3DSA:1.10.238.10:FF:000098', NULL, NULL, 'calcium-binding mitochondrial carrier protein SCaMC-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(151686, NULL, 'G3DSA:3.20.180.20:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151687, NULL, 'G3DSA:1.10.10.1230:FF:000003', NULL, NULL, 'Penicillin-binding protein H', NULL, NULL, NULL, NULL, NULL, 4),
(151688, NULL, 'G3DSA:3.90.190.20:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151689, NULL, 'G3DSA:2.40.50.140:FF:000365', NULL, NULL, 'Lysine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(151690, NULL, 'G3DSA:3.40.50.620:FF:000201', NULL, NULL, 'Universal stress protein PHOS34', NULL, NULL, NULL, NULL, NULL, 4),
(151691, NULL, 'G3DSA:3.30.710.10:FF:000116', NULL, NULL, 'SLX4 structure-specific endonuclease subunit', NULL, NULL, NULL, NULL, NULL, 4),
(151692, NULL, 'G3DSA:3.20.20.100:FF:000044', NULL, NULL, 'Aldose reductase', NULL, NULL, NULL, NULL, NULL, 4),
(151693, NULL, 'G3DSA:1.10.150.530:FF:000002', NULL, NULL, 'Probable dual-specificity RNA methyltransferase RlmN', NULL, NULL, NULL, NULL, NULL, 4),
(151694, NULL, 'G3DSA:3.10.20.10:FF:000008', NULL, NULL, 'Cell death inducing DFFA like effector a', NULL, NULL, NULL, NULL, NULL, 4),
(151695, NULL, 'G3DSA:2.60.120.200:FF:000751', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(151696, NULL, 'G3DSA:2.60.40.290:FF:000009', NULL, NULL, 'Beta-N-acetylhexosaminidase HexB', NULL, NULL, NULL, NULL, NULL, 4),
(151697, NULL, 'G3DSA:3.40.50.720:FF:000405', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(151698, NULL, 'G3DSA:3.40.50.1100:FF:000131', NULL, NULL, 'Diaminopropionate ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(151699, NULL, 'G3DSA:2.130.10.10:FF:005563', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(151700, NULL, 'G3DSA:2.70.70.10:FF:000062', NULL, NULL, 'Membrane protein related to metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(151701, NULL, 'G3DSA:2.60.40.10:FF:004978', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151702, NULL, 'G3DSA:3.30.1490.70:FF:000003', NULL, NULL, 'Probable ATP-dependent DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(151703, NULL, 'G3DSA:1.10.472.10:FF:000658', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151704, NULL, 'G3DSA:2.60.40.1180:FF:000100', NULL, NULL, 'Alpha-L-fucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(151705, NULL, 'G3DSA:1.20.5.190:FF:000090', NULL, NULL, 'Abnormal spindle microtubule assembly', NULL, NULL, NULL, NULL, NULL, 4),
(151706, NULL, 'G3DSA:1.25.10.10:FF:003441', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151707, NULL, 'G3DSA:2.10.110.10:FF:000005', NULL, NULL, 'Testin isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(151708, NULL, 'G3DSA:3.40.50.620:FF:000044', NULL, NULL, 'GMP synthase [glutamine-hydrolyzing]', NULL, NULL, NULL, NULL, NULL, 4),
(151709, NULL, 'G3DSA:2.60.40.1180:FF:000196', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(151710, NULL, 'G3DSA:3.40.50.300:FF:006373', NULL, NULL, 'Replication factor C subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(151711, NULL, 'G3DSA:3.80.10.10:FF:000471', NULL, NULL, 'Leucine rich repeat containing 29', NULL, NULL, NULL, NULL, NULL, 4),
(151712, NULL, 'G3DSA:2.60.40.150:FF:000283', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(151713, NULL, 'G3DSA:3.30.40.10:FF:000048', NULL, NULL, 'nucleosome-remodeling factor subunit BPTF isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(151714, NULL, 'G3DSA:3.30.40.10:FF:002178', NULL, NULL, 'Ring finger protein 112, gene 2', NULL, NULL, NULL, NULL, NULL, 4),
(151715, NULL, 'G3DSA:1.25.40.20:FF:001181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151716, NULL, 'G3DSA:3.30.450.40:FF:000245', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(151717, NULL, 'G3DSA:1.25.40.10:FF:002425', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g22830', NULL, NULL, NULL, NULL, NULL, 4),
(151718, NULL, 'G3DSA:3.40.50.300:FF:001314', NULL, NULL, 'DNA replication licensing factor MCM8', NULL, NULL, NULL, NULL, NULL, 4),
(151719, NULL, 'G3DSA:3.80.10.10:FF:002505', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151720, NULL, 'G3DSA:1.25.10.10:FF:003284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151721, NULL, 'G3DSA:1.25.40.10:FF:003853', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151722, NULL, 'G3DSA:2.10.90.10:FF:000060', NULL, NULL, 'Spatzle 6', NULL, NULL, NULL, NULL, NULL, 4),
(151723, NULL, 'G3DSA:3.10.330.20:FF:000010', NULL, NULL, 'tRNA (adenine(58)-N(1))-methyltransferase catalytic subunit TRMT61A', NULL, NULL, NULL, NULL, NULL, 4),
(151724, NULL, 'G3DSA:2.130.10.10:FF:003433', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(151725, NULL, 'G3DSA:2.60.40.4240:FF:000001', NULL, NULL, 'Churchill domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(151726, NULL, 'G3DSA:3.30.70.141:FF:000014', NULL, NULL, 'Nucleoside diphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(151727, NULL, 'G3DSA:3.30.70.330:FF:002060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151728, NULL, 'G3DSA:3.40.50.12780:FF:000071', NULL, NULL, 'Long-chain-fatty-acid--ACP ligase MbtM', NULL, NULL, NULL, NULL, NULL, 4),
(151729, NULL, 'G3DSA:2.30.30.140:FF:000262', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(151730, NULL, 'G3DSA:3.40.50.300:FF:002983', NULL, NULL, 'Mtg2p', NULL, NULL, NULL, NULL, NULL, 4),
(151731, NULL, 'G3DSA:3.40.50.1820:FF:000313', NULL, NULL, '1-alkyl-2-acetylglycerophosphocholine esterase', NULL, NULL, NULL, NULL, NULL, 4),
(151732, NULL, 'G3DSA:2.20.100.10:FF:000126', NULL, NULL, 'Lonely heart, isoform A', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(151733, NULL, 'G3DSA:3.90.70.10:FF:000890', NULL, NULL, 'Type I protein secretion system bifunctional ATPase and permease component AggC', NULL, NULL, NULL, NULL, NULL, 4),
(151734, NULL, 'G3DSA:3.30.420.40:FF:000968', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(151735, NULL, 'G3DSA:2.60.120.200:FF:000363', NULL, NULL, 'Agrin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151736, NULL, 'G3DSA:3.40.50.620:FF:000432', NULL, NULL, 'Phosphoadenosine phosphosulfate reductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(151737, NULL, 'G3DSA:1.10.437.10:FF:000004', NULL, NULL, 'apoptosis regulator BAX isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(151738, NULL, 'G3DSA:3.30.160.60:FF:004186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151739, NULL, 'G3DSA:3.40.390.80:FF:000002', NULL, NULL, 'Metallprotease, enhancin', NULL, NULL, NULL, NULL, NULL, 4),
(151740, NULL, 'G3DSA:2.60.40.1760:FF:000010', NULL, NULL, 'Glucosidase II catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(151741, NULL, 'G3DSA:3.40.50.10810:FF:000249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151742, NULL, 'G3DSA:1.20.1560.10:FF:000523', NULL, NULL, 'AGAP004602-PA', NULL, NULL, NULL, NULL, NULL, 4),
(151743, NULL, 'G3DSA:3.30.200.20:FF:000136', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(151744, NULL, 'G3DSA:1.20.58.1120:FF:000024', NULL, NULL, 'Kl-2 1-beta dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(151745, NULL, 'G3DSA:3.30.540.30:FF:000002', NULL, NULL, 'Dipeptidyl peptidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(151746, NULL, 'G3DSA:1.20.1250.10:FF:000073', NULL, NULL, 'Growth hormone d24', NULL, NULL, NULL, NULL, NULL, 4),
(151747, NULL, 'G3DSA:3.30.40.10:FF:000380', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(151748, NULL, 'G3DSA:1.25.40.20:FF:001029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151749, NULL, 'G3DSA:1.10.490.60:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151750, NULL, 'G3DSA:2.60.40.2500:FF:000002', NULL, NULL, 'Type IV secretion system protein VirB9', NULL, NULL, NULL, NULL, NULL, 4),
(151751, NULL, 'G3DSA:3.80.10.10:FF:000639', NULL, NULL, 'Brassinosteroid LRR receptor kinase BRL3', NULL, NULL, NULL, NULL, NULL, 4),
(151752, NULL, 'G3DSA:1.10.287.130:FF:000022', NULL, NULL, 'Two-component sensor CbrA', NULL, NULL, NULL, NULL, NULL, 4),
(151753, NULL, 'G3DSA:2.10.25.10:FF:001730', NULL, NULL, 'Brevican', NULL, NULL, NULL, NULL, NULL, 4),
(151754, NULL, 'G3DSA:2.130.10.10:FF:003146', NULL, NULL, 'Outer segment 1', NULL, NULL, NULL, NULL, NULL, 4),
(151755, NULL, 'G3DSA:1.25.40.180:FF:000201', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151756, NULL, 'G3DSA:1.20.1280.50:FF:000058', NULL, NULL, 'OSJNBa0058K23.14 protein', NULL, NULL, NULL, NULL, NULL, 4),
(151757, NULL, 'G3DSA:3.20.140.10:FF:000024', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(151758, NULL, 'G3DSA:1.50.40.10:FF:000271', NULL, NULL, 'Mitochondrial dicarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151759, NULL, 'G3DSA:3.30.70.330:FF:000935', NULL, NULL, 'Hrb1p', NULL, NULL, NULL, NULL, NULL, 4),
(151760, NULL, 'G3DSA:3.30.420.40:FF:000417', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(151761, NULL, 'G3DSA:3.40.50.2300:FF:000007', NULL, NULL, 'Putative glutamate receptor ionotropic kainate 1', NULL, NULL, NULL, NULL, NULL, 4),
(151762, NULL, 'G3DSA:3.20.20.10:FF:000070', NULL, NULL, 'Zgc:162816', NULL, NULL, NULL, NULL, NULL, 4),
(151763, NULL, 'G3DSA:3.30.230.10:FF:000186', NULL, NULL, 'Phosphomevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(151764, NULL, 'G3DSA:3.40.930.10:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151765, NULL, 'G3DSA:1.20.1250.20:FF:001531', NULL, NULL, 'Facilitated trehalose transporter Tret1', NULL, NULL, NULL, NULL, NULL, 4),
(151766, NULL, 'G3DSA:3.30.497.10:FF:000001', NULL, NULL, 'Serine protease inhibitor', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(151767, NULL, 'G3DSA:3.20.20.20:FF:000016', NULL, NULL, '4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase (flavodoxin)', NULL, NULL, NULL, NULL, NULL, 4),
(151768, NULL, 'G3DSA:1.10.630.10:FF:000178', NULL, NULL, 'Cytochrome P450, family 2, subfamily N, polypeptide 13', NULL, NULL, NULL, NULL, NULL, 4),
(151769, NULL, 'G3DSA:3.80.10.10:FF:003276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151770, NULL, 'G3DSA:1.25.10.10:FF:000911', NULL, NULL, 'MMS19 nucleotide excision repair protein isogeny', NULL, NULL, NULL, NULL, NULL, 4),
(151771, NULL, 'G3DSA:2.60.40.2880:FF:000003', NULL, NULL, 'Conserved hypothetical threonine and proline rich protein', NULL, NULL, NULL, NULL, NULL, 4),
(151772, NULL, 'G3DSA:3.30.830.10:FF:000164', NULL, NULL, 'Os01g0779100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(151773, NULL, 'G3DSA:1.25.40.10:FF:004578', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151774, NULL, 'G3DSA:2.170.130.10:FF:000008', NULL, NULL, 'SusC/RagA family TonB-linked outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(151775, NULL, 'G3DSA:2.60.40.10:FF:003730', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(151776, NULL, 'G3DSA:3.30.1330.40:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151777, NULL, 'G3DSA:3.40.50.11060:FF:000010', NULL, NULL, 'GTPase HflX', NULL, NULL, NULL, NULL, NULL, 4),
(151778, NULL, 'G3DSA:3.30.200.20:FF:002284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151779, NULL, 'G3DSA:3.40.50.300:FF:004220', NULL, NULL, 'ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(151780, NULL, 'G3DSA:1.20.120.1750:FF:000086', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(151781, NULL, 'G3DSA:3.30.559.30:FF:000084', NULL, NULL, 'Nonribosomal peptide synthetase 8', NULL, NULL, NULL, NULL, NULL, 4),
(151782, NULL, 'G3DSA:1.25.10.10:FF:000535', NULL, NULL, 'Sxm1p', NULL, NULL, NULL, NULL, NULL, 4),
(151783, NULL, 'G3DSA:2.40.70.10:FF:000366', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151784, NULL, 'G3DSA:1.10.510.10:FF:004126', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151785, NULL, 'G3DSA:2.10.25.10:FF:000370', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(151786, NULL, 'G3DSA:3.90.550.10:FF:000567', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151787, NULL, 'G3DSA:1.20.120.1380:FF:000014', NULL, NULL, 'Flagellar biosynthesis protein FlhF', NULL, NULL, NULL, NULL, NULL, 4),
(151788, NULL, 'G3DSA:2.60.40.10:FF:000375', NULL, NULL, 'Sodium channel beta 1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(151789, NULL, 'G3DSA:3.40.850.10:FF:000045', NULL, NULL, 'Kinesin-like protein KIN-14I isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(151790, NULL, 'G3DSA:1.20.1560.10:FF:000236', NULL, NULL, 'p-GlycoProtein related', NULL, NULL, NULL, NULL, NULL, 4),
(151791, NULL, 'G3DSA:3.40.33.10:FF:000008', NULL, NULL, 'GLI pathogenesis-related 1 (Glioma)', NULL, NULL, NULL, NULL, NULL, 4),
(151792, NULL, 'G3DSA:1.20.1250.20:FF:000755', NULL, NULL, 'Vacuolar sorting protein', NULL, NULL, NULL, NULL, NULL, 4),
(151793, NULL, 'G3DSA:2.60.40.150:FF:000491', NULL, NULL, 'Synaptotagmin 15', NULL, NULL, NULL, NULL, NULL, 4),
(151794, NULL, 'G3DSA:1.10.357.10:FF:000003', NULL, NULL, 'HTH-type transcriptional regulator AcrR', NULL, NULL, NULL, NULL, NULL, 4),
(151795, NULL, 'G3DSA:4.10.240.10:FF:000075', NULL, NULL, 'Transcriptional regulatory protein moc3', NULL, NULL, NULL, NULL, NULL, 4),
(151796, NULL, 'G3DSA:1.20.1250.20:FF:000171', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(151797, NULL, 'G3DSA:2.40.30.70:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151798, NULL, 'G3DSA:3.40.220.10:FF:000043', NULL, NULL, 'Probable cytosol aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(151799, NULL, 'G3DSA:3.40.50.10420:FF:000059', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(151800, NULL, 'G3DSA:3.30.1510.10:FF:000010', NULL, NULL, 'C-1-tetrahydrofolate synthase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(151801, NULL, 'G3DSA:2.130.10.10:FF:001084', NULL, NULL, 'Phosphatidylinositol 3,5-bisphosphate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(151802, NULL, 'G3DSA:3.40.50.1820:FF:001038', NULL, NULL, 'cDNA clone:J013114C10, full insert sequence', NULL, NULL, NULL, NULL, NULL, 4),
(151803, NULL, 'G3DSA:3.40.50.150:FF:001016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151804, NULL, 'G3DSA:1.20.272.10:FF:000045', NULL, NULL, 'AGAP007477-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(151805, NULL, 'G3DSA:3.30.70.1170:FF:000025', NULL, NULL, 'NOP2/Sun RNA methyltransferase family member 5', NULL, NULL, NULL, NULL, NULL, 4),
(151806, NULL, 'G3DSA:3.40.630.30:FF:000220', NULL, NULL, 'Ribosomal-protein-serine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(151807, NULL, 'G3DSA:2.30.30.470:FF:000001', NULL, NULL, 'Putative DD-carboxypeptidase TP_0574', NULL, NULL, NULL, NULL, NULL, 4),
(151808, NULL, 'G3DSA:3.40.50.10190:FF:000119', NULL, NULL, 'BRCA1 C Terminus (BRCT) domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151809, NULL, 'G3DSA:1.10.10.60:FF:001073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151810, NULL, 'G3DSA:3.40.50.720:FF:001092', NULL, NULL, 'Probable dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(151811, NULL, 'G3DSA:1.20.58.60:FF:000586', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(151812, NULL, 'G3DSA:3.40.50.12780:FF:000183', NULL, NULL, 'Acetyl-CoA synthetase (Acetate-CoA ligase) carboxy-end (AcsA-4)', NULL, NULL, NULL, NULL, NULL, 4),
(151813, NULL, 'G3DSA:3.40.50.1780:FF:000020', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', NULL, NULL, NULL, NULL, NULL, 4),
(151814, NULL, 'G3DSA:3.40.50.1460:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151815, NULL, 'G3DSA:1.10.1450.10:FF:000180', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(151816, NULL, 'G3DSA:4.10.60.10:FF:000036', NULL, NULL, 'Gag polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(151817, NULL, 'G3DSA:3.40.1110.10:FF:000303', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151818, NULL, 'G3DSA:2.30.29.30:FF:000243', NULL, NULL, 'Pleckstrin 2', NULL, NULL, NULL, NULL, NULL, 4),
(151819, NULL, 'G3DSA:3.40.50.300:FF:002663', NULL, NULL, 'ABC transporter ATP-binding protein/permease', NULL, NULL, NULL, NULL, NULL, 4),
(151820, NULL, 'G3DSA:3.40.50.800:FF:000042', NULL, NULL, 'Unplaced genomic scaffold supercont1.23, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(151821, NULL, 'G3DSA:3.80.10.10:FF:004181', NULL, NULL, 'Os05g0105300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(151822, NULL, 'G3DSA:3.30.56.10:FF:000005', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(151823, NULL, 'G3DSA:3.30.870.10:FF:000009', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(151824, NULL, 'G3DSA:2.30.42.10:FF:000521', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151825, NULL, 'G3DSA:2.30.18.10:FF:000004', NULL, NULL, 'General transcription factor IIA 1', NULL, NULL, NULL, NULL, NULL, 4),
(151826, NULL, 'G3DSA:3.40.50.1820:FF:000521', NULL, NULL, 'Acetyl esterase (Acetylxylosidase)', NULL, NULL, NULL, NULL, NULL, 4),
(151827, NULL, 'G3DSA:1.25.40.20:FF:001260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151828, NULL, 'G3DSA:2.130.10.10:FF:001988', NULL, NULL, 'Putative WD-repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(151829, NULL, 'G3DSA:3.40.50.150:FF:000892', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151830, NULL, 'G3DSA:3.30.70.270:FF:000052', NULL, NULL, 'DNA repair protein REV1', NULL, NULL, NULL, NULL, NULL, 4),
(151831, NULL, 'G3DSA:3.80.10.10:FF:001831', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(151832, NULL, 'G3DSA:3.10.450.50:FF:000112', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(151833, NULL, 'G3DSA:1.50.40.10:FF:000063', NULL, NULL, 'Mitochondrial nicotinamide adenine dinucleotide transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(151834, NULL, 'G3DSA:1.25.40.20:FF:000984', NULL, NULL, 'Putative huntingtin interacting protein (HIP)', NULL, NULL, NULL, NULL, NULL, 4),
(151835, NULL, 'G3DSA:3.90.226.10:FF:000241', NULL, NULL, 'Enoyl-CoA hydratase/isomerase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(151836, NULL, 'G3DSA:3.30.428.10:FF:000078', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(151837, NULL, 'G3DSA:1.20.1560.10:FF:000787', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151838, NULL, 'G3DSA:3.40.30.10:FF:001042', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(151839, NULL, 'G3DSA:3.40.50.150:FF:000948', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151840, NULL, 'G3DSA:2.130.10.10:FF:004506', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151841, NULL, 'G3DSA:1.10.287.70:FF:000785', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151842, NULL, 'G3DSA:3.40.50.300:FF:005125', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(151843, NULL, 'G3DSA:2.40.30.10:FF:000369', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151844, NULL, 'G3DSA:2.60.40.2030:FF:000041', NULL, NULL, 'Adhesion G-protein coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(151845, NULL, 'G3DSA:2.60.210.10:FF:000075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151846, NULL, 'G3DSA:3.80.30.20:FF:000008', NULL, NULL, 'CDK5 regulatory subunit-associated protein 1 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(151847, NULL, 'G3DSA:3.40.30.10:FF:000766', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(151848, NULL, 'G3DSA:1.20.1250.20:FF:002048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151849, NULL, 'G3DSA:1.10.10.10:FF:000355', NULL, NULL, 'Putative transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(151850, NULL, 'G3DSA:1.20.120.350:FF:000272', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151851, NULL, 'G3DSA:3.40.50.620:FF:000168', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(151852, NULL, 'G3DSA:3.30.160.60:FF:004686', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151853, NULL, 'G3DSA:1.20.1070.10:FF:000480', NULL, NULL, 'G protein-coupled receptor 37', NULL, NULL, NULL, NULL, NULL, 4),
(151854, NULL, 'G3DSA:2.30.29.30:FF:001339', NULL, NULL, 'Protein tyrosine kinase 2 beta, a', NULL, NULL, NULL, NULL, NULL, 4),
(151855, NULL, 'G3DSA:2.60.40.60:FF:000406', NULL, NULL, 'Protocadherin 12', NULL, NULL, NULL, NULL, NULL, 4),
(151856, NULL, 'G3DSA:3.30.420.10:FF:000521', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151857, NULL, 'G3DSA:1.10.510.10:FF:000591', NULL, NULL, 'Serine protein kinase Sky1', NULL, NULL, NULL, NULL, NULL, 4),
(151858, NULL, 'G3DSA:3.40.630.10:FF:000473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151859, NULL, 'G3DSA:1.20.120.850:FF:000040', NULL, NULL, 'Helicase SWR1', NULL, NULL, NULL, NULL, NULL, 4),
(151860, NULL, 'G3DSA:1.20.58.1440:FF:000002', NULL, NULL, 'AFR652Wp', NULL, NULL, NULL, NULL, NULL, 4),
(151861, NULL, 'G3DSA:2.40.50.140:FF:000157', NULL, NULL, '39S ribosomal protein L2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(151862, NULL, 'G3DSA:2.60.40.10:FF:001544', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(151863, NULL, 'G3DSA:3.75.10.10:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151864, NULL, 'G3DSA:1.20.58.60:FF:000322', NULL, NULL, 'SMAll', NULL, NULL, NULL, NULL, NULL, 4),
(151865, NULL, 'G3DSA:2.60.120.430:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151866, NULL, 'G3DSA:3.40.1350.60:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151867, NULL, 'G3DSA:2.10.150.10:FF:000002', NULL, NULL, 'Urease', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(151868, NULL, 'G3DSA:3.30.160.60:FF:004927', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151869, NULL, 'G3DSA:3.80.10.10:FF:002152', NULL, NULL, 'Receptor like protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(151870, NULL, 'G3DSA:3.40.630.10:FF:000130', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(151871, NULL, 'G3DSA:3.30.160.60:FF:005203', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151872, NULL, 'G3DSA:3.90.70.10:FF:000738', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151873, NULL, 'G3DSA:1.10.238.10:FF:000715', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(151874, NULL, 'G3DSA:1.10.10.10:FF:001979', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151875, NULL, 'G3DSA:2.10.25.10:FF:000218', NULL, NULL, 'latent-transforming growth factor beta-binding protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(151876, NULL, 'G3DSA:3.80.10.10:FF:000139', NULL, NULL, 'centriolin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(151877, NULL, 'G3DSA:1.10.532.10:FF:000017', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(151878, NULL, 'G3DSA:1.10.10.60:FF:000549', NULL, NULL, 'Myb like transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(151879, NULL, 'G3DSA:3.40.50.300:FF:003888', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(151880, NULL, 'G3DSA:1.10.287.470:FF:000006', NULL, NULL, 'Multidrug resistance protein MdtE', NULL, NULL, NULL, NULL, NULL, 4),
(151881, NULL, 'G3DSA:1.10.540.10:FF:000143', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(151882, NULL, 'G3DSA:1.10.490.10:FF:000026', NULL, NULL, 'Preprotein translocase subunit TatC', NULL, NULL, NULL, NULL, NULL, 4),
(151883, NULL, 'G3DSA:2.40.30.170:FF:000044', NULL, NULL, 'Efflux transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(151884, NULL, 'G3DSA:3.90.1150.10:FF:000452', NULL, NULL, 'Glycine/serine hydroxymethyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151885, NULL, 'G3DSA:3.30.420.40:FF:000625', NULL, NULL, 'Ppx/GppA phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(151886, NULL, 'G3DSA:3.30.2350.10:FF:000088', NULL, NULL, 'Uncharacterized RNA pseudouridine synthase MG209', NULL, NULL, NULL, NULL, NULL, 4),
(151887, NULL, 'G3DSA:3.30.70.1730:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151888, NULL, 'G3DSA:1.25.10.10:FF:000799', NULL, NULL, 'U2 snRNP component HSH155', NULL, NULL, NULL, NULL, NULL, 4),
(151889, NULL, 'G3DSA:1.10.287.40:FF:000006', NULL, NULL, 'Seryl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(151890, NULL, 'G3DSA:1.20.1070.10:FF:001429', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151891, NULL, 'G3DSA:3.30.70.330:FF:000727', NULL, NULL, 'UBP1-associated protein 2A', NULL, NULL, NULL, NULL, NULL, 4),
(151892, NULL, 'G3DSA:3.90.190.10:FF:000472', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151893, NULL, 'G3DSA:3.40.50.2000:FF:000710', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151894, NULL, 'G3DSA:2.20.100.10:FF:000065', NULL, NULL, 'Cellular communication network factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(151895, NULL, 'G3DSA:3.30.420.10:FF:000133', NULL, NULL, 'DNA polymerase III PolC-type', NULL, NULL, NULL, NULL, NULL, 4),
(151896, NULL, 'G3DSA:1.20.1250.20:FF:001295', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151897, NULL, 'G3DSA:2.40.70.10:FF:000546', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151898, NULL, 'G3DSA:1.25.40.10:FF:001644', NULL, NULL, 'AGAP001559-PA', NULL, NULL, NULL, NULL, NULL, 4),
(151899, NULL, 'G3DSA:1.20.140.10:FF:000054', NULL, NULL, 'Acyl-CoA dehydrogenase FadE33', NULL, NULL, NULL, NULL, NULL, 4),
(151900, NULL, 'G3DSA:2.10.220.10:FF:000177', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(151901, NULL, 'G3DSA:2.40.50.90:FF:000164', NULL, NULL, 'Tudor domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(151902, NULL, 'G3DSA:2.40.340.10:FF:000010', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(151903, NULL, 'G3DSA:2.60.40.60:FF:000749', NULL, NULL, 'Cdh-4', NULL, NULL, NULL, NULL, NULL, 4),
(151904, NULL, 'G3DSA:2.30.30.40:FF:000396', NULL, NULL, 'Alkylphosphonate uptake protein', NULL, NULL, NULL, NULL, NULL, 4),
(151905, NULL, 'G3DSA:3.30.40.10:FF:001397', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(151906, NULL, 'G3DSA:3.90.260.10:FF:000056', NULL, NULL, 'Xeroderma pigmentosum, complementation group C', NULL, NULL, NULL, NULL, NULL, 4),
(151907, NULL, 'G3DSA:2.60.40.10:FF:003230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151908, NULL, 'G3DSA:1.20.58.570:FF:000001', NULL, NULL, 'F-actin-capping protein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(151909, NULL, 'G3DSA:1.10.238.10:FF:000991', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151910, NULL, 'G3DSA:1.25.10.10:FF:001075', NULL, NULL, 'E3 ubiquitin-protein ligase UPL1', NULL, NULL, NULL, NULL, NULL, 4),
(151911, NULL, 'G3DSA:1.20.1560.10:FF:000444', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151912, NULL, 'G3DSA:3.40.50.1010:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151913, NULL, 'G3DSA:3.50.50.60:FF:000478', NULL, NULL, 'RAB GDP-dissociation inhibitor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151914, NULL, 'G3DSA:3.30.70.330:FF:002583', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151915, NULL, 'G3DSA:1.10.287.110:FF:000483', NULL, NULL, 'Diphthamide biosynthesis protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(151916, NULL, 'G3DSA:3.40.50.300:FF:006878', NULL, NULL, 'Elongator complex protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(151917, NULL, 'G3DSA:1.10.150.250:FF:000008', NULL, NULL, 'Succinate dehydrogenase assembly factor 2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(151918, NULL, 'G3DSA:1.10.510.10:FF:000315', NULL, NULL, 'membrane-associated tyrosine- and threonine-specific cdc2-inhibitory kinase', NULL, NULL, NULL, NULL, NULL, 4),
(151919, NULL, 'G3DSA:3.30.70.580:FF:000044', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(151920, NULL, 'G3DSA:1.20.91.20:FF:000005', NULL, NULL, 'Complement C4', NULL, NULL, NULL, NULL, NULL, 4),
(151921, NULL, 'G3DSA:1.10.150.240:FF:000062', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(151922, NULL, 'G3DSA:1.10.10.60:FF:000881', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151923, NULL, 'G3DSA:3.30.1330.10:FF:000024', NULL, NULL, 'Trifunctional purine biosynthetic protein adenosine-3', NULL, NULL, NULL, NULL, NULL, 4),
(151924, NULL, 'G3DSA:1.20.920.10:FF:000232', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(151925, NULL, 'G3DSA:3.30.200.20:FF:000636', NULL, NULL, 'Serine/threonine-protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151926, NULL, 'G3DSA:1.20.1720.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151927, NULL, 'G3DSA:3.40.50.960:FF:000005', NULL, NULL, '6,7-dimethyl-8-ribityllumazine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(151928, NULL, 'G3DSA:1.25.40.70:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151929, NULL, 'G3DSA:3.40.50.300:FF:007154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151930, NULL, 'G3DSA:3.30.160.60:FF:003461', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151931, NULL, 'G3DSA:2.130.10.10:FF:000892', NULL, NULL, 'Os03g0355200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(151932, NULL, 'G3DSA:3.40.50.970:FF:000065', NULL, NULL, 'Oxoglutarate dehydrogenase (Succinyl-transferring), E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(151933, NULL, 'G3DSA:3.40.720.10:FF:000221', NULL, NULL, 'Putative sulfatase yidJ', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(151934, NULL, 'G3DSA:3.40.1380.10:FF:000025', NULL, NULL, 'ATP synthase gamma chain 1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(151935, NULL, 'G3DSA:3.40.190.10:FF:000545', NULL, NULL, 'Sensory box sensor histidine kinase/response regulator VieS', NULL, NULL, NULL, NULL, NULL, 4),
(151936, NULL, 'G3DSA:2.60.40.10:FF:004854', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151937, NULL, 'G3DSA:1.10.510.10:FF:002968', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151938, NULL, 'G3DSA:1.20.1640.10:FF:000057', NULL, NULL, 'MMPL domain-containing drug exporter', NULL, NULL, NULL, NULL, NULL, 4),
(151939, NULL, 'G3DSA:3.30.740.10:FF:000005', NULL, NULL, 'Dynein light chain', NULL, NULL, NULL, NULL, NULL, 4),
(151940, NULL, 'G3DSA:1.10.4000.10:FF:000001', NULL, NULL, 'Flagellar transcriptional regulator FlhD', NULL, NULL, NULL, NULL, NULL, 4),
(151941, NULL, 'G3DSA:2.30.39.10:FF:000081', NULL, NULL, 'Antithrombin-III', NULL, NULL, NULL, NULL, NULL, 4),
(151942, NULL, 'G3DSA:3.20.20.80:FF:000579', NULL, NULL, '14-alpha-glucan-branching enzyme 2-2 chloroplastic/amyloplastic', NULL, NULL, NULL, NULL, NULL, 4),
(151943, NULL, 'G3DSA:1.25.40.10:FF:001987', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g79490, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(151944, NULL, 'G3DSA:1.20.1070.10:FF:000328', NULL, NULL, 'Tachykinin-like peptides receptor 86C', NULL, NULL, NULL, NULL, NULL, 4),
(151945, NULL, 'G3DSA:3.30.559.10:FF:000281', NULL, NULL, 'Carnitine palmitoyltransferase 1Cb', NULL, NULL, NULL, NULL, NULL, 4),
(151946, NULL, 'G3DSA:1.20.1250.20:FF:000250', NULL, NULL, 'Protein NRT1/ PTR FAMILY 4.6', NULL, NULL, NULL, NULL, NULL, 4),
(151947, NULL, 'G3DSA:3.30.160.60:FF:000976', NULL, NULL, 'B-cell CLL/lymphoma 6, member B', NULL, NULL, NULL, NULL, NULL, 4),
(151948, NULL, 'G3DSA:3.40.50.1000:FF:000798', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151949, NULL, 'G3DSA:1.10.287.70:FF:000521', NULL, NULL, 'Glutamate receptor 1.4', NULL, NULL, NULL, NULL, NULL, 4),
(151950, NULL, 'G3DSA:3.40.710.10:FF:000131', NULL, NULL, 'Putative lipoprotein YbbD', NULL, NULL, NULL, NULL, NULL, 4),
(151951, NULL, 'G3DSA:3.30.70.2850:FF:000001', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(151952, NULL, 'G3DSA:3.30.160.60:FF:001252', NULL, NULL, 'Zinc finger and BTB domain-containing 48', NULL, NULL, NULL, NULL, NULL, 4),
(151953, NULL, 'G3DSA:1.20.1390.20:FF:000001', NULL, NULL, 'Elongation factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(151954, NULL, 'G3DSA:3.40.50.300:FF:000797', NULL, NULL, 'Rac-like GTP-binding protein ARAC7', NULL, NULL, NULL, NULL, NULL, 4),
(151955, NULL, 'G3DSA:2.40.320.10:FF:000026', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 18', NULL, NULL, NULL, NULL, NULL, 4),
(151956, NULL, 'G3DSA:3.30.70.330:FF:002240', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151957, NULL, 'G3DSA:1.20.1260.140:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151958, NULL, 'G3DSA:3.30.300.130:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151959, NULL, 'G3DSA:1.20.1070.10:FF:000148', NULL, NULL, '5-hydroxytryptamine receptor 6', NULL, NULL, NULL, NULL, NULL, 4),
(151960, NULL, 'G3DSA:1.20.90.10:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151961, NULL, 'G3DSA:2.40.50.140:FF:000718', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151962, NULL, 'G3DSA:2.60.40.420:FF:000217', NULL, NULL, 'Laccase family multicopper oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(151963, NULL, 'G3DSA:2.170.270.10:FF:000226', NULL, NULL, 'SET domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(151964, NULL, 'G3DSA:2.40.160.210:FF:000002', NULL, NULL, 'acyl-coenzyme A thioesterase 8', NULL, NULL, NULL, NULL, NULL, 4),
(151965, NULL, 'G3DSA:3.30.200.20:FF:000979', NULL, NULL, 'Os06g0693900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(151966, NULL, 'G3DSA:2.40.290.10:FF:000028', NULL, NULL, 'AGAP009910-PA', NULL, NULL, NULL, NULL, NULL, 4),
(151967, NULL, 'G3DSA:2.10.25.10:FF:001651', NULL, NULL, 'Epidermal growth factor', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(151968, NULL, 'G3DSA:1.20.1250.20:FF:002312', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151969, NULL, 'G3DSA:2.60.40.1120:FF:000009', NULL, NULL, 'adipocyte enhancer-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(151970, NULL, 'G3DSA:1.50.10.10:FF:000235', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(151971, NULL, 'G3DSA:3.30.870.10:FF:000161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151972, NULL, 'G3DSA:3.40.50.300:FF:008435', NULL, NULL, 'ATP-dependent DEAD/H DNA helicase recQ family-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(151973, NULL, 'G3DSA:3.30.420.40:FF:000237', NULL, NULL, 'Actin-related protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(151974, NULL, 'G3DSA:1.10.2000.10:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151975, NULL, 'G3DSA:3.30.1370.50:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151976, NULL, 'G3DSA:2.130.10.10:FF:004782', NULL, NULL, 'Ribosomal RNA processing 9, U3 small nucleolar RNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(151977, NULL, 'G3DSA:1.20.1270.10:FF:000068', NULL, NULL, 'Heat shock cognate 70 kDa protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(151978, NULL, 'G3DSA:2.10.230.10:FF:000003', NULL, NULL, 'dnaJ homolog subfamily A member 3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(151979, NULL, 'G3DSA:3.40.640.10:FF:000299', NULL, NULL, 'L-seryl-tRNA(Sec) selenium transferase', NULL, NULL, NULL, NULL, NULL, 4),
(151980, NULL, 'G3DSA:3.30.160.60:FF:000796', NULL, NULL, 'Zinc finger protein 335', NULL, NULL, NULL, NULL, NULL, 4),
(151981, NULL, 'G3DSA:3.40.50.720:FF:000748', NULL, NULL, 'Adenylyltransferase and sulfurtransferase MOCS3', NULL, NULL, NULL, NULL, NULL, 4),
(151982, NULL, 'G3DSA:1.10.510.10:FF:002389', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151983, NULL, 'G3DSA:1.25.40.470:FF:000052', NULL, NULL, 'Cotamer alpha, putative', NULL, NULL, NULL, NULL, NULL, 4),
(151984, NULL, 'G3DSA:1.10.418.10:FF:000084', NULL, NULL, 'Girdin, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(151985, NULL, 'G3DSA:2.40.128.130:FF:000003', NULL, NULL, 'AIDA-I family autotransporter YfaL', NULL, NULL, NULL, NULL, NULL, 4),
(151986, NULL, 'G3DSA:3.30.70.2740:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151987, NULL, 'G3DSA:3.20.20.140:FF:000320', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151988, NULL, 'G3DSA:2.30.29.30:FF:000822', NULL, NULL, 'Oxysterol-binding protein-like 9', NULL, NULL, NULL, NULL, NULL, 4),
(151989, NULL, 'G3DSA:2.60.40.10:FF:001156', NULL, NULL, 'Interferon alpha/beta receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(151990, NULL, 'G3DSA:1.10.533.10:FF:000008', NULL, NULL, 'Death associated protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(151991, NULL, 'G3DSA:1.25.10.10:FF:001816', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(151992, NULL, 'G3DSA:1.10.10.10:FF:001136', NULL, NULL, 'Transcription factor E2F7', NULL, NULL, NULL, NULL, NULL, 4),
(151993, NULL, 'G3DSA:1.25.40.10:FF:000363', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(151994, NULL, 'G3DSA:1.25.40.10:FF:005298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(151995, NULL, 'G3DSA:1.10.510.10:FF:003406', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151996, NULL, 'G3DSA:2.60.120.200:FF:000020', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(151997, NULL, 'G3DSA:1.20.950.20:FF:000006', NULL, NULL, 'Cytochrome b561 2', NULL, NULL, NULL, NULL, NULL, 4),
(151998, NULL, 'G3DSA:1.10.472.80:FF:000286', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(151999, NULL, 'G3DSA:3.30.160.60:FF:001813', NULL, NULL, 'Zinc finger protein 687 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(152000, NULL, 'G3DSA:3.10.310.20:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(152001, NULL, 'G3DSA:1.20.58.390:FF:000003', NULL, NULL, 'Glycine receptor alpha 2 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(152002, NULL, 'G3DSA:2.130.10.10:FF:005299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152003, NULL, 'G3DSA:3.30.40.10:FF:000733', NULL, NULL, 'Pib1p', NULL, NULL, NULL, NULL, NULL, 4),
(152004, NULL, 'G3DSA:3.40.50.300:FF:003500', NULL, NULL, 'ADP-ribosylation factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(152005, NULL, 'G3DSA:4.10.1060.10:FF:000013', NULL, NULL, 'Zinc finger, RanBP2-type protein', NULL, NULL, NULL, NULL, NULL, 4),
(152006, NULL, 'G3DSA:1.10.472.80:FF:000022', NULL, NULL, 'TBC1 domain family, member 31', NULL, NULL, NULL, NULL, NULL, 4),
(152007, NULL, 'G3DSA:4.10.60.10:FF:000115', NULL, NULL, 'Putative cleavage and polyadenylation specificity factor 30 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(152008, NULL, 'G3DSA:3.40.50.1820:FF:001690', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152009, NULL, 'G3DSA:1.20.58.390:FF:000267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152010, NULL, 'G3DSA:3.40.50.720:FF:000187', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(152011, NULL, 'G3DSA:3.30.460.10:FF:000175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152012, NULL, 'G3DSA:1.20.1260.60:FF:000009', NULL, NULL, 'IST1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(152013, NULL, 'G3DSA:2.130.10.10:FF:002949', NULL, NULL, 'EG:63B12.7 protein', NULL, NULL, NULL, NULL, NULL, 4),
(152014, NULL, 'G3DSA:1.20.120.160:FF:000041', NULL, NULL, 'Diguanylate cyclase with response regulator receiver modulation', NULL, NULL, NULL, NULL, NULL, 4),
(152015, NULL, 'G3DSA:3.10.20.90:FF:000189', NULL, NULL, 'Neutrophil cytosol factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(152016, NULL, 'G3DSA:1.10.510.10:FF:001872', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152017, NULL, 'G3DSA:3.30.565.10:FF:000255', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(152018, NULL, 'G3DSA:2.70.170.10:FF:000046', NULL, NULL, 'Cholinergic receptor nicotinic alpha 1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(152019, NULL, 'G3DSA:2.60.40.10:FF:005310', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152020, NULL, 'G3DSA:2.60.120.650:FF:000037', NULL, NULL, 'Transcription factor jumonji (JmjC) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(152021, NULL, 'G3DSA:2.40.240.10:FF:000025', NULL, NULL, 'Glutamine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(152022, NULL, 'G3DSA:3.40.50.300:FF:008559', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152023, NULL, 'G3DSA:3.40.50.1000:FF:000455', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(152024, NULL, 'G3DSA:2.10.25.10:FF:001090', NULL, NULL, 'Vein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(152025, NULL, 'G3DSA:2.60.120.260:FF:000510', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152026, NULL, 'G3DSA:3.40.50.300:FF:001814', NULL, NULL, 'DNA mismatch repair protein MutS type 2', NULL, NULL, NULL, NULL, NULL, 4),
(152027, NULL, 'G3DSA:2.30.30.40:FF:000053', NULL, NULL, 'endophilin-A1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(152028, NULL, 'G3DSA:1.25.40.570:FF:000048', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(152029, NULL, 'G3DSA:3.40.50.2300:FF:000289', NULL, NULL, 'Osmosensing histidine protein kinase SLN1', NULL, NULL, NULL, NULL, NULL, 4),
(152030, NULL, 'G3DSA:1.10.10.10:FF:000698', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(152031, NULL, 'G3DSA:3.40.390.10:FF:000318', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152032, NULL, 'G3DSA:1.20.1270.60:FF:000122', NULL, NULL, 'Protein CBG22463', NULL, NULL, NULL, NULL, NULL, 4),
(152033, NULL, 'G3DSA:2.130.10.10:FF:001016', NULL, NULL, 'WD repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(152034, NULL, 'G3DSA:2.10.110.10:FF:000348', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152035, NULL, 'G3DSA:2.40.160.10:FF:000024', NULL, NULL, 'Mitochondrial outer membrane protein porin 1 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(152036, NULL, 'G3DSA:1.20.1070.10:FF:001840', NULL, NULL, 'NMUR (NeuroMedin U Receptor) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(152037, NULL, 'G3DSA:3.40.50.1820:FF:000133', NULL, NULL, 'esterase AGAP003155', NULL, NULL, NULL, NULL, NULL, 4),
(152038, NULL, 'G3DSA:2.60.40.380:FF:000003', NULL, NULL, 'Metallo phosphoesterase', NULL, NULL, NULL, NULL, NULL, 4),
(152039, NULL, 'G3DSA:1.10.1670.10:FF:000011', NULL, NULL, 'N-glycosylase/DNA lyase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152040, NULL, 'G3DSA:3.30.160.20:FF:000071', NULL, NULL, 'Double-stranded RNA-binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(152041, NULL, 'G3DSA:3.80.10.10:FF:004029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152042, NULL, 'G3DSA:3.80.10.10:FF:003629', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152043, NULL, 'G3DSA:3.90.70.10:FF:000659', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152044, NULL, 'G3DSA:3.40.190.80:FF:000026', NULL, NULL, '3''-phosphoadenosine 5''-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(152045, NULL, 'G3DSA:1.25.40.20:FF:000708', NULL, NULL, 'Intracelllar PhosphoLipase A family', NULL, NULL, NULL, NULL, NULL, 4),
(152046, NULL, 'G3DSA:1.25.10.10:FF:001255', NULL, NULL, 'Exportin 1', NULL, NULL, NULL, NULL, NULL, 4),
(152047, NULL, 'G3DSA:2.60.120.290:FF:000053', NULL, NULL, 'Cubilin', NULL, NULL, NULL, NULL, NULL, 4),
(152048, NULL, 'G3DSA:3.30.70.330:FF:000031', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein h3 isoform', NULL, NULL, NULL, NULL, NULL, 4),
(152049, NULL, 'G3DSA:2.130.10.10:FF:003225', NULL, NULL, 'Cilia- and flagella-associated protein 43', NULL, NULL, NULL, NULL, NULL, 4),
(152050, NULL, 'G3DSA:3.40.50.720:FF:001597', NULL, NULL, 'Os07g0601900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(152051, NULL, 'G3DSA:2.60.40.60:FF:000518', NULL, NULL, 'Protein CBG11732', NULL, NULL, NULL, NULL, NULL, 4),
(152052, NULL, 'G3DSA:1.10.560.10:FF:000026', NULL, NULL, 'Chaperonin 60 subunit alpha 2 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(152053, NULL, 'G3DSA:3.40.309.10:FF:000069', NULL, NULL, 'Aldehyde-alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(152054, NULL, 'G3DSA:1.25.10.10:FF:000294', NULL, NULL, 'Transformation/transcription domain associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(152055, NULL, 'G3DSA:1.25.40.10:FF:000863', NULL, NULL, 'Vacuolar protein sorting-associated protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(152056, NULL, 'G3DSA:3.50.50.60:FF:000321', NULL, NULL, 'D-amino acid dehydrogenase small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(152057, NULL, 'G3DSA:3.10.129.10:FF:000275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152058, NULL, 'G3DSA:1.10.510.10:FF:003221', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152059, NULL, 'G3DSA:1.25.40.10:FF:001431', NULL, NULL, 'NRDE-2, necessary for RNA interference, domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(152060, NULL, 'G3DSA:2.130.10.10:FF:001640', NULL, NULL, 'GM20238', NULL, NULL, NULL, NULL, NULL, 4),
(152061, NULL, 'G3DSA:3.30.200.20:FF:000715', NULL, NULL, 'AGC protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(152062, NULL, 'G3DSA:1.20.120.1900:FF:000092', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(152063, NULL, 'G3DSA:3.30.40.10:FF:001958', NULL, NULL, 'Putative RING zinc finger domain superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(152064, NULL, 'G3DSA:2.60.120.650:FF:000014', NULL, NULL, 'PHD transcription factor (Rum1)', NULL, NULL, NULL, NULL, NULL, 4),
(152065, NULL, 'G3DSA:3.30.1520.10:FF:000011', NULL, NULL, 'Putative sorting nexin-16', NULL, NULL, NULL, NULL, NULL, 4),
(152066, NULL, 'G3DSA:3.90.226.10:FF:000073', NULL, NULL, 'Probable enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(152067, NULL, 'G3DSA:2.60.20.10:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152068, NULL, 'G3DSA:1.25.40.20:FF:000860', NULL, NULL, 'Transient receptor potential cation channel subfamily A member 1', NULL, NULL, NULL, NULL, NULL, 4),
(152069, NULL, 'G3DSA:3.30.200.20:FF:002261', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152070, NULL, 'G3DSA:3.30.1640.10:FF:000065', NULL, NULL, 'DNA replication licensing factor MCM4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(152071, NULL, 'G3DSA:3.40.1050.10:FF:000028', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(152072, NULL, 'G3DSA:3.30.200.20:FF:000659', NULL, NULL, 'SH2-protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(152073, NULL, 'G3DSA:3.30.230.70:FF:000069', NULL, NULL, '3''-5''-exoribonuclease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(152074, NULL, 'G3DSA:3.30.1540.10:FF:000006', NULL, NULL, 'Succinyl-CoA--L-malate CoA-transferase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(152075, NULL, 'G3DSA:2.20.80.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152076, NULL, 'G3DSA:2.60.120.1020:FF:000002', NULL, NULL, 'N-glycanase 1', NULL, NULL, NULL, NULL, NULL, 4),
(152077, NULL, 'G3DSA:3.80.10.10:FF:002213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152078, NULL, 'G3DSA:1.10.510.10:FF:003165', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152079, NULL, 'G3DSA:3.30.230.70:FF:000125', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(152080, NULL, 'G3DSA:3.30.590.20:FF:000013', NULL, NULL, 'Glutamate--cysteine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(152081, NULL, 'G3DSA:2.10.70.10:FF:000289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152082, NULL, 'G3DSA:3.60.21.10:FF:000441', NULL, NULL, 'Protein phosphatase 2B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152083, NULL, 'G3DSA:3.40.50.2300:FF:001019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152084, NULL, 'G3DSA:3.30.559.10:FF:000218', NULL, NULL, 'Ferrichrome siderophore peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(152085, NULL, 'G3DSA:2.60.40.10:FF:004298', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152086, NULL, 'G3DSA:2.60.120.1190:FF:000007', NULL, NULL, 'Discoidin domain receptor tyrosine kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(152087, NULL, 'G3DSA:3.40.50.2300:FF:000507', NULL, NULL, 'Two-component response regulator NatK', NULL, NULL, NULL, NULL, NULL, 4),
(152088, NULL, 'G3DSA:1.20.59.10:FF:000023', NULL, NULL, 'Shikimate 5-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(152089, NULL, 'G3DSA:1.20.58.60:FF:000827', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152090, NULL, 'G3DSA:3.40.50.300:FF:003152', NULL, NULL, 'Elongation factor 1-alpha', NULL, NULL, NULL, NULL, NULL, 4),
(152091, NULL, 'G3DSA:3.30.160.60:FF:004803', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152092, NULL, 'G3DSA:3.80.10.10:FF:002264', NULL, NULL, 'GH06740p', NULL, NULL, NULL, NULL, NULL, 4),
(152093, NULL, 'G3DSA:3.60.21.10:FF:000334', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152094, NULL, 'G3DSA:3.30.160.60:FF:000476', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(152095, NULL, 'G3DSA:1.20.1270.60:FF:000061', NULL, NULL, 'Rho guanine nucleotide exchange factor 38', NULL, NULL, NULL, NULL, NULL, 4),
(152096, NULL, 'G3DSA:3.40.50.300:FF:006822', NULL, NULL, 'Adenylate kinase isoenzyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(152097, NULL, 'G3DSA:1.10.238.10:FF:001115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152098, NULL, 'G3DSA:2.40.70.10:FF:000074', NULL, NULL, 'Os05g0384300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(152099, NULL, 'G3DSA:2.40.30.170:FF:000021', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(152100, NULL, 'G3DSA:3.10.100.10:FF:000248', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(152101, NULL, 'G3DSA:1.20.5.170:FF:000224', NULL, NULL, 'SNF2 family N-terminal domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(152102, NULL, 'G3DSA:3.40.190.10:FF:000258', NULL, NULL, 'ATP phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(152103, NULL, 'G3DSA:2.130.10.10:FF:005911', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152104, NULL, 'G3DSA:3.10.580.10:FF:000109', NULL, NULL, 'SNF1-related protein kinase regulatory subunit gamma-like PV42b', NULL, NULL, NULL, NULL, NULL, 4),
(152105, NULL, 'G3DSA:2.130.10.10:FF:005799', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152106, NULL, 'G3DSA:3.30.1490.480:FF:000005', NULL, NULL, 'Endolytic murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(152107, NULL, 'G3DSA:3.80.10.10:FF:001752', NULL, NULL, 'Putative disease resistance protein At3g14460', NULL, NULL, NULL, NULL, NULL, 4),
(152108, NULL, 'G3DSA:3.40.50.720:FF:001541', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152109, NULL, 'G3DSA:3.40.33.10:FF:000003', NULL, NULL, 'Peptidase inhibitor 15', NULL, NULL, NULL, NULL, NULL, 4),
(152110, NULL, 'G3DSA:3.10.129.10:FF:000224', NULL, NULL, 'Cytosolic acyl coenzyme A thioester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(152111, NULL, 'G3DSA:3.40.1110.10:FF:000034', NULL, NULL, 'Zinc/cadmium/lead-transporting P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(152112, NULL, 'G3DSA:3.40.50.200:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152113, NULL, 'G3DSA:2.60.40.2030:FF:000046', NULL, NULL, 'Adhesion G protein-coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(152114, NULL, 'G3DSA:2.20.70.10:FF:000148', NULL, NULL, 'AFR317Cp', NULL, NULL, NULL, NULL, NULL, 4),
(152115, NULL, 'G3DSA:3.40.50.10810:FF:000188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152116, NULL, 'G3DSA:3.40.190.80:FF:000077', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(152117, NULL, 'G3DSA:3.90.480.20:FF:000008', NULL, NULL, 'Ferredoxin--nitrite reductase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(152118, NULL, 'G3DSA:2.60.120.260:FF:000459', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152119, NULL, 'G3DSA:1.20.58.60:FF:000086', NULL, NULL, 'Short stop, isoform K', NULL, NULL, NULL, NULL, NULL, 4),
(152120, NULL, 'G3DSA:3.20.20.300:FF:000071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152121, NULL, 'G3DSA:3.80.10.10:FF:002320', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(152122, NULL, 'G3DSA:3.30.160.60:FF:004747', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152123, NULL, 'G3DSA:3.30.750.24:FF:000109', NULL, NULL, 'ABC transporter permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(152124, NULL, 'G3DSA:1.10.1670.40:FF:000003', NULL, NULL, 'DNA-3-methyladenine glycosylase II', NULL, NULL, NULL, NULL, NULL, 4),
(152125, NULL, 'G3DSA:3.90.1150.10:FF:000457', NULL, NULL, 'Aminotransferase class-III', NULL, NULL, NULL, NULL, NULL, 4),
(152126, NULL, 'G3DSA:2.20.70.10:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152127, NULL, 'G3DSA:3.40.20.10:FF:000029', NULL, NULL, 'SEC24 homolog B, COPII coat complex component', NULL, NULL, NULL, NULL, NULL, 4),
(152128, NULL, 'G3DSA:1.10.640.10:FF:000027', NULL, NULL, 'Protein CBG06977', NULL, NULL, NULL, NULL, NULL, 4),
(152129, NULL, 'G3DSA:3.60.130.10:FF:000059', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(152130, NULL, 'G3DSA:1.20.58.340:FF:000005', NULL, NULL, 'Inner membrane magnesium transporter MRS2', NULL, NULL, NULL, NULL, NULL, 4),
(152131, NULL, 'G3DSA:2.130.10.10:FF:005855', NULL, NULL, 'Nucleoporin nup131', NULL, NULL, NULL, NULL, NULL, 4),
(152132, NULL, 'G3DSA:1.10.840.10:FF:000008', NULL, NULL, 'Ras-GEF domain-containing family member 1B', NULL, NULL, NULL, NULL, NULL, 4),
(152133, NULL, 'G3DSA:3.90.1150.10:FF:000513', NULL, NULL, 'Transcriptional regulator, GntR family', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(152134, NULL, 'G3DSA:3.40.1410.10:FF:000023', NULL, NULL, 'Phosphonate utilization transcriptional regulator PhnR', NULL, NULL, NULL, NULL, NULL, 4),
(152135, NULL, 'G3DSA:2.10.25.10:FF:000870', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152136, NULL, 'G3DSA:3.40.800.20:FF:000051', NULL, NULL, 'Histone deacetylase 1 HDAC Hda1p', NULL, NULL, NULL, NULL, NULL, 4),
(152137, NULL, 'G3DSA:3.40.50.150:FF:000212', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4),
(152138, NULL, 'G3DSA:1.10.10.10:FF:001075', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC3', NULL, NULL, NULL, NULL, NULL, 4),
(152139, NULL, 'G3DSA:1.20.920.20:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152140, NULL, 'G3DSA:3.40.50.720:FF:001592', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152141, NULL, 'G3DSA:3.30.160.60:FF:000532', NULL, NULL, 'GLIS family zinc finger 2', NULL, NULL, NULL, NULL, NULL, 4),
(152142, NULL, 'G3DSA:3.40.50.300:FF:003096', NULL, NULL, 'Small GTPase EhRabX29, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152143, NULL, 'G3DSA:1.10.238.10:FF:000159', NULL, NULL, 'Calcium uptake protein 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(152144, NULL, 'G3DSA:3.30.70.330:FF:003072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152145, NULL, 'G3DSA:3.10.20.90:FF:000369', NULL, NULL, 'Bud emergence protein', NULL, NULL, NULL, NULL, NULL, 4),
(152146, NULL, 'G3DSA:3.40.630.10:FF:000394', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152147, NULL, 'G3DSA:3.40.190.10:FF:000314', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(152148, NULL, 'G3DSA:3.30.450.50:FF:000006', NULL, NULL, 'Vesicle-associated membrane protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(152149, NULL, 'G3DSA:3.50.50.60:FF:000265', NULL, NULL, 'Putative lysine-specific histone demethylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(152150, NULL, 'G3DSA:2.60.40.770:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152151, NULL, 'G3DSA:2.40.50.140:FF:000426', NULL, NULL, 'Protection of telomeres protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(152152, NULL, 'G3DSA:1.20.1160.20:FF:000012', NULL, NULL, 'Regulator of telomere elongation helicase 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(152153, NULL, 'G3DSA:3.30.1490.100:FF:000037', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(152154, NULL, 'G3DSA:1.20.1270.60:FF:000010', NULL, NULL, 'Metastasis suppressor 1, isoform CRA_e', NULL, NULL, NULL, NULL, NULL, 4),
(152155, NULL, 'G3DSA:1.20.272.10:FF:000040', NULL, NULL, 'Replication factor C large subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152156, NULL, 'G3DSA:3.60.20.30:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152157, NULL, 'G3DSA:3.40.50.1820:FF:001538', NULL, NULL, 'Neuroligin-3', NULL, NULL, NULL, NULL, NULL, 4),
(152158, NULL, 'G3DSA:1.25.40.420:FF:000026', NULL, NULL, 'BTB/POZ domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(152159, NULL, 'G3DSA:2.130.10.10:FF:002926', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(152160, NULL, 'G3DSA:1.20.1460.20:FF:000001', NULL, NULL, 'V-type ATP synthase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(152161, NULL, 'G3DSA:2.60.40.10:FF:005203', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152162, NULL, 'G3DSA:3.40.50.1980:FF:000080', NULL, NULL, 'Nickel/cobalt efflux system', NULL, NULL, NULL, NULL, NULL, 4),
(152163, NULL, 'G3DSA:3.30.160.20:FF:000251', NULL, NULL, 'RISC-loading complex subunit TARBP2', NULL, NULL, NULL, NULL, NULL, 4),
(152164, NULL, 'G3DSA:1.20.1250.20:FF:000194', NULL, NULL, 'Inner membrane protein yhjX', NULL, NULL, NULL, NULL, NULL, 4),
(152165, NULL, 'G3DSA:1.25.40.10:FF:004393', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152166, NULL, 'G3DSA:2.10.25.10:FF:000033', NULL, NULL, 'Laminin subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(152167, NULL, 'G3DSA:2.60.40.1080:FF:000008', NULL, NULL, 'Ig-like repeat domain protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(152168, NULL, 'G3DSA:4.10.400.10:FF:000138', NULL, NULL, 'Low-density lipoprotein receptor-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(152169, NULL, 'G3DSA:3.40.50.1240:FF:000055', NULL, NULL, 'Phosphoglycerate mutase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152170, NULL, 'G3DSA:3.40.50.280:FF:000015', NULL, NULL, 'Methionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(152171, NULL, 'G3DSA:2.30.30.20:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152172, NULL, 'G3DSA:3.30.70.330:FF:002408', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152173, NULL, 'G3DSA:2.120.10.30:FF:000590', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152174, NULL, 'G3DSA:3.40.50.300:FF:006081', NULL, NULL, 'ATP-binding cassette sub-family A member 3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(152175, NULL, 'G3DSA:1.25.40.570:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152176, NULL, 'G3DSA:1.25.40.10:FF:003229', NULL, NULL, 'Interferon-induced protein with tetratricopeptide repeats 5-like', NULL, NULL, NULL, NULL, NULL, 4),
(152177, NULL, 'G3DSA:2.130.10.10:FF:004006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152178, NULL, 'G3DSA:3.90.70.10:FF:000103', NULL, NULL, 'Hypothetical LOC496748', NULL, NULL, NULL, NULL, NULL, 4),
(152179, NULL, 'G3DSA:3.30.160.60:FF:005703', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152180, NULL, 'G3DSA:3.30.200.20:FF:002109', NULL, NULL, 'CMGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(152181, NULL, 'G3DSA:1.10.274.30:FF:000035', NULL, NULL, 'Protein CBG13704', NULL, NULL, NULL, NULL, NULL, 4),
(152182, NULL, 'G3DSA:1.25.40.10:FF:002717', NULL, NULL, 'YALI0D14344p', NULL, NULL, NULL, NULL, NULL, 4),
(152183, NULL, 'G3DSA:2.170.150.10:FF:000010', NULL, NULL, 'Translationally-controlled tumor protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(152184, NULL, 'G3DSA:2.170.130.10:FF:000003', NULL, NULL, 'SusC/RagA family TonB-linked outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(152185, NULL, 'G3DSA:3.40.50.300:FF:004405', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152186, NULL, 'G3DSA:1.10.510.10:FF:000259', NULL, NULL, 'Serine/threonine-protein kinase TNNI3K', NULL, NULL, NULL, NULL, NULL, 4),
(152187, NULL, 'G3DSA:3.90.660.10:FF:000109', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152188, NULL, 'G3DSA:2.70.170.10:FF:000277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152189, NULL, 'G3DSA:1.25.40.20:FF:000629', NULL, NULL, 'Intracelllar PhosphoLipase A family', NULL, NULL, NULL, NULL, NULL, 4),
(152190, NULL, 'G3DSA:3.90.550.10:FF:000455', NULL, NULL, 'Glycosyl transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(152191, NULL, 'G3DSA:3.40.630.10:FF:000450', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152192, NULL, 'G3DSA:3.10.20.90:FF:000425', NULL, NULL, 'Polyubiquitin containing 7 ubiquitin monomers', NULL, NULL, NULL, NULL, NULL, 4),
(152193, NULL, 'G3DSA:2.70.150.10:FF:000219', NULL, NULL, 'ATPase copper transporting beta', NULL, NULL, NULL, NULL, NULL, 4),
(152194, NULL, 'G3DSA:2.60.120.200:FF:000251', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(152195, NULL, 'G3DSA:1.20.1410.10:FF:000012', NULL, NULL, 'YLR287C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(152196, NULL, 'G3DSA:1.10.10.10:FF:001479', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC3', NULL, NULL, NULL, NULL, NULL, 4),
(152197, NULL, 'G3DSA:2.40.50.140:FF:000477', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(152198, NULL, 'G3DSA:3.40.630.30:FF:000456', NULL, NULL, 'Similar to nourseothricin acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(152199, NULL, 'G3DSA:1.20.1070.10:FF:001784', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(152200, NULL, 'G3DSA:3.30.1640.10:FF:000014', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(152201, NULL, 'G3DSA:3.30.160.60:FF:002893', NULL, NULL, 'Zinc finger protein 971', NULL, NULL, NULL, NULL, NULL, 4),
(152202, NULL, 'G3DSA:1.10.472.10:FF:000366', NULL, NULL, 'General transcription factor IIB', NULL, NULL, NULL, NULL, NULL, 4),
(152203, NULL, 'G3DSA:2.60.120.260:FF:000515', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(152204, NULL, 'G3DSA:3.30.40.10:FF:000109', NULL, NULL, 'Zinc finger FYVE domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(152205, NULL, 'G3DSA:3.40.50.150:FF:000268', NULL, NULL, 'Histidine protein methyltransferase 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(152206, NULL, 'G3DSA:1.10.3210.10:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152207, NULL, 'G3DSA:1.10.287.70:FF:000285', NULL, NULL, 'TWiK family of potassium channels', NULL, NULL, NULL, NULL, NULL, 4),
(152208, NULL, 'G3DSA:3.40.50.150:FF:000156', NULL, NULL, 'Methyltransferase like 22', NULL, NULL, NULL, NULL, NULL, 4),
(152209, NULL, 'G3DSA:1.10.472.10:FF:000254', NULL, NULL, 'Cyclin-T1.2', NULL, NULL, NULL, NULL, NULL, 4),
(152210, NULL, 'G3DSA:1.10.10.10:FF:000967', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(152211, NULL, 'G3DSA:3.30.160.60:FF:003382', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152212, NULL, 'G3DSA:2.40.270.10:FF:000010', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(152213, NULL, 'G3DSA:1.25.40.20:FF:001760', NULL, NULL, 'Protein tirA', NULL, NULL, NULL, NULL, NULL, 4),
(152214, NULL, 'G3DSA:2.120.10.80:FF:000121', NULL, NULL, 'acyl-CoA-binding domain-containing protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(152215, NULL, 'G3DSA:2.30.42.10:FF:000572', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152216, NULL, 'G3DSA:3.40.50.11660:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152217, NULL, 'G3DSA:2.60.40.1970:FF:000011', NULL, NULL, 'YEATS family', NULL, NULL, NULL, NULL, NULL, 4),
(152218, NULL, 'G3DSA:3.40.30.10:FF:001199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152219, NULL, 'G3DSA:3.30.70.330:FF:003021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152220, NULL, 'G3DSA:1.20.1070.10:FF:001609', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(152221, NULL, 'G3DSA:3.30.420.140:FF:000037', NULL, NULL, 'SUPT6H,-like protein to suppressor of ty 6', NULL, NULL, NULL, NULL, NULL, 4),
(152222, NULL, 'G3DSA:3.50.50.60:FF:000214', NULL, NULL, 'PROBABLE MONOOXYGENASE', NULL, NULL, NULL, NULL, NULL, 4),
(152223, NULL, 'G3DSA:1.20.1280.20:FF:000015', NULL, NULL, 'Fe-S protein assembly co-chaperone HscB', NULL, NULL, NULL, NULL, NULL, 4),
(152224, NULL, 'G3DSA:3.10.28.10:FF:000060', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(152225, NULL, 'G3DSA:1.10.238.10:FF:001290', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152226, NULL, 'G3DSA:3.40.50.1000:FF:000163', NULL, NULL, 'Pyridoxal phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(152227, NULL, 'G3DSA:2.130.10.10:FF:002185', NULL, NULL, 'Transducin family protein, putative, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(152228, NULL, 'G3DSA:4.10.280.110:FF:000010', NULL, NULL, 'mRNA splicing factor (Prp18), putative', NULL, NULL, NULL, NULL, NULL, 4),
(152229, NULL, 'G3DSA:1.25.10.10:FF:003172', NULL, NULL, 'Ras guanine nucleotide exchange factor V', NULL, NULL, NULL, NULL, NULL, 4),
(152230, NULL, 'G3DSA:2.70.98.10:FF:000007', NULL, NULL, 'Putative alpha-1,2-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(152231, NULL, 'G3DSA:2.60.40.10:FF:002437', NULL, NULL, 'Cilia- and flagella-associated protein 74', NULL, NULL, NULL, NULL, NULL, 4),
(152232, NULL, 'G3DSA:3.40.1380.20:FF:000062', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(152233, NULL, 'G3DSA:2.60.40.60:FF:000581', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(152234, NULL, 'G3DSA:1.20.1740.10:FF:000273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152235, NULL, 'G3DSA:3.30.70.330:FF:002560', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152236, NULL, 'G3DSA:3.40.50.300:FF:003944', NULL, NULL, 'Shikimate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(152237, NULL, 'G3DSA:1.10.287.110:FF:000207', NULL, NULL, 'Uncharacterized J domain-containing protein C1071.09c', NULL, NULL, NULL, NULL, NULL, 4),
(152238, NULL, 'G3DSA:3.40.50.360:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152239, NULL, 'G3DSA:2.10.25.10:FF:001382', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152240, NULL, 'G3DSA:3.60.21.10:FF:000385', NULL, NULL, 'Serine/threonine protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152241, NULL, 'G3DSA:3.40.309.10:FF:000125', NULL, NULL, '10-formyltetrahydrofolate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(152242, NULL, 'G3DSA:3.40.630.30:FF:000405', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(152243, NULL, 'G3DSA:1.10.640.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152244, NULL, 'G3DSA:3.30.300.130:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152245, NULL, 'G3DSA:1.10.510.10:FF:003114', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152246, NULL, 'G3DSA:1.20.1560.10:FF:000175', NULL, NULL, 'ABC transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(152247, NULL, 'G3DSA:1.25.10.10:FF:000350', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(152248, NULL, 'G3DSA:3.90.70.10:FF:000154', NULL, NULL, 'Putative U4/U6.U5 tri-snRNP-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(152249, NULL, 'G3DSA:3.20.20.300:FF:000008', NULL, NULL, 'Beta-N-acetylglucosaminidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152250, NULL, 'G3DSA:1.20.1280.290:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152251, NULL, 'G3DSA:2.20.70.10:FF:000199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152252, NULL, 'G3DSA:3.90.226.10:FF:000180', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(152253, NULL, 'G3DSA:2.30.29.30:FF:000479', NULL, NULL, 'General transcription factor IIH subunit', NULL, NULL, NULL, NULL, NULL, 4),
(152254, NULL, 'G3DSA:1.10.1200.10:FF:000072', NULL, NULL, 'Nonribosomal peptide synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152255, NULL, 'G3DSA:3.40.50.12610:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152256, NULL, 'G3DSA:2.30.29.30:FF:001047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152257, NULL, 'G3DSA:3.90.226.10:FF:000185', NULL, NULL, 'ClpP/crotonase', NULL, NULL, NULL, NULL, NULL, 4),
(152258, NULL, 'G3DSA:2.130.10.10:FF:001752', NULL, NULL, 'Putative duf1620 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(152259, NULL, 'G3DSA:3.40.190.10:FF:000202', NULL, NULL, 'ABC transporter, substrate-binding protein, family 5', NULL, NULL, NULL, NULL, NULL, 4),
(152260, NULL, 'G3DSA:3.80.10.10:FF:001775', NULL, NULL, 'F-box/LRR-repeat protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(152261, NULL, 'G3DSA:2.40.50.90:FF:000057', NULL, NULL, 'Nuclease domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(152262, NULL, 'G3DSA:3.30.70.330:FF:001104', NULL, NULL, 'Putative RNA-binding protein EEED8.10', NULL, NULL, NULL, NULL, NULL, 4),
(152263, NULL, 'G3DSA:3.30.1680.10:FF:000011', NULL, NULL, 'Semaphorin 3B', NULL, NULL, NULL, NULL, NULL, 4),
(152264, NULL, 'G3DSA:3.30.230.80:FF:000010', NULL, NULL, 'Heat shock protein 75 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(152265, NULL, 'G3DSA:1.20.58.80:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152266, NULL, 'G3DSA:1.10.760.10:FF:000070', NULL, NULL, 'Cytochrome c peroxidase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(152267, NULL, 'G3DSA:1.20.1250.20:FF:001536', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152268, NULL, 'G3DSA:2.40.10.10:FF:000418', NULL, NULL, 'GH24985p', NULL, NULL, NULL, NULL, NULL, 4),
(152269, NULL, 'G3DSA:2.30.29.30:FF:000535', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(152270, NULL, 'G3DSA:3.40.50.11320:FF:000009', NULL, NULL, 'Os12g0581400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(152271, NULL, 'G3DSA:1.20.120.1630:FF:000011', NULL, NULL, 'Delta(14)-sterol reductase', NULL, NULL, NULL, NULL, NULL, 4),
(152272, NULL, 'G3DSA:3.40.50.720:FF:000428', NULL, NULL, 'Leucoanthocyanidin reductase', NULL, NULL, NULL, NULL, NULL, 4),
(152273, NULL, 'G3DSA:1.20.1250.20:FF:001188', NULL, NULL, 'WGS project CABT00000000 data, contig 2.10', NULL, NULL, NULL, NULL, NULL, 4),
(152274, NULL, 'G3DSA:3.40.1350.100:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152275, NULL, 'G3DSA:2.170.140.10:FF:000009', NULL, NULL, 'Chondroitin proteoglycan 1', NULL, NULL, NULL, NULL, NULL, 4),
(152276, NULL, 'G3DSA:2.130.10.10:FF:001696', NULL, NULL, 'WD repeats protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(152277, NULL, 'G3DSA:3.30.420.40:FF:000468', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(152278, NULL, 'G3DSA:3.30.60.270:FF:000011', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(152279, NULL, 'G3DSA:2.130.10.10:FF:000509', NULL, NULL, 'U3 small nucleolar RNA-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(152280, NULL, 'G3DSA:2.60.120.10:FF:000540', NULL, NULL, 'AER145Wp', NULL, NULL, NULL, NULL, NULL, 4),
(152281, NULL, 'G3DSA:3.40.50.150:FF:001516', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152282, NULL, 'G3DSA:2.60.120.10:FF:000484', NULL, NULL, 'Homogentisate 1,2-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(152283, NULL, 'G3DSA:3.90.70.10:FF:000210', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(152284, NULL, 'G3DSA:3.30.160.60:FF:004742', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152285, NULL, 'G3DSA:2.40.240.20:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152286, NULL, 'G3DSA:1.25.40.10:FF:001487', NULL, NULL, 'Os12g0552300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(152287, NULL, 'G3DSA:1.20.1250.20:FF:000019', NULL, NULL, 'Multidrug resistance protein B', NULL, NULL, NULL, NULL, NULL, 4),
(152288, NULL, 'G3DSA:3.30.260.10:FF:000070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152289, NULL, 'G3DSA:2.30.29.30:FF:000827', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152290, NULL, 'G3DSA:3.30.1370.10:FF:000089', NULL, NULL, 'BnaC09g50550D protein', NULL, NULL, NULL, NULL, NULL, 4),
(152291, NULL, 'G3DSA:1.20.1250.20:FF:000750', NULL, NULL, 'protein NRT1/ PTR FAMILY 5.4', NULL, NULL, NULL, NULL, NULL, 4),
(152292, NULL, 'G3DSA:3.40.20.10:FF:000024', NULL, NULL, 'Glia maturation factor', NULL, NULL, NULL, NULL, NULL, 4),
(152293, NULL, 'G3DSA:3.40.50.300:FF:007311', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152294, NULL, 'G3DSA:1.20.5.170:FF:000112', NULL, NULL, 'testis-specific serine kinase substrate', NULL, NULL, NULL, NULL, NULL, 4),
(152295, NULL, 'G3DSA:3.40.50.12760:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152296, NULL, 'G3DSA:3.40.50.720:FF:002030', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(152297, NULL, 'G3DSA:2.60.120.10:FF:000832', NULL, NULL, 'Transcriptional regulator (Crp/Fnr family)', NULL, NULL, NULL, NULL, NULL, 4),
(152298, NULL, 'G3DSA:2.40.50.1060:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152299, NULL, 'G3DSA:3.90.1210.10:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152300, NULL, 'G3DSA:1.10.10.2660:FF:000005', NULL, NULL, 'Ubiquitin-activating enzyme E1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152301, NULL, 'G3DSA:2.60.40.10:FF:000875', NULL, NULL, 'Interleukin 12 receptor subunit beta 2', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(152302, NULL, 'G3DSA:2.30.60.10:FF:000001', NULL, NULL, 'Cyanovirin-N', NULL, NULL, NULL, NULL, NULL, 4),
(152303, NULL, 'G3DSA:3.10.129.10:FF:000163', NULL, NULL, 'Thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(152304, NULL, 'G3DSA:2.30.29.30:FF:001103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152305, NULL, 'G3DSA:3.10.100.10:FF:000136', NULL, NULL, 'Mannose receptor, C type 2', NULL, NULL, NULL, NULL, NULL, 4),
(152306, NULL, 'G3DSA:3.30.70.2850:FF:000006', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(152307, NULL, 'G3DSA:2.60.40.150:FF:000108', NULL, NULL, 'Synaptotagmin like 1', NULL, NULL, NULL, NULL, NULL, 4),
(152308, NULL, 'G3DSA:1.25.10.10:FF:003109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152309, NULL, 'G3DSA:3.30.310.80:FF:000011', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(152310, NULL, 'G3DSA:1.20.1250.20:FF:001587', NULL, NULL, 'Monocarboxylate transporter 2, transcript variant X3', NULL, NULL, NULL, NULL, NULL, 4),
(152311, NULL, 'G3DSA:3.30.70.330:FF:001447', NULL, NULL, 'RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(152312, NULL, 'G3DSA:3.30.160.60:FF:005147', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152313, NULL, 'G3DSA:3.10.490.10:FF:000046', NULL, NULL, 'Putative gamma-glutamylcyclotransferase CG2811-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(152314, NULL, 'G3DSA:3.40.50.2000:FF:000654', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(152315, NULL, 'G3DSA:3.30.200.20:FF:001772', NULL, NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(152316, NULL, 'G3DSA:2.40.50.140:FF:000533', NULL, NULL, 'Aspartate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(152317, NULL, 'G3DSA:2.30.29.30:FF:000086', NULL, NULL, 'GRAM domain-containing protein 2B isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(152318, NULL, 'G3DSA:3.20.20.70:FF:000301', NULL, NULL, '2-nitropropane dioxygenase family', NULL, NULL, NULL, NULL, NULL, 4),
(152319, NULL, 'G3DSA:1.20.58.60:FF:000030', NULL, NULL, 'Short stop, isoform K', NULL, NULL, NULL, NULL, NULL, 4),
(152320, NULL, 'G3DSA:3.40.190.80:FF:000021', NULL, NULL, 'Myo-inositol-1(Or 4)-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(152321, NULL, 'G3DSA:1.25.10.10:FF:000355', NULL, NULL, 'Exportin-T', NULL, NULL, NULL, NULL, NULL, 4),
(152322, NULL, 'G3DSA:1.25.40.10:FF:002780', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152323, NULL, 'G3DSA:2.60.120.1190:FF:000002', NULL, NULL, 'epithelial discoidin domain-containing receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(152324, NULL, 'G3DSA:1.25.10.10:FF:001659', NULL, NULL, 'Subunit of TORC2 (Tor2p-Lst8p-Avo1-Avo2-Tsc11p-Bit61p), a membrane-associated complex that regulates actin cytoskeletal dynamics during polarized growth and cell wall integrity, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152325, NULL, 'G3DSA:2.60.40.10:FF:004186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152326, NULL, 'G3DSA:1.20.58.2130:FF:000001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152327, NULL, 'G3DSA:2.20.100.10:FF:000121', NULL, NULL, 'Lonely heart, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(152328, NULL, 'G3DSA:3.40.50.10490:FF:000142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152329, NULL, 'G3DSA:1.10.10.10:FF:000731', NULL, NULL, 'Phenazine-specific methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(152330, NULL, 'G3DSA:2.60.40.10:FF:000824', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(152331, NULL, 'G3DSA:2.60.120.10:FF:000091', NULL, NULL, 'cGMP-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(152332, NULL, 'G3DSA:3.30.450.20:FF:000407', NULL, NULL, 'Sensor histidine kinase, PAS, PAS and PAS domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(152333, NULL, 'G3DSA:1.10.10.10:FF:000170', NULL, NULL, 'Vacuolar protein-sorting-associated protein 36', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(152334, NULL, 'G3DSA:1.25.10.10:FF:002952', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152335, NULL, 'G3DSA:3.60.130.10:FF:000003', NULL, NULL, 'Alpha-ketoglutarate-dependent taurine dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(152336, NULL, 'G3DSA:1.20.90.10:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152337, NULL, 'G3DSA:1.10.510.10:FF:002676', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152338, NULL, 'G3DSA:2.120.10.80:FF:000177', NULL, NULL, 'Putative protein tag-53', NULL, NULL, NULL, NULL, NULL, 4),
(152339, NULL, 'G3DSA:1.20.5.570:FF:000001', NULL, NULL, '3-octaprenyl-4-hydroxybenzoate carboxy-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(152340, NULL, 'G3DSA:1.20.120.730:FF:000026', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(152341, NULL, 'G3DSA:3.40.50.11260:FF:000002', NULL, NULL, 'Molecular chaperone HtpG', NULL, NULL, NULL, NULL, NULL, 4),
(152342, NULL, 'G3DSA:2.60.40.10:FF:001100', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(152343, NULL, 'G3DSA:4.10.240.10:FF:000131', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(152344, NULL, 'G3DSA:2.70.98.10:FF:000119', NULL, NULL, 'Alpha-1,2-mannosidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(152345, NULL, 'G3DSA:2.60.120.290:FF:000058', NULL, NULL, 'CUB domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(152346, NULL, 'G3DSA:1.20.120.1750:FF:000030', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(152347, NULL, 'G3DSA:3.40.1230.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152348, NULL, 'G3DSA:3.30.1370.70:FF:000005', NULL, NULL, 'Type Fe-S cluster assembly protein NFU', NULL, NULL, NULL, NULL, NULL, 4),
(152349, NULL, 'G3DSA:3.40.532.10:FF:000020', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(152350, NULL, 'G3DSA:2.130.10.10:FF:004843', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152351, NULL, 'G3DSA:3.40.50.300:FF:001527', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(152352, NULL, 'G3DSA:2.40.30.10:FF:000184', NULL, NULL, 'Ferredoxin--NADP reductase', NULL, NULL, NULL, NULL, NULL, 4),
(152353, NULL, 'G3DSA:3.40.33.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152354, NULL, 'G3DSA:1.10.630.10:FF:000127', NULL, NULL, 'Cytochrome P450 Cyp124', NULL, NULL, NULL, NULL, NULL, 4),
(152355, NULL, 'G3DSA:3.30.70.330:FF:000143', NULL, NULL, 'msx2-interacting protein-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(152356, NULL, 'G3DSA:3.30.70.330:FF:001048', NULL, NULL, 'Nucleolar protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(152357, NULL, 'G3DSA:1.10.472.130:FF:000006', NULL, NULL, 'Dynein axonemal heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(152358, NULL, 'G3DSA:3.30.1370.10:FF:000145', NULL, NULL, 'KH domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(152359, NULL, 'G3DSA:1.10.10.10:FF:000063', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(152360, NULL, 'G3DSA:2.10.25.10:FF:001494', NULL, NULL, 'Scavenger receptor cysteine-rich protein variant 1', NULL, NULL, NULL, NULL, NULL, 4),
(152361, NULL, 'G3DSA:3.40.50.2300:FF:000682', NULL, NULL, 'Vomeronasal 2 receptor, x4', NULL, NULL, NULL, NULL, NULL, 4),
(152362, NULL, 'G3DSA:2.120.10.30:FF:000483', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(152363, NULL, 'G3DSA:1.20.5.170:FF:000056', NULL, NULL, 'DNA repair protein SWI5 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(152364, NULL, 'G3DSA:2.30.30.40:FF:000553', NULL, NULL, 'SH3 domain protein, conserved', NULL, NULL, NULL, NULL, NULL, 4),
(152365, NULL, 'G3DSA:1.25.10.10:FF:002660', NULL, NULL, 'ATPase H+-transporting V1 subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(152366, NULL, 'G3DSA:1.10.760.10:FF:000007', NULL, NULL, 'Cytochrome c peroxidase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(152367, NULL, 'G3DSA:3.30.465.10:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152368, NULL, 'G3DSA:3.30.160.60:FF:002218', NULL, NULL, 'Transcriptional regulator CRZ1', NULL, NULL, NULL, NULL, NULL, 4),
(152369, NULL, 'G3DSA:3.30.40.10:FF:001458', NULL, NULL, 'Peroxisome assembly protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152370, NULL, 'G3DSA:3.30.230.10:FF:000242', NULL, NULL, 'Galactokinase', NULL, NULL, NULL, NULL, NULL, 4),
(152371, NULL, 'G3DSA:3.30.470.20:FF:000122', NULL, NULL, 'Formate-dependent phosphoribosylglycinamide formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(152372, NULL, 'G3DSA:3.90.70.10:FF:000159', NULL, NULL, 'Ubiquitin-specific protease', NULL, NULL, NULL, NULL, NULL, 4),
(152373, NULL, 'G3DSA:3.30.450.20:FF:000290', NULL, NULL, 'Development and carotenogenesis control-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(152374, NULL, 'G3DSA:3.80.10.10:FF:003517', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152375, NULL, 'G3DSA:2.40.37.10:FF:000014', NULL, NULL, 'Ornithine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(152376, NULL, 'G3DSA:3.80.20.20:FF:000025', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(152377, NULL, 'G3DSA:3.10.110.10:FF:000018', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 G1', NULL, NULL, NULL, NULL, NULL, 4),
(152378, NULL, 'G3DSA:3.40.50.10190:FF:000114', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(152379, NULL, 'G3DSA:3.40.1810.10:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152380, NULL, 'G3DSA:3.10.100.10:FF:000187', NULL, NULL, 'Latrophilin-like protein LAT-2', NULL, NULL, NULL, NULL, NULL, 4),
(152381, NULL, 'G3DSA:2.60.40.10:FF:004747', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152382, NULL, 'G3DSA:3.30.565.10:FF:000278', NULL, NULL, 'Sporulation-specific ATP-dependent proteinhistidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(152383, NULL, 'G3DSA:3.40.50.10810:FF:000137', NULL, NULL, 'Helicase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(152384, NULL, 'G3DSA:3.30.9.10:FF:000144', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(152385, NULL, 'G3DSA:1.25.10.10:FF:002148', NULL, NULL, 'Os01g0235400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(152386, NULL, 'G3DSA:3.40.630.30:FF:000512', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152387, NULL, 'G3DSA:3.30.9.10:FF:000200', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase (FAD-dependent), putative', NULL, NULL, NULL, NULL, NULL, 4),
(152388, NULL, 'G3DSA:3.90.1010.10:FF:000003', NULL, NULL, 'NifU family SUF system Fe-S assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(152389, NULL, 'G3DSA:2.60.120.260:FF:000566', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(152390, NULL, 'G3DSA:1.20.58.60:FF:000822', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152391, NULL, 'G3DSA:3.40.50.620:FF:000724', NULL, NULL, 'Nicotinamide-nucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(152392, NULL, 'G3DSA:3.30.420.10:FF:000072', NULL, NULL, 'DNA-directed DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(152393, NULL, 'G3DSA:2.160.20.10:FF:000138', NULL, NULL, 'Putative pectinesterase/pectinesterase inhibitor 54', NULL, NULL, NULL, NULL, NULL, 4),
(152394, NULL, 'G3DSA:3.80.10.10:FF:003225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152395, NULL, 'G3DSA:3.80.10.10:FF:001196', NULL, NULL, 'F-box/LRR-repeat protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(152396, NULL, 'G3DSA:3.20.20.80:FF:000051', NULL, NULL, 'glycogen debranching enzyme isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(152397, NULL, 'G3DSA:3.30.470.20:FF:000173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152398, NULL, 'G3DSA:3.80.10.10:FF:003169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152399, NULL, 'G3DSA:3.30.54.20:FF:000004', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(152400, NULL, 'G3DSA:1.20.120.160:FF:000046', NULL, NULL, 'Diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(152401, NULL, 'G3DSA:1.10.8.60:FF:000537', NULL, NULL, 'Peroxisome biogenesis factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152402, NULL, 'G3DSA:3.40.390.10:FF:000206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152403, NULL, 'G3DSA:2.60.40.10:FF:005315', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152404, NULL, 'G3DSA:1.10.10.10:FF:000675', NULL, NULL, 'Cell division cycle-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(152405, NULL, 'G3DSA:1.10.10.10:FF:001131', NULL, NULL, 'Winged helix-turn-helix transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(152406, NULL, 'G3DSA:2.120.10.80:FF:000126', NULL, NULL, 'Calicin', NULL, NULL, NULL, NULL, NULL, 4),
(152407, NULL, 'G3DSA:1.10.20.10:FF:000288', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152408, NULL, 'G3DSA:1.20.120.1750:FF:000081', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(152409, NULL, 'G3DSA:2.60.120.290:FF:000114', NULL, NULL, 'AGAP004160-PA', NULL, NULL, NULL, NULL, NULL, 4),
(152410, NULL, 'G3DSA:1.25.10.10:FF:000299', NULL, NULL, 'Protein phosphatase 4 regulatory subunit 1-like (pseudogene)', NULL, NULL, NULL, NULL, NULL, 4),
(152411, NULL, 'G3DSA:3.30.160.60:FF:002269', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152412, NULL, 'G3DSA:2.60.40.10:FF:001044', NULL, NULL, 'TAP binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(152413, NULL, 'G3DSA:3.30.450.20:FF:000470', NULL, NULL, 'Period', NULL, NULL, NULL, NULL, NULL, 4),
(152414, NULL, 'G3DSA:3.30.450.40:FF:000296', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(152415, NULL, 'G3DSA:3.40.50.720:FF:002553', NULL, NULL, '17-beta-hydroxysteroid dehydrogenase type 4', NULL, NULL, NULL, NULL, NULL, 4),
(152416, NULL, 'G3DSA:1.10.10.10:FF:000855', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(152417, NULL, 'G3DSA:3.30.420.10:FF:000021', NULL, NULL, 'RNA exonuclease 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(152418, NULL, 'G3DSA:1.10.460.10:FF:000030', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(152419, NULL, 'G3DSA:3.30.500.40:FF:000002', NULL, NULL, 'Zinc finger FYVE domain-containing protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(152420, NULL, 'G3DSA:1.10.510.10:FF:003906', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152421, NULL, 'G3DSA:1.10.418.10:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152422, NULL, 'G3DSA:2.60.120.380:FF:000080', NULL, NULL, 'AGAP012907-PA', NULL, NULL, NULL, NULL, NULL, 4),
(152423, NULL, 'G3DSA:3.30.70.330:FF:000087', NULL, NULL, 'Nucleolysin TIAR isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(152424, NULL, 'G3DSA:2.60.300.12:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152425, NULL, 'G3DSA:3.80.10.10:FF:003568', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(152426, NULL, 'G3DSA:3.40.1190.20:FF:000199', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152427, NULL, 'G3DSA:3.30.1440.10:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152428, NULL, 'G3DSA:2.60.40.4100:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152429, NULL, 'G3DSA:3.40.630.60:FF:000004', NULL, NULL, 'Putative Ornithine decarboxylase antizyme', NULL, NULL, NULL, NULL, NULL, 4),
(152430, NULL, 'G3DSA:1.50.10.10:FF:000230', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(152431, NULL, 'G3DSA:2.130.10.10:FF:005063', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(152432, NULL, 'G3DSA:3.40.718.10:FF:000064', NULL, NULL, 'Isocitrate dehydrogenase [NAD] subunit alpha, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(152433, NULL, 'G3DSA:3.20.20.150:FF:000042', NULL, NULL, 'Xylose isomerase domain protein TIM barrel', NULL, NULL, NULL, NULL, NULL, 4),
(152434, NULL, 'G3DSA:3.30.70.1050:FF:000006', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(152435, NULL, 'G3DSA:1.10.275.20:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152436, NULL, 'G3DSA:2.60.120.260:FF:000223', NULL, NULL, 'F5/8 type C domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(152437, NULL, 'G3DSA:3.40.850.10:FF:000337', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(152438, NULL, 'G3DSA:2.40.30.110:FF:000009', NULL, NULL, 'Glycine cleavage system T protein', NULL, NULL, NULL, NULL, NULL, 4),
(152439, NULL, 'G3DSA:3.90.550.10:FF:000399', NULL, NULL, 'Glycosyltransferase, group 2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(152440, NULL, 'G3DSA:3.30.420.60:FF:000007', NULL, NULL, 'Eukaryotic peptide chain release factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(152441, NULL, 'G3DSA:1.20.5.340:FF:000129', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(152442, NULL, 'G3DSA:2.60.40.10:FF:004354', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152443, NULL, 'G3DSA:3.40.50.300:FF:000297', NULL, NULL, 'Uridine-cytidine kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(152444, NULL, 'G3DSA:2.130.10.10:FF:001191', NULL, NULL, 'WD repeat-containing protein 48', NULL, NULL, NULL, NULL, NULL, 4),
(152445, NULL, 'G3DSA:3.40.1110.10:FF:000146', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(152446, NULL, 'G3DSA:3.30.559.10:FF:000106', NULL, NULL, 'Spermidine sinapoyl-CoA acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(152447, NULL, 'G3DSA:1.10.418.10:FF:000145', NULL, NULL, 'WGS project CABT00000000 data, contig 2.3', NULL, NULL, NULL, NULL, NULL, 4),
(152448, NULL, 'G3DSA:1.10.510.10:FF:002732', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152449, NULL, 'G3DSA:1.10.10.60:FF:001180', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152450, NULL, 'G3DSA:3.40.50.300:FF:001590', NULL, NULL, 'DNA polymerase III, delta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(152451, NULL, 'G3DSA:1.20.120.520:FF:000002', NULL, NULL, 'F-box/LRR-repeat protein 5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(152452, NULL, 'G3DSA:2.40.330.10:FF:000009', NULL, NULL, 'Transcriptional factor B3 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(152453, NULL, 'G3DSA:2.60.15.10:FF:000007', NULL, NULL, 'ATP synthase epsilon chain', NULL, NULL, NULL, NULL, NULL, 4),
(152454, NULL, 'G3DSA:3.30.1490.70:FF:000008', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(152455, NULL, 'G3DSA:1.20.120.350:FF:000277', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152456, NULL, 'G3DSA:3.40.640.10:FF:000456', NULL, NULL, 'DegT/DnrJ/EryC1/StrS aminotransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(152457, NULL, 'G3DSA:3.20.20.80:FF:000523', NULL, NULL, 'Alpha-L-arabinofuranosidase A', NULL, NULL, NULL, NULL, NULL, 4),
(152458, NULL, 'G3DSA:3.30.160.60:FF:006260', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152459, NULL, 'G3DSA:2.60.40.10:FF:001095', NULL, NULL, 'Interleukin 22 receptor, alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(152460, NULL, 'G3DSA:1.10.275.40:FF:000018', NULL, NULL, 'Helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152461, NULL, 'G3DSA:2.130.10.10:FF:000392', NULL, NULL, 'WD repeat-containing protein 37', NULL, NULL, NULL, NULL, NULL, 4),
(152462, NULL, 'G3DSA:3.40.390.10:FF:000257', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152463, NULL, 'G3DSA:3.40.50.1000:FF:000270', NULL, NULL, 'Nuclear envelope-endoplasmic reticulum network protein', NULL, NULL, NULL, NULL, NULL, 4),
(152464, NULL, 'G3DSA:3.40.50.300:FF:006873', NULL, NULL, 'Branched-chain amino acid ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(152465, NULL, 'G3DSA:3.60.130.10:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152466, NULL, 'G3DSA:2.30.31.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152467, NULL, 'G3DSA:3.40.640.10:FF:000243', NULL, NULL, 'Cytochrome D ubiquinol oxidase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(152468, NULL, 'G3DSA:1.10.10.60:FF:000381', NULL, NULL, 'Transcription factor MYB119', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(152469, NULL, 'G3DSA:2.30.29.30:FF:000878', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152470, NULL, 'G3DSA:1.20.1070.10:FF:000305', NULL, NULL, 'Sphingosine 1-phosphate receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(152471, NULL, 'G3DSA:2.60.40.10:FF:000083', NULL, NULL, 'Sortilin-related VPS10 domain containing receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(152472, NULL, 'G3DSA:3.30.40.10:FF:000672', NULL, NULL, 'E3 ubiquitin-protein ligase ATL41', NULL, NULL, NULL, NULL, NULL, 4),
(152473, NULL, 'G3DSA:2.130.10.110:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152474, NULL, 'G3DSA:2.40.10.10:FF:000481', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152475, NULL, 'G3DSA:3.40.50.300:FF:005861', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(152476, NULL, 'G3DSA:1.10.1600.10:FF:000001', NULL, NULL, 'X-ray repair cross-complementing protein 6 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(152477, NULL, 'G3DSA:3.10.20.230:FF:000012', NULL, NULL, 'Doublecortin domain containing 2C', NULL, NULL, NULL, NULL, NULL, 4),
(152478, NULL, 'G3DSA:1.10.472.10:FF:000422', NULL, NULL, 'Cyclin-T1-5', NULL, NULL, NULL, NULL, NULL, 4),
(152479, NULL, 'G3DSA:3.40.718.10:FF:000013', NULL, NULL, 'Tartrate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(152480, NULL, 'G3DSA:3.30.200.20:FF:002553', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152481, NULL, 'G3DSA:1.10.510.10:FF:003457', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152482, NULL, 'G3DSA:1.20.58.60:FF:000479', NULL, NULL, 'Microtubule-actin crosslinking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(152483, NULL, 'G3DSA:1.10.8.10:FF:000371', NULL, NULL, 'Nascent polypeptide-associated complex subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(152484, NULL, 'G3DSA:3.40.50.300:FF:005529', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(152485, NULL, 'G3DSA:2.60.40.10:FF:003461', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152486, NULL, 'G3DSA:1.10.30.10:FF:000002', NULL, NULL, 'transcription factor Sox-2', NULL, NULL, NULL, NULL, NULL, 4),
(152487, NULL, 'G3DSA:3.40.570.10:FF:000012', NULL, NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase 2', NULL, NULL, NULL, NULL, NULL, 4),
(152488, NULL, 'G3DSA:3.30.70.330:FF:000666', NULL, NULL, 'UBP1-associated protein 2A', NULL, NULL, NULL, NULL, NULL, 4),
(152489, NULL, 'G3DSA:3.30.1330.40:FF:000016', NULL, NULL, 'Endoribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(152490, NULL, 'G3DSA:2.60.40.640:FF:000042', NULL, NULL, 'Vacuolar sorting-associated protein-like,putative', NULL, NULL, NULL, NULL, NULL, 4),
(152491, NULL, 'G3DSA:1.20.1070.10:FF:000704', NULL, NULL, 'NeuroPeptide Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(152492, NULL, 'G3DSA:2.60.220.50:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152493, NULL, 'G3DSA:1.10.3730.20:FF:000019', NULL, NULL, 'DMT family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(152494, NULL, 'G3DSA:1.25.10.10:FF:000586', NULL, NULL, 'Microtubule-associated protein TORTIFOLIA1', NULL, NULL, NULL, NULL, NULL, 4),
(152495, NULL, 'G3DSA:3.30.497.10:FF:000158', NULL, NULL, 'Serpin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152496, NULL, 'G3DSA:2.60.120.10:FF:000596', NULL, NULL, 'cGMP-dependent protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152497, NULL, 'G3DSA:1.25.40.90:FF:000049', NULL, NULL, 'ZFP family member, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152498, NULL, 'G3DSA:1.25.10.10:FF:000642', NULL, NULL, 'TATA-binding protein-associated factor BTAF1', NULL, NULL, NULL, NULL, NULL, 4),
(152499, NULL, 'G3DSA:1.20.1390.10:FF:000015', NULL, NULL, 'RNA-binding protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(152500, NULL, 'G3DSA:2.10.110.10:FF:000056', NULL, NULL, 'insulin gene enhancer protein ISL-1', NULL, NULL, NULL, NULL, NULL, 4),
(152501, NULL, 'G3DSA:1.10.150.240:FF:000123', NULL, NULL, 'Phosphoglycolate phosphatase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(152502, NULL, 'G3DSA:3.40.50.300:FF:001258', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(152503, NULL, 'G3DSA:3.40.605.10:FF:000049', NULL, NULL, 'CRE-ALH-9 protein', NULL, NULL, NULL, NULL, NULL, 4),
(152504, NULL, 'G3DSA:1.10.3710.10:FF:000015', NULL, NULL, 'ATP/GTP-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(152505, NULL, 'G3DSA:2.30.40.10:FF:000062', NULL, NULL, 'Pyrimidine deaminase archaeal predicted', NULL, NULL, NULL, NULL, NULL, 4),
(152506, NULL, 'G3DSA:1.10.720.60:FF:000003', NULL, NULL, 'Enolase-phosphatase E1', NULL, NULL, NULL, NULL, NULL, 4),
(152507, NULL, 'G3DSA:3.30.70.960:FF:000006', NULL, NULL, 'Suppressor of tumorigenicity 14 protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(152508, NULL, 'G3DSA:2.60.40.2130:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152509, NULL, 'G3DSA:2.60.40.10:FF:005602', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152510, NULL, 'G3DSA:3.30.70.330:FF:002852', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152511, NULL, 'G3DSA:3.30.200.20:FF:000367', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(152512, NULL, 'G3DSA:3.40.50.2000:FF:000182', NULL, NULL, 'UDP-N-acetylglucosamine transferase subunit ALG14 isogeny', NULL, NULL, NULL, NULL, NULL, 4),
(152513, NULL, 'G3DSA:3.40.1650.10:FF:000001', NULL, NULL, 'L-fucose mutarotase', NULL, NULL, NULL, NULL, NULL, 4),
(152514, NULL, 'G3DSA:3.40.50.2300:FF:000114', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(152515, NULL, 'G3DSA:3.30.160.60:FF:000240', NULL, NULL, 'Zinc finger protein 250', NULL, NULL, NULL, NULL, NULL, 4),
(152516, NULL, 'G3DSA:1.20.58.60:FF:000535', NULL, NULL, 'Nesprin-3', NULL, NULL, NULL, NULL, NULL, 4),
(152517, NULL, 'G3DSA:2.130.10.10:FF:002477', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(152518, NULL, 'G3DSA:3.30.43.10:FF:000026', NULL, NULL, 'Aldehyde oxidase 4', NULL, NULL, NULL, NULL, NULL, 4),
(152519, NULL, 'G3DSA:3.30.60.20:FF:000153', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(152520, NULL, 'G3DSA:3.30.70.660:FF:000074', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(152521, NULL, 'G3DSA:2.30.30.100:FF:000093', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm4', NULL, NULL, NULL, NULL, NULL, 4),
(152522, NULL, 'G3DSA:3.90.1150.10:FF:000221', NULL, NULL, 'Lysine decarboxylase, constitutive', NULL, NULL, NULL, NULL, NULL, 4),
(152523, NULL, 'G3DSA:3.10.290.10:FF:000065', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(152524, NULL, 'G3DSA:1.10.510.10:FF:003513', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152525, NULL, 'G3DSA:3.40.50.1820:FF:001089', NULL, NULL, 'Hydrolase, alpha/beta fold family protein, putative, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(152526, NULL, 'G3DSA:2.30.140.10:FF:000014', NULL, NULL, 'Polyamine aminopropyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(152527, NULL, 'G3DSA:3.30.70.330:FF:000559', NULL, NULL, 'U11/U12 small nuclear ribonucleoprotein 65 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(152528, NULL, 'G3DSA:3.30.160.60:FF:004455', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152529, NULL, 'G3DSA:2.60.120.470:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152530, NULL, 'G3DSA:3.40.640.10:FF:000512', NULL, NULL, 'Serine--pyruvate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(152531, NULL, 'G3DSA:2.30.29.30:FF:000030', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(152532, NULL, 'G3DSA:1.20.1300.10:FF:000015', NULL, NULL, 'Succinate dehydrogenase cytochrome B subunit', NULL, NULL, NULL, NULL, NULL, 4),
(152533, NULL, 'G3DSA:3.90.1150.10:FF:000165', NULL, NULL, 'Probable L-lysine-epsilon aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(152534, NULL, 'G3DSA:3.20.20.140:FF:000213', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(152535, NULL, 'G3DSA:3.30.40.10:FF:001565', NULL, NULL, 'YALI0B22088p', NULL, NULL, NULL, NULL, NULL, 4),
(152536, NULL, 'G3DSA:3.40.50.720:FF:001884', NULL, NULL, 'Protein CBG22303', NULL, NULL, NULL, NULL, NULL, 4),
(152537, NULL, 'G3DSA:1.10.357.40:FF:000006', NULL, NULL, 'Riboflavin biosynthesis protein VVA0006', NULL, NULL, NULL, NULL, NULL, 4),
(152538, NULL, 'G3DSA:3.30.160.60:FF:002325', NULL, NULL, 'Si:cabz01021430.2', NULL, NULL, NULL, NULL, NULL, 4),
(152539, NULL, 'G3DSA:3.40.50.80:FF:000176', NULL, NULL, 'FAD-binding domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(152540, NULL, 'G3DSA:2.40.10.10:FF:000149', NULL, NULL, 'Inactive serine protease 35', NULL, NULL, NULL, NULL, NULL, 4),
(152541, NULL, 'G3DSA:3.40.50.300:FF:000746', NULL, NULL, 'Ribosome assembly protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(152542, NULL, 'G3DSA:3.90.1310.10:FF:000043', NULL, NULL, 'Penicillin binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(152543, NULL, 'G3DSA:3.40.50.10260:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152544, NULL, 'G3DSA:1.10.8.10:FF:000039', NULL, NULL, 'HBS1-like translational GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(152545, NULL, 'G3DSA:3.30.160.60:FF:005759', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152546, NULL, 'G3DSA:1.10.1410.40:FF:000006', NULL, NULL, 'Inositol 1,4,5-trisphosphate receptor-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(152547, NULL, 'G3DSA:3.80.10.10:FF:001988', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152548, NULL, 'G3DSA:1.10.8.960:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152549, NULL, 'G3DSA:2.60.40.10:FF:001313', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(152550, NULL, 'G3DSA:1.20.1110.10:FF:000259', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152551, NULL, 'G3DSA:1.25.40.10:FF:002268', NULL, NULL, 'Pentatricopeptide repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(152552, NULL, 'G3DSA:3.50.7.10:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152553, NULL, 'G3DSA:2.130.10.10:FF:004950', NULL, NULL, 'WD-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152554, NULL, 'G3DSA:3.30.60.20:FF:000097', NULL, NULL, 'CYtoKinesis defect', NULL, NULL, NULL, NULL, NULL, 4),
(152555, NULL, 'G3DSA:3.90.79.10:FF:000258', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(152556, NULL, 'G3DSA:3.10.20.90:FF:000717', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152557, NULL, 'G3DSA:3.40.50.300:FF:006530', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152558, NULL, 'G3DSA:3.40.1550.20:FF:000002', NULL, NULL, 'Transcriptional regulator MraZ', NULL, NULL, NULL, NULL, NULL, 4),
(152559, NULL, 'G3DSA:3.30.160.60:FF:000184', NULL, NULL, 'Zinc finger protein 333', NULL, NULL, NULL, NULL, NULL, 4),
(152560, NULL, 'G3DSA:2.10.110.10:FF:000112', NULL, NULL, 'Rho GTPase activator (Lrg11)', NULL, NULL, NULL, NULL, NULL, 4),
(152561, NULL, 'G3DSA:1.10.10.10:FF:001423', NULL, NULL, 'BLM RecQ like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(152562, NULL, 'G3DSA:3.40.50.10490:FF:000035', NULL, NULL, '30S ribosomal protein S2', NULL, NULL, NULL, NULL, NULL, 4),
(152563, NULL, 'G3DSA:3.30.70.330:FF:002796', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152564, NULL, 'G3DSA:3.30.200.20:FF:000423', NULL, NULL, 'L-type lectin-domain containing receptor kinase S.1', NULL, NULL, NULL, NULL, NULL, 4),
(152565, NULL, 'G3DSA:1.20.1560.10:FF:000287', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(152566, NULL, 'G3DSA:2.10.70.10:FF:000053', NULL, NULL, 'CUB and Sushi multiple domains 3', NULL, NULL, NULL, NULL, NULL, 4),
(152567, NULL, 'G3DSA:1.20.970.10:FF:000004', NULL, NULL, 'Thymidine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(152568, NULL, 'G3DSA:3.30.1370.240:FF:000007', NULL, NULL, 'Phenylalanine--tRNA ligase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(152569, NULL, 'G3DSA:3.40.50.150:FF:000717', NULL, NULL, 'Dihydroaeruginoic acid synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(152570, NULL, 'G3DSA:3.40.225.10:FF:000008', NULL, NULL, 'Sugar aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(152571, NULL, 'G3DSA:3.30.160.60:FF:001544', NULL, NULL, 'Zinc finger protein 69', NULL, NULL, NULL, NULL, NULL, 4),
(152572, NULL, 'G3DSA:2.130.10.10:FF:006024', NULL, NULL, 'Centriole proteome protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(152573, NULL, 'G3DSA:3.10.310.20:FF:000003', NULL, NULL, 'Prune exopolyphosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(152574, NULL, 'G3DSA:2.60.40.1170:FF:000035', NULL, NULL, 'Coatomer subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(152575, NULL, 'G3DSA:1.10.3430.10:FF:000033', NULL, NULL, 'Solute carrier family 14 member 2', NULL, NULL, NULL, NULL, NULL, 4),
(152576, NULL, 'G3DSA:3.40.50.80:FF:000069', NULL, NULL, 'POSSIBLE OXYGENASE', NULL, NULL, NULL, NULL, NULL, 4),
(152577, NULL, 'G3DSA:3.20.20.30:FF:000025', NULL, NULL, 'LLM class F420-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(152578, NULL, 'G3DSA:2.60.40.10:FF:004803', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152579, NULL, 'G3DSA:3.10.330.10:FF:000001', NULL, NULL, 'Cell division control 48', NULL, NULL, NULL, NULL, NULL, 4),
(152580, NULL, 'G3DSA:1.20.990.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152581, NULL, 'G3DSA:4.10.520.10:FF:000006', NULL, NULL, 'DNA-binding protein HU', NULL, NULL, NULL, NULL, NULL, 4),
(152582, NULL, 'G3DSA:1.10.437.20:FF:000001', NULL, NULL, 'N1L', NULL, NULL, NULL, NULL, NULL, 4),
(152583, NULL, 'G3DSA:2.60.40.60:FF:001070', NULL, NULL, 'Si:dkey-1m11.6', NULL, NULL, NULL, NULL, NULL, 4),
(152584, NULL, 'G3DSA:3.40.50.1000:FF:000562', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152585, NULL, 'G3DSA:2.60.40.1770:FF:000007', NULL, NULL, 'Ephrin receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(152586, NULL, 'G3DSA:1.10.3020.10:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152587, NULL, 'G3DSA:1.10.238.10:FF:000103', NULL, NULL, 'Troponin C Ib', NULL, NULL, NULL, NULL, NULL, 4),
(152588, NULL, 'G3DSA:1.25.40.10:FF:003117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152589, NULL, 'G3DSA:1.10.472.130:FF:000057', NULL, NULL, 'Inner dynein arm I1 heavy chain 1-ALPHA', NULL, NULL, NULL, NULL, NULL, 4),
(152590, NULL, 'G3DSA:2.60.40.150:FF:000440', NULL, NULL, 'Arrestin domain-containing protein B', NULL, NULL, NULL, NULL, NULL, 4),
(152591, NULL, 'G3DSA:3.90.1030.20:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152592, NULL, 'G3DSA:3.80.10.10:FF:003337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152593, NULL, 'G3DSA:3.40.50.2300:FF:000390', NULL, NULL, 'Branched-chain amino acid ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(152594, NULL, 'G3DSA:3.30.160.60:FF:003730', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152595, NULL, 'G3DSA:1.25.40.10:FF:005141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152596, NULL, 'G3DSA:1.10.1300.10:FF:000017', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(152597, NULL, 'G3DSA:3.90.70.200:FF:000001', NULL, NULL, 'RNA polymerase-associated protein RTF1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(152598, NULL, 'G3DSA:3.40.50.300:FF:003731', NULL, NULL, 'GM17994', NULL, NULL, NULL, NULL, NULL, 4),
(152599, NULL, 'G3DSA:2.60.40.10:FF:005259', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152600, NULL, 'G3DSA:2.60.200.30:FF:000024', NULL, NULL, 'Inorganic polyphosphate/ATP-NAD kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152601, NULL, 'G3DSA:2.170.130.10:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152602, NULL, 'G3DSA:1.25.40.20:FF:000416', NULL, NULL, 'E3 ubiquitin-protein ligase XB3', NULL, NULL, NULL, NULL, NULL, 4),
(152603, NULL, 'G3DSA:2.60.40.10:FF:000532', NULL, NULL, 'Vascular endothelial growth factor receptor 2', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(152604, NULL, 'G3DSA:3.60.10.10:FF:000073', NULL, NULL, 'Inositol phosphosphingolipid phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(152605, NULL, 'G3DSA:1.10.10.10:FF:000624', NULL, NULL, 'PCI domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(152606, NULL, 'G3DSA:3.40.640.10:FF:000187', NULL, NULL, 'Biotin F', NULL, NULL, NULL, NULL, NULL, 4),
(152607, NULL, 'G3DSA:3.90.550.10:FF:000724', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152608, NULL, 'G3DSA:2.40.160.110:FF:000034', NULL, NULL, 'Lysosomal-associated membrane protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(152609, NULL, 'G3DSA:3.40.50.10380:FF:000002', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(152610, NULL, 'G3DSA:3.30.420.10:FF:000526', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152611, NULL, 'G3DSA:3.40.50.1000:FF:000724', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152612, NULL, 'G3DSA:3.30.750.44:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152613, NULL, 'G3DSA:3.30.160.60:FF:004399', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152614, NULL, 'G3DSA:1.20.1250.20:FF:002043', NULL, NULL, 'General alpha-glucoside permease', NULL, NULL, NULL, NULL, NULL, 4),
(152615, NULL, 'G3DSA:2.130.10.10:FF:004894', NULL, NULL, 'Pre-rRNA-processing protein IPI3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152616, NULL, 'G3DSA:1.10.287.70:FF:000678', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152617, NULL, 'G3DSA:1.10.730.10:FF:000186', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(152618, NULL, 'G3DSA:1.10.1170.10:FF:000023', NULL, NULL, 'Baculoviral IAP repeat-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(152619, NULL, 'G3DSA:2.120.10.80:FF:000233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152620, NULL, 'G3DSA:1.10.1530.10:FF:000006', NULL, NULL, 'Ureidoglycolate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(152621, NULL, 'G3DSA:3.30.1330.30:FF:000070', NULL, NULL, 'Ribosomal protein L7Ae, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152622, NULL, 'G3DSA:1.20.1250.20:FF:002205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152623, NULL, 'G3DSA:3.30.200.20:FF:002508', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152624, NULL, 'G3DSA:3.50.30.30:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152625, NULL, 'G3DSA:3.40.50.300:FF:002932', NULL, NULL, 'Putative AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(152626, NULL, 'G3DSA:3.50.50.60:FF:000826', NULL, NULL, 'Probable FAD-dependent oxidoreductase PA4991', NULL, NULL, NULL, NULL, NULL, 4),
(152627, NULL, 'G3DSA:1.10.860.10:FF:000010', NULL, NULL, 'Replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(152628, NULL, 'G3DSA:2.130.10.10:FF:002533', NULL, NULL, 'F-box/WD-40 repeat-containing protein At5g21040', NULL, NULL, NULL, NULL, NULL, 4),
(152629, NULL, 'G3DSA:2.130.10.10:FF:002657', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152630, NULL, 'G3DSA:3.30.565.10:FF:000547', NULL, NULL, 'DNA gyrase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(152631, NULL, 'G3DSA:3.30.70.3270:FF:000003', NULL, NULL, 'NADH-quinone oxidoreductase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(152632, NULL, 'G3DSA:3.40.140.10:FF:000255', NULL, NULL, 'Protein CBG16582', NULL, NULL, NULL, NULL, NULL, 4),
(152633, NULL, 'G3DSA:3.40.50.150:FF:000555', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase H', NULL, NULL, NULL, NULL, NULL, 4),
(152634, NULL, 'G3DSA:3.40.50.2300:FF:000058', NULL, NULL, 'Two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(152635, NULL, 'G3DSA:3.40.50.11050:FF:000001', NULL, NULL, 'Toxin B', NULL, NULL, NULL, NULL, NULL, 4),
(152636, NULL, 'G3DSA:1.25.40.10:FF:000470', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g66520', NULL, NULL, NULL, NULL, NULL, 4),
(152637, NULL, 'G3DSA:3.40.50.2020:FF:000188', NULL, NULL, 'Dynein heavy chain 9', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(152638, NULL, 'G3DSA:2.40.30.10:FF:000420', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152639, NULL, 'G3DSA:1.25.40.180:FF:000252', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152640, NULL, 'G3DSA:1.10.390.10:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152641, NULL, 'G3DSA:3.30.70.3290:FF:000009', NULL, NULL, 'Fatty acid synthase 2, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(152642, NULL, 'G3DSA:3.30.70.330:FF:000379', NULL, NULL, 'la-related protein 7 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(152643, NULL, 'G3DSA:3.40.50.300:FF:008328', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152644, NULL, 'G3DSA:2.60.120.330:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152645, NULL, 'G3DSA:1.10.520.10:FF:000029', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(152646, NULL, 'G3DSA:3.20.20.60:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152647, NULL, 'G3DSA:3.40.50.1820:FF:000364', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(152648, NULL, 'G3DSA:3.10.450.40:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152649, NULL, 'G3DSA:2.20.100.10:FF:000177', NULL, NULL, 'SCO-spondin', NULL, NULL, NULL, NULL, NULL, 4),
(152650, NULL, 'G3DSA:1.25.40.90:FF:000105', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(152651, NULL, 'G3DSA:3.40.50.1100:FF:000187', NULL, NULL, 'L-threonine dehydratase catabolic TdcB', NULL, NULL, NULL, NULL, NULL, 4),
(152652, NULL, 'G3DSA:3.40.50.300:FF:002039', NULL, NULL, 'ABC multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152653, NULL, 'G3DSA:2.120.10.80:FF:000357', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(152654, NULL, 'G3DSA:1.25.10.10:FF:002772', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152655, NULL, 'G3DSA:2.60.120.10:FF:000776', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152656, NULL, 'G3DSA:3.30.200.20:FF:001148', NULL, NULL, 'Si:ch211-171h4.3', NULL, NULL, NULL, NULL, NULL, 4),
(152657, NULL, 'G3DSA:1.25.40.80:FF:000007', NULL, NULL, 'Cryptochrome 4', NULL, NULL, NULL, NULL, NULL, 4),
(152658, NULL, 'G3DSA:3.40.50.170:FF:000038', NULL, NULL, 'Phosphoribosylglycinamide formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(152659, NULL, 'G3DSA:3.10.110.10:FF:000249', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152660, NULL, 'G3DSA:3.40.50.300:FF:007042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152661, NULL, 'G3DSA:2.60.40.10:FF:001948', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(152662, NULL, 'G3DSA:3.40.50.150:FF:001229', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152663, NULL, 'G3DSA:1.20.58.90:FF:000022', NULL, NULL, 'Tubulin-specific chaperone A', NULL, NULL, NULL, NULL, NULL, 4),
(152664, NULL, 'G3DSA:2.60.40.150:FF:000552', NULL, NULL, 'Paired amphipathic helix SIN3-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(152665, NULL, 'G3DSA:3.40.470.10:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152666, NULL, 'G3DSA:1.20.900.10:FF:000017', NULL, NULL, 'pleckstrin homology domain-containing family G member 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(152667, NULL, 'G3DSA:1.10.8.730:FF:000001', NULL, NULL, 'PrgJ', NULL, NULL, NULL, NULL, NULL, 4),
(152668, NULL, 'G3DSA:2.40.160.210:FF:000007', NULL, NULL, 'Probable peroxisomal acyl-coenzyme A thioester hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(152669, NULL, 'G3DSA:1.20.870.10:FF:000019', NULL, NULL, 'Rap guanine nucleotide exchange factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(152670, NULL, 'G3DSA:1.10.10.790:FF:000028', NULL, NULL, 'Splicing factor putative', NULL, NULL, NULL, NULL, NULL, 4),
(152671, NULL, 'G3DSA:1.25.10.10:FF:001024', NULL, NULL, 'Importin subunit alpha-3, putative', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(152672, NULL, 'G3DSA:2.60.40.420:FF:000212', NULL, NULL, 'cDNA FLJ37971 fis, clone CTONG2009958, highly similar to CERULOPLASMIN', NULL, NULL, NULL, NULL, NULL, 4),
(152673, NULL, 'G3DSA:2.30.30.40:FF:000160', NULL, NULL, 'dynamin-binding protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(152674, NULL, 'G3DSA:1.10.418.10:FF:000252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152675, NULL, 'G3DSA:1.10.150.240:FF:000067', NULL, NULL, 'Putative phosphatase YhcW', NULL, NULL, NULL, NULL, NULL, 4),
(152676, NULL, 'G3DSA:2.60.40.10:FF:000588', NULL, NULL, 'Cell adhesion molecule 4', NULL, NULL, NULL, NULL, NULL, 4),
(152677, NULL, 'G3DSA:3.90.640.10:FF:000226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152678, NULL, 'G3DSA:1.10.10.10:FF:000911', NULL, NULL, 'HTH-type transcriptional regulator NorG', NULL, NULL, NULL, NULL, NULL, 4),
(152679, NULL, 'G3DSA:2.130.10.10:FF:005967', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152680, NULL, 'G3DSA:1.10.340.70:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152681, NULL, 'G3DSA:3.30.70.3490:FF:000013', NULL, NULL, 'Oxysterol-binding protein-related protein 2A', NULL, NULL, NULL, NULL, NULL, 4),
(152682, NULL, 'G3DSA:1.20.5.1010:FF:000002', NULL, NULL, 'Transient receptor potential cation channel subfamily M member 7', NULL, NULL, NULL, NULL, NULL, 4),
(152683, NULL, 'G3DSA:3.40.390.10:FF:000026', NULL, NULL, 'Pappalysin 1', NULL, NULL, NULL, NULL, NULL, 4),
(152684, NULL, 'G3DSA:3.60.60.10:FF:000020', NULL, NULL, 'Acyl-coenzyme A:6-aminopenicillanic acid acyl-transferase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(152685, NULL, 'G3DSA:1.25.40.60:FF:000001', NULL, NULL, 'syntaxin-binding protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(152686, NULL, 'G3DSA:3.30.930.10:FF:000048', NULL, NULL, 'Serine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(152687, NULL, 'G3DSA:1.25.40.20:FF:000692', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152688, NULL, 'G3DSA:3.40.50.10140:FF:000060', NULL, NULL, 'Toll-Interleukin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(152689, NULL, 'G3DSA:3.40.50.720:FF:000136', NULL, NULL, 'ATP-citrate synthase beta chain protein', NULL, NULL, NULL, NULL, NULL, 4),
(152690, NULL, 'G3DSA:2.30.39.10:FF:000030', NULL, NULL, 'Serpin 2', NULL, NULL, NULL, NULL, NULL, 4),
(152691, NULL, 'G3DSA:1.20.144.10:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152692, NULL, 'G3DSA:3.30.1520.10:FF:000123', NULL, NULL, 'Phosphatidylinositol 3-kinase piki-1', NULL, NULL, NULL, NULL, NULL, 4),
(152693, NULL, 'G3DSA:1.10.30.10:FF:000058', NULL, NULL, 'IXR1p Transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(152694, NULL, 'G3DSA:1.25.10.10:FF:000804', NULL, NULL, 'Phosphoinositide 3-kinase regulatory subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(152695, NULL, 'G3DSA:1.20.58.70:FF:000072', NULL, NULL, 'Syntaxin-16', NULL, NULL, NULL, NULL, NULL, 4),
(152696, NULL, 'G3DSA:2.40.30.270:FF:000012', NULL, NULL, 'ATP-dependent 5''-3'' DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(152697, NULL, 'G3DSA:3.40.50.300:FF:005417', NULL, NULL, 'P-loop nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(152698, NULL, 'G3DSA:3.60.20.10:FF:000242', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152699, NULL, 'G3DSA:1.25.40.10:FF:000975', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(152700, NULL, 'G3DSA:3.20.180.20:FF:000012', NULL, NULL, 'Dynein Heavy Chain', NULL, NULL, NULL, NULL, NULL, 4),
(152701, NULL, 'G3DSA:3.80.10.10:FF:001483', NULL, NULL, 'Insulin like growth factor binding protein acid labile subunit', NULL, NULL, NULL, NULL, NULL, 4),
(152702, NULL, 'G3DSA:3.90.70.10:FF:000502', NULL, NULL, 'Ubiquitin-specific protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152703, NULL, 'G3DSA:3.40.47.10:FF:000001', NULL, NULL, '3-ketoacyl-CoA thiolase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(152704, NULL, 'G3DSA:2.20.130.20:FF:000007', NULL, NULL, 'Alpha-2-macroglobulin like 1', NULL, NULL, NULL, NULL, NULL, 4),
(152705, NULL, 'G3DSA:1.20.1600.10:FF:000055', NULL, NULL, 'Outer membrane efflux protein', NULL, NULL, NULL, NULL, NULL, 4),
(152706, NULL, 'G3DSA:3.20.20.80:FF:000630', NULL, NULL, 'Os05g0366200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(152707, NULL, 'G3DSA:1.20.1070.10:FF:001997', NULL, NULL, 'Protein CBR-GNRR-8', NULL, NULL, NULL, NULL, NULL, 4),
(152708, NULL, 'G3DSA:3.10.110.10:FF:000305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152709, NULL, 'G3DSA:3.30.70.370:FF:000020', NULL, NULL, 'DNA polymerase family A', NULL, NULL, NULL, NULL, NULL, 4),
(152710, NULL, 'G3DSA:3.40.50.300:FF:007603', NULL, NULL, 'ATP-binding cassette subfamily F member 2', NULL, NULL, NULL, NULL, NULL, 4),
(152711, NULL, 'G3DSA:2.60.120.200:FF:000756', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152712, NULL, 'G3DSA:3.30.160.60:FF:000745', NULL, NULL, 'zinc finger protein 181 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(152713, NULL, 'G3DSA:3.30.200.20:FF:000187', NULL, NULL, 'Cell division control protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(152714, NULL, 'G3DSA:1.25.40.10:FF:001195', NULL, NULL, 'GD10841', NULL, NULL, NULL, NULL, NULL, 4),
(152715, NULL, 'G3DSA:2.60.40.10:FF:003281', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152716, NULL, 'G3DSA:2.10.109.10:FF:000042', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(152717, NULL, 'G3DSA:3.40.50.2300:FF:000238', NULL, NULL, 'Diguanylate cyclase (GGDEF) domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(152718, NULL, 'G3DSA:3.10.250.10:FF:000124', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152719, NULL, 'G3DSA:3.40.50.12780:FF:000132', NULL, NULL, '8-demethylnovobiocic acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(152720, NULL, 'G3DSA:3.40.50.300:FF:004512', NULL, NULL, 'DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(152721, NULL, 'G3DSA:2.40.30.300:FF:000004', NULL, NULL, 'ATP dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(152722, NULL, 'G3DSA:2.40.50.90:FF:000113', NULL, NULL, 'Tudor domain-containing 12', NULL, NULL, NULL, NULL, NULL, 4),
(152723, NULL, 'G3DSA:1.25.40.10:FF:004286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152724, NULL, 'G3DSA:3.30.470.20:FF:000066', NULL, NULL, 'Acetyl coenzyme A synthetase (ADP forming), alpha domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(152725, NULL, 'G3DSA:3.40.30.10:FF:000474', NULL, NULL, 'Zeta class glutathione transferase GSTZ1', NULL, NULL, NULL, NULL, NULL, 4),
(152726, NULL, 'G3DSA:3.30.2160.10:FF:000045', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(152727, NULL, 'G3DSA:3.30.160.40:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152728, NULL, 'G3DSA:3.40.50.1820:FF:001706', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152729, NULL, 'G3DSA:1.10.10.580:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152730, NULL, 'G3DSA:3.10.410.10:FF:000002', NULL, NULL, '10-formyltetrahydrofolate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(152731, NULL, 'G3DSA:1.25.40.10:FF:004342', NULL, NULL, 'At2g37400', NULL, NULL, NULL, NULL, NULL, 4),
(152732, NULL, 'G3DSA:2.40.70.10:FF:000254', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152733, NULL, 'G3DSA:1.10.472.10:FF:000310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152734, NULL, 'G3DSA:3.30.40.10:FF:001689', NULL, NULL, 'YALI0C16390p', NULL, NULL, NULL, NULL, NULL, 4),
(152735, NULL, 'G3DSA:1.10.1200.10:FF:000021', NULL, NULL, 'Isochorismatase', NULL, NULL, NULL, NULL, NULL, 4),
(152736, NULL, 'G3DSA:2.40.50.140:FF:000825', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152737, NULL, 'G3DSA:1.25.40.10:FF:001936', NULL, NULL, 'EMB2750', NULL, NULL, NULL, NULL, NULL, 4),
(152738, NULL, 'G3DSA:2.40.30.10:FF:000476', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(152739, NULL, 'G3DSA:3.40.50.300:FF:004456', NULL, NULL, 'Dynein heavy chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(152740, NULL, 'G3DSA:3.30.40.10:FF:002021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152741, NULL, 'G3DSA:2.60.40.420:FF:000268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152742, NULL, 'G3DSA:3.30.70.270:FF:000007', NULL, NULL, 'Membrane-associated phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(152743, NULL, 'G3DSA:3.40.50.620:FF:000275', NULL, NULL, 'Probable cysteinyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(152744, NULL, 'G3DSA:2.130.10.10:FF:004551', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152745, NULL, 'G3DSA:2.60.40.790:FF:000165', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152746, NULL, 'G3DSA:3.60.21.10:FF:000098', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(152747, NULL, 'G3DSA:1.10.238.10:FF:000608', NULL, NULL, 'mRNA, clone: RTFL01-44-H24', NULL, NULL, NULL, NULL, NULL, 4),
(152748, NULL, 'G3DSA:3.80.10.10:FF:002444', NULL, NULL, 'Receptor like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(152749, NULL, 'G3DSA:3.90.550.10:FF:000163', NULL, NULL, 'Van1p', NULL, NULL, NULL, NULL, NULL, 4),
(152750, NULL, 'G3DSA:3.30.200.20:FF:000928', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(152751, NULL, 'G3DSA:3.50.50.60:FF:001102', NULL, NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(152752, NULL, 'G3DSA:1.10.510.10:FF:004238', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152753, NULL, 'G3DSA:3.30.70.250:FF:000001', NULL, NULL, 'Malonyl CoA-acyl carrier protein transacylase', NULL, NULL, NULL, NULL, NULL, 4),
(152754, NULL, 'G3DSA:3.40.50.2000:FF:000362', NULL, NULL, 'soyasaponin III rhamnosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(152755, NULL, 'G3DSA:2.60.40.10:FF:004242', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152756, NULL, 'G3DSA:1.10.20.10:FF:000176', NULL, NULL, 'Histone H2B', NULL, NULL, NULL, NULL, NULL, 4),
(152757, NULL, 'G3DSA:3.40.190.10:FF:000837', NULL, NULL, 'Phosphonate ABC transporter, periplasmic phosphonate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(152758, NULL, 'G3DSA:3.40.50.300:FF:006586', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152759, NULL, 'G3DSA:1.10.3470.10:FF:000030', NULL, NULL, 'Fe(3+)-hydroxamate ABC transporter permease FhuB', NULL, NULL, NULL, NULL, NULL, 4),
(152760, NULL, 'G3DSA:3.30.160.20:FF:000020', NULL, NULL, 'Peptide chain release factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(152761, NULL, 'G3DSA:3.30.200.20:FF:001204', NULL, NULL, 'Probable inactive receptor kinase At5g67200', NULL, NULL, NULL, NULL, NULL, 4),
(152762, NULL, 'G3DSA:1.25.40.10:FF:000071', NULL, NULL, 'Putative mitochondrial import receptor subunit TOM70', NULL, NULL, NULL, NULL, NULL, 4),
(152763, NULL, 'G3DSA:1.25.40.10:FF:000632', NULL, NULL, 'Pre-mRNA splicing factor (Prp24), putative', NULL, NULL, NULL, NULL, NULL, 4),
(152764, NULL, 'G3DSA:2.60.120.590:FF:000030', NULL, NULL, '2OG-Fe(II)_oxygenase_superfamily_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(152765, NULL, 'G3DSA:3.90.640.10:FF:000046', NULL, NULL, 'Actin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152766, NULL, 'G3DSA:1.25.40.10:FF:002212', NULL, NULL, 'Mitochondrial fission 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(152767, NULL, 'G3DSA:2.60.40.60:FF:000013', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor', NULL, NULL, NULL, NULL, NULL, 4),
(152768, NULL, 'G3DSA:1.10.510.10:FF:002097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152769, NULL, 'G3DSA:3.30.160.60:FF:004978', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152770, NULL, 'G3DSA:1.10.510.10:FF:000023', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(152771, NULL, 'G3DSA:1.25.40.10:FF:004865', NULL, NULL, 'Vacuolar protein sorting-associated protein 41', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(152772, NULL, 'G3DSA:3.40.50.300:FF:008166', NULL, NULL, 'Eukaryotic translation initiation factor 2 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(152773, NULL, 'G3DSA:2.60.40.3510:FF:000018', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(152774, NULL, 'G3DSA:2.40.30.10:FF:000077', NULL, NULL, 'Putative translation elongation/initiation factor family protein', NULL, NULL, NULL, NULL, NULL, 4),
(152775, NULL, 'G3DSA:3.30.160.60:FF:001021', NULL, NULL, 'zinc finger and BTB domain-containing protein 17 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(152776, NULL, 'G3DSA:2.130.10.10:FF:005350', NULL, NULL, 'Damage-specific DNA binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152777, NULL, 'G3DSA:3.40.250.10:FF:000084', NULL, NULL, 'MercaptoPyruvate SulfurTransferase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(152778, NULL, 'G3DSA:3.30.70.330:FF:002291', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152779, NULL, 'G3DSA:3.90.110.10:FF:000017', NULL, NULL, 'Malate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(152780, NULL, 'G3DSA:3.30.230.10:FF:000135', NULL, NULL, 'Ribonuclease P protein component', NULL, NULL, NULL, NULL, NULL, 4),
(152781, NULL, 'G3DSA:3.30.70.1400:FF:000021', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(152782, NULL, 'G3DSA:2.60.120.200:FF:000812', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152783, NULL, 'G3DSA:3.40.630.10:FF:000181', NULL, NULL, 'Succinyl-diaminopimelate desuccinylase', NULL, NULL, NULL, NULL, NULL, 4),
(152784, NULL, 'G3DSA:1.20.1270.10:FF:000017', NULL, NULL, 'Heat shock protein family A (Hsp70) member 4', NULL, NULL, NULL, NULL, NULL, 4),
(152785, NULL, 'G3DSA:1.10.510.10:FF:000528', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(152786, NULL, 'G3DSA:2.60.120.650:FF:000088', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(152787, NULL, 'G3DSA:1.10.10.10:FF:001928', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152788, NULL, 'G3DSA:2.70.130.10:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152789, NULL, 'G3DSA:2.60.40.10:FF:000931', NULL, NULL, 'V-set and immunoglobulin domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(152790, NULL, 'G3DSA:4.10.320.10:FF:000025', NULL, NULL, '2-oxo acid dehydrogenases acyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152791, NULL, 'G3DSA:1.20.1730.10:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152792, NULL, 'G3DSA:4.10.240.10:FF:000024', NULL, NULL, 'Proline utilization trans-activator', NULL, NULL, NULL, NULL, NULL, 4),
(152793, NULL, 'G3DSA:2.60.120.200:FF:000071', NULL, NULL, 'Hydroxyproline O-galactosyltransferase GALT2', NULL, NULL, NULL, NULL, NULL, 4),
(152794, NULL, 'G3DSA:3.30.40.10:FF:000784', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(152795, NULL, 'G3DSA:1.20.1560.10:FF:000231', NULL, NULL, 'ABC transporter, ATP-binding/permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(152796, NULL, 'G3DSA:2.30.30.940:FF:000013', NULL, NULL, 'ATP-dependent RecD-like DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(152797, NULL, 'G3DSA:2.60.120.200:FF:000195', NULL, NULL, 'Lys-gingipain W83', NULL, NULL, NULL, NULL, NULL, 4),
(152798, NULL, 'G3DSA:3.40.50.620:FF:000836', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152799, NULL, 'G3DSA:1.10.238.10:FF:000047', NULL, NULL, 'Calcineurin subunit B type 1', NULL, NULL, NULL, NULL, NULL, 4),
(152800, NULL, 'G3DSA:3.10.450.700:FF:000002', NULL, NULL, 'Transcription factor Pur-alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(152801, NULL, 'G3DSA:2.10.25.10:FF:000325', NULL, NULL, 'Mutant fibrillin-1', NULL, NULL, NULL, NULL, NULL, 4),
(152802, NULL, 'G3DSA:1.25.40.1040:FF:000006', NULL, NULL, 'CFIA complex component Rna14, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152803, NULL, 'G3DSA:1.10.10.10:FF:001187', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(152804, NULL, 'G3DSA:2.130.10.10:FF:003438', NULL, NULL, 'GPI inositol-deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(152805, NULL, 'G3DSA:2.60.120.290:FF:000002', NULL, NULL, 'Signal peptide, CUB domain and EGF-like domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(152806, NULL, 'G3DSA:3.30.360.10:FF:000139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152807, NULL, 'G3DSA:3.40.50.2000:FF:000761', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152808, NULL, 'G3DSA:3.30.160.60:FF:003674', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152809, NULL, 'G3DSA:3.40.525.10:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152810, NULL, 'G3DSA:4.10.280.10:FF:000201', NULL, NULL, 'Hms1p', NULL, NULL, NULL, NULL, NULL, 4),
(152811, NULL, 'G3DSA:4.10.280.10:FF:000021', NULL, NULL, 'Transcription factor bHLH130 family', NULL, NULL, NULL, NULL, NULL, 4),
(152812, NULL, 'G3DSA:2.70.130.10:FF:000100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152813, NULL, 'G3DSA:1.20.140.150:FF:000081', NULL, NULL, 'Calcium channel, voltage-dependent, gamma subunit 8a', NULL, NULL, NULL, NULL, NULL, 4),
(152814, NULL, 'G3DSA:2.60.40.150:FF:000496', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152815, NULL, 'G3DSA:1.20.58.60:FF:000878', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152816, NULL, 'G3DSA:1.25.10.10:FF:001603', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152817, NULL, 'G3DSA:2.60.40.60:FF:000850', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152818, NULL, 'G3DSA:3.30.300.30:FF:000136', NULL, NULL, 'Beta-alanine-activating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(152819, NULL, 'G3DSA:1.20.120.350:FF:000221', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152820, NULL, 'G3DSA:3.30.70.270:FF:000283', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152821, NULL, 'G3DSA:1.20.1070.10:FF:001492', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(152822, NULL, 'G3DSA:2.130.10.30:FF:000162', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152823, NULL, 'G3DSA:1.10.287.130:FF:000258', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(152824, NULL, 'G3DSA:1.10.287.70:FF:000173', NULL, NULL, 'glutamate receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(152825, NULL, 'G3DSA:2.60.120.620:FF:000146', NULL, NULL, 'Zgc:174917', NULL, NULL, NULL, NULL, NULL, 4),
(152826, NULL, 'G3DSA:3.40.250.10:FF:000140', NULL, NULL, 'Rhodanese-like domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(152827, NULL, 'G3DSA:3.90.870.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152828, NULL, 'G3DSA:1.25.40.10:FF:005303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152829, NULL, 'G3DSA:2.40.420.20:FF:000008', NULL, NULL, 'RND family efflux transporter, MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(152830, NULL, 'G3DSA:3.90.950.10:FF:000036', NULL, NULL, 'Maf-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(152831, NULL, 'G3DSA:2.170.150.20:FF:000007', NULL, NULL, 'Protein cereblon', NULL, NULL, NULL, NULL, NULL, 4),
(152832, NULL, 'G3DSA:1.25.40.240:FF:000005', NULL, NULL, 'ATP-dependent DNA helicase II subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(152833, NULL, 'G3DSA:1.10.10.650:FF:000003', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(152834, NULL, 'G3DSA:2.40.50.100:FF:000044', NULL, NULL, 'exosome complex component RRP40', NULL, NULL, NULL, NULL, NULL, 4),
(152835, NULL, 'G3DSA:3.40.50.300:FF:003495', NULL, NULL, 'Ras homolog family member Q', NULL, NULL, NULL, NULL, NULL, 4),
(152836, NULL, 'G3DSA:1.20.930.40:FF:000005', NULL, NULL, 'putative N-acetylated-alpha-linked acidic dipeptidase isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(152837, NULL, 'G3DSA:3.40.50.300:FF:007946', NULL, NULL, 'Si:ch211-241b2.5', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(152838, NULL, 'G3DSA:1.10.510.10:FF:000860', NULL, NULL, 'Serine/threonine-protein kinase ENV7', NULL, NULL, NULL, NULL, NULL, 4),
(152839, NULL, 'G3DSA:1.10.287.70:FF:000734', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152840, NULL, 'G3DSA:3.40.30.10:FF:001255', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(152841, NULL, 'G3DSA:1.20.1250.20:FF:000463', NULL, NULL, 'Nitrate transporter CrnA', NULL, NULL, NULL, NULL, NULL, 4),
(152842, NULL, 'G3DSA:1.20.5.170:FF:000168', NULL, NULL, 'AP-1-like transcription factor YAP2', NULL, NULL, NULL, NULL, NULL, 4),
(152843, NULL, 'G3DSA:3.30.540.30:FF:000007', NULL, NULL, 'Dipeptidyl peptidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(152844, NULL, 'G3DSA:3.30.40.10:FF:001745', NULL, NULL, 'YALI0B14443p', NULL, NULL, NULL, NULL, NULL, 4),
(152845, NULL, 'G3DSA:3.40.50.300:FF:000802', NULL, NULL, 'Sulfate adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(152846, NULL, 'G3DSA:3.80.10.10:FF:002500', NULL, NULL, 'Leucine Rich Repeat family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(152847, NULL, 'G3DSA:1.10.20.10:FF:000232', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152848, NULL, 'G3DSA:2.40.50.140:FF:000769', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152849, NULL, 'G3DSA:1.10.510.10:FF:004418', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152850, NULL, 'G3DSA:1.10.510.10:FF:000708', NULL, NULL, 'serine/threonine-protein kinase par-1-like', NULL, NULL, NULL, NULL, NULL, 4),
(152851, NULL, 'G3DSA:1.25.10.10:FF:000243', NULL, NULL, 'Putative Vacuolar protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(152852, NULL, 'G3DSA:3.30.160.60:FF:004635', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152853, NULL, 'G3DSA:2.130.10.10:FF:000004', NULL, NULL, 'F-box/WD repeat-containing protein 11 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(152854, NULL, 'G3DSA:1.10.238.10:FF:000446', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(152855, NULL, 'G3DSA:3.30.700.10:FF:000003', NULL, NULL, 'Type IV pilin', NULL, NULL, NULL, NULL, NULL, 4),
(152856, NULL, 'G3DSA:2.30.30.30:FF:000044', NULL, NULL, 'Elongation factor P', NULL, NULL, NULL, NULL, NULL, 4),
(152857, NULL, 'G3DSA:1.10.150.60:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152858, NULL, 'G3DSA:1.10.4040.10:FF:000003', NULL, NULL, 'Transcriptional regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152859, NULL, 'G3DSA:3.40.50.12430:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152860, NULL, 'G3DSA:3.30.590.10:FF:000004', NULL, NULL, 'Glutamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(152861, NULL, 'G3DSA:2.120.10.80:FF:000413', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152862, NULL, 'G3DSA:2.30.34.10:FF:000002', NULL, NULL, 'Leishmanolysin-like peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(152863, NULL, 'G3DSA:2.60.34.10:FF:000023', NULL, NULL, '70 kDa heat shock cognate protein', NULL, NULL, NULL, NULL, NULL, 4),
(152864, NULL, 'G3DSA:1.20.1250.20:FF:001823', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152865, NULL, 'G3DSA:3.30.2130.30:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152866, NULL, 'G3DSA:3.30.200.20:FF:000243', NULL, NULL, 'serine/threonine-protein kinase Nek8', NULL, NULL, NULL, NULL, NULL, 4),
(152867, NULL, 'G3DSA:2.60.40.10:FF:003129', NULL, NULL, 'Solute carrier family 35 member C2', NULL, NULL, NULL, NULL, NULL, 4),
(152868, NULL, 'G3DSA:3.90.70.10:FF:000446', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 32', NULL, NULL, NULL, NULL, NULL, 4),
(152869, NULL, 'G3DSA:2.60.40.10:FF:002729', NULL, NULL, 'Muscle M-line assembly protein unc-89-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(152870, NULL, 'G3DSA:1.10.1370.10:FF:000022', NULL, NULL, 'Mitochondrial intermediate peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(152871, NULL, 'G3DSA:1.20.85.10:FF:000004', NULL, NULL, 'Photosynthetic reaction center subunit M', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(152872, NULL, 'G3DSA:3.90.1150.10:FF:000401', NULL, NULL, 'Protein CBG19479', NULL, NULL, NULL, NULL, NULL, 4),
(152873, NULL, 'G3DSA:3.100.10.10:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152874, NULL, 'G3DSA:3.90.420.10:FF:000007', NULL, NULL, 'Sulfite:cytochrome c oxidoreductase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(152875, NULL, 'G3DSA:2.30.170.40:FF:000002', NULL, NULL, '50S ribosomal protein L28', NULL, NULL, NULL, NULL, NULL, 4),
(152876, NULL, 'G3DSA:2.160.10.10:FF:000025', NULL, NULL, 'Hexapeptide-repeat containing-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(152877, NULL, 'G3DSA:3.30.1520.10:FF:000067', NULL, NULL, 'Unplaced genomic scaffold supercont1.259, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(152878, NULL, 'G3DSA:1.10.533.10:FF:000059', NULL, NULL, 'Fas-associated via death domain', NULL, NULL, NULL, NULL, NULL, 4),
(152879, NULL, 'G3DSA:2.30.30.40:FF:000665', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152880, NULL, 'G3DSA:2.60.260.20:FF:000143', NULL, NULL, 'Chaperone protein DnaJ 2', NULL, NULL, NULL, NULL, NULL, 4),
(152881, NULL, 'G3DSA:3.40.50.620:FF:000437', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(152882, NULL, 'G3DSA:3.40.50.1820:FF:001145', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(152883, NULL, 'G3DSA:3.10.50.40:FF:000047', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(152884, NULL, 'G3DSA:3.30.160.60:FF:001201', NULL, NULL, 'Zinc finger protein 217', NULL, NULL, NULL, NULL, NULL, 4),
(152885, NULL, 'G3DSA:3.90.340.10:FF:000006', NULL, NULL, 'Nitric oxide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(152886, NULL, 'G3DSA:1.20.58.610:FF:000002', NULL, NULL, 'Hsp90 co-chaperone Cdc37, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152887, NULL, 'G3DSA:1.25.40.10:FF:004685', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152888, NULL, 'G3DSA:1.25.40.1030:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152889, NULL, 'G3DSA:1.10.8.60:FF:000301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152890, NULL, 'G3DSA:3.40.50.300:FF:004113', NULL, NULL, 'Putative ABC Transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(152891, NULL, 'G3DSA:3.10.20.90:FF:000993', NULL, NULL, 'Sorting nexin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152892, NULL, 'G3DSA:3.40.50.1820:FF:001437', NULL, NULL, 'Lysosomal acid lipase/cholesteryl ester hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152893, NULL, 'G3DSA:3.40.50.720:FF:000012', NULL, NULL, 'C-terminal-binding protein 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(152894, NULL, 'G3DSA:1.20.58.60:FF:000187', NULL, NULL, 'SEC14 domain and spectrin repeat-containing protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(152895, NULL, 'G3DSA:2.60.40.1400:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152896, NULL, 'G3DSA:1.10.472.10:FF:000523', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152897, NULL, 'G3DSA:2.60.120.200:FF:000447', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(152898, NULL, 'G3DSA:1.10.10.10:FF:001760', NULL, NULL, 'Regulatory protein RecX', NULL, NULL, NULL, NULL, NULL, 4),
(152899, NULL, 'G3DSA:3.40.50.1100:FF:000266', NULL, NULL, 'Os06g0564400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(152900, NULL, 'G3DSA:3.50.50.60:FF:001411', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152901, NULL, 'G3DSA:3.30.9.10:FF:000060', NULL, NULL, 'FAD dependent oxidoreductase superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(152902, NULL, 'G3DSA:3.30.450.20:FF:000374', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(152903, NULL, 'G3DSA:1.20.1250.20:FF:000570', NULL, NULL, 'Glucose transporter, lmgt1', NULL, NULL, NULL, NULL, NULL, 4),
(152904, NULL, 'G3DSA:3.20.20.140:FF:000404', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(152905, NULL, 'G3DSA:1.20.120.290:FF:000006', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase CYP38, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(152906, NULL, 'G3DSA:2.60.40.10:FF:005411', NULL, NULL, 'Beta-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(152907, NULL, 'G3DSA:3.30.200.20:FF:001171', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152908, NULL, 'G3DSA:3.60.40.10:FF:000081', NULL, NULL, 'protein phosphatase 1G isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(152909, NULL, 'G3DSA:3.80.10.10:FF:001595', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3', NULL, NULL, NULL, NULL, NULL, 4),
(152910, NULL, 'G3DSA:1.10.1300.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152911, NULL, 'G3DSA:3.30.750.24:FF:000160', NULL, NULL, 'Sodium-independent sulfate anion transporter-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(152912, NULL, 'G3DSA:2.30.29.30:FF:000850', NULL, NULL, 'SHC (Src homology 2 domain-containing)-transforming protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(152913, NULL, 'G3DSA:3.30.70.1840:FF:000001', NULL, NULL, 'Putative spike glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(152914, NULL, 'G3DSA:4.10.280.10:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152915, NULL, 'G3DSA:3.40.50.720:FF:000451', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(152916, NULL, 'G3DSA:1.25.40.790:FF:000018', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(152917, NULL, 'G3DSA:3.40.50.300:FF:008519', NULL, NULL, 'Protein CBR-CDC-48.3', NULL, NULL, NULL, NULL, NULL, 4),
(152918, NULL, 'G3DSA:3.10.20.90:FF:000745', NULL, NULL, 'Autophagy protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(152919, NULL, 'G3DSA:2.60.120.310:FF:000025', NULL, NULL, 'Dopamine beta-hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(152920, NULL, 'G3DSA:2.20.110.10:FF:000026', NULL, NULL, 'MORN repeat containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(152921, NULL, 'G3DSA:2.40.30.130:FF:000015', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(152922, NULL, 'G3DSA:3.90.1180.10:FF:000009', NULL, NULL, '60S ribosomal protein L13a', NULL, NULL, NULL, NULL, NULL, 4),
(152923, NULL, 'G3DSA:2.60.40.10:FF:003157', NULL, NULL, 'Chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(152924, NULL, 'G3DSA:3.30.160.60:FF:001145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152925, NULL, 'G3DSA:1.10.167.10:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152926, NULL, 'G3DSA:1.10.510.10:FF:003805', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152927, NULL, 'G3DSA:3.30.160.60:FF:004904', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152928, NULL, 'G3DSA:3.80.10.10:FF:000134', NULL, NULL, 'F-box and leucine rich repeat protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(152929, NULL, 'G3DSA:1.20.1250.20:FF:001716', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152930, NULL, 'G3DSA:1.20.120.350:FF:000148', NULL, NULL, 'Sodium/hydrogen exchanger 10-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(152931, NULL, 'G3DSA:3.40.50.10330:FF:000111', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(152932, NULL, 'G3DSA:3.40.640.10:FF:000372', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152933, NULL, 'G3DSA:2.130.10.10:FF:003770', NULL, NULL, 'WD repeat-containing protein 34-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(152934, NULL, 'G3DSA:2.130.10.10:FF:000055', NULL, NULL, 'DDB1 and CUL4-associated factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(152935, NULL, 'G3DSA:3.40.50.880:FF:000127', NULL, NULL, 'Catalase-3', NULL, NULL, NULL, NULL, NULL, 4),
(152936, NULL, 'G3DSA:2.60.40.10:FF:002168', NULL, NULL, 'Protein roller-3', NULL, NULL, NULL, NULL, NULL, 4),
(152937, NULL, 'G3DSA:2.40.50.140:FF:001270', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(152938, NULL, 'G3DSA:3.10.490.20:FF:000038', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(152939, NULL, 'G3DSA:1.10.287.70:FF:000077', NULL, NULL, 'Potassium channel subfamily K member 5', NULL, NULL, NULL, NULL, NULL, 4),
(152940, NULL, 'G3DSA:1.10.286.10:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152941, NULL, 'G3DSA:3.90.79.10:FF:000022', NULL, NULL, 'Nudix hydrolase 17, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(152942, NULL, 'G3DSA:2.60.40.10:FF:001549', NULL, NULL, 'Sidekick, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(152943, NULL, 'G3DSA:3.40.50.200:FF:000194', NULL, NULL, 'Clan SB, family S8, subtilisin-like serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(152944, NULL, 'G3DSA:1.10.645.10:FF:000004', NULL, NULL, 'Hydrogenase 3, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(152945, NULL, 'G3DSA:2.10.25.10:FF:000134', NULL, NULL, 'Transmembrane agrin', NULL, NULL, NULL, NULL, NULL, 4),
(152946, NULL, 'G3DSA:3.40.50.2000:FF:000906', NULL, NULL, 'UDP-glycosyltransferase 71B1', NULL, NULL, NULL, NULL, NULL, 4),
(152947, NULL, 'G3DSA:3.50.50.60:FF:000894', NULL, NULL, 'Probable malate:quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(152948, NULL, 'G3DSA:1.25.10.10:FF:000451', NULL, NULL, 'Coatomer subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(152949, NULL, 'G3DSA:3.30.160.60:FF:002617', NULL, NULL, 'Kruppel like factor 18', NULL, NULL, NULL, NULL, NULL, 4),
(152950, NULL, 'G3DSA:3.40.50.1820:FF:000818', NULL, NULL, 'Plipastatin synthase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(152951, NULL, 'G3DSA:1.20.1070.10:FF:002121', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(152952, NULL, 'G3DSA:3.90.190.10:FF:000152', NULL, NULL, 'Tyrosine phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152953, NULL, 'G3DSA:3.30.565.10:FF:000379', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152954, NULL, 'G3DSA:3.30.40.10:FF:001857', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152955, NULL, 'G3DSA:1.20.1280.50:FF:000131', NULL, NULL, 'F-box/LRR-repeat protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(152956, NULL, 'G3DSA:1.20.1250.20:FF:002335', NULL, NULL, 'Solute carrier family 2 member 10', NULL, NULL, NULL, NULL, NULL, 4),
(152957, NULL, 'G3DSA:3.10.50.10:FF:000004', NULL, NULL, 'Chitinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(152958, NULL, 'G3DSA:2.130.10.30:FF:000111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152959, NULL, 'G3DSA:1.50.10.10:FF:000050', NULL, NULL, 'G-protein coupled receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152960, NULL, 'G3DSA:3.80.10.10:FF:002904', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152961, NULL, 'G3DSA:1.25.10.10:FF:002912', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152962, NULL, 'G3DSA:3.30.70.330:FF:000267', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(152963, NULL, 'G3DSA:1.10.3720.10:FF:000179', NULL, NULL, 'Amino acid ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(152964, NULL, 'G3DSA:1.20.58.1280:FF:000004', NULL, NULL, 'DNA repair protein REV1', NULL, NULL, NULL, NULL, NULL, 4),
(152965, NULL, 'G3DSA:2.30.29.220:FF:000008', NULL, NULL, 'FACT complex subunit SSRP1', NULL, NULL, NULL, NULL, NULL, 4),
(152966, NULL, 'G3DSA:3.30.1590.10:FF:000004', NULL, NULL, 'Malto-oligosyltrehalose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(152967, NULL, 'G3DSA:3.30.420.40:FF:001058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152968, NULL, 'G3DSA:1.20.5.50:FF:000005', NULL, NULL, 'Fibrinogen gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(152969, NULL, 'G3DSA:1.20.1270.60:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152970, NULL, 'G3DSA:1.10.533.10:FF:000295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152971, NULL, 'G3DSA:3.40.390.10:FF:000049', NULL, NULL, 'Kell blood group, metallo-endopeptidase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(152972, NULL, 'G3DSA:3.40.50.2000:FF:000423', NULL, NULL, 'AGAP008401-PA', NULL, NULL, NULL, NULL, NULL, 4),
(152973, NULL, 'G3DSA:1.20.1250.10:FF:000078', NULL, NULL, 'Kit ligand', NULL, NULL, NULL, NULL, NULL, 4),
(152974, NULL, 'G3DSA:3.40.630.30:FF:000304', NULL, NULL, 'YghO protein', NULL, NULL, NULL, NULL, NULL, 4),
(152975, NULL, 'G3DSA:3.10.450.80:FF:000003', NULL, NULL, '60S ribosomal protein L36a-like', NULL, NULL, NULL, NULL, NULL, 4),
(152976, NULL, 'G3DSA:1.20.1560.10:FF:000860', NULL, NULL, 'ABC transporter AbcB-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(152977, NULL, 'G3DSA:2.60.40.10:FF:001712', NULL, NULL, 'Interleukin-27 receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(152978, NULL, 'G3DSA:3.40.30.10:FF:000007', NULL, NULL, 'Thioredoxin-dependent thiol peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(152979, NULL, 'G3DSA:3.30.160.60:FF:003123', NULL, NULL, 'Zinc finger protein 443', NULL, NULL, NULL, NULL, NULL, 4),
(152980, NULL, 'G3DSA:1.20.1310.10:FF:000179', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152981, NULL, 'G3DSA:3.50.50.60:FF:000905', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152982, NULL, 'G3DSA:1.10.510.10:FF:001035', NULL, NULL, 'Serine/threonine-protein kinase CHK1', NULL, NULL, NULL, NULL, NULL, 4),
(152983, NULL, 'G3DSA:1.25.10.10:FF:002379', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(152984, NULL, 'G3DSA:3.60.40.10:FF:000125', NULL, NULL, 'IcfG protein', NULL, NULL, NULL, NULL, NULL, 4),
(152985, NULL, 'G3DSA:3.30.559.70:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152986, NULL, 'G3DSA:1.20.120.1750:FF:000119', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(152987, NULL, 'G3DSA:1.20.5.340:FF:000045', NULL, NULL, 'SCAR family protein', NULL, NULL, NULL, NULL, NULL, 4),
(152988, NULL, 'G3DSA:2.60.40.640:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152989, NULL, 'G3DSA:2.60.40.10:FF:004585', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152990, NULL, 'G3DSA:3.40.50.1820:FF:001807', NULL, NULL, 'Gastric triacylglycerol lipase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152991, NULL, 'G3DSA:3.30.160.60:FF:005040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152992, NULL, 'G3DSA:2.60.40.10:FF:003949', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(152993, NULL, 'G3DSA:3.30.60.30:FF:000145', NULL, NULL, 'Agrin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152994, NULL, 'G3DSA:1.20.1070.10:FF:000204', NULL, NULL, 'platelet-activating factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(152995, NULL, 'G3DSA:3.90.260.10:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152996, NULL, 'G3DSA:3.30.1010.10:FF:000091', NULL, NULL, 'Phosphatidylinositol 4-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(152997, NULL, 'G3DSA:1.10.357.10:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(152998, NULL, 'G3DSA:3.90.190.10:FF:000505', NULL, NULL, 'Protein tyrosine phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(152999, NULL, 'G3DSA:3.20.20.80:FF:000231', NULL, NULL, 'Chitinase 9', NULL, NULL, NULL, NULL, NULL, 4),
(153000, NULL, 'G3DSA:3.30.1330.30:FF:000103', NULL, NULL, '50S ribosomal protein L30e', NULL, NULL, NULL, NULL, NULL, 4),
(153001, NULL, 'G3DSA:2.40.30.10:FF:000285', NULL, NULL, 'Elongation factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(153002, NULL, 'G3DSA:3.40.50.1460:FF:000014', NULL, NULL, 'Caspase 10, apoptosis-related cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(153003, NULL, 'G3DSA:1.20.1250.20:FF:001396', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153004, NULL, 'G3DSA:3.30.160.60:FF:004534', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153005, NULL, 'G3DSA:3.20.20.100:FF:000179', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(153006, NULL, 'G3DSA:1.20.58.70:FF:000044', NULL, NULL, 'GM25395', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(153007, NULL, 'G3DSA:3.30.450.40:FF:000060', NULL, NULL, 'Stage II sporulation protein E', NULL, NULL, NULL, NULL, NULL, 4),
(153008, NULL, 'G3DSA:3.60.10.10:FF:000253', NULL, NULL, 'Secreted protein containing Endonuclease/exonuclease/phosphatase domain', NULL, NULL, NULL, NULL, NULL, 4),
(153009, NULL, 'G3DSA:3.40.50.10860:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153010, NULL, 'G3DSA:3.40.50.800:FF:000014', NULL, NULL, 'Putative dna polymerase subunit gamma-2 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(153011, NULL, 'G3DSA:1.10.472.10:FF:000153', NULL, NULL, 'Putative transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(153012, NULL, 'G3DSA:3.40.50.10420:FF:000003', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(153013, NULL, 'G3DSA:2.30.30.30:FF:000123', NULL, NULL, '39S ribosomal protein L24, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(153014, NULL, 'G3DSA:3.90.70.30:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153015, NULL, 'G3DSA:1.25.40.20:FF:001580', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153016, NULL, 'G3DSA:2.30.42.10:FF:000234', NULL, NULL, 'Protein KINase', NULL, NULL, NULL, NULL, NULL, 4),
(153017, NULL, 'G3DSA:2.40.50.150:FF:000019', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(153018, NULL, 'G3DSA:1.10.287.1150:FF:000003', NULL, NULL, '2-oxoglutarate dehydrogenase, E1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(153019, NULL, 'G3DSA:1.20.58.60:FF:000507', NULL, NULL, 'Nesprin-2', NULL, NULL, NULL, NULL, NULL, 4),
(153020, NULL, 'G3DSA:3.30.70.380:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153021, NULL, 'G3DSA:3.30.200.20:FF:001980', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(153022, NULL, 'G3DSA:3.40.50.300:FF:000561', NULL, NULL, 'rho-related GTP-binding protein RhoV', NULL, NULL, NULL, NULL, NULL, 4),
(153023, NULL, 'G3DSA:3.10.580.10:FF:000008', NULL, NULL, 'Integral membrane protein TerC', NULL, NULL, NULL, NULL, NULL, 4),
(153024, NULL, 'G3DSA:3.30.70.330:FF:001739', NULL, NULL, 'RNA-binding motif protein 28', NULL, NULL, NULL, NULL, NULL, 4),
(153025, NULL, 'G3DSA:2.60.40.10:FF:004894', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153026, NULL, 'G3DSA:3.90.70.10:FF:000002', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 13', NULL, NULL, NULL, NULL, NULL, 4),
(153027, NULL, 'G3DSA:2.60.40.10:FF:004455', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153028, NULL, 'G3DSA:3.30.200.20:FF:000991', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(153029, NULL, 'G3DSA:3.40.50.620:FF:000084', NULL, NULL, 'arginine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(153030, NULL, 'G3DSA:1.10.1900.20:FF:000004', NULL, NULL, 'MRPL20 isoform 5', NULL, NULL, NULL, NULL, NULL, 4),
(153031, NULL, 'G3DSA:1.20.1560.10:FF:000208', NULL, NULL, 'Peptidase domain-containing ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(153032, NULL, 'G3DSA:3.90.70.10:FF:000811', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153033, NULL, 'G3DSA:1.10.510.10:FF:002496', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153034, NULL, 'G3DSA:1.25.10.10:FF:003205', NULL, NULL, 'Valyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(153035, NULL, 'G3DSA:3.30.160.60:FF:003606', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153036, NULL, 'G3DSA:2.40.50.100:FF:000100', NULL, NULL, 'Carbohydrate ABC transporter ATP-binding protein (CUT1 family)', NULL, NULL, NULL, NULL, NULL, 4),
(153037, NULL, 'G3DSA:1.25.70.10:FF:000090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153038, NULL, 'G3DSA:1.10.1040.10:FF:000019', NULL, NULL, '3-hydroxybutyryl-CoA dehydrogenase FadB2', NULL, NULL, NULL, NULL, NULL, 4),
(153039, NULL, 'G3DSA:3.40.50.300:FF:006058', NULL, NULL, 'ATP-binding cassette transporter, subfamily C, member 10, group MRP protein PpABCC10', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(153040, NULL, 'G3DSA:3.30.1010.10:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153041, NULL, 'G3DSA:1.20.5.110:FF:000105', NULL, NULL, 'SNARE protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153042, NULL, 'G3DSA:3.30.420.10:FF:000217', NULL, NULL, 'DNA polymerase epsilon catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(153043, NULL, 'G3DSA:1.25.40.20:FF:000961', NULL, NULL, 'Ankyrin repeat domain 33', NULL, NULL, NULL, NULL, NULL, 4),
(153044, NULL, 'G3DSA:1.25.40.10:FF:002740', NULL, NULL, 'TPR domain protein (AFU_orthologue AFUA_4G13160)', NULL, NULL, NULL, NULL, NULL, 4),
(153045, NULL, 'G3DSA:3.40.50.10190:FF:000243', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(153046, NULL, 'G3DSA:1.20.900.10:FF:000045', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(153047, NULL, 'G3DSA:1.25.40.20:FF:000591', NULL, NULL, 'Ankyrin repeat, PH and SEC7 domain containing protein secG', NULL, NULL, NULL, NULL, NULL, 4),
(153048, NULL, 'G3DSA:1.20.1250.20:FF:001407', NULL, NULL, 'MFS sugar transporter, putative (AFU_orthologue AFUA_5G06720)', NULL, NULL, NULL, NULL, NULL, 4),
(153049, NULL, 'G3DSA:2.30.30.140:FF:000189', NULL, NULL, 'maternal protein tudor', NULL, NULL, NULL, NULL, NULL, 4),
(153050, NULL, 'G3DSA:3.30.160.60:FF:003915', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153051, NULL, 'G3DSA:2.60.40.10:FF:005074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153052, NULL, 'G3DSA:2.130.10.10:FF:000847', NULL, NULL, 'F-box protein MET30', NULL, NULL, NULL, NULL, NULL, 4),
(153053, NULL, 'G3DSA:3.40.50.720:FF:000760', NULL, NULL, 'Putative short-chain dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(153054, NULL, 'G3DSA:2.60.40.150:FF:000737', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153055, NULL, 'G3DSA:3.30.56.10:FF:000028', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(153056, NULL, 'G3DSA:3.40.50.2000:FF:001042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153057, NULL, 'G3DSA:3.40.1110.10:FF:000410', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153058, NULL, 'G3DSA:3.40.630.10:FF:000118', NULL, NULL, 'Metallo-peptidase, Clan MC, Family M14', NULL, NULL, NULL, NULL, NULL, 4),
(153059, NULL, 'G3DSA:1.25.40.10:FF:001116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153060, NULL, 'G3DSA:1.10.357.150:FF:000005', NULL, NULL, 'Dsl1p', NULL, NULL, NULL, NULL, NULL, 4),
(153061, NULL, 'G3DSA:3.40.1180.10:FF:000021', NULL, NULL, 'Undecaprenyl diphosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(153062, NULL, 'G3DSA:3.30.420.40:FF:000069', NULL, NULL, 'Heat shock protein 70', NULL, NULL, NULL, NULL, NULL, 4),
(153063, NULL, 'G3DSA:3.40.50.1010:FF:000109', NULL, NULL, 'Ribonuclease VapC', NULL, NULL, NULL, NULL, NULL, 4),
(153064, NULL, 'G3DSA:1.25.40.10:FF:004977', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(153065, NULL, 'G3DSA:3.30.200.20:FF:000535', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(153066, NULL, 'G3DSA:3.20.20.70:FF:000065', NULL, NULL, 'Hyaluronidase', NULL, NULL, NULL, NULL, NULL, 4),
(153067, NULL, 'G3DSA:3.80.10.10:FF:002112', NULL, NULL, 'Protein CBG01819', NULL, NULL, NULL, NULL, NULL, 4),
(153068, NULL, 'G3DSA:2.40.50.140:FF:000325', NULL, NULL, 'Maltose ABC transporter, ATP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153069, NULL, 'G3DSA:3.40.50.300:FF:001387', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(153070, NULL, 'G3DSA:1.10.246.90:FF:000016', NULL, NULL, 'U4/U6-U5 snRNP complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(153071, NULL, 'G3DSA:2.130.10.10:FF:003118', NULL, NULL, 'WD-40 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(153072, NULL, 'G3DSA:3.40.50.2300:FF:000406', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(153073, NULL, 'G3DSA:1.10.10.60:FF:000836', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153074, NULL, 'G3DSA:1.10.510.10:FF:000416', NULL, NULL, 'Serine/threonine-protein kinase H1', NULL, NULL, NULL, NULL, NULL, 4),
(153075, NULL, 'G3DSA:1.20.1640.10:FF:000052', NULL, NULL, 'Transmembrane transport protein MmpL11', NULL, NULL, NULL, NULL, NULL, 4),
(153076, NULL, 'G3DSA:1.10.472.10:FF:000653', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153077, NULL, 'G3DSA:3.20.20.370:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153078, NULL, 'G3DSA:3.90.190.20:FF:000042', NULL, NULL, 'Folyl-polyglutamate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(153079, NULL, 'G3DSA:3.40.140.10:FF:000227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153080, NULL, 'G3DSA:3.30.230.10:FF:000034', NULL, NULL, '30S ribosomal protein S9', NULL, NULL, NULL, NULL, NULL, 4),
(153081, NULL, 'G3DSA:3.30.160.60:FF:005170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153082, NULL, 'G3DSA:3.40.50.720:FF:001277', NULL, NULL, 'Yersiniabactin polyketide/non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(153083, NULL, 'G3DSA:2.60.120.260:FF:000667', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153084, NULL, 'G3DSA:3.90.550.20:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153085, NULL, 'G3DSA:1.25.10.10:FF:002249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153086, NULL, 'G3DSA:1.10.287.70:FF:000414', NULL, NULL, 'Ion_channel_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(153087, NULL, 'G3DSA:2.60.40.10:FF:000723', NULL, NULL, 'Collagen type VI alpha 3 chain', NULL, NULL, NULL, NULL, NULL, 4),
(153088, NULL, 'G3DSA:3.30.70.20:FF:000070', NULL, NULL, 'Iron-sulfur cluster-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(153089, NULL, 'G3DSA:1.10.10.10:FF:000815', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(153090, NULL, 'G3DSA:1.10.10.820:FF:000032', NULL, NULL, 'Chitin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(153091, NULL, 'G3DSA:3.10.20.90:FF:000392', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 47', NULL, NULL, NULL, NULL, NULL, 4),
(153092, NULL, 'G3DSA:1.10.1760.20:FF:000015', NULL, NULL, 'Riboflavin transporter', NULL, NULL, NULL, NULL, NULL, 4),
(153093, NULL, 'G3DSA:3.10.120.10:FF:000042', NULL, NULL, 'Acyl-CoA desaturase', NULL, NULL, NULL, NULL, NULL, 4),
(153094, NULL, 'G3DSA:3.30.70.270:FF:000288', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153095, NULL, 'G3DSA:1.10.3370.10:FF:000022', NULL, NULL, 'Protein translocase subunit SecY', NULL, NULL, NULL, NULL, NULL, 4),
(153096, NULL, 'G3DSA:2.10.25.10:FF:000117', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(153097, NULL, 'G3DSA:2.60.40.640:FF:000098', NULL, NULL, 'Arrestin domain-containing protein B', NULL, NULL, NULL, NULL, NULL, 4),
(153098, NULL, 'G3DSA:3.80.10.10:FF:002921', NULL, NULL, 'Os05g0256500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(153099, NULL, 'G3DSA:3.40.50.300:FF:004613', NULL, NULL, 'Putative RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(153100, NULL, 'G3DSA:3.30.710.10:FF:000083', NULL, NULL, 'Kelch-like family member 22', NULL, NULL, NULL, NULL, NULL, 4),
(153101, NULL, 'G3DSA:3.40.605.10:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153102, NULL, 'G3DSA:2.160.10.10:FF:000093', NULL, NULL, 'Transferase hexapeptide repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(153103, NULL, 'G3DSA:3.10.20.720:FF:000002', NULL, NULL, 'Inner kinetochore subunit mis15', NULL, NULL, NULL, NULL, NULL, 4),
(153104, NULL, 'G3DSA:3.20.20.70:FF:000082', NULL, NULL, 'NADPH-dependent 2,4-dienoyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(153105, NULL, 'G3DSA:3.40.50.1820:FF:000026', NULL, NULL, 'GPI inositol-deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(153106, NULL, 'G3DSA:3.40.50.2000:FF:000553', NULL, NULL, 'Glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(153107, NULL, 'G3DSA:1.10.8.590:FF:000004', NULL, NULL, 'tRNA (cytidine/uridine/adenosine-2''-O-)-methyltransferase TrmJ', NULL, NULL, NULL, NULL, NULL, 4),
(153108, NULL, 'G3DSA:2.160.20.10:FF:000178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153109, NULL, 'G3DSA:2.60.120.290:FF:000210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153110, NULL, 'G3DSA:3.40.720.10:FF:000064', NULL, NULL, 'Probable acid phosphatase Pho610', NULL, NULL, NULL, NULL, NULL, 4),
(153111, NULL, 'G3DSA:3.30.70.270:FF:000108', NULL, NULL, 'GGDEF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(153112, NULL, 'G3DSA:1.25.40.10:FF:004185', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(153113, NULL, 'G3DSA:1.25.40.20:FF:001900', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153114, NULL, 'G3DSA:3.30.70.3490:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153115, NULL, 'G3DSA:1.20.142.10:FF:000013', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(153116, NULL, 'G3DSA:1.10.150.670:FF:000005', NULL, NULL, 'ERCC4 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(153117, NULL, 'G3DSA:3.40.50.300:FF:008536', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153118, NULL, 'G3DSA:3.40.50.300:FF:002359', NULL, NULL, 'SNF2 superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(153119, NULL, 'G3DSA:1.20.1230.10:FF:000015', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(153120, NULL, 'G3DSA:3.40.47.10:FF:000282', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153121, NULL, 'G3DSA:1.25.40.10:FF:000262', NULL, NULL, 'Histone-lysine N-methyltransferase SMYD3', NULL, NULL, NULL, NULL, NULL, 4),
(153122, NULL, 'G3DSA:3.40.50.150:FF:000364', NULL, NULL, 'S-adenosylmethionine-dependent methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153123, NULL, 'G3DSA:3.30.70.330:FF:002728', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153124, NULL, 'G3DSA:3.40.50.2000:FF:000114', NULL, NULL, 'GHMP kinase-like', NULL, NULL, NULL, NULL, NULL, 4),
(153125, NULL, 'G3DSA:3.30.200.20:FF:002008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153126, NULL, 'G3DSA:3.10.110.10:FF:000294', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153127, NULL, 'G3DSA:3.20.20.140:FF:000421', NULL, NULL, 'Os08g0165800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(153128, NULL, 'G3DSA:3.80.10.10:FF:000443', NULL, NULL, 'Leucine-rich repeat (LRR) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(153129, NULL, 'G3DSA:1.25.40.10:FF:003016', NULL, NULL, 'Pentatricopeptide repeat-containing protein MRL1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(153130, NULL, 'G3DSA:3.30.420.40:FF:000232', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(153131, NULL, 'G3DSA:3.40.50.300:FF:004793', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153132, NULL, 'G3DSA:2.30.29.30:FF:000187', NULL, NULL, 'SH2B adapter protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(153133, NULL, 'G3DSA:3.80.10.10:FF:000004', NULL, NULL, 'Slit guidance ligand 2', NULL, NULL, NULL, NULL, NULL, 4),
(153134, NULL, 'G3DSA:1.25.40.20:FF:001006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153135, NULL, 'G3DSA:2.60.40.10:FF:004085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153136, NULL, 'G3DSA:1.25.40.10:FF:004005', NULL, NULL, 'Gamma-soluble NSF attachment protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153137, NULL, 'G3DSA:2.60.40.10:FF:000740', NULL, NULL, '6-phosphofructo-2-kinase/fructose-2,6-bisphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(153138, NULL, 'G3DSA:3.20.20.70:FF:000565', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153139, NULL, 'G3DSA:3.30.40.10:FF:000705', NULL, NULL, 'E3 ubiquitin-protein ligase RHF2A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(153140, NULL, 'G3DSA:3.30.70.330:FF:002245', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(153141, NULL, 'G3DSA:1.20.1070.10:FF:000143', NULL, NULL, 'C-X-C chemokine receptor type 5', NULL, NULL, NULL, NULL, NULL, 4),
(153142, NULL, 'G3DSA:3.40.50.1240:FF:000212', NULL, NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(153143, NULL, 'G3DSA:3.40.50.300:FF:002798', NULL, NULL, 'Cytoplasmic dynein 2 heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(153144, NULL, 'G3DSA:3.80.10.10:FF:004366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153145, NULL, 'G3DSA:2.70.160.11:FF:000081', NULL, NULL, 'Protein arginine methyltransferase 3', NULL, NULL, NULL, NULL, NULL, 4),
(153146, NULL, 'G3DSA:3.10.290.70:FF:000009', NULL, NULL, '40S ribosomal protein S8', NULL, NULL, NULL, NULL, NULL, 4),
(153147, NULL, 'G3DSA:1.50.40.10:FF:000198', NULL, NULL, 'Protein CBG17210', NULL, NULL, NULL, NULL, NULL, 4),
(153148, NULL, 'G3DSA:2.60.120.200:FF:000094', NULL, NULL, 'Collagen type XVI alpha 1 chain', NULL, NULL, NULL, NULL, NULL, 4),
(153149, NULL, 'G3DSA:1.20.1050.10:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153150, NULL, 'G3DSA:1.25.40.20:FF:001445', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153151, NULL, 'G3DSA:3.40.309.10:FF:000092', NULL, NULL, 'AGAP009944-PA', NULL, NULL, NULL, NULL, NULL, 4),
(153152, NULL, 'G3DSA:3.30.1370.10:FF:000010', NULL, NULL, 'far upstream element-binding protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(153153, NULL, 'G3DSA:1.50.40.10:FF:000170', NULL, NULL, 'Mitochondrial carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153154, NULL, 'G3DSA:3.30.499.10:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153155, NULL, 'G3DSA:3.40.710.10:FF:000136', NULL, NULL, 'Stage V sporulation protein D', NULL, NULL, NULL, NULL, NULL, 4),
(153156, NULL, 'G3DSA:1.10.10.350:FF:000003', NULL, NULL, 'probable glutamate--tRNA ligase, mitochondrial isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(153157, NULL, 'G3DSA:1.10.472.10:FF:000506', NULL, NULL, 'Protein CBG15501', NULL, NULL, NULL, NULL, NULL, 4),
(153158, NULL, 'G3DSA:1.10.10.60:FF:000706', NULL, NULL, 'NK2b', NULL, NULL, NULL, NULL, NULL, 4),
(153159, NULL, 'G3DSA:1.20.1270.60:FF:000223', NULL, NULL, 'F-BAR and double SH3 domains protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(153160, NULL, 'G3DSA:2.20.110.10:FF:000043', NULL, NULL, 'MORN repeat-containing protein 4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(153161, NULL, 'G3DSA:3.30.40.140:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153162, NULL, 'G3DSA:1.10.1040.10:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153163, NULL, 'G3DSA:3.30.160.60:FF:001128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153164, NULL, 'G3DSA:2.120.10.10:FF:000033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(153165, NULL, 'G3DSA:1.10.167.10:FF:000039', NULL, NULL, 'A-kinase anchor protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(153166, NULL, 'G3DSA:1.20.1070.10:FF:001632', NULL, NULL, 'Diuretic hormone receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153167, NULL, 'G3DSA:1.25.10.10:FF:002688', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153168, NULL, 'G3DSA:1.20.1250.10:FF:000106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153169, NULL, 'G3DSA:3.30.160.60:FF:001206', NULL, NULL, 'Zinc finger protein 668', NULL, NULL, NULL, NULL, NULL, 4),
(153170, NULL, 'G3DSA:3.30.1310.10:FF:000017', NULL, NULL, 'Nucleoid-associated protein FN1270', NULL, NULL, NULL, NULL, NULL, 4),
(153171, NULL, 'G3DSA:1.25.10.10:FF:001940', NULL, NULL, 'Regulator of chromosome condensation repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(153172, NULL, 'G3DSA:3.40.47.10:FF:000102', NULL, NULL, 'Keto acyl-CoA thiolase', NULL, NULL, NULL, NULL, NULL, 4),
(153173, NULL, 'G3DSA:3.30.60.20:FF:000125', NULL, NULL, 'Diacylglycerol kinase A', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(153174, NULL, 'G3DSA:2.40.30.70:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153175, NULL, 'G3DSA:1.25.40.320:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153176, NULL, 'G3DSA:3.30.470.20:FF:000257', NULL, NULL, 'Cycloserine biosynthesis protein DcsG', NULL, NULL, NULL, NULL, NULL, 4),
(153177, NULL, 'G3DSA:3.60.20.10:FF:000079', NULL, NULL, 'Proteasome subunit beta 2', NULL, NULL, NULL, NULL, NULL, 4),
(153178, NULL, 'G3DSA:3.30.450.30:FF:000068', NULL, NULL, 'Profilin', NULL, NULL, NULL, NULL, NULL, 4),
(153179, NULL, 'G3DSA:3.30.499.10:FF:000011', NULL, NULL, 'Iron-responsive element binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(153180, NULL, 'G3DSA:2.10.110.10:FF:000343', NULL, NULL, 'Protein DA1-related 2', NULL, NULL, NULL, NULL, NULL, 4),
(153181, NULL, 'G3DSA:3.90.1150.10:FF:000300', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(153182, NULL, 'G3DSA:3.10.450.50:FF:000005', NULL, NULL, 'Nuclear transport factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(153183, NULL, 'G3DSA:3.30.420.40:FF:000569', NULL, NULL, 'Carbohydrate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(153184, NULL, 'G3DSA:2.60.40.60:FF:001002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153185, NULL, 'G3DSA:3.30.160.60:FF:002634', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153186, NULL, 'G3DSA:3.50.30.30:FF:000024', NULL, NULL, 'E3 ubiquitin-protein ligase RNF43 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(153187, NULL, 'G3DSA:1.20.190.10:FF:000001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153188, NULL, 'G3DSA:3.10.129.10:FF:000123', NULL, NULL, 'Phenylacetic acid degradation protein PaaI', NULL, NULL, NULL, NULL, NULL, 4),
(153189, NULL, 'G3DSA:1.25.10.10:FF:000434', NULL, NULL, 'Hsp70 nucleotide exchange factor fes1', NULL, NULL, NULL, NULL, NULL, 4),
(153190, NULL, 'G3DSA:1.10.12.10:FF:000005', NULL, NULL, 'Carnitinyl-CoA dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(153191, NULL, 'G3DSA:3.30.870.10:FF:000037', NULL, NULL, 'Superfamily I DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(153192, NULL, 'G3DSA:1.25.10.10:FF:001070', NULL, NULL, 'AGAP009004-PA', NULL, NULL, NULL, NULL, NULL, 4),
(153193, NULL, 'G3DSA:1.20.120.850:FF:000045', NULL, NULL, 'SWI/SNF chromatin remodeling complex component', NULL, NULL, NULL, NULL, NULL, 4),
(153194, NULL, 'G3DSA:3.30.420.10:FF:000234', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(153195, NULL, 'G3DSA:1.25.40.10:FF:001088', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g33990', NULL, NULL, NULL, NULL, NULL, 4),
(153196, NULL, 'G3DSA:3.40.50.10130:FF:000023', NULL, NULL, 'Fanconi anemia core complex-associated protein 24', NULL, NULL, NULL, NULL, NULL, 4),
(153197, NULL, 'G3DSA:3.30.1520.10:FF:000039', NULL, NULL, 'PX domain containing serine/threonine kinase like', NULL, NULL, NULL, NULL, NULL, 4),
(153198, NULL, 'G3DSA:1.20.1270.20:FF:000009', NULL, NULL, 'Hydroxylamine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(153199, NULL, 'G3DSA:1.25.40.10:FF:000823', NULL, NULL, 'Unplaced genomic scaffold supercont1.141, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(153200, NULL, 'G3DSA:1.10.287.110:FF:000308', NULL, NULL, 'DnaJ heat shock protein family (Hsp40) member B12a', NULL, NULL, NULL, NULL, NULL, 4),
(153201, NULL, 'G3DSA:2.130.10.10:FF:002764', NULL, NULL, 'Nan1p', NULL, NULL, NULL, NULL, NULL, 4),
(153202, NULL, 'G3DSA:3.40.1280.10:FF:000068', NULL, NULL, 'Mitochondrial rRNA methyltransferase 1 homolog (S. cerevisiae), isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(153203, NULL, 'G3DSA:3.30.2160.10:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153204, NULL, 'G3DSA:2.60.120.10:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153205, NULL, 'G3DSA:2.30.30.40:FF:000261', NULL, NULL, 'Chemotaxis protein CheV', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(153206, NULL, 'G3DSA:1.25.40.10:FF:000599', NULL, NULL, 'Protein CBG09283', NULL, NULL, NULL, NULL, NULL, 4),
(153207, NULL, 'G3DSA:3.30.2260.10:FF:000002', NULL, NULL, 'LOW QUALITY PROTEIN: enhancer of rudimentary homolog', NULL, NULL, NULL, NULL, NULL, 4),
(153208, NULL, 'G3DSA:3.40.50.300:FF:007710', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(153209, NULL, 'G3DSA:1.10.287.130:FF:000157', NULL, NULL, 'Two-component system sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(153210, NULL, 'G3DSA:3.30.70.330:FF:000930', NULL, NULL, 'Sbp1p', NULL, NULL, NULL, NULL, NULL, 4),
(153211, NULL, 'G3DSA:2.10.70.10:FF:000210', NULL, NULL, 'Complement regulatory membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(153212, NULL, 'G3DSA:4.10.240.30:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153213, NULL, 'G3DSA:1.10.287.4070:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153214, NULL, 'G3DSA:1.10.10.10:FF:000462', NULL, NULL, 'Two component transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(153215, NULL, 'G3DSA:1.10.287.10:FF:000003', NULL, NULL, '40S ribosomal protein S13', NULL, NULL, NULL, NULL, NULL, 4),
(153216, NULL, 'G3DSA:1.10.238.10:FF:000816', NULL, NULL, 'Calcium-binding protein CML38', NULL, NULL, NULL, NULL, NULL, 4),
(153217, NULL, 'G3DSA:3.40.30.10:FF:000581', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(153218, NULL, 'G3DSA:2.60.40.10:FF:002538', NULL, NULL, 'PLeXin', NULL, NULL, NULL, NULL, NULL, 4),
(153219, NULL, 'G3DSA:3.50.50.60:FF:000113', NULL, NULL, 'NADPH-dependent 2,4-dienoyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(153220, NULL, 'G3DSA:3.30.1490.80:FF:000017', NULL, NULL, 'Eukaryotic glutathione synthase', NULL, NULL, NULL, NULL, NULL, 4),
(153221, NULL, 'G3DSA:1.20.1070.10:FF:000452', NULL, NULL, 'SERotonin/octopamine receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(153222, NULL, 'G3DSA:1.20.144.10:FF:000097', NULL, NULL, 'Phosphatidic acid phosphatase type 2/haloperoxidase', NULL, NULL, NULL, NULL, NULL, 4),
(153223, NULL, 'G3DSA:3.40.50.10750:FF:000001', NULL, NULL, 'Phosphate acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(153224, NULL, 'G3DSA:3.30.70.330:FF:000800', NULL, NULL, 'AAEL005515-PF', NULL, NULL, NULL, NULL, NULL, 4),
(153225, NULL, 'G3DSA:3.30.70.20:FF:000053', NULL, NULL, 'Ferredoxin-type protein NapF', NULL, NULL, NULL, NULL, NULL, 4),
(153226, NULL, 'G3DSA:2.60.40.10:FF:003466', NULL, NULL, 'FI18055p1', NULL, NULL, NULL, NULL, NULL, 4),
(153227, NULL, 'G3DSA:1.10.238.10:FF:000946', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153228, NULL, 'G3DSA:1.10.20.10:FF:000108', NULL, NULL, 'High mobility group protein B4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153229, NULL, 'G3DSA:3.40.50.300:FF:002668', NULL, NULL, 'ATP binding cassette subfamily A member 8', NULL, NULL, NULL, NULL, NULL, 4),
(153230, NULL, 'G3DSA:1.10.3200.20:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153231, NULL, 'G3DSA:2.60.40.10:FF:002977', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(153232, NULL, 'G3DSA:4.10.260.10:FF:000014', NULL, NULL, 'Guanine nucleotide-binding protein subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(153233, NULL, 'G3DSA:3.30.160.60:FF:003253', NULL, NULL, 'Si:dkeyp-82b4.6', NULL, NULL, NULL, NULL, NULL, 4),
(153234, NULL, 'G3DSA:1.10.3060.10:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153235, NULL, 'G3DSA:1.10.560.10:FF:000127', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit E', NULL, NULL, NULL, NULL, NULL, 4),
(153236, NULL, 'G3DSA:2.20.25.20:FF:000013', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(153237, NULL, 'G3DSA:2.60.40.10:FF:002640', NULL, NULL, 'AXL2p Integral plasma membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(153238, NULL, 'G3DSA:4.10.1000.10:FF:000110', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(153239, NULL, 'G3DSA:1.10.238.230:FF:000003', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(153240, NULL, 'G3DSA:3.90.550.20:FF:000008', NULL, NULL, 'Mannosyltransferase OCH1 and related enzymes', NULL, NULL, NULL, NULL, NULL, 4),
(153241, NULL, 'G3DSA:3.30.160.190:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153242, NULL, 'G3DSA:4.10.60.10:FF:000143', NULL, NULL, 'Replication protein A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(153243, NULL, 'G3DSA:2.70.150.10:FF:000039', NULL, NULL, 'Cadmium-translocating P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(153244, NULL, 'G3DSA:3.20.20.80:FF:000214', NULL, NULL, 'Class V chitinase Chi100', NULL, NULL, NULL, NULL, NULL, 4),
(153245, NULL, 'G3DSA:3.40.850.10:FF:000085', NULL, NULL, 'Myosin heavy chain 7', NULL, NULL, NULL, NULL, NULL, 4),
(153246, NULL, 'G3DSA:1.10.3720.10:FF:000049', NULL, NULL, 'Oligopeptide transport system permease oppC', NULL, NULL, NULL, NULL, NULL, 4),
(153247, NULL, 'G3DSA:2.40.30.10:FF:000268', NULL, NULL, 'NADPH--cytochrome P450 reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153248, NULL, 'G3DSA:3.10.580.10:FF:000025', NULL, NULL, 'Magnesium transporter MgtE', NULL, NULL, NULL, NULL, NULL, 4),
(153249, NULL, 'G3DSA:3.90.70.10:FF:000783', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(153250, NULL, 'G3DSA:3.40.1180.10:FF:000004', NULL, NULL, 'Isoprenyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(153251, NULL, 'G3DSA:1.10.472.10:FF:000170', NULL, NULL, 'Putative mitotic cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(153252, NULL, 'G3DSA:2.60.120.290:FF:000081', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(153253, NULL, 'G3DSA:2.60.40.10:FF:002668', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(153254, NULL, 'G3DSA:4.10.1000.10:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153255, NULL, 'G3DSA:3.30.70.1560:FF:000007', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(153256, NULL, 'G3DSA:1.10.10.160:FF:000053', NULL, NULL, 'UVRD/Rep like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(153257, NULL, 'G3DSA:1.10.10.10:FF:001108', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(153258, NULL, 'G3DSA:1.20.1250.20:FF:000435', NULL, NULL, 'Os11g0620400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(153259, NULL, 'G3DSA:1.25.40.180:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153260, NULL, 'G3DSA:2.60.40.1510:FF:000059', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(153261, NULL, 'G3DSA:3.10.100.10:FF:000057', NULL, NULL, 'Lymphatic vessel endothelial hyaluronic acid receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(153262, NULL, 'G3DSA:3.90.70.10:FF:000474', NULL, NULL, 'Bleomycin hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(153263, NULL, 'G3DSA:3.10.110.10:FF:000114', NULL, NULL, 'Yih1p', NULL, NULL, NULL, NULL, NULL, 4),
(153264, NULL, 'G3DSA:1.20.5.190:FF:000174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153265, NULL, 'G3DSA:3.40.50.620:FF:000067', NULL, NULL, 'Protein FixB', NULL, NULL, NULL, NULL, NULL, 4),
(153266, NULL, 'G3DSA:1.10.510.10:FF:000388', NULL, NULL, 'Leucine-rich repeat receptor-like tyrosine-protein kinase PXC3', NULL, NULL, NULL, NULL, NULL, 4),
(153267, NULL, 'G3DSA:1.10.150.20:FF:000262', NULL, NULL, '50S ribosomal protein L32e', NULL, NULL, NULL, NULL, NULL, 4),
(153268, NULL, 'G3DSA:3.80.10.10:FF:003540', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153269, NULL, 'G3DSA:2.60.40.10:FF:004877', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153270, NULL, 'G3DSA:1.25.40.10:FF:003033', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g04750, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(153271, NULL, 'G3DSA:3.40.50.150:FF:001336', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153272, NULL, 'G3DSA:2.40.10.10:FF:000385', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(153273, NULL, 'G3DSA:1.20.1310.10:FF:000049', NULL, NULL, 'Putative ubiquitin ligase subunit CulD', NULL, NULL, NULL, NULL, NULL, 4),
(153274, NULL, 'G3DSA:2.30.29.30:FF:001367', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153275, NULL, 'G3DSA:3.30.830.10:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153276, NULL, 'G3DSA:3.30.460.10:FF:000208', NULL, NULL, 'tRNA nucleotidyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153277, NULL, 'G3DSA:3.40.50.2300:FF:000654', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(153278, NULL, 'G3DSA:3.30.930.10:FF:000172', NULL, NULL, 'Lipoate-protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153279, NULL, 'G3DSA:2.60.120.260:FF:000066', NULL, NULL, 'Muskelin 1', NULL, NULL, NULL, NULL, NULL, 4),
(153280, NULL, 'G3DSA:1.25.40.10:FF:003797', NULL, NULL, 'Mitochondrial fission 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(153281, NULL, 'G3DSA:3.40.50.720:FF:000304', NULL, NULL, 'UDP-glucose 4,6-dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(153282, NULL, 'G3DSA:3.40.120.10:FF:000035', NULL, NULL, 'Pgm3p', NULL, NULL, NULL, NULL, NULL, 4),
(153283, NULL, 'G3DSA:3.30.1360.10:FF:000037', NULL, NULL, 'DNA-directed RNA polymerase II subunit RPB11', NULL, NULL, NULL, NULL, NULL, 4),
(153284, NULL, 'G3DSA:2.40.128.20:FF:000020', NULL, NULL, 'Lipocalin 1', NULL, NULL, NULL, NULL, NULL, 4),
(153285, NULL, 'G3DSA:3.30.160.60:FF:005068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153286, NULL, 'G3DSA:3.40.50.410:FF:000330', NULL, NULL, 'Chloride channel accessory 3, pseudogene', NULL, NULL, NULL, NULL, NULL, 4),
(153287, NULL, 'G3DSA:1.10.10.10:FF:000962', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(153288, NULL, 'G3DSA:3.40.225.10:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153289, NULL, 'G3DSA:3.40.50.300:FF:005001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153290, NULL, 'G3DSA:3.90.1150.10:FF:000328', NULL, NULL, 'Kynureninase', NULL, NULL, NULL, NULL, NULL, 4),
(153291, NULL, 'G3DSA:2.60.40.1930:FF:000027', NULL, NULL, 'Complement 4B (Chido blood group)', NULL, NULL, NULL, NULL, NULL, 4),
(153292, NULL, 'G3DSA:1.10.510.10:FF:001905', NULL, NULL, 'nuclear receptor-binding protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(153293, NULL, 'G3DSA:3.90.45.10:FF:000034', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(153294, NULL, 'G3DSA:2.130.10.10:FF:002972', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153295, NULL, 'G3DSA:1.25.40.10:FF:000615', NULL, NULL, 'Golgi to ER traffic protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(153296, NULL, 'G3DSA:3.40.1210.10:FF:000002', NULL, NULL, 'Tubulin-tyrosine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(153297, NULL, 'G3DSA:3.40.50.150:FF:001292', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153298, NULL, 'G3DSA:3.40.630.30:FF:000113', NULL, NULL, 'Elongator complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(153299, NULL, 'G3DSA:3.10.170.20:FF:000008', NULL, NULL, 'GP63', NULL, NULL, NULL, NULL, NULL, 4),
(153300, NULL, 'G3DSA:4.10.410.10:FF:000032', NULL, NULL, 'CRE-MEC-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(153301, NULL, 'G3DSA:3.30.2460.20:FF:000003', NULL, NULL, 'Protein Wnt', NULL, NULL, NULL, NULL, NULL, 4),
(153302, NULL, 'G3DSA:3.40.50.300:FF:008183', NULL, NULL, 'Type III restriction enzyme, res subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(153303, NULL, 'G3DSA:1.10.10.60:FF:000914', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153304, NULL, 'G3DSA:3.30.160.60:FF:000291', NULL, NULL, 'Spalt-like transcription factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(153305, NULL, 'G3DSA:1.20.1070.10:FF:000660', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(153306, NULL, 'G3DSA:1.25.40.70:FF:000010', NULL, NULL, 'Phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit gamma', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(153307, NULL, 'G3DSA:3.40.50.1000:FF:000354', NULL, NULL, 'Putative P-type cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(153308, NULL, 'G3DSA:1.25.10.10:FF:001631', NULL, NULL, 'catenin delta-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(153309, NULL, 'G3DSA:1.10.1060.10:FF:000004', NULL, NULL, 'Glutamate synthase, small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(153310, NULL, 'G3DSA:3.70.10.10:FF:000084', NULL, NULL, 'Proliferating cell nuclear antigen', NULL, NULL, NULL, NULL, NULL, 4),
(153311, NULL, 'G3DSA:3.40.30.10:FF:000890', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153312, NULL, 'G3DSA:2.60.470.10:FF:000004', NULL, NULL, 'Degenerin unc-8', NULL, NULL, NULL, NULL, NULL, 4),
(153313, NULL, 'G3DSA:3.30.160.60:FF:004079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153314, NULL, 'G3DSA:2.40.70.10:FF:000259', NULL, NULL, 'ASpartyl Protease', NULL, NULL, NULL, NULL, NULL, 4),
(153315, NULL, 'G3DSA:3.40.50.11210:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153316, NULL, 'G3DSA:3.80.10.10:FF:004158', NULL, NULL, 'Si:ch211-64i20.3', NULL, NULL, NULL, NULL, NULL, 4),
(153317, NULL, 'G3DSA:1.25.40.20:FF:001237', NULL, NULL, 'KN motif and ankyrin repeat domain-containing protein 1-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(153318, NULL, 'G3DSA:3.30.60.60:FF:000013', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(153319, NULL, 'G3DSA:3.30.360.10:FF:000055', NULL, NULL, 'Putative myo-inositol-1-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(153320, NULL, 'G3DSA:2.10.25.10:FF:001623', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153321, NULL, 'G3DSA:1.20.1440.80:FF:000001', NULL, NULL, 'Gap junction alpha-1', NULL, NULL, NULL, NULL, NULL, 4),
(153322, NULL, 'G3DSA:3.80.10.10:FF:002449', NULL, NULL, 'MDIS1-interacting receptor like kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(153323, NULL, 'G3DSA:3.80.10.10:FF:003068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153324, NULL, 'G3DSA:1.10.10.750:FF:000016', NULL, NULL, 'GTPase-activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153325, NULL, 'G3DSA:2.30.42.10:FF:000156', NULL, NULL, 'Ras-associating and dilute domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(153326, NULL, 'G3DSA:1.20.1250.20:FF:001851', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153327, NULL, 'G3DSA:2.10.50.10:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153328, NULL, 'G3DSA:3.90.740.10:FF:000059', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(153329, NULL, 'G3DSA:3.40.50.1780:FF:000008', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', NULL, NULL, NULL, NULL, NULL, 4),
(153330, NULL, 'G3DSA:3.40.50.720:FF:000349', NULL, NULL, 'Uncharacterized protein At1g32220, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(153331, NULL, 'G3DSA:3.40.50.300:FF:004484', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(153332, NULL, 'G3DSA:1.10.132.10:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153333, NULL, 'G3DSA:3.80.10.10:FF:002360', NULL, NULL, 'Platelet glycoprotein V', NULL, NULL, NULL, NULL, NULL, 4),
(153334, NULL, 'G3DSA:1.20.1070.10:FF:002149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153335, NULL, 'G3DSA:3.40.50.300:FF:005102', NULL, NULL, 'ABC transporter family-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(153336, NULL, 'G3DSA:1.25.40.10:FF:004314', NULL, NULL, 'mRNA splicing protein', NULL, NULL, NULL, NULL, NULL, 4),
(153337, NULL, 'G3DSA:3.40.50.10810:FF:000160', NULL, NULL, 'Helicase', NULL, NULL, NULL, NULL, NULL, 4),
(153338, NULL, 'G3DSA:3.30.160.60:FF:005023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153339, NULL, 'G3DSA:2.30.30.490:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153340, NULL, 'G3DSA:3.30.450.30:FF:000040', NULL, NULL, 'Late endosomal/lysosomal adaptor, Mapk (MAPK) and mToR (MTOR) activator homolog', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(153341, NULL, 'G3DSA:1.20.1090.10:FF:000026', NULL, NULL, 'Alcohol dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153342, NULL, 'G3DSA:2.60.200.20:FF:000274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153343, NULL, 'G3DSA:3.40.1770.10:FF:000004', NULL, NULL, 'Urocanate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(153344, NULL, 'G3DSA:3.40.50.720:FF:001940', NULL, NULL, 'C-3 sterol dehydrogenase/C-4 decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(153345, NULL, 'G3DSA:2.40.70.10:FF:000170', NULL, NULL, 'Eukaryotic aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(153346, NULL, 'G3DSA:2.70.150.10:FF:000247', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(153347, NULL, 'G3DSA:3.40.50.10130:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153348, NULL, 'G3DSA:1.10.510.10:FF:002996', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153349, NULL, 'G3DSA:1.10.1040.10:FF:000093', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(153350, NULL, 'G3DSA:1.10.510.10:FF:003614', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153351, NULL, 'G3DSA:1.20.120.720:FF:000034', NULL, NULL, 'Dachs, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(153352, NULL, 'G3DSA:2.130.10.10:FF:005243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153353, NULL, 'G3DSA:3.30.160.60:FF:001437', NULL, NULL, 'Zinc finger protein 594', NULL, NULL, NULL, NULL, NULL, 4),
(153354, NULL, 'G3DSA:3.30.40.10:FF:000677', NULL, NULL, 'E3 ubiquitin-protein ligase SDIR1', NULL, NULL, NULL, NULL, NULL, 4),
(153355, NULL, 'G3DSA:3.40.50.1820:FF:000156', NULL, NULL, 'Neuroligin-4, Y-linked', NULL, NULL, NULL, NULL, NULL, 4),
(153356, NULL, 'G3DSA:1.10.510.10:FF:003030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153357, NULL, 'G3DSA:1.10.510.10:FF:002524', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153358, NULL, 'G3DSA:1.20.1250.20:FF:000227', NULL, NULL, 'MFS transporter, metabolite:H+ symporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(153359, NULL, 'G3DSA:1.25.40.10:FF:003696', NULL, NULL, 'Tetratricopeptide repeat protein 30 homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(153360, NULL, 'G3DSA:1.20.940.10:FF:000019', NULL, NULL, 'Steroid receptor RNA activator 1', NULL, NULL, NULL, NULL, NULL, 4),
(153361, NULL, 'G3DSA:2.40.50.140:FF:000134', NULL, NULL, 'ATP-dependent DNA helicase RecG', NULL, NULL, NULL, NULL, NULL, 4),
(153362, NULL, 'G3DSA:3.40.50.1100:FF:000075', NULL, NULL, 'Threonine synthase ThrC', NULL, NULL, NULL, NULL, NULL, 4),
(153363, NULL, 'G3DSA:2.60.40.10:FF:001257', NULL, NULL, 'Sallimus, isoform Q', NULL, NULL, NULL, NULL, NULL, 4),
(153364, NULL, 'G3DSA:3.30.160.20:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153365, NULL, 'G3DSA:3.30.780.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153366, NULL, 'G3DSA:1.10.630.10:FF:000234', NULL, NULL, 'Cytochrome P450 71D7', NULL, NULL, NULL, NULL, NULL, 4),
(153367, NULL, 'G3DSA:3.10.110.10:FF:000322', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153368, NULL, 'G3DSA:3.30.530.20:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153369, NULL, 'G3DSA:1.10.390.10:FF:000035', NULL, NULL, 'NPEPPS isoform 15', NULL, NULL, NULL, NULL, NULL, 4),
(153370, NULL, 'G3DSA:3.30.70.330:FF:002700', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153371, NULL, 'G3DSA:2.40.10.190:FF:000006', NULL, NULL, 'Ribosomal protein L35Ae, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153372, NULL, 'G3DSA:2.60.120.920:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153373, NULL, 'G3DSA:3.40.950.10:FF:000002', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', NULL, NULL, NULL, NULL, NULL, 4),
(153374, NULL, 'G3DSA:3.40.50.1240:FF:000184', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(153375, NULL, 'G3DSA:3.30.70.330:FF:001756', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153376, NULL, 'G3DSA:2.10.25.10:FF:001078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153377, NULL, 'G3DSA:3.30.70.330:FF:000328', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit G', NULL, NULL, NULL, NULL, NULL, 4),
(153378, NULL, 'G3DSA:1.10.3720.10:FF:000151', NULL, NULL, 'Amino acid ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(153379, NULL, 'G3DSA:3.40.190.10:FF:000410', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(153380, NULL, 'G3DSA:1.10.8.870:FF:000009', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(153381, NULL, 'G3DSA:3.40.50.150:FF:001544', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153382, NULL, 'G3DSA:1.20.120.1320:FF:000002', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(153383, NULL, 'G3DSA:3.90.550.50:FF:000231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153384, NULL, 'G3DSA:3.40.50.12660:FF:000006', NULL, NULL, 'Mca1p', NULL, NULL, NULL, NULL, NULL, 4),
(153385, NULL, 'G3DSA:2.60.40.60:FF:000030', NULL, NULL, 'Protocadherin 9', NULL, NULL, NULL, NULL, NULL, 4),
(153386, NULL, 'G3DSA:3.40.50.2300:FF:000906', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153387, NULL, 'G3DSA:3.90.1600.10:FF:000071', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(153388, NULL, 'G3DSA:3.30.420.40:FF:000440', NULL, NULL, 'Actin', NULL, NULL, NULL, NULL, NULL, 4),
(153389, NULL, 'G3DSA:1.10.3060.10:FF:000004', NULL, NULL, 'Protein translocase subunit SecA 1', NULL, NULL, NULL, NULL, NULL, 4),
(153390, NULL, 'G3DSA:2.60.40.10:FF:005383', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153391, NULL, 'G3DSA:3.80.10.10:FF:001623', NULL, NULL, 'F-box domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(153392, NULL, 'G3DSA:1.10.1450.10:FF:000157', NULL, NULL, 'Leukocyte surface antigen CD53-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(153393, NULL, 'G3DSA:3.10.110.10:FF:000086', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 J1', NULL, NULL, NULL, NULL, NULL, 4),
(153394, NULL, 'G3DSA:1.10.510.10:FF:002625', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153395, NULL, 'G3DSA:2.40.70.10:FF:000523', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153396, NULL, 'G3DSA:3.30.70.1130:FF:000013', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(153397, NULL, 'G3DSA:3.50.50.60:FF:001439', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153398, NULL, 'G3DSA:1.20.1260.10:FF:000034', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(153399, NULL, 'G3DSA:3.30.40.10:FF:001296', NULL, NULL, 'E3 ubiquitin-protein ligase RNF167', NULL, NULL, NULL, NULL, NULL, 4),
(153400, NULL, 'G3DSA:2.130.10.30:FF:000050', NULL, NULL, 'HECT and RLD domain containing E3 ubiquitin protein ligase family member 6', NULL, NULL, NULL, NULL, NULL, 4),
(153401, NULL, 'G3DSA:3.10.350.10:FF:000008', NULL, NULL, 'Murein hydrolase activator NlpD', NULL, NULL, NULL, NULL, NULL, 4),
(153402, NULL, 'G3DSA:2.130.10.10:FF:001544', NULL, NULL, 'Elongator complex protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(153403, NULL, 'G3DSA:1.10.630.10:FF:000543', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153404, NULL, 'G3DSA:3.40.1190.20:FF:000070', NULL, NULL, 'Putative pyridoxal kinase C6F6.11c', NULL, NULL, NULL, NULL, NULL, 4),
(153405, NULL, 'G3DSA:3.30.9.10:FF:000088', NULL, NULL, 'Hydrogen cyanide synthase HcnC', NULL, NULL, NULL, NULL, NULL, 4),
(153406, NULL, 'G3DSA:1.10.238.10:FF:000463', NULL, NULL, 'Protein CBG14543', NULL, NULL, NULL, NULL, NULL, 4),
(153407, NULL, 'G3DSA:3.40.50.2000:FF:000345', NULL, NULL, 'Sucrose synthase 3', NULL, NULL, NULL, NULL, NULL, 4),
(153408, NULL, 'G3DSA:3.30.60.190:FF:000009', NULL, NULL, 'Uncharacterized zinc-finger protein C4F10.19c', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(153409, NULL, 'G3DSA:2.60.40.60:FF:000614', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153410, NULL, 'G3DSA:1.20.1270.10:FF:000080', NULL, NULL, '105/110 kDa heat shock protein, nucleotide-binding domain', NULL, NULL, NULL, NULL, NULL, 4),
(153411, NULL, 'G3DSA:2.60.220.30:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153412, NULL, 'G3DSA:3.40.50.2300:FF:000862', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153413, NULL, 'G3DSA:3.90.550.10:FF:000270', NULL, NULL, 'Rhamnosyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(153414, NULL, 'G3DSA:3.30.200.20:FF:001199', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153415, NULL, 'G3DSA:2.130.10.10:FF:000717', NULL, NULL, 'Cilia- and flagella-associated protein 43', NULL, NULL, NULL, NULL, NULL, 4),
(153416, NULL, 'G3DSA:3.30.70.330:FF:000019', NULL, NULL, 'heterogeneous nuclear ribonucleoproteins C1/C2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(153417, NULL, 'G3DSA:3.40.50.300:FF:001050', NULL, NULL, 'ATP-dependent DNA helicase DDX11', NULL, NULL, NULL, NULL, NULL, 4),
(153418, NULL, 'G3DSA:3.40.1110.10:FF:000039', NULL, NULL, 'Sodium P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(153419, NULL, 'G3DSA:1.10.238.260:FF:000001', NULL, NULL, '2-isopropylmalate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(153420, NULL, 'G3DSA:1.10.3810.10:FF:000023', NULL, NULL, 'Penicillin-binding protein 1A (PBP-1a)', NULL, NULL, NULL, NULL, NULL, 4),
(153421, NULL, 'G3DSA:2.102.10.10:FF:000051', NULL, NULL, 'Gll1923 protein', NULL, NULL, NULL, NULL, NULL, 4),
(153422, NULL, 'G3DSA:3.40.50.12780:FF:000059', NULL, NULL, 'Coronamic acid synthetase CmaA', NULL, NULL, NULL, NULL, NULL, 4),
(153423, NULL, 'G3DSA:2.60.120.260:FF:000330', NULL, NULL, 'Endoprotease aex-5', NULL, NULL, NULL, NULL, NULL, 4),
(153424, NULL, 'G3DSA:2.130.10.10:FF:001645', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1', NULL, NULL, NULL, NULL, NULL, 4),
(153425, NULL, 'G3DSA:1.10.30.10:FF:000053', NULL, NULL, 'Protein CRABS CLAW', NULL, NULL, NULL, NULL, NULL, 4),
(153426, NULL, 'G3DSA:3.30.40.10:FF:000913', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(153427, NULL, 'G3DSA:3.30.230.70:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153428, NULL, 'G3DSA:3.40.50.150:FF:001191', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153429, NULL, 'G3DSA:3.30.160.60:FF:002089', NULL, NULL, 'Zinc finger protein 629', NULL, NULL, NULL, NULL, NULL, 4),
(153430, NULL, 'G3DSA:3.30.160.540:FF:000001', NULL, NULL, 'Probable septum site-determining protein MinC', NULL, NULL, NULL, NULL, NULL, 4),
(153431, NULL, 'G3DSA:2.30.42.10:FF:000364', NULL, NULL, 'Tail-specific protease', NULL, NULL, NULL, NULL, NULL, 4),
(153432, NULL, 'G3DSA:2.60.120.290:FF:000182', NULL, NULL, 'Adhesion G protein-coupled receptor L3', NULL, NULL, NULL, NULL, NULL, 4),
(153433, NULL, 'G3DSA:3.50.50.60:FF:000714', NULL, NULL, 'NAD(P)-binding Rossmann-like domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(153434, NULL, 'G3DSA:3.40.630.10:FF:000427', NULL, NULL, 'Nicalin', NULL, NULL, NULL, NULL, NULL, 4),
(153435, NULL, 'G3DSA:3.40.50.11850:FF:000005', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(153436, NULL, 'G3DSA:2.60.220.50:FF:000037', NULL, NULL, 'Adhesion G protein-coupled receptor E15', NULL, NULL, NULL, NULL, NULL, 4),
(153437, NULL, 'G3DSA:2.40.37.10:FF:000082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153438, NULL, 'G3DSA:3.40.50.2300:FF:000553', NULL, NULL, 'Response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(153439, NULL, 'G3DSA:1.10.1130.10:FF:000009', NULL, NULL, 'Nitrite reductase (cytochrome; ammonia-forming)', NULL, NULL, NULL, NULL, NULL, 4),
(153440, NULL, 'G3DSA:3.30.160.60:FF:003270', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153441, NULL, 'G3DSA:2.130.10.10:FF:004315', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(153442, NULL, 'G3DSA:3.90.180.10:FF:000078', NULL, NULL, 'Quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(153443, NULL, 'G3DSA:3.30.450.20:FF:000391', NULL, NULL, 'Two-component oxygen-sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(153444, NULL, 'G3DSA:1.10.238.10:FF:000154', NULL, NULL, 'Reticulocalbin 3', NULL, NULL, NULL, NULL, NULL, 4),
(153445, NULL, 'G3DSA:3.30.479.30:FF:000004', NULL, NULL, 'Putative membrane protease family, stomatin', NULL, NULL, NULL, NULL, NULL, 4),
(153446, NULL, 'G3DSA:3.40.50.12230:FF:000018', NULL, NULL, 'Methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(153447, NULL, 'G3DSA:3.40.50.1100:FF:000283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153448, NULL, 'G3DSA:1.10.510.10:FF:002316', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153449, NULL, 'G3DSA:3.40.50.620:FF:000729', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153450, NULL, 'G3DSA:3.30.160.60:FF:004343', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153451, NULL, 'G3DSA:3.40.50.150:FF:000925', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153452, NULL, 'G3DSA:1.10.510.10:FF:001552', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153453, NULL, 'G3DSA:3.30.1370.210:FF:000004', NULL, NULL, 'Muscleblind like splicing regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(153454, NULL, 'G3DSA:3.40.50.1760:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153455, NULL, 'G3DSA:1.20.870.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153456, NULL, 'G3DSA:3.30.1150.10:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153457, NULL, 'G3DSA:1.20.1070.10:FF:000351', NULL, NULL, 'Octopamine receptor Oamb', NULL, NULL, NULL, NULL, NULL, 4),
(153458, NULL, 'G3DSA:3.30.1370.10:FF:000190', NULL, NULL, 'KH domain-containing, RNA-binding, signal transduction-associated protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(153459, NULL, 'G3DSA:1.20.1070.10:FF:000013', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(153460, NULL, 'G3DSA:3.10.430.100:FF:000003', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(153461, NULL, 'G3DSA:3.40.50.300:FF:000898', NULL, NULL, 'ADP-ribosylation factor-like protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(153462, NULL, 'G3DSA:3.30.530.20:FF:000083', NULL, NULL, 'Uncharacterized protein MT0096', NULL, NULL, NULL, NULL, NULL, 4),
(153463, NULL, 'G3DSA:2.20.25.30:FF:000004', NULL, NULL, 'Ribosomal protein L37', NULL, NULL, NULL, NULL, NULL, 4),
(153464, NULL, 'G3DSA:1.10.1450.10:FF:000056', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(153465, NULL, 'G3DSA:1.10.472.10:FF:000714', NULL, NULL, 'Cyclin-A1-1', NULL, NULL, NULL, NULL, NULL, 4),
(153466, NULL, 'G3DSA:3.30.200.20:FF:000474', NULL, NULL, 'Serine/threonine-protein kinase N2-like', NULL, NULL, NULL, NULL, NULL, 4),
(153467, NULL, 'G3DSA:2.40.50.100:FF:000128', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(153468, NULL, 'G3DSA:3.30.50.10:FF:000178', NULL, NULL, 'Nuclear receptor subfamily 2, group F, member 6b', NULL, NULL, NULL, NULL, NULL, 4),
(153469, NULL, 'G3DSA:1.10.287.110:FF:000382', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(153470, NULL, 'G3DSA:2.130.10.10:FF:001336', NULL, NULL, 'LisH protein', NULL, NULL, NULL, NULL, NULL, 4),
(153471, NULL, 'G3DSA:3.30.160.60:FF:000509', NULL, NULL, 'zinc finger protein with KRAB and SCAN domains 5', NULL, NULL, NULL, NULL, NULL, 4),
(153472, NULL, 'G3DSA:1.10.630.10:FF:000335', NULL, NULL, 'CYtochrome P450 family', NULL, NULL, NULL, NULL, NULL, 4),
(153473, NULL, 'G3DSA:2.60.210.10:FF:000002', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(153474, NULL, 'G3DSA:1.10.238.10:FF:000890', NULL, NULL, 'ubiquitin carboxyl-terminal hydrolase 32', NULL, NULL, NULL, NULL, NULL, 4),
(153475, NULL, 'G3DSA:2.60.120.310:FF:000008', NULL, NULL, 'Probable peptidyl-glycine alpha-amidating monooxygenase pamn-1', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(153476, NULL, 'G3DSA:2.60.40.10:FF:002185', NULL, NULL, 'Uncharacterized protein, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(153477, NULL, 'G3DSA:3.40.20.10:FF:000052', NULL, NULL, 'Actin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(153478, NULL, 'G3DSA:3.40.50.970:FF:000166', NULL, NULL, 'Pyruvate dehydrogenase E1 component subunit alpha, somatic form, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(153479, NULL, 'G3DSA:1.10.10.10:FF:001788', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(153480, NULL, 'G3DSA:1.20.272.10:FF:000017', NULL, NULL, 'DNA polymerase III subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(153481, NULL, 'G3DSA:1.10.287.130:FF:000174', NULL, NULL, 'Sensory box histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(153482, NULL, 'G3DSA:3.30.70.330:FF:002375', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153483, NULL, 'G3DSA:3.90.320.10:FF:000067', NULL, NULL, 'DNA replication helicase DNA2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153484, NULL, 'G3DSA:2.10.110.10:FF:000213', NULL, NULL, 'Four and a half LIM domains protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(153485, NULL, 'G3DSA:3.40.50.300:FF:007255', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153486, NULL, 'G3DSA:2.70.98.90:FF:000008', NULL, NULL, 'Membrane protein insertase YidC', NULL, NULL, NULL, NULL, NULL, 4),
(153487, NULL, 'G3DSA:1.10.238.20:FF:000011', NULL, NULL, 'Odorant-binding protein 56c, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(153488, NULL, 'G3DSA:3.90.70.10:FF:000339', NULL, NULL, 'Os09g0565000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(153489, NULL, 'G3DSA:1.25.40.20:FF:001080', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(153490, NULL, 'G3DSA:2.60.40.10:FF:001212', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', NULL, NULL, NULL, NULL, NULL, 4),
(153491, NULL, 'G3DSA:3.30.70.330:FF:002037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153492, NULL, 'G3DSA:1.25.40.10:FF:001543', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g32415, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(153493, NULL, 'G3DSA:2.60.40.10:FF:004646', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153494, NULL, 'G3DSA:3.30.200.20:FF:000108', NULL, NULL, 'Serine/threonine-protein kinase Nek2', NULL, NULL, NULL, NULL, NULL, 4),
(153495, NULL, 'G3DSA:1.25.10.10:FF:003076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153496, NULL, 'G3DSA:3.40.50.2300:FF:001379', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153497, NULL, 'G3DSA:2.10.25.10:FF:001286', NULL, NULL, 'Vasorin', NULL, NULL, NULL, NULL, NULL, 4),
(153498, NULL, 'G3DSA:1.20.1560.10:FF:000079', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(153499, NULL, 'G3DSA:3.20.20.70:FF:000666', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153500, NULL, 'G3DSA:3.30.200.20:FF:000783', NULL, NULL, 'RGD1307355 protein', NULL, NULL, NULL, NULL, NULL, 4),
(153501, NULL, 'G3DSA:3.40.140.10:FF:000098', NULL, NULL, 'Cytidine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(153502, NULL, 'G3DSA:1.10.220.150:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153503, NULL, 'G3DSA:2.10.25.10:FF:001387', NULL, NULL, 'von Willebrand factor D and EGF domains', NULL, NULL, NULL, NULL, NULL, 4),
(153504, NULL, 'G3DSA:3.30.1370.10:FF:000201', NULL, NULL, 'Protein CBR-NUO-2', NULL, NULL, NULL, NULL, NULL, 4),
(153505, NULL, 'G3DSA:3.30.1490.40:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153506, NULL, 'G3DSA:1.20.1730.10:FF:000008', NULL, NULL, 'High affinity choline transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(153507, NULL, 'G3DSA:3.40.50.12100:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153508, NULL, 'G3DSA:2.60.40.1530:FF:000014', NULL, NULL, 'Integrin alpha 2b', NULL, NULL, NULL, NULL, NULL, 4),
(153509, NULL, 'G3DSA:1.20.245.10:FF:000005', NULL, NULL, 'Arachidonate 12-lipoxygenase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(153510, NULL, 'G3DSA:3.90.1720.10:FF:000029', NULL, NULL, 'ALdehyde deHydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(153511, NULL, 'G3DSA:1.20.5.1190:FF:000011', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(153512, NULL, 'G3DSA:3.10.50.10:FF:000021', NULL, NULL, 'Chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153513, NULL, 'G3DSA:2.40.50.140:FF:000342', NULL, NULL, 'RNA polymerase A', NULL, NULL, NULL, NULL, NULL, 4),
(153514, NULL, 'G3DSA:1.25.40.10:FF:004769', NULL, NULL, 'Anaphase-promoting complex subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(153515, NULL, 'G3DSA:3.90.640.10:FF:000142', NULL, NULL, 'Actin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153516, NULL, 'G3DSA:1.10.730.10:FF:000135', NULL, NULL, 'Methionine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(153517, NULL, 'G3DSA:1.10.196.10:FF:000005', NULL, NULL, 'Axin 1', NULL, NULL, NULL, NULL, NULL, 4),
(153518, NULL, 'G3DSA:2.30.42.10:FF:000465', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153519, NULL, 'G3DSA:1.20.5.320:FF:000022', NULL, NULL, 'Collagen, type XVII, alpha 1b', NULL, NULL, NULL, NULL, NULL, 4),
(153520, NULL, 'G3DSA:1.25.40.10:FF:002869', NULL, NULL, 'Protein O-mannosyl-transferase TMTC1', NULL, NULL, NULL, NULL, NULL, 4),
(153521, NULL, 'G3DSA:3.40.50.300:FF:006749', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153522, NULL, 'G3DSA:1.20.1050.60:FF:000004', NULL, NULL, 'Putative alpha-1,2-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(153523, NULL, 'G3DSA:2.30.40.10:FF:000174', NULL, NULL, 'Deacetylase Oant_2987', NULL, NULL, NULL, NULL, NULL, 4),
(153524, NULL, 'G3DSA:3.40.390.10:FF:000066', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(153525, NULL, 'G3DSA:3.90.660.10:FF:000008', NULL, NULL, 'Spermine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(153526, NULL, 'G3DSA:1.10.287.2230:FF:000001', NULL, NULL, 'Structural polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(153527, NULL, 'G3DSA:3.40.50.720:FF:002558', NULL, NULL, 'Inositol-3-phosphate synthase isozyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(153528, NULL, 'G3DSA:3.40.50.300:FF:007210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153529, NULL, 'G3DSA:3.30.230.130:FF:000069', NULL, NULL, 'Cullin homolog 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(153530, NULL, 'G3DSA:3.40.50.300:FF:004804', NULL, NULL, '6-phosphofructo-2-kinase/fructose-2, 6-bisphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(153531, NULL, 'G3DSA:1.25.40.10:FF:001588', NULL, NULL, 'Cell division cycle 27, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(153532, NULL, 'G3DSA:3.10.110.10:FF:000013', NULL, NULL, 'SUMO-conjugating enzyme UBC9', NULL, NULL, NULL, NULL, NULL, 4),
(153533, NULL, 'G3DSA:1.25.40.770:FF:000007', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(153534, NULL, 'G3DSA:3.50.50.60:FF:000922', NULL, NULL, 'IP11909p', NULL, NULL, NULL, NULL, NULL, 4),
(153535, NULL, 'G3DSA:3.40.50.1820:FF:000509', NULL, NULL, 'lipase member H', NULL, NULL, NULL, NULL, NULL, 4),
(153536, NULL, 'G3DSA:3.30.190.20:FF:000011', NULL, NULL, '50S ribosomal protein L1', NULL, NULL, NULL, NULL, NULL, 4),
(153537, NULL, 'G3DSA:1.20.58.1970:FF:000009', NULL, NULL, 'Exocyst complex component sec10', NULL, NULL, NULL, NULL, NULL, 4),
(153538, NULL, 'G3DSA:3.30.160.60:FF:002297', NULL, NULL, 'Zinc finger protein 85', NULL, NULL, NULL, NULL, NULL, 4),
(153539, NULL, 'G3DSA:2.60.40.10:FF:004910', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153540, NULL, 'G3DSA:2.170.130.10:FF:000031', NULL, NULL, 'TonB-linked outer membrane protein SusC/RagA family', NULL, NULL, NULL, NULL, NULL, 4),
(153541, NULL, 'G3DSA:2.130.10.10:FF:002264', NULL, NULL, 'Guanine nucleotide-binding protein beta subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153542, NULL, 'G3DSA:2.60.40.10:FF:002769', NULL, NULL, 'Coagulation factor III, tissue factor', NULL, NULL, NULL, NULL, NULL, 4),
(153543, NULL, 'G3DSA:3.40.50.2300:FF:000345', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(153544, NULL, 'G3DSA:1.20.5.340:FF:000028', NULL, NULL, 'rab GTPase-binding effector protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(153545, NULL, 'G3DSA:3.30.160.60:FF:002409', NULL, NULL, 'Crooked legs, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(153546, NULL, 'G3DSA:2.60.120.200:FF:000464', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153547, NULL, 'G3DSA:3.30.40.10:FF:001649', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153548, NULL, 'G3DSA:3.40.50.1360:FF:000001', NULL, NULL, 'Ribose-5-phosphate isomerase A', NULL, NULL, NULL, NULL, NULL, 4),
(153549, NULL, 'G3DSA:1.20.1460.10:FF:000015', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(153550, NULL, 'G3DSA:3.10.20.90:FF:000976', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153551, NULL, 'G3DSA:1.10.287.2250:FF:000007', NULL, NULL, 'P34 probable thiol protease', NULL, NULL, NULL, NULL, NULL, 4),
(153552, NULL, 'G3DSA:1.20.58.60:FF:000850', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153553, NULL, 'G3DSA:1.10.10.10:FF:000254', NULL, NULL, 'Two-component system response regulator CreB', NULL, NULL, NULL, NULL, NULL, 4),
(153554, NULL, 'G3DSA:3.90.1750.10:FF:000065', NULL, NULL, 'HECT-domain ubiquitin--protein ligase E3', NULL, NULL, NULL, NULL, NULL, 4),
(153555, NULL, 'G3DSA:2.80.10.50:FF:000165', NULL, NULL, 'YALI0D10549p', NULL, NULL, NULL, NULL, NULL, 4),
(153556, NULL, 'G3DSA:3.30.200.20:FF:000682', NULL, NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(153557, NULL, 'G3DSA:3.80.10.10:FF:003332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153558, NULL, 'G3DSA:2.30.29.30:FF:000378', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(153559, NULL, 'G3DSA:3.40.50.720:FF:001069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153560, NULL, 'G3DSA:3.30.70.330:FF:001211', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(153561, NULL, 'G3DSA:1.20.1070.10:FF:001177', NULL, NULL, 'Neuropeptide Y receptor type 1', NULL, NULL, NULL, NULL, NULL, 4),
(153562, NULL, 'G3DSA:2.130.10.10:FF:006007', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(153563, NULL, 'G3DSA:3.40.850.10:FF:000293', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(153564, NULL, 'G3DSA:1.10.220.150:FF:000012', NULL, NULL, 'ADP-ribosylation factor GTPase-activating protein AGD10', NULL, NULL, NULL, NULL, NULL, 4),
(153565, NULL, 'G3DSA:1.10.510.10:FF:003244', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153566, NULL, 'G3DSA:3.90.226.10:FF:000342', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(153567, NULL, 'G3DSA:3.40.850.10:FF:000101', NULL, NULL, 'Slow myosin heavy chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(153568, NULL, 'G3DSA:1.20.1540.10:FF:000117', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(153569, NULL, 'G3DSA:3.40.50.10880:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153570, NULL, 'G3DSA:3.10.20.870:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153571, NULL, 'G3DSA:2.170.140.10:FF:000060', NULL, NULL, 'Major mite allergen Der p 23', NULL, NULL, NULL, NULL, NULL, 4),
(153572, NULL, 'G3DSA:3.40.630.30:FF:000321', NULL, NULL, 'N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(153573, NULL, 'G3DSA:3.40.50.970:FF:000019', NULL, NULL, 'Pyruvate decarboxylase isozyme', NULL, NULL, NULL, NULL, NULL, 4),
(153574, NULL, 'G3DSA:1.10.510.10:FF:001344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153575, NULL, 'G3DSA:3.40.50.300:FF:000089', NULL, NULL, 'Eukaryotic initiation factor 4A-II', NULL, NULL, NULL, NULL, NULL, 4),
(153576, NULL, 'G3DSA:3.40.630.10:FF:000326', NULL, NULL, 'Glutamate carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153577, NULL, 'G3DSA:1.20.1420.30:FF:000047', NULL, NULL, 'Probable sodium/calcium exchanger antiporter', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(153578, NULL, 'G3DSA:1.10.8.60:FF:000032', NULL, NULL, 'Replication factor C subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(153579, NULL, 'G3DSA:2.30.29.30:FF:000642', NULL, NULL, 'Regulator of G-protein signaling loco', NULL, NULL, NULL, NULL, NULL, 4),
(153580, NULL, 'G3DSA:3.60.20.10:FF:000107', NULL, NULL, 'Probable proteasome subunit beta type-5', NULL, NULL, NULL, NULL, NULL, 4),
(153581, NULL, 'G3DSA:3.40.50.150:FF:001853', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153582, NULL, 'G3DSA:3.40.50.80:FF:000102', NULL, NULL, 'Putative reductase', NULL, NULL, NULL, NULL, NULL, 4),
(153583, NULL, 'G3DSA:1.10.3380.10:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153584, NULL, 'G3DSA:3.30.200.20:FF:001300', NULL, NULL, 'Ephrin receptor like protein', NULL, NULL, NULL, NULL, NULL, 4),
(153585, NULL, 'G3DSA:1.10.8.60:FF:000296', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(153586, NULL, 'G3DSA:3.90.70.10:FF:000839', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153587, NULL, 'G3DSA:3.60.10.10:FF:000022', NULL, NULL, 'type I inositol 1,4,5-trisphosphate 5-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(153588, NULL, 'G3DSA:3.40.50.720:FF:000804', NULL, NULL, 'UDP-galactopyranose mutase', NULL, NULL, NULL, NULL, NULL, 4),
(153589, NULL, 'G3DSA:1.20.1600.10:FF:000004', NULL, NULL, 'Outer membrane efflux protein', NULL, NULL, NULL, NULL, NULL, 4),
(153590, NULL, 'G3DSA:3.80.10.10:FF:001387', NULL, NULL, 'Similarity to receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(153591, NULL, 'G3DSA:3.30.40.10:FF:000368', NULL, NULL, 'Lysine demethylase 5A', NULL, NULL, NULL, NULL, NULL, 4),
(153592, NULL, 'G3DSA:3.20.70.20:FF:000031', NULL, NULL, 'Vitamin B12-dependent ribonucleotide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(153593, NULL, 'G3DSA:3.40.50.1440:FF:000036', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(153594, NULL, 'G3DSA:3.30.470.110:FF:000004', NULL, NULL, 'ATP-citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(153595, NULL, 'G3DSA:3.90.70.10:FF:000682', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153596, NULL, 'G3DSA:3.90.199.10:FF:000008', NULL, NULL, 'DNA topoisomerase (ATP-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4),
(153597, NULL, 'G3DSA:1.10.287.1150:FF:000020', NULL, NULL, 'Probable 2-oxoglutarate dehydrogenase E1 component DHKTD1 homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(153598, NULL, 'G3DSA:3.40.20.10:FF:000153', NULL, NULL, 'Cofilin-4', NULL, NULL, NULL, NULL, NULL, 4),
(153599, NULL, 'G3DSA:2.60.120.620:FF:000129', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(153600, NULL, 'G3DSA:3.30.160.60:FF:004551', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153601, NULL, 'G3DSA:1.10.238.10:FF:001082', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(153602, NULL, 'G3DSA:1.10.1520.10:FF:000023', NULL, NULL, 'Endoribonuclease dcr-1', NULL, NULL, NULL, NULL, NULL, 4),
(153603, NULL, 'G3DSA:1.10.10.10:FF:001007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153604, NULL, 'G3DSA:1.25.40.570:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153605, NULL, 'G3DSA:1.10.510.10:FF:004469', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153606, NULL, 'G3DSA:3.40.640.10:FF:000355', NULL, NULL, 'Cystathionine synthase/lyase (Cystathionine gamma-synthase, cystathionine gamma-lyase, cystathionine beta-lyase)', NULL, NULL, NULL, NULL, NULL, 4),
(153607, NULL, 'G3DSA:3.30.160.60:FF:000397', NULL, NULL, 'Metal regulatory transcription factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(153608, NULL, 'G3DSA:1.20.1560.10:FF:000888', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153609, NULL, 'G3DSA:3.30.40.10:FF:001796', NULL, NULL, 'Protein CBG15934', NULL, NULL, NULL, NULL, NULL, 4),
(153610, NULL, 'G3DSA:1.20.1250.20:FF:000070', NULL, NULL, 'Solute carrier family 22 member 5', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(153611, NULL, 'G3DSA:4.10.60.10:FF:000244', NULL, NULL, 'RNA-binding region RNP-1 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(153612, NULL, 'G3DSA:3.40.630.10:FF:000074', NULL, NULL, 'Peptide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(153613, NULL, 'G3DSA:1.20.1420.10:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153614, NULL, 'G3DSA:2.130.10.10:FF:004107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153615, NULL, 'G3DSA:1.25.40.10:FF:000924', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g39620, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(153616, NULL, 'G3DSA:3.40.50.410:FF:000122', NULL, NULL, 'Mesocentin', NULL, NULL, NULL, NULL, NULL, 4),
(153617, NULL, 'G3DSA:2.160.10.10:FF:000121', NULL, NULL, 'Polysialic acid O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(153618, NULL, 'G3DSA:3.80.10.10:FF:002713', NULL, NULL, 'PXY', NULL, NULL, NULL, NULL, NULL, 4),
(153619, NULL, 'G3DSA:2.60.120.330:FF:000003', NULL, NULL, 'Gibberellin 20 oxidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(153620, NULL, 'G3DSA:3.30.1360.180:FF:000004', NULL, NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase family member 4', NULL, NULL, NULL, NULL, NULL, 4),
(153621, NULL, 'G3DSA:3.40.50.300:FF:003315', NULL, NULL, 'Small GTPase EhRabX8, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153622, NULL, 'G3DSA:2.40.50.140:FF:000556', NULL, NULL, 'GEO08380p1', NULL, NULL, NULL, NULL, NULL, 4),
(153623, NULL, 'G3DSA:3.80.10.10:FF:000651', NULL, NULL, 'F-box/LRR-repeat protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(153624, NULL, 'G3DSA:3.30.505.10:FF:000139', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(153625, NULL, 'G3DSA:3.30.70.330:FF:000694', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153626, NULL, 'G3DSA:1.20.120.1880:FF:000001', NULL, NULL, 'Nuclear pore complex protein Nup155', NULL, NULL, NULL, NULL, NULL, 4),
(153627, NULL, 'G3DSA:3.40.50.10810:FF:000261', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153628, NULL, 'G3DSA:1.20.1250.20:FF:001508', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(153629, NULL, 'G3DSA:1.20.5.110:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153630, NULL, 'G3DSA:3.40.50.150:FF:000572', NULL, NULL, 'CLL-associated antigen KW-2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153631, NULL, 'G3DSA:3.40.50.1480:FF:000008', NULL, NULL, 'Adenosylhomocysteinase', NULL, NULL, NULL, NULL, NULL, 4),
(153632, NULL, 'G3DSA:1.10.8.270:FF:000026', NULL, NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', NULL, NULL, NULL, NULL, NULL, 4),
(153633, NULL, 'G3DSA:3.30.160.60:FF:001780', NULL, NULL, 'zinc finger protein 420 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(153634, NULL, 'G3DSA:1.20.1050.10:FF:000097', NULL, NULL, 'Glutathione S-transferase U20', NULL, NULL, NULL, NULL, NULL, 4),
(153635, NULL, 'G3DSA:2.170.270.10:FF:000064', NULL, NULL, 'SET_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(153636, NULL, 'G3DSA:1.10.10.60:FF:000353', NULL, NULL, 'Transcription factor WER', NULL, NULL, NULL, NULL, NULL, 4),
(153637, NULL, 'G3DSA:3.60.130.10:FF:000082', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(153638, NULL, 'G3DSA:1.10.30.10:FF:000154', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(153639, NULL, 'G3DSA:3.30.160.60:FF:000852', NULL, NULL, 'zinc finger protein 629 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(153640, NULL, 'G3DSA:2.130.10.10:FF:005698', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(153641, NULL, 'G3DSA:2.130.10.10:FF:003798', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153642, NULL, 'G3DSA:2.60.120.10:FF:000692', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153643, NULL, 'G3DSA:3.30.710.10:FF:000291', NULL, NULL, 'Ankyrin repeat and BTB/POZ domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(153644, NULL, 'G3DSA:3.40.1120.10:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153645, NULL, 'G3DSA:1.10.10.10:FF:001316', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153646, NULL, 'G3DSA:2.30.30.30:FF:000140', NULL, NULL, '60S ribosomal protein L14', NULL, NULL, NULL, NULL, NULL, 4),
(153647, NULL, 'G3DSA:3.30.420.210:FF:000007', NULL, NULL, 'UBX domain protein 2B', NULL, NULL, NULL, NULL, NULL, 4),
(153648, NULL, 'G3DSA:3.30.160.60:FF:006451', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153649, NULL, 'G3DSA:3.30.60.10:FF:000004', NULL, NULL, 'Endochitinase At2g43590', NULL, NULL, NULL, NULL, NULL, 4),
(153650, NULL, 'G3DSA:2.60.40.10:FF:003365', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153651, NULL, 'G3DSA:3.40.50.10490:FF:000018', NULL, NULL, 'Glucose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(153652, NULL, 'G3DSA:1.20.1720.10:FF:000070', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(153653, NULL, 'G3DSA:1.10.3520.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153654, NULL, 'G3DSA:2.70.70.10:FF:000039', NULL, NULL, 'Membrane-bound metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(153655, NULL, 'G3DSA:3.90.1150.10:FF:000429', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153656, NULL, 'G3DSA:2.60.120.650:FF:000222', NULL, NULL, 'Multicopy suppressor of chk1 protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(153657, NULL, 'G3DSA:3.40.50.1820:FF:000257', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(153658, NULL, 'G3DSA:3.40.50.150:FF:000263', NULL, NULL, 'Putative methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(153659, NULL, 'G3DSA:2.170.300.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153660, NULL, 'G3DSA:3.30.230.10:FF:000051', NULL, NULL, '30S ribosomal protein S9', NULL, NULL, NULL, NULL, NULL, 4),
(153661, NULL, 'G3DSA:1.20.1280.50:FF:000159', NULL, NULL, 'F-box and leucine rich repeat protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(153662, NULL, 'G3DSA:3.80.10.10:FF:000342', NULL, NULL, 'Leucine rich repeat containing 47', NULL, NULL, NULL, NULL, NULL, 4),
(153663, NULL, 'G3DSA:3.90.79.10:FF:000230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153664, NULL, 'G3DSA:3.40.50.140:FF:000018', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(153665, NULL, 'G3DSA:3.30.540.10:FF:000052', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(153666, NULL, 'G3DSA:2.130.10.10:FF:003489', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153667, NULL, 'G3DSA:3.30.160.60:FF:005523', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153668, NULL, 'G3DSA:3.40.1090.10:FF:000014', NULL, NULL, 'Patatin like phospholipase domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(153669, NULL, 'G3DSA:2.130.10.10:FF:005035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153670, NULL, 'G3DSA:1.10.10.60:FF:000044', NULL, NULL, 'chromodomain-helicase-DNA-binding protein 9 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(153671, NULL, 'G3DSA:2.130.10.10:FF:002825', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153672, NULL, 'G3DSA:3.40.640.10:FF:000400', NULL, NULL, 'Ornithine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(153673, NULL, 'G3DSA:3.40.30.10:FF:000081', NULL, NULL, 'phosducin-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(153674, NULL, 'G3DSA:1.25.40.10:FF:003488', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(153675, NULL, 'G3DSA:2.60.40.2160:FF:000006', NULL, NULL, 'Interleukin cytokine receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(153676, NULL, 'G3DSA:2.30.30.40:FF:000452', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(153677, NULL, 'G3DSA:3.30.9.10:FF:000043', NULL, NULL, 'FAD-dependent oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(153678, NULL, 'G3DSA:1.20.58.60:FF:000142', NULL, NULL, 'Envoplakin like', NULL, NULL, NULL, NULL, NULL, 4),
(153679, NULL, 'G3DSA:3.40.50.300:FF:005310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153680, NULL, 'G3DSA:3.90.530.10:FF:000004', NULL, NULL, 'DNA repair protein RAD14', NULL, NULL, NULL, NULL, NULL, 4),
(153681, NULL, 'G3DSA:3.90.650.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153682, NULL, 'G3DSA:2.60.40.150:FF:000659', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(153683, NULL, 'G3DSA:2.130.10.10:FF:000925', NULL, NULL, 'Transcription factor SPT8', NULL, NULL, NULL, NULL, NULL, 4),
(153684, NULL, 'G3DSA:3.40.50.720:FF:002249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153685, NULL, 'G3DSA:3.30.40.10:FF:002049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153686, NULL, 'G3DSA:2.120.10.80:FF:000317', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(153687, NULL, 'G3DSA:3.90.1410.10:FF:000028', NULL, NULL, 'SET domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153688, NULL, 'G3DSA:1.20.5.930:FF:000008', NULL, NULL, 'Integrin subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(153689, NULL, 'G3DSA:1.20.1250.20:FF:002127', NULL, NULL, 'Os03g0286700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(153690, NULL, 'G3DSA:3.90.1300.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153691, NULL, 'G3DSA:3.30.1370.240:FF:000002', NULL, NULL, 'phenylalanine--tRNA ligase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(153692, NULL, 'G3DSA:3.30.160.60:FF:005832', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153693, NULL, 'G3DSA:1.50.10.20:FF:000019', NULL, NULL, 'Alpha-2-macroglobulin', NULL, NULL, NULL, NULL, NULL, 4),
(153694, NULL, 'G3DSA:3.40.50.11260:FF:000025', NULL, NULL, 'Chaperone protein HtpG', NULL, NULL, NULL, NULL, NULL, 4),
(153695, NULL, 'G3DSA:2.130.10.10:FF:000616', NULL, NULL, 'Striatin-3 isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(153696, NULL, 'G3DSA:3.90.1140.10:FF:000035', NULL, NULL, '2'',3''-cyclic-nucleotide 3''-phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(153697, NULL, 'G3DSA:2.130.10.10:FF:000364', NULL, NULL, 'Autophagy-related protein 16-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(153698, NULL, 'G3DSA:1.25.40.10:FF:002971', NULL, NULL, 'OSM-5', NULL, NULL, NULL, NULL, NULL, 4),
(153699, NULL, 'G3DSA:3.80.10.10:FF:001168', NULL, NULL, 'Leucine-rich repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(153700, NULL, 'G3DSA:3.40.605.10:FF:000021', NULL, NULL, 'NADP-dependent glyceraldehyde-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(153701, NULL, 'G3DSA:3.90.70.200:FF:000006', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(153702, NULL, 'G3DSA:2.30.29.30:FF:000423', NULL, NULL, 'Phosphatidylinositol kinase (PIK-H1)', NULL, NULL, NULL, NULL, NULL, 4),
(153703, NULL, 'G3DSA:4.10.1170.10:FF:000004', NULL, NULL, 'MAP kinase-activated protein kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(153704, NULL, 'G3DSA:3.40.50.300:FF:001415', NULL, NULL, 'Polyprotein P1234', NULL, NULL, NULL, NULL, NULL, 4),
(153705, NULL, 'G3DSA:3.30.200.20:FF:001963', NULL, NULL, 'Membrane-associated tyrosine-and threonine-specific cdc2-inhibitory kinase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(153706, NULL, 'G3DSA:2.120.10.70:FF:000005', NULL, NULL, 'Putative secreted neuraminidase', NULL, NULL, NULL, NULL, NULL, 4),
(153707, NULL, 'G3DSA:1.10.10.60:FF:000605', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(153708, NULL, 'G3DSA:3.40.50.720:FF:001732', NULL, NULL, 'Putative myo-inositol phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(153709, NULL, 'G3DSA:3.30.1390.20:FF:000014', NULL, NULL, '50S ribosomal protein L30', NULL, NULL, NULL, NULL, NULL, 4),
(153710, NULL, 'G3DSA:1.20.1110.10:FF:000040', NULL, NULL, 'Na(+)-exporting P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(153711, NULL, 'G3DSA:3.40.50.1000:FF:000707', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153712, NULL, 'G3DSA:3.40.50.300:FF:003624', NULL, NULL, 'Uncharacterized ABC transporter ATP-binding protein MJ1662', NULL, NULL, NULL, NULL, NULL, 4),
(153713, NULL, 'G3DSA:2.60.120.590:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153714, NULL, 'G3DSA:2.60.120.20:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153715, NULL, 'G3DSA:3.90.550.50:FF:000023', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(153716, NULL, 'G3DSA:3.30.160.60:FF:006349', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153717, NULL, 'G3DSA:2.40.160.110:FF:000039', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(153718, NULL, 'G3DSA:3.20.20.210:FF:000021', NULL, NULL, 'Uroporphyrinogen decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(153719, NULL, 'G3DSA:1.10.1220.10:FF:000011', NULL, NULL, 'Transcriptional repressor arc', NULL, NULL, NULL, NULL, NULL, 4),
(153720, NULL, 'G3DSA:2.60.120.380:FF:000001', NULL, NULL, 'Calpain-1 catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(153721, NULL, 'G3DSA:2.40.10.10:FF:000486', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153722, NULL, 'G3DSA:3.90.226.10:FF:000117', NULL, NULL, 'Biotin carboxylase subunit of acetyl CoA carboxylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153723, NULL, 'G3DSA:2.60.40.10:FF:000032', NULL, NULL, 'palladin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(153724, NULL, 'G3DSA:3.40.50.300:FF:008430', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153725, NULL, 'G3DSA:2.130.10.10:FF:001089', NULL, NULL, 'WD domain', NULL, NULL, NULL, NULL, NULL, 4),
(153726, NULL, 'G3DSA:1.10.150.20:FF:000054', NULL, NULL, 'DNA repair protein RAD51 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(153727, NULL, 'G3DSA:3.40.50.12650:FF:000043', NULL, NULL, 'DNA repair metallo-beta-lactamase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(153728, NULL, 'G3DSA:3.30.200.20:FF:001755', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153729, NULL, 'G3DSA:1.25.40.10:FF:000368', NULL, NULL, 'Sperm associated antigen 1', NULL, NULL, NULL, NULL, NULL, 4),
(153730, NULL, 'G3DSA:3.30.40.10:FF:000340', NULL, NULL, 'RUN and FYVE domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(153731, NULL, 'G3DSA:3.40.630.10:FF:000349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153732, NULL, 'G3DSA:2.60.40.10:FF:004793', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153733, NULL, 'G3DSA:3.40.640.10:FF:000271', NULL, NULL, 'Probable aminotransferase gliI', NULL, NULL, NULL, NULL, NULL, 4),
(153734, NULL, 'G3DSA:3.30.70.270:FF:000182', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153735, NULL, 'G3DSA:3.30.160.60:FF:001572', NULL, NULL, 'General transcription factor IIIA', NULL, NULL, NULL, NULL, NULL, 4),
(153736, NULL, 'G3DSA:3.30.70.330:FF:001520', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153737, NULL, 'G3DSA:3.30.420.10:FF:000442', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153738, NULL, 'G3DSA:1.20.1280.290:FF:000009', NULL, NULL, 'PQ loop repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(153739, NULL, 'G3DSA:1.10.246.130:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153740, NULL, 'G3DSA:1.10.540.10:FF:000019', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(153741, NULL, 'G3DSA:3.10.450.10:FF:000027', NULL, NULL, 'Cystatin cpi-2', NULL, NULL, NULL, NULL, NULL, 4),
(153742, NULL, 'G3DSA:3.30.70.330:FF:001992', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153743, NULL, 'G3DSA:1.25.10.10:FF:003104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153744, NULL, 'G3DSA:1.10.10.60:FF:000145', NULL, NULL, 'homeobox protein Hox-A2', NULL, NULL, NULL, NULL, NULL, 4),
(153745, NULL, 'G3DSA:1.10.1200.30:FF:000004', NULL, NULL, 'Gag polyprotein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(153746, NULL, 'G3DSA:3.30.160.60:FF:001100', NULL, NULL, 'Zinc finger protein 184', NULL, NULL, NULL, NULL, NULL, 4),
(153747, NULL, 'G3DSA:2.40.30.10:FF:000499', NULL, NULL, 'Uncharacterized FAD-binding protein C17H9.12c', NULL, NULL, NULL, NULL, NULL, 4),
(153748, NULL, 'G3DSA:1.20.1740.10:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153749, NULL, 'G3DSA:3.30.260.10:FF:000093', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153750, NULL, 'G3DSA:3.40.50.12240:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153751, NULL, 'G3DSA:1.10.287.70:FF:000178', NULL, NULL, 'Ion transporter', NULL, NULL, NULL, NULL, NULL, 4),
(153752, NULL, 'G3DSA:1.20.5.170:FF:000180', NULL, NULL, 'C-type lectin domain family 4 member F', NULL, NULL, NULL, NULL, NULL, 4),
(153753, NULL, 'G3DSA:2.60.34.10:FF:000091', NULL, NULL, 'Luminal binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(153754, NULL, 'G3DSA:1.10.510.10:FF:002069', NULL, NULL, 'Protein_kinase_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(153755, NULL, 'G3DSA:2.170.130.10:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153756, NULL, 'G3DSA:1.10.150.900:FF:000001', NULL, NULL, 'Aminoacylase-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153757, NULL, 'G3DSA:3.10.450.40:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153758, NULL, 'G3DSA:1.10.220.10:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153759, NULL, 'G3DSA:1.10.20.120:FF:000009', NULL, NULL, 'YALI0E29535p', NULL, NULL, NULL, NULL, NULL, 4),
(153760, NULL, 'G3DSA:1.20.920.20:FF:000049', NULL, NULL, 'Dynein-1-beta heavy chain, flagellar inner arm I1 complex', NULL, NULL, NULL, NULL, NULL, 4),
(153761, NULL, 'G3DSA:3.40.800.20:FF:000039', NULL, NULL, 'Histone deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(153762, NULL, 'G3DSA:3.30.200.20:FF:001272', NULL, NULL, 'Serine/threonine protein kinase 24', NULL, NULL, NULL, NULL, NULL, 4),
(153763, NULL, 'G3DSA:1.20.920.10:FF:000153', NULL, NULL, 'Bromodomain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(153764, NULL, 'G3DSA:3.40.50.11000:FF:000003', NULL, NULL, 'Fe-S cluster assembly protein DRE2', NULL, NULL, NULL, NULL, NULL, 4),
(153765, NULL, 'G3DSA:3.60.110.10:FF:000064', NULL, NULL, 'Beta-ureidopropionase', NULL, NULL, NULL, NULL, NULL, 4),
(153766, NULL, 'G3DSA:2.60.40.10:FF:001021', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(153767, NULL, 'G3DSA:3.40.50.1820:FF:000392', NULL, NULL, 'Beta-ketoadipate enol-lactone hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(153768, NULL, 'G3DSA:2.60.40.10:FF:004686', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153769, NULL, 'G3DSA:3.80.20.20:FF:000053', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(153770, NULL, 'G3DSA:1.25.40.630:FF:000004', NULL, NULL, 'Rna15p', NULL, NULL, NULL, NULL, NULL, 4),
(153771, NULL, 'G3DSA:3.30.420.110:FF:000067', NULL, NULL, 'Him-14', NULL, NULL, NULL, NULL, NULL, 4),
(153772, NULL, 'G3DSA:3.40.1090.10:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153773, NULL, 'G3DSA:2.40.110.10:FF:000044', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(153774, NULL, 'G3DSA:3.30.450.20:FF:000475', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(153775, NULL, 'G3DSA:2.130.10.10:FF:004181', NULL, NULL, 'Diphthine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(153776, NULL, 'G3DSA:1.10.10.60:FF:001078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153777, NULL, 'G3DSA:3.30.60.270:FF:000016', NULL, NULL, 'uncharacterized protein LOC100182944', NULL, NULL, NULL, NULL, NULL, 4),
(153778, NULL, 'G3DSA:3.30.200.20:FF:000760', NULL, NULL, 'Casein kinase II subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(153779, NULL, 'G3DSA:2.60.40.150:FF:000631', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153780, NULL, 'G3DSA:1.25.40.10:FF:000970', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g26630, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(153781, NULL, 'G3DSA:3.20.20.30:FF:000002', NULL, NULL, 'LLM class flavin-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(153782, NULL, 'G3DSA:3.90.190.10:FF:000404', NULL, NULL, 'Dual specificity protein phosphatase CDC14B-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(153783, NULL, 'G3DSA:3.20.20.300:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153784, NULL, 'G3DSA:3.20.20.70:FF:000649', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153785, NULL, 'G3DSA:3.30.420.10:FF:000009', NULL, NULL, 'Ribonuclease T', NULL, NULL, NULL, NULL, NULL, 4),
(153786, NULL, 'G3DSA:3.90.730.10:FF:000008', NULL, NULL, 'Drought-induced S-like ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(153787, NULL, 'G3DSA:3.90.1010.10:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153788, NULL, 'G3DSA:1.10.150.20:FF:000161', NULL, NULL, 'ATP-dependent RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153789, NULL, 'G3DSA:3.40.50.300:FF:003540', NULL, NULL, 'DNA replication protein', NULL, NULL, NULL, NULL, NULL, 4),
(153790, NULL, 'G3DSA:3.40.50.300:FF:001606', NULL, NULL, 'Rab family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(153791, NULL, 'G3DSA:1.10.3430.10:FF:000038', NULL, NULL, 'Ammonium transporter', NULL, NULL, NULL, NULL, NULL, 4),
(153792, NULL, 'G3DSA:1.10.472.130:FF:000074', NULL, NULL, 'Flagellar outer dynein arm heavy chain gamma', NULL, NULL, NULL, NULL, NULL, 4),
(153793, NULL, 'G3DSA:2.130.10.10:FF:000156', NULL, NULL, 'protein TSSC1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(153794, NULL, 'G3DSA:2.60.120.200:FF:000548', NULL, NULL, 'Calreticulin 2, calcium-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(153795, NULL, 'G3DSA:1.10.30.10:FF:000137', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(153796, NULL, 'G3DSA:1.20.1250.20:FF:001615', NULL, NULL, 'Sucrose transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153797, NULL, 'G3DSA:2.110.10.10:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153798, NULL, 'G3DSA:3.30.70.100:FF:000052', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(153799, NULL, 'G3DSA:1.10.1740.10:FF:000011', NULL, NULL, 'RNA polymerase sigma factor rpoD', NULL, NULL, NULL, NULL, NULL, 4),
(153800, NULL, 'G3DSA:1.10.1390.10:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153801, NULL, 'G3DSA:1.10.10.10:FF:000916', NULL, NULL, 'Probable metalloprotease ARX1', NULL, NULL, NULL, NULL, NULL, 4),
(153802, NULL, 'G3DSA:3.40.395.10:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153803, NULL, 'G3DSA:2.120.10.80:FF:000109', NULL, NULL, 'Kelch-like protein 34', NULL, NULL, NULL, NULL, NULL, 4),
(153804, NULL, 'G3DSA:2.60.200.40:FF:000044', NULL, NULL, 'Sphingosine kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(153805, NULL, 'G3DSA:3.40.50.300:FF:001595', NULL, NULL, 'DNA helicase B', NULL, NULL, NULL, NULL, NULL, 4),
(153806, NULL, 'G3DSA:3.40.50.10190:FF:000035', NULL, NULL, 'DNA-directed DNA/RNA polymerase mu', NULL, NULL, NULL, NULL, NULL, 4),
(153807, NULL, 'G3DSA:1.10.150.920:FF:000001', NULL, NULL, 'Bifunctional hemolysin/adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(153808, NULL, 'G3DSA:2.60.120.740:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153809, NULL, 'G3DSA:2.70.98.10:FF:000058', NULL, NULL, 'Aldose 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(153810, NULL, 'G3DSA:1.25.40.180:FF:000061', NULL, NULL, 'Eukaryotic translation initiation factor 4 gamma 2', NULL, NULL, NULL, NULL, NULL, 4),
(153811, NULL, 'G3DSA:2.130.10.10:FF:005962', NULL, NULL, 'Two component signal transduction system hybrid histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(153812, NULL, 'G3DSA:2.40.50.580:FF:000002', NULL, NULL, 'Sugar fermentation stimulation protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(153813, NULL, 'G3DSA:3.90.180.10:FF:000123', NULL, NULL, 'Enoyl-[acyl-carrier-protein] reductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(153814, NULL, 'G3DSA:1.20.1250.20:FF:000671', NULL, NULL, 'Major facilitator transporter', NULL, NULL, NULL, NULL, NULL, 4),
(153815, NULL, 'G3DSA:2.40.30.10:FF:000504', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(153816, NULL, 'G3DSA:1.10.10.10:FF:000607', NULL, NULL, 'Virulence genes transcriptional activator SpvR', NULL, NULL, NULL, NULL, NULL, 4),
(153817, NULL, 'G3DSA:2.60.40.1120:FF:000037', NULL, NULL, 'SusC/RagA family TonB-linked outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(153818, NULL, 'G3DSA:2.30.29.30:FF:000951', NULL, NULL, 'AAR091Wp', NULL, NULL, NULL, NULL, NULL, 4),
(153819, NULL, 'G3DSA:1.25.40.10:FF:002841', NULL, NULL, 'Ubiquitin-protein ligase Sel1/Ubx2', NULL, NULL, NULL, NULL, NULL, 4),
(153820, NULL, 'G3DSA:2.40.10.10:FF:000593', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153821, NULL, 'G3DSA:1.20.5.110:FF:000313', NULL, NULL, 'WASH complex subunit CCDC53 homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(153822, NULL, 'G3DSA:3.30.40.10:FF:000604', NULL, NULL, 'Blast:E3 ubiquitin-protein ligase TRIM33', NULL, NULL, NULL, NULL, NULL, 4),
(153823, NULL, 'G3DSA:2.120.10.30:FF:000460', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153824, NULL, 'G3DSA:3.30.1240.10:FF:000017', NULL, NULL, 'Cof family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(153825, NULL, 'G3DSA:2.60.120.200:FF:000239', NULL, NULL, 'Laminin subunit alpha-3', NULL, NULL, NULL, NULL, NULL, 4),
(153826, NULL, 'G3DSA:3.30.160.60:FF:006248', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153827, NULL, 'G3DSA:3.30.160.60:FF:002870', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153828, NULL, 'G3DSA:3.30.450.20:FF:000582', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153829, NULL, 'G3DSA:3.50.50.60:FF:001203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153830, NULL, 'G3DSA:1.20.1560.10:FF:000635', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153831, NULL, 'G3DSA:3.90.550.10:FF:000376', NULL, NULL, 'Putative UDP-N-acetylglucosamine pyrophosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(153832, NULL, 'G3DSA:3.90.70.10:FF:000710', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153833, NULL, 'G3DSA:2.60.260.20:FF:000148', NULL, NULL, 'Heat shock protein DnaJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153834, NULL, 'G3DSA:3.40.850.10:FF:000410', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(153835, NULL, 'G3DSA:1.10.565.10:FF:000211', NULL, NULL, 'Estrogen receptor', NULL, NULL, NULL, NULL, NULL, 4),
(153836, NULL, 'G3DSA:3.90.1150.10:FF:000406', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153837, NULL, 'G3DSA:3.40.50.2300:FF:001598', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153838, NULL, 'G3DSA:3.90.1720.30:FF:000001', NULL, NULL, 'desumoylating isopeptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(153839, NULL, 'G3DSA:3.90.190.10:FF:000399', NULL, NULL, 'Protein-tyrosine-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(153840, NULL, 'G3DSA:3.80.10.10:FF:003641', NULL, NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g29720', NULL, NULL, NULL, NULL, NULL, 4),
(153841, NULL, 'G3DSA:2.60.40.10:FF:001448', NULL, NULL, 'Frazzled, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(153842, NULL, 'G3DSA:2.30.180.10:FF:000056', NULL, NULL, 'Fasciclin-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(153843, NULL, 'G3DSA:1.10.238.10:FF:000710', NULL, NULL, 'Calbindin 2', NULL, NULL, NULL, NULL, NULL, 4),
(153844, NULL, 'G3DSA:3.90.950.10:FF:000013', NULL, NULL, 'Nucleoside triphosphate pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(153845, NULL, 'G3DSA:3.30.720.10:FF:000015', NULL, NULL, 'Uncharacterized protein C17H9.07', NULL, NULL, NULL, NULL, NULL, 4),
(153846, NULL, 'G3DSA:3.90.79.10:FF:000123', NULL, NULL, 'Membrane-associated phospholipid phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(153847, NULL, 'G3DSA:3.40.50.360:FF:000101', NULL, NULL, '5-methyltetrahydrofolate-homocysteine methyltransferase reductase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(153848, NULL, 'G3DSA:3.40.50.720:FF:001838', NULL, NULL, 'FAD dependent oxidoreductase superfamily (AFU_orthologue AFUA_6G10230)', NULL, NULL, NULL, NULL, NULL, 4),
(153849, NULL, 'G3DSA:2.30.30.1020:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153850, NULL, 'G3DSA:3.80.10.10:FF:000235', NULL, NULL, 'Leucine-rich repeat serine/threonine-protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(153851, NULL, 'G3DSA:2.10.110.10:FF:000079', NULL, NULL, 'LIM and cysteine-rich domains protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(153852, NULL, 'G3DSA:3.30.1360.40:FF:000035', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(153853, NULL, 'G3DSA:2.60.40.150:FF:000092', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(153854, NULL, 'G3DSA:1.25.40.430:FF:000023', NULL, NULL, 'BUB1 mitotic checkpoint serine/threonine kinase Bb', NULL, NULL, NULL, NULL, NULL, 4),
(153855, NULL, 'G3DSA:2.120.10.80:FF:000418', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(153856, NULL, 'G3DSA:2.60.40.3210:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153857, NULL, 'G3DSA:2.160.20.10:FF:000150', NULL, NULL, 'Os06g0280100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(153858, NULL, 'G3DSA:1.20.120.1750:FF:000013', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(153859, NULL, 'G3DSA:3.40.640.10:FF:000164', NULL, NULL, 'Cystathionine gamma-lyase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153860, NULL, 'G3DSA:1.10.150.20:FF:000318', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(153861, NULL, 'G3DSA:3.30.1740.10:FF:000022', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(153862, NULL, 'G3DSA:3.10.250.10:FF:000023', NULL, NULL, 'lysyl oxidase homolog 4', NULL, NULL, NULL, NULL, NULL, 4),
(153863, NULL, 'G3DSA:2.60.34.10:FF:000102', NULL, NULL, 'Heat shock 105/110 protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(153864, NULL, 'G3DSA:3.40.390.10:FF:000274', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153865, NULL, 'G3DSA:4.10.60.10:FF:000227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153866, NULL, 'G3DSA:3.40.50.300:FF:007811', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153867, NULL, 'G3DSA:3.40.50.410:FF:000228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153868, NULL, 'G3DSA:1.25.10.10:FF:001176', NULL, NULL, 'Karyopherin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153869, NULL, 'G3DSA:2.60.120.650:FF:000121', NULL, NULL, 'Lysine-specific demethylase JMJ25', NULL, NULL, NULL, NULL, NULL, 4),
(153870, NULL, 'G3DSA:3.30.40.10:FF:000593', NULL, NULL, 'Cti6p', NULL, NULL, NULL, NULL, NULL, 4),
(153871, NULL, 'G3DSA:2.60.40.1180:FF:000229', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(153872, NULL, 'G3DSA:3.40.710.10:FF:000030', NULL, NULL, 'Penicillin-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(153873, NULL, 'G3DSA:2.60.40.630:FF:000005', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(153874, NULL, 'G3DSA:2.30.30.190:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153875, NULL, 'G3DSA:3.40.50.150:FF:000791', NULL, NULL, 'Os12g0199500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(153876, NULL, 'G3DSA:1.10.3380.30:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153877, NULL, 'G3DSA:2.120.10.30:FF:000466', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(153878, NULL, 'G3DSA:3.30.700.10:FF:000008', NULL, NULL, 'ComG operon protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(153879, NULL, 'G3DSA:2.60.40.1910:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153880, NULL, 'G3DSA:3.40.50.720:FF:000113', NULL, NULL, 'Glutamate synthase [NADH], amyloplastic', NULL, NULL, NULL, NULL, NULL, 4),
(153881, NULL, 'G3DSA:3.30.160.60:FF:005259', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(153882, NULL, 'G3DSA:2.60.120.1540:FF:000017', NULL, NULL, 'Complement component 4', NULL, NULL, NULL, NULL, NULL, 4),
(153883, NULL, 'G3DSA:2.60.40.10:FF:003702', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153884, NULL, 'G3DSA:3.30.342.10:FF:000007', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(153885, NULL, 'G3DSA:3.60.21.60:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153886, NULL, 'G3DSA:3.30.160.60:FF:001881', NULL, NULL, 'Protein tramtrack, beta isoform', NULL, NULL, NULL, NULL, NULL, 4),
(153887, NULL, 'G3DSA:3.30.70.330:FF:000475', NULL, NULL, 'splicing factor-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(153888, NULL, 'G3DSA:2.60.40.10:FF:001920', NULL, NULL, 'Immunoglobulin lambda variable 6-57', NULL, NULL, NULL, NULL, NULL, 4),
(153889, NULL, 'G3DSA:3.30.70.870:FF:000035', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(153890, NULL, 'G3DSA:3.10.100.10:FF:000260', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153891, NULL, 'G3DSA:3.30.360.10:FF:000038', NULL, NULL, 'Gfo/Idh/MocA family oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(153892, NULL, 'G3DSA:3.30.230.70:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153893, NULL, 'G3DSA:3.30.450.40:FF:000161', NULL, NULL, 'Sensor histidine kinase/response regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153894, NULL, 'G3DSA:3.40.50.450:FF:000100', NULL, NULL, 'Uncharacterized protein C191.05c', NULL, NULL, NULL, NULL, NULL, 4),
(153895, NULL, 'G3DSA:3.40.50.720:FF:001529', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(153896, NULL, 'G3DSA:3.80.10.10:FF:004260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153897, NULL, 'G3DSA:2.60.40.10:FF:003382', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153898, NULL, 'G3DSA:3.40.50.300:FF:002904', NULL, NULL, 'Type VII secretion system ESX-1 associated protein EspI', NULL, NULL, NULL, NULL, NULL, 4),
(153899, NULL, 'G3DSA:3.40.190.10:FF:000629', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153900, NULL, 'G3DSA:3.60.40.10:FF:000226', NULL, NULL, 'Sigma factor SibG regulation protein RsbU', NULL, NULL, NULL, NULL, NULL, 4),
(153901, NULL, 'G3DSA:3.40.50.10810:FF:000058', NULL, NULL, 'RDH54p DNA-dependent ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(153902, NULL, 'G3DSA:3.30.70.20:FF:000098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153903, NULL, 'G3DSA:2.20.70.30:FF:000002', NULL, NULL, 'Nascent polypeptide-associated complex (NAC), alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(153904, NULL, 'G3DSA:3.40.50.720:FF:002474', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(153905, NULL, 'G3DSA:1.20.1070.10:FF:001733', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153906, NULL, 'G3DSA:2.60.120.10:FF:000591', NULL, NULL, 'Patatin like phospholipase domain containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(153907, NULL, 'G3DSA:2.40.420.20:FF:000020', NULL, NULL, 'Probable RND efflux membrane fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(153908, NULL, 'G3DSA:3.90.1480.20:FF:000058', NULL, NULL, 'ST6 beta-galactosamide alpha-2,6-sialyltranferase 2b', NULL, NULL, NULL, NULL, NULL, 4),
(153909, NULL, 'G3DSA:3.40.50.300:FF:005996', NULL, NULL, 'Katanin p60 ATPase-containing subunit', NULL, NULL, NULL, NULL, NULL, 4),
(153910, NULL, 'G3DSA:1.20.120.1770:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153911, NULL, 'G3DSA:1.10.8.60:FF:000397', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(153912, NULL, 'G3DSA:1.20.140.40:FF:000074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153913, NULL, 'G3DSA:3.60.10.10:FF:000045', NULL, NULL, 'Endonuclease/exonuclease/phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(153914, NULL, 'G3DSA:3.30.559.10:FF:000174', NULL, NULL, 'Nonribosomal peptide synthetase 6', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(153915, NULL, 'G3DSA:3.30.160.60:FF:000936', NULL, NULL, 'Zinc finger protein 577', NULL, NULL, NULL, NULL, NULL, 4),
(153916, NULL, 'G3DSA:2.40.50.1000:FF:000006', NULL, NULL, '40S ribosomal protein S11', NULL, NULL, NULL, NULL, NULL, 4),
(153917, NULL, 'G3DSA:3.40.50.300:FF:006485', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(153918, NULL, 'G3DSA:3.30.740.10:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153919, NULL, 'G3DSA:1.25.40.10:FF:002313', NULL, NULL, 'Pentatricopeptide repeat (PPR) superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(153920, NULL, 'G3DSA:3.10.20.30:FF:000087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153921, NULL, 'G3DSA:1.25.40.180:FF:000280', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153922, NULL, 'G3DSA:1.25.40.10:FF:002768', NULL, NULL, 'YALI0E15994p', NULL, NULL, NULL, NULL, NULL, 4),
(153923, NULL, 'G3DSA:3.30.479.20:FF:000030', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(153924, NULL, 'G3DSA:1.50.10.10:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153925, NULL, 'G3DSA:2.120.10.30:FF:000090', NULL, NULL, 'Putative Dipeptidyl aminopeptidases /acylaminoacyl-peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(153926, NULL, 'G3DSA:1.25.40.10:FF:005039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153927, NULL, 'G3DSA:3.40.50.300:FF:006030', NULL, NULL, 'Helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153928, NULL, 'G3DSA:2.40.70.10:FF:000153', NULL, NULL, 'Basic 7S globulin', NULL, NULL, NULL, NULL, NULL, 4),
(153929, NULL, 'G3DSA:2.40.50.140:FF:000926', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153930, NULL, 'G3DSA:3.40.50.300:FF:002899', NULL, NULL, 'Unplaced genomic scaffold supercont1.83, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(153931, NULL, 'G3DSA:1.20.1250.20:FF:002104', NULL, NULL, 'Monocarboxylate transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(153932, NULL, 'G3DSA:2.40.70.10:FF:000389', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153933, NULL, 'G3DSA:3.30.450.30:FF:000023', NULL, NULL, 'Profilin', NULL, NULL, NULL, NULL, NULL, 4),
(153934, NULL, 'G3DSA:3.40.50.2300:FF:001626', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153935, NULL, 'G3DSA:1.10.510.10:FF:003053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153936, NULL, 'G3DSA:3.90.1470.20:FF:000001', NULL, NULL, 'Putative phosphoserine phosphatase protein', NULL, NULL, NULL, NULL, NULL, 4),
(153937, NULL, 'G3DSA:1.20.58.340:FF:000022', NULL, NULL, 'Magnesium transporter MRS2-F', NULL, NULL, NULL, NULL, NULL, 4),
(153938, NULL, 'G3DSA:3.80.10.10:FF:002343', NULL, NULL, 'EIN3-binding F-box protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(153939, NULL, 'G3DSA:3.40.50.150:FF:001752', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153940, NULL, 'G3DSA:3.40.630.10:FF:000219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153941, NULL, 'G3DSA:1.50.40.10:FF:000299', NULL, NULL, 'Uncharacterized mitochondrial carrier C4G8.08', NULL, NULL, NULL, NULL, NULL, 4),
(153942, NULL, 'G3DSA:3.50.50.60:FF:000669', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(153943, NULL, 'G3DSA:1.20.5.120:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153944, NULL, 'G3DSA:3.30.420.10:FF:000318', NULL, NULL, 'Polymerase (DNA directed) nu', NULL, NULL, NULL, NULL, NULL, 4),
(153945, NULL, 'G3DSA:2.130.10.10:FF:005012', NULL, NULL, 'Neural precursor cell expressed, developmentally down-regulated 1', NULL, NULL, NULL, NULL, NULL, 4),
(153946, NULL, 'G3DSA:1.20.5.100:FF:000001', NULL, NULL, 'UDP-glucose 6-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(153947, NULL, 'G3DSA:2.60.40.3360:FF:000001', NULL, NULL, 'Mucosa-associated lymphoid tissue lymphoma translocation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(153948, NULL, 'G3DSA:1.10.472.80:FF:000027', NULL, NULL, 'GTPase activating protein (Evi5)', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(153949, NULL, 'G3DSA:2.60.200.10:FF:000046', NULL, NULL, 'Interferon regulatory factor 7', NULL, NULL, NULL, NULL, NULL, 4),
(153950, NULL, 'G3DSA:3.30.40.10:FF:001902', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153951, NULL, 'G3DSA:3.90.730.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153952, NULL, 'G3DSA:3.30.420.40:FF:001030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153953, NULL, 'G3DSA:3.40.50.300:FF:003995', NULL, NULL, 'Ras-related protein Rab-37', NULL, NULL, NULL, NULL, NULL, 4),
(153954, NULL, 'G3DSA:1.25.40.20:FF:000736', NULL, NULL, 'Ankyrin repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(153955, NULL, 'G3DSA:1.25.40.10:FF:001779', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g08210', NULL, NULL, NULL, NULL, NULL, 4),
(153956, NULL, 'G3DSA:1.10.238.10:FF:001183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153957, NULL, 'G3DSA:2.60.40.10:FF:003921', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153958, NULL, 'G3DSA:3.40.50.300:FF:003523', NULL, NULL, 'Endosomal AAA ATPase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(153959, NULL, 'G3DSA:2.40.50.100:FF:000145', NULL, NULL, 'Sugar ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(153960, NULL, 'G3DSA:3.40.50.11500:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153961, NULL, 'G3DSA:1.20.920.10:FF:000029', NULL, NULL, 'Bromodomain adjacent to zinc finger domain protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(153962, NULL, 'G3DSA:1.10.274.10:FF:000007', NULL, NULL, 'Phosphoenolpyruvate-protein phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(153963, NULL, 'G3DSA:3.30.300.30:FF:000164', NULL, NULL, 'Nonribosomal peptide synthetase asqK', NULL, NULL, NULL, NULL, NULL, 4),
(153964, NULL, 'G3DSA:2.60.120.40:FF:000015', NULL, NULL, 'Collagen-like triple helix repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(153965, NULL, 'G3DSA:4.10.240.10:FF:000215', NULL, NULL, 'Zcf1p', NULL, NULL, NULL, NULL, NULL, 4),
(153966, NULL, 'G3DSA:3.30.200.20:FF:000344', NULL, NULL, 'Serine/threonine-protein kinase WARTS homolog', NULL, NULL, NULL, NULL, NULL, 4),
(153967, NULL, 'G3DSA:3.50.30.50:FF:000002', NULL, NULL, 'Kynurenine formamidase', NULL, NULL, NULL, NULL, NULL, 4),
(153968, NULL, 'G3DSA:3.50.4.10:FF:000004', NULL, NULL, 'Hepatocyte growth factor-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(153969, NULL, 'G3DSA:1.20.140.40:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153970, NULL, 'G3DSA:3.30.450.230:FF:000002', NULL, NULL, 'AGR054Cp', NULL, NULL, NULL, NULL, NULL, 4),
(153971, NULL, 'G3DSA:3.40.50.300:FF:007446', NULL, NULL, 'ATP-dependent DEAD/H RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(153972, NULL, 'G3DSA:1.25.40.10:FF:001352', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(153973, NULL, 'G3DSA:1.20.1250.20:FF:002251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153974, NULL, 'G3DSA:3.40.50.10190:FF:000018', NULL, NULL, 'DNA topoisomerase 2-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(153975, NULL, 'G3DSA:4.10.40.30:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153976, NULL, 'G3DSA:3.30.70.330:FF:002392', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153977, NULL, 'G3DSA:3.30.160.60:FF:006243', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(153978, NULL, 'G3DSA:3.40.50.720:FF:002457', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(153979, NULL, 'G3DSA:3.30.160.60:FF:000588', NULL, NULL, 'Zinc finger protein 568', NULL, NULL, NULL, NULL, NULL, 4),
(153980, NULL, 'G3DSA:1.10.640.10:FF:000055', NULL, NULL, 'Putative peroxinectin', NULL, NULL, NULL, NULL, NULL, 4),
(153981, NULL, 'G3DSA:3.30.497.10:FF:000097', NULL, NULL, 'Serpin 42Db, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(153982, NULL, 'G3DSA:1.10.510.10:FF:002288', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(153983, NULL, 'G3DSA:1.50.10.10:FF:000134', NULL, NULL, 'Putative secreted protein', NULL, NULL, NULL, NULL, NULL, 4),
(153984, NULL, 'G3DSA:1.10.1670.40:FF:000008', NULL, NULL, 'DNA-3-methyladenine glycosidase II', NULL, NULL, NULL, NULL, NULL, 4),
(153985, NULL, 'G3DSA:3.90.70.10:FF:000603', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153986, NULL, 'G3DSA:3.40.50.1980:FF:000052', NULL, NULL, 'Ferrichrome ABC transporter lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(153987, NULL, 'G3DSA:2.160.10.10:FF:000020', NULL, NULL, 'Glucose-1-phosphate adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(153988, NULL, 'G3DSA:1.25.40.10:FF:000059', NULL, NULL, 'Vacuolar protein sorting-associated protein 41 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(153989, NULL, 'G3DSA:1.10.238.10:FF:000238', NULL, NULL, 'CALmodulin related genes', NULL, NULL, NULL, NULL, NULL, 4),
(153990, NULL, 'G3DSA:3.80.10.10:FF:001640', NULL, NULL, 'Transforming growth factor beta activator LRRC33', NULL, NULL, NULL, NULL, NULL, 4),
(153991, NULL, 'G3DSA:4.10.1060.10:FF:000041', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(153992, NULL, 'G3DSA:2.60.120.260:FF:000089', NULL, NULL, 'Eph receptor tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(153993, NULL, 'G3DSA:2.60.120.680:FF:000001', NULL, NULL, 'SEC14-like protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(153994, NULL, 'G3DSA:3.40.50.620:FF:000645', NULL, NULL, 'Os01g0120300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(153995, NULL, 'G3DSA:3.40.800.10:FF:000019', NULL, NULL, 'Agmatinase', NULL, NULL, NULL, NULL, NULL, 4),
(153996, NULL, 'G3DSA:1.10.510.10:FF:000490', NULL, NULL, 'Proto-oncogene serine/threonine-protein kinase mos', NULL, NULL, NULL, NULL, NULL, 4),
(153997, NULL, 'G3DSA:3.40.50.170:FF:000033', NULL, NULL, 'Trifunctional purine biosynthetic protein adenosine-3', NULL, NULL, NULL, NULL, NULL, 4),
(153998, NULL, 'G3DSA:3.30.9.10:FF:000279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(153999, NULL, 'G3DSA:2.60.40.790:FF:000137', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154000, NULL, 'G3DSA:4.10.280.110:FF:000015', NULL, NULL, 'WD40-repeat-containing domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(154001, NULL, 'G3DSA:2.40.50.880:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154002, NULL, 'G3DSA:1.10.418.50:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154003, NULL, 'G3DSA:3.40.50.300:FF:001179', NULL, NULL, 'Rho family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(154004, NULL, 'G3DSA:1.10.20.130:FF:000001', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(154005, NULL, 'G3DSA:3.60.110.10:FF:000092', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154006, NULL, 'G3DSA:3.40.50.1820:FF:001662', NULL, NULL, 'Narbonolide/10-deoxymethynolide synthase PikA4, module 6', NULL, NULL, NULL, NULL, NULL, 4),
(154007, NULL, 'G3DSA:3.90.226.10:FF:000078', NULL, NULL, 'Enoyl-CoA hydratase EchA12', NULL, NULL, NULL, NULL, NULL, 4),
(154008, NULL, 'G3DSA:3.10.20.30:FF:000082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154009, NULL, 'G3DSA:1.20.120.1020:FF:000002', NULL, NULL, 'Heterokaryon incompatibility protein s', NULL, NULL, NULL, NULL, NULL, 4),
(154010, NULL, 'G3DSA:3.80.10.10:FF:001724', NULL, NULL, 'F-box and leucine-rich repeat protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(154011, NULL, 'G3DSA:3.40.50.720:FF:001524', NULL, NULL, '3-ketodihydrosphingosine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(154012, NULL, 'G3DSA:3.10.20.90:FF:000493', NULL, NULL, 'Ubiquitin', NULL, NULL, NULL, NULL, NULL, 4),
(154013, NULL, 'G3DSA:3.30.160.60:FF:000408', NULL, NULL, 'Krueppel-like factor 15', NULL, NULL, NULL, NULL, NULL, 4),
(154014, NULL, 'G3DSA:3.30.70.330:FF:003100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154015, NULL, 'G3DSA:2.40.50.140:FF:000241', NULL, NULL, 'DNA-directed RNA polymerases I, II, and III subunit RPABC3', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(154016, NULL, 'G3DSA:2.40.100.20:FF:000001', NULL, NULL, 'Flavodoxin', NULL, NULL, NULL, NULL, NULL, 4),
(154017, NULL, 'G3DSA:1.10.287.110:FF:000191', NULL, NULL, 'Putative heat shock protein DNAJ', NULL, NULL, NULL, NULL, NULL, 4),
(154018, NULL, 'G3DSA:2.60.120.200:FF:000655', NULL, NULL, 'Collagen type XXVII alpha 1 chain', NULL, NULL, NULL, NULL, NULL, 4),
(154019, NULL, 'G3DSA:2.130.10.10:FF:002073', NULL, NULL, 'WD40 repeat-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(154020, NULL, 'G3DSA:3.40.50.1220:FF:000072', NULL, NULL, 'Hst3p', NULL, NULL, NULL, NULL, NULL, 4),
(154021, NULL, 'G3DSA:2.70.98.60:FF:000005', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(154022, NULL, 'G3DSA:1.10.8.60:FF:000402', NULL, NULL, 'Katanin p60 ATPase-containing subunit A-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(154023, NULL, 'G3DSA:2.30.30.100:FF:000172', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm3', NULL, NULL, NULL, NULL, NULL, 4),
(154024, NULL, 'G3DSA:2.60.40.60:FF:000693', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154025, NULL, 'G3DSA:3.10.20.90:FF:000970', NULL, NULL, 'CHD gene family protein containing chromodomain, helicase domain, and DNA-binding domain', NULL, NULL, NULL, NULL, NULL, 4),
(154026, NULL, 'G3DSA:3.10.20.90:FF:000184', NULL, NULL, 'UBX domain-containing protein 8 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(154027, NULL, 'G3DSA:2.40.180.10:FF:000008', NULL, NULL, 'lipoxygenase homology domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(154028, NULL, 'G3DSA:3.40.190.10:FF:000865', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154029, NULL, 'G3DSA:3.30.70.330:FF:002476', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154030, NULL, 'G3DSA:1.10.20.10:FF:000333', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154031, NULL, 'G3DSA:2.40.50.1070:FF:000010', NULL, NULL, '23S rRNA m(5)U-1939 methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(154032, NULL, 'G3DSA:3.30.160.60:FF:003831', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154033, NULL, 'G3DSA:3.40.532.10:FF:000008', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(154034, NULL, 'G3DSA:3.30.110.20:FF:000017', NULL, NULL, 'WGS project CABT00000000 data, contig 2.72', NULL, NULL, NULL, NULL, NULL, 4),
(154035, NULL, 'G3DSA:3.40.50.1820:FF:001353', NULL, NULL, 'GH05794p', NULL, NULL, NULL, NULL, NULL, 4),
(154036, NULL, 'G3DSA:3.40.33.10:FF:000031', NULL, NULL, 'Extracellular SCP domain-containing protein Pry1', NULL, NULL, NULL, NULL, NULL, 4),
(154037, NULL, 'G3DSA:3.30.70.330:FF:000222', NULL, NULL, 'mRNA binding post-transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(154038, NULL, 'G3DSA:3.40.30.10:FF:001070', NULL, NULL, 'Thioredoxin SoxW', NULL, NULL, NULL, NULL, NULL, 4),
(154039, NULL, 'G3DSA:3.40.50.1820:FF:000717', NULL, NULL, 'Acetylcholinesterase/butyrylcholinesterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(154040, NULL, 'G3DSA:2.40.50.140:FF:000550', NULL, NULL, 'RNA-editing complex protein MP81', NULL, NULL, NULL, NULL, NULL, 4),
(154041, NULL, 'G3DSA:3.40.50.1100:FF:000182', NULL, NULL, 'Cysteine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(154042, NULL, 'G3DSA:1.20.1250.20:FF:000654', NULL, NULL, 'Carcinine transporter', NULL, NULL, NULL, NULL, NULL, 4),
(154043, NULL, 'G3DSA:3.40.50.2300:FF:001250', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154044, NULL, 'G3DSA:1.10.840.10:FF:000020', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(154045, NULL, 'G3DSA:3.40.120.10:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154046, NULL, 'G3DSA:3.40.50.720:FF:000220', NULL, NULL, '3 beta-hydroxysteroid dehydrogenase/Delta 5-->4-isomerase type 1', NULL, NULL, NULL, NULL, NULL, 4),
(154047, NULL, 'G3DSA:2.20.70.10:FF:000125', NULL, NULL, 'E3 ubiquitin-protein ligase Smurf1', NULL, NULL, NULL, NULL, NULL, 4),
(154048, NULL, 'G3DSA:3.40.50.300:FF:007339', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(154049, NULL, 'G3DSA:1.10.510.10:FF:004233', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154050, NULL, 'G3DSA:3.40.50.2300:FF:000446', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(154051, NULL, 'G3DSA:3.10.350.10:FF:000082', NULL, NULL, 'Lipoprotein NlpD', NULL, NULL, NULL, NULL, NULL, 4),
(154052, NULL, 'G3DSA:3.30.200.20:FF:000451', NULL, NULL, 'L-type lectin-domain containing receptor kinase I.9', NULL, NULL, NULL, NULL, NULL, 4),
(154053, NULL, 'G3DSA:2.130.10.10:FF:002634', NULL, NULL, 'Pleiotropic regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(154054, NULL, 'G3DSA:3.20.20.300:FF:000020', NULL, NULL, 'Sugar hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(154055, NULL, 'G3DSA:3.30.260.10:FF:000098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154056, NULL, 'G3DSA:3.30.160.60:FF:005624', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154057, NULL, 'G3DSA:2.90.10.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154058, NULL, 'G3DSA:3.40.190.10:FF:000646', NULL, NULL, 'Peptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(154059, NULL, 'G3DSA:1.20.1560.10:FF:000107', NULL, NULL, 'ABC transporter C family member 13', NULL, NULL, NULL, NULL, NULL, 4),
(154060, NULL, 'G3DSA:2.60.120.970:FF:000099', NULL, NULL, 'Bone morphogenetic protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(154061, NULL, 'G3DSA:3.90.79.10:FF:000106', NULL, NULL, 'NUDIX domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(154062, NULL, 'G3DSA:3.30.1120.30:FF:000048', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(154063, NULL, 'G3DSA:3.40.50.2300:FF:000322', NULL, NULL, 'Autoinducer 2 sensor kinase/phosphatase luxQ', NULL, NULL, NULL, NULL, NULL, 4),
(154064, NULL, 'G3DSA:1.20.1250.20:FF:001632', NULL, NULL, 'MFS multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(154065, NULL, 'G3DSA:3.50.50.60:FF:000821', NULL, NULL, 'AGR055Cp', NULL, NULL, NULL, NULL, NULL, 4),
(154066, NULL, 'G3DSA:3.10.129.10:FF:000270', NULL, NULL, 'Acyl coenzyme A thioester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(154067, NULL, 'G3DSA:3.40.50.300:FF:003068', NULL, NULL, 'Rab family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(154068, NULL, 'G3DSA:3.40.50.1820:FF:001701', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154069, NULL, 'G3DSA:3.40.50.1240:FF:000167', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154070, NULL, 'G3DSA:2.130.10.10:FF:003034', NULL, NULL, 'Uncharacterized WD repeat-containing protein slr1409', NULL, NULL, NULL, NULL, NULL, 4),
(154071, NULL, 'G3DSA:3.30.930.10:FF:000200', NULL, NULL, 'Lysyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(154072, NULL, 'G3DSA:3.80.10.10:FF:003438', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154073, NULL, 'G3DSA:2.30.39.10:FF:000002', NULL, NULL, 'Serpin family D member 1', NULL, NULL, NULL, NULL, NULL, 4),
(154074, NULL, 'G3DSA:3.30.160.60:FF:001353', NULL, NULL, 'zinc finger protein 133 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(154075, NULL, 'G3DSA:2.40.50.100:FF:000229', NULL, NULL, 'Protein CBR-LIN-7', NULL, NULL, NULL, NULL, NULL, 4),
(154076, NULL, 'G3DSA:1.25.40.20:FF:000517', NULL, NULL, 'Phosphate metabolism-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(154077, NULL, 'G3DSA:3.90.850.10:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154078, NULL, 'G3DSA:3.30.70.580:FF:000072', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(154079, NULL, 'G3DSA:3.40.50.2300:FF:000761', NULL, NULL, 'Gamma-aminobutyric acid type B receptor subunit 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(154080, NULL, 'G3DSA:1.25.10.10:FF:003093', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(154081, NULL, 'G3DSA:3.30.900.10:FF:000035', NULL, NULL, 'Autophagy related 13', NULL, NULL, NULL, NULL, NULL, 4),
(154082, NULL, 'G3DSA:1.20.5.110:FF:000330', NULL, NULL, 't-SNARE domain containing 1', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(154083, NULL, 'G3DSA:3.30.420.390:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154084, NULL, 'G3DSA:2.130.10.10:FF:003562', NULL, NULL, 'Os02g0796700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(154085, NULL, 'G3DSA:1.20.1250.20:FF:000126', NULL, NULL, 'MFS transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(154086, NULL, 'G3DSA:1.20.120.610:FF:000001', NULL, NULL, 'V-type proton ATPase proteolipid subunit', NULL, NULL, NULL, NULL, NULL, 4),
(154087, NULL, 'G3DSA:1.20.1560.10:FF:000416', NULL, NULL, 'ATP-binding cassette sub-family C member 8', NULL, NULL, NULL, NULL, NULL, 4),
(154088, NULL, 'G3DSA:3.40.50.410:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154089, NULL, 'G3DSA:1.20.120.1750:FF:000018', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(154090, NULL, 'G3DSA:1.10.260.40:FF:000052', NULL, NULL, 'HTH-type transcriptional regulator DicA', NULL, NULL, NULL, NULL, NULL, 4),
(154091, NULL, 'G3DSA:3.40.50.2000:FF:000570', NULL, NULL, 'Glycosyl transferase family 1', NULL, NULL, NULL, NULL, NULL, 4),
(154092, NULL, 'G3DSA:1.25.40.20:FF:001681', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154093, NULL, 'G3DSA:1.20.930.10:FF:000002', NULL, NULL, 'Transcription elongation factor A (SII), 1', NULL, NULL, NULL, NULL, NULL, 4),
(154094, NULL, 'G3DSA:3.90.1290.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154095, NULL, 'G3DSA:3.50.50.60:FF:001310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154096, NULL, 'G3DSA:3.40.50.850:FF:000023', NULL, NULL, 'Isochorismatase domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(154097, NULL, 'G3DSA:3.40.50.2300:FF:000631', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(154098, NULL, 'G3DSA:4.10.400.10:FF:000003', NULL, NULL, 'Putative low-density lipoprotein receptor-related protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(154099, NULL, 'G3DSA:3.30.40.10:FF:001773', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154100, NULL, 'G3DSA:3.30.40.10:FF:001897', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154101, NULL, 'G3DSA:2.20.25.80:FF:000008', NULL, NULL, 'WRKY transcription factor 40', NULL, NULL, NULL, NULL, NULL, 4),
(154102, NULL, 'G3DSA:3.30.160.60:FF:000953', NULL, NULL, 'Zinc finger protein 691', NULL, NULL, NULL, NULL, NULL, 4),
(154103, NULL, 'G3DSA:3.30.720.10:FF:000010', NULL, NULL, 'Signal recognition particle (SRP) subunit', NULL, NULL, NULL, NULL, NULL, 4),
(154104, NULL, 'G3DSA:3.30.200.20:FF:000890', NULL, NULL, 'Putative serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(154105, NULL, 'G3DSA:2.30.180.10:FF:000039', NULL, NULL, 'Fasciclin 1, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(154106, NULL, 'G3DSA:2.130.10.10:FF:003253', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(154107, NULL, 'G3DSA:2.10.25.10:FF:001314', NULL, NULL, 'Delta/notch-like EGF-related receptor', NULL, NULL, NULL, NULL, NULL, 4),
(154108, NULL, 'G3DSA:1.25.40.20:FF:000697', NULL, NULL, 'Transient receptor potential cation channel, subfamily A, member 1b', NULL, NULL, NULL, NULL, NULL, 4),
(154109, NULL, 'G3DSA:1.10.510.10:FF:001136', NULL, NULL, 'MTK1/MEKK4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(154110, NULL, 'G3DSA:1.20.1270.60:FF:000307', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154111, NULL, 'G3DSA:3.40.50.720:FF:000905', NULL, NULL, 'Oxidoreductase, short chain dehydrogenase/reductase family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(154112, NULL, 'G3DSA:3.90.550.10:FF:000371', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(154113, NULL, 'G3DSA:2.130.10.30:FF:000010', NULL, NULL, 'RCC1 and BTB domain-containing protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(154114, NULL, 'G3DSA:1.10.533.10:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(154115, NULL, 'G3DSA:1.25.40.470:FF:000024', NULL, NULL, 'Reduced mechanoreceptor potential A', NULL, NULL, NULL, NULL, NULL, 4),
(154116, NULL, 'G3DSA:3.30.2130.30:FF:000004', NULL, NULL, 'THUMP domain-containing protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(154117, NULL, 'G3DSA:2.60.40.1510:FF:000031', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(154118, NULL, 'G3DSA:3.40.50.300:FF:000645', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(154119, NULL, 'G3DSA:3.30.40.10:FF:000576', NULL, NULL, 'RING finger protein ETP1', NULL, NULL, NULL, NULL, NULL, 4),
(154120, NULL, 'G3DSA:1.10.101.10:FF:000005', NULL, NULL, 'General secretion pathway protein A', NULL, NULL, NULL, NULL, NULL, 4),
(154121, NULL, 'G3DSA:1.10.8.140:FF:000015', NULL, NULL, 'DNA-binding protein VNG_2008H', NULL, NULL, NULL, NULL, NULL, 4),
(154122, NULL, 'G3DSA:2.60.40.60:FF:000513', NULL, NULL, 'CaDHerin family', NULL, NULL, NULL, NULL, NULL, 4),
(154123, NULL, 'G3DSA:3.30.160.60:FF:004450', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154124, NULL, 'G3DSA:2.130.10.10:FF:004973', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154125, NULL, 'G3DSA:2.60.450.20:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154126, NULL, 'G3DSA:1.25.40.20:FF:000388', NULL, NULL, 'Os11g0251200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(154127, NULL, 'G3DSA:1.20.1250.20:FF:001290', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(154128, NULL, 'G3DSA:1.25.40.20:FF:001664', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154129, NULL, 'G3DSA:3.30.70.330:FF:001172', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(154130, NULL, 'G3DSA:2.120.10.30:FF:000544', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154131, NULL, 'G3DSA:1.10.565.10:FF:000189', NULL, NULL, 'RAR-related orphan receptor A', NULL, NULL, NULL, NULL, NULL, 4),
(154132, NULL, 'G3DSA:2.40.50.140:FF:000472', NULL, NULL, 'Unplaced genomic scaffold supercont1.9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(154133, NULL, 'G3DSA:1.10.10.10:FF:002069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154134, NULL, 'G3DSA:3.10.20.30:FF:000065', NULL, NULL, 'Carbazole 1,9a-dioxygenase ferredoxin component', NULL, NULL, NULL, NULL, NULL, 4),
(154135, NULL, 'G3DSA:1.10.760.10:FF:000002', NULL, NULL, 'Cytochrome c1, heme protein', NULL, NULL, NULL, NULL, NULL, 4),
(154136, NULL, 'G3DSA:3.40.50.300:FF:002775', NULL, NULL, 'Regulator of nonsense transcripts 1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(154137, NULL, 'G3DSA:1.10.10.10:FF:001996', NULL, NULL, 'Transcriptional regulator, MarR family', NULL, NULL, NULL, NULL, NULL, 4),
(154138, NULL, 'G3DSA:2.60.40.10:FF:000268', NULL, NULL, 'Nectin cell adhesion molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(154139, NULL, 'G3DSA:1.10.238.10:FF:000255', NULL, NULL, 'Mitochondrial Rho GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(154140, NULL, 'G3DSA:1.20.1070.10:FF:000120', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(154141, NULL, 'G3DSA:3.40.50.620:FF:000628', NULL, NULL, 'Argininosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(154142, NULL, 'G3DSA:3.30.70.80:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154143, NULL, 'G3DSA:1.10.287.310:FF:000003', NULL, NULL, '50S ribosomal protein L29', NULL, NULL, NULL, NULL, NULL, 4),
(154144, NULL, 'G3DSA:3.80.10.10:FF:004057', NULL, NULL, 'CAP-Gly domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(154145, NULL, 'G3DSA:1.10.8.1220:FF:000012', NULL, NULL, 'Protein CBR-CHE-3', NULL, NULL, NULL, NULL, NULL, 4),
(154146, NULL, 'G3DSA:3.40.30.10:FF:000878', NULL, NULL, 'Glutathione s-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(154147, NULL, 'G3DSA:3.30.565.10:FF:000250', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(154148, NULL, 'G3DSA:2.30.30.40:FF:000036', NULL, NULL, 'Spectrin alpha chain, non-erythrocytic 1', NULL, NULL, NULL, NULL, NULL, 4),
(154149, NULL, 'G3DSA:1.10.730.20:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154150, NULL, 'G3DSA:2.60.120.260:FF:000561', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154151, NULL, 'G3DSA:3.80.10.10:FF:000420', NULL, NULL, 'protein NLRC5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(154152, NULL, 'G3DSA:2.60.40.60:FF:000822', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154153, NULL, 'G3DSA:2.70.70.10:FF:000011', NULL, NULL, 'Leukocyte cell-derived chemotaxin-2', NULL, NULL, NULL, NULL, NULL, 4),
(154154, NULL, 'G3DSA:3.40.50.2300:FF:000215', NULL, NULL, 'LacI family DNA-binding transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(154155, NULL, 'G3DSA:1.10.287.130:FF:000073', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(154156, NULL, 'G3DSA:3.40.50.10700:FF:000003', NULL, NULL, 'D-aminoacyl-tRNA deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(154157, NULL, 'G3DSA:2.130.10.10:FF:004995', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154158, NULL, 'G3DSA:3.40.50.1440:FF:000019', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(154159, NULL, 'G3DSA:1.20.120.790:FF:000010', NULL, NULL, 'Endoplasmin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(154160, NULL, 'G3DSA:3.40.50.11990:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154161, NULL, 'G3DSA:1.25.40.20:FF:001136', NULL, NULL, 'YALI0E32791p', NULL, NULL, NULL, NULL, NULL, 4),
(154162, NULL, 'G3DSA:1.10.340.30:FF:000010', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(154163, NULL, 'G3DSA:3.20.20.100:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154164, NULL, 'G3DSA:1.25.40.10:FF:003802', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154165, NULL, 'G3DSA:1.25.40.10:FF:004421', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154166, NULL, 'G3DSA:2.20.70.10:FF:000232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154167, NULL, 'G3DSA:3.30.240.40:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154168, NULL, 'G3DSA:3.40.50.300:FF:003287', NULL, NULL, 'U5 small nuclear ribonucleoprotein 200 kDa helicase', NULL, NULL, NULL, NULL, NULL, 4),
(154169, NULL, 'G3DSA:2.120.10.30:FF:000016', NULL, NULL, 'peptidyl-glycine alpha-amidating monooxygenase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(154170, NULL, 'G3DSA:3.40.50.980:FF:000051', NULL, NULL, 'N-(5-amino-5-carboxypentanoyl)-L-cysteinyl-D-valine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(154171, NULL, 'G3DSA:3.10.150.10:FF:000004', NULL, NULL, 'Beta sliding clamp', NULL, NULL, NULL, NULL, NULL, 4),
(154172, NULL, 'G3DSA:1.25.40.10:FF:002280', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(154173, NULL, 'G3DSA:2.70.50.40:FF:000007', NULL, NULL, 'Unc-119 homolog a (C. elegans)', NULL, NULL, NULL, NULL, NULL, 4),
(154174, NULL, 'G3DSA:2.170.270.10:FF:000069', NULL, NULL, 'protein msta', NULL, NULL, NULL, NULL, NULL, 4),
(154175, NULL, 'G3DSA:3.40.50.300:FF:006518', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154176, NULL, 'G3DSA:3.40.190.10:FF:000073', NULL, NULL, 'Spermidine/putrescine ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(154177, NULL, 'G3DSA:3.40.50.300:FF:004377', NULL, NULL, 'AGAP006740-PA', NULL, NULL, NULL, NULL, NULL, 4),
(154178, NULL, 'G3DSA:3.30.565.10:FF:000339', NULL, NULL, 'Two-component system sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(154179, NULL, 'G3DSA:3.20.110.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154180, NULL, 'G3DSA:3.40.50.1480:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154181, NULL, 'G3DSA:3.50.30.30:FF:000007', NULL, NULL, 'Signal peptide peptidase-like 3', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(154182, NULL, 'G3DSA:1.20.1050.20:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154183, NULL, 'G3DSA:3.30.40.10:FF:001301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154184, NULL, 'G3DSA:2.130.10.10:FF:002865', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', NULL, NULL, NULL, NULL, NULL, 4),
(154185, NULL, 'G3DSA:3.30.565.10:FF:000143', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(154186, NULL, 'G3DSA:1.10.1870.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154187, NULL, 'G3DSA:3.30.70.330:FF:002167', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154188, NULL, 'G3DSA:1.20.58.60:FF:000378', NULL, NULL, 'AGAP009554-PA', NULL, NULL, NULL, NULL, NULL, 4),
(154189, NULL, 'G3DSA:3.90.70.10:FF:000238', NULL, NULL, 'Putative calpain-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(154190, NULL, 'G3DSA:3.20.20.80:FF:000422', NULL, NULL, 'Alpha-L-arabinofuranosidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(154191, NULL, 'G3DSA:1.20.1070.10:FF:000805', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154192, NULL, 'G3DSA:1.25.40.10:FF:004786', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154193, NULL, 'G3DSA:2.10.25.10:FF:000898', NULL, NULL, 'Crumbs family member 1, photoreceptor morphogenesis associated', NULL, NULL, NULL, NULL, NULL, 4),
(154194, NULL, 'G3DSA:2.60.120.650:FF:000205', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154195, NULL, 'G3DSA:1.10.30.50:FF:000014', NULL, NULL, 'SNF2 domain-containing protein / helicase domain-containing protein / HNH endonuclease domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(154196, NULL, 'G3DSA:2.60.40.150:FF:000176', NULL, NULL, 'Synaptotagmin 8', NULL, NULL, NULL, NULL, NULL, 4),
(154197, NULL, 'G3DSA:3.40.50.300:FF:004012', NULL, NULL, 'ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(154198, NULL, 'G3DSA:3.30.710.10:FF:000436', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154199, NULL, 'G3DSA:2.60.40.60:FF:000277', NULL, NULL, 'DE-cadherin', NULL, NULL, NULL, NULL, NULL, 4),
(154200, NULL, 'G3DSA:1.25.10.10:FF:003177', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154201, NULL, 'G3DSA:1.10.274.30:FF:000018', NULL, NULL, 'Protein CBG13694', NULL, NULL, NULL, NULL, NULL, 4),
(154202, NULL, 'G3DSA:3.90.228.10:FF:000032', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(154203, NULL, 'G3DSA:3.10.430.100:FF:000009', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(154204, NULL, 'G3DSA:3.40.50.1820:FF:001246', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(154205, NULL, 'G3DSA:1.25.40.720:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154206, NULL, 'G3DSA:3.20.100.10:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154207, NULL, 'G3DSA:3.40.50.300:FF:007250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154208, NULL, 'G3DSA:2.60.40.3640:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154209, NULL, 'G3DSA:3.30.497.10:FF:000057', NULL, NULL, 'GM20478', NULL, NULL, NULL, NULL, NULL, 4),
(154210, NULL, 'G3DSA:1.10.510.10:FF:000596', NULL, NULL, 'CK1 family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(154211, NULL, 'G3DSA:3.40.50.150:FF:001437', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154212, NULL, 'G3DSA:2.30.29.30:FF:000979', NULL, NULL, 'Class VII unconventional myosin', NULL, NULL, NULL, NULL, NULL, 4),
(154213, NULL, 'G3DSA:3.90.640.10:FF:000125', NULL, NULL, 'Actin related protein 3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(154214, NULL, 'G3DSA:3.40.50.2300:FF:000070', NULL, NULL, 'Glutamate receptor, ionotropic, delta 1b', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(154215, NULL, 'G3DSA:3.30.70.330:FF:002953', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154216, NULL, 'G3DSA:3.10.50.10:FF:000044', NULL, NULL, 'AGAP011033-PA', NULL, NULL, NULL, NULL, NULL, 4),
(154217, NULL, 'G3DSA:1.10.10.60:FF:000600', NULL, NULL, 'Pyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(154218, NULL, 'G3DSA:3.50.50.60:FF:000219', NULL, NULL, 'Ubiquinone biosynthesis hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(154219, NULL, 'G3DSA:1.25.40.10:FF:004893', NULL, NULL, 'Pentatricopeptide repeat protein PPR868-14', NULL, NULL, NULL, NULL, NULL, 4),
(154220, NULL, 'G3DSA:3.40.50.150:FF:000347', NULL, NULL, 'Methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(154221, NULL, 'G3DSA:3.10.50.40:FF:000148', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(154222, NULL, 'G3DSA:3.10.10.10:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154223, NULL, 'G3DSA:2.130.10.10:FF:004523', NULL, NULL, 'Protein CBG19705', NULL, NULL, NULL, NULL, NULL, 4),
(154224, NULL, 'G3DSA:2.70.220.10:FF:000006', NULL, NULL, 'GM24104', NULL, NULL, NULL, NULL, NULL, 4),
(154225, NULL, 'G3DSA:3.40.850.10:FF:000332', NULL, NULL, 'Kifc1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(154226, NULL, 'G3DSA:2.60.40.10:FF:005158', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154227, NULL, 'G3DSA:3.30.160.60:FF:000717', NULL, NULL, 'MDS1 and EVI1 complex locus protein EVI1-A', NULL, NULL, NULL, NULL, NULL, 4),
(154228, NULL, 'G3DSA:3.30.40.10:FF:002285', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(154229, NULL, 'G3DSA:2.170.130.20:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154230, NULL, 'G3DSA:1.20.120.230:FF:000011', NULL, NULL, 'Catenin alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(154231, NULL, 'G3DSA:3.80.10.10:FF:001415', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154232, NULL, 'G3DSA:3.40.30.10:FF:000210', NULL, NULL, 'nucleoredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(154233, NULL, 'G3DSA:3.30.160.60:FF:003045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154234, NULL, 'G3DSA:3.50.50.60:FF:000130', NULL, NULL, '3-oxosteroid 1-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(154235, NULL, 'G3DSA:3.60.21.10:FF:000289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154236, NULL, 'G3DSA:1.10.287.70:FF:000633', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154237, NULL, 'G3DSA:3.30.60.190:FF:000003', NULL, NULL, 'HIT-type Zinc finger family protein', NULL, NULL, NULL, NULL, NULL, 4),
(154238, NULL, 'G3DSA:1.10.510.10:FF:004339', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154239, NULL, 'G3DSA:3.20.20.70:FF:000110', NULL, NULL, '1-(5-phosphoribosyl)-5-[(5-phosphoribosylamino)methylideneamino] imidazole-4-carboxamide isomerase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(154240, NULL, 'G3DSA:3.40.525.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154241, NULL, 'G3DSA:3.30.70.330:FF:001548', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154242, NULL, 'G3DSA:2.40.50.90:FF:000029', NULL, NULL, 'Probable endonuclease lcl3', NULL, NULL, NULL, NULL, NULL, 4),
(154243, NULL, 'G3DSA:1.25.40.660:FF:000002', NULL, NULL, 'Vacuolar protein sorting-associated protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(154244, NULL, 'G3DSA:3.30.450.20:FF:000402', NULL, NULL, 'Diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(154245, NULL, 'G3DSA:1.20.1070.10:FF:001424', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154246, NULL, 'G3DSA:2.130.10.10:FF:000139', NULL, NULL, 'WD repeat domain 36', NULL, NULL, NULL, NULL, NULL, 4),
(154247, NULL, 'G3DSA:1.10.4020.10:FF:000013', NULL, NULL, 'Zinc finger protein 444', NULL, NULL, NULL, NULL, NULL, 4),
(154248, NULL, 'G3DSA:2.60.260.20:FF:000042', NULL, NULL, 'Protein SIS1', NULL, NULL, NULL, NULL, NULL, 4),
(154249, NULL, 'G3DSA:4.10.60.10:FF:000008', NULL, NULL, 'Cleavage and polyadenylation specificity factor subunit 4', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(154250, NULL, 'G3DSA:1.20.58.390:FF:000262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154251, NULL, 'G3DSA:1.10.510.10:FF:000607', NULL, NULL, 'Cyclin-dependent-like kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(154252, NULL, 'G3DSA:3.10.450.580:FF:000016', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(154253, NULL, 'G3DSA:1.10.150.780:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154254, NULL, 'G3DSA:1.10.510.10:FF:001119', NULL, NULL, 'Aurora kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(154255, NULL, 'G3DSA:1.10.10.2360:FF:000005', NULL, NULL, 'Putative nuclear pore outer ring', NULL, NULL, NULL, NULL, NULL, 4),
(154256, NULL, 'G3DSA:2.30.29.240:FF:000003', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(154257, NULL, 'G3DSA:1.20.1250.20:FF:002144', NULL, NULL, 'Acetyl-coenzyme A transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(154258, NULL, 'G3DSA:2.60.40.10:FF:002741', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase beta', NULL, NULL, NULL, NULL, NULL, 4),
(154259, NULL, 'G3DSA:3.40.50.300:FF:006827', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154260, NULL, 'G3DSA:1.25.10.10:FF:001524', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(154261, NULL, 'G3DSA:1.10.287.70:FF:000105', NULL, NULL, 'Eye-enriched kainate receptor, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(154262, NULL, 'G3DSA:1.20.1070.10:FF:001969', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154263, NULL, 'G3DSA:1.20.58.60:FF:000743', NULL, NULL, 'Dystonin', NULL, NULL, NULL, NULL, NULL, 4),
(154264, NULL, 'G3DSA:3.40.1410.10:FF:000006', NULL, NULL, 'Transcriptional regulator, GntR family', NULL, NULL, NULL, NULL, NULL, 4),
(154265, NULL, 'G3DSA:1.20.1290.10:FF:000007', NULL, NULL, 'YJR111C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(154266, NULL, 'G3DSA:3.60.60.30:FF:000003', NULL, NULL, 'Phospholipase B-like', NULL, NULL, NULL, NULL, NULL, 4),
(154267, NULL, 'G3DSA:1.10.150.320:FF:000001', NULL, NULL, 'Competence protein ComEA helix-hairpin-helix repeat region', NULL, NULL, NULL, NULL, NULL, 4),
(154268, NULL, 'G3DSA:4.10.280.10:FF:000122', NULL, NULL, 'Retrograde regulation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(154269, NULL, 'G3DSA:2.60.40.150:FF:000428', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(154270, NULL, 'G3DSA:3.40.350.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154271, NULL, 'G3DSA:3.30.1020.10:FF:000001', NULL, NULL, '1-Cys peroxiredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(154272, NULL, 'G3DSA:3.30.470.10:FF:000029', NULL, NULL, '4-amino-4-deoxychorismate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(154273, NULL, 'G3DSA:1.25.40.10:FF:004078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154274, NULL, 'G3DSA:3.30.70.330:FF:000823', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(154275, NULL, 'G3DSA:3.40.30.10:FF:000682', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154276, NULL, 'G3DSA:3.80.10.10:FF:000111', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase ERECTA', NULL, NULL, NULL, NULL, NULL, 4),
(154277, NULL, 'G3DSA:3.40.50.300:FF:004720', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154278, NULL, 'G3DSA:3.30.160.60:FF:001122', NULL, NULL, 'Zinc finger protein 180', NULL, NULL, NULL, NULL, NULL, 4),
(154279, NULL, 'G3DSA:3.30.70.270:FF:000215', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154280, NULL, 'G3DSA:2.30.29.30:FF:000507', NULL, NULL, 'AGC protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(154281, NULL, 'G3DSA:1.10.8.10:FF:000051', NULL, NULL, 'ubiquitin-associated and SH3 domain-containing protein B', NULL, NULL, NULL, NULL, NULL, 4),
(154282, NULL, 'G3DSA:2.60.200.20:FF:000066', NULL, NULL, 'Kinesin protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(154283, NULL, 'G3DSA:3.30.420.40:FF:000529', NULL, NULL, 'Actin-like ATPase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(154284, NULL, 'G3DSA:1.10.575.10:FF:000015', NULL, NULL, 'S1/P1 Nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(154285, NULL, 'G3DSA:3.30.710.10:FF:000184', NULL, NULL, 'BTB/POZ domain and ankyrin repeat-containing protein NPR1', NULL, NULL, NULL, NULL, NULL, 4),
(154286, NULL, 'G3DSA:1.10.8.60:FF:000060', NULL, NULL, 'peroxisome biogenesis factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(154287, NULL, 'G3DSA:3.10.129.10:FF:000140', NULL, NULL, 'Putative thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(154288, NULL, 'G3DSA:3.40.50.1820:FF:000734', NULL, NULL, 'LIPaSe related', NULL, NULL, NULL, NULL, NULL, 4),
(154289, NULL, 'G3DSA:3.30.1490.180:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154290, NULL, 'G3DSA:1.10.10.60:FF:000128', NULL, NULL, 'Putative ZZ-type zinc finger-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(154291, NULL, 'G3DSA:3.30.1520.10:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154292, NULL, 'G3DSA:1.20.200.10:FF:000025', NULL, NULL, 'Argininosuccinate lyase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(154293, NULL, 'G3DSA:2.60.40.10:FF:003360', NULL, NULL, 'Plexin-2', NULL, NULL, NULL, NULL, NULL, 4),
(154294, NULL, 'G3DSA:2.170.150.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154295, NULL, 'G3DSA:2.30.30.140:FF:000161', NULL, NULL, 'Polycomblike, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(154296, NULL, 'G3DSA:1.25.10.10:FF:000687', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(154297, NULL, 'G3DSA:1.10.287.370:FF:000015', NULL, NULL, 'unconventional prefoldin RPB5 interactor 1', NULL, NULL, NULL, NULL, NULL, 4),
(154298, NULL, 'G3DSA:1.10.10.2010:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154299, NULL, 'G3DSA:3.40.50.300:FF:000870', NULL, NULL, 'MutS protein homolog 4', NULL, NULL, NULL, NULL, NULL, 4),
(154300, NULL, 'G3DSA:3.30.2130.10:FF:000009', NULL, NULL, 'Aspartate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(154301, NULL, 'G3DSA:2.60.40.1460:FF:000010', NULL, NULL, 'Integrin alpha pat-2', NULL, NULL, NULL, NULL, NULL, 4),
(154302, NULL, 'G3DSA:3.40.225.10:FF:000020', NULL, NULL, 'Methylthioribulose-1-phosphate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(154303, NULL, 'G3DSA:3.40.50.460:FF:000013', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(154304, NULL, 'G3DSA:3.40.50.300:FF:005232', NULL, NULL, 'Gluconokinase', NULL, NULL, NULL, NULL, NULL, 4),
(154305, NULL, 'G3DSA:2.130.10.10:FF:000471', NULL, NULL, 'Peptidylprolyl isomerase domain and WD repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(154306, NULL, 'G3DSA:3.30.500.10:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154307, NULL, 'G3DSA:2.40.10.10:FF:000413', NULL, NULL, 'Serine protease H164', NULL, NULL, NULL, NULL, NULL, 4),
(154308, NULL, 'G3DSA:3.30.710.10:FF:000060', NULL, NULL, 'Potassium voltage-gated channel modifier subfamily G member 3', NULL, NULL, NULL, NULL, NULL, 4),
(154309, NULL, 'G3DSA:1.25.40.10:FF:000840', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g12770', NULL, NULL, NULL, NULL, NULL, 4),
(154310, NULL, 'G3DSA:3.30.160.60:FF:005607', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154311, NULL, 'G3DSA:3.40.50.300:FF:005541', NULL, NULL, 'ADP-ribosylation factor-like protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(154312, NULL, 'G3DSA:1.10.287.70:FF:000094', NULL, NULL, 'Two pore calcium channel protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(154313, NULL, 'G3DSA:3.30.200.20:FF:001305', NULL, NULL, 'Dual specificity protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(154314, NULL, 'G3DSA:2.40.30.130:FF:000032', NULL, NULL, 'Alanyl-tRNA editing protein AlaX-M', NULL, NULL, NULL, NULL, NULL, 4),
(154315, NULL, 'G3DSA:1.20.120.350:FF:000120', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(154316, NULL, 'G3DSA:3.30.450.60:FF:000043', NULL, NULL, 'AP complex subunit sigma', NULL, NULL, NULL, NULL, NULL, 4),
(154317, NULL, 'G3DSA:3.30.710.10:FF:000217', NULL, NULL, 'Rho-related BTB domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(154318, NULL, 'G3DSA:2.60.40.420:FF:000077', NULL, NULL, 'SKU5 similar 17', NULL, NULL, NULL, NULL, NULL, 4),
(154319, NULL, 'G3DSA:2.60.40.60:FF:000058', NULL, NULL, 'FAT atypical cadherin 3', NULL, NULL, NULL, NULL, NULL, 4),
(154320, NULL, 'G3DSA:2.130.10.10:FF:005142', NULL, NULL, 'AGAP006535-PA', NULL, NULL, NULL, NULL, NULL, 4),
(154321, NULL, 'G3DSA:3.40.50.1240:FF:000083', NULL, NULL, 'Fructose-2,6-bisphosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(154322, NULL, 'G3DSA:3.80.10.10:FF:002820', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154323, NULL, 'G3DSA:4.10.280.10:FF:000100', NULL, NULL, 'Transcription factor BEE 3', NULL, NULL, NULL, NULL, NULL, 4),
(154324, NULL, 'G3DSA:3.80.10.10:FF:000999', NULL, NULL, 'Receptor-like protein kinase HSL1', NULL, NULL, NULL, NULL, NULL, 4),
(154325, NULL, 'G3DSA:3.40.1190.20:FF:000042', NULL, NULL, 'Probable thiamine biosynthetic bifunctional enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(154326, NULL, 'G3DSA:2.130.10.10:FF:004742', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154327, NULL, 'G3DSA:3.30.40.10:FF:001666', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(154328, NULL, 'G3DSA:3.10.100.10:FF:000288', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154329, NULL, 'G3DSA:3.30.160.60:FF:001336', NULL, NULL, 'Zinc finger protein 334', NULL, NULL, NULL, NULL, NULL, 4),
(154330, NULL, 'G3DSA:2.30.30.40:FF:000345', NULL, NULL, 'serine-rich adhesin for platelets isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(154331, NULL, 'G3DSA:2.10.25.10:FF:000589', NULL, NULL, 'Multiple epidermal growth factor-like domains 9', NULL, NULL, NULL, NULL, NULL, 4),
(154332, NULL, 'G3DSA:3.30.160.60:FF:003354', NULL, NULL, 'Zinc finger protein 555 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(154333, NULL, 'G3DSA:1.10.460.10:FF:000035', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(154334, NULL, 'G3DSA:3.60.60.10:FF:000008', NULL, NULL, 'Mutant tan', NULL, NULL, NULL, NULL, NULL, 4),
(154335, NULL, 'G3DSA:3.40.850.10:FF:000438', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154336, NULL, 'G3DSA:2.40.110.10:FF:000061', NULL, NULL, 'Butyryl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(154337, NULL, 'G3DSA:1.20.1560.10:FF:000551', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154338, NULL, 'G3DSA:2.20.160.10:FF:000001', NULL, NULL, 'Titin-cap (Telethonin)', NULL, NULL, NULL, NULL, NULL, 4),
(154339, NULL, 'G3DSA:1.10.10.2330:FF:000007', NULL, NULL, 'Phenylalanine-tRNA ligase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(154340, NULL, 'G3DSA:2.10.25.10:FF:001207', NULL, NULL, 'signal peptide, CUB and EGF-like domain-containing protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(154341, NULL, 'G3DSA:3.30.505.10:FF:000111', NULL, NULL, 'Suppressor of cytokine signaling, invertebrate', NULL, NULL, NULL, NULL, NULL, 4),
(154342, NULL, 'G3DSA:1.20.58.100:FF:000001', NULL, NULL, 'Succinate dehydrogenase flavoprotein subunit (SdhA)', NULL, NULL, NULL, NULL, NULL, 4),
(154343, NULL, 'G3DSA:3.30.40.10:FF:002066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154344, NULL, 'G3DSA:1.20.1070.10:FF:000244', NULL, NULL, 'galanin receptor type 3', NULL, NULL, NULL, NULL, NULL, 4),
(154345, NULL, 'G3DSA:1.10.8.10:FF:000303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154346, NULL, 'G3DSA:1.20.5.1700:FF:000007', NULL, NULL, 'Homer scaffold protein 3b', NULL, NULL, NULL, NULL, NULL, 4),
(154347, NULL, 'G3DSA:3.30.70.330:FF:000244', NULL, NULL, 'serine/arginine-rich splicing factor SR34A-like', NULL, NULL, NULL, NULL, NULL, 4),
(154348, NULL, 'G3DSA:3.40.50.1820:FF:000173', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(154349, NULL, 'G3DSA:2.120.10.80:FF:000334', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154350, NULL, 'G3DSA:3.30.470.20:FF:000021', NULL, NULL, 'Biotin carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(154351, NULL, 'G3DSA:1.10.510.10:FF:002541', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 17', NULL, NULL, NULL, NULL, NULL, 4),
(154352, NULL, 'G3DSA:2.40.290.30:FF:000006', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 25', NULL, NULL, NULL, NULL, NULL, 4),
(154353, NULL, 'G3DSA:3.30.160.20:FF:000155', NULL, NULL, 'Os04g0529500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(154354, NULL, 'G3DSA:3.30.70.330:FF:002931', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154355, NULL, 'G3DSA:3.40.190.10:FF:000382', NULL, NULL, 'Nitrate ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(154356, NULL, 'G3DSA:3.40.910.10:FF:000011', NULL, NULL, 'Deoxyhypusine synthase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(154357, NULL, 'G3DSA:2.80.10.50:FF:000058', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(154358, NULL, 'G3DSA:3.30.43.10:FF:000049', NULL, NULL, 'UDP-N-acetylenolpyruvoylglucosamine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(154359, NULL, 'G3DSA:1.25.40.180:FF:000044', NULL, NULL, 'Eukaryotic translation initiation factor 4G1, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(154360, NULL, 'G3DSA:2.20.25.10:FF:000049', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(154361, NULL, 'G3DSA:2.70.170.10:FF:000142', NULL, NULL, 'Transmembrane ion channel', NULL, NULL, NULL, NULL, NULL, 4),
(154362, NULL, 'G3DSA:2.60.40.10:FF:001252', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(154363, NULL, 'G3DSA:4.10.1240.10:FF:000004', NULL, NULL, 'Adhesion G protein-coupled receptor L3', NULL, NULL, NULL, NULL, NULL, 4),
(154364, NULL, 'G3DSA:1.10.510.10:FF:000287', NULL, NULL, 'probable LRR receptor-like serine/threonine-protein kinase RKF3', NULL, NULL, NULL, NULL, NULL, 4),
(154365, NULL, 'G3DSA:1.10.630.10:FF:000318', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154366, NULL, 'G3DSA:2.160.20.10:FF:000077', NULL, NULL, 'F-box protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(154367, NULL, 'G3DSA:3.60.110.10:FF:000103', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154368, NULL, 'G3DSA:1.10.150.220:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154369, NULL, 'G3DSA:1.10.10.10:FF:001451', NULL, NULL, 'ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(154370, NULL, 'G3DSA:2.120.10.30:FF:000235', NULL, NULL, 'Putative Nhl ring finger b-box coiled coil domain containing family member nhl-3', NULL, NULL, NULL, NULL, NULL, 4),
(154371, NULL, 'G3DSA:3.40.50.12780:FF:000031', NULL, NULL, 'Enterobactin synthase component E', NULL, NULL, NULL, NULL, NULL, 4),
(154372, NULL, 'G3DSA:2.40.10.10:FF:000519', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154373, NULL, 'G3DSA:2.40.50.140:FF:000781', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154374, NULL, 'G3DSA:2.40.160.50:FF:000008', NULL, NULL, 'Mitochondrial outer membrane beta-barrel protein Tob55', NULL, NULL, NULL, NULL, NULL, 4),
(154375, NULL, 'G3DSA:3.40.640.10:FF:000395', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154376, NULL, 'G3DSA:3.10.110.10:FF:000193', NULL, NULL, 'Ubiquitin-conjugating enzyme/RWD-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(154377, NULL, 'G3DSA:1.10.10.10:FF:000832', NULL, NULL, 'E2F-like (Mammalian transcription factor)', NULL, NULL, NULL, NULL, NULL, 4),
(154378, NULL, 'G3DSA:1.20.1250.20:FF:000199', NULL, NULL, 'Probable anion transporter 7', NULL, NULL, NULL, NULL, NULL, 4),
(154379, NULL, 'G3DSA:3.80.10.10:FF:003669', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154380, NULL, 'G3DSA:1.25.10.10:FF:003413', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(154381, NULL, 'G3DSA:6.10.140.2220:FF:000054', NULL, NULL, 'SD27884p', NULL, NULL, NULL, NULL, NULL, 4),
(154382, NULL, 'G3DSA:1.10.510.10:FF:001580', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154383, NULL, 'G3DSA:3.10.450.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154384, NULL, 'G3DSA:2.160.10.10:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154385, NULL, 'G3DSA:3.20.20.80:FF:000528', NULL, NULL, 'Glucan 13-beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(154386, NULL, 'G3DSA:3.80.10.10:FF:004130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154387, NULL, 'G3DSA:3.30.1330.30:FF:000002', NULL, NULL, 'NHP2-like protein 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(154388, NULL, 'G3DSA:3.30.70.3220:FF:000005', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(154389, NULL, 'G3DSA:2.130.10.10:FF:002741', NULL, NULL, 'notchless protein homolog 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(154390, NULL, 'G3DSA:3.30.230.10:FF:000181', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(154391, NULL, 'G3DSA:2.60.120.260:FF:000291', NULL, NULL, 'Os01g0531400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(154392, NULL, 'G3DSA:2.40.128.80:FF:000004', NULL, NULL, 'Dipeptidyl aminopeptidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(154393, NULL, 'G3DSA:3.40.1050.10:FF:000023', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(154394, NULL, 'G3DSA:3.10.490.10:FF:000018', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(154395, NULL, 'G3DSA:3.40.50.10810:FF:000036', NULL, NULL, 'Chromatin remodelling complex ATPase chain', NULL, NULL, NULL, NULL, NULL, 4),
(154396, NULL, 'G3DSA:2.40.50.180:FF:000017', NULL, NULL, 'Chemotaxis protein CheV', NULL, NULL, NULL, NULL, NULL, 4),
(154397, NULL, 'G3DSA:3.20.20.80:FF:000186', NULL, NULL, 'Alpha glucosidase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(154398, NULL, 'G3DSA:2.10.80.10:FF:000014', NULL, NULL, 'Dickkopf-1', NULL, NULL, NULL, NULL, NULL, 4),
(154399, NULL, 'G3DSA:3.30.420.10:FF:000425', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154400, NULL, 'G3DSA:3.40.50.720:FF:001041', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(154401, NULL, 'G3DSA:1.25.40.10:FF:002532', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g74600, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(154402, NULL, 'G3DSA:3.30.230.70:FF:000046', NULL, NULL, 'Exosome complex component MTR3', NULL, NULL, NULL, NULL, NULL, 4),
(154403, NULL, 'G3DSA:1.10.238.10:FF:001328', NULL, NULL, 'Calpain 10-like', NULL, NULL, NULL, NULL, NULL, 4),
(154404, NULL, 'G3DSA:3.40.50.2000:FF:000007', NULL, NULL, 'Trehalose-6-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(154405, NULL, 'G3DSA:2.60.40.10:FF:000487', NULL, NULL, 'ADAMTS-like 3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(154406, NULL, 'G3DSA:3.40.50.2300:FF:001143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154407, NULL, 'G3DSA:3.40.50.300:FF:006266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154408, NULL, 'G3DSA:2.60.40.10:FF:004562', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154409, NULL, 'G3DSA:3.90.1580.10:FF:000001', NULL, NULL, 'Sulfatase modifying factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(154410, NULL, 'G3DSA:2.40.50.140:FF:000106', NULL, NULL, 'DNA polymerase III subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(154411, NULL, 'G3DSA:1.10.3730.10:FF:000005', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(154412, NULL, 'G3DSA:2.60.120.10:FF:000675', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154413, NULL, 'G3DSA:3.70.10.10:FF:000067', NULL, NULL, 'YALI0F06204p', NULL, NULL, NULL, NULL, NULL, 4),
(154414, NULL, 'G3DSA:4.10.1060.50:FF:000002', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(154415, NULL, 'G3DSA:1.25.10.10:FF:003071', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154416, NULL, 'G3DSA:3.30.160.60:FF:006479', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154417, NULL, 'G3DSA:3.30.300.30:FF:000057', NULL, NULL, 'Nonribosomal siderophore peptide synthase SidC', NULL, NULL, NULL, NULL, NULL, 4),
(154418, NULL, 'G3DSA:1.10.1060.10:FF:000021', NULL, NULL, 'Glutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(154419, NULL, 'G3DSA:1.20.920.10:FF:000136', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154420, NULL, 'G3DSA:1.10.287.110:FF:000387', NULL, NULL, 'Chaperone protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(154421, NULL, 'G3DSA:3.40.50.1000:FF:000371', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154422, NULL, 'G3DSA:2.40.10.10:FF:000177', NULL, NULL, 'Serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(154423, NULL, 'G3DSA:2.60.40.10:FF:005866', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154424, NULL, 'G3DSA:1.25.10.10:FF:002795', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154425, NULL, 'G3DSA:1.10.150.20:FF:000285', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4),
(154426, NULL, 'G3DSA:1.20.1740.10:FF:000172', NULL, NULL, 'Amino acid transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(154427, NULL, 'G3DSA:2.30.42.10:FF:000381', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154428, NULL, 'G3DSA:2.60.40.60:FF:000586', NULL, NULL, 'Fat-like cadherin-related tumor suppressor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(154429, NULL, 'G3DSA:3.30.50.10:FF:000094', NULL, NULL, 'Os07g0246901 protein', NULL, NULL, NULL, NULL, NULL, 4),
(154430, NULL, 'G3DSA:2.60.40.10:FF:002432', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(154431, NULL, 'G3DSA:3.40.50.1580:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154432, NULL, 'G3DSA:3.80.10.10:FF:003293', NULL, NULL, 'Toll-like receptor 12', NULL, NULL, NULL, NULL, NULL, 4),
(154433, NULL, 'G3DSA:3.10.180.10:FF:000051', NULL, NULL, 'Putative enzyme related to lactoylglutathione lyase', NULL, NULL, NULL, NULL, NULL, 4),
(154434, NULL, 'G3DSA:3.30.70.330:FF:000458', NULL, NULL, 'U2 snRNP auxiliary factor large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(154435, NULL, 'G3DSA:1.25.40.10:FF:003241', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g46790, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(154436, NULL, 'G3DSA:4.10.1000.10:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154437, NULL, 'G3DSA:1.10.420.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154438, NULL, 'G3DSA:2.40.170.20:FF:000039', NULL, NULL, 'TonB-dependent siderophore receptor', NULL, NULL, NULL, NULL, NULL, 4),
(154439, NULL, 'G3DSA:1.10.472.10:FF:000607', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154440, NULL, 'G3DSA:3.30.200.20:FF:002233', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154441, NULL, 'G3DSA:2.60.120.620:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154442, NULL, 'G3DSA:3.30.70.870:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154443, NULL, 'G3DSA:3.50.50.60:FF:000585', NULL, NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', NULL, NULL, NULL, NULL, NULL, 4),
(154444, NULL, 'G3DSA:3.40.50.1700:FF:000030', NULL, NULL, 'Beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(154445, NULL, 'G3DSA:3.40.50.150:FF:000908', NULL, NULL, 'Modification methylase MjaII', NULL, NULL, NULL, NULL, NULL, 4),
(154446, NULL, 'G3DSA:3.20.20.80:FF:000219', NULL, NULL, 'Acidic mammalian chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(154447, NULL, 'G3DSA:1.25.40.70:FF:000015', NULL, NULL, 'Related to PIK1-phosphatidylinositol 4-kinase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(154448, NULL, 'G3DSA:3.30.450.20:FF:000166', NULL, NULL, 'CMGC/MAPK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(154449, NULL, 'G3DSA:3.40.850.10:FF:000062', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(154450, NULL, 'G3DSA:1.10.1420.10:FF:000083', NULL, NULL, 'DNA mismatch repair protein Msh4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(154451, NULL, 'G3DSA:1.10.10.2740:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154452, NULL, 'G3DSA:3.40.50.150:FF:001308', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154453, NULL, 'G3DSA:2.130.10.10:FF:002180', NULL, NULL, 'Small nucleolar ribonucleoprotein complex subunit, putative (AFU_orthologue AFUA_4G07540)', NULL, NULL, NULL, NULL, NULL, 4),
(154454, NULL, 'G3DSA:3.80.10.10:FF:002365', NULL, NULL, 'F-box and leucine-rich repeat protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(154455, NULL, 'G3DSA:2.40.50.110:FF:000002', NULL, NULL, 'Enterotoxin type A', NULL, NULL, NULL, NULL, NULL, 4),
(154456, NULL, 'G3DSA:2.70.98.90:FF:000003', NULL, NULL, 'Membrane protein insertase YidC', NULL, NULL, NULL, NULL, NULL, 4),
(154457, NULL, 'G3DSA:3.30.56.10:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154458, NULL, 'G3DSA:3.40.50.1010:FF:000008', NULL, NULL, 'Meiosis regulator and mRNA stability factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(154459, NULL, 'G3DSA:3.40.50.720:FF:002002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154460, NULL, 'G3DSA:1.20.190.40:FF:000004', NULL, NULL, 'Major DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(154461, NULL, 'G3DSA:2.30.30.100:FF:000065', NULL, NULL, 'Small nuclear ribonucleoprotein E', NULL, NULL, NULL, NULL, NULL, 4),
(154462, NULL, 'G3DSA:3.40.50.970:FF:000149', NULL, NULL, 'Pyruvate-flavodoxin oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(154463, NULL, 'G3DSA:3.10.490.20:FF:000010', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(154464, NULL, 'G3DSA:3.30.470.10:FF:000052', NULL, NULL, 'Branched chain amino acid transaminase 1', NULL, NULL, NULL, NULL, NULL, 4),
(154465, NULL, 'G3DSA:3.30.830.10:FF:000147', NULL, NULL, 'A-factor-processing enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(154466, NULL, 'G3DSA:1.10.510.10:FF:003013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154467, NULL, 'G3DSA:3.60.40.10:FF:000209', NULL, NULL, 'Protein phosphatase 2C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(154468, NULL, 'G3DSA:3.40.50.150:FF:001061', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154469, NULL, 'G3DSA:3.40.50.300:FF:001286', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(154470, NULL, 'G3DSA:1.20.58.80:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154471, NULL, 'G3DSA:1.25.10.10:FF:000198', NULL, NULL, 'GCN1, eIF2 alpha kinase activator homolog', NULL, NULL, NULL, NULL, NULL, 4),
(154472, NULL, 'G3DSA:3.40.50.2000:FF:000098', NULL, NULL, 'UDP-N-acetylglucosamine transferase subunit ALG14 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(154473, NULL, 'G3DSA:1.25.40.10:FF:002077', NULL, NULL, 'Putative adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(154474, NULL, 'G3DSA:2.60.220.50:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154475, NULL, 'G3DSA:2.60.40.10:FF:000829', NULL, NULL, 'Sialic acid-binding Ig-like lectin 8', NULL, NULL, NULL, NULL, NULL, 4),
(154476, NULL, 'G3DSA:3.40.50.300:FF:006721', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154477, NULL, 'G3DSA:2.60.40.290:FF:000004', NULL, NULL, 'Putative chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(154478, NULL, 'G3DSA:2.30.40.10:FF:000090', NULL, NULL, 'N-acyl-D-amino-acid deacylase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(154479, NULL, 'G3DSA:3.90.190.20:FF:000025', NULL, NULL, 'Folylpolyglutamate synthase/dihydrofolate synthase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(154480, NULL, 'G3DSA:3.30.70.890:FF:000058', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(154481, NULL, 'G3DSA:1.10.510.10:FF:003721', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154482, NULL, 'G3DSA:3.30.1490.20:FF:000050', NULL, NULL, 'Succinate--CoA ligase (ADP-forming)', NULL, NULL, NULL, NULL, NULL, 4),
(154483, NULL, 'G3DSA:3.30.1330.50:FF:000008', NULL, NULL, 'Bifunctional enzyme IspD/IspF', NULL, NULL, NULL, NULL, NULL, 4),
(154484, NULL, 'G3DSA:2.40.30.10:FF:000521', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(154485, NULL, 'G3DSA:3.30.160.60:FF:002050', NULL, NULL, 'zinc finger protein 527 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(154486, NULL, 'G3DSA:3.30.70.600:FF:000016', NULL, NULL, 'Probable 28S ribosomal protein S10, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(154487, NULL, 'G3DSA:1.25.50.10:FF:000009', NULL, NULL, 'Membrane alanine aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(154488, NULL, 'G3DSA:1.20.120.1900:FF:000064', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(154489, NULL, 'G3DSA:2.60.40.10:FF:004871', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154490, NULL, 'G3DSA:3.30.470.30:FF:000058', NULL, NULL, 'mRNA capping enzyme alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(154491, NULL, 'G3DSA:1.20.1560.10:FF:000096', NULL, NULL, 'ABC transporter related', NULL, NULL, NULL, NULL, NULL, 4),
(154492, NULL, 'G3DSA:1.10.472.10:FF:000389', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154493, NULL, 'G3DSA:2.40.30.30:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154494, NULL, 'G3DSA:2.30.30.490:FF:000024', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(154495, NULL, 'G3DSA:3.20.20.20:FF:000011', NULL, NULL, 'Dihydropteroate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(154496, NULL, 'G3DSA:1.20.5.2210:FF:000008', NULL, NULL, 'ATP synthase F(0) complex subunit B1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(154497, NULL, 'G3DSA:3.30.200.20:FF:002452', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154498, NULL, 'G3DSA:3.40.50.300:FF:005338', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(154499, NULL, 'G3DSA:2.30.29.30:FF:000294', NULL, NULL, 'WAS/WASL-interacting protein family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(154500, NULL, 'G3DSA:3.30.479.20:FF:000013', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(154501, NULL, 'G3DSA:2.60.40.10:FF:005490', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154502, NULL, 'G3DSA:1.20.1250.20:FF:001379', NULL, NULL, 'Uncharacterized MFS-type transporter C1399.02', NULL, NULL, NULL, NULL, NULL, 4),
(154503, NULL, 'G3DSA:2.40.100.10:FF:000088', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase CYP23', NULL, NULL, NULL, NULL, NULL, 4),
(154504, NULL, 'G3DSA:1.10.510.10:FF:003160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154505, NULL, 'G3DSA:2.130.10.10:FF:004287', NULL, NULL, 'TATA box-binding protein-associated factor RNA polymerase I subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(154506, NULL, 'G3DSA:2.60.40.420:FF:000280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154507, NULL, 'G3DSA:3.30.260.10:FF:000019', NULL, NULL, '60 kDa heat shock mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(154508, NULL, 'G3DSA:3.60.15.10:FF:000157', NULL, NULL, 'Ribonuclease Z 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(154509, NULL, 'G3DSA:1.25.10.10:FF:002143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154510, NULL, 'G3DSA:2.120.10.10:FF:000010', NULL, NULL, 'Sialidase B', NULL, NULL, NULL, NULL, NULL, 4),
(154511, NULL, 'G3DSA:1.10.287.2620:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154512, NULL, 'G3DSA:2.130.10.10:FF:001561', NULL, NULL, 'Small nucleolar ribonucleoprotein complex subunit (SOF1), putative', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(154513, NULL, 'G3DSA:2.60.40.10:FF:000976', NULL, NULL, 'V-set and immunoglobulin domain containing 8', NULL, NULL, NULL, NULL, NULL, 4),
(154514, NULL, 'G3DSA:3.30.420.40:FF:000333', NULL, NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(154515, NULL, 'G3DSA:1.10.20.10:FF:000097', NULL, NULL, 'Histone H2A', NULL, NULL, NULL, NULL, NULL, 4),
(154516, NULL, 'G3DSA:3.40.50.300:FF:000667', NULL, NULL, 'Dynein axonemal heavy chain 11', NULL, NULL, NULL, NULL, NULL, 4),
(154517, NULL, 'G3DSA:1.20.1110.10:FF:000068', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(154518, NULL, 'G3DSA:1.25.40.990:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154519, NULL, 'G3DSA:4.10.830.30:FF:000002', NULL, NULL, '50S ribosomal protein L31 type B', NULL, NULL, NULL, NULL, NULL, 4),
(154520, NULL, 'G3DSA:1.10.760.10:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154521, NULL, 'G3DSA:1.25.10.10:FF:002704', NULL, NULL, 'Microtubule-associated protein 215 long isoform', NULL, NULL, NULL, NULL, NULL, 4),
(154522, NULL, 'G3DSA:1.20.58.60:FF:000614', NULL, NULL, 'Spectrin repeat containing nuclear envelope protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(154523, NULL, 'G3DSA:1.25.10.10:FF:002452', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154524, NULL, 'G3DSA:1.10.10.2030:FF:000002', NULL, NULL, 'KIN17 protein', NULL, NULL, NULL, NULL, NULL, 4),
(154525, NULL, 'G3DSA:3.40.50.2000:FF:000659', NULL, NULL, 'Alpha-1,3/1,6-mannosyltransferase ALG2', NULL, NULL, NULL, NULL, NULL, 4),
(154526, NULL, 'G3DSA:2.60.40.10:FF:004539', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154527, NULL, 'G3DSA:3.40.50.720:FF:002221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154528, NULL, 'G3DSA:1.20.120.1080:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154529, NULL, 'G3DSA:3.30.40.10:FF:000121', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(154530, NULL, 'G3DSA:1.10.510.10:FF:002760', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154531, NULL, 'G3DSA:3.30.450.30:FF:000045', NULL, NULL, 'Profilin', NULL, NULL, NULL, NULL, NULL, 4),
(154532, NULL, 'G3DSA:1.20.1050.130:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154533, NULL, 'G3DSA:1.10.1200.10:FF:000100', NULL, NULL, 'Polyketide synthase type I', NULL, NULL, NULL, NULL, NULL, 4),
(154534, NULL, 'G3DSA:2.60.40.10:FF:001813', NULL, NULL, 'Protein tyrosine phosphatase, receptor type B', NULL, NULL, NULL, NULL, NULL, 4),
(154535, NULL, 'G3DSA:3.30.160.60:FF:002426', NULL, NULL, 'Unplaced genomic scaffold supercont1.20, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(154536, NULL, 'G3DSA:3.30.1360.40:FF:000052', NULL, NULL, 'Ribosome recycling factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(154537, NULL, 'G3DSA:3.30.450.20:FF:000508', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(154538, NULL, 'G3DSA:1.10.10.10:FF:000271', NULL, NULL, 'HTH-type transcriptional regulator yhjB', NULL, NULL, NULL, NULL, NULL, 4),
(154539, NULL, 'G3DSA:2.10.110.10:FF:000320', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154540, NULL, 'G3DSA:1.25.40.10:FF:003460', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g12100, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(154541, NULL, 'G3DSA:1.25.10.10:FF:001159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154542, NULL, 'G3DSA:3.60.10.10:FF:000152', NULL, NULL, 'DNase I-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(154543, NULL, 'G3DSA:1.25.40.10:FF:002521', NULL, NULL, 'Adenylate/guanylate cyclase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(154544, NULL, 'G3DSA:1.10.510.10:FF:001563', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(154545, NULL, 'G3DSA:1.10.472.10:FF:000529', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(154546, NULL, 'G3DSA:1.20.1070.10:FF:002014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154547, NULL, 'G3DSA:3.60.20.10:FF:000118', NULL, NULL, 'Proteasome endopeptidase complex', NULL, NULL, NULL, NULL, NULL, 4),
(154548, NULL, 'G3DSA:2.130.10.10:FF:003242', NULL, NULL, 'Wdr1p', NULL, NULL, NULL, NULL, NULL, 4),
(154549, NULL, 'G3DSA:3.40.50.300:FF:006277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154550, NULL, 'G3DSA:2.60.60.20:FF:000036', NULL, NULL, 'Lipase, endothelial', NULL, NULL, NULL, NULL, NULL, 4),
(154551, NULL, 'G3DSA:3.40.50.300:FF:003629', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154552, NULL, 'G3DSA:2.60.120.340:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154553, NULL, 'G3DSA:2.10.25.10:FF:000241', NULL, NULL, 'Fibulin-1', NULL, NULL, NULL, NULL, NULL, 4),
(154554, NULL, 'G3DSA:3.30.160.60:FF:006456', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154555, NULL, 'G3DSA:1.20.1120.10:FF:000001', NULL, NULL, 'Botulinum neurotoxin type A', NULL, NULL, NULL, NULL, NULL, 4),
(154556, NULL, 'G3DSA:3.40.50.300:FF:000875', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(154557, NULL, 'G3DSA:1.20.1560.10:FF:000427', NULL, NULL, 'p-GlycoProtein related', NULL, NULL, NULL, NULL, NULL, 4),
(154558, NULL, 'G3DSA:1.10.3080.10:FF:000039', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(154559, NULL, 'G3DSA:3.40.190.10:FF:000854', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154560, NULL, 'G3DSA:2.60.40.10:FF:002645', NULL, NULL, 'Interleukin 4 receptor, tandem duplicate 1', NULL, NULL, NULL, NULL, NULL, 4),
(154561, NULL, 'G3DSA:3.30.40.10:FF:000924', NULL, NULL, 'Putative RING zinc finger domain superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(154562, NULL, 'G3DSA:3.90.1180.10:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154563, NULL, 'G3DSA:3.30.479.30:FF:000027', NULL, NULL, 'Putative transmembrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(154564, NULL, 'G3DSA:1.10.287.4070:FF:000014', NULL, NULL, 'Os02g0730200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(154565, NULL, 'G3DSA:1.10.510.10:FF:000040', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(154566, NULL, 'G3DSA:1.20.20.10:FF:000012', NULL, NULL, 'ATP synthase subunit c', NULL, NULL, NULL, NULL, NULL, 4),
(154567, NULL, 'G3DSA:2.130.10.10:FF:000583', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(154568, NULL, 'G3DSA:1.10.10.10:FF:001232', NULL, NULL, 'ORC1-type DNA replication protein', NULL, NULL, NULL, NULL, NULL, 4),
(154569, NULL, 'G3DSA:1.20.140.150:FF:000053', NULL, NULL, 'EG:80H7.2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(154570, NULL, 'G3DSA:3.30.160.150:FF:000002', NULL, NULL, 'LPS-assembly lipoprotein LptE', NULL, NULL, NULL, NULL, NULL, 4),
(154571, NULL, 'G3DSA:2.60.40.60:FF:000480', NULL, NULL, 'Protocadherin-23', NULL, NULL, NULL, NULL, NULL, 4),
(154572, NULL, 'G3DSA:1.10.472.10:FF:000046', NULL, NULL, 'Transcription factor IIIB 50 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(154573, NULL, 'G3DSA:1.10.10.60:FF:000572', NULL, NULL, 'Fis family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(154574, NULL, 'G3DSA:3.40.50.10490:FF:000119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154575, NULL, 'G3DSA:3.30.70.580:FF:000061', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(154576, NULL, 'G3DSA:3.80.10.10:FF:000662', NULL, NULL, 'NACHT, LRR and PYD domains-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(154577, NULL, 'G3DSA:3.30.70.330:FF:002509', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154578, NULL, 'G3DSA:1.25.40.10:FF:000267', NULL, NULL, 'DAP3 binding cell death enhancer 1', NULL, NULL, NULL, NULL, NULL, 4),
(154579, NULL, 'G3DSA:3.40.50.150:FF:000583', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(154580, NULL, 'G3DSA:3.40.50.300:FF:008531', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154581, NULL, 'G3DSA:1.20.1730.10:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154582, NULL, 'G3DSA:1.20.870.10:FF:000036', NULL, NULL, 'Kinase non-catalytic C-lobe domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(154583, NULL, 'G3DSA:1.10.510.10:FF:003266', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154584, NULL, 'G3DSA:3.40.50.10330:FF:000004', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(154585, NULL, 'G3DSA:3.30.160.60:FF:001673', NULL, NULL, 'Zinc finger protein 536', NULL, NULL, NULL, NULL, NULL, 4),
(154586, NULL, 'G3DSA:4.10.60.10:FF:000019', NULL, NULL, 'Zinc finger CCHC domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(154587, NULL, 'G3DSA:3.30.710.10:FF:000200', NULL, NULL, 'YLR108C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(154588, NULL, 'G3DSA:3.40.390.10:FF:000043', NULL, NULL, 'Major allergen Asp F2', NULL, NULL, NULL, NULL, NULL, 4),
(154589, NULL, 'G3DSA:2.10.109.10:FF:000019', NULL, NULL, 'Mitochondrial inner membrane protease subunit', NULL, NULL, NULL, NULL, NULL, 4),
(154590, NULL, 'G3DSA:1.25.10.10:FF:001384', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154591, NULL, 'G3DSA:3.40.50.1820:FF:000504', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(154592, NULL, 'G3DSA:1.10.510.10:FF:000944', NULL, NULL, 'Testis-specific serine/threonine-protein kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(154593, NULL, 'G3DSA:3.30.160.60:FF:004427', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154594, NULL, 'G3DSA:1.20.1070.10:FF:000457', NULL, NULL, 'Somatostatin receptor type 4', NULL, NULL, NULL, NULL, NULL, 4),
(154595, NULL, 'G3DSA:3.30.300.320:FF:000002', NULL, NULL, 'N-acetylglucosamine-1-phosphotransferase subunits alpha/beta isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(154596, NULL, 'G3DSA:3.90.226.10:FF:000218', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(154597, NULL, 'G3DSA:1.10.287.3240:FF:000001', NULL, NULL, 'V-type proton ATPase subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(154598, NULL, 'G3DSA:2.60.40.10:FF:003590', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154599, NULL, 'G3DSA:3.40.1380.10:FF:000008', NULL, NULL, 'ATP synthase gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(154600, NULL, 'G3DSA:3.30.750.24:FF:000053', NULL, NULL, 'Anti-sigma F factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(154601, NULL, 'G3DSA:2.30.38.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154602, NULL, 'G3DSA:2.40.37.10:FF:000087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154603, NULL, 'G3DSA:3.30.1330.30:FF:000098', NULL, NULL, 'Ribosomal protein L7Ae', NULL, NULL, NULL, NULL, NULL, 4),
(154604, NULL, 'G3DSA:3.10.100.10:FF:000052', NULL, NULL, 'Lymphocyte antigen 75', NULL, NULL, NULL, NULL, NULL, 4),
(154605, NULL, 'G3DSA:2.30.39.10:FF:000013', NULL, NULL, 'Serpin family I member 2', NULL, NULL, NULL, NULL, NULL, 4),
(154606, NULL, 'G3DSA:3.80.10.10:FF:001067', NULL, NULL, 'Protein singed wings 2', NULL, NULL, NULL, NULL, NULL, 4),
(154607, NULL, 'G3DSA:3.40.50.720:FF:001737', NULL, NULL, 'D-aspartate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(154608, NULL, 'G3DSA:1.20.1270.10:FF:000085', NULL, NULL, 'Chaperone protein DnaK', NULL, NULL, NULL, NULL, NULL, 4),
(154609, NULL, 'G3DSA:2.130.10.10:FF:002286', NULL, NULL, 'Transducin', NULL, NULL, NULL, NULL, NULL, 4),
(154610, NULL, 'G3DSA:2.130.10.10:FF:001100', NULL, NULL, 'Blast:U4/U6 small nuclear ribonucleoprotein Prp4', NULL, NULL, NULL, NULL, NULL, 4),
(154611, NULL, 'G3DSA:1.10.287.110:FF:000415', NULL, NULL, 'DnaJ domain containing protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(154612, NULL, 'G3DSA:1.20.58.60:FF:000726', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154613, NULL, 'G3DSA:2.70.170.10:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(154614, NULL, 'G3DSA:2.30.29.30:FF:001362', NULL, NULL, 'Vps51/Vps67 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(154615, NULL, 'G3DSA:3.90.550.10:FF:000707', NULL, NULL, 'Dolichylphosphate beta-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(154616, NULL, 'G3DSA:1.10.10.10:FF:001327', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(154617, NULL, 'G3DSA:3.30.160.60:FF:000728', NULL, NULL, 'Zinc finger protein 521', NULL, NULL, NULL, NULL, NULL, 4),
(154618, NULL, 'G3DSA:3.30.450.70:FF:000012', NULL, NULL, 'Trafficking protein particle complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(154619, NULL, 'G3DSA:2.60.40.10:FF:001235', NULL, NULL, 'Interferon lambda receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(154620, NULL, 'G3DSA:3.30.200.20:FF:000558', NULL, NULL, 'Receptor-like cytosolic serine/threonine-protein kinase RBK1', NULL, NULL, NULL, NULL, NULL, 4),
(154621, NULL, 'G3DSA:3.40.50.300:FF:006974', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(154622, NULL, 'G3DSA:2.10.70.10:FF:000188', NULL, NULL, 'Modular serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(154623, NULL, 'G3DSA:3.30.559.10:FF:000073', NULL, NULL, 'Nonribosomal peptide synthase SidE', NULL, NULL, NULL, NULL, NULL, 4),
(154624, NULL, 'G3DSA:2.60.210.10:FF:000007', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(154625, NULL, 'G3DSA:3.40.1190.20:FF:000154', NULL, NULL, 'Fructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(154626, NULL, 'G3DSA:3.40.30.10:FF:000114', NULL, NULL, 'Prostaglandin E synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(154627, NULL, 'G3DSA:1.20.120.1710:FF:000001', NULL, NULL, 'NAD-dependent histone deacetylase SIR2', NULL, NULL, NULL, NULL, NULL, 4),
(154628, NULL, 'G3DSA:2.130.10.10:FF:000369', NULL, NULL, 'semaphorin-2A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(154629, NULL, 'G3DSA:2.130.10.10:FF:004765', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154630, NULL, 'G3DSA:2.40.128.330:FF:000012', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154631, NULL, 'G3DSA:1.10.287.370:FF:000010', NULL, NULL, 'Protein UXT like', NULL, NULL, NULL, NULL, NULL, 4),
(154632, NULL, 'G3DSA:3.30.230.10:FF:000057', NULL, NULL, 'DNA topoisomerase II large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(154633, NULL, 'G3DSA:1.10.730.10:FF:000146', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(154634, NULL, 'G3DSA:3.40.50.1470:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154635, NULL, 'G3DSA:3.30.40.10:FF:002274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154636, NULL, 'G3DSA:2.60.120.920:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154637, NULL, 'G3DSA:3.30.2350.20:FF:000006', NULL, NULL, 'Multisubstrate pseudouridine synthase 7', NULL, NULL, NULL, NULL, NULL, 4),
(154638, NULL, 'G3DSA:3.80.10.10:FF:001859', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(154639, NULL, 'G3DSA:3.30.70.330:FF:001312', NULL, NULL, 'RNA-binding protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(154640, NULL, 'G3DSA:2.60.40.650:FF:000011', NULL, NULL, 'Oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(154641, NULL, 'G3DSA:2.10.25.10:FF:001067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154642, NULL, 'G3DSA:3.30.2400.10:FF:000002', NULL, NULL, 'HK97 family phage major capsid protein', NULL, NULL, NULL, NULL, NULL, 4),
(154643, NULL, 'G3DSA:1.10.486.10:FF:000016', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(154644, NULL, 'G3DSA:3.30.40.10:FF:000020', NULL, NULL, 'lysine-specific demethylase 2B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(154645, NULL, 'G3DSA:2.60.40.2160:FF:000001', NULL, NULL, 'Interleukin 17 receptor A', NULL, NULL, NULL, NULL, NULL, 4),
(154646, NULL, 'G3DSA:3.90.190.20:FF:000048', NULL, NULL, 'Folylpolyglutamate synthase/dihydrofolate synthase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(154647, NULL, 'G3DSA:2.10.90.10:FF:000088', NULL, NULL, 'Inhibin beta B chain', NULL, NULL, NULL, NULL, NULL, 4),
(154648, NULL, 'G3DSA:3.40.630.10:FF:000079', NULL, NULL, 'Carboxypeptidase D', NULL, NULL, NULL, NULL, NULL, 4),
(154649, NULL, 'G3DSA:3.30.2310.30:FF:000001', NULL, NULL, 'S-type pyocin protein', NULL, NULL, NULL, NULL, NULL, 4),
(154650, NULL, 'G3DSA:3.40.50.300:FF:001831', NULL, NULL, 'DDX46 isoform 10', NULL, NULL, NULL, NULL, NULL, 4),
(154651, NULL, 'G3DSA:4.10.1060.10:FF:000030', NULL, NULL, 'HECT E3 ubiquitin ligase', NULL, NULL, NULL, NULL, NULL, 4),
(154652, NULL, 'G3DSA:3.80.10.10:FF:000448', NULL, NULL, 'Toll-like receptor 7', NULL, NULL, NULL, NULL, NULL, 4),
(154653, NULL, 'G3DSA:3.40.850.10:FF:000192', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(154654, NULL, 'G3DSA:3.30.160.60:FF:005046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154655, NULL, 'G3DSA:1.10.220.150:FF:000017', NULL, NULL, 'ARF GTPase activator (Csx2), putative', NULL, NULL, NULL, NULL, NULL, 4),
(154656, NULL, 'G3DSA:1.10.418.10:FF:000016', NULL, NULL, 'Probable fimbrin', NULL, NULL, NULL, NULL, NULL, 4),
(154657, NULL, 'G3DSA:1.10.510.10:FF:002861', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154658, NULL, 'G3DSA:3.40.50.300:FF:007233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154659, NULL, 'G3DSA:3.40.50.300:FF:006614', NULL, NULL, 'Muscle-specific beta 1 integrin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(154660, NULL, 'G3DSA:3.30.420.10:FF:000650', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154661, NULL, 'G3DSA:1.10.238.10:FF:000923', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(154662, NULL, 'G3DSA:1.10.1520.10:FF:000045', NULL, NULL, '39S ribosomal protein L44, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(154663, NULL, 'G3DSA:1.10.533.10:FF:000076', NULL, NULL, 'Interferon-inducible protein AIM2', NULL, NULL, NULL, NULL, NULL, 4),
(154664, NULL, 'G3DSA:3.40.30.10:FF:000906', NULL, NULL, 'Thioredoxin domain containing 15', NULL, NULL, NULL, NULL, NULL, 4),
(154665, NULL, 'G3DSA:3.30.160.60:FF:000375', NULL, NULL, 'Zinc finger and BTB domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(154666, NULL, 'G3DSA:3.30.40.10:FF:000132', NULL, NULL, 'G2/M phase-specific E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(154667, NULL, 'G3DSA:1.25.10.10:FF:003424', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154668, NULL, 'G3DSA:3.10.580.10:FF:000020', NULL, NULL, 'Glycine betaine/L-proline ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(154669, NULL, 'G3DSA:2.60.40.4060:FF:000003', NULL, NULL, 'Ferric chelate reductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(154670, NULL, 'G3DSA:1.10.533.10:FF:000188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154671, NULL, 'G3DSA:1.20.58.60:FF:000631', NULL, NULL, 'Spectrin repeat-containing, nuclear envelope 1b', NULL, NULL, NULL, NULL, NULL, 4),
(154672, NULL, 'G3DSA:3.20.20.100:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154673, NULL, 'G3DSA:2.160.10.10:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154674, NULL, 'G3DSA:1.20.120.790:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154675, NULL, 'G3DSA:3.10.20.90:FF:000526', NULL, NULL, 'Ubiquitin-like 7', NULL, NULL, NULL, NULL, NULL, 4),
(154676, NULL, 'G3DSA:1.25.10.10:FF:002805', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154677, NULL, 'G3DSA:3.40.50.80:FF:000193', NULL, NULL, 'Ferric reductase-like transmembrane component', NULL, NULL, NULL, NULL, NULL, 4),
(154678, NULL, 'G3DSA:3.30.40.10:FF:001329', NULL, NULL, 'AGAP000736-PA', NULL, NULL, NULL, NULL, NULL, 4),
(154679, NULL, 'G3DSA:3.30.450.20:FF:000267', NULL, NULL, 'Voltage-dependent calcium channel subunit alpha-2/delta-1', NULL, NULL, NULL, NULL, NULL, 4),
(154680, NULL, 'G3DSA:3.40.630.30:FF:000557', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(154681, NULL, 'G3DSA:1.10.238.10:FF:000699', NULL, NULL, 'EF-hand domain pair, putative', NULL, NULL, NULL, NULL, NULL, 4),
(154682, NULL, 'G3DSA:3.10.120.10:FF:000047', NULL, NULL, 'Hect domain and RLD 2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(154683, NULL, 'G3DSA:1.10.238.10:FF:000811', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154684, NULL, 'G3DSA:3.30.450.20:FF:000155', NULL, NULL, 'Sensor histidine kinase TodS', NULL, NULL, NULL, NULL, NULL, 4),
(154685, NULL, 'G3DSA:4.10.240.30:FF:000002', NULL, NULL, 'Tumor necrosis factor, alpha-induced protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(154686, NULL, 'G3DSA:1.20.1070.10:FF:001076', NULL, NULL, 'Histamine H2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(154687, NULL, 'G3DSA:2.130.10.10:FF:005703', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154688, NULL, 'G3DSA:3.40.50.1100:FF:000159', NULL, NULL, 'Cysteine synthase B protein', NULL, NULL, NULL, NULL, NULL, 4),
(154689, NULL, 'G3DSA:3.30.420.40:FF:000193', NULL, NULL, 'Actin-like protein ARP6', NULL, NULL, NULL, NULL, NULL, 4),
(154690, NULL, 'G3DSA:1.25.40.10:FF:002184', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g14470', NULL, NULL, NULL, NULL, NULL, 4),
(154691, NULL, 'G3DSA:3.30.710.10:FF:000088', NULL, NULL, 'zinc finger and BTB domain-containing protein 41', NULL, NULL, NULL, NULL, NULL, 4),
(154692, NULL, 'G3DSA:1.25.40.10:FF:003140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154693, NULL, 'G3DSA:2.60.40.10:FF:000279', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(154694, NULL, 'G3DSA:3.30.200.20:FF:001856', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154695, NULL, 'G3DSA:3.20.20.190:FF:000161', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154696, NULL, 'G3DSA:2.50.20.10:FF:000014', NULL, NULL, 'RNA polymerase subunit sigma', NULL, NULL, NULL, NULL, NULL, 4),
(154697, NULL, 'G3DSA:1.20.1050.10:FF:000102', NULL, NULL, 'Glutaredoxin/Glutathione_S-transferase_-_N-terminal_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(154698, NULL, 'G3DSA:3.30.56.10:FF:000022', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(154699, NULL, 'G3DSA:3.80.10.10:FF:003888', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154700, NULL, 'G3DSA:1.20.1440.130:FF:000010', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154701, NULL, 'G3DSA:1.25.40.20:FF:000967', NULL, NULL, 'YALI0A19778p', NULL, NULL, NULL, NULL, NULL, 4),
(154702, NULL, 'G3DSA:2.70.98.30:FF:000013', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(154703, NULL, 'G3DSA:2.10.25.10:FF:001634', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154704, NULL, 'G3DSA:3.40.30.10:FF:000895', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154705, NULL, 'G3DSA:3.40.50.150:FF:001325', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154706, NULL, 'G3DSA:2.60.40.10:FF:005630', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154707, NULL, 'G3DSA:3.40.50.2300:FF:000901', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154708, NULL, 'G3DSA:1.25.10.10:FF:000439', NULL, NULL, 'Exportin-4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(154709, NULL, 'G3DSA:3.40.50.300:FF:003208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154710, NULL, 'G3DSA:3.30.365.10:FF:000015', NULL, NULL, 'Xanthine dehydrogenase yagR molybdenum-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(154711, NULL, 'G3DSA:1.25.40.20:FF:001001', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154712, NULL, 'G3DSA:1.20.1440.80:FF:000006', NULL, NULL, 'gap junction epsilon-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(154713, NULL, 'G3DSA:1.10.510.10:FF:003480', NULL, NULL, 'Serine/threonine-protein kinase ppk1', NULL, NULL, NULL, NULL, NULL, 4),
(154714, NULL, 'G3DSA:3.10.129.10:FF:000016', NULL, NULL, 'Acyl-coenzyme A thioesterase 9, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(154715, NULL, 'G3DSA:1.20.120.330:FF:000018', NULL, NULL, 'Focal adhesion kinase, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(154716, NULL, 'G3DSA:2.170.270.10:FF:000209', NULL, NULL, 'SET and MYND domain-containing protein DDB_G0288495', NULL, NULL, NULL, NULL, NULL, 4),
(154717, NULL, 'G3DSA:3.50.30.30:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154718, NULL, 'G3DSA:1.10.8.270:FF:000133', NULL, NULL, 'Rab-GTPase-TBC domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(154719, NULL, 'G3DSA:2.130.10.10:FF:002409', NULL, NULL, 'Polyadenylation factor subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(154720, NULL, 'G3DSA:3.40.50.1580:FF:000044', NULL, NULL, 'Phosphorylase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(154721, NULL, 'G3DSA:2.30.29.30:FF:000743', NULL, NULL, 'Histone-arginine methyltransferase CARM1', NULL, NULL, NULL, NULL, NULL, 4),
(154722, NULL, 'G3DSA:3.30.70.330:FF:002723', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154723, NULL, 'G3DSA:1.10.510.10:FF:002991', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154724, NULL, 'G3DSA:2.60.40.60:FF:000833', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154725, NULL, 'G3DSA:2.40.10.10:FF:000278', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154726, NULL, 'G3DSA:1.10.150.390:FF:000005', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(154727, NULL, 'G3DSA:1.20.5.190:FF:000067', NULL, NULL, 'Dilute class unconventional myosin', NULL, NULL, NULL, NULL, NULL, 4),
(154728, NULL, 'G3DSA:3.40.50.1820:FF:001010', NULL, NULL, 'Serine hydrolase FSH', NULL, NULL, NULL, NULL, NULL, 4),
(154729, NULL, 'G3DSA:3.40.50.1000:FF:000590', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154730, NULL, 'G3DSA:1.25.40.470:FF:000035', NULL, NULL, 'WD repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(154731, NULL, 'G3DSA:3.50.50.60:FF:000580', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(154732, NULL, 'G3DSA:2.20.110.10:FF:000020', NULL, NULL, 'MORN repeat containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(154733, NULL, 'G3DSA:3.40.50.300:FF:004248', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(154734, NULL, 'G3DSA:3.40.50.300:FF:002011', NULL, NULL, 'Shikimate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(154735, NULL, 'G3DSA:1.25.40.10:FF:004550', NULL, NULL, 'Os02g0191200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(154736, NULL, 'G3DSA:1.20.1110.10:FF:000175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154737, NULL, 'G3DSA:1.20.150.20:FF:000001', NULL, NULL, 'ATP synthase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(154738, NULL, 'G3DSA:1.10.730.10:FF:000034', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(154739, NULL, 'G3DSA:3.40.640.10:FF:000378', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154740, NULL, 'G3DSA:3.20.20.70:FF:000430', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(154741, NULL, 'G3DSA:2.170.270.10:FF:000086', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(154742, NULL, 'G3DSA:2.10.25.10:FF:000353', NULL, NULL, 'Delta/notch like EGF repeat containing', NULL, NULL, NULL, NULL, NULL, 4),
(154743, NULL, 'G3DSA:2.60.200.20:FF:000055', NULL, NULL, 'Transcriptional regulator EmbR', NULL, NULL, NULL, NULL, NULL, 4),
(154744, NULL, 'G3DSA:3.20.20.300:FF:000048', NULL, NULL, 'Beta-glucosidase C', NULL, NULL, NULL, NULL, NULL, 4),
(154745, NULL, 'G3DSA:3.40.30.10:FF:000002', NULL, NULL, 'Alkyl hydroperoxide reductase C', NULL, NULL, NULL, NULL, NULL, 4),
(154746, NULL, 'G3DSA:1.10.3720.10:FF:000156', NULL, NULL, 'ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(154747, NULL, 'G3DSA:3.30.565.10:FF:000356', NULL, NULL, 'Histidine protein kinase SLN1', NULL, NULL, NULL, NULL, NULL, 4),
(154748, NULL, 'G3DSA:3.30.50.10:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(154749, NULL, 'G3DSA:2.20.100.10:FF:000222', NULL, NULL, 'SCO-spondin', NULL, NULL, NULL, NULL, NULL, 4),
(154750, NULL, 'G3DSA:3.40.50.1110:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154751, NULL, 'G3DSA:3.30.420.40:FF:000760', NULL, NULL, 'Hsp70 protein-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(154752, NULL, 'G3DSA:1.10.510.10:FF:001451', NULL, NULL, 'Serine/threonine protein kinase, STE20 family', NULL, NULL, NULL, NULL, NULL, 4),
(154753, NULL, 'G3DSA:1.10.1000.11:FF:000018', NULL, NULL, 'Sec7_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(154754, NULL, 'G3DSA:3.40.190.10:FF:000966', NULL, NULL, 'Oligopeptide-binding protein oppA', NULL, NULL, NULL, NULL, NULL, 4),
(154755, NULL, 'G3DSA:2.130.10.30:FF:000134', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154756, NULL, 'G3DSA:3.90.70.10:FF:000255', NULL, NULL, 'Toxin secretion ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(154757, NULL, 'G3DSA:2.60.40.10:FF:000728', NULL, NULL, 'Plexin D1', NULL, NULL, NULL, NULL, NULL, 4),
(154758, NULL, 'G3DSA:1.20.920.20:FF:000038', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(154759, NULL, 'G3DSA:3.40.50.2300:FF:001278', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154760, NULL, 'G3DSA:1.20.200.10:FF:000008', NULL, NULL, 'Adenylosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(154761, NULL, 'G3DSA:1.10.8.10:FF:000056', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(154762, NULL, 'G3DSA:3.60.15.10:FF:000134', NULL, NULL, 'Metallo-beta-lactamase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(154763, NULL, 'G3DSA:3.40.50.1010:FF:000233', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154764, NULL, 'G3DSA:3.40.50.1000:FF:000808', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154765, NULL, 'G3DSA:1.50.40.10:FF:000546', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154766, NULL, 'G3DSA:1.10.472.10:FF:000158', NULL, NULL, 'RNA polymerase II holoenzyme cyclin-like subunit', NULL, NULL, NULL, NULL, NULL, 4),
(154767, NULL, 'G3DSA:2.60.40.2140:FF:000006', NULL, NULL, 'GNBP A1', NULL, NULL, NULL, NULL, NULL, 4),
(154768, NULL, 'G3DSA:1.10.10.60:FF:000460', NULL, NULL, 'Homebox and aldo/keto reductase', NULL, NULL, NULL, NULL, NULL, 4),
(154769, NULL, 'G3DSA:3.40.390.10:FF:000173', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154770, NULL, 'G3DSA:2.60.40.1180:FF:000128', NULL, NULL, '1,4-alpha-glucan branching enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(154771, NULL, 'G3DSA:3.40.50.10490:FF:000007', NULL, NULL, '30S ribosomal protein S2', NULL, NULL, NULL, NULL, NULL, 4),
(154772, NULL, 'G3DSA:3.40.1190.20:FF:000171', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(154773, NULL, 'G3DSA:1.10.20.10:FF:000092', NULL, NULL, 'Protein MHF1-like isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(154774, NULL, 'G3DSA:1.25.40.10:FF:004533', NULL, NULL, 'Pre-mRNA-splicing factor CLF1', NULL, NULL, NULL, NULL, NULL, 4),
(154775, NULL, 'G3DSA:2.40.50.140:FF:000578', NULL, NULL, '26S protease regulatory subunit 6A', NULL, NULL, NULL, NULL, NULL, 4),
(154776, NULL, 'G3DSA:3.40.50.150:FF:000471', NULL, NULL, 'Methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(154777, NULL, 'G3DSA:2.30.30.210:FF:000002', NULL, NULL, 'Ribonuclease P protein subunit p29', NULL, NULL, NULL, NULL, NULL, 4),
(154778, NULL, 'G3DSA:1.25.40.10:FF:000155', NULL, NULL, 'General transcription factor 3C polypeptide 3', NULL, NULL, NULL, NULL, NULL, 4),
(154779, NULL, 'G3DSA:3.90.550.10:FF:000354', NULL, NULL, 'UDP-N-acetyl-alpha-D-galactosamine:polypeptide N-acetylgalactosaminyltransferase 14 (GalNAc-T14)', NULL, NULL, NULL, NULL, NULL, 4),
(154780, NULL, 'G3DSA:3.80.10.10:FF:000550', NULL, NULL, 'peroxidasin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(154781, NULL, 'G3DSA:3.40.50.300:FF:004265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154782, NULL, 'G3DSA:2.40.50.140:FF:001197', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(154783, NULL, 'G3DSA:2.20.70.10:FF:000108', NULL, NULL, 'growth arrest-specific protein 7 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(154784, NULL, 'G3DSA:1.10.287.610:FF:000003', NULL, NULL, 'DNA ligase B', NULL, NULL, NULL, NULL, NULL, 4),
(154785, NULL, 'G3DSA:3.80.10.10:FF:001960', NULL, NULL, 'Probable inactive receptor kinase At4g23740', NULL, NULL, NULL, NULL, NULL, 4),
(154786, NULL, 'G3DSA:1.10.10.60:FF:000358', NULL, NULL, 'Myb-related protein 305', NULL, NULL, NULL, NULL, NULL, 4),
(154787, NULL, 'G3DSA:3.30.200.20:FF:001968', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154788, NULL, 'G3DSA:2.130.10.10:FF:003697', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154789, NULL, 'G3DSA:3.40.225.10:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154790, NULL, 'G3DSA:1.25.40.10:FF:003252', NULL, NULL, 'Pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(154791, NULL, 'G3DSA:1.25.40.10:FF:002976', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154792, NULL, 'G3DSA:1.25.40.990:FF:000067', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154793, NULL, 'G3DSA:1.10.8.1220:FF:000023', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(154794, NULL, 'G3DSA:3.40.50.300:FF:005546', NULL, NULL, 'Senataxin', NULL, NULL, NULL, NULL, NULL, 4),
(154795, NULL, 'G3DSA:1.10.238.270:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154796, NULL, 'G3DSA:3.60.21.10:FF:000418', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(154797, NULL, 'G3DSA:3.40.50.720:FF:000327', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(154798, NULL, 'G3DSA:3.40.50.2300:FF:000429', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(154799, NULL, 'G3DSA:3.40.50.1820:FF:000942', NULL, NULL, 'Protein phosphatase methylesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(154800, NULL, 'G3DSA:3.40.250.10:FF:000112', NULL, NULL, 'Sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(154801, NULL, 'G3DSA:3.40.50.10810:FF:000266', NULL, NULL, 'Uncharacterized ATP-dependent helicase C17A2.12', NULL, NULL, NULL, NULL, NULL, 4),
(154802, NULL, 'G3DSA:2.60.410.10:FF:000006', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase DacA', NULL, NULL, NULL, NULL, NULL, 4),
(154803, NULL, 'G3DSA:2.60.40.1400:FF:000003', NULL, NULL, 'Potassium voltage-gated channel subfamily J member 16', NULL, NULL, NULL, NULL, NULL, 4),
(154804, NULL, 'G3DSA:3.30.70.330:FF:001767', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154805, NULL, 'G3DSA:1.25.40.790:FF:000013', NULL, NULL, 'Ccr4-Not transcription complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(154806, NULL, 'G3DSA:1.20.1250.10:FF:000117', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154807, NULL, 'G3DSA:3.30.710.10:FF:000425', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154808, NULL, 'G3DSA:2.30.29.30:FF:000631', NULL, NULL, 'PH-protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(154809, NULL, 'G3DSA:3.40.50.10470:FF:000001', NULL, NULL, 'Translation initiation factor eIF-2B subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(154810, NULL, 'G3DSA:3.90.550.20:FF:000020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154811, NULL, 'G3DSA:2.60.120.200:FF:000442', NULL, NULL, 'Putative L-type lectin-domain containing receptor kinase S.7', NULL, NULL, NULL, NULL, NULL, 4),
(154812, NULL, 'G3DSA:3.30.43.10:FF:000043', NULL, NULL, 'Carbon monoxide dehydrogenase, medium subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(154813, NULL, 'G3DSA:2.60.40.10:FF:001673', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(154814, NULL, 'G3DSA:3.40.1140.10:FF:000002', NULL, NULL, 'Chromosome partition protein MukB', NULL, NULL, NULL, NULL, NULL, 4),
(154815, NULL, 'G3DSA:3.30.160.60:FF:006344', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(154816, NULL, 'G3DSA:3.40.50.300:FF:008194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154817, NULL, 'G3DSA:3.40.50.920:FF:000044', NULL, NULL, '2-oxoacid:acceptor oxidoreductase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(154818, NULL, 'G3DSA:3.40.50.10860:FF:000039', NULL, NULL, 'Bifunctional protein FolD', NULL, NULL, NULL, NULL, NULL, 4),
(154819, NULL, 'G3DSA:1.10.3260.10:FF:000025', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(154820, NULL, 'G3DSA:3.30.40.10:FF:000357', NULL, NULL, 'Peroxisome biogenesis protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(154821, NULL, 'G3DSA:2.40.50.140:FF:000348', NULL, NULL, 'DNA replication helicase protein MCM', NULL, NULL, NULL, NULL, NULL, 4),
(154822, NULL, 'G3DSA:1.10.1040.10:FF:000014', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(154823, NULL, 'G3DSA:3.40.30.10:FF:000665', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(154824, NULL, 'G3DSA:2.60.120.10:FF:000568', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(154825, NULL, 'G3DSA:1.10.287.630:FF:000009', NULL, NULL, 'Tetrameric potassium-selective cyclic nucleotide gated channel', NULL, NULL, NULL, NULL, NULL, 4),
(154826, NULL, 'G3DSA:1.25.40.10:FF:000604', NULL, NULL, 'MAU2 sister chromatid cohesion factor', NULL, NULL, NULL, NULL, NULL, 4),
(154827, NULL, 'G3DSA:2.130.10.10:FF:000611', NULL, NULL, 'Dynein axonemal intermediate chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(154828, NULL, 'G3DSA:1.10.10.10:FF:000838', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(154829, NULL, 'G3DSA:2.130.10.10:FF:002848', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154830, NULL, 'G3DSA:2.40.30.10:FF:000280', NULL, NULL, 'Eukaryotic translation initiation factor 5B, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(154831, NULL, 'G3DSA:3.30.200.20:FF:002475', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154832, NULL, 'G3DSA:2.60.120.330:FF:000008', NULL, NULL, 'Jasmonate-regulated gene 21', NULL, NULL, NULL, NULL, NULL, 4),
(154833, NULL, 'G3DSA:2.70.98.30:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154834, NULL, 'G3DSA:3.40.50.1820:FF:000381', NULL, NULL, 'YJR107W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(154835, NULL, 'G3DSA:3.30.2130.10:FF:000026', NULL, NULL, 'ACT domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(154836, NULL, 'G3DSA:2.60.40.60:FF:001126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154837, NULL, 'G3DSA:3.40.50.300:FF:002803', NULL, NULL, 'Structural maintenance of chromosomes', NULL, NULL, NULL, NULL, NULL, 4),
(154838, NULL, 'G3DSA:3.30.40.10:FF:002386', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154839, NULL, 'G3DSA:2.30.29.220:FF:000003', NULL, NULL, 'FACT complex subunit POB3', NULL, NULL, NULL, NULL, NULL, 4),
(154840, NULL, 'G3DSA:3.30.450.90:FF:000018', NULL, NULL, 'Twitching motility pilus retraction protein', NULL, NULL, NULL, NULL, NULL, 4),
(154841, NULL, 'G3DSA:2.60.40.10:FF:003601', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154842, NULL, 'G3DSA:3.30.70.330:FF:001200', NULL, NULL, 'AGAP013051-PA', NULL, NULL, NULL, NULL, NULL, 4),
(154843, NULL, 'G3DSA:2.40.10.10:FF:000166', NULL, NULL, 'Trypsin', NULL, NULL, NULL, NULL, NULL, 4),
(154844, NULL, 'G3DSA:3.60.110.10:FF:000075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154845, NULL, 'G3DSA:2.60.40.10:FF:002196', NULL, NULL, 'Probable beta-D-xylosidase 6', NULL, NULL, NULL, NULL, NULL, 4),
(154846, NULL, 'G3DSA:2.10.25.10:FF:001179', NULL, NULL, 'Low-density lipoprotein receptor-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(154847, NULL, 'G3DSA:1.10.3130.10:FF:000004', NULL, NULL, 'Serine acetyltransferase 5', NULL, NULL, NULL, NULL, NULL, 4),
(154848, NULL, 'G3DSA:1.10.8.270:FF:000150', NULL, NULL, 'TBC domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(154849, NULL, 'G3DSA:1.10.1420.10:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154850, NULL, 'G3DSA:3.40.190.10:FF:000174', NULL, NULL, 'Peptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(154851, NULL, 'G3DSA:1.20.5.110:FF:000100', NULL, NULL, 'Pep12p', NULL, NULL, NULL, NULL, NULL, 4),
(154852, NULL, 'G3DSA:2.20.90.10:FF:000008', NULL, NULL, 'Vitellogenin 3, phosvitinless', NULL, NULL, NULL, NULL, NULL, 4),
(154853, NULL, 'G3DSA:2.60.120.650:FF:000228', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154854, NULL, 'G3DSA:2.30.42.10:FF:000257', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(154855, NULL, 'G3DSA:3.40.50.1000:FF:000247', NULL, NULL, 'HAD family phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(154856, NULL, 'G3DSA:3.30.830.10:FF:000035', NULL, NULL, 'Protease 3', NULL, NULL, NULL, NULL, NULL, 4),
(154857, NULL, 'G3DSA:1.20.120.330:FF:000035', NULL, NULL, 'Protein tyrosine kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(154858, NULL, 'G3DSA:1.20.1270.280:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154859, NULL, 'G3DSA:1.25.10.10:FF:001412', NULL, NULL, 'BRCA1 associated ATM activator 1', NULL, NULL, NULL, NULL, NULL, 4),
(154860, NULL, 'G3DSA:3.30.200.20:FF:001064', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 25 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(154861, NULL, 'G3DSA:3.90.70.30:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154862, NULL, 'G3DSA:3.40.250.10:FF:000016', NULL, NULL, 'Dual specificity phosphatase 16 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(154863, NULL, 'G3DSA:3.10.110.10:FF:000333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154864, NULL, 'G3DSA:2.130.10.30:FF:000038', NULL, NULL, 'RCC1 and BTB domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(154865, NULL, 'G3DSA:2.130.10.10:FF:002269', NULL, NULL, 'Putative WD-40 repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(154866, NULL, 'G3DSA:2.60.220.50:FF:000048', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154867, NULL, 'G3DSA:3.90.70.10:FF:000816', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154868, NULL, 'G3DSA:1.10.10.2330:FF:000002', NULL, NULL, 'Phenylalanyl-tRNA synthetase alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(154869, NULL, 'G3DSA:1.10.510.10:FF:001349', NULL, NULL, 'Serine/threonine protein kinase ULK3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(154870, NULL, 'G3DSA:1.25.10.10:FF:003312', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154871, NULL, 'G3DSA:1.10.1450.10:FF:000051', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(154872, NULL, 'G3DSA:3.40.50.300:FF:006726', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154873, NULL, 'G3DSA:3.30.160.60:FF:004787', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154874, NULL, 'G3DSA:2.160.20.10:FF:000285', NULL, NULL, 'Periplasmic copper-binding', NULL, NULL, NULL, NULL, NULL, 4),
(154875, NULL, 'G3DSA:2.60.40.150:FF:000423', NULL, NULL, 'Synaptotagmin 3', NULL, NULL, NULL, NULL, NULL, 4),
(154876, NULL, 'G3DSA:3.30.200.20:FF:000788', NULL, NULL, 'Ribosomal protein S6 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(154877, NULL, 'G3DSA:2.130.10.10:FF:002056', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(154878, NULL, 'G3DSA:3.40.50.720:FF:000344', NULL, NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(154879, NULL, 'G3DSA:3.40.367.20:FF:000032', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(154880, NULL, 'G3DSA:1.50.40.10:FF:000203', NULL, NULL, 'Solute carrier family 25 member 39', NULL, NULL, NULL, NULL, NULL, 4),
(154881, NULL, 'G3DSA:2.30.30.30:FF:000016', NULL, NULL, 'Transcription elongation factor SPT5', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(154882, NULL, 'G3DSA:1.10.630.10:FF:000779', NULL, NULL, 'Cytochrome P450 71D7', NULL, NULL, NULL, NULL, NULL, 4),
(154883, NULL, 'G3DSA:3.90.180.10:FF:000090', NULL, NULL, 'Possible dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(154884, NULL, 'G3DSA:3.90.226.10:FF:000348', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(154885, NULL, 'G3DSA:3.30.200.20:FF:000575', NULL, NULL, 'Protein KINase', NULL, NULL, NULL, NULL, NULL, 4),
(154886, NULL, 'G3DSA:3.40.50.12780:FF:000054', NULL, NULL, 'Bifunctional fatty acid transporter/acyl-CoA synthetase (FAT1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(154887, NULL, 'G3DSA:3.30.160.60:FF:002292', NULL, NULL, 'Zinc finger protein 816', NULL, NULL, NULL, NULL, NULL, 4),
(154888, NULL, 'G3DSA:2.170.300.10:FF:000067', NULL, NULL, 'Laminin subunit gamma-1', NULL, NULL, NULL, NULL, NULL, 4),
(154889, NULL, 'G3DSA:1.10.8.100:FF:000026', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(154890, NULL, 'G3DSA:3.40.50.10310:FF:000009', NULL, NULL, 'Creatinine amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(154891, NULL, 'G3DSA:1.20.1070.10:FF:001188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154892, NULL, 'G3DSA:1.25.40.10:FF:002072', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(154893, NULL, 'G3DSA:3.90.25.10:FF:000050', NULL, NULL, 'GDP-mannose 4,6 dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(154894, NULL, 'G3DSA:2.30.31.10:FF:000001', NULL, NULL, 'Activated RNA polymerase II transcriptional coactivator p15', NULL, NULL, NULL, NULL, NULL, 4),
(154895, NULL, 'G3DSA:3.90.190.10:FF:000612', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154896, NULL, 'G3DSA:2.20.100.10:FF:000205', NULL, NULL, 'Complement factor properdin', NULL, NULL, NULL, NULL, NULL, 4),
(154897, NULL, 'G3DSA:2.120.10.30:FF:000567', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154898, NULL, 'G3DSA:1.50.10.20:FF:000143', NULL, NULL, 'Squalene cyclase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(154899, NULL, 'G3DSA:1.10.510.10:FF:000832', NULL, NULL, 'Serine/threonine protein kinase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(154900, NULL, 'G3DSA:1.10.510.10:FF:003036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154901, NULL, 'G3DSA:1.20.1250.20:FF:000093', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(154902, NULL, 'G3DSA:3.30.70.330:FF:000795', NULL, NULL, 'RNA-binding protein CP33, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(154903, NULL, 'G3DSA:3.30.230.10:FF:000287', NULL, NULL, 'DNA gyrase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(154904, NULL, 'G3DSA:3.30.200.20:FF:000119', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(154905, NULL, 'G3DSA:1.10.238.10:FF:001216', NULL, NULL, 'EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(154906, NULL, 'G3DSA:3.40.50.300:FF:007671', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154907, NULL, 'G3DSA:3.80.10.10:FF:000095', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase GSO1', NULL, NULL, NULL, NULL, NULL, 4),
(154908, NULL, 'G3DSA:3.30.160.60:FF:003601', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154909, NULL, 'G3DSA:1.20.120.1750:FF:000114', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(154910, NULL, 'G3DSA:3.40.50.300:FF:001494', NULL, NULL, 'Pachytene checkpoint component Pch2', NULL, NULL, NULL, NULL, NULL, 4),
(154911, NULL, 'G3DSA:1.20.1310.20:FF:000030', NULL, NULL, 'Duffy binding-like merozoite surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(154912, NULL, 'G3DSA:3.40.800.20:FF:000028', NULL, NULL, 'Histone deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(154913, NULL, 'G3DSA:3.30.160.60:FF:005063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154914, NULL, 'G3DSA:3.40.50.410:FF:000127', NULL, NULL, '60 kDa SS-A/Ro ribonucleoprotein homolog', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(154915, NULL, 'G3DSA:3.40.50.620:FF:000409', NULL, NULL, 'Putative SanA protein', NULL, NULL, NULL, NULL, NULL, 4),
(154916, NULL, 'G3DSA:2.60.40.10:FF:002292', NULL, NULL, 'Twitchin', NULL, NULL, NULL, NULL, NULL, 4),
(154917, NULL, 'G3DSA:1.20.1070.10:FF:000671', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154918, NULL, 'G3DSA:2.60.40.10:FF:004450', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154919, NULL, 'G3DSA:3.40.50.150:FF:001297', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154920, NULL, 'G3DSA:1.10.238.10:FF:000570', NULL, NULL, 'Defective in cullin neddylation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(154921, NULL, 'G3DSA:1.20.5.520:FF:000003', NULL, NULL, 'Thymosin beta', NULL, NULL, NULL, NULL, NULL, 4),
(154922, NULL, 'G3DSA:3.90.660.10:FF:000002', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(154923, NULL, 'G3DSA:1.25.40.10:FF:001127', NULL, NULL, 'BnaUnng00170D protein', NULL, NULL, NULL, NULL, NULL, 4),
(154924, NULL, 'G3DSA:3.60.40.10:FF:000120', NULL, NULL, 'Protein phosphatase PPM5', NULL, NULL, NULL, NULL, NULL, 4),
(154925, NULL, 'G3DSA:3.40.50.2300:FF:000659', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(154926, NULL, 'G3DSA:2.40.50.1000:FF:000017', NULL, NULL, 'Os08g0207000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(154927, NULL, 'G3DSA:3.10.20.90:FF:000509', NULL, NULL, 'WGS project CABT00000000 data, contig 2.9', NULL, NULL, NULL, NULL, NULL, 4),
(154928, NULL, 'G3DSA:3.90.470.20:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154929, NULL, 'G3DSA:1.10.10.10:FF:000708', NULL, NULL, 'Transcription factor SFL2', NULL, NULL, NULL, NULL, NULL, 4),
(154930, NULL, 'G3DSA:1.25.40.10:FF:001223', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(154931, NULL, 'G3DSA:3.30.160.60:FF:000392', NULL, NULL, 'early growth response protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(154932, NULL, 'G3DSA:1.10.230.10:FF:000018', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(154933, NULL, 'G3DSA:1.10.1520.10:FF:000028', NULL, NULL, 'RNA editing complex protein MP90', NULL, NULL, NULL, NULL, NULL, 4),
(154934, NULL, 'G3DSA:3.90.550.10:FF:000584', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154935, NULL, 'G3DSA:3.40.630.10:FF:000321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154936, NULL, 'G3DSA:1.25.40.20:FF:000484', NULL, NULL, 'Ankyrin repeat-containing protein ITN1 isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(154937, NULL, 'G3DSA:3.20.70.20:FF:000036', NULL, NULL, 'Ribonucleoside-diphosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(154938, NULL, 'G3DSA:3.40.50.300:FF:006165', NULL, NULL, 'DExH-box ATP-dependent RNA helicase DExH18 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(154939, NULL, 'G3DSA:3.30.1240.20:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154940, NULL, 'G3DSA:3.30.110.10:FF:000008', NULL, NULL, 'Translation initiation factor IF3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(154941, NULL, 'G3DSA:2.60.40.60:FF:000378', NULL, NULL, 'Cadherin-87A', NULL, NULL, NULL, NULL, NULL, 4),
(154942, NULL, 'G3DSA:1.25.40.10:FF:000947', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(154943, NULL, 'G3DSA:1.25.40.10:FF:002633', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154944, NULL, 'G3DSA:3.30.530.20:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154945, NULL, 'G3DSA:1.10.150.20:FF:000301', NULL, NULL, 'DNA repair protein rev1', NULL, NULL, NULL, NULL, NULL, 4),
(154946, NULL, 'G3DSA:1.25.10.10:FF:000670', NULL, NULL, 'Vacuole-associated enzyme activator complex component (Vac14), putative', NULL, NULL, NULL, NULL, NULL, 4),
(154947, NULL, 'G3DSA:1.10.510.10:FF:003249', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154948, NULL, 'G3DSA:2.40.50.140:FF:000218', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(154949, NULL, 'G3DSA:1.10.238.10:FF:000474', NULL, NULL, 'Mitochondrial Rho GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(154950, NULL, 'G3DSA:3.40.50.10190:FF:000350', NULL, NULL, 'BRCT-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(154951, NULL, 'G3DSA:1.10.510.10:FF:001012', NULL, NULL, 'Protein kinase KNS1', NULL, NULL, NULL, NULL, NULL, 4),
(154952, NULL, 'G3DSA:3.30.160.60:FF:001914', NULL, NULL, 'Zinc finger protein 713', NULL, NULL, NULL, NULL, NULL, 4),
(154953, NULL, 'G3DSA:1.20.1420.10:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154954, NULL, 'G3DSA:2.30.30.140:FF:000054', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(154955, NULL, 'G3DSA:3.20.20.80:FF:000315', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(154956, NULL, 'G3DSA:2.60.40.790:FF:000148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154957, NULL, 'G3DSA:3.40.630.10:FF:000107', NULL, NULL, 'N-acetylated-alpha-linked acidic dipeptidase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(154958, NULL, 'G3DSA:3.30.50.10:FF:000077', NULL, NULL, 'White collar 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(154959, NULL, 'G3DSA:1.20.1560.10:FF:000091', NULL, NULL, 'ATP-dependent permease MDL2', NULL, NULL, NULL, NULL, NULL, 4),
(154960, NULL, 'G3DSA:3.30.70.20:FF:000075', NULL, NULL, 'Dissimilatory sulfite reductase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(154961, NULL, 'G3DSA:2.60.120.200:FF:000211', NULL, NULL, 'Adhesion G protein-coupled receptor D2', NULL, NULL, NULL, NULL, NULL, 4),
(154962, NULL, 'G3DSA:3.60.15.10:FF:000264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154963, NULL, 'G3DSA:3.80.10.10:FF:000903', NULL, NULL, 'F-box protein family-like', NULL, NULL, NULL, NULL, NULL, 4),
(154964, NULL, 'G3DSA:3.40.50.10810:FF:000053', NULL, NULL, 'SNF2 family helicase/ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(154965, NULL, 'G3DSA:1.25.40.10:FF:002763', NULL, NULL, 'Soluble NSF attachment protein, SNAP, putative', NULL, NULL, NULL, NULL, NULL, 4),
(154966, NULL, 'G3DSA:2.10.25.20:FF:000002', NULL, NULL, 'Outer capsid protein sigma-1', NULL, NULL, NULL, NULL, NULL, 4),
(154967, NULL, 'G3DSA:3.10.100.10:FF:000395', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154968, NULL, 'G3DSA:2.170.260.40:FF:000004', NULL, NULL, '5''-3'' exoribonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(154969, NULL, 'G3DSA:3.30.450.40:FF:000144', NULL, NULL, 'Phytochrome', NULL, NULL, NULL, NULL, NULL, 4),
(154970, NULL, 'G3DSA:3.30.9.10:FF:000296', NULL, NULL, 'D-aspartate oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(154971, NULL, 'G3DSA:3.10.20.90:FF:000498', NULL, NULL, 'Serine/threonine-protein kinase WNK8', NULL, NULL, NULL, NULL, NULL, 4),
(154972, NULL, 'G3DSA:3.40.50.300:FF:001735', NULL, NULL, 'Mov10 like RISC complex RNA helicase 1', NULL, NULL, NULL, NULL, NULL, 4),
(154973, NULL, 'G3DSA:3.90.1300.10:FF:000014', NULL, NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit A, chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(154974, NULL, 'G3DSA:3.50.50.60:FF:001063', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(154975, NULL, 'G3DSA:2.130.10.10:FF:000824', NULL, NULL, 'U4/U6 small nuclear ribonucleoprotein PRP4', NULL, NULL, NULL, NULL, NULL, 4),
(154976, NULL, 'G3DSA:1.20.1070.10:FF:001738', NULL, NULL, 'Si:dkey-181m19.11', NULL, NULL, NULL, NULL, NULL, 4),
(154977, NULL, 'G3DSA:1.10.287.110:FF:000174', NULL, NULL, 'DnaJ protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(154978, NULL, 'G3DSA:2.60.120.200:FF:000099', NULL, NULL, 'Contactin associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(154979, NULL, 'G3DSA:3.75.10.10:FF:000017', NULL, NULL, 'NGNG-dimethylarginine dimethylaminohydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(154980, NULL, 'G3DSA:2.70.50.30:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154981, NULL, 'G3DSA:3.40.50.720:FF:001288', NULL, NULL, 'Short chain alcohol dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(154982, NULL, 'G3DSA:3.30.465.10:FF:000079', NULL, NULL, 'Protein CBG02085', NULL, NULL, NULL, NULL, NULL, 4),
(154983, NULL, 'G3DSA:2.60.40.10:FF:003022', NULL, NULL, 'CD79A isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(154984, NULL, 'G3DSA:3.30.1310.10:FF:000006', NULL, NULL, 'Nucleoid-associated protein LEP1GSC116_0101', NULL, NULL, NULL, NULL, NULL, 4),
(154985, NULL, 'G3DSA:3.40.50.1820:FF:000049', NULL, NULL, 'probable glutamyl endopeptidase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(154986, NULL, 'G3DSA:3.30.160.60:FF:004995', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154987, NULL, 'G3DSA:2.60.40.1730:FF:000097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154988, NULL, 'G3DSA:3.40.390.10:FF:000285', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(154989, NULL, 'G3DSA:3.80.10.10:FF:003984', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154990, NULL, 'G3DSA:1.10.3660.10:FF:000005', NULL, NULL, 'Prephenate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(154991, NULL, 'G3DSA:3.90.79.10:FF:000095', NULL, NULL, 'NADH pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(154992, NULL, 'G3DSA:2.60.120.970:FF:000094', NULL, NULL, 'Maverick', NULL, NULL, NULL, NULL, NULL, 4),
(154993, NULL, 'G3DSA:3.40.50.800:FF:000019', NULL, NULL, 'Threonine--tRNA ligase mitochondrial 1', NULL, NULL, NULL, NULL, NULL, 4),
(154994, NULL, 'G3DSA:3.55.40.20:FF:000017', NULL, NULL, 'Superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(154995, NULL, 'G3DSA:1.10.510.10:FF:000282', NULL, NULL, 'LIM domain kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(154996, NULL, 'G3DSA:1.10.238.10:FF:001300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154997, NULL, 'G3DSA:1.10.420.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154998, NULL, 'G3DSA:1.10.238.10:FF:001188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(154999, NULL, 'G3DSA:1.20.1250.20:FF:002357', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155000, NULL, 'G3DSA:3.30.2310.20:FF:000015', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(155001, NULL, 'G3DSA:3.30.200.20:FF:000900', NULL, NULL, 'Os02g0136900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(155002, NULL, 'G3DSA:1.10.150.20:FF:000189', NULL, NULL, 'Dmc1b', NULL, NULL, NULL, NULL, NULL, 4),
(155003, NULL, 'G3DSA:3.30.200.40:FF:000002', NULL, NULL, 'm7GpppX diphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(155004, NULL, 'G3DSA:2.30.29.30:FF:000182', NULL, NULL, 'Rho GTPase activating protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(155005, NULL, 'G3DSA:2.60.120.10:FF:000017', NULL, NULL, 'cAMP-dependent protein kinase type II regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(155006, NULL, 'G3DSA:3.10.20.90:FF:001015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155007, NULL, 'G3DSA:1.10.510.10:FF:001804', NULL, NULL, 'Protein CBG04913', NULL, NULL, NULL, NULL, NULL, 4),
(155008, NULL, 'G3DSA:3.80.10.10:FF:004490', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(155009, NULL, 'G3DSA:3.60.21.10:FF:000194', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(155010, NULL, 'G3DSA:3.30.70.1660:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155011, NULL, 'G3DSA:1.20.1070.10:FF:000019', NULL, NULL, 'Lutropin-choriogonadotropic hormone receptor', NULL, NULL, NULL, NULL, NULL, 4),
(155012, NULL, 'G3DSA:3.90.660.10:FF:000132', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155013, NULL, 'G3DSA:3.40.50.300:FF:006957', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155014, NULL, 'G3DSA:1.20.1050.10:FF:000214', NULL, NULL, 'Glutathione s-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(155015, NULL, 'G3DSA:1.10.10.60:FF:001106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155016, NULL, 'G3DSA:2.40.70.10:FF:000158', NULL, NULL, 'OSJNba0093F12.2 protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(155017, NULL, 'G3DSA:2.10.110.10:FF:000219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155018, NULL, 'G3DSA:1.50.10.20:FF:000013', NULL, NULL, 'Transcobalamin-2', NULL, NULL, NULL, NULL, NULL, 4),
(155019, NULL, 'G3DSA:3.10.20.90:FF:000397', NULL, NULL, 'Splicing factor 3A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(155020, NULL, 'G3DSA:1.10.220.150:FF:000034', NULL, NULL, 'Sporulation protein SPS18', NULL, NULL, NULL, NULL, NULL, 4),
(155021, NULL, 'G3DSA:2.60.34.20:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155022, NULL, 'G3DSA:2.10.25.10:FF:001522', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155023, NULL, 'G3DSA:2.160.20.10:FF:000155', NULL, NULL, 'Os01g0172900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(155024, NULL, 'G3DSA:3.90.226.10:FF:000320', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(155025, NULL, 'G3DSA:3.30.70.330:FF:001863', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155026, NULL, 'G3DSA:2.130.10.10:FF:005720', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155027, NULL, 'G3DSA:3.40.50.300:FF:007463', NULL, NULL, 'Probable ATP-dependent RNA helicase ddx27', NULL, NULL, NULL, NULL, NULL, 4),
(155028, NULL, 'G3DSA:3.40.50.2000:FF:000238', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(155029, NULL, 'G3DSA:1.10.10.60:FF:000813', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155030, NULL, 'G3DSA:3.40.50.1010:FF:000025', NULL, NULL, 'DNA repair protein RAD2', NULL, NULL, NULL, NULL, NULL, 4),
(155031, NULL, 'G3DSA:2.60.120.590:FF:000058', NULL, NULL, 'Alpha-ketoglutarate-dependent dioxygenase abh1', NULL, NULL, NULL, NULL, NULL, 4),
(155032, NULL, 'G3DSA:1.25.40.20:FF:000141', NULL, NULL, 'E3 ubiquitin-protein ligase MIB1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(155033, NULL, 'G3DSA:2.170.150.20:FF:000024', NULL, NULL, 'Peptide-methionine (R)-S-oxide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(155034, NULL, 'G3DSA:3.30.40.10:FF:001088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155035, NULL, 'G3DSA:3.40.640.10:FF:000035', NULL, NULL, 'O-succinylhomoserine sulfhydrylase', NULL, NULL, NULL, NULL, NULL, 4),
(155036, NULL, 'G3DSA:1.10.287.70:FF:000419', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(155037, NULL, 'G3DSA:2.60.40.10:FF:004118', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155038, NULL, 'G3DSA:1.25.40.10:FF:001335', NULL, NULL, 'Os10g0558600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(155039, NULL, 'G3DSA:3.80.10.10:FF:000218', NULL, NULL, 'Probable E3 ubiquitin-protein ligase ipaH7.8', NULL, NULL, NULL, NULL, NULL, 4),
(155040, NULL, 'G3DSA:3.40.50.300:FF:005333', NULL, NULL, 'DEAD (Asp-Glu-Ala-Asp) box polypeptide 41', NULL, NULL, NULL, NULL, NULL, 4),
(155041, NULL, 'G3DSA:3.40.50.300:FF:002354', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NUBP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(155042, NULL, 'G3DSA:1.10.238.10:FF:000362', NULL, NULL, 'Centrin-4', NULL, NULL, NULL, NULL, NULL, 4),
(155043, NULL, 'G3DSA:1.10.510.10:FF:001220', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(155044, NULL, 'G3DSA:4.10.1000.10:FF:000037', NULL, NULL, 'Zinc finger CCCH domain-containing protein 39', NULL, NULL, NULL, NULL, NULL, 4),
(155045, NULL, 'G3DSA:1.25.10.10:FF:002564', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 5-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(155046, NULL, 'G3DSA:2.40.30.270:FF:000040', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(155047, NULL, 'G3DSA:3.30.70.2280:FF:000009', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(155048, NULL, 'G3DSA:1.10.1070.11:FF:000051', NULL, NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(155049, NULL, 'G3DSA:1.10.238.10:FF:000682', NULL, NULL, 'GM13096', NULL, NULL, NULL, NULL, NULL, 4),
(155050, NULL, 'G3DSA:1.10.760.10:FF:000103', NULL, NULL, 'Cytochrome c, somatic a', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(155051, NULL, 'G3DSA:3.30.420.10:FF:000212', NULL, NULL, 'Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(155052, NULL, 'G3DSA:3.20.20.100:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155053, NULL, 'G3DSA:3.90.640.10:FF:000018', NULL, NULL, 'Chromatin remodeling complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(155054, NULL, 'G3DSA:3.40.50.300:FF:001943', NULL, NULL, 'DEAD (Asp-Glu-Ala-Asp) box polypeptide 60', NULL, NULL, NULL, NULL, NULL, 4),
(155055, NULL, 'G3DSA:1.25.40.10:FF:001919', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At1g74400', NULL, NULL, NULL, NULL, NULL, 4),
(155056, NULL, 'G3DSA:1.10.620.20:FF:000034', NULL, NULL, 'Stearoyl-[acyl-carrier-protein] 9-desaturase 7 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(155057, NULL, 'G3DSA:1.10.3080.10:FF:000011', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(155058, NULL, 'G3DSA:2.40.50.140:FF:000786', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155059, NULL, 'G3DSA:2.40.50.690:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155060, NULL, 'G3DSA:1.10.600.10:FF:000030', NULL, NULL, 'Geranylgeranyl pyrophosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(155061, NULL, 'G3DSA:1.25.40.10:FF:003589', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(155062, NULL, 'G3DSA:1.25.10.10:FF:002935', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(155063, NULL, 'G3DSA:1.10.510.10:FF:000383', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 14', NULL, NULL, NULL, NULL, NULL, 4),
(155064, NULL, 'G3DSA:1.10.150.50:FF:000052', NULL, NULL, 'Kinesin family member 24', NULL, NULL, NULL, NULL, NULL, 4),
(155065, NULL, 'G3DSA:3.40.50.720:FF:002114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155066, NULL, 'G3DSA:3.30.420.40:FF:000316', NULL, NULL, 'Heat shock 70 kDa protein cognate', NULL, NULL, NULL, NULL, NULL, 4),
(155067, NULL, 'G3DSA:2.20.25.160:FF:000001', NULL, NULL, 'Aspartoacylase', NULL, NULL, NULL, NULL, NULL, 4),
(155068, NULL, 'G3DSA:3.30.160.60:FF:003258', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(155069, NULL, 'G3DSA:4.10.240.10:FF:000108', NULL, NULL, 'NosA protein', NULL, NULL, NULL, NULL, NULL, 4),
(155070, NULL, 'G3DSA:2.70.150.10:FF:000028', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(155071, NULL, 'G3DSA:1.20.58.60:FF:000165', NULL, NULL, 'nesprin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(155072, NULL, 'G3DSA:3.40.50.720:FF:001496', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155073, NULL, 'G3DSA:3.30.70.260:FF:000083', NULL, NULL, 'Acetolactate synthase small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(155074, NULL, 'G3DSA:2.40.30.10:FF:000049', NULL, NULL, '39S ribosomal protein L3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(155075, NULL, 'G3DSA:3.20.20.80:FF:000107', NULL, NULL, 'Alpha-N-acetylglucosaminidase family', NULL, NULL, NULL, NULL, NULL, 4),
(155076, NULL, 'G3DSA:2.60.40.10:FF:000959', NULL, NULL, 'Interleukin-12 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(155077, NULL, 'G3DSA:3.30.230.70:FF:000029', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(155078, NULL, 'G3DSA:1.10.640.10:FF:000044', NULL, NULL, 'Skpo-1', NULL, NULL, NULL, NULL, NULL, 4),
(155079, NULL, 'G3DSA:1.10.418.10:FF:000128', NULL, NULL, 'CRE-PAT-6 protein', NULL, NULL, NULL, NULL, NULL, 4),
(155080, NULL, 'G3DSA:3.40.47.10:FF:000097', NULL, NULL, 'Acetyl-CoA acetyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(155081, NULL, 'G3DSA:2.60.34.10:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155082, NULL, 'G3DSA:3.30.160.60:FF:005512', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155083, NULL, 'G3DSA:1.20.1070.10:FF:000912', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(155084, NULL, 'G3DSA:3.40.50.300:FF:003079', NULL, NULL, 'Small GTPase EhRabX5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(155085, NULL, 'G3DSA:3.10.110.10:FF:000221', NULL, NULL, 'Ubiquitin-conjugating enzyme E2E 2', NULL, NULL, NULL, NULL, NULL, 4),
(155086, NULL, 'G3DSA:1.20.5.1160:FF:000019', NULL, NULL, 'LamC, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(155087, NULL, 'G3DSA:3.80.10.10:FF:002348', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155088, NULL, 'G3DSA:3.40.50.880:FF:000116', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(155089, NULL, 'G3DSA:2.10.25.10:FF:000903', NULL, NULL, 'C-type LECtin', NULL, NULL, NULL, NULL, NULL, 4),
(155090, NULL, 'G3DSA:2.130.10.10:FF:001117', NULL, NULL, 'DDB1 and CUL4-associated factor 11', NULL, NULL, NULL, NULL, NULL, 4),
(155091, NULL, 'G3DSA:3.30.160.60:FF:003359', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(155092, NULL, 'G3DSA:1.20.920.20:FF:000021', NULL, NULL, 'Dynein heavy chain 5, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(155093, NULL, 'G3DSA:1.20.58.1100:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155094, NULL, 'G3DSA:1.10.132.30:FF:000015', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(155095, NULL, 'G3DSA:3.40.50.1820:FF:001459', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155096, NULL, 'G3DSA:3.90.190.10:FF:000163', NULL, NULL, 'Protein tyrosine phosphatase, receptor type D', NULL, NULL, NULL, NULL, NULL, 4),
(155097, NULL, 'G3DSA:3.90.550.10:FF:000146', NULL, NULL, 'Tout-velu, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(155098, NULL, 'G3DSA:3.40.50.10330:FF:000100', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(155099, NULL, 'G3DSA:1.25.40.20:FF:001456', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155100, NULL, 'G3DSA:3.40.50.720:FF:002238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155101, NULL, 'G3DSA:1.10.10.10:FF:000046', NULL, NULL, 'RNA polymerase sigma factor RpoS', NULL, NULL, NULL, NULL, NULL, 4),
(155102, NULL, 'G3DSA:2.20.25.10:FF:000021', NULL, NULL, 'Multifunctional methyltransferase subunit trm112', NULL, NULL, NULL, NULL, NULL, 4),
(155103, NULL, 'G3DSA:3.30.450.30:FF:000028', NULL, NULL, 'Profilin', NULL, NULL, NULL, NULL, NULL, 4),
(155104, NULL, 'G3DSA:3.30.460.10:FF:000107', NULL, NULL, 'Aminoglycoside 6-adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(155105, NULL, 'G3DSA:1.20.1070.10:FF:000227', NULL, NULL, 'Pyroglutamylated RFamide peptide receptor a', NULL, NULL, NULL, NULL, NULL, 4),
(155106, NULL, 'G3DSA:1.10.472.10:FF:000490', NULL, NULL, 'Cyclin-D2-1', NULL, NULL, NULL, NULL, NULL, 4),
(155107, NULL, 'G3DSA:3.40.50.300:FF:002562', NULL, NULL, 'ATP synthase subunit alpha, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(155108, NULL, 'G3DSA:3.30.160.60:FF:002533', NULL, NULL, 'Zinc finger protein 770', NULL, NULL, NULL, NULL, NULL, 4),
(155109, NULL, 'G3DSA:3.50.30.20:FF:000010', NULL, NULL, 'Carbamoyl-phosphate synthase small chain', NULL, NULL, NULL, NULL, NULL, 4),
(155110, NULL, 'G3DSA:1.10.8.270:FF:000037', NULL, NULL, 'TBC1 domain family member 22A', NULL, NULL, NULL, NULL, NULL, 4),
(155111, NULL, 'G3DSA:3.90.800.10:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155112, NULL, 'G3DSA:3.40.190.290:FF:000126', NULL, NULL, 'Arginine/lysine-responsive transcriptional regulator ArgP', NULL, NULL, NULL, NULL, NULL, 4),
(155113, NULL, 'G3DSA:2.90.10.10:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155114, NULL, 'G3DSA:2.30.30.30:FF:000128', NULL, NULL, 'Ribosomal protein L24', NULL, NULL, NULL, NULL, NULL, 4),
(155115, NULL, 'G3DSA:3.60.40.10:FF:000092', NULL, NULL, 'Protein phosphatase 2C', NULL, NULL, NULL, NULL, NULL, 4),
(155116, NULL, 'G3DSA:2.60.120.10:FF:000225', NULL, NULL, 'Transcriptional regulator Crp/Fnr family', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(155117, NULL, 'G3DSA:3.40.30.10:FF:001171', NULL, NULL, 'Glutathione S-transferase Mu 5', NULL, NULL, NULL, NULL, NULL, 4),
(155118, NULL, 'G3DSA:3.40.50.620:FF:000853', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155119, NULL, 'G3DSA:1.20.1270.60:FF:000201', NULL, NULL, 'growth arrest-specific protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(155120, NULL, 'G3DSA:3.80.10.10:FF:001179', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(155121, NULL, 'G3DSA:1.50.40.10:FF:000304', NULL, NULL, 'Mitochondrial carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(155122, NULL, 'G3DSA:3.30.870.10:FF:000032', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(155123, NULL, 'G3DSA:1.10.3210.10:FF:000073', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(155124, NULL, 'G3DSA:1.10.10.60:FF:000488', NULL, NULL, 'DnaJ-like protein subfamily C member 2', NULL, NULL, NULL, NULL, NULL, 4),
(155125, NULL, 'G3DSA:1.20.120.1900:FF:000069', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(155126, NULL, 'G3DSA:2.60.40.10:FF:002988', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(155127, NULL, 'G3DSA:3.30.470.20:FF:000038', NULL, NULL, 'Pyruvate, phosphate dikinase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(155128, NULL, 'G3DSA:3.40.250.10:FF:000224', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(155129, NULL, 'G3DSA:1.20.1310.10:FF:000156', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155130, NULL, 'G3DSA:3.90.1140.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155131, NULL, 'G3DSA:3.30.70.330:FF:001975', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155132, NULL, 'G3DSA:3.10.20.440:FF:000002', NULL, NULL, 'Sarcosine oxidase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(155133, NULL, 'G3DSA:1.20.1050.10:FF:000006', NULL, NULL, 'Elongation factor 1 gamma', NULL, NULL, NULL, NULL, NULL, 4),
(155134, NULL, 'G3DSA:3.30.70.330:FF:000227', NULL, NULL, 'mRNA binding post-transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(155135, NULL, 'G3DSA:3.90.70.10:FF:000463', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(155136, NULL, 'G3DSA:3.30.559.70:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155137, NULL, 'G3DSA:3.30.420.40:FF:000108', NULL, NULL, 'Glycerol kinase, glycosomal', NULL, NULL, NULL, NULL, NULL, 4),
(155138, NULL, 'G3DSA:1.20.1720.10:FF:000081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155139, NULL, 'G3DSA:3.40.50.300:FF:008082', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(155140, NULL, 'G3DSA:1.10.10.10:FF:001215', NULL, NULL, 'Two-component transcriptional regulator, winged helix family', NULL, NULL, NULL, NULL, NULL, 4),
(155141, NULL, 'G3DSA:2.130.10.10:FF:000499', NULL, NULL, 'PWP2, small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4),
(155142, NULL, 'G3DSA:3.30.160.60:FF:005967', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155143, NULL, 'G3DSA:2.70.98.10:FF:000035', NULL, NULL, 'Aldose 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(155144, NULL, 'G3DSA:1.25.40.10:FF:000716', NULL, NULL, 'Protein KINESIN LIGHT CHAIN-RELATED 2', NULL, NULL, NULL, NULL, NULL, 4),
(155145, NULL, 'G3DSA:1.20.1270.60:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155146, NULL, 'G3DSA:1.20.80.10:FF:000016', NULL, NULL, 'Krev interaction trapped protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(155147, NULL, 'G3DSA:3.80.10.10:FF:003860', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155148, NULL, 'G3DSA:3.30.40.10:FF:000469', NULL, NULL, 'Anaphase-promoting complex subunit 11', NULL, NULL, NULL, NULL, NULL, 4),
(155149, NULL, 'G3DSA:3.60.15.10:FF:000140', NULL, NULL, 'Ribonuclease J', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(155150, NULL, 'G3DSA:3.30.2160.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155151, NULL, 'G3DSA:3.30.200.20:FF:002345', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155152, NULL, 'G3DSA:3.40.50.2000:FF:000901', NULL, NULL, 'Gll0082 protein', NULL, NULL, NULL, NULL, NULL, 4),
(155153, NULL, 'G3DSA:3.30.1490.20:FF:000033', NULL, NULL, 'alpha-glucan water dikinase, chloroplastic isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(155154, NULL, 'G3DSA:2.30.30.40:FF:000249', NULL, NULL, 'Activated Cdc42 kinase-like', NULL, NULL, NULL, NULL, NULL, 4),
(155155, NULL, 'G3DSA:2.30.110.10:FF:000097', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(155156, NULL, 'G3DSA:3.30.160.60:FF:004770', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155157, NULL, 'G3DSA:3.60.20.10:FF:000006', NULL, NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', NULL, NULL, NULL, NULL, NULL, 4),
(155158, NULL, 'G3DSA:3.30.1640.10:FF:000093', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(155159, NULL, 'G3DSA:3.20.20.60:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155160, NULL, 'G3DSA:1.20.1070.10:FF:001637', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155161, NULL, 'G3DSA:3.40.50.850:FF:000012', NULL, NULL, 'Isochorismatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(155162, NULL, 'G3DSA:3.30.70.2800:FF:000003', NULL, NULL, 'Protein Diedel', NULL, NULL, NULL, NULL, NULL, 4),
(155163, NULL, 'G3DSA:1.20.1560.10:FF:000315', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(155164, NULL, 'G3DSA:2.60.40.10:FF:004669', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155165, NULL, 'G3DSA:3.90.199.10:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155166, NULL, 'G3DSA:2.60.40.10:FF:004899', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155167, NULL, 'G3DSA:3.40.850.10:FF:000202', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(155168, NULL, 'G3DSA:1.20.1250.20:FF:000446', NULL, NULL, 'Nodulin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(155169, NULL, 'G3DSA:3.30.230.130:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155170, NULL, 'G3DSA:3.30.470.30:FF:000030', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(155171, NULL, 'G3DSA:3.90.930.40:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155172, NULL, 'G3DSA:3.30.565.10:FF:000126', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(155173, NULL, 'G3DSA:1.25.10.10:FF:000226', NULL, NULL, 'GCN1, eIF2 alpha kinase activator homolog', NULL, NULL, NULL, NULL, NULL, 4),
(155174, NULL, 'G3DSA:3.40.50.1820:FF:001561', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155175, NULL, 'G3DSA:3.90.148.10:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155176, NULL, 'G3DSA:1.25.10.10:FF:002356', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155177, NULL, 'G3DSA:2.40.50.1020:FF:000012', NULL, NULL, 'Two-component response regulator NatK', NULL, NULL, NULL, NULL, NULL, 4),
(155178, NULL, 'G3DSA:3.30.830.10:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155179, NULL, 'G3DSA:1.20.1090.10:FF:000003', NULL, NULL, 'Probable hydroxyacid-oxoacid transhydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(155180, NULL, 'G3DSA:3.30.40.10:FF:000812', NULL, NULL, 'Bitesize, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(155181, NULL, 'G3DSA:3.60.21.10:FF:000317', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(155182, NULL, 'G3DSA:2.130.10.10:FF:004978', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155183, NULL, 'G3DSA:1.10.10.740:FF:000002', NULL, NULL, 'Cysteine-rich venom protein kaouthin-1', NULL, NULL, NULL, NULL, NULL, 4),
(155184, NULL, 'G3DSA:3.30.900.10:FF:000030', NULL, NULL, 'Mitotic spindle assembly checkpoint protein MAD2B', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(155185, NULL, 'G3DSA:2.60.40.2580:FF:000003', NULL, NULL, 'Minor fimbrium tip subunit MfA4', NULL, NULL, NULL, NULL, NULL, 4),
(155186, NULL, 'G3DSA:3.80.10.10:FF:003433', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155187, NULL, 'G3DSA:3.30.450.70:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155188, NULL, 'G3DSA:3.30.2130.30:FF:000015', NULL, NULL, 'RNA methylase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(155189, NULL, 'G3DSA:1.20.1250.20:FF:001840', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155190, NULL, 'G3DSA:3.30.70.980:FF:000068', NULL, NULL, 'AGL053Cp', NULL, NULL, NULL, NULL, NULL, 4),
(155191, NULL, 'G3DSA:3.50.50.60:FF:000006', NULL, NULL, 'Succinate dehydrogenase flavoprotein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(155192, NULL, 'G3DSA:1.25.40.10:FF:000498', NULL, NULL, 'lysine-specific demethylase 6A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(155193, NULL, 'G3DSA:1.10.840.10:FF:000025', NULL, NULL, 'uncharacterized protein LOC108092584 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(155194, NULL, 'G3DSA:3.30.70.890:FF:000030', NULL, NULL, 'glucuronokinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(155195, NULL, 'G3DSA:1.10.8.10:FF:000298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155196, NULL, 'G3DSA:2.130.10.10:FF:001325', NULL, NULL, 'Lethal(2) giant larvae protein homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(155197, NULL, 'G3DSA:1.25.40.20:FF:001113', NULL, NULL, 'E3 ubiquitin-protein ligase KEG', NULL, NULL, NULL, NULL, NULL, 4),
(155198, NULL, 'G3DSA:3.30.60.60:FF:000002', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(155199, NULL, 'G3DSA:2.60.40.1860:FF:000006', NULL, NULL, 'protein-arginine deiminase type-1', NULL, NULL, NULL, NULL, NULL, 4),
(155200, NULL, 'G3DSA:3.10.50.10:FF:000027', NULL, NULL, 'Protein CBG06565', NULL, NULL, NULL, NULL, NULL, 4),
(155201, NULL, 'G3DSA:1.25.40.10:FF:002392', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g09650, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(155202, NULL, 'G3DSA:3.30.450.50:FF:000023', NULL, NULL, 'Putative synaptobrevin-type transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(155203, NULL, 'G3DSA:2.60.40.10:FF:005175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155204, NULL, 'G3DSA:1.20.900.10:FF:000034', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(155205, NULL, 'G3DSA:3.40.50.2300:FF:000530', NULL, NULL, 'Autoinducer 2-binding periplasmic protein LuxP', NULL, NULL, NULL, NULL, NULL, 4),
(155206, NULL, 'G3DSA:3.40.50.1820:FF:001802', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155207, NULL, 'G3DSA:3.30.160.60:FF:003590', NULL, NULL, 'Zinc finger protein 248', NULL, NULL, NULL, NULL, NULL, 4),
(155208, NULL, 'G3DSA:3.40.50.300:FF:007025', NULL, NULL, 'RacS, RHO family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(155209, NULL, 'G3DSA:2.130.10.10:FF:003354', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(155210, NULL, 'G3DSA:2.30.29.30:FF:000390', NULL, NULL, 'AGC/PDK1 protein kinase, variant 1', NULL, NULL, NULL, NULL, NULL, 4),
(155211, NULL, 'G3DSA:1.10.510.10:FF:004093', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155212, NULL, 'G3DSA:3.40.47.10:FF:000181', NULL, NULL, 'Beta ketoacyl-acyl carrier protein synthase', NULL, NULL, NULL, NULL, NULL, 4),
(155213, NULL, 'G3DSA:3.30.160.60:FF:001561', NULL, NULL, 'Zinc finger and SCAN domain containing 30', NULL, NULL, NULL, NULL, NULL, 4),
(155214, NULL, 'G3DSA:1.10.472.130:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155215, NULL, 'G3DSA:2.60.40.10:FF:003146', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(155216, NULL, 'G3DSA:3.40.50.300:FF:006406', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155217, NULL, 'G3DSA:3.40.50.1820:FF:000280', NULL, NULL, 'Possible conserved membrane protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(155218, NULL, 'G3DSA:3.90.190.10:FF:000371', NULL, NULL, 'Protein-tyrosine-phosphatase PTP1', NULL, NULL, NULL, NULL, NULL, 4),
(155219, NULL, 'G3DSA:1.25.40.20:FF:000837', NULL, NULL, 'LOC100005699 protein', NULL, NULL, NULL, NULL, NULL, 4),
(155220, NULL, 'G3DSA:3.40.50.300:FF:002792', NULL, NULL, 'bifunctional heparan sulfate N-deacetylase/N-sulfotransferase 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(155221, NULL, 'G3DSA:1.10.287.70:FF:000650', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155222, NULL, 'G3DSA:3.80.10.10:FF:004052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155223, NULL, 'G3DSA:1.10.10.820:FF:000037', NULL, NULL, 'Myosin, heavy chain 9a, non-muscle', NULL, NULL, NULL, NULL, NULL, 4),
(155224, NULL, 'G3DSA:2.60.40.200:FF:000011', NULL, NULL, 'Superoxide dismutase [Cu-Zn]', NULL, NULL, NULL, NULL, NULL, 4),
(155225, NULL, 'G3DSA:1.25.10.10:FF:000327', NULL, NULL, 'Epoxyqueuosine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(155226, NULL, 'G3DSA:2.60.40.1110:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155227, NULL, 'G3DSA:3.40.850.10:FF:000545', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155228, NULL, 'G3DSA:1.20.58.670:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155229, NULL, 'G3DSA:3.30.160.60:FF:000841', NULL, NULL, 'zinc finger and BTB domain-containing protein 41', NULL, NULL, NULL, NULL, NULL, 4),
(155230, NULL, 'G3DSA:3.30.870.10:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155231, NULL, 'G3DSA:3.30.70.270:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155232, NULL, 'G3DSA:3.30.40.10:FF:001661', NULL, NULL, 'General Transcription Factor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(155233, NULL, 'G3DSA:2.60.120.380:FF:000012', NULL, NULL, 'Microbial collagenase', NULL, NULL, NULL, NULL, NULL, 4),
(155234, NULL, 'G3DSA:2.60.120.260:FF:000431', NULL, NULL, 'Glycoside hydrolase family 29', NULL, NULL, NULL, NULL, NULL, 4),
(155235, NULL, 'G3DSA:3.30.70.330:FF:000683', NULL, NULL, 'RNA binding protein rggm', NULL, NULL, NULL, NULL, NULL, 4),
(155236, NULL, 'G3DSA:3.40.50.300:FF:001382', NULL, NULL, 'Protein Ycf2', NULL, NULL, NULL, NULL, NULL, 4),
(155237, NULL, 'G3DSA:1.20.1270.10:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155238, NULL, 'G3DSA:3.80.10.10:FF:003776', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155239, NULL, 'G3DSA:3.30.200.20:FF:000007', NULL, NULL, 'Cyclin-dependent kinase 14, putative', NULL, NULL, NULL, NULL, NULL, 4),
(155240, NULL, 'G3DSA:1.10.3460.10:FF:000006', NULL, NULL, 'Chlorophyll a-b binding protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(155241, NULL, 'G3DSA:3.40.525.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155242, NULL, 'G3DSA:3.30.1240.10:FF:000012', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(155243, NULL, 'G3DSA:1.10.238.210:FF:000003', NULL, NULL, 'GLutamiNAse', NULL, NULL, NULL, NULL, NULL, 4),
(155244, NULL, 'G3DSA:1.25.40.10:FF:001015', NULL, NULL, 'Cartilage associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(155245, NULL, 'G3DSA:2.40.128.620:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155246, NULL, 'G3DSA:3.30.160.60:FF:004871', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155247, NULL, 'G3DSA:3.30.160.20:FF:000048', NULL, NULL, 'Double-stranded RNA-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(155248, NULL, 'G3DSA:3.40.140.20:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155249, NULL, 'G3DSA:3.30.60.20:FF:000136', NULL, NULL, 'Heavy chain, Unconventional Myosin', NULL, NULL, NULL, NULL, NULL, 4),
(155250, NULL, 'G3DSA:2.10.25.10:FF:000802', NULL, NULL, 'Adhesion G protein-coupled receptor E5b, duplicate 3', NULL, NULL, NULL, NULL, NULL, 4),
(155251, NULL, 'G3DSA:3.40.1280.10:FF:000063', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(155252, NULL, 'G3DSA:1.10.1740.10:FF:000039', NULL, NULL, 'Response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(155253, NULL, 'G3DSA:2.30.140.10:FF:000031', NULL, NULL, 'Polyamine aminopropyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(155254, NULL, 'G3DSA:1.10.510.10:FF:004334', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155255, NULL, 'G3DSA:3.30.160.60:FF:002741', NULL, NULL, 'Zinc finger protein 786', NULL, NULL, NULL, NULL, NULL, 4),
(155256, NULL, 'G3DSA:2.40.50.120:FF:000022', NULL, NULL, 'Netrin-B', NULL, NULL, NULL, NULL, NULL, 4),
(155257, NULL, 'G3DSA:3.40.50.620:FF:000752', NULL, NULL, 'Cytidylyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(155258, NULL, 'G3DSA:3.30.40.10:FF:001981', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155259, NULL, 'G3DSA:1.25.40.20:FF:000596', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155260, NULL, 'G3DSA:3.30.420.40:FF:000889', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(155261, NULL, 'G3DSA:3.40.50.300:FF:005788', NULL, NULL, 'Vesicular fusion ATPase, putative (AFU_orthologue AFUA_3G12510)', NULL, NULL, NULL, NULL, NULL, 4),
(155262, NULL, 'G3DSA:2.130.10.10:FF:005254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155263, NULL, 'G3DSA:1.25.40.10:FF:003010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155264, NULL, 'G3DSA:1.10.238.230:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155265, NULL, 'G3DSA:1.25.10.10:FF:002699', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155266, NULL, 'G3DSA:2.80.10.50:FF:000030', NULL, NULL, 'Fascin', NULL, NULL, NULL, NULL, NULL, 4),
(155267, NULL, 'G3DSA:3.40.50.300:FF:002915', NULL, NULL, 'Unplaced genomic scaffold supercont2.6, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(155268, NULL, 'G3DSA:2.60.34.30:FF:000001', NULL, NULL, 'Competence protein j', NULL, NULL, NULL, NULL, NULL, 4),
(155269, NULL, 'G3DSA:3.30.1520.10:FF:000163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155270, NULL, 'G3DSA:2.20.100.10:FF:000194', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(155271, NULL, 'G3DSA:3.40.309.10:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155272, NULL, 'G3DSA:2.130.10.10:FF:004074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155273, NULL, 'G3DSA:1.20.5.370:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155274, NULL, 'G3DSA:1.10.1040.10:FF:000126', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(155275, NULL, 'G3DSA:3.20.10.10:FF:000041', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(155276, NULL, 'G3DSA:1.20.5.4770:FF:000006', NULL, NULL, 'Zinc finger A20 and AN1 domain-containing stress-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(155277, NULL, 'G3DSA:3.50.50.60:FF:000349', NULL, NULL, '2-heptyl-3-hydroxy-4(1H)-quinolone synthase', NULL, NULL, NULL, NULL, NULL, 4),
(155278, NULL, 'G3DSA:3.30.70.1230:FF:000167', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(155279, NULL, 'G3DSA:2.70.98.20:FF:000027', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(155280, NULL, 'G3DSA:3.40.50.2300:FF:000075', NULL, NULL, 'L-arabinose-binding periplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(155281, NULL, 'G3DSA:2.60.40.10:FF:002084', NULL, NULL, 'Glucanase', NULL, NULL, NULL, NULL, NULL, 4),
(155282, NULL, 'G3DSA:1.25.40.10:FF:004449', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155283, NULL, 'G3DSA:1.20.120.910:FF:000001', NULL, NULL, 'RNA polymerase-binding transcription factor DksA', NULL, NULL, NULL, NULL, NULL, 4),
(155284, NULL, 'G3DSA:1.25.40.10:FF:000054', NULL, NULL, 'Pre-mRNA processing factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(155285, NULL, 'G3DSA:2.40.30.180:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(155286, NULL, 'G3DSA:1.20.120.220:FF:000002', NULL, NULL, 'ATP synthase subunit a', NULL, NULL, NULL, NULL, NULL, 4),
(155287, NULL, 'G3DSA:3.40.50.1000:FF:000146', NULL, NULL, 'Phosphoserine phosphatase SerB', NULL, NULL, NULL, NULL, NULL, 4),
(155288, NULL, 'G3DSA:3.80.10.10:FF:001729', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(155289, NULL, 'G3DSA:2.130.10.10:FF:003011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155290, NULL, 'G3DSA:1.20.1530.20:FF:000024', NULL, NULL, 'YMR034C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(155291, NULL, 'G3DSA:3.40.50.2000:FF:000322', NULL, NULL, 'UDP glucuronosyltransferase family 2 member B4', NULL, NULL, NULL, NULL, NULL, 4),
(155292, NULL, 'G3DSA:3.30.540.10:FF:000029', NULL, NULL, '3''-phosphoadenosine 5''-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(155293, NULL, 'G3DSA:1.10.287.1490:FF:000083', NULL, NULL, 'Maltose/maltodextrin ABC transporter, permease protein MalG', NULL, NULL, NULL, NULL, NULL, 4),
(155294, NULL, 'G3DSA:3.30.565.10:FF:000564', NULL, NULL, 'Sensor histidine kinase/response regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(155295, NULL, 'G3DSA:1.20.1250.20:FF:000103', NULL, NULL, 'monosaccharide-sensing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(155296, NULL, 'G3DSA:3.50.50.60:FF:001198', NULL, NULL, 'Putative flavin-containing monooxygenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(155297, NULL, 'G3DSA:3.40.50.2300:FF:000210', NULL, NULL, 'Vomeronasal 2, receptor 79', NULL, NULL, NULL, NULL, NULL, 4),
(155298, NULL, 'G3DSA:2.160.10.30:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155299, NULL, 'G3DSA:2.30.180.10:FF:000163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155300, NULL, 'G3DSA:4.10.830.40:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155301, NULL, 'G3DSA:3.20.20.30:FF:000008', NULL, NULL, 'Xenobiotic compound monooxygenase A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(155302, NULL, 'G3DSA:1.10.340.70:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155303, NULL, 'G3DSA:3.40.50.720:FF:000771', NULL, NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(155304, NULL, 'G3DSA:4.10.240.10:FF:000007', NULL, NULL, 'C6 transcription factor FacB', NULL, NULL, NULL, NULL, NULL, 4),
(155305, NULL, 'G3DSA:2.40.30.10:FF:000392', NULL, NULL, 'tRNA-specific 2-thiouridylase', NULL, NULL, NULL, NULL, NULL, 4),
(155306, NULL, 'G3DSA:3.40.30.10:FF:000457', NULL, NULL, 'Co-chaperone YbbN', NULL, NULL, NULL, NULL, NULL, 4),
(155307, NULL, 'G3DSA:3.30.160.60:FF:004539', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155308, NULL, 'G3DSA:1.10.506.10:FF:000064', NULL, NULL, 'Plexin A3', NULL, NULL, NULL, NULL, NULL, 4),
(155309, NULL, 'G3DSA:3.40.50.2300:FF:000873', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155310, NULL, 'G3DSA:3.40.50.620:FF:000191', NULL, NULL, 'Nicotinamide-nucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(155311, NULL, 'G3DSA:1.10.132.60:FF:000013', NULL, NULL, 'DNA polymerase Pol2', NULL, NULL, NULL, NULL, NULL, 4),
(155312, NULL, 'G3DSA:2.60.260.20:FF:000047', NULL, NULL, 'Molecular chaperone DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(155313, NULL, 'G3DSA:1.20.58.70:FF:000055', NULL, NULL, 'QA-SNARE protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(155314, NULL, 'G3DSA:2.130.10.10:FF:004635', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155315, NULL, 'G3DSA:1.25.40.10:FF:004106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155316, NULL, 'G3DSA:3.40.50.300:FF:004692', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(155317, NULL, 'G3DSA:3.40.50.300:FF:001600', NULL, NULL, 'RhoU, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(155318, NULL, 'G3DSA:2.70.130.10:FF:000128', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155319, NULL, 'G3DSA:3.90.1150.10:FF:000305', NULL, NULL, 'Sphingosine Phosphate Lyase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(155320, NULL, 'G3DSA:1.20.58.60:FF:000518', NULL, NULL, 'Spectrin repeat containing, nuclear envelope 1a', NULL, NULL, NULL, NULL, NULL, 4),
(155321, NULL, 'G3DSA:3.30.1640.10:FF:000082', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(155322, NULL, 'G3DSA:1.20.1250.20:FF:001727', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155323, NULL, 'G3DSA:1.10.10.10:FF:000484', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(155324, NULL, 'G3DSA:1.25.40.330:FF:000004', NULL, NULL, 'Adenylyl cyclase-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(155325, NULL, 'G3DSA:2.60.40.10:FF:001465', NULL, NULL, 'Interleukin-22 receptor subunit alpha-1', NULL, NULL, NULL, NULL, NULL, 4),
(155326, NULL, 'G3DSA:1.25.10.10:FF:001507', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155327, NULL, 'G3DSA:3.30.160.60:FF:002639', NULL, NULL, 'Kruppel-Like Factor (Zinc finger protein)', NULL, NULL, NULL, NULL, NULL, 4),
(155328, NULL, 'G3DSA:1.20.1050.130:FF:000011', NULL, NULL, 'Glutamyl-prolyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(155329, NULL, 'G3DSA:3.30.160.60:FF:002078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155330, NULL, 'G3DSA:1.10.1300.10:FF:000034', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(155331, NULL, 'G3DSA:3.20.20.10:FF:000002', NULL, NULL, 'Alanine racemase', NULL, NULL, NULL, NULL, NULL, 4),
(155332, NULL, 'G3DSA:3.80.10.10:FF:002005', NULL, NULL, 'Zgc:194906', NULL, NULL, NULL, NULL, NULL, 4),
(155333, NULL, 'G3DSA:3.30.70.330:FF:001655', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155334, NULL, 'G3DSA:1.25.40.10:FF:004781', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(155335, NULL, 'G3DSA:1.20.5.220:FF:000003', NULL, NULL, 'Photosystem I reaction center subunit VI', NULL, NULL, NULL, NULL, NULL, 4),
(155336, NULL, 'G3DSA:3.30.40.10:FF:000149', NULL, NULL, 'E3 ubiquitin-protein ligase AMFR', NULL, NULL, NULL, NULL, NULL, 4),
(155337, NULL, 'G3DSA:3.30.160.60:FF:001229', NULL, NULL, 'Zinc finger protein 341', NULL, NULL, NULL, NULL, NULL, 4),
(155338, NULL, 'G3DSA:2.40.180.10:FF:000003', NULL, NULL, 'Catalase', NULL, NULL, NULL, NULL, NULL, 4),
(155339, NULL, 'G3DSA:2.60.40.10:FF:000616', NULL, NULL, 'PKHD1 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(155340, NULL, 'G3DSA:2.10.110.10:FF:000096', NULL, NULL, 'LIM domain kinase 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(155341, NULL, 'G3DSA:3.30.160.60:FF:001105', NULL, NULL, 'Zinc finger protein 677', NULL, NULL, NULL, NULL, NULL, 4),
(155342, NULL, 'G3DSA:2.60.40.1190:FF:000002', NULL, NULL, 'Amidohydrolase 2', NULL, NULL, NULL, NULL, NULL, 4),
(155343, NULL, 'G3DSA:2.40.160.120:FF:000054', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(155344, NULL, 'G3DSA:3.40.50.2000:FF:000446', NULL, NULL, 'WbcN protein', NULL, NULL, NULL, NULL, NULL, 4),
(155345, NULL, 'G3DSA:3.10.250.10:FF:000040', NULL, NULL, 'Multidomain scavenger receptor', NULL, NULL, NULL, NULL, NULL, 4),
(155346, NULL, 'G3DSA:3.30.70.330:FF:000806', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein Q isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(155347, NULL, 'G3DSA:3.30.160.60:FF:005490', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155348, NULL, 'G3DSA:3.30.420.40:FF:000546', NULL, NULL, 'YALI0B10538p', NULL, NULL, NULL, NULL, NULL, 4),
(155349, NULL, 'G3DSA:3.90.180.10:FF:000100', NULL, NULL, 'Putative cinnamyl alcohol dehydrogenase 6', NULL, NULL, NULL, NULL, NULL, 4),
(155350, NULL, 'G3DSA:1.20.1080.10:FF:000042', NULL, NULL, 'AQuaPorin or aquaglyceroporin related', NULL, NULL, NULL, NULL, NULL, 4),
(155351, NULL, 'G3DSA:1.10.418.10:FF:000117', NULL, NULL, 'p-loop nucleoside triphosphate hydrolase superfamily protein with CH (Calponin Homology) domain', NULL, NULL, NULL, NULL, NULL, 4),
(155352, NULL, 'G3DSA:3.30.110.60:FF:000001', NULL, NULL, 'RNA-binding protein YhbY', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(155353, NULL, 'G3DSA:1.20.1250.10:FF:000005', NULL, NULL, 'cardiotrophin-like cytokine factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(155354, NULL, 'G3DSA:3.30.470.20:FF:000049', NULL, NULL, 'tubulin--tyrosine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(155355, NULL, 'G3DSA:3.40.50.980:FF:000034', NULL, NULL, 'Nonribosomal peptide synthase, putative (JCVI)', NULL, NULL, NULL, NULL, NULL, 4),
(155356, NULL, 'G3DSA:2.40.30.10:FF:000493', NULL, NULL, 'Nitric oxide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(155357, NULL, 'G3DSA:3.30.710.10:FF:000189', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(155358, NULL, 'G3DSA:3.40.50.1000:FF:000702', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155359, NULL, 'G3DSA:1.25.40.610:FF:000004', NULL, NULL, 'adhesion G protein-coupled receptor B1', NULL, NULL, NULL, NULL, NULL, 4),
(155360, NULL, 'G3DSA:1.20.870.10:FF:000042', NULL, NULL, 'Ras guanine nucleotide exchange factor M', NULL, NULL, NULL, NULL, NULL, 4),
(155361, NULL, 'G3DSA:1.20.1070.10:FF:001396', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155362, NULL, 'G3DSA:1.25.40.10:FF:005163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155363, NULL, 'G3DSA:1.10.1200.10:FF:000004', NULL, NULL, 'D-alanyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(155364, NULL, 'G3DSA:1.20.1280.50:FF:000030', NULL, NULL, 'F-box/kelch-repeat protein At3g61590', NULL, NULL, NULL, NULL, NULL, 4),
(155365, NULL, 'G3DSA:3.50.50.60:FF:000793', NULL, NULL, 'FAD-dependent oxidoreductase domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(155366, NULL, 'G3DSA:3.30.420.40:FF:000884', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155367, NULL, 'G3DSA:1.10.238.20:FF:000016', NULL, NULL, 'Odorant-binding protein 57e', NULL, NULL, NULL, NULL, NULL, 4),
(155368, NULL, 'G3DSA:3.40.50.620:FF:000292', NULL, NULL, 'Pantetheine-phosphate adenylyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(155369, NULL, 'G3DSA:3.30.160.60:FF:004326', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155370, NULL, 'G3DSA:3.40.50.170:FF:000010', NULL, NULL, 'Methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(155371, NULL, 'G3DSA:1.25.10.10:FF:001390', NULL, NULL, 'Armadillo repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(155372, NULL, 'G3DSA:3.30.479.20:FF:000018', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(155373, NULL, 'G3DSA:1.10.20.10:FF:000209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155374, NULL, 'G3DSA:3.30.710.10:FF:000301', NULL, NULL, 'GDNF inducible zinc finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(155375, NULL, 'G3DSA:3.40.50.1000:FF:000584', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155376, NULL, 'G3DSA:3.30.70.330:FF:002032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155377, NULL, 'G3DSA:1.20.5.270:FF:000001', NULL, NULL, 'Cytochrome b-c1 complex subunit Rieske, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(155378, NULL, 'G3DSA:3.20.20.210:FF:000009', NULL, NULL, 'Putative uroporphyrinogen decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(155379, NULL, 'G3DSA:3.40.50.300:FF:003635', NULL, NULL, 'DNA repair protein RecN', NULL, NULL, NULL, NULL, NULL, 4),
(155380, NULL, 'G3DSA:3.10.20.90:FF:000846', NULL, NULL, 'Ubiquitin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(155381, NULL, 'G3DSA:2.60.40.60:FF:000957', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155382, NULL, 'G3DSA:3.30.70.2970:FF:000003', NULL, NULL, 'Putative lipoprotein LpqG', NULL, NULL, NULL, NULL, NULL, 4),
(155383, NULL, 'G3DSA:3.30.1960.10:FF:000010', NULL, NULL, 'tRNA(Phe) 7-((3-amino-3-carboxypropyl)-4-demethylwyosine(37)-N(4))-methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(155384, NULL, 'G3DSA:3.40.50.720:FF:000552', NULL, NULL, 'NEDD8-activating enzyme E1 catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(155385, NULL, 'G3DSA:3.90.550.50:FF:000129', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(155386, NULL, 'G3DSA:1.20.120.350:FF:000249', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155387, NULL, 'G3DSA:2.60.40.10:FF:002746', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155388, NULL, 'G3DSA:3.20.70.20:FF:000042', NULL, NULL, 'Hypothetical nucleotide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(155389, NULL, 'G3DSA:1.10.287.4070:FF:000008', NULL, NULL, 'PRP31p Splicing factor', NULL, NULL, NULL, NULL, NULL, 4),
(155390, NULL, 'G3DSA:3.30.1020.10:FF:000006', NULL, NULL, 'Peroxiredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(155391, NULL, 'G3DSA:3.30.160.60:FF:003814', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155392, NULL, 'G3DSA:1.10.20.10:FF:000316', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155393, NULL, 'G3DSA:3.40.50.300:FF:000881', NULL, NULL, 'ABC multidrug transporter A-1', NULL, NULL, NULL, NULL, NULL, 4),
(155394, NULL, 'G3DSA:1.20.1270.10:FF:000091', NULL, NULL, 'Heat shock cognate 71 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(155395, NULL, 'G3DSA:2.10.25.10:FF:001758', NULL, NULL, 'Notch 3', NULL, NULL, NULL, NULL, NULL, 4),
(155396, NULL, 'G3DSA:3.40.50.12280:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155397, NULL, 'G3DSA:2.60.40.10:FF:003258', NULL, NULL, 'Interleukin-6 receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(155398, NULL, 'G3DSA:3.30.830.10:FF:000248', NULL, NULL, 'AGAP006099-PA', NULL, NULL, NULL, NULL, NULL, 4),
(155399, NULL, 'G3DSA:1.10.3470.10:FF:000058', NULL, NULL, 'Probable metal transport system membrane protein TM_0125', NULL, NULL, NULL, NULL, NULL, 4),
(155400, NULL, 'G3DSA:2.60.120.920:FF:000101', NULL, NULL, 'Neuralized E3 ubiquitin protein ligase 1Ab', NULL, NULL, NULL, NULL, NULL, 4),
(155401, NULL, 'G3DSA:2.30.39.10:FF:000007', NULL, NULL, 'pigment epithelium-derived factor isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(155402, NULL, 'G3DSA:2.60.40.420:FF:000072', NULL, NULL, 'Spore coat protein A', NULL, NULL, NULL, NULL, NULL, 4),
(155403, NULL, 'G3DSA:3.30.160.60:FF:003707', NULL, NULL, 'Zinc finger protein 786', NULL, NULL, NULL, NULL, NULL, 4),
(155404, NULL, 'G3DSA:1.10.510.10:FF:000624', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(155405, NULL, 'G3DSA:3.30.60.30:FF:000246', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(155406, NULL, 'G3DSA:2.40.50.140:FF:000909', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155407, NULL, 'G3DSA:3.40.50.1000:FF:000691', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155408, NULL, 'G3DSA:2.130.10.10:FF:002617', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit wuho', NULL, NULL, NULL, NULL, NULL, 4),
(155409, NULL, 'G3DSA:1.20.1560.10:FF:000540', NULL, NULL, 'ATP-binding cassette transporter, subfamily C, member 5, group MRP protein PpABCC5', NULL, NULL, NULL, NULL, NULL, 4),
(155410, NULL, 'G3DSA:1.25.40.20:FF:000383', NULL, NULL, 'Ankyrin repeat and SOCS box protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(155411, NULL, 'G3DSA:3.80.10.10:FF:003208', NULL, NULL, 'Si:dkey-286j17.4', NULL, NULL, NULL, NULL, NULL, 4),
(155412, NULL, 'G3DSA:1.10.3370.10:FF:000011', NULL, NULL, 'Protein translocase subunit SecY', NULL, NULL, NULL, NULL, NULL, 4),
(155413, NULL, 'G3DSA:1.25.10.10:FF:000771', NULL, NULL, 'Unplaced genomic scaffold supercont1.234, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(155414, NULL, 'G3DSA:3.40.50.720:FF:001968', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155415, NULL, 'G3DSA:2.20.25.80:FF:000002', NULL, NULL, 'probable WRKY transcription factor 31', NULL, NULL, NULL, NULL, NULL, 4),
(155416, NULL, 'G3DSA:3.30.70.360:FF:000006', NULL, NULL, 'N-fatty-acyl-amino acid synthase/hydrolase PM20D1', NULL, NULL, NULL, NULL, NULL, 4),
(155417, NULL, 'G3DSA:3.30.70.2520:FF:000003', NULL, NULL, 'L-gulonolactone oxidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(155418, NULL, 'G3DSA:1.10.150.390:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(155419, NULL, 'G3DSA:3.30.70.1990:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155420, NULL, 'G3DSA:2.170.150.80:FF:000019', NULL, NULL, 'NAC domain containing protein 64', NULL, NULL, NULL, NULL, NULL, 4),
(155421, NULL, 'G3DSA:3.30.160.60:FF:005271', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155422, NULL, 'G3DSA:1.10.555.10:FF:000025', NULL, NULL, 'Rho GTPase-activating protein 20', NULL, NULL, NULL, NULL, NULL, 4),
(155423, NULL, 'G3DSA:3.30.70.330:FF:001998', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155424, NULL, 'G3DSA:3.40.50.2000:FF:000103', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(155425, NULL, 'G3DSA:4.10.280.10:FF:000105', NULL, NULL, 'Rtg3p', NULL, NULL, NULL, NULL, NULL, 4),
(155426, NULL, 'G3DSA:3.80.10.10:FF:003197', NULL, NULL, 'Receptor-like kinase TMK2', NULL, NULL, NULL, NULL, NULL, 4),
(155427, NULL, 'G3DSA:3.40.50.300:FF:002112', NULL, NULL, 'NLR family pyrin domain containing 10', NULL, NULL, NULL, NULL, NULL, 4),
(155428, NULL, 'G3DSA:3.30.530.20:FF:000088', NULL, NULL, 'START domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(155429, NULL, 'G3DSA:3.40.1620.60:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155430, NULL, 'G3DSA:1.20.58.60:FF:000406', NULL, NULL, 'Related to alpha-actinin', NULL, NULL, NULL, NULL, NULL, 4),
(155431, NULL, 'G3DSA:3.40.50.150:FF:001089', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155432, NULL, 'G3DSA:3.30.200.20:FF:000327', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 10', NULL, NULL, NULL, NULL, NULL, 4),
(155433, NULL, 'G3DSA:2.60.40.10:FF:005731', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155434, NULL, 'G3DSA:3.40.50.11500:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155435, NULL, 'G3DSA:1.20.1730.10:FF:000019', NULL, NULL, 'Solute carrier family 5 member 10', NULL, NULL, NULL, NULL, NULL, 4),
(155436, NULL, 'G3DSA:3.40.140.10:FF:000126', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(155437, NULL, 'G3DSA:3.10.490.10:FF:000029', NULL, NULL, 'Gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(155438, NULL, 'G3DSA:3.30.40.10:FF:002043', NULL, NULL, 'PHd Finger family', NULL, NULL, NULL, NULL, NULL, 4),
(155439, NULL, 'G3DSA:3.30.160.60:FF:000959', NULL, NULL, 'zinc finger protein 449', NULL, NULL, NULL, NULL, NULL, 4),
(155440, NULL, 'G3DSA:2.20.100.10:FF:000093', NULL, NULL, 'SCO-spondin-like isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(155441, NULL, 'G3DSA:2.60.40.10:FF:000515', NULL, NULL, 'Leptin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(155442, NULL, 'G3DSA:1.25.10.10:FF:001968', NULL, NULL, 'Rapamycin-insensitive companion of mTOR, N-term-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(155443, NULL, 'G3DSA:3.40.50.10190:FF:000142', NULL, NULL, 'BRCT domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(155444, NULL, 'G3DSA:3.30.1120.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155445, NULL, 'G3DSA:1.25.40.20:FF:000276', NULL, NULL, 'Asparaginase', NULL, NULL, NULL, NULL, NULL, 4),
(155446, NULL, 'G3DSA:2.70.160.11:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155447, NULL, 'G3DSA:2.60.120.260:FF:000206', NULL, NULL, 'Netrin-B, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(155448, NULL, 'G3DSA:1.20.58.390:FF:000020', NULL, NULL, '5-hydroxytryptamine (serotonin) receptor 3A', NULL, NULL, NULL, NULL, NULL, 4),
(155449, NULL, 'G3DSA:2.10.25.10:FF:001073', NULL, NULL, 'AGAP008185-PA', NULL, NULL, NULL, NULL, NULL, 4),
(155450, NULL, 'G3DSA:3.30.2330.10:FF:000002', NULL, NULL, 'Arginine biosynthesis bifunctional protein ArgJ', NULL, NULL, NULL, NULL, NULL, 4),
(155451, NULL, 'G3DSA:3.90.1720.10:FF:000001', NULL, NULL, 'Bifunctional murein DD-endopeptidase/murein LD-carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(155452, NULL, 'G3DSA:3.40.630.10:FF:000085', NULL, NULL, 'Gly-Xaa carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(155453, NULL, 'G3DSA:4.10.60.10:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155454, NULL, 'G3DSA:1.10.630.10:FF:000785', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155455, NULL, 'G3DSA:3.40.1110.10:FF:000399', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155456, NULL, 'G3DSA:2.130.10.10:FF:004534', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155457, NULL, 'G3DSA:1.10.510.10:FF:001243', NULL, NULL, 'Protein CBG14903', NULL, NULL, NULL, NULL, NULL, 4),
(155458, NULL, 'G3DSA:2.30.39.10:FF:000114', NULL, NULL, 'Male accessory gland protein', NULL, NULL, NULL, NULL, NULL, 4),
(155459, NULL, 'G3DSA:2.60.40.4070:FF:000012', NULL, NULL, 'Basal-body rod modification protein FlgD', NULL, NULL, NULL, NULL, NULL, 4),
(155460, NULL, 'G3DSA:1.20.58.390:FF:000138', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(155461, NULL, 'G3DSA:3.90.1410.10:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155462, NULL, 'G3DSA:2.60.40.60:FF:000272', NULL, NULL, 'DE cadherin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(155463, NULL, 'G3DSA:1.20.58.60:FF:000395', NULL, NULL, 'Utrophin', NULL, NULL, NULL, NULL, NULL, 4),
(155464, NULL, 'G3DSA:1.25.10.10:FF:003418', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155465, NULL, 'G3DSA:3.40.50.1820:FF:001229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155466, NULL, 'G3DSA:3.30.430.20:FF:000047', NULL, NULL, 'Os01g0366300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(155467, NULL, 'G3DSA:3.40.50.1480:FF:000020', NULL, NULL, 'Adenosylhomocysteinase', NULL, NULL, NULL, NULL, NULL, 4),
(155468, NULL, 'G3DSA:2.10.25.10:FF:000561', NULL, NULL, 'Wing blister, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(155469, NULL, 'G3DSA:1.10.555.10:FF:000132', NULL, NULL, 'Inositol polyphosphate-5-phosphatase B', NULL, NULL, NULL, NULL, NULL, 4),
(155470, NULL, 'G3DSA:3.30.40.10:FF:002280', NULL, NULL, 'Lysine-specific demethylase rbr-2', NULL, NULL, NULL, NULL, NULL, 4),
(155471, NULL, 'G3DSA:1.10.300.10:FF:000013', NULL, NULL, 'Adenylosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(155472, NULL, 'G3DSA:2.40.50.140:FF:000117', NULL, NULL, 'Replication protein A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(155473, NULL, 'G3DSA:3.30.420.40:FF:000092', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(155474, NULL, 'G3DSA:1.10.220.160:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155475, NULL, 'G3DSA:2.30.30.490:FF:000035', NULL, NULL, 'BAH and TFIIS domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(155476, NULL, 'G3DSA:2.60.40.650:FF:000005', NULL, NULL, 'Sulfite oxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(155477, NULL, 'G3DSA:3.90.70.10:FF:000575', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155478, NULL, 'G3DSA:2.60.40.1910:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155479, NULL, 'G3DSA:1.20.58.900:FF:000016', NULL, NULL, 'Small G protein signaling modulator 3', NULL, NULL, NULL, NULL, NULL, 4),
(155480, NULL, 'G3DSA:3.40.50.150:FF:001196', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155481, NULL, 'G3DSA:2.130.10.10:FF:000263', NULL, NULL, 'cytoplasmic dynein 1 intermediate chain 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(155482, NULL, 'G3DSA:3.30.70.330:FF:002717', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155483, NULL, 'G3DSA:3.20.20.100:FF:000090', NULL, NULL, 'Aldehyde reductase protein', NULL, NULL, NULL, NULL, NULL, 4),
(155484, NULL, 'G3DSA:1.10.10.10:FF:002064', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(155485, NULL, 'G3DSA:4.10.260.10:FF:000003', NULL, NULL, 'G-protein complex gamma subunit Ste18/GpgA', NULL, NULL, NULL, NULL, NULL, 4),
(155486, NULL, 'G3DSA:3.40.50.300:FF:006390', NULL, NULL, 'Ras-related protein RabK2', NULL, NULL, NULL, NULL, NULL, 4),
(155487, NULL, 'G3DSA:1.10.10.10:FF:001552', NULL, NULL, 'Adenosine deaminase, RNA-specific', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(155488, NULL, 'G3DSA:2.40.100.10:FF:000116', NULL, NULL, 'Protein CBG27914', NULL, NULL, NULL, NULL, NULL, 4),
(155489, NULL, 'G3DSA:2.60.120.200:FF:000672', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155490, NULL, 'G3DSA:3.40.50.880:FF:000228', NULL, NULL, 'Carbamoyl-phosphate synthase small chain', NULL, NULL, NULL, NULL, NULL, 4),
(155491, NULL, 'G3DSA:1.10.132.30:FF:000010', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(155492, NULL, 'G3DSA:3.30.70.330:FF:002936', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155493, NULL, 'G3DSA:2.60.40.10:FF:001460', NULL, NULL, 'Receptor protein-tyrosine phosphatase 10d', NULL, NULL, NULL, NULL, NULL, 4),
(155494, NULL, 'G3DSA:3.20.20.330:FF:000023', NULL, NULL, 'Methionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(155495, NULL, 'G3DSA:3.90.1720.30:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155496, NULL, 'G3DSA:3.40.50.300:FF:000662', NULL, NULL, 'Pachytene checkpoint protein 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(155497, NULL, 'G3DSA:1.10.10.60:FF:000252', NULL, NULL, 'Retinal homeobox protein Rx-B', NULL, NULL, NULL, NULL, NULL, 4),
(155498, NULL, 'G3DSA:3.90.640.80:FF:000005', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(155499, NULL, 'G3DSA:1.10.8.1290:FF:000004', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(155500, NULL, 'G3DSA:2.40.50.140:FF:001062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155501, NULL, 'G3DSA:1.25.40.10:FF:002408', NULL, NULL, 'CBN-SEL-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(155502, NULL, 'G3DSA:3.30.740.10:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155503, NULL, 'G3DSA:1.10.510.10:FF:002985', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155504, NULL, 'G3DSA:3.30.497.10:FF:000074', NULL, NULL, 'Angiotensinogen', NULL, NULL, NULL, NULL, NULL, 4),
(155505, NULL, 'G3DSA:1.25.40.20:FF:001214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155506, NULL, 'G3DSA:2.60.120.920:FF:000096', NULL, NULL, 'Si:dkey-31n13.4', NULL, NULL, NULL, NULL, NULL, 4),
(155507, NULL, 'G3DSA:3.40.720.10:FF:000204', NULL, NULL, 'GM26188', NULL, NULL, NULL, NULL, NULL, 4),
(155508, NULL, 'G3DSA:3.10.20.90:FF:000953', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155509, NULL, 'G3DSA:1.20.1290.10:FF:000002', NULL, NULL, '4-carboxymuconolactone decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(155510, NULL, 'G3DSA:3.30.420.40:FF:000777', NULL, NULL, 'Hydantoinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(155511, NULL, 'G3DSA:3.60.20.10:FF:000219', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155512, NULL, 'G3DSA:4.10.1000.10:FF:000032', NULL, NULL, 'Zinc finger CCCH-type containing 7A', NULL, NULL, NULL, NULL, NULL, 4),
(155513, NULL, 'G3DSA:3.40.50.720:FF:000119', NULL, NULL, '3-hydroxyisobutyrate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(155514, NULL, 'G3DSA:3.10.350.10:FF:000087', NULL, NULL, 'Lytic transglycosylase, SLT, LysM and LysM domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(155515, NULL, 'G3DSA:3.30.505.10:FF:000246', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155516, NULL, 'G3DSA:3.30.830.10:FF:000136', NULL, NULL, 'Putative mitochondrial-processing peptidase subunit beta, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(155517, NULL, 'G3DSA:2.10.25.10:FF:000342', NULL, NULL, 'Betacellulin preproprotein', NULL, NULL, NULL, NULL, NULL, 4),
(155518, NULL, 'G3DSA:1.10.220.10:FF:000068', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(155519, NULL, 'G3DSA:2.60.120.260:FF:000083', NULL, NULL, 'Cyclic di-GMP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(155520, NULL, 'G3DSA:2.60.120.10:FF:000467', NULL, NULL, 'Cysteine dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(155521, NULL, 'G3DSA:1.10.1580.10:FF:000032', NULL, NULL, 'Mitochondrial GTPase 1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(155522, NULL, 'G3DSA:3.20.20.70:FF:000773', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155523, NULL, 'G3DSA:2.30.29.30:FF:001356', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155524, NULL, 'G3DSA:3.40.50.2000:FF:000215', NULL, NULL, 'Polysaccharide pyruvyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(155525, NULL, 'G3DSA:3.30.160.60:FF:004219', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155526, NULL, 'G3DSA:3.30.1490.80:FF:000028', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(155527, NULL, 'G3DSA:1.20.1070.10:FF:001289', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(155528, NULL, 'G3DSA:1.10.1450.10:FF:000152', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(155529, NULL, 'G3DSA:3.40.50.150:FF:000577', NULL, NULL, 'Protein-lysine N-methyltransferase EHI_110190', NULL, NULL, NULL, NULL, NULL, 4),
(155530, NULL, 'G3DSA:1.25.40.10:FF:000492', NULL, NULL, 'Tetratricopeptide repeat domain 21B', NULL, NULL, NULL, NULL, NULL, 4),
(155531, NULL, 'G3DSA:1.20.5.270:FF:000007', NULL, NULL, 'Cytochrome b-c1 complex subunit Rieske, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(155532, NULL, 'G3DSA:3.90.950.10:FF:000019', NULL, NULL, 'Inosine triphosphate pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(155533, NULL, 'G3DSA:3.40.50.300:FF:008306', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(155534, NULL, 'G3DSA:3.30.160.60:FF:002398', NULL, NULL, 'Zinc finger and SCAN domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(155535, NULL, 'G3DSA:3.30.70.370:FF:000003', NULL, NULL, 'DNA polymerase I A, chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(155536, NULL, 'G3DSA:3.40.190.10:FF:000753', NULL, NULL, 'Hydroxymethylbilane synthase (Porphobilinogen deaminase)', NULL, NULL, NULL, NULL, NULL, 4),
(155537, NULL, 'G3DSA:1.10.15.30:FF:000001', NULL, NULL, '60S ribosomal protein L7', NULL, NULL, NULL, NULL, NULL, 4),
(155538, NULL, 'G3DSA:3.40.50.1010:FF:000020', NULL, NULL, '20S-pre-rRNA D-site endonuclease NOB1', NULL, NULL, NULL, NULL, NULL, 4),
(155539, NULL, 'G3DSA:3.30.60.20:FF:000024', NULL, NULL, 'Protein kinase C epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(155540, NULL, 'G3DSA:3.80.10.10:FF:003085', NULL, NULL, 'F-box protein SKIP14', NULL, NULL, NULL, NULL, NULL, 4),
(155541, NULL, 'G3DSA:3.30.160.60:FF:003022', NULL, NULL, 'Transcription factor Sp7 isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(155542, NULL, 'G3DSA:2.130.10.10:FF:002494', NULL, NULL, 'YALI0D19778p', NULL, NULL, NULL, NULL, NULL, 4),
(155543, NULL, 'G3DSA:3.30.760.10:FF:000035', NULL, NULL, 'Eukaryotic translation initiation factor 4E, putative', NULL, NULL, NULL, NULL, NULL, 4),
(155544, NULL, 'G3DSA:1.25.40.990:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155545, NULL, 'G3DSA:1.25.10.10:FF:002587', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155546, NULL, 'G3DSA:1.10.510.10:FF:000843', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(155547, NULL, 'G3DSA:3.90.660.10:FF:000137', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155548, NULL, 'G3DSA:1.20.1510.10:FF:000025', NULL, NULL, 'Zinc transporter 35C, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(155549, NULL, 'G3DSA:3.20.20.80:FF:000427', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155550, NULL, 'G3DSA:3.20.20.80:FF:000091', NULL, NULL, 'Class V chitinase CHIT5', NULL, NULL, NULL, NULL, NULL, 4),
(155551, NULL, 'G3DSA:2.60.40.10:FF:004663', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155552, NULL, 'G3DSA:3.30.160.60:FF:001460', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155553, NULL, 'G3DSA:3.40.50.10190:FF:000030', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(155554, NULL, 'G3DSA:1.10.274.10:FF:000001', NULL, NULL, 'Phosphoenolpyruvate-protein phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(155555, NULL, 'G3DSA:3.40.50.300:FF:001623', NULL, NULL, 'Adenylate cyclase type 10', NULL, NULL, NULL, NULL, NULL, 4),
(155556, NULL, 'G3DSA:3.80.10.10:FF:002573', NULL, NULL, 'Leucine rich repeats and guanylate kinase domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(155557, NULL, 'G3DSA:2.60.200.20:FF:000061', NULL, NULL, 'Zgc:165656 protein', NULL, NULL, NULL, NULL, NULL, 4),
(155558, NULL, 'G3DSA:1.10.510.10:FF:002529', NULL, NULL, 'Probable serine/threonine-protein kinase pknH', NULL, NULL, NULL, NULL, NULL, 4),
(155559, NULL, 'G3DSA:2.130.10.10:FF:000948', NULL, NULL, 'Pre-mRNA-processing factor 19', NULL, NULL, NULL, NULL, NULL, 4),
(155560, NULL, 'G3DSA:2.60.98.20:FF:000005', NULL, NULL, 'Flagellar hook protein FlgE', NULL, NULL, NULL, NULL, NULL, 4),
(155561, NULL, 'G3DSA:1.20.1050.10:FF:000237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155562, NULL, 'G3DSA:1.10.10.160:FF:000036', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(155563, NULL, 'G3DSA:1.20.1250.20:FF:000204', NULL, NULL, 'Peptide transporter PTR2', NULL, NULL, NULL, NULL, NULL, 4),
(155564, NULL, 'G3DSA:2.60.40.10:FF:000392', NULL, NULL, 'CLUMA_CG000981, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(155565, NULL, 'G3DSA:3.30.460.10:FF:000102', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(155566, NULL, 'G3DSA:3.20.20.140:FF:000180', NULL, NULL, 'YJL213W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(155567, NULL, 'G3DSA:2.130.10.10:FF:001224', NULL, NULL, 'Protein CBR-SMU-1', NULL, NULL, NULL, NULL, NULL, 4),
(155568, NULL, 'G3DSA:2.60.120.260:FF:000190', NULL, NULL, 'Odd Oz/ten-m (Odz2), mRNA protein', NULL, NULL, NULL, NULL, NULL, 4),
(155569, NULL, 'G3DSA:3.40.50.300:FF:008295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155570, NULL, 'G3DSA:1.10.287.70:FF:000313', NULL, NULL, 'Small conductance calcium-activated potassium channel-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(155571, NULL, 'G3DSA:3.40.50.300:FF:005889', NULL, NULL, 'CHL1 helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(155572, NULL, 'G3DSA:3.40.50.720:FF:001176', NULL, NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 9, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(155573, NULL, 'G3DSA:3.40.50.10490:FF:000013', NULL, NULL, 'Phosphoheptose isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(155574, NULL, 'G3DSA:1.25.40.10:FF:000503', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(155575, NULL, 'G3DSA:3.40.50.300:FF:006513', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155576, NULL, 'G3DSA:1.10.246.190:FF:000003', NULL, NULL, 'Autophagy protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(155577, NULL, 'G3DSA:3.30.900.10:FF:000024', NULL, NULL, 'Autophagy-related protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(155578, NULL, 'G3DSA:1.50.10.10:FF:000027', NULL, NULL, 'Probable mannosyl-oligosaccharide glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(155579, NULL, 'G3DSA:2.40.50.40:FF:000054', NULL, NULL, 'Chromo-domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(155580, NULL, 'G3DSA:1.25.40.10:FF:002285', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(155581, NULL, 'G3DSA:1.20.920.20:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155582, NULL, 'G3DSA:2.130.10.10:FF:005838', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155583, NULL, 'G3DSA:3.30.160.60:FF:005731', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155584, NULL, 'G3DSA:1.10.8.60:FF:000161', NULL, NULL, 'Putative AAA family ATPase SEC18', NULL, NULL, NULL, NULL, NULL, 4),
(155585, NULL, 'G3DSA:1.10.357.140:FF:000031', NULL, NULL, 'Probable protoheme IX farnesyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(155586, NULL, 'G3DSA:3.30.710.10:FF:000431', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(155587, NULL, 'G3DSA:2.20.70.10:FF:000221', NULL, NULL, 'Putative mitochondrial protein', NULL, NULL, NULL, NULL, NULL, 4),
(155588, NULL, 'G3DSA:2.60.40.150:FF:000636', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155589, NULL, 'G3DSA:3.40.50.1440:FF:000143', NULL, NULL, 'Tubulin/FtsZ family, GTPase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(155590, NULL, 'G3DSA:3.10.20.90:FF:000734', NULL, NULL, 'Serine threonine protein kinase raf1', NULL, NULL, NULL, NULL, NULL, 4),
(155591, NULL, 'G3DSA:1.10.8.10:FF:000062', NULL, NULL, 'NEDD8 ultimate buster 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(155592, NULL, 'G3DSA:3.30.160.60:FF:000167', NULL, NULL, 'Zinc finger protein 521', NULL, NULL, NULL, NULL, NULL, 4),
(155593, NULL, 'G3DSA:3.40.350.10:FF:000052', NULL, NULL, 'X-Pro aminopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(155594, NULL, 'G3DSA:1.10.2020.20:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155595, NULL, 'G3DSA:3.40.50.300:FF:001281', NULL, NULL, 'Dynamin-like protein ARC5', NULL, NULL, NULL, NULL, NULL, 4),
(155596, NULL, 'G3DSA:1.10.274.30:FF:000007', NULL, NULL, 'Male-specific lethal 3', NULL, NULL, NULL, NULL, NULL, 4),
(155597, NULL, 'G3DSA:3.40.50.300:FF:008188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155598, NULL, 'G3DSA:1.10.510.10:FF:003474', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155599, NULL, 'G3DSA:3.90.180.10:FF:000106', NULL, NULL, 'Quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(155600, NULL, 'G3DSA:3.10.20.90:FF:001010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155601, NULL, 'G3DSA:2.130.10.10:FF:004990', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155602, NULL, 'G3DSA:3.40.140.10:FF:000019', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit F', NULL, NULL, NULL, NULL, NULL, 4),
(155603, NULL, 'G3DSA:3.30.450.20:FF:000161', NULL, NULL, 'Cyclic-di-AMP phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(155604, NULL, 'G3DSA:3.20.20.140:FF:000073', NULL, NULL, 'Parathion hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(155605, NULL, 'G3DSA:3.10.100.10:FF:000372', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155606, NULL, 'G3DSA:1.10.238.10:FF:000468', NULL, NULL, 'Dual oxidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(155607, NULL, 'G3DSA:1.25.50.20:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155608, NULL, 'G3DSA:3.90.550.50:FF:000124', NULL, NULL, 'UDP-galactose:N-acetylgalactosamine-alpha-R beta 1,3-galactosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(155609, NULL, 'G3DSA:3.40.190.290:FF:000014', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(155610, NULL, 'G3DSA:3.20.20.210:FF:000004', NULL, NULL, 'Uroporphyrinogen decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(155611, NULL, 'G3DSA:1.25.10.10:FF:002457', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155612, NULL, 'G3DSA:1.20.120.1490:FF:000002', NULL, NULL, 'ATP-independent periplasmic protein-refolding chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(155613, NULL, 'G3DSA:3.40.50.300:FF:003416', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(155614, NULL, 'G3DSA:2.60.40.10:FF:005282', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155615, NULL, 'G3DSA:3.40.1030.10:FF:000016', NULL, NULL, 'Thymidine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(155616, NULL, 'G3DSA:1.10.600.10:FF:000053', NULL, NULL, 'Squalene synthase', NULL, NULL, NULL, NULL, NULL, 4),
(155617, NULL, 'G3DSA:3.90.1140.10:FF:000030', NULL, NULL, 'A-kinase-anchoring protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(155618, NULL, 'G3DSA:3.10.50.40:FF:000120', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(155619, NULL, 'G3DSA:3.40.1090.10:FF:000121', NULL, NULL, 'Patatin', NULL, NULL, NULL, NULL, NULL, 4),
(155620, NULL, 'G3DSA:3.60.40.10:FF:000114', NULL, NULL, 'PP2C-family Ser/Thr phosphatase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(155621, NULL, 'G3DSA:3.10.290.10:FF:000048', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(155622, NULL, 'G3DSA:2.60.220.50:FF:000161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155623, NULL, 'G3DSA:3.30.450.20:FF:000503', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(155624, NULL, 'G3DSA:3.40.50.620:FF:000297', NULL, NULL, 'Universal stress protein MT2087', NULL, NULL, NULL, NULL, NULL, 4),
(155625, NULL, 'G3DSA:2.30.30.40:FF:000244', NULL, NULL, 'Peptidase, M23/M37 family', NULL, NULL, NULL, NULL, NULL, 4),
(155626, NULL, 'G3DSA:1.10.10.2750:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155627, NULL, 'G3DSA:3.80.10.10:FF:001628', NULL, NULL, 'Receptor like protein 41', NULL, NULL, NULL, NULL, NULL, 4),
(155628, NULL, 'G3DSA:3.40.1370.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155629, NULL, 'G3DSA:1.20.1640.10:FF:000029', NULL, NULL, 'Putative Patched sphingolipid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(155630, NULL, 'G3DSA:3.60.10.10:FF:000157', NULL, NULL, 'Pantothenate kinase subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(155631, NULL, 'G3DSA:3.40.630.30:FF:000080', NULL, NULL, 'Siderophore biosynthesis acetylase AceI, putative', NULL, NULL, NULL, NULL, NULL, 4),
(155632, NULL, 'G3DSA:1.10.418.10:FF:000229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155633, NULL, 'G3DSA:3.30.720.210:FF:000019', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(155634, NULL, 'G3DSA:1.10.150.620:FF:000001', NULL, NULL, 'Structural polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(155635, NULL, 'G3DSA:1.10.150.240:FF:000090', NULL, NULL, 'Phosphoglycolate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(155636, NULL, 'G3DSA:1.10.220.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155637, NULL, 'G3DSA:3.90.1520.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155638, NULL, 'G3DSA:1.10.10.60:FF:001213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155639, NULL, 'G3DSA:3.40.50.300:FF:004933', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155640, NULL, 'G3DSA:3.30.1780.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155641, NULL, 'G3DSA:1.10.630.10:FF:000223', NULL, NULL, 'Sporulation-specific N-formyltyrosine oxidase Dit2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(155642, NULL, 'G3DSA:3.30.1060.10:FF:000003', NULL, NULL, 'Peptide methionine sulfoxide reductase MsrA', NULL, NULL, NULL, NULL, NULL, 4),
(155643, NULL, 'G3DSA:2.10.110.10:FF:000073', NULL, NULL, 'Uncharacterized protein, isoform Z', NULL, NULL, NULL, NULL, NULL, 4),
(155644, NULL, 'G3DSA:1.10.10.60:FF:000589', NULL, NULL, 'AEL176Cp', NULL, NULL, NULL, NULL, NULL, 4),
(155645, NULL, 'G3DSA:3.30.200.20:FF:002244', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155646, NULL, 'G3DSA:2.130.10.10:FF:003017', NULL, NULL, 'U3 small nucleolar RNA-associated protein 15 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(155647, NULL, 'G3DSA:3.40.1170.60:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155648, NULL, 'G3DSA:1.10.287.1130:FF:000014', NULL, NULL, 'Cytochrome c oxidase copper chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(155649, NULL, 'G3DSA:3.30.40.10:FF:000126', NULL, NULL, 'metal-response element-binding transcription factor 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(155650, NULL, 'G3DSA:3.30.450.40:FF:000149', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(155651, NULL, 'G3DSA:2.40.160.120:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155652, NULL, 'G3DSA:3.40.50.1010:FF:000132', NULL, NULL, 'Flap endonuclease Xni', NULL, NULL, NULL, NULL, NULL, 4),
(155653, NULL, 'G3DSA:1.20.1080.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(155654, NULL, 'G3DSA:2.60.40.10:FF:005624', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155655, NULL, 'G3DSA:2.60.40.10:FF:001004', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(155656, NULL, 'G3DSA:1.20.190.50:FF:000018', NULL, NULL, 'Nuclear pore complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(155657, NULL, 'G3DSA:2.10.25.10:FF:000347', NULL, NULL, 'delta-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(155658, NULL, 'G3DSA:3.30.160.60:FF:005276', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155659, NULL, 'G3DSA:2.80.10.50:FF:000266', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(155660, NULL, 'G3DSA:2.40.10.10:FF:000172', NULL, NULL, 'Prostate-specific antigen', NULL, NULL, NULL, NULL, NULL, 4),
(155661, NULL, 'G3DSA:1.20.1270.280:FF:000049', NULL, NULL, 'Dynein heavy chain 6, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(155662, NULL, 'G3DSA:1.10.238.10:FF:001087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155663, NULL, 'G3DSA:1.10.400.10:FF:000054', NULL, NULL, 'Os05g0341300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(155664, NULL, 'G3DSA:3.90.650.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155665, NULL, 'G3DSA:1.20.120.910:FF:000007', NULL, NULL, 'Zinc finger transcriptional regulator, TraR/DksA family', NULL, NULL, NULL, NULL, NULL, 4),
(155666, NULL, 'G3DSA:2.40.10.10:FF:000514', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155667, NULL, 'G3DSA:1.10.10.10:FF:000147', NULL, NULL, 'Fur family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(155668, NULL, 'G3DSA:1.25.40.20:FF:000832', NULL, NULL, 'Death-associated protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(155669, NULL, 'G3DSA:3.40.140.10:FF:000238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155670, NULL, 'G3DSA:1.25.50.20:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155671, NULL, 'G3DSA:1.25.10.10:FF:000664', NULL, NULL, 'Pta1p', NULL, NULL, NULL, NULL, NULL, 4),
(155672, NULL, 'G3DSA:3.80.10.10:FF:004153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155673, NULL, 'G3DSA:1.10.760.10:FF:000098', NULL, NULL, 'Uvrd / recb / pcra DNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(155674, NULL, 'G3DSA:3.30.70.330:FF:000582', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(155675, NULL, 'G3DSA:1.10.287.470:FF:000034', NULL, NULL, 'Nodulation protein nolF', NULL, NULL, NULL, NULL, NULL, 4),
(155676, NULL, 'G3DSA:1.20.120.720:FF:000057', NULL, NULL, 'Extraocular myosin heavy chain EO-MYHC', NULL, NULL, NULL, NULL, NULL, 4),
(155677, NULL, 'G3DSA:1.20.1740.10:FF:000200', NULL, NULL, 'Solute carrier family 7 (Cationic amino acid transporter, y+ system), member 12, isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(155678, NULL, 'G3DSA:1.20.120.1240:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155679, NULL, 'G3DSA:3.80.10.10:FF:003753', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(155680, NULL, 'G3DSA:2.130.10.10:FF:003910', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155681, NULL, 'G3DSA:3.40.50.150:FF:001084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155682, NULL, 'G3DSA:1.10.15.30:FF:000006', NULL, NULL, '50S ribosomal protein L30', NULL, NULL, NULL, NULL, NULL, 4),
(155683, NULL, 'G3DSA:2.120.10.30:FF:000230', NULL, NULL, 'Haloacid dehalogenase-like hydrolase family', NULL, NULL, NULL, NULL, NULL, 4),
(155684, NULL, 'G3DSA:3.40.50.11860:FF:000002', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(155685, NULL, 'G3DSA:3.30.70.330:FF:000452', NULL, NULL, 'Multiple RNA-binding domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(155686, NULL, 'G3DSA:2.40.50.140:FF:000680', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155687, NULL, 'G3DSA:2.30.42.10:FF:000133', NULL, NULL, 'PDZ domain containing ring finger 4', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(155688, NULL, 'G3DSA:1.20.1540.10:FF:000089', NULL, NULL, 'Os02g0326700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(155689, NULL, 'G3DSA:3.30.530.20:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155690, NULL, 'G3DSA:2.60.40.10:FF:000953', NULL, NULL, 'Collagen, type XX, alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(155691, NULL, 'G3DSA:2.60.40.10:FF:002308', NULL, NULL, 'Stretchin-Mlck, isoform T', NULL, NULL, NULL, NULL, NULL, 4),
(155692, NULL, 'G3DSA:1.20.1070.10:FF:000800', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(155693, NULL, 'G3DSA:3.80.10.10:FF:004501', NULL, NULL, 'Os03g0773700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(155694, NULL, 'G3DSA:1.10.10.60:FF:000937', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155695, NULL, 'G3DSA:1.20.1310.10:FF:000151', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155696, NULL, 'G3DSA:2.60.40.1730:FF:000102', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155697, NULL, 'G3DSA:3.40.50.150:FF:000684', NULL, NULL, 'Nodulation protein', NULL, NULL, NULL, NULL, NULL, 4),
(155698, NULL, 'G3DSA:3.40.800.20:FF:000034', NULL, NULL, 'Histone deacetylase 19', NULL, NULL, NULL, NULL, NULL, 4),
(155699, NULL, 'G3DSA:3.40.50.2300:FF:000098', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(155700, NULL, 'G3DSA:3.60.60.10:FF:000003', NULL, NULL, 'N-acylethanolamine-hydrolyzing acid amidase', NULL, NULL, NULL, NULL, NULL, 4),
(155701, NULL, 'G3DSA:3.40.50.80:FF:000092', NULL, NULL, 'Similar to gi|11359636|pir||T49761 related to ferric reductase', NULL, NULL, NULL, NULL, NULL, 4),
(155702, NULL, 'G3DSA:2.70.70.10:FF:000016', NULL, NULL, 'Peptidase, M23 family', NULL, NULL, NULL, NULL, NULL, 4),
(155703, NULL, 'G3DSA:3.80.10.10:FF:003877', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155704, NULL, 'G3DSA:1.10.10.10:FF:001440', NULL, NULL, 'Iron-dependent repressor IdeR/DtxR', NULL, NULL, NULL, NULL, NULL, 4),
(155705, NULL, 'G3DSA:3.90.190.10:FF:000051', NULL, NULL, 'Dual specificity phosphatase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(155706, NULL, 'G3DSA:2.40.30.10:FF:000055', NULL, NULL, 'Siderophore-interacting family protein', NULL, NULL, NULL, NULL, NULL, 4),
(155707, NULL, 'G3DSA:3.30.70.3490:FF:000030', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(155708, NULL, 'G3DSA:1.25.40.90:FF:000021', NULL, NULL, 'Cytoskeleton assembly control protein Sla2', NULL, NULL, NULL, NULL, NULL, 4),
(155709, NULL, 'G3DSA:3.30.342.10:FF:000002', NULL, NULL, 'DNA polymerase zeta catalytic subunit isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(155710, NULL, 'G3DSA:1.10.8.1220:FF:000017', NULL, NULL, 'Putative dynein heavy chain, cytosolic', NULL, NULL, NULL, NULL, NULL, 4),
(155711, NULL, 'G3DSA:3.40.50.620:FF:000415', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(155712, NULL, 'G3DSA:1.10.510.10:FF:002636', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155713, NULL, 'G3DSA:3.40.50.300:FF:001842', NULL, NULL, 'Pre-mRNA-splicing helicase BRR2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(155714, NULL, 'G3DSA:3.30.160.60:FF:002853', NULL, NULL, 'zinc finger protein 707 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(155715, NULL, 'G3DSA:3.30.300.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155716, NULL, 'G3DSA:3.30.70.330:FF:001071', NULL, NULL, 'Tar DNA-binding protein homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(155717, NULL, 'G3DSA:3.50.50.60:FF:000686', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155718, NULL, 'G3DSA:1.25.10.10:FF:001283', NULL, NULL, 'V-type proton ATPase subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(155719, NULL, 'G3DSA:1.20.1250.20:FF:002121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155720, NULL, 'G3DSA:3.40.50.720:FF:002007', NULL, NULL, 'Dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(155721, NULL, 'G3DSA:1.25.40.10:FF:000610', NULL, NULL, 'Pentatricopeptide repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(155722, NULL, 'G3DSA:3.90.1150.10:FF:000081', NULL, NULL, 'serine palmitoyltransferase 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(155723, NULL, 'G3DSA:3.40.30.10:FF:000215', NULL, NULL, '39S ribosomal protein L53, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(155724, NULL, 'G3DSA:1.10.150.20:FF:000077', NULL, NULL, 'DExH-box ATP-dependent RNA helicase DExH17', NULL, NULL, NULL, NULL, NULL, 4),
(155725, NULL, 'G3DSA:2.30.29.30:FF:000518', NULL, NULL, 'Arf-GAP with ANK repeat and PH domain-containing protein cnt-2', NULL, NULL, NULL, NULL, NULL, 4),
(155726, NULL, 'G3DSA:1.25.40.10:FF:001796', NULL, NULL, 'Genomes uncoupled1', NULL, NULL, NULL, NULL, NULL, 4),
(155727, NULL, 'G3DSA:3.40.50.300:FF:007002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155728, NULL, 'G3DSA:3.40.50.1400:FF:000030', NULL, NULL, 'Sirohydrochlorin cobaltochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(155729, NULL, 'G3DSA:1.10.287.110:FF:000179', NULL, NULL, 'DNaJ domain (Prokaryotic heat shock protein)', NULL, NULL, NULL, NULL, NULL, 4),
(155730, NULL, 'G3DSA:3.90.1600.10:FF:000054', NULL, NULL, 'DNA polymerase alpha subunit one', NULL, NULL, NULL, NULL, NULL, 4),
(155731, NULL, 'G3DSA:1.10.510.10:FF:004098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155732, NULL, 'G3DSA:3.40.850.10:FF:000433', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155733, NULL, 'G3DSA:1.25.40.10:FF:003246', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(155734, NULL, 'G3DSA:3.40.50.720:FF:000557', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(155735, NULL, 'G3DSA:1.25.40.180:FF:000049', NULL, NULL, 'Eukaryotic translation initation factor 4 gamma, putative', NULL, NULL, NULL, NULL, NULL, 4),
(155736, NULL, 'G3DSA:3.40.50.1460:FF:000025', NULL, NULL, 'Cell death protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(155737, NULL, 'G3DSA:1.20.272.40:FF:000015', NULL, NULL, 'SUPV3L1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(155738, NULL, 'G3DSA:1.20.1560.10:FF:000652', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155739, NULL, 'G3DSA:3.80.10.10:FF:003192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155740, NULL, 'G3DSA:3.40.50.300:FF:005552', NULL, NULL, 'Oligopeptide transport ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(155741, NULL, 'G3DSA:3.30.40.10:FF:000363', NULL, NULL, 'E3 ubiquitin-protein ligase ZNRF2', NULL, NULL, NULL, NULL, NULL, 4),
(155742, NULL, 'G3DSA:3.40.50.150:FF:001645', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155743, NULL, 'G3DSA:2.60.40.150:FF:000417', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(155744, NULL, 'G3DSA:2.120.10.80:FF:000093', NULL, NULL, 'Rab9 effector protein with kelch motifs', NULL, NULL, NULL, NULL, NULL, 4),
(155745, NULL, 'G3DSA:2.40.50.140:FF:000005', NULL, NULL, 'Cold shock protein CspE', NULL, NULL, NULL, NULL, NULL, 4),
(155746, NULL, 'G3DSA:1.20.58.60:FF:000390', NULL, NULL, 'Trio, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(155747, NULL, 'G3DSA:3.40.640.10:FF:000147', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(155748, NULL, 'G3DSA:1.10.1070.11:FF:000056', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(155749, NULL, 'G3DSA:2.40.10.170:FF:000023', NULL, NULL, 'ATP synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(155750, NULL, 'G3DSA:2.60.40.150:FF:000075', NULL, NULL, 'protein fantom isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(155751, NULL, 'G3DSA:3.40.1280.10:FF:000040', NULL, NULL, 'YMR310C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(155752, NULL, 'G3DSA:1.20.1260.10:FF:000051', NULL, NULL, 'Ferritin light chain', NULL, NULL, NULL, NULL, NULL, 4),
(155753, NULL, 'G3DSA:1.10.1450.10:FF:000045', NULL, NULL, 'AGAP013391-PA', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(155754, NULL, 'G3DSA:3.40.50.150:FF:000139', NULL, NULL, 'probable 28S rRNA (Cytosine-C(5))-methyltransferase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(155755, NULL, 'G3DSA:2.30.30.70:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155756, NULL, 'G3DSA:3.30.200.20:FF:002025', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(155757, NULL, 'G3DSA:3.10.110.10:FF:000327', NULL, NULL, 'ubiquitin-conjugating enzyme E2 35-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(155758, NULL, 'G3DSA:3.60.40.10:FF:000333', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(155759, NULL, 'G3DSA:1.10.472.10:FF:000383', NULL, NULL, 'D7-type cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(155760, NULL, 'G3DSA:1.10.100.10:FF:000014', NULL, NULL, 'GD12890', NULL, NULL, NULL, NULL, NULL, 4),
(155761, NULL, 'G3DSA:1.10.630.10:FF:000442', NULL, NULL, 'Putative cytochrome P450 superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(155762, NULL, 'G3DSA:1.25.40.10:FF:002757', NULL, NULL, 'AGAP003616-PA', NULL, NULL, NULL, NULL, NULL, 4),
(155763, NULL, 'G3DSA:1.10.510.10:FF:001799', NULL, NULL, 'Kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(155764, NULL, 'G3DSA:3.30.420.10:FF:000094', NULL, NULL, 'Gag-Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(155765, NULL, 'G3DSA:2.60.120.10:FF:000124', NULL, NULL, 'Glycinin G5', NULL, NULL, NULL, NULL, NULL, 4),
(155766, NULL, 'G3DSA:1.20.1250.20:FF:000334', NULL, NULL, 'Drug resistance transporter, EmrB/QacA family', NULL, NULL, NULL, NULL, NULL, 4),
(155767, NULL, 'G3DSA:1.20.1280.50:FF:000266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155768, NULL, 'G3DSA:2.10.220.10:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155769, NULL, 'G3DSA:1.25.10.10:FF:002244', NULL, NULL, 'Nipped-B protein', NULL, NULL, NULL, NULL, NULL, 4),
(155770, NULL, 'G3DSA:3.40.50.1820:FF:001673', NULL, NULL, 'Putative peptide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(155771, NULL, 'G3DSA:1.20.1050.10:FF:000113', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(155772, NULL, 'G3DSA:1.10.510.10:FF:002417', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155773, NULL, 'G3DSA:3.40.50.360:FF:000073', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(155774, NULL, 'G3DSA:1.10.287.70:FF:000425', NULL, NULL, 'Voltage-gated Ca2+ channel, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(155775, NULL, 'G3DSA:3.40.50.300:FF:006619', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155776, NULL, 'G3DSA:2.10.60.10:FF:000024', NULL, NULL, 'Cytotoxin 1', NULL, NULL, NULL, NULL, NULL, 4),
(155777, NULL, 'G3DSA:3.30.300.20:FF:000043', NULL, NULL, 'Uncharacterized GTP-binding protein E02H1.2', NULL, NULL, NULL, NULL, NULL, 4),
(155778, NULL, 'G3DSA:1.25.10.10:FF:001732', NULL, NULL, 'Related to SLS1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(155779, NULL, 'G3DSA:1.10.3720.10:FF:000044', NULL, NULL, 'Thiamine/thiamine pyrophosphate ABC transporter permease ThiP', NULL, NULL, NULL, NULL, NULL, 4),
(155780, NULL, 'G3DSA:1.20.1420.30:FF:000024', NULL, NULL, 'Calcium/proton exchanger, variant', NULL, NULL, NULL, NULL, NULL, 4),
(155781, NULL, 'G3DSA:2.60.200.20:FF:000167', NULL, NULL, 'Bifunctional polynucleotide phosphatase/kinase', NULL, NULL, NULL, NULL, NULL, 4),
(155782, NULL, 'G3DSA:3.40.390.10:FF:000279', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155783, NULL, 'G3DSA:1.25.40.20:FF:000040', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(155784, NULL, 'G3DSA:3.40.720.10:FF:000081', NULL, NULL, 'Protein CBG02074', NULL, NULL, NULL, NULL, NULL, 4),
(155785, NULL, 'G3DSA:1.10.1080.10:FF:000011', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(155786, NULL, 'G3DSA:3.40.250.10:FF:000117', NULL, NULL, 'Rodhanase family domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(155787, NULL, 'G3DSA:3.50.50.60:FF:000118', NULL, NULL, 'Glutathione reductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(155788, NULL, 'G3DSA:3.90.70.80:FF:000006', NULL, NULL, 'Ubiquitin thioesterase OTU1', NULL, NULL, NULL, NULL, NULL, 4),
(155789, NULL, 'G3DSA:3.20.20.100:FF:000207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155790, NULL, 'G3DSA:1.20.1250.20:FF:001952', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155791, NULL, 'G3DSA:2.130.10.10:FF:001437', NULL, NULL, 'LLGL scribble cell polarity complex component 1', NULL, NULL, NULL, NULL, NULL, 4),
(155792, NULL, 'G3DSA:3.30.420.40:FF:000209', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(155793, NULL, 'G3DSA:3.40.50.1820:FF:000150', NULL, NULL, 'Alpha/beta fold hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(155794, NULL, 'G3DSA:3.30.160.60:FF:001330', NULL, NULL, 'Zinc finger protein ZIC 4', NULL, NULL, NULL, NULL, NULL, 4),
(155795, NULL, 'G3DSA:2.120.10.10:FF:000016', NULL, NULL, 'Trans-sialidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(155796, NULL, 'G3DSA:3.30.30.30:FF:000076', NULL, NULL, 'Protein CBG19479', NULL, NULL, NULL, NULL, NULL, 4),
(155797, NULL, 'G3DSA:3.30.1740.10:FF:000027', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(155798, NULL, 'G3DSA:3.40.50.300:FF:001151', NULL, NULL, 'Large subunit GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(155799, NULL, 'G3DSA:2.160.20.10:FF:000054', NULL, NULL, 'Polygalacturonase', NULL, NULL, NULL, NULL, NULL, 4),
(155800, NULL, 'G3DSA:1.20.144.10:FF:000074', NULL, NULL, 'Dolichyl pyrophosphate phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(155801, NULL, 'G3DSA:3.30.870.10:FF:000133', NULL, NULL, 'AGAP006233-PA', NULL, NULL, NULL, NULL, NULL, 4),
(155802, NULL, 'G3DSA:1.10.1520.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155803, NULL, 'G3DSA:3.30.2410.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155804, NULL, 'G3DSA:2.60.40.10:FF:005063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155805, NULL, 'G3DSA:3.40.50.1460:FF:000019', NULL, NULL, 'caspase-14-like', NULL, NULL, NULL, NULL, NULL, 4),
(155806, NULL, 'G3DSA:3.40.50.300:FF:002348', NULL, NULL, 'ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(155807, NULL, 'G3DSA:3.30.200.20:FF:000895', NULL, NULL, 'Transmembrane ion channel', NULL, NULL, NULL, NULL, NULL, 4),
(155808, NULL, 'G3DSA:1.25.40.20:FF:000725', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(155809, NULL, 'G3DSA:1.20.58.70:FF:000049', NULL, NULL, 'EhSyntaxin 1B', NULL, NULL, NULL, NULL, NULL, 4),
(155810, NULL, 'G3DSA:3.30.420.40:FF:000541', NULL, NULL, 'Luminal-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(155811, NULL, 'G3DSA:3.30.930.10:FF:000071', NULL, NULL, 'histidine--tRNA ligase, cytoplasmic isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(155812, NULL, 'G3DSA:1.20.120.680:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155813, NULL, 'G3DSA:2.120.10.30:FF:000443', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155814, NULL, 'G3DSA:3.40.50.300:FF:005108', NULL, NULL, 'Elongator complex protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(155815, NULL, 'G3DSA:3.40.50.800:FF:000025', NULL, NULL, 'PEK/GCN2 protein kinase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(155816, NULL, 'G3DSA:3.50.50.60:FF:000450', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(155817, NULL, 'G3DSA:3.10.180.10:FF:000040', NULL, NULL, 'Methylmalonyl-CoA epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(155818, NULL, 'G3DSA:2.60.40.10:FF:000167', NULL, NULL, 'Down syndrome cell adhesion molecule b', NULL, NULL, NULL, NULL, NULL, 4),
(155819, NULL, 'G3DSA:1.20.1070.10:FF:000221', NULL, NULL, 'Muscarinic acetylcholine receptor gar-2', NULL, NULL, NULL, NULL, NULL, 4),
(155820, NULL, 'G3DSA:3.30.470.20:FF:000044', NULL, NULL, 'tubulin polyglutamylase TTLL11 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(155821, NULL, 'G3DSA:3.30.420.10:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(155822, NULL, 'G3DSA:3.30.2310.20:FF:000009', NULL, NULL, 'HigB toxin protein', NULL, NULL, NULL, NULL, NULL, 4),
(155823, NULL, 'G3DSA:1.10.287.110:FF:000067', NULL, NULL, 'Chaperone DnaJ domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(155824, NULL, 'G3DSA:3.10.129.10:FF:000146', NULL, NULL, 'Cytosolic acyl coenzyme A thioester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(155825, NULL, 'G3DSA:3.90.550.10:FF:000359', NULL, NULL, 'Similar to UTP--glucose-1-phosphate uridylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(155826, NULL, 'G3DSA:3.30.60.30:FF:000010', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(155827, NULL, 'G3DSA:3.50.30.50:FF:000007', NULL, NULL, 'Cyclase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(155828, NULL, 'G3DSA:3.20.20.300:FF:000031', NULL, NULL, 'Glycosyl hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(155829, NULL, 'G3DSA:3.80.10.10:FF:000898', NULL, NULL, 'Leucine Rich Repeat family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(155830, NULL, 'G3DSA:1.20.1440.170:FF:000005', NULL, NULL, 'Putative translation machinery-associated protein 16 protein', NULL, NULL, NULL, NULL, NULL, 4),
(155831, NULL, 'G3DSA:1.25.10.10:FF:002351', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(155832, NULL, 'G3DSA:2.130.10.10:FF:004079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155833, NULL, 'G3DSA:2.60.120.260:FF:000662', NULL, NULL, 'Beta-Mannosidase, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(155834, NULL, 'G3DSA:3.30.230.130:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155835, NULL, 'G3DSA:3.40.50.300:FF:005440', NULL, NULL, 'ATP-dependent DEAD/H RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(155836, NULL, 'G3DSA:1.10.3110.10:FF:000014', NULL, NULL, 'NAD(P)/FAD-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(155837, NULL, 'G3DSA:2.60.40.60:FF:000721', NULL, NULL, 'Cadherin-4', NULL, NULL, NULL, NULL, NULL, 4),
(155838, NULL, 'G3DSA:3.40.50.980:FF:000039', NULL, NULL, 'Peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(155839, NULL, 'G3DSA:2.30.30.40:FF:000137', NULL, NULL, 'Uncharacterized protein, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(155840, NULL, 'G3DSA:3.20.20.60:FF:000096', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(155841, NULL, 'G3DSA:3.60.40.10:FF:000221', NULL, NULL, 'Sigma factor sigB regulation protein rsbU', NULL, NULL, NULL, NULL, NULL, 4),
(155842, NULL, 'G3DSA:3.40.50.720:FF:002244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155843, NULL, 'G3DSA:1.20.1310.10:FF:000044', NULL, NULL, 'Ubiquitin ligase subunit CulD, putative', NULL, NULL, NULL, NULL, NULL, 4),
(155844, NULL, 'G3DSA:4.10.400.10:FF:000211', NULL, NULL, 'Lipophorin receptor 2, isoform I', NULL, NULL, NULL, NULL, NULL, 4),
(155845, NULL, 'G3DSA:3.40.50.2000:FF:000558', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(155846, NULL, 'G3DSA:1.10.510.10:FF:000276', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RCH1', NULL, NULL, NULL, NULL, NULL, 4),
(155847, NULL, 'G3DSA:3.40.1800.20:FF:000016', NULL, NULL, 'LD15650p', NULL, NULL, NULL, NULL, NULL, 4),
(155848, NULL, 'G3DSA:3.40.50.970:FF:000143', NULL, NULL, '1-deoxy-D-xylulose-5-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(155849, NULL, 'G3DSA:2.60.40.10:FF:002297', NULL, NULL, 'CRE-TWK-32 protein', NULL, NULL, NULL, NULL, NULL, 4),
(155850, NULL, 'G3DSA:2.70.98.10:FF:000030', NULL, NULL, 'Putative alpha-1,2-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(155851, NULL, 'G3DSA:3.40.50.720:FF:002013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155852, NULL, 'G3DSA:3.20.20.70:FF:000205', NULL, NULL, 'Fructose-bisphosphate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(155853, NULL, 'G3DSA:2.30.29.30:FF:001120', NULL, NULL, 'TBC1 domain family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(155854, NULL, 'G3DSA:3.40.50.720:FF:000900', NULL, NULL, 'Phthiocerol synthesis polyketide synthase type I PpsB', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(155855, NULL, 'G3DSA:2.60.40.10:FF:004438', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155856, NULL, 'G3DSA:3.90.190.10:FF:000500', NULL, NULL, 'mRNA capping enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(155857, NULL, 'G3DSA:2.60.40.1510:FF:000036', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(155858, NULL, 'G3DSA:3.30.160.60:FF:003365', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155859, NULL, 'G3DSA:1.25.40.10:FF:001228', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g20770', NULL, NULL, NULL, NULL, NULL, 4),
(155860, NULL, 'G3DSA:3.30.200.20:FF:001513', NULL, NULL, 'Protein kinase, putative (AFU_orthologue AFUA_6G09240)', NULL, NULL, NULL, NULL, NULL, 4),
(155861, NULL, 'G3DSA:2.60.120.200:FF:000104', NULL, NULL, 'adhesion G-protein coupled receptor D1', NULL, NULL, NULL, NULL, NULL, 4),
(155862, NULL, 'G3DSA:3.90.660.10:FF:000025', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(155863, NULL, 'G3DSA:3.30.260.10:FF:000103', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155864, NULL, 'G3DSA:3.40.50.300:FF:007570', NULL, NULL, 'Si:dkey-88j15.4', NULL, NULL, NULL, NULL, NULL, 4),
(155865, NULL, 'G3DSA:3.40.50.300:FF:004585', NULL, NULL, 'NACHT and Ankyrin domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(155866, NULL, 'G3DSA:2.20.25.20:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155867, NULL, 'G3DSA:1.10.10.10:FF:000259', NULL, NULL, 'Transcriptional regulator, DeoR family', NULL, NULL, NULL, NULL, NULL, 4),
(155868, NULL, 'G3DSA:1.10.8.270:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155869, NULL, 'G3DSA:3.30.40.10:FF:001874', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(155870, NULL, 'G3DSA:4.10.40.20:FF:000010', NULL, NULL, 'Kazal-type serine protease inhibitor domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(155871, NULL, 'G3DSA:1.10.150.80:FF:000049', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(155872, NULL, 'G3DSA:2.120.10.30:FF:000224', NULL, NULL, 'Regucalcin', NULL, NULL, NULL, NULL, NULL, 4),
(155873, NULL, 'G3DSA:3.40.1110.10:FF:000163', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(155874, NULL, 'G3DSA:2.40.30.10:FF:000509', NULL, NULL, 'NADPH oxidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(155875, NULL, 'G3DSA:1.10.640.10:FF:000050', NULL, NULL, 'Protein CBR-PXN-2', NULL, NULL, NULL, NULL, NULL, 4),
(155876, NULL, 'G3DSA:3.30.160.60:FF:002746', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(155877, NULL, 'G3DSA:3.40.50.300:FF:005097', NULL, NULL, 'X-ray repair-complementing defective repair in Chinese hamster cells 3', NULL, NULL, NULL, NULL, NULL, 4),
(155878, NULL, 'G3DSA:2.30.29.30:FF:000395', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(155879, NULL, 'G3DSA:3.80.10.10:FF:002135', NULL, NULL, 'CD180 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(155880, NULL, 'G3DSA:3.30.160.60:FF:004764', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155881, NULL, 'G3DSA:1.10.510.10:FF:003261', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155882, NULL, 'G3DSA:3.30.70.270:FF:000316', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155883, NULL, 'G3DSA:3.30.160.60:FF:003146', NULL, NULL, 'Zinc finger 30C', NULL, NULL, NULL, NULL, NULL, 4),
(155884, NULL, 'G3DSA:1.10.238.10:FF:000575', NULL, NULL, 'GM19870', NULL, NULL, NULL, NULL, NULL, 4),
(155885, NULL, 'G3DSA:1.10.510.10:FF:000495', NULL, NULL, 'calcium/calmodulin-regulated receptor-like kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(155886, NULL, 'G3DSA:3.30.559.70:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155887, NULL, 'G3DSA:3.40.50.720:FF:001625', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(155888, NULL, 'G3DSA:2.60.40.150:FF:000529', NULL, NULL, 'Phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit alpha-like protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(155889, NULL, 'G3DSA:3.30.1640.10:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155890, NULL, 'G3DSA:3.90.1150.10:FF:000530', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155891, NULL, 'G3DSA:3.10.580.10:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155892, NULL, 'G3DSA:3.40.47.10:FF:000074', NULL, NULL, 'Fatty acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(155893, NULL, 'G3DSA:2.60.120.10:FF:000809', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155894, NULL, 'G3DSA:3.40.50.720:FF:002137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155895, NULL, 'G3DSA:1.20.1720.10:FF:000075', NULL, NULL, 'Transmembrane transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(155896, NULL, 'G3DSA:2.40.240.10:FF:000042', NULL, NULL, 'Glutaminyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(155897, NULL, 'G3DSA:3.30.1370.10:FF:000229', NULL, NULL, 'KH domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(155898, NULL, 'G3DSA:2.60.40.10:FF:001572', NULL, NULL, 'Prolactin-inducible protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(155899, NULL, 'G3DSA:3.90.1100.10:FF:000033', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(155900, NULL, 'G3DSA:1.25.10.10:FF:002929', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155901, NULL, 'G3DSA:2.130.10.10:FF:004186', NULL, NULL, 'Anaphase-promoting complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(155902, NULL, 'G3DSA:1.25.40.10:FF:003701', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155903, NULL, 'G3DSA:2.120.10.30:FF:000336', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(155904, NULL, 'G3DSA:2.30.29.30:FF:000406', NULL, NULL, 'Putative RNA polymerase II transcription factor related protein', NULL, NULL, NULL, NULL, NULL, 4),
(155905, NULL, 'G3DSA:1.20.140.150:FF:000058', NULL, NULL, 'Actin cortical patch protein Sur7', NULL, NULL, NULL, NULL, NULL, 4),
(155906, NULL, 'G3DSA:2.60.120.10:FF:000231', NULL, NULL, '5-deoxy-glucuronate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(155907, NULL, 'G3DSA:3.40.50.620:FF:000308', NULL, NULL, 'Cytidylyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(155908, NULL, 'G3DSA:2.10.25.10:FF:001415', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155909, NULL, 'G3DSA:3.40.50.261:FF:000038', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit alpha-1 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(155910, NULL, 'G3DSA:3.30.70.1880:FF:000002', NULL, NULL, 'UPF0749 protein Rv1825', NULL, NULL, NULL, NULL, NULL, 4),
(155911, NULL, 'G3DSA:3.40.190.10:FF:000281', NULL, NULL, 'ABC transporter, periplasmic substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(155912, NULL, 'G3DSA:1.10.3460.10:FF:000001', NULL, NULL, 'Chlorophyll a-b binding protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(155913, NULL, 'G3DSA:3.80.10.10:FF:000212', NULL, NULL, 'Podocan', NULL, NULL, NULL, NULL, NULL, 4),
(155914, NULL, 'G3DSA:2.130.10.30:FF:000139', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155915, NULL, 'G3DSA:1.25.40.10:FF:004213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155916, NULL, 'G3DSA:3.30.470.30:FF:000035', NULL, NULL, 'CRE-LIG-4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(155917, NULL, 'G3DSA:3.30.450.40:FF:000037', NULL, NULL, 'PAS sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(155918, NULL, 'G3DSA:1.20.120.1900:FF:000075', NULL, NULL, 'Gamma-tubulin complex component gfh1', NULL, NULL, NULL, NULL, NULL, 4),
(155919, NULL, 'G3DSA:1.10.238.220:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155920, NULL, 'G3DSA:4.10.170.10:FF:000007', NULL, NULL, 'Serine/threonine-protein kinase cst-1', NULL, NULL, NULL, NULL, NULL, 4),
(155921, NULL, 'G3DSA:2.40.50.140:FF:000573', NULL, NULL, 'Aspartyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(155922, NULL, 'G3DSA:3.40.33.10:FF:000132', NULL, NULL, 'AFR700Wp', NULL, NULL, NULL, NULL, NULL, 4),
(155923, NULL, 'G3DSA:2.60.40.60:FF:000485', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155924, NULL, 'G3DSA:3.80.10.10:FF:003646', NULL, NULL, 'Disease resistance protein SUMM2', NULL, NULL, NULL, NULL, NULL, 4),
(155925, NULL, 'G3DSA:3.30.505.10:FF:000010', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(155926, NULL, 'G3DSA:3.80.20.20:FF:000042', NULL, NULL, 'Meiotic expression up-regulated protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(155927, NULL, 'G3DSA:3.40.640.10:FF:000260', NULL, NULL, 'Aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(155928, NULL, 'G3DSA:3.30.200.20:FF:002132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155929, NULL, 'G3DSA:2.130.10.10:FF:002281', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit TRM82', NULL, NULL, NULL, NULL, NULL, 4),
(155930, NULL, 'G3DSA:3.30.420.40:FF:001053', NULL, NULL, 'Probable actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(155931, NULL, 'G3DSA:1.10.238.10:FF:001194', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(155932, NULL, 'G3DSA:2.60.40.10:FF:005170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155933, NULL, 'G3DSA:3.30.870.10:FF:000026', NULL, NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(155934, NULL, 'G3DSA:1.20.1250.20:FF:001059', NULL, NULL, 'Major facilitator superfamily MFS_1', NULL, NULL, NULL, NULL, NULL, 4),
(155935, NULL, 'G3DSA:1.10.560.10:FF:000099', NULL, NULL, '60 kDa chaperonin 2', NULL, NULL, NULL, NULL, NULL, 4),
(155936, NULL, 'G3DSA:3.30.450.20:FF:000031', NULL, NULL, 'Nuclear receptor coactivator', NULL, NULL, NULL, NULL, NULL, 4),
(155937, NULL, 'G3DSA:3.30.160.60:FF:005383', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155938, NULL, 'G3DSA:3.40.630.10:FF:000214', NULL, NULL, 'Acetylornithine deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(155939, NULL, 'G3DSA:2.60.120.340:FF:000023', NULL, NULL, 'Nucleoplasmin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(155940, NULL, 'G3DSA:3.90.1490.10:FF:000016', NULL, NULL, 'Diphthine--ammonia ligase', NULL, NULL, NULL, NULL, NULL, 4),
(155941, NULL, 'G3DSA:2.170.270.10:FF:000081', NULL, NULL, 'GD10068', NULL, NULL, NULL, NULL, NULL, 4),
(155942, NULL, 'G3DSA:3.10.20.90:FF:000740', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155943, NULL, 'G3DSA:2.60.40.10:FF:004770', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155944, NULL, 'G3DSA:3.40.50.2000:FF:000890', NULL, NULL, 'N-acetylglucosaminyl-phosphatidylinositol biosynthetic protein', NULL, NULL, NULL, NULL, NULL, 4),
(155945, NULL, 'G3DSA:3.30.160.60:FF:006001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155946, NULL, 'G3DSA:3.90.550.10:FF:000691', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155947, NULL, 'G3DSA:1.10.472.130:FF:000079', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(155948, NULL, 'G3DSA:1.10.10.10:FF:000591', NULL, NULL, 'Archaeal heat shock regulator, ArsR family', NULL, NULL, NULL, NULL, NULL, 4),
(155949, NULL, 'G3DSA:1.10.510.10:FF:003822', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155950, NULL, 'G3DSA:2.60.40.10:FF:004219', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155951, NULL, 'G3DSA:2.60.120.380:FF:000006', NULL, NULL, 'Calpain 10', NULL, NULL, NULL, NULL, NULL, 4),
(155952, NULL, 'G3DSA:2.30.30.380:FF:000002', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(155953, NULL, 'G3DSA:1.20.120.1080:FF:000110', NULL, NULL, 'Putative ATP-dependent RNA helicase DHX40', NULL, NULL, NULL, NULL, NULL, 4),
(155954, NULL, 'G3DSA:3.90.190.10:FF:000157', NULL, NULL, 'Protein-tyrosine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(155955, NULL, 'G3DSA:6.10.250.3310:FF:000004', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(155956, NULL, 'G3DSA:2.60.120.970:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155957, NULL, 'G3DSA:2.60.40.10:FF:005967', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155958, NULL, 'G3DSA:3.40.250.10:FF:000011', NULL, NULL, 'Dual specificity phosphatase 7', NULL, NULL, NULL, NULL, NULL, 4),
(155959, NULL, 'G3DSA:3.40.50.620:FF:000640', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155960, NULL, 'G3DSA:2.40.30.110:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155961, NULL, 'G3DSA:2.10.25.10:FF:000797', NULL, NULL, 'Thrombomodulin', NULL, NULL, NULL, NULL, NULL, 4),
(155962, NULL, 'G3DSA:3.40.50.10140:FF:000037', NULL, NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', NULL, NULL, NULL, NULL, NULL, 4),
(155963, NULL, 'G3DSA:1.25.40.10:FF:002864', NULL, NULL, 'Fanconi anemia group G protein', NULL, NULL, NULL, NULL, NULL, 4),
(155964, NULL, 'G3DSA:1.20.920.30:FF:000030', NULL, NULL, 'Putative dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(155965, NULL, 'G3DSA:3.40.50.1220:FF:000077', NULL, NULL, 'NAD-dependent deacetylase, Sir2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(155966, NULL, 'G3DSA:3.40.50.300:FF:006951', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155967, NULL, 'G3DSA:3.30.40.10:FF:000256', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(155968, NULL, 'G3DSA:3.90.110.10:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155969, NULL, 'G3DSA:3.40.850.10:FF:000540', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(155970, NULL, 'G3DSA:3.30.70.330:FF:002144', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155971, NULL, 'G3DSA:2.40.70.10:FF:000383', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155972, NULL, 'G3DSA:1.20.1250.20:FF:000210', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(155973, NULL, 'G3DSA:3.40.710.10:FF:000035', NULL, NULL, 'Membrane peptidoglycan carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(155974, NULL, 'G3DSA:2.60.120.10:FF:000012', NULL, NULL, 'neuropathy target esterase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(155975, NULL, 'G3DSA:2.60.40.790:FF:000036', NULL, NULL, 'Heat Shock Protein', NULL, NULL, NULL, NULL, NULL, 4),
(155976, NULL, 'G3DSA:3.30.420.40:FF:000996', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(155977, NULL, 'G3DSA:3.40.50.1820:FF:001797', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(155978, NULL, 'G3DSA:2.130.10.10:FF:000712', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(155979, NULL, 'G3DSA:1.20.1050.10:FF:000001', NULL, NULL, 'Chloride intracellular channel 2', NULL, NULL, NULL, NULL, NULL, 4),
(155980, NULL, 'G3DSA:2.130.10.10:FF:002842', NULL, NULL, 'FG-nucleoporin', NULL, NULL, NULL, NULL, NULL, 4),
(155981, NULL, 'G3DSA:1.10.472.80:FF:000269', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155982, NULL, 'G3DSA:1.50.10.20:FF:000036', NULL, NULL, 'Protein farnesyltransferase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(155983, NULL, 'G3DSA:2.60.40.10:FF:002533', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(155984, NULL, 'G3DSA:1.10.437.10:FF:000032', NULL, NULL, 'Bcl-2-related ovarian killer protein homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(155985, NULL, 'G3DSA:1.10.10.10:FF:000602', NULL, NULL, 'MurR/RpiR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(155986, NULL, 'G3DSA:3.40.50.300:FF:007019', NULL, NULL, 'Iron (III) ABC transporter ATP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(155987, NULL, 'G3DSA:3.40.50.2300:FF:000766', NULL, NULL, 'Argonaute 2, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(155988, NULL, 'G3DSA:1.20.1250.20:FF:000098', NULL, NULL, 'D-xylose transporter XylE', NULL, NULL, NULL, NULL, NULL, 4),
(155989, NULL, 'G3DSA:1.20.1250.20:FF:002352', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(155990, NULL, 'G3DSA:2.40.110.10:FF:000049', NULL, NULL, 'GD25894', NULL, NULL, NULL, NULL, NULL, 4),
(155991, NULL, 'G3DSA:2.10.25.10:FF:000111', NULL, NULL, 'Protein kinase C-binding protein NELL2', NULL, NULL, NULL, NULL, NULL, 4),
(155992, NULL, 'G3DSA:1.10.510.10:FF:004441', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(155993, NULL, 'G3DSA:1.10.150.20:FF:000184', NULL, NULL, 'DNA excision repair protein ERCC-1', NULL, NULL, NULL, NULL, NULL, 4),
(155994, NULL, 'G3DSA:3.90.180.10:FF:000095', NULL, NULL, 'Chlorophyll synthesis pathway protein BchC', NULL, NULL, NULL, NULL, NULL, 4),
(155995, NULL, 'G3DSA:3.30.70.1170:FF:000008', NULL, NULL, 'Proliferating-cell nucleolar antigen p120', NULL, NULL, NULL, NULL, NULL, 4),
(155996, NULL, 'G3DSA:1.10.10.750:FF:000011', NULL, NULL, 'TBC1 domain family member 2B-like', NULL, NULL, NULL, NULL, NULL, 4),
(155997, NULL, 'G3DSA:2.160.20.70:FF:000044', NULL, NULL, 'Adenylyl cyclase-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(155998, NULL, 'G3DSA:3.40.50.720:FF:000664', NULL, NULL, 'GDP-mannose 6-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(155999, NULL, 'G3DSA:3.30.450.20:FF:000610', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156000, NULL, 'G3DSA:1.10.1130.10:FF:000004', NULL, NULL, 'Cytochrome c-552', NULL, NULL, NULL, NULL, NULL, 4),
(156001, NULL, 'G3DSA:2.30.42.10:FF:000026', NULL, NULL, 'Golgi reassembly stacking protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(156002, NULL, 'G3DSA:3.40.1280.10:FF:000057', NULL, NULL, 'tRNA (cytidine(34)-2''-O)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(156003, NULL, 'G3DSA:2.60.40.60:FF:000827', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156004, NULL, 'G3DSA:1.20.120.330:FF:000030', NULL, NULL, 'Probable mannitol operon repressor', NULL, NULL, NULL, NULL, NULL, 4),
(156005, NULL, 'G3DSA:2.170.150.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156006, NULL, 'G3DSA:3.30.420.110:FF:000062', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(156007, NULL, 'G3DSA:3.30.70.330:FF:000014', NULL, NULL, 'RNA-binding motif, single-stranded-interacting protein 3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(156008, NULL, 'G3DSA:3.40.50.720:FF:000321', NULL, NULL, 'Chloroplast stem-loop binding protein of 41 kDa a, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(156009, NULL, 'G3DSA:3.40.50.2300:FF:001042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156010, NULL, 'G3DSA:3.30.9.100:FF:000004', NULL, NULL, 'Squalene monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(156011, NULL, 'G3DSA:3.80.10.10:FF:004046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156012, NULL, 'G3DSA:3.40.190.290:FF:000121', NULL, NULL, 'Probable nitrogen assimilation transcriptional activator', NULL, NULL, NULL, NULL, NULL, 4),
(156013, NULL, 'G3DSA:1.25.10.10:FF:000895', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(156014, NULL, 'G3DSA:3.50.30.80:FF:000005', NULL, NULL, 'Dihydroxy-acid dehydratase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(156015, NULL, 'G3DSA:3.30.230.10:FF:000282', NULL, NULL, 'Translation elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(156016, NULL, 'G3DSA:3.40.1810.10:FF:000076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156017, NULL, 'G3DSA:2.70.150.10:FF:000242', NULL, NULL, 'ACR086Cp', NULL, NULL, NULL, NULL, NULL, 4),
(156018, NULL, 'G3DSA:2.60.40.60:FF:001103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156019, NULL, 'G3DSA:3.50.50.60:FF:000574', NULL, NULL, 'Putative polyamine oxidase 5 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(156020, NULL, 'G3DSA:2.10.25.10:FF:000454', NULL, NULL, 'Laminin subunit alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(156021, NULL, 'G3DSA:3.40.190.10:FF:000623', NULL, NULL, 'Putative chorismate mutase/prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(156022, NULL, 'G3DSA:2.130.10.10:FF:003461', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(156023, NULL, 'G3DSA:2.60.40.10:FF:002876', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156024, NULL, 'G3DSA:3.30.460.10:FF:000091', NULL, NULL, 'DNA polymerase lambda subunit', NULL, NULL, NULL, NULL, NULL, 4),
(156025, NULL, 'G3DSA:1.25.40.10:FF:000846', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(156026, NULL, 'G3DSA:1.20.58.220:FF:000008', NULL, NULL, 'Phosphate-specific transport system accessory protein PhoU homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(156027, NULL, 'G3DSA:3.40.50.700:FF:000001', NULL, NULL, 'Hydrogenase 2 small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(156028, NULL, 'G3DSA:3.40.850.10:FF:000197', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156029, NULL, 'G3DSA:3.30.1240.10:FF:000006', NULL, NULL, 'HAD superfamily hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(156030, NULL, 'G3DSA:3.30.70.330:FF:002487', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156031, NULL, 'G3DSA:3.30.497.10:FF:000181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156032, NULL, 'G3DSA:3.40.525.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156033, NULL, 'G3DSA:2.130.10.30:FF:000033', NULL, NULL, 'RCC1 and BTB domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(156034, NULL, 'G3DSA:2.60.40.10:FF:003152', NULL, NULL, 'Tyrosine-protein phosphatase 69D', NULL, NULL, NULL, NULL, NULL, 4),
(156035, NULL, 'G3DSA:2.60.40.1120:FF:000026', NULL, NULL, 'Carboxypeptidase D', NULL, NULL, NULL, NULL, NULL, 4),
(156036, NULL, 'G3DSA:1.20.1250.20:FF:001391', NULL, NULL, 'monocarboxylate transporter 13-like', NULL, NULL, NULL, NULL, NULL, 4),
(156037, NULL, 'G3DSA:3.30.420.380:FF:000002', NULL, NULL, 'Type II secretion system protein L', NULL, NULL, NULL, NULL, NULL, 4),
(156038, NULL, 'G3DSA:1.25.10.10:FF:001171', NULL, NULL, 'Unplaced genomic scaffold supercont1.20, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(156039, NULL, 'G3DSA:2.40.10.10:FF:000621', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156040, NULL, 'G3DSA:2.60.120.200:FF:000228', NULL, NULL, 'Beta-glucan synthesis-associated protein KRE6', NULL, NULL, NULL, NULL, NULL, 4),
(156041, NULL, 'G3DSA:3.40.50.410:FF:000015', NULL, NULL, 'General transcription factor IIH subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(156042, NULL, 'G3DSA:3.40.50.300:FF:003860', NULL, NULL, 'Si:rp71-7l19.2', NULL, NULL, NULL, NULL, NULL, 4),
(156043, NULL, 'G3DSA:3.90.1180.10:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156044, NULL, 'G3DSA:1.10.8.140:FF:000010', NULL, NULL, 'Uncharacterized protein D2005.3', NULL, NULL, NULL, NULL, NULL, 4),
(156045, NULL, 'G3DSA:1.20.900.10:FF:000040', NULL, NULL, 'Trio, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(156046, NULL, 'G3DSA:3.40.50.2300:FF:000081', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(156047, NULL, 'G3DSA:1.10.510.10:FF:001113', NULL, NULL, 'Casein kinase 1 gamma 2', NULL, NULL, NULL, NULL, NULL, 4),
(156048, NULL, 'G3DSA:3.40.50.300:FF:000437', NULL, NULL, 'ATP-dependent DNA helicase DinG', NULL, NULL, NULL, NULL, NULL, 4),
(156049, NULL, 'G3DSA:1.25.40.20:FF:000489', NULL, NULL, 'Ankyrin 2', NULL, NULL, NULL, NULL, NULL, 4),
(156050, NULL, 'G3DSA:3.10.450.50:FF:000016', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(156051, NULL, 'G3DSA:2.10.230.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156052, NULL, 'G3DSA:2.60.40.150:FF:000187', NULL, NULL, 'Protein C2-DOMAIN ABA-RELATED 10', NULL, NULL, NULL, NULL, NULL, 4),
(156053, NULL, 'G3DSA:3.30.2130.30:FF:000009', NULL, NULL, 'Probable tRNA sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(156054, NULL, 'G3DSA:1.20.5.2950:FF:000005', NULL, NULL, 'Vacuolar ATP synthase subunit G, putative', NULL, NULL, NULL, NULL, NULL, 4),
(156055, NULL, 'G3DSA:1.10.287.70:FF:000206', NULL, NULL, 'Voltage-dependent T-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(156056, NULL, 'G3DSA:3.40.50.300:FF:002909', NULL, NULL, 'GPN-loop GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(156057, NULL, 'G3DSA:2.130.10.10:FF:001331', NULL, NULL, 'Actin-related protein 2/3 complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(156058, NULL, 'G3DSA:2.130.10.10:FF:003803', NULL, NULL, 'Meiotic fizzy-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(156059, NULL, 'G3DSA:1.25.70.10:FF:000095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156060, NULL, 'G3DSA:1.20.1440.120:FF:000001', NULL, NULL, 'DNA repair protein RecO', NULL, NULL, NULL, NULL, NULL, 4),
(156061, NULL, 'G3DSA:3.80.10.10:FF:001735', NULL, NULL, 'Leucine_Rich_repeat/Leucine_Rich_Repeat/Leucine_R ich_repeats_(2_copies)_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(156062, NULL, 'G3DSA:3.30.565.10:FF:000019', NULL, NULL, 'Virulence sensor histidine kinase PhoQ', NULL, NULL, NULL, NULL, NULL, 4),
(156063, NULL, 'G3DSA:1.10.510.10:FF:000731', NULL, NULL, 'Serine/threonine-protein kinase RCK1', NULL, NULL, NULL, NULL, NULL, 4),
(156064, NULL, 'G3DSA:3.40.50.300:FF:001730', NULL, NULL, 'Multidrug ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(156065, NULL, 'G3DSA:3.30.160.880:FF:000002', NULL, NULL, 'Cell division protein ZapA', NULL, NULL, NULL, NULL, NULL, 4),
(156066, NULL, 'G3DSA:3.10.100.10:FF:000265', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156067, NULL, 'G3DSA:1.20.1070.10:FF:001525', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156068, NULL, 'G3DSA:1.10.533.10:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156069, NULL, 'G3DSA:1.10.630.10:FF:000330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156070, NULL, 'G3DSA:1.10.510.10:FF:004109', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156071, NULL, 'G3DSA:1.10.730.10:FF:000039', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(156072, NULL, 'G3DSA:1.25.40.20:FF:000944', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156073, NULL, 'G3DSA:2.60.40.60:FF:000266', NULL, NULL, 'Cadherin 23', NULL, NULL, NULL, NULL, NULL, 4),
(156074, NULL, 'G3DSA:1.25.40.20:FF:001344', NULL, NULL, 'Ankyrin repeat and MYND domain-containing 2b', NULL, NULL, NULL, NULL, NULL, 4),
(156075, NULL, 'G3DSA:1.10.1060.10:FF:000009', NULL, NULL, 'Glutamate synthase 1 [NADH] chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(156076, NULL, 'G3DSA:3.40.225.10:FF:000031', NULL, NULL, 'Hu li tai shao-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(156077, NULL, 'G3DSA:3.30.40.10:FF:002150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156078, NULL, 'G3DSA:3.40.50.150:FF:000920', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156079, NULL, 'G3DSA:1.25.40.10:FF:000048', NULL, NULL, 'Cell cycle control protein', NULL, NULL, NULL, NULL, NULL, 4),
(156080, NULL, 'G3DSA:3.90.226.10:FF:000325', NULL, NULL, 'Retinol binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(156081, NULL, 'G3DSA:3.80.10.10:FF:004265', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156082, NULL, 'G3DSA:2.60.40.10:FF:003713', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156083, NULL, 'G3DSA:2.130.10.10:FF:004422', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156084, NULL, 'G3DSA:1.10.405.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156085, NULL, 'G3DSA:1.20.5.170:FF:000191', NULL, NULL, 'FOS-like antigen 1b', NULL, NULL, NULL, NULL, NULL, 4),
(156086, NULL, 'G3DSA:1.25.40.10:FF:004319', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156087, NULL, 'G3DSA:1.10.260.40:FF:000057', NULL, NULL, 'XRE family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(156088, NULL, 'G3DSA:3.40.190.10:FF:000062', NULL, NULL, 'Putrescine-binding periplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(156089, NULL, 'G3DSA:3.40.50.1820:FF:000493', NULL, NULL, 'Protein CBG12424', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(156090, NULL, 'G3DSA:3.30.160.190:FF:000003', NULL, NULL, 'NADH dehydrogenase [ubiquinone] iron-sulfur protein 4, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(156091, NULL, 'G3DSA:1.25.40.20:FF:001220', NULL, NULL, 'No mechanoreceptor potential C, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(156092, NULL, 'G3DSA:3.40.50.300:FF:002567', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(156093, NULL, 'G3DSA:3.40.50.1100:FF:000058', NULL, NULL, 'Cysteine synthase B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(156094, NULL, 'G3DSA:1.10.287.380:FF:000007', NULL, NULL, 'Valine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(156095, NULL, 'G3DSA:3.40.50.880:FF:000122', NULL, NULL, '4-methyl-5(B-hydroxyethyl)-thiazol monophosphate biosynthesis enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(156096, NULL, 'G3DSA:2.40.50.140:FF:000792', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156097, NULL, 'G3DSA:3.40.50.1000:FF:000359', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(156098, NULL, 'G3DSA:3.30.810.10:FF:000028', NULL, NULL, 'RpkA', NULL, NULL, NULL, NULL, NULL, 4),
(156099, NULL, 'G3DSA:2.30.42.10:FF:000369', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(156100, NULL, 'G3DSA:1.20.5.510:FF:000006', NULL, NULL, 'Photosystem II psbX protein', NULL, NULL, NULL, NULL, NULL, 4),
(156101, NULL, 'G3DSA:1.25.40.10:FF:004994', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156102, NULL, 'G3DSA:2.170.150.20:FF:000030', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156103, NULL, 'G3DSA:3.40.50.2300:FF:000423', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156104, NULL, 'G3DSA:2.40.420.20:FF:000031', NULL, NULL, 'Efflux transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(156105, NULL, 'G3DSA:3.30.565.10:FF:000351', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(156106, NULL, 'G3DSA:1.10.8.590:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156107, NULL, 'G3DSA:3.30.200.20:FF:000552', NULL, NULL, 'Cell division protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(156108, NULL, 'G3DSA:3.40.140.20:FF:000005', NULL, NULL, 'Bifunctional purine biosynthesis protein PurH', NULL, NULL, NULL, NULL, NULL, 4),
(156109, NULL, 'G3DSA:1.20.120.610:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156110, NULL, 'G3DSA:3.80.10.10:FF:003989', NULL, NULL, 'Si:dkey-156k2.3', NULL, NULL, NULL, NULL, NULL, 4),
(156111, NULL, 'G3DSA:3.30.1120.160:FF:000001', NULL, NULL, 'GTPase-activating Rap/Ran-GAP domain-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(156112, NULL, 'G3DSA:3.40.50.620:FF:000061', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(156113, NULL, 'G3DSA:3.30.70.330:FF:002829', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156114, NULL, 'G3DSA:3.40.50.1780:FF:000003', NULL, NULL, 'Periplasmic [Fe] hydrogenase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(156115, NULL, 'G3DSA:2.160.20.110:FF:000001', NULL, NULL, 'CXC-rich protein', NULL, NULL, NULL, NULL, NULL, 4),
(156116, NULL, 'G3DSA:3.30.500.10:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156117, NULL, 'G3DSA:3.40.462.10:FF:000003', NULL, NULL, 'Cholesterol oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(156118, NULL, 'G3DSA:3.90.226.10:FF:000106', NULL, NULL, 'Possible enoyl-CoA hydratase echA4', NULL, NULL, NULL, NULL, NULL, 4),
(156119, NULL, 'G3DSA:3.40.1190.10:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156120, NULL, 'G3DSA:3.40.50.1820:FF:001454', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156121, NULL, 'G3DSA:1.10.1670.10:FF:000039', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(156122, NULL, 'G3DSA:1.10.1300.10:FF:000040', NULL, NULL, 'cGMP-specific 3'',5''-cyclic phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(156123, NULL, 'G3DSA:1.25.40.20:FF:001905', NULL, NULL, 'Molting protein MLT-4', NULL, NULL, NULL, NULL, NULL, 4),
(156124, NULL, 'G3DSA:1.25.40.10:FF:001560', NULL, NULL, 'Tetratricopeptide repeat domain 21A', NULL, NULL, NULL, NULL, NULL, 4),
(156125, NULL, 'G3DSA:3.40.50.1240:FF:000072', NULL, NULL, 'Histidine phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(156126, NULL, 'G3DSA:2.20.25.90:FF:000011', NULL, NULL, 'Dimethyl sulfoxide reductase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(156127, NULL, 'G3DSA:3.30.70.260:FF:000190', NULL, NULL, 'Glycine cleavage system transcriptional repressor GcvR', NULL, NULL, NULL, NULL, NULL, 4),
(156128, NULL, 'G3DSA:3.40.50.300:FF:007238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156129, NULL, 'G3DSA:3.40.50.300:FF:003528', NULL, NULL, 'CTP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(156130, NULL, 'G3DSA:2.40.70.10:FF:000506', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156131, NULL, 'G3DSA:3.30.70.330:FF:003105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156132, NULL, 'G3DSA:3.40.50.10860:FF:000034', NULL, NULL, 'monofunctional C1-tetrahydrofolate synthase, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(156133, NULL, 'G3DSA:3.90.550.50:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156134, NULL, 'G3DSA:3.10.20.90:FF:000285', NULL, NULL, 'Putative ubiquitin/ribosomal protein S27a', NULL, NULL, NULL, NULL, NULL, 4),
(156135, NULL, 'G3DSA:1.25.40.10:FF:005270', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156136, NULL, 'G3DSA:3.80.10.10:FF:001516', NULL, NULL, 'Lap1, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(156137, NULL, 'G3DSA:3.30.920.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156138, NULL, 'G3DSA:3.40.50.1980:FF:000057', NULL, NULL, 'Similar to ferrichrome ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(156139, NULL, 'G3DSA:1.10.10.10:FF:001895', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156140, NULL, 'G3DSA:3.20.20.100:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156141, NULL, 'G3DSA:1.10.418.20:FF:000002', NULL, NULL, 'sentrin-specific protease 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(156142, NULL, 'G3DSA:1.25.40.340:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156143, NULL, 'G3DSA:2.60.40.640:FF:000019', NULL, NULL, 'Arrestin 3', NULL, NULL, NULL, NULL, NULL, 4),
(156144, NULL, 'G3DSA:2.30.230.10:FF:000044', NULL, NULL, 'Zgc:136383 protein', NULL, NULL, NULL, NULL, NULL, 4),
(156145, NULL, 'G3DSA:3.30.720.50:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156146, NULL, 'G3DSA:1.20.1070.10:FF:001868', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156147, NULL, 'G3DSA:2.130.10.10:FF:003129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156148, NULL, 'G3DSA:1.10.10.60:FF:000701', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(156149, NULL, 'G3DSA:3.40.50.300:FF:004821', NULL, NULL, 'SNF2 family N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(156150, NULL, 'G3DSA:3.40.190.10:FF:000860', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156151, NULL, 'G3DSA:3.30.559.10:FF:000185', NULL, NULL, 'Brassinosteroid-related acyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(156152, NULL, 'G3DSA:1.20.1070.10:FF:001744', NULL, NULL, 'Zg01', NULL, NULL, NULL, NULL, NULL, 4),
(156153, NULL, 'G3DSA:1.10.132.50:FF:000004', NULL, NULL, 'V-type proton ATPase subunit d 1', NULL, NULL, NULL, NULL, NULL, 4),
(156154, NULL, 'G3DSA:3.30.160.60:FF:000616', NULL, NULL, 'PR domain zinc finger protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(156155, NULL, 'G3DSA:1.25.40.770:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156156, NULL, 'G3DSA:2.120.10.80:FF:000104', NULL, NULL, 'Multiple EGF like domains 8', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(156157, NULL, 'G3DSA:3.30.70.1150:FF:000002', NULL, NULL, 'Nickel-responsive regulator', NULL, NULL, NULL, NULL, NULL, 4),
(156158, NULL, 'G3DSA:3.40.47.10:FF:000310', NULL, NULL, 'Polyketide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(156159, NULL, 'G3DSA:3.30.450.70:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156160, NULL, 'G3DSA:3.30.70.330:FF:001868', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156161, NULL, 'G3DSA:1.20.1070.10:FF:002144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156162, NULL, 'G3DSA:3.40.50.200:FF:000177', NULL, NULL, 'Putative subtilisin proteinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(156163, NULL, 'G3DSA:3.30.70.330:FF:002268', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156164, NULL, 'G3DSA:1.10.418.40:FF:000008', NULL, NULL, 'Vacuolar sorting protein', NULL, NULL, NULL, NULL, NULL, 4),
(156165, NULL, 'G3DSA:2.40.30.170:FF:000004', NULL, NULL, 'Auxiliary transport protein, membrane fusion protein family', NULL, NULL, NULL, NULL, NULL, 4),
(156166, NULL, 'G3DSA:1.20.1270.60:FF:000083', NULL, NULL, 'Rho guanyl nucleotide exchange factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(156167, NULL, 'G3DSA:2.120.10.30:FF:000314', NULL, NULL, 'NHL repeat domain lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(156168, NULL, 'G3DSA:3.40.50.10490:FF:000131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156169, NULL, 'G3DSA:3.30.160.60:FF:002668', NULL, NULL, 'Paternally expressed 3', NULL, NULL, NULL, NULL, NULL, 4),
(156170, NULL, 'G3DSA:3.30.1120.10:FF:000059', NULL, NULL, 'Probable sulfatase atsG', NULL, NULL, NULL, NULL, NULL, 4),
(156171, NULL, 'G3DSA:2.40.160.110:FF:000045', NULL, NULL, 'Lysosomal-associated membrane protein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(156172, NULL, 'G3DSA:1.10.357.100:FF:000002', NULL, NULL, 'ADL286Wp', NULL, NULL, NULL, NULL, NULL, 4),
(156173, NULL, 'G3DSA:1.10.1220.10:FF:000005', NULL, NULL, 'Bifunctional antitoxin/transcriptional repressor RelB', NULL, NULL, NULL, NULL, NULL, 4),
(156174, NULL, 'G3DSA:2.130.10.10:FF:002730', NULL, NULL, 'Bardet-Biedl syndrome 1 protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(156175, NULL, 'G3DSA:1.10.287.1260:FF:000002', NULL, NULL, 'Potassium efflux system KefA', NULL, NULL, NULL, NULL, NULL, 4),
(156176, NULL, 'G3DSA:1.10.10.60:FF:000095', NULL, NULL, 'LIM homeobox transcription factor 1 beta', NULL, NULL, NULL, NULL, NULL, 4),
(156177, NULL, 'G3DSA:1.10.510.10:FF:002075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156178, NULL, 'G3DSA:2.40.160.120:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156179, NULL, 'G3DSA:2.60.40.10:FF:004843', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156180, NULL, 'G3DSA:3.40.50.300:FF:006772', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156181, NULL, 'G3DSA:3.80.10.10:FF:000072', NULL, NULL, 'protein scribble homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(156182, NULL, 'G3DSA:1.10.510.10:FF:004199', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156183, NULL, 'G3DSA:3.30.70.330:FF:003122', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156184, NULL, 'G3DSA:2.70.150.10:FF:000118', NULL, NULL, 'Copper-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(156185, NULL, 'G3DSA:3.40.50.720:FF:002154', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(156186, NULL, 'G3DSA:3.90.70.200:FF:000012', NULL, NULL, 'GM16155', NULL, NULL, NULL, NULL, NULL, 4),
(156187, NULL, 'G3DSA:2.30.30.550:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156188, NULL, 'G3DSA:3.30.420.40:FF:001007', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(156189, NULL, 'G3DSA:3.10.110.10:FF:000182', NULL, NULL, 'UBiquitin Conjugating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(156190, NULL, 'G3DSA:3.40.50.150:FF:001095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156191, NULL, 'G3DSA:1.20.20.10:FF:000018', NULL, NULL, 'H+transporting two-sector ATPase C subunit', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(156192, NULL, 'G3DSA:1.20.120.350:FF:000199', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156193, NULL, 'G3DSA:3.80.10.10:FF:001174', NULL, NULL, 'Si:ch211-156p11.1', NULL, NULL, NULL, NULL, NULL, 4),
(156194, NULL, 'G3DSA:3.40.1080.10:FF:000019', NULL, NULL, 'CoA transferase CarA2', NULL, NULL, NULL, NULL, NULL, 4),
(156195, NULL, 'G3DSA:3.40.50.300:FF:005670', NULL, NULL, 'ATP-dependent nuclease subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(156196, NULL, 'G3DSA:1.25.40.10:FF:000374', NULL, NULL, 'Mitochondrial proteins import receptor', NULL, NULL, NULL, NULL, NULL, 4),
(156197, NULL, 'G3DSA:3.80.10.10:FF:002163', NULL, NULL, 'Leucine Rich repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(156198, NULL, 'G3DSA:3.30.160.60:FF:001566', NULL, NULL, 'Zinc finger protein 263', NULL, NULL, NULL, NULL, NULL, 4),
(156199, NULL, 'G3DSA:3.40.50.720:FF:001491', NULL, NULL, 'Ornithine cyclodeaminase', NULL, NULL, NULL, NULL, NULL, 4),
(156200, NULL, 'G3DSA:1.20.1250.10:FF:000027', NULL, NULL, 'Cardiotrophin 1', NULL, NULL, NULL, NULL, NULL, 4),
(156201, NULL, 'G3DSA:3.40.190.10:FF:000359', NULL, NULL, 'Putative molybdopterin biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(156202, NULL, 'G3DSA:3.60.40.10:FF:000030', NULL, NULL, 'Protein phosphatase, Mg2+/Mn2+-dependent 1D', NULL, NULL, NULL, NULL, NULL, 4),
(156203, NULL, 'G3DSA:1.25.40.10:FF:004556', NULL, NULL, 'Protein NPGR1', NULL, NULL, NULL, NULL, NULL, 4),
(156204, NULL, 'G3DSA:1.10.418.10:FF:000269', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156205, NULL, 'G3DSA:1.25.10.10:FF:000872', NULL, NULL, 'U3 small nucleolar RNA-associated protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(156206, NULL, 'G3DSA:3.50.50.60:FF:001299', NULL, NULL, 'Glr2871 protein', NULL, NULL, NULL, NULL, NULL, 4),
(156207, NULL, 'G3DSA:3.40.1190.20:FF:000210', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156208, NULL, 'G3DSA:3.40.50.300:FF:004681', NULL, NULL, 'Mitochondrial GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(156209, NULL, 'G3DSA:1.25.10.10:FF:002963', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156210, NULL, 'G3DSA:2.60.120.200:FF:000352', NULL, NULL, 'Concanavalin A-like lectin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(156211, NULL, 'G3DSA:1.10.3430.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156212, NULL, 'G3DSA:3.40.850.10:FF:000034', NULL, NULL, 'Kinesin family member 15', NULL, NULL, NULL, NULL, NULL, 4),
(156213, NULL, 'G3DSA:1.25.40.10:FF:002465', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g13040, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(156214, NULL, 'G3DSA:3.40.50.2300:FF:000457', NULL, NULL, 'Transcriptional regulator, LacI family', NULL, NULL, NULL, NULL, NULL, 4),
(156215, NULL, 'G3DSA:2.130.10.10:FF:004821', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156216, NULL, 'G3DSA:3.40.50.970:FF:000233', NULL, NULL, 'Putative 2-oxoglutarate dehydrogenase E1 component DHKTD1 homolog, mitochondrial-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(156217, NULL, 'G3DSA:3.40.640.10:FF:000434', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156218, NULL, 'G3DSA:3.40.50.1970:FF:000026', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(156219, NULL, 'G3DSA:2.60.40.10:FF:004197', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156220, NULL, 'G3DSA:1.10.472.130:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156221, NULL, 'G3DSA:2.60.120.200:FF:000026', NULL, NULL, 'contactin-associated protein-like 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(156222, NULL, 'G3DSA:3.40.220.10:FF:000003', NULL, NULL, 'O-acetyl-ADP-ribose deacetylase MACROD2', NULL, NULL, NULL, NULL, NULL, 4),
(156223, NULL, 'G3DSA:3.10.129.10:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156224, NULL, 'G3DSA:3.40.50.12780:FF:000110', NULL, NULL, 'Nonribosomal peptide synthase, putative', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(156225, NULL, 'G3DSA:3.30.60.30:FF:000196', NULL, NULL, 'Potamin-1', NULL, NULL, NULL, NULL, NULL, 4),
(156226, NULL, 'G3DSA:3.40.50.1820:FF:001488', NULL, NULL, 'Hydrolase-like protein family', NULL, NULL, NULL, NULL, NULL, 4),
(156227, NULL, 'G3DSA:3.40.30.10:FF:000221', NULL, NULL, 'Glutathione S-transferase rho', NULL, NULL, NULL, NULL, NULL, 4),
(156228, NULL, 'G3DSA:2.60.120.330:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156229, NULL, 'G3DSA:3.30.230.70:FF:000024', NULL, NULL, 'Similar to exosome complex exonuclease RRP41', NULL, NULL, NULL, NULL, NULL, 4),
(156230, NULL, 'G3DSA:3.40.309.10:FF:000024', NULL, NULL, 'Betaine aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(156231, NULL, 'G3DSA:1.10.418.10:FF:000123', NULL, NULL, 'Protein CBR-UNC-53, isoform d', NULL, NULL, NULL, NULL, NULL, 4),
(156232, NULL, 'G3DSA:2.30.18.10:FF:000015', NULL, NULL, 'Transcription initiation factor IIA subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(156233, NULL, 'G3DSA:3.40.50.1980:FF:000029', NULL, NULL, 'Ferrichrome ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(156234, NULL, 'G3DSA:2.60.120.260:FF:000263', NULL, NULL, 'Cellulose synthase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(156235, NULL, 'G3DSA:2.60.40.150:FF:000625', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156236, NULL, 'G3DSA:3.20.20.80:FF:000652', NULL, NULL, 'RP120N2.5 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(156237, NULL, 'G3DSA:3.40.47.10:FF:000170', NULL, NULL, '3-hydroxy-3-methylglutaryl coenzyme A synthase', NULL, NULL, NULL, NULL, NULL, 4),
(156238, NULL, 'G3DSA:3.30.420.40:FF:000783', NULL, NULL, 'YALI0B10934p', NULL, NULL, NULL, NULL, NULL, 4),
(156239, NULL, 'G3DSA:2.130.10.10:FF:000959', NULL, NULL, 'F-box and WD repeat domain containing 9', NULL, NULL, NULL, NULL, NULL, 4),
(156240, NULL, 'G3DSA:1.10.238.10:FF:001014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156241, NULL, 'G3DSA:2.130.10.10:FF:004175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156242, NULL, 'G3DSA:3.40.50.300:FF:005344', NULL, NULL, 'DNA replication ATP-dependent helicase/nuclease DNA2', NULL, NULL, NULL, NULL, NULL, 4),
(156243, NULL, 'G3DSA:1.10.4160.10:FF:000001', NULL, NULL, 'Uracil permease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(156244, NULL, 'G3DSA:3.30.70.1450:FF:000025', NULL, NULL, 'Sulfur deprivation response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(156245, NULL, 'G3DSA:1.10.357.140:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156246, NULL, 'G3DSA:1.10.8.140:FF:000021', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156247, NULL, 'G3DSA:2.10.109.10:FF:000064', NULL, NULL, 'Transcription regulator LexA', NULL, NULL, NULL, NULL, NULL, 4),
(156248, NULL, 'G3DSA:3.60.21.10:FF:000284', NULL, NULL, 'Glr0056 protein', NULL, NULL, NULL, NULL, NULL, 4),
(156249, NULL, 'G3DSA:3.30.930.10:FF:000413', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156250, NULL, 'G3DSA:1.10.620.20:FF:000023', NULL, NULL, 'Heavy-metal transporting P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(156251, NULL, 'G3DSA:2.60.40.60:FF:000856', NULL, NULL, 'Cadherin 26', NULL, NULL, NULL, NULL, NULL, 4),
(156252, NULL, 'G3DSA:2.60.40.1510:FF:000025', NULL, NULL, 'integrin alpha-PS2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(156253, NULL, 'G3DSA:3.10.20.90:FF:000796', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156254, NULL, 'G3DSA:3.90.79.10:FF:000073', NULL, NULL, 'ADP-ribose pyrophosphatase NudF', NULL, NULL, NULL, NULL, NULL, 4),
(156255, NULL, 'G3DSA:2.40.40.20:FF:000002', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(156256, NULL, 'G3DSA:2.40.50.140:FF:000376', NULL, NULL, 'Putative exosome complex component CSL4', NULL, NULL, NULL, NULL, NULL, 4),
(156257, NULL, 'G3DSA:1.10.20.10:FF:000159', NULL, NULL, 'CBF/NF-Y family transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(156258, NULL, 'G3DSA:2.40.50.40:FF:000132', NULL, NULL, 'Signal recognition particle 43 kDa protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(156259, NULL, 'G3DSA:2.60.220.50:FF:000104', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156260, NULL, 'G3DSA:3.40.190.10:FF:000652', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(156261, NULL, 'G3DSA:1.20.140.100:FF:000038', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(156262, NULL, 'G3DSA:3.80.10.10:FF:003944', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156263, NULL, 'G3DSA:3.40.50.1370:FF:000060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156264, NULL, 'G3DSA:3.40.50.150:FF:001302', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156265, NULL, 'G3DSA:2.30.30.140:FF:000301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156266, NULL, 'G3DSA:1.10.486.10:FF:000061', NULL, NULL, 'ATP-dependent DNA helicase srs2', NULL, NULL, NULL, NULL, NULL, 4),
(156267, NULL, 'G3DSA:3.20.110.10:FF:000011', NULL, NULL, 'Lysosomal alpha-mannosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(156268, NULL, 'G3DSA:1.10.238.10:FF:000497', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156269, NULL, 'G3DSA:3.30.70.330:FF:000481', NULL, NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(156270, NULL, 'G3DSA:3.40.1170.20:FF:000001', NULL, NULL, 'tRNA-splicing endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(156271, NULL, 'G3DSA:3.40.50.150:FF:000959', NULL, NULL, 'RNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(156272, NULL, 'G3DSA:3.90.70.10:FF:000906', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(156273, NULL, 'G3DSA:1.25.40.20:FF:001366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156274, NULL, 'G3DSA:2.70.160.11:FF:000013', NULL, NULL, 'Protein arginine N-methyltransferase 1.6', NULL, NULL, NULL, NULL, NULL, 4),
(156275, NULL, 'G3DSA:2.60.15.10:FF:000030', NULL, NULL, 'ATP synthase H+ transporting, F1 complex, delta subunit precursor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(156276, NULL, 'G3DSA:3.30.160.60:FF:004000', NULL, NULL, 'GD24229', NULL, NULL, NULL, NULL, NULL, 4),
(156277, NULL, 'G3DSA:3.10.20.770:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156278, NULL, 'G3DSA:3.40.50.10810:FF:000238', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156279, NULL, 'G3DSA:1.10.10.60:FF:000774', NULL, NULL, 'Homeobox protein NANOG', NULL, NULL, NULL, NULL, NULL, 4),
(156280, NULL, 'G3DSA:2.70.98.10:FF:000108', NULL, NULL, 'Putative alpha-1,2-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(156281, NULL, 'G3DSA:1.20.58.60:FF:000136', NULL, NULL, 'MCF.2 cell line derived transforming sequence like', NULL, NULL, NULL, NULL, NULL, 4),
(156282, NULL, 'G3DSA:2.40.30.10:FF:000347', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(156283, NULL, 'G3DSA:6.10.140.2220:FF:000003', NULL, NULL, 'MYND-type zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(156284, NULL, 'G3DSA:2.130.10.10:FF:005164', NULL, NULL, 'Os02g0796700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(156285, NULL, 'G3DSA:2.170.270.10:FF:000058', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(156286, NULL, 'G3DSA:3.40.50.300:FF:006479', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156287, NULL, 'G3DSA:1.10.418.40:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156288, NULL, 'G3DSA:1.25.40.10:FF:002791', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156289, NULL, 'G3DSA:3.30.160.60:FF:004646', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156290, NULL, 'G3DSA:3.40.50.2000:FF:000811', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(156291, NULL, 'G3DSA:3.30.420.10:FF:000122', NULL, NULL, '3''-5'' exonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(156292, NULL, 'G3DSA:3.30.160.60:FF:002994', NULL, NULL, 'Zinc finger protein 473', NULL, NULL, NULL, NULL, NULL, 4),
(156293, NULL, 'G3DSA:1.10.510.10:FF:000837', NULL, NULL, 'STE family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(156294, NULL, 'G3DSA:1.10.275.20:FF:000001', NULL, NULL, 'carnitine O-palmitoyltransferase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(156295, NULL, 'G3DSA:3.10.50.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156296, NULL, 'G3DSA:3.40.50.300:FF:003427', NULL, NULL, 'DExD/H-box helicase 58', NULL, NULL, NULL, NULL, NULL, 4),
(156297, NULL, 'G3DSA:3.30.470.20:FF:000223', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(156298, NULL, 'G3DSA:3.50.50.60:FF:000517', NULL, NULL, 'Lysine-specific histone demethylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(156299, NULL, 'G3DSA:3.30.70.270:FF:000030', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(156300, NULL, 'G3DSA:1.20.1250.20:FF:000356', NULL, NULL, 'Glycoside-Pentoside-Hexuronide (GPH):Cation Symporter Family', NULL, NULL, NULL, NULL, NULL, 4),
(156301, NULL, 'G3DSA:3.90.190.10:FF:000101', NULL, NULL, 'phosphatidylinositol phosphatase PTPRQ', NULL, NULL, NULL, NULL, NULL, 4),
(156302, NULL, 'G3DSA:2.60.260.20:FF:000154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156303, NULL, 'G3DSA:3.30.565.10:FF:000328', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(156304, NULL, 'G3DSA:1.20.1050.130:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156305, NULL, 'G3DSA:2.60.40.10:FF:003415', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156306, NULL, 'G3DSA:2.130.10.10:FF:004528', NULL, NULL, 'WD domain, Gbeta repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(156307, NULL, 'G3DSA:3.20.20.150:FF:000019', NULL, NULL, 'Probable endonuclease 4', NULL, NULL, NULL, NULL, NULL, 4),
(156308, NULL, 'G3DSA:3.40.718.10:FF:000053', NULL, NULL, 'Isocitrate dehydrogenase [NAD] subunit alpha, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(156309, NULL, 'G3DSA:1.20.120.30:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156310, NULL, 'G3DSA:3.40.50.300:FF:001336', NULL, NULL, 'Dynein heavy chain domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(156311, NULL, 'G3DSA:3.30.43.10:FF:000015', NULL, NULL, 'Carbon monoxide dehydrogenase medium chain', NULL, NULL, NULL, NULL, NULL, 4),
(156312, NULL, 'G3DSA:2.60.40.10:FF:000774', NULL, NULL, 'Hepatitis A virus cellular receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(156313, NULL, 'G3DSA:1.10.10.10:FF:000866', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(156314, NULL, 'G3DSA:2.30.42.10:FF:000122', NULL, NULL, 'Pro-interleukin-16', NULL, NULL, NULL, NULL, NULL, 4),
(156315, NULL, 'G3DSA:2.10.25.10:FF:001657', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(156316, NULL, 'G3DSA:3.30.1370.10:FF:000105', NULL, NULL, 'Protein CBG12765', NULL, NULL, NULL, NULL, NULL, 4),
(156317, NULL, 'G3DSA:3.30.40.10:FF:000008', NULL, NULL, 'Bromodomain containing 1, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(156318, NULL, 'G3DSA:2.130.10.10:FF:001302', NULL, NULL, 'Protein kinase family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(156319, NULL, 'G3DSA:2.60.120.260:FF:000616', NULL, NULL, 'Tail spike protein', NULL, NULL, NULL, NULL, NULL, 4),
(156320, NULL, 'G3DSA:3.40.50.2300:FF:000311', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(156321, NULL, 'G3DSA:3.30.200.20:FF:002531', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156322, NULL, 'G3DSA:3.40.525.10:FF:000037', NULL, NULL, 'CRAL/TRIO, N-terminus family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(156323, NULL, 'G3DSA:3.40.50.2300:FF:001300', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(156324, NULL, 'G3DSA:3.60.130.10:FF:000014', NULL, NULL, 'Gamma-butyrobetaine hydroxylase subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(156325, NULL, 'G3DSA:1.20.1250.20:FF:001458', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(156326, NULL, 'G3DSA:1.10.510.10:FF:002928', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156327, NULL, 'G3DSA:3.30.70.330:FF:000688', NULL, NULL, 'RNA-binding protein 8A-like', NULL, NULL, NULL, NULL, NULL, 4),
(156328, NULL, 'G3DSA:3.40.30.10:FF:000867', NULL, NULL, 'Thioredoxin domain-containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(156329, NULL, 'G3DSA:3.30.470.20:FF:000162', NULL, NULL, 'Blr0101 protein', NULL, NULL, NULL, NULL, NULL, 4),
(156330, NULL, 'G3DSA:2.30.40.10:FF:000140', NULL, NULL, 'Amidohydrolase domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(156331, NULL, 'G3DSA:3.40.50.720:FF:002480', NULL, NULL, 'Asperfuranone polyketide synthase afoG', NULL, NULL, NULL, NULL, NULL, 4),
(156332, NULL, 'G3DSA:3.80.10.10:FF:003618', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156333, NULL, 'G3DSA:3.30.70.330:FF:002279', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156334, NULL, 'G3DSA:1.20.5.1500:FF:000003', NULL, NULL, 'SET isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(156335, NULL, 'G3DSA:1.10.510.10:FF:000776', NULL, NULL, 'Cdc2-related protein kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(156336, NULL, 'G3DSA:1.20.1070.10:FF:000255', NULL, NULL, 'Allatostatin A receptor', NULL, NULL, NULL, NULL, NULL, 4),
(156337, NULL, 'G3DSA:3.40.366.10:FF:000026', NULL, NULL, 'Fatty acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(156338, NULL, 'G3DSA:3.30.40.10:FF:002251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156339, NULL, 'G3DSA:3.30.540.10:FF:000069', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156340, NULL, 'G3DSA:2.130.10.10:FF:001887', NULL, NULL, 'Chromatin assembly factor 1, subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(156341, NULL, 'G3DSA:1.20.120.160:FF:000001', NULL, NULL, 'Histidine-containing phosphotransfer protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(156342, NULL, 'G3DSA:3.60.10.10:FF:000202', NULL, NULL, 'DNA-(apurinic or apyrimidinic site) lyase', NULL, NULL, NULL, NULL, NULL, 4),
(156343, NULL, 'G3DSA:1.25.10.10:FF:001209', NULL, NULL, 'Tubulin-specific chaperone D', NULL, NULL, NULL, NULL, NULL, 4),
(156344, NULL, 'G3DSA:3.30.1370.10:FF:000044', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(156345, NULL, 'G3DSA:3.40.50.300:FF:002438', NULL, NULL, 'tRNA dimethylallyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(156346, NULL, 'G3DSA:3.30.200.20:FF:000940', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(156347, NULL, 'G3DSA:2.60.40.10:FF:000509', NULL, NULL, 'Immunoglobin superfamily member 21', NULL, NULL, NULL, NULL, NULL, 4),
(156348, NULL, 'G3DSA:2.40.340.10:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156349, NULL, 'G3DSA:1.10.287.70:FF:000009', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(156350, NULL, 'G3DSA:2.60.40.790:FF:000143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156351, NULL, 'G3DSA:3.40.50.720:FF:000237', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(156352, NULL, 'G3DSA:3.30.70.870:FF:000029', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(156353, NULL, 'G3DSA:1.20.1270.60:FF:000111', NULL, NULL, 'YPR148C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(156354, NULL, 'G3DSA:1.25.10.10:FF:000193', NULL, NULL, 'HEAT repeat-containing protein 5A isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(156355, NULL, 'G3DSA:1.10.10.10:FF:001030', NULL, NULL, 'Methionine aminopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(156356, NULL, 'G3DSA:1.10.510.10:FF:004492', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(156357, NULL, 'G3DSA:1.25.40.20:FF:000377', NULL, NULL, 'No mechanoreceptor potential C, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(156358, NULL, 'G3DSA:3.30.920.20:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156359, NULL, 'G3DSA:1.10.275.30:FF:000004', NULL, NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(156360, NULL, 'G3DSA:3.40.350.10:FF:000041', NULL, NULL, 'Intermediate cleaving peptidase 55, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(156361, NULL, 'G3DSA:1.20.120.20:FF:000005', NULL, NULL, 'Apolipoprotein A-IV', NULL, NULL, NULL, NULL, NULL, 4),
(156362, NULL, 'G3DSA:3.40.720.10:FF:000322', NULL, NULL, 'Phosphatidylinositol-glycan biosynthesis, class O protein', NULL, NULL, NULL, NULL, NULL, 4),
(156363, NULL, 'G3DSA:3.40.50.1820:FF:000386', NULL, NULL, 'Probable lipase/esterase LipG', NULL, NULL, NULL, NULL, NULL, 4),
(156364, NULL, 'G3DSA:3.80.10.10:FF:003298', NULL, NULL, 'Si:ch211-197f20.1', NULL, NULL, NULL, NULL, NULL, 4),
(156365, NULL, 'G3DSA:3.30.710.10:FF:000402', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156366, NULL, 'G3DSA:3.30.720.10:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156367, NULL, 'G3DSA:3.40.50.1820:FF:000240', NULL, NULL, 'Alpha/beta-Hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(156368, NULL, 'G3DSA:1.20.120.180:FF:000007', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156369, NULL, 'G3DSA:3.30.40.10:FF:001762', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(156370, NULL, 'G3DSA:3.90.70.80:FF:000028', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(156371, NULL, 'G3DSA:1.20.1250.20:FF:001930', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156372, NULL, 'G3DSA:1.20.1420.30:FF:000013', NULL, NULL, 'Calcium permease family membrane transporter', NULL, NULL, NULL, NULL, NULL, 4),
(156373, NULL, 'G3DSA:1.20.200.10:FF:000003', NULL, NULL, 'Histidine ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(156374, NULL, 'G3DSA:3.30.70.330:FF:002133', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156375, NULL, 'G3DSA:3.40.50.300:FF:005018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156376, NULL, 'G3DSA:3.30.160.60:FF:004585', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156377, NULL, 'G3DSA:3.40.390.10:FF:000307', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156378, NULL, 'G3DSA:3.90.1150.10:FF:000412', NULL, NULL, 'Serine--pyruvate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(156379, NULL, 'G3DSA:2.40.70.10:FF:000439', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156380, NULL, 'G3DSA:1.10.150.210:FF:000002', NULL, NULL, 'Phosphoserine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(156381, NULL, 'G3DSA:1.10.1200.10:FF:000122', NULL, NULL, 'HC-toxin synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(156382, NULL, 'G3DSA:3.40.630.10:FF:000169', NULL, NULL, 'Peptidase M20 domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(156383, NULL, 'G3DSA:1.20.5.1200:FF:000003', NULL, NULL, 'Alpha-tocopherol transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(156384, NULL, 'G3DSA:1.20.58.60:FF:000075', NULL, NULL, 'utrophin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(156385, NULL, 'G3DSA:2.130.10.10:FF:001802', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156386, NULL, 'G3DSA:2.40.50.140:FF:000404', NULL, NULL, 'Lysylphosphatidylglycerol biosynthesis bifunctional protein LysX', NULL, NULL, NULL, NULL, NULL, 4),
(156387, NULL, 'G3DSA:3.30.160.60:FF:002494', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156388, NULL, 'G3DSA:3.40.50.2000:FF:000783', NULL, NULL, 'Granule bound starch synthase', NULL, NULL, NULL, NULL, NULL, 4),
(156389, NULL, 'G3DSA:3.30.70.330:FF:000542', NULL, NULL, 'Putative rnp domain protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(156390, NULL, 'G3DSA:3.30.450.20:FF:000306', NULL, NULL, 'GGDEF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(156391, NULL, 'G3DSA:2.60.40.420:FF:000083', NULL, NULL, 'Plastocyanin', NULL, NULL, NULL, NULL, NULL, 4),
(156392, NULL, 'G3DSA:3.30.70.2280:FF:000004', NULL, NULL, 'DExD-box helicase 21', NULL, NULL, NULL, NULL, NULL, 4),
(156393, NULL, 'G3DSA:3.30.200.20:FF:002385', NULL, NULL, 'AGAP006960-PA', NULL, NULL, NULL, NULL, NULL, 4),
(156394, NULL, 'G3DSA:2.60.120.650:FF:000138', NULL, NULL, 'YALI0C16390p', NULL, NULL, NULL, NULL, NULL, 4),
(156395, NULL, 'G3DSA:3.30.420.40:FF:000518', NULL, NULL, 'Heat shock protein 70 putative', NULL, NULL, NULL, NULL, NULL, 4),
(156396, NULL, 'G3DSA:3.30.460.50:FF:000001', NULL, NULL, 'WGS project CAEQ00000000 data, annotated contig 1888', NULL, NULL, NULL, NULL, NULL, 4),
(156397, NULL, 'G3DSA:1.10.220.10:FF:000057', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(156398, NULL, 'G3DSA:1.10.287.2720:FF:000002', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(156399, NULL, 'G3DSA:3.40.50.300:FF:006507', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156400, NULL, 'G3DSA:3.40.50.720:FF:001698', NULL, NULL, 'GDP-mannose dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(156401, NULL, 'G3DSA:3.30.450.30:FF:000017', NULL, NULL, 'Profilin', NULL, NULL, NULL, NULL, NULL, 4),
(156402, NULL, 'G3DSA:3.40.50.1820:FF:001549', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156403, NULL, 'G3DSA:1.20.58.70:FF:000078', NULL, NULL, 'Syntaxin-7A', NULL, NULL, NULL, NULL, NULL, 4),
(156404, NULL, 'G3DSA:3.90.70.10:FF:000199', NULL, NULL, 'Cysteine proteinases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(156405, NULL, 'G3DSA:1.20.1000.10:FF:000009', NULL, NULL, 'Guanylate nucleotide binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(156406, NULL, 'G3DSA:3.30.450.20:FF:000014', NULL, NULL, 'voltage-dependent calcium channel subunit alpha-2/delta-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(156407, NULL, 'G3DSA:1.20.58.1460:FF:000002', NULL, NULL, 'PaaX domain-containing protein, C-domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(156408, NULL, 'G3DSA:1.10.10.60:FF:000802', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156409, NULL, 'G3DSA:1.20.144.10:FF:000063', NULL, NULL, 'PAP2-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(156410, NULL, 'G3DSA:1.10.150.220:FF:000005', NULL, NULL, 'Protein phosphatase 1 regulatory inhibitor subunit 14D', NULL, NULL, NULL, NULL, NULL, 4),
(156411, NULL, 'G3DSA:3.40.50.1000:FF:000466', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156412, NULL, 'G3DSA:3.40.50.2300:FF:000283', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(156413, NULL, 'G3DSA:1.25.40.180:FF:000274', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156414, NULL, 'G3DSA:2.30.42.10:FF:000268', NULL, NULL, 'DegP protease 7', NULL, NULL, NULL, NULL, NULL, 4),
(156415, NULL, 'G3DSA:3.90.1150.10:FF:000351', NULL, NULL, 'Perosamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(156416, NULL, 'G3DSA:1.10.274.100:FF:000009', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(156417, NULL, 'G3DSA:1.25.40.10:FF:000548', NULL, NULL, 'Tetratricopeptide repeat domain 21A', NULL, NULL, NULL, NULL, NULL, 4),
(156418, NULL, 'G3DSA:1.10.287.690:FF:000027', NULL, NULL, 'DNA polymerase delta subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(156419, NULL, 'G3DSA:2.130.10.10:FF:000459', NULL, NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', NULL, NULL, NULL, NULL, NULL, 4),
(156420, NULL, 'G3DSA:1.25.40.270:FF:000003', NULL, NULL, 'Vacuolar protein sorting-associated protein VTA1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(156421, NULL, 'G3DSA:3.90.70.10:FF:000553', NULL, NULL, 'Probable ubiquitin carboxyl-terminal hydrolase 8', NULL, NULL, NULL, NULL, NULL, 4),
(156422, NULL, 'G3DSA:3.30.160.60:FF:004972', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(156423, NULL, 'G3DSA:3.40.50.2000:FF:000491', NULL, NULL, 'DNA beta-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(156424, NULL, 'G3DSA:3.30.70.330:FF:000834', NULL, NULL, 'RNA binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(156425, NULL, 'G3DSA:3.30.40.10:FF:000273', NULL, NULL, 'E3 ubiquitin-protein ligase RBX1', NULL, NULL, NULL, NULL, NULL, 4),
(156426, NULL, 'G3DSA:1.20.5.110:FF:000010', NULL, NULL, 'Vesicle-associated membrane protein 726', NULL, NULL, NULL, NULL, NULL, 4),
(156427, NULL, 'G3DSA:3.40.50.300:FF:002910', NULL, NULL, 'Dephospho-CoA kinase', NULL, NULL, NULL, NULL, NULL, 4),
(156428, NULL, 'G3DSA:1.20.1250.20:FF:002301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156429, NULL, 'G3DSA:2.30.29.30:FF:001238', NULL, NULL, 'GTPase-activating protein BEM2', NULL, NULL, NULL, NULL, NULL, 4),
(156430, NULL, 'G3DSA:2.20.100.10:FF:000019', NULL, NULL, 'Thrombospondin type 1 domain containing 7A', NULL, NULL, NULL, NULL, NULL, 4),
(156431, NULL, 'G3DSA:1.20.1060.10:FF:000018', NULL, NULL, 'Polq-1', NULL, NULL, NULL, NULL, NULL, 4),
(156432, NULL, 'G3DSA:1.20.950.20:FF:000017', NULL, NULL, 'Quinone-reactive Ni/Fe-hydrogenase B-type cytochrome subunit', NULL, NULL, NULL, NULL, NULL, 4),
(156433, NULL, 'G3DSA:3.40.50.720:FF:000563', NULL, NULL, '3-oxoacyl-acyl carrier protein reductase', NULL, NULL, NULL, NULL, NULL, 4),
(156434, NULL, 'G3DSA:3.30.200.20:FF:001103', NULL, NULL, 'Os08g0514000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(156435, NULL, 'G3DSA:1.20.58.1480:FF:000008', NULL, NULL, 'Lon protease', NULL, NULL, NULL, NULL, NULL, 4),
(156436, NULL, 'G3DSA:2.30.42.10:FF:000622', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156437, NULL, 'G3DSA:3.40.50.300:FF:002764', NULL, NULL, 'Sulfate adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(156438, NULL, 'G3DSA:3.30.70.270:FF:000237', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156439, NULL, 'G3DSA:1.20.1560.10:FF:000130', NULL, NULL, 'ABC transporter B family member 5', NULL, NULL, NULL, NULL, NULL, 4),
(156440, NULL, 'G3DSA:2.130.10.10:FF:004349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156441, NULL, 'G3DSA:3.80.10.10:FF:003798', NULL, NULL, 'Volume-regulated anion channel subunit LRRC8C', NULL, NULL, NULL, NULL, NULL, 4),
(156442, NULL, 'G3DSA:3.30.465.10:FF:000118', NULL, NULL, 'Glr1833 protein', NULL, NULL, NULL, NULL, NULL, 4),
(156443, NULL, 'G3DSA:3.50.50.60:FF:000490', NULL, NULL, 'Phytoene desaturase', NULL, NULL, NULL, NULL, NULL, 4),
(156444, NULL, 'G3DSA:3.80.10.10:FF:004080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156445, NULL, 'G3DSA:3.30.160.60:FF:003483', NULL, NULL, 'Zinc finger and BTB domain-containing 41', NULL, NULL, NULL, NULL, NULL, 4),
(156446, NULL, 'G3DSA:2.40.50.120:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156447, NULL, 'G3DSA:2.60.40.60:FF:001053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156448, NULL, 'G3DSA:2.60.40.10:FF:002926', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(156449, NULL, 'G3DSA:1.10.290.10:FF:000005', NULL, NULL, 'DNA topoisomerase 1A', NULL, NULL, NULL, NULL, NULL, 4),
(156450, NULL, 'G3DSA:2.60.450.10:FF:000008', NULL, NULL, 'Lipopolysaccharide export system protein LptA', NULL, NULL, NULL, NULL, NULL, 4),
(156451, NULL, 'G3DSA:3.40.50.80:FF:000052', NULL, NULL, 'NADH-cytochrome b5 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(156452, NULL, 'G3DSA:2.130.10.10:FF:000813', NULL, NULL, 'F-box and WD repeat domain containing 10', NULL, NULL, NULL, NULL, NULL, 4),
(156453, NULL, 'G3DSA:2.60.120.10:FF:000141', NULL, NULL, 'Sulfate transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(156454, NULL, 'G3DSA:3.40.50.2300:FF:001385', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156455, NULL, 'G3DSA:3.30.950.10:FF:000004', NULL, NULL, 'Diphthine synthase putative', NULL, NULL, NULL, NULL, NULL, 4),
(156456, NULL, 'G3DSA:3.80.10.10:FF:001674', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(156457, NULL, 'G3DSA:3.30.200.20:FF:000440', NULL, NULL, 'CMGC/DYRK/PRP4 protein kinase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(156458, NULL, 'G3DSA:1.25.40.10:FF:000874', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g60770', NULL, NULL, NULL, NULL, NULL, 4),
(156459, NULL, 'G3DSA:1.20.1070.10:FF:000581', NULL, NULL, 'octopamine receptor Oamb isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(156460, NULL, 'G3DSA:3.20.20.80:FF:000034', NULL, NULL, 'Solute carrier family 3 member 1', NULL, NULL, NULL, NULL, NULL, 4),
(156461, NULL, 'G3DSA:3.40.50.300:FF:005170', NULL, NULL, 'Torsin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(156462, NULL, 'G3DSA:3.90.1580.10:FF:000023', NULL, NULL, 'AGAP013122-PA', NULL, NULL, NULL, NULL, NULL, 4),
(156463, NULL, 'G3DSA:1.25.10.10:FF:002019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156464, NULL, 'G3DSA:3.30.70.330:FF:001969', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156465, NULL, 'G3DSA:1.25.40.280:FF:000006', NULL, NULL, 'GH16790', NULL, NULL, NULL, NULL, NULL, 4),
(156466, NULL, 'G3DSA:3.90.470.20:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156467, NULL, 'G3DSA:1.25.40.10:FF:003600', NULL, NULL, 'RNA-binding protein 4F, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(156468, NULL, 'G3DSA:3.30.1520.10:FF:000168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156469, NULL, 'G3DSA:1.10.238.10:FF:000558', NULL, NULL, 'EH domain-containing and endocytosis protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(156470, NULL, 'G3DSA:3.40.50.1220:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156471, NULL, 'G3DSA:1.10.600.10:FF:000103', NULL, NULL, 'Bifunctional protein CrtB/UppS', NULL, NULL, NULL, NULL, NULL, 4),
(156472, NULL, 'G3DSA:3.40.50.620:FF:000033', NULL, NULL, 'tryptophan--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(156473, NULL, 'G3DSA:2.130.10.10:FF:004793', NULL, NULL, 'WD repeat-containing protein 48 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(156474, NULL, 'G3DSA:3.30.870.10:FF:000088', NULL, NULL, 'Phospholipase d active site domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(156475, NULL, 'G3DSA:2.30.29.30:FF:000136', NULL, NULL, 'Ran-specific GTPase-activating protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(156476, NULL, 'G3DSA:2.60.40.10:FF:005332', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156477, NULL, 'G3DSA:2.30.30.100:FF:000222', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm4', NULL, NULL, NULL, NULL, NULL, 4),
(156478, NULL, 'G3DSA:1.10.10.10:FF:000692', NULL, NULL, 'Vacuolar-sorting protein SNF8', NULL, NULL, NULL, NULL, NULL, 4),
(156479, NULL, 'G3DSA:3.90.215.10:FF:000002', NULL, NULL, 'Fibrinogen gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(156480, NULL, 'G3DSA:3.30.70.960:FF:000023', NULL, NULL, 'Serine protease P146', NULL, NULL, NULL, NULL, NULL, 4),
(156481, NULL, 'G3DSA:1.10.510.10:FF:000158', NULL, NULL, 'Dual specificity mitogen-activated protein kinase kinase 6', NULL, NULL, NULL, NULL, NULL, 4),
(156482, NULL, 'G3DSA:2.30.130.30:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156483, NULL, 'G3DSA:3.10.450.590:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156484, NULL, 'G3DSA:3.40.50.720:FF:001844', NULL, NULL, 'Dhs-28', NULL, NULL, NULL, NULL, NULL, 4),
(156485, NULL, 'G3DSA:1.10.579.10:FF:000007', NULL, NULL, '(6-4) photolyase', NULL, NULL, NULL, NULL, NULL, 4),
(156486, NULL, 'G3DSA:3.30.200.20:FF:002059', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(156487, NULL, 'G3DSA:3.30.1120.90:FF:000009', NULL, NULL, 'Nucleosome assembly protein (NAP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(156488, NULL, 'G3DSA:1.10.640.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156489, NULL, 'G3DSA:2.10.70.80:FF:000012', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(156490, NULL, 'G3DSA:2.130.10.10:FF:000785', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit I', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(156491, NULL, 'G3DSA:3.30.420.80:FF:000036', NULL, NULL, '40S ribosomal protein S14', NULL, NULL, NULL, NULL, NULL, 4),
(156492, NULL, 'G3DSA:3.10.20.90:FF:000824', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156493, NULL, 'G3DSA:2.30.30.100:FF:000076', NULL, NULL, 'small Nuclear ribonucleoprotein F, Putative', NULL, NULL, NULL, NULL, NULL, 4),
(156494, NULL, 'G3DSA:3.30.160.60:FF:003511', NULL, NULL, 'Zinc finger protein 114', NULL, NULL, NULL, NULL, NULL, 4),
(156495, NULL, 'G3DSA:3.40.50.220:FF:000003', NULL, NULL, 'Ornithine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(156496, NULL, 'G3DSA:3.30.160.60:FF:005282', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156497, NULL, 'G3DSA:2.60.40.10:FF:002898', NULL, NULL, 'Neural cell adhesion molecule 1a', NULL, NULL, NULL, NULL, NULL, 4),
(156498, NULL, 'G3DSA:3.30.1360.100:FF:000003', NULL, NULL, 'Type II secretion system protein L', NULL, NULL, NULL, NULL, NULL, 4),
(156499, NULL, 'G3DSA:3.30.200.210:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156500, NULL, 'G3DSA:3.20.20.70:FF:000031', NULL, NULL, 'Glutamate synthase 1 [NADH]', NULL, NULL, NULL, NULL, NULL, 4),
(156501, NULL, 'G3DSA:1.20.120.620:FF:000010', NULL, NULL, 'Nodulation protein V', NULL, NULL, NULL, NULL, NULL, 4),
(156502, NULL, 'G3DSA:3.90.470.10:FF:000055', NULL, NULL, 'Gem (nuclear organelle)-associated protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(156503, NULL, 'G3DSA:2.40.50.90:FF:000153', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156504, NULL, 'G3DSA:3.40.50.620:FF:000325', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(156505, NULL, 'G3DSA:3.30.870.10:FF:000116', NULL, NULL, 'Cardiolipin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(156506, NULL, 'G3DSA:1.25.40.20:FF:000877', NULL, NULL, 'Espin-like a', NULL, NULL, NULL, NULL, NULL, 4),
(156507, NULL, 'G3DSA:2.90.10.10:FF:000057', NULL, NULL, 'Comitin', NULL, NULL, NULL, NULL, NULL, 4),
(156508, NULL, 'G3DSA:3.30.40.10:FF:000834', NULL, NULL, 'RING-H2 finger protein ATL80', NULL, NULL, NULL, NULL, NULL, 4),
(156509, NULL, 'G3DSA:2.130.10.10:FF:003040', NULL, NULL, 'Ribosome biogenesis protein ERB1', NULL, NULL, NULL, NULL, NULL, 4),
(156510, NULL, 'G3DSA:2.20.70.10:FF:000249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156511, NULL, 'G3DSA:4.10.60.10:FF:000194', NULL, NULL, 'AGAP008075-PA', NULL, NULL, NULL, NULL, NULL, 4),
(156512, NULL, 'G3DSA:2.60.40.10:FF:002691', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(156513, NULL, 'G3DSA:1.25.10.10:FF:003126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156514, NULL, 'G3DSA:2.60.200.20:FF:000145', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(156515, NULL, 'G3DSA:3.40.50.300:FF:004355', NULL, NULL, 'MEI-218', NULL, NULL, NULL, NULL, NULL, 4),
(156516, NULL, 'G3DSA:1.20.1510.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156517, NULL, 'G3DSA:1.10.490.40:FF:000001', NULL, NULL, 'Diphtheria toxin', NULL, NULL, NULL, NULL, NULL, 4),
(156518, NULL, 'G3DSA:3.40.630.10:FF:000495', NULL, NULL, 'Aspartyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(156519, NULL, 'G3DSA:3.30.160.60:FF:005102', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156520, NULL, 'G3DSA:1.10.510.10:FF:002693', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156521, NULL, 'G3DSA:3.60.15.10:FF:000224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156522, NULL, 'G3DSA:3.30.1380.20:FF:000019', NULL, NULL, 'Trafficking protein particle complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(156523, NULL, 'G3DSA:1.20.1070.10:FF:002172', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156524, NULL, 'G3DSA:1.10.510.10:FF:004519', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156525, NULL, 'G3DSA:1.20.272.10:FF:000085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(156526, NULL, 'G3DSA:3.30.70.1350:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156527, NULL, 'G3DSA:3.30.50.10:FF:000099', NULL, NULL, 'Peroxisome proliferator-activated receptor gamma', NULL, NULL, NULL, NULL, NULL, 4),
(156528, NULL, 'G3DSA:3.40.228.10:FF:000032', NULL, NULL, 'Molybdopterin oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(156529, NULL, 'G3DSA:3.40.50.1000:FF:000792', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156530, NULL, 'G3DSA:2.30.130.10:FF:000002', NULL, NULL, '60S ribosome subunit biogenesis protein NIP7 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(156531, NULL, 'G3DSA:3.30.40.10:FF:001936', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156532, NULL, 'G3DSA:3.30.450.20:FF:000632', NULL, NULL, 'Two component system histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(156533, NULL, 'G3DSA:1.25.40.10:FF:002139', NULL, NULL, 'Pentatricopeptide repeat domain 3', NULL, NULL, NULL, NULL, NULL, 4),
(156534, NULL, 'G3DSA:3.40.850.10:FF:000360', NULL, NULL, 'Kinesin-like protein Nod', NULL, NULL, NULL, NULL, NULL, 4),
(156535, NULL, 'G3DSA:3.40.50.1110:FF:000061', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(156536, NULL, 'G3DSA:1.10.340.30:FF:000044', NULL, NULL, 'Endonuclease III', NULL, NULL, NULL, NULL, NULL, 4),
(156537, NULL, 'G3DSA:2.60.40.150:FF:000597', NULL, NULL, 'Probable Ras GTPase-activating-like protein ngap', NULL, NULL, NULL, NULL, NULL, 4),
(156538, NULL, 'G3DSA:3.30.300.180:FF:000011', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(156539, NULL, 'G3DSA:2.160.20.10:FF:000161', NULL, NULL, 'Polygalacturonase', NULL, NULL, NULL, NULL, NULL, 4),
(156540, NULL, 'G3DSA:3.80.10.10:FF:000100', NULL, NULL, 'Si:dkey-11n14.1', NULL, NULL, NULL, NULL, NULL, 4),
(156541, NULL, 'G3DSA:2.60.40.10:FF:003123', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156542, NULL, 'G3DSA:1.10.10.200:FF:000003', NULL, NULL, 'Probable transcriptional regulatory protein YeeN', NULL, NULL, NULL, NULL, NULL, 4),
(156543, NULL, 'G3DSA:1.10.10.60:FF:000595', NULL, NULL, 'Transcriptional regulator AraC/XylS family', NULL, NULL, NULL, NULL, NULL, 4),
(156544, NULL, 'G3DSA:2.60.40.10:FF:000482', NULL, NULL, 'Down syndrome cell adhesion molecule like 1', NULL, NULL, NULL, NULL, NULL, 4),
(156545, NULL, 'G3DSA:1.20.1080.10:FF:000020', NULL, NULL, 'Entomoglyceroporin 4, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(156546, NULL, 'G3DSA:3.40.50.970:FF:000087', NULL, NULL, 'Thi3p', NULL, NULL, NULL, NULL, NULL, 4),
(156547, NULL, 'G3DSA:1.10.357.50:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156548, NULL, 'G3DSA:3.30.1490.100:FF:000015', NULL, NULL, 'DNA repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(156549, NULL, 'G3DSA:2.130.10.10:FF:003247', NULL, NULL, 'WD-40 repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(156550, NULL, 'G3DSA:3.60.10.10:FF:000174', NULL, NULL, 'Endonuclease/exonuclease/phosphatase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(156551, NULL, 'G3DSA:3.80.10.10:FF:003591', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156552, NULL, 'G3DSA:1.10.10.160:FF:000002', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(156553, NULL, 'G3DSA:1.10.1300.10:FF:000006', NULL, NULL, 'Phosphodiesterase 9A', NULL, NULL, NULL, NULL, NULL, 4),
(156554, NULL, 'G3DSA:3.40.50.300:FF:003253', NULL, NULL, 'Chromatin remodeling 38', NULL, NULL, NULL, NULL, NULL, 4),
(156555, NULL, 'G3DSA:1.25.40.10:FF:001037', NULL, NULL, 'Pentatricopeptide', NULL, NULL, NULL, NULL, NULL, 4),
(156556, NULL, 'G3DSA:3.90.780.10:FF:000039', NULL, NULL, 'NAD 5''-nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(156557, NULL, 'G3DSA:2.40.10.170:FF:000017', NULL, NULL, 'ATP synthase subunit beta 1', NULL, NULL, NULL, NULL, NULL, 4),
(156558, NULL, 'G3DSA:3.40.50.150:FF:000021', NULL, NULL, 'Ribosomal protein L11 methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(156559, NULL, 'G3DSA:2.60.40.10:FF:005006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(156560, NULL, 'G3DSA:2.70.20.50:FF:000003', NULL, NULL, 'Matrix protein', NULL, NULL, NULL, NULL, NULL, 4),
(156561, NULL, 'G3DSA:3.40.50.850:FF:000017', NULL, NULL, 'Nicotinamidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(156562, NULL, 'G3DSA:2.60.40.10:FF:004517', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156563, NULL, 'G3DSA:3.30.230.10:FF:000113', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(156564, NULL, 'G3DSA:3.30.200.20:FF:000614', NULL, NULL, 'Os06g0689600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(156565, NULL, 'G3DSA:3.40.50.180:FF:000002', NULL, NULL, 'Protein-glutamate methylesterase/protein-glutamine glutaminase', NULL, NULL, NULL, NULL, NULL, 4),
(156566, NULL, 'G3DSA:3.30.420.100:FF:000008', NULL, NULL, '50S ribosomal protein L18', NULL, NULL, NULL, NULL, NULL, 4),
(156567, NULL, 'G3DSA:3.20.20.80:FF:000360', NULL, NULL, 'Amylo-alpha-1,6-glucosidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(156568, NULL, 'G3DSA:3.40.190.10:FF:000859', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156569, NULL, 'G3DSA:1.10.10.60:FF:000448', NULL, NULL, 'LIM/homeobox protein Lhx4', NULL, NULL, NULL, NULL, NULL, 4),
(156570, NULL, 'G3DSA:3.30.160.60:FF:005309', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156571, NULL, 'G3DSA:3.40.50.1820:FF:000414', NULL, NULL, 'Lysophospholipase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(156572, NULL, 'G3DSA:1.10.3720.10:FF:000145', NULL, NULL, 'Phosphate transport system permease protein PstA', NULL, NULL, NULL, NULL, NULL, 4),
(156573, NULL, 'G3DSA:3.50.50.60:FF:000164', NULL, NULL, 'Peroxisomal sarcosine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(156574, NULL, 'G3DSA:3.90.1600.10:FF:000048', NULL, NULL, 'DNA-directed DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(156575, NULL, 'G3DSA:3.40.190.10:FF:000831', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156576, NULL, 'G3DSA:3.40.50.150:FF:001123', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156577, NULL, 'G3DSA:1.25.40.730:FF:000012', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(156578, NULL, 'G3DSA:3.40.50.300:FF:008278', NULL, NULL, 'AGAP012862-PA', NULL, NULL, NULL, NULL, NULL, 4),
(156579, NULL, 'G3DSA:1.20.58.1880:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156580, NULL, 'G3DSA:1.20.58.60:FF:000636', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156581, NULL, 'G3DSA:3.40.50.620:FF:000651', NULL, NULL, 'Valyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(156582, NULL, 'G3DSA:3.30.200.20:FF:002238', NULL, NULL, 'AGC protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(156583, NULL, 'G3DSA:3.40.50.170:FF:000027', NULL, NULL, 'Putative methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(156584, NULL, 'G3DSA:2.10.110.10:FF:000163', NULL, NULL, 'LIM domain-containing protein ajuba isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(156585, NULL, 'G3DSA:3.40.50.880:FF:000178', NULL, NULL, 'Imidazole glycerol phosphate synthase subunit HisH', NULL, NULL, NULL, NULL, NULL, 4),
(156586, NULL, 'G3DSA:3.10.450.40:FF:000036', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(156587, NULL, 'G3DSA:1.20.1070.10:FF:001683', NULL, NULL, 'Zg09', NULL, NULL, NULL, NULL, NULL, 4),
(156588, NULL, 'G3DSA:2.40.128.80:FF:000009', NULL, NULL, 'Encystation-specific protease', NULL, NULL, NULL, NULL, NULL, 4),
(156589, NULL, 'G3DSA:1.25.10.10:FF:002637', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156590, NULL, 'G3DSA:3.40.50.2000:FF:000165', NULL, NULL, 'Starch synthase, chloroplastic/amyloplastic', NULL, NULL, NULL, NULL, NULL, 4),
(156591, NULL, 'G3DSA:2.60.120.10:FF:000787', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156592, NULL, 'G3DSA:2.30.30.40:FF:000238', NULL, NULL, 'NADPH oxidase organizer 1', NULL, NULL, NULL, NULL, NULL, 4),
(156593, NULL, 'G3DSA:3.10.450.50:FF:000039', NULL, NULL, 'Nuclear transport factor 2, putative', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(156594, NULL, 'G3DSA:3.40.390.10:FF:000133', NULL, NULL, 'ADAM metallopeptidase domain 3A', NULL, NULL, NULL, NULL, NULL, 4),
(156595, NULL, 'G3DSA:2.120.10.30:FF:000168', NULL, NULL, 'S9 family peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(156596, NULL, 'G3DSA:1.10.510.10:FF:000484', NULL, NULL, 'Serine/threonine-protein kinase greatwall, putative', NULL, NULL, NULL, NULL, NULL, 4),
(156597, NULL, 'G3DSA:3.40.190.10:FF:000298', NULL, NULL, 'Blast:Glutamate receptor ionotropic, kainate 2', NULL, NULL, NULL, NULL, NULL, 4),
(156598, NULL, 'G3DSA:3.30.465.10:FF:000091', NULL, NULL, 'FAD binding oxidoreductase CpoX1', NULL, NULL, NULL, NULL, NULL, 4),
(156599, NULL, 'G3DSA:3.30.70.330:FF:000216', NULL, NULL, 'RNA-binding protein BRN1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(156600, NULL, 'G3DSA:2.10.25.10:FF:000701', NULL, NULL, 'tenascin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(156601, NULL, 'G3DSA:1.20.1070.10:FF:000401', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156602, NULL, 'G3DSA:4.10.1060.10:FF:000035', NULL, NULL, 'RanBP2-type zinc finger protein At1g67325', NULL, NULL, NULL, NULL, NULL, 4),
(156603, NULL, 'G3DSA:1.25.40.10:FF:004909', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156604, NULL, 'G3DSA:2.170.130.10:FF:000048', NULL, NULL, 'Heme receptor HasR', NULL, NULL, NULL, NULL, NULL, 4),
(156605, NULL, 'G3DSA:1.25.10.10:FF:000485', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(156606, NULL, 'G3DSA:1.10.3820.10:FF:000001', NULL, NULL, 'Cytochrome c-type protein', NULL, NULL, NULL, NULL, NULL, 4),
(156607, NULL, 'G3DSA:3.30.200.40:FF:000007', NULL, NULL, 'HIT-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(156608, NULL, 'G3DSA:3.40.50.410:FF:000060', NULL, NULL, 'Collagen, type VI, alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(156609, NULL, 'G3DSA:3.30.160.60:FF:003157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156610, NULL, 'G3DSA:1.20.1310.10:FF:000145', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156611, NULL, 'G3DSA:1.25.40.20:FF:001720', NULL, NULL, 'CASK-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(156612, NULL, 'G3DSA:2.120.10.30:FF:000494', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156613, NULL, 'G3DSA:1.10.472.80:FF:000151', NULL, NULL, 'Rab-GTPase-TBC_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(156614, NULL, 'G3DSA:2.40.50.140:FF:000522', NULL, NULL, 'DNA-directed RNA polymerase III subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(156615, NULL, 'G3DSA:3.10.20.30:FF:000059', NULL, NULL, 'Threonyl-tRNA synthetase cytoplasmic, putative', NULL, NULL, NULL, NULL, NULL, 4),
(156616, NULL, 'G3DSA:3.40.850.10:FF:000326', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(156617, NULL, 'G3DSA:3.30.40.10:FF:002190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156618, NULL, 'G3DSA:1.20.120.330:FF:000013', NULL, NULL, 'DNA-binding transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(156619, NULL, 'G3DSA:3.30.40.10:FF:001728', NULL, NULL, 'Vacuolar protein sorting-associated protein 11 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(156620, NULL, 'G3DSA:2.20.70.10:FF:000283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156621, NULL, 'G3DSA:1.25.10.10:FF:001210', NULL, NULL, 'Uncharacterized protein B20D17.200', NULL, NULL, NULL, NULL, NULL, 4),
(156622, NULL, 'G3DSA:1.10.10.60:FF:000387', NULL, NULL, 'Replication termination factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(156623, NULL, 'G3DSA:3.30.413.10:FF:000010', NULL, NULL, 'Nitrite reductase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(156624, NULL, 'G3DSA:2.70.170.10:FF:000299', NULL, NULL, 'Cholinergic receptor nicotinic alpha 10 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(156625, NULL, 'G3DSA:3.30.420.40:FF:000636', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(156626, NULL, 'G3DSA:3.30.70.330:FF:000660', NULL, NULL, 'Pre-mRNA-splicing factor', NULL, NULL, NULL, NULL, NULL, 4),
(156627, NULL, 'G3DSA:3.30.160.60:FF:002376', NULL, NULL, 'Zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(156628, NULL, 'G3DSA:1.25.40.10:FF:002173', NULL, NULL, 'Tetratricopeptide repeat protein 30A', NULL, NULL, NULL, NULL, NULL, 4),
(156629, NULL, 'G3DSA:3.30.1360.40:FF:000001', NULL, NULL, 'Ribosome-recycling factor', NULL, NULL, NULL, NULL, NULL, 4),
(156630, NULL, 'G3DSA:1.10.510.10:FF:001265', NULL, NULL, 'Casein kinase I, putative', NULL, NULL, NULL, NULL, NULL, 4),
(156631, NULL, 'G3DSA:1.10.400.10:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156632, NULL, 'G3DSA:2.120.10.30:FF:000606', NULL, NULL, 'Dipeptidyl Peptidase Four (IV) family', NULL, NULL, NULL, NULL, NULL, 4),
(156633, NULL, 'G3DSA:3.30.70.330:FF:000716', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit G', NULL, NULL, NULL, NULL, NULL, 4),
(156634, NULL, 'G3DSA:2.60.120.590:FF:000013', NULL, NULL, '2-oxoglutarate-dependent dioxygenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(156635, NULL, 'G3DSA:2.60.40.10:FF:004489', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156636, NULL, 'G3DSA:3.90.640.10:FF:000063', NULL, NULL, 'Chromatin remodeling and histone acetyltransferase complexes subunit putative', NULL, NULL, NULL, NULL, NULL, 4),
(156637, NULL, 'G3DSA:1.20.5.190:FF:000045', NULL, NULL, 'Sperm surface protein Sp17', NULL, NULL, NULL, NULL, NULL, 4),
(156638, NULL, 'G3DSA:3.40.50.300:FF:004973', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156639, NULL, 'G3DSA:3.40.50.300:FF:000639', NULL, NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily A containing DEAD/H box 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(156640, NULL, 'G3DSA:3.40.50.2300:FF:000165', NULL, NULL, 'Glutamate receptor ionotropic, kainate', NULL, NULL, NULL, NULL, NULL, 4),
(156641, NULL, 'G3DSA:2.30.30.100:FF:000104', NULL, NULL, 'Small nuclear ribonucleoprotein Sm D2', NULL, NULL, NULL, NULL, NULL, 4),
(156642, NULL, 'G3DSA:1.20.1410.10:FF:000001', NULL, NULL, 'Talin 2', NULL, NULL, NULL, NULL, NULL, 4),
(156643, NULL, 'G3DSA:2.30.40.10:FF:000106', NULL, NULL, 'Formylmethanofuran dehydrogenase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(156644, NULL, 'G3DSA:3.90.110.10:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156645, NULL, 'G3DSA:3.30.160.60:FF:003039', NULL, NULL, 'Putative endonuclease or glycosyl hydrolase with C2H2-type zinc finger domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(156646, NULL, 'G3DSA:3.90.660.10:FF:000031', NULL, NULL, 'Protein anon-37Cs-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(156647, NULL, 'G3DSA:3.40.50.300:FF:004916', NULL, NULL, 'Protein CBG03934', NULL, NULL, NULL, NULL, NULL, 4),
(156648, NULL, 'G3DSA:2.60.40.10:FF:000274', NULL, NULL, 'Tenascin C', NULL, NULL, NULL, NULL, NULL, 4),
(156649, NULL, 'G3DSA:3.20.20.100:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156650, NULL, 'G3DSA:3.30.710.10:FF:000015', NULL, NULL, 'BTB/POZ domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(156651, NULL, 'G3DSA:3.90.1410.10:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156652, NULL, 'G3DSA:3.30.70.60:FF:000036', NULL, NULL, '30S ribosomal protein S6', NULL, NULL, NULL, NULL, NULL, 4),
(156653, NULL, 'G3DSA:3.90.170.10:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156654, NULL, 'G3DSA:1.20.120.770:FF:000004', NULL, NULL, 'Amyloid beta (A4) precursor protein b', NULL, NULL, NULL, NULL, NULL, 4),
(156655, NULL, 'G3DSA:3.40.1280.10:FF:000034', NULL, NULL, 'Putative small subunit rRNA processing factor', NULL, NULL, NULL, NULL, NULL, 4),
(156656, NULL, 'G3DSA:3.40.50.80:FF:000170', NULL, NULL, 'Ferric reductase transmembrane component, putative', NULL, NULL, NULL, NULL, NULL, 4),
(156657, NULL, 'G3DSA:3.40.50.1820:FF:001667', NULL, NULL, 'Non-ribosomal peptide synthase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(156658, NULL, 'G3DSA:3.20.20.300:FF:000025', NULL, NULL, '1,4-beta-D-glucan glucohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(156659, NULL, 'G3DSA:3.30.300.90:FF:000007', NULL, NULL, 'YAL044W-A-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(156660, NULL, 'G3DSA:3.30.760.10:FF:000052', NULL, NULL, 'Eukaryotic translation initiation factor 4E type 6', NULL, NULL, NULL, NULL, NULL, 4),
(156661, NULL, 'G3DSA:1.10.10.10:FF:000366', NULL, NULL, 'COP9 signalosome complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(156662, NULL, 'G3DSA:3.30.565.10:FF:000093', NULL, NULL, 'Histidine protein kinase SaeS', NULL, NULL, NULL, NULL, NULL, 4),
(156663, NULL, 'G3DSA:1.25.40.20:FF:000995', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156664, NULL, 'G3DSA:1.20.58.1780:FF:000008', NULL, NULL, 'Nuclear pore complex protein Nup154', NULL, NULL, NULL, NULL, NULL, 4),
(156665, NULL, 'G3DSA:3.30.40.10:FF:000481', NULL, NULL, 'U-box domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(156666, NULL, 'G3DSA:1.25.40.10:FF:004264', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156667, NULL, 'G3DSA:2.60.40.1170:FF:000086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156668, NULL, 'G3DSA:3.30.160.60:FF:002847', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156669, NULL, 'G3DSA:1.10.287.370:FF:000021', NULL, NULL, 'Prefoldin, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(156670, NULL, 'G3DSA:3.30.1520.10:FF:000140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156671, NULL, 'G3DSA:1.10.8.20:FF:000003', NULL, NULL, 'Alpha-tocopherol transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(156672, NULL, 'G3DSA:1.20.58.1770:FF:000005', NULL, NULL, 'RILP-like protein homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(156673, NULL, 'G3DSA:3.40.50.300:FF:002938', NULL, NULL, 'ATP-dependent RNA helicase DBP7', NULL, NULL, NULL, NULL, NULL, 4),
(156674, NULL, 'G3DSA:3.40.140.10:FF:000087', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(156675, NULL, 'G3DSA:3.40.50.300:FF:003192', NULL, NULL, 'AAA family ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(156676, NULL, 'G3DSA:3.30.160.60:FF:006119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156677, NULL, 'G3DSA:2.60.40.10:FF:000689', NULL, NULL, 'Immunoglobulin superfamily member 3', NULL, NULL, NULL, NULL, NULL, 4),
(156678, NULL, 'G3DSA:3.40.50.1820:FF:001196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156679, NULL, 'G3DSA:3.90.70.10:FF:000671', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156680, NULL, 'G3DSA:3.10.50.40:FF:000098', NULL, NULL, 'Protein export protein', NULL, NULL, NULL, NULL, NULL, 4),
(156681, NULL, 'G3DSA:3.10.20.90:FF:000942', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156682, NULL, 'G3DSA:3.40.50.1820:FF:000740', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156683, NULL, 'G3DSA:3.30.200.20:FF:002446', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(156684, NULL, 'G3DSA:2.60.40.1180:FF:000089', NULL, NULL, 'Alpha-glucosidase B', NULL, NULL, NULL, NULL, NULL, 4),
(156685, NULL, 'G3DSA:1.10.287.380:FF:000024', NULL, NULL, 'Valyl-tRNA synthetase 2, mitochondrial (putative)', NULL, NULL, NULL, NULL, NULL, 4),
(156686, NULL, 'G3DSA:1.25.40.10:FF:000992', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(156687, NULL, 'G3DSA:1.10.400.10:FF:000037', NULL, NULL, 'Guanine nucleotide-binding protein alpha-14 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(156688, NULL, 'G3DSA:1.20.58.60:FF:000428', NULL, NULL, 'Chromosome 14 open reading frame 49', NULL, NULL, NULL, NULL, NULL, 4),
(156689, NULL, 'G3DSA:3.30.750.24:FF:000031', NULL, NULL, 'Sulfate permease', NULL, NULL, NULL, NULL, NULL, 4),
(156690, NULL, 'G3DSA:3.30.160.60:FF:000931', NULL, NULL, 'zinc finger protein 697', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(156691, NULL, 'G3DSA:3.90.980.20:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156692, NULL, 'G3DSA:1.10.150.240:FF:000129', NULL, NULL, 'Probable phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(156693, NULL, 'G3DSA:2.60.120.1560:FF:000006', NULL, NULL, 'Putative cell agglutination protein SPAC1348.08c', NULL, NULL, NULL, NULL, NULL, 4),
(156694, NULL, 'G3DSA:1.25.40.570:FF:000003', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 11', NULL, NULL, NULL, NULL, NULL, 4),
(156695, NULL, 'G3DSA:3.40.50.300:FF:007143', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(156696, NULL, 'G3DSA:3.40.30.10:FF:000985', NULL, NULL, '2-hydroxychromene-2-carboxylate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(156697, NULL, 'G3DSA:4.10.80.160:FF:000005', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156698, NULL, 'G3DSA:2.60.120.260:FF:000555', NULL, NULL, 'Clan SB, family S8, subtilisin-like serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(156699, NULL, 'G3DSA:1.20.5.780:FF:000008', NULL, NULL, 'FXYD domain-containing ion transport regulator', NULL, NULL, NULL, NULL, NULL, 4),
(156700, NULL, 'G3DSA:1.20.80.10:FF:000061', NULL, NULL, 'Acyl-CoA binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(156701, NULL, 'G3DSA:3.40.250.10:FF:000123', NULL, NULL, 'Rhodanese-like domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(156702, NULL, 'G3DSA:1.20.1250.20:FF:000710', NULL, NULL, 'YMR221C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(156703, NULL, 'G3DSA:3.30.420.110:FF:000045', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(156704, NULL, 'G3DSA:2.10.25.10:FF:001718', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156705, NULL, 'G3DSA:3.40.50.920:FF:000033', NULL, NULL, '2-oxoglutarate oxidoreductase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(156706, NULL, 'G3DSA:1.25.10.10:FF:000693', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(156707, NULL, 'G3DSA:3.10.100.10:FF:000119', NULL, NULL, 'C-type lectin domain family 12 member B', NULL, NULL, NULL, NULL, NULL, 4),
(156708, NULL, 'G3DSA:2.40.100.10:FF:000094', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(156709, NULL, 'G3DSA:1.25.40.10:FF:004943', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156710, NULL, 'G3DSA:3.30.70.660:FF:000023', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(156711, NULL, 'G3DSA:3.60.15.10:FF:000163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156712, NULL, 'G3DSA:3.40.50.80:FF:000226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156713, NULL, 'G3DSA:3.30.70.330:FF:000508', NULL, NULL, 'Protein HRB1', NULL, NULL, NULL, NULL, NULL, 4),
(156714, NULL, 'G3DSA:3.30.160.60:FF:001712', NULL, NULL, 'Neurotrophin receptor-interacting factor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(156715, NULL, 'G3DSA:1.25.10.10:FF:001002', NULL, NULL, 'Related to septation (SepH) gene', NULL, NULL, NULL, NULL, NULL, 4),
(156716, NULL, 'G3DSA:3.40.50.300:FF:003545', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156717, NULL, 'G3DSA:3.60.20.10:FF:000028', NULL, NULL, 'Proteasome subunit alpha type', NULL, NULL, NULL, NULL, NULL, 4),
(156718, NULL, 'G3DSA:3.30.70.1820:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156719, NULL, 'G3DSA:1.20.1250.20:FF:001576', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156720, NULL, 'G3DSA:3.40.30.10:FF:001238', NULL, NULL, 'Calsequestrin', NULL, NULL, NULL, NULL, NULL, 4),
(156721, NULL, 'G3DSA:1.10.150.780:FF:000004', NULL, NULL, 'Vacuolar protein sorting-associated protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(156722, NULL, 'G3DSA:1.10.472.10:FF:000439', NULL, NULL, 'Cyclin-related protein FAM58A', NULL, NULL, NULL, NULL, NULL, 4),
(156723, NULL, 'G3DSA:4.10.60.10:FF:000014', NULL, NULL, 'RNA-binding motif protein 4', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(156724, NULL, 'G3DSA:2.40.50.140:FF:000730', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156725, NULL, 'G3DSA:3.90.190.10:FF:000281', NULL, NULL, 'Serine/threonine/tyrosine-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(156726, NULL, 'G3DSA:2.60.260.20:FF:000036', NULL, NULL, 'Type I HSP40 co-chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(156727, NULL, 'G3DSA:3.40.630.170:FF:000006', NULL, NULL, 'Glycylpeptide N-tetradecanoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(156728, NULL, 'G3DSA:3.30.420.40:FF:000844', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(156729, NULL, 'G3DSA:1.25.40.180:FF:000066', NULL, NULL, 'Eukaryotic translation initiation factor', NULL, NULL, NULL, NULL, NULL, 4),
(156730, NULL, 'G3DSA:1.10.10.10:FF:001237', NULL, NULL, 'Anaphase-promoting complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(156731, NULL, 'G3DSA:1.20.144.10:FF:000029', NULL, NULL, 'Phospholipid phosphatase 4', NULL, NULL, NULL, NULL, NULL, 4),
(156732, NULL, 'G3DSA:1.25.40.20:FF:000938', NULL, NULL, 'Ankyrin repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(156733, NULL, 'G3DSA:2.40.10.10:FF:000582', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156734, NULL, 'G3DSA:1.10.510.10:FF:001001', NULL, NULL, 'Putative serine/threonine-protein kinase K06H7.1', NULL, NULL, NULL, NULL, NULL, 4),
(156735, NULL, 'G3DSA:1.10.8.270:FF:000094', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(156736, NULL, 'G3DSA:3.40.1090.10:FF:000082', NULL, NULL, 'Lysophospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(156737, NULL, 'G3DSA:1.20.58.60:FF:000221', NULL, NULL, 'nesprin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(156738, NULL, 'G3DSA:3.10.100.10:FF:000237', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156739, NULL, 'G3DSA:1.10.150.770:FF:000001', NULL, NULL, 'Peptidoglycan D,D-transpeptidase FtsI', NULL, NULL, NULL, NULL, NULL, 4),
(156740, NULL, 'G3DSA:2.20.70.10:FF:000075', NULL, NULL, 'Pre-mRNA-processing protein 40A isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(156741, NULL, 'G3DSA:3.80.10.10:FF:004315', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156742, NULL, 'G3DSA:1.10.1070.11:FF:000039', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(156743, NULL, 'G3DSA:2.120.10.80:FF:000194', NULL, NULL, 'Kelch repeat-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(156744, NULL, 'G3DSA:3.40.50.2000:FF:000457', NULL, NULL, 'Lipopolysaccharide heptosyltransferase II', NULL, NULL, NULL, NULL, NULL, 4),
(156745, NULL, 'G3DSA:3.30.710.10:FF:000223', NULL, NULL, 'SD05384p', NULL, NULL, NULL, NULL, NULL, 4),
(156746, NULL, 'G3DSA:3.40.50.150:FF:000398', NULL, NULL, '3-demethylubiquinone-9 3-O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(156747, NULL, 'G3DSA:3.40.50.300:FF:006833', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156748, NULL, 'G3DSA:1.10.287.70:FF:000043', NULL, NULL, 'Potassium channel subfamily K member 10 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(156749, NULL, 'G3DSA:3.40.640.10:FF:000288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156750, NULL, 'G3DSA:3.30.40.10:FF:002133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156751, NULL, 'G3DSA:3.30.200.20:FF:001311', NULL, NULL, 'PH-protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(156752, NULL, 'G3DSA:3.30.2060.10:FF:000003', NULL, NULL, 'Penicillin-binding protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(156753, NULL, 'G3DSA:3.30.830.10:FF:000288', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156754, NULL, 'G3DSA:1.10.287.3240:FF:000006', NULL, NULL, 'V-type proton ATPase subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(156755, NULL, 'G3DSA:2.40.10.10:FF:000464', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156756, NULL, 'G3DSA:2.130.10.10:FF:002584', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(156757, NULL, 'G3DSA:2.160.20.10:FF:000335', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156758, NULL, 'G3DSA:2.40.50.140:FF:000258', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(156759, NULL, 'G3DSA:1.20.900.10:FF:000011', NULL, NULL, 'Intersectin 1', NULL, NULL, NULL, NULL, NULL, 4),
(156760, NULL, 'G3DSA:2.30.29.30:FF:000344', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(156761, NULL, 'G3DSA:3.40.50.80:FF:000018', NULL, NULL, 'NADPH--cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(156762, NULL, 'G3DSA:3.30.160.60:FF:003303', NULL, NULL, 'Transcription factor IIIA', NULL, NULL, NULL, NULL, NULL, 4),
(156763, NULL, 'G3DSA:1.10.238.20:FF:000033', NULL, NULL, 'GD21452', NULL, NULL, NULL, NULL, NULL, 4),
(156764, NULL, 'G3DSA:3.40.50.2300:FF:001593', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156765, NULL, 'G3DSA:2.130.10.10:FF:000993', NULL, NULL, 'Sperm associated antigen 16', NULL, NULL, NULL, NULL, NULL, 4),
(156766, NULL, 'G3DSA:3.30.420.40:FF:000283', NULL, NULL, 'Actin-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(156767, NULL, 'G3DSA:2.10.110.10:FF:000337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156768, NULL, 'G3DSA:2.60.120.620:FF:000096', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156769, NULL, 'G3DSA:2.60.40.10:FF:001145', NULL, NULL, 'Jitterbug, isoform I', NULL, NULL, NULL, NULL, NULL, 4),
(156770, NULL, 'G3DSA:3.30.310.80:FF:000033', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(156771, NULL, 'G3DSA:2.40.160.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156772, NULL, 'G3DSA:1.10.1070.11:FF:000096', NULL, NULL, 'Phosphatidylinositol 3-kinase-related protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(156773, NULL, 'G3DSA:3.80.10.10:FF:001466', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(156774, NULL, 'G3DSA:3.30.40.10:FF:002279', NULL, NULL, 'Cbl proto-oncogene-like 1, E3 ubiquitin protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(156775, NULL, 'G3DSA:1.25.40.1040:FF:000023', NULL, NULL, 'mRNA 3''-end-processing protein RNA14', NULL, NULL, NULL, NULL, NULL, 4),
(156776, NULL, 'G3DSA:2.30.42.10:FF:000330', NULL, NULL, 'HtrA-like serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(156777, NULL, 'G3DSA:3.30.70.270:FF:000029', NULL, NULL, 'DNA polymerase eta', NULL, NULL, NULL, NULL, NULL, 4),
(156778, NULL, 'G3DSA:2.60.40.10:FF:005540', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156779, NULL, 'G3DSA:3.30.160.60:FF:000723', NULL, NULL, 'PR domain zinc finger protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(156780, NULL, 'G3DSA:1.10.533.10:FF:000166', NULL, NULL, 'Melanoma differentiation associated gene 5', NULL, NULL, NULL, NULL, NULL, 4),
(156781, NULL, 'G3DSA:3.90.550.10:FF:000702', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156782, NULL, 'G3DSA:3.30.160.20:FF:000060', NULL, NULL, 'DEA(D/H)-box RNA helicase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(156783, NULL, 'G3DSA:2.60.120.590:FF:000070', NULL, NULL, 'AlkB, alkylation repair homolog', NULL, NULL, NULL, NULL, NULL, 4),
(156784, NULL, 'G3DSA:2.70.170.10:FF:000092', NULL, NULL, 'Gamma-aminobutyric acid type A receptor alpha6 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(156785, NULL, 'G3DSA:1.20.1070.10:FF:001918', NULL, NULL, 'G protein-coupled receptor 141', NULL, NULL, NULL, NULL, NULL, 4),
(156786, NULL, 'G3DSA:2.120.10.80:FF:000076', NULL, NULL, 'F-box/kelch-repeat protein At3g61590 family', NULL, NULL, NULL, NULL, NULL, 4),
(156787, NULL, 'G3DSA:2.60.120.680:FF:000006', NULL, NULL, 'Acyl-CoA binding domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(156788, NULL, 'G3DSA:2.130.10.30:FF:000145', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156789, NULL, 'G3DSA:3.30.1550.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(156790, NULL, 'G3DSA:2.60.40.60:FF:000890', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156791, NULL, 'G3DSA:3.80.10.10:FF:000572', NULL, NULL, 'Ran GTPase-activating protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(156792, NULL, 'G3DSA:3.40.50.300:FF:006272', NULL, NULL, 'Mitochondrial Rho GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(156793, NULL, 'G3DSA:3.40.50.150:FF:000459', NULL, NULL, 'Methionine S-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(156794, NULL, 'G3DSA:2.60.260.20:FF:000093', NULL, NULL, 'DNaJ domain (Prokaryotic heat shock protein)', NULL, NULL, NULL, NULL, NULL, 4),
(156795, NULL, 'G3DSA:1.10.460.10:FF:000013', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(156796, NULL, 'G3DSA:1.25.40.10:FF:004735', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156797, NULL, 'G3DSA:1.25.10.10:FF:002345', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156798, NULL, 'G3DSA:3.30.420.10:FF:000004', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(156799, NULL, 'G3DSA:1.10.472.10:FF:000557', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156800, NULL, 'G3DSA:3.90.650.10:FF:000002', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(156801, NULL, 'G3DSA:3.40.350.10:FF:000069', NULL, NULL, 'FACT complex subunit SPT16', NULL, NULL, NULL, NULL, NULL, 4),
(156802, NULL, 'G3DSA:1.10.510.10:FF:000658', NULL, NULL, 'Protein CBG12184', NULL, NULL, NULL, NULL, NULL, 4),
(156803, NULL, 'G3DSA:1.10.510.10:FF:003210', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156804, NULL, 'G3DSA:3.40.50.880:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156805, NULL, 'G3DSA:2.40.128.270:FF:000005', NULL, NULL, 'Slr0841 protein', NULL, NULL, NULL, NULL, NULL, 4),
(156806, NULL, 'G3DSA:1.10.472.10:FF:000591', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156807, NULL, 'G3DSA:2.10.220.10:FF:000076', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(156808, NULL, 'G3DSA:2.10.25.10:FF:001157', NULL, NULL, 'Putative Fibrillin-1', NULL, NULL, NULL, NULL, NULL, 4),
(156809, NULL, 'G3DSA:3.30.40.10:FF:002072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156810, NULL, 'G3DSA:2.40.50.1000:FF:000012', NULL, NULL, '30S ribosomal protein S17', NULL, NULL, NULL, NULL, NULL, 4),
(156811, NULL, 'G3DSA:3.30.2350.10:FF:000043', NULL, NULL, 'RNA-guided pseudouridylation complex pseudouridine synthase subunit Cbf5', NULL, NULL, NULL, NULL, NULL, 4),
(156812, NULL, 'G3DSA:1.20.120.1150:FF:000007', NULL, NULL, 'Serine/threonine-protein phosphatase 2A activator', NULL, NULL, NULL, NULL, NULL, 4),
(156813, NULL, 'G3DSA:1.20.1080.10:FF:000019', NULL, NULL, 'AQuaPorin or aquaglyceroporin related', NULL, NULL, NULL, NULL, NULL, 4),
(156814, NULL, 'G3DSA:3.40.190.10:FF:000444', NULL, NULL, 'Accessory colonization factor AcfC', NULL, NULL, NULL, NULL, NULL, 4),
(156815, NULL, 'G3DSA:3.40.50.300:FF:003753', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(156816, NULL, 'G3DSA:3.30.460.10:FF:000040', NULL, NULL, 'tRNA nucleotidyltransferase cca1', NULL, NULL, NULL, NULL, NULL, 4),
(156817, NULL, 'G3DSA:1.20.1250.20:FF:000502', NULL, NULL, 'Membrane transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(156818, NULL, 'G3DSA:3.40.50.150:FF:001510', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156819, NULL, 'G3DSA:1.25.40.10:FF:002583', NULL, NULL, 'Crooked neck protein, putative / cell cycle protein', NULL, NULL, NULL, NULL, NULL, 4),
(156820, NULL, 'G3DSA:3.30.160.60:FF:002786', NULL, NULL, 'SAGA-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(156821, NULL, 'G3DSA:3.30.200.20:FF:002093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156822, NULL, 'G3DSA:1.20.120.1130:FF:000001', NULL, NULL, 'Vacuolar protein sorting-associated protein 28 homolog', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(156823, NULL, 'G3DSA:3.40.1800.30:FF:000002', NULL, NULL, 'Histone deacetylase complex subunit SAP30', NULL, NULL, NULL, NULL, NULL, 4),
(156824, NULL, 'G3DSA:3.80.10.10:FF:001819', NULL, NULL, 'Centrosomal protein of 78 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(156825, NULL, 'G3DSA:3.40.50.2000:FF:000311', NULL, NULL, 'Lipopolysaccharide core biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(156826, NULL, 'G3DSA:3.40.50.12780:FF:000025', NULL, NULL, 'luciferin 4-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(156827, NULL, 'G3DSA:1.10.1670.10:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156828, NULL, 'G3DSA:3.30.200.20:FF:000294', NULL, NULL, 'Map kinase kinase', NULL, NULL, NULL, NULL, NULL, 4),
(156829, NULL, 'G3DSA:3.30.230.10:FF:000028', NULL, NULL, 'DNA mismatch repair protein Mlh3', NULL, NULL, NULL, NULL, NULL, 4),
(156830, NULL, 'G3DSA:3.40.50.300:FF:006979', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156831, NULL, 'G3DSA:3.40.50.720:FF:002272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156832, NULL, 'G3DSA:3.30.60.290:FF:000005', NULL, NULL, 'YALI0D08756p', NULL, NULL, NULL, NULL, NULL, 4),
(156833, NULL, 'G3DSA:4.10.40.50:FF:000002', NULL, NULL, 'Leucine-rich colipase-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(156834, NULL, 'G3DSA:1.10.418.10:FF:000095', NULL, NULL, 'Fimbrin', NULL, NULL, NULL, NULL, NULL, 4),
(156835, NULL, 'G3DSA:3.20.20.60:FF:000079', NULL, NULL, 'Putative aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(156836, NULL, 'G3DSA:3.50.50.60:FF:000079', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(156837, NULL, 'G3DSA:1.25.40.20:FF:001248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156838, NULL, 'G3DSA:2.40.50.140:FF:000112', NULL, NULL, 'Exosome complex component RRP40', NULL, NULL, NULL, NULL, NULL, 4),
(156839, NULL, 'G3DSA:3.40.50.11840:FF:000013', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(156840, NULL, 'G3DSA:2.130.10.10:FF:001510', NULL, NULL, 'Protein NEDD1', NULL, NULL, NULL, NULL, NULL, 4),
(156841, NULL, 'G3DSA:2.130.10.10:FF:002904', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156842, NULL, 'G3DSA:3.40.50.720:FF:002215', NULL, NULL, 'Enoyl-CoA hydratase and 3-hydroxyacyl CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(156843, NULL, 'G3DSA:2.60.40.10:FF:005040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156844, NULL, 'G3DSA:2.130.10.10:FF:005310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156845, NULL, 'G3DSA:3.30.200.20:FF:000406', NULL, NULL, 'PTI1-like tyrosine-protein kinase At3g15890', NULL, NULL, NULL, NULL, NULL, 4),
(156846, NULL, 'G3DSA:2.60.120.260:FF:000145', NULL, NULL, 'Nuclear receptor 2C2-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(156847, NULL, 'G3DSA:2.60.40.10:FF:004725', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156848, NULL, 'G3DSA:2.160.20.10:FF:000127', NULL, NULL, 'Right_handed_beta_helix_region /Periplasmic_copper-binding_protein_(NosD)_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(156849, NULL, 'G3DSA:3.60.10.10:FF:000320', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156850, NULL, 'G3DSA:1.25.40.10:FF:001245', NULL, NULL, 'Dsf2p', NULL, NULL, NULL, NULL, NULL, 4),
(156851, NULL, 'G3DSA:1.10.10.2330:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156852, NULL, 'G3DSA:2.30.30.40:FF:000682', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(156853, NULL, 'G3DSA:2.40.70.10:FF:000147', NULL, NULL, 'GPI-anchored aspartic protease', NULL, NULL, NULL, NULL, NULL, 4),
(156854, NULL, 'G3DSA:1.25.40.10:FF:004382', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156855, NULL, 'G3DSA:1.25.40.430:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156856, NULL, 'G3DSA:3.90.180.10:FF:000044', NULL, NULL, 'Glutathione-dependent formaldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(156857, NULL, 'G3DSA:3.60.10.10:FF:000410', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156858, NULL, 'G3DSA:1.10.1420.10:FF:000190', NULL, NULL, 'DNA mismatch repair protein Msh2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(156859, NULL, 'G3DSA:1.25.10.10:FF:001417', NULL, NULL, 'Unplaced genomic scaffold supercont1.18, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(156860, NULL, 'G3DSA:3.20.20.450:FF:000019', NULL, NULL, 'EAL domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(156861, NULL, 'G3DSA:3.30.230.10:FF:000231', NULL, NULL, 'MUTL protein homolog 3', NULL, NULL, NULL, NULL, NULL, 4),
(156862, NULL, 'G3DSA:2.60.40.10:FF:003500', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156863, NULL, 'G3DSA:3.30.1120.90:FF:000010', NULL, NULL, 'Probable nucleosome assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(156864, NULL, 'G3DSA:3.20.20.80:FF:000326', NULL, NULL, 'Glycoside hydrolase family 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(156865, NULL, 'G3DSA:2.30.30.790:FF:000001', NULL, NULL, '50S ribosomal protein L19', NULL, NULL, NULL, NULL, NULL, 4),
(156866, NULL, 'G3DSA:4.10.400.10:FF:000329', NULL, NULL, 'Lipophorin receptor 2, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(156867, NULL, 'G3DSA:2.30.42.10:FF:000594', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156868, NULL, 'G3DSA:3.30.230.10:FF:000085', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(156869, NULL, 'G3DSA:2.30.30.230:FF:000002', NULL, NULL, 'Fumarylacetoacetase', NULL, NULL, NULL, NULL, NULL, 4),
(156870, NULL, 'G3DSA:3.40.1450.10:FF:000008', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156871, NULL, 'G3DSA:1.10.10.10:FF:001501', NULL, NULL, 'Transcriptional regulator, Crp/Fnr family', NULL, NULL, NULL, NULL, NULL, 4),
(156872, NULL, 'G3DSA:3.30.230.70:FF:000142', NULL, NULL, 'Exosome complex exonuclease RRP46-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(156873, NULL, 'G3DSA:3.20.20.70:FF:000323', NULL, NULL, 'Fructose-bisphosphate aldolase A', NULL, NULL, NULL, NULL, NULL, 4),
(156874, NULL, 'G3DSA:3.40.630.30:FF:000001', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(156875, NULL, 'G3DSA:1.20.58.160:FF:000007', NULL, NULL, 'Hepatocyte growth factor-regulated tyrosine kinase substrate', NULL, NULL, NULL, NULL, NULL, 4),
(156876, NULL, 'G3DSA:3.40.50.12780:FF:000082', NULL, NULL, 'Fatty-acid-CoA ligase FadD2', NULL, NULL, NULL, NULL, NULL, 4),
(156877, NULL, 'G3DSA:1.25.40.20:FF:000585', NULL, NULL, 'Ankyrin repeat-containing protein ITN1', NULL, NULL, NULL, NULL, NULL, 4),
(156878, NULL, 'G3DSA:3.90.190.20:FF:000019', NULL, NULL, 'UDP-N-acetylmuramate--L-alanyl-gamma-D-glutamyl-meso-2,6-diaminoheptandioate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(156879, NULL, 'G3DSA:1.10.10.60:FF:000948', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156880, NULL, 'G3DSA:2.60.40.10:FF:000835', NULL, NULL, 'Hibris, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(156881, NULL, 'G3DSA:3.90.190.10:FF:000073', NULL, NULL, 'Tyrosine-protein phosphatase CDC14', NULL, NULL, NULL, NULL, NULL, 4),
(156882, NULL, 'G3DSA:3.40.50.10860:FF:000028', NULL, NULL, 'Bifunctional protein FolD', NULL, NULL, NULL, NULL, NULL, 4),
(156883, NULL, 'G3DSA:2.60.40.60:FF:000682', NULL, NULL, 'Hedgehog protein', NULL, NULL, NULL, NULL, NULL, 4),
(156884, NULL, 'G3DSA:2.70.150.10:FF:000236', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156885, NULL, 'G3DSA:3.40.50.300:FF:003135', NULL, NULL, 'Putative DEAD box RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(156886, NULL, 'G3DSA:3.30.70.330:FF:000008', NULL, NULL, 'Cytoplasmic polyadenylation element-binding 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(156887, NULL, 'G3DSA:3.30.470.20:FF:000015', NULL, NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(156888, NULL, 'G3DSA:3.30.1510.10:FF:000016', NULL, NULL, 'C-1-tetrahydrofolate synthase, cytoplasmic-like Protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(156889, NULL, 'G3DSA:3.30.160.60:FF:002168', NULL, NULL, 'Zinc finger protein 484', NULL, NULL, NULL, NULL, NULL, 4),
(156890, NULL, 'G3DSA:3.40.50.720:FF:002362', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156891, NULL, 'G3DSA:3.40.1410.10:FF:000034', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(156892, NULL, 'G3DSA:2.60.40.150:FF:000479', NULL, NULL, 'Phosphatidylinositol 3-kinase VPS34-like', NULL, NULL, NULL, NULL, NULL, 4),
(156893, NULL, 'G3DSA:1.20.58.150:FF:000004', NULL, NULL, 'ENTH domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(156894, NULL, 'G3DSA:1.25.10.10:FF:002845', NULL, NULL, 'Tubulin-specific chaperone D-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(156895, NULL, 'G3DSA:3.40.630.40:FF:000004', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase CwlD', NULL, NULL, NULL, NULL, NULL, 4),
(156896, NULL, 'G3DSA:3.10.20.90:FF:000678', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156897, NULL, 'G3DSA:1.20.1250.20:FF:000148', NULL, NULL, 'Solute carrier family 22 member 2', NULL, NULL, NULL, NULL, NULL, 4),
(156898, NULL, 'G3DSA:1.20.1070.10:FF:001475', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156899, NULL, 'G3DSA:3.40.50.300:FF:004563', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(156900, NULL, 'G3DSA:3.80.10.10:FF:002281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156901, NULL, 'G3DSA:3.30.470.30:FF:000018', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(156902, NULL, 'G3DSA:3.30.460.10:FF:000130', NULL, NULL, 'Poly(A) polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(156903, NULL, 'G3DSA:3.90.190.20:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156904, NULL, 'G3DSA:3.30.160.60:FF:003191', NULL, NULL, 'LOC100124727 protein', NULL, NULL, NULL, NULL, NULL, 4),
(156905, NULL, 'G3DSA:1.10.472.150:FF:000001', NULL, NULL, 'Protein MtfA', NULL, NULL, NULL, NULL, NULL, 4),
(156906, NULL, 'G3DSA:3.40.47.10:FF:000052', NULL, NULL, 'Beta-ketoacyl-acyl-carrier-protein synthase III', NULL, NULL, NULL, NULL, NULL, 4),
(156907, NULL, 'G3DSA:3.60.15.10:FF:000106', NULL, NULL, 'MoRTal germline', NULL, NULL, NULL, NULL, NULL, 4),
(156908, NULL, 'G3DSA:3.10.129.10:FF:000292', NULL, NULL, 'Putative sterigmatocystin biosynthesis fatty acid synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(156909, NULL, 'G3DSA:3.30.160.60:FF:002876', NULL, NULL, 'Zgc:172128', NULL, NULL, NULL, NULL, NULL, 4),
(156910, NULL, 'G3DSA:2.60.120.200:FF:000705', NULL, NULL, 'Os08g0514000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(156911, NULL, 'G3DSA:3.40.390.10:FF:000195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156912, NULL, 'G3DSA:1.10.150.20:FF:000324', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156913, NULL, 'G3DSA:3.40.50.1700:FF:000024', NULL, NULL, 'Beta-hexosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(156914, NULL, 'G3DSA:2.10.25.10:FF:001775', NULL, NULL, 'Stabilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(156915, NULL, 'G3DSA:4.10.240.10:FF:000120', NULL, NULL, 'Zcf18p', NULL, NULL, NULL, NULL, NULL, 4),
(156916, NULL, 'G3DSA:2.60.40.10:FF:004635', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156917, NULL, 'G3DSA:1.25.10.10:FF:003008', NULL, NULL, 'tRNA exportin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(156918, NULL, 'G3DSA:1.10.3180.10:FF:000002', NULL, NULL, 'Ethylene insensitive 3-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(156919, NULL, 'G3DSA:3.30.1010.10:FF:000023', NULL, NULL, 'Serine/threonine-protein kinase ATM', NULL, NULL, NULL, NULL, NULL, 4),
(156920, NULL, 'G3DSA:1.20.1250.20:FF:001166', NULL, NULL, 'Membrane associated transporter protein', NULL, NULL, NULL, NULL, NULL, 4),
(156921, NULL, 'G3DSA:1.25.40.20:FF:001512', NULL, NULL, 'Ankyrin repeat domain 17', NULL, NULL, NULL, NULL, NULL, 4),
(156922, NULL, 'G3DSA:1.25.10.10:FF:000546', NULL, NULL, 'Armadillo repeat containing 4', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(156923, NULL, 'G3DSA:3.80.10.10:FF:001909', NULL, NULL, 'NLR family pyrin domain containing 9', NULL, NULL, NULL, NULL, NULL, 4),
(156924, NULL, 'G3DSA:3.30.1050.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156925, NULL, 'G3DSA:3.40.1190.20:FF:000002', NULL, NULL, 'Bifunctional protein HldE', NULL, NULL, NULL, NULL, NULL, 4),
(156926, NULL, 'G3DSA:1.10.10.520:FF:000009', NULL, NULL, 'Ubiquitin activating enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(156927, NULL, 'G3DSA:3.30.1490.430:FF:000001', NULL, NULL, 'mRNA-capping enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(156928, NULL, 'G3DSA:3.30.450.20:FF:000514', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156929, NULL, 'G3DSA:1.20.120.1190:FF:000002', NULL, NULL, 'GTP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(156930, NULL, 'G3DSA:3.30.1330.90:FF:000020', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(156931, NULL, 'G3DSA:1.10.20.10:FF:000193', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156932, NULL, 'G3DSA:2.40.170.20:FF:000045', NULL, NULL, 'TonB-dependent outer membrane receptor', NULL, NULL, NULL, NULL, NULL, 4),
(156933, NULL, 'G3DSA:3.40.50.1000:FF:000674', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156934, NULL, 'G3DSA:1.20.1080.10:FF:000109', NULL, NULL, 'Formate/nitrite transporter family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(156935, NULL, 'G3DSA:3.90.640.10:FF:000029', NULL, NULL, 'Heat shock protein 110', NULL, NULL, NULL, NULL, NULL, 4),
(156936, NULL, 'G3DSA:3.90.150.10:FF:000008', NULL, NULL, 'Variant surface glycoprotein (VSG), putative', NULL, NULL, NULL, NULL, NULL, 4),
(156937, NULL, 'G3DSA:3.10.20.90:FF:000588', NULL, NULL, 'Ubiquitin fold modifier 1', NULL, NULL, NULL, NULL, NULL, 4),
(156938, NULL, 'G3DSA:1.10.510.10:FF:001473', NULL, NULL, 'Casein kinase I isoform alpha', NULL, NULL, NULL, NULL, NULL, 4),
(156939, NULL, 'G3DSA:2.120.10.30:FF:000286', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM71', NULL, NULL, NULL, NULL, NULL, 4),
(156940, NULL, 'G3DSA:3.40.50.12230:FF:000029', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(156941, NULL, 'G3DSA:3.90.226.10:FF:000319', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156942, NULL, 'G3DSA:2.130.10.10:FF:000398', NULL, NULL, 'U3 small nucleolar RNA-associated protein 15 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(156943, NULL, 'G3DSA:1.10.8.100:FF:000003', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(156944, NULL, 'G3DSA:2.10.110.10:FF:000129', NULL, NULL, 'LIM domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(156945, NULL, 'G3DSA:3.30.70.270:FF:000322', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156946, NULL, 'G3DSA:1.10.10.10:FF:000574', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(156947, NULL, 'G3DSA:3.90.1300.10:FF:000003', NULL, NULL, 'Amidase signature enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(156948, NULL, 'G3DSA:3.40.50.360:FF:000112', NULL, NULL, 'NAD(P)H dehydrogenase (Quinone) FQR1', NULL, NULL, NULL, NULL, NULL, 4),
(156949, NULL, 'G3DSA:3.40.570.10:FF:000052', NULL, NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase 3', NULL, NULL, NULL, NULL, NULL, 4),
(156950, NULL, 'G3DSA:1.10.10.500:FF:000003', NULL, NULL, 'prospero homeobox protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(156951, NULL, 'G3DSA:3.20.20.140:FF:000101', NULL, NULL, 'PHP domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(156952, NULL, 'G3DSA:3.10.110.10:FF:000209', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156953, NULL, 'G3DSA:3.30.160.60:FF:004938', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156954, NULL, 'G3DSA:2.20.100.10:FF:000227', NULL, NULL, 'spondin-1-like', NULL, NULL, NULL, NULL, NULL, 4),
(156955, NULL, 'G3DSA:1.25.40.180:FF:000302', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(156956, NULL, 'G3DSA:3.50.50.60:FF:000225', NULL, NULL, 'Renalase', NULL, NULL, NULL, NULL, NULL, 4),
(156957, NULL, 'G3DSA:3.50.50.60:FF:000282', NULL, NULL, 'Lipoamide dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(156958, NULL, 'G3DSA:2.60.120.200:FF:000144', NULL, NULL, 'Beta-glucan synthesis-associated protein SKN1', NULL, NULL, NULL, NULL, NULL, 4),
(156959, NULL, 'G3DSA:4.10.640.40:FF:000007', NULL, NULL, 'Feminization Of Germline', NULL, NULL, NULL, NULL, NULL, 4),
(156960, NULL, 'G3DSA:3.40.50.300:FF:004473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156961, NULL, 'G3DSA:3.80.10.10:FF:002371', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156962, NULL, 'G3DSA:3.40.50.1220:FF:000094', NULL, NULL, 'DHS-like NAD/FAD-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(156963, NULL, 'G3DSA:1.25.10.10:FF:002755', NULL, NULL, 'Importin beta-3 subunit, ran-binding protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(156964, NULL, 'G3DSA:1.10.600.10:FF:000075', NULL, NULL, 'Probable farnesyl diphosphate synthase DDB_G0268742', NULL, NULL, NULL, NULL, NULL, 4),
(156965, NULL, 'G3DSA:3.40.225.10:FF:000025', NULL, NULL, 'Adducin 1', NULL, NULL, NULL, NULL, NULL, 4),
(156966, NULL, 'G3DSA:3.75.10.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156967, NULL, 'G3DSA:1.10.3380.30:FF:000023', NULL, NULL, 'Ski2 like RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(156968, NULL, 'G3DSA:3.40.50.720:FF:000063', NULL, NULL, 'NAD(P) transhydrogenase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(156969, NULL, 'G3DSA:3.40.50.620:FF:000533', NULL, NULL, 'Tryptophanyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(156970, NULL, 'G3DSA:3.40.50.300:FF:002882', NULL, NULL, 'Irc20p', NULL, NULL, NULL, NULL, NULL, 4),
(156971, NULL, 'G3DSA:2.130.10.10:FF:004293', NULL, NULL, 'F7H2.18 protein', NULL, NULL, NULL, NULL, NULL, 4),
(156972, NULL, 'G3DSA:2.40.128.80:FF:000010', NULL, NULL, 'Cathepsin C', NULL, NULL, NULL, NULL, NULL, 4),
(156973, NULL, 'G3DSA:3.40.50.2300:FF:000783', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156974, NULL, 'G3DSA:1.10.486.10:FF:000027', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(156975, NULL, 'G3DSA:1.25.40.10:FF:003100', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(156976, NULL, 'G3DSA:2.130.10.10:FF:004383', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156977, NULL, 'G3DSA:2.60.40.10:FF:000982', NULL, NULL, 'Platelet-derived growth factor receptor beta', NULL, NULL, NULL, NULL, NULL, 4),
(156978, NULL, 'G3DSA:1.10.510.10:FF:003064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156979, NULL, 'G3DSA:3.30.160.60:FF:002729', NULL, NULL, 'Zinc finger protein 546', NULL, NULL, NULL, NULL, NULL, 4),
(156980, NULL, 'G3DSA:2.60.120.10:FF:000669', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156981, NULL, 'G3DSA:2.60.200.40:FF:000010', NULL, NULL, 'Sphingosine kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(156982, NULL, 'G3DSA:3.40.50.1820:FF:000532', NULL, NULL, 'hormone-sensitive lipase', NULL, NULL, NULL, NULL, NULL, 4),
(156983, NULL, 'G3DSA:3.40.50.2000:FF:000047', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(156984, NULL, 'G3DSA:3.10.110.10:FF:000356', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156985, NULL, 'G3DSA:2.130.10.10:FF:003101', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(156986, NULL, 'G3DSA:2.70.98.10:FF:000081', NULL, NULL, 'Beta-galactosidase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(156987, NULL, 'G3DSA:3.60.10.10:FF:000056', NULL, NULL, 'LINE-1 reverse transcriptase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(156988, NULL, 'G3DSA:1.10.630.10:FF:000200', NULL, NULL, 'Cytochrome P450, family 2, subfamily d, polypeptide 22', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(156989, NULL, 'G3DSA:3.30.160.60:FF:000577', NULL, NULL, 'zinc finger protein 692 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(156990, NULL, 'G3DSA:3.30.40.10:FF:000334', NULL, NULL, 'MATH and UCH domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(156991, NULL, 'G3DSA:1.20.80.10:FF:000027', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(156992, NULL, 'G3DSA:1.20.1720.10:FF:000103', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(156993, NULL, 'G3DSA:3.90.550.10:FF:000556', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156994, NULL, 'G3DSA:1.20.1250.20:FF:001784', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(156995, NULL, 'G3DSA:1.10.238.10:FF:000968', NULL, NULL, 'Os04g0681500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(156996, NULL, 'G3DSA:3.40.50.720:FF:000681', NULL, NULL, '2,4-dienoyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(156997, NULL, 'G3DSA:2.30.130.40:FF:000045', NULL, NULL, 'Protein cereblon homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(156998, NULL, 'G3DSA:2.160.20.70:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(156999, NULL, 'G3DSA:1.10.730.10:FF:000169', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(157000, NULL, 'G3DSA:3.30.70.330:FF:002307', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157001, NULL, 'G3DSA:2.10.110.10:FF:000281', NULL, NULL, 'Filamin binding LIM protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(157002, NULL, 'G3DSA:2.60.120.200:FF:000234', NULL, NULL, 'Calsyntenin 3', NULL, NULL, NULL, NULL, NULL, 4),
(157003, NULL, 'G3DSA:1.10.472.10:FF:000703', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157004, NULL, 'G3DSA:1.20.1070.10:FF:000081', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(157005, NULL, 'G3DSA:3.50.50.60:FF:000843', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(157006, NULL, 'G3DSA:4.10.770.10:FF:000002', NULL, NULL, 'Runt-related transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(157007, NULL, 'G3DSA:2.20.100.10:FF:000020', NULL, NULL, 'Thrombospondin type 1 domain containing 7A', NULL, NULL, NULL, NULL, NULL, 4),
(157008, NULL, 'G3DSA:1.25.40.20:FF:001158', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(157009, NULL, 'G3DSA:2.60.40.1360:FF:000019', NULL, NULL, 'Lysosomal alpha-mannosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157010, NULL, 'G3DSA:3.30.420.40:FF:000928', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157011, NULL, 'G3DSA:1.20.1250.20:FF:000564', NULL, NULL, 'YFL040W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(157012, NULL, 'G3DSA:2.60.40.420:FF:000021', NULL, NULL, 'Extracellular dihydrogeodin oxidase/laccase', NULL, NULL, NULL, NULL, NULL, 4),
(157013, NULL, 'G3DSA:3.40.190.10:FF:000270', NULL, NULL, 'HTH-type transcriptional regulator HdfR', NULL, NULL, NULL, NULL, NULL, 4),
(157014, NULL, 'G3DSA:3.30.70.330:FF:000424', NULL, NULL, 'RNA-binding protein 48 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(157015, NULL, 'G3DSA:3.30.200.20:FF:002323', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157016, NULL, 'G3DSA:3.40.50.261:FF:000033', NULL, NULL, 'Succinyl-CoA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(157017, NULL, 'G3DSA:1.10.1300.10:FF:000063', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157018, NULL, 'G3DSA:2.60.120.260:FF:000408', NULL, NULL, 'Alpha-L-arabinofuranosidase A', NULL, NULL, NULL, NULL, NULL, 4),
(157019, NULL, 'G3DSA:3.90.1150.220:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157020, NULL, 'G3DSA:2.40.50.140:FF:000814', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157021, NULL, 'G3DSA:3.30.2170.10:FF:000006', NULL, NULL, 'Endonuclease V', NULL, NULL, NULL, NULL, NULL, 4),
(157022, NULL, 'G3DSA:3.60.40.10:FF:000119', NULL, NULL, 'Protein phosphatase PPM7, putative', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(157023, NULL, 'G3DSA:1.20.120.230:FF:000045', NULL, NULL, 'Alpha-catenin-like protein hmp-1', NULL, NULL, NULL, NULL, NULL, 4),
(157024, NULL, 'G3DSA:3.80.10.10:FF:000128', NULL, NULL, 'Lutropin-choriogonadotropic hormone receptor', NULL, NULL, NULL, NULL, NULL, 4),
(157025, NULL, 'G3DSA:2.30.36.70:FF:000002', NULL, NULL, 'actin-related protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(157026, NULL, 'G3DSA:3.30.559.10:FF:000123', NULL, NULL, 'ATP-dependent serine activating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(157027, NULL, 'G3DSA:3.90.830.10:FF:000010', NULL, NULL, 'Sly1p', NULL, NULL, NULL, NULL, NULL, 4),
(157028, NULL, 'G3DSA:2.130.10.10:FF:002668', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157029, NULL, 'G3DSA:3.90.1150.210:FF:000005', NULL, NULL, 'F-actin-capping protein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(157030, NULL, 'G3DSA:3.30.565.10:FF:000536', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(157031, NULL, 'G3DSA:1.20.1310.10:FF:000229', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157032, NULL, 'G3DSA:3.50.50.60:FF:000309', NULL, NULL, 'Unplaced genomic scaffold supercont1.13, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(157033, NULL, 'G3DSA:1.10.510.10:FF:002659', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157034, NULL, 'G3DSA:1.20.1260.10:FF:000056', NULL, NULL, 'Aldehyde decarbonylase', NULL, NULL, NULL, NULL, NULL, 4),
(157035, NULL, 'G3DSA:3.30.450.20:FF:000424', NULL, NULL, 'Sensor histidine kinase, PAS domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(157036, NULL, 'G3DSA:1.20.1250.20:FF:000620', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(157037, NULL, 'G3DSA:3.60.15.10:FF:000016', NULL, NULL, 'N-acyl-phosphatidylethanolamine-hydrolyzing phospholipase D, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157038, NULL, 'G3DSA:1.10.510.10:FF:001029', NULL, NULL, 'Os02g0194400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(157039, NULL, 'G3DSA:1.10.10.10:FF:000809', NULL, NULL, 'DNA-binding transcriptional regulator, MarR family', NULL, NULL, NULL, NULL, NULL, 4),
(157040, NULL, 'G3DSA:3.40.50.300:FF:001544', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(157041, NULL, 'G3DSA:3.30.900.10:FF:000001', NULL, NULL, 'Autophagy-related protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(157042, NULL, 'G3DSA:2.60.40.1490:FF:000002', NULL, NULL, 'Histone chaperone ASF1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157043, NULL, 'G3DSA:1.10.287.70:FF:000127', NULL, NULL, 'Calcium-activated outward-rectifying potassium channel 1', NULL, NULL, NULL, NULL, NULL, 4),
(157044, NULL, 'G3DSA:2.70.170.10:FF:000119', NULL, NULL, 'Acetylcholine receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(157045, NULL, 'G3DSA:2.60.120.620:FF:000011', NULL, NULL, 'Prolyl alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(157046, NULL, 'G3DSA:2.160.20.10:FF:000189', NULL, NULL, 'Tail spike protein', NULL, NULL, NULL, NULL, NULL, 4),
(157047, NULL, 'G3DSA:3.40.50.300:FF:002972', NULL, NULL, 'ESX-3 secretion system protein EccC3', NULL, NULL, NULL, NULL, NULL, 4),
(157048, NULL, 'G3DSA:1.20.58.1710:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157049, NULL, 'G3DSA:3.40.50.150:FF:001038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157050, NULL, 'G3DSA:2.130.10.30:FF:000061', NULL, NULL, 'E3 ubiquitin-protein ligase UBR5', NULL, NULL, NULL, NULL, NULL, 4),
(157051, NULL, 'G3DSA:1.10.533.10:FF:000289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157052, NULL, 'G3DSA:2.10.25.10:FF:000140', NULL, NULL, 'Transmembrane agrin', NULL, NULL, NULL, NULL, NULL, 4),
(157053, NULL, 'G3DSA:3.40.50.300:FF:001393', NULL, NULL, 'Elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(157054, NULL, 'G3DSA:2.60.40.10:FF:002808', NULL, NULL, 'AGAP003656-PA', NULL, NULL, NULL, NULL, NULL, 4),
(157055, NULL, 'G3DSA:1.20.1250.20:FF:001666', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(157056, NULL, 'G3DSA:3.30.230.130:FF:000058', NULL, NULL, 'Cullin family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157057, NULL, 'G3DSA:3.30.1490.40:FF:000005', NULL, NULL, 'CD2 antigen cytoplasmic tail-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(157058, NULL, 'G3DSA:3.90.550.50:FF:000192', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(157059, NULL, 'G3DSA:3.90.226.10:FF:000168', NULL, NULL, 'Interphotoreceptor retinoid-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(157060, NULL, 'G3DSA:3.40.50.300:FF:002646', NULL, NULL, 'ATP-dependent RNA helicase MRH4, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(157061, NULL, 'G3DSA:1.10.510.10:FF:003272', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157062, NULL, 'G3DSA:3.10.180.10:FF:000068', NULL, NULL, '4-hydroxyphenylpyruvate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(157063, NULL, 'G3DSA:1.10.3720.10:FF:000229', NULL, NULL, 'Sugar ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(157064, NULL, 'G3DSA:3.30.160.60:FF:005517', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157065, NULL, 'G3DSA:3.30.2090.10:FF:000005', NULL, NULL, 'Multidrug resistance protein MdtC', NULL, NULL, NULL, NULL, NULL, 4),
(157066, NULL, 'G3DSA:1.20.5.190:FF:000168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157067, NULL, 'G3DSA:3.30.60.10:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157068, NULL, 'G3DSA:1.20.120.1080:FF:000115', NULL, NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase DEAH10', NULL, NULL, NULL, NULL, NULL, 4),
(157069, NULL, 'G3DSA:2.40.10.10:FF:000379', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157070, NULL, 'G3DSA:1.10.1320.10:FF:000007', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(157071, NULL, 'G3DSA:2.60.40.10:FF:003270', NULL, NULL, 'GD22562', NULL, NULL, NULL, NULL, NULL, 4),
(157072, NULL, 'G3DSA:1.25.10.10:FF:002429', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157073, NULL, 'G3DSA:1.50.10.10:FF:000100', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(157074, NULL, 'G3DSA:1.10.640.10:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157075, NULL, 'G3DSA:1.20.1070.10:FF:000463', NULL, NULL, 'Substance-K receptor', NULL, NULL, NULL, NULL, NULL, 4),
(157076, NULL, 'G3DSA:3.40.50.300:FF:006715', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157077, NULL, 'G3DSA:3.30.300.130:FF:000018', NULL, NULL, 'Phenylacetate-CoA oxygenase subunit PaaJ', NULL, NULL, NULL, NULL, NULL, 4),
(157078, NULL, 'G3DSA:1.10.8.60:FF:000200', NULL, NULL, 'Ctf18p', NULL, NULL, NULL, NULL, NULL, 4),
(157079, NULL, 'G3DSA:3.30.1120.30:FF:000014', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(157080, NULL, 'G3DSA:1.20.1250.20:FF:001722', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157081, NULL, 'G3DSA:2.40.30.130:FF:000009', NULL, NULL, 'Alanine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(157082, NULL, 'G3DSA:3.40.630.10:FF:000405', NULL, NULL, 'Peptidase M20 domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(157083, NULL, 'G3DSA:1.20.1560.10:FF:000045', NULL, NULL, 'ATP-binding cassette subfamily C member 10', NULL, NULL, NULL, NULL, NULL, 4),
(157084, NULL, 'G3DSA:3.40.50.300:FF:006917', NULL, NULL, 'Protein SMG9-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(157085, NULL, 'G3DSA:3.30.70.330:FF:002515', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157086, NULL, 'G3DSA:3.30.160.60:FF:001302', NULL, NULL, 'Zinc finger protein 618', NULL, NULL, NULL, NULL, NULL, 4),
(157087, NULL, 'G3DSA:1.20.1540.10:FF:000038', NULL, NULL, 'Rhomboid protease ROM10', NULL, NULL, NULL, NULL, NULL, 4),
(157088, NULL, 'G3DSA:3.30.590.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157089, NULL, 'G3DSA:1.10.8.710:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(157090, NULL, 'G3DSA:3.80.10.10:FF:000510', NULL, NULL, 'Leucine-rich-repeats and calponin homology domain protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(157091, NULL, 'G3DSA:3.10.28.10:FF:000048', NULL, NULL, 'Laglidadg endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(157092, NULL, 'G3DSA:2.40.30.170:FF:000027', NULL, NULL, 'Nodulation protein nolF', NULL, NULL, NULL, NULL, NULL, 4),
(157093, NULL, 'G3DSA:3.40.50.410:FF:000026', NULL, NULL, 'Collagen, type VI, alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(157094, NULL, 'G3DSA:2.10.110.10:FF:000247', NULL, NULL, 'YALI0D18898p', NULL, NULL, NULL, NULL, NULL, 4),
(157095, NULL, 'G3DSA:3.30.1490.30:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157096, NULL, 'G3DSA:2.40.30.110:FF:000003', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(157097, NULL, 'G3DSA:3.30.50.10:FF:000037', NULL, NULL, 'Nuclear hormone receptor FTZ-F1 beta', NULL, NULL, NULL, NULL, NULL, 4),
(157098, NULL, 'G3DSA:3.40.50.2000:FF:000373', NULL, NULL, 'Chitobiosyldiphosphodolichol beta-mannosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157099, NULL, 'G3DSA:2.60.40.10:FF:000892', NULL, NULL, 'Plexin B3', NULL, NULL, NULL, NULL, NULL, 4),
(157100, NULL, 'G3DSA:1.10.510.10:FF:001181', NULL, NULL, 'MAP kinase-interacting serine/threonine-protein kinase mnk-1', NULL, NULL, NULL, NULL, NULL, 4),
(157101, NULL, 'G3DSA:3.10.20.10:FF:000019', NULL, NULL, 'Cell death inducing DFFA like effector c', NULL, NULL, NULL, NULL, NULL, 4),
(157102, NULL, 'G3DSA:3.30.160.60:FF:001830', NULL, NULL, 'zinc finger protein 200', NULL, NULL, NULL, NULL, NULL, 4),
(157103, NULL, 'G3DSA:3.30.420.40:FF:000726', NULL, NULL, 'AaceriACR184Cp', NULL, NULL, NULL, NULL, NULL, 4),
(157104, NULL, 'G3DSA:1.25.40.10:FF:001801', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157105, NULL, 'G3DSA:1.10.510.10:FF:002283', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157106, NULL, 'G3DSA:2.40.50.140:FF:000612', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(157107, NULL, 'G3DSA:2.160.10.10:FF:000071', NULL, NULL, 'Translation initiation factor eIF-2B subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(157108, NULL, 'G3DSA:2.60.40.60:FF:000148', NULL, NULL, 'cadherin-13 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(157109, NULL, 'G3DSA:2.130.10.10:FF:000870', NULL, NULL, 'WD repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(157110, NULL, 'G3DSA:1.25.10.20:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157111, NULL, 'G3DSA:3.40.1280.10:FF:000118', NULL, NULL, 'tRNA/rRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(157112, NULL, 'G3DSA:3.30.450.20:FF:000222', NULL, NULL, 'Protein CBR-TAG-180', NULL, NULL, NULL, NULL, NULL, 4),
(157113, NULL, 'G3DSA:1.10.150.810:FF:000002', NULL, NULL, 'Polymerase (DNA directed) kappa', NULL, NULL, NULL, NULL, NULL, 4),
(157114, NULL, 'G3DSA:3.80.10.10:FF:002601', NULL, NULL, 'Vasorin a', NULL, NULL, NULL, NULL, NULL, 4),
(157115, NULL, 'G3DSA:3.30.40.10:FF:001644', NULL, NULL, 'Snf2 histone linker PHD ring helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157116, NULL, 'G3DSA:1.10.20.10:FF:000367', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157117, NULL, 'G3DSA:2.130.10.10:FF:002994', NULL, NULL, 'MGC89952 protein', NULL, NULL, NULL, NULL, NULL, 4),
(157118, NULL, 'G3DSA:2.60.40.10:FF:004579', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157119, NULL, 'G3DSA:1.25.40.20:FF:001574', NULL, NULL, 'Ankyrin repeat domain 1b (cardiac muscle)', NULL, NULL, NULL, NULL, NULL, 4),
(157120, NULL, 'G3DSA:3.30.450.40:FF:000228', NULL, NULL, 'Sensor histidine kinase, PAS and GAF domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(157121, NULL, 'G3DSA:3.30.70.330:FF:000626', NULL, NULL, 'Zinc finger protein 638', NULL, NULL, NULL, NULL, NULL, 4),
(157122, NULL, 'G3DSA:2.60.200.20:FF:000263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157123, NULL, 'G3DSA:3.30.70.330:FF:002841', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(157124, NULL, 'G3DSA:1.20.140.20:FF:000006', NULL, NULL, 'Pkp2p', NULL, NULL, NULL, NULL, NULL, 4),
(157125, NULL, 'G3DSA:1.10.510.10:FF:000719', NULL, NULL, 'serine/threonine-protein kinase 16 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(157126, NULL, 'G3DSA:3.30.160.60:FF:002286', NULL, NULL, 'Zinc finger protein 112', NULL, NULL, NULL, NULL, NULL, 4),
(157127, NULL, 'G3DSA:2.130.10.10:FF:002466', NULL, NULL, 'U3 small nucleolar RNA-associated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157128, NULL, 'G3DSA:3.30.70.330:FF:000750', NULL, NULL, 'Protein terminal ear1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(157129, NULL, 'G3DSA:1.20.140.10:FF:000003', NULL, NULL, 'isovaleryl-CoA dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(157130, NULL, 'G3DSA:1.25.40.20:FF:001804', NULL, NULL, 'E3 ubiquitin-protein ligase KEG', NULL, NULL, NULL, NULL, NULL, 4),
(157131, NULL, 'G3DSA:3.30.40.10:FF:000716', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(157132, NULL, 'G3DSA:2.60.120.650:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157133, NULL, 'G3DSA:3.90.550.20:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157134, NULL, 'G3DSA:3.40.50.410:FF:000352', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157135, NULL, 'G3DSA:2.60.40.150:FF:000682', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(157136, NULL, 'G3DSA:3.40.50.300:FF:006980', NULL, NULL, 'Cobalt import ATP-binding protein CbiO', NULL, NULL, NULL, NULL, NULL, 4),
(157137, NULL, 'G3DSA:1.10.357.10:FF:000076', NULL, NULL, 'Transcriptional regulator PhaD', NULL, NULL, NULL, NULL, NULL, 4),
(157138, NULL, 'G3DSA:3.90.190.10:FF:000511', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157139, NULL, 'G3DSA:3.30.1010.10:FF:000085', NULL, NULL, 'DNA damage-sensing protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(157140, NULL, 'G3DSA:3.30.40.10:FF:000065', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(157141, NULL, 'G3DSA:3.40.50.720:FF:002423', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157142, NULL, 'G3DSA:1.25.10.10:FF:002906', NULL, NULL, 'Armadillo repeat containing 8', NULL, NULL, NULL, NULL, NULL, 4),
(157143, NULL, 'G3DSA:3.80.10.10:FF:002106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157144, NULL, 'G3DSA:3.40.50.2300:FF:000249', NULL, NULL, 'Alkaline phosphatase synthesis transcriptional regulatory proteinphoP', NULL, NULL, NULL, NULL, NULL, 4),
(157145, NULL, 'G3DSA:2.60.40.10:FF:005068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157146, NULL, 'G3DSA:3.80.10.10:FF:000454', NULL, NULL, 'F-box and leucine-rich repeat protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(157147, NULL, 'G3DSA:3.40.50.2000:FF:000575', NULL, NULL, 'GalNAc-alpha-(1->4)-GalNAc-alpha-(1->3)-diNAcBac-PP-undecaprenol alpha-1,4-N-acetyl-D-galactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(157148, NULL, 'G3DSA:4.10.280.10:FF:000010', NULL, NULL, 'Scleraxis bHLH transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(157149, NULL, 'G3DSA:3.40.47.10:FF:000259', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157150, NULL, 'G3DSA:3.30.160.60:FF:001358', NULL, NULL, 'zinc finger protein 580', NULL, NULL, NULL, NULL, NULL, 4),
(157151, NULL, 'G3DSA:2.60.40.10:FF:003000', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(157152, NULL, 'G3DSA:2.60.40.10:FF:000717', NULL, NULL, 'interleukin-13 receptor subunit alpha-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(157153, NULL, 'G3DSA:2.30.29.30:FF:000221', NULL, NULL, 'Lysosomal trafficking regulator', NULL, NULL, NULL, NULL, NULL, 4),
(157154, NULL, 'G3DSA:3.40.640.10:FF:000226', NULL, NULL, 'Alanine aminotransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(157155, NULL, 'G3DSA:3.50.50.60:FF:000579', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(157156, NULL, 'G3DSA:3.30.470.20:FF:000105', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157157, NULL, 'G3DSA:1.50.10.20:FF:000103', NULL, NULL, 'Protein farnesyltransferase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(157158, NULL, 'G3DSA:3.30.230.10:FF:000321', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(157159, NULL, 'G3DSA:1.10.287.110:FF:000258', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157160, NULL, 'G3DSA:3.30.160.60:FF:002932', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157161, NULL, 'G3DSA:2.120.10.30:FF:000578', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157162, NULL, 'G3DSA:1.20.1070.10:FF:000137', NULL, NULL, 'neuropeptide FF receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(157163, NULL, 'G3DSA:3.10.20.870:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157164, NULL, 'G3DSA:2.60.40.10:FF:002488', NULL, NULL, 'Exocyst complex component 2', NULL, NULL, NULL, NULL, NULL, 4),
(157165, NULL, 'G3DSA:1.25.40.10:FF:002673', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157166, NULL, 'G3DSA:1.20.5.470:FF:000005', NULL, NULL, 'Argininosuccinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(157167, NULL, 'G3DSA:2.60.120.260:FF:000055', NULL, NULL, 'Reelin', NULL, NULL, NULL, NULL, NULL, 4),
(157168, NULL, 'G3DSA:3.20.20.80:FF:000444', NULL, NULL, 'Glucan endo-1,3-beta-glucosidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(157169, NULL, 'G3DSA:1.10.490.160:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157170, NULL, 'G3DSA:2.60.40.10:FF:002960', NULL, NULL, 'Protein lin-41', NULL, NULL, NULL, NULL, NULL, 4),
(157171, NULL, 'G3DSA:3.30.930.10:FF:000205', NULL, NULL, 'Glycine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(157172, NULL, 'G3DSA:4.10.1000.10:FF:000060', NULL, NULL, 'Probable E3 ubiquitin-protein ligase makorin-3', NULL, NULL, NULL, NULL, NULL, 4),
(157173, NULL, 'G3DSA:3.40.50.300:FF:005136', NULL, NULL, 'ABC transporter family-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(157174, NULL, 'G3DSA:1.25.10.10:FF:002227', NULL, NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(157175, NULL, 'G3DSA:3.90.25.10:FF:000010', NULL, NULL, 'NmrA-like family domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(157176, NULL, 'G3DSA:3.40.50.80:FF:000136', NULL, NULL, 'Ferric reductase transmembrane component, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157177, NULL, 'G3DSA:3.30.160.60:FF:006299', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157178, NULL, 'G3DSA:2.10.25.10:FF:001628', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157179, NULL, 'G3DSA:1.20.5.460:FF:000002', NULL, NULL, 'Curved DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(157180, NULL, 'G3DSA:3.30.720.150:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157181, NULL, 'G3DSA:2.10.60.10:FF:000041', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(157182, NULL, 'G3DSA:3.40.30.10:FF:000749', NULL, NULL, 'Putative frnE protein', NULL, NULL, NULL, NULL, NULL, 4),
(157183, NULL, 'G3DSA:1.10.150.670:FF:000027', NULL, NULL, 'Probable crossover junction endonuclease EME2', NULL, NULL, NULL, NULL, NULL, 4),
(157184, NULL, 'G3DSA:3.30.420.140:FF:000031', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(157185, NULL, 'G3DSA:2.30.42.10:FF:000240', NULL, NULL, 'Golgi reassembly-stacking protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(157186, NULL, 'G3DSA:2.70.160.11:FF:000075', NULL, NULL, 'Arginine N-methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157187, NULL, 'G3DSA:3.40.50.1820:FF:000122', NULL, NULL, 'Vitellogenin-3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(157188, NULL, 'G3DSA:3.40.630.10:FF:000080', NULL, NULL, 'p-aminobenzoyl-glutamate hydrolase subunit A', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(157189, NULL, 'G3DSA:1.25.40.190:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157190, NULL, 'G3DSA:2.30.30.1150:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157191, NULL, 'G3DSA:3.40.30.10:FF:000013', NULL, NULL, 'Blast:Protein SCO1 homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(157192, NULL, 'G3DSA:1.10.238.10:FF:000766', NULL, NULL, 'Naked cuticle homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(157193, NULL, 'G3DSA:2.60.40.10:FF:001706', NULL, NULL, 'Molecular chaperone FimC', NULL, NULL, NULL, NULL, NULL, 4),
(157194, NULL, 'G3DSA:1.10.238.180:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157195, NULL, 'G3DSA:1.25.10.10:FF:003211', NULL, NULL, 'Erythrocyte membrane-associated giant protein antigen 332 containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(157196, NULL, 'G3DSA:3.30.200.20:FF:000378', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(157197, NULL, 'G3DSA:1.10.10.60:FF:000982', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157198, NULL, 'G3DSA:3.10.20.230:FF:000001', NULL, NULL, 'serine/threonine-protein kinase DCLK1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(157199, NULL, 'G3DSA:1.25.40.180:FF:000010', NULL, NULL, 'Nuclear cap-binding protein subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(157200, NULL, 'G3DSA:3.50.4.10:FF:000038', NULL, NULL, 'FI17836p1', NULL, NULL, NULL, NULL, NULL, 4),
(157201, NULL, 'G3DSA:1.20.1420.30:FF:000070', NULL, NULL, 'Potassium-dependent sodium-calcium exchanger, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157202, NULL, 'G3DSA:2.160.20.10:FF:000245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157203, NULL, 'G3DSA:3.90.1010.10:FF:000020', NULL, NULL, 'Iron-sulfur cluster assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(157204, NULL, 'G3DSA:1.10.287.2480:FF:000003', NULL, NULL, 'Fusion glycoprotein F0', NULL, NULL, NULL, NULL, NULL, 4),
(157205, NULL, 'G3DSA:2.130.10.10:FF:004557', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157206, NULL, 'G3DSA:2.60.40.10:FF:001027', NULL, NULL, 'Interleukin 1 receptor type 2', NULL, NULL, NULL, NULL, NULL, 4),
(157207, NULL, 'G3DSA:3.30.70.330:FF:002190', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157208, NULL, 'G3DSA:1.10.10.10:FF:001119', NULL, NULL, 'ATP-dependent helicase SGS1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157209, NULL, 'G3DSA:1.10.3120.10:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157210, NULL, 'G3DSA:3.30.1370.50:FF:000005', NULL, NULL, 'probable ATP-dependent RNA helicase YTHDC2', NULL, NULL, NULL, NULL, NULL, 4),
(157211, NULL, 'G3DSA:1.20.58.60:FF:000344', NULL, NULL, 'SMAll', NULL, NULL, NULL, NULL, NULL, 4),
(157212, NULL, 'G3DSA:3.30.20.10:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157213, NULL, 'G3DSA:2.130.10.10:FF:005046', NULL, NULL, 'Dmx like 1', NULL, NULL, NULL, NULL, NULL, 4),
(157214, NULL, 'G3DSA:3.40.50.620:FF:000117', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(157215, NULL, 'G3DSA:3.10.100.10:FF:000327', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157216, NULL, 'G3DSA:3.50.50.60:FF:000725', NULL, NULL, 'Pyridine nucleotide-disulfide oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(157217, NULL, 'G3DSA:2.40.50.140:FF:000640', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157218, NULL, 'G3DSA:2.60.40.10:FF:004433', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157219, NULL, 'G3DSA:1.25.40.10:FF:004527', NULL, NULL, 'Os03g0168400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(157220, NULL, 'G3DSA:3.30.160.60:FF:005192', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157221, NULL, 'G3DSA:1.25.40.10:FF:002403', NULL, NULL, 'Os06g0493801 protein', NULL, NULL, NULL, NULL, NULL, 4),
(157222, NULL, 'G3DSA:1.10.3370.10:FF:000016', NULL, NULL, 'Protein translocase subunit SecY', NULL, NULL, NULL, NULL, NULL, 4),
(157223, NULL, 'G3DSA:1.20.1560.10:FF:000545', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(157224, NULL, 'G3DSA:3.20.20.300:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157225, NULL, 'G3DSA:3.30.70.330:FF:003004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157226, NULL, 'G3DSA:2.120.10.30:FF:000432', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157227, NULL, 'G3DSA:3.40.50.2000:FF:000603', NULL, NULL, 'UDP-GlcNAc:ribostamycin N-acetylglucosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(157228, NULL, 'G3DSA:2.40.30.10:FF:000381', NULL, NULL, 'Elongation factor G 1', NULL, NULL, NULL, NULL, NULL, 4),
(157229, NULL, 'G3DSA:3.40.50.300:FF:006890', NULL, NULL, 'GPN-loop GTPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(157230, NULL, 'G3DSA:2.60.40.2030:FF:000029', NULL, NULL, 'Na/Ca-exchange protein, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(157231, NULL, 'G3DSA:3.10.120.10:FF:000036', NULL, NULL, 'Damage response protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157232, NULL, 'G3DSA:3.80.10.10:FF:003675', NULL, NULL, 'Podocan-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(157233, NULL, 'G3DSA:1.25.10.10:FF:003216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157234, NULL, 'G3DSA:3.40.250.10:FF:000241', NULL, NULL, 'Rhodanese homology domain pair protein', NULL, NULL, NULL, NULL, NULL, 4),
(157235, NULL, 'G3DSA:3.40.50.10990:FF:000011', NULL, NULL, '3,4-dihydroxy-2-butanone 4-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(157236, NULL, 'G3DSA:1.25.40.770:FF:000001', NULL, NULL, 'Transcription initiation factor TFIID subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(157237, NULL, 'G3DSA:3.90.550.10:FF:000348', NULL, NULL, 'Uncharacterized glycosyltransferase EpsJ', NULL, NULL, NULL, NULL, NULL, 4),
(157238, NULL, 'G3DSA:2.40.30.10:FF:000139', NULL, NULL, 'Elongation factor Tu', NULL, NULL, NULL, NULL, NULL, 4),
(157239, NULL, 'G3DSA:1.20.1050.40:FF:000004', NULL, NULL, 'Thimet-like oligopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(157240, NULL, 'G3DSA:3.30.40.10:FF:001846', NULL, NULL, 'Putative RING zinc finger domain superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(157241, NULL, 'G3DSA:1.20.1070.10:FF:001626', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157242, NULL, 'G3DSA:3.30.710.10:FF:000133', NULL, NULL, 'Suppressor of kinetochore protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(157243, NULL, 'G3DSA:2.130.10.10:FF:004736', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157244, NULL, 'G3DSA:2.60.120.200:FF:000621', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157245, NULL, 'G3DSA:3.30.70.870:FF:000030', NULL, NULL, 'Tetracycline resistance protein TetM', NULL, NULL, NULL, NULL, NULL, 4),
(157246, NULL, 'G3DSA:2.40.50.140:FF:000584', NULL, NULL, '23S rRNA (Uracil-5-)-methyltransferase RumA', NULL, NULL, NULL, NULL, NULL, 4),
(157247, NULL, 'G3DSA:3.30.160.60:FF:001212', NULL, NULL, 'Tripartite motif-containing protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(157248, NULL, 'G3DSA:3.30.70.360:FF:000023', NULL, NULL, 'Acetylornithine deacetylase ArgE', NULL, NULL, NULL, NULL, NULL, 4),
(157249, NULL, 'G3DSA:1.25.40.20:FF:000259', NULL, NULL, 'E3 ubiquitin-protein ligase mind-bomb', NULL, NULL, NULL, NULL, NULL, 4),
(157250, NULL, 'G3DSA:2.130.10.10:FF:004883', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157251, NULL, 'G3DSA:3.40.720.10:FF:000199', NULL, NULL, 'Iduronate-2-sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(157252, NULL, 'G3DSA:2.60.120.260:FF:000673', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(157253, NULL, 'G3DSA:1.10.10.10:FF:000782', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(157254, NULL, 'G3DSA:1.10.238.10:FF:000912', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(157255, NULL, 'G3DSA:1.25.40.790:FF:000007', NULL, NULL, 'CCR4-NOT transcription complex subunit 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157256, NULL, 'G3DSA:1.20.1260.20:FF:000003', NULL, NULL, 'PPE family protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(157257, NULL, 'G3DSA:1.10.760.10:FF:000058', NULL, NULL, 'Nitric oxide reductase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(157258, NULL, 'G3DSA:3.30.160.20:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157259, NULL, 'G3DSA:1.25.40.10:FF:000256', NULL, NULL, 'Probable pre-mRNA splicing factor prp1', NULL, NULL, NULL, NULL, NULL, 4),
(157260, NULL, 'G3DSA:3.40.190.10:FF:000921', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157261, NULL, 'G3DSA:3.10.20.90:FF:000386', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 26', NULL, NULL, NULL, NULL, NULL, 4),
(157262, NULL, 'G3DSA:3.90.400.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157263, NULL, 'G3DSA:1.10.510.10:FF:003300', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157264, NULL, 'G3DSA:1.25.10.10:FF:002901', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157265, NULL, 'G3DSA:2.60.120.650:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157266, NULL, 'G3DSA:3.30.420.40:FF:000698', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157267, NULL, 'G3DSA:2.60.40.10:FF:002634', NULL, NULL, 'Protein-tyrosine-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(157268, NULL, 'G3DSA:2.60.40.150:FF:000743', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157269, NULL, 'G3DSA:2.40.50.140:FF:000292', NULL, NULL, 'Probable ATP-dependent DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(157270, NULL, 'G3DSA:1.10.510.10:FF:002962', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157271, NULL, 'G3DSA:2.40.70.10:FF:000501', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157272, NULL, 'G3DSA:1.10.287.70:FF:000543', NULL, NULL, 'YALI0D05841p', NULL, NULL, NULL, NULL, NULL, 4),
(157273, NULL, 'G3DSA:3.40.30.10:FF:000659', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157274, NULL, 'G3DSA:1.20.1560.10:FF:000601', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157275, NULL, 'G3DSA:3.30.40.10:FF:001498', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157276, NULL, 'G3DSA:3.40.50.300:FF:006687', NULL, NULL, 'Guanylate-binding family protein', NULL, NULL, NULL, NULL, NULL, 4),
(157277, NULL, 'G3DSA:3.40.1110.10:FF:000404', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157278, NULL, 'G3DSA:3.40.50.1820:FF:000650', NULL, NULL, 'Lysosomal Pro-X carboxypeptidase isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(157279, NULL, 'G3DSA:3.40.50.300:FF:002848', NULL, NULL, 'ATP-dependent helicase, DinG family', NULL, NULL, NULL, NULL, NULL, 4),
(157280, NULL, 'G3DSA:3.40.50.2300:FF:000721', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(157281, NULL, 'G3DSA:3.40.50.300:FF:005226', NULL, NULL, 'ATP-dependent DNA helicase PIF5', NULL, NULL, NULL, NULL, NULL, 4),
(157282, NULL, 'G3DSA:3.30.479.30:FF:000038', NULL, NULL, 'Putative stomatin-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(157283, NULL, 'G3DSA:3.30.160.60:FF:002937', NULL, NULL, 'zinc finger and BTB domain-containing protein 16-A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(157284, NULL, 'G3DSA:3.40.50.80:FF:000108', NULL, NULL, 'Terephthalate 1,2-dioxygenase, reductase component 2', NULL, NULL, NULL, NULL, NULL, 4),
(157285, NULL, 'G3DSA:3.30.1540.20:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157286, NULL, 'G3DSA:1.20.58.60:FF:000018', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(157287, NULL, 'G3DSA:1.10.630.10:FF:000700', NULL, NULL, 'Os02g0504000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(157288, NULL, 'G3DSA:1.20.58.460:FF:000002', NULL, NULL, 'O-GlcNAcase BT_4395', NULL, NULL, NULL, NULL, NULL, 4),
(157289, NULL, 'G3DSA:1.10.10.820:FF:000009', NULL, NULL, 'unconventional myosin-XVIIIa isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(157290, NULL, 'G3DSA:2.30.39.10:FF:000131', NULL, NULL, 'Angiotensinogen', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(157291, NULL, 'G3DSA:2.60.40.420:FF:000026', NULL, NULL, 'Coagulation factor VIII (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(157292, NULL, 'G3DSA:3.40.225.10:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157293, NULL, 'G3DSA:3.40.50.1910:FF:000031', NULL, NULL, 'Abhd-3.1', NULL, NULL, NULL, NULL, NULL, 4),
(157294, NULL, 'G3DSA:3.30.479.20:FF:000035', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(157295, NULL, 'G3DSA:1.20.58.900:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157296, NULL, 'G3DSA:3.40.50.1820:FF:001752', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157297, NULL, 'G3DSA:1.10.1520.10:FF:000051', NULL, NULL, 'Ribonuclease 3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157298, NULL, 'G3DSA:3.30.540.10:FF:000007', NULL, NULL, '3''(2''),5''-bisphosphate nucleotidase CysQ', NULL, NULL, NULL, NULL, NULL, 4),
(157299, NULL, 'G3DSA:3.30.160.60:FF:000987', NULL, NULL, 'Zinc finger protein 275', NULL, NULL, NULL, NULL, NULL, 4),
(157300, NULL, 'G3DSA:3.30.160.60:FF:004793', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157301, NULL, 'G3DSA:3.40.640.10:FF:000198', NULL, NULL, 'Dubious cystathionine gamma-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(157302, NULL, 'G3DSA:3.30.70.370:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157303, NULL, 'G3DSA:1.20.1070.10:FF:001767', NULL, NULL, 'Putative vasopressin/oxytocin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(157304, NULL, 'G3DSA:3.40.50.1820:FF:000032', NULL, NULL, 'KAT8 regulatory NSL complex subunit 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(157305, NULL, 'G3DSA:1.20.58.1970:FF:000003', NULL, NULL, 'Conserved oligomeric Golgi complex component', NULL, NULL, NULL, NULL, NULL, 4),
(157306, NULL, 'G3DSA:1.10.1420.10:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157307, NULL, 'G3DSA:3.10.20.590:FF:000002', NULL, NULL, 'Leucyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(157308, NULL, 'G3DSA:1.10.8.60:FF:000054', NULL, NULL, 'ATPase WRNIP1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(157309, NULL, 'G3DSA:1.20.1070.10:FF:000047', NULL, NULL, 'Muscarinic acetylcholine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(157310, NULL, 'G3DSA:3.40.50.2300:FF:000575', NULL, NULL, 'Glutamate receptor, ionotropic, kainate 5', NULL, NULL, NULL, NULL, NULL, 4),
(157311, NULL, 'G3DSA:1.20.1070.10:FF:001952', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157312, NULL, 'G3DSA:2.40.10.120:FF:000025', NULL, NULL, 'PDZ domain-containing protein C23G3.12c', NULL, NULL, NULL, NULL, NULL, 4),
(157313, NULL, 'G3DSA:1.10.10.800:FF:000003', NULL, NULL, 'Carboxymuconolactone decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(157314, NULL, 'G3DSA:1.10.510.10:FF:004284', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157315, NULL, 'G3DSA:1.10.510.10:FF:001355', NULL, NULL, 'TKL protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(157316, NULL, 'G3DSA:1.10.238.10:FF:001132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157317, NULL, 'G3DSA:3.40.50.720:FF:000473', NULL, NULL, 'NADP-dependent alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(157318, NULL, 'G3DSA:2.120.10.30:FF:000522', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157319, NULL, 'G3DSA:3.30.565.10:FF:000446', NULL, NULL, 'Sensory histidine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(157320, NULL, 'G3DSA:2.60.40.10:FF:001701', NULL, NULL, 'CD19 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(157321, NULL, 'G3DSA:3.30.1490.190:FF:000002', NULL, NULL, 'Zinc uptake transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(157322, NULL, 'G3DSA:1.10.1040.10:FF:000025', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(P)+]', NULL, NULL, NULL, NULL, NULL, 4),
(157323, NULL, 'G3DSA:3.50.50.60:FF:000635', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(157324, NULL, 'G3DSA:1.25.40.10:FF:002055', NULL, NULL, 'Clathrin heavy chain 2', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(157325, NULL, 'G3DSA:1.10.510.10:FF:001501', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157326, NULL, 'G3DSA:3.90.1800.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157327, NULL, 'G3DSA:3.90.1310.10:FF:000032', NULL, NULL, 'Penicillin-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(157328, NULL, 'G3DSA:3.40.50.880:FF:000094', NULL, NULL, 'Uncharacterized peptidase Lmo0363', NULL, NULL, NULL, NULL, NULL, 4),
(157329, NULL, 'G3DSA:3.30.420.40:FF:000754', NULL, NULL, 'AGR099Cp', NULL, NULL, NULL, NULL, NULL, 4),
(157330, NULL, 'G3DSA:3.40.50.1980:FF:000086', NULL, NULL, 'Possible binding-protein-dependent transport lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(157331, NULL, 'G3DSA:3.30.460.10:FF:000006', NULL, NULL, 'non-canonical poly(A) RNA polymerase PAPD5', NULL, NULL, NULL, NULL, NULL, 4),
(157332, NULL, 'G3DSA:3.40.630.10:FF:000259', NULL, NULL, 'Transferrin receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157333, NULL, 'G3DSA:2.130.10.10:FF:002758', NULL, NULL, 'Transcription factor TFIIIC complex subunit Tfc6, putative (AFU_orthologue AFUA_3G10380)', NULL, NULL, NULL, NULL, NULL, 4),
(157334, NULL, 'G3DSA:2.40.70.10:FF:000355', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157335, NULL, 'G3DSA:3.90.15.10:FF:000009', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(157336, NULL, 'G3DSA:3.80.10.10:FF:000038', NULL, NULL, 'Biglycan', NULL, NULL, NULL, NULL, NULL, 4),
(157337, NULL, 'G3DSA:3.30.559.30:FF:000039', NULL, NULL, 'Probable non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(157338, NULL, 'G3DSA:3.10.129.10:FF:000117', NULL, NULL, '3-hydroxyacyl-thioester dehydratase HtdY', NULL, NULL, NULL, NULL, NULL, 4),
(157339, NULL, 'G3DSA:2.60.40.420:FF:000111', NULL, NULL, 'OSJNBa0028I23.23 protein', NULL, NULL, NULL, NULL, NULL, 4),
(157340, NULL, 'G3DSA:3.40.190.10:FF:000360', NULL, NULL, 'ABC transporter lipoprotein BldKB', NULL, NULL, NULL, NULL, NULL, 4),
(157341, NULL, 'G3DSA:1.25.40.20:FF:001630', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157342, NULL, 'G3DSA:3.30.40.10:FF:000542', NULL, NULL, 'RING/U-box superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(157343, NULL, 'G3DSA:1.20.120.1750:FF:000069', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(157344, NULL, 'G3DSA:1.10.510.10:FF:001411', NULL, NULL, 'Calcium-dependent protein kinase 27', NULL, NULL, NULL, NULL, NULL, 4),
(157345, NULL, 'G3DSA:1.10.8.100:FF:000032', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(157346, NULL, 'G3DSA:3.30.519.10:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157347, NULL, 'G3DSA:3.40.50.300:FF:007053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157348, NULL, 'G3DSA:1.20.210.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157349, NULL, 'G3DSA:3.10.10.10:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157350, NULL, 'G3DSA:1.25.40.20:FF:001282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157351, NULL, 'G3DSA:2.40.50.140:FF:000494', NULL, NULL, 'Suppressor of Ty 6 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(157352, NULL, 'G3DSA:3.90.550.10:FF:000438', NULL, NULL, 'Cellulose synthase-like protein G3', NULL, NULL, NULL, NULL, NULL, 4),
(157353, NULL, 'G3DSA:1.20.910.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157354, NULL, 'G3DSA:3.30.420.40:FF:001064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157355, NULL, 'G3DSA:1.10.8.1240:FF:000001', NULL, NULL, 'Rap guanine nucleotide exchange factor (GEF) 4', NULL, NULL, NULL, NULL, NULL, 4),
(157356, NULL, 'G3DSA:1.10.10.10:FF:002047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157357, NULL, 'G3DSA:3.40.50.620:FF:000090', NULL, NULL, 'asparagine synthetase [glutamine-hydrolyzing]', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(157358, NULL, 'G3DSA:3.30.160.60:FF:000369', NULL, NULL, 'Zinc finger protein 384 like', NULL, NULL, NULL, NULL, NULL, 4),
(157359, NULL, 'G3DSA:3.90.1150.170:FF:000009', NULL, NULL, 'Glutamate decarboxylase 1b', NULL, NULL, NULL, NULL, NULL, 4),
(157360, NULL, 'G3DSA:2.10.25.10:FF:000263', NULL, NULL, 'Protein delta homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(157361, NULL, 'G3DSA:3.10.110.10:FF:000148', NULL, NULL, 'RWD domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(157362, NULL, 'G3DSA:1.10.287.70:FF:000217', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(157363, NULL, 'G3DSA:3.30.1010.10:FF:000141', NULL, NULL, 'PIKK family atypical protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(157364, NULL, 'G3DSA:3.30.190.20:FF:000033', NULL, NULL, 'Mitochondrial 54S ribosomal protein MRPL1', NULL, NULL, NULL, NULL, NULL, 4),
(157365, NULL, 'G3DSA:1.25.40.210:FF:000002', NULL, NULL, 'Telomeric repeat-binding factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(157366, NULL, 'G3DSA:3.10.580.10:FF:000031', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(157367, NULL, 'G3DSA:3.80.10.10:FF:000280', NULL, NULL, 'oligodendrocyte-myelin glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(157368, NULL, 'G3DSA:3.40.1280.10:FF:000091', NULL, NULL, 'Os08g0506500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(157369, NULL, 'G3DSA:2.60.40.10:FF:003180', NULL, NULL, 'Heparan sulfate proteoglycan 2', NULL, NULL, NULL, NULL, NULL, 4),
(157370, NULL, 'G3DSA:3.90.70.10:FF:000637', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157371, NULL, 'G3DSA:3.40.50.300:FF:007704', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157372, NULL, 'G3DSA:2.60.40.60:FF:000564', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157373, NULL, 'G3DSA:3.40.50.1220:FF:000032', NULL, NULL, 'NAD-dependent protein deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(157374, NULL, 'G3DSA:3.30.559.10:FF:000033', NULL, NULL, 'O-acyltransferase (WSD1-like) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(157375, NULL, 'G3DSA:1.10.238.10:FF:001222', NULL, NULL, 'Calmodulin-like 4a', NULL, NULL, NULL, NULL, NULL, 4),
(157376, NULL, 'G3DSA:1.20.120.730:FF:000009', NULL, NULL, 'Vesicle coat component', NULL, NULL, NULL, NULL, NULL, 4),
(157377, NULL, 'G3DSA:3.80.10.10:FF:004023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157378, NULL, 'G3DSA:3.40.630.10:FF:000315', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157379, NULL, 'G3DSA:3.80.10.10:FF:001382', NULL, NULL, 'F-box/LRR-repeat protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(157380, NULL, 'G3DSA:1.25.40.20:FF:001102', NULL, NULL, 'Putative ankyrin repeat domain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(157381, NULL, 'G3DSA:1.10.510.10:FF:000922', NULL, NULL, 'Protein kinase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(157382, NULL, 'G3DSA:3.50.30.30:FF:000030', NULL, NULL, 'Peptide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(157383, NULL, 'G3DSA:3.30.200.20:FF:000086', NULL, NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(157384, NULL, 'G3DSA:3.30.460.20:FF:000009', NULL, NULL, 'Magnesium transport protein CorA', NULL, NULL, NULL, NULL, NULL, 4),
(157385, NULL, 'G3DSA:3.90.640.10:FF:000147', NULL, NULL, 'Actin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157386, NULL, 'G3DSA:1.25.40.10:FF:004590', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g49240, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(157387, NULL, 'G3DSA:2.130.10.10:FF:004613', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157388, NULL, 'G3DSA:3.60.20.10:FF:000231', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157389, NULL, 'G3DSA:2.130.10.10:FF:005102', NULL, NULL, 'Dynein intermediate chain 2, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(157390, NULL, 'G3DSA:3.30.200.110:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(157391, NULL, 'G3DSA:3.20.20.450:FF:000020', NULL, NULL, 'Biofilm architecture maintenance protein MbaA', NULL, NULL, NULL, NULL, NULL, 4),
(157392, NULL, 'G3DSA:3.40.50.2300:FF:000665', NULL, NULL, 'Response regulator VieA', NULL, NULL, NULL, NULL, NULL, 4),
(157393, NULL, 'G3DSA:1.20.120.720:FF:000006', NULL, NULL, 'Unconventional myosin-Va', NULL, NULL, NULL, NULL, NULL, 4),
(157394, NULL, 'G3DSA:3.40.50.720:FF:000506', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase (NAD(P)(+))', NULL, NULL, NULL, NULL, NULL, 4),
(157395, NULL, 'G3DSA:1.20.1070.10:FF:002115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157396, NULL, 'G3DSA:1.10.40.30:FF:000031', NULL, NULL, '3-carboxy-cis,cis-muconate cycloisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(157397, NULL, 'G3DSA:3.90.226.10:FF:000258', NULL, NULL, 'S41 family peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(157398, NULL, 'G3DSA:3.30.230.10:FF:000293', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157399, NULL, 'G3DSA:3.10.350.10:FF:000019', NULL, NULL, 'Cell wall hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(157400, NULL, 'G3DSA:1.20.58.1120:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157401, NULL, 'G3DSA:1.10.443.10:FF:000018', NULL, NULL, 'Site-specific recombinase Flp', NULL, NULL, NULL, NULL, NULL, 4),
(157402, NULL, 'G3DSA:2.60.200.20:FF:000268', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157403, NULL, 'G3DSA:1.25.40.10:FF:004348', NULL, NULL, 'High chlorophyll fluorescence3', NULL, NULL, NULL, NULL, NULL, 4),
(157404, NULL, 'G3DSA:2.60.40.1120:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157405, NULL, 'G3DSA:1.25.10.10:FF:002199', NULL, NULL, 'Ring assembly protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(157406, NULL, 'G3DSA:3.10.450.50:FF:000011', NULL, NULL, 'Nuclear transport factor 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157407, NULL, 'G3DSA:1.25.40.20:FF:000787', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157408, NULL, 'G3DSA:1.10.135.10:FF:000016', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157409, NULL, 'G3DSA:3.80.10.10:FF:001758', NULL, NULL, 'NLR family member X1', NULL, NULL, NULL, NULL, NULL, 4),
(157410, NULL, 'G3DSA:3.40.50.1480:FF:000003', NULL, NULL, 'Adenosylhomocysteinase', NULL, NULL, NULL, NULL, NULL, 4),
(157411, NULL, 'G3DSA:1.10.340.70:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157412, NULL, 'G3DSA:3.10.20.90:FF:000908', NULL, NULL, 'Tln1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(157413, NULL, 'G3DSA:4.10.260.10:FF:000008', NULL, NULL, 'G protein gamma subunit', NULL, NULL, NULL, NULL, NULL, 4),
(157414, NULL, 'G3DSA:3.40.50.1380:FF:000029', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(157415, NULL, 'G3DSA:3.40.50.1820:FF:001696', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157416, NULL, 'G3DSA:2.170.130.10:FF:000020', NULL, NULL, 'TonB-dependent receptor', NULL, NULL, NULL, NULL, NULL, 4),
(157417, NULL, 'G3DSA:2.160.20.10:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157418, NULL, 'G3DSA:3.40.50.300:FF:007789', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157419, NULL, 'G3DSA:3.30.200.20:FF:000794', NULL, NULL, 'Acyl-CoA dehydrogenase FadE36', NULL, NULL, NULL, NULL, NULL, 4),
(157420, NULL, 'G3DSA:2.60.40.1660:FF:000019', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit beta-3', NULL, NULL, NULL, NULL, NULL, 4),
(157421, NULL, 'G3DSA:3.20.20.30:FF:000036', NULL, NULL, 'LuxA-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(157422, NULL, 'G3DSA:3.30.450.70:FF:000006', NULL, NULL, 'Trafficking particle complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(157423, NULL, 'G3DSA:1.10.510.10:FF:003182', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157424, NULL, 'G3DSA:3.30.70.330:FF:002425', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(157425, NULL, 'G3DSA:1.25.40.10:FF:000784', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(157426, NULL, 'G3DSA:1.50.10.10:FF:000044', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(157427, NULL, 'G3DSA:2.30.42.10:FF:000184', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(157428, NULL, 'G3DSA:3.60.21.10:FF:000492', NULL, NULL, 'Serine/threonine-protein phosphatase with EF-hands', NULL, NULL, NULL, NULL, NULL, 4),
(157429, NULL, 'G3DSA:3.30.160.60:FF:000459', NULL, NULL, 'Zinc finger with KRAB and SCAN domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(157430, NULL, 'G3DSA:3.30.200.20:FF:000176', NULL, NULL, 'Fructosamine kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(157431, NULL, 'G3DSA:3.40.50.1360:FF:000023', NULL, NULL, 'Glucosamine-6-phosphate isomerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157432, NULL, 'G3DSA:3.40.50.1370:FF:000026', NULL, NULL, 'Ornithine carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(157433, NULL, 'G3DSA:2.60.40.150:FF:000687', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(157434, NULL, 'G3DSA:3.50.50.60:FF:000107', NULL, NULL, 'Rab proteins geranylgeranyltransferase component A', NULL, NULL, NULL, NULL, NULL, 4),
(157435, NULL, 'G3DSA:3.30.300.30:FF:000130', NULL, NULL, 'Peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(157436, NULL, 'G3DSA:1.10.20.10:FF:000075', NULL, NULL, 'WGS project CABT00000000 data, contig 2.56', NULL, NULL, NULL, NULL, NULL, 4),
(157437, NULL, 'G3DSA:2.30.30.40:FF:000295', NULL, NULL, 'Blast:Tyrosine-protein kinase Src-1', NULL, NULL, NULL, NULL, NULL, 4),
(157438, NULL, 'G3DSA:3.30.450.80:FF:000009', NULL, NULL, 'Quorum-sensing transcriptional activator EsaR', NULL, NULL, NULL, NULL, NULL, 4),
(157439, NULL, 'G3DSA:1.10.150.20:FF:000116', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(157440, NULL, 'G3DSA:2.20.100.10:FF:000109', NULL, NULL, 'Spondin-1', NULL, NULL, NULL, NULL, NULL, 4),
(157441, NULL, 'G3DSA:3.20.20.20:FF:000033', NULL, NULL, 'Methionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(157442, NULL, 'G3DSA:3.30.60.20:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157443, NULL, 'G3DSA:3.30.750.24:FF:000154', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(157444, NULL, 'G3DSA:1.10.1740.100:FF:000005', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(157445, NULL, 'G3DSA:1.20.58.1380:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157446, NULL, 'G3DSA:3.90.70.10:FF:000289', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 26', NULL, NULL, NULL, NULL, NULL, 4),
(157447, NULL, 'G3DSA:3.40.50.2300:FF:000047', NULL, NULL, 'PTS system mannitol-specific transporter subunit IICBA', NULL, NULL, NULL, NULL, NULL, 4),
(157448, NULL, 'G3DSA:1.20.1560.10:FF:000040', NULL, NULL, 'Multidrug ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(157449, NULL, 'G3DSA:3.40.1090.10:FF:000109', NULL, NULL, 'Patatin', NULL, NULL, NULL, NULL, NULL, 4),
(157450, NULL, 'G3DSA:1.25.10.10:FF:000428', NULL, NULL, 'Adaptor related protein complex 3 subunit beta 1', NULL, NULL, NULL, NULL, NULL, 4),
(157451, NULL, 'G3DSA:1.50.10.20:FF:000047', NULL, NULL, 'Complement 4B (Chido blood group)', NULL, NULL, NULL, NULL, NULL, 4),
(157452, NULL, 'G3DSA:3.30.70.330:FF:001498', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157453, NULL, 'G3DSA:3.90.960.10:FF:000019', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(157454, NULL, 'G3DSA:2.60.40.60:FF:000474', NULL, NULL, 'GD20623', NULL, NULL, NULL, NULL, NULL, 4),
(157455, NULL, 'G3DSA:1.10.238.10:FF:000289', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(157456, NULL, 'G3DSA:3.30.450.40:FF:000138', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(157457, NULL, 'G3DSA:3.30.50.10:FF:000127', NULL, NULL, 'Xenobiotic receptor', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(157458, NULL, 'G3DSA:1.10.10.10:FF:001029', NULL, NULL, 'Related to RPC82-RNA polymerase III subunit C82', NULL, NULL, NULL, NULL, NULL, 4),
(157459, NULL, 'G3DSA:2.30.29.30:FF:000075', NULL, NULL, 'unconventional myosin-VIIa', NULL, NULL, NULL, NULL, NULL, 4),
(157460, NULL, 'G3DSA:2.60.120.200:FF:000205', NULL, NULL, 'MAM and LDL receptor class A domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(157461, NULL, 'G3DSA:3.30.497.10:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157462, NULL, 'G3DSA:3.90.1150.10:FF:000266', NULL, NULL, '3-oxo-glucose-6-phosphate:glutamate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(157463, NULL, 'G3DSA:2.40.70.10:FF:000265', NULL, NULL, 'Aspartic peptidase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(157464, NULL, 'G3DSA:3.30.160.60:FF:001920', NULL, NULL, 'Zinc finger protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(157465, NULL, 'G3DSA:3.30.390.80:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157466, NULL, 'G3DSA:3.40.140.70:FF:000003', NULL, NULL, 'Ubiquitin-like modifier-activating enzyme ATG7', NULL, NULL, NULL, NULL, NULL, 4),
(157467, NULL, 'G3DSA:3.30.40.10:FF:000626', NULL, NULL, 'Transmembrane ubiquitin ligase 1', NULL, NULL, NULL, NULL, NULL, 4),
(157468, NULL, 'G3DSA:3.30.450.30:FF:000079', NULL, NULL, 'Profilin', NULL, NULL, NULL, NULL, NULL, 4),
(157469, NULL, 'G3DSA:1.10.10.10:FF:000956', NULL, NULL, 'HxlR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(157470, NULL, 'G3DSA:3.80.10.10:FF:004107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157471, NULL, 'G3DSA:2.60.120.200:FF:000149', NULL, NULL, 'Beta-glucan synthesis-associated protein KRE6', NULL, NULL, NULL, NULL, NULL, 4),
(157472, NULL, 'G3DSA:1.10.630.10:FF:000341', NULL, NULL, 'Cytochrome P450, CYP85 clan', NULL, NULL, NULL, NULL, NULL, 4),
(157473, NULL, 'G3DSA:3.40.50.300:FF:003337', NULL, NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(157474, NULL, 'G3DSA:1.25.10.10:FF:001092', NULL, NULL, 'Pumilio RNA-binding family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(157475, NULL, 'G3DSA:3.40.50.300:FF:001213', NULL, NULL, 'DNA repair helicase RAD25', NULL, NULL, NULL, NULL, NULL, 4),
(157476, NULL, 'G3DSA:2.60.40.60:FF:000766', NULL, NULL, 'Cdh-4', NULL, NULL, NULL, NULL, NULL, 4),
(157477, NULL, 'G3DSA:2.60.470.10:FF:000010', NULL, NULL, 'Pickpocket 13', NULL, NULL, NULL, NULL, NULL, 4),
(157478, NULL, 'G3DSA:3.30.1140.32:FF:000001', NULL, NULL, '30S ribosomal protein S3', NULL, NULL, NULL, NULL, NULL, 4),
(157479, NULL, 'G3DSA:3.50.50.60:FF:000551', NULL, NULL, 'Spermidine dehydrogenase, SpdH', NULL, NULL, NULL, NULL, NULL, 4),
(157480, NULL, 'G3DSA:2.60.420.10:FF:000006', NULL, NULL, 'Cellobiose phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(157481, NULL, 'G3DSA:2.30.29.120:FF:000001', NULL, NULL, 'RTT106p Histone chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(157482, NULL, 'G3DSA:3.90.79.10:FF:000157', NULL, NULL, 'Hydrolase, NUDIX family', NULL, NULL, NULL, NULL, NULL, 4),
(157483, NULL, 'G3DSA:3.30.70.330:FF:002751', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157484, NULL, 'G3DSA:1.10.287.130:FF:000123', NULL, NULL, 'Probable two-component sensor', NULL, NULL, NULL, NULL, NULL, 4),
(157485, NULL, 'G3DSA:2.30.42.10:FF:000094', NULL, NULL, 'Zinc metalloprotease', NULL, NULL, NULL, NULL, NULL, 4),
(157486, NULL, 'G3DSA:2.10.25.10:FF:001573', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157487, NULL, 'G3DSA:2.130.10.10:FF:002376', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157488, NULL, 'G3DSA:2.60.490.10:FF:000011', NULL, NULL, 'Purinergic receptor P2X5-2', NULL, NULL, NULL, NULL, NULL, 4),
(157489, NULL, 'G3DSA:1.10.3260.10:FF:000008', NULL, NULL, 'DNA ligase 4', NULL, NULL, NULL, NULL, NULL, 4),
(157490, NULL, 'G3DSA:3.30.200.20:FF:000468', NULL, NULL, 'LysM receptor kinase 2', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(157491, NULL, 'G3DSA:2.60.40.10:FF:003505', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157492, NULL, 'G3DSA:1.10.287.130:FF:000180', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(157493, NULL, 'G3DSA:3.40.50.720:FF:001783', NULL, NULL, 'Probable 2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(157494, NULL, 'G3DSA:3.90.226.10:FF:000314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157495, NULL, 'G3DSA:3.30.450.20:FF:000132', NULL, NULL, 'Methyl-accepting chemotaxis protein PctA', NULL, NULL, NULL, NULL, NULL, 4),
(157496, NULL, 'G3DSA:1.20.1250.20:FF:002363', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157497, NULL, 'G3DSA:2.60.40.10:FF:001414', NULL, NULL, 'Anosmin 1', NULL, NULL, NULL, NULL, NULL, 4),
(157498, NULL, 'G3DSA:1.20.1250.20:FF:000272', NULL, NULL, 'Probable anion transporter 6, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(157499, NULL, 'G3DSA:3.30.530.20:FF:000190', NULL, NULL, 'Os06g0526466 protein', NULL, NULL, NULL, NULL, NULL, 4),
(157500, NULL, 'G3DSA:3.40.190.10:FF:000562', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(157501, NULL, 'G3DSA:3.30.70.980:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157502, NULL, 'G3DSA:3.30.160.60:FF:003101', NULL, NULL, 'Ras-responsive element-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(157503, NULL, 'G3DSA:2.60.120.10:FF:000023', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(157504, NULL, 'G3DSA:1.20.1250.20:FF:000233', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(157505, NULL, 'G3DSA:1.25.40.10:FF:002908', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157506, NULL, 'G3DSA:1.25.40.40:FF:000001', NULL, NULL, 'Cytochrome c oxidase subunit VI', NULL, NULL, NULL, NULL, NULL, 4),
(157507, NULL, 'G3DSA:1.25.40.10:FF:003370', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(157508, NULL, 'G3DSA:3.40.50.300:FF:005052', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157509, NULL, 'G3DSA:3.30.160.60:FF:004085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157510, NULL, 'G3DSA:2.130.10.10:FF:004467', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157511, NULL, 'G3DSA:3.30.200.20:FF:000850', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157512, NULL, 'G3DSA:1.10.510.10:FF:000866', NULL, NULL, 'Serine/threonine-protein kinase GA29083', NULL, NULL, NULL, NULL, NULL, 4),
(157513, NULL, 'G3DSA:3.30.465.10:FF:000028', NULL, NULL, 'Related to ALO1-D-arabinono-1,4-lactone oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(157514, NULL, 'G3DSA:3.30.9.10:FF:000301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157515, NULL, 'G3DSA:3.50.50.60:FF:000080', NULL, NULL, 'Spermine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(157516, NULL, 'G3DSA:3.10.129.10:FF:000090', NULL, NULL, 'Tol-pal system-associated acyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(157517, NULL, 'G3DSA:3.30.70.3490:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157518, NULL, 'G3DSA:2.60.120.20:FF:000026', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(157519, NULL, 'G3DSA:3.40.50.620:FF:000207', NULL, NULL, 'Tryptophan--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(157520, NULL, 'G3DSA:3.10.330.10:FF:000046', NULL, NULL, 'Peroxisome biogenesis factor 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(157521, NULL, 'G3DSA:3.30.2040.10:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157522, NULL, 'G3DSA:2.60.40.820:FF:000017', NULL, NULL, 'TBR1 isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(157523, NULL, 'G3DSA:3.30.70.330:FF:002223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(157524, NULL, 'G3DSA:2.30.30.40:FF:000564', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157525, NULL, 'G3DSA:3.40.50.1240:FF:000038', NULL, NULL, 'venom acid phosphatase Acph-1', NULL, NULL, NULL, NULL, NULL, 4),
(157526, NULL, 'G3DSA:3.30.450.40:FF:000195', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(157527, NULL, 'G3DSA:1.10.132.10:FF:000009', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(157528, NULL, 'G3DSA:1.20.1070.10:FF:001593', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(157529, NULL, 'G3DSA:3.40.50.1760:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157530, NULL, 'G3DSA:2.170.120.12:FF:000038', NULL, NULL, 'DNA-directed RNA polymerases II IV and V subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(157531, NULL, 'G3DSA:3.30.40.10:FF:000211', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(157532, NULL, 'G3DSA:2.30.30.100:FF:000194', NULL, NULL, 'Bifunctional ligase/repressor BirA', NULL, NULL, NULL, NULL, NULL, 4),
(157533, NULL, 'G3DSA:3.40.640.10:FF:000142', NULL, NULL, 'Putative ornithine aminotransferase RocD2', NULL, NULL, NULL, NULL, NULL, 4),
(157534, NULL, 'G3DSA:3.30.40.10:FF:000155', NULL, NULL, 'RNA binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(157535, NULL, 'G3DSA:1.20.920.20:FF:000015', NULL, NULL, 'Dynein beta chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157536, NULL, 'G3DSA:3.40.640.10:FF:000518', NULL, NULL, 'Selenocysteine lyase', NULL, NULL, NULL, NULL, NULL, 4),
(157537, NULL, 'G3DSA:3.30.530.20:FF:000077', NULL, NULL, 'START domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(157538, NULL, 'G3DSA:1.20.1080.10:FF:000104', NULL, NULL, 'Aquaporin 8', NULL, NULL, NULL, NULL, NULL, 4),
(157539, NULL, 'G3DSA:2.60.210.10:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157540, NULL, 'G3DSA:1.25.10.10:FF:002671', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157541, NULL, 'G3DSA:1.20.5.420:FF:000013', NULL, NULL, 'LD24721p', NULL, NULL, NULL, NULL, NULL, 4),
(157542, NULL, 'G3DSA:3.90.1150.170:FF:000010', NULL, NULL, 'Zgc:112198', NULL, NULL, NULL, NULL, NULL, 4),
(157543, NULL, 'G3DSA:3.30.450.20:FF:000076', NULL, NULL, 'Phosphate regulon sensor histidine kinase PhoR', NULL, NULL, NULL, NULL, NULL, 4),
(157544, NULL, 'G3DSA:3.80.10.10:FF:000364', NULL, NULL, 'NLR family CARD domain containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(157545, NULL, 'G3DSA:1.10.132.30:FF:000021', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(157546, NULL, 'G3DSA:1.25.40.10:FF:000817', NULL, NULL, 'Unplaced genomic scaffold supercont2.15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(157547, NULL, 'G3DSA:1.10.10.750:FF:000022', NULL, NULL, 'GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(157548, NULL, 'G3DSA:3.40.50.1000:FF:000876', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157549, NULL, 'G3DSA:1.25.40.990:FF:000039', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 8 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(157550, NULL, 'G3DSA:3.30.70.330:FF:000278', NULL, NULL, 'Nucleolin', NULL, NULL, NULL, NULL, NULL, 4),
(157551, NULL, 'G3DSA:1.10.490.10:FF:000043', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157552, NULL, 'G3DSA:3.40.50.1820:FF:000206', NULL, NULL, 'Acetyl xylan esterase', NULL, NULL, NULL, NULL, NULL, 4),
(157553, NULL, 'G3DSA:1.25.40.10:FF:000458', NULL, NULL, 'Pentatricopeptide, putative, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(157554, NULL, 'G3DSA:3.40.190.10:FF:000449', NULL, NULL, 'Ionotropic receptor 40a', NULL, NULL, NULL, NULL, NULL, 4),
(157555, NULL, 'G3DSA:2.170.300.10:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157556, NULL, 'G3DSA:3.40.1190.20:FF:000064', NULL, NULL, 'Ribokinase', NULL, NULL, NULL, NULL, NULL, 4),
(157557, NULL, 'G3DSA:2.170.270.10:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(157558, NULL, 'G3DSA:2.40.70.10:FF:000529', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157559, NULL, 'G3DSA:3.90.550.50:FF:000225', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157560, NULL, 'G3DSA:1.10.510.10:FF:001703', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157561, NULL, 'G3DSA:2.20.20.110:FF:000006', NULL, NULL, 'DNA repair protein RAD4', NULL, NULL, NULL, NULL, NULL, 4),
(157562, NULL, 'G3DSA:3.90.1640.10:FF:000023', NULL, NULL, 'Protein prune-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(157563, NULL, 'G3DSA:1.20.120.1240:FF:000006', NULL, NULL, 'Dynamin-1-like protein isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(157564, NULL, 'G3DSA:3.40.50.300:FF:004647', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157565, NULL, 'G3DSA:3.30.70.270:FF:000092', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(157566, NULL, 'G3DSA:3.30.900.10:FF:000029', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157567, NULL, 'G3DSA:1.25.10.10:FF:000962', NULL, NULL, 'Importin alpha-1 subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157568, NULL, 'G3DSA:1.25.40.10:FF:004617', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157569, NULL, 'G3DSA:2.60.40.10:FF:004809', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157570, NULL, 'G3DSA:1.10.150.20:FF:000032', NULL, NULL, 'meiotic recombination protein DMC1/LIM15 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(157571, NULL, 'G3DSA:3.30.110.20:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157572, NULL, 'G3DSA:3.50.50.60:FF:000927', NULL, NULL, 'Probable SOLUBLE pyridine nucleotide transhydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(157573, NULL, 'G3DSA:1.20.930.60:FF:000005', NULL, NULL, 'DUF89 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(157574, NULL, 'G3DSA:3.90.70.10:FF:000345', NULL, NULL, 'Ubiquitin-specific peptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(157575, NULL, 'G3DSA:1.20.1270.10:FF:000118', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(157576, NULL, 'G3DSA:1.20.1740.10:FF:000082', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(157577, NULL, 'G3DSA:1.20.58.400:FF:000006', NULL, NULL, 't-SNARE VTI1', NULL, NULL, NULL, NULL, NULL, 4),
(157578, NULL, 'G3DSA:1.20.1070.10:FF:001391', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157579, NULL, 'G3DSA:3.30.590.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157580, NULL, 'G3DSA:3.30.70.400:FF:000001', NULL, NULL, 'Chemotaxis protein CheA', NULL, NULL, NULL, NULL, NULL, 4),
(157581, NULL, 'G3DSA:3.40.50.2300:FF:000491', NULL, NULL, 'Branched-chain amino acid ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(157582, NULL, 'G3DSA:3.80.10.10:FF:001617', NULL, NULL, 'Nyctalopin', NULL, NULL, NULL, NULL, NULL, 4),
(157583, NULL, 'G3DSA:3.30.1520.10:FF:000022', NULL, NULL, 'Kinesin family member 16B', NULL, NULL, NULL, NULL, NULL, 4),
(157584, NULL, 'G3DSA:1.10.510.10:FF:002631', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157585, NULL, 'G3DSA:2.40.50.100:FF:000179', NULL, NULL, 'Pyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(157586, NULL, 'G3DSA:3.30.1240.10:FF:000040', NULL, NULL, 'Cof-type HAD-IIB family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(157587, NULL, 'G3DSA:1.10.472.10:FF:000501', NULL, NULL, 'RNA polymerase II holoenzyme cyclin-like subunit', NULL, NULL, NULL, NULL, NULL, 4),
(157588, NULL, 'G3DSA:3.90.320.10:FF:000016', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(157589, NULL, 'G3DSA:2.40.160.50:FF:000031', NULL, NULL, 'AaceriAER403Cp', NULL, NULL, NULL, NULL, NULL, 4),
(157590, NULL, 'G3DSA:3.40.50.300:FF:000847', NULL, NULL, 'helicase-like transcription factor isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(157591, NULL, 'G3DSA:3.30.40.10:FF:002341', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(157592, NULL, 'G3DSA:3.40.120.10:FF:000086', NULL, NULL, 'Phosphoglucomutase/phosphomannomutase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(157593, NULL, 'G3DSA:3.40.50.300:FF:002556', NULL, NULL, 'Pentafunctional AROM polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(157594, NULL, 'G3DSA:3.30.559.10:FF:000207', NULL, NULL, 'Putative peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(157595, NULL, 'G3DSA:3.10.310.10:FF:000045', NULL, NULL, 'trans-L-3-hydroxyproline dehydratase-like', NULL, NULL, NULL, NULL, NULL, 4),
(157596, NULL, 'G3DSA:1.25.40.10:FF:000930', NULL, NULL, 'Serine/threonine protein phosphatase type 5', NULL, NULL, NULL, NULL, NULL, 4),
(157597, NULL, 'G3DSA:1.20.1070.10:FF:000373', NULL, NULL, 'Neuropeptide F receptor', NULL, NULL, NULL, NULL, NULL, 4),
(157598, NULL, 'G3DSA:2.40.50.770:FF:000008', NULL, NULL, 'RMi1 (RMI1) Homolog', NULL, NULL, NULL, NULL, NULL, 4),
(157599, NULL, 'G3DSA:3.40.190.10:FF:000505', NULL, NULL, 'Oligopeptide ABC transporter,oligopeptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(157600, NULL, 'G3DSA:3.30.160.60:FF:000993', NULL, NULL, 'pH-response transcription factor pacC/RIM101', NULL, NULL, NULL, NULL, NULL, 4),
(157601, NULL, 'G3DSA:3.90.226.10:FF:000084', NULL, NULL, 'Enoyl-CoA delta isomerase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(157602, NULL, 'G3DSA:3.80.10.10:FF:004164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157603, NULL, 'G3DSA:3.40.50.20:FF:000051', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(157604, NULL, 'G3DSA:3.40.50.2300:FF:000811', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157605, NULL, 'G3DSA:3.10.590.10:FF:000003', NULL, NULL, 'Thymocyte nuclear protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(157606, NULL, 'G3DSA:3.20.20.190:FF:000071', NULL, NULL, 'glycerophosphocholine phosphodiesterase GPCPD1', NULL, NULL, NULL, NULL, NULL, 4),
(157607, NULL, 'G3DSA:1.20.1420.30:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157608, NULL, 'G3DSA:3.30.870.10:FF:000178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157609, NULL, 'G3DSA:2.130.10.10:FF:003303', NULL, NULL, 'Heterotrimeric G protein beta subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(157610, NULL, 'G3DSA:3.40.50.720:FF:000147', NULL, NULL, 'Reticulon-4-interacting protein 1 homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(157611, NULL, 'G3DSA:1.10.238.10:FF:000676', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157612, NULL, 'G3DSA:1.10.287.3550:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157613, NULL, 'G3DSA:1.10.3470.10:FF:000018', NULL, NULL, 'Iron-compound ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(157614, NULL, 'G3DSA:1.20.5.550:FF:000001', NULL, NULL, 'Bifunctional protein PutA', NULL, NULL, NULL, NULL, NULL, 4),
(157615, NULL, 'G3DSA:1.25.40.10:FF:001240', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(157616, NULL, 'G3DSA:3.30.428.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157617, NULL, 'G3DSA:3.30.200.20:FF:000322', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(157618, NULL, 'G3DSA:2.20.110.10:FF:000048', NULL, NULL, 'Alsin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(157619, NULL, 'G3DSA:1.20.58.760:FF:000007', NULL, NULL, 'ATP-dependent zinc metalloprotease', NULL, NULL, NULL, NULL, NULL, 4),
(157620, NULL, 'G3DSA:2.60.40.60:FF:000709', NULL, NULL, 'Cadherin-4', NULL, NULL, NULL, NULL, NULL, 4),
(157621, NULL, 'G3DSA:2.60.120.200:FF:000060', NULL, NULL, 'Terribly reduced optic lobes, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(157622, NULL, 'G3DSA:3.30.70.120:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157623, NULL, 'G3DSA:1.25.40.10:FF:004056', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157624, NULL, 'G3DSA:1.25.40.20:FF:001243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(157625, NULL, 'G3DSA:3.40.5.10:FF:000006', NULL, NULL, '50S ribosomal protein L9, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(157626, NULL, 'G3DSA:3.40.47.10:FF:000136', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157627, NULL, 'G3DSA:1.25.40.10:FF:004674', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g42450, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(157628, NULL, 'G3DSA:2.30.30.30:FF:000090', NULL, NULL, '30S ribosomal protein S4e', NULL, NULL, NULL, NULL, NULL, 4),
(157629, NULL, 'G3DSA:2.60.40.150:FF:000395', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157630, NULL, 'G3DSA:2.130.10.110:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157631, NULL, 'G3DSA:3.40.50.300:FF:007412', NULL, NULL, 'ATP-binding cassette transporter, subfamily C, member 14, group MRP protein PpABCC14', NULL, NULL, NULL, NULL, NULL, 4),
(157632, NULL, 'G3DSA:3.40.50.1000:FF:000348', NULL, NULL, 'HAD hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(157633, NULL, 'G3DSA:1.10.10.10:FF:000776', NULL, NULL, 'Unplaced genomic scaffold supercont1.9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(157634, NULL, 'G3DSA:3.40.50.2300:FF:000339', NULL, NULL, 'Transcriptional regulator PtxS', NULL, NULL, NULL, NULL, NULL, 4),
(157635, NULL, 'G3DSA:3.30.160.20:FF:000121', NULL, NULL, 'Glycosyl hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(157636, NULL, 'G3DSA:2.60.40.10:FF:002718', NULL, NULL, 'Inositol polyphosphate 5-phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157637, NULL, 'G3DSA:3.30.40.10:FF:002009', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(157638, NULL, 'G3DSA:2.60.40.10:FF:002398', NULL, NULL, 'Beat IIb', NULL, NULL, NULL, NULL, NULL, 4),
(157639, NULL, 'G3DSA:3.40.630.30:FF:000647', NULL, NULL, 'N-acetyltransferase ats1', NULL, NULL, NULL, NULL, NULL, 4),
(157640, NULL, 'G3DSA:1.10.287.110:FF:000168', NULL, NULL, 'BnaC04g52570D protein', NULL, NULL, NULL, NULL, NULL, 4),
(157641, NULL, 'G3DSA:1.25.40.120:FF:000071', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157642, NULL, 'G3DSA:1.10.10.60:FF:001112', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157643, NULL, 'G3DSA:2.60.40.640:FF:000087', NULL, NULL, 'Os03g0679100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(157644, NULL, 'G3DSA:3.10.110.10:FF:000064', NULL, NULL, 'RWD domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(157645, NULL, 'G3DSA:2.130.10.10:FF:001123', NULL, NULL, 'Unplaced genomic scaffold supercont1.24, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(157646, NULL, 'G3DSA:1.10.533.10:FF:000290', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157647, NULL, 'G3DSA:3.20.20.80:FF:000096', NULL, NULL, 'Xylan alpha-1,2-glucuronidase', NULL, NULL, NULL, NULL, NULL, 4),
(157648, NULL, 'G3DSA:1.10.2000.10:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157649, NULL, 'G3DSA:3.80.10.10:FF:001584', NULL, NULL, 'RNI-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(157650, NULL, 'G3DSA:3.10.20.90:FF:000616', NULL, NULL, 'AGAP008530-PA', NULL, NULL, NULL, NULL, NULL, 4),
(157651, NULL, 'G3DSA:2.30.30.30:FF:000089', NULL, NULL, 'Transcription termination/antitermination protein NusG', NULL, NULL, NULL, NULL, NULL, 4),
(157652, NULL, 'G3DSA:1.10.510.10:FF:002485', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157653, NULL, 'G3DSA:3.40.190.290:FF:000109', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(157654, NULL, 'G3DSA:2.130.10.10:FF:002612', NULL, NULL, 'Nuclear pore complex protein nup43', NULL, NULL, NULL, NULL, NULL, 4),
(157655, NULL, 'G3DSA:3.40.850.10:FF:000152', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(157656, NULL, 'G3DSA:3.40.50.150:FF:001802', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157657, NULL, 'G3DSA:2.10.25.10:FF:001393', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(157658, NULL, 'G3DSA:1.10.472.10:FF:000355', NULL, NULL, 'Cyclin protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(157659, NULL, 'G3DSA:3.20.180.20:FF:000018', NULL, NULL, 'Dynein heavy chain, cytosolic, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157660, NULL, 'G3DSA:1.25.40.10:FF:002875', NULL, NULL, 'Protein NRDE2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(157661, NULL, 'G3DSA:3.80.10.10:FF:003383', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157662, NULL, 'G3DSA:1.25.40.10:FF:002347', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g15300', NULL, NULL, NULL, NULL, NULL, 4),
(157663, NULL, 'G3DSA:2.40.50.100:FF:000089', NULL, NULL, 'Sugar ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(157664, NULL, 'G3DSA:3.40.390.10:FF:000072', NULL, NULL, 'Matrix metallopeptidase 25', NULL, NULL, NULL, NULL, NULL, 4),
(157665, NULL, 'G3DSA:1.10.730.10:FF:000085', NULL, NULL, 'Leucyl-tRNA synthetase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(157666, NULL, 'G3DSA:3.10.100.10:FF:000035', NULL, NULL, 'C-type mannose receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(157667, NULL, 'G3DSA:3.40.50.1760:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157668, NULL, 'G3DSA:2.40.10.10:FF:000380', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157669, NULL, 'G3DSA:3.40.850.10:FF:000096', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(157670, NULL, 'G3DSA:2.60.40.1170:FF:000081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157671, NULL, 'G3DSA:1.10.220.30:FF:000012', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(157672, NULL, 'G3DSA:1.20.5.170:FF:000213', NULL, NULL, 'Galactose-responsive transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(157673, NULL, 'G3DSA:3.40.50.10240:FF:000022', NULL, NULL, 'Thiamine pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(157674, NULL, 'G3DSA:3.90.950.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157675, NULL, 'G3DSA:3.90.640.10:FF:000001', NULL, NULL, 'Actin, muscle', NULL, NULL, NULL, NULL, NULL, 4),
(157676, NULL, 'G3DSA:2.130.10.10:FF:001033', NULL, NULL, 'Pre-mRNA-processing factor 19 2', NULL, NULL, NULL, NULL, NULL, 4),
(157677, NULL, 'G3DSA:2.60.120.590:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157678, NULL, 'G3DSA:3.90.70.10:FF:000676', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157679, NULL, 'G3DSA:3.30.70.330:FF:000188', NULL, NULL, 'Negative elongation factor complex member E', NULL, NULL, NULL, NULL, NULL, 4),
(157680, NULL, 'G3DSA:1.10.260.100:FF:000033', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(157681, NULL, 'G3DSA:2.10.110.10:FF:000045', NULL, NULL, 'LIM domain-binding protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(157682, NULL, 'G3DSA:1.20.1280.290:FF:000032', NULL, NULL, 'Sugar transporter SWEET', NULL, NULL, NULL, NULL, NULL, 4),
(157683, NULL, 'G3DSA:3.40.50.300:FF:006356', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157684, NULL, 'G3DSA:2.60.40.10:FF:000690', NULL, NULL, 'Cytokine receptor like factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(157685, NULL, 'G3DSA:1.20.1250.20:FF:001492', NULL, NULL, 'Protein CBG06794', NULL, NULL, NULL, NULL, NULL, 4),
(157686, NULL, 'G3DSA:1.10.10.60:FF:001022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157687, NULL, 'G3DSA:2.30.30.190:FF:000001', NULL, NULL, 'Putative CAP-Gly domain-containing linker protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(157688, NULL, 'G3DSA:2.40.170.20:FF:000129', NULL, NULL, 'Second ferric pyoverdine receptor FpvB', NULL, NULL, NULL, NULL, NULL, 4),
(157689, NULL, 'G3DSA:3.80.10.10:FF:003854', NULL, NULL, 'PH domain and leucine rich repeat protein phosphatase 2', NULL, NULL, NULL, NULL, NULL, 4),
(157690, NULL, 'G3DSA:3.30.70.330:FF:002189', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157691, NULL, 'G3DSA:1.25.40.20:FF:000933', NULL, NULL, 'Ankyrin repeat domain 9', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(157692, NULL, 'G3DSA:2.60.34.10:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157693, NULL, 'G3DSA:3.30.70.3080:FF:000002', NULL, NULL, 'Alpha,alpha-trehalose-phosphate synthase [UDP-forming] 2', NULL, NULL, NULL, NULL, NULL, 4),
(157694, NULL, 'G3DSA:3.40.50.10260:FF:000028', NULL, NULL, 'YALI0D14410p', NULL, NULL, NULL, NULL, NULL, 4),
(157695, NULL, 'G3DSA:1.10.20.10:FF:000277', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157696, NULL, 'G3DSA:2.60.120.290:FF:000013', NULL, NULL, 'Membrane frizzled-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(157697, NULL, 'G3DSA:2.60.40.60:FF:001019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157698, NULL, 'G3DSA:2.60.470.10:FF:000009', NULL, NULL, 'Pickpocket protein 28', NULL, NULL, NULL, NULL, NULL, 4),
(157699, NULL, 'G3DSA:3.40.50.150:FF:001331', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157700, NULL, 'G3DSA:3.30.930.10:FF:000003', NULL, NULL, 'Phenylalanine--tRNA ligase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(157701, NULL, 'G3DSA:1.20.58.1040:FF:000017', NULL, NULL, '1,3-beta-glucanosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(157702, NULL, 'G3DSA:2.40.30.30:FF:000004', NULL, NULL, 'Riboflavin biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(157703, NULL, 'G3DSA:1.20.1050.10:FF:000136', NULL, NULL, 'YqjG-type gamma-glutamylcysteinyl-hydroquinone reductase', NULL, NULL, NULL, NULL, NULL, 4),
(157704, NULL, 'G3DSA:1.10.10.10:FF:000248', NULL, NULL, 'Fur family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(157705, NULL, 'G3DSA:1.10.220.100:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157706, NULL, 'G3DSA:2.20.25.30:FF:000010', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(157707, NULL, 'G3DSA:1.25.10.10:FF:001125', NULL, NULL, 'WAPL (Wings apart-like protein regulation of heterochromatin) protein', NULL, NULL, NULL, NULL, NULL, 4),
(157708, NULL, 'G3DSA:1.20.58.1030:FF:000014', NULL, NULL, 'DNA replication complex GINS protein SLD5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157709, NULL, 'G3DSA:3.40.50.150:FF:000785', NULL, NULL, '5-pentadecatrienyl resorcinol O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(157710, NULL, 'G3DSA:1.10.1220.70:FF:000001', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(157711, NULL, 'G3DSA:3.40.50.970:FF:000172', NULL, NULL, '2-oxoisovalerate dehydrogenase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(157712, NULL, 'G3DSA:2.60.120.260:FF:000381', NULL, NULL, 'Beta-galactosidase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(157713, NULL, 'G3DSA:1.20.58.1020:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157714, NULL, 'G3DSA:3.30.70.330:FF:001205', NULL, NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(157715, NULL, 'G3DSA:3.90.1860.10:FF:000005', NULL, NULL, 'tRNA-splicing ligase RtcB, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157716, NULL, 'G3DSA:1.25.70.10:FF:000084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157717, NULL, 'G3DSA:3.30.160.60:FF:001156', NULL, NULL, 'Zinc finger protein 407', NULL, NULL, NULL, NULL, NULL, 4),
(157718, NULL, 'G3DSA:3.40.50.720:FF:002507', NULL, NULL, 'Adenylate kinase 7', NULL, NULL, NULL, NULL, NULL, 4),
(157719, NULL, 'G3DSA:1.25.40.10:FF:003038', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(157720, NULL, 'G3DSA:3.90.110.10:FF:000006', NULL, NULL, 'putative malate dehydrogenase 1B', NULL, NULL, NULL, NULL, NULL, 4),
(157721, NULL, 'G3DSA:2.60.40.10:FF:001381', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(157722, NULL, 'G3DSA:3.30.310.10:FF:000001', NULL, NULL, 'TATA-box-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(157723, NULL, 'G3DSA:1.20.120.520:FF:000008', NULL, NULL, 'BnaA01g26820D protein', NULL, NULL, NULL, NULL, NULL, 4),
(157724, NULL, 'G3DSA:3.40.50.970:FF:000115', NULL, NULL, 'Probable acetohydroxyacid synthase ilvX', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(157725, NULL, 'G3DSA:1.20.1250.20:FF:001868', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157726, NULL, 'G3DSA:3.40.50.300:FF:000757', NULL, NULL, 'MAGUK p55 subfamily member 7', NULL, NULL, NULL, NULL, NULL, 4),
(157727, NULL, 'G3DSA:2.60.40.10:FF:004961', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157728, NULL, 'G3DSA:3.40.50.300:FF:008486', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157729, NULL, 'G3DSA:3.90.1170.10:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157730, NULL, 'G3DSA:2.120.10.30:FF:000106', NULL, NULL, 'LDL receptor protein 1, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(157731, NULL, 'G3DSA:3.30.310.20:FF:000004', NULL, NULL, '3-methyladenine DNA glycosylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(157732, NULL, 'G3DSA:1.25.10.10:FF:001182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157733, NULL, 'G3DSA:2.60.200.10:FF:000024', NULL, NULL, 'Interferon regulatory factor like protein', NULL, NULL, NULL, NULL, NULL, 4),
(157734, NULL, 'G3DSA:3.30.70.330:FF:000334', NULL, NULL, 'RNA-binding protein BRN1', NULL, NULL, NULL, NULL, NULL, 4),
(157735, NULL, 'G3DSA:1.20.890.10:FF:000009', NULL, NULL, 'DPY30 domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(157736, NULL, 'G3DSA:3.40.850.10:FF:000242', NULL, NULL, 'Putative Unc104-like kinesin', NULL, NULL, NULL, NULL, NULL, 4),
(157737, NULL, 'G3DSA:3.30.1360.180:FF:000010', NULL, NULL, 'AGAP000982-PA', NULL, NULL, NULL, NULL, NULL, 4),
(157738, NULL, 'G3DSA:2.40.30.10:FF:000465', NULL, NULL, 'Nitric oxide synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157739, NULL, 'G3DSA:2.70.130.10:FF:000089', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157740, NULL, 'G3DSA:1.25.40.530:FF:000014', NULL, NULL, 'RhoGAP domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(157741, NULL, 'G3DSA:2.10.25.10:FF:001483', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157742, NULL, 'G3DSA:3.60.110.10:FF:000013', NULL, NULL, 'Omega-amidase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(157743, NULL, 'G3DSA:1.10.472.10:FF:000265', NULL, NULL, 'Cyclin, N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(157744, NULL, 'G3DSA:1.10.630.10:FF:000228', NULL, NULL, 'Cytochrome P450 hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(157745, NULL, 'G3DSA:2.60.260.20:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157746, NULL, 'G3DSA:2.60.40.10:FF:000358', NULL, NULL, 'Prolactin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(157747, NULL, 'G3DSA:3.30.200.20:FF:001957', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157748, NULL, 'G3DSA:3.90.770.10:FF:000005', NULL, NULL, '3-hydroxy-3-methylglutaryl-coenzyme A reductase', NULL, NULL, NULL, NULL, NULL, 4),
(157749, NULL, 'G3DSA:1.20.1560.10:FF:000219', NULL, NULL, 'Pyoverdine biosynthesis protein PvdE', NULL, NULL, NULL, NULL, NULL, 4),
(157750, NULL, 'G3DSA:3.40.50.970:FF:000025', NULL, NULL, 'Ubiquinone-dependent pyruvate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(157751, NULL, 'G3DSA:3.30.160.100:FF:000004', NULL, NULL, 'Ribosome hibernation promoting factor', NULL, NULL, NULL, NULL, NULL, 4),
(157752, NULL, 'G3DSA:1.20.920.20:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157753, NULL, 'G3DSA:3.20.20.100:FF:000022', NULL, NULL, 'Oxidoreductase, aldo/keto reductase family', NULL, NULL, NULL, NULL, NULL, 4),
(157754, NULL, 'G3DSA:3.40.50.2000:FF:000283', NULL, NULL, 'ADP-heptose--LPS heptosyltransferase II', NULL, NULL, NULL, NULL, NULL, 4),
(157755, NULL, 'G3DSA:3.40.50.300:FF:001628', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(157756, NULL, 'G3DSA:2.130.10.10:FF:000667', NULL, NULL, 'WD repeat-containing protein 82-B', NULL, NULL, NULL, NULL, NULL, 4),
(157757, NULL, 'G3DSA:2.70.70.10:FF:000045', NULL, NULL, 'PTS system transporter subunit IIA', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(157758, NULL, 'G3DSA:3.40.50.720:FF:001726', NULL, NULL, 'Homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(157759, NULL, 'G3DSA:2.60.40.10:FF:001471', NULL, NULL, 'interleukin-1 receptor-like 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(157760, NULL, 'G3DSA:1.25.40.10:FF:002257', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g31790', NULL, NULL, NULL, NULL, NULL, 4),
(157761, NULL, 'G3DSA:1.20.920.30:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157762, NULL, 'G3DSA:3.40.50.980:FF:000028', NULL, NULL, 'Bacitracin synthetase 3', NULL, NULL, NULL, NULL, NULL, 4),
(157763, NULL, 'G3DSA:3.30.70.330:FF:001970', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157764, NULL, 'G3DSA:2.70.98.10:FF:000018', NULL, NULL, 'Aldose 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(157765, NULL, 'G3DSA:3.40.50.10090:FF:000011', NULL, NULL, 'Uroporphyrinogen-III synthase (UroS), putative', NULL, NULL, NULL, NULL, NULL, 4),
(157766, NULL, 'G3DSA:3.30.70.2010:FF:000002', NULL, NULL, '2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-succinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(157767, NULL, 'G3DSA:1.20.920.30:FF:000018', NULL, NULL, 'Axonemal dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(157768, NULL, 'G3DSA:1.10.10.60:FF:000656', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(157769, NULL, 'G3DSA:3.30.420.40:FF:000367', NULL, NULL, 'actin-related protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(157770, NULL, 'G3DSA:2.40.10.10:FF:000048', NULL, NULL, 'serine protease 23', NULL, NULL, NULL, NULL, NULL, 4),
(157771, NULL, 'G3DSA:2.30.29.30:FF:000018', NULL, NULL, 'E3 SUMO-protein ligase RanBP2', NULL, NULL, NULL, NULL, NULL, 4),
(157772, NULL, 'G3DSA:3.30.40.10:FF:002195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157773, NULL, 'G3DSA:1.50.40.10:FF:000102', NULL, NULL, 'Folate carrier protein Flx1', NULL, NULL, NULL, NULL, NULL, 4),
(157774, NULL, 'G3DSA:3.40.50.970:FF:000082', NULL, NULL, 'Oxoglutarate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(157775, NULL, 'G3DSA:3.30.200.20:FF:002177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157776, NULL, 'G3DSA:2.120.10.80:FF:000368', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157777, NULL, 'G3DSA:2.30.42.10:FF:000414', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157778, NULL, 'G3DSA:3.40.50.150:FF:001241', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157779, NULL, 'G3DSA:2.30.38.10:FF:000016', NULL, NULL, 'NRPS-like enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157780, NULL, 'G3DSA:3.40.50.300:FF:008396', NULL, NULL, 'ATP-dependent DEAD/H DNA helicase recQ family-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(157781, NULL, 'G3DSA:3.20.20.80:FF:000152', NULL, NULL, 'Extracellular endoglucanase', NULL, NULL, NULL, NULL, NULL, 4),
(157782, NULL, 'G3DSA:3.90.960.10:FF:000020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157783, NULL, 'G3DSA:3.80.10.10:FF:004400', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(157784, NULL, 'G3DSA:3.80.10.10:FF:003416', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157785, NULL, 'G3DSA:3.20.20.80:FF:000242', NULL, NULL, 'Glycogen debranching enzyme Gdb1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157786, NULL, 'G3DSA:3.10.450.10:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157787, NULL, 'G3DSA:1.10.510.10:FF:002518', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157788, NULL, 'G3DSA:2.40.10.10:FF:000609', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157789, NULL, 'G3DSA:2.30.42.10:FF:000504', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157790, NULL, 'G3DSA:3.40.190.290:FF:000076', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(157791, NULL, 'G3DSA:3.30.70.141:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(157792, NULL, 'G3DSA:3.30.470.30:FF:000081', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157793, NULL, 'G3DSA:1.25.40.10:FF:002818', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157794, NULL, 'G3DSA:2.60.40.10:FF:005214', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157795, NULL, 'G3DSA:3.80.10.10:FF:000600', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(157796, NULL, 'G3DSA:3.30.70.330:FF:000391', NULL, NULL, 'Putative RNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(157797, NULL, 'G3DSA:3.30.160.60:FF:003011', NULL, NULL, 'zinc finger protein 521 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(157798, NULL, 'G3DSA:3.30.160.60:FF:001066', NULL, NULL, 'Zinc finger protein 292', NULL, NULL, NULL, NULL, NULL, 4),
(157799, NULL, 'G3DSA:1.20.1050.10:FF:000046', NULL, NULL, 'Glutathione S-transferase rho', NULL, NULL, NULL, NULL, NULL, 4),
(157800, NULL, 'G3DSA:3.30.60.10:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157801, NULL, 'G3DSA:2.60.40.10:FF:005124', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157802, NULL, 'G3DSA:3.40.50.300:FF:001067', NULL, NULL, 'DNA mismatch repair protein MSH5', NULL, NULL, NULL, NULL, NULL, 4),
(157803, NULL, 'G3DSA:1.25.10.10:FF:002519', NULL, NULL, 'Apoptosis inhibitor 5 homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(157804, NULL, 'G3DSA:1.10.10.460:FF:000002', NULL, NULL, 'Ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(157805, NULL, 'G3DSA:2.160.20.10:FF:000043', NULL, NULL, 'Exo-beta-1,3-glucanase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157806, NULL, 'G3DSA:1.20.1250.20:FF:002273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157807, NULL, 'G3DSA:3.30.1230.20:FF:000014', NULL, NULL, '40S ribosomal protein S21', NULL, NULL, NULL, NULL, NULL, 4),
(157808, NULL, 'G3DSA:2.60.120.260:FF:000229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157809, NULL, 'G3DSA:3.40.50.150:FF:000875', NULL, NULL, 'O-methyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(157810, NULL, 'G3DSA:1.10.510.10:FF:003502', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157811, NULL, 'G3DSA:2.60.40.10:FF:000919', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(157812, NULL, 'G3DSA:1.20.920.10:FF:000102', NULL, NULL, 'Chromatin structure-remodeling complex subunit RSC1/2', NULL, NULL, NULL, NULL, NULL, 4),
(157813, NULL, 'G3DSA:1.10.10.10:FF:000338', NULL, NULL, 'Glc operon transcriptional activator', NULL, NULL, NULL, NULL, NULL, 4),
(157814, NULL, 'G3DSA:2.120.10.80:FF:000278', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157815, NULL, 'G3DSA:1.10.730.10:FF:000141', NULL, NULL, 'YALI0E24607p', NULL, NULL, NULL, NULL, NULL, 4),
(157816, NULL, 'G3DSA:3.40.390.10:FF:000015', NULL, NULL, 'Meprin A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(157817, NULL, 'G3DSA:3.40.50.300:FF:001252', NULL, NULL, 'AIG1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(157818, NULL, 'G3DSA:1.10.10.470:FF:000005', NULL, NULL, 'Maltooligosyltrehalose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(157819, NULL, 'G3DSA:1.10.10.480:FF:000008', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(157820, NULL, 'G3DSA:2.60.120.260:FF:000471', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157821, NULL, 'G3DSA:1.25.40.10:FF:004820', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157822, NULL, 'G3DSA:3.40.50.1010:FF:000031', NULL, NULL, 'DNA repair protein UVH3', NULL, NULL, NULL, NULL, NULL, 4),
(157823, NULL, 'G3DSA:2.70.170.10:FF:000209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157824, NULL, 'G3DSA:3.40.50.1580:FF:000033', NULL, NULL, 'GM15517', NULL, NULL, NULL, NULL, NULL, 4),
(157825, NULL, 'G3DSA:3.40.50.720:FF:002036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(157826, NULL, 'G3DSA:2.30.240.10:FF:000005', NULL, NULL, 'At5g19860', NULL, NULL, NULL, NULL, NULL, 4),
(157827, NULL, 'G3DSA:1.20.1560.10:FF:000129', NULL, NULL, 'ABC bile acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(157828, NULL, 'G3DSA:2.60.40.10:FF:004287', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157829, NULL, 'G3DSA:3.55.40.20:FF:000023', NULL, NULL, 'Superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(157830, NULL, 'G3DSA:3.40.50.12240:FF:000004', NULL, NULL, 'F-type H+-transporting ATPase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(157831, NULL, 'G3DSA:3.80.10.10:FF:004310', NULL, NULL, 'Probable serine/threonine-protein kinase roco5', NULL, NULL, NULL, NULL, NULL, 4),
(157832, NULL, 'G3DSA:2.30.110.10:FF:000001', NULL, NULL, 'Pyridoxine/pyridoxamine 5''-phosphate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(157833, NULL, 'G3DSA:2.30.29.30:FF:000636', NULL, NULL, 'Downstream of kinase', NULL, NULL, NULL, NULL, NULL, 4),
(157834, NULL, 'G3DSA:1.10.8.10:FF:000180', NULL, NULL, 'WGS project CABT00000000 data, contig 2.7', NULL, NULL, NULL, NULL, NULL, 4),
(157835, NULL, 'G3DSA:3.30.70.330:FF:000952', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157836, NULL, 'G3DSA:1.10.420.10:FF:000038', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(157837, NULL, 'G3DSA:1.10.510.10:FF:002575', NULL, NULL, 'BUB1 mitotic checkpoint serine/threonine kinase Ba', NULL, NULL, NULL, NULL, NULL, 4),
(157838, NULL, 'G3DSA:2.40.10.10:FF:000666', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157839, NULL, 'G3DSA:2.130.10.10:FF:000577', NULL, NULL, 'WD domain G-beta repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(157840, NULL, 'G3DSA:3.30.1360.10:FF:000015', NULL, NULL, 'DNA-directed RNA polymerase alpha chain,putative', NULL, NULL, NULL, NULL, NULL, 4),
(157841, NULL, 'G3DSA:3.30.160.60:FF:006445', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157842, NULL, 'G3DSA:3.30.200.20:FF:002267', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157843, NULL, 'G3DSA:3.40.50.12230:FF:000001', NULL, NULL, 'Methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(157844, NULL, 'G3DSA:2.20.70.10:FF:000103', NULL, NULL, 'nudix hydrolase 23, chloroplastic-like', NULL, NULL, NULL, NULL, NULL, 4),
(157845, NULL, 'G3DSA:1.20.1280.20:FF:000004', NULL, NULL, 'Co-chaperone protein HscB homolog', NULL, NULL, NULL, NULL, NULL, 4),
(157846, NULL, 'G3DSA:1.10.10.60:FF:000566', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(157847, NULL, 'G3DSA:1.20.1530.20:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157848, NULL, 'G3DSA:3.40.30.10:FF:001154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157849, NULL, 'G3DSA:3.40.1480.10:FF:000010', NULL, NULL, 'Glycerate kinase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(157850, NULL, 'G3DSA:3.90.1600.10:FF:000043', NULL, NULL, 'DNA-directed DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(157851, NULL, 'G3DSA:1.20.1260.10:FF:000062', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(157852, NULL, 'G3DSA:3.40.1420.10:FF:000001', NULL, NULL, 'Inhibitor of vertebrate lysozyme', NULL, NULL, NULL, NULL, NULL, 4),
(157853, NULL, 'G3DSA:1.10.510.10:FF:003215', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157854, NULL, 'G3DSA:3.40.630.10:FF:000293', NULL, NULL, 'N-acetylated alpha-linked acidic dipeptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(157855, NULL, 'G3DSA:3.80.10.10:FF:004405', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157856, NULL, 'G3DSA:1.10.1240.10:FF:000012', NULL, NULL, 'Corrinoid-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(157857, NULL, 'G3DSA:3.40.850.10:FF:000562', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157858, NULL, 'G3DSA:1.25.40.10:FF:004707', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At1g09680', NULL, NULL, NULL, NULL, NULL, 4),
(157859, NULL, 'G3DSA:1.10.472.10:FF:000467', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(157860, NULL, 'G3DSA:2.10.25.10:FF:001281', NULL, NULL, 'Neurogenic locus notch, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157861, NULL, 'G3DSA:2.60.120.260:FF:000414', NULL, NULL, 'Centrosomal protein of 104 kDa-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(157862, NULL, 'G3DSA:3.40.50.300:FF:003051', NULL, NULL, 'Small GTP-binding protein domain', NULL, NULL, NULL, NULL, NULL, 4),
(157863, NULL, 'G3DSA:3.90.190.10:FF:000303', NULL, NULL, 'Tyrosine-protein phosphatase Lar-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(157864, NULL, 'G3DSA:3.10.20.90:FF:000268', NULL, NULL, 'Ubiquitin-like modifier HUB1', NULL, NULL, NULL, NULL, NULL, 4),
(157865, NULL, 'G3DSA:3.80.10.10:FF:003793', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157866, NULL, 'G3DSA:1.10.10.60:FF:001235', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157867, NULL, 'G3DSA:1.20.120.230:FF:000039', NULL, NULL, 'Serendipity alpha', NULL, NULL, NULL, NULL, NULL, 4),
(157868, NULL, 'G3DSA:2.160.20.10:FF:000251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157869, NULL, 'G3DSA:3.40.50.410:FF:000032', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(157870, NULL, 'G3DSA:3.40.50.261:FF:000027', NULL, NULL, 'Succinyl-CoA ligase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(157871, NULL, 'G3DSA:3.40.630.30:FF:000299', NULL, NULL, 'GNAT family N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(157872, NULL, 'G3DSA:2.130.10.30:FF:000004', NULL, NULL, 'E3 ubiquitin-protein ligase HERC2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(157873, NULL, 'G3DSA:2.110.10.10:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157874, NULL, 'G3DSA:3.40.50.720:FF:002210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157875, NULL, 'G3DSA:3.30.1490.100:FF:000043', NULL, NULL, 'DNA polymerase eta, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157876, NULL, 'G3DSA:3.30.559.70:FF:000028', NULL, NULL, 'carnitine O-acetyltransferase-like', NULL, NULL, NULL, NULL, NULL, 4),
(157877, NULL, 'G3DSA:1.10.238.10:FF:000553', NULL, NULL, 'Centrin 3', NULL, NULL, NULL, NULL, NULL, 4),
(157878, NULL, 'G3DSA:2.40.180.10:FF:000037', NULL, NULL, 'Catalase-related peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(157879, NULL, 'G3DSA:3.40.50.2000:FF:000367', NULL, NULL, 'Lipopolysaccharide 1,2-N-acetylglucosaminetransferase', NULL, NULL, NULL, NULL, NULL, 4),
(157880, NULL, 'G3DSA:3.30.40.10:FF:000278', NULL, NULL, 'cullin-9 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(157881, NULL, 'G3DSA:1.20.1070.10:FF:001885', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157882, NULL, 'G3DSA:2.120.10.30:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157883, NULL, 'G3DSA:4.10.640.40:FF:000002', NULL, NULL, 'Putative Cytoplasmic polyadenylation element-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(157884, NULL, 'G3DSA:1.20.120.1240:FF:000040', NULL, NULL, 'Dynamin family GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157885, NULL, 'G3DSA:1.20.1310.10:FF:000235', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157886, NULL, 'G3DSA:3.10.129.110:FF:000015', NULL, NULL, 'CurH', NULL, NULL, NULL, NULL, NULL, 4),
(157887, NULL, 'G3DSA:3.40.50.1820:FF:001870', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157888, NULL, 'G3DSA:3.80.10.10:FF:003742', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157889, NULL, 'G3DSA:3.30.40.10:FF:001964', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157890, NULL, 'G3DSA:1.20.1070.10:FF:001508', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157891, NULL, 'G3DSA:1.25.40.20:FF:001422', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157892, NULL, 'G3DSA:2.40.110.10:FF:000038', NULL, NULL, 'Dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(157893, NULL, 'G3DSA:1.10.510.10:FF:004317', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(157894, NULL, 'G3DSA:3.40.1090.10:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157895, NULL, 'G3DSA:3.30.160.60:FF:001038', NULL, NULL, 'Zinc finger protein 217', NULL, NULL, NULL, NULL, NULL, 4),
(157896, NULL, 'G3DSA:1.25.40.10:FF:002993', NULL, NULL, 'Os02g0191200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(157897, NULL, 'G3DSA:3.80.10.10:FF:002314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157898, NULL, 'G3DSA:3.60.20.10:FF:000023', NULL, NULL, 'Proteasome subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(157899, NULL, 'G3DSA:3.30.160.60:FF:002724', NULL, NULL, 'Similar to transcription factor Zn, C2H2', NULL, NULL, NULL, NULL, NULL, 4),
(157900, NULL, 'G3DSA:2.30.30.40:FF:000328', NULL, NULL, 'Actin cytoskeleton-regulatory complex protein sla1', NULL, NULL, NULL, NULL, NULL, 4),
(157901, NULL, 'G3DSA:1.25.40.10:FF:002616', NULL, NULL, 'Tetratricopeptide repeat protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(157902, NULL, 'G3DSA:1.25.10.10:FF:002435', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157903, NULL, 'G3DSA:2.20.70.10:FF:000047', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(157904, NULL, 'G3DSA:1.20.1250.20:FF:001609', NULL, NULL, 'Equilibrative nucleoside transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(157905, NULL, 'G3DSA:2.120.10.30:FF:000258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157906, NULL, 'G3DSA:2.40.50.140:FF:000820', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157907, NULL, 'G3DSA:3.10.330.10:FF:000018', NULL, NULL, 'Unplaced genomic scaffold supercont2.17, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(157908, NULL, 'G3DSA:1.10.510.10:FF:003120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157909, NULL, 'G3DSA:1.20.1280.20:FF:000009', NULL, NULL, 'Co-chaperone protein HscB homolog', NULL, NULL, NULL, NULL, NULL, 4),
(157910, NULL, 'G3DSA:2.60.40.10:FF:005304', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157911, NULL, 'G3DSA:3.30.40.10:FF:000503', NULL, NULL, 'RING-H2 finger protein ATL7', NULL, NULL, NULL, NULL, NULL, 4),
(157912, NULL, 'G3DSA:1.20.1070.10:FF:000311', NULL, NULL, 'TYRAmine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(157913, NULL, 'G3DSA:3.30.70.330:FF:002077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157914, NULL, 'G3DSA:2.130.10.10:FF:004377', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157915, NULL, 'G3DSA:3.90.226.10:FF:000174', NULL, NULL, 'Probable enoyl-CoA hydratase EchA18 (Enoyl hydrase) (Unsaturated acyl-CoA hydratase) (Crotonase)', NULL, NULL, NULL, NULL, NULL, 4),
(157916, NULL, 'G3DSA:1.10.510.10:FF:001142', NULL, NULL, 'Unplaced genomic scaffold supercont1.19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(157917, NULL, 'G3DSA:3.40.50.2030:FF:000005', NULL, NULL, 'Carbon monoxide dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(157918, NULL, 'G3DSA:3.30.200.20:FF:001598', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157919, NULL, 'G3DSA:3.30.230.130:FF:000064', NULL, NULL, 'AaceriAGL193Wp', NULL, NULL, NULL, NULL, NULL, 4),
(157920, NULL, 'G3DSA:2.30.230.10:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157921, NULL, 'G3DSA:3.30.710.10:FF:000346', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157922, NULL, 'G3DSA:3.30.70.270:FF:000327', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157923, NULL, 'G3DSA:1.10.600.10:FF:000013', NULL, NULL, 'NADH dehydrogenase (ubiquinone) complex I, assembly factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(157924, NULL, 'G3DSA:2.120.10.80:FF:000071', NULL, NULL, 'kelch domain-containing protein 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(157925, NULL, 'G3DSA:1.10.3820.10:FF:000006', NULL, NULL, 'Cytochrome c-type protein NrfH', NULL, NULL, NULL, NULL, NULL, 4),
(157926, NULL, 'G3DSA:2.30.42.10:FF:000392', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(157927, NULL, 'G3DSA:2.60.40.60:FF:001143', NULL, NULL, 'Cadherin 4', NULL, NULL, NULL, NULL, NULL, 4),
(157928, NULL, 'G3DSA:3.40.190.10:FF:000157', NULL, NULL, 'Glutamate receptor ionotropic, NMDA 2B', NULL, NULL, NULL, NULL, NULL, 4),
(157929, NULL, 'G3DSA:3.30.1010.10:FF:000028', NULL, NULL, 'Phosphatidylinositol kinase (PIK-G3)', NULL, NULL, NULL, NULL, NULL, 4),
(157930, NULL, 'G3DSA:3.40.50.2020:FF:000002', NULL, NULL, 'Ribose-phosphate pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(157931, NULL, 'G3DSA:3.40.50.300:FF:005400', NULL, NULL, 'Protein CBR-MUT-14', NULL, NULL, NULL, NULL, NULL, 4),
(157932, NULL, 'G3DSA:1.20.1740.10:FF:000104', NULL, NULL, 'Amino-acid permease BAT1', NULL, NULL, NULL, NULL, NULL, 4),
(157933, NULL, 'G3DSA:2.130.10.30:FF:000055', NULL, NULL, 'SCF-associated factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(157934, NULL, 'G3DSA:3.30.420.40:FF:000288', NULL, NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(157935, NULL, 'G3DSA:1.20.1070.10:FF:001834', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157936, NULL, 'G3DSA:2.20.80.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157937, NULL, 'G3DSA:1.20.120.720:FF:000012', NULL, NULL, 'Myosin IIIB', NULL, NULL, NULL, NULL, NULL, 4),
(157938, NULL, 'G3DSA:1.20.5.190:FF:000129', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157939, NULL, 'G3DSA:3.30.1640.10:FF:000059', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(157940, NULL, 'G3DSA:2.130.10.10:FF:001246', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157941, NULL, 'G3DSA:3.90.1140.10:FF:000058', NULL, NULL, 'RNA 2'',3''-cyclic phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(157942, NULL, 'G3DSA:2.30.42.10:FF:000178', NULL, NULL, 'disks large homolog 5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(157943, NULL, 'G3DSA:2.60.120.290:FF:000215', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(157944, NULL, 'G3DSA:2.60.40.10:FF:004399', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157945, NULL, 'G3DSA:3.90.740.10:FF:000037', NULL, NULL, 'Isoleucyl-tRNA synthetase (Mitochondrial)', NULL, NULL, NULL, NULL, NULL, 4),
(157946, NULL, 'G3DSA:3.60.40.10:FF:000232', NULL, NULL, 'Stage II sporulation E family protein', NULL, NULL, NULL, NULL, NULL, 4),
(157947, NULL, 'G3DSA:3.90.640.10:FF:000153', NULL, NULL, 'Endoplasmic reticulum chaperone BiP', NULL, NULL, NULL, NULL, NULL, 4),
(157948, NULL, 'G3DSA:1.20.1560.10:FF:000006', NULL, NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 9', NULL, NULL, NULL, NULL, NULL, 4),
(157949, NULL, 'G3DSA:1.25.10.10:FF:003003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157950, NULL, 'G3DSA:1.10.8.270:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157951, NULL, 'G3DSA:3.20.20.80:FF:000450', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157952, NULL, 'G3DSA:3.50.50.60:FF:000315', NULL, NULL, 'Unplaced genomic scaffold supercont2.6, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(157953, NULL, 'G3DSA:2.60.40.1170:FF:000108', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157954, NULL, 'G3DSA:3.30.160.60:FF:002499', NULL, NULL, 'Blast:Zinc finger protein 568', NULL, NULL, NULL, NULL, NULL, 4),
(157955, NULL, 'G3DSA:3.40.50.20:FF:000017', NULL, NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(157956, NULL, 'G3DSA:3.60.110.10:FF:000007', NULL, NULL, 'Glutamine-dependent NAD(+) synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(157957, NULL, 'G3DSA:3.30.50.10:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157958, NULL, 'G3DSA:1.20.1250.20:FF:000300', NULL, NULL, 'Dicarboxylate MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(157959, NULL, 'G3DSA:2.40.50.140:FF:000606', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(157960, NULL, 'G3DSA:3.40.850.10:FF:000236', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(157961, NULL, 'G3DSA:1.20.1160.11:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157962, NULL, 'G3DSA:3.40.50.300:FF:004299', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157963, NULL, 'G3DSA:1.20.1320.30:FF:000005', NULL, NULL, 'probable ATP-dependent RNA helicase DHX58', NULL, NULL, NULL, NULL, NULL, 4),
(157964, NULL, 'G3DSA:1.10.1410.40:FF:000001', NULL, NULL, 'interleukin enhancer-binding factor 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(157965, NULL, 'G3DSA:2.120.10.30:FF:000584', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157966, NULL, 'G3DSA:1.25.40.10:FF:004387', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g11310, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(157967, NULL, 'G3DSA:3.50.50.60:FF:000641', NULL, NULL, 'Putative cellulose synthase A catalytic subunit 2 [UDP-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(157968, NULL, 'G3DSA:1.20.5.170:FF:000123', NULL, NULL, 'Basic region/leucine zipper protein', NULL, NULL, NULL, NULL, NULL, 4),
(157969, NULL, 'G3DSA:1.10.510.10:FF:002277', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157970, NULL, 'G3DSA:4.10.1000.10:FF:000003', NULL, NULL, 'Zinc finger CCCH domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(157971, NULL, 'G3DSA:1.10.1820.10:FF:000006', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(157972, NULL, 'G3DSA:1.10.150.280:FF:000006', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(157973, NULL, 'G3DSA:3.40.1280.10:FF:000124', NULL, NULL, 'Os08g0506500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(157974, NULL, 'G3DSA:3.30.70.1660:FF:000026', NULL, NULL, 'Mitochondrial translation release factor (RF-1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(157975, NULL, 'G3DSA:3.80.10.10:FF:000241', NULL, NULL, 'leucine-rich repeat-containing protein 73 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(157976, NULL, 'G3DSA:1.20.1540.10:FF:000044', NULL, NULL, 'Rhomboid family intramembrane serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(157977, NULL, 'G3DSA:2.40.110.10:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157978, NULL, 'G3DSA:3.30.160.60:FF:001364', NULL, NULL, 'zinc finger protein 746 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(157979, NULL, 'G3DSA:3.30.40.10:FF:001638', NULL, NULL, 'Chromodomain-helicase-DNA-binding protein 3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(157980, NULL, 'G3DSA:2.130.10.10:FF:002932', NULL, NULL, 'Uncharacterized WD repeat-containing protein C4F8.11', NULL, NULL, NULL, NULL, NULL, 4),
(157981, NULL, 'G3DSA:3.20.20.100:FF:000061', NULL, NULL, 'Aldo/keto reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157982, NULL, 'G3DSA:2.60.40.10:FF:002275', NULL, NULL, 'Coagulation factor XIII, A1 polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(157983, NULL, 'G3DSA:3.40.250.10:FF:000033', NULL, NULL, 'Thiosulfate sulfurtransferase TUM1', NULL, NULL, NULL, NULL, NULL, 4),
(157984, NULL, 'G3DSA:1.20.1250.20:FF:001986', NULL, NULL, 'MDR-type permease', NULL, NULL, NULL, NULL, NULL, 4),
(157985, NULL, 'G3DSA:3.40.50.300:FF:008273', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(157986, NULL, 'G3DSA:3.30.465.10:FF:000113', NULL, NULL, 'Isoamyl alcohol oxidase, putative (AFU_orthologue AFUA_1G01180)', NULL, NULL, NULL, NULL, NULL, 4),
(157987, NULL, 'G3DSA:1.25.40.430:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(157988, NULL, 'G3DSA:3.30.160.60:FF:005630', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157989, NULL, 'G3DSA:3.90.1800.10:FF:000024', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(157990, NULL, 'G3DSA:1.20.5.170:FF:000011', NULL, NULL, 'Transcription factor MafG, putative', NULL, NULL, NULL, NULL, NULL, 4),
(157991, NULL, 'G3DSA:4.10.1000.10:FF:000054', NULL, NULL, 'RING finger protein unkempt homolog', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(157992, NULL, 'G3DSA:2.60.40.10:FF:002954', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(157993, NULL, 'G3DSA:1.20.58.100:FF:000012', NULL, NULL, 'L-aspartate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(157994, NULL, 'G3DSA:1.20.5.1300:FF:000005', NULL, NULL, 'Histidinol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(157995, NULL, 'G3DSA:3.40.50.11610:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(157996, NULL, 'G3DSA:2.60.40.790:FF:000019', NULL, NULL, 'cytochrome b5 reductase 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(157997, NULL, 'G3DSA:3.30.1490.40:FF:000011', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(157998, NULL, 'G3DSA:3.80.10.10:FF:002899', NULL, NULL, 'Protein CBG18939', NULL, NULL, NULL, NULL, NULL, 4),
(157999, NULL, 'G3DSA:3.10.180.10:FF:000074', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(158000, NULL, 'G3DSA:1.20.5.170:FF:000218', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(158001, NULL, 'G3DSA:2.30.30.140:FF:000071', NULL, NULL, 'Zinc finger CCCH-type with G patch domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(158002, NULL, 'G3DSA:3.30.230.10:FF:000315', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(158003, NULL, 'G3DSA:1.10.10.510:FF:000001', NULL, NULL, 'Replication protein E1', NULL, NULL, NULL, NULL, NULL, 4),
(158004, NULL, 'G3DSA:2.30.250.10:FF:000005', NULL, NULL, 'M18 aspartyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(158005, NULL, 'G3DSA:1.10.150.20:FF:000155', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(158006, NULL, 'G3DSA:1.25.40.10:FF:004180', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(158007, NULL, 'G3DSA:3.30.930.10:FF:000211', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(158008, NULL, 'G3DSA:3.10.28.10:FF:000054', NULL, NULL, 'Replication factor C small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(158009, NULL, 'G3DSA:3.90.120.10:FF:000029', NULL, NULL, 'Cytosine-specific methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(158010, NULL, 'G3DSA:1.10.1380.10:FF:000022', NULL, NULL, 'Fra mauro, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(158011, NULL, 'G3DSA:1.25.40.10:FF:003510', NULL, NULL, 'TPR domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(158012, NULL, 'G3DSA:1.10.220.150:FF:000068', NULL, NULL, 'ArfGAP with SH3 domain, ankyrin repeat and PH domain 2a', NULL, NULL, NULL, NULL, NULL, 4),
(158013, NULL, 'G3DSA:3.30.200.20:FF:000816', NULL, NULL, 'Ksp1p', NULL, NULL, NULL, NULL, NULL, 4),
(158014, NULL, 'G3DSA:3.50.50.60:FF:000220', NULL, NULL, 'UDP-galactopyranose mutase', NULL, NULL, NULL, NULL, NULL, 4),
(158015, NULL, 'G3DSA:3.10.129.10:FF:000230', NULL, NULL, 'Fatty acid synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(158016, NULL, 'G3DSA:3.80.10.10:FF:000920', NULL, NULL, 'mRNA, clone: RTFL01-33-G14', NULL, NULL, NULL, NULL, NULL, 4),
(158017, NULL, 'G3DSA:2.40.10.10:FF:000587', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158018, NULL, 'G3DSA:3.90.45.10:FF:000011', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(158019, NULL, 'G3DSA:1.10.510.10:FF:000686', NULL, NULL, 'Serine/threonine-protein kinase ULK4', NULL, NULL, NULL, NULL, NULL, 4),
(158020, NULL, 'G3DSA:3.30.342.10:FF:000013', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(158021, NULL, 'G3DSA:1.10.510.10:FF:004368', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158022, NULL, 'G3DSA:3.40.50.300:FF:006923', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158023, NULL, 'G3DSA:2.60.40.770:FF:000013', NULL, NULL, 'AGAP002848-PA', NULL, NULL, NULL, NULL, NULL, 4),
(158024, NULL, 'G3DSA:3.30.200.210:FF:000003', NULL, NULL, 'Formate dehydrogenase-N subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(158025, NULL, 'G3DSA:1.10.287.1050:FF:000001', NULL, NULL, 'DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(158026, NULL, 'G3DSA:3.40.850.10:FF:000511', NULL, NULL, 'Kinesin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(158027, NULL, 'G3DSA:1.20.1050.10:FF:000248', NULL, NULL, 'Glutathione S-transferase Mu 5', NULL, NULL, NULL, NULL, NULL, 4),
(158028, NULL, 'G3DSA:1.10.287.1060:FF:000004', NULL, NULL, 'ESAT-6-like protein EsxI', NULL, NULL, NULL, NULL, NULL, 4),
(158029, NULL, 'G3DSA:1.10.1060.10:FF:000026', NULL, NULL, 'H(2):CoB-CoM heterodisulfide,ferredoxin reductase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(158030, NULL, 'G3DSA:3.90.650.10:FF:000030', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(158031, NULL, 'G3DSA:3.50.50.60:FF:000366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158032, NULL, 'G3DSA:1.25.10.10:FF:002839', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158033, NULL, 'G3DSA:1.20.1560.10:FF:000332', NULL, NULL, 'ATP binding cassette subfamily B member 5', NULL, NULL, NULL, NULL, NULL, 4),
(158034, NULL, 'G3DSA:3.80.10.10:FF:000302', NULL, NULL, 'CD180 antigen', NULL, NULL, NULL, NULL, NULL, 4),
(158035, NULL, 'G3DSA:3.30.360.110:FF:000002', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(158036, NULL, 'G3DSA:3.40.50.300:FF:003197', NULL, NULL, '26S proteasome regulatory subunit 10B', NULL, NULL, NULL, NULL, NULL, 4),
(158037, NULL, 'G3DSA:3.40.50.300:FF:006709', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158038, NULL, 'G3DSA:3.30.559.10:FF:000117', NULL, NULL, 'Dihydrolipoyllysine-residue acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(158039, NULL, 'G3DSA:3.60.15.10:FF:000168', NULL, NULL, 'MBL fold metallo-hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(158040, NULL, 'G3DSA:2.60.120.290:FF:000103', NULL, NULL, 'Zgc:154142', NULL, NULL, NULL, NULL, NULL, 4),
(158041, NULL, 'G3DSA:3.55.50.30:FF:000026', NULL, NULL, 'Putative anti-sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(158042, NULL, 'G3DSA:3.30.160.60:FF:006086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158043, NULL, 'G3DSA:1.25.10.10:FF:000069', NULL, NULL, 'Splicing factor 3B subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(158044, NULL, 'G3DSA:1.10.287.130:FF:000213', NULL, NULL, 'Hybrid sensory kinase', NULL, NULL, NULL, NULL, NULL, 4),
(158045, NULL, 'G3DSA:1.20.1270.350:FF:000003', NULL, NULL, 'CRE-CED-5 protein', NULL, NULL, NULL, NULL, NULL, 4),
(158046, NULL, 'G3DSA:3.40.50.10810:FF:000087', NULL, NULL, 'Chromatin remodeling 38', NULL, NULL, NULL, NULL, NULL, 4),
(158047, NULL, 'G3DSA:3.90.79.10:FF:000078', NULL, NULL, 'Peroxisomal coenzyme A diphosphatase NUDT7', NULL, NULL, NULL, NULL, NULL, 4),
(158048, NULL, 'G3DSA:3.40.50.2000:FF:000581', NULL, NULL, 'Probable glycosyltransferase WbpH', NULL, NULL, NULL, NULL, NULL, 4),
(158049, NULL, 'G3DSA:3.30.310.80:FF:000005', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(158050, NULL, 'G3DSA:3.30.750.24:FF:000115', NULL, NULL, 'Anion transporter SULP-7d', NULL, NULL, NULL, NULL, NULL, 4),
(158051, NULL, 'G3DSA:3.30.379.10:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158052, NULL, 'G3DSA:1.25.10.10:FF:000748', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(158053, NULL, 'G3DSA:1.10.8.110:FF:000001', NULL, NULL, 'Photosystem I reaction center subunit III', NULL, NULL, NULL, NULL, NULL, 4),
(158054, NULL, 'G3DSA:1.10.287.380:FF:000029', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(158055, NULL, 'G3DSA:3.30.497.10:FF:000052', NULL, NULL, 'Serpin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(158056, NULL, 'G3DSA:1.10.1450.10:FF:000129', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(158057, NULL, 'G3DSA:3.30.160.60:FF:005012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158058, NULL, 'G3DSA:3.30.200.20:FF:002441', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(158059, NULL, 'G3DSA:1.25.50.20:FF:000001', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(158060, NULL, 'G3DSA:3.30.70.330:FF:000486', NULL, NULL, 'Pumilio domain-containing protein c', NULL, NULL, NULL, NULL, NULL, 4),
(158061, NULL, 'G3DSA:2.60.40.10:FF:004427', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158062, NULL, 'G3DSA:2.120.10.30:FF:000084', NULL, NULL, 'Protein STRICTOSIDINE SYNTHASE-LIKE 12', NULL, NULL, NULL, NULL, NULL, 4),
(158063, NULL, 'G3DSA:3.40.50.410:FF:000144', NULL, NULL, 'RNA polymerase II transcription factor B subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(158064, NULL, 'G3DSA:3.30.70.1180:FF:000011', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(158065, NULL, 'G3DSA:3.50.50.60:FF:000719', NULL, NULL, 'Probable oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(158066, NULL, 'G3DSA:3.40.50.720:FF:000911', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(158067, NULL, 'G3DSA:1.20.1250.20:FF:001486', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158068, NULL, 'G3DSA:2.40.510.10:FF:000001', NULL, NULL, 'Capsid protein VP1', NULL, NULL, NULL, NULL, NULL, 4),
(158069, NULL, 'G3DSA:2.60.220.50:FF:000014', NULL, NULL, 'Adhesion G-protein coupled receptor G1', NULL, NULL, NULL, NULL, NULL, 4),
(158070, NULL, 'G3DSA:3.40.50.300:FF:006648', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(158071, NULL, 'G3DSA:2.40.10.120:FF:000019', NULL, NULL, 'Trypsin', NULL, NULL, NULL, NULL, NULL, 4),
(158072, NULL, 'G3DSA:3.30.70.1400:FF:000027', NULL, NULL, 'Sarcosine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(158073, NULL, 'G3DSA:3.40.640.10:FF:000018', NULL, NULL, 'Alanine aminotransferase AlaC', NULL, NULL, NULL, NULL, NULL, 4),
(158074, NULL, 'G3DSA:3.40.50.2000:FF:000255', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(158075, NULL, 'G3DSA:3.80.10.10:FF:003916', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158076, NULL, 'G3DSA:3.90.1150.10:FF:000502', NULL, NULL, 'Putative diaminobutyrate-pyruvate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(158077, NULL, 'G3DSA:3.40.850.10:FF:000450', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158078, NULL, 'G3DSA:3.30.70.920:FF:000028', NULL, NULL, 'Transcriptional regulator AsnC family', NULL, NULL, NULL, NULL, NULL, 4),
(158079, NULL, 'G3DSA:1.25.40.10:FF:002049', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(158080, NULL, 'G3DSA:2.40.50.90:FF:000063', NULL, NULL, 'RING finger protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(158081, NULL, 'G3DSA:3.30.70.870:FF:000024', NULL, NULL, 'Mitochondrial elongation factor G2', NULL, NULL, NULL, NULL, NULL, 4),
(158082, NULL, 'G3DSA:3.30.1680.10:FF:000056', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(158083, NULL, 'G3DSA:1.25.10.10:FF:002547', NULL, NULL, 'Sister chromatid cohesion protein', NULL, NULL, NULL, NULL, NULL, 4),
(158084, NULL, 'G3DSA:1.10.510.10:FF:002777', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158085, NULL, 'G3DSA:3.90.20.20:FF:000030', NULL, NULL, 'Protein GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(158086, NULL, 'G3DSA:3.30.40.10:FF:001852', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(158087, NULL, 'G3DSA:3.30.160.60:FF:000807', NULL, NULL, 'Polymerase (DNA directed) kappa', NULL, NULL, NULL, NULL, NULL, 4),
(158088, NULL, 'G3DSA:2.170.140.10:FF:000015', NULL, NULL, 'Peritrophin-A', NULL, NULL, NULL, NULL, NULL, 4),
(158089, NULL, 'G3DSA:3.40.50.150:FF:000903', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158090, NULL, 'G3DSA:3.30.160.60:FF:003213', NULL, NULL, 'GD13584', NULL, NULL, NULL, NULL, NULL, 4),
(158091, NULL, 'G3DSA:1.20.1250.20:FF:000800', NULL, NULL, 'Sugar phosphate permease', NULL, NULL, NULL, NULL, NULL, 4),
(158092, NULL, 'G3DSA:2.40.50.140:FF:000932', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(158093, NULL, 'G3DSA:2.130.10.10:FF:000903', NULL, NULL, 'DNA damage-binding protein CMR1', NULL, NULL, NULL, NULL, NULL, 4),
(158094, NULL, 'G3DSA:3.40.30.10:FF:000131', NULL, NULL, 'migration and invasion enhancer 1', NULL, NULL, NULL, NULL, NULL, 4),
(158095, NULL, 'G3DSA:3.90.320.10:FF:000011', NULL, NULL, 'ATP-dependent helicase/nuclease subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(158096, NULL, 'G3DSA:1.25.40.10:FF:004584', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158097, NULL, 'G3DSA:3.40.50.300:FF:001752', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(158098, NULL, 'G3DSA:3.30.559.10:FF:000090', NULL, NULL, 'Choline/Carnitine o-acyltransferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(158099, NULL, 'G3DSA:1.10.510.10:FF:002726', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(158100, NULL, 'G3DSA:1.10.472.10:FF:000260', NULL, NULL, 'Cyclin domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(158101, NULL, 'G3DSA:3.40.50.720:FF:000035', NULL, NULL, 'Adenosylhomocysteinase', NULL, NULL, NULL, NULL, NULL, 4),
(158102, NULL, 'G3DSA:2.20.28.200:FF:000010', NULL, NULL, 'NAD-dependent protein deacetylase sirtuin-6', NULL, NULL, NULL, NULL, NULL, 4),
(158103, NULL, 'G3DSA:3.90.1180.10:FF:000004', NULL, NULL, '50S ribosomal protein L13', NULL, NULL, NULL, NULL, NULL, 4),
(158104, NULL, 'G3DSA:2.60.40.10:FF:004192', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158105, NULL, 'G3DSA:2.60.40.10:FF:002724', NULL, NULL, 'CoLlagen with Endostatin domain', NULL, NULL, NULL, NULL, NULL, 4),
(158106, NULL, 'G3DSA:1.20.1250.20:FF:001935', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158107, NULL, 'G3DSA:2.60.120.260:FF:000061', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(158108, NULL, 'G3DSA:2.60.40.10:FF:002628', NULL, NULL, 'T cell receptor alpha variable 16n', NULL, NULL, NULL, NULL, NULL, 4),
(158109, NULL, 'G3DSA:1.25.40.10:FF:004680', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158110, NULL, 'G3DSA:1.25.40.180:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158111, NULL, 'G3DSA:3.90.660.10:FF:000036', NULL, NULL, 'Lysine-specific histone demethylase 1 homolog 3', NULL, NULL, NULL, NULL, NULL, 4),
(158112, NULL, 'G3DSA:3.10.20.90:FF:000998', NULL, NULL, 'Autophagy protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(158113, NULL, 'G3DSA:2.20.110.10:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158114, NULL, 'G3DSA:1.10.287.130:FF:000090', NULL, NULL, 'Histidine kinase sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(158115, NULL, 'G3DSA:3.40.50.300:FF:001460', NULL, NULL, 'ATP-binding cassette transporter', NULL, NULL, NULL, NULL, NULL, 4),
(158116, NULL, 'G3DSA:2.10.25.10:FF:000027', NULL, NULL, 'Thrombospondin 3', NULL, NULL, NULL, NULL, NULL, 4),
(158117, NULL, 'G3DSA:3.30.260.10:FF:000064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158118, NULL, 'G3DSA:3.30.160.60:FF:004736', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158119, NULL, 'G3DSA:4.10.1030.10:FF:000005', NULL, NULL, 'Cullin', NULL, NULL, NULL, NULL, NULL, 4),
(158120, NULL, 'G3DSA:1.10.287.3550:FF:000004', NULL, NULL, 'stromal interaction molecule homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(158121, NULL, 'G3DSA:3.40.50.2300:FF:000401', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(158122, NULL, 'G3DSA:3.80.10.10:FF:001376', NULL, NULL, 'Leucine-rich repeats and IQ motif-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(158123, NULL, 'G3DSA:1.20.1250.20:FF:000351', NULL, NULL, 'sodium-dependent lysophosphatidylcholine symporter 1 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(158124, NULL, 'G3DSA:4.10.1110.10:FF:000006', NULL, NULL, 'Zinc finger AN1-type containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(158125, NULL, 'G3DSA:1.10.238.10:FF:000906', NULL, NULL, 'Mechanosensitive ion channel protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(158126, NULL, 'G3DSA:3.30.2350.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158127, NULL, 'G3DSA:3.30.200.20:FF:001839', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(158128, NULL, 'G3DSA:2.60.200.20:FF:000089', NULL, NULL, 'Probable conserved transmembrane ATP-binding protein ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(158129, NULL, 'G3DSA:2.60.40.420:FF:000105', NULL, NULL, 'WGS project CABT00000000 data, contig 2.7', NULL, NULL, NULL, NULL, NULL, 4),
(158130, NULL, 'G3DSA:2.120.10.80:FF:000312', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(158131, NULL, 'G3DSA:2.60.40.10:FF:004753', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158132, NULL, 'G3DSA:2.40.50.140:FF:000320', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(158133, NULL, 'G3DSA:3.40.850.10:FF:000124', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(158134, NULL, 'G3DSA:3.40.50.2300:FF:000452', NULL, NULL, 'PTS fructose transporter subunit IIB', NULL, NULL, NULL, NULL, NULL, 4),
(158135, NULL, 'G3DSA:3.30.420.40:FF:000788', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158136, NULL, 'G3DSA:1.25.40.10:FF:002667', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158137, NULL, 'G3DSA:1.10.10.10:FF:000810', NULL, NULL, 'DNA-directed RNA polymerase iii 34 kDa polypeptide, putative', NULL, NULL, NULL, NULL, NULL, 4),
(158138, NULL, 'G3DSA:3.30.420.40:FF:001070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158139, NULL, 'G3DSA:3.30.565.10:FF:000098', NULL, NULL, 'Signal transduction histidine-protein kinase ArlS', NULL, NULL, NULL, NULL, NULL, 4),
(158140, NULL, 'G3DSA:3.30.230.10:FF:000236', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(158141, NULL, 'G3DSA:6.10.250.3430:FF:000001', NULL, NULL, 'CurK', NULL, NULL, NULL, NULL, NULL, 4),
(158142, NULL, 'G3DSA:1.10.3380.30:FF:000028', NULL, NULL, 'Polymerase (DNA directed), theta', NULL, NULL, NULL, NULL, NULL, 4),
(158143, NULL, 'G3DSA:3.40.50.12780:FF:000233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158144, NULL, 'G3DSA:1.10.3210.10:FF:000056', NULL, NULL, 'Sam/hd domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(158145, NULL, 'G3DSA:2.60.40.3960:FF:000001', NULL, NULL, 'Sexual development activator VeA', NULL, NULL, NULL, NULL, NULL, 4),
(158146, NULL, 'G3DSA:1.10.101.10:FF:000011', NULL, NULL, 'PDZ domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(158147, NULL, 'G3DSA:1.10.20.10:FF:000069', NULL, NULL, 'Transcription initiation factor TFIID subunit', NULL, NULL, NULL, NULL, NULL, 4),
(158148, NULL, 'G3DSA:3.30.450.60:FF:000060', NULL, NULL, 'Coatomer subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(158149, NULL, 'G3DSA:3.30.300.210:FF:000003', NULL, NULL, 'Spore germination protein GerHC', NULL, NULL, NULL, NULL, NULL, 4),
(158150, NULL, 'G3DSA:3.30.70.330:FF:001846', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158151, NULL, 'G3DSA:1.20.58.2140:FF:000010', NULL, NULL, 'Translin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(158152, NULL, 'G3DSA:1.10.510.10:FF:003620', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158153, NULL, 'G3DSA:3.30.470.20:FF:000167', NULL, NULL, 'Glutathione synthetase, putative (AFU_orthologue AFUA_5G06610)', NULL, NULL, NULL, NULL, NULL, 4),
(158154, NULL, 'G3DSA:3.40.1160.10:FF:000031', NULL, NULL, 'Isopentenyl phosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(158155, NULL, 'G3DSA:3.30.300.90:FF:000002', NULL, NULL, 'Acid stress protein IbaG', NULL, NULL, NULL, NULL, NULL, 4),
(158156, NULL, 'G3DSA:1.10.1040.10:FF:000031', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase (NAD(P)(+))', NULL, NULL, NULL, NULL, NULL, 4),
(158157, NULL, 'G3DSA:2.30.29.30:FF:000760', NULL, NULL, 'FACT complex subunit POB3', NULL, NULL, NULL, NULL, NULL, 4),
(158158, NULL, 'G3DSA:1.25.40.20:FF:001810', NULL, NULL, 'E3 ubiquitin-protein ligase mind-bomb-like Protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(158159, NULL, 'G3DSA:1.20.1280.290:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158160, NULL, 'G3DSA:3.30.200.20:FF:002115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158161, NULL, 'G3DSA:2.30.30.140:FF:000211', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(158162, NULL, 'G3DSA:2.60.120.260:FF:000353', NULL, NULL, 'Beta-galactosidase 17', NULL, NULL, NULL, NULL, NULL, 4),
(158163, NULL, 'G3DSA:4.10.520.10:FF:000012', NULL, NULL, 'DNA-binding protein HU', NULL, NULL, NULL, NULL, NULL, 4),
(158164, NULL, 'G3DSA:3.40.50.300:FF:001185', NULL, NULL, 'GTPase Der', NULL, NULL, NULL, NULL, NULL, 4),
(158165, NULL, 'G3DSA:3.30.910.10:FF:000002', NULL, NULL, 'DinI-like family protein', NULL, NULL, NULL, NULL, NULL, 4),
(158166, NULL, 'G3DSA:3.30.479.20:FF:000041', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(158167, NULL, 'G3DSA:1.25.40.20:FF:000793', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(158168, NULL, 'G3DSA:3.40.190.10:FF:000483', NULL, NULL, 'Sensory box sensor histidine kinase/response regulator VieS', NULL, NULL, NULL, NULL, NULL, 4),
(158169, NULL, 'G3DSA:1.20.1730.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158170, NULL, 'G3DSA:3.40.50.12780:FF:000020', NULL, NULL, 'Acetyl-coenzyme A synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(158171, NULL, 'G3DSA:3.30.910.20:FF:000005', NULL, NULL, 'Chaperone protein skp', NULL, NULL, NULL, NULL, NULL, 4),
(158172, NULL, 'G3DSA:1.10.10.10:FF:000861', NULL, NULL, 'Transcriptional regulator, TrmB', NULL, NULL, NULL, NULL, NULL, 4),
(158173, NULL, 'G3DSA:3.30.465.10:FF:000034', NULL, NULL, 'FAD binding domain in molybdopterin dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(158174, NULL, 'G3DSA:1.25.40.10:FF:000790', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(158175, NULL, 'G3DSA:1.20.1250.20:FF:002149', NULL, NULL, 'Os10g0110600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(158176, NULL, 'G3DSA:1.10.510.10:FF:004194', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158177, NULL, 'G3DSA:3.30.230.10:FF:000023', NULL, NULL, 'Putative N-acetylgalactosamine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(158178, NULL, 'G3DSA:2.10.25.10:FF:001488', NULL, NULL, 'Neurogenic locus notch-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(158179, NULL, 'G3DSA:3.20.20.70:FF:000121', NULL, NULL, 'Dihydropyrimidine dehydrogenase (NADP(+)), chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(158180, NULL, 'G3DSA:3.40.50.880:FF:000088', NULL, NULL, 'Pyridoxine biosynthesis protein PDX2', NULL, NULL, NULL, NULL, NULL, 4),
(158181, NULL, 'G3DSA:3.30.70.330:FF:002335', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158182, NULL, 'G3DSA:2.60.40.10:FF:000830', NULL, NULL, 'Turtle, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(158183, NULL, 'G3DSA:1.10.3720.10:FF:000235', NULL, NULL, 'Binding-protein-dependent transport systems inner membrane component', NULL, NULL, NULL, NULL, NULL, 4),
(158184, NULL, 'G3DSA:3.40.50.2000:FF:000816', NULL, NULL, 'Protein CBR-UGT-41', NULL, NULL, NULL, NULL, NULL, 4),
(158185, NULL, 'G3DSA:1.10.150.20:FF:000329', NULL, NULL, 'RAD51 recombinase', NULL, NULL, NULL, NULL, NULL, 4),
(158186, NULL, 'G3DSA:2.60.40.60:FF:000912', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158187, NULL, 'G3DSA:1.25.40.10:FF:000638', NULL, NULL, 'Pentatricopeptide repeat domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(158188, NULL, 'G3DSA:1.25.40.10:FF:002942', NULL, NULL, 'Os02g0116100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(158189, NULL, 'G3DSA:2.40.50.140:FF:000527', NULL, NULL, 'Methionine sulfoxide reductase B1b', NULL, NULL, NULL, NULL, NULL, 4),
(158190, NULL, 'G3DSA:3.40.50.300:FF:006474', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(158191, NULL, 'G3DSA:2.60.40.60:FF:000687', NULL, NULL, 'Cadherin-4', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(158192, NULL, 'G3DSA:3.30.479.30:FF:000044', NULL, NULL, 'Zgc:112408', NULL, NULL, NULL, NULL, NULL, 4),
(158193, NULL, 'G3DSA:3.40.720.10:FF:000120', NULL, NULL, 'GG16284', NULL, NULL, NULL, NULL, NULL, 4),
(158194, NULL, 'G3DSA:3.30.40.10:FF:000003', NULL, NULL, 'E3 SUMO-protein ligase PIAS2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(158195, NULL, 'G3DSA:2.40.50.90:FF:000012', NULL, NULL, 'serine/threonine-protein kinase 31 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(158196, NULL, 'G3DSA:1.10.630.10:FF:000133', NULL, NULL, 'Putative cytochrome P450 135A1', NULL, NULL, NULL, NULL, NULL, 4),
(158197, NULL, 'G3DSA:3.40.50.10190:FF:000041', NULL, NULL, 'DNA nucleotidylexotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(158198, NULL, 'G3DSA:3.20.20.80:FF:000124', NULL, NULL, 'Exported cellulase', NULL, NULL, NULL, NULL, NULL, 4),
(158199, NULL, 'G3DSA:3.40.50.970:FF:000177', NULL, NULL, 'Pyruvate dehydrogenase E1 component alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(158200, NULL, 'G3DSA:3.30.160.60:FF:001190', NULL, NULL, 'zinc finger transcription factor YY1', NULL, NULL, NULL, NULL, NULL, 4),
(158201, NULL, 'G3DSA:3.30.54.20:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158202, NULL, 'G3DSA:2.30.42.60:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158203, NULL, 'G3DSA:1.10.10.850:FF:000001', NULL, NULL, 'Isocitrate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(158204, NULL, 'G3DSA:6.10.140.2230:FF:000001', NULL, NULL, 'RNA polymerase-associated protein RapA', NULL, NULL, NULL, NULL, NULL, 4),
(158205, NULL, 'G3DSA:3.40.50.300:FF:001134', NULL, NULL, 'Probable ATP-dependent RNA helicase DDX27', NULL, NULL, NULL, NULL, NULL, 4),
(158206, NULL, 'G3DSA:4.10.240.10:FF:000125', NULL, NULL, 'Zinc cluster transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(158207, NULL, 'G3DSA:3.90.550.10:FF:000680', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158208, NULL, 'G3DSA:2.60.120.200:FF:000700', NULL, NULL, 'Exotoxin A', NULL, NULL, NULL, NULL, NULL, 4),
(158209, NULL, 'G3DSA:3.30.200.20:FF:000524', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(158210, NULL, 'G3DSA:3.40.50.10490:FF:000136', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158211, NULL, 'G3DSA:3.40.1190.20:FF:000120', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(158212, NULL, 'G3DSA:1.20.1050.10:FF:000074', NULL, NULL, 'Elongation factor 1-gamma 1', NULL, NULL, NULL, NULL, NULL, 4),
(158213, NULL, 'G3DSA:3.40.50.1440:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158214, NULL, 'G3DSA:3.50.50.60:FF:001389', NULL, NULL, 'Lysine-specific histone demethylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(158215, NULL, 'G3DSA:3.10.10.10:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158216, NULL, 'G3DSA:3.30.2350.20:FF:000074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158217, NULL, 'G3DSA:2.40.10.240:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158218, NULL, 'G3DSA:3.30.2070.10:FF:000004', NULL, NULL, 'Anaerobic dehydrogenase typically selenocysteine-containing', NULL, NULL, NULL, NULL, NULL, 4),
(158219, NULL, 'G3DSA:1.10.950.10:FF:000011', NULL, NULL, 'Dematin actin binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(158220, NULL, 'G3DSA:2.40.50.140:FF:000371', NULL, NULL, 'DNA-directed RNA polymerases I, II, and III subunit RPABC3', NULL, NULL, NULL, NULL, NULL, 4),
(158221, NULL, 'G3DSA:3.30.450.20:FF:000284', NULL, NULL, 'Helix-loop-helix 34', NULL, NULL, NULL, NULL, NULL, 4),
(158222, NULL, 'G3DSA:3.40.50.150:FF:000780', NULL, NULL, 'N2,N2-dimethylguanosine tRNA methyltransferase,putative', NULL, NULL, NULL, NULL, NULL, 4),
(158223, NULL, 'G3DSA:3.80.10.10:FF:001943', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase At1g17230', NULL, NULL, NULL, NULL, NULL, 4),
(158224, NULL, 'G3DSA:3.30.505.10:FF:000229', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(158225, NULL, 'G3DSA:2.60.40.10:FF:002893', NULL, NULL, '1,4-alpha-glucan-branching enzyme-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(158226, NULL, 'G3DSA:3.90.190.20:FF:000020', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(158227, NULL, 'G3DSA:2.10.25.10:FF:000471', NULL, NULL, 'Protein lin-12', NULL, NULL, NULL, NULL, NULL, 4),
(158228, NULL, 'G3DSA:3.40.50.1000:FF:000882', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158229, NULL, 'G3DSA:1.10.510.10:FF:003507', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158230, NULL, 'G3DSA:3.30.70.60:FF:000042', NULL, NULL, '30S ribosomal protein S6', NULL, NULL, NULL, NULL, NULL, 4),
(158231, NULL, 'G3DSA:3.80.10.10:FF:004113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158232, NULL, 'G3DSA:1.25.10.10:FF:000636', NULL, NULL, 'Nipped-B protein', NULL, NULL, NULL, NULL, NULL, 4),
(158233, NULL, 'G3DSA:1.25.40.10:FF:004415', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158234, NULL, 'G3DSA:2.60.40.1910:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158235, NULL, 'G3DSA:2.10.70.10:FF:000103', NULL, NULL, 'Coagulation factor XIII B chain', NULL, NULL, NULL, NULL, NULL, 4),
(158236, NULL, 'G3DSA:3.90.79.10:FF:000196', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(158237, NULL, 'G3DSA:3.40.50.300:FF:002769', NULL, NULL, 'DNA repair helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(158238, NULL, 'G3DSA:3.30.160.60:FF:005080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158239, NULL, 'G3DSA:2.30.29.30:FF:000081', NULL, NULL, 'Citron rho-interacting serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(158240, NULL, 'G3DSA:1.10.720.40:FF:000003', NULL, NULL, 'thymopoietin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(158241, NULL, 'G3DSA:4.10.60.10:FF:000216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158242, NULL, 'G3DSA:3.40.50.620:FF:000089', NULL, NULL, 'Bifunctional coenzyme A synthase', NULL, NULL, NULL, NULL, NULL, 4),
(158243, NULL, 'G3DSA:1.20.1250.20:FF:001374', NULL, NULL, 'YALI0F03795p', NULL, NULL, NULL, NULL, NULL, 4),
(158244, NULL, 'G3DSA:1.10.510.10:FF:001321', NULL, NULL, 'Myosin light chain kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(158245, NULL, 'G3DSA:2.40.128.20:FF:000014', NULL, NULL, 'THAP domain-containing protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(158246, NULL, 'G3DSA:2.10.110.10:FF:000157', NULL, NULL, 'LIM/homeobox protein Lhx2', NULL, NULL, NULL, NULL, NULL, 4),
(158247, NULL, 'G3DSA:1.10.150.240:FF:000073', NULL, NULL, 'Indigoidine synthesis like protein', NULL, NULL, NULL, NULL, NULL, 4),
(158248, NULL, 'G3DSA:3.10.200.10:FF:000014', NULL, NULL, 'Carbonic anhydrase 1', NULL, NULL, NULL, NULL, NULL, 4),
(158249, NULL, 'G3DSA:2.170.300.10:FF:000033', NULL, NULL, 'platelet endothelial aggregation receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(158250, NULL, 'G3DSA:2.170.300.10:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158251, NULL, 'G3DSA:2.30.42.10:FF:000627', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158252, NULL, 'G3DSA:3.40.50.2000:FF:000137', NULL, NULL, 'alpha-1,3/1,6-mannosyltransferase ALG2', NULL, NULL, NULL, NULL, NULL, 4),
(158253, NULL, 'G3DSA:2.60.420.10:FF:000012', NULL, NULL, 'Glycoside hydrolase family 65 protein', NULL, NULL, NULL, NULL, NULL, 4),
(158254, NULL, 'G3DSA:1.20.5.420:FF:000007', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(158255, NULL, 'G3DSA:1.20.1070.10:FF:000603', NULL, NULL, 'neuropeptides B/W receptor type 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(158256, NULL, 'G3DSA:3.40.190.290:FF:000082', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(158257, NULL, 'G3DSA:3.30.780.10:FF:000002', NULL, NULL, 'Stress response translation initiation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(158258, NULL, 'G3DSA:3.40.50.300:FF:000111', NULL, NULL, 'DEAD-box ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(158259, NULL, 'G3DSA:3.80.10.10:FF:001937', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158260, NULL, 'G3DSA:3.40.50.300:FF:000696', NULL, NULL, 'GPN-loop GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(158261, NULL, 'G3DSA:1.10.287.70:FF:000004', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(158262, NULL, 'G3DSA:1.20.1050.130:FF:000056', NULL, NULL, 'Glutamyl(E) Amino-acyl tRNA Synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(158263, NULL, 'G3DSA:3.40.50.1580:FF:000027', NULL, NULL, 'Uridine and thymidine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(158264, NULL, 'G3DSA:1.20.140.40:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158265, NULL, 'G3DSA:3.90.1150.170:FF:000004', NULL, NULL, 'Pyridoxal-dependent decarboxylase domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(158266, NULL, 'G3DSA:3.30.450.380:FF:000002', NULL, NULL, 'Secretion protein, partial', NULL, NULL, NULL, NULL, NULL, 4),
(158267, NULL, 'G3DSA:1.20.1250.20:FF:000912', NULL, NULL, 'Major facilitator superfamily MFS_1', NULL, NULL, NULL, NULL, NULL, 4),
(158268, NULL, 'G3DSA:3.30.70.330:FF:002902', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158269, NULL, 'G3DSA:2.40.30.10:FF:000263', NULL, NULL, 'Eukaryotic Elongation Factor, SelenoCysteine-tRNA-specific', NULL, NULL, NULL, NULL, NULL, 4),
(158270, NULL, 'G3DSA:3.10.50.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158271, NULL, 'G3DSA:1.10.510.10:FF:000714', NULL, NULL, 'Kinase family with leucine-rich repeat domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(158272, NULL, 'G3DSA:1.20.5.400:FF:000001', NULL, NULL, 'Cell division protein FtsB', NULL, NULL, NULL, NULL, NULL, 4),
(158273, NULL, 'G3DSA:3.30.70.3340:FF:000002', NULL, NULL, 'Sulfite reductase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(158274, NULL, 'G3DSA:3.10.100.10:FF:000294', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158275, NULL, 'G3DSA:1.20.5.320:FF:000011', NULL, NULL, 'Collagen, type XX, alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(158276, NULL, 'G3DSA:1.20.5.110:FF:000015', NULL, NULL, 'Syntaxin-18, putative', NULL, NULL, NULL, NULL, NULL, 4),
(158277, NULL, 'G3DSA:2.130.10.10:FF:004669', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158278, NULL, 'G3DSA:2.60.40.640:FF:000093', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(158279, NULL, 'G3DSA:3.80.10.10:FF:001994', NULL, NULL, 'Leucine rich repeat receptor protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(158280, NULL, 'G3DSA:3.30.420.40:FF:000693', NULL, NULL, 'Carbohydrate kinase FGGY', NULL, NULL, NULL, NULL, NULL, 4),
(158281, NULL, 'G3DSA:3.80.10.10:FF:004170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158282, NULL, 'G3DSA:3.40.718.10:FF:000058', NULL, NULL, 'Putative isocitrate dehydrogenase [NAD] subunit-like 4', NULL, NULL, NULL, NULL, NULL, 4),
(158283, NULL, 'G3DSA:3.30.1240.10:FF:000034', NULL, NULL, 'Cof-type HAD-IIB family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(158284, NULL, 'G3DSA:1.20.1250.20:FF:002037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158285, NULL, 'G3DSA:3.90.1150.160:FF:000001', NULL, NULL, 'Glutamate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(158286, NULL, 'G3DSA:3.10.20.230:FF:000006', NULL, NULL, 'Oxygen-regulated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(158287, NULL, 'G3DSA:1.10.510.10:FF:002844', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(158288, NULL, 'G3DSA:1.20.120.1750:FF:000148', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(158289, NULL, 'G3DSA:3.40.50.300:FF:007997', NULL, NULL, 'Helicase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(158290, NULL, 'G3DSA:3.80.10.10:FF:000802', NULL, NULL, 'F-box protein At-B', NULL, NULL, NULL, NULL, NULL, 4),
(158291, NULL, 'G3DSA:3.30.70.3490:FF:000064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(158292, NULL, 'G3DSA:2.130.10.10:FF:003045', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(158293, NULL, 'G3DSA:3.90.70.10:FF:000558', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(158294, NULL, 'G3DSA:3.90.180.10:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158295, NULL, 'G3DSA:1.10.287.70:FF:000330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158296, NULL, 'G3DSA:3.30.200.20:FF:000530', NULL, NULL, 'receptor protein-tyrosine kinase CEPR1', NULL, NULL, NULL, NULL, NULL, 4),
(158297, NULL, 'G3DSA:2.40.50.140:FF:000078', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(158298, NULL, 'G3DSA:1.25.10.10:FF:002873', NULL, NULL, 'Meiotic check point regulator-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(158299, NULL, 'G3DSA:1.25.40.80:FF:000001', NULL, NULL, 'Cryptochrome circadian regulator 2', NULL, NULL, NULL, NULL, NULL, 4),
(158300, NULL, 'G3DSA:3.30.200.20:FF:000316', NULL, NULL, 'Proto-oncogene serine/threonine-protein kinase mos', NULL, NULL, NULL, NULL, NULL, 4),
(158301, NULL, 'G3DSA:1.25.40.90:FF:000004', NULL, NULL, 'splicing factor, arginine/serine-rich 15', NULL, NULL, NULL, NULL, NULL, 4),
(158302, NULL, 'G3DSA:2.10.50.30:FF:000052', NULL, NULL, 'Vomeronasal 2 receptor p1', NULL, NULL, NULL, NULL, NULL, 4),
(158303, NULL, 'G3DSA:3.30.1330.60:FF:000028', NULL, NULL, 'Peptidoglycan-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(158304, NULL, 'G3DSA:3.40.50.2000:FF:000081', NULL, NULL, 'UDP-glucuronosyltransferase 2A2', NULL, NULL, NULL, NULL, NULL, 4),
(158305, NULL, 'G3DSA:3.30.70.3030:FF:000010', NULL, NULL, 'U3 small nucleolar RNA-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(158306, NULL, 'G3DSA:1.10.10.60:FF:000443', NULL, NULL, 'Transcription factor MYB36', NULL, NULL, NULL, NULL, NULL, 4),
(158307, NULL, 'G3DSA:1.10.1170.10:FF:000029', NULL, NULL, 'Death-associated inhibitor of apoptosis 2', NULL, NULL, NULL, NULL, NULL, 4),
(158308, NULL, 'G3DSA:3.30.70.980:FF:000057', NULL, NULL, 'DNA-binding protein Ets97D-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(158309, NULL, 'G3DSA:1.20.58.610:FF:000007', NULL, NULL, 'Hsp90 co-chaperone Cdc37', NULL, NULL, NULL, NULL, NULL, 4),
(158310, NULL, 'G3DSA:3.40.50.300:FF:001634', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(158311, NULL, 'G3DSA:3.30.497.10:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158312, NULL, 'G3DSA:2.60.40.10:FF:003067', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(158313, NULL, 'G3DSA:1.20.1510.10:FF:000003', NULL, NULL, 'Metal tolerance protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(158314, NULL, 'G3DSA:3.40.50.150:FF:000454', NULL, NULL, 'tRNA m5C-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(158315, NULL, 'G3DSA:3.40.50.2020:FF:000087', NULL, NULL, 'Ribose-phosphate pyrophosphokinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(158316, NULL, 'G3DSA:2.60.40.10:FF:005208', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158317, NULL, 'G3DSA:1.25.40.90:FF:000061', NULL, NULL, 'UV-stimulated scaffold protein A', NULL, NULL, NULL, NULL, NULL, 4),
(158318, NULL, 'G3DSA:3.30.1330.40:FF:000022', NULL, NULL, 'YLR143W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(158319, NULL, 'G3DSA:3.40.50.1000:FF:000556', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158320, NULL, 'G3DSA:1.10.10.60:FF:000179', NULL, NULL, 'Two component, sigma54 specific, transcriptional regulator, Fis family', NULL, NULL, NULL, NULL, NULL, 4),
(158321, NULL, 'G3DSA:1.10.150.20:FF:000088', NULL, NULL, 'DNA repair protein RadC', NULL, NULL, NULL, NULL, NULL, 4),
(158322, NULL, 'G3DSA:3.30.200.20:FF:002407', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158323, NULL, 'G3DSA:3.40.50.300:FF:000971', NULL, NULL, 'GTPase RhebL1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(158324, NULL, 'G3DSA:1.10.4160.10:FF:000006', NULL, NULL, 'NCS1 family nucleobase:cation symporter-1', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(158325, NULL, 'G3DSA:2.130.10.10:FF:002814', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(158326, NULL, 'G3DSA:3.30.559.10:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158327, NULL, 'G3DSA:3.30.160.60:FF:004298', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158328, NULL, 'G3DSA:2.40.160.50:FF:000025', NULL, NULL, 'ShlB/FhaC/HecB family hemolysin secretion/activation protein', NULL, NULL, NULL, NULL, NULL, 4),
(158329, NULL, 'G3DSA:1.10.1200.60:FF:000002', NULL, NULL, '50S ribosomal protein L19e', NULL, NULL, NULL, NULL, NULL, 4),
(158330, NULL, 'G3DSA:1.25.40.20:FF:001922', NULL, NULL, 'Ion channel NompC', NULL, NULL, NULL, NULL, NULL, 4),
(158331, NULL, 'G3DSA:1.25.40.10:FF:002493', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g18940, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(158332, NULL, 'G3DSA:3.30.460.20:FF:000015', NULL, NULL, 'Magnesium transport protein CorA', NULL, NULL, NULL, NULL, NULL, 4),
(158333, NULL, 'G3DSA:3.90.550.50:FF:000219', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(158334, NULL, 'G3DSA:3.90.950.10:FF:000042', NULL, NULL, 'dTTP/UTP pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(158335, NULL, 'G3DSA:1.25.40.10:FF:002549', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(158336, NULL, 'G3DSA:3.40.50.720:FF:001985', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158337, NULL, 'G3DSA:3.30.460.10:FF:000012', NULL, NULL, 'GTP pyrophosphokinase YjbM', NULL, NULL, NULL, NULL, NULL, 4),
(158338, NULL, 'G3DSA:3.90.470.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158339, NULL, 'G3DSA:3.90.1150.10:FF:000064', NULL, NULL, 'Serine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(158340, NULL, 'G3DSA:3.40.50.1820:FF:000419', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(158341, NULL, 'G3DSA:2.130.10.10:FF:004905', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(158342, NULL, 'G3DSA:1.20.1070.10:FF:001946', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158343, NULL, 'G3DSA:1.25.40.180:FF:000190', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158344, NULL, 'G3DSA:1.25.40.10:FF:000464', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(158345, NULL, 'G3DSA:1.25.40.480:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158346, NULL, 'G3DSA:3.90.470.20:FF:000053', NULL, NULL, '4''-phosphopantetheinyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(158347, NULL, 'G3DSA:3.40.390.10:FF:000077', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(158348, NULL, 'G3DSA:3.30.590.50:FF:000011', NULL, NULL, 'Gamma-glutamylcysteine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(158349, NULL, 'G3DSA:2.60.40.10:FF:004933', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158350, NULL, 'G3DSA:2.120.10.80:FF:000306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158351, NULL, 'G3DSA:2.60.40.60:FF:000980', NULL, NULL, 'Si:dkey-30k22.7', NULL, NULL, NULL, NULL, NULL, 4),
(158352, NULL, 'G3DSA:3.40.1310.20:FF:000001', NULL, NULL, 'Replication-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(158353, NULL, 'G3DSA:2.40.30.10:FF:000471', NULL, NULL, 'Cytochrome p450 oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(158354, NULL, 'G3DSA:2.60.40.10:FF:001999', NULL, NULL, 'FiLamiN (Actin binding protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(158355, NULL, 'G3DSA:2.20.130.20:FF:000002', NULL, NULL, 'Complement C4-A', NULL, NULL, NULL, NULL, NULL, 4),
(158356, NULL, 'G3DSA:3.80.10.10:FF:003388', NULL, NULL, 'F-box and leucine-rich repeat protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(158357, NULL, 'G3DSA:1.25.40.20:FF:000467', NULL, NULL, 'E3 ubiquitin-protein ligase XB3', NULL, NULL, NULL, NULL, NULL, 4),
(158358, NULL, 'G3DSA:3.40.50.1820:FF:001836', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(158359, NULL, 'G3DSA:1.25.40.10:FF:000868', NULL, NULL, 'SET and MYND domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(158360, NULL, 'G3DSA:2.40.50.40:FF:000008', NULL, NULL, 'Chromodomain-helicase-DNA-binding protein 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(158361, NULL, 'G3DSA:3.10.20.90:FF:000768', NULL, NULL, 'Phosphatidylinositol-3-phosphate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(158362, NULL, 'G3DSA:1.20.1050.10:FF:000315', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(158363, NULL, 'G3DSA:3.40.50.150:FF:000549', NULL, NULL, 'tRNA (adenine(58)-N(1))-methyltransferase catalytic subunit TRMT61A', NULL, NULL, NULL, NULL, NULL, 4),
(158364, NULL, 'G3DSA:1.20.1070.10:FF:000811', NULL, NULL, 'Muscarinic acetylcholine receptor gar-2', NULL, NULL, NULL, NULL, NULL, 4),
(158365, NULL, 'G3DSA:3.30.70.270:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158366, NULL, 'G3DSA:2.120.10.80:FF:000363', NULL, NULL, 'Nitrile-specifier protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(158367, NULL, 'G3DSA:3.80.10.10:FF:004282', NULL, NULL, 'Toll-9, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(158368, NULL, 'G3DSA:3.40.710.10:FF:000052', NULL, NULL, 'Penicillin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(158369, NULL, 'G3DSA:3.30.70.330:FF:002009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158370, NULL, 'G3DSA:1.25.40.10:FF:003898', NULL, NULL, 'Coatomer subunit epsilon-2', NULL, NULL, NULL, NULL, NULL, 4),
(158371, NULL, 'G3DSA:1.20.1070.10:FF:001267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158372, NULL, 'G3DSA:3.30.70.330:FF:001003', NULL, NULL, 'Multiple RNA-binding domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(158373, NULL, 'G3DSA:3.30.200.20:FF:000592', NULL, NULL, 'L-type lectin-domain containing receptor kinase V.9', NULL, NULL, NULL, NULL, NULL, 4),
(158374, NULL, 'G3DSA:1.25.40.20:FF:001361', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158375, NULL, 'G3DSA:3.30.710.10:FF:000054', NULL, NULL, 'Zinc finger and BTB domain-containing protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(158376, NULL, 'G3DSA:2.60.40.10:FF:002836', NULL, NULL, 'Glucoamylase', NULL, NULL, NULL, NULL, NULL, 4),
(158377, NULL, 'G3DSA:3.60.10.10:FF:000230', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(158378, NULL, 'G3DSA:1.25.40.10:FF:000189', NULL, NULL, 'Tetratricopeptide repeat domain 25', NULL, NULL, NULL, NULL, NULL, 4),
(158379, NULL, 'G3DSA:3.40.50.300:FF:008391', NULL, NULL, 'ATP-dependent DNA helicase recQ', NULL, NULL, NULL, NULL, NULL, 4),
(158380, NULL, 'G3DSA:3.40.50.150:FF:001443', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158381, NULL, 'G3DSA:3.10.20.90:FF:000886', NULL, NULL, 'RanBP-type and C3HC4-type zinc finger-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(158382, NULL, 'G3DSA:2.30.29.30:FF:000434', NULL, NULL, 'Rho guanine nucleotide exchange factor 17', NULL, NULL, NULL, NULL, NULL, 4),
(158383, NULL, 'G3DSA:3.90.1310.10:FF:000037', NULL, NULL, 'Probable peptidoglycan D,D-transpeptidase PbpC', NULL, NULL, NULL, NULL, NULL, 4),
(158384, NULL, 'G3DSA:3.40.190.10:FF:000775', NULL, NULL, 'ABC-type transport system periplasmic substrate-binding protein (Probable substrate dipeptide/oligopeptide)', NULL, NULL, NULL, NULL, NULL, 4),
(158385, NULL, 'G3DSA:2.40.30.120:FF:000001', NULL, NULL, 'Capsid protein VP1', NULL, NULL, NULL, NULL, NULL, 4),
(158386, NULL, 'G3DSA:3.40.50.2300:FF:000805', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158387, NULL, 'G3DSA:3.30.160.60:FF:000875', NULL, NULL, 'zinc finger protein 236 isoform X7', NULL, NULL, NULL, NULL, NULL, 4),
(158388, NULL, 'G3DSA:1.20.1070.10:FF:001385', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(158389, NULL, 'G3DSA:3.40.50.80:FF:000046', NULL, NULL, 'Probable ferric reductase transmembrane component', NULL, NULL, NULL, NULL, NULL, 4),
(158390, NULL, 'G3DSA:2.160.20.10:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(158391, NULL, 'G3DSA:3.10.310.40:FF:000003', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(158392, NULL, 'G3DSA:1.20.140.150:FF:000036', NULL, NULL, 'Voltage-dependent calcium channel gamma-4 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(158393, NULL, 'G3DSA:2.30.30.40:FF:000558', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(158394, NULL, 'G3DSA:3.40.50.1440:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158395, NULL, 'G3DSA:3.40.50.720:FF:001928', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158396, NULL, 'G3DSA:3.10.20.90:FF:000829', NULL, NULL, 'Autophagy-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(158397, NULL, 'G3DSA:2.40.160.110:FF:000040', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(158398, NULL, 'G3DSA:3.40.50.300:FF:001426', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(158399, NULL, 'G3DSA:1.25.40.10:FF:004792', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(158400, NULL, 'G3DSA:3.40.640.10:FF:000136', NULL, NULL, 'Possible aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(158401, NULL, 'G3DSA:1.25.40.10:FF:003044', NULL, NULL, 'Crooked neck protein', NULL, NULL, NULL, NULL, NULL, 4),
(158402, NULL, 'G3DSA:1.20.120.20:FF:000033', NULL, NULL, 'Uncharacterized protein At4g13230', NULL, NULL, NULL, NULL, NULL, 4),
(158403, NULL, 'G3DSA:3.30.70.330:FF:002627', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158404, NULL, 'G3DSA:2.60.40.60:FF:000979', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158405, NULL, 'G3DSA:2.10.25.10:FF:001567', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158406, NULL, 'G3DSA:1.10.510.10:FF:002159', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(158407, NULL, 'G3DSA:3.30.160.60:FF:001482', NULL, NULL, 'Hunchback', NULL, NULL, NULL, NULL, NULL, 4),
(158408, NULL, 'G3DSA:3.40.50.720:FF:000361', NULL, NULL, 'Acyl-CoA synthetase FdrA', NULL, NULL, NULL, NULL, NULL, 4),
(158409, NULL, 'G3DSA:2.130.10.10:FF:002871', NULL, NULL, 'Related to KOG1-Subunit of TORC1, a rapamycin-sensitive complex involved in growth control', NULL, NULL, NULL, NULL, NULL, 4),
(158410, NULL, 'G3DSA:1.20.1390.10:FF:000009', NULL, NULL, 'RNA binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(158411, NULL, 'G3DSA:1.10.30.50:FF:000008', NULL, NULL, 'Phage endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(158412, NULL, 'G3DSA:3.10.310.50:FF:000006', NULL, NULL, 'Sll1390 protein', NULL, NULL, NULL, NULL, NULL, 4),
(158413, NULL, 'G3DSA:2.60.40.10:FF:005416', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158414, NULL, 'G3DSA:3.40.850.10:FF:000444', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158415, NULL, 'G3DSA:3.90.550.50:FF:000158', NULL, NULL, 'AGAP009562-PA', NULL, NULL, NULL, NULL, NULL, 4),
(158416, NULL, 'G3DSA:2.40.50.140:FF:000819', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158417, NULL, 'G3DSA:3.30.70.330:FF:000536', NULL, NULL, 'RNA-binding protein 6, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(158418, NULL, 'G3DSA:2.40.10.10:FF:000374', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158419, NULL, 'G3DSA:2.40.10.350:FF:000004', NULL, NULL, 'Cell shape-determining protein MreC', NULL, NULL, NULL, NULL, NULL, 4),
(158420, NULL, 'G3DSA:1.10.472.10:FF:000647', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(158421, NULL, 'G3DSA:2.130.10.10:FF:002606', NULL, NULL, 'Ribosome biogenesis protein WDR12 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(158422, NULL, 'G3DSA:3.30.60.30:FF:000229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158423, NULL, 'G3DSA:3.60.20.10:FF:000236', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158424, NULL, 'G3DSA:3.30.420.60:FF:000002', NULL, NULL, 'Protein pelota homolog', NULL, NULL, NULL, NULL, NULL, 4),
(158425, NULL, 'G3DSA:1.10.730.10:FF:000079', NULL, NULL, 'Isoleucyl-tRNA synthetase, cytoplasmic, putative', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(158426, NULL, 'G3DSA:2.40.50.100:FF:000095', NULL, NULL, 'Efflux transporter, RND family, MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(158427, NULL, 'G3DSA:1.10.20.10:FF:000283', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158428, NULL, 'G3DSA:1.25.40.20:FF:001602', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(158429, NULL, 'G3DSA:3.30.420.40:FF:000816', NULL, NULL, 'Putative nodulation protein nolNO', NULL, NULL, NULL, NULL, NULL, 4),
(158430, NULL, 'G3DSA:2.130.10.10:FF:003888', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158431, NULL, 'G3DSA:3.30.160.60:FF:002842', NULL, NULL, 'zinc finger and BTB domain-containing protein 49 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(158432, NULL, 'G3DSA:2.120.10.30:FF:000376', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158433, NULL, 'G3DSA:3.30.160.60:FF:005304', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158434, NULL, 'G3DSA:1.20.58.60:FF:000131', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(158435, NULL, 'G3DSA:1.10.8.270:FF:000116', NULL, NULL, 'Small G protein-signaling modulator 1b', NULL, NULL, NULL, NULL, NULL, 4),
(158436, NULL, 'G3DSA:1.10.510.10:FF:002491', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158437, NULL, 'G3DSA:2.40.10.340:FF:000001', NULL, NULL, 'Cell shape-determining protein MreC', NULL, NULL, NULL, NULL, NULL, 4),
(158438, NULL, 'G3DSA:2.120.10.80:FF:000284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158439, NULL, 'G3DSA:3.40.50.300:FF:003225', NULL, NULL, 'Structural maintenance of chromosomes protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(158440, NULL, 'G3DSA:3.80.10.10:FF:004523', NULL, NULL, 'FBD, F-box and Leucine Rich Repeat domains containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(158441, NULL, 'G3DSA:3.40.630.10:FF:000175', NULL, NULL, 'Double-zinc aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(158442, NULL, 'G3DSA:3.40.190.170:FF:000006', NULL, NULL, 'C4-dicarboxylate ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(158443, NULL, 'G3DSA:1.10.10.410:FF:000010', NULL, NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit B, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(158444, NULL, 'G3DSA:1.20.1280.120:FF:000003', NULL, NULL, 'Catalase-related peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(158445, NULL, 'G3DSA:3.20.110.10:FF:000016', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(158446, NULL, 'G3DSA:1.10.10.10:FF:001878', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158447, NULL, 'G3DSA:1.20.910.10:FF:000006', NULL, NULL, 'Bifunctional TH2 protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(158448, NULL, 'G3DSA:3.30.300.30:FF:000063', NULL, NULL, 'Acyl-CoA ligase sidI', NULL, NULL, NULL, NULL, NULL, 4),
(158449, NULL, 'G3DSA:1.10.555.10:FF:000042', NULL, NULL, 'rho GTPase-activating protein 11A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(158450, NULL, 'G3DSA:3.30.760.10:FF:000057', NULL, NULL, 'Predicted gene 20696', NULL, NULL, NULL, NULL, NULL, 4),
(158451, NULL, 'G3DSA:2.60.40.10:FF:000925', NULL, NULL, 'immunoglobulin superfamily member 10', NULL, NULL, NULL, NULL, NULL, 4),
(158452, NULL, 'G3DSA:2.60.120.10:FF:000782', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158453, NULL, 'G3DSA:3.10.100.10:FF:000029', NULL, NULL, 'Mannose receptor C type 2', NULL, NULL, NULL, NULL, NULL, 4),
(158454, NULL, 'G3DSA:3.30.300.20:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158455, NULL, 'G3DSA:3.40.50.720:FF:001367', NULL, NULL, 'D-2-hydroxy-acid dehydrogenase-like', NULL, NULL, NULL, NULL, NULL, 4),
(158456, NULL, 'G3DSA:1.10.533.10:FF:000284', NULL, NULL, 'NLR family, CARD domain-containing 3-like', NULL, NULL, NULL, NULL, NULL, 4),
(158457, NULL, 'G3DSA:2.60.40.60:FF:000704', NULL, NULL, 'Fat-like cadherin-related tumor suppressor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(158458, NULL, 'G3DSA:1.20.1280.20:FF:000010', NULL, NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(158459, NULL, 'G3DSA:3.40.50.150:FF:001454', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158460, NULL, 'G3DSA:3.30.70.120:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158461, NULL, 'G3DSA:3.40.190.10:FF:000500', NULL, NULL, 'CG15327', NULL, NULL, NULL, NULL, NULL, 4),
(158462, NULL, 'G3DSA:4.10.240.10:FF:000030', NULL, NULL, 'C6 transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(158463, NULL, 'G3DSA:3.40.50.720:FF:001996', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158464, NULL, 'G3DSA:1.25.40.10:FF:002881', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158465, NULL, 'G3DSA:2.60.470.10:FF:000015', NULL, NULL, 'Pickpocket 20, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(158466, NULL, 'G3DSA:2.60.40.10:FF:003331', NULL, NULL, 'Down syndrome cell adhesion molecule b', NULL, NULL, NULL, NULL, NULL, 4),
(158467, NULL, 'G3DSA:1.10.340.30:FF:000072', NULL, NULL, 'Helix-hairpin-helix motif', NULL, NULL, NULL, NULL, NULL, 4),
(158468, NULL, 'G3DSA:3.30.160.60:FF:004641', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158469, NULL, 'G3DSA:3.40.50.10140:FF:000054', NULL, NULL, 'Toll-like receptor2', NULL, NULL, NULL, NULL, NULL, 4),
(158470, NULL, 'G3DSA:2.60.40.150:FF:000389', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(158471, NULL, 'G3DSA:3.30.70.330:FF:002285', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158472, NULL, 'G3DSA:1.25.40.10:FF:004292', NULL, NULL, 'Pentatricopeptide repeat-containing protein 5, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(158473, NULL, 'G3DSA:3.80.10.10:FF:001590', NULL, NULL, 'MDIS1-interacting receptor like kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(158474, NULL, 'G3DSA:3.40.30.10:FF:001087', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(158475, NULL, 'G3DSA:1.10.510.10:FF:000692', NULL, NULL, 'Serine/threonine protein kinase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(158476, NULL, 'G3DSA:3.40.1440.10:FF:000013', NULL, NULL, 'Structure-specific endonuclease subunit SLX1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(158477, NULL, 'G3DSA:1.25.40.10:FF:002824', NULL, NULL, 'Mitochondrial group I intron splicing factor CCM1', NULL, NULL, NULL, NULL, NULL, 4),
(158478, NULL, 'G3DSA:2.130.10.10:FF:004405', NULL, NULL, 'Protein CBG02012', NULL, NULL, NULL, NULL, NULL, 4),
(158479, NULL, 'G3DSA:2.60.40.10:FF:005130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158480, NULL, 'G3DSA:3.20.20.80:FF:000006', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(158481, NULL, 'G3DSA:2.60.40.60:FF:001025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158482, NULL, 'G3DSA:3.40.640.10:FF:000344', NULL, NULL, 'Low-specificity L-threonine aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(158483, NULL, 'G3DSA:3.40.309.10:FF:000052', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(158484, NULL, 'G3DSA:3.30.470.20:FF:000072', NULL, NULL, 'Biotin carboxylase subunit of acetyl CoA carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(158485, NULL, 'G3DSA:3.30.160.60:FF:006439', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158486, NULL, 'G3DSA:3.40.50.2300:FF:001469', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158487, NULL, 'G3DSA:3.30.40.10:FF:002015', NULL, NULL, 'Lysine-specific demethylase 5C', NULL, NULL, NULL, NULL, NULL, 4),
(158488, NULL, 'G3DSA:1.20.1080.10:FF:000076', NULL, NULL, 'aquaporin-like', NULL, NULL, NULL, NULL, NULL, 4),
(158489, NULL, 'G3DSA:2.120.10.30:FF:000319', NULL, NULL, 'Bll6325 protein', NULL, NULL, NULL, NULL, NULL, 4),
(158490, NULL, 'G3DSA:2.60.15.10:FF:000002', NULL, NULL, 'ATP synthase epsilon chain, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(158491, NULL, 'G3DSA:1.10.260.40:FF:000074', NULL, NULL, 'Homeobox protein cut-like', NULL, NULL, NULL, NULL, NULL, 4),
(158492, NULL, 'G3DSA:1.10.418.10:FF:000207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(158493, NULL, 'G3DSA:3.20.20.70:FF:000003', NULL, NULL, 'GMP reductase', NULL, NULL, NULL, NULL, NULL, 4),
(158494, NULL, 'G3DSA:3.10.110.10:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158495, NULL, 'G3DSA:3.40.50.1240:FF:000156', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158496, NULL, 'G3DSA:1.20.1280.290:FF:000026', NULL, NULL, 'PQ loop repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(158497, NULL, 'G3DSA:1.25.10.10:FF:003121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158498, NULL, 'G3DSA:3.30.1520.10:FF:000016', NULL, NULL, 'Sorting nexin 2', NULL, NULL, NULL, NULL, NULL, 4),
(158499, NULL, 'G3DSA:3.90.640.10:FF:000271', NULL, NULL, 'Actin-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(158500, NULL, 'G3DSA:3.90.340.10:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158501, NULL, 'G3DSA:3.20.20.80:FF:000236', NULL, NULL, 'Arabinogalactan endo-beta-1,4-galactanase', NULL, NULL, NULL, NULL, NULL, 4),
(158502, NULL, 'G3DSA:1.10.3720.10:FF:000027', NULL, NULL, 'Arginine ABC transporter, permease protein ArtQ', NULL, NULL, NULL, NULL, NULL, 4),
(158503, NULL, 'G3DSA:1.10.287.10:FF:000008', NULL, NULL, 'histidine--tRNA ligase, cytoplasmic isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(158504, NULL, 'G3DSA:1.10.238.10:FF:000671', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158505, NULL, 'G3DSA:2.30.280.10:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158506, NULL, 'G3DSA:3.90.70.10:FF:000497', NULL, NULL, 'Si:ch211-165f21.4', NULL, NULL, NULL, NULL, NULL, 4),
(158507, NULL, 'G3DSA:3.90.70.80:FF:000023', NULL, NULL, 'OTU ovarian tumor-like cysteine protease', NULL, NULL, NULL, NULL, NULL, 4),
(158508, NULL, 'G3DSA:1.10.472.10:FF:000029', NULL, NULL, 'Cyclin h', NULL, NULL, NULL, NULL, NULL, 4),
(158509, NULL, 'G3DSA:1.20.1740.10:FF:000222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158510, NULL, 'G3DSA:2.130.10.10:FF:005400', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158511, NULL, 'G3DSA:2.60.34.10:FF:000074', NULL, NULL, 'Heat shock protein 110, putative', NULL, NULL, NULL, NULL, NULL, 4),
(158512, NULL, 'G3DSA:1.25.40.180:FF:000122', NULL, NULL, 'CaGCR3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(158513, NULL, 'G3DSA:3.80.10.10:FF:002039', NULL, NULL, 'Insulin-like growth factor-binding protein acid labile subunit', NULL, NULL, NULL, NULL, NULL, 4),
(158514, NULL, 'G3DSA:3.30.559.10:FF:000005', NULL, NULL, 'Dihydrolipoyllysine-residue succinyltransferase component of 2-oxoglutarate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(158515, NULL, 'G3DSA:3.30.260.10:FF:000025', NULL, NULL, 'Chaperonin containing TCP1 subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(158516, NULL, 'G3DSA:3.30.420.40:FF:000075', NULL, NULL, 'Actin-related protein 10 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(158517, NULL, 'G3DSA:1.20.1280.130:FF:000006', NULL, NULL, 'Vacuolar protein sorting 54 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(158518, NULL, 'G3DSA:1.20.210.10:FF:000037', NULL, NULL, 'Cytochrome c oxidase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(158519, NULL, 'G3DSA:2.60.120.200:FF:000200', NULL, NULL, 'Laminin subunit alpha-3', NULL, NULL, NULL, NULL, NULL, 4),
(158520, NULL, 'G3DSA:3.40.50.300:FF:008514', NULL, NULL, 'Valosin-containing protein homolog, putative', NULL, NULL, NULL, NULL, NULL, 4),
(158521, NULL, 'G3DSA:2.10.109.10:FF:000036', NULL, NULL, 'DEAD/DEAH box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(158522, NULL, 'G3DSA:3.30.429.10:FF:000001', NULL, NULL, 'Macrophage migration inhibitory factor', NULL, NULL, NULL, NULL, NULL, 4),
(158523, NULL, 'G3DSA:2.160.20.10:FF:000037', NULL, NULL, 'Probable exopolygalacturonase C', NULL, NULL, NULL, NULL, NULL, 4),
(158524, NULL, 'G3DSA:3.90.175.10:FF:000004', NULL, NULL, 'Grass carp reovirus (GCRV)-induced gene 2e', NULL, NULL, NULL, NULL, NULL, 4),
(158525, NULL, 'G3DSA:1.10.600.10:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(158526, NULL, 'G3DSA:3.30.160.60:FF:001690', NULL, NULL, 'Zinc finger and SCAN domain containing 5A', NULL, NULL, NULL, NULL, NULL, 4),
(158527, NULL, 'G3DSA:2.60.40.10:FF:002393', NULL, NULL, 'Lys-gingipain 381', NULL, NULL, NULL, NULL, NULL, 4),
(158528, NULL, 'G3DSA:3.40.50.720:FF:002159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158529, NULL, 'G3DSA:1.20.1280.50:FF:000249', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(158530, NULL, 'G3DSA:3.10.100.10:FF:000361', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158531, NULL, 'G3DSA:1.20.1070.10:FF:000250', NULL, NULL, 'probable G-protein coupled receptor 141', NULL, NULL, NULL, NULL, NULL, 4),
(158532, NULL, 'G3DSA:3.30.470.30:FF:000075', NULL, NULL, 'Putative DNA ligase 4', NULL, NULL, NULL, NULL, NULL, 4),
(158533, NULL, 'G3DSA:3.80.10.10:FF:003467', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158534, NULL, 'G3DSA:1.25.40.10:FF:004679', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(158535, NULL, 'G3DSA:1.10.510.10:FF:002569', NULL, NULL, 'Non-specific protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(158536, NULL, 'G3DSA:1.20.1070.10:FF:002048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158537, NULL, 'G3DSA:1.20.1000.10:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158538, NULL, 'G3DSA:1.20.1250.20:FF:000412', NULL, NULL, 'SIT1p Ferrioxamine B transporter', NULL, NULL, NULL, NULL, NULL, 4),
(158539, NULL, 'G3DSA:1.10.510.10:FF:004289', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158540, NULL, 'G3DSA:2.40.70.10:FF:000467', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158541, NULL, 'G3DSA:3.30.50.10:FF:000043', NULL, NULL, 'Sexual development transcription factor NsdD', NULL, NULL, NULL, NULL, NULL, 4),
(158542, NULL, 'G3DSA:2.130.10.10:FF:005220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158543, NULL, 'G3DSA:1.20.5.20:FF:000002', NULL, NULL, 'Apolipoprotein A-IV b, tandem duplicate 1', NULL, NULL, NULL, NULL, NULL, 4),
(158544, NULL, 'G3DSA:1.10.1200.80:FF:000008', NULL, NULL, 'tRNA-dihydrouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(158545, NULL, 'G3DSA:3.10.20.870:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158546, NULL, 'G3DSA:2.130.10.10:FF:002882', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(158547, NULL, 'G3DSA:3.40.50.1820:FF:001757', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158548, NULL, 'G3DSA:1.20.1250.20:FF:001694', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158549, NULL, 'G3DSA:2.30.30.940:FF:000007', NULL, NULL, 'ATP-dependent RecD-like DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(158550, NULL, 'G3DSA:1.10.274.100:FF:000004', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(158551, NULL, 'G3DSA:1.20.1530.20:FF:000069', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(158552, NULL, 'G3DSA:2.130.10.10:FF:004944', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158553, NULL, 'G3DSA:3.90.420.10:FF:000013', NULL, NULL, 'Oxidoreductase molybdopterin binding', NULL, NULL, NULL, NULL, NULL, 4),
(158554, NULL, 'G3DSA:2.40.50.140:FF:000432', NULL, NULL, 'ABC sugar transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(158555, NULL, 'G3DSA:2.130.10.10:FF:000454', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit WDR4', NULL, NULL, NULL, NULL, NULL, 4),
(158556, NULL, 'G3DSA:3.80.10.10:FF:001258', NULL, NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(158557, NULL, 'G3DSA:3.40.50.300:FF:001073', NULL, NULL, 'ATP-binding Cassette (ABC) Superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(158558, NULL, 'G3DSA:1.20.1250.20:FF:001874', NULL, NULL, 'Pyrazinamidase/nicotinamidase, putative', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(158559, NULL, 'G3DSA:1.25.70.10:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158560, NULL, 'G3DSA:1.25.10.10:FF:001530', NULL, NULL, 'Serine/threonine-protein kinase sepA', NULL, NULL, NULL, NULL, NULL, 4),
(158561, NULL, 'G3DSA:2.170.210.20:FF:000001', NULL, NULL, 'Spindle assembly abnormal protein 6 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(158562, NULL, 'G3DSA:1.20.1310.10:FF:000027', NULL, NULL, 'Anaphase-promoting complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(158563, NULL, 'G3DSA:1.20.1250.20:FF:002150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158564, NULL, 'G3DSA:1.10.1300.10:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158565, NULL, 'G3DSA:1.20.1050.130:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158566, NULL, 'G3DSA:1.10.472.10:FF:000259', NULL, NULL, 'Putative cyclin-D7-1', NULL, NULL, NULL, NULL, NULL, 4),
(158567, NULL, 'G3DSA:2.60.120.260:FF:000465', NULL, NULL, 'Reelin', NULL, NULL, NULL, NULL, NULL, 4),
(158568, NULL, 'G3DSA:2.30.30.30:FF:000117', NULL, NULL, 'Putative ribosomal protein S4 (RPS4A) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(158569, NULL, 'G3DSA:3.50.50.60:FF:000933', NULL, NULL, 'NADH-rubredoxin oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(158570, NULL, 'G3DSA:1.20.1250.20:FF:001817', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158571, NULL, 'G3DSA:3.30.300.30:FF:000006', NULL, NULL, 'Long-chain-fatty-acid--CoA ligase FadD', NULL, NULL, NULL, NULL, NULL, 4),
(158572, NULL, 'G3DSA:3.40.50.10490:FF:000041', NULL, NULL, 'Transcriptional regulator, RpiR family', NULL, NULL, NULL, NULL, NULL, 4),
(158573, NULL, 'G3DSA:1.10.1370.10:FF:000016', NULL, NULL, 'Thimet oligopeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(158574, NULL, 'G3DSA:1.10.1320.10:FF:000013', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(158575, NULL, 'G3DSA:3.40.390.10:FF:000251', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158576, NULL, 'G3DSA:2.10.25.10:FF:001831', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158577, NULL, 'G3DSA:3.30.720.150:FF:000001', NULL, NULL, 'UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase 110 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(158578, NULL, 'G3DSA:3.30.160.60:FF:001072', NULL, NULL, 'zinc finger and BTB domain-containing protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(158579, NULL, 'G3DSA:2.60.40.2860:FF:000008', NULL, NULL, '6-cysteine protein', NULL, NULL, NULL, NULL, NULL, 4),
(158580, NULL, 'G3DSA:3.40.50.460:FF:000018', NULL, NULL, 'Phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(158581, NULL, 'G3DSA:3.40.190.10:FF:000707', NULL, NULL, 'Taurine ABC transporter, periplasmic taurine-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(158582, NULL, 'G3DSA:3.80.10.10:FF:001876', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(158583, NULL, 'G3DSA:1.10.357.10:FF:000071', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(158584, NULL, 'G3DSA:3.90.226.10:FF:000286', NULL, NULL, 'Enoyl-CoA-hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(158585, NULL, 'G3DSA:1.10.510.10:FF:000978', NULL, NULL, 'Protein kinase family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(158586, NULL, 'G3DSA:3.30.160.60:FF:004287', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158587, NULL, 'G3DSA:1.10.287.3700:FF:000010', NULL, NULL, 'PAB-dependent poly(A)-specific ribonuclease subunit PAN3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(158588, NULL, 'G3DSA:2.60.40.10:FF:003410', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158589, NULL, 'G3DSA:3.40.50.1980:FF:000153', NULL, NULL, 'Sll1202 protein', NULL, NULL, NULL, NULL, NULL, 4),
(158590, NULL, 'G3DSA:3.30.160.60:FF:003281', NULL, NULL, 'Kruppel like factor 9', NULL, NULL, NULL, NULL, NULL, 4),
(158591, NULL, 'G3DSA:3.30.560.10:FF:000008', NULL, NULL, 'NinaG, isoform B', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(158592, NULL, 'G3DSA:3.10.100.10:FF:000086', NULL, NULL, 'PKD1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(158593, NULL, 'G3DSA:3.30.430.20:FF:000064', NULL, NULL, 'Plasmodesmata-located protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(158594, NULL, 'G3DSA:2.60.40.10:FF:004692', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158595, NULL, 'G3DSA:2.30.42.10:FF:000009', NULL, NULL, 'Putative tight junction protein ZO-1', NULL, NULL, NULL, NULL, NULL, 4),
(158596, NULL, 'G3DSA:2.40.50.40:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158597, NULL, 'G3DSA:3.30.230.10:FF:000141', NULL, NULL, '30S ribosomal protein S9', NULL, NULL, NULL, NULL, NULL, 4),
(158598, NULL, 'G3DSA:3.40.190.10:FF:000365', NULL, NULL, 'Oligopeptide ABC transporter OppAIV', NULL, NULL, NULL, NULL, NULL, 4),
(158599, NULL, 'G3DSA:2.60.40.150:FF:000569', NULL, NULL, 'Multiple C2 and transmembrane domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(158600, NULL, 'G3DSA:2.60.40.10:FF:002516', NULL, NULL, 'Twitchin', NULL, NULL, NULL, NULL, NULL, 4),
(158601, NULL, 'G3DSA:2.60.40.10:FF:001201', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(158602, NULL, 'G3DSA:3.30.750.24:FF:000087', NULL, NULL, 'Anion exchange transporter', NULL, NULL, NULL, NULL, NULL, 4),
(158603, NULL, 'G3DSA:3.30.70.330:FF:001964', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158604, NULL, 'G3DSA:3.30.430.20:FF:000007', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 11', NULL, NULL, NULL, NULL, NULL, 4),
(158605, NULL, 'G3DSA:1.10.357.40:FF:000001', NULL, NULL, 'Swarming motility protein ybiA', NULL, NULL, NULL, NULL, NULL, 4),
(158606, NULL, 'G3DSA:3.90.230.10:FF:000066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158607, NULL, 'G3DSA:1.25.40.510:FF:000002', NULL, NULL, 'Protein GLE1', NULL, NULL, NULL, NULL, NULL, 4),
(158608, NULL, 'G3DSA:1.10.630.10:FF:000015', NULL, NULL, 'Cholesterol side-chain cleavage enzyme, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(158609, NULL, 'G3DSA:1.10.510.10:FF:003007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158610, NULL, 'G3DSA:3.90.930.12:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158611, NULL, 'G3DSA:3.30.160.60:FF:001414', NULL, NULL, 'telomere zinc finger-associated protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(158612, NULL, 'G3DSA:1.10.472.100:FF:000003', NULL, NULL, 'Presenilin', NULL, NULL, NULL, NULL, NULL, 4),
(158613, NULL, 'G3DSA:3.50.50.60:FF:000192', NULL, NULL, 'Dihydrolipoamide dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(158614, NULL, 'G3DSA:2.30.42.10:FF:000066', NULL, NULL, 'Rho GTPase activating protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(158615, NULL, 'G3DSA:3.40.720.10:FF:000002', NULL, NULL, 'Phosphopentomutase', NULL, NULL, NULL, NULL, NULL, 4),
(158616, NULL, 'G3DSA:3.90.550.50:FF:000197', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(158617, NULL, 'G3DSA:1.25.10.10:FF:002665', NULL, NULL, 'Protein MOR1', NULL, NULL, NULL, NULL, NULL, 4),
(158618, NULL, 'G3DSA:1.20.58.60:FF:000760', NULL, NULL, 'AT10293p', NULL, NULL, NULL, NULL, NULL, 4),
(158619, NULL, 'G3DSA:1.25.40.10:FF:004472', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158620, NULL, 'G3DSA:3.40.50.300:FF:004849', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(158621, NULL, 'G3DSA:3.30.1370.10:FF:000246', NULL, NULL, 'LD38872p', NULL, NULL, NULL, NULL, NULL, 4),
(158622, NULL, 'G3DSA:3.30.1370.120:FF:000022', NULL, NULL, 'Fimbrial assembly protein PilQ', NULL, NULL, NULL, NULL, NULL, 4),
(158623, NULL, 'G3DSA:3.90.1150.10:FF:000053', NULL, NULL, 'Cysteine desulfurase NifS', NULL, NULL, NULL, NULL, NULL, 4),
(158624, NULL, 'G3DSA:1.20.5.30:FF:000005', NULL, NULL, 'Matrilin 3b', NULL, NULL, NULL, NULL, NULL, 4),
(158625, NULL, 'G3DSA:3.30.70.270:FF:000232', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158626, NULL, 'G3DSA:1.25.40.10:FF:002263', NULL, NULL, 'Protein VAC14-like protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(158627, NULL, 'G3DSA:2.40.30.30:FF:000010', NULL, NULL, 'Riboflavin kinase / fad synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(158628, NULL, 'G3DSA:3.40.50.1760:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158629, NULL, 'G3DSA:3.30.70.600:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158630, NULL, 'G3DSA:3.30.160.60:FF:004848', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158631, NULL, 'G3DSA:3.30.40.10:FF:000391', NULL, NULL, 'E3 ubiquitin protein ligase RIE1', NULL, NULL, NULL, NULL, NULL, 4),
(158632, NULL, 'G3DSA:3.20.20.140:FF:000399', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158633, NULL, 'G3DSA:1.10.1420.10:FF:000077', NULL, NULL, 'DNA mismatch repair protein MSH2', NULL, NULL, NULL, NULL, NULL, 4),
(158634, NULL, 'G3DSA:2.10.25.10:FF:000139', NULL, NULL, 'Fibulin-1', NULL, NULL, NULL, NULL, NULL, 4),
(158635, NULL, 'G3DSA:1.25.40.530:FF:000008', NULL, NULL, 'unconventional myosin-XV', NULL, NULL, NULL, NULL, NULL, 4),
(158636, NULL, 'G3DSA:2.120.10.10:FF:000038', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(158637, NULL, 'G3DSA:2.40.70.10:FF:000260', NULL, NULL, 'ASpartyl Protease', NULL, NULL, NULL, NULL, NULL, 4),
(158638, NULL, 'G3DSA:3.40.50.150:FF:000662', NULL, NULL, '23S rRNA (Uracil-5-)-methyltransferase RumA', NULL, NULL, NULL, NULL, NULL, 4),
(158639, NULL, 'G3DSA:3.40.50.10330:FF:000021', NULL, NULL, 'NAD kinase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(158640, NULL, 'G3DSA:1.10.238.10:FF:001053', NULL, NULL, 'EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(158641, NULL, 'G3DSA:3.40.630.10:FF:000287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158642, NULL, 'G3DSA:1.10.600.10:FF:000070', NULL, NULL, 'Geranylgeranyl pyrophosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(158643, NULL, 'G3DSA:1.10.472.10:FF:000473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158644, NULL, 'G3DSA:2.10.25.10:FF:001275', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(158645, NULL, 'G3DSA:1.10.8.270:FF:000178', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(158646, NULL, 'G3DSA:3.40.50.300:FF:004675', NULL, NULL, 'Type II secretion system protein E', NULL, NULL, NULL, NULL, NULL, 4),
(158647, NULL, 'G3DSA:1.25.10.10:FF:003042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158648, NULL, 'G3DSA:1.10.4160.10:FF:000040', NULL, NULL, 'Uncharacterized permease C1683.05', NULL, NULL, NULL, NULL, NULL, 4),
(158649, NULL, 'G3DSA:3.40.1090.10:FF:000048', NULL, NULL, 'Patatin-like protein, PlpD', NULL, NULL, NULL, NULL, NULL, 4),
(158650, NULL, 'G3DSA:2.40.70.10:FF:000029', NULL, NULL, 'Aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(158651, NULL, 'G3DSA:1.25.10.10:FF:000928', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158652, NULL, 'G3DSA:2.40.10.10:FF:000604', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158653, NULL, 'G3DSA:2.70.98.10:FF:000114', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(158654, NULL, 'G3DSA:1.20.1070.10:FF:001891', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158655, NULL, 'G3DSA:3.40.50.300:FF:003107', NULL, NULL, 'RecBCD enzyme subunit RecC', NULL, NULL, NULL, NULL, NULL, 4),
(158656, NULL, 'G3DSA:3.30.160.60:FF:003224', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158657, NULL, 'G3DSA:3.30.160.60:FF:004798', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158658, NULL, 'G3DSA:4.10.400.10:FF:000296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158659, NULL, 'G3DSA:1.20.1740.10:FF:000110', NULL, NULL, 'Spore germination protein SB', NULL, NULL, NULL, NULL, NULL, 4),
(158660, NULL, 'G3DSA:3.30.160.60:FF:005422', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158661, NULL, 'G3DSA:1.10.150.60:FF:000021', NULL, NULL, 'Chromatin structure-remodeling complex subunit rsc9', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(158662, NULL, 'G3DSA:2.40.10.10:FF:000548', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158663, NULL, 'G3DSA:3.30.200.20:FF:000081', NULL, NULL, 'Octicosapeptide/phox/Bem1p domain kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(158664, NULL, 'G3DSA:3.40.50.1370:FF:000021', NULL, NULL, 'Aspartate carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(158665, NULL, 'G3DSA:3.30.160.60:FF:004854', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158666, NULL, 'G3DSA:3.40.50.300:FF:003045', NULL, NULL, 'GD10885', NULL, NULL, NULL, NULL, NULL, 4),
(158667, NULL, 'G3DSA:1.20.120.810:FF:000005', NULL, NULL, 'Protein CBR-DEB-1, isoform b', NULL, NULL, NULL, NULL, NULL, 4),
(158668, NULL, 'G3DSA:3.40.50.720:FF:002160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158669, NULL, 'G3DSA:2.60.40.10:FF:000987', NULL, NULL, 'Protogenin', NULL, NULL, NULL, NULL, NULL, 4),
(158670, NULL, 'G3DSA:3.30.559.70:FF:000034', NULL, NULL, 'Choline/Carnitine o-acyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(158671, NULL, 'G3DSA:2.60.40.820:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158672, NULL, 'G3DSA:3.30.420.40:FF:001013', NULL, NULL, 'Forkhead-associated (FHA) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(158673, NULL, 'G3DSA:1.20.1310.10:FF:000078', NULL, NULL, 'Cullin homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(158674, NULL, 'G3DSA:1.20.80.10:FF:000033', NULL, NULL, 'RIC1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(158675, NULL, 'G3DSA:3.30.1680.10:FF:000067', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(158676, NULL, 'G3DSA:3.30.1050.10:FF:000036', NULL, NULL, 'Alkyl/aryl-sulfatase BDS1', NULL, NULL, NULL, NULL, NULL, 4),
(158677, NULL, 'G3DSA:2.60.40.10:FF:004309', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158678, NULL, 'G3DSA:3.20.20.80:FF:000118', NULL, NULL, 'Probable bifunctional chitinase/lysozyme', NULL, NULL, NULL, NULL, NULL, 4),
(158679, NULL, 'G3DSA:3.30.160.60:FF:000583', NULL, NULL, 'Zinc finger protein 800 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(158680, NULL, 'G3DSA:2.40.50.90:FF:000001', NULL, NULL, 'Staphylococcal nuclease domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(158681, NULL, 'G3DSA:1.10.150.80:FF:000027', NULL, NULL, 'ATP-dependent helicase SGS1', NULL, NULL, NULL, NULL, NULL, 4),
(158682, NULL, 'G3DSA:4.10.400.10:FF:000189', NULL, NULL, 'low-density lipoprotein receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(158683, NULL, 'G3DSA:3.40.30.10:FF:001148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158684, NULL, 'G3DSA:3.30.70.330:FF:002397', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158685, NULL, 'G3DSA:1.10.30.10:FF:000188', NULL, NULL, 'Upstream-binding factor 1-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(158686, NULL, 'G3DSA:3.30.160.20:FF:000200', NULL, NULL, 'Blanks', NULL, NULL, NULL, NULL, NULL, 4),
(158687, NULL, 'G3DSA:3.30.540.10:FF:000075', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(158688, NULL, 'G3DSA:1.10.560.10:FF:000077', NULL, NULL, 'Chaperonin 60, putative', NULL, NULL, NULL, NULL, NULL, 4),
(158689, NULL, 'G3DSA:2.30.230.10:FF:000004', NULL, NULL, 'Vitellogenin-1', NULL, NULL, NULL, NULL, NULL, 4),
(158690, NULL, 'G3DSA:1.10.238.10:FF:001008', NULL, NULL, 'Mitochondrial substrate carrier family protein B', NULL, NULL, NULL, NULL, NULL, 4),
(158691, NULL, 'G3DSA:1.20.1050.10:FF:000254', NULL, NULL, 'Glutathione S-transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(158692, NULL, 'G3DSA:3.30.160.60:FF:001999', NULL, NULL, 'Zinc finger protein 195', NULL, NULL, NULL, NULL, NULL, 4),
(158693, NULL, 'G3DSA:3.50.50.60:FF:000372', NULL, NULL, 'Lysine-specific histone demethylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(158694, NULL, 'G3DSA:3.30.70.330:FF:002127', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158695, NULL, 'G3DSA:1.25.40.10:FF:004174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(158696, NULL, 'G3DSA:3.40.50.620:FF:000443', NULL, NULL, 'Protein kinase protein with adenine nucleotide alpha hydrolase-like domain', NULL, NULL, NULL, NULL, NULL, 4),
(158697, NULL, 'G3DSA:1.25.40.20:FF:000759', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158698, NULL, 'G3DSA:1.10.620.20:FF:000017', NULL, NULL, 'Ribonucleoside-diphosphate reductase small chain A', NULL, NULL, NULL, NULL, NULL, 4),
(158699, NULL, 'G3DSA:1.20.1050.10:FF:000310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158700, NULL, 'G3DSA:3.10.110.10:FF:000069', NULL, NULL, 'vacuolar protein sorting-associated protein 37A', NULL, NULL, NULL, NULL, NULL, 4),
(158701, NULL, 'G3DSA:1.20.5.390:FF:000009', NULL, NULL, 'Protein CBR-EEA-1', NULL, NULL, NULL, NULL, NULL, 4),
(158702, NULL, 'G3DSA:1.20.930.70:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158703, NULL, 'G3DSA:3.20.190.10:FF:000021', NULL, NULL, 'Glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(158704, NULL, 'G3DSA:1.20.5.370:FF:000003', NULL, NULL, 'Myosin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(158705, NULL, 'G3DSA:2.30.42.10:FF:000442', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158706, NULL, 'G3DSA:2.40.160.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158707, NULL, 'G3DSA:1.10.168.10:FF:000002', NULL, NULL, 'Phosducin, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(158708, NULL, 'G3DSA:2.30.250.10:FF:000011', NULL, NULL, 'Aspartyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(158709, NULL, 'G3DSA:1.25.40.180:FF:000307', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158710, NULL, 'G3DSA:2.60.200.10:FF:000029', NULL, NULL, 'Dwarfin sma', NULL, NULL, NULL, NULL, NULL, 4),
(158711, NULL, 'G3DSA:3.50.50.60:FF:000158', NULL, NULL, 'Rab GDP dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(158712, NULL, 'G3DSA:3.30.310.210:FF:000005', NULL, NULL, 'Flowering locus K homology domain', NULL, NULL, NULL, NULL, NULL, 4),
(158713, NULL, 'G3DSA:3.10.129.10:FF:000168', NULL, NULL, 'Hypothetical cytosolic protein', NULL, NULL, NULL, NULL, NULL, 4),
(158714, NULL, 'G3DSA:1.20.1250.20:FF:001992', NULL, NULL, 'Antibiotic resistance (Efflux) protein, conjectural', NULL, NULL, NULL, NULL, NULL, 4),
(158715, NULL, 'G3DSA:2.130.10.10:FF:002819', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158716, NULL, 'G3DSA:3.30.565.10:FF:000385', NULL, NULL, 'Integral membrane sensor signal transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(158717, NULL, 'G3DSA:1.10.238.10:FF:001160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158718, NULL, 'G3DSA:3.80.10.10:FF:001589', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158719, NULL, 'G3DSA:2.30.42.10:FF:000335', NULL, NULL, 'NHERF (Mammalian Na/H Exchange Regulatory Factor) Like', NULL, NULL, NULL, NULL, NULL, 4),
(158720, NULL, 'G3DSA:3.40.50.1220:FF:000004', NULL, NULL, 'Electron transfer flavoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(158721, NULL, 'G3DSA:4.10.1050.10:FF:000001', NULL, NULL, 'Zinc finger protein 706', NULL, NULL, NULL, NULL, NULL, 4),
(158722, NULL, 'G3DSA:3.40.1160.10:FF:000020', NULL, NULL, 'Glutamate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(158723, NULL, 'G3DSA:3.80.10.10:FF:002157', NULL, NULL, 'Jetlag, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(158724, NULL, 'G3DSA:2.170.270.10:FF:000171', NULL, NULL, 'Histone-lysine N-methyltransferase set-1', NULL, NULL, NULL, NULL, NULL, 4),
(158725, NULL, 'G3DSA:1.10.10.60:FF:000735', NULL, NULL, 'Putative transcription factor gt-2', NULL, NULL, NULL, NULL, NULL, 4),
(158726, NULL, 'G3DSA:3.30.70.2610:FF:000002', NULL, NULL, 'RNA polymerase II transcription factor B subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(158727, NULL, 'G3DSA:2.40.50.140:FF:000319', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(158728, NULL, 'G3DSA:3.40.50.1820:FF:000178', NULL, NULL, 'Carboxymethylenebutenolidase homolog', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(158729, NULL, 'G3DSA:2.60.40.10:FF:003056', NULL, NULL, 'Leptin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(158730, NULL, 'G3DSA:1.20.140.150:FF:000098', NULL, NULL, 'Voltage-dependent calcium channel, putative', NULL, NULL, NULL, NULL, NULL, 4),
(158731, NULL, 'G3DSA:1.10.287.1490:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158732, NULL, 'G3DSA:1.10.10.60:FF:000628', NULL, NULL, 'Myb-like DNA-binding domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(158733, NULL, 'G3DSA:2.130.10.10:FF:000639', NULL, NULL, 'Leucine-rich repeat and WD repeat-containing protein KIAA1239', NULL, NULL, NULL, NULL, NULL, 4),
(158734, NULL, 'G3DSA:3.30.40.10:FF:001003', NULL, NULL, 'Zinc finger domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(158735, NULL, 'G3DSA:3.30.40.10:FF:001970', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158736, NULL, 'G3DSA:1.20.120.1240:FF:000034', NULL, NULL, 'Dynamin 1 like', NULL, NULL, NULL, NULL, NULL, 4),
(158737, NULL, 'G3DSA:1.10.287.70:FF:000341', NULL, NULL, 'Protein CBR-TWK-30', NULL, NULL, NULL, NULL, NULL, 4),
(158738, NULL, 'G3DSA:2.60.120.200:FF:000065', NULL, NULL, 'Laminin subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(158739, NULL, 'G3DSA:2.40.20.10:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158740, NULL, 'G3DSA:1.20.58.60:FF:000193', NULL, NULL, 'Spectrin repeat containing, nuclear envelope 1a', NULL, NULL, NULL, NULL, NULL, 4),
(158741, NULL, 'G3DSA:2.70.9.30:FF:000001', NULL, NULL, 'Major capsid protein P3', NULL, NULL, NULL, NULL, NULL, 4),
(158742, NULL, 'G3DSA:3.30.200.20:FF:002098', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(158743, NULL, 'G3DSA:1.10.472.100:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158744, NULL, 'G3DSA:3.40.50.720:FF:001485', NULL, NULL, 'SUMO1 activating enzyme subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(158745, NULL, 'G3DSA:2.130.10.10:FF:000746', NULL, NULL, 'THO Complex (Transcription factor/nuclear export) subunit', NULL, NULL, NULL, NULL, NULL, 4),
(158746, NULL, 'G3DSA:1.20.1070.10:FF:001598', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158747, NULL, 'G3DSA:3.30.160.60:FF:000690', NULL, NULL, 'Zinc finger protein 354C', NULL, NULL, NULL, NULL, NULL, 4),
(158748, NULL, 'G3DSA:3.30.70.330:FF:002346', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158749, NULL, 'G3DSA:3.30.70.20:FF:000047', NULL, NULL, 'Formate dehydrogenase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(158750, NULL, 'G3DSA:3.30.360.10:FF:000089', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(158751, NULL, 'G3DSA:2.20.70.10:FF:000193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158752, NULL, 'G3DSA:1.20.1300.20:FF:000001', NULL, NULL, 'Ubiquitin thioesterase OTUB1', NULL, NULL, NULL, NULL, NULL, 4),
(158753, NULL, 'G3DSA:3.55.50.30:FF:000032', NULL, NULL, 'SusC/RagA family TonB-linked outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(158754, NULL, 'G3DSA:3.10.100.10:FF:000355', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158755, NULL, 'G3DSA:3.30.420.10:FF:000240', NULL, NULL, 'YALI0F25729p', NULL, NULL, NULL, NULL, NULL, 4),
(158756, NULL, 'G3DSA:3.30.390.30:FF:000012', NULL, NULL, 'Putative dihydrolipoamide dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(158757, NULL, 'G3DSA:2.130.10.10:FF:005170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158758, NULL, 'G3DSA:1.10.10.60:FF:000954', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158759, NULL, 'G3DSA:1.20.5.170:FF:000005', NULL, NULL, 'Tropomyosin alpha-1 chain', NULL, NULL, NULL, NULL, NULL, 4),
(158760, NULL, 'G3DSA:1.10.246.90:FF:000022', NULL, NULL, 'NOP56 ribonucleoprotein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(158761, NULL, 'G3DSA:3.40.50.1000:FF:000848', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158762, NULL, 'G3DSA:1.20.1050.90:FF:000002', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(158763, NULL, 'G3DSA:1.25.10.10:FF:002278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158764, NULL, 'G3DSA:2.40.50.770:FF:000003', NULL, NULL, 'tudor domain-containing protein 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(158765, NULL, 'G3DSA:1.10.287.130:FF:000207', NULL, NULL, 'GAF sensor signal transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(158766, NULL, 'G3DSA:1.10.287.10:FF:000014', NULL, NULL, 'Methionyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(158767, NULL, 'G3DSA:3.40.50.720:FF:000703', NULL, NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(158768, NULL, 'G3DSA:1.10.340.30:FF:000038', NULL, NULL, 'DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(158769, NULL, 'G3DSA:1.20.1080.10:FF:000082', NULL, NULL, 'Formate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(158770, NULL, 'G3DSA:3.40.50.720:FF:000922', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158771, NULL, 'G3DSA:3.40.190.10:FF:000039', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(158772, NULL, 'G3DSA:3.30.390.50:FF:000018', NULL, NULL, 'AGAP012186-PA', NULL, NULL, NULL, NULL, NULL, 4),
(158773, NULL, 'G3DSA:1.20.120.1080:FF:000020', NULL, NULL, 'ATP dependent RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(158774, NULL, 'G3DSA:1.25.40.10:FF:000582', NULL, NULL, 'E3 SUMO-protein ligase RanBP2', NULL, NULL, NULL, NULL, NULL, 4),
(158775, NULL, 'G3DSA:3.40.50.1820:FF:000234', NULL, NULL, 'GG17261', NULL, NULL, NULL, NULL, NULL, 4),
(158776, NULL, 'G3DSA:3.40.50.300:FF:005350', NULL, NULL, 'ABC transporter ATP-binding protein uup-1', NULL, NULL, NULL, NULL, NULL, 4),
(158777, NULL, 'G3DSA:1.25.10.10:FF:000187', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(158778, NULL, 'G3DSA:3.40.50.720:FF:000243', NULL, NULL, 'Ubiquitin-like modifier-activating enzyme ATG7', NULL, NULL, NULL, NULL, NULL, 4),
(158779, NULL, 'G3DSA:1.20.1070.10:FF:000249', NULL, NULL, 'Adhesion G protein-coupled receptor G5', NULL, NULL, NULL, NULL, NULL, 4),
(158780, NULL, 'G3DSA:1.20.58.850:FF:000001', NULL, NULL, 'Chromosome partition protein MukB', NULL, NULL, NULL, NULL, NULL, 4),
(158781, NULL, 'G3DSA:1.20.1250.20:FF:000238', NULL, NULL, 'Major facilitator superfamily domain containing 2B', NULL, NULL, NULL, NULL, NULL, 4),
(158782, NULL, 'G3DSA:1.20.1250.20:FF:001929', NULL, NULL, 'Transporter', NULL, NULL, NULL, NULL, NULL, 4),
(158783, NULL, 'G3DSA:2.60.120.290:FF:000221', NULL, NULL, 'Subtilisin-like serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(158784, NULL, 'G3DSA:2.60.40.1510:FF:000019', NULL, NULL, 'Integrin subunit alpha 4', NULL, NULL, NULL, NULL, NULL, 4),
(158785, NULL, 'G3DSA:1.20.1070.10:FF:001828', NULL, NULL, 'Vasopressin v1a recpetor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(158786, NULL, 'G3DSA:3.30.200.20:FF:000822', NULL, NULL, 'cAMP-dependent protein kinase catalytic subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(158787, NULL, 'G3DSA:2.30.170.20:FF:000013', NULL, NULL, '50S ribosomal protein L24e', NULL, NULL, NULL, NULL, NULL, 4),
(158788, NULL, 'G3DSA:3.40.1380.20:FF:000011', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(158789, NULL, 'G3DSA:3.60.40.10:FF:000350', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(158790, NULL, 'G3DSA:3.10.310.10:FF:000017', NULL, NULL, 'Diaminopimelate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(158791, NULL, 'G3DSA:1.10.10.10:FF:001024', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(158792, NULL, 'G3DSA:2.30.30.40:FF:000497', NULL, NULL, 'SH3 and multiple ankyrin repeat domains 2', NULL, NULL, NULL, NULL, NULL, 4),
(158793, NULL, 'G3DSA:2.40.50.140:FF:001101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158794, NULL, 'G3DSA:3.60.90.10:FF:000010', NULL, NULL, 'S-adenosylmethionine decarboxylase-ornithine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(158795, NULL, 'G3DSA:1.20.1280.130:FF:000001', NULL, NULL, 'Vacuolar protein sorting-associated protein 54', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(158796, NULL, 'G3DSA:2.60.40.60:FF:001137', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(158797, NULL, 'G3DSA:3.30.70.60:FF:000031', NULL, NULL, 'Mitochondrial ribosomal protein S6', NULL, NULL, NULL, NULL, NULL, 4),
(158798, NULL, 'G3DSA:3.30.200.20:FF:000934', NULL, NULL, 'Kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(158799, NULL, 'G3DSA:3.30.70.270:FF:000119', NULL, NULL, 'GGDEF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(158800, NULL, 'G3DSA:3.80.10.10:FF:003736', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158801, NULL, 'G3DSA:3.30.160.60:FF:003331', NULL, NULL, 'paternally-expressed gene 3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(158802, NULL, 'G3DSA:1.50.10.130:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158803, NULL, 'G3DSA:3.40.50.10810:FF:000244', NULL, NULL, 'SNF2 family N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(158804, NULL, 'G3DSA:3.50.50.60:FF:000484', NULL, NULL, 'Glutathione reductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(158805, NULL, 'G3DSA:3.20.20.450:FF:000025', NULL, NULL, 'PAS-containing EAL phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(158806, NULL, 'G3DSA:2.130.10.10:FF:000965', NULL, NULL, 'Autophagy-like protein 18 Atg18', NULL, NULL, NULL, NULL, NULL, 4),
(158807, NULL, 'G3DSA:3.30.420.40:FF:000631', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(158808, NULL, 'G3DSA:3.40.50.20:FF:000023', NULL, NULL, 'ATP-grasp domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(158809, NULL, 'G3DSA:3.30.70.1450:FF:000019', NULL, NULL, 'Putative Na+/sulfate symporter', NULL, NULL, NULL, NULL, NULL, 4),
(158810, NULL, 'G3DSA:3.30.70.1430:FF:000013', NULL, NULL, 'Transporter, AcrB/D/F family', NULL, NULL, NULL, NULL, NULL, 4),
(158811, NULL, 'G3DSA:3.40.50.2300:FF:000463', NULL, NULL, 'ANTAR domain-containing response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(158812, NULL, 'G3DSA:3.30.470.30:FF:000013', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(158813, NULL, 'G3DSA:1.25.40.20:FF:000815', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158814, NULL, 'G3DSA:3.40.50.360:FF:000090', NULL, NULL, 'NADPH oxidoreductase A', NULL, NULL, NULL, NULL, NULL, 4),
(158815, NULL, 'G3DSA:1.20.58.110:FF:000009', NULL, NULL, '30S ribosomal protein S20 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(158816, NULL, 'G3DSA:3.40.50.970:FF:000020', NULL, NULL, 'Pyruvate dehydrogenase E1 component subunit alpha, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(158817, NULL, 'G3DSA:3.30.70.260:FF:000116', NULL, NULL, 'GTP pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(158818, NULL, 'G3DSA:3.10.129.110:FF:000021', NULL, NULL, 'Non-ribosomal peptide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(158819, NULL, 'G3DSA:3.40.630.90:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158820, NULL, 'G3DSA:3.10.129.10:FF:000112', NULL, NULL, 'YALI0A19096p', NULL, NULL, NULL, NULL, NULL, 4),
(158821, NULL, 'G3DSA:1.25.40.420:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158822, NULL, 'G3DSA:3.30.40.10:FF:001695', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM71', NULL, NULL, NULL, NULL, NULL, 4),
(158823, NULL, 'G3DSA:3.30.70.1440:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158824, NULL, 'G3DSA:3.40.30.10:FF:000873', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158825, NULL, 'G3DSA:1.20.58.100:FF:000006', NULL, NULL, 'L-aspartate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(158826, NULL, 'G3DSA:3.40.47.10:FF:000164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158827, NULL, 'G3DSA:3.30.1700.10:FF:000002', NULL, NULL, 'Probable UDP-3-O-acyl-N-acetylglucosamine deacetylase 3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(158828, NULL, 'G3DSA:3.40.50.300:FF:006766', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158829, NULL, 'G3DSA:2.30.42.10:FF:000386', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(158830, NULL, 'G3DSA:1.25.40.10:FF:002903', NULL, NULL, 'U3 small nucleolar RNA-associated protein 6 like', NULL, NULL, NULL, NULL, NULL, 4),
(158831, NULL, 'G3DSA:2.60.40.150:FF:000619', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(158832, NULL, 'G3DSA:3.40.50.1220:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158833, NULL, 'G3DSA:1.20.1060.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158834, NULL, 'G3DSA:2.60.40.60:FF:000648', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158835, NULL, 'G3DSA:1.25.40.20:FF:001304', NULL, NULL, 'GA-binding protein subunit beta-1-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(158836, NULL, 'G3DSA:1.20.5.320:FF:000016', NULL, NULL, 'Collagen type XXVI alpha 1 chain', NULL, NULL, NULL, NULL, NULL, 4),
(158837, NULL, 'G3DSA:3.60.10.10:FF:000415', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158838, NULL, 'G3DSA:3.30.160.60:FF:001151', NULL, NULL, 'zinc finger homeobox protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(158839, NULL, 'G3DSA:3.40.190.290:FF:000104', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(158840, NULL, 'G3DSA:3.30.428.10:FF:000033', NULL, NULL, 'Hnt2p', NULL, NULL, NULL, NULL, NULL, 4),
(158841, NULL, 'G3DSA:3.30.565.10:FF:000334', NULL, NULL, 'Two-component sensor kinase czcS', NULL, NULL, NULL, NULL, NULL, 4),
(158842, NULL, 'G3DSA:3.10.180.10:FF:000017', NULL, NULL, 'Methylmalonyl-CoA epimerase /ethylmalonyl-CoA epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(158843, NULL, 'G3DSA:3.40.50.2000:FF:000524', NULL, NULL, '3-deoxy-D-manno-octulosonic acid transferase', NULL, NULL, NULL, NULL, NULL, 4),
(158844, NULL, 'G3DSA:3.30.1520.10:FF:000174', NULL, NULL, 'GTPase-activating protein BEM3', NULL, NULL, NULL, NULL, NULL, 4),
(158845, NULL, 'G3DSA:1.25.40.10:FF:001301', NULL, NULL, 'Os11g0433100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(158846, NULL, 'G3DSA:1.20.1060.20:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158847, NULL, 'G3DSA:2.30.42.10:FF:000116', NULL, NULL, 'Phosphatidylinositol-3,4,5-trisphosphate dependent Rac exchange factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(158848, NULL, 'G3DSA:2.30.29.30:FF:000316', NULL, NULL, 'Arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(158849, NULL, 'G3DSA:3.30.160.60:FF:004528', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158850, NULL, 'G3DSA:3.30.470.20:FF:000010', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(158851, NULL, 'G3DSA:1.25.40.10:FF:000812', NULL, NULL, 'Putative pentatricopeptide repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(158852, NULL, 'G3DSA:3.10.50.10:FF:000049', NULL, NULL, 'CHiTinase', NULL, NULL, NULL, NULL, NULL, 4),
(158853, NULL, 'G3DSA:2.60.40.10:FF:005192', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158854, NULL, 'G3DSA:1.25.10.10:FF:000698', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(158855, NULL, 'G3DSA:2.30.29.30:FF:000193', NULL, NULL, 'arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(158856, NULL, 'G3DSA:1.10.1380.10:FF:000011', NULL, NULL, 'GM12465', NULL, NULL, NULL, NULL, NULL, 4),
(158857, NULL, 'G3DSA:1.25.10.10:FF:001030', NULL, NULL, 'Proteasome activator complex subunit 4 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(158858, NULL, 'G3DSA:3.30.420.40:FF:000524', NULL, NULL, 'Actin related protein 3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(158859, NULL, 'G3DSA:3.40.1110.10:FF:000489', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158860, NULL, 'G3DSA:3.30.200.60:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158861, NULL, 'G3DSA:1.10.420.10:FF:000033', NULL, NULL, 'L-ascorbate peroxidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(158862, NULL, 'G3DSA:3.50.50.60:FF:000433', NULL, NULL, 'NAD(P)/FAD-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(158863, NULL, 'G3DSA:1.10.10.60:FF:001117', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158864, NULL, 'G3DSA:3.40.50.410:FF:000150', NULL, NULL, 'Protein BONZAI 2', NULL, NULL, NULL, NULL, NULL, 4),
(158865, NULL, 'G3DSA:1.20.930.20:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158866, NULL, 'G3DSA:3.30.200.40:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158867, NULL, 'G3DSA:1.10.510.10:FF:001153', NULL, NULL, 'Putative serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(158868, NULL, 'G3DSA:3.30.160.60:FF:002488', NULL, NULL, 'Zinc finger protein 709', NULL, NULL, NULL, NULL, NULL, 4),
(158869, NULL, 'G3DSA:3.60.40.10:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158870, NULL, 'G3DSA:2.30.38.10:FF:000011', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(158871, NULL, 'G3DSA:1.10.1450.10:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158872, NULL, 'G3DSA:2.10.25.10:FF:001449', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158873, NULL, 'G3DSA:3.30.200.20:FF:002391', NULL, NULL, 'Protein CBG12765', NULL, NULL, NULL, NULL, NULL, 4),
(158874, NULL, 'G3DSA:1.10.10.10:FF:001350', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(158875, NULL, 'G3DSA:1.10.287.3700:FF:000009', NULL, NULL, 'PAB-dependent poly(A)-specific ribonuclease subunit pan3-like', NULL, NULL, NULL, NULL, NULL, 4),
(158876, NULL, 'G3DSA:3.30.50.10:FF:000009', NULL, NULL, 'nuclear receptor subfamily 4 group A member 2', NULL, NULL, NULL, NULL, NULL, 4),
(158877, NULL, 'G3DSA:3.30.70.330:FF:000828', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit G', NULL, NULL, NULL, NULL, NULL, 4),
(158878, NULL, 'G3DSA:1.10.1450.10:FF:000079', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(158879, NULL, 'G3DSA:1.20.930.10:FF:000013', NULL, NULL, 'Transcription factor IWS1', NULL, NULL, NULL, NULL, NULL, 4),
(158880, NULL, 'G3DSA:3.30.497.10:FF:000046', NULL, NULL, 'RE27547p', NULL, NULL, NULL, NULL, NULL, 4),
(158881, NULL, 'G3DSA:1.25.10.10:FF:000754', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(158882, NULL, 'G3DSA:3.30.40.10:FF:000216', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM41 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(158883, NULL, 'G3DSA:1.10.418.10:FF:000089', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(158884, NULL, 'G3DSA:2.120.10.30:FF:000078', NULL, NULL, 'low-density lipoprotein receptor-related protein 6 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(158885, NULL, 'G3DSA:1.10.10.10:FF:002098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158886, NULL, 'G3DSA:3.30.160.60:FF:001307', NULL, NULL, 'zinc finger protein 140 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(158887, NULL, 'G3DSA:3.30.980.10:FF:000040', NULL, NULL, 'Threonine--tRNA ligase mitochondrial 1', NULL, NULL, NULL, NULL, NULL, 4),
(158888, NULL, 'G3DSA:3.90.1150.10:FF:000390', NULL, NULL, 'Ornithine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(158889, NULL, 'G3DSA:3.30.200.160:FF:000010', NULL, NULL, 'Uncharacterized protein B18D24.130', NULL, NULL, NULL, NULL, NULL, 4),
(158890, NULL, 'G3DSA:1.20.58.60:FF:000423', NULL, NULL, 'periplakin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(158891, NULL, 'G3DSA:1.10.287.1970:FF:000007', NULL, NULL, 'Alanine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(158892, NULL, 'G3DSA:1.25.40.10:FF:004179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158893, NULL, 'G3DSA:3.40.50.2000:FF:000249', NULL, NULL, 'Trehalose phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(158894, NULL, 'G3DSA:2.30.30.100:FF:000216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158895, NULL, 'G3DSA:2.60.40.10:FF:001151', NULL, NULL, 'Uncharacterized protein, isoform F', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(158896, NULL, 'G3DSA:3.30.70.270:FF:000114', NULL, NULL, 'Sensory box/GGDEF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(158897, NULL, 'G3DSA:3.40.140.10:FF:000109', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(158898, NULL, 'G3DSA:2.60.220.50:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158899, NULL, 'G3DSA:2.130.10.10:FF:003601', NULL, NULL, 'Elongator acetyltransferase complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(158900, NULL, 'G3DSA:3.30.160.60:FF:000695', NULL, NULL, 'Spalt-like transcription factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(158901, NULL, 'G3DSA:3.40.50.150:FF:001561', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158902, NULL, 'G3DSA:3.30.70.260:FF:000111', NULL, NULL, 'GTP pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(158903, NULL, 'G3DSA:3.40.50.300:FF:001128', NULL, NULL, 'ATP-binding cassette sub-family C member 12', NULL, NULL, NULL, NULL, NULL, 4),
(158904, NULL, 'G3DSA:2.60.120.650:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158905, NULL, 'G3DSA:3.60.110.10:FF:000041', NULL, NULL, 'Bifunctional apolipoprotein N-acyltransferase/polyprenol monophosphomannose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(158906, NULL, 'G3DSA:2.30.29.30:FF:001098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158907, NULL, 'G3DSA:1.25.40.10:FF:001886', NULL, NULL, 'Tetratricopeptide repeat protein 7B', NULL, NULL, NULL, NULL, NULL, 4),
(158908, NULL, 'G3DSA:3.80.20.20:FF:000076', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(158909, NULL, 'G3DSA:2.30.29.30:FF:000428', NULL, NULL, 'GEM-like protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(158910, NULL, 'G3DSA:3.40.1110.10:FF:000202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158911, NULL, 'G3DSA:1.10.60.30:FF:000004', NULL, NULL, 'UPF0307 protein NCTC10783_04020', NULL, NULL, NULL, NULL, NULL, 4),
(158912, NULL, 'G3DSA:2.130.10.10:FF:004495', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158913, NULL, 'G3DSA:1.20.1420.30:FF:000007', NULL, NULL, 'Vacuolar calcium ion transporter', NULL, NULL, NULL, NULL, NULL, 4),
(158914, NULL, 'G3DSA:3.30.40.10:FF:000621', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(158915, NULL, 'G3DSA:1.10.950.10:FF:000005', NULL, NULL, 'Villin-1', NULL, NULL, NULL, NULL, NULL, 4),
(158916, NULL, 'G3DSA:2.80.10.50:FF:000249', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(158917, NULL, 'G3DSA:1.10.510.10:FF:003002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158918, NULL, 'G3DSA:3.40.50.300:FF:005024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158919, NULL, 'G3DSA:1.20.1250.20:FF:002155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158920, NULL, 'G3DSA:3.40.50.720:FF:000181', NULL, NULL, 'NmrA-like family domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(158921, NULL, 'G3DSA:3.40.30.10:FF:001143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158922, NULL, 'G3DSA:1.10.60.20:FF:000001', NULL, NULL, '40S ribosomal protein S17', NULL, NULL, NULL, NULL, NULL, 4),
(158923, NULL, 'G3DSA:3.30.160.60:FF:003163', NULL, NULL, 'Zinc finger protein OZF', NULL, NULL, NULL, NULL, NULL, 4),
(158924, NULL, 'G3DSA:3.90.180.10:FF:000016', NULL, NULL, 'Quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(158925, NULL, 'G3DSA:2.60.40.10:FF:005422', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158926, NULL, 'G3DSA:3.40.390.10:FF:000313', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158927, NULL, 'G3DSA:2.130.10.10:FF:004787', NULL, NULL, 'WD40-repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(158928, NULL, 'G3DSA:3.60.15.10:FF:000281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158929, NULL, 'G3DSA:3.40.50.1170:FF:000005', NULL, NULL, 'Probable L-asparaginase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(158930, NULL, 'G3DSA:3.40.50.300:FF:004894', NULL, NULL, 'Caspase recruitment domain family, member 11', NULL, NULL, NULL, NULL, NULL, 4),
(158931, NULL, 'G3DSA:3.40.50.300:FF:002770', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(158932, NULL, 'G3DSA:2.130.10.10:FF:001128', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(158933, NULL, 'G3DSA:2.60.120.920:FF:000011', NULL, NULL, 'RAN binding protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(158934, NULL, 'G3DSA:3.80.10.10:FF:003624', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(158935, NULL, 'G3DSA:3.40.800.10:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158936, NULL, 'G3DSA:1.20.1560.10:FF:000124', NULL, NULL, 'Putative ABC transporter transmembrane subunit', NULL, NULL, NULL, NULL, NULL, 4),
(158937, NULL, 'G3DSA:1.10.287.470:FF:000051', NULL, NULL, 'RND efflux membrane fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(158938, NULL, 'G3DSA:2.40.50.40:FF:000014', NULL, NULL, 'Chromodomain-helicase-DNA-binding protein 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(158939, NULL, 'G3DSA:3.30.1740.20:FF:000002', NULL, NULL, '40S ribosomal protein S26', NULL, NULL, NULL, NULL, NULL, 4),
(158940, NULL, 'G3DSA:3.40.50.720:FF:000029', NULL, NULL, 'L-lactate dehydrogenase A chain', NULL, NULL, NULL, NULL, NULL, 4),
(158941, NULL, 'G3DSA:1.20.1050.10:FF:000080', NULL, NULL, 'YGR201C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(158942, NULL, 'G3DSA:2.130.10.10:FF:002371', NULL, NULL, 'Transducin', NULL, NULL, NULL, NULL, NULL, 4),
(158943, NULL, 'G3DSA:1.10.510.10:FF:000478', NULL, NULL, 'Cell cycle protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(158944, NULL, 'G3DSA:2.60.490.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158945, NULL, 'G3DSA:3.40.640.10:FF:000294', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158946, NULL, 'G3DSA:3.40.50.1820:FF:000420', NULL, NULL, 'Alpha/beta fold hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(158947, NULL, 'G3DSA:3.30.1680.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158948, NULL, 'G3DSA:3.40.50.720:FF:001659', NULL, NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase NAD-binding', NULL, NULL, NULL, NULL, NULL, 4),
(158949, NULL, 'G3DSA:3.30.450.20:FF:000008', NULL, NULL, 'Nuclear receptor coactivator', NULL, NULL, NULL, NULL, NULL, 4),
(158950, NULL, 'G3DSA:2.60.40.10:FF:004079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158951, NULL, 'G3DSA:1.10.10.60:FF:000561', NULL, NULL, 'Transcription factor MYB75', NULL, NULL, NULL, NULL, NULL, 4),
(158952, NULL, 'G3DSA:6.20.10.30:FF:000006', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(158953, NULL, 'G3DSA:3.30.160.60:FF:005641', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158954, NULL, 'G3DSA:1.10.510.10:FF:002783', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158955, NULL, 'G3DSA:3.90.1100.10:FF:000016', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(158956, NULL, 'G3DSA:2.130.10.10:FF:000572', NULL, NULL, 'VPS10 domain-containing receptor SorCS2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(158957, NULL, 'G3DSA:1.25.10.10:FF:002553', NULL, NULL, 'UTP20, small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4),
(158958, NULL, 'G3DSA:3.40.720.10:FF:000114', NULL, NULL, 'Putative integral membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(158959, NULL, 'G3DSA:2.60.40.150:FF:000507', NULL, NULL, 'Synaptotagmin', NULL, NULL, NULL, NULL, NULL, 4),
(158960, NULL, 'G3DSA:3.40.50.150:FF:001117', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158961, NULL, 'G3DSA:1.20.1720.10:FF:000108', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158962, NULL, 'G3DSA:3.30.420.40:FF:000850', NULL, NULL, 'ROK family protein', NULL, NULL, NULL, NULL, NULL, 4),
(158963, NULL, 'G3DSA:1.20.1250.20:FF:002211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(158964, NULL, 'G3DSA:1.20.144.10:FF:000057', NULL, NULL, 'Lipid phosphate phosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(158965, NULL, 'G3DSA:2.60.40.10:FF:000476', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(158966, NULL, 'G3DSA:1.50.40.10:FF:000220', NULL, NULL, 'Chromosome 12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(158967, NULL, 'G3DSA:2.30.42.10:FF:000509', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158968, NULL, 'G3DSA:3.90.1150.10:FF:000019', NULL, NULL, '4-aminobutyrate aminotransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(158969, NULL, 'G3DSA:3.40.366.10:FF:000032', NULL, NULL, 'Malonyl CoA-acyl carrier protein transacylase', NULL, NULL, NULL, NULL, NULL, 4),
(158970, NULL, 'G3DSA:3.30.70.330:FF:002341', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158971, NULL, 'G3DSA:2.130.10.10:FF:004388', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158972, NULL, 'G3DSA:1.20.1510.10:FF:000059', NULL, NULL, 'Cation efflux family protein', NULL, NULL, NULL, NULL, NULL, 4),
(158973, NULL, 'G3DSA:1.20.1070.10:FF:002166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158974, NULL, 'G3DSA:1.20.1560.10:FF:000343', NULL, NULL, 'Lethal (2) 03659, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(158975, NULL, 'G3DSA:3.30.50.10:FF:000161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158976, NULL, 'G3DSA:3.30.70.2610:FF:000007', NULL, NULL, 'General transcription factor IIH subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(158977, NULL, 'G3DSA:2.40.110.10:FF:000027', NULL, NULL, 'Isovaleryl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(158978, NULL, 'G3DSA:1.10.472.90:FF:000002', NULL, NULL, 'Pyruvate carboxylase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(158979, NULL, 'G3DSA:3.10.100.10:FF:000243', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158980, NULL, 'G3DSA:3.30.230.10:FF:000080', NULL, NULL, 'Diphosphomevalonate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(158981, NULL, 'G3DSA:2.50.20.10:FF:000003', NULL, NULL, 'Sigma-E factor regulatory protein RseB', NULL, NULL, NULL, NULL, NULL, 4),
(158982, NULL, 'G3DSA:2.150.10.10:FF:000003', NULL, NULL, 'Bifunctional hemolysin/adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(158983, NULL, 'G3DSA:3.40.50.300:FF:003601', NULL, NULL, 'Uridine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(158984, NULL, 'G3DSA:3.30.40.10:FF:001110', NULL, NULL, 'E3 ubiquitin-protein ligase ORTHRUS 3', NULL, NULL, NULL, NULL, NULL, 4),
(158985, NULL, 'G3DSA:3.30.1360.120:FF:000099', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(158986, NULL, 'G3DSA:3.90.1150.10:FF:000238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158987, NULL, 'G3DSA:3.20.20.100:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158988, NULL, 'G3DSA:1.10.10.10:FF:000804', NULL, NULL, 'Transcriptional regulator, RpiR family', NULL, NULL, NULL, NULL, NULL, 4),
(158989, NULL, 'G3DSA:2.10.10.20:FF:000007', NULL, NULL, 'Chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(158990, NULL, 'G3DSA:1.25.40.10:FF:002381', NULL, NULL, 'Subunit of the RNA polymerase III transcription initiation factor complex (TFIIIC), putative', NULL, NULL, NULL, NULL, NULL, 4),
(158991, NULL, 'G3DSA:2.10.10.10:FF:000004', NULL, NULL, 'lymphocyte antigen 75 precursor', NULL, NULL, NULL, NULL, NULL, 4),
(158992, NULL, 'G3DSA:3.40.850.10:FF:000118', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(158993, NULL, 'G3DSA:3.30.160.60:FF:006378', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(158994, NULL, 'G3DSA:3.40.50.300:FF:004349', NULL, NULL, 'Lipoprotein-releasing system ATP-binding protein LolD', NULL, NULL, NULL, NULL, NULL, 4),
(158995, NULL, 'G3DSA:4.10.830.10:FF:000002', NULL, NULL, '40S ribosomal protein S29', NULL, NULL, NULL, NULL, NULL, 4),
(158996, NULL, 'G3DSA:1.25.40.720:FF:000003', NULL, NULL, 'Telomere length regulation protein TEL2 homolog', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(158997, NULL, 'G3DSA:2.60.120.260:FF:000622', NULL, NULL, 'Putative secreted beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(158998, NULL, 'G3DSA:3.90.550.10:FF:000674', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(158999, NULL, 'G3DSA:1.25.40.10:FF:004915', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g62260, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(159000, NULL, 'G3DSA:1.20.58.60:FF:000642', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159001, NULL, 'G3DSA:1.20.920.20:FF:000010', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(159002, NULL, 'G3DSA:2.60.40.10:FF:000768', NULL, NULL, 'Neural cell adhesion molecule L1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(159003, NULL, 'G3DSA:3.40.50.670:FF:000025', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(159004, NULL, 'G3DSA:1.10.10.60:FF:000780', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159005, NULL, 'G3DSA:3.30.160.60:FF:006327', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159006, NULL, 'G3DSA:3.30.200.20:FF:002328', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159007, NULL, 'G3DSA:3.30.2350.20:FF:000080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159008, NULL, 'G3DSA:1.10.472.10:FF:000147', NULL, NULL, 'PCL8p Cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(159009, NULL, 'G3DSA:2.40.10.350:FF:000009', NULL, NULL, 'Cell shape-determining protein MreC', NULL, NULL, NULL, NULL, NULL, 4),
(159010, NULL, 'G3DSA:1.25.40.730:FF:000006', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(159011, NULL, 'G3DSA:2.70.150.10:FF:000096', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(159012, NULL, 'G3DSA:2.30.18.10:FF:000009', NULL, NULL, 'Transcription initiation factor IIA subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(159013, NULL, 'G3DSA:3.40.50.10090:FF:000016', NULL, NULL, 'Uroporphyrinogen-III synthase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(159014, NULL, 'G3DSA:1.20.920.30:FF:000013', NULL, NULL, 'Dynein heavy chain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(159015, NULL, 'G3DSA:3.40.1490.10:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(159016, NULL, 'G3DSA:3.30.230.70:FF:000018', NULL, NULL, 'Exosome complex exonuclease RRP43', NULL, NULL, NULL, NULL, NULL, 4),
(159017, NULL, 'G3DSA:1.20.58.1030:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159018, NULL, 'G3DSA:3.30.70.1350:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159019, NULL, 'G3DSA:3.40.190.290:FF:000048', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(159020, NULL, 'G3DSA:2.30.30.100:FF:000109', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm5', NULL, NULL, NULL, NULL, NULL, 4),
(159021, NULL, 'G3DSA:1.10.565.10:FF:000104', NULL, NULL, 'Retinoic acid receptor RXR-gamma-A', NULL, NULL, NULL, NULL, NULL, 4),
(159022, NULL, 'G3DSA:2.20.70.10:FF:000255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159023, NULL, 'G3DSA:2.40.10.340:FF:000006', NULL, NULL, 'Cell shape-determining protein MreC', NULL, NULL, NULL, NULL, NULL, 4),
(159024, NULL, 'G3DSA:3.30.70.330:FF:000273', NULL, NULL, 'THO complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(159025, NULL, 'G3DSA:3.30.450.30:FF:000074', NULL, NULL, 'MK1', NULL, NULL, NULL, NULL, NULL, 4),
(159026, NULL, 'G3DSA:1.20.58.410:FF:000004', NULL, NULL, 'Peptide chain release factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(159027, NULL, 'G3DSA:2.40.50.90:FF:000006', NULL, NULL, 'Tudor domain-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(159028, NULL, 'G3DSA:3.40.50.11610:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159029, NULL, 'G3DSA:3.30.160.60:FF:003505', NULL, NULL, 'GD16882', NULL, NULL, NULL, NULL, NULL, 4),
(159030, NULL, 'G3DSA:3.30.420.40:FF:000575', NULL, NULL, 'Heat shock protein 70 putative', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(159031, NULL, 'G3DSA:2.30.29.30:FF:000142', NULL, NULL, 'protein-tyrosine kinase 2-beta isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(159032, NULL, 'G3DSA:3.40.50.1980:FF:000035', NULL, NULL, 'Iron ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(159033, NULL, 'G3DSA:3.40.309.10:FF:000018', NULL, NULL, 'Alpha-aminoadipic semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(159034, NULL, 'G3DSA:3.60.40.10:FF:000024', NULL, NULL, 'probable protein phosphatase 2C 33', NULL, NULL, NULL, NULL, NULL, 4),
(159035, NULL, 'G3DSA:3.40.50.300:FF:004568', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(159036, NULL, 'G3DSA:1.20.58.400:FF:000001', NULL, NULL, 'Vesicle transport through interaction with t-SNAREs homolog 1A', NULL, NULL, NULL, NULL, NULL, 4),
(159037, NULL, 'G3DSA:3.40.50.1970:FF:000032', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(159038, NULL, 'G3DSA:3.40.50.510:FF:000005', NULL, NULL, 'PTS-dependent dihydroxyacetone kinase phosphotransferase subunit DhaM', NULL, NULL, NULL, NULL, NULL, 4),
(159039, NULL, 'G3DSA:3.40.50.300:FF:003040', NULL, NULL, 'Guanylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(159040, NULL, 'G3DSA:1.20.1510.10:FF:000008', NULL, NULL, 'zinc transporter 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(159041, NULL, 'G3DSA:3.40.50.300:FF:005462', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(159042, NULL, 'G3DSA:1.10.1040.50:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159043, NULL, 'G3DSA:2.60.120.260:FF:000347', NULL, NULL, 'Sad1 / UNC-like C-terminal, putative', NULL, NULL, NULL, NULL, NULL, 4),
(159044, NULL, 'G3DSA:3.40.50.150:FF:000993', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159045, NULL, 'G3DSA:1.10.287.130:FF:000202', NULL, NULL, 'Integral membrane sensor signal transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(159046, NULL, 'G3DSA:3.30.70.330:FF:000429', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein A1-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(159047, NULL, 'G3DSA:2.30.30.100:FF:000042', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm2', NULL, NULL, NULL, NULL, NULL, 4),
(159048, NULL, 'G3DSA:3.60.10.10:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159049, NULL, 'G3DSA:3.40.47.10:FF:000057', NULL, NULL, '3-ketoacyl-CoA synthase', NULL, NULL, NULL, NULL, NULL, 4),
(159050, NULL, 'G3DSA:3.30.450.20:FF:000071', NULL, NULL, 'PAS domain-containing sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(159051, NULL, 'G3DSA:3.20.20.70:FF:000115', NULL, NULL, 'Isopentenyl-diphosphate delta-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(159052, NULL, 'G3DSA:3.90.780.10:FF:000045', NULL, NULL, 'YALI0D13640p', NULL, NULL, NULL, NULL, NULL, 4),
(159053, NULL, 'G3DSA:2.130.10.10:FF:000791', NULL, NULL, 'U3 small nucleolar RNA-associated protein 4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(159054, NULL, 'G3DSA:2.60.40.1730:FF:000012', NULL, NULL, 'Aminopeptidase N', NULL, NULL, NULL, NULL, NULL, 4),
(159055, NULL, 'G3DSA:3.40.50.720:FF:001608', NULL, NULL, 'UDP-glucuronic acid decarboxylase 6', NULL, NULL, NULL, NULL, NULL, 4),
(159056, NULL, 'G3DSA:3.90.1200.10:FF:000001', NULL, NULL, 'Fructosamine kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(159057, NULL, 'G3DSA:3.20.20.100:FF:000050', NULL, NULL, 'Aldo-keto reductase family 1 member C2', NULL, NULL, NULL, NULL, NULL, 4),
(159058, NULL, 'G3DSA:2.60.220.50:FF:000020', NULL, NULL, 'Adhesion G-protein coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(159059, NULL, 'G3DSA:1.10.10.10:FF:000456', NULL, NULL, 'LysR family transcriptional regulator ArgP', NULL, NULL, NULL, NULL, NULL, 4),
(159060, NULL, 'G3DSA:3.40.50.300:FF:001191', NULL, NULL, 'Elongation factor 1-alpha', NULL, NULL, NULL, NULL, NULL, 4),
(159061, NULL, 'G3DSA:2.130.10.10:FF:004169', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 16', NULL, NULL, NULL, NULL, NULL, 4),
(159062, NULL, 'G3DSA:1.25.40.30:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(159063, NULL, 'G3DSA:1.20.58.60:FF:000081', NULL, NULL, 'Short stop, isoform K', NULL, NULL, NULL, NULL, NULL, 4),
(159064, NULL, 'G3DSA:2.40.50.140:FF:000314', NULL, NULL, 'Protein OSB2 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(159065, NULL, 'G3DSA:3.40.50.720:FF:002502', NULL, NULL, 'Lysine-ketoglutarate reductase/saccharopine dehydrogenase bifunctional enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(159066, NULL, 'G3DSA:3.30.420.40:FF:000923', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159067, NULL, 'G3DSA:3.50.50.60:FF:000377', NULL, NULL, 'Selenate reductase subunit YgfK', NULL, NULL, NULL, NULL, NULL, 4),
(159068, NULL, 'G3DSA:1.10.472.10:FF:000198', NULL, NULL, 'G2/mitotic-specific cyclin-B1', NULL, NULL, NULL, NULL, NULL, 4),
(159069, NULL, 'G3DSA:3.30.40.10:FF:002077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159070, NULL, 'G3DSA:3.40.50.720:FF:001878', NULL, NULL, '3-hydroxyisobutyrate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(159071, NULL, 'G3DSA:1.20.5.1160:FF:000036', NULL, NULL, 'Lamin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(159072, NULL, 'G3DSA:2.60.120.650:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159073, NULL, 'G3DSA:1.20.140.20:FF:000001', NULL, NULL, '[Pyruvate dehydrogenase (acetyl-transferring)] kinase isozyme 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(159074, NULL, 'G3DSA:3.40.30.10:FF:000980', NULL, NULL, 'Protein disulfide-isomerase A3', NULL, NULL, NULL, NULL, NULL, 4),
(159075, NULL, 'G3DSA:3.60.15.10:FF:000218', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(159076, NULL, 'G3DSA:1.20.120.330:FF:000007', NULL, NULL, 'protein-tyrosine kinase 2-beta isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(159077, NULL, 'G3DSA:1.20.1250.20:FF:001368', NULL, NULL, 'solute carrier family 15 member 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(159078, NULL, 'G3DSA:3.30.160.60:FF:005074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159079, NULL, 'G3DSA:3.90.650.10:FF:000041', NULL, NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(159080, NULL, 'G3DSA:1.25.10.10:FF:001204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159081, NULL, 'G3DSA:3.50.50.60:FF:000607', NULL, NULL, 'Glucose-inhibited division family A protein', NULL, NULL, NULL, NULL, NULL, 4),
(159082, NULL, 'G3DSA:3.40.50.11660:FF:000021', NULL, NULL, 'Alpha3-fucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(159083, NULL, 'G3DSA:1.10.400.10:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159084, NULL, 'G3DSA:3.30.60.90:FF:000022', NULL, NULL, 'Histone acetyltransferase of the CBP family 12', NULL, NULL, NULL, NULL, NULL, 4),
(159085, NULL, 'G3DSA:1.20.5.110:FF:000122', NULL, NULL, 'Synaptosomal-associated protein, 23kDa', NULL, NULL, NULL, NULL, NULL, 4),
(159086, NULL, 'G3DSA:2.30.30.490:FF:000001', NULL, NULL, 'Metastasis-associated 1 family, member 3', NULL, NULL, NULL, NULL, NULL, 4),
(159087, NULL, 'G3DSA:4.10.60.10:FF:000222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159088, NULL, 'G3DSA:1.10.8.500:FF:000005', NULL, NULL, 'Sensor histidine kinase YycG', NULL, NULL, NULL, NULL, NULL, 4),
(159089, NULL, 'G3DSA:2.40.30.10:FF:000257', NULL, NULL, 'Putative reductase', NULL, NULL, NULL, NULL, NULL, 4),
(159090, NULL, 'G3DSA:3.30.200.20:FF:002497', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159091, NULL, 'G3DSA:4.10.60.10:FF:000166', NULL, NULL, 'TIMELESS-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(159092, NULL, 'G3DSA:3.40.850.10:FF:000270', NULL, NULL, 'Kinesin family member 21A', NULL, NULL, NULL, NULL, NULL, 4),
(159093, NULL, 'G3DSA:2.130.10.10:FF:004618', NULL, NULL, 'Putative U4/U6 small nuclear ribonuclear protein', NULL, NULL, NULL, NULL, NULL, 4),
(159094, NULL, 'G3DSA:3.30.710.10:FF:000009', NULL, NULL, 'Zinc finger and BTB domain-containing 37', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(159095, NULL, 'G3DSA:2.10.25.10:FF:000999', NULL, NULL, 'Wall-associated receptor kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(159096, NULL, 'G3DSA:3.40.390.10:FF:000190', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159097, NULL, 'G3DSA:1.20.120.310:FF:000001', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(159098, NULL, 'G3DSA:3.90.190.20:FF:000014', NULL, NULL, 'Dihydrofolate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(159099, NULL, 'G3DSA:3.30.760.10:FF:000001', NULL, NULL, 'Eukaryotic translation initiation factor 4E type 2 isoformX2', NULL, NULL, NULL, NULL, NULL, 4),
(159100, NULL, 'G3DSA:3.30.40.10:FF:002184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159101, NULL, 'G3DSA:3.20.20.140:FF:000106', NULL, NULL, 'Amidohydrolase family', NULL, NULL, NULL, NULL, NULL, 4),
(159102, NULL, 'G3DSA:1.25.40.10:FF:004409', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159103, NULL, 'G3DSA:3.40.50.300:FF:001308', NULL, NULL, 'DEAD-box ATP-dependent RNA helicase 50', NULL, NULL, NULL, NULL, NULL, 4),
(159104, NULL, 'G3DSA:1.25.40.20:FF:001074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159105, NULL, 'G3DSA:2.130.10.10:FF:003039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159106, NULL, 'G3DSA:3.40.50.620:FF:000038', NULL, NULL, 'Argininosuccinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(159107, NULL, 'G3DSA:3.40.50.80:FF:000232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159108, NULL, 'G3DSA:3.40.50.2300:FF:000171', NULL, NULL, 'Vomeronasal 2, receptor 17', NULL, NULL, NULL, NULL, NULL, 4),
(159109, NULL, 'G3DSA:3.30.70.330:FF:000722', NULL, NULL, 'Nuclear mRNA splicing factor-associated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(159110, NULL, 'G3DSA:2.40.330.10:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159111, NULL, 'G3DSA:1.10.238.10:FF:000845', NULL, NULL, 'Calcium uptake protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(159112, NULL, 'G3DSA:3.40.50.620:FF:000095', NULL, NULL, 'Phosphoadenosine phosphosulfate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(159113, NULL, 'G3DSA:1.25.40.90:FF:000055', NULL, NULL, 'Blast:Protein LST8 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(159114, NULL, 'G3DSA:1.10.150.530:FF:000008', NULL, NULL, 'Probable dual-specificity RNA methyltransferase RlmN', NULL, NULL, NULL, NULL, NULL, 4),
(159115, NULL, 'G3DSA:3.90.70.10:FF:000665', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159116, NULL, 'G3DSA:2.130.10.10:FF:000347', NULL, NULL, 'Pre-mRNA-splicing factor PRP46, putative', NULL, NULL, NULL, NULL, NULL, 4),
(159117, NULL, 'G3DSA:3.40.50.920:FF:000027', NULL, NULL, 'Transketolase', NULL, NULL, NULL, NULL, NULL, 4),
(159118, NULL, 'G3DSA:2.60.40.10:FF:001263', NULL, NULL, 'brother of CDO isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(159119, NULL, 'G3DSA:3.40.630.30:FF:000006', NULL, NULL, 'Putative n-alpha-acetyltransferase 50', NULL, NULL, NULL, NULL, NULL, 4),
(159120, NULL, 'G3DSA:3.40.50.2000:FF:000075', NULL, NULL, 'Lipopolysaccharide heptosyltransferase I', NULL, NULL, NULL, NULL, NULL, 4),
(159121, NULL, 'G3DSA:3.40.50.720:FF:001934', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159122, NULL, 'G3DSA:3.90.25.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159123, NULL, 'G3DSA:1.10.730.10:FF:000017', NULL, NULL, 'Arginine--tRNA ligase, chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(159124, NULL, 'G3DSA:3.30.160.60:FF:000869', NULL, NULL, 'Zinc finger protein 213', NULL, NULL, NULL, NULL, NULL, 4),
(159125, NULL, 'G3DSA:3.30.160.60:FF:005130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159126, NULL, 'G3DSA:2.60.40.150:FF:000277', NULL, NULL, 'Nicotinic receptor-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(159127, NULL, 'G3DSA:2.40.10.10:FF:000256', NULL, NULL, 'Vitamin K-dependent protein C', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(159128, NULL, 'G3DSA:1.10.275.20:FF:000006', NULL, NULL, 'CROT isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(159129, NULL, 'G3DSA:2.60.260.20:FF:000087', NULL, NULL, 'DNAJ heat shock family protein', NULL, NULL, NULL, NULL, NULL, 4),
(159130, NULL, 'G3DSA:2.60.40.10:FF:000369', NULL, NULL, 'Protein tyrosine phosphatase, receptor type B', NULL, NULL, NULL, NULL, NULL, 4),
(159131, NULL, 'G3DSA:1.10.472.10:FF:000708', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159132, NULL, 'G3DSA:1.10.1580.20:FF:000001', NULL, NULL, 'YihD family protein', NULL, NULL, NULL, NULL, NULL, 4),
(159133, NULL, 'G3DSA:1.10.275.30:FF:000009', NULL, NULL, 'RAD3-like DNA-binding helicase protein', NULL, NULL, NULL, NULL, NULL, 4),
(159134, NULL, 'G3DSA:3.10.350.10:FF:000053', NULL, NULL, 'LysM Domain (Peptidoglycan binding) protein', NULL, NULL, NULL, NULL, NULL, 4),
(159135, NULL, 'G3DSA:1.10.10.60:FF:001050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159136, NULL, 'G3DSA:3.30.830.10:FF:000226', NULL, NULL, 'Mitochondrial processing peptidase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(159137, NULL, 'G3DSA:1.10.486.10:FF:000033', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(159138, NULL, 'G3DSA:1.10.10.60:FF:000336', NULL, NULL, 'Transcription factor MYB39', NULL, NULL, NULL, NULL, NULL, 4),
(159139, NULL, 'G3DSA:3.50.50.60:FF:000720', NULL, NULL, 'Pyridine nucleotide-disulfide oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(159140, NULL, 'G3DSA:1.25.40.20:FF:001035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159141, NULL, 'G3DSA:3.40.640.10:FF:000462', NULL, NULL, 'Lipopolysaccharide biosynthesis protein RfbH', NULL, NULL, NULL, NULL, NULL, 4),
(159142, NULL, 'G3DSA:1.25.40.10:FF:004466', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159143, NULL, 'G3DSA:1.25.10.10:FF:002727', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159144, NULL, 'G3DSA:3.30.430.20:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159145, NULL, 'G3DSA:2.40.50.40:FF:000071', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(159146, NULL, 'G3DSA:3.40.50.300:FF:006480', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159147, NULL, 'G3DSA:1.20.58.1380:FF:000017', NULL, NULL, 'Nucleoporin nup131', NULL, NULL, NULL, NULL, NULL, 4),
(159148, NULL, 'G3DSA:3.40.50.720:FF:000630', NULL, NULL, '3-hydroxyisobutyrate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(159149, NULL, 'G3DSA:1.25.40.480:FF:000004', NULL, NULL, 'Bystin', NULL, NULL, NULL, NULL, NULL, 4),
(159150, NULL, 'G3DSA:1.10.150.670:FF:000022', NULL, NULL, 'Crossover junction endonuclease MUS81', NULL, NULL, NULL, NULL, NULL, 4),
(159151, NULL, 'G3DSA:3.40.50.150:FF:000667', NULL, NULL, 'NucleOLar protein', NULL, NULL, NULL, NULL, NULL, 4),
(159152, NULL, 'G3DSA:2.60.40.60:FF:000917', NULL, NULL, 'Si:dkey-1m11.5', NULL, NULL, NULL, NULL, NULL, 4),
(159153, NULL, 'G3DSA:1.10.150.20:FF:000150', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(159154, NULL, 'G3DSA:1.10.238.110:FF:000001', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(159155, NULL, 'G3DSA:3.40.50.620:FF:000151', NULL, NULL, 'Phosphoadenosine phosphosulfate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(159156, NULL, 'G3DSA:4.10.60.10:FF:000109', NULL, NULL, 'Universal minicircle sequence binding protein (UMSBP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(159157, NULL, 'G3DSA:3.40.50.1820:FF:000526', NULL, NULL, 'Carboxylesterase', NULL, NULL, NULL, NULL, NULL, 4),
(159158, NULL, 'G3DSA:1.25.40.470:FF:000001', NULL, NULL, 'Coatomer subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(159159, NULL, 'G3DSA:1.25.40.180:FF:000015', NULL, NULL, 'regulator of nonsense transcripts 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(159160, NULL, 'G3DSA:1.20.1560.10:FF:000337', NULL, NULL, 'Multidrug resistance-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(159161, NULL, 'G3DSA:1.10.10.10:FF:000568', NULL, NULL, 'Two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(159162, NULL, 'G3DSA:3.10.350.10:FF:000014', NULL, NULL, 'Soluble lytic murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(159163, NULL, 'G3DSA:2.130.10.10:FF:003152', NULL, NULL, 'Vacuolar protein sorting-associated protein 41 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(159164, NULL, 'G3DSA:2.60.40.10:FF:002567', NULL, NULL, 'Juxtamembrane domain-associated catenin', NULL, NULL, NULL, NULL, NULL, 4),
(159165, NULL, 'G3DSA:1.20.1070.10:FF:002110', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(159166, NULL, 'G3DSA:3.30.450.70:FF:000001', NULL, NULL, 'Trafficking protein particle complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(159167, NULL, 'G3DSA:2.70.170.10:FF:000097', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(159168, NULL, 'G3DSA:1.25.40.10:FF:002375', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At1g09680', NULL, NULL, NULL, NULL, NULL, 4),
(159169, NULL, 'G3DSA:1.25.10.10:FF:003334', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159170, NULL, 'G3DSA:3.40.50.2300:FF:001587', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159171, NULL, 'G3DSA:3.30.450.80:FF:000004', NULL, NULL, 'LuxR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(159172, NULL, 'G3DSA:1.25.40.10:FF:000138', NULL, NULL, 'Protein arginine methyltransferase 9', NULL, NULL, NULL, NULL, NULL, 4),
(159173, NULL, 'G3DSA:2.60.40.150:FF:000390', NULL, NULL, 'Putative triglyceride lipase', NULL, NULL, NULL, NULL, NULL, 4),
(159174, NULL, 'G3DSA:1.10.375.10:FF:000005', NULL, NULL, 'Gag-pro-pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(159175, NULL, 'G3DSA:2.30.42.10:FF:000004', NULL, NULL, 'Disks large homolog 4 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(159176, NULL, 'G3DSA:3.40.50.720:FF:001991', NULL, NULL, 'Glr3777 protein', NULL, NULL, NULL, NULL, NULL, 4),
(159177, NULL, 'G3DSA:3.40.50.2000:FF:000923', NULL, NULL, 'ADP-heptose--lipopolysaccharide heptosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(159178, NULL, 'G3DSA:1.25.40.10:FF:002555', NULL, NULL, 'Pentatricopeptide (PPR) repeat-containing protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(159179, NULL, 'G3DSA:2.60.40.10:FF:004697', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159180, NULL, 'G3DSA:3.90.1150.10:FF:000058', NULL, NULL, 'Cystathionine beta-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(159181, NULL, 'G3DSA:1.10.418.10:FF:000090', NULL, NULL, 'Kinesin-like protein KIN-14D', NULL, NULL, NULL, NULL, NULL, 4),
(159182, NULL, 'G3DSA:1.20.58.160:FF:000002', NULL, NULL, 'Golgi-associated, gamma adaptin ear containing, ARF binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(159183, NULL, 'G3DSA:2.60.40.10:FF:001206', NULL, NULL, 'Sallimus, isoform P', NULL, NULL, NULL, NULL, NULL, 4),
(159184, NULL, 'G3DSA:1.20.1550.10:FF:000005', NULL, NULL, 'Disulfide bond formation protein B', NULL, NULL, NULL, NULL, NULL, 4),
(159185, NULL, 'G3DSA:1.10.150.20:FF:000094', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(159186, NULL, 'G3DSA:1.10.3860.10:FF:000003', NULL, NULL, 'Serine/threonine transporter sstT', NULL, NULL, NULL, NULL, NULL, 4),
(159187, NULL, 'G3DSA:3.60.15.10:FF:000112', NULL, NULL, 'Metallo-beta-lactamase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(159188, NULL, 'G3DSA:2.130.10.10:FF:002590', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159189, NULL, 'G3DSA:2.40.50.140:FF:000264', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(159190, NULL, 'G3DSA:3.40.50.300:FF:000965', NULL, NULL, 'RecBCD enzyme subunit RecD', NULL, NULL, NULL, NULL, NULL, 4),
(159191, NULL, 'G3DSA:3.30.450.20:FF:000520', NULL, NULL, 'Multi-sensor hybrid histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(159192, NULL, 'G3DSA:3.90.550.50:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(159193, NULL, 'G3DSA:3.80.10.10:FF:003175', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(159194, NULL, 'G3DSA:1.20.1530.20:FF:000007', NULL, NULL, 'K(+) efflux antiporter 2 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(159195, NULL, 'G3DSA:3.40.710.10:FF:000001', NULL, NULL, 'D-alanyl-D-alanine serine-type carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(159196, NULL, 'G3DSA:2.130.10.10:FF:002820', NULL, NULL, 'Anaphase-promoting complex component Cut20/Apc4, putative (AFU_orthologue AFUA_1G15710)', NULL, NULL, NULL, NULL, NULL, 4),
(159197, NULL, 'G3DSA:1.10.10.10:FF:000748', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(159198, NULL, 'G3DSA:3.40.640.10:FF:000349', NULL, NULL, 'DegT/DnrJ/EryC1/StrS aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(159199, NULL, 'G3DSA:2.60.120.230:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159200, NULL, 'G3DSA:3.40.395.10:FF:000009', NULL, NULL, 'Deneddylase 1, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(159201, NULL, 'G3DSA:1.10.238.10:FF:000884', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(159202, NULL, 'G3DSA:2.10.25.10:FF:001724', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(159203, NULL, 'G3DSA:2.60.120.260:FF:000403', NULL, NULL, 'Extracellular exo-alpha-L-arabinofuranosidase', NULL, NULL, NULL, NULL, NULL, 4),
(159204, NULL, 'G3DSA:1.25.40.10:FF:004741', NULL, NULL, 'Anaphase-promoting complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(159205, NULL, 'G3DSA:2.10.25.10:FF:001781', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159206, NULL, 'G3DSA:1.10.10.60:FF:001230', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159207, NULL, 'G3DSA:1.10.10.10:FF:001243', NULL, NULL, 'AGAP002394-PA', NULL, NULL, NULL, NULL, NULL, 4),
(159208, NULL, 'G3DSA:1.25.40.10:FF:003162', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(159209, NULL, 'G3DSA:2.130.10.10:FF:004675', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159210, NULL, 'G3DSA:2.20.70.10:FF:000081', NULL, NULL, 'PDZ domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(159211, NULL, 'G3DSA:3.40.50.300:FF:006367', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159212, NULL, 'G3DSA:3.40.50.720:FF:000355', NULL, NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(159213, NULL, 'G3DSA:1.25.10.10:FF:001423', NULL, NULL, 'Microtubule-associated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(159214, NULL, 'G3DSA:3.80.20.20:FF:000019', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(159215, NULL, 'G3DSA:3.30.40.10:FF:000840', NULL, NULL, 'E3 ubiquitin-protein ligase SINA-like 5', NULL, NULL, NULL, NULL, NULL, 4),
(159216, NULL, 'G3DSA:3.30.1370.210:FF:000010', NULL, NULL, 'Zinc finger CCCH domain-containing protein 28', NULL, NULL, NULL, NULL, NULL, 4),
(159217, NULL, 'G3DSA:2.60.120.680:FF:000012', NULL, NULL, 'Opossum, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(159218, NULL, 'G3DSA:3.30.1550.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159219, NULL, 'G3DSA:1.10.8.60:FF:000588', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159220, NULL, 'G3DSA:3.30.450.20:FF:000340', NULL, NULL, 'Potassium voltage-gated channel, subfamily H (eag-related), member 8', NULL, NULL, NULL, NULL, NULL, 4),
(159221, NULL, 'G3DSA:3.40.140.10:FF:000093', NULL, NULL, 'POSSIBLE DEAMINASE', NULL, NULL, NULL, NULL, NULL, 4),
(159222, NULL, 'G3DSA:3.90.70.10:FF:000884', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(159223, NULL, 'G3DSA:3.40.640.10:FF:000350', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159224, NULL, 'G3DSA:3.90.70.10:FF:000901', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(159225, NULL, 'G3DSA:3.90.190.20:FF:000071', NULL, NULL, 'Putative folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(159226, NULL, 'G3DSA:1.10.150.20:FF:000037', NULL, NULL, 'DNA repair protein complementing XP-G cells homolog', NULL, NULL, NULL, NULL, NULL, 4),
(159227, NULL, 'G3DSA:2.60.40.10:FF:002842', NULL, NULL, 'Putative invasin', NULL, NULL, NULL, NULL, NULL, 4),
(159228, NULL, 'G3DSA:3.40.50.620:FF:000331', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(159229, NULL, 'G3DSA:3.40.190.10:FF:000657', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(159230, NULL, 'G3DSA:3.30.70.360:FF:000028', NULL, NULL, 'Acetylornithine deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(159231, NULL, 'G3DSA:3.30.70.330:FF:002015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159232, NULL, 'G3DSA:3.40.50.300:FF:006148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159233, NULL, 'G3DSA:1.10.1420.10:FF:000184', NULL, NULL, 'Mismatch repair-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(159234, NULL, 'G3DSA:1.10.150.510:FF:000002', NULL, NULL, 'Receptor activity-modifying protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(159235, NULL, 'G3DSA:1.10.510.10:FF:002838', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159236, NULL, 'G3DSA:1.20.5.340:FF:000079', NULL, NULL, 'Protein hook', NULL, NULL, NULL, NULL, NULL, 4),
(159237, NULL, 'G3DSA:1.10.8.10:FF:000202', NULL, NULL, 'Ubiquitin-conjugating enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(159238, NULL, 'G3DSA:3.30.300.180:FF:000016', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(159239, NULL, 'G3DSA:2.130.10.10:FF:001241', NULL, NULL, 'Sperm-associated antigen 16 protein', NULL, NULL, NULL, NULL, NULL, 4),
(159240, NULL, 'G3DSA:2.10.50.10:FF:000001', NULL, NULL, 'Ephrin type-A receptor 5', NULL, NULL, NULL, NULL, NULL, 4),
(159241, NULL, 'G3DSA:1.20.1250.20:FF:000025', NULL, NULL, 'probable polyol transporter 4', NULL, NULL, NULL, NULL, NULL, 4),
(159242, NULL, 'G3DSA:3.40.630.40:FF:000009', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(159243, NULL, 'G3DSA:3.30.40.10:FF:002127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159244, NULL, 'G3DSA:2.30.40.10:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159245, NULL, 'G3DSA:3.80.10.10:FF:002606', NULL, NULL, 'Slit guidance ligand 3', NULL, NULL, NULL, NULL, NULL, 4),
(159246, NULL, 'G3DSA:2.60.120.260:FF:000173', NULL, NULL, 'Netrin 4', NULL, NULL, NULL, NULL, NULL, 4),
(159247, NULL, 'G3DSA:1.20.58.60:FF:000316', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(159248, NULL, 'G3DSA:1.25.40.10:FF:004522', NULL, NULL, 'Crooked neck-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(159249, NULL, 'G3DSA:3.40.1000.30:FF:000020', NULL, NULL, 'Zgc:92785', NULL, NULL, NULL, NULL, NULL, 4),
(159250, NULL, 'G3DSA:3.30.710.10:FF:000341', NULL, NULL, 'BTB/POZ domain-containing protein KCTD5', NULL, NULL, NULL, NULL, NULL, 4),
(159251, NULL, 'G3DSA:3.30.200.20:FF:001081', NULL, NULL, 'Putative haspin protein kinase protein', NULL, NULL, NULL, NULL, NULL, 4),
(159252, NULL, 'G3DSA:3.10.20.530:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159253, NULL, 'G3DSA:1.20.5.190:FF:000163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159254, NULL, 'G3DSA:1.10.510.10:FF:001147', NULL, NULL, 'NNK1p Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(159255, NULL, 'G3DSA:2.10.50.30:FF:000007', NULL, NULL, 'Vomeronasal 2, receptor 82', NULL, NULL, NULL, NULL, NULL, 4),
(159256, NULL, 'G3DSA:1.20.140.40:FF:000046', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(159257, NULL, 'G3DSA:2.70.70.10:FF:000056', NULL, NULL, 'Gll3471 protein', NULL, NULL, NULL, NULL, NULL, 4),
(159258, NULL, 'G3DSA:3.40.50.150:FF:001162', NULL, NULL, 'DNA (cytosine-5)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(159259, NULL, 'G3DSA:3.40.50.300:FF:005911', NULL, NULL, 'ATP-binding cassette subfamily C member 10', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(159260, NULL, 'G3DSA:1.20.58.900:FF:000038', NULL, NULL, 'Small G protein signaling modulator 3', NULL, NULL, NULL, NULL, NULL, 4),
(159261, NULL, 'G3DSA:3.30.70.141:FF:000020', NULL, NULL, 'Thioredoxin domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(159262, NULL, 'G3DSA:1.10.510.10:FF:002895', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159263, NULL, 'G3DSA:3.30.160.60:FF:001706', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159264, NULL, 'G3DSA:2.60.40.1170:FF:000092', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159265, NULL, 'G3DSA:1.10.287.3990:FF:000001', NULL, NULL, '26S proteasome regulatory subunit S5A', NULL, NULL, NULL, NULL, NULL, 4),
(159266, NULL, 'G3DSA:3.90.190.10:FF:000011', NULL, NULL, 'Dual specificity phosphatase 6', NULL, NULL, NULL, NULL, NULL, 4),
(159267, NULL, 'G3DSA:3.30.160.60:FF:005017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159268, NULL, 'G3DSA:2.130.10.10:FF:005512', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159269, NULL, 'G3DSA:2.60.40.10:FF:004927', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159270, NULL, 'G3DSA:3.50.50.60:FF:000427', NULL, NULL, 'NADPH-ferredoxin reductase FprA', NULL, NULL, NULL, NULL, NULL, 4),
(159271, NULL, 'G3DSA:1.20.120.560:FF:000003', NULL, NULL, 'pH-response regulator protein palA/RIM20', NULL, NULL, NULL, NULL, NULL, 4),
(159272, NULL, 'G3DSA:3.30.1370.10:FF:000072', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(159273, NULL, 'G3DSA:2.10.22.10:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159274, NULL, 'G3DSA:3.30.420.40:FF:000962', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159275, NULL, 'G3DSA:2.60.40.1180:FF:000095', NULL, NULL, 'Glycoside hydrolase family 27', NULL, NULL, NULL, NULL, NULL, 4),
(159276, NULL, 'G3DSA:3.30.590.50:FF:000005', NULL, NULL, 'glutamate--cysteine ligase catalytic subunit isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(159277, NULL, 'G3DSA:3.30.1010.10:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159278, NULL, 'G3DSA:3.10.310.50:FF:000001', NULL, NULL, 'Inner membrane protein ycfZ', NULL, NULL, NULL, NULL, NULL, 4),
(159279, NULL, 'G3DSA:3.20.20.220:FF:000086', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(159280, NULL, 'G3DSA:3.80.10.10:FF:001825', NULL, NULL, 'Leucine-rich repeat transmembrane protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(159281, NULL, 'G3DSA:3.40.190.10:FF:000438', NULL, NULL, 'Ionotropic receptor IR21a', NULL, NULL, NULL, NULL, NULL, 4),
(159282, NULL, 'G3DSA:3.40.190.10:FF:000152', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(159283, NULL, 'G3DSA:1.25.40.20:FF:001310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159284, NULL, 'G3DSA:3.90.280.10:FF:000018', NULL, NULL, 'Mitochondrial Ribosomal Protein, Large', NULL, NULL, NULL, NULL, NULL, 4),
(159285, NULL, 'G3DSA:2.60.40.60:FF:000356', NULL, NULL, 'Protocadherin 15', NULL, NULL, NULL, NULL, NULL, 4),
(159286, NULL, 'G3DSA:3.30.750.24:FF:000036', NULL, NULL, 'Putative sulfate transporter YPR003C', NULL, NULL, NULL, NULL, NULL, 4),
(159287, NULL, 'G3DSA:3.30.2350.10:FF:000037', NULL, NULL, 'TIGR01621 family pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(159288, NULL, 'G3DSA:1.20.910.10:FF:000012', NULL, NULL, 'Heme oxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(159289, NULL, 'G3DSA:3.90.980.20:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159290, NULL, 'G3DSA:3.80.10.10:FF:002101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159291, NULL, 'G3DSA:3.10.450.50:FF:000106', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(159292, NULL, 'G3DSA:2.10.25.10:FF:001505', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159293, NULL, 'G3DSA:3.30.40.10:FF:000508', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(159294, NULL, 'G3DSA:3.40.50.720:FF:002266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159295, NULL, 'G3DSA:3.40.50.150:FF:000954', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159296, NULL, 'G3DSA:2.130.10.10:FF:002258', NULL, NULL, 'U3 small nucleolar RNA-associated protein 18 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(159297, NULL, 'G3DSA:2.60.40.10:FF:003623', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159298, NULL, 'G3DSA:3.40.50.300:FF:007261', NULL, NULL, 'Polynucleotide 5''-hydroxyl-kinase NOL9', NULL, NULL, NULL, NULL, NULL, 4),
(159299, NULL, 'G3DSA:3.30.1640.30:FF:000003', NULL, NULL, 'RH60875p', NULL, NULL, NULL, NULL, NULL, 4),
(159300, NULL, 'G3DSA:3.80.10.10:FF:002045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159301, NULL, 'G3DSA:3.40.50.410:FF:000200', NULL, NULL, 'ATP-dependent DNA helicase II subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(159302, NULL, 'G3DSA:1.10.510.10:FF:000927', NULL, NULL, 'Protein kinase OspG', NULL, NULL, NULL, NULL, NULL, 4),
(159303, NULL, 'G3DSA:3.30.200.20:FF:000529', NULL, NULL, 'L-type lectin-domain containing receptor kinase IX.1', NULL, NULL, NULL, NULL, NULL, 4),
(159304, NULL, 'G3DSA:3.30.160.60:FF:005310', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159305, NULL, 'G3DSA:3.40.50.300:FF:004855', NULL, NULL, 'UPF1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(159306, NULL, 'G3DSA:3.90.1150.10:FF:000345', NULL, NULL, 'Alanine aminotransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(159307, NULL, 'G3DSA:1.20.1270.60:FF:000116', NULL, NULL, 'Suppressor of yeast profilin deletion', NULL, NULL, NULL, NULL, NULL, 4),
(159308, NULL, 'G3DSA:1.20.930.10:FF:000007', NULL, NULL, 'Transcription elongation factor S-II', NULL, NULL, NULL, NULL, NULL, 4),
(159309, NULL, 'G3DSA:3.40.50.300:FF:003219', NULL, NULL, 'RAB30 isoform 11', NULL, NULL, NULL, NULL, NULL, 4),
(159310, NULL, 'G3DSA:3.80.10.10:FF:000246', NULL, NULL, 'Leucine rich repeat containing 18', NULL, NULL, NULL, NULL, NULL, 4),
(159311, NULL, 'G3DSA:3.90.1070.20:FF:000004', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(159312, NULL, 'G3DSA:3.40.190.170:FF:000012', NULL, NULL, 'Ectoine/5-hydroxyectoine-binding periplasmic protein UehA', NULL, NULL, NULL, NULL, NULL, 4),
(159313, NULL, 'G3DSA:3.30.230.10:FF:000079', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(159314, NULL, 'G3DSA:1.25.10.10:FF:002497', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159315, NULL, 'G3DSA:3.90.1070.10:FF:000001', NULL, NULL, 'Sucrose-phosphate synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(159316, NULL, 'G3DSA:3.40.50.300:FF:005131', NULL, NULL, 'Lipopolysaccharide biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(159317, NULL, 'G3DSA:1.10.1670.10:FF:000062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159318, NULL, 'G3DSA:3.30.430.20:FF:000013', NULL, NULL, 'Cysteine-rich RLK (RECEPTOR-like protein kinase) 23', NULL, NULL, NULL, NULL, NULL, 4),
(159319, NULL, 'G3DSA:1.20.1080.10:FF:000025', NULL, NULL, 'Formate/nitrite transporter', NULL, NULL, NULL, NULL, NULL, 4),
(159320, NULL, 'G3DSA:1.10.510.10:FF:001203', NULL, NULL, 'Related to ABC1-ubiquinol--cytochrome-c reductase complex assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(159321, NULL, 'G3DSA:2.30.280.10:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159322, NULL, 'G3DSA:1.10.400.10:FF:000032', NULL, NULL, 'G Protein, Alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(159323, NULL, 'G3DSA:3.40.190.10:FF:000096', NULL, NULL, 'Aliphatic sulfonates ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(159324, NULL, 'G3DSA:1.10.220.150:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159325, NULL, 'G3DSA:1.20.1250.10:FF:000022', NULL, NULL, 'ciliary neurotrophic factor', NULL, NULL, NULL, NULL, NULL, 4),
(159326, NULL, 'G3DSA:2.170.140.10:FF:000054', NULL, NULL, 'AGAP009022-PA', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(159327, NULL, 'G3DSA:1.10.238.10:FF:001227', NULL, NULL, 'Ryanodine receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(159328, NULL, 'G3DSA:2.60.210.10:FF:000081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159329, NULL, 'G3DSA:3.80.10.10:FF:004231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159330, NULL, 'G3DSA:3.40.1000.50:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159331, NULL, 'G3DSA:3.40.30.10:FF:001036', NULL, NULL, 'Peroxiredoxin-6', NULL, NULL, NULL, NULL, NULL, 4),
(159332, NULL, 'G3DSA:3.30.70.580:FF:000038', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(159333, NULL, 'G3DSA:3.30.465.10:FF:000096', NULL, NULL, 'Cholesterol oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(159334, NULL, 'G3DSA:3.30.560.10:FF:000014', NULL, NULL, 'LD25803p', NULL, NULL, NULL, NULL, NULL, 4),
(159335, NULL, 'G3DSA:1.10.1670.10:FF:000005', NULL, NULL, 'N-glycosylase/DNA lyase OGG1', NULL, NULL, NULL, NULL, NULL, 4),
(159336, NULL, 'G3DSA:3.40.50.1240:FF:000162', NULL, NULL, 'Ubiquitin-associated and SH3 domain-containing protein B', NULL, NULL, NULL, NULL, NULL, 4),
(159337, NULL, 'G3DSA:3.30.450.170:FF:000001', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(159338, NULL, 'G3DSA:2.40.50.690:FF:000018', NULL, NULL, 'RNB-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(159339, NULL, 'G3DSA:1.10.8.270:FF:000009', NULL, NULL, 'TBC1 domain family member 30', NULL, NULL, NULL, NULL, NULL, 4),
(159340, NULL, 'G3DSA:3.30.40.10:FF:002307', NULL, NULL, 'TNF-receptor-associated factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(159341, NULL, 'G3DSA:1.10.510.10:FF:001260', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(159342, NULL, 'G3DSA:2.70.40.10:FF:000009', NULL, NULL, 'dCTP deaminase, dUMP-forming', NULL, NULL, NULL, NULL, NULL, 4),
(159343, NULL, 'G3DSA:3.90.70.10:FF:000845', NULL, NULL, 'Protein CBG17829', NULL, NULL, NULL, NULL, NULL, 4),
(159344, NULL, 'G3DSA:3.30.2350.20:FF:000079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159345, NULL, 'G3DSA:1.20.1560.10:FF:000450', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159346, NULL, 'G3DSA:2.40.70.10:FF:000198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159347, NULL, 'G3DSA:3.40.50.1910:FF:000003', NULL, NULL, 'vacuolar protein sorting-associated protein 33B isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(159348, NULL, 'G3DSA:3.30.160.60:FF:004579', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159349, NULL, 'G3DSA:2.130.10.10:FF:004057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159350, NULL, 'G3DSA:3.30.450.190:FF:000007', NULL, NULL, 'GTP-binding protein GTR1', NULL, NULL, NULL, NULL, NULL, 4),
(159351, NULL, 'G3DSA:3.40.50.300:FF:007204', NULL, NULL, 'Shikimate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(159352, NULL, 'G3DSA:1.10.246.110:FF:000002', NULL, NULL, 'ATP synthase-coupling factor 6, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(159353, NULL, 'G3DSA:2.30.30.40:FF:000446', NULL, NULL, 'SH3 domain and tetratricopeptide repeat-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(159354, NULL, 'G3DSA:2.60.120.200:FF:000470', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(159355, NULL, 'G3DSA:1.10.510.10:FF:000984', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(159356, NULL, 'G3DSA:3.30.420.10:FF:000127', NULL, NULL, 'Exoribonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(159357, NULL, 'G3DSA:1.10.510.10:FF:003390', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159358, NULL, 'G3DSA:3.40.50.300:FF:004911', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159359, NULL, 'G3DSA:3.30.428.10:FF:000027', NULL, NULL, 'Histidine triad (HIT) protein', NULL, NULL, NULL, NULL, NULL, 4),
(159360, NULL, 'G3DSA:3.40.50.360:FF:000106', NULL, NULL, 'NADPH-dependent FMN reductase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(159361, NULL, 'G3DSA:3.75.10.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159362, NULL, 'G3DSA:3.30.200.20:FF:000586', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(159363, NULL, 'G3DSA:2.30.29.70:FF:000013', NULL, NULL, 'Proteasome complex subunit Rpn13 ubiquitin receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(159364, NULL, 'G3DSA:3.30.70.330:FF:002633', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159365, NULL, 'G3DSA:3.40.50.2000:FF:000305', NULL, NULL, 'RE03785p', NULL, NULL, NULL, NULL, NULL, 4),
(159366, NULL, 'G3DSA:2.60.40.60:FF:000974', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159367, NULL, 'G3DSA:1.10.246.120:FF:000005', NULL, NULL, 'rab5 GDP/GTP exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(159368, NULL, 'G3DSA:3.40.50.300:FF:006985', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159369, NULL, 'G3DSA:1.10.10.410:FF:000004', NULL, NULL, 'GatB/YqeY domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(159370, NULL, 'G3DSA:1.10.287.110:FF:000376', NULL, NULL, 'Sll1384 protein', NULL, NULL, NULL, NULL, NULL, 4),
(159371, NULL, 'G3DSA:2.170.16.10:FF:000004', NULL, NULL, 'Replicative DNA helicase DnaB', NULL, NULL, NULL, NULL, NULL, 4),
(159372, NULL, 'G3DSA:3.10.300.10:FF:000011', NULL, NULL, 'N-methylpurine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(159373, NULL, 'G3DSA:3.60.21.10:FF:000497', NULL, NULL, 'ABC transporter AbcH.3', NULL, NULL, NULL, NULL, NULL, 4),
(159374, NULL, 'G3DSA:1.20.120.1150:FF:000013', NULL, NULL, 'Serine/threonine-protein phosphatase 2A activator', NULL, NULL, NULL, NULL, NULL, 4),
(159375, NULL, 'G3DSA:1.10.510.10:FF:001821', NULL, NULL, 'Pkinase-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(159376, NULL, 'G3DSA:1.10.1060.10:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159377, NULL, 'G3DSA:3.30.1010.10:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159378, NULL, 'G3DSA:3.40.50.1980:FF:000147', NULL, NULL, 'Putative ferrichrome-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(159379, NULL, 'G3DSA:3.30.559.10:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159380, NULL, 'G3DSA:3.40.50.300:FF:003551', NULL, NULL, 'Signal recognition particle receptor alpha subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(159381, NULL, 'G3DSA:3.90.226.10:FF:000292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159382, NULL, 'G3DSA:2.60.120.200:FF:000357', NULL, NULL, 'Putative L-type lectin-domain containing receptor kinase S.7 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(159383, NULL, 'G3DSA:2.130.10.10:FF:002876', NULL, NULL, '77 kDa echinoderm microtubule-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(159384, NULL, 'G3DSA:3.40.50.2300:FF:000570', NULL, NULL, 'AGAP000803-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(159385, NULL, 'G3DSA:3.30.160.60:FF:001600', NULL, NULL, 'Adr1 transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(159386, NULL, 'G3DSA:3.30.460.10:FF:000124', NULL, NULL, 'Speckle targeted PIP5K1A-regulated poly(A) polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(159387, NULL, 'G3DSA:1.10.3720.10:FF:000078', NULL, NULL, 'Dipeptide ABC transporter permease DppB', NULL, NULL, NULL, NULL, NULL, 4),
(159388, NULL, 'G3DSA:1.25.40.10:FF:002611', NULL, NULL, 'Tetratricopeptide repeat protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(159389, NULL, 'G3DSA:1.20.1250.20:FF:000244', NULL, NULL, 'Multidrug resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(159390, NULL, 'G3DSA:3.30.160.60:FF:000982', NULL, NULL, 'Zinc finger and SCAN domain containing 10', NULL, NULL, NULL, NULL, NULL, 4),
(159391, NULL, 'G3DSA:2.10.25.10:FF:000201', NULL, NULL, 'EGF-containing fibulin-like extracellular matrix protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(159392, NULL, 'G3DSA:2.10.25.10:FF:000145', NULL, NULL, 'Laminin subunit beta 1', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(159393, NULL, 'G3DSA:2.20.100.10:FF:000014', NULL, NULL, 'Thrombospondin type 1 domain containing 7A', NULL, NULL, NULL, NULL, NULL, 4),
(159394, NULL, 'G3DSA:3.30.200.20:FF:000861', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(159395, NULL, 'G3DSA:1.10.287.3240:FF:000012', NULL, NULL, 'V-type ATP synthase subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(159396, NULL, 'G3DSA:3.10.100.10:FF:000299', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159397, NULL, 'G3DSA:2.60.40.10:FF:004641', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159398, NULL, 'G3DSA:3.30.160.60:FF:001420', NULL, NULL, 'Zinc finger and BTB domain containing 11', NULL, NULL, NULL, NULL, NULL, 4),
(159399, NULL, 'G3DSA:3.40.1690.20:FF:000001', NULL, NULL, 'AFG3-like AAA ATPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(159400, NULL, 'G3DSA:3.40.50.300:FF:001421', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(159401, NULL, 'G3DSA:1.10.1540.10:FF:000001', NULL, NULL, 'neurobeachin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(159402, NULL, 'G3DSA:2.40.70.10:FF:000473', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159403, NULL, 'G3DSA:1.20.1410.10:FF:000006', NULL, NULL, 'Huntingtin interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(159404, NULL, 'G3DSA:1.10.8.720:FF:000066', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(159405, NULL, 'G3DSA:2.60.120.200:FF:000413', NULL, NULL, 'Crumbs-like protein 2b', NULL, NULL, NULL, NULL, NULL, 4),
(159406, NULL, 'G3DSA:1.10.630.10:FF:000021', NULL, NULL, 'Cytochrome P450 61', NULL, NULL, NULL, NULL, NULL, 4),
(159407, NULL, 'G3DSA:2.40.50.140:FF:000084', NULL, NULL, 'Single-stranded DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(159408, NULL, 'G3DSA:3.10.20.90:FF:000594', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159409, NULL, 'G3DSA:3.30.559.10:FF:000095', NULL, NULL, 'Carnitine O-palmitoyltransferase 1, muscle isoform', NULL, NULL, NULL, NULL, NULL, 4),
(159410, NULL, 'G3DSA:3.30.70.3030:FF:000004', NULL, NULL, 'U3 small nucleolar RNA-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(159411, NULL, 'G3DSA:3.30.70.3040:FF:000007', NULL, NULL, 'Cell division protein FtsX', NULL, NULL, NULL, NULL, NULL, 4),
(159412, NULL, 'G3DSA:1.25.40.10:FF:000576', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(159413, NULL, 'G3DSA:1.25.40.10:FF:001032', NULL, NULL, 'PPR repeat family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(159414, NULL, 'G3DSA:3.40.190.10:FF:000770', NULL, NULL, 'Ionotropic receptor 11a', NULL, NULL, NULL, NULL, NULL, 4),
(159415, NULL, 'G3DSA:2.40.160.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159416, NULL, 'G3DSA:1.10.287.70:FF:000335', NULL, NULL, 'TWiK family of potassium channels protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(159417, NULL, 'G3DSA:1.25.40.20:FF:000579', NULL, NULL, 'Mga2p', NULL, NULL, NULL, NULL, NULL, 4),
(159418, NULL, 'G3DSA:1.10.287.380:FF:000030', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(159419, NULL, 'G3DSA:1.20.1250.20:FF:000064', NULL, NULL, 'MFS allantoate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(159420, NULL, 'G3DSA:3.30.750.24:FF:000093', NULL, NULL, 'Sulfate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(159421, NULL, 'G3DSA:3.30.710.10:FF:000161', NULL, NULL, 'Os07g0625400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(159422, NULL, 'G3DSA:3.40.30.10:FF:000979', NULL, NULL, 'NADH:ubiquinone oxidoreductase 11 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(159423, NULL, 'G3DSA:1.25.40.10:FF:000756', NULL, NULL, 'RNA polymerase III transcription factor TFIIIC subunit (Tfc4), putative', NULL, NULL, NULL, NULL, NULL, 4),
(159424, NULL, 'G3DSA:3.40.190.10:FF:000713', NULL, NULL, 'Aliphatic sulfonates binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(159425, NULL, 'G3DSA:1.10.1070.11:FF:000034', NULL, NULL, 'Serine/threonine-protein kinase Tel1', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(159426, NULL, 'G3DSA:3.80.10.10:FF:001882', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(159427, NULL, 'G3DSA:3.40.50.300:FF:008565', NULL, NULL, 'Uncharacterized protein ABCH4', NULL, NULL, NULL, NULL, NULL, 4),
(159428, NULL, 'G3DSA:1.10.510.10:FF:003058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159429, NULL, 'G3DSA:3.40.50.1820:FF:000127', NULL, NULL, 'Thyroglobulin', NULL, NULL, NULL, NULL, NULL, 4),
(159430, NULL, 'G3DSA:1.20.1070.10:FF:002054', NULL, NULL, 'Growth hormone-releasing hormone receptor b', NULL, NULL, NULL, NULL, NULL, 4),
(159431, NULL, 'G3DSA:3.40.30.10:FF:001093', NULL, NULL, 'Glutathione s-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(159432, NULL, 'G3DSA:3.40.50.300:FF:008508', NULL, NULL, 'ATPase, AAA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(159433, NULL, 'G3DSA:3.40.50.1820:FF:000184', NULL, NULL, 'Lipase 2', NULL, NULL, NULL, NULL, NULL, 4),
(159434, NULL, 'G3DSA:1.10.720.30:FF:000005', NULL, NULL, 'scaffold attachment factor B2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(159435, NULL, 'G3DSA:3.90.79.10:FF:000191', NULL, NULL, 'Putative ADP-ribose pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(159436, NULL, 'G3DSA:3.90.550.10:FF:000562', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(159437, NULL, 'G3DSA:1.10.260.40:FF:000080', NULL, NULL, 'Transcriptional regulator of HTH-type, xre family', NULL, NULL, NULL, NULL, NULL, 4),
(159438, NULL, 'G3DSA:2.20.100.10:FF:000233', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs adt-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(159439, NULL, 'G3DSA:1.10.40.30:FF:000003', NULL, NULL, 'Aspartate ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(159440, NULL, 'G3DSA:3.30.160.60:FF:002999', NULL, NULL, 'Zinc finger imprinted 2', NULL, NULL, NULL, NULL, NULL, 4),
(159441, NULL, 'G3DSA:3.30.430.20:FF:000070', NULL, NULL, 'Os11g0681400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(159442, NULL, 'G3DSA:3.10.129.10:FF:000056', NULL, NULL, 'Hypothetical Thioesterase Protein SP_1851', NULL, NULL, NULL, NULL, NULL, 4),
(159443, NULL, 'G3DSA:1.10.220.150:FF:000006', NULL, NULL, 'arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(159444, NULL, 'G3DSA:2.130.10.10:FF:003371', NULL, NULL, 'WD repeat-containing protein dyf-2', NULL, NULL, NULL, NULL, NULL, 4),
(159445, NULL, 'G3DSA:3.40.50.300:FF:002876', NULL, NULL, '3''-5'' exonuclease DinG', NULL, NULL, NULL, NULL, NULL, 4),
(159446, NULL, 'G3DSA:3.40.50.1820:FF:001544', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159447, NULL, 'G3DSA:3.60.21.10:FF:000278', NULL, NULL, 'Protein CBG07490', NULL, NULL, NULL, NULL, NULL, 4),
(159448, NULL, 'G3DSA:3.30.160.60:FF:000925', NULL, NULL, 'Zinc finger protein 668', NULL, NULL, NULL, NULL, NULL, 4),
(159449, NULL, 'G3DSA:3.30.450.20:FF:000301', NULL, NULL, 'SIM bHLH transcription factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(159450, NULL, 'G3DSA:3.30.420.110:FF:000039', NULL, NULL, 'DNA mismatch repair protein msh2', NULL, NULL, NULL, NULL, NULL, 4),
(159451, NULL, 'G3DSA:1.10.220.160:FF:000009', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(159452, NULL, 'G3DSA:3.80.10.10:FF:001606', NULL, NULL, 'Receptor protein-tyrosine kinase CEPR1', NULL, NULL, NULL, NULL, NULL, 4),
(159453, NULL, 'G3DSA:3.90.180.10:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159454, NULL, 'G3DSA:3.30.70.660:FF:000017', NULL, NULL, 'tRNA pseudouridine(38-40) synthase', NULL, NULL, NULL, NULL, NULL, 4),
(159455, NULL, 'G3DSA:2.60.120.200:FF:000138', NULL, NULL, 'Contactin associated protein like 4', NULL, NULL, NULL, NULL, NULL, 4),
(159456, NULL, 'G3DSA:2.60.40.2170:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159457, NULL, 'G3DSA:3.30.160.60:FF:003275', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159458, NULL, 'G3DSA:3.30.780.10:FF:000053', NULL, NULL, 'Translation initiation factor SUI1', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(159459, NULL, 'G3DSA:1.20.1070.10:FF:001559', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(159460, NULL, 'G3DSA:3.30.1770.10:FF:000001', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(159461, NULL, 'G3DSA:1.20.950.20:FF:000012', NULL, NULL, 'Cytochrome B561', NULL, NULL, NULL, NULL, NULL, 4),
(159462, NULL, 'G3DSA:3.30.710.10:FF:000228', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(159463, NULL, 'G3DSA:3.30.200.20:FF:000642', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(159464, NULL, 'G3DSA:2.60.40.10:FF:003005', NULL, NULL, 'Kazal-type serine protease inhibitor domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(159465, NULL, 'G3DSA:3.30.160.60:FF:004293', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159466, NULL, 'G3DSA:3.40.50.300:FF:007148', NULL, NULL, 'Shikimate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(159467, NULL, 'G3DSA:2.60.40.10:FF:003062', NULL, NULL, 'Fibroblast growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(159468, NULL, 'G3DSA:3.40.50.450:FF:000021', NULL, NULL, 'Probable ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(159469, NULL, 'G3DSA:1.10.510.10:FF:000366', NULL, NULL, 'Serine/threonine-protein kinase Nek2', NULL, NULL, NULL, NULL, NULL, 4),
(159470, NULL, 'G3DSA:2.60.40.2860:FF:000014', NULL, NULL, 'Transmission-blocking target antigen S230', NULL, NULL, NULL, NULL, NULL, 4),
(159471, NULL, 'G3DSA:3.30.565.10:FF:000441', NULL, NULL, 'Sensor protein QseC', NULL, NULL, NULL, NULL, NULL, 4),
(159472, NULL, 'G3DSA:3.30.300.30:FF:000012', NULL, NULL, 'D-alanine--D-alanyl carrier protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(159473, NULL, 'G3DSA:1.25.40.10:FF:001251', NULL, NULL, 'Type III export protein PscG', NULL, NULL, NULL, NULL, NULL, 4),
(159474, NULL, 'G3DSA:2.10.50.30:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159475, NULL, 'G3DSA:3.40.50.12780:FF:000076', NULL, NULL, 'Salicyl-AMP ligase / salicyl-S-ArCP synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(159476, NULL, 'G3DSA:3.40.50.460:FF:000024', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(159477, NULL, 'G3DSA:2.130.10.10:FF:004731', NULL, NULL, 'Protein NEDD1', NULL, NULL, NULL, NULL, NULL, 4),
(159478, NULL, 'G3DSA:2.30.18.10:FF:000010', NULL, NULL, 'Transcription initiation factor IIA subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(159479, NULL, 'G3DSA:1.25.40.20:FF:001254', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(159480, NULL, 'G3DSA:3.30.70.330:FF:002453', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159481, NULL, 'G3DSA:3.40.50.720:FF:000411', NULL, NULL, 'Aspartate-semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(159482, NULL, 'G3DSA:2.60.40.10:FF:002786', NULL, NULL, 'Contactin rig-6', NULL, NULL, NULL, NULL, NULL, 4),
(159483, NULL, 'G3DSA:3.10.20.90:FF:000936', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159484, NULL, 'G3DSA:3.40.50.11500:FF:000001', NULL, NULL, 'Putative DENN domain-containing protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(159485, NULL, 'G3DSA:1.10.260.40:FF:000023', NULL, NULL, 'Cyanate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(159486, NULL, 'G3DSA:3.40.50.2300:FF:000513', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159487, NULL, 'G3DSA:3.40.50.1000:FF:000668', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159488, NULL, 'G3DSA:3.80.10.10:FF:004175', NULL, NULL, 'Tubulin folding cofactor E', NULL, NULL, NULL, NULL, NULL, 4),
(159489, NULL, 'G3DSA:3.40.630.10:FF:000467', NULL, NULL, 'Amidohydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(159490, NULL, 'G3DSA:1.10.510.10:FF:004076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159491, NULL, 'G3DSA:2.10.110.10:FF:000360', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159492, NULL, 'G3DSA:3.40.50.10900:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(159493, NULL, 'G3DSA:2.60.40.10:FF:001066', NULL, NULL, 'Obscurin-like protein 1 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(159494, NULL, 'G3DSA:1.10.530.40:FF:000005', NULL, NULL, 'Lysozyme', NULL, NULL, NULL, NULL, NULL, 4),
(159495, NULL, 'G3DSA:3.30.230.70:FF:000075', NULL, NULL, 'Exosome-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(159496, NULL, 'G3DSA:3.30.990.10:FF:000001', NULL, NULL, 'Formimidoyltransferase cyclodeaminase', NULL, NULL, NULL, NULL, NULL, 4),
(159497, NULL, 'G3DSA:2.60.120.260:FF:000358', NULL, NULL, 'Cellulose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(159498, NULL, 'G3DSA:1.10.565.10:FF:000003', NULL, NULL, 'Coup transcription factor 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(159499, NULL, 'G3DSA:1.10.418.10:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159500, NULL, 'G3DSA:2.60.40.420:FF:000015', NULL, NULL, 'Ceruloplasmin', NULL, NULL, NULL, NULL, NULL, 4),
(159501, NULL, 'G3DSA:3.40.30.10:FF:001098', NULL, NULL, 'Glutathione S-transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(159502, NULL, 'G3DSA:3.30.70.330:FF:000430', NULL, NULL, 'Glycine-rich RNA-binding protein GRP1A', NULL, NULL, NULL, NULL, NULL, 4),
(159503, NULL, 'G3DSA:3.40.50.1910:FF:000020', NULL, NULL, 'GD21217', NULL, NULL, NULL, NULL, NULL, 4),
(159504, NULL, 'G3DSA:2.70.170.10:FF:000069', NULL, NULL, 'Acetylcholine-gated chloride channel subunit acc-1', NULL, NULL, NULL, NULL, NULL, 4),
(159505, NULL, 'G3DSA:1.25.10.10:FF:000288', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(159506, NULL, 'G3DSA:3.30.70.330:FF:002554', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159507, NULL, 'G3DSA:3.30.200.20:FF:002317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159508, NULL, 'G3DSA:3.40.50.150:FF:000538', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', NULL, NULL, NULL, NULL, NULL, 4),
(159509, NULL, 'G3DSA:1.10.287.810:FF:000001', NULL, NULL, 'mitochondrial import inner membrane translocase subunit TIM13', NULL, NULL, NULL, NULL, NULL, 4),
(159510, NULL, 'G3DSA:1.10.287.820:FF:000004', NULL, NULL, 'Amiloride-sensitive Na+ channel', NULL, NULL, NULL, NULL, NULL, 4),
(159511, NULL, 'G3DSA:3.60.21.10:FF:000379', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159512, NULL, 'G3DSA:3.10.20.620:FF:000005', NULL, NULL, 'Autophagy protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(159513, NULL, 'G3DSA:3.90.1150.10:FF:000463', NULL, NULL, 'Kynureninase', NULL, NULL, NULL, NULL, NULL, 4),
(159514, NULL, 'G3DSA:1.25.10.10:FF:002542', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159515, NULL, 'G3DSA:3.30.40.10:FF:000385', NULL, NULL, 'SNF2 helicase, putative (ISWI)', NULL, NULL, NULL, NULL, NULL, 4),
(159516, NULL, 'G3DSA:3.40.50.10680:FF:000002', NULL, NULL, 'Maternal effect embryo arrest 18', NULL, NULL, NULL, NULL, NULL, 4),
(159517, NULL, 'G3DSA:1.20.120.810:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159518, NULL, 'G3DSA:3.30.300.130:FF:000024', NULL, NULL, 'Scaffold protein Nfu/NifU N terminal/NifU-like domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(159519, NULL, 'G3DSA:3.30.230.70:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159520, NULL, 'G3DSA:1.10.630.10:FF:000043', NULL, NULL, 'Cytochrome P450 99A2', NULL, NULL, NULL, NULL, NULL, 4),
(159521, NULL, 'G3DSA:2.160.20.10:FF:000239', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(159522, NULL, 'G3DSA:3.90.1150.10:FF:000507', NULL, NULL, 'Cysteine desulfurase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(159523, NULL, 'G3DSA:1.25.40.20:FF:000798', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(159524, NULL, 'G3DSA:3.90.550.10:FF:000770', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159525, NULL, 'G3DSA:1.10.1420.10:FF:000167', NULL, NULL, 'MutS domain III family protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(159526, NULL, 'G3DSA:1.10.268.20:FF:000001', NULL, NULL, 'EH domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(159527, NULL, 'G3DSA:1.25.40.180:FF:000206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159528, NULL, 'G3DSA:3.30.590.10:FF:000055', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(159529, NULL, 'G3DSA:1.10.150.20:FF:000099', NULL, NULL, 'DNA ligase B', NULL, NULL, NULL, NULL, NULL, 4),
(159530, NULL, 'G3DSA:2.130.10.10:FF:001044', NULL, NULL, 'Protein HIRA', NULL, NULL, NULL, NULL, NULL, 4),
(159531, NULL, 'G3DSA:3.40.50.12780:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159532, NULL, 'G3DSA:2.10.25.10:FF:001269', NULL, NULL, 'Laminin subunit alpha-1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(159533, NULL, 'G3DSA:3.30.460.10:FF:000017', NULL, NULL, 'Interleukin enhancer-binding factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(159534, NULL, 'G3DSA:3.30.200.20:FF:000182', NULL, NULL, 'PTI1-like tyrosine-protein kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(159535, NULL, 'G3DSA:2.120.10.30:FF:000409', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159536, NULL, 'G3DSA:3.40.50.1820:FF:000335', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(159537, NULL, 'G3DSA:3.30.1120.30:FF:000020', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(159538, NULL, 'G3DSA:1.25.10.10:FF:000934', NULL, NULL, 'Degreening related gene dee76 protein', NULL, NULL, NULL, NULL, NULL, 4),
(159539, NULL, 'G3DSA:1.20.1050.10:FF:000260', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(159540, NULL, 'G3DSA:1.25.40.10:FF:004494', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159541, NULL, 'G3DSA:3.60.60.10:FF:000025', NULL, NULL, 'N-acylsphingosine amidohydrolase (acid ceramidase) 1', NULL, NULL, NULL, NULL, NULL, 4),
(159542, NULL, 'G3DSA:3.50.50.60:FF:000422', NULL, NULL, 'Probable dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(159543, NULL, 'G3DSA:1.10.510.10:FF:001714', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(159544, NULL, 'G3DSA:2.60.120.650:FF:000059', NULL, NULL, 'Ecm5p', NULL, NULL, NULL, NULL, NULL, 4),
(159545, NULL, 'G3DSA:3.30.40.10:FF:001487', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159546, NULL, 'G3DSA:1.20.1050.10:FF:000304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159547, NULL, 'G3DSA:2.40.128.180:FF:000001', NULL, NULL, 'Fas apoptotic inhibitory molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(159548, NULL, 'G3DSA:1.20.1070.10:FF:000513', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(159549, NULL, 'G3DSA:3.30.430.20:FF:000002', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 10', NULL, NULL, NULL, NULL, NULL, 4),
(159550, NULL, 'G3DSA:3.10.350.10:FF:000025', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(159551, NULL, 'G3DSA:2.40.30.170:FF:000066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159552, NULL, 'G3DSA:3.40.630.10:FF:000248', NULL, NULL, 'Peptidase T', NULL, NULL, NULL, NULL, NULL, 4),
(159553, NULL, 'G3DSA:3.40.50.300:FF:004776', NULL, NULL, 'UPF1 regulator of nonsense transcripts homolog', NULL, NULL, NULL, NULL, NULL, 4),
(159554, NULL, 'G3DSA:2.40.50.140:FF:000281', NULL, NULL, '26S protease regulatory subunit S10B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(159555, NULL, 'G3DSA:3.90.1150.10:FF:000137', NULL, NULL, 'DegT/DnrJ/EryC1/StrS aminotransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(159556, NULL, 'G3DSA:2.20.28.120:FF:000014', NULL, NULL, '50S ribosomal protein L33', NULL, NULL, NULL, NULL, NULL, 4),
(159557, NULL, 'G3DSA:1.10.10.10:FF:000771', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(159558, NULL, 'G3DSA:2.60.40.10:FF:003320', NULL, NULL, 'CBN-SAX-3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(159559, NULL, 'G3DSA:1.25.40.10:FF:004168', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(159560, NULL, 'G3DSA:1.25.40.10:FF:000806', NULL, NULL, 'Os11g0114800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(159561, NULL, 'G3DSA:2.130.10.10:FF:002781', NULL, NULL, 'Protein TRANSPARENT TESTA GLABRA, putative', NULL, NULL, NULL, NULL, NULL, 4),
(159562, NULL, 'G3DSA:2.20.70.10:FF:000154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159563, NULL, 'G3DSA:1.20.58.60:FF:000350', NULL, NULL, 'Dystonin', NULL, NULL, NULL, NULL, NULL, 4),
(159564, NULL, 'G3DSA:3.40.50.1220:FF:000043', NULL, NULL, 'NAD-dependent protein deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(159565, NULL, 'G3DSA:3.40.50.1000:FF:000545', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159566, NULL, 'G3DSA:1.10.510.10:FF:000888', NULL, NULL, 'Mitogen-activated protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(159567, NULL, 'G3DSA:2.30.30.100:FF:000008', NULL, NULL, 'Small nuclear ribonucleoprotein Sm D1', NULL, NULL, NULL, NULL, NULL, 4),
(159568, NULL, 'G3DSA:1.25.40.20:FF:000809', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159569, NULL, 'G3DSA:3.30.1370.10:FF:000156', NULL, NULL, 'RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(159570, NULL, 'G3DSA:3.40.50.2000:FF:000053', NULL, NULL, 'Phosphatidylinositol N-acetylglucosaminyltransferase GPI3 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(159571, NULL, 'G3DSA:3.30.565.10:FF:000542', NULL, NULL, 'Hybrid signal transduction histidine kinase M', NULL, NULL, NULL, NULL, NULL, 4),
(159572, NULL, 'G3DSA:3.40.50.880:FF:000083', NULL, NULL, 'Imidazole glycerol phosphate synthase subunit HisH', NULL, NULL, NULL, NULL, NULL, 4),
(159573, NULL, 'G3DSA:1.20.210.10:FF:000026', NULL, NULL, 'Cytochrome c oxidase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(159574, NULL, 'G3DSA:2.60.40.790:FF:000194', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159575, NULL, 'G3DSA:1.20.120.1630:FF:000022', NULL, NULL, '15-cis-zeta-carotene isomerase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(159576, NULL, 'G3DSA:3.30.420.40:FF:000395', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(159577, NULL, 'G3DSA:3.40.350.10:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159578, NULL, 'G3DSA:1.10.150.60:FF:000015', NULL, NULL, 'AT-rich interactive domain-containing protein 5B', NULL, NULL, NULL, NULL, NULL, 4),
(159579, NULL, 'G3DSA:3.40.850.10:FF:000129', NULL, NULL, 'Dachs, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(159580, NULL, 'G3DSA:1.20.1070.10:FF:001941', NULL, NULL, 'Protein CBR-DOP-6', NULL, NULL, NULL, NULL, NULL, 4),
(159581, NULL, 'G3DSA:2.70.98.110:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159582, NULL, 'G3DSA:3.40.50.300:FF:008475', NULL, NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 8', NULL, NULL, NULL, NULL, NULL, 4),
(159583, NULL, 'G3DSA:3.40.50.2300:FF:000362', NULL, NULL, 'Probable metabotropic glutamate receptor mgl-1', NULL, NULL, NULL, NULL, NULL, 4),
(159584, NULL, 'G3DSA:3.30.160.60:FF:000998', NULL, NULL, 'Zinc finger protein 521', NULL, NULL, NULL, NULL, NULL, 4),
(159585, NULL, 'G3DSA:3.40.640.10:FF:000529', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159586, NULL, 'G3DSA:3.30.40.10:FF:002004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159587, NULL, 'G3DSA:3.40.50.300:FF:000398', NULL, NULL, 'Type IV pilus assembly ATPase PilB', NULL, NULL, NULL, NULL, NULL, 4),
(159588, NULL, 'G3DSA:3.40.50.1240:FF:000049', NULL, NULL, 'Acid phosphatase aph, 3-phytase phyB', NULL, NULL, NULL, NULL, NULL, 4),
(159589, NULL, 'G3DSA:2.60.40.820:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159590, NULL, 'G3DSA:2.120.10.80:FF:000273', NULL, NULL, 'F-box/LRR-repeat/kelch-repeat protein At1g09650', NULL, NULL, NULL, NULL, NULL, 4),
(159591, NULL, 'G3DSA:1.25.40.10:FF:003988', NULL, NULL, 'Mitochondrial ribosomal protein S27', NULL, NULL, NULL, NULL, NULL, 4),
(159592, NULL, 'G3DSA:3.20.20.100:FF:000016', NULL, NULL, '2,5-diketo-D-gluconic acid reductase B', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(159593, NULL, 'G3DSA:3.30.160.60:FF:004697', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159594, NULL, 'G3DSA:1.10.510.10:FF:003322', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159595, NULL, 'G3DSA:3.30.710.10:FF:000144', NULL, NULL, 'BTB/POZ domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(159596, NULL, 'G3DSA:1.20.1420.30:FF:000108', NULL, NULL, 'AGAP010974-PA', NULL, NULL, NULL, NULL, NULL, 4),
(159597, NULL, 'G3DSA:3.30.1230.20:FF:000003', NULL, NULL, '40S ribosomal protein S21', NULL, NULL, NULL, NULL, NULL, 4),
(159598, NULL, 'G3DSA:3.40.50.150:FF:000864', NULL, NULL, 'tRNA (adenine(58)-N(1))-methyltransferase TrmI', NULL, NULL, NULL, NULL, NULL, 4),
(159599, NULL, 'G3DSA:1.25.40.10:FF:005011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159600, NULL, 'G3DSA:2.20.100.10:FF:000250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159601, NULL, 'G3DSA:2.130.10.10:FF:002472', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 26', NULL, NULL, NULL, NULL, NULL, 4),
(159602, NULL, 'G3DSA:3.40.50.280:FF:000009', NULL, NULL, 'Methylmalonyl-CoA mutase small subunit mutA', NULL, NULL, NULL, NULL, NULL, 4),
(159603, NULL, 'G3DSA:1.25.10.10:FF:001114', NULL, NULL, 'Related to MAPKK kinase', NULL, NULL, NULL, NULL, NULL, 4),
(159604, NULL, 'G3DSA:1.20.1090.10:FF:000043', NULL, NULL, 'Putative iron alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(159605, NULL, 'G3DSA:3.40.50.300:FF:002859', NULL, NULL, 'putative pre-mRNA-splicing factor ATP-dependent RNA helicase DHX16 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(159606, NULL, 'G3DSA:3.80.10.10:FF:002421', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159607, NULL, 'G3DSA:1.10.40.30:FF:000020', NULL, NULL, 'Adenylosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(159608, NULL, 'G3DSA:1.20.1070.10:FF:000160', NULL, NULL, 'Related to Opsin-1', NULL, NULL, NULL, NULL, NULL, 4),
(159609, NULL, 'G3DSA:1.10.510.10:FF:000681', NULL, NULL, 'Muscle M-line assembly protein unc-89-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(159610, NULL, 'G3DSA:2.30.30.40:FF:000435', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159611, NULL, 'G3DSA:3.10.100.10:FF:000349', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159612, NULL, 'G3DSA:1.20.1560.10:FF:000051', NULL, NULL, 'ATP-binding cassette subfamily B member 11', NULL, NULL, NULL, NULL, NULL, 4),
(159613, NULL, 'G3DSA:3.20.180.20:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159614, NULL, 'G3DSA:3.30.260.10:FF:000036', NULL, NULL, '60 kDa heat shock protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(159615, NULL, 'G3DSA:2.10.110.10:FF:000034', NULL, NULL, 'Insulin gene enhancer protein ISL', NULL, NULL, NULL, NULL, NULL, 4),
(159616, NULL, 'G3DSA:2.40.70.10:FF:000361', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159617, NULL, 'G3DSA:3.30.70.330:FF:002184', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159618, NULL, 'G3DSA:3.40.190.10:FF:000590', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(159619, NULL, 'G3DSA:2.10.25.10:FF:001595', NULL, NULL, 'LOC553337 protein', NULL, NULL, NULL, NULL, NULL, 4),
(159620, NULL, 'G3DSA:3.30.710.10:FF:000453', NULL, NULL, 'Skp1 family, dimerisation domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(159621, NULL, 'G3DSA:1.20.1420.30:FF:000064', NULL, NULL, 'Sodium/potassium/calcium exchanger Nckx30C', NULL, NULL, NULL, NULL, NULL, 4),
(159622, NULL, 'G3DSA:1.10.510.10:FF:002507', NULL, NULL, 'Os02g0722250 protein', NULL, NULL, NULL, NULL, NULL, 4),
(159623, NULL, 'G3DSA:2.30.30.750:FF:000001', NULL, NULL, '5''-3'' exoribonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(159624, NULL, 'G3DSA:3.80.10.10:FF:004203', NULL, NULL, 'NLR family CARD domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(159625, NULL, 'G3DSA:1.10.238.10:FF:000772', NULL, NULL, 'Mitochondrial proton/calcium exchanger protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(159626, NULL, 'G3DSA:2.10.10.20:FF:000013', NULL, NULL, 'Lambda phage tail fiber protein J', NULL, NULL, NULL, NULL, NULL, 4),
(159627, NULL, 'G3DSA:1.20.120.1920:FF:000002', NULL, NULL, 'Ubiquitin-associated protein 1-like a', NULL, NULL, NULL, NULL, NULL, 4),
(159628, NULL, 'G3DSA:3.40.50.300:FF:008149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159629, NULL, 'G3DSA:2.40.100.10:FF:000173', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(159630, NULL, 'G3DSA:3.30.160.60:FF:001515', NULL, NULL, 'zinc finger protein 408', NULL, NULL, NULL, NULL, NULL, 4),
(159631, NULL, 'G3DSA:3.30.160.240:FF:000001', NULL, NULL, 'DUF1876 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(159632, NULL, 'G3DSA:3.40.50.720:FF:000821', NULL, NULL, 'Him1p', NULL, NULL, NULL, NULL, NULL, 4),
(159633, NULL, 'G3DSA:2.60.40.10:FF:001403', NULL, NULL, 'Sallimus, isoform U', NULL, NULL, NULL, NULL, NULL, 4),
(159634, NULL, 'G3DSA:3.90.79.10:FF:000168', NULL, NULL, 'Translation initiation factor eIF-2B subunit family protein (AFU_orthologue AFUA_2G14290)', NULL, NULL, NULL, NULL, NULL, 4),
(159635, NULL, 'G3DSA:1.10.238.10:FF:001261', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159636, NULL, 'G3DSA:3.40.390.10:FF:000212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159637, NULL, 'G3DSA:3.40.50.150:FF:001353', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159638, NULL, 'G3DSA:4.10.800.10:FF:000017', NULL, NULL, 'Thyroglobulin', NULL, NULL, NULL, NULL, NULL, 4),
(159639, NULL, 'G3DSA:2.10.10.10:FF:000010', NULL, NULL, 'Coagulation factor XII', NULL, NULL, NULL, NULL, NULL, 4),
(159640, NULL, 'G3DSA:3.10.660.10:FF:000009', NULL, NULL, 'DPH4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(159641, NULL, 'G3DSA:3.40.190.10:FF:000601', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(159642, NULL, 'G3DSA:3.40.50.300:FF:007064', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(159643, NULL, 'G3DSA:1.20.120.420:FF:000017', NULL, NULL, 'Putative methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(159644, NULL, 'G3DSA:1.25.40.20:FF:001271', NULL, NULL, 'Ankyrin repeat and KH domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(159645, NULL, 'G3DSA:3.30.70.330:FF:002228', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159646, NULL, 'G3DSA:1.10.510.10:FF:002816', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159647, NULL, 'G3DSA:1.25.40.10:FF:002370', NULL, NULL, 'Os01g0754700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(159648, NULL, 'G3DSA:3.40.50.300:FF:003332', NULL, NULL, 'Ras family gtpase', NULL, NULL, NULL, NULL, NULL, 4),
(159649, NULL, 'G3DSA:3.30.70.260:FF:000122', NULL, NULL, 'Putative acetolactate synthase small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(159650, NULL, 'G3DSA:2.130.10.10:FF:004579', NULL, NULL, 'Protein SLOW WALKER 1', NULL, NULL, NULL, NULL, NULL, 4),
(159651, NULL, 'G3DSA:2.130.10.10:FF:005113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159652, NULL, 'G3DSA:3.10.129.10:FF:000106', NULL, NULL, 'UPF0336 protein ERDMAN_0553', NULL, NULL, NULL, NULL, NULL, 4),
(159653, NULL, 'G3DSA:1.25.40.10:FF:002886', NULL, NULL, 'Protein NPGR2', NULL, NULL, NULL, NULL, NULL, 4),
(159654, NULL, 'G3DSA:1.10.10.60:FF:001016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159655, NULL, 'G3DSA:3.40.718.10:FF:000002', NULL, NULL, 'Isocitrate dehydrogenase [NADP]', NULL, NULL, NULL, NULL, NULL, 4),
(159656, NULL, 'G3DSA:3.40.50.1000:FF:000871', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159657, NULL, 'G3DSA:3.20.20.220:FF:000069', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(159658, NULL, 'G3DSA:3.40.50.2300:FF:000715', NULL, NULL, 'ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(159659, NULL, 'G3DSA:1.20.1250.20:FF:000261', NULL, NULL, 'NarK/NasA family nitrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(159660, NULL, 'G3DSA:3.50.30.30:FF:000041', NULL, NULL, 'Cell wall-associated serine proteinase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(159661, NULL, 'G3DSA:1.20.1270.250:FF:000001', NULL, NULL, 'Inhibitor of nuclear factor kappa-B kinase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(159662, NULL, 'G3DSA:3.80.20.20:FF:000098', NULL, NULL, 'Erb-b2 receptor tyrosine kinase 3a', NULL, NULL, NULL, NULL, NULL, 4),
(159663, NULL, 'G3DSA:1.25.40.530:FF:000019', NULL, NULL, 'Heavy chain, Unconventional Myosin', NULL, NULL, NULL, NULL, NULL, 4),
(159664, NULL, 'G3DSA:3.30.200.110:FF:000001', NULL, NULL, 'Inositol-pentakisphosphate 2-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(159665, NULL, 'G3DSA:3.30.70.2850:FF:000012', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(159666, NULL, 'G3DSA:3.90.550.50:FF:000186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159667, NULL, 'G3DSA:3.10.110.10:FF:000277', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(159668, NULL, 'G3DSA:3.30.70.270:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159669, NULL, 'G3DSA:3.90.25.10:FF:000004', NULL, NULL, 'ADP-L-glycero-D-manno-heptose-6-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(159670, NULL, 'G3DSA:3.80.10.10:FF:001932', NULL, NULL, 'Receptor-like protein 41', NULL, NULL, NULL, NULL, NULL, 4),
(159671, NULL, 'G3DSA:1.20.58.1380:FF:000001', NULL, NULL, 'Nuclear pore complex protein Nup133', NULL, NULL, NULL, NULL, NULL, 4),
(159672, NULL, 'G3DSA:2.60.40.1960:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159673, NULL, 'G3DSA:3.40.50.300:FF:001550', NULL, NULL, 'DEAD box DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(159674, NULL, 'G3DSA:1.25.40.10:FF:004831', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159675, NULL, 'G3DSA:2.60.40.1940:FF:000002', NULL, NULL, 'Alpha-2-macroglobulin', NULL, NULL, NULL, NULL, NULL, 4),
(159676, NULL, 'G3DSA:3.40.50.2300:FF:000036', NULL, NULL, 'D-ribose ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(159677, NULL, 'G3DSA:2.160.20.10:FF:000032', NULL, NULL, 'Pectin lyase-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(159678, NULL, 'G3DSA:3.90.70.10:FF:000648', NULL, NULL, 'Ubiquitin carboxylterminal hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(159679, NULL, 'G3DSA:2.60.40.60:FF:000805', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(159680, NULL, 'G3DSA:1.10.10.10:FF:000445', NULL, NULL, 'Response regulator transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(159681, NULL, 'G3DSA:1.25.40.90:FF:000066', NULL, NULL, 'VHS domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(159682, NULL, 'G3DSA:3.40.50.150:FF:001044', NULL, NULL, 'Leucine carboxyl methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(159683, NULL, 'G3DSA:3.40.190.10:FF:000910', NULL, NULL, 'ABC-type dipeptide transport system periplasmic component-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(159684, NULL, 'G3DSA:3.40.50.720:FF:001586', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] reductase (NADPH)', NULL, NULL, NULL, NULL, NULL, 4),
(159685, NULL, 'G3DSA:1.10.10.60:FF:000527', NULL, NULL, 'Zinc Finger and Homeobox', NULL, NULL, NULL, NULL, NULL, 4),
(159686, NULL, 'G3DSA:2.60.40.10:FF:002494', NULL, NULL, 'Uip4p', NULL, NULL, NULL, NULL, NULL, 4),
(159687, NULL, 'G3DSA:2.130.10.10:FF:000908', NULL, NULL, 'U3 small nucleolar RNA-associated protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(159688, NULL, 'G3DSA:2.60.40.150:FF:000367', NULL, NULL, 'Protein CBR-CED-5', NULL, NULL, NULL, NULL, NULL, 4),
(159689, NULL, 'G3DSA:2.60.40.150:FF:000676', NULL, NULL, 'Dedicator of cytokinesis 1', NULL, NULL, NULL, NULL, NULL, 4),
(159690, NULL, 'G3DSA:3.90.1310.10:FF:000009', NULL, NULL, 'Penicillin-binding protein transpeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(159691, NULL, 'G3DSA:2.30.42.10:FF:000543', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159692, NULL, 'G3DSA:2.40.50.140:FF:000634', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(159693, NULL, 'G3DSA:3.40.50.1820:FF:001746', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159694, NULL, 'G3DSA:1.10.287.10:FF:000020', NULL, NULL, 'Methionine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(159695, NULL, 'G3DSA:3.90.180.10:FF:000050', NULL, NULL, 'Unplaced genomic scaffold supercont2.5, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(159696, NULL, 'G3DSA:2.60.40.60:FF:000794', NULL, NULL, 'Desmocollin 3', NULL, NULL, NULL, NULL, NULL, 4),
(159697, NULL, 'G3DSA:2.30.42.10:FF:000173', NULL, NULL, 'whirlin isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(159698, NULL, 'G3DSA:3.30.160.60:FF:005540', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159699, NULL, 'G3DSA:1.10.12.10:FF:000022', NULL, NULL, 'Probable enoyl-CoA hydratase echA17', NULL, NULL, NULL, NULL, NULL, 4),
(159700, NULL, 'G3DSA:2.130.10.10:FF:000538', NULL, NULL, 'Peroxisomal targeting signal 2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(159701, NULL, 'G3DSA:3.40.50.300:FF:001241', NULL, NULL, 'Endonuclease MutS2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(159702, NULL, 'G3DSA:1.25.40.10:FF:005320', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159703, NULL, 'G3DSA:2.10.25.10:FF:001606', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159704, NULL, 'G3DSA:3.20.20.80:FF:000601', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159705, NULL, 'G3DSA:3.30.70.120:FF:000013', NULL, NULL, 'DUF190 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(159706, NULL, 'G3DSA:1.25.40.10:FF:004477', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(159707, NULL, 'G3DSA:3.30.300.110:FF:000001', NULL, NULL, 'tRNA (guanine(37)-N1)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(159708, NULL, 'G3DSA:3.10.450.10:FF:000089', NULL, NULL, 'Latexin', NULL, NULL, NULL, NULL, NULL, 4),
(159709, NULL, 'G3DSA:3.40.50.300:FF:001078', NULL, NULL, 'Elongator acetyltransferase complex subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(159710, NULL, 'G3DSA:3.30.160.60:FF:006288', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159711, NULL, 'G3DSA:2.60.40.2860:FF:000019', NULL, NULL, 'Cysteine-rich surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(159712, NULL, 'G3DSA:3.10.350.10:FF:000042', NULL, NULL, 'Muramidase (Invasin repeat family)', NULL, NULL, NULL, NULL, NULL, 4),
(159713, NULL, 'G3DSA:1.20.120.720:FF:000017', NULL, NULL, 'unconventional myosin-XV', NULL, NULL, NULL, NULL, NULL, 4),
(159714, NULL, 'G3DSA:3.30.530.20:FF:000066', NULL, NULL, 'Polyketide cyclase/dehydrase and lipid transport', NULL, NULL, NULL, NULL, NULL, 4),
(159715, NULL, 'G3DSA:1.20.930.20:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159716, NULL, 'G3DSA:3.30.200.20:FF:000491', NULL, NULL, 'Lectin-domain containing receptor kinase VI.3', NULL, NULL, NULL, NULL, NULL, 4),
(159717, NULL, 'G3DSA:2.20.70.10:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159718, NULL, 'G3DSA:2.30.30.100:FF:000025', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm7', NULL, NULL, NULL, NULL, NULL, 4),
(159719, NULL, 'G3DSA:3.30.70.330:FF:001110', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(159720, NULL, 'G3DSA:1.25.40.10:FF:003679', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g39680', NULL, NULL, NULL, NULL, NULL, 4),
(159721, NULL, 'G3DSA:3.30.160.60:FF:004388', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159722, NULL, 'G3DSA:3.40.50.150:FF:001027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159723, NULL, 'G3DSA:3.40.630.30:FF:000130', NULL, NULL, 'Putative ribosomal-protein-serine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(159724, NULL, 'G3DSA:3.50.50.60:FF:000085', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(159725, NULL, 'G3DSA:2.30.30.40:FF:000289', NULL, NULL, 'Rho guanine nucleotide exchange factor (GEF) 4', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(159726, NULL, 'G3DSA:3.30.420.140:FF:000008', NULL, NULL, 'Putative pre-16S rRNA nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(159727, NULL, 'G3DSA:2.70.70.10:FF:000073', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(159728, NULL, 'G3DSA:1.20.1310.10:FF:000196', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159729, NULL, 'G3DSA:3.40.50.2300:FF:000053', NULL, NULL, 'glutamate receptor ionotropic, NMDA 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(159730, NULL, 'G3DSA:1.10.10.60:FF:000853', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159731, NULL, 'G3DSA:3.80.10.10:FF:001578', NULL, NULL, 'Tubulin folding cofactor E', NULL, NULL, NULL, NULL, NULL, 4),
(159732, NULL, 'G3DSA:3.30.160.60:FF:003106', NULL, NULL, 'Zinc finger protein 991', NULL, NULL, NULL, NULL, NULL, 4),
(159733, NULL, 'G3DSA:1.20.5.190:FF:000157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159734, NULL, 'G3DSA:3.30.780.10:FF:000064', NULL, NULL, 'Eukaryotic translation initiation factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(159735, NULL, 'G3DSA:3.40.190.290:FF:000071', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(159736, NULL, 'G3DSA:3.30.160.60:FF:002589', NULL, NULL, 'J protein JJJ1', NULL, NULL, NULL, NULL, NULL, 4),
(159737, NULL, 'G3DSA:6.20.10.30:FF:000012', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(159738, NULL, 'G3DSA:3.80.10.10:FF:002051', NULL, NULL, 'Os02g0553000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(159739, NULL, 'G3DSA:3.30.50.10:FF:000150', NULL, NULL, 'GATAa protein', NULL, NULL, NULL, NULL, NULL, 4),
(159740, NULL, 'G3DSA:2.60.490.10:FF:000022', NULL, NULL, 'p2X purinoceptor,putative', NULL, NULL, NULL, NULL, NULL, 4),
(159741, NULL, 'G3DSA:2.60.40.60:FF:000777', NULL, NULL, 'Novel protein similar to vertebrate cadherin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(159742, NULL, 'G3DSA:1.25.40.10:FF:002577', NULL, NULL, 'Pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(159743, NULL, 'G3DSA:2.60.40.150:FF:000693', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159744, NULL, 'G3DSA:3.40.50.720:FF:001895', NULL, NULL, 'Pyrroline-5-carboxylate reductase, flame shift', NULL, NULL, NULL, NULL, NULL, 4),
(159745, NULL, 'G3DSA:3.20.20.70:FF:000857', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159746, NULL, 'G3DSA:2.30.29.30:FF:000541', NULL, NULL, 'CRE-MIG-10 protein', NULL, NULL, NULL, NULL, NULL, 4),
(159747, NULL, 'G3DSA:3.30.710.10:FF:000127', NULL, NULL, 'Suppressor of kinetochore protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(159748, NULL, 'G3DSA:3.20.20.100:FF:000033', NULL, NULL, 'Aldo/keto reductase', NULL, NULL, NULL, NULL, NULL, 4),
(159749, NULL, 'G3DSA:2.130.10.10:FF:004933', NULL, NULL, 'WD-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(159750, NULL, 'G3DSA:2.60.40.2030:FF:000035', NULL, NULL, 'Fraser extracellular matrix complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(159751, NULL, 'G3DSA:3.30.1560.10:FF:000002', NULL, NULL, 'Protein mago nashi homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(159752, NULL, 'G3DSA:3.90.226.10:FF:000179', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(159753, NULL, 'G3DSA:3.90.550.50:FF:000214', NULL, NULL, 'Beta-1,3-galactosyltransferase pvg3', NULL, NULL, NULL, NULL, NULL, 4),
(159754, NULL, 'G3DSA:3.40.190.10:FF:000573', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(159755, NULL, 'G3DSA:2.60.40.10:FF:005102', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159756, NULL, 'G3DSA:2.120.10.30:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159757, NULL, 'G3DSA:3.55.50.30:FF:000021', NULL, NULL, 'Putative anti-sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(159758, NULL, 'G3DSA:3.90.190.10:FF:000522', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159759, NULL, 'G3DSA:3.40.50.1110:FF:000010', NULL, NULL, 'Putative rhamnogalacturonan acetylesterase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(159760, NULL, 'G3DSA:3.30.230.70:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159761, NULL, 'G3DSA:1.10.340.70:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159762, NULL, 'G3DSA:3.40.190.10:FF:000247', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(159763, NULL, 'G3DSA:3.40.50.1100:FF:000249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159764, NULL, 'G3DSA:3.40.50.10490:FF:000052', NULL, NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', NULL, NULL, NULL, NULL, NULL, 4),
(159765, NULL, 'G3DSA:3.30.160.60:FF:002943', NULL, NULL, 'AT-rich binding protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(159766, NULL, 'G3DSA:1.20.1250.20:FF:001879', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159767, NULL, 'G3DSA:1.20.1250.20:FF:002161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159768, NULL, 'G3DSA:1.20.120.1750:FF:000058', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(159769, NULL, 'G3DSA:2.30.30.30:FF:000106', NULL, NULL, 'Ribosomal protein L14, putative', NULL, NULL, NULL, NULL, NULL, 4),
(159770, NULL, 'G3DSA:2.60.40.420:FF:000032', NULL, NULL, 'Coagulation factor VIII (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(159771, NULL, 'G3DSA:3.40.50.720:FF:002412', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159772, NULL, 'G3DSA:2.40.70.10:FF:000568', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159773, NULL, 'G3DSA:3.60.20.10:FF:000051', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(159774, NULL, 'G3DSA:3.80.10.10:FF:000151', NULL, NULL, 'Lumican', NULL, NULL, NULL, NULL, NULL, 4),
(159775, NULL, 'G3DSA:2.90.10.30:FF:000001', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(159776, NULL, 'G3DSA:3.40.50.300:FF:006693', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159777, NULL, 'G3DSA:2.60.40.10:FF:003174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159778, NULL, 'G3DSA:2.40.160.10:FF:000047', NULL, NULL, 'Translocase of outer mitochondrial membrane', NULL, NULL, NULL, NULL, NULL, 4),
(159779, NULL, 'G3DSA:3.30.160.60:FF:004843', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159780, NULL, 'G3DSA:1.10.10.10:FF:001260', NULL, NULL, 'RNI-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(159781, NULL, 'G3DSA:2.30.42.10:FF:000217', NULL, NULL, 'PDZ domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(159782, NULL, 'G3DSA:3.30.160.60:FF:000689', NULL, NULL, 'Spalt like transcription factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(159783, NULL, 'G3DSA:2.130.10.10:FF:001061', NULL, NULL, 'Type I inositol polyphosphate 5-phosphatase 13', NULL, NULL, NULL, NULL, NULL, 4),
(159784, NULL, 'G3DSA:3.40.50.10090:FF:000022', NULL, NULL, 'Uroporphyrinogen-III synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(159785, NULL, 'G3DSA:3.30.300.130:FF:000007', NULL, NULL, 'Cytoplasmic protein required for cell viability', NULL, NULL, NULL, NULL, NULL, 4),
(159786, NULL, 'G3DSA:2.60.40.10:FF:001050', NULL, NULL, 'MER proto-oncogene, tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(159787, NULL, 'G3DSA:2.130.10.10:FF:001370', NULL, NULL, 'Protein SOF1', NULL, NULL, NULL, NULL, NULL, 4),
(159788, NULL, 'G3DSA:3.10.450.220:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159789, NULL, 'G3DSA:1.10.630.10:FF:000060', NULL, NULL, 'Cytochrome P450 family 39 subfamily A member 1', NULL, NULL, NULL, NULL, NULL, 4),
(159790, NULL, 'G3DSA:2.60.440.10:FF:000002', NULL, NULL, 'Cell division protein ZapD', NULL, NULL, NULL, NULL, NULL, 4),
(159791, NULL, 'G3DSA:3.40.50.720:FF:000512', NULL, NULL, 'Acetyl coenzyme A synthetase (ADP forming), alpha domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(159792, NULL, 'G3DSA:3.90.550.10:FF:000668', NULL, NULL, 'Glycosyltransferases', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(159793, NULL, 'G3DSA:4.10.860.10:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159794, NULL, 'G3DSA:3.40.50.410:FF:000037', NULL, NULL, 'Collagen type VI alpha 3 chain', NULL, NULL, NULL, NULL, NULL, 4),
(159795, NULL, 'G3DSA:1.10.287.520:FF:000004', NULL, NULL, 'Noggin', NULL, NULL, NULL, NULL, NULL, 4),
(159796, NULL, 'G3DSA:3.40.50.670:FF:000019', NULL, NULL, 'Topoisomerase II large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(159797, NULL, 'G3DSA:1.10.510.10:FF:001405', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(159798, NULL, 'G3DSA:3.90.550.10:FF:000753', NULL, NULL, 'Galactosylgalactosylxylosylprotein 3-beta-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(159799, NULL, 'G3DSA:3.90.1150.10:FF:000154', NULL, NULL, 'Putative ornithine aminotransferase RocD1', NULL, NULL, NULL, NULL, NULL, 4),
(159800, NULL, 'G3DSA:1.10.443.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159801, NULL, 'G3DSA:1.10.10.750:FF:000033', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(159802, NULL, 'G3DSA:3.40.50.2000:FF:000732', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159803, NULL, 'G3DSA:1.10.940.10:FF:000027', NULL, NULL, 'Transcription antitermination protein NusB', NULL, NULL, NULL, NULL, NULL, 4),
(159804, NULL, 'G3DSA:3.30.1120.30:FF:000003', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(159805, NULL, 'G3DSA:3.40.50.300:FF:006558', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159806, NULL, 'G3DSA:3.30.559.10:FF:000112', NULL, NULL, 'Trichothecene 3-O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(159807, NULL, 'G3DSA:1.10.287.510:FF:000001', NULL, NULL, 'RAD50 homolog, double strand break repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(159808, NULL, 'G3DSA:3.50.50.60:FF:000731', NULL, NULL, 'Oleate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(159809, NULL, 'G3DSA:2.70.150.10:FF:000186', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(159810, NULL, 'G3DSA:1.10.760.10:FF:000064', NULL, NULL, 'Probable cytochrome c', NULL, NULL, NULL, NULL, NULL, 4),
(159811, NULL, 'G3DSA:3.30.70.120:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159812, NULL, 'G3DSA:2.30.36.70:FF:000024', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(159813, NULL, 'G3DSA:2.30.29.30:FF:000215', NULL, NULL, 'Oxysterol-binding protein-related protein 1C', NULL, NULL, NULL, NULL, NULL, 4),
(159814, NULL, 'G3DSA:3.40.50.300:FF:007047', NULL, NULL, 'Signal recognition particle receptor subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(159815, NULL, 'G3DSA:2.130.10.10:FF:000864', NULL, NULL, 'U4/U6 small nuclear ribonucleoprotein PRP4', NULL, NULL, NULL, NULL, NULL, 4),
(159816, NULL, 'G3DSA:1.50.10.20:FF:000070', NULL, NULL, 'Mannan endo-1,6-alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(159817, NULL, 'G3DSA:3.40.50.720:FF:001923', NULL, NULL, 'NAD(P)H-dependent anabolic L-arginine dehydrogenase DauB', NULL, NULL, NULL, NULL, NULL, 4),
(159818, NULL, 'G3DSA:3.40.50.620:FF:000600', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(159819, NULL, 'G3DSA:1.10.10.60:FF:001033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159820, NULL, 'G3DSA:3.90.1310.10:FF:000026', NULL, NULL, 'Penicillin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(159821, NULL, 'G3DSA:3.30.1010.10:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159822, NULL, 'G3DSA:3.30.160.60:FF:003432', NULL, NULL, 'Zinc finger protein 561', NULL, NULL, NULL, NULL, NULL, 4),
(159823, NULL, 'G3DSA:2.130.10.110:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159824, NULL, 'G3DSA:3.30.160.60:FF:002926', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159825, NULL, 'G3DSA:1.20.58.60:FF:000333', NULL, NULL, 'SMAll', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(159826, NULL, 'G3DSA:3.30.70.270:FF:000260', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159827, NULL, 'G3DSA:2.60.120.200:FF:000301', NULL, NULL, 'Protein EMP47', NULL, NULL, NULL, NULL, NULL, 4),
(159828, NULL, 'G3DSA:3.90.550.50:FF:000169', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(159829, NULL, 'G3DSA:1.20.120.1750:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159830, NULL, 'G3DSA:3.30.750.24:FF:000008', NULL, NULL, 'Sulfate transporter YchM', NULL, NULL, NULL, NULL, NULL, 4),
(159831, NULL, 'G3DSA:3.40.50.300:FF:001533', NULL, NULL, 'ABC transporter G family member 11', NULL, NULL, NULL, NULL, NULL, 4),
(159832, NULL, 'G3DSA:1.20.900.10:FF:000062', NULL, NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(159833, NULL, 'G3DSA:3.90.190.10:FF:000213', NULL, NULL, 'Receptor tyrosine phosphatase type r2b, putative', NULL, NULL, NULL, NULL, NULL, 4),
(159834, NULL, 'G3DSA:3.40.50.720:FF:000158', NULL, NULL, 'Zinc-binding alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(159835, NULL, 'G3DSA:3.90.320.10:FF:000022', NULL, NULL, 'Mitochondrial genome maintenance exonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(159836, NULL, 'G3DSA:3.40.1260.10:FF:000005', NULL, NULL, 'Sulfur relay protein DsrH', NULL, NULL, NULL, NULL, NULL, 4),
(159837, NULL, 'G3DSA:3.90.226.10:FF:000281', NULL, NULL, 'Enoyl-CoA hydratase, probable', NULL, NULL, NULL, NULL, NULL, 4),
(159838, NULL, 'G3DSA:3.40.640.10:FF:000237', NULL, NULL, 'Methionine S-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(159839, NULL, 'G3DSA:1.10.3720.10:FF:000196', NULL, NULL, 'ABC-type transport system, permease protein, involved in antimicrobial peptide resistance', NULL, NULL, NULL, NULL, NULL, 4),
(159840, NULL, 'G3DSA:1.10.10.350:FF:000020', NULL, NULL, 'Glutamate--tRNA ligase 1', NULL, NULL, NULL, NULL, NULL, 4),
(159841, NULL, 'G3DSA:2.40.10.10:FF:000694', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159842, NULL, 'G3DSA:1.10.490.10:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159843, NULL, 'G3DSA:2.60.120.200:FF:000610', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159844, NULL, 'G3DSA:1.20.210.10:FF:000009', NULL, NULL, 'Cytochrome c oxidase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(159845, NULL, 'G3DSA:3.60.10.10:FF:000123', NULL, NULL, 'RNA exonuclease NGL2', NULL, NULL, NULL, NULL, NULL, 4),
(159846, NULL, 'G3DSA:3.40.50.300:FF:001224', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(159847, NULL, 'G3DSA:2.130.10.10:FF:001353', NULL, NULL, 'WGS project CABT00000000 data, contig 2.19', NULL, NULL, NULL, NULL, NULL, 4),
(159848, NULL, 'G3DSA:3.10.20.320:FF:000005', NULL, NULL, 'LPXTG cell wall anchor domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(159849, NULL, 'G3DSA:2.130.10.10:FF:000555', NULL, NULL, 'Dmx like 2', NULL, NULL, NULL, NULL, NULL, 4),
(159850, NULL, 'G3DSA:2.60.40.150:FF:000384', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159851, NULL, 'G3DSA:3.30.200.20:FF:002289', NULL, NULL, 'CDPK-related kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(159852, NULL, 'G3DSA:1.20.120.1760:FF:000078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159853, NULL, 'G3DSA:1.10.730.10:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159854, NULL, 'G3DSA:2.40.50.90:FF:000102', NULL, NULL, 'Nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(159855, NULL, 'G3DSA:1.10.630.10:FF:000352', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159856, NULL, 'G3DSA:1.10.10.60:FF:000544', NULL, NULL, 'Cell division control protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(159857, NULL, 'G3DSA:2.40.50.140:FF:000308', NULL, NULL, 'Possible replication factor-a protein', NULL, NULL, NULL, NULL, NULL, 4),
(159858, NULL, 'G3DSA:2.120.10.80:FF:000256', NULL, NULL, 'Kelch domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(159859, NULL, 'G3DSA:2.30.30.1150:FF:000008', NULL, NULL, 'PHD finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(159860, NULL, 'G3DSA:2.30.42.10:FF:000190', NULL, NULL, 'Uncharacterized protein, isoform K', NULL, NULL, NULL, NULL, NULL, 4),
(159861, NULL, 'G3DSA:2.60.40.1660:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159862, NULL, 'G3DSA:2.30.42.10:FF:000526', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159863, NULL, 'G3DSA:3.40.190.10:FF:000882', NULL, NULL, 'AGAP008759-PA', NULL, NULL, NULL, NULL, NULL, 4),
(159864, NULL, 'G3DSA:1.10.10.820:FF:000015', NULL, NULL, 'Myosin IG', NULL, NULL, NULL, NULL, NULL, 4),
(159865, NULL, 'G3DSA:2.40.390.10:FF:000002', NULL, NULL, 'ACR027Cp', NULL, NULL, NULL, NULL, NULL, 4),
(159866, NULL, 'G3DSA:2.70.150.10:FF:000169', NULL, NULL, 'Cu(2+)-transporting P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(159867, NULL, 'G3DSA:3.90.1150.210:FF:000016', NULL, NULL, 'F-actin-capping protein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(159868, NULL, 'G3DSA:3.30.160.60:FF:000791', NULL, NULL, 'B-cell CLL/lymphoma 6, member B', NULL, NULL, NULL, NULL, NULL, 4),
(159869, NULL, 'G3DSA:3.40.50.300:FF:005147', NULL, NULL, 'Atlastin-2', NULL, NULL, NULL, NULL, NULL, 4),
(159870, NULL, 'G3DSA:3.40.140.10:FF:000199', NULL, NULL, 'Cytidine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(159871, NULL, 'G3DSA:1.20.5.170:FF:000016', NULL, NULL, 'MAF bZIP transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(159872, NULL, 'G3DSA:1.10.1650.10:FF:000004', NULL, NULL, '50S ribosomal protein L19e', NULL, NULL, NULL, NULL, NULL, 4),
(159873, NULL, 'G3DSA:3.40.50.150:FF:000847', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159874, NULL, 'G3DSA:3.40.1130.10:FF:000001', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase (NAD(P)(+))', NULL, NULL, NULL, NULL, NULL, 4),
(159875, NULL, 'G3DSA:1.10.238.10:FF:001126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159876, NULL, 'G3DSA:2.130.10.10:FF:005405', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159877, NULL, 'G3DSA:3.40.1360.10:FF:000069', NULL, NULL, 'Spo11/DNA topoisomerase VI, subunit A protein', NULL, NULL, NULL, NULL, NULL, 4),
(159878, NULL, 'G3DSA:1.20.1070.10:FF:001587', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159879, NULL, 'G3DSA:3.30.70.141:FF:000003', NULL, NULL, 'Nucleoside diphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(159880, NULL, 'G3DSA:1.20.58.70:FF:000027', NULL, NULL, 'Putative syntaxin-3', NULL, NULL, NULL, NULL, NULL, 4),
(159881, NULL, 'G3DSA:1.10.287.70:FF:000240', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(159882, NULL, 'G3DSA:1.20.1420.30:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159883, NULL, 'G3DSA:3.10.25.10:FF:000019', NULL, NULL, 'Methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(159884, NULL, 'G3DSA:3.20.180.20:FF:000029', NULL, NULL, 'Flagellar outer dynein arm heavy chain alpha', NULL, NULL, NULL, NULL, NULL, 4),
(159885, NULL, 'G3DSA:3.40.50.1820:FF:000009', NULL, NULL, 'NDRG family member 4', NULL, NULL, NULL, NULL, NULL, 4),
(159886, NULL, 'G3DSA:3.30.160.60:FF:004517', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159887, NULL, 'G3DSA:2.130.10.10:FF:004607', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159888, NULL, 'G3DSA:2.170.8.10:FF:000008', NULL, NULL, 'Phosphoenolpyruvate carboxykinase (ATP), glycosomal', NULL, NULL, NULL, NULL, NULL, 4),
(159889, NULL, 'G3DSA:3.40.50.720:FF:001569', NULL, NULL, 'Short chain dehydrogenase/reductase, putative (AFU_orthologue AFUA_7G00840)', NULL, NULL, NULL, NULL, NULL, 4),
(159890, NULL, 'G3DSA:2.10.25.10:FF:001578', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159891, NULL, 'G3DSA:2.60.40.10:FF:000695', NULL, NULL, 'Plexin A2', NULL, NULL, NULL, NULL, NULL, 4),
(159892, NULL, 'G3DSA:1.20.1740.10:FF:000014', NULL, NULL, 'Putrescine transporter PotE', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(159893, NULL, 'G3DSA:1.20.970.10:FF:000010', NULL, NULL, 'Anthranilate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(159894, NULL, 'G3DSA:3.90.1150.10:FF:000480', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159895, NULL, 'G3DSA:2.60.120.650:FF:000161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159896, NULL, 'G3DSA:2.130.10.10:FF:004916', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159897, NULL, 'G3DSA:3.40.50.1820:FF:000318', NULL, NULL, 'Probable lysophospholipase BODYGUARD 1', NULL, NULL, NULL, NULL, NULL, 4),
(159898, NULL, 'G3DSA:3.30.1330.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159899, NULL, 'G3DSA:1.20.910.10:FF:000017', NULL, NULL, 'Heme oxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(159900, NULL, 'G3DSA:2.40.10.340:FF:000012', NULL, NULL, 'Cell shape-determining protein MreC', NULL, NULL, NULL, NULL, NULL, 4),
(159901, NULL, 'G3DSA:1.10.10.10:FF:000669', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(159902, NULL, 'G3DSA:2.40.50.140:FF:000179', NULL, NULL, 'rRNA biogenesis protein RRP5', NULL, NULL, NULL, NULL, NULL, 4),
(159903, NULL, 'G3DSA:3.90.360.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159904, NULL, 'G3DSA:2.40.10.350:FF:000015', NULL, NULL, 'Cell shape-determining protein MreC', NULL, NULL, NULL, NULL, NULL, 4),
(159905, NULL, 'G3DSA:3.30.200.20:FF:000389', NULL, NULL, 'Receptor-like cytosolic serine/threonine-protein kinase RBK1', NULL, NULL, NULL, NULL, NULL, 4),
(159906, NULL, 'G3DSA:3.40.50.300:FF:007401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159907, NULL, 'G3DSA:2.130.10.10:FF:002455', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159908, NULL, 'G3DSA:1.20.58.60:FF:000024', NULL, NULL, 'Kalirin RhoGEF kinase a', NULL, NULL, NULL, NULL, NULL, 4),
(159909, NULL, 'G3DSA:3.50.4.10:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159910, NULL, 'G3DSA:3.40.190.10:FF:000556', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(159911, NULL, 'G3DSA:2.60.120.200:FF:000155', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(159912, NULL, 'G3DSA:1.25.40.20:FF:000574', NULL, NULL, 'I Kappa B homolog', NULL, NULL, NULL, NULL, NULL, 4),
(159913, NULL, 'G3DSA:1.20.5.470:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159914, NULL, 'G3DSA:3.50.50.60:FF:000613', NULL, NULL, 'Salicylate hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(159915, NULL, 'G3DSA:3.90.180.10:FF:000033', NULL, NULL, 'Quinone oxidoreductase PIG3', NULL, NULL, NULL, NULL, NULL, 4),
(159916, NULL, 'G3DSA:3.40.50.11660:FF:000015', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(159917, NULL, 'G3DSA:1.20.1080.10:FF:000087', NULL, NULL, 'MIP aquaporin (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(159918, NULL, 'G3DSA:3.80.10.10:FF:001887', NULL, NULL, 'Si:ch211-156p11.1', NULL, NULL, NULL, NULL, NULL, 4),
(159919, NULL, 'G3DSA:3.20.20.140:FF:000112', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(159920, NULL, 'G3DSA:3.20.20.190:FF:000020', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(159921, NULL, 'G3DSA:3.80.10.10:FF:003495', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(159922, NULL, 'G3DSA:3.30.450.40:FF:000088', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(159923, NULL, 'G3DSA:1.25.40.10:FF:004359', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159924, NULL, 'G3DSA:1.20.1530.20:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159925, NULL, 'G3DSA:3.60.10.10:FF:000331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159926, NULL, 'G3DSA:3.40.50.300:FF:004967', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(159927, NULL, 'G3DSA:1.25.10.10:FF:002766', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159928, NULL, 'G3DSA:3.30.70.330:FF:000076', NULL, NULL, 'Synaptojanin-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(159929, NULL, 'G3DSA:3.30.470.30:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159930, NULL, 'G3DSA:1.25.40.120:FF:000003', NULL, NULL, 'Protein prenyltransferase alpha subunit repeat containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(159931, NULL, 'G3DSA:1.20.1270.60:FF:000240', NULL, NULL, 'rho GTPase-activating protein 17 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(159932, NULL, 'G3DSA:2.30.29.170:FF:000004', NULL, NULL, 'EF-hand domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(159933, NULL, 'G3DSA:3.30.390.80:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159934, NULL, 'G3DSA:3.40.50.720:FF:001777', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(159935, NULL, 'G3DSA:1.10.287.1770:FF:000009', NULL, NULL, 'Ferrous iron transport protein B', NULL, NULL, NULL, NULL, NULL, 4),
(159936, NULL, 'G3DSA:3.30.200.20:FF:000417', NULL, NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 64', NULL, NULL, NULL, NULL, NULL, 4),
(159937, NULL, 'G3DSA:3.90.1150.10:FF:000272', NULL, NULL, 'Uncharacterized HTH-type transcriptional regulator YdfD', NULL, NULL, NULL, NULL, NULL, 4),
(159938, NULL, 'G3DSA:1.10.1040.10:FF:000036', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(159939, NULL, 'G3DSA:3.40.50.300:FF:000589', NULL, NULL, 'ABC transporter, ATP-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(159940, NULL, 'G3DSA:3.90.930.12:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159941, NULL, 'G3DSA:1.25.10.10:FF:003340', NULL, NULL, 'Condensin-2 complex subunit D3', NULL, NULL, NULL, NULL, NULL, 4),
(159942, NULL, 'G3DSA:1.20.58.60:FF:000541', NULL, NULL, 'Nesprin-1', NULL, NULL, NULL, NULL, NULL, 4),
(159943, NULL, 'G3DSA:3.90.190.10:FF:000005', NULL, NULL, 'receptor-type tyrosine-protein phosphatase kappa isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(159944, NULL, 'G3DSA:3.40.50.1000:FF:000399', NULL, NULL, 'GD13364', NULL, NULL, NULL, NULL, NULL, 4),
(159945, NULL, 'G3DSA:3.30.70.2460:FF:000002', NULL, NULL, 'DNA repair protein RAD34', NULL, NULL, NULL, NULL, NULL, 4),
(159946, NULL, 'G3DSA:3.30.40.10:FF:000104', NULL, NULL, 'Ankyrin repeat and FYVE domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(159947, NULL, 'G3DSA:2.60.120.10:FF:000658', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159948, NULL, 'G3DSA:3.40.390.10:FF:000228', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159949, NULL, 'G3DSA:3.30.40.10:FF:000205', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(159950, NULL, 'G3DSA:4.10.860.10:FF:000009', NULL, NULL, 'UvrABC system protein B', NULL, NULL, NULL, NULL, NULL, 4),
(159951, NULL, 'G3DSA:3.40.50.300:FF:002197', NULL, NULL, 'ATP-dependent DNA helicase UvrD', NULL, NULL, NULL, NULL, NULL, 4),
(159952, NULL, 'G3DSA:3.40.50.300:FF:002298', NULL, NULL, 'Type IV secretion system protein VirB11', NULL, NULL, NULL, NULL, NULL, 4),
(159953, NULL, 'G3DSA:3.30.60.20:FF:000108', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(159954, NULL, 'G3DSA:3.30.40.10:FF:000093', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(159955, NULL, 'G3DSA:2.60.40.10:FF:000914', NULL, NULL, 'E3 ubiquitin-protein ligase Trim36', NULL, NULL, NULL, NULL, NULL, 4),
(159956, NULL, 'G3DSA:2.30.30.100:FF:000143', NULL, NULL, 'Ssm4 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(159957, NULL, 'G3DSA:3.30.450.20:FF:000082', NULL, NULL, 'sigma-54-dependent Fis family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(159958, NULL, 'G3DSA:3.40.5.10:FF:000012', NULL, NULL, 'Mitochondrial ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(159959, NULL, 'G3DSA:1.10.472.10:FF:000670', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(159960, NULL, 'G3DSA:1.25.40.10:FF:000571', NULL, NULL, 'Aspartyl beta-hydroxylase, isoform L', NULL, NULL, NULL, NULL, NULL, 4),
(159961, NULL, 'G3DSA:3.40.190.170:FF:000017', NULL, NULL, 'TRAP-type C4-dicarboxylate transport system, substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(159962, NULL, 'G3DSA:1.10.150.20:FF:000245', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(159963, NULL, 'G3DSA:3.55.50.20:FF:000001', NULL, NULL, 'Phage baseplate hub subunit', NULL, NULL, NULL, NULL, NULL, 4),
(159964, NULL, 'G3DSA:3.30.160.60:FF:001280', NULL, NULL, 'Zinc finger protein 771', NULL, NULL, NULL, NULL, NULL, 4),
(159965, NULL, 'G3DSA:3.10.310.10:FF:000051', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(159966, NULL, 'G3DSA:1.10.150.120:FF:000014', NULL, NULL, 'Xanthine DeHydrogenase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(159967, NULL, 'G3DSA:3.30.450.30:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159968, NULL, 'G3DSA:3.30.230.10:FF:000017', NULL, NULL, 'Galactokinase', NULL, NULL, NULL, NULL, NULL, 4),
(159969, NULL, 'G3DSA:1.10.238.10:FF:000738', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(159970, NULL, 'G3DSA:3.80.10.10:FF:002612', NULL, NULL, 'Dynein regulatory complex subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(159971, NULL, 'G3DSA:1.25.40.10:FF:002706', NULL, NULL, 'rRNA processing protein Utp6, putative', NULL, NULL, NULL, NULL, NULL, 4),
(159972, NULL, 'G3DSA:2.60.40.2030:FF:000018', NULL, NULL, 'Fras1-related extracellular matrix protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(159973, NULL, 'G3DSA:3.50.50.60:FF:001220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159974, NULL, 'G3DSA:3.30.450.40:FF:000189', NULL, NULL, 'ATP-binding region ATPase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(159975, NULL, 'G3DSA:3.30.160.60:FF:002797', NULL, NULL, 'Zinc finger protein 613', NULL, NULL, NULL, NULL, NULL, 4),
(159976, NULL, 'G3DSA:1.10.1670.10:FF:000067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159977, NULL, 'G3DSA:3.30.160.60:FF:003415', NULL, NULL, 'GD16884', NULL, NULL, NULL, NULL, NULL, 4),
(159978, NULL, 'G3DSA:3.30.2010.10:FF:000017', NULL, NULL, 'CAAX prenyl protease', NULL, NULL, NULL, NULL, NULL, 4),
(159979, NULL, 'G3DSA:1.20.990.10:FF:000011', NULL, NULL, 'Bifunctional cytochrome P450/NADPH--P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(159980, NULL, 'G3DSA:2.60.120.260:FF:000167', NULL, NULL, 'Transient receptor potential cation channel subfamily C member 2 (pseudogene)', NULL, NULL, NULL, NULL, NULL, 4),
(159981, NULL, 'G3DSA:3.30.420.10:FF:000251', NULL, NULL, 'Transposon Ty4-P Gag-Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(159982, NULL, 'G3DSA:2.40.50.90:FF:000074', NULL, NULL, 'Tudor domain containing 6', NULL, NULL, NULL, NULL, NULL, 4),
(159983, NULL, 'G3DSA:3.40.50.150:FF:000881', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159984, NULL, 'G3DSA:1.20.58.1480:FF:000031', NULL, NULL, 'Lon protease homolog 2 peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(159985, NULL, 'G3DSA:2.130.10.10:FF:000881', NULL, NULL, 'Mitochondrial division protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(159986, NULL, 'G3DSA:1.25.10.10:FF:000479', NULL, NULL, 'Transportin', NULL, NULL, NULL, NULL, NULL, 4),
(159987, NULL, 'G3DSA:3.30.450.20:FF:000183', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(159988, NULL, 'G3DSA:3.30.870.10:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(159989, NULL, 'G3DSA:2.160.10.10:FF:000076', NULL, NULL, 'Serine acetyltransferase 3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(159990, NULL, 'G3DSA:3.10.100.10:FF:000350', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159991, NULL, 'G3DSA:1.20.1560.10:FF:000034', NULL, NULL, 'Putative ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(159992, NULL, 'G3DSA:1.10.8.10:FF:000320', NULL, NULL, 'Ubiquitin family protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(159993, NULL, 'G3DSA:1.10.150.130:FF:000017', NULL, NULL, 'Prophage lambda integrase', NULL, NULL, NULL, NULL, NULL, 4),
(159994, NULL, 'G3DSA:1.20.1050.10:FF:000158', NULL, NULL, 'Hematopoietic prostaglandin D synthase', NULL, NULL, NULL, NULL, NULL, 4),
(159995, NULL, 'G3DSA:2.30.29.30:FF:000232', NULL, NULL, 'Bardet-Biedl syndrome 5 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(159996, NULL, 'G3DSA:3.40.50.720:FF:002283', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(159997, NULL, 'G3DSA:3.40.50.150:FF:001235', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(159998, NULL, 'G3DSA:3.30.465.10:FF:000040', NULL, NULL, 'Putative HlyC/CorC family of transporters with 2 CBS domains', NULL, NULL, NULL, NULL, NULL, 4),
(159999, NULL, 'G3DSA:2.10.110.10:FF:000258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160000, NULL, 'G3DSA:2.60.40.10:FF:001420', NULL, NULL, 'Exo-1,4-beta-xylosidase xlnD', NULL, NULL, NULL, NULL, NULL, 4),
(160001, NULL, 'G3DSA:3.40.47.10:FF:000248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160002, NULL, 'G3DSA:2.60.120.650:FF:000060', NULL, NULL, 'Histone demethylase JHD2', NULL, NULL, NULL, NULL, NULL, 4),
(160003, NULL, 'G3DSA:1.20.1250.20:FF:001907', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160004, NULL, 'G3DSA:1.25.40.10:FF:000245', NULL, NULL, 'Tetratricopeptide repeat domain 21B', NULL, NULL, NULL, NULL, NULL, 4),
(160005, NULL, 'G3DSA:1.20.1070.10:FF:000058', NULL, NULL, 'Adhesion G protein-coupled receptor F5', NULL, NULL, NULL, NULL, NULL, 4),
(160006, NULL, 'G3DSA:3.40.630.30:FF:000012', NULL, NULL, 'GNAT family acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(160007, NULL, 'G3DSA:3.40.50.300:FF:001207', NULL, NULL, 'Fanconi anemia group J protein-like isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(160008, NULL, 'G3DSA:3.30.70.330:FF:002330', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160009, NULL, 'G3DSA:3.40.630.40:FF:000015', NULL, NULL, 'Putative N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(160010, NULL, 'G3DSA:1.20.1070.10:FF:001795', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160011, NULL, 'G3DSA:1.20.140.80:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160012, NULL, 'G3DSA:3.90.190.20:FF:000008', NULL, NULL, 'UDP-N-acetylmuramoyl-tripeptide--D-alanyl-D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(160013, NULL, 'G3DSA:2.10.90.10:FF:000110', NULL, NULL, 'Unc-129 protein', NULL, NULL, NULL, NULL, NULL, 4),
(160014, NULL, 'G3DSA:3.30.70.20:FF:000036', NULL, NULL, '4Fe-4S dicluster domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(160015, NULL, 'G3DSA:3.30.200.20:FF:000373', NULL, NULL, 'Mitogen-activated protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(160016, NULL, 'G3DSA:1.10.357.10:FF:000048', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(160017, NULL, 'G3DSA:3.40.50.12780:FF:000014', NULL, NULL, 'Nonribosomal peptide synthetase 1', NULL, NULL, NULL, NULL, NULL, 4),
(160018, NULL, 'G3DSA:3.30.50.10:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160019, NULL, 'G3DSA:3.30.470.20:FF:000083', NULL, NULL, 'Biotin carboxylase subunit of acetyl CoA carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(160020, NULL, 'G3DSA:1.10.10.60:FF:000870', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160021, NULL, 'G3DSA:3.40.1690.20:FF:000006', NULL, NULL, 'ATP-dependent zinc metalloprotease FTSH', NULL, NULL, NULL, NULL, NULL, 4),
(160022, NULL, 'G3DSA:3.30.70.360:FF:000034', NULL, NULL, 'Allantoate amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(160023, NULL, 'G3DSA:1.20.1070.10:FF:001486', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160024, NULL, 'G3DSA:2.40.50.770:FF:000014', NULL, NULL, 'Tudor domain protein (DUF1767)', NULL, NULL, NULL, NULL, NULL, 4),
(160025, NULL, 'G3DSA:3.30.70.370:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(160026, NULL, 'G3DSA:2.30.40.10:FF:000011', NULL, NULL, 'Probable imidazolonepropionase', NULL, NULL, NULL, NULL, NULL, 4),
(160027, NULL, 'G3DSA:1.10.10.650:FF:000020', NULL, NULL, 'SH2 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(160028, NULL, 'G3DSA:1.10.510.10:FF:003305', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160029, NULL, 'G3DSA:2.10.25.10:FF:000151', NULL, NULL, 'FAT atypical cadherin 4', NULL, NULL, NULL, NULL, NULL, 4),
(160030, NULL, 'G3DSA:1.20.1200.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160031, NULL, 'G3DSA:3.40.50.150:FF:000982', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160032, NULL, 'G3DSA:3.30.70.3490:FF:000007', NULL, NULL, 'Oxysterol-binding protein-related protein 4B', NULL, NULL, NULL, NULL, NULL, 4),
(160033, NULL, 'G3DSA:3.50.50.60:FF:000405', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] flavoprotein subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(160034, NULL, 'G3DSA:1.20.1070.10:FF:002104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160035, NULL, 'G3DSA:3.40.190.10:FF:000808', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160036, NULL, 'G3DSA:1.10.110.10:FF:000015', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160037, NULL, 'G3DSA:2.40.50.140:FF:000842', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160038, NULL, 'G3DSA:3.20.20.30:FF:000031', NULL, NULL, 'Putative FMN-dependent luciferase-like monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(160039, NULL, 'G3DSA:3.80.10.10:FF:002303', NULL, NULL, 'Fgr38p', NULL, NULL, NULL, NULL, NULL, 4),
(160040, NULL, 'G3DSA:3.40.50.1220:FF:000026', NULL, NULL, 'NAD-dependent protein deacetylase sirtuin-2', NULL, NULL, NULL, NULL, NULL, 4),
(160041, NULL, 'G3DSA:3.50.50.60:FF:000293', NULL, NULL, 'FAD-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(160042, NULL, 'G3DSA:3.30.9.80:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160043, NULL, 'G3DSA:1.20.1070.10:FF:002060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160044, NULL, 'G3DSA:1.10.10.10:FF:000754', NULL, NULL, 'Z-DNA binding protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(160045, NULL, 'G3DSA:3.40.50.300:FF:006249', NULL, NULL, 'SNF2 DNA repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(160046, NULL, 'G3DSA:3.30.70.330:FF:000284', NULL, NULL, '39S ribosomal protein L23, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(160047, NULL, 'G3DSA:1.10.238.10:FF:001143', NULL, NULL, 'WD repeat-containing protein 66-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(160048, NULL, 'G3DSA:3.40.50.880:FF:000049', NULL, NULL, 'Catalase HPII', NULL, NULL, NULL, NULL, NULL, 4),
(160049, NULL, 'G3DSA:3.30.160.60:FF:002808', NULL, NULL, 'Zinc finger protein 311', NULL, NULL, NULL, NULL, NULL, 4),
(160050, NULL, 'G3DSA:3.40.630.30:FF:000698', NULL, NULL, 'RNA cytidine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(160051, NULL, 'G3DSA:3.10.390.10:FF:000016', NULL, NULL, 'Sp140 nuclear body protein', NULL, NULL, NULL, NULL, NULL, 4),
(160052, NULL, 'G3DSA:3.40.630.10:FF:000383', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160053, NULL, 'G3DSA:1.25.40.10:FF:002369', NULL, NULL, 'Pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(160054, NULL, 'G3DSA:3.40.50.2000:FF:000036', NULL, NULL, 'Alpha,alpha-trehalose-phosphate synthase subunit Tps2', NULL, NULL, NULL, NULL, NULL, 4),
(160055, NULL, 'G3DSA:1.10.490.10:FF:000037', NULL, NULL, 'GH09296p', NULL, NULL, NULL, NULL, NULL, 4),
(160056, NULL, 'G3DSA:3.10.20.90:FF:000667', NULL, NULL, 'Ubiquitin-like protein ATG12', NULL, NULL, NULL, NULL, NULL, 4),
(160057, NULL, 'G3DSA:2.60.40.10:FF:001521', NULL, NULL, 'Interleukin 27 receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(160058, NULL, 'G3DSA:3.40.50.300:FF:008458', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(160059, NULL, 'G3DSA:1.20.1720.10:FF:000114', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160060, NULL, 'G3DSA:2.40.50.40:FF:000003', NULL, NULL, 'chromodomain-helicase-DNA-binding protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(160061, NULL, 'G3DSA:1.10.510.10:FF:000990', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(160062, NULL, 'G3DSA:3.40.630.10:FF:000265', NULL, NULL, 'Peptidase M14, carboxypeptidase A', NULL, NULL, NULL, NULL, NULL, 4),
(160063, NULL, 'G3DSA:3.40.50.10190:FF:000052', NULL, NULL, 'Transcription coactivator', NULL, NULL, NULL, NULL, NULL, 4),
(160064, NULL, 'G3DSA:1.10.10.2590:FF:000006', NULL, NULL, 'uncharacterized protein LOC108744368 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(160065, NULL, 'G3DSA:3.40.50.300:FF:000959', NULL, NULL, 'structural maintenance of chromosomes protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(160066, NULL, 'G3DSA:1.10.472.10:FF:000462', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160067, NULL, 'G3DSA:3.90.190.10:FF:000314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160068, NULL, 'G3DSA:3.20.20.80:FF:000040', NULL, NULL, 'Beta-galactosidase A', NULL, NULL, NULL, NULL, NULL, 4),
(160069, NULL, 'G3DSA:3.30.565.10:FF:000525', NULL, NULL, 'Putative methanol utilization control sensor protein moxY', NULL, NULL, NULL, NULL, NULL, 4),
(160070, NULL, 'G3DSA:3.30.200.20:FF:000726', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(160071, NULL, 'G3DSA:1.10.8.270:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160072, NULL, 'G3DSA:3.80.10.10:FF:000049', NULL, NULL, 'Dynein light chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(160073, NULL, 'G3DSA:3.40.1190.20:FF:000013', NULL, NULL, 'ATP-dependent (S)-NAD(P)H-hydrate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(160074, NULL, 'G3DSA:1.25.10.10:FF:000417', NULL, NULL, 'Wings apart-like protein-like isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(160075, NULL, 'G3DSA:2.40.10.10:FF:000559', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160076, NULL, 'G3DSA:3.50.50.60:FF:001496', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(160077, NULL, 'G3DSA:1.10.30.10:FF:000199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160078, NULL, 'G3DSA:3.30.428.10:FF:000055', NULL, NULL, 'ADP-glucose phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(160079, NULL, 'G3DSA:3.40.1090.10:FF:000059', NULL, NULL, 'Intracelllar PhosphoLipase A family', NULL, NULL, NULL, NULL, NULL, 4),
(160080, NULL, 'G3DSA:1.20.58.860:FF:000009', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase isozyme L5', NULL, NULL, NULL, NULL, NULL, 4),
(160081, NULL, 'G3DSA:3.30.200.20:FF:000844', NULL, NULL, 'NIMA related kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(160082, NULL, 'G3DSA:3.30.40.10:FF:000413', NULL, NULL, 'PHD zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(160083, NULL, 'G3DSA:3.40.50.1820:FF:001628', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(160084, NULL, 'G3DSA:3.30.160.60:FF:002909', NULL, NULL, 'Zinc finger protein 142', NULL, NULL, NULL, NULL, NULL, 4),
(160085, NULL, 'G3DSA:2.40.320.10:FF:000037', NULL, NULL, 'Thiamine triphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(160086, NULL, 'G3DSA:3.30.70.270:FF:000243', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160087, NULL, 'G3DSA:1.10.510.10:FF:004278', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160088, NULL, 'G3DSA:3.30.1050.10:FF:000020', NULL, NULL, 'AGAP003091-PA', NULL, NULL, NULL, NULL, NULL, 4),
(160089, NULL, 'G3DSA:3.30.50.10:FF:000032', NULL, NULL, 'Transcription factor GATA-3', NULL, NULL, NULL, NULL, NULL, 4),
(160090, NULL, 'G3DSA:1.10.150.50:FF:000203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160091, NULL, 'G3DSA:2.10.70.10:FF:000002', NULL, NULL, 'CUB and Sushi multiple domains 3', NULL, NULL, NULL, NULL, NULL, 4),
(160092, NULL, 'G3DSA:3.30.70.330:FF:002745', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(160093, NULL, 'G3DSA:3.30.1370.120:FF:000011', NULL, NULL, 'Type II secretion system protein', NULL, NULL, NULL, NULL, NULL, 4),
(160094, NULL, 'G3DSA:1.20.1270.10:FF:000023', NULL, NULL, 'Heat shock protein 70', NULL, NULL, NULL, NULL, NULL, 4),
(160095, NULL, 'G3DSA:3.30.750.24:FF:000143', NULL, NULL, 'Glycosyl transferase, WecB/TagA/CpsF family', NULL, NULL, NULL, NULL, NULL, 4),
(160096, NULL, 'G3DSA:2.60.40.10:FF:004394', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160097, NULL, 'G3DSA:2.130.10.10:FF:004681', NULL, NULL, 'WD40 repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(160098, NULL, 'G3DSA:1.25.40.990:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160099, NULL, 'G3DSA:3.30.70.3170:FF:000001', NULL, NULL, 'galactokinase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(160100, NULL, 'G3DSA:3.40.50.620:FF:000145', NULL, NULL, 'ATP-binding domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(160101, NULL, 'G3DSA:3.90.70.10:FF:000396', NULL, NULL, 'Ubiquitin specific peptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(160102, NULL, 'G3DSA:3.40.50.10990:FF:000005', NULL, NULL, '3,4-dihydroxy-2-butanone 4-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(160103, NULL, 'G3DSA:2.40.30.40:FF:000002', NULL, NULL, 'Aminopeptidase YpdE', NULL, NULL, NULL, NULL, NULL, 4),
(160104, NULL, 'G3DSA:2.60.130.10:FF:000001', NULL, NULL, 'Protocatechuate 3,4-dioxygenase alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(160105, NULL, 'G3DSA:3.40.50.10980:FF:000002', NULL, NULL, 'DNA damage response protein RcaA', NULL, NULL, NULL, NULL, NULL, 4),
(160106, NULL, 'G3DSA:3.80.10.10:FF:003832', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160107, NULL, 'G3DSA:3.10.196.10:FF:000003', NULL, NULL, 'Methionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(160108, NULL, 'G3DSA:3.30.519.10:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160109, NULL, 'G3DSA:1.10.630.10:FF:000026', NULL, NULL, 'Cytochrome P450 82C4', NULL, NULL, NULL, NULL, NULL, 4),
(160110, NULL, 'G3DSA:2.60.40.1660:FF:000008', NULL, NULL, 'Probable sodium/potassium-transporting ATPase subunit beta-3', NULL, NULL, NULL, NULL, NULL, 4),
(160111, NULL, 'G3DSA:2.130.10.10:FF:004372', NULL, NULL, 'Flagellar associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(160112, NULL, 'G3DSA:3.40.640.10:FF:000193', NULL, NULL, 'DegT/DnrJ/EryC1/StrS aminotransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(160113, NULL, 'G3DSA:2.130.10.10:FF:002679', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160114, NULL, 'G3DSA:3.30.200.20:FF:000165', NULL, NULL, 'Serine/threonine-protein kinase PDIK1L', NULL, NULL, NULL, NULL, NULL, 4),
(160115, NULL, 'G3DSA:1.25.40.180:FF:000223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160116, NULL, 'G3DSA:2.60.120.200:FF:000273', NULL, NULL, 'Collagen type XIX alpha 1 chain', NULL, NULL, NULL, NULL, NULL, 4),
(160117, NULL, 'G3DSA:3.30.1520.10:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160118, NULL, 'G3DSA:2.130.10.10:FF:001027', NULL, NULL, 'WD repeat-containing protein 66, putative', NULL, NULL, NULL, NULL, NULL, 4),
(160119, NULL, 'G3DSA:1.10.1320.10:FF:000002', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(160120, NULL, 'G3DSA:1.10.400.10:FF:000026', NULL, NULL, 'Guanine nucleotide binding protein (G protein), alpha, variant', NULL, NULL, NULL, NULL, NULL, 4),
(160121, NULL, 'G3DSA:3.10.28.10:FF:000043', NULL, NULL, 'Probable intron-encoded endonuclease aI5', NULL, NULL, NULL, NULL, NULL, 4),
(160122, NULL, 'G3DSA:1.10.287.3990:FF:000006', NULL, NULL, '26S proteasome component', NULL, NULL, NULL, NULL, NULL, 4),
(160123, NULL, 'G3DSA:3.40.50.80:FF:000147', NULL, NULL, 'Ferric reductase-like transmembrane component', NULL, NULL, NULL, NULL, NULL, 4),
(160124, NULL, 'G3DSA:1.10.472.10:FF:000361', NULL, NULL, 'Transcription factor IIB family protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(160125, NULL, 'G3DSA:3.30.342.10:FF:000024', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(160126, NULL, 'G3DSA:1.10.510.10:FF:004379', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160127, NULL, 'G3DSA:3.30.40.10:FF:000514', NULL, NULL, 'FYVE and coiled-coil domain-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(160128, NULL, 'G3DSA:2.60.40.1170:FF:000075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160129, NULL, 'G3DSA:3.30.2070.10:FF:000009', NULL, NULL, 'Thiosulfate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(160130, NULL, 'G3DSA:3.40.50.720:FF:000142', NULL, NULL, 'probable UDP-arabinose 4-epimerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(160131, NULL, 'G3DSA:1.20.1070.10:FF:000822', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160132, NULL, 'G3DSA:1.10.10.10:FF:000299', NULL, NULL, 'ANTAR domain-containing response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(160133, NULL, 'G3DSA:3.40.50.12380:FF:000001', NULL, NULL, 'Nitrogenase MoFe cofactor biosynthesis protein NifE', NULL, NULL, NULL, NULL, NULL, 4),
(160134, NULL, 'G3DSA:3.40.50.300:FF:002961', NULL, NULL, 'DYNC2H1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(160135, NULL, 'G3DSA:3.30.1520.10:FF:000073', NULL, NULL, 'Vacuolar morphogenesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(160136, NULL, 'G3DSA:4.10.1240.10:FF:000089', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160137, NULL, 'G3DSA:3.80.10.10:FF:003377', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160138, NULL, 'G3DSA:2.60.40.10:FF:004955', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160139, NULL, 'G3DSA:3.40.50.2300:FF:000244', NULL, NULL, 'Sugar ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(160140, NULL, 'G3DSA:1.10.238.10:FF:000429', NULL, NULL, 'EF-hand calcium-binding domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(160141, NULL, 'G3DSA:1.10.510.10:FF:000579', NULL, NULL, 'Sensor histidine kinase/response regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(160142, NULL, 'G3DSA:3.40.50.300:FF:004905', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160143, NULL, 'G3DSA:3.10.300.10:FF:000005', NULL, NULL, 'Putative 3-methyladenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(160144, NULL, 'G3DSA:3.90.1030.20:FF:000002', NULL, NULL, 'DNA polymerase delta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(160145, NULL, 'G3DSA:3.80.10.10:FF:003731', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160146, NULL, 'G3DSA:3.60.15.10:FF:000084', NULL, NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(160147, NULL, 'G3DSA:3.10.20.90:FF:000919', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160148, NULL, 'G3DSA:3.90.550.50:FF:000068', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(160149, NULL, 'G3DSA:2.60.120.1040:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160150, NULL, 'G3DSA:3.50.7.10:FF:000073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160151, NULL, 'G3DSA:1.20.58.1020:FF:000005', NULL, NULL, 'DNA replication complex GINS protein', NULL, NULL, NULL, NULL, NULL, 4),
(160152, NULL, 'G3DSA:2.30.40.10:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160153, NULL, 'G3DSA:3.40.50.2000:FF:000070', NULL, NULL, 'probable UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SEC', NULL, NULL, NULL, NULL, NULL, 4),
(160154, NULL, 'G3DSA:2.60.40.10:FF:001830', NULL, NULL, 'Interleukin-2 receptor subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(160155, NULL, 'G3DSA:3.40.190.10:FF:000146', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(160156, NULL, 'G3DSA:3.40.50.300:FF:008492', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160157, NULL, 'G3DSA:3.30.390.150:FF:000003', NULL, NULL, 'Gastrokine 1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(160158, NULL, 'G3DSA:3.40.850.10:FF:000146', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(160159, NULL, 'G3DSA:3.30.70.330:FF:002436', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160160, NULL, 'G3DSA:1.10.287.130:FF:000011', NULL, NULL, 'Sensor histidine kinase DcuS', NULL, NULL, NULL, NULL, NULL, 4),
(160161, NULL, 'G3DSA:1.10.10.60:FF:000398', NULL, NULL, 'Homeobox protein lin-39', NULL, NULL, NULL, NULL, NULL, 4),
(160162, NULL, 'G3DSA:3.30.160.60:FF:003062', NULL, NULL, 'Tripartite motif-containing protein 40', NULL, NULL, NULL, NULL, NULL, 4),
(160163, NULL, 'G3DSA:1.20.58.1030:FF:000008', NULL, NULL, 'Hypothetical_protein', NULL, NULL, NULL, NULL, NULL, 4),
(160164, NULL, 'G3DSA:2.40.37.10:FF:000025', NULL, NULL, 'Diaminopimelate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(160165, NULL, 'G3DSA:3.40.50.720:FF:001468', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160166, NULL, 'G3DSA:1.20.1540.10:FF:000016', NULL, NULL, 'Derlin', NULL, NULL, NULL, NULL, NULL, 4),
(160167, NULL, 'G3DSA:3.30.200.20:FF:002435', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160168, NULL, 'G3DSA:2.60.40.1180:FF:000078', NULL, NULL, 'Maltase A5', NULL, NULL, NULL, NULL, NULL, 4),
(160169, NULL, 'G3DSA:3.40.50.620:FF:000454', NULL, NULL, 'Tryptophan--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(160170, NULL, 'G3DSA:3.30.420.40:FF:001075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160171, NULL, 'G3DSA:3.40.850.10:FF:000500', NULL, NULL, 'Kinesin-like protein costa', NULL, NULL, NULL, NULL, NULL, 4),
(160172, NULL, 'G3DSA:3.40.50.970:FF:000121', NULL, NULL, 'Sulfite reductase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(160173, NULL, 'G3DSA:2.10.25.10:FF:000504', NULL, NULL, 'LDL receptor related protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(160174, NULL, 'G3DSA:1.10.3470.10:FF:000024', NULL, NULL, 'Iron ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(160175, NULL, 'G3DSA:1.20.120.560:FF:000008', NULL, NULL, 'Vacuolar protein-sorting protein BRO1', NULL, NULL, NULL, NULL, NULL, 4),
(160176, NULL, 'G3DSA:3.30.40.10:FF:001739', NULL, NULL, 'Putative E3 ubiquitin-protein ligase ORTHRUS 4', NULL, NULL, NULL, NULL, NULL, 4),
(160177, NULL, 'G3DSA:3.30.70.330:FF:000385', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(160178, NULL, 'G3DSA:3.30.70.330:FF:000637', NULL, NULL, 'Nonsense-mediated mRNA decay protein Upf3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(160179, NULL, 'G3DSA:3.30.1360.120:FF:000094', NULL, NULL, 'Dimethylsulfonioproprionate demethylase DmdA', NULL, NULL, NULL, NULL, NULL, 4),
(160180, NULL, 'G3DSA:3.90.1860.10:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160181, NULL, 'G3DSA:3.40.50.1980:FF:000097', NULL, NULL, 'Periplasmic chelated iron-binding protein YfeA', NULL, NULL, NULL, NULL, NULL, 4),
(160182, NULL, 'G3DSA:3.30.420.40:FF:000715', NULL, NULL, 'Actin-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(160183, NULL, 'G3DSA:3.30.160.60:FF:006187', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160184, NULL, 'G3DSA:3.10.10.10:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160185, NULL, 'G3DSA:3.50.50.60:FF:000304', NULL, NULL, 'FAD-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(160186, NULL, 'G3DSA:2.120.10.80:FF:000155', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160187, NULL, 'G3DSA:2.40.10.500:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160188, NULL, 'G3DSA:1.25.10.10:FF:000625', NULL, NULL, 'Importin-9', NULL, NULL, NULL, NULL, NULL, 4),
(160189, NULL, 'G3DSA:1.25.10.10:FF:003031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160190, NULL, 'G3DSA:1.10.1070.11:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160191, NULL, 'G3DSA:2.10.25.10:FF:001786', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(160192, NULL, 'G3DSA:3.40.50.1440:FF:000093', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160193, NULL, 'G3DSA:2.40.30.200:FF:000002', NULL, NULL, 'Distal tail protein', NULL, NULL, NULL, NULL, NULL, 4),
(160194, NULL, 'G3DSA:3.40.50.920:FF:000022', NULL, NULL, 'Sulfite reductase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(160195, NULL, 'G3DSA:3.90.1640.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160196, NULL, 'G3DSA:3.30.40.10:FF:002313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160197, NULL, 'G3DSA:3.30.70.330:FF:002537', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160198, NULL, 'G3DSA:2.10.110.10:FF:000051', NULL, NULL, 'LIM domain transcription factor LMO4', NULL, NULL, NULL, NULL, NULL, 4),
(160199, NULL, 'G3DSA:1.10.730.10:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160200, NULL, 'G3DSA:1.50.10.160:FF:000010', NULL, NULL, 'Terpentedienyl-diphosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(160201, NULL, 'G3DSA:1.10.10.10:FF:000653', NULL, NULL, 'Transposase IS6110', NULL, NULL, NULL, NULL, NULL, 4),
(160202, NULL, 'G3DSA:2.30.30.40:FF:000098', NULL, NULL, 'Protein arginine N-methyltransferase 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(160203, NULL, 'G3DSA:3.90.470.10:FF:000016', NULL, NULL, '60S ribosomal protein L17, putative', NULL, NULL, NULL, NULL, NULL, 4),
(160204, NULL, 'G3DSA:3.40.390.10:FF:000021', NULL, NULL, 'Matrix metallopeptidase 28', NULL, NULL, NULL, NULL, NULL, 4),
(160205, NULL, 'G3DSA:3.40.50.12390:FF:000004', NULL, NULL, '5''-3'' exoribonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(160206, NULL, 'G3DSA:3.30.2160.10:FF:000039', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160207, NULL, 'G3DSA:4.10.800.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160208, NULL, 'G3DSA:1.20.58.60:FF:000232', NULL, NULL, 'nesprin-1 isoform X9', NULL, NULL, NULL, NULL, NULL, 4),
(160209, NULL, 'G3DSA:1.20.80.10:FF:000050', NULL, NULL, 'Autophagy-related protein 37', NULL, NULL, NULL, NULL, NULL, 4),
(160210, NULL, 'G3DSA:3.20.20.140:FF:000230', NULL, NULL, 'RNase P subunit p30-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(160211, NULL, 'G3DSA:3.40.50.300:FF:006704', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160212, NULL, 'G3DSA:1.25.40.10:FF:000099', NULL, NULL, 'Clustered mitochondria protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(160213, NULL, 'G3DSA:1.10.510.10:FF:002833', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160214, NULL, 'G3DSA:2.130.10.10:FF:002663', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160215, NULL, 'G3DSA:1.20.58.760:FF:000013', NULL, NULL, 'Probable inactive ATP-dependent zinc metalloprotease FTSHI 4, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(160216, NULL, 'G3DSA:2.30.30.30:FF:000095', NULL, NULL, 'PTAC13', NULL, NULL, NULL, NULL, NULL, 4),
(160217, NULL, 'G3DSA:2.30.36.100:FF:000001', NULL, NULL, 'Uncharacterized protein MJ0776', NULL, NULL, NULL, NULL, NULL, 4),
(160218, NULL, 'G3DSA:3.90.950.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160219, NULL, 'G3DSA:1.20.5.170:FF:000117', NULL, NULL, 'Positive regulator of galactose inducible genes', NULL, NULL, NULL, NULL, NULL, 4),
(160220, NULL, 'G3DSA:4.10.60.10:FF:000082', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(160221, NULL, 'G3DSA:3.40.50.1000:FF:000854', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160222, NULL, 'G3DSA:1.25.40.10:FF:002605', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160223, NULL, 'G3DSA:2.130.10.10:FF:000982', NULL, NULL, 'Ribosomal assembly complex component Ipi3', NULL, NULL, NULL, NULL, NULL, 4),
(160224, NULL, 'G3DSA:3.40.50.300:FF:000853', NULL, NULL, 'Nicotinamide riboside kinase 1', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(160225, NULL, 'G3DSA:3.40.50.300:FF:004759', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160226, NULL, 'G3DSA:3.30.479.30:FF:000049', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160227, NULL, 'G3DSA:3.40.50.2000:FF:000631', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160228, NULL, 'G3DSA:3.30.200.20:FF:002525', NULL, NULL, 'WNK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(160229, NULL, 'G3DSA:3.75.10.10:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160230, NULL, 'G3DSA:3.40.50.460:FF:000030', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(160231, NULL, 'G3DSA:1.25.40.10:FF:004505', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160232, NULL, 'G3DSA:2.60.40.2860:FF:000020', NULL, NULL, 'Transmission-blocking target antigen S230', NULL, NULL, NULL, NULL, NULL, 4),
(160233, NULL, 'G3DSA:3.30.40.10:FF:000059', NULL, NULL, 'PHD finger protein 14 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(160234, NULL, 'G3DSA:3.30.43.10:FF:000021', NULL, NULL, 'Cytokinin oxidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(160235, NULL, 'G3DSA:3.10.180.10:FF:000079', NULL, NULL, 'Methylmalonyl-CoA epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(160236, NULL, 'G3DSA:3.30.70.270:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160237, NULL, 'G3DSA:2.40.30.10:FF:000459', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160238, NULL, 'G3DSA:2.70.130.10:FF:000095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160239, NULL, 'G3DSA:2.40.50.40:FF:000109', NULL, NULL, 'Interleukin-8', NULL, NULL, NULL, NULL, NULL, 4),
(160240, NULL, 'G3DSA:3.40.50.300:FF:006659', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160241, NULL, 'G3DSA:3.30.160.60:FF:005214', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160242, NULL, 'G3DSA:3.30.160.60:FF:003314', NULL, NULL, 'Sex determination protein fruitless', NULL, NULL, NULL, NULL, NULL, 4),
(160243, NULL, 'G3DSA:2.40.330.10:FF:000010', NULL, NULL, 'B3 domain-containing protein REM1', NULL, NULL, NULL, NULL, NULL, 4),
(160244, NULL, 'G3DSA:1.10.1300.10:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160245, NULL, 'G3DSA:1.10.150.20:FF:000144', NULL, NULL, 'DNA repair endonuclease XPF', NULL, NULL, NULL, NULL, NULL, 4),
(160246, NULL, 'G3DSA:1.20.120.1240:FF:000012', NULL, NULL, 'dynamin-3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(160247, NULL, 'G3DSA:3.80.10.10:FF:000504', NULL, NULL, 'F-box family protein', NULL, NULL, NULL, NULL, NULL, 4),
(160248, NULL, 'G3DSA:1.20.1080.10:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160249, NULL, 'G3DSA:2.60.40.10:FF:000706', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(160250, NULL, 'G3DSA:1.20.1270.60:FF:000032', NULL, NULL, 'Sorting nexin', NULL, NULL, NULL, NULL, NULL, 4),
(160251, NULL, 'G3DSA:3.30.413.10:FF:000021', NULL, NULL, 'Nitrite reductase', NULL, NULL, NULL, NULL, NULL, 4),
(160252, NULL, 'G3DSA:2.170.300.10:FF:000005', NULL, NULL, 'multiple epidermal growth factor-like domains protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(160253, NULL, 'G3DSA:2.30.30.40:FF:000659', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160254, NULL, 'G3DSA:3.90.70.10:FF:000749', NULL, NULL, 'Clan CA, family C1, cathepsin L-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(160255, NULL, 'G3DSA:3.30.160.60:FF:006496', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160256, NULL, 'G3DSA:3.80.10.10:FF:000813', NULL, NULL, 'Leucine rich repeats and guanylate kinase domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(160257, NULL, 'G3DSA:2.130.10.10:FF:004725', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160258, NULL, 'G3DSA:3.30.1460.20:FF:000020', NULL, NULL, 'Arp2/3 complex 34 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(160259, NULL, 'G3DSA:3.40.30.10:FF:000024', NULL, NULL, 'Glutathione S-transferase A4', NULL, NULL, NULL, NULL, NULL, 4),
(160260, NULL, 'G3DSA:3.40.50.300:FF:003006', NULL, NULL, 'Rab family gtpase', NULL, NULL, NULL, NULL, NULL, 4),
(160261, NULL, 'G3DSA:2.30.29.30:FF:000333', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(160262, NULL, 'G3DSA:2.60.40.10:FF:004293', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160263, NULL, 'G3DSA:1.25.40.1040:FF:000012', NULL, NULL, 'N-alpha-acetyltransferase 15, NatA auxiliary subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(160264, NULL, 'G3DSA:1.25.40.10:FF:004814', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160265, NULL, 'G3DSA:3.40.850.10:FF:000455', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160266, NULL, 'G3DSA:3.40.190.10:FF:000455', NULL, NULL, 'Glycine cleavage operon activator', NULL, NULL, NULL, NULL, NULL, 4),
(160267, NULL, 'G3DSA:3.40.50.2000:FF:000940', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160268, NULL, 'G3DSA:3.40.30.10:FF:001109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160269, NULL, 'G3DSA:2.130.10.10:FF:002573', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160270, NULL, 'G3DSA:1.25.10.10:FF:001131', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(160271, NULL, 'G3DSA:1.20.1090.10:FF:000060', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160272, NULL, 'G3DSA:1.20.1050.10:FF:000052', NULL, NULL, 'Glutathione S-transferase GstA', NULL, NULL, NULL, NULL, NULL, 4),
(160273, NULL, 'G3DSA:3.30.420.10:FF:000043', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(160274, NULL, 'G3DSA:3.30.160.60:FF:003623', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160275, NULL, 'G3DSA:3.30.505.10:FF:000196', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160276, NULL, 'G3DSA:3.10.129.10:FF:000062', NULL, NULL, 'Acyl-CoA thioester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(160277, NULL, 'G3DSA:1.10.720.30:FF:000011', NULL, NULL, 'E3 ubiquitin-protein ligase RNF34 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(160278, NULL, 'G3DSA:2.170.16.10:FF:000010', NULL, NULL, 'Ataxin 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(160279, NULL, 'G3DSA:2.60.120.260:FF:000375', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(160280, NULL, 'G3DSA:3.80.10.10:FF:001786', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160281, NULL, 'G3DSA:3.30.160.60:FF:001723', NULL, NULL, 'Zinc finger protein 408', NULL, NULL, NULL, NULL, NULL, 4),
(160282, NULL, 'G3DSA:3.80.10.10:FF:002404', NULL, NULL, 'PH domain and leucine-rich repeat protein phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(160283, NULL, 'G3DSA:1.25.40.10:FF:000762', NULL, NULL, 'tetratricopeptide repeat protein 30B', NULL, NULL, NULL, NULL, NULL, 4),
(160284, NULL, 'G3DSA:1.10.510.10:FF:001506', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(160285, NULL, 'G3DSA:1.10.472.10:FF:000568', NULL, NULL, 'Cyclin O', NULL, NULL, NULL, NULL, NULL, 4),
(160286, NULL, 'G3DSA:1.10.287.70:FF:000122', NULL, NULL, 'Potassium channel subfamily K member 18', NULL, NULL, NULL, NULL, NULL, 4),
(160287, NULL, 'G3DSA:3.30.465.10:FF:000006', NULL, NULL, 'Delta(24)-sterol reductase', NULL, NULL, NULL, NULL, NULL, 4),
(160288, NULL, 'G3DSA:2.30.42.10:FF:000408', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160289, NULL, 'G3DSA:3.80.10.10:FF:003938', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160290, NULL, 'G3DSA:1.10.510.10:FF:002788', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160291, NULL, 'G3DSA:1.10.10.60:FF:000971', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160292, NULL, 'G3DSA:2.30.29.30:FF:000024', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(160293, NULL, 'G3DSA:2.60.40.10:FF:005220', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(160294, NULL, 'G3DSA:2.40.30.260:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160295, NULL, 'G3DSA:3.30.390.110:FF:000008', NULL, NULL, 'Protein MAK16 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(160296, NULL, 'G3DSA:3.80.10.10:FF:000252', NULL, NULL, 'Leucine-rich repeat-containing protein 61', NULL, NULL, NULL, NULL, NULL, 4),
(160297, NULL, 'G3DSA:1.10.10.60:FF:000662', NULL, NULL, 'Transcriptional regulator, AraC/XylS family', NULL, NULL, NULL, NULL, NULL, 4),
(160298, NULL, 'G3DSA:3.30.2090.10:FF:000011', NULL, NULL, 'RND multidrug efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(160299, NULL, 'G3DSA:1.20.920.30:FF:000069', NULL, NULL, 'Dynein axonemal heavy chain 14', NULL, NULL, NULL, NULL, NULL, 4),
(160300, NULL, 'G3DSA:3.90.640.10:FF:000052', NULL, NULL, 'Actin', NULL, NULL, NULL, NULL, NULL, 4),
(160301, NULL, 'G3DSA:3.90.79.10:FF:000185', NULL, NULL, 'NUDIX hydrolase domain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(160302, NULL, 'G3DSA:3.40.50.10260:FF:000034', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160303, NULL, 'G3DSA:1.10.1070.11:FF:000028', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(160304, NULL, 'G3DSA:3.30.70.920:FF:000056', NULL, NULL, 'Transcriptional regulator AsnC family', NULL, NULL, NULL, NULL, NULL, 4),
(160305, NULL, 'G3DSA:1.20.1070.10:FF:001907', NULL, NULL, 'Odorant receptor', NULL, NULL, NULL, NULL, NULL, 4),
(160306, NULL, 'G3DSA:3.80.10.10:FF:001477', NULL, NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', NULL, NULL, NULL, NULL, NULL, 4),
(160307, NULL, 'G3DSA:3.40.50.300:FF:001106', NULL, NULL, 'Guanine nucleotide-binding protein-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(160308, NULL, 'G3DSA:1.25.40.10:FF:000453', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(160309, NULL, 'G3DSA:3.30.160.60:FF:001162', NULL, NULL, 'zinc finger protein 879 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(160310, NULL, 'G3DSA:2.40.30.270:FF:000006', NULL, NULL, 'Similar to DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(160311, NULL, 'G3DSA:1.10.8.270:FF:000083', NULL, NULL, 'TBC1 domain family member 9B', NULL, NULL, NULL, NULL, NULL, 4),
(160312, NULL, 'G3DSA:2.130.10.10:FF:000673', NULL, NULL, 'WD repeat and FYVE domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(160313, NULL, 'G3DSA:1.25.40.10:FF:002914', NULL, NULL, 'mRNA splicing protein', NULL, NULL, NULL, NULL, NULL, 4),
(160314, NULL, 'G3DSA:1.20.920.20:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160315, NULL, 'G3DSA:2.60.40.60:FF:000659', NULL, NULL, 'Cadherin 16', NULL, NULL, NULL, NULL, NULL, 4),
(160316, NULL, 'G3DSA:3.30.230.10:FF:000208', NULL, NULL, 'Ribonuclease P protein component', NULL, NULL, NULL, NULL, NULL, 4),
(160317, NULL, 'G3DSA:3.80.10.10:FF:003686', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160318, NULL, 'G3DSA:2.120.10.80:FF:000065', NULL, NULL, 'Leucine-zipper-like transcription regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(160319, NULL, 'G3DSA:1.20.1250.20:FF:002060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160320, NULL, 'G3DSA:1.25.10.10:FF:001440', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(160321, NULL, 'G3DSA:1.10.510.10:FF:002479', NULL, NULL, 'CK1 family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(160322, NULL, 'G3DSA:1.10.238.10:FF:001244', NULL, NULL, 'MIP10861p', NULL, NULL, NULL, NULL, NULL, 4),
(160323, NULL, 'G3DSA:2.40.10.10:FF:000705', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160324, NULL, 'G3DSA:1.20.1050.10:FF:000259', NULL, NULL, 'Glutathione s-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(160325, NULL, 'G3DSA:1.10.472.30:FF:000001', NULL, NULL, 'Transcription elongation factor A (SII), 1', NULL, NULL, NULL, NULL, NULL, 4),
(160326, NULL, 'G3DSA:1.10.10.570:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(160327, NULL, 'G3DSA:3.40.850.10:FF:000040', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(160328, NULL, 'G3DSA:3.30.590.50:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160329, NULL, 'G3DSA:3.30.160.60:FF:002718', NULL, NULL, 'C2H2 transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(160330, NULL, 'G3DSA:3.20.20.80:FF:000023', NULL, NULL, 'heparanase-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(160331, NULL, 'G3DSA:1.10.510.10:FF:002597', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160332, NULL, 'G3DSA:3.30.750.24:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160333, NULL, 'G3DSA:3.30.200.20:FF:001699', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160334, NULL, 'G3DSA:2.120.10.30:FF:000308', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160335, NULL, 'G3DSA:3.90.1170.50:FF:000010', NULL, NULL, 'Carbon monoxide dehydrogenase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(160336, NULL, 'G3DSA:2.20.100.10:FF:000042', NULL, NULL, 'ADAMTS like 2', NULL, NULL, NULL, NULL, NULL, 4),
(160337, NULL, 'G3DSA:1.10.510.10:FF:000989', NULL, NULL, 'Wee1-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(160338, NULL, 'G3DSA:1.20.1070.10:FF:000412', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160339, NULL, 'G3DSA:3.40.50.2300:FF:000940', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160340, NULL, 'G3DSA:2.60.40.60:FF:001042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160341, NULL, 'G3DSA:3.30.160.60:FF:003180', NULL, NULL, 'Zinc finger protein 786', NULL, NULL, NULL, NULL, NULL, 4),
(160342, NULL, 'G3DSA:1.10.20.140:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160343, NULL, 'G3DSA:3.20.20.70:FF:000020', NULL, NULL, 'Triosephosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(160344, NULL, 'G3DSA:3.90.70.10:FF:000856', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160345, NULL, 'G3DSA:2.30.42.10:FF:000291', NULL, NULL, 'Partitioning defective protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(160346, NULL, 'G3DSA:3.40.50.620:FF:000336', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(160347, NULL, 'G3DSA:2.120.10.80:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160348, NULL, 'G3DSA:1.25.40.20:FF:001372', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160349, NULL, 'G3DSA:1.25.40.10:FF:002459', NULL, NULL, 'Os02g0670700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(160350, NULL, 'G3DSA:3.40.1190.20:FF:000204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160351, NULL, 'G3DSA:1.10.510.10:FF:002715', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160352, NULL, 'G3DSA:2.60.40.10:FF:001611', NULL, NULL, 'cardiomyopathy-associated protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(160353, NULL, 'G3DSA:3.80.10.10:FF:001707', NULL, NULL, 'Inactive disease susceptibility protein LOV1', NULL, NULL, NULL, NULL, NULL, 4),
(160354, NULL, 'G3DSA:1.10.10.60:FF:000089', NULL, NULL, 'Caudal type homeobox 4', NULL, NULL, NULL, NULL, NULL, 4),
(160355, NULL, 'G3DSA:3.30.40.10:FF:000284', NULL, NULL, 'pleckstrin homology domain-containing family F member 1', NULL, NULL, NULL, NULL, NULL, 4),
(160356, NULL, 'G3DSA:1.10.1070.11:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160357, NULL, 'G3DSA:3.40.1440.10:FF:000002', NULL, NULL, 'UPF0213 protein YhbQ', NULL, NULL, NULL, NULL, NULL, 4),
(160358, NULL, 'G3DSA:1.20.1250.10:FF:000033', NULL, NULL, 'Interferon epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(160359, NULL, 'G3DSA:3.40.50.150:FF:001145', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160360, NULL, 'G3DSA:2.60.40.3040:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160361, NULL, 'G3DSA:3.30.70.330:FF:001947', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160362, NULL, 'G3DSA:3.30.160.70:FF:000001', NULL, NULL, 'Methylated-DNA--protein-cysteine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(160363, NULL, 'G3DSA:1.10.287.110:FF:000365', NULL, NULL, 'Co-chaperone protein HscB homolog', NULL, NULL, NULL, NULL, NULL, 4),
(160364, NULL, 'G3DSA:1.25.40.10:FF:004713', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160365, NULL, 'G3DSA:1.25.10.10:FF:000833', NULL, NULL, '26S proteasome non-ATPase regulatory subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(160366, NULL, 'G3DSA:3.40.50.720:FF:002204', NULL, NULL, 'DNA damage tolerance protein rad31', NULL, NULL, NULL, NULL, NULL, 4),
(160367, NULL, 'G3DSA:2.60.40.10:FF:002595', NULL, NULL, 'Sallimus, isoform Z', NULL, NULL, NULL, NULL, NULL, 4),
(160368, NULL, 'G3DSA:2.130.10.10:FF:001145', NULL, NULL, 'Lethal(2) giant larvae protein homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(160369, NULL, 'G3DSA:1.25.40.10:FF:000907', NULL, NULL, 'YMR018W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(160370, NULL, 'G3DSA:1.10.10.10:FF:000670', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(160371, NULL, 'G3DSA:2.40.70.10:FF:000462', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160372, NULL, 'G3DSA:3.40.50.300:FF:007272', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160373, NULL, 'G3DSA:1.10.600.10:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160374, NULL, 'G3DSA:1.10.630.10:FF:000144', NULL, NULL, 'probable cytochrome P450 303a1', NULL, NULL, NULL, NULL, NULL, 4),
(160375, NULL, 'G3DSA:1.10.10.60:FF:001241', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160376, NULL, 'G3DSA:2.60.120.200:FF:000402', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(160377, NULL, 'G3DSA:2.40.50.140:FF:000180', NULL, NULL, '40S ribosomal protein S28e', NULL, NULL, NULL, NULL, NULL, 4),
(160378, NULL, 'G3DSA:2.10.25.10:FF:001696', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160379, NULL, 'G3DSA:3.30.160.60:FF:005315', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160380, NULL, 'G3DSA:1.10.287.3700:FF:000004', NULL, NULL, 'Poly(A) specific ribonuclease subunit PAN3', NULL, NULL, NULL, NULL, NULL, 4),
(160381, NULL, 'G3DSA:3.40.50.300:FF:001016', NULL, NULL, 'ras-like protein family member 12', NULL, NULL, NULL, NULL, NULL, 4),
(160382, NULL, 'G3DSA:1.25.40.10:FF:005112', NULL, NULL, 'Receptor-associated protein of the synapse', NULL, NULL, NULL, NULL, NULL, 4),
(160383, NULL, 'G3DSA:1.20.1070.10:FF:000261', NULL, NULL, 'Prostaglandin E receptor 4 (subtype EP4) c', NULL, NULL, NULL, NULL, NULL, 4),
(160384, NULL, 'G3DSA:1.10.510.10:FF:002608', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160385, NULL, 'G3DSA:2.60.40.60:FF:000569', NULL, NULL, 'Cadherin 5', NULL, NULL, NULL, NULL, NULL, 4),
(160386, NULL, 'G3DSA:3.80.10.10:FF:004304', NULL, NULL, 'Dual specificity protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(160387, NULL, 'G3DSA:1.10.472.10:FF:000580', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160388, NULL, 'G3DSA:2.130.10.10:FF:005321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160389, NULL, 'G3DSA:3.20.20.80:FF:000130', NULL, NULL, 'Endoglucanase C', NULL, NULL, NULL, NULL, NULL, 4),
(160390, NULL, 'G3DSA:3.40.525.10:FF:000043', NULL, NULL, 'Tocopherol (alpha) transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(160391, NULL, 'G3DSA:2.60.40.1170:FF:000058', NULL, NULL, 'Adaptor-related protein complex 5 subunit mu 1', NULL, NULL, NULL, NULL, NULL, 4),
(160392, NULL, 'G3DSA:3.80.10.10:FF:001814', NULL, NULL, 'F-box family protein', NULL, NULL, NULL, NULL, NULL, 4),
(160393, NULL, 'G3DSA:3.30.200.20:FF:002216', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(160394, NULL, 'G3DSA:2.30.30.40:FF:000660', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(160395, NULL, 'G3DSA:1.10.460.10:FF:000018', NULL, NULL, 'DNA topoisomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(160396, NULL, 'G3DSA:3.30.559.10:FF:000230', NULL, NULL, 'Nonribosomal peptide synthetase easA', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(160397, NULL, 'G3DSA:3.30.230.10:FF:000107', NULL, NULL, 'Phosphomevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(160398, NULL, 'G3DSA:1.10.418.10:FF:000275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160399, NULL, 'G3DSA:1.25.10.10:FF:001541', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160400, NULL, 'G3DSA:3.30.70.330:FF:000531', NULL, NULL, 'Myelin expression factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(160401, NULL, 'G3DSA:3.80.10.10:FF:000712', NULL, NULL, 'F-box/LRR-repeat MAX2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(160402, NULL, 'G3DSA:3.30.200.20:FF:000608', NULL, NULL, 'Serine/threonine kinase protein', NULL, NULL, NULL, NULL, NULL, 4),
(160403, NULL, 'G3DSA:3.20.20.80:FF:000500', NULL, NULL, 'Beta-1,4-endoglucanase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(160404, NULL, 'G3DSA:3.40.50.2000:FF:000480', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(160405, NULL, 'G3DSA:3.30.1370.170:FF:000003', NULL, NULL, 'Erythronate-4-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(160406, NULL, 'G3DSA:1.10.600.10:FF:000007', NULL, NULL, 'Isoprene synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(160407, NULL, 'G3DSA:3.30.160.60:FF:004949', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160408, NULL, 'G3DSA:1.10.238.10:FF:000654', NULL, NULL, 'Caltractin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(160409, NULL, 'G3DSA:2.60.40.60:FF:000895', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160410, NULL, 'G3DSA:1.10.510.10:FF:003070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160411, NULL, 'G3DSA:3.80.20.20:FF:000008', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(160412, NULL, 'G3DSA:3.40.50.970:FF:000076', NULL, NULL, 'Transketolase', NULL, NULL, NULL, NULL, NULL, 4),
(160413, NULL, 'G3DSA:1.10.287.4270:FF:000001', NULL, NULL, 'Serine/threonine-protein kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(160414, NULL, 'G3DSA:2.60.40.60:FF:000906', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160415, NULL, 'G3DSA:2.60.40.150:FF:000468', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160416, NULL, 'G3DSA:3.40.50.300:FF:001342', NULL, NULL, 'ATP-dependent OLD family endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(160417, NULL, 'G3DSA:3.60.15.10:FF:000067', NULL, NULL, 'Metallo-beta-lactamase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(160418, NULL, 'G3DSA:2.160.20.10:FF:000094', NULL, NULL, 'Putative pectinesterase/pectinesterase inhibitor 51', NULL, NULL, NULL, NULL, NULL, 4),
(160419, NULL, 'G3DSA:3.80.10.10:FF:000033', NULL, NULL, 'FLII, actin remodeling protein', NULL, NULL, NULL, NULL, NULL, 4),
(160420, NULL, 'G3DSA:3.30.200.20:FF:000597', NULL, NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(160421, NULL, 'G3DSA:2.30.30.550:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160422, NULL, 'G3DSA:1.10.1820.10:FF:000012', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(160423, NULL, 'G3DSA:2.60.34.10:FF:000046', NULL, NULL, 'HSP70-family chaperone protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(160424, NULL, 'G3DSA:1.25.40.10:FF:001043', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160425, NULL, 'G3DSA:2.60.40.150:FF:000575', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160426, NULL, 'G3DSA:1.10.238.10:FF:000547', NULL, NULL, 'Reticulocalbin 2', NULL, NULL, NULL, NULL, NULL, 4),
(160427, NULL, 'G3DSA:3.30.2350.10:FF:000048', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(160428, NULL, 'G3DSA:3.90.550.50:FF:000085', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(160429, NULL, 'G3DSA:3.40.50.80:FF:000041', NULL, NULL, '1,2-phenylacetyl-CoA epoxidase subunit E', NULL, NULL, NULL, NULL, NULL, 4),
(160430, NULL, 'G3DSA:3.40.50.150:FF:000639', NULL, NULL, 'Met-10+ like-protein/Methyltransferase small domain/Methyltransferase domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(160431, NULL, 'G3DSA:2.130.10.10:FF:002247', NULL, NULL, 'Coatomer subunit alpha-3', NULL, NULL, NULL, NULL, NULL, 4),
(160432, NULL, 'G3DSA:1.20.1440.230:FF:000006', NULL, NULL, 'NADH-ubiquinone oxidoreductase 51 kDa subunit homolog SPBC18E5.10, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(160433, NULL, 'G3DSA:2.30.29.70:FF:000002', NULL, NULL, 'Proteasomal ubiquitin receptor ADRM1', NULL, NULL, NULL, NULL, NULL, 4),
(160434, NULL, 'G3DSA:3.90.79.10:FF:000286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160435, NULL, 'G3DSA:3.40.190.10:FF:000691', NULL, NULL, 'Sll1762 protein', NULL, NULL, NULL, NULL, NULL, 4),
(160436, NULL, 'G3DSA:2.40.50.40:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160437, NULL, 'G3DSA:1.20.1280.290:FF:000054', NULL, NULL, 'L-cystine transporter', NULL, NULL, NULL, NULL, NULL, 4),
(160438, NULL, 'G3DSA:3.80.10.10:FF:001696', NULL, NULL, 'Receptor like protein 39', NULL, NULL, NULL, NULL, NULL, 4),
(160439, NULL, 'G3DSA:3.40.50.620:FF:000229', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(160440, NULL, 'G3DSA:3.10.110.10:FF:000176', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(160441, NULL, 'G3DSA:3.90.640.10:FF:000203', NULL, NULL, 'Heat shock 70 kDa protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(160442, NULL, 'G3DSA:3.40.50.720:FF:000057', NULL, NULL, 'Formate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(160443, NULL, 'G3DSA:1.25.40.20:FF:001046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160444, NULL, 'G3DSA:3.60.130.10:FF:000008', NULL, NULL, 'Alpha-ketoglutarate-dependent taurine dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(160445, NULL, 'G3DSA:1.20.1070.10:FF:000042', NULL, NULL, 'Taste receptor type 2 member 7', NULL, NULL, NULL, NULL, NULL, 4),
(160446, NULL, 'G3DSA:2.60.200.20:FF:000139', NULL, NULL, 'APTX isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(160447, NULL, 'G3DSA:3.30.70.560:FF:000004', NULL, NULL, 'Dihydropteroate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(160448, NULL, 'G3DSA:1.20.1250.20:FF:000362', NULL, NULL, 'Major Facilitator Superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(160449, NULL, 'G3DSA:3.40.850.10:FF:000354', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160450, NULL, 'G3DSA:3.40.50.11610:FF:000017', NULL, NULL, '2-oxoglutarate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(160451, NULL, 'G3DSA:2.10.25.10:FF:001477', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160452, NULL, 'G3DSA:1.25.40.10:FF:000661', NULL, NULL, 'UTP6 small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4),
(160453, NULL, 'G3DSA:3.75.10.10:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160454, NULL, 'G3DSA:3.20.20.150:FF:000025', NULL, NULL, 'Hydroxypyruvate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(160455, NULL, 'G3DSA:3.40.50.1980:FF:000142', NULL, NULL, 'Putative iron ABC transporter, periplasmic iron-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(160456, NULL, 'G3DSA:3.40.190.10:FF:000472', NULL, NULL, 'Peptide/nickel transport system substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(160457, NULL, 'G3DSA:3.60.15.10:FF:000174', NULL, NULL, 'MBL fold metallo-hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(160458, NULL, 'G3DSA:2.40.50.140:FF:000382', NULL, NULL, 'Cold shock protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(160459, NULL, 'G3DSA:3.20.20.190:FF:000104', NULL, NULL, 'Glycerophosphoryl diester phosphodiesterase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(160460, NULL, 'G3DSA:2.130.10.10:FF:004490', NULL, NULL, 'WD repeat domain 5B-like', NULL, NULL, NULL, NULL, NULL, 4),
(160461, NULL, 'G3DSA:3.40.50.2300:FF:000614', NULL, NULL, 'Metabotropic GLutamate receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(160462, NULL, 'G3DSA:3.40.50.300:FF:002753', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(160463, NULL, 'G3DSA:2.60.40.150:FF:000794', NULL, NULL, 'Os04g0644900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(160464, NULL, 'G3DSA:3.40.50.1820:FF:000083', NULL, NULL, 'Esterase YpfH', NULL, NULL, NULL, NULL, NULL, 4),
(160465, NULL, 'G3DSA:3.40.190.10:FF:000702', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(160466, NULL, 'G3DSA:3.80.10.10:FF:003585', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160467, NULL, 'G3DSA:2.30.29.90:FF:000008', NULL, NULL, 'Exocyst complex component 1', NULL, NULL, NULL, NULL, NULL, 4),
(160468, NULL, 'G3DSA:3.40.50.150:FF:000746', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160469, NULL, 'G3DSA:3.40.50.300:FF:008576', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160470, NULL, 'G3DSA:3.40.50.300:FF:001123', NULL, NULL, 'C-1-tetrahydrofolate synthase, cytoplasmic isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(160471, NULL, 'G3DSA:1.20.1250.20:FF:001924', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160472, NULL, 'G3DSA:2.60.120.200:FF:000711', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160473, NULL, 'G3DSA:2.60.40.10:FF:005017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160474, NULL, 'G3DSA:3.80.10.10:FF:003950', NULL, NULL, 'Insulin like growth factor binding protein acid labile subunit', NULL, NULL, NULL, NULL, NULL, 4),
(160475, NULL, 'G3DSA:1.20.58.1080:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160476, NULL, 'G3DSA:3.20.20.100:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160477, NULL, 'G3DSA:3.90.70.80:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160478, NULL, 'G3DSA:2.40.50.140:FF:000073', NULL, NULL, 'DNA-directed RNA polymerases I, II, and III subunit RPABC3', NULL, NULL, NULL, NULL, NULL, 4),
(160479, NULL, 'G3DSA:3.30.300.30:FF:000074', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(160480, NULL, 'G3DSA:2.60.40.60:FF:000676', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160481, NULL, 'G3DSA:1.10.510.10:FF:004486', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160482, NULL, 'G3DSA:4.10.400.10:FF:000020', NULL, NULL, 'LDL receptor related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(160483, NULL, 'G3DSA:2.10.110.10:FF:000152', NULL, NULL, 'Four and a half LIM domains protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(160484, NULL, 'G3DSA:2.10.25.10:FF:000988', NULL, NULL, 'putative vitellogenin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(160485, NULL, 'G3DSA:1.25.10.10:FF:001215', NULL, NULL, 'Related to yeast Vacuolar Protein Sorting factor', NULL, NULL, NULL, NULL, NULL, 4),
(160486, NULL, 'G3DSA:2.10.70.80:FF:000006', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(160487, NULL, 'G3DSA:1.20.120.20:FF:000011', NULL, NULL, 'Apolipoprotein A-IV b, tandem duplicate 2', NULL, NULL, NULL, NULL, NULL, 4),
(160488, NULL, 'G3DSA:2.60.40.10:FF:002376', NULL, NULL, 'HYDIN, axonemal central pair apparatus protein', NULL, NULL, NULL, NULL, NULL, 4),
(160489, NULL, 'G3DSA:3.10.330.10:FF:000024', NULL, NULL, 'AAA family ATPase peroxin 1', NULL, NULL, NULL, NULL, NULL, 4),
(160490, NULL, 'G3DSA:3.40.50.1000:FF:000753', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160491, NULL, 'G3DSA:2.40.50.700:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160492, NULL, 'G3DSA:1.20.58.390:FF:000189', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160493, NULL, 'G3DSA:2.120.10.30:FF:000617', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160494, NULL, 'G3DSA:1.20.120.1900:FF:000047', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(160495, NULL, 'G3DSA:3.30.1640.30:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160496, NULL, 'G3DSA:1.20.1260.10:FF:000005', NULL, NULL, 'Bacterioferritin', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(160497, NULL, 'G3DSA:2.120.10.30:FF:000527', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160498, NULL, 'G3DSA:3.40.50.410:FF:000301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160499, NULL, 'G3DSA:1.20.1510.10:FF:000076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160500, NULL, 'G3DSA:3.40.50.620:FF:000701', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160501, NULL, 'G3DSA:1.10.10.60:FF:001134', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160502, NULL, 'G3DSA:1.25.40.280:FF:000012', NULL, NULL, 'BRO1-like domain/ALIX V-shaped domain binding to HIV, putative', NULL, NULL, NULL, NULL, NULL, 4),
(160503, NULL, 'G3DSA:3.90.650.10:FF:000024', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(160504, NULL, 'G3DSA:3.30.420.40:FF:000507', NULL, NULL, 'O-sialoglycoprotein endopeptidase-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(160505, NULL, 'G3DSA:2.60.40.420:FF:000240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160506, NULL, 'G3DSA:2.10.10.100:FF:000003', NULL, NULL, 'UDP-N-acetylglucosamine pyrophosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(160507, NULL, 'G3DSA:3.30.70.330:FF:000205', NULL, NULL, 'Sex lethal, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(160508, NULL, 'G3DSA:3.30.450.30:FF:000006', NULL, NULL, 'Profilin', NULL, NULL, NULL, NULL, NULL, 4),
(160509, NULL, 'G3DSA:1.10.150.20:FF:000009', NULL, NULL, 'Flap endonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(160510, NULL, 'G3DSA:1.20.5.710:FF:000015', NULL, NULL, '39S ribosomal protein L12, mitochondrial-like', NULL, NULL, NULL, NULL, NULL, 4),
(160511, NULL, 'G3DSA:1.10.10.10:FF:001052', NULL, NULL, 'Protein CBG12577', NULL, NULL, NULL, NULL, NULL, 4),
(160512, NULL, 'G3DSA:1.10.1420.10:FF:000066', NULL, NULL, 'DNA mismatch repair protein mutS, putative', NULL, NULL, NULL, NULL, NULL, 4),
(160513, NULL, 'G3DSA:1.10.510.10:FF:001304', NULL, NULL, 'Kinase suppressor of Ras 2', NULL, NULL, NULL, NULL, NULL, 4),
(160514, NULL, 'G3DSA:2.170.140.10:FF:000026', NULL, NULL, 'Blast:Peritrophin-1', NULL, NULL, NULL, NULL, NULL, 4),
(160515, NULL, 'G3DSA:3.40.50.1820:FF:001864', NULL, NULL, 'Carboxylesterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(160516, NULL, 'G3DSA:3.40.50.12780:FF:000104', NULL, NULL, 'Ochratoxin A non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(160517, NULL, 'G3DSA:2.90.10.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160518, NULL, 'G3DSA:3.90.110.10:FF:000012', NULL, NULL, 'Malate dehydrogenase (NAD)', NULL, NULL, NULL, NULL, NULL, 4),
(160519, NULL, 'G3DSA:3.30.70.330:FF:000845', NULL, NULL, 'CCR4-NOT transcription complex subunit 4, variant 1', NULL, NULL, NULL, NULL, NULL, 4),
(160520, NULL, 'G3DSA:2.120.10.30:FF:000157', NULL, NULL, 'FI21413p1', NULL, NULL, NULL, NULL, NULL, 4),
(160521, NULL, 'G3DSA:1.20.1070.10:FF:002059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160522, NULL, 'G3DSA:3.40.50.300:FF:000499', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(160523, NULL, 'G3DSA:1.10.220.150:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160524, NULL, 'G3DSA:1.10.10.10:FF:000563', NULL, NULL, 'RNA polymerase sigma factor SigB', NULL, NULL, NULL, NULL, NULL, 4),
(160525, NULL, 'G3DSA:3.40.50.970:FF:000227', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160526, NULL, 'G3DSA:3.40.50.2000:FF:000154', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(160527, NULL, 'G3DSA:1.25.40.10:FF:000677', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(160528, NULL, 'G3DSA:1.25.10.10:FF:002957', NULL, NULL, 'Exportin-T', NULL, NULL, NULL, NULL, NULL, 4),
(160529, NULL, 'G3DSA:3.40.140.10:FF:000284', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160530, NULL, 'G3DSA:3.10.450.50:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(160531, NULL, 'G3DSA:3.50.7.10:FF:000090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160532, NULL, 'G3DSA:2.40.50.730:FF:000019', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(160533, NULL, 'G3DSA:3.30.900.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160534, NULL, 'G3DSA:2.60.120.290:FF:000007', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(160535, NULL, 'G3DSA:3.30.43.10:FF:000009', NULL, NULL, 'Glycolate oxidase, subunit GlcD', NULL, NULL, NULL, NULL, NULL, 4),
(160536, NULL, 'G3DSA:1.10.510.10:FF:002934', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160537, NULL, 'G3DSA:3.40.50.720:FF:002513', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160538, NULL, 'G3DSA:1.20.1070.10:FF:000721', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160539, NULL, 'G3DSA:3.30.160.60:FF:000897', NULL, NULL, 'Zinc finger and BTB domain-containing protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(160540, NULL, 'G3DSA:1.20.58.1880:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160541, NULL, 'G3DSA:1.50.40.10:FF:000389', NULL, NULL, 'Protein CBG24187', NULL, NULL, NULL, NULL, NULL, 4),
(160542, NULL, 'G3DSA:1.10.10.10:FF:000872', NULL, NULL, 'Probable hydrogen peroxide-inducible genes activator', NULL, NULL, NULL, NULL, NULL, 4),
(160543, NULL, 'G3DSA:1.20.1250.10:FF:000140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160544, NULL, 'G3DSA:3.30.420.40:FF:000496', NULL, NULL, 'Hsp70 protein/TPR repeat/Tetratricopeptide repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(160545, NULL, 'G3DSA:1.25.40.10:FF:004404', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160546, NULL, 'G3DSA:2.30.130.40:FF:000034', NULL, NULL, 'LON peptidase N-terminal domain and RING finger protein C14F5.10c', NULL, NULL, NULL, NULL, NULL, 4),
(160547, NULL, 'G3DSA:3.30.70.330:FF:000166', NULL, NULL, 'Trna selenocysteine 1-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(160548, NULL, 'G3DSA:1.20.1250.20:FF:000143', NULL, NULL, 'Protein NRT1/ PTR FAMILY 6.3', NULL, NULL, NULL, NULL, NULL, 4),
(160549, NULL, 'G3DSA:2.60.40.420:FF:000116', NULL, NULL, 'Os02g0725500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(160550, NULL, 'G3DSA:3.20.20.140:FF:000022', NULL, NULL, 'Guanine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(160551, NULL, 'G3DSA:3.40.50.300:FF:008267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160552, NULL, 'G3DSA:1.10.510.10:FF:001613', NULL, NULL, 'Serine/threonine-protein kinase VRK1', NULL, NULL, NULL, NULL, NULL, 4),
(160553, NULL, 'G3DSA:3.30.450.20:FF:000003', NULL, NULL, 'Aryl hydrocarbon receptor nuclear translocator 2', NULL, NULL, NULL, NULL, NULL, 4),
(160554, NULL, 'G3DSA:3.90.920.10:FF:000017', NULL, NULL, 'DNA primase small subunit PriS', NULL, NULL, NULL, NULL, NULL, 4),
(160555, NULL, 'G3DSA:1.10.486.10:FF:000038', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(160556, NULL, 'G3DSA:3.30.70.1730:FF:000013', NULL, NULL, '50S ribosomal protein L10', NULL, NULL, NULL, NULL, NULL, 4),
(160557, NULL, 'G3DSA:2.10.110.10:FF:000242', NULL, NULL, 'YALI0A18381p', NULL, NULL, NULL, NULL, NULL, 4),
(160558, NULL, 'G3DSA:2.40.128.130:FF:000008', NULL, NULL, 'Serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(160559, NULL, 'G3DSA:2.30.30.1190:FF:000003', NULL, NULL, 'Zinc finger CCCH domain-containing protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(160560, NULL, 'G3DSA:3.30.930.10:FF:000110', NULL, NULL, 'Lipoate-protein ligase B', NULL, NULL, NULL, NULL, NULL, 4),
(160561, NULL, 'G3DSA:2.60.120.200:FF:000037', NULL, NULL, 'Meprin A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(160562, NULL, 'G3DSA:3.30.70.3040:FF:000002', NULL, NULL, 'Cell division protein FtsX', NULL, NULL, NULL, NULL, NULL, 4),
(160563, NULL, 'G3DSA:1.25.10.10:FF:001322', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(160564, NULL, 'G3DSA:2.40.70.10:FF:000097', NULL, NULL, 'Aspartyl protease AED3', NULL, NULL, NULL, NULL, NULL, 4),
(160565, NULL, 'G3DSA:1.20.58.1480:FF:000014', NULL, NULL, 'Lon protease', NULL, NULL, NULL, NULL, NULL, 4),
(160566, NULL, 'G3DSA:3.40.225.10:FF:000003', NULL, NULL, 'Methylthioribulose-1-phosphate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(160567, NULL, 'G3DSA:3.30.40.10:FF:002122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160568, NULL, 'G3DSA:1.10.287.370:FF:000032', NULL, NULL, 'Prefoldin 5-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(160569, NULL, 'G3DSA:3.30.70.330:FF:000194', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit G', NULL, NULL, NULL, NULL, NULL, 4),
(160570, NULL, 'G3DSA:3.30.200.20:FF:000827', NULL, NULL, 'Unplaced genomic scaffold supercont1.6, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(160571, NULL, 'G3DSA:3.50.50.60:FF:001001', NULL, NULL, 'Rab proteins geranylgeranyltransferase component A', NULL, NULL, NULL, NULL, NULL, 4),
(160572, NULL, 'G3DSA:2.60.40.150:FF:000159', NULL, NULL, 'Synaptotagmin-7', NULL, NULL, NULL, NULL, NULL, 4),
(160573, NULL, 'G3DSA:3.30.760.10:FF:000063', NULL, NULL, 'Putative translation initiation factor 4f cap-binding subunit eif-4e', NULL, NULL, NULL, NULL, NULL, 4),
(160574, NULL, 'G3DSA:3.30.160.60:FF:004933', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160575, NULL, 'G3DSA:2.30.30.150:FF:000001', NULL, NULL, 'Transcriptional repressor protein KorB', NULL, NULL, NULL, NULL, NULL, 4),
(160576, NULL, 'G3DSA:3.30.230.10:FF:000326', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160577, NULL, 'G3DSA:3.40.50.10540:FF:000011', NULL, NULL, 'GH11368p', NULL, NULL, NULL, NULL, NULL, 4),
(160578, NULL, 'G3DSA:3.10.129.10:FF:000207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160579, NULL, 'G3DSA:3.30.160.60:FF:005006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160580, NULL, 'G3DSA:1.20.1740.10:FF:000031', NULL, NULL, 'Glutamate:gamma-aminobutyric acid antiporter', NULL, NULL, NULL, NULL, NULL, 4),
(160581, NULL, 'G3DSA:1.10.287.80:FF:000018', NULL, NULL, 'ATP synthase gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(160582, NULL, 'G3DSA:3.40.50.620:FF:000027', NULL, NULL, 'Cysteine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(160583, NULL, 'G3DSA:1.25.40.10:FF:001060', NULL, NULL, 'Os05g0572900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(160584, NULL, 'G3DSA:2.60.40.10:FF:001302', NULL, NULL, 'Interleukin 1 receptor like 2', NULL, NULL, NULL, NULL, NULL, 4),
(160585, NULL, 'G3DSA:3.10.450.700:FF:000007', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160586, NULL, 'G3DSA:1.25.40.120:FF:000020', NULL, NULL, 'Rab geranylgeranyltransferase alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(160587, NULL, 'G3DSA:3.40.50.300:FF:008357', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160588, NULL, 'G3DSA:3.10.20.90:FF:000583', NULL, NULL, 'Ubiquitin-like protein ATG12', NULL, NULL, NULL, NULL, NULL, 4),
(160589, NULL, 'G3DSA:1.10.287.70:FF:000015', NULL, NULL, 'Calcium-activated potassium channel subunit alpha-1 isoform X7', NULL, NULL, NULL, NULL, NULL, 4),
(160590, NULL, 'G3DSA:2.60.310.20:FF:000001', NULL, NULL, 'Tyrosinase', NULL, NULL, NULL, NULL, NULL, 4),
(160591, NULL, 'G3DSA:3.30.70.1450:FF:000036', NULL, NULL, 'Calcium-gated potassium channel MthK', NULL, NULL, NULL, NULL, NULL, 4),
(160592, NULL, 'G3DSA:3.30.565.10:FF:000317', NULL, NULL, 'DNA mismatch repair protein Mlh1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(160593, NULL, 'G3DSA:2.60.120.590:FF:000002', NULL, NULL, 'RNA demethylase ALKBH5', NULL, NULL, NULL, NULL, NULL, 4),
(160594, NULL, 'G3DSA:1.10.101.10:FF:000022', NULL, NULL, 'Spore cortex-lytic enzyme pre-pro-form', NULL, NULL, NULL, NULL, NULL, 4),
(160595, NULL, 'G3DSA:1.25.40.20:FF:001063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160596, NULL, 'G3DSA:3.40.980.10:FF:000049', NULL, NULL, 'FAD synthase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(160597, NULL, 'G3DSA:1.20.120.1750:FF:000159', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(160598, NULL, 'G3DSA:1.10.287.380:FF:000035', NULL, NULL, 'DNA-binding ATPase Uup', NULL, NULL, NULL, NULL, NULL, 4),
(160599, NULL, 'G3DSA:2.60.40.10:FF:004484', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160600, NULL, 'G3DSA:3.30.2450.30:FF:000005', NULL, NULL, 'Transcriptional activator protein Pur-alpha', NULL, NULL, NULL, NULL, NULL, 4),
(160601, NULL, 'G3DSA:2.60.120.200:FF:000172', NULL, NULL, 'Adhesion G protein-coupled receptor G4', NULL, NULL, NULL, NULL, NULL, 4),
(160602, NULL, 'G3DSA:3.40.50.2300:FF:000923', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160603, NULL, 'G3DSA:3.40.50.150:FF:000763', NULL, NULL, 'DUF858-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(160604, NULL, 'G3DSA:1.25.40.10:FF:002454', NULL, NULL, 'Pentatricopeptide repeat-containing protein CRP1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(160605, NULL, 'G3DSA:1.10.238.10:FF:001036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160606, NULL, 'G3DSA:3.30.870.10:FF:000094', NULL, NULL, 'Competence protein ComE', NULL, NULL, NULL, NULL, NULL, 4),
(160607, NULL, 'G3DSA:3.20.20.300:FF:000003', NULL, NULL, 'Beta-D-glucan exohydrolase isoenzyme ExoI', NULL, NULL, NULL, NULL, NULL, 4),
(160608, NULL, 'G3DSA:1.10.8.270:FF:000099', NULL, NULL, 'Growth hormone-regulated TBC protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(160609, NULL, 'G3DSA:3.40.50.1000:FF:000663', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160610, NULL, 'G3DSA:2.60.40.60:FF:000199', NULL, NULL, 'neural-cadherin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(160611, NULL, 'G3DSA:1.10.472.10:FF:000552', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160612, NULL, 'G3DSA:2.40.50.120:FF:000050', NULL, NULL, 'Netrin 3', NULL, NULL, NULL, NULL, NULL, 4),
(160613, NULL, 'G3DSA:1.25.40.20:FF:001153', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160614, NULL, 'G3DSA:1.25.40.10:FF:002678', NULL, NULL, 'NASP-related protein sim3', NULL, NULL, NULL, NULL, NULL, 4),
(160615, NULL, 'G3DSA:3.80.10.10:FF:001668', NULL, NULL, 'Cytoplasmic membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(160616, NULL, 'G3DSA:3.30.710.10:FF:000262', NULL, NULL, 'Assembly of substrate-specific ubiquitin ligase complexes modulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(160617, NULL, 'G3DSA:3.40.50.300:FF:008593', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160618, NULL, 'G3DSA:2.60.120.260:FF:000583', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160619, NULL, 'G3DSA:3.30.70.660:FF:000051', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(160620, NULL, 'G3DSA:1.10.510.10:FF:002378', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160621, NULL, 'G3DSA:3.40.50.970:FF:000222', NULL, NULL, '2-hydroxyacyl-CoA lyase 1', NULL, NULL, NULL, NULL, NULL, 4),
(160622, NULL, 'G3DSA:2.40.10.10:FF:000469', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160623, NULL, 'G3DSA:3.80.10.10:FF:004074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160624, NULL, 'G3DSA:3.40.630.10:FF:000366', NULL, NULL, 'Carboxypeptidase D, b', NULL, NULL, NULL, NULL, NULL, 4),
(160625, NULL, 'G3DSA:2.20.100.10:FF:000025', NULL, NULL, 'ADAMTS like 1', NULL, NULL, NULL, NULL, NULL, 4),
(160626, NULL, 'G3DSA:1.25.40.180:FF:000100', NULL, NULL, 'Pre-mRNA-splicing factor cwc22, putative', NULL, NULL, NULL, NULL, NULL, 4),
(160627, NULL, 'G3DSA:1.20.1250.10:FF:000050', NULL, NULL, 'Chorionic somatomammotropin hormone 1', NULL, NULL, NULL, NULL, NULL, 4),
(160628, NULL, 'G3DSA:3.40.50.300:FF:004670', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160629, NULL, 'G3DSA:3.90.70.10:FF:000547', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160630, NULL, 'G3DSA:3.10.400.20:FF:000004', NULL, NULL, 'Eukaryotic Initiation Factor', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(160631, NULL, 'G3DSA:1.25.40.10:FF:004932', NULL, NULL, 'Os01g0390600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(160632, NULL, 'G3DSA:1.10.287.1060:FF:000010', NULL, NULL, 'conserved oligomeric Golgi complex subunit 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(160633, NULL, 'G3DSA:3.80.10.10:FF:000403', NULL, NULL, 'Receptor-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(160634, NULL, 'G3DSA:1.10.238.10:FF:000856', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(160635, NULL, 'G3DSA:1.25.10.10:FF:000850', NULL, NULL, 'Importin beta SMX1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(160636, NULL, 'G3DSA:1.20.5.1300:FF:000011', NULL, NULL, 'Putative histidinol dehydrogenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(160637, NULL, 'G3DSA:3.30.70.330:FF:000840', NULL, NULL, 'Uncharacterized protein, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(160638, NULL, 'G3DSA:1.10.8.10:FF:000011', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(160639, NULL, 'G3DSA:2.170.130.10:FF:000071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160640, NULL, 'G3DSA:3.30.1370.10:FF:000038', NULL, NULL, 'exosome complex component RRP40', NULL, NULL, NULL, NULL, NULL, 4),
(160641, NULL, 'G3DSA:1.20.1560.10:FF:000017', NULL, NULL, 'Cystic fibrosis transmembrane conductance regulator', NULL, NULL, NULL, NULL, NULL, 4),
(160642, NULL, 'G3DSA:3.30.160.60:FF:001263', NULL, NULL, 'zinc finger protein 341 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(160643, NULL, 'G3DSA:2.60.40.10:FF:002578', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160644, NULL, 'G3DSA:2.40.50.140:FF:000056', NULL, NULL, '26S protease regulatory subunit 6A', NULL, NULL, NULL, NULL, NULL, 4),
(160645, NULL, 'G3DSA:2.70.160.11:FF:000024', NULL, NULL, 'Arginine methyltransferase 8', NULL, NULL, NULL, NULL, NULL, 4),
(160646, NULL, 'G3DSA:3.40.50.300:FF:003124', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(160647, NULL, 'G3DSA:2.160.20.10:FF:000240', NULL, NULL, 'Exopolygalacturonase clone GBGE184', NULL, NULL, NULL, NULL, NULL, 4),
(160648, NULL, 'G3DSA:2.70.40.10:FF:000037', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160649, NULL, 'G3DSA:1.25.40.10:FF:004623', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160650, NULL, 'G3DSA:2.20.70.10:FF:000272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160651, NULL, 'G3DSA:2.130.10.10:FF:002887', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160652, NULL, 'G3DSA:3.10.20.90:FF:000785', NULL, NULL, 'polycomb group protein Psc', NULL, NULL, NULL, NULL, NULL, 4),
(160653, NULL, 'G3DSA:3.10.450.50:FF:000062', NULL, NULL, 'Austinol synthesis protein F', NULL, NULL, NULL, NULL, NULL, 4),
(160654, NULL, 'G3DSA:2.60.120.260:FF:000274', NULL, NULL, 'O-GlcNAcase NagJ', NULL, NULL, NULL, NULL, NULL, 4),
(160655, NULL, 'G3DSA:3.30.200.20:FF:000743', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(160656, NULL, 'G3DSA:1.25.40.10:FF:001150', NULL, NULL, 'Pre-mRNA-splicing factor SYF1', NULL, NULL, NULL, NULL, NULL, 4),
(160657, NULL, 'G3DSA:2.10.50.30:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160658, NULL, 'G3DSA:3.40.50.300:FF:000960', NULL, NULL, 'Si:ch211-196f19.1', NULL, NULL, NULL, NULL, NULL, 4),
(160659, NULL, 'G3DSA:1.10.10.440:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160660, NULL, 'G3DSA:1.10.10.10:FF:000198', NULL, NULL, 'HTH-type transcriptional repressor AllR', NULL, NULL, NULL, NULL, NULL, 4),
(160661, NULL, 'G3DSA:2.30.36.70:FF:000007', NULL, NULL, 'Actin-like 6a isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(160662, NULL, 'G3DSA:1.10.238.10:FF:000963', NULL, NULL, 'Troponin C, isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(160663, NULL, 'G3DSA:2.20.100.10:FF:000132', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs adt-2', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(160664, NULL, 'G3DSA:3.40.228.10:FF:000026', NULL, NULL, 'NADPH-Fe(3+) oxidoreductase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(160665, NULL, 'G3DSA:1.25.10.10:FF:001232', NULL, NULL, 'armadillo repeat-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(160666, NULL, 'G3DSA:3.30.2350.20:FF:000068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160667, NULL, 'G3DSA:3.30.450.20:FF:000110', NULL, NULL, 'Signal transduction histidine-protein kinase atoS', NULL, NULL, NULL, NULL, NULL, 4),
(160668, NULL, 'G3DSA:1.10.510.10:FF:002687', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160669, NULL, 'G3DSA:3.40.50.1820:FF:001645', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(160670, NULL, 'G3DSA:3.30.450.330:FF:000004', NULL, NULL, 'Stage V sporulation protein D', NULL, NULL, NULL, NULL, NULL, 4),
(160671, NULL, 'G3DSA:1.20.272.10:FF:000091', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160672, NULL, 'G3DSA:1.10.150.20:FF:000026', NULL, NULL, 'DNA polymerase beta', NULL, NULL, NULL, NULL, NULL, 4),
(160673, NULL, 'G3DSA:3.40.1090.10:FF:000076', NULL, NULL, 'Patatin', NULL, NULL, NULL, NULL, NULL, 4),
(160674, NULL, 'G3DSA:3.30.40.10:FF:001588', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160675, NULL, 'G3DSA:2.40.340.10:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160676, NULL, 'G3DSA:3.30.70.960:FF:000017', NULL, NULL, 'Mucin 13b, cell surface-associated', NULL, NULL, NULL, NULL, NULL, 4),
(160677, NULL, 'G3DSA:1.10.3630.10:FF:000003', NULL, NULL, 'Golgi phosphoprotein 3', NULL, NULL, NULL, NULL, NULL, 4),
(160678, NULL, 'G3DSA:2.60.40.10:FF:001274', NULL, NULL, 'tyrosine-protein phosphatase Lar isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(160679, NULL, 'G3DSA:3.30.710.10:FF:000043', NULL, NULL, 'Zinc finger and BTB domain containing 7A', NULL, NULL, NULL, NULL, NULL, 4),
(160680, NULL, 'G3DSA:2.130.10.10:FF:002578', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160681, NULL, 'G3DSA:3.40.390.10:FF:000127', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160682, NULL, 'G3DSA:1.10.238.10:FF:000637', NULL, NULL, 'Putative calcium-binding protein CML20', NULL, NULL, NULL, NULL, NULL, 4),
(160683, NULL, 'G3DSA:1.20.1510.10:FF:000071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160684, NULL, 'G3DSA:1.20.1070.10:FF:001368', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160685, NULL, 'G3DSA:2.110.10.10:FF:000056', NULL, NULL, 'Hemopexin b', NULL, NULL, NULL, NULL, NULL, 4),
(160686, NULL, 'G3DSA:3.40.50.720:FF:002058', NULL, NULL, 'Dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(160687, NULL, 'G3DSA:3.40.50.300:FF:002977', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160688, NULL, 'G3DSA:3.10.20.90:FF:000476', NULL, NULL, 'Ubiquitin-like protein SUMO', NULL, NULL, NULL, NULL, NULL, 4),
(160689, NULL, 'G3DSA:3.30.2070.10:FF:000010', NULL, NULL, 'Thiosulfate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(160690, NULL, 'G3DSA:3.40.50.2300:FF:000137', NULL, NULL, 'Histidine kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(160691, NULL, 'G3DSA:1.10.8.60:FF:000110', NULL, NULL, 'Ribosome biogenesis ATPase RIX7', NULL, NULL, NULL, NULL, NULL, 4),
(160692, NULL, 'G3DSA:3.40.50.880:FF:000184', NULL, NULL, 'Anthranilate synthase component II', NULL, NULL, NULL, NULL, NULL, 4),
(160693, NULL, 'G3DSA:3.40.50.2000:FF:000171', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(160694, NULL, 'G3DSA:1.20.1070.10:FF:001716', NULL, NULL, 'Mu-opioid receptor', NULL, NULL, NULL, NULL, NULL, 4),
(160695, NULL, 'G3DSA:3.20.140.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160696, NULL, 'G3DSA:3.40.50.300:FF:005810', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160697, NULL, 'G3DSA:3.10.50.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160698, NULL, 'G3DSA:3.30.160.60:FF:004826', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(160699, NULL, 'G3DSA:2.60.40.10:FF:002269', NULL, NULL, 'Myotactin form B', NULL, NULL, NULL, NULL, NULL, 4),
(160700, NULL, 'G3DSA:1.20.1080.10:FF:000014', NULL, NULL, 'Aquaporin 1', NULL, NULL, NULL, NULL, NULL, 4),
(160701, NULL, 'G3DSA:3.10.20.90:FF:000818', NULL, NULL, 'Autophagy-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(160702, NULL, 'G3DSA:3.30.420.40:FF:000479', NULL, NULL, 'Glycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(160703, NULL, 'G3DSA:3.30.40.10:FF:000177', NULL, NULL, 'PHD finger protein ING', NULL, NULL, NULL, NULL, NULL, 4),
(160704, NULL, 'G3DSA:1.10.238.10:FF:000873', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160705, NULL, 'G3DSA:1.20.1070.10:FF:001896', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160706, NULL, 'G3DSA:3.30.465.10:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160707, NULL, 'G3DSA:3.40.50.300:FF:005501', NULL, NULL, 'Helicase conserved C-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(160708, NULL, 'G3DSA:2.60.210.10:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160709, NULL, 'G3DSA:3.30.2350.10:FF:000065', NULL, NULL, 'YALI0B01276p', NULL, NULL, NULL, NULL, NULL, 4),
(160710, NULL, 'G3DSA:1.20.1700.10:FF:000006', NULL, NULL, 'Pantothenate kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(160711, NULL, 'G3DSA:2.10.25.10:FF:001680', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160712, NULL, 'G3DSA:3.40.50.620:FF:000246', NULL, NULL, 'NH3-dependent NAD+ synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(160713, NULL, 'G3DSA:3.40.50.80:FF:000131', NULL, NULL, 'Mitochondrial NADH-dependent fumarate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(160714, NULL, 'G3DSA:3.80.10.10:FF:000061', NULL, NULL, 'leucine-rich repeat-containing protein 7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(160715, NULL, 'G3DSA:3.50.50.60:FF:000506', NULL, NULL, 'peroxisomal N(1)-acetyl-spermine/spermidine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(160716, NULL, 'G3DSA:1.20.1070.10:FF:001677', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160717, NULL, 'G3DSA:1.10.150.170:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160718, NULL, 'G3DSA:3.30.70.270:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160719, NULL, 'G3DSA:1.10.510.10:FF:001630', NULL, NULL, 'KIT proto-oncogene receptor tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(160720, NULL, 'G3DSA:3.30.70.330:FF:002329', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160721, NULL, 'G3DSA:1.25.40.10:FF:000880', NULL, NULL, 'Pentatricopeptide (PPR) repeat-containing protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(160722, NULL, 'G3DSA:2.60.120.200:FF:000256', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(160723, NULL, 'G3DSA:3.40.30.10:FF:001227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160724, NULL, 'G3DSA:2.40.70.10:FF:000136', NULL, NULL, 'Putative nucleoid DNA-binding protein cnd41, chloroplast', NULL, NULL, NULL, NULL, NULL, 4),
(160725, NULL, 'G3DSA:2.10.25.10:FF:000050', NULL, NULL, 'neurogenic locus notch homolog protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(160726, NULL, 'G3DSA:3.40.50.2000:FF:000822', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160727, NULL, 'G3DSA:1.10.420.10:FF:000016', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(160728, NULL, 'G3DSA:1.25.40.20:FF:000883', NULL, NULL, 'E3 ubiquitin-protein ligase KEG', NULL, NULL, NULL, NULL, NULL, 4),
(160729, NULL, 'G3DSA:3.30.70.330:FF:002083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160730, NULL, 'G3DSA:3.10.20.10:FF:000014', NULL, NULL, '60S ribosomal protein L18a (partial)', NULL, NULL, NULL, NULL, NULL, 4),
(160731, NULL, 'G3DSA:3.40.50.300:FF:002758', NULL, NULL, 'Ras-related protein Rab-1A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(160732, NULL, 'G3DSA:3.40.50.300:FF:006468', NULL, NULL, 'Ferric transport protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(160733, NULL, 'G3DSA:1.10.1300.10:FF:000012', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(160734, NULL, 'G3DSA:1.25.10.10:FF:001013', NULL, NULL, 'Uncharacterized ARM-like repeat-containing protein C1703.03c', NULL, NULL, NULL, NULL, NULL, 4),
(160735, NULL, 'G3DSA:2.40.50.140:FF:000617', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(160736, NULL, 'G3DSA:2.130.10.10:FF:003989', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160737, NULL, 'G3DSA:3.60.20.10:FF:000141', NULL, NULL, 'Asparagine synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(160738, NULL, 'G3DSA:3.40.50.1220:FF:000009', NULL, NULL, 'Pyruvate decarboxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(160739, NULL, 'G3DSA:3.30.40.10:FF:001279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160740, NULL, 'G3DSA:3.10.20.70:FF:000009', NULL, NULL, 'Glutamate-ammonia ligase', NULL, NULL, NULL, NULL, NULL, 4),
(160741, NULL, 'G3DSA:3.90.79.10:FF:000067', NULL, NULL, 'Nudix hydrolase 16', NULL, NULL, NULL, NULL, NULL, 4),
(160742, NULL, 'G3DSA:3.90.70.10:FF:000873', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160743, NULL, 'G3DSA:1.20.58.310:FF:000002', NULL, NULL, 'Polyphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(160744, NULL, 'G3DSA:2.60.260.20:FF:000025', NULL, NULL, 'Molecular chaperone Hsp40/DnaJ family protein', NULL, NULL, NULL, NULL, NULL, 4),
(160745, NULL, 'G3DSA:3.30.70.330:FF:000621', NULL, NULL, 'Nuclear localization sequence-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(160746, NULL, 'G3DSA:1.20.58.2190:FF:000002', NULL, NULL, 'spermatogenesis-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(160747, NULL, 'G3DSA:3.30.160.60:FF:001044', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(160748, NULL, 'G3DSA:2.60.40.10:FF:002359', NULL, NULL, 'Protein sidekick homolog', NULL, NULL, NULL, NULL, NULL, 4),
(160749, NULL, 'G3DSA:1.10.10.1420:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160750, NULL, 'G3DSA:3.40.50.300:FF:008374', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160751, NULL, 'G3DSA:2.30.30.40:FF:000199', NULL, NULL, 'Sorting nexin', NULL, NULL, NULL, NULL, NULL, 4),
(160752, NULL, 'G3DSA:3.10.110.10:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160753, NULL, 'G3DSA:3.100.10.10:FF:000013', NULL, NULL, '50S ribosomal protein L18e', NULL, NULL, NULL, NULL, NULL, 4),
(160754, NULL, 'G3DSA:1.20.1250.20:FF:000036', NULL, NULL, 'Hexuronate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(160755, NULL, 'G3DSA:2.10.109.10:FF:000070', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160756, NULL, 'G3DSA:3.40.50.11210:FF:000004', NULL, NULL, 'Tuberin isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(160757, NULL, 'G3DSA:3.40.630.10:FF:000282', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160758, NULL, 'G3DSA:3.40.50.2000:FF:000261', NULL, NULL, 'Putative glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(160759, NULL, 'G3DSA:3.30.70.330:FF:002638', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160760, NULL, 'G3DSA:2.40.70.10:FF:000445', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160761, NULL, 'G3DSA:3.30.710.10:FF:000352', NULL, NULL, 'SKP1-like protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(160762, NULL, 'G3DSA:3.30.40.10:FF:002212', NULL, NULL, 'E3 ubiquitin-protein ligase mind-bomb-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(160763, NULL, 'G3DSA:3.30.300.180:FF:000005', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(160764, NULL, 'G3DSA:3.90.1280.20:FF:000003', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(160765, NULL, 'G3DSA:3.10.129.10:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160766, NULL, 'G3DSA:1.20.1070.10:FF:000266', NULL, NULL, 'Atypical chemokine receptor 1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(160767, NULL, 'G3DSA:3.40.5.60:FF:000009', NULL, NULL, 'DNA replication complex GINS protein sld5', NULL, NULL, NULL, NULL, NULL, 4),
(160768, NULL, 'G3DSA:3.40.190.10:FF:000337', NULL, NULL, 'ABC transporter, periplasmic substrate-binding protein YnjB', NULL, NULL, NULL, NULL, NULL, 4),
(160769, NULL, 'G3DSA:1.25.40.20:FF:001714', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160770, NULL, 'G3DSA:3.80.10.10:FF:002511', NULL, NULL, 'Tubulin-specific chaperone E-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(160771, NULL, 'G3DSA:3.30.470.20:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160772, NULL, 'G3DSA:3.30.70.1350:FF:000006', NULL, NULL, 'Cation transporter', NULL, NULL, NULL, NULL, NULL, 4),
(160773, NULL, 'G3DSA:2.130.10.10:FF:000780', NULL, NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(160774, NULL, 'G3DSA:3.40.630.10:FF:000057', NULL, NULL, 'Vacuolar membrane protease', NULL, NULL, NULL, NULL, NULL, 4),
(160775, NULL, 'G3DSA:2.30.30.140:FF:000104', NULL, NULL, 'Unplaced genomic scaffold supercont2.8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(160776, NULL, 'G3DSA:3.30.1520.10:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160777, NULL, 'G3DSA:3.30.1370.50:FF:000027', NULL, NULL, 'G-patch and R3H domain-containing protein C30B4.02c', NULL, NULL, NULL, NULL, NULL, 4),
(160778, NULL, 'G3DSA:3.30.160.60:FF:003516', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160779, NULL, 'G3DSA:1.20.1510.10:FF:000093', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160780, NULL, 'G3DSA:1.10.510.10:FF:000809', NULL, NULL, 'Serine/threonine-protein kinase-like protein At5g23170', NULL, NULL, NULL, NULL, NULL, 4),
(160781, NULL, 'G3DSA:2.30.29.30:FF:000131', NULL, NULL, 'Kinesin-like calmodulin-binding protein (ZWICHEL)', NULL, NULL, NULL, NULL, NULL, 4),
(160782, NULL, 'G3DSA:3.40.50.1820:FF:001729', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160783, NULL, 'G3DSA:2.120.10.30:FF:000488', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160784, NULL, 'G3DSA:3.30.160.60:FF:002898', NULL, NULL, 'endothelial zinc finger protein induced by tumor necrosis factor alpha', NULL, NULL, NULL, NULL, NULL, 4),
(160785, NULL, 'G3DSA:3.10.20.70:FF:000026', NULL, NULL, 'Extracellular developmental signal biosynthesis protein FluG', NULL, NULL, NULL, NULL, NULL, 4),
(160786, NULL, 'G3DSA:2.70.20.10:FF:000019', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(160787, NULL, 'G3DSA:1.10.510.10:FF:001271', NULL, NULL, 'Putative serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(160788, NULL, 'G3DSA:3.50.50.60:FF:000495', NULL, NULL, 'Putative dihydrolipoamide dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(160789, NULL, 'G3DSA:3.10.200.10:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160790, NULL, 'G3DSA:3.30.70.1050:FF:000017', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(160791, NULL, 'G3DSA:3.40.366.10:FF:000021', NULL, NULL, 'Malonyl-CoA:ACP transferase', NULL, NULL, NULL, NULL, NULL, 4),
(160792, NULL, 'G3DSA:3.40.50.300:FF:001196', NULL, NULL, 'ATP-dependent helicase/nuclease subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(160793, NULL, 'G3DSA:2.30.42.10:FF:000633', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160794, NULL, 'G3DSA:3.50.50.100:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160795, NULL, 'G3DSA:3.40.190.10:FF:000028', NULL, NULL, 'Arogenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(160796, NULL, 'G3DSA:1.20.5.190:FF:000039', NULL, NULL, 'Myosin VB', NULL, NULL, NULL, NULL, NULL, 4),
(160797, NULL, 'G3DSA:2.60.220.50:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160798, NULL, 'G3DSA:2.40.50.90:FF:000181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(160799, NULL, 'G3DSA:3.90.150.10:FF:000003', NULL, NULL, 'Variant surface glycoprotein (VSG), putative', NULL, NULL, NULL, NULL, NULL, 4),
(160800, NULL, 'G3DSA:1.25.40.820:FF:000016', NULL, NULL, 'Putative RNA polymerase II subunit B1 CTD phosphatase RPAP2', NULL, NULL, NULL, NULL, NULL, 4),
(160801, NULL, 'G3DSA:1.20.1530.20:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160802, NULL, 'G3DSA:3.30.300.30:FF:000001', NULL, NULL, 'DIP2 disco-interacting protein 2 homolog C', NULL, NULL, NULL, NULL, NULL, 4),
(160803, NULL, 'G3DSA:3.40.50.2000:FF:000715', NULL, NULL, 'Glycosyl transferase group 1', NULL, NULL, NULL, NULL, NULL, 4),
(160804, NULL, 'G3DSA:1.10.357.50:FF:000021', NULL, NULL, 'Exocyst complex component Sec6-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(160805, NULL, 'G3DSA:3.40.228.10:FF:000004', NULL, NULL, 'Dimethyl sulfoxide reductase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(160806, NULL, 'G3DSA:2.10.25.10:FF:000044', NULL, NULL, 'Fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(160807, NULL, 'G3DSA:1.20.58.60:FF:000434', NULL, NULL, 'Spectrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(160808, NULL, 'G3DSA:3.40.50.670:FF:000020', NULL, NULL, 'DNA topoisomerase II', NULL, NULL, NULL, NULL, NULL, 4),
(160809, NULL, 'G3DSA:1.20.58.1080:FF:000001', NULL, NULL, 'ATP-dependent RNA helicase SUPV3L1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(160810, NULL, 'G3DSA:2.120.10.30:FF:000073', NULL, NULL, 'Protein STRICTOSIDINE SYNTHASE-LIKE 6', NULL, NULL, NULL, NULL, NULL, 4),
(160811, NULL, 'G3DSA:1.10.274.100:FF:000032', NULL, NULL, 'RNA polymerase II largest subunit', NULL, NULL, NULL, NULL, NULL, 4),
(160812, NULL, 'G3DSA:3.30.420.40:FF:000586', NULL, NULL, 'Actin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(160813, NULL, 'G3DSA:3.30.200.20:FF:000518', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(160814, NULL, 'G3DSA:1.10.10.60:FF:000437', NULL, NULL, 'pathogenesis-related homeodomain protein', NULL, NULL, NULL, NULL, NULL, 4),
(160815, NULL, 'G3DSA:3.40.50.300:FF:006575', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160816, NULL, 'G3DSA:3.40.50.300:FF:004866', NULL, NULL, 'ATP-dependent helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(160817, NULL, 'G3DSA:1.25.10.10:FF:002087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160818, NULL, 'G3DSA:3.30.70.560:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160819, NULL, 'G3DSA:1.10.40.80:FF:000001', NULL, NULL, 'DsbA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(160820, NULL, 'G3DSA:1.20.1250.20:FF:001469', NULL, NULL, 'Putative monocarboxylate transporter 3 monocarboxylate transporter 3', NULL, NULL, NULL, NULL, NULL, 4),
(160821, NULL, 'G3DSA:3.30.70.270:FF:000035', NULL, NULL, 'Diguanylate cyclase YdeH', NULL, NULL, NULL, NULL, NULL, 4),
(160822, NULL, 'G3DSA:3.30.565.10:FF:000087', NULL, NULL, 'Histidine kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(160823, NULL, 'G3DSA:3.80.10.10:FF:004220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160824, NULL, 'G3DSA:3.20.20.150:FF:000008', NULL, NULL, 'Protein arginine N-methyltransferase 5', NULL, NULL, NULL, NULL, NULL, 4),
(160825, NULL, 'G3DSA:1.10.510.10:FF:000916', NULL, NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 42', NULL, NULL, NULL, NULL, NULL, 4),
(160826, NULL, 'G3DSA:3.90.20.20:FF:000002', NULL, NULL, 'Protein GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(160827, NULL, 'G3DSA:3.40.850.10:FF:000371', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(160828, NULL, 'G3DSA:2.60.120.650:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160829, NULL, 'G3DSA:3.30.1010.10:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160830, NULL, 'G3DSA:3.60.15.10:FF:000213', NULL, NULL, 'DNA repair metallo-beta-lactamase family protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(160831, NULL, 'G3DSA:3.10.20.90:FF:000892', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160832, NULL, 'G3DSA:3.30.70.330:FF:002419', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160833, NULL, 'G3DSA:1.10.720.80:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160834, NULL, 'G3DSA:2.40.170.20:FF:000096', NULL, NULL, 'SusC/RagA family TonB-linked outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(160835, NULL, 'G3DSA:3.100.10.10:FF:000007', NULL, NULL, '50S ribosomal protein L15', NULL, NULL, NULL, NULL, NULL, 4),
(160836, NULL, 'G3DSA:2.40.50.140:FF:000415', NULL, NULL, 'Single-stranded DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(160837, NULL, 'G3DSA:3.90.226.10:FF:000264', NULL, NULL, 'Nodulation efficiency, NfeD', NULL, NULL, NULL, NULL, NULL, 4),
(160838, NULL, 'G3DSA:1.10.730.10:FF:000118', NULL, NULL, 'Methionine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(160839, NULL, 'G3DSA:3.80.10.10:FF:000257', NULL, NULL, 'F-box protein FBW2', NULL, NULL, NULL, NULL, NULL, 4),
(160840, NULL, 'G3DSA:1.10.472.10:FF:000136', NULL, NULL, 'Cyclin 4', NULL, NULL, NULL, NULL, NULL, 4),
(160841, NULL, 'G3DSA:3.30.70.580:FF:000027', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(160842, NULL, 'G3DSA:3.30.559.10:FF:000027', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(160843, NULL, 'G3DSA:3.30.70.1390:FF:000012', NULL, NULL, 'Roco6, ROCO family protein', NULL, NULL, NULL, NULL, NULL, 4),
(160844, NULL, 'G3DSA:1.20.5.110:FF:000021', NULL, NULL, 'novel plant SNARE 11', NULL, NULL, NULL, NULL, NULL, 4),
(160845, NULL, 'G3DSA:3.40.1280.10:FF:000085', NULL, NULL, 'tRNA/rRNA methyltransferase (SpoU)', NULL, NULL, NULL, NULL, NULL, 4),
(160846, NULL, 'G3DSA:3.40.50.1000:FF:000769', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160847, NULL, 'G3DSA:3.30.40.10:FF:000194', NULL, NULL, 'ERAD-associated E3 ubiquitin-protein ligase HRD1A', NULL, NULL, NULL, NULL, NULL, 4),
(160848, NULL, 'G3DSA:3.30.200.20:FF:000266', NULL, NULL, 'probable serine/threonine-protein kinase RLCKVII', NULL, NULL, NULL, NULL, NULL, 4),
(160849, NULL, 'G3DSA:2.130.10.10:FF:004580', NULL, NULL, 'AGAP007799-PA', NULL, NULL, NULL, NULL, NULL, 4),
(160850, NULL, 'G3DSA:1.10.10.10:FF:001142', NULL, NULL, 'Protein CBG24678', NULL, NULL, NULL, NULL, NULL, 4),
(160851, NULL, 'G3DSA:3.40.50.720:FF:000260', NULL, NULL, 'Prephenate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(160852, NULL, 'G3DSA:1.10.3380.20:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160853, NULL, 'G3DSA:2.40.20.10:FF:000077', NULL, NULL, 'Putative macrophage stimulating 1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(160854, NULL, 'G3DSA:3.30.413.10:FF:000004', NULL, NULL, 'Sulfite reductase [NADPH] hemoprotein beta-component', NULL, NULL, NULL, NULL, NULL, 4),
(160855, NULL, 'G3DSA:3.90.190.10:FF:000112', NULL, NULL, 'Tyrosine-protein phosphatase CDC14 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(160856, NULL, 'G3DSA:3.20.20.100:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160857, NULL, 'G3DSA:3.40.50.10810:FF:000199', NULL, NULL, 'Protein CBR-RAD-54', NULL, NULL, NULL, NULL, NULL, 4),
(160858, NULL, 'G3DSA:2.60.120.200:FF:000481', NULL, NULL, 'MAM and LDL-receptor class A domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(160859, NULL, 'G3DSA:3.40.50.2300:FF:000159', NULL, NULL, 'Two-component response regulator ORR5', NULL, NULL, NULL, NULL, NULL, 4),
(160860, NULL, 'G3DSA:3.30.70.1450:FF:000053', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160861, NULL, 'G3DSA:1.25.10.10:FF:000743', NULL, NULL, 'Cytoplasmic export protein', NULL, NULL, NULL, NULL, NULL, 4),
(160862, NULL, 'G3DSA:2.60.40.10:FF:000796', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(160863, NULL, 'G3DSA:3.30.160.60:FF:000774', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(160864, NULL, 'G3DSA:3.30.70.260:FF:000032', NULL, NULL, 'UPF0237 protein SP_0238', NULL, NULL, NULL, NULL, NULL, 4),
(160865, NULL, 'G3DSA:2.60.40.10:FF:004068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160866, NULL, 'G3DSA:1.10.3380.30:FF:000017', NULL, NULL, 'DEAD/DEAH box helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(160867, NULL, 'G3DSA:3.30.40.10:FF:002228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160868, NULL, 'G3DSA:2.60.40.10:FF:002937', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160869, NULL, 'G3DSA:3.60.20.10:FF:000034', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(160870, NULL, 'G3DSA:2.40.50.140:FF:000724', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160871, NULL, 'G3DSA:3.40.1110.10:FF:000101', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(160872, NULL, 'G3DSA:2.130.10.10:FF:002808', NULL, NULL, 'WDR11 isoform 12', NULL, NULL, NULL, NULL, NULL, 4),
(160873, NULL, 'G3DSA:1.10.510.10:FF:004177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160874, NULL, 'G3DSA:2.60.120.260:FF:000268', NULL, NULL, 'netrin-G2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(160875, NULL, 'G3DSA:2.40.30.170:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160876, NULL, 'G3DSA:1.25.10.10:FF:000378', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(160877, NULL, 'G3DSA:3.30.1910.20:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160878, NULL, 'G3DSA:2.20.70.10:FF:000069', NULL, NULL, 'Neural precursor cell expressed, developmentally down-regulated 4-like', NULL, NULL, NULL, NULL, NULL, 4),
(160879, NULL, 'G3DSA:3.30.70.330:FF:000514', NULL, NULL, 'Small nuclear ribonucleoprotein 70 (U1)', NULL, NULL, NULL, NULL, NULL, 4),
(160880, NULL, 'G3DSA:3.40.50.970:FF:000205', NULL, NULL, 'Pyruvate dehydrogenase E1 component subunit beta, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(160881, NULL, 'G3DSA:2.60.40.10:FF:002685', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(160882, NULL, 'G3DSA:2.60.40.10:FF:003303', NULL, NULL, 'Leukemia inhibitory factor receptor alpha b', NULL, NULL, NULL, NULL, NULL, 4),
(160883, NULL, 'G3DSA:3.90.470.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160884, NULL, 'G3DSA:3.40.50.20:FF:000028', NULL, NULL, 'D-alanine-D-alanine ligase family', NULL, NULL, NULL, NULL, NULL, 4),
(160885, NULL, 'G3DSA:3.30.230.10:FF:000124', NULL, NULL, 'Ribonuclease P protein component', NULL, NULL, NULL, NULL, NULL, 4),
(160886, NULL, 'G3DSA:1.20.1270.60:FF:000015', NULL, NULL, 'Islet cell autoantigen 1, 69kDa', NULL, NULL, NULL, NULL, NULL, 4),
(160887, NULL, 'G3DSA:3.30.1050.10:FF:000025', NULL, NULL, 'GG11567', NULL, NULL, NULL, NULL, NULL, 4),
(160888, NULL, 'G3DSA:2.130.10.10:FF:003270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160889, NULL, 'G3DSA:1.10.8.80:FF:000009', NULL, NULL, 'ATPase, MoxR family', NULL, NULL, NULL, NULL, NULL, 4),
(160890, NULL, 'G3DSA:3.30.420.40:FF:000838', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160891, NULL, 'G3DSA:1.20.1250.20:FF:001582', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(160892, NULL, 'G3DSA:3.90.780.10:FF:000034', NULL, NULL, 'Putative 5-nucleotidase/2,3-cyclic phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(160893, NULL, 'G3DSA:3.40.50.300:FF:006794', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160894, NULL, 'G3DSA:2.130.10.10:FF:004832', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160895, NULL, 'G3DSA:3.40.850.10:FF:000039', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(160896, NULL, 'G3DSA:2.130.10.10:FF:000448', NULL, NULL, 'U3 small nucleolar RNA-associated protein 15 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(160897, NULL, 'G3DSA:2.60.40.10:FF:003073', NULL, NULL, 'Immunoglobulin superfamily member 3-like', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(160898, NULL, 'G3DSA:1.10.8.1320:FF:000002', NULL, NULL, 'Envelope glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(160899, NULL, 'G3DSA:2.60.40.10:FF:004832', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160900, NULL, 'G3DSA:3.40.50.300:FF:008609', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160901, NULL, 'G3DSA:2.60.40.60:FF:000985', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160902, NULL, 'G3DSA:3.40.190.10:FF:000781', NULL, NULL, 'Extracellular solute-binding protein family 5', NULL, NULL, NULL, NULL, NULL, 4),
(160903, NULL, 'G3DSA:2.40.160.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160904, NULL, 'G3DSA:3.30.750.24:FF:000025', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(160905, NULL, 'G3DSA:1.20.1310.10:FF:000089', NULL, NULL, 'Cullin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(160906, NULL, 'G3DSA:3.30.160.60:FF:006389', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160907, NULL, 'G3DSA:3.90.470.40:FF:000002', NULL, NULL, 'DNA damage-inducible transcript 4-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(160908, NULL, 'G3DSA:1.20.1250.20:FF:000053', NULL, NULL, 'Nitrate transporter 2.1', NULL, NULL, NULL, NULL, NULL, 4),
(160909, NULL, 'G3DSA:3.30.830.10:FF:000327', NULL, NULL, 'Protein CBG17023', NULL, NULL, NULL, NULL, NULL, 4),
(160910, NULL, 'G3DSA:1.25.10.10:FF:002396', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160911, NULL, 'G3DSA:3.90.180.10:FF:000140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160912, NULL, 'G3DSA:3.40.50.300:FF:003141', NULL, NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(160913, NULL, 'G3DSA:2.10.109.10:FF:000053', NULL, NULL, 'Repressor protein cI', NULL, NULL, NULL, NULL, NULL, 4),
(160914, NULL, 'G3DSA:3.30.200.20:FF:002396', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160915, NULL, 'G3DSA:1.20.1250.20:FF:000704', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160916, NULL, 'G3DSA:1.10.238.10:FF:001019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160917, NULL, 'G3DSA:3.40.30.10:FF:001244', NULL, NULL, 'Protein disulfide isomerase family A member 2', NULL, NULL, NULL, NULL, NULL, 4),
(160918, NULL, 'G3DSA:3.40.50.2300:FF:000272', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(160919, NULL, 'G3DSA:3.30.450.190:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160920, NULL, 'G3DSA:2.60.40.150:FF:000485', NULL, NULL, 'Copine 7', NULL, NULL, NULL, NULL, NULL, 4),
(160921, NULL, 'G3DSA:1.10.8.60:FF:000003', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(160922, NULL, 'G3DSA:1.10.510.10:FF:001052', NULL, NULL, 'FERM and PDZ domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(160923, NULL, 'G3DSA:1.25.40.20:FF:001607', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160924, NULL, 'G3DSA:1.20.120.230:FF:000067', NULL, NULL, 'Talin-A', NULL, NULL, NULL, NULL, NULL, 4),
(160925, NULL, 'G3DSA:2.60.40.10:FF:001049', NULL, NULL, 'Down syndrome cell adhesion molecule-like protein Dscam2', NULL, NULL, NULL, NULL, NULL, 4),
(160926, NULL, 'G3DSA:3.40.50.300:FF:003702', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(160927, NULL, 'G3DSA:4.10.60.10:FF:000065', NULL, NULL, 'A/G-specific adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(160928, NULL, 'G3DSA:2.40.50.140:FF:000943', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160929, NULL, 'G3DSA:1.10.472.80:FF:000100', NULL, NULL, 'TBC1 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(160930, NULL, 'G3DSA:1.10.260.40:FF:000012', NULL, NULL, 'HTH-type transcriptional regulator GntR', NULL, NULL, NULL, NULL, NULL, 4),
(160931, NULL, 'G3DSA:3.30.230.10:FF:000091', NULL, NULL, 'Type 2 DNA topoisomerase 6 subunit B', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(160932, NULL, 'G3DSA:3.40.30.10:FF:001025', NULL, NULL, 'Glutathione peroxidase 4a', NULL, NULL, NULL, NULL, NULL, 4),
(160933, NULL, 'G3DSA:3.40.50.300:FF:003450', NULL, NULL, 'ABC multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(160934, NULL, 'G3DSA:3.30.230.10:FF:000343', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160935, NULL, 'G3DSA:1.10.238.10:FF:001042', NULL, NULL, 'Calmodulin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(160936, NULL, 'G3DSA:1.25.40.10:FF:005202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160937, NULL, 'G3DSA:1.10.418.10:FF:000191', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160938, NULL, 'G3DSA:3.40.1110.10:FF:000320', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160939, NULL, 'G3DSA:1.10.3720.10:FF:000089', NULL, NULL, 'Ectoine/hydroxyectoine ABC transporter permease subunit EhuD', NULL, NULL, NULL, NULL, NULL, 4),
(160940, NULL, 'G3DSA:1.20.1560.10:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160941, NULL, 'G3DSA:2.130.10.10:FF:003051', NULL, NULL, 'WD40-repeat-containing domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(160942, NULL, 'G3DSA:3.40.1410.10:FF:000028', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(160943, NULL, 'G3DSA:2.30.29.30:FF:000440', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160944, NULL, 'G3DSA:1.20.58.390:FF:000099', NULL, NULL, 'Cholinergic receptor, nicotinic, epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(160945, NULL, 'G3DSA:3.40.50.720:FF:002075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160946, NULL, 'G3DSA:2.40.70.10:FF:000552', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160947, NULL, 'G3DSA:3.30.160.60:FF:002679', NULL, NULL, 'Zinc finger protein 726', NULL, NULL, NULL, NULL, NULL, 4),
(160948, NULL, 'G3DSA:3.30.160.60:FF:005231', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160949, NULL, 'G3DSA:1.25.40.10:FF:000346', NULL, NULL, 'Sodium-type flagellar protein MotX', NULL, NULL, NULL, NULL, NULL, 4),
(160950, NULL, 'G3DSA:2.40.30.170:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160951, NULL, 'G3DSA:1.10.10.10:FF:001361', NULL, NULL, 'Heat shock regulator', NULL, NULL, NULL, NULL, NULL, 4),
(160952, NULL, 'G3DSA:3.90.70.10:FF:000766', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160953, NULL, 'G3DSA:3.90.170.10:FF:000004', NULL, NULL, 'Adenylosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(160954, NULL, 'G3DSA:3.40.50.880:FF:000167', NULL, NULL, 'Uncharacterized protein C18G6.12c', NULL, NULL, NULL, NULL, NULL, 4),
(160955, NULL, 'G3DSA:2.120.10.30:FF:000179', NULL, NULL, 'Bll1368 protein', NULL, NULL, NULL, NULL, NULL, 4),
(160956, NULL, 'G3DSA:3.30.160.60:FF:003207', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160957, NULL, 'G3DSA:3.40.50.1820:FF:000425', NULL, NULL, 'Alpha/beta hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(160958, NULL, 'G3DSA:3.90.980.20:FF:000018', NULL, NULL, 'PHF19 isoform 10', NULL, NULL, NULL, NULL, NULL, 4),
(160959, NULL, 'G3DSA:3.30.465.10:FF:000141', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(160960, NULL, 'G3DSA:1.10.510.10:FF:004396', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160961, NULL, 'G3DSA:1.25.40.20:FF:000989', NULL, NULL, 'Phosphate system positive regulatory protein PHO81', NULL, NULL, NULL, NULL, NULL, 4),
(160962, NULL, 'G3DSA:3.30.1120.90:FF:000004', NULL, NULL, 'Nucleosome assembly protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(160963, NULL, 'G3DSA:3.90.920.10:FF:000023', NULL, NULL, 'DNA primase small subunit PriS', NULL, NULL, NULL, NULL, NULL, 4),
(160964, NULL, 'G3DSA:1.20.5.170:FF:000033', NULL, NULL, 'Lamin A/C', NULL, NULL, NULL, NULL, NULL, 4),
(160965, NULL, 'G3DSA:3.40.50.620:FF:000230', NULL, NULL, 'FAD synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(160966, NULL, 'G3DSA:3.30.450.20:FF:000312', NULL, NULL, 'Nitrogen fixation regulatory protein, NifL', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(160967, NULL, 'G3DSA:2.60.40.10:FF:004719', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160968, NULL, 'G3DSA:3.40.50.300:FF:003231', NULL, NULL, 'DNA repair helicase', NULL, NULL, NULL, NULL, NULL, 4),
(160969, NULL, 'G3DSA:1.10.510.10:FF:003103', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160970, NULL, 'G3DSA:3.30.1370.210:FF:000021', NULL, NULL, 'DExH-box helicase 57', NULL, NULL, NULL, NULL, NULL, 4),
(160971, NULL, 'G3DSA:3.40.50.1000:FF:000770', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160972, NULL, 'G3DSA:2.130.10.10:FF:002556', NULL, NULL, 'LLGL2, scribble cell polarity complex component', NULL, NULL, NULL, NULL, NULL, 4),
(160973, NULL, 'G3DSA:1.20.58.60:FF:000125', NULL, NULL, 'Desmoplakin', NULL, NULL, NULL, NULL, NULL, 4),
(160974, NULL, 'G3DSA:3.30.420.10:FF:000026', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(160975, NULL, 'G3DSA:2.130.10.10:FF:004686', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160976, NULL, 'G3DSA:2.130.10.10:FF:005304', NULL, NULL, 'Uncharacterized WD repeat-containing protein C343.04c', NULL, NULL, NULL, NULL, NULL, 4),
(160977, NULL, 'G3DSA:2.60.40.10:FF:002831', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160978, NULL, 'G3DSA:3.40.1110.10:FF:000011', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(160979, NULL, 'G3DSA:2.30.29.30:FF:001289', NULL, NULL, 'KRIT 1 (Krev interaction trapped/cerebral cavernous malformation 1) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(160980, NULL, 'G3DSA:3.90.190.10:FF:000421', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type 2', NULL, NULL, NULL, NULL, NULL, 4),
(160981, NULL, 'G3DSA:1.20.950.20:FF:000023', NULL, NULL, 'CoB--CoM heterodisulfide reductase 2 subunit E', NULL, NULL, NULL, NULL, NULL, 4),
(160982, NULL, 'G3DSA:1.25.10.10:FF:002648', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160983, NULL, 'G3DSA:3.40.50.150:FF:000656', NULL, NULL, '25S rRNA (adenine(2142)-N(1))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(160984, NULL, 'G3DSA:3.30.160.60:FF:002792', NULL, NULL, 'Zinc finger protein 646', NULL, NULL, NULL, NULL, NULL, 4),
(160985, NULL, 'G3DSA:1.10.10.2590:FF:000001', NULL, NULL, 'protein BANP isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(160986, NULL, 'G3DSA:3.30.200.20:FF:000288', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase ERECTA', NULL, NULL, NULL, NULL, NULL, 4),
(160987, NULL, 'G3DSA:3.40.50.300:FF:006884', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160988, NULL, 'G3DSA:3.40.50.150:FF:001460', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160989, NULL, 'G3DSA:2.120.10.30:FF:000382', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(160990, NULL, 'G3DSA:2.60.40.10:FF:004377', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160991, NULL, 'G3DSA:1.20.1050.10:FF:000175', NULL, NULL, 'Ganglioside-induced differentiation-associated-protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(160992, NULL, 'G3DSA:3.40.50.300:FF:004557', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(160993, NULL, 'G3DSA:3.40.50.720:FF:000366', NULL, NULL, 'Protein FMP52, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(160994, NULL, 'G3DSA:1.10.510.10:FF:003631', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(160995, NULL, 'G3DSA:3.30.2010.10:FF:000012', NULL, NULL, 'Metallopeptidase Oma1', NULL, NULL, NULL, NULL, NULL, 4),
(160996, NULL, 'G3DSA:3.30.450.20:FF:000109', NULL, NULL, 'Sensor domain-containing diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(160997, NULL, 'G3DSA:3.40.50.2300:FF:000468', NULL, NULL, 'G protein-coupled receptor, class C, group 6, member A', NULL, NULL, NULL, NULL, NULL, 4),
(160998, NULL, 'G3DSA:2.60.220.50:FF:000115', NULL, NULL, 'Cadherin, EGF LAG seven-pass G-type receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(160999, NULL, 'G3DSA:2.60.120.650:FF:000043', NULL, NULL, 'tRNA wybutosine-synthesizing protein 4', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(161000, NULL, 'G3DSA:3.30.530.20:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161001, NULL, 'G3DSA:1.20.1070.10:FF:001823', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161002, NULL, 'G3DSA:2.20.70.10:FF:000070', NULL, NULL, 'Pre-mRNA-processing protein 40C', NULL, NULL, NULL, NULL, NULL, 4),
(161003, NULL, 'G3DSA:2.60.120.260:FF:000252', NULL, NULL, 'Endo-1,4-beta-xylanase 4', NULL, NULL, NULL, NULL, NULL, 4),
(161004, NULL, 'G3DSA:3.90.79.10:FF:000269', NULL, NULL, '39S ribosomal protein L46, putative', NULL, NULL, NULL, NULL, NULL, 4),
(161005, NULL, 'G3DSA:3.20.20.80:FF:000129', NULL, NULL, 'Lysozyme-like protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(161006, NULL, 'G3DSA:3.40.47.10:FF:000046', NULL, NULL, 'UPF0219 protein M1627_1703', NULL, NULL, NULL, NULL, NULL, 4),
(161007, NULL, 'G3DSA:3.40.50.2000:FF:000406', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(161008, NULL, 'G3DSA:3.30.559.70:FF:000023', NULL, NULL, 'Si:ch211-256m1.8', NULL, NULL, NULL, NULL, NULL, 4),
(161009, NULL, 'G3DSA:1.25.40.10:FF:002931', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(161010, NULL, 'G3DSA:3.40.50.720:FF:002165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161011, NULL, 'G3DSA:1.25.10.10:FF:002851', NULL, NULL, 'Importin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(161012, NULL, 'G3DSA:3.40.50.300:FF:001432', NULL, NULL, 'Menage a trois, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(161013, NULL, 'G3DSA:1.20.1250.20:FF:001778', NULL, NULL, 'Monocarboxylate transporter 11', NULL, NULL, NULL, NULL, NULL, 4),
(161014, NULL, 'G3DSA:2.60.120.260:FF:000049', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(161015, NULL, 'G3DSA:3.60.40.10:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161016, NULL, 'G3DSA:3.40.220.10:FF:000014', NULL, NULL, 'M17 leucyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(161017, NULL, 'G3DSA:3.40.309.10:FF:000046', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(161018, NULL, 'G3DSA:1.20.58.150:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161019, NULL, 'G3DSA:1.25.40.20:FF:000990', NULL, NULL, 'Ankyrin repeat protein C9L', NULL, NULL, NULL, NULL, NULL, 4),
(161020, NULL, 'G3DSA:2.60.40.420:FF:000133', NULL, NULL, 'GM10275', NULL, NULL, NULL, NULL, NULL, 4),
(161021, NULL, 'G3DSA:3.50.50.60:FF:000186', NULL, NULL, 'Succinate dehydrogenase flavoprotein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(161022, NULL, 'G3DSA:1.25.10.10:FF:000849', NULL, NULL, 'Importin beta-3 subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(161023, NULL, 'G3DSA:3.30.1540.10:FF:000001', NULL, NULL, 'L-carnitine CoA-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(161024, NULL, 'G3DSA:3.40.850.10:FF:000023', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(161025, NULL, 'G3DSA:2.60.120.260:FF:000139', NULL, NULL, 'Anaphase-promoting complex subunit 10', NULL, NULL, NULL, NULL, NULL, 4),
(161026, NULL, 'G3DSA:3.10.20.770:FF:000011', NULL, NULL, 'Phosphatidylinositol-4,5-bisphosphate 3-kinase catalytic subunit delta isoform, putative', NULL, NULL, NULL, NULL, NULL, 4),
(161027, NULL, 'G3DSA:1.25.10.10:FF:000597', NULL, NULL, 'Deoxyhypusine hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(161028, NULL, 'G3DSA:3.30.1320.10:FF:000018', NULL, NULL, '30S ribosomal protein S16', NULL, NULL, NULL, NULL, NULL, 4),
(161029, NULL, 'G3DSA:3.80.10.10:FF:002730', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(161030, NULL, 'G3DSA:3.30.200.20:FF:002290', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(161031, NULL, 'G3DSA:2.120.10.80:FF:000391', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161032, NULL, 'G3DSA:1.10.600.10:FF:000081', NULL, NULL, 'AGAP000326-PA', NULL, NULL, NULL, NULL, NULL, 4),
(161033, NULL, 'G3DSA:3.30.200.20:FF:002542', NULL, NULL, 'Probable serine/threonine-protein kinase DDB_G0290859', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(161034, NULL, 'G3DSA:2.170.270.10:FF:000047', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(161035, NULL, 'G3DSA:3.40.50.80:FF:000024', NULL, NULL, 'NADH oxidoreductase hcr', NULL, NULL, NULL, NULL, NULL, 4),
(161036, NULL, 'G3DSA:2.60.120.200:FF:000150', NULL, NULL, 'Laminin subunit alpha 5', NULL, NULL, NULL, NULL, NULL, 4),
(161037, NULL, 'G3DSA:2.60.40.150:FF:000827', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161038, NULL, 'G3DSA:3.40.350.10:FF:000018', NULL, NULL, 'Metallo-peptidase, Clan MG, Family M24', NULL, NULL, NULL, NULL, NULL, 4),
(161039, NULL, 'G3DSA:3.40.50.720:FF:001816', NULL, NULL, 'Lovastatin nonaketide synthase, polyketide synthase component', NULL, NULL, NULL, NULL, NULL, 4),
(161040, NULL, 'G3DSA:3.40.570.10:FF:000001', NULL, NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(161041, NULL, 'G3DSA:2.130.10.10:FF:000757', NULL, NULL, 'rRNA processing WD-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(161042, NULL, 'G3DSA:2.30.42.10:FF:000072', NULL, NULL, 'multiple PDZ domain protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(161043, NULL, 'G3DSA:3.30.420.40:FF:000277', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(161044, NULL, 'G3DSA:1.10.10.60:FF:000746', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161045, NULL, 'G3DSA:3.90.1150.10:FF:000047', NULL, NULL, 'Ornithine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(161046, NULL, 'G3DSA:3.60.150.10:FF:000010', NULL, NULL, 'Chorismate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(161047, NULL, 'G3DSA:3.30.1490.100:FF:000026', NULL, NULL, 'Putative DNA polymerase kappa', NULL, NULL, NULL, NULL, NULL, 4),
(161048, NULL, 'G3DSA:1.25.40.10:FF:004730', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161049, NULL, 'G3DSA:1.20.1720.10:FF:000030', NULL, NULL, 'Bcr/CflA family efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(161050, NULL, 'G3DSA:3.40.50.300:FF:001090', NULL, NULL, 'ATP-binding cassette subfamily C member 10', NULL, NULL, NULL, NULL, NULL, 4),
(161051, NULL, 'G3DSA:3.30.200.20:FF:002087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161052, NULL, 'G3DSA:3.40.50.300:FF:007502', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(161053, NULL, 'G3DSA:3.40.50.150:FF:001128', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161054, NULL, 'G3DSA:3.90.1170.50:FF:000009', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(161055, NULL, 'G3DSA:2.160.20.10:FF:000329', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161056, NULL, 'G3DSA:3.40.50.300:FF:005703', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161057, NULL, 'G3DSA:3.50.50.60:FF:000528', NULL, NULL, 'Phytoene desaturase', NULL, NULL, NULL, NULL, NULL, 4),
(161058, NULL, 'G3DSA:2.70.170.10:FF:000086', NULL, NULL, 'NtR, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(161059, NULL, 'G3DSA:2.160.20.10:FF:000133', NULL, NULL, 'PKHD1, fibrocystin/polyductin', NULL, NULL, NULL, NULL, NULL, 4),
(161060, NULL, 'G3DSA:2.10.25.10:FF:001825', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161061, NULL, 'G3DSA:3.60.10.10:FF:000314', NULL, NULL, 'Type I inositol-1,4,5-trisphosphate 5-phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(161062, NULL, 'G3DSA:3.40.980.20:FF:000001', NULL, NULL, 'Ketose-bisphosphate aldolase class-II family protein', NULL, NULL, NULL, NULL, NULL, 4),
(161063, NULL, 'G3DSA:3.30.830.10:FF:000294', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161064, NULL, 'G3DSA:1.10.1520.10:FF:000101', NULL, NULL, 'ADL023Wp', NULL, NULL, NULL, NULL, NULL, 4),
(161065, NULL, 'G3DSA:3.50.50.60:FF:000276', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(161066, NULL, 'G3DSA:1.10.340.30:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(161067, NULL, 'G3DSA:1.10.4160.10:FF:000012', NULL, NULL, 'Cytosine-purine permease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(161068, NULL, 'G3DSA:1.20.1560.10:FF:000152', NULL, NULL, 'MDR-like ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(161069, NULL, 'G3DSA:3.40.50.150:FF:001370', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161070, NULL, 'G3DSA:2.40.50.140:FF:000163', NULL, NULL, 'Probable DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(161071, NULL, 'G3DSA:2.30.29.30:FF:000350', NULL, NULL, 'AGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(161072, NULL, 'G3DSA:1.20.58.70:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161073, NULL, 'G3DSA:3.30.565.10:FF:000396', NULL, NULL, 'Two-component system sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(161074, NULL, 'G3DSA:3.90.550.10:FF:000298', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(161075, NULL, 'G3DSA:1.20.1740.10:FF:000115', NULL, NULL, 'Cationic amino acid transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(161076, NULL, 'G3DSA:2.30.29.30:FF:000108', NULL, NULL, 'C-Jun-amino-terminal kinase-interacting protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(161077, NULL, 'G3DSA:2.30.42.10:FF:000324', NULL, NULL, 'Probable serine protease PepD (Serine proteinase) (MTB32B)', NULL, NULL, NULL, NULL, NULL, 4),
(161078, NULL, 'G3DSA:1.10.150.20:FF:000228', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(161079, NULL, 'G3DSA:3.40.50.1820:FF:001499', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161080, NULL, 'G3DSA:2.10.25.10:FF:001679', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161081, NULL, 'G3DSA:2.70.130.10:FF:000179', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161082, NULL, 'G3DSA:1.10.472.10:FF:000445', NULL, NULL, 'Cyclin domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(161083, NULL, 'G3DSA:2.130.10.10:FF:004596', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161084, NULL, 'G3DSA:2.120.10.30:FF:000292', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM71', NULL, NULL, NULL, NULL, NULL, 4),
(161085, NULL, 'G3DSA:1.20.1560.10:FF:000461', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161086, NULL, 'G3DSA:3.30.428.10:FF:000038', NULL, NULL, 'Galactose-1-phosphate uridylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(161087, NULL, 'G3DSA:1.10.150.510:FF:000013', NULL, NULL, 'uncharacterized protein LOC100178270', NULL, NULL, NULL, NULL, NULL, 4),
(161088, NULL, 'G3DSA:2.40.10.10:FF:000576', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161089, NULL, 'G3DSA:3.30.470.20:FF:000111', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(161090, NULL, 'G3DSA:1.25.10.10:FF:003014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161091, NULL, 'G3DSA:3.90.650.10:FF:000007', NULL, NULL, 'Trifunctional purine biosynthetic protein adenosine-3', NULL, NULL, NULL, NULL, NULL, 4),
(161092, NULL, 'G3DSA:1.20.1250.20:FF:001688', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(161093, NULL, 'G3DSA:3.30.420.40:FF:000732', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161094, NULL, 'G3DSA:3.30.40.10:FF:000430', NULL, NULL, 'E3 ubiquitin-protein ligase RDUF2', NULL, NULL, NULL, NULL, NULL, 4),
(161095, NULL, 'G3DSA:1.20.1250.20:FF:002306', NULL, NULL, 'Multidrug resistance protein fnx1', NULL, NULL, NULL, NULL, NULL, 4),
(161096, NULL, 'G3DSA:2.60.40.420:FF:000223', NULL, NULL, 'Bll2293 protein', NULL, NULL, NULL, NULL, NULL, 4),
(161097, NULL, 'G3DSA:2.170.140.10:FF:000043', NULL, NULL, 'Chitinase 12', NULL, NULL, NULL, NULL, NULL, 4),
(161098, NULL, 'G3DSA:3.40.50.11060:FF:000015', NULL, NULL, 'LOC563225 protein', NULL, NULL, NULL, NULL, NULL, 4),
(161099, NULL, 'G3DSA:3.40.50.300:FF:005029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(161100, NULL, 'G3DSA:2.30.30.100:FF:000227', NULL, NULL, 'SnRNP core Sm protein Sm-X5-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(161101, NULL, 'G3DSA:1.10.150.530:FF:000019', NULL, NULL, 'Probable dual-specificity RNA methyltransferase RlmN', NULL, NULL, NULL, NULL, NULL, 4),
(161102, NULL, 'G3DSA:1.10.510.10:FF:002917', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161103, NULL, 'G3DSA:3.30.1370.10:FF:000173', NULL, NULL, 'Tudor and KH domain-containing protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(161104, NULL, 'G3DSA:2.60.40.10:FF:005091', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161105, NULL, 'G3DSA:3.20.20.300:FF:000076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161106, NULL, 'G3DSA:3.40.50.12780:FF:000121', NULL, NULL, 'Acyl-CoA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(161107, NULL, 'G3DSA:3.40.47.10:FF:000265', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161108, NULL, 'G3DSA:2.70.160.11:FF:000002', NULL, NULL, 'Probable histone-arginine methyltransferase CARM1', NULL, NULL, NULL, NULL, NULL, 4),
(161109, NULL, 'G3DSA:2.60.40.10:FF:000886', NULL, NULL, 'Interleukin-6 receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(161110, NULL, 'G3DSA:1.20.1640.10:FF:000097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161111, NULL, 'G3DSA:1.10.630.10:FF:000251', NULL, NULL, 'Cytochrome P450, family 2, subfamily X, polypeptide 10.2', NULL, NULL, NULL, NULL, NULL, 4),
(161112, NULL, 'G3DSA:2.70.170.10:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161113, NULL, 'G3DSA:3.40.630.10:FF:000512', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(161114, NULL, 'G3DSA:2.60.40.150:FF:000266', NULL, NULL, 'Phospholipase D alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(161115, NULL, 'G3DSA:3.80.10.10:FF:003815', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161116, NULL, 'G3DSA:2.70.98.10:FF:000075', NULL, NULL, 'ADR339Cp', NULL, NULL, NULL, NULL, NULL, 4),
(161117, NULL, 'G3DSA:2.60.120.260:FF:000504', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161118, NULL, 'G3DSA:3.60.10.10:FF:000005', NULL, NULL, 'phosphatidylinositol 3,4,5-trisphosphate 5-phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(161119, NULL, 'G3DSA:3.40.50.720:FF:002530', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161120, NULL, 'G3DSA:3.30.390.50:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161121, NULL, 'G3DSA:3.40.640.10:FF:000119', NULL, NULL, 'Molybdenum cofactor sulfurase', NULL, NULL, NULL, NULL, NULL, 4),
(161122, NULL, 'G3DSA:1.20.1250.20:FF:001997', NULL, NULL, 'Multidrug-efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(161123, NULL, 'G3DSA:1.20.120.1080:FF:000031', NULL, NULL, 'ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(161124, NULL, 'G3DSA:3.90.1150.10:FF:000356', NULL, NULL, 'Spore coat polysaccharide biosynthesis proteinSpsC', NULL, NULL, NULL, NULL, NULL, 4),
(161125, NULL, 'G3DSA:3.40.50.300:FF:001651', NULL, NULL, 'EscN/YscN/HrcN family type III secretion system ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(161126, NULL, 'G3DSA:1.20.58.60:FF:000215', NULL, NULL, 'VAB-10B protein', NULL, NULL, NULL, NULL, NULL, 4),
(161127, NULL, 'G3DSA:3.20.20.140:FF:000005', NULL, NULL, 'TatD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(161128, NULL, 'G3DSA:3.40.640.10:FF:000338', NULL, NULL, 'Serine--glyoxylate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(161129, NULL, 'G3DSA:3.30.1330.90:FF:000014', NULL, NULL, 'L-serine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(161130, NULL, 'G3DSA:1.10.8.10:FF:000213', NULL, NULL, 'Defective in cullin neddylation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(161131, NULL, 'G3DSA:1.25.40.10:FF:002785', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161132, NULL, 'G3DSA:2.130.10.10:FF:001252', NULL, NULL, 'Receptor of activated protein C kinase 1', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(161133, NULL, 'G3DSA:2.60.40.10:FF:000667', NULL, NULL, 'V-set and transmembrane domain containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(161134, NULL, 'G3DSA:2.60.40.10:FF:004629', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161135, NULL, 'G3DSA:3.40.50.720:FF:002311', NULL, NULL, 'C-terminal-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(161136, NULL, 'G3DSA:3.90.1600.10:FF:000026', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(161137, NULL, 'G3DSA:3.40.50.150:FF:000965', NULL, NULL, 'Uncharacterized methyltransferase-like C25B8.10', NULL, NULL, NULL, NULL, NULL, 4),
(161138, NULL, 'G3DSA:3.30.160.60:FF:002483', NULL, NULL, 'Zinc finger protein 90', NULL, NULL, NULL, NULL, NULL, 4),
(161139, NULL, 'G3DSA:3.30.54.20:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161140, NULL, 'G3DSA:3.30.390.30:FF:000023', NULL, NULL, 'Ferredoxin reductase', NULL, NULL, NULL, NULL, NULL, 4),
(161141, NULL, 'G3DSA:1.20.120.980:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161142, NULL, 'G3DSA:3.30.160.60:FF:005085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161143, NULL, 'G3DSA:1.10.510.10:FF:003412', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161144, NULL, 'G3DSA:2.40.370.10:FF:000001', NULL, NULL, 'Survival factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(161145, NULL, 'G3DSA:2.60.40.10:FF:004848', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161146, NULL, 'G3DSA:3.40.640.10:FF:000428', NULL, NULL, 'Alanine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(161147, NULL, 'G3DSA:1.20.1720.10:FF:000007', NULL, NULL, 'Bcr/CflA family efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(161148, NULL, 'G3DSA:1.25.40.10:FF:002476', NULL, NULL, 'Os08g0131000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(161149, NULL, 'G3DSA:3.30.420.40:FF:000951', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161150, NULL, 'G3DSA:3.30.160.60:FF:002825', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM17', NULL, NULL, NULL, NULL, NULL, 4),
(161151, NULL, 'G3DSA:3.30.70.330:FF:000059', NULL, NULL, 'splicing factor 3B subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(161152, NULL, 'G3DSA:3.40.640.10:FF:000086', NULL, NULL, 'Kynurenine--oxoglutarate transaminase 1', NULL, NULL, NULL, NULL, NULL, 4),
(161153, NULL, 'G3DSA:1.20.5.320:FF:000005', NULL, NULL, 'collagen alpha-2(VI) chain isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(161154, NULL, 'G3DSA:3.30.420.580:FF:000011', NULL, NULL, 'Probable actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(161155, NULL, 'G3DSA:2.60.40.10:FF:004938', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161156, NULL, 'G3DSA:2.60.40.10:FF:001504', NULL, NULL, 'Interleukin 18 receptor accessory protein', NULL, NULL, NULL, NULL, NULL, 4),
(161157, NULL, 'G3DSA:1.25.40.430:FF:000006', NULL, NULL, 'Pre-mRNA-splicing factor SYF1', NULL, NULL, NULL, NULL, NULL, 4),
(161158, NULL, 'G3DSA:2.70.150.10:FF:000287', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(161159, NULL, 'G3DSA:3.40.1280.10:FF:000012', NULL, NULL, 'RNA methyltransferase, TrmH family, group 3', NULL, NULL, NULL, NULL, NULL, 4),
(161160, NULL, 'G3DSA:1.25.10.10:FF:002761', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161161, NULL, 'G3DSA:3.30.210.10:FF:000016', NULL, NULL, 'Pol lambda-related class X DNA repair polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(161162, NULL, 'G3DSA:2.130.10.10:FF:001162', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(161163, NULL, 'G3DSA:2.60.40.10:FF:000577', NULL, NULL, 'immunoglobulin superfamily DCC subclass member 3', NULL, NULL, NULL, NULL, NULL, 4),
(161164, NULL, 'G3DSA:1.10.510.10:FF:001158', NULL, NULL, 'Probable serine/threonine-protein kinase mkcE', NULL, NULL, NULL, NULL, NULL, 4),
(161165, NULL, 'G3DSA:2.10.110.10:FF:000135', NULL, NULL, 'LIM domain-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(161166, NULL, 'G3DSA:3.10.100.10:FF:000434', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(161167, NULL, 'G3DSA:1.20.140.40:FF:000035', NULL, NULL, 'Pectinesterase inhibitor 12', NULL, NULL, NULL, NULL, NULL, 4),
(161168, NULL, 'G3DSA:3.40.50.150:FF:001151', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161169, NULL, 'G3DSA:3.90.550.10:FF:000769', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(161170, NULL, 'G3DSA:1.10.10.60:FF:001151', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161171, NULL, 'G3DSA:3.40.50.720:FF:001693', NULL, NULL, 'Dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(161172, NULL, 'G3DSA:1.25.40.10:FF:003403', NULL, NULL, 'Os06g0506100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(161173, NULL, 'G3DSA:1.10.2010.10:FF:000001', NULL, NULL, 'Ion transport peptide isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(161174, NULL, 'G3DSA:1.25.40.420:FF:000003', NULL, NULL, 'BTB/POZ domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(161175, NULL, 'G3DSA:1.50.40.10:FF:000012', NULL, NULL, 'Phosphate carrier protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(161176, NULL, 'G3DSA:2.40.37.10:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161177, NULL, 'G3DSA:1.10.510.10:FF:000995', NULL, NULL, 'BcCMK3, calcium/calmodulin-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(161178, NULL, 'G3DSA:2.130.10.10:FF:002674', NULL, NULL, 'Mitotic checkpoint protein bub3', NULL, NULL, NULL, NULL, NULL, 4),
(161179, NULL, 'G3DSA:4.10.640.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161180, NULL, 'G3DSA:3.90.1150.210:FF:000011', NULL, NULL, 'F-actin-capping protein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(161181, NULL, 'G3DSA:1.10.510.10:FF:002709', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161182, NULL, 'G3DSA:3.40.50.300:FF:000937', NULL, NULL, 'Corrinoid adenosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(161183, NULL, 'G3DSA:3.30.70.330:FF:000418', NULL, NULL, 'heterogeneous nuclear ribonucleoprotein A0', NULL, NULL, NULL, NULL, NULL, 4),
(161184, NULL, 'G3DSA:3.30.450.20:FF:000430', NULL, NULL, 'Sensor histidine kinase, PAS, PAS and PAS domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(161185, NULL, 'G3DSA:3.30.230.10:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161186, NULL, 'G3DSA:1.20.1250.20:FF:002166', NULL, NULL, 'Metabolite transport protein csbC-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(161187, NULL, 'G3DSA:3.40.640.10:FF:000327', NULL, NULL, 'Sphingosine Phosphate Lyase', NULL, NULL, NULL, NULL, NULL, 4),
(161188, NULL, 'G3DSA:3.80.10.10:FF:000611', NULL, NULL, 'Capricious, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(161189, NULL, 'G3DSA:2.60.40.150:FF:000474', NULL, NULL, 'WW domain-containing E3 ubiquitin protein ligase 1', NULL, NULL, NULL, NULL, NULL, 4),
(161190, NULL, 'G3DSA:2.40.37.10:FF:000036', NULL, NULL, 'Alanine racemase', NULL, NULL, NULL, NULL, NULL, 4),
(161191, NULL, 'G3DSA:2.60.40.10:FF:002707', NULL, NULL, 'CoLlagen with Endostatin domain', NULL, NULL, NULL, NULL, NULL, 4),
(161192, NULL, 'G3DSA:3.30.160.60:FF:001622', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161193, NULL, 'G3DSA:1.10.10.570:FF:000007', NULL, NULL, 'ESCRT-II complex, vps25 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(161194, NULL, 'G3DSA:1.10.730.10:FF:000197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161195, NULL, 'G3DSA:1.10.260.40:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161196, NULL, 'G3DSA:1.20.1250.20:FF:000042', NULL, NULL, 'Fosmidomycin resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(161197, NULL, 'G3DSA:1.10.3470.10:FF:000013', NULL, NULL, 'Fe(3+)-hydroxamate ABC transporter permease FhuB', NULL, NULL, NULL, NULL, NULL, 4),
(161198, NULL, 'G3DSA:2.40.50.140:FF:000174', NULL, NULL, 'DNA replication licensing factor mcm10', NULL, NULL, NULL, NULL, NULL, 4),
(161199, NULL, 'G3DSA:3.30.420.40:FF:000934', NULL, NULL, 'Actin-related protein 3', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(161200, NULL, 'G3DSA:1.20.1070.10:FF:000406', NULL, NULL, 'Adhesion G protein-coupled receptor B1', NULL, NULL, NULL, NULL, NULL, 4),
(161201, NULL, 'G3DSA:3.90.550.10:FF:000758', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161202, NULL, 'G3DSA:1.10.287.110:FF:000466', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161203, NULL, 'G3DSA:3.40.50.720:FF:000602', NULL, NULL, 'Steroid dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(161204, NULL, 'G3DSA:1.20.1270.10:FF:000034', NULL, NULL, 'Chaperone protein DnaK', NULL, NULL, NULL, NULL, NULL, 4),
(161205, NULL, 'G3DSA:1.10.1370.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161206, NULL, 'G3DSA:2.160.20.10:FF:000346', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161207, NULL, 'G3DSA:1.25.40.10:FF:000329', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(161208, NULL, 'G3DSA:3.90.550.50:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161209, NULL, 'G3DSA:3.90.70.10:FF:000429', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161210, NULL, 'G3DSA:2.130.10.10:FF:001151', NULL, NULL, 'Semaphorin 5C', NULL, NULL, NULL, NULL, NULL, 4),
(161211, NULL, 'G3DSA:3.40.390.10:FF:000105', NULL, NULL, 'Zinc metalloproteinase nas-16', NULL, NULL, NULL, NULL, NULL, 4),
(161212, NULL, 'G3DSA:3.40.50.300:FF:001443', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(161213, NULL, 'G3DSA:2.10.25.10:FF:001808', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161214, NULL, 'G3DSA:2.60.40.10:FF:003308', NULL, NULL, 'DLEC1, cilia and flagella associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(161215, NULL, 'G3DSA:2.60.120.200:FF:000503', NULL, NULL, 'Basement membrane proteoglycan', NULL, NULL, NULL, NULL, NULL, 4),
(161216, NULL, 'G3DSA:2.40.70.10:FF:000563', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161217, NULL, 'G3DSA:3.60.15.10:FF:000073', NULL, NULL, 'MBL fold metallo-hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(161218, NULL, 'G3DSA:1.25.10.10:FF:001007', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(161219, NULL, 'G3DSA:2.60.40.720:FF:000010', NULL, NULL, 'Runx2a splice form 5', NULL, NULL, NULL, NULL, NULL, 4),
(161220, NULL, 'G3DSA:3.30.497.10:FF:000035', NULL, NULL, 'Serine (or cysteine) peptidase inhibitor, clade H, member 2', NULL, NULL, NULL, NULL, NULL, 4),
(161221, NULL, 'G3DSA:1.10.10.10:FF:000759', NULL, NULL, 'Ferric uptake regulation protein FUR', NULL, NULL, NULL, NULL, NULL, 4),
(161222, NULL, 'G3DSA:2.60.40.10:FF:002696', NULL, NULL, 'Obscurin', NULL, NULL, NULL, NULL, NULL, 4),
(161223, NULL, 'G3DSA:3.30.2350.20:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161224, NULL, 'G3DSA:1.20.58.1880:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161225, NULL, 'G3DSA:3.30.1070.10:FF:000004', NULL, NULL, 'Cell division topological specificity factor', NULL, NULL, NULL, NULL, NULL, 4),
(161226, NULL, 'G3DSA:2.60.40.10:FF:004736', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161227, NULL, 'G3DSA:1.10.3860.10:FF:000020', NULL, NULL, 'Proton glutamate symport protein', NULL, NULL, NULL, NULL, NULL, 4),
(161228, NULL, 'G3DSA:3.30.160.60:FF:002819', NULL, NULL, 'Putative C2H2 transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(161229, NULL, 'G3DSA:3.30.830.10:FF:000198', NULL, NULL, 'Peptidase M16C associated domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(161230, NULL, 'G3DSA:1.10.510.10:FF:001512', NULL, NULL, 'Receptor tyrosine-protein kinase erbB-2', NULL, NULL, NULL, NULL, NULL, 4),
(161231, NULL, 'G3DSA:3.30.1520.10:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161232, NULL, 'G3DSA:2.60.40.420:FF:000122', NULL, NULL, 'Ephrin-4', NULL, NULL, NULL, NULL, NULL, 4),
(161233, NULL, 'G3DSA:3.40.50.300:FF:002966', NULL, NULL, 'ABC-type multidrug transport system fused ATPase/permease subunit', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(161234, NULL, 'G3DSA:2.20.100.10:FF:000143', NULL, NULL, 'Complement factor properdin', NULL, NULL, NULL, NULL, NULL, 4),
(161235, NULL, 'G3DSA:2.170.140.10:FF:000032', NULL, NULL, 'BcDNA.GH02976', NULL, NULL, NULL, NULL, NULL, 4),
(161236, NULL, 'G3DSA:1.25.10.10:FF:000395', NULL, NULL, 'transportin-3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(161237, NULL, 'G3DSA:2.70.210.12:FF:000002', NULL, NULL, 'Putative gtp-binding protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(161238, NULL, 'G3DSA:1.10.510.10:FF:002698', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161239, NULL, 'G3DSA:1.20.1250.20:FF:001565', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(161240, NULL, 'G3DSA:1.10.20.10:FF:000266', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161241, NULL, 'G3DSA:3.90.470.10:FF:000027', NULL, NULL, 'LSU ribosomal protein L22P', NULL, NULL, NULL, NULL, NULL, 4),
(161242, NULL, 'G3DSA:1.10.510.10:FF:000574', NULL, NULL, 'Cell division related protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(161243, NULL, 'G3DSA:2.40.100.10:FF:000066', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(161244, NULL, 'G3DSA:3.40.50.300:FF:008368', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161245, NULL, 'G3DSA:1.25.40.190:FF:000007', NULL, NULL, 'Actin-related protein 2/3 complex subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(161246, NULL, 'G3DSA:3.30.70.330:FF:002661', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161247, NULL, 'G3DSA:1.10.10.10:FF:000664', NULL, NULL, 'Lactose phosphotransferase system repressor', NULL, NULL, NULL, NULL, NULL, 4),
(161248, NULL, 'G3DSA:3.40.50.2300:FF:000255', NULL, NULL, 'BMP family ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(161249, NULL, 'G3DSA:2.60.40.10:FF:003213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161250, NULL, 'G3DSA:2.60.40.10:FF:004950', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161251, NULL, 'G3DSA:1.10.238.10:FF:000974', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161252, NULL, 'G3DSA:2.120.10.80:FF:000166', NULL, NULL, 'Klhl4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(161253, NULL, 'G3DSA:3.40.50.720:FF:002305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161254, NULL, 'G3DSA:1.25.40.180:FF:000004', NULL, NULL, 'pre-mRNA-splicing factor CWC22 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(161255, NULL, 'G3DSA:1.20.900.10:FF:000101', NULL, NULL, 'Rho guanine nucleotide exchange factor (GEF) 26', NULL, NULL, NULL, NULL, NULL, 4),
(161256, NULL, 'G3DSA:3.30.710.10:FF:000251', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(161257, NULL, 'G3DSA:3.30.160.60:FF:005321', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161258, NULL, 'G3DSA:1.10.8.790:FF:000002', NULL, NULL, 'RNA-dependent RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(161259, NULL, 'G3DSA:3.60.21.10:FF:000486', NULL, NULL, 'Protein CBG05769', NULL, NULL, NULL, NULL, NULL, 4),
(161260, NULL, 'G3DSA:1.10.1070.11:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161261, NULL, 'G3DSA:1.25.40.10:FF:004612', NULL, NULL, 'Uncharacterized Sel1-like repeat-containing protein C1B3.10c', NULL, NULL, NULL, NULL, NULL, 4),
(161262, NULL, 'G3DSA:3.30.40.230:FF:000006', NULL, NULL, 'Glycine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(161263, NULL, 'G3DSA:3.40.140.10:FF:000076', NULL, NULL, 'COP9 signalosome complex subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(161264, NULL, 'G3DSA:2.40.30.10:FF:000454', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161265, NULL, 'G3DSA:3.10.20.90:FF:000689', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(161266, NULL, 'G3DSA:3.30.2160.10:FF:000028', NULL, NULL, 'Ubiquitin ligase e3', NULL, NULL, NULL, NULL, NULL, 4),
(161267, NULL, 'G3DSA:1.20.90.10:FF:000011', NULL, NULL, 'Phospholipase A(2)', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(161268, NULL, 'G3DSA:1.20.1250.20:FF:000721', NULL, NULL, 'Synaptic vesicle glycoprotein 2C', NULL, NULL, NULL, NULL, NULL, 4),
(161269, NULL, 'G3DSA:3.30.70.330:FF:000744', NULL, NULL, 'RNA recognition motif (RRM)-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(161270, NULL, 'G3DSA:3.30.40.10:FF:000183', NULL, NULL, 'putative E3 ubiquitin-protein ligase UBR7', NULL, NULL, NULL, NULL, NULL, 4),
(161271, NULL, 'G3DSA:2.60.120.260:FF:000370', NULL, NULL, 'Protein CBG10890', NULL, NULL, NULL, NULL, NULL, 4),
(161272, NULL, 'G3DSA:1.20.1080.10:FF:000008', NULL, NULL, 'Nitrite transporter NirC', NULL, NULL, NULL, NULL, NULL, 4),
(161273, NULL, 'G3DSA:1.10.150.670:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161274, NULL, 'G3DSA:3.20.20.190:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161275, NULL, 'G3DSA:3.40.50.1980:FF:000136', NULL, NULL, 'Periplasmic binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(161276, NULL, 'G3DSA:3.30.2010.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161277, NULL, 'G3DSA:2.30.29.30:FF:001199', NULL, NULL, 'Mitogen-activated protein kinase associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(161278, NULL, 'G3DSA:1.20.58.2190:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161279, NULL, 'G3DSA:3.30.70.660:FF:000028', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(161280, NULL, 'G3DSA:3.40.50.620:FF:000140', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(161281, NULL, 'G3DSA:1.10.472.10:FF:000681', NULL, NULL, 'G1/S-specific cyclin pas1', NULL, NULL, NULL, NULL, NULL, 4),
(161282, NULL, 'G3DSA:1.10.10.10:FF:000990', NULL, NULL, 'Putative Crp-family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(161283, NULL, 'G3DSA:2.160.10.10:FF:000065', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(161284, NULL, 'G3DSA:3.40.50.300:FF:008582', NULL, NULL, 'Terminase, large subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(161285, NULL, 'G3DSA:1.20.58.1780:FF:000019', NULL, NULL, 'Nuclear pore complex protein NUP155', NULL, NULL, NULL, NULL, NULL, 4),
(161286, NULL, 'G3DSA:3.40.50.12780:FF:000003', NULL, NULL, 'Long-chain-fatty-acid--CoA ligase FadD', NULL, NULL, NULL, NULL, NULL, 4),
(161287, NULL, 'G3DSA:3.90.226.10:FF:000269', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(161288, NULL, 'G3DSA:1.25.40.10:FF:004275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161289, NULL, 'G3DSA:2.60.120.650:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161290, NULL, 'G3DSA:3.30.40.10:FF:002318', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(161291, NULL, 'G3DSA:1.10.150.120:FF:000003', NULL, NULL, 'Carbon monoxide dehydrogenase, small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(161292, NULL, 'G3DSA:3.30.1490.20:FF:000100', NULL, NULL, 'Cycloserine biosynthesis protein DcsG', NULL, NULL, NULL, NULL, NULL, 4),
(161293, NULL, 'G3DSA:3.40.50.11370:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161294, NULL, 'G3DSA:3.30.230.10:FF:000006', NULL, NULL, 'Translation elongation factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(161295, NULL, 'G3DSA:3.30.200.20:FF:000507', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(161296, NULL, 'G3DSA:3.10.20.10:FF:000025', NULL, NULL, '60S ribosomal protein L18a', NULL, NULL, NULL, NULL, NULL, 4),
(161297, NULL, 'G3DSA:1.25.40.20:FF:001052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161298, NULL, 'G3DSA:3.80.10.10:FF:001797', NULL, NULL, 'GD21685', NULL, NULL, NULL, NULL, NULL, 4),
(161299, NULL, 'G3DSA:1.10.1170.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161300, NULL, 'G3DSA:3.30.450.20:FF:000216', NULL, NULL, 'Sensory box/GGDEF family protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(161301, NULL, 'G3DSA:2.30.40.10:FF:000016', NULL, NULL, 'Guanine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(161302, NULL, 'G3DSA:1.10.150.240:FF:000039', NULL, NULL, 'Epoxide hydrolase 2', NULL, NULL, NULL, NULL, NULL, 4),
(161303, NULL, 'G3DSA:1.25.40.170:FF:000001', NULL, NULL, 'Protein Smaug homolog 1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(161304, NULL, 'G3DSA:1.10.10.60:FF:000297', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(161305, NULL, 'G3DSA:2.30.42.10:FF:000083', NULL, NULL, 'Tail-specific protease', NULL, NULL, NULL, NULL, NULL, 4),
(161306, NULL, 'G3DSA:2.10.50.30:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161307, NULL, 'G3DSA:3.40.50.1820:FF:000116', NULL, NULL, 'Sterigmatocystin biosynthesis polyketide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(161308, NULL, 'G3DSA:4.10.91.10:FF:000001', NULL, NULL, 'Cytochrome c oxidase subunit 7A1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(161309, NULL, 'G3DSA:1.20.1530.20:FF:000092', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(161310, NULL, 'G3DSA:2.10.55.10:FF:000001', NULL, NULL, 'Leishmanolysin like peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(161311, NULL, 'G3DSA:1.25.10.10:FF:002744', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(161312, NULL, 'G3DSA:3.50.7.10:FF:000084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161313, NULL, 'G3DSA:2.130.10.10:FF:004714', NULL, NULL, 'MIP10235p', NULL, NULL, NULL, NULL, NULL, 4),
(161314, NULL, 'G3DSA:3.40.50.1000:FF:000438', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(161315, NULL, 'G3DSA:1.25.40.10:FF:002246', NULL, NULL, 'Os01g0301700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(161316, NULL, 'G3DSA:3.40.50.2300:FF:000160', NULL, NULL, 'DNA-binding transcriptional repressor EbgR', NULL, NULL, NULL, NULL, NULL, 4),
(161317, NULL, 'G3DSA:3.30.559.10:FF:000022', NULL, NULL, 'Trehalose-2-sulfate acyltransferase papA2', NULL, NULL, NULL, NULL, NULL, 4),
(161318, NULL, 'G3DSA:1.10.357.90:FF:000004', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(161319, NULL, 'G3DSA:2.60.40.1090:FF:000011', NULL, NULL, 'Fimbrial-like adhesin protein', NULL, NULL, NULL, NULL, NULL, 4),
(161320, NULL, 'G3DSA:3.40.190.10:FF:000466', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(161321, NULL, 'G3DSA:1.10.150.130:FF:000006', NULL, NULL, 'Prophage DLP12 integrase', NULL, NULL, NULL, NULL, NULL, 4),
(161322, NULL, 'G3DSA:2.60.40.10:FF:000779', NULL, NULL, 'Titin b', NULL, NULL, NULL, NULL, NULL, 4),
(161323, NULL, 'G3DSA:3.10.129.10:FF:000067', NULL, NULL, 'Thioesterase-like family protein', NULL, NULL, NULL, NULL, NULL, 4),
(161324, NULL, 'G3DSA:1.20.1070.10:FF:002065', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(161325, NULL, 'G3DSA:3.40.50.720:FF:000265', NULL, NULL, 'NAD dependent epimerase/dehydratase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(161326, NULL, 'G3DSA:1.25.10.10:FF:001333', NULL, NULL, 'AGAP012183-PA', NULL, NULL, NULL, NULL, NULL, 4),
(161327, NULL, 'G3DSA:3.30.40.10:FF:002223', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(161328, NULL, 'G3DSA:1.20.1250.20:FF:002071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161329, NULL, 'G3DSA:3.80.10.10:FF:003484', NULL, NULL, 'Fgr28p', NULL, NULL, NULL, NULL, NULL, 4),
(161330, NULL, 'G3DSA:2.130.10.10:FF:005203', NULL, NULL, 'ELongator complex Protein Component', NULL, NULL, NULL, NULL, NULL, 4),
(161331, NULL, 'G3DSA:3.40.50.300:FF:003360', NULL, NULL, 'Methylcoenzyme M reductase system, component A2', NULL, NULL, NULL, NULL, NULL, 4),
(161332, NULL, 'G3DSA:2.60.40.420:FF:000234', NULL, NULL, 'Periplasmic cell division protein (SufI)', NULL, NULL, NULL, NULL, NULL, 4),
(161333, NULL, 'G3DSA:1.25.40.20:FF:001731', NULL, NULL, 'Glycerophosphodiester phosphodiesterase gde1', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(161334, NULL, 'G3DSA:1.10.510.10:FF:001400', NULL, NULL, 'Mitogen-activated protein kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(161335, NULL, 'G3DSA:2.60.40.10:FF:004624', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161336, NULL, 'G3DSA:1.20.1560.10:FF:000702', NULL, NULL, 'ABC transporter, ATP-binding protein, MsbA family', NULL, NULL, NULL, NULL, NULL, 4),
(161337, NULL, 'G3DSA:3.50.50.60:FF:000736', NULL, NULL, 'Probable oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(161338, NULL, 'G3DSA:3.40.1190.20:FF:000103', NULL, NULL, 'Tagatose-6-phosphate kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(161339, NULL, 'G3DSA:3.40.50.300:FF:005142', NULL, NULL, 'Putative ABC transporter ATP-binding protein VNG_1631G', NULL, NULL, NULL, NULL, NULL, 4),
(161340, NULL, 'G3DSA:2.60.210.10:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161341, NULL, 'G3DSA:3.40.850.10:FF:000141', NULL, NULL, 'Kinesin-like protein KIN-6', NULL, NULL, NULL, NULL, NULL, 4),
(161342, NULL, 'G3DSA:3.30.2350.10:FF:000054', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(161343, NULL, 'G3DSA:1.10.400.10:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161344, NULL, 'G3DSA:3.40.50.620:FF:000235', NULL, NULL, 'Leucine--tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(161345, NULL, 'G3DSA:3.40.50.80:FF:000142', NULL, NULL, 'Ferric reductase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(161346, NULL, 'G3DSA:3.40.50.300:FF:001117', NULL, NULL, 'Mitochondrial Rho GTPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(161347, NULL, 'G3DSA:2.70.230.10:FF:000001', NULL, NULL, 'Envelope glycoprotein D', NULL, NULL, NULL, NULL, NULL, 4),
(161348, NULL, 'G3DSA:2.130.10.10:FF:004809', NULL, NULL, 'Shk1 kinase-binding protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(161349, NULL, 'G3DSA:2.30.30.40:FF:000654', NULL, NULL, 'Small G protein signaling modulator 3', NULL, NULL, NULL, NULL, NULL, 4),
(161350, NULL, 'G3DSA:3.30.565.10:FF:000177', NULL, NULL, 'Mlh3p', NULL, NULL, NULL, NULL, NULL, 4),
(161351, NULL, 'G3DSA:3.30.160.60:FF:000779', NULL, NULL, 'zinc finger protein 385B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(161352, NULL, 'G3DSA:3.40.50.2300:FF:000581', NULL, NULL, 'Metabotropic glutamate receptor-like protein D', NULL, NULL, NULL, NULL, NULL, 4),
(161353, NULL, 'G3DSA:3.40.50.2000:FF:000272', NULL, NULL, 'Adhesin', NULL, NULL, NULL, NULL, NULL, 4),
(161354, NULL, 'G3DSA:2.60.40.10:FF:006086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161355, NULL, 'G3DSA:3.40.50.11660:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161356, NULL, 'G3DSA:1.10.10.60:FF:001140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161357, NULL, 'G3DSA:1.10.630.10:FF:000150', NULL, NULL, 'beta-amyrin 11-oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(161358, NULL, 'G3DSA:3.40.50.460:FF:000035', NULL, NULL, 'Phosphofructokinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(161359, NULL, 'G3DSA:2.60.40.10:FF:000684', NULL, NULL, 'Dystroglycan 1', NULL, NULL, NULL, NULL, NULL, 4),
(161360, NULL, 'G3DSA:1.20.140.20:FF:000012', NULL, NULL, '[Pyruvate dehydrogenase (acetyl-transferring)] kinase isozyme 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(161361, NULL, 'G3DSA:3.40.50.970:FF:000109', NULL, NULL, 'Indolepyruvate oxidoreductase subunit IorA', NULL, NULL, NULL, NULL, NULL, 4),
(161362, NULL, 'G3DSA:3.10.20.90:FF:000577', NULL, NULL, 'FERM, RhoGEF (ARHGEF) and pleckstrin domain protein 1 (chondrocyte-derived)', NULL, NULL, NULL, NULL, NULL, 4),
(161363, NULL, 'G3DSA:1.20.5.470:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161364, NULL, 'G3DSA:2.130.10.10:FF:002348', NULL, NULL, 'Guanine nucleotide-binding beta subunit-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(161365, NULL, 'G3DSA:3.30.200.20:FF:000496', NULL, NULL, 'Cell cycle protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(161366, NULL, 'G3DSA:3.50.50.60:FF:000950', NULL, NULL, 'FAD-dependent oxidoreductase domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(161367, NULL, 'G3DSA:1.10.287.1350:FF:000001', NULL, NULL, 'Carminomycin 4-O-methyltransferase DnrK', NULL, NULL, NULL, NULL, NULL, 4),
(161368, NULL, 'G3DSA:1.10.238.10:FF:000648', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161369, NULL, 'G3DSA:3.30.70.330:FF:000632', NULL, NULL, 'Poly(A) binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(161370, NULL, 'G3DSA:3.40.50.2000:FF:000058', NULL, NULL, 'Alpha-1,3-glucan synthase Ags1', NULL, NULL, NULL, NULL, NULL, 4),
(161371, NULL, 'G3DSA:1.10.418.10:FF:000067', NULL, NULL, 'kinesin-like protein KIN-14F', NULL, NULL, NULL, NULL, NULL, 4),
(161372, NULL, 'G3DSA:3.80.10.10:FF:001808', NULL, NULL, 'Antagonist of mitotic exit network protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(161373, NULL, 'G3DSA:3.30.505.10:FF:000089', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(161374, NULL, 'G3DSA:1.10.287.70:FF:000133', NULL, NULL, 'KCNN (Potassium K ChaNNel, calcium activated)-Like', NULL, NULL, NULL, NULL, NULL, 4),
(161375, NULL, 'G3DSA:1.20.1250.20:FF:001891', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161376, NULL, 'G3DSA:2.60.40.10:FF:001173', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(161377, NULL, 'G3DSA:3.30.40.10:FF:000071', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(161378, NULL, 'G3DSA:1.20.1300.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161379, NULL, 'G3DSA:3.50.50.60:FF:000057', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(161380, NULL, 'G3DSA:2.60.120.260:FF:000482', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161381, NULL, 'G3DSA:3.30.300.30:FF:000080', NULL, NULL, 'Aspergillus niger contig An11c0010, genomic contig', NULL, NULL, NULL, NULL, NULL, 4),
(161382, NULL, 'G3DSA:2.20.70.10:FF:000159', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(161383, NULL, 'G3DSA:3.30.200.20:FF:000833', NULL, NULL, 'Protein kinase KNS1', NULL, NULL, NULL, NULL, NULL, 4),
(161384, NULL, 'G3DSA:3.20.20.80:FF:000141', NULL, NULL, 'Glucosylceramidase beta 3 (gene/pseudogene)', NULL, NULL, NULL, NULL, NULL, 4),
(161385, NULL, 'G3DSA:3.30.70.330:FF:000306', NULL, NULL, 'CUGBP Elav-like family member 4 isoform X47', NULL, NULL, NULL, NULL, NULL, 4),
(161386, NULL, 'G3DSA:1.20.1070.10:FF:002082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161387, NULL, 'G3DSA:2.30.29.30:FF:000013', NULL, NULL, 'Putative TBC1 domain family member 8B', NULL, NULL, NULL, NULL, NULL, 4),
(161388, NULL, 'G3DSA:1.25.10.10:FF:000518', NULL, NULL, 'Receptor mediated endocytosis 8, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(161389, NULL, 'G3DSA:1.25.40.10:FF:005101', NULL, NULL, 'LD22235p', NULL, NULL, NULL, NULL, NULL, 4),
(161390, NULL, 'G3DSA:3.30.2090.10:FF:000016', NULL, NULL, 'RND multidrug efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(161391, NULL, 'G3DSA:1.25.40.10:FF:004819', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161392, NULL, 'G3DSA:1.25.40.10:FF:003201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161393, NULL, 'G3DSA:2.40.50.770:FF:000025', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(161394, NULL, 'G3DSA:3.30.1240.10:FF:000051', NULL, NULL, 'Cof-type HAD-IIB family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(161395, NULL, 'G3DSA:3.30.230.10:FF:000332', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(161396, NULL, 'G3DSA:3.10.110.10:FF:000058', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 6', NULL, NULL, NULL, NULL, NULL, 4),
(161397, NULL, 'G3DSA:2.170.300.10:FF:000016', NULL, NULL, 'Multiple epidermal growth factor-like domains 10', NULL, NULL, NULL, NULL, NULL, 4),
(161398, NULL, 'G3DSA:1.10.3720.10:FF:000218', NULL, NULL, 'Peptide/nickel transport system permease protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(161399, NULL, 'G3DSA:3.30.160.20:FF:000211', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(161400, NULL, 'G3DSA:3.40.350.10:FF:000097', NULL, NULL, 'AGL032Cp', NULL, NULL, NULL, NULL, NULL, 4),
(161401, NULL, 'G3DSA:3.40.640.10:FF:000439', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(161402, NULL, 'G3DSA:1.20.1560.10:FF:000253', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(161403, NULL, 'G3DSA:1.10.238.10:FF:000862', NULL, NULL, 'Phospholipase D B', NULL, NULL, NULL, NULL, NULL, 4),
(161404, NULL, 'G3DSA:2.130.10.10:FF:000662', NULL, NULL, 'WD repeat domain 73', NULL, NULL, NULL, NULL, NULL, 4),
(161405, NULL, 'G3DSA:1.25.40.10:FF:002925', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161406, NULL, 'G3DSA:3.30.420.10:FF:000032', NULL, NULL, 'Retrovirus-related Pol polyprotein from transposon 297-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(161407, NULL, 'G3DSA:2.30.30.40:FF:000637', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161408, NULL, 'G3DSA:3.40.390.10:FF:000217', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161409, NULL, 'G3DSA:1.10.10.250:FF:000001', NULL, NULL, '50S ribosomal protein L11', NULL, NULL, NULL, NULL, NULL, 4),
(161410, NULL, 'G3DSA:3.100.10.10:FF:000030', NULL, NULL, 'Putative 60S ribosomal protein L27a-1', NULL, NULL, NULL, NULL, NULL, 4),
(161411, NULL, 'G3DSA:3.40.630.10:FF:000372', NULL, NULL, 'ACY1L2 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(161412, NULL, 'G3DSA:1.10.8.10:FF:000005', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(161413, NULL, 'G3DSA:2.160.20.10:FF:000234', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(161414, NULL, 'G3DSA:2.40.50.40:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161415, NULL, 'G3DSA:1.10.8.20:FF:000008', NULL, NULL, 'SEC14 cytosolic factor family protein', NULL, NULL, NULL, NULL, NULL, 4),
(161416, NULL, 'G3DSA:3.60.15.10:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161417, NULL, 'G3DSA:2.40.10.10:FF:000571', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161418, NULL, 'G3DSA:3.10.310.10:FF:000040', NULL, NULL, 'Diaminopimelate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(161419, NULL, 'G3DSA:2.60.40.10:FF:002584', NULL, NULL, 'Filamin 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(161420, NULL, 'G3DSA:2.60.40.10:FF:005225', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161421, NULL, 'G3DSA:3.30.497.10:FF:000147', NULL, NULL, 'Serpin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(161422, NULL, 'G3DSA:3.40.50.1000:FF:000859', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161423, NULL, 'G3DSA:3.40.50.150:FF:000757', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase G', NULL, NULL, NULL, NULL, NULL, 4),
(161424, NULL, 'G3DSA:1.20.1560.10:FF:000023', NULL, NULL, 'Multidrug ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(161425, NULL, 'G3DSA:1.25.40.820:FF:000011', NULL, NULL, 'AGAP008431-PA', NULL, NULL, NULL, NULL, NULL, 4),
(161426, NULL, 'G3DSA:2.10.10.10:FF:000015', NULL, NULL, 'Binder of sperm protein homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(161427, NULL, 'G3DSA:3.40.850.10:FF:000253', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(161428, NULL, 'G3DSA:3.10.100.10:FF:000226', NULL, NULL, 'Lymphocyte antigen 75', NULL, NULL, NULL, NULL, NULL, 4),
(161429, NULL, 'G3DSA:1.25.40.10:FF:002684', NULL, NULL, 'Putative TPR repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(161430, NULL, 'G3DSA:3.30.160.60:FF:004495', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161431, NULL, 'G3DSA:3.40.630.10:FF:000276', NULL, NULL, 'IAA-amino acid hydrolase ILR1-like 4 isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(161432, NULL, 'G3DSA:3.40.1110.10:FF:000112', NULL, NULL, 'Metal cation transporter P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(161433, NULL, 'G3DSA:3.80.10.10:FF:004422', NULL, NULL, 'Leucine-rich repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(161434, NULL, 'G3DSA:1.10.357.10:FF:000037', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(161435, NULL, 'G3DSA:1.25.40.20:FF:001501', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161436, NULL, 'G3DSA:3.40.50.620:FF:000123', NULL, NULL, 'Universal stress protein family', NULL, NULL, NULL, NULL, NULL, 4),
(161437, NULL, 'G3DSA:3.40.50.1820:FF:000330', NULL, NULL, 'Monoglyceride lipase', NULL, NULL, NULL, NULL, NULL, 4),
(161438, NULL, 'G3DSA:3.40.30.10:FF:001233', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(161439, NULL, 'G3DSA:2.70.150.10:FF:000079', NULL, NULL, 'Copper-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(161440, NULL, 'G3DSA:3.10.450.700:FF:000013', NULL, NULL, 'Transcription factor Pur-alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(161441, NULL, 'G3DSA:2.60.40.1180:FF:000179', NULL, NULL, 'Lysosomal alpha-mannosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(161442, NULL, 'G3DSA:3.90.79.10:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161443, NULL, 'G3DSA:1.10.10.1410:FF:000001', NULL, NULL, '60S acidic ribosomal protein P1', NULL, NULL, NULL, NULL, NULL, 4),
(161444, NULL, 'G3DSA:3.50.4.10:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161445, NULL, 'G3DSA:1.20.1420.30:FF:000103', NULL, NULL, 'Vacuolar cation/proton exchanger 2', NULL, NULL, NULL, NULL, NULL, 4),
(161446, NULL, 'G3DSA:1.25.40.10:FF:001402', NULL, NULL, 'Intraflagellar transport protein 56 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(161447, NULL, 'G3DSA:3.30.300.30:FF:000107', NULL, NULL, 'PKS-NRPS hybrid synthetase psoA', NULL, NULL, NULL, NULL, NULL, 4),
(161448, NULL, 'G3DSA:1.20.1310.10:FF:000218', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161449, NULL, 'G3DSA:1.20.1270.60:FF:000021', NULL, NULL, 'Endophilin-A2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(161450, NULL, 'G3DSA:3.40.50.2000:FF:000384', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(161451, NULL, 'G3DSA:3.40.30.10:FF:000957', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161452, NULL, 'G3DSA:3.60.10.10:FF:000207', NULL, NULL, 'Endonuclease/exonuclease/phosphatase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(161453, NULL, 'G3DSA:1.50.40.10:FF:000597', NULL, NULL, 'Mitochondrial amino acid carrier', NULL, NULL, NULL, NULL, NULL, 4),
(161454, NULL, 'G3DSA:1.10.418.10:FF:000179', NULL, NULL, 'LIM domain only protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(161455, NULL, 'G3DSA:2.10.25.10:FF:001590', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161456, NULL, 'G3DSA:1.10.10.1420:FF:000004', NULL, NULL, 'DNA replication factor Cdt1', NULL, NULL, NULL, NULL, NULL, 4),
(161457, NULL, 'G3DSA:3.90.1150.10:FF:000261', NULL, NULL, 'Nucleotide sugar transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(161458, NULL, 'G3DSA:3.40.50.1220:FF:000015', NULL, NULL, 'NAD-dependent protein deacetylase SRT1', NULL, NULL, NULL, NULL, NULL, 4),
(161459, NULL, 'G3DSA:1.20.58.60:FF:000552', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(161460, NULL, 'G3DSA:1.20.120.1750:FF:000165', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(161461, NULL, 'G3DSA:2.130.10.10:FF:003163', NULL, NULL, 'AGR180Wp', NULL, NULL, NULL, NULL, NULL, 4),
(161462, NULL, 'G3DSA:1.20.120.1240:FF:000023', NULL, NULL, 'Dynamin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(161463, NULL, 'G3DSA:3.30.1370.10:FF:000049', NULL, NULL, 'far upstream element-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(161464, NULL, 'G3DSA:2.130.10.10:FF:004591', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161465, NULL, 'G3DSA:1.25.40.20:FF:001405', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161466, NULL, 'G3DSA:3.40.190.10:FF:000915', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(161467, NULL, 'G3DSA:2.40.160.110:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161468, NULL, 'G3DSA:3.30.60.30:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161469, NULL, 'G3DSA:1.20.1070.10:FF:000620', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161470, NULL, 'G3DSA:3.30.60.20:FF:000086', NULL, NULL, 'Thymidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(161471, NULL, 'G3DSA:3.90.70.10:FF:000867', NULL, NULL, 'Peptidase C19 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(161472, NULL, 'G3DSA:1.20.58.390:FF:000329', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161473, NULL, 'G3DSA:3.40.50.300:FF:004883', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161474, NULL, 'G3DSA:3.90.1510.10:FF:000002', NULL, NULL, 'Glycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(161475, NULL, 'G3DSA:1.10.287.70:FF:000021', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(161476, NULL, 'G3DSA:1.25.10.10:FF:002418', NULL, NULL, 'GTPase-binding protein rid1', NULL, NULL, NULL, NULL, NULL, 4),
(161477, NULL, 'G3DSA:2.60.40.10:FF:001061', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(161478, NULL, 'G3DSA:3.80.10.10:FF:000044', NULL, NULL, 'Putative leucine-rich repeat protein shoc-2', NULL, NULL, NULL, NULL, NULL, 4),
(161479, NULL, 'G3DSA:3.40.50.11900:FF:000003', NULL, NULL, '(R)-2-hydroxyglutaryl-CoA dehydratase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(161480, NULL, 'G3DSA:3.30.710.10:FF:000037', NULL, NULL, 'BTB (POZ) domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(161481, NULL, 'G3DSA:1.20.930.80:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161482, NULL, 'G3DSA:3.40.50.1820:FF:001639', NULL, NULL, 'Esterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(161483, NULL, 'G3DSA:3.40.50.20:FF:000034', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(161484, NULL, 'G3DSA:3.30.1360.200:FF:000005', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(161485, NULL, 'G3DSA:3.40.5.10:FF:000017', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(161486, NULL, 'G3DSA:3.30.420.40:FF:000608', NULL, NULL, 'Glucokinase regulator family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(161487, NULL, 'G3DSA:1.20.5.700:FF:000001', NULL, NULL, 'Cytochrome f', NULL, NULL, NULL, NULL, NULL, 4),
(161488, NULL, 'G3DSA:2.40.70.10:FF:000349', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161489, NULL, 'G3DSA:2.10.50.10:FF:000012', NULL, NULL, 'tumor necrosis factor receptor superfamily member 16', NULL, NULL, NULL, NULL, NULL, 4),
(161490, NULL, 'G3DSA:2.120.10.30:FF:000516', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161491, NULL, 'G3DSA:3.30.70.270:FF:000018', NULL, NULL, 'Diguanylate cyclase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(161492, NULL, 'G3DSA:3.20.20.450:FF:000014', NULL, NULL, 'Diguanylate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(161493, NULL, 'G3DSA:2.130.10.10:FF:004826', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161494, NULL, 'G3DSA:3.40.50.2000:FF:000513', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(161495, NULL, 'G3DSA:3.80.10.10:FF:001685', NULL, NULL, 'Dynein regulatory complex subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(161496, NULL, 'G3DSA:3.40.1410.10:FF:000045', NULL, NULL, 'Probable chorismate pyruvate-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(161497, NULL, 'G3DSA:1.20.930.60:FF:000011', NULL, NULL, 'Putative methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(161498, NULL, 'G3DSA:3.40.50.300:FF:006906', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161499, NULL, 'G3DSA:3.30.450.20:FF:000104', NULL, NULL, 'Sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(161500, NULL, 'G3DSA:1.10.510.10:FF:000557', NULL, NULL, 'Serine/threonine-protein kinase 33', NULL, NULL, NULL, NULL, NULL, 4),
(161501, NULL, 'G3DSA:2.40.50.140:FF:001112', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161502, NULL, 'G3DSA:3.60.21.10:FF:000469', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161503, NULL, 'G3DSA:3.30.230.130:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161504, NULL, 'G3DSA:3.30.40.10:FF:000306', NULL, NULL, 'PHD finger alfin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(161505, NULL, 'G3DSA:3.30.200.20:FF:000737', NULL, NULL, 'Protein kinase putative (CRK)', NULL, NULL, NULL, NULL, NULL, 4),
(161506, NULL, 'G3DSA:1.20.5.710:FF:000004', NULL, NULL, '50S ribosomal protein L7/L12', NULL, NULL, NULL, NULL, NULL, 4),
(161507, NULL, 'G3DSA:2.60.120.260:FF:000044', NULL, NULL, 'Reelin', NULL, NULL, NULL, NULL, NULL, 4),
(161508, NULL, 'G3DSA:1.10.1600.10:FF:000029', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(161509, NULL, 'G3DSA:2.60.40.10:FF:004169', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161510, NULL, 'G3DSA:1.20.1250.20:FF:001918', NULL, NULL, 'Putative nitrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(161511, NULL, 'G3DSA:2.60.40.10:FF:006069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161512, NULL, 'G3DSA:3.40.630.40:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161513, NULL, 'G3DSA:3.30.70.330:FF:002431', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161514, NULL, 'G3DSA:3.40.50.150:FF:001246', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161515, NULL, 'G3DSA:3.40.50.720:FF:001788', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161516, NULL, 'G3DSA:3.30.60.20:FF:000069', NULL, NULL, 'SET domain binding factor', NULL, NULL, NULL, NULL, NULL, 4),
(161517, NULL, 'G3DSA:1.25.10.10:FF:002856', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161518, NULL, 'G3DSA:1.10.510.10:FF:001063', NULL, NULL, 'Protein kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(161519, NULL, 'G3DSA:3.20.20.100:FF:000140', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(161520, NULL, 'G3DSA:3.50.50.60:FF:000287', NULL, NULL, 'Cholesterol oxidase ChoD', NULL, NULL, NULL, NULL, NULL, 4),
(161521, NULL, 'G3DSA:2.30.30.100:FF:000132', NULL, NULL, 'Putative small nuclear ribonucleoprotein G', NULL, NULL, NULL, NULL, NULL, 4),
(161522, NULL, 'G3DSA:3.30.70.330:FF:002644', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161523, NULL, 'G3DSA:1.25.40.10:FF:002358', NULL, NULL, 'ERAD-associated E3 ubiquitin-protein ligase component HRD3A', NULL, NULL, NULL, NULL, NULL, 4),
(161524, NULL, 'G3DSA:3.90.640.10:FF:000170', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(161525, NULL, 'G3DSA:3.30.460.20:FF:000032', NULL, NULL, 'Magnesium transport protein CorA', NULL, NULL, NULL, NULL, NULL, 4),
(161526, NULL, 'G3DSA:1.20.58.1380:FF:000006', NULL, NULL, 'Nuclear pore complex protein Nup133', NULL, NULL, NULL, NULL, NULL, 4),
(161527, NULL, 'G3DSA:1.10.150.50:FF:000102', NULL, NULL, 'uncharacterized protein LOC108093779', NULL, NULL, NULL, NULL, NULL, 4),
(161528, NULL, 'G3DSA:3.30.160.60:FF:003067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161529, NULL, 'G3DSA:3.40.50.720:FF:002064', NULL, NULL, 'Oxidoreductase, short-chain dehydrogenase/reductase family', NULL, NULL, NULL, NULL, NULL, 4),
(161530, NULL, 'G3DSA:3.40.50.1370:FF:000032', NULL, NULL, 'Aspartate carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(161531, NULL, 'G3DSA:2.10.25.10:FF:000611', NULL, NULL, 'Cysteine rich with EGF like domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(161532, NULL, 'G3DSA:3.30.160.60:FF:002578', NULL, NULL, 'Blast:Zinc finger protein 568', NULL, NULL, NULL, NULL, NULL, 4),
(161533, NULL, 'G3DSA:3.40.50.1380:FF:000035', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(161534, NULL, 'G3DSA:3.40.50.2300:FF:000608', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(161535, NULL, 'G3DSA:1.10.10.10:FF:001602', NULL, NULL, 'Ribosomal protein S19', NULL, NULL, NULL, NULL, NULL, 4),
(161536, NULL, 'G3DSA:2.70.170.10:FF:000288', NULL, NULL, 'Si:ch211-39a7.1', NULL, NULL, NULL, NULL, NULL, 4),
(161537, NULL, 'G3DSA:3.30.70.260:FF:000015', NULL, NULL, 'Glycine cleavage system transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(161538, NULL, 'G3DSA:2.60.40.10:FF:001622', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(161539, NULL, 'G3DSA:3.55.50.30:FF:000009', NULL, NULL, 'DUF4974 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(161540, NULL, 'G3DSA:1.20.58.1370:FF:000003', NULL, NULL, 'Lysine-specific demethylase jmjd-3.1', NULL, NULL, NULL, NULL, NULL, 4),
(161541, NULL, 'G3DSA:3.40.50.620:FF:000561', NULL, NULL, 'YALI0A19624p', NULL, NULL, NULL, NULL, NULL, 4),
(161542, NULL, 'G3DSA:2.130.10.10:FF:004265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161543, NULL, 'G3DSA:1.20.1050.10:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161544, NULL, 'G3DSA:1.25.10.10:FF:002289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161545, NULL, 'G3DSA:3.40.50.1110:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161546, NULL, 'G3DSA:3.30.200.20:FF:002424', NULL, NULL, 'Protein kinase C delta', NULL, NULL, NULL, NULL, NULL, 4),
(161547, NULL, 'G3DSA:1.25.40.10:FF:004258', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(161548, NULL, 'G3DSA:3.40.50.300:FF:000954', NULL, NULL, 'Upregulator of cell proliferation', NULL, NULL, NULL, NULL, NULL, 4),
(161549, NULL, 'G3DSA:1.10.150.120:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161550, NULL, 'G3DSA:3.30.830.10:FF:000086', NULL, NULL, 'Os01g0779100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(161551, NULL, 'G3DSA:3.30.160.60:FF:004169', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161552, NULL, 'G3DSA:3.50.50.60:FF:000512', NULL, NULL, 'Dihydropyrimidine dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(161553, NULL, 'G3DSA:2.10.110.10:FF:000253', NULL, NULL, 'Ci-Fhl1/2/3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(161554, NULL, 'G3DSA:2.160.20.60:FF:000007', NULL, NULL, 'Formyltransferase/hydrolase complex Fhc subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(161555, NULL, 'G3DSA:3.40.1280.10:FF:000107', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase H', NULL, NULL, NULL, NULL, NULL, 4),
(161556, NULL, 'G3DSA:2.40.160.50:FF:000042', NULL, NULL, 'Protein CBR-GOP-3', NULL, NULL, NULL, NULL, NULL, 4),
(161557, NULL, 'G3DSA:1.10.20.10:FF:000378', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161558, NULL, 'G3DSA:2.60.120.200:FF:000262', NULL, NULL, 'OSJNBa0027H06.10-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(161559, NULL, 'G3DSA:1.20.1070.10:FF:000053', NULL, NULL, 'Frizzled class receptor 8a', NULL, NULL, NULL, NULL, NULL, 4),
(161560, NULL, 'G3DSA:3.30.50.10:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161561, NULL, 'G3DSA:1.20.1070.10:FF:001929', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161562, NULL, 'G3DSA:2.40.50.140:FF:000623', NULL, NULL, 'mRNA-capping enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(161563, NULL, 'G3DSA:3.30.420.40:FF:000485', NULL, NULL, 'Chaperone protein DNAK, putative', NULL, NULL, NULL, NULL, NULL, 4),
(161564, NULL, 'G3DSA:3.40.50.300:FF:003130', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(161565, NULL, 'G3DSA:3.10.180.10:FF:000006', NULL, NULL, 'Methylmalonyl-CoA epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(161566, NULL, 'G3DSA:2.60.40.10:FF:003090', NULL, NULL, 'Sialic-acid binding protein-4', NULL, NULL, NULL, NULL, NULL, 4),
(161567, NULL, 'G3DSA:3.10.110.10:FF:000384', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(161568, NULL, 'G3DSA:2.10.25.10:FF:001713', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161569, NULL, 'G3DSA:3.30.200.20:FF:001013', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(161570, NULL, 'G3DSA:2.10.50.30:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161571, NULL, 'G3DSA:3.40.50.1000:FF:000298', NULL, NULL, 'Haloacid dehalogenase like hydrolase domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(161572, NULL, 'G3DSA:3.40.390.10:FF:000094', NULL, NULL, 'Meltrin, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(161573, NULL, 'G3DSA:3.30.63.10:FF:000005', NULL, NULL, 'Guanylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(161574, NULL, 'G3DSA:3.30.519.10:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161575, NULL, 'G3DSA:1.25.40.180:FF:000330', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161576, NULL, 'G3DSA:3.90.1800.10:FF:000007', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(161577, NULL, 'G3DSA:3.40.50.300:FF:006777', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161578, NULL, 'G3DSA:3.30.70.330:FF:000177', NULL, NULL, 'U2 snRNP-associated SURP motif-containing protein-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(161579, NULL, 'G3DSA:3.30.465.10:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161580, NULL, 'G3DSA:3.20.140.10:FF:000041', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(161581, NULL, 'G3DSA:3.30.63.20:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161582, NULL, 'G3DSA:3.40.50.300:FF:002854', NULL, NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(161583, NULL, 'G3DSA:3.10.129.10:FF:000084', NULL, NULL, 'Phenylacetic acid degradation protein PaaD', NULL, NULL, NULL, NULL, NULL, 4),
(161584, NULL, 'G3DSA:3.40.50.300:FF:003343', NULL, NULL, 'ATP/GTP hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(161585, NULL, 'G3DSA:3.30.40.10:FF:000519', NULL, NULL, 'Histone-lysine N-methyltransferase ATX4', NULL, NULL, NULL, NULL, NULL, 4),
(161586, NULL, 'G3DSA:3.30.70.2850:FF:000023', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(161587, NULL, 'G3DSA:4.10.1000.10:FF:000071', NULL, NULL, 'Zinc finger protein family member', NULL, NULL, NULL, NULL, NULL, 4),
(161588, NULL, 'G3DSA:3.40.366.10:FF:000015', NULL, NULL, 'Malonyl CoA-acyl carrier protein transacylase', NULL, NULL, NULL, NULL, NULL, 4),
(161589, NULL, 'G3DSA:3.40.50.300:FF:004439', NULL, NULL, 'ATP-binding cassette protein subfamily G member 3', NULL, NULL, NULL, NULL, NULL, 4),
(161590, NULL, 'G3DSA:3.15.10.30:FF:000008', NULL, NULL, 'GM10364', NULL, NULL, NULL, NULL, NULL, 4),
(161591, NULL, 'G3DSA:4.10.860.10:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161592, NULL, 'G3DSA:3.30.870.10:FF:000077', NULL, NULL, 'Phosphatidylcholine-hydrolyzing phospholipase D (PLD) family', NULL, NULL, NULL, NULL, NULL, 4),
(161593, NULL, 'G3DSA:2.30.29.30:FF:000125', NULL, NULL, 'Putative rab gtpase-activating protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(161594, NULL, 'G3DSA:3.30.200.20:FF:000945', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(161595, NULL, 'G3DSA:3.10.100.10:FF:000439', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161596, NULL, 'G3DSA:3.30.70.330:FF:002318', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161597, NULL, 'G3DSA:2.60.200.20:FF:000229', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(161598, NULL, 'G3DSA:1.10.238.10:FF:000199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161599, NULL, 'G3DSA:2.70.40.10:FF:000026', NULL, NULL, 'dUTPase', NULL, NULL, NULL, NULL, NULL, 4),
(161600, NULL, 'G3DSA:2.60.40.2760:FF:000001', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(161601, NULL, 'G3DSA:3.40.50.300:FF:006569', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161602, NULL, 'G3DSA:3.40.50.360:FF:000123', NULL, NULL, 'Flavoprotein wrbA', NULL, NULL, NULL, NULL, NULL, 4),
(161603, NULL, 'G3DSA:2.130.10.10:FF:000774', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(161604, NULL, 'G3DSA:1.10.10.10:FF:001035', NULL, NULL, 'AfsR/SARP family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(161605, NULL, 'G3DSA:2.10.70.80:FF:000017', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(161606, NULL, 'G3DSA:1.25.40.10:FF:004371', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161607, NULL, 'G3DSA:1.20.58.60:FF:000013', NULL, NULL, 'Spectrin alpha chain, non-erythrocytic 1', NULL, NULL, NULL, NULL, NULL, 4),
(161608, NULL, 'G3DSA:3.30.565.10:FF:000194', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(161609, NULL, 'G3DSA:1.10.490.160:FF:000001', NULL, NULL, 'Ryanodine receptor 2 (Cardiac)', NULL, NULL, NULL, NULL, NULL, 4),
(161610, NULL, 'G3DSA:3.40.50.2300:FF:000710', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161611, NULL, 'G3DSA:3.30.160.60:FF:003522', NULL, NULL, 'Zinc finger and BTB domain-containing 17', NULL, NULL, NULL, NULL, NULL, 4),
(161612, NULL, 'G3DSA:2.60.40.10:FF:000807', NULL, NULL, 'Protein-glutamine gamma-glutamyltransferase 5', NULL, NULL, NULL, NULL, NULL, 4),
(161613, NULL, 'G3DSA:3.40.50.2000:FF:000721', NULL, NULL, 'ADP-heptose:LPS heptosyltransferase II', NULL, NULL, NULL, NULL, NULL, 4),
(161614, NULL, 'G3DSA:3.30.1370.50:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161615, NULL, 'G3DSA:1.10.510.10:FF:004497', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161616, NULL, 'G3DSA:2.60.40.10:FF:005107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161617, NULL, 'G3DSA:2.60.40.60:FF:000671', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161618, NULL, 'G3DSA:1.25.40.10:FF:002813', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(161619, NULL, 'G3DSA:3.90.190.10:FF:000106', NULL, NULL, 'Protein-tyrosine phosphatase 2', NULL, NULL, NULL, NULL, NULL, 4),
(161620, NULL, 'G3DSA:2.60.40.150:FF:000698', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(161621, NULL, 'G3DSA:3.90.660.10:FF:000070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161622, NULL, 'G3DSA:1.20.58.1030:FF:000019', NULL, NULL, 'DNA replication complex GINS protein SLD5', NULL, NULL, NULL, NULL, NULL, 4),
(161623, NULL, 'G3DSA:2.160.20.10:FF:000116', NULL, NULL, 'Exopolygalacturonase clone GBGE184', NULL, NULL, NULL, NULL, NULL, 4),
(161624, NULL, 'G3DSA:3.80.10.10:FF:000370', NULL, NULL, 'Relaxin family peptide receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(161625, NULL, 'G3DSA:2.60.120.260:FF:000611', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(161626, NULL, 'G3DSA:2.60.40.60:FF:000772', NULL, NULL, 'Cadherin', NULL, NULL, NULL, NULL, NULL, 4),
(161627, NULL, 'G3DSA:1.10.340.30:FF:000049', NULL, NULL, 'Endonuclease III family protein', NULL, NULL, NULL, NULL, NULL, 4),
(161628, NULL, 'G3DSA:2.30.30.1040:FF:000003', NULL, NULL, 'Bromodomain and WD repeat domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(161629, NULL, 'G3DSA:2.40.10.10:FF:000683', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161630, NULL, 'G3DSA:4.10.320.10:FF:000008', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(161631, NULL, 'G3DSA:3.30.160.60:FF:004618', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161632, NULL, 'G3DSA:1.10.260.40:FF:000006', NULL, NULL, 'Transcriptional Regulator BldD', NULL, NULL, NULL, NULL, NULL, 4),
(161633, NULL, 'G3DSA:1.10.287.130:FF:000230', NULL, NULL, 'Sensor histidine kinase, HAMP domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(161634, NULL, 'G3DSA:3.40.50.150:FF:000869', NULL, NULL, 'GD20534', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(161635, NULL, 'G3DSA:3.50.50.60:FF:000074', NULL, NULL, 'Squalene monooxygenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(161636, NULL, 'G3DSA:3.40.630.10:FF:000484', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161637, NULL, 'G3DSA:3.30.40.10:FF:000632', NULL, NULL, 'RING-H2 finger protein ATL73', NULL, NULL, NULL, NULL, NULL, 4),
(161638, NULL, 'G3DSA:1.20.1560.10:FF:000135', NULL, NULL, 'ATP-binding cassette sub-family B member 10', NULL, NULL, NULL, NULL, NULL, 4),
(161639, NULL, 'G3DSA:3.80.10.10:FF:001359', NULL, NULL, 'Toll-like receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(161640, NULL, 'G3DSA:3.30.70.1730:FF:000030', NULL, NULL, '50S ribosomal protein L10', NULL, NULL, NULL, NULL, NULL, 4),
(161641, NULL, 'G3DSA:3.30.565.10:FF:000289', NULL, NULL, 'Bacteriophytochrome', NULL, NULL, NULL, NULL, NULL, 4),
(161642, NULL, 'G3DSA:3.30.160.60:FF:005225', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161643, NULL, 'G3DSA:1.20.58.60:FF:000108', NULL, NULL, 'microtubule-actin cross-linking factor 1 isoform X8', NULL, NULL, NULL, NULL, NULL, 4),
(161644, NULL, 'G3DSA:3.30.750.200:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161645, NULL, 'G3DSA:1.20.1070.10:FF:000171', NULL, NULL, 'KISS1 receptor b', NULL, NULL, NULL, NULL, NULL, 4),
(161646, NULL, 'G3DSA:1.20.1420.30:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161647, NULL, 'G3DSA:3.30.70.330:FF:002217', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161648, NULL, 'G3DSA:3.80.10.10:FF:003596', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161649, NULL, 'G3DSA:3.30.1010.10:FF:000124', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(161650, NULL, 'G3DSA:1.10.760.10:FF:000053', NULL, NULL, 'Cytochrome c554', NULL, NULL, NULL, NULL, NULL, 4),
(161651, NULL, 'G3DSA:1.10.260.50:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161652, NULL, 'G3DSA:3.30.40.10:FF:002335', NULL, NULL, 'ATP-dependent RNA helicase DEAH12, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(161653, NULL, 'G3DSA:3.10.310.10:FF:000039', NULL, NULL, 'Diaminopimelate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(161654, NULL, 'G3DSA:2.60.120.200:FF:000054', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(161655, NULL, 'G3DSA:3.90.960.10:FF:000014', NULL, NULL, 'Prolyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(161656, NULL, 'G3DSA:1.25.40.20:FF:000675', NULL, NULL, 'Ankyrin repeat and death domain-containing protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(161657, NULL, 'G3DSA:2.30.29.30:FF:000552', NULL, NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', NULL, NULL, NULL, NULL, NULL, 4),
(161658, NULL, 'G3DSA:2.130.10.10:FF:004473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161659, NULL, 'G3DSA:2.60.40.10:FF:005012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161660, NULL, 'G3DSA:2.30.30.30:FF:000084', NULL, NULL, 'Related to SPT5-transcription elongation protein', NULL, NULL, NULL, NULL, NULL, 4),
(161661, NULL, 'G3DSA:1.10.472.10:FF:000338', NULL, NULL, 'Cyclin domain-containing protein, variant 2', NULL, NULL, NULL, NULL, NULL, 4),
(161662, NULL, 'G3DSA:3.30.160.60:FF:000667', NULL, NULL, 'Zinc finger protein 33B', NULL, NULL, NULL, NULL, NULL, 4),
(161663, NULL, 'G3DSA:3.40.50.410:FF:000161', NULL, NULL, 'Mesocentin', NULL, NULL, NULL, NULL, NULL, 4),
(161664, NULL, 'G3DSA:1.20.58.1480:FF:000019', NULL, NULL, 'Lon protease homolog 2, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(161665, NULL, 'G3DSA:1.25.40.430:FF:000001', NULL, NULL, 'Mitotic checkpoint serine/threonine-protein kinase BUB1', NULL, NULL, NULL, NULL, NULL, 4),
(161666, NULL, 'G3DSA:2.130.10.10:FF:002915', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(161667, NULL, 'G3DSA:3.30.470.20:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161668, NULL, 'G3DSA:3.40.50.1980:FF:000119', NULL, NULL, 'Iron-siderophore ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(161669, NULL, 'G3DSA:3.40.50.2000:FF:000608', NULL, NULL, 'Os01g0598000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(161670, NULL, 'G3DSA:1.25.40.10:FF:000672', NULL, NULL, 'DNAJ heat shock N-terminal domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(161671, NULL, 'G3DSA:2.60.40.2310:FF:000001', NULL, NULL, 'Subtilisin-like protease SBT1.5', NULL, NULL, NULL, NULL, NULL, 4),
(161672, NULL, 'G3DSA:3.30.160.60:FF:004950', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161673, NULL, 'G3DSA:3.30.160.60:FF:001381', NULL, NULL, 'zinc finger protein 566 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(161674, NULL, 'G3DSA:3.50.50.60:FF:000169', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(161675, NULL, 'G3DSA:3.30.1490.100:FF:000009', NULL, NULL, 'DNA polymerase eta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(161676, NULL, 'G3DSA:1.20.120.1630:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161677, NULL, 'G3DSA:1.10.10.60:FF:000763', NULL, NULL, 'Zinc finger homeobox 2', NULL, NULL, NULL, NULL, NULL, 4),
(161678, NULL, 'G3DSA:1.10.1030.10:FF:000007', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(161679, NULL, 'G3DSA:1.20.120.80:FF:000006', NULL, NULL, 'Cytochrome C oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(161680, NULL, 'G3DSA:2.30.30.40:FF:000087', NULL, NULL, 'Src substrate cortactin', NULL, NULL, NULL, NULL, NULL, 4),
(161681, NULL, 'G3DSA:3.40.50.300:FF:007300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161682, NULL, 'G3DSA:1.25.40.280:FF:000017', NULL, NULL, 'pH-response regulator protein palC', NULL, NULL, NULL, NULL, NULL, 4),
(161683, NULL, 'G3DSA:3.30.1230.20:FF:000008', NULL, NULL, '40S ribosomal protein S21', NULL, NULL, NULL, NULL, NULL, 4),
(161684, NULL, 'G3DSA:2.120.10.30:FF:000067', NULL, NULL, 'HHIP-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(161685, NULL, 'G3DSA:3.90.70.10:FF:000188', NULL, NULL, 'Competence factor transporting ATP-binding protein/permease ComA', NULL, NULL, NULL, NULL, NULL, 4),
(161686, NULL, 'G3DSA:3.40.50.720:FF:002390', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161687, NULL, 'G3DSA:3.40.50.300:FF:007620', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(161688, NULL, 'G3DSA:2.20.25.350:FF:000002', NULL, NULL, 'Eukaryotic translation initiation factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(161689, NULL, 'G3DSA:2.120.10.30:FF:000387', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161690, NULL, 'G3DSA:3.40.30.10:FF:001019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161691, NULL, 'G3DSA:3.40.50.720:FF:000153', NULL, NULL, 'Altronate oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(161692, NULL, 'G3DSA:2.40.160.10:FF:000058', NULL, NULL, 'Eukaryotic translation initiation factor 2 alpha', NULL, NULL, NULL, NULL, NULL, 4),
(161693, NULL, 'G3DSA:3.80.20.20:FF:000093', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(161694, NULL, 'G3DSA:1.25.10.10:FF:002194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161695, NULL, 'G3DSA:2.40.128.180:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161696, NULL, 'G3DSA:3.40.50.150:FF:001600', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161697, NULL, 'G3DSA:1.20.120.980:FF:000039', NULL, NULL, 'Prolylcarboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(161698, NULL, 'G3DSA:3.30.2230.10:FF:000011', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(161699, NULL, 'G3DSA:3.80.10.10:FF:003697', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(161700, NULL, 'G3DSA:3.40.50.1970:FF:000021', NULL, NULL, 'multifunctional protein ADE2', NULL, NULL, NULL, NULL, NULL, 4),
(161701, NULL, 'G3DSA:3.30.930.10:FF:000020', NULL, NULL, 'Octanoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(161702, NULL, 'G3DSA:3.40.190.10:FF:000354', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(161703, NULL, 'G3DSA:1.25.40.20:FF:000776', NULL, NULL, 'Transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(161704, NULL, 'G3DSA:3.40.190.10:FF:000236', NULL, NULL, 'Molybdate ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(161705, NULL, 'G3DSA:1.20.1050.10:FF:000271', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161706, NULL, 'G3DSA:1.10.155.10:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161707, NULL, 'G3DSA:2.60.40.4100:FF:000010', NULL, NULL, 'Dusky-like, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(161708, NULL, 'G3DSA:3.40.50.720:FF:000052', NULL, NULL, 'D-lactate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(161709, NULL, 'G3DSA:3.90.1600.10:FF:000009', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(161710, NULL, 'G3DSA:1.10.30.10:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161711, NULL, 'G3DSA:3.90.550.50:FF:000181', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(161712, NULL, 'G3DSA:3.60.40.10:FF:000035', NULL, NULL, 'Leucine rich repeat protein phosphatase 2c domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(161713, NULL, 'G3DSA:3.10.20.90:FF:000791', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161714, NULL, 'G3DSA:1.25.10.10:FF:000956', NULL, NULL, 'Importin alpha-1 subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(161715, NULL, 'G3DSA:3.90.226.10:FF:000157', NULL, NULL, 'Enoyl CoA hydratase (PaaF-4)', NULL, NULL, NULL, NULL, NULL, 4),
(161716, NULL, 'G3DSA:1.20.58.400:FF:000012', NULL, NULL, 'Vesicle transport through interaction with t-SNAREs 1A', NULL, NULL, NULL, NULL, NULL, 4),
(161717, NULL, 'G3DSA:1.20.1070.10:FF:000502', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161718, NULL, 'G3DSA:3.40.50.2000:FF:000401', NULL, NULL, 'Exopolysaccharide biosynthesis protein EpsF', NULL, NULL, NULL, NULL, NULL, 4),
(161719, NULL, 'G3DSA:3.30.200.20:FF:000625', NULL, NULL, 'Os04g0372100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(161720, NULL, 'G3DSA:3.40.50.300:FF:002399', NULL, NULL, 'GTPase SAR1-related small G protein', NULL, NULL, NULL, NULL, NULL, 4),
(161721, NULL, 'G3DSA:3.30.200.20:FF:002183', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(161722, NULL, 'G3DSA:3.90.780.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161723, NULL, 'G3DSA:3.40.50.300:FF:003017', NULL, NULL, 'Phosphoglycerate transport system transcriptional regulatory protein PgtA', NULL, NULL, NULL, NULL, NULL, 4),
(161724, NULL, 'G3DSA:3.30.160.20:FF:000003', NULL, NULL, 'Ribonuclease 3', NULL, NULL, NULL, NULL, NULL, 4),
(161725, NULL, 'G3DSA:1.20.1250.20:FF:001806', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161726, NULL, 'G3DSA:2.60.40.60:FF:000558', NULL, NULL, 'Cadherin-related tumor suppressor', NULL, NULL, NULL, NULL, NULL, 4),
(161727, NULL, 'G3DSA:3.30.590.10:FF:000044', NULL, NULL, 'Glutamate-ammonia ligase', NULL, NULL, NULL, NULL, NULL, 4),
(161728, NULL, 'G3DSA:2.30.30.40:FF:000188', NULL, NULL, 'Insulin receptor tyrosine kinase substrate', NULL, NULL, NULL, NULL, NULL, 4),
(161729, NULL, 'G3DSA:2.30.42.10:FF:000419', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161730, NULL, 'G3DSA:3.30.1370.10:FF:000167', NULL, NULL, 'Exosome complex component Rrp4', NULL, NULL, NULL, NULL, NULL, 4),
(161731, NULL, 'G3DSA:3.40.50.720:FF:001676', NULL, NULL, 'Bll6549 protein', NULL, NULL, NULL, NULL, NULL, 4),
(161732, NULL, 'G3DSA:3.30.160.60:FF:001061', NULL, NULL, 'zinc finger and BTB domain-containing protein 40', NULL, NULL, NULL, NULL, NULL, 4),
(161733, NULL, 'G3DSA:1.10.730.10:FF:000225', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(161734, NULL, 'G3DSA:3.30.160.60:FF:001173', NULL, NULL, 'Zinc finger protein 613', NULL, NULL, NULL, NULL, NULL, 4),
(161735, NULL, 'G3DSA:3.40.50.970:FF:000194', NULL, NULL, 'Thiamine diphosphate dependent-3-acetyloctanal synthase PigD', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(161736, NULL, 'G3DSA:3.40.50.300:FF:001005', NULL, NULL, 'MoxR family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(161737, NULL, 'G3DSA:3.40.50.1820:FF:000004', NULL, NULL, 'Protein FAM135A isoform a', NULL, NULL, NULL, NULL, NULL, 4),
(161738, NULL, 'G3DSA:2.30.42.10:FF:000195', NULL, NULL, 'Serine protease, DegP/HtrA', NULL, NULL, NULL, NULL, NULL, 4),
(161739, NULL, 'G3DSA:3.40.50.880:FF:000173', NULL, NULL, 'Imidazole glycerol phosphate synthase subunit HisH', NULL, NULL, NULL, NULL, NULL, 4),
(161740, NULL, 'G3DSA:3.40.50.150:FF:001134', NULL, NULL, 'Ribosomal RNA-processing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(161741, NULL, 'G3DSA:2.30.42.10:FF:000307', NULL, NULL, 'CBN-SHN-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(161742, NULL, 'G3DSA:2.60.40.820:FF:000023', NULL, NULL, 'CSON002431 protein', NULL, NULL, NULL, NULL, NULL, 4),
(161743, NULL, 'G3DSA:1.20.1740.10:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161744, NULL, 'G3DSA:2.60.34.10:FF:000063', NULL, NULL, 'Heat shock 70 kDa protein cognate 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(161745, NULL, 'G3DSA:2.60.40.1120:FF:000077', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(161746, NULL, 'G3DSA:3.30.420.40:FF:001002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161747, NULL, 'G3DSA:3.30.1520.10:FF:000084', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(161748, NULL, 'G3DSA:3.30.160.60:FF:004719', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161749, NULL, 'G3DSA:1.20.5.2020:FF:000002', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(161750, NULL, 'G3DSA:3.40.50.2000:FF:000390', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(161751, NULL, 'G3DSA:1.20.120.1530:FF:000003', NULL, NULL, 'Atypical/HisK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(161752, NULL, 'G3DSA:1.10.3720.10:FF:000095', NULL, NULL, 'Nitrate/sulfonate/bicarbonate ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(161753, NULL, 'G3DSA:3.80.10.10:FF:003708', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(161754, NULL, 'G3DSA:3.60.10.10:FF:000112', NULL, NULL, 'Probable type I inositol 1,4,5-trisphosphate 5-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(161755, NULL, 'G3DSA:1.25.10.10:FF:003020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(161756, NULL, 'G3DSA:2.60.120.650:FF:000048', NULL, NULL, 'Lysine-specific demethylase 4A', NULL, NULL, NULL, NULL, NULL, 4),
(161757, NULL, 'G3DSA:3.40.50.1910:FF:000025', NULL, NULL, 'Protein transport Sec1b', NULL, NULL, NULL, NULL, NULL, 4),
(161758, NULL, 'G3DSA:1.10.472.170:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161759, NULL, 'G3DSA:1.20.1250.20:FF:000480', NULL, NULL, 'Integral membrane efflux protein', NULL, NULL, NULL, NULL, NULL, 4),
(161760, NULL, 'G3DSA:3.30.70.860:FF:000004', NULL, NULL, 'UPF0234 protein AWC22_11905', NULL, NULL, NULL, NULL, NULL, 4),
(161761, NULL, 'G3DSA:1.25.40.20:FF:001613', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161762, NULL, 'G3DSA:2.10.25.10:FF:001258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161763, NULL, 'G3DSA:2.20.100.10:FF:000031', NULL, NULL, 'Thrombospondin type 1 domain containing 7A', NULL, NULL, NULL, NULL, NULL, 4),
(161764, NULL, 'G3DSA:3.30.70.330:FF:001121', NULL, NULL, 'tRNA selenocysteine 1-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(161765, NULL, 'G3DSA:1.10.510.10:FF:002468', NULL, NULL, 'STE family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(161766, NULL, 'G3DSA:2.120.10.30:FF:000275', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM71', NULL, NULL, NULL, NULL, NULL, 4),
(161767, NULL, 'G3DSA:3.90.980.10:FF:000009', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(161768, NULL, 'G3DSA:3.90.226.10:FF:000056', NULL, NULL, 'Tricorn protease homolog', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(161769, NULL, 'G3DSA:2.60.40.150:FF:000715', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(161770, NULL, 'G3DSA:3.30.70.850:FF:000001', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(161771, NULL, 'G3DSA:2.60.40.10:FF:001055', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', NULL, NULL, NULL, NULL, NULL, 4),
(161772, NULL, 'G3DSA:3.30.70.1450:FF:000047', NULL, NULL, 'DASS family transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(161773, NULL, 'G3DSA:2.30.36.70:FF:000013', NULL, NULL, 'Brahma associated protein 55kD', NULL, NULL, NULL, NULL, NULL, 4),
(161774, NULL, 'G3DSA:3.30.40.10:FF:001829', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(161775, NULL, 'G3DSA:1.20.272.10:FF:000074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161776, NULL, 'G3DSA:3.30.70.870:FF:000007', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(161777, NULL, 'G3DSA:3.30.540.10:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161778, NULL, 'G3DSA:1.10.418.10:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161779, NULL, 'G3DSA:3.40.109.10:FF:000048', NULL, NULL, 'Nitroreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(161780, NULL, 'G3DSA:3.40.50.300:FF:005046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161781, NULL, 'G3DSA:3.60.110.10:FF:000030', NULL, NULL, 'Carbon-nitrogen hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(161782, NULL, 'G3DSA:2.70.150.10:FF:000085', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(161783, NULL, 'G3DSA:1.10.10.60:FF:000651', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(161784, NULL, 'G3DSA:3.40.50.1820:FF:000212', NULL, NULL, 'Acetyl-CoA--deacetylcephalosporin C acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(161785, NULL, 'G3DSA:3.10.20.90:FF:000459', NULL, NULL, 'F15C11.2', NULL, NULL, NULL, NULL, NULL, 4),
(161786, NULL, 'G3DSA:2.40.50.140:FF:000303', NULL, NULL, 'Protection of telomeres protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(161787, NULL, 'G3DSA:1.25.40.10:FF:001610', NULL, NULL, 'Clustered mitochondria protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(161788, NULL, 'G3DSA:1.10.10.60:FF:000858', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161789, NULL, 'G3DSA:3.90.1200.10:FF:000012', NULL, NULL, 'Spore coat protein YsxE', NULL, NULL, NULL, NULL, NULL, 4),
(161790, NULL, 'G3DSA:3.30.230.70:FF:000086', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(161791, NULL, 'G3DSA:1.25.40.10:FF:000559', NULL, NULL, 'Mitochondrial RNA binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(161792, NULL, 'G3DSA:3.80.10.10:FF:002073', NULL, NULL, 'Leucine-rich repeat-containing 24', NULL, NULL, NULL, NULL, NULL, 4),
(161793, NULL, 'G3DSA:2.40.50.140:FF:000286', NULL, NULL, 'Exosome complex component RRP4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(161794, NULL, 'G3DSA:3.40.50.300:FF:004771', NULL, NULL, 'BRCA1 interacting protein C-terminal helicase 1', NULL, NULL, NULL, NULL, NULL, 4),
(161795, NULL, 'G3DSA:2.130.10.10:FF:000869', NULL, NULL, 'Zinc finger CCCH domain-containing protein 48', NULL, NULL, NULL, NULL, NULL, 4),
(161796, NULL, 'G3DSA:1.20.58.60:FF:000440', NULL, NULL, 'Dystrophin-1', NULL, NULL, NULL, NULL, NULL, 4),
(161797, NULL, 'G3DSA:3.30.160.60:FF:006395', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161798, NULL, 'G3DSA:3.30.1050.10:FF:000019', NULL, NULL, 'Probable hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(161799, NULL, 'G3DSA:1.20.1310.10:FF:000095', NULL, NULL, 'Cullin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(161800, NULL, 'G3DSA:1.25.10.10:FF:000844', NULL, NULL, 'TFIIH regulator', NULL, NULL, NULL, NULL, NULL, 4),
(161801, NULL, 'G3DSA:3.40.50.300:FF:006805', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(161802, NULL, 'G3DSA:3.40.50.670:FF:000014', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(161803, NULL, 'G3DSA:3.30.230.10:FF:000219', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(161804, NULL, 'G3DSA:2.170.8.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161805, NULL, 'G3DSA:2.30.42.10:FF:000212', NULL, NULL, 'PDZ domain-containing protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(161806, NULL, 'G3DSA:1.20.1250.20:FF:001795', NULL, NULL, 'Putative membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(161807, NULL, 'G3DSA:3.30.70.920:FF:000045', NULL, NULL, 'Lrp/AsnC family transcription regulator', NULL, NULL, NULL, NULL, NULL, 4),
(161808, NULL, 'G3DSA:1.10.510.10:FF:003075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161809, NULL, 'G3DSA:3.90.1150.10:FF:000373', NULL, NULL, 'Ornithine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(161810, NULL, 'G3DSA:3.40.47.10:FF:000260', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161811, NULL, 'G3DSA:3.40.390.10:FF:000122', NULL, NULL, 'Zinc metalloproteinase', NULL, NULL, NULL, NULL, NULL, 4),
(161812, NULL, 'G3DSA:2.70.98.10:FF:000092', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(161813, NULL, 'G3DSA:1.25.40.10:FF:000773', NULL, NULL, 'Os11g0583200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(161814, NULL, 'G3DSA:1.25.10.10:FF:003019', NULL, NULL, 'Sister chromatid cohesion protein', NULL, NULL, NULL, NULL, NULL, 4),
(161815, NULL, 'G3DSA:3.40.140.10:FF:000188', NULL, NULL, 'Cytosine/adenosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(161816, NULL, 'G3DSA:1.20.1070.10:FF:001694', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(161817, NULL, 'G3DSA:3.30.750.24:FF:000019', NULL, NULL, 'STAS domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(161818, NULL, 'G3DSA:3.30.160.40:FF:000009', NULL, NULL, 'Probable porphobilinogen deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(161819, NULL, 'G3DSA:3.30.160.60:FF:000566', NULL, NULL, 'zinc finger protein 133 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(161820, NULL, 'G3DSA:3.40.309.10:FF:000029', NULL, NULL, 'Aldehyde dehydrogenase family 16 member A1', NULL, NULL, NULL, NULL, NULL, 4),
(161821, NULL, 'G3DSA:3.30.40.10:FF:001947', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161822, NULL, 'G3DSA:3.30.70.3270:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161823, NULL, 'G3DSA:3.40.190.290:FF:000059', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(161824, NULL, 'G3DSA:3.80.10.10:FF:003719', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161825, NULL, 'G3DSA:3.30.70.330:FF:002094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161826, NULL, 'G3DSA:4.10.230.10:FF:000001', NULL, NULL, 'Amyloid beta A4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(161827, NULL, 'G3DSA:2.10.25.10:FF:000403', NULL, NULL, 'Delta-like 3 (Drosophila), isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(161828, NULL, 'G3DSA:2.10.25.140:FF:000003', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(161829, NULL, 'G3DSA:1.20.1250.20:FF:000160', NULL, NULL, 'monocarboxylate transporter 12 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(161830, NULL, 'G3DSA:3.30.870.10:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161831, NULL, 'G3DSA:3.30.9.20:FF:000001', NULL, NULL, '2-polyprenyl-6-methoxyphenol hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(161832, NULL, 'G3DSA:1.10.3380.30:FF:000012', NULL, NULL, 'Probable helicase HelY', NULL, NULL, NULL, NULL, NULL, 4),
(161833, NULL, 'G3DSA:2.60.40.10:FF:005001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161834, NULL, 'G3DSA:1.20.1420.30:FF:000086', NULL, NULL, 'AGAP008342-PA', NULL, NULL, NULL, NULL, NULL, 4),
(161835, NULL, 'G3DSA:2.60.40.150:FF:000592', NULL, NULL, 'Synaptotagmin 15a', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(161836, NULL, 'G3DSA:2.10.25.10:FF:000061', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(161837, NULL, 'G3DSA:1.25.40.20:FF:001490', NULL, NULL, 'Palmitoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(161838, NULL, 'G3DSA:1.10.3120.10:FF:000015', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(161839, NULL, 'G3DSA:2.60.40.60:FF:000878', NULL, NULL, 'E-cadherin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(161840, NULL, 'G3DSA:2.60.40.10:FF:002483', NULL, NULL, 'Jitterbug, isoform M', NULL, NULL, NULL, NULL, NULL, 4),
(161841, NULL, 'G3DSA:2.60.40.820:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161842, NULL, 'G3DSA:3.30.780.10:FF:000070', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(161843, NULL, 'G3DSA:1.20.1070.10:FF:001576', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(161844, NULL, 'G3DSA:2.60.40.10:FF:003101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161845, NULL, 'G3DSA:3.100.10.10:FF:000024', NULL, NULL, 'RPL27A isoform 10', NULL, NULL, NULL, NULL, NULL, 4),
(161846, NULL, 'G3DSA:3.40.640.10:FF:000445', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161847, NULL, 'G3DSA:1.10.287.70:FF:000251', NULL, NULL, 'TAX2', NULL, NULL, NULL, NULL, NULL, 4),
(161848, NULL, 'G3DSA:1.10.486.10:FF:000050', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(161849, NULL, 'G3DSA:1.20.1720.10:FF:000024', NULL, NULL, 'MFS multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(161850, NULL, 'G3DSA:3.40.50.300:FF:001325', NULL, NULL, 'Type II secretion system protein E', NULL, NULL, NULL, NULL, NULL, 4),
(161851, NULL, 'G3DSA:3.30.9.30:FF:000004', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(161852, NULL, 'G3DSA:3.40.50.1820:FF:001847', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161853, NULL, 'G3DSA:2.30.42.10:FF:000318', NULL, NULL, 'Arc, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(161854, NULL, 'G3DSA:1.10.246.200:FF:000001', NULL, NULL, 'WPP domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(161855, NULL, 'G3DSA:2.40.10.10:FF:000672', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161856, NULL, 'G3DSA:1.10.10.60:FF:000752', NULL, NULL, 'Transcriptional adapter 2A', NULL, NULL, NULL, NULL, NULL, 4),
(161857, NULL, 'G3DSA:1.10.150.20:FF:000234', NULL, NULL, 'DNA-dependent RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(161858, NULL, 'G3DSA:2.10.25.10:FF:001685', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161859, NULL, 'G3DSA:3.30.70.330:FF:000295', NULL, NULL, 'RNA-binding motif protein 45', NULL, NULL, NULL, NULL, NULL, 4),
(161860, NULL, 'G3DSA:3.40.1090.10:FF:000071', NULL, NULL, 'Patatin', NULL, NULL, NULL, NULL, NULL, 4),
(161861, NULL, 'G3DSA:2.170.120.40:FF:000011', NULL, NULL, 'Putative exported protein', NULL, NULL, NULL, NULL, NULL, 4),
(161862, NULL, 'G3DSA:3.30.160.60:FF:001504', NULL, NULL, 'zinc finger protein 517 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(161863, NULL, 'G3DSA:1.20.970.10:FF:000021', NULL, NULL, 'Similar to anthranilate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(161864, NULL, 'G3DSA:3.40.50.2300:FF:000816', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161865, NULL, 'G3DSA:1.10.640.10:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161866, NULL, 'G3DSA:1.20.1090.10:FF:000048', NULL, NULL, 'Probable oxidoreductase (Iron-containing alcohol dehydrogenase family)', NULL, NULL, NULL, NULL, NULL, 4),
(161867, NULL, 'G3DSA:3.40.50.720:FF:000714', NULL, NULL, 'Probable oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(161868, NULL, 'G3DSA:2.130.10.10:FF:000763', NULL, NULL, 'U4/U6 small nuclear ribonucleoprotein PRP4-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(161869, NULL, 'G3DSA:2.60.260.20:FF:000126', NULL, NULL, 'YALI0F12551p', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(161870, NULL, 'G3DSA:3.40.50.300:FF:004978', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161871, NULL, 'G3DSA:2.130.10.10:FF:002792', NULL, NULL, 'RE36115p', NULL, NULL, NULL, NULL, NULL, 4),
(161872, NULL, 'G3DSA:3.40.190.10:FF:000674', NULL, NULL, 'Uncharacterized solute-binding protein OE_3270R', NULL, NULL, NULL, NULL, NULL, 4),
(161873, NULL, 'G3DSA:3.30.70.2460:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161874, NULL, 'G3DSA:3.30.70.1350:FF:000023', NULL, NULL, 'Cation efflux family protein', NULL, NULL, NULL, NULL, NULL, 4),
(161875, NULL, 'G3DSA:3.50.50.60:FF:000624', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(161876, NULL, 'G3DSA:2.30.42.10:FF:000420', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161877, NULL, 'G3DSA:3.40.50.300:FF:005254', NULL, NULL, 'ABC transporter, putative (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(161878, NULL, 'G3DSA:3.90.1310.10:FF:000021', NULL, NULL, 'Penicillin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(161879, NULL, 'G3DSA:1.10.3430.10:FF:000016', NULL, NULL, 'Ammonium transporter', NULL, NULL, NULL, NULL, NULL, 4),
(161880, NULL, 'G3DSA:3.30.450.40:FF:000099', NULL, NULL, 'Sensor histidine kinase, KdpD', NULL, NULL, NULL, NULL, NULL, 4),
(161881, NULL, 'G3DSA:3.30.200.20:FF:002536', NULL, NULL, 'Mitogen activated kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(161882, NULL, 'G3DSA:1.25.10.10:FF:001221', NULL, NULL, 'HEAT repeat domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(161883, NULL, 'G3DSA:2.10.25.10:FF:000162', NULL, NULL, 'Coagulation factor X (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(161884, NULL, 'G3DSA:1.25.40.530:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161885, NULL, 'G3DSA:3.30.70.330:FF:000065', NULL, NULL, 'mRNA binding post-transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(161886, NULL, 'G3DSA:3.30.70.330:FF:002195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161887, NULL, 'G3DSA:1.20.1050.10:FF:000282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161888, NULL, 'G3DSA:1.25.10.10:FF:000945', NULL, NULL, 'Importin beta 3 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(161889, NULL, 'G3DSA:3.40.50.620:FF:000353', NULL, NULL, 'DUF218 domain', NULL, NULL, NULL, NULL, NULL, 4),
(161890, NULL, 'G3DSA:2.60.40.1390:FF:000011', NULL, NULL, 'Myelin regulatory factor-like', NULL, NULL, NULL, NULL, NULL, 4),
(161891, NULL, 'G3DSA:3.40.366.10:FF:000004', NULL, NULL, 'Fatty acid synthase beta subunit dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(161892, NULL, 'G3DSA:3.30.460.10:FF:000141', NULL, NULL, 'Iojap-like ribosome-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(161893, NULL, 'G3DSA:2.40.50.140:FF:000511', NULL, NULL, 'OB-fold nucleic acid binding domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(161894, NULL, 'G3DSA:3.40.50.2000:FF:000160', NULL, NULL, 'Glycosyltransferase, group 1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(161895, NULL, 'G3DSA:3.40.1190.20:FF:000221', NULL, NULL, 'Bifunctional NAD(P)H-hydrate repair enzyme Nnr', NULL, NULL, NULL, NULL, NULL, 4),
(161896, NULL, 'G3DSA:1.20.1070.10:FF:001817', NULL, NULL, 'Vasopressin/oxytocin-related Peptide receptor', NULL, NULL, NULL, NULL, NULL, 4),
(161897, NULL, 'G3DSA:3.90.550.10:FF:000646', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161898, NULL, 'G3DSA:2.60.40.790:FF:000087', NULL, NULL, '22.0 kDa heat shock protein', NULL, NULL, NULL, NULL, NULL, 4),
(161899, NULL, 'G3DSA:1.25.40.570:FF:000014', NULL, NULL, 'COP9 signalosome complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(161900, NULL, 'G3DSA:2.70.170.10:FF:000193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161901, NULL, 'G3DSA:3.90.79.10:FF:000275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161902, NULL, 'G3DSA:2.40.50.140:FF:000387', NULL, NULL, 'Unplaced genomic scaffold supercont2.24, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(161903, NULL, 'G3DSA:3.40.50.10930:FF:000004', NULL, NULL, 'RecBCD enzyme subunit RecC', NULL, NULL, NULL, NULL, NULL, 4),
(161904, NULL, 'G3DSA:3.30.200.20:FF:000384', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(161905, NULL, 'G3DSA:1.10.357.90:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161906, NULL, 'G3DSA:2.10.25.160:FF:000009', NULL, NULL, 'Progranulin', NULL, NULL, NULL, NULL, NULL, 4),
(161907, NULL, 'G3DSA:2.70.150.10:FF:000293', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(161908, NULL, 'G3DSA:1.10.510.10:FF:004391', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161909, NULL, 'G3DSA:3.40.228.10:FF:000021', NULL, NULL, 'NADH-quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(161910, NULL, 'G3DSA:1.50.10.20:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161911, NULL, 'G3DSA:2.60.200.10:FF:000018', NULL, NULL, 'Dwarfin sma', NULL, NULL, NULL, NULL, NULL, 4),
(161912, NULL, 'G3DSA:1.25.40.540:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161913, NULL, 'G3DSA:3.30.420.40:FF:000384', NULL, NULL, 'Actin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(161914, NULL, 'G3DSA:3.60.20.10:FF:000040', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(161915, NULL, 'G3DSA:1.10.472.10:FF:000349', NULL, NULL, 'Cyclin A', NULL, NULL, NULL, NULL, NULL, 4),
(161916, NULL, 'G3DSA:1.20.1270.250:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161917, NULL, 'G3DSA:2.60.120.260:FF:000156', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(161918, NULL, 'G3DSA:3.90.650.10:FF:000013', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase subunit PurL', NULL, NULL, NULL, NULL, NULL, 4),
(161919, NULL, 'G3DSA:2.40.70.10:FF:000237', NULL, NULL, 'Acid protease', NULL, NULL, NULL, NULL, NULL, 4),
(161920, NULL, 'G3DSA:3.30.1360.10:FF:000009', NULL, NULL, 'RNA polymerase I and III subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(161921, NULL, 'G3DSA:3.90.1640.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161922, NULL, 'G3DSA:3.30.40.10:FF:002324', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(161923, NULL, 'G3DSA:3.20.20.300:FF:000082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161924, NULL, 'G3DSA:1.20.50.60:FF:000001', NULL, NULL, 'Exocrine gland secreted peptide 6', NULL, NULL, NULL, NULL, NULL, 4),
(161925, NULL, 'G3DSA:1.10.1070.20:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161926, NULL, 'G3DSA:1.25.40.10:FF:004163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161927, NULL, 'G3DSA:1.10.238.10:FF:001025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161928, NULL, 'G3DSA:1.50.10.130:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161929, NULL, 'G3DSA:1.25.40.10:FF:003887', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161930, NULL, 'G3DSA:1.10.510.10:FF:000669', NULL, NULL, 'Tau TuBulin Kinase', NULL, NULL, NULL, NULL, NULL, 4),
(161931, NULL, 'G3DSA:3.40.1280.10:FF:000006', NULL, NULL, 'Uncharacterized tRNA/rRNA methyltransferase HI_0380', NULL, NULL, NULL, NULL, NULL, 4),
(161932, NULL, 'G3DSA:1.20.120.420:FF:000006', NULL, NULL, 'Methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(161933, NULL, 'G3DSA:2.40.30.170:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161934, NULL, 'G3DSA:1.25.10.10:FF:003250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161935, NULL, 'G3DSA:3.30.160.60:FF:004596', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161936, NULL, 'G3DSA:3.30.70.60:FF:000008', NULL, NULL, '28S ribosomal protein S6, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(161937, NULL, 'G3DSA:3.30.230.10:FF:000118', NULL, NULL, 'Lon protease homolog 2, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(161938, NULL, 'G3DSA:2.130.10.10:FF:001600', NULL, NULL, 'WD repeat-containing protein JIP5', NULL, NULL, NULL, NULL, NULL, 4),
(161939, NULL, 'G3DSA:2.30.30.100:FF:000233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161940, NULL, 'G3DSA:2.120.10.80:FF:000374', NULL, NULL, 'Host cell factor-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(161941, NULL, 'G3DSA:3.90.1410.10:FF:000085', NULL, NULL, 'SET domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(161942, NULL, 'G3DSA:1.20.1280.180:FF:000004', NULL, NULL, 'Carnitine palmitoyltransferase family member cpt-2', NULL, NULL, NULL, NULL, NULL, 4),
(161943, NULL, 'G3DSA:1.20.58.1070:FF:000003', NULL, NULL, 'Spliceosomal snRNP component', NULL, NULL, NULL, NULL, NULL, 4),
(161944, NULL, 'G3DSA:2.60.120.830:FF:000001', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 1', NULL, NULL, NULL, NULL, NULL, 4),
(161945, NULL, 'G3DSA:3.30.428.10:FF:000044', NULL, NULL, 'Galactose-1-phosphate uridylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(161946, NULL, 'G3DSA:3.30.160.60:FF:002696', NULL, NULL, 'Brain tumor, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(161947, NULL, 'G3DSA:2.60.110.10:FF:000011', NULL, NULL, 'Thaumatin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(161948, NULL, 'G3DSA:1.20.58.1080:FF:000006', NULL, NULL, 'DExH-box ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(161949, NULL, 'G3DSA:1.20.5.190:FF:000146', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161950, NULL, 'G3DSA:1.20.1280.170:FF:000001', NULL, NULL, 'Exocyst complex component 7', NULL, NULL, NULL, NULL, NULL, 4),
(161951, NULL, 'G3DSA:3.30.750.24:FF:000132', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(161952, NULL, 'G3DSA:3.40.50.300:FF:000488', NULL, NULL, 'Small monomeric GTPase (Gtr1)', NULL, NULL, NULL, NULL, NULL, 4),
(161953, NULL, 'G3DSA:1.10.510.10:FF:002923', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161954, NULL, 'G3DSA:2.40.50.140:FF:000409', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(161955, NULL, 'G3DSA:1.20.1720.10:FF:000013', NULL, NULL, 'Related to multidrug resistance proteins', NULL, NULL, NULL, NULL, NULL, 4),
(161956, NULL, 'G3DSA:1.20.1540.10:FF:000027', NULL, NULL, 'Rhomboid family intramembrane serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(161957, NULL, 'G3DSA:3.40.30.10:FF:000856', NULL, NULL, 'NADH-quinone oxidoreductase, E subunit', NULL, NULL, NULL, NULL, NULL, 4),
(161958, NULL, 'G3DSA:2.60.120.10:FF:000759', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161959, NULL, 'G3DSA:1.20.1060.10:FF:000013', NULL, NULL, 'Mitochondrial DNA polymerase A', NULL, NULL, NULL, NULL, NULL, 4),
(161960, NULL, 'G3DSA:3.80.10.10:FF:000162', NULL, NULL, 'Relaxin family peptide receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(161961, NULL, 'G3DSA:1.20.120.430:FF:000009', NULL, NULL, 'tRNA modification GTPase MnmE', NULL, NULL, NULL, NULL, NULL, 4),
(161962, NULL, 'G3DSA:1.10.238.10:FF:000761', NULL, NULL, 'EF-hand calcium-binding domain 6', NULL, NULL, NULL, NULL, NULL, 4),
(161963, NULL, 'G3DSA:3.40.50.300:FF:006682', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161964, NULL, 'G3DSA:3.30.2300.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161965, NULL, 'G3DSA:3.30.559.10:FF:000134', NULL, NULL, 'Putative carnitine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(161966, NULL, 'G3DSA:3.40.50.720:FF:001687', NULL, NULL, 'YALI0F02211p', NULL, NULL, NULL, NULL, NULL, 4),
(161967, NULL, 'G3DSA:1.25.10.10:FF:002974', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161968, NULL, 'G3DSA:3.10.110.10:FF:000266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161969, NULL, 'G3DSA:3.90.1170.40:FF:000012', NULL, NULL, 'Molybdopterin synthase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(161970, NULL, 'G3DSA:3.80.10.10:FF:001567', NULL, NULL, 'Chitin binding protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(161971, NULL, 'G3DSA:3.40.630.10:FF:000164', NULL, NULL, 'Os01g0740650 protein', NULL, NULL, NULL, NULL, NULL, 4),
(161972, NULL, 'G3DSA:3.30.40.10:FF:000424', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(161973, NULL, 'G3DSA:2.60.40.10:FF:004944', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161974, NULL, 'G3DSA:3.40.390.10:FF:000009', NULL, NULL, 'Oligopeptidase A', NULL, NULL, NULL, NULL, NULL, 4),
(161975, NULL, 'G3DSA:3.90.920.10:FF:000006', NULL, NULL, 'DNA primase small subunit PriS', NULL, NULL, NULL, NULL, NULL, 4),
(161976, NULL, 'G3DSA:3.30.310.80:FF:000022', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(161977, NULL, 'G3DSA:3.10.50.10:FF:000066', NULL, NULL, 'Chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(161978, NULL, 'G3DSA:3.90.1170.50:FF:000015', NULL, NULL, 'Xanthine dehydrogenase/oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(161979, NULL, 'G3DSA:3.10.180.10:FF:000091', NULL, NULL, '4-hydroxyphenylpyruvic acid dioxgenase', NULL, NULL, NULL, NULL, NULL, 4),
(161980, NULL, 'G3DSA:3.40.5.60:FF:000010', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(161981, NULL, 'G3DSA:2.60.40.10:FF:001510', NULL, NULL, 'Jitterbug, isoform M', NULL, NULL, NULL, NULL, NULL, 4),
(161982, NULL, 'G3DSA:1.10.150.60:FF:000010', NULL, NULL, 'PHD transcription factor (Rum1)', NULL, NULL, NULL, NULL, NULL, 4),
(161983, NULL, 'G3DSA:3.20.20.140:FF:000011', NULL, NULL, 'Uronate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(161984, NULL, 'G3DSA:1.20.58.1030:FF:000020', NULL, NULL, 'DNA replication complex GINS protein PSF1', NULL, NULL, NULL, NULL, NULL, 4),
(161985, NULL, 'G3DSA:1.25.40.10:FF:002572', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(161986, NULL, 'G3DSA:2.40.50.140:FF:000741', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161987, NULL, 'G3DSA:3.90.380.10:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161988, NULL, 'G3DSA:3.80.10.10:FF:004214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(161989, NULL, 'G3DSA:3.10.100.10:FF:000338', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161990, NULL, 'G3DSA:2.60.40.420:FF:000010', NULL, NULL, 'Early nodulin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(161991, NULL, 'G3DSA:1.20.120.230:FF:000062', NULL, NULL, 'Probable vinculin', NULL, NULL, NULL, NULL, NULL, 4),
(161992, NULL, 'G3DSA:3.40.50.300:FF:004198', NULL, NULL, 'Secretion related GTPase SrgD (AFU_orthologue AFUA_1G07680)', NULL, NULL, NULL, NULL, NULL, 4),
(161993, NULL, 'G3DSA:1.20.1200.10:FF:000002', NULL, NULL, 'Cob(I)yrinic acid a,c-diamide adenosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(161994, NULL, 'G3DSA:3.30.160.60:FF:005433', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(161995, NULL, 'G3DSA:2.30.29.30:FF:000114', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(161996, NULL, 'G3DSA:3.60.130.10:FF:000025', NULL, NULL, 'Probable gamma-butyrobetaine dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(161997, NULL, 'G3DSA:3.40.50.1820:FF:000442', NULL, NULL, 'Subfamily S9C unassigned peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(161998, NULL, 'G3DSA:3.40.140.10:FF:000177', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit F', NULL, NULL, NULL, NULL, NULL, 4),
(161999, NULL, 'G3DSA:1.10.8.70:FF:000001', NULL, NULL, 'Glutamate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(162000, NULL, 'G3DSA:1.20.5.170:FF:000140', NULL, NULL, 'BZIP transcription factor family', NULL, NULL, NULL, NULL, NULL, 4),
(162001, NULL, 'G3DSA:3.30.1050.10:FF:000008', NULL, NULL, 'N-acetyltransferase Eis', NULL, NULL, NULL, NULL, NULL, 4),
(162002, NULL, 'G3DSA:3.30.1520.10:FF:000106', NULL, NULL, 'Vacuolar protein sorting-associated protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(162003, NULL, 'G3DSA:3.80.10.10:FF:002062', NULL, NULL, 'GH20134p', NULL, NULL, NULL, NULL, NULL, 4),
(162004, NULL, 'G3DSA:3.30.70.560:FF:000015', NULL, NULL, 'Folic acid synthesis protein fol1', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(162005, NULL, 'G3DSA:2.170.130.10:FF:000076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162006, NULL, 'G3DSA:1.20.58.890:FF:000001', NULL, NULL, 'BAG family molecular chaperone regulator 2', NULL, NULL, NULL, NULL, NULL, 4),
(162007, NULL, 'G3DSA:3.30.1140.40:FF:000007', NULL, NULL, 'Dynein light chain Tctex-type', NULL, NULL, NULL, NULL, NULL, 4),
(162008, NULL, 'G3DSA:1.20.58.860:FF:000021', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(162009, NULL, 'G3DSA:2.30.42.10:FF:000650', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162010, NULL, 'G3DSA:3.40.50.150:FF:000971', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162011, NULL, 'G3DSA:1.25.40.180:FF:000212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162012, NULL, 'G3DSA:2.10.110.10:FF:000039', NULL, NULL, 'LIM/homeobox protein Lhx9 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(162013, NULL, 'G3DSA:3.40.47.10:FF:000029', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(162014, NULL, 'G3DSA:1.10.600.10:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162015, NULL, 'G3DSA:3.90.1150.10:FF:000362', NULL, NULL, 'DegT/DnrJ/EryC1/StrS family aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(162016, NULL, 'G3DSA:1.25.40.10:FF:004724', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162017, NULL, 'G3DSA:3.40.50.12780:FF:000115', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(162018, NULL, 'G3DSA:3.10.450.50:FF:000067', NULL, NULL, 'Nuclear transport factor 2 (NTF2) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(162019, NULL, 'G3DSA:1.20.58.60:FF:000451', NULL, NULL, 'Spectrin, beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(162020, NULL, 'G3DSA:1.10.287.10:FF:000031', NULL, NULL, '28S ribosomal protein S15, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(162021, NULL, 'G3DSA:1.50.10.10:FF:000201', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(162022, NULL, 'G3DSA:2.170.120.12:FF:000033', NULL, NULL, 'DNA-directed RNA polymerase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(162023, NULL, 'G3DSA:3.40.50.360:FF:000022', NULL, NULL, 'NADPH azoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(162024, NULL, 'G3DSA:3.20.20.150:FF:000014', NULL, NULL, 'Putative sugar phosphate isomerase/epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(162025, NULL, 'G3DSA:3.10.330.10:FF:000041', NULL, NULL, 'Vesicle-fusing ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(162026, NULL, 'G3DSA:2.30.30.100:FF:000014', NULL, NULL, 'Small nuclear ribonucleoprotein Sm D1', NULL, NULL, NULL, NULL, NULL, 4),
(162027, NULL, 'G3DSA:3.40.50.720:FF:002182', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(162028, NULL, 'G3DSA:3.40.50.1220:FF:000127', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(162029, NULL, 'G3DSA:3.30.230.70:FF:000097', NULL, NULL, 'Exosome non-catalytic core subunit', NULL, NULL, NULL, NULL, NULL, 4),
(162030, NULL, 'G3DSA:1.20.930.10:FF:000024', NULL, NULL, 'GM26494', NULL, NULL, NULL, NULL, NULL, 4),
(162031, NULL, 'G3DSA:3.50.50.100:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162032, NULL, 'G3DSA:2.20.70.10:FF:000064', NULL, NULL, 'rho GTPase-activating protein 9 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(162033, NULL, 'G3DSA:3.40.50.1000:FF:000764', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162034, NULL, 'G3DSA:2.60.40.10:FF:002825', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162035, NULL, 'G3DSA:1.25.40.10:FF:005000', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162036, NULL, 'G3DSA:3.10.20.620:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162037, NULL, 'G3DSA:3.40.50.11610:FF:000006', NULL, NULL, '2-oxoglutarate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(162038, NULL, 'G3DSA:3.10.20.90:FF:000897', NULL, NULL, 'UBX domain-containing protein 10', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(162039, NULL, 'G3DSA:3.30.830.10:FF:000299', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(162040, NULL, 'G3DSA:1.20.90.10:FF:000005', NULL, NULL, 'Secretory phospholipase A2', NULL, NULL, NULL, NULL, NULL, 4),
(162041, NULL, 'G3DSA:2.60.40.720:FF:000004', NULL, NULL, 'runt-related transcription factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(162042, NULL, 'G3DSA:1.25.40.10:FF:002471', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(162043, NULL, 'G3DSA:1.20.58.760:FF:000002', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(162044, NULL, 'G3DSA:2.40.70.10:FF:000557', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162045, NULL, 'G3DSA:3.40.640.10:FF:000333', NULL, NULL, 'Aromatic-amino-acid transaminase, hypothetical (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(162046, NULL, 'G3DSA:1.25.40.10:FF:004595', NULL, NULL, 'Pentatricopeptide repeat domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(162047, NULL, 'G3DSA:1.10.3470.10:FF:000007', NULL, NULL, 'Iron ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(162048, NULL, 'G3DSA:2.60.40.10:FF:004837', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162049, NULL, 'G3DSA:3.40.1000.50:FF:000009', NULL, NULL, 'Unplaced genomic scaffold supercont1.257, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(162050, NULL, 'G3DSA:2.60.40.710:FF:000001', NULL, NULL, 'Endoglucanase 1', NULL, NULL, NULL, NULL, NULL, 4),
(162051, NULL, 'G3DSA:3.40.50.1000:FF:000646', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162052, NULL, 'G3DSA:3.40.1000.30:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162053, NULL, 'G3DSA:3.30.710.10:FF:000245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162054, NULL, 'G3DSA:3.30.200.20:FF:001221', NULL, NULL, 'Cyclin dependent kinase', NULL, NULL, NULL, NULL, NULL, 4),
(162055, NULL, 'G3DSA:2.60.40.420:FF:000009', NULL, NULL, 'Ceruloplasmin', NULL, NULL, NULL, NULL, NULL, 4),
(162056, NULL, 'G3DSA:3.90.810.10:FF:000003', NULL, NULL, 'Neural Wiskott-Aldrich syndrome protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(162057, NULL, 'G3DSA:3.40.50.80:FF:000029', NULL, NULL, 'NADPH oxidase A', NULL, NULL, NULL, NULL, NULL, 4),
(162058, NULL, 'G3DSA:1.20.1270.10:FF:000040', NULL, NULL, 'Heat shock 70 kDa protein BIP5', NULL, NULL, NULL, NULL, NULL, 4),
(162059, NULL, 'G3DSA:3.30.390.150:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162060, NULL, 'G3DSA:2.60.15.10:FF:000024', NULL, NULL, 'ATP synthase epsilon chain, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(162061, NULL, 'G3DSA:3.40.50.720:FF:000501', NULL, NULL, 'Undecaprenyl-phosphate glucose phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(162062, NULL, 'G3DSA:4.10.240.10:FF:000041', NULL, NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(162063, NULL, 'G3DSA:2.60.40.10:FF:000566', NULL, NULL, 'fibronectin type III and SPRY domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(162064, NULL, 'G3DSA:2.120.10.80:FF:000267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162065, NULL, 'G3DSA:3.40.50.460:FF:000041', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(162066, NULL, 'G3DSA:2.20.20.150:FF:000001', NULL, NULL, 'Blast:Protein giant-lens', NULL, NULL, NULL, NULL, NULL, 4),
(162067, NULL, 'G3DSA:3.90.470.10:FF:000033', NULL, NULL, 'Probable 39S ribosomal protein L22, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(162068, NULL, 'G3DSA:2.70.160.11:FF:000007', NULL, NULL, 'Protein arginine N-methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(162069, NULL, 'G3DSA:3.30.420.40:FF:000940', NULL, NULL, 'Actin-like protein arp10', NULL, NULL, NULL, NULL, NULL, 4),
(162070, NULL, 'G3DSA:1.25.40.180:FF:000105', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(162071, NULL, 'G3DSA:3.40.390.10:FF:000004', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(162072, NULL, 'G3DSA:2.30.29.30:FF:000900', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162073, NULL, 'G3DSA:1.10.510.10:FF:000568', NULL, NULL, 'Calmodulin-domain protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(162074, NULL, 'G3DSA:1.10.10.1180:FF:000005', NULL, NULL, 'Inner nuclear membrane protein SRC1', NULL, NULL, NULL, NULL, NULL, 4),
(162075, NULL, 'G3DSA:2.60.40.10:FF:000459', NULL, NULL, 'Intercellular adhesion molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(162076, NULL, 'G3DSA:1.10.238.10:FF:000980', NULL, NULL, 'Calcium-dependent protein kinase 25', NULL, NULL, NULL, NULL, NULL, 4),
(162077, NULL, 'G3DSA:1.25.40.10:FF:004606', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162078, NULL, 'G3DSA:3.10.100.10:FF:000097', NULL, NULL, 'Uninflatable, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(162079, NULL, 'G3DSA:3.90.1150.10:FF:000036', NULL, NULL, '8-amino-7-oxononanoate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(162080, NULL, 'G3DSA:3.40.50.12780:FF:000093', NULL, NULL, 'Probable acyl-activating enzyme 18, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(162081, NULL, 'G3DSA:3.40.50.720:FF:000490', NULL, NULL, 'Dehydrogenase/reductase SDR family member on chromosome X', NULL, NULL, NULL, NULL, NULL, 4),
(162082, NULL, 'G3DSA:3.30.420.40:FF:000833', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162083, NULL, 'G3DSA:3.40.630.170:FF:000001', NULL, NULL, 'Glycylpeptide N-tetradecanoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(162084, NULL, 'G3DSA:3.30.70.330:FF:000519', NULL, NULL, 'heterogeneous nuclear ribonucleoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(162085, NULL, 'G3DSA:2.60.120.260:FF:000257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162086, NULL, 'G3DSA:2.130.10.10:FF:002680', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162087, NULL, 'G3DSA:3.80.10.10:FF:000605', NULL, NULL, 'F-box/LRR-repeat protein 15 isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(162088, NULL, 'G3DSA:3.40.50.1260:FF:000004', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(162089, NULL, 'G3DSA:1.10.510.10:FF:000894', NULL, NULL, 'Serine/threonine-protein kinase srpk2', NULL, NULL, NULL, NULL, NULL, 4),
(162090, NULL, 'G3DSA:3.30.160.60:FF:004377', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162091, NULL, 'G3DSA:3.50.50.60:FF:000742', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(162092, NULL, 'G3DSA:3.90.70.10:FF:000761', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(162093, NULL, 'G3DSA:1.20.1250.20:FF:002065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162094, NULL, 'G3DSA:1.10.730.10:FF:000096', NULL, NULL, 'Arginine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(162095, NULL, 'G3DSA:3.30.1370.10:FF:000162', NULL, NULL, 'KRR1 small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4),
(162096, NULL, 'G3DSA:3.30.70.120:FF:000007', NULL, NULL, 'ATP phosphoribosyltransferase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(162097, NULL, 'G3DSA:3.30.760.10:FF:000080', NULL, NULL, 'Eukaryotic translation initiation factor 4E', NULL, NULL, NULL, NULL, NULL, 4),
(162098, NULL, 'G3DSA:1.10.1450.10:FF:000096', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(162099, NULL, 'G3DSA:1.20.950.20:FF:000028', NULL, NULL, 'Cytochrome b', NULL, NULL, NULL, NULL, NULL, 4),
(162100, NULL, 'G3DSA:3.30.160.60:FF:003073', NULL, NULL, 'GM13855', NULL, NULL, NULL, NULL, NULL, 4),
(162101, NULL, 'G3DSA:1.20.930.10:FF:000030', NULL, NULL, 'Transcription elongation factor TFIIS', NULL, NULL, NULL, NULL, NULL, 4),
(162102, NULL, 'G3DSA:3.40.50.300:FF:000836', NULL, NULL, 'ABC transporter B family member 25', NULL, NULL, NULL, NULL, NULL, 4),
(162103, NULL, 'G3DSA:3.30.497.10:FF:000029', NULL, NULL, 'Serpin family B member 12', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(162104, NULL, 'G3DSA:3.90.1150.10:FF:000143', NULL, NULL, 'Glycine cleavage system P protein', NULL, NULL, NULL, NULL, NULL, 4),
(162105, NULL, 'G3DSA:1.20.272.10:FF:000079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162106, NULL, 'G3DSA:3.30.559.10:FF:000016', NULL, NULL, 'Nonribosomal peptide synthase Pes1', NULL, NULL, NULL, NULL, NULL, 4),
(162107, NULL, 'G3DSA:1.10.287.70:FF:000032', NULL, NULL, 'Voltage-dependent T-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(162108, NULL, 'G3DSA:2.10.25.10:FF:001814', NULL, NULL, 'Keratin-associated protein 5-8, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162109, NULL, 'G3DSA:2.130.10.10:FF:004815', NULL, NULL, 'Uncharacterized WD repeat-containing protein C17D11.16', NULL, NULL, NULL, NULL, NULL, 4),
(162110, NULL, 'G3DSA:3.30.230.10:FF:000096', NULL, NULL, 'Homoserine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(162111, NULL, 'G3DSA:3.60.10.10:FF:000090', NULL, NULL, 'Actin', NULL, NULL, NULL, NULL, NULL, 4),
(162112, NULL, 'G3DSA:3.90.550.10:FF:000764', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(162113, NULL, 'G3DSA:3.30.160.60:FF:005001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162114, NULL, 'G3DSA:3.40.50.150:FF:000870', NULL, NULL, 'tRNA/rRNA cytosine-C5-methylase, NOL1/NOP2/Sun family', NULL, NULL, NULL, NULL, NULL, 4),
(162115, NULL, 'G3DSA:3.90.980.10:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162116, NULL, 'G3DSA:2.60.210.10:FF:000064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162117, NULL, 'G3DSA:3.30.200.20:FF:002418', NULL, NULL, 'Protein lin-2', NULL, NULL, NULL, NULL, NULL, 4),
(162118, NULL, 'G3DSA:3.30.70.270:FF:000024', NULL, NULL, 'Predicted diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(162119, NULL, 'G3DSA:2.130.10.10:FF:004708', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162120, NULL, 'G3DSA:1.20.1250.20:FF:002172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162121, NULL, 'G3DSA:1.20.1070.10:FF:002071', NULL, NULL, 'Retinal G protein coupled receptor', NULL, NULL, NULL, NULL, NULL, 4),
(162122, NULL, 'G3DSA:3.10.129.10:FF:000073', NULL, NULL, 'Putative acyl-ACP thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(162123, NULL, 'G3DSA:1.25.10.10:FF:000496', NULL, NULL, 'Cell proliferation regulating inhibitor of protein phosphatase 2A', NULL, NULL, NULL, NULL, NULL, 4),
(162124, NULL, 'G3DSA:3.30.70.260:FF:000021', NULL, NULL, 'Formyltetrahydrofolate deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(162125, NULL, 'G3DSA:1.10.472.10:FF:000675', NULL, NULL, 'Cyclin D2, a', NULL, NULL, NULL, NULL, NULL, 4),
(162126, NULL, 'G3DSA:3.50.50.60:FF:000523', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(162127, NULL, 'G3DSA:1.10.510.10:FF:003423', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162128, NULL, 'G3DSA:3.10.20.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162129, NULL, 'G3DSA:3.30.160.60:FF:000908', NULL, NULL, 'Zinc finger and BTB domain containing 41', NULL, NULL, NULL, NULL, NULL, 4),
(162130, NULL, 'G3DSA:1.10.150.130:FF:000012', NULL, NULL, 'Tyrosine recombinase XerC', NULL, NULL, NULL, NULL, NULL, 4),
(162131, NULL, 'G3DSA:3.60.150.10:FF:000015', NULL, NULL, 'Chorismate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(162132, NULL, 'G3DSA:3.40.50.300:FF:005041', NULL, NULL, 'Guanylate-binding protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(162133, NULL, 'G3DSA:2.60.40.10:FF:003421', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162134, NULL, 'G3DSA:3.30.70.660:FF:000034', NULL, NULL, 'Similar to pseudouridylate synthase 3', NULL, NULL, NULL, NULL, NULL, 4),
(162135, NULL, 'G3DSA:3.50.50.60:FF:000063', NULL, NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', NULL, NULL, NULL, NULL, NULL, 4),
(162136, NULL, 'G3DSA:1.25.40.20:FF:001170', NULL, NULL, 'Ankyrin repeat and SOCS box-containing 2b', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(162137, NULL, 'G3DSA:1.20.5.420:FF:000018', NULL, NULL, 'Ribonuclease P protein component 4', NULL, NULL, NULL, NULL, NULL, 4),
(162138, NULL, 'G3DSA:3.30.200.20:FF:000513', NULL, NULL, 'Receptor-like protein kinase HSL1', NULL, NULL, NULL, NULL, NULL, 4),
(162139, NULL, 'G3DSA:3.80.10.10:FF:004091', NULL, NULL, 'Roco6, ROCO family protein', NULL, NULL, NULL, NULL, NULL, 4),
(162140, NULL, 'G3DSA:3.40.50.150:FF:001252', NULL, NULL, 'tRNA (cytosine(48)-C(5))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(162141, NULL, 'G3DSA:3.30.70.100:FF:000001', NULL, NULL, 'ATPase copper transporting beta', NULL, NULL, NULL, NULL, NULL, 4),
(162142, NULL, 'G3DSA:3.30.200.20:FF:001114', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(162143, NULL, 'G3DSA:3.40.50.10260:FF:000017', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(162144, NULL, 'G3DSA:1.10.150.240:FF:000045', NULL, NULL, 'CBBY-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(162145, NULL, 'G3DSA:3.30.200.20:FF:000283', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 8', NULL, NULL, NULL, NULL, NULL, 4),
(162146, NULL, 'G3DSA:1.25.10.10:FF:002862', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(162147, NULL, 'G3DSA:3.30.200.20:FF:001002', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(162148, NULL, 'G3DSA:3.10.290.10:FF:000099', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(162149, NULL, 'G3DSA:3.30.70.360:FF:000051', NULL, NULL, 'Peptidase T', NULL, NULL, NULL, NULL, NULL, 4),
(162150, NULL, 'G3DSA:3.30.70.1390:FF:000001', NULL, NULL, 'Leucine-rich repeat serine/threonine-protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(162151, NULL, 'G3DSA:3.30.1010.10:FF:000129', NULL, NULL, 'Putative actin-fragmin kinase DDB_G0279609', NULL, NULL, NULL, NULL, NULL, 4),
(162152, NULL, 'G3DSA:3.30.40.10:FF:002094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162153, NULL, 'G3DSA:1.25.10.10:FF:000726', NULL, NULL, 'Deoxyhypusine hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(162154, NULL, 'G3DSA:3.40.50.1820:FF:000543', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162155, NULL, 'G3DSA:2.30.30.40:FF:000536', NULL, NULL, 'F-BAR and double SH3 domains protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(162156, NULL, 'G3DSA:3.40.50.620:FF:000022', NULL, NULL, 'Argininosuccinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(162157, NULL, 'G3DSA:2.30.30.40:FF:000648', NULL, NULL, 'Tyrosine-protein kinase sid-3', NULL, NULL, NULL, NULL, NULL, 4),
(162158, NULL, 'G3DSA:2.60.420.10:FF:000001', NULL, NULL, 'Family 65 glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(162159, NULL, 'G3DSA:3.30.1250.10:FF:000001', NULL, NULL, 'SBDS, ribosome maturation factor', NULL, NULL, NULL, NULL, NULL, 4),
(162160, NULL, 'G3DSA:1.10.10.10:FF:000439', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(162161, NULL, 'G3DSA:3.15.10.30:FF:000003', NULL, NULL, 'GL26316', NULL, NULL, NULL, NULL, NULL, 4),
(162162, NULL, 'G3DSA:3.90.20.20:FF:000007', NULL, NULL, 'Protein GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(162163, NULL, 'G3DSA:3.90.226.10:FF:000275', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(162164, NULL, 'G3DSA:3.40.50.1000:FF:000539', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162165, NULL, 'G3DSA:4.10.60.10:FF:000188', NULL, NULL, 'Cold shock domain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(162166, NULL, 'G3DSA:3.10.350.10:FF:000031', NULL, NULL, 'Murein DD-endopeptidase MepM/ murein hydrolase activator NlpD', NULL, NULL, NULL, NULL, NULL, 4),
(162167, NULL, 'G3DSA:1.20.1080.10:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162168, NULL, 'G3DSA:1.10.12.70:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162169, NULL, 'G3DSA:3.30.160.60:FF:004489', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(162170, NULL, 'G3DSA:2.40.70.10:FF:000338', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162171, NULL, 'G3DSA:3.40.228.10:FF:000009', NULL, NULL, 'Formate dehydrogenase, alpha subunit, selenocysteine-containing', NULL, NULL, NULL, NULL, NULL, 4),
(162172, NULL, 'G3DSA:2.60.40.10:FF:002932', NULL, NULL, 'Connectin', NULL, NULL, NULL, NULL, NULL, 4),
(162173, NULL, 'G3DSA:3.20.110.10:FF:000005', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(162174, NULL, 'G3DSA:2.60.40.10:FF:004618', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162175, NULL, 'G3DSA:1.25.40.530:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162176, NULL, 'G3DSA:1.25.40.540:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162177, NULL, 'G3DSA:3.30.40.10:FF:002105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162178, NULL, 'G3DSA:3.30.160.60:FF:005113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162179, NULL, 'G3DSA:1.10.510.10:FF:000782', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(162180, NULL, 'G3DSA:3.90.1150.10:FF:000255', NULL, NULL, 'ATLCB1', NULL, NULL, NULL, NULL, NULL, 4),
(162181, NULL, 'G3DSA:1.25.10.10:FF:002750', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(162182, NULL, 'G3DSA:3.30.2350.20:FF:000063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162183, NULL, 'G3DSA:3.40.50.300:FF:003354', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(162184, NULL, 'G3DSA:1.20.1530.20:FF:000086', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(162185, NULL, 'G3DSA:3.30.2350.10:FF:000060', NULL, NULL, 'Trans-splicing factor Raa2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(162186, NULL, 'G3DSA:1.10.10.10:FF:000658', NULL, NULL, 'COP9 signalosome complex subunit 4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162187, NULL, 'G3DSA:2.130.10.10:FF:004585', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162188, NULL, 'G3DSA:3.40.50.620:FF:000241', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(162189, NULL, 'G3DSA:2.10.50.30:FF:000029', NULL, NULL, 'Metabotropic glutamate receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(162190, NULL, 'G3DSA:3.40.50.300:FF:008481', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162191, NULL, 'G3DSA:3.90.79.10:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162192, NULL, 'G3DSA:3.90.550.10:FF:000545', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(162193, NULL, 'G3DSA:2.170.300.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162194, NULL, 'G3DSA:2.40.100.10:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162195, NULL, 'G3DSA:3.40.50.300:FF:004984', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162196, NULL, 'G3DSA:2.60.40.10:FF:003207', NULL, NULL, 'Inducible T cell costimulator', NULL, NULL, NULL, NULL, NULL, 4),
(162197, NULL, 'G3DSA:1.10.274.100:FF:000015', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(162198, NULL, 'G3DSA:3.40.50.2300:FF:000154', NULL, NULL, 'Stage 0 sporulation protein A', NULL, NULL, NULL, NULL, NULL, 4),
(162199, NULL, 'G3DSA:2.40.50.140:FF:000168', NULL, NULL, '26S protease regulatory subunit 10B', NULL, NULL, NULL, NULL, NULL, 4),
(162200, NULL, 'G3DSA:2.30.42.10:FF:000077', NULL, NULL, 'Periplasmic serine peptidase DegS', NULL, NULL, NULL, NULL, NULL, 4),
(162201, NULL, 'G3DSA:1.10.1030.10:FF:000002', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(162202, NULL, 'G3DSA:3.40.50.10240:FF:000011', NULL, NULL, 'Thiamin pyrophosphokinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(162203, NULL, 'G3DSA:3.30.420.100:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(162204, NULL, 'G3DSA:1.20.120.1750:FF:000064', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(162205, NULL, 'G3DSA:1.20.1070.10:FF:002183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162206, NULL, 'G3DSA:1.25.10.10:FF:001120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162207, NULL, 'G3DSA:3.30.70.1350:FF:000017', NULL, NULL, 'Related to cation diffusion facilitator 10', NULL, NULL, NULL, NULL, NULL, 4),
(162208, NULL, 'G3DSA:1.25.40.10:FF:004269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162209, NULL, 'G3DSA:3.40.190.290:FF:000065', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(162210, NULL, 'G3DSA:2.30.30.40:FF:000643', NULL, NULL, 'Protein vav-1', NULL, NULL, NULL, NULL, NULL, 4),
(162211, NULL, 'G3DSA:2.30.30.100:FF:000019', NULL, NULL, 'Small nuclear ribonucleoprotein G', NULL, NULL, NULL, NULL, NULL, 4),
(162212, NULL, 'G3DSA:3.40.50.10810:FF:000227', NULL, NULL, 'ERCC excision repair 6, chromatin remodeling factor', NULL, NULL, NULL, NULL, NULL, 4),
(162213, NULL, 'G3DSA:3.10.350.10:FF:000036', NULL, NULL, 'Membrane-bound lytic murein transglycosylase D', NULL, NULL, NULL, NULL, NULL, 4),
(162214, NULL, 'G3DSA:3.90.1150.10:FF:000148', NULL, NULL, 'Perosamine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(162215, NULL, 'G3DSA:2.60.120.260:FF:000476', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162216, NULL, 'G3DSA:1.25.40.10:FF:002919', NULL, NULL, 'Os09g0412900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(162217, NULL, 'G3DSA:1.10.10.60:FF:000319', NULL, NULL, 'Mushroom body large-type Kenyon cell-specific protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(162218, NULL, 'G3DSA:2.20.70.10:FF:000165', NULL, NULL, 'Yes-associated protein homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(162219, NULL, 'G3DSA:3.40.525.10:FF:000026', NULL, NULL, 'ECM25p protein', NULL, NULL, NULL, NULL, NULL, 4),
(162220, NULL, 'G3DSA:2.130.10.10:FF:006058', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', NULL, NULL, NULL, NULL, NULL, 4),
(162221, NULL, 'G3DSA:3.30.465.10:FF:000017', NULL, NULL, 'Xanthine dehydrogenase, FAD binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(162222, NULL, 'G3DSA:2.60.40.10:FF:000678', NULL, NULL, 'Down syndrome cell adhesion molecule-like protein Dscam2', NULL, NULL, NULL, NULL, NULL, 4),
(162223, NULL, 'G3DSA:3.40.50.300:FF:006457', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162224, NULL, 'G3DSA:1.25.40.10:FF:004825', NULL, NULL, 'Putative pentatricopeptide repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(162225, NULL, 'G3DSA:3.60.10.10:FF:000213', NULL, NULL, 'Type I inositol polyphosphate 5-phosphatase 10', NULL, NULL, NULL, NULL, NULL, 4),
(162226, NULL, 'G3DSA:3.20.20.100:FF:000027', NULL, NULL, 'Aldo/keto reductase', NULL, NULL, NULL, NULL, NULL, 4),
(162227, NULL, 'G3DSA:1.25.40.10:FF:004483', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162228, NULL, 'G3DSA:1.25.40.990:FF:000028', NULL, NULL, 'GM24516', NULL, NULL, NULL, NULL, NULL, 4),
(162229, NULL, 'G3DSA:2.40.50.40:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162230, NULL, 'G3DSA:2.40.50.770:FF:000019', NULL, NULL, 'RecQ-mediated genome instability protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(162231, NULL, 'G3DSA:3.30.559.10:FF:000235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162232, NULL, 'G3DSA:3.40.390.10:FF:000116', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(162233, NULL, 'G3DSA:3.50.4.10:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162234, NULL, 'G3DSA:2.10.25.10:FF:001691', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162235, NULL, 'G3DSA:1.10.10.10:FF:000546', NULL, NULL, 'Two-component response regulator GraR', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(162236, NULL, 'G3DSA:3.30.300.130:FF:000013', NULL, NULL, 'NifU-like scaffold protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162237, NULL, 'G3DSA:3.40.50.1220:FF:000021', NULL, NULL, 'IlvB (bacterial acetolactate synthase)-like', NULL, NULL, NULL, NULL, NULL, 4),
(162238, NULL, 'G3DSA:2.160.20.10:FF:000228', NULL, NULL, 'SHC SH2 domain-binding protein 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(162239, NULL, 'G3DSA:3.40.50.720:FF:000613', NULL, NULL, 'Ubiquitin-activating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(162240, NULL, 'G3DSA:3.10.20.370:FF:000003', NULL, NULL, 'Transposon Tf2-6 polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(162241, NULL, 'G3DSA:3.30.310.50:FF:000047', NULL, NULL, 'KEOPS complex subunit Pcc1', NULL, NULL, NULL, NULL, NULL, 4),
(162242, NULL, 'G3DSA:3.40.50.150:FF:001033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162243, NULL, 'G3DSA:1.10.940.10:FF:000033', NULL, NULL, 'Transcription antitermination protein NusB', NULL, NULL, NULL, NULL, NULL, 4),
(162244, NULL, 'G3DSA:2.120.10.80:FF:000379', NULL, NULL, 'AGAP009495-PA', NULL, NULL, NULL, NULL, NULL, 4),
(162245, NULL, 'G3DSA:3.30.1330.60:FF:000039', NULL, NULL, 'OmpA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(162246, NULL, 'G3DSA:2.10.25.10:FF:001584', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162247, NULL, 'G3DSA:1.10.150.20:FF:000133', NULL, NULL, 'DNA repair protein RAD51 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(162248, NULL, 'G3DSA:2.130.10.10:FF:004259', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(162249, NULL, 'G3DSA:3.30.1330.40:FF:000033', NULL, NULL, 'ATP-binding region containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162250, NULL, 'G3DSA:3.40.50.150:FF:001701', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162251, NULL, 'G3DSA:3.80.10.10:FF:004102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162252, NULL, 'G3DSA:4.10.60.10:FF:000183', NULL, NULL, 'Serine/arginine-rich splicing factor RSZ21', NULL, NULL, NULL, NULL, NULL, 4),
(162253, NULL, 'G3DSA:1.10.510.10:FF:003204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162254, NULL, 'G3DSA:2.130.10.10:FF:003511', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(162255, NULL, 'G3DSA:3.30.950.10:FF:000010', NULL, NULL, 'Uroporphyrin-III C-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(162256, NULL, 'G3DSA:3.80.10.10:FF:003478', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(162257, NULL, 'G3DSA:1.10.472.10:FF:000456', NULL, NULL, 'Origin recognition complex subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(162258, NULL, 'G3DSA:1.10.4160.10:FF:000023', NULL, NULL, 'Allantoin permease', NULL, NULL, NULL, NULL, NULL, 4),
(162259, NULL, 'G3DSA:3.40.190.10:FF:000567', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(162260, NULL, 'G3DSA:3.30.710.10:FF:000026', NULL, NULL, 'E3 ubiquitin ligase complex SCF subunit', NULL, NULL, NULL, NULL, NULL, 4),
(162261, NULL, 'G3DSA:2.120.10.30:FF:000281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162262, NULL, 'G3DSA:1.10.8.270:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162263, NULL, 'G3DSA:1.25.40.10:FF:000902', NULL, NULL, 'Testis expressed 11', NULL, NULL, NULL, NULL, NULL, 4),
(162264, NULL, 'G3DSA:3.30.160.60:FF:000785', NULL, NULL, 'zinc finger protein 648', NULL, NULL, NULL, NULL, NULL, 4),
(162265, NULL, 'G3DSA:3.30.60.20:FF:000075', NULL, NULL, 'Rho-associated protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(162266, NULL, 'G3DSA:3.40.50.12780:FF:000216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162267, NULL, 'G3DSA:3.80.10.10:FF:003826', NULL, NULL, 'SYM-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(162268, NULL, 'G3DSA:3.40.50.1820:FF:000324', NULL, NULL, 'Homoserine O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(162269, NULL, 'G3DSA:3.40.50.720:FF:000271', NULL, NULL, 'oxidoreductase HTATIP2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(162270, NULL, 'G3DSA:3.90.1590.10:FF:000001', NULL, NULL, 'Putative DUF636 domain protein (AFU_orthologue AFUA_2G15290)', NULL, NULL, NULL, NULL, NULL, 4),
(162271, NULL, 'G3DSA:1.25.40.10:FF:003302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162272, NULL, 'G3DSA:3.40.140.10:FF:000289', NULL, NULL, 'STAM binding protein like 1', NULL, NULL, NULL, NULL, NULL, 4),
(162273, NULL, 'G3DSA:3.40.50.720:FF:001794', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(162274, NULL, 'G3DSA:3.40.50.1000:FF:000865', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162275, NULL, 'G3DSA:2.60.40.60:FF:001047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162276, NULL, 'G3DSA:1.20.1250.20:FF:000603', NULL, NULL, 'Acetyl-coenzyme A transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(162277, NULL, 'G3DSA:3.40.390.10:FF:000223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162278, NULL, 'G3DSA:3.40.50.2000:FF:000159', NULL, NULL, 'Glycosyltransferase, group 1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(162279, NULL, 'G3DSA:2.10.10.10:FF:000021', NULL, NULL, 'HGF activator', NULL, NULL, NULL, NULL, NULL, 4),
(162280, NULL, 'G3DSA:3.30.1640.10:FF:000048', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(162281, NULL, 'G3DSA:3.60.15.10:FF:000191', NULL, NULL, 'Prostate cancer susceptibility protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(162282, NULL, 'G3DSA:1.10.287.130:FF:000112', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(162283, NULL, 'G3DSA:2.40.10.10:FF:000565', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162284, NULL, 'G3DSA:3.40.50.2300:FF:000373', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(162285, NULL, 'G3DSA:3.40.850.10:FF:000247', NULL, NULL, 'Kinesin family member 4A', NULL, NULL, NULL, NULL, NULL, 4),
(162286, NULL, 'G3DSA:2.60.40.10:FF:000785', NULL, NULL, 'Myosin light chain kinase, smooth muscle', NULL, NULL, NULL, NULL, NULL, 4),
(162287, NULL, 'G3DSA:3.80.10.10:FF:002174', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(162288, NULL, 'G3DSA:2.30.40.10:FF:000022', NULL, NULL, 'Dihydropyrimidinase-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(162289, NULL, 'G3DSA:3.40.50.720:FF:002070', NULL, NULL, 'Dihydroflavonol-4-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(162290, NULL, 'G3DSA:3.40.50.300:FF:000729', NULL, NULL, 'ATP-binding cassette, sub-family A (ABC1), member 5', NULL, NULL, NULL, NULL, NULL, 4),
(162291, NULL, 'G3DSA:3.90.1150.10:FF:000474', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162292, NULL, 'G3DSA:3.40.50.300:FF:001218', NULL, NULL, 'AAA family ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162293, NULL, 'G3DSA:3.40.50.300:FF:003910', NULL, NULL, 'Adenylate kinase isoenzyme 6 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(162294, NULL, 'G3DSA:1.25.40.90:FF:000072', NULL, NULL, 'ANTH domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(162295, NULL, 'G3DSA:1.20.5.170:FF:000241', NULL, NULL, 'transcription factor protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(162296, NULL, 'G3DSA:3.30.160.60:FF:005332', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162297, NULL, 'G3DSA:3.30.160.60:FF:002691', NULL, NULL, 'Blast:Zinc finger protein 425', NULL, NULL, NULL, NULL, NULL, 4),
(162298, NULL, 'G3DSA:1.25.40.10:FF:000554', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g41720', NULL, NULL, NULL, NULL, NULL, 4),
(162299, NULL, 'G3DSA:2.30.30.100:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162300, NULL, 'G3DSA:1.20.1250.20:FF:001683', NULL, NULL, 'Siderophore iron transporter 3', NULL, NULL, NULL, NULL, NULL, 4),
(162301, NULL, 'G3DSA:3.30.160.60:FF:006294', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162302, NULL, 'G3DSA:1.20.5.710:FF:000010', NULL, NULL, '50S ribosomal protein L7/L12', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(162303, NULL, 'G3DSA:3.40.1280.10:FF:000113', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(162304, NULL, 'G3DSA:2.60.40.10:FF:003202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162305, NULL, 'G3DSA:1.10.10.10:FF:000984', NULL, NULL, 'U5 small nuclear ribonucleoprotein helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162306, NULL, 'G3DSA:3.40.50.300:FF:005153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162307, NULL, 'G3DSA:3.30.1340.10:FF:000008', NULL, NULL, 'Phosphocarrier protein NPr', NULL, NULL, NULL, NULL, NULL, 4),
(162308, NULL, 'G3DSA:3.30.497.10:FF:000136', NULL, NULL, 'Serpin 2 precursor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162309, NULL, 'G3DSA:2.40.10.10:FF:000458', NULL, NULL, 'Probable trypsin-like serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(162310, NULL, 'G3DSA:2.30.29.30:FF:000451', NULL, NULL, 'Pez, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(162311, NULL, 'G3DSA:2.60.120.260:FF:000038', NULL, NULL, 'BTB/POZ domain-containing protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(162312, NULL, 'G3DSA:1.10.260.40:FF:000001', NULL, NULL, 'POU domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(162313, NULL, 'G3DSA:2.130.10.10:FF:004478', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162314, NULL, 'G3DSA:3.40.50.20:FF:000040', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(162315, NULL, 'G3DSA:3.30.70.330:FF:001020', NULL, NULL, 'Unplaced genomic scaffold supercont1.57, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(162316, NULL, 'G3DSA:3.50.7.10:FF:000078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162317, NULL, 'G3DSA:3.40.50.300:FF:004877', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162318, NULL, 'G3DSA:1.10.510.10:FF:003311', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162319, NULL, 'G3DSA:2.120.10.30:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162320, NULL, 'G3DSA:2.10.25.10:FF:001707', NULL, NULL, 'Protein CBR-STR-90', NULL, NULL, NULL, NULL, NULL, 4),
(162321, NULL, 'G3DSA:3.20.20.450:FF:000008', NULL, NULL, 'Cyclic di-GMP phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(162322, NULL, 'G3DSA:1.20.1070.10:FF:000614', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162323, NULL, 'G3DSA:3.60.130.10:FF:000020', NULL, NULL, 'GG15479', NULL, NULL, NULL, NULL, NULL, 4),
(162324, NULL, 'G3DSA:1.10.640.10:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162325, NULL, 'G3DSA:3.30.70.330:FF:000396', NULL, NULL, 'Putative Pre-mRNA-splicing factor slt11', NULL, NULL, NULL, NULL, NULL, 4),
(162326, NULL, 'G3DSA:3.30.200.20:FF:002295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162327, NULL, 'G3DSA:1.10.10.60:FF:001027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162328, NULL, 'G3DSA:3.40.720.10:FF:000030', NULL, NULL, 'Phosphoethanolamine transferase eptB', NULL, NULL, NULL, NULL, NULL, 4),
(162329, NULL, 'G3DSA:3.40.47.10:FF:000147', NULL, NULL, 'Polyketide synthase type I', NULL, NULL, NULL, NULL, NULL, 4),
(162330, NULL, 'G3DSA:1.10.357.50:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162331, NULL, 'G3DSA:3.40.50.300:FF:006564', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162332, NULL, 'G3DSA:3.40.50.2000:FF:000507', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(162333, NULL, 'G3DSA:1.20.1740.10:FF:000020', NULL, NULL, 'Putative cadaverine/lysine antiporter CadB', NULL, NULL, NULL, NULL, NULL, 4),
(162334, NULL, 'G3DSA:3.30.519.10:FF:000019', NULL, NULL, 'Rab proteins geranylgeranyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(162335, NULL, 'G3DSA:3.10.110.10:FF:000378', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(162336, NULL, 'G3DSA:3.40.50.720:FF:001575', NULL, NULL, 'Acetoacetyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(162337, NULL, 'G3DSA:1.25.10.10:FF:003132', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(162338, NULL, 'G3DSA:3.30.450.20:FF:000317', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(162339, NULL, 'G3DSA:3.90.940.10:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162340, NULL, 'G3DSA:1.10.220.150:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162341, NULL, 'G3DSA:2.10.25.10:FF:001365', NULL, NULL, 'Coagulation factor X', NULL, NULL, NULL, NULL, NULL, 4),
(162342, NULL, 'G3DSA:3.30.40.10:FF:000312', NULL, NULL, 'Zinc finger, FYVE-type, endofin', NULL, NULL, NULL, NULL, NULL, 4),
(162343, NULL, 'G3DSA:1.20.120.1240:FF:000017', NULL, NULL, 'Dynamin-2A', NULL, NULL, NULL, NULL, NULL, 4),
(162344, NULL, 'G3DSA:2.10.50.30:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162345, NULL, 'G3DSA:3.30.260.10:FF:000047', NULL, NULL, 'Bardet-Biedl syndrome 10 protein', NULL, NULL, NULL, NULL, NULL, 4),
(162346, NULL, 'G3DSA:3.40.50.300:FF:004658', NULL, NULL, 'Guanylate kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(162347, NULL, 'G3DSA:3.30.1370.10:FF:000055', NULL, NULL, 'protein quaking isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(162348, NULL, 'G3DSA:3.40.50.300:FF:006783', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162349, NULL, 'G3DSA:3.80.10.10:FF:002522', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162350, NULL, 'G3DSA:2.60.220.50:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162351, NULL, 'G3DSA:1.10.510.10:FF:000787', NULL, NULL, 'NEK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(162352, NULL, 'G3DSA:1.25.10.10:FF:002643', NULL, NULL, 'Armadillo repeat-containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(162353, NULL, 'G3DSA:1.20.1280.290:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162354, NULL, 'G3DSA:2.30.30.1190:FF:000014', NULL, NULL, 'Zinc finger C-x8-C-x5-C-x3-H type family protein', NULL, NULL, NULL, NULL, NULL, 4),
(162355, NULL, 'G3DSA:3.60.21.70:FF:000003', NULL, NULL, 'WW domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(162356, NULL, 'G3DSA:3.30.450.190:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162357, NULL, 'G3DSA:1.10.10.60:FF:000196', NULL, NULL, 'Multiple antibiotic resistance protein MarA', NULL, NULL, NULL, NULL, NULL, 4),
(162358, NULL, 'G3DSA:2.40.160.50:FF:000036', NULL, NULL, 'Hemolysin activator protein', NULL, NULL, NULL, NULL, NULL, 4),
(162359, NULL, 'G3DSA:3.30.1490.130:FF:000001', NULL, NULL, 'N-acyl-D-amino acid deacylase protein', NULL, NULL, NULL, NULL, NULL, 4),
(162360, NULL, 'G3DSA:2.30.42.10:FF:000532', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162361, NULL, 'G3DSA:3.60.110.10:FF:000018', NULL, NULL, 'Protein N-terminal asparagine amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(162362, NULL, 'G3DSA:3.30.470.20:FF:000212', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(162363, NULL, 'G3DSA:1.20.120.20:FF:000016', NULL, NULL, 'Plant Late Embryo Abundant (LEA) related', NULL, NULL, NULL, NULL, NULL, 4),
(162364, NULL, 'G3DSA:1.25.40.820:FF:000005', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(162365, NULL, 'G3DSA:1.10.10.60:FF:000538', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(162366, NULL, 'G3DSA:3.40.50.300:FF:000948', NULL, NULL, 'Thymidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(162367, NULL, 'G3DSA:1.25.10.10:FF:002295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162368, NULL, 'G3DSA:2.130.10.10:FF:002803', NULL, NULL, 'WD repeat domain 5', NULL, NULL, NULL, NULL, NULL, 4),
(162369, NULL, 'G3DSA:3.40.50.10810:FF:000098', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(162370, NULL, 'G3DSA:1.10.1370.10:FF:000044', NULL, NULL, 'Mitochondrial intermediate peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(162371, NULL, 'G3DSA:3.30.230.70:FF:000108', NULL, NULL, 'EXOSome (Multiexonuclease complex) component', NULL, NULL, NULL, NULL, NULL, 4),
(162372, NULL, 'G3DSA:2.130.10.10:FF:001038', NULL, NULL, 'WD repeat domain 70', NULL, NULL, NULL, NULL, NULL, 4),
(162373, NULL, 'G3DSA:1.20.5.170:FF:000022', NULL, NULL, 'Tripartite motif containing 55', NULL, NULL, NULL, NULL, NULL, 4),
(162374, NULL, 'G3DSA:3.20.20.80:FF:000028', NULL, NULL, 'Chitinase domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(162375, NULL, 'G3DSA:2.60.40.3180:FF:000003', NULL, NULL, 'Knot, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(162376, NULL, 'G3DSA:3.40.50.300:FF:001437', NULL, NULL, 'Plasmid partition protein A', NULL, NULL, NULL, NULL, NULL, 4),
(162377, NULL, 'G3DSA:1.20.1720.10:FF:000131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162378, NULL, 'G3DSA:2.130.10.10:FF:000549', NULL, NULL, 'Small nucleolar ribonucleoprotein complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(162379, NULL, 'G3DSA:2.130.10.10:FF:005889', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162380, NULL, 'G3DSA:3.50.50.60:FF:000068', NULL, NULL, 'Glutamate synthase small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(162381, NULL, 'G3DSA:2.70.170.10:FF:000294', NULL, NULL, 'Cholinergic receptor, nicotinic, alpha 6', NULL, NULL, NULL, NULL, NULL, 4),
(162382, NULL, 'G3DSA:3.40.50.720:FF:002406', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162383, NULL, 'G3DSA:2.60.120.40:FF:000066', NULL, NULL, 'Elastin microfibril interfacer 1', NULL, NULL, NULL, NULL, NULL, 4),
(162384, NULL, 'G3DSA:3.40.50.1820:FF:000105', NULL, NULL, 'Fatty acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(162385, NULL, 'G3DSA:3.30.1680.10:FF:000039', NULL, NULL, 'Semaphorin 4B', NULL, NULL, NULL, NULL, NULL, 4),
(162386, NULL, 'G3DSA:1.10.490.10:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162387, NULL, 'G3DSA:3.40.850.10:FF:000028', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(162388, NULL, 'G3DSA:1.10.10.10:FF:000765', NULL, NULL, 'Transcriptional regulator HrpG', NULL, NULL, NULL, NULL, NULL, 4),
(162389, NULL, 'G3DSA:3.40.50.300:FF:001095', NULL, NULL, 'Intraflagellar transport protein 27 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(162390, NULL, 'G3DSA:1.10.510.10:FF:003530', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162391, NULL, 'G3DSA:1.20.120.160:FF:000012', NULL, NULL, 'Phosphorelay protein LuxU', NULL, NULL, NULL, NULL, NULL, 4),
(162392, NULL, 'G3DSA:3.80.10.10:FF:003259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162393, NULL, 'G3DSA:3.30.200.20:FF:002082', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162394, NULL, 'G3DSA:3.10.310.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162395, NULL, 'G3DSA:1.10.10.10:FF:001041', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(162396, NULL, 'G3DSA:3.30.9.10:FF:000110', NULL, NULL, 'tRNA 5-methylaminomethyl-2-thiouridine biosynthesis bifunctional protein MnmC', NULL, NULL, NULL, NULL, NULL, 4),
(162397, NULL, 'G3DSA:1.10.1820.10:FF:000017', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(162398, NULL, 'G3DSA:3.40.50.300:FF:006912', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162399, NULL, 'G3DSA:1.25.40.10:FF:002690', NULL, NULL, 'Coatomer subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(162400, NULL, 'G3DSA:3.40.50.720:FF:001917', NULL, NULL, 'SUMO1 activating enzyme subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(162401, NULL, 'G3DSA:2.60.40.150:FF:000822', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162402, NULL, 'G3DSA:1.10.287.570:FF:000002', NULL, NULL, 'Solute carrier family 4 member 11', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(162403, NULL, 'G3DSA:1.25.10.10:FF:000389', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 56 kDa regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(162404, NULL, 'G3DSA:1.10.472.10:FF:000237', NULL, NULL, 'Cyclin-D1-2', NULL, NULL, NULL, NULL, NULL, 4),
(162405, NULL, 'G3DSA:2.130.10.10:FF:005080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162406, NULL, 'G3DSA:3.30.470.30:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162407, NULL, 'G3DSA:3.30.565.10:FF:000188', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(162408, NULL, 'G3DSA:1.25.40.10:FF:002807', NULL, NULL, 'tetratricopeptide repeat protein 7B-like', NULL, NULL, NULL, NULL, NULL, 4),
(162409, NULL, 'G3DSA:1.25.10.10:FF:002188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162410, NULL, 'G3DSA:1.20.58.60:FF:000007', NULL, NULL, 'Spectrin alpha chain non-erythrocytic 1', NULL, NULL, NULL, NULL, NULL, 4),
(162411, NULL, 'G3DSA:2.60.40.10:FF:004495', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162412, NULL, 'G3DSA:3.80.10.10:FF:003607', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(162413, NULL, 'G3DSA:3.30.420.10:FF:000150', NULL, NULL, 'Ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(162414, NULL, 'G3DSA:2.60.40.150:FF:000816', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162415, NULL, 'G3DSA:1.20.1560.10:FF:000141', NULL, NULL, 'Thiol reductant ABC exporter subunit CydC', NULL, NULL, NULL, NULL, NULL, 4),
(162416, NULL, 'G3DSA:3.30.465.10:FF:000129', NULL, NULL, 'D-lactate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(162417, NULL, 'G3DSA:1.10.150.870:FF:000003', NULL, NULL, 'DNA-directed DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(162418, NULL, 'G3DSA:2.60.40.10:FF:005113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162419, NULL, 'G3DSA:1.20.140.60:FF:000001', NULL, NULL, 'Calmodulin-sensitive adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(162420, NULL, 'G3DSA:2.20.70.10:FF:000277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162421, NULL, 'G3DSA:3.30.450.30:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162422, NULL, 'G3DSA:2.30.29.30:FF:000119', NULL, NULL, 'FACT complex subunit SSRP1', NULL, NULL, NULL, NULL, NULL, 4),
(162423, NULL, 'G3DSA:3.40.50.1240:FF:000139', NULL, NULL, 'YALI0A08019p', NULL, NULL, NULL, NULL, NULL, 4),
(162424, NULL, 'G3DSA:3.30.70.20:FF:000137', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162425, NULL, 'G3DSA:1.20.1070.10:FF:001688', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(162426, NULL, 'G3DSA:1.20.1250.20:FF:001896', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162427, NULL, 'G3DSA:3.20.20.80:FF:000253', NULL, NULL, 'glycoprotein endo-alpha-1,2-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(162428, NULL, 'G3DSA:3.10.100.10:FF:000445', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162429, NULL, 'G3DSA:2.70.40.10:FF:000032', NULL, NULL, 'Putative inactive deoxyuridine 5''-triphosphate nucleotidohydrolase-like protein FLJ16323', NULL, NULL, NULL, NULL, NULL, 4),
(162430, NULL, 'G3DSA:1.10.10.60:FF:000864', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162431, NULL, 'G3DSA:3.40.50.1220:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162432, NULL, 'G3DSA:2.60.120.290:FF:000024', NULL, NULL, 'Low-density lipoprotein receptor-related protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(162433, NULL, 'G3DSA:3.30.420.40:FF:000159', NULL, NULL, 'L-fuculokinase', NULL, NULL, NULL, NULL, NULL, 4),
(162434, NULL, 'G3DSA:3.30.70.920:FF:000039', NULL, NULL, 'Transcriptional regulator, AsnC family', NULL, NULL, NULL, NULL, NULL, 4),
(162435, NULL, 'G3DSA:2.10.25.10:FF:001472', NULL, NULL, 'Neurocan core protein', NULL, NULL, NULL, NULL, NULL, 4),
(162436, NULL, 'G3DSA:1.20.1050.10:FF:000057', NULL, NULL, 'Glutathione S-transferase, N-terminal domain protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(162437, NULL, 'G3DSA:2.60.40.60:FF:000665', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162438, NULL, 'G3DSA:3.30.300.30:FF:000102', NULL, NULL, 'AM-toxin synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(162439, NULL, 'G3DSA:1.10.238.10:FF:001250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162440, NULL, 'G3DSA:3.30.200.20:FF:002076', NULL, NULL, 'NimA-related protein kinase 8', NULL, NULL, NULL, NULL, NULL, 4),
(162441, NULL, 'G3DSA:2.30.42.10:FF:000206', NULL, NULL, 'Glutamate receptor-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(162442, NULL, 'G3DSA:3.30.70.560:FF:000009', NULL, NULL, '2-amino-4-hydroxy-6-hydroxymethyldihydropteridine pyrophosphokinase FolK-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(162443, NULL, 'G3DSA:2.60.120.590:FF:000007', NULL, NULL, 'Alpha-ketoglutarate-dependent dioxygenase alkB homolog 6', NULL, NULL, NULL, NULL, NULL, 4),
(162444, NULL, 'G3DSA:2.130.10.10:FF:000768', NULL, NULL, 'Syntaxin-binding protein 5 isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(162445, NULL, 'G3DSA:3.30.870.10:FF:000083', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(162446, NULL, 'G3DSA:2.130.10.10:FF:000875', NULL, NULL, 'WD repeat-containing protein 82', NULL, NULL, NULL, NULL, NULL, 4),
(162447, NULL, 'G3DSA:2.40.50.140:FF:000516', NULL, NULL, 'Ribonuclease E/G', NULL, NULL, NULL, NULL, NULL, 4),
(162448, NULL, 'G3DSA:3.80.10.10:FF:004208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162449, NULL, 'G3DSA:1.10.760.10:FF:000047', NULL, NULL, 'Hydrazine synthase subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(162450, NULL, 'G3DSA:1.20.1050.10:FF:000164', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(162451, NULL, 'G3DSA:3.30.1380.10:FF:000005', NULL, NULL, 'Sonic hedgehog signaling molecule', NULL, NULL, NULL, NULL, NULL, 4),
(162452, NULL, 'G3DSA:3.30.70.330:FF:002324', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162453, NULL, 'G3DSA:3.30.2010.10:FF:000023', NULL, NULL, 'YALI0E12309p', NULL, NULL, NULL, NULL, NULL, 4),
(162454, NULL, 'G3DSA:3.30.70.330:FF:000183', NULL, NULL, 'R3H domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(162455, NULL, 'G3DSA:3.40.50.1820:FF:000111', NULL, NULL, 'Alpha/beta-Hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(162456, NULL, 'G3DSA:3.30.930.10:FF:000121', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(162457, NULL, 'G3DSA:3.30.50.10:FF:000026', NULL, NULL, 'DNA gyrase inhibitor YacG', NULL, NULL, NULL, NULL, NULL, 4),
(162458, NULL, 'G3DSA:3.80.10.10:FF:001792', NULL, NULL, 'Leucine-rich repeat protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(162459, NULL, 'G3DSA:3.30.420.40:FF:000491', NULL, NULL, 'Chaperone protein HscA', NULL, NULL, NULL, NULL, NULL, 4),
(162460, NULL, 'G3DSA:1.10.150.20:FF:000239', NULL, NULL, 'DNA transformation protein TfoX2', NULL, NULL, NULL, NULL, NULL, 4),
(162461, NULL, 'G3DSA:3.80.10.10:FF:002410', NULL, NULL, 'Toll-like receptor 6', NULL, NULL, NULL, NULL, NULL, 4),
(162462, NULL, 'G3DSA:1.20.5.170:FF:000134', NULL, NULL, 'Transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(162463, NULL, 'G3DSA:3.30.40.10:FF:000531', NULL, NULL, 'RING/FYVE/PHD zinc finger superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(162464, NULL, 'G3DSA:1.10.510.10:FF:002474', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162465, NULL, 'G3DSA:1.20.1250.20:FF:001789', NULL, NULL, 'Sodium-dependent glucose transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162466, NULL, 'G3DSA:2.30.29.30:FF:000226', NULL, NULL, 'Pleckstrin', NULL, NULL, NULL, NULL, NULL, 4),
(162467, NULL, 'G3DSA:2.130.10.10:FF:002909', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162468, NULL, 'G3DSA:3.90.940.10:FF:000007', NULL, NULL, 'DNA-directed RNA polymerase subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162469, NULL, 'G3DSA:3.40.50.2300:FF:000603', NULL, NULL, 'Nitrogen regulation protein NR(I)', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(162470, NULL, 'G3DSA:3.30.420.140:FF:000003', NULL, NULL, 'Putative pre-16S rRNA nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(162471, NULL, 'G3DSA:3.30.470.20:FF:000100', NULL, NULL, 'Succinate--CoA ligase [GDP-forming] subunit beta, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(162472, NULL, 'G3DSA:1.20.58.60:FF:000114', NULL, NULL, 'dystonin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(162473, NULL, 'G3DSA:1.10.1820.10:FF:000023', NULL, NULL, 'Probable casein kinase II subunit beta-2', NULL, NULL, NULL, NULL, NULL, 4),
(162474, NULL, 'G3DSA:3.40.50.11610:FF:000012', NULL, NULL, '2-oxoglutarate dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(162475, NULL, 'G3DSA:3.10.450.50:FF:000073', NULL, NULL, 'Zgc:101555', NULL, NULL, NULL, NULL, NULL, 4),
(162476, NULL, 'G3DSA:1.20.1070.10:FF:000165', NULL, NULL, 'Probable G-protein coupled receptor 19', NULL, NULL, NULL, NULL, NULL, 4),
(162477, NULL, 'G3DSA:2.30.30.1190:FF:000008', NULL, NULL, 'Zinc finger CCCH domain-containing protein 33', NULL, NULL, NULL, NULL, NULL, 4),
(162478, NULL, 'G3DSA:2.160.20.10:FF:000009', NULL, NULL, 'Pectate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(162479, NULL, 'G3DSA:1.10.510.10:FF:001170', NULL, NULL, 'Ribosomal protein S6 kinase alpha-1', NULL, NULL, NULL, NULL, NULL, 4),
(162480, NULL, 'G3DSA:2.60.120.260:FF:000605', NULL, NULL, 'Arylsulfatase homolog b1498', NULL, NULL, NULL, NULL, NULL, 4),
(162481, NULL, 'G3DSA:3.20.20.150:FF:000020', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(162482, NULL, 'G3DSA:3.90.1150.10:FF:000367', NULL, NULL, 'Pleiotropic regulatory protein, conjectural', NULL, NULL, NULL, NULL, NULL, 4),
(162483, NULL, 'G3DSA:3.40.50.300:FF:003242', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(162484, NULL, 'G3DSA:3.40.50.670:FF:000008', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(162485, NULL, 'G3DSA:3.30.420.150:FF:000006', NULL, NULL, 'Ppx/GppA family phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(162486, NULL, 'G3DSA:3.30.160.60:FF:004725', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162487, NULL, 'G3DSA:3.30.1520.10:FF:000090', NULL, NULL, 'PX domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(162488, NULL, 'G3DSA:2.30.130.40:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162489, NULL, 'G3DSA:3.30.160.60:FF:001274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162490, NULL, 'G3DSA:3.30.2380.10:FF:000005', NULL, NULL, 'Kinase binding protein CGI-121, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162491, NULL, 'G3DSA:3.90.70.80:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162492, NULL, 'G3DSA:3.80.10.10:FF:003933', NULL, NULL, 'Leucine-rich repeats and death domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(162493, NULL, 'G3DSA:2.60.40.1120:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162494, NULL, 'G3DSA:1.10.340.30:FF:000055', NULL, NULL, 'HhH-GPD family protein', NULL, NULL, NULL, NULL, NULL, 4),
(162495, NULL, 'G3DSA:3.30.260.10:FF:000053', NULL, NULL, 'Chaperonin-containing TCP1 subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(162496, NULL, 'G3DSA:3.40.50.1000:FF:000197', NULL, NULL, '4-nitrophenylphosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162497, NULL, 'G3DSA:3.40.630.10:FF:000490', NULL, NULL, 'Peptidase M20 domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(162498, NULL, 'G3DSA:3.40.190.10:FF:000129', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(162499, NULL, 'G3DSA:3.40.50.970:FF:000104', NULL, NULL, '1-deoxy-D-xylulose-5-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(162500, NULL, 'G3DSA:1.10.220.30:FF:000001', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(162501, NULL, 'G3DSA:2.60.40.10:FF:004388', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162502, NULL, 'G3DSA:3.30.160.60:FF:001167', NULL, NULL, 'zinc finger protein 691', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(162503, NULL, 'G3DSA:3.60.110.10:FF:000024', NULL, NULL, 'Deaminated glutathione amidase', NULL, NULL, NULL, NULL, NULL, 4),
(162504, NULL, 'G3DSA:2.60.120.200:FF:000161', NULL, NULL, 'Laminin subunit alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(162505, NULL, 'G3DSA:1.20.58.1030:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162506, NULL, 'G3DSA:1.10.510.10:FF:004508', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162507, NULL, 'G3DSA:3.10.110.10:FF:000272', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(162508, NULL, 'G3DSA:1.10.510.10:FF:002367', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162509, NULL, 'G3DSA:3.30.1520.10:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162510, NULL, 'G3DSA:3.30.40.10:FF:001835', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162511, NULL, 'G3DSA:2.10.25.10:FF:001359', NULL, NULL, 'laminin subunit beta-1 isoform X7', NULL, NULL, NULL, NULL, NULL, 4),
(162512, NULL, 'G3DSA:3.30.910.20:FF:000016', NULL, NULL, 'Outer membrane protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(162513, NULL, 'G3DSA:3.40.309.10:FF:000035', NULL, NULL, 'Aldehyde dehydrogenase, dimeric NADP-preferring', NULL, NULL, NULL, NULL, NULL, 4),
(162514, NULL, 'G3DSA:3.30.160.60:FF:002584', NULL, NULL, 'Zinc finger protein 445', NULL, NULL, NULL, NULL, NULL, 4),
(162515, NULL, 'G3DSA:1.10.238.10:FF:001137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162516, NULL, 'G3DSA:1.10.8.270:FF:000088', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(162517, NULL, 'G3DSA:1.25.40.20:FF:001400', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162518, NULL, 'G3DSA:1.10.460.10:FF:000007', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(162519, NULL, 'G3DSA:1.10.472.10:FF:000563', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162520, NULL, 'G3DSA:1.10.510.10:FF:003081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162521, NULL, 'G3DSA:3.40.50.1980:FF:000018', NULL, NULL, 'Iron(III) dicitrate-binding periplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(162522, NULL, 'G3DSA:3.40.50.720:FF:000046', NULL, NULL, 'UDP-N-acetylmuramate--L-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(162523, NULL, 'G3DSA:3.40.50.150:FF:000976', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162524, NULL, 'G3DSA:3.10.129.10:FF:000185', NULL, NULL, 'Mitochondrial hydroxyacyl-thioester dehydratase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162525, NULL, 'G3DSA:3.80.10.10:FF:004321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162526, NULL, 'G3DSA:3.40.30.10:FF:001126', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(162527, NULL, 'G3DSA:3.30.930.10:FF:000014', NULL, NULL, 'Glycine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(162528, NULL, 'G3DSA:3.30.70.330:FF:000290', NULL, NULL, 'RNA-binding protein 45 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(162529, NULL, 'G3DSA:2.130.10.10:FF:004366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162530, NULL, 'G3DSA:2.160.20.10:FF:000341', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162531, NULL, 'G3DSA:1.20.1280.290:FF:000043', NULL, NULL, 'Sugar transporter SWEET', NULL, NULL, NULL, NULL, NULL, 4),
(162532, NULL, 'G3DSA:3.40.50.300:FF:004765', NULL, NULL, 'neuron navigator 2', NULL, NULL, NULL, NULL, NULL, 4),
(162533, NULL, 'G3DSA:3.40.50.1970:FF:000015', NULL, NULL, 'Maleylacetate reductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(162534, NULL, 'G3DSA:3.50.50.60:FF:000175', NULL, NULL, 'Pyridine nucleotide-disulfide oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(162535, NULL, 'G3DSA:3.40.190.10:FF:000348', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(162536, NULL, 'G3DSA:3.60.40.10:FF:000041', NULL, NULL, 'Protein phosphatase 2C 51', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(162537, NULL, 'G3DSA:1.10.10.10:FF:000097', NULL, NULL, 'Protein c-ets-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(162538, NULL, 'G3DSA:1.10.1410.10:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162539, NULL, 'G3DSA:3.40.50.970:FF:000093', NULL, NULL, '1-deoxy-D-xylulose-5-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(162540, NULL, 'G3DSA:2.40.128.180:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162541, NULL, 'G3DSA:2.30.42.10:FF:000425', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162542, NULL, 'G3DSA:3.40.50.150:FF:001140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162543, NULL, 'G3DSA:1.20.1560.10:FF:000028', NULL, NULL, 'ABC transporter B family member 20', NULL, NULL, NULL, NULL, NULL, 4),
(162544, NULL, 'G3DSA:2.70.98.10:FF:000086', NULL, NULL, 'Chondroitin sulfate ABC exolyase', NULL, NULL, NULL, NULL, NULL, 4),
(162545, NULL, 'G3DSA:3.80.10.10:FF:000050', NULL, NULL, 'FLII, actin remodeling protein', NULL, NULL, NULL, NULL, NULL, 4),
(162546, NULL, 'G3DSA:3.40.50.12090:FF:000004', NULL, NULL, 'Endolysin CS74L', NULL, NULL, NULL, NULL, NULL, 4),
(162547, NULL, 'G3DSA:1.10.510.10:FF:001057', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(162548, NULL, 'G3DSA:3.40.50.300:FF:006676', NULL, NULL, 'RecQ DNA helicase-like protein C212.06c', NULL, NULL, NULL, NULL, NULL, 4),
(162549, NULL, 'G3DSA:1.10.10.60:FF:000645', NULL, NULL, 'Os07g0634900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(162550, NULL, 'G3DSA:3.30.420.40:FF:000378', NULL, NULL, 'Actin-related protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(162551, NULL, 'G3DSA:3.30.1370.120:FF:000005', NULL, NULL, 'Type III secretion system outer membrane pore InvG', NULL, NULL, NULL, NULL, NULL, 4),
(162552, NULL, 'G3DSA:1.20.120.420:FF:000012', NULL, NULL, 'Putative methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(162553, NULL, 'G3DSA:3.10.129.10:FF:000202', NULL, NULL, 'Thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(162554, NULL, 'G3DSA:3.40.50.2000:FF:000614', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(162555, NULL, 'G3DSA:3.50.50.60:FF:000394', NULL, NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162556, NULL, 'G3DSA:3.10.110.10:FF:000159', NULL, NULL, 'Putative ubiquitin-conjugating enzyme E2 24', NULL, NULL, NULL, NULL, NULL, 4),
(162557, NULL, 'G3DSA:3.40.47.10:FF:000254', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162558, NULL, 'G3DSA:1.25.10.10:FF:000838', NULL, NULL, 'HEAT repeat domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(162559, NULL, 'G3DSA:3.80.10.10:FF:001679', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162560, NULL, 'G3DSA:3.30.230.10:FF:000225', NULL, NULL, 'DNA mismatch repair protein pms2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162561, NULL, 'G3DSA:1.25.40.20:FF:000782', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162562, NULL, 'G3DSA:2.60.40.150:FF:000709', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162563, NULL, 'G3DSA:2.60.40.4100:FF:000004', NULL, NULL, 'Zona pellucida sperm-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(162564, NULL, 'G3DSA:1.20.1560.10:FF:000360', NULL, NULL, 'Os01g0533900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(162565, NULL, 'G3DSA:1.10.472.10:FF:000344', NULL, NULL, 'CCNK isoform 5', NULL, NULL, NULL, NULL, NULL, 4),
(162566, NULL, 'G3DSA:2.120.10.30:FF:000393', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162567, NULL, 'G3DSA:2.150.10.10:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162568, NULL, 'G3DSA:3.90.960.10:FF:000008', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(162569, NULL, 'G3DSA:1.20.58.1480:FF:000025', NULL, NULL, 'Protein cereblon', NULL, NULL, NULL, NULL, NULL, 4),
(162570, NULL, 'G3DSA:2.40.37.10:FF:000031', NULL, NULL, 'Ornithine decarboxylase 1', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(162571, NULL, 'G3DSA:2.60.40.10:FF:002590', NULL, NULL, 'Putative Filamin-A', NULL, NULL, NULL, NULL, NULL, 4),
(162572, NULL, 'G3DSA:3.30.160.60:FF:003421', NULL, NULL, 'Si:dkey-7i4.10', NULL, NULL, NULL, NULL, NULL, 4),
(162573, NULL, 'G3DSA:3.90.190.10:FF:000320', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(162574, NULL, 'G3DSA:3.30.565.10:FF:000295', NULL, NULL, 'Sensor histidine kinase/response regulator LuxN', NULL, NULL, NULL, NULL, NULL, 4),
(162575, NULL, 'G3DSA:1.20.58.60:FF:000226', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(162576, NULL, 'G3DSA:1.10.510.10:FF:002586', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162577, NULL, 'G3DSA:3.10.180.10:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162578, NULL, 'G3DSA:3.40.50.720:FF:001682', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(162579, NULL, 'G3DSA:3.40.50.720:FF:002300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162580, NULL, 'G3DSA:1.20.1250.20:FF:001677', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(162581, NULL, 'G3DSA:2.70.130.10:FF:000078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162582, NULL, 'G3DSA:3.40.50.10900:FF:000029', NULL, NULL, 'Proteasome assembly chaperone 2', NULL, NULL, NULL, NULL, NULL, 4),
(162583, NULL, 'G3DSA:1.10.150.20:FF:000127', NULL, NULL, 'Unplaced genomic scaffold supercont1.238, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(162584, NULL, 'G3DSA:1.10.8.10:FF:000112', NULL, NULL, 'Phosphoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(162585, NULL, 'G3DSA:1.10.565.10:FF:000020', NULL, NULL, 'Nuclear receptor subfamily 2 group F member 6', NULL, NULL, NULL, NULL, NULL, 4),
(162586, NULL, 'G3DSA:2.60.40.790:FF:000199', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162587, NULL, 'G3DSA:3.90.550.10:FF:000197', NULL, NULL, 'Alpha-1,6-mannosyltransferase subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162588, NULL, 'G3DSA:3.40.50.1820:FF:001398', NULL, NULL, 'Conditioned medium factor', NULL, NULL, NULL, NULL, NULL, 4),
(162589, NULL, 'G3DSA:3.40.50.1370:FF:000037', NULL, NULL, 'Aspartate carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(162590, NULL, 'G3DSA:2.40.10.10:FF:000677', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162591, NULL, 'G3DSA:3.40.50.2300:FF:000367', NULL, NULL, 'Histidine kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(162592, NULL, 'G3DSA:3.60.10.10:FF:000106', NULL, NULL, 'Unplaced genomic scaffold supercont1.219, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(162593, NULL, 'G3DSA:2.60.40.10:FF:000908', NULL, NULL, 'Interleukin 31 receptor A', NULL, NULL, NULL, NULL, NULL, 4),
(162594, NULL, 'G3DSA:2.60.40.10:FF:000897', NULL, NULL, 'Immunoglobulin kappa variable 3-20', NULL, NULL, NULL, NULL, NULL, 4),
(162595, NULL, 'G3DSA:2.60.120.290:FF:000131', NULL, NULL, 'SOL-1 related protein', NULL, NULL, NULL, NULL, NULL, 4),
(162596, NULL, 'G3DSA:1.20.140.80:FF:000007', NULL, NULL, 'Transcription factor dpl-1', NULL, NULL, NULL, NULL, NULL, 4),
(162597, NULL, 'G3DSA:2.40.10.250:FF:000002', NULL, NULL, 'Replicase polyprotein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(162598, NULL, 'G3DSA:3.40.50.1440:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162599, NULL, 'G3DSA:2.60.120.650:FF:000054', NULL, NULL, 'Histone H3-K36 demethylase', NULL, NULL, NULL, NULL, NULL, 4),
(162600, NULL, 'G3DSA:2.130.10.10:FF:004927', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162601, NULL, 'G3DSA:3.40.50.300:FF:003023', NULL, NULL, 'Uncharacterized ATP-dependent helicase IRC5', NULL, NULL, NULL, NULL, NULL, 4),
(162602, NULL, 'G3DSA:1.10.730.10:FF:000219', NULL, NULL, 'Valyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(162603, NULL, 'G3DSA:2.170.270.10:FF:000148', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(162604, NULL, 'G3DSA:3.30.1010.10:FF:000130', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(162605, NULL, 'G3DSA:3.30.830.10:FF:000193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162606, NULL, 'G3DSA:2.40.50.90:FF:000080', NULL, NULL, 'Staphylococcal_nuclease_homologue /Tudor_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(162607, NULL, 'G3DSA:2.60.40.10:FF:004276', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162608, NULL, 'G3DSA:3.30.160.60:FF:001055', NULL, NULL, 'Zinc finger and BTB domain-containing protein 24', NULL, NULL, NULL, NULL, NULL, 4),
(162609, NULL, 'G3DSA:2.60.40.180:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162610, NULL, 'G3DSA:3.60.20.10:FF:000152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162611, NULL, 'G3DSA:1.10.110.10:FF:000021', NULL, NULL, 'Bifunctional inhibitor/lipid-transfer protein/seed storage 2S albumin superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(162612, NULL, 'G3DSA:3.50.50.60:FF:001012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162613, NULL, 'G3DSA:3.40.50.12780:FF:000222', NULL, NULL, 'Disco interacting protein 2 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(162614, NULL, 'G3DSA:2.70.150.10:FF:000298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162615, NULL, 'G3DSA:3.40.50.300:FF:005260', NULL, NULL, 'YALI0C18447p', NULL, NULL, NULL, NULL, NULL, 4),
(162616, NULL, 'G3DSA:3.40.50.2300:FF:000822', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162617, NULL, 'G3DSA:3.30.40.10:FF:000750', NULL, NULL, 'Chromatin modification-related protein YNG2', NULL, NULL, NULL, NULL, NULL, 4),
(162618, NULL, 'G3DSA:3.30.160.60:FF:000892', NULL, NULL, 'zinc finger and BTB domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(162619, NULL, 'G3DSA:3.30.870.10:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162620, NULL, 'G3DSA:1.10.150.190:FF:000007', NULL, NULL, 'Translation initiation factor 2 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(162621, NULL, 'G3DSA:2.60.40.1170:FF:000069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162622, NULL, 'G3DSA:3.40.50.620:FF:000460', NULL, NULL, 'Tryptophan--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(162623, NULL, 'G3DSA:1.10.3120.10:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162624, NULL, 'G3DSA:3.10.180.10:FF:000107', NULL, NULL, '4-hydroxyphenylpyruvate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(162625, NULL, 'G3DSA:1.10.3380.30:FF:000006', NULL, NULL, 'DExH-box ATP-dependent RNA helicase DExH10', NULL, NULL, NULL, NULL, NULL, 4),
(162626, NULL, 'G3DSA:3.10.330.10:FF:000035', NULL, NULL, 'Nsf-1', NULL, NULL, NULL, NULL, NULL, 4),
(162627, NULL, 'G3DSA:3.30.160.60:FF:001510', NULL, NULL, 'Endolytic murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(162628, NULL, 'G3DSA:2.130.10.10:FF:002786', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit wdr4', NULL, NULL, NULL, NULL, NULL, 4),
(162629, NULL, 'G3DSA:3.30.160.60:FF:003640', NULL, NULL, 'Related to RNA splicing factor PRP9', NULL, NULL, NULL, NULL, NULL, 4),
(162630, NULL, 'G3DSA:3.40.50.2300:FF:000480', NULL, NULL, 'Response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(162631, NULL, 'G3DSA:3.10.28.10:FF:000037', NULL, NULL, 'Probable intron-encoded DNA endonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(162632, NULL, 'G3DSA:3.40.50.300:FF:003461', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162633, NULL, 'G3DSA:1.20.1250.20:FF:000154', NULL, NULL, 'Solute carrier family 22 member 16', NULL, NULL, NULL, NULL, NULL, 4),
(162634, NULL, 'G3DSA:1.10.510.10:FF:004385', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162635, NULL, 'G3DSA:3.40.190.10:FF:000680', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162636, NULL, 'G3DSA:3.30.565.10:FF:000418', NULL, NULL, 'Probable heat shock protein (Hsp90 family)', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(162637, NULL, 'G3DSA:3.30.465.10:FF:000023', NULL, NULL, 'Magnesium and cobalt transporter', NULL, NULL, NULL, NULL, NULL, 4),
(162638, NULL, 'G3DSA:1.10.3380.20:FF:000003', NULL, NULL, 'Helicase and polymerase-containing protein TEBICHI', NULL, NULL, NULL, NULL, NULL, 4),
(162639, NULL, 'G3DSA:2.130.10.10:FF:003404', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162640, NULL, 'G3DSA:2.60.40.10:FF:002819', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(162641, NULL, 'G3DSA:1.10.150.170:FF:000001', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase H', NULL, NULL, NULL, NULL, NULL, 4),
(162642, NULL, 'G3DSA:2.130.10.10:FF:003062', NULL, NULL, 'WD repeat-containing protein 36', NULL, NULL, NULL, NULL, NULL, 4),
(162643, NULL, 'G3DSA:2.60.40.150:FF:000586', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162644, NULL, 'G3DSA:2.10.25.10:FF:000055', NULL, NULL, 'alpha-tectorin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(162645, NULL, 'G3DSA:3.40.50.620:FF:000802', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162646, NULL, 'G3DSA:2.30.29.30:FF:000007', NULL, NULL, 'Calcium-dependent secretion activator 2 isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(162647, NULL, 'G3DSA:3.90.180.10:FF:000151', NULL, NULL, 'D-arabinitol dehydrogenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(162648, NULL, 'G3DSA:3.30.70.330:FF:002088', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162649, NULL, 'G3DSA:2.130.10.30:FF:000072', NULL, NULL, 'Regulator of chromosome condensation, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162650, NULL, 'G3DSA:1.10.150.20:FF:000240', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(162651, NULL, 'G3DSA:2.170.120.12:FF:000027', NULL, NULL, 'DNA-directed RNA polymerase, alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162652, NULL, 'G3DSA:2.60.40.60:FF:000884', NULL, NULL, 'Si:dkey-30k22.7', NULL, NULL, NULL, NULL, NULL, 4),
(162653, NULL, 'G3DSA:1.10.8.60:FF:000211', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(162654, NULL, 'G3DSA:2.60.40.10:FF:002477', NULL, NULL, 'Protein CBR-UNC-22', NULL, NULL, NULL, NULL, NULL, 4),
(162655, NULL, 'G3DSA:2.20.80.10:FF:000008', NULL, NULL, 'Vitellogenin-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(162656, NULL, 'G3DSA:2.70.170.10:FF:000187', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(162657, NULL, 'G3DSA:3.90.550.10:FF:000539', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(162658, NULL, 'G3DSA:2.40.50.140:FF:000393', NULL, NULL, 'Sugar ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(162659, NULL, 'G3DSA:3.40.50.1000:FF:000758', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162660, NULL, 'G3DSA:3.40.50.300:FF:001331', NULL, NULL, 'Replication factor C subunit 4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162661, NULL, 'G3DSA:3.30.200.20:FF:002188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162662, NULL, 'G3DSA:3.40.50.300:FF:005602', NULL, NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 9', NULL, NULL, NULL, NULL, NULL, 4),
(162663, NULL, 'G3DSA:2.130.10.10:FF:000656', NULL, NULL, 'Nuclear pore complex protein NUP133', NULL, NULL, NULL, NULL, NULL, 4),
(162664, NULL, 'G3DSA:1.20.1070.10:FF:001924', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162665, NULL, 'G3DSA:3.90.870.10:FF:000001', NULL, NULL, 'Riboflavin biosynthesis protein RibBA', NULL, NULL, NULL, NULL, NULL, 4),
(162666, NULL, 'G3DSA:1.10.150.50:FF:000001', NULL, NULL, 'Ephrin type-A receptor 5', NULL, NULL, NULL, NULL, NULL, 4),
(162667, NULL, 'G3DSA:3.30.559.10:FF:000241', NULL, NULL, 'Carnitine O-palmitoyltransferase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(162668, NULL, 'G3DSA:1.25.40.10:FF:004718', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(162669, NULL, 'G3DSA:3.40.1410.10:FF:000040', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(162670, NULL, 'G3DSA:1.20.1070.10:FF:001469', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(162671, NULL, 'G3DSA:2.60.40.820:FF:000028', NULL, NULL, 'T-box transcription factor Ci-mT', NULL, NULL, NULL, NULL, NULL, 4),
(162672, NULL, 'G3DSA:2.120.10.80:FF:000048', NULL, NULL, 'Kelch-like family, member 42', NULL, NULL, NULL, NULL, NULL, 4),
(162673, NULL, 'G3DSA:3.30.2340.10:FF:000008', NULL, NULL, 'tRNA pseudouridine synthase D', NULL, NULL, NULL, NULL, NULL, 4),
(162674, NULL, 'G3DSA:3.30.450.20:FF:000211', NULL, NULL, 'Protein TWIN LOV 1', NULL, NULL, NULL, NULL, NULL, 4),
(162675, NULL, 'G3DSA:3.30.1050.10:FF:000014', NULL, NULL, 'DeHydrogenases, Short chain', NULL, NULL, NULL, NULL, NULL, 4),
(162676, NULL, 'G3DSA:1.10.287.70:FF:000700', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162677, NULL, 'G3DSA:2.20.70.10:FF:000058', NULL, NULL, 'Formin binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(162678, NULL, 'G3DSA:3.40.5.60:FF:000004', NULL, NULL, 'DNA replication complex GINS protein SLD5', NULL, NULL, NULL, NULL, NULL, 4),
(162679, NULL, 'G3DSA:3.30.200.20:FF:000732', NULL, NULL, 'Mitogen-activated protein kinase kinase', NULL, NULL, NULL, NULL, NULL, 4),
(162680, NULL, 'G3DSA:1.25.10.10:FF:003025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162681, NULL, 'G3DSA:3.40.1090.10:FF:000065', NULL, NULL, 'Patatin', NULL, NULL, NULL, NULL, NULL, 4),
(162682, NULL, 'G3DSA:3.30.160.60:FF:005107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162683, NULL, 'G3DSA:3.30.420.40:FF:000939', NULL, NULL, 'ARP6 actin related protein 6 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(162684, NULL, 'G3DSA:3.30.70.330:FF:000413', NULL, NULL, 'Serine/arginine-rich splicing factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(162685, NULL, 'G3DSA:2.10.55.10:FF:000006', NULL, NULL, 'GP63', NULL, NULL, NULL, NULL, NULL, 4),
(162686, NULL, 'G3DSA:3.20.20.190:FF:000003', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(162687, NULL, 'G3DSA:2.10.25.10:FF:000510', NULL, NULL, 'Signal peptide, CUB and EGF-like domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(162688, NULL, 'G3DSA:1.20.1090.10:FF:000054', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(162689, NULL, 'G3DSA:1.25.10.10:FF:000619', NULL, NULL, 'Hsp70 nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(162690, NULL, 'G3DSA:1.10.274.100:FF:000021', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(162691, NULL, 'G3DSA:1.25.10.10:FF:002749', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162692, NULL, 'G3DSA:3.30.420.40:FF:000597', NULL, NULL, 'Os08g0369300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(162693, NULL, 'G3DSA:1.10.1050.10:FF:000003', NULL, NULL, '30S ribosomal protein S4', NULL, NULL, NULL, NULL, NULL, 4),
(162694, NULL, 'G3DSA:1.10.150.60:FF:000004', NULL, NULL, 'AT-rich interactive domain-containing protein 5B', NULL, NULL, NULL, NULL, NULL, 4),
(162695, NULL, 'G3DSA:3.30.40.10:FF:002217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162696, NULL, 'G3DSA:3.90.550.50:FF:000074', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(162697, NULL, 'G3DSA:3.40.50.2300:FF:000148', NULL, NULL, 'Catabolite control protein A', NULL, NULL, NULL, NULL, NULL, 4),
(162698, NULL, 'G3DSA:2.40.50.140:FF:000735', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162699, NULL, 'G3DSA:2.40.70.10:FF:000344', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162700, NULL, 'G3DSA:3.60.15.10:FF:000078', NULL, NULL, 'Ribonuclease Z, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162701, NULL, 'G3DSA:3.90.1800.10:FF:000002', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(162702, NULL, 'G3DSA:3.40.50.880:FF:000066', NULL, NULL, 'CTP synthase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(162703, NULL, 'G3DSA:3.30.43.10:FF:000004', NULL, NULL, 'Berberine bridge enzyme-like 15', NULL, NULL, NULL, NULL, NULL, 4),
(162704, NULL, 'G3DSA:1.20.1070.10:FF:001582', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162705, NULL, 'G3DSA:2.60.40.10:FF:003191', NULL, NULL, 'Lin1840 protein', NULL, NULL, NULL, NULL, NULL, 4),
(162706, NULL, 'G3DSA:1.25.40.10:FF:000447', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(162707, NULL, 'G3DSA:1.10.287.130:FF:000005', NULL, NULL, 'Nitrogen regulation histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(162708, NULL, 'G3DSA:1.10.10.10:FF:000877', NULL, NULL, 'Anaphase-promoting complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(162709, NULL, 'G3DSA:1.25.40.10:FF:001161', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(162710, NULL, 'G3DSA:1.20.1250.20:FF:001790', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162711, NULL, 'G3DSA:3.30.413.10:FF:000015', NULL, NULL, '4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase (flavodoxin)', NULL, NULL, NULL, NULL, NULL, 4),
(162712, NULL, 'G3DSA:3.30.40.10:FF:000418', NULL, NULL, 'Peroxisome biogenesis factor 10', NULL, NULL, NULL, NULL, NULL, 4),
(162713, NULL, 'G3DSA:1.20.1080.10:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162714, NULL, 'G3DSA:2.40.50.140:FF:001011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162715, NULL, 'G3DSA:3.30.40.10:FF:000076', NULL, NULL, 'E3 ubiquitin-protein ligase Mdm2', NULL, NULL, NULL, NULL, NULL, 4),
(162716, NULL, 'G3DSA:2.40.50.90:FF:000203', NULL, NULL, 'Methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(162717, NULL, 'G3DSA:3.30.70.330:FF:000289', NULL, NULL, 'RNA-binding protein 40 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(162718, NULL, 'G3DSA:3.30.590.10:FF:000038', NULL, NULL, 'Arginine kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162719, NULL, 'G3DSA:1.10.472.170:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162720, NULL, 'G3DSA:3.40.350.10:FF:000007', NULL, NULL, 'Xaa-Pro dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(162721, NULL, 'G3DSA:1.20.5.420:FF:000024', NULL, NULL, 'Putative small glutamine-rich tetratricopeptide repeat-containing protein alpha', NULL, NULL, NULL, NULL, NULL, 4),
(162722, NULL, 'G3DSA:2.170.130.10:FF:000082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162723, NULL, 'G3DSA:3.90.1410.10:FF:000079', NULL, NULL, 'Protein-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(162724, NULL, 'G3DSA:3.40.50.1820:FF:000217', NULL, NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(162725, NULL, 'G3DSA:1.10.600.10:FF:000092', NULL, NULL, 'Squalene synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(162726, NULL, 'G3DSA:1.10.10.10:FF:001153', NULL, NULL, 'GM24041', NULL, NULL, NULL, NULL, NULL, 4),
(162727, NULL, 'G3DSA:3.40.50.1820:FF:001179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162728, NULL, 'G3DSA:1.25.40.10:FF:000885', NULL, NULL, 'Tetratricopeptide repeat protein 37', NULL, NULL, NULL, NULL, NULL, 4),
(162729, NULL, 'G3DSA:2.30.30.40:FF:000194', NULL, NULL, 'SH3 and PX domains 2A', NULL, NULL, NULL, NULL, NULL, 4),
(162730, NULL, 'G3DSA:3.30.160.60:FF:003308', NULL, NULL, 'Zinc finger protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(162731, NULL, 'G3DSA:3.100.10.10:FF:000018', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(162732, NULL, 'G3DSA:1.25.40.10:FF:004157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162733, NULL, 'G3DSA:1.25.10.10:FF:000277', NULL, NULL, 'AP-3 complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(162734, NULL, 'G3DSA:3.40.5.50:FF:000001', NULL, NULL, 'DNA replication complex GINS protein PSF2', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(162735, NULL, 'G3DSA:3.30.540.10:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162736, NULL, 'G3DSA:3.30.70.270:FF:000136', NULL, NULL, 'Diguanylate cyclase or phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(162737, NULL, 'G3DSA:2.120.10.80:FF:000380', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(162738, NULL, 'G3DSA:2.60.40.640:FF:000076', NULL, NULL, 'Arrestin domain-containing protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(162739, NULL, 'G3DSA:3.30.70.60:FF:000014', NULL, NULL, '28S ribosomal protein S6, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(162740, NULL, 'G3DSA:3.80.10.10:FF:001915', NULL, NULL, 'Lysine (K)-specific demethylase 2B', NULL, NULL, NULL, NULL, NULL, 4),
(162741, NULL, 'G3DSA:3.80.10.10:FF:001573', NULL, NULL, 'Leucine-rich repeats and immunoglobulin-like domains protein sma-10', NULL, NULL, NULL, NULL, NULL, 4),
(162742, NULL, 'G3DSA:3.90.20.20:FF:000013', NULL, NULL, 'GrpE protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(162743, NULL, 'G3DSA:3.40.630.10:FF:000377', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162744, NULL, 'G3DSA:1.10.238.10:FF:001031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162745, NULL, 'G3DSA:1.25.40.20:FF:000888', NULL, NULL, 'Zgc:77223 protein', NULL, NULL, NULL, NULL, NULL, 4),
(162746, NULL, 'G3DSA:3.30.750.24:FF:000126', NULL, NULL, 'Sulfate permease', NULL, NULL, NULL, NULL, NULL, 4),
(162747, NULL, 'G3DSA:3.30.40.10:FF:002330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162748, NULL, 'G3DSA:1.25.40.20:FF:001506', NULL, NULL, 'Ankyrin repeat and SOCS box-containing 2b', NULL, NULL, NULL, NULL, NULL, 4),
(162749, NULL, 'G3DSA:1.20.58.60:FF:000445', NULL, NULL, 'AGAP009554-PA', NULL, NULL, NULL, NULL, NULL, 4),
(162750, NULL, 'G3DSA:3.40.20.10:FF:000102', NULL, NULL, 'VILL isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(162751, NULL, 'G3DSA:4.10.800.10:FF:000028', NULL, NULL, 'Thyroglobulin', NULL, NULL, NULL, NULL, NULL, 4),
(162752, NULL, 'G3DSA:3.30.70.330:FF:002762', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162753, NULL, 'G3DSA:1.10.10.520:FF:000015', NULL, NULL, 'Ubiquitin-activating enzyme E1 1', NULL, NULL, NULL, NULL, NULL, 4),
(162754, NULL, 'G3DSA:2.160.10.10:FF:000059', NULL, NULL, 'Acetyltransferase RfbO, CysE/LacA/LpxA/NodL family', NULL, NULL, NULL, NULL, NULL, 4),
(162755, NULL, 'G3DSA:3.40.50.300:FF:006895', NULL, NULL, 'Glr3264 protein', NULL, NULL, NULL, NULL, NULL, 4),
(162756, NULL, 'G3DSA:3.40.50.12470:FF:000011', NULL, NULL, 'Oxoglutarate dehydrogenase (Succinyl-transferring), E1 component, variant 3', NULL, NULL, NULL, NULL, NULL, 4),
(162757, NULL, 'G3DSA:3.40.50.300:FF:003129', NULL, NULL, 'DEAD box ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(162758, NULL, 'G3DSA:2.30.30.100:FF:000020', NULL, NULL, 'Small nuclear ribonucleoprotein Sm D2', NULL, NULL, NULL, NULL, NULL, 4),
(162759, NULL, 'G3DSA:2.60.34.10:FF:000057', NULL, NULL, 'Hypoxia up-regulated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162760, NULL, 'G3DSA:3.40.47.10:FF:000035', NULL, NULL, '3-ketoacyl-CoA thiolase A, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(162761, NULL, 'G3DSA:3.30.710.10:FF:000470', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162762, NULL, 'G3DSA:2.60.40.2070:FF:000007', NULL, NULL, 'Usher CupA3', NULL, NULL, NULL, NULL, NULL, 4),
(162763, NULL, 'G3DSA:1.25.40.20:FF:001164', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(162764, NULL, 'G3DSA:1.25.40.10:FF:002920', NULL, NULL, 'Anaphase-promoting complex subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(162765, NULL, 'G3DSA:1.10.287.1060:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162766, NULL, 'G3DSA:3.30.428.10:FF:000050', NULL, NULL, 'CWF19-like protein mug161', NULL, NULL, NULL, NULL, NULL, 4),
(162767, NULL, 'G3DSA:3.30.70.330:FF:002543', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(162768, NULL, 'G3DSA:3.30.200.20:FF:000619', NULL, NULL, 'macrophage colony-stimulating factor 1 receptor isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(162769, NULL, 'G3DSA:3.20.130.10:FF:000001', NULL, NULL, 'Fumarate hydratase class I', NULL, NULL, NULL, NULL, NULL, 4),
(162770, NULL, 'G3DSA:3.40.366.10:FF:000010', NULL, NULL, 'Polyketide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(162771, NULL, 'G3DSA:2.60.110.10:FF:000005', NULL, NULL, 'Osmotin-like protein OSM34', NULL, NULL, NULL, NULL, NULL, 4),
(162772, NULL, 'G3DSA:3.40.50.300:FF:007171', NULL, NULL, 'Small GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162773, NULL, 'G3DSA:2.60.120.200:FF:000048', NULL, NULL, 'Calnexin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(162774, NULL, 'G3DSA:3.60.21.10:FF:000368', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(162775, NULL, 'G3DSA:3.90.226.10:FF:000163', NULL, NULL, 'Propionyl-CoA carboxylase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(162776, NULL, 'G3DSA:3.30.1010.10:FF:000017', NULL, NULL, 'Inositol kinase kinase (UvsB)', NULL, NULL, NULL, NULL, NULL, 4),
(162777, NULL, 'G3DSA:3.40.50.300:FF:004546', NULL, NULL, 'Dynein, axonemal, heavy chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(162778, NULL, 'G3DSA:1.10.3210.30:FF:000005', NULL, NULL, 'ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(162779, NULL, 'G3DSA:1.10.510.10:FF:000675', NULL, NULL, 'cyclin-dependent kinase 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(162780, NULL, 'G3DSA:2.30.30.30:FF:000078', NULL, NULL, 'Transcription termination/antitermination protein NusG', NULL, NULL, NULL, NULL, NULL, 4),
(162781, NULL, 'G3DSA:3.30.70.660:FF:000040', NULL, NULL, 'tRNA pseudouridine synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162782, NULL, 'G3DSA:4.10.60.10:FF:000076', NULL, NULL, 'Zinc knuckle domain protein (Byr3), putative (AFU_orthologue AFUA_1G07630)', NULL, NULL, NULL, NULL, NULL, 4),
(162783, NULL, 'G3DSA:1.20.140.150:FF:000019', NULL, NULL, 'Peripheral myelin protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(162784, NULL, 'G3DSA:1.50.10.130:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162785, NULL, 'G3DSA:3.30.200.20:FF:000390', NULL, NULL, 'probable LRR receptor-like serine/threonine-protein kinase RKF3', NULL, NULL, NULL, NULL, NULL, 4),
(162786, NULL, 'G3DSA:2.30.30.140:FF:000003', NULL, NULL, 'Protein kinase C-binding protein 1 isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(162787, NULL, 'G3DSA:3.40.50.12780:FF:000109', NULL, NULL, 'Probable non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(162788, NULL, 'G3DSA:1.25.40.10:FF:004376', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162789, NULL, 'G3DSA:1.10.400.10:FF:000009', NULL, NULL, 'Guanine nucleotide-binding protein G(O) subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(162790, NULL, 'G3DSA:3.90.1170.50:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162791, NULL, 'G3DSA:3.30.710.10:FF:000138', NULL, NULL, 'Fruitless, isoform N', NULL, NULL, NULL, NULL, NULL, 4),
(162792, NULL, 'G3DSA:2.40.50.100:FF:000078', NULL, NULL, 'Exosome complex component CSL4', NULL, NULL, NULL, NULL, NULL, 4),
(162793, NULL, 'G3DSA:1.20.930.40:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162794, NULL, 'G3DSA:1.20.1060.10:FF:000007', NULL, NULL, 'DNA-directed DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(162795, NULL, 'G3DSA:3.40.50.2300:FF:000261', NULL, NULL, 'glutamate receptor 4 isoform X7', NULL, NULL, NULL, NULL, NULL, 4),
(162796, NULL, 'G3DSA:2.30.30.830:FF:000002', NULL, NULL, 'Fimbrial assembly protein PilP', NULL, NULL, NULL, NULL, NULL, 4),
(162797, NULL, 'G3DSA:2.60.120.200:FF:000380', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162798, NULL, 'G3DSA:2.30.29.30:FF:000120', NULL, NULL, 'rho GTPase-activating protein 22 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(162799, NULL, 'G3DSA:3.50.50.60:FF:000630', NULL, NULL, 'FAD-dependent pyridine nucleotide-disulphide oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(162800, NULL, 'G3DSA:2.60.40.2030:FF:000024', NULL, NULL, 'sodium/calcium exchanger 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(162801, NULL, 'G3DSA:3.40.190.10:FF:000461', NULL, NULL, 'GM24642', NULL, NULL, NULL, NULL, NULL, 4),
(162802, NULL, 'G3DSA:1.20.120.230:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162803, NULL, 'G3DSA:3.10.20.90:FF:000684', NULL, NULL, 'Ubiquitin-60S ribosomal protein L40', NULL, NULL, NULL, NULL, NULL, 4),
(162804, NULL, 'G3DSA:2.40.50.770:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162805, NULL, 'G3DSA:3.40.630.10:FF:000158', NULL, NULL, 'Peptide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(162806, NULL, 'G3DSA:1.20.58.1080:FF:000012', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(162807, NULL, 'G3DSA:1.10.287.130:FF:000224', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(162808, NULL, 'G3DSA:1.25.10.10:FF:000951', NULL, NULL, 'Anaphase-promoting complex subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162809, NULL, 'G3DSA:3.30.160.60:FF:004944', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162810, NULL, 'G3DSA:3.40.50.620:FF:000128', NULL, NULL, 'Isoleucyl-tRNA synthetase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(162811, NULL, 'G3DSA:3.40.50.1820:FF:000094', NULL, NULL, 'Homoserine O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(162812, NULL, 'G3DSA:1.10.238.10:FF:000755', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162813, NULL, 'G3DSA:3.40.250.10:FF:000050', NULL, NULL, 'Dual specificity phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162814, NULL, 'G3DSA:3.30.559.10:FF:000128', NULL, NULL, 'Ferricrocin synthetase (Nonribosomal peptide siderophore synthase ) (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(162815, NULL, 'G3DSA:1.10.287.70:FF:000026', NULL, NULL, 'Voltage-dependent R-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(162816, NULL, 'G3DSA:3.40.50.720:FF:000720', NULL, NULL, 'Carbonyl reductase, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(162817, NULL, 'G3DSA:1.25.40.10:FF:000666', NULL, NULL, 'DNA repair and transcription protein (Xab2)', NULL, NULL, NULL, NULL, NULL, 4),
(162818, NULL, 'G3DSA:3.30.200.20:FF:000058', NULL, NULL, 'Putative serine/threonine-protein kinase N2', NULL, NULL, NULL, NULL, NULL, 4),
(162819, NULL, 'G3DSA:3.40.50.1820:FF:001853', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162820, NULL, 'G3DSA:3.30.70.2760:FF:000002', NULL, NULL, 'SAM and HD domain-containing deoxynucleoside triphosphate triphosphohydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(162821, NULL, 'G3DSA:3.90.79.10:FF:000281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162822, NULL, 'G3DSA:3.30.160.20:FF:000110', NULL, NULL, '30S ribosomal protein S5', NULL, NULL, NULL, NULL, NULL, 4),
(162823, NULL, 'G3DSA:1.20.1540.10:FF:000033', NULL, NULL, 'Rhomboid family membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(162824, NULL, 'G3DSA:1.25.40.20:FF:000669', NULL, NULL, 'SPRY domain/Ankyrin repeats (3 copies), putative', NULL, NULL, NULL, NULL, NULL, 4),
(162825, NULL, 'G3DSA:3.40.190.10:FF:000803', NULL, NULL, 'Excitatory amino acid transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162826, NULL, 'G3DSA:1.20.58.1780:FF:000014', NULL, NULL, 'Nucleoporin NUP170, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162827, NULL, 'G3DSA:3.30.160.60:FF:005220', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162828, NULL, 'G3DSA:2.40.30.170:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162829, NULL, 'G3DSA:2.60.40.10:FF:003314', NULL, NULL, 'Contactin rig-6', NULL, NULL, NULL, NULL, NULL, 4),
(162830, NULL, 'G3DSA:3.80.10.10:FF:000156', NULL, NULL, 'volume-regulated anion channel subunit LRRC8C isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(162831, NULL, 'G3DSA:3.30.200.20:FF:000951', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(162832, NULL, 'G3DSA:3.90.70.10:FF:000755', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162833, NULL, 'G3DSA:3.30.710.10:FF:000239', NULL, NULL, 'Potassium voltage-gated channel, shaker-related subfamily, member 7', NULL, NULL, NULL, NULL, NULL, 4),
(162834, NULL, 'G3DSA:1.10.600.10:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162835, NULL, 'G3DSA:1.10.1070.11:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162836, NULL, 'G3DSA:1.20.120.1810:FF:000003', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(162837, NULL, 'G3DSA:2.60.40.60:FF:001036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162838, NULL, 'G3DSA:3.40.1050.10:FF:000034', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(162839, NULL, 'G3DSA:3.40.50.80:FF:000035', NULL, NULL, 'FRE4p Ferric reductase', NULL, NULL, NULL, NULL, NULL, 4),
(162840, NULL, 'G3DSA:1.10.560.10:FF:000032', NULL, NULL, 'HSPD1 isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(162841, NULL, 'G3DSA:1.10.10.60:FF:000139', NULL, NULL, 'cyclin-D-binding Myb-like transcription factor 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(162842, NULL, 'G3DSA:3.40.50.150:FF:001578', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162843, NULL, 'G3DSA:3.30.1640.10:FF:000071', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(162844, NULL, 'G3DSA:1.10.8.60:FF:000571', NULL, NULL, 'Os05g0376200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(162845, NULL, 'G3DSA:3.30.40.10:FF:000290', NULL, NULL, 'probable E3 ubiquitin-protein ligase TRIM8', NULL, NULL, NULL, NULL, NULL, 4),
(162846, NULL, 'G3DSA:1.25.40.10:FF:000857', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(162847, NULL, 'G3DSA:2.40.10.230:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162848, NULL, 'G3DSA:3.40.190.290:FF:000003', NULL, NULL, 'HTH-type transcriptional activator AaeR', NULL, NULL, NULL, NULL, NULL, 4),
(162849, NULL, 'G3DSA:2.10.25.10:FF:001820', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162850, NULL, 'G3DSA:3.40.1000.50:FF:000015', NULL, NULL, 'Repressor of RNA polymerase III transcription MAF1', NULL, NULL, NULL, NULL, NULL, 4),
(162851, NULL, 'G3DSA:4.10.280.110:FF:000004', NULL, NULL, 'U4/U6 small nuclear ribonucleoprotein PRP4-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(162852, NULL, 'G3DSA:3.90.1170.40:FF:000001', NULL, NULL, 'Molybdopterin synthase catalytic subunit MoaE', NULL, NULL, NULL, NULL, NULL, 4),
(162853, NULL, 'G3DSA:1.20.810.10:FF:000021', NULL, NULL, 'Cytochrome b/b6 complex, cytochrome b subunit', NULL, NULL, NULL, NULL, NULL, 4),
(162854, NULL, 'G3DSA:2.102.10.10:FF:000068', NULL, NULL, 'Gll0366 protein', NULL, NULL, NULL, NULL, NULL, 4),
(162855, NULL, 'G3DSA:3.40.50.300:FF:002601', NULL, NULL, 'Ras-related protein R-Ras2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162856, NULL, 'G3DSA:3.80.10.10:FF:001218', NULL, NULL, 'Leucine rich repeat containing 15', NULL, NULL, NULL, NULL, NULL, 4),
(162857, NULL, 'G3DSA:3.40.20.10:FF:000086', NULL, NULL, 'Actin-binding protein, cofilin/tropomyosin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(162858, NULL, 'G3DSA:3.30.160.60:FF:004276', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162859, NULL, 'G3DSA:1.50.10.10:FF:000145', NULL, NULL, 'Neutral/alkaline invertase 5', NULL, NULL, NULL, NULL, NULL, 4),
(162860, NULL, 'G3DSA:1.10.246.130:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162861, NULL, 'G3DSA:1.10.510.10:FF:002119', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(162862, NULL, 'G3DSA:2.30.29.30:FF:000945', NULL, NULL, 'Sca1 complex protein phr', NULL, NULL, NULL, NULL, NULL, 4),
(162863, NULL, 'G3DSA:3.60.20.30:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162864, NULL, 'G3DSA:3.40.1410.10:FF:000017', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(162865, NULL, 'G3DSA:1.10.150.50:FF:000063', NULL, NULL, 'ETS-related transcription factor Elf-3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(162866, NULL, 'G3DSA:2.40.30.10:FF:000510', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162867, NULL, 'G3DSA:3.20.20.60:FF:000011', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(162868, NULL, 'G3DSA:1.10.640.10:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162869, NULL, 'G3DSA:3.40.50.1000:FF:000157', NULL, NULL, 'HAD phosphatase, family IIIA', NULL, NULL, NULL, NULL, NULL, 4),
(162870, NULL, 'G3DSA:3.20.20.210:FF:000015', NULL, NULL, 'Uroporphyrinogen decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(162871, NULL, 'G3DSA:3.20.20.80:FF:000017', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(162872, NULL, 'G3DSA:3.30.590.50:FF:000022', NULL, NULL, 'Glutamate-cysteine ligase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(162873, NULL, 'G3DSA:1.20.1280.20:FF:000021', NULL, NULL, 'Chaperone protein dnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(162874, NULL, 'G3DSA:3.10.20.90:FF:000807', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162875, NULL, 'G3DSA:3.90.550.10:FF:000073', NULL, NULL, 'UTP--glucose-1-phosphate uridylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(162876, NULL, 'G3DSA:3.40.50.300:FF:008380', NULL, NULL, 'Zinc finger, NFX1-type-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(162877, NULL, 'G3DSA:4.10.70.10:FF:000003', NULL, NULL, 'Disintegrin and metalloproteinase domain-containing protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(162878, NULL, 'G3DSA:3.40.50.620:FF:000342', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(162879, NULL, 'G3DSA:3.90.226.10:FF:000067', NULL, NULL, 'ATP-dependent Clp protease proteolytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(162880, NULL, 'G3DSA:3.60.10.10:FF:000039', NULL, NULL, '72 kDa inositol polyphosphate 5-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(162881, NULL, 'G3DSA:3.30.200.20:FF:002222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162882, NULL, 'G3DSA:1.10.20.10:FF:000322', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162883, NULL, 'G3DSA:2.60.120.920:FF:000051', NULL, NULL, 'Fibronectin type III and SPRY domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(162884, NULL, 'G3DSA:3.40.50.10230:FF:000002', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(162885, NULL, 'G3DSA:1.10.10.60:FF:001128', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162886, NULL, 'G3DSA:3.10.100.10:FF:000254', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162887, NULL, 'G3DSA:2.130.10.10:FF:005001', NULL, NULL, 'Angio-associated migratory protein', NULL, NULL, NULL, NULL, NULL, 4),
(162888, NULL, 'G3DSA:3.30.160.60:FF:005265', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162889, NULL, 'G3DSA:2.60.40.10:FF:004360', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162890, NULL, 'G3DSA:3.30.1440.10:FF:000004', NULL, NULL, '60S ribosomal protein L11, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162891, NULL, 'G3DSA:1.10.472.80:FF:000016', NULL, NULL, 'TBC1 domain family, member 9', NULL, NULL, NULL, NULL, NULL, 4),
(162892, NULL, 'G3DSA:2.60.120.620:FF:000112', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(162893, NULL, 'G3DSA:3.90.1290.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162894, NULL, 'G3DSA:1.25.40.660:FF:000013', NULL, NULL, 'Vacuolar protein sorting 35', NULL, NULL, NULL, NULL, NULL, 4),
(162895, NULL, 'G3DSA:3.40.1190.10:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162896, NULL, 'G3DSA:3.40.50.300:FF:007805', NULL, NULL, 'Translational initiation factor IF2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162897, NULL, 'G3DSA:1.20.5.170:FF:000230', NULL, NULL, 'Putative basic region leucine zipper transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(162898, NULL, 'G3DSA:3.30.70.330:FF:000997', NULL, NULL, 'U4/U6 snRNP-associated protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(162899, NULL, 'G3DSA:1.10.220.10:FF:000074', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(162900, NULL, 'G3DSA:3.30.70.100:FF:000102', NULL, NULL, 'Cadmium, zinc and cobalt-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(162901, NULL, 'G3DSA:3.40.50.300:FF:005827', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(162902, NULL, 'G3DSA:3.50.50.60:FF:000208', NULL, NULL, '3-ketosteroid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(162903, NULL, 'G3DSA:2.160.20.10:FF:000144', NULL, NULL, 'Probable polygalacturonase At2g43860', NULL, NULL, NULL, NULL, NULL, 4),
(162904, NULL, 'G3DSA:2.40.50.140:FF:000067', NULL, NULL, '26S protease regulatory subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(162905, NULL, 'G3DSA:3.40.30.10:FF:000704', NULL, NULL, 'Predicted gene 6665', NULL, NULL, NULL, NULL, NULL, 4),
(162906, NULL, 'G3DSA:3.30.160.60:FF:003820', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162907, NULL, 'G3DSA:3.90.70.10:FF:000536', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162908, NULL, 'G3DSA:3.40.50.720:FF:001535', NULL, NULL, 'AGAP002484-PA', NULL, NULL, NULL, NULL, NULL, 4),
(162909, NULL, 'G3DSA:1.10.10.10:FF:000557', NULL, NULL, 'Rrf2 family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(162910, NULL, 'G3DSA:1.10.10.540:FF:000004', NULL, NULL, 'UV excision repair protein Rad23', NULL, NULL, NULL, NULL, NULL, 4),
(162911, NULL, 'G3DSA:1.20.1070.10:FF:000890', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(162912, NULL, 'G3DSA:2.60.40.10:FF:000465', NULL, NULL, 'Granulocyte colony-stimulating factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(162913, NULL, 'G3DSA:1.10.420.10:FF:000022', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(162914, NULL, 'G3DSA:3.30.1520.10:FF:000005', NULL, NULL, 'SH3 and PX domain-containing protein 2B', NULL, NULL, NULL, NULL, NULL, 4),
(162915, NULL, 'G3DSA:1.10.555.10:FF:000082', NULL, NULL, 'Rho GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162916, NULL, 'G3DSA:3.30.1240.10:FF:000023', NULL, NULL, 'Haloacid dehalogenase-like hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(162917, NULL, 'G3DSA:3.30.70.330:FF:002942', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162918, NULL, 'G3DSA:3.30.1600.10:FF:000006', NULL, NULL, 'SIR2 family histone deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(162919, NULL, 'G3DSA:3.80.10.10:FF:000229', NULL, NULL, 'F-box only protein 41', NULL, NULL, NULL, NULL, NULL, 4),
(162920, NULL, 'G3DSA:3.10.580.10:FF:000222', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(162921, NULL, 'G3DSA:3.20.20.80:FF:000489', NULL, NULL, 'Glycoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(162922, NULL, 'G3DSA:3.30.70.330:FF:001514', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162923, NULL, 'G3DSA:2.130.10.10:FF:001139', NULL, NULL, 'DIP2p Nucleolar protein', NULL, NULL, NULL, NULL, NULL, 4),
(162924, NULL, 'G3DSA:3.30.200.20:FF:000277', NULL, NULL, 'serine/threonine-protein kinase greatwall isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(162925, NULL, 'G3DSA:1.20.1740.10:FF:000211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162926, NULL, 'G3DSA:2.130.10.10:FF:002567', NULL, NULL, 'Elongator complex protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(162927, NULL, 'G3DSA:1.25.40.180:FF:000111', NULL, NULL, 'Sugar 1-phosphate guanyl transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162928, NULL, 'G3DSA:3.90.1410.10:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162929, NULL, 'G3DSA:3.30.160.60:FF:000914', NULL, NULL, 'Zinc finger protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(162930, NULL, 'G3DSA:3.40.50.2300:FF:000620', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(162931, NULL, 'G3DSA:2.130.10.10:FF:004012', NULL, NULL, 'WD repeat-containing protein 76', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(162932, NULL, 'G3DSA:3.30.60.20:FF:000030', NULL, NULL, 'Chimaerin', NULL, NULL, NULL, NULL, NULL, 4),
(162933, NULL, 'G3DSA:1.50.10.130:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162934, NULL, 'G3DSA:3.80.10.10:FF:000881', NULL, NULL, 'Toll-like receptor 21', NULL, NULL, NULL, NULL, NULL, 4),
(162935, NULL, 'G3DSA:2.20.25.530:FF:000011', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(162936, NULL, 'G3DSA:3.30.160.690:FF:000001', NULL, NULL, 'CP4-57 prophage RNase LS', NULL, NULL, NULL, NULL, NULL, 4),
(162937, NULL, 'G3DSA:1.10.3380.30:FF:000040', NULL, NULL, 'DEAD-box family ATP dependent helicase', NULL, NULL, NULL, NULL, NULL, 4),
(162938, NULL, 'G3DSA:2.30.29.30:FF:001081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162939, NULL, 'G3DSA:2.30.30.100:FF:000059', NULL, NULL, 'Small nuclear ribonucleoprotein E', NULL, NULL, NULL, NULL, NULL, 4),
(162940, NULL, 'G3DSA:1.50.10.20:FF:000002', NULL, NULL, 'Terpene cyclase/mutase family member', NULL, NULL, NULL, NULL, NULL, 4),
(162941, NULL, 'G3DSA:1.10.287.470:FF:000096', NULL, NULL, 'Sll0180 protein', NULL, NULL, NULL, NULL, NULL, 4),
(162942, NULL, 'G3DSA:3.40.1380.20:FF:000056', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(162943, NULL, 'G3DSA:3.40.50.300:FF:002281', NULL, NULL, 'DNA repair helicase rad3/xp-D, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162944, NULL, 'G3DSA:3.40.50.1400:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162945, NULL, 'G3DSA:2.60.120.260:FF:000100', NULL, NULL, 'von Willebrand factor D and EGF domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(162946, NULL, 'G3DSA:3.40.50.300:FF:001645', NULL, NULL, 'ABC transporter I family member 11 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(162947, NULL, 'G3DSA:1.10.238.10:FF:000221', NULL, NULL, 'Protein S100-A14 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(162948, NULL, 'G3DSA:2.10.110.10:FF:000146', NULL, NULL, 'ALP/Enigma encoding', NULL, NULL, NULL, NULL, NULL, 4),
(162949, NULL, 'G3DSA:3.20.20.70:FF:000340', NULL, NULL, 'IMP dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(162950, NULL, 'G3DSA:3.20.20.140:FF:000146', NULL, NULL, 'AMP deaminase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(162951, NULL, 'G3DSA:2.40.128.20:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162952, NULL, 'G3DSA:3.30.40.10:FF:002088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162953, NULL, 'G3DSA:2.60.40.1080:FF:000014', NULL, NULL, 'Nucleoporin 210 like', NULL, NULL, NULL, NULL, NULL, 4),
(162954, NULL, 'G3DSA:3.40.50.10190:FF:000029', NULL, NULL, 'DNA topoisomerase II binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(162955, NULL, 'G3DSA:2.60.40.10:FF:000818', NULL, NULL, 'Interleukin 5 receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(162956, NULL, 'G3DSA:4.10.400.10:FF:000200', NULL, NULL, 'Uncharacterized protein, isoform AB', NULL, NULL, NULL, NULL, NULL, 4),
(162957, NULL, 'G3DSA:3.30.860.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162958, NULL, 'G3DSA:2.40.50.90:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162959, NULL, 'G3DSA:3.40.50.2000:FF:001137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162960, NULL, 'G3DSA:3.40.50.300:FF:001292', NULL, NULL, 'NLR family CARD domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(162961, NULL, 'G3DSA:3.40.50.2300:FF:001076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162962, NULL, 'G3DSA:1.25.20.10:FF:000002', NULL, NULL, 'Soluble lytic murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(162963, NULL, 'G3DSA:2.60.120.260:FF:000572', NULL, NULL, 'Cry21a', NULL, NULL, NULL, NULL, NULL, 4),
(162964, NULL, 'G3DSA:3.40.50.1010:FF:000014', NULL, NULL, 'telomerase-binding protein EST1A isoform X1', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(162965, NULL, 'G3DSA:3.40.50.12470:FF:000005', NULL, NULL, 'probable 2-oxoglutarate dehydrogenase E1 component DHKTD1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(162966, NULL, 'G3DSA:1.20.1070.10:FF:001727', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162967, NULL, 'G3DSA:1.20.1510.10:FF:000082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162968, NULL, 'G3DSA:3.30.420.110:FF:000028', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(162969, NULL, 'G3DSA:3.30.160.60:FF:000094', NULL, NULL, 'Zinc finger protein 605', NULL, NULL, NULL, NULL, NULL, 4),
(162970, NULL, 'G3DSA:3.10.20.30:FF:000104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162971, NULL, 'G3DSA:1.10.510.10:FF:000321', NULL, NULL, 'Bent, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(162972, NULL, 'G3DSA:1.10.510.10:FF:003547', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162973, NULL, 'G3DSA:3.40.50.2000:FF:000148', NULL, NULL, 'Phosphatidylinositol N-acetylglucosaminyltransferase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(162974, NULL, 'G3DSA:3.10.20.90:FF:000487', NULL, NULL, 'Tubulin-specific chaperone E', NULL, NULL, NULL, NULL, NULL, 4),
(162975, NULL, 'G3DSA:1.20.5.4130:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162976, NULL, 'G3DSA:3.40.140.10:FF:000132', NULL, NULL, 'PSMD14 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(162977, NULL, 'G3DSA:1.10.510.10:FF:004036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(162978, NULL, 'G3DSA:1.20.58.390:FF:000065', NULL, NULL, 'GABA-gated ion channel', NULL, NULL, NULL, NULL, NULL, 4),
(162979, NULL, 'G3DSA:1.25.40.10:FF:001846', NULL, NULL, 'Regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(162980, NULL, 'G3DSA:1.25.10.10:FF:001665', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162981, NULL, 'G3DSA:1.25.40.20:FF:001703', NULL, NULL, 'Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(162982, NULL, 'G3DSA:3.40.50.1820:FF:001651', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162983, NULL, 'G3DSA:1.25.10.10:FF:002154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162984, NULL, 'G3DSA:2.30.29.30:FF:000092', NULL, NULL, 'Connector enhancer of kinase suppressor of Ras 2', NULL, NULL, NULL, NULL, NULL, 4),
(162985, NULL, 'G3DSA:1.10.630.10:FF:000740', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162986, NULL, 'G3DSA:1.20.1250.20:FF:000665', NULL, NULL, 'Solute carrier family 22 member 18', NULL, NULL, NULL, NULL, NULL, 4),
(162987, NULL, 'G3DSA:2.30.30.870:FF:000003', NULL, NULL, 'Protein pelota homolog', NULL, NULL, NULL, NULL, NULL, 4),
(162988, NULL, 'G3DSA:2.40.30.10:FF:000190', NULL, NULL, 'Putative translation initiation factor IF-2', NULL, NULL, NULL, NULL, NULL, 4),
(162989, NULL, 'G3DSA:3.30.450.40:FF:000155', NULL, NULL, 'Bacteriophytochrome protein', NULL, NULL, NULL, NULL, NULL, 4),
(162990, NULL, 'G3DSA:3.90.190.10:FF:000410', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(162991, NULL, 'G3DSA:1.10.510.10:FF:001310', NULL, NULL, 'Putative serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(162992, NULL, 'G3DSA:4.10.320.10:FF:000019', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(162993, NULL, 'G3DSA:2.130.10.10:FF:005473', NULL, NULL, 'WD-40 repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(162994, NULL, 'G3DSA:3.40.50.140:FF:000001', NULL, NULL, 'DNA topoisomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(162995, NULL, 'G3DSA:1.20.120.1240:FF:000079', NULL, NULL, 'Myxovirus (influenza virus) resistance G', NULL, NULL, NULL, NULL, NULL, 4),
(162996, NULL, 'G3DSA:2.40.270.10:FF:000004', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(162997, NULL, 'G3DSA:2.10.25.10:FF:000864', NULL, NULL, 'Y-linked cadherin EGF LAG seven-pass G-type receptor 2', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(162998, NULL, 'G3DSA:3.30.160.60:FF:001403', NULL, NULL, 'Zinc finger with KRAB and SCAN domains 8', NULL, NULL, NULL, NULL, NULL, 4),
(162999, NULL, 'G3DSA:3.40.50.2000:FF:000648', NULL, NULL, 'UDP-glycosyltransferase 88A1', NULL, NULL, NULL, NULL, NULL, 4),
(163000, NULL, 'G3DSA:3.30.40.10:FF:001599', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163001, NULL, 'G3DSA:2.20.70.10:FF:000266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163002, NULL, 'G3DSA:3.40.720.10:FF:000159', NULL, NULL, 'Arylsulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(163003, NULL, 'G3DSA:1.10.472.10:FF:000248', NULL, NULL, 'Plant-specific TFIIB-related protein PTF2', NULL, NULL, NULL, NULL, NULL, 4),
(163004, NULL, 'G3DSA:3.40.228.10:FF:000015', NULL, NULL, 'Thiosulfate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(163005, NULL, 'G3DSA:3.30.450.50:FF:000012', NULL, NULL, 'vesicle-trafficking protein SEC22c isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(163006, NULL, 'G3DSA:1.10.10.10:FF:001485', NULL, NULL, 'Selenocysteine-specific translation elongation factor SelB', NULL, NULL, NULL, NULL, NULL, 4),
(163007, NULL, 'G3DSA:1.20.58.60:FF:000092', NULL, NULL, 'microtubule-actin cross-linking factor 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(163008, NULL, 'G3DSA:3.50.50.60:FF:001136', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(163009, NULL, 'G3DSA:2.40.70.10:FF:000456', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163010, NULL, 'G3DSA:2.120.10.30:FF:000005', NULL, NULL, 'Teneurin transmembrane protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(163011, NULL, 'G3DSA:2.40.50.140:FF:001056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163012, NULL, 'G3DSA:3.40.640.10:FF:000097', NULL, NULL, 'Serine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(163013, NULL, 'G3DSA:3.40.390.10:FF:000296', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163014, NULL, 'G3DSA:3.40.50.2300:FF:001137', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163015, NULL, 'G3DSA:1.20.1250.20:FF:001621', NULL, NULL, 'Transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(163016, NULL, 'G3DSA:2.130.10.10:FF:004984', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163017, NULL, 'G3DSA:2.60.40.10:FF:001454', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(163018, NULL, 'G3DSA:2.40.10.10:FF:000008', NULL, NULL, 'Cationic trypsin', NULL, NULL, NULL, NULL, NULL, 4),
(163019, NULL, 'G3DSA:1.10.630.10:FF:000268', NULL, NULL, 'Cytochrome P-450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163020, NULL, 'G3DSA:2.60.40.3210:FF:000024', NULL, NULL, 'Endoglin', NULL, NULL, NULL, NULL, NULL, 4),
(163021, NULL, 'G3DSA:3.30.1740.10:FF:000016', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(163022, NULL, 'G3DSA:1.10.10.10:FF:001546', NULL, NULL, 'YALI0A02200p', NULL, NULL, NULL, NULL, NULL, 4),
(163023, NULL, 'G3DSA:3.40.50.300:FF:000656', NULL, NULL, 'Leucine-rich repeat serine/threonine-protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(163024, NULL, 'G3DSA:2.60.40.3510:FF:000024', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(163025, NULL, 'G3DSA:3.30.70.330:FF:001953', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163026, NULL, 'G3DSA:3.90.1150.10:FF:000042', NULL, NULL, 'Histidinol-phosphate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(163027, NULL, 'G3DSA:3.60.10.10:FF:000191', NULL, NULL, 'RNA exonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163028, NULL, 'G3DSA:2.130.10.10:FF:001578', NULL, NULL, 'Protein SEC13 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(163029, NULL, 'G3DSA:3.30.200.20:FF:001266', NULL, NULL, 'Kinase', NULL, NULL, NULL, NULL, NULL, 4),
(163030, NULL, 'G3DSA:3.40.720.10:FF:000098', NULL, NULL, 'Arylsulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(163031, NULL, 'G3DSA:3.40.50.1100:FF:000041', NULL, NULL, 'Threonine ammonia-lyase, variant', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(163032, NULL, 'G3DSA:3.30.530.20:FF:000150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163033, NULL, 'G3DSA:1.25.40.10:FF:000065', NULL, NULL, 'Programmed cell death 11', NULL, NULL, NULL, NULL, NULL, 4),
(163034, NULL, 'G3DSA:3.30.30.30:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163035, NULL, 'G3DSA:3.90.79.10:FF:000117', NULL, NULL, 'Protein CBG19301', NULL, NULL, NULL, NULL, NULL, 4),
(163036, NULL, 'G3DSA:3.60.21.10:FF:000328', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163037, NULL, 'G3DSA:3.40.50.720:FF:000546', NULL, NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(163038, NULL, 'G3DSA:3.40.50.450:FF:000089', NULL, NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(163039, NULL, 'G3DSA:3.10.129.10:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163040, NULL, 'G3DSA:1.25.40.10:FF:001785', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At3g01580', NULL, NULL, NULL, NULL, NULL, 4),
(163041, NULL, 'G3DSA:1.10.10.10:FF:000057', NULL, NULL, 'Heat shock transcription factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(163042, NULL, 'G3DSA:3.10.310.10:FF:000028', NULL, NULL, 'Probable phenazine biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(163043, NULL, 'G3DSA:3.30.230.10:FF:000276', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(163044, NULL, 'G3DSA:1.10.630.10:FF:000801', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163045, NULL, 'G3DSA:1.10.238.10:FF:001177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163046, NULL, 'G3DSA:2.60.120.10:FF:000478', NULL, NULL, 'Cysteine dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(163047, NULL, 'G3DSA:3.40.50.1820:FF:000695', NULL, NULL, 'Type IV secretory pathway, VirJ component', NULL, NULL, NULL, NULL, NULL, 4),
(163048, NULL, 'G3DSA:3.10.180.10:FF:000113', NULL, NULL, '4-hydroxyphenylpyruvate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(163049, NULL, 'G3DSA:3.40.33.10:FF:000065', NULL, NULL, 'Predicted extracellular protein', NULL, NULL, NULL, NULL, NULL, 4),
(163050, NULL, 'G3DSA:1.20.1250.20:FF:002110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163051, NULL, 'G3DSA:1.10.418.10:FF:000106', NULL, NULL, 'Scp1p', NULL, NULL, NULL, NULL, NULL, 4),
(163052, NULL, 'G3DSA:2.60.40.60:FF:000108', NULL, NULL, 'FAT atypical cadherin 4', NULL, NULL, NULL, NULL, NULL, 4),
(163053, NULL, 'G3DSA:1.20.140.40:FF:000063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163054, NULL, 'G3DSA:3.60.21.10:FF:000267', NULL, NULL, 'UDP-sugar hydrolase 5-nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(163055, NULL, 'G3DSA:1.10.287.380:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163056, NULL, 'G3DSA:3.10.20.90:FF:001004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163057, NULL, 'G3DSA:3.40.50.10130:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163058, NULL, 'G3DSA:2.60.40.10:FF:003871', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163059, NULL, 'G3DSA:3.30.200.20:FF:000777', NULL, NULL, 'probably inactive receptor-like protein kinase At2g46850', NULL, NULL, NULL, NULL, NULL, 4),
(163060, NULL, 'G3DSA:3.80.10.10:FF:003135', NULL, NULL, 'U2 small nuclear ribonucleoprotein A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163061, NULL, 'G3DSA:1.25.10.10:FF:000176', NULL, NULL, 'Cell division control protein', NULL, NULL, NULL, NULL, NULL, 4),
(163062, NULL, 'G3DSA:3.30.70.330:FF:002442', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163063, NULL, 'G3DSA:3.30.200.20:FF:000305', NULL, NULL, 'PTI1-like tyrosine-protein kinase At3g15890', NULL, NULL, NULL, NULL, NULL, 4),
(163064, NULL, 'G3DSA:2.60.120.620:FF:000079', NULL, NULL, '2OG-Fe(II) oxygenase family protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(163065, NULL, 'G3DSA:1.10.10.60:FF:001067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163066, NULL, 'G3DSA:3.80.10.10:FF:000729', NULL, NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g34110', NULL, NULL, NULL, NULL, NULL, 4),
(163067, NULL, 'G3DSA:2.60.40.150:FF:000642', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163068, NULL, 'G3DSA:3.40.50.300:FF:002129', NULL, NULL, 'ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163069, NULL, 'G3DSA:3.30.160.60:FF:000122', NULL, NULL, 'Zinc finger protein 568', NULL, NULL, NULL, NULL, NULL, 4),
(163070, NULL, 'G3DSA:3.10.450.40:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163071, NULL, 'G3DSA:3.30.420.40:FF:000035', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(163072, NULL, 'G3DSA:1.25.40.10:FF:001346', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(163073, NULL, 'G3DSA:4.10.240.10:FF:000165', NULL, NULL, 'Znc1p', NULL, NULL, NULL, NULL, NULL, 4),
(163074, NULL, 'G3DSA:1.25.10.10:FF:002654', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163075, NULL, 'G3DSA:1.25.40.20:FF:000394', NULL, NULL, 'Arginine N-methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(163076, NULL, 'G3DSA:3.40.50.300:FF:007452', NULL, NULL, 'Helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163077, NULL, 'G3DSA:3.40.50.720:FF:001182', NULL, NULL, 'GD25538', NULL, NULL, NULL, NULL, NULL, 4),
(163078, NULL, 'G3DSA:3.30.300.30:FF:000170', NULL, NULL, 'Acyl-CoA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(163079, NULL, 'G3DSA:2.60.120.40:FF:000021', NULL, NULL, 'Tumor necrosis factor ligand superfamily member 13', NULL, NULL, NULL, NULL, NULL, 4),
(163080, NULL, 'G3DSA:1.10.555.10:FF:000143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163081, NULL, 'G3DSA:2.60.40.10:FF:003724', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163082, NULL, 'G3DSA:3.30.160.60:FF:000414', NULL, NULL, 'Zinc finger protein 398', NULL, NULL, NULL, NULL, NULL, 4),
(163083, NULL, 'G3DSA:3.10.290.10:FF:000003', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(163084, NULL, 'G3DSA:1.20.1440.170:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163085, NULL, 'G3DSA:3.90.550.50:FF:000118', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(163086, NULL, 'G3DSA:3.40.120.10:FF:000102', NULL, NULL, 'Phosphoglucomutase/phosphomannomutase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(163087, NULL, 'G3DSA:1.10.287.110:FF:000185', NULL, NULL, 'Putative heat shock protein', NULL, NULL, NULL, NULL, NULL, 4),
(163088, NULL, 'G3DSA:2.60.120.920:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163089, NULL, 'G3DSA:1.10.8.60:FF:000099', NULL, NULL, 'Replication factor C subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(163090, NULL, 'G3DSA:3.40.1110.10:FF:000152', NULL, NULL, 'Cation transporter E1-E2 family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(163091, NULL, 'G3DSA:1.10.10.1890:FF:000004', NULL, NULL, 'Spindle and kinetochore-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(163092, NULL, 'G3DSA:2.40.30.10:FF:000010', NULL, NULL, 'Translation elongation factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(163093, NULL, 'G3DSA:1.20.1560.10:FF:000646', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163094, NULL, 'G3DSA:3.40.50.300:FF:006024', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(163095, NULL, 'G3DSA:3.40.50.300:FF:003562', NULL, NULL, 'ras-related protein Rab-11A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(163096, NULL, 'G3DSA:1.25.40.10:FF:002774', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163097, NULL, 'G3DSA:1.20.1070.10:FF:001227', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163098, NULL, 'G3DSA:3.30.70.260:FF:000156', NULL, NULL, 'Ribose-5-phosphate isomerase A', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(163099, NULL, 'G3DSA:3.30.930.10:FF:000189', NULL, NULL, 'Octanoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(163100, NULL, 'G3DSA:1.20.1050.90:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163101, NULL, 'G3DSA:1.20.1730.10:FF:000093', NULL, NULL, 'High affinity choline transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163102, NULL, 'G3DSA:3.80.10.10:FF:003282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163103, NULL, 'G3DSA:1.20.5.110:FF:000139', NULL, NULL, 'Syntaxin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(163104, NULL, 'G3DSA:1.10.10.2660:FF:000011', NULL, NULL, 'Ubiquitin-activating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(163105, NULL, 'G3DSA:3.30.160.60:FF:004337', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163106, NULL, 'G3DSA:3.30.200.20:FF:001766', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(163107, NULL, 'G3DSA:3.30.160.60:FF:001875', NULL, NULL, 'pH-response transcription factor pacC/RIM101', NULL, NULL, NULL, NULL, NULL, 4),
(163108, NULL, 'G3DSA:3.30.160.390:FF:000001', NULL, NULL, 'Phage integrase', NULL, NULL, NULL, NULL, NULL, 4),
(163109, NULL, 'G3DSA:1.20.1560.10:FF:000938', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163110, NULL, 'G3DSA:3.10.350.10:FF:000093', NULL, NULL, 'Vacuolar assembly protein vps41, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163111, NULL, 'G3DSA:3.40.50.1360:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163112, NULL, 'G3DSA:3.30.70.330:FF:001453', NULL, NULL, 'Nucleic acid binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(163113, NULL, 'G3DSA:2.60.40.10:FF:002382', NULL, NULL, 'Stretchin-Mlck, isoform V', NULL, NULL, NULL, NULL, NULL, 4),
(163114, NULL, 'G3DSA:1.10.510.10:FF:002058', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163115, NULL, 'G3DSA:1.10.10.1100:FF:000021', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(163116, NULL, 'G3DSA:3.30.1120.10:FF:000076', NULL, NULL, 'LOC402795 protein', NULL, NULL, NULL, NULL, NULL, 4),
(163117, NULL, 'G3DSA:4.10.60.10:FF:000177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163118, NULL, 'G3DSA:2.130.10.10:FF:001078', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(163119, NULL, 'G3DSA:2.10.50.30:FF:000030', NULL, NULL, 'Extracellular calcium-sensing receptor', NULL, NULL, NULL, NULL, NULL, 4),
(163120, NULL, 'G3DSA:1.25.40.20:FF:001675', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163121, NULL, 'G3DSA:3.65.10.20:FF:000009', NULL, NULL, 'RNA 3''-terminal phosphate cyclase-like protein,putative', NULL, NULL, NULL, NULL, NULL, 4),
(163122, NULL, 'G3DSA:3.40.850.10:FF:000343', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(163123, NULL, 'G3DSA:1.25.40.10:FF:005236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163124, NULL, 'G3DSA:3.40.50.1950:FF:000003', NULL, NULL, 'Dipicolinate synthase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(163125, NULL, 'G3DSA:3.40.50.150:FF:001078', NULL, NULL, 'Leucine carboxyl methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(163126, NULL, 'G3DSA:3.55.10.10:FF:000001', NULL, NULL, 'protein archease isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(163127, NULL, 'G3DSA:3.40.50.300:FF:004990', NULL, NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 8', NULL, NULL, NULL, NULL, NULL, 4),
(163128, NULL, 'G3DSA:2.30.29.30:FF:000592', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163129, NULL, 'G3DSA:1.20.120.310:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163130, NULL, 'G3DSA:3.40.50.12710:FF:000033', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7', NULL, NULL, NULL, NULL, NULL, 4),
(163131, NULL, 'G3DSA:3.90.1480.20:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(163132, NULL, 'G3DSA:2.10.25.10:FF:001320', NULL, NULL, 'Laminin subunit gamma-1', NULL, NULL, NULL, NULL, NULL, 4),
(163133, NULL, 'G3DSA:3.30.160.60:FF:001583', NULL, NULL, 'UBP1-associated proteins 1C', NULL, NULL, NULL, NULL, NULL, 4),
(163134, NULL, 'G3DSA:3.30.40.10:FF:001099', NULL, NULL, 'E3 ubiquitin-protein ligase CHIP', NULL, NULL, NULL, NULL, NULL, 4),
(163135, NULL, 'G3DSA:2.40.30.10:FF:000038', NULL, NULL, 'Sulfite reductase [NADPH] flavoprotein alpha-component', NULL, NULL, NULL, NULL, NULL, 4),
(163136, NULL, 'G3DSA:3.40.50.300:FF:007744', NULL, NULL, 'Helicase', NULL, NULL, NULL, NULL, NULL, 4),
(163137, NULL, 'G3DSA:3.30.300.10:FF:000012', NULL, NULL, 'S-adenosylmethionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(163138, NULL, 'G3DSA:3.30.70.980:FF:000046', NULL, NULL, 'Probable transcriptional regulatory protein RW64_15025', NULL, NULL, NULL, NULL, NULL, 4),
(163139, NULL, 'G3DSA:2.60.40.1910:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163140, NULL, 'G3DSA:3.90.730.10:FF:000019', NULL, NULL, 'Ribonuclease T2', NULL, NULL, NULL, NULL, NULL, 4),
(163141, NULL, 'G3DSA:2.130.10.10:FF:004484', NULL, NULL, 'Target of rapamycin complex 1 subunit mip1', NULL, NULL, NULL, NULL, NULL, 4),
(163142, NULL, 'G3DSA:3.40.50.1970:FF:000009', NULL, NULL, 'Fe-containing alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(163143, NULL, 'G3DSA:3.40.850.10:FF:000051', NULL, NULL, 'Kinesin-like protein bimC', NULL, NULL, NULL, NULL, NULL, 4),
(163144, NULL, 'G3DSA:1.10.3430.10:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163145, NULL, 'G3DSA:2.130.10.10:FF:003995', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163146, NULL, 'G3DSA:3.20.20.80:FF:000809', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163147, NULL, 'G3DSA:2.60.40.630:FF:000011', NULL, NULL, 'Novel protein similar to human signal transduction and activator of transcription 4 (STAT4)', NULL, NULL, NULL, NULL, NULL, 4),
(163148, NULL, 'G3DSA:1.10.510.10:FF:000793', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(163149, NULL, 'G3DSA:1.10.510.10:FF:000613', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(163150, NULL, 'G3DSA:2.60.40.10:FF:005669', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163151, NULL, 'G3DSA:3.40.1810.10:FF:000065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163152, NULL, 'G3DSA:2.60.120.620:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163153, NULL, 'G3DSA:2.130.10.10:FF:003556', NULL, NULL, 'WD repeat domain 3', NULL, NULL, NULL, NULL, NULL, 4),
(163154, NULL, 'G3DSA:3.40.50.1820:FF:000723', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(163155, NULL, 'G3DSA:3.40.930.10:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163156, NULL, 'G3DSA:3.80.20.20:FF:000031', NULL, NULL, 'FI18055p1', NULL, NULL, NULL, NULL, NULL, 4),
(163157, NULL, 'G3DSA:1.20.58.190:FF:000005', NULL, NULL, 'Translin associated factor X', NULL, NULL, NULL, NULL, NULL, 4),
(163158, NULL, 'G3DSA:3.40.50.300:FF:005799', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163159, NULL, 'G3DSA:3.30.70.330:FF:001014', NULL, NULL, 'Homologous to Drosophila SQD (Squid) protein', NULL, NULL, NULL, NULL, NULL, 4),
(163160, NULL, 'G3DSA:3.30.930.10:FF:000430', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(163161, NULL, 'G3DSA:3.30.760.10:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163162, NULL, 'G3DSA:3.30.9.10:FF:000138', NULL, NULL, 'Pipecolic acid oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(163163, NULL, 'G3DSA:1.10.287.70:FF:000291', NULL, NULL, 'TWiK family of potassium channels', NULL, NULL, NULL, NULL, NULL, 4),
(163164, NULL, 'G3DSA:3.30.1370.110:FF:000025', NULL, NULL, 'Smr domain-containing protein C1235.03', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(163165, NULL, 'G3DSA:1.20.120.350:FF:000070', NULL, NULL, 'K+ channel tetramerization domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(163166, NULL, 'G3DSA:3.40.50.150:FF:000330', NULL, NULL, 'Trimethylguanosine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(163167, NULL, 'G3DSA:1.10.132.30:FF:000004', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(163168, NULL, 'G3DSA:3.30.1680.10:FF:000045', NULL, NULL, 'Semaphorin 7A', NULL, NULL, NULL, NULL, NULL, 4),
(163169, NULL, 'G3DSA:3.20.20.80:FF:000517', NULL, NULL, 'Putative galactocerebrosidase', NULL, NULL, NULL, NULL, NULL, 4),
(163170, NULL, 'G3DSA:2.130.10.10:FF:004192', NULL, NULL, 'IFT140', NULL, NULL, NULL, NULL, NULL, 4),
(163171, NULL, 'G3DSA:3.30.800.10:FF:000005', NULL, NULL, '1-phosphatidylinositol-3-phosphate 5-kinase (Fab1)', NULL, NULL, NULL, NULL, NULL, 4),
(163172, NULL, 'G3DSA:2.60.40.1180:FF:000218', NULL, NULL, 'Glucosidase 2 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(163173, NULL, 'G3DSA:1.10.840.10:FF:000014', NULL, NULL, 'SH2 domain containing 3A', NULL, NULL, NULL, NULL, NULL, 4),
(163174, NULL, 'G3DSA:1.20.1060.20:FF:000010', NULL, NULL, 'Structural maintenance of chromosomes protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(163175, NULL, 'G3DSA:3.10.20.90:FF:000779', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 7', NULL, NULL, NULL, NULL, NULL, 4),
(163176, NULL, 'G3DSA:1.20.120.20:FF:000022', NULL, NULL, 'Si:dkey-7f3.14', NULL, NULL, NULL, NULL, NULL, 4),
(163177, NULL, 'G3DSA:3.30.160.60:FF:005765', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163178, NULL, 'G3DSA:1.10.8.60:FF:000071', NULL, NULL, 'Cell division cycle-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(163179, NULL, 'G3DSA:1.10.10.10:FF:002002', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163180, NULL, 'G3DSA:1.10.238.10:FF:000660', NULL, NULL, 'FI14603p', NULL, NULL, NULL, NULL, NULL, 4),
(163181, NULL, 'G3DSA:3.30.720.10:FF:000004', NULL, NULL, 'Signal recognition particle 14 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(163182, NULL, 'G3DSA:2.60.15.10:FF:000013', NULL, NULL, 'ATP synthase epsilon chain', NULL, NULL, NULL, NULL, NULL, 4),
(163183, NULL, 'G3DSA:2.60.120.10:FF:000450', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(163184, NULL, 'G3DSA:2.30.30.40:FF:000547', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163185, NULL, 'G3DSA:3.30.460.90:FF:000002', NULL, NULL, 'Mitochondrial dynamics protein MID51', NULL, NULL, NULL, NULL, NULL, 4),
(163186, NULL, 'G3DSA:2.60.40.10:FF:000998', NULL, NULL, 'Immunoglobulin heavy constant epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(163187, NULL, 'G3DSA:2.30.29.30:FF:000884', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163188, NULL, 'G3DSA:3.30.1120.30:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163189, NULL, 'G3DSA:2.60.120.260:FF:000280', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(163190, NULL, 'G3DSA:1.20.1250.20:FF:001593', NULL, NULL, 'Membrane-associated transporter protein', NULL, NULL, NULL, NULL, NULL, 4),
(163191, NULL, 'G3DSA:3.30.160.60:FF:006254', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163192, NULL, 'G3DSA:1.20.1070.10:FF:000738', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163193, NULL, 'G3DSA:1.20.5.110:FF:000291', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163194, NULL, 'G3DSA:1.20.120.1750:FF:000024', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(163195, NULL, 'G3DSA:3.40.50.150:FF:001639', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163196, NULL, 'G3DSA:2.60.120.380:FF:000023', NULL, NULL, 'Kinesin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163197, NULL, 'G3DSA:2.40.50.690:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163198, NULL, 'G3DSA:2.10.25.10:FF:000572', NULL, NULL, 'Nidogen 2', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(163199, NULL, 'G3DSA:3.70.10.10:FF:000050', NULL, NULL, 'Checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(163200, NULL, 'G3DSA:3.30.160.60:FF:002331', NULL, NULL, 'Zinc finger protein 672', NULL, NULL, NULL, NULL, NULL, 4),
(163201, NULL, 'G3DSA:2.30.29.30:FF:000445', NULL, NULL, 'ephexin-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(163202, NULL, 'G3DSA:3.10.20.30:FF:000076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163203, NULL, 'G3DSA:3.80.10.10:FF:002646', NULL, NULL, 'F-box/LRR-repeat protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(163204, NULL, 'G3DSA:3.30.420.40:FF:000827', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163205, NULL, 'G3DSA:2.120.10.30:FF:000477', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163206, NULL, 'G3DSA:3.30.70.330:FF:000525', NULL, NULL, 'RNA-binding protein 8A', NULL, NULL, NULL, NULL, NULL, 4),
(163207, NULL, 'G3DSA:3.30.9.10:FF:000285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163208, NULL, 'G3DSA:2.60.40.420:FF:000066', NULL, NULL, 'Early nodulin-like protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(163209, NULL, 'G3DSA:3.30.1140.60:FF:000013', NULL, NULL, 'F-actin-capping protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(163210, NULL, 'G3DSA:3.30.70.1730:FF:000002', NULL, NULL, '60S acidic ribosomal protein P0', NULL, NULL, NULL, NULL, NULL, 4),
(163211, NULL, 'G3DSA:3.30.70.330:FF:001161', NULL, NULL, 'Peptidyl prolyl cis-trans isomerase Cyclophilin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163212, NULL, 'G3DSA:3.40.50.300:FF:004046', NULL, NULL, 'ATP-dependent DNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163213, NULL, 'G3DSA:3.40.50.410:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163214, NULL, 'G3DSA:3.40.50.1820:FF:001212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163215, NULL, 'G3DSA:1.10.760.10:FF:000013', NULL, NULL, 'Cbb3-type cytochrome c oxidase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(163216, NULL, 'G3DSA:3.10.50.40:FF:000114', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(163217, NULL, 'G3DSA:3.30.497.10:FF:000063', NULL, NULL, 'Serpin family E member 3', NULL, NULL, NULL, NULL, NULL, 4),
(163218, NULL, 'G3DSA:2.70.50.40:FF:000018', NULL, NULL, 'Unc-119 lipid binding chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(163219, NULL, 'G3DSA:3.40.718.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163220, NULL, 'G3DSA:3.10.50.10:FF:000038', NULL, NULL, 'Chitinase domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(163221, NULL, 'G3DSA:3.40.1170.60:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163222, NULL, 'G3DSA:3.30.70.360:FF:000040', NULL, NULL, 'Acetylornithine deacetylase ArgE', NULL, NULL, NULL, NULL, NULL, 4),
(163223, NULL, 'G3DSA:1.25.10.10:FF:000737', NULL, NULL, 'Splicing factor 3B subunit 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163224, NULL, 'G3DSA:2.60.40.10:FF:004208', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163225, NULL, 'G3DSA:1.10.4160.10:FF:000017', NULL, NULL, 'Permease for cytosine/purines uracil thiamine allantoin', NULL, NULL, NULL, NULL, NULL, 4),
(163226, NULL, 'G3DSA:2.60.40.10:FF:001746', NULL, NULL, 'Carbohydrate-binding-like fold', NULL, NULL, NULL, NULL, NULL, 4),
(163227, NULL, 'G3DSA:3.90.550.10:FF:000101', NULL, NULL, 'Probable glycosyltransferase 5', NULL, NULL, NULL, NULL, NULL, 4),
(163228, NULL, 'G3DSA:2.40.110.10:FF:000050', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(163229, NULL, 'G3DSA:3.30.900.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163230, NULL, 'G3DSA:2.60.120.200:FF:000661', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163231, NULL, 'G3DSA:3.40.50.300:FF:006816', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163232, NULL, 'G3DSA:1.25.40.20:FF:000214', NULL, NULL, 'No mechanoreceptor potential C, isoform D', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(163233, NULL, 'G3DSA:1.25.10.10:FF:002946', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163234, NULL, 'G3DSA:2.130.10.10:FF:005501', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163235, NULL, 'G3DSA:1.20.5.340:FF:000011', NULL, NULL, 'Stromal interaction molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(163236, NULL, 'G3DSA:3.30.40.10:FF:002116', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163237, NULL, 'G3DSA:2.30.30.490:FF:000046', NULL, NULL, 'DNA (cytosine-5)-methyltransferase 3', NULL, NULL, NULL, NULL, NULL, 4),
(163238, NULL, 'G3DSA:3.30.70.360:FF:000068', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163239, NULL, 'G3DSA:1.25.40.10:FF:001493', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163240, NULL, 'G3DSA:1.20.1070.10:FF:001374', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163241, NULL, 'G3DSA:3.40.910.10:FF:000022', NULL, NULL, 'Deoxyhypusine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(163242, NULL, 'G3DSA:3.30.160.60:FF:005618', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163243, NULL, 'G3DSA:2.60.40.10:FF:000026', NULL, NULL, 'roundabout homolog 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(163244, NULL, 'G3DSA:3.40.30.10:FF:000884', NULL, NULL, 'Ganglioside-induced differentiation-associated protein 1, 2 gdap, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163245, NULL, 'G3DSA:3.40.50.970:FF:000216', NULL, NULL, 'Pyruvate decarboxylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(163246, NULL, 'G3DSA:3.40.50.720:FF:002463', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163247, NULL, 'G3DSA:1.10.238.20:FF:000050', NULL, NULL, 'AGAP002190-PA', NULL, NULL, NULL, NULL, NULL, 4),
(163248, NULL, 'G3DSA:1.20.58.60:FF:000120', NULL, NULL, 'proto-oncogene DBL isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(163249, NULL, 'G3DSA:3.40.109.10:FF:000059', NULL, NULL, 'Nitroreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(163250, NULL, 'G3DSA:2.60.120.200:FF:000689', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163251, NULL, 'G3DSA:1.20.120.1770:FF:000002', NULL, NULL, 'Cytochrome b561 domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(163252, NULL, 'G3DSA:1.10.3210.10:FF:000016', NULL, NULL, 'HD domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(163253, NULL, 'G3DSA:3.40.50.1820:FF:001151', NULL, NULL, 'Dienelactone hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(163254, NULL, 'G3DSA:1.10.12.10:FF:000039', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(163255, NULL, 'G3DSA:3.40.50.360:FF:000067', NULL, NULL, 'Putative p450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(163256, NULL, 'G3DSA:3.10.50.40:FF:000053', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(163257, NULL, 'G3DSA:2.60.40.790:FF:000098', NULL, NULL, 'Nuclear movement protein nudc, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163258, NULL, 'G3DSA:4.10.1060.10:FF:000052', NULL, NULL, 'Npp-9', NULL, NULL, NULL, NULL, NULL, 4),
(163259, NULL, 'G3DSA:2.60.40.10:FF:002943', NULL, NULL, 'Twitchin', NULL, NULL, NULL, NULL, NULL, 4),
(163260, NULL, 'G3DSA:3.30.40.10:FF:000582', NULL, NULL, 'Transcription factor jumonji (JmjC) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(163261, NULL, 'G3DSA:3.30.830.10:FF:000125', NULL, NULL, 'Uncharacterized protein C05D11.1', NULL, NULL, NULL, NULL, NULL, 4),
(163262, NULL, 'G3DSA:1.25.10.10:FF:001726', NULL, NULL, 'Exportin-T', NULL, NULL, NULL, NULL, NULL, 4),
(163263, NULL, 'G3DSA:1.20.1070.10:FF:001166', NULL, NULL, 'AGAP002229-PA', NULL, NULL, NULL, NULL, NULL, 4),
(163264, NULL, 'G3DSA:1.20.58.1030:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163265, NULL, 'G3DSA:3.40.50.300:FF:000156', NULL, NULL, 'ATP-dependent DNA helicase recQ', NULL, NULL, NULL, NULL, NULL, 4),
(163266, NULL, 'G3DSA:3.40.50.11960:FF:000004', NULL, NULL, 'YALI0F12947p', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(163267, NULL, 'G3DSA:1.25.40.10:FF:003263', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g48250, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(163268, NULL, 'G3DSA:1.20.1410.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163269, NULL, 'G3DSA:3.30.70.660:FF:000068', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(163270, NULL, 'G3DSA:1.10.730.20:FF:000014', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(163271, NULL, 'G3DSA:1.20.1270.420:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163272, NULL, 'G3DSA:3.40.50.300:FF:005535', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163273, NULL, 'G3DSA:3.30.70.330:FF:001806', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163274, NULL, 'G3DSA:3.90.1150.190:FF:000004', NULL, NULL, 'Polycomb protein Scm', NULL, NULL, NULL, NULL, NULL, 4),
(163275, NULL, 'G3DSA:3.40.50.720:FF:000254', NULL, NULL, 'UDP-glucose 4-epimerase GalE', NULL, NULL, NULL, NULL, NULL, 4),
(163276, NULL, 'G3DSA:1.10.1520.10:FF:000034', NULL, NULL, 'Mini-ribonuclease 3', NULL, NULL, NULL, NULL, NULL, 4),
(163277, NULL, 'G3DSA:2.60.40.10:FF:003399', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163278, NULL, 'G3DSA:1.50.40.10:FF:000473', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163279, NULL, 'G3DSA:1.20.1050.10:FF:000063', NULL, NULL, 'Putative glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(163280, NULL, 'G3DSA:3.40.50.620:FF:000634', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(163281, NULL, 'G3DSA:3.30.70.330:FF:001222', NULL, NULL, 'Putative Transcriptional repressor NOT4Hp', NULL, NULL, NULL, NULL, NULL, 4),
(163282, NULL, 'G3DSA:2.60.40.10:FF:000318', NULL, NULL, 'Growth hormone receptor', NULL, NULL, NULL, NULL, NULL, 4),
(163283, NULL, 'G3DSA:3.40.630.30:FF:000546', NULL, NULL, 'Slr8037 protein', NULL, NULL, NULL, NULL, NULL, 4),
(163284, NULL, 'G3DSA:2.40.50.730:FF:000002', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(163285, NULL, 'G3DSA:1.20.5.440:FF:000007', NULL, NULL, 'ATP synthase epsilon chain', NULL, NULL, NULL, NULL, NULL, 4),
(163286, NULL, 'G3DSA:3.40.720.10:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163287, NULL, 'G3DSA:1.10.3380.10:FF:000062', NULL, NULL, 'Activating signal cointegrator 1 complex subunit 3, helc1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163288, NULL, 'G3DSA:3.10.620.30:FF:000024', NULL, NULL, 'Slr8037 protein', NULL, NULL, NULL, NULL, NULL, 4),
(163289, NULL, 'G3DSA:2.10.50.10:FF:000052', NULL, NULL, 'Cysteine repeat modular protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(163290, NULL, 'G3DSA:3.30.160.60:FF:005557', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163291, NULL, 'G3DSA:3.30.160.60:FF:004129', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163292, NULL, 'G3DSA:3.30.1360.40:FF:000046', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163293, NULL, 'G3DSA:3.10.20.90:FF:000987', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163294, NULL, 'G3DSA:1.20.58.70:FF:000010', NULL, NULL, 'Syntaxin-43', NULL, NULL, NULL, NULL, NULL, 4),
(163295, NULL, 'G3DSA:3.40.630.30:FF:000107', NULL, NULL, 'N-terminal acetyltransferase complex ARD1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(163296, NULL, 'G3DSA:1.10.1410.40:FF:000012', NULL, NULL, 'spermatid perinuclear RNA-binding protein isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(163297, NULL, 'G3DSA:3.90.70.80:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163298, NULL, 'G3DSA:2.30.29.30:FF:000653', NULL, NULL, 'Quattro', NULL, NULL, NULL, NULL, NULL, 4),
(163299, NULL, 'G3DSA:3.40.30.10:FF:000412', NULL, NULL, 'Glutaredoxin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(163300, NULL, 'G3DSA:1.10.20.10:FF:000030', NULL, NULL, 'Transcription initiation factor TFIID subunit 6', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(163301, NULL, 'G3DSA:1.20.58.60:FF:000384', NULL, NULL, 'AcTiniN', NULL, NULL, NULL, NULL, NULL, 4),
(163302, NULL, 'G3DSA:3.80.10.10:FF:002938', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163303, NULL, 'G3DSA:1.10.238.10:FF:000249', NULL, NULL, 'calcium and calcium/calmodulin-dependent serine/threonine-protein kinase DMI-3', NULL, NULL, NULL, NULL, NULL, 4),
(163304, NULL, 'G3DSA:1.10.533.10:FF:000065', NULL, NULL, 'Ectodysplasin-A receptor-associated adapter protein', NULL, NULL, NULL, NULL, NULL, 4),
(163305, NULL, 'G3DSA:3.30.40.10:FF:001571', NULL, NULL, 'Fgr3p', NULL, NULL, NULL, NULL, NULL, 4),
(163306, NULL, 'G3DSA:1.20.1300.10:FF:000009', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(163307, NULL, 'G3DSA:2.130.10.10:FF:002859', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163308, NULL, 'G3DSA:3.30.565.10:FF:000137', NULL, NULL, 'Unplaced genomic scaffold supercont1.28, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(163309, NULL, 'G3DSA:2.60.40.1230:FF:000020', NULL, NULL, 'VHS domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(163310, NULL, 'G3DSA:2.60.260.20:FF:000137', NULL, NULL, 'Chaperone protein DnaJ 2', NULL, NULL, NULL, NULL, NULL, 4),
(163311, NULL, 'G3DSA:2.40.10.10:FF:000155', NULL, NULL, 'Flocculation FLO11-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(163312, NULL, 'G3DSA:1.25.50.20:FF:000012', NULL, NULL, 'Aminopeptidase N', NULL, NULL, NULL, NULL, NULL, 4),
(163313, NULL, 'G3DSA:2.170.270.10:FF:000075', NULL, NULL, 'Histone-lysine N-methyltransferase 2D', NULL, NULL, NULL, NULL, NULL, 4),
(163314, NULL, 'G3DSA:1.20.1110.10:FF:000265', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163315, NULL, 'G3DSA:1.10.630.10:FF:000768', NULL, NULL, 'Protein CBG01387', NULL, NULL, NULL, NULL, NULL, 4),
(163316, NULL, 'G3DSA:1.10.30.50:FF:000020', NULL, NULL, 'Sll2007 protein', NULL, NULL, NULL, NULL, NULL, 4),
(163317, NULL, 'G3DSA:3.40.630.20:FF:000009', NULL, NULL, 'Pyrrolidone-carboxylate peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(163318, NULL, 'G3DSA:3.30.420.60:FF:000013', NULL, NULL, 'Protein PELOTA 1', NULL, NULL, NULL, NULL, NULL, 4),
(163319, NULL, 'G3DSA:3.90.550.10:FF:000365', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163320, NULL, 'G3DSA:2.60.40.10:FF:000173', NULL, NULL, 'Neural cell adhesion molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(163321, NULL, 'G3DSA:1.10.1450.10:FF:000118', NULL, NULL, 'Putative tetraspanin family', NULL, NULL, NULL, NULL, NULL, 4),
(163322, NULL, 'G3DSA:2.60.120.650:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163323, NULL, 'G3DSA:3.40.33.10:FF:000126', NULL, NULL, 'SCP-Like extracellular protein', NULL, NULL, NULL, NULL, NULL, 4),
(163324, NULL, 'G3DSA:3.90.190.10:FF:000382', NULL, NULL, 'Protein tyrosine phosphatase, receptor type T', NULL, NULL, NULL, NULL, NULL, 4),
(163325, NULL, 'G3DSA:2.130.10.10:FF:002275', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(163326, NULL, 'G3DSA:2.70.70.10:FF:000005', NULL, NULL, 'Hypothetical lipoprotein YgeR', NULL, NULL, NULL, NULL, NULL, 4),
(163327, NULL, 'G3DSA:2.60.40.10:FF:001954', NULL, NULL, 'CD48 antigen', NULL, NULL, NULL, NULL, NULL, 4),
(163328, NULL, 'G3DSA:2.30.30.910:FF:000004', NULL, NULL, 'Basal-body rod modification protein FlgD', NULL, NULL, NULL, NULL, NULL, 4),
(163329, NULL, 'G3DSA:1.20.5.100:FF:000018', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(163330, NULL, 'G3DSA:3.30.70.330:FF:002650', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163331, NULL, 'G3DSA:3.30.1360.120:FF:000026', NULL, NULL, 'Sarcosine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(163332, NULL, 'G3DSA:3.30.160.60:FF:000386', NULL, NULL, 'Tripartite motif-containing 5 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(163333, NULL, 'G3DSA:1.20.58.90:FF:000016', NULL, NULL, 'Tubulin-specific chaperone A', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(163334, NULL, 'G3DSA:3.30.310.280:FF:000003', NULL, NULL, 'Siderophore biosynthesis IucC family protein', NULL, NULL, NULL, NULL, NULL, 4),
(163335, NULL, 'G3DSA:3.10.580.10:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163336, NULL, 'G3DSA:1.10.510.10:FF:003991', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163337, NULL, 'G3DSA:3.10.20.90:FF:000515', NULL, NULL, 'FERM domain (Protein4.1-ezrin-radixin-moesin) family', NULL, NULL, NULL, NULL, NULL, 4),
(163338, NULL, 'G3DSA:2.120.10.80:FF:000031', NULL, NULL, 'attractin', NULL, NULL, NULL, NULL, NULL, 4),
(163339, NULL, 'G3DSA:1.10.3710.10:FF:000009', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(163340, NULL, 'G3DSA:1.10.10.10:FF:000849', NULL, NULL, 'O-methyltransferase GliM', NULL, NULL, NULL, NULL, NULL, 4),
(163341, NULL, 'G3DSA:1.10.20.10:FF:000294', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163342, NULL, 'G3DSA:3.40.50.720:FF:001243', NULL, NULL, '4-hydroxy-tetrahydrodipicolinate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(163343, NULL, 'G3DSA:3.40.525.10:FF:000054', NULL, NULL, 'Clavesin-2', NULL, NULL, NULL, NULL, NULL, 4),
(163344, NULL, 'G3DSA:3.40.30.10:FF:000676', NULL, NULL, 'Methionyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163345, NULL, 'G3DSA:3.40.50.200:FF:000008', NULL, NULL, 'Membrane-bound transcription factor site-1 protease preproprotein', NULL, NULL, NULL, NULL, NULL, 4),
(163346, NULL, 'G3DSA:1.10.720.30:FF:000045', NULL, NULL, 'T. brucei spp.-specific protein', NULL, NULL, NULL, NULL, NULL, 4),
(163347, NULL, 'G3DSA:3.40.50.2300:FF:000120', NULL, NULL, 'Alginate biosynthesis transcriptional regulator AlgB', NULL, NULL, NULL, NULL, NULL, 4),
(163348, NULL, 'G3DSA:3.40.50.300:FF:002781', NULL, NULL, 'DEAD-box ATP-dependent RNA helicase 39', NULL, NULL, NULL, NULL, NULL, 4),
(163349, NULL, 'G3DSA:3.30.43.10:FF:000032', NULL, NULL, 'Carbon monoxide dehydrogenase medium chain', NULL, NULL, NULL, NULL, NULL, 4),
(163350, NULL, 'G3DSA:3.20.20.70:FF:000632', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163351, NULL, 'G3DSA:3.40.605.10:FF:000055', NULL, NULL, 'Delta-1-pyrroline-5-carboxylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(163352, NULL, 'G3DSA:3.80.10.10:FF:004063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163353, NULL, 'G3DSA:3.40.50.1240:FF:000145', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163354, NULL, 'G3DSA:3.40.50.1440:FF:000025', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(163355, NULL, 'G3DSA:1.25.40.20:FF:000894', NULL, NULL, 'Protein ACCELERATED CELL DEATH 6', NULL, NULL, NULL, NULL, NULL, 4),
(163356, NULL, 'G3DSA:2.60.200.30:FF:000018', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(163357, NULL, 'G3DSA:3.40.30.10:FF:000204', NULL, NULL, 'Protein disulfide isomerase-like 1-6', NULL, NULL, NULL, NULL, NULL, 4),
(163358, NULL, 'G3DSA:2.60.40.10:FF:003663', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163359, NULL, 'G3DSA:3.40.50.200:FF:000160', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163360, NULL, 'G3DSA:1.20.1250.20:FF:002138', NULL, NULL, 'Uncharacterized transporter C757.13', NULL, NULL, NULL, NULL, NULL, 4),
(163361, NULL, 'G3DSA:1.25.10.10:FF:001518', NULL, NULL, 'Diaphanous protein, homolog 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163362, NULL, 'G3DSA:1.20.1560.10:FF:000293', NULL, NULL, 'ATP binding cassette subfamily B member 1', NULL, NULL, NULL, NULL, NULL, 4),
(163363, NULL, 'G3DSA:3.40.50.1820:FF:000431', NULL, NULL, 'Membrane bound polyketide synthase Pks6', NULL, NULL, NULL, NULL, NULL, 4),
(163364, NULL, 'G3DSA:4.10.40.20:FF:000004', NULL, NULL, 'HtrA serine peptidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(163365, NULL, 'G3DSA:3.80.10.10:FF:003343', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163366, NULL, 'G3DSA:2.30.42.10:FF:000431', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163367, NULL, 'G3DSA:1.25.40.20:FF:000422', NULL, NULL, 'E3 ubiquitin-protein ligase mind-bomb', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(163368, NULL, 'G3DSA:3.60.40.10:FF:000159', NULL, NULL, 'Probable protein phosphatase 2C 26', NULL, NULL, NULL, NULL, NULL, 4),
(163369, NULL, 'G3DSA:3.40.30.10:FF:000092', NULL, NULL, 'Monothiol glutaredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(163370, NULL, 'G3DSA:1.10.472.130:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163371, NULL, 'G3DSA:1.10.510.10:FF:004183', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163372, NULL, 'G3DSA:3.40.50.170:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163373, NULL, 'G3DSA:3.40.50.10190:FF:000176', NULL, NULL, 'DNA ligase 4', NULL, NULL, NULL, NULL, NULL, 4),
(163374, NULL, 'G3DSA:3.40.50.790:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163375, NULL, 'G3DSA:3.60.10.10:FF:000011', NULL, NULL, 'Type II inositol polyphosphate 5-phosphatase 15', NULL, NULL, NULL, NULL, NULL, 4),
(163376, NULL, 'G3DSA:3.30.200.20:FF:000569', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(163377, NULL, 'G3DSA:3.40.50.150:FF:000089', NULL, NULL, 'S-adenosylmethionine sensor upstream of mTORC1', NULL, NULL, NULL, NULL, NULL, 4),
(163378, NULL, 'G3DSA:2.60.40.1170:FF:000041', NULL, NULL, 'AP-2 complex subunit mu', NULL, NULL, NULL, NULL, NULL, 4),
(163379, NULL, 'G3DSA:1.20.1070.10:FF:000446', NULL, NULL, 'Prostaglandin E receptor subtype EP4', NULL, NULL, NULL, NULL, NULL, 4),
(163380, NULL, 'G3DSA:1.20.1560.10:FF:000877', NULL, NULL, 'Protein CBG20250', NULL, NULL, NULL, NULL, NULL, 4),
(163381, NULL, 'G3DSA:3.30.1370.240:FF:000013', NULL, NULL, 'tRNA synthetases class II core domain (F)-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(163382, NULL, 'G3DSA:1.20.120.350:FF:000215', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163383, NULL, 'G3DSA:3.40.390.10:FF:000032', NULL, NULL, 'Probable thimet oligopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(163384, NULL, 'G3DSA:3.40.50.460:FF:000007', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(163385, NULL, 'G3DSA:2.60.40.1510:FF:000042', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(163386, NULL, 'G3DSA:3.30.160.60:FF:002100', NULL, NULL, 'Paternally-expressed gene 3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(163387, NULL, 'G3DSA:4.10.240.10:FF:000226', NULL, NULL, 'Uncharacterized transcriptional regulatory protein C16G5.17', NULL, NULL, NULL, NULL, NULL, 4),
(163388, NULL, 'G3DSA:1.20.58.80:FF:000070', NULL, NULL, 'serine/threonine-protein kinase ULK3', NULL, NULL, NULL, NULL, NULL, 4),
(163389, NULL, 'G3DSA:3.40.50.2000:FF:001076', NULL, NULL, 'Beta-1,4 mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(163390, NULL, 'G3DSA:3.40.50.300:FF:002101', NULL, NULL, 'DNA replication helicase DNA2', NULL, NULL, NULL, NULL, NULL, 4),
(163391, NULL, 'G3DSA:3.90.70.10:FF:000244', NULL, NULL, 'Cysteine protease 18', NULL, NULL, NULL, NULL, NULL, 4),
(163392, NULL, 'G3DSA:1.25.40.20:FF:000186', NULL, NULL, 'Transient receptor potential cation channel A1, isoform K', NULL, NULL, NULL, NULL, NULL, 4),
(163393, NULL, 'G3DSA:4.10.280.10:FF:000083', NULL, NULL, 'Neuronal PAS domain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(163394, NULL, 'G3DSA:1.10.730.10:FF:000124', NULL, NULL, 'Leucyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(163395, NULL, 'G3DSA:3.80.10.10:FF:001718', NULL, NULL, 'Os02g0317300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(163396, NULL, 'G3DSA:3.30.160.60:FF:003848', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163397, NULL, 'G3DSA:2.170.130.10:FF:000065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163398, NULL, 'G3DSA:3.80.10.10:FF:003927', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163399, NULL, 'G3DSA:1.20.1270.60:FF:000009', NULL, NULL, 'Protein kinase C and casein kinase substrate in neurons 2', NULL, NULL, NULL, NULL, NULL, 4),
(163400, NULL, 'G3DSA:2.70.98.10:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(163401, NULL, 'G3DSA:1.10.510.10:FF:004244', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163402, NULL, 'G3DSA:1.10.260.40:FF:000063', NULL, NULL, 'HTH-type transcriptional regulator prtR', NULL, NULL, NULL, NULL, NULL, 4),
(163403, NULL, 'G3DSA:1.10.4020.10:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163404, NULL, 'G3DSA:3.90.190.10:FF:000590', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163405, NULL, 'G3DSA:3.30.505.10:FF:000128', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(163406, NULL, 'G3DSA:3.40.50.720:FF:001035', NULL, NULL, 'Saccharopine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(163407, NULL, 'G3DSA:3.40.50.1820:FF:001504', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163408, NULL, 'G3DSA:2.60.40.1460:FF:000004', NULL, NULL, 'integrin alpha-3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(163409, NULL, 'G3DSA:3.40.50.300:FF:001792', NULL, NULL, 'Putative abc transporter', NULL, NULL, NULL, NULL, NULL, 4),
(163410, NULL, 'G3DSA:3.40.1010.20:FF:000006', NULL, NULL, '4-hydroxy-3-methylbut-2-enyl diphosphate reductase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(163411, NULL, 'G3DSA:3.20.20.140:FF:000207', NULL, NULL, 'DNA polymerase III subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(163412, NULL, 'G3DSA:3.40.50.2000:FF:000620', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163413, NULL, 'G3DSA:3.40.190.10:FF:000135', NULL, NULL, 'DNA-binding transcriptional regulator DsdC', NULL, NULL, NULL, NULL, NULL, 4),
(163414, NULL, 'G3DSA:3.30.710.10:FF:000178', NULL, NULL, 'Armadillo/beta-catenin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(163415, NULL, 'G3DSA:1.20.1070.10:FF:001519', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163416, NULL, 'G3DSA:2.60.40.60:FF:000339', NULL, NULL, 'Cadherin-related hmr-1', NULL, NULL, NULL, NULL, NULL, 4),
(163417, NULL, 'G3DSA:3.30.420.40:FF:000535', NULL, NULL, 'Heat shock 70 kDa protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(163418, NULL, 'G3DSA:1.10.10.350:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163419, NULL, 'G3DSA:2.20.100.10:FF:000183', NULL, NULL, 'Thrombospondin type-1 domain-containing protein 7A', NULL, NULL, NULL, NULL, NULL, 4),
(163420, NULL, 'G3DSA:3.30.810.10:FF:000011', NULL, NULL, 'Phosphoinositide kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163421, NULL, 'G3DSA:3.30.420.40:FF:000799', NULL, NULL, 'Actin, epsilon 1', NULL, NULL, NULL, NULL, NULL, 4),
(163422, NULL, 'G3DSA:1.25.40.10:FF:002010', NULL, NULL, 'Os12g0109800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(163423, NULL, 'G3DSA:2.40.160.120:FF:000065', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(163424, NULL, 'G3DSA:3.40.50.740:FF:000001', NULL, NULL, 'Periplasmic nitrate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(163425, NULL, 'G3DSA:1.25.10.10:FF:002093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163426, NULL, 'G3DSA:3.60.15.10:FF:000207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163427, NULL, 'G3DSA:1.50.10.10:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163428, NULL, 'G3DSA:3.40.50.980:FF:000045', NULL, NULL, 'AMP dependent CoA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163429, NULL, 'G3DSA:3.40.50.2020:FF:000042', NULL, NULL, 'Putative ribose-phosphate pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(163430, NULL, 'G3DSA:1.20.920.10:FF:000142', NULL, NULL, 'Putative polybromo 1', NULL, NULL, NULL, NULL, NULL, 4),
(163431, NULL, 'G3DSA:3.40.50.11340:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163432, NULL, 'G3DSA:3.90.190.10:FF:000438', NULL, NULL, 'Dual-specificity phosphatase 12', NULL, NULL, NULL, NULL, NULL, 4),
(163433, NULL, 'G3DSA:3.40.50.720:FF:002171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(163434, NULL, 'G3DSA:1.25.40.10:FF:002982', NULL, NULL, 'Pre-mRNA-splicing factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(163435, NULL, 'G3DSA:3.30.160.60:FF:004837', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163436, NULL, 'G3DSA:2.40.50.140:FF:000567', NULL, NULL, 'Cold-shock DNA-binding domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163437, NULL, 'G3DSA:3.80.10.10:FF:001157', NULL, NULL, 'Leucine-rich receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(163438, NULL, 'G3DSA:3.40.50.10490:FF:000029', NULL, NULL, 'RpiR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(163439, NULL, 'G3DSA:3.40.800.20:FF:000017', NULL, NULL, 'Histone deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(163440, NULL, 'G3DSA:1.10.8.10:FF:000045', NULL, NULL, 'Putative FAS-associated factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(163441, NULL, 'G3DSA:2.60.40.150:FF:000434', NULL, NULL, 'Synaptotagmin XV', NULL, NULL, NULL, NULL, NULL, 4),
(163442, NULL, 'G3DSA:3.40.50.2000:FF:000709', NULL, NULL, 'GM18614', NULL, NULL, NULL, NULL, NULL, 4),
(163443, NULL, 'G3DSA:3.30.160.60:FF:002067', NULL, NULL, 'Zinc finger protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(163444, NULL, 'G3DSA:3.40.50.11260:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163445, NULL, 'G3DSA:3.40.50.300:FF:006524', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163446, NULL, 'G3DSA:1.20.144.10:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163447, NULL, 'G3DSA:2.60.120.10:FF:000506', NULL, NULL, 'Protein kinase cGMP-dependent 1', NULL, NULL, NULL, NULL, NULL, 4),
(163448, NULL, 'G3DSA:3.50.50.60:FF:000388', NULL, NULL, 'Probable monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(163449, NULL, 'G3DSA:1.25.40.10:FF:002274', NULL, NULL, 'U3 small nucleolar RNA-associated protein 6 isogeny', NULL, NULL, NULL, NULL, NULL, 4),
(163450, NULL, 'G3DSA:3.30.420.10:FF:000431', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163451, NULL, 'G3DSA:3.20.20.70:FF:000840', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163452, NULL, 'G3DSA:2.130.10.10:FF:003787', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163453, NULL, 'G3DSA:2.130.10.10:FF:003264', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163454, NULL, 'G3DSA:3.30.70.330:FF:000817', NULL, NULL, 'Polyadenylate-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(163455, NULL, 'G3DSA:3.10.450.10:FF:000038', NULL, NULL, 'Retinoic acid receptor responder (tazarotene-induced) 1', NULL, NULL, NULL, NULL, NULL, 4),
(163456, NULL, 'G3DSA:1.10.1300.10:FF:000023', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(163457, NULL, 'G3DSA:1.10.510.10:FF:001574', NULL, NULL, 'Si:ch211-63o20.7', NULL, NULL, NULL, NULL, NULL, 4),
(163458, NULL, 'G3DSA:3.30.200.60:FF:000002', NULL, NULL, 'ubiquitin thioesterase OTUB2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(163459, NULL, 'G3DSA:3.30.160.430:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163460, NULL, 'G3DSA:3.90.180.10:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163461, NULL, 'G3DSA:2.60.120.10:FF:000006', NULL, NULL, 'cAMP-dependent protein kinase type I-alpha regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(163462, NULL, 'G3DSA:2.30.39.10:FF:000024', NULL, NULL, 'Spn43Ac', NULL, NULL, NULL, NULL, NULL, 4),
(163463, NULL, 'G3DSA:3.90.228.10:FF:000049', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(163464, NULL, 'G3DSA:3.30.540.10:FF:000086', NULL, NULL, '3''(2''),5''-bisphosphate nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(163465, NULL, 'G3DSA:3.40.50.300:FF:001853', NULL, NULL, 'Dynamin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(163466, NULL, 'G3DSA:3.30.160.60:FF:003292', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163467, NULL, 'G3DSA:1.10.30.10:FF:000120', NULL, NULL, 'protein polybromo-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(163468, NULL, 'G3DSA:4.10.240.10:FF:000018', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(163469, NULL, 'G3DSA:3.40.640.10:FF:000389', NULL, NULL, 'Cobalamin biosynthetic protein CobC', NULL, NULL, NULL, NULL, NULL, 4),
(163470, NULL, 'G3DSA:3.40.50.300:FF:001084', NULL, NULL, 'RecQ like helicase 4', NULL, NULL, NULL, NULL, NULL, 4),
(163471, NULL, 'G3DSA:1.20.1070.10:FF:000238', NULL, NULL, 'Opsin-VA', NULL, NULL, NULL, NULL, NULL, 4),
(163472, NULL, 'G3DSA:1.10.510.10:FF:000349', NULL, NULL, 'probable serine/threonine-protein kinase DDB_G0280111', NULL, NULL, NULL, NULL, NULL, 4),
(163473, NULL, 'G3DSA:3.40.50.450:FF:000061', NULL, NULL, '6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(163474, NULL, 'G3DSA:3.40.470.10:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163475, NULL, 'G3DSA:1.20.1280.50:FF:000148', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(163476, NULL, 'G3DSA:1.10.8.140:FF:000004', NULL, NULL, 'DNA-binding protein PAE3044', NULL, NULL, NULL, NULL, NULL, 4),
(163477, NULL, 'G3DSA:3.40.710.10:FF:000041', NULL, NULL, 'Penicillin-binding protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(163478, NULL, 'G3DSA:3.40.50.300:FF:006463', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163479, NULL, 'G3DSA:2.30.30.40:FF:000339', NULL, NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(163480, NULL, 'G3DSA:1.10.510.10:FF:000293', NULL, NULL, 'SRSF protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(163481, NULL, 'G3DSA:2.130.10.10:FF:005973', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163482, NULL, 'G3DSA:2.20.60.10:FF:000001', NULL, NULL, 'Pleiotrophin', NULL, NULL, NULL, NULL, NULL, 4),
(163483, NULL, 'G3DSA:2.20.130.20:FF:000013', NULL, NULL, 'Thioester-containing protein 4, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(163484, NULL, 'G3DSA:3.40.1350.10:FF:000046', NULL, NULL, 'tRNA-splicing endonuclease subunit SEN15', NULL, NULL, NULL, NULL, NULL, 4),
(163485, NULL, 'G3DSA:1.10.8.10:FF:000106', NULL, NULL, 'Ubiquitin-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(163486, NULL, 'G3DSA:3.40.50.1820:FF:000223', NULL, NULL, 'Lipase/serine esterase', NULL, NULL, NULL, NULL, NULL, 4),
(163487, NULL, 'G3DSA:4.10.400.10:FF:000228', NULL, NULL, 'Serine protease nudel', NULL, NULL, NULL, NULL, NULL, 4),
(163488, NULL, 'G3DSA:3.90.550.10:FF:000601', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163489, NULL, 'G3DSA:3.30.160.60:FF:003348', NULL, NULL, 'ZFP90 zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(163490, NULL, 'G3DSA:3.30.160.20:FF:000161', NULL, NULL, 'Ribonuclease 3', NULL, NULL, NULL, NULL, NULL, 4),
(163491, NULL, 'G3DSA:3.30.70.330:FF:002150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163492, NULL, 'G3DSA:1.25.40.20:FF:000686', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(163493, NULL, 'G3DSA:3.30.2130.10:FF:000015', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(163494, NULL, 'G3DSA:3.10.20.90:FF:000279', NULL, NULL, 'Blast:Serine/threonine-protein kinase WNK3', NULL, NULL, NULL, NULL, NULL, 4),
(163495, NULL, 'G3DSA:3.40.50.2000:FF:000356', NULL, NULL, 'Glycosyltransferase, group 1 family', NULL, NULL, NULL, NULL, NULL, 4),
(163496, NULL, 'G3DSA:3.40.50.11660:FF:000004', NULL, NULL, 'Glycoprotein 3-alpha-L-fucosyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(163497, NULL, 'G3DSA:1.10.8.720:FF:000049', NULL, NULL, 'YALI0E32857p', NULL, NULL, NULL, NULL, NULL, 4),
(163498, NULL, 'G3DSA:3.40.449.10:FF:000017', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163499, NULL, 'G3DSA:4.10.60.10:FF:000205', NULL, NULL, 'Nucleic acid binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163500, NULL, 'G3DSA:2.60.40.420:FF:000274', NULL, NULL, 'Plastocyanin-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(163501, NULL, 'G3DSA:3.40.50.261:FF:000016', NULL, NULL, 'Acyl-CoA synthetase FdrA', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(163502, NULL, 'G3DSA:2.40.30.10:FF:000482', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163503, NULL, 'G3DSA:1.25.40.10:FF:002482', NULL, NULL, 'Os11g0587100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(163504, NULL, 'G3DSA:3.40.50.300:FF:003854', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163505, NULL, 'G3DSA:3.30.160.60:FF:001903', NULL, NULL, 'Zinc finger protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(163506, NULL, 'G3DSA:3.30.40.10:FF:001419', NULL, NULL, 'HMG1/2 (High mobility group) box-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(163507, NULL, 'G3DSA:2.40.160.110:FF:000028', NULL, NULL, 'Lysosomal-associated membrane protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(163508, NULL, 'G3DSA:1.20.120.1510:FF:000003', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(163509, NULL, 'G3DSA:1.25.10.10:FF:001165', NULL, NULL, 'UvrB/uvrC_motif_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(163510, NULL, 'G3DSA:3.40.50.300:FF:006316', NULL, NULL, 'Chromodomain-helicase-DNA-binding protein 3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(163511, NULL, 'G3DSA:1.20.1560.10:FF:000354', NULL, NULL, 'ABC a-pheromone efflux pump AtrD', NULL, NULL, NULL, NULL, NULL, 4),
(163512, NULL, 'G3DSA:3.80.10.10:FF:002438', NULL, NULL, 'Leucine-rich repeat-containing 15', NULL, NULL, NULL, NULL, NULL, 4),
(163513, NULL, 'G3DSA:1.25.40.20:FF:001203', NULL, NULL, 'Phosphocholine transferase AnkX', NULL, NULL, NULL, NULL, NULL, 4),
(163514, NULL, 'G3DSA:3.40.50.1820:FF:001712', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163515, NULL, 'G3DSA:2.10.50.10:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163516, NULL, 'G3DSA:3.30.1320.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163517, NULL, 'G3DSA:2.40.50.140:FF:000831', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163518, NULL, 'G3DSA:2.70.20.10:FF:000002', NULL, NULL, 'DNA topoisomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(163519, NULL, 'G3DSA:2.40.70.10:FF:000248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163520, NULL, 'G3DSA:3.30.160.60:FF:004629', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163521, NULL, 'G3DSA:1.20.900.10:FF:000079', NULL, NULL, 'Obscurin', NULL, NULL, NULL, NULL, NULL, 4),
(163522, NULL, 'G3DSA:3.90.1600.10:FF:000032', NULL, NULL, 'DNA polymerase zeta catalytic subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163523, NULL, 'G3DSA:3.40.50.1010:FF:000278', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163524, NULL, 'G3DSA:2.130.10.10:FF:003056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163525, NULL, 'G3DSA:2.130.10.10:FF:000330', NULL, NULL, 'Dynein, cytoplasmic 1, intermediate chain 2b', NULL, NULL, NULL, NULL, NULL, 4),
(163526, NULL, 'G3DSA:3.70.10.10:FF:000106', NULL, NULL, 'DNA repair protein rad9, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163527, NULL, 'G3DSA:2.60.220.30:FF:000020', NULL, NULL, 'Ankyrin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(163528, NULL, 'G3DSA:3.30.830.10:FF:000333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163529, NULL, 'G3DSA:2.10.70.10:FF:000227', NULL, NULL, 'C-type LECtin', NULL, NULL, NULL, NULL, NULL, 4),
(163530, NULL, 'G3DSA:3.30.420.40:FF:000327', NULL, NULL, 'Hsp70 family', NULL, NULL, NULL, NULL, NULL, 4),
(163531, NULL, 'G3DSA:3.30.70.330:FF:001745', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163532, NULL, 'G3DSA:1.10.287.70:FF:000352', NULL, NULL, 'Calcium channel, voltage-dependent, P/Q type, alpha 1A subunit, b', NULL, NULL, NULL, NULL, NULL, 4),
(163533, NULL, 'G3DSA:1.20.120.610:FF:000018', NULL, NULL, 'V-atpase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(163534, NULL, 'G3DSA:2.60.200.40:FF:000055', NULL, NULL, 'Diacylglycerol kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(163535, NULL, 'G3DSA:3.30.200.20:FF:001474', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(163536, NULL, 'G3DSA:3.30.200.20:FF:002194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163537, NULL, 'G3DSA:3.10.110.10:FF:000311', NULL, NULL, 'Protein CBG21481', NULL, NULL, NULL, NULL, NULL, 4),
(163538, NULL, 'G3DSA:1.10.10.60:FF:000639', NULL, NULL, 'V-myb avian myeloblastosis viral oncogene homolog-like 2b', NULL, NULL, NULL, NULL, NULL, 4),
(163539, NULL, 'G3DSA:4.10.460.10:FF:000001', NULL, NULL, 'Inositol polyphosphate 1-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(163540, NULL, 'G3DSA:3.90.70.10:FF:000305', NULL, NULL, 'GM20254', NULL, NULL, NULL, NULL, NULL, 4),
(163541, NULL, 'G3DSA:3.30.70.1990:FF:000001', NULL, NULL, 'Amine oxidase, flavin-containing superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(163542, NULL, 'G3DSA:4.10.400.10:FF:000172', NULL, NULL, 'Low-density lipoprotein receptor-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(163543, NULL, 'G3DSA:2.60.40.10:FF:001246', NULL, NULL, 'Centrosomal protein of 192 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(163544, NULL, 'G3DSA:1.20.1250.20:FF:001121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163545, NULL, 'G3DSA:1.10.287.1040:FF:000004', NULL, NULL, 'Exodeoxyribonuclease 7 small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(163546, NULL, 'G3DSA:1.20.58.60:FF:000737', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163547, NULL, 'G3DSA:2.70.170.10:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163548, NULL, 'G3DSA:3.30.450.260:FF:000011', NULL, NULL, 'Soluble guanylyl cyclase beta2 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(163549, NULL, 'G3DSA:1.10.510.10:FF:001782', NULL, NULL, 'Protein CBG12789', NULL, NULL, NULL, NULL, NULL, 4),
(163550, NULL, 'G3DSA:3.40.50.150:FF:000914', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163551, NULL, 'G3DSA:1.10.10.1590:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163552, NULL, 'G3DSA:2.10.25.10:FF:001409', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163553, NULL, 'G3DSA:3.40.50.300:FF:007952', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163554, NULL, 'G3DSA:2.60.120.200:FF:000189', NULL, NULL, 'MAM domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(163555, NULL, 'G3DSA:3.30.70.1430:FF:000002', NULL, NULL, 'Efflux pump membrane transporter', NULL, NULL, NULL, NULL, NULL, 4),
(163556, NULL, 'G3DSA:3.30.56.70:FF:000006', NULL, NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(163557, NULL, 'G3DSA:1.20.120.1900:FF:000058', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(163558, NULL, 'G3DSA:3.10.260.20:FF:000004', NULL, NULL, 'V-ski avian sarcoma viral oncogene homolog b', NULL, NULL, NULL, NULL, NULL, 4),
(163559, NULL, 'G3DSA:1.20.1090.10:FF:000037', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(163560, NULL, 'G3DSA:2.60.40.10:FF:000526', NULL, NULL, 'Contactin 1', NULL, NULL, NULL, NULL, NULL, 4),
(163561, NULL, 'G3DSA:1.25.10.10:FF:002446', NULL, NULL, 'Hsp70 nucleotide exchange factor fes1', NULL, NULL, NULL, NULL, NULL, 4),
(163562, NULL, 'G3DSA:3.40.640.10:FF:000125', NULL, NULL, 'Probable L-tyrosine/L-aspartate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(163563, NULL, 'G3DSA:3.30.360.10:FF:000021', NULL, NULL, 'Acetaldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(163564, NULL, 'G3DSA:1.10.10.10:FF:000265', NULL, NULL, 'Cell division control protein', NULL, NULL, NULL, NULL, NULL, 4),
(163565, NULL, 'G3DSA:3.30.40.10:FF:000790', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163566, NULL, 'G3DSA:1.10.238.10:FF:000749', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163567, NULL, 'G3DSA:3.40.50.300:FF:004107', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(163568, NULL, 'G3DSA:3.40.50.620:FF:000842', NULL, NULL, 'Asparagine synthetase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(163569, NULL, 'G3DSA:2.60.40.60:FF:000991', NULL, NULL, 'Protein CBR-CDH-12', NULL, NULL, NULL, NULL, NULL, 4),
(163570, NULL, 'G3DSA:1.25.40.10:FF:004691', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163571, NULL, 'G3DSA:3.30.1490.20:FF:000044', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(163572, NULL, 'G3DSA:1.10.510.10:FF:003839', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163573, NULL, 'G3DSA:3.10.450.50:FF:000090', NULL, NULL, 'Nuclear transport factor 2 (NTF2) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(163574, NULL, 'G3DSA:3.50.50.60:FF:000591', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(163575, NULL, 'G3DSA:3.40.50.1000:FF:000365', NULL, NULL, 'Nuclear LIM interactor-interacting factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(163576, NULL, 'G3DSA:2.60.40.10:FF:001807', NULL, NULL, 'Roundabout 1, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(163577, NULL, 'G3DSA:1.10.530.10:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163578, NULL, 'G3DSA:3.30.70.100:FF:000069', NULL, NULL, 'Acylphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(163579, NULL, 'G3DSA:1.25.10.10:FF:003374', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163580, NULL, 'G3DSA:1.10.167.10:FF:000022', NULL, NULL, 'A-kinase anchor protein 10, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(163581, NULL, 'G3DSA:6.20.240.60:FF:000001', NULL, NULL, 'Spore cortex-lytic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(163582, NULL, 'G3DSA:3.30.70.1230:FF:000122', NULL, NULL, 'Adenylate cyclase 1', NULL, NULL, NULL, NULL, NULL, 4),
(163583, NULL, 'G3DSA:1.10.287.110:FF:000393', NULL, NULL, 'DNAJ heat shock family protein', NULL, NULL, NULL, NULL, NULL, 4),
(163584, NULL, 'G3DSA:3.20.200.10:FF:000001', NULL, NULL, 'Transient receptor potential cation channel, subfamily M, member 7', NULL, NULL, NULL, NULL, NULL, 4),
(163585, NULL, 'G3DSA:1.20.58.830:FF:000034', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(163586, NULL, 'G3DSA:3.40.50.720:FF:000990', NULL, NULL, 'SDR family oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(163587, NULL, 'G3DSA:1.20.58.60:FF:000884', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163588, NULL, 'G3DSA:1.10.405.10:FF:000043', NULL, NULL, 'Gll0991 protein', NULL, NULL, NULL, NULL, NULL, 4),
(163589, NULL, 'G3DSA:2.60.40.10:FF:002735', NULL, NULL, 'Cysteine protease', NULL, NULL, NULL, NULL, NULL, 4),
(163590, NULL, 'G3DSA:3.40.30.10:FF:001132', NULL, NULL, 'Os01g0949750 protein', NULL, NULL, NULL, NULL, NULL, 4),
(163591, NULL, 'G3DSA:3.30.530.20:FF:000206', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163592, NULL, 'G3DSA:1.25.10.10:FF:000237', NULL, NULL, 'Pumilio homolog 9', NULL, NULL, NULL, NULL, NULL, 4),
(163593, NULL, 'G3DSA:1.10.1060.10:FF:000015', NULL, NULL, 'Cytochrome c oxidase accessory protein CcoG', NULL, NULL, NULL, NULL, NULL, 4),
(163594, NULL, 'G3DSA:1.25.40.990:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163595, NULL, 'G3DSA:3.40.50.620:FF:000134', NULL, NULL, 'L-cysteine:1D-myo-inositol 2-amino-2-deoxy-alpha-D-glucopyranoside ligase', NULL, NULL, NULL, NULL, NULL, 4),
(163596, NULL, 'G3DSA:2.40.10.310:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163597, NULL, 'G3DSA:3.40.630.30:FF:000607', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163598, NULL, 'G3DSA:1.25.40.10:FF:003763', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163599, NULL, 'G3DSA:1.10.1140.10:FF:000016', NULL, NULL, 'ATP synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(163600, NULL, 'G3DSA:2.170.16.10:FF:000044', NULL, NULL, 'DNA topoisomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(163601, NULL, 'G3DSA:3.30.70.60:FF:000020', NULL, NULL, 'Unplaced genomic scaffold supercont1.170, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(163602, NULL, 'G3DSA:3.30.160.60:FF:000622', NULL, NULL, 'zinc finger protein 26 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(163603, NULL, 'G3DSA:3.40.1110.10:FF:000213', NULL, NULL, 'CU (Copper) ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(163604, NULL, 'G3DSA:1.10.8.60:FF:000419', NULL, NULL, 'Replication factor C subunit 2/4', NULL, NULL, NULL, NULL, NULL, 4),
(163605, NULL, 'G3DSA:3.30.2130.30:FF:000026', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163606, NULL, 'G3DSA:3.30.9.10:FF:000077', NULL, NULL, 'Putative malatequinone oxidoreductase protein', NULL, NULL, NULL, NULL, NULL, 4),
(163607, NULL, 'G3DSA:1.10.287.410:FF:000005', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(163608, NULL, 'G3DSA:3.40.50.300:FF:005035', NULL, NULL, 'ABC transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(163609, NULL, 'G3DSA:3.90.1030.20:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163610, NULL, 'G3DSA:1.10.10.10:FF:001193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163611, NULL, 'G3DSA:1.20.58.340:FF:000039', NULL, NULL, 'Magnesium/cobalt transporter CorA', NULL, NULL, NULL, NULL, NULL, 4),
(163612, NULL, 'G3DSA:2.40.50.100:FF:000050', NULL, NULL, 'Exosome complex component rrp4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(163613, NULL, 'G3DSA:3.10.180.20:FF:000003', NULL, NULL, 'GLYcosylation related', NULL, NULL, NULL, NULL, NULL, 4),
(163614, NULL, 'G3DSA:1.20.1260.10:FF:000073', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(163615, NULL, 'G3DSA:3.30.420.10:FF:000167', NULL, NULL, 'Ribonuclease HII', NULL, NULL, NULL, NULL, NULL, 4),
(163616, NULL, 'G3DSA:3.40.630.10:FF:000040', NULL, NULL, 'zinc carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(163617, NULL, 'G3DSA:3.40.50.2300:FF:001401', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163618, NULL, 'G3DSA:6.10.140.2220:FF:000048', NULL, NULL, 'GM24612', NULL, NULL, NULL, NULL, NULL, 4),
(163619, NULL, 'G3DSA:3.30.450.20:FF:000205', NULL, NULL, 'Hypoxia-inducible factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(163620, NULL, 'G3DSA:1.10.60.10:FF:000004', NULL, NULL, 'DtxR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(163621, NULL, 'G3DSA:1.10.287.80:FF:000001', NULL, NULL, 'ATP synthase gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(163622, NULL, 'G3DSA:3.30.420.270:FF:000031', NULL, NULL, 'Sll0479 protein', NULL, NULL, NULL, NULL, NULL, 4),
(163623, NULL, 'G3DSA:1.10.3730.10:FF:000011', NULL, NULL, 'Pyrroline-5-carboxylate reductase 3', NULL, NULL, NULL, NULL, NULL, 4),
(163624, NULL, 'G3DSA:3.30.160.60:FF:002831', NULL, NULL, 'Zinc finger protein 36', NULL, NULL, NULL, NULL, NULL, 4),
(163625, NULL, 'G3DSA:1.10.472.80:FF:000196', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163626, NULL, 'G3DSA:3.40.50.300:FF:007244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163627, NULL, 'G3DSA:2.60.40.290:FF:000010', NULL, NULL, 'Putative secreted cellulase', NULL, NULL, NULL, NULL, NULL, 4),
(163628, NULL, 'G3DSA:2.30.30.1020:FF:000020', NULL, NULL, 'CCR4/NOT transcription complex subunit 3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163629, NULL, 'G3DSA:3.30.460.10:FF:000085', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(163630, NULL, 'G3DSA:3.30.565.10:FF:000345', NULL, NULL, 'Phytochrome-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(163631, NULL, 'G3DSA:3.30.930.10:FF:000397', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163632, NULL, 'G3DSA:1.25.40.10:FF:001554', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163633, NULL, 'G3DSA:3.90.870.10:FF:000029', NULL, NULL, 'Glr3274 protein', NULL, NULL, NULL, NULL, NULL, 4),
(163634, NULL, 'G3DSA:3.40.50.720:FF:000838', NULL, NULL, 'Glyoxylate reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163635, NULL, 'G3DSA:3.10.196.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163636, NULL, 'G3DSA:3.30.40.10:FF:000082', NULL, NULL, 'Polycomb group ring finger 2', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(163637, NULL, 'G3DSA:4.10.280.10:FF:000139', NULL, NULL, 'Clockwork orange, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(163638, NULL, 'G3DSA:3.40.630.30:FF:000046', NULL, NULL, 'Dopamine N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(163639, NULL, 'G3DSA:3.40.50.300:FF:000364', NULL, NULL, 'ATP-dependent RNA helicase DDX6', NULL, NULL, NULL, NULL, NULL, 4),
(163640, NULL, 'G3DSA:3.30.70.20:FF:000120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163641, NULL, 'G3DSA:1.20.930.40:FF:000011', NULL, NULL, 'Tre2p', NULL, NULL, NULL, NULL, NULL, 4),
(163642, NULL, 'G3DSA:2.10.90.10:FF:000026', NULL, NULL, 'Nodal homolog 3-A', NULL, NULL, NULL, NULL, NULL, 4),
(163643, NULL, 'G3DSA:2.60.120.330:FF:000177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163644, NULL, 'G3DSA:3.30.450.20:FF:000469', NULL, NULL, 'PAS domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(163645, NULL, 'G3DSA:1.10.287.1060:FF:000015', NULL, NULL, 'SNF7 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(163646, NULL, 'G3DSA:3.30.559.10:FF:000224', NULL, NULL, 'Protein CBG13268', NULL, NULL, NULL, NULL, NULL, 4),
(163647, NULL, 'G3DSA:2.130.10.10:FF:004692', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163648, NULL, 'G3DSA:3.30.160.60:FF:000886', NULL, NULL, 'zinc finger protein 64 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(163649, NULL, 'G3DSA:3.10.20.90:FF:000015', NULL, NULL, 'B-Raf proto-oncogene serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(163650, NULL, 'G3DSA:3.40.50.300:FF:005299', NULL, NULL, 'YALI0F09009p', NULL, NULL, NULL, NULL, NULL, 4),
(163651, NULL, 'G3DSA:3.80.10.10:FF:004271', NULL, NULL, 'Si:ch211-156p11.1', NULL, NULL, NULL, NULL, NULL, 4),
(163652, NULL, 'G3DSA:3.40.50.300:FF:002573', NULL, NULL, 'Pre-mRNA-splicing factor', NULL, NULL, NULL, NULL, NULL, 4),
(163653, NULL, 'G3DSA:2.10.270.10:FF:000011', NULL, NULL, 'Dextransucrase', NULL, NULL, NULL, NULL, NULL, 4),
(163654, NULL, 'G3DSA:3.40.190.80:FF:000083', NULL, NULL, 'Monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(163655, NULL, 'G3DSA:3.60.20.10:FF:000068', NULL, NULL, 'NAD(P)H-dependent glutamate synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163656, NULL, 'G3DSA:1.10.3080.10:FF:000045', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(163657, NULL, 'G3DSA:1.10.287.820:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163658, NULL, 'G3DSA:2.40.170.20:FF:000005', NULL, NULL, 'TonB-dependent siderophore receptor', NULL, NULL, NULL, NULL, NULL, 4),
(163659, NULL, 'G3DSA:1.10.1420.10:FF:000173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163660, NULL, 'G3DSA:2.40.20.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163661, NULL, 'G3DSA:3.40.30.10:FF:000120', NULL, NULL, 'Thioredoxin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(163662, NULL, 'G3DSA:2.60.40.10:FF:002651', NULL, NULL, 'Hibris, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(163663, NULL, 'G3DSA:3.40.50.2300:FF:000884', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163664, NULL, 'G3DSA:1.25.10.10:FF:001434', NULL, NULL, 'Related to yeast Vacuolar Protein Sorting factor', NULL, NULL, NULL, NULL, NULL, 4),
(163665, NULL, 'G3DSA:3.40.50.200:FF:000188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163666, NULL, 'G3DSA:3.40.50.2300:FF:000412', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(163667, NULL, 'G3DSA:2.60.120.260:FF:000364', NULL, NULL, 'Endo-1,4-beta-xylanase A', NULL, NULL, NULL, NULL, NULL, 4),
(163668, NULL, 'G3DSA:3.40.50.1910:FF:000014', NULL, NULL, 'Vacuolar protein sorting 33', NULL, NULL, NULL, NULL, NULL, 4),
(163669, NULL, 'G3DSA:3.40.30.10:FF:000592', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163670, NULL, 'G3DSA:2.10.110.10:FF:000354', NULL, NULL, 'ISL LIM homeobox 2', NULL, NULL, NULL, NULL, NULL, 4),
(163671, NULL, 'G3DSA:3.20.20.140:FF:000354', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase NAGA', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(163672, NULL, 'G3DSA:1.10.287.110:FF:000421', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163673, NULL, 'G3DSA:3.40.50.2300:FF:000356', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(163674, NULL, 'G3DSA:3.30.160.60:FF:001139', NULL, NULL, 'zinc finger protein 202 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(163675, NULL, 'G3DSA:2.60.210.10:FF:000013', NULL, NULL, 'TRAF-like family protein', NULL, NULL, NULL, NULL, NULL, 4),
(163676, NULL, 'G3DSA:3.10.20.90:FF:000695', NULL, NULL, 'YALI0D13046p', NULL, NULL, NULL, NULL, NULL, 4),
(163677, NULL, 'G3DSA:3.40.50.1370:FF:000009', NULL, NULL, 'Ornithine carbamoyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(163678, NULL, 'G3DSA:2.20.25.420:FF:000006', NULL, NULL, 'Zn finger containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(163679, NULL, 'G3DSA:3.40.50.300:FF:008469', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163680, NULL, 'G3DSA:1.20.1070.10:FF:000946', NULL, NULL, 'AGAP001774-PA', NULL, NULL, NULL, NULL, NULL, 4),
(163681, NULL, 'G3DSA:1.20.1070.10:FF:001935', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163682, NULL, 'G3DSA:1.25.40.10:FF:002038', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At5g08490', NULL, NULL, NULL, NULL, NULL, 4),
(163683, NULL, 'G3DSA:3.30.710.10:FF:000150', NULL, NULL, 'Potassium channel tetramerization domain containing 14', NULL, NULL, NULL, NULL, NULL, 4),
(163684, NULL, 'G3DSA:2.60.220.50:FF:000003', NULL, NULL, 'adhesion G-protein coupled receptor G2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(163685, NULL, 'G3DSA:3.40.50.1820:FF:000931', NULL, NULL, 'Homoserine O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(163686, NULL, 'G3DSA:3.80.10.10:FF:001073', NULL, NULL, 'Leucine rich repeats and IQ motif containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(163687, NULL, 'G3DSA:3.60.15.10:FF:000123', NULL, NULL, 'Metallo-beta-lactamase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(163688, NULL, 'G3DSA:3.40.50.880:FF:000077', NULL, NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(163689, NULL, 'G3DSA:1.10.510.10:FF:003755', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163690, NULL, 'G3DSA:3.30.565.10:FF:000429', NULL, NULL, 'Hybrid signal transduction histidine kinase J', NULL, NULL, NULL, NULL, NULL, 4),
(163691, NULL, 'G3DSA:3.40.50.1820:FF:001443', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163692, NULL, 'G3DSA:2.130.10.10:FF:002303', NULL, NULL, 'WD repeat-containing protein 73', NULL, NULL, NULL, NULL, NULL, 4),
(163693, NULL, 'G3DSA:2.30.30.140:FF:000195', NULL, NULL, 'SGF29 tudor-like domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(163694, NULL, 'G3DSA:3.30.160.60:FF:006462', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163695, NULL, 'G3DSA:3.40.50.10330:FF:000061', NULL, NULL, 'GM18115', NULL, NULL, NULL, NULL, NULL, 4),
(163696, NULL, 'G3DSA:1.10.10.10:FF:001810', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163697, NULL, 'G3DSA:2.40.50.140:FF:000331', NULL, NULL, 'Nucleoporin NUP116/NSP116', NULL, NULL, NULL, NULL, NULL, 4),
(163698, NULL, 'G3DSA:3.40.630.30:FF:000310', NULL, NULL, 'Acteyltransferase GNAT family', NULL, NULL, NULL, NULL, NULL, 4),
(163699, NULL, 'G3DSA:3.10.320.10:FF:000001', NULL, NULL, 'HLA class II histocompatibility antigen, DRB1-1 beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(163700, NULL, 'G3DSA:1.10.357.150:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163701, NULL, 'G3DSA:1.10.8.50:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163702, NULL, 'G3DSA:3.40.50.10190:FF:000237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163703, NULL, 'G3DSA:1.25.10.10:FF:001873', NULL, NULL, 'Slr1098 protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(163704, NULL, 'G3DSA:1.20.120.350:FF:000098', NULL, NULL, 'Calcium channel subunit Cch1', NULL, NULL, NULL, NULL, NULL, 4),
(163705, NULL, 'G3DSA:3.20.20.70:FF:000071', NULL, NULL, 'Hydroxymethylglutaryl-CoA lyase', NULL, NULL, NULL, NULL, NULL, 4),
(163706, NULL, 'G3DSA:2.120.10.30:FF:000213', NULL, NULL, 'Tricorn protease homolog', NULL, NULL, NULL, NULL, NULL, 4),
(163707, NULL, 'G3DSA:2.130.10.10:FF:005265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163708, NULL, 'G3DSA:3.80.10.10:FF:002590', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163709, NULL, 'G3DSA:3.50.50.60:FF:000888', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163710, NULL, 'G3DSA:3.40.50.2000:FF:000856', NULL, NULL, 'Chalcone 4''-O-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(163711, NULL, 'G3DSA:1.10.510.10:FF:002030', NULL, NULL, 'Tau TuBulin Kinase', NULL, NULL, NULL, NULL, NULL, 4),
(163712, NULL, 'G3DSA:3.40.50.410:FF:000133', NULL, NULL, 'Protein transport protein Sec24C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163713, NULL, 'G3DSA:2.130.10.10:FF:003287', NULL, NULL, 'Kinesin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(163714, NULL, 'G3DSA:3.30.710.10:FF:000094', NULL, NULL, 'Armadillo repeat containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(163715, NULL, 'G3DSA:3.30.70.330:FF:000317', NULL, NULL, 'Rox8, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(163716, NULL, 'G3DSA:3.40.390.10:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163717, NULL, 'G3DSA:1.20.1280.50:FF:000125', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163718, NULL, 'G3DSA:3.40.850.10:FF:000079', NULL, NULL, 'Probable chitin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(163719, NULL, 'G3DSA:3.80.10.10:FF:002854', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163720, NULL, 'G3DSA:1.20.120.420:FF:000023', NULL, NULL, 'Methylthioribose-1-phosphate isomerase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(163721, NULL, 'G3DSA:3.40.50.970:FF:000132', NULL, NULL, '2-oxoisovalerate dehydrogenase, E1 component, alpha and beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(163722, NULL, 'G3DSA:3.30.160.60:FF:002623', NULL, NULL, 'Zinc finger protein 422, related sequence 1', NULL, NULL, NULL, NULL, NULL, 4),
(163723, NULL, 'G3DSA:1.20.1560.10:FF:000910', NULL, NULL, 'ABC transporter B family member 29 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(163724, NULL, 'G3DSA:3.50.50.60:FF:000944', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163725, NULL, 'G3DSA:2.40.160.10:FF:000030', NULL, NULL, 'Outer membrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163726, NULL, 'G3DSA:3.30.40.10:FF:001863', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163727, NULL, 'G3DSA:1.20.58.390:FF:000301', NULL, NULL, 'AcetylCholine Receptor', NULL, NULL, NULL, NULL, NULL, 4),
(163728, NULL, 'G3DSA:2.40.240.10:FF:000031', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(163729, NULL, 'G3DSA:3.10.110.10:FF:000283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163730, NULL, 'G3DSA:3.40.50.880:FF:000133', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163731, NULL, 'G3DSA:1.25.40.20:FF:000006', NULL, NULL, 'Arf-GAP with SH3 domain, ANK repeat and PH domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(163732, NULL, 'G3DSA:3.90.550.10:FF:000657', NULL, NULL, 'Glycoside transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(163733, NULL, 'G3DSA:3.90.1260.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163734, NULL, 'G3DSA:1.10.238.210:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163735, NULL, 'G3DSA:3.90.1180.10:FF:000015', NULL, NULL, '60S ribosomal protein L13a isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(163736, NULL, 'G3DSA:1.10.286.10:FF:000006', NULL, NULL, 'GTP cyclohydrolase 1', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(163737, NULL, 'G3DSA:3.40.190.10:FF:000904', NULL, NULL, 'Periplasmic substrate-binding histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(163738, NULL, 'G3DSA:3.40.50.2300:FF:001345', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163739, NULL, 'G3DSA:1.10.590.10:FF:000005', NULL, NULL, 'Chorismate mutase1', NULL, NULL, NULL, NULL, NULL, 4),
(163740, NULL, 'G3DSA:3.40.50.300:FF:000448', NULL, NULL, 'RAB3D, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(163741, NULL, 'G3DSA:2.130.10.10:FF:001050', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163742, NULL, 'G3DSA:2.40.10.10:FF:000216', NULL, NULL, 'Chymase 1', NULL, NULL, NULL, NULL, NULL, 4),
(163743, NULL, 'G3DSA:1.10.287.2620:FF:000017', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163744, NULL, 'G3DSA:1.25.40.790:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163745, NULL, 'G3DSA:3.50.50.60:FF:001405', NULL, NULL, 'Sarcosine oxidase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(163746, NULL, 'G3DSA:3.40.630.30:FF:000254', NULL, NULL, 'Ribosomal-protein-S18p-alanine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(163747, NULL, 'G3DSA:3.90.176.10:FF:000006', NULL, NULL, 'RNA polymerase ADP-ribosylase', NULL, NULL, NULL, NULL, NULL, 4),
(163748, NULL, 'G3DSA:2.60.40.10:FF:003163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163749, NULL, 'G3DSA:1.20.120.350:FF:000154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163750, NULL, 'G3DSA:1.20.900.10:FF:000051', NULL, NULL, 'Phosphatidylinositol-3,4,5-trisphosphate dependent Rac exchange factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(163751, NULL, 'G3DSA:3.10.20.90:FF:000223', NULL, NULL, 'Transcription initiation factor TFIID subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(163752, NULL, 'G3DSA:1.10.287.3810:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163753, NULL, 'G3DSA:1.50.40.10:FF:000181', NULL, NULL, 'Mitochondrial folate transporter/carrier', NULL, NULL, NULL, NULL, NULL, 4),
(163754, NULL, 'G3DSA:3.30.460.20:FF:000026', NULL, NULL, 'Divalent cation transporter', NULL, NULL, NULL, NULL, NULL, 4),
(163755, NULL, 'G3DSA:3.30.160.60:FF:000678', NULL, NULL, 'Myoneurin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(163756, NULL, 'G3DSA:3.40.50.720:FF:002255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163757, NULL, 'G3DSA:3.40.50.10090:FF:000033', NULL, NULL, 'Tetrapyrrole biosynthesis, uroporphyrinogen III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(163758, NULL, 'G3DSA:3.20.80.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163759, NULL, 'G3DSA:1.50.40.10:FF:000029', NULL, NULL, 'Solute carrier family 25 member 28', NULL, NULL, NULL, NULL, NULL, 4),
(163760, NULL, 'G3DSA:3.30.830.10:FF:000097', NULL, NULL, 'Zn-dependent peptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163761, NULL, 'G3DSA:2.60.40.10:FF:003899', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163762, NULL, 'G3DSA:3.30.230.10:FF:000012', NULL, NULL, 'DNA topoisomerase 4 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(163763, NULL, 'G3DSA:2.60.410.10:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163764, NULL, 'G3DSA:3.20.20.80:FF:000225', NULL, NULL, 'Protein PslG', NULL, NULL, NULL, NULL, NULL, 4),
(163765, NULL, 'G3DSA:1.10.8.1220:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163766, NULL, 'G3DSA:1.25.10.10:FF:000092', NULL, NULL, 'apoptosis inhibitor 5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(163767, NULL, 'G3DSA:3.40.50.150:FF:001786', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163768, NULL, 'G3DSA:1.20.58.70:FF:000038', NULL, NULL, 'Unplaced genomic scaffold supercont1.17, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(163769, NULL, 'G3DSA:3.30.60.30:FF:000151', NULL, NULL, 'KAZ1-type serine protease inhibitor-like protein type epsilon', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(163770, NULL, 'G3DSA:1.20.1070.10:FF:001082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163771, NULL, 'G3DSA:3.30.160.60:FF:003612', NULL, NULL, 'Pre-mRNA splicing factor Prp8', NULL, NULL, NULL, NULL, NULL, 4),
(163772, NULL, 'G3DSA:3.40.50.300:FF:000072', NULL, NULL, 'Transcription termination factor Rho', NULL, NULL, NULL, NULL, NULL, 4),
(163773, NULL, 'G3DSA:1.20.120.1080:FF:000008', NULL, NULL, 'probable ATP-dependent RNA helicase YTHDC2', NULL, NULL, NULL, NULL, NULL, 4),
(163774, NULL, 'G3DSA:3.40.50.1460:FF:000008', NULL, NULL, 'caspase-8 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(163775, NULL, 'G3DSA:1.10.10.60:FF:000403', NULL, NULL, 'Transcription repressor MYB4', NULL, NULL, NULL, NULL, NULL, 4),
(163776, NULL, 'G3DSA:1.10.730.10:FF:000101', NULL, NULL, 'Isoleucine--tRNA ligase protein', NULL, NULL, NULL, NULL, NULL, 4),
(163777, NULL, 'G3DSA:2.120.10.10:FF:000027', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163778, NULL, 'G3DSA:3.30.1330.90:FF:000008', NULL, NULL, 'L-serine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(163779, NULL, 'G3DSA:2.60.40.1250:FF:000003', NULL, NULL, 'Thiol:disulfide interchange protein DsbD', NULL, NULL, NULL, NULL, NULL, 4),
(163780, NULL, 'G3DSA:1.10.630.10:FF:000829', NULL, NULL, 'Os06g0267400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(163781, NULL, 'G3DSA:2.60.40.1180:FF:000162', NULL, NULL, 'Alpha-D-1,4-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(163782, NULL, 'G3DSA:3.40.30.10:FF:000968', NULL, NULL, 'Thioredoxin domain containing 8', NULL, NULL, NULL, NULL, NULL, 4),
(163783, NULL, 'G3DSA:1.20.58.1780:FF:000025', NULL, NULL, 'Nuclear pore complex protein NUP155', NULL, NULL, NULL, NULL, NULL, 4),
(163784, NULL, 'G3DSA:2.60.470.10:FF:000026', NULL, NULL, 'FLR-1', NULL, NULL, NULL, NULL, NULL, 4),
(163785, NULL, 'G3DSA:3.40.50.300:FF:002865', NULL, NULL, 'DNA-binding protein MutS2', NULL, NULL, NULL, NULL, NULL, 4),
(163786, NULL, 'G3DSA:3.40.50.150:FF:000858', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(163787, NULL, 'G3DSA:3.30.60.20:FF:000119', NULL, NULL, 'AGAP005583-PA', NULL, NULL, NULL, NULL, NULL, 4),
(163788, NULL, 'G3DSA:3.40.50.11060:FF:000009', NULL, NULL, 'GTPase HflX', NULL, NULL, NULL, NULL, NULL, 4),
(163789, NULL, 'G3DSA:2.130.10.10:FF:004720', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163790, NULL, 'G3DSA:3.30.160.60:FF:000206', NULL, NULL, 'zinc finger protein 202 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(163791, NULL, 'G3DSA:1.10.20.10:FF:000058', NULL, NULL, 'Histone H4', NULL, NULL, NULL, NULL, NULL, 4),
(163792, NULL, 'G3DSA:2.60.290.11:FF:000002', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(163793, NULL, 'G3DSA:1.10.287.70:FF:000436', NULL, NULL, 'Protein CBR-TWK-47', NULL, NULL, NULL, NULL, NULL, 4),
(163794, NULL, 'G3DSA:3.80.10.10:FF:002910', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163795, NULL, 'G3DSA:3.40.50.1580:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163796, NULL, 'G3DSA:1.10.510.10:FF:001338', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163797, NULL, 'G3DSA:1.10.220.120:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163798, NULL, 'G3DSA:1.20.1250.20:FF:001885', NULL, NULL, 'SLC (SoLute Carrier) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(163799, NULL, 'G3DSA:1.20.5.110:FF:000111', NULL, NULL, 'GH06387p', NULL, NULL, NULL, NULL, NULL, 4),
(163800, NULL, 'G3DSA:3.20.20.80:FF:000753', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163801, NULL, 'G3DSA:3.40.50.720:FF:002199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163802, NULL, 'G3DSA:3.40.1180.10:FF:000015', NULL, NULL, 'Diterpene synthase', NULL, NULL, NULL, NULL, NULL, 4),
(163803, NULL, 'G3DSA:2.60.40.150:FF:000373', NULL, NULL, 'Phosphatidylinositol 3-kinase VPS34', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(163804, NULL, 'G3DSA:3.30.830.10:FF:000041', NULL, NULL, 'Protease 3', NULL, NULL, NULL, NULL, NULL, 4),
(163805, NULL, 'G3DSA:3.40.50.150:FF:001842', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163806, NULL, 'G3DSA:1.20.1270.280:FF:000010', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(163807, NULL, 'G3DSA:4.10.1000.10:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163808, NULL, 'G3DSA:1.10.10.1760:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163809, NULL, 'G3DSA:3.40.1160.10:FF:000008', NULL, NULL, 'Acetylglutamate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(163810, NULL, 'G3DSA:3.40.50.10860:FF:000045', NULL, NULL, 'Repressor protein', NULL, NULL, NULL, NULL, NULL, 4),
(163811, NULL, 'G3DSA:2.40.30.10:FF:000302', NULL, NULL, 'G1 to S phase transition protein 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163812, NULL, 'G3DSA:3.30.1460.50:FF:000023', NULL, NULL, 'Autophagy-related protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(163813, NULL, 'G3DSA:3.90.190.10:FF:000202', NULL, NULL, 'Protein tyrosine phosphatase Pps1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163814, NULL, 'G3DSA:1.25.40.10:FF:004983', NULL, NULL, 'Tetratricopeptide repeat domain 21A', NULL, NULL, NULL, NULL, NULL, 4),
(163815, NULL, 'G3DSA:3.30.410.40:FF:000001', NULL, NULL, 'Choline oxidase (CodA)', NULL, NULL, NULL, NULL, NULL, 4),
(163816, NULL, 'G3DSA:2.130.10.10:FF:002775', NULL, NULL, 'Angio-associated, migratory cell protein', NULL, NULL, NULL, NULL, NULL, 4),
(163817, NULL, 'G3DSA:3.30.565.10:FF:000053', NULL, NULL, 'DNA topoisomerase 6 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(163818, NULL, 'G3DSA:3.30.365.10:FF:000009', NULL, NULL, 'Aldehyde oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(163819, NULL, 'G3DSA:1.10.10.440:FF:000064', NULL, NULL, 'Transcription elongation regulator', NULL, NULL, NULL, NULL, NULL, 4),
(163820, NULL, 'G3DSA:1.10.472.80:FF:000224', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163821, NULL, 'G3DSA:3.30.160.60:FF:004101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163822, NULL, 'G3DSA:3.30.160.60:FF:001791', NULL, NULL, 'Zinc finger protein 766', NULL, NULL, NULL, NULL, NULL, 4),
(163823, NULL, 'G3DSA:3.30.1330.30:FF:000036', NULL, NULL, 'Putative 60s ribosomal protein L7a', NULL, NULL, NULL, NULL, NULL, 4),
(163824, NULL, 'G3DSA:1.20.1270.280:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163825, NULL, 'G3DSA:3.30.70.330:FF:001245', NULL, NULL, 'nuclear receptor coactivator 5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(163826, NULL, 'G3DSA:1.20.58.2050:FF:000005', NULL, NULL, 'CG2222-PA', NULL, NULL, NULL, NULL, NULL, 4),
(163827, NULL, 'G3DSA:2.160.10.10:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163828, NULL, 'G3DSA:3.30.40.10:FF:001335', NULL, NULL, 'NEP1-interacting protein-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(163829, NULL, 'G3DSA:2.60.200.20:FF:000044', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(163830, NULL, 'G3DSA:2.60.40.10:FF:004888', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163831, NULL, 'G3DSA:3.30.70.2450:FF:000004', NULL, NULL, 'Octylphenol 4-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(163832, NULL, 'G3DSA:3.10.120.10:FF:000053', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163833, NULL, 'G3DSA:3.80.10.10:FF:001926', NULL, NULL, 'Disease resistance protein RGA5', NULL, NULL, NULL, NULL, NULL, 4),
(163834, NULL, 'G3DSA:2.40.300.10:FF:000002', NULL, NULL, 'Preneck appendage protein', NULL, NULL, NULL, NULL, NULL, 4),
(163835, NULL, 'G3DSA:2.60.40.60:FF:000311', NULL, NULL, 'Kugelei, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(163836, NULL, 'G3DSA:2.40.50.90:FF:000198', NULL, NULL, 'Suppressor of fused homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(163837, NULL, 'G3DSA:3.80.10.10:FF:003490', NULL, NULL, 'AGAP007465-PA', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(163838, NULL, 'G3DSA:1.20.1560.10:FF:000854', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163839, NULL, 'G3DSA:1.10.150.20:FF:000279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163840, NULL, 'G3DSA:3.30.1330.10:FF:000030', NULL, NULL, 'Selenophosphate synthetase 2, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(163841, NULL, 'G3DSA:3.30.200.20:FF:001974', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(163842, NULL, 'G3DSA:1.10.565.10:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163843, NULL, 'G3DSA:3.20.20.220:FF:000075', NULL, NULL, 'Methylenetetrahydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(163844, NULL, 'G3DSA:3.40.30.10:FF:000912', NULL, NULL, 'Thioredoxin fold domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(163845, NULL, 'G3DSA:3.30.200.20:FF:002014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163846, NULL, 'G3DSA:3.40.850.10:FF:000135', NULL, NULL, 'Putative kinesin', NULL, NULL, NULL, NULL, NULL, 4),
(163847, NULL, 'G3DSA:3.40.50.150:FF:001347', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163848, NULL, 'G3DSA:1.25.40.10:FF:001262', NULL, NULL, 'Heat shock protein 70 (HSP70)-interacting protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163849, NULL, 'G3DSA:2.60.40.1180:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163850, NULL, 'G3DSA:1.20.1740.10:FF:000003', NULL, NULL, 'Y+L amino acid transporter 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(163851, NULL, 'G3DSA:1.20.1110.10:FF:000118', NULL, NULL, 'Sarcoplasmic/endoplasmic reticulum calcium ATPase 3', NULL, NULL, NULL, NULL, NULL, 4),
(163852, NULL, 'G3DSA:3.40.50.1440:FF:000002', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(163853, NULL, 'G3DSA:3.40.50.300:FF:007536', NULL, NULL, 'DEAQ box RNA-dependent ATPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(163854, NULL, 'G3DSA:3.30.365.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163855, NULL, 'G3DSA:3.40.1160.10:FF:000071', NULL, NULL, 'Aspartokinase 1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(163856, NULL, 'G3DSA:3.40.720.10:FF:000070', NULL, NULL, 'Arylsulfatase A', NULL, NULL, NULL, NULL, NULL, 4),
(163857, NULL, 'G3DSA:3.40.50.720:FF:001743', NULL, NULL, 'Enoyl-[acyl-carrier-protein] reductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(163858, NULL, 'G3DSA:2.60.220.50:FF:000059', NULL, NULL, 'Adhesion G protein-coupled receptor G11', NULL, NULL, NULL, NULL, NULL, 4),
(163859, NULL, 'G3DSA:3.30.160.60:FF:001667', NULL, NULL, 'tissue-resident T-cell transcription regulator protein ZNF683', NULL, NULL, NULL, NULL, NULL, 4),
(163860, NULL, 'G3DSA:2.60.120.650:FF:000239', NULL, NULL, '40S ribosomal protein S4-3', NULL, NULL, NULL, NULL, NULL, 4),
(163861, NULL, 'G3DSA:3.40.190.10:FF:000899', NULL, NULL, 'Probable sensor/response regulator hybrid', NULL, NULL, NULL, NULL, NULL, 4),
(163862, NULL, 'G3DSA:3.30.200.20:FF:000069', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(163863, NULL, 'G3DSA:1.20.1070.10:FF:000682', NULL, NULL, 'NeuroPeptide Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(163864, NULL, 'G3DSA:2.60.40.1730:FF:000080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163865, NULL, 'G3DSA:1.10.1780.10:FF:000019', NULL, NULL, 'ATP-dependent Clp protease ATP-binding subunit ClpA', NULL, NULL, NULL, NULL, NULL, 4),
(163866, NULL, 'G3DSA:3.40.1360.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163867, NULL, 'G3DSA:2.20.100.10:FF:000244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163868, NULL, 'G3DSA:1.25.40.10:FF:003819', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163869, NULL, 'G3DSA:3.10.580.10:FF:000014', NULL, NULL, 'Cystathionine beta-synthase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(163870, NULL, 'G3DSA:3.20.20.100:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163871, NULL, 'G3DSA:3.40.50.1460:FF:000036', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163872, NULL, 'G3DSA:3.40.50.150:FF:000061', NULL, NULL, 'Caffeic acid O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(163873, NULL, 'G3DSA:1.20.120.1080:FF:000071', NULL, NULL, 'CBN-RHA-2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(163874, NULL, 'G3DSA:2.60.120.330:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163875, NULL, 'G3DSA:1.25.40.10:FF:004191', NULL, NULL, 'Cytochrome c maturation system haem lyase subunit SirG', NULL, NULL, NULL, NULL, NULL, 4),
(163876, NULL, 'G3DSA:1.10.510.10:FF:003339', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163877, NULL, 'G3DSA:3.40.50.2300:FF:001340', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163878, NULL, 'G3DSA:1.20.1250.20:FF:000396', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(163879, NULL, 'G3DSA:3.40.50.1820:FF:000807', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163880, NULL, 'G3DSA:3.30.230.10:FF:000040', NULL, NULL, 'Galactokinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(163881, NULL, 'G3DSA:1.25.70.10:FF:000005', NULL, NULL, 'Transcription termination factor MTERF4, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(163882, NULL, 'G3DSA:3.40.50.300:FF:004607', NULL, NULL, 'Regulator of nonsense transcripts 1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(163883, NULL, 'G3DSA:3.40.30.10:FF:000176', NULL, NULL, 'Glutathione S-transferase theta-1', NULL, NULL, NULL, NULL, NULL, 4),
(163884, NULL, 'G3DSA:3.40.50.1820:FF:000987', NULL, NULL, 'Putative thioesterase, MmyT', NULL, NULL, NULL, NULL, NULL, 4),
(163885, NULL, 'G3DSA:3.90.10.10:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163886, NULL, 'G3DSA:1.10.3720.10:FF:000162', NULL, NULL, 'Binding-protein-dependent transport systems inner membrane component', NULL, NULL, NULL, NULL, NULL, 4),
(163887, NULL, 'G3DSA:3.30.10.30:FF:000001', NULL, NULL, 'Dual specificity tyrosine-phosphorylation-regulated kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(163888, NULL, 'G3DSA:3.40.50.1820:FF:000459', NULL, NULL, 'Hydrolase, alpha/beta fold family protein', NULL, NULL, NULL, NULL, NULL, 4),
(163889, NULL, 'G3DSA:3.30.160.60:FF:005534', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163890, NULL, 'G3DSA:3.30.160.60:FF:006338', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163891, NULL, 'G3DSA:3.40.109.10:FF:000031', NULL, NULL, 'Nitroreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(163892, NULL, 'G3DSA:3.20.20.70:FF:000132', NULL, NULL, 'FMN dependent dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(163893, NULL, 'G3DSA:3.30.1610.10:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163894, NULL, 'G3DSA:3.80.10.10:FF:000673', NULL, NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At2g02780', NULL, NULL, NULL, NULL, NULL, 4),
(163895, NULL, 'G3DSA:2.170.120.30:FF:000014', NULL, NULL, 'YbbR family protein', NULL, NULL, NULL, NULL, NULL, 4),
(163896, NULL, 'G3DSA:3.40.50.360:FF:000011', NULL, NULL, 'Protein NrdI', NULL, NULL, NULL, NULL, NULL, 4),
(163897, NULL, 'G3DSA:4.10.1000.10:FF:000099', NULL, NULL, 'Zinc finger CCCH domain-containing protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(163898, NULL, 'G3DSA:1.10.20.70:FF:000002', NULL, NULL, 'Related to Cleavage stimulation factor', NULL, NULL, NULL, NULL, NULL, 4),
(163899, NULL, 'G3DSA:1.20.58.60:FF:000653', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163900, NULL, 'G3DSA:3.40.605.10:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163901, NULL, 'G3DSA:1.25.10.10:FF:000029', NULL, NULL, 'Transportin-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(163902, NULL, 'G3DSA:2.130.10.10:FF:000414', NULL, NULL, 'Cytoplasmic dynein intermediate chain', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(163903, NULL, 'G3DSA:3.20.20.70:FF:000076', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(163904, NULL, 'G3DSA:3.30.1450.10:FF:000005', NULL, NULL, 'Cell envelope protein SmpA', NULL, NULL, NULL, NULL, NULL, 4),
(163905, NULL, 'G3DSA:2.130.10.30:FF:000128', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163906, NULL, 'G3DSA:2.10.70.10:FF:000171', NULL, NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(163907, NULL, 'G3DSA:1.25.40.10:FF:003971', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163908, NULL, 'G3DSA:1.20.1270.60:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163909, NULL, 'G3DSA:3.40.250.10:FF:000106', NULL, NULL, 'Thiosulfate sulfurtransferase GlpE', NULL, NULL, NULL, NULL, NULL, 4),
(163910, NULL, 'G3DSA:3.90.105.20:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163911, NULL, 'G3DSA:3.40.1180.10:FF:000010', NULL, NULL, 'Alkyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(163912, NULL, 'G3DSA:1.20.120.80:FF:000017', NULL, NULL, 'Cytochrome c oxidase subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(163913, NULL, 'G3DSA:1.10.287.950:FF:000049', NULL, NULL, 'Methyl-accepting chemotaxis sensory transducer, class 34H-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(163914, NULL, 'G3DSA:2.120.10.30:FF:000185', NULL, NULL, 'Acylaminoacyl peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(163915, NULL, 'G3DSA:1.20.1250.20:FF:000873', NULL, NULL, 'YALI0D20350p', NULL, NULL, NULL, NULL, NULL, 4),
(163916, NULL, 'G3DSA:3.30.50.10:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163917, NULL, 'G3DSA:1.20.80.60:FF:000008', NULL, NULL, 'Sorting nexin-27', NULL, NULL, NULL, NULL, NULL, 4),
(163918, NULL, 'G3DSA:3.40.50.2300:FF:001284', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163919, NULL, 'G3DSA:3.30.200.20:FF:000541', NULL, NULL, 'leucine-rich repeat receptor-like serine/threonine/tyrosine-protein kinase SOBIR1', NULL, NULL, NULL, NULL, NULL, 4),
(163920, NULL, 'G3DSA:3.10.20.310:FF:000036', NULL, NULL, 'POTRA domain protein, ShlB-type', NULL, NULL, NULL, NULL, NULL, 4),
(163921, NULL, 'G3DSA:2.60.120.310:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163922, NULL, 'G3DSA:3.30.70.330:FF:002678', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163923, NULL, 'G3DSA:3.40.50.300:FF:000920', NULL, NULL, 'Molybdopterin-guanine dinucleotide biosynthesis protein B', NULL, NULL, NULL, NULL, NULL, 4),
(163924, NULL, 'G3DSA:1.10.167.10:FF:000045', NULL, NULL, 'GD24046', NULL, NULL, NULL, NULL, NULL, 4),
(163925, NULL, 'G3DSA:2.60.40.1910:FF:000010', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(163926, NULL, 'G3DSA:3.30.40.10:FF:000851', NULL, NULL, 'Alcohol sensitive Ring/PHD finger', NULL, NULL, NULL, NULL, NULL, 4),
(163927, NULL, 'G3DSA:3.50.50.60:FF:001344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163928, NULL, 'G3DSA:3.30.450.20:FF:000677', NULL, NULL, 'Blue-light receptor phototropin 2', NULL, NULL, NULL, NULL, NULL, 4),
(163929, NULL, 'G3DSA:3.30.70.1130:FF:000002', NULL, NULL, 'Translation initiation factor 2 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(163930, NULL, 'G3DSA:3.30.200.20:FF:001502', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163931, NULL, 'G3DSA:3.30.70.330:FF:000441', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(163932, NULL, 'G3DSA:1.20.80.40:FF:000002', NULL, NULL, 'U5 snRNA-associated splicing factor', NULL, NULL, NULL, NULL, NULL, 4),
(163933, NULL, 'G3DSA:1.25.40.20:FF:001591', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163934, NULL, 'G3DSA:1.25.40.10:FF:002510', NULL, NULL, 'Proteinaceous RNase P 1, chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(163935, NULL, 'G3DSA:1.10.520.20:FF:000004', NULL, NULL, 'ATP synthase subunit b-delta', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(163936, NULL, 'G3DSA:2.130.10.10:FF:000066', NULL, NULL, 'retinoblastoma-binding protein 5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(163937, NULL, 'G3DSA:2.60.40.60:FF:000255', NULL, NULL, 'protocadherin-23 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(163938, NULL, 'G3DSA:3.30.160.60:FF:005349', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163939, NULL, 'G3DSA:3.30.50.10:FF:000144', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(163940, NULL, 'G3DSA:3.40.190.10:FF:000051', NULL, NULL, 'Membrane-bound lytic murein transglycosylase F', NULL, NULL, NULL, NULL, NULL, 4),
(163941, NULL, 'G3DSA:3.30.160.60:FF:001611', NULL, NULL, 'Zinc finger protein 501', NULL, NULL, NULL, NULL, NULL, 4),
(163942, NULL, 'G3DSA:1.20.1250.20:FF:000401', NULL, NULL, 'Vesicular amine transporter', NULL, NULL, NULL, NULL, NULL, 4),
(163943, NULL, 'G3DSA:1.20.1250.20:FF:001413', NULL, NULL, 'Major facilitator superfamily MFS_1', NULL, NULL, NULL, NULL, NULL, 4),
(163944, NULL, 'G3DSA:2.170.190.11:FF:000019', NULL, NULL, 'LOC100124966 protein', NULL, NULL, NULL, NULL, NULL, 4),
(163945, NULL, 'G3DSA:3.90.79.10:FF:000033', NULL, NULL, 'nucleoside diphosphate-linked moiety X motif 17 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(163946, NULL, 'G3DSA:3.40.50.1240:FF:000206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163947, NULL, 'G3DSA:1.25.40.10:FF:000149', NULL, NULL, 'Clathrin-coated vesiclec protein (Bud7)', NULL, NULL, NULL, NULL, NULL, 4),
(163948, NULL, 'G3DSA:3.30.40.10:FF:001071', NULL, NULL, 'Ring finger protein 180', NULL, NULL, NULL, NULL, NULL, 4),
(163949, NULL, 'G3DSA:1.20.120.1750:FF:000108', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(163950, NULL, 'G3DSA:3.30.310.10:FF:000041', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(163951, NULL, 'G3DSA:3.40.50.720:FF:000815', NULL, NULL, 'Probable short-chain type dehydrogenase/reductase', NULL, NULL, NULL, NULL, NULL, 4),
(163952, NULL, 'G3DSA:2.170.240.10:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163953, NULL, 'G3DSA:1.25.40.1010:FF:000020', NULL, NULL, 'N-terminal acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163954, NULL, 'G3DSA:2.60.40.10:FF:002179', NULL, NULL, 'Hemicentin 2', NULL, NULL, NULL, NULL, NULL, 4),
(163955, NULL, 'G3DSA:3.40.50.2000:FF:000120', NULL, NULL, 'UDP-glycosyltransferase 76C1', NULL, NULL, NULL, NULL, NULL, 4),
(163956, NULL, 'G3DSA:3.30.390.60:FF:000015', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(163957, NULL, 'G3DSA:1.20.1250.10:FF:000067', NULL, NULL, 'Interleukin-3', NULL, NULL, NULL, NULL, NULL, 4),
(163958, NULL, 'G3DSA:3.40.50.300:FF:002073', NULL, NULL, 'Pfk27p', NULL, NULL, NULL, NULL, NULL, 4),
(163959, NULL, 'G3DSA:1.10.8.60:FF:000363', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(163960, NULL, 'G3DSA:1.10.510.10:FF:001046', NULL, NULL, 'Protein kinase Cdc7', NULL, NULL, NULL, NULL, NULL, 4),
(163961, NULL, 'G3DSA:3.40.50.300:FF:000864', NULL, NULL, 'Mov10-like RISC complex RNA helicase 1', NULL, NULL, NULL, NULL, NULL, 4),
(163962, NULL, 'G3DSA:3.40.50.300:FF:003793', NULL, NULL, 'Probable disease resistance protein At5g66900', NULL, NULL, NULL, NULL, NULL, 4),
(163963, NULL, 'G3DSA:1.20.1260.110:FF:000002', NULL, NULL, 'DNA integrity scanning protein DisA', NULL, NULL, NULL, NULL, NULL, 4),
(163964, NULL, 'G3DSA:1.25.40.1030:FF:000026', NULL, NULL, 'Protein transport protein SEC31', NULL, NULL, NULL, NULL, NULL, 4),
(163965, NULL, 'G3DSA:1.10.10.10:FF:001338', NULL, NULL, 'Regulatory protein CysR homolog', NULL, NULL, NULL, NULL, NULL, 4),
(163966, NULL, 'G3DSA:3.30.420.150:FF:000017', NULL, NULL, 'Putative exopolyphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(163967, NULL, 'G3DSA:1.10.390.10:FF:000024', NULL, NULL, 'Peptidase M28', NULL, NULL, NULL, NULL, NULL, 4),
(163968, NULL, 'G3DSA:2.130.10.10:FF:000561', NULL, NULL, 'Putative WD repeat protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(163969, NULL, 'G3DSA:3.80.10.10:FF:000965', NULL, NULL, 'Os12g0108500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(163970, NULL, 'G3DSA:1.10.287.3240:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163971, NULL, 'G3DSA:2.130.10.30:FF:000044', NULL, NULL, 'Serine/threonine-protein kinase-like protein CR4', NULL, NULL, NULL, NULL, NULL, 4),
(163972, NULL, 'G3DSA:3.30.160.60:FF:002595', NULL, NULL, 'Zinc finger and SCAN domain containing 10', NULL, NULL, NULL, NULL, NULL, 4),
(163973, NULL, 'G3DSA:3.30.160.60:FF:004192', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163974, NULL, 'G3DSA:3.30.1490.10:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163975, NULL, 'G3DSA:3.40.50.2020:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163976, NULL, 'G3DSA:3.30.2420.10:FF:000003', NULL, NULL, 'Protein TonB', NULL, NULL, NULL, NULL, NULL, 4),
(163977, NULL, 'G3DSA:1.10.287.70:FF:000583', NULL, NULL, 'Glutamate receptor 3.5', NULL, NULL, NULL, NULL, NULL, 4),
(163978, NULL, 'G3DSA:3.40.50.620:FF:000898', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163979, NULL, 'G3DSA:3.30.60.30:FF:000095', NULL, NULL, 'Complement component C7', NULL, NULL, NULL, NULL, NULL, 4),
(163980, NULL, 'G3DSA:2.40.50.100:FF:000111', NULL, NULL, 'Oxaloacetate decarboxylase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(163981, NULL, 'G3DSA:2.40.440.10:FF:000012', NULL, NULL, 'L,D-transpeptidase catalytic domain', NULL, NULL, NULL, NULL, NULL, 4),
(163982, NULL, 'G3DSA:1.25.40.550:FF:000008', NULL, NULL, 'A1 cistron-splicing factor AAR2', NULL, NULL, NULL, NULL, NULL, 4),
(163983, NULL, 'G3DSA:1.10.418.10:FF:000022', NULL, NULL, 'Short stop, isoform K', NULL, NULL, NULL, NULL, NULL, 4),
(163984, NULL, 'G3DSA:1.10.10.60:FF:000111', NULL, NULL, 'Two-component system response regulator GlrR', NULL, NULL, NULL, NULL, NULL, 4),
(163985, NULL, 'G3DSA:3.30.160.60:FF:003556', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163986, NULL, 'G3DSA:2.60.40.790:FF:000070', NULL, NULL, 'CG7409', NULL, NULL, NULL, NULL, NULL, 4),
(163987, NULL, 'G3DSA:1.10.110.10:FF:000009', NULL, NULL, 'Non-specific lipid transfer protein-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(163988, NULL, 'G3DSA:3.30.70.120:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163989, NULL, 'G3DSA:2.60.40.200:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163990, NULL, 'G3DSA:2.130.10.10:FF:004304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163991, NULL, 'G3DSA:3.40.5.10:FF:000023', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(163992, NULL, 'G3DSA:3.90.70.10:FF:000480', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(163993, NULL, 'G3DSA:2.60.40.780:FF:000005', NULL, NULL, 'Iduronate-sulfatase (Partial) and sulfatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(163994, NULL, 'G3DSA:1.20.58.100:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163995, NULL, 'G3DSA:3.40.1260.10:FF:000011', NULL, NULL, 'Intracellular sulfur oxidation protein DsrF', NULL, NULL, NULL, NULL, NULL, 4),
(163996, NULL, 'G3DSA:3.30.160.60:FF:004540', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(163997, NULL, 'G3DSA:1.20.1250.20:FF:001705', NULL, NULL, 'Organic anion transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(163998, NULL, 'G3DSA:2.102.10.10:FF:000040', NULL, NULL, 'Toluene 12-dioxygenase system ferredoxin subunit protein', NULL, NULL, NULL, NULL, NULL, 4),
(163999, NULL, 'G3DSA:2.10.77.10:FF:000001', NULL, NULL, 'Hemagglutinin', NULL, NULL, NULL, NULL, NULL, 4),
(164000, NULL, 'G3DSA:1.10.1410.10:FF:000060', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164001, NULL, 'G3DSA:2.60.40.150:FF:000378', NULL, NULL, 'Putative copine', NULL, NULL, NULL, NULL, NULL, 4),
(164002, NULL, 'G3DSA:2.70.130.10:FF:000162', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164003, NULL, 'G3DSA:3.30.720.170:FF:000001', NULL, NULL, 'Perilipin', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(164004, NULL, 'G3DSA:1.10.510.10:FF:001102', NULL, NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', NULL, NULL, NULL, NULL, NULL, 4),
(164005, NULL, 'G3DSA:1.25.40.20:FF:000478', NULL, NULL, 'Palmitoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(164006, NULL, 'G3DSA:1.10.1240.40:FF:000004', NULL, NULL, 'Protein EMSY-LIKE 4', NULL, NULL, NULL, NULL, NULL, 4),
(164007, NULL, 'G3DSA:2.10.50.10:FF:000136', NULL, NULL, 'Zgc:153759', NULL, NULL, NULL, NULL, NULL, 4),
(164008, NULL, 'G3DSA:3.30.40.10:FF:000879', NULL, NULL, 'abscission/NoCut checkpoint regulator', NULL, NULL, NULL, NULL, NULL, 4),
(164009, NULL, 'G3DSA:1.10.533.10:FF:000273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164010, NULL, 'G3DSA:3.60.21.10:FF:000183', NULL, NULL, 'Serine/threonine protein phosphatase 7', NULL, NULL, NULL, NULL, NULL, 4),
(164011, NULL, 'G3DSA:3.90.550.10:FF:000281', NULL, NULL, '16S rRNA processing protein RimM family', NULL, NULL, NULL, NULL, NULL, 4),
(164012, NULL, 'G3DSA:2.60.200.20:FF:000100', NULL, NULL, 'Serine/threonine protein kinase cds1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164013, NULL, 'G3DSA:2.60.40.10:FF:003955', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164014, NULL, 'G3DSA:1.10.1520.10:FF:000118', NULL, NULL, 'DsRNA-specific nuclease dicer and related ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(164015, NULL, 'G3DSA:1.50.40.10:FF:000557', NULL, NULL, 'Mitochondrial fusion and transport protein ugo1', NULL, NULL, NULL, NULL, NULL, 4),
(164016, NULL, 'G3DSA:2.130.10.30:FF:000100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164017, NULL, 'G3DSA:2.60.40.1930:FF:000016', NULL, NULL, 'Thioester-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(164018, NULL, 'G3DSA:1.25.10.30:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164019, NULL, 'G3DSA:3.30.70.260:FF:000072', NULL, NULL, 'Probable aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(164020, NULL, 'G3DSA:3.30.70.330:FF:000789', NULL, NULL, 'RNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(164021, NULL, 'G3DSA:3.30.40.10:FF:001627', NULL, NULL, 'Tripartite motif-containing protein 28', NULL, NULL, NULL, NULL, NULL, 4),
(164022, NULL, 'G3DSA:3.60.21.10:FF:000036', NULL, NULL, 'Serine/threonine protein phosphatase 5', NULL, NULL, NULL, NULL, NULL, 4),
(164023, NULL, 'G3DSA:2.60.40.650:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164024, NULL, 'G3DSA:2.40.10.10:FF:000211', NULL, NULL, 'serine proteinase stubble isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(164025, NULL, 'G3DSA:1.20.1250.20:FF:000581', NULL, NULL, 'Major Facilitator Superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(164026, NULL, 'G3DSA:3.40.50.2000:FF:000912', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164027, NULL, 'G3DSA:1.20.5.110:FF:000055', NULL, NULL, 'vesicle-associated membrane protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(164028, NULL, 'G3DSA:3.30.499.10:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164029, NULL, 'G3DSA:2.170.270.10:FF:000159', NULL, NULL, 'Histone methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(164030, NULL, 'G3DSA:3.30.70.1560:FF:000013', NULL, NULL, 'tRNA pseudouridine synthase A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164031, NULL, 'G3DSA:3.50.50.60:FF:000416', NULL, NULL, 'NADH oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(164032, NULL, 'G3DSA:3.30.160.60:FF:004045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164033, NULL, 'G3DSA:3.90.1150.210:FF:000022', NULL, NULL, 'F-actin-capping protein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(164034, NULL, 'G3DSA:1.25.10.10:FF:000001', NULL, NULL, 'CLIP-associating protein 1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(164035, NULL, 'G3DSA:1.10.287.110:FF:000005', NULL, NULL, 'DnaJ (Hsp40) homolog, subfamily B, member 4', NULL, NULL, NULL, NULL, NULL, 4),
(164036, NULL, 'G3DSA:3.50.50.60:FF:001400', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(164037, NULL, 'G3DSA:1.20.1250.20:FF:000957', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164038, NULL, 'G3DSA:3.30.200.20:FF:002430', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164039, NULL, 'G3DSA:1.10.20.10:FF:000114', NULL, NULL, 'Taf3p', NULL, NULL, NULL, NULL, NULL, 4),
(164040, NULL, 'G3DSA:1.10.10.10:FF:001254', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(164041, NULL, 'G3DSA:1.10.510.10:FF:000085', NULL, NULL, 'Serine/threonine-protein kinase SRK2E', NULL, NULL, NULL, NULL, NULL, 4),
(164042, NULL, 'G3DSA:3.30.70.330:FF:001189', NULL, NULL, 'RNA-binding protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(164043, NULL, 'G3DSA:1.20.1250.20:FF:001357', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164044, NULL, 'G3DSA:2.60.40.10:FF:002235', NULL, NULL, 'Diverse immunoglobulin domain-containing protein 1.16', NULL, NULL, NULL, NULL, NULL, 4),
(164045, NULL, 'G3DSA:1.20.140.150:FF:000047', NULL, NULL, 'transmembrane protein 114 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(164046, NULL, 'G3DSA:3.30.160.60:FF:003409', NULL, NULL, 'zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(164047, NULL, 'G3DSA:1.25.40.20:FF:001411', NULL, NULL, 'Oxysterol-binding protein homolog C2F12.05c', NULL, NULL, NULL, NULL, NULL, 4),
(164048, NULL, 'G3DSA:3.30.40.230:FF:000012', NULL, NULL, 'GlycyltRNA synthetase. Putative', NULL, NULL, NULL, NULL, NULL, 4),
(164049, NULL, 'G3DSA:3.90.550.20:FF:000014', NULL, NULL, 'Glycosyl transferase, putative (AFU_orthologue AFUA_8G02040)', NULL, NULL, NULL, NULL, NULL, 4),
(164050, NULL, 'G3DSA:2.60.40.60:FF:000783', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164051, NULL, 'G3DSA:3.30.70.330:FF:002734', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164052, NULL, 'G3DSA:3.80.10.10:FF:000437', NULL, NULL, 'NLR family pyrin domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(164053, NULL, 'G3DSA:1.10.287.1490:FF:000150', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(164054, NULL, 'G3DSA:3.30.1370.10:FF:000004', NULL, NULL, 'Fragile X mental retardation 1, isoform CRA_e', NULL, NULL, NULL, NULL, NULL, 4),
(164055, NULL, 'G3DSA:2.130.10.10:FF:002359', NULL, NULL, 'Guanine nucleotide-binding protein subunit beta-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(164056, NULL, 'G3DSA:2.60.90.10:FF:000001', NULL, NULL, 'Fiber', NULL, NULL, NULL, NULL, NULL, 4),
(164057, NULL, 'G3DSA:1.10.533.10:FF:000126', NULL, NULL, 'Tumor necrosis factor receptor superfamily, member 1a', NULL, NULL, NULL, NULL, NULL, 4),
(164058, NULL, 'G3DSA:1.20.120.790:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164059, NULL, 'G3DSA:3.60.15.10:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164060, NULL, 'G3DSA:3.90.470.20:FF:000013', NULL, NULL, 'L-aminoadipate-semialdehyde dehydrogenase-phosphopantetheinyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(164061, NULL, 'G3DSA:1.20.1070.10:FF:000974', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164062, NULL, 'G3DSA:3.40.250.10:FF:000022', NULL, NULL, 'Thiosulfate sulfurtransferase/rhodanese-like domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(164063, NULL, 'G3DSA:2.40.50.220:FF:000001', NULL, NULL, 'Ethanolamine utilization microcompartment protein EutN', NULL, NULL, NULL, NULL, NULL, 4),
(164064, NULL, 'G3DSA:3.30.70.260:FF:000009', NULL, NULL, 'Acetolactate synthase isozyme 2 small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(164065, NULL, 'G3DSA:3.90.70.10:FF:000328', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 38', NULL, NULL, NULL, NULL, NULL, 4),
(164066, NULL, 'G3DSA:1.25.10.10:FF:003435', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164067, NULL, 'G3DSA:1.20.58.530:FF:000034', NULL, NULL, 'Heavy chain, Unconventional Myosin', NULL, NULL, NULL, NULL, NULL, 4),
(164068, NULL, 'G3DSA:3.10.20.90:FF:000751', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(164069, NULL, 'G3DSA:2.10.70.10:FF:000204', NULL, NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(164070, NULL, 'G3DSA:1.10.238.10:FF:000513', NULL, NULL, 'Magu, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(164071, NULL, 'G3DSA:1.10.10.10:FF:001777', NULL, NULL, 'Selenocysteine-specific translation elongation factor', NULL, NULL, NULL, NULL, NULL, 4),
(164072, NULL, 'G3DSA:1.25.40.20:FF:001439', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164073, NULL, 'G3DSA:1.10.287.130:FF:000163', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(164074, NULL, 'G3DSA:2.10.70.10:FF:000019', NULL, NULL, 'Complement factor b,-like', NULL, NULL, NULL, NULL, NULL, 4),
(164075, NULL, 'G3DSA:3.90.320.10:FF:000056', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164076, NULL, 'G3DSA:3.30.200.20:FF:000485', NULL, NULL, 'Dual-specificity kinase', NULL, NULL, NULL, NULL, NULL, 4),
(164077, NULL, 'G3DSA:2.130.10.10:FF:000122', NULL, NULL, 'THO complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(164078, NULL, 'G3DSA:3.10.50.10:FF:000010', NULL, NULL, 'Chitinase A1', NULL, NULL, NULL, NULL, NULL, 4),
(164079, NULL, 'G3DSA:2.40.50.140:FF:000275', NULL, NULL, 'mRNA-capping enzyme subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(164080, NULL, 'G3DSA:3.90.550.10:FF:000129', NULL, NULL, 'Glycosyltransferase family 2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(164081, NULL, 'G3DSA:3.20.20.80:FF:000697', NULL, NULL, 'Alpha-amylase 4', NULL, NULL, NULL, NULL, NULL, 4),
(164082, NULL, 'G3DSA:3.40.1190.20:FF:000081', NULL, NULL, 'Pyridoxal kinase', NULL, NULL, NULL, NULL, NULL, 4),
(164083, NULL, 'G3DSA:2.60.120.340:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164084, NULL, 'G3DSA:3.40.50.1100:FF:000272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164085, NULL, 'G3DSA:3.30.420.10:FF:000228', NULL, NULL, 'ISPsy11, transposase OrfB', NULL, NULL, NULL, NULL, NULL, 4),
(164086, NULL, 'G3DSA:3.40.50.620:FF:000903', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164087, NULL, 'G3DSA:1.10.510.10:FF:003491', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164088, NULL, 'G3DSA:3.90.190.20:FF:000003', NULL, NULL, 'UDP-N-acetylmuramoylalanine--D-glutamate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(164089, NULL, 'G3DSA:3.30.930.10:FF:000222', NULL, NULL, 'Prolyl-tRNA synthetase, mitochondrial, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(164090, NULL, 'G3DSA:1.20.140.50:FF:000004', NULL, NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(164091, NULL, 'G3DSA:2.60.120.260:FF:000072', NULL, NULL, 'Proprotein convertase subtilisin/kexin type', NULL, NULL, NULL, NULL, NULL, 4),
(164092, NULL, 'G3DSA:3.40.50.2300:FF:000704', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164093, NULL, 'G3DSA:3.20.20.80:FF:000309', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(164094, NULL, 'G3DSA:3.40.50.300:FF:006047', NULL, NULL, 'ATP-binding cassette subfamily B member 1', NULL, NULL, NULL, NULL, NULL, 4),
(164095, NULL, 'G3DSA:3.30.930.10:FF:000166', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(164096, NULL, 'G3DSA:3.40.190.10:FF:000612', NULL, NULL, 'Phosphate ABC transporter, periplasmic phosphate-binding protein PstS', NULL, NULL, NULL, NULL, NULL, 4),
(164097, NULL, 'G3DSA:2.130.10.10:FF:003472', NULL, NULL, 'WD repeat-containing protein 66-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(164098, NULL, 'G3DSA:2.30.29.30:FF:001165', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(164099, NULL, 'G3DSA:2.30.30.140:FF:000048', NULL, NULL, 'Tudor domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(164100, NULL, 'G3DSA:3.40.630.30:FF:000490', NULL, NULL, '[Ribosomal protein S18]-alanine N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(164101, NULL, 'G3DSA:2.30.180.10:FF:000022', NULL, NULL, 'fasciclin-like arabinogalactan protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(164102, NULL, 'G3DSA:3.80.10.10:FF:001365', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', NULL, NULL, NULL, NULL, NULL, 4),
(164103, NULL, 'G3DSA:3.40.50.620:FF:000050', NULL, NULL, 'Isoleucyl-tRNA synthetase,cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(164104, NULL, 'G3DSA:3.30.1520.10:FF:000185', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164105, NULL, 'G3DSA:1.20.120.350:FF:000007', NULL, NULL, 'Voltage-dependent T-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(164106, NULL, 'G3DSA:3.10.250.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164107, NULL, 'G3DSA:3.40.190.90:FF:000001', NULL, NULL, 'Fructose-1,6-bisphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(164108, NULL, 'G3DSA:3.50.50.60:FF:001113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164109, NULL, 'G3DSA:4.10.1000.10:FF:000043', NULL, NULL, 'tRNA methyltransferase 44 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(164110, NULL, 'G3DSA:2.130.10.10:FF:000830', NULL, NULL, 'Putative chromatin assembly factor 1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(164111, NULL, 'G3DSA:3.10.250.10:FF:000113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164112, NULL, 'G3DSA:1.10.287.10:FF:000025', NULL, NULL, 'Glycine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(164113, NULL, 'G3DSA:1.10.1060.10:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164114, NULL, 'G3DSA:3.80.10.10:FF:001893', NULL, NULL, 'Pxn-1', NULL, NULL, NULL, NULL, NULL, 4),
(164115, NULL, 'G3DSA:3.30.70.920:FF:000051', NULL, NULL, 'Uncharacterized HTH-type transcriptional regulator PH1519', NULL, NULL, NULL, NULL, NULL, 4),
(164116, NULL, 'G3DSA:3.40.50.720:FF:000310', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(P)+]', NULL, NULL, NULL, NULL, NULL, 4),
(164117, NULL, 'G3DSA:3.40.50.300:FF:006996', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164118, NULL, 'G3DSA:3.30.70.330:FF:001661', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164119, NULL, 'G3DSA:2.60.120.200:FF:000745', NULL, NULL, 'Collagen XV alpha 1 chain', NULL, NULL, NULL, NULL, NULL, 4),
(164120, NULL, 'G3DSA:3.30.30.30:FF:000031', NULL, NULL, 'Protein CBG02604', NULL, NULL, NULL, NULL, NULL, 4),
(164121, NULL, 'G3DSA:1.25.10.10:FF:003290', NULL, NULL, 'SNF2 superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(164122, NULL, 'G3DSA:2.70.150.10:FF:000253', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(164123, NULL, 'G3DSA:2.30.30.180:FF:000009', NULL, NULL, 'Ribosome maturation factor RimP', NULL, NULL, NULL, NULL, NULL, 4),
(164124, NULL, 'G3DSA:2.60.40.60:FF:000816', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164125, NULL, 'G3DSA:3.30.1120.120:FF:000006', NULL, NULL, 'Serine/threonine-protein kinase PLK4', NULL, NULL, NULL, NULL, NULL, 4),
(164126, NULL, 'G3DSA:1.20.1070.10:FF:001643', NULL, NULL, 'Secretin receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164127, NULL, 'G3DSA:3.40.50.300:FF:008177', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(164128, NULL, 'G3DSA:3.40.50.1100:FF:000125', NULL, NULL, 'Putative cysteine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(164129, NULL, 'G3DSA:3.30.200.20:FF:001558', NULL, NULL, 'AGAP010162-PA', NULL, NULL, NULL, NULL, NULL, 4),
(164130, NULL, 'G3DSA:2.130.10.10:FF:001286', NULL, NULL, 'WD repeat-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164131, NULL, 'G3DSA:3.30.420.40:FF:000058', NULL, NULL, 'Putative actin-related protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(164132, NULL, 'G3DSA:1.10.472.10:FF:000720', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164133, NULL, 'G3DSA:2.60.40.10:FF:004124', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164134, NULL, 'G3DSA:1.25.40.10:FF:000621', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(164135, NULL, 'G3DSA:3.10.129.10:FF:000101', NULL, NULL, '3-hydroxyacyl-thioester dehydratase HtdY', NULL, NULL, NULL, NULL, NULL, 4),
(164136, NULL, 'G3DSA:2.40.420.20:FF:000042', NULL, NULL, 'HlyD family secretion protein', NULL, NULL, NULL, NULL, NULL, 4),
(164137, NULL, 'G3DSA:1.10.510.10:FF:004452', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164138, NULL, 'G3DSA:1.10.150.20:FF:000195', NULL, NULL, 'DNA polymerase eta', NULL, NULL, NULL, NULL, NULL, 4),
(164139, NULL, 'G3DSA:3.90.1800.10:FF:000013', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(164140, NULL, 'G3DSA:1.20.120.340:FF:000010', NULL, NULL, 'Flagellar protein FliS', NULL, NULL, NULL, NULL, NULL, 4),
(164141, NULL, 'G3DSA:3.90.1720.10:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164142, NULL, 'G3DSA:3.20.20.140:FF:000062', NULL, NULL, 'Adenosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(164143, NULL, 'G3DSA:3.30.460.10:FF:000113', NULL, NULL, 'Interleukin enhancer-binding factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(164144, NULL, 'G3DSA:3.90.190.20:FF:000059', NULL, NULL, 'Bifunctional folylpolyglutamate synthase/dihydrofolate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(164145, NULL, 'G3DSA:1.20.1070.10:FF:002099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164146, NULL, 'G3DSA:3.40.50.300:FF:004338', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164147, NULL, 'G3DSA:3.30.420.10:FF:000195', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(164148, NULL, 'G3DSA:1.10.238.10:FF:001238', NULL, NULL, 'NKD2, WNT signaling pathway inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(164149, NULL, 'G3DSA:2.60.120.330:FF:000172', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164150, NULL, 'G3DSA:1.20.1250.20:FF:000429', NULL, NULL, 'MFS drug efflux transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164151, NULL, 'G3DSA:1.10.10.160:FF:000047', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(164152, NULL, 'G3DSA:3.60.20.10:FF:000253', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164153, NULL, 'G3DSA:2.60.40.10:FF:004652', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164154, NULL, 'G3DSA:3.30.310.130:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164155, NULL, 'G3DSA:2.130.10.10:FF:005557', NULL, NULL, 'Type II inositol polyphosphate 5-phosphatase 15', NULL, NULL, NULL, NULL, NULL, 4),
(164156, NULL, 'G3DSA:1.25.10.10:FF:001249', NULL, NULL, 'MMS19 nucleotide excision repair protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(164157, NULL, 'G3DSA:2.60.40.3120:FF:000002', NULL, NULL, 'cytosolic carboxypeptidase-like protein 5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(164158, NULL, 'G3DSA:3.40.50.1780:FF:000014', NULL, NULL, 'Long irondependent hydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164159, NULL, 'G3DSA:3.40.50.1010:FF:000250', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164160, NULL, 'G3DSA:2.70.150.10:FF:000197', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(164161, NULL, 'G3DSA:2.60.40.10:FF:001690', NULL, NULL, 'Immunoglobulin heavy constant epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(164162, NULL, 'G3DSA:1.25.10.10:FF:001581', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164163, NULL, 'G3DSA:1.10.1670.10:FF:000073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164164, NULL, 'G3DSA:3.30.70.870:FF:000013', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(164165, NULL, 'G3DSA:1.10.1420.10:FF:000026', NULL, NULL, 'DNA mismatch repair protein MSH5', NULL, NULL, NULL, NULL, NULL, 4),
(164166, NULL, 'G3DSA:1.10.510.10:FF:001810', NULL, NULL, 'Protein CBG24469', NULL, NULL, NULL, NULL, NULL, 4),
(164167, NULL, 'G3DSA:2.30.30.360:FF:000002', NULL, NULL, 'Unconventional myosin-VI', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(164168, NULL, 'G3DSA:1.20.1740.10:FF:000239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164169, NULL, 'G3DSA:2.180.10.10:FF:000013', NULL, NULL, 'Si:dkey-34l15.2', NULL, NULL, NULL, NULL, NULL, 4),
(164170, NULL, 'G3DSA:3.40.50.300:FF:008233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164171, NULL, 'G3DSA:4.10.410.10:FF:000026', NULL, NULL, 'Serine protease inhibitor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164172, NULL, 'G3DSA:1.10.1510.30:FF:000011', NULL, NULL, 'Probable tRNA pseudouridine synthase D', NULL, NULL, NULL, NULL, NULL, 4),
(164173, NULL, 'G3DSA:3.50.70.10:FF:000009', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164174, NULL, 'G3DSA:2.40.100.10:FF:000105', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(164175, NULL, 'G3DSA:1.20.1270.60:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164176, NULL, 'G3DSA:2.60.120.290:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164177, NULL, 'G3DSA:3.90.640.10:FF:000164', NULL, NULL, 'Os08g0369300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(164178, NULL, 'G3DSA:3.30.310.10:FF:000069', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(164179, NULL, 'G3DSA:3.30.710.10:FF:000386', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164180, NULL, 'G3DSA:1.25.40.10:FF:000565', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(164181, NULL, 'G3DSA:2.130.10.10:FF:001342', NULL, NULL, 'Target of rapamycin complex subunit lst8', NULL, NULL, NULL, NULL, NULL, 4),
(164182, NULL, 'G3DSA:1.10.506.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164183, NULL, 'G3DSA:1.10.510.10:FF:002794', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164184, NULL, 'G3DSA:3.30.160.60:FF:003792', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164185, NULL, 'G3DSA:3.90.180.10:FF:000084', NULL, NULL, 'NADH oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(164186, NULL, 'G3DSA:3.40.50.450:FF:000066', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(164187, NULL, 'G3DSA:2.40.70.10:FF:000372', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164188, NULL, 'G3DSA:1.10.10.60:FF:000550', NULL, NULL, 'Homeobox domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(164189, NULL, 'G3DSA:2.30.30.570:FF:000003', NULL, NULL, 'Major vault protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(164190, NULL, 'G3DSA:2.40.50.1070:FF:000004', NULL, NULL, '23S rRNA (uracil(1939)-C(5))-methyltransferase RlmD', NULL, NULL, NULL, NULL, NULL, 4),
(164191, NULL, 'G3DSA:3.30.160.60:FF:003264', NULL, NULL, 'Juxtaposed with another zinc finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(164192, NULL, 'G3DSA:3.30.479.20:FF:000052', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(164193, NULL, 'G3DSA:3.40.50.150:FF:001494', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164194, NULL, 'G3DSA:2.130.10.10:FF:003848', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164195, NULL, 'G3DSA:3.40.50.12780:FF:000065', NULL, NULL, 'Fatty-acid-CoA ligase FadD34', NULL, NULL, NULL, NULL, NULL, 4),
(164196, NULL, 'G3DSA:4.10.400.10:FF:000256', NULL, NULL, 'Serine protease P146', NULL, NULL, NULL, NULL, NULL, 4),
(164197, NULL, 'G3DSA:1.25.40.10:FF:003999', NULL, NULL, 'Pentatricopeptide repeat-containing protein 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(164198, NULL, 'G3DSA:2.130.10.10:FF:004776', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164199, NULL, 'G3DSA:3.30.230.10:FF:000068', NULL, NULL, 'Homoserine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(164200, NULL, 'G3DSA:3.40.50.620:FF:000426', NULL, NULL, 'Leucyl-tRNA synthetase a', NULL, NULL, NULL, NULL, NULL, 4),
(164201, NULL, 'G3DSA:3.40.50.970:FF:000188', NULL, NULL, 'Pyruvate:ferredoxin oxidoreductase F', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(164202, NULL, 'G3DSA:1.10.3060.10:FF:000010', NULL, NULL, 'Protein translocase subunit SecA 2', NULL, NULL, NULL, NULL, NULL, 4),
(164203, NULL, 'G3DSA:3.30.40.10:FF:002032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164204, NULL, 'G3DSA:3.10.110.10:FF:000316', NULL, NULL, 'Os06g0506600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(164205, NULL, 'G3DSA:1.50.40.10:FF:000265', NULL, NULL, 'Mitochondrial glycine transporter', NULL, NULL, NULL, NULL, NULL, 4),
(164206, NULL, 'G3DSA:3.30.70.3460:FF:000004', NULL, NULL, 'Putative heme biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(164207, NULL, 'G3DSA:3.30.559.10:FF:000196', NULL, NULL, 'Alcohol acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(164208, NULL, 'G3DSA:2.30.30.40:FF:000255', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(164209, NULL, 'G3DSA:2.40.160.180:FF:000004', NULL, NULL, 'Porin', NULL, NULL, NULL, NULL, NULL, 4),
(164210, NULL, 'G3DSA:3.40.50.1820:FF:000195', NULL, NULL, 'Proline iminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(164211, NULL, 'G3DSA:1.20.1310.10:FF:000162', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164212, NULL, 'G3DSA:1.25.40.340:FF:000002', NULL, NULL, 'Dihydroxyacetone kinase, L subunit', NULL, NULL, NULL, NULL, NULL, 4),
(164213, NULL, 'G3DSA:3.40.50.1000:FF:000096', NULL, NULL, 'Trehalose 6-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(164214, NULL, 'G3DSA:2.40.50.140:FF:000359', NULL, NULL, 'Translation initiation factor IF-1', NULL, NULL, NULL, NULL, NULL, 4),
(164215, NULL, 'G3DSA:3.40.630.30:FF:000338', NULL, NULL, 'Ribosomal-protein-alanine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(164216, NULL, 'G3DSA:3.90.550.10:FF:000573', NULL, NULL, 'Mannosyl-3-phosphoglycerate synthase/mannosyl-3-phosphoglycerate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(164217, NULL, 'G3DSA:2.60.40.1120:FF:000015', NULL, NULL, 'carboxypeptidase D isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(164218, NULL, 'G3DSA:2.60.40.10:FF:000381', NULL, NULL, 'Neural cell adhesion molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(164219, NULL, 'G3DSA:1.10.8.870:FF:000015', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(164220, NULL, 'G3DSA:1.50.10.10:FF:000061', NULL, NULL, 'LanC-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(164221, NULL, 'G3DSA:2.60.40.10:FF:002090', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(164222, NULL, 'G3DSA:3.30.40.10:FF:000374', NULL, NULL, 'Autoimmune regulator', NULL, NULL, NULL, NULL, NULL, 4),
(164223, NULL, 'G3DSA:3.80.30.30:FF:000006', NULL, NULL, 'DNA repair photolyase', NULL, NULL, NULL, NULL, NULL, 4),
(164224, NULL, 'G3DSA:1.10.472.10:FF:000012', NULL, NULL, 'G1/S-specific cyclin-D1', NULL, NULL, NULL, NULL, NULL, 4),
(164225, NULL, 'G3DSA:3.20.70.20:FF:000053', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164226, NULL, 'G3DSA:1.20.940.10:FF:000025', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164227, NULL, 'G3DSA:3.30.70.1170:FF:000019', NULL, NULL, 'RNA methylase, NOL1/NOP2/sun family', NULL, NULL, NULL, NULL, NULL, 4),
(164228, NULL, 'G3DSA:3.40.50.300:FF:003118', NULL, NULL, 'ATP-dependent RNA helicase, DEAD box family', NULL, NULL, NULL, NULL, NULL, 4),
(164229, NULL, 'G3DSA:1.10.238.10:FF:000457', NULL, NULL, 'mRNA, clone: RTFL01-44-H24', NULL, NULL, NULL, NULL, NULL, 4),
(164230, NULL, 'G3DSA:1.20.120.740:FF:000001', NULL, NULL, 'UPF0149 protein YgfB', NULL, NULL, NULL, NULL, NULL, 4),
(164231, NULL, 'G3DSA:3.90.740.10:FF:000020', NULL, NULL, 'Leucine--tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164232, NULL, 'G3DSA:3.40.50.150:FF:000622', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164233, NULL, 'G3DSA:2.60.120.200:FF:000458', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164234, NULL, 'G3DSA:3.50.50.60:FF:000708', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(164235, NULL, 'G3DSA:3.30.40.10:FF:000935', NULL, NULL, 'E3 ubiquitin-protein ligase RNF187', NULL, NULL, NULL, NULL, NULL, 4),
(164236, NULL, 'G3DSA:2.10.25.10:FF:000100', NULL, NULL, 'neurogenic locus notch homolog protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(164237, NULL, 'G3DSA:3.80.10.10:FF:004416', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164238, NULL, 'G3DSA:3.60.110.10:FF:000086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164239, NULL, 'G3DSA:1.25.10.10:FF:003379', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164240, NULL, 'G3DSA:1.25.40.20:FF:001883', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164241, NULL, 'G3DSA:1.10.510.10:FF:002322', NULL, NULL, 'Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(164242, NULL, 'G3DSA:3.40.50.740:FF:000029', NULL, NULL, 'NADH-quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(164243, NULL, 'G3DSA:1.25.40.610:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164244, NULL, 'G3DSA:3.10.450.10:FF:000010', NULL, NULL, 'Alpha-2-HS-glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(164245, NULL, 'G3DSA:2.10.25.10:FF:001264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164246, NULL, 'G3DSA:1.10.510.10:FF:003608', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164247, NULL, 'G3DSA:3.30.450.150:FF:000001', NULL, NULL, 'Cob(I)yrinic acid a,c-diamide adenosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(164248, NULL, 'G3DSA:1.10.10.650:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164249, NULL, 'G3DSA:1.20.5.110:FF:000347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164250, NULL, 'G3DSA:1.20.120.1080:FF:000099', NULL, NULL, 'Atp-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(164251, NULL, 'G3DSA:3.90.70.10:FF:000036', NULL, NULL, 'Serine repeat antigen 5', NULL, NULL, NULL, NULL, NULL, 4),
(164252, NULL, 'G3DSA:3.80.10.10:FF:000145', NULL, NULL, 'Tubulin-specific chaperone cofactor E-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(164253, NULL, 'G3DSA:3.40.50.300:FF:003826', NULL, NULL, 'SNF2_family_N-terminal_domain /Helicase_conserved_C-terminal_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(164254, NULL, 'G3DSA:4.10.470.10:FF:000002', NULL, NULL, 'Antiviral protein I', NULL, NULL, NULL, NULL, NULL, 4),
(164255, NULL, 'G3DSA:2.60.120.1440:FF:000015', NULL, NULL, 'Protein containing FecR protein domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(164256, NULL, 'G3DSA:3.40.50.1000:FF:000657', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164257, NULL, 'G3DSA:3.40.1770.10:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164258, NULL, 'G3DSA:1.20.1720.10:FF:000120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164259, NULL, 'G3DSA:1.10.287.110:FF:000477', NULL, NULL, 'DnaJ domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(164260, NULL, 'G3DSA:3.30.450.90:FF:000001', NULL, NULL, 'Type II secretion system ATPase GspE', NULL, NULL, NULL, NULL, NULL, 4),
(164261, NULL, 'G3DSA:3.10.20.90:FF:000307', NULL, NULL, 'Phosphatidylinositol 4-kinase gamma 4', NULL, NULL, NULL, NULL, NULL, 4),
(164262, NULL, 'G3DSA:1.10.8.60:FF:000127', NULL, NULL, 'Vesicular-fusion protein SEC18', NULL, NULL, NULL, NULL, NULL, 4),
(164263, NULL, 'G3DSA:3.90.1150.10:FF:000103', NULL, NULL, 'Serine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(164264, NULL, 'G3DSA:1.20.1070.10:FF:002155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164265, NULL, 'G3DSA:3.40.190.10:FF:000871', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164266, NULL, 'G3DSA:3.40.50.1100:FF:000069', NULL, NULL, 'Pyridoxal-phosphate dependent protein', NULL, NULL, NULL, NULL, NULL, 4),
(164267, NULL, 'G3DSA:2.130.10.10:FF:002067', NULL, NULL, 'Cleavage and polyadenylation specificity factor-like protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(164268, NULL, 'G3DSA:3.40.50.1010:FF:000194', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164269, NULL, 'G3DSA:1.10.510.10:FF:000377', NULL, NULL, 'Checkpoint protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(164270, NULL, 'G3DSA:1.10.150.20:FF:000251', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(164271, NULL, 'G3DSA:2.60.40.10:FF:005377', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164272, NULL, 'G3DSA:3.40.50.2300:FF:000648', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(164273, NULL, 'G3DSA:3.30.420.10:FF:000459', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164274, NULL, 'G3DSA:2.20.100.10:FF:000059', NULL, NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 12', NULL, NULL, NULL, NULL, NULL, 4),
(164275, NULL, 'G3DSA:3.40.630.10:FF:000332', NULL, NULL, 'Carboxypeptidase Z', NULL, NULL, NULL, NULL, NULL, 4),
(164276, NULL, 'G3DSA:3.30.70.330:FF:000497', NULL, NULL, 'flowering time control protein FPA', NULL, NULL, NULL, NULL, NULL, 4),
(164277, NULL, 'G3DSA:3.40.50.300:FF:007721', NULL, NULL, 'Putative ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(164278, NULL, 'G3DSA:1.25.40.10:FF:004308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164279, NULL, 'G3DSA:1.25.40.10:FF:001077', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(164280, NULL, 'G3DSA:1.10.1370.10:FF:000033', NULL, NULL, 'Peptidase M3A and M3B domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(164281, NULL, 'G3DSA:3.40.50.300:FF:004810', NULL, NULL, 'Elongation factor 1 alpha-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(164282, NULL, 'G3DSA:3.40.50.300:FF:004490', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(164283, NULL, 'G3DSA:2.130.10.130:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164284, NULL, 'G3DSA:3.90.70.10:FF:000800', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164285, NULL, 'G3DSA:3.40.50.2300:FF:001576', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164286, NULL, 'G3DSA:1.20.5.1190:FF:000005', NULL, NULL, 'ISWI chromatin-remodeling complex ATPase ISW1', NULL, NULL, NULL, NULL, NULL, 4),
(164287, NULL, 'G3DSA:3.40.50.1980:FF:000102', NULL, NULL, 'Iron(III) ABC transporter, solute-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(164288, NULL, 'G3DSA:3.30.160.60:FF:006046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164289, NULL, 'G3DSA:1.20.1250.20:FF:002054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164290, NULL, 'G3DSA:2.60.40.2610:FF:000001', NULL, NULL, 'Outer membrane fimbrial usher protein', NULL, NULL, NULL, NULL, NULL, 4),
(164291, NULL, 'G3DSA:2.60.120.10:FF:000186', NULL, NULL, 'Cyclic nucleotide-binding transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(164292, NULL, 'G3DSA:1.25.40.10:FF:000801', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(164293, NULL, 'G3DSA:2.130.10.10:FF:002270', NULL, NULL, 'Subunit of the COMPASS complex, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164294, NULL, 'G3DSA:3.10.330.70:FF:000002', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164295, NULL, 'G3DSA:1.20.120.1900:FF:000030', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(164296, NULL, 'G3DSA:2.60.120.10:FF:000242', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(164297, NULL, 'G3DSA:3.40.50.1980:FF:000046', NULL, NULL, 'Nitrogenase molybdenum-iron protein beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(164298, NULL, 'G3DSA:2.60.40.10:FF:004091', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164299, NULL, 'G3DSA:3.30.230.70:FF:000007', NULL, NULL, 'Exosome complex component RRP45B', NULL, NULL, NULL, NULL, NULL, 4),
(164300, NULL, 'G3DSA:1.10.287.3990:FF:000012', NULL, NULL, '26S proteasome regulatory subunit rpn10', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(164301, NULL, 'G3DSA:3.40.50.800:FF:000036', NULL, NULL, 'Histidine--tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164302, NULL, 'G3DSA:3.40.190.10:FF:000668', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164303, NULL, 'G3DSA:1.10.510.10:FF:003047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164304, NULL, 'G3DSA:3.30.56.10:FF:000011', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(164305, NULL, 'G3DSA:1.20.58.2220:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164306, NULL, 'G3DSA:3.90.230.10:FF:000026', NULL, NULL, 'Intermediate cleaving peptidase 55', NULL, NULL, NULL, NULL, NULL, 4),
(164307, NULL, 'G3DSA:3.30.870.10:FF:000015', NULL, NULL, 'Cardiolipin synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(164308, NULL, 'G3DSA:1.10.510.10:FF:002827', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(164309, NULL, 'G3DSA:2.130.10.10:FF:001994', NULL, NULL, 'PRP4 pre-mRNA processing factor 4-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(164310, NULL, 'G3DSA:1.20.1230.10:FF:000009', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(164311, NULL, 'G3DSA:2.60.120.620:FF:000135', NULL, NULL, 'Kanamycin B dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(164312, NULL, 'G3DSA:3.40.50.2000:FF:000064', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(164313, NULL, 'G3DSA:3.40.50.1820:FF:000515', NULL, NULL, 'Hydrolase, alpha/beta fold family domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(164314, NULL, 'G3DSA:2.60.120.230:FF:000001', NULL, NULL, 'Monooxygenase, DBH-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(164315, NULL, 'G3DSA:3.40.50.300:FF:005119', NULL, NULL, 'Polysaccharide biosynthesis tyrosine autokinase', NULL, NULL, NULL, NULL, NULL, 4),
(164316, NULL, 'G3DSA:3.30.160.60:FF:000594', NULL, NULL, 'Transcription factor HIVEP2', NULL, NULL, NULL, NULL, NULL, 4),
(164317, NULL, 'G3DSA:1.10.287.1150:FF:000014', NULL, NULL, 'Oxoglutarate dehydrogenase (Succinyl-transferring)', NULL, NULL, NULL, NULL, NULL, 4),
(164318, NULL, 'G3DSA:3.30.70.890:FF:000024', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(164319, NULL, 'G3DSA:2.60.40.1530:FF:000020', NULL, NULL, 'Integrin, alpha 2b', NULL, NULL, NULL, NULL, NULL, 4),
(164320, NULL, 'G3DSA:2.30.30.380:FF:000013', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(164321, NULL, 'G3DSA:3.30.200.20:FF:000013', NULL, NULL, 'Ribosomal protein S6 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(164322, NULL, 'G3DSA:3.80.10.10:FF:000201', NULL, NULL, 'protein phosphatase 1 regulatory subunit 42', NULL, NULL, NULL, NULL, NULL, 4),
(164323, NULL, 'G3DSA:2.60.40.10:FF:001723', NULL, NULL, 'Interference hedgehog', NULL, NULL, NULL, NULL, NULL, 4),
(164324, NULL, 'G3DSA:2.60.40.10:FF:001538', NULL, NULL, 'immunoglobulin superfamily member 22', NULL, NULL, NULL, NULL, NULL, 4),
(164325, NULL, 'G3DSA:2.170.150.80:FF:000008', NULL, NULL, 'NAC domain-containing protein 72-like', NULL, NULL, NULL, NULL, NULL, 4),
(164326, NULL, 'G3DSA:1.20.1110.10:FF:000034', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(164327, NULL, 'G3DSA:3.40.50.300:FF:007160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164328, NULL, 'G3DSA:1.10.630.10:FF:000032', NULL, NULL, 'Cytochrome P450 aromatase', NULL, NULL, NULL, NULL, NULL, 4),
(164329, NULL, 'G3DSA:1.20.1640.10:FF:000063', NULL, NULL, 'PaTched Related family', NULL, NULL, NULL, NULL, NULL, 4),
(164330, NULL, 'G3DSA:3.30.1390.20:FF:000008', NULL, NULL, '60S ribosomal protein L7', NULL, NULL, NULL, NULL, NULL, 4),
(164331, NULL, 'G3DSA:3.30.420.10:FF:000515', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164332, NULL, 'G3DSA:3.40.50.410:FF:000189', NULL, NULL, 'ATP-dependent DNA helicase 2 subunit KU80', NULL, NULL, NULL, NULL, NULL, 4),
(164333, NULL, 'G3DSA:2.30.30.100:FF:000031', NULL, NULL, 'Small nuclear ribonucleoprotein E', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(164334, NULL, 'G3DSA:2.170.270.10:FF:000103', NULL, NULL, 'Hamlet, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(164335, NULL, 'G3DSA:2.130.10.10:FF:005737', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(164336, NULL, 'G3DSA:3.20.20.100:FF:000218', NULL, NULL, 'Aldo-keto-reductase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(164337, NULL, 'G3DSA:2.30.29.30:FF:001345', NULL, NULL, 'Rac guanyl-nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(164338, NULL, 'G3DSA:3.30.56.30:FF:000017', NULL, NULL, 'Signal recognition particle 19 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(164339, NULL, 'G3DSA:1.25.10.10:FF:002362', NULL, NULL, 'Binding', NULL, NULL, NULL, NULL, NULL, 4),
(164340, NULL, 'G3DSA:2.40.33.10:FF:000016', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(164341, NULL, 'G3DSA:3.40.20.10:FF:000147', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(164342, NULL, 'G3DSA:3.30.160.60:FF:005973', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164343, NULL, 'G3DSA:2.10.25.10:FF:000156', NULL, NULL, 'cadherin EGF LAG seven-pass G-type receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(164344, NULL, 'G3DSA:1.25.40.10:FF:001638', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g06540', NULL, NULL, NULL, NULL, NULL, 4),
(164345, NULL, 'G3DSA:1.20.1070.10:FF:000715', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164346, NULL, 'G3DSA:1.10.3120.10:FF:000009', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(164347, NULL, 'G3DSA:1.20.920.10:FF:000226', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164348, NULL, 'G3DSA:3.90.290.10:FF:000002', NULL, NULL, 'Latent-transforming growth factor beta-binding protein 3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(164349, NULL, 'G3DSA:1.10.1420.10:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164350, NULL, 'G3DSA:3.40.950.10:FF:000019', NULL, NULL, 'Periplasmic [Fe] hydrogenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(164351, NULL, 'G3DSA:3.40.50.1700:FF:000064', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164352, NULL, 'G3DSA:3.90.199.10:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164353, NULL, 'G3DSA:2.70.98.30:FF:000047', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164354, NULL, 'G3DSA:1.20.990.10:FF:000028', NULL, NULL, 'NADPH-cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(164355, NULL, 'G3DSA:2.60.40.10:FF:000049', NULL, NULL, 'Leukocyte immunoglobulin-like receptor subfamily B member 1', NULL, NULL, NULL, NULL, NULL, 4),
(164356, NULL, 'G3DSA:3.30.200.20:FF:002486', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(164357, NULL, 'G3DSA:1.10.540.10:FF:000002', NULL, NULL, 'Acyl-CoA dehydrogenase FadE19', NULL, NULL, NULL, NULL, NULL, 4),
(164358, NULL, 'G3DSA:1.25.40.10:FF:003494', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g62720', NULL, NULL, NULL, NULL, NULL, 4),
(164359, NULL, 'G3DSA:1.20.1110.10:FF:000181', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164360, NULL, 'G3DSA:2.130.10.10:FF:001903', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(164361, NULL, 'G3DSA:3.30.300.160:FF:000016', NULL, NULL, 'Protein transport protein HofB homolog', NULL, NULL, NULL, NULL, NULL, 4),
(164362, NULL, 'G3DSA:1.10.12.10:FF:000016', NULL, NULL, 'Probable enoyl-CoA hydratase echA7', NULL, NULL, NULL, NULL, NULL, 4),
(164363, NULL, 'G3DSA:3.10.105.10:FF:000097', NULL, NULL, 'Oligopeptide ABC transporter, periplasmic oligopeptide-binding protein OppA', NULL, NULL, NULL, NULL, NULL, 4),
(164364, NULL, 'G3DSA:2.130.10.10:FF:001847', NULL, NULL, 'Nucleolar protein, component of the U3 processome', NULL, NULL, NULL, NULL, NULL, 4),
(164365, NULL, 'G3DSA:3.30.420.40:FF:000619', NULL, NULL, 'Protein CBG19480', NULL, NULL, NULL, NULL, NULL, 4),
(164366, NULL, 'G3DSA:3.40.1110.10:FF:000444', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(164367, NULL, 'G3DSA:3.30.70.330:FF:000733', NULL, NULL, 'YGR250C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(164368, NULL, 'G3DSA:3.30.559.10:FF:000140', NULL, NULL, 'Glycoside hydrolase family 128 protein', NULL, NULL, NULL, NULL, NULL, 4),
(164369, NULL, 'G3DSA:1.20.120.850:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164370, NULL, 'G3DSA:1.25.40.10:FF:002190', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g18110, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(164371, NULL, 'G3DSA:2.130.10.10:FF:006013', NULL, NULL, 'Spliceosomal protein sap, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164372, NULL, 'G3DSA:2.120.10.30:FF:000269', NULL, NULL, 'Low-density lipoprotein receptor-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(164373, NULL, 'G3DSA:2.130.10.10:FF:000358', NULL, NULL, 'Hermansky-Pudlak syndrome 5 protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(164374, NULL, 'G3DSA:3.30.450.20:FF:000385', NULL, NULL, 'Transcriptional regulator, PpsR', NULL, NULL, NULL, NULL, NULL, 4),
(164375, NULL, 'G3DSA:3.30.70.1230:FF:000206', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(164376, NULL, 'G3DSA:1.10.510.10:FF:001490', NULL, NULL, 'Kinase, CAMK CAMKL', NULL, NULL, NULL, NULL, NULL, 4),
(164377, NULL, 'G3DSA:3.30.450.60:FF:000077', NULL, NULL, 'AP complex subunit sigma', NULL, NULL, NULL, NULL, NULL, 4),
(164378, NULL, 'G3DSA:2.70.98.10:FF:000041', NULL, NULL, 'Aldose 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(164379, NULL, 'G3DSA:3.40.50.1000:FF:000713', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164380, NULL, 'G3DSA:1.20.1250.20:FF:001093', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164381, NULL, 'G3DSA:1.20.120.1760:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164382, NULL, 'G3DSA:1.25.40.180:FF:000083', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(164383, NULL, 'G3DSA:2.80.10.50:FF:000171', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(164384, NULL, 'G3DSA:2.20.25.10:FF:000015', NULL, NULL, 'Multifunctional methyltransferase subunit TRM112-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(164385, NULL, 'G3DSA:1.25.10.10:FF:001957', NULL, NULL, 'BEACH domain-containing protein B', NULL, NULL, NULL, NULL, NULL, 4),
(164386, NULL, 'G3DSA:2.30.29.30:FF:001401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164387, NULL, 'G3DSA:3.90.1750.20:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164388, NULL, 'G3DSA:3.30.310.50:FF:000002', NULL, NULL, 'Phosphoglucomutase 5', NULL, NULL, NULL, NULL, NULL, 4),
(164389, NULL, 'G3DSA:3.40.50.720:FF:001474', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(164390, NULL, 'G3DSA:1.20.5.340:FF:000034', NULL, NULL, 'Myosin heavy chain, isoform U', NULL, NULL, NULL, NULL, NULL, 4),
(164391, NULL, 'G3DSA:1.20.120.1770:FF:000007', NULL, NULL, 'Cytochrome b561 and DOMON domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(164392, NULL, 'G3DSA:3.90.1750.10:FF:000071', NULL, NULL, 'E3 ubiquitin-protein ligase hyd', NULL, NULL, NULL, NULL, NULL, 4),
(164393, NULL, 'G3DSA:3.30.160.60:FF:005826', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164394, NULL, 'G3DSA:1.20.5.190:FF:000005', NULL, NULL, 'IQ motif containing GTPase activating protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(164395, NULL, 'G3DSA:3.40.50.300:FF:006608', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164396, NULL, 'G3DSA:3.30.200.20:FF:001182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164397, NULL, 'G3DSA:2.30.30.40:FF:000311', NULL, NULL, 'Polarized growth protein (Boi2)', NULL, NULL, NULL, NULL, NULL, 4),
(164398, NULL, 'G3DSA:1.10.8.720:FF:000021', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(164399, NULL, 'G3DSA:3.90.530.10:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(164400, NULL, 'G3DSA:2.130.10.10:FF:004068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164401, NULL, 'G3DSA:3.30.230.130:FF:000075', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164402, NULL, 'G3DSA:2.60.40.10:FF:003668', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164403, NULL, 'G3DSA:3.50.7.10:FF:000067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164404, NULL, 'G3DSA:1.25.10.10:FF:002738', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164405, NULL, 'G3DSA:1.20.1070.10:FF:000154', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(164406, NULL, 'G3DSA:1.50.40.10:FF:000501', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164407, NULL, 'G3DSA:2.60.40.10:FF:000234', NULL, NULL, 'Collagen, type XII, alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(164408, NULL, 'G3DSA:3.80.10.10:FF:002146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164409, NULL, 'G3DSA:3.30.450.40:FF:000071', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(164410, NULL, 'G3DSA:2.10.25.10:FF:001117', NULL, NULL, 'Protein glp-1', NULL, NULL, NULL, NULL, NULL, 4),
(164411, NULL, 'G3DSA:3.30.360.50:FF:000005', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(164412, NULL, 'G3DSA:3.30.460.10:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164413, NULL, 'G3DSA:3.30.40.10:FF:000407', NULL, NULL, 'Histone-lysine N-methyltransferase MLL3', NULL, NULL, NULL, NULL, NULL, 4),
(164414, NULL, 'G3DSA:3.30.420.40:FF:000390', NULL, NULL, 'ROK family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(164415, NULL, 'G3DSA:3.40.50.150:FF:001550', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164416, NULL, 'G3DSA:1.25.40.10:FF:003527', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164417, NULL, 'G3DSA:3.30.160.60:FF:001898', NULL, NULL, 'Zinc finger protein with KRAB and SCAN domains 5', NULL, NULL, NULL, NULL, NULL, 4),
(164418, NULL, 'G3DSA:2.40.290.10:FF:000034', NULL, NULL, 'KU80 protein', NULL, NULL, NULL, NULL, NULL, 4),
(164419, NULL, 'G3DSA:2.60.40.10:FF:005433', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164420, NULL, 'G3DSA:1.25.40.20:FF:000714', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(164421, NULL, 'G3DSA:3.10.180.10:FF:000085', NULL, NULL, '4-hydroxyphenylpyruvate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(164422, NULL, 'G3DSA:3.40.640.10:FF:000361', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164423, NULL, 'G3DSA:2.130.10.120:FF:000020', NULL, NULL, 'Prolyl oligopeptidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(164424, NULL, 'G3DSA:2.40.37.10:FF:000076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164425, NULL, 'G3DSA:3.80.20.20:FF:000087', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164426, NULL, 'G3DSA:2.10.220.10:FF:000036', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(164427, NULL, 'G3DSA:1.10.10.60:FF:000347', NULL, NULL, 'Regulatory protein Ada', NULL, NULL, NULL, NULL, NULL, 4),
(164428, NULL, 'G3DSA:3.80.10.10:FF:003635', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164429, NULL, 'G3DSA:2.80.10.50:FF:000024', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(164430, NULL, 'G3DSA:3.30.160.60:FF:003320', NULL, NULL, 'Cys2/His2 zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(164431, NULL, 'G3DSA:2.20.25.120:FF:000001', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(164432, NULL, 'G3DSA:2.60.40.10:FF:005613', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164433, NULL, 'G3DSA:3.40.50.300:FF:002337', NULL, NULL, 'Transcription factor bHLH140', NULL, NULL, NULL, NULL, NULL, 4),
(164434, NULL, 'G3DSA:1.10.3520.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(164435, NULL, 'G3DSA:1.10.8.10:FF:000337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164436, NULL, 'G3DSA:2.60.40.10:FF:001162', NULL, NULL, 'PKHD1 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(164437, NULL, 'G3DSA:3.90.1140.10:FF:000041', NULL, NULL, 'Uncharacterized protein UNK4,15', NULL, NULL, NULL, NULL, NULL, 4),
(164438, NULL, 'G3DSA:1.20.58.1540:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164439, NULL, 'G3DSA:1.10.10.60:FF:001275', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164440, NULL, 'G3DSA:3.30.200.20:FF:002519', NULL, NULL, 'Ribosomal protein S6 kinase A1', NULL, NULL, NULL, NULL, NULL, 4),
(164441, NULL, 'G3DSA:1.25.40.470:FF:000046', NULL, NULL, 'Intraflagellar Transport Protein 122', NULL, NULL, NULL, NULL, NULL, 4),
(164442, NULL, 'G3DSA:1.20.5.1230:FF:000001', NULL, NULL, 'Heparin-binding hemagglutinin HbhA', NULL, NULL, NULL, NULL, NULL, 4),
(164443, NULL, 'G3DSA:3.90.70.80:FF:000040', NULL, NULL, 'Extracellular OTU-like cysteine protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164444, NULL, 'G3DSA:3.20.20.80:FF:000461', NULL, NULL, 'Beta-glucosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164445, NULL, 'G3DSA:1.20.5.190:FF:000152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164446, NULL, 'G3DSA:1.10.860.10:FF:000021', NULL, NULL, 'Replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(164447, NULL, 'G3DSA:3.40.50.1440:FF:000109', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(164448, NULL, 'G3DSA:1.10.630.10:FF:000537', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164449, NULL, 'G3DSA:3.30.420.10:FF:000700', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164450, NULL, 'G3DSA:3.40.50.2300:FF:001053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164451, NULL, 'G3DSA:3.40.50.300:FF:001409', NULL, NULL, 'ABC transporter G family member 23', NULL, NULL, NULL, NULL, NULL, 4),
(164452, NULL, 'G3DSA:2.10.25.10:FF:001792', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164453, NULL, 'G3DSA:3.40.720.10:FF:000215', NULL, NULL, 'Arylsulfatase A', NULL, NULL, NULL, NULL, NULL, 4),
(164454, NULL, 'G3DSA:2.120.10.80:FF:000059', NULL, NULL, 'F-box only protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(164455, NULL, 'G3DSA:1.10.8.60:FF:000599', NULL, NULL, 'Lon protease homolog 3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(164456, NULL, 'G3DSA:2.60.40.150:FF:000142', NULL, NULL, 'DnaJ protein ERDJ2A', NULL, NULL, NULL, NULL, NULL, 4),
(164457, NULL, 'G3DSA:2.40.50.430:FF:000002', NULL, NULL, 'DNA polymerase delta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(164458, NULL, 'G3DSA:3.30.160.60:FF:002336', NULL, NULL, 'Regular, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(164459, NULL, 'G3DSA:3.30.420.40:FF:000243', NULL, NULL, 'Heat shock protein 105 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(164460, NULL, 'G3DSA:3.30.160.20:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164461, NULL, 'G3DSA:2.60.120.290:FF:000232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164462, NULL, 'G3DSA:1.10.1740.10:FF:000045', NULL, NULL, 'RNA polymerase sigma factor SigI1', NULL, NULL, NULL, NULL, NULL, 4),
(164463, NULL, 'G3DSA:3.30.70.330:FF:000025', NULL, NULL, 'RNA-binding protein Musashi homolog 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(164464, NULL, 'G3DSA:1.10.10.10:FF:000613', NULL, NULL, 'Heme response regulator HssR', NULL, NULL, NULL, NULL, NULL, 4),
(164465, NULL, 'G3DSA:3.40.50.80:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164466, NULL, 'G3DSA:2.10.220.10:FF:000183', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(164467, NULL, 'G3DSA:3.80.10.10:FF:002707', NULL, NULL, 'MDIS1-interacting receptor like kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(164468, NULL, 'G3DSA:3.40.50.300:FF:001937', NULL, NULL, 'Adenylyl-sulfate kinase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(164469, NULL, 'G3DSA:2.130.10.10:FF:002831', NULL, NULL, 'Coatomer subunit beta''-3', NULL, NULL, NULL, NULL, NULL, 4),
(164470, NULL, 'G3DSA:1.20.1170.10:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164471, NULL, 'G3DSA:2.130.10.10:FF:005029', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(164472, NULL, 'G3DSA:1.10.357.70:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164473, NULL, 'G3DSA:1.20.1560.10:FF:000585', NULL, NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 13', NULL, NULL, NULL, NULL, NULL, 4),
(164474, NULL, 'G3DSA:1.20.1070.10:FF:000210', NULL, NULL, 'probable G-protein coupled receptor 101', NULL, NULL, NULL, NULL, NULL, 4),
(164475, NULL, 'G3DSA:3.40.50.10810:FF:000255', NULL, NULL, 'Snf2 histone linker PHD ring helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164476, NULL, 'G3DSA:2.130.10.10:FF:005181', NULL, NULL, 'AEL269Cp', NULL, NULL, NULL, NULL, NULL, 4),
(164477, NULL, 'G3DSA:3.40.1110.10:FF:000388', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164478, NULL, 'G3DSA:1.10.510.10:FF:001866', NULL, NULL, 'Protein kinase C, alpha', NULL, NULL, NULL, NULL, NULL, 4),
(164479, NULL, 'G3DSA:3.20.20.70:FF:000363', NULL, NULL, 'Oxygen-independent coproporphyrinogen III oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(164480, NULL, 'G3DSA:2.40.30.10:FF:000246', NULL, NULL, 'Protein CBG12339', NULL, NULL, NULL, NULL, NULL, 4),
(164481, NULL, 'G3DSA:1.20.120.980:FF:000022', NULL, NULL, 'Thymus-specific serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(164482, NULL, 'G3DSA:2.60.40.10:FF:001870', NULL, NULL, 'V-set and immunoglobulin domain containing 8', NULL, NULL, NULL, NULL, NULL, 4),
(164483, NULL, 'G3DSA:1.10.510.10:FF:002266', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164484, NULL, 'G3DSA:1.10.275.10:FF:000009', NULL, NULL, 'Phenylalanine ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(164485, NULL, 'G3DSA:2.60.40.10:FF:004596', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164486, NULL, 'G3DSA:2.10.25.10:FF:001084', NULL, NULL, 'Thrombospondin-3a', NULL, NULL, NULL, NULL, NULL, 4),
(164487, NULL, 'G3DSA:1.10.472.10:FF:000664', NULL, NULL, 'Os08g0421100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(164488, NULL, 'G3DSA:1.20.58.420:FF:000001', NULL, NULL, 'Atlastin-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(164489, NULL, 'G3DSA:1.25.40.10:FF:002566', NULL, NULL, 'UDP-N-acetylglucosaminyltransferase (AFU_orthologue AFUA_1G03380)', NULL, NULL, NULL, NULL, NULL, 4),
(164490, NULL, 'G3DSA:1.10.630.10:FF:000684', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164491, NULL, 'G3DSA:3.80.10.10:FF:003074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164492, NULL, 'G3DSA:3.40.50.300:FF:006232', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164493, NULL, 'G3DSA:3.30.740.10:FF:000011', NULL, NULL, 'Dynein light chain', NULL, NULL, NULL, NULL, NULL, 4),
(164494, NULL, 'G3DSA:3.40.50.2000:FF:000592', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(164495, NULL, 'G3DSA:3.40.50.720:FF:001327', NULL, NULL, 'Ubiquitin activating enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164496, NULL, 'G3DSA:3.40.850.10:FF:000551', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164497, NULL, 'G3DSA:2.60.40.10:FF:005580', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164498, NULL, 'G3DSA:3.50.50.60:FF:001080', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] flavoprotein subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(164499, NULL, 'G3DSA:2.30.29.30:FF:000384', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(164500, NULL, 'G3DSA:3.40.720.10:FF:000362', NULL, NULL, 'Uncharacterized protein HI_0841', NULL, NULL, NULL, NULL, NULL, 4),
(164501, NULL, 'G3DSA:3.30.160.60:FF:006193', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164502, NULL, 'G3DSA:2.70.170.10:FF:000052', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(164503, NULL, 'G3DSA:4.10.60.10:FF:000121', NULL, NULL, 'HCL585Cp', NULL, NULL, NULL, NULL, NULL, 4),
(164504, NULL, 'G3DSA:1.10.150.240:FF:000056', NULL, NULL, '5-amino-6-(5-phospho-D-ribitylamino)uracil phosphatase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(164505, NULL, 'G3DSA:3.40.47.10:FF:000299', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164506, NULL, 'G3DSA:3.30.1490.80:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164507, NULL, 'G3DSA:1.20.1720.10:FF:000064', NULL, NULL, 'MFS transporter, DHA2 family, multidrug resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(164508, NULL, 'G3DSA:3.30.160.60:FF:001375', NULL, NULL, 'Zinc finger and BTB domain-containing protein 39', NULL, NULL, NULL, NULL, NULL, 4),
(164509, NULL, 'G3DSA:3.40.50.300:FF:001376', NULL, NULL, 'tRNA modification GTPase MnmE', NULL, NULL, NULL, NULL, NULL, 4),
(164510, NULL, 'G3DSA:3.30.70.580:FF:000050', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(164511, NULL, 'G3DSA:1.25.40.10:FF:004511', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164512, NULL, 'G3DSA:1.10.225.10:FF:000006', NULL, NULL, 'prosaposin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(164513, NULL, 'G3DSA:3.40.50.2300:FF:001429', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164514, NULL, 'G3DSA:1.10.418.10:FF:000078', NULL, NULL, 'Putative Filamin-A', NULL, NULL, NULL, NULL, NULL, 4),
(164515, NULL, 'G3DSA:1.20.120.140:FF:000006', NULL, NULL, 'Cell division FtsY, chloroplastic-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(164516, NULL, 'G3DSA:1.20.1560.10:FF:000438', NULL, NULL, 'Multidrug resistance protein 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164517, NULL, 'G3DSA:3.60.15.10:FF:000090', NULL, NULL, 'DNA repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(164518, NULL, 'G3DSA:3.40.980.10:FF:000032', NULL, NULL, 'Molybdopterin adenylyltransferase MoaB, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164519, NULL, 'G3DSA:2.40.50.990:FF:000001', NULL, NULL, 'Elongation factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(164520, NULL, 'G3DSA:3.20.20.140:FF:000438', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164521, NULL, 'G3DSA:2.30.30.1020:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164522, NULL, 'G3DSA:3.40.50.150:FF:000566', NULL, NULL, 'tRNA (adenine(58)-N(1))-methyltransferase non-catalytic subunit TRM6', NULL, NULL, NULL, NULL, NULL, 4),
(164523, NULL, 'G3DSA:1.10.472.130:FF:000068', NULL, NULL, 'Dynein axonemal heavy chain 3', NULL, NULL, NULL, NULL, NULL, 4),
(164524, NULL, 'G3DSA:1.20.120.550:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164525, NULL, 'G3DSA:2.30.40.10:FF:000180', NULL, NULL, 'Gll3171 protein', NULL, NULL, NULL, NULL, NULL, 4),
(164526, NULL, 'G3DSA:1.10.510.10:FF:003811', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164527, NULL, 'G3DSA:3.90.190.10:FF:000146', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164528, NULL, 'G3DSA:2.170.270.10:FF:000070', NULL, NULL, 'protein msta', NULL, NULL, NULL, NULL, NULL, 4),
(164529, NULL, 'G3DSA:3.40.190.10:FF:000320', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(164530, NULL, 'G3DSA:3.40.50.20:FF:000068', NULL, NULL, 'Trifunctional purine biosynthetic protein adenosine-3', NULL, NULL, NULL, NULL, NULL, 4),
(164531, NULL, 'G3DSA:3.40.50.150:FF:001634', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164532, NULL, 'G3DSA:3.30.230.70:FF:000131', NULL, NULL, '3'' exoribonuclease family, domain 1 containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(164533, NULL, 'G3DSA:1.10.287.1250:FF:000005', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(164534, NULL, 'G3DSA:3.30.70.330:FF:002498', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164535, NULL, 'G3DSA:2.70.98.10:FF:000120', NULL, NULL, 'Glucan 14-alpha-glucosidase Cga', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(164536, NULL, 'G3DSA:2.10.25.10:FF:001325', NULL, NULL, 'Notch receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(164537, NULL, 'G3DSA:3.80.10.10:FF:001713', NULL, NULL, 'Immunoglobulin superfamily-containing leucine-rich repeat 2', NULL, NULL, NULL, NULL, NULL, 4),
(164538, NULL, 'G3DSA:3.40.50.300:FF:002545', NULL, NULL, 'ATP-dependent DNA helicase DinG', NULL, NULL, NULL, NULL, NULL, 4),
(164539, NULL, 'G3DSA:1.10.510.10:FF:003171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164540, NULL, 'G3DSA:1.25.40.10:FF:000913', NULL, NULL, 'Os01g0814300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(164541, NULL, 'G3DSA:2.130.10.10:FF:001634', NULL, NULL, 'Dynein, axonemal, intermediate chain 2b', NULL, NULL, NULL, NULL, NULL, 4),
(164542, NULL, 'G3DSA:1.10.540.10:FF:000025', NULL, NULL, 'Related to Dibenzothiophene desulfurization enzyme C', NULL, NULL, NULL, NULL, NULL, 4),
(164543, NULL, 'G3DSA:2.40.40.50:FF:000005', NULL, NULL, 'Ubiquitin recognition factor in ER-associated degradation 1', NULL, NULL, NULL, NULL, NULL, 4),
(164544, NULL, 'G3DSA:2.60.40.60:FF:000524', NULL, NULL, 'Dachsous cadherin-related 1a', NULL, NULL, NULL, NULL, NULL, 4),
(164545, NULL, 'G3DSA:3.30.500.10:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164546, NULL, 'G3DSA:2.30.29.30:FF:000889', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164547, NULL, 'G3DSA:2.60.40.1120:FF:000043', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164548, NULL, 'G3DSA:1.10.510.10:FF:001607', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164549, NULL, 'G3DSA:2.60.40.10:FF:000993', NULL, NULL, 'vascular endothelial growth factor receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(164550, NULL, 'G3DSA:3.10.129.10:FF:000281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164551, NULL, 'G3DSA:3.40.30.10:FF:000648', NULL, NULL, 'Thioredoxin (TrxA-1)', NULL, NULL, NULL, NULL, NULL, 4),
(164552, NULL, 'G3DSA:2.60.40.10:FF:005293', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164553, NULL, 'G3DSA:1.10.600.10:FF:000064', NULL, NULL, 'Terpene synthase', NULL, NULL, NULL, NULL, NULL, 4),
(164554, NULL, 'G3DSA:1.20.1250.20:FF:001126', NULL, NULL, 'Related to multidrug resistance proteins', NULL, NULL, NULL, NULL, NULL, 4),
(164555, NULL, 'G3DSA:3.20.10.10:FF:000075', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164556, NULL, 'G3DSA:2.30.29.30:FF:000417', NULL, NULL, 'Trio, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(164557, NULL, 'G3DSA:1.25.40.10:FF:001369', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g05340', NULL, NULL, NULL, NULL, NULL, 4),
(164558, NULL, 'G3DSA:3.40.50.1360:FF:000012', NULL, NULL, 'LsrR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(164559, NULL, 'G3DSA:3.10.580.10:FF:000166', NULL, NULL, 'Chloride channel protein A', NULL, NULL, NULL, NULL, NULL, 4),
(164560, NULL, 'G3DSA:3.60.21.10:FF:000391', NULL, NULL, 'Protein phosphatase from PCR D6', NULL, NULL, NULL, NULL, NULL, 4),
(164561, NULL, 'G3DSA:3.40.20.10:FF:000142', NULL, NULL, 'Gelsolin-related protein of 125 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(164562, NULL, 'G3DSA:3.40.50.1360:FF:000063', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164563, NULL, 'G3DSA:3.30.559.10:FF:000168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164564, NULL, 'G3DSA:3.80.10.10:FF:000706', NULL, NULL, 'Ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(164565, NULL, 'G3DSA:1.10.287.70:FF:000228', NULL, NULL, 'Cyclic nucleotide-binding transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(164566, NULL, 'G3DSA:3.30.160.60:FF:005793', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164567, NULL, 'G3DSA:3.90.70.10:FF:000272', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(164568, NULL, 'G3DSA:3.40.630.10:FF:000304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(164569, NULL, 'G3DSA:3.30.70.100:FF:000097', NULL, NULL, 'Copper chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(164570, NULL, 'G3DSA:2.60.120.970:FF:000009', NULL, NULL, 'bone morphogenetic protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(164571, NULL, 'G3DSA:1.20.1270.60:FF:000004', NULL, NULL, 'Arf-GAP with SH3 domain, ANK repeat and PH domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(164572, NULL, 'G3DSA:2.130.10.10:FF:005849', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164573, NULL, 'G3DSA:3.30.200.20:FF:001322', NULL, NULL, 'Protein_kinase_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(164574, NULL, 'G3DSA:4.10.240.10:FF:000142', NULL, NULL, 'Fungal zinc cluster transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164575, NULL, 'G3DSA:3.40.50.620:FF:000870', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164576, NULL, 'G3DSA:3.30.200.20:FF:001761', NULL, NULL, 'TP53-regulating kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(164577, NULL, 'G3DSA:1.50.40.10:FF:000237', NULL, NULL, 'Solute carrier family 25 member 46-B', NULL, NULL, NULL, NULL, NULL, 4),
(164578, NULL, 'G3DSA:2.60.120.380:FF:000046', NULL, NULL, 'Calpain 14', NULL, NULL, NULL, NULL, NULL, 4),
(164579, NULL, 'G3DSA:1.10.10.10:FF:000181', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(164580, NULL, 'G3DSA:2.80.10.70:FF:000002', NULL, NULL, 'spindlin-2B isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(164581, NULL, 'G3DSA:3.30.190.20:FF:000022', NULL, NULL, 'LSU ribosomal protein L1P', NULL, NULL, NULL, NULL, NULL, 4),
(164582, NULL, 'G3DSA:3.30.160.60:FF:004753', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164583, NULL, 'G3DSA:3.30.920.10:FF:000008', NULL, NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(164584, NULL, 'G3DSA:2.60.40.10:FF:003747', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164585, NULL, 'G3DSA:3.30.70.330:FF:001458', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164586, NULL, 'G3DSA:2.130.10.10:FF:002191', NULL, NULL, 'WD repeat-containing protein 48 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(164587, NULL, 'G3DSA:1.20.1740.10:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164588, NULL, 'G3DSA:3.30.70.330:FF:003015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164589, NULL, 'G3DSA:3.50.50.60:FF:001260', NULL, NULL, 'L-amino-acid oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(164590, NULL, 'G3DSA:2.40.10.10:FF:000071', NULL, NULL, 'Prothrombin', NULL, NULL, NULL, NULL, NULL, 4),
(164591, NULL, 'G3DSA:3.40.190.10:FF:000371', NULL, NULL, 'Alpha-keto acid-binding periplasmic protein TakP', NULL, NULL, NULL, NULL, NULL, 4),
(164592, NULL, 'G3DSA:1.25.40.10:FF:004224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164593, NULL, 'G3DSA:3.40.33.10:FF:000042', NULL, NULL, 'Venom allergen 3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(164594, NULL, 'G3DSA:3.30.420.40:FF:000451', NULL, NULL, 'Actin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164595, NULL, 'G3DSA:2.60.200.10:FF:000035', NULL, NULL, 'interferon regulatory factor like protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(164596, NULL, 'G3DSA:2.10.25.10:FF:001376', NULL, NULL, 'Growth arrest-specific 6', NULL, NULL, NULL, NULL, NULL, 4),
(164597, NULL, 'G3DSA:3.40.1110.10:FF:000180', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(164598, NULL, 'G3DSA:1.10.520.10:FF:000063', NULL, NULL, 'Os01g0293900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(164599, NULL, 'G3DSA:1.50.40.10:FF:000288', NULL, NULL, 'Putative mitochondrial carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(164600, NULL, 'G3DSA:3.10.100.10:FF:000198', NULL, NULL, 'Intimin', NULL, NULL, NULL, NULL, NULL, 4),
(164601, NULL, 'G3DSA:1.20.120.1900:FF:000053', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(164602, NULL, 'G3DSA:3.40.1170.10:FF:000037', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(164603, NULL, 'G3DSA:3.30.470.20:FF:000004', NULL, NULL, 'Carbamoyl-phosphate synthase (glutamine-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4),
(164604, NULL, 'G3DSA:3.30.900.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164605, NULL, 'G3DSA:1.20.85.10:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164606, NULL, 'G3DSA:1.20.5.170:FF:000174', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164607, NULL, 'G3DSA:2.60.40.60:FF:000575', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164608, NULL, 'G3DSA:1.20.1250.20:FF:000137', NULL, NULL, 'Probable inositol transporter 2', NULL, NULL, NULL, NULL, NULL, 4),
(164609, NULL, 'G3DSA:3.40.50.1980:FF:000041', NULL, NULL, 'Iron-hydroxamate ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(164610, NULL, 'G3DSA:3.40.250.10:FF:000258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164611, NULL, 'G3DSA:1.10.510.10:FF:001658', NULL, NULL, 'Os03g0748400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(164612, NULL, 'G3DSA:3.40.50.300:FF:004574', NULL, NULL, 'Adenylate/guanylate cyclase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(164613, NULL, 'G3DSA:1.10.1370.40:FF:000008', NULL, NULL, 'Oligopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164614, NULL, 'G3DSA:3.80.10.10:FF:002270', NULL, NULL, 'YALI0C06556p', NULL, NULL, NULL, NULL, NULL, 4),
(164615, NULL, 'G3DSA:3.40.850.10:FF:000399', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(164616, NULL, 'G3DSA:3.40.605.10:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164617, NULL, 'G3DSA:3.10.180.10:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164618, NULL, 'G3DSA:1.10.630.10:FF:000245', NULL, NULL, 'Cytochrome P450 monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164619, NULL, 'G3DSA:2.110.10.10:FF:000016', NULL, NULL, 'Matrix metallopeptidase 25', NULL, NULL, NULL, NULL, NULL, 4),
(164620, NULL, 'G3DSA:2.40.70.10:FF:000080', NULL, NULL, 'Plasmepsin V', NULL, NULL, NULL, NULL, NULL, 4),
(164621, NULL, 'G3DSA:3.40.47.10:FF:000063', NULL, NULL, 'Trifunctional enzyme subunit beta, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(164622, NULL, 'G3DSA:2.70.150.10:FF:000225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164623, NULL, 'G3DSA:1.25.40.20:FF:001259', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164624, NULL, 'G3DSA:1.20.920.20:FF:000004', NULL, NULL, 'Dynein axonemal heavy chain 5', NULL, NULL, NULL, NULL, NULL, 4),
(164625, NULL, 'G3DSA:2.60.40.150:FF:000518', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164626, NULL, 'G3DSA:2.30.42.10:FF:000015', NULL, NULL, 'Membrane associated guanylate kinase, WW and PDZ domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(164627, NULL, 'G3DSA:2.10.25.10:FF:000920', NULL, NULL, 'protein eyes shut homolog', NULL, NULL, NULL, NULL, NULL, 4),
(164628, NULL, 'G3DSA:2.60.120.10:FF:000422', NULL, NULL, 'Oxalate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(164629, NULL, 'G3DSA:3.90.230.10:FF:000021', NULL, NULL, 'Transcription factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(164630, NULL, 'G3DSA:1.20.120.140:FF:000001', NULL, NULL, 'Signal recognition particle GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(164631, NULL, 'G3DSA:1.20.58.400:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164632, NULL, 'G3DSA:3.40.50.2300:FF:001132', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164633, NULL, 'G3DSA:2.60.40.10:FF:001982', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(164634, NULL, 'G3DSA:3.30.1680.10:FF:000073', NULL, NULL, 'Plexin C1', NULL, NULL, NULL, NULL, NULL, 4),
(164635, NULL, 'G3DSA:1.25.10.10:FF:002098', NULL, NULL, 'Os03g0435300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(164636, NULL, 'G3DSA:1.10.472.80:FF:000191', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(164637, NULL, 'G3DSA:3.40.50.300:FF:007328', NULL, NULL, 'Uncharacterized protein MJECL44', NULL, NULL, NULL, NULL, NULL, 4),
(164638, NULL, 'G3DSA:1.10.1370.20:FF:000002', NULL, NULL, 'Oligoendopeptidase F homolog', NULL, NULL, NULL, NULL, NULL, 4),
(164639, NULL, 'G3DSA:3.90.190.10:FF:000354', NULL, NULL, 'Dual-specificity phosphatase 19b', NULL, NULL, NULL, NULL, NULL, 4),
(164640, NULL, 'G3DSA:2.60.120.1190:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164641, NULL, 'G3DSA:3.90.550.10:FF:000337', NULL, NULL, 'Glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(164642, NULL, 'G3DSA:3.40.50.12780:FF:000149', NULL, NULL, 'Nonribosomal peptide synthase Pes1 (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(164643, NULL, 'G3DSA:1.25.40.10:FF:001470', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At5g59200, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(164644, NULL, 'G3DSA:3.40.50.1240:FF:000061', NULL, NULL, 'YDR051C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(164645, NULL, 'G3DSA:3.20.20.300:FF:000014', NULL, NULL, 'Beta-hexosaminidase, lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(164646, NULL, 'G3DSA:1.25.40.20:FF:001698', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(164647, NULL, 'G3DSA:3.40.33.10:FF:000093', NULL, NULL, 'Os07g0128700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(164648, NULL, 'G3DSA:1.10.3720.10:FF:000010', NULL, NULL, 'Maltose ABC transporter permease MalG', NULL, NULL, NULL, NULL, NULL, 4),
(164649, NULL, 'G3DSA:3.80.10.10:FF:003579', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164650, NULL, 'G3DSA:2.30.30.40:FF:000603', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164651, NULL, 'G3DSA:3.30.70.1350:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164652, NULL, 'G3DSA:1.20.120.1070:FF:000011', NULL, NULL, 'Translation initiation factor eIF-2B alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(164653, NULL, 'G3DSA:3.30.30.30:FF:000036', NULL, NULL, 'Hsp70_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(164654, NULL, 'G3DSA:2.130.10.10:FF:003612', NULL, NULL, 'U3 small nucleolar RNA-associated protein 15 homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(164655, NULL, 'G3DSA:2.40.50.140:FF:001000', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164656, NULL, 'G3DSA:4.10.400.10:FF:000144', NULL, NULL, 'enteropeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(164657, NULL, 'G3DSA:1.10.443.20:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164658, NULL, 'G3DSA:3.30.160.20:FF:000245', NULL, NULL, 'Double-stranded RNA-specific editase B2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164659, NULL, 'G3DSA:3.40.50.200:FF:000036', NULL, NULL, 'Serin endopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(164660, NULL, 'G3DSA:1.10.3730.20:FF:000053', NULL, NULL, 'EamA-like transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(164661, NULL, 'G3DSA:3.20.20.70:FF:000284', NULL, NULL, 'Possible oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(164662, NULL, 'G3DSA:3.40.50.2300:FF:000676', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(164663, NULL, 'G3DSA:2.40.420.20:FF:000014', NULL, NULL, 'Cation efflux system protein', NULL, NULL, NULL, NULL, NULL, 4),
(164664, NULL, 'G3DSA:1.10.287.920:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164665, NULL, 'G3DSA:2.60.120.10:FF:000034', NULL, NULL, 'Homogentisate 1,2-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(164666, NULL, 'G3DSA:2.60.120.200:FF:000245', NULL, NULL, 'Similar to lectin family integral membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(164667, NULL, 'G3DSA:3.10.28.10:FF:000003', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(164668, NULL, 'G3DSA:1.10.8.530:FF:000003', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(164669, NULL, 'G3DSA:3.40.50.960:FF:000011', NULL, NULL, '6,7-dimethyl-8-ribityllumazine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(164670, NULL, 'G3DSA:3.80.10.10:FF:000353', NULL, NULL, 'Zyg-11 family member B, cell cycle regulator', NULL, NULL, NULL, NULL, NULL, 4),
(164671, NULL, 'G3DSA:1.10.275.40:FF:000001', NULL, NULL, 'DNA repair helicase (Rad3)', NULL, NULL, NULL, NULL, NULL, 4),
(164672, NULL, 'G3DSA:3.30.310.130:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164673, NULL, 'G3DSA:3.30.70.330:FF:002818', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164674, NULL, 'G3DSA:3.30.565.10:FF:000340', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(164675, NULL, 'G3DSA:2.170.16.10:FF:000049', NULL, NULL, 'ATP-dependent DNA helicase Hel308', NULL, NULL, NULL, NULL, NULL, 4),
(164676, NULL, 'G3DSA:2.60.40.1730:FF:000113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164677, NULL, 'G3DSA:3.90.79.10:FF:000292', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(164678, NULL, 'G3DSA:3.30.2130.30:FF:000049', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164679, NULL, 'G3DSA:3.90.70.10:FF:000221', NULL, NULL, 'Ubiquitin-specific peptidase 32', NULL, NULL, NULL, NULL, NULL, 4),
(164680, NULL, 'G3DSA:3.10.20.90:FF:000482', NULL, NULL, 'Small ubiquitin-related modifier 2', NULL, NULL, NULL, NULL, NULL, 4),
(164681, NULL, 'G3DSA:1.20.1560.10:FF:000169', NULL, NULL, 'Drug efflux ABC transporter, ATP-binding/permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(164682, NULL, 'G3DSA:3.30.160.60:FF:000419', NULL, NULL, 'Early growth response protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(164683, NULL, 'G3DSA:3.90.79.10:FF:000241', NULL, NULL, 'MutT/nudix family protein', NULL, NULL, NULL, NULL, NULL, 4),
(164684, NULL, 'G3DSA:1.25.40.10:FF:003786', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(164685, NULL, 'G3DSA:2.160.20.10:FF:000088', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(164686, NULL, 'G3DSA:3.20.20.150:FF:000031', NULL, NULL, 'Probable endonuclease 4', NULL, NULL, NULL, NULL, NULL, 4),
(164687, NULL, 'G3DSA:3.40.50.300:FF:005563', NULL, NULL, 'Polynucleotide kinase 3''-phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164688, NULL, 'G3DSA:3.40.50.980:FF:000017', NULL, NULL, 'Acetyl-CoA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(164689, NULL, 'G3DSA:1.25.10.10:FF:001642', NULL, NULL, 'TELO2-interacting protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(164690, NULL, 'G3DSA:1.25.40.10:FF:003347', NULL, NULL, 'Pre-mRNA-splicing factor CLF1', NULL, NULL, NULL, NULL, NULL, 4),
(164691, NULL, 'G3DSA:3.40.50.300:FF:005451', NULL, NULL, 'Related to ATP-binding cassette, sub-family A', NULL, NULL, NULL, NULL, NULL, 4),
(164692, NULL, 'G3DSA:3.10.290.60:FF:000001', NULL, NULL, 'Ubiquitin-activating enzyme E1 2', NULL, NULL, NULL, NULL, NULL, 4),
(164693, NULL, 'G3DSA:2.60.120.260:FF:000577', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164694, NULL, 'G3DSA:1.25.40.10:FF:003235', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(164695, NULL, 'G3DSA:3.40.50.280:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164696, NULL, 'G3DSA:3.40.50.720:FF:000170', NULL, NULL, 'T-protein', NULL, NULL, NULL, NULL, NULL, 4),
(164697, NULL, 'G3DSA:3.20.20.300:FF:000065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164698, NULL, 'G3DSA:3.30.1360.10:FF:000026', NULL, NULL, 'RNA polymerase II subunit Rpb11', NULL, NULL, NULL, NULL, NULL, 4),
(164699, NULL, 'G3DSA:3.30.450.50:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164700, NULL, 'G3DSA:3.30.450.20:FF:000525', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(164701, NULL, 'G3DSA:3.30.300.10:FF:000017', NULL, NULL, 'GMP synthase [glutamine-hydrolyzing]', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(164702, NULL, 'G3DSA:2.40.290.10:FF:000011', NULL, NULL, 'DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(164703, NULL, 'G3DSA:3.60.110.10:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164704, NULL, 'G3DSA:2.40.10.10:FF:000183', NULL, NULL, 'Complement component 1, s subcomponent', NULL, NULL, NULL, NULL, NULL, 4),
(164705, NULL, 'G3DSA:3.30.70.60:FF:000025', NULL, NULL, '30S ribosomal protein S6', NULL, NULL, NULL, NULL, NULL, 4),
(164706, NULL, 'G3DSA:3.30.420.10:FF:000083', NULL, NULL, 'SET domain and mariner transposase fusion gene', NULL, NULL, NULL, NULL, NULL, 4),
(164707, NULL, 'G3DSA:3.30.450.20:FF:000121', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(164708, NULL, 'G3DSA:2.40.50.100:FF:000218', NULL, NULL, 'Iron(III)-transport ATP-binding protein sfuC', NULL, NULL, NULL, NULL, NULL, 4),
(164709, NULL, 'G3DSA:3.60.40.10:FF:000344', NULL, NULL, 'Os02g0599200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(164710, NULL, 'G3DSA:1.10.472.10:FF:000372', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164711, NULL, 'G3DSA:1.25.10.10:FF:001693', NULL, NULL, 'AGR238Cp', NULL, NULL, NULL, NULL, NULL, 4),
(164712, NULL, 'G3DSA:2.40.128.20:FF:000031', NULL, NULL, 'Phenolic acid decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(164713, NULL, 'G3DSA:3.40.50.10810:FF:000250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164714, NULL, 'G3DSA:3.40.50.300:FF:004462', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164715, NULL, 'G3DSA:3.80.10.10:FF:002382', NULL, NULL, 'YALI0C14740p', NULL, NULL, NULL, NULL, NULL, 4),
(164716, NULL, 'G3DSA:3.30.70.1430:FF:000007', NULL, NULL, 'Multidrug transporter AcrB', NULL, NULL, NULL, NULL, NULL, 4),
(164717, NULL, 'G3DSA:3.40.630.30:FF:000523', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164718, NULL, 'G3DSA:3.30.200.20:FF:001710', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(164719, NULL, 'G3DSA:3.90.1750.10:FF:000076', NULL, NULL, 'UBR E3 ubiquitin ligase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(164720, NULL, 'G3DSA:1.25.40.10:FF:003286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164721, NULL, 'G3DSA:2.30.110.10:FF:000012', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164722, NULL, 'G3DSA:1.20.920.20:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164723, NULL, 'G3DSA:3.40.850.10:FF:000287', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164724, NULL, 'G3DSA:3.40.50.300:FF:000780', NULL, NULL, 'Rho GTPase Rho3', NULL, NULL, NULL, NULL, NULL, 4),
(164725, NULL, 'G3DSA:3.30.1640.10:FF:000008', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(164726, NULL, 'G3DSA:2.20.70.10:FF:000210', NULL, NULL, 'Rho GTPase activating protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(164727, NULL, 'G3DSA:2.30.30.40:FF:000103', NULL, NULL, 'Amphiphysin', NULL, NULL, NULL, NULL, NULL, 4),
(164728, NULL, 'G3DSA:2.60.120.290:FF:000092', NULL, NULL, 'Cubilin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(164729, NULL, 'G3DSA:1.10.8.10:FF:000073', NULL, NULL, 'NEDD8 ultimate buster 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(164730, NULL, 'G3DSA:2.130.10.10:FF:002039', NULL, NULL, 'WD_domain_-_G-beta_repeat_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(164731, NULL, 'G3DSA:3.10.20.90:FF:000431', NULL, NULL, 'Protein CBG06226', NULL, NULL, NULL, NULL, NULL, 4),
(164732, NULL, 'G3DSA:1.25.40.20:FF:001147', NULL, NULL, 'Serine/threonine-protein kinase NEK', NULL, NULL, NULL, NULL, NULL, 4),
(164733, NULL, 'G3DSA:3.40.605.10:FF:000032', NULL, NULL, 'Aldehyde dehydrogenase family 16 member A1', NULL, NULL, NULL, NULL, NULL, 4),
(164734, NULL, 'G3DSA:3.30.70.2760:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164735, NULL, 'G3DSA:1.20.1310.10:FF:000010', NULL, NULL, 'Cullin 4B', NULL, NULL, NULL, NULL, NULL, 4),
(164736, NULL, 'G3DSA:3.40.50.150:FF:000274', NULL, NULL, 'ERF1 methyltransferase catalytic subunit MTQ2', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(164737, NULL, 'G3DSA:4.10.240.10:FF:000193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164738, NULL, 'G3DSA:3.40.800.20:FF:000045', NULL, NULL, 'Histone deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(164739, NULL, 'G3DSA:3.40.390.10:FF:000268', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164740, NULL, 'G3DSA:2.120.10.80:FF:000115', NULL, NULL, 'Kelch like family member 42', NULL, NULL, NULL, NULL, NULL, 4),
(164741, NULL, 'G3DSA:3.80.10.10:FF:004068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164742, NULL, 'G3DSA:3.30.70.330:FF:000109', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein a1 isoform', NULL, NULL, NULL, NULL, NULL, 4),
(164743, NULL, 'G3DSA:1.10.630.10:FF:000296', NULL, NULL, 'Cholesterol side-chain cleavage enzyme, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(164744, NULL, 'G3DSA:3.40.50.300:FF:002157', NULL, NULL, 'Type IV pilus twitching motility protein PilT', NULL, NULL, NULL, NULL, NULL, 4),
(164745, NULL, 'G3DSA:2.60.120.10:FF:000534', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164746, NULL, 'G3DSA:4.10.400.10:FF:000195', NULL, NULL, 'Sortilin-related receptor', NULL, NULL, NULL, NULL, NULL, 4),
(164747, NULL, 'G3DSA:3.90.190.10:FF:000466', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164748, NULL, 'G3DSA:2.120.10.30:FF:000033', NULL, NULL, 'teneurin-a isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(164749, NULL, 'G3DSA:2.40.50.140:FF:000595', NULL, NULL, 'Uncharacterized protein 100H1.110', NULL, NULL, NULL, NULL, NULL, 4),
(164750, NULL, 'G3DSA:3.40.850.10:FF:000348', NULL, NULL, 'Myosin XVIIIB', NULL, NULL, NULL, NULL, NULL, 4),
(164751, NULL, 'G3DSA:3.40.50.720:FF:002047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164752, NULL, 'G3DSA:2.60.40.150:FF:000406', NULL, NULL, 'Activating signal cointegrator 1 complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(164753, NULL, 'G3DSA:1.20.1560.10:FF:000118', NULL, NULL, 'Multidrug resistance protein 2 (Heavy metal transport family)', NULL, NULL, NULL, NULL, NULL, 4),
(164754, NULL, 'G3DSA:2.40.30.10:FF:000015', NULL, NULL, 'Translation factor GUF1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(164755, NULL, 'G3DSA:3.30.1460.70:FF:000001', NULL, NULL, 'Putative sensory transduction regulator', NULL, NULL, NULL, NULL, NULL, 4),
(164756, NULL, 'G3DSA:3.30.160.60:FF:006310', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164757, NULL, 'G3DSA:2.80.10.50:FF:000255', NULL, NULL, 'Fascin', NULL, NULL, NULL, NULL, NULL, 4),
(164758, NULL, 'G3DSA:3.80.10.10:FF:000757', NULL, NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', NULL, NULL, NULL, NULL, NULL, 4),
(164759, NULL, 'G3DSA:3.90.226.10:FF:000123', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(164760, NULL, 'G3DSA:3.40.630.30:FF:000462', NULL, NULL, 'Lmo1129 protein', NULL, NULL, NULL, NULL, NULL, 4),
(164761, NULL, 'G3DSA:3.90.550.10:FF:000449', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164762, NULL, 'G3DSA:3.10.150.10:FF:000021', NULL, NULL, 'DNA polymerase III, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(164763, NULL, 'G3DSA:2.30.38.10:FF:000005', NULL, NULL, 'Luciferin 4-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(164764, NULL, 'G3DSA:1.10.640.10:FF:000010', NULL, NULL, 'Thyroid peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(164765, NULL, 'G3DSA:2.30.29.30:FF:000529', NULL, NULL, 'Nuclear protein export protein Yrb2', NULL, NULL, NULL, NULL, NULL, 4),
(164766, NULL, 'G3DSA:2.40.10.10:FF:000424', NULL, NULL, 'AGAP001252-PA', NULL, NULL, NULL, NULL, NULL, 4),
(164767, NULL, 'G3DSA:3.40.50.300:FF:007249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164768, NULL, 'G3DSA:3.40.190.80:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164769, NULL, 'G3DSA:1.25.40.20:FF:000742', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(164770, NULL, 'G3DSA:3.40.50.300:FF:007980', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164771, NULL, 'G3DSA:1.25.40.450:FF:000012', NULL, NULL, 'Nuclear pore complex protein Nup155', NULL, NULL, NULL, NULL, NULL, 4),
(164772, NULL, 'G3DSA:1.20.58.340:FF:000016', NULL, NULL, 'Magnesium transporter ALR1', NULL, NULL, NULL, NULL, NULL, 4),
(164773, NULL, 'G3DSA:3.40.120.10:FF:000097', NULL, NULL, 'Phosphoglucomutase/phosphomannomutase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(164774, NULL, 'G3DSA:1.20.58.1210:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164775, NULL, 'G3DSA:3.10.129.10:FF:000213', NULL, NULL, 'Acyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(164776, NULL, 'G3DSA:1.10.560.10:FF:000088', NULL, NULL, 'T-complex protein 1 delta subunit putative', NULL, NULL, NULL, NULL, NULL, 4),
(164777, NULL, 'G3DSA:3.50.50.60:FF:000203', NULL, NULL, 'Related to sulfide:quinone oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(164778, NULL, 'G3DSA:3.30.420.140:FF:000020', NULL, NULL, 'Putative pre-16S rRNA nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(164779, NULL, 'G3DSA:3.40.33.10:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164780, NULL, 'G3DSA:1.25.40.10:FF:004303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164781, NULL, 'G3DSA:3.30.60.270:FF:000005', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(164782, NULL, 'G3DSA:3.10.20.90:FF:000931', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164783, NULL, 'G3DSA:3.90.1490.10:FF:000005', NULL, NULL, 'Cytoplasmic protein, variant', NULL, NULL, NULL, NULL, NULL, 4),
(164784, NULL, 'G3DSA:2.30.42.10:FF:000515', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164785, NULL, 'G3DSA:1.10.10.60:FF:001123', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164786, NULL, 'G3DSA:1.25.10.10:FF:002598', NULL, NULL, 'Os04g0608500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(164787, NULL, 'G3DSA:1.25.40.10:FF:003735', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164788, NULL, 'G3DSA:1.25.40.20:FF:000450', NULL, NULL, 'Kinase D-interacting substrate 220', NULL, NULL, NULL, NULL, NULL, 4),
(164789, NULL, 'G3DSA:1.10.238.10:FF:001233', NULL, NULL, 'Myosin light chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(164790, NULL, 'G3DSA:3.90.226.10:FF:000191', NULL, NULL, '6-oxocamphor hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(164791, NULL, 'G3DSA:1.10.10.60:FF:000555', NULL, NULL, 'Homeobox domain containing protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(164792, NULL, 'G3DSA:1.10.10.10:FF:000113', NULL, NULL, 'ETS domain-containing protein Elk-3', NULL, NULL, NULL, NULL, NULL, 4),
(164793, NULL, 'G3DSA:1.20.58.60:FF:000709', NULL, NULL, 'Spectrin repeat containing nuclear envelope protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(164794, NULL, 'G3DSA:1.25.40.250:FF:000003', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit K', NULL, NULL, NULL, NULL, NULL, 4),
(164795, NULL, 'G3DSA:3.50.50.60:FF:000383', NULL, NULL, 'protein anon-37Cs', NULL, NULL, NULL, NULL, NULL, 4),
(164796, NULL, 'G3DSA:1.10.510.10:FF:003575', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164797, NULL, 'G3DSA:2.40.10.10:FF:000132', NULL, NULL, 'Inactive serine protease 54', NULL, NULL, NULL, NULL, NULL, 4),
(164798, NULL, 'G3DSA:2.170.120.20:FF:000005', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(164799, NULL, 'G3DSA:1.10.420.10:FF:000027', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(164800, NULL, 'G3DSA:3.40.50.2300:FF:001632', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164801, NULL, 'G3DSA:3.40.50.1010:FF:000042', NULL, NULL, 'Ribonuclease VapC', NULL, NULL, NULL, NULL, NULL, 4),
(164802, NULL, 'G3DSA:1.10.533.10:FF:000042', NULL, NULL, 'Tumor necrosis factor receptor type 1-associated DEATH domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(164803, NULL, 'G3DSA:2.60.40.150:FF:000165', NULL, NULL, 'rho GTPase-activating protein 100F isoform X6', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(164804, NULL, 'G3DSA:1.10.238.10:FF:000957', NULL, NULL, 'Probable calcium-binding protein CML21', NULL, NULL, NULL, NULL, NULL, 4),
(164805, NULL, 'G3DSA:1.20.960.20:FF:000001', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(164806, NULL, 'G3DSA:1.20.1250.20:FF:000249', NULL, NULL, 'facilitated trehalose transporter Tret1', NULL, NULL, NULL, NULL, NULL, 4),
(164807, NULL, 'G3DSA:3.40.50.300:FF:000628', NULL, NULL, 'Endoribonuclease Dicer', NULL, NULL, NULL, NULL, NULL, 4),
(164808, NULL, 'G3DSA:1.20.5.1230:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164809, NULL, 'G3DSA:2.60.40.1230:FF:000025', NULL, NULL, 'AdaPTin or adaptin-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(164810, NULL, 'G3DSA:2.10.25.10:FF:001404', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164811, NULL, 'G3DSA:3.80.10.10:FF:002202', NULL, NULL, 'DmMstProx', NULL, NULL, NULL, NULL, NULL, 4),
(164812, NULL, 'G3DSA:1.10.630.10:FF:000745', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164813, NULL, 'G3DSA:1.25.10.10:FF:003166', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(164814, NULL, 'G3DSA:1.25.40.470:FF:000018', NULL, NULL, 'Reduced mechanoreceptor potential A', NULL, NULL, NULL, NULL, NULL, 4),
(164815, NULL, 'G3DSA:2.40.70.10:FF:000012', NULL, NULL, 'Aspartyl protease family protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(164816, NULL, 'G3DSA:3.40.50.2020:FF:000070', NULL, NULL, 'Ribose-phosphate pyrophosphokinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164817, NULL, 'G3DSA:3.80.10.10:FF:003630', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164818, NULL, 'G3DSA:1.20.1250.20:FF:000688', NULL, NULL, 'Predicted arabinose efflux permease, MFS family', NULL, NULL, NULL, NULL, NULL, 4),
(164819, NULL, 'G3DSA:3.30.1490.20:FF:000016', NULL, NULL, 'phosphoribosylaminoimidazole carboxylase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(164820, NULL, 'G3DSA:3.30.160.60:FF:002836', NULL, NULL, 'Spalt-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(164821, NULL, 'G3DSA:1.20.1740.10:FF:000267', NULL, NULL, 'Low affinity cationic amino acid transporter 2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(164822, NULL, 'G3DSA:3.90.105.10:FF:000005', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(164823, NULL, 'G3DSA:3.40.50.1820:FF:001656', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(164824, NULL, 'G3DSA:2.40.10.10:FF:000475', NULL, NULL, 'Azurocidin', NULL, NULL, NULL, NULL, NULL, 4),
(164825, NULL, 'G3DSA:3.40.30.10:FF:001137', NULL, NULL, 'Os01g0353400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(164826, NULL, 'G3DSA:3.30.160.60:FF:002887', NULL, NULL, 'Zinc finger protein 263 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(164827, NULL, 'G3DSA:3.40.50.300:FF:003938', NULL, NULL, 'Shikimate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(164828, NULL, 'G3DSA:3.30.160.60:FF:001931', NULL, NULL, 'Zinc finger protein 92', NULL, NULL, NULL, NULL, NULL, 4),
(164829, NULL, 'G3DSA:3.30.450.20:FF:000413', NULL, NULL, 'Hybrid signal transduction histidine kinase I', NULL, NULL, NULL, NULL, NULL, 4),
(164830, NULL, 'G3DSA:2.130.10.10:FF:002691', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164831, NULL, 'G3DSA:1.20.5.170:FF:000106', NULL, NULL, 'Chromatin structure-remodeling complex subunit snf21', NULL, NULL, NULL, NULL, NULL, 4),
(164832, NULL, 'G3DSA:1.10.8.60:FF:000594', NULL, NULL, 'Cell division control protein', NULL, NULL, NULL, NULL, NULL, 4),
(164833, NULL, 'G3DSA:1.10.10.10:FF:001018', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(164834, NULL, 'G3DSA:2.40.30.70:FF:000005', NULL, NULL, 'Nef-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(164835, NULL, 'G3DSA:2.120.10.30:FF:000533', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164836, NULL, 'G3DSA:3.30.160.60:FF:005293', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(164837, NULL, 'G3DSA:2.60.40.3210:FF:000029', NULL, NULL, 'Zona pellucida glycoprotein 3b', NULL, NULL, NULL, NULL, NULL, 4),
(164838, NULL, 'G3DSA:3.40.50.150:FF:001555', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164839, NULL, 'G3DSA:1.25.40.470:FF:000069', NULL, NULL, 'WD repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164840, NULL, 'G3DSA:3.30.1490.20:FF:000067', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(164841, NULL, 'G3DSA:3.30.70.330:FF:002970', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164842, NULL, 'G3DSA:3.30.160.60:FF:000066', NULL, NULL, 'Putative zinc finger E-box-binding homeobox 2', NULL, NULL, NULL, NULL, NULL, 4),
(164843, NULL, 'G3DSA:2.70.170.10:FF:000108', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(164844, NULL, 'G3DSA:1.10.510.10:FF:002114', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(164845, NULL, 'G3DSA:3.60.21.60:FF:000034', NULL, NULL, 'DNA polymerase epsilon subunit', NULL, NULL, NULL, NULL, NULL, 4),
(164846, NULL, 'G3DSA:3.40.50.2300:FF:000917', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164847, NULL, 'G3DSA:1.10.3210.10:FF:000039', NULL, NULL, 'Protein CBG02420', NULL, NULL, NULL, NULL, NULL, 4),
(164848, NULL, 'G3DSA:2.30.30.140:FF:000279', NULL, NULL, 'Probable histone-lysine N-methyltransferase Mes-4', NULL, NULL, NULL, NULL, NULL, 4),
(164849, NULL, 'G3DSA:2.60.40.10:FF:005372', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164850, NULL, 'G3DSA:2.40.50.140:FF:000191', NULL, NULL, 'DNA-directed RNA polymerases I, II, and III subunit RPABC3', NULL, NULL, NULL, NULL, NULL, 4),
(164851, NULL, 'G3DSA:1.10.533.10:FF:000093', NULL, NULL, 'Death-associated protein kinase dapk-1', NULL, NULL, NULL, NULL, NULL, 4),
(164852, NULL, 'G3DSA:3.10.20.90:FF:000835', NULL, NULL, 'Chromosome 23, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(164853, NULL, 'G3DSA:2.30.30.100:FF:000115', NULL, NULL, 'Yeast Enhancer of DeCapping homolog', NULL, NULL, NULL, NULL, NULL, 4),
(164854, NULL, 'G3DSA:3.30.460.10:FF:000080', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164855, NULL, 'G3DSA:1.10.630.10:FF:000796', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164856, NULL, 'G3DSA:2.130.10.10:FF:002983', NULL, NULL, 'Protein CBG03993', NULL, NULL, NULL, NULL, NULL, 4),
(164857, NULL, 'G3DSA:1.20.58.60:FF:000417', NULL, NULL, 'Spectrin repeat containing nuclear envelope family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(164858, NULL, 'G3DSA:3.30.590.20:FF:000002', NULL, NULL, 'Putative glutamate--cysteine ligase 2', NULL, NULL, NULL, NULL, NULL, 4),
(164859, NULL, 'G3DSA:3.90.430.10:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164860, NULL, 'G3DSA:1.10.150.20:FF:000043', NULL, NULL, 'Meiotic recombination protein DMC1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(164861, NULL, 'G3DSA:2.30.30.1020:FF:000025', NULL, NULL, 'Subunit of the ccr4not complex', NULL, NULL, NULL, NULL, NULL, 4),
(164862, NULL, 'G3DSA:1.10.510.10:FF:000265', NULL, NULL, 'Putative LOV domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(164863, NULL, 'G3DSA:2.60.40.1970:FF:000005', NULL, NULL, 'YEATS domain-containing protein 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(164864, NULL, 'G3DSA:3.30.420.40:FF:000530', NULL, NULL, 'Heat shock protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164865, NULL, 'G3DSA:3.90.226.10:FF:000011', NULL, NULL, 'Fatty acid oxidation complex subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(164866, NULL, 'G3DSA:2.10.25.10:FF:000387', NULL, NULL, 'basement membrane-specific heparan sulfate proteoglycan core protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(164867, NULL, 'G3DSA:3.30.160.60:FF:006198', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164868, NULL, 'G3DSA:3.30.930.10:FF:000374', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164869, NULL, 'G3DSA:3.10.490.10:FF:000007', NULL, NULL, 'Gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(164870, NULL, 'G3DSA:6.10.250.3250:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164871, NULL, 'G3DSA:2.40.270.10:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164872, NULL, 'G3DSA:3.40.50.2300:FF:000968', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164873, NULL, 'G3DSA:1.10.8.60:FF:000543', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164874, NULL, 'G3DSA:2.60.40.10:FF:001038', NULL, NULL, 'Immunoglobulin superfamily DCC subclass member 4', NULL, NULL, NULL, NULL, NULL, 4),
(164875, NULL, 'G3DSA:1.10.560.10:FF:000060', NULL, NULL, '60 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(164876, NULL, 'G3DSA:3.30.40.10:FF:000666', NULL, NULL, 'E3 ubiquitin-protein ligase MYLIP', NULL, NULL, NULL, NULL, NULL, 4),
(164877, NULL, 'G3DSA:1.10.40.30:FF:000008', NULL, NULL, 'Fumarate hydratase class II', NULL, NULL, NULL, NULL, NULL, 4),
(164878, NULL, 'G3DSA:2.60.40.10:FF:001931', NULL, NULL, 'Uncharacterized LOC100216153', NULL, NULL, NULL, NULL, NULL, 4),
(164879, NULL, 'G3DSA:3.30.160.60:FF:003376', NULL, NULL, 'GD10244', NULL, NULL, NULL, NULL, NULL, 4),
(164880, NULL, 'G3DSA:2.60.120.290:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164881, NULL, 'G3DSA:2.30.29.30:FF:000940', NULL, NULL, 'UDP-sugar-dependent glycosyltransferase 52', NULL, NULL, NULL, NULL, NULL, 4),
(164882, NULL, 'G3DSA:3.40.50.300:FF:007828', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164883, NULL, 'G3DSA:3.20.190.10:FF:000010', NULL, NULL, 'Endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(164884, NULL, 'G3DSA:1.10.287.1040:FF:000009', NULL, NULL, 'Exodeoxyribonuclease 7 small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(164885, NULL, 'G3DSA:1.10.10.10:FF:001069', NULL, NULL, 'Response regulator VieA', NULL, NULL, NULL, NULL, NULL, 4),
(164886, NULL, 'G3DSA:3.30.2460.20:FF:000014', NULL, NULL, 'Protein Wnt', NULL, NULL, NULL, NULL, NULL, 4),
(164887, NULL, 'G3DSA:3.40.50.11210:FF:000010', NULL, NULL, 'Tuberous sclerosis complex 2 tsc2', NULL, NULL, NULL, NULL, NULL, 4),
(164888, NULL, 'G3DSA:1.10.3500.10:FF:000027', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164889, NULL, 'G3DSA:1.20.1690.10:FF:000010', NULL, NULL, 'V-type proton ATPase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(164890, NULL, 'G3DSA:1.10.238.10:FF:000165', NULL, NULL, 'Calbindin 2', NULL, NULL, NULL, NULL, NULL, 4),
(164891, NULL, 'G3DSA:3.40.630.30:FF:000170', NULL, NULL, 'Acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164892, NULL, 'G3DSA:3.40.532.10:FF:000014', NULL, NULL, 'ubiquitin carboxyl-terminal hydrolase BAP1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(164893, NULL, 'G3DSA:1.10.246.130:FF:000002', NULL, NULL, 'glutathione hydrolase 1 proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(164894, NULL, 'G3DSA:2.40.40.20:FF:000081', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(164895, NULL, 'G3DSA:2.160.20.10:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164896, NULL, 'G3DSA:3.40.1350.10:FF:000023', NULL, NULL, 'Putative helicase', NULL, NULL, NULL, NULL, NULL, 4),
(164897, NULL, 'G3DSA:2.60.40.10:FF:003247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164898, NULL, 'G3DSA:1.10.8.10:FF:000314', NULL, NULL, 'Protein DDI1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(164899, NULL, 'G3DSA:3.40.50.300:FF:005855', NULL, NULL, 'Lon protease', NULL, NULL, NULL, NULL, NULL, 4),
(164900, NULL, 'G3DSA:2.60.120.650:FF:000071', NULL, NULL, 'Lysine (K)-specific demethylase 4B', NULL, NULL, NULL, NULL, NULL, 4),
(164901, NULL, 'G3DSA:1.25.40.10:FF:000121', NULL, NULL, 'Tetratricopeptide repeat domain 8', NULL, NULL, NULL, NULL, NULL, 4),
(164902, NULL, 'G3DSA:1.50.10.10:FF:000168', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(164903, NULL, 'G3DSA:2.120.10.80:FF:000183', NULL, NULL, 'F-box/kelch-repeat protein isoform A', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(164904, NULL, 'G3DSA:3.40.395.10:FF:000015', NULL, NULL, 'Protease ElaD', NULL, NULL, NULL, NULL, NULL, 4),
(164905, NULL, 'G3DSA:3.10.20.90:FF:000190', NULL, NULL, 'Small ubiquitin-related modifier', NULL, NULL, NULL, NULL, NULL, 4),
(164906, NULL, 'G3DSA:1.10.8.10:FF:000101', NULL, NULL, 'Nascent polypeptide associated complex alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(164907, NULL, 'G3DSA:1.20.120.1900:FF:000002', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(164908, NULL, 'G3DSA:2.60.120.970:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164909, NULL, 'G3DSA:3.10.110.10:FF:000024', NULL, NULL, 'Ubiquitin-conjugating enzyme 5, E2', NULL, NULL, NULL, NULL, NULL, 4),
(164910, NULL, 'G3DSA:1.10.1070.11:FF:000146', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(164911, NULL, 'G3DSA:1.10.640.10:FF:000089', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164912, NULL, 'G3DSA:3.90.70.10:FF:000660', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(164913, NULL, 'G3DSA:1.10.510.10:FF:003963', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164914, NULL, 'G3DSA:1.10.20.10:FF:000350', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164915, NULL, 'G3DSA:3.30.420.10:FF:000015', NULL, NULL, 'DNA polymerase epsilon catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(164916, NULL, 'G3DSA:1.20.1560.10:FF:000562', NULL, NULL, 'Chromosome 21, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(164917, NULL, 'G3DSA:1.10.640.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164918, NULL, 'G3DSA:3.40.120.10:FF:000046', NULL, NULL, 'Pgm3p', NULL, NULL, NULL, NULL, NULL, 4),
(164919, NULL, 'G3DSA:1.25.10.10:FF:000361', NULL, NULL, 'GCN1, eIF2 alpha kinase activator homolog', NULL, NULL, NULL, NULL, NULL, 4),
(164920, NULL, 'G3DSA:3.30.70.270:FF:000069', NULL, NULL, 'Probable diguanylate cyclase DgcE', NULL, NULL, NULL, NULL, NULL, 4),
(164921, NULL, 'G3DSA:3.30.450.40:FF:000239', NULL, NULL, 'Sensor histidine kinase, GAF domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(164922, NULL, 'G3DSA:2.60.40.60:FF:000171', NULL, NULL, 'FAT atypical cadherin 4', NULL, NULL, NULL, NULL, NULL, 4),
(164923, NULL, 'G3DSA:1.20.58.340:FF:000067', NULL, NULL, 'Polynucleotide adenylyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(164924, NULL, 'G3DSA:2.60.40.60:FF:000075', NULL, NULL, 'FAT atypical cadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(164925, NULL, 'G3DSA:3.30.310.50:FF:000007', NULL, NULL, 'Phosphomannomutase/phosphoglucomutase', NULL, NULL, NULL, NULL, NULL, 4),
(164926, NULL, 'G3DSA:1.10.287.70:FF:000616', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164927, NULL, 'G3DSA:2.60.300.12:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164928, NULL, 'G3DSA:2.60.120.290:FF:000171', NULL, NULL, 'Cubilin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(164929, NULL, 'G3DSA:2.130.10.10:FF:005057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164930, NULL, 'G3DSA:3.10.110.10:FF:000075', NULL, NULL, 'RWD domain-containing protein (Gir2)', NULL, NULL, NULL, NULL, NULL, 4),
(164931, NULL, 'G3DSA:1.25.60.10:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164932, NULL, 'G3DSA:2.40.50.140:FF:000983', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164933, NULL, 'G3DSA:3.40.50.720:FF:001479', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164934, NULL, 'G3DSA:2.60.40.10:FF:003808', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(164935, NULL, 'G3DSA:1.10.390.10:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164936, NULL, 'G3DSA:3.40.50.300:FF:003034', NULL, NULL, 'RAB34, member RAS oncogene family b', NULL, NULL, NULL, NULL, NULL, 4),
(164937, NULL, 'G3DSA:1.20.1070.10:FF:001722', NULL, NULL, 'Endothelin receptor type B', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(164938, NULL, 'G3DSA:2.40.50.140:FF:000887', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164939, NULL, 'G3DSA:3.30.70.100:FF:000046', NULL, NULL, 'Nipsnap, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(164940, NULL, 'G3DSA:1.10.460.10:FF:000024', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(164941, NULL, 'G3DSA:3.40.470.10:FF:000010', NULL, NULL, 'G/U mismatch-specific DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(164942, NULL, 'G3DSA:3.30.60.20:FF:000035', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(164943, NULL, 'G3DSA:1.20.5.170:FF:000286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164944, NULL, 'G3DSA:2.60.40.790:FF:000103', NULL, NULL, 'Spore coat protein M', NULL, NULL, NULL, NULL, NULL, 4),
(164945, NULL, 'G3DSA:3.30.1240.10:FF:000028', NULL, NULL, 'Hydrolase, haloacid dehalogenase-like family', NULL, NULL, NULL, NULL, NULL, 4),
(164946, NULL, 'G3DSA:1.25.10.10:FF:001721', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164947, NULL, 'G3DSA:3.40.50.2000:FF:000204', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(164948, NULL, 'G3DSA:2.130.10.10:FF:001134', NULL, NULL, 'Protein transport protein Sec31, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164949, NULL, 'G3DSA:2.60.40.150:FF:000114', NULL, NULL, 'Extended synaptotagmin 3', NULL, NULL, NULL, NULL, NULL, 4),
(164950, NULL, 'G3DSA:3.30.40.10:FF:001104', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(164951, NULL, 'G3DSA:3.40.50.880:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164952, NULL, 'G3DSA:3.40.50.1000:FF:000213', NULL, NULL, 'HAD hydrolase, family IA, variant 3', NULL, NULL, NULL, NULL, NULL, 4),
(164953, NULL, 'G3DSA:2.60.120.10:FF:000826', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164954, NULL, 'G3DSA:1.10.274.30:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164955, NULL, 'G3DSA:1.10.238.150:FF:000007', NULL, NULL, 'Formin 3, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(164956, NULL, 'G3DSA:3.30.230.120:FF:000010', NULL, NULL, 'Protein CBG25497', NULL, NULL, NULL, NULL, NULL, 4),
(164957, NULL, 'G3DSA:4.10.410.10:FF:000021', NULL, NULL, 'Serine protease inhibitor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164958, NULL, 'G3DSA:3.30.40.10:FF:000615', NULL, NULL, 'E3 ubiquitin ligase BIG BROTHER', NULL, NULL, NULL, NULL, NULL, 4),
(164959, NULL, 'G3DSA:1.10.10.10:FF:001962', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164960, NULL, 'G3DSA:1.20.1070.10:FF:000362', NULL, NULL, 'D(4) dopamine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(164961, NULL, 'G3DSA:3.40.50.300:FF:005804', NULL, NULL, 'p-GlycoProtein related', NULL, NULL, NULL, NULL, NULL, 4),
(164962, NULL, 'G3DSA:3.40.50.2000:FF:000300', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(164963, NULL, 'G3DSA:1.25.10.10:FF:002210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164964, NULL, 'G3DSA:2.60.120.920:FF:000056', NULL, NULL, 'Tripartite motif containing 14', NULL, NULL, NULL, NULL, NULL, 4),
(164965, NULL, 'G3DSA:1.10.8.10:FF:000365', NULL, NULL, 'Putative countin receptor Cnr4', NULL, NULL, NULL, NULL, NULL, 4),
(164966, NULL, 'G3DSA:3.40.50.620:FF:000718', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164967, NULL, 'G3DSA:1.20.1280.300:FF:000001', NULL, NULL, 'DNA-directed DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(164968, NULL, 'G3DSA:3.40.50.720:FF:000198', NULL, NULL, 'UDP-glucuronate 4-epimerase 3', NULL, NULL, NULL, NULL, NULL, 4),
(164969, NULL, 'G3DSA:3.10.20.70:FF:000032', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(164970, NULL, 'G3DSA:2.60.40.10:FF:005585', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164971, NULL, 'G3DSA:1.25.40.20:FF:000630', NULL, NULL, 'G9a, isoform B', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(164972, NULL, 'G3DSA:1.20.1250.20:FF:001418', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164973, NULL, 'G3DSA:3.40.1110.10:FF:000421', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164974, NULL, 'G3DSA:3.10.20.30:FF:000109', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164975, NULL, 'G3DSA:3.80.10.10:FF:001421', NULL, NULL, 'Trophoblast glycoprotein a', NULL, NULL, NULL, NULL, NULL, 4),
(164976, NULL, 'G3DSA:1.10.8.1220:FF:000006', NULL, NULL, 'Dynein axonemal heavy chain 14', NULL, NULL, NULL, NULL, NULL, 4),
(164977, NULL, 'G3DSA:2.80.10.50:FF:000176', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(164978, NULL, 'G3DSA:3.80.10.10:FF:003551', NULL, NULL, 'Si:ch211-214j8.12', NULL, NULL, NULL, NULL, NULL, 4),
(164979, NULL, 'G3DSA:3.30.300.70:FF:000007', NULL, NULL, 'Ribosome maturation factor RimP', NULL, NULL, NULL, NULL, NULL, 4),
(164980, NULL, 'G3DSA:2.30.30.100:FF:000087', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm4', NULL, NULL, NULL, NULL, NULL, 4),
(164981, NULL, 'G3DSA:2.40.50.90:FF:000175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164982, NULL, 'G3DSA:2.30.140.10:FF:000020', NULL, NULL, 'Spermine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(164983, NULL, 'G3DSA:3.40.30.10:FF:000356', NULL, NULL, 'Glutathione S-Transferase', NULL, NULL, NULL, NULL, NULL, 4),
(164984, NULL, 'G3DSA:3.10.20.550:FF:000001', NULL, NULL, 'Histone deacetylase complex subunit SAP18', NULL, NULL, NULL, NULL, NULL, 4),
(164985, NULL, 'G3DSA:2.40.50.120:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164986, NULL, 'G3DSA:2.70.160.11:FF:000092', NULL, NULL, 'Shk1 kinase-binding protein (Skb1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(164987, NULL, 'G3DSA:1.10.10.10:FF:000001', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(164988, NULL, 'G3DSA:3.40.390.10:FF:000240', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164989, NULL, 'G3DSA:2.60.40.10:FF:003455', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164990, NULL, 'G3DSA:3.40.1670.10:FF:000002', NULL, NULL, 'Menaquinone biosynthesis decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(164991, NULL, 'G3DSA:1.10.510.10:FF:003463', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164992, NULL, 'G3DSA:2.30.42.10:FF:000111', NULL, NULL, 'Whirlin a', NULL, NULL, NULL, NULL, NULL, 4),
(164993, NULL, 'G3DSA:3.40.630.10:FF:000063', NULL, NULL, 'Glutamate carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(164994, NULL, 'G3DSA:1.20.58.670:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(164995, NULL, 'G3DSA:1.25.40.20:FF:001708', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(164996, NULL, 'G3DSA:1.10.340.70:FF:000016', NULL, NULL, 'Retrovirus-related Pol polyprotein from transposon opus-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(164997, NULL, 'G3DSA:2.10.25.10:FF:001617', NULL, NULL, 'Brevican', NULL, NULL, NULL, NULL, NULL, 4),
(164998, NULL, 'G3DSA:1.20.140.10:FF:000043', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(164999, NULL, 'G3DSA:3.40.50.1820:FF:001095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165000, NULL, 'G3DSA:1.20.58.390:FF:000060', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(165001, NULL, 'G3DSA:1.10.555.10:FF:000166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165002, NULL, 'G3DSA:3.40.50.300:FF:005479', NULL, NULL, 'DNA repair protein RecN', NULL, NULL, NULL, NULL, NULL, 4),
(165003, NULL, 'G3DSA:2.160.20.70:FF:000027', NULL, NULL, 'Adenylyl cyclase-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(165004, NULL, 'G3DSA:1.50.40.10:FF:000529', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165005, NULL, 'G3DSA:2.130.10.10:FF:004040', NULL, NULL, 'Vacuolar assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(165006, NULL, 'G3DSA:1.10.357.10:FF:000060', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(165007, NULL, 'G3DSA:2.10.25.10:FF:001033', NULL, NULL, 'Mesocentin', NULL, NULL, NULL, NULL, NULL, 4),
(165008, NULL, 'G3DSA:2.130.10.10:FF:004568', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165009, NULL, 'G3DSA:3.20.20.150:FF:000059', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(165010, NULL, 'G3DSA:1.20.5.110:FF:000116', NULL, NULL, 'Vacuolar v-SNARE', NULL, NULL, NULL, NULL, NULL, 4),
(165011, NULL, 'G3DSA:3.30.70.330:FF:001166', NULL, NULL, 'SAFB like transcription modulator', NULL, NULL, NULL, NULL, NULL, 4),
(165012, NULL, 'G3DSA:3.30.160.60:FF:001870', NULL, NULL, 'Zinc finger protein 425', NULL, NULL, NULL, NULL, NULL, 4),
(165013, NULL, 'G3DSA:1.20.1070.10:FF:000070', NULL, NULL, 'Parathyroid hormone/parathyroid hormone-related peptide receptor', NULL, NULL, NULL, NULL, NULL, 4),
(165014, NULL, 'G3DSA:2.40.10.170:FF:000006', NULL, NULL, 'ATP synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(165015, NULL, 'G3DSA:3.30.710.10:FF:000442', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165016, NULL, 'G3DSA:3.10.110.10:FF:000367', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165017, NULL, 'G3DSA:3.90.520.10:FF:000009', NULL, NULL, 'Mothers against decapentaplegic homolog', NULL, NULL, NULL, NULL, NULL, 4),
(165018, NULL, 'G3DSA:2.30.30.40:FF:000042', NULL, NULL, 'SH3 and PX domain-containing protein 2A', NULL, NULL, NULL, NULL, NULL, 4),
(165019, NULL, 'G3DSA:1.10.1410.20:FF:000006', NULL, NULL, '2''-5'' oligoadenylate synthetase 1H', NULL, NULL, NULL, NULL, NULL, 4),
(165020, NULL, 'G3DSA:3.30.160.60:FF:000919', NULL, NULL, 'Zinc finger protein 260', NULL, NULL, NULL, NULL, NULL, 4),
(165021, NULL, 'G3DSA:2.20.70.10:FF:000182', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(165022, NULL, 'G3DSA:3.50.50.60:FF:001164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165023, NULL, 'G3DSA:1.20.1070.10:FF:001222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165024, NULL, 'G3DSA:3.90.1410.10:FF:000146', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165025, NULL, 'G3DSA:2.160.10.10:FF:000031', NULL, NULL, 'Translation initiation factor eIF-2B subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(165026, NULL, 'G3DSA:1.10.12.70:FF:000006', NULL, NULL, 'serine/threonine-protein kinase svkA', NULL, NULL, NULL, NULL, NULL, 4),
(165027, NULL, 'G3DSA:3.20.20.70:FF:000784', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165028, NULL, 'G3DSA:3.40.605.10:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165029, NULL, 'G3DSA:3.40.50.2300:FF:000064', NULL, NULL, 'HTH-type transcriptional regulator GntR', NULL, NULL, NULL, NULL, NULL, 4),
(165030, NULL, 'G3DSA:3.40.50.1110:FF:000134', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165031, NULL, 'G3DSA:3.80.10.10:FF:002562', NULL, NULL, 'Cysteine peptidase, Clan CA, family C2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165032, NULL, 'G3DSA:1.10.3370.10:FF:000033', NULL, NULL, 'Sec61 alpha subunit putative', NULL, NULL, NULL, NULL, NULL, 4),
(165033, NULL, 'G3DSA:1.10.1200.260:FF:000005', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165034, NULL, 'G3DSA:1.10.630.10:FF:000824', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165035, NULL, 'G3DSA:3.40.50.720:FF:001187', NULL, NULL, 'UDP-glucuronic acid decarboxylase 5', NULL, NULL, NULL, NULL, NULL, 4),
(165036, NULL, 'G3DSA:3.40.50.300:FF:004282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165037, NULL, 'G3DSA:2.60.40.60:FF:000283', NULL, NULL, 'neural-cadherin isoform X9', NULL, NULL, NULL, NULL, NULL, 4),
(165038, NULL, 'G3DSA:1.10.287.70:FF:000796', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165039, NULL, 'G3DSA:3.90.228.10:FF:000026', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(165040, NULL, 'G3DSA:1.25.40.10:FF:004516', NULL, NULL, 'DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(165041, NULL, 'G3DSA:3.30.40.10:FF:002083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165042, NULL, 'G3DSA:1.25.10.10:FF:003227', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165043, NULL, 'G3DSA:3.50.30.30:FF:000165', NULL, NULL, 'Extracellular serine alkaline protease SapSH', NULL, NULL, NULL, NULL, NULL, 4),
(165044, NULL, 'G3DSA:3.40.190.10:FF:000663', NULL, NULL, 'p-protein (PheA)', NULL, NULL, NULL, NULL, NULL, 4),
(165045, NULL, 'G3DSA:1.25.40.10:FF:001762', NULL, NULL, 'Tetratricopeptide repeat domain 28', NULL, NULL, NULL, NULL, NULL, 4),
(165046, NULL, 'G3DSA:3.90.190.10:FF:000062', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase kappa', NULL, NULL, NULL, NULL, NULL, 4),
(165047, NULL, 'G3DSA:1.20.120.790:FF:000004', NULL, NULL, 'Heat shock protein 75 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(165048, NULL, 'G3DSA:3.40.50.300:FF:007036', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165049, NULL, 'G3DSA:2.60.40.10:FF:006102', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165050, NULL, 'G3DSA:1.25.10.20:FF:000010', NULL, NULL, 'GD24418', NULL, NULL, NULL, NULL, NULL, 4),
(165051, NULL, 'G3DSA:1.10.287.110:FF:000269', NULL, NULL, 'Chaperone protein DNAj, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165052, NULL, 'G3DSA:3.30.420.40:FF:000007', NULL, NULL, 'Glycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(165053, NULL, 'G3DSA:2.60.40.10:FF:000650', NULL, NULL, 'Mannosidase beta', NULL, NULL, NULL, NULL, NULL, 4),
(165054, NULL, 'G3DSA:2.40.50.40:FF:000121', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(165055, NULL, 'G3DSA:3.30.160.60:FF:002044', NULL, NULL, 'Cardiomyopathy associated 5', NULL, NULL, NULL, NULL, NULL, 4),
(165056, NULL, 'G3DSA:2.10.110.20:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165057, NULL, 'G3DSA:1.50.10.10:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165058, NULL, 'G3DSA:1.10.10.10:FF:002030', NULL, NULL, 'RNA polymerase sigma factor sigC', NULL, NULL, NULL, NULL, NULL, 4),
(165059, NULL, 'G3DSA:2.60.40.150:FF:000226', NULL, NULL, 'Tcb1p', NULL, NULL, NULL, NULL, NULL, 4),
(165060, NULL, 'G3DSA:3.20.20.80:FF:000692', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165061, NULL, 'G3DSA:2.60.120.10:FF:000714', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165062, NULL, 'G3DSA:2.30.29.30:FF:000709', NULL, NULL, 'Coactivator-associated arginine methyltransferase 1,-like', NULL, NULL, NULL, NULL, NULL, 4),
(165063, NULL, 'G3DSA:1.10.533.10:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165064, NULL, 'G3DSA:2.10.25.10:FF:000948', NULL, NULL, 'Crumbs homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(165065, NULL, 'G3DSA:2.10.110.10:FF:000062', NULL, NULL, 'LIM domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(165066, NULL, 'G3DSA:4.10.990.10:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165067, NULL, 'G3DSA:3.40.50.1820:FF:000690', NULL, NULL, 'Lipid particle protein, variant', NULL, NULL, NULL, NULL, NULL, 4),
(165068, NULL, 'G3DSA:2.60.40.60:FF:000867', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165069, NULL, 'G3DSA:2.40.30.10:FF:000358', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165070, NULL, 'G3DSA:3.10.290.10:FF:000059', NULL, NULL, '30S ribosomal protein S4e', NULL, NULL, NULL, NULL, NULL, 4),
(165071, NULL, 'G3DSA:1.10.10.60:FF:000959', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165072, NULL, 'G3DSA:1.10.8.500:FF:000011', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(165073, NULL, 'G3DSA:3.40.50.2000:FF:000917', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165074, NULL, 'G3DSA:2.10.90.10:FF:000003', NULL, NULL, 'Bone morphogenetic protein 5', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(165075, NULL, 'G3DSA:3.40.50.2300:FF:001424', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165076, NULL, 'G3DSA:2.60.40.10:FF:005321', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165077, NULL, 'G3DSA:1.10.10.60:FF:000055', NULL, NULL, 'Homeobox protein Hox-A5', NULL, NULL, NULL, NULL, NULL, 4),
(165078, NULL, 'G3DSA:2.10.110.10:FF:000270', NULL, NULL, 'LIM domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(165079, NULL, 'G3DSA:3.40.50.300:FF:007896', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165080, NULL, 'G3DSA:3.30.160.60:FF:003668', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165081, NULL, 'G3DSA:2.130.10.10:FF:005288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165082, NULL, 'G3DSA:3.30.40.10:FF:000958', NULL, NULL, 'Cellulose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(165083, NULL, 'G3DSA:2.20.100.10:FF:000008', NULL, NULL, 'Unc-5 netrin receptor C', NULL, NULL, NULL, NULL, NULL, 4),
(165084, NULL, 'G3DSA:2.30.180.10:FF:000174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165085, NULL, 'G3DSA:3.20.20.30:FF:000019', NULL, NULL, 'F420-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(165086, NULL, 'G3DSA:1.10.286.10:FF:000001', NULL, NULL, 'GTP cyclohydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(165087, NULL, 'G3DSA:3.20.20.70:FF:000508', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165088, NULL, 'G3DSA:3.30.70.330:FF:001430', NULL, NULL, 'RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(165089, NULL, 'G3DSA:3.40.50.620:FF:000786', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165090, NULL, 'G3DSA:1.25.10.10:FF:002502', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165091, NULL, 'G3DSA:2.130.10.10:FF:005506', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165092, NULL, 'G3DSA:1.10.150.20:FF:000200', NULL, NULL, 'DNA damage repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165093, NULL, 'G3DSA:1.10.510.10:FF:002035', NULL, NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 182', NULL, NULL, NULL, NULL, NULL, 4),
(165094, NULL, 'G3DSA:3.40.50.10330:FF:000089', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(165095, NULL, 'G3DSA:1.10.510.10:FF:003671', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165096, NULL, 'G3DSA:3.40.50.720:FF:002547', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(165097, NULL, 'G3DSA:1.10.510.10:FF:003783', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165098, NULL, 'G3DSA:1.10.132.60:FF:000024', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(165099, NULL, 'G3DSA:2.10.25.10:FF:000095', NULL, NULL, 'Notch, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(165100, NULL, 'G3DSA:1.20.120.350:FF:000238', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165101, NULL, 'G3DSA:3.40.50.2060:FF:000003', NULL, NULL, 'vacuolar protein sorting-associated protein 45 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(165102, NULL, 'G3DSA:2.70.130.10:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165103, NULL, 'G3DSA:3.30.70.330:FF:000992', NULL, NULL, 'Hrb1p', NULL, NULL, NULL, NULL, NULL, 4),
(165104, NULL, 'G3DSA:3.30.572.10:FF:000013', NULL, NULL, 'Thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(165105, NULL, 'G3DSA:1.20.1170.10:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165106, NULL, 'G3DSA:1.20.58.60:FF:000861', NULL, NULL, 'BetaH spectrin', NULL, NULL, NULL, NULL, NULL, 4),
(165107, NULL, 'G3DSA:2.60.40.10:FF:005872', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165108, NULL, 'G3DSA:2.30.29.30:FF:000861', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165109, NULL, 'G3DSA:1.20.1070.10:FF:001430', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165110, NULL, 'G3DSA:3.20.20.10:FF:000013', NULL, NULL, 'Alanine/ornithine racemase family PLP-dependent enzyme', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(165111, NULL, 'G3DSA:1.10.1300.10:FF:000079', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(165112, NULL, 'G3DSA:3.40.190.10:FF:000820', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(165113, NULL, 'G3DSA:3.40.1160.10:FF:000099', NULL, NULL, 'Carbamate kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165114, NULL, 'G3DSA:1.25.40.10:FF:001026', NULL, NULL, 'CTR9 homolog, Paf1/RNA polymerase II complex component', NULL, NULL, NULL, NULL, NULL, 4),
(165115, NULL, 'G3DSA:3.40.50.300:FF:007772', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165116, NULL, 'G3DSA:1.10.10.10:FF:000905', NULL, NULL, 'transcription factor RFX4 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(165117, NULL, 'G3DSA:2.40.40.20:FF:000013', NULL, NULL, 'Dimethyl sulfoxide reductase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(165118, NULL, 'G3DSA:3.90.70.10:FF:000772', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165119, NULL, 'G3DSA:2.60.40.10:FF:002095', NULL, NULL, 'Gamma interferon receptor', NULL, NULL, NULL, NULL, NULL, 4),
(165120, NULL, 'G3DSA:1.20.120.1760:FF:000089', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165121, NULL, 'G3DSA:3.30.200.20:FF:002227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165122, NULL, 'G3DSA:3.100.10.10:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165123, NULL, 'G3DSA:3.30.300.180:FF:000022', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(165124, NULL, 'G3DSA:3.80.10.10:FF:003219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165125, NULL, 'G3DSA:3.40.1190.20:FF:000137', NULL, NULL, 'Hydroxyethylthiazole kinase family-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(165126, NULL, 'G3DSA:4.10.280.110:FF:000009', NULL, NULL, 'U4/U6 small nuclear ribonucleoprotein Prp4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165127, NULL, 'G3DSA:3.40.1390.30:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165128, NULL, 'G3DSA:3.40.1280.10:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165129, NULL, 'G3DSA:1.10.357.20:FF:000006', NULL, NULL, 'Protein CBG01586', NULL, NULL, NULL, NULL, NULL, 4),
(165130, NULL, 'G3DSA:2.60.200.20:FF:000072', NULL, NULL, 'Mutator 2, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(165131, NULL, 'G3DSA:2.30.39.10:FF:000047', NULL, NULL, 'Serpin-1 precursor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165132, NULL, 'G3DSA:3.40.225.10:FF:000014', NULL, NULL, 'Rhamnulose-1-phosphate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(165133, NULL, 'G3DSA:3.50.50.60:FF:001372', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(165134, NULL, 'G3DSA:3.10.100.10:FF:000170', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165135, NULL, 'G3DSA:3.60.130.10:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165136, NULL, 'G3DSA:3.40.1110.10:FF:000096', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(165137, NULL, 'G3DSA:3.30.1330.30:FF:000064', NULL, NULL, 'RNA methyltransferase, TrmH family', NULL, NULL, NULL, NULL, NULL, 4),
(165138, NULL, 'G3DSA:1.20.1250.20:FF:000637', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(165139, NULL, 'G3DSA:2.60.40.1400:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165140, NULL, 'G3DSA:1.10.1200.10:FF:000015', NULL, NULL, 'Putative acyl-activating enzyme 19', NULL, NULL, NULL, NULL, NULL, 4),
(165141, NULL, 'G3DSA:3.10.100.10:FF:000018', NULL, NULL, 'Mannose receptor, C type 2', NULL, NULL, NULL, NULL, NULL, 4),
(165142, NULL, 'G3DSA:3.50.50.60:FF:000832', NULL, NULL, 'Sll0703 protein', NULL, NULL, NULL, NULL, NULL, 4),
(165143, NULL, 'G3DSA:3.80.10.10:FF:000696', NULL, NULL, 'GH23033', NULL, NULL, NULL, NULL, NULL, 4),
(165144, NULL, 'G3DSA:2.60.40.60:FF:000463', NULL, NULL, 'Cadherin 3', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(165145, NULL, 'G3DSA:3.10.580.10:FF:000227', NULL, NULL, 'Chloride channel, voltage-sensitive Kb', NULL, NULL, NULL, NULL, NULL, 4),
(165146, NULL, 'G3DSA:3.60.10.10:FF:000067', NULL, NULL, 'Carbon catabolite repressor protein 4 homolog 4', NULL, NULL, NULL, NULL, NULL, 4),
(165147, NULL, 'G3DSA:1.20.1270.280:FF:000038', NULL, NULL, 'AT13908p', NULL, NULL, NULL, NULL, NULL, 4),
(165148, NULL, 'G3DSA:3.30.40.10:FF:000323', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(165149, NULL, 'G3DSA:3.50.30.10:FF:000007', NULL, NULL, 'Phosphoenolpyruvate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(165150, NULL, 'G3DSA:1.20.80.10:FF:000038', NULL, NULL, 'Myosin 28B1, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(165151, NULL, 'G3DSA:1.20.900.10:FF:000135', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165152, NULL, 'G3DSA:3.20.20.140:FF:000331', NULL, NULL, 'Non-ATP-dependent L-selective hydantoinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165153, NULL, 'G3DSA:3.30.160.60:FF:004461', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165154, NULL, 'G3DSA:3.30.750.44:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165155, NULL, 'G3DSA:1.20.5.4820:FF:000010', NULL, NULL, 'Unconventional myosin-X', NULL, NULL, NULL, NULL, NULL, 4),
(165156, NULL, 'G3DSA:1.50.10.20:FF:000058', NULL, NULL, 'Terpene cyclase/mutase family member', NULL, NULL, NULL, NULL, NULL, 4),
(165157, NULL, 'G3DSA:3.40.50.2000:FF:001109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165158, NULL, 'G3DSA:1.20.1250.10:FF:000016', NULL, NULL, 'Fms-related tyrosine kinase 3 ligand', NULL, NULL, NULL, NULL, NULL, 4),
(165159, NULL, 'G3DSA:2.60.40.10:FF:002679', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165160, NULL, 'G3DSA:3.40.50.300:FF:002253', NULL, NULL, 'U5 small nuclear ribonucleoprotein 200 kDa helicase', NULL, NULL, NULL, NULL, NULL, 4),
(165161, NULL, 'G3DSA:3.30.70.1230:FF:000066', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165162, NULL, 'G3DSA:3.30.160.60:FF:005821', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165163, NULL, 'G3DSA:2.40.70.10:FF:000580', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165164, NULL, 'G3DSA:1.10.10.60:FF:000342', NULL, NULL, 'trihelix transcription factor PTL-like', NULL, NULL, NULL, NULL, NULL, 4),
(165165, NULL, 'G3DSA:1.25.40.550:FF:000003', NULL, NULL, 'AAR2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(165166, NULL, 'G3DSA:1.20.58.1290:FF:000002', NULL, NULL, 'Transcriptional regulator, CarD', NULL, NULL, NULL, NULL, NULL, 4),
(165167, NULL, 'G3DSA:2.130.10.10:FF:000353', NULL, NULL, 'Transcriptional corepressor LEUNIG', NULL, NULL, NULL, NULL, NULL, 4),
(165168, NULL, 'G3DSA:2.60.40.1770:FF:000013', NULL, NULL, 'Si:ch73-40a2.1', NULL, NULL, NULL, NULL, NULL, 4),
(165169, NULL, 'G3DSA:1.20.58.60:FF:000529', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165170, NULL, 'G3DSA:2.10.25.10:FF:000836', NULL, NULL, 'Wall-associated receptor kinase-like 14 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(165171, NULL, 'G3DSA:3.90.1290.10:FF:000057', NULL, NULL, 'Microtubule-actin crosslinking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(165172, NULL, 'G3DSA:2.130.10.10:FF:004164', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165173, NULL, 'G3DSA:3.40.50.300:FF:005355', NULL, NULL, 'Preprotein translocase SecA subunit', NULL, NULL, NULL, NULL, NULL, 4),
(165174, NULL, 'G3DSA:1.25.40.10:FF:000981', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(165175, NULL, 'G3DSA:3.30.160.60:FF:003404', NULL, NULL, 'Palmate-like pentafoliata 1 transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(165176, NULL, 'G3DSA:3.40.50.300:FF:002949', NULL, NULL, 'Putative dynein heavy chain, cytosolic', NULL, NULL, NULL, NULL, NULL, 4),
(165177, NULL, 'G3DSA:3.20.20.190:FF:000144', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(165178, NULL, 'G3DSA:1.10.510.10:FF:003283', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165179, NULL, 'G3DSA:3.60.60.10:FF:000014', NULL, NULL, 'Choloylglycine hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(165180, NULL, 'G3DSA:3.30.2160.10:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165181, NULL, 'G3DSA:1.10.10.60:FF:000263', NULL, NULL, 'Putative homeodomain-like transcription factor superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(165182, NULL, 'G3DSA:1.10.506.10:FF:000075', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165183, NULL, 'G3DSA:2.30.29.30:FF:001053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165184, NULL, 'G3DSA:3.40.50.1820:FF:000751', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(165185, NULL, 'G3DSA:3.90.190.10:FF:000415', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165186, NULL, 'G3DSA:3.30.40.10:FF:000458', NULL, NULL, 'Unkempt, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(165187, NULL, 'G3DSA:1.20.1070.10:FF:000766', NULL, NULL, 'Secretin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(165188, NULL, 'G3DSA:3.40.50.2300:FF:000300', NULL, NULL, 'Vomeronasal 2, receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(165189, NULL, 'G3DSA:1.10.238.10:FF:000373', NULL, NULL, '45 kDa calcium-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(165190, NULL, 'G3DSA:3.90.280.10:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165191, NULL, 'G3DSA:1.10.30.10:FF:000064', NULL, NULL, 'Mutant transcription factor sox9a', NULL, NULL, NULL, NULL, NULL, 4),
(165192, NULL, 'G3DSA:3.40.50.10810:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165193, NULL, 'G3DSA:1.10.405.20:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165194, NULL, 'G3DSA:2.30.30.30:FF:000050', NULL, NULL, '60S ribosomal protein L14', NULL, NULL, NULL, NULL, NULL, 4),
(165195, NULL, 'G3DSA:3.30.420.10:FF:000695', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165196, NULL, 'G3DSA:1.10.150.50:FF:000086', NULL, NULL, 'Alpha-globin transcription factor CP2', NULL, NULL, NULL, NULL, NULL, 4),
(165197, NULL, 'G3DSA:2.60.40.10:FF:005664', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165198, NULL, 'G3DSA:2.10.25.10:FF:000595', NULL, NULL, 'von Willebrand factor D and EGF domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(165199, NULL, 'G3DSA:3.40.50.300:FF:006991', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(165200, NULL, 'G3DSA:1.10.287.460:FF:000003', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(165201, NULL, 'G3DSA:3.90.980.20:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165202, NULL, 'G3DSA:3.90.70.10:FF:000452', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 13', NULL, NULL, NULL, NULL, NULL, 4),
(165203, NULL, 'G3DSA:1.10.620.20:FF:000012', NULL, NULL, 'R2-like ligand binding oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(165204, NULL, 'G3DSA:1.20.5.440:FF:000002', NULL, NULL, 'ATP synthase subunit delta, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(165205, NULL, 'G3DSA:3.40.50.720:FF:001822', NULL, NULL, 'Ubiquitin-activating enzyme E1 1', NULL, NULL, NULL, NULL, NULL, 4),
(165206, NULL, 'G3DSA:2.60.40.10:FF:004236', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165207, NULL, 'G3DSA:3.80.10.10:FF:000196', NULL, NULL, 'Si:dkey-16p6.1', NULL, NULL, NULL, NULL, NULL, 4),
(165208, NULL, 'G3DSA:1.25.40.730:FF:000001', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(165209, NULL, 'G3DSA:3.40.50.10470:FF:000046', NULL, NULL, 'Translation initiation factor eIF-2B alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(165210, NULL, 'G3DSA:1.50.40.10:FF:000349', NULL, NULL, 'Mitochondrial carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165211, NULL, 'G3DSA:2.130.10.10:FF:003843', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(165212, NULL, 'G3DSA:3.60.21.10:FF:000160', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(165213, NULL, 'G3DSA:3.30.70.1730:FF:000007', NULL, NULL, '50S ribosomal protein L10', NULL, NULL, NULL, NULL, NULL, 4),
(165214, NULL, 'G3DSA:1.25.40.10:FF:003443', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(165215, NULL, 'G3DSA:1.10.10.1540:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165216, NULL, 'G3DSA:2.40.50.140:FF:000775', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165217, NULL, 'G3DSA:3.60.40.10:FF:000136', NULL, NULL, 'Probable two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(165218, NULL, 'G3DSA:3.30.160.60:FF:004309', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165219, NULL, 'G3DSA:2.120.10.30:FF:000241', NULL, NULL, 'Low-density lipoprotein receptor-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(165220, NULL, 'G3DSA:3.30.200.20:FF:001530', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(165221, NULL, 'G3DSA:1.10.287.70:FF:000728', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165222, NULL, 'G3DSA:3.30.200.20:FF:001210', NULL, NULL, 'Calcium-dependent protein kinase 31', NULL, NULL, NULL, NULL, NULL, 4),
(165223, NULL, 'G3DSA:3.40.50.300:FF:002606', NULL, NULL, 'Dephospho-CoA kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(165224, NULL, 'G3DSA:1.50.40.10:FF:000006', NULL, NULL, 'brain mitochondrial carrier protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(165225, NULL, 'G3DSA:2.40.50.140:FF:001051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165226, NULL, 'G3DSA:2.40.50.690:FF:000024', NULL, NULL, 'Exosome complex exonuclease RRP44, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165227, NULL, 'G3DSA:3.40.630.10:FF:000416', NULL, NULL, 'M28 family peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(165228, NULL, 'G3DSA:3.10.20.250:FF:000001', NULL, NULL, 'YML108W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(165229, NULL, 'G3DSA:3.40.50.10190:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165230, NULL, 'G3DSA:1.10.287.70:FF:000408', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165231, NULL, 'G3DSA:2.60.40.10:FF:000021', NULL, NULL, 'transcription factor COE1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(165232, NULL, 'G3DSA:1.10.10.10:FF:000973', NULL, NULL, 'E74 like ETS transcription factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(165233, NULL, 'G3DSA:3.50.50.60:FF:001288', NULL, NULL, 'Rab GDP dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(165234, NULL, 'G3DSA:3.30.1490.300:FF:000002', NULL, NULL, 'Type IV pilus assembly protein PilM', NULL, NULL, NULL, NULL, NULL, 4),
(165235, NULL, 'G3DSA:1.10.287.30:FF:000003', NULL, NULL, 'Regulatory protein E2', NULL, NULL, NULL, NULL, NULL, 4),
(165236, NULL, 'G3DSA:3.30.40.10:FF:000115', NULL, NULL, 'probable E3 ubiquitin-protein ligase LOG2', NULL, NULL, NULL, NULL, NULL, 4),
(165237, NULL, 'G3DSA:3.40.50.880:FF:000105', NULL, NULL, 'CTP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(165238, NULL, 'G3DSA:3.30.160.60:FF:000358', NULL, NULL, 'zinc finger protein 24', NULL, NULL, NULL, NULL, NULL, 4),
(165239, NULL, 'G3DSA:1.10.1520.10:FF:000062', NULL, NULL, 'Ribonuclease III domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(165240, NULL, 'G3DSA:2.70.98.10:FF:000069', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(165241, NULL, 'G3DSA:3.10.20.90:FF:000543', NULL, NULL, 'OTU-like cysteine protease', NULL, NULL, NULL, NULL, NULL, 4),
(165242, NULL, 'G3DSA:2.60.40.3510:FF:000001', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(165243, NULL, 'G3DSA:3.80.10.10:FF:001134', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(165244, NULL, 'G3DSA:1.10.150.240:FF:000005', NULL, NULL, 'HAD hydrolase family', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(165245, NULL, 'G3DSA:1.25.10.10:FF:002710', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165246, NULL, 'G3DSA:3.40.50.1000:FF:000101', NULL, NULL, '2,3-diketo-5-methylthio-1-phosphopentane phosphatase protein', NULL, NULL, NULL, NULL, NULL, 4),
(165247, NULL, 'G3DSA:1.10.287.70:FF:000167', NULL, NULL, 'Two-pore potassium channel 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(165248, NULL, 'G3DSA:3.40.50.300:FF:002045', NULL, NULL, 'Type I restriction-modification system endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(165249, NULL, 'G3DSA:1.10.8.10:FF:000253', NULL, NULL, 'baculoviral IAP repeat-containing protein 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(165250, NULL, 'G3DSA:3.40.630.30:FF:000574', NULL, NULL, 'Acyl-homoserine-lactone synthase', NULL, NULL, NULL, NULL, NULL, 4),
(165251, NULL, 'G3DSA:2.20.70.10:FF:000030', NULL, NULL, 'Salvador family WW domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(165252, NULL, 'G3DSA:3.30.530.20:FF:000173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165253, NULL, 'G3DSA:3.30.70.330:FF:002526', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165254, NULL, 'G3DSA:3.40.1380.20:FF:000028', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(165255, NULL, 'G3DSA:3.30.450.20:FF:000172', NULL, NULL, 'Cyclic di-GMP phosphodiesterase Gmr', NULL, NULL, NULL, NULL, NULL, 4),
(165256, NULL, 'G3DSA:3.30.505.10:FF:000105', NULL, NULL, 'Transcription elongation factor SPT6', NULL, NULL, NULL, NULL, NULL, 4),
(165257, NULL, 'G3DSA:2.60.200.20:FF:000252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165258, NULL, 'G3DSA:3.30.1330.20:FF:000027', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(165259, NULL, 'G3DSA:2.60.40.150:FF:000614', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165260, NULL, 'G3DSA:1.10.510.10:FF:001597', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165261, NULL, 'G3DSA:3.90.1150.10:FF:000339', NULL, NULL, 'Pyridoxal phosphate-dependent aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(165262, NULL, 'G3DSA:3.40.50.2000:FF:000412', NULL, NULL, 'Flavonoid glucosyl-transferase-like', NULL, NULL, NULL, NULL, NULL, 4),
(165263, NULL, 'G3DSA:1.25.40.20:FF:001647', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165264, NULL, 'G3DSA:3.40.50.970:FF:000008', NULL, NULL, '1-deoxy-D-xylulose-5-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(165265, NULL, 'G3DSA:2.60.120.1440:FF:000010', NULL, NULL, 'FecR family protein', NULL, NULL, NULL, NULL, NULL, 4),
(165266, NULL, 'G3DSA:1.20.58.60:FF:000209', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(165267, NULL, 'G3DSA:3.90.550.50:FF:000113', NULL, NULL, 'Fringe', NULL, NULL, NULL, NULL, NULL, 4),
(165268, NULL, 'G3DSA:2.60.40.1110:FF:000006', NULL, NULL, 'Formin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(165269, NULL, 'G3DSA:3.40.1710.10:FF:000006', NULL, NULL, 'Probable conserved transmembrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(165270, NULL, 'G3DSA:3.40.50.10190:FF:000232', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(165271, NULL, 'G3DSA:1.10.510.10:FF:001815', NULL, NULL, 'Casein kinase 1-like protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(165272, NULL, 'G3DSA:2.60.120.10:FF:000326', NULL, NULL, 'Cyclic nucleotide-binding domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165273, NULL, 'G3DSA:2.30.30.40:FF:000671', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165274, NULL, 'G3DSA:1.20.870.10:FF:000002', NULL, NULL, 'son of sevenless homolog 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(165275, NULL, 'G3DSA:3.10.105.10:FF:000102', NULL, NULL, 'Peptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(165276, NULL, 'G3DSA:1.25.40.70:FF:000009', NULL, NULL, 'Phosphatidylinositol 3-kinase VPS34', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(165277, NULL, 'G3DSA:3.30.830.10:FF:000153', NULL, NULL, 'Metalloenzyme, LuxS/M16 peptidase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(165278, NULL, 'G3DSA:3.30.460.10:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165279, NULL, 'G3DSA:3.30.200.20:FF:000693', NULL, NULL, 'TKL protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(165280, NULL, 'G3DSA:3.40.30.10:FF:000148', NULL, NULL, 'Elongation factor 1B gamma', NULL, NULL, NULL, NULL, NULL, 4),
(165281, NULL, 'G3DSA:2.130.10.10:FF:003500', NULL, NULL, 'Plexin A3', NULL, NULL, NULL, NULL, NULL, 4),
(165282, NULL, 'G3DSA:1.25.40.10:FF:002779', NULL, NULL, 'Putative chaperone protein DNAj', NULL, NULL, NULL, NULL, NULL, 4),
(165283, NULL, 'G3DSA:3.80.10.10:FF:003287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165284, NULL, 'G3DSA:3.10.20.90:FF:000723', NULL, NULL, '2'',5''-oligo adenylate synthetase A', NULL, NULL, NULL, NULL, NULL, 4),
(165285, NULL, 'G3DSA:3.40.50.2300:FF:000564', NULL, NULL, 'Vomeronasal 2 receptor, 53', NULL, NULL, NULL, NULL, NULL, 4),
(165286, NULL, 'G3DSA:3.50.50.100:FF:000015', NULL, NULL, 'Amid-like NADH oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165287, NULL, 'G3DSA:1.20.120.350:FF:000159', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165288, NULL, 'G3DSA:3.40.50.10810:FF:000019', NULL, NULL, 'DNA excision repair protein ERCC-6-like 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(165289, NULL, 'G3DSA:1.20.1290.10:FF:000013', NULL, NULL, 'Sestrin-1', NULL, NULL, NULL, NULL, NULL, 4),
(165290, NULL, 'G3DSA:3.80.10.10:FF:000937', NULL, NULL, 'Scribbled planar cell polarity protein', NULL, NULL, NULL, NULL, NULL, 4),
(165291, NULL, 'G3DSA:3.90.640.90:FF:000025', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165292, NULL, 'G3DSA:3.40.50.720:FF:000462', NULL, NULL, 'Glyoxylate reductase (NADP+)', NULL, NULL, NULL, NULL, NULL, 4),
(165293, NULL, 'G3DSA:1.10.150.650:FF:000010', NULL, NULL, 'Metal-dependent phosphoesterase, PHP family protein', NULL, NULL, NULL, NULL, NULL, 4),
(165294, NULL, 'G3DSA:3.40.50.300:FF:005743', NULL, NULL, 'DNA double-strand break repair Rad50 ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(165295, NULL, 'G3DSA:3.90.110.10:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165296, NULL, 'G3DSA:3.40.50.300:FF:001589', NULL, NULL, 'ras-related protein Rab-34 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(165297, NULL, 'G3DSA:1.25.40.10:FF:003055', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(165298, NULL, 'G3DSA:3.40.50.720:FF:002491', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165299, NULL, 'G3DSA:3.40.50.10420:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165300, NULL, 'G3DSA:3.40.250.10:FF:000078', NULL, NULL, 'Related to 3-mercaptopyruvate sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(165301, NULL, 'G3DSA:3.40.50.150:FF:000206', NULL, NULL, 'O-methyltransferase ZRP4', NULL, NULL, NULL, NULL, NULL, 4),
(165302, NULL, 'G3DSA:1.25.40.20:FF:000366', NULL, NULL, 'Ankyrin repeat and SOCS box protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(165303, NULL, 'G3DSA:3.30.710.10:FF:000234', NULL, NULL, 'GD15448', NULL, NULL, NULL, NULL, NULL, 4),
(165304, NULL, 'G3DSA:3.30.160.60:FF:005742', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165305, NULL, 'G3DSA:3.80.10.10:FF:001213', NULL, NULL, 'Si:ch211-149a19.3', NULL, NULL, NULL, NULL, NULL, 4),
(165306, NULL, 'G3DSA:3.40.1110.10:FF:000028', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(165307, NULL, 'G3DSA:3.30.1120.10:FF:000048', NULL, NULL, 'Galactosamine (N-acetyl)-6-sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(165308, NULL, 'G3DSA:2.120.10.80:FF:000407', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165309, NULL, 'G3DSA:3.10.440.10:FF:000009', NULL, NULL, 'Os08g0505300 protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(165310, NULL, 'G3DSA:3.10.20.710:FF:000004', NULL, NULL, 'SATB homeobox 1', NULL, NULL, NULL, NULL, NULL, 4),
(165311, NULL, 'G3DSA:1.10.1470.10:FF:000001', NULL, NULL, 'CsbD family protein', NULL, NULL, NULL, NULL, NULL, 4),
(165312, NULL, 'G3DSA:2.60.40.420:FF:000094', NULL, NULL, 'Hephaestin', NULL, NULL, NULL, NULL, NULL, 4),
(165313, NULL, 'G3DSA:3.20.20.70:FF:000576', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165314, NULL, 'G3DSA:1.10.150.670:FF:000016', NULL, NULL, 'YALI0E33715p', NULL, NULL, NULL, NULL, NULL, 4),
(165315, NULL, 'G3DSA:2.130.10.10:FF:000274', NULL, NULL, 'Chromatin assembly factor 1 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(165316, NULL, 'G3DSA:3.30.9.10:FF:000262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165317, NULL, 'G3DSA:3.60.21.10:FF:000008', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(165318, NULL, 'G3DSA:3.30.70.340:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165319, NULL, 'G3DSA:3.30.420.40:FF:000979', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165320, NULL, 'G3DSA:1.25.40.10:FF:003578', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165321, NULL, 'G3DSA:2.40.10.10:FF:000363', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165322, NULL, 'G3DSA:3.40.30.10:FF:000709', NULL, NULL, 'Protein disulfide isomerase 3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165323, NULL, 'G3DSA:1.10.472.130:FF:000040', NULL, NULL, 'Dynein, axonemal, heavy chain 12', NULL, NULL, NULL, NULL, NULL, 4),
(165324, NULL, 'G3DSA:3.10.20.30:FF:000048', NULL, NULL, 'BnaA01g28110D protein', NULL, NULL, NULL, NULL, NULL, 4),
(165325, NULL, 'G3DSA:3.30.160.60:FF:005181', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165326, NULL, 'G3DSA:1.10.1620.20:FF:000011', NULL, NULL, 'ATP synthase subunit epsilon, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(165327, NULL, 'G3DSA:3.40.50.1820:FF:000190', NULL, NULL, 'Prolyl carboxypeptidase like protein', NULL, NULL, NULL, NULL, NULL, 4),
(165328, NULL, 'G3DSA:3.10.20.10:FF:000042', NULL, NULL, 'Cell death-inducing DFFA-like effector b', NULL, NULL, NULL, NULL, NULL, 4),
(165329, NULL, 'G3DSA:3.30.40.10:FF:002291', NULL, NULL, 'Breast cancer type 1 susceptibility protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(165330, NULL, 'G3DSA:3.40.20.10:FF:000063', NULL, NULL, 'YDR063W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(165331, NULL, 'G3DSA:3.40.50.300:FF:000179', NULL, NULL, 'ABC transporter G family member 34', NULL, NULL, NULL, NULL, NULL, 4),
(165332, NULL, 'G3DSA:2.120.10.30:FF:000421', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165333, NULL, 'G3DSA:1.25.40.10:FF:004016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165334, NULL, 'G3DSA:3.30.160.60:FF:000178', NULL, NULL, 'Zinc finger protein 14 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(165335, NULL, 'G3DSA:1.20.120.1810:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165336, NULL, 'G3DSA:1.10.472.10:FF:000304', NULL, NULL, 'Cyclin 9', NULL, NULL, NULL, NULL, NULL, 4),
(165337, NULL, 'G3DSA:1.20.1600.10:FF:000049', NULL, NULL, 'Putative outer membrane efflux protein', NULL, NULL, NULL, NULL, NULL, 4),
(165338, NULL, 'G3DSA:3.40.50.11530:FF:000016', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165339, NULL, 'G3DSA:3.40.50.720:FF:002339', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165340, NULL, 'G3DSA:3.40.50.300:FF:004782', NULL, NULL, 'ADP-ribosylation factor-related', NULL, NULL, NULL, NULL, NULL, 4),
(165341, NULL, 'G3DSA:3.30.40.10:FF:001751', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165342, NULL, 'G3DSA:3.40.930.10:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165343, NULL, 'G3DSA:2.130.10.10:FF:002483', NULL, NULL, 'Centriole proteome protein', NULL, NULL, NULL, NULL, NULL, 4),
(165344, NULL, 'G3DSA:2.60.40.10:FF:001898', NULL, NULL, 'Twitchin', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(165345, NULL, 'G3DSA:3.90.550.10:FF:000157', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(165346, NULL, 'G3DSA:2.30.30.490:FF:000018', NULL, NULL, 'Lid2 complex component snt2', NULL, NULL, NULL, NULL, NULL, 4),
(165347, NULL, 'G3DSA:1.25.40.20:FF:001467', NULL, NULL, 'Ankyrin repeat protein C9L', NULL, NULL, NULL, NULL, NULL, 4),
(165348, NULL, 'G3DSA:2.60.40.10:FF:002174', NULL, NULL, 'Signal-regulatory protein beta 3', NULL, NULL, NULL, NULL, NULL, 4),
(165349, NULL, 'G3DSA:3.60.10.10:FF:000308', NULL, NULL, 'DNA-(apurinic or apyrimidinic site) lyase', NULL, NULL, NULL, NULL, NULL, 4),
(165350, NULL, 'G3DSA:3.40.630.30:FF:000231', NULL, NULL, 'uncharacterized protein LOC106768637', NULL, NULL, NULL, NULL, NULL, 4),
(165351, NULL, 'G3DSA:3.90.1480.20:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165352, NULL, 'G3DSA:1.20.1280.50:FF:000069', NULL, NULL, 'F-box/SPRY domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(165353, NULL, 'G3DSA:1.25.10.10:FF:003407', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165354, NULL, 'G3DSA:2.60.40.10:FF:005085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165355, NULL, 'G3DSA:3.40.50.300:FF:008093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165356, NULL, 'G3DSA:2.60.40.10:FF:002999', NULL, NULL, 'Chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(165357, NULL, 'G3DSA:3.40.47.10:FF:000271', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165358, NULL, 'G3DSA:1.25.40.10:FF:000705', NULL, NULL, 'Related to PEX5-peroxisomal targeting signal receptor', NULL, NULL, NULL, NULL, NULL, 4),
(165359, NULL, 'G3DSA:1.25.40.20:FF:000242', NULL, NULL, 'Ankyrin repeat, SAM and basic leucine zipper domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(165360, NULL, 'G3DSA:1.20.1420.30:FF:000002', NULL, NULL, 'Sodium/potassium/calcium exchanger 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(165361, NULL, 'G3DSA:1.10.630.10:FF:000588', NULL, NULL, 'Cytochrome P450, family 4, subfamily a, polypeptide 31', NULL, NULL, NULL, NULL, NULL, 4),
(165362, NULL, 'G3DSA:3.10.20.90:FF:000200', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(165363, NULL, 'G3DSA:1.10.287.280:FF:000005', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(165364, NULL, 'G3DSA:2.60.20.10:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165365, NULL, 'G3DSA:1.10.510.10:FF:002614', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165366, NULL, 'G3DSA:1.10.510.10:FF:004300', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165367, NULL, 'G3DSA:3.80.10.10:FF:002770', NULL, NULL, 'Probable disease resistance protein At5g47260', NULL, NULL, NULL, NULL, NULL, 4),
(165368, NULL, 'G3DSA:1.20.272.10:FF:000006', NULL, NULL, 'Replication factor C subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(165369, NULL, 'G3DSA:3.40.1110.10:FF:000360', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165370, NULL, 'G3DSA:1.10.510.10:FF:001254', NULL, NULL, 'Serine/threonine-protein kinase ATG1', NULL, NULL, NULL, NULL, NULL, 4),
(165371, NULL, 'G3DSA:3.60.150.10:FF:000004', NULL, NULL, 'Chorismate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(165372, NULL, 'G3DSA:1.20.142.10:FF:000002', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(165373, NULL, 'G3DSA:1.20.120.1380:FF:000003', NULL, NULL, 'Flagellar biosynthesis regulator FlhF', NULL, NULL, NULL, NULL, NULL, 4),
(165374, NULL, 'G3DSA:2.60.40.10:FF:001774', NULL, NULL, 'Uncharacterized LOC100216153', NULL, NULL, NULL, NULL, NULL, 4),
(165375, NULL, 'G3DSA:2.30.29.30:FF:000597', NULL, NULL, 'Protein CBG02248', NULL, NULL, NULL, NULL, NULL, 4),
(165376, NULL, 'G3DSA:2.40.160.20:FF:000027', NULL, NULL, 'Omp-1N', NULL, NULL, NULL, NULL, NULL, 4),
(165377, NULL, 'G3DSA:3.30.160.60:FF:002387', NULL, NULL, 'Zinc finger protein 346', NULL, NULL, NULL, NULL, NULL, 4),
(165378, NULL, 'G3DSA:1.10.10.820:FF:000026', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(165379, NULL, 'G3DSA:3.40.850.10:FF:000556', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165380, NULL, 'G3DSA:1.10.132.110:FF:000003', NULL, NULL, 'Serum amyloid A protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165381, NULL, 'G3DSA:4.10.860.130:FF:000001', NULL, NULL, '40S ribosomal protein S13', NULL, NULL, NULL, NULL, NULL, 4),
(165382, NULL, 'G3DSA:1.10.1280.10:FF:000026', NULL, NULL, 'Tyrosinase', NULL, NULL, NULL, NULL, NULL, 4),
(165383, NULL, 'G3DSA:3.90.1600.10:FF:000037', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(165384, NULL, 'G3DSA:3.40.50.1820:FF:000875', NULL, NULL, 'Os07g0575800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(165385, NULL, 'G3DSA:3.30.70.270:FF:000226', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165386, NULL, 'G3DSA:2.130.10.10:FF:003764', NULL, NULL, 'Ribosome biogenesis protein WDR12 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(165387, NULL, 'G3DSA:1.10.510.10:FF:000473', NULL, NULL, 'Putative wall-associated kinase', NULL, NULL, NULL, NULL, NULL, 4),
(165388, NULL, 'G3DSA:3.80.10.10:FF:003787', NULL, NULL, 'RNI-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(165389, NULL, 'G3DSA:3.60.40.10:FF:000075', NULL, NULL, 'Protein phosphatase 2C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165390, NULL, 'G3DSA:2.10.220.10:FF:000008', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(165391, NULL, 'G3DSA:1.10.8.480:FF:000016', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(165392, NULL, 'G3DSA:2.20.110.10:FF:000065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165393, NULL, 'G3DSA:2.30.30.210:FF:000013', NULL, NULL, 'Ribonuclease P protein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(165394, NULL, 'G3DSA:3.80.10.10:FF:003843', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(165395, NULL, 'G3DSA:3.60.40.10:FF:000131', NULL, NULL, 'Orphans transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(165396, NULL, 'G3DSA:3.80.10.10:FF:004411', NULL, NULL, 'F-box family protein', NULL, NULL, NULL, NULL, NULL, 4),
(165397, NULL, 'G3DSA:1.25.40.20:FF:000922', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165398, NULL, 'G3DSA:2.40.50.140:FF:001264', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165399, NULL, 'G3DSA:3.30.1540.20:FF:000009', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(165400, NULL, 'G3DSA:2.40.50.690:FF:000001', NULL, NULL, 'Cell wall biogenesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(165401, NULL, 'G3DSA:1.20.1250.10:FF:000128', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165402, NULL, 'G3DSA:3.30.70.1230:FF:000127', NULL, NULL, 'Chlamyopsin-5 sensory rhodopsin', NULL, NULL, NULL, NULL, NULL, 4),
(165403, NULL, 'G3DSA:2.130.10.10:FF:000061', NULL, NULL, 'Ribosome biogenesis protein BOP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(165404, NULL, 'G3DSA:2.60.40.10:FF:005933', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165405, NULL, 'G3DSA:3.10.440.10:FF:000004', NULL, NULL, '50S ribosomal protein L31e', NULL, NULL, NULL, NULL, NULL, 4),
(165406, NULL, 'G3DSA:3.30.40.10:FF:000379', NULL, NULL, 'transcription intermediary factor 1-alpha isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(165407, NULL, 'G3DSA:3.80.10.10:FF:004355', NULL, NULL, 'ADR009Wp', NULL, NULL, NULL, NULL, NULL, 4),
(165408, NULL, 'G3DSA:3.80.10.10:FF:004299', NULL, NULL, 'Si:dkey-126g1.7', NULL, NULL, NULL, NULL, NULL, 4),
(165409, NULL, 'G3DSA:3.40.50.740:FF:000024', NULL, NULL, 'Probable oxidoreductase YoaE', NULL, NULL, NULL, NULL, NULL, 4),
(165410, NULL, 'G3DSA:2.60.40.10:FF:005877', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165411, NULL, 'G3DSA:3.90.360.10:FF:000002', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(165412, NULL, 'G3DSA:1.10.10.10:FF:001698', NULL, NULL, 'Cell division control protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(165413, NULL, 'G3DSA:2.30.30.40:FF:000227', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(165414, NULL, 'G3DSA:2.30.42.10:FF:000279', NULL, NULL, 'Membrane-associated guanylate kinase, WW and PDZ domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(165415, NULL, 'G3DSA:3.40.50.970:FF:000183', NULL, NULL, 'Transketolase-1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(165416, NULL, 'G3DSA:1.10.238.10:FF:000452', NULL, NULL, 'Calcium-dependent protein kinase 7', NULL, NULL, NULL, NULL, NULL, 4),
(165417, NULL, 'G3DSA:3.30.420.10:FF:000291', NULL, NULL, 'Protein CBG02435', NULL, NULL, NULL, NULL, NULL, 4),
(165418, NULL, 'G3DSA:2.130.10.10:FF:003820', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165419, NULL, 'G3DSA:1.25.40.10:FF:004067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165420, NULL, 'G3DSA:3.90.1140.10:FF:000013', NULL, NULL, 'U6 snRNA phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(165421, NULL, 'G3DSA:3.40.50.300:FF:004731', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165422, NULL, 'G3DSA:2.170.40.20:FF:000007', NULL, NULL, 'Truncated surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(165423, NULL, 'G3DSA:3.40.50.1010:FF:000222', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165424, NULL, 'G3DSA:3.40.47.10:FF:000220', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165425, NULL, 'G3DSA:3.40.50.300:FF:005243', NULL, NULL, 'RNA ligase/AAA domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165426, NULL, 'G3DSA:1.25.40.10:FF:003555', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165427, NULL, 'G3DSA:2.130.10.10:FF:004332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165428, NULL, 'G3DSA:3.40.50.2000:FF:000468', NULL, NULL, 'Alpha 1 3-mannosyltransferase alg2 putative', NULL, NULL, NULL, NULL, NULL, 4),
(165429, NULL, 'G3DSA:3.10.110.10:FF:000232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165430, NULL, 'G3DSA:2.40.33.10:FF:000011', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(165431, NULL, 'G3DSA:2.10.220.10:FF:000059', NULL, NULL, 'Fraser extracellular matrix complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(165432, NULL, 'G3DSA:3.30.160.60:FF:003909', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165433, NULL, 'G3DSA:2.60.40.2910:FF:000001', NULL, NULL, 'Major fimbrial subunit of aggregative adherence fimbria II', NULL, NULL, NULL, NULL, NULL, 4),
(165434, NULL, 'G3DSA:3.30.505.10:FF:000044', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(165435, NULL, 'G3DSA:1.25.40.10:FF:003504', NULL, NULL, 'AGAP000894-PA', NULL, NULL, NULL, NULL, NULL, 4),
(165436, NULL, 'G3DSA:3.30.450.40:FF:000003', NULL, NULL, 'GTP-sensing transcriptional pleiotropic repressor CodY', NULL, NULL, NULL, NULL, NULL, 4),
(165437, NULL, 'G3DSA:2.60.40.10:FF:004416', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165438, NULL, 'G3DSA:3.40.50.300:FF:005294', NULL, NULL, 'YALI0E06171p', NULL, NULL, NULL, NULL, NULL, 4),
(165439, NULL, 'G3DSA:2.130.10.10:FF:004225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165440, NULL, 'G3DSA:3.40.50.300:FF:001932', NULL, NULL, 'Translesion DNA synthesis-associated protein ImuA', NULL, NULL, NULL, NULL, NULL, 4),
(165441, NULL, 'G3DSA:3.40.50.300:FF:001876', NULL, NULL, 'Type IV secretion system protein VirB4', NULL, NULL, NULL, NULL, NULL, 4),
(165442, NULL, 'G3DSA:1.10.630.10:FF:000532', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165443, NULL, 'G3DSA:2.60.120.10:FF:000265', NULL, NULL, 'Phosphomannose isomerase type I, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165444, NULL, 'G3DSA:2.40.160.90:FF:000003', NULL, NULL, 'Lipoprotein binding FH', NULL, NULL, NULL, NULL, NULL, 4),
(165445, NULL, 'G3DSA:1.20.1250.20:FF:000457', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(165446, NULL, 'G3DSA:1.25.40.10:FF:004808', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(165447, NULL, 'G3DSA:1.10.10.160:FF:000019', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(165448, NULL, 'G3DSA:2.30.30.380:FF:000036', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(165449, NULL, 'G3DSA:3.10.20.90:FF:000700', NULL, NULL, 'FERM domain-containing protein A', NULL, NULL, NULL, NULL, NULL, 4),
(165450, NULL, 'G3DSA:3.40.50.1820:FF:000982', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(165451, NULL, 'G3DSA:3.30.230.10:FF:000309', NULL, NULL, 'Galactokinase', NULL, NULL, NULL, NULL, NULL, 4),
(165452, NULL, 'G3DSA:3.30.70.270:FF:000333', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165453, NULL, 'G3DSA:3.30.160.60:FF:006041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165454, NULL, 'G3DSA:2.10.25.10:FF:000656', NULL, NULL, 'Shifted, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(165455, NULL, 'G3DSA:3.30.70.270:FF:000277', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165456, NULL, 'G3DSA:1.20.1070.10:FF:000997', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165457, NULL, 'G3DSA:2.170.130.20:FF:000006', NULL, NULL, 'Multidomain scavenger receptor', NULL, NULL, NULL, NULL, NULL, 4),
(165458, NULL, 'G3DSA:1.25.40.500:FF:000005', NULL, NULL, 'GM23579', NULL, NULL, NULL, NULL, NULL, 4),
(165459, NULL, 'G3DSA:2.130.10.10:FF:000010', NULL, NULL, 'Coatomer subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(165460, NULL, 'G3DSA:3.10.360.10:FF:000003', NULL, NULL, 'Gallin protein', NULL, NULL, NULL, NULL, NULL, 4),
(165461, NULL, 'G3DSA:1.10.630.10:FF:000476', NULL, NULL, 'Fatty-acid-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(165462, NULL, 'G3DSA:3.40.50.150:FF:001050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165463, NULL, 'G3DSA:3.40.250.10:FF:000027', NULL, NULL, 'Dual specificity phosphatase 4', NULL, NULL, NULL, NULL, NULL, 4),
(165464, NULL, 'G3DSA:2.170.150.20:FF:000013', NULL, NULL, 'protein cereblon homolog', NULL, NULL, NULL, NULL, NULL, 4),
(165465, NULL, 'G3DSA:3.30.160.20:FF:000037', NULL, NULL, '39S ribosomal protein L44, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(165466, NULL, 'G3DSA:3.30.590.10:FF:000010', NULL, NULL, 'Glutamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(165467, NULL, 'G3DSA:3.40.50.1460:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165468, NULL, 'G3DSA:1.10.10.10:FF:000237', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC6', NULL, NULL, NULL, NULL, NULL, 4),
(165469, NULL, 'G3DSA:3.10.280.10:FF:000002', NULL, NULL, 'Mitochondrial glycoprotein family protein', NULL, NULL, NULL, NULL, NULL, 4),
(165470, NULL, 'G3DSA:3.30.450.60:FF:000009', NULL, NULL, 'AP complex subunit sigma', NULL, NULL, NULL, NULL, NULL, 4),
(165471, NULL, 'G3DSA:3.40.1280.10:FF:000074', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4),
(165472, NULL, 'G3DSA:3.60.10.10:FF:000303', NULL, NULL, 'Endonuclease/exonuclease/phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165473, NULL, 'G3DSA:3.30.70.1230:FF:000178', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165474, NULL, 'G3DSA:1.10.10.140:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165475, NULL, 'G3DSA:1.25.40.10:FF:003611', NULL, NULL, 'Adenylyl cyclase class-3/4/guanylyl cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(165476, NULL, 'G3DSA:3.40.50.10380:FF:000019', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(165477, NULL, 'G3DSA:2.60.40.10:FF:001662', NULL, NULL, 'Sidekick cell adhesion molecule 2b', NULL, NULL, NULL, NULL, NULL, 4),
(165478, NULL, 'G3DSA:3.90.480.10:FF:000005', NULL, NULL, 'Sulfite reductase, assimilatory', NULL, NULL, NULL, NULL, NULL, 4),
(165479, NULL, 'G3DSA:3.40.50.300:FF:005187', NULL, NULL, 'Uncharacterized ABC transporter ATP-binding protein HI_1618', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(165480, NULL, 'G3DSA:1.20.58.70:FF:000089', NULL, NULL, 'Syntaxin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165481, NULL, 'G3DSA:1.10.10.10:FF:001754', NULL, NULL, 'YALI0D14520p', NULL, NULL, NULL, NULL, NULL, 4),
(165482, NULL, 'G3DSA:2.60.120.10:FF:000158', NULL, NULL, 'Cyclic nucleotide-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(165483, NULL, 'G3DSA:3.40.710.10:FF:000125', NULL, NULL, 'Penicillin-binding protein PbpC', NULL, NULL, NULL, NULL, NULL, 4),
(165484, NULL, 'G3DSA:3.40.50.620:FF:000662', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165485, NULL, 'G3DSA:3.30.160.60:FF:004124', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165486, NULL, 'G3DSA:3.30.200.20:FF:001553', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165487, NULL, 'G3DSA:1.20.1250.20:FF:002374', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165488, NULL, 'G3DSA:3.40.50.300:FF:007660', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165489, NULL, 'G3DSA:3.30.200.20:FF:000018', NULL, NULL, 'Casein kinase I isoform gamma-1', NULL, NULL, NULL, NULL, NULL, 4),
(165490, NULL, 'G3DSA:1.20.1270.60:FF:000280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165491, NULL, 'G3DSA:1.25.40.10:FF:001138', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g33350', NULL, NULL, NULL, NULL, NULL, 4),
(165492, NULL, 'G3DSA:2.30.30.140:FF:000200', NULL, NULL, 'RING finger protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(165493, NULL, 'G3DSA:1.20.1110.10:FF:000242', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(165494, NULL, 'G3DSA:1.10.3380.10:FF:000034', NULL, NULL, 'Activating signal cointegrator 1 complex subunit 3-like', NULL, NULL, NULL, NULL, NULL, 4),
(165495, NULL, 'G3DSA:1.25.40.10:FF:004859', NULL, NULL, 'Paf1 complex component', NULL, NULL, NULL, NULL, NULL, 4),
(165496, NULL, 'G3DSA:3.40.50.11540:FF:000002', NULL, NULL, 'Putative oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(165497, NULL, 'G3DSA:3.30.160.60:FF:004068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165498, NULL, 'G3DSA:1.10.285.10:FF:000015', NULL, NULL, 'Glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(165499, NULL, 'G3DSA:1.10.510.10:FF:001889', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(165500, NULL, 'G3DSA:3.60.21.10:FF:000115', NULL, NULL, 'Putative metallophosphoesterase', NULL, NULL, NULL, NULL, NULL, 4),
(165501, NULL, 'G3DSA:2.60.40.1660:FF:000036', NULL, NULL, 'ATPase Na+/K+-transporting subunit beta 3a', NULL, NULL, NULL, NULL, NULL, 4),
(165502, NULL, 'G3DSA:2.60.450.10:FF:000019', NULL, NULL, 'Lipopolysaccharide export system protein LptA', NULL, NULL, NULL, NULL, NULL, 4),
(165503, NULL, 'G3DSA:2.10.25.10:FF:001612', NULL, NULL, 'AGAP007850-PA', NULL, NULL, NULL, NULL, NULL, 4),
(165504, NULL, 'G3DSA:3.90.740.10:FF:000043', NULL, NULL, 'Isoleucine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(165505, NULL, 'G3DSA:1.25.40.20:FF:000074', NULL, NULL, 'Usher syndrome type-1G protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(165506, NULL, 'G3DSA:1.20.58.1610:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165507, NULL, 'G3DSA:3.40.50.1440:FF:000053', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165508, NULL, 'G3DSA:3.30.1370.60:FF:000002', NULL, NULL, 'Malate/L-lactate family dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(165509, NULL, 'G3DSA:3.40.50.720:FF:001322', NULL, NULL, 'PERMeable eggshell', NULL, NULL, NULL, NULL, NULL, 4),
(165510, NULL, 'G3DSA:3.90.660.10:FF:000042', NULL, NULL, 'Putative bifunctional amine oxidase DDB_G0291301', NULL, NULL, NULL, NULL, NULL, 4),
(165511, NULL, 'G3DSA:3.30.160.60:FF:004961', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165512, NULL, 'G3DSA:2.60.40.10:FF:003516', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165513, NULL, 'G3DSA:3.40.50.300:FF:002314', NULL, NULL, 'Iron ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(165514, NULL, 'G3DSA:2.30.30.30:FF:000005', NULL, NULL, '40S ribosomal protein S4', NULL, NULL, NULL, NULL, NULL, 4),
(165515, NULL, 'G3DSA:3.30.160.60:FF:005473', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165516, NULL, 'G3DSA:2.60.40.10:FF:003112', NULL, NULL, 'Fibronectin_type_III_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(165517, NULL, 'G3DSA:2.20.28.230:FF:000007', NULL, NULL, 'Interleukin-2 receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(165518, NULL, 'G3DSA:3.40.1280.30:FF:000029', NULL, NULL, 'Chromosome 15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(165519, NULL, 'G3DSA:3.90.660.10:FF:000047', NULL, NULL, 'Putative polyamine oxidase 5 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(165520, NULL, 'G3DSA:3.40.1280.10:FF:000023', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4),
(165521, NULL, 'G3DSA:1.25.40.10:FF:000649', NULL, NULL, 'mRNA splicing factor (Prp1/Zer1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(165522, NULL, 'G3DSA:3.30.70.80:FF:000031', NULL, NULL, 'Subtilisin-like protease SBT1.1', NULL, NULL, NULL, NULL, NULL, 4),
(165523, NULL, 'G3DSA:3.30.200.20:FF:002042', NULL, NULL, 'AGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(165524, NULL, 'G3DSA:1.10.10.350:FF:000014', NULL, NULL, 'Glutamate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(165525, NULL, 'G3DSA:1.10.3720.10:FF:000134', NULL, NULL, 'Amino acid ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(165526, NULL, 'G3DSA:1.20.1540.10:FF:000050', NULL, NULL, 'Rhomboid-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(165527, NULL, 'G3DSA:3.30.70.330:FF:001666', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165528, NULL, 'G3DSA:3.40.50.620:FF:000550', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165529, NULL, 'G3DSA:3.40.50.300:FF:008172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165530, NULL, 'G3DSA:2.130.10.10:FF:000914', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(165531, NULL, 'G3DSA:3.40.50.720:FF:000698', NULL, NULL, 'Putative oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(165532, NULL, 'G3DSA:3.60.60.10:FF:000019', NULL, NULL, 'LD30995p', NULL, NULL, NULL, NULL, NULL, 4),
(165533, NULL, 'G3DSA:2.60.40.60:FF:000811', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165534, NULL, 'G3DSA:1.10.287.130:FF:000084', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(165535, NULL, 'G3DSA:3.30.1360.80:FF:000002', NULL, NULL, 'S-ribosylhomocysteine lyase', NULL, NULL, NULL, NULL, NULL, 4),
(165536, NULL, 'G3DSA:3.90.280.10:FF:000001', NULL, NULL, 'Terminal flower 1', NULL, NULL, NULL, NULL, NULL, 4),
(165537, NULL, 'G3DSA:1.25.10.10:FF:001081', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(165538, NULL, 'G3DSA:1.20.1070.10:FF:001143', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165539, NULL, 'G3DSA:3.30.1330.90:FF:000003', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(165540, NULL, 'G3DSA:3.30.505.10:FF:000156', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165541, NULL, 'G3DSA:1.10.1370.30:FF:000011', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(165542, NULL, 'G3DSA:2.10.25.10:FF:001112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165543, NULL, 'G3DSA:1.10.287.70:FF:000560', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165544, NULL, 'G3DSA:3.30.1010.10:FF:000034', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(165545, NULL, 'G3DSA:3.90.440.10:FF:000003', NULL, NULL, 'Nitric oxide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(165546, NULL, 'G3DSA:3.30.1460.20:FF:000008', NULL, NULL, 'Arp2/3 complex 34 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(165547, NULL, 'G3DSA:3.80.10.10:FF:000914', NULL, NULL, 'Toll-like receptor 22', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(165548, NULL, 'G3DSA:3.30.470.30:FF:000069', NULL, NULL, 'DNA ligase IV', NULL, NULL, NULL, NULL, NULL, 4),
(165549, NULL, 'G3DSA:3.90.550.50:FF:000034', NULL, NULL, 'Parasite-infected erythrocyte surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(165550, NULL, 'G3DSA:2.60.40.10:FF:004528', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165551, NULL, 'G3DSA:3.40.50.1580:FF:000022', NULL, NULL, 'Uridine phosphorylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(165552, NULL, 'G3DSA:3.30.505.10:FF:000100', NULL, NULL, 'phosphatidylinositol 3-kinase regulatory subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(165553, NULL, 'G3DSA:1.20.5.1430:FF:000010', NULL, NULL, 'Microtubule End Binding Protein', NULL, NULL, NULL, NULL, NULL, 4),
(165554, NULL, 'G3DSA:1.10.3660.10:FF:000016', NULL, NULL, 'Prephenate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(165555, NULL, 'G3DSA:2.10.220.10:FF:000115', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(165556, NULL, 'G3DSA:2.60.120.200:FF:000806', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165557, NULL, 'G3DSA:2.30.130.10:FF:000019', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(165558, NULL, 'G3DSA:2.10.25.10:FF:000712', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165559, NULL, 'G3DSA:3.40.50.10420:FF:000060', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(165560, NULL, 'G3DSA:1.25.10.10:FF:002441', NULL, NULL, 'TELO2-interacting protein 1 homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(165561, NULL, 'G3DSA:1.20.144.10:FF:000052', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(165562, NULL, 'G3DSA:4.10.400.10:FF:000352', NULL, NULL, 'Vitellogenin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(165563, NULL, 'G3DSA:1.10.20.140:FF:000009', NULL, NULL, 'tRNA dimethylallyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(165564, NULL, 'G3DSA:3.30.160.60:FF:003168', NULL, NULL, 'AGAP004651-PA', NULL, NULL, NULL, NULL, NULL, 4),
(165565, NULL, 'G3DSA:1.20.1310.10:FF:000134', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165566, NULL, 'G3DSA:3.30.70.2630:FF:000002', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(165567, NULL, 'G3DSA:2.40.100.10:FF:000021', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(165568, NULL, 'G3DSA:3.40.50.1010:FF:000166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165569, NULL, 'G3DSA:2.130.10.30:FF:000049', NULL, NULL, 'HECT and RLD domain containing E3 ubiquitin protein ligase family member 6', NULL, NULL, NULL, NULL, NULL, 4),
(165570, NULL, 'G3DSA:1.20.1080.10:FF:000031', NULL, NULL, 'Glycerol channel', NULL, NULL, NULL, NULL, NULL, 4),
(165571, NULL, 'G3DSA:3.20.20.70:FF:000008', NULL, NULL, 'Dual-specificity RNA methyltransferase RlmN', NULL, NULL, NULL, NULL, NULL, 4),
(165572, NULL, 'G3DSA:1.20.1280.50:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165573, NULL, 'G3DSA:3.30.300.20:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165574, NULL, 'G3DSA:2.60.40.10:FF:000257', NULL, NULL, 'Dyslexia-associated protein KIAA0319-like', NULL, NULL, NULL, NULL, NULL, 4),
(165575, NULL, 'G3DSA:1.10.8.60:FF:000251', NULL, NULL, 'replication factor C familiy protein', NULL, NULL, NULL, NULL, NULL, 4),
(165576, NULL, 'G3DSA:1.10.8.270:FF:000015', NULL, NULL, 'GTPase activating protein (Gyp2)', NULL, NULL, NULL, NULL, NULL, 4),
(165577, NULL, 'G3DSA:1.10.10.10:FF:000349', NULL, NULL, 'Heat shock transcription factor, Y-linked', NULL, NULL, NULL, NULL, NULL, 4),
(165578, NULL, 'G3DSA:4.10.60.10:FF:000093', NULL, NULL, 'cellular nucleic acid-binding protein-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(165579, NULL, 'G3DSA:2.130.10.10:FF:004276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165580, NULL, 'G3DSA:1.10.565.10:FF:000048', NULL, NULL, 'Nuclear hormone receptor family member nhr-35', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(165581, NULL, 'G3DSA:3.10.250.10:FF:000118', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165582, NULL, 'G3DSA:1.25.40.10:FF:003499', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At1g13800', NULL, NULL, NULL, NULL, NULL, 4),
(165583, NULL, 'G3DSA:1.20.1270.280:FF:000015', NULL, NULL, 'Dynein heavy chain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(165584, NULL, 'G3DSA:3.30.160.60:FF:002600', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(165585, NULL, 'G3DSA:1.25.40.10:FF:004011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165586, NULL, 'G3DSA:2.60.40.10:FF:006041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165587, NULL, 'G3DSA:1.20.58.120:FF:000001', NULL, NULL, 'BAG family molecular chaperone regulator 4', NULL, NULL, NULL, NULL, NULL, 4),
(165588, NULL, 'G3DSA:3.30.70.870:FF:000018', NULL, NULL, 'Translation elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(165589, NULL, 'G3DSA:3.30.70.270:FF:000338', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165590, NULL, 'G3DSA:3.40.30.10:FF:000524', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(165591, NULL, 'G3DSA:3.40.30.10:FF:000468', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(165592, NULL, 'G3DSA:1.10.510.10:FF:000877', NULL, NULL, 'TAO kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(165593, NULL, 'G3DSA:3.30.40.10:FF:002296', NULL, NULL, 'RING finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(165594, NULL, 'G3DSA:3.40.1360.10:FF:000024', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(165595, NULL, 'G3DSA:3.90.740.10:FF:000048', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(165596, NULL, 'G3DSA:3.30.160.60:FF:003112', NULL, NULL, 'Zinc finger imprinted 2', NULL, NULL, NULL, NULL, NULL, 4),
(165597, NULL, 'G3DSA:3.30.420.40:FF:000182', NULL, NULL, 'Plasmid segregation protein ParM', NULL, NULL, NULL, NULL, NULL, 4),
(165598, NULL, 'G3DSA:3.50.70.10:FF:000004', NULL, NULL, 'Altered inheritance of mitochondria protein 18, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(165599, NULL, 'G3DSA:3.10.580.10:FF:000042', NULL, NULL, 'DUF21 domain-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(165600, NULL, 'G3DSA:3.90.226.10:FF:000303', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(165601, NULL, 'G3DSA:3.30.160.60:FF:002544', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165602, NULL, 'G3DSA:3.30.70.330:FF:000492', NULL, NULL, 'Blast:Myelin expression factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(165603, NULL, 'G3DSA:1.50.40.10:FF:000113', NULL, NULL, 'Mitochondrial substrate carrier family protein', NULL, NULL, NULL, NULL, NULL, 4),
(165604, NULL, 'G3DSA:2.60.40.10:FF:000206', NULL, NULL, 'Sidekick cell adhesion molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(165605, NULL, 'G3DSA:2.60.40.10:FF:005821', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165606, NULL, 'G3DSA:2.30.42.10:FF:000167', NULL, NULL, 'whirlin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(165607, NULL, 'G3DSA:3.30.70.2840:FF:000003', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(165608, NULL, 'G3DSA:3.30.200.20:FF:000193', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(165609, NULL, 'G3DSA:2.60.40.1510:FF:000014', NULL, NULL, 'Integrin subunit alpha 10', NULL, NULL, NULL, NULL, NULL, 4),
(165610, NULL, 'G3DSA:1.10.285.10:FF:000010', NULL, NULL, 'Glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(165611, NULL, 'G3DSA:3.90.79.10:FF:000084', NULL, NULL, 'RNA pyrophosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(165612, NULL, 'G3DSA:1.10.4020.10:FF:000002', NULL, NULL, 'zinc finger and SCAN domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(165613, NULL, 'G3DSA:2.130.10.10:FF:002308', NULL, NULL, 'Glycine-rich protein', NULL, NULL, NULL, NULL, NULL, 4),
(165614, NULL, 'G3DSA:1.10.418.60:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(165615, NULL, 'G3DSA:3.60.20.10:FF:000192', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165616, NULL, 'G3DSA:3.40.50.1100:FF:000193', NULL, NULL, 'Cysteine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(165617, NULL, 'G3DSA:1.10.10.10:FF:000405', NULL, NULL, 'HTH-type transcriptional regulator SinR', NULL, NULL, NULL, NULL, NULL, 4),
(165618, NULL, 'G3DSA:3.40.50.300:FF:002421', NULL, NULL, 'DEAD boX helicase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(165619, NULL, 'G3DSA:2.40.100.10:FF:000077', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(165620, NULL, 'G3DSA:3.40.630.50:FF:000001', NULL, NULL, 'D-aminoacyl-tRNA deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(165621, NULL, 'G3DSA:3.50.50.60:FF:001052', NULL, NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG 1', NULL, NULL, NULL, NULL, NULL, 4),
(165622, NULL, 'G3DSA:1.20.1290.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165623, NULL, 'G3DSA:1.20.58.70:FF:000033', NULL, NULL, 'Unplaced genomic scaffold supercont1.13, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(165624, NULL, 'G3DSA:3.30.519.10:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165625, NULL, 'G3DSA:1.10.10.60:FF:000903', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165626, NULL, 'G3DSA:1.25.10.10:FF:001985', NULL, NULL, 'HEAT repeat-containing protein 5B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165627, NULL, 'G3DSA:1.20.1560.10:FF:000793', NULL, NULL, 'ATP-binding cassette sub-family C member Sur', NULL, NULL, NULL, NULL, NULL, 4),
(165628, NULL, 'G3DSA:3.10.50.40:FF:000030', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(165629, NULL, 'G3DSA:3.40.50.300:FF:003326', NULL, NULL, 'GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165630, NULL, 'G3DSA:2.130.10.10:FF:004220', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165631, NULL, 'G3DSA:2.40.70.10:FF:000304', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165632, NULL, 'G3DSA:2.40.50.1070:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165633, NULL, 'G3DSA:1.20.870.10:FF:000025', NULL, NULL, 'C3G guanyl-nucleotide exchange factor, isoform L', NULL, NULL, NULL, NULL, NULL, 4),
(165634, NULL, 'G3DSA:3.40.50.150:FF:000561', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(165635, NULL, 'G3DSA:3.30.830.10:FF:000046', NULL, NULL, 'Peptidase, M16 family', NULL, NULL, NULL, NULL, NULL, 4),
(165636, NULL, 'G3DSA:1.20.58.1930:FF:000003', NULL, NULL, 'PfEMP1 variant 1 of strain MC', NULL, NULL, NULL, NULL, NULL, 4),
(165637, NULL, 'G3DSA:2.60.40.1660:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165638, NULL, 'G3DSA:2.10.25.10:FF:001056', NULL, NULL, 'Os06g0170250 protein', NULL, NULL, NULL, NULL, NULL, 4),
(165639, NULL, 'G3DSA:1.10.510.10:FF:001838', NULL, NULL, 'Cell division protein kinase 6', NULL, NULL, NULL, NULL, NULL, 4),
(165640, NULL, 'G3DSA:2.10.50.10:FF:000057', NULL, NULL, 'Cysteine repeat modular protein 4 PbCRM4', NULL, NULL, NULL, NULL, NULL, 4),
(165641, NULL, 'G3DSA:2.60.40.10:FF:002730', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', NULL, NULL, NULL, NULL, NULL, 4),
(165642, NULL, 'G3DSA:3.60.20.10:FF:000129', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(165643, NULL, 'G3DSA:1.25.40.10:FF:002162', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(165644, NULL, 'G3DSA:3.90.370.10:FF:000008', NULL, NULL, 'Metalloproteinase inhibitor 2', NULL, NULL, NULL, NULL, NULL, 4),
(165645, NULL, 'G3DSA:3.90.320.10:FF:000005', NULL, NULL, 'Mitochondrial genome maintenance exonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(165646, NULL, 'G3DSA:3.40.30.10:FF:000125', NULL, NULL, 'DnaJ homolog subfamily C member 10', NULL, NULL, NULL, NULL, NULL, 4),
(165647, NULL, 'G3DSA:3.30.160.60:FF:005585', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(165648, NULL, 'G3DSA:1.20.58.2140:FF:000004', NULL, NULL, 'Haloacid dehalogenase', NULL, NULL, NULL, NULL, NULL, 4),
(165649, NULL, 'G3DSA:1.20.120.1320:FF:000013', NULL, NULL, 'Bifunctional aspartate kinase/diaminopimelate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(165650, NULL, 'G3DSA:3.40.720.10:FF:000007', NULL, NULL, 'Arylsulfatase family, member J', NULL, NULL, NULL, NULL, NULL, 4),
(165651, NULL, 'G3DSA:3.20.20.70:FF:000571', NULL, NULL, 'Delta-aminolevulinic acid dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(165652, NULL, 'G3DSA:1.10.10.10:FF:001693', NULL, NULL, 'Winged-helix domain-containing putative tarnscription factor', NULL, NULL, NULL, NULL, NULL, 4),
(165653, NULL, 'G3DSA:1.10.472.140:FF:000009', NULL, NULL, 'Retinoblastoma-like protein homolog lin-35', NULL, NULL, NULL, NULL, NULL, 4),
(165654, NULL, 'G3DSA:3.30.565.10:FF:000553', NULL, NULL, 'PMS1 homolog 2, mismatch repair system component', NULL, NULL, NULL, NULL, NULL, 4),
(165655, NULL, 'G3DSA:3.30.60.30:FF:000100', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(165656, NULL, 'G3DSA:1.25.40.180:FF:000139', NULL, NULL, 'Eukaryotic translation initiation factor 4 gamma 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(165657, NULL, 'G3DSA:4.10.1240.10:FF:000049', NULL, NULL, 'SEcretin/class B GPCR', NULL, NULL, NULL, NULL, NULL, 4),
(165658, NULL, 'G3DSA:1.10.1420.10:FF:000178', NULL, NULL, 'DNA mismatch repair mutS protein', NULL, NULL, NULL, NULL, NULL, 4),
(165659, NULL, 'G3DSA:2.40.100.10:FF:000026', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(165660, NULL, 'G3DSA:3.30.1360.40:FF:000018', NULL, NULL, 'Ribosome-recycling factor, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(165661, NULL, 'G3DSA:1.20.120.1760:FF:000033', NULL, NULL, 'CDP-alcohol phosphatidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(165662, NULL, 'G3DSA:3.30.450.150:FF:000006', NULL, NULL, 'UPF0303 protein EF915_34475', NULL, NULL, NULL, NULL, NULL, 4),
(165663, NULL, 'G3DSA:3.40.50.300:FF:000572', NULL, NULL, 'Mitochondrial Rho GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(165664, NULL, 'G3DSA:1.10.287.4070:FF:000025', NULL, NULL, 'Pre-mRNA processing ribonucleoprotein, binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(165665, NULL, 'G3DSA:2.130.10.10:FF:005681', NULL, NULL, 'Alkaline phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(165666, NULL, 'G3DSA:2.70.150.10:FF:000101', NULL, NULL, 'Probable cobalt/nickel-exporting P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(165667, NULL, 'G3DSA:2.60.40.10:FF:002151', NULL, NULL, 'Sialic acid-binding Ig-like lectin 5', NULL, NULL, NULL, NULL, NULL, 4),
(165668, NULL, 'G3DSA:3.40.50.10330:FF:000122', NULL, NULL, 'NAD kinase a', NULL, NULL, NULL, NULL, NULL, 4),
(165669, NULL, 'G3DSA:1.20.5.580:FF:000004', NULL, NULL, 'Complexin-2', NULL, NULL, NULL, NULL, NULL, 4),
(165670, NULL, 'G3DSA:3.40.50.300:FF:002365', NULL, NULL, 'Unplaced genomic scaffold supercont2.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(165671, NULL, 'G3DSA:2.30.130.110:FF:000002', NULL, NULL, 'Altronate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(165672, NULL, 'G3DSA:4.10.1000.10:FF:000048', NULL, NULL, 'ZFP family member', NULL, NULL, NULL, NULL, NULL, 4),
(165673, NULL, 'G3DSA:1.25.40.20:FF:000130', NULL, NULL, 'Mindbomb E3 ubiquitin protein ligase 2', NULL, NULL, NULL, NULL, NULL, 4),
(165674, NULL, 'G3DSA:3.80.10.10:FF:003051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165675, NULL, 'G3DSA:1.20.5.780:FF:000019', NULL, NULL, 'FXYD domain-containing ion transport regulator', NULL, NULL, NULL, NULL, NULL, 4),
(165676, NULL, 'G3DSA:3.50.50.60:FF:000091', NULL, NULL, '15-cis-phytoene desaturase, chloroplastic/chromoplastic', NULL, NULL, NULL, NULL, NULL, 4),
(165677, NULL, 'G3DSA:1.10.10.1940:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165678, NULL, 'G3DSA:3.30.160.60:FF:001370', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(165679, NULL, 'G3DSA:1.20.960.30:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(165680, NULL, 'G3DSA:1.20.120.720:FF:000023', NULL, NULL, 'Class V myosin', NULL, NULL, NULL, NULL, NULL, 4),
(165681, NULL, 'G3DSA:1.20.1280.50:FF:000064', NULL, NULL, 'Os05g0177100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(165682, NULL, 'G3DSA:1.10.510.10:FF:004188', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165683, NULL, 'G3DSA:2.60.40.10:FF:005080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165684, NULL, 'G3DSA:1.20.1050.10:FF:000147', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165685, NULL, 'G3DSA:3.40.50.80:FF:000119', NULL, NULL, 'Ferric reductase transmembrane component, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165686, NULL, 'G3DSA:1.20.1420.30:FF:000058', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165687, NULL, 'G3DSA:1.20.900.10:FF:000056', NULL, NULL, 'TOR unique function suppressor', NULL, NULL, NULL, NULL, NULL, 4),
(165688, NULL, 'G3DSA:1.20.120.850:FF:000039', NULL, NULL, 'Helicase SWR1', NULL, NULL, NULL, NULL, NULL, 4),
(165689, NULL, 'G3DSA:3.20.20.140:FF:000090', NULL, NULL, 'Adenosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(165690, NULL, 'G3DSA:2.40.128.330:FF:000001', NULL, NULL, 'Magnesium transporter MRS2-1', NULL, NULL, NULL, NULL, NULL, 4),
(165691, NULL, 'G3DSA:2.170.270.10:FF:000108', NULL, NULL, 'Histone-lysine N-methyltransferase SETD5', NULL, NULL, NULL, NULL, NULL, 4),
(165692, NULL, 'G3DSA:2.30.29.30:FF:000209', NULL, NULL, 'FYVE, RhoGEF and PH domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(165693, NULL, 'G3DSA:3.30.870.10:FF:000043', NULL, NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(165694, NULL, 'G3DSA:3.40.50.800:FF:000008', NULL, NULL, 'histidine--tRNA ligase, cytoplasmic isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(165695, NULL, 'G3DSA:2.130.10.10:FF:006018', NULL, NULL, 'Spliceosomal protein sap, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165696, NULL, 'G3DSA:3.50.50.60:FF:001395', NULL, NULL, 'Hydrogenase subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165697, NULL, 'G3DSA:2.30.29.30:FF:001373', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165698, NULL, 'G3DSA:3.30.70.330:FF:002122', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165699, NULL, 'G3DSA:1.10.12.10:FF:000011', NULL, NULL, 'Enoyl-CoA hydratase/isomerase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(165700, NULL, 'G3DSA:3.40.1160.10:FF:000076', NULL, NULL, 'Aspartate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(165701, NULL, 'G3DSA:3.90.290.10:FF:000007', NULL, NULL, 'Fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(165702, NULL, 'G3DSA:3.40.50.2300:FF:001368', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165703, NULL, 'G3DSA:3.90.400.10:FF:000006', NULL, NULL, 'Alpha-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(165704, NULL, 'G3DSA:1.10.1580.10:FF:000015', NULL, NULL, 'Ras-like small GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165705, NULL, 'G3DSA:3.30.450.60:FF:000054', NULL, NULL, 'AP complex subunit sigma', NULL, NULL, NULL, NULL, NULL, 4),
(165706, NULL, 'G3DSA:3.40.50.1010:FF:000273', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165707, NULL, 'G3DSA:3.80.10.10:FF:002831', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165708, NULL, 'G3DSA:1.25.10.10:FF:002334', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165709, NULL, 'G3DSA:3.40.50.300:FF:005979', NULL, NULL, 'CRISPR-associated helicase Cas3', NULL, NULL, NULL, NULL, NULL, 4),
(165710, NULL, 'G3DSA:3.40.50.1820:FF:000015', NULL, NULL, 'Sn1-specific diacylglycerol lipase alpha', NULL, NULL, NULL, NULL, NULL, 4),
(165711, NULL, 'G3DSA:1.10.10.60:FF:000898', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165712, NULL, 'G3DSA:1.10.150.50:FF:000147', NULL, NULL, 'phosphatidylcholine:ceramide cholinephosphotransferase 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(165713, NULL, 'G3DSA:1.20.120.1760:FF:000084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(165714, NULL, 'G3DSA:1.25.40.10:FF:000301', NULL, NULL, 'Nephronophthisis 3', NULL, NULL, NULL, NULL, NULL, 4),
(165715, NULL, 'G3DSA:3.90.360.10:FF:000007', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(165716, NULL, 'G3DSA:3.40.1180.10:FF:000038', NULL, NULL, 'Dehydrodolichyl diphosphate synthase complex subunit nus1', NULL, NULL, NULL, NULL, NULL, 4),
(165717, NULL, 'G3DSA:2.40.10.120:FF:000008', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(165718, NULL, 'G3DSA:3.40.1000.10:FF:000031', NULL, NULL, 'Putative oxygen-evolving enhancer protein 2-2', NULL, NULL, NULL, NULL, NULL, 4),
(165719, NULL, 'G3DSA:3.30.365.10:FF:000004', NULL, NULL, 'Xanthine dehydrogenase oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(165720, NULL, 'G3DSA:1.10.555.10:FF:000227', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165721, NULL, 'G3DSA:1.25.40.20:FF:000181', NULL, NULL, 'Nanchung, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(165722, NULL, 'G3DSA:1.10.238.110:FF:000018', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(165723, NULL, 'G3DSA:3.30.70.1230:FF:000234', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165724, NULL, 'G3DSA:3.20.20.80:FF:000337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165725, NULL, 'G3DSA:3.30.54.10:FF:000001', NULL, NULL, 'DNA replication terminus site-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(165726, NULL, 'G3DSA:3.40.50.300:FF:006255', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165727, NULL, 'G3DSA:3.60.10.10:FF:000247', NULL, NULL, 'DNA-(apurinic or apyrimidinic site) lyase', NULL, NULL, NULL, NULL, NULL, 4),
(165728, NULL, 'G3DSA:1.20.1070.10:FF:000923', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165729, NULL, 'G3DSA:2.10.220.10:FF:000160', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(165730, NULL, 'G3DSA:1.20.1050.10:FF:000203', NULL, NULL, 'Endothelial monocyte-activating polypeptide II pro-EMAP II family protein', NULL, NULL, NULL, NULL, NULL, 4),
(165731, NULL, 'G3DSA:3.30.420.40:FF:000794', NULL, NULL, 'Actin-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(165732, NULL, 'G3DSA:3.90.440.10:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165733, NULL, 'G3DSA:3.30.930.10:FF:000161', NULL, NULL, 'ATP phosphoribosyltransferase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(165734, NULL, 'G3DSA:1.10.510.10:FF:002327', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165735, NULL, 'G3DSA:3.40.350.10:FF:000086', NULL, NULL, 'Xaa-Pro aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(165736, NULL, 'G3DSA:2.20.110.10:FF:000060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165737, NULL, 'G3DSA:3.30.230.130:FF:000070', NULL, NULL, 'Cullin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165738, NULL, 'G3DSA:3.40.50.800:FF:000059', NULL, NULL, 'Prolyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(165739, NULL, 'G3DSA:3.40.630.70:FF:000007', NULL, NULL, 'Leucyl/phenylalanyl-tRNA--protein transferase', NULL, NULL, NULL, NULL, NULL, 4),
(165740, NULL, 'G3DSA:3.40.630.10:FF:000012', NULL, NULL, 'Acetylornithine deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(165741, NULL, 'G3DSA:1.10.510.10:FF:002390', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165742, NULL, 'G3DSA:1.10.472.10:FF:000080', NULL, NULL, 'G1/S-specific cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(165743, NULL, 'G3DSA:2.130.10.10:FF:005529', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165744, NULL, 'G3DSA:3.30.565.10:FF:000497', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165745, NULL, 'G3DSA:2.70.150.10:FF:000045', NULL, NULL, 'Magnesium-translocating P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(165746, NULL, 'G3DSA:2.40.30.10:FF:000370', NULL, NULL, 'NADH-cytochrome b5 reductase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(165747, NULL, 'G3DSA:1.10.10.820:FF:000021', NULL, NULL, 'Heavy chain, Unconventional Myosin', NULL, NULL, NULL, NULL, NULL, 4),
(165748, NULL, 'G3DSA:2.30.30.40:FF:000334', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165749, NULL, 'G3DSA:1.25.10.10:FF:001373', NULL, NULL, 'YALI0D04444p', NULL, NULL, NULL, NULL, NULL, 4),
(165750, NULL, 'G3DSA:1.50.40.10:FF:000506', NULL, NULL, 'Uncharacterized mitochondrial carrier C1271.11', NULL, NULL, NULL, NULL, NULL, 4),
(165751, NULL, 'G3DSA:3.40.50.300:FF:006603', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165752, NULL, 'G3DSA:3.90.190.10:FF:000174', NULL, NULL, 'Protein CBG03773', NULL, NULL, NULL, NULL, NULL, 4),
(165753, NULL, 'G3DSA:3.30.390.10:FF:000017', NULL, NULL, 'o-succinylbenzoate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(165754, NULL, 'G3DSA:2.130.10.10:FF:002707', NULL, NULL, 'AGAP009046-PA', NULL, NULL, NULL, NULL, NULL, 4),
(165755, NULL, 'G3DSA:3.30.470.10:FF:000018', NULL, NULL, 'Branched-chain-amino-acid transaminase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165756, NULL, 'G3DSA:1.25.40.180:FF:000291', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165757, NULL, 'G3DSA:1.10.245.10:FF:000013', NULL, NULL, 'SWI/SNF and RSC complexes subunit ssr3', NULL, NULL, NULL, NULL, NULL, 4),
(165758, NULL, 'G3DSA:3.40.50.300:FF:002022', NULL, NULL, 'ATP-dependent RNA helicase DBP4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165759, NULL, 'G3DSA:1.10.510.10:FF:001097', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(165760, NULL, 'G3DSA:1.20.1110.10:FF:000186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165761, NULL, 'G3DSA:1.10.10.60:FF:000847', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165762, NULL, 'G3DSA:3.40.50.720:FF:000866', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(165763, NULL, 'G3DSA:1.25.10.10:FF:001934', NULL, NULL, 'Importin subunit alpha-7', NULL, NULL, NULL, NULL, NULL, 4),
(165764, NULL, 'G3DSA:2.30.42.10:FF:000223', NULL, NULL, 'USH1 protein network component harmonin', NULL, NULL, NULL, NULL, NULL, 4),
(165765, NULL, 'G3DSA:3.30.160.60:FF:003904', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165766, NULL, 'G3DSA:1.20.120.530:FF:000005', NULL, NULL, 'Transcriptional regulator, GntR family', NULL, NULL, NULL, NULL, NULL, 4),
(165767, NULL, 'G3DSA:3.40.50.720:FF:001266', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(165768, NULL, 'G3DSA:3.40.50.1000:FF:000337', NULL, NULL, 'Phosphomannomutase', NULL, NULL, NULL, NULL, NULL, 4),
(165769, NULL, 'G3DSA:2.60.40.150:FF:000726', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165770, NULL, 'G3DSA:3.40.50.300:FF:006204', NULL, NULL, 'AGR113Wp', NULL, NULL, NULL, NULL, NULL, 4),
(165771, NULL, 'G3DSA:1.10.510.10:FF:001990', NULL, NULL, 'cAMP-dependent protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165772, NULL, 'G3DSA:3.30.70.330:FF:001722', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165773, NULL, 'G3DSA:3.20.19.10:FF:000004', NULL, NULL, 'Aconitate hydratase B', NULL, NULL, NULL, NULL, NULL, 4),
(165774, NULL, 'G3DSA:2.60.120.10:FF:000214', NULL, NULL, 'Pirin-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(165775, NULL, 'G3DSA:2.130.10.10:FF:001347', NULL, NULL, 'Cytoplasmic dynein 1 intermediate chain', NULL, NULL, NULL, NULL, NULL, 4),
(165776, NULL, 'G3DSA:3.20.20.70:FF:000520', NULL, NULL, 'tRNA-dihydrouridine(47) synthase [NAD(P)(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(165777, NULL, 'G3DSA:3.30.70.590:FF:000024', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165778, NULL, 'G3DSA:3.30.420.40:FF:000119', NULL, NULL, 'tRNA threonylcarbamoyladenosine biosynthesis protein TsaB', NULL, NULL, NULL, NULL, NULL, 4),
(165779, NULL, 'G3DSA:1.20.1720.10:FF:000092', NULL, NULL, 'Multidrug resistance transporter, Bcr family', NULL, NULL, NULL, NULL, NULL, 4),
(165780, NULL, 'G3DSA:3.30.200.20:FF:001497', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(165781, NULL, 'G3DSA:2.130.10.10:FF:000858', NULL, NULL, 'GH16945', NULL, NULL, NULL, NULL, NULL, 4),
(165782, NULL, 'G3DSA:3.65.10.10:FF:000012', NULL, NULL, 'Pentafunctional AROM polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(165783, NULL, 'G3DSA:2.60.40.60:FF:000232', NULL, NULL, 'Neural-cadherin', NULL, NULL, NULL, NULL, NULL, 4),
(165784, NULL, 'G3DSA:3.40.50.150:FF:000830', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase G', NULL, NULL, NULL, NULL, NULL, 4),
(165785, NULL, 'G3DSA:3.30.40.10:FF:002240', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165786, NULL, 'G3DSA:3.40.50.1820:FF:000583', NULL, NULL, 'Acylamino-acid-releasing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(165787, NULL, 'G3DSA:3.30.160.60:FF:003000', NULL, NULL, 'Zinc finger and SCAN domain-containing 20', NULL, NULL, NULL, NULL, NULL, 4),
(165788, NULL, 'G3DSA:1.25.70.10:FF:000073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165789, NULL, 'G3DSA:2.80.10.50:FF:000232', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(165790, NULL, 'G3DSA:3.40.1110.10:FF:000365', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165791, NULL, 'G3DSA:2.130.10.10:FF:001926', NULL, NULL, 'Autophagy-related protein 18d', NULL, NULL, NULL, NULL, NULL, 4),
(165792, NULL, 'G3DSA:3.40.50.1400:FF:000013', NULL, NULL, 'Ferrochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(165793, NULL, 'G3DSA:3.30.1320.10:FF:000029', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165794, NULL, 'G3DSA:1.20.81.30:FF:000007', NULL, NULL, 'Type II secretion system inner membrane protein PulF', NULL, NULL, NULL, NULL, NULL, 4),
(165795, NULL, 'G3DSA:3.40.50.150:FF:001342', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165796, NULL, 'G3DSA:1.10.510.10:FF:000821', NULL, NULL, 'Serine/threonine-protein kinase gcn2', NULL, NULL, NULL, NULL, NULL, 4),
(165797, NULL, 'G3DSA:1.20.1070.10:FF:000654', NULL, NULL, 'Adrenoceptor alpha 2A', NULL, NULL, NULL, NULL, NULL, 4),
(165798, NULL, 'G3DSA:1.50.40.10:FF:000001', NULL, NULL, 'ADP,ATP carrier protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(165799, NULL, 'G3DSA:3.40.1690.10:FF:000009', NULL, NULL, 'Flagellar biosynthesis protein FlhB', NULL, NULL, NULL, NULL, NULL, 4),
(165800, NULL, 'G3DSA:2.10.90.10:FF:000054', NULL, NULL, 'Bursicon', NULL, NULL, NULL, NULL, NULL, 4),
(165801, NULL, 'G3DSA:3.40.120.10:FF:000041', NULL, NULL, 'Phosphoglucomutase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165802, NULL, 'G3DSA:1.25.40.10:FF:003903', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g60980, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(165803, NULL, 'G3DSA:3.30.390.60:FF:000010', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(165804, NULL, 'G3DSA:3.40.50.12710:FF:000038', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7', NULL, NULL, NULL, NULL, NULL, 4),
(165805, NULL, 'G3DSA:3.30.60.20:FF:000114', NULL, NULL, 'Thymidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(165806, NULL, 'G3DSA:2.60.40.1910:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165807, NULL, 'G3DSA:2.40.30.10:FF:000307', NULL, NULL, 'GTP-binding elongation factor protein, TetM/TetO family', NULL, NULL, NULL, NULL, NULL, 4),
(165808, NULL, 'G3DSA:1.25.40.10:FF:003847', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165809, NULL, 'G3DSA:1.20.1070.10:FF:000598', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165810, NULL, 'G3DSA:1.10.390.10:FF:000029', NULL, NULL, 'Protein CBG19917', NULL, NULL, NULL, NULL, NULL, 4),
(165811, NULL, 'G3DSA:3.30.420.10:FF:000583', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165812, NULL, 'G3DSA:2.60.220.50:FF:000183', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165813, NULL, 'G3DSA:2.30.40.10:FF:000056', NULL, NULL, 'N-acyl-D-amino acid deacylase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(165814, NULL, 'G3DSA:2.70.170.10:FF:000260', NULL, NULL, 'Protein CBG24733', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(165815, NULL, 'G3DSA:1.20.1070.10:FF:000710', NULL, NULL, 'NeuroPeptide Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(165816, NULL, 'G3DSA:1.10.8.280:FF:000001', NULL, NULL, 'UvrABC system protein A', NULL, NULL, NULL, NULL, NULL, 4),
(165817, NULL, 'G3DSA:3.40.50.1000:FF:000505', NULL, NULL, 'Phospholipid-transporting ATPase IA, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165818, NULL, 'G3DSA:1.25.40.990:FF:000051', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 8 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(165819, NULL, 'G3DSA:3.40.50.720:FF:001827', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165820, NULL, 'G3DSA:1.20.81.10:FF:000001', NULL, NULL, 'Alpha-2-macroglobulin receptor-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(165821, NULL, 'G3DSA:2.30.40.10:FF:000005', NULL, NULL, 'Adenine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(165822, NULL, 'G3DSA:1.20.58.830:FF:000006', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(165823, NULL, 'G3DSA:3.40.720.10:FF:000238', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165824, NULL, 'G3DSA:1.10.510.10:FF:002951', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165825, NULL, 'G3DSA:1.10.287.470:FF:000068', NULL, NULL, 'Discs, large homolog 4b (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(165826, NULL, 'G3DSA:1.10.238.10:FF:000160', NULL, NULL, 'Lysophosphatidylcholine acyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(165827, NULL, 'G3DSA:1.20.990.10:FF:000005', NULL, NULL, 'Nitric oxide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(165828, NULL, 'G3DSA:3.40.50.1700:FF:000041', NULL, NULL, 'Ngs1p', NULL, NULL, NULL, NULL, NULL, 4),
(165829, NULL, 'G3DSA:3.30.200.20:FF:001946', NULL, NULL, 'Serine/threonine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(165830, NULL, 'G3DSA:1.10.287.600:FF:000028', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(165831, NULL, 'G3DSA:2.60.120.40:FF:000026', NULL, NULL, 'Tumor necrosis factor ligand superfamily member 18', NULL, NULL, NULL, NULL, NULL, 4),
(165832, NULL, 'G3DSA:2.60.40.10:FF:005641', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165833, NULL, 'G3DSA:1.25.40.10:FF:005360', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165834, NULL, 'G3DSA:1.10.357.30:FF:000003', NULL, NULL, 'Exocyst complex component', NULL, NULL, NULL, NULL, NULL, 4),
(165835, NULL, 'G3DSA:3.40.50.300:FF:003438', NULL, NULL, 'Recombinase RecB', NULL, NULL, NULL, NULL, NULL, 4),
(165836, NULL, 'G3DSA:3.30.1330.30:FF:000013', NULL, NULL, '40S ribosomal protein S12', NULL, NULL, NULL, NULL, NULL, 4),
(165837, NULL, 'G3DSA:1.25.40.20:FF:001815', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165838, NULL, 'G3DSA:3.30.70.330:FF:000609', NULL, NULL, 'U2 snRNP component IST3', NULL, NULL, NULL, NULL, NULL, 4),
(165839, NULL, 'G3DSA:1.20.1250.20:FF:000749', NULL, NULL, 'Sugar transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(165840, NULL, 'G3DSA:3.40.50.300:FF:008621', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165841, NULL, 'G3DSA:3.40.1810.10:FF:000042', NULL, NULL, 'Os01g0912400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(165842, NULL, 'G3DSA:3.30.70.330:FF:001273', NULL, NULL, 'GM11803', NULL, NULL, NULL, NULL, NULL, 4),
(165843, NULL, 'G3DSA:2.130.10.10:FF:001971', NULL, NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(165844, NULL, 'G3DSA:3.30.160.60:FF:003617', NULL, NULL, 'AGAP005274-PA', NULL, NULL, NULL, NULL, NULL, 4),
(165845, NULL, 'G3DSA:3.30.420.40:FF:000743', NULL, NULL, 'actin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(165846, NULL, 'G3DSA:2.130.10.10:FF:005237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165847, NULL, 'G3DSA:3.40.30.10:FF:000199', NULL, NULL, 'Thioredoxin-like 1-2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(165848, NULL, 'G3DSA:1.25.10.10:FF:001193', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(165849, NULL, 'G3DSA:2.130.10.10:FF:001819', NULL, NULL, 'Probable SOF1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(165850, NULL, 'G3DSA:1.20.120.1380:FF:000008', NULL, NULL, 'Flagellar biosynthesis protein FlhF', NULL, NULL, NULL, NULL, NULL, 4),
(165851, NULL, 'G3DSA:3.80.10.10:FF:002882', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165852, NULL, 'G3DSA:3.30.420.40:FF:000687', NULL, NULL, '(R)-2-hydroxyacyl-CoA dehydratase-radicalizing ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(165853, NULL, 'G3DSA:3.40.1110.10:FF:000472', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165854, NULL, 'G3DSA:3.40.50.2300:FF:001637', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165855, NULL, 'G3DSA:1.25.40.250:FF:000008', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit K', NULL, NULL, NULL, NULL, NULL, 4),
(165856, NULL, 'G3DSA:1.20.5.350:FF:000008', NULL, NULL, 'Troponin I4b, tandem duplicate 2', NULL, NULL, NULL, NULL, NULL, 4),
(165857, NULL, 'G3DSA:2.30.29.30:FF:001322', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165858, NULL, 'G3DSA:3.30.70.330:FF:002739', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165859, NULL, 'G3DSA:2.10.25.10:FF:001668', NULL, NULL, 'Protein eyes shut homolog', NULL, NULL, NULL, NULL, NULL, 4),
(165860, NULL, 'G3DSA:3.90.70.10:FF:000721', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165861, NULL, 'G3DSA:2.120.10.30:FF:000589', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165862, NULL, 'G3DSA:1.10.357.50:FF:000009', NULL, NULL, 'Exocyst complex component 3-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(165863, NULL, 'G3DSA:3.30.60.30:FF:000156', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165864, NULL, 'G3DSA:1.10.3730.20:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165865, NULL, 'G3DSA:2.60.40.10:FF:001370', NULL, NULL, 'Sallimus, isoform P', NULL, NULL, NULL, NULL, NULL, 4),
(165866, NULL, 'G3DSA:1.25.10.10:FF:000529', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(165867, NULL, 'G3DSA:1.10.630.10:FF:000184', NULL, NULL, 'Cytochrome P450 family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(165868, NULL, 'G3DSA:3.40.50.1000:FF:000449', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165869, NULL, 'G3DSA:1.10.10.10:FF:001462', NULL, NULL, 'ORC1-type DNA replication protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(165870, NULL, 'G3DSA:2.60.120.10:FF:000557', NULL, NULL, 'Probable mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(165871, NULL, 'G3DSA:1.10.510.10:FF:001366', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165872, NULL, 'G3DSA:1.10.3730.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165873, NULL, 'G3DSA:3.40.1710.10:FF:000001', NULL, NULL, 'Inner membrane transport permease ybhS', NULL, NULL, NULL, NULL, NULL, 4),
(165874, NULL, 'G3DSA:2.60.300.12:FF:000011', NULL, NULL, 'Iron-sulfur assembly protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(165875, NULL, 'G3DSA:1.10.510.10:FF:000080', NULL, NULL, 'Putative activated CDC42 kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(165876, NULL, 'G3DSA:3.40.50.300:FF:001584', NULL, NULL, 'Ras-like GTP-binding protein RYL2', NULL, NULL, NULL, NULL, NULL, 4),
(165877, NULL, 'G3DSA:3.30.40.10:FF:000727', NULL, NULL, 'Zinc finger, C3HC4 type family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(165878, NULL, 'G3DSA:3.50.50.60:FF:000596', NULL, NULL, 'Flavin-containing monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165879, NULL, 'G3DSA:2.60.120.920:FF:000079', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165880, NULL, 'G3DSA:3.30.70.2590:FF:000001', NULL, NULL, 'Cellulose synthase operon protein D', NULL, NULL, NULL, NULL, NULL, 4),
(165881, NULL, 'G3DSA:3.60.40.10:FF:000367', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(165882, NULL, 'G3DSA:2.40.37.10:FF:000008', NULL, NULL, 'antizyme inhibitor 1', NULL, NULL, NULL, NULL, NULL, 4),
(165883, NULL, 'G3DSA:6.10.140.2220:FF:000043', NULL, NULL, 'protein msta', NULL, NULL, NULL, NULL, NULL, 4),
(165884, NULL, 'G3DSA:1.10.3810.10:FF:000017', NULL, NULL, 'Transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(165885, NULL, 'G3DSA:3.40.50.1260:FF:000044', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(165886, NULL, 'G3DSA:3.40.50.150:FF:000774', NULL, NULL, 'Protein arginine N-methyltransferase 7', NULL, NULL, NULL, NULL, NULL, 4),
(165887, NULL, 'G3DSA:3.30.160.60:FF:004416', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165888, NULL, 'G3DSA:1.10.30.20:FF:000005', NULL, NULL, 'DNA repair helicase Rad3', NULL, NULL, NULL, NULL, NULL, 4),
(165889, NULL, 'G3DSA:3.30.160.60:FF:002275', NULL, NULL, 'Myeloid zinc finger 1', NULL, NULL, NULL, NULL, NULL, 4),
(165890, NULL, 'G3DSA:3.20.20.80:FF:000629', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165891, NULL, 'G3DSA:2.30.30.140:FF:000256', NULL, NULL, 'SAGA complex associated factor 29', NULL, NULL, NULL, NULL, NULL, 4),
(165892, NULL, 'G3DSA:3.40.50.2300:FF:000856', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165893, NULL, 'G3DSA:1.20.1280.50:FF:000120', NULL, NULL, 'F-box/WD repeat-containing protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(165894, NULL, 'G3DSA:4.10.640.10:FF:000010', NULL, NULL, '30S ribosomal protein S18', NULL, NULL, NULL, NULL, NULL, 4),
(165895, NULL, 'G3DSA:3.20.20.20:FF:000022', NULL, NULL, 'Dihydropteroate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(165896, NULL, 'G3DSA:3.40.190.10:FF:000876', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165897, NULL, 'G3DSA:2.60.220.30:FF:000025', NULL, NULL, 'Ankyrin-3', NULL, NULL, NULL, NULL, NULL, 4),
(165898, NULL, 'G3DSA:2.60.40.10:FF:002623', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165899, NULL, 'G3DSA:3.40.190.290:FF:000031', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(165900, NULL, 'G3DSA:2.60.200.20:FF:000021', NULL, NULL, 'Kinesin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(165901, NULL, 'G3DSA:3.40.800.10:FF:000008', NULL, NULL, 'Arginase', NULL, NULL, NULL, NULL, NULL, 4),
(165902, NULL, 'G3DSA:1.20.58.1120:FF:000030', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(165903, NULL, 'G3DSA:1.25.10.10:FF:001878', NULL, NULL, 'Slr1098 protein', NULL, NULL, NULL, NULL, NULL, 4),
(165904, NULL, 'G3DSA:3.10.330.20:FF:000004', NULL, NULL, 'tRNA (adenine(58)-N(1))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(165905, NULL, 'G3DSA:3.40.50.720:FF:000574', NULL, NULL, 'WW domain containing oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(165906, NULL, 'G3DSA:1.20.120.1080:FF:000132', NULL, NULL, 'DExH-box helicase 34', NULL, NULL, NULL, NULL, NULL, 4),
(165907, NULL, 'G3DSA:1.20.120.1110:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165908, NULL, 'G3DSA:3.30.450.20:FF:000464', NULL, NULL, 'Hypoxia-inducible factor 1 subunit alpha,-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(165909, NULL, 'G3DSA:1.10.510.10:FF:002619', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165910, NULL, 'G3DSA:2.40.160.50:FF:000019', NULL, NULL, 'Outer membrane protein assembly factor', NULL, NULL, NULL, NULL, NULL, 4),
(165911, NULL, 'G3DSA:3.10.400.10:FF:000007', NULL, NULL, 'Sulfate adenylyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165912, NULL, 'G3DSA:3.40.50.1820:FF:000307', NULL, NULL, 'Probable conserved membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(165913, NULL, 'G3DSA:3.50.50.60:FF:001321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165914, NULL, 'G3DSA:1.20.58.60:FF:000592', NULL, NULL, 'Putative titin isoform x14', NULL, NULL, NULL, NULL, NULL, 4),
(165915, NULL, 'G3DSA:3.40.50.300:FF:008385', NULL, NULL, 'DNA repair helicase, putative', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(165916, NULL, 'G3DSA:1.10.20.10:FF:000119', NULL, NULL, 'Unplaced genomic scaffold supercont1.244, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(165917, NULL, 'G3DSA:2.40.20.10:FF:000032', NULL, NULL, 'Tyrosine-protein kinase receptor cam-1', NULL, NULL, NULL, NULL, NULL, 4),
(165918, NULL, 'G3DSA:1.20.140.100:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165919, NULL, 'G3DSA:2.40.160.120:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165920, NULL, 'G3DSA:1.10.630.10:FF:000240', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165921, NULL, 'G3DSA:1.10.10.10:FF:000681', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(165922, NULL, 'G3DSA:2.60.200.40:FF:000027', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(165923, NULL, 'G3DSA:1.25.40.10:FF:000413', NULL, NULL, 'General transcription factor 3C polypeptide 3', NULL, NULL, NULL, NULL, NULL, 4),
(165924, NULL, 'G3DSA:1.10.1450.10:FF:000062', NULL, NULL, 'TetraSPanin family', NULL, NULL, NULL, NULL, NULL, 4),
(165925, NULL, 'G3DSA:3.50.50.60:FF:000883', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165926, NULL, 'G3DSA:1.10.472.10:FF:000035', NULL, NULL, 'RB transcriptional corepressor-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(165927, NULL, 'G3DSA:1.20.1250.20:FF:002262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165928, NULL, 'G3DSA:1.20.1730.10:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165929, NULL, 'G3DSA:3.20.20.140:FF:000270', NULL, NULL, 'Ribonuclease P protein component 3', NULL, NULL, NULL, NULL, NULL, 4),
(165930, NULL, 'G3DSA:1.20.920.10:FF:000018', NULL, NULL, 'nucleosome-remodeling factor subunit BPTF isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(165931, NULL, 'G3DSA:3.20.20.140:FF:000382', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165932, NULL, 'G3DSA:3.30.420.10:FF:000307', NULL, NULL, 'DNA polymerase Pol2', NULL, NULL, NULL, NULL, NULL, 4),
(165933, NULL, 'G3DSA:1.10.510.10:FF:003732', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165934, NULL, 'G3DSA:2.10.25.10:FF:000364', NULL, NULL, 'Latent transforming growth factor beta binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(165935, NULL, 'G3DSA:3.40.50.11060:FF:000004', NULL, NULL, 'AGAP003969-PA', NULL, NULL, NULL, NULL, NULL, 4),
(165936, NULL, 'G3DSA:1.10.220.10:FF:000046', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(165937, NULL, 'G3DSA:3.80.10.10:FF:000701', NULL, NULL, 'Disease resistance protein (TIR-NBS-LRR class)', NULL, NULL, NULL, NULL, NULL, 4),
(165938, NULL, 'G3DSA:1.25.40.10:FF:003050', NULL, NULL, 'Pre-mRNA splicing factor putative', NULL, NULL, NULL, NULL, NULL, 4),
(165939, NULL, 'G3DSA:3.40.50.300:FF:005748', NULL, NULL, 'DNA polymerase III, gamma subunit-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(165940, NULL, 'G3DSA:1.25.10.10:FF:002042', NULL, NULL, 'Microtubule associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(165941, NULL, 'G3DSA:3.40.50.1000:FF:000781', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165942, NULL, 'G3DSA:2.60.40.1760:FF:000004', NULL, NULL, 'Alpha-xylosidase', NULL, NULL, NULL, NULL, NULL, 4),
(165943, NULL, 'G3DSA:3.40.50.300:FF:001297', NULL, NULL, 'Cysteine/glutathione ABC transporter ATP-binding protein/permease CydC', NULL, NULL, NULL, NULL, NULL, 4),
(165944, NULL, 'G3DSA:1.20.5.4770:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165945, NULL, 'G3DSA:3.30.160.60:FF:001763', NULL, NULL, 'Zinc finger protein 574', NULL, NULL, NULL, NULL, NULL, 4),
(165946, NULL, 'G3DSA:3.30.60.30:FF:000212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165947, NULL, 'G3DSA:2.130.10.10:FF:005349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165948, NULL, 'G3DSA:3.90.1180.10:FF:000010', NULL, NULL, '50S ribosomal protein L13-like protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(165949, NULL, 'G3DSA:1.10.510.10:FF:001546', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165950, NULL, 'G3DSA:2.60.120.920:FF:000135', NULL, NULL, 'TRIM65 isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(165951, NULL, 'G3DSA:3.30.40.10:FF:000907', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(165952, NULL, 'G3DSA:3.80.10.10:FF:003394', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(165953, NULL, 'G3DSA:3.10.120.10:FF:000025', NULL, NULL, 'Cytochrome b5-like Heme/Steroid binding domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(165954, NULL, 'G3DSA:3.80.10.10:FF:004012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165955, NULL, 'G3DSA:3.40.50.300:FF:001640', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(165956, NULL, 'G3DSA:3.10.290.10:FF:000008', NULL, NULL, 'Heat shock protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(165957, NULL, 'G3DSA:3.40.50.2000:FF:000980', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165958, NULL, 'G3DSA:2.60.40.10:FF:004860', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165959, NULL, 'G3DSA:1.10.238.10:FF:000901', NULL, NULL, 'Respiratory burst oxidase homolog protein C', NULL, NULL, NULL, NULL, NULL, 4),
(165960, NULL, 'G3DSA:3.30.200.20:FF:002278', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(165961, NULL, 'G3DSA:3.40.50.12390:FF:000010', NULL, NULL, 'Putative 5''-3'' exonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(165962, NULL, 'G3DSA:3.20.20.360:FF:000004', NULL, NULL, 'Malate synthase G', NULL, NULL, NULL, NULL, NULL, 4),
(165963, NULL, 'G3DSA:1.25.40.20:FF:000473', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(165964, NULL, 'G3DSA:3.30.70.330:FF:000941', NULL, NULL, 'ATP-independent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(165965, NULL, 'G3DSA:3.30.160.60:FF:002095', NULL, NULL, 'ras-responsive element-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(165966, NULL, 'G3DSA:3.50.50.100:FF:000010', NULL, NULL, 'Alternative NAD(P)H-ubiquinone oxidoreductase C1, chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(165967, NULL, 'G3DSA:2.130.10.10:FF:000566', NULL, NULL, 'Dynein cytoplasmic 1 intermediate chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(165968, NULL, 'G3DSA:3.30.160.60:FF:006434', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165969, NULL, 'G3DSA:3.30.530.20:FF:000178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165970, NULL, 'G3DSA:3.40.50.300:FF:006311', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165971, NULL, 'G3DSA:1.10.8.10:FF:000258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165972, NULL, 'G3DSA:2.130.10.10:FF:001639', NULL, NULL, 'WD domain, G-beta repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(165973, NULL, 'G3DSA:3.40.50.300:FF:002096', NULL, NULL, 'nuclear GTPase SLIP-GC isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(165974, NULL, 'G3DSA:2.40.50.140:FF:000207', NULL, NULL, 'Sugar ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(165975, NULL, 'G3DSA:3.40.50.150:FF:001286', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165976, NULL, 'G3DSA:1.20.1740.10:FF:000216', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165977, NULL, 'G3DSA:3.90.76.10:FF:000055', NULL, NULL, 'Probable ABC transporter-binding protein DR_1571', NULL, NULL, NULL, NULL, NULL, 4),
(165978, NULL, 'G3DSA:1.20.1000.10:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165979, NULL, 'G3DSA:3.20.70.20:FF:000025', NULL, NULL, 'Ribonucleoside-diphosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(165980, NULL, 'G3DSA:1.25.40.70:FF:000004', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(165981, NULL, 'G3DSA:3.30.450.20:FF:000177', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(165982, NULL, 'G3DSA:2.60.40.10:FF:003168', NULL, NULL, 'AGAP011650-PA', NULL, NULL, NULL, NULL, NULL, 4),
(165983, NULL, 'G3DSA:3.40.720.10:FF:000283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165984, NULL, 'G3DSA:2.60.60.20:FF:000025', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165985, NULL, 'G3DSA:1.25.10.10:FF:003115', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(165986, NULL, 'G3DSA:3.80.10.10:FF:001769', NULL, NULL, 'NACHT, LRR and PYD domains-containing protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(165987, NULL, 'G3DSA:3.30.40.10:FF:000110', NULL, NULL, 'E3 ubiquitin-protein ligase RNF34 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(165988, NULL, 'G3DSA:2.60.40.1180:FF:000038', NULL, NULL, 'Lysosomal glucosyl ceramidase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(165989, NULL, 'G3DSA:1.25.40.20:FF:001759', NULL, NULL, 'CASK-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(165990, NULL, 'G3DSA:1.20.920.10:FF:000170', NULL, NULL, 'Protein polybromo-1', NULL, NULL, NULL, NULL, NULL, 4),
(165991, NULL, 'G3DSA:3.40.390.10:FF:000083', NULL, NULL, 'Zinc metalloproteinase', NULL, NULL, NULL, NULL, NULL, 4),
(165992, NULL, 'G3DSA:3.90.550.10:FF:000106', NULL, NULL, 'Translation initiation factor eIF-2B subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(165993, NULL, 'G3DSA:3.80.10.10:FF:003899', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165994, NULL, 'G3DSA:3.60.40.10:FF:000187', NULL, NULL, 'Protein phosphatase 2C', NULL, NULL, NULL, NULL, NULL, 4),
(165995, NULL, 'G3DSA:3.40.50.1760:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(165996, NULL, 'G3DSA:3.40.1380.10:FF:000019', NULL, NULL, 'ATP synthase subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(165997, NULL, 'G3DSA:1.25.40.20:FF:000978', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(165998, NULL, 'G3DSA:1.20.1070.10:FF:000474', NULL, NULL, 'Nematocin receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(165999, NULL, 'G3DSA:1.50.40.10:FF:000057', NULL, NULL, 'Solute carrier family 25 member 46', NULL, NULL, NULL, NULL, NULL, 4),
(166000, NULL, 'G3DSA:1.10.238.150:FF:000002', NULL, NULL, 'protein diaphanous homolog 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(166001, NULL, 'G3DSA:1.10.1410.10:FF:000065', NULL, NULL, 'Non-canonical poly(A) RNA polymerase PAPD7', NULL, NULL, NULL, NULL, NULL, 4),
(166002, NULL, 'G3DSA:3.20.110.10:FF:000022', NULL, NULL, 'Chromosome 12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(166003, NULL, 'G3DSA:1.10.510.10:FF:000641', NULL, NULL, 'Serine/threonine-protein kinase PEPKR2', NULL, NULL, NULL, NULL, NULL, 4),
(166004, NULL, 'G3DSA:3.30.70.1520:FF:000001', NULL, NULL, 'Sarcosine oxidase, gamma subunit family', NULL, NULL, NULL, NULL, NULL, 4),
(166005, NULL, 'G3DSA:3.40.50.300:FF:008109', NULL, NULL, 'Dicer-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166006, NULL, 'G3DSA:2.10.50.10:FF:000164', NULL, NULL, 'IGF-like family receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(166007, NULL, 'G3DSA:3.40.50.300:FF:002657', NULL, NULL, 'WD_domain', NULL, NULL, NULL, NULL, NULL, 4),
(166008, NULL, 'G3DSA:2.60.120.1680:FF:000003', NULL, NULL, 'Replicase polyprotein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(166009, NULL, 'G3DSA:3.40.50.620:FF:000218', NULL, NULL, 'Cysteine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(166010, NULL, 'G3DSA:3.40.50.1100:FF:000148', NULL, NULL, 'Cysteine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(166011, NULL, 'G3DSA:3.30.160.60:FF:003056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166012, NULL, 'G3DSA:1.10.287.3510:FF:000003', NULL, NULL, 'NADH-ubiquinone oxidoreductase chain 4L', NULL, NULL, NULL, NULL, NULL, 4),
(166013, NULL, 'G3DSA:3.40.30.10:FF:000816', NULL, NULL, 'Maleylacetoacetate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(166014, NULL, 'G3DSA:2.10.110.20:FF:000003', NULL, NULL, 'Lysine (K)-specific demethylase 6B, a', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(166015, NULL, 'G3DSA:2.130.10.10:FF:004512', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166016, NULL, 'G3DSA:3.40.140.10:FF:000216', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(166017, NULL, 'G3DSA:3.30.160.60:FF:000706', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(166018, NULL, 'G3DSA:3.30.530.20:FF:000122', NULL, NULL, 'Oligoketide cyclase/lipid transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(166019, NULL, 'G3DSA:2.60.120.330:FF:000093', NULL, NULL, 'Oxidoreductase, 2OG-Fe(II) oxygenase family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166020, NULL, 'G3DSA:2.60.40.10:FF:001482', NULL, NULL, 'Protein-glutamine gamma-glutamyltransferase 4', NULL, NULL, NULL, NULL, NULL, 4),
(166021, NULL, 'G3DSA:1.10.533.10:FF:000278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166022, NULL, 'G3DSA:1.10.287.500:FF:000004', NULL, NULL, 'Chemotaxis response-phosphatase CheZ', NULL, NULL, NULL, NULL, NULL, 4),
(166023, NULL, 'G3DSA:3.90.70.10:FF:000160', NULL, NULL, 'Trophozoite cysteine proteinase', NULL, NULL, NULL, NULL, NULL, 4),
(166024, NULL, 'G3DSA:3.10.320.10:FF:000006', NULL, NULL, 'cDNA FLJ57033, highly similar to Antigen peptide transporter 2', NULL, NULL, NULL, NULL, NULL, 4),
(166025, NULL, 'G3DSA:1.10.10.60:FF:000611', NULL, NULL, 'MmsAB operon regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(166026, NULL, 'G3DSA:3.40.50.300:FF:000280', NULL, NULL, 'Putative ras-related protein Rab-4B', NULL, NULL, NULL, NULL, NULL, 4),
(166027, NULL, 'G3DSA:3.30.40.10:FF:000166', NULL, NULL, 'E3 ubiquitin-protein ligase RNF139', NULL, NULL, NULL, NULL, NULL, 4),
(166028, NULL, 'G3DSA:1.10.287.70:FF:000116', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(166029, NULL, 'G3DSA:1.10.287.130:FF:000191', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(166030, NULL, 'G3DSA:2.10.25.10:FF:000887', NULL, NULL, 'Os02g0807800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(166031, NULL, 'G3DSA:3.40.50.300:FF:003950', NULL, NULL, 'IPP transferase/Zinc-finger of C2H2 type, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166032, NULL, 'G3DSA:3.40.50.620:FF:000893', NULL, NULL, 'Tryptophanyl-trna synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(166033, NULL, 'G3DSA:3.40.50.720:FF:001715', NULL, NULL, 'Glyoxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(166034, NULL, 'G3DSA:1.20.140.150:FF:000042', NULL, NULL, 'Clc-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(166035, NULL, 'G3DSA:1.10.238.10:FF:000665', NULL, NULL, 'troponin C', NULL, NULL, NULL, NULL, NULL, 4),
(166036, NULL, 'G3DSA:2.30.30.40:FF:000047', NULL, NULL, 'Disks large homolog 2 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(166037, NULL, 'G3DSA:2.120.10.80:FF:000290', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(166038, NULL, 'G3DSA:1.25.40.20:FF:001198', NULL, NULL, 'Si:ch211-209a2.2', NULL, NULL, NULL, NULL, NULL, 4),
(166039, NULL, 'G3DSA:1.10.730.10:FF:000129', NULL, NULL, 'Methionine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(166040, NULL, 'G3DSA:1.20.210.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166041, NULL, 'G3DSA:1.20.140.10:FF:000104', NULL, NULL, 'Acyl-CoA dehydrogenase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(166042, NULL, 'G3DSA:3.90.1720.10:FF:000035', NULL, NULL, 'Lysin', NULL, NULL, NULL, NULL, NULL, 4),
(166043, NULL, 'G3DSA:1.20.58.80:FF:000075', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(166044, NULL, 'G3DSA:2.20.25.240:FF:000008', NULL, NULL, 'AGAP003439-PA', NULL, NULL, NULL, NULL, NULL, 4),
(166045, NULL, 'G3DSA:3.90.1110.10:FF:000005', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(166046, NULL, 'G3DSA:3.30.559.30:FF:000090', NULL, NULL, 'HC-toxin synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(166047, NULL, 'G3DSA:3.40.50.1820:FF:001420', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(166048, NULL, 'G3DSA:3.40.50.300:FF:003618', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166049, NULL, 'G3DSA:1.10.10.10:FF:001985', NULL, NULL, 'Protein CBR-HSF-1', NULL, NULL, NULL, NULL, NULL, 4),
(166050, NULL, 'G3DSA:1.20.1070.10:FF:001379', NULL, NULL, 'GoNadotropin-Releasing hormone Receptor (GnRHR) related', NULL, NULL, NULL, NULL, NULL, 4),
(166051, NULL, 'G3DSA:3.30.200.20:FF:001822', NULL, NULL, 'CHEK2 isoform 21', NULL, NULL, NULL, NULL, NULL, 4),
(166052, NULL, 'G3DSA:3.90.1640.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166053, NULL, 'G3DSA:3.30.70.260:FF:000004', NULL, NULL, 'Ribose-5-phosphate isomerase A', NULL, NULL, NULL, NULL, NULL, 4),
(166054, NULL, 'G3DSA:3.40.30.10:FF:000417', NULL, NULL, 'Glutathione S-transferase Gst', NULL, NULL, NULL, NULL, NULL, 4),
(166055, NULL, 'G3DSA:3.30.450.40:FF:000127', NULL, NULL, 'Sigma factor sigB regulation protein rsbU', NULL, NULL, NULL, NULL, NULL, 4),
(166056, NULL, 'G3DSA:3.40.50.150:FF:001847', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166057, NULL, 'G3DSA:3.40.50.1820:FF:001364', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(166058, NULL, 'G3DSA:3.30.70.330:FF:001397', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166059, NULL, 'G3DSA:3.30.830.10:FF:000102', NULL, NULL, 'Probable zinc protease PqqL', NULL, NULL, NULL, NULL, NULL, 4),
(166060, NULL, 'G3DSA:3.40.630.10:FF:000124', NULL, NULL, 'Cytosolic leucyl aminopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166061, NULL, 'G3DSA:3.30.160.60:FF:004017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166062, NULL, 'G3DSA:3.40.50.10490:FF:000092', NULL, NULL, 'RpiR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(166063, NULL, 'G3DSA:2.40.30.170:FF:000038', NULL, NULL, 'RND multidrug efflux membrane permease', NULL, NULL, NULL, NULL, NULL, 4),
(166064, NULL, 'G3DSA:2.40.170.20:FF:000028', NULL, NULL, 'Outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(166065, NULL, 'G3DSA:3.30.1520.10:FF:000180', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(166066, NULL, 'G3DSA:2.102.10.10:FF:000045', NULL, NULL, 'Rieske (2Fe-2S) iron-sulphur domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(166067, NULL, 'G3DSA:1.25.40.10:FF:002830', NULL, NULL, 'Clustered mitochondria protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(166068, NULL, 'G3DSA:3.40.50.10260:FF:000040', NULL, NULL, 'Enhancer of mRNA decapping 3 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(166069, NULL, 'G3DSA:3.30.70.1730:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166070, NULL, 'G3DSA:2.130.10.10:FF:003551', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166071, NULL, 'G3DSA:2.60.40.3500:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166072, NULL, 'G3DSA:3.30.2410.10:FF:000025', NULL, NULL, 'Ubiquitin ligase (E3)', NULL, NULL, NULL, NULL, NULL, 4),
(166073, NULL, 'G3DSA:3.10.20.90:FF:000251', NULL, NULL, 'DNA-binding protein Ets97D', NULL, NULL, NULL, NULL, NULL, 4),
(166074, NULL, 'G3DSA:1.10.287.40:FF:000012', NULL, NULL, 'Seryl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166075, NULL, 'G3DSA:3.40.50.2000:FF:000704', NULL, NULL, 'UDP-glycosyltransferase 83A1', NULL, NULL, NULL, NULL, NULL, 4),
(166076, NULL, 'G3DSA:3.30.70.330:FF:003139', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166077, NULL, 'G3DSA:3.10.20.90:FF:000195', NULL, NULL, 'small ubiquitin-related modifier 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(166078, NULL, 'G3DSA:1.20.1250.20:FF:001149', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(166079, NULL, 'G3DSA:1.10.1300.10:FF:000074', NULL, NULL, 'Amino acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(166080, NULL, 'G3DSA:2.10.25.10:FF:000600', NULL, NULL, 'cartilage matrix protein-like', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(166081, NULL, 'G3DSA:1.10.287.110:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166082, NULL, 'G3DSA:1.25.40.10:FF:005180', NULL, NULL, 'Prolyl 4-hydroxylase subunit alpha-2', NULL, NULL, NULL, NULL, NULL, 4),
(166083, NULL, 'G3DSA:3.40.50.720:FF:000754', NULL, NULL, 'Short chain dehydrogenase/reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166084, NULL, 'G3DSA:2.40.100.10:FF:000133', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(166085, NULL, 'G3DSA:2.60.120.740:FF:000002', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(166086, NULL, 'G3DSA:1.10.238.10:FF:000721', NULL, NULL, 'calmodulin-related protein-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(166087, NULL, 'G3DSA:4.10.240.10:FF:000081', NULL, NULL, 'Zcf17p', NULL, NULL, NULL, NULL, NULL, 4),
(166088, NULL, 'G3DSA:2.60.40.10:FF:002443', NULL, NULL, 'Ig-like and fibronectin type-III domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(166089, NULL, 'G3DSA:3.80.10.10:FF:001426', NULL, NULL, 'Dynein regulatory complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(166090, NULL, 'G3DSA:1.25.10.10:FF:003458', NULL, NULL, 'Translational activator, putative (AFU_orthologue AFUA_2G07960)', NULL, NULL, NULL, NULL, NULL, 4),
(166091, NULL, 'G3DSA:1.20.1270.10:FF:000074', NULL, NULL, 'Heat shock 70 kDa protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(166092, NULL, 'G3DSA:3.30.70.100:FF:000041', NULL, NULL, 'Mechanosensitive ion channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(166093, NULL, 'G3DSA:2.30.42.10:FF:000459', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166094, NULL, 'G3DSA:3.40.50.720:FF:001030', NULL, NULL, 'Alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(166095, NULL, 'G3DSA:3.30.40.10:FF:001127', NULL, NULL, 'General transcription factor IIH subunit', NULL, NULL, NULL, NULL, NULL, 4),
(166096, NULL, 'G3DSA:1.10.510.10:FF:000585', NULL, NULL, 'Probable inactive receptor kinase At1g48480', NULL, NULL, NULL, NULL, NULL, 4),
(166097, NULL, 'G3DSA:1.25.40.20:FF:000635', NULL, NULL, 'Transient receptor potential cation channel subfamily C member 1', NULL, NULL, NULL, NULL, NULL, 4),
(166098, NULL, 'G3DSA:3.30.565.10:FF:000261', NULL, NULL, 'Histidine kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166099, NULL, 'G3DSA:2.30.30.490:FF:000069', NULL, NULL, 'Cytosine-C5 specific DNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(166100, NULL, 'G3DSA:3.30.360.20:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166101, NULL, 'G3DSA:2.40.50.140:FF:000483', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(166102, NULL, 'G3DSA:3.80.10.10:FF:000645', NULL, NULL, 'Leucine-rich repeat-containing protein 59', NULL, NULL, NULL, NULL, NULL, 4),
(166103, NULL, 'G3DSA:1.10.132.30:FF:000032', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(166104, NULL, 'G3DSA:3.30.70.330:FF:002178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166105, NULL, 'G3DSA:1.20.90.10:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166106, NULL, 'G3DSA:2.130.10.10:FF:000802', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(166107, NULL, 'G3DSA:3.30.40.100:FF:000001', NULL, NULL, 'MORC family CW-type zinc finger protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(166108, NULL, 'G3DSA:1.10.510.10:FF:004295', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166109, NULL, 'G3DSA:1.20.120.1080:FF:000076', NULL, NULL, 'Protein CBG04082', NULL, NULL, NULL, NULL, NULL, 4),
(166110, NULL, 'G3DSA:3.40.50.2300:FF:000912', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166111, NULL, 'G3DSA:3.30.70.330:FF:002234', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166112, NULL, 'G3DSA:3.40.50.300:FF:000004', NULL, NULL, 'ATP synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(166113, NULL, 'G3DSA:1.25.40.10:FF:001993', NULL, NULL, 'Os03g0241800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(166114, NULL, 'G3DSA:3.30.160.60:FF:000127', NULL, NULL, 'Zinc finger protein 354C', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(166115, NULL, 'G3DSA:3.30.230.10:FF:000192', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(166116, NULL, 'G3DSA:3.30.200.20:FF:000985', NULL, NULL, 'Putative serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(166117, NULL, 'G3DSA:1.10.287.70:FF:000459', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(166118, NULL, 'G3DSA:3.40.50.300:FF:000128', NULL, NULL, 'Putative DNA repair helicase RAD3', NULL, NULL, NULL, NULL, NULL, 4),
(166119, NULL, 'G3DSA:1.20.1250.20:FF:000188', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(166120, NULL, 'G3DSA:2.60.40.790:FF:000126', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166121, NULL, 'G3DSA:1.10.2000.10:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166122, NULL, 'G3DSA:2.30.30.140:FF:000312', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166123, NULL, 'G3DSA:1.20.1070.10:FF:001778', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(166124, NULL, 'G3DSA:3.30.200.20:FF:001261', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(166125, NULL, 'G3DSA:2.130.10.10:FF:000622', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(166126, NULL, 'G3DSA:1.25.10.10:FF:000024', NULL, NULL, 'Formin-like 1, isoform CRA_c', NULL, NULL, NULL, NULL, NULL, 4),
(166127, NULL, 'G3DSA:3.60.21.10:FF:000059', NULL, NULL, 'Metallophosphoesterase, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(166128, NULL, 'G3DSA:3.40.630.30:FF:000282', NULL, NULL, 'GCN5-related N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(166129, NULL, 'G3DSA:1.10.287.1490:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166130, NULL, 'G3DSA:2.60.40.10:FF:002387', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(166131, NULL, 'G3DSA:3.60.10.10:FF:000359', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(166132, NULL, 'G3DSA:3.10.20.90:FF:000375', NULL, NULL, 'Myosin 28B1, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(166133, NULL, 'G3DSA:1.25.40.10:FF:001318', NULL, NULL, 'Os03g0314400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(166134, NULL, 'G3DSA:1.10.555.10:FF:000115', NULL, NULL, 'CHImaeriN (Rac-GTPase-activating protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(166135, NULL, 'G3DSA:1.20.1250.20:FF:001481', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166136, NULL, 'G3DSA:3.30.70.330:FF:001958', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166137, NULL, 'G3DSA:1.25.10.10:FF:000861', NULL, NULL, 'Protein HASTY 1', NULL, NULL, NULL, NULL, NULL, 4),
(166138, NULL, 'G3DSA:2.60.40.10:FF:000313', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase zeta', NULL, NULL, NULL, NULL, NULL, 4),
(166139, NULL, 'G3DSA:3.40.50.300:FF:007480', NULL, NULL, 'Pre-mRNA-splicing factor cwf11', NULL, NULL, NULL, NULL, NULL, 4),
(166140, NULL, 'G3DSA:2.170.150.10:FF:000004', NULL, NULL, 'Guanine nucleotide exchange factor MSS4', NULL, NULL, NULL, NULL, NULL, 4),
(166141, NULL, 'G3DSA:3.40.50.1820:FF:001763', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166142, NULL, 'G3DSA:3.30.710.10:FF:000447', NULL, NULL, 'SKP1-like protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(166143, NULL, 'G3DSA:2.60.40.10:FF:003404', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166144, NULL, 'G3DSA:3.90.228.10:FF:000021', NULL, NULL, 'Ubiquitin conjugating enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166145, NULL, 'G3DSA:3.40.50.720:FF:000810', NULL, NULL, 'SDR family oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(166146, NULL, 'G3DSA:3.10.20.70:FF:000037', NULL, NULL, 'Glutamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(166147, NULL, 'G3DSA:1.10.357.10:FF:000065', NULL, NULL, 'TetR/AcrR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(166148, NULL, 'G3DSA:3.40.710.10:FF:000069', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase DacB', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(166149, NULL, 'G3DSA:3.90.550.10:FF:000505', NULL, NULL, 'Probable dolichol-phosphate mannosyltransferase-putative membrane bound sugar transferase involved in LPS biosynthesis', NULL, NULL, NULL, NULL, NULL, 4),
(166150, NULL, 'G3DSA:1.20.58.390:FF:000273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166151, NULL, 'G3DSA:1.10.437.10:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166152, NULL, 'G3DSA:3.80.10.10:FF:000589', NULL, NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g06840', NULL, NULL, NULL, NULL, NULL, 4),
(166153, NULL, 'G3DSA:2.60.120.200:FF:000537', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(166154, NULL, 'G3DSA:2.130.10.10:FF:003495', NULL, NULL, 'Intraflagellar transport protein 140-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(166155, NULL, 'G3DSA:1.20.140.10:FF:000048', NULL, NULL, 'Putative acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(166156, NULL, 'G3DSA:3.90.260.10:FF:000062', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(166157, NULL, 'G3DSA:3.30.1370.30:FF:000010', NULL, NULL, '30S ribosomal protein S8', NULL, NULL, NULL, NULL, NULL, 4),
(166158, NULL, 'G3DSA:3.40.50.300:FF:004170', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(166159, NULL, 'G3DSA:1.10.510.10:FF:001602', NULL, NULL, 'Kinase/ Serine/Threonine Kinase', NULL, NULL, NULL, NULL, NULL, 4),
(166160, NULL, 'G3DSA:3.30.565.10:FF:000109', NULL, NULL, 'Related to MLH1-DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(166161, NULL, 'G3DSA:1.25.40.10:FF:005028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166162, NULL, 'G3DSA:3.50.50.60:FF:000540', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(166163, NULL, 'G3DSA:1.20.1070.10:FF:001435', NULL, NULL, 'Vasotocin receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(166164, NULL, 'G3DSA:1.20.1250.20:FF:000805', NULL, NULL, 'Unplaced genomic scaffold supercont1.223, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(166165, NULL, 'G3DSA:3.30.160.60:FF:003399', NULL, NULL, 'zinc finger protein 184', NULL, NULL, NULL, NULL, NULL, 4),
(166166, NULL, 'G3DSA:1.20.58.340:FF:000011', NULL, NULL, 'Magnesium transporter MRS2-1', NULL, NULL, NULL, NULL, NULL, 4),
(166167, NULL, 'G3DSA:2.60.40.640:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166168, NULL, 'G3DSA:2.160.10.10:FF:000082', NULL, NULL, 'Translation initiation factor eIF-2B subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(166169, NULL, 'G3DSA:3.80.10.10:FF:000988', NULL, NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(166170, NULL, 'G3DSA:3.40.50.300:FF:003770', NULL, NULL, 'ATP-dependent RNA helicase DHR1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166171, NULL, 'G3DSA:3.40.630.10:FF:000068', NULL, NULL, 'Peptidase M20 domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(166172, NULL, 'G3DSA:3.30.1370.50:FF:000016', NULL, NULL, 'R3H domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166173, NULL, 'G3DSA:2.60.34.10:FF:000080', NULL, NULL, 'Molecular chaperone DnaK', NULL, NULL, NULL, NULL, NULL, 4),
(166174, NULL, 'G3DSA:3.40.50.2060:FF:000008', NULL, NULL, 'Sec1 family superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(166175, NULL, 'G3DSA:3.40.50.300:FF:008441', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166176, NULL, 'G3DSA:1.10.10.60:FF:000050', NULL, NULL, 'LIM homeobox 6', NULL, NULL, NULL, NULL, NULL, 4),
(166177, NULL, 'G3DSA:1.10.150.50:FF:000035', NULL, NULL, 'lethal(3)malignant brain tumor-like protein 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(166178, NULL, 'G3DSA:1.10.167.10:FF:000073', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(166179, NULL, 'G3DSA:3.10.20.310:FF:000008', NULL, NULL, 'Outer membrane protein, OMP85 family', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(166180, NULL, 'G3DSA:1.10.287.130:FF:000039', NULL, NULL, 'Sensor-like histidine kinase YfhK', NULL, NULL, NULL, NULL, NULL, 4),
(166181, NULL, 'G3DSA:2.10.25.10:FF:000544', NULL, NULL, 'Merozoite surface antigen 1', NULL, NULL, NULL, NULL, NULL, 4),
(166182, NULL, 'G3DSA:1.10.287.110:FF:000157', NULL, NULL, 'JJJ3p protein', NULL, NULL, NULL, NULL, NULL, 4),
(166183, NULL, 'G3DSA:1.20.1250.20:FF:001205', NULL, NULL, 'Proline/betaine transporter (ProP)', NULL, NULL, NULL, NULL, NULL, 4),
(166184, NULL, 'G3DSA:3.80.10.10:FF:000465', NULL, NULL, 'NACHT, LRR and PYD domains-containing protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(166185, NULL, 'G3DSA:4.10.400.10:FF:000121', NULL, NULL, 'low-density lipoprotein receptor-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(166186, NULL, 'G3DSA:3.30.590.20:FF:000007', NULL, NULL, 'Glutamate--cysteine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(166187, NULL, 'G3DSA:2.10.25.10:FF:000943', NULL, NULL, 'WNT inhibitory factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(166188, NULL, 'G3DSA:1.50.10.10:FF:000229', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(166189, NULL, 'G3DSA:1.25.40.1040:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166190, NULL, 'G3DSA:1.25.40.10:FF:000357', NULL, NULL, 'Mitochondrial proteins import receptor', NULL, NULL, NULL, NULL, NULL, 4),
(166191, NULL, 'G3DSA:3.90.45.10:FF:000028', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(166192, NULL, 'G3DSA:1.20.1250.20:FF:000929', NULL, NULL, 'Solute carrier family 18 member 2', NULL, NULL, NULL, NULL, NULL, 4),
(166193, NULL, 'G3DSA:3.30.200.20:FF:000709', NULL, NULL, 'Unc-51 like kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(166194, NULL, 'G3DSA:2.60.470.10:FF:000021', NULL, NULL, 'Sodium channel protein Nach', NULL, NULL, NULL, NULL, NULL, 4),
(166195, NULL, 'G3DSA:2.60.40.10:FF:006097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166196, NULL, 'G3DSA:2.180.10.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166197, NULL, 'G3DSA:1.25.40.1030:FF:000003', NULL, NULL, 'Protein transport protein sec16', NULL, NULL, NULL, NULL, NULL, 4),
(166198, NULL, 'G3DSA:3.40.50.620:FF:000494', NULL, NULL, 'GD16539', NULL, NULL, NULL, NULL, NULL, 4),
(166199, NULL, 'G3DSA:1.10.287.70:FF:000791', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166200, NULL, 'G3DSA:1.10.287.110:FF:000033', NULL, NULL, 'dnaJ homolog subfamily B member 13', NULL, NULL, NULL, NULL, NULL, 4),
(166201, NULL, 'G3DSA:3.40.350.10:FF:000030', NULL, NULL, 'Xaa-Pro aminopeptidase app-1', NULL, NULL, NULL, NULL, NULL, 4),
(166202, NULL, 'G3DSA:1.10.510.10:FF:000242', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type 13', NULL, NULL, NULL, NULL, NULL, 4),
(166203, NULL, 'G3DSA:3.80.10.10:FF:002697', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(166204, NULL, 'G3DSA:3.10.490.10:FF:000035', NULL, NULL, 'Histone deacetylase 5', NULL, NULL, NULL, NULL, NULL, 4),
(166205, NULL, 'G3DSA:3.30.420.40:FF:000878', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166206, NULL, 'G3DSA:2.60.40.60:FF:000468', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166207, NULL, 'G3DSA:3.40.309.10:FF:000119', NULL, NULL, 'Os06g0592400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(166208, NULL, 'G3DSA:1.10.10.60:FF:001179', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166209, NULL, 'G3DSA:3.20.20.70:FF:000548', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166210, NULL, 'G3DSA:2.40.50.140:FF:000808', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166211, NULL, 'G3DSA:3.40.50.2300:FF:001508', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166212, NULL, 'G3DSA:1.25.40.10:FF:001897', NULL, NULL, 'U1 small nuclear ribonucleoprotein component, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166213, NULL, 'G3DSA:1.25.40.10:FF:005157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(166214, NULL, 'G3DSA:3.40.190.10:FF:000264', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(166215, NULL, 'G3DSA:3.10.129.10:FF:000269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166216, NULL, 'G3DSA:1.20.1160.20:FF:000006', NULL, NULL, 'Regulator of telomere elongation helicase 1', NULL, NULL, NULL, NULL, NULL, 4),
(166217, NULL, 'G3DSA:3.40.50.300:FF:003641', NULL, NULL, 'DNA double-strand break repair Rad50 ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166218, NULL, 'G3DSA:3.30.160.60:FF:000043', NULL, NULL, 'Scratch family zinc finger 2', NULL, NULL, NULL, NULL, NULL, 4),
(166219, NULL, 'G3DSA:1.10.238.10:FF:001109', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(166220, NULL, 'G3DSA:2.170.15.10:FF:000002', NULL, NULL, 'natterin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(166221, NULL, 'G3DSA:1.10.520.10:FF:000018', NULL, NULL, 'thylakoid lumenal 29 kDa protein, chloroplastic isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(166222, NULL, 'G3DSA:3.30.160.60:FF:000482', NULL, NULL, 'PLAG1 like zinc finger 1', NULL, NULL, NULL, NULL, NULL, 4),
(166223, NULL, 'G3DSA:3.40.1110.10:FF:000073', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(166224, NULL, 'G3DSA:1.25.40.20:FF:000282', NULL, NULL, 'Ankyrin repeat domain-containing protein 13C-A', NULL, NULL, NULL, NULL, NULL, 4),
(166225, NULL, 'G3DSA:3.40.50.1820:FF:000291', NULL, NULL, 'Alpha/beta-Hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(166226, NULL, 'G3DSA:2.60.20.10:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166227, NULL, 'G3DSA:2.60.40.1180:FF:000010', NULL, NULL, 'Glycogen debranching enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(166228, NULL, 'G3DSA:1.10.1200.10:FF:000010', NULL, NULL, 'Acyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(166229, NULL, 'G3DSA:2.60.40.150:FF:000530', NULL, NULL, 'phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit alpha-like', NULL, NULL, NULL, NULL, NULL, 4),
(166230, NULL, 'G3DSA:3.40.50.1440:FF:000154', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(166231, NULL, 'G3DSA:1.25.40.180:FF:000162', NULL, NULL, 'YALI0E24629p', NULL, NULL, NULL, NULL, NULL, 4),
(166232, NULL, 'G3DSA:1.20.5.170:FF:000281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166233, NULL, 'G3DSA:2.20.25.20:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166234, NULL, 'G3DSA:3.30.200.20:FF:000226', NULL, NULL, 'receptor protein kinase TMK1', NULL, NULL, NULL, NULL, NULL, 4),
(166235, NULL, 'G3DSA:3.90.79.20:FF:000025', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(166236, NULL, 'G3DSA:3.50.50.60:FF:000259', NULL, NULL, 'Dihydrolipoamide dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166237, NULL, 'G3DSA:1.10.510.10:FF:003159', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166238, NULL, 'G3DSA:1.10.555.10:FF:000031', NULL, NULL, 'rho GTPase-activating protein 100F isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(166239, NULL, 'G3DSA:1.10.286.20:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166240, NULL, 'G3DSA:3.30.160.60:FF:004860', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166241, NULL, 'G3DSA:1.20.272.10:FF:000034', NULL, NULL, 'Activator 1 40 kDa subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166242, NULL, 'G3DSA:1.25.40.120:FF:000088', NULL, NULL, 'Geranylgeranyl transferase type-2 subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(166243, NULL, 'G3DSA:2.60.120.10:FF:000366', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(166244, NULL, 'G3DSA:3.40.20.10:FF:000035', NULL, NULL, 'Villin-1', NULL, NULL, NULL, NULL, NULL, 4),
(166245, NULL, 'G3DSA:3.30.540.10:FF:000018', NULL, NULL, 'inositol polyphosphate 1-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(166246, NULL, 'G3DSA:3.40.190.10:FF:000747', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(166247, NULL, 'G3DSA:3.30.70.1230:FF:000026', NULL, NULL, 'Guanylyl cyclase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166248, NULL, 'G3DSA:3.40.50.720:FF:002103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166249, NULL, 'G3DSA:2.40.70.10:FF:000035', NULL, NULL, 'Plasmepsin-2', NULL, NULL, NULL, NULL, NULL, 4),
(166250, NULL, 'G3DSA:3.90.190.10:FF:000298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166251, NULL, 'G3DSA:3.30.160.60:FF:000526', NULL, NULL, 'PR domain zinc finger protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(166252, NULL, 'G3DSA:1.10.540.10:FF:000070', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(166253, NULL, 'G3DSA:3.40.50.620:FF:000393', NULL, NULL, 'ATP binding L-PSP endoribonuclease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(166254, NULL, 'G3DSA:1.20.1270.30:FF:000001', NULL, NULL, 'Carbon monoxide dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(166255, NULL, 'G3DSA:3.40.109.10:FF:000008', NULL, NULL, 'Putative NAD(P)H nitroreductase', NULL, NULL, NULL, NULL, NULL, 4),
(166256, NULL, 'G3DSA:2.60.40.10:FF:000077', NULL, NULL, 'Kirre like nephrin family adhesion molecule 3', NULL, NULL, NULL, NULL, NULL, 4),
(166257, NULL, 'G3DSA:1.10.510.10:FF:000372', NULL, NULL, 'MAP3K epsilon protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(166258, NULL, 'G3DSA:3.80.10.10:FF:003214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166259, NULL, 'G3DSA:1.25.40.10:FF:002414', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(166260, NULL, 'G3DSA:1.10.3370.10:FF:000005', NULL, NULL, 'Protein translocase subunit SecY', NULL, NULL, NULL, NULL, NULL, 4),
(166261, NULL, 'G3DSA:2.130.10.10:FF:001999', NULL, NULL, 'Flowering time control protein FY', NULL, NULL, NULL, NULL, NULL, 4),
(166262, NULL, 'G3DSA:3.60.20.10:FF:000225', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166263, NULL, 'G3DSA:1.10.8.60:FF:000520', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(166264, NULL, 'G3DSA:2.130.10.10:FF:003927', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166265, NULL, 'G3DSA:1.50.10.20:FF:000053', NULL, NULL, 'Protein farnesyltransferase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(166266, NULL, 'G3DSA:2.30.22.10:FF:000008', NULL, NULL, 'GrpE protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(166267, NULL, 'G3DSA:3.10.105.10:FF:000029', NULL, NULL, 'Peptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(166268, NULL, 'G3DSA:1.10.560.10:FF:000083', NULL, NULL, 'T-complex protein 1 subunit theta', NULL, NULL, NULL, NULL, NULL, 4),
(166269, NULL, 'G3DSA:1.20.1510.10:FF:000014', NULL, NULL, 'Cation efflux protein/ zinc transporter', NULL, NULL, NULL, NULL, NULL, 4),
(166270, NULL, 'G3DSA:1.10.890.20:FF:000003', NULL, NULL, 'fatty-acid-binding protein 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(166271, NULL, 'G3DSA:1.10.10.10:FF:001917', NULL, NULL, 'Winged-helix DNA-binding transcription factor family protein', NULL, NULL, NULL, NULL, NULL, 4),
(166272, NULL, 'G3DSA:2.40.10.10:FF:000059', NULL, NULL, 'Complement C1s subcomponent', NULL, NULL, NULL, NULL, NULL, 4),
(166273, NULL, 'G3DSA:3.10.20.90:FF:000419', NULL, NULL, 'UBX domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(166274, NULL, 'G3DSA:3.40.50.300:FF:006867', NULL, NULL, 'Uncharacterized ABC transporter ATP-binding protein HI_1470', NULL, NULL, NULL, NULL, NULL, 4),
(166275, NULL, 'G3DSA:3.40.50.620:FF:000763', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166276, NULL, 'G3DSA:2.60.40.10:FF:003792', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166277, NULL, 'G3DSA:3.40.50.720:FF:002575', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166278, NULL, 'G3DSA:1.10.10.10:FF:001434', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(166279, NULL, 'G3DSA:3.40.50.2300:FF:001025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(166280, NULL, 'G3DSA:2.60.120.970:FF:000054', NULL, NULL, 'Bone morphogenetic protein 2a', NULL, NULL, NULL, NULL, NULL, 4),
(166281, NULL, 'G3DSA:2.60.120.200:FF:000773', NULL, NULL, 'Calnexin', NULL, NULL, NULL, NULL, NULL, 4),
(166282, NULL, 'G3DSA:3.20.20.70:FF:000109', NULL, NULL, 'Glutamate synthase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(166283, NULL, 'G3DSA:1.10.10.2050:FF:000002', NULL, NULL, 'tRNA pseudouridine(54/55) synthase', NULL, NULL, NULL, NULL, NULL, 4),
(166284, NULL, 'G3DSA:2.10.110.10:FF:000197', NULL, NULL, 'Transforming growth factor beta 1-induced transcript 1', NULL, NULL, NULL, NULL, NULL, 4),
(166285, NULL, 'G3DSA:3.80.10.10:FF:001269', NULL, NULL, 'Putative RNA-binding protein EEED8.10', NULL, NULL, NULL, NULL, NULL, 4),
(166286, NULL, 'G3DSA:3.30.70.330:FF:001902', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166287, NULL, 'G3DSA:2.30.30.40:FF:000126', NULL, NULL, 'Cytoplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(166288, NULL, 'G3DSA:3.30.420.10:FF:000543', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166289, NULL, 'G3DSA:1.10.418.10:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166290, NULL, 'G3DSA:2.10.70.10:FF:000295', NULL, NULL, 'Complement C1r subcomponent like', NULL, NULL, NULL, NULL, NULL, 4),
(166291, NULL, 'G3DSA:1.10.8.880:FF:000001', NULL, NULL, 'Structural polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(166292, NULL, 'G3DSA:2.30.29.210:FF:000005', NULL, NULL, 'Chromatin-specific transcription elongation factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166293, NULL, 'G3DSA:1.10.8.60:FF:000150', NULL, NULL, 'Replication factor c protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166294, NULL, 'G3DSA:3.40.50.300:FF:006384', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(166295, NULL, 'G3DSA:2.10.25.10:FF:000813', NULL, NULL, 'AAEL001196-PA', NULL, NULL, NULL, NULL, NULL, 4),
(166296, NULL, 'G3DSA:3.80.10.10:FF:000460', NULL, NULL, 'Fibromodulin', NULL, NULL, NULL, NULL, NULL, 4),
(166297, NULL, 'G3DSA:3.90.640.10:FF:000260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166298, NULL, 'G3DSA:1.10.533.10:FF:000306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166299, NULL, 'G3DSA:3.30.160.60:FF:002090', NULL, NULL, 'Zinc finger protein 473', NULL, NULL, NULL, NULL, NULL, 4),
(166300, NULL, 'G3DSA:3.10.250.10:FF:000141', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166301, NULL, 'G3DSA:2.30.29.30:FF:000524', NULL, NULL, 'EXOCyst component', NULL, NULL, NULL, NULL, NULL, 4),
(166302, NULL, 'G3DSA:2.70.170.10:FF:000232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166303, NULL, 'G3DSA:3.30.750.130:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166304, NULL, 'G3DSA:1.25.40.610:FF:000010', NULL, NULL, 'Latrophilin 1', NULL, NULL, NULL, NULL, NULL, 4),
(166305, NULL, 'G3DSA:4.10.1240.10:FF:000021', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor', NULL, NULL, NULL, NULL, NULL, 4),
(166306, NULL, 'G3DSA:1.20.58.60:FF:000833', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166307, NULL, 'G3DSA:2.60.40.10:FF:003803', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166308, NULL, 'G3DSA:1.20.58.390:FF:000144', NULL, NULL, 'Protein CBR-ACR-25', NULL, NULL, NULL, NULL, NULL, 4),
(166309, NULL, 'G3DSA:3.40.30.10:FF:001261', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166310, NULL, 'G3DSA:3.30.160.60:FF:003269', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166311, NULL, 'G3DSA:1.20.1310.10:FF:000033', NULL, NULL, 'Anaphase-promoting complex subunit ApcB', NULL, NULL, NULL, NULL, NULL, 4),
(166312, NULL, 'G3DSA:2.40.70.10:FF:000405', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166313, NULL, 'G3DSA:2.30.29.30:FF:000041', NULL, NULL, 'TBC1 domain family member 9 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(166314, NULL, 'G3DSA:3.40.50.300:FF:005439', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(166315, NULL, 'G3DSA:1.10.287.600:FF:000023', NULL, NULL, 'Alpha-tubulin,putative', NULL, NULL, NULL, NULL, NULL, 4),
(166316, NULL, 'G3DSA:1.20.58.60:FF:000041', NULL, NULL, 'Nesprin-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(166317, NULL, 'G3DSA:3.90.550.10:FF:000022', NULL, NULL, 'Histo-blood group ABO system transferase', NULL, NULL, NULL, NULL, NULL, 4),
(166318, NULL, 'G3DSA:3.30.1120.120:FF:000001', NULL, NULL, 'serine/threonine-protein kinase PLK4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(166319, NULL, 'G3DSA:1.10.1240.100:FF:000004', NULL, NULL, 'Polyketide synthase/nonribosomal peptide synthetase hybrid RzxB', NULL, NULL, NULL, NULL, NULL, 4),
(166320, NULL, 'G3DSA:1.10.510.10:FF:000725', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(166321, NULL, 'G3DSA:1.25.40.10:FF:004331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166322, NULL, 'G3DSA:2.10.220.10:FF:000216', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(166323, NULL, 'G3DSA:1.20.58.390:FF:000014', NULL, NULL, 'Neuronal nicotinic acetylcholine receptor alpha4 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(166324, NULL, 'G3DSA:3.40.50.300:FF:004467', NULL, NULL, 'Replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(166325, NULL, 'G3DSA:1.20.1280.290:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166326, NULL, 'G3DSA:2.130.10.10:FF:005052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166327, NULL, 'G3DSA:3.30.450.200:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166328, NULL, 'G3DSA:3.30.40.10:FF:000722', NULL, NULL, 'Ring-H2 zinc finger protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(166329, NULL, 'G3DSA:1.20.1070.10:FF:001306', NULL, NULL, 'Chemokine (C-X-C motif) receptor 3, tandem duplicate 3', NULL, NULL, NULL, NULL, NULL, 4),
(166330, NULL, 'G3DSA:3.40.30.10:FF:000316', NULL, NULL, 'Peroxiredoxin AHP1', NULL, NULL, NULL, NULL, NULL, 4),
(166331, NULL, 'G3DSA:3.40.50.410:FF:000346', NULL, NULL, 'Proteasome 26S subunit, non-ATPase 4', NULL, NULL, NULL, NULL, NULL, 4),
(166332, NULL, 'G3DSA:4.10.60.10:FF:000126', NULL, NULL, 'Serine and arginine-rich-splicing factor 7a', NULL, NULL, NULL, NULL, NULL, 4),
(166333, NULL, 'G3DSA:2.60.200.20:FF:000257', NULL, NULL, 'SMAD/FHA domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(166334, NULL, 'G3DSA:3.80.10.10:FF:003523', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166335, NULL, 'G3DSA:3.30.2410.10:FF:000048', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(166336, NULL, 'G3DSA:2.60.120.380:FF:000091', NULL, NULL, 'Thermostable beta-glucosidase B', NULL, NULL, NULL, NULL, NULL, 4),
(166337, NULL, 'G3DSA:2.60.120.260:FF:000212', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(166338, NULL, 'G3DSA:1.10.10.10:FF:001125', NULL, NULL, 'Two-component response regulator YrkQ', NULL, NULL, NULL, NULL, NULL, 4),
(166339, NULL, 'G3DSA:1.25.10.10:FF:003194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166340, NULL, 'G3DSA:2.60.40.10:FF:000414', NULL, NULL, 'Interleukin-6 receptor subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(166341, NULL, 'G3DSA:3.40.50.360:FF:000163', NULL, NULL, 'S-adenosyl-L-methionine-dependent tRNA 4-demethylwyosine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(166342, NULL, 'G3DSA:1.10.472.80:FF:000067', NULL, NULL, 'GTPase-activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166343, NULL, 'G3DSA:1.10.150.240:FF:000112', NULL, NULL, 'HAD hydrolase, family IA, variant 3', NULL, NULL, NULL, NULL, NULL, 4),
(166344, NULL, 'G3DSA:3.20.20.330:FF:000017', NULL, NULL, 'S-adenosylmethionine-homocysteine S-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(166345, NULL, 'G3DSA:1.20.58.80:FF:000047', NULL, NULL, 'Endosomal AAA ATPase-like protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(166346, NULL, 'G3DSA:1.10.510.10:FF:001361', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166347, NULL, 'G3DSA:1.10.630.10:FF:000791', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(166348, NULL, 'G3DSA:3.40.640.10:FF:000046', NULL, NULL, 'Cystathionine gamma-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(166349, NULL, 'G3DSA:3.40.50.300:FF:005878', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(166350, NULL, 'G3DSA:2.130.10.10:FF:000381', NULL, NULL, 'WD repeat-containing protein 48', NULL, NULL, NULL, NULL, NULL, 4),
(166351, NULL, 'G3DSA:1.10.860.10:FF:000009', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(166352, NULL, 'G3DSA:2.40.50.140:FF:000016', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(166353, NULL, 'G3DSA:3.30.760.10:FF:000029', NULL, NULL, 'Eukaryotic translation initiation factor 4E, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166354, NULL, 'G3DSA:1.10.10.10:FF:002070', NULL, NULL, 'ETS proto-oncogene 2, transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(166355, NULL, 'G3DSA:1.20.1070.10:FF:001615', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166356, NULL, 'G3DSA:3.80.10.10:FF:004512', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166357, NULL, 'G3DSA:3.40.50.2000:FF:000699', NULL, NULL, 'Mannosyltransferase B', NULL, NULL, NULL, NULL, NULL, 4),
(166358, NULL, 'G3DSA:2.130.10.10:FF:000690', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(166359, NULL, 'G3DSA:3.40.50.1450:FF:000011', NULL, NULL, 'Hydrogenase formation/expression factor related protein', NULL, NULL, NULL, NULL, NULL, 4),
(166360, NULL, 'G3DSA:3.90.15.10:FF:000015', NULL, NULL, 'DNA topoisomerase I mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(166361, NULL, 'G3DSA:1.10.3720.10:FF:000033', NULL, NULL, 'Polar amino acid ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(166362, NULL, 'G3DSA:2.70.98.10:FF:000013', NULL, NULL, 'Putative alpha-1,2-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(166363, NULL, 'G3DSA:1.10.760.10:FF:000081', NULL, NULL, 'Cytochrome C-550', NULL, NULL, NULL, NULL, NULL, 4),
(166364, NULL, 'G3DSA:3.30.60.20:FF:000142', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(166365, NULL, 'G3DSA:1.10.287.470:FF:000045', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(166366, NULL, 'G3DSA:2.10.25.10:FF:000460', NULL, NULL, 'Laminin subunit alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(166367, NULL, 'G3DSA:3.90.1290.10:FF:000001', NULL, NULL, 'Plectin a', NULL, NULL, NULL, NULL, NULL, 4),
(166368, NULL, 'G3DSA:1.20.120.350:FF:000002', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(166369, NULL, 'G3DSA:2.40.420.20:FF:000019', NULL, NULL, 'Efflux transporter, RND family, MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(166370, NULL, 'G3DSA:1.20.1070.10:FF:001295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166371, NULL, 'G3DSA:1.25.10.10:FF:002103', NULL, NULL, 'Zyg-11 family member A, cell cycle regulator', NULL, NULL, NULL, NULL, NULL, 4),
(166372, NULL, 'G3DSA:2.130.10.10:FF:004063', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(166373, NULL, 'G3DSA:2.130.10.10:FF:004433', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166374, NULL, 'G3DSA:2.130.10.10:FF:000701', NULL, NULL, 'Protein HIR', NULL, NULL, NULL, NULL, NULL, 4),
(166375, NULL, 'G3DSA:3.30.160.60:FF:004225', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166376, NULL, 'G3DSA:3.30.830.10:FF:000254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166377, NULL, 'G3DSA:3.20.20.140:FF:000197', NULL, NULL, 'Ribonuclease P protein subunit p30, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166378, NULL, 'G3DSA:3.20.20.80:FF:000438', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166379, NULL, 'G3DSA:1.10.238.10:FF:001098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(166380, NULL, 'G3DSA:3.40.1380.20:FF:000005', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(166381, NULL, 'G3DSA:3.60.130.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166382, NULL, 'G3DSA:3.50.50.80:FF:000006', NULL, NULL, 'SUMO-activating enzyme subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(166383, NULL, 'G3DSA:3.30.70.1730:FF:000070', NULL, NULL, '50S ribosomal protein L10', NULL, NULL, NULL, NULL, NULL, 4),
(166384, NULL, 'G3DSA:3.20.20.80:FF:000068', NULL, NULL, 'hexosaminidase D isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(166385, NULL, 'G3DSA:1.10.10.10:FF:000136', NULL, NULL, 'ETS homologous factor isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(166386, NULL, 'G3DSA:1.10.510.10:FF:003598', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166387, NULL, 'G3DSA:3.40.50.2300:FF:001497', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166388, NULL, 'G3DSA:2.20.100.10:FF:000087', NULL, NULL, 'Complement component C6', NULL, NULL, NULL, NULL, NULL, 4),
(166389, NULL, 'G3DSA:3.30.1520.10:FF:000056', NULL, NULL, 'Phosphoinositide-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166390, NULL, 'G3DSA:1.10.1900.10:FF:000001', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(166391, NULL, 'G3DSA:1.10.10.10:FF:000506', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(166392, NULL, 'G3DSA:3.30.930.10:FF:000301', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(166393, NULL, 'G3DSA:1.10.10.60:FF:000370', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(166394, NULL, 'G3DSA:1.10.800.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166395, NULL, 'G3DSA:3.20.20.60:FF:000062', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(166396, NULL, 'G3DSA:2.60.40.10:FF:000869', NULL, NULL, 'Protein tyrosine phosphatase, receptor type Q', NULL, NULL, NULL, NULL, NULL, 4),
(166397, NULL, 'G3DSA:3.80.10.10:FF:002258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166398, NULL, 'G3DSA:2.60.120.290:FF:000064', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(166399, NULL, 'G3DSA:2.60.120.260:FF:000521', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(166400, NULL, 'G3DSA:2.60.220.50:FF:000155', NULL, NULL, 'Adhesion G protein-coupled receptor E1', NULL, NULL, NULL, NULL, NULL, 4),
(166401, NULL, 'G3DSA:2.105.10.10:FF:000001', NULL, NULL, 'Adsorption protein P2', NULL, NULL, NULL, NULL, NULL, 4),
(166402, NULL, 'G3DSA:1.25.10.10:FF:001614', NULL, NULL, 'Proteasome/cyclosome repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(166403, NULL, 'G3DSA:3.40.50.300:FF:001696', NULL, NULL, 'Dynamin-3', NULL, NULL, NULL, NULL, NULL, 4),
(166404, NULL, 'G3DSA:3.30.70.100:FF:000153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166405, NULL, 'G3DSA:3.40.80.10:FF:000044', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(166406, NULL, 'G3DSA:3.40.50.1000:FF:000106', NULL, NULL, 'Beta-phosphoglucomutase', NULL, NULL, NULL, NULL, NULL, 4),
(166407, NULL, 'G3DSA:3.30.40.10:FF:001211', NULL, NULL, 'ENOS interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(166408, NULL, 'G3DSA:2.40.128.20:FF:000003', NULL, NULL, 'Apolipoprotein D', NULL, NULL, NULL, NULL, NULL, 4),
(166409, NULL, 'G3DSA:3.30.70.330:FF:000593', NULL, NULL, 'Serrate RNA effector molecule homolog', NULL, NULL, NULL, NULL, NULL, 4),
(166410, NULL, 'G3DSA:2.30.30.140:FF:000043', NULL, NULL, 'PHD finger protein 20 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(166411, NULL, 'G3DSA:3.90.1030.10:FF:000027', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(166412, NULL, 'G3DSA:3.30.70.330:FF:001082', NULL, NULL, 'RNA-binding protein 38', NULL, NULL, NULL, NULL, NULL, 4),
(166413, NULL, 'G3DSA:1.10.510.10:FF:001670', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 9', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(166414, NULL, 'G3DSA:2.60.40.150:FF:000221', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(166415, NULL, 'G3DSA:3.30.160.60:FF:004208', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166416, NULL, 'G3DSA:1.20.1070.10:FF:001278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166417, NULL, 'G3DSA:1.20.5.620:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166418, NULL, 'G3DSA:1.10.287.1130:FF:000008', NULL, NULL, 'Cx9C motif-containing protein 4, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(166419, NULL, 'G3DSA:1.10.510.10:FF:004087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166420, NULL, 'G3DSA:2.30.30.360:FF:000007', NULL, NULL, 'Myosin-2 heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(166421, NULL, 'G3DSA:3.30.70.340:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166422, NULL, 'G3DSA:1.10.10.720:FF:000002', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(166423, NULL, 'G3DSA:3.30.1640.10:FF:000003', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(166424, NULL, 'G3DSA:1.10.10.60:FF:000499', NULL, NULL, 'Siamois homeodomain 1', NULL, NULL, NULL, NULL, NULL, 4),
(166425, NULL, 'G3DSA:3.40.50.10190:FF:000260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166426, NULL, 'G3DSA:2.40.50.140:FF:000590', NULL, NULL, 'Single-stranded DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(166427, NULL, 'G3DSA:3.30.70.360:FF:000017', NULL, NULL, 'Amidohydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166428, NULL, 'G3DSA:3.30.70.260:FF:000105', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(166429, NULL, 'G3DSA:3.30.40.10:FF:001548', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166430, NULL, 'G3DSA:3.30.70.330:FF:003010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166431, NULL, 'G3DSA:3.20.20.80:FF:000085', NULL, NULL, 'Poly-beta-1,6-N-acetyl-D-glucosamine N-deacetylase PgaB', NULL, NULL, NULL, NULL, NULL, 4),
(166432, NULL, 'G3DSA:3.80.10.10:FF:002567', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166433, NULL, 'G3DSA:3.40.50.1110:FF:000139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166434, NULL, 'G3DSA:1.10.8.60:FF:000503', NULL, NULL, 'Uncharacterized AAA domain-containing protein C24B10.10c', NULL, NULL, NULL, NULL, NULL, 4),
(166435, NULL, 'G3DSA:1.25.40.10:FF:002061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166436, NULL, 'G3DSA:2.40.10.10:FF:000076', NULL, NULL, 'Structural polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(166437, NULL, 'G3DSA:1.20.1510.10:FF:000031', NULL, NULL, 'Zinc transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166438, NULL, 'G3DSA:3.30.1370.10:FF:000139', NULL, NULL, 'Exosome complex exonuclease RRP40, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166439, NULL, 'G3DSA:2.30.29.30:FF:000833', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166440, NULL, 'G3DSA:3.40.1160.10:FF:000104', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(166441, NULL, 'G3DSA:3.40.50.150:FF:000229', NULL, NULL, 'tRNA methyltransferase 2 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(166442, NULL, 'G3DSA:2.60.40.10:FF:004129', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166443, NULL, 'G3DSA:2.130.10.10:FF:001218', NULL, NULL, 'TEP1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(166444, NULL, 'G3DSA:3.80.10.10:FF:001286', NULL, NULL, 'Leucine rich repeat and phosphatase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(166445, NULL, 'G3DSA:1.20.120.1630:FF:000005', NULL, NULL, 'Phosphatidylethanolamine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(166446, NULL, 'G3DSA:2.130.10.10:FF:003944', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166447, NULL, 'G3DSA:3.30.420.10:FF:000560', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166448, NULL, 'G3DSA:1.25.10.10:FF:000760', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(166449, NULL, 'G3DSA:1.20.1560.10:FF:000197', NULL, NULL, 'AGAP009835-PA', NULL, NULL, NULL, NULL, NULL, 4),
(166450, NULL, 'G3DSA:2.60.40.150:FF:000058', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(166451, NULL, 'G3DSA:2.30.30.90:FF:000017', NULL, NULL, 'Iron dependent repressor', NULL, NULL, NULL, NULL, NULL, 4),
(166452, NULL, 'G3DSA:3.40.50.1000:FF:000045', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(166453, NULL, 'G3DSA:3.40.720.10:FF:000108', NULL, NULL, 'Arylsulfatase A [precursor]', NULL, NULL, NULL, NULL, NULL, 4),
(166454, NULL, 'G3DSA:1.10.472.80:FF:000128', NULL, NULL, 'Rab GTPase activator', NULL, NULL, NULL, NULL, NULL, 4),
(166455, NULL, 'G3DSA:3.30.160.60:FF:002308', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166456, NULL, 'G3DSA:2.10.90.10:FF:000178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166457, NULL, 'G3DSA:3.40.50.300:FF:007795', NULL, NULL, 'Si:ch211-247i17.1', NULL, NULL, NULL, NULL, NULL, 4),
(166458, NULL, 'G3DSA:1.25.40.10:FF:005287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166459, NULL, 'G3DSA:2.60.40.10:FF:000386', NULL, NULL, 'Cytokine receptor like factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(166460, NULL, 'G3DSA:3.20.20.80:FF:000568', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166461, NULL, 'G3DSA:1.10.30.10:FF:000019', NULL, NULL, 'nucleolar transcription factor 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(166462, NULL, 'G3DSA:2.40.10.10:FF:000368', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166463, NULL, 'G3DSA:3.90.640.10:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166464, NULL, 'G3DSA:3.20.20.370:FF:000018', NULL, NULL, 'ChbG/HpnK family deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(166465, NULL, 'G3DSA:1.20.1250.20:FF:001250', NULL, NULL, 'Polyamine transport-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166466, NULL, 'G3DSA:2.60.40.10:FF:003820', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166467, NULL, 'G3DSA:1.10.630.10:FF:000217', NULL, NULL, 'Os08g0105600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(166468, NULL, 'G3DSA:3.40.50.2300:FF:000671', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166469, NULL, 'G3DSA:3.10.290.60:FF:000006', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(166470, NULL, 'G3DSA:1.20.1070.10:FF:000659', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(166471, NULL, 'G3DSA:2.40.70.10:FF:000052', NULL, NULL, 'ASpartyl Protease', NULL, NULL, NULL, NULL, NULL, 4),
(166472, NULL, 'G3DSA:3.30.1490.480:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166473, NULL, 'G3DSA:2.60.40.2240:FF:000008', NULL, NULL, 'bile acid-CoA:amino acid N-acyltransferase isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(166474, NULL, 'G3DSA:2.20.100.10:FF:000115', NULL, NULL, 'Thrombospondin type-1 domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(166475, NULL, 'G3DSA:1.10.510.10:FF:000742', NULL, NULL, 'Serine/threonine-protein kinase atg1', NULL, NULL, NULL, NULL, NULL, 4),
(166476, NULL, 'G3DSA:1.10.10.10:FF:000006', NULL, NULL, 'cAMP-activated global transcriptional regulator CRP', NULL, NULL, NULL, NULL, NULL, 4),
(166477, NULL, 'G3DSA:3.60.40.10:FF:000108', NULL, NULL, 'Protein phosphatase 2C', NULL, NULL, NULL, NULL, NULL, 4),
(166478, NULL, 'G3DSA:1.10.238.20:FF:000027', NULL, NULL, 'General odorant-binding protein 84a', NULL, NULL, NULL, NULL, NULL, 4),
(166479, NULL, 'G3DSA:3.90.70.10:FF:000148', NULL, NULL, 'Alpha-hemolysin translocation ATP-binding protein HlyB', NULL, NULL, NULL, NULL, NULL, 4),
(166480, NULL, 'G3DSA:3.30.110.80:FF:000001', NULL, NULL, 'DNA double-strand break repair protein Mre11', NULL, NULL, NULL, NULL, NULL, 4),
(166481, NULL, 'G3DSA:3.30.450.20:FF:000357', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(166482, NULL, 'G3DSA:3.10.450.60:FF:000008', NULL, NULL, 'Arachidonate 12-lipoxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(166483, NULL, 'G3DSA:2.60.40.60:FF:000159', NULL, NULL, 'cadherin-16 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(166484, NULL, 'G3DSA:1.10.150.80:FF:000038', NULL, NULL, 'Ribonuclease D', NULL, NULL, NULL, NULL, NULL, 4),
(166485, NULL, 'G3DSA:1.10.510.10:FF:003468', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166486, NULL, 'G3DSA:3.40.720.10:FF:000210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166487, NULL, 'G3DSA:1.10.1070.11:FF:000062', NULL, NULL, 'Phosphatidylinositol 3-and 4-kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166488, NULL, 'G3DSA:3.30.70.330:FF:000093', NULL, NULL, 'Putative DAZ-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(166489, NULL, 'G3DSA:2.40.50.1060:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166490, NULL, 'G3DSA:3.40.1110.10:FF:000056', NULL, NULL, 'Copper-exporting P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(166491, NULL, 'G3DSA:3.40.50.300:FF:007356', NULL, NULL, 'AGAP012289-PA', NULL, NULL, NULL, NULL, NULL, 4),
(166492, NULL, 'G3DSA:3.20.20.140:FF:000067', NULL, NULL, 'Adenine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(166493, NULL, 'G3DSA:3.30.40.10:FF:002167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166494, NULL, 'G3DSA:1.25.40.20:FF:000265', NULL, NULL, 'ASPG isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(166495, NULL, 'G3DSA:2.130.10.10:FF:005844', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166496, NULL, 'G3DSA:2.60.40.10:FF:004000', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166497, NULL, 'G3DSA:2.170.260.10:FF:000018', NULL, NULL, 'Endoribonuclease Dicer', NULL, NULL, NULL, NULL, NULL, 4),
(166498, NULL, 'G3DSA:3.40.50.2000:FF:000199', NULL, NULL, 'UDP-glycosyltransferase 76C1', NULL, NULL, NULL, NULL, NULL, 4),
(166499, NULL, 'G3DSA:3.30.200.20:FF:000209', NULL, NULL, 'MAP kinase-activated protein kinase 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(166500, NULL, 'G3DSA:2.60.40.1710:FF:000001', NULL, NULL, 'Cell wall-associated serine proteinase', NULL, NULL, NULL, NULL, NULL, 4),
(166501, NULL, 'G3DSA:3.30.565.10:FF:000233', NULL, NULL, 'Two-component sensor EnvZ', NULL, NULL, NULL, NULL, NULL, 4),
(166502, NULL, 'G3DSA:1.25.40.10:FF:001442', NULL, NULL, 'Os11g0483950 protein', NULL, NULL, NULL, NULL, NULL, 4),
(166503, NULL, 'G3DSA:3.30.160.60:FF:002151', NULL, NULL, 'Zinc finger protein 670', NULL, NULL, NULL, NULL, NULL, 4),
(166504, NULL, 'G3DSA:3.30.160.60:FF:000173', NULL, NULL, 'Mds1 and evi1 complex locus protein', NULL, NULL, NULL, NULL, NULL, 4),
(166505, NULL, 'G3DSA:1.10.860.10:FF:000026', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(166506, NULL, 'G3DSA:1.20.1050.40:FF:000010', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(166507, NULL, 'G3DSA:2.60.40.10:FF:005720', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166508, NULL, 'G3DSA:3.40.1490.10:FF:000005', NULL, NULL, 'Peptidyl-tRNA hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(166509, NULL, 'G3DSA:1.10.630.10:FF:000689', NULL, NULL, 'Os03g0850200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(166510, NULL, 'G3DSA:3.40.50.720:FF:002120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166511, NULL, 'G3DSA:1.10.555.10:FF:000014', NULL, NULL, 'Rho GTPase activating protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(166512, NULL, 'G3DSA:3.30.200.20:FF:001154', NULL, NULL, 'Serine/threonine-protein kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(166513, NULL, 'G3DSA:2.60.120.590:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166514, NULL, 'G3DSA:3.80.10.10:FF:003186', NULL, NULL, 'Protein CBR-GADR-3', NULL, NULL, NULL, NULL, NULL, 4),
(166515, NULL, 'G3DSA:3.30.450.20:FF:000065', NULL, NULL, 'probable G-protein coupled receptor 158', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(166516, NULL, 'G3DSA:3.10.450.40:FF:000002', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(166517, NULL, 'G3DSA:4.10.280.10:FF:000223', NULL, NULL, 'uncharacterized protein LOC100176581', NULL, NULL, NULL, NULL, NULL, 4),
(166518, NULL, 'G3DSA:3.40.50.300:FF:005895', NULL, NULL, 'GTPase HflX', NULL, NULL, NULL, NULL, NULL, 4),
(166519, NULL, 'G3DSA:3.30.1490.80:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166520, NULL, 'G3DSA:3.60.21.10:FF:000216', NULL, NULL, 'Sphingomyelin phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(166521, NULL, 'G3DSA:3.30.40.10:FF:000222', NULL, NULL, 'E3 ubiquitin-protein ligase COP1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(166522, NULL, 'G3DSA:3.90.550.10:FF:000152', NULL, NULL, 'Glycosyltransferases', NULL, NULL, NULL, NULL, NULL, 4),
(166523, NULL, 'G3DSA:1.20.1720.10:FF:000069', NULL, NULL, 'Multidrug resistance protein B', NULL, NULL, NULL, NULL, NULL, 4),
(166524, NULL, 'G3DSA:2.130.10.10:FF:001662', NULL, NULL, 'CPSF_A_subunit_region_containing_protein', NULL, NULL, NULL, NULL, NULL, 4),
(166525, NULL, 'G3DSA:3.30.40.10:FF:001650', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(166526, NULL, 'G3DSA:3.30.40.100:FF:000006', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(166527, NULL, 'G3DSA:2.60.40.10:FF:001566', NULL, NULL, 'collagen alpha-1(VII) chain isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(166528, NULL, 'G3DSA:1.25.10.10:FF:002603', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166529, NULL, 'G3DSA:2.10.25.10:FF:000443', NULL, NULL, 'Coagulation factor X', NULL, NULL, NULL, NULL, NULL, 4),
(166530, NULL, 'G3DSA:3.30.60.30:FF:000128', NULL, NULL, 'MIP10102p', NULL, NULL, NULL, NULL, NULL, 4),
(166531, NULL, 'G3DSA:2.60.120.290:FF:000108', NULL, NULL, 'SOL-1 related protein', NULL, NULL, NULL, NULL, NULL, 4),
(166532, NULL, 'G3DSA:1.10.300.10:FF:000007', NULL, NULL, 'Adenylosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(166533, NULL, 'G3DSA:2.60.40.10:FF:003483', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166534, NULL, 'G3DSA:3.10.20.90:FF:000728', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166535, NULL, 'G3DSA:3.40.800.20:FF:000040', NULL, NULL, 'Histone deacetylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(166536, NULL, 'G3DSA:1.10.10.1050:FF:000011', NULL, NULL, 'mRNA-decapping enzyme 2', NULL, NULL, NULL, NULL, NULL, 4),
(166537, NULL, 'G3DSA:2.60.40.2220:FF:000002', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(166538, NULL, 'G3DSA:2.120.10.30:FF:000426', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166539, NULL, 'G3DSA:3.30.900.10:FF:000018', NULL, NULL, 'Putative mitotic spindle checkpoint component', NULL, NULL, NULL, NULL, NULL, 4),
(166540, NULL, 'G3DSA:2.20.70.10:FF:000215', NULL, NULL, 'WW domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166541, NULL, 'G3DSA:2.40.30.10:FF:000061', NULL, NULL, 'Translation release factor eRF3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166542, NULL, 'G3DSA:3.30.1480.10:FF:000001', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(166543, NULL, 'G3DSA:3.40.50.300:FF:006075', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(166544, NULL, 'G3DSA:1.25.40.20:FF:000826', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166545, NULL, 'G3DSA:1.25.40.60:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166546, NULL, 'G3DSA:1.10.400.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166547, NULL, 'G3DSA:3.60.20.10:FF:000208', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166548, NULL, 'G3DSA:1.25.10.10:FF:000788', NULL, NULL, 'E3 ubiquitin-protein ligase UPL1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(166549, NULL, 'G3DSA:3.30.200.20:FF:001715', NULL, NULL, 'Mitogen-activated protein kinase 15', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(166550, NULL, 'G3DSA:1.10.287.470:FF:000028', NULL, NULL, 'Probable RND efflux membrane fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(166551, NULL, 'G3DSA:1.25.40.10:FF:001925', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g04750, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(166552, NULL, 'G3DSA:2.60.40.4220:FF:000001', NULL, NULL, 'Lectin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(166553, NULL, 'G3DSA:2.70.160.11:FF:000064', NULL, NULL, 'protein arginine N-methyltransferase 6', NULL, NULL, NULL, NULL, NULL, 4),
(166554, NULL, 'G3DSA:1.25.40.10:FF:002723', NULL, NULL, 'Sel1 repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166555, NULL, 'G3DSA:2.60.34.10:FF:000001', NULL, NULL, 'Molecular chaperone DnaK', NULL, NULL, NULL, NULL, NULL, 4),
(166556, NULL, 'G3DSA:1.10.630.10:FF:000661', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166557, NULL, 'G3DSA:1.10.510.10:FF:002979', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166558, NULL, 'G3DSA:2.20.25.290:FF:000001', NULL, NULL, 'Protein kinase AMP-activated non-catalytic subunit beta 2', NULL, NULL, NULL, NULL, NULL, 4),
(166559, NULL, 'G3DSA:3.90.650.10:FF:000069', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(166560, NULL, 'G3DSA:2.60.40.10:FF:002331', NULL, NULL, 'Myotactin form A', NULL, NULL, NULL, NULL, NULL, 4),
(166561, NULL, 'G3DSA:3.90.132.10:FF:000012', NULL, NULL, 'GP63-like', NULL, NULL, NULL, NULL, NULL, 4),
(166562, NULL, 'G3DSA:4.10.400.10:FF:000312', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(166563, NULL, 'G3DSA:2.10.60.10:FF:000058', NULL, NULL, 'Serine/threonine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(166564, NULL, 'G3DSA:1.10.10.10:FF:000153', NULL, NULL, 'LuxR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(166565, NULL, 'G3DSA:1.10.8.60:FF:000048', NULL, NULL, 'Katanin p60 ATPase-containing subunit A-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(166566, NULL, 'G3DSA:3.40.50.150:FF:000690', NULL, NULL, 'SAM-dependent methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(166567, NULL, 'G3DSA:3.40.50.10140:FF:000026', NULL, NULL, 'Toll-like receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(166568, NULL, 'G3DSA:4.10.400.10:FF:000088', NULL, NULL, 'Heparan sulfate proteoglycan 2', NULL, NULL, NULL, NULL, NULL, 4),
(166569, NULL, 'G3DSA:1.10.20.10:FF:000081', NULL, NULL, 'Histone H3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166570, NULL, 'G3DSA:3.30.450.290:FF:000003', NULL, NULL, 'Sensor histidine kinase response regulator, DUF3365, PAS, PAS and Hpt domain-containing, heme-binding', NULL, NULL, NULL, NULL, NULL, 4),
(166571, NULL, 'G3DSA:3.90.810.10:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166572, NULL, 'G3DSA:1.10.1450.10:FF:000039', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(166573, NULL, 'G3DSA:3.30.420.40:FF:000086', NULL, NULL, 'Glycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(166574, NULL, 'G3DSA:3.90.550.10:FF:000461', NULL, NULL, '2-C-methyl-D-erythritol 4-phosphate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(166575, NULL, 'G3DSA:1.20.58.1100:FF:000007', NULL, NULL, 'Protein unc-13 B', NULL, NULL, NULL, NULL, NULL, 4),
(166576, NULL, 'G3DSA:3.30.1490.70:FF:000014', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(166577, NULL, 'G3DSA:1.10.287.110:FF:000281', NULL, NULL, 'DnaJ-like chaperone, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166578, NULL, 'G3DSA:1.20.1270.10:FF:000006', NULL, NULL, 'Chaperone protein HscA', NULL, NULL, NULL, NULL, NULL, 4),
(166579, NULL, 'G3DSA:1.50.40.10:FF:000344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166580, NULL, 'G3DSA:3.40.50.10470:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166581, NULL, 'G3DSA:3.30.450.20:FF:000048', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(166582, NULL, 'G3DSA:1.20.1640.10:FF:000035', NULL, NULL, 'PaTched Related family', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(166583, NULL, 'G3DSA:3.30.160.60:FF:005978', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166584, NULL, 'G3DSA:3.40.50.1010:FF:000126', NULL, NULL, 'Putative rrp44p homologue', NULL, NULL, NULL, NULL, NULL, 4),
(166585, NULL, 'G3DSA:3.40.50.12120:FF:000002', NULL, NULL, 'Proteasome biogenesis-associated', NULL, NULL, NULL, NULL, NULL, 4),
(166586, NULL, 'G3DSA:1.20.5.3310:FF:000001', NULL, NULL, 'Probable Sec-independent protein translocase protein TatE', NULL, NULL, NULL, NULL, NULL, 4),
(166587, NULL, 'G3DSA:1.20.1070.10:FF:001323', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166588, NULL, 'G3DSA:1.10.418.10:FF:000235', NULL, NULL, 'DIX domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(166589, NULL, 'G3DSA:3.30.70.330:FF:001065', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(166590, NULL, 'G3DSA:3.30.9.10:FF:000189', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(166591, NULL, 'G3DSA:1.20.58.1120:FF:000018', NULL, NULL, 'Dynein heavy chain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(166592, NULL, 'G3DSA:1.10.569.10:FF:000001', NULL, NULL, 'Aldehyde:ferredoxin oxidoreductase, tungsten-containing', NULL, NULL, NULL, NULL, NULL, 4),
(166593, NULL, 'G3DSA:1.20.5.340:FF:000062', NULL, NULL, 'Protein CBR-MYO-2', NULL, NULL, NULL, NULL, NULL, 4),
(166594, NULL, 'G3DSA:3.40.140.10:FF:000244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166595, NULL, 'G3DSA:3.40.50.720:FF:001614', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166596, NULL, 'G3DSA:1.25.10.10:FF:000125', NULL, NULL, 'cytosolic carboxypeptidase 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(166597, NULL, 'G3DSA:3.30.70.330:FF:000576', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(166598, NULL, 'G3DSA:3.30.505.10:FF:000257', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166599, NULL, 'G3DSA:3.40.50.10810:FF:000143', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit E', NULL, NULL, NULL, NULL, NULL, 4),
(166600, NULL, 'G3DSA:3.20.20.190:FF:000149', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166601, NULL, 'G3DSA:2.20.50.20:FF:000009', NULL, NULL, 'Apolipophorin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(166602, NULL, 'G3DSA:3.30.1330.30:FF:000120', NULL, NULL, 'ADL269Wp', NULL, NULL, NULL, NULL, NULL, 4),
(166603, NULL, 'G3DSA:3.40.50.300:FF:005456', NULL, NULL, 'ATP-binding cassette sub-family F member 1', NULL, NULL, NULL, NULL, NULL, 4),
(166604, NULL, 'G3DSA:2.60.40.60:FF:001087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166605, NULL, 'G3DSA:3.30.70.3490:FF:000024', NULL, NULL, 'Oxysterol Binding protein (OSBP) Related', NULL, NULL, NULL, NULL, NULL, 4),
(166606, NULL, 'G3DSA:3.90.550.10:FF:000005', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(166607, NULL, 'G3DSA:3.40.50.1820:FF:001572', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(166608, NULL, 'G3DSA:1.10.1200.270:FF:000002', NULL, NULL, 'indole-3-acetate O-methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(166609, NULL, 'G3DSA:1.25.40.10:FF:003342', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g49710', NULL, NULL, NULL, NULL, NULL, 4),
(166610, NULL, 'G3DSA:2.30.29.30:FF:001030', NULL, NULL, 'FERM domain-containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(166611, NULL, 'G3DSA:3.30.1360.120:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166612, NULL, 'G3DSA:3.90.260.10:FF:000034', NULL, NULL, 'DNA repair protein Rad4 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(166613, NULL, 'G3DSA:3.60.10.10:FF:000270', NULL, NULL, 'DNA-(apurinic or apyrimidinic site) lyase', NULL, NULL, NULL, NULL, NULL, 4),
(166614, NULL, 'G3DSA:3.30.160.60:FF:000026', NULL, NULL, 'Transcription factor Sp3', NULL, NULL, NULL, NULL, NULL, 4),
(166615, NULL, 'G3DSA:1.25.10.10:FF:001277', NULL, NULL, 'AGAP001820-PA', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(166616, NULL, 'G3DSA:1.10.3430.10:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166617, NULL, 'G3DSA:1.10.510.10:FF:002642', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166618, NULL, 'G3DSA:3.40.50.200:FF:000059', NULL, NULL, 'Clan SB, family S8, subtilisin-like serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(166619, NULL, 'G3DSA:3.30.160.60:FF:006203', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166620, NULL, 'G3DSA:2.60.40.10:FF:005618', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166621, NULL, 'G3DSA:1.20.58.920:FF:000005', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(166622, NULL, 'G3DSA:1.20.1070.10:FF:000789', NULL, NULL, 'Probable G-protein coupled receptor AH9.4', NULL, NULL, NULL, NULL, NULL, 4),
(166623, NULL, 'G3DSA:2.30.42.10:FF:000010', NULL, NULL, 'Neurabin-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(166624, NULL, 'G3DSA:2.30.30.40:FF:000598', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166625, NULL, 'G3DSA:2.20.25.10:FF:000010', NULL, NULL, 'Two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(166626, NULL, 'G3DSA:3.10.290.10:FF:000054', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(166627, NULL, 'G3DSA:3.40.50.800:FF:000031', NULL, NULL, 'Threonine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(166628, NULL, 'G3DSA:3.30.200.20:FF:002334', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166629, NULL, 'G3DSA:2.60.40.150:FF:000513', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166630, NULL, 'G3DSA:2.160.20.10:FF:000195', NULL, NULL, 'F-box only protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(166631, NULL, 'G3DSA:3.60.21.10:FF:000396', NULL, NULL, 'Sphingomyelin phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(166632, NULL, 'G3DSA:3.40.930.10:FF:000001', NULL, NULL, 'Anion exchange protein', NULL, NULL, NULL, NULL, NULL, 4),
(166633, NULL, 'G3DSA:3.40.50.80:FF:000086', NULL, NULL, 'NADPH-dependent ferric siderophore reductase', NULL, NULL, NULL, NULL, NULL, 4),
(166634, NULL, 'G3DSA:3.90.70.80:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166635, NULL, 'G3DSA:3.20.20.70:FF:000211', NULL, NULL, 'Nitronate monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(166636, NULL, 'G3DSA:3.30.420.10:FF:000690', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166637, NULL, 'G3DSA:3.30.160.60:FF:005714', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166638, NULL, 'G3DSA:2.40.128.50:FF:000001', NULL, NULL, 'D-aminopeptidase domain C', NULL, NULL, NULL, NULL, NULL, 4),
(166639, NULL, 'G3DSA:2.40.50.40:FF:000020', NULL, NULL, 'C-X-C motif chemokine 14', NULL, NULL, NULL, NULL, NULL, 4),
(166640, NULL, 'G3DSA:1.10.1450.10:FF:000141', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(166641, NULL, 'G3DSA:3.20.20.330:FF:000034', NULL, NULL, 'Uncharacterized protein HI_1042', NULL, NULL, NULL, NULL, NULL, 4),
(166642, NULL, 'G3DSA:1.20.58.900:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166643, NULL, 'G3DSA:1.25.10.10:FF:003222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166644, NULL, 'G3DSA:2.20.28.10:FF:000033', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(166645, NULL, 'G3DSA:2.60.40.10:FF:005309', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166646, NULL, 'G3DSA:1.10.10.10:FF:002053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166647, NULL, 'G3DSA:3.60.90.10:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166648, NULL, 'G3DSA:3.30.760.10:FF:000046', NULL, NULL, 'AGAP007172-PB', NULL, NULL, NULL, NULL, NULL, 4),
(166649, NULL, 'G3DSA:2.30.33.40:FF:000020', NULL, NULL, 'Chaperonin 23', NULL, NULL, NULL, NULL, NULL, 4),
(166650, NULL, 'G3DSA:3.40.250.10:FF:000235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(166651, NULL, 'G3DSA:1.10.287.1480:FF:000001', NULL, NULL, '30S ribosomal protein S14', NULL, NULL, NULL, NULL, NULL, 4),
(166652, NULL, 'G3DSA:2.60.40.10:FF:005057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166653, NULL, 'G3DSA:2.40.50.40:FF:000048', NULL, NULL, 'Polycomb group protein Pc', NULL, NULL, NULL, NULL, NULL, 4),
(166654, NULL, 'G3DSA:3.60.15.10:FF:000275', NULL, NULL, 'Putative DNA interstrand cross-link repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(166655, NULL, 'G3DSA:4.10.240.10:FF:000086', NULL, NULL, 'C6 transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166656, NULL, 'G3DSA:3.20.20.70:FF:000239', NULL, NULL, 'tRNA-dihydrouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(166657, NULL, 'G3DSA:2.60.120.620:FF:000028', NULL, NULL, 'Phytanoyl-CoA dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(166658, NULL, 'G3DSA:2.40.50.1020:FF:000001', NULL, NULL, 'Two-component response regulator yehT', NULL, NULL, NULL, NULL, NULL, 4),
(166659, NULL, 'G3DSA:2.10.60.10:FF:000030', NULL, NULL, 'Lymphocyte antigen 6 complex, locus G6G', NULL, NULL, NULL, NULL, NULL, 4),
(166660, NULL, 'G3DSA:1.20.1740.10:FF:000099', NULL, NULL, 'BnaA03g01440D protein', NULL, NULL, NULL, NULL, NULL, 4),
(166661, NULL, 'G3DSA:2.60.40.2030:FF:000052', NULL, NULL, 'Adhesion G-protein coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(166662, NULL, 'G3DSA:3.40.50.1440:FF:000137', NULL, NULL, 'Tubulin gamma-2 chain', NULL, NULL, NULL, NULL, NULL, 4),
(166663, NULL, 'G3DSA:1.10.30.10:FF:000036', NULL, NULL, 'high mobility group protein D', NULL, NULL, NULL, NULL, NULL, 4),
(166664, NULL, 'G3DSA:1.10.238.10:FF:001289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166665, NULL, 'G3DSA:1.10.287.70:FF:000431', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166666, NULL, 'G3DSA:2.60.120.920:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166667, NULL, 'G3DSA:2.10.220.10:FF:000188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166668, NULL, 'G3DSA:2.30.39.10:FF:000092', NULL, NULL, 'Serpin 42Db, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(166669, NULL, 'G3DSA:2.60.40.420:FF:000195', NULL, NULL, 'Early nodulin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(166670, NULL, 'G3DSA:3.30.70.2120:FF:000001', NULL, NULL, 'Flagellin', NULL, NULL, NULL, NULL, NULL, 4),
(166671, NULL, 'G3DSA:3.30.200.20:FF:000889', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(166672, NULL, 'G3DSA:2.170.300.10:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166673, NULL, 'G3DSA:2.130.10.10:FF:004624', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166674, NULL, 'G3DSA:3.40.50.2300:FF:001160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166675, NULL, 'G3DSA:3.30.160.60:FF:002960', NULL, NULL, 'Zinc finger protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(166676, NULL, 'G3DSA:3.30.200.20:FF:001507', NULL, NULL, 'rho-associated protein kinase 2 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(166677, NULL, 'G3DSA:1.25.40.70:FF:000055', NULL, NULL, 'Age-1', NULL, NULL, NULL, NULL, NULL, 4),
(166678, NULL, 'G3DSA:4.10.400.10:FF:000104', NULL, NULL, 'Low-density lipoprotein receptor class A domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(166679, NULL, 'G3DSA:3.40.50.10860:FF:000017', NULL, NULL, 'Shikimate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(166680, NULL, 'G3DSA:2.30.39.10:FF:000148', NULL, NULL, 'Serpin peptidase inhibitor 31', NULL, NULL, NULL, NULL, NULL, 4),
(166681, NULL, 'G3DSA:3.30.160.60:FF:000818', NULL, NULL, 'zinc finger transcription factor YY1', NULL, NULL, NULL, NULL, NULL, 4),
(166682, NULL, 'G3DSA:3.30.420.10:FF:000088', NULL, NULL, 'Ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(166683, NULL, 'G3DSA:2.60.40.10:FF:003511', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166684, NULL, 'G3DSA:1.25.40.10:FF:000144', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(166685, NULL, 'G3DSA:3.40.50.300:FF:007564', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(166686, NULL, 'G3DSA:1.25.40.10:FF:001234', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(166687, NULL, 'G3DSA:3.30.310.10:FF:000018', NULL, NULL, 'TATA-box-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(166688, NULL, 'G3DSA:1.10.418.10:FF:000027', NULL, NULL, 'Probable fimbrin', NULL, NULL, NULL, NULL, NULL, 4),
(166689, NULL, 'G3DSA:1.10.10.1210:FF:000003', NULL, NULL, 'Nse3p', NULL, NULL, NULL, NULL, NULL, 4),
(166690, NULL, 'G3DSA:1.25.40.20:FF:000618', NULL, NULL, 'Ankyrin repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(166691, NULL, 'G3DSA:3.60.40.10:FF:000316', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(166692, NULL, 'G3DSA:3.40.50.10730:FF:000006', NULL, NULL, 'Urocanate hydratase 1', NULL, NULL, NULL, NULL, NULL, 4),
(166693, NULL, 'G3DSA:1.20.1440.90:FF:000004', NULL, NULL, 'Phosphoenolpyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(166694, NULL, 'G3DSA:3.30.470.20:FF:000139', NULL, NULL, '[Butirosin acyl-carrier protein]--L-glutamate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(166695, NULL, 'G3DSA:2.30.39.10:FF:000103', NULL, NULL, 'Protein CBG15466', NULL, NULL, NULL, NULL, NULL, 4),
(166696, NULL, 'G3DSA:3.90.245.10:FF:000010', NULL, NULL, 'Inosine-uridine preferring nucleoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(166697, NULL, 'G3DSA:3.90.55.10:FF:000006', NULL, NULL, 'Molybdopterin guanine dinucleotide-containing S/N-oxide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(166698, NULL, 'G3DSA:3.30.160.60:FF:005169', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166699, NULL, 'G3DSA:3.90.1150.10:FF:000171', NULL, NULL, 'Possible 8-amino-7-oxononanoate synthase bioF2', NULL, NULL, NULL, NULL, NULL, 4),
(166700, NULL, 'G3DSA:3.30.1360.70:FF:000010', NULL, NULL, 'Arginyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166701, NULL, 'G3DSA:4.10.780.10:FF:000008', NULL, NULL, 'Pyruvate dehydrogenase [NADP(+)], mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(166702, NULL, 'G3DSA:3.10.180.10:FF:000034', NULL, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(166703, NULL, 'G3DSA:1.25.10.10:FF:002250', NULL, NULL, 'Importin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(166704, NULL, 'G3DSA:1.10.287.110:FF:000073', NULL, NULL, 'DnaJ domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(166705, NULL, 'G3DSA:1.20.1070.10:FF:001750', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166706, NULL, 'G3DSA:2.30.30.40:FF:000570', NULL, NULL, 'Protein csh3', NULL, NULL, NULL, NULL, NULL, 4),
(166707, NULL, 'G3DSA:2.60.40.420:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166708, NULL, 'G3DSA:2.30.29.30:FF:000496', NULL, NULL, 'Rho GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(166709, NULL, 'G3DSA:2.130.10.10:FF:003899', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166710, NULL, 'G3DSA:3.40.50.1460:FF:000031', NULL, NULL, 'Gingipain R2', NULL, NULL, NULL, NULL, NULL, 4),
(166711, NULL, 'G3DSA:3.30.2020.30:FF:000001', NULL, NULL, 'fe-S cluster assembly factor HCF101, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(166712, NULL, 'G3DSA:3.40.50.10140:FF:000043', NULL, NULL, 'Disease resistance protein CHS1', NULL, NULL, NULL, NULL, NULL, 4),
(166713, NULL, 'G3DSA:3.40.50.1110:FF:000078', NULL, NULL, 'Secreted protein containing Lipase, GDSL domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(166714, NULL, 'G3DSA:3.10.105.10:FF:000001', NULL, NULL, 'Oligopeptide ABC transporter, oligopeptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(166715, NULL, 'G3DSA:3.40.50.300:FF:003978', NULL, NULL, 'mRNA cleavage and polyadenylation factor clp1', NULL, NULL, NULL, NULL, NULL, 4),
(166716, NULL, 'G3DSA:1.10.540.10:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(166717, NULL, 'G3DSA:3.30.450.40:FF:000043', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(166718, NULL, 'G3DSA:2.60.40.1180:FF:000139', NULL, NULL, 'Glycogen debranching enzyme (TreX)', NULL, NULL, NULL, NULL, NULL, 4),
(166719, NULL, 'G3DSA:1.10.132.20:FF:000018', NULL, NULL, 'Ribosome-recycling factor, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(166720, NULL, 'G3DSA:3.30.200.20:FF:002126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166721, NULL, 'G3DSA:2.130.10.10:FF:001235', NULL, NULL, 'Zinc finger CCCH domain-containing protein 48', NULL, NULL, NULL, NULL, NULL, 4),
(166722, NULL, 'G3DSA:3.30.160.60:FF:006333', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166723, NULL, 'G3DSA:1.10.8.60:FF:000178', NULL, NULL, 'CDC48/VCP homolog, AAA superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(166724, NULL, 'G3DSA:3.40.390.10:FF:000184', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166725, NULL, 'G3DSA:3.40.630.10:FF:000220', NULL, NULL, 'Peptidase M20 domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(166726, NULL, 'G3DSA:3.40.50.1000:FF:000606', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166727, NULL, 'G3DSA:1.25.40.20:FF:000034', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(166728, NULL, 'G3DSA:3.30.200.20:FF:001406', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166729, NULL, 'G3DSA:2.60.120.230:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166730, NULL, 'G3DSA:1.10.1450.10:FF:000011', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(166731, NULL, 'G3DSA:3.40.50.1820:FF:001780', NULL, NULL, 'Protein phosphatase methylesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(166732, NULL, 'G3DSA:3.40.50.12650:FF:000003', NULL, NULL, 'DNA cross-link repair 1B', NULL, NULL, NULL, NULL, NULL, 4),
(166733, NULL, 'G3DSA:2.30.29.30:FF:000069', NULL, NULL, 'Intersectin 1', NULL, NULL, NULL, NULL, NULL, 4),
(166734, NULL, 'G3DSA:3.40.1230.10:FF:000003', NULL, NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex assembly factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(166735, NULL, 'G3DSA:2.60.40.10:FF:001797', NULL, NULL, 'Frazzled, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(166736, NULL, 'G3DSA:1.10.3260.10:FF:000014', NULL, NULL, 'Unplaced genomic scaffold supercont2.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(166737, NULL, 'G3DSA:2.60.490.10:FF:000005', NULL, NULL, 'C12orf76 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(166738, NULL, 'G3DSA:3.40.50.300:FF:000544', NULL, NULL, 'Protein ROOT HAIR DEFECTIVE 3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(166739, NULL, 'G3DSA:1.25.40.90:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166740, NULL, 'G3DSA:1.10.10.10:FF:001889', NULL, NULL, 'Lmo2004 protein', NULL, NULL, NULL, NULL, NULL, 4),
(166741, NULL, 'G3DSA:1.10.437.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166742, NULL, 'G3DSA:3.30.70.330:FF:002846', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166743, NULL, 'G3DSA:3.40.50.300:FF:003669', NULL, NULL, 'Peroxisomal biogenesis factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(166744, NULL, 'G3DSA:1.20.1730.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166745, NULL, 'G3DSA:1.25.10.10:FF:000316', NULL, NULL, 'Phospholipase A2-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(166746, NULL, 'G3DSA:1.10.540.10:FF:000109', NULL, NULL, 'short-chain specific acyl-CoA dehydrogenase, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(166747, NULL, 'G3DSA:3.80.10.10:FF:001741', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(166748, NULL, 'G3DSA:3.40.50.150:FF:001662', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166749, NULL, 'G3DSA:2.60.40.10:FF:005265', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166750, NULL, 'G3DSA:3.30.160.60:FF:003724', NULL, NULL, 'Zinc finger protein 77', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(166751, NULL, 'G3DSA:1.10.150.80:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166752, NULL, 'G3DSA:1.10.1670.10:FF:000022', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(166753, NULL, 'G3DSA:1.25.10.10:FF:001294', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166754, NULL, 'G3DSA:3.40.50.12670:FF:000009', NULL, NULL, 'Serine carboxypeptidase-like 39', NULL, NULL, NULL, NULL, NULL, 4),
(166755, NULL, 'G3DSA:3.40.190.100:FF:000002', NULL, NULL, 'Choline ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(166756, NULL, 'G3DSA:1.10.8.60:FF:000487', NULL, NULL, 'Transitional endoplasmic reticulum ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166757, NULL, 'G3DSA:3.40.50.300:FF:005687', NULL, NULL, 'Compact plant2', NULL, NULL, NULL, NULL, NULL, 4),
(166758, NULL, 'G3DSA:2.60.120.330:FF:000109', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(166759, NULL, 'G3DSA:2.130.10.10:FF:004888', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166760, NULL, 'G3DSA:3.10.105.10:FF:000046', NULL, NULL, 'Putative oligopeptide-binding lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(166761, NULL, 'G3DSA:3.40.50.300:FF:000443', NULL, NULL, 'Peptide transport system ATP-binding protein SapD', NULL, NULL, NULL, NULL, NULL, 4),
(166762, NULL, 'G3DSA:3.40.50.10090:FF:000005', NULL, NULL, 'Uroporphyrinogen-III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(166763, NULL, 'G3DSA:3.30.160.60:FF:002752', NULL, NULL, 'Zinc finger protein 589', NULL, NULL, NULL, NULL, NULL, 4),
(166764, NULL, 'G3DSA:1.10.246.60:FF:000002', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit J', NULL, NULL, NULL, NULL, NULL, 4),
(166765, NULL, 'G3DSA:2.60.40.10:FF:004337', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166766, NULL, 'G3DSA:2.130.10.10:FF:000510', NULL, NULL, 'WD repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(166767, NULL, 'G3DSA:3.40.50.1820:FF:001471', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166768, NULL, 'G3DSA:1.25.40.420:FF:000043', NULL, NULL, 'BTB/POZ domain-containing protein 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(166769, NULL, 'G3DSA:1.10.532.10:FF:000006', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(166770, NULL, 'G3DSA:3.40.50.11840:FF:000002', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(166771, NULL, 'G3DSA:2.60.40.10:FF:000594', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(166772, NULL, 'G3DSA:3.20.20.380:FF:000010', NULL, NULL, 'Copper homeostasis protein CutC, putative (JCVI)', NULL, NULL, NULL, NULL, NULL, 4),
(166773, NULL, 'G3DSA:3.40.190.120:FF:000008', NULL, NULL, 'Osmoprotection protein (ProWX)', NULL, NULL, NULL, NULL, NULL, 4),
(166774, NULL, 'G3DSA:1.10.630.10:FF:000644', NULL, NULL, 'Os03g0603100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(166775, NULL, 'G3DSA:2.60.40.10:FF:000605', NULL, NULL, 'Tyrosine-protein kinase receptor TYRO3', NULL, NULL, NULL, NULL, NULL, 4),
(166776, NULL, 'G3DSA:2.60.40.10:FF:005849', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166777, NULL, 'G3DSA:1.10.287.70:FF:000223', NULL, NULL, 'Ion channel/Calcium-activated BK potassium channel alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166778, NULL, 'G3DSA:3.10.450.50:FF:000022', NULL, NULL, 'Alcohol dehydrogenase 3', NULL, NULL, NULL, NULL, NULL, 4),
(166779, NULL, 'G3DSA:3.30.710.10:FF:000335', NULL, NULL, 'Zinc finger protein 570-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(166780, NULL, 'G3DSA:3.30.70.100:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166781, NULL, 'G3DSA:3.30.70.330:FF:002493', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166782, NULL, 'G3DSA:2.70.130.10:FF:000139', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166783, NULL, 'G3DSA:1.10.530.10:FF:000024', NULL, NULL, 'C-type lysozyme', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(166784, NULL, 'G3DSA:2.60.120.330:FF:000048', NULL, NULL, '2OG-Fe(II) oxygenase superfamily, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166785, NULL, 'G3DSA:3.40.50.720:FF:002592', NULL, NULL, 'Putative malate dehydrogenase 1B-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(166786, NULL, 'G3DSA:2.40.50.40:FF:000065', NULL, NULL, 'Protein CHROMATIN REMODELING 4', NULL, NULL, NULL, NULL, NULL, 4),
(166787, NULL, 'G3DSA:2.10.230.10:FF:000014', NULL, NULL, 'CG7387 protein', NULL, NULL, NULL, NULL, NULL, 4),
(166788, NULL, 'G3DSA:2.60.40.60:FF:000923', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166789, NULL, 'G3DSA:1.20.58.390:FF:000161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166790, NULL, 'G3DSA:3.30.420.230:FF:000002', NULL, NULL, 'U5 snRNA-associated splicing factor', NULL, NULL, NULL, NULL, NULL, 4),
(166791, NULL, 'G3DSA:3.10.100.10:FF:000142', NULL, NULL, 'C-type LECtin', NULL, NULL, NULL, NULL, NULL, 4),
(166792, NULL, 'G3DSA:1.20.58.1980:FF:000001', NULL, NULL, 'Kinesin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166793, NULL, 'G3DSA:1.10.287.70:FF:000532', NULL, NULL, 'Putative potassium channel subunit', NULL, NULL, NULL, NULL, NULL, 4),
(166794, NULL, 'G3DSA:2.10.25.10:FF:000252', NULL, NULL, 'Crumbs homolog 1 (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(166795, NULL, 'G3DSA:3.30.930.10:FF:000329', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166796, NULL, 'G3DSA:1.10.510.10:FF:001698', NULL, NULL, 'NUAK family, SNF1-like kinase, 1b', NULL, NULL, NULL, NULL, NULL, 4),
(166797, NULL, 'G3DSA:1.10.1240.10:FF:000001', NULL, NULL, 'Methionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(166798, NULL, 'G3DSA:3.30.565.10:FF:000025', NULL, NULL, 'Aerobic respiration control sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(166799, NULL, 'G3DSA:2.40.30.10:FF:000414', NULL, NULL, 'NADPH--cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(166800, NULL, 'G3DSA:3.40.50.300:FF:004130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166801, NULL, 'G3DSA:3.30.160.60:FF:002651', NULL, NULL, 'zinc finger protein 597', NULL, NULL, NULL, NULL, NULL, 4),
(166802, NULL, 'G3DSA:3.90.226.10:FF:000308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166803, NULL, 'G3DSA:3.20.10.10:FF:000052', NULL, NULL, '4-amino-4-deoxychorismate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(166804, NULL, 'G3DSA:3.40.50.1820:FF:000852', NULL, NULL, 'Clan SC, family S28, unassigned serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(166805, NULL, 'G3DSA:1.50.40.10:FF:000214', NULL, NULL, 'Mitochondrial carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166806, NULL, 'G3DSA:1.25.40.10:FF:004668', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166807, NULL, 'G3DSA:1.10.1410.10:FF:000048', NULL, NULL, 'HESO1', NULL, NULL, NULL, NULL, NULL, 4),
(166808, NULL, 'G3DSA:3.30.160.60:FF:005377', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166809, NULL, 'G3DSA:1.10.1200.10:FF:000139', NULL, NULL, '7-keto-8-aminopelargonate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(166810, NULL, 'G3DSA:2.60.120.10:FF:000349', NULL, NULL, 'Homogentisate 1,2-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(166811, NULL, 'G3DSA:2.130.10.10:FF:002163', NULL, NULL, 'ABC transporter A family member 7', NULL, NULL, NULL, NULL, NULL, 4),
(166812, NULL, 'G3DSA:3.10.20.90:FF:000083', NULL, NULL, 'Trans-2,3-enoyl-CoA reductase b', NULL, NULL, NULL, NULL, NULL, 4),
(166813, NULL, 'G3DSA:1.10.238.270:FF:000004', NULL, NULL, 'Odorant-binding protein 50e', NULL, NULL, NULL, NULL, NULL, 4),
(166814, NULL, 'G3DSA:3.80.10.10:FF:001314', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase At1g17230', NULL, NULL, NULL, NULL, NULL, 4),
(166815, NULL, 'G3DSA:3.40.50.150:FF:000673', NULL, NULL, 'N5-glutamine methyltransferase, HemK family', NULL, NULL, NULL, NULL, NULL, 4),
(166816, NULL, 'G3DSA:2.80.10.50:FF:000283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(166817, NULL, 'G3DSA:3.40.640.10:FF:000254', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(166818, NULL, 'G3DSA:3.40.50.410:FF:000138', NULL, NULL, 'general transcription factor IIH subunit 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(166819, NULL, 'G3DSA:1.10.238.10:FF:000581', NULL, NULL, 'GD21233', NULL, NULL, NULL, NULL, NULL, 4),
(166820, NULL, 'G3DSA:3.30.70.330:FF:001402', NULL, NULL, 'Terminal EAR1-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(166821, NULL, 'G3DSA:2.120.10.30:FF:000218', NULL, NULL, 'adipocyte plasma membrane-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(166822, NULL, 'G3DSA:1.10.1000.11:FF:000007', NULL, NULL, 'Golgi-specific brefeldin A-resistance guanine nucleotide exchange factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(166823, NULL, 'G3DSA:1.20.5.650:FF:000003', NULL, NULL, 'Transcription factor IIIB, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166824, NULL, 'G3DSA:1.10.20.10:FF:000182', NULL, NULL, 'DRAP1 corepressor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(166825, NULL, 'G3DSA:3.40.50.300:FF:000752', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(166826, NULL, 'G3DSA:2.40.240.10:FF:000036', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(166827, NULL, 'G3DSA:1.20.120.1750:FF:000103', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(166828, NULL, 'G3DSA:1.25.10.10:FF:000108', NULL, NULL, 'N-terminal kinase-like protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(166829, NULL, 'G3DSA:3.30.1890.10:FF:000004', NULL, NULL, 'LPS O-antigen length regulator', NULL, NULL, NULL, NULL, NULL, 4),
(166830, NULL, 'G3DSA:3.10.100.10:FF:000041', NULL, NULL, 'Asialoglycoprotein receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(166831, NULL, 'G3DSA:3.30.450.20:FF:000492', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(166832, NULL, 'G3DSA:3.80.10.10:FF:004467', NULL, NULL, 'Phytosulfokine receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(166833, NULL, 'G3DSA:1.25.40.20:FF:001546', NULL, NULL, 'Os09g0331600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(166834, NULL, 'G3DSA:2.120.10.80:FF:000110', NULL, NULL, 'Kelch domain-containing protein 8B', NULL, NULL, NULL, NULL, NULL, 4),
(166835, NULL, 'G3DSA:1.20.58.390:FF:000222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166836, NULL, 'G3DSA:3.30.160.60:FF:005478', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166837, NULL, 'G3DSA:1.20.140.10:FF:000099', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(166838, NULL, 'G3DSA:1.20.5.170:FF:000207', NULL, NULL, 'Protein tipD', NULL, NULL, NULL, NULL, NULL, 4),
(166839, NULL, 'G3DSA:3.50.50.60:FF:001187', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(166840, NULL, 'G3DSA:1.10.510.10:FF:000933', NULL, NULL, 'Mitogen-activated protein kinase kinase 10-2', NULL, NULL, NULL, NULL, NULL, 4),
(166841, NULL, 'G3DSA:3.30.1330.30:FF:000087', NULL, NULL, 'Ribosomal protein L7Ae/L30e/S12e/Gadd45', NULL, NULL, NULL, NULL, NULL, 4),
(166842, NULL, 'G3DSA:3.40.190.290:FF:000115', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(166843, NULL, 'G3DSA:3.40.80.10:FF:000027', NULL, NULL, 'Peptidoglycan-recognition protein SC2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(166844, NULL, 'G3DSA:3.20.20.190:FF:000088', NULL, NULL, 'Phospholipase D', NULL, NULL, NULL, NULL, NULL, 4),
(166845, NULL, 'G3DSA:3.30.160.60:FF:003932', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166846, NULL, 'G3DSA:3.40.50.300:FF:003169', NULL, NULL, 'GD14479', NULL, NULL, NULL, NULL, NULL, 4),
(166847, NULL, 'G3DSA:1.10.472.80:FF:000275', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166848, NULL, 'G3DSA:2.20.100.10:FF:000216', NULL, NULL, 'Spondin-1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(166849, NULL, 'G3DSA:3.20.20.80:FF:000669', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(166850, NULL, 'G3DSA:3.40.50.300:FF:000235', NULL, NULL, 'ATPase ASNA1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(166851, NULL, 'G3DSA:3.30.70.330:FF:001874', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166852, NULL, 'G3DSA:1.50.40.10:FF:000552', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166853, NULL, 'G3DSA:1.25.40.10:FF:000969', NULL, NULL, 'Chromosome 14 open reading frame 102', NULL, NULL, NULL, NULL, NULL, 4),
(166854, NULL, 'G3DSA:3.40.630.30:FF:000175', NULL, NULL, 'Acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166855, NULL, 'G3DSA:1.20.120.1080:FF:000104', NULL, NULL, 'DEAH-box helicase 34', NULL, NULL, NULL, NULL, NULL, 4),
(166856, NULL, 'G3DSA:3.30.70.1230:FF:000257', NULL, NULL, '4-phytase', NULL, NULL, NULL, NULL, NULL, 4),
(166857, NULL, 'G3DSA:3.30.70.1170:FF:000014', NULL, NULL, 'SAM-dependent tRNA/rRNA cytosine-C5 methylase', NULL, NULL, NULL, NULL, NULL, 4),
(166858, NULL, 'G3DSA:1.20.5.2950:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166859, NULL, 'G3DSA:1.20.1530.20:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166860, NULL, 'G3DSA:3.40.50.1820:FF:001128', NULL, NULL, 'Dipeptidyl Peptidase Four (IV) family', NULL, NULL, NULL, NULL, NULL, 4),
(166861, NULL, 'G3DSA:3.40.50.1240:FF:000066', NULL, NULL, 'Phosphoglycerate mutase-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(166862, NULL, 'G3DSA:3.30.70.330:FF:000784', NULL, NULL, 'Serine/arginine-rich SC35-like splicing factor SCL30A', NULL, NULL, NULL, NULL, NULL, 4),
(166863, NULL, 'G3DSA:1.20.58.60:FF:000496', NULL, NULL, 'Guanine nucleotide exchange factor UNC-73B', NULL, NULL, NULL, NULL, NULL, 4),
(166864, NULL, 'G3DSA:3.40.570.10:FF:000029', NULL, NULL, 'GM12731', NULL, NULL, NULL, NULL, NULL, 4),
(166865, NULL, 'G3DSA:3.10.20.90:FF:000144', NULL, NULL, 'Ubiquitin-like protein 4A', NULL, NULL, NULL, NULL, NULL, 4),
(166866, NULL, 'G3DSA:3.30.70.330:FF:000121', NULL, NULL, 'Splicing factor 3b subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(166867, NULL, 'G3DSA:1.25.50.20:FF:000080', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(166868, NULL, 'G3DSA:1.20.120.330:FF:000024', NULL, NULL, 'Inactive tyrosine-protein kinase kin-32', NULL, NULL, NULL, NULL, NULL, 4),
(166869, NULL, 'G3DSA:3.90.226.10:FF:000090', NULL, NULL, 'Tail-specific protease', NULL, NULL, NULL, NULL, NULL, 4),
(166870, NULL, 'G3DSA:2.130.10.10:FF:005389', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166871, NULL, 'G3DSA:3.50.50.60:FF:000568', NULL, NULL, 'Paromamine 6''-oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(166872, NULL, 'G3DSA:1.25.40.20:FF:000927', NULL, NULL, 'F22M8.6 protein', NULL, NULL, NULL, NULL, NULL, 4),
(166873, NULL, 'G3DSA:3.90.1410.10:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166874, NULL, 'G3DSA:3.40.50.410:FF:000329', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166875, NULL, 'G3DSA:3.30.70.330:FF:001301', NULL, NULL, 'Peroxisome proliferator-activated receptor gamma, coactivator-related 1', NULL, NULL, NULL, NULL, NULL, 4),
(166876, NULL, 'G3DSA:3.30.1780.10:FF:000013', NULL, NULL, 'Homolog to ornithine cyclodeaminase', NULL, NULL, NULL, NULL, NULL, 4),
(166877, NULL, 'G3DSA:1.20.1070.10:FF:001087', NULL, NULL, 'Allatostatin-A receptor', NULL, NULL, NULL, NULL, NULL, 4),
(166878, NULL, 'G3DSA:1.25.10.10:FF:000889', NULL, NULL, 'HEAT repeat domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(166879, NULL, 'G3DSA:1.10.287.70:FF:000740', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166880, NULL, 'G3DSA:1.10.20.10:FF:000226', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166881, NULL, 'G3DSA:1.20.1070.10:FF:002003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166882, NULL, 'G3DSA:3.30.720.50:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166883, NULL, 'G3DSA:1.10.560.10:FF:000009', NULL, NULL, 'T-complex protein 1 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(166884, NULL, 'G3DSA:3.40.50.1000:FF:000236', NULL, NULL, 'Phosphoserine phosphatase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(166885, NULL, 'G3DSA:3.40.250.10:FF:000134', NULL, NULL, 'Arsenate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(166886, NULL, 'G3DSA:1.20.58.1590:FF:000007', NULL, NULL, 'Tethering factor for nuclear proteasome STS1', NULL, NULL, NULL, NULL, NULL, 4),
(166887, NULL, 'G3DSA:2.60.40.10:FF:001111', NULL, NULL, 'tyrosine-protein phosphatase Lar isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(166888, NULL, 'G3DSA:3.40.50.150:FF:001398', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166889, NULL, 'G3DSA:3.40.50.300:FF:002230', NULL, NULL, 'Multidrug ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(166890, NULL, 'G3DSA:2.70.150.10:FF:000040', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(166891, NULL, 'G3DSA:1.25.40.10:FF:003842', NULL, NULL, 'F18B13.21 protein', NULL, NULL, NULL, NULL, NULL, 4),
(166892, NULL, 'G3DSA:1.10.220.160:FF:000015', NULL, NULL, 'SET domain-containing protein SmydA-8, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(166893, NULL, 'G3DSA:1.10.10.60:FF:001224', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166894, NULL, 'G3DSA:3.30.70.330:FF:002021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166895, NULL, 'G3DSA:2.70.170.10:FF:000001', NULL, NULL, 'Gamma-aminobutyric acid A receptor subunit alpha-2', NULL, NULL, NULL, NULL, NULL, 4),
(166896, NULL, 'G3DSA:3.60.10.10:FF:000399', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(166897, NULL, 'G3DSA:3.30.750.24:FF:000042', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(166898, NULL, 'G3DSA:3.40.50.800:FF:000132', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(166899, NULL, 'G3DSA:3.30.160.100:FF:000010', NULL, NULL, 'Ribosomal subunit interface protein', NULL, NULL, NULL, NULL, NULL, 4),
(166900, NULL, 'G3DSA:3.10.580.10:FF:000126', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(166901, NULL, 'G3DSA:1.10.287.610:FF:000014', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(166902, NULL, 'G3DSA:1.10.287.110:FF:000426', NULL, NULL, 'DnaJ-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(166903, NULL, 'G3DSA:3.40.50.720:FF:000658', NULL, NULL, 'Oxidoreductase, NAD-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(166904, NULL, 'G3DSA:3.30.70.1230:FF:000043', NULL, NULL, 'Luxr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(166905, NULL, 'G3DSA:1.50.40.10:FF:000405', NULL, NULL, 'Solute carrier family 25 member 46', NULL, NULL, NULL, NULL, NULL, 4),
(166906, NULL, 'G3DSA:1.20.120.1900:FF:000081', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(166907, NULL, 'G3DSA:2.130.10.10:FF:004416', NULL, NULL, 'AGAP006359-PA', NULL, NULL, NULL, NULL, NULL, 4),
(166908, NULL, 'G3DSA:2.130.10.10:FF:003444', NULL, NULL, 'AGAP000602-PA', NULL, NULL, NULL, NULL, NULL, 4),
(166909, NULL, 'G3DSA:3.50.30.30:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166910, NULL, 'G3DSA:1.20.1250.20:FF:000536', NULL, NULL, 'Monocarboxylate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(166911, NULL, 'G3DSA:2.20.70.10:FF:000007', NULL, NULL, 'E3 ubiquitin-protein ligase HECW2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(166912, NULL, 'G3DSA:1.10.472.10:FF:000271', NULL, NULL, 'Cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(166913, NULL, 'G3DSA:1.20.1560.10:FF:000225', NULL, NULL, 'Type I secretion system permease/ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(166914, NULL, 'G3DSA:3.30.500.10:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166915, NULL, 'G3DSA:3.30.2310.10:FF:000001', NULL, NULL, 'tRNA (N6-threonylcarbamoyladenosine(37)-N6)-methyltransferase TrmO', NULL, NULL, NULL, NULL, NULL, 4),
(166916, NULL, 'G3DSA:3.10.129.10:FF:000005', NULL, NULL, 'Acyl-CoA thioesterase YciA', NULL, NULL, NULL, NULL, NULL, 4),
(166917, NULL, 'G3DSA:3.30.1360.170:FF:000001', NULL, NULL, 'Flavin-dependent thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(166918, NULL, 'G3DSA:2.130.10.10:FF:002516', NULL, NULL, 'WD repeat domain 66', NULL, NULL, NULL, NULL, NULL, 4),
(166919, NULL, 'G3DSA:3.40.50.720:FF:001378', NULL, NULL, 'Related to ERG27-3-keto sterol reductase', NULL, NULL, NULL, NULL, NULL, 4),
(166920, NULL, 'G3DSA:1.20.1270.60:FF:000077', NULL, NULL, 'SH3 domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(166921, NULL, 'G3DSA:1.20.58.340:FF:000062', NULL, NULL, 'Magnesium transporter MRS2-F', NULL, NULL, NULL, NULL, NULL, 4),
(166922, NULL, 'G3DSA:3.80.10.10:FF:003995', NULL, NULL, 'NACHT, LRR and PYD domains-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(166923, NULL, 'G3DSA:3.40.1370.10:FF:000030', NULL, NULL, 'Ribosomal protein L4 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(166924, NULL, 'G3DSA:1.10.730.10:FF:000045', NULL, NULL, 'Leucyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(166925, NULL, 'G3DSA:3.30.710.10:FF:000099', NULL, NULL, 'BTB/POZ domain-containing protein POB1', NULL, NULL, NULL, NULL, NULL, 4),
(166926, NULL, 'G3DSA:3.40.50.11500:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166927, NULL, 'G3DSA:2.60.40.150:FF:000193', NULL, NULL, 'Phospholipase D delta', NULL, NULL, NULL, NULL, NULL, 4),
(166928, NULL, 'G3DSA:6.10.140.2220:FF:000071', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(166929, NULL, 'G3DSA:3.20.20.70:FF:000756', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166930, NULL, 'G3DSA:1.10.287.210:FF:000001', NULL, NULL, 'Envelope glycoprotein gp160', NULL, NULL, NULL, NULL, NULL, 4),
(166931, NULL, 'G3DSA:2.60.98.10:FF:000007', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(166932, NULL, 'G3DSA:3.40.50.10480:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166933, NULL, 'G3DSA:2.170.220.10:FF:000004', NULL, NULL, 'Methionine-tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(166934, NULL, 'G3DSA:2.60.40.10:FF:003011', NULL, NULL, 'Immunoglobulin heavy chain precursor', NULL, NULL, NULL, NULL, NULL, 4),
(166935, NULL, 'G3DSA:3.40.50.2300:FF:000199', NULL, NULL, 'Vomeronasal 2, receptor 28', NULL, NULL, NULL, NULL, NULL, 4),
(166936, NULL, 'G3DSA:1.20.1250.20:FF:001750', NULL, NULL, 'Major facilitator superfamily MFS_1', NULL, NULL, NULL, NULL, NULL, 4),
(166937, NULL, 'G3DSA:2.30.30.40:FF:000143', NULL, NULL, 'Caspase recruitment domain family member 10', NULL, NULL, NULL, NULL, NULL, 4),
(166938, NULL, 'G3DSA:3.30.2280.10:FF:000003', NULL, NULL, 'GSK3-beta interaction protein', NULL, NULL, NULL, NULL, NULL, 4),
(166939, NULL, 'G3DSA:2.130.10.10:FF:003135', NULL, NULL, 'YALI0B09977p', NULL, NULL, NULL, NULL, NULL, 4),
(166940, NULL, 'G3DSA:3.80.10.10:FF:001078', NULL, NULL, 'Protein phosphatase PP1 regulatory subunit sds22', NULL, NULL, NULL, NULL, NULL, 4),
(166941, NULL, 'G3DSA:3.30.540.30:FF:000013', NULL, NULL, 'Dipeptidyl peptidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(166942, NULL, 'G3DSA:1.20.1250.20:FF:001042', NULL, NULL, 'Oligopeptide transporter-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(166943, NULL, 'G3DSA:3.30.420.10:FF:000190', NULL, NULL, 'Egalitarian, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(166944, NULL, 'G3DSA:3.80.10.10:FF:003422', NULL, NULL, 'Cf2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(166945, NULL, 'G3DSA:2.30.110.10:FF:000119', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(166946, NULL, 'G3DSA:3.30.60.20:FF:000007', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(166947, NULL, 'G3DSA:3.30.160.60:FF:003005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166948, NULL, 'G3DSA:3.60.21.10:FF:000407', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166949, NULL, 'G3DSA:2.10.220.10:FF:000087', NULL, NULL, 'High cysteine membrane protein TMK-like', NULL, NULL, NULL, NULL, NULL, 4),
(166950, NULL, 'G3DSA:1.10.510.10:FF:002215', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(166951, NULL, 'G3DSA:3.40.630.30:FF:000630', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166952, NULL, 'G3DSA:3.30.160.60:FF:006142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166953, NULL, 'G3DSA:1.20.1310.10:FF:000050', NULL, NULL, 'Cullin-5', NULL, NULL, NULL, NULL, NULL, 4),
(166954, NULL, 'G3DSA:3.30.40.10:FF:002268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166955, NULL, 'G3DSA:3.40.50.1000:FF:000500', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166956, NULL, 'G3DSA:1.25.40.10:FF:005079', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(166957, NULL, 'G3DSA:3.40.50.720:FF:000097', NULL, NULL, 'SDR family oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(166958, NULL, 'G3DSA:3.30.930.10:FF:000273', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(166959, NULL, 'G3DSA:2.20.25.590:FF:000001', NULL, NULL, 'Beta-microseminoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(166960, NULL, 'G3DSA:3.20.20.140:FF:000275', NULL, NULL, 'Adenosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(166961, NULL, 'G3DSA:3.60.20.10:FF:000017', NULL, NULL, 'Glucosamine-fructose-6-phosphate aminotransferase, isomerising', NULL, NULL, NULL, NULL, NULL, 4),
(166962, NULL, 'G3DSA:3.40.30.10:FF:000333', NULL, NULL, 'Thioredoxin-like protein CDSP32, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(166963, NULL, 'G3DSA:3.40.50.2300:FF:001525', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166964, NULL, 'G3DSA:2.60.40.2170:FF:000009', NULL, NULL, 'Wnt inhibitory factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(166965, NULL, 'G3DSA:3.20.20.220:FF:000001', NULL, NULL, 'Methylenetetrahydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(166966, NULL, 'G3DSA:3.30.160.60:FF:003371', NULL, NULL, 'Zinc finger protein 700', NULL, NULL, NULL, NULL, NULL, 4),
(166967, NULL, 'G3DSA:3.30.200.20:FF:001654', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166968, NULL, 'G3DSA:3.40.50.300:FF:001724', NULL, NULL, 'Vacuolar membrane ATPase subunit a', NULL, NULL, NULL, NULL, NULL, 4),
(166969, NULL, 'G3DSA:2.60.120.200:FF:000110', NULL, NULL, 'pentraxin-related protein PTX3', NULL, NULL, NULL, NULL, NULL, 4),
(166970, NULL, 'G3DSA:2.30.30.100:FF:000188', NULL, NULL, 'Sm-like protein LSM3B isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(166971, NULL, 'G3DSA:3.30.160.60:FF:001471', NULL, NULL, 'Zinc finger protein 324A', NULL, NULL, NULL, NULL, NULL, 4),
(166972, NULL, 'G3DSA:2.10.25.10:FF:001180', NULL, NULL, 'LP19846p', NULL, NULL, NULL, NULL, NULL, 4),
(166973, NULL, 'G3DSA:2.60.40.1170:FF:000018', NULL, NULL, 'stonin-2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(166974, NULL, 'G3DSA:1.20.1560.10:FF:000534', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166975, NULL, 'G3DSA:3.20.20.240:FF:000007', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(166976, NULL, 'G3DSA:3.30.2410.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166977, NULL, 'G3DSA:2.60.40.10:FF:003584', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166978, NULL, 'G3DSA:3.40.50.10490:FF:000108', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166979, NULL, 'G3DSA:4.10.60.10:FF:000025', NULL, NULL, 'U11/U12 small nuclear ribonucleoprotein 31 kDa protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(166980, NULL, 'G3DSA:3.30.160.60:FF:004197', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166981, NULL, 'G3DSA:3.30.1390.10:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166982, NULL, 'G3DSA:2.70.130.10:FF:000038', NULL, NULL, 'Insulin-like growth factor 2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(166983, NULL, 'G3DSA:1.20.5.190:FF:000056', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(166984, NULL, 'G3DSA:1.10.510.10:FF:004424', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166985, NULL, 'G3DSA:1.10.287.70:FF:000329', NULL, NULL, 'Uncoordinated protein 58', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(166986, NULL, 'G3DSA:3.30.160.60:FF:006097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166987, NULL, 'G3DSA:1.10.630.10:FF:000189', NULL, NULL, 'Phenylalanine N-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(166988, NULL, 'G3DSA:2.30.29.30:FF:000732', NULL, NULL, 'Collagen type IV alpha-3-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(166989, NULL, 'G3DSA:3.40.50.720:FF:001423', NULL, NULL, 'Fatty acid synthase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(166990, NULL, 'G3DSA:2.130.10.30:FF:000156', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166991, NULL, 'G3DSA:2.60.40.10:FF:003275', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(166992, NULL, 'G3DSA:3.90.190.10:FF:000359', NULL, NULL, 'PTP/DSP-like', NULL, NULL, NULL, NULL, NULL, 4),
(166993, NULL, 'G3DSA:3.40.50.300:FF:006592', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166994, NULL, 'G3DSA:3.30.420.10:FF:000751', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(166995, NULL, 'G3DSA:1.10.10.1770:FF:000002', NULL, NULL, 'Sll1380 protein', NULL, NULL, NULL, NULL, NULL, 4),
(166996, NULL, 'G3DSA:2.60.40.60:FF:000968', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(166997, NULL, 'G3DSA:1.25.40.10:FF:002206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(166998, NULL, 'G3DSA:1.10.10.10:FF:001226', NULL, NULL, 'Transcriptional regulator, GntR family', NULL, NULL, NULL, NULL, NULL, 4),
(166999, NULL, 'G3DSA:4.10.280.10:FF:000015', NULL, NULL, 'T-cell acute lymphocytic leukemia 1', NULL, NULL, NULL, NULL, NULL, 4),
(167000, NULL, 'G3DSA:1.50.10.10:FF:000016', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(167001, NULL, 'G3DSA:2.10.25.10:FF:001741', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167002, NULL, 'G3DSA:3.30.65.10:FF:000009', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(167003, NULL, 'G3DSA:1.10.3720.10:FF:000050', NULL, NULL, 'Molybdenum transport system permease', NULL, NULL, NULL, NULL, NULL, 4),
(167004, NULL, 'G3DSA:2.10.25.10:FF:001432', NULL, NULL, 'Serine protease P146', NULL, NULL, NULL, NULL, NULL, 4),
(167005, NULL, 'G3DSA:3.40.190.10:FF:000764', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(167006, NULL, 'G3DSA:1.10.472.10:FF:000052', NULL, NULL, 'cyclin-I isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(167007, NULL, 'G3DSA:2.60.40.2150:FF:000003', NULL, NULL, 'Interleukin 17 receptor A1a', NULL, NULL, NULL, NULL, NULL, 4),
(167008, NULL, 'G3DSA:1.10.510.10:FF:004115', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167009, NULL, 'G3DSA:3.30.160.60:FF:003680', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167010, NULL, 'G3DSA:3.40.190.10:FF:000056', NULL, NULL, 'Lactotransferrin', NULL, NULL, NULL, NULL, NULL, 4),
(167011, NULL, 'G3DSA:3.30.2170.10:FF:000012', NULL, NULL, 'Probable dolichyl pyrophosphate Glc1Man9GlcNAc2 alpha-1,3-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(167012, NULL, 'G3DSA:2.40.50.140:FF:000090', NULL, NULL, 'Replication protein A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(167013, NULL, 'G3DSA:3.30.70.270:FF:000097', NULL, NULL, 'Related to DNA polymerase eta', NULL, NULL, NULL, NULL, NULL, 4),
(167014, NULL, 'G3DSA:1.10.3210.10:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167015, NULL, 'G3DSA:3.30.980.10:FF:000012', NULL, NULL, 'Threonyl/alanyl tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(167016, NULL, 'G3DSA:2.120.10.80:FF:000008', NULL, NULL, 'host cell factor 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(167017, NULL, 'G3DSA:1.25.10.10:FF:002002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167018, NULL, 'G3DSA:3.30.565.10:FF:000008', NULL, NULL, 'Nitrogen regulation histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(167019, NULL, 'G3DSA:2.130.10.10:FF:002724', NULL, NULL, 'Putative WD-repeat family protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(167020, NULL, 'G3DSA:1.25.40.10:FF:002987', NULL, NULL, 'Pre-mRNA-splicing factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(167021, NULL, 'G3DSA:1.20.1730.10:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167022, NULL, 'G3DSA:3.20.20.220:FF:000024', NULL, NULL, 'Methylenetetrahydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(167023, NULL, 'G3DSA:2.60.40.10:FF:003691', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167024, NULL, 'G3DSA:3.30.70.330:FF:003116', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167025, NULL, 'G3DSA:3.90.190.10:FF:000253', NULL, NULL, 'Map kinase phosphatase-M B1 isoform', NULL, NULL, NULL, NULL, NULL, 4),
(167026, NULL, 'G3DSA:1.25.10.10:FF:001378', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(167027, NULL, 'G3DSA:3.40.1090.10:FF:000104', NULL, NULL, 'Lysophospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(167028, NULL, 'G3DSA:3.40.190.10:FF:000848', NULL, NULL, 'ABC-type transport system substrate binding component', NULL, NULL, NULL, NULL, NULL, 4),
(167029, NULL, 'G3DSA:3.90.550.50:FF:000141', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(167030, NULL, 'G3DSA:3.90.550.10:FF:000230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167031, NULL, 'G3DSA:3.40.50.720:FF:002148', NULL, NULL, 'F1F0-ATPase inhibitor protein', NULL, NULL, NULL, NULL, NULL, 4),
(167032, NULL, 'G3DSA:2.40.100.10:FF:000009', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase D', NULL, NULL, NULL, NULL, NULL, 4),
(167033, NULL, 'G3DSA:3.40.50.300:FF:006283', NULL, NULL, 'Spastin', NULL, NULL, NULL, NULL, NULL, 4),
(167034, NULL, 'G3DSA:1.25.40.10:FF:002515', NULL, NULL, 'LD41803p', NULL, NULL, NULL, NULL, NULL, 4),
(167035, NULL, 'G3DSA:2.10.110.10:FF:000298', NULL, NULL, 'LIM domain-containing protein F', NULL, NULL, NULL, NULL, NULL, 4),
(167036, NULL, 'G3DSA:3.60.20.10:FF:000124', NULL, NULL, 'Proteasome endopeptidase complex', NULL, NULL, NULL, NULL, NULL, 4),
(167037, NULL, 'G3DSA:3.40.30.10:FF:001160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167038, NULL, 'G3DSA:3.30.420.40:FF:000294', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(167039, NULL, 'G3DSA:1.10.510.10:FF:000517', NULL, NULL, 'Putative receptor kinase Lecrk', NULL, NULL, NULL, NULL, NULL, 4),
(167040, NULL, 'G3DSA:2.70.130.10:FF:000111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167041, NULL, 'G3DSA:3.20.20.140:FF:000298', NULL, NULL, 'Blr5239 protein', NULL, NULL, NULL, NULL, NULL, 4),
(167042, NULL, 'G3DSA:1.20.1270.10:FF:000079', NULL, NULL, 'Major heat shock 70 kDa protein Bbb', NULL, NULL, NULL, NULL, NULL, 4),
(167043, NULL, 'G3DSA:3.30.559.10:FF:000067', NULL, NULL, 'Transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(167044, NULL, 'G3DSA:3.40.50.150:FF:000482', NULL, NULL, 'Probable S-adenosylmethionine-dependent methyltransferase CRG1', NULL, NULL, NULL, NULL, NULL, 4),
(167045, NULL, 'G3DSA:3.20.20.60:FF:000118', NULL, NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase 1 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(167046, NULL, 'G3DSA:1.10.8.10:FF:000174', NULL, NULL, 'Ubiquitin-associated (UBA)/TS-N domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(167047, NULL, 'G3DSA:1.10.530.10:FF:000047', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(167048, NULL, 'G3DSA:1.10.150.910:FF:000004', NULL, NULL, 'Pic', NULL, NULL, NULL, NULL, NULL, 4),
(167049, NULL, 'G3DSA:1.20.1270.60:FF:000105', NULL, NULL, 'Ysp1p', NULL, NULL, NULL, NULL, NULL, 4),
(167050, NULL, 'G3DSA:3.60.21.10:FF:000290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167051, NULL, 'G3DSA:2.160.20.10:FF:000296', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(167052, NULL, 'G3DSA:3.40.630.30:FF:000198', NULL, NULL, 'Acyl-CoA N-acyltransferases (NAT) superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(167053, NULL, 'G3DSA:3.90.550.10:FF:000713', NULL, NULL, 'AFL235Wp', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(167054, NULL, 'G3DSA:3.30.70.1400:FF:000010', NULL, NULL, 'Protein CBG22093', NULL, NULL, NULL, NULL, NULL, 4),
(167055, NULL, 'G3DSA:3.30.160.60:FF:000627', NULL, NULL, 'Zinc finger protein 341', NULL, NULL, NULL, NULL, NULL, 4),
(167056, NULL, 'G3DSA:3.30.110.110:FF:000003', NULL, NULL, 'Double-strand break repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(167057, NULL, 'G3DSA:3.10.20.90:FF:000274', NULL, NULL, 'Tether containing UBX domain for GLUT4', NULL, NULL, NULL, NULL, NULL, 4),
(167058, NULL, 'G3DSA:2.160.20.10:FF:000301', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(167059, NULL, 'G3DSA:2.170.270.10:FF:000215', NULL, NULL, 'AGAP003597-PA', NULL, NULL, NULL, NULL, NULL, 4),
(167060, NULL, 'G3DSA:3.40.30.10:FF:000547', NULL, NULL, 'Putative glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(167061, NULL, 'G3DSA:3.40.50.2300:FF:001396', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167062, NULL, 'G3DSA:1.20.5.500:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167063, NULL, 'G3DSA:2.170.150.80:FF:000031', NULL, NULL, 'At1g19040', NULL, NULL, NULL, NULL, NULL, 4),
(167064, NULL, 'G3DSA:3.40.367.20:FF:000043', NULL, NULL, 'Hexokinase', NULL, NULL, NULL, NULL, NULL, 4),
(167065, NULL, 'G3DSA:1.20.1600.10:FF:000044', NULL, NULL, 'TolC family protein', NULL, NULL, NULL, NULL, NULL, 4),
(167066, NULL, 'G3DSA:3.30.70.330:FF:000368', NULL, NULL, 'EWS RNA binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(167067, NULL, 'G3DSA:3.30.1540.20:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167068, NULL, 'G3DSA:3.10.20.90:FF:000167', NULL, NULL, 'Ubiquitin-like 3a', NULL, NULL, NULL, NULL, NULL, 4),
(167069, NULL, 'G3DSA:2.60.60.20:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167070, NULL, 'G3DSA:3.30.200.20:FF:000125', NULL, NULL, 'Protein STRUBBELIG-RECEPTOR FAMILY 8', NULL, NULL, NULL, NULL, NULL, 4),
(167071, NULL, 'G3DSA:1.25.10.10:FF:001485', NULL, NULL, 'Condensin-2 complex subunit D3', NULL, NULL, NULL, NULL, NULL, 4),
(167072, NULL, 'G3DSA:3.90.226.10:FF:000224', NULL, NULL, 'Methylglutaconyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(167073, NULL, 'G3DSA:3.50.50.60:FF:001512', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167074, NULL, 'G3DSA:3.20.20.40:FF:000005', NULL, NULL, 'uncharacterized protein LOC100181482', NULL, NULL, NULL, NULL, NULL, 4),
(167075, NULL, 'G3DSA:1.10.720.30:FF:000073', NULL, NULL, 'ATP-dependent DNA helicase ku70', NULL, NULL, NULL, NULL, NULL, 4),
(167076, NULL, 'G3DSA:1.10.540.10:FF:000126', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(167077, NULL, 'G3DSA:3.30.9.10:FF:000161', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(167078, NULL, 'G3DSA:2.60.120.200:FF:000346', NULL, NULL, 'Apical endosomal glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(167079, NULL, 'G3DSA:2.60.40.10:FF:005826', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167080, NULL, 'G3DSA:1.10.8.270:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167081, NULL, 'G3DSA:3.30.40.10:FF:000823', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(167082, NULL, 'G3DSA:3.40.1360.10:FF:000001', NULL, NULL, 'Recombination protein RecR', NULL, NULL, NULL, NULL, NULL, 4),
(167083, NULL, 'G3DSA:1.20.1560.10:FF:000326', NULL, NULL, 'ATP-binding cassette protein subfamily D, member 3', NULL, NULL, NULL, NULL, NULL, 4),
(167084, NULL, 'G3DSA:1.10.437.10:FF:000021', NULL, NULL, 'Apoptosis regulator BHRF1', NULL, NULL, NULL, NULL, NULL, 4),
(167085, NULL, 'G3DSA:3.40.30.10:FF:000541', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(167086, NULL, 'G3DSA:3.40.50.2300:FF:001609', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167087, NULL, 'G3DSA:3.40.50.1820:FF:001336', NULL, NULL, 'GH06241p', NULL, NULL, NULL, NULL, NULL, 4),
(167088, NULL, 'G3DSA:1.10.565.10:FF:000060', NULL, NULL, 'Nuclear hormone receptor family member nhr-8', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(167089, NULL, 'G3DSA:3.40.1380.10:FF:000014', NULL, NULL, 'ATP synthase gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(167090, NULL, 'G3DSA:1.20.1070.10:FF:001407', NULL, NULL, 'G-protein coupled receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167091, NULL, 'G3DSA:2.60.200.30:FF:000041', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(167092, NULL, 'G3DSA:3.40.50.300:FF:005664', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167093, NULL, 'G3DSA:3.40.630.10:FF:000192', NULL, NULL, 'Succinyl-diaminopimelate desuccinylase', NULL, NULL, NULL, NULL, NULL, 4),
(167094, NULL, 'G3DSA:3.30.70.100:FF:000198', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167095, NULL, 'G3DSA:1.25.40.10:FF:003134', NULL, NULL, 'Interferon-induced protein with tetratricopeptide repeats 1', NULL, NULL, NULL, NULL, NULL, 4),
(167096, NULL, 'G3DSA:3.40.1360.10:FF:000007', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(167097, NULL, 'G3DSA:1.10.1420.10:FF:000122', NULL, NULL, 'AGAP002642-PA', NULL, NULL, NULL, NULL, NULL, 4),
(167098, NULL, 'G3DSA:3.80.10.10:FF:002359', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167099, NULL, 'G3DSA:3.10.129.110:FF:000009', NULL, NULL, 'Probable polyketide synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(167100, NULL, 'G3DSA:3.40.50.2300:FF:000305', NULL, NULL, 'Putative Two-component transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(167101, NULL, 'G3DSA:3.40.50.300:FF:001488', NULL, NULL, 'Putative helicase CHR10', NULL, NULL, NULL, NULL, NULL, 4),
(167102, NULL, 'G3DSA:3.90.1100.10:FF:000044', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(167103, NULL, 'G3DSA:1.20.1070.10:FF:001514', NULL, NULL, 'Melanocortin 1 receptor protein', NULL, NULL, NULL, NULL, NULL, 4),
(167104, NULL, 'G3DSA:1.10.510.10:FF:000141', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(167105, NULL, 'G3DSA:3.40.350.10:FF:000035', NULL, NULL, 'Aminopeptidase P, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167106, NULL, 'G3DSA:2.60.120.260:FF:000420', NULL, NULL, 'Probable cytochrome c', NULL, NULL, NULL, NULL, NULL, 4),
(167107, NULL, 'G3DSA:1.20.120.350:FF:000047', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(167108, NULL, 'G3DSA:1.10.510.10:FF:004323', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167109, NULL, 'G3DSA:2.60.40.1130:FF:000001', NULL, NULL, 'Geranylgeranyl transferase type-2 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(167110, NULL, 'G3DSA:2.70.98.30:FF:000007', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(167111, NULL, 'G3DSA:1.20.58.670:FF:000003', NULL, NULL, 'RAD50-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(167112, NULL, 'G3DSA:1.10.510.10:FF:003699', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167113, NULL, 'G3DSA:1.10.3110.10:FF:000003', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(167114, NULL, 'G3DSA:1.10.630.10:FF:000088', NULL, NULL, 'Cytochrome P450 monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(167115, NULL, 'G3DSA:2.30.110.10:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167116, NULL, 'G3DSA:3.30.56.70:FF:000001', NULL, NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(167117, NULL, 'G3DSA:1.10.510.10:FF:000034', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(167118, NULL, 'G3DSA:1.25.10.10:FF:003430', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167119, NULL, 'G3DSA:3.20.20.70:FF:000447', NULL, NULL, 'N-(5''-phosphoribosyl)anthranilate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(167120, NULL, 'G3DSA:3.80.10.10:FF:003894', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167121, NULL, 'G3DSA:2.40.50.140:FF:000707', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167122, NULL, 'G3DSA:3.40.50.10310:FF:000010', NULL, NULL, 'Creatinine amidohydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(167123, NULL, 'G3DSA:1.20.1070.10:FF:001194', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(167124, NULL, 'G3DSA:1.10.506.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167125, NULL, 'G3DSA:3.30.40.10:FF:001756', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(167126, NULL, 'G3DSA:2.60.40.640:FF:000008', NULL, NULL, 'Down syndrome critical region protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(167127, NULL, 'G3DSA:3.40.850.10:FF:000186', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(167128, NULL, 'G3DSA:3.40.1110.10:FF:000281', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167129, NULL, 'G3DSA:3.40.50.300:FF:001825', NULL, NULL, 'Bifunctional adenosylcobalamin biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(167130, NULL, 'G3DSA:2.130.10.10:FF:002410', NULL, NULL, 'Flagellar associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(167131, NULL, 'G3DSA:3.30.930.10:FF:000082', NULL, NULL, 'Phenylalanine--tRNA ligase chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(167132, NULL, 'G3DSA:3.30.390.10:FF:000012', NULL, NULL, 'Mandelate racemase/muconate lactonizing protein', NULL, NULL, NULL, NULL, NULL, 4),
(167133, NULL, 'G3DSA:2.10.25.10:FF:000549', NULL, NULL, 'Vitamin K-dependent protein C', NULL, NULL, NULL, NULL, NULL, 4),
(167134, NULL, 'G3DSA:3.80.10.10:FF:001505', NULL, NULL, 'F-box/LRR-repeat protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(167135, NULL, 'G3DSA:1.20.120.330:FF:000041', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(167136, NULL, 'G3DSA:3.40.50.620:FF:000538', NULL, NULL, 'Putative tRNA 2-thiolation protein', NULL, NULL, NULL, NULL, NULL, 4),
(167137, NULL, 'G3DSA:3.30.200.20:FF:001429', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(167138, NULL, 'G3DSA:3.30.2350.20:FF:000012', NULL, NULL, 'Putative tRNA pseudouridine synthase D', NULL, NULL, NULL, NULL, NULL, 4),
(167139, NULL, 'G3DSA:3.30.505.10:FF:000151', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167140, NULL, 'G3DSA:1.10.230.10:FF:000007', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(167141, NULL, 'G3DSA:1.25.40.10:FF:001689', NULL, NULL, 'RNA polymerase-associated protein CTR9', NULL, NULL, NULL, NULL, NULL, 4),
(167142, NULL, 'G3DSA:3.90.550.10:FF:000606', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167143, NULL, 'G3DSA:1.10.510.10:FF:002395', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167144, NULL, 'G3DSA:3.60.15.10:FF:000230', NULL, NULL, 'Metallo-beta-lactamase fold-containing protein ST1585', NULL, NULL, NULL, NULL, NULL, 4),
(167145, NULL, 'G3DSA:3.90.25.10:FF:000061', NULL, NULL, 'GDP-L-fucose synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167146, NULL, 'G3DSA:1.10.287.340:FF:000001', NULL, NULL, 'Phosphoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(167147, NULL, 'G3DSA:2.40.10.10:FF:000284', NULL, NULL, 'Serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(167148, NULL, 'G3DSA:3.90.190.10:FF:000623', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167149, NULL, 'G3DSA:3.40.50.150:FF:000802', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167150, NULL, 'G3DSA:3.40.50.2300:FF:001289', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167151, NULL, 'G3DSA:3.90.640.10:FF:000035', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(167152, NULL, 'G3DSA:1.25.40.10:FF:003943', NULL, NULL, 'Pentatricopeptide repeat (PPR) superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(167153, NULL, 'G3DSA:1.20.1270.60:FF:000324', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167154, NULL, 'G3DSA:3.40.50.1400:FF:000018', NULL, NULL, 'Ferrochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(167155, NULL, 'G3DSA:2.40.30.270:FF:000023', NULL, NULL, 'Immunoglobulin mu DNA-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(167156, NULL, 'G3DSA:2.30.29.30:FF:001261', NULL, NULL, 'Putative histone-arginine methyltransferase CARMER-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(167157, NULL, 'G3DSA:3.30.870.10:FF:000122', NULL, NULL, 'Phospholipase D/Transphosphatidylase', NULL, NULL, NULL, NULL, NULL, 4),
(167158, NULL, 'G3DSA:3.40.1800.20:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167159, NULL, 'G3DSA:1.25.10.10:FF:003306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167160, NULL, 'G3DSA:3.30.1380.20:FF:000042', NULL, NULL, 'Trafficking protein particle complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(167161, NULL, 'G3DSA:2.130.10.10:FF:001426', NULL, NULL, 'Sema domain, immunoglobulin domain (Ig), short basic domain, secreted, (semaphorin) 3E', NULL, NULL, NULL, NULL, NULL, 4),
(167162, NULL, 'G3DSA:3.80.10.10:FF:001494', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167163, NULL, 'G3DSA:3.30.160.60:FF:001246', NULL, NULL, 'Zinc finger protein 446', NULL, NULL, NULL, NULL, NULL, 4),
(167164, NULL, 'G3DSA:1.20.1070.10:FF:000098', NULL, NULL, 'Sphingosine 1-phosphate receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(167165, NULL, 'G3DSA:1.10.238.10:FF:000345', NULL, NULL, 'Mechanosensitive ion channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(167166, NULL, 'G3DSA:3.40.50.360:FF:000062', NULL, NULL, 'NAD(P)H quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(167167, NULL, 'G3DSA:1.10.630.10:FF:000425', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167168, NULL, 'G3DSA:4.10.1000.40:FF:000018', NULL, NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', NULL, NULL, NULL, NULL, NULL, 4),
(167169, NULL, 'G3DSA:1.20.120.1760:FF:000016', NULL, NULL, 'ethanolaminephosphotransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(167170, NULL, 'G3DSA:2.60.120.10:FF:000135', NULL, NULL, 'Neuropathy target esterase sws', NULL, NULL, NULL, NULL, NULL, 4),
(167171, NULL, 'G3DSA:3.40.50.300:FF:002444', NULL, NULL, 'DEAD/DEAH box ATP-dependent RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167172, NULL, 'G3DSA:2.10.110.10:FF:000303', NULL, NULL, 'Zyxin', NULL, NULL, NULL, NULL, NULL, 4),
(167173, NULL, 'G3DSA:2.60.40.60:FF:000367', NULL, NULL, 'Protocadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(167174, NULL, 'G3DSA:3.40.50.300:FF:002814', NULL, NULL, 'Translation factor GUF1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(167175, NULL, 'G3DSA:1.25.40.10:FF:002622', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g39952, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(167176, NULL, 'G3DSA:3.30.40.10:FF:002375', NULL, NULL, 'PHD finger protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(167177, NULL, 'G3DSA:1.10.8.720:FF:000077', NULL, NULL, 'Dynein heavy chain 3', NULL, NULL, NULL, NULL, NULL, 4),
(167178, NULL, 'G3DSA:2.60.40.10:FF:003848', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167179, NULL, 'G3DSA:3.30.450.20:FF:000273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167180, NULL, 'G3DSA:2.60.40.10:FF:000285', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(167181, NULL, 'G3DSA:2.40.170.20:FF:000056', NULL, NULL, 'Ferrioxamine receptor FoxA', NULL, NULL, NULL, NULL, NULL, 4),
(167182, NULL, 'G3DSA:2.10.25.10:FF:001168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167183, NULL, 'G3DSA:3.30.420.10:FF:000335', NULL, NULL, 'Pro-Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(167184, NULL, 'G3DSA:1.20.1070.10:FF:000103', NULL, NULL, 'Muscarinic acetylcholine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(167185, NULL, 'G3DSA:3.40.190.10:FF:000539', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(167186, NULL, 'G3DSA:3.40.190.10:FF:000163', NULL, NULL, 'Glutamate ionotropic receptor NMDA type subunit 3B', NULL, NULL, NULL, NULL, NULL, 4),
(167187, NULL, 'G3DSA:3.40.50.300:FF:006176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(167188, NULL, 'G3DSA:3.30.50.10:FF:000088', NULL, NULL, 'Nuclear receptor', NULL, NULL, NULL, NULL, NULL, 4),
(167189, NULL, 'G3DSA:3.90.120.10:FF:000001', NULL, NULL, 'DNA (cytosine-5)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(167190, NULL, 'G3DSA:1.25.10.10:FF:001980', NULL, NULL, 'YALI0E33774p', NULL, NULL, NULL, NULL, NULL, 4),
(167191, NULL, 'G3DSA:1.10.1410.10:FF:000020', NULL, NULL, 'U3 small nucleolar RNA-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(167192, NULL, 'G3DSA:3.40.50.720:FF:000759', NULL, NULL, 'Thiamine biosynthesis protein ThiF', NULL, NULL, NULL, NULL, NULL, 4),
(167193, NULL, 'G3DSA:3.40.50.720:FF:001159', NULL, NULL, 'Polyketide synthase RzxD', NULL, NULL, NULL, NULL, NULL, 4),
(167194, NULL, 'G3DSA:2.30.30.100:FF:000082', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm3', NULL, NULL, NULL, NULL, NULL, 4),
(167195, NULL, 'G3DSA:3.40.50.300:FF:001269', NULL, NULL, 'SNF2 family helicase/ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(167196, NULL, 'G3DSA:1.20.920.10:FF:000046', NULL, NULL, 'Histone acetyltransferase GCN5', NULL, NULL, NULL, NULL, NULL, 4),
(167197, NULL, 'G3DSA:2.60.40.10:FF:002067', NULL, NULL, 'Myosin light chain kinase isoform-II', NULL, NULL, NULL, NULL, NULL, 4),
(167198, NULL, 'G3DSA:3.30.160.60:FF:002191', NULL, NULL, 'Hamlet, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(167199, NULL, 'G3DSA:3.30.230.70:FF:000030', NULL, NULL, 'Exosome complex component RRP42', NULL, NULL, NULL, NULL, NULL, 4),
(167200, NULL, 'G3DSA:1.10.510.10:FF:001922', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167201, NULL, 'G3DSA:2.70.150.10:FF:000124', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(167202, NULL, 'G3DSA:2.30.40.10:FF:000073', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(167203, NULL, 'G3DSA:3.30.420.40:FF:000187', NULL, NULL, 'Actin-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(167204, NULL, 'G3DSA:3.30.40.10:FF:000014', NULL, NULL, 'probable E3 ubiquitin-protein ligase MID2', NULL, NULL, NULL, NULL, NULL, 4),
(167205, NULL, 'G3DSA:1.20.120.1760:FF:000010', NULL, NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(167206, NULL, 'G3DSA:3.40.50.10330:FF:000010', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(167207, NULL, 'G3DSA:1.10.630.10:FF:000453', NULL, NULL, 'Cytochrome P450, family 705, subfamily A, polypeptide 28', NULL, NULL, NULL, NULL, NULL, 4),
(167208, NULL, 'G3DSA:3.90.1420.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167209, NULL, 'G3DSA:2.130.10.10:FF:001454', NULL, NULL, 'WD repeat domain phosphoinositide-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(167210, NULL, 'G3DSA:1.20.1070.10:FF:001879', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167211, NULL, 'G3DSA:1.10.510.10:FF:003704', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167212, NULL, 'G3DSA:2.10.90.10:FF:000094', NULL, NULL, 'Transforming growth factor beta', NULL, NULL, NULL, NULL, NULL, 4),
(167213, NULL, 'G3DSA:2.130.10.10:FF:005597', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase 9', NULL, NULL, NULL, NULL, NULL, 4),
(167214, NULL, 'G3DSA:3.30.450.20:FF:000149', NULL, NULL, 'Peroxide stress-activated histidine kinase mak1', NULL, NULL, NULL, NULL, NULL, 4),
(167215, NULL, 'G3DSA:3.30.420.10:FF:000644', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167216, NULL, 'G3DSA:1.20.1250.20:FF:001834', NULL, NULL, 'Glucose transport protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167217, NULL, 'G3DSA:2.40.70.10:FF:000299', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167218, NULL, 'G3DSA:3.40.50.2000:FF:000805', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167219, NULL, 'G3DSA:1.25.40.10:FF:001998', NULL, NULL, 'Os06g0493801 protein', NULL, NULL, NULL, NULL, NULL, 4),
(167220, NULL, 'G3DSA:3.30.70.1230:FF:000251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(167221, NULL, 'G3DSA:1.25.10.10:FF:002811', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167222, NULL, 'G3DSA:3.30.160.60:FF:002988', NULL, NULL, 'RCG45242, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(167223, NULL, 'G3DSA:3.40.50.1820:FF:001555', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167224, NULL, 'G3DSA:3.40.640.10:FF:000501', NULL, NULL, 'Kynurenine aminotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167225, NULL, 'G3DSA:3.60.40.10:FF:000007', NULL, NULL, 'Phosphatase 2C and cyclic nucleotide-binding/kinase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(167226, NULL, 'G3DSA:3.40.50.300:FF:006159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167227, NULL, 'G3DSA:2.60.120.200:FF:000329', NULL, NULL, 'laminin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(167228, NULL, 'G3DSA:1.20.1250.20:FF:001306', NULL, NULL, 'Major facilitator superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(167229, NULL, 'G3DSA:1.10.10.440:FF:000013', NULL, NULL, 'pre-mRNA-processing protein 40A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(167230, NULL, 'G3DSA:1.10.565.10:FF:000065', NULL, NULL, 'Nuclear hormone receptor family member nhr-91', NULL, NULL, NULL, NULL, NULL, 4),
(167231, NULL, 'G3DSA:3.30.70.141:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167232, NULL, 'G3DSA:3.40.50.200:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167233, NULL, 'G3DSA:1.20.58.60:FF:000069', NULL, NULL, 'dystonin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(167234, NULL, 'G3DSA:2.30.180.10:FF:000146', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167235, NULL, 'G3DSA:3.30.1010.10:FF:000051', NULL, NULL, 'Phosphatidylinositol 4-kinase alpha', NULL, NULL, NULL, NULL, NULL, 4),
(167236, NULL, 'G3DSA:1.20.58.630:FF:000002', NULL, NULL, 'Diaphanous, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(167237, NULL, 'G3DSA:2.30.30.40:FF:000351', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(167238, NULL, 'G3DSA:3.40.30.10:FF:000232', NULL, NULL, 'Endoplasmic reticulum resident protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(167239, NULL, 'G3DSA:2.130.10.10:FF:003360', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(167240, NULL, 'G3DSA:2.60.120.780:FF:000014', NULL, NULL, 'SUMO ligase', NULL, NULL, NULL, NULL, NULL, 4),
(167241, NULL, 'G3DSA:4.10.1000.10:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167242, NULL, 'G3DSA:3.40.50.10420:FF:000043', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(167243, NULL, 'G3DSA:3.40.50.850:FF:000006', NULL, NULL, 'Bifunctional pyrazinamidase/nicotinamidase', NULL, NULL, NULL, NULL, NULL, 4),
(167244, NULL, 'G3DSA:2.130.10.10:FF:004208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167245, NULL, 'G3DSA:2.60.120.330:FF:000149', NULL, NULL, '2-oxoglutarate (2OG) and Fe(II)-dependent oxygenase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(167246, NULL, 'G3DSA:3.30.710.10:FF:000419', NULL, NULL, 'Leucine-zipper-like transcription regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(167247, NULL, 'G3DSA:3.40.50.12550:FF:000013', NULL, NULL, 'Os12g0105975 protein', NULL, NULL, NULL, NULL, NULL, 4),
(167248, NULL, 'G3DSA:3.30.450.40:FF:000026', NULL, NULL, 'Ethylene response sensor', NULL, NULL, NULL, NULL, NULL, 4),
(167249, NULL, 'G3DSA:1.20.1250.20:FF:000452', NULL, NULL, 'sialin-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(167250, NULL, 'G3DSA:1.20.58.60:FF:000597', NULL, NULL, 'Microtubule actin crosslinking factor 1a', NULL, NULL, NULL, NULL, NULL, 4),
(167251, NULL, 'G3DSA:1.20.5.110:FF:000004', NULL, NULL, 'Vesicle-associated membrane protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(167252, NULL, 'G3DSA:2.60.120.200:FF:000565', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(167253, NULL, 'G3DSA:3.60.120.10:FF:000019', NULL, NULL, 'Isochorismate synthase MenF', NULL, NULL, NULL, NULL, NULL, 4),
(167254, NULL, 'G3DSA:2.60.40.10:FF:006029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167255, NULL, 'G3DSA:3.30.160.60:FF:002196', NULL, NULL, 'zinc finger protein 850-like isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(167256, NULL, 'G3DSA:1.10.533.10:FF:000177', NULL, NULL, 'CARD domain-containing protein E10', NULL, NULL, NULL, NULL, NULL, 4),
(167257, NULL, 'G3DSA:2.70.150.10:FF:000141', NULL, NULL, 'Putative calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(167258, NULL, 'G3DSA:1.25.10.10:FF:001850', NULL, NULL, 'Integrator complex subunit 4-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(167259, NULL, 'G3DSA:2.60.40.10:FF:002106', NULL, NULL, 'Soluble VEGFR3 variant 2', NULL, NULL, NULL, NULL, NULL, 4),
(167260, NULL, 'G3DSA:1.20.1250.20:FF:000980', NULL, NULL, 'AGAP003684-PA', NULL, NULL, NULL, NULL, NULL, 4),
(167261, NULL, 'G3DSA:3.30.200.20:FF:001053', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(167262, NULL, 'G3DSA:3.30.2130.30:FF:000021', NULL, NULL, 'THUMP domain-containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(167263, NULL, 'G3DSA:4.10.1110.10:FF:000012', NULL, NULL, 'DNA-binding protein SMUBP-2', NULL, NULL, NULL, NULL, NULL, 4),
(167264, NULL, 'G3DSA:3.30.70.330:FF:001773', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167265, NULL, 'G3DSA:3.40.50.1820:FF:001027', NULL, NULL, 'Dihydrofolate reductase (AFU_orthologue AFUA_3G06620)', NULL, NULL, NULL, NULL, NULL, 4),
(167266, NULL, 'G3DSA:3.40.50.620:FF:000319', NULL, NULL, 'Putative transcriptional regulatory protein NadR', NULL, NULL, NULL, NULL, NULL, 4),
(167267, NULL, 'G3DSA:1.10.238.10:FF:000564', NULL, NULL, 'Calmodulin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(167268, NULL, 'G3DSA:2.20.25.10:FF:000055', NULL, NULL, 'DNA-direcetd RNA polymerase II, subunit 9, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167269, NULL, 'G3DSA:3.40.50.300:FF:008065', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(167270, NULL, 'G3DSA:3.40.50.40:FF:000006', NULL, NULL, 'L-asparaginase I', NULL, NULL, NULL, NULL, NULL, 4),
(167271, NULL, 'G3DSA:2.130.10.10:FF:002415', NULL, NULL, 'Polyadenylation factor subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(167272, NULL, 'G3DSA:3.10.10.10:FF:000013', NULL, NULL, 'Pro-Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(167273, NULL, 'G3DSA:3.60.15.10:FF:000011', NULL, NULL, 'integrator complex subunit 9', NULL, NULL, NULL, NULL, NULL, 4),
(167274, NULL, 'G3DSA:3.40.50.20:FF:000091', NULL, NULL, 'D-alanine--D-alanine ligase A', NULL, NULL, NULL, NULL, NULL, 4),
(167275, NULL, 'G3DSA:1.50.10.20:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167276, NULL, 'G3DSA:1.10.287.1490:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167277, NULL, 'G3DSA:1.10.510.10:FF:001445', NULL, NULL, 'Kinase, CMGC RCK', NULL, NULL, NULL, NULL, NULL, 4),
(167278, NULL, 'G3DSA:3.30.450.20:FF:000020', NULL, NULL, 'Aryl hydrocarbon receptor nuclear translocator 2', NULL, NULL, NULL, NULL, NULL, 4),
(167279, NULL, 'G3DSA:1.10.472.10:FF:000405', NULL, NULL, 'Cyclin domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(167280, NULL, 'G3DSA:2.70.170.10:FF:000007', NULL, NULL, 'Gamma-aminobutyric acid type A receptor rho2 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(167281, NULL, 'G3DSA:1.10.8.10:FF:000197', NULL, NULL, 'Inhibitor of apoptosis protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(167282, NULL, 'G3DSA:1.10.1000.11:FF:000024', NULL, NULL, 'Pleckstrin and Sec7 domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(167283, NULL, 'G3DSA:2.10.60.10:FF:000013', NULL, NULL, 'Urokinase plasminogen activator surface receptor', NULL, NULL, NULL, NULL, NULL, 4),
(167284, NULL, 'G3DSA:3.40.50.10190:FF:000125', NULL, NULL, 'Replication factor C subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(167285, NULL, 'G3DSA:3.40.50.1820:FF:000936', NULL, NULL, 'Protein phosphatase methylesterase 1', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(167286, NULL, 'G3DSA:3.40.50.620:FF:000847', NULL, NULL, 'Kinase with adenine nucleotide alpha hydrolases-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(167287, NULL, 'G3DSA:4.10.80.20:FF:000001', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(167288, NULL, 'G3DSA:2.20.28.200:FF:000004', NULL, NULL, 'Transcriptional regulatory protein sir2b', NULL, NULL, NULL, NULL, NULL, 4),
(167289, NULL, 'G3DSA:3.30.465.10:FF:000068', NULL, NULL, 'HlyC/CorC family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(167290, NULL, 'G3DSA:1.10.510.10:FF:002406', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167291, NULL, 'G3DSA:1.10.20.140:FF:000004', NULL, NULL, 'tRNA dimethylallyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(167292, NULL, 'G3DSA:3.30.40.10:FF:000795', NULL, NULL, 'E3 ubiquitin-protein ligase RMA1H1', NULL, NULL, NULL, NULL, NULL, 4),
(167293, NULL, 'G3DSA:2.30.42.10:FF:000616', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167294, NULL, 'G3DSA:1.10.150.910:FF:000009', NULL, NULL, 'Damaged DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(167295, NULL, 'G3DSA:3.80.10.10:FF:004276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167296, NULL, 'G3DSA:3.40.50.300:FF:001516', NULL, NULL, 'LR34', NULL, NULL, NULL, NULL, NULL, 4),
(167297, NULL, 'G3DSA:1.10.150.50:FF:000187', NULL, NULL, 'Kinase suppressor of Ras 2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(167298, NULL, 'G3DSA:2.130.10.10:FF:000807', NULL, NULL, 'WD repeat-containing protein 60 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(167299, NULL, 'G3DSA:2.60.40.150:FF:000777', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167300, NULL, 'G3DSA:2.30.42.10:FF:000274', NULL, NULL, 'inactivation-no-after-potential D protein', NULL, NULL, NULL, NULL, NULL, 4),
(167301, NULL, 'G3DSA:3.30.40.10:FF:001447', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167302, NULL, 'G3DSA:3.40.50.620:FF:000499', NULL, NULL, 'Probable valine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(167303, NULL, 'G3DSA:2.40.10.480:FF:000003', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(167304, NULL, 'G3DSA:3.30.200.20:FF:000434', NULL, NULL, 'Receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(167305, NULL, 'G3DSA:3.30.559.10:FF:000084', NULL, NULL, 'Spermidine coumaroyl-CoA acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(167306, NULL, 'G3DSA:3.90.640.90:FF:000002', NULL, NULL, 'BTG anti-proliferation factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(167307, NULL, 'G3DSA:4.10.1220.10:FF:000003', NULL, NULL, 'Basement membrane proteoglycan', NULL, NULL, NULL, NULL, NULL, 4),
(167308, NULL, 'G3DSA:1.25.40.20:FF:001355', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(167309, NULL, 'G3DSA:2.170.270.10:FF:000210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167310, NULL, 'G3DSA:3.90.25.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167311, NULL, 'G3DSA:2.130.10.10:FF:000465', NULL, NULL, 'Autophagy-related protein 18g', NULL, NULL, NULL, NULL, NULL, 4),
(167312, NULL, 'G3DSA:3.10.110.10:FF:000204', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 2', NULL, NULL, NULL, NULL, NULL, 4),
(167313, NULL, 'G3DSA:3.40.50.1010:FF:000143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167314, NULL, 'G3DSA:1.25.40.10:FF:001217', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(167315, NULL, 'G3DSA:2.60.120.370:FF:000009', NULL, NULL, 'Uncharacterized protein HI_0227', NULL, NULL, NULL, NULL, NULL, 4),
(167316, NULL, 'G3DSA:1.20.1640.10:FF:000018', NULL, NULL, 'Transmembrane transport protein MmpL10', NULL, NULL, NULL, NULL, NULL, 4),
(167317, NULL, 'G3DSA:3.30.160.60:FF:005933', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167318, NULL, 'G3DSA:3.30.160.60:FF:000251', NULL, NULL, 'FEZ family zinc finger 2', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(167319, NULL, 'G3DSA:3.40.50.300:FF:001140', NULL, NULL, 'Zinc finger NFX1-type containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(167320, NULL, 'G3DSA:3.40.50.300:FF:007581', NULL, NULL, 'RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167321, NULL, 'G3DSA:1.20.1560.10:FF:000298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167322, NULL, 'G3DSA:2.60.40.10:FF:002286', NULL, NULL, 'Cdon', NULL, NULL, NULL, NULL, NULL, 4),
(167323, NULL, 'G3DSA:1.10.418.60:FF:000008', NULL, NULL, 'NDC80 kinetochore complex component NUF2', NULL, NULL, NULL, NULL, NULL, 4),
(167324, NULL, 'G3DSA:2.60.40.60:FF:000732', NULL, NULL, 'Cadherin-4', NULL, NULL, NULL, NULL, NULL, 4),
(167325, NULL, 'G3DSA:1.20.1270.280:FF:000061', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(167326, NULL, 'G3DSA:1.20.20.10:FF:000029', NULL, NULL, 'ATP synthase subunit c', NULL, NULL, NULL, NULL, NULL, 4),
(167327, NULL, 'G3DSA:3.40.50.1110:FF:000038', NULL, NULL, 'Probable carbohydrate esterase At4g34215', NULL, NULL, NULL, NULL, NULL, 4),
(167328, NULL, 'G3DSA:3.10.200.10:FF:000003', NULL, NULL, 'Carbonic anhydrase 12', NULL, NULL, NULL, NULL, NULL, 4),
(167329, NULL, 'G3DSA:1.10.287.110:FF:000056', NULL, NULL, 'DnaJ (Hsp40) homolog, subfamily C, member 24', NULL, NULL, NULL, NULL, NULL, 4),
(167330, NULL, 'G3DSA:1.10.10.60:FF:000454', NULL, NULL, 'Even-skipped homeobox 2', NULL, NULL, NULL, NULL, NULL, 4),
(167331, NULL, 'G3DSA:2.10.25.10:FF:001533', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(167332, NULL, 'G3DSA:3.40.367.20:FF:000026', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(167333, NULL, 'G3DSA:3.30.200.20:FF:002379', NULL, NULL, 'Checkpoint kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(167334, NULL, 'G3DSA:2.70.50.30:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167335, NULL, 'G3DSA:1.10.1200.10:FF:000116', NULL, NULL, 'Polyketide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(167336, NULL, 'G3DSA:2.60.200.20:FF:000049', NULL, NULL, 'Forkhead box protein K1', NULL, NULL, NULL, NULL, NULL, 4),
(167337, NULL, 'G3DSA:1.10.246.140:FF:000011', NULL, NULL, 'Enhancer of yellow 2 transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(167338, NULL, 'G3DSA:3.40.1800.20:FF:000005', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(167339, NULL, 'G3DSA:2.40.10.10:FF:000031', NULL, NULL, 'Haptoglobin', NULL, NULL, NULL, NULL, NULL, 4),
(167340, NULL, 'G3DSA:1.25.40.10:FF:003387', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167341, NULL, 'G3DSA:3.30.70.1180:FF:000005', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(167342, NULL, 'G3DSA:4.10.80.40:FF:000007', NULL, NULL, 'Pre-neck appendage protein', NULL, NULL, NULL, NULL, NULL, 4),
(167343, NULL, 'G3DSA:1.10.510.10:FF:003923', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167344, NULL, 'G3DSA:2.160.20.10:FF:000279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167345, NULL, 'G3DSA:2.70.98.50:FF:000002', NULL, NULL, 'Glycoside hydrolase family 95', NULL, NULL, NULL, NULL, NULL, 4),
(167346, NULL, 'G3DSA:3.90.190.10:FF:000258', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(167347, NULL, 'G3DSA:3.80.10.10:FF:004383', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167348, NULL, 'G3DSA:3.30.230.10:FF:000416', NULL, NULL, 'Putative MLH3, MutL protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(167349, NULL, 'G3DSA:3.40.50.300:FF:003433', NULL, NULL, 'tRNA dimethylallyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(167350, NULL, 'G3DSA:1.25.40.20:FF:001462', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167351, NULL, 'G3DSA:3.30.160.60:FF:001662', NULL, NULL, 'Zinc finger protein 64', NULL, NULL, NULL, NULL, NULL, 4),
(167352, NULL, 'G3DSA:1.20.1300.10:FF:000004', NULL, NULL, 'Succinate dehydrogenase cytochrome B558', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(167353, NULL, 'G3DSA:3.80.10.10:FF:001977', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167354, NULL, 'G3DSA:3.40.50.10310:FF:000015', NULL, NULL, 'Creatininase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(167355, NULL, 'G3DSA:2.20.90.10:FF:000014', NULL, NULL, 'Vitellogenin 3', NULL, NULL, NULL, NULL, NULL, 4),
(167356, NULL, 'G3DSA:3.30.40.10:FF:002392', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167357, NULL, 'G3DSA:3.30.200.20:FF:000917', NULL, NULL, 'Serine/threonine-protein kinase unc-51', NULL, NULL, NULL, NULL, NULL, 4),
(167358, NULL, 'G3DSA:3.40.190.10:FF:000180', NULL, NULL, 'Iron ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(167359, NULL, 'G3DSA:1.25.40.10:FF:004567', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167360, NULL, 'G3DSA:3.40.1090.10:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167361, NULL, 'G3DSA:3.40.50.10190:FF:000344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167362, NULL, 'G3DSA:1.20.5.690:FF:000009', NULL, NULL, 'Importin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(167363, NULL, 'G3DSA:3.40.1190.20:FF:000058', NULL, NULL, 'ATP-dependent (S)-NAD(P)H-hydrate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(167364, NULL, 'G3DSA:1.10.390.10:FF:000075', NULL, NULL, 'Clan MA, family M1, aminopeptidase N-like metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(167365, NULL, 'G3DSA:2.60.40.10:FF:004231', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167366, NULL, 'G3DSA:2.60.40.420:FF:000279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167367, NULL, 'G3DSA:2.60.40.60:FF:000384', NULL, NULL, 'Cadherin 74A, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(167368, NULL, 'G3DSA:3.40.50.300:FF:004231', NULL, NULL, 'Endonuclease MutS2', NULL, NULL, NULL, NULL, NULL, 4),
(167369, NULL, 'G3DSA:1.10.10.60:FF:000235', NULL, NULL, 'Zinc fingers and homeoboxes protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(167370, NULL, 'G3DSA:1.20.1310.10:FF:000139', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167371, NULL, 'G3DSA:2.60.120.430:FF:000033', NULL, NULL, 'Mannan endo-1,4-beta-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(167372, NULL, 'G3DSA:2.40.40.10:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167373, NULL, 'G3DSA:3.30.110.10:FF:000014', NULL, NULL, 'Translation initiation factor IF3-2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(167374, NULL, 'G3DSA:3.30.200.20:FF:001845', NULL, NULL, 'Mitogen-activated protein kinase kinase 7', NULL, NULL, NULL, NULL, NULL, 4),
(167375, NULL, 'G3DSA:3.30.40.10:FF:000828', NULL, NULL, 'E3 ubiquitin-protein ligase At3g02290 family', NULL, NULL, NULL, NULL, NULL, 4),
(167376, NULL, 'G3DSA:3.90.226.10:FF:000207', NULL, NULL, 'Benzoyl-CoA-dihydrodiol lyase', NULL, NULL, NULL, NULL, NULL, 4),
(167377, NULL, 'G3DSA:3.40.50.300:FF:008284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167378, NULL, 'G3DSA:1.10.357.140:FF:000042', NULL, NULL, '2-carboxy-1,4-naphthoquinone phytyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(167379, NULL, 'G3DSA:2.60.40.10:FF:001583', NULL, NULL, 'Frazzled, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(167380, NULL, 'G3DSA:3.40.50.300:FF:008104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167381, NULL, 'G3DSA:1.25.40.10:FF:000514', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(167382, NULL, 'G3DSA:1.25.40.20:FF:000051', NULL, NULL, 'E3 ubiquitin-protein ligase HACE1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(167383, NULL, 'G3DSA:3.30.40.10:FF:000486', NULL, NULL, 'PHD finger and BAH domain (Snt2)', NULL, NULL, NULL, NULL, NULL, 4),
(167384, NULL, 'G3DSA:1.20.5.350:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167385, NULL, 'G3DSA:1.10.238.10:FF:000480', NULL, NULL, 'Probable calcium-binding protein CML27', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(167386, NULL, 'G3DSA:3.20.20.10:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167387, NULL, 'G3DSA:3.40.50.300:FF:002449', NULL, NULL, 'Adenylate kinase 9', NULL, NULL, NULL, NULL, NULL, 4),
(167388, NULL, 'G3DSA:1.25.40.10:FF:004876', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g62590', NULL, NULL, NULL, NULL, NULL, 4),
(167389, NULL, 'G3DSA:3.30.70.100:FF:000193', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167390, NULL, 'G3DSA:3.40.30.10:FF:000917', NULL, NULL, 'Glutathione PeroXidase', NULL, NULL, NULL, NULL, NULL, 4),
(167391, NULL, 'G3DSA:1.20.1250.10:FF:000123', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167392, NULL, 'G3DSA:1.20.1310.20:FF:000024', NULL, NULL, 'Duffy receptor', NULL, NULL, NULL, NULL, NULL, 4),
(167393, NULL, 'G3DSA:4.10.1240.50:FF:000005', NULL, NULL, 'Mesoderm induction early response protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(167394, NULL, 'G3DSA:3.40.50.300:FF:004361', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(167395, NULL, 'G3DSA:3.40.50.300:FF:003742', NULL, NULL, 'Dynamin-related protein 1E', NULL, NULL, NULL, NULL, NULL, 4),
(167396, NULL, 'G3DSA:3.40.50.1110:FF:000055', NULL, NULL, 'Isoamyl acetate-hydrolyzing esterase', NULL, NULL, NULL, NULL, NULL, 4),
(167397, NULL, 'G3DSA:3.30.160.60:FF:000734', NULL, NULL, 'Zinc finger protein 462', NULL, NULL, NULL, NULL, NULL, 4),
(167398, NULL, 'G3DSA:3.40.50.1820:FF:000408', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(167399, NULL, 'G3DSA:1.10.3550.10:FF:000002', NULL, NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(167400, NULL, 'G3DSA:1.25.40.10:FF:005056', NULL, NULL, 'Tetratricopeptide repeat domain 21A', NULL, NULL, NULL, NULL, NULL, 4),
(167401, NULL, 'G3DSA:3.40.190.10:FF:000955', NULL, NULL, 'Uncharacterized lipoprotein MG412', NULL, NULL, NULL, NULL, NULL, 4),
(167402, NULL, 'G3DSA:1.25.40.10:FF:003948', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167403, NULL, 'G3DSA:1.10.3260.10:FF:000031', NULL, NULL, 'DNA ligase IV', NULL, NULL, NULL, NULL, NULL, 4),
(167404, NULL, 'G3DSA:1.10.510.10:FF:000826', NULL, NULL, 'Serine/threonine-protein kinase-like protein CCR1', NULL, NULL, NULL, NULL, NULL, 4),
(167405, NULL, 'G3DSA:1.10.1080.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167406, NULL, 'G3DSA:1.20.5.170:FF:000073', NULL, NULL, 'Voltage-gated hydrogen channel 1', NULL, NULL, NULL, NULL, NULL, 4),
(167407, NULL, 'G3DSA:2.60.120.330:FF:000121', NULL, NULL, 'Naringenin,2-oxoglutarate 3-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(167408, NULL, 'G3DSA:3.90.470.20:FF:000064', NULL, NULL, 'Putative 4''-phosphopantetheinyl transferase HI_0152', NULL, NULL, NULL, NULL, NULL, 4),
(167409, NULL, 'G3DSA:3.30.60.90:FF:000011', NULL, NULL, 'Transcriptional adapter', NULL, NULL, NULL, NULL, NULL, 4),
(167410, NULL, 'G3DSA:1.20.1070.10:FF:000575', NULL, NULL, 'Hector, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(167411, NULL, 'G3DSA:2.130.10.10:FF:003343', NULL, NULL, 'DENN/MADD domain-containing 3a', NULL, NULL, NULL, NULL, NULL, 4),
(167412, NULL, 'G3DSA:4.10.1080.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167413, NULL, 'G3DSA:1.20.58.60:FF:000288', NULL, NULL, 'Karst, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(167414, NULL, 'G3DSA:3.90.1580.10:FF:000017', NULL, NULL, 'Sulfatase-modifying factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(167415, NULL, 'G3DSA:2.130.10.10:FF:004517', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167416, NULL, 'G3DSA:1.10.472.80:FF:000168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167417, NULL, 'G3DSA:1.10.1200.10:FF:000083', NULL, NULL, 'Nonribosomal peptide synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(167418, NULL, 'G3DSA:3.30.2020.30:FF:000007', NULL, NULL, 'Probable gamma-butyrobetaine dioxygenase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(167419, NULL, 'G3DSA:2.60.40.2840:FF:000008', NULL, NULL, 'Phosphatidylethanolamine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(167420, NULL, 'G3DSA:2.130.10.10:FF:003719', NULL, NULL, 'Sema domain, immunoglobulin domain (Ig), short basic domain, secreted, (semaphorin) 3bl', NULL, NULL, NULL, NULL, NULL, 4),
(167421, NULL, 'G3DSA:3.20.20.100:FF:000078', NULL, NULL, 'Aldo-keto reductase family 1 member D1', NULL, NULL, NULL, NULL, NULL, 4),
(167422, NULL, 'G3DSA:1.20.1250.20:FF:000345', NULL, NULL, 'Monosaccharide-sensing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(167423, NULL, 'G3DSA:2.60.40.10:FF:004540', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167424, NULL, 'G3DSA:1.20.120.620:FF:000004', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(167425, NULL, 'G3DSA:3.30.160.60:FF:005405', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167426, NULL, 'G3DSA:3.80.10.10:FF:000089', NULL, NULL, 'volume-regulated anion channel subunit LRRC8B', NULL, NULL, NULL, NULL, NULL, 4),
(167427, NULL, 'G3DSA:1.20.58.390:FF:000245', NULL, NULL, 'Si:ch211-256e16.4', NULL, NULL, NULL, NULL, NULL, 4),
(167428, NULL, 'G3DSA:1.20.1070.10:FF:001986', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(167429, NULL, 'G3DSA:1.10.3720.10:FF:000139', NULL, NULL, 'Glycine betaine/carnitine/choline/L-proline ABC transporter permease ProW', NULL, NULL, NULL, NULL, NULL, 4),
(167430, NULL, 'G3DSA:1.10.10.790:FF:000017', NULL, NULL, 'Splicing factor 3A subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(167431, NULL, 'G3DSA:1.10.3710.10:FF:000004', NULL, NULL, 'Putative ATPase, AAA family', NULL, NULL, NULL, NULL, NULL, 4),
(167432, NULL, 'G3DSA:3.30.40.10:FF:000267', NULL, NULL, 'E3 ubiquitin-protein ligase RNF138 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(167433, NULL, 'G3DSA:1.10.246.10:FF:000004', NULL, NULL, 'Serum albumin', NULL, NULL, NULL, NULL, NULL, 4),
(167434, NULL, 'G3DSA:3.40.50.1820:FF:000066', NULL, NULL, 'Monoglyceride lipase', NULL, NULL, NULL, NULL, NULL, 4),
(167435, NULL, 'G3DSA:2.130.10.10:FF:000246', NULL, NULL, 'striatin-4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(167436, NULL, 'G3DSA:3.90.660.10:FF:000126', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167437, NULL, 'G3DSA:3.40.50.300:FF:004703', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167438, NULL, 'G3DSA:2.60.40.3500:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167439, NULL, 'G3DSA:3.40.50.300:FF:000336', NULL, NULL, 'rac-like GTP-binding protein RHO1', NULL, NULL, NULL, NULL, NULL, 4),
(167440, NULL, 'G3DSA:3.30.200.20:FF:001070', NULL, NULL, 'Si:ch211-63o20.7', NULL, NULL, NULL, NULL, NULL, 4),
(167441, NULL, 'G3DSA:1.20.1250.20:FF:001941', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167442, NULL, 'G3DSA:3.40.50.300:FF:000521', NULL, NULL, 'Type II secretion system protein E', NULL, NULL, NULL, NULL, NULL, 4),
(167443, NULL, 'G3DSA:3.60.10.10:FF:000298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167444, NULL, 'G3DSA:3.40.50.300:FF:008413', NULL, NULL, 'ATP-dependent DEAD/H RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167445, NULL, 'G3DSA:3.40.50.1820:FF:000375', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167446, NULL, 'G3DSA:2.60.450.10:FF:000014', NULL, NULL, 'Lipopolysaccharide export system protein LptA', NULL, NULL, NULL, NULL, NULL, 4),
(167447, NULL, 'G3DSA:1.10.287.130:FF:000067', NULL, NULL, 'Methylmalonic aciduria type A homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(167448, NULL, 'G3DSA:3.40.50.10490:FF:000097', NULL, NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', NULL, NULL, NULL, NULL, NULL, 4),
(167449, NULL, 'G3DSA:3.90.740.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167450, NULL, 'G3DSA:2.10.250.10:FF:000004', NULL, NULL, 'CNE1p Calnexin', NULL, NULL, NULL, NULL, NULL, 4),
(167451, NULL, 'G3DSA:3.20.180.20:FF:000001', NULL, NULL, 'Dynein axonemal heavy chain 5', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(167452, NULL, 'G3DSA:3.40.50.720:FF:002367', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167453, NULL, 'G3DSA:1.10.530.10:FF:000064', NULL, NULL, 'Conjugal transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(167454, NULL, 'G3DSA:2.130.10.10:FF:001870', NULL, NULL, 'WD repeat and HMG-box DNA-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(167455, NULL, 'G3DSA:3.30.420.40:FF:000642', NULL, NULL, 'Exopolyphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(167456, NULL, 'G3DSA:3.60.21.10:FF:000087', NULL, NULL, 'Serine/threonine-protein phosphatase with EF-hands', NULL, NULL, NULL, NULL, NULL, 4),
(167457, NULL, 'G3DSA:3.40.50.300:FF:001741', NULL, NULL, 'Formate--tetrahydrofolate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(167458, NULL, 'G3DSA:3.30.465.10:FF:000085', NULL, NULL, 'Hemolysin C', NULL, NULL, NULL, NULL, NULL, 4),
(167459, NULL, 'G3DSA:3.40.50.2020:FF:000093', NULL, NULL, 'Ribose-phosphate pyrophosphokinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167460, NULL, 'G3DSA:2.60.260.20:FF:000188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167461, NULL, 'G3DSA:1.25.40.10:FF:001661', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167462, NULL, 'G3DSA:3.90.190.10:FF:000489', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167463, NULL, 'G3DSA:2.30.29.30:FF:001221', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(167464, NULL, 'G3DSA:1.20.1250.20:FF:000906', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(167465, NULL, 'G3DSA:2.60.40.10:FF:002887', NULL, NULL, 'Short-form leptin receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(167466, NULL, 'G3DSA:3.30.365.10:FF:000032', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(167467, NULL, 'G3DSA:1.10.238.10:FF:000800', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(167468, NULL, 'G3DSA:1.25.40.90:FF:000010', NULL, NULL, 'EH domain binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(167469, NULL, 'G3DSA:1.10.510.10:FF:000181', NULL, NULL, 'Nuclear receptor-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(167470, NULL, 'G3DSA:3.40.50.1820:FF:000627', NULL, NULL, 'Alpha/beta-Hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(167471, NULL, 'G3DSA:3.30.160.60:FF:006226', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167472, NULL, 'G3DSA:1.25.40.20:FF:000135', NULL, NULL, 'KN motif and ankyrin repeat domains 4', NULL, NULL, NULL, NULL, NULL, 4),
(167473, NULL, 'G3DSA:3.50.30.30:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167474, NULL, 'G3DSA:3.10.350.10:FF:000098', NULL, NULL, 'Intracellular hyphae protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(167475, NULL, 'G3DSA:3.40.50.300:FF:000651', NULL, NULL, 'Lon protease homolog 2, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(167476, NULL, 'G3DSA:3.40.710.10:FF:000153', NULL, NULL, 'Glutaminase like', NULL, NULL, NULL, NULL, NULL, 4),
(167477, NULL, 'G3DSA:3.40.50.300:FF:007665', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167478, NULL, 'G3DSA:1.10.510.10:FF:003940', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167479, NULL, 'G3DSA:3.40.250.10:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167480, NULL, 'G3DSA:2.30.170.20:FF:000002', NULL, NULL, '60S ribosomal protein L24', NULL, NULL, NULL, NULL, NULL, 4),
(167481, NULL, 'G3DSA:3.40.50.11980:FF:000010', NULL, NULL, 'Zinc finger CCCH-type containing 12D', NULL, NULL, NULL, NULL, NULL, 4),
(167482, NULL, 'G3DSA:2.160.20.80:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167483, NULL, 'G3DSA:1.10.510.10:FF:002850', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167484, NULL, 'G3DSA:3.90.70.10:FF:000564', NULL, NULL, 'HL02756p', NULL, NULL, NULL, NULL, NULL, 4),
(167485, NULL, 'G3DSA:3.50.50.60:FF:001057', NULL, NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(167486, NULL, 'G3DSA:3.40.605.10:FF:000004', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(167487, NULL, 'G3DSA:3.90.70.130:FF:000002', NULL, NULL, 'Zinc finger containing ubiquitin peptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(167488, NULL, 'G3DSA:3.30.1330.10:FF:000007', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167489, NULL, 'G3DSA:1.20.1540.10:FF:000078', NULL, NULL, 'Rhomboid protein', NULL, NULL, NULL, NULL, NULL, 4),
(167490, NULL, 'G3DSA:1.20.1250.20:FF:001380', NULL, NULL, 'monocarboxylate transporter 5-like', NULL, NULL, NULL, NULL, NULL, 4),
(167491, NULL, 'G3DSA:3.40.50.300:FF:000212', NULL, NULL, 'Adenylyl-sulfate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(167492, NULL, 'G3DSA:2.70.50.30:FF:000004', NULL, NULL, 'Rho GDP-dissociation inhibitor 1', NULL, NULL, NULL, NULL, NULL, 4),
(167493, NULL, 'G3DSA:3.40.50.720:FF:001294', NULL, NULL, 'Glyoxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(167494, NULL, 'G3DSA:3.40.50.720:FF:000675', NULL, NULL, 'Trk system potassium uptake protein TrkA', NULL, NULL, NULL, NULL, NULL, 4),
(167495, NULL, 'G3DSA:1.20.1070.10:FF:000553', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167496, NULL, 'G3DSA:3.80.10.10:FF:000797', NULL, NULL, 'CTF13p Subunit of the CBF3 complex', NULL, NULL, NULL, NULL, NULL, 4),
(167497, NULL, 'G3DSA:3.30.450.20:FF:000621', NULL, NULL, 'Protein single-minded-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(167498, NULL, 'G3DSA:1.25.10.10:FF:000541', NULL, NULL, 'Splicing factor 3B subunit 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167499, NULL, 'G3DSA:1.10.8.530:FF:000008', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(167500, NULL, 'G3DSA:2.60.40.790:FF:000154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167501, NULL, 'G3DSA:3.40.50.300:FF:007137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167502, NULL, 'G3DSA:3.40.970.10:FF:000003', NULL, NULL, 'Transactivator/viroplasmin protein', NULL, NULL, NULL, NULL, NULL, 4),
(167503, NULL, 'G3DSA:1.20.1250.20:FF:000761', NULL, NULL, 'Major facilitator superfamily MFS_1', NULL, NULL, NULL, NULL, NULL, 4),
(167504, NULL, 'G3DSA:3.40.50.1000:FF:000461', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167505, NULL, 'G3DSA:1.20.1420.10:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167506, NULL, 'G3DSA:1.20.1110.10:FF:000158', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167507, NULL, 'G3DSA:1.20.1250.20:FF:001273', NULL, NULL, 'Conserved hypthetical protein', NULL, NULL, NULL, NULL, NULL, 4),
(167508, NULL, 'G3DSA:2.60.40.10:FF:001903', NULL, NULL, 'Starch synthase 3, chloroplastic/amyloplastic', NULL, NULL, NULL, NULL, NULL, 4),
(167509, NULL, 'G3DSA:3.30.70.80:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167510, NULL, 'G3DSA:1.25.40.570:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167511, NULL, 'G3DSA:3.90.550.50:FF:000006', NULL, NULL, 'Fringe-related protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(167512, NULL, 'G3DSA:1.25.40.10:FF:001133', NULL, NULL, 'Crooked neck protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167513, NULL, 'G3DSA:3.50.7.10:FF:000011', NULL, NULL, 'McKusick-Kaufman/Bardet-Biedl syndromes putative chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(167514, NULL, 'G3DSA:1.25.10.10:FF:002339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167515, NULL, 'G3DSA:3.30.70.330:FF:001329', NULL, NULL, 'GM22984', NULL, NULL, NULL, NULL, NULL, 4),
(167516, NULL, 'G3DSA:3.40.50.2000:FF:000772', NULL, NULL, 'AGAP005163-PA', NULL, NULL, NULL, NULL, NULL, 4),
(167517, NULL, 'G3DSA:2.60.40.10:FF:002994', NULL, NULL, 'Chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(167518, NULL, 'G3DSA:2.60.40.60:FF:000131', NULL, NULL, 'FAT atypical cadherin 4', NULL, NULL, NULL, NULL, NULL, 4),
(167519, NULL, 'G3DSA:1.10.418.80:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(167520, NULL, 'G3DSA:1.25.40.120:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167521, NULL, 'G3DSA:3.40.50.720:FF:000203', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase (SerA)', NULL, NULL, NULL, NULL, NULL, 4),
(167522, NULL, 'G3DSA:3.60.20.10:FF:000197', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167523, NULL, 'G3DSA:2.10.25.10:FF:001516', NULL, NULL, 'Neurogenic locus protein delta-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(167524, NULL, 'G3DSA:1.10.400.10:FF:000043', NULL, NULL, 'Guanine nucleotide-binding protein-like alpha-11 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(167525, NULL, 'G3DSA:3.40.50.1820:FF:001100', NULL, NULL, 'ENC6 protein', NULL, NULL, NULL, NULL, NULL, 4),
(167526, NULL, 'G3DSA:3.30.160.60:FF:001807', NULL, NULL, 'Blast:Transcription factor Sp4', NULL, NULL, NULL, NULL, NULL, 4),
(167527, NULL, 'G3DSA:3.40.30.10:FF:000463', NULL, NULL, 'Pheromone-regulated membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(167528, NULL, 'G3DSA:3.30.70.3250:FF:000003', NULL, NULL, 'Ribonuclease P/MRP protein subunit POP5', NULL, NULL, NULL, NULL, NULL, 4),
(167529, NULL, 'G3DSA:2.130.10.30:FF:000151', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167530, NULL, 'G3DSA:1.25.40.20:FF:001771', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167531, NULL, 'G3DSA:1.20.58.70:FF:000061', NULL, NULL, 'Syntaxin 16/TLG2-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167532, NULL, 'G3DSA:1.25.10.10:FF:000209', NULL, NULL, 'Protein kinase family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(167533, NULL, 'G3DSA:3.10.50.40:FF:000002', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(167534, NULL, 'G3DSA:2.60.120.10:FF:000219', NULL, NULL, 'Probable mannose-6-phosphate isomerase manA', NULL, NULL, NULL, NULL, NULL, 4),
(167535, NULL, 'G3DSA:2.60.120.650:FF:000099', NULL, NULL, 'Jumonji, AT-rich interactive domain 2a', NULL, NULL, NULL, NULL, NULL, 4),
(167536, NULL, 'G3DSA:3.90.550.10:FF:000045', NULL, NULL, 'UTP--glucose-1-phosphate uridylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(167537, NULL, 'G3DSA:3.40.50.300:FF:003394', NULL, NULL, 'GCN20-type ATP-binding cassette protein GCN3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167538, NULL, 'G3DSA:3.30.160.60:FF:004989', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167539, NULL, 'G3DSA:3.40.140.10:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167540, NULL, 'G3DSA:1.25.40.10:FF:001818', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g06140, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(167541, NULL, 'G3DSA:3.40.720.10:FF:000182', NULL, NULL, 'DEAD-box ATP-dependent RNA helicase 18', NULL, NULL, NULL, NULL, NULL, 4),
(167542, NULL, 'G3DSA:3.40.50.720:FF:000889', NULL, NULL, 'Oxidoreductase, Gfo/Idh/MocA family', NULL, NULL, NULL, NULL, NULL, 4),
(167543, NULL, 'G3DSA:3.40.50.300:FF:004922', NULL, NULL, 'Zgc:153654', NULL, NULL, NULL, NULL, NULL, 4),
(167544, NULL, 'G3DSA:4.10.240.10:FF:000013', NULL, NULL, 'C6 transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167545, NULL, 'G3DSA:3.40.50.720:FF:001979', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(167546, NULL, 'G3DSA:3.50.50.60:FF:000023', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(167547, NULL, 'G3DSA:2.130.10.10:FF:005613', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167548, NULL, 'G3DSA:3.30.420.40:FF:000114', NULL, NULL, 'Heat shock 70 kDa protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(167549, NULL, 'G3DSA:1.10.10.10:FF:000052', NULL, NULL, 'Cell cycle response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(167550, NULL, 'G3DSA:1.10.2000.10:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167551, NULL, 'G3DSA:3.30.40.10:FF:001195', NULL, NULL, 'Protein ENHANCED DOWNY MILDEW 2', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(167552, NULL, 'G3DSA:1.10.640.10:FF:000038', NULL, NULL, 'Peroxinectin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167553, NULL, 'G3DSA:1.10.287.1490:FF:000077', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(167554, NULL, 'G3DSA:2.20.28.10:FF:000056', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(167555, NULL, 'G3DSA:3.30.1460.20:FF:000003', NULL, NULL, 'Arp2/3 complex 34 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(167556, NULL, 'G3DSA:2.60.120.260:FF:000448', NULL, NULL, 'Carboxypeptidase X (M14 family), member 2', NULL, NULL, NULL, NULL, NULL, 4),
(167557, NULL, 'G3DSA:2.40.10.10:FF:000632', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167558, NULL, 'G3DSA:2.170.130.10:FF:000014', NULL, NULL, 'SusC/RagA family TonB-linked outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(167559, NULL, 'G3DSA:1.20.1050.10:FF:000012', NULL, NULL, 'Tau class glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(167560, NULL, 'G3DSA:2.60.120.200:FF:000801', NULL, NULL, 'Os07g0569800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(167561, NULL, 'G3DSA:3.40.390.10:FF:000291', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167562, NULL, 'G3DSA:1.20.1070.10:FF:001059', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(167563, NULL, 'G3DSA:3.60.10.10:FF:000168', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(167564, NULL, 'G3DSA:1.25.10.10:FF:001833', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167565, NULL, 'G3DSA:3.40.50.11540:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167566, NULL, 'G3DSA:3.20.140.10:FF:000018', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(167567, NULL, 'G3DSA:1.10.3470.10:FF:000041', NULL, NULL, 'Lipoprotein, SirC, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167568, NULL, 'G3DSA:3.30.40.10:FF:001520', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167569, NULL, 'G3DSA:1.25.40.20:FF:001916', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167570, NULL, 'G3DSA:1.10.10.60:FF:001095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167571, NULL, 'G3DSA:3.40.630.10:FF:000309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167572, NULL, 'G3DSA:3.40.50.1000:FF:000680', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167573, NULL, 'G3DSA:1.20.58.760:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167574, NULL, 'G3DSA:2.70.170.10:FF:000029', NULL, NULL, 'Cholinergic receptor nicotinic alpha 10 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(167575, NULL, 'G3DSA:2.130.10.10:FF:000015', NULL, NULL, 'Semaphorin 3B', NULL, NULL, NULL, NULL, NULL, 4),
(167576, NULL, 'G3DSA:1.50.10.10:FF:000241', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(167577, NULL, 'G3DSA:1.20.5.170:FF:000179', NULL, NULL, 'Autophagy-related protein 16 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(167578, NULL, 'G3DSA:2.60.120.10:FF:000821', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167579, NULL, 'G3DSA:3.90.1150.10:FF:000070', NULL, NULL, 'Putative cystathionine gamma-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(167580, NULL, 'G3DSA:1.10.238.100:FF:000004', NULL, NULL, 'Arr1p', NULL, NULL, NULL, NULL, NULL, 4),
(167581, NULL, 'G3DSA:3.40.50.2000:FF:000463', NULL, NULL, 'Lipid-A-disaccharide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(167582, NULL, 'G3DSA:3.40.50.300:FF:003539', NULL, NULL, 'ADP-ribosylation factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(167583, NULL, 'G3DSA:2.10.25.10:FF:000679', NULL, NULL, 'Latent-transforming growth factor beta-binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(167584, NULL, 'G3DSA:3.40.1190.20:FF:000188', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167585, NULL, 'G3DSA:3.40.50.12780:FF:000177', NULL, NULL, 'LP07340p', NULL, NULL, NULL, NULL, NULL, 4),
(167586, NULL, 'G3DSA:3.40.50.300:FF:008520', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(167587, NULL, 'G3DSA:1.10.10.10:FF:001670', NULL, NULL, 'Putative transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(167588, NULL, 'G3DSA:3.90.79.20:FF:000002', NULL, NULL, 'Peroxisomal NADH pyrophosphatase NUDT12', NULL, NULL, NULL, NULL, NULL, 4),
(167589, NULL, 'G3DSA:3.40.800.10:FF:000020', NULL, NULL, 'Putative agmatinase', NULL, NULL, NULL, NULL, NULL, 4),
(167590, NULL, 'G3DSA:3.40.50.11030:FF:000001', NULL, NULL, 'Threonylcarbamoyl-AMP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(167591, NULL, 'G3DSA:2.60.120.200:FF:000790', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(167592, NULL, 'G3DSA:3.90.1140.10:FF:000018', NULL, NULL, 'Putative eukaryotic LigT', NULL, NULL, NULL, NULL, NULL, 4),
(167593, NULL, 'G3DSA:3.40.50.720:FF:001507', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(167594, NULL, 'G3DSA:3.40.630.30:FF:000214', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(167595, NULL, 'G3DSA:3.80.10.10:FF:000566', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(167596, NULL, 'G3DSA:3.30.2160.10:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167597, NULL, 'G3DSA:3.40.20.10:FF:000170', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(167598, NULL, 'G3DSA:3.40.50.450:FF:000010', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(167599, NULL, 'G3DSA:3.30.565.10:FF:000452', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(167600, NULL, 'G3DSA:3.40.50.300:FF:000319', NULL, NULL, 'DNA repair protein RecN', NULL, NULL, NULL, NULL, NULL, 4),
(167601, NULL, 'G3DSA:1.25.40.10:FF:004640', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167602, NULL, 'G3DSA:3.90.70.10:FF:000457', NULL, NULL, 'Clan CA, family C1, cathepsin L-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(167603, NULL, 'G3DSA:1.10.1070.11:FF:000045', NULL, NULL, 'Serine/threonine-protein kinase smg-1', NULL, NULL, NULL, NULL, NULL, 4),
(167604, NULL, 'G3DSA:2.40.160.10:FF:000007', NULL, NULL, 'Outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(167605, NULL, 'G3DSA:3.40.50.300:FF:004158', NULL, NULL, 'Putative multidrug resistance-associated protein lethal(2)03659-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(167606, NULL, 'G3DSA:3.30.420.110:FF:000051', NULL, NULL, 'DNA mismatch repair protein Msh2', NULL, NULL, NULL, NULL, NULL, 4),
(167607, NULL, 'G3DSA:1.10.287.70:FF:000324', NULL, NULL, 'GLutamate Receptor family (AMPA)', NULL, NULL, NULL, NULL, NULL, 4),
(167608, NULL, 'G3DSA:3.40.710.10:FF:000046', NULL, NULL, 'Transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(167609, NULL, 'G3DSA:1.20.1740.10:FF:000059', NULL, NULL, 'Na(+)-linked D-alanine glycine permease', NULL, NULL, NULL, NULL, NULL, 4),
(167610, NULL, 'G3DSA:3.40.50.2300:FF:000980', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167611, NULL, 'G3DSA:1.10.418.10:FF:000134', NULL, NULL, 'kinesin-4-like', NULL, NULL, NULL, NULL, NULL, 4),
(167612, NULL, 'G3DSA:1.10.238.200:FF:000028', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(167613, NULL, 'G3DSA:3.50.30.20:FF:000004', NULL, NULL, 'Carbamoyl-phosphate synthase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(167614, NULL, 'G3DSA:2.120.10.80:FF:000082', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(167615, NULL, 'G3DSA:2.60.40.1730:FF:000001', NULL, NULL, 'Leucyl-cystinyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(167616, NULL, 'G3DSA:3.90.190.10:FF:000275', NULL, NULL, 'Tensin 1', NULL, NULL, NULL, NULL, NULL, 4),
(167617, NULL, 'G3DSA:3.30.479.20:FF:000029', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(167618, NULL, 'G3DSA:3.30.830.10:FF:000018', NULL, NULL, 'Cytochrome b-c1 complex subunit 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(167619, NULL, 'G3DSA:2.60.40.790:FF:000047', NULL, NULL, '23.6 kDa heat shock protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(167620, NULL, 'G3DSA:1.25.40.20:FF:000843', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167621, NULL, 'G3DSA:3.30.200.20:FF:001738', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(167622, NULL, 'G3DSA:1.10.238.10:FF:000036', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(167623, NULL, 'G3DSA:1.10.287.380:FF:000018', NULL, NULL, 'Putative ABC transporter ATP-binding potein', NULL, NULL, NULL, NULL, NULL, 4),
(167624, NULL, 'G3DSA:2.60.40.10:FF:003612', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167625, NULL, 'G3DSA:3.30.420.40:FF:000895', NULL, NULL, 'N-acetylgalactosamine kinase AgaK', NULL, NULL, NULL, NULL, NULL, 4),
(167626, NULL, 'G3DSA:3.40.33.10:FF:000014', NULL, NULL, 'C-type lectin domain family 18 member A', NULL, NULL, NULL, NULL, NULL, 4),
(167627, NULL, 'G3DSA:2.40.50.140:FF:000691', NULL, NULL, 'Lysine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(167628, NULL, 'G3DSA:3.90.180.10:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167629, NULL, 'G3DSA:3.30.200.20:FF:001614', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167630, NULL, 'G3DSA:1.20.5.110:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167631, NULL, 'G3DSA:1.10.8.270:FF:000043', NULL, NULL, 'AGAP000552-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(167632, NULL, 'G3DSA:3.40.50.1820:FF:000858', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167633, NULL, 'G3DSA:3.30.160.60:FF:003825', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167634, NULL, 'G3DSA:1.10.10.10:FF:001198', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(167635, NULL, 'G3DSA:3.40.50.1820:FF:000482', NULL, NULL, 'DltD N-terminal domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(167636, NULL, 'G3DSA:1.25.10.10:FF:001305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167637, NULL, 'G3DSA:3.30.420.320:FF:000001', NULL, NULL, 'Tripartite terminase subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(167638, NULL, 'G3DSA:2.170.150.20:FF:000018', NULL, NULL, 'AGAP004264-PA', NULL, NULL, NULL, NULL, NULL, 4),
(167639, NULL, 'G3DSA:1.25.40.10:FF:000037', NULL, NULL, 'Putative pre-mRNA-processing factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(167640, NULL, 'G3DSA:3.80.10.10:FF:003978', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167641, NULL, 'G3DSA:3.40.190.290:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167642, NULL, 'G3DSA:3.60.20.10:FF:000091', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(167643, NULL, 'G3DSA:3.80.10.10:FF:000544', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3', NULL, NULL, NULL, NULL, NULL, 4),
(167644, NULL, 'G3DSA:3.40.50.720:FF:001530', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167645, NULL, 'G3DSA:1.20.1250.20:FF:001525', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(167646, NULL, 'G3DSA:3.40.50.300:FF:000105', NULL, NULL, 'BMS1 ribosome biogenesis factor', NULL, NULL, NULL, NULL, NULL, 4),
(167647, NULL, 'G3DSA:3.30.450.40:FF:000251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167648, NULL, 'G3DSA:3.30.300.30:FF:000147', NULL, NULL, 'O-succinylbenzoic acid CoA ligase MenE', NULL, NULL, NULL, NULL, NULL, 4),
(167649, NULL, 'G3DSA:1.20.120.1750:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167650, NULL, 'G3DSA:3.30.160.820:FF:000001', NULL, NULL, 'Orf1ab polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(167651, NULL, 'G3DSA:1.20.120.350:FF:000266', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167652, NULL, 'G3DSA:3.40.30.10:FF:000991', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167653, NULL, 'G3DSA:1.10.100.10:FF:000003', NULL, NULL, 'Insulin', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(167654, NULL, 'G3DSA:3.90.1750.10:FF:000048', NULL, NULL, 'E3 ubiquitin-protein ligase UPL3', NULL, NULL, NULL, NULL, NULL, 4),
(167655, NULL, 'G3DSA:3.40.50.880:FF:000021', NULL, NULL, 'Anthranilate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(167656, NULL, 'G3DSA:1.20.1270.60:FF:000072', NULL, NULL, 'Sorting nexin MVP1', NULL, NULL, NULL, NULL, NULL, 4),
(167657, NULL, 'G3DSA:2.60.40.10:FF:001667', NULL, NULL, 'Sallimus, isoform P', NULL, NULL, NULL, NULL, NULL, 4),
(167658, NULL, 'G3DSA:3.90.79.10:FF:000213', NULL, NULL, 'Bll2550 protein', NULL, NULL, NULL, NULL, NULL, 4),
(167659, NULL, 'G3DSA:3.30.70.330:FF:001857', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167660, NULL, 'G3DSA:2.30.30.30:FF:000033', NULL, NULL, 'Woronin body major protein HEX1', NULL, NULL, NULL, NULL, NULL, 4),
(167661, NULL, 'G3DSA:3.40.50.300:FF:002466', NULL, NULL, 'Rab B GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(167662, NULL, 'G3DSA:1.20.5.170:FF:000090', NULL, NULL, 'Propionate catabolism operon regulatory protein PrpR', NULL, NULL, NULL, NULL, NULL, 4),
(167663, NULL, 'G3DSA:4.10.280.10:FF:000246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167664, NULL, 'G3DSA:2.60.40.10:FF:001358', NULL, NULL, 'Cilia and flagella associated protein 221', NULL, NULL, NULL, NULL, NULL, 4),
(167665, NULL, 'G3DSA:1.10.10.60:FF:000004', NULL, NULL, 'Meis2 homeobox isoform 2c', NULL, NULL, NULL, NULL, NULL, 4),
(167666, NULL, 'G3DSA:2.60.40.4370:FF:000006', NULL, NULL, 'GD10187', NULL, NULL, NULL, NULL, NULL, 4),
(167667, NULL, 'G3DSA:1.20.1440.180:FF:000002', NULL, NULL, 'Serine/threonine-protein kinase/endoribonuclease IRE1', NULL, NULL, NULL, NULL, NULL, 4),
(167668, NULL, 'G3DSA:3.30.450.50:FF:000040', NULL, NULL, 'vesicle-associated membrane protein 7-like', NULL, NULL, NULL, NULL, NULL, 4),
(167669, NULL, 'G3DSA:1.10.10.2320:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167670, NULL, 'G3DSA:3.30.60.30:FF:000235', NULL, NULL, 'Agrin-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(167671, NULL, 'G3DSA:2.60.40.10:FF:005181', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167672, NULL, 'G3DSA:3.40.630.30:FF:000670', NULL, NULL, 'Protein CBG11297', NULL, NULL, NULL, NULL, NULL, 4),
(167673, NULL, 'G3DSA:3.30.470.30:FF:000024', NULL, NULL, 'ATP-dependent DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(167674, NULL, 'G3DSA:1.20.900.10:FF:000028', NULL, NULL, 'Puratrophin-1-like, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(167675, NULL, 'G3DSA:1.10.472.130:FF:000091', NULL, NULL, 'Dynein heavy chain, cytosolic, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167676, NULL, 'G3DSA:3.40.50.150:FF:001746', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167677, NULL, 'G3DSA:1.10.540.10:FF:000093', NULL, NULL, 'Glutaryl-CoA dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(167678, NULL, 'G3DSA:3.30.830.10:FF:000237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167679, NULL, 'G3DSA:1.20.1560.10:FF:000309', NULL, NULL, 'ABC transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(167680, NULL, 'G3DSA:3.30.70.330:FF:001296', NULL, NULL, 'Alternative splicing factor', NULL, NULL, NULL, NULL, NULL, 4),
(167681, NULL, 'G3DSA:3.30.40.10:FF:000806', NULL, NULL, 'PHD finger family protein', NULL, NULL, NULL, NULL, NULL, 4),
(167682, NULL, 'G3DSA:3.30.450.50:FF:000017', NULL, NULL, 'Synaptobrevin-like protein Sybl1', NULL, NULL, NULL, NULL, NULL, 4),
(167683, NULL, 'G3DSA:3.10.105.10:FF:000006', NULL, NULL, 'Peptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(167684, NULL, 'G3DSA:3.40.430.10:FF:000019', NULL, NULL, 'Riboflavin biosynthesis protein RibD', NULL, NULL, NULL, NULL, NULL, 4),
(167685, NULL, 'G3DSA:3.30.70.330:FF:001638', NULL, NULL, 'EWS RNA-binding protein 1b', NULL, NULL, NULL, NULL, NULL, 4),
(167686, NULL, 'G3DSA:3.30.200.20:FF:002143', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(167687, NULL, 'G3DSA:3.40.50.300:FF:005647', NULL, NULL, 'DNA replication licensing factor, MCM2/3/5 family', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(167688, NULL, 'G3DSA:1.10.1170.10:FF:000012', NULL, NULL, 'E3 ubiquitin-protein ligase XIAP isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(167689, NULL, 'G3DSA:1.25.40.10:FF:003151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167690, NULL, 'G3DSA:1.10.8.60:FF:000256', NULL, NULL, 'Nuclear VCP-like', NULL, NULL, NULL, NULL, NULL, 4),
(167691, NULL, 'G3DSA:1.10.287.70:FF:000779', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167692, NULL, 'G3DSA:3.30.450.20:FF:000256', NULL, NULL, 'Hypothetical regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(167693, NULL, 'G3DSA:3.40.50.300:FF:006940', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(167694, NULL, 'G3DSA:1.10.10.10:FF:000361', NULL, NULL, 'Terminase small subunit nu1', NULL, NULL, NULL, NULL, NULL, 4),
(167695, NULL, 'G3DSA:3.40.50.1010:FF:000227', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167696, NULL, 'G3DSA:3.40.50.150:FF:001218', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(167697, NULL, 'G3DSA:3.40.50.970:FF:000059', NULL, NULL, '2-oxoisovalerate dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(167698, NULL, 'G3DSA:3.40.50.300:FF:005794', NULL, NULL, 'Vesicular fusion ATPase, putative (AFU_orthologue AFUA_3G12510)', NULL, NULL, NULL, NULL, NULL, 4),
(167699, NULL, 'G3DSA:2.60.40.10:FF:005956', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167700, NULL, 'G3DSA:1.10.510.10:FF:004340', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167701, NULL, 'G3DSA:1.25.10.10:FF:001069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167702, NULL, 'G3DSA:1.10.260.40:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167703, NULL, 'G3DSA:3.40.395.10:FF:000043', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(167704, NULL, 'G3DSA:1.25.10.10:FF:000996', NULL, NULL, 'Armadillo repeat-containing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(167705, NULL, 'G3DSA:3.80.10.10:FF:001185', NULL, NULL, 'Acid labile subunit', NULL, NULL, NULL, NULL, NULL, 4),
(167706, NULL, 'G3DSA:2.60.40.10:FF:000633', NULL, NULL, 'Sushi, nidogen and EGF like domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(167707, NULL, 'G3DSA:2.10.90.10:FF:000077', NULL, NULL, 'TransformIng Growth factor beta family', NULL, NULL, NULL, NULL, NULL, 4),
(167708, NULL, 'G3DSA:2.60.120.1540:FF:000023', NULL, NULL, 'Complement component C5', NULL, NULL, NULL, NULL, NULL, 4),
(167709, NULL, 'G3DSA:1.10.10.10:FF:001209', NULL, NULL, 'Metallo-beta-lactamase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(167710, NULL, 'G3DSA:3.20.20.70:FF:000183', NULL, NULL, 'Orotidine-5-phosphate decarboxylase/orotate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(167711, NULL, 'G3DSA:3.30.40.10:FF:000031', NULL, NULL, 'Cellulose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(167712, NULL, 'G3DSA:3.50.50.60:FF:000675', NULL, NULL, 'Aerobic glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(167713, NULL, 'G3DSA:2.40.30.10:FF:000375', NULL, NULL, 'YALI0F29161p', NULL, NULL, NULL, NULL, NULL, 4),
(167714, NULL, 'G3DSA:3.90.245.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167715, NULL, 'G3DSA:1.10.30.10:FF:000013', NULL, NULL, 'High mobility group protein B3', NULL, NULL, NULL, NULL, NULL, 4),
(167716, NULL, 'G3DSA:2.60.40.10:FF:001139', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(167717, NULL, 'G3DSA:3.30.70.330:FF:000677', NULL, NULL, 'Cytoplasmic polyadenylation element-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(167718, NULL, 'G3DSA:3.40.50.300:FF:007901', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167719, NULL, 'G3DSA:3.30.1330.40:FF:000005', NULL, NULL, 'Enamine deaminase RidA (YjgF/YER057c/UK114 family)', NULL, NULL, NULL, NULL, NULL, 4),
(167720, NULL, 'G3DSA:2.60.200.20:FF:000156', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(167721, NULL, 'G3DSA:1.10.730.10:FF:000028', NULL, NULL, 'Methionine--tRNA ligase, chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(167722, NULL, 'G3DSA:3.20.20.70:FF:000525', NULL, NULL, 'Fructose-bisphosphate aldolase class 1', NULL, NULL, NULL, NULL, NULL, 4),
(167723, NULL, 'G3DSA:2.60.120.10:FF:000113', NULL, NULL, 'cAMP-dependent protein kinase type II-alpha regulatory subunit isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(167724, NULL, 'G3DSA:3.30.420.40:FF:000423', NULL, NULL, 'Chaperone protein DNAK, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167725, NULL, 'G3DSA:3.30.1130.10:FF:000026', NULL, NULL, 'Folic acid synthesis protein fol1', NULL, NULL, NULL, NULL, NULL, 4),
(167726, NULL, 'G3DSA:1.10.10.10:FF:001541', NULL, NULL, 'General transcription factor IIE subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(167727, NULL, 'G3DSA:3.30.160.60:FF:001555', NULL, NULL, 'Draculin-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(167728, NULL, 'G3DSA:1.25.40.10:FF:001239', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g31850, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(167729, NULL, 'G3DSA:3.30.160.60:FF:002207', NULL, NULL, 'Zinc finger protein 74', NULL, NULL, NULL, NULL, NULL, 4),
(167730, NULL, 'G3DSA:3.20.20.80:FF:000332', NULL, NULL, 'Alpha-L-fucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(167731, NULL, 'G3DSA:1.20.140.10:FF:000060', NULL, NULL, 'Acyl-CoA dehydrogenase FadE18', NULL, NULL, NULL, NULL, NULL, 4),
(167732, NULL, 'G3DSA:3.30.2020.30:FF:000029', NULL, NULL, 'AEL035Wp', NULL, NULL, NULL, NULL, NULL, 4),
(167733, NULL, 'G3DSA:1.20.890.10:FF:000032', NULL, NULL, 'Guanylate kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167734, NULL, 'G3DSA:2.10.70.10:FF:000064', NULL, NULL, 'Fibulin 7', NULL, NULL, NULL, NULL, NULL, 4),
(167735, NULL, 'G3DSA:3.30.70.330:FF:003083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167736, NULL, 'G3DSA:3.30.870.10:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167737, NULL, 'G3DSA:1.25.40.10:FF:000060', NULL, NULL, 'Golgi to ER traffic protein 4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(167738, NULL, 'G3DSA:3.40.30.10:FF:000772', NULL, NULL, 'OST3/OST6 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(167739, NULL, 'G3DSA:1.20.190.50:FF:000007', NULL, NULL, 'Nuclear pore complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(167740, NULL, 'G3DSA:3.40.50.300:FF:006412', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167741, NULL, 'G3DSA:3.90.1200.10:FF:000063', NULL, NULL, 'Hydroxylysine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(167742, NULL, 'G3DSA:1.10.8.10:FF:000157', NULL, NULL, 'Phosphoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(167743, NULL, 'G3DSA:3.60.21.10:FF:000323', NULL, NULL, 'Slr0306 protein', NULL, NULL, NULL, NULL, NULL, 4),
(167744, NULL, 'G3DSA:1.20.58.60:FF:000524', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167745, NULL, 'G3DSA:3.30.430.20:FF:000058', NULL, NULL, 'Putative DUF26-domain protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(167746, NULL, 'G3DSA:3.40.50.1000:FF:000129', NULL, NULL, 'Calcium-translocating P-type ATPase PMCA-type', NULL, NULL, NULL, NULL, NULL, 4),
(167747, NULL, 'G3DSA:1.10.840.10:FF:000019', NULL, NULL, 'Guanine nucleotide exchange factor LTE1', NULL, NULL, NULL, NULL, NULL, 4),
(167748, NULL, 'G3DSA:3.40.50.150:FF:000038', NULL, NULL, 'Site-specific DNA-methyltransferase (adenine-specific)', NULL, NULL, NULL, NULL, NULL, 4),
(167749, NULL, 'G3DSA:1.20.5.650:FF:000008', NULL, NULL, 'Transcription initiation factor IIIB chain BRF, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167750, NULL, 'G3DSA:1.10.20.10:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167751, NULL, 'G3DSA:2.10.60.10:FF:000035', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(167752, NULL, 'G3DSA:1.10.472.10:FF:000299', NULL, NULL, 'BRF2, RNA polymerase III transcription initiation factor subunit', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(167753, NULL, 'G3DSA:1.25.10.10:FF:003323', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(167754, NULL, 'G3DSA:3.90.1150.10:FF:000446', NULL, NULL, 'Aminotransferase, class III', NULL, NULL, NULL, NULL, NULL, 4),
(167755, NULL, 'G3DSA:2.130.10.10:FF:005361', NULL, NULL, 'Wd-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167756, NULL, 'G3DSA:1.10.3730.20:FF:000008', NULL, NULL, 'EamA family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(167757, NULL, 'G3DSA:3.30.160.60:FF:006102', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167758, NULL, 'G3DSA:1.25.10.10:FF:002233', NULL, NULL, 'Exportin-4', NULL, NULL, NULL, NULL, NULL, 4),
(167759, NULL, 'G3DSA:3.30.930.10:FF:000402', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167760, NULL, 'G3DSA:1.10.510.10:FF:002086', NULL, NULL, 'Probable serine/threonine-protein kinase cdc7', NULL, NULL, NULL, NULL, NULL, 4),
(167761, NULL, 'G3DSA:3.30.70.330:FF:000929', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167762, NULL, 'G3DSA:3.40.50.80:FF:000187', NULL, NULL, 'YALI0C21362p', NULL, NULL, NULL, NULL, NULL, 4),
(167763, NULL, 'G3DSA:3.40.50.300:FF:001033', NULL, NULL, 'Shikimate kinase 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(167764, NULL, 'G3DSA:1.10.4080.10:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(167765, NULL, 'G3DSA:3.20.20.60:FF:000085', NULL, NULL, '2,4-dihydroxyhept-2-ene-1,7-dioic acid aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(167766, NULL, 'G3DSA:2.130.10.10:FF:005158', NULL, NULL, 'Protein DECREASED SIZE EXCLUSION LIMIT 1', NULL, NULL, NULL, NULL, NULL, 4),
(167767, NULL, 'G3DSA:3.30.300.20:FF:000054', NULL, NULL, 'Ribosome-binding factor A', NULL, NULL, NULL, NULL, NULL, 4),
(167768, NULL, 'G3DSA:3.30.420.10:FF:000116', NULL, NULL, 'Putative DNA polymerase III epsilon subunit (3''-5'' exonuclease)', NULL, NULL, NULL, NULL, NULL, 4),
(167769, NULL, 'G3DSA:3.20.10.10:FF:000035', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(167770, NULL, 'G3DSA:1.25.40.60:FF:000012', NULL, NULL, 'SNARE docking complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(167771, NULL, 'G3DSA:3.40.190.80:FF:000032', NULL, NULL, 'Putative inositol monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(167772, NULL, 'G3DSA:3.30.160.60:FF:002516', NULL, NULL, 'Zinc finger and SCAN domain-containing protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(167773, NULL, 'G3DSA:3.30.450.40:FF:000048', NULL, NULL, 'Free methionine-R-sulfoxide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(167774, NULL, 'G3DSA:3.60.10.10:FF:000371', NULL, NULL, 'Inositol polyphosphate-5-phosphatase Ka', NULL, NULL, NULL, NULL, NULL, 4),
(167775, NULL, 'G3DSA:3.30.160.60:FF:005394', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167776, NULL, 'G3DSA:1.10.3080.10:FF:000005', NULL, NULL, 'H(+)/Cl(-) exchange transporter ClcA', NULL, NULL, NULL, NULL, NULL, 4),
(167777, NULL, 'G3DSA:2.80.10.50:FF:000148', NULL, NULL, 'Botulinum neurotoxin type B', NULL, NULL, NULL, NULL, NULL, 4),
(167778, NULL, 'G3DSA:3.40.1170.60:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167779, NULL, 'G3DSA:3.40.50.1220:FF:000088', NULL, NULL, 'Acetolactate synthase, large subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167780, NULL, 'G3DSA:3.10.129.120:FF:000001', NULL, NULL, 'CurJ', NULL, NULL, NULL, NULL, NULL, 4),
(167781, NULL, 'G3DSA:3.30.470.20:FF:000055', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(167782, NULL, 'G3DSA:1.10.10.10:FF:000922', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(167783, NULL, 'G3DSA:2.10.25.10:FF:001769', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167784, NULL, 'G3DSA:3.40.50.1000:FF:000005', NULL, NULL, 'Calcium-transporting ATPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(167785, NULL, 'G3DSA:3.30.160.60:FF:002174', NULL, NULL, 'Zinc finger protein 786', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(167786, NULL, 'G3DSA:2.60.40.10:FF:004995', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167787, NULL, 'G3DSA:2.60.40.150:FF:000322', NULL, NULL, 'Extended SYnapTotagmin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(167788, NULL, 'G3DSA:3.20.20.190:FF:000048', NULL, NULL, 'PI-PLC X domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(167789, NULL, 'G3DSA:2.60.120.290:FF:000209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167790, NULL, 'G3DSA:3.20.20.140:FF:000314', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(167791, NULL, 'G3DSA:3.40.50.1000:FF:000152', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(167792, NULL, 'G3DSA:1.10.10.10:FF:000580', NULL, NULL, 'Cell division control protein', NULL, NULL, NULL, NULL, NULL, 4),
(167793, NULL, 'G3DSA:3.40.850.10:FF:000528', NULL, NULL, 'Kinesin-like protein KIN-7N', NULL, NULL, NULL, NULL, NULL, 4),
(167794, NULL, 'G3DSA:3.40.50.300:FF:002921', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(167795, NULL, 'G3DSA:1.50.40.10:FF:000321', NULL, NULL, 'Mitochondrial phosphate carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167796, NULL, 'G3DSA:3.30.505.10:FF:000021', NULL, NULL, 'Putative SH2 domain-containing adapter protein F', NULL, NULL, NULL, NULL, NULL, 4),
(167797, NULL, 'G3DSA:1.10.3460.10:FF:000012', NULL, NULL, 'Fucoxanthin chlorophyll a/c protein, LI818 clade', NULL, NULL, NULL, NULL, NULL, 4),
(167798, NULL, 'G3DSA:3.30.160.20:FF:000065', NULL, NULL, 'Peptidyl-tRNA hydrolase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(167799, NULL, 'G3DSA:2.30.140.10:FF:000025', NULL, NULL, 'Polyamine aminopropyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(167800, NULL, 'G3DSA:3.40.720.10:FF:000339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167801, NULL, 'G3DSA:3.40.50.2000:FF:000569', NULL, NULL, 'UDP-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(167802, NULL, 'G3DSA:1.10.1040.30:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167803, NULL, 'G3DSA:3.40.970.40:FF:000001', NULL, NULL, 'Fibronectin-binding protein / Fibrinogen-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(167804, NULL, 'G3DSA:3.40.50.300:FF:002213', NULL, NULL, 'Putative dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(167805, NULL, 'G3DSA:1.25.40.80:FF:000018', NULL, NULL, '(6-4) photolyase', NULL, NULL, NULL, NULL, NULL, 4),
(167806, NULL, 'G3DSA:3.60.10.10:FF:000062', NULL, NULL, 'Putative phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(167807, NULL, 'G3DSA:1.10.238.270:FF:000009', NULL, NULL, 'GM21538', NULL, NULL, NULL, NULL, NULL, 4),
(167808, NULL, 'G3DSA:2.130.10.10:FF:005922', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167809, NULL, 'G3DSA:2.20.28.230:FF:000002', NULL, NULL, 'Interleukin-2 receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(167810, NULL, 'G3DSA:3.80.10.10:FF:003107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167811, NULL, 'G3DSA:2.20.100.10:FF:000188', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(167812, NULL, 'G3DSA:3.40.50.2300:FF:000777', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167813, NULL, 'G3DSA:1.20.1560.10:FF:000770', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167814, NULL, 'G3DSA:1.10.630.10:FF:000009', NULL, NULL, 'Cytochrome P450 26B1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(167815, NULL, 'G3DSA:3.40.50.150:FF:001527', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167816, NULL, 'G3DSA:3.30.1640.10:FF:000076', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(167817, NULL, 'G3DSA:2.60.40.420:FF:000190', NULL, NULL, 'Blue copper protein', NULL, NULL, NULL, NULL, NULL, 4),
(167818, NULL, 'G3DSA:1.25.40.180:FF:000263', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167819, NULL, 'G3DSA:3.40.850.10:FF:000219', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(167820, NULL, 'G3DSA:3.20.20.80:FF:000641', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167821, NULL, 'G3DSA:3.40.630.10:FF:000203', NULL, NULL, 'Carboxypeptidase M', NULL, NULL, NULL, NULL, NULL, 4),
(167822, NULL, 'G3DSA:1.50.40.10:FF:000445', NULL, NULL, 'GH07093p', NULL, NULL, NULL, NULL, NULL, 4),
(167823, NULL, 'G3DSA:3.10.580.10:FF:000143', NULL, NULL, 'Meiotically up-regulated gene 70 protein', NULL, NULL, NULL, NULL, NULL, 4),
(167824, NULL, 'G3DSA:2.60.40.10:FF:000178', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM9 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(167825, NULL, 'G3DSA:3.80.10.10:FF:002798', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167826, NULL, 'G3DSA:2.40.160.40:FF:000005', NULL, NULL, 'Outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(167827, NULL, 'G3DSA:3.30.160.60:FF:002735', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(167828, NULL, 'G3DSA:2.60.120.260:FF:000105', NULL, NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(167829, NULL, 'G3DSA:3.40.50.300:FF:005086', NULL, NULL, 'Ras family protein', NULL, NULL, NULL, NULL, NULL, 4),
(167830, NULL, 'G3DSA:3.40.50.300:FF:001960', NULL, NULL, 'Adenylate kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(167831, NULL, 'G3DSA:1.25.40.10:FF:004112', NULL, NULL, 'Slr1196 protein', NULL, NULL, NULL, NULL, NULL, 4),
(167832, NULL, 'G3DSA:3.80.10.10:FF:002674', NULL, NULL, 'Nodule autoregulation receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(167833, NULL, 'G3DSA:3.30.479.10:FF:000010', NULL, NULL, '6-carboxy-5,6,7,8-tetrahydropterin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(167834, NULL, 'G3DSA:3.40.50.410:FF:000369', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167835, NULL, 'G3DSA:3.40.1110.10:FF:000264', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(167836, NULL, 'G3DSA:1.10.287.770:FF:000028', NULL, NULL, 'Fusion glycoprotein F0', NULL, NULL, NULL, NULL, NULL, 4),
(167837, NULL, 'G3DSA:2.60.40.10:FF:002522', NULL, NULL, 'Titin b', NULL, NULL, NULL, NULL, NULL, 4),
(167838, NULL, 'G3DSA:2.40.50.90:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167839, NULL, 'G3DSA:3.30.70.1660:FF:000037', NULL, NULL, 'Peptide chain release factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(167840, NULL, 'G3DSA:4.10.60.30:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167841, NULL, 'G3DSA:1.10.10.60:FF:001308', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167842, NULL, 'G3DSA:1.10.630.10:FF:000560', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(167843, NULL, 'G3DSA:4.10.830.40:FF:000005', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM9', NULL, NULL, NULL, NULL, NULL, 4),
(167844, NULL, 'G3DSA:2.40.10.10:FF:000267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167845, NULL, 'G3DSA:1.25.40.10:FF:003712', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167846, NULL, 'G3DSA:2.120.10.30:FF:000325', NULL, NULL, 'Putative quinoprotein dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(167847, NULL, 'G3DSA:2.40.30.20:FF:000035', NULL, NULL, 'ATP synthase subunit alpha, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(167848, NULL, 'G3DSA:3.60.10.10:FF:000404', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167849, NULL, 'G3DSA:1.10.1280.10:FF:000003', NULL, NULL, 'Tyrosinase', NULL, NULL, NULL, NULL, NULL, 4),
(167850, NULL, 'G3DSA:3.40.50.300:FF:002360', NULL, NULL, 'Ras-related protein Rab-2', NULL, NULL, NULL, NULL, NULL, 4),
(167851, NULL, 'G3DSA:3.40.640.10:FF:000029', NULL, NULL, '4-aminobutyrate aminotransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(167852, NULL, 'G3DSA:1.20.920.30:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167853, NULL, 'G3DSA:3.30.300.130:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(167854, NULL, 'G3DSA:2.130.10.10:FF:001319', NULL, NULL, 'Gastrulation defective protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(167855, NULL, 'G3DSA:1.25.40.10:FF:002167', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(167856, NULL, 'G3DSA:1.25.40.420:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167857, NULL, 'G3DSA:1.25.40.10:FF:003926', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(167858, NULL, 'G3DSA:1.10.510.10:FF:001467', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167859, NULL, 'G3DSA:3.90.70.80:FF:000017', NULL, NULL, 'ubiquitin thioesterase OTU1', NULL, NULL, NULL, NULL, NULL, 4),
(167860, NULL, 'G3DSA:3.30.70.1230:FF:000173', NULL, NULL, 'Adenylate/guanylate cyclase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(167861, NULL, 'G3DSA:2.60.120.970:FF:000077', NULL, NULL, 'Myoglianin', NULL, NULL, NULL, NULL, NULL, 4),
(167862, NULL, 'G3DSA:3.40.50.410:FF:000245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167863, NULL, 'G3DSA:3.30.230.70:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167864, NULL, 'G3DSA:1.20.1280.50:FF:000041', NULL, NULL, 'F-box only protein 48', NULL, NULL, NULL, NULL, NULL, 4),
(167865, NULL, 'G3DSA:3.80.10.10:FF:002489', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167866, NULL, 'G3DSA:2.60.40.4390:FF:000001', NULL, NULL, 'Flagellin', NULL, NULL, NULL, NULL, NULL, 4),
(167867, NULL, 'G3DSA:1.10.840.10:FF:000042', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(167868, NULL, 'G3DSA:3.40.50.300:FF:006631', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167869, NULL, 'G3DSA:1.20.1530.20:FF:000018', NULL, NULL, 'Probable sodium/metabolite cotransporter BASS1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(167870, NULL, 'G3DSA:1.10.10.10:FF:000029', NULL, NULL, 'Proliferation-associated 2G4, a', NULL, NULL, NULL, NULL, NULL, 4),
(167871, NULL, 'G3DSA:2.130.10.10:FF:005366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167872, NULL, 'G3DSA:3.30.540.30:FF:000018', NULL, NULL, 'Dipeptidyl peptidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(167873, NULL, 'G3DSA:3.40.50.300:FF:004153', NULL, NULL, 'Ras-related protein Rab-32B', NULL, NULL, NULL, NULL, NULL, 4),
(167874, NULL, 'G3DSA:2.40.10.10:FF:000492', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167875, NULL, 'G3DSA:1.10.287.70:FF:000667', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(167876, NULL, 'G3DSA:2.60.40.10:FF:004787', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167877, NULL, 'G3DSA:1.10.418.10:FF:000230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167878, NULL, 'G3DSA:1.20.920.10:FF:000147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167879, NULL, 'G3DSA:3.30.540.10:FF:000030', NULL, NULL, 'Inositol monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(167880, NULL, 'G3DSA:3.10.450.10:FF:000033', NULL, NULL, 'Cysteine proteinase inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(167881, NULL, 'G3DSA:3.40.50.2300:FF:001502', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167882, NULL, 'G3DSA:3.40.50.720:FF:001058', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(167883, NULL, 'G3DSA:3.30.160.60:FF:003808', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167884, NULL, 'G3DSA:3.40.50.300:FF:007912', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(167885, NULL, 'G3DSA:3.30.70.330:FF:002026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167886, NULL, 'G3DSA:1.10.20.10:FF:000215', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167887, NULL, 'G3DSA:3.30.479.20:FF:000024', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(167888, NULL, 'G3DSA:3.30.160.60:FF:000049', NULL, NULL, 'transcriptional repressor CTCF isoform X1', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(167889, NULL, 'G3DSA:3.40.50.1010:FF:000121', NULL, NULL, '20S-pre-rRNA D-site endonuclease NOB1', NULL, NULL, NULL, NULL, NULL, 4),
(167890, NULL, 'G3DSA:3.30.160.60:FF:004332', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167891, NULL, 'G3DSA:3.10.100.10:FF:000147', NULL, NULL, 'GD24195', NULL, NULL, NULL, NULL, NULL, 4),
(167892, NULL, 'G3DSA:2.60.40.10:FF:001561', NULL, NULL, 'Jitterbug, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(167893, NULL, 'G3DSA:3.30.980.10:FF:000017', NULL, NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(167894, NULL, 'G3DSA:1.10.555.10:FF:000019', NULL, NULL, 'Arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(167895, NULL, 'G3DSA:3.40.50.10190:FF:000136', NULL, NULL, 'DNA polymerase lambda subunit', NULL, NULL, NULL, NULL, NULL, 4),
(167896, NULL, 'G3DSA:2.30.30.140:FF:000296', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(167897, NULL, 'G3DSA:1.20.58.1590:FF:000002', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(167898, NULL, 'G3DSA:3.60.15.10:FF:000022', NULL, NULL, 'DNA cross-link repair 1B', NULL, NULL, NULL, NULL, NULL, 4),
(167899, NULL, 'G3DSA:1.10.238.20:FF:000022', NULL, NULL, 'Odorant-binding protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(167900, NULL, 'G3DSA:3.30.1120.10:FF:000071', NULL, NULL, 'Aryl-sulphate sulphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(167901, NULL, 'G3DSA:3.40.50.300:FF:002106', NULL, NULL, 'ATP-dependent helicase Lhr', NULL, NULL, NULL, NULL, NULL, 4),
(167902, NULL, 'G3DSA:2.115.10.20:FF:000003', NULL, NULL, 'Levanbiose-producing levanase', NULL, NULL, NULL, NULL, NULL, 4),
(167903, NULL, 'G3DSA:3.90.640.10:FF:000248', NULL, NULL, 'Endoplasmic reticulum chaperone BiP', NULL, NULL, NULL, NULL, NULL, 4),
(167904, NULL, 'G3DSA:1.10.287.70:FF:000184', NULL, NULL, 'Two pore segment channel 2', NULL, NULL, NULL, NULL, NULL, 4),
(167905, NULL, 'G3DSA:2.60.40.10:FF:000521', NULL, NULL, 'leukocyte surface antigen CD47', NULL, NULL, NULL, NULL, NULL, 4),
(167906, NULL, 'G3DSA:3.30.1960.10:FF:000004', NULL, NULL, 'Transcription factor INI', NULL, NULL, NULL, NULL, NULL, 4),
(167907, NULL, 'G3DSA:2.60.40.1170:FF:000013', NULL, NULL, 'AP-5 complex subunit mu-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(167908, NULL, 'G3DSA:3.30.60.270:FF:000022', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(167909, NULL, 'G3DSA:2.40.10.10:FF:000503', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167910, NULL, 'G3DSA:2.10.25.10:FF:000819', NULL, NULL, 'Fibulin 7', NULL, NULL, NULL, NULL, NULL, 4),
(167911, NULL, 'G3DSA:2.60.120.330:FF:000025', NULL, NULL, 'Gibberellin 2-beta-dioxygenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(167912, NULL, 'G3DSA:2.30.29.30:FF:000838', NULL, NULL, 'Associated with RAN (Nuclear import/export) function', NULL, NULL, NULL, NULL, NULL, 4),
(167913, NULL, 'G3DSA:3.40.30.10:FF:000209', NULL, NULL, 'Protein disulfide isomerase like, testis expressed', NULL, NULL, NULL, NULL, NULL, 4),
(167914, NULL, 'G3DSA:1.10.150.20:FF:000060', NULL, NULL, 'Mitochondrial DNA polymerase I protein C', NULL, NULL, NULL, NULL, NULL, 4),
(167915, NULL, 'G3DSA:3.30.70.1820:FF:000001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167916, NULL, 'G3DSA:1.20.1250.20:FF:000558', NULL, NULL, 'MFS quinate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167917, NULL, 'G3DSA:1.10.10.60:FF:001191', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167918, NULL, 'G3DSA:2.60.40.10:FF:006018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167919, NULL, 'G3DSA:3.30.505.50:FF:000005', NULL, NULL, 'Dormancy associated translation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(167920, NULL, 'G3DSA:1.25.40.180:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167921, NULL, 'G3DSA:2.40.160.120:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(167922, NULL, 'G3DSA:1.20.1250.20:FF:001177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167923, NULL, 'G3DSA:1.10.510.10:FF:000618', NULL, NULL, 'Ribonuclease L', NULL, NULL, NULL, NULL, NULL, 4),
(167924, NULL, 'G3DSA:2.70.98.40:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167925, NULL, 'G3DSA:3.80.10.10:FF:002691', NULL, NULL, 'Receptor-like protein kinase HSL1', NULL, NULL, NULL, NULL, NULL, 4),
(167926, NULL, 'G3DSA:1.20.1280.50:FF:000024', NULL, NULL, 'F-box/SPRY domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(167927, NULL, 'G3DSA:1.25.40.10:FF:000964', NULL, NULL, 'Ethylene-overproduction protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(167928, NULL, 'G3DSA:3.20.20.80:FF:000545', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167929, NULL, 'G3DSA:3.50.50.60:FF:000787', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(167930, NULL, 'G3DSA:3.40.50.300:FF:003534', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167931, NULL, 'G3DSA:1.10.510.10:FF:002182', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167932, NULL, 'G3DSA:1.10.8.140:FF:000009', NULL, NULL, 'Apoptosis-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(167933, NULL, 'G3DSA:2.10.25.10:FF:000336', NULL, NULL, 'von Willebrand factor A domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(167934, NULL, 'G3DSA:3.90.550.50:FF:000242', NULL, NULL, 'RFNG O-fucosylpeptide 3-beta-N-acetylglucosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(167935, NULL, 'G3DSA:3.40.50.620:FF:000769', NULL, NULL, 'ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(167936, NULL, 'G3DSA:3.40.50.2300:FF:000985', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167937, NULL, 'G3DSA:3.30.70.330:FF:001407', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167938, NULL, 'G3DSA:1.20.120.1080:FF:000109', NULL, NULL, 'Pre-mRNA splicing factor ATP-dependent RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167939, NULL, 'G3DSA:2.40.230.10:FF:000002', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(167940, NULL, 'G3DSA:1.10.1170.10:FF:000001', NULL, NULL, 'baculoviral IAP repeat-containing protein 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(167941, NULL, 'G3DSA:2.40.50.90:FF:000046', NULL, NULL, 'Nuclease domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(167942, NULL, 'G3DSA:3.40.950.10:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167943, NULL, 'G3DSA:3.30.1370.10:FF:000212', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(167944, NULL, 'G3DSA:3.30.160.60:FF:003713', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167945, NULL, 'G3DSA:1.20.1070.10:FF:000783', NULL, NULL, 'Dopamine receptor D4b', NULL, NULL, NULL, NULL, NULL, 4),
(167946, NULL, 'G3DSA:1.25.40.770:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167947, NULL, 'G3DSA:3.30.530.20:FF:000105', NULL, NULL, 'Blr4478 protein', NULL, NULL, NULL, NULL, NULL, 4),
(167948, NULL, 'G3DSA:3.10.20.90:FF:000852', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167949, NULL, 'G3DSA:1.25.40.10:FF:003718', NULL, NULL, 'U3 small nucleolar RNA-associated protein 6 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(167950, NULL, 'G3DSA:1.10.510.10:FF:003592', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167951, NULL, 'G3DSA:3.30.450.20:FF:000481', NULL, NULL, 'Chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(167952, NULL, 'G3DSA:3.30.60.30:FF:000252', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(167953, NULL, 'G3DSA:3.30.40.10:FF:001543', NULL, NULL, 'YALI0E34650p', NULL, NULL, NULL, NULL, NULL, 4),
(167954, NULL, 'G3DSA:1.10.287.1130:FF:000003', NULL, NULL, 'Cytochrome c oxidase copper chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(167955, NULL, 'G3DSA:2.40.30.10:FF:000066', NULL, NULL, 'Elongation factor Tu GTP-binding domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(167956, NULL, 'G3DSA:1.10.10.10:FF:000130', NULL, NULL, 'COP9 signalosome complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(167957, NULL, 'G3DSA:3.40.1160.10:FF:000109', NULL, NULL, 'Putative inactive aspartokinase 3 HI_1632', NULL, NULL, NULL, NULL, NULL, 4),
(167958, NULL, 'G3DSA:1.10.8.60:FF:000043', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(167959, NULL, 'G3DSA:3.90.930.1:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167960, NULL, 'G3DSA:3.30.160.60:FF:001459', NULL, NULL, 'Zinc finger protein 823', NULL, NULL, NULL, NULL, NULL, 4),
(167961, NULL, 'G3DSA:2.30.30.100:FF:000183', NULL, NULL, 'Probable small nuclear ribonucleoprotein G', NULL, NULL, NULL, NULL, NULL, 4),
(167962, NULL, 'G3DSA:3.30.70.890:FF:000047', NULL, NULL, 'Phosphomevalonate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(167963, NULL, 'G3DSA:1.10.2000.10:FF:000017', NULL, NULL, 'Alpha 1 type XVIII collagen', NULL, NULL, NULL, NULL, NULL, 4),
(167964, NULL, 'G3DSA:3.20.20.70:FF:000216', NULL, NULL, '3-dehydroquinate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(167965, NULL, 'G3DSA:2.60.40.10:FF:000942', NULL, NULL, 'Immunoglobulin heavy variable 3-23', NULL, NULL, NULL, NULL, NULL, 4),
(167966, NULL, 'G3DSA:2.60.120.620:FF:000005', NULL, NULL, 'Egl nine homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(167967, NULL, 'G3DSA:3.40.50.620:FF:000286', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(167968, NULL, 'G3DSA:1.10.1450.10:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167969, NULL, 'G3DSA:3.30.70.870:FF:000041', NULL, NULL, 'Elongation factor G 2', NULL, NULL, NULL, NULL, NULL, 4),
(167970, NULL, 'G3DSA:1.10.246.60:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167971, NULL, 'G3DSA:3.40.50.10490:FF:000024', NULL, NULL, '30S ribosomal protein S2', NULL, NULL, NULL, NULL, NULL, 4),
(167972, NULL, 'G3DSA:3.30.420.10:FF:000436', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167973, NULL, 'G3DSA:1.10.510.10:FF:003603', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(167974, NULL, 'G3DSA:3.50.50.60:FF:000692', NULL, NULL, 'Pyridine_nucleotide-disulphide_oxidoreductase_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(167975, NULL, 'G3DSA:1.20.1560.10:FF:000753', NULL, NULL, 'ABC transporter B family member 27', NULL, NULL, NULL, NULL, NULL, 4),
(167976, NULL, 'G3DSA:3.20.20.140:FF:000191', NULL, NULL, 'Amidohydrolase 2', NULL, NULL, NULL, NULL, NULL, 4),
(167977, NULL, 'G3DSA:3.30.930.10:FF:000306', NULL, NULL, 'Phenylalanyl-tRNA synthetase alpha chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167978, NULL, 'G3DSA:3.90.180.10:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167979, NULL, 'G3DSA:1.10.565.10:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167980, NULL, 'G3DSA:4.10.60.10:FF:000250', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(167981, NULL, 'G3DSA:3.30.2350.10:FF:000003', NULL, NULL, 'tRNA pseudouridine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(167982, NULL, 'G3DSA:3.30.70.330:FF:001088', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(167983, NULL, 'G3DSA:3.30.460.10:FF:000192', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(167984, NULL, 'G3DSA:3.90.245.10:FF:000015', NULL, NULL, 'Inosine-uridine preferring nucleoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(167985, NULL, 'G3DSA:2.30.30.490:FF:000041', NULL, NULL, 'Polybromo', NULL, NULL, NULL, NULL, NULL, 4),
(167986, NULL, 'G3DSA:1.10.418.20:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167987, NULL, 'G3DSA:2.60.40.4070:FF:000006', NULL, NULL, 'OmpA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(167988, NULL, 'G3DSA:3.30.1360.40:FF:000041', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(167989, NULL, 'G3DSA:1.25.10.10:FF:001058', NULL, NULL, 'U3 snoRNP protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(167990, NULL, 'G3DSA:3.30.65.10:FF:000004', NULL, NULL, 'Predicted DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(167991, NULL, 'G3DSA:3.30.2410.10:FF:000042', NULL, NULL, 'MKIAA1625 protein', NULL, NULL, NULL, NULL, NULL, 4),
(167992, NULL, 'G3DSA:3.40.50.720:FF:002468', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167993, NULL, 'G3DSA:1.20.1080.10:FF:000059', NULL, NULL, 'Aquaporin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(167994, NULL, 'G3DSA:3.40.30.10:FF:000440', NULL, NULL, 'BnaC02g02860D protein', NULL, NULL, NULL, NULL, NULL, 4),
(167995, NULL, 'G3DSA:3.10.20.90:FF:000060', NULL, NULL, 'ubiquitin-like domain-containing CTD phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(167996, NULL, 'G3DSA:3.40.140.10:FF:000008', NULL, NULL, 'Cytidine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(167997, NULL, 'G3DSA:3.90.190.10:FF:000045', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type 12', NULL, NULL, NULL, NULL, NULL, 4),
(167998, NULL, 'G3DSA:1.25.40.10:FF:002307', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(167999, NULL, 'G3DSA:2.60.40.10:FF:005725', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168000, NULL, 'G3DSA:3.40.50.1240:FF:000173', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168001, NULL, 'G3DSA:2.130.10.10:FF:003028', NULL, NULL, 'YALI0A20636p', NULL, NULL, NULL, NULL, NULL, 4),
(168002, NULL, 'G3DSA:3.40.50.300:FF:006491', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(168003, NULL, 'G3DSA:3.30.1390.20:FF:000003', NULL, NULL, '60S ribosomal protein L7', NULL, NULL, NULL, NULL, NULL, 4),
(168004, NULL, 'G3DSA:3.90.550.10:FF:000028', NULL, NULL, 'beta-1,4-galactosyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(168005, NULL, 'G3DSA:3.30.70.1230:FF:000279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168006, NULL, 'G3DSA:2.60.200.40:FF:000050', NULL, NULL, 'Diacylglycerol kinase, delta', NULL, NULL, NULL, NULL, NULL, 4),
(168007, NULL, 'G3DSA:2.30.39.10:FF:000108', NULL, NULL, 'Serpin peptidase inhibitor 27', NULL, NULL, NULL, NULL, NULL, 4),
(168008, NULL, 'G3DSA:3.30.60.20:FF:000018', NULL, NULL, 'Citron rho-interacting serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(168009, NULL, 'G3DSA:1.20.1420.10:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168010, NULL, 'G3DSA:2.60.40.10:FF:003359', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168011, NULL, 'G3DSA:3.40.630.30:FF:000102', NULL, NULL, 'N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(168012, NULL, 'G3DSA:1.10.287.770:FF:000023', NULL, NULL, 'Pickpocket 27', NULL, NULL, NULL, NULL, NULL, 4),
(168013, NULL, 'G3DSA:3.40.720.10:FF:000103', NULL, NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase-like', NULL, NULL, NULL, NULL, NULL, 4),
(168014, NULL, 'G3DSA:3.40.50.2000:FF:000221', NULL, NULL, 'Glycosyltransferase, group 1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(168015, NULL, 'G3DSA:2.60.120.10:FF:000473', NULL, NULL, 'JmjC domain-containing protein E', NULL, NULL, NULL, NULL, NULL, 4),
(168016, NULL, 'G3DSA:3.80.10.10:FF:001393', NULL, NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', NULL, NULL, NULL, NULL, NULL, 4),
(168017, NULL, 'G3DSA:3.40.630.30:FF:000091', NULL, NULL, 'Peptide alpha-N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(168018, NULL, 'G3DSA:3.40.50.300:FF:000196', NULL, NULL, 'Cell division control 3', NULL, NULL, NULL, NULL, NULL, 4),
(168019, NULL, 'G3DSA:3.30.780.10:FF:000036', NULL, NULL, 'Protein CBG02294', NULL, NULL, NULL, NULL, NULL, 4),
(168020, NULL, 'G3DSA:3.10.50.40:FF:000007', NULL, NULL, 'Chaperone SurA', NULL, NULL, NULL, NULL, NULL, 4),
(168021, NULL, 'G3DSA:1.10.287.470:FF:000040', NULL, NULL, 'Membrane fusion protein (MFP) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(168022, NULL, 'G3DSA:3.80.10.10:FF:001281', NULL, NULL, 'Cyclic nucleotide-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(168023, NULL, 'G3DSA:2.130.10.10:FF:003921', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(168024, NULL, 'G3DSA:1.10.555.10:FF:000250', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168025, NULL, 'G3DSA:2.60.40.1530:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168026, NULL, 'G3DSA:2.60.120.10:FF:000585', NULL, NULL, 'CooA protein', NULL, NULL, NULL, NULL, NULL, 4),
(168027, NULL, 'G3DSA:1.25.40.20:FF:001568', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168028, NULL, 'G3DSA:1.10.510.10:FF:001237', NULL, NULL, 'GM20338', NULL, NULL, NULL, NULL, NULL, 4),
(168029, NULL, 'G3DSA:1.10.150.50:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168030, NULL, 'G3DSA:3.40.50.620:FF:000639', NULL, NULL, 'Phosphatidylinositol-binding clathrin assembly protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(168031, NULL, 'G3DSA:1.20.1070.10:FF:001300', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(168032, NULL, 'G3DSA:3.40.50.2000:FF:000676', NULL, NULL, 'Algn-2', NULL, NULL, NULL, NULL, NULL, 4),
(168033, NULL, 'G3DSA:3.40.50.1480:FF:000014', NULL, NULL, 'Adenosylhomocysteinase', NULL, NULL, NULL, NULL, NULL, 4),
(168034, NULL, 'G3DSA:3.40.50.1820:FF:001105', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(168035, NULL, 'G3DSA:2.130.10.10:FF:002623', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(168036, NULL, 'G3DSA:1.20.58.90:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168037, NULL, 'G3DSA:2.60.40.10:FF:002319', NULL, NULL, 'Zgc:162154', NULL, NULL, NULL, NULL, NULL, 4),
(168038, NULL, 'G3DSA:3.20.20.80:FF:000192', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(168039, NULL, 'G3DSA:1.20.1440.90:FF:000009', NULL, NULL, 'Phosphoenolpyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(168040, NULL, 'G3DSA:1.10.287.370:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168041, NULL, 'G3DSA:1.10.510.10:FF:004008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168042, NULL, 'G3DSA:3.40.50.1000:FF:000601', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168043, NULL, 'G3DSA:1.10.10.60:FF:000246', NULL, NULL, 'Telomeric repeat-binding factor 2-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(168044, NULL, 'G3DSA:3.30.70.330:FF:000469', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(168045, NULL, 'G3DSA:2.40.50.120:FF:000016', NULL, NULL, 'Metalloproteinase inhibitor 1', NULL, NULL, NULL, NULL, NULL, 4),
(168046, NULL, 'G3DSA:3.30.50.10:FF:000060', NULL, NULL, 'GATA transcription factor 16', NULL, NULL, NULL, NULL, NULL, 4),
(168047, NULL, 'G3DSA:3.40.50.10320:FF:000001', NULL, NULL, 'Mycothiol S-conjugate amidase', NULL, NULL, NULL, NULL, NULL, 4),
(168048, NULL, 'G3DSA:3.30.505.10:FF:000252', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168049, NULL, 'G3DSA:3.60.21.10:FF:000082', NULL, NULL, 'Endopolyphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(168050, NULL, 'G3DSA:3.40.395.10:FF:000032', NULL, NULL, 'SUMO protease', NULL, NULL, NULL, NULL, NULL, 4),
(168051, NULL, 'G3DSA:3.30.200.20:FF:001390', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168052, NULL, 'G3DSA:1.25.40.70:FF:000032', NULL, NULL, 'Phosphatidylinositol-4,5-bisphosphate 3-kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(168053, NULL, 'G3DSA:3.40.1090.10:FF:000003', NULL, NULL, 'Patatin-like phospholipase domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(168054, NULL, 'G3DSA:1.50.40.10:FF:000080', NULL, NULL, 'Mitochondrial substrate carrier protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(168055, NULL, 'G3DSA:3.40.50.1820:FF:000830', NULL, NULL, 'Alpha/beta-hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(168056, NULL, 'G3DSA:1.10.3170.10:FF:000001', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(168057, NULL, 'G3DSA:3.30.40.10:FF:000587', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(168058, NULL, 'G3DSA:3.80.10.10:FF:002702', NULL, NULL, 'CLL3 clavata1-like receptor S/T protein kinase protein', NULL, NULL, NULL, NULL, NULL, 4),
(168059, NULL, 'G3DSA:1.20.1250.20:FF:000997', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(168060, NULL, 'G3DSA:3.30.160.60:FF:002415', NULL, NULL, 'Zinc finger protein 700', NULL, NULL, NULL, NULL, NULL, 4),
(168061, NULL, 'G3DSA:1.10.150.380:FF:000002', NULL, NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit E', NULL, NULL, NULL, NULL, NULL, 4),
(168062, NULL, 'G3DSA:3.10.105.10:FF:000023', NULL, NULL, 'Peptide ABC transporter, periplasmic peptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(168063, NULL, 'G3DSA:2.70.98.20:FF:000010', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(168064, NULL, 'G3DSA:4.10.280.10:FF:000004', NULL, NULL, 'Basic helix-loop-helix transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(168065, NULL, 'G3DSA:3.40.50.300:FF:005872', NULL, NULL, 'Zinc finger NFX1-type containing homolog', NULL, NULL, NULL, NULL, NULL, 4),
(168066, NULL, 'G3DSA:1.25.40.90:FF:000038', NULL, NULL, 'TOM1-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(168067, NULL, 'G3DSA:1.10.10.160:FF:000042', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(168068, NULL, 'G3DSA:3.40.50.720:FF:002356', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168069, NULL, 'G3DSA:3.30.160.60:FF:005725', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168070, NULL, 'G3DSA:2.60.40.10:FF:003264', NULL, NULL, 'Cytokine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(168071, NULL, 'G3DSA:3.90.70.10:FF:000581', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168072, NULL, 'G3DSA:1.10.1450.10:FF:000034', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(168073, NULL, 'G3DSA:1.10.30.10:FF:000143', NULL, NULL, 'Protein CBG07235', NULL, NULL, NULL, NULL, NULL, 4),
(168074, NULL, 'G3DSA:3.30.700.10:FF:000014', NULL, NULL, 'Fimbrial protein', NULL, NULL, NULL, NULL, NULL, 4),
(168075, NULL, 'G3DSA:3.20.20.150:FF:000082', NULL, NULL, 'Protein arginine N-methyltransferase 1.5', NULL, NULL, NULL, NULL, NULL, 4),
(168076, NULL, 'G3DSA:3.90.1410.10:FF:000017', NULL, NULL, 'YBR030W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(168077, NULL, 'G3DSA:2.60.40.150:FF:000086', NULL, NULL, 'Ras GTPase-activating protein 2 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(168078, NULL, 'G3DSA:2.10.50.10:FF:000080', NULL, NULL, 'Uninflatable, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(168079, NULL, 'G3DSA:1.20.1560.10:FF:000641', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168080, NULL, 'G3DSA:3.30.110.30:FF:000003', NULL, NULL, 'Proline--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(168081, NULL, 'G3DSA:2.60.120.200:FF:000554', NULL, NULL, 'Sex hormone binding globulin', NULL, NULL, NULL, NULL, NULL, 4),
(168082, NULL, 'G3DSA:2.160.10.10:FF:000014', NULL, NULL, 'dynactin subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(168083, NULL, 'G3DSA:2.120.10.80:FF:000424', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(168084, NULL, 'G3DSA:2.40.50.140:FF:000915', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168085, NULL, 'G3DSA:3.20.20.70:FF:000655', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168086, NULL, 'G3DSA:3.30.1360.140:FF:000009', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(168087, NULL, 'G3DSA:2.60.40.60:FF:000154', NULL, NULL, 'FAT atypical cadherin 4', NULL, NULL, NULL, NULL, NULL, 4),
(168088, NULL, 'G3DSA:2.60.40.420:FF:000173', NULL, NULL, 'Laccase-like multicopper oxidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(168089, NULL, 'G3DSA:2.130.10.10:FF:003449', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168090, NULL, 'G3DSA:3.90.1740.10:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168091, NULL, 'G3DSA:2.130.10.10:FF:000257', NULL, NULL, 'semaphorin-4A isoform X2', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(168092, NULL, 'G3DSA:3.20.20.140:FF:000174', NULL, NULL, 'Dihydropyrimidinase-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(168093, NULL, 'G3DSA:3.30.200.20:FF:001401', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(168094, NULL, 'G3DSA:3.10.450.120:FF:000002', NULL, NULL, 'PUA domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(168095, NULL, 'G3DSA:1.10.510.10:FF:004429', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168096, NULL, 'G3DSA:1.25.10.10:FF:000232', NULL, NULL, 'leucine-rich repeat serine/threonine-protein kinase 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(168097, NULL, 'G3DSA:2.60.200.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168098, NULL, 'G3DSA:3.40.50.300:FF:003989', NULL, NULL, 'ABC ATPase, putative (AFU_orthologue AFUA_1G16440)', NULL, NULL, NULL, NULL, NULL, 4),
(168099, NULL, 'G3DSA:1.10.510.10:FF:001675', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(168100, NULL, 'G3DSA:3.40.50.300:FF:007800', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168101, NULL, 'G3DSA:3.30.200.20:FF:001631', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(168102, NULL, 'G3DSA:3.40.50.150:FF:000706', NULL, NULL, 'O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(168103, NULL, 'G3DSA:2.60.40.10:FF:001010', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(168104, NULL, 'G3DSA:3.40.50.10190:FF:000024', NULL, NULL, 'Nibrin', NULL, NULL, NULL, NULL, NULL, 4),
(168105, NULL, 'G3DSA:1.20.1560.10:FF:000539', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168106, NULL, 'G3DSA:4.10.240.10:FF:000221', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(168107, NULL, 'G3DSA:3.30.70.330:FF:002386', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168108, NULL, 'G3DSA:2.70.170.10:FF:000237', NULL, NULL, 'Glycine receptor alpha 1 variant, putative', NULL, NULL, NULL, NULL, NULL, 4),
(168109, NULL, 'G3DSA:2.10.220.10:FF:000082', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5a', NULL, NULL, NULL, NULL, NULL, 4),
(168110, NULL, 'G3DSA:1.20.1070.10:FF:001290', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(168111, NULL, 'G3DSA:1.10.287.70:FF:000537', NULL, NULL, 'Protein CBR-TWK-47', NULL, NULL, NULL, NULL, NULL, 4),
(168112, NULL, 'G3DSA:3.60.10.10:FF:000163', NULL, NULL, 'Probable RNA-directed DNA polymerase from transposon BS', NULL, NULL, NULL, NULL, NULL, 4),
(168113, NULL, 'G3DSA:3.10.20.410:FF:000004', NULL, NULL, 'Fimbrial biogenesis outer membrane usher protein', NULL, NULL, NULL, NULL, NULL, 4),
(168114, NULL, 'G3DSA:3.40.50.10480:FF:000004', NULL, NULL, 'Ribosome production factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(168115, NULL, 'G3DSA:3.30.9.10:FF:000178', NULL, NULL, 'Slr0734 protein', NULL, NULL, NULL, NULL, NULL, 4),
(168116, NULL, 'G3DSA:3.30.160.60:FF:004444', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168117, NULL, 'G3DSA:2.30.29.30:FF:000968', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168118, NULL, 'G3DSA:3.80.10.10:FF:003079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168119, NULL, 'G3DSA:3.40.50.1000:FF:000230', NULL, NULL, 'copper-transporting ATPase 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(168120, NULL, 'G3DSA:1.25.40.20:FF:000158', NULL, NULL, 'E3 ubiquitin-protein ligase MIB2 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(168121, NULL, 'G3DSA:2.60.40.60:FF:000603', NULL, NULL, 'Cadherin 4', NULL, NULL, NULL, NULL, NULL, 4),
(168122, NULL, 'G3DSA:3.40.50.720:FF:000670', NULL, NULL, 'Probable peptide synthetase nrp', NULL, NULL, NULL, NULL, NULL, 4),
(168123, NULL, 'G3DSA:1.20.5.5160:FF:000005', NULL, NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', NULL, NULL, NULL, NULL, NULL, 4),
(168124, NULL, 'G3DSA:3.90.1150.10:FF:000210', NULL, NULL, 'Cysteine desulfurase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(168125, NULL, 'G3DSA:1.10.150.80:FF:000050', NULL, NULL, 'Ribonuclease D, putative', NULL, NULL, NULL, NULL, NULL, 4),
(168126, NULL, 'G3DSA:1.10.20.10:FF:000327', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168127, NULL, 'G3DSA:1.10.287.110:FF:000292', NULL, NULL, 'Translocation protein SEC63-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(168128, NULL, 'G3DSA:3.30.450.40:FF:000262', NULL, NULL, 'Chromosome 21, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(168129, NULL, 'G3DSA:3.40.50.1000:FF:000573', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168130, NULL, 'G3DSA:3.40.50.300:FF:002236', NULL, NULL, 'Shikimate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(168131, NULL, 'G3DSA:3.40.640.10:FF:000153', NULL, NULL, 'Serine palmitoyltransferase component', NULL, NULL, NULL, NULL, NULL, 4),
(168132, NULL, 'G3DSA:3.30.930.10:FF:000296', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(168133, NULL, 'G3DSA:1.25.10.10:FF:000653', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(168134, NULL, 'G3DSA:3.20.20.80:FF:000433', NULL, NULL, 'Chromosome 16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(168135, NULL, 'G3DSA:1.20.1070.10:FF:000002', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(168136, NULL, 'G3DSA:2.130.10.10:FF:002511', NULL, NULL, 'Histidine kinase/response regulator hybrid protein', NULL, NULL, NULL, NULL, NULL, 4),
(168137, NULL, 'G3DSA:3.40.50.300:FF:001617', NULL, NULL, 'Adenylate kinase 8', NULL, NULL, NULL, NULL, NULL, 4),
(168138, NULL, 'G3DSA:1.20.1250.20:FF:001065', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(168139, NULL, 'G3DSA:1.10.510.10:FF:000506', NULL, NULL, 'Serine/threonine-protein kinase rio2', NULL, NULL, NULL, NULL, NULL, 4),
(168140, NULL, 'G3DSA:3.30.1310.30:FF:000001', NULL, NULL, 'Calcium channel, voltage-dependent, beta 4b subunit', NULL, NULL, NULL, NULL, NULL, 4),
(168141, NULL, 'G3DSA:4.10.60.10:FF:000233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168142, NULL, 'G3DSA:2.30.30.190:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168143, NULL, 'G3DSA:3.40.30.10:FF:000569', NULL, NULL, 'Glutathionyl-hydroquinone reductase YqjG', NULL, NULL, NULL, NULL, NULL, 4),
(168144, NULL, 'G3DSA:3.30.160.60:FF:003685', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168145, NULL, 'G3DSA:3.30.70.330:FF:002043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168146, NULL, 'G3DSA:3.40.1090.10:FF:000115', NULL, NULL, 'Patatin', NULL, NULL, NULL, NULL, NULL, 4),
(168147, NULL, 'G3DSA:3.30.2170.10:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168148, NULL, 'G3DSA:3.30.1540.20:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168149, NULL, 'G3DSA:1.20.1260.10:FF:000045', NULL, NULL, 'Rubrerythrin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(168150, NULL, 'G3DSA:3.20.20.70:FF:000767', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168151, NULL, 'G3DSA:3.80.10.10:FF:002814', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168152, NULL, 'G3DSA:2.60.40.60:FF:000507', NULL, NULL, 'AGAP003579-PA', NULL, NULL, NULL, NULL, NULL, 4),
(168153, NULL, 'G3DSA:3.50.50.60:FF:000332', NULL, NULL, 'Probable malate:quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(168154, NULL, 'G3DSA:2.30.180.10:FF:000045', NULL, NULL, 'Fasciclin domain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(168155, NULL, 'G3DSA:3.40.190.10:FF:000303', NULL, NULL, 'C4-dicarboxylate ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(168156, NULL, 'G3DSA:3.40.50.150:FF:001651', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168157, NULL, 'G3DSA:2.60.40.10:FF:005276', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168158, NULL, 'G3DSA:2.60.40.10:FF:001914', NULL, NULL, 'TAP binding protein-like variant', NULL, NULL, NULL, NULL, NULL, 4),
(168159, NULL, 'G3DSA:2.60.270.20:FF:000003', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(168160, NULL, 'G3DSA:2.120.10.80:FF:000003', NULL, NULL, 'Ectoderm-neural cortex protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(168161, NULL, 'G3DSA:1.25.40.20:FF:000607', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(168162, NULL, 'G3DSA:1.10.238.10:FF:000244', NULL, NULL, 'Phospholipase C, epsilon 1', NULL, NULL, NULL, NULL, NULL, 4),
(168163, NULL, 'G3DSA:2.30.30.40:FF:000019', NULL, NULL, 'Chemotaxis protein CheW', NULL, NULL, NULL, NULL, NULL, 4),
(168164, NULL, 'G3DSA:3.90.70.10:FF:000351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168165, NULL, 'G3DSA:3.40.50.261:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168166, NULL, 'G3DSA:3.80.10.10:FF:003528', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168167, NULL, 'G3DSA:3.20.20.210:FF:000010', NULL, NULL, 'Uroporphyrinogen decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(168168, NULL, 'G3DSA:2.40.70.10:FF:000400', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168169, NULL, 'G3DSA:2.10.25.10:FF:000696', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(168170, NULL, 'G3DSA:3.10.129.10:FF:000264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168171, NULL, 'G3DSA:3.30.360.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168172, NULL, 'G3DSA:2.60.40.10:FF:003376', NULL, NULL, 'Si:dkey-13m1.2', NULL, NULL, NULL, NULL, NULL, 4),
(168173, NULL, 'G3DSA:2.60.120.320:FF:000005', NULL, NULL, 'Thiamine pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(168174, NULL, 'G3DSA:2.60.40.2130:FF:000003', NULL, NULL, 'Spondin 2', NULL, NULL, NULL, NULL, NULL, 4),
(168175, NULL, 'G3DSA:3.30.200.20:FF:000092', NULL, NULL, 'Serine/threonine-protein kinase 24', NULL, NULL, NULL, NULL, NULL, 4),
(168176, NULL, 'G3DSA:1.20.120.350:FF:000030', NULL, NULL, 'sodium leak channel non-selective protein', NULL, NULL, NULL, NULL, NULL, 4),
(168177, NULL, 'G3DSA:3.30.70.100:FF:000176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168178, NULL, 'G3DSA:3.30.70.1230:FF:000150', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(168179, NULL, 'G3DSA:1.20.140.150:FF:000070', NULL, NULL, 'peripheral myelin protein 22-like', NULL, NULL, NULL, NULL, NULL, 4),
(168180, NULL, 'G3DSA:1.10.8.60:FF:000498', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(168181, NULL, 'G3DSA:2.70.130.10:FF:000033', NULL, NULL, 'Lysosomal enzyme receptor protein', NULL, NULL, NULL, NULL, NULL, 4),
(168182, NULL, 'G3DSA:1.10.3480.10:FF:000002', NULL, NULL, 'Tat proofreading chaperone DmsD', NULL, NULL, NULL, NULL, NULL, 4),
(168183, NULL, 'G3DSA:1.20.1540.10:FF:000095', NULL, NULL, 'Rhomboid domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(168184, NULL, 'G3DSA:1.20.120.220:FF:000019', NULL, NULL, 'ATP synthase subunit a', NULL, NULL, NULL, NULL, NULL, 4),
(168185, NULL, 'G3DSA:3.60.21.10:FF:000401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168186, NULL, 'G3DSA:3.40.50.300:FF:003085', NULL, NULL, 'Rab family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(168187, NULL, 'G3DSA:3.30.70.3600:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168188, NULL, 'G3DSA:3.30.420.40:FF:000434', NULL, NULL, 'Actin-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(168189, NULL, 'G3DSA:2.130.10.10:FF:005496', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168190, NULL, 'G3DSA:2.60.40.60:FF:000024', NULL, NULL, 'FAT atypical cadherin 3', NULL, NULL, NULL, NULL, NULL, 4),
(168191, NULL, 'G3DSA:3.90.1410.10:FF:000129', NULL, NULL, 'Cytochrome c lysine N-methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(168192, NULL, 'G3DSA:3.40.50.300:FF:001168', NULL, NULL, 'nucleolar RNA helicase 2', NULL, NULL, NULL, NULL, NULL, 4),
(168193, NULL, 'G3DSA:2.30.29.30:FF:000389', NULL, NULL, 'FYVE, RhoGEF and PH domain containing 3', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(168194, NULL, 'G3DSA:3.90.1600.10:FF:000060', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(168195, NULL, 'G3DSA:4.10.280.10:FF:000116', NULL, NULL, 'Putative HLH transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(168196, NULL, 'G3DSA:2.170.270.10:FF:000182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168197, NULL, 'G3DSA:1.10.357.140:FF:000025', NULL, NULL, 'Protoheme IX farnesyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(168198, NULL, 'G3DSA:3.50.50.60:FF:001181', NULL, NULL, 'NADPH-adrenodoxin reductase', NULL, NULL, NULL, NULL, NULL, 4),
(168199, NULL, 'G3DSA:1.20.1250.20:FF:001626', NULL, NULL, 'FabG, Dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(168200, NULL, 'G3DSA:3.40.30.10:FF:001188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168201, NULL, 'G3DSA:2.40.50.140:FF:000674', NULL, NULL, 'Related to RFA2-DNA replication factor A, 36 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(168202, NULL, 'G3DSA:3.10.28.10:FF:000071', NULL, NULL, 'Replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(168203, NULL, 'G3DSA:1.25.10.10:FF:000310', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(168204, NULL, 'G3DSA:2.60.40.10:FF:003831', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168205, NULL, 'G3DSA:1.10.10.1600:FF:000002', NULL, NULL, 'DNA polymerase III subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(168206, NULL, 'G3DSA:3.60.40.10:FF:000327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168207, NULL, 'G3DSA:1.25.40.10:FF:004207', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(168208, NULL, 'G3DSA:3.30.160.60:FF:006018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168209, NULL, 'G3DSA:3.30.1360.170:FF:000007', NULL, NULL, 'FAD-dependent thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(168210, NULL, 'G3DSA:3.40.33.10:FF:000025', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(168211, NULL, 'G3DSA:3.40.1010.20:FF:000001', NULL, NULL, '4-hydroxy-3-methylbut-2-enyl diphosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(168212, NULL, 'G3DSA:3.30.70.330:FF:000918', NULL, NULL, 'Regulatory protein E2', NULL, NULL, NULL, NULL, NULL, 4),
(168213, NULL, 'G3DSA:2.130.10.10:FF:003904', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168214, NULL, 'G3DSA:3.20.20.140:FF:000202', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(168215, NULL, 'G3DSA:3.40.50.300:FF:004591', NULL, NULL, '6-phosphofructo-2-kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(168216, NULL, 'G3DSA:3.80.10.10:FF:002253', NULL, NULL, 'GH22922p', NULL, NULL, NULL, NULL, NULL, 4),
(168217, NULL, 'G3DSA:2.10.110.10:FF:000202', NULL, NULL, 'LIM-domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(168218, NULL, 'G3DSA:3.50.50.80:FF:000001', NULL, NULL, 'ubiquitin-like modifier-activating enzyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(168219, NULL, 'G3DSA:3.80.10.10:FF:004147', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(168220, NULL, 'G3DSA:2.40.30.10:FF:000403', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168221, NULL, 'G3DSA:2.30.30.620:FF:000001', NULL, NULL, 'major vault protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(168222, NULL, 'G3DSA:3.50.50.60:FF:000815', NULL, NULL, 'Zgc:77439', NULL, NULL, NULL, NULL, NULL, 4),
(168223, NULL, 'G3DSA:3.40.50.880:FF:000004', NULL, NULL, 'Homoserine O-succinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(168224, NULL, 'G3DSA:3.30.160.20:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168225, NULL, 'G3DSA:2.30.30.40:FF:000120', NULL, NULL, 'dynamin-binding protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(168226, NULL, 'G3DSA:3.40.50.150:FF:000145', NULL, NULL, 'Methyltransferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(168227, NULL, 'G3DSA:1.25.10.10:FF:002570', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(168228, NULL, 'G3DSA:3.40.47.10:FF:000080', NULL, NULL, '3-oxoacyl-[acyl-carrier protein] synthase II', NULL, NULL, NULL, NULL, NULL, 4),
(168229, NULL, 'G3DSA:1.20.1440.100:FF:000012', NULL, NULL, 'Possible phosphoserine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(168230, NULL, 'G3DSA:1.10.10.10:FF:000501', NULL, NULL, 'Ferric uptake regulator family protein', NULL, NULL, NULL, NULL, NULL, 4),
(168231, NULL, 'G3DSA:1.10.1740.10:FF:000022', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(168232, NULL, 'G3DSA:2.30.42.10:FF:000487', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168233, NULL, 'G3DSA:1.20.1270.60:FF:000313', NULL, NULL, 'BAI1-associated protein 2b', NULL, NULL, NULL, NULL, NULL, 4),
(168234, NULL, 'G3DSA:3.40.50.2000:FF:000564', NULL, NULL, 'CalG3', NULL, NULL, NULL, NULL, NULL, 4),
(168235, NULL, 'G3DSA:2.130.10.10:FF:004540', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168236, NULL, 'G3DSA:3.30.200.20:FF:000221', NULL, NULL, 'Putative serine/threonine-protein kinase PLK4', NULL, NULL, NULL, NULL, NULL, 4),
(168237, NULL, 'G3DSA:3.30.1010.10:FF:000079', NULL, NULL, 'Probable serine/threonine-protein kinase atr1', NULL, NULL, NULL, NULL, NULL, 4),
(168238, NULL, 'G3DSA:3.40.1800.20:FF:000022', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(168239, NULL, 'G3DSA:2.80.10.50:FF:000272', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(168240, NULL, 'G3DSA:2.60.40.150:FF:000069', NULL, NULL, 'Ras GTPase-activating protein 4 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(168241, NULL, 'G3DSA:1.10.1410.10:FF:000037', NULL, NULL, 'Topoisomerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(168242, NULL, 'G3DSA:2.40.50.140:FF:000011', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(168243, NULL, 'G3DSA:2.30.110.10:FF:000080', NULL, NULL, 'Protein CREG1 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(168244, NULL, 'G3DSA:3.30.70.1230:FF:000049', NULL, NULL, 'Guanylyl cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(168245, NULL, 'G3DSA:3.90.70.40:FF:000005', NULL, NULL, 'Ataxin 3', NULL, NULL, NULL, NULL, NULL, 4),
(168246, NULL, 'G3DSA:1.20.120.1240:FF:000074', NULL, NULL, 'Dynamin-related protein 3A', NULL, NULL, NULL, NULL, NULL, 4),
(168247, NULL, 'G3DSA:1.50.10.10:FF:000038', NULL, NULL, 'Phosphorylase b kinase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(168248, NULL, 'G3DSA:3.30.1780.10:FF:000018', NULL, NULL, 'Ornithine cyclodeaminase', NULL, NULL, NULL, NULL, NULL, 4),
(168249, NULL, 'G3DSA:3.40.850.10:FF:000427', NULL, NULL, 'Motor domain of KIF6', NULL, NULL, NULL, NULL, NULL, 4),
(168250, NULL, 'G3DSA:3.30.420.610:FF:000009', NULL, NULL, 'Tudor domain-containing protein 7 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(168251, NULL, 'G3DSA:1.25.40.10:FF:005152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168252, NULL, 'G3DSA:3.40.30.10:FF:000339', NULL, NULL, 'Os03g0335300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(168253, NULL, 'G3DSA:3.30.450.20:FF:000593', NULL, NULL, 'BfiS', NULL, NULL, NULL, NULL, NULL, 4),
(168254, NULL, 'G3DSA:1.20.58.390:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168255, NULL, 'G3DSA:2.10.25.10:FF:001308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168256, NULL, 'G3DSA:1.25.10.10:FF:003087', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(168257, NULL, 'G3DSA:2.30.39.10:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168258, NULL, 'G3DSA:3.30.1400.10:FF:000002', NULL, NULL, 'Cell division protein ZipA', NULL, NULL, NULL, NULL, NULL, 4),
(168259, NULL, 'G3DSA:3.30.230.10:FF:000383', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168260, NULL, 'G3DSA:3.40.50.300:FF:003646', NULL, NULL, 'ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(168261, NULL, 'G3DSA:1.10.238.10:FF:000114', NULL, NULL, 'RAS guanyl releasing protein 4', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(168262, NULL, 'G3DSA:3.80.10.10:FF:001730', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168263, NULL, 'G3DSA:1.10.510.10:FF:002294', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168264, NULL, 'G3DSA:3.80.10.10:FF:001634', NULL, NULL, 'Si:ch211-201o1.1', NULL, NULL, NULL, NULL, NULL, 4),
(168265, NULL, 'G3DSA:3.40.366.10:FF:000066', NULL, NULL, 'Chromosome 23, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(168266, NULL, 'G3DSA:1.20.1250.10:FF:000090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168267, NULL, 'G3DSA:1.50.10.10:FF:000140', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(168268, NULL, 'G3DSA:1.20.58.390:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168269, NULL, 'G3DSA:3.40.800.10:FF:000025', NULL, NULL, 'Agmatinase protein', NULL, NULL, NULL, NULL, NULL, 4),
(168270, NULL, 'G3DSA:3.40.140.10:FF:000025', NULL, NULL, 'Riboflavin biosynthesis protein RibD', NULL, NULL, NULL, NULL, NULL, 4),
(168271, NULL, 'G3DSA:1.10.472.80:FF:000044', NULL, NULL, 'GTPase-activating protein GYP5', NULL, NULL, NULL, NULL, NULL, 4),
(168272, NULL, 'G3DSA:3.30.1370.10:FF:000100', NULL, NULL, 'Putative branch point binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(168273, NULL, 'G3DSA:1.10.10.10:FF:001653', NULL, NULL, 'Ribosomal protein S25', NULL, NULL, NULL, NULL, NULL, 4),
(168274, NULL, 'G3DSA:3.40.630.30:FF:000074', NULL, NULL, 'N(alpha)-acetyltransferase 50, NatE catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(168275, NULL, 'G3DSA:3.50.50.60:FF:001304', NULL, NULL, 'Mercuric reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(168276, NULL, 'G3DSA:1.10.472.80:FF:000140', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(168277, NULL, 'G3DSA:3.10.20.90:FF:000043', NULL, NULL, 'serine/threonine-protein kinase OSR1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(168278, NULL, 'G3DSA:3.40.50.1240:FF:000190', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168279, NULL, 'G3DSA:1.10.600.10:FF:000047', NULL, NULL, 'Terpene synthase', NULL, NULL, NULL, NULL, NULL, 4),
(168280, NULL, 'G3DSA:3.10.290.70:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168281, NULL, 'G3DSA:3.90.660.20:FF:000005', NULL, NULL, 'NAD(P)-binding Rossmann-like domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(168282, NULL, 'G3DSA:3.30.160.60:FF:001347', NULL, NULL, 'Transcription factor IIIA', NULL, NULL, NULL, NULL, NULL, 4),
(168283, NULL, 'G3DSA:3.10.580.10:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168284, NULL, 'G3DSA:3.30.70.330:FF:002947', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168285, NULL, 'G3DSA:3.10.130.10:FF:000003', NULL, NULL, 'Inactive ribonuclease-like protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(168286, NULL, 'G3DSA:1.25.40.10:FF:000481', NULL, NULL, 'Mitochondrial fission 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(168287, NULL, 'G3DSA:1.20.1250.20:FF:001969', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168288, NULL, 'G3DSA:3.40.50.300:FF:000549', NULL, NULL, 'ABC transporter ATP-binding protein arb1', NULL, NULL, NULL, NULL, NULL, 4),
(168289, NULL, 'G3DSA:2.60.120.40:FF:000009', NULL, NULL, 'Multimerin-1', NULL, NULL, NULL, NULL, NULL, 4),
(168290, NULL, 'G3DSA:2.10.70.10:FF:000300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168291, NULL, 'G3DSA:3.40.50.300:FF:008317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168292, NULL, 'G3DSA:1.10.287.70:FF:000307', NULL, NULL, 'TWiK family of potassium channels', NULL, NULL, NULL, NULL, NULL, 4),
(168293, NULL, 'G3DSA:3.30.1360.150:FF:000001', NULL, NULL, 'Alkaline phosphatase PhoK', NULL, NULL, NULL, NULL, NULL, 4),
(168294, NULL, 'G3DSA:2.60.120.260:FF:000656', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168295, NULL, 'G3DSA:2.60.40.10:FF:001347', NULL, NULL, 'Vascular endothelial growth factor receptor 1', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(168296, NULL, 'G3DSA:3.30.70.330:FF:001537', NULL, NULL, 'AGAP002655-PA', NULL, NULL, NULL, NULL, NULL, 4),
(168297, NULL, 'G3DSA:3.40.50.1100:FF:000176', NULL, NULL, 'YALI0B16214p', NULL, NULL, NULL, NULL, NULL, 4),
(168298, NULL, 'G3DSA:1.20.920.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168299, NULL, 'G3DSA:3.30.420.10:FF:000324', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168300, NULL, 'G3DSA:1.25.10.10:FF:001625', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168301, NULL, 'G3DSA:3.30.300.30:FF:000158', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(168302, NULL, 'G3DSA:2.40.50.100:FF:000139', NULL, NULL, 'Exosome complex exonuclease subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(168303, NULL, 'G3DSA:2.40.10.10:FF:000520', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168304, NULL, 'G3DSA:3.40.50.300:FF:005900', NULL, NULL, 'tRNA modification GTPase GTPBP3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(168305, NULL, 'G3DSA:1.20.1250.20:FF:002245', NULL, NULL, 'Os05g0169700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(168306, NULL, 'G3DSA:3.30.420.140:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168307, NULL, 'G3DSA:3.40.50.1820:FF:000279', NULL, NULL, 'Family of serine hydrolases', NULL, NULL, NULL, NULL, NULL, 4),
(168308, NULL, 'G3DSA:2.130.10.10:FF:004877', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168309, NULL, 'G3DSA:1.25.10.10:FF:002238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168310, NULL, 'G3DSA:2.70.50.40:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168311, NULL, 'G3DSA:3.80.10.10:FF:002461', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168312, NULL, 'G3DSA:1.20.1560.10:FF:000669', NULL, NULL, 'ATP-binding cassette transporter, subfamily B, member 21, group MDR/PGP protein PpABCB21', NULL, NULL, NULL, NULL, NULL, 4),
(168313, NULL, 'G3DSA:3.20.20.70:FF:000312', NULL, NULL, '7-carboxy-7-deazaguanine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(168314, NULL, 'G3DSA:3.30.160.60:FF:000830', NULL, NULL, 'zinc finger protein 596 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(168315, NULL, 'G3DSA:3.30.870.10:FF:000127', NULL, NULL, 'AaceriAAR169Cp', NULL, NULL, NULL, NULL, NULL, 4),
(168316, NULL, 'G3DSA:3.20.20.100:FF:000089', NULL, NULL, 'Aldo-keto reductase family 1, member B1 (aldose reductase)', NULL, NULL, NULL, NULL, NULL, 4),
(168317, NULL, 'G3DSA:2.40.70.10:FF:000271', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168318, NULL, 'G3DSA:3.30.1360.10:FF:000043', NULL, NULL, 'RNA polymerase Rpb3/Rpb11 dimerization domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(168319, NULL, 'G3DSA:1.20.1280.50:FF:000272', NULL, NULL, 'F-box/leucine rich repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(168320, NULL, 'G3DSA:1.10.3720.10:FF:000038', NULL, NULL, 'Nickel ABC transporter permease subunit NikC', NULL, NULL, NULL, NULL, NULL, 4),
(168321, NULL, 'G3DSA:3.40.50.300:FF:003293', NULL, NULL, 'Putative insertion sequence ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(168322, NULL, 'G3DSA:2.30.42.10:FF:000583', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168323, NULL, 'G3DSA:1.20.1250.20:FF:000328', NULL, NULL, 'Solute carrier family 45 member 4', NULL, NULL, NULL, NULL, NULL, 4),
(168324, NULL, 'G3DSA:1.25.40.20:FF:001670', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168325, NULL, 'G3DSA:2.60.200.20:FF:000173', NULL, NULL, 'FHA domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(168326, NULL, 'G3DSA:3.30.160.60:FF:003472', NULL, NULL, 'Zinc finger protein 985', NULL, NULL, NULL, NULL, NULL, 4),
(168327, NULL, 'G3DSA:3.30.160.60:FF:000279', NULL, NULL, 'gastrula zinc finger protein XlCGF58.1-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(168328, NULL, 'G3DSA:3.30.40.10:FF:001200', NULL, NULL, 'RING finger protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(168329, NULL, 'G3DSA:1.10.565.10:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168330, NULL, 'G3DSA:2.30.30.40:FF:000463', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168331, NULL, 'G3DSA:2.60.120.10:FF:000130', NULL, NULL, 'Protein kinase, cGMP-dependent', NULL, NULL, NULL, NULL, NULL, 4),
(168332, NULL, 'G3DSA:3.40.50.300:FF:003877', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168333, NULL, 'G3DSA:2.120.10.30:FF:000550', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168334, NULL, 'G3DSA:3.30.70.330:FF:000132', NULL, NULL, 'Small nuclear ribonucleoprotein U11/U12 subunit 35', NULL, NULL, NULL, NULL, NULL, 4),
(168335, NULL, 'G3DSA:2.60.40.10:FF:004545', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168336, NULL, 'G3DSA:2.10.60.10:FF:000018', NULL, NULL, 'BMP and activin membrane-bound inhibitor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(168337, NULL, 'G3DSA:3.30.70.2100:FF:000001', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(168338, NULL, 'G3DSA:1.10.340.30:FF:000004', NULL, NULL, 'DNA-3-methyladenine glycosylase II', NULL, NULL, NULL, NULL, NULL, 4),
(168339, NULL, 'G3DSA:3.40.50.1220:FF:000083', NULL, NULL, 'Pyruvate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(168340, NULL, 'G3DSA:3.40.50.720:FF:000782', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(168341, NULL, 'G3DSA:3.50.50.60:FF:000124', NULL, NULL, 'Glutamate synthase small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(168342, NULL, 'G3DSA:3.90.660.10:FF:000019', NULL, NULL, 'lysine-specific histone demethylase 1 homolog 3', NULL, NULL, NULL, NULL, NULL, 4),
(168343, NULL, 'G3DSA:2.60.34.10:FF:000006', NULL, NULL, 'Heat shock protein cognate 5', NULL, NULL, NULL, NULL, NULL, 4),
(168344, NULL, 'G3DSA:1.10.10.10:FF:000473', NULL, NULL, 'Caffeic acid O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(168345, NULL, 'G3DSA:3.90.550.10:FF:000466', NULL, NULL, 'Slr1070 protein', NULL, NULL, NULL, NULL, NULL, 4),
(168346, NULL, 'G3DSA:2.130.10.10:FF:003000', NULL, NULL, 'Utp5p', NULL, NULL, NULL, NULL, NULL, 4),
(168347, NULL, 'G3DSA:1.20.1280.290:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168348, NULL, 'G3DSA:2.130.10.10:FF:004085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168349, NULL, 'G3DSA:1.25.10.10:FF:000102', NULL, NULL, 'Sister chromatid cohesion protein PDS5 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(168350, NULL, 'G3DSA:1.25.40.10:FF:004887', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168351, NULL, 'G3DSA:2.60.40.60:FF:000715', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(168352, NULL, 'G3DSA:3.30.565.10:FF:000244', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(168353, NULL, 'G3DSA:2.40.50.140:FF:000466', NULL, NULL, 'Replication factor A (SsDNA-binding protein)', NULL, NULL, NULL, NULL, NULL, 4),
(168354, NULL, 'G3DSA:2.60.40.10:FF:002415', NULL, NULL, 'Predicted gene 15448', NULL, NULL, NULL, NULL, NULL, 4),
(168355, NULL, 'G3DSA:3.40.50.1240:FF:000201', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168356, NULL, 'G3DSA:3.30.300.20:FF:000037', NULL, NULL, 'Organic hydroperoxide resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(168357, NULL, 'G3DSA:3.30.240.10:FF:000001', NULL, NULL, 'Regulatory protein cro', NULL, NULL, NULL, NULL, NULL, 4),
(168358, NULL, 'G3DSA:1.10.510.10:FF:002423', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168359, NULL, 'G3DSA:3.90.190.10:FF:000483', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168360, NULL, 'G3DSA:1.10.510.10:FF:003362', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168361, NULL, 'G3DSA:1.10.405.10:FF:000020', NULL, NULL, 'Rab proteins geranylgeranyltransferase component', NULL, NULL, NULL, NULL, NULL, 4),
(168362, NULL, 'G3DSA:3.40.50.1820:FF:000728', NULL, NULL, 'Lipase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(168363, NULL, 'G3DSA:1.20.1560.10:FF:000192', NULL, NULL, 'ABC transporter B family member 6', NULL, NULL, NULL, NULL, NULL, 4),
(168364, NULL, 'G3DSA:1.10.287.370:FF:000009', NULL, NULL, 'Prefoldin chaperone subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(168365, NULL, 'G3DSA:3.80.10.10:FF:001842', NULL, NULL, 'Leucine-rich repeat-containing protein 70', NULL, NULL, NULL, NULL, NULL, 4),
(168366, NULL, 'G3DSA:1.10.472.80:FF:000252', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168367, NULL, 'G3DSA:2.40.30.10:FF:000162', NULL, NULL, 'Iron ABC transporter ATP-binding protein/permease IrtA', NULL, NULL, NULL, NULL, NULL, 4),
(168368, NULL, 'G3DSA:3.30.890.10:FF:000027', NULL, NULL, 'Methyl-CpG-binding domain protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(168369, NULL, 'G3DSA:3.40.630.30:FF:000653', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(168370, NULL, 'G3DSA:2.130.10.10:FF:003579', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168371, NULL, 'G3DSA:3.90.1290.10:FF:000012', NULL, NULL, 'Microtubule-actin cross-linking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(168372, NULL, 'G3DSA:1.25.40.10:FF:002858', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(168373, NULL, 'G3DSA:3.40.50.300:FF:002674', NULL, NULL, 'GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(168374, NULL, 'G3DSA:3.80.10.10:FF:001522', NULL, NULL, 'Leucine_rich_repeat/Leucine_Rich_repeat/Leucine_R ich_Repeat', NULL, NULL, NULL, NULL, NULL, 4),
(168375, NULL, 'G3DSA:2.60.120.430:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168376, NULL, 'G3DSA:3.40.190.10:FF:000399', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(168377, NULL, 'G3DSA:1.10.132.20:FF:000012', NULL, NULL, 'ribosome-recycling factor, mitochondrial-like', NULL, NULL, NULL, NULL, NULL, 4),
(168378, NULL, 'G3DSA:3.30.60.30:FF:000004', NULL, NULL, 'SPARC isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(168379, NULL, 'G3DSA:3.10.20.90:FF:000622', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168380, NULL, 'G3DSA:3.30.450.60:FF:000037', NULL, NULL, 'AP complex subunit sigma', NULL, NULL, NULL, NULL, NULL, 4),
(168381, NULL, 'G3DSA:3.40.50.1000:FF:000022', NULL, NULL, 'Phosphoglycolate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(168382, NULL, 'G3DSA:3.30.420.40:FF:001047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168383, NULL, 'G3DSA:3.40.47.10:FF:000304', NULL, NULL, 'Sterigmatocystin biosynthesis fatty acid synthase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(168384, NULL, 'G3DSA:1.10.230.10:FF:000024', NULL, NULL, 'ATP-citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(168385, NULL, 'G3DSA:3.30.160.60:FF:001004', NULL, NULL, 'Zinc finger protein 426', NULL, NULL, NULL, NULL, NULL, 4),
(168386, NULL, 'G3DSA:1.10.10.720:FF:000007', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(168387, NULL, 'G3DSA:2.60.40.3210:FF:000001', NULL, NULL, 'Zona pellucida sperm-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(168388, NULL, 'G3DSA:2.60.40.10:FF:005973', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168389, NULL, 'G3DSA:3.30.160.60:FF:005613', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168390, NULL, 'G3DSA:3.60.10.10:FF:000275', NULL, NULL, 'CCR4-NOT transcription complex subunit 6-like', NULL, NULL, NULL, NULL, NULL, 4),
(168391, NULL, 'G3DSA:3.40.50.720:FF:001400', NULL, NULL, 'NADP-dependent alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(168392, NULL, 'G3DSA:3.90.79.10:FF:000112', NULL, NULL, 'NUDIX hydrolase dihydroneopterin triphosphate pyrophosphohydrolase/hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(168393, NULL, 'G3DSA:3.30.450.270:FF:000003', NULL, NULL, 'Phytochrome-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(168394, NULL, 'G3DSA:1.10.555.10:FF:000267', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168395, NULL, 'G3DSA:3.40.50.620:FF:000741', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(168396, NULL, 'G3DSA:2.60.120.290:FF:000069', NULL, NULL, 'Dorsal-ventral patterning tolloid protein', NULL, NULL, NULL, NULL, NULL, 4),
(168397, NULL, 'G3DSA:3.90.1430.10:FF:000001', NULL, NULL, '116 kDa U5 small nuclear ribonucleoprotein component', NULL, NULL, NULL, NULL, NULL, 4),
(168398, NULL, 'G3DSA:2.130.10.10:FF:002382', NULL, NULL, 'Glycosyl hydrolase BNR repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(168399, NULL, 'G3DSA:3.40.720.10:FF:000075', NULL, NULL, 'GPI ethanolamine phosphate transferase 3,putative', NULL, NULL, NULL, NULL, NULL, 4),
(168400, NULL, 'G3DSA:2.170.150.10:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168401, NULL, 'G3DSA:2.40.50.100:FF:000027', NULL, NULL, 'DNA-binding transcriptional regulator ModE', NULL, NULL, NULL, NULL, NULL, 4),
(168402, NULL, 'G3DSA:1.10.238.10:FF:001093', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(168403, NULL, 'G3DSA:3.30.430.20:FF:000030', NULL, NULL, 'Cysteine-rich repeat secretory protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(168404, NULL, 'G3DSA:2.130.10.10:FF:004989', NULL, NULL, 'WD repeat domain 18', NULL, NULL, NULL, NULL, NULL, 4),
(168405, NULL, 'G3DSA:1.10.510.10:FF:000169', NULL, NULL, 'Serine/threonine-protein kinase 32A', NULL, NULL, NULL, NULL, NULL, 4),
(168406, NULL, 'G3DSA:2.130.10.10:FF:000145', NULL, NULL, 'WD repeat domain phosphoinositide-interacting protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(168407, NULL, 'G3DSA:3.10.20.30:FF:000071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168408, NULL, 'G3DSA:1.10.10.10:FF:001569', NULL, NULL, 'Purple acid phosphatase 3', NULL, NULL, NULL, NULL, NULL, 4),
(168409, NULL, 'G3DSA:3.30.70.270:FF:000086', NULL, NULL, 'Protein FimX', NULL, NULL, NULL, NULL, NULL, 4),
(168410, NULL, 'G3DSA:2.30.29.30:FF:000277', NULL, NULL, 'src kinase-associated phosphoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(168411, NULL, 'G3DSA:2.60.40.10:FF:006001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168412, NULL, 'G3DSA:3.30.70.270:FF:000198', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168413, NULL, 'G3DSA:3.90.550.10:FF:000258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168414, NULL, 'G3DSA:2.60.40.10:FF:003825', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168415, NULL, 'G3DSA:2.20.25.20:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168416, NULL, 'G3DSA:2.30.31.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168417, NULL, 'G3DSA:3.80.10.10:FF:004259', NULL, NULL, 'Si:ch211-208f21.3', NULL, NULL, NULL, NULL, NULL, 4),
(168418, NULL, 'G3DSA:1.25.10.10:FF:000440', NULL, NULL, 'Armadillo repeat-containing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(168419, NULL, 'G3DSA:1.25.40.20:FF:001338', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(168420, NULL, 'G3DSA:1.10.287.70:FF:000088', NULL, NULL, 'Intermediate conductance calcium-activated potassium channel protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(168421, NULL, 'G3DSA:1.20.5.110:FF:000324', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168422, NULL, 'G3DSA:1.20.120.1900:FF:000070', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(168423, NULL, 'G3DSA:3.30.70.330:FF:002594', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168424, NULL, 'G3DSA:1.10.630.10:FF:000116', NULL, NULL, 'Oxidoreductase A;oxidoreductase/cytochrome P450 monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(168425, NULL, 'G3DSA:1.20.920.30:FF:000024', NULL, NULL, 'Dynein heavy chain, cytosolic, putative', NULL, NULL, NULL, NULL, NULL, 4),
(168426, NULL, 'G3DSA:1.20.58.60:FF:000277', NULL, NULL, 'Spectrin beta chain, non-erythrocytic', NULL, NULL, NULL, NULL, NULL, 4),
(168427, NULL, 'G3DSA:1.20.1250.20:FF:000660', NULL, NULL, 'Unplaced genomic scaffold supercont2.3, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(168428, NULL, 'G3DSA:2.40.30.130:FF:000026', NULL, NULL, 'Alanyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(168429, NULL, 'G3DSA:2.120.10.30:FF:000342', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168430, NULL, 'G3DSA:2.40.30.10:FF:000515', NULL, NULL, 'Elongation factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(168431, NULL, 'G3DSA:1.20.1070.10:FF:001851', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168432, NULL, 'G3DSA:3.30.470.10:FF:000035', NULL, NULL, 'Branched-chain amino acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(168433, NULL, 'G3DSA:3.40.50.300:FF:000420', NULL, NULL, 'Endoribonuclease dicer-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(168434, NULL, 'G3DSA:3.40.50.720:FF:001619', NULL, NULL, 'Os09g0491804 protein', NULL, NULL, NULL, NULL, NULL, 4),
(168435, NULL, 'G3DSA:2.60.40.10:FF:000493', NULL, NULL, 'Coxsackievirus and adenovirus receptor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(168436, NULL, 'G3DSA:3.30.160.60:FF:002628', NULL, NULL, 'Zinc finger and BTB domain containing 11', NULL, NULL, NULL, NULL, NULL, 4),
(168437, NULL, 'G3DSA:1.10.510.10:FF:002743', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168438, NULL, 'G3DSA:1.25.40.10:FF:001453', NULL, NULL, 'Pentatricopeptide repeat-containing protein PNM1 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(168439, NULL, 'G3DSA:3.60.21.10:FF:000295', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(168440, NULL, 'G3DSA:1.10.630.10:FF:000667', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168441, NULL, 'G3DSA:3.40.50.1820:FF:001347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168442, NULL, 'G3DSA:4.10.400.10:FF:000205', NULL, NULL, 'Sortilin-related receptor', NULL, NULL, NULL, NULL, NULL, 4),
(168443, NULL, 'G3DSA:1.10.1000.11:FF:000001', NULL, NULL, 'IQ motif and SEC7 domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(168444, NULL, 'G3DSA:1.25.40.370:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168445, NULL, 'G3DSA:2.60.40.10:FF:000066', NULL, NULL, 'receptor-type tyrosine-protein phosphatase delta isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(168446, NULL, 'G3DSA:3.40.50.12500:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168447, NULL, 'G3DSA:3.40.50.300:FF:007345', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168448, NULL, 'G3DSA:1.20.140.10:FF:000088', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(168449, NULL, 'G3DSA:1.10.287.70:FF:000751', NULL, NULL, 'Calcium voltage-gated channel subunit alpha1 H', NULL, NULL, NULL, NULL, NULL, 4),
(168450, NULL, 'G3DSA:3.90.1520.10:FF:000008', NULL, NULL, 'Soluble guanylate cyclase gcy-33', NULL, NULL, NULL, NULL, NULL, 4),
(168451, NULL, 'G3DSA:2.30.29.30:FF:001114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168452, NULL, 'G3DSA:3.30.470.30:FF:000041', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(168453, NULL, 'G3DSA:3.30.500.10:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168454, NULL, 'G3DSA:3.10.129.10:FF:000258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168455, NULL, 'G3DSA:4.10.1000.10:FF:000150', NULL, NULL, 'Dosage compensation regulator-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(168456, NULL, 'G3DSA:3.30.160.60:FF:004091', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168457, NULL, 'G3DSA:2.40.10.10:FF:000407', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168458, NULL, 'G3DSA:3.30.200.20:FF:002250', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168459, NULL, 'G3DSA:3.40.50.12650:FF:000026', NULL, NULL, 'Beta-lactamase superfamily domain/DNA repair metallo-beta-lactamase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(168460, NULL, 'G3DSA:3.50.30.30:FF:000013', NULL, NULL, 'E3 ubiquitin-protein ligase RNF167', NULL, NULL, NULL, NULL, NULL, 4),
(168461, NULL, 'G3DSA:3.40.50.2000:FF:000884', NULL, NULL, 'Glycosyl transferase group 1', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(168462, NULL, 'G3DSA:2.130.10.10:FF:001763', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168463, NULL, 'G3DSA:3.40.50.720:FF:002570', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168464, NULL, 'G3DSA:3.40.30.10:FF:000777', NULL, NULL, 'Mitosis protein dim1', NULL, NULL, NULL, NULL, NULL, 4),
(168465, NULL, 'G3DSA:3.40.630.10:FF:000208', NULL, NULL, 'Protein CBG05161', NULL, NULL, NULL, NULL, NULL, 4),
(168466, NULL, 'G3DSA:2.120.10.80:FF:000211', NULL, NULL, 'attractin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(168467, NULL, 'G3DSA:1.20.1050.20:FF:000009', NULL, NULL, 'Signal transducer and activator of transcription 5', NULL, NULL, NULL, NULL, NULL, 4),
(168468, NULL, 'G3DSA:3.40.50.10810:FF:000148', NULL, NULL, 'CHD gene family protein containing chromodomain, helicase domain, and DNA-binding domain', NULL, NULL, NULL, NULL, NULL, 4),
(168469, NULL, 'G3DSA:3.40.190.80:FF:000037', NULL, NULL, 'Inositol monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(168470, NULL, 'G3DSA:1.25.40.20:FF:000719', NULL, NULL, 'Putative ankyrin repeat and btb poz domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(168471, NULL, 'G3DSA:3.20.20.190:FF:000065', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(168472, NULL, 'G3DSA:1.20.1310.10:FF:000038', NULL, NULL, 'CDC53p Cullin', NULL, NULL, NULL, NULL, NULL, 4),
(168473, NULL, 'G3DSA:2.60.60.20:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168474, NULL, 'G3DSA:1.20.58.60:FF:000838', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168475, NULL, 'G3DSA:3.40.190.10:FF:000511', NULL, NULL, 'Oligopeptide-binding protein oppA', NULL, NULL, NULL, NULL, NULL, 4),
(168476, NULL, 'G3DSA:3.30.505.10:FF:000004', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(168477, NULL, 'G3DSA:3.10.490.10:FF:000024', NULL, NULL, 'Putative gamma-glutamylcyclotransferase YkqA', NULL, NULL, NULL, NULL, NULL, 4),
(168478, NULL, 'G3DSA:3.30.559.30:FF:000062', NULL, NULL, 'Nonribosomal peptide synthase Pes1', NULL, NULL, NULL, NULL, NULL, 4),
(168479, NULL, 'G3DSA:2.60.40.10:FF:005164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168480, NULL, 'G3DSA:3.10.110.10:FF:000103', NULL, NULL, 'Ubiquitin conjugating enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(168481, NULL, 'G3DSA:2.60.120.200:FF:000796', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(168482, NULL, 'G3DSA:2.60.120.650:FF:000211', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(168483, NULL, 'G3DSA:2.60.40.150:FF:000182', NULL, NULL, 'Synaptotagmin 8', NULL, NULL, NULL, NULL, NULL, 4),
(168484, NULL, 'G3DSA:3.90.740.10:FF:000071', NULL, NULL, 'Isoleucyl tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(168485, NULL, 'G3DSA:2.160.20.10:FF:000060', NULL, NULL, 'Pectin lyase-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(168486, NULL, 'G3DSA:3.40.47.10:FF:000203', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168487, NULL, 'G3DSA:2.10.25.10:FF:001421', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168488, NULL, 'G3DSA:1.10.472.10:FF:000063', NULL, NULL, 'cyclin-H1-1', NULL, NULL, NULL, NULL, NULL, 4),
(168489, NULL, 'G3DSA:2.40.70.10:FF:000057', NULL, NULL, 'Eukaryotic aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(168490, NULL, 'G3DSA:3.40.50.300:FF:004714', NULL, NULL, 'DEAD/DEAH box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(168491, NULL, 'G3DSA:2.40.50.140:FF:001180', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168492, NULL, 'G3DSA:2.10.109.10:FF:000002', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(168493, NULL, 'G3DSA:3.20.20.70:FF:000104', NULL, NULL, 'Thiamine biosynthetic bifunctional enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(168494, NULL, 'G3DSA:1.25.40.10:FF:004084', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g40240, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(168495, NULL, 'G3DSA:1.50.40.10:FF:000428', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(168496, NULL, 'G3DSA:2.70.98.20:FF:000038', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(168497, NULL, 'G3DSA:1.10.1130.10:FF:000010', NULL, NULL, 'C-type polyheme cytochrome OmcB', NULL, NULL, NULL, NULL, NULL, 4),
(168498, NULL, 'G3DSA:3.60.10.10:FF:000376', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168499, NULL, 'G3DSA:3.40.1110.10:FF:000157', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(168500, NULL, 'G3DSA:1.10.1080.10:FF:000005', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(168501, NULL, 'G3DSA:1.10.437.10:FF:000026', NULL, NULL, 'BCL2 associated X, apoptosis regulator', NULL, NULL, NULL, NULL, NULL, 4),
(168502, NULL, 'G3DSA:3.40.309.10:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168503, NULL, 'G3DSA:1.10.510.10:FF:002535', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168504, NULL, 'G3DSA:3.90.1150.10:FF:000098', NULL, NULL, 'Transcriptional regulator, GntR family', NULL, NULL, NULL, NULL, NULL, 4),
(168505, NULL, 'G3DSA:3.30.160.60:FF:000942', NULL, NULL, 'Snail zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(168506, NULL, 'G3DSA:2.60.40.10:FF:005517', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168507, NULL, 'G3DSA:3.90.180.10:FF:000089', NULL, NULL, 'GroES-like zinc-binding alcohol dehydrogenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(168508, NULL, 'G3DSA:2.40.110.10:FF:000055', NULL, NULL, 'Acyl-Coenzyme A dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(168509, NULL, 'G3DSA:3.20.16.10:FF:000003', NULL, NULL, 'Capsid scaffolding protein', NULL, NULL, NULL, NULL, NULL, 4),
(168510, NULL, 'G3DSA:1.20.1250.20:FF:002346', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168511, NULL, 'G3DSA:3.30.450.40:FF:000020', NULL, NULL, 'Acetate operon transcriptional repressor IclR', NULL, NULL, NULL, NULL, NULL, 4),
(168512, NULL, 'G3DSA:2.60.40.1850:FF:000003', NULL, NULL, 'Sortase B protein-sorting domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(168513, NULL, 'G3DSA:2.60.40.60:FF:000592', NULL, NULL, 'Si:dkey-1m11.5', NULL, NULL, NULL, NULL, NULL, 4),
(168514, NULL, 'G3DSA:3.40.720.10:FF:000311', NULL, NULL, 'Alkaline phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(168515, NULL, 'G3DSA:1.10.10.750:FF:000005', NULL, NULL, 'TBC1 domain family member 14', NULL, NULL, NULL, NULL, NULL, 4),
(168516, NULL, 'G3DSA:3.40.50.300:FF:000763', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(168517, NULL, 'G3DSA:1.20.5.350:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168518, NULL, 'G3DSA:1.25.40.120:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168519, NULL, 'G3DSA:1.10.510.10:FF:000405', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(168520, NULL, 'G3DSA:2.60.40.10:FF:000150', NULL, NULL, 'Leucine rich repeats and immunoglobulin like domains 3', NULL, NULL, NULL, NULL, NULL, 4),
(168521, NULL, 'G3DSA:3.30.420.110:FF:000056', NULL, NULL, 'YALI0B10197p', NULL, NULL, NULL, NULL, NULL, 4),
(168522, NULL, 'G3DSA:1.25.10.10:FF:002126', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(168523, NULL, 'G3DSA:3.30.1360.120:FF:000003', NULL, NULL, 'tRNA modification GTPase MnmE', NULL, NULL, NULL, NULL, NULL, 4),
(168524, NULL, 'G3DSA:1.10.10.10:FF:001445', NULL, NULL, 'Replication Protein A homolog', NULL, NULL, NULL, NULL, NULL, 4),
(168525, NULL, 'G3DSA:2.70.160.11:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168526, NULL, 'G3DSA:1.10.287.70:FF:000296', NULL, NULL, 'TWiK family of potassium channels', NULL, NULL, NULL, NULL, NULL, 4),
(168527, NULL, 'G3DSA:2.30.42.10:FF:000032', NULL, NULL, 'Afadin isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(168528, NULL, 'G3DSA:1.20.1070.10:FF:001531', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(168529, NULL, 'G3DSA:1.10.20.110:FF:000001', NULL, NULL, 'Bifunctional aspartate aminotransferase and L-aspartate beta-decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(168530, NULL, 'G3DSA:3.40.50.410:FF:000009', NULL, NULL, 'Putative vitrin', NULL, NULL, NULL, NULL, NULL, 4),
(168531, NULL, 'G3DSA:2.40.20.10:FF:000110', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(168532, NULL, 'G3DSA:1.10.630.10:FF:000324', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168533, NULL, 'G3DSA:3.30.450.60:FF:000026', NULL, NULL, 'Signal recognition particle receptor alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(168534, NULL, 'G3DSA:3.40.50.300:FF:007688', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(168535, NULL, 'G3DSA:3.40.50.300:FF:000100', NULL, NULL, 'Translation elongation factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(168536, NULL, 'G3DSA:3.30.1360.70:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168537, NULL, 'G3DSA:1.25.40.180:FF:000167', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168538, NULL, 'G3DSA:1.10.287.110:FF:000050', NULL, NULL, 'Chaperone protein dnaJ 50', NULL, NULL, NULL, NULL, NULL, 4),
(168539, NULL, 'G3DSA:6.10.140.2220:FF:000060', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(168540, NULL, 'G3DSA:3.40.930.10:FF:000012', NULL, NULL, 'Anion exchange protein', NULL, NULL, NULL, NULL, NULL, 4),
(168541, NULL, 'G3DSA:2.60.40.790:FF:000042', NULL, NULL, 'heat shock protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(168542, NULL, 'G3DSA:3.30.559.10:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168543, NULL, 'G3DSA:2.10.25.10:FF:000780', NULL, NULL, 'Slit homolog 1b (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(168544, NULL, 'G3DSA:2.60.120.10:FF:000681', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168545, NULL, 'G3DSA:2.130.10.10:FF:000706', NULL, NULL, 'Ribosome biogenesis protein YTM1', NULL, NULL, NULL, NULL, NULL, 4),
(168546, NULL, 'G3DSA:1.25.40.20:FF:001776', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168547, NULL, 'G3DSA:2.10.80.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168548, NULL, 'G3DSA:1.20.58.1120:FF:000013', NULL, NULL, 'Dynein heavy chain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(168549, NULL, 'G3DSA:1.10.510.10:FF:003154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168550, NULL, 'G3DSA:3.40.50.10810:FF:000042', NULL, NULL, 'SNF2 family helicase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(168551, NULL, 'G3DSA:2.60.40.640:FF:000025', NULL, NULL, 'Putative Beta-arrestin-2', NULL, NULL, NULL, NULL, NULL, 4),
(168552, NULL, 'G3DSA:3.30.70.270:FF:000209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168553, NULL, 'G3DSA:3.40.50.200:FF:000183', NULL, NULL, 'Gll1055 protein', NULL, NULL, NULL, NULL, NULL, 4),
(168554, NULL, 'G3DSA:3.40.50.1700:FF:000013', NULL, NULL, 'Glycoside hydrolase family 3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(168555, NULL, 'G3DSA:1.20.1250.20:FF:001385', NULL, NULL, 'Major facilitator superfamily MFS_1', NULL, NULL, NULL, NULL, NULL, 4),
(168556, NULL, 'G3DSA:1.20.58.390:FF:000037', NULL, NULL, 'Nicotinic acetylcholine receptor subunit alpha6', NULL, NULL, NULL, NULL, NULL, 4),
(168557, NULL, 'G3DSA:3.40.50.300:FF:006064', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(168558, NULL, 'G3DSA:2.40.10.10:FF:000615', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168559, NULL, 'G3DSA:3.40.1010.10:FF:000009', NULL, NULL, 'ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(168560, NULL, 'G3DSA:2.130.10.10:FF:003455', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168561, NULL, 'G3DSA:3.30.230.10:FF:000175', NULL, NULL, 'Small nuclear ribonucleoprotein component-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(168562, NULL, 'G3DSA:1.10.238.220:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(168563, NULL, 'G3DSA:3.40.50.1820:FF:000622', NULL, NULL, 'Ferri-bacillibactin esterase BesA', NULL, NULL, NULL, NULL, NULL, 4),
(168564, NULL, 'G3DSA:3.80.10.10:FF:000780', NULL, NULL, '18 wheeler', NULL, NULL, NULL, NULL, NULL, 4),
(168565, NULL, 'G3DSA:3.30.70.20:FF:000064', NULL, NULL, 'Ion-translocating oxidoreductase complex subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(168566, NULL, 'G3DSA:1.25.10.10:FF:003295', NULL, NULL, 'Probable sulfatase atsG', NULL, NULL, NULL, NULL, NULL, 4),
(168567, NULL, 'G3DSA:1.10.3080.10:FF:000022', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(168568, NULL, 'G3DSA:2.60.120.650:FF:000003', NULL, NULL, 'Lysine-specific demethylase 4D', NULL, NULL, NULL, NULL, NULL, 4),
(168569, NULL, 'G3DSA:4.10.1240.10:FF:000010', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(168570, NULL, 'G3DSA:3.30.420.10:FF:000223', NULL, NULL, 'Probable CCR4-associated factor 1 homolog 5', NULL, NULL, NULL, NULL, NULL, 4),
(168571, NULL, 'G3DSA:1.10.246.10:FF:000009', NULL, NULL, 'Vitamin D-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(168572, NULL, 'G3DSA:1.20.5.990:FF:000009', NULL, NULL, 'Optineurin', NULL, NULL, NULL, NULL, NULL, 4),
(168573, NULL, 'G3DSA:3.30.200.20:FF:000120', NULL, NULL, 'STE20-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(168574, NULL, 'G3DSA:3.40.50.1460:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168575, NULL, 'G3DSA:2.60.40.150:FF:000305', NULL, NULL, 'Phosphatidylinositol 3-kinase putative', NULL, NULL, NULL, NULL, NULL, 4),
(168576, NULL, 'G3DSA:3.30.160.60:FF:005719', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168577, NULL, 'G3DSA:2.60.120.590:FF:000069', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(168578, NULL, 'G3DSA:1.20.1160.20:FF:000001', NULL, NULL, 'harmonin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(168579, NULL, 'G3DSA:3.10.20.90:FF:000291', NULL, NULL, 'Next to BRCA1 gene 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(168580, NULL, 'G3DSA:1.10.287.1490:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168581, NULL, 'G3DSA:1.10.260.100:FF:000027', NULL, NULL, 'Ankyrin repeat-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(168582, NULL, 'G3DSA:3.30.70.330:FF:002835', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168583, NULL, 'G3DSA:3.30.200.20:FF:001289', NULL, NULL, 'Possible macrolide 2-phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(168584, NULL, 'G3DSA:2.130.10.10:FF:001555', NULL, NULL, 'Similar to U4/U6 small nuclear ribonucleoprotein Prp4', NULL, NULL, NULL, NULL, NULL, 4),
(168585, NULL, 'G3DSA:3.40.50.2300:FF:001036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168586, NULL, 'G3DSA:3.40.50.300:FF:008205', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(168587, NULL, 'G3DSA:3.40.50.300:FF:007929', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168588, NULL, 'G3DSA:1.20.1740.10:FF:000076', NULL, NULL, 'Spore germination protein (Amino acid permease)', NULL, NULL, NULL, NULL, NULL, 4),
(168589, NULL, 'G3DSA:2.60.40.10:FF:004107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168590, NULL, 'G3DSA:3.40.710.10:FF:000029', NULL, NULL, 'Penicillin-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(168591, NULL, 'G3DSA:3.40.50.720:FF:001951', NULL, NULL, 'Short chain dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(168592, NULL, 'G3DSA:1.20.1070.10:FF:000570', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168593, NULL, 'G3DSA:3.40.50.1100:FF:000064', NULL, NULL, 'Threonine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(168594, NULL, 'G3DSA:2.40.240.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168595, NULL, 'G3DSA:1.10.10.60:FF:000134', NULL, NULL, 'Homeobox protein MSX-1', NULL, NULL, NULL, NULL, NULL, 4),
(168596, NULL, 'G3DSA:3.90.226.10:FF:000331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(168597, NULL, 'G3DSA:3.30.920.10:FF:000025', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(168598, NULL, 'G3DSA:3.80.20.20:FF:000036', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(168599, NULL, 'G3DSA:3.30.70.330:FF:003111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168600, NULL, 'G3DSA:3.40.50.1820:FF:000167', NULL, NULL, 'Abhydrolase domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(168601, NULL, 'G3DSA:2.30.29.30:FF:001249', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(168602, NULL, 'G3DSA:2.40.50.1060:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168603, NULL, 'G3DSA:3.40.1050.10:FF:000006', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(168604, NULL, 'G3DSA:1.20.120.920:FF:000004', NULL, NULL, 'CRISPR-associated endonuclease Cas1', NULL, NULL, NULL, NULL, NULL, 4),
(168605, NULL, 'G3DSA:3.30.56.10:FF:000039', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(168606, NULL, 'G3DSA:2.120.10.30:FF:000112', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(168607, NULL, 'G3DSA:3.40.1110.10:FF:000051', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(168608, NULL, 'G3DSA:1.10.472.10:FF:000613', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168609, NULL, 'G3DSA:2.40.10.10:FF:000054', NULL, NULL, 'Complement C1r subcomponent', NULL, NULL, NULL, NULL, NULL, 4),
(168610, NULL, 'G3DSA:3.90.1520.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168611, NULL, 'G3DSA:1.20.1250.20:FF:000766', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(168612, NULL, 'G3DSA:3.40.50.300:FF:004815', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168613, NULL, 'G3DSA:3.30.60.30:FF:000139', NULL, NULL, 'Agr-1', NULL, NULL, NULL, NULL, NULL, 4),
(168614, NULL, 'G3DSA:1.10.575.10:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168615, NULL, 'G3DSA:2.130.10.10:FF:001898', NULL, NULL, 'Ribosome biogenesis protein WDR12 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(168616, NULL, 'G3DSA:1.10.8.190:FF:000002', NULL, NULL, 'Carbon monoxide dehydrogenase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(168617, NULL, 'G3DSA:3.90.70.10:FF:000704', NULL, NULL, 'Ubiquitin-specific protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(168618, NULL, 'G3DSA:1.50.40.10:FF:000097', NULL, NULL, 'Protein MITOFERRINLIKE 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(168619, NULL, 'G3DSA:3.90.79.10:FF:000218', NULL, NULL, 'RPS10-NUDT3 readthrough', NULL, NULL, NULL, NULL, NULL, 4),
(168620, NULL, 'G3DSA:3.30.70.330:FF:000340', NULL, NULL, 'RNA-binding motif protein 28', NULL, NULL, NULL, NULL, NULL, 4),
(168621, NULL, 'G3DSA:2.70.98.10:FF:000024', NULL, NULL, 'Galactose mutarotase', NULL, NULL, NULL, NULL, NULL, 4),
(168622, NULL, 'G3DSA:3.30.160.60:FF:005158', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168623, NULL, 'G3DSA:3.90.1200.10:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168624, NULL, 'G3DSA:3.10.20.90:FF:000414', NULL, NULL, 'Tubulin-specific chaperone B', NULL, NULL, NULL, NULL, NULL, 4),
(168625, NULL, 'G3DSA:1.20.1640.10:FF:000012', NULL, NULL, 'Cation efflux system protein CusA', NULL, NULL, NULL, NULL, NULL, 4),
(168626, NULL, 'G3DSA:3.90.1100.10:FF:000027', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(168627, NULL, 'G3DSA:3.70.10.10:FF:000073', NULL, NULL, 'Checkpoint protein hus1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(168628, NULL, 'G3DSA:3.40.50.1010:FF:000149', NULL, NULL, 'Exonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(168629, NULL, 'G3DSA:1.20.1250.20:FF:000901', NULL, NULL, 'Sucrose transport protein SUC5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(168630, NULL, 'G3DSA:2.40.50.140:FF:000123', NULL, NULL, '30S ribosomal protein S17', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(168631, NULL, 'G3DSA:3.40.50.720:FF:001390', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(168632, NULL, 'G3DSA:3.30.160.60:FF:000487', NULL, NULL, 'ras-responsive element-binding protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(168633, NULL, 'G3DSA:1.20.58.530:FF:000006', NULL, NULL, 'Putative unconventional myosin-VI', NULL, NULL, NULL, NULL, NULL, 4),
(168634, NULL, 'G3DSA:1.20.120.230:FF:000005', NULL, NULL, 'Talin 1', NULL, NULL, NULL, NULL, NULL, 4),
(168635, NULL, 'G3DSA:2.60.40.150:FF:000535', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(168636, NULL, 'G3DSA:3.50.7.10:FF:000016', NULL, NULL, '1-phosphatidylinositol 3-phosphate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(168637, NULL, 'G3DSA:2.40.30.170:FF:000010', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(168638, NULL, 'G3DSA:1.20.1250.20:FF:001520', NULL, NULL, 'Os07g0131200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(168639, NULL, 'G3DSA:2.30.42.10:FF:000375', NULL, NULL, 'Slip1, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(168640, NULL, 'G3DSA:1.25.40.340:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168641, NULL, 'G3DSA:3.30.1130.10:FF:000009', NULL, NULL, 'GTP cyclohydrolase I', NULL, NULL, NULL, NULL, NULL, 4),
(168642, NULL, 'G3DSA:3.60.40.10:FF:000215', NULL, NULL, 'Ptc8p', NULL, NULL, NULL, NULL, NULL, 4),
(168643, NULL, 'G3DSA:2.30.30.40:FF:000362', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(168644, NULL, 'G3DSA:3.40.630.30:FF:000445', NULL, NULL, 'Ribosomal-protein-alanine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(168645, NULL, 'G3DSA:1.20.1270.60:FF:000212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168646, NULL, 'G3DSA:3.40.109.10:FF:000003', NULL, NULL, 'Probable malonic semialdehyde reductase RutE', NULL, NULL, NULL, NULL, NULL, 4),
(168647, NULL, 'G3DSA:3.30.70.260:FF:000184', NULL, NULL, 'Putative prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(168648, NULL, 'G3DSA:3.40.50.300:FF:006968', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168649, NULL, 'G3DSA:2.60.40.10:FF:002207', NULL, NULL, 'Poliovirus receptor-related 2 like', NULL, NULL, NULL, NULL, NULL, 4),
(168650, NULL, 'G3DSA:1.20.58.60:FF:000176', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(168651, NULL, 'G3DSA:3.40.50.2300:FF:001492', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168652, NULL, 'G3DSA:3.30.530.20:FF:000094', NULL, NULL, 'Bet v I allergen family protein', NULL, NULL, NULL, NULL, NULL, 4),
(168653, NULL, 'G3DSA:1.25.40.10:FF:005264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168654, NULL, 'G3DSA:2.30.230.10:FF:000038', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(168655, NULL, 'G3DSA:1.20.5.110:FF:000083', NULL, NULL, 'syntaxin-4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(168656, NULL, 'G3DSA:3.30.230.80:FF:000021', NULL, NULL, 'HSP90 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(168657, NULL, 'G3DSA:1.20.1250.20:FF:002003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168658, NULL, 'G3DSA:3.40.50.410:FF:000341', NULL, NULL, 'Integrin beta-like protein C', NULL, NULL, NULL, NULL, NULL, 4),
(168659, NULL, 'G3DSA:1.10.132.70:FF:000016', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(168660, NULL, 'G3DSA:3.40.50.720:FF:000439', NULL, NULL, 'Short chain dehydrogenase/reductase (AFU_orthologue AFUA_2G00830)', NULL, NULL, NULL, NULL, NULL, 4),
(168661, NULL, 'G3DSA:3.90.730.10:FF:000014', NULL, NULL, 'Ribonuclease T2', NULL, NULL, NULL, NULL, NULL, 4),
(168662, NULL, 'G3DSA:3.40.50.1820:FF:001448', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168663, NULL, 'G3DSA:1.10.510.10:FF:002878', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168664, NULL, 'G3DSA:3.40.50.150:FF:001763', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(168665, NULL, 'G3DSA:3.40.50.10860:FF:000040', NULL, NULL, 'Shikimate biosynthesis protein AroDE', NULL, NULL, NULL, NULL, NULL, 4),
(168666, NULL, 'G3DSA:3.20.20.20:FF:000005', NULL, NULL, '4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase (flavodoxin)', NULL, NULL, NULL, NULL, NULL, 4),
(168667, NULL, 'G3DSA:3.40.50.12780:FF:000172', NULL, NULL, 'Long-chain-fatty-acid--CoA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(168668, NULL, 'G3DSA:1.25.40.10:FF:004988', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168669, NULL, 'G3DSA:3.40.50.150:FF:000353', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase G', NULL, NULL, NULL, NULL, NULL, 4),
(168670, NULL, 'G3DSA:2.40.70.10:FF:000512', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168671, NULL, 'G3DSA:1.10.246.90:FF:000005', NULL, NULL, 'Nucleolar protein 5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(168672, NULL, 'G3DSA:2.10.25.10:FF:000448', NULL, NULL, 'Stabilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(168673, NULL, 'G3DSA:2.30.29.30:FF:000288', NULL, NULL, 'Leucine-rich repeat, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(168674, NULL, 'G3DSA:3.90.190.20:FF:000031', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(168675, NULL, 'G3DSA:2.60.220.50:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168676, NULL, 'G3DSA:1.25.40.20:FF:000057', NULL, NULL, 'Ankyrin repeat domain-containing protein 13B', NULL, NULL, NULL, NULL, NULL, 4),
(168677, NULL, 'G3DSA:2.60.40.10:FF:001589', NULL, NULL, 'Tyrosine-protein phosphatase 10D', NULL, NULL, NULL, NULL, NULL, 4),
(168678, NULL, 'G3DSA:3.20.20.140:FF:000410', NULL, NULL, 'TatD DNase domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(168679, NULL, 'G3DSA:3.90.70.10:FF:000143', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(168680, NULL, 'G3DSA:3.30.420.10:FF:000566', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168681, NULL, 'G3DSA:3.30.470.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168682, NULL, 'G3DSA:3.40.50.970:FF:000031', NULL, NULL, 'Pyruvate dehydrogenase [ubiquinone]', NULL, NULL, NULL, NULL, NULL, 4),
(168683, NULL, 'G3DSA:1.10.8.60:FF:000386', NULL, NULL, 'Putative nuclear aaa atpase vcp subfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(168684, NULL, 'G3DSA:3.40.50.300:FF:005434', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168685, NULL, 'G3DSA:1.20.58.80:FF:000058', NULL, NULL, 'Probable ubiquitin thioesterase DG1039', NULL, NULL, NULL, NULL, NULL, 4),
(168686, NULL, 'G3DSA:1.10.510.10:FF:003715', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168687, NULL, 'G3DSA:1.25.40.10:FF:003364', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g56690, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(168688, NULL, 'G3DSA:2.30.40.10:FF:000084', NULL, NULL, 'Cytosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(168689, NULL, 'G3DSA:3.40.50.620:FF:000398', NULL, NULL, 'Cytoplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(168690, NULL, 'G3DSA:3.30.40.10:FF:001442', NULL, NULL, 'RNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(168691, NULL, 'G3DSA:2.130.10.10:FF:002174', NULL, NULL, 'F-box and WD repeat domain-containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(168692, NULL, 'G3DSA:2.60.120.1540:FF:000006', NULL, NULL, 'MHC-linked complement C4', NULL, NULL, NULL, NULL, NULL, 4),
(168693, NULL, 'G3DSA:3.30.450.20:FF:000604', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168694, NULL, 'G3DSA:2.70.150.10:FF:000017', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(168695, NULL, 'G3DSA:2.60.120.260:FF:000201', NULL, NULL, 'Si:dkey-147f3.8', NULL, NULL, NULL, NULL, NULL, 4),
(168696, NULL, 'G3DSA:1.25.40.10:FF:001678', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g36730', NULL, NULL, NULL, NULL, NULL, 4),
(168697, NULL, 'G3DSA:2.40.160.110:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(168698, NULL, 'G3DSA:1.25.40.20:FF:000950', NULL, NULL, 'Ankyrin repeat domain 12', NULL, NULL, NULL, NULL, NULL, 4),
(168699, NULL, 'G3DSA:2.60.40.10:FF:005405', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168700, NULL, 'G3DSA:3.30.565.10:FF:000002', NULL, NULL, 'DNA gyrase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(168701, NULL, 'G3DSA:1.20.1560.10:FF:000433', NULL, NULL, 'ABC transporter, multidrug resistance associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(168702, NULL, 'G3DSA:3.80.10.10:FF:003315', NULL, NULL, 'Toll-9, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(168703, NULL, 'G3DSA:1.25.40.620:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168704, NULL, 'G3DSA:4.10.110.10:FF:000009', NULL, NULL, 'integumentary mucin A.1-like', NULL, NULL, NULL, NULL, NULL, 4),
(168705, NULL, 'G3DSA:3.30.540.30:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168706, NULL, 'G3DSA:1.10.510.10:FF:002081', NULL, NULL, 'Kinase', NULL, NULL, NULL, NULL, NULL, 4),
(168707, NULL, 'G3DSA:3.80.10.10:FF:000561', NULL, NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At2g16250', NULL, NULL, NULL, NULL, NULL, 4),
(168708, NULL, 'G3DSA:3.40.50.300:FF:004147', NULL, NULL, 'Uncharacterized MCM-type protein MJ0961', NULL, NULL, NULL, NULL, NULL, 4),
(168709, NULL, 'G3DSA:3.30.499.10:FF:000022', NULL, NULL, 'Aconitate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(168710, NULL, 'G3DSA:3.40.30.10:FF:000108', NULL, NULL, 'NHL repeat-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(168711, NULL, 'G3DSA:2.130.10.10:FF:003236', NULL, NULL, 'U4/U6-U5 snRNP complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(168712, NULL, 'G3DSA:2.130.10.10:FF:005372', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168713, NULL, 'G3DSA:1.20.1070.10:FF:002020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168714, NULL, 'G3DSA:1.10.238.10:FF:000013', NULL, NULL, 'Microtubule-actin cross-linking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(168715, NULL, 'G3DSA:3.40.50.10490:FF:000125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168716, NULL, 'G3DSA:3.40.50.10330:FF:000105', NULL, NULL, 'Uncharacterized kinase C1B1.02c', NULL, NULL, NULL, NULL, NULL, 4),
(168717, NULL, 'G3DSA:2.60.120.200:FF:000453', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168718, NULL, 'G3DSA:2.60.120.10:FF:000793', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168719, NULL, 'G3DSA:3.40.50.150:FF:000010', NULL, NULL, 'Protein-L-isoaspartate O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(168720, NULL, 'G3DSA:2.10.70.10:FF:000194', NULL, NULL, 'CUB and sushi domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(168721, NULL, 'G3DSA:1.25.40.470:FF:000041', NULL, NULL, 'intraflagellar transport protein 140 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(168722, NULL, 'G3DSA:1.25.40.10:FF:003027', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(168723, NULL, 'G3DSA:3.40.50.300:FF:002005', NULL, NULL, 'Type IV secretion system protein VirD4', NULL, NULL, NULL, NULL, NULL, 4),
(168724, NULL, 'G3DSA:3.30.160.60:FF:005950', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168725, NULL, 'G3DSA:3.40.1190.20:FF:000160', NULL, NULL, 'ATP-dependent (S)-NAD(P)H-hydrate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(168726, NULL, 'G3DSA:1.10.730.10:FF:000152', NULL, NULL, 'Valyl tRNA Synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(168727, NULL, 'G3DSA:2.40.50.140:FF:000224', NULL, NULL, 'RecQ mediated genome instability 2', NULL, NULL, NULL, NULL, NULL, 4),
(168728, NULL, 'G3DSA:3.40.50.1820:FF:001004', NULL, NULL, 'ADR202Cp', NULL, NULL, NULL, NULL, NULL, 4),
(168729, NULL, 'G3DSA:1.10.10.60:FF:001090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168730, NULL, 'G3DSA:2.60.120.310:FF:000019', NULL, NULL, 'Dopamine beta-hydroxylase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(168731, NULL, 'G3DSA:3.40.50.300:FF:005771', NULL, NULL, 'SNF2 helicase', NULL, NULL, NULL, NULL, NULL, 4),
(168732, NULL, 'G3DSA:3.30.9.10:FF:000054', NULL, NULL, 'Unplaced genomic scaffold supercont1.188, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(168733, NULL, 'G3DSA:1.25.40.20:FF:001911', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168734, NULL, 'G3DSA:3.30.559.30:FF:000067', NULL, NULL, 'Putative peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(168735, NULL, 'G3DSA:1.25.40.600:FF:000001', NULL, NULL, 'Acid-activated urea channel', NULL, NULL, NULL, NULL, NULL, 4),
(168736, NULL, 'G3DSA:1.20.5.190:FF:000180', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168737, NULL, 'G3DSA:1.10.246.20:FF:000001', NULL, NULL, 'E1A binding protein p300', NULL, NULL, NULL, NULL, NULL, 4),
(168738, NULL, 'G3DSA:1.25.10.10:FF:000445', NULL, NULL, 'Related to MOT1-transcriptional accessory protein', NULL, NULL, NULL, NULL, NULL, 4),
(168739, NULL, 'G3DSA:2.130.10.10:FF:000482', NULL, NULL, 'WD repeat-containing protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(168740, NULL, 'G3DSA:3.80.10.10:FF:002803', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168741, NULL, 'G3DSA:1.10.287.110:FF:000409', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168742, NULL, 'G3DSA:2.60.40.10:FF:006024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168743, NULL, 'G3DSA:1.50.40.10:FF:000074', NULL, NULL, 'Solute carrier family 25 member 36', NULL, NULL, NULL, NULL, NULL, 4),
(168744, NULL, 'G3DSA:1.20.58.1800:FF:000003', NULL, NULL, 'Trehalose-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(168745, NULL, 'G3DSA:1.10.287.70:FF:000768', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168746, NULL, 'G3DSA:3.20.20.370:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168747, NULL, 'G3DSA:3.40.50.1110:FF:000162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168748, NULL, 'G3DSA:2.40.128.630:FF:000001', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(168749, NULL, 'G3DSA:1.10.238.10:FF:000120', NULL, NULL, '45 kDa calcium-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(168750, NULL, 'G3DSA:1.10.510.10:FF:001462', NULL, NULL, 'Kinase, CMGC CDK', NULL, NULL, NULL, NULL, NULL, 4),
(168751, NULL, 'G3DSA:3.40.50.300:FF:004254', NULL, NULL, 'Putative vesicular-fusion ATPase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(168752, NULL, 'G3DSA:2.20.25.90:FF:000005', NULL, NULL, 'Thiosulfate reductase PhsA', NULL, NULL, NULL, NULL, NULL, 4),
(168753, NULL, 'G3DSA:2.80.10.50:FF:000047', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(168754, NULL, 'G3DSA:3.20.20.80:FF:000646', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168755, NULL, 'G3DSA:2.60.260.20:FF:000053', NULL, NULL, 'Related to DnaJ homolog subfamily A member 2', NULL, NULL, NULL, NULL, NULL, 4),
(168756, NULL, 'G3DSA:2.120.10.80:FF:000323', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168757, NULL, 'G3DSA:1.20.120.350:FF:000261', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168758, NULL, 'G3DSA:2.40.10.10:FF:000391', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168759, NULL, 'G3DSA:2.20.70.10:FF:000002', NULL, NULL, 'Membrane-associated guanylate kinase, WW and PDZ domain-containing protein 3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(168760, NULL, 'G3DSA:3.80.10.10:FF:001180', NULL, NULL, 'Receptor like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(168761, NULL, 'G3DSA:3.30.200.20:FF:001862', NULL, NULL, 'Cyclin dependent kinase 19', NULL, NULL, NULL, NULL, NULL, 4),
(168762, NULL, 'G3DSA:1.10.10.10:FF:000821', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(168763, NULL, 'G3DSA:2.60.120.330:FF:000126', NULL, NULL, '2OG-Fe(II) oxygenase superfamily, putative', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(168764, NULL, 'G3DSA:3.40.50.720:FF:000445', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(168765, NULL, 'G3DSA:3.40.50.2300:FF:000991', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168766, NULL, 'G3DSA:3.40.140.10:FF:000233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168767, NULL, 'G3DSA:1.10.510.10:FF:004216', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168768, NULL, 'G3DSA:3.30.160.60:FF:002179', NULL, NULL, 'Zinc finger protein 961', NULL, NULL, NULL, NULL, NULL, 4),
(168769, NULL, 'G3DSA:2.60.40.10:FF:000622', NULL, NULL, 'Fibronectin 1', NULL, NULL, NULL, NULL, NULL, 4),
(168770, NULL, 'G3DSA:3.40.50.300:FF:008418', NULL, NULL, 'ATP-dependent DNA helicase chl1', NULL, NULL, NULL, NULL, NULL, 4),
(168771, NULL, 'G3DSA:1.10.530.10:FF:000041', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(168772, NULL, 'G3DSA:1.10.10.10:FF:000714', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(168773, NULL, 'G3DSA:2.30.29.30:FF:000844', NULL, NULL, 'Nuclear pore complex protein Nup50', NULL, NULL, NULL, NULL, NULL, 4),
(168774, NULL, 'G3DSA:3.40.50.300:FF:008525', NULL, NULL, 'ATP-dependent helicase hrpA', NULL, NULL, NULL, NULL, NULL, 4),
(168775, NULL, 'G3DSA:1.10.3130.10:FF:000010', NULL, NULL, 'Serine acetyltransferase 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(168776, NULL, 'G3DSA:3.30.479.10:FF:000015', NULL, NULL, '6-carboxy-5,6,7,8-tetrahydropterin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(168777, NULL, 'G3DSA:1.25.40.10:FF:000273', NULL, NULL, 'Tetratricopeptide repeat domain 39B', NULL, NULL, NULL, NULL, NULL, 4),
(168778, NULL, 'G3DSA:3.40.1120.10:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168779, NULL, 'G3DSA:3.10.50.40:FF:000013', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(168780, NULL, 'G3DSA:1.20.140.10:FF:000071', NULL, NULL, 'Acyl-CoA dehydrogenase, mitochondrial,putative', NULL, NULL, NULL, NULL, NULL, 4),
(168781, NULL, 'G3DSA:3.40.50.300:FF:003309', NULL, NULL, 'L-seryl-tRNA(Sec) kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(168782, NULL, 'G3DSA:3.30.170.10:FF:000006', NULL, NULL, 'Cyclin-dependent kinases regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(168783, NULL, 'G3DSA:3.30.70.580:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168784, NULL, 'G3DSA:2.60.120.310:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168785, NULL, 'G3DSA:3.30.40.10:FF:000930', NULL, NULL, 'RING finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(168786, NULL, 'G3DSA:3.40.50.1820:FF:000487', NULL, NULL, 'Dienelactone hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(168787, NULL, 'G3DSA:3.90.1580.10:FF:000012', NULL, NULL, 'Protein PvdO', NULL, NULL, NULL, NULL, NULL, 4),
(168788, NULL, 'G3DSA:3.80.10.10:FF:000549', NULL, NULL, 'Carboxypeptidase N subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(168789, NULL, 'G3DSA:2.60.220.50:FF:000054', NULL, NULL, 'Polycystin 1 like 3, transient receptor potential channel interacting', NULL, NULL, NULL, NULL, NULL, 4),
(168790, NULL, 'G3DSA:3.40.50.720:FF:000338', NULL, NULL, '3-oxoacyl-ACP reductase FabG', NULL, NULL, NULL, NULL, NULL, 4),
(168791, NULL, 'G3DSA:2.120.10.80:FF:000216', NULL, NULL, 'Flagellar outer dynein arm heavy chain alpha', NULL, NULL, NULL, NULL, NULL, 4),
(168792, NULL, 'G3DSA:2.60.40.1180:FF:000111', NULL, NULL, 'GM24746', NULL, NULL, NULL, NULL, NULL, 4),
(168793, NULL, 'G3DSA:1.25.40.10:FF:000380', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(168794, NULL, 'G3DSA:2.60.120.260:FF:000313', NULL, NULL, 'Beta-glucuronidase (GusB)', NULL, NULL, NULL, NULL, NULL, 4),
(168795, NULL, 'G3DSA:1.20.58.70:FF:000050', NULL, NULL, 'EhSyntaxin 1A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(168796, NULL, 'G3DSA:1.10.220.150:FF:000023', NULL, NULL, 'Arf-GAP with ANK repeat and PH domain-containing protein cnt-2', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(168797, NULL, 'G3DSA:3.90.550.20:FF:000019', NULL, NULL, 'WD repeat and SOF domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(168798, NULL, 'G3DSA:3.40.1110.10:FF:000287', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168799, NULL, 'G3DSA:1.10.1200.270:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168800, NULL, 'G3DSA:3.40.718.10:FF:000047', NULL, NULL, 'Isocitrate dehydrogenase [NAD] subunit gamma, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(168801, NULL, 'G3DSA:2.130.10.10:FF:001786', NULL, NULL, 'Probable cytosolic iron-sulfur protein assembly protein Ciao1', NULL, NULL, NULL, NULL, NULL, 4),
(168802, NULL, 'G3DSA:3.30.160.60:FF:005164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168803, NULL, 'G3DSA:2.60.40.640:FF:000002', NULL, NULL, 'Vacuolar protein sorting-associated protein 26A', NULL, NULL, NULL, NULL, NULL, 4),
(168804, NULL, 'G3DSA:2.30.29.30:FF:001137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168805, NULL, 'G3DSA:4.10.1060.10:FF:000024', NULL, NULL, 'RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(168806, NULL, 'G3DSA:3.30.2020.30:FF:000024', NULL, NULL, 'IP11527p', NULL, NULL, NULL, NULL, NULL, 4),
(168807, NULL, 'G3DSA:2.10.70.10:FF:000087', NULL, NULL, 'Complement component receptor type 1', NULL, NULL, NULL, NULL, NULL, 4),
(168808, NULL, 'G3DSA:1.25.40.10:FF:001577', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(168809, NULL, 'G3DSA:1.10.533.10:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168810, NULL, 'G3DSA:3.90.70.40:FF:000011', NULL, NULL, 'GM12472', NULL, NULL, NULL, NULL, NULL, 4),
(168811, NULL, 'G3DSA:3.40.50.300:FF:006620', NULL, NULL, 'LL-diaminopimelate aminotransferase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(168812, NULL, 'G3DSA:2.40.50.90:FF:000147', NULL, NULL, 'AGAP012831-PA', NULL, NULL, NULL, NULL, NULL, 4),
(168813, NULL, 'G3DSA:1.20.1250.20:FF:001278', NULL, NULL, 'Membrane transport protein, possible multidrug resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(168814, NULL, 'G3DSA:3.40.605.10:FF:000009', NULL, NULL, 'Cytosolic 10-formyltetrahydrofolate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(168815, NULL, 'G3DSA:3.30.160.60:FF:004652', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168816, NULL, 'G3DSA:3.30.200.20:FF:001058', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(168817, NULL, 'G3DSA:2.60.40.10:FF:000841', NULL, NULL, 'obscurin isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(168818, NULL, 'G3DSA:3.40.120.10:FF:000001', NULL, NULL, 'Phosphoglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(168819, NULL, 'G3DSA:3.30.60.30:FF:000027', NULL, NULL, 'Complement factor I', NULL, NULL, NULL, NULL, NULL, 4),
(168820, NULL, 'G3DSA:1.10.1410.10:FF:000043', NULL, NULL, 'Poly(A) polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(168821, NULL, 'G3DSA:1.10.150.50:FF:000164', NULL, NULL, 'Tyrosine kinase, non-receptor, 1', NULL, NULL, NULL, NULL, NULL, 4),
(168822, NULL, 'G3DSA:3.40.50.410:FF:000240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168823, NULL, 'G3DSA:2.60.40.640:FF:000132', NULL, NULL, 'Arrestin 3', NULL, NULL, NULL, NULL, NULL, 4),
(168824, NULL, 'G3DSA:2.30.29.30:FF:000625', NULL, NULL, 'target of rapamycin complex 2 subunit MAPKAP1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(168825, NULL, 'G3DSA:2.30.29.30:FF:000737', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168826, NULL, 'G3DSA:1.20.1070.10:FF:000558', NULL, NULL, 'Thromboxane A2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(168827, NULL, 'G3DSA:1.10.8.10:FF:000281', NULL, NULL, 'SBP (S-ribonuclease binding protein) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(168828, NULL, 'G3DSA:3.40.50.10470:FF:000018', NULL, NULL, 'Methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(168829, NULL, 'G3DSA:1.10.230.10:FF:000001', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(168830, NULL, 'G3DSA:1.20.1110.10:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168831, NULL, 'G3DSA:2.60.120.200:FF:000560', NULL, NULL, 'L-type lectin-domain containing receptor kinase V.9', NULL, NULL, NULL, NULL, NULL, 4),
(168832, NULL, 'G3DSA:4.10.900.10:FF:000013', NULL, NULL, 'transcription factor 7-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(168833, NULL, 'G3DSA:1.20.1530.20:FF:000030', NULL, NULL, 'Na(+)/H(+) antiporter NhaP', NULL, NULL, NULL, NULL, NULL, 4),
(168834, NULL, 'G3DSA:1.20.5.190:FF:000073', NULL, NULL, 'Abnormal spindle microtubule assembly', NULL, NULL, NULL, NULL, NULL, 4),
(168835, NULL, 'G3DSA:3.15.20.10:FF:000003', NULL, NULL, 'BPI fold-containing family B member 3', NULL, NULL, NULL, NULL, NULL, 4),
(168836, NULL, 'G3DSA:3.40.50.720:FF:001283', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(168837, NULL, 'G3DSA:3.20.20.80:FF:000776', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168838, NULL, 'G3DSA:3.40.50.1700:FF:000018', NULL, NULL, 'Glycosyl hydrolase family 3 C terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(168839, NULL, 'G3DSA:3.40.50.300:FF:007587', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168840, NULL, 'G3DSA:2.60.120.10:FF:000686', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(168841, NULL, 'G3DSA:1.20.1420.10:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168842, NULL, 'G3DSA:2.40.30.10:FF:000167', NULL, NULL, 'Slm3p', NULL, NULL, NULL, NULL, NULL, 4),
(168843, NULL, 'G3DSA:3.30.160.60:FF:004433', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168844, NULL, 'G3DSA:2.60.260.20:FF:000160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168845, NULL, 'G3DSA:3.40.50.300:FF:000095', NULL, NULL, 'Rho-related GTP-binding protein RhoC', NULL, NULL, NULL, NULL, NULL, 4),
(168846, NULL, 'G3DSA:2.60.40.10:FF:004101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168847, NULL, 'G3DSA:3.40.720.10:FF:000316', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(168848, NULL, 'G3DSA:2.60.120.330:FF:000233', NULL, NULL, 'Os05g0514600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(168849, NULL, 'G3DSA:3.90.260.10:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168850, NULL, 'G3DSA:3.40.50.920:FF:000050', NULL, NULL, 'Pyruvate dehydrogenase E1 component subunit beta, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(168851, NULL, 'G3DSA:1.20.900.10:FF:000039', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(168852, NULL, 'G3DSA:3.40.50.10190:FF:000367', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(168853, NULL, 'G3DSA:3.40.30.10:FF:001053', NULL, NULL, 'Glutathione S-transferase kappa', NULL, NULL, NULL, NULL, NULL, 4),
(168854, NULL, 'G3DSA:3.40.50.10190:FF:000361', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168855, NULL, 'G3DSA:3.40.50.300:FF:004366', NULL, NULL, 'Probable metal transport system ATP-binding protein CT_416', NULL, NULL, NULL, NULL, NULL, 4),
(168856, NULL, 'G3DSA:3.40.50.1110:FF:000050', NULL, NULL, 'N-acetylneuraminate 9-O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(168857, NULL, 'G3DSA:1.10.246.60:FF:000007', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit J', NULL, NULL, NULL, NULL, NULL, 4),
(168858, NULL, 'G3DSA:1.25.40.10:FF:004432', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168859, NULL, 'G3DSA:3.40.50.1100:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168860, NULL, 'G3DSA:3.40.640.10:FF:000496', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168861, NULL, 'G3DSA:1.10.1200.10:FF:000111', NULL, NULL, 'Peptidyl carrier protein type II', NULL, NULL, NULL, NULL, NULL, 4),
(168862, NULL, 'G3DSA:3.30.70.330:FF:002251', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(168863, NULL, 'G3DSA:1.20.90.10:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168864, NULL, 'G3DSA:3.30.310.130:FF:000009', NULL, NULL, 'Unplaced genomic scaffold supercont2.24, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(168865, NULL, 'G3DSA:3.30.470.20:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168866, NULL, 'G3DSA:1.25.40.10:FF:000958', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g39530', NULL, NULL, NULL, NULL, NULL, 4),
(168867, NULL, 'G3DSA:2.50.20.10:FF:000020', NULL, NULL, 'Outer membrane lipoprotein carrier protein LolA', NULL, NULL, NULL, NULL, NULL, 4),
(168868, NULL, 'G3DSA:2.10.25.10:FF:000128', NULL, NULL, 'laminin subunit alpha-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(168869, NULL, 'G3DSA:2.70.50.30:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168870, NULL, 'G3DSA:1.20.1440.90:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168871, NULL, 'G3DSA:3.60.21.10:FF:000076', NULL, NULL, 'Putative nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(168872, NULL, 'G3DSA:1.10.2000.10:FF:000023', NULL, NULL, 'Tyrosine-protein kinase transmembrane receptor ROR2', NULL, NULL, NULL, NULL, NULL, 4),
(168873, NULL, 'G3DSA:1.10.10.10:FF:001333', NULL, NULL, 'PCI domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(168874, NULL, 'G3DSA:1.10.287.130:FF:000056', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(168875, NULL, 'G3DSA:1.25.40.10:FF:000161', NULL, NULL, 'prolyl 4-hydroxylase subunit alpha-3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(168876, NULL, 'G3DSA:3.30.70.380:FF:000006', NULL, NULL, 'Phenylalanyl-tRNA synthetase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(168877, NULL, 'G3DSA:1.10.3260.10:FF:000019', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(168878, NULL, 'G3DSA:3.90.470.20:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168879, NULL, 'G3DSA:3.30.160.60:FF:005849', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168880, NULL, 'G3DSA:1.10.238.10:FF:000805', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(168881, NULL, 'G3DSA:1.20.58.670:FF:000008', NULL, NULL, 'Protein transport protein TIP20', NULL, NULL, NULL, NULL, NULL, 4),
(168882, NULL, 'G3DSA:3.40.50.620:FF:000078', NULL, NULL, 'Valine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(168883, NULL, 'G3DSA:3.20.20.70:FF:000317', NULL, NULL, '2-isopropylmalate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(168884, NULL, 'G3DSA:1.25.40.20:FF:000495', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(168885, NULL, 'G3DSA:1.10.510.10:FF:000164', NULL, NULL, 'Casein kinase 1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(168886, NULL, 'G3DSA:1.10.555.10:FF:000244', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168887, NULL, 'G3DSA:2.70.170.10:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168888, NULL, 'G3DSA:1.20.1050.130:FF:000028', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(168889, NULL, 'G3DSA:3.90.70.10:FF:000805', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(168890, NULL, 'G3DSA:3.10.100.10:FF:000046', NULL, NULL, 'Secretory phospholipase A2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(168891, NULL, 'G3DSA:1.10.470.10:FF:000002', NULL, NULL, 'Variant surface glycoprotein (VSG, atypical), putative', NULL, NULL, NULL, NULL, NULL, 4),
(168892, NULL, 'G3DSA:3.90.550.10:FF:000360', NULL, NULL, 'UDP-N-acetylglucosamine pyrophosphorylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(168893, NULL, 'G3DSA:1.20.120.350:FF:000024', NULL, NULL, 'Potassium voltage-gated channel subfamily G member 1', NULL, NULL, NULL, NULL, NULL, 4),
(168894, NULL, 'G3DSA:3.30.1370.10:FF:000111', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(168895, NULL, 'G3DSA:1.10.510.10:FF:004435', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(168896, NULL, 'G3DSA:3.20.20.140:FF:000303', NULL, NULL, 'Putative cell surface-anchored phosphoesterase', NULL, NULL, NULL, NULL, NULL, 4),
(168897, NULL, 'G3DSA:4.10.1000.40:FF:000012', NULL, NULL, 'Nuclear polyadenylated RNA-binding protein NAB2', NULL, NULL, NULL, NULL, NULL, 4),
(168898, NULL, 'G3DSA:1.10.287.770:FF:000017', NULL, NULL, 'T-cell surface glycoprotein CD3 delta chain', NULL, NULL, NULL, NULL, NULL, 4),
(168899, NULL, 'G3DSA:3.40.50.2020:FF:000103', NULL, NULL, 'Ribose-phosphate pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(168900, NULL, 'G3DSA:2.80.10.50:FF:000159', NULL, NULL, 'Dolichyl-phosphate-mannose-protein mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(168901, NULL, 'G3DSA:3.30.160.60:FF:000381', NULL, NULL, 'zinc finger protein 574', NULL, NULL, NULL, NULL, NULL, 4),
(168902, NULL, 'G3DSA:1.10.1520.10:FF:000039', NULL, NULL, '39S ribosomal protein L44, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(168903, NULL, 'G3DSA:3.30.160.60:FF:003477', NULL, NULL, 'FI01424p', NULL, NULL, NULL, NULL, NULL, 4),
(168904, NULL, 'G3DSA:3.40.50.300:FF:007906', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(168905, NULL, 'G3DSA:3.30.160.60:FF:001802', NULL, NULL, 'zinc finger protein 133 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(168906, NULL, 'G3DSA:2.40.50.100:FF:000004', NULL, NULL, '50S ribosomal protein L27', NULL, NULL, NULL, NULL, NULL, 4),
(168907, NULL, 'G3DSA:1.10.287.70:FF:000190', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(168908, NULL, 'G3DSA:1.10.15.40:FF:000004', NULL, NULL, 'Fe-S cluster domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(168909, NULL, 'G3DSA:2.60.40.10:FF:005512', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168910, NULL, 'G3DSA:3.30.70.330:FF:001306', NULL, NULL, 'RE24187p', NULL, NULL, NULL, NULL, NULL, 4),
(168911, NULL, 'G3DSA:1.20.58.60:FF:000625', NULL, NULL, 'Spectrin repeat-containing, nuclear envelope 1b', NULL, NULL, NULL, NULL, NULL, 4),
(168912, NULL, 'G3DSA:1.10.533.10:FF:000194', NULL, NULL, 'Protein MC160', NULL, NULL, NULL, NULL, NULL, 4),
(168913, NULL, 'G3DSA:2.30.30.140:FF:000172', NULL, NULL, 'Maternal protein tudor', NULL, NULL, NULL, NULL, NULL, 4),
(168914, NULL, 'G3DSA:3.90.1290.10:FF:000029', NULL, NULL, 'Dystonin', NULL, NULL, NULL, NULL, NULL, 4),
(168915, NULL, 'G3DSA:3.40.50.2300:FF:000772', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168916, NULL, 'G3DSA:3.30.70.330:FF:000020', NULL, NULL, 'RNA-binding protein Musashi homolog 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(168917, NULL, 'G3DSA:3.30.70.330:FF:001290', NULL, NULL, 'Nucleolin 2', NULL, NULL, NULL, NULL, NULL, 4),
(168918, NULL, 'G3DSA:1.10.510.10:FF:001681', NULL, NULL, 'Putative tyrosine-protein kinase Wsck', NULL, NULL, NULL, NULL, NULL, 4),
(168919, NULL, 'G3DSA:3.80.10.10:FF:003427', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168920, NULL, 'G3DSA:3.30.450.40:FF:000256', NULL, NULL, 'Transcriptional regulator (IclR family)', NULL, NULL, NULL, NULL, NULL, 4),
(168921, NULL, 'G3DSA:3.40.50.1000:FF:000814', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168922, NULL, 'G3DSA:1.25.40.20:FF:000506', NULL, NULL, 'E3 ubiquitin-protein ligase XBAT32', NULL, NULL, NULL, NULL, NULL, 4),
(168923, NULL, 'G3DSA:3.40.50.10480:FF:000010', NULL, NULL, 'Ribosome biogenesis protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(168924, NULL, 'G3DSA:3.30.160.60:FF:004438', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168925, NULL, 'G3DSA:1.20.200.10:FF:000014', NULL, NULL, '3-carboxy-cis,cis-muconate cycloisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(168926, NULL, 'G3DSA:3.40.50.300:FF:004259', NULL, NULL, 'Dicer-like 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(168927, NULL, 'G3DSA:3.10.110.10:FF:000108', NULL, NULL, 'Ubiquitin-conjugating enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(168928, NULL, 'G3DSA:1.25.40.180:FF:000268', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168929, NULL, 'G3DSA:3.30.890.10:FF:000022', NULL, NULL, 'Methyl-CpG-binding domain-containing protein 13', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(168930, NULL, 'G3DSA:1.10.1420.10:FF:000105', NULL, NULL, 'DNA mismatch repair protein Msh2', NULL, NULL, NULL, NULL, NULL, 4),
(168931, NULL, 'G3DSA:3.30.50.10:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168932, NULL, 'G3DSA:3.40.50.300:FF:006171', NULL, NULL, 'Rad3-related DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(168933, NULL, 'G3DSA:3.30.170.10:FF:000001', NULL, NULL, 'Cyclin-dependent kinases regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(168934, NULL, 'G3DSA:3.40.50.2000:FF:000777', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(168935, NULL, 'G3DSA:1.20.120.1750:FF:000120', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(168936, NULL, 'G3DSA:3.40.50.2000:FF:001053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168937, NULL, 'G3DSA:2.60.40.10:FF:002527', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(168938, NULL, 'G3DSA:3.30.420.10:FF:000330', NULL, NULL, 'DNA polymerase III subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(168939, NULL, 'G3DSA:1.20.920.10:FF:000041', NULL, NULL, 'ATP-dependent helicase brm', NULL, NULL, NULL, NULL, NULL, 4),
(168940, NULL, 'G3DSA:1.25.40.570:FF:000059', NULL, NULL, 'COP9 signalosome complex-related / CSN complex-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(168941, NULL, 'G3DSA:1.10.730.10:FF:000040', NULL, NULL, 'Methionyl-tRNA synthetase, cytoplasmic, putative', NULL, NULL, NULL, NULL, NULL, 4),
(168942, NULL, 'G3DSA:1.10.225.10:FF:000034', NULL, NULL, 'sphingomyelin phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(168943, NULL, 'G3DSA:2.60.40.60:FF:000491', NULL, NULL, 'Cadherin 17, LI cadherin (Liver-intestine)', NULL, NULL, NULL, NULL, NULL, 4),
(168944, NULL, 'G3DSA:3.90.660.20:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168945, NULL, 'G3DSA:3.40.50.150:FF:000807', NULL, NULL, 'Protein-lysine N-methyltransferase CBG01728', NULL, NULL, NULL, NULL, NULL, 4),
(168946, NULL, 'G3DSA:3.90.70.10:FF:000249', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(168947, NULL, 'G3DSA:3.30.70.2280:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168948, NULL, 'G3DSA:2.60.98.10:FF:000002', NULL, NULL, 'Structural polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(168949, NULL, 'G3DSA:3.40.50.150:FF:001319', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168950, NULL, 'G3DSA:3.30.1330.10:FF:000002', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(168951, NULL, 'G3DSA:3.40.630.30:FF:000422', NULL, NULL, 'Acetyltransferase, GNAT family protein', NULL, NULL, NULL, NULL, NULL, 4),
(168952, NULL, 'G3DSA:3.30.160.60:FF:006350', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168953, NULL, 'G3DSA:3.80.10.10:FF:002915', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168954, NULL, 'G3DSA:3.40.50.2300:FF:001391', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168955, NULL, 'G3DSA:1.25.40.20:FF:000613', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(168956, NULL, 'G3DSA:1.20.1250.20:FF:002239', NULL, NULL, 'Solute carrier family 37 member 4b', NULL, NULL, NULL, NULL, NULL, 4),
(168957, NULL, 'G3DSA:1.10.1280.10:FF:000009', NULL, NULL, 'Tyrosinase', NULL, NULL, NULL, NULL, NULL, 4),
(168958, NULL, 'G3DSA:3.40.710.10:FF:000142', NULL, NULL, 'Serine hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(168959, NULL, 'G3DSA:3.80.10.10:FF:003534', NULL, NULL, 'AER398Wp', NULL, NULL, NULL, NULL, NULL, 4),
(168960, NULL, 'G3DSA:1.20.1250.20:FF:000789', NULL, NULL, 'Permease, multidrug efflux', NULL, NULL, NULL, NULL, NULL, 4),
(168961, NULL, 'G3DSA:3.30.479.30:FF:000010', NULL, NULL, 'major vault protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(168962, NULL, 'G3DSA:2.10.25.10:FF:001292', NULL, NULL, 'Stabilin 1, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(168963, NULL, 'G3DSA:3.80.10.10:FF:002808', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168964, NULL, 'G3DSA:1.20.1070.10:FF:000339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168965, NULL, 'G3DSA:1.10.3060.10:FF:000015', NULL, NULL, 'Protein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(168966, NULL, 'G3DSA:1.10.10.2740:FF:000001', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(168967, NULL, 'G3DSA:1.10.472.10:FF:000512', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168968, NULL, 'G3DSA:2.10.90.10:FF:000071', NULL, NULL, 'PDGF-and VEGF-related factor 1, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(168969, NULL, 'G3DSA:1.10.510.10:FF:003816', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168970, NULL, 'G3DSA:2.30.29.30:FF:001244', NULL, NULL, 'Ras GTPase-activating protein gap-1', NULL, NULL, NULL, NULL, NULL, 4),
(168971, NULL, 'G3DSA:3.30.559.70:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168972, NULL, 'G3DSA:3.30.720.210:FF:000002', NULL, NULL, 'ATP-dependent zinc metalloprotease FTSH chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(168973, NULL, 'G3DSA:1.10.287.310:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168974, NULL, 'G3DSA:3.90.190.10:FF:000606', NULL, NULL, 'Protein-tyrosine-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(168975, NULL, 'G3DSA:3.80.10.10:FF:004372', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168976, NULL, 'G3DSA:3.20.20.150:FF:000076', NULL, NULL, 'Si:ch211-141o9.10', NULL, NULL, NULL, NULL, NULL, 4),
(168977, NULL, 'G3DSA:3.40.50.150:FF:000465', NULL, NULL, 'Carnosine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(168978, NULL, 'G3DSA:4.10.1060.10:FF:000029', NULL, NULL, 'ubiquitin thioesterase trabid', NULL, NULL, NULL, NULL, NULL, 4),
(168979, NULL, 'G3DSA:3.40.50.300:FF:003298', NULL, NULL, 'ATPase involved in chromosome partitioning', NULL, NULL, NULL, NULL, NULL, 4),
(168980, NULL, 'G3DSA:3.40.50.2020:FF:000098', NULL, NULL, 'Probable PRS4-ribose-phosphate pyrophosphokinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(168981, NULL, 'G3DSA:1.25.40.10:FF:003920', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168982, NULL, 'G3DSA:3.40.390.10:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168983, NULL, 'G3DSA:3.40.1190.20:FF:000165', NULL, NULL, 'ATP-dependent (S)-NAD(P)H-hydrate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(168984, NULL, 'G3DSA:2.70.170.10:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168985, NULL, 'G3DSA:1.10.287.70:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168986, NULL, 'G3DSA:1.10.472.10:FF:000057', NULL, NULL, 'Cyclin N-terminal domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(168987, NULL, 'G3DSA:2.60.40.10:FF:001353', NULL, NULL, 'Sallimus, isoform P', NULL, NULL, NULL, NULL, NULL, 4),
(168988, NULL, 'G3DSA:2.10.25.10:FF:001640', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168989, NULL, 'G3DSA:3.40.190.10:FF:000972', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(168990, NULL, 'G3DSA:2.60.40.150:FF:000294', NULL, NULL, 'Synaptotagmin 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(168991, NULL, 'G3DSA:2.170.300.10:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(168992, NULL, 'G3DSA:3.40.50.150:FF:000358', NULL, NULL, 'Ribosomal RNA-processing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(168993, NULL, 'G3DSA:3.30.365.10:FF:000021', NULL, NULL, 'Carbon monoxide dehydrogenase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(168994, NULL, 'G3DSA:1.20.5.1160:FF:000002', NULL, NULL, 'Type I keratin 10', NULL, NULL, NULL, NULL, NULL, 4),
(168995, NULL, 'G3DSA:2.40.20.10:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(168996, NULL, 'G3DSA:1.10.3200.20:FF:000007', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(168997, NULL, 'G3DSA:1.20.20.10:FF:000001', NULL, NULL, 'ATP synthase subunit c, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(168998, NULL, 'G3DSA:3.30.420.10:FF:000667', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(168999, NULL, 'G3DSA:3.90.70.10:FF:000120', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(169000, NULL, 'G3DSA:1.10.287.2900:FF:000011', NULL, NULL, 'Coiled-coil-helix-coiled-coil-helix domain-containing 4b', NULL, NULL, NULL, NULL, NULL, 4),
(169001, NULL, 'G3DSA:3.40.50.300:FF:000999', NULL, NULL, 'Mov10 like RISC complex RNA helicase 1', NULL, NULL, NULL, NULL, NULL, 4),
(169002, NULL, 'G3DSA:3.90.1150.10:FF:000204', NULL, NULL, 'Hypothetical aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(169003, NULL, 'G3DSA:3.40.50.720:FF:001631', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169004, NULL, 'G3DSA:3.10.490.20:FF:000021', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(169005, NULL, 'G3DSA:1.20.120.900:FF:000004', NULL, NULL, 'Peroxisomal membrane protein receptor Pex19', NULL, NULL, NULL, NULL, NULL, 4),
(169006, NULL, 'G3DSA:2.60.120.290:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169007, NULL, 'G3DSA:1.10.472.10:FF:000164', NULL, NULL, 'CYC2-like cyclin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169008, NULL, 'G3DSA:4.10.110.20:FF:000001', NULL, NULL, 'Variant surface glycoprotein (VSG), putative', NULL, NULL, NULL, NULL, NULL, 4),
(169009, NULL, 'G3DSA:3.20.20.140:FF:000415', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169010, NULL, 'G3DSA:2.130.10.10:FF:001893', NULL, NULL, 'Coronin, actin-binding protein, 1Cb', NULL, NULL, NULL, NULL, NULL, 4),
(169011, NULL, 'G3DSA:3.80.10.10:FF:002466', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(169012, NULL, 'G3DSA:3.60.110.10:FF:000081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169013, NULL, 'G3DSA:2.70.150.10:FF:000129', NULL, NULL, 'Probable cadmium/zinc-transporting ATPase HMA1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(169014, NULL, 'G3DSA:3.30.160.60:FF:004096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169015, NULL, 'G3DSA:1.10.510.10:FF:003255', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169016, NULL, 'G3DSA:3.40.50.300:FF:002461', NULL, NULL, 'GTP-binding protein CIN4', NULL, NULL, NULL, NULL, NULL, 4),
(169017, NULL, 'G3DSA:3.30.505.10:FF:000027', NULL, NULL, 'Cytoplasmic protein nck1', NULL, NULL, NULL, NULL, NULL, 4),
(169018, NULL, 'G3DSA:3.50.50.60:FF:000809', NULL, NULL, 'Putative monooxygenase NMA2164', NULL, NULL, NULL, NULL, NULL, 4),
(169019, NULL, 'G3DSA:1.25.40.20:FF:000490', NULL, NULL, 'ANKS1B isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(169020, NULL, 'G3DSA:1.25.10.10:FF:001064', NULL, NULL, 'Putative gtp binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(169021, NULL, 'G3DSA:2.10.25.10:FF:001185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169022, NULL, 'G3DSA:3.60.20.10:FF:000096', NULL, NULL, 'Ferredoxin-dependent glutamate synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(169023, NULL, 'G3DSA:3.30.830.10:FF:000029', NULL, NULL, 'Presequence protease 1', NULL, NULL, NULL, NULL, NULL, 4),
(169024, NULL, 'G3DSA:2.10.70.10:FF:000199', NULL, NULL, 'Mannan-binding lectin serine peptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(169025, NULL, 'G3DSA:3.30.1150.10:FF:000016', NULL, NULL, 'Energy transducer TonB', NULL, NULL, NULL, NULL, NULL, 4),
(169026, NULL, 'G3DSA:1.25.10.10:FF:001406', NULL, NULL, 'U3 small nucleolar RNA-associated protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(169027, NULL, 'G3DSA:3.20.20.190:FF:000172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169028, NULL, 'G3DSA:3.40.33.10:FF:000149', NULL, NULL, 'Pathogenesis-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(169029, NULL, 'G3DSA:3.40.50.150:FF:001426', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(169030, NULL, 'G3DSA:3.40.50.150:FF:000015', NULL, NULL, 'Protein-L-isoaspartate (D-aspartate) O-methyltransferase domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(169031, NULL, 'G3DSA:3.30.1130.10:FF:000003', NULL, NULL, '7,8-dihydroneopterin aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(169032, NULL, 'G3DSA:3.90.1670.10:FF:000002', NULL, NULL, 'Protein FdhE homolog', NULL, NULL, NULL, NULL, NULL, 4),
(169033, NULL, 'G3DSA:3.30.420.40:FF:000428', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169034, NULL, 'G3DSA:3.10.450.240:FF:000021', NULL, NULL, 'Mitochondrial inner membrane protein Mba1', NULL, NULL, NULL, NULL, NULL, 4),
(169035, NULL, 'G3DSA:2.30.30.770:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169036, NULL, 'G3DSA:3.50.30.30:FF:000018', NULL, NULL, 'E3 ubiquitin-protein ligase ZNRF3', NULL, NULL, NULL, NULL, NULL, 4),
(169037, NULL, 'G3DSA:2.160.10.10:FF:000003', NULL, NULL, 'Acyl-[acyl-carrier-protein]--UDP-N-acetylglucosamine O-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(169038, NULL, 'G3DSA:3.30.160.60:FF:002640', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(169039, NULL, 'G3DSA:3.90.199.10:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169040, NULL, 'G3DSA:2.60.40.10:FF:004096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169041, NULL, 'G3DSA:2.40.50.150:FF:000008', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(169042, NULL, 'G3DSA:3.40.630.30:FF:000203', NULL, NULL, 'N-alpha-acetyltransferase NAT5', NULL, NULL, NULL, NULL, NULL, 4),
(169043, NULL, 'G3DSA:2.20.110.10:FF:000037', NULL, NULL, 'Phosphatidylinositol 4-phosphate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(169044, NULL, 'G3DSA:2.60.120.10:FF:000574', NULL, NULL, 'Bacterial regulatory s, crp family protein', NULL, NULL, NULL, NULL, NULL, 4),
(169045, NULL, 'G3DSA:2.60.40.10:FF:001908', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(169046, NULL, 'G3DSA:2.60.40.1820:FF:000011', NULL, NULL, 'Os01g0624400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(169047, NULL, 'G3DSA:2.70.98.30:FF:000024', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(169048, NULL, 'G3DSA:1.10.10.60:FF:000471', NULL, NULL, 'Homeobox domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(169049, NULL, 'G3DSA:3.50.50.60:FF:000467', NULL, NULL, 'NAD(P)-binding Rossmann-like domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(169050, NULL, 'G3DSA:1.10.8.270:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169051, NULL, 'G3DSA:1.10.1040.10:FF:000008', NULL, NULL, '2-hydroxy-3-oxopropionate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(169052, NULL, 'G3DSA:2.40.160.10:FF:000002', NULL, NULL, 'Outer membrane porin F', NULL, NULL, NULL, NULL, NULL, 4),
(169053, NULL, 'G3DSA:3.40.800.10:FF:000031', NULL, NULL, 'Formimidoylglutamase', NULL, NULL, NULL, NULL, NULL, 4),
(169054, NULL, 'G3DSA:2.30.30.790:FF:000018', NULL, NULL, '39S ribosomal protein L19, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(169055, NULL, 'G3DSA:3.30.930.10:FF:000065', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(169056, NULL, 'G3DSA:3.40.33.10:FF:000019', NULL, NULL, 'Pathogenesis-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(169057, NULL, 'G3DSA:3.20.20.220:FF:000007', NULL, NULL, 'Bifunctional homocysteine S-methyltransferase/methylenetetrahydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(169058, NULL, 'G3DSA:3.30.930.10:FF:000407', NULL, NULL, 'Os04g0398300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(169059, NULL, 'G3DSA:1.25.40.20:FF:001799', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169060, NULL, 'G3DSA:3.40.50.150:FF:001769', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169061, NULL, 'G3DSA:1.10.3080.10:FF:000028', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(169062, NULL, 'G3DSA:3.50.50.60:FF:001428', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(169063, NULL, 'G3DSA:3.30.160.60:FF:005057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169064, NULL, 'G3DSA:2.40.30.10:FF:000274', NULL, NULL, 'Adenylyl-sulfate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(169065, NULL, 'G3DSA:3.90.190.10:FF:000270', NULL, NULL, 'Protein-tyrosine-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(169066, NULL, 'G3DSA:2.60.40.10:FF:004444', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169067, NULL, 'G3DSA:1.20.5.340:FF:000039', NULL, NULL, 'Nance-Horan syndrome protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(169068, NULL, 'G3DSA:2.130.10.10:FF:005153', NULL, NULL, 'Wd-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169069, NULL, 'G3DSA:3.30.70.330:FF:002599', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169070, NULL, 'G3DSA:3.30.70.330:FF:001413', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169071, NULL, 'G3DSA:1.10.290.10:FF:000011', NULL, NULL, 'DNA topoisomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(169072, NULL, 'G3DSA:1.10.3430.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169073, NULL, 'G3DSA:2.20.25.420:FF:000001', NULL, NULL, 'Zinc finger protein ZPR1', NULL, NULL, NULL, NULL, NULL, 4),
(169074, NULL, 'G3DSA:1.25.10.10:FF:001749', NULL, NULL, 'Importin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169075, NULL, 'G3DSA:2.60.40.10:FF:005950', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169076, NULL, 'G3DSA:1.20.120.1080:FF:000003', NULL, NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase PRP43', NULL, NULL, NULL, NULL, NULL, 4),
(169077, NULL, 'G3DSA:3.90.1150.10:FF:000199', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169078, NULL, 'G3DSA:1.10.238.200:FF:000017', NULL, NULL, 'DCN1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(169079, NULL, 'G3DSA:1.20.1740.10:FF:000071', NULL, NULL, 'Amino acid permease', NULL, NULL, NULL, NULL, NULL, 4),
(169080, NULL, 'G3DSA:3.40.50.720:FF:001850', NULL, NULL, 'Putative malate dehydrogenase 1B', NULL, NULL, NULL, NULL, NULL, 4),
(169081, NULL, 'G3DSA:3.30.60.20:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169082, NULL, 'G3DSA:1.25.40.120:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169083, NULL, 'G3DSA:2.60.40.10:FF:000734', NULL, NULL, 'plexin-B1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(169084, NULL, 'G3DSA:3.40.30.10:FF:000671', NULL, NULL, 'Pyruvate decarboxylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(169085, NULL, 'G3DSA:2.30.30.30:FF:000022', NULL, NULL, '60S ribosomal protein L14', NULL, NULL, NULL, NULL, NULL, 4),
(169086, NULL, 'G3DSA:3.30.70.330:FF:000924', NULL, NULL, 'RNA-binding protein CP33, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(169087, NULL, 'G3DSA:1.20.58.60:FF:000732', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169088, NULL, 'G3DSA:3.40.50.1000:FF:000028', NULL, NULL, 'Calcium-transporting P-type ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169089, NULL, 'G3DSA:4.10.410.10:FF:000049', NULL, NULL, 'Protein CBR-MEC-1', NULL, NULL, NULL, NULL, NULL, 4),
(169090, NULL, 'G3DSA:2.20.25.10:FF:000038', NULL, NULL, 'DNA-directed RNA polymerase 30 kDa polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(169091, NULL, 'G3DSA:3.80.10.10:FF:002247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169092, NULL, 'G3DSA:2.60.120.290:FF:000199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169093, NULL, 'G3DSA:3.90.1200.10:FF:000086', NULL, NULL, 'Protein-ribulosamine 3-kinase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(169094, NULL, 'G3DSA:2.60.120.650:FF:000104', NULL, NULL, 'Lysine-specific demethylase 4B', NULL, NULL, NULL, NULL, NULL, 4),
(169095, NULL, 'G3DSA:2.130.10.10:FF:001443', NULL, NULL, 'WD domain, G-beta repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(169096, NULL, 'G3DSA:3.30.420.40:FF:000215', NULL, NULL, 'Actin-related protein RO7, putative', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(169097, NULL, 'G3DSA:3.20.20.70:FF:000424', NULL, NULL, 'Inosine-5''-monophosphate dehydrogenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(169098, NULL, 'G3DSA:3.40.930.10:FF:000029', NULL, NULL, 'PTS system fructose-specific IIA component', NULL, NULL, NULL, NULL, NULL, 4),
(169099, NULL, 'G3DSA:3.10.100.10:FF:000153', NULL, NULL, 'Mannose receptor, C type 1a', NULL, NULL, NULL, NULL, NULL, 4),
(169100, NULL, 'G3DSA:1.25.10.10:FF:002025', NULL, NULL, 'Armadillo repeat-containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(169101, NULL, 'G3DSA:2.60.120.10:FF:000118', NULL, NULL, 'cAMP-dependent protein kinase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(169102, NULL, 'G3DSA:3.30.450.20:FF:000380', NULL, NULL, 'PAS/PAC sensor-containing diguanylate cyclase/phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(169103, NULL, 'G3DSA:2.70.170.10:FF:000024', NULL, NULL, 'Histamine-gated chloride channel subunit', NULL, NULL, NULL, NULL, NULL, 4),
(169104, NULL, 'G3DSA:3.30.360.10:FF:000049', NULL, NULL, 'Aspartate-semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(169105, NULL, 'G3DSA:3.30.565.10:FF:000238', NULL, NULL, 'Response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(169106, NULL, 'G3DSA:2.60.40.10:FF:004551', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169107, NULL, 'G3DSA:3.40.50.2000:FF:000671', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169108, NULL, 'G3DSA:2.130.10.10:FF:002966', NULL, NULL, 'Ribosome biogenesis protein NSA1', NULL, NULL, NULL, NULL, NULL, 4),
(169109, NULL, 'G3DSA:1.10.472.80:FF:000145', NULL, NULL, 'AGAP002392-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(169110, NULL, 'G3DSA:3.70.10.10:FF:000078', NULL, NULL, 'Cell cycle checkpoint protein RAD1', NULL, NULL, NULL, NULL, NULL, 4),
(169111, NULL, 'G3DSA:3.30.40.10:FF:001094', NULL, NULL, 'Similar to PHD finger domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(169112, NULL, 'G3DSA:3.30.230.10:FF:000388', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(169113, NULL, 'G3DSA:1.20.1560.10:FF:000085', NULL, NULL, 'Probable ATP-binding cassette (ABC) transporter', NULL, NULL, NULL, NULL, NULL, 4),
(169114, NULL, 'G3DSA:1.10.150.20:FF:000296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169115, NULL, 'G3DSA:2.130.10.10:FF:005714', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169116, NULL, 'G3DSA:3.20.20.80:FF:000197', NULL, NULL, 'Alpha-amylase', NULL, NULL, NULL, NULL, NULL, 4),
(169117, NULL, 'G3DSA:3.30.460.10:FF:000214', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(169118, NULL, 'G3DSA:3.30.300.10:FF:000040', NULL, NULL, 'Os07g0477250 protein', NULL, NULL, NULL, NULL, NULL, 4),
(169119, NULL, 'G3DSA:3.30.160.60:FF:001908', NULL, NULL, 'Zinc finger protein 425', NULL, NULL, NULL, NULL, NULL, 4),
(169120, NULL, 'G3DSA:3.40.50.150:FF:001870', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169121, NULL, 'G3DSA:1.10.287.130:FF:000168', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(169122, NULL, 'G3DSA:1.10.1900.10:FF:000024', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169123, NULL, 'G3DSA:3.40.50.1000:FF:000360', NULL, NULL, 'Trehalose 6-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(169124, NULL, 'G3DSA:3.10.100.10:FF:000389', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169125, NULL, 'G3DSA:1.10.287.110:FF:000180', NULL, NULL, 'WGS project CABT00000000 data, contig 2.6', NULL, NULL, NULL, NULL, NULL, 4),
(169126, NULL, 'G3DSA:3.30.70.330:FF:001762', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169127, NULL, 'G3DSA:1.10.630.10:FF:000436', NULL, NULL, 'Ferulate-5-hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(169128, NULL, 'G3DSA:3.30.200.20:FF:002019', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(169129, NULL, 'G3DSA:1.10.8.60:FF:000279', NULL, NULL, 'Replication factor C small subunit', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(169130, NULL, 'G3DSA:1.20.120.720:FF:000040', NULL, NULL, 'myosin-IB isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(169131, NULL, 'G3DSA:2.60.120.590:FF:000064', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169132, NULL, 'G3DSA:2.60.120.290:FF:000075', NULL, NULL, 'Blast:Cubilin', NULL, NULL, NULL, NULL, NULL, 4),
(169133, NULL, 'G3DSA:3.40.50.1450:FF:000016', NULL, NULL, 'Ni,Fe-hydrogenase maturation factor', NULL, NULL, NULL, NULL, NULL, 4),
(169134, NULL, 'G3DSA:3.40.50.720:FF:001406', NULL, NULL, 'NmrA-like family protein', NULL, NULL, NULL, NULL, NULL, 4),
(169135, NULL, 'G3DSA:3.90.70.10:FF:000137', NULL, NULL, 'Putative ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(169136, NULL, 'G3DSA:3.40.640.10:FF:000041', NULL, NULL, 'Adenosylmethionine-8-amino-7-oxononanoate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(169137, NULL, 'G3DSA:1.25.40.10:FF:000722', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g49740', NULL, NULL, NULL, NULL, NULL, 4),
(169138, NULL, 'G3DSA:3.40.50.2300:FF:001261', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169139, NULL, 'G3DSA:1.20.1420.30:FF:000030', NULL, NULL, 'Cation/calcium exchanger 4', NULL, NULL, NULL, NULL, NULL, 4),
(169140, NULL, 'G3DSA:3.40.50.10810:FF:000047', NULL, NULL, 'DEAD/DEAH box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(169141, NULL, 'G3DSA:1.20.120.670:FF:000002', NULL, NULL, 'GD22403', NULL, NULL, NULL, NULL, NULL, 4),
(169142, NULL, 'G3DSA:1.50.40.10:FF:000422', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169143, NULL, 'G3DSA:1.10.510.10:FF:001911', NULL, NULL, 'Myosin light chain kinase', NULL, NULL, NULL, NULL, NULL, 4),
(169144, NULL, 'G3DSA:3.40.50.300:FF:008076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169145, NULL, 'G3DSA:3.30.70.330:FF:000126', NULL, NULL, 'paraspeckle component 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(169146, NULL, 'G3DSA:3.30.450.40:FF:000150', NULL, NULL, 'Hybrid sensory kinase', NULL, NULL, NULL, NULL, NULL, 4),
(169147, NULL, 'G3DSA:1.10.565.10:FF:000200', NULL, NULL, 'Retinoic X receptor alpha', NULL, NULL, NULL, NULL, NULL, 4),
(169148, NULL, 'G3DSA:2.60.40.10:FF:001791', NULL, NULL, 'Ig gamma-2B chain C region', NULL, NULL, NULL, NULL, NULL, 4),
(169149, NULL, 'G3DSA:3.30.1380.20:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169150, NULL, 'G3DSA:2.60.40.690:FF:000006', NULL, NULL, 'Alpha-2-macroglobulin like 1', NULL, NULL, NULL, NULL, NULL, 4),
(169151, NULL, 'G3DSA:3.40.50.300:FF:001729', NULL, NULL, 'Transcriptional regulator ATRX homolog', NULL, NULL, NULL, NULL, NULL, 4),
(169152, NULL, 'G3DSA:2.30.30.140:FF:000060', NULL, NULL, 'Scm-like with four mbt domains 1, isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(169153, NULL, 'G3DSA:3.60.15.10:FF:000258', NULL, NULL, 'Cleavage and polyadenylation specific factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(169154, NULL, 'G3DSA:1.10.1040.30:FF:000003', NULL, NULL, 'ISWI chromatin-remodeling complex ATPase ISW2', NULL, NULL, NULL, NULL, NULL, 4),
(169155, NULL, 'G3DSA:3.40.50.1760:FF:000008', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(169156, NULL, 'G3DSA:3.40.190.80:FF:000043', NULL, NULL, 'Inositol polyphosphate 1-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(169157, NULL, 'G3DSA:1.10.565.10:FF:000088', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(169158, NULL, 'G3DSA:2.60.40.10:FF:003932', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169159, NULL, 'G3DSA:1.10.630.10:FF:000329', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169160, NULL, 'G3DSA:1.25.10.10:FF:001619', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(169161, NULL, 'G3DSA:1.20.58.930:FF:000002', NULL, NULL, 'Biosynthetic arginine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(169162, NULL, 'G3DSA:2.40.50.100:FF:000134', NULL, NULL, 'EXOSome (Multiexonuclease complex) component', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(169163, NULL, 'G3DSA:3.60.21.10:FF:000188', NULL, NULL, 'Metallophosphoesterase', NULL, NULL, NULL, NULL, NULL, 4),
(169164, NULL, 'G3DSA:1.20.5.170:FF:000078', NULL, NULL, 'Methylmalonic aciduria type A homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(169165, NULL, 'G3DSA:3.40.50.620:FF:000527', NULL, NULL, 'Nicotinamide-nucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(169166, NULL, 'G3DSA:3.30.450.20:FF:000609', NULL, NULL, 'Sensor histidine kinase, Cache_1 and HAMP domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(169167, NULL, 'G3DSA:4.10.1000.10:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169168, NULL, 'G3DSA:3.30.70.330:FF:001649', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169169, NULL, 'G3DSA:2.60.40.10:FF:001459', NULL, NULL, 'Titin a', NULL, NULL, NULL, NULL, NULL, 4),
(169170, NULL, 'G3DSA:1.10.420.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169171, NULL, 'G3DSA:3.40.50.300:FF:001836', NULL, NULL, 'DEAD box helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169172, NULL, 'G3DSA:3.90.740.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169173, NULL, 'G3DSA:3.40.50.2300:FF:000547', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(169174, NULL, 'G3DSA:3.30.2310.10:FF:000006', NULL, NULL, 'tRNA-Thr(GGU) m(6)t(6)A37 methyltransferase TsaA', NULL, NULL, NULL, NULL, NULL, 4),
(169175, NULL, 'G3DSA:3.30.40.10:FF:000475', NULL, NULL, 'RING-H2 finger protein ATL3', NULL, NULL, NULL, NULL, NULL, 4),
(169176, NULL, 'G3DSA:1.25.40.10:FF:004320', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g61370, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(169177, NULL, 'G3DSA:3.60.10.10:FF:000382', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169178, NULL, 'G3DSA:3.10.580.10:FF:000019', NULL, NULL, 'Chloride voltage-gated channel 2', NULL, NULL, NULL, NULL, NULL, 4),
(169179, NULL, 'G3DSA:3.20.20.70:FF:000099', NULL, NULL, 'tRNA-dihydrouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(169180, NULL, 'G3DSA:3.40.30.10:FF:000783', NULL, NULL, '1,2-dihydroxy-3-keto-5-methylthiopentene dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(169181, NULL, 'G3DSA:2.120.10.30:FF:000117', NULL, NULL, 'AGAP007095-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(169182, NULL, 'G3DSA:2.60.40.10:FF:005748', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169183, NULL, 'G3DSA:2.30.29.30:FF:000176', NULL, NULL, 'ras-specific guanine nucleotide-releasing factor 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(169184, NULL, 'G3DSA:2.60.200.20:FF:000280', NULL, NULL, 'Serine/threonine-protein kinase cds1', NULL, NULL, NULL, NULL, NULL, 4),
(169185, NULL, 'G3DSA:2.60.40.150:FF:000081', NULL, NULL, 'otoferlin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(169186, NULL, 'G3DSA:3.30.160.60:FF:002527', NULL, NULL, 'Zinc finger protein 772', NULL, NULL, NULL, NULL, NULL, 4),
(169187, NULL, 'G3DSA:1.25.40.10:FF:002066', NULL, NULL, 'GM12478', NULL, NULL, NULL, NULL, NULL, 4),
(169188, NULL, 'G3DSA:3.30.70.1230:FF:000274', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169189, NULL, 'G3DSA:1.20.1740.10:FF:000183', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169190, NULL, 'G3DSA:3.40.47.10:FF:000198', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169191, NULL, 'G3DSA:3.30.300.30:FF:000046', NULL, NULL, 'Long-chain-fatty-acid--ACP ligase MbtM', NULL, NULL, NULL, NULL, NULL, 4),
(169192, NULL, 'G3DSA:3.40.50.300:FF:006732', NULL, NULL, 'Os07g0226000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(169193, NULL, 'G3DSA:2.60.40.10:FF:000280', NULL, NULL, 'HLA class II histocompatibility antigen, DR alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(169194, NULL, 'G3DSA:1.10.10.10:FF:000372', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(169195, NULL, 'G3DSA:2.40.50.140:FF:001079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(169196, NULL, 'G3DSA:3.40.630.30:FF:000439', NULL, NULL, 'Acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(169197, NULL, 'G3DSA:1.20.1440.160:FF:000002', NULL, NULL, 'Tumor necrosis factor, alpha-induced protein 8-like protein 2 A', NULL, NULL, NULL, NULL, NULL, 4),
(169198, NULL, 'G3DSA:3.40.50.300:FF:000313', NULL, NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase PRP16', NULL, NULL, NULL, NULL, NULL, 4),
(169199, NULL, 'G3DSA:3.40.630.10:FF:000433', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169200, NULL, 'G3DSA:3.90.550.10:FF:000472', NULL, NULL, 'Glycosyltransferase HpnI', NULL, NULL, NULL, NULL, NULL, 4),
(169201, NULL, 'G3DSA:3.30.230.70:FF:000035', NULL, NULL, 'Exosome complex component MTR3', NULL, NULL, NULL, NULL, NULL, 4),
(169202, NULL, 'G3DSA:2.130.10.10:FF:002062', NULL, NULL, 'WD repeat and SOF domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(169203, NULL, 'G3DSA:3.30.470.10:FF:000041', NULL, NULL, 'Branched-chain amino acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(169204, NULL, 'G3DSA:3.10.20.90:FF:000408', NULL, NULL, 'Small ubiquitin protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169205, NULL, 'G3DSA:3.30.160.60:FF:005506', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169206, NULL, 'G3DSA:2.30.30.30:FF:000134', NULL, NULL, 'Transcription elongation factor SPT5', NULL, NULL, NULL, NULL, NULL, 4),
(169207, NULL, 'G3DSA:1.10.10.60:FF:000920', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169208, NULL, 'G3DSA:3.20.20.80:FF:000208', NULL, NULL, 'Glycosyl hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(169209, NULL, 'G3DSA:4.10.60.10:FF:000020', NULL, NULL, 'Zinc finger CCHC domain-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(169210, NULL, 'G3DSA:2.130.10.10:FF:004203', NULL, NULL, 'Nucleoporin 133', NULL, NULL, NULL, NULL, NULL, 4),
(169211, NULL, 'G3DSA:3.40.50.300:FF:004602', NULL, NULL, 'Dynein heavy chain, cytosolic, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169212, NULL, 'G3DSA:3.40.250.10:FF:000230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169213, NULL, 'G3DSA:2.40.50.1060:FF:000007', NULL, NULL, 'GD22536', NULL, NULL, NULL, NULL, NULL, 4),
(169214, NULL, 'G3DSA:2.130.10.10:FF:000931', NULL, NULL, 'WD repeat-containing protein 66', NULL, NULL, NULL, NULL, NULL, 4),
(169215, NULL, 'G3DSA:2.30.29.30:FF:001013', NULL, NULL, 'FERM domain-containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(169216, NULL, 'G3DSA:3.30.70.1820:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169217, NULL, 'G3DSA:3.40.50.1460:FF:000132', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169218, NULL, 'G3DSA:1.25.40.10:FF:003471', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(169219, NULL, 'G3DSA:2.130.10.10:FF:001550', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(169220, NULL, 'G3DSA:3.30.420.40:FF:000322', NULL, NULL, 'probable tRNA N6-adenosine threonylcarbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(169221, NULL, 'G3DSA:3.40.1090.10:FF:000008', NULL, NULL, 'Phospholipase, patatin family', NULL, NULL, NULL, NULL, NULL, 4),
(169222, NULL, 'G3DSA:1.10.560.10:FF:000116', NULL, NULL, 'Putative GroEL-like chaperonine protein', NULL, NULL, NULL, NULL, NULL, 4),
(169223, NULL, 'G3DSA:2.30.29.30:FF:000283', NULL, NULL, 'Ras GTPase-activating protein 4 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(169224, NULL, 'G3DSA:1.10.10.10:FF:001676', NULL, NULL, 'Helix-turn-helix iron-sulfur cluster-binding transcriptional regulator IscR', NULL, NULL, NULL, NULL, NULL, 4),
(169225, NULL, 'G3DSA:1.25.10.10:FF:003082', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169226, NULL, 'G3DSA:1.20.58.60:FF:000283', NULL, NULL, 'Dystrophin', NULL, NULL, NULL, NULL, NULL, 4),
(169227, NULL, 'G3DSA:3.30.40.10:FF:001998', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(169228, NULL, 'G3DSA:2.10.25.10:FF:000673', NULL, NULL, 'Heart development protein with EGF like domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(169229, NULL, 'G3DSA:1.10.620.20:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169230, NULL, 'G3DSA:2.40.10.10:FF:000508', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169231, NULL, 'G3DSA:3.30.200.20:FF:002351', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169232, NULL, 'G3DSA:3.40.20.10:FF:000046', NULL, NULL, 'Cofilin/actin-depolymerizing factor like 1', NULL, NULL, NULL, NULL, NULL, 4),
(169233, NULL, 'G3DSA:3.40.50.300:FF:005327', NULL, NULL, 'Nucleoid maintenance ATPase YjeE', NULL, NULL, NULL, NULL, NULL, 4),
(169234, NULL, 'G3DSA:3.10.110.10:FF:000092', NULL, NULL, 'Constitutive photomorphogenesis protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(169235, NULL, 'G3DSA:4.10.240.10:FF:000114', NULL, NULL, 'Transcription factor Upc2', NULL, NULL, NULL, NULL, NULL, 4),
(169236, NULL, 'G3DSA:3.40.50.720:FF:000883', NULL, NULL, '4-phosphoerythronate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(169237, NULL, 'G3DSA:3.40.630.30:FF:000315', NULL, NULL, 'Acetyltransferase, GNAT family protein', NULL, NULL, NULL, NULL, NULL, 4),
(169238, NULL, 'G3DSA:3.30.70.330:FF:001981', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169239, NULL, 'G3DSA:1.20.1310.20:FF:000047', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(169240, NULL, 'G3DSA:2.60.40.10:FF:002314', NULL, NULL, 'Immunoglobulin kappa variable 5-2', NULL, NULL, NULL, NULL, NULL, 4),
(169241, NULL, 'G3DSA:1.20.1110.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169242, NULL, 'G3DSA:2.130.10.10:FF:005945', NULL, NULL, 'Sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(169243, NULL, 'G3DSA:3.20.20.80:FF:000540', NULL, NULL, 'Putative catalytically inactive chitinase-like lectins', NULL, NULL, NULL, NULL, NULL, 4),
(169244, NULL, 'G3DSA:2.60.40.1430:FF:000001', NULL, NULL, 'Thiol-activated cytolysin', NULL, NULL, NULL, NULL, NULL, 4),
(169245, NULL, 'G3DSA:3.40.50.1000:FF:000253', NULL, NULL, 'TIGR01456 family HAD hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(169246, NULL, 'G3DSA:3.30.160.20:FF:000054', NULL, NULL, 'Chromosome 12 open reading frame 65', NULL, NULL, NULL, NULL, NULL, 4),
(169247, NULL, 'G3DSA:3.30.70.260:FF:000077', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(169248, NULL, 'G3DSA:3.40.50.150:FF:001538', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169249, NULL, 'G3DSA:3.30.70.600:FF:000005', NULL, NULL, '28S ribosomal protein S10, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(169250, NULL, 'G3DSA:1.10.510.10:FF:002530', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169251, NULL, 'G3DSA:3.40.50.720:FF:001395', NULL, NULL, 'Erythronate-4-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(169252, NULL, 'G3DSA:3.40.50.1010:FF:000019', NULL, NULL, 'U3 small nucleolar RNA-associated protein 24', NULL, NULL, NULL, NULL, NULL, 4),
(169253, NULL, 'G3DSA:2.30.30.40:FF:000250', NULL, NULL, 'Dynamin associated protein isoform Dap160-2', NULL, NULL, NULL, NULL, NULL, 4),
(169254, NULL, 'G3DSA:3.30.160.60:FF:004888', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169255, NULL, 'G3DSA:1.20.272.10:FF:000023', NULL, NULL, 'Replication factor C subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(169256, NULL, 'G3DSA:1.20.58.2220:FF:000017', NULL, NULL, 'Formin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(169257, NULL, 'G3DSA:3.10.490.10:FF:000030', NULL, NULL, 'putative gamma-glutamylcyclotransferase CG2811', NULL, NULL, NULL, NULL, NULL, 4),
(169258, NULL, 'G3DSA:2.60.120.10:FF:000343', NULL, NULL, 'HSPB1-associated protein 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(169259, NULL, 'G3DSA:1.10.10.60:FF:001207', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169260, NULL, 'G3DSA:1.10.3210.10:FF:000067', NULL, NULL, 'HD domain protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(169261, NULL, 'G3DSA:2.60.60.20:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169262, NULL, 'G3DSA:1.20.1050.10:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169263, NULL, 'G3DSA:2.60.120.330:FF:000020', NULL, NULL, 'Lipid A hydroxylase LpxO', NULL, NULL, NULL, NULL, NULL, 4),
(169264, NULL, 'G3DSA:1.10.510.10:FF:000512', NULL, NULL, 'AKT serine/threonine kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(169265, NULL, 'G3DSA:3.40.190.290:FF:000008', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(169266, NULL, 'G3DSA:4.10.400.10:FF:000099', NULL, NULL, 'Complement component C7', NULL, NULL, NULL, NULL, NULL, 4),
(169267, NULL, 'G3DSA:3.40.50.10810:FF:000154', NULL, NULL, 'SNF2 histone linker PHD RING helicase', NULL, NULL, NULL, NULL, NULL, 4),
(169268, NULL, 'G3DSA:3.90.550.50:FF:000130', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(169269, NULL, 'G3DSA:3.40.50.300:FF:002680', NULL, NULL, 'Peroxisomal ABC transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(169270, NULL, 'G3DSA:1.20.1070.10:FF:000345', NULL, NULL, '40S ribosomal protein S27', NULL, NULL, NULL, NULL, NULL, 4),
(169271, NULL, 'G3DSA:3.30.70.330:FF:000233', NULL, NULL, 'Zinc finger CCHC-type and RNA-binding motif-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(169272, NULL, 'G3DSA:3.30.450.30:FF:000034', NULL, NULL, 'Profilin', NULL, NULL, NULL, NULL, NULL, 4),
(169273, NULL, 'G3DSA:1.10.132.30:FF:000009', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(169274, NULL, 'G3DSA:1.10.10.440:FF:000036', NULL, NULL, 'Pre-mRNA-processing factor 40', NULL, NULL, NULL, NULL, NULL, 4),
(169275, NULL, 'G3DSA:1.10.260.100:FF:000022', NULL, NULL, 'Heat shock protein STI1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169276, NULL, 'G3DSA:1.25.10.10:FF:002463', NULL, NULL, 'AP-5 complex subunit beta-1', NULL, NULL, NULL, NULL, NULL, 4),
(169277, NULL, 'G3DSA:3.90.1520.10:FF:000014', NULL, NULL, 'Guanylate cyclase soluble subunit beta-1', NULL, NULL, NULL, NULL, NULL, 4),
(169278, NULL, 'G3DSA:1.10.3500.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169279, NULL, 'G3DSA:2.20.70.10:FF:000114', NULL, NULL, 'Transcription elongation regulator', NULL, NULL, NULL, NULL, NULL, 4),
(169280, NULL, 'G3DSA:2.30.42.10:FF:000482', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169281, NULL, 'G3DSA:2.60.40.1860:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169282, NULL, 'G3DSA:3.20.10.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169283, NULL, 'G3DSA:1.25.10.10:FF:000097', NULL, NULL, 'Serine/threonine-protein phosphatase 4 regulatory subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(169284, NULL, 'G3DSA:3.60.21.10:FF:000300', NULL, NULL, 'UDP-2,3-diacylglucosamine pyrophosphatase LpxH', NULL, NULL, NULL, NULL, NULL, 4),
(169285, NULL, 'G3DSA:2.60.120.260:FF:000549', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169286, NULL, 'G3DSA:2.60.40.10:FF:001802', NULL, NULL, 'Myotactin form A', NULL, NULL, NULL, NULL, NULL, 4),
(169287, NULL, 'G3DSA:1.25.10.10:FF:001856', NULL, NULL, 'Hypothetical nuclear condensin complex subunit 3 (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(169288, NULL, 'G3DSA:1.10.10.10:FF:000260', NULL, NULL, 'Forkhead transcription factor (Sep1)', NULL, NULL, NULL, NULL, NULL, 4),
(169289, NULL, 'G3DSA:1.25.40.10:FF:001447', NULL, NULL, 'general transcription factor 3C polypeptide 3', NULL, NULL, NULL, NULL, NULL, 4),
(169290, NULL, 'G3DSA:3.40.50.2000:FF:000339', NULL, NULL, 'Glycogen synthase', NULL, NULL, NULL, NULL, NULL, 4),
(169291, NULL, 'G3DSA:3.90.1300.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169292, NULL, 'G3DSA:2.60.120.370:FF:000003', NULL, NULL, 'Uncharacterized protein, YhcH/YjgK/YiaL family', NULL, NULL, NULL, NULL, NULL, 4),
(169293, NULL, 'G3DSA:2.130.10.10:FF:005821', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(169294, NULL, 'G3DSA:3.40.50.150:FF:000246', NULL, NULL, 'Methyltransferase protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(169295, NULL, 'G3DSA:1.10.510.10:FF:003946', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169296, NULL, 'G3DSA:1.10.20.10:FF:000086', NULL, NULL, 'Histone H2A', NULL, NULL, NULL, NULL, NULL, 4),
(169297, NULL, 'G3DSA:3.40.50.10130:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169298, NULL, 'G3DSA:3.40.50.300:FF:007351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169299, NULL, 'G3DSA:1.20.1070.10:FF:000906', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169300, NULL, 'G3DSA:3.40.30.10:FF:000564', NULL, NULL, 'Glutathione S-transferase mu 1', NULL, NULL, NULL, NULL, NULL, 4),
(169301, NULL, 'G3DSA:3.30.70.1130:FF:000007', NULL, NULL, 'Eukaryotic translation initiation factor 2 alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(169302, NULL, 'G3DSA:1.10.246.10:FF:000015', NULL, NULL, 'Serum albumin 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(169303, NULL, 'G3DSA:2.60.120.430:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169304, NULL, 'G3DSA:1.25.40.10:FF:003595', NULL, NULL, 'Formate-dependent nitrite reductase complex bifunctional subunit NrfFG', NULL, NULL, NULL, NULL, NULL, 4),
(169305, NULL, 'G3DSA:1.10.8.60:FF:000155', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(169306, NULL, 'G3DSA:3.30.930.10:FF:000290', NULL, NULL, 'Leucyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(169307, NULL, 'G3DSA:1.10.540.10:FF:000103', NULL, NULL, 'Acyl-CoA dehydrogenase, short-chain specific', NULL, NULL, NULL, NULL, NULL, 4),
(169308, NULL, 'G3DSA:1.10.418.60:FF:000003', NULL, NULL, 'Probable kinetochore protein nuf2', NULL, NULL, NULL, NULL, NULL, 4),
(169309, NULL, 'G3DSA:3.30.160.60:FF:006125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169310, NULL, 'G3DSA:3.80.10.10:FF:002354', NULL, NULL, 'Leucine-rich repeat-containing 8 VRAC subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(169311, NULL, 'G3DSA:3.60.21.10:FF:000424', NULL, NULL, 'Uncharacterized protein C1020.05', NULL, NULL, NULL, NULL, NULL, 4),
(169312, NULL, 'G3DSA:1.10.238.10:FF:000137', NULL, NULL, 'Calmodulin-like protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(169313, NULL, 'G3DSA:2.40.50.1020:FF:000006', NULL, NULL, 'Sensory transduction protein LytR', NULL, NULL, NULL, NULL, NULL, 4),
(169314, NULL, 'G3DSA:3.30.9.10:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169315, NULL, 'G3DSA:3.40.50.620:FF:000746', NULL, NULL, 'Electron transferring flavoprotein, beta polypeptide-like', NULL, NULL, NULL, NULL, NULL, 4),
(169316, NULL, 'G3DSA:3.30.160.60:FF:003584', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169317, NULL, 'G3DSA:3.30.200.20:FF:001637', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169318, NULL, 'G3DSA:1.10.10.60:FF:000027', NULL, NULL, 'LIM/homeobox protein Lhx9', NULL, NULL, NULL, NULL, NULL, 4),
(169319, NULL, 'G3DSA:3.30.70.340:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169320, NULL, 'G3DSA:1.10.260.170:FF:000003', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', NULL, NULL, NULL, NULL, NULL, 4),
(169321, NULL, 'G3DSA:3.30.40.10:FF:000694', NULL, NULL, 'Putative lysine-specific histone demethylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(169322, NULL, 'G3DSA:1.25.40.20:FF:001782', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169323, NULL, 'G3DSA:1.25.40.420:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169324, NULL, 'G3DSA:3.30.160.60:FF:004202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169325, NULL, 'G3DSA:3.30.40.10:FF:001312', NULL, NULL, 'RING finger protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(169326, NULL, 'G3DSA:3.30.160.60:FF:001454', NULL, NULL, 'C2H2 finger domain protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(169327, NULL, 'G3DSA:1.10.287.110:FF:000286', NULL, NULL, 'DnaJ-like protein subfamily A member 2', NULL, NULL, NULL, NULL, NULL, 4),
(169328, NULL, 'G3DSA:3.40.50.300:FF:008312', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(169329, NULL, 'G3DSA:2.20.25.80:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169330, NULL, 'G3DSA:3.30.70.980:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169331, NULL, 'G3DSA:2.130.10.10:FF:005260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169332, NULL, 'G3DSA:3.20.20.380:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169333, NULL, 'G3DSA:3.90.550.50:FF:000017', NULL, NULL, 'Glycoprotein-N-acetylgalactosamine 3-beta-galactosyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(169334, NULL, 'G3DSA:2.130.10.10:FF:003348', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169335, NULL, 'G3DSA:3.40.50.11840:FF:000007', NULL, NULL, 'Diphthamide biosynthesis protein 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169336, NULL, 'G3DSA:3.90.70.10:FF:000013', NULL, NULL, 'ubiquitin carboxyl-terminal hydrolase 15 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(169337, NULL, 'G3DSA:1.25.40.10:FF:005051', NULL, NULL, 'LP07472p', NULL, NULL, NULL, NULL, NULL, 4),
(169338, NULL, 'G3DSA:3.40.50.880:FF:000009', NULL, NULL, 'Imidazole glycerol phosphate synthase subunit HisH', NULL, NULL, NULL, NULL, NULL, 4),
(169339, NULL, 'G3DSA:3.40.630.30:FF:000658', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169340, NULL, 'G3DSA:3.40.50.1000:FF:000472', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169341, NULL, 'G3DSA:1.10.510.10:FF:002187', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase EFR', NULL, NULL, NULL, NULL, NULL, 4),
(169342, NULL, 'G3DSA:3.40.50.300:FF:003747', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169343, NULL, 'G3DSA:1.25.40.10:FF:003139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169344, NULL, 'G3DSA:3.90.640.10:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169345, NULL, 'G3DSA:2.130.10.10:FF:005602', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(169346, NULL, 'G3DSA:3.80.10.10:FF:001050', NULL, NULL, 'Probable disease resistance protein At5g66900', NULL, NULL, NULL, NULL, NULL, 4),
(169347, NULL, 'G3DSA:2.60.40.10:FF:002191', NULL, NULL, 'Trehalose-phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169348, NULL, 'G3DSA:2.70.130.10:FF:000134', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169349, NULL, 'G3DSA:3.40.50.150:FF:000122', NULL, NULL, 'probable methyltransferase PMT2', NULL, NULL, NULL, NULL, NULL, 4),
(169350, NULL, 'G3DSA:1.25.40.570:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169351, NULL, 'G3DSA:3.30.200.20:FF:000114', NULL, NULL, 'serine/threonine-protein kinase OSR1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(169352, NULL, 'G3DSA:1.50.10.10:FF:000033', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(169353, NULL, 'G3DSA:3.90.950.10:FF:000002', NULL, NULL, 'Inosine/xanthosine triphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(169354, NULL, 'G3DSA:2.60.40.10:FF:003039', NULL, NULL, 'Embigin', NULL, NULL, NULL, NULL, NULL, 4),
(169355, NULL, 'G3DSA:3.30.70.100:FF:000170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169356, NULL, 'G3DSA:3.40.1160.10:FF:000003', NULL, NULL, 'Glutamate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(169357, NULL, 'G3DSA:1.20.1250.10:FF:000095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169358, NULL, 'G3DSA:2.60.40.630:FF:000016', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(169359, NULL, 'G3DSA:3.30.565.10:FF:000132', NULL, NULL, 'GHKL domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(169360, NULL, 'G3DSA:3.40.50.300:FF:004023', NULL, NULL, 'Os02g0780800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(169361, NULL, 'G3DSA:3.30.980.50:FF:000001', NULL, NULL, 'Microbial collagenase', NULL, NULL, NULL, NULL, NULL, 4),
(169362, NULL, 'G3DSA:1.20.5.650:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169363, NULL, 'G3DSA:3.80.10.10:FF:000774', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(169364, NULL, 'G3DSA:1.10.10.10:FF:001097', NULL, NULL, 'Helix-turn-helix transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(169365, NULL, 'G3DSA:1.25.40.10:FF:004775', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169366, NULL, 'G3DSA:1.10.1420.10:FF:000094', NULL, NULL, 'DNA mismatch repair protein MSH2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169367, NULL, 'G3DSA:3.40.50.1820:FF:000616', NULL, NULL, 'Putative peptidase S9 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(169368, NULL, 'G3DSA:2.130.10.10:FF:000370', NULL, NULL, 'Kinesin family member 21A', NULL, NULL, NULL, NULL, NULL, 4),
(169369, NULL, 'G3DSA:1.20.5.530:FF:000001', NULL, NULL, 'Serine/threonine-protein kinase pelle', NULL, NULL, NULL, NULL, NULL, 4),
(169370, NULL, 'G3DSA:3.50.30.30:FF:000125', NULL, NULL, 'Transferrin receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(169371, NULL, 'G3DSA:3.10.129.10:FF:000022', NULL, NULL, 'Phenylacetic acid degradation protein', NULL, NULL, NULL, NULL, NULL, 4),
(169372, NULL, 'G3DSA:3.40.850.10:FF:000539', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169373, NULL, 'G3DSA:3.40.50.80:FF:000198', NULL, NULL, 'FRE family ferric-chelate reductase, putative (AFU_orthologue AFUA_1G17270)', NULL, NULL, NULL, NULL, NULL, 4),
(169374, NULL, 'G3DSA:1.25.40.10:FF:001684', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(169375, NULL, 'G3DSA:1.25.40.10:FF:004090', NULL, NULL, 'Signal recognition particle subunit SRP72', NULL, NULL, NULL, NULL, NULL, 4),
(169376, NULL, 'G3DSA:2.60.40.10:FF:004332', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169377, NULL, 'G3DSA:3.40.50.300:FF:004708', NULL, NULL, '26S protease regulatory subunit 6B', NULL, NULL, NULL, NULL, NULL, 4),
(169378, NULL, 'G3DSA:3.40.1010.10:FF:000015', NULL, NULL, 'Probable uroporphyrin-III c-methyltransferase hemD', NULL, NULL, NULL, NULL, NULL, 4),
(169379, NULL, 'G3DSA:1.20.1440.130:FF:000004', NULL, NULL, 'Thiol-disulfide oxidoreductase LTO1', NULL, NULL, NULL, NULL, NULL, 4),
(169380, NULL, 'G3DSA:1.20.1070.10:FF:001183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169381, NULL, 'G3DSA:1.20.1250.20:FF:000553', NULL, NULL, 'Organic cation transporter protein', NULL, NULL, NULL, NULL, NULL, 4),
(169382, NULL, 'G3DSA:2.40.50.100:FF:000010', NULL, NULL, 'Acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(169383, NULL, 'G3DSA:1.10.287.70:FF:000644', NULL, NULL, 'Protein CBR-TWK-49', NULL, NULL, NULL, NULL, NULL, 4),
(169384, NULL, 'G3DSA:3.30.200.20:FF:000676', NULL, NULL, 'Choline kinase', NULL, NULL, NULL, NULL, NULL, 4),
(169385, NULL, 'G3DSA:2.130.10.10:FF:000038', NULL, NULL, 'Lissencephaly-1 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(169386, NULL, 'G3DSA:2.130.10.10:FF:004309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169387, NULL, 'G3DSA:1.10.287.2250:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169388, NULL, 'G3DSA:3.30.160.60:FF:000835', NULL, NULL, 'Zinc finger and BTB domain-containing protein 49', NULL, NULL, NULL, NULL, NULL, 4),
(169389, NULL, 'G3DSA:3.40.50.1820:FF:000274', NULL, NULL, 'Aminopeptidase C', NULL, NULL, NULL, NULL, NULL, 4),
(169390, NULL, 'G3DSA:2.60.40.420:FF:000178', NULL, NULL, 'Multicopper oxidase, manganese oxidase family', NULL, NULL, NULL, NULL, NULL, 4),
(169391, NULL, 'G3DSA:1.10.390.10:FF:000052', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(169392, NULL, 'G3DSA:3.40.50.1100:FF:000277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169393, NULL, 'G3DSA:3.50.50.60:FF:000012', NULL, NULL, 'Thioredoxin reductase 1, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(169394, NULL, 'G3DSA:1.10.510.10:FF:003148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169395, NULL, 'G3DSA:3.90.640.90:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169396, NULL, 'G3DSA:3.10.20.870:FF:000007', NULL, NULL, 'WD_domain', NULL, NULL, NULL, NULL, NULL, 4),
(169397, NULL, 'G3DSA:3.10.250.10:FF:000034', NULL, NULL, 'Hepsin', NULL, NULL, NULL, NULL, NULL, 4),
(169398, NULL, 'G3DSA:1.20.58.670:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169399, NULL, 'G3DSA:1.20.5.500:FF:000003', NULL, NULL, 'ATPase inhibitor B, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(169400, NULL, 'G3DSA:2.60.40.200:FF:000005', NULL, NULL, 'Superoxide dismutase [Cu-Zn]', NULL, NULL, NULL, NULL, NULL, 4),
(169401, NULL, 'G3DSA:1.20.58.1120:FF:000007', NULL, NULL, 'Dynein heavy chain 4', NULL, NULL, NULL, NULL, NULL, 4),
(169402, NULL, 'G3DSA:2.40.50.140:FF:000679', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169403, NULL, 'G3DSA:2.130.10.10:FF:004641', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169404, NULL, 'G3DSA:1.10.10.60:FF:001196', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169405, NULL, 'G3DSA:2.170.260.10:FF:000029', NULL, NULL, 'Dicer-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169406, NULL, 'G3DSA:1.20.58.60:FF:000844', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169407, NULL, 'G3DSA:3.80.10.10:FF:000336', NULL, NULL, 'Si:dkey-222h21.2', NULL, NULL, NULL, NULL, NULL, 4),
(169408, NULL, 'G3DSA:3.30.420.340:FF:000001', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4),
(169409, NULL, 'G3DSA:3.90.1150.10:FF:000311', NULL, NULL, 'Tryptophan aminotransferase-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(169410, NULL, 'G3DSA:3.90.79.10:FF:000005', NULL, NULL, 'Cleavage and polyadenylation specificity factor subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(169411, NULL, 'G3DSA:3.80.10.10:FF:002011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169412, NULL, 'G3DSA:3.30.160.60:FF:000493', NULL, NULL, 'Zinc finger protein 805', NULL, NULL, NULL, NULL, NULL, 4),
(169413, NULL, 'G3DSA:1.20.1250.20:FF:001733', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169414, NULL, 'G3DSA:2.60.40.10:FF:005169', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169415, NULL, 'G3DSA:1.20.58.240:FF:000003', NULL, NULL, 'Si:dkey-183c6.8', NULL, NULL, NULL, NULL, NULL, 4),
(169416, NULL, 'G3DSA:1.10.287.130:FF:000062', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(169417, NULL, 'G3DSA:1.10.10.10:FF:002058', NULL, NULL, 'Transcriptional regulator (PhoB-like)', NULL, NULL, NULL, NULL, NULL, 4),
(169418, NULL, 'G3DSA:1.10.238.10:FF:001317', NULL, NULL, 'YALI0D26147p', NULL, NULL, NULL, NULL, NULL, 4),
(169419, NULL, 'G3DSA:3.30.710.10:FF:000318', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169420, NULL, 'G3DSA:2.60.120.200:FF:000666', NULL, NULL, 'Os04g0531400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(169421, NULL, 'G3DSA:1.10.150.240:FF:000101', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(169422, NULL, 'G3DSA:2.30.39.10:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169423, NULL, 'G3DSA:3.50.50.60:FF:000916', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169424, NULL, 'G3DSA:1.25.10.10:FF:001513', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169425, NULL, 'G3DSA:3.30.190.20:FF:000005', NULL, NULL, 'Ribosomal L1 domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(169426, NULL, 'G3DSA:3.10.110.10:FF:000215', NULL, NULL, 'Ubiquitin-fold modifier-conjugating enzyme 1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(169427, NULL, 'G3DSA:3.30.540.10:FF:000035', NULL, NULL, 'Golgi-resident PAp (PAP) 3-Phosphatase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(169428, NULL, 'G3DSA:1.20.58.1100:FF:000001', NULL, NULL, 'Protein unc-13 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(169429, NULL, 'G3DSA:1.20.1050.20:FF:000004', NULL, NULL, 'Signal transducer and transcription activator 6', NULL, NULL, NULL, NULL, NULL, 4),
(169430, NULL, 'G3DSA:1.10.30.10:FF:000148', NULL, NULL, 'HMG box family protein', NULL, NULL, NULL, NULL, NULL, 4),
(169431, NULL, 'G3DSA:3.20.20.190:FF:000060', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(169432, NULL, 'G3DSA:3.40.50.980:FF:000040', NULL, NULL, 'AMP-binding enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169433, NULL, 'G3DSA:1.10.287.370:FF:000004', NULL, NULL, 'Probable prefoldin subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(169434, NULL, 'G3DSA:3.40.190.10:FF:000404', NULL, NULL, 'Nitrate ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(169435, NULL, 'G3DSA:3.40.50.1820:FF:000835', NULL, NULL, 'GPI inositol-deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(169436, NULL, 'G3DSA:1.20.58.60:FF:000389', NULL, NULL, 'Microtubule-actin crosslinking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(169437, NULL, 'G3DSA:1.10.510.10:FF:003709', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169438, NULL, 'G3DSA:3.60.130.10:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169439, NULL, 'G3DSA:2.70.98.20:FF:000033', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(169440, NULL, 'G3DSA:3.40.50.11660:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169441, NULL, 'G3DSA:3.40.50.1820:FF:001235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169442, NULL, 'G3DSA:1.10.510.10:FF:003367', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169443, NULL, 'G3DSA:1.10.490.20:FF:000001', NULL, NULL, 'Allophycocyanin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(169444, NULL, 'G3DSA:2.130.10.10:FF:003680', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169445, NULL, 'G3DSA:1.20.1250.20:FF:001172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169446, NULL, 'G3DSA:3.40.50.20:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169447, NULL, 'G3DSA:2.60.40.60:FF:000608', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169448, NULL, 'G3DSA:1.25.10.10:FF:000552', NULL, NULL, 'USO1p protein', NULL, NULL, NULL, NULL, NULL, 4),
(169449, NULL, 'G3DSA:3.40.140.10:FF:000002', NULL, NULL, 'Pre-mRNA-processing-splicing factor 8', NULL, NULL, NULL, NULL, NULL, 4),
(169450, NULL, 'G3DSA:3.40.50.1820:FF:000959', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169451, NULL, 'G3DSA:1.20.5.110:FF:000212', NULL, NULL, 'Syntaxin-21', NULL, NULL, NULL, NULL, NULL, 4),
(169452, NULL, 'G3DSA:3.90.260.10:FF:000039', NULL, NULL, 'Cdc-73', NULL, NULL, NULL, NULL, NULL, 4),
(169453, NULL, 'G3DSA:2.30.40.10:FF:000078', NULL, NULL, 'Non-ATP-dependent L-selective hydantoinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169454, NULL, 'G3DSA:3.50.50.60:FF:000231', NULL, NULL, 'Cholesterol oxidase ChoD', NULL, NULL, NULL, NULL, NULL, 4),
(169455, NULL, 'G3DSA:2.40.20.10:FF:000009', NULL, NULL, 'Hepatocyte growth factor-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(169456, NULL, 'G3DSA:3.40.50.1820:FF:001111', NULL, NULL, 'Putative secreted tripeptidyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(169457, NULL, 'G3DSA:3.10.20.90:FF:000066', NULL, NULL, 'Talin 1', NULL, NULL, NULL, NULL, NULL, 4),
(169458, NULL, 'G3DSA:3.10.50.40:FF:000137', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(169459, NULL, 'G3DSA:2.60.34.10:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169460, NULL, 'G3DSA:2.160.10.10:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(169461, NULL, 'G3DSA:2.70.50.80:FF:000002', NULL, NULL, 'transcriptional enhancer factor TEF-4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(169462, NULL, 'G3DSA:3.40.50.720:FF:000102', NULL, NULL, 'GDP-mannose 4,6-dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(169463, NULL, 'G3DSA:3.40.630.30:FF:000097', NULL, NULL, 'Histone acetyltransferase HPA2 and related acetyltransferases', NULL, NULL, NULL, NULL, NULL, 4),
(169464, NULL, 'G3DSA:1.20.1250.20:FF:000772', NULL, NULL, 'Multidrug efflux transporter MdtP', NULL, NULL, NULL, NULL, NULL, 4),
(169465, NULL, 'G3DSA:2.40.50.1040:FF:000001', NULL, NULL, 'Stn1p', NULL, NULL, NULL, NULL, NULL, 4),
(169466, NULL, 'G3DSA:3.40.50.2300:FF:000204', NULL, NULL, 'glutamate receptor ionotropic, NMDA 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(169467, NULL, 'G3DSA:2.130.10.10:FF:004080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169468, NULL, 'G3DSA:2.30.30.190:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169469, NULL, 'G3DSA:3.10.290.10:FF:000031', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(169470, NULL, 'G3DSA:3.40.605.10:FF:000015', NULL, NULL, 'alpha-aminoadipic semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(169471, NULL, 'G3DSA:3.90.25.10:FF:000049', NULL, NULL, 'UDP-galactose 4-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(169472, NULL, 'G3DSA:2.30.42.10:FF:000588', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169473, NULL, 'G3DSA:3.30.160.60:FF:001111', NULL, NULL, 'Zinc finger protein 92 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(169474, NULL, 'G3DSA:3.50.7.10:FF:000022', NULL, NULL, 'T-complex protein 1 alpha subunit putative', NULL, NULL, NULL, NULL, NULL, 4),
(169475, NULL, 'G3DSA:3.90.70.10:FF:000356', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(169476, NULL, 'G3DSA:2.130.10.10:FF:002168', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169477, NULL, 'G3DSA:4.10.400.10:FF:000335', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169478, NULL, 'G3DSA:1.25.40.330:FF:000010', NULL, NULL, 'Adenylyl cyclase-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(169479, NULL, 'G3DSA:2.40.100.10:FF:000004', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(169480, NULL, 'G3DSA:3.30.1110.10:FF:000002', NULL, NULL, 'Putative sugar kinase slr0537', NULL, NULL, NULL, NULL, NULL, 4),
(169481, NULL, 'G3DSA:1.25.40.10:FF:001341', NULL, NULL, 'Heat shock protein STI1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169482, NULL, 'G3DSA:1.10.8.270:FF:000032', NULL, NULL, 'GTPase activating protein (Gyp7)', NULL, NULL, NULL, NULL, NULL, 4),
(169483, NULL, 'G3DSA:3.40.50.12780:FF:000166', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(169484, NULL, 'G3DSA:3.30.160.60:FF:004545', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169485, NULL, 'G3DSA:3.30.200.20:FF:000333', NULL, NULL, 'Serine/threonine-protein kinase AGC1-5', NULL, NULL, NULL, NULL, NULL, 4),
(169486, NULL, 'G3DSA:3.30.1520.10:FF:000157', NULL, NULL, 'Sorting nexin-4', NULL, NULL, NULL, NULL, NULL, 4),
(169487, NULL, 'G3DSA:1.20.1270.10:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169488, NULL, 'G3DSA:1.20.1250.20:FF:000896', NULL, NULL, 'Amino acid/peptide transporter', NULL, NULL, NULL, NULL, NULL, 4),
(169489, NULL, 'G3DSA:3.40.630.10:FF:000091', NULL, NULL, 'Hippurate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(169490, NULL, 'G3DSA:2.40.170.20:FF:000051', NULL, NULL, 'SusC/RagA family TonB-linked outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(169491, NULL, 'G3DSA:1.20.1600.10:FF:000021', NULL, NULL, 'Membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(169492, NULL, 'G3DSA:1.25.10.10:FF:000333', NULL, NULL, 'Nipped-B protein', NULL, NULL, NULL, NULL, NULL, 4),
(169493, NULL, 'G3DSA:1.10.1200.270:FF:000025', NULL, NULL, 'Os06g0243400 protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(169494, NULL, 'G3DSA:3.40.50.300:FF:007457', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169495, NULL, 'G3DSA:1.25.40.10:FF:001902', NULL, NULL, 'Exomer complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(169496, NULL, 'G3DSA:3.30.40.10:FF:001655', NULL, NULL, 'Checkpoint with forkhead and ring finger domains, E3 ubiquitin protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(169497, NULL, 'G3DSA:3.80.10.10:FF:004484', NULL, NULL, 'Os01g0957100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(169498, NULL, 'G3DSA:1.10.418.30:FF:000005', NULL, NULL, 'LD33040p', NULL, NULL, NULL, NULL, NULL, 4),
(169499, NULL, 'G3DSA:1.25.40.20:FF:001563', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(169500, NULL, 'G3DSA:3.40.50.150:FF:000701', NULL, NULL, 'Methyltransferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(169501, NULL, 'G3DSA:3.30.720.90:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169502, NULL, 'G3DSA:2.60.40.60:FF:000047', NULL, NULL, 'protocadherin-15 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(169503, NULL, 'G3DSA:1.10.510.10:FF:000950', NULL, NULL, 'Inactive receptor-like serine/threonine-protein kinase At2g40270', NULL, NULL, NULL, NULL, NULL, 4),
(169504, NULL, 'G3DSA:1.10.506.10:FF:000058', NULL, NULL, 'Ras GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(169505, NULL, 'G3DSA:1.10.1200.120:FF:000008', NULL, NULL, 'Mechanosensitive ion channel protein MscL', NULL, NULL, NULL, NULL, NULL, 4),
(169506, NULL, 'G3DSA:1.10.238.10:FF:000356', NULL, NULL, 'Myosin II light chain', NULL, NULL, NULL, NULL, NULL, 4),
(169507, NULL, 'G3DSA:1.20.1730.10:FF:000025', NULL, NULL, 'High-affinity choline transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(169508, NULL, 'G3DSA:1.10.472.10:FF:000400', NULL, NULL, 'Cyclin-K', NULL, NULL, NULL, NULL, NULL, 4),
(169509, NULL, 'G3DSA:1.25.40.10:FF:002302', NULL, NULL, 'LD39177p', NULL, NULL, NULL, NULL, NULL, 4),
(169510, NULL, 'G3DSA:1.10.132.60:FF:000007', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(169511, NULL, 'G3DSA:3.40.50.620:FF:000185', NULL, NULL, 'nicotinamide mononucleotide adenylyltransferase 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(169512, NULL, 'G3DSA:3.40.50.200:FF:000053', NULL, NULL, 'Subtilisin-like serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(169513, NULL, 'G3DSA:1.25.40.10:FF:001009', NULL, NULL, 'Chitin biosynthesis protein CHS6', NULL, NULL, NULL, NULL, NULL, 4),
(169514, NULL, 'G3DSA:3.40.50.10420:FF:000020', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(169515, NULL, 'G3DSA:2.60.120.780:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169516, NULL, 'G3DSA:3.40.605.10:FF:000139', NULL, NULL, 'Aldehyde dehydrogenase 4 family member A1', NULL, NULL, NULL, NULL, NULL, 4),
(169517, NULL, 'G3DSA:3.90.550.10:FF:000253', NULL, NULL, 'Capsule polysaccharide synthase Cps1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169518, NULL, 'G3DSA:3.40.120.10:FF:000018', NULL, NULL, 'Glucose 1,6-bisphosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(169519, NULL, 'G3DSA:1.20.120.350:FF:000255', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169520, NULL, 'G3DSA:1.10.510.10:FF:004328', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169521, NULL, 'G3DSA:3.40.1190.20:FF:000053', NULL, NULL, 'Ribokinase', NULL, NULL, NULL, NULL, NULL, 4),
(169522, NULL, 'G3DSA:3.40.50.300:FF:003186', NULL, NULL, 'Helicase SEN1', NULL, NULL, NULL, NULL, NULL, 4),
(169523, NULL, 'G3DSA:3.30.572.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169524, NULL, 'G3DSA:3.30.160.60:FF:000274', NULL, NULL, 'zinc finger protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(169525, NULL, 'G3DSA:3.90.79.10:FF:000224', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169526, NULL, 'G3DSA:1.20.120.350:FF:000131', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(169527, NULL, 'G3DSA:2.30.30.40:FF:000356', NULL, NULL, 'Cell death abnormality protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(169528, NULL, 'G3DSA:3.30.450.60:FF:000032', NULL, NULL, 'AP complex subunit sigma', NULL, NULL, NULL, NULL, NULL, 4),
(169529, NULL, 'G3DSA:3.10.20.90:FF:000627', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169530, NULL, 'G3DSA:1.10.287.70:FF:000083', NULL, NULL, 'Potassium/sodium hyperpolarization-activated cyclic nucleotide-gated channel', NULL, NULL, NULL, NULL, NULL, 4),
(169531, NULL, 'G3DSA:2.40.30.180:FF:000007', NULL, NULL, 'Putative ubiquitin-activating enzyme e1', NULL, NULL, NULL, NULL, NULL, 4),
(169532, NULL, 'G3DSA:3.10.450.580:FF:000005', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(169533, NULL, 'G3DSA:4.10.280.10:FF:000111', NULL, NULL, 'HLH transcription factor (Hpa3)', NULL, NULL, NULL, NULL, NULL, 4),
(169534, NULL, 'G3DSA:3.90.1750.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169535, NULL, 'G3DSA:1.10.10.10:FF:001439', NULL, NULL, 'DtxR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(169536, NULL, 'G3DSA:2.40.30.130:FF:000021', NULL, NULL, 'Alanyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169537, NULL, 'G3DSA:2.30.180.10:FF:000157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169538, NULL, 'G3DSA:2.60.40.10:FF:002078', NULL, NULL, 'Juxtamembrane domain-associated catenin', NULL, NULL, NULL, NULL, NULL, 4),
(169539, NULL, 'G3DSA:2.70.130.10:FF:000010', NULL, NULL, 'Insulin-like growth factor 2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(169540, NULL, 'G3DSA:2.40.70.10:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169541, NULL, 'G3DSA:3.30.160.60:FF:000150', NULL, NULL, 'Mds1 and evi1 complex locus protein', NULL, NULL, NULL, NULL, NULL, 4),
(169542, NULL, 'G3DSA:2.60.40.60:FF:000940', NULL, NULL, 'Protocadherin alpha 11', NULL, NULL, NULL, NULL, NULL, 4),
(169543, NULL, 'G3DSA:1.10.510.10:FF:000057', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(169544, NULL, 'G3DSA:3.90.1480.20:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169545, NULL, 'G3DSA:3.40.570.10:FF:000046', NULL, NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(169546, NULL, 'G3DSA:3.30.230.10:FF:000169', NULL, NULL, 'SSU ribosomal protein S9P/S16', NULL, NULL, NULL, NULL, NULL, 4),
(169547, NULL, 'G3DSA:3.30.70.270:FF:000193', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169548, NULL, 'G3DSA:1.20.1250.20:FF:001514', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169549, NULL, 'G3DSA:2.60.40.10:FF:003371', NULL, NULL, 'Synaptogenesis protein syg-2', NULL, NULL, NULL, NULL, NULL, 4),
(169550, NULL, 'G3DSA:2.10.25.10:FF:000235', NULL, NULL, 'Prostaglandin G/H synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(169551, NULL, 'G3DSA:4.10.860.120:FF:000010', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(169552, NULL, 'G3DSA:3.30.70.260:FF:000173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169553, NULL, 'G3DSA:3.30.559.30:FF:000073', NULL, NULL, 'Nonribosomal peptide synthase Pes1 (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(169554, NULL, 'G3DSA:1.20.1730.10:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169555, NULL, 'G3DSA:1.10.8.770:FF:000002', NULL, NULL, 'C-1-tetrahydrofolate synthase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(169556, NULL, 'G3DSA:3.30.70.1230:FF:000077', NULL, NULL, 'Adenylyl CYclase', NULL, NULL, NULL, NULL, NULL, 4),
(169557, NULL, 'G3DSA:1.25.10.10:FF:000400', NULL, NULL, '20S cyclosome subunit (APC1/BimE), putative', NULL, NULL, NULL, NULL, NULL, 4),
(169558, NULL, 'G3DSA:1.20.1560.10:FF:000955', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(169559, NULL, 'G3DSA:3.40.1110.10:FF:000135', NULL, NULL, 'Copper-transporting ATPase HMA5', NULL, NULL, NULL, NULL, NULL, 4),
(169560, NULL, 'G3DSA:3.30.40.10:FF:001436', NULL, NULL, 'TNF receptor-associated factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(169561, NULL, 'G3DSA:2.40.30.20:FF:000030', NULL, NULL, 'Yellow fluorescent protein', NULL, NULL, NULL, NULL, NULL, 4),
(169562, NULL, 'G3DSA:2.10.25.10:FF:000229', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(169563, NULL, 'G3DSA:2.40.50.140:FF:000230', NULL, NULL, '3''-5'' exoribonuclease YhaM', NULL, NULL, NULL, NULL, NULL, 4),
(169564, NULL, 'G3DSA:1.20.900.10:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169565, NULL, 'G3DSA:3.30.70.330:FF:001470', NULL, NULL, 'RNA-binding protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(169566, NULL, 'G3DSA:3.40.50.2300:FF:001446', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169567, NULL, 'G3DSA:3.30.710.10:FF:000195', NULL, NULL, 'Hypothetical_protein', NULL, NULL, NULL, NULL, NULL, 4),
(169568, NULL, 'G3DSA:3.40.30.10:FF:001210', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(169569, NULL, 'G3DSA:3.65.10.10:FF:000023', NULL, NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(169570, NULL, 'G3DSA:2.120.10.80:FF:000222', NULL, NULL, 'Kelch domain-containing protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(169571, NULL, 'G3DSA:3.90.190.10:FF:000247', NULL, NULL, 'Tyrosine specific protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169572, NULL, 'G3DSA:2.130.10.10:FF:001095', NULL, NULL, 'Ribosome biogenesis protein YTM1', NULL, NULL, NULL, NULL, NULL, 4),
(169573, NULL, 'G3DSA:3.40.50.300:FF:008424', NULL, NULL, 'EG:33C11.2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(169574, NULL, 'G3DSA:3.30.500.10:FF:000010', NULL, NULL, 'Histocompatibility 2, T region locus 22', NULL, NULL, NULL, NULL, NULL, 4),
(169575, NULL, 'G3DSA:3.10.20.90:FF:000324', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(169576, NULL, 'G3DSA:3.30.200.20:FF:001749', NULL, NULL, 'Putative serine/threonine protein kinase IREH1', NULL, NULL, NULL, NULL, NULL, 4),
(169577, NULL, 'G3DSA:2.60.40.10:FF:005299', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169578, NULL, 'G3DSA:4.10.160.10:FF:000001', NULL, NULL, 'Methanol dehydrogenase [cytochrome c] subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(169579, NULL, 'G3DSA:1.25.40.10:FF:005219', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169580, NULL, 'G3DSA:3.40.190.10:FF:000798', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(169581, NULL, 'G3DSA:3.30.160.60:FF:000105', NULL, NULL, 'B-cell CLL/lymphoma 6, member B', NULL, NULL, NULL, NULL, NULL, 4),
(169582, NULL, 'G3DSA:1.10.20.120:FF:000015', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(169583, NULL, 'G3DSA:2.130.10.10:FF:002084', NULL, NULL, 'Nan1p', NULL, NULL, NULL, NULL, NULL, 4),
(169584, NULL, 'G3DSA:3.65.10.20:FF:000026', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169585, NULL, 'G3DSA:1.25.10.10:FF:001974', NULL, NULL, 'Similarity to HELICASE MOT1', NULL, NULL, NULL, NULL, NULL, 4),
(169586, NULL, 'G3DSA:1.10.10.250:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169587, NULL, 'G3DSA:2.10.70.10:FF:000244', NULL, NULL, 'Complement factor B', NULL, NULL, NULL, NULL, NULL, 4),
(169588, NULL, 'G3DSA:1.25.40.10:FF:003128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169589, NULL, 'G3DSA:1.10.238.200:FF:000023', NULL, NULL, 'DCN1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(169590, NULL, 'G3DSA:1.20.1740.10:FF:000048', NULL, NULL, 'Fructoselysine transporter frlA', NULL, NULL, NULL, NULL, NULL, 4),
(169591, NULL, 'G3DSA:2.70.130.10:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169592, NULL, 'G3DSA:3.30.70.1400:FF:000004', NULL, NULL, 'Sarcosine dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(169593, NULL, 'G3DSA:4.10.1240.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169594, NULL, 'G3DSA:1.25.40.10:FF:001476', NULL, NULL, 'Os12g0557800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(169595, NULL, 'G3DSA:1.10.10.10:FF:000720', NULL, NULL, 'Two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(169596, NULL, 'G3DSA:3.40.50.300:FF:006333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169597, NULL, 'G3DSA:1.25.40.10:FF:004117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169598, NULL, 'G3DSA:3.30.420.40:FF:000344', NULL, NULL, 'Conserved hypothetical proline rich protein', NULL, NULL, NULL, NULL, NULL, 4),
(169599, NULL, 'G3DSA:3.30.70.270:FF:000176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169600, NULL, 'G3DSA:3.40.50.2000:FF:000957', NULL, NULL, 'Lipid-A-disaccharide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(169601, NULL, 'G3DSA:1.10.730.10:FF:000202', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(169602, NULL, 'G3DSA:2.60.40.10:FF:005506', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169603, NULL, 'G3DSA:3.40.50.1100:FF:000171', NULL, NULL, 'Threonine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(169604, NULL, 'G3DSA:3.30.160.60:FF:003657', NULL, NULL, 'transcription factor grauzone', NULL, NULL, NULL, NULL, NULL, 4),
(169605, NULL, 'G3DSA:2.60.200.30:FF:000035', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(169606, NULL, 'G3DSA:1.25.40.10:FF:003454', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(169607, NULL, 'G3DSA:3.40.50.200:FF:000143', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169608, NULL, 'G3DSA:3.40.33.10:FF:000048', NULL, NULL, 'AGAP007584-PA', NULL, NULL, NULL, NULL, NULL, 4),
(169609, NULL, 'G3DSA:3.40.930.10:FF:000035', NULL, NULL, 'Anion exchange protein', NULL, NULL, NULL, NULL, NULL, 4),
(169610, NULL, 'G3DSA:3.30.230.10:FF:000259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169611, NULL, 'G3DSA:3.40.630.30:FF:000681', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169612, NULL, 'G3DSA:3.30.9.10:FF:000155', NULL, NULL, 'FAD-dependent oxidoreductase domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(169613, NULL, 'G3DSA:3.10.580.10:FF:000059', NULL, NULL, 'mRNA, clone: RTFL01-01-J02', NULL, NULL, NULL, NULL, NULL, 4),
(169614, NULL, 'G3DSA:1.20.140.40:FF:000080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169615, NULL, 'G3DSA:1.20.1560.10:FF:000276', NULL, NULL, 'Multidrug ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(169616, NULL, 'G3DSA:3.30.40.10:FF:000773', NULL, NULL, 'FYVE and coiled-coil domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(169617, NULL, 'G3DSA:2.60.120.10:FF:000315', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169618, NULL, 'G3DSA:1.10.3520.10:FF:000017', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169619, NULL, 'G3DSA:1.10.10.10:FF:000074', NULL, NULL, 'Arginine repressor', NULL, NULL, NULL, NULL, NULL, 4),
(169620, NULL, 'G3DSA:3.90.930.12:FF:000003', NULL, NULL, '60S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(169621, NULL, 'G3DSA:3.30.160.60:FF:005748', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169622, NULL, 'G3DSA:4.10.240.10:FF:000148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169623, NULL, 'G3DSA:1.20.1110.10:FF:000017', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(169624, NULL, 'G3DSA:1.25.40.990:FF:000011', NULL, NULL, 'COP9 signalosome complex subunit 8-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(169625, NULL, 'G3DSA:3.30.160.60:FF:002229', NULL, NULL, 'IKAROS family zinc finger 3', NULL, NULL, NULL, NULL, NULL, 4),
(169626, NULL, 'G3DSA:1.10.510.10:FF:003710', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(169627, NULL, 'G3DSA:2.60.40.1180:FF:000061', NULL, NULL, 'Alpha-1,4-glucan:maltose-1-phosphate maltosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(169628, NULL, 'G3DSA:3.30.420.40:FF:000018', NULL, NULL, 'Actin-like protein (Centractin)', NULL, NULL, NULL, NULL, NULL, 4),
(169629, NULL, 'G3DSA:1.20.1070.10:FF:000901', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169630, NULL, 'G3DSA:3.40.50.2000:FF:001093', NULL, NULL, 'Starch synthase, chloroplastic/amyloplastic', NULL, NULL, NULL, NULL, NULL, 4),
(169631, NULL, 'G3DSA:3.40.50.1440:FF:000103', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(169632, NULL, 'G3DSA:3.40.50.620:FF:000179', NULL, NULL, '7-cyano-7-deazaguanine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(169633, NULL, 'G3DSA:3.40.50.300:FF:007435', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169634, NULL, 'G3DSA:3.90.550.50:FF:000135', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(169635, NULL, 'G3DSA:1.25.40.120:FF:000037', NULL, NULL, 'Protein farnesyltransferase alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169636, NULL, 'G3DSA:3.40.50.1460:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169637, NULL, 'G3DSA:3.40.1110.10:FF:000461', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169638, NULL, 'G3DSA:3.40.630.150:FF:000028', NULL, NULL, 'Malonyl-CoA decarboxylase, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169639, NULL, 'G3DSA:3.10.20.90:FF:000650', NULL, NULL, 'Autophagy-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(169640, NULL, 'G3DSA:2.60.40.10:FF:002752', NULL, NULL, 'CD3 glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(169641, NULL, 'G3DSA:2.40.50.100:FF:000212', NULL, NULL, 'sn-glycerol-3-phosphate import ATP-binding protein UgpC', NULL, NULL, NULL, NULL, NULL, 4),
(169642, NULL, 'G3DSA:1.10.260.40:FF:000046', NULL, NULL, 'Cyanate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(169643, NULL, 'G3DSA:1.10.287.370:FF:000049', NULL, NULL, 'Protein CBG01589', NULL, NULL, NULL, NULL, NULL, 4),
(169644, NULL, 'G3DSA:3.40.50.10580:FF:000006', NULL, NULL, 'V-type proton ATPase subunit F', NULL, NULL, NULL, NULL, NULL, 4),
(169645, NULL, 'G3DSA:1.10.510.10:FF:001765', NULL, NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 168', NULL, NULL, NULL, NULL, NULL, 4),
(169646, NULL, 'G3DSA:1.20.5.170:FF:000067', NULL, NULL, 'BZIP transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(169647, NULL, 'G3DSA:3.40.50.300:FF:003899', NULL, NULL, 'Site-determining protein', NULL, NULL, NULL, NULL, NULL, 4),
(169648, NULL, 'G3DSA:3.50.30.30:FF:000092', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169649, NULL, 'G3DSA:3.40.630.10:FF:000023', NULL, NULL, 'M20/M25/M40 family metallo-hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(169650, NULL, 'G3DSA:1.20.140.10:FF:000065', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(169651, NULL, 'G3DSA:2.10.25.10:FF:000555', NULL, NULL, 'Dumpy, isoform I', NULL, NULL, NULL, NULL, NULL, 4),
(169652, NULL, 'G3DSA:3.40.50.410:FF:000234', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169653, NULL, 'G3DSA:2.30.30.140:FF:000094', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(169654, NULL, 'G3DSA:3.40.50.300:FF:006007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169655, NULL, 'G3DSA:3.30.70.330:FF:001144', NULL, NULL, 'U11/U12 small nuclear ribonucleoprotein 31 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(169656, NULL, 'G3DSA:3.10.20.30:FF:000093', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169657, NULL, 'G3DSA:1.10.760.10:FF:000030', NULL, NULL, 'L-cysteine S-thiosulfotransferase subunit SoxA', NULL, NULL, NULL, NULL, NULL, 4),
(169658, NULL, 'G3DSA:2.60.40.10:FF:001763', NULL, NULL, 'Sallimus, isoform Q', NULL, NULL, NULL, NULL, NULL, 4),
(169659, NULL, 'G3DSA:3.40.50.10190:FF:000338', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(169660, NULL, 'G3DSA:3.30.70.250:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169661, NULL, 'G3DSA:3.30.70.330:FF:000042', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(169662, NULL, 'G3DSA:3.30.497.10:FF:000080', NULL, NULL, 'Serine protease inhibitor (serpin) 4', NULL, NULL, NULL, NULL, NULL, 4),
(169663, NULL, 'G3DSA:1.10.630.10:FF:000431', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169664, NULL, 'G3DSA:3.30.460.10:FF:000068', NULL, NULL, 'DNA-directed DNA/RNA polymerase mu', NULL, NULL, NULL, NULL, NULL, 4),
(169665, NULL, 'G3DSA:3.30.830.10:FF:000203', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169666, NULL, 'G3DSA:1.20.5.110:FF:000156', NULL, NULL, 'Syntaxin binding protein 6 (amisyn), like', NULL, NULL, NULL, NULL, NULL, 4),
(169667, NULL, 'G3DSA:3.30.70.2740:FF:000013', NULL, NULL, 'Putative oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(169668, NULL, 'G3DSA:3.40.50.1000:FF:000320', NULL, NULL, 'Probable hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(169669, NULL, 'G3DSA:1.10.472.80:FF:000179', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169670, NULL, 'G3DSA:2.70.70.10:FF:000022', NULL, NULL, 'Peptidase, M23 family', NULL, NULL, NULL, NULL, NULL, 4),
(169671, NULL, 'G3DSA:3.90.550.10:FF:000382', NULL, NULL, 'Alpha-1,6-mannosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169672, NULL, 'G3DSA:1.20.190.50:FF:000001', NULL, NULL, 'Nuclear pore complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(169673, NULL, 'G3DSA:1.25.40.10:FF:004882', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169674, NULL, 'G3DSA:1.10.510.10:FF:003856', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169675, NULL, 'G3DSA:3.30.70.240:FF:000015', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(169676, NULL, 'G3DSA:3.40.50.12710:FF:000016', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7', NULL, NULL, NULL, NULL, NULL, 4),
(169677, NULL, 'G3DSA:3.30.70.330:FF:002779', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169678, NULL, 'G3DSA:2.60.120.290:FF:000159', NULL, NULL, 'Cubilin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(169679, NULL, 'G3DSA:3.90.25.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169680, NULL, 'G3DSA:3.10.20.230:FF:000029', NULL, NULL, 'probable serine/threonine-protein kinase kinX isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(169681, NULL, 'G3DSA:1.10.10.2170:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169682, NULL, 'G3DSA:3.40.630.20:FF:000026', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169683, NULL, 'G3DSA:1.10.287.70:FF:000509', NULL, NULL, 'Ionotropic glutamate receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169684, NULL, 'G3DSA:1.10.287.70:FF:000774', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169685, NULL, 'G3DSA:2.60.40.640:FF:000031', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(169686, NULL, 'G3DSA:2.30.30.490:FF:000029', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(169687, NULL, 'G3DSA:3.10.310.20:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169688, NULL, 'G3DSA:3.40.605.10:FF:000038', NULL, NULL, 'Aldehyde dehydrogenase 1 family member L1', NULL, NULL, NULL, NULL, NULL, 4),
(169689, NULL, 'G3DSA:3.40.630.30:FF:000029', NULL, NULL, 'Bifunctional acetylglutamate kinase/N-acetyl-gamma-glutamyl-phosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(169690, NULL, 'G3DSA:2.130.10.10:FF:001741', NULL, NULL, 'Pre-mRNA-splicing factor PRP46, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169691, NULL, 'G3DSA:3.20.20.190:FF:000037', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(169692, NULL, 'G3DSA:3.90.80.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(169693, NULL, 'G3DSA:1.20.1250.20:FF:000295', NULL, NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(169694, NULL, 'G3DSA:3.90.70.10:FF:000699', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 17', NULL, NULL, NULL, NULL, NULL, 4),
(169695, NULL, 'G3DSA:3.20.20.140:FF:000455', NULL, NULL, 'Guanine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(169696, NULL, 'G3DSA:3.40.710.10:FF:000024', NULL, NULL, 'Penicillin-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(169697, NULL, 'G3DSA:3.40.50.10300:FF:000001', NULL, NULL, 'Coenzyme A biosynthesis bifunctional protein CoaBC', NULL, NULL, NULL, NULL, NULL, 4),
(169698, NULL, 'G3DSA:2.40.290.10:FF:000017', NULL, NULL, 'ATP-dependent DNA helicase 2 subunit KU70', NULL, NULL, NULL, NULL, NULL, 4),
(169699, NULL, 'G3DSA:3.80.10.10:FF:004254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169700, NULL, 'G3DSA:3.40.50.300:FF:002590', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(169701, NULL, 'G3DSA:3.40.50.800:FF:000109', NULL, NULL, 'Threonine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(169702, NULL, 'G3DSA:1.10.510.10:FF:000630', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(169703, NULL, 'G3DSA:2.60.40.10:FF:003854', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169704, NULL, 'G3DSA:3.50.50.60:FF:001506', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(169705, NULL, 'G3DSA:3.40.1810.10:FF:000082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169706, NULL, 'G3DSA:3.40.50.10310:FF:000004', NULL, NULL, '3-dehydro-scyllo-inosose hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(169707, NULL, 'G3DSA:3.90.228.10:FF:000066', NULL, NULL, 'Poly [ADP-ribose] polymerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(169708, NULL, 'G3DSA:2.10.25.10:FF:000494', NULL, NULL, 'Weary, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(169709, NULL, 'G3DSA:3.40.50.1820:FF:000706', NULL, NULL, 'Lypla1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(169710, NULL, 'G3DSA:3.40.50.10320:FF:000007', NULL, NULL, '2''-N-acetylparomamine deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(169711, NULL, 'G3DSA:1.10.840.10:FF:000031', NULL, NULL, 'Phospholipase C, epsilon 1', NULL, NULL, NULL, NULL, NULL, 4),
(169712, NULL, 'G3DSA:3.40.50.300:FF:003692', NULL, NULL, 'SNF2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(169713, NULL, 'G3DSA:3.40.50.620:FF:000825', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(169714, NULL, 'G3DSA:3.80.10.10:FF:003152', NULL, NULL, 'Protein CBG22557', NULL, NULL, NULL, NULL, NULL, 4),
(169715, NULL, 'G3DSA:1.10.540.10:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169716, NULL, 'G3DSA:2.30.39.10:FF:000069', NULL, NULL, 'Serine protease inhibitor (serpin) 19', NULL, NULL, NULL, NULL, NULL, 4),
(169717, NULL, 'G3DSA:3.40.50.300:FF:000347', NULL, NULL, 'Heparan-sulfate 6-O-sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(169718, NULL, 'G3DSA:1.50.40.10:FF:000456', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169719, NULL, 'G3DSA:1.25.40.20:FF:000231', NULL, NULL, '2-5A-dependent ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(169720, NULL, 'G3DSA:2.40.10.10:FF:000317', NULL, NULL, 'serine protease gd isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(169721, NULL, 'G3DSA:1.10.8.10:FF:000354', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169722, NULL, 'G3DSA:1.10.10.10:FF:001855', NULL, NULL, 'Manganese ABC transporter permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(169723, NULL, 'G3DSA:3.10.620.10:FF:000001', NULL, NULL, 'Blast:Protein N-terminal glutamine amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(169724, NULL, 'G3DSA:2.30.30.190:FF:000029', NULL, NULL, 'Cytoskeleton associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(169725, NULL, 'G3DSA:3.30.800.10:FF:000022', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(169726, NULL, 'G3DSA:3.40.50.150:FF:000313', NULL, NULL, 'methyltransferase-like protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(169727, NULL, 'G3DSA:3.60.10.10:FF:000348', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169728, NULL, 'G3DSA:2.70.150.10:FF:000270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169729, NULL, 'G3DSA:1.20.1270.60:FF:000257', NULL, NULL, 'BAR domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(169730, NULL, 'G3DSA:1.10.555.10:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169731, NULL, 'G3DSA:3.30.413.10:FF:000038', NULL, NULL, 'Probable oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(169732, NULL, 'G3DSA:1.10.167.10:FF:000005', NULL, NULL, 'Putative A-kinase anchor protein 10 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(169733, NULL, 'G3DSA:3.40.430.10:FF:000042', NULL, NULL, 'Riboflavin biosynthesis protein RibD', NULL, NULL, NULL, NULL, NULL, 4),
(169734, NULL, 'G3DSA:2.130.10.10:FF:001269', NULL, NULL, 'telomerase Cajal body protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(169735, NULL, 'G3DSA:3.40.50.300:FF:000201', NULL, NULL, 'Glycine betaine/L-proline ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(169736, NULL, 'G3DSA:3.10.620.30:FF:000007', NULL, NULL, 'Transglutaminase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(169737, NULL, 'G3DSA:1.20.120.350:FF:000053', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(169738, NULL, 'G3DSA:1.10.274.30:FF:000013', NULL, NULL, 'MSL3-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(169739, NULL, 'G3DSA:1.20.5.190:FF:000106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169740, NULL, 'G3DSA:1.20.1600.10:FF:000038', NULL, NULL, 'Outer membrane channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(169741, NULL, 'G3DSA:3.90.1440.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169742, NULL, 'G3DSA:1.10.287.950:FF:000009', NULL, NULL, 'Signal transduction four helix bundle sensory module', NULL, NULL, NULL, NULL, NULL, 4),
(169743, NULL, 'G3DSA:3.30.200.20:FF:001575', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169744, NULL, 'G3DSA:1.10.238.10:FF:000058', NULL, NULL, 'Calmodulin', NULL, NULL, NULL, NULL, NULL, 4),
(169745, NULL, 'G3DSA:3.30.390.10:FF:000006', NULL, NULL, 'Mitochondrial enolase superfamily member 1', NULL, NULL, NULL, NULL, NULL, 4),
(169746, NULL, 'G3DSA:2.80.10.50:FF:000070', NULL, NULL, 'Botulinum neurotoxin type A', NULL, NULL, NULL, NULL, NULL, 4),
(169747, NULL, 'G3DSA:1.10.630.10:FF:000577', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169748, NULL, 'G3DSA:2.130.10.10:FF:001948', NULL, NULL, 'WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(169749, NULL, 'G3DSA:1.20.120.1750:FF:000007', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(169750, NULL, 'G3DSA:3.80.10.10:FF:001527', NULL, NULL, 'Leucine-rich repeat-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(169751, NULL, 'G3DSA:1.20.120.1910:FF:000050', NULL, NULL, 'Cysteinyl-tRNA synthetase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(169752, NULL, 'G3DSA:1.10.10.10:FF:001176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169753, NULL, 'G3DSA:2.60.40.1730:FF:000119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169754, NULL, 'G3DSA:2.30.30.40:FF:000064', NULL, NULL, 'Plectin a', NULL, NULL, NULL, NULL, NULL, 4),
(169755, NULL, 'G3DSA:1.25.40.10:FF:003780', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169756, NULL, 'G3DSA:1.10.287.940:FF:000006', NULL, NULL, 'p2X purinoceptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(169757, NULL, 'G3DSA:3.30.260.10:FF:000087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169758, NULL, 'G3DSA:2.40.50.140:FF:000876', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169759, NULL, 'G3DSA:3.90.550.10:FF:000056', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(169760, NULL, 'G3DSA:2.20.100.10:FF:000166', NULL, NULL, 'Zinc metalloproteinase', NULL, NULL, NULL, NULL, NULL, 4),
(169761, NULL, 'G3DSA:2.60.40.10:FF:003915', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169762, NULL, 'G3DSA:3.80.10.10:FF:002629', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169763, NULL, 'G3DSA:1.10.565.10:FF:000071', NULL, NULL, 'Steroid receptor seven-up, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(169764, NULL, 'G3DSA:1.25.40.10:FF:003393', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g22070', NULL, NULL, NULL, NULL, NULL, 4),
(169765, NULL, 'G3DSA:2.40.50.100:FF:000151', NULL, NULL, 'Component of multidrug efflux system', NULL, NULL, NULL, NULL, NULL, 4),
(169766, NULL, 'G3DSA:1.10.472.80:FF:000033', NULL, NULL, 'TBC1 domain family member 9B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(169767, NULL, 'G3DSA:2.130.10.10:FF:000167', NULL, NULL, 'Actin-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(169768, NULL, 'G3DSA:2.120.10.30:FF:000140', NULL, NULL, 'Tol-Pal system protein TolB', NULL, NULL, NULL, NULL, NULL, 4),
(169769, NULL, 'G3DSA:3.40.50.720:FF:001226', NULL, NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169770, NULL, 'G3DSA:1.10.3330.10:FF:000008', NULL, NULL, '2-oxo-4-hydroxy-4-carboxy--5-ureidoimidazoline (OHCU) decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(169771, NULL, 'G3DSA:3.40.33.10:FF:000109', NULL, NULL, 'Antigen 5/SCP domain-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169772, NULL, 'G3DSA:1.10.510.10:FF:003917', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169773, NULL, 'G3DSA:3.30.160.60:FF:002022', NULL, NULL, 'Transcriptional regulator MET31', NULL, NULL, NULL, NULL, NULL, 4),
(169774, NULL, 'G3DSA:1.10.510.10:FF:001439', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169775, NULL, 'G3DSA:1.25.40.10:FF:002291', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At3g15130', NULL, NULL, NULL, NULL, NULL, 4),
(169776, NULL, 'G3DSA:1.20.1250.20:FF:000974', NULL, NULL, 'Sodium-dependent lysophosphatidylcholine symporter 1-A', NULL, NULL, NULL, NULL, NULL, 4),
(169777, NULL, 'G3DSA:3.60.20.30:FF:000006', NULL, NULL, 'Threonine aspartase', NULL, NULL, NULL, NULL, NULL, 4),
(169778, NULL, 'G3DSA:3.60.21.10:FF:000019', NULL, NULL, 'Double-strand break repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(169779, NULL, 'G3DSA:1.50.40.10:FF:000602', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169780, NULL, 'G3DSA:2.10.25.10:FF:000881', NULL, NULL, 'Uninflatable, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(169781, NULL, 'G3DSA:3.40.50.300:FF:005844', NULL, NULL, 'Os04g0413000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(169782, NULL, 'G3DSA:3.90.700.10:FF:000001', NULL, NULL, 'Mitochondrial succinate dehydrogenase flavoprotein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(169783, NULL, 'G3DSA:3.40.50.1010:FF:000177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169784, NULL, 'G3DSA:1.50.40.10:FF:000310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169785, NULL, 'G3DSA:3.40.50.12550:FF:000007', NULL, NULL, 'Ubiquitin like modifier activating enzyme 6', NULL, NULL, NULL, NULL, NULL, 4),
(169786, NULL, 'G3DSA:2.170.270.10:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169787, NULL, 'G3DSA:3.40.910.10:FF:000005', NULL, NULL, 'deoxyhypusine synthase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(169788, NULL, 'G3DSA:3.40.50.720:FF:001518', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169789, NULL, 'G3DSA:4.10.400.10:FF:000363', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169790, NULL, 'G3DSA:2.60.40.10:FF:005771', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169791, NULL, 'G3DSA:4.10.410.10:FF:000009', NULL, NULL, 'WAP, Kazal, immunoglobulin, Kunitz and NTR domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(169792, NULL, 'G3DSA:2.40.50.40:FF:000099', NULL, NULL, 'Chromodomain-helicase-DNA-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(169793, NULL, 'G3DSA:3.40.50.300:FF:008250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169794, NULL, 'G3DSA:3.20.20.70:FF:000469', NULL, NULL, 'Cinnamate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(169795, NULL, 'G3DSA:3.40.50.10420:FF:000037', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(169796, NULL, 'G3DSA:3.30.1490.120:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169797, NULL, 'G3DSA:3.30.830.10:FF:000142', NULL, NULL, 'Cytochrome b-c1 complex subunit 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(169798, NULL, 'G3DSA:3.80.10.10:FF:002337', NULL, NULL, 'Putative leucine-rich repeat receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(169799, NULL, 'G3DSA:1.20.1250.20:FF:001312', NULL, NULL, 'monocarboxylate transporter 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(169800, NULL, 'G3DSA:3.40.50.300:FF:000173', NULL, NULL, 'GTPase HflX', NULL, NULL, NULL, NULL, NULL, 4),
(169801, NULL, 'G3DSA:1.10.1070.11:FF:000011', NULL, NULL, 'Serine-protein kinase ATM', NULL, NULL, NULL, NULL, NULL, 4),
(169802, NULL, 'G3DSA:1.10.150.50:FF:000193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169803, NULL, 'G3DSA:3.40.250.10:FF:000005', NULL, NULL, 'Rhodanese-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(169804, NULL, 'G3DSA:3.30.420.10:FF:000268', NULL, NULL, 'Putative ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(169805, NULL, 'G3DSA:2.60.40.10:FF:001437', NULL, NULL, 'Echinoid, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(169806, NULL, 'G3DSA:3.40.50.200:FF:000082', NULL, NULL, 'Serine protease, subtilisin family', NULL, NULL, NULL, NULL, NULL, 4),
(169807, NULL, 'G3DSA:2.60.40.10:FF:000009', NULL, NULL, 'receptor-type tyrosine-protein phosphatase U isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(169808, NULL, 'G3DSA:1.10.287.70:FF:000189', NULL, NULL, 'Potassium channel, two pore domain subfamily K, member 3', NULL, NULL, NULL, NULL, NULL, 4),
(169809, NULL, 'G3DSA:3.40.720.10:FF:000261', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169810, NULL, 'G3DSA:3.40.50.10190:FF:000131', NULL, NULL, 'Deoxycytidyl transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169811, NULL, 'G3DSA:3.40.50.150:FF:000813', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169812, NULL, 'G3DSA:4.10.400.10:FF:000037', NULL, NULL, 'Sortilin related receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(169813, NULL, 'G3DSA:1.10.10.60:FF:000156', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(169814, NULL, 'G3DSA:1.25.40.10:FF:003628', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g64320, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(169815, NULL, 'G3DSA:1.10.287.470:FF:000079', NULL, NULL, 'Sll1053 protein', NULL, NULL, NULL, NULL, NULL, 4),
(169816, NULL, 'G3DSA:1.25.10.10:FF:001709', NULL, NULL, 'Proteasome 26S subunit, non-ATPase 5', NULL, NULL, NULL, NULL, NULL, 4),
(169817, NULL, 'G3DSA:1.20.272.40:FF:000009', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(169818, NULL, 'G3DSA:1.10.12.10:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169819, NULL, 'G3DSA:3.30.60.30:FF:000050', NULL, NULL, 'Follistatin like 5', NULL, NULL, NULL, NULL, NULL, 4),
(169820, NULL, 'G3DSA:2.130.10.10:FF:003539', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', NULL, NULL, NULL, NULL, NULL, 4),
(169821, NULL, 'G3DSA:3.40.50.790:FF:000005', NULL, NULL, '50S ribosomal protein L1', NULL, NULL, NULL, NULL, NULL, 4),
(169822, NULL, 'G3DSA:3.40.50.10190:FF:000159', NULL, NULL, 'Telomeric repeat-binding factor 2-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(169823, NULL, 'G3DSA:3.40.50.1400:FF:000024', NULL, NULL, 'Ferrochelatase-like protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(169824, NULL, 'G3DSA:1.20.810.10:FF:000004', NULL, NULL, 'Cytochrome b', NULL, NULL, NULL, NULL, NULL, 4),
(169825, NULL, 'G3DSA:2.130.10.10:FF:004321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169826, NULL, 'G3DSA:1.20.1250.20:FF:000795', NULL, NULL, 'Protein CBG05932', NULL, NULL, NULL, NULL, NULL, 4),
(169827, NULL, 'G3DSA:3.40.50.300:FF:005198', NULL, NULL, 'Dephospho-CoA kinase', NULL, NULL, NULL, NULL, NULL, 4),
(169828, NULL, 'G3DSA:3.40.190.290:FF:000020', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(169829, NULL, 'G3DSA:3.20.20.100:FF:000084', NULL, NULL, 'Glycerol dehydrogenase (GCY1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(169830, NULL, 'G3DSA:2.10.90.10:FF:000127', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169831, NULL, 'G3DSA:1.10.630.10:FF:000077', NULL, NULL, 'Cytochrome P450 71A1-like', NULL, NULL, NULL, NULL, NULL, 4),
(169832, NULL, 'G3DSA:1.25.10.10:FF:003273', NULL, NULL, 'Serine/threonine-protein kinase tor', NULL, NULL, NULL, NULL, NULL, 4),
(169833, NULL, 'G3DSA:1.20.120.350:FF:000232', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169834, NULL, 'G3DSA:3.60.20.40:FF:000009', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169835, NULL, 'G3DSA:2.10.60.10:FF:000007', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(169836, NULL, 'G3DSA:1.10.1000.11:FF:000030', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169837, NULL, 'G3DSA:3.30.70.330:FF:003061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169838, NULL, 'G3DSA:1.10.1670.40:FF:000014', NULL, NULL, 'DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(169839, NULL, 'G3DSA:2.30.29.30:FF:001390', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169840, NULL, 'G3DSA:4.10.240.10:FF:000209', NULL, NULL, 'Uncharacterized transcriptional regulatory protein C3H8.08c', NULL, NULL, NULL, NULL, NULL, 4),
(169841, NULL, 'G3DSA:1.50.10.10:FF:000128', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(169842, NULL, 'G3DSA:3.40.50.300:FF:001275', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169843, NULL, 'G3DSA:3.40.50.10810:FF:000064', NULL, NULL, 'SWI/SNF family DNA-dependent ATPase Ris1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169844, NULL, 'G3DSA:1.10.510.10:FF:000304', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(169845, NULL, 'G3DSA:3.30.160.360:FF:000003', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(169846, NULL, 'G3DSA:1.25.40.10:FF:001829', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g39980, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(169847, NULL, 'G3DSA:3.40.50.800:FF:000082', NULL, NULL, 'Histidyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169848, NULL, 'G3DSA:2.20.25.10:FF:000061', NULL, NULL, 'DNA-directed RNA polymerase II subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169849, NULL, 'G3DSA:2.40.30.230:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169850, NULL, 'G3DSA:3.40.1280.30:FF:000012', NULL, NULL, 'RNA (Guanine-9-) methyltransferase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(169851, NULL, 'G3DSA:3.30.160.60:FF:006237', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169852, NULL, 'G3DSA:3.30.565.10:FF:000154', NULL, NULL, 'PAS domain-containing sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(169853, NULL, 'G3DSA:1.20.1250.20:FF:001284', NULL, NULL, 'Major facilitator superfamily MFS_1', NULL, NULL, NULL, NULL, NULL, 4),
(169854, NULL, 'G3DSA:3.40.50.300:FF:003719', NULL, NULL, 'ATP-binding cassette transporter, subfamily C, member 12, group MRP protein PpABCC12', NULL, NULL, NULL, NULL, NULL, 4),
(169855, NULL, 'G3DSA:3.40.50.1460:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(169856, NULL, 'G3DSA:1.20.1070.10:FF:001244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169857, NULL, 'G3DSA:1.10.510.10:FF:004053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169858, NULL, 'G3DSA:1.20.1250.20:FF:000648', NULL, NULL, 'MFS superfamily vanillate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(169859, NULL, 'G3DSA:1.20.1560.10:FF:000629', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169860, NULL, 'G3DSA:1.20.58.390:FF:000082', NULL, NULL, 'Glutamate-gated ChLoride channel', NULL, NULL, NULL, NULL, NULL, 4),
(169861, NULL, 'G3DSA:1.10.510.10:FF:004227', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169862, NULL, 'G3DSA:2.10.25.10:FF:000729', NULL, NULL, 'Blast:Protein slit', NULL, NULL, NULL, NULL, NULL, 4),
(169863, NULL, 'G3DSA:3.30.450.40:FF:000172', NULL, NULL, 'Sigma factor SibG regulation protein RsbU', NULL, NULL, NULL, NULL, NULL, 4),
(169864, NULL, 'G3DSA:2.130.10.10:FF:002404', NULL, NULL, 'Elongator acetyltransferase complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(169865, NULL, 'G3DSA:2.130.10.10:FF:005456', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169866, NULL, 'G3DSA:3.10.350.10:FF:000076', NULL, NULL, 'LysM domain receptor-like kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(169867, NULL, 'G3DSA:2.60.40.4370:FF:000001', NULL, NULL, 'general transcription factor 3C polypeptide 6', NULL, NULL, NULL, NULL, NULL, 4),
(169868, NULL, 'G3DSA:3.90.1170.10:FF:000003', NULL, NULL, '54S ribosomal protein L16, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(169869, NULL, 'G3DSA:2.60.40.2030:FF:000001', NULL, NULL, 'sodium/calcium exchanger 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(169870, NULL, 'G3DSA:2.10.25.10:FF:001011', NULL, NULL, 'Slit protein', NULL, NULL, NULL, NULL, NULL, 4),
(169871, NULL, 'G3DSA:3.50.50.60:FF:000989', NULL, NULL, 'Pyridine nucleotide-disulphide oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169872, NULL, 'G3DSA:3.90.190.10:FF:000573', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169873, NULL, 'G3DSA:3.40.50.1820:FF:001521', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169874, NULL, 'G3DSA:3.30.160.60:FF:001892', NULL, NULL, 'Zinc finger protein 786', NULL, NULL, NULL, NULL, NULL, 4),
(169875, NULL, 'G3DSA:3.90.1170.20:FF:000006', NULL, NULL, 'Nicotinate-nucleotide diphosphorylase (Carboxylating)', NULL, NULL, NULL, NULL, NULL, 4),
(169876, NULL, 'G3DSA:3.40.1500.10:FF:000007', NULL, NULL, 'Oxygen-dependent coproporphyrinogen-III oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(169877, NULL, 'G3DSA:3.90.640.10:FF:000294', NULL, NULL, 'Immunoglobulin heavy chain binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169878, NULL, 'G3DSA:1.20.1070.10:FF:001536', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169879, NULL, 'G3DSA:1.20.1540.10:FF:000100', NULL, NULL, 'Uncharacterized rhomboid protein C19B12.06c', NULL, NULL, NULL, NULL, NULL, 4),
(169880, NULL, 'G3DSA:3.30.420.10:FF:000594', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169881, NULL, 'G3DSA:2.40.100.10:FF:000122', NULL, NULL, 'Peptidyl-prolyl isomerase CWC27', NULL, NULL, NULL, NULL, NULL, 4),
(169882, NULL, 'G3DSA:1.10.390.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169883, NULL, 'G3DSA:3.30.160.380:FF:000009', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(169884, NULL, 'G3DSA:1.20.58.1880:FF:000010', NULL, NULL, 'Nuclear receptor corepressor 1', NULL, NULL, NULL, NULL, NULL, 4),
(169885, NULL, 'G3DSA:3.30.160.60:FF:005927', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169886, NULL, 'G3DSA:3.90.1170.30:FF:000009', NULL, NULL, 'Pyrimidine-nucleoside phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(169887, NULL, 'G3DSA:2.40.10.10:FF:000025', NULL, NULL, 'serine proteases 1/2', NULL, NULL, NULL, NULL, NULL, 4),
(169888, NULL, 'G3DSA:2.130.10.10:FF:004967', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(169889, NULL, 'G3DSA:2.60.120.650:FF:000110', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169890, NULL, 'G3DSA:2.60.40.3510:FF:000007', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(169891, NULL, 'G3DSA:2.30.29.30:FF:000575', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(169892, NULL, 'G3DSA:2.60.40.10:FF:004051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169893, NULL, 'G3DSA:2.130.10.10:FF:005810', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(169894, NULL, 'G3DSA:3.30.300.20:FF:000032', NULL, NULL, 'AGAP010622-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(169895, NULL, 'G3DSA:2.60.40.60:FF:000210', NULL, NULL, 'FAT atypical cadherin 2', NULL, NULL, NULL, NULL, NULL, 4),
(169896, NULL, 'G3DSA:3.20.20.70:FF:000823', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169897, NULL, 'G3DSA:1.20.1280.50:FF:000047', NULL, NULL, 'Tubby-like F-box protein', NULL, NULL, NULL, NULL, NULL, 4),
(169898, NULL, 'G3DSA:3.20.20.80:FF:000826', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169899, NULL, 'G3DSA:3.40.440.10:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169900, NULL, 'G3DSA:3.40.50.300:FF:007761', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169901, NULL, 'G3DSA:3.60.21.10:FF:000345', NULL, NULL, 'MRE11 eukaryotic DNA repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(169902, NULL, 'G3DSA:3.30.10.20:FF:000009', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(169903, NULL, 'G3DSA:3.40.50.10140:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169904, NULL, 'G3DSA:4.10.900.10:FF:000002', NULL, NULL, 'transcription factor 7-like 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(169905, NULL, 'G3DSA:2.60.40.3500:FF:000004', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(169906, NULL, 'G3DSA:3.40.50.10090:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169907, NULL, 'G3DSA:2.40.170.20:FF:000106', NULL, NULL, 'SusC homolog', NULL, NULL, NULL, NULL, NULL, 4),
(169908, NULL, 'G3DSA:3.90.70.10:FF:000114', NULL, NULL, 'Calpain a', NULL, NULL, NULL, NULL, NULL, 4),
(169909, NULL, 'G3DSA:3.40.1620.60:FF:000008', NULL, NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 8', NULL, NULL, NULL, NULL, NULL, 4),
(169910, NULL, 'G3DSA:1.20.1070.10:FF:000429', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169911, NULL, 'G3DSA:2.60.40.60:FF:000417', NULL, NULL, 'Dachsous cadherin-related 1a', NULL, NULL, NULL, NULL, NULL, 4),
(169912, NULL, 'G3DSA:3.40.50.620:FF:000679', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169913, NULL, 'G3DSA:3.30.505.10:FF:000206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169914, NULL, 'G3DSA:2.30.29.30:FF:001064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169915, NULL, 'G3DSA:3.80.10.10:FF:003444', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169916, NULL, 'G3DSA:1.10.238.10:FF:000204', NULL, NULL, 'EF-hand domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(169917, NULL, 'G3DSA:1.25.40.20:FF:000523', NULL, NULL, 'Os07g0193200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(169918, NULL, 'G3DSA:2.130.10.10:FF:003865', NULL, NULL, 'Uncharacterized WD repeat-containing protein C16H5.13', NULL, NULL, NULL, NULL, NULL, 4),
(169919, NULL, 'G3DSA:1.25.70.10:FF:000022', NULL, NULL, 'BnaA06g33880D protein', NULL, NULL, NULL, NULL, NULL, 4),
(169920, NULL, 'G3DSA:3.40.1380.20:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169921, NULL, 'G3DSA:3.90.226.10:FF:000230', NULL, NULL, 'ATP-dependent Clp protease proteolytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(169922, NULL, 'G3DSA:3.50.50.60:FF:000782', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(169923, NULL, 'G3DSA:1.25.40.10:FF:000520', NULL, NULL, 'pentatricopeptide repeat-containing protein At5g39980, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(169924, NULL, 'G3DSA:2.10.25.10:FF:001218', NULL, NULL, 'von Willebrand factor D and EGF domains', NULL, NULL, NULL, NULL, NULL, 4),
(169925, NULL, 'G3DSA:3.30.930.10:FF:000059', NULL, NULL, 'phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(169926, NULL, 'G3DSA:3.40.20.10:FF:000069', NULL, NULL, 'Sfb3p', NULL, NULL, NULL, NULL, NULL, 4),
(169927, NULL, 'G3DSA:2.40.128.20:FF:000071', NULL, NULL, 'apolipoprotein D-like', NULL, NULL, NULL, NULL, NULL, 4),
(169928, NULL, 'G3DSA:3.40.50.11530:FF:000010', NULL, NULL, 'Interleukin cytokine receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(169929, NULL, 'G3DSA:1.10.10.60:FF:001084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169930, NULL, 'G3DSA:2.60.120.10:FF:000580', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(169931, NULL, 'G3DSA:2.60.40.10:FF:000335', NULL, NULL, 'Intercellular adhesion molecule 5', NULL, NULL, NULL, NULL, NULL, 4),
(169932, NULL, 'G3DSA:4.10.280.110:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169933, NULL, 'G3DSA:3.40.190.10:FF:000213', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(169934, NULL, 'G3DSA:1.20.1410.10:FF:000029', NULL, NULL, 'AGR286Cp', NULL, NULL, NULL, NULL, NULL, 4),
(169935, NULL, 'G3DSA:3.60.20.10:FF:000259', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169936, NULL, 'G3DSA:3.40.50.150:FF:001741', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169937, NULL, 'G3DSA:3.80.10.10:FF:001235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169938, NULL, 'G3DSA:3.40.630.30:FF:000416', NULL, NULL, 'N-terminal acetyltransferase complex ARD1 subunit homolog', NULL, NULL, NULL, NULL, NULL, 4),
(169939, NULL, 'G3DSA:2.60.120.810:FF:000001', NULL, NULL, 'TCP pilus virulence regulatory protein ToxT', NULL, NULL, NULL, NULL, NULL, 4),
(169940, NULL, 'G3DSA:2.170.150.30:FF:000004', NULL, NULL, 'DEXH (Asp-Glu-X-His) box polypeptide 58', NULL, NULL, NULL, NULL, NULL, 4),
(169941, NULL, 'G3DSA:3.40.50.2300:FF:001059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169942, NULL, 'G3DSA:3.40.50.410:FF:000088', NULL, NULL, 'RNA polymerase II transcription factor B subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(169943, NULL, 'G3DSA:1.25.40.10:FF:001184', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At3g18840', NULL, NULL, NULL, NULL, NULL, 4),
(169944, NULL, 'G3DSA:3.30.1140.32:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169945, NULL, 'G3DSA:1.10.10.10:FF:001468', NULL, NULL, 'histone H1-delta-like', NULL, NULL, NULL, NULL, NULL, 4),
(169946, NULL, 'G3DSA:1.25.10.10:FF:001682', NULL, NULL, 'AGAP003488-PA', NULL, NULL, NULL, NULL, NULL, 4),
(169947, NULL, 'G3DSA:3.40.50.1000:FF:000174', NULL, NULL, 'Phosphoenolpyruvate and 6-phosphogluconate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(169948, NULL, 'G3DSA:3.30.530.20:FF:000015', NULL, NULL, 'Steroidogenic acute regulatory protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(169949, NULL, 'G3DSA:1.25.40.10:FF:003954', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169950, NULL, 'G3DSA:3.40.50.11350:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169951, NULL, 'G3DSA:3.40.50.10180:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169952, NULL, 'G3DSA:1.20.1560.10:FF:000776', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169953, NULL, 'G3DSA:1.20.58.1120:FF:000069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169954, NULL, 'G3DSA:1.20.1280.50:FF:000226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169955, NULL, 'G3DSA:3.30.160.60:FF:000431', NULL, NULL, 'zinc finger protein 629 isoform X2', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(169956, NULL, 'G3DSA:3.50.30.30:FF:000120', NULL, NULL, 'Peptide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(169957, NULL, 'G3DSA:2.30.30.40:FF:000210', NULL, NULL, 'Karst, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(169958, NULL, 'G3DSA:2.60.40.10:FF:005978', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169959, NULL, 'G3DSA:1.25.10.10:FF:002171', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169960, NULL, 'G3DSA:3.80.10.10:FF:002955', NULL, NULL, 'Disease resistance protein RPP8', NULL, NULL, NULL, NULL, NULL, 4),
(169961, NULL, 'G3DSA:3.90.550.10:FF:000410', NULL, NULL, 'Cellulose synthase-like protein E6', NULL, NULL, NULL, NULL, NULL, 4),
(169962, NULL, 'G3DSA:3.30.450.20:FF:000099', NULL, NULL, 'Sensory box sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(169963, NULL, 'G3DSA:2.60.40.60:FF:000182', NULL, NULL, 'Blast:Putative neural-cadherin 2', NULL, NULL, NULL, NULL, NULL, 4),
(169964, NULL, 'G3DSA:1.10.472.80:FF:000207', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169965, NULL, 'G3DSA:3.50.30.30:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169966, NULL, 'G3DSA:2.130.10.10:FF:003478', NULL, NULL, 'Protein CBR-DAF-15', NULL, NULL, NULL, NULL, NULL, 4),
(169967, NULL, 'G3DSA:4.10.800.20:FF:000003', NULL, NULL, 'Putative adenosine monophosphate deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(169968, NULL, 'G3DSA:4.10.800.30:FF:000006', NULL, NULL, 'Essential meiotic structure-specific endonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(169969, NULL, 'G3DSA:3.40.1110.10:FF:000427', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169970, NULL, 'G3DSA:2.40.50.140:FF:000994', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169971, NULL, 'G3DSA:3.30.1330.30:FF:000019', NULL, NULL, '40S ribosomal protein S12', NULL, NULL, NULL, NULL, NULL, 4),
(169972, NULL, 'G3DSA:3.60.21.10:FF:000137', NULL, NULL, 'Calcineurin-like metallo-phosphoesterase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(169973, NULL, 'G3DSA:1.10.10.440:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169974, NULL, 'G3DSA:3.50.50.60:FF:001119', NULL, NULL, 'Squalene monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(169975, NULL, 'G3DSA:3.40.50.2000:FF:000665', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(169976, NULL, 'G3DSA:1.10.287.2250:FF:000018', NULL, NULL, 'Cathepsin Lb', NULL, NULL, NULL, NULL, NULL, 4),
(169977, NULL, 'G3DSA:3.30.1330.20:FF:000016', NULL, NULL, 'Cell division protein FtsZ', NULL, NULL, NULL, NULL, NULL, 4),
(169978, NULL, 'G3DSA:3.40.50.720:FF:001344', NULL, NULL, 'Molybdopterin biosynthesis MoeB protein', NULL, NULL, NULL, NULL, NULL, 4),
(169979, NULL, 'G3DSA:3.40.605.10:FF:000010', NULL, NULL, 'N-succinylglutamate 5-semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(169980, NULL, 'G3DSA:2.170.260.10:FF:000001', NULL, NULL, 'Protein argonaute-2', NULL, NULL, NULL, NULL, NULL, 4),
(169981, NULL, 'G3DSA:3.30.1380.20:FF:000053', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(169982, NULL, 'G3DSA:1.25.40.20:FF:001658', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(169983, NULL, 'G3DSA:3.30.260.10:FF:000002', NULL, NULL, 'T-complex protein 1 subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(169984, NULL, 'G3DSA:1.20.120.1760:FF:000044', NULL, NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(169985, NULL, 'G3DSA:2.120.10.30:FF:000022', NULL, NULL, 'Tol-Pal system protein TolB', NULL, NULL, NULL, NULL, NULL, 4),
(169986, NULL, 'G3DSA:3.30.200.20:FF:002031', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(169987, NULL, 'G3DSA:2.30.30.30:FF:000027', NULL, NULL, 'Transcription elongation factor SPT5', NULL, NULL, NULL, NULL, NULL, 4),
(169988, NULL, 'G3DSA:1.20.1250.20:FF:001430', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169989, NULL, 'G3DSA:3.40.720.10:FF:000176', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(169990, NULL, 'G3DSA:2.70.160.11:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169991, NULL, 'G3DSA:3.90.1410.10:FF:000039', NULL, NULL, 'SET domain protein (AFU_orthologue AFUA_4G11040)', NULL, NULL, NULL, NULL, NULL, 4),
(169992, NULL, 'G3DSA:3.80.10.10:FF:001409', NULL, NULL, 'Ribonuclease inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(169993, NULL, 'G3DSA:1.10.510.10:FF:003890', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169994, NULL, 'G3DSA:2.60.120.200:FF:000644', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169995, NULL, 'G3DSA:3.40.50.720:FF:000737', NULL, NULL, 'NAD(P)-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(169996, NULL, 'G3DSA:3.30.1330.10:FF:000013', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(169997, NULL, 'G3DSA:3.90.70.10:FF:000614', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(169998, NULL, 'G3DSA:2.60.40.10:FF:004017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(169999, NULL, 'G3DSA:3.30.60.30:FF:000049', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170000, NULL, 'G3DSA:3.40.50.300:FF:006625', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170001, NULL, 'G3DSA:3.30.450.40:FF:000200', NULL, NULL, 'GAF domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(170002, NULL, 'G3DSA:3.50.50.60:FF:000990', NULL, NULL, '67 kDa Myosin-crossreactive antigen', NULL, NULL, NULL, NULL, NULL, 4),
(170003, NULL, 'G3DSA:3.40.50.10180:FF:000010', NULL, NULL, 'AGAP007988-PA', NULL, NULL, NULL, NULL, NULL, 4),
(170004, NULL, 'G3DSA:2.170.270.10:FF:000030', NULL, NULL, 'Histone-lysine N-methyltransferase ATX4', NULL, NULL, NULL, NULL, NULL, 4),
(170005, NULL, 'G3DSA:3.30.450.20:FF:000571', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170006, NULL, 'G3DSA:3.30.40.10:FF:001144', NULL, NULL, 'Nitric oxide synthase-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(170007, NULL, 'G3DSA:3.30.160.60:FF:001858', NULL, NULL, 'Spalt like transcription factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(170008, NULL, 'G3DSA:3.40.50.150:FF:000252', NULL, NULL, 'EEF1A lysine methyltransferase 4', NULL, NULL, NULL, NULL, NULL, 4),
(170009, NULL, 'G3DSA:2.60.40.790:FF:000204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170010, NULL, 'G3DSA:4.10.410.60:FF:000002', NULL, NULL, '50S ribosomal protein L35', NULL, NULL, NULL, NULL, NULL, 4),
(170011, NULL, 'G3DSA:3.40.532.10:FF:000003', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(170012, NULL, 'G3DSA:2.130.10.10:FF:005664', NULL, NULL, 'GPI inositol-deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(170013, NULL, 'G3DSA:3.40.1360.10:FF:000035', NULL, NULL, 'AGAP010898-PA', NULL, NULL, NULL, NULL, NULL, 4),
(170014, NULL, 'G3DSA:1.10.3370.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170015, NULL, 'G3DSA:1.10.8.970:FF:000005', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(170016, NULL, 'G3DSA:3.50.50.60:FF:000017', NULL, NULL, 'Fumarate reductase flavoprotein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(170017, NULL, 'G3DSA:3.40.1380.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170018, NULL, 'G3DSA:1.20.1250.20:FF:001519', NULL, NULL, 'Os05g0338933 protein', NULL, NULL, NULL, NULL, NULL, 4),
(170019, NULL, 'G3DSA:1.25.10.10:FF:002137', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170020, NULL, 'G3DSA:2.60.40.1530:FF:000003', NULL, NULL, 'Integrin alpha M', NULL, NULL, NULL, NULL, NULL, 4),
(170021, NULL, 'G3DSA:2.60.40.10:FF:000217', NULL, NULL, 'High affinity immunoglobulin gamma Fc receptor I', NULL, NULL, NULL, NULL, NULL, 4),
(170022, NULL, 'G3DSA:2.70.98.110:FF:000002', NULL, NULL, 'Mannosyl-oligosaccharide glucosidase GCS1', NULL, NULL, NULL, NULL, NULL, 4),
(170023, NULL, 'G3DSA:1.10.10.60:FF:000010', NULL, NULL, 'Transcriptional activator Myb isoform A', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(170024, NULL, 'G3DSA:2.60.120.10:FF:000169', NULL, NULL, 'cAMP-binding domain (Catabolite gene activator) transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(170025, NULL, 'G3DSA:1.25.40.570:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170026, NULL, 'G3DSA:3.80.10.10:FF:003652', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170027, NULL, 'G3DSA:1.20.58.1220:FF:000009', NULL, NULL, 'Exocyst complex component 8', NULL, NULL, NULL, NULL, NULL, 4),
(170028, NULL, 'G3DSA:1.25.40.20:FF:000731', NULL, NULL, 'Ankyrin repeat domain 6b', NULL, NULL, NULL, NULL, NULL, 4),
(170029, NULL, 'G3DSA:3.30.160.60:FF:006063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170030, NULL, 'G3DSA:1.10.196.10:FF:000016', NULL, NULL, 'Regulator of G protein-signaling 14a', NULL, NULL, NULL, NULL, NULL, 4),
(170031, NULL, 'G3DSA:1.20.58.70:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170032, NULL, 'G3DSA:3.80.10.10:FF:004546', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170033, NULL, 'G3DSA:2.20.25.10:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170034, NULL, 'G3DSA:3.40.50.150:FF:001387', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170035, NULL, 'G3DSA:2.60.40.10:FF:002460', NULL, NULL, 'CRE-TWK-32 protein', NULL, NULL, NULL, NULL, NULL, 4),
(170036, NULL, 'G3DSA:3.30.70.890:FF:000007', NULL, NULL, 'Galactokinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(170037, NULL, 'G3DSA:1.10.510.10:FF:002900', NULL, NULL, 'Serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(170038, NULL, 'G3DSA:3.90.230.10:FF:000043', NULL, NULL, 'Ab1-334', NULL, NULL, NULL, NULL, NULL, 4),
(170039, NULL, 'G3DSA:1.20.120.1900:FF:000013', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(170040, NULL, 'G3DSA:3.50.30.50:FF:000013', NULL, NULL, 'Cyclase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(170041, NULL, 'G3DSA:3.40.1380.20:FF:000039', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(170042, NULL, 'G3DSA:3.40.50.2300:FF:000749', NULL, NULL, 'Guanylate cyclase 2G', NULL, NULL, NULL, NULL, NULL, 4),
(170043, NULL, 'G3DSA:1.10.287.110:FF:000230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170044, NULL, 'G3DSA:3.10.110.10:FF:000002', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 D3', NULL, NULL, NULL, NULL, NULL, 4),
(170045, NULL, 'G3DSA:3.40.50.300:FF:005962', NULL, NULL, 'ATP-dependent DNA helicase, RecQ family', NULL, NULL, NULL, NULL, NULL, 4),
(170046, NULL, 'G3DSA:3.40.1370.10:FF:000007', NULL, NULL, '50S ribosomal protein L4', NULL, NULL, NULL, NULL, NULL, 4),
(170047, NULL, 'G3DSA:1.10.8.60:FF:000228', NULL, NULL, 'ESX-1 secretion system protein EccA1', NULL, NULL, NULL, NULL, NULL, 4),
(170048, NULL, 'G3DSA:3.30.300.30:FF:000153', NULL, NULL, 'Nonribosomal peptide synthetase asqK', NULL, NULL, NULL, NULL, NULL, 4),
(170049, NULL, 'G3DSA:1.25.10.10:FF:000046', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(170050, NULL, 'G3DSA:1.10.240.10:FF:000002', NULL, NULL, 'Tryptophan--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(170051, NULL, 'G3DSA:1.20.120.1750:FF:000041', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(170052, NULL, 'G3DSA:2.40.33.10:FF:000033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170053, NULL, 'G3DSA:1.10.10.10:FF:000102', NULL, NULL, 'LexA repressor', NULL, NULL, NULL, NULL, NULL, 4),
(170054, NULL, 'G3DSA:1.10.510.10:FF:003564', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170055, NULL, 'G3DSA:1.20.120.1910:FF:000016', NULL, NULL, 'Putative cysteinyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(170056, NULL, 'G3DSA:1.25.40.10:FF:001655', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170057, NULL, 'G3DSA:3.40.140.100:FF:000009', NULL, NULL, 'ubiquitin-like modifier-activating enzyme ATG7', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(170058, NULL, 'G3DSA:3.30.565.10:FF:000300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170059, NULL, 'G3DSA:3.40.30.10:FF:000249', NULL, NULL, 'Peroxiredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(170060, NULL, 'G3DSA:3.90.190.10:FF:000539', NULL, NULL, 'Dual specificity protein phosphatase CDC14A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(170061, NULL, 'G3DSA:2.60.220.50:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170062, NULL, 'G3DSA:3.40.50.10190:FF:000277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170063, NULL, 'G3DSA:2.30.30.140:FF:000155', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(170064, NULL, 'G3DSA:1.20.1070.10:FF:000755', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170065, NULL, 'G3DSA:1.10.510.10:FF:000130', NULL, NULL, 'Ephrin type-A receptor 7', NULL, NULL, NULL, NULL, NULL, 4),
(170066, NULL, 'G3DSA:2.60.40.10:FF:003707', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170067, NULL, 'G3DSA:2.10.90.10:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170068, NULL, 'G3DSA:3.30.160.60:FF:000077', NULL, NULL, 'Sp8 transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(170069, NULL, 'G3DSA:1.20.1560.10:FF:000568', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170070, NULL, 'G3DSA:1.20.58.390:FF:000048', NULL, NULL, 'Cholinergic receptor nicotinic epsilon subunit', NULL, NULL, NULL, NULL, NULL, 4),
(170071, NULL, 'G3DSA:1.20.58.1210:FF:000006', NULL, NULL, 'Exocyst complex component EXO84', NULL, NULL, NULL, NULL, NULL, 4),
(170072, NULL, 'G3DSA:1.20.1250.20:FF:000856', NULL, NULL, 'Permease, multidrug efflux', NULL, NULL, NULL, NULL, NULL, 4),
(170073, NULL, 'G3DSA:1.20.58.390:FF:000256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170074, NULL, 'G3DSA:3.10.490.10:FF:000001', NULL, NULL, 'Gamma-glutamylcyclotransferase ytfP', NULL, NULL, NULL, NULL, NULL, 4),
(170075, NULL, 'G3DSA:3.30.200.20:FF:001783', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170076, NULL, 'G3DSA:3.10.20.90:FF:000178', NULL, NULL, 'Probable splicing factor 3A subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(170077, NULL, 'G3DSA:2.10.25.10:FF:001191', NULL, NULL, 'Sperm transmembrane protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(170078, NULL, 'G3DSA:3.40.50.300:FF:004063', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(170079, NULL, 'G3DSA:3.80.10.10:FF:002781', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', NULL, NULL, NULL, NULL, NULL, 4),
(170080, NULL, 'G3DSA:1.20.1070.10:FF:001418', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170081, NULL, 'G3DSA:2.40.10.10:FF:000110', NULL, NULL, 'Hepsin', NULL, NULL, NULL, NULL, NULL, 4),
(170082, NULL, 'G3DSA:3.30.70.330:FF:001436', NULL, NULL, 'HNRNPD isoform 12', NULL, NULL, NULL, NULL, NULL, 4),
(170083, NULL, 'G3DSA:3.20.20.70:FF:000470', NULL, NULL, '2,4-dienoyl-coa reductase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(170084, NULL, 'G3DSA:3.10.490.20:FF:000004', NULL, NULL, 'Cytoplasmic dynein heavy chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(170085, NULL, 'G3DSA:2.60.120.330:FF:000071', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170086, NULL, 'G3DSA:3.40.50.10610:FF:000004', NULL, NULL, 'Putative lipoprotein YmbA', NULL, NULL, NULL, NULL, NULL, 4),
(170087, NULL, 'G3DSA:3.40.850.10:FF:000534', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170088, NULL, 'G3DSA:2.60.40.10:FF:004225', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170089, NULL, 'G3DSA:3.30.40.10:FF:001880', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170090, NULL, 'G3DSA:1.20.5.340:FF:000112', NULL, NULL, 'Rho-associated protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(170091, NULL, 'G3DSA:1.10.2000.10:FF:000079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(170092, NULL, 'G3DSA:2.60.40.150:FF:000007', NULL, NULL, 'Synaptotagmin 1', NULL, NULL, NULL, NULL, NULL, 4),
(170093, NULL, 'G3DSA:2.40.160.20:FF:000016', NULL, NULL, 'Lipid A deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(170094, NULL, 'G3DSA:1.10.287.70:FF:000627', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170095, NULL, 'G3DSA:2.70.170.10:FF:000035', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(170096, NULL, 'G3DSA:1.25.40.10:FF:005253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170097, NULL, 'G3DSA:3.40.50.40:FF:000001', NULL, NULL, 'L-asparaginase 1', NULL, NULL, NULL, NULL, NULL, 4),
(170098, NULL, 'G3DSA:1.25.10.10:FF:001356', NULL, NULL, 'Potential nuclear cohesin complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(170099, NULL, 'G3DSA:1.10.510.10:FF:004345', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170100, NULL, 'G3DSA:2.30.30.380:FF:000053', NULL, NULL, 'Nei like DNA glycosylase 3', NULL, NULL, NULL, NULL, NULL, 4),
(170101, NULL, 'G3DSA:3.30.70.1230:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170102, NULL, 'G3DSA:1.20.120.1080:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170103, NULL, 'G3DSA:2.130.10.10:FF:000021', NULL, NULL, 'histone-binding protein RBBP4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(170104, NULL, 'G3DSA:1.20.140.150:FF:000064', NULL, NULL, 'Integral membrane protein (AFU_orthologue AFUA_6G07470)', NULL, NULL, NULL, NULL, NULL, 4),
(170105, NULL, 'G3DSA:2.40.160.10:FF:000013', NULL, NULL, 'Voltage-dependent anion channel protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(170106, NULL, 'G3DSA:1.10.268.10:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170107, NULL, 'G3DSA:1.20.120.140:FF:000023', NULL, NULL, 'Signal recognition particle 54 kDa protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(170108, NULL, 'G3DSA:3.40.50.720:FF:001552', NULL, NULL, 'Short chain dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(170109, NULL, 'G3DSA:1.10.10.2210:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170110, NULL, 'G3DSA:3.20.20.80:FF:000591', NULL, NULL, 'Arabinogalactan endo-beta-1,4-galactanase', NULL, NULL, NULL, NULL, NULL, 4),
(170111, NULL, 'G3DSA:1.10.10.2200:FF:000002', NULL, NULL, 'Rab family protein', NULL, NULL, NULL, NULL, NULL, 4),
(170112, NULL, 'G3DSA:3.10.580.10:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170113, NULL, 'G3DSA:3.60.21.10:FF:000430', NULL, NULL, 'Metallophosphoesterase', NULL, NULL, NULL, NULL, NULL, 4),
(170114, NULL, 'G3DSA:2.40.180.10:FF:000014', NULL, NULL, 'Catalase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(170115, NULL, 'G3DSA:1.20.1270.10:FF:000057', NULL, NULL, 'Endoplasmic reticulum chaperone BiP homolog', NULL, NULL, NULL, NULL, NULL, 4),
(170116, NULL, 'G3DSA:3.10.580.10:FF:000093', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(170117, NULL, 'G3DSA:2.70.130.10:FF:000027', NULL, NULL, 'Glucosidase 2 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(170118, NULL, 'G3DSA:2.60.40.10:FF:003354', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170119, NULL, 'G3DSA:3.40.30.10:FF:000513', NULL, NULL, 'Phosducin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(170120, NULL, 'G3DSA:2.130.10.10:FF:002230', NULL, NULL, 'NACHT and WD domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(170121, NULL, 'G3DSA:3.30.2140.20:FF:000007', NULL, NULL, 'Arylamine N-acetyltransferase 6', NULL, NULL, NULL, NULL, NULL, 4),
(170122, NULL, 'G3DSA:3.20.80.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170123, NULL, 'G3DSA:2.30.42.10:FF:000476', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170124, NULL, 'G3DSA:3.90.1180.10:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170125, NULL, 'G3DSA:3.20.10.10:FF:000029', NULL, NULL, '4-amino-4-deoxychorismate lyase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(170126, NULL, 'G3DSA:1.10.1420.10:FF:000133', NULL, NULL, 'Putative mis-match repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(170127, NULL, 'G3DSA:2.60.40.10:FF:001645', NULL, NULL, 'Protein tyrosine phosphatase, receptor type Q', NULL, NULL, NULL, NULL, NULL, 4),
(170128, NULL, 'G3DSA:1.20.120.350:FF:000171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170129, NULL, 'G3DSA:1.20.5.170:FF:000185', NULL, NULL, 'BZIP transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(170130, NULL, 'G3DSA:1.10.30.10:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170131, NULL, 'G3DSA:2.130.10.30:FF:000027', NULL, NULL, 'Protein FMP25, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(170132, NULL, 'G3DSA:1.20.120.350:FF:000114', NULL, NULL, 'Potassium voltage-gated channel modifier subfamily V member 1', NULL, NULL, NULL, NULL, NULL, 4),
(170133, NULL, 'G3DSA:1.10.555.10:FF:000008', NULL, NULL, 'Rho GTPase-activating protein 42', NULL, NULL, NULL, NULL, NULL, 4),
(170134, NULL, 'G3DSA:1.10.555.10:FF:000065', NULL, NULL, 'Rho GTPase activator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(170135, NULL, 'G3DSA:2.80.10.50:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170136, NULL, 'G3DSA:3.20.20.70:FF:000531', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170137, NULL, 'G3DSA:3.30.540.10:FF:000041', NULL, NULL, 'inositol polyphosphate 1-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(170138, NULL, 'G3DSA:3.40.50.10810:FF:000272', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170139, NULL, 'G3DSA:2.60.120.340:FF:000017', NULL, NULL, 'Nucleophosmin (Nucleolar phosphoprotein B23, numatrin)', NULL, NULL, NULL, NULL, NULL, 4),
(170140, NULL, 'G3DSA:3.40.630.30:FF:000501', NULL, NULL, 'Hypothetical conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(170141, NULL, 'G3DSA:3.40.50.1240:FF:000100', NULL, NULL, '6-phosphofructo-2-kinase/fructose-2,6-biphosphata se-1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(170142, NULL, 'G3DSA:2.60.20.10:FF:000008', NULL, NULL, 'very large A-kinase anchor protein', NULL, NULL, NULL, NULL, NULL, 4),
(170143, NULL, 'G3DSA:3.20.20.70:FF:000677', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170144, NULL, 'G3DSA:2.60.120.330:FF:000014', NULL, NULL, 'Gibberellin 2-beta-dioxygenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(170145, NULL, 'G3DSA:3.40.50.20:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170146, NULL, 'G3DSA:3.40.50.300:FF:002410', NULL, NULL, 'YML133C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(170147, NULL, 'G3DSA:2.40.37.10:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170148, NULL, 'G3DSA:3.60.20.10:FF:000085', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(170149, NULL, 'G3DSA:3.10.105.10:FF:000113', NULL, NULL, 'ABC-type dipeptide/oligopeptide transport system, probable periplasmic component', NULL, NULL, NULL, NULL, NULL, 4),
(170150, NULL, 'G3DSA:1.20.120.160:FF:000029', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(170151, NULL, 'G3DSA:1.10.533.10:FF:000020', NULL, NULL, 'CASP8 and FADD like apoptosis regulator', NULL, NULL, NULL, NULL, NULL, 4),
(170152, NULL, 'G3DSA:1.25.10.10:FF:001827', NULL, NULL, 'Importin 8', NULL, NULL, NULL, NULL, NULL, 4),
(170153, NULL, 'G3DSA:1.10.10.60:FF:001258', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170154, NULL, 'G3DSA:2.10.220.10:FF:000019', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 6', NULL, NULL, NULL, NULL, NULL, 4),
(170155, NULL, 'G3DSA:2.60.34.10:FF:000130', NULL, NULL, 'Heat shock protein family A (Hsp70) member 9', NULL, NULL, NULL, NULL, NULL, 4),
(170156, NULL, 'G3DSA:3.20.20.80:FF:000534', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(170157, NULL, 'G3DSA:2.130.10.10:FF:000605', NULL, NULL, 'Transducin beta-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(170158, NULL, 'G3DSA:1.10.260.30:FF:000009', NULL, NULL, 'Putative signal peptide binding domain protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(170159, NULL, 'G3DSA:2.60.40.60:FF:000125', NULL, NULL, 'Neural-cadherin', NULL, NULL, NULL, NULL, NULL, 4),
(170160, NULL, 'G3DSA:2.60.120.320:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170161, NULL, 'G3DSA:3.90.70.10:FF:000406', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(170162, NULL, 'G3DSA:1.10.533.10:FF:000109', NULL, NULL, 'GG10810', NULL, NULL, NULL, NULL, NULL, 4),
(170163, NULL, 'G3DSA:3.30.160.60:FF:003691', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170164, NULL, 'G3DSA:2.30.29.30:FF:000867', NULL, NULL, 'PH domain protein (AFU_orthologue AFUA_3G13830)', NULL, NULL, NULL, NULL, NULL, 4),
(170165, NULL, 'G3DSA:3.40.50.1820:FF:000268', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(170166, NULL, 'G3DSA:3.90.1150.10:FF:000497', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170167, NULL, 'G3DSA:3.40.50.1000:FF:000202', NULL, NULL, 'Cation transporting P-ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(170168, NULL, 'G3DSA:2.60.120.10:FF:000815', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170169, NULL, 'G3DSA:1.10.10.2480:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170170, NULL, 'G3DSA:1.10.575.10:FF:000009', NULL, NULL, 'Phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(170171, NULL, 'G3DSA:3.30.710.10:FF:000487', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170172, NULL, 'G3DSA:3.40.1000.10:FF:000014', NULL, NULL, 'Nuclear import protein MOG1', NULL, NULL, NULL, NULL, NULL, 4),
(170173, NULL, 'G3DSA:2.30.29.30:FF:000928', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170174, NULL, 'G3DSA:3.30.1390.20:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170175, NULL, 'G3DSA:3.30.420.10:FF:000740', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170176, NULL, 'G3DSA:2.130.10.10:FF:005782', NULL, NULL, 'Zgc:77560', NULL, NULL, NULL, NULL, NULL, 4),
(170177, NULL, 'G3DSA:3.40.50.300:FF:001483', NULL, NULL, 'Small GTP-binding protein Rab1', NULL, NULL, NULL, NULL, NULL, 4),
(170178, NULL, 'G3DSA:1.25.50.20:FF:000057', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(170179, NULL, 'G3DSA:3.40.50.1010:FF:000205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170180, NULL, 'G3DSA:3.90.570.10:FF:000001', NULL, NULL, 'Amyloid beta A4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(170181, NULL, 'G3DSA:2.40.20.10:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170182, NULL, 'G3DSA:3.30.160.60:FF:006271', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170183, NULL, 'G3DSA:3.40.1050.10:FF:000017', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(170184, NULL, 'G3DSA:2.60.40.150:FF:000125', NULL, NULL, 'Phosphatidylinositol-4-phosphate 3-kinase catalytic subunit type 2 gamma', NULL, NULL, NULL, NULL, NULL, 4),
(170185, NULL, 'G3DSA:3.40.50.10900:FF:000001', NULL, NULL, 'Proteasome assembly chaperone 2', NULL, NULL, NULL, NULL, NULL, 4),
(170186, NULL, 'G3DSA:3.60.20.40:FF:000043', NULL, NULL, 'Gamma glutamyl transpeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(170187, NULL, 'G3DSA:2.60.40.10:FF:000627', NULL, NULL, 'Nectin cell adhesion molecule 4', NULL, NULL, NULL, NULL, NULL, 4),
(170188, NULL, 'G3DSA:3.30.2160.10:FF:000005', NULL, NULL, 'E3 ubiquitin-protein ligase HECW2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(170189, NULL, 'G3DSA:3.40.1390.20:FF:000012', NULL, NULL, 'HPr kinase/phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(170190, NULL, 'G3DSA:3.10.100.10:FF:000271', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170191, NULL, 'G3DSA:2.60.40.60:FF:000064', NULL, NULL, 'FAT atypical cadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(170192, NULL, 'G3DSA:3.40.50.1000:FF:000820', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170193, NULL, 'G3DSA:1.10.455.10:FF:000001', NULL, NULL, '30S ribosomal protein S7', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(170194, NULL, 'G3DSA:3.80.10.10:FF:003091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170195, NULL, 'G3DSA:3.40.50.300:FF:006215', NULL, NULL, 'Uncharacterized protein MJ0325', NULL, NULL, NULL, NULL, NULL, 4),
(170196, NULL, 'G3DSA:3.30.160.60:FF:005248', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170197, NULL, 'G3DSA:1.10.510.10:FF:002193', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(170198, NULL, 'G3DSA:2.120.10.80:FF:000340', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170199, NULL, 'G3DSA:1.10.238.10:FF:000143', NULL, NULL, 'probable calcium-binding protein CML13', NULL, NULL, NULL, NULL, NULL, 4),
(170200, NULL, 'G3DSA:1.25.40.10:FF:005045', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g39530', NULL, NULL, NULL, NULL, NULL, 4),
(170201, NULL, 'G3DSA:1.10.150.20:FF:000178', NULL, NULL, 'DNA-directed RNA polymerase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(170202, NULL, 'G3DSA:1.20.960.40:FF:000001', NULL, NULL, 'FGFR1 oncogene partner', NULL, NULL, NULL, NULL, NULL, 4),
(170203, NULL, 'G3DSA:1.10.275.10:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170204, NULL, 'G3DSA:3.30.70.330:FF:000250', NULL, NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(170205, NULL, 'G3DSA:3.40.1350.10:FF:000001', NULL, NULL, 'tRNA-splicing endonuclease subunit Sen2', NULL, NULL, NULL, NULL, NULL, 4),
(170206, NULL, 'G3DSA:1.20.1070.10:FF:002138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170207, NULL, 'G3DSA:3.30.40.10:FF:001262', NULL, NULL, 'YALI0F18634p', NULL, NULL, NULL, NULL, NULL, 4),
(170208, NULL, 'G3DSA:1.10.533.10:FF:000227', NULL, NULL, 'Si:dkey-61p9.9', NULL, NULL, NULL, NULL, NULL, 4),
(170209, NULL, 'G3DSA:3.40.1160.10:FF:000054', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(170210, NULL, 'G3DSA:1.25.40.20:FF:000023', NULL, NULL, 'short transient receptor potential channel 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(170211, NULL, 'G3DSA:3.40.50.300:FF:003399', NULL, NULL, 'Bifunctional polynucleotide phosphatase/kinase', NULL, NULL, NULL, NULL, NULL, 4),
(170212, NULL, 'G3DSA:3.30.420.10:FF:000622', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170213, NULL, 'G3DSA:2.60.120.290:FF:000098', NULL, NULL, 'AAEL003472-PA', NULL, NULL, NULL, NULL, NULL, 4),
(170214, NULL, 'G3DSA:1.20.1740.10:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170215, NULL, 'G3DSA:2.160.10.10:FF:000008', NULL, NULL, 'Maltose O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(170216, NULL, 'G3DSA:1.25.40.10:FF:000020', NULL, NULL, 'Stress-induced phosphoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(170217, NULL, 'G3DSA:3.40.50.150:FF:001269', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170218, NULL, 'G3DSA:1.10.630.10:FF:000459', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170219, NULL, 'G3DSA:3.40.30.10:FF:000721', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170220, NULL, 'G3DSA:1.10.601.10:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170221, NULL, 'G3DSA:2.10.70.10:FF:000070', NULL, NULL, 'Complement C3d receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(170222, NULL, 'G3DSA:3.30.70.330:FF:002925', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170223, NULL, 'G3DSA:3.30.710.10:FF:000369', NULL, NULL, 'BTB/POZ domain-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(170224, NULL, 'G3DSA:3.90.190.10:FF:000129', NULL, NULL, 'Dual specificity protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(170225, NULL, 'G3DSA:1.10.1410.10:FF:000014', NULL, NULL, 'U3 small nucleolar RNA-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(170226, NULL, 'G3DSA:3.40.50.300:FF:007553', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170227, NULL, 'G3DSA:3.40.30.10:FF:000103', NULL, NULL, '28S ribosomal protein S25, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(170228, NULL, 'G3DSA:3.30.1300.10:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170229, NULL, 'G3DSA:2.40.10.10:FF:000525', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170230, NULL, 'G3DSA:2.30.30.140:FF:000273', NULL, NULL, 'Retinoblastoma-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(170231, NULL, 'G3DSA:3.40.50.1820:FF:000886', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(170232, NULL, 'G3DSA:2.60.200.20:FF:000206', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(170233, NULL, 'G3DSA:3.40.30.10:FF:000367', NULL, NULL, 'Glutaredoxin 1', NULL, NULL, NULL, NULL, NULL, 4),
(170234, NULL, 'G3DSA:1.10.238.10:FF:001278', NULL, NULL, 'Troponin C', NULL, NULL, NULL, NULL, NULL, 4),
(170235, NULL, 'G3DSA:3.10.130.10:FF:000008', NULL, NULL, 'Liver ribonuclease A', NULL, NULL, NULL, NULL, NULL, 4),
(170236, NULL, 'G3DSA:1.10.287.950:FF:000043', NULL, NULL, 'Laminin subunit alpha-1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(170237, NULL, 'G3DSA:2.60.120.10:FF:000579', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(170238, NULL, 'G3DSA:3.20.20.80:FF:000798', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170239, NULL, 'G3DSA:3.30.160.60:FF:003803', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170240, NULL, 'G3DSA:3.30.559.10:FF:000179', NULL, NULL, 'HC-toxin synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(170241, NULL, 'G3DSA:4.10.1000.10:FF:000026', NULL, NULL, 'Zinc finger CCCH domain-containing protein 11A', NULL, NULL, NULL, NULL, NULL, 4),
(170242, NULL, 'G3DSA:3.20.20.220:FF:000035', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(170243, NULL, 'G3DSA:3.10.250.10:FF:000074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170244, NULL, 'G3DSA:3.20.20.70:FF:000177', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(170245, NULL, 'G3DSA:3.80.10.10:FF:000538', NULL, NULL, 'Si:ch211-127b6.2', NULL, NULL, NULL, NULL, NULL, 4),
(170246, NULL, 'G3DSA:2.40.160.120:FF:000020', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(170247, NULL, 'G3DSA:1.25.40.10:FF:000110', NULL, NULL, 'Peroxisome biogenesis protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(170248, NULL, 'G3DSA:1.25.10.10:FF:001620', NULL, NULL, 'Importin 11', NULL, NULL, NULL, NULL, NULL, 4),
(170249, NULL, 'G3DSA:3.30.160.60:FF:000223', NULL, NULL, 'zinc finger protein 64 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(170250, NULL, 'G3DSA:1.10.287.810:FF:000018', NULL, NULL, 'Mitochondrial import inner membrane translocase subunit tim-10', NULL, NULL, NULL, NULL, NULL, 4),
(170251, NULL, 'G3DSA:1.10.510.10:FF:002136', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(170252, NULL, 'G3DSA:3.30.750.24:FF:000177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170253, NULL, 'G3DSA:3.40.50.2300:FF:001093', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170254, NULL, 'G3DSA:3.40.50.300:FF:007289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170255, NULL, 'G3DSA:3.90.550.10:FF:000202', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase 6', NULL, NULL, NULL, NULL, NULL, 4),
(170256, NULL, 'G3DSA:3.30.930.10:FF:000352', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170257, NULL, 'G3DSA:3.40.50.1820:FF:001460', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170258, NULL, 'G3DSA:3.40.33.10:FF:000020', NULL, NULL, 'Pathogenesis-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(170259, NULL, 'G3DSA:3.30.160.60:FF:001448', NULL, NULL, 'Zinc finger and BTB domain containing 7a', NULL, NULL, NULL, NULL, NULL, 4),
(170260, NULL, 'G3DSA:1.10.630.10:FF:000369', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170261, NULL, 'G3DSA:3.40.395.10:FF:000037', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170262, NULL, 'G3DSA:3.40.50.450:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(170263, NULL, 'G3DSA:3.30.40.10:FF:000688', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(170264, NULL, 'G3DSA:2.40.420.20:FF:000025', NULL, NULL, 'Cation efflux system protein', NULL, NULL, NULL, NULL, NULL, 4),
(170265, NULL, 'G3DSA:1.10.1580.10:FF:000026', NULL, NULL, 'YALI0E01760p', NULL, NULL, NULL, NULL, NULL, 4),
(170266, NULL, 'G3DSA:1.10.565.10:FF:000037', NULL, NULL, 'Hormone receptor 3, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(170267, NULL, 'G3DSA:1.10.630.10:FF:000723', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170268, NULL, 'G3DSA:2.60.40.10:FF:004989', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170269, NULL, 'G3DSA:3.40.50.1820:FF:001403', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170270, NULL, 'G3DSA:3.80.10.10:FF:002837', NULL, NULL, 'Probable inactive receptor kinase At5g67200', NULL, NULL, NULL, NULL, NULL, 4),
(170271, NULL, 'G3DSA:2.40.30.10:FF:000173', NULL, NULL, 'Selenocysteine-specific elongation factor selB', NULL, NULL, NULL, NULL, NULL, 4),
(170272, NULL, 'G3DSA:4.10.49.10:FF:000004', NULL, NULL, 'Related to COX8-cytochrome-c oxidase chain VIII', NULL, NULL, NULL, NULL, NULL, 4),
(170273, NULL, 'G3DSA:1.10.510.10:FF:001939', NULL, NULL, 'Os05g0270875 protein', NULL, NULL, NULL, NULL, NULL, 4),
(170274, NULL, 'G3DSA:1.25.10.10:FF:001474', NULL, NULL, 'Splicing factor 3B subunit 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(170275, NULL, 'G3DSA:3.30.450.50:FF:000057', NULL, NULL, 'Putative synaptobrevin homolog YKT6', NULL, NULL, NULL, NULL, NULL, 4),
(170276, NULL, 'G3DSA:1.25.40.20:FF:001866', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(170277, NULL, 'G3DSA:3.30.450.30:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170278, NULL, 'G3DSA:1.10.286.30:FF:000001', NULL, NULL, 'Baseplate wedge completion tail pin', NULL, NULL, NULL, NULL, NULL, 4),
(170279, NULL, 'G3DSA:1.10.287.110:FF:000084', NULL, NULL, 'chaperone protein dnaJ 8, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(170280, NULL, 'G3DSA:2.10.25.10:FF:000847', NULL, NULL, 'Faulty attraction, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(170281, NULL, 'G3DSA:2.60.120.970:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170282, NULL, 'G3DSA:3.90.70.10:FF:000053', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(170283, NULL, 'G3DSA:3.40.50.11660:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170284, NULL, 'G3DSA:3.50.50.60:FF:001153', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(170285, NULL, 'G3DSA:2.60.40.10:FF:002426', NULL, NULL, 'Immunoglobulin heavy variable V15-2', NULL, NULL, NULL, NULL, NULL, 4),
(170286, NULL, 'G3DSA:1.25.10.10:FF:000900', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170287, NULL, 'G3DSA:2.40.50.140:FF:001039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170288, NULL, 'G3DSA:1.20.1740.10:FF:000256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170289, NULL, 'G3DSA:3.40.50.300:FF:000673', NULL, NULL, 'Origin recognition complex subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(170290, NULL, 'G3DSA:3.30.70.100:FF:000024', NULL, NULL, 'Mechanosensitive ion channel family protein', NULL, NULL, NULL, NULL, NULL, 4),
(170291, NULL, 'G3DSA:1.20.1250.20:FF:001019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170292, NULL, 'G3DSA:1.10.10.10:FF:000220', NULL, NULL, 'SAM pointed domain-containing Ets transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(170293, NULL, 'G3DSA:1.10.1040.30:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170294, NULL, 'G3DSA:2.40.30.20:FF:000029', NULL, NULL, 'Riboflavin synthase alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(170295, NULL, 'G3DSA:3.30.160.60:FF:005809', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(170296, NULL, 'G3DSA:1.25.40.70:FF:000021', NULL, NULL, 'PI-3 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(170297, NULL, 'G3DSA:1.10.238.10:FF:000704', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170298, NULL, 'G3DSA:3.30.160.60:FF:005866', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170299, NULL, 'G3DSA:3.40.50.720:FF:000529', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(170300, NULL, 'G3DSA:3.90.1200.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170301, NULL, 'G3DSA:4.10.970.10:FF:000012', NULL, NULL, 'DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(170302, NULL, 'G3DSA:2.30.29.30:FF:001272', NULL, NULL, 'PH domain-containing protein DDB_G0287875', NULL, NULL, NULL, NULL, NULL, 4),
(170303, NULL, 'G3DSA:1.10.510.10:FF:003682', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170304, NULL, 'G3DSA:3.50.30.30:FF:000119', NULL, NULL, 'Glr2658 protein', NULL, NULL, NULL, NULL, NULL, 4),
(170305, NULL, 'G3DSA:1.20.920.10:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170306, NULL, 'G3DSA:3.30.420.10:FF:000476', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170307, NULL, 'G3DSA:2.60.120.200:FF:000498', NULL, NULL, 'Adhesion G protein-coupled receptor G6', NULL, NULL, NULL, NULL, NULL, 4),
(170308, NULL, 'G3DSA:1.10.10.790:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170309, NULL, 'G3DSA:3.50.80.20:FF:000002', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase dacB', NULL, NULL, NULL, NULL, NULL, 4),
(170310, NULL, 'G3DSA:3.30.930.10:FF:000088', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(170311, NULL, 'G3DSA:1.25.40.10:FF:004325', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170312, NULL, 'G3DSA:3.30.450.40:FF:000054', NULL, NULL, 'Diguanylate cyclase (GGDEF) domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(170313, NULL, 'G3DSA:3.30.565.10:FF:000036', NULL, NULL, 'Sensor histidine kinase YpdA', NULL, NULL, NULL, NULL, NULL, 4),
(170314, NULL, 'G3DSA:3.80.10.10:FF:002129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170315, NULL, 'G3DSA:3.40.50.620:FF:000797', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170316, NULL, 'G3DSA:1.10.510.10:FF:002400', NULL, NULL, 'CAMKK1 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(170317, NULL, 'G3DSA:3.30.70.1060:FF:000003', NULL, NULL, 'Possible muconolactone isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(170318, NULL, 'G3DSA:1.20.1070.10:FF:000547', NULL, NULL, 'urotensin-2 receptor-like', NULL, NULL, NULL, NULL, NULL, 4),
(170319, NULL, 'G3DSA:3.40.50.1980:FF:000063', NULL, NULL, 'Periplasmic chelated iron-binding protein YfeA', NULL, NULL, NULL, NULL, NULL, 4),
(170320, NULL, 'G3DSA:3.40.50.300:FF:004416', NULL, NULL, 'Ras-related protein Rab-1B', NULL, NULL, NULL, NULL, NULL, 4),
(170321, NULL, 'G3DSA:3.30.2020.30:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170322, NULL, 'G3DSA:3.30.70.1070:FF:000006', NULL, NULL, 'Cell division protein', NULL, NULL, NULL, NULL, NULL, 4),
(170323, NULL, 'G3DSA:3.40.50.300:FF:000055', NULL, NULL, 'GTP-binding protein TypA', NULL, NULL, NULL, NULL, NULL, 4),
(170324, NULL, 'G3DSA:3.40.50.300:FF:005698', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170325, NULL, 'G3DSA:3.40.120.10:FF:000024', NULL, NULL, 'Phosphoglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(170326, NULL, 'G3DSA:2.130.10.10:FF:004759', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170327, NULL, 'G3DSA:1.25.10.10:FF:003065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170328, NULL, 'G3DSA:3.90.230.10:FF:000009', NULL, NULL, 'xaa-Pro aminopeptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(170329, NULL, 'G3DSA:3.90.226.10:FF:000112', NULL, NULL, '6-oxocyclohex-1-ene-1-carbonyl-CoA hydrolase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(170330, NULL, 'G3DSA:3.40.50.300:FF:002000', NULL, NULL, 'Putative heat shock protein', NULL, NULL, NULL, NULL, NULL, 4),
(170331, NULL, 'G3DSA:1.50.40.10:FF:000282', NULL, NULL, 'Transporter of the mitochondrial inner membrane, putative', NULL, NULL, NULL, NULL, NULL, 4),
(170332, NULL, 'G3DSA:1.10.437.10:FF:000015', NULL, NULL, 'BCL2 like 13', NULL, NULL, NULL, NULL, NULL, 4),
(170333, NULL, 'G3DSA:3.20.70.20:FF:000008', NULL, NULL, 'Hypothetical formate acetyltransferase 3', NULL, NULL, NULL, NULL, NULL, 4),
(170334, NULL, 'G3DSA:3.40.50.300:FF:002264', NULL, NULL, 'Clp1-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(170335, NULL, 'G3DSA:3.30.160.60:FF:000313', NULL, NULL, 'Zinc finger protein 281', NULL, NULL, NULL, NULL, NULL, 4),
(170336, NULL, 'G3DSA:3.40.50.300:FF:002207', NULL, NULL, 'ATP-dependent Clp protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(170337, NULL, 'G3DSA:3.30.70.3400:FF:000020', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(170338, NULL, 'G3DSA:2.170.150.80:FF:000025', NULL, NULL, 'NAC domain-containing protein 73', NULL, NULL, NULL, NULL, NULL, 4),
(170339, NULL, 'G3DSA:1.10.1170.10:FF:000006', NULL, NULL, 'Baculoviral IAP repeat containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(170340, NULL, 'G3DSA:2.10.80.10:FF:000008', NULL, NULL, 'Dickkopf WNT-signaling pathway inhibitor 3a', NULL, NULL, NULL, NULL, NULL, 4),
(170341, NULL, 'G3DSA:3.10.150.10:FF:000010', NULL, NULL, 'Proliferating cell nuclear antigen', NULL, NULL, NULL, NULL, NULL, 4),
(170342, NULL, 'G3DSA:2.60.40.1120:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170343, NULL, 'G3DSA:1.25.40.860:FF:000023', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(170344, NULL, 'G3DSA:3.40.630.30:FF:000355', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(170345, NULL, 'G3DSA:1.20.58.60:FF:000575', NULL, NULL, 'Vab-10', NULL, NULL, NULL, NULL, NULL, 4),
(170346, NULL, 'G3DSA:1.10.8.60:FF:000262', NULL, NULL, '26S protease regulatory subunit 6A', NULL, NULL, NULL, NULL, NULL, 4),
(170347, NULL, 'G3DSA:3.30.450.210:FF:000002', NULL, NULL, 'Sensor protein CpxA', NULL, NULL, NULL, NULL, NULL, 4),
(170348, NULL, 'G3DSA:3.40.50.300:FF:007643', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170349, NULL, 'G3DSA:1.10.357.10:FF:000014', NULL, NULL, 'Transcriptional regulator, TetR family', NULL, NULL, NULL, NULL, NULL, 4),
(170350, NULL, 'G3DSA:3.40.50.12650:FF:000037', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170351, NULL, 'G3DSA:3.40.950.10:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170352, NULL, 'G3DSA:3.40.50.150:FF:000605', NULL, NULL, 'Os06g0322400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(170353, NULL, 'G3DSA:1.10.1200.10:FF:000061', NULL, NULL, 'Putative acyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(170354, NULL, 'G3DSA:3.90.550.10:FF:000090', NULL, NULL, 'Alpha-1,3-mannosyl-glycoprotein 2-beta-N-acetylglucosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(170355, NULL, 'G3DSA:1.25.40.10:FF:001863', NULL, NULL, 'Coatomer subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(170356, NULL, 'G3DSA:1.10.357.20:FF:000017', NULL, NULL, 'Solute carrier family 41 member 2', NULL, NULL, NULL, NULL, NULL, 4),
(170357, NULL, 'G3DSA:1.20.990.10:FF:000045', NULL, NULL, 'Pyruvate:ferredoxin oxidoreductase/NADPH-cytochrome P450 reductase PNO', NULL, NULL, NULL, NULL, NULL, 4),
(170358, NULL, 'G3DSA:1.20.1250.40:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170359, NULL, 'G3DSA:3.40.50.1820:FF:001049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170360, NULL, 'G3DSA:3.80.30.20:FF:000020', NULL, NULL, 'tRNA 2-methylthioadenosine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(170361, NULL, 'G3DSA:3.80.10.10:FF:002747', NULL, NULL, 'Glucose-induced repressor, putative', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(170362, NULL, 'G3DSA:3.40.1190.20:FF:000148', NULL, NULL, 'Ribokinase', NULL, NULL, NULL, NULL, NULL, 4),
(170363, NULL, 'G3DSA:1.10.20.10:FF:000221', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170364, NULL, 'G3DSA:2.130.10.10:FF:000049', NULL, NULL, 'DDB1-and CUL4-associated factor 7', NULL, NULL, NULL, NULL, NULL, 4),
(170365, NULL, 'G3DSA:3.90.550.10:FF:000174', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(170366, NULL, 'G3DSA:2.40.50.140:FF:000758', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170367, NULL, 'G3DSA:2.60.40.60:FF:000002', NULL, NULL, 'Protocadherin alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(170368, NULL, 'G3DSA:3.30.40.10:FF:001380', NULL, NULL, 'DNA-binding E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(170369, NULL, 'G3DSA:3.60.21.10:FF:000429', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170370, NULL, 'G3DSA:2.60.40.730:FF:000001', NULL, NULL, 'Desulfoferrodoxin', NULL, NULL, NULL, NULL, NULL, 4),
(170371, NULL, 'G3DSA:2.30.29.30:FF:000367', NULL, NULL, 'Neutral sphingomyelinase activation associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(170372, NULL, 'G3DSA:3.30.200.20:FF:001811', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170373, NULL, 'G3DSA:3.30.40.10:FF:000918', NULL, NULL, 'E3 ubiquitin-protein ligase EL5', NULL, NULL, NULL, NULL, NULL, 4),
(170374, NULL, 'G3DSA:3.30.450.20:FF:000368', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170375, NULL, 'G3DSA:1.25.10.10:FF:000338', NULL, NULL, 'Anaphase-promoting complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(170376, NULL, 'G3DSA:1.20.1250.20:FF:001076', NULL, NULL, 'Bypass of stop codon protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(170377, NULL, 'G3DSA:1.25.40.10:FF:001947', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170378, NULL, 'G3DSA:4.10.240.10:FF:000092', NULL, NULL, 'Aflatoxin regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(170379, NULL, 'G3DSA:2.60.120.10:FF:000372', NULL, NULL, 'Transcriptional regulator, Crp/Fnr family', NULL, NULL, NULL, NULL, NULL, 4),
(170380, NULL, 'G3DSA:3.90.79.20:FF:000019', NULL, NULL, 'NUDIX hydrolase domain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(170381, NULL, 'G3DSA:3.30.200.20:FF:001165', NULL, NULL, 'Kinase, AGC PKA', NULL, NULL, NULL, NULL, NULL, 4),
(170382, NULL, 'G3DSA:4.10.280.10:FF:000156', NULL, NULL, 'Myogenic determination factor', NULL, NULL, NULL, NULL, NULL, 4),
(170383, NULL, 'G3DSA:1.20.272.10:FF:000028', NULL, NULL, 'Replication factor C subunit 2/4', NULL, NULL, NULL, NULL, NULL, 4),
(170384, NULL, 'G3DSA:3.40.50.1000:FF:000112', NULL, NULL, 'CTD small phosphatase-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(170385, NULL, 'G3DSA:3.40.50.1010:FF:000115', NULL, NULL, 'Mitotic control protein dis3', NULL, NULL, NULL, NULL, NULL, 4),
(170386, NULL, 'G3DSA:3.30.70.330:FF:002987', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170387, NULL, 'G3DSA:1.20.1250.10:FF:000084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170388, NULL, 'G3DSA:1.20.1720.10:FF:000047', NULL, NULL, 'Major facilitator superfamily (MFS) transporter', NULL, NULL, NULL, NULL, NULL, 4),
(170389, NULL, 'G3DSA:3.40.50.450:FF:000044', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(170390, NULL, 'G3DSA:3.30.160.60:FF:002084', NULL, NULL, 'RB-associated KRAB zinc finger protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(170391, NULL, 'G3DSA:1.25.40.180:FF:000156', NULL, NULL, 'MIF4G domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(170392, NULL, 'G3DSA:3.30.200.20:FF:000232', NULL, NULL, 'Serine/threonine-protein kinase pim-1', NULL, NULL, NULL, NULL, NULL, 4),
(170393, NULL, 'G3DSA:1.10.1760.20:FF:000009', NULL, NULL, 'Riboflavin transporter', NULL, NULL, NULL, NULL, NULL, 4),
(170394, NULL, 'G3DSA:3.90.470.20:FF:000030', NULL, NULL, '4''phosphopantetheinyl transferase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(170395, NULL, 'G3DSA:1.20.5.340:FF:000051', NULL, NULL, 'Rabaptin, RAB GTPase binding effector protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(170396, NULL, 'G3DSA:1.25.40.10:FF:001419', NULL, NULL, 'Yop proteins translocation protein Y', NULL, NULL, NULL, NULL, NULL, 4),
(170397, NULL, 'G3DSA:2.130.10.10:FF:000105', NULL, NULL, 'Protein HIRA', NULL, NULL, NULL, NULL, NULL, 4),
(170398, NULL, 'G3DSA:1.10.1760.10:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170399, NULL, 'G3DSA:1.20.1250.20:FF:000087', NULL, NULL, 'L-fucose:H+ symporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(170400, NULL, 'G3DSA:2.60.40.3170:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170401, NULL, 'G3DSA:3.40.50.10090:FF:000039', NULL, NULL, 'Uroporphyrinogen-III C-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(170402, NULL, 'G3DSA:3.30.70.330:FF:000896', NULL, NULL, 'RNA-binding protein with serine-rich domain 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(170403, NULL, 'G3DSA:2.10.290.10:FF:000001', NULL, NULL, 'PF07191 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(170404, NULL, 'G3DSA:3.60.130.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170405, NULL, 'G3DSA:3.40.50.1820:FF:000824', NULL, NULL, 'Poly(3-hydroxyalkanoate) depolymerase', NULL, NULL, NULL, NULL, NULL, 4),
(170406, NULL, 'G3DSA:1.10.510.10:FF:001557', NULL, NULL, 'Protein CBG13435', NULL, NULL, NULL, NULL, NULL, 4),
(170407, NULL, 'G3DSA:1.20.1280.50:FF:000081', NULL, NULL, 'Unplaced genomic scaffold supercont1.10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(170408, NULL, 'G3DSA:3.40.50.150:FF:001533', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170409, NULL, 'G3DSA:2.130.10.10:FF:006035', NULL, NULL, 'Centriole proteome protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(170410, NULL, 'G3DSA:3.40.50.300:FF:003484', NULL, NULL, 'Dynamin central region family protein', NULL, NULL, NULL, NULL, NULL, 4),
(170411, NULL, 'G3DSA:2.60.40.10:FF:003646', NULL, NULL, 'GM20392', NULL, NULL, NULL, NULL, NULL, 4),
(170412, NULL, 'G3DSA:2.60.40.10:FF:000127', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(170413, NULL, 'G3DSA:1.10.10.60:FF:000038', NULL, NULL, 'Homeobox-containing protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(170414, NULL, 'G3DSA:3.20.20.190:FF:000155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170415, NULL, 'G3DSA:3.40.50.300:FF:002702', NULL, NULL, 'Ras-related protein RABA5d', NULL, NULL, NULL, NULL, NULL, 4),
(170416, NULL, 'G3DSA:3.30.160.270:FF:000010', NULL, NULL, '2-isopropylmalate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(170417, NULL, 'G3DSA:2.10.220.10:FF:000053', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(170418, NULL, 'G3DSA:1.10.3810.10:FF:000028', NULL, NULL, 'Penicillin binding protein transpeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(170419, NULL, 'G3DSA:3.30.160.60:FF:006355', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170420, NULL, 'G3DSA:2.130.10.10:FF:001679', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170421, NULL, 'G3DSA:1.50.40.10:FF:000338', NULL, NULL, 'Carnitine-acylcarnitine carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(170422, NULL, 'G3DSA:1.20.58.60:FF:000783', NULL, NULL, 'Dystonin', NULL, NULL, NULL, NULL, NULL, 4),
(170423, NULL, 'G3DSA:3.40.50.150:FF:001477', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170424, NULL, 'G3DSA:1.10.10.60:FF:001292', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170425, NULL, 'G3DSA:1.25.40.470:FF:000029', NULL, NULL, 'Intraflagellar transport protein 122', NULL, NULL, NULL, NULL, NULL, 4),
(170426, NULL, 'G3DSA:3.30.1370.210:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170427, NULL, 'G3DSA:2.10.25.10:FF:001426', NULL, NULL, 'Multiple epidermal growth factor-like domains protein 8', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(170428, NULL, 'G3DSA:2.60.40.10:FF:001555', NULL, NULL, 'Protein tyrosine phosphatase, receptor type Q', NULL, NULL, NULL, NULL, NULL, 4),
(170429, NULL, 'G3DSA:1.10.10.41:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170430, NULL, 'G3DSA:1.10.10.10:FF:001647', NULL, NULL, 'Ferric uptake regulation protein', NULL, NULL, NULL, NULL, NULL, 4),
(170431, NULL, 'G3DSA:1.20.1640.10:FF:000046', NULL, NULL, 'Multidrug transporter AcrB', NULL, NULL, NULL, NULL, NULL, 4),
(170432, NULL, 'G3DSA:3.80.10.10:FF:000656', NULL, NULL, 'CG12283', NULL, NULL, NULL, NULL, NULL, 4),
(170433, NULL, 'G3DSA:1.10.630.10:FF:000195', NULL, NULL, 'Putative cytochrome P450 136', NULL, NULL, NULL, NULL, NULL, 4),
(170434, NULL, 'G3DSA:1.25.40.20:FF:000169', NULL, NULL, 'Cyclin-dependent kinase 4 inhibitor D', NULL, NULL, NULL, NULL, NULL, 4),
(170435, NULL, 'G3DSA:2.40.30.10:FF:000116', NULL, NULL, 'Elongation factor Tu', NULL, NULL, NULL, NULL, NULL, 4),
(170436, NULL, 'G3DSA:3.90.79.10:FF:000016', NULL, NULL, 'ADP-sugar pyrophosphatase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(170437, NULL, 'G3DSA:1.20.1280.50:FF:000018', NULL, NULL, 'F-box/LRR-repeat protein 7 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(170438, NULL, 'G3DSA:1.20.940.10:FF:000008', NULL, NULL, 'Related to potassium channel regulatory factor', NULL, NULL, NULL, NULL, NULL, 4),
(170439, NULL, 'G3DSA:1.20.1270.60:FF:000049', NULL, NULL, 'Sorting nexin 8', NULL, NULL, NULL, NULL, NULL, 4),
(170440, NULL, 'G3DSA:3.30.160.60:FF:004231', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170441, NULL, 'G3DSA:2.40.70.10:FF:000411', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170442, NULL, 'G3DSA:2.60.40.10:FF:002016', NULL, NULL, 'Immunoglobulin heavy constant alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(170443, NULL, 'G3DSA:4.10.280.10:FF:000212', NULL, NULL, 'Transcription factor DYT1', NULL, NULL, NULL, NULL, NULL, 4),
(170444, NULL, 'G3DSA:3.30.160.60:FF:002140', NULL, NULL, 'paternally-expressed gene 3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(170445, NULL, 'G3DSA:3.50.50.60:FF:001035', NULL, NULL, 'Probable lysine-specific histone demethylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(170446, NULL, 'G3DSA:3.40.50.720:FF:001108', NULL, NULL, 'Alanine dehydrogenase, truncation', NULL, NULL, NULL, NULL, NULL, 4),
(170447, NULL, 'G3DSA:3.60.20.10:FF:000175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170448, NULL, 'G3DSA:3.30.70.1730:FF:000047', NULL, NULL, '50S ribosomal protein L10', NULL, NULL, NULL, NULL, NULL, 4),
(170449, NULL, 'G3DSA:3.40.50.300:FF:002500', NULL, NULL, 'Ras-related protein Rap-2a', NULL, NULL, NULL, NULL, NULL, 4),
(170450, NULL, 'G3DSA:3.40.50.1820:FF:000768', NULL, NULL, 'Serine hydrolase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(170451, NULL, 'G3DSA:2.130.10.10:FF:003394', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170452, NULL, 'G3DSA:3.40.50.300:FF:006125', NULL, NULL, 'Retrovirus-related Pol polyprotein LINE-1', NULL, NULL, NULL, NULL, NULL, 4),
(170453, NULL, 'G3DSA:2.40.30.10:FF:000291', NULL, NULL, 'Mitochondrial tRNA-specific 2-thiouridylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(170454, NULL, 'G3DSA:3.30.460.10:FF:000186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170455, NULL, 'G3DSA:3.60.21.10:FF:000053', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(170456, NULL, 'G3DSA:1.10.510.10:FF:001883', NULL, NULL, 'Related to yeast Vacuolar Protein Sorting factor', NULL, NULL, NULL, NULL, NULL, 4),
(170457, NULL, 'G3DSA:1.20.58.340:FF:000056', NULL, NULL, 'Mitochondrial inner membrane magnesium transporter LPE10', NULL, NULL, NULL, NULL, NULL, 4),
(170458, NULL, 'G3DSA:3.80.10.10:FF:002545', NULL, NULL, 'Ubiquitin-like domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(170459, NULL, 'G3DSA:3.30.160.60:FF:001948', NULL, NULL, 'zinc finger and BTB domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(170460, NULL, 'G3DSA:3.30.450.20:FF:000694', NULL, NULL, 'Diguanylate cyclase with PAS sensory domain', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(170461, NULL, 'G3DSA:1.25.40.10:FF:002201', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170462, NULL, 'G3DSA:1.10.565.10:FF:000099', NULL, NULL, 'Nuclear hormone receptor family member nhr-6', NULL, NULL, NULL, NULL, NULL, 4),
(170463, NULL, 'G3DSA:1.10.720.30:FF:000028', NULL, NULL, 'Myocardin-related transcription factor, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(170464, NULL, 'G3DSA:3.30.200.20:FF:002469', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170465, NULL, 'G3DSA:2.60.40.420:FF:000167', NULL, NULL, 'Coagulation factor V', NULL, NULL, NULL, NULL, NULL, 4),
(170466, NULL, 'G3DSA:3.40.960.10:FF:000008', NULL, NULL, 'DEAD/DEAH box helicase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(170467, NULL, 'G3DSA:3.40.980.10:FF:000015', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(170468, NULL, 'G3DSA:1.20.120.1750:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170469, NULL, 'G3DSA:3.90.228.10:FF:000009', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(170470, NULL, 'G3DSA:3.40.50.2300:FF:001654', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170471, NULL, 'G3DSA:3.30.2010.30:FF:000001', NULL, NULL, 'Leukotriene A(4) hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(170472, NULL, 'G3DSA:1.20.5.110:FF:000038', NULL, NULL, 'BET1-like protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(170473, NULL, 'G3DSA:2.60.120.970:FF:000060', NULL, NULL, 'Bone morphogenetic protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(170474, NULL, 'G3DSA:1.10.287.600:FF:000017', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(170475, NULL, 'G3DSA:3.30.160.60:FF:000195', NULL, NULL, 'Hypermethylated in cancer 1 protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(170476, NULL, 'G3DSA:2.60.120.200:FF:000767', NULL, NULL, 'Calciumbinding protein Calnexin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(170477, NULL, 'G3DSA:2.60.40.10:FF:005563', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170478, NULL, 'G3DSA:3.40.50.300:FF:007227', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170479, NULL, 'G3DSA:1.20.5.100:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170480, NULL, 'G3DSA:2.40.50.140:FF:000022', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(170481, NULL, 'G3DSA:3.30.70.1620:FF:000014', NULL, NULL, 'Chromosome partition protein Smc', NULL, NULL, NULL, NULL, NULL, 4),
(170482, NULL, 'G3DSA:1.10.8.60:FF:000346', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170483, NULL, 'G3DSA:1.10.533.10:FF:000143', NULL, NULL, 'Caspase 8, apoptosis-related cysteine peptidase,-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(170484, NULL, 'G3DSA:1.10.510.10:FF:003974', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170485, NULL, 'G3DSA:1.10.287.70:FF:000397', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170486, NULL, 'G3DSA:1.25.40.10:FF:002083', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g16010', NULL, NULL, NULL, NULL, NULL, 4),
(170487, NULL, 'G3DSA:1.20.1070.10:FF:000991', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170488, NULL, 'G3DSA:3.70.10.10:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170489, NULL, 'G3DSA:3.40.50.720:FF:001434', NULL, NULL, 'Chorismate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(170490, NULL, 'G3DSA:1.25.40.20:FF:000113', NULL, NULL, 'E3 ubiquitin-protein ligase mib1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(170491, NULL, 'G3DSA:2.60.120.620:FF:000157', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170492, NULL, 'G3DSA:4.10.410.10:FF:000066', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170493, NULL, 'G3DSA:2.130.10.10:FF:000375', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(170494, NULL, 'G3DSA:3.20.20.190:FF:000099', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(170495, NULL, 'G3DSA:3.30.160.60:FF:003921', NULL, NULL, 'AGAP001525-PA', NULL, NULL, NULL, NULL, NULL, 4),
(170496, NULL, 'G3DSA:3.80.10.10:FF:003034', NULL, NULL, 'Antagonist of mitotic exit network 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(170497, NULL, 'G3DSA:2.60.120.290:FF:000070', NULL, NULL, 'Suppression of tumorigenicity 14b', NULL, NULL, NULL, NULL, NULL, 4),
(170498, NULL, 'G3DSA:3.40.50.1000:FF:000258', NULL, NULL, 'YER134C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(170499, NULL, 'G3DSA:3.30.870.10:FF:000060', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(170500, NULL, 'G3DSA:3.40.190.80:FF:000009', NULL, NULL, 'Fructose-1,6-bisphosphatase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(170501, NULL, 'G3DSA:2.60.40.10:FF:000251', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(170502, NULL, 'G3DSA:3.10.20.30:FF:000031', NULL, NULL, 'Mitochondrial ribosomal protein L39', NULL, NULL, NULL, NULL, NULL, 4),
(170503, NULL, 'G3DSA:3.90.650.10:FF:000058', NULL, NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase (AIRS) (PurM)', NULL, NULL, NULL, NULL, NULL, 4),
(170504, NULL, 'G3DSA:2.10.90.10:FF:000043', NULL, NULL, 'Neurotrophin 1, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(170505, NULL, 'G3DSA:3.30.420.40:FF:000136', NULL, NULL, 'Putative fructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(170506, NULL, 'G3DSA:2.130.10.10:FF:003450', NULL, NULL, 'Prp-8', NULL, NULL, NULL, NULL, NULL, 4),
(170507, NULL, 'G3DSA:3.30.160.60:FF:006029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170508, NULL, 'G3DSA:2.60.120.10:FF:000107', NULL, NULL, 'Potassium voltage-gated channel unc-103', NULL, NULL, NULL, NULL, NULL, 4),
(170509, NULL, 'G3DSA:3.40.30.10:FF:000283', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(170510, NULL, 'G3DSA:1.20.120.1880:FF:000018', NULL, NULL, 'Nucleoporin 155', NULL, NULL, NULL, NULL, NULL, 4),
(170511, NULL, 'G3DSA:1.10.10.10:FF:000012', NULL, NULL, 'U5 small nuclear ribonucleoprotein helicase', NULL, NULL, NULL, NULL, NULL, 4),
(170512, NULL, 'G3DSA:1.10.10.60:FF:000364', NULL, NULL, 'Propionate catabolism operon regulatory protein PrpR', NULL, NULL, NULL, NULL, NULL, 4),
(170513, NULL, 'G3DSA:1.25.40.10:FF:001099', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(170514, NULL, 'G3DSA:1.25.40.10:FF:003662', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170515, NULL, 'G3DSA:1.20.58.200:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170516, NULL, 'G3DSA:1.10.287.130:FF:000270', NULL, NULL, 'Sensory histidine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(170517, NULL, 'G3DSA:3.10.50.40:FF:000036', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(170518, NULL, 'G3DSA:1.20.1070.10:FF:000839', NULL, NULL, 'Purinergic receptor P2Y14', NULL, NULL, NULL, NULL, NULL, 4),
(170519, NULL, 'G3DSA:1.20.5.1430:FF:000016', NULL, NULL, 'Actin binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(170520, NULL, 'G3DSA:3.30.160.60:FF:006153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170521, NULL, 'G3DSA:1.10.555.10:FF:000183', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170522, NULL, 'G3DSA:1.10.1040.10:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170523, NULL, 'G3DSA:3.15.10.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170524, NULL, 'G3DSA:3.30.70.660:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170525, NULL, 'G3DSA:3.40.50.1820:FF:001134', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(170526, NULL, 'G3DSA:3.30.1240.10:FF:000068', NULL, NULL, 'Uncharacterized hydrolase C215.10', NULL, NULL, NULL, NULL, NULL, 4),
(170527, NULL, 'G3DSA:3.30.40.100:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170528, NULL, 'G3DSA:1.25.10.10:FF:001917', NULL, NULL, 'DDB1- and CUL4-associated factor homolog 1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(170529, NULL, 'G3DSA:3.30.830.10:FF:000260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170530, NULL, 'G3DSA:1.10.10.10:FF:002103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170531, NULL, 'G3DSA:3.30.160.60:FF:001297', NULL, NULL, 'Zinc finger and SCAN domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(170532, NULL, 'G3DSA:1.10.150.110:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170533, NULL, 'G3DSA:3.30.420.40:FF:000226', NULL, NULL, 'Chromatin remodeling complex subunit (Arp9), putative', NULL, NULL, NULL, NULL, NULL, 4),
(170534, NULL, 'G3DSA:3.90.190.10:FF:000039', NULL, NULL, 'receptor-type tyrosine-protein phosphatase O isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(170535, NULL, 'G3DSA:2.40.50.150:FF:000025', NULL, NULL, 'GH25170', NULL, NULL, NULL, NULL, NULL, 4),
(170536, NULL, 'G3DSA:2.170.270.10:FF:000120', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170537, NULL, 'G3DSA:1.10.150.240:FF:000106', NULL, NULL, 'Putative beta-phosphoglucomutase', NULL, NULL, NULL, NULL, NULL, 4),
(170538, NULL, 'G3DSA:1.20.1440.100:FF:000001', NULL, NULL, 'Inhibition of morphological differentiation protein', NULL, NULL, NULL, NULL, NULL, 4),
(170539, NULL, 'G3DSA:2.60.40.740:FF:000004', NULL, NULL, 'Collagen adhesin', NULL, NULL, NULL, NULL, NULL, 4),
(170540, NULL, 'G3DSA:3.40.50.300:FF:000229', NULL, NULL, 'Probable Ras-related protein Rab-6A', NULL, NULL, NULL, NULL, NULL, 4),
(170541, NULL, 'G3DSA:1.10.287.1490:FF:000043', NULL, NULL, 'WH2 motif domain contaning, putative', NULL, NULL, NULL, NULL, NULL, 4),
(170542, NULL, 'G3DSA:1.10.167.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170543, NULL, 'G3DSA:3.10.20.310:FF:000019', NULL, NULL, 'Protein TOC75-3, chloroplastic isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(170544, NULL, 'G3DSA:1.10.3500.10:FF:000016', NULL, NULL, 'Transcription accessory protein (S1 RNA-binding domain)', NULL, NULL, NULL, NULL, NULL, 4),
(170545, NULL, 'G3DSA:3.30.870.10:FF:000150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170546, NULL, 'G3DSA:3.40.30.10:FF:000603', NULL, NULL, 'Glutathione S-transferase Mu 1', NULL, NULL, NULL, NULL, NULL, 4),
(170547, NULL, 'G3DSA:1.25.10.10:FF:003357', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170548, NULL, 'G3DSA:1.10.510.10:FF:002344', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170549, NULL, 'G3DSA:3.30.930.10:FF:000144', NULL, NULL, 'Octanoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(170550, NULL, 'G3DSA:1.10.132.130:FF:000003', NULL, NULL, 'Legumain', NULL, NULL, NULL, NULL, NULL, 4),
(170551, NULL, 'G3DSA:3.30.30.170:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170552, NULL, 'G3DSA:1.25.10.10:FF:001266', NULL, NULL, 'Pumilio/PUF RNA binding protein 8, putative', NULL, NULL, NULL, NULL, NULL, 4),
(170553, NULL, 'G3DSA:3.40.850.10:FF:000388', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(170554, NULL, 'G3DSA:2.10.25.10:FF:000639', NULL, NULL, 'Notch 2', NULL, NULL, NULL, NULL, NULL, 4),
(170555, NULL, 'G3DSA:3.30.40.10:FF:001554', NULL, NULL, 'RING/U-box superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(170556, NULL, 'G3DSA:3.30.565.10:FF:000070', NULL, NULL, 'Sensor histidine kinase RstB', NULL, NULL, NULL, NULL, NULL, 4),
(170557, NULL, 'G3DSA:1.20.1250.20:FF:001020', NULL, NULL, 'AFR578Cp', NULL, NULL, NULL, NULL, NULL, 4),
(170558, NULL, 'G3DSA:2.130.10.10:FF:002320', NULL, NULL, 'Protein CBG05554', NULL, NULL, NULL, NULL, NULL, 4),
(170559, NULL, 'G3DSA:1.20.140.10:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170560, NULL, 'G3DSA:1.10.510.10:FF:004137', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170561, NULL, 'G3DSA:3.40.50.300:FF:003809', NULL, NULL, 'Dynein heavy chain 5, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(170562, NULL, 'G3DSA:3.30.710.10:FF:000077', NULL, NULL, 'transcriptional regulator Kaiso isoform X1', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(170563, NULL, 'G3DSA:3.30.160.60:FF:001976', NULL, NULL, 'Klumpfuss, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(170564, NULL, 'G3DSA:1.20.1250.20:FF:000738', NULL, NULL, 'Azole resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(170565, NULL, 'G3DSA:3.40.50.300:FF:004271', NULL, NULL, 'X-ray repair-complementing defective repair in Chinese hamster cells 3', NULL, NULL, NULL, NULL, NULL, 4),
(170566, NULL, 'G3DSA:2.130.10.10:FF:003596', NULL, NULL, 'GATOR complex protein MIOS', NULL, NULL, NULL, NULL, NULL, 4),
(170567, NULL, 'G3DSA:2.170.270.10:FF:000092', NULL, NULL, 'Pleiomorphic adenoma gene-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(170568, NULL, 'G3DSA:3.40.50.1780:FF:000031', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NAR1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(170569, NULL, 'G3DSA:3.30.160.60:FF:000700', NULL, NULL, 'zinc finger protein 346 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(170570, NULL, 'G3DSA:3.30.70.270:FF:000294', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170571, NULL, 'G3DSA:3.80.10.10:FF:002871', NULL, NULL, 'YALI0A17358p', NULL, NULL, NULL, NULL, NULL, 4),
(170572, NULL, 'G3DSA:2.20.25.100:FF:000006', NULL, NULL, '30S ribosomal protein S27e', NULL, NULL, NULL, NULL, NULL, 4),
(170573, NULL, 'G3DSA:3.40.140.10:FF:000210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170574, NULL, 'G3DSA:3.30.1330.30:FF:000081', NULL, NULL, 'TrmH family tRNA/rRNA methyltransferase YacO', NULL, NULL, NULL, NULL, NULL, 4),
(170575, NULL, 'G3DSA:3.90.660.10:FF:000093', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170576, NULL, 'G3DSA:2.30.30.40:FF:000148', NULL, NULL, 'Caspase recruitment domain family member 11', NULL, NULL, NULL, NULL, NULL, 4),
(170577, NULL, 'G3DSA:3.30.30.30:FF:000014', NULL, NULL, 'Chaperone protein DnaK', NULL, NULL, NULL, NULL, NULL, 4),
(170578, NULL, 'G3DSA:3.40.50.880:FF:000150', NULL, NULL, 'GMP synthase [glutamine-hydrolyzing] subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(170579, NULL, 'G3DSA:3.40.980.10:FF:000010', NULL, NULL, 'Phosphoadenosine phosphosulfate reductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(170580, NULL, 'G3DSA:3.30.2010.30:FF:000006', NULL, NULL, 'Aminopeptidase O', NULL, NULL, NULL, NULL, NULL, 4),
(170581, NULL, 'G3DSA:3.40.50.1100:FF:000086', NULL, NULL, 'Related to CYS4-cystathionine beta-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(170582, NULL, 'G3DSA:3.40.50.2300:FF:000103', NULL, NULL, 'DNA-binding response regulator PrrA', NULL, NULL, NULL, NULL, NULL, 4),
(170583, NULL, 'G3DSA:3.40.50.300:FF:000465', NULL, NULL, 'ATP-binding cassette, sub-family A (ABC1), member 3', NULL, NULL, NULL, NULL, NULL, 4),
(170584, NULL, 'G3DSA:2.30.29.30:FF:000491', NULL, NULL, 'Stress-activated map kinase interacting 1', NULL, NULL, NULL, NULL, NULL, 4),
(170585, NULL, 'G3DSA:2.40.240.10:FF:000014', NULL, NULL, 'bifunctional glutamate/proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(170586, NULL, 'G3DSA:3.40.50.300:FF:008542', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(170587, NULL, 'G3DSA:1.20.1310.10:FF:000055', NULL, NULL, 'Cullin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(170588, NULL, 'G3DSA:3.30.499.10:FF:000005', NULL, NULL, 'cytoplasmic aconitate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(170589, NULL, 'G3DSA:2.30.180.10:FF:000005', NULL, NULL, 'Stabilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(170590, NULL, 'G3DSA:1.25.40.10:FF:002111', NULL, NULL, 'Pentatricopeptide (PPR) repeat-containing protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(170591, NULL, 'G3DSA:3.40.50.1110:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170592, NULL, 'G3DSA:3.30.70.2820:FF:000003', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(170593, NULL, 'G3DSA:1.10.510.10:FF:001973', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170594, NULL, 'G3DSA:3.90.25.10:FF:000095', NULL, NULL, 'NmrA-like family domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(170595, NULL, 'G3DSA:3.80.10.10:FF:001112', NULL, NULL, 'Leucine rich repeat protein phosphatase 2c domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(170596, NULL, 'G3DSA:2.130.10.10:FF:000521', NULL, NULL, 'syntaxin-binding protein 5-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(170597, NULL, 'G3DSA:3.30.160.60:FF:003775', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170598, NULL, 'G3DSA:3.20.20.100:FF:000168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170599, NULL, 'G3DSA:1.10.510.10:FF:000394', NULL, NULL, 'Serine/threonine-protein kinase HSL1', NULL, NULL, NULL, NULL, NULL, 4),
(170600, NULL, 'G3DSA:2.40.30.330:FF:000007', NULL, NULL, 'Protein CLP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(170601, NULL, 'G3DSA:1.10.10.10:FF:001737', NULL, NULL, 'ATP-dependent DNA helicase, RecQ family', NULL, NULL, NULL, NULL, NULL, 4),
(170602, NULL, 'G3DSA:3.10.110.10:FF:000120', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 E3', NULL, NULL, NULL, NULL, NULL, 4),
(170603, NULL, 'G3DSA:1.10.287.2210:FF:000001', NULL, NULL, 'BLM10p Proteasome activator', NULL, NULL, NULL, NULL, NULL, 4),
(170604, NULL, 'G3DSA:6.10.20.180:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170605, NULL, 'G3DSA:3.30.70.1230:FF:000195', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170606, NULL, 'G3DSA:3.30.200.20:FF:001160', NULL, NULL, 'Cyclin-dependent kinase 4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(170607, NULL, 'G3DSA:1.20.1310.20:FF:000058', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(170608, NULL, 'G3DSA:1.10.10.60:FF:000510', NULL, NULL, 'Pdc2p', NULL, NULL, NULL, NULL, NULL, 4),
(170609, NULL, 'G3DSA:1.10.150.50:FF:000136', NULL, NULL, 'Protein VTS1', NULL, NULL, NULL, NULL, NULL, 4),
(170610, NULL, 'G3DSA:1.25.40.10:FF:003572', NULL, NULL, 'protein RRP5 homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(170611, NULL, 'G3DSA:4.10.640.10:FF:000021', NULL, NULL, 'Mitochondrial Ribosomal Protein, Small', NULL, NULL, NULL, NULL, NULL, 4),
(170612, NULL, 'G3DSA:1.10.580.10:FF:000016', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(170613, NULL, 'G3DSA:1.10.3720.10:FF:000055', NULL, NULL, 'ABC transporter, permease component', NULL, NULL, NULL, NULL, NULL, 4),
(170614, NULL, 'G3DSA:1.10.8.720:FF:000043', NULL, NULL, 'Dynein heavy chain, cytosolic, putative', NULL, NULL, NULL, NULL, NULL, 4),
(170615, NULL, 'G3DSA:3.30.60.90:FF:000045', NULL, NULL, 'At2g17740', NULL, NULL, NULL, NULL, NULL, 4),
(170616, NULL, 'G3DSA:1.10.357.120:FF:000013', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(170617, NULL, 'G3DSA:1.25.10.10:FF:002255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170618, NULL, 'G3DSA:1.20.1340.10:FF:000001', NULL, NULL, 'Histidine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(170619, NULL, 'G3DSA:3.30.1360.120:FF:000104', NULL, NULL, 'Putative transferase caf17, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(170620, NULL, 'G3DSA:2.130.10.10:FF:003781', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170621, NULL, 'G3DSA:3.40.50.1820:FF:000594', NULL, NULL, 'Putative phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(170622, NULL, 'G3DSA:3.30.160.60:FF:003247', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170623, NULL, 'G3DSA:3.30.1490.180:FF:000027', NULL, NULL, 'Putative rna polymerase iii large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(170624, NULL, 'G3DSA:1.25.40.300:FF:000001', NULL, NULL, 'SPI-1 type III secretion system effector HECT-type E3 ubiquitin transferase SopA', NULL, NULL, NULL, NULL, NULL, 4),
(170625, NULL, 'G3DSA:2.60.40.10:FF:003472', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170626, NULL, 'G3DSA:1.10.287.70:FF:000690', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170627, NULL, 'G3DSA:2.30.140.10:FF:000003', NULL, NULL, 'Spermidine synthase 1', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(170628, NULL, 'G3DSA:3.30.160.60:FF:000515', NULL, NULL, 'early growth response protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(170629, NULL, 'G3DSA:3.30.930.10:FF:000149', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(170630, NULL, 'G3DSA:2.40.170.20:FF:000022', NULL, NULL, 'TonB-dependent heme receptor HutR', NULL, NULL, NULL, NULL, NULL, 4),
(170631, NULL, 'G3DSA:3.40.630.30:FF:000563', NULL, NULL, 'Putative increased recombination centers protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(170632, NULL, 'G3DSA:1.50.40.10:FF:000248', NULL, NULL, 'Mitochondrial phosphate carrier protein 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(170633, NULL, 'G3DSA:3.40.50.300:FF:002472', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(170634, NULL, 'G3DSA:3.10.20.90:FF:000532', NULL, NULL, 'Auxin-responsive protein', NULL, NULL, NULL, NULL, NULL, 4),
(170635, NULL, 'G3DSA:3.10.290.70:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170636, NULL, 'G3DSA:1.50.40.10:FF:000490', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170637, NULL, 'G3DSA:3.90.550.10:FF:000590', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170638, NULL, 'G3DSA:3.40.50.10330:FF:000044', NULL, NULL, 'Long-chain base (LCB) kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(170639, NULL, 'G3DSA:3.30.70.1320:FF:000014', NULL, NULL, 'Efflux pump membrane transporter', NULL, NULL, NULL, NULL, NULL, 4),
(170640, NULL, 'G3DSA:2.20.50.20:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170641, NULL, 'G3DSA:3.30.70.1230:FF:000285', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(170642, NULL, 'G3DSA:1.50.10.10:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170643, NULL, 'G3DSA:1.10.630.10:FF:000515', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170644, NULL, 'G3DSA:3.40.50.1100:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170645, NULL, 'G3DSA:3.40.50.2000:FF:000547', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(170646, NULL, 'G3DSA:1.20.5.110:FF:000274', NULL, NULL, 'Qc-SNARE SYP6-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(170647, NULL, 'G3DSA:3.40.50.1110:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170648, NULL, 'G3DSA:3.30.160.60:FF:002314', NULL, NULL, 'E3 ubiquitin/ISG15 ligase TRIM25', NULL, NULL, NULL, NULL, NULL, 4),
(170649, NULL, 'G3DSA:3.30.230.10:FF:000377', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170650, NULL, 'G3DSA:1.10.510.10:FF:003738', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170651, NULL, 'G3DSA:3.60.10.10:FF:000264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170652, NULL, 'G3DSA:3.30.70.80:FF:000014', NULL, NULL, 'Epidermin leader peptide processing serine protease EpiP', NULL, NULL, NULL, NULL, NULL, 4),
(170653, NULL, 'G3DSA:3.40.50.1260:FF:000055', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(170654, NULL, 'G3DSA:3.30.40.10:FF:001470', NULL, NULL, 'PHD finger protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(170655, NULL, 'G3DSA:3.60.110.10:FF:000069', NULL, NULL, 'Carbon-nitrogen hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(170656, NULL, 'G3DSA:3.30.160.60:FF:004354', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170657, NULL, 'G3DSA:2.30.110.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170658, NULL, 'G3DSA:1.25.40.20:FF:001748', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170659, NULL, 'G3DSA:1.20.1250.40:FF:000008', NULL, NULL, 'RNA polymerase II, Rpb4, core protein', NULL, NULL, NULL, NULL, NULL, 4),
(170660, NULL, 'G3DSA:2.40.30.70:FF:000022', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170661, NULL, 'G3DSA:1.10.10.440:FF:000047', NULL, NULL, 'TransCription Elongation Regulator homolog', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(170662, NULL, 'G3DSA:3.40.1190.20:FF:000238', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170663, NULL, 'G3DSA:1.10.472.80:FF:000117', NULL, NULL, 'Rab GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(170664, NULL, 'G3DSA:3.10.250.10:FF:000135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170665, NULL, 'G3DSA:4.10.400.10:FF:000306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170666, NULL, 'G3DSA:1.10.565.10:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170667, NULL, 'G3DSA:3.50.30.30:FF:000148', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170668, NULL, 'G3DSA:1.10.1070.11:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170669, NULL, 'G3DSA:1.20.1460.10:FF:000004', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(170670, NULL, 'G3DSA:3.90.1150.10:FF:000120', NULL, NULL, 'Serine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(170671, NULL, 'G3DSA:3.90.70.10:FF:000822', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170672, NULL, 'G3DSA:1.25.40.10:FF:000166', NULL, NULL, 'Cartilage associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(170673, NULL, 'G3DSA:3.30.40.10:FF:001228', NULL, NULL, 'E3 ubiquitin-protein ligase hrd-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(170674, NULL, 'G3DSA:1.25.40.10:FF:001745', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170675, NULL, 'G3DSA:3.30.70.100:FF:000142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170676, NULL, 'G3DSA:2.130.10.10:FF:002292', NULL, NULL, 'Lambda-carrageenase', NULL, NULL, NULL, NULL, NULL, 4),
(170677, NULL, 'G3DSA:2.130.10.10:FF:004118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170678, NULL, 'G3DSA:3.20.20.10:FF:000058', NULL, NULL, 'Alanine racemase', NULL, NULL, NULL, NULL, NULL, 4),
(170679, NULL, 'G3DSA:3.30.70.2190:FF:000011', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(170680, NULL, 'G3DSA:3.40.50.300:FF:000611', NULL, NULL, 'RAB GTPase Vps21/Ypt51, putative', NULL, NULL, NULL, NULL, NULL, 4),
(170681, NULL, 'G3DSA:1.20.1250.20:FF:000002', NULL, NULL, 'Sugar transport protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(170682, NULL, 'G3DSA:3.90.550.50:FF:000051', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(170683, NULL, 'G3DSA:3.40.50.300:FF:000555', NULL, NULL, 'ATP-dependent RNA helicase SrmB', NULL, NULL, NULL, NULL, NULL, 4),
(170684, NULL, 'G3DSA:3.30.70.260:FF:000139', NULL, NULL, 'Homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(170685, NULL, 'G3DSA:3.40.50.300:FF:007519', NULL, NULL, 'ATP-dependent RNA helicase mss116, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(170686, NULL, 'G3DSA:1.10.238.10:FF:000822', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170687, NULL, 'G3DSA:1.10.530.10:FF:000013', NULL, NULL, 'Pneumococcal vaccine antigen A', NULL, NULL, NULL, NULL, NULL, 4),
(170688, NULL, 'G3DSA:3.40.50.10470:FF:000035', NULL, NULL, 'Translation initiation factor eif-2B alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(170689, NULL, 'G3DSA:3.40.50.300:FF:007699', NULL, NULL, 'ATP-dependent DEAD/H RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(170690, NULL, 'G3DSA:1.25.40.10:FF:001094', NULL, NULL, 'Intraflagellar transport particle protein IFT88', NULL, NULL, NULL, NULL, NULL, 4),
(170691, NULL, 'G3DSA:1.25.40.20:FF:001097', NULL, NULL, 'Si:ch211-119c20.2', NULL, NULL, NULL, NULL, NULL, 4),
(170692, NULL, 'G3DSA:1.10.10.10:FF:001092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170693, NULL, 'G3DSA:3.40.140.10:FF:000031', NULL, NULL, 'Probable C->U-editing enzyme APOBEC-2', NULL, NULL, NULL, NULL, NULL, 4),
(170694, NULL, 'G3DSA:3.90.550.10:FF:000320', NULL, NULL, 'Uncharacterized glycosyltransferase HI_0868', NULL, NULL, NULL, NULL, NULL, 4),
(170695, NULL, 'G3DSA:3.40.50.1010:FF:000087', NULL, NULL, 'Unplaced genomic scaffold supercont2.30, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(170696, NULL, 'G3DSA:3.40.50.300:FF:002382', NULL, NULL, 'DNA repair protein RAD51C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(170697, NULL, 'G3DSA:3.30.160.60:FF:001010', NULL, NULL, 'zinc finger protein 64 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(170698, NULL, 'G3DSA:3.60.90.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170699, NULL, 'G3DSA:3.40.50.300:FF:003961', NULL, NULL, 'ATP binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(170700, NULL, 'G3DSA:3.40.50.620:FF:000589', NULL, NULL, 'Arginyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(170701, NULL, 'G3DSA:3.90.180.10:FF:000067', NULL, NULL, 'alcohol dehydrogenase 1-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(170702, NULL, 'G3DSA:3.40.50.200:FF:000025', NULL, NULL, 'Peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(170703, NULL, 'G3DSA:3.40.50.11480:FF:000001', NULL, NULL, 'tubulin--tyrosine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(170704, NULL, 'G3DSA:3.90.70.10:FF:000171', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(170705, NULL, 'G3DSA:4.10.950.10:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170706, NULL, 'G3DSA:3.80.10.10:FF:000982', NULL, NULL, 'UBA/TS-N domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(170707, NULL, 'G3DSA:3.40.50.300:FF:004208', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170708, NULL, 'G3DSA:3.30.572.10:FF:000002', NULL, NULL, 'Possible thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(170709, NULL, 'G3DSA:2.20.100.10:FF:000076', NULL, NULL, 'ADAMTS-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(170710, NULL, 'G3DSA:3.40.50.1390:FF:000004', NULL, NULL, 'Resolvase YneB', NULL, NULL, NULL, NULL, NULL, 4),
(170711, NULL, 'G3DSA:3.40.50.1820:FF:001050', NULL, NULL, 'Serine carboxypeptidase-like 18', NULL, NULL, NULL, NULL, NULL, 4),
(170712, NULL, 'G3DSA:3.40.30.10:FF:000485', NULL, NULL, 'GM25516', NULL, NULL, NULL, NULL, NULL, 4),
(170713, NULL, 'G3DSA:1.20.1280.290:FF:000088', NULL, NULL, 'PQ loop repeat-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(170714, NULL, 'G3DSA:1.25.40.320:FF:000007', NULL, NULL, 'Putative bifunctional leukotriene a4 hydrolase/aminopeptidase lta4h', NULL, NULL, NULL, NULL, NULL, 4),
(170715, NULL, 'G3DSA:3.40.50.1380:FF:000001', NULL, NULL, 'Bifunctional purine biosynthesis protein PurH', NULL, NULL, NULL, NULL, NULL, 4),
(170716, NULL, 'G3DSA:1.20.1070.10:FF:000665', NULL, NULL, '5-hydroxytryptamine receptor 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(170717, NULL, 'G3DSA:1.10.357.70:FF:000010', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(170718, NULL, 'G3DSA:3.40.50.1820:FF:000678', NULL, NULL, 'Acetyl esterase/lipase', NULL, NULL, NULL, NULL, NULL, 4),
(170719, NULL, 'G3DSA:3.30.420.610:FF:000015', NULL, NULL, 'GD25688', NULL, NULL, NULL, NULL, NULL, 4),
(170720, NULL, 'G3DSA:1.10.510.10:FF:003648', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170721, NULL, 'G3DSA:3.30.160.60:FF:003865', NULL, NULL, 'Zinc finger protein 587', NULL, NULL, NULL, NULL, NULL, 4),
(170722, NULL, 'G3DSA:3.40.50.2300:FF:001031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170723, NULL, 'G3DSA:1.10.357.140:FF:000019', NULL, NULL, 'Protoheme IX farnesyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(170724, NULL, 'G3DSA:3.80.10.10:FF:000746', NULL, NULL, 'Plant intracellular Ras-group-related LRR protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(170725, NULL, 'G3DSA:4.10.400.10:FF:000273', NULL, NULL, 'Receptor Mediated Endocytosis', NULL, NULL, NULL, NULL, NULL, 4),
(170726, NULL, 'G3DSA:1.10.8.1310:FF:000016', NULL, NULL, 'TBC1 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(170727, NULL, 'G3DSA:2.10.50.10:FF:000097', NULL, NULL, 'Tumor necrosis factor receptor superfamily, member 1a', NULL, NULL, NULL, NULL, NULL, 4),
(170728, NULL, 'G3DSA:3.40.630.30:FF:000473', NULL, NULL, 'Elongator complex protein 3', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(170729, NULL, 'G3DSA:3.40.50.12780:FF:000048', NULL, NULL, 'Coenzyme A ligase', NULL, NULL, NULL, NULL, NULL, 4),
(170730, NULL, 'G3DSA:3.80.10.10:FF:001292', NULL, NULL, 'Tubulin-specific chaperone E', NULL, NULL, NULL, NULL, NULL, 4),
(170731, NULL, 'G3DSA:1.20.144.10:FF:000006', NULL, NULL, 'Phospholipid phosphatase-related protein type 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(170732, NULL, 'G3DSA:1.20.5.50:FF:000011', NULL, NULL, 'Fibrinogen gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(170733, NULL, 'G3DSA:3.40.50.300:FF:008014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170734, NULL, 'G3DSA:3.30.420.10:FF:000537', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170735, NULL, 'G3DSA:3.20.20.80:FF:000388', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170736, NULL, 'G3DSA:3.40.30.10:FF:000575', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(170737, NULL, 'G3DSA:1.10.418.10:FF:000241', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170738, NULL, 'G3DSA:3.90.70.10:FF:000261', NULL, NULL, 'calpain-15', NULL, NULL, NULL, NULL, NULL, 4),
(170739, NULL, 'G3DSA:3.90.640.10:FF:000237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170740, NULL, 'G3DSA:3.40.20.10:FF:000041', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(170741, NULL, 'G3DSA:1.25.40.10:FF:004966', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170742, NULL, 'G3DSA:1.20.58.60:FF:000693', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170743, NULL, 'G3DSA:1.10.8.60:FF:000144', NULL, NULL, 'Replication factor C subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(170744, NULL, 'G3DSA:1.10.287.110:FF:000314', NULL, NULL, 'Chloroplast DnaJ-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(170745, NULL, 'G3DSA:2.130.10.10:FF:000431', NULL, NULL, 'WD repeat-containing protein 41 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(170746, NULL, 'G3DSA:1.10.510.10:FF:000427', NULL, NULL, 'SRSF protein kinase 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(170747, NULL, 'G3DSA:2.60.40.1230:FF:000008', NULL, NULL, 'AP-1 complex subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(170748, NULL, 'G3DSA:3.10.20.90:FF:000442', NULL, NULL, 'RanBP-type and C3HC4-type zinc finger-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(170749, NULL, 'G3DSA:4.10.240.10:FF:000182', NULL, NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(170750, NULL, 'G3DSA:1.25.40.20:FF:001012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170751, NULL, 'G3DSA:1.25.10.10:FF:003183', NULL, NULL, 'Probable inactive serine/threonine-protein kinase DDB_G0278909', NULL, NULL, NULL, NULL, NULL, 4),
(170752, NULL, 'G3DSA:1.10.10.60:FF:000420', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(170753, NULL, 'G3DSA:3.10.580.10:FF:000121', NULL, NULL, 'Glycine betaine/carnitine/choline ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(170754, NULL, 'G3DSA:2.60.40.1130:FF:000006', NULL, NULL, 'geranylgeranyl transferase type-2 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(170755, NULL, 'G3DSA:2.60.120.10:FF:000079', NULL, NULL, '1,2-dihydroxy-3-keto-5-methylthiopentene dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(170756, NULL, 'G3DSA:3.20.20.70:FF:000385', NULL, NULL, 'Multifunctional tryptophan biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(170757, NULL, 'G3DSA:3.30.420.510:FF:000013', NULL, NULL, 'Pantothenate kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(170758, NULL, 'G3DSA:3.40.850.10:FF:000298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170759, NULL, 'G3DSA:1.20.1640.10:FF:000041', NULL, NULL, 'Multidrug transporter AcrB', NULL, NULL, NULL, NULL, NULL, 4),
(170760, NULL, 'G3DSA:3.40.50.10190:FF:000069', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(170761, NULL, 'G3DSA:2.60.40.10:FF:002544', NULL, NULL, 'L1 CAM ADhesion molecule homolog', NULL, NULL, NULL, NULL, NULL, 4),
(170762, NULL, 'G3DSA:3.40.50.300:FF:006069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170763, NULL, 'G3DSA:3.30.1360.120:FF:000071', NULL, NULL, 'Putative transferase CAF17, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(170764, NULL, 'G3DSA:3.30.200.20:FF:001721', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170765, NULL, 'G3DSA:3.30.2350.20:FF:000017', NULL, NULL, 'Putative pseudouridine synthase B0024.11', NULL, NULL, NULL, NULL, NULL, 4),
(170766, NULL, 'G3DSA:2.60.120.1040:FF:000002', NULL, NULL, 'zinc finger protein ZPR1', NULL, NULL, NULL, NULL, NULL, 4),
(170767, NULL, 'G3DSA:3.40.50.10860:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170768, NULL, 'G3DSA:3.40.50.1820:FF:001611', NULL, NULL, 'Protein CBG13037', NULL, NULL, NULL, NULL, NULL, 4),
(170769, NULL, 'G3DSA:2.40.50.100:FF:000033', NULL, NULL, 'Dihydrolipoyllysine-residue succinyltransferase component of 2-oxoglutarate dehydrogenase complex, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(170770, NULL, 'G3DSA:3.40.120.10:FF:000029', NULL, NULL, 'Phosphomannomutase/phosphoglucomutase', NULL, NULL, NULL, NULL, NULL, 4),
(170771, NULL, 'G3DSA:3.30.60.30:FF:000111', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(170772, NULL, 'G3DSA:1.10.3200.20:FF:000002', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(170773, NULL, 'G3DSA:1.10.3730.20:FF:000031', NULL, NULL, 'EamA-like transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(170774, NULL, 'G3DSA:1.20.1070.10:FF:001160', NULL, NULL, 'Free fatty acid receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(170775, NULL, 'G3DSA:2.60.40.10:FF:003977', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170776, NULL, 'G3DSA:1.10.10.790:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170777, NULL, 'G3DSA:3.90.190.10:FF:000601', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170778, NULL, 'G3DSA:3.40.50.300:FF:000701', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(170779, NULL, 'G3DSA:3.30.420.10:FF:000206', NULL, NULL, 'Exonuclease, DNA polymerase III, epsilon subunit family', NULL, NULL, NULL, NULL, NULL, 4),
(170780, NULL, 'G3DSA:3.30.2410.10:FF:000014', NULL, NULL, 'E3 ubiquitin-protein ligase SMURF1', NULL, NULL, NULL, NULL, NULL, 4),
(170781, NULL, 'G3DSA:3.30.1490.20:FF:000084', NULL, NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(170782, NULL, 'G3DSA:3.30.420.270:FF:000014', NULL, NULL, 'Biopolymer transporter ExbD', NULL, NULL, NULL, NULL, NULL, 4),
(170783, NULL, 'G3DSA:3.30.70.20:FF:000081', NULL, NULL, 'Anaerobic sulfite reductase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(170784, NULL, 'G3DSA:3.80.10.10:FF:002455', NULL, NULL, 'Receptor-like protein 30', NULL, NULL, NULL, NULL, NULL, 4),
(170785, NULL, 'G3DSA:3.30.160.60:FF:004028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170786, NULL, 'G3DSA:2.60.300.12:FF:000017', NULL, NULL, 'FeS cluster insertion', NULL, NULL, NULL, NULL, NULL, 4),
(170787, NULL, 'G3DSA:3.40.50.300:FF:001685', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(170788, NULL, 'G3DSA:3.80.10.10:FF:002399', NULL, NULL, 'Chondroadherin like', NULL, NULL, NULL, NULL, NULL, 4),
(170789, NULL, 'G3DSA:3.40.50.300:FF:004501', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170790, NULL, 'G3DSA:3.30.360.10:FF:000061', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(170791, NULL, 'G3DSA:2.60.40.420:FF:000257', NULL, NULL, 'Spore germination protein 270-11', NULL, NULL, NULL, NULL, NULL, 4),
(170792, NULL, 'G3DSA:1.10.1520.10:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170793, NULL, 'G3DSA:1.10.630.10:FF:000285', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(170794, NULL, 'G3DSA:1.20.58.60:FF:000491', NULL, NULL, 'Spectrin alpha, non-erythrocytic 1', NULL, NULL, NULL, NULL, NULL, 4),
(170795, NULL, 'G3DSA:2.90.20.10:FF:000001', NULL, NULL, '25 kDa ookinete surface antigen', NULL, NULL, NULL, NULL, NULL, 4),
(170796, NULL, 'G3DSA:3.30.160.60:FF:000341', NULL, NULL, 'Spalt-like transcription factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(170797, NULL, 'G3DSA:1.10.357.70:FF:000009', NULL, NULL, 'Exocyst complex component, putative', NULL, NULL, NULL, NULL, NULL, 4),
(170798, NULL, 'G3DSA:1.25.40.20:FF:000085', NULL, NULL, 'Notch-regulated ankyrin repeat-containing protein A', NULL, NULL, NULL, NULL, NULL, 4),
(170799, NULL, 'G3DSA:1.25.40.180:FF:000297', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170800, NULL, 'G3DSA:3.40.50.150:FF:000403', NULL, NULL, 'Phenazine-specific methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(170801, NULL, 'G3DSA:1.25.40.10:FF:000082', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(170802, NULL, 'G3DSA:2.130.10.10:FF:003955', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170803, NULL, 'G3DSA:3.20.20.80:FF:000298', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(170804, NULL, 'G3DSA:2.60.120.10:FF:000080', NULL, NULL, 'Auxin-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(170805, NULL, 'G3DSA:3.30.160.60:FF:003949', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170806, NULL, 'G3DSA:1.25.40.20:FF:000028', NULL, NULL, 'ankyrin repeat domain-containing protein 17 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(170807, NULL, 'G3DSA:2.60.120.10:FF:000551', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170808, NULL, 'G3DSA:3.40.50.300:FF:003776', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170809, NULL, 'G3DSA:1.25.40.70:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170810, NULL, 'G3DSA:1.10.555.10:FF:000216', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170811, NULL, 'G3DSA:3.40.50.2020:FF:000143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170812, NULL, 'G3DSA:3.30.70.980:FF:000006', NULL, NULL, 'Probable transcriptional regulatory protein J113_18170', NULL, NULL, NULL, NULL, NULL, 4),
(170813, NULL, 'G3DSA:1.10.390.10:FF:000041', NULL, NULL, 'Leukotriene A-4 hydrolase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(170814, NULL, 'G3DSA:3.40.50.300:FF:005428', NULL, NULL, 'ATP-binding cassette transporter, subfamily A, member 7, group AOH protein PpABCA7', NULL, NULL, NULL, NULL, NULL, 4),
(170815, NULL, 'G3DSA:1.20.1270.280:FF:000083', NULL, NULL, 'Dynein heavy chain, cytosolic, putative', NULL, NULL, NULL, NULL, NULL, 4),
(170816, NULL, 'G3DSA:3.40.50.1000:FF:000404', NULL, NULL, 'Unplaced genomic scaffold supercont2.16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(170817, NULL, 'G3DSA:3.40.50.2300:FF:001323', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170818, NULL, 'G3DSA:2.60.40.60:FF:000333', NULL, NULL, 'Protocadherin-related 15b', NULL, NULL, NULL, NULL, NULL, 4),
(170819, NULL, 'G3DSA:3.40.50.150:FF:000931', NULL, NULL, 'mRNA cap guanine-N7 methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(170820, NULL, 'G3DSA:2.130.10.10:FF:003629', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170821, NULL, 'G3DSA:2.60.40.10:FF:003562', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170822, NULL, 'G3DSA:3.30.200.20:FF:000996', NULL, NULL, 'Rac serine-threonine kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(170823, NULL, 'G3DSA:3.90.1290.10:FF:000006', NULL, NULL, 'microtubule-actin cross-linking factor 1 isoform X10', NULL, NULL, NULL, NULL, NULL, 4),
(170824, NULL, 'G3DSA:1.25.40.10:FF:003746', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170825, NULL, 'G3DSA:3.40.30.10:FF:000193', NULL, NULL, 'Protein disulfide isomerase-like 5-2', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(170826, NULL, 'G3DSA:2.40.30.10:FF:000408', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170827, NULL, 'G3DSA:1.50.40.10:FF:000046', NULL, NULL, 'Phosphate carrier protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(170828, NULL, 'G3DSA:2.60.40.10:FF:006052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170829, NULL, 'G3DSA:1.10.220.150:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170830, NULL, 'G3DSA:3.20.90.10:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170831, NULL, 'G3DSA:2.30.30.40:FF:000620', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170832, NULL, 'G3DSA:1.10.287.70:FF:000274', NULL, NULL, 'ATP-sensitive inward rectifier potassium channel 10', NULL, NULL, NULL, NULL, NULL, 4),
(170833, NULL, 'G3DSA:1.10.10.10:FF:001086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170834, NULL, 'G3DSA:1.25.40.420:FF:000037', NULL, NULL, 'GD17043', NULL, NULL, NULL, NULL, NULL, 4),
(170835, NULL, 'G3DSA:1.10.45.10:FF:000008', NULL, NULL, 'D-arabinono-1,4-lactone oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(170836, NULL, 'G3DSA:3.10.20.90:FF:001021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170837, NULL, 'G3DSA:1.20.140.100:FF:000010', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(170838, NULL, 'G3DSA:3.30.70.330:FF:002369', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170839, NULL, 'G3DSA:1.10.238.10:FF:000148', NULL, NULL, 'alpha-actinin, sarcomeric isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(170840, NULL, 'G3DSA:3.30.360.10:FF:000004', NULL, NULL, '4-hydroxy-tetrahydrodipicolinate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(170841, NULL, 'G3DSA:1.20.1250.20:FF:000379', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(170842, NULL, 'G3DSA:3.30.160.60:FF:005720', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170843, NULL, 'G3DSA:2.60.120.380:FF:000068', NULL, NULL, 'Calpain 11', NULL, NULL, NULL, NULL, NULL, 4),
(170844, NULL, 'G3DSA:3.10.290.20:FF:000023', NULL, NULL, 'Ubiquitin-activating enzyme-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(170845, NULL, 'G3DSA:3.90.76.10:FF:000010', NULL, NULL, 'Peptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(170846, NULL, 'G3DSA:3.10.290.10:FF:000020', NULL, NULL, 'Ribosomal protein S4', NULL, NULL, NULL, NULL, NULL, 4),
(170847, NULL, 'G3DSA:3.40.50.150:FF:001185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170848, NULL, 'G3DSA:1.10.287.470:FF:000023', NULL, NULL, 'Multidrug resistance protein MexA', NULL, NULL, NULL, NULL, NULL, 4),
(170849, NULL, 'G3DSA:1.10.10.10:FF:001939', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170850, NULL, 'G3DSA:3.30.70.330:FF:001059', NULL, NULL, 'Putative polypyrimidine tract binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(170851, NULL, 'G3DSA:2.10.50.10:FF:000153', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170852, NULL, 'G3DSA:3.30.360.20:FF:000007', NULL, NULL, 'RNA 3''-terminal phosphate cyclase-like protein,putative', NULL, NULL, NULL, NULL, NULL, 4),
(170853, NULL, 'G3DSA:3.20.20.370:FF:000001', NULL, NULL, 'Chitooligosaccharide deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(170854, NULL, 'G3DSA:3.30.2130.10:FF:000032', NULL, NULL, 'Prephenate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(170855, NULL, 'G3DSA:3.40.630.10:FF:000113', NULL, NULL, 'Dug2p', NULL, NULL, NULL, NULL, NULL, 4),
(170856, NULL, 'G3DSA:2.40.50.140:FF:000668', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170857, NULL, 'G3DSA:3.30.420.10:FF:000678', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170858, NULL, 'G3DSA:2.60.40.1930:FF:000033', NULL, NULL, 'Complement component 4A (Rodgers blood group)', NULL, NULL, NULL, NULL, NULL, 4),
(170859, NULL, 'G3DSA:3.40.50.10470:FF:000029', NULL, NULL, 'Methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(170860, NULL, 'G3DSA:2.60.40.10:FF:001847', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(170861, NULL, 'G3DSA:1.10.101.10:FF:000039', NULL, NULL, 'Matrix metallopeptidase 19', NULL, NULL, NULL, NULL, NULL, 4),
(170862, NULL, 'G3DSA:1.20.1270.60:FF:000291', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170863, NULL, 'G3DSA:3.40.50.300:FF:000903', NULL, NULL, 'ABC transporter G family member 7', NULL, NULL, NULL, NULL, NULL, 4),
(170864, NULL, 'G3DSA:3.40.1110.10:FF:000045', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(170865, NULL, 'G3DSA:3.20.20.380:FF:000004', NULL, NULL, 'Copper homeostasis protein CutC', NULL, NULL, NULL, NULL, NULL, 4),
(170866, NULL, 'G3DSA:3.40.50.300:FF:008340', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170867, NULL, 'G3DSA:3.30.160.710:FF:000002', NULL, NULL, 'Hemagglutinin', NULL, NULL, NULL, NULL, NULL, 4),
(170868, NULL, 'G3DSA:1.20.58.60:FF:000159', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(170869, NULL, 'G3DSA:2.20.100.10:FF:000082', NULL, NULL, 'Complement component C8 beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(170870, NULL, 'G3DSA:3.50.50.60:FF:001327', NULL, NULL, 'LD39082p', NULL, NULL, NULL, NULL, NULL, 4),
(170871, NULL, 'G3DSA:3.30.160.60:FF:002230', NULL, NULL, 'Zinc finger protein 469', NULL, NULL, NULL, NULL, NULL, 4),
(170872, NULL, 'G3DSA:1.20.1250.20:FF:001104', NULL, NULL, 'Glucuronide transporter UidB', NULL, NULL, NULL, NULL, NULL, 4),
(170873, NULL, 'G3DSA:2.60.120.200:FF:000003', NULL, NULL, 'neurexin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(170874, NULL, 'G3DSA:1.10.287.70:FF:000745', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170875, NULL, 'G3DSA:3.30.160.60:FF:004410', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170876, NULL, 'G3DSA:1.10.20.10:FF:000131', NULL, NULL, 'Histone H2B', NULL, NULL, NULL, NULL, NULL, 4),
(170877, NULL, 'G3DSA:3.40.50.1820:FF:001465', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170878, NULL, 'G3DSA:2.60.40.10:FF:004343', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170879, NULL, 'G3DSA:1.10.510.10:FF:001647', NULL, NULL, 'WGS project CABT00000000 data, contig 2.1', NULL, NULL, NULL, NULL, NULL, 4),
(170880, NULL, 'G3DSA:1.25.40.10:FF:005129', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170881, NULL, 'G3DSA:2.60.40.10:FF:000072', NULL, NULL, 'RIMS-binding protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(170882, NULL, 'G3DSA:2.60.40.60:FF:000390', NULL, NULL, 'Protocadherin Fat', NULL, NULL, NULL, NULL, NULL, 4),
(170883, NULL, 'G3DSA:1.10.510.10:FF:000068', NULL, NULL, 'STE20/SPS1-related proline-alanine-rich protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(170884, NULL, 'G3DSA:4.10.75.10:FF:000008', NULL, NULL, 'Whey acidic protein', NULL, NULL, NULL, NULL, NULL, 4),
(170885, NULL, 'G3DSA:1.10.287.110:FF:000022', NULL, NULL, 'DnaJ homolog subfamily B member 6', NULL, NULL, NULL, NULL, NULL, 4),
(170886, NULL, 'G3DSA:2.40.70.10:FF:000063', NULL, NULL, 'aspartic proteinase nepenthesin-1', NULL, NULL, NULL, NULL, NULL, 4),
(170887, NULL, 'G3DSA:3.40.50.300:FF:004181', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170888, NULL, 'G3DSA:2.60.40.10:FF:002252', NULL, NULL, 'Glycoside hydrolase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(170889, NULL, 'G3DSA:3.30.1370.100:FF:000005', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(170890, NULL, 'G3DSA:3.30.70.330:FF:002897', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170891, NULL, 'G3DSA:1.10.3090.10:FF:000034', NULL, NULL, 'tRNA nucleotidyltransferase cca1', NULL, NULL, NULL, NULL, NULL, 4),
(170892, NULL, 'G3DSA:1.20.1270.60:FF:000139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170893, NULL, 'G3DSA:3.30.1490.20:FF:000027', NULL, NULL, 'Pyruvate, phosphate dikinase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(170894, NULL, 'G3DSA:1.10.287.130:FF:000269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170895, NULL, 'G3DSA:1.20.5.990:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170896, NULL, 'G3DSA:1.20.120.350:FF:000176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170897, NULL, 'G3DSA:1.10.510.10:FF:000012', NULL, NULL, 'microtubule-associated serine/threonine-protein kinase 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(170898, NULL, 'G3DSA:3.30.1370.110:FF:000008', NULL, NULL, 'YPL199C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(170899, NULL, 'G3DSA:3.40.50.300:FF:002090', NULL, NULL, 'ADP-ribosylation factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(170900, NULL, 'G3DSA:3.40.50.300:FF:000381', NULL, NULL, 'TFIIH basal transcription factor complex helicase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(170901, NULL, 'G3DSA:3.40.50.720:FF:000945', NULL, NULL, 'UDP-glucose/GDP-mannose dehydrogenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(170902, NULL, 'G3DSA:3.30.1600.10:FF:000023', NULL, NULL, 'Transcriptional regulator, Sir2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(170903, NULL, 'G3DSA:3.40.50.410:FF:000116', NULL, NULL, 'Voltage-dependent calcium channel unc-36', NULL, NULL, NULL, NULL, NULL, 4),
(170904, NULL, 'G3DSA:2.40.110.10:FF:000004', NULL, NULL, 'Isovaleryl-CoA dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(170905, NULL, 'G3DSA:3.40.630.30:FF:000271', NULL, NULL, 'L-2,4-diaminobutyric acid acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(170906, NULL, 'G3DSA:3.40.50.1100:FF:000232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170907, NULL, 'G3DSA:1.10.287.1490:FF:000133', NULL, NULL, 'Phosphoinositide-3-kinase regulatory subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(170908, NULL, 'G3DSA:3.40.50.620:FF:000735', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170909, NULL, 'G3DSA:2.70.150.10:FF:000034', NULL, NULL, 'Sodium ion P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(170910, NULL, 'G3DSA:1.10.10.10:FF:001794', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170911, NULL, 'G3DSA:1.10.150.80:FF:000004', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(170912, NULL, 'G3DSA:3.80.10.10:FF:001151', NULL, NULL, 'F-box/LRR-repeat protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(170913, NULL, 'G3DSA:3.40.50.720:FF:000001', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(170914, NULL, 'G3DSA:1.10.238.10:FF:000530', NULL, NULL, 'Zgc:85932', NULL, NULL, NULL, NULL, NULL, 4),
(170915, NULL, 'G3DSA:3.10.20.90:FF:000240', NULL, NULL, 'ISG15 ubiquitin-like modifier', NULL, NULL, NULL, NULL, NULL, 4),
(170916, NULL, 'G3DSA:2.60.40.10:FF:005686', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170917, NULL, 'G3DSA:3.40.50.2300:FF:000957', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170918, NULL, 'G3DSA:3.90.550.10:FF:000207', NULL, NULL, 'Ceramide glucosyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(170919, NULL, 'G3DSA:3.30.40.10:FF:000683', NULL, NULL, 'RING/U-box superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(170920, NULL, 'G3DSA:1.10.30.10:FF:000047', NULL, NULL, 'Axial regulator YABBY', NULL, NULL, NULL, NULL, NULL, 4),
(170921, NULL, 'G3DSA:1.10.510.10:FF:000540', NULL, NULL, 'Serine/threonine-protein kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(170922, NULL, 'G3DSA:3.40.50.300:FF:007935', NULL, NULL, 'Conjugal transfer protein, conjectural', NULL, NULL, NULL, NULL, NULL, 4),
(170923, NULL, 'G3DSA:2.130.10.10:FF:004091', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170924, NULL, 'G3DSA:2.80.10.50:FF:000277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170925, NULL, 'G3DSA:3.30.160.60:FF:003573', NULL, NULL, 'KLF17 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(170926, NULL, 'G3DSA:1.10.510.10:FF:003356', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(170927, NULL, 'G3DSA:3.40.50.10190:FF:000215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170928, NULL, 'G3DSA:3.30.565.10:FF:000031', NULL, NULL, 'DNA mismatch repair protein Mlh3', NULL, NULL, NULL, NULL, NULL, 4),
(170929, NULL, 'G3DSA:2.60.120.200:FF:000436', NULL, NULL, 'Beta-1,3-glucan binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(170930, NULL, 'G3DSA:3.40.50.300:FF:004124', NULL, NULL, 'ATP-binding cassette protein subfamily C, member 8', NULL, NULL, NULL, NULL, NULL, 4),
(170931, NULL, 'G3DSA:3.40.50.300:FF:007558', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170932, NULL, 'G3DSA:2.10.70.10:FF:000154', NULL, NULL, 'Complement component 1, r subcomponent', NULL, NULL, NULL, NULL, NULL, 4),
(170933, NULL, 'G3DSA:3.40.50.300:FF:007845', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170934, NULL, 'G3DSA:1.20.1600.10:FF:000010', NULL, NULL, 'Outer membrane efflux protein', NULL, NULL, NULL, NULL, NULL, 4),
(170935, NULL, 'G3DSA:1.50.10.10:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170936, NULL, 'G3DSA:1.25.40.10:FF:001386', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g26782, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(170937, NULL, 'G3DSA:3.40.50.740:FF:000007', NULL, NULL, 'Formate dehydrogenase, alpha subunit, selenocysteine-containing', NULL, NULL, NULL, NULL, NULL, 4),
(170938, NULL, 'G3DSA:3.40.50.10810:FF:000002', NULL, NULL, 'ISWI chromatin-remodeling complex ATPase CHR11 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(170939, NULL, 'G3DSA:3.40.50.200:FF:000109', NULL, NULL, 'Clan SB, family S8, subtilisin-like serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(170940, NULL, 'G3DSA:1.25.40.10:FF:001329', NULL, NULL, 'ESX-1 secretion system protein EccA1', NULL, NULL, NULL, NULL, NULL, 4),
(170941, NULL, 'G3DSA:3.60.40.10:FF:000322', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170942, NULL, 'G3DSA:2.60.40.60:FF:000620', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170943, NULL, 'G3DSA:3.30.70.100:FF:000086', NULL, NULL, 'Heavy metal translocatin', NULL, NULL, NULL, NULL, NULL, 4),
(170944, NULL, 'G3DSA:3.40.1350.10:FF:000006', NULL, NULL, 'tRNA-splicing endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(170945, NULL, 'G3DSA:3.30.160.60:FF:005664', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170946, NULL, 'G3DSA:3.40.50.10330:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170947, NULL, 'G3DSA:1.10.238.10:FF:000620', NULL, NULL, 'Putative polycystic kidney disease protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(170948, NULL, 'G3DSA:2.40.40.20:FF:000064', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(170949, NULL, 'G3DSA:3.40.630.30:FF:000181', NULL, NULL, 'Acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(170950, NULL, 'G3DSA:3.70.10.10:FF:000033', NULL, NULL, 'Rad9 protein', NULL, NULL, NULL, NULL, NULL, 4),
(170951, NULL, 'G3DSA:2.30.42.10:FF:000358', NULL, NULL, 'Sperm Meiosis PDZ domain containing proteins', NULL, NULL, NULL, NULL, NULL, 4),
(170952, NULL, 'G3DSA:1.20.58.60:FF:000867', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170953, NULL, 'G3DSA:1.20.140.10:FF:000094', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(170954, NULL, 'G3DSA:1.10.10.60:FF:000712', NULL, NULL, 'V-myb avian myeloblastosis viral oncogene homolog-like 2a', NULL, NULL, NULL, NULL, NULL, 4),
(170955, NULL, 'G3DSA:2.70.130.10:FF:000145', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170956, NULL, 'G3DSA:1.10.150.50:FF:000046', NULL, NULL, 'ephrin type-A receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(170957, NULL, 'G3DSA:1.25.40.20:FF:001389', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170958, NULL, 'G3DSA:2.60.34.20:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170959, NULL, 'G3DSA:3.10.20.90:FF:000150', NULL, NULL, 'Ubiquitin-like protein ATG12', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(170960, NULL, 'G3DSA:3.90.550.10:FF:000264', NULL, NULL, 'Glycosyltransferases', NULL, NULL, NULL, NULL, NULL, 4),
(170961, NULL, 'G3DSA:2.170.16.10:FF:000027', NULL, NULL, 'Replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(170962, NULL, 'G3DSA:2.130.10.10:FF:000723', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(170963, NULL, 'G3DSA:1.25.10.10:FF:000254', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(170964, NULL, 'G3DSA:3.30.160.60:FF:000228', NULL, NULL, 'Wilms tumor 1-KTS isoform', NULL, NULL, NULL, NULL, NULL, 4),
(170965, NULL, 'G3DSA:2.60.120.10:FF:000495', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170966, NULL, 'G3DSA:3.30.40.10:FF:001026', NULL, NULL, 'baculoviral IAP repeat-containing protein 7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(170967, NULL, 'G3DSA:2.60.34.10:FF:000012', NULL, NULL, 'Heat shock 70 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(170968, NULL, 'G3DSA:3.30.9.10:FF:000245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170969, NULL, 'G3DSA:1.50.40.10:FF:000574', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170970, NULL, 'G3DSA:3.50.4.10:FF:000010', NULL, NULL, 'GD21471', NULL, NULL, NULL, NULL, NULL, 4),
(170971, NULL, 'G3DSA:3.30.160.60:FF:000285', NULL, NULL, 'Zinc finger matrin-type protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(170972, NULL, 'G3DSA:3.10.20.90:FF:000296', NULL, NULL, 'Ubiquitin-like protein-NEDD8-like protein RUB3', NULL, NULL, NULL, NULL, NULL, 4),
(170973, NULL, 'G3DSA:3.70.10.10:FF:000090', NULL, NULL, 'Checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(170974, NULL, 'G3DSA:3.20.20.70:FF:000559', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170975, NULL, 'G3DSA:1.10.8.60:FF:000436', NULL, NULL, 'Peroxisomal ATPase PEX1', NULL, NULL, NULL, NULL, NULL, 4),
(170976, NULL, 'G3DSA:2.10.60.10:FF:000069', NULL, NULL, 'Serine/threonine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(170977, NULL, 'G3DSA:3.30.230.130:FF:000002', NULL, NULL, 'cullin-3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(170978, NULL, 'G3DSA:1.10.150.60:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(170979, NULL, 'G3DSA:3.40.190.80:FF:000066', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(170980, NULL, 'G3DSA:2.60.120.780:FF:000008', NULL, NULL, 'SIZ1p SUMO/Smt3 ligase', NULL, NULL, NULL, NULL, NULL, 4),
(170981, NULL, 'G3DSA:3.50.70.20:FF:000001', NULL, NULL, 'Cytochrome P460', NULL, NULL, NULL, NULL, NULL, 4),
(170982, NULL, 'G3DSA:3.90.730.10:FF:000031', NULL, NULL, 'Os07g0629300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(170983, NULL, 'G3DSA:1.10.472.10:FF:000411', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170984, NULL, 'G3DSA:3.90.76.10:FF:000009', NULL, NULL, 'Peptide/nickel transport system substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(170985, NULL, 'G3DSA:1.10.630.10:FF:000807', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170986, NULL, 'G3DSA:3.40.50.2000:FF:000839', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170987, NULL, 'G3DSA:1.10.10.10:FF:001940', NULL, NULL, 'Os06g0553100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(170988, NULL, 'G3DSA:1.25.10.10:FF:001558', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(170989, NULL, 'G3DSA:2.60.40.1280:FF:000001', NULL, NULL, 'Agglutinin-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(170990, NULL, 'G3DSA:1.10.510.10:FF:002013', NULL, NULL, 'Kinase, CDC7', NULL, NULL, NULL, NULL, NULL, 4),
(170991, NULL, 'G3DSA:3.30.200.20:FF:001867', NULL, NULL, 'Fibroblast growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(170992, NULL, 'G3DSA:3.30.505.10:FF:000055', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(170993, NULL, 'G3DSA:2.130.10.10:FF:005248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(170994, NULL, 'G3DSA:3.90.1420.10:FF:000006', NULL, NULL, 'SET domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(170995, NULL, 'G3DSA:3.30.70.330:FF:001352', NULL, NULL, 'Serine and arginine rich splicing factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(170996, NULL, 'G3DSA:3.40.50.150:FF:000167', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(170997, NULL, 'G3DSA:1.20.5.110:FF:000190', NULL, NULL, 'Predicted_coiled-coil_domain-containing_protein_(DUF2360)_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(170998, NULL, 'G3DSA:3.90.190.10:FF:000365', NULL, NULL, 'AGAP012901-PA', NULL, NULL, NULL, NULL, NULL, 4),
(170999, NULL, 'G3DSA:3.30.565.10:FF:000362', NULL, NULL, 'YALI0E10769p', NULL, NULL, NULL, NULL, NULL, 4),
(171000, NULL, 'G3DSA:2.60.40.150:FF:000209', NULL, NULL, 'Synaptotagmin 4', NULL, NULL, NULL, NULL, NULL, 4),
(171001, NULL, 'G3DSA:3.30.160.60:FF:004500', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171002, NULL, 'G3DSA:3.30.200.20:FF:001339', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171003, NULL, 'G3DSA:1.20.1560.10:FF:000837', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171004, NULL, 'G3DSA:2.60.40.1730:FF:000035', NULL, NULL, 'Putative aminopeptidase-2', NULL, NULL, NULL, NULL, NULL, 4),
(171005, NULL, 'G3DSA:3.30.930.10:FF:000060', NULL, NULL, 'ATP phosphoribosyltransferase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(171006, NULL, 'G3DSA:3.40.250.10:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171007, NULL, 'G3DSA:3.40.50.720:FF:000855', NULL, NULL, 'NAD-dependent epimerase/dehydratase / Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(171008, NULL, 'G3DSA:3.40.50.150:FF:000370', NULL, NULL, 'Si:ch211-93g23.2', NULL, NULL, NULL, NULL, NULL, 4),
(171009, NULL, 'G3DSA:3.30.70.850:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171010, NULL, 'G3DSA:3.90.1480.20:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171011, NULL, 'G3DSA:1.20.58.90:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171012, NULL, 'G3DSA:2.30.29.30:FF:000783', NULL, NULL, 'RHo Guanine nucleotide exchange Factor', NULL, NULL, NULL, NULL, NULL, 4),
(171013, NULL, 'G3DSA:3.40.50.11340:FF:000009', NULL, NULL, 'GDP-fucose protein O-fucosyltransferase 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171014, NULL, 'G3DSA:1.10.287.110:FF:000112', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(171015, NULL, 'G3DSA:3.10.580.10:FF:000177', NULL, NULL, 'Cystathionine beta-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(171016, NULL, 'G3DSA:1.10.150.110:FF:000034', NULL, NULL, 'MUS81 structure-specific endonuclease subunit', NULL, NULL, NULL, NULL, NULL, 4),
(171017, NULL, 'G3DSA:2.60.40.150:FF:000451', NULL, NULL, 'Coiled-coil domain-containing protein 33', NULL, NULL, NULL, NULL, NULL, 4),
(171018, NULL, 'G3DSA:3.20.20.120:FF:000033', NULL, NULL, 'L-amino acid-D/L-Glu epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(171019, NULL, 'G3DSA:2.60.120.10:FF:000731', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171020, NULL, 'G3DSA:2.60.40.10:FF:002342', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171021, NULL, 'G3DSA:3.20.20.80:FF:000675', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(171022, NULL, 'G3DSA:3.40.800.20:FF:000062', NULL, NULL, 'Histone deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(171023, NULL, 'G3DSA:2.60.40.3850:FF:000002', NULL, NULL, 'Interleukin-3 receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(171024, NULL, 'G3DSA:1.10.10.10:FF:000304', NULL, NULL, 'LuxR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(171025, NULL, 'G3DSA:1.20.120.1320:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171026, NULL, 'G3DSA:3.20.20.60:FF:000141', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(171027, NULL, 'G3DSA:3.30.160.60:FF:005484', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171028, NULL, 'G3DSA:2.60.120.330:FF:000194', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(171029, NULL, 'G3DSA:3.90.1410.10:FF:000034', NULL, NULL, 'SET domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(171030, NULL, 'G3DSA:1.10.533.10:FF:000104', NULL, NULL, 'Si:dkey-103e21.5', NULL, NULL, NULL, NULL, NULL, 4),
(171031, NULL, 'G3DSA:2.40.10.10:FF:000233', NULL, NULL, 'Blast:Transmembrane protease serine 6', NULL, NULL, NULL, NULL, NULL, 4),
(171032, NULL, 'G3DSA:2.30.29.30:FF:000726', NULL, NULL, 'AGAP012332-PA', NULL, NULL, NULL, NULL, NULL, 4),
(171033, NULL, 'G3DSA:3.50.50.60:FF:001237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171034, NULL, 'G3DSA:3.40.50.720:FF:001075', NULL, NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(171035, NULL, 'G3DSA:3.40.50.1440:FF:000042', NULL, NULL, 'Tubulin delta chain', NULL, NULL, NULL, NULL, NULL, 4),
(171036, NULL, 'G3DSA:1.10.238.10:FF:001076', NULL, NULL, 'Penta-EF-hand domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(171037, NULL, 'G3DSA:3.20.20.70:FF:000672', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171038, NULL, 'G3DSA:3.40.50.300:FF:006070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171039, NULL, 'G3DSA:1.25.10.10:FF:001272', NULL, NULL, 'HEAT repeat protein (DRIM), putative', NULL, NULL, NULL, NULL, NULL, 4),
(171040, NULL, 'G3DSA:1.10.10.10:FF:000158', NULL, NULL, 'La ribonucleoprotein domain family member 7', NULL, NULL, NULL, NULL, NULL, 4),
(171041, NULL, 'G3DSA:1.10.238.10:FF:000002', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(171042, NULL, 'G3DSA:1.25.40.1030:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171043, NULL, 'G3DSA:3.20.20.70:FF:000615', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171044, NULL, 'G3DSA:3.60.40.10:FF:000086', NULL, NULL, 'Protein phosphatase 2C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(171045, NULL, 'G3DSA:3.30.160.60:FF:002701', NULL, NULL, 'zinc finger protein 646', NULL, NULL, NULL, NULL, NULL, 4),
(171046, NULL, 'G3DSA:3.30.160.60:FF:002645', NULL, NULL, 'Transcription factor IIIA', NULL, NULL, NULL, NULL, NULL, 4),
(171047, NULL, 'G3DSA:3.10.290.10:FF:000076', NULL, NULL, 'Ribosomal large subunit pseudouridine synthase D', NULL, NULL, NULL, NULL, NULL, 4),
(171048, NULL, 'G3DSA:1.10.560.10:FF:000015', NULL, NULL, 'T-complex protein 1 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(171049, NULL, 'G3DSA:3.40.50.300:FF:000139', NULL, NULL, 'ras-related protein Rab-6A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(171050, NULL, 'G3DSA:3.40.50.2300:FF:000867', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171051, NULL, 'G3DSA:1.10.10.1100:FF:000009', NULL, NULL, 'Bacterioferritin-associated ferredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(171052, NULL, 'G3DSA:1.10.3080.10:FF:000062', NULL, NULL, 'Uncharacterized protein MJ0305', NULL, NULL, NULL, NULL, NULL, 4),
(171053, NULL, 'G3DSA:2.130.10.10:FF:001651', NULL, NULL, 'GM18507', NULL, NULL, NULL, NULL, NULL, 4),
(171054, NULL, 'G3DSA:3.90.650.10:FF:000064', NULL, NULL, 'Probable phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(171055, NULL, 'G3DSA:3.30.450.20:FF:000655', NULL, NULL, 'Diguanylate cyclase with PAS/PAC sensor', NULL, NULL, NULL, NULL, NULL, 4),
(171056, NULL, 'G3DSA:2.30.30.60:FF:000008', NULL, NULL, 'Mechanosensitive ion channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(171057, NULL, 'G3DSA:3.40.50.300:FF:005518', NULL, NULL, 'EIF2-interacting protein ABC50, putative (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(171058, NULL, 'G3DSA:1.10.630.10:FF:000846', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171059, NULL, 'G3DSA:1.10.238.20:FF:000005', NULL, NULL, 'Odorant-binding protein 99a', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(171060, NULL, 'G3DSA:1.10.510.10:FF:002428', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171061, NULL, 'G3DSA:2.30.29.30:FF:001002', NULL, NULL, 'Rab-GTPase-TBC domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(171062, NULL, 'G3DSA:3.40.50.720:FF:002564', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171063, NULL, 'G3DSA:3.30.70.1660:FF:000003', NULL, NULL, 'Peptide chain release factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(171064, NULL, 'G3DSA:3.30.70.330:FF:001823', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171065, NULL, 'G3DSA:2.30.30.50:FF:000005', NULL, NULL, 'Nitrile hydratase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(171066, NULL, 'G3DSA:2.60.40.10:FF:000543', NULL, NULL, 'Alpha-protein kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(171067, NULL, 'G3DSA:3.30.70.330:FF:001880', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171068, NULL, 'G3DSA:1.20.190.20:FF:000009', NULL, NULL, '14-3-3 protein gamma', NULL, NULL, NULL, NULL, NULL, 4),
(171069, NULL, 'G3DSA:1.10.510.10:FF:003446', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171070, NULL, 'G3DSA:1.25.40.10:FF:000312', NULL, NULL, 'Mitochondrial import receptor subunit TOM34', NULL, NULL, NULL, NULL, NULL, 4),
(171071, NULL, 'G3DSA:1.10.10.10:FF:000490', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(171072, NULL, 'G3DSA:3.40.930.10:FF:000006', NULL, NULL, 'Fructose-specific PTS system IIA component', NULL, NULL, NULL, NULL, NULL, 4),
(171073, NULL, 'G3DSA:3.40.50.300:FF:005760', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(171074, NULL, 'G3DSA:1.20.58.830:FF:000017', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(171075, NULL, 'G3DSA:2.130.10.10:FF:005866', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171076, NULL, 'G3DSA:3.30.160.60:FF:005574', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171077, NULL, 'G3DSA:4.10.280.10:FF:000066', NULL, NULL, 'BHLH transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(171078, NULL, 'G3DSA:3.40.50.720:FF:000765', NULL, NULL, 'YPL033C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(171079, NULL, 'G3DSA:3.30.1360.40:FF:000029', NULL, NULL, 'Ribosome_recycling_factor_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(171080, NULL, 'G3DSA:1.20.1070.10:FF:000929', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171081, NULL, 'G3DSA:1.20.1530.20:FF:000041', NULL, NULL, 'Sodium/bile acid cotransporter', NULL, NULL, NULL, NULL, NULL, 4),
(171082, NULL, 'G3DSA:2.30.30.40:FF:000002', NULL, NULL, 'abl interactor 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(171083, NULL, 'G3DSA:3.40.250.10:FF:000095', NULL, NULL, 'Tyrosine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(171084, NULL, 'G3DSA:3.40.50.150:FF:000223', NULL, NULL, 'Caffeic acid 3-O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(171085, NULL, 'G3DSA:3.40.50.1820:FF:000914', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171086, NULL, 'G3DSA:2.10.110.10:FF:000101', NULL, NULL, 'Zinc finger protein 185 with LIM domain', NULL, NULL, NULL, NULL, NULL, 4),
(171087, NULL, 'G3DSA:3.10.450.240:FF:000010', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(171088, NULL, 'G3DSA:1.20.1300.10:FF:000026', NULL, NULL, 'Quinol:fumarate reductase menaquinol-oxidizing subunit FrdC', NULL, NULL, NULL, NULL, NULL, 4),
(171089, NULL, 'G3DSA:3.30.40.10:FF:001700', NULL, NULL, 'Lysine demethylase 5B', NULL, NULL, NULL, NULL, NULL, 4),
(171090, NULL, 'G3DSA:1.25.40.20:FF:000315', NULL, NULL, 'serine/threonine-protein phosphatase 6 regulatory ankyrin repeat subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(171091, NULL, 'G3DSA:1.25.10.10:FF:001890', NULL, NULL, 'C11.1, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(171092, NULL, 'G3DSA:3.80.10.10:FF:003236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(171093, NULL, 'G3DSA:2.40.37.20:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171094, NULL, 'G3DSA:1.25.10.10:FF:001648', NULL, NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(171095, NULL, 'G3DSA:1.10.520.10:FF:000041', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(171096, NULL, 'G3DSA:3.40.50.300:FF:002180', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(171097, NULL, 'G3DSA:1.20.1560.10:FF:000747', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171098, NULL, 'G3DSA:2.130.10.10:FF:002522', NULL, NULL, 'AGAP005330-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(171099, NULL, 'G3DSA:2.60.40.10:FF:005271', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171100, NULL, 'G3DSA:3.40.50.720:FF:001018', NULL, NULL, '4-phosphoerythronate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(171101, NULL, 'G3DSA:2.40.10.10:FF:000290', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171102, NULL, 'G3DSA:3.40.50.300:FF:001775', NULL, NULL, 'Protein virC1', NULL, NULL, NULL, NULL, NULL, 4),
(171103, NULL, 'G3DSA:3.40.50.2000:FF:000991', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171104, NULL, 'G3DSA:3.30.70.680:FF:000001', NULL, NULL, 'Tumor necrosis factor receptor type 1-associated DEATH domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(171105, NULL, 'G3DSA:3.30.420.40:FF:000552', NULL, NULL, 'Related to ARP5-Actin-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(171106, NULL, 'G3DSA:2.20.70.10:FF:000013', NULL, NULL, 'E3 ubiquitin-protein ligase HECW2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(171107, NULL, 'G3DSA:3.40.50.12660:FF:000012', NULL, NULL, 'Metacaspase', NULL, NULL, NULL, NULL, NULL, 4),
(171108, NULL, 'G3DSA:1.25.40.10:FF:003185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171109, NULL, 'G3DSA:2.60.120.920:FF:000034', NULL, NULL, 'Fibronectin type III and SPRY domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(171110, NULL, 'G3DSA:3.30.200.20:FF:001491', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171111, NULL, 'G3DSA:1.25.40.10:FF:002965', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(171112, NULL, 'G3DSA:3.40.1090.10:FF:000020', NULL, NULL, 'neuropathy target esterase-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(171113, NULL, 'G3DSA:2.60.40.10:FF:001937', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171114, NULL, 'G3DSA:1.10.287.70:FF:000689', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171115, NULL, 'G3DSA:3.30.930.10:FF:000436', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(171116, NULL, 'G3DSA:3.90.190.10:FF:000455', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171117, NULL, 'G3DSA:2.130.10.10:FF:005580', NULL, NULL, 'Chromosome 16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(171118, NULL, 'G3DSA:3.30.230.40:FF:000009', NULL, NULL, 'Imidazoleglycerol-phosphate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(171119, NULL, 'G3DSA:1.20.5.4770:FF:000012', NULL, NULL, 'GD13604', NULL, NULL, NULL, NULL, NULL, 4),
(171120, NULL, 'G3DSA:3.30.160.60:FF:001774', NULL, NULL, 'Myoneurin', NULL, NULL, NULL, NULL, NULL, 4),
(171121, NULL, 'G3DSA:3.30.70.330:FF:001262', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(171122, NULL, 'G3DSA:2.130.10.10:FF:005338', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171123, NULL, 'G3DSA:3.40.50.150:FF:000257', NULL, NULL, '16S rRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(171124, NULL, 'G3DSA:1.20.1280.50:FF:000108', NULL, NULL, 'F-box domain containing protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(171125, NULL, 'G3DSA:1.10.8.10:FF:000028', NULL, NULL, 'ATP-dependent protease ATPase subunit HslU', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(171126, NULL, 'G3DSA:1.20.140.10:FF:000150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171127, NULL, 'G3DSA:2.40.50.800:FF:000001', NULL, NULL, 'Single-stranded TG1-3 telomere G-tails binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(171128, NULL, 'G3DSA:3.40.50.300:FF:002028', NULL, NULL, 'Related to GTR1-GTP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(171129, NULL, 'G3DSA:3.30.70.330:FF:001913', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171130, NULL, 'G3DSA:3.30.200.20:FF:001249', NULL, NULL, 'Serine/threonine-protein kinase-like protein At5g23170', NULL, NULL, NULL, NULL, NULL, 4),
(171131, NULL, 'G3DSA:2.60.40.10:FF:005922', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171132, NULL, 'G3DSA:3.40.720.10:FF:000053', NULL, NULL, 'GPI ethanolamine phosphate transferase 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(171133, NULL, 'G3DSA:4.10.1240.10:FF:000038', NULL, NULL, 'Vasoactive intestinal peptide receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(171134, NULL, 'G3DSA:1.10.30.10:FF:000160', NULL, NULL, 'FACT complex subunit SSRP1', NULL, NULL, NULL, NULL, NULL, 4),
(171135, NULL, 'G3DSA:3.40.470.10:FF:000016', NULL, NULL, 'Uracil-DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(171136, NULL, 'G3DSA:3.40.50.2300:FF:001177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171137, NULL, 'G3DSA:3.40.640.10:FF:000052', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(171138, NULL, 'G3DSA:3.30.980.10:FF:000006', NULL, NULL, '39S ribosomal protein L39, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(171139, NULL, 'G3DSA:2.130.10.10:FF:001538', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(171140, NULL, 'G3DSA:3.40.50.300:FF:006541', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171141, NULL, 'G3DSA:3.40.30.10:FF:000805', NULL, NULL, 'Putative glutathione S-transferase C460.02c', NULL, NULL, NULL, NULL, NULL, 4),
(171142, NULL, 'G3DSA:2.130.10.10:FF:001595', NULL, NULL, 'Trichohyalin/putative WD40 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(171143, NULL, 'G3DSA:2.60.40.10:FF:001229', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(171144, NULL, 'G3DSA:3.40.50.2300:FF:001362', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171145, NULL, 'G3DSA:1.25.40.10:FF:003836', NULL, NULL, 'Gamma-soluble NSF attachment protein', NULL, NULL, NULL, NULL, NULL, 4),
(171146, NULL, 'G3DSA:3.40.50.2000:FF:000749', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171147, NULL, 'G3DSA:3.40.50.12670:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171148, NULL, 'G3DSA:2.60.200.40:FF:000038', NULL, NULL, 'Diacylglycerol kinase, delta', NULL, NULL, NULL, NULL, NULL, 4),
(171149, NULL, 'G3DSA:1.10.730.10:FF:000051', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(171150, NULL, 'G3DSA:1.10.8.10:FF:000270', NULL, NULL, 'E3 ubiquitin-protein ligase AMFR isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(171151, NULL, 'G3DSA:3.30.530.20:FF:000133', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(171152, NULL, 'G3DSA:1.25.40.10:FF:000402', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(171153, NULL, 'G3DSA:3.40.50.720:FF:001260', NULL, NULL, 'Nucleoside-diphosphate-sugar epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(171154, NULL, 'G3DSA:1.25.40.20:FF:000405', NULL, NULL, 'Serine/threonine-protein phosphatase 6 regulatory ankyrin repeat subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(171155, NULL, 'G3DSA:1.10.1450.10:FF:000163', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(171156, NULL, 'G3DSA:3.10.100.10:FF:000001', NULL, NULL, 'Hyaluronan proteoglycan link protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(171157, NULL, 'G3DSA:3.30.505.10:FF:000145', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(171158, NULL, 'G3DSA:1.10.8.470:FF:000002', NULL, NULL, 'Serine_hydrolase_(FSH1)/50S_ribosome-binding_GTPase/GTPase_of_uncharacterized_function_C-terminal_-_putative', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(171159, NULL, 'G3DSA:3.90.245.10:FF:000004', NULL, NULL, 'Probable uridine nucleosidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(171160, NULL, 'G3DSA:3.20.20.140:FF:000129', NULL, NULL, 'Related to guanine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(171161, NULL, 'G3DSA:2.60.40.2240:FF:000002', NULL, NULL, 'Acyl-CoA thioesterase 18', NULL, NULL, NULL, NULL, NULL, 4),
(171162, NULL, 'G3DSA:1.25.10.10:FF:002053', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(171163, NULL, 'G3DSA:2.60.200.20:FF:000122', NULL, NULL, 'Probable serine/threonine-protein kinase fhkC', NULL, NULL, NULL, NULL, NULL, 4),
(171164, NULL, 'G3DSA:2.10.70.10:FF:000098', NULL, NULL, 'Complement component 4 binding protein beta', NULL, NULL, NULL, NULL, NULL, 4),
(171165, NULL, 'G3DSA:3.20.20.140:FF:000039', NULL, NULL, 'Adenine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(171166, NULL, 'G3DSA:3.20.20.70:FF:000705', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171167, NULL, 'G3DSA:3.20.20.80:FF:000618', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171168, NULL, 'G3DSA:3.60.40.10:FF:000176', NULL, NULL, 'Protein phosphatase 2C 32', NULL, NULL, NULL, NULL, NULL, 4),
(171169, NULL, 'G3DSA:2.30.29.30:FF:001036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171170, NULL, 'G3DSA:3.20.20.140:FF:000281', NULL, NULL, 'Dihydroorotase', NULL, NULL, NULL, NULL, NULL, 4),
(171171, NULL, 'G3DSA:3.80.10.10:FF:003326', NULL, NULL, 'Si:ch211-191a16.5', NULL, NULL, NULL, NULL, NULL, 4),
(171172, NULL, 'G3DSA:3.30.160.60:FF:001589', NULL, NULL, 'putative transcription factor Ovo-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(171173, NULL, 'G3DSA:2.60.40.1180:FF:000027', NULL, NULL, 'Oligo-1,6-glucosidase IMA1', NULL, NULL, NULL, NULL, NULL, 4),
(171174, NULL, 'G3DSA:3.20.20.80:FF:000708', NULL, NULL, 'Amylo-alpha-1,6-glucosidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(171175, NULL, 'G3DSA:3.60.40.10:FF:000266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171176, NULL, 'G3DSA:3.40.50.300:FF:001718', NULL, NULL, 'Elongation factor Tu, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171177, NULL, 'G3DSA:1.20.1560.10:FF:000186', NULL, NULL, 'Long-chain fatty acid transporter subunit', NULL, NULL, NULL, NULL, NULL, 4),
(171178, NULL, 'G3DSA:3.30.70.2580:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171179, NULL, 'G3DSA:1.20.1560.10:FF:000894', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171180, NULL, 'G3DSA:1.10.30.10:FF:000103', NULL, NULL, 'HMG box-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(171181, NULL, 'G3DSA:1.10.510.10:FF:002052', NULL, NULL, 'Protein CBG25248', NULL, NULL, NULL, NULL, NULL, 4),
(171182, NULL, 'G3DSA:2.60.40.1170:FF:000024', NULL, NULL, 'AP-1 complex subunit mu, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171183, NULL, 'G3DSA:1.20.1280.50:FF:000165', NULL, NULL, 'F-box only protein 31', NULL, NULL, NULL, NULL, NULL, 4),
(171184, NULL, 'G3DSA:3.40.50.720:FF:000799', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(171185, NULL, 'G3DSA:3.30.70.2570:FF:000001', NULL, NULL, 'Translation factor GUF1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(171186, NULL, 'G3DSA:3.20.20.140:FF:000371', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171187, NULL, 'G3DSA:2.130.10.10:FF:005395', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171188, NULL, 'G3DSA:1.10.220.10:FF:000001', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(171189, NULL, 'G3DSA:2.130.10.10:FF:005956', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171190, NULL, 'G3DSA:2.60.120.10:FF:000641', NULL, NULL, 'D-lyxose ketol-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(171191, NULL, 'G3DSA:1.20.58.80:FF:000030', NULL, NULL, 'Regulator of free ubiquitin chains 1', NULL, NULL, NULL, NULL, NULL, 4),
(171192, NULL, 'G3DSA:3.40.50.720:FF:001636', NULL, NULL, 'Ketoreductase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(171193, NULL, 'G3DSA:2.60.40.1180:FF:000212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171194, NULL, 'G3DSA:3.20.20.60:FF:000051', NULL, NULL, 'Pyruvate kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(171195, NULL, 'G3DSA:1.10.3380.10:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171196, NULL, 'G3DSA:3.20.20.70:FF:000054', NULL, NULL, 'KHG/KDPG aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(171197, NULL, 'G3DSA:2.60.40.150:FF:000541', NULL, NULL, 'Translocation protein SEC63-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(171198, NULL, 'G3DSA:2.60.40.10:FF:005832', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171199, NULL, 'G3DSA:2.30.29.30:FF:000693', NULL, NULL, 'Pleckstrin domain-containing family J member 1', NULL, NULL, NULL, NULL, NULL, 4),
(171200, NULL, 'G3DSA:3.30.1310.10:FF:000012', NULL, NULL, 'Nucleoid-associated protein Tpet_0244', NULL, NULL, NULL, NULL, NULL, 4),
(171201, NULL, 'G3DSA:3.30.200.20:FF:001159', NULL, NULL, 'Si:ch73-206d17.1', NULL, NULL, NULL, NULL, NULL, 4),
(171202, NULL, 'G3DSA:3.30.10.20:FF:000010', NULL, NULL, 'Serine/threonine-protein kinase PknB', NULL, NULL, NULL, NULL, NULL, 4),
(171203, NULL, 'G3DSA:1.20.1310.20:FF:000002', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(171204, NULL, 'G3DSA:1.25.40.10:FF:003218', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(171205, NULL, 'G3DSA:2.130.10.10:FF:001685', NULL, NULL, 'WD domain, G-beta repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(171206, NULL, 'G3DSA:3.30.160.60:FF:004270', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171207, NULL, 'G3DSA:1.20.1250.20:FF:001082', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(171208, NULL, 'G3DSA:2.10.25.10:FF:000757', NULL, NULL, 'Fibrillin-1', NULL, NULL, NULL, NULL, NULL, 4),
(171209, NULL, 'G3DSA:3.40.50.300:FF:001977', NULL, NULL, 'Dynamin GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171210, NULL, 'G3DSA:1.25.10.10:FF:000344', NULL, NULL, 'Tubulin folding cofactor D', NULL, NULL, NULL, NULL, NULL, 4),
(171211, NULL, 'G3DSA:3.30.70.330:FF:003066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171212, NULL, 'G3DSA:2.130.10.10:FF:004326', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171213, NULL, 'G3DSA:3.40.50.300:FF:005193', NULL, NULL, 'Adenylate kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171214, NULL, 'G3DSA:2.30.330.10:FF:000006', NULL, NULL, 'SPI-2 type III secretion system apparatus protein SsaQ', NULL, NULL, NULL, NULL, NULL, 4),
(171215, NULL, 'G3DSA:1.20.5.110:FF:000358', NULL, NULL, 'Syntaxin 1A', NULL, NULL, NULL, NULL, NULL, 4),
(171216, NULL, 'G3DSA:3.80.10.10:FF:001651', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(171217, NULL, 'G3DSA:3.40.1110.10:FF:000079', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(171218, NULL, 'G3DSA:1.20.1560.10:FF:000899', NULL, NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 13', NULL, NULL, NULL, NULL, NULL, 4),
(171219, NULL, 'G3DSA:3.40.50.300:FF:004091', NULL, NULL, 'Tudor domain-containing 12', NULL, NULL, NULL, NULL, NULL, 4),
(171220, NULL, 'G3DSA:1.20.58.480:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171221, NULL, 'G3DSA:3.40.50.720:FF:002098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171222, NULL, 'G3DSA:3.60.21.10:FF:000435', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171223, NULL, 'G3DSA:3.40.50.150:FF:001100', NULL, NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(171224, NULL, 'G3DSA:2.130.10.10:FF:002202', NULL, NULL, 'Sema domain, transmembrane domain (TM), and cytoplasmic domain, (semaphorin) 6A', NULL, NULL, NULL, NULL, NULL, 4),
(171225, NULL, 'G3DSA:2.60.120.650:FF:000020', NULL, NULL, 'Lysine (K)-specific demethylase 5Bb', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(171226, NULL, 'G3DSA:3.40.30.10:FF:000070', NULL, NULL, 'Arsenate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(171227, NULL, 'G3DSA:1.20.5.170:FF:000269', NULL, NULL, 'ADR293C-Ap', NULL, NULL, NULL, NULL, NULL, 4),
(171228, NULL, 'G3DSA:2.40.10.10:FF:000020', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(171229, NULL, 'G3DSA:1.10.10.10:FF:001799', NULL, NULL, 'Selenocysteine-specific translation elongation factor SelB', NULL, NULL, NULL, NULL, NULL, 4),
(171230, NULL, 'G3DSA:1.20.58.60:FF:000777', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171231, NULL, 'G3DSA:3.60.21.10:FF:000340', NULL, NULL, 'YALI0D13640p', NULL, NULL, NULL, NULL, NULL, 4),
(171232, NULL, 'G3DSA:1.20.1270.60:FF:000055', NULL, NULL, 'Uncharacterized protein, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(171233, NULL, 'G3DSA:3.30.160.60:FF:006361', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171234, NULL, 'G3DSA:3.40.50.300:FF:007379', NULL, NULL, 'Dynamin 3', NULL, NULL, NULL, NULL, NULL, 4),
(171235, NULL, 'G3DSA:3.60.10.10:FF:000146', NULL, NULL, 'Endonuclease exonuclease phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(171236, NULL, 'G3DSA:3.90.1170.20:FF:000001', NULL, NULL, 'Nicotinate-nucleotide diphosphorylase (Carboxylating)', NULL, NULL, NULL, NULL, NULL, 4),
(171237, NULL, 'G3DSA:3.30.70.100:FF:000108', NULL, NULL, 'Stress responsive A/B Barrel Domain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171238, NULL, 'G3DSA:3.30.70.1230:FF:000133', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(171239, NULL, 'G3DSA:3.20.20.220:FF:000030', NULL, NULL, 'Methylenetetrahydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(171240, NULL, 'G3DSA:2.60.40.10:FF:003685', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171241, NULL, 'G3DSA:2.60.40.150:FF:000035', NULL, NULL, 'LOW QUALITY PROTEIN: E3 ubiquitin-protein ligase HECW2', NULL, NULL, NULL, NULL, NULL, 4),
(171242, NULL, 'G3DSA:3.40.50.300:FF:006182', NULL, NULL, '6-phosphofructo-2-kinase/fructose-2,6-biphosphatase 2b', NULL, NULL, NULL, NULL, NULL, 4),
(171243, NULL, 'G3DSA:1.10.10.60:FF:000151', NULL, NULL, 'histone H2A deubiquitinase MYSM1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(171244, NULL, 'G3DSA:1.10.8.60:FF:000138', NULL, NULL, 'ATP-dependent Clp protease ATP-binding subunit ClpX', NULL, NULL, NULL, NULL, NULL, 4),
(171245, NULL, 'G3DSA:1.10.630.10:FF:000633', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171246, NULL, 'G3DSA:3.40.50.1010:FF:000172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171247, NULL, 'G3DSA:2.30.310.10:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171248, NULL, 'G3DSA:2.60.40.10:FF:005776', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171249, NULL, 'G3DSA:3.30.160.60:FF:005372', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171250, NULL, 'G3DSA:1.10.601.10:FF:000004', NULL, NULL, 'RNA polymerase sigma factor sigA', NULL, NULL, NULL, NULL, NULL, 4),
(171251, NULL, 'G3DSA:2.10.220.10:FF:000014', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(171252, NULL, 'G3DSA:3.40.50.1820:FF:000881', NULL, NULL, 'Acyl-protein thioesterase 1 homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(171253, NULL, 'G3DSA:3.40.1500.10:FF:000002', NULL, NULL, 'oxygen-dependent coproporphyrinogen-III oxidase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(171254, NULL, 'G3DSA:1.10.1200.210:FF:000001', NULL, NULL, 'Chaperonin-like RBCX protein 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(171255, NULL, 'G3DSA:6.20.200.30:FF:000001', NULL, NULL, 'Prostaglandin E synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(171256, NULL, 'G3DSA:3.30.160.270:FF:000004', NULL, NULL, '2-isopropylmalate synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(171257, NULL, 'G3DSA:1.10.287.110:FF:000027', NULL, NULL, 'DnaJ (Hsp40) homolog, subfamily C, member 11', NULL, NULL, NULL, NULL, NULL, 4),
(171258, NULL, 'G3DSA:2.10.220.10:FF:000109', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(171259, NULL, 'G3DSA:2.102.20.10:FF:000001', NULL, NULL, 'Beta-galactosidase A', NULL, NULL, NULL, NULL, NULL, 4),
(171260, NULL, 'G3DSA:2.130.10.10:FF:004231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171261, NULL, 'G3DSA:3.30.70.1230:FF:000228', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(171262, NULL, 'G3DSA:3.30.160.60:FF:006035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171263, NULL, 'G3DSA:1.10.720.30:FF:000067', NULL, NULL, 'Vacuole membrane protein 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(171264, NULL, 'G3DSA:2.40.33.10:FF:000005', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(171265, NULL, 'G3DSA:3.20.10.10:FF:000024', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(171266, NULL, 'G3DSA:4.10.400.10:FF:000239', NULL, NULL, 'LDL receptor protein 1, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(171267, NULL, 'G3DSA:3.30.40.10:FF:001913', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171268, NULL, 'G3DSA:1.10.8.60:FF:000526', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(171269, NULL, 'G3DSA:3.40.50.200:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171270, NULL, 'G3DSA:2.60.40.10:FF:002550', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(171271, NULL, 'G3DSA:1.25.40.10:FF:003398', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At3g18840', NULL, NULL, NULL, NULL, NULL, 4),
(171272, NULL, 'G3DSA:1.20.5.900:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171273, NULL, 'G3DSA:1.20.1280.50:FF:000075', NULL, NULL, 'F-box protein SKIP1', NULL, NULL, NULL, NULL, NULL, 4),
(171274, NULL, 'G3DSA:3.40.630.30:FF:000411', NULL, NULL, 'protein O-GlcNAcase-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(171275, NULL, 'G3DSA:3.40.50.720:FF:001642', NULL, NULL, 'YALI0F09075p', NULL, NULL, NULL, NULL, NULL, 4),
(171276, NULL, 'G3DSA:3.30.160.60:FF:003859', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171277, NULL, 'G3DSA:1.10.287.130:FF:000264', NULL, NULL, 'Two component system histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(171278, NULL, 'G3DSA:3.40.50.2300:FF:001295', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171279, NULL, 'G3DSA:3.30.420.110:FF:000073', NULL, NULL, 'DNA mismatch repair protein MSH3', NULL, NULL, NULL, NULL, NULL, 4),
(171280, NULL, 'G3DSA:2.60.120.10:FF:000259', NULL, NULL, 'Cyclic nucleotide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(171281, NULL, 'G3DSA:1.20.58.2220:FF:000028', NULL, NULL, 'Formin-D', NULL, NULL, NULL, NULL, NULL, 4),
(171282, NULL, 'G3DSA:3.40.50.300:FF:001926', NULL, NULL, 'Putative GTP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(171283, NULL, 'G3DSA:3.10.580.10:FF:000115', NULL, NULL, 'Manganese-dependent inorganic pyrophosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171284, NULL, 'G3DSA:3.20.20.60:FF:000017', NULL, NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(171285, NULL, 'G3DSA:3.40.50.1000:FF:000264', NULL, NULL, 'TIGR01456 family HAD hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(171286, NULL, 'G3DSA:3.40.50.150:FF:000162', NULL, NULL, 'Orf1ab polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(171287, NULL, 'G3DSA:1.10.510.10:FF:003912', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171288, NULL, 'G3DSA:3.30.870.30:FF:000004', NULL, NULL, 'MIT domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(171289, NULL, 'G3DSA:2.130.10.10:FF:002140', NULL, NULL, 'WD domain, G-beta repeat/PFU (PLAA family ubiquitin binding), putative', NULL, NULL, NULL, NULL, NULL, 4),
(171290, NULL, 'G3DSA:3.40.50.1010:FF:000267', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171291, NULL, 'G3DSA:1.10.1040.10:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171292, NULL, 'G3DSA:3.30.160.60:FF:001089', NULL, NULL, 'zinc finger protein 140 isoform X2', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(171293, NULL, 'G3DSA:3.30.70.330:FF:001621', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171294, NULL, 'G3DSA:2.60.40.10:FF:003910', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171295, NULL, 'G3DSA:3.40.640.10:FF:000170', NULL, NULL, '4-aminobutyrate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(171296, NULL, 'G3DSA:3.30.420.40:FF:000985', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(171297, NULL, 'G3DSA:1.20.5.100:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171298, NULL, 'G3DSA:3.30.1360.120:FF:000037', NULL, NULL, 'Glycine cleavage T protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(171299, NULL, 'G3DSA:1.10.3380.10:FF:000040', NULL, NULL, 'Activating signal cointegrator 1 complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(171300, NULL, 'G3DSA:3.40.50.300:FF:005934', NULL, NULL, 'Type II secretion system protein, virB homolog (GspE-1)', NULL, NULL, NULL, NULL, NULL, 4),
(171301, NULL, 'G3DSA:3.30.160.60:FF:001768', NULL, NULL, 'Zinc finger and BTB domain-containing protein 45', NULL, NULL, NULL, NULL, NULL, 4),
(171302, NULL, 'G3DSA:3.80.10.10:FF:004198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171303, NULL, 'G3DSA:2.60.120.200:FF:000296', NULL, NULL, 'Cadherin-related hmr-1', NULL, NULL, NULL, NULL, NULL, 4),
(171304, NULL, 'G3DSA:3.40.50.410:FF:000083', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(171305, NULL, 'G3DSA:3.40.30.10:FF:000811', NULL, NULL, 'Glutathione S-transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171306, NULL, 'G3DSA:3.40.50.2060:FF:000020', NULL, NULL, 'Vacuolar protein sorting-associated protein 33A', NULL, NULL, NULL, NULL, NULL, 4),
(171307, NULL, 'G3DSA:3.40.50.720:FF:001428', NULL, NULL, 'CurK', NULL, NULL, NULL, NULL, NULL, 4),
(171308, NULL, 'G3DSA:1.25.40.10:FF:004758', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171309, NULL, 'G3DSA:3.40.980.10:FF:000009', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(171310, NULL, 'G3DSA:1.20.59.10:FF:000017', NULL, NULL, 'Chorismate mutase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(171311, NULL, 'G3DSA:3.90.1750.10:FF:000025', NULL, NULL, 'Putative E3 ubiquitin-protein ligase HECTD3', NULL, NULL, NULL, NULL, NULL, 4),
(171312, NULL, 'G3DSA:1.10.510.10:FF:002552', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171313, NULL, 'G3DSA:2.130.10.10:FF:003337', NULL, NULL, 'YALI0E28226p', NULL, NULL, NULL, NULL, NULL, 4),
(171314, NULL, 'G3DSA:3.60.21.10:FF:000109', NULL, NULL, 'UDP-2,3-diacylglucosamine hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(171315, NULL, 'G3DSA:1.10.287.110:FF:000078', NULL, NULL, 'Chaperone protein dnaJ 49', NULL, NULL, NULL, NULL, NULL, 4),
(171316, NULL, 'G3DSA:3.40.366.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171317, NULL, 'G3DSA:3.20.20.70:FF:000346', NULL, NULL, 'Thiamine-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(171318, NULL, 'G3DSA:2.30.29.30:FF:000159', NULL, NULL, 'mRNA-decapping enzyme-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(171319, NULL, 'G3DSA:2.30.110.10:FF:000063', NULL, NULL, 'Unplaced genomic scaffold supercont1.16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(171320, NULL, 'G3DSA:2.60.40.10:FF:000184', NULL, NULL, 'cell adhesion molecule 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(171321, NULL, 'G3DSA:3.40.50.300:FF:004411', NULL, NULL, 'Dynamin-like 120 kDa protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(171322, NULL, 'G3DSA:3.30.40.10:FF:001060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171323, NULL, 'G3DSA:3.30.420.10:FF:000178', NULL, NULL, 'Ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(171324, NULL, 'G3DSA:1.10.3260.10:FF:000042', NULL, NULL, 'Ligase4-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(171325, NULL, 'G3DSA:3.30.70.1320:FF:000008', NULL, NULL, 'RND multidrug efflux transporter', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(171326, NULL, 'G3DSA:2.120.10.80:FF:000020', NULL, NULL, 'Kelch repeat and BTB domain-containing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(171327, NULL, 'G3DSA:2.60.40.790:FF:000120', NULL, NULL, 'Related to SGT1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(171328, NULL, 'G3DSA:2.170.270.10:FF:000114', NULL, NULL, 'PR domain zinc finger protein 10-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(171329, NULL, 'G3DSA:3.30.710.10:FF:000397', NULL, NULL, 'BTB/POZ domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(171330, NULL, 'G3DSA:2.60.120.10:FF:000164', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(171331, NULL, 'G3DSA:3.30.565.10:FF:000210', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(171332, NULL, 'G3DSA:3.30.200.20:FF:001547', NULL, NULL, 'Probable protein kinase DDB_G0277539', NULL, NULL, NULL, NULL, NULL, 4),
(171333, NULL, 'G3DSA:2.130.10.10:FF:003388', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171334, NULL, 'G3DSA:3.50.50.60:FF:001097', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(171335, NULL, 'G3DSA:3.60.10.10:FF:000197', NULL, NULL, 'ANGeL-like deadenylase', NULL, NULL, NULL, NULL, NULL, 4),
(171336, NULL, 'G3DSA:3.30.930.10:FF:000262', NULL, NULL, 'Aminoacyl-tRNA synthetase, class II (D, K and N) domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(171337, NULL, 'G3DSA:1.20.960.10:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171338, NULL, 'G3DSA:2.40.50.150:FF:000031', NULL, NULL, 'DNA-directed RNA polymerase III subunit rpc2', NULL, NULL, NULL, NULL, NULL, 4),
(171339, NULL, 'G3DSA:1.20.120.1750:FF:000131', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(171340, NULL, 'G3DSA:3.30.70.330:FF:001672', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171341, NULL, 'G3DSA:2.170.270.10:FF:000002', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(171342, NULL, 'G3DSA:1.25.70.10:FF:000027', NULL, NULL, 'Os05g0413000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(171343, NULL, 'G3DSA:1.25.40.20:FF:000528', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(171344, NULL, 'G3DSA:3.30.450.20:FF:000576', NULL, NULL, 'Neuronal PAS domain protein 4a', NULL, NULL, NULL, NULL, NULL, 4),
(171345, NULL, 'G3DSA:1.10.472.80:FF:000123', NULL, NULL, 'GTPase activating protein, conserved', NULL, NULL, NULL, NULL, NULL, 4),
(171346, NULL, 'G3DSA:1.10.1420.10:FF:000009', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(171347, NULL, 'G3DSA:2.130.10.10:FF:000162', NULL, NULL, 'vacuolar protein sorting-associated protein 8 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(171348, NULL, 'G3DSA:1.25.10.10:FF:000018', NULL, NULL, 'E3 ubiquitin-protein ligase TRIP12 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(171349, NULL, 'G3DSA:2.60.120.260:FF:000639', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171350, NULL, 'G3DSA:3.90.70.80:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171351, NULL, 'G3DSA:3.40.50.450:FF:000083', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit beta 2', NULL, NULL, NULL, NULL, NULL, 4),
(171352, NULL, 'G3DSA:2.60.200.20:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171353, NULL, 'G3DSA:3.90.550.10:FF:000612', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171354, NULL, 'G3DSA:3.40.50.300:FF:004832', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(171355, NULL, 'G3DSA:2.40.50.100:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171356, NULL, 'G3DSA:3.30.70.980:FF:000040', NULL, NULL, 'Probable transcriptional regulatory protein XCC3027', NULL, NULL, NULL, NULL, NULL, 4),
(171357, NULL, 'G3DSA:2.130.10.120:FF:000003', NULL, NULL, 'Protease II', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(171358, NULL, 'G3DSA:1.10.510.10:FF:000186', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase', NULL, NULL, NULL, NULL, NULL, 4),
(171359, NULL, 'G3DSA:1.20.1110.10:FF:000080', NULL, NULL, 'Plasma membrane ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(171360, NULL, 'G3DSA:1.10.238.10:FF:001284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171361, NULL, 'G3DSA:1.25.10.10:FF:001704', NULL, NULL, 'Hsp70 nucleotide exchange factor FES1', NULL, NULL, NULL, NULL, NULL, 4),
(171362, NULL, 'G3DSA:2.60.120.200:FF:000649', NULL, NULL, 'Laminin subunit alpha 5', NULL, NULL, NULL, NULL, NULL, 4),
(171363, NULL, 'G3DSA:3.40.50.150:FF:001685', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171364, NULL, 'G3DSA:3.40.50.300:FF:005288', NULL, NULL, 'Shikimate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(171365, NULL, 'G3DSA:2.130.10.10:FF:003663', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171366, NULL, 'G3DSA:2.60.40.10:FF:000133', NULL, NULL, 'Neogenin isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(171367, NULL, 'G3DSA:3.30.160.60:FF:003455', NULL, NULL, 'ZNF749 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(171368, NULL, 'G3DSA:3.40.33.10:FF:000104', NULL, NULL, 'OSJNBb0096E05.15 protein', NULL, NULL, NULL, NULL, NULL, 4),
(171369, NULL, 'G3DSA:3.40.50.10090:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171370, NULL, 'G3DSA:1.10.1040.10:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171371, NULL, 'G3DSA:3.30.160.60:FF:006147', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171372, NULL, 'G3DSA:1.10.10.60:FF:001286', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171373, NULL, 'G3DSA:2.30.130.10:FF:000025', NULL, NULL, 'tRNA pseudouridine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(171374, NULL, 'G3DSA:1.10.510.10:FF:002226', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171375, NULL, 'G3DSA:3.30.160.60:FF:000633', NULL, NULL, 'Zinc finger and BTB domain containing 11', NULL, NULL, NULL, NULL, NULL, 4),
(171376, NULL, 'G3DSA:3.30.40.10:FF:002369', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(171377, NULL, 'G3DSA:1.10.3720.10:FF:000061', NULL, NULL, 'Peptide ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(171378, NULL, 'G3DSA:1.10.238.10:FF:000502', NULL, NULL, 'Probable calcium-binding protein CML30', NULL, NULL, NULL, NULL, NULL, 4),
(171379, NULL, 'G3DSA:4.10.240.10:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171380, NULL, 'G3DSA:1.10.8.60:FF:000464', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171381, NULL, 'G3DSA:3.40.50.300:FF:002320', NULL, NULL, 'Shikimate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(171382, NULL, 'G3DSA:3.30.70.330:FF:002869', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171383, NULL, 'G3DSA:3.70.10.10:FF:000005', NULL, NULL, 'Cell cycle checkpoint control protein', NULL, NULL, NULL, NULL, NULL, 4),
(171384, NULL, 'G3DSA:1.10.287.70:FF:000279', NULL, NULL, 'Cyclic nucleotide-gated ion channel 18', NULL, NULL, NULL, NULL, NULL, 4),
(171385, NULL, 'G3DSA:1.10.10.60:FF:000797', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', NULL, NULL, NULL, NULL, NULL, 4),
(171386, NULL, 'G3DSA:2.130.10.10:FF:005754', NULL, NULL, 'Protein CBG24565', NULL, NULL, NULL, NULL, NULL, 4),
(171387, NULL, 'G3DSA:2.60.40.10:FF:002224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171388, NULL, 'G3DSA:1.50.40.10:FF:000400', NULL, NULL, 'Carnitine/acylcarnitine translocase', NULL, NULL, NULL, NULL, NULL, 4),
(171389, NULL, 'G3DSA:2.130.10.10:FF:001297', NULL, NULL, 'RNA polymerase II Elongator subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171390, NULL, 'G3DSA:1.10.510.10:FF:000135', NULL, NULL, 'Putative myosin light chain kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(171391, NULL, 'G3DSA:1.10.268.10:FF:000004', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(171392, NULL, 'G3DSA:3.30.200.20:FF:002036', NULL, NULL, 'Serine/threonine-protein kinase fray1', NULL, NULL, NULL, NULL, NULL, 4),
(171393, NULL, 'G3DSA:2.130.10.10:FF:000111', NULL, NULL, 'Transcriptional repressor rco-1', NULL, NULL, NULL, NULL, NULL, 4),
(171394, NULL, 'G3DSA:3.30.40.10:FF:001172', NULL, NULL, 'Elfless, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(171395, NULL, 'G3DSA:1.10.1740.10:FF:000005', NULL, NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(171396, NULL, 'G3DSA:1.10.630.10:FF:000307', NULL, NULL, 'Protein CBG06602', NULL, NULL, NULL, NULL, NULL, 4),
(171397, NULL, 'G3DSA:2.60.40.790:FF:000171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171398, NULL, 'G3DSA:3.30.230.70:FF:000001', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(171399, NULL, 'G3DSA:1.10.10.60:FF:000100', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(171400, NULL, 'G3DSA:3.40.50.1820:FF:000976', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171401, NULL, 'G3DSA:3.30.420.110:FF:000022', NULL, NULL, 'DNA mismatch repair protein Msh1', NULL, NULL, NULL, NULL, NULL, 4),
(171402, NULL, 'G3DSA:4.10.680.10:FF:000001', NULL, NULL, 'activated CDC42 kinase 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(171403, NULL, 'G3DSA:1.25.10.10:FF:001479', NULL, NULL, 'eIF-2-alpha kinase activator GCN1', NULL, NULL, NULL, NULL, NULL, 4),
(171404, NULL, 'G3DSA:3.40.109.10:FF:000020', NULL, NULL, 'Oxygen-insensitive NADPH nitroreductase', NULL, NULL, NULL, NULL, NULL, 4),
(171405, NULL, 'G3DSA:3.40.50.720:FF:001316', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171406, NULL, 'G3DSA:3.10.110.10:FF:000007', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 2', NULL, NULL, NULL, NULL, NULL, 4),
(171407, NULL, 'G3DSA:3.30.200.20:FF:000350', NULL, NULL, 'Cyclin-dependent kinase e-1', NULL, NULL, NULL, NULL, NULL, 4),
(171408, NULL, 'G3DSA:1.10.287.160:FF:000014', NULL, NULL, 'Protein Kinase N (PKN) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(171409, NULL, 'G3DSA:2.60.120.330:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171410, NULL, 'G3DSA:3.40.50.1820:FF:001605', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171411, NULL, 'G3DSA:3.40.50.300:FF:003517', NULL, NULL, 'Activator 1 subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171412, NULL, 'G3DSA:1.20.5.110:FF:000184', NULL, NULL, 'Qb-SNARE protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171413, NULL, 'G3DSA:1.20.58.390:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171414, NULL, 'G3DSA:1.20.1070.10:FF:001334', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171415, NULL, 'G3DSA:3.30.70.330:FF:000778', NULL, NULL, 'RNA-binding protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(171416, NULL, 'G3DSA:2.60.40.60:FF:000120', NULL, NULL, 'Protocadherin 8', NULL, NULL, NULL, NULL, NULL, 4),
(171417, NULL, 'G3DSA:3.40.630.10:FF:000225', NULL, NULL, 'YALI0A20416p', NULL, NULL, NULL, NULL, NULL, 4),
(171418, NULL, 'G3DSA:3.10.20.90:FF:000094', NULL, NULL, 'Sorting nexin-17 isoform1', NULL, NULL, NULL, NULL, NULL, 4),
(171419, NULL, 'G3DSA:1.20.1270.280:FF:000021', NULL, NULL, 'Dynein heavy chain at 16F', NULL, NULL, NULL, NULL, NULL, 4),
(171420, NULL, 'G3DSA:3.30.830.10:FF:000001', NULL, NULL, 'Mitochondrial-processing peptidase subunit beta, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(171421, NULL, 'G3DSA:3.40.50.2300:FF:001570', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171422, NULL, 'G3DSA:3.30.160.60:FF:002550', NULL, NULL, 'Si:ch73-221f6.3', NULL, NULL, NULL, NULL, NULL, 4),
(171423, NULL, 'G3DSA:2.130.10.10:FF:001746', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171424, NULL, 'G3DSA:3.30.70.260:FF:000049', NULL, NULL, 'Diaminopimelate decarboxylase, putative', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(171425, NULL, 'G3DSA:2.130.10.10:FF:002314', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', NULL, NULL, NULL, NULL, NULL, 4),
(171426, NULL, 'G3DSA:1.10.530.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171427, NULL, 'G3DSA:1.10.287.940:FF:000001', NULL, NULL, 'P2X purinoceptor', NULL, NULL, NULL, NULL, NULL, 4),
(171428, NULL, 'G3DSA:3.60.21.10:FF:000261', NULL, NULL, 'Capsular biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(171429, NULL, 'G3DSA:1.10.1200.10:FF:000066', NULL, NULL, 'Phenyloxazoline synthase MbtB', NULL, NULL, NULL, NULL, NULL, 4),
(171430, NULL, 'G3DSA:3.30.70.100:FF:000029', NULL, NULL, 'Zinc/cadmium/lead-transporting P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(171431, NULL, 'G3DSA:3.30.40.10:FF:001560', NULL, NULL, 'Replication termination factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(171432, NULL, 'G3DSA:3.40.50.300:FF:002415', NULL, NULL, 'Probable ATP-dependent RNA helicase DDX28', NULL, NULL, NULL, NULL, NULL, 4),
(171433, NULL, 'G3DSA:3.30.70.330:FF:001054', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171434, NULL, 'G3DSA:3.30.70.1970:FF:000001', NULL, NULL, 'RET2, RNA editing complex MP57', NULL, NULL, NULL, NULL, NULL, 4),
(171435, NULL, 'G3DSA:1.10.287.950:FF:000004', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(171436, NULL, 'G3DSA:3.40.30.10:FF:000518', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(171437, NULL, 'G3DSA:3.30.160.60:FF:001982', NULL, NULL, 'MEP-1, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(171438, NULL, 'G3DSA:3.40.50.2000:FF:001098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171439, NULL, 'G3DSA:3.30.1680.10:FF:000005', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(171440, NULL, 'G3DSA:3.40.50.1220:FF:000066', NULL, NULL, 'NAD-dependent protein deacetylase sir-2.4', NULL, NULL, NULL, NULL, NULL, 4),
(171441, NULL, 'G3DSA:2.30.30.40:FF:000154', NULL, NULL, 'Alpha spectrin, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(171442, NULL, 'G3DSA:3.60.10.10:FF:000258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171443, NULL, 'G3DSA:1.20.1310.10:FF:000061', NULL, NULL, 'Related to cullulin 3', NULL, NULL, NULL, NULL, NULL, 4),
(171444, NULL, 'G3DSA:3.30.70.240:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171445, NULL, 'G3DSA:3.30.200.20:FF:001098', NULL, NULL, 'Spore coat protein S', NULL, NULL, NULL, NULL, NULL, 4),
(171446, NULL, 'G3DSA:2.60.40.10:FF:000212', NULL, NULL, 'Immunoglobulin kappa chain variable 12-38', NULL, NULL, NULL, NULL, NULL, 4),
(171447, NULL, 'G3DSA:3.30.70.1230:FF:000021', NULL, NULL, 'Adenylate cyclase type 10', NULL, NULL, NULL, NULL, NULL, 4),
(171448, NULL, 'G3DSA:2.40.160.60:FF:000011', NULL, NULL, 'Long-chain fatty acid transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(171449, NULL, 'G3DSA:2.10.50.10:FF:000063', NULL, NULL, 'signal peptide, CUB and EGF-like domain-containing protein 3 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(171450, NULL, 'G3DSA:1.20.58.1000:FF:000005', NULL, NULL, 'Copper homeostasis operon regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(171451, NULL, 'G3DSA:1.10.287.70:FF:000358', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171452, NULL, 'G3DSA:2.10.25.10:FF:000645', NULL, NULL, 'Protocadherin Fat 2', NULL, NULL, NULL, NULL, NULL, 4),
(171453, NULL, 'G3DSA:3.40.50.300:FF:000342', NULL, NULL, 'Protein strawberry notch homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(171454, NULL, 'G3DSA:3.10.280.10:FF:000019', NULL, NULL, 'Mitochondrial acidic protein MAM33', NULL, NULL, NULL, NULL, NULL, 4),
(171455, NULL, 'G3DSA:3.30.70.660:FF:000079', NULL, NULL, 'Zgc:56653 protein', NULL, NULL, NULL, NULL, NULL, 4),
(171456, NULL, 'G3DSA:2.30.30.30:FF:000151', NULL, NULL, 'Os01g0140500 protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(171457, NULL, 'G3DSA:2.30.30.100:FF:000166', NULL, NULL, 'SnRNP Sm related protein', NULL, NULL, NULL, NULL, NULL, 4),
(171458, NULL, 'G3DSA:2.60.40.10:FF:003859', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171459, NULL, 'G3DSA:3.10.20.740:FF:000002', NULL, NULL, 'NADH-quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(171460, NULL, 'G3DSA:3.40.50.20:FF:000085', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(171461, NULL, 'G3DSA:3.40.50.620:FF:000595', NULL, NULL, 'Diphthamide biosynthesis protein Dph6', NULL, NULL, NULL, NULL, NULL, 4),
(171462, NULL, 'G3DSA:2.30.29.30:FF:001148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171463, NULL, 'G3DSA:2.60.120.330:FF:000104', NULL, NULL, 'Validamycin A dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(171464, NULL, 'G3DSA:2.30.39.10:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171465, NULL, 'G3DSA:1.10.472.80:FF:000174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171466, NULL, 'G3DSA:3.40.50.300:FF:004214', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(171467, NULL, 'G3DSA:1.20.1250.20:FF:001143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171468, NULL, 'G3DSA:1.10.580.10:FF:000022', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(171469, NULL, 'G3DSA:1.10.418.10:FF:000151', NULL, NULL, 'Hook microtubule-tethering protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(171470, NULL, 'G3DSA:2.60.120.10:FF:000085', NULL, NULL, 'Cyclic nucleotide-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(171471, NULL, 'G3DSA:1.10.287.370:FF:000077', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(171472, NULL, 'G3DSA:1.10.10.60:FF:000504', NULL, NULL, 'Transcription factor RFX3', NULL, NULL, NULL, NULL, NULL, 4),
(171473, NULL, 'G3DSA:1.25.10.10:FF:001979', NULL, NULL, 'Protein CELLULOSE SYNTHASE INTERACTIVE 1', NULL, NULL, NULL, NULL, NULL, 4),
(171474, NULL, 'G3DSA:1.20.1110.10:FF:000141', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(171475, NULL, 'G3DSA:1.25.10.10:FF:002261', NULL, NULL, 'AGAP000048-PA', NULL, NULL, NULL, NULL, NULL, 4),
(171476, NULL, 'G3DSA:3.30.160.60:FF:000521', NULL, NULL, 'Krueppel-like factor 9', NULL, NULL, NULL, NULL, NULL, 4),
(171477, NULL, 'G3DSA:1.20.1560.10:FF:000692', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171478, NULL, 'G3DSA:1.20.120.530:FF:000011', NULL, NULL, 'Transcriptional regulator, GntR family', NULL, NULL, NULL, NULL, NULL, 4),
(171479, NULL, 'G3DSA:2.60.40.10:FF:001089', NULL, NULL, 'Titin novex-3', NULL, NULL, NULL, NULL, NULL, 4),
(171480, NULL, 'G3DSA:3.70.10.10:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171481, NULL, 'G3DSA:3.30.830.10:FF:000052', NULL, NULL, 'Ubiquinol-cytochrome c reductase core protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(171482, NULL, 'G3DSA:2.30.29.170:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171483, NULL, 'G3DSA:1.10.40.60:FF:000006', NULL, NULL, 'Type II secretion system protein K', NULL, NULL, NULL, NULL, NULL, 4),
(171484, NULL, 'G3DSA:2.60.120.10:FF:000490', NULL, NULL, 'YALI0F27819p', NULL, NULL, NULL, NULL, NULL, 4),
(171485, NULL, 'G3DSA:3.20.200.10:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171486, NULL, 'G3DSA:1.50.40.10:FF:000512', NULL, NULL, 'Mitochondrial fusion and transport protein ugo1', NULL, NULL, NULL, NULL, NULL, 4),
(171487, NULL, 'G3DSA:2.130.10.10:FF:000515', NULL, NULL, 'Autophagy-related 16, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(171488, NULL, 'G3DSA:3.90.850.10:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171489, NULL, 'G3DSA:3.40.720.10:FF:000171', NULL, NULL, 'Bisphosphoglycerate-independent phosphoglycerate mutase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(171490, NULL, 'G3DSA:3.40.50.1000:FF:000090', NULL, NULL, 'Putative transferase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(171491, NULL, 'G3DSA:1.20.1310.20:FF:000064', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(171492, NULL, 'G3DSA:4.10.280.10:FF:000038', NULL, NULL, 'achaete-scute homolog 3', NULL, NULL, NULL, NULL, NULL, 4),
(171493, NULL, 'G3DSA:3.20.20.10:FF:000064', NULL, NULL, 'Pyridoxal phosphate homeostasis protein', NULL, NULL, NULL, NULL, NULL, 4),
(171494, NULL, 'G3DSA:3.30.160.60:FF:003781', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171495, NULL, 'G3DSA:1.10.10.60:FF:001174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171496, NULL, 'G3DSA:2.30.42.10:FF:000566', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171497, NULL, 'G3DSA:3.30.780.10:FF:000019', NULL, NULL, 'Putative translation factor sui1', NULL, NULL, NULL, NULL, NULL, 4),
(171498, NULL, 'G3DSA:3.40.50.300:FF:002820', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(171499, NULL, 'G3DSA:3.40.50.11500:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171500, NULL, 'G3DSA:3.30.365.10:FF:000049', NULL, NULL, 'Isoquinoline 1-oxidoreductase, beta subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171501, NULL, 'G3DSA:3.30.40.10:FF:001234', NULL, NULL, 'Lysine (K)-specific demethylase 2Aa', NULL, NULL, NULL, NULL, NULL, 4),
(171502, NULL, 'G3DSA:2.30.29.30:FF:000485', NULL, NULL, 'Ran-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(171503, NULL, 'G3DSA:3.30.200.20:FF:001047', NULL, NULL, 'Elongation factor-2 kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171504, NULL, 'G3DSA:3.40.50.1010:FF:000093', NULL, NULL, 'Exonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171505, NULL, 'G3DSA:2.130.10.10:FF:001797', NULL, NULL, 'Ribosome biogenesis protein WDR12 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(171506, NULL, 'G3DSA:2.130.10.10:FF:002640', NULL, NULL, 'Sema domain, transmembrane domain (TM), and cytoplasmic domain, (semaphorin) 6D,-like', NULL, NULL, NULL, NULL, NULL, 4),
(171507, NULL, 'G3DSA:3.30.250.20:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171508, NULL, 'G3DSA:3.20.20.80:FF:000175', NULL, NULL, 'Alpha-1,3-glucan synthase Ags2', NULL, NULL, NULL, NULL, NULL, 4),
(171509, NULL, 'G3DSA:2.30.180.10:FF:000062', NULL, NULL, 'Vacuolar membrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171510, NULL, 'G3DSA:2.40.155.10:FF:000006', NULL, NULL, 'GD10735', NULL, NULL, NULL, NULL, NULL, 4),
(171511, NULL, 'G3DSA:1.10.10.440:FF:000053', NULL, NULL, 'TransCription Elongation Regulator homolog', NULL, NULL, NULL, NULL, NULL, 4),
(171512, NULL, 'G3DSA:3.40.50.1260:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171513, NULL, 'G3DSA:3.30.40.10:FF:001464', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171514, NULL, 'G3DSA:1.10.1580.10:FF:000021', NULL, NULL, 'Mitochondrial GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171515, NULL, 'G3DSA:3.40.50.720:FF:001142', NULL, NULL, 'NmrA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(171516, NULL, 'G3DSA:3.30.70.2190:FF:000005', NULL, NULL, 'FAD-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(171517, NULL, 'G3DSA:3.30.420.10:FF:000066', NULL, NULL, 'DNA polymerase theta', NULL, NULL, NULL, NULL, NULL, 4),
(171518, NULL, 'G3DSA:3.40.50.2000:FF:000867', NULL, NULL, 'UDP-N-acetylglucosamine 2-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(171519, NULL, 'G3DSA:1.10.1370.30:FF:000022', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(171520, NULL, 'G3DSA:3.30.1330.80:FF:000017', NULL, NULL, 'AT hook motif DNA-binding family protein', NULL, NULL, NULL, NULL, NULL, 4),
(171521, NULL, 'G3DSA:3.30.70.1450:FF:000002', NULL, NULL, 'Trk system potassium transporter TrkA', NULL, NULL, NULL, NULL, NULL, 4),
(171522, NULL, 'G3DSA:3.30.200.20:FF:001659', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171523, NULL, 'G3DSA:3.30.200.20:FF:001373', NULL, NULL, 'Eukaryotic translation initiation factor 2 alpha kinase 1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(171524, NULL, 'G3DSA:3.20.20.70:FF:000172', NULL, NULL, 'D-allulose-6-phosphate 3-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(171525, NULL, 'G3DSA:3.40.50.300:FF:006131', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(171526, NULL, 'G3DSA:2.120.10.80:FF:000132', NULL, NULL, 'F-box/kelch-repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(171527, NULL, 'G3DSA:1.20.1250.40:FF:000014', NULL, NULL, 'RNA polymerase II Rpb4 core protein', NULL, NULL, NULL, NULL, NULL, 4),
(171528, NULL, 'G3DSA:3.40.50.300:FF:003955', NULL, NULL, 'Ras homolog family member B', NULL, NULL, NULL, NULL, NULL, 4),
(171529, NULL, 'G3DSA:1.25.40.1010:FF:000003', NULL, NULL, 'N-alpha-acetyltransferase 15, NatA auxiliary subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171530, NULL, 'G3DSA:3.40.630.30:FF:000506', NULL, NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', NULL, NULL, NULL, NULL, NULL, 4),
(171531, NULL, 'G3DSA:2.20.70.10:FF:000131', NULL, NULL, 'WW domain-containing oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(171532, NULL, 'G3DSA:4.10.410.10:FF:000072', NULL, NULL, 'Kunitz-type serine protease inhibitor BmKTT-3', NULL, NULL, NULL, NULL, NULL, 4),
(171533, NULL, 'G3DSA:2.60.200.40:FF:000033', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(171534, NULL, 'G3DSA:2.40.30.130:FF:000043', NULL, NULL, 'Alanyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(171535, NULL, 'G3DSA:3.30.1330.60:FF:000011', NULL, NULL, 'Flagellar motor protein MotS', NULL, NULL, NULL, NULL, NULL, 4),
(171536, NULL, 'G3DSA:3.40.630.30:FF:000383', NULL, NULL, 'Amino-acid acetyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(171537, NULL, 'G3DSA:1.25.10.10:FF:001772', NULL, NULL, 'Cullin-associated NEDD8-dissociated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(171538, NULL, 'G3DSA:3.40.50.11720:FF:000005', NULL, NULL, '3-deoxy-D-manno-octulosonic acid transferase', NULL, NULL, NULL, NULL, NULL, 4),
(171539, NULL, 'G3DSA:3.30.70.80:FF:000020', NULL, NULL, 'Subtilisin-like serine protease Pen ch 13.0101', NULL, NULL, NULL, NULL, NULL, 4),
(171540, NULL, 'G3DSA:1.10.287.110:FF:000320', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171541, NULL, 'G3DSA:2.60.200.30:FF:000030', NULL, NULL, 'ATP-NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(171542, NULL, 'G3DSA:2.40.50.140:FF:001163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171543, NULL, 'G3DSA:3.80.10.10:FF:001325', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(171544, NULL, 'G3DSA:2.180.10.10:FF:000030', NULL, NULL, 'N-acetylglucosamine-1-phosphodiester alpha-N-acetylglucosaminidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171545, NULL, 'G3DSA:3.90.550.10:FF:000500', NULL, NULL, 'Slr1065 protein', NULL, NULL, NULL, NULL, NULL, 4),
(171546, NULL, 'G3DSA:3.40.50.1440:FF:000047', NULL, NULL, 'Tubulin delta chain', NULL, NULL, NULL, NULL, NULL, 4),
(171547, NULL, 'G3DSA:1.20.1110.10:FF:000192', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171548, NULL, 'G3DSA:1.10.565.10:FF:000161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171549, NULL, 'G3DSA:2.60.120.1000:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171550, NULL, 'G3DSA:3.30.160.60:FF:004118', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171551, NULL, 'G3DSA:1.25.40.1030:FF:000009', NULL, NULL, 'Secretory 16, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(171552, NULL, 'G3DSA:1.20.120.550:FF:000017', NULL, NULL, 'Microsomal glutathione S-transferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(171553, NULL, 'G3DSA:3.30.70.330:FF:001380', NULL, NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(171554, NULL, 'G3DSA:4.10.280.10:FF:000190', NULL, NULL, 'Protein INO4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171555, NULL, 'G3DSA:1.20.1070.10:FF:000699', NULL, NULL, 'Adenosine receptor A1', NULL, NULL, NULL, NULL, NULL, 4),
(171556, NULL, 'G3DSA:3.40.33.10:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(171557, NULL, 'G3DSA:3.30.70.1470:FF:000008', NULL, NULL, 'caspase-3', NULL, NULL, NULL, NULL, NULL, 4),
(171558, NULL, 'G3DSA:3.10.20.90:FF:000352', NULL, NULL, 'Protein phosphatase 1, regulatory subunit 13Ba', NULL, NULL, NULL, NULL, NULL, 4),
(171559, NULL, 'G3DSA:2.60.40.10:FF:004702', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171560, NULL, 'G3DSA:3.40.50.2300:FF:000755', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171561, NULL, 'G3DSA:3.40.50.1820:FF:000684', NULL, NULL, 'Protein CBG03928', NULL, NULL, NULL, NULL, NULL, 4),
(171562, NULL, 'G3DSA:3.40.50.12440:FF:000002', NULL, NULL, 'Anaerobic dimethyl sulfoxide reductase, A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(171563, NULL, 'G3DSA:3.30.200.20:FF:000884', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(171564, NULL, 'G3DSA:3.40.50.360:FF:000168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171565, NULL, 'G3DSA:1.20.5.110:FF:000307', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(171566, NULL, 'G3DSA:3.40.50.300:FF:008008', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(171567, NULL, 'G3DSA:1.50.40.10:FF:000158', NULL, NULL, 'Mitochondrial carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(171568, NULL, 'G3DSA:2.30.30.40:FF:000480', NULL, NULL, 'Positive regulator of CheA protein activity (CheW)', NULL, NULL, NULL, NULL, NULL, 4),
(171569, NULL, 'G3DSA:1.25.40.10:FF:001532', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(171570, NULL, 'G3DSA:1.10.8.10:FF:000152', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(171571, NULL, 'G3DSA:3.20.90.10:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171572, NULL, 'G3DSA:3.40.30.10:FF:000311', NULL, NULL, 'Thioredoxin-dependent peroxide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(171573, NULL, 'G3DSA:3.40.50.1390:FF:000010', NULL, NULL, 'Recombinase resolvase family', NULL, NULL, NULL, NULL, NULL, 4),
(171574, NULL, 'G3DSA:4.10.400.10:FF:000127', NULL, NULL, 'basement membrane-specific heparan sulfate proteoglycan core protein', NULL, NULL, NULL, NULL, NULL, 4),
(171575, NULL, 'G3DSA:3.40.190.10:FF:000949', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(171576, NULL, 'G3DSA:4.10.860.120:FF:000015', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(171577, NULL, 'G3DSA:1.25.40.660:FF:000019', NULL, NULL, 'Vacuolar protein sorting-associated protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(171578, NULL, 'G3DSA:3.40.50.11030:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171579, NULL, 'G3DSA:1.20.1270.130:FF:000004', NULL, NULL, 'Type III effector NopM1-1', NULL, NULL, NULL, NULL, NULL, 4),
(171580, NULL, 'G3DSA:3.80.10.10:FF:003096', NULL, NULL, 'Leucine-rich repeat-containing 41', NULL, NULL, NULL, NULL, NULL, 4),
(171581, NULL, 'G3DSA:3.30.1360.40:FF:000024', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(171582, NULL, 'G3DSA:2.60.40.10:FF:005708', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171583, NULL, 'G3DSA:3.40.50.1820:FF:000588', NULL, NULL, 'CocE/NonD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(171584, NULL, 'G3DSA:1.25.40.10:FF:002324', NULL, NULL, 'General transcription factor 3C polypeptide 3 (Transcription factor C subunit 4)', NULL, NULL, NULL, NULL, NULL, 4),
(171585, NULL, 'G3DSA:3.40.50.720:FF:000653', NULL, NULL, 'Voltage-gated Ion Channel (VIC) Superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(171586, NULL, 'G3DSA:3.30.960.10:FF:000005', NULL, NULL, 'Eukaryotic peptide chain release factor subunit 1-3', NULL, NULL, NULL, NULL, NULL, 4),
(171587, NULL, 'G3DSA:2.40.100.10:FF:000032', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(171588, NULL, 'G3DSA:1.10.20.10:FF:000018', NULL, NULL, 'Transcription initiation factor TFIID subunit 9', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(171589, NULL, 'G3DSA:3.40.30.10:FF:000923', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171590, NULL, 'G3DSA:3.30.70.330:FF:002695', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171591, NULL, 'G3DSA:1.25.40.20:FF:000175', NULL, NULL, 'protein fem-1 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(171592, NULL, 'G3DSA:1.10.238.110:FF:000024', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(171593, NULL, 'G3DSA:3.40.50.11040:FF:000015', NULL, NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', NULL, NULL, NULL, NULL, NULL, 4),
(171594, NULL, 'G3DSA:1.25.40.10:FF:000172', NULL, NULL, 'Tetratricopeptide repeat domain 28', NULL, NULL, NULL, NULL, NULL, 4),
(171595, NULL, 'G3DSA:3.30.9.10:FF:000099', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(171596, NULL, 'G3DSA:3.40.50.150:FF:000111', NULL, NULL, 'EEF1A lysine methyltransferase 4', NULL, NULL, NULL, NULL, NULL, 4),
(171597, NULL, 'G3DSA:3.30.70.3250:FF:000008', NULL, NULL, 'Ribonuclease P/MRP protein subunit POP5', NULL, NULL, NULL, NULL, NULL, 4),
(171598, NULL, 'G3DSA:3.90.70.10:FF:000204', NULL, NULL, 'Papain', NULL, NULL, NULL, NULL, NULL, 4),
(171599, NULL, 'G3DSA:1.25.10.10:FF:003396', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171600, NULL, 'G3DSA:3.30.420.40:FF:000400', NULL, NULL, 'Actin-related protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(171601, NULL, 'G3DSA:3.30.160.60:FF:001656', NULL, NULL, 'CCCTC-binding factor like', NULL, NULL, NULL, NULL, NULL, 4),
(171602, NULL, 'G3DSA:3.10.170.20:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171603, NULL, 'G3DSA:3.40.50.2300:FF:001244', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171604, NULL, 'G3DSA:1.20.1250.20:FF:001194', NULL, NULL, 'Putative integral membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(171605, NULL, 'G3DSA:2.30.180.10:FF:000011', NULL, NULL, 'Fasciclin-like arabinogalactan protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(171606, NULL, 'G3DSA:3.80.10.10:FF:004456', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(171607, NULL, 'G3DSA:3.40.50.150:FF:001393', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171608, NULL, 'G3DSA:3.10.105.10:FF:000091', NULL, NULL, 'Putative lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(171609, NULL, 'G3DSA:3.30.160.60:FF:005579', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171610, NULL, 'G3DSA:1.10.455.10:FF:000040', NULL, NULL, 'Mitochondrial ribosomal protein S7', NULL, NULL, NULL, NULL, NULL, 4),
(171611, NULL, 'G3DSA:2.60.40.10:FF:004141', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171612, NULL, 'G3DSA:3.40.1160.10:FF:000082', NULL, NULL, 'Glutamate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(171613, NULL, 'G3DSA:3.10.20.90:FF:000026', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 3 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(171614, NULL, 'G3DSA:1.10.510.10:FF:004025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171615, NULL, 'G3DSA:3.40.50.300:FF:004383', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171616, NULL, 'G3DSA:3.40.50.300:FF:001691', NULL, NULL, 'Probable ATP-dependent kinase TDA10', NULL, NULL, NULL, NULL, NULL, 4),
(171617, NULL, 'G3DSA:3.30.160.60:FF:002432', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171618, NULL, 'G3DSA:3.40.50.1110:FF:000033', NULL, NULL, 'Acyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(171619, NULL, 'G3DSA:3.40.50.11350:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171620, NULL, 'G3DSA:2.30.110.10:FF:000029', NULL, NULL, 'YGR017W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(171621, NULL, 'G3DSA:3.30.40.10:FF:001672', NULL, NULL, 'Lysine demethylase 5B', NULL, NULL, NULL, NULL, NULL, 4),
(171622, NULL, 'G3DSA:2.60.120.260:FF:000122', NULL, NULL, 'Anaphase-promoting complex subunit 10', NULL, NULL, NULL, NULL, NULL, 4),
(171623, NULL, 'G3DSA:3.40.50.410:FF:000318', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(171624, NULL, 'G3DSA:3.40.50.1100:FF:000030', NULL, NULL, 'Threonine synthase 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(171625, NULL, 'G3DSA:3.30.428.10:FF:000010', NULL, NULL, 'Galactose-1-phosphate uridylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(171626, NULL, 'G3DSA:2.130.10.10:FF:005136', NULL, NULL, 'Intraflagellar transport particle protein IFT140', NULL, NULL, NULL, NULL, NULL, 4),
(171627, NULL, 'G3DSA:2.30.30.190:FF:000024', NULL, NULL, 'CAP-Gly domain-containing linker protein 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(171628, NULL, 'G3DSA:1.10.238.10:FF:000261', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(171629, NULL, 'G3DSA:3.20.20.70:FF:000790', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171630, NULL, 'G3DSA:3.30.310.10:FF:000024', NULL, NULL, 'Transcription initiation factor-like protein (TFIID-like protein)', NULL, NULL, NULL, NULL, NULL, 4),
(171631, NULL, 'G3DSA:2.130.10.10:FF:001864', NULL, NULL, 'Cleavage stimulation factor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(171632, NULL, 'G3DSA:1.10.10.10:FF:001524', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171633, NULL, 'G3DSA:3.40.1110.10:FF:000371', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171634, NULL, 'G3DSA:2.60.40.640:FF:000036', NULL, NULL, 'beta-arrestin-2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(171635, NULL, 'G3DSA:3.10.20.30:FF:000115', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171636, NULL, 'G3DSA:3.40.630.30:FF:000057', NULL, NULL, 'N-acetylaspartate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(171637, NULL, 'G3DSA:1.20.58.60:FF:000485', NULL, NULL, 'Microtubule actin crosslinking factor 1a', NULL, NULL, NULL, NULL, NULL, 4),
(171638, NULL, 'G3DSA:1.10.287.470:FF:000074', NULL, NULL, 'HAE1 family efflux pump MFP component MexE', NULL, NULL, NULL, NULL, NULL, 4),
(171639, NULL, 'G3DSA:1.20.58.530:FF:000017', NULL, NULL, 'Chitin synthase ChsE', NULL, NULL, NULL, NULL, NULL, 4),
(171640, NULL, 'G3DSA:1.25.40.10:FF:001599', NULL, NULL, 'Mitochondrial import receptor subunit TOM20-3', NULL, NULL, NULL, NULL, NULL, 4),
(171641, NULL, 'G3DSA:2.40.160.210:FF:000013', NULL, NULL, 'Acyl-CoA thioesterase II', NULL, NULL, NULL, NULL, NULL, 4),
(171642, NULL, 'G3DSA:3.30.420.10:FF:000684', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171643, NULL, 'G3DSA:1.10.8.10:FF:000359', NULL, NULL, 'NOG1', NULL, NULL, NULL, NULL, NULL, 4),
(171644, NULL, 'G3DSA:3.30.420.270:FF:000008', NULL, NULL, 'Biopolymer transporter ExbD', NULL, NULL, NULL, NULL, NULL, 4),
(171645, NULL, 'G3DSA:2.60.120.10:FF:000613', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171646, NULL, 'G3DSA:3.40.1690.10:FF:000015', NULL, NULL, 'FlhB domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(171647, NULL, 'G3DSA:3.30.310.10:FF:000063', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(171648, NULL, 'G3DSA:2.60.40.150:FF:000327', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit gamma, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171649, NULL, 'G3DSA:3.30.1370.10:FF:000021', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein K, like', NULL, NULL, NULL, NULL, NULL, 4),
(171650, NULL, 'G3DSA:3.40.50.1820:FF:001139', NULL, NULL, 'Serine carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171651, NULL, 'G3DSA:2.20.25.240:FF:000003', NULL, NULL, 'Broad-complex core protein isoform 6', NULL, NULL, NULL, NULL, NULL, 4),
(171652, NULL, 'G3DSA:3.40.50.1260:FF:000050', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(171653, NULL, 'G3DSA:3.50.50.100:FF:000004', NULL, NULL, 'Pyridine nucleotide-disulfide oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(171654, NULL, 'G3DSA:1.20.1270.60:FF:000285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171655, NULL, 'G3DSA:3.30.420.10:FF:000627', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171656, NULL, 'G3DSA:1.10.472.10:FF:000181', NULL, NULL, 'Protein CBR-CIT-1.1', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(171657, NULL, 'G3DSA:1.10.238.10:FF:000210', NULL, NULL, 'NADPH oxidase 5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(171658, NULL, 'G3DSA:3.30.70.1020:FF:000008', NULL, NULL, 'Putative alpha,alpha-trehalose phosphate synthase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(171659, NULL, 'G3DSA:1.20.1560.10:FF:000624', NULL, NULL, 'ATP-binding cassette transporter, subfamily B, member 19, group MDR/PGP protein PpABCB19', NULL, NULL, NULL, NULL, NULL, 4),
(171660, NULL, 'G3DSA:3.30.160.60:FF:005658', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171661, NULL, 'G3DSA:2.60.120.460:FF:000002', NULL, NULL, 'Secondary thiamine-phosphate synthase enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(171662, NULL, 'G3DSA:1.20.5.110:FF:000072', NULL, NULL, 'Syntaxin, t-snare coiled-coil domain family', NULL, NULL, NULL, NULL, NULL, 4),
(171663, NULL, 'G3DSA:3.30.200.20:FF:001608', NULL, NULL, 'Kinase, CAMK unique', NULL, NULL, NULL, NULL, NULL, 4),
(171664, NULL, 'G3DSA:1.10.10.10:FF:002075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171665, NULL, 'G3DSA:1.20.58.390:FF:000104', NULL, NULL, 'AcetylCholine Receptor', NULL, NULL, NULL, NULL, NULL, 4),
(171666, NULL, 'G3DSA:2.30.30.140:FF:000099', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(171667, NULL, 'G3DSA:2.30.29.30:FF:001215', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(171668, NULL, 'G3DSA:3.30.2350.10:FF:000020', NULL, NULL, 'tRNA pseudouridine(55) synthase', NULL, NULL, NULL, NULL, NULL, 4),
(171669, NULL, 'G3DSA:2.130.10.10:FF:003949', NULL, NULL, 'RE68083p', NULL, NULL, NULL, NULL, NULL, 4),
(171670, NULL, 'G3DSA:3.40.50.410:FF:000375', NULL, NULL, 'voltage-dependent calcium channel subunit alpha-2/delta-1', NULL, NULL, NULL, NULL, NULL, 4),
(171671, NULL, 'G3DSA:2.60.120.330:FF:000222', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(171672, NULL, 'G3DSA:3.30.160.60:FF:003567', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171673, NULL, 'G3DSA:3.30.2350.20:FF:000023', NULL, NULL, 'Probable tRNA pseudouridine synthase D', NULL, NULL, NULL, NULL, NULL, 4),
(171674, NULL, 'G3DSA:1.20.1280.50:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171675, NULL, 'G3DSA:3.30.70.1010:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171676, NULL, 'G3DSA:1.10.20.10:FF:000344', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171677, NULL, 'G3DSA:3.40.140.10:FF:000143', NULL, NULL, 'Cytidine and dCMP deaminase domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(171678, NULL, 'G3DSA:3.20.20.140:FF:000483', NULL, NULL, '2-amino-3-carboxymuconate-6-semialdehyde decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(171679, NULL, 'G3DSA:1.10.860.10:FF:000004', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(171680, NULL, 'G3DSA:3.40.1110.10:FF:000258', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(171681, NULL, 'G3DSA:3.30.70.330:FF:002689', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171682, NULL, 'G3DSA:2.60.120.200:FF:000588', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(171683, NULL, 'G3DSA:1.10.287.1490:FF:000127', NULL, NULL, 'LD20207p', NULL, NULL, NULL, NULL, NULL, 4),
(171684, NULL, 'G3DSA:1.10.8.10:FF:000264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171685, NULL, 'G3DSA:3.60.140.10:FF:000009', NULL, NULL, 'Polyphenol oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(171686, NULL, 'G3DSA:2.30.29.30:FF:000698', NULL, NULL, 'Serine/threonine-protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171687, NULL, 'G3DSA:2.80.10.50:FF:000075', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(171688, NULL, 'G3DSA:1.20.1250.20:FF:001317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171689, NULL, 'G3DSA:3.40.50.300:FF:006210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(171690, NULL, 'G3DSA:3.30.160.60:FF:003955', NULL, NULL, 'Zinc finger protein 277', NULL, NULL, NULL, NULL, NULL, 4),
(171691, NULL, 'G3DSA:2.130.10.10:FF:001825', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', NULL, NULL, NULL, NULL, NULL, 4),
(171692, NULL, 'G3DSA:3.40.50.1820:FF:000476', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(171693, NULL, 'G3DSA:2.70.130.10:FF:000151', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171694, NULL, 'G3DSA:3.40.50.720:FF:000939', NULL, NULL, 'Protein CBG19189', NULL, NULL, NULL, NULL, NULL, 4),
(171695, NULL, 'G3DSA:2.10.70.10:FF:000160', NULL, NULL, 'Membrane cofactor protein', NULL, NULL, NULL, NULL, NULL, 4),
(171696, NULL, 'G3DSA:3.30.160.750:FF:000002', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(171697, NULL, 'G3DSA:3.40.50.300:FF:005642', NULL, NULL, 'ATP-binding subunit of ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(171698, NULL, 'G3DSA:3.30.390.50:FF:000001', NULL, NULL, 'Xanthine dehydrogenase oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(171699, NULL, 'G3DSA:3.30.420.10:FF:000532', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171700, NULL, 'G3DSA:2.60.120.40:FF:000032', NULL, NULL, 'Tumor necrosis factor ligand superfamily member 9', NULL, NULL, NULL, NULL, NULL, 4),
(171701, NULL, 'G3DSA:1.25.40.180:FF:000246', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171702, NULL, 'G3DSA:2.160.20.80:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171703, NULL, 'G3DSA:3.30.1600.10:FF:000017', NULL, NULL, 'SIR2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(171704, NULL, 'G3DSA:2.20.230.10:FF:000001', NULL, NULL, 'Signal peptide protein, YSIRK family', NULL, NULL, NULL, NULL, NULL, 4),
(171705, NULL, 'G3DSA:1.20.120.350:FF:000058', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(171706, NULL, 'G3DSA:3.30.160.60:FF:004562', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171707, NULL, 'G3DSA:3.30.710.10:FF:000279', NULL, NULL, 'Kelch repeat and BTB domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(171708, NULL, 'G3DSA:3.30.160.60:FF:005990', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171709, NULL, 'G3DSA:1.20.5.190:FF:000101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171710, NULL, 'G3DSA:1.20.5.4770:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171711, NULL, 'G3DSA:3.30.390.60:FF:000004', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(171712, NULL, 'G3DSA:4.10.1060.10:FF:000058', NULL, NULL, 'Nuclear pore complex protein Nup153-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(171713, NULL, 'G3DSA:2.60.40.10:FF:003298', NULL, NULL, 'DLEC1, cilia and flagella associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(171714, NULL, 'G3DSA:1.10.555.10:FF:000121', NULL, NULL, 'Rho GTPase-activating protein gacJ', NULL, NULL, NULL, NULL, NULL, 4),
(171715, NULL, 'G3DSA:4.10.1080.10:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171716, NULL, 'G3DSA:3.30.420.10:FF:000296', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(171717, NULL, 'G3DSA:1.10.8.710:FF:000001', NULL, NULL, 'Dynein axonemal heavy chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(171718, NULL, 'G3DSA:3.30.9.10:FF:000032', NULL, NULL, 'L-2-hydroxyglutarate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(171719, NULL, 'G3DSA:1.10.10.10:FF:001299', NULL, NULL, 'Plectin/S10 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(171720, NULL, 'G3DSA:3.30.450.20:FF:000458', NULL, NULL, 'GAF domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(171721, NULL, 'G3DSA:3.80.10.10:FF:002657', NULL, NULL, 'Phytosulfokine receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(171722, NULL, 'G3DSA:3.40.1110.10:FF:000219', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(171723, NULL, 'G3DSA:1.10.8.720:FF:000004', NULL, NULL, 'Dynein heavy chain 5, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(171724, NULL, 'G3DSA:3.30.40.10:FF:000778', NULL, NULL, 'E3 ubiquitin-protein ligase RMA1H1 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(171725, NULL, 'G3DSA:3.40.50.300:FF:003725', NULL, NULL, 'Similar to AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(171726, NULL, 'G3DSA:1.25.40.10:FF:002959', NULL, NULL, 'Os09g0573000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(171727, NULL, 'G3DSA:3.30.160.60:FF:002224', NULL, NULL, 'AZF1p Zinc-finger transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(171728, NULL, 'G3DSA:1.10.530.10:FF:000069', NULL, NULL, 'Invertebrate LYSozyme', NULL, NULL, NULL, NULL, NULL, 4),
(171729, NULL, 'G3DSA:2.60.40.2690:FF:000002', NULL, NULL, 'Splicing factor 3a subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(171730, NULL, 'G3DSA:3.30.160.60:FF:000015', NULL, NULL, 'Zinc finger protein 569', NULL, NULL, NULL, NULL, NULL, 4),
(171731, NULL, 'G3DSA:3.80.10.10:FF:000595', NULL, NULL, 'EIN3-binding F-box protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(171732, NULL, 'G3DSA:3.40.720.10:FF:000345', NULL, NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171733, NULL, 'G3DSA:3.40.50.300:FF:005849', NULL, NULL, 'GTPase Era', NULL, NULL, NULL, NULL, NULL, 4),
(171734, NULL, 'G3DSA:2.130.10.10:FF:006030', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(171735, NULL, 'G3DSA:3.40.50.300:FF:006305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171736, NULL, 'G3DSA:1.20.5.340:FF:000056', NULL, NULL, 'Monopolin complex subunit CSM1', NULL, NULL, NULL, NULL, NULL, 4),
(171737, NULL, 'G3DSA:1.25.40.120:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171738, NULL, 'G3DSA:3.40.50.2000:FF:000985', NULL, NULL, 'Sucrose synthase 3', NULL, NULL, NULL, NULL, NULL, 4),
(171739, NULL, 'G3DSA:2.10.25.10:FF:000319', NULL, NULL, 'Dumpy, isoform P', NULL, NULL, NULL, NULL, NULL, 4),
(171740, NULL, 'G3DSA:3.40.50.2300:FF:001536', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171741, NULL, 'G3DSA:1.20.120.850:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171742, NULL, 'G3DSA:1.10.510.10:FF:004401', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171743, NULL, 'G3DSA:2.60.120.620:FF:000039', NULL, NULL, 'Phytanoyl-CoA dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(171744, NULL, 'G3DSA:3.40.50.300:FF:001359', NULL, NULL, 'ATPase GET3', NULL, NULL, NULL, NULL, NULL, 4),
(171745, NULL, 'G3DSA:1.10.510.10:FF:000074', NULL, NULL, 'G protein-coupled receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(171746, NULL, 'G3DSA:3.10.450.580:FF:000022', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(171747, NULL, 'G3DSA:3.90.850.10:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171748, NULL, 'G3DSA:3.40.50.300:FF:008334', NULL, NULL, 'Chromatin remodeling factor mit1', NULL, NULL, NULL, NULL, NULL, 4),
(171749, NULL, 'G3DSA:3.10.450.230:FF:000001', NULL, NULL, 'Type IV secretion system protein virB8', NULL, NULL, NULL, NULL, NULL, 4),
(171750, NULL, 'G3DSA:3.10.450.240:FF:000004', NULL, NULL, 'Mitochondrial import inner membrane translocase subunit TIM44', NULL, NULL, NULL, NULL, NULL, 4),
(171751, NULL, 'G3DSA:1.25.10.10:FF:001884', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(171752, NULL, 'G3DSA:1.10.225.10:FF:000023', NULL, NULL, 'Granulysin', NULL, NULL, NULL, NULL, NULL, 4),
(171753, NULL, 'G3DSA:2.170.190.11:FF:000002', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(171754, NULL, 'G3DSA:3.10.400.10:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171755, NULL, 'G3DSA:3.40.50.150:FF:000083', NULL, NULL, '7SK snRNA methylphosphate capping enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(171756, NULL, 'G3DSA:2.70.150.10:FF:000146', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(171757, NULL, 'G3DSA:2.80.10.50:FF:000007', NULL, NULL, 'Fibroblast growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(171758, NULL, 'G3DSA:3.40.1170.60:FF:000024', NULL, NULL, 'DNA polymerase kappa', NULL, NULL, NULL, NULL, NULL, 4),
(171759, NULL, 'G3DSA:2.10.90.10:FF:000155', NULL, NULL, 'Vascular endothelial growth factor B', NULL, NULL, NULL, NULL, NULL, 4),
(171760, NULL, 'G3DSA:2.60.40.60:FF:000007', NULL, NULL, 'Protocadherin alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(171761, NULL, 'G3DSA:3.40.50.1820:FF:000358', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(171762, NULL, 'G3DSA:3.30.70.330:FF:001554', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(171763, NULL, 'G3DSA:2.30.40.10:FF:000163', NULL, NULL, 'Metal-dependent hydrolase, subgroup D', NULL, NULL, NULL, NULL, NULL, 4),
(171764, NULL, 'G3DSA:1.10.10.60:FF:001168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171765, NULL, 'G3DSA:2.130.10.10:FF:001179', NULL, NULL, 'Transcription factor tau 60 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(171766, NULL, 'G3DSA:3.30.160.60:FF:000133', NULL, NULL, 'Zinc finger protein 347', NULL, NULL, NULL, NULL, NULL, 4),
(171767, NULL, 'G3DSA:1.20.1070.10:FF:001542', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171768, NULL, 'G3DSA:3.90.76.10:FF:000004', NULL, NULL, 'Peptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(171769, NULL, 'G3DSA:3.40.640.10:FF:000411', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171770, NULL, 'G3DSA:2.40.30.10:FF:000206', NULL, NULL, 'NADPH-cytochrome p450 reductase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(171771, NULL, 'G3DSA:1.10.510.10:FF:000017', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(171772, NULL, 'G3DSA:3.30.200.20:FF:001665', NULL, NULL, 'Kinase, CMGC RCK', NULL, NULL, NULL, NULL, NULL, 4),
(171773, NULL, 'G3DSA:3.40.50.10190:FF:000333', NULL, NULL, 'Breast cancer type 1 susceptibility protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(171774, NULL, 'G3DSA:1.20.1300.10:FF:000021', NULL, NULL, 'Succinate dehydrogenase hydrophobic membrane anchor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(171775, NULL, 'G3DSA:2.40.110.10:FF:000010', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(171776, NULL, 'G3DSA:1.10.287.70:FF:000684', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171777, NULL, 'G3DSA:2.60.120.480:FF:000008', NULL, NULL, 'Ureidoglycolate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(171778, NULL, 'G3DSA:3.40.50.1820:FF:001370', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171779, NULL, 'G3DSA:3.30.450.20:FF:000363', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(171780, NULL, 'G3DSA:3.40.50.261:FF:000010', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(171781, NULL, 'G3DSA:1.25.40.10:FF:001824', NULL, NULL, 'Selenium binding protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(171782, NULL, 'G3DSA:1.20.200.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171783, NULL, 'G3DSA:3.40.50.1820:FF:001252', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(171784, NULL, 'G3DSA:2.60.40.790:FF:000053', NULL, NULL, '17.5 kDa class I heat shock protein', NULL, NULL, NULL, NULL, NULL, 4),
(171785, NULL, 'G3DSA:3.20.20.70:FF:000413', NULL, NULL, 'tRNA-dihydrouridine(16/17) synthase (NAD(P)(+))', NULL, NULL, NULL, NULL, NULL, 4),
(171786, NULL, 'G3DSA:1.20.1730.10:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171787, NULL, 'G3DSA:1.10.4080.10:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171788, NULL, 'G3DSA:1.10.10.10:FF:000164', NULL, NULL, 'Transcriptional regulator, Rrf2 family', NULL, NULL, NULL, NULL, NULL, 4),
(171789, NULL, 'G3DSA:2.40.20.10:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(171790, NULL, 'G3DSA:1.10.1870.10:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171791, NULL, 'G3DSA:1.10.287.470:FF:000017', NULL, NULL, 'RND family efflux transporter, MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(171792, NULL, 'G3DSA:3.10.290.10:FF:000014', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(171793, NULL, 'G3DSA:2.60.120.470:FF:000005', NULL, NULL, 'AT08565p', NULL, NULL, NULL, NULL, NULL, 4),
(171794, NULL, 'G3DSA:3.20.100.10:FF:000010', NULL, NULL, 'mRNA capping enzyme subunit beta, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171795, NULL, 'G3DSA:2.160.10.10:FF:000132', NULL, NULL, 'Acetyltransferase CysE/LacA/LpxA/NodL family', NULL, NULL, NULL, NULL, NULL, 4),
(171796, NULL, 'G3DSA:3.60.20.40:FF:000015', NULL, NULL, 'Putative gamma-glutamyltranspeptidase GgtB', NULL, NULL, NULL, NULL, NULL, 4),
(171797, NULL, 'G3DSA:3.40.30.10:FF:000069', NULL, NULL, 'Chloride intracellular channel 2', NULL, NULL, NULL, NULL, NULL, 4),
(171798, NULL, 'G3DSA:3.30.160.60:FF:002319', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171799, NULL, 'G3DSA:3.40.50.2300:FF:000221', NULL, NULL, 'Two component transcriptional regulator DevR', NULL, NULL, NULL, NULL, NULL, 4),
(171800, NULL, 'G3DSA:1.25.40.10:FF:000407', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(171801, NULL, 'G3DSA:3.40.30.10:FF:000631', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(171802, NULL, 'G3DSA:3.30.360.20:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171803, NULL, 'G3DSA:3.40.1110.10:FF:000466', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171804, NULL, 'G3DSA:3.10.50.40:FF:000154', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(171805, NULL, 'G3DSA:3.60.20.30:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171806, NULL, 'G3DSA:3.30.160.60:FF:000072', NULL, NULL, 'zinc finger protein 143 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(171807, NULL, 'G3DSA:2.30.29.30:FF:000985', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171808, NULL, 'G3DSA:1.10.10.10:FF:000630', NULL, NULL, 'DNA replication licensing factor (Mcm)', NULL, NULL, NULL, NULL, NULL, 4),
(171809, NULL, 'G3DSA:2.60.210.10:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171810, NULL, 'G3DSA:3.40.720.10:FF:000137', NULL, NULL, 'Phosphatidylinositol-glycan biosynthesis class O protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171811, NULL, 'G3DSA:3.10.290.20:FF:000017', NULL, NULL, 'Ubiquitin-activating enzyme E1-like', NULL, NULL, NULL, NULL, NULL, 4),
(171812, NULL, 'G3DSA:1.25.40.10:FF:000200', NULL, NULL, 'protein sel-1 homolog 1 precursor', NULL, NULL, NULL, NULL, NULL, 4),
(171813, NULL, 'G3DSA:3.40.50.300:FF:005754', NULL, NULL, 'F0F1 ATP synthase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(171814, NULL, 'G3DSA:3.80.10.10:FF:001033', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase GSO1', NULL, NULL, NULL, NULL, NULL, 4),
(171815, NULL, 'G3DSA:3.80.10.10:FF:001090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171816, NULL, 'G3DSA:3.40.80.10:FF:000016', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(171817, NULL, 'G3DSA:3.40.630.150:FF:000023', NULL, NULL, 'Malonyl-CoA decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(171818, NULL, 'G3DSA:3.90.550.10:FF:000051', NULL, NULL, 'Alpha-1,2-mannosyltransferase (Ktr4)', NULL, NULL, NULL, NULL, NULL, 4),
(171819, NULL, 'G3DSA:3.30.160.20:FF:000149', NULL, NULL, 'Double stranded RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(171820, NULL, 'G3DSA:3.30.360.10:FF:000010', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(171821, NULL, 'G3DSA:3.30.70.330:FF:003145', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171822, NULL, 'G3DSA:1.10.630.10:FF:000083', NULL, NULL, 'Thromboxane A synthase 1', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(171823, NULL, 'G3DSA:3.40.50.300:FF:004006', NULL, NULL, 'DEAD/DEAH box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(171824, NULL, 'G3DSA:2.60.40.340:FF:000002', NULL, NULL, 'Nuclear factor of activated T-cells 5, tonicity-responsive', NULL, NULL, NULL, NULL, NULL, 4),
(171825, NULL, 'G3DSA:3.30.70.330:FF:001267', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(171826, NULL, 'G3DSA:3.90.550.10:FF:000730', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171827, NULL, 'G3DSA:3.40.50.1700:FF:000047', NULL, NULL, 'Beta-glucosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171828, NULL, 'G3DSA:3.30.40.10:FF:000896', NULL, NULL, 'SNF2 domain-containing protein / helicase domain-containing protein / zinc finger protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(171829, NULL, 'G3DSA:1.25.40.10:FF:005135', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g04810, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(171830, NULL, 'G3DSA:3.20.20.80:FF:000416', NULL, NULL, 'Putative lysosomal beta-galactosid', NULL, NULL, NULL, NULL, NULL, 4),
(171831, NULL, 'G3DSA:1.25.40.180:FF:000038', NULL, NULL, 'Nuclear cap-binding protein subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(171832, NULL, 'G3DSA:1.20.120.1240:FF:000057', NULL, NULL, 'Dynamin-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171833, NULL, 'G3DSA:3.80.10.10:FF:003124', NULL, NULL, 'NLR family, pyrin domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(171834, NULL, 'G3DSA:3.30.930.10:FF:000054', NULL, NULL, 'Histidine--tRNA ligase chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(171835, NULL, 'G3DSA:2.40.70.10:FF:000203', NULL, NULL, 'YALI0D02024p', NULL, NULL, NULL, NULL, NULL, 4),
(171836, NULL, 'G3DSA:2.80.10.50:FF:000064', NULL, NULL, 'Fascin', NULL, NULL, NULL, NULL, NULL, 4),
(171837, NULL, 'G3DSA:3.40.50.300:FF:007199', NULL, NULL, 'Mevalonate-3-phosphate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(171838, NULL, 'G3DSA:3.30.310.80:FF:000056', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(171839, NULL, 'G3DSA:3.30.1330.30:FF:000143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171840, NULL, 'G3DSA:3.90.260.10:FF:000011', NULL, NULL, 'DNA repair protein RAD4', NULL, NULL, NULL, NULL, NULL, 4),
(171841, NULL, 'G3DSA:1.10.287.660:FF:000018', NULL, NULL, 'Si:ch211-284f22.3', NULL, NULL, NULL, NULL, NULL, 4),
(171842, NULL, 'G3DSA:3.40.1190.10:FF:000033', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(171843, NULL, 'G3DSA:1.20.1070.10:FF:001042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171844, NULL, 'G3DSA:3.30.70.330:FF:001060', NULL, NULL, 'Mip6p', NULL, NULL, NULL, NULL, NULL, 4),
(171845, NULL, 'G3DSA:1.10.10.10:FF:001592', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyl transferase PigF', NULL, NULL, NULL, NULL, NULL, 4),
(171846, NULL, 'G3DSA:1.20.120.980:FF:000005', NULL, NULL, 'Clan SC, family S28, unassigned serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(171847, NULL, 'G3DSA:3.30.10.20:FF:000004', NULL, NULL, 'Serine/threonine-protein kinase B PknB', NULL, NULL, NULL, NULL, NULL, 4),
(171848, NULL, 'G3DSA:2.40.30.10:FF:000083', NULL, NULL, 'Eukaryotic elongation factor, selenocysteine-tRNA-specific', NULL, NULL, NULL, NULL, NULL, 4),
(171849, NULL, 'G3DSA:3.80.10.10:FF:001533', NULL, NULL, 'NACHT, LRR and PYD domains-containing protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(171850, NULL, 'G3DSA:1.10.760.10:FF:000114', NULL, NULL, 'Glr3801 protein', NULL, NULL, NULL, NULL, NULL, 4),
(171851, NULL, 'G3DSA:3.40.1620.60:FF:000003', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 1', NULL, NULL, NULL, NULL, NULL, 4),
(171852, NULL, 'G3DSA:3.10.20.30:FF:000003', NULL, NULL, 'Developmentally-regulated GTP-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(171853, NULL, 'G3DSA:1.25.10.10:FF:000170', NULL, NULL, 'Splicing factor 3B subunit 1', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(171854, NULL, 'G3DSA:2.60.120.620:FF:000073', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(171855, NULL, 'G3DSA:2.40.50.140:FF:001096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171856, NULL, 'G3DSA:1.20.1270.60:FF:000167', NULL, NULL, 'Bridging integrator 2', NULL, NULL, NULL, NULL, NULL, 4),
(171857, NULL, 'G3DSA:1.10.20.70:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171858, NULL, 'G3DSA:3.40.1190.20:FF:000036', NULL, NULL, 'Phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(171859, NULL, 'G3DSA:2.10.25.10:FF:000937', NULL, NULL, 'Putative thrombospondin', NULL, NULL, NULL, NULL, NULL, 4),
(171860, NULL, 'G3DSA:2.30.29.30:FF:000777', NULL, NULL, 'YALI0F15719p', NULL, NULL, NULL, NULL, NULL, 4),
(171861, NULL, 'G3DSA:3.30.10.30:FF:000007', NULL, NULL, 'Probable serine/threonine-protein kinase dyrk2', NULL, NULL, NULL, NULL, NULL, 4),
(171862, NULL, 'G3DSA:1.25.10.10:FF:000810', NULL, NULL, 'Splicing factor 3B subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(171863, NULL, 'G3DSA:3.20.20.70:FF:000138', NULL, NULL, 'NADPH dehydrogenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(171864, NULL, 'G3DSA:1.20.1070.10:FF:001328', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171865, NULL, 'G3DSA:1.20.5.190:FF:000112', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171866, NULL, 'G3DSA:2.60.40.150:FF:000215', NULL, NULL, 'Putative pre-mRNA-splicing helicase BRR2', NULL, NULL, NULL, NULL, NULL, 4),
(171867, NULL, 'G3DSA:2.60.11.10:FF:000004', NULL, NULL, 'Cytochrome c oxidase subunit 5B', NULL, NULL, NULL, NULL, NULL, 4),
(171868, NULL, 'G3DSA:2.60.40.1730:FF:000029', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(171869, NULL, 'G3DSA:2.60.120.10:FF:000725', NULL, NULL, 'cGMP-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(171870, NULL, 'G3DSA:1.10.287.70:FF:000066', NULL, NULL, 'Sodium leak channel non-selective protein', NULL, NULL, NULL, NULL, NULL, 4),
(171871, NULL, 'G3DSA:3.40.1360.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171872, NULL, 'G3DSA:3.40.50.2000:FF:000013', NULL, NULL, 'Bifunctional UDP-N-acetylglucosamine 2-epimerase/N-acetylmannosamine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(171873, NULL, 'G3DSA:1.10.1780.10:FF:000002', NULL, NULL, 'ATP-dependent Clp protease ATP-binding subunit ClpA', NULL, NULL, NULL, NULL, NULL, 4),
(171874, NULL, 'G3DSA:1.25.10.10:FF:002789', NULL, NULL, 'Tetratricopeptide repeat protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(171875, NULL, 'G3DSA:3.80.10.10:FF:002668', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(171876, NULL, 'G3DSA:1.10.287.3240:FF:000029', NULL, NULL, 'V-type ATPase V1 subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(171877, NULL, 'G3DSA:2.40.150.20:FF:000021', NULL, NULL, 'Ribosomal protein L14', NULL, NULL, NULL, NULL, NULL, 4),
(171878, NULL, 'G3DSA:3.40.50.1820:FF:001313', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(171879, NULL, 'G3DSA:2.40.100.10:FF:000127', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(171880, NULL, 'G3DSA:1.10.565.10:FF:000127', NULL, NULL, 'Thyroid hormone receptor', NULL, NULL, NULL, NULL, NULL, 4),
(171881, NULL, 'G3DSA:3.90.550.10:FF:000112', NULL, NULL, 'Cellulose synthase-like protein E1', NULL, NULL, NULL, NULL, NULL, 4),
(171882, NULL, 'G3DSA:3.20.20.330:FF:000012', NULL, NULL, 'Os01g0772900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(171883, NULL, 'G3DSA:3.10.170.20:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171884, NULL, 'G3DSA:1.20.58.60:FF:000608', NULL, NULL, 'Spectrin repeat containing nuclear envelope family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(171885, NULL, 'G3DSA:3.30.559.30:FF:000106', NULL, NULL, 'Tryptophan N-acetyltransferase ivoA', NULL, NULL, NULL, NULL, NULL, 4),
(171886, NULL, 'G3DSA:1.10.506.10:FF:000030', NULL, NULL, 'probable Ras GTPase-activating protein isoform X8', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(171887, NULL, 'G3DSA:1.10.3380.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171888, NULL, 'G3DSA:3.30.200.20:FF:001873', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171889, NULL, 'G3DSA:3.40.50.620:FF:000269', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(171890, NULL, 'G3DSA:3.30.70.330:FF:001346', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171891, NULL, 'G3DSA:3.90.132.10:FF:000023', NULL, NULL, 'GP63-like', NULL, NULL, NULL, NULL, NULL, 4),
(171892, NULL, 'G3DSA:3.30.10.10:FF:000001', NULL, NULL, 'Serine protease inhibitor, potato inhibitor I-type family protein', NULL, NULL, NULL, NULL, NULL, 4),
(171893, NULL, 'G3DSA:1.10.1410.10:FF:000071', NULL, NULL, 'Caffeine-induced protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(171894, NULL, 'G3DSA:2.130.10.130:FF:000006', NULL, NULL, 'Integrin, alpha 9', NULL, NULL, NULL, NULL, NULL, 4),
(171895, NULL, 'G3DSA:3.80.10.10:FF:000870', NULL, NULL, 'Leucine-rich repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(171896, NULL, 'G3DSA:3.90.1410.10:FF:000040', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(171897, NULL, 'G3DSA:3.40.50.300:FF:003568', NULL, NULL, 'ATPase ASNA1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(171898, NULL, 'G3DSA:1.10.510.10:FF:002434', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171899, NULL, 'G3DSA:3.30.420.10:FF:000419', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171900, NULL, 'G3DSA:1.20.58.2170:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171901, NULL, 'G3DSA:3.20.20.140:FF:000045', NULL, NULL, 'Amidohydrolase family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(171902, NULL, 'G3DSA:3.40.50.300:FF:004506', NULL, NULL, 'Repair helicase UvrD', NULL, NULL, NULL, NULL, NULL, 4),
(171903, NULL, 'G3DSA:2.60.40.3500:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171904, NULL, 'G3DSA:3.30.110.110:FF:000008', NULL, NULL, 'Double-strand break repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(171905, NULL, 'G3DSA:3.30.479.20:FF:000007', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(171906, NULL, 'G3DSA:3.10.450.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171907, NULL, 'G3DSA:2.60.60.20:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171908, NULL, 'G3DSA:3.40.50.360:FF:000056', NULL, NULL, 'NADPH-dependent diflavin oxidoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(171909, NULL, 'G3DSA:3.30.230.70:FF:000052', NULL, NULL, 'Exosome complex exonuclease RRP41, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171910, NULL, 'G3DSA:1.10.1650.20:FF:000001', NULL, NULL, 'Ribonucleoside-diphosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(171911, NULL, 'G3DSA:2.60.120.260:FF:000111', NULL, NULL, 'anaphase-promoting complex subunit 10 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(171912, NULL, 'G3DSA:1.20.58.80:FF:000024', NULL, NULL, 'Endosome-associated ubiquitin isopeptidase (AmsH)', NULL, NULL, NULL, NULL, NULL, 4),
(171913, NULL, 'G3DSA:3.20.20.70:FF:000621', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171914, NULL, 'G3DSA:3.40.50.1820:FF:000796', NULL, NULL, 'Putative serine carboxypeptidase-like 52', NULL, NULL, NULL, NULL, NULL, 4),
(171915, NULL, 'G3DSA:3.40.30.10:FF:000423', NULL, NULL, 'Thiol:disulfide interchange protein', NULL, NULL, NULL, NULL, NULL, 4),
(171916, NULL, 'G3DSA:3.30.70.890:FF:000064', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(171917, NULL, 'G3DSA:3.10.250.10:FF:000130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171918, NULL, 'G3DSA:1.10.8.60:FF:000352', NULL, NULL, 'Werner helicase-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(171919, NULL, 'G3DSA:1.10.238.10:FF:000614', NULL, NULL, 'Centrin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171920, NULL, 'G3DSA:3.40.50.150:FF:001797', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(171921, NULL, 'G3DSA:2.60.40.1180:FF:000033', NULL, NULL, 'Calpain-like cysteine peptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(171922, NULL, 'G3DSA:1.20.58.90:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171923, NULL, 'G3DSA:1.25.40.20:FF:000287', NULL, NULL, 'Uveal autoantigen with coiled-coil domains and ankyrin repeats', NULL, NULL, NULL, NULL, NULL, 4),
(171924, NULL, 'G3DSA:3.40.50.2020:FF:000019', NULL, NULL, 'Hypoxanthine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(171925, NULL, 'G3DSA:1.50.40.10:FF:000451', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171926, NULL, 'G3DSA:3.20.20.60:FF:000135', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(171927, NULL, 'G3DSA:2.10.25.10:FF:000550', NULL, NULL, 'Growth arrest-specific protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(171928, NULL, 'G3DSA:3.30.160.60:FF:005922', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171929, NULL, 'G3DSA:2.40.50.100:FF:000038', NULL, NULL, '50S ribosomal protein L27', NULL, NULL, NULL, NULL, NULL, 4),
(171930, NULL, 'G3DSA:1.20.1070.10:FF:001660', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(171931, NULL, 'G3DSA:1.10.167.10:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171932, NULL, 'G3DSA:3.10.105.10:FF:000057', NULL, NULL, 'ABC-type uncharacterized transport system, periplasmic component', NULL, NULL, NULL, NULL, NULL, 4),
(171933, NULL, 'G3DSA:3.40.50.300:FF:001769', NULL, NULL, 'ras-related protein RABF2a', NULL, NULL, NULL, NULL, NULL, 4),
(171934, NULL, 'G3DSA:1.10.287.110:FF:000106', NULL, NULL, 'Putative heat shock protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(171935, NULL, 'G3DSA:3.30.450.40:FF:000110', NULL, NULL, 'Histidine kinase sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(171936, NULL, 'G3DSA:3.30.479.10:FF:000004', NULL, NULL, '6-carboxytetrahydropterin synthase QueD', NULL, NULL, NULL, NULL, NULL, 4),
(171937, NULL, 'G3DSA:3.40.50.720:FF:000861', NULL, NULL, 'Shikimate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(171938, NULL, 'G3DSA:1.10.510.10:FF:000635', NULL, NULL, 'Casein kinase I', NULL, NULL, NULL, NULL, NULL, 4),
(171939, NULL, 'G3DSA:2.60.40.1170:FF:000030', NULL, NULL, 'AP-1 complex subunit mu-1', NULL, NULL, NULL, NULL, NULL, 4),
(171940, NULL, 'G3DSA:2.130.10.10:FF:005574', NULL, NULL, 'Vacuolar protein sorting/targeting protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(171941, NULL, 'G3DSA:2.60.260.20:FF:000070', NULL, NULL, 'DnaJ domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(171942, NULL, 'G3DSA:3.20.20.80:FF:000624', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171943, NULL, 'G3DSA:2.60.40.10:FF:002336', NULL, NULL, 'B-cell receptor CD22', NULL, NULL, NULL, NULL, NULL, 4),
(171944, NULL, 'G3DSA:3.40.50.620:FF:000887', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171945, NULL, 'G3DSA:2.10.25.10:FF:001213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171946, NULL, 'G3DSA:1.10.150.50:FF:000041', NULL, NULL, 'Chromosome 19 C19orf47 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(171947, NULL, 'G3DSA:1.10.730.20:FF:000003', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(171948, NULL, 'G3DSA:3.30.70.940:FF:000017', NULL, NULL, 'Transcription termination/antitermination protein NusG', NULL, NULL, NULL, NULL, NULL, 4),
(171949, NULL, 'G3DSA:1.25.40.10:FF:001189', NULL, NULL, 'Tetratricopeptide repeat domain 21A', NULL, NULL, NULL, NULL, NULL, 4),
(171950, NULL, 'G3DSA:2.60.120.200:FF:000762', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171951, NULL, 'G3DSA:3.20.20.80:FF:000293', NULL, NULL, 'Alpha-L-fucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(171952, NULL, 'G3DSA:3.40.190.290:FF:000025', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(171953, NULL, 'G3DSA:2.60.40.10:FF:003893', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(171954, NULL, 'G3DSA:2.30.30.140:FF:000088', NULL, NULL, 'Protein EMSY-LIKE 3', NULL, NULL, NULL, NULL, NULL, 4),
(171955, NULL, 'G3DSA:3.80.10.10:FF:003113', NULL, NULL, 'D111/G-patch domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(171956, NULL, 'G3DSA:3.20.20.70:FF:000290', NULL, NULL, '3-dehydroquinate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(171957, NULL, 'G3DSA:1.10.472.80:FF:000241', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171958, NULL, 'G3DSA:3.40.50.1000:FF:000730', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171959, NULL, 'G3DSA:1.10.238.20:FF:000056', NULL, NULL, 'IP02289p', NULL, NULL, NULL, NULL, NULL, 4),
(171960, NULL, 'G3DSA:3.30.420.40:FF:000900', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(171961, NULL, 'G3DSA:3.30.40.10:FF:001352', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(171962, NULL, 'G3DSA:3.40.50.2000:FF:000755', NULL, NULL, 'Os03g0757000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(171963, NULL, 'G3DSA:3.40.50.1100:FF:000294', NULL, NULL, 'Bifunctional D-cysteine desulfhydrase/1-aminocyclopropane-1-carboxylate deaminase mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(171964, NULL, 'G3DSA:3.40.50.300:FF:003489', NULL, NULL, 'ABC transporter G family member 39', NULL, NULL, NULL, NULL, NULL, 4),
(171965, NULL, 'G3DSA:3.40.50.300:FF:003843', NULL, NULL, 'Ras-associated protein 2-like, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(171966, NULL, 'G3DSA:1.20.1110.10:FF:000074', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(171967, NULL, 'G3DSA:4.10.1120.10:FF:000001', NULL, NULL, 'retinal rod rhodopsin-sensitive cGMP 3'',5''-cyclic phosphodiesterase subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(171968, NULL, 'G3DSA:1.20.120.1080:FF:000082', NULL, NULL, 'Putative RNA helicase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(171969, NULL, 'G3DSA:3.40.50.720:FF:001024', NULL, NULL, 'Oxidoreductase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(171970, NULL, 'G3DSA:3.90.180.10:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171971, NULL, 'G3DSA:3.40.50.2300:FF:001126', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171972, NULL, 'G3DSA:3.60.21.10:FF:000227', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(171973, NULL, 'G3DSA:3.40.50.150:FF:001179', NULL, NULL, 'PKS-NRPS hybrid synthetase psoA', NULL, NULL, NULL, NULL, NULL, 4),
(171974, NULL, 'G3DSA:3.10.250.10:FF:000017', NULL, NULL, 'CD6 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(171975, NULL, 'G3DSA:1.25.40.20:FF:000080', NULL, NULL, 'ankyrin repeat domain-containing protein 17 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(171976, NULL, 'G3DSA:3.40.50.2020:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171977, NULL, 'G3DSA:1.10.238.10:FF:000053', NULL, NULL, 'Putative testican-3 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(171978, NULL, 'G3DSA:3.40.50.150:FF:000044', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase I', NULL, NULL, NULL, NULL, NULL, 4),
(171979, NULL, 'G3DSA:3.90.1750.10:FF:000031', NULL, NULL, 'E3 ubiquitin-protein ligase TOM1', NULL, NULL, NULL, NULL, NULL, 4),
(171980, NULL, 'G3DSA:2.170.130.30:FF:000003', NULL, NULL, 'Transcobalamin 1', NULL, NULL, NULL, NULL, NULL, 4),
(171981, NULL, 'G3DSA:1.10.10.10:FF:000400', NULL, NULL, 'DiSHevelled related', NULL, NULL, NULL, NULL, NULL, 4),
(171982, NULL, 'G3DSA:3.40.50.2060:FF:000014', NULL, NULL, 'SNARE-interacting protein KEULE', NULL, NULL, NULL, NULL, NULL, 4),
(171983, NULL, 'G3DSA:1.10.510.10:FF:003862', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171984, NULL, 'G3DSA:3.30.860.10:FF:000003', NULL, NULL, 'Ribosomal protein S19, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(171985, NULL, 'G3DSA:3.30.160.60:FF:001538', NULL, NULL, 'Zinc finger 202 m1', NULL, NULL, NULL, NULL, NULL, 4),
(171986, NULL, 'G3DSA:2.10.220.10:FF:000222', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5a', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(171987, NULL, 'G3DSA:3.40.50.620:FF:000909', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171988, NULL, 'G3DSA:1.20.1050.80:FF:000022', NULL, NULL, 'UPF0507 protein YALI0E18612g', NULL, NULL, NULL, NULL, NULL, 4),
(171989, NULL, 'G3DSA:3.40.50.12160:FF:000008', NULL, NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(171990, NULL, 'G3DSA:4.10.75.10:FF:000014', NULL, NULL, 'Uromodulin-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(171991, NULL, 'G3DSA:1.10.10.160:FF:000025', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(171992, NULL, 'G3DSA:3.40.250.10:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(171993, NULL, 'G3DSA:3.30.160.60:FF:005580', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171994, NULL, 'G3DSA:3.30.160.60:FF:004023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171995, NULL, 'G3DSA:2.60.40.10:FF:005484', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(171996, NULL, 'G3DSA:3.50.50.60:FF:000658', NULL, NULL, 'Prenylcysteine oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(171997, NULL, 'G3DSA:3.30.40.10:FF:000857', NULL, NULL, 'E3 ubiquitin-protein ligase DTX3L', NULL, NULL, NULL, NULL, NULL, 4),
(171998, NULL, 'G3DSA:1.25.10.10:FF:002047', NULL, NULL, 'cytoskeleton-associated protein 5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(171999, NULL, 'G3DSA:2.40.420.20:FF:000059', NULL, NULL, 'Acriflavin resistance periplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(172000, NULL, 'G3DSA:1.10.1450.10:FF:000112', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(172001, NULL, 'G3DSA:3.20.20.80:FF:000854', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172002, NULL, 'G3DSA:3.90.1100.10:FF:000050', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(172003, NULL, 'G3DSA:1.20.58.1250:FF:000001', NULL, NULL, 'Tubulin-specific chaperone C', NULL, NULL, NULL, NULL, NULL, 4),
(172004, NULL, 'G3DSA:3.30.160.60:FF:003747', NULL, NULL, 'Zinc finger protein 1182', NULL, NULL, NULL, NULL, NULL, 4),
(172005, NULL, 'G3DSA:3.40.50.1000:FF:000056', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(172006, NULL, 'G3DSA:1.10.3080.10:FF:000056', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(172007, NULL, 'G3DSA:3.40.50.720:FF:001081', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] reductase FabG', NULL, NULL, NULL, NULL, NULL, 4),
(172008, NULL, 'G3DSA:1.10.10.390:FF:000009', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(172009, NULL, 'G3DSA:1.25.40.20:FF:000641', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(172010, NULL, 'G3DSA:3.40.50.2300:FF:001183', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172011, NULL, 'G3DSA:1.20.1640.10:FF:000102', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172012, NULL, 'G3DSA:2.60.120.620:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172013, NULL, 'G3DSA:3.30.200.20:FF:000030', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(172014, NULL, 'G3DSA:2.40.10.120:FF:000002', NULL, NULL, 'HtrA serine peptidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(172015, NULL, 'G3DSA:3.90.640.10:FF:000119', NULL, NULL, 'ARP5 actin related protein 5 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(172016, NULL, 'G3DSA:2.130.10.10:FF:001589', NULL, NULL, 'Mahjong, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(172017, NULL, 'G3DSA:3.40.50.11990:FF:000007', NULL, NULL, 'RNA polymerase-associated protein CDC73, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172018, NULL, 'G3DSA:4.10.280.10:FF:000072', NULL, NULL, 'enhancer of split mgamma protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(172019, NULL, 'G3DSA:2.20.25.10:FF:000066', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(172020, NULL, 'G3DSA:3.40.50.1010:FF:000059', NULL, NULL, 'Putative 5''-3'' exonuclease, N-terminal resolvase-like domain', NULL, NULL, NULL, NULL, NULL, 4),
(172021, NULL, 'G3DSA:3.30.470.160:FF:000002', NULL, NULL, 'Kinase', NULL, NULL, NULL, NULL, NULL, 4),
(172022, NULL, 'G3DSA:2.60.40.10:FF:002050', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(172023, NULL, 'G3DSA:1.10.8.60:FF:000077', NULL, NULL, 'Peroxisome biogenesis protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(172024, NULL, 'G3DSA:1.10.10.10:FF:001535', NULL, NULL, 'Subunit of ESCRT-II complex', NULL, NULL, NULL, NULL, NULL, 4),
(172025, NULL, 'G3DSA:4.10.1200.10:FF:000002', NULL, NULL, 'Nitrate reductase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(172026, NULL, 'G3DSA:4.10.1250.10:FF:000005', NULL, NULL, 'Glycine cleavage system T protein', NULL, NULL, NULL, NULL, NULL, 4),
(172027, NULL, 'G3DSA:4.10.1240.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172028, NULL, 'G3DSA:2.10.25.10:FF:000196', NULL, NULL, 'Fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(172029, NULL, 'G3DSA:3.40.50.2000:FF:001031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172030, NULL, 'G3DSA:3.40.50.11980:FF:000004', NULL, NULL, 'Telomerase-binding protein EST1A', NULL, NULL, NULL, NULL, NULL, 4),
(172031, NULL, 'G3DSA:3.30.60.30:FF:000105', NULL, NULL, 'AGAP010646-PA', NULL, NULL, NULL, NULL, NULL, 4),
(172032, NULL, 'G3DSA:3.30.200.20:FF:001255', NULL, NULL, 'CMGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(172033, NULL, 'G3DSA:3.30.1660.10:FF:000004', NULL, NULL, 'Calcium dodecin', NULL, NULL, NULL, NULL, NULL, 4),
(172034, NULL, 'G3DSA:2.60.40.10:FF:000307', NULL, NULL, 'collagen alpha-1(VII) chain isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(172035, NULL, 'G3DSA:1.20.1560.10:FF:000399', NULL, NULL, 'ATP-binding cassette transporter (ABC transporter) family C member 11', NULL, NULL, NULL, NULL, NULL, 4),
(172036, NULL, 'G3DSA:1.10.8.50:FF:000017', NULL, NULL, 'Fibronectin-binding protein / Fibrinogen-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(172037, NULL, 'G3DSA:3.40.640.10:FF:000001', NULL, NULL, 'Serine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(172038, NULL, 'G3DSA:3.40.50.1480:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172039, NULL, 'G3DSA:3.30.70.330:FF:001907', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172040, NULL, 'G3DSA:1.25.50.20:FF:000018', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(172041, NULL, 'G3DSA:2.10.50.10:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172042, NULL, 'G3DSA:2.40.128.310:FF:000001', NULL, NULL, 'Protein HRI1', NULL, NULL, NULL, NULL, NULL, 4),
(172043, NULL, 'G3DSA:1.20.1250.20:FF:001132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172044, NULL, 'G3DSA:2.40.30.20:FF:000024', NULL, NULL, 'Riboflavin synthase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(172045, NULL, 'G3DSA:3.40.5.120:FF:000007', NULL, NULL, 'Chromodomain-helicase-DNA-binding protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(172046, NULL, 'G3DSA:2.30.310.10:FF:000005', NULL, NULL, 'FbpA domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172047, NULL, 'G3DSA:3.40.50.1820:FF:000919', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(172048, NULL, 'G3DSA:2.40.30.30:FF:000027', NULL, NULL, 'Riboflavin biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(172049, NULL, 'G3DSA:1.10.10.10:FF:001816', NULL, NULL, 'Glr1376 protein', NULL, NULL, NULL, NULL, NULL, 4),
(172050, NULL, 'G3DSA:2.40.30.10:FF:000021', NULL, NULL, 'NADH-cytochrome b5 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(172051, NULL, 'G3DSA:1.10.10.580:FF:000010', NULL, NULL, 'DNA repair protein Rad21, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172052, NULL, 'G3DSA:1.25.40.10:FF:004123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(172053, NULL, 'G3DSA:3.40.50.1390:FF:000009', NULL, NULL, 'Recombinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(172054, NULL, 'G3DSA:3.40.50.150:FF:000049', NULL, NULL, '23S rRNA (uracil(747)-C(5))-methyltransferase RlmC', NULL, NULL, NULL, NULL, NULL, 4),
(172055, NULL, 'G3DSA:2.60.40.10:FF:002218', NULL, NULL, 'roundabout homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(172056, NULL, 'G3DSA:2.10.25.10:FF:001331', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(172057, NULL, 'G3DSA:3.30.160.60:FF:005366', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172058, NULL, 'G3DSA:3.20.20.60:FF:000056', NULL, NULL, 'Macrophomate synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172059, NULL, 'G3DSA:2.60.40.150:FF:000041', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(172060, NULL, 'G3DSA:3.40.50.300:FF:001983', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(172061, NULL, 'G3DSA:1.10.630.10:FF:000583', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172062, NULL, 'G3DSA:3.30.1490.180:FF:000022', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(172063, NULL, 'G3DSA:3.40.50.150:FF:000105', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(172064, NULL, 'G3DSA:3.90.1200.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172065, NULL, 'G3DSA:3.30.1370.100:FF:000033', NULL, NULL, 'DNA mismatch repair protein PMS1', NULL, NULL, NULL, NULL, NULL, 4),
(172066, NULL, 'G3DSA:3.40.50.150:FF:001628', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172067, NULL, 'G3DSA:3.40.50.300:FF:000353', NULL, NULL, 'Dynein axonemal heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(172068, NULL, 'G3DSA:1.10.437.10:FF:000009', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(172069, NULL, 'G3DSA:1.20.1740.10:FF:000054', NULL, NULL, 'Large neutral amino acids transporter small subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(172070, NULL, 'G3DSA:3.40.47.10:FF:000113', NULL, NULL, 'Putative 3-oxoacyl-(Acyl-carrier-protein) synthase III', NULL, NULL, NULL, NULL, NULL, 4),
(172071, NULL, 'G3DSA:3.30.230.120:FF:000004', NULL, NULL, 'Putative fucose kinase', NULL, NULL, NULL, NULL, NULL, 4),
(172072, NULL, 'G3DSA:1.20.144.10:FF:000001', NULL, NULL, 'Lipid phosphate phosphatase 2', NULL, NULL, NULL, NULL, NULL, 4),
(172073, NULL, 'G3DSA:3.30.160.20:FF:000088', NULL, NULL, 'Uncharacterized protein ZK632.2', NULL, NULL, NULL, NULL, NULL, 4),
(172074, NULL, 'G3DSA:2.60.40.10:FF:001499', NULL, NULL, 'Interleukin-27 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(172075, NULL, 'G3DSA:3.40.20.10:FF:000136', NULL, NULL, 'Actin depolymerizing protein', NULL, NULL, NULL, NULL, NULL, 4),
(172076, NULL, 'G3DSA:3.10.20.90:FF:000318', NULL, NULL, 'polycomb group protein Psc', NULL, NULL, NULL, NULL, NULL, 4),
(172077, NULL, 'G3DSA:3.40.5.100:FF:000001', NULL, NULL, 'Arsenite methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(172078, NULL, 'G3DSA:2.40.240.10:FF:000019', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(172079, NULL, 'G3DSA:3.40.50.800:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172080, NULL, 'G3DSA:3.30.1330.120:FF:000003', NULL, NULL, '2-methylcitrate dehydratase PrpD', NULL, NULL, NULL, NULL, NULL, 4),
(172081, NULL, 'G3DSA:3.90.70.10:FF:000322', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(172082, NULL, 'G3DSA:3.30.70.100:FF:000147', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172083, NULL, 'G3DSA:3.40.630.30:FF:000349', NULL, NULL, 'Glucosamine 6-phosphate N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(172084, NULL, 'G3DSA:4.10.400.10:FF:000301', NULL, NULL, 'Vitellogenin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(172085, NULL, 'G3DSA:4.10.860.120:FF:000004', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(172086, NULL, 'G3DSA:1.20.1110.10:FF:000023', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(172087, NULL, 'G3DSA:1.10.3080.10:FF:000090', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(172088, NULL, 'G3DSA:3.40.190.10:FF:000421', NULL, NULL, 'HTH-type transcriptional regulator IlvY', NULL, NULL, NULL, NULL, NULL, 4),
(172089, NULL, 'G3DSA:2.30.29.240:FF:000014', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(172090, NULL, 'G3DSA:3.90.226.10:FF:000022', NULL, NULL, 'methylglutaconyl-CoA hydratase, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(172091, NULL, 'G3DSA:3.80.10.10:FF:004248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172092, NULL, 'G3DSA:1.20.1250.20:FF:002329', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172093, NULL, 'G3DSA:3.40.50.300:FF:004624', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(172094, NULL, 'G3DSA:1.10.10.10:FF:001861', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(172095, NULL, 'G3DSA:3.40.710.10:FF:000018', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase dacB', NULL, NULL, NULL, NULL, NULL, 4),
(172096, NULL, 'G3DSA:1.20.120.1910:FF:000044', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(172097, NULL, 'G3DSA:3.40.109.10:FF:000014', NULL, NULL, 'Putative NAD(P)H nitroreductase acg', NULL, NULL, NULL, NULL, NULL, 4),
(172098, NULL, 'G3DSA:3.40.50.880:FF:000026', NULL, NULL, 'Protein/nucleic acid deglycase HchA', NULL, NULL, NULL, NULL, NULL, 4),
(172099, NULL, 'G3DSA:1.25.40.10:FF:003448', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(172100, NULL, 'G3DSA:3.90.228.10:FF:000072', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(172101, NULL, 'G3DSA:1.20.1740.10:FF:000161', NULL, NULL, 'Putative amino acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(172102, NULL, 'G3DSA:3.10.580.10:FF:000172', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(172103, NULL, 'G3DSA:3.40.50.720:FF:000647', NULL, NULL, 'YNL181W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(172104, NULL, 'G3DSA:4.10.240.10:FF:000187', NULL, NULL, 'Zcf21p', NULL, NULL, NULL, NULL, NULL, 4),
(172105, NULL, 'G3DSA:2.60.40.10:FF:004410', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172106, NULL, 'G3DSA:2.40.30.330:FF:000002', NULL, NULL, 'Protein CLP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(172107, NULL, 'G3DSA:1.20.1560.10:FF:000916', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172108, NULL, 'G3DSA:1.10.510.10:FF:000422', NULL, NULL, 'serine/threonine-protein kinase 17B', NULL, NULL, NULL, NULL, NULL, 4),
(172109, NULL, 'G3DSA:2.60.40.1280:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172110, NULL, 'G3DSA:3.40.50.11780:FF:000001', NULL, NULL, 'Major tail sheath protein', NULL, NULL, NULL, NULL, NULL, 4),
(172111, NULL, 'G3DSA:3.30.160.60:FF:004910', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172112, NULL, 'G3DSA:1.25.10.10:FF:001822', NULL, NULL, 'Protein CBG25999', NULL, NULL, NULL, NULL, NULL, 4),
(172113, NULL, 'G3DSA:2.40.50.140:FF:001157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172114, NULL, 'G3DSA:3.90.1750.10:FF:000082', NULL, NULL, 'Apoptosis-resistant E3 ubiquitin protein ligase 1', NULL, NULL, NULL, NULL, NULL, 4),
(172115, NULL, 'G3DSA:1.25.40.120:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172116, NULL, 'G3DSA:2.30.30.40:FF:000272', NULL, NULL, 'Chemotaxis protein CheW', NULL, NULL, NULL, NULL, NULL, 4),
(172117, NULL, 'G3DSA:3.20.20.70:FF:000059', NULL, NULL, 'N-ethylmaleimide reductase, FMN-linked', NULL, NULL, NULL, NULL, NULL, 4),
(172118, NULL, 'G3DSA:1.10.20.10:FF:000052', NULL, NULL, 'Histone H2A', NULL, NULL, NULL, NULL, NULL, 4),
(172119, NULL, 'G3DSA:3.30.200.20:FF:001367', NULL, NULL, 'Protein CBR-DYF-18', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(172120, NULL, 'G3DSA:3.30.230.130:FF:000007', NULL, NULL, 'Cullin-3A like', NULL, NULL, NULL, NULL, NULL, 4),
(172121, NULL, 'G3DSA:3.90.70.10:FF:000373', NULL, NULL, 'Probable papain cyctein protease', NULL, NULL, NULL, NULL, NULL, 4),
(172122, NULL, 'G3DSA:3.40.50.2000:FF:001036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172123, NULL, 'G3DSA:3.40.50.1440:FF:000160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172124, NULL, 'G3DSA:3.30.160.20:FF:000144', NULL, NULL, 'Protein CBG12024', NULL, NULL, NULL, NULL, NULL, 4),
(172125, NULL, 'G3DSA:1.20.1250.20:FF:001025', NULL, NULL, 'Solute carrier family 22 (organic cation transporter), member 21', NULL, NULL, NULL, NULL, NULL, 4),
(172126, NULL, 'G3DSA:1.10.8.60:FF:000470', NULL, NULL, 'ATPase, AAA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(172127, NULL, 'G3DSA:2.10.25.10:FF:000763', NULL, NULL, 'Matrilin-4', NULL, NULL, NULL, NULL, NULL, 4),
(172128, NULL, 'G3DSA:3.40.920.10:FF:000006', NULL, NULL, 'Sulfite reductase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(172129, NULL, 'G3DSA:2.130.10.10:FF:001477', NULL, NULL, 'WD domain, G-beta repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(172130, NULL, 'G3DSA:2.60.40.60:FF:000625', NULL, NULL, 'Cadherin-related neuronal receptor 9', NULL, NULL, NULL, NULL, NULL, 4),
(172131, NULL, 'G3DSA:3.40.50.150:FF:001679', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172132, NULL, 'G3DSA:1.25.40.10:FF:001324', NULL, NULL, 'Empty pericarp7', NULL, NULL, NULL, NULL, NULL, 4),
(172133, NULL, 'G3DSA:1.10.560.10:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172134, NULL, 'G3DSA:3.30.70.340:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172135, NULL, 'G3DSA:2.10.80.10:FF:000003', NULL, NULL, 'Dickkopf WNT-signaling pathway inhibitor 3', NULL, NULL, NULL, NULL, NULL, 4),
(172136, NULL, 'G3DSA:3.80.10.10:FF:001319', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase TDR', NULL, NULL, NULL, NULL, NULL, 4),
(172137, NULL, 'G3DSA:2.130.10.10:FF:003657', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172138, NULL, 'G3DSA:3.40.50.20:FF:000074', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(172139, NULL, 'G3DSA:3.40.630.10:FF:000017', NULL, NULL, 'Succinylglutamate desuccinylase', NULL, NULL, NULL, NULL, NULL, 4),
(172140, NULL, 'G3DSA:1.10.1790.10:FF:000003', NULL, NULL, 'Transcription antiterminator LicT', NULL, NULL, NULL, NULL, NULL, 4),
(172141, NULL, 'G3DSA:1.10.287.70:FF:000622', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172142, NULL, 'G3DSA:3.40.50.10130:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172143, NULL, 'G3DSA:3.30.70.260:FF:000167', NULL, NULL, 'ACT domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(172144, NULL, 'G3DSA:2.60.120.290:FF:000165', NULL, NULL, 'Cubilin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(172145, NULL, 'G3DSA:3.90.70.10:FF:000266', NULL, NULL, 'Ubiquitin-specific peptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(172146, NULL, 'G3DSA:4.10.780.10:FF:000003', NULL, NULL, 'Pyruvate:ferredoxin (Flavodoxin) oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(172147, NULL, 'G3DSA:1.10.3720.10:FF:000004', NULL, NULL, 'Sulfate transport system permease protein CysT', NULL, NULL, NULL, NULL, NULL, 4),
(172148, NULL, 'G3DSA:2.40.70.10:FF:000181', NULL, NULL, 'Acid extracellular protease', NULL, NULL, NULL, NULL, NULL, 4),
(172149, NULL, 'G3DSA:3.30.460.10:FF:000074', NULL, NULL, 'Repair DNA polymerase X', NULL, NULL, NULL, NULL, NULL, 4),
(172150, NULL, 'G3DSA:2.60.40.10:FF:004461', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172151, NULL, 'G3DSA:2.10.25.10:FF:000437', NULL, NULL, 'Laminin subunit alpha 5', NULL, NULL, NULL, NULL, NULL, 4),
(172152, NULL, 'G3DSA:1.10.472.80:FF:000185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172153, NULL, 'G3DSA:3.40.50.1820:FF:001813', NULL, NULL, 'Protein phosphatase methylesterase 1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(172154, NULL, 'G3DSA:2.60.40.10:FF:001881', NULL, NULL, 'immunoglobulin superfamily DCC subclass member 3', NULL, NULL, NULL, NULL, NULL, 4),
(172155, NULL, 'G3DSA:3.30.160.60:FF:004062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172156, NULL, 'G3DSA:3.30.70.920:FF:000011', NULL, NULL, 'Lrp/AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(172157, NULL, 'G3DSA:1.25.10.10:FF:000136', NULL, NULL, 'serine/threonine-protein kinase SMG1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(172158, NULL, 'G3DSA:3.40.50.11990:FF:000002', NULL, NULL, 'protein CDC73 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(172159, NULL, 'G3DSA:2.130.10.10:FF:005748', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172160, NULL, 'G3DSA:2.60.40.10:FF:000190', NULL, NULL, 'Ephrin type-A receptor 7', NULL, NULL, NULL, NULL, NULL, 4),
(172161, NULL, 'G3DSA:1.10.510.10:FF:001945', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(172162, NULL, 'G3DSA:3.30.40.10:FF:001054', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(172163, NULL, 'G3DSA:3.30.420.10:FF:000184', NULL, NULL, 'Gag-Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(172164, NULL, 'G3DSA:1.10.10.10:FF:000512', NULL, NULL, 'Chromatin modification-related protein YNG2', NULL, NULL, NULL, NULL, NULL, 4),
(172165, NULL, 'G3DSA:3.10.20.90:FF:000644', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172166, NULL, 'G3DSA:2.170.300.10:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172167, NULL, 'G3DSA:3.30.1780.10:FF:000007', NULL, NULL, 'YGL159W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(172168, NULL, 'G3DSA:3.30.70.1070:FF:000001', NULL, NULL, 'Cell division protein DedD', NULL, NULL, NULL, NULL, NULL, 4),
(172169, NULL, 'G3DSA:1.25.40.120:FF:000043', NULL, NULL, 'Protein farnesyltransferase alpha subunit / Protein geranylgeranyltransferase type I, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(172170, NULL, 'G3DSA:2.60.40.10:FF:000420', NULL, NULL, 'Sidekick cell adhesion molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(172171, NULL, 'G3DSA:3.40.50.300:FF:008216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172172, NULL, 'G3DSA:1.25.40.10:FF:001268', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(172173, NULL, 'G3DSA:3.30.300.30:FF:000029', NULL, NULL, 'Fatty-acid-CoA ligase FadD31', NULL, NULL, NULL, NULL, NULL, 4),
(172174, NULL, 'G3DSA:1.10.287.130:FF:000146', NULL, NULL, 'PAS domain S-box protein', NULL, NULL, NULL, NULL, NULL, 4),
(172175, NULL, 'G3DSA:1.10.20.10:FF:000007', NULL, NULL, 'Histone H4', NULL, NULL, NULL, NULL, NULL, 4),
(172176, NULL, 'G3DSA:1.25.10.10:FF:001766', NULL, NULL, 'Importin-alpha re-exporter protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172177, NULL, 'G3DSA:3.30.310.10:FF:000029', NULL, NULL, 'AP-2 complex subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(172178, NULL, 'G3DSA:3.30.559.10:FF:000269', NULL, NULL, 'GH02484p', NULL, NULL, NULL, NULL, NULL, 4),
(172179, NULL, 'G3DSA:1.10.418.60:FF:000025', NULL, NULL, 'Protein CBR-HIM-10', NULL, NULL, NULL, NULL, NULL, 4),
(172180, NULL, 'G3DSA:2.120.10.30:FF:000027', NULL, NULL, 'Regucalcin homologue', NULL, NULL, NULL, NULL, NULL, 4),
(172181, NULL, 'G3DSA:3.40.50.200:FF:000137', NULL, NULL, 'Tripeptidyl-peptidase 2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(172182, NULL, 'G3DSA:3.30.70.20:FF:000103', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172183, NULL, 'G3DSA:3.40.50.10130:FF:000012', NULL, NULL, 'ERCC1 nucleotide excision repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172184, NULL, 'G3DSA:3.30.160.60:FF:005692', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172185, NULL, 'G3DSA:1.10.287.70:FF:000566', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172186, NULL, 'G3DSA:3.40.50.300:FF:000134', NULL, NULL, 'Iron-enterobactin ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(172187, NULL, 'G3DSA:2.130.10.10:FF:003545', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172188, NULL, 'G3DSA:3.20.20.190:FF:000043', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(172189, NULL, 'G3DSA:2.10.25.10:FF:000488', NULL, NULL, 'von Willebrand factor D and EGF domains', NULL, NULL, NULL, NULL, NULL, 4),
(172190, NULL, 'G3DSA:1.10.1000.11:FF:000029', NULL, NULL, 'Protein transport protein sec72', NULL, NULL, NULL, NULL, NULL, 4),
(172191, NULL, 'G3DSA:3.40.710.10:FF:000176', NULL, NULL, 'Penicillin-binding protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(172192, NULL, 'G3DSA:3.30.40.10:FF:000565', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(172193, NULL, 'G3DSA:3.20.20.140:FF:000449', NULL, NULL, 'Sodium/hydrogen exchanger 2', NULL, NULL, NULL, NULL, NULL, 4),
(172194, NULL, 'G3DSA:2.60.40.10:FF:005658', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172195, NULL, 'G3DSA:4.10.400.10:FF:000071', NULL, NULL, 'Prolow-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(172196, NULL, 'G3DSA:3.30.360.10:FF:000066', NULL, NULL, 'Aspartate-semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(172197, NULL, 'G3DSA:3.10.110.10:FF:000125', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(172198, NULL, 'G3DSA:1.10.10.10:FF:000282', NULL, NULL, 'RNA polymerase sigma factor SigX', NULL, NULL, NULL, NULL, NULL, 4),
(172199, NULL, 'G3DSA:3.40.50.620:FF:000387', NULL, NULL, 'Probable nicotinate-nucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(172200, NULL, 'G3DSA:3.40.630.30:FF:000675', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172201, NULL, 'G3DSA:3.80.10.10:FF:003006', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(172202, NULL, 'G3DSA:3.40.250.10:FF:000090', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(172203, NULL, 'G3DSA:1.10.287.1490:FF:000015', NULL, NULL, 'WD repeat-containing protein 65, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172204, NULL, 'G3DSA:2.30.30.40:FF:000502', NULL, NULL, 'BAR domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(172205, NULL, 'G3DSA:2.30.29.30:FF:001210', NULL, NULL, 'Amyloid beta precursor protein binding family A member 3', NULL, NULL, NULL, NULL, NULL, 4),
(172206, NULL, 'G3DSA:3.30.70.330:FF:001615', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172207, NULL, 'G3DSA:3.30.160.60:FF:003449', NULL, NULL, 'Zinc finger protein 223', NULL, NULL, NULL, NULL, NULL, 4),
(172208, NULL, 'G3DSA:1.10.10.10:FF:001709', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(172209, NULL, 'G3DSA:1.25.40.10:FF:002032', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(172210, NULL, 'G3DSA:3.30.2410.10:FF:000019', NULL, NULL, 'G2/M-phase specific E3 ubiquitin protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(172211, NULL, 'G3DSA:2.130.10.10:FF:005636', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172212, NULL, 'G3DSA:3.90.70.80:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172213, NULL, 'G3DSA:2.60.120.10:FF:000321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172214, NULL, 'G3DSA:3.40.50.150:FF:000431', NULL, NULL, 'tRNA(Phe) (4-demethylwyosine(37)-C(7)) aminocarboxypropyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(172215, NULL, 'G3DSA:1.10.3520.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172216, NULL, 'G3DSA:2.10.70.10:FF:000126', NULL, NULL, 'Complement C1r subcomponent like', NULL, NULL, NULL, NULL, NULL, 4),
(172217, NULL, 'G3DSA:3.40.50.2020:FF:000064', NULL, NULL, 'Hypoxanthine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(172218, NULL, 'G3DSA:3.40.50.720:FF:000973', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(172219, NULL, 'G3DSA:1.10.287.110:FF:000140', NULL, NULL, 'Chaperone protein DNAj', NULL, NULL, NULL, NULL, NULL, 4),
(172220, NULL, 'G3DSA:1.10.510.10:FF:000192', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', NULL, NULL, NULL, NULL, NULL, 4),
(172221, NULL, 'G3DSA:3.40.50.11340:FF:000004', NULL, NULL, 'Galactoside 2-alpha-L-fucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(172222, NULL, 'G3DSA:3.30.160.60:FF:002437', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172223, NULL, 'G3DSA:2.10.50.10:FF:000119', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(172224, NULL, 'G3DSA:1.10.10.10:FF:001642', NULL, NULL, 'Transcriptional regulator, BadM/Rrf2 family', NULL, NULL, NULL, NULL, NULL, 4),
(172225, NULL, 'G3DSA:2.40.50.140:FF:001219', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172226, NULL, 'G3DSA:1.20.5.170:FF:000275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172227, NULL, 'G3DSA:3.90.660.10:FF:000098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172228, NULL, 'G3DSA:3.20.10.10:FF:000030', NULL, NULL, 'Aminotransferase, class IV', NULL, NULL, NULL, NULL, NULL, 4),
(172229, NULL, 'G3DSA:1.20.1110.10:FF:000079', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(172230, NULL, 'G3DSA:3.40.250.10:FF:000157', NULL, NULL, 'LOC100124764 protein', NULL, NULL, NULL, NULL, NULL, 4),
(172231, NULL, 'G3DSA:3.30.70.260:FF:000055', NULL, NULL, '(P)ppGpp synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(172232, NULL, 'G3DSA:2.60.40.10:FF:003972', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172233, NULL, 'G3DSA:3.40.50.300:FF:007497', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(172234, NULL, 'G3DSA:2.130.10.130:FF:000012', NULL, NULL, 'Integrin alpha-IIb', NULL, NULL, NULL, NULL, NULL, 4),
(172235, NULL, 'G3DSA:2.60.120.200:FF:000088', NULL, NULL, 'Contactin associated protein-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(172236, NULL, 'G3DSA:3.30.160.60:FF:000751', NULL, NULL, 'zinc finger protein 629 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(172237, NULL, 'G3DSA:3.40.1110.10:FF:000253', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172238, NULL, 'G3DSA:2.60.120.260:FF:000004', NULL, NULL, 'Ephrin type-B receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(172239, NULL, 'G3DSA:1.10.510.10:FF:003569', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172240, NULL, 'G3DSA:3.10.20.90:FF:000088', NULL, NULL, 'polycomb group RING finger protein 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(172241, NULL, 'G3DSA:3.40.1170.10:FF:000026', NULL, NULL, 'DNA mismatch repair protein MutS 1', NULL, NULL, NULL, NULL, NULL, 4),
(172242, NULL, 'G3DSA:2.60.120.920:FF:000062', NULL, NULL, 'Tripartite motif-containing protein 49', NULL, NULL, NULL, NULL, NULL, 4),
(172243, NULL, 'G3DSA:3.30.1490.20:FF:000022', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(172244, NULL, 'G3DSA:1.20.58.390:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172245, NULL, 'G3DSA:2.40.10.10:FF:000082', NULL, NULL, 'Plasma kallikrein', NULL, NULL, NULL, NULL, NULL, 4),
(172246, NULL, 'G3DSA:2.40.170.20:FF:000073', NULL, NULL, 'Probable TonB-dependent receptor', NULL, NULL, NULL, NULL, NULL, 4),
(172247, NULL, 'G3DSA:2.60.40.10:FF:005765', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172248, NULL, 'G3DSA:3.40.50.410:FF:000094', NULL, NULL, 'Voltage-dependent calcium channel subunit alpha-2/delta-3', NULL, NULL, NULL, NULL, NULL, 4),
(172249, NULL, 'G3DSA:3.30.70.1230:FF:000015', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(172250, NULL, 'G3DSA:2.120.10.30:FF:000134', NULL, NULL, 'Low-density lipoprotein RecePtor related', NULL, NULL, NULL, NULL, NULL, 4),
(172251, NULL, 'G3DSA:1.10.630.10:FF:000695', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172252, NULL, 'G3DSA:2.40.50.140:FF:001152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(172253, NULL, 'G3DSA:1.10.630.10:FF:000751', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172254, NULL, 'G3DSA:3.30.497.10:FF:000102', NULL, NULL, 'Serpin peptidase inhibitor 4', NULL, NULL, NULL, NULL, NULL, 4),
(172255, NULL, 'G3DSA:2.60.40.10:FF:001729', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(172256, NULL, 'G3DSA:1.10.560.10:FF:000138', NULL, NULL, 'Chaperonin complex component, TCP-1 delta subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172257, NULL, 'G3DSA:2.130.10.10:FF:000173', NULL, NULL, 'Cilia- and flagella-associated protein 52', NULL, NULL, NULL, NULL, NULL, 4),
(172258, NULL, 'G3DSA:1.10.287.160:FF:000020', NULL, NULL, 'Serine/threonine-protein kinase N2', NULL, NULL, NULL, NULL, NULL, 4),
(172259, NULL, 'G3DSA:3.40.630.10:FF:000231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172260, NULL, 'G3DSA:3.40.50.11500:FF:000018', NULL, NULL, 'DENN domain-containing protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(172261, NULL, 'G3DSA:1.10.10.10:FF:001294', NULL, NULL, 'Protein CBR-ETS-9', NULL, NULL, NULL, NULL, NULL, 4),
(172262, NULL, 'G3DSA:2.110.10.10:FF:000005', NULL, NULL, 'Stromelysin-3 preproprotein', NULL, NULL, NULL, NULL, NULL, 4),
(172263, NULL, 'G3DSA:1.10.1760.10:FF:000001', NULL, NULL, 'Actin-related protein 2/3 complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(172264, NULL, 'G3DSA:2.60.40.10:FF:004135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172265, NULL, 'G3DSA:3.60.21.10:FF:000222', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(172266, NULL, 'G3DSA:1.10.8.60:FF:000318', NULL, NULL, 'Peroxisome biosynthesis protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(172267, NULL, 'G3DSA:1.20.58.60:FF:000715', NULL, NULL, 'Spectrin, beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(172268, NULL, 'G3DSA:1.10.510.10:FF:002108', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172269, NULL, 'G3DSA:3.40.50.720:FF:001760', NULL, NULL, 'Zgc:110348', NULL, NULL, NULL, NULL, NULL, 4),
(172270, NULL, 'G3DSA:1.10.10.1050:FF:000005', NULL, NULL, 'mRNA decapping complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(172271, NULL, 'G3DSA:3.40.720.10:FF:000058', NULL, NULL, 'Phosphoethanolamine N-methyltransferase, putative (AFU_orthologue AFUA_6G04290)', NULL, NULL, NULL, NULL, NULL, 4),
(172272, NULL, 'G3DSA:1.20.1500.20:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172273, NULL, 'G3DSA:2.60.40.10:FF:005714', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172274, NULL, 'G3DSA:3.40.50.2000:FF:000598', NULL, NULL, 'Glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(172275, NULL, 'G3DSA:3.40.50.300:FF:002707', NULL, NULL, 'ATLastiN (Endoplasmic reticulum GTPase) related', NULL, NULL, NULL, NULL, NULL, 4),
(172276, NULL, 'G3DSA:3.10.20.90:FF:000206', NULL, NULL, 'Type VII secretion integral membrane protein EccD', NULL, NULL, NULL, NULL, NULL, 4),
(172277, NULL, 'G3DSA:3.30.70.3250:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172278, NULL, 'G3DSA:3.40.1110.10:FF:000197', NULL, NULL, 'Cation transport ATPase, E1-E2 family', NULL, NULL, NULL, NULL, NULL, 4),
(172279, NULL, 'G3DSA:3.40.630.30:FF:000237', NULL, NULL, 'GNAT family acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(172280, NULL, 'G3DSA:2.130.10.10:FF:002022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172281, NULL, 'G3DSA:3.40.33.10:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172282, NULL, 'G3DSA:1.20.1110.10:FF:000135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172283, NULL, 'G3DSA:1.20.810.10:FF:000010', NULL, NULL, 'Cytochrome b', NULL, NULL, NULL, NULL, NULL, 4),
(172284, NULL, 'G3DSA:1.25.10.10:FF:000131', NULL, NULL, 'Vacuolar protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(172285, NULL, 'G3DSA:2.40.30.10:FF:000240', NULL, NULL, 'predicted NADPH oxidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(172286, NULL, 'G3DSA:3.40.33.10:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(172287, NULL, 'G3DSA:3.40.1090.10:FF:000025', NULL, NULL, 'Patatin-like phospholipase domain containing 6', NULL, NULL, NULL, NULL, NULL, 4),
(172288, NULL, 'G3DSA:1.20.1560.10:FF:000686', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172289, NULL, 'G3DSA:1.20.900.10:FF:000129', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(172290, NULL, 'G3DSA:3.30.300.10:FF:000023', NULL, NULL, 'GMP synthase (glutamine-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4),
(172291, NULL, 'G3DSA:3.30.505.10:FF:000212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172292, NULL, 'G3DSA:2.60.120.620:FF:000034', NULL, NULL, '2-oxoglutarate and iron-dependent oxygenase domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(172293, NULL, 'G3DSA:3.30.310.40:FF:000010', NULL, NULL, 'AGAP001854-PA', NULL, NULL, NULL, NULL, NULL, 4),
(172294, NULL, 'G3DSA:3.30.360.10:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172295, NULL, 'G3DSA:1.20.1560.10:FF:000394', NULL, NULL, 'Cystic Fibrosis Transmembrane conductance regulator homolog', NULL, NULL, NULL, NULL, NULL, 4),
(172296, NULL, 'G3DSA:2.30.30.140:FF:000329', NULL, NULL, 'Protein lin-61', NULL, NULL, NULL, NULL, NULL, 4),
(172297, NULL, 'G3DSA:3.30.40.10:FF:000891', NULL, NULL, 'General transcription factor IIH subunit', NULL, NULL, NULL, NULL, NULL, 4),
(172298, NULL, 'G3DSA:4.10.410.20:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172299, NULL, 'G3DSA:1.20.1310.10:FF:000004', NULL, NULL, 'Cullin 4B', NULL, NULL, NULL, NULL, NULL, 4),
(172300, NULL, 'G3DSA:2.40.160.60:FF:000005', NULL, NULL, 'Transporter, Ompp1/FadL/TodX family', NULL, NULL, NULL, NULL, NULL, 4),
(172301, NULL, 'G3DSA:3.30.70.330:FF:001503', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172302, NULL, 'G3DSA:3.90.1150.10:FF:000289', NULL, NULL, 'Serine-pyruvate aminotransferase (AgxT)', NULL, NULL, NULL, NULL, NULL, 4),
(172303, NULL, 'G3DSA:3.20.20.140:FF:000337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172304, NULL, 'G3DSA:3.10.150.10:FF:000015', NULL, NULL, 'Proliferating cell nuclear antigen', NULL, NULL, NULL, NULL, NULL, 4),
(172305, NULL, 'G3DSA:3.30.300.20:FF:000026', NULL, NULL, 'Ribosome-binding factor A', NULL, NULL, NULL, NULL, NULL, 4),
(172306, NULL, 'G3DSA:3.70.10.10:FF:000095', NULL, NULL, 'DNA damage checkpoint protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(172307, NULL, 'G3DSA:1.25.10.10:FF:001715', NULL, NULL, 'Neurochondrin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(172308, NULL, 'G3DSA:1.20.1560.10:FF:000742', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(172309, NULL, 'G3DSA:2.60.120.1000:FF:000007', NULL, NULL, 'Collagen type V alpha 3 chain', NULL, NULL, NULL, NULL, NULL, 4),
(172310, NULL, 'G3DSA:1.10.10.60:FF:000162', NULL, NULL, 'trihelix transcription factor GT-1', NULL, NULL, NULL, NULL, NULL, 4),
(172311, NULL, 'G3DSA:4.10.410.10:FF:000015', NULL, NULL, 'WAP four-disulfide core domain 6A', NULL, NULL, NULL, NULL, NULL, 4),
(172312, NULL, 'G3DSA:2.40.30.10:FF:000532', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172313, NULL, 'G3DSA:3.30.310.50:FF:000013', NULL, NULL, 'Phosphoglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(172314, NULL, 'G3DSA:3.30.420.10:FF:000706', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172315, NULL, 'G3DSA:3.10.50.40:FF:000159', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(172316, NULL, 'G3DSA:1.20.1310.20:FF:000007', NULL, NULL, 'Erythrocyte-binding antigen 175', NULL, NULL, NULL, NULL, NULL, 4),
(172317, NULL, 'G3DSA:1.10.8.10:FF:000146', NULL, NULL, 'Toll-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(172318, NULL, 'G3DSA:2.60.120.10:FF:000433', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(172319, NULL, 'G3DSA:3.40.50.150:FF:001409', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172320, NULL, 'G3DSA:3.10.105.10:FF:000107', NULL, NULL, 'Putative binding protein HI_0213', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(172321, NULL, 'G3DSA:1.20.58.60:FF:000367', NULL, NULL, 'SMAll', NULL, NULL, NULL, NULL, NULL, 4),
(172322, NULL, 'G3DSA:1.10.1420.10:FF:000015', NULL, NULL, 'DNA mismatch repair protein Msh2', NULL, NULL, NULL, NULL, NULL, 4),
(172323, NULL, 'G3DSA:2.20.25.20:FF:000007', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(172324, NULL, 'G3DSA:3.90.1420.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172325, NULL, 'G3DSA:3.40.50.1820:FF:001257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172326, NULL, 'G3DSA:2.20.25.10:FF:000004', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(172327, NULL, 'G3DSA:3.30.200.20:FF:000878', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(172328, NULL, 'G3DSA:3.40.140.10:FF:000261', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172329, NULL, 'G3DSA:2.130.10.30:FF:000179', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172330, NULL, 'G3DSA:3.40.50.1000:FF:000051', NULL, NULL, 'Phospholysine phosphohistidine inorganic pyrophosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(172331, NULL, 'G3DSA:4.10.400.10:FF:000357', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172332, NULL, 'G3DSA:1.25.40.10:FF:005197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172333, NULL, 'G3DSA:1.20.1260.10:FF:000028', NULL, NULL, 'tRNA-(MS[2]IO[6]A)-hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(172334, NULL, 'G3DSA:3.80.10.10:FF:002949', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172335, NULL, 'G3DSA:3.40.50.300:FF:004001', NULL, NULL, 'DEAD-box ATP-dependent RNA helicase 36', NULL, NULL, NULL, NULL, NULL, 4),
(172336, NULL, 'G3DSA:3.40.50.2000:FF:000873', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(172337, NULL, 'G3DSA:1.20.1280.50:FF:000232', NULL, NULL, 'F-box protein pof12', NULL, NULL, NULL, NULL, NULL, 4),
(172338, NULL, 'G3DSA:3.30.379.10:FF:000002', NULL, NULL, 'Beta-hexosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(172339, NULL, 'G3DSA:3.30.505.10:FF:000263', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172340, NULL, 'G3DSA:3.10.100.10:FF:000411', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172341, NULL, 'G3DSA:2.10.60.10:FF:000064', NULL, NULL, 'Serine/threonine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(172342, NULL, 'G3DSA:1.10.472.10:FF:000203', NULL, NULL, 'CyCliN K', NULL, NULL, NULL, NULL, NULL, 4),
(172343, NULL, 'G3DSA:3.50.50.60:FF:001271', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172344, NULL, 'G3DSA:3.30.420.10:FF:000358', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172345, NULL, 'G3DSA:1.25.10.10:FF:002204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172346, NULL, 'G3DSA:3.50.50.60:FF:001451', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172347, NULL, 'G3DSA:1.20.920.10:FF:000069', NULL, NULL, 'RSC complex subunit (RSC1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(172348, NULL, 'G3DSA:3.30.310.130:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172349, NULL, 'G3DSA:1.10.260.100:FF:000005', NULL, NULL, 'Ubiquitin domain-containing protein DSK2b', NULL, NULL, NULL, NULL, NULL, 4),
(172350, NULL, 'G3DSA:3.40.50.300:FF:006417', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172351, NULL, 'G3DSA:1.10.510.10:FF:001771', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172352, NULL, 'G3DSA:1.20.920.10:FF:000125', NULL, NULL, 'Chromatin structure remodeling complex subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172353, NULL, 'G3DSA:2.60.40.10:FF:005147', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172354, NULL, 'G3DSA:3.30.530.20:FF:000009', NULL, NULL, 'StAR related lipid transfer domain containing 13', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(172355, NULL, 'G3DSA:1.10.10.1100:FF:000004', NULL, NULL, '(2Fe-2S)-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(172356, NULL, 'G3DSA:3.40.50.720:FF:001136', NULL, NULL, 'Alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(172357, NULL, 'G3DSA:3.20.20.110:FF:000002', NULL, NULL, '2,3-diketo-5-methylthiopentyl-1-phosphate enolase', NULL, NULL, NULL, NULL, NULL, 4),
(172358, NULL, 'G3DSA:4.10.860.120:FF:000009', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(172359, NULL, 'G3DSA:1.10.8.60:FF:000195', NULL, NULL, 'AAA-type ATPase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(172360, NULL, 'G3DSA:2.130.10.10:FF:005804', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172361, NULL, 'G3DSA:3.40.50.300:FF:005928', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172362, NULL, 'G3DSA:3.40.50.150:FF:000375', NULL, NULL, 'SAM-dependent methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(172363, NULL, 'G3DSA:3.30.70.330:FF:000891', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(172364, NULL, 'G3DSA:1.20.1070.10:FF:000761', NULL, NULL, '7 transmembrane receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172365, NULL, 'G3DSA:3.40.50.2300:FF:001238', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172366, NULL, 'G3DSA:3.40.50.2000:FF:001087', NULL, NULL, 'Protein CBG00513', NULL, NULL, NULL, NULL, NULL, 4),
(172367, NULL, 'G3DSA:2.60.40.1730:FF:000063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172368, NULL, 'G3DSA:3.40.50.10130:FF:000017', NULL, NULL, 'Zip2p', NULL, NULL, NULL, NULL, NULL, 4),
(172369, NULL, 'G3DSA:3.30.420.10:FF:000414', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172370, NULL, 'G3DSA:1.10.750.20:FF:000004', NULL, NULL, 'Ankyrin repeat and SOCS box containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(172371, NULL, 'G3DSA:2.60.40.10:FF:005984', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172372, NULL, 'G3DSA:3.90.810.10:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172373, NULL, 'G3DSA:3.30.110.170:FF:000004', NULL, NULL, 'Putative lipoprotein LpqG', NULL, NULL, NULL, NULL, NULL, 4),
(172374, NULL, 'G3DSA:3.20.20.120:FF:000005', NULL, NULL, 'Putative L-rhamnonate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(172375, NULL, 'G3DSA:1.10.880.10:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172376, NULL, 'G3DSA:3.10.100.10:FF:000063', NULL, NULL, 'Lymphocyte antigen 75', NULL, NULL, NULL, NULL, NULL, 4),
(172377, NULL, 'G3DSA:1.25.10.10:FF:001592', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172378, NULL, 'G3DSA:2.60.40.10:FF:000425', NULL, NULL, 'Myosin light chain kinase', NULL, NULL, NULL, NULL, NULL, 4),
(172379, NULL, 'G3DSA:3.80.10.10:FF:004462', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172380, NULL, 'G3DSA:1.25.70.10:FF:000016', NULL, NULL, 'Mitochondrial transcription termination factor-like', NULL, NULL, NULL, NULL, NULL, 4),
(172381, NULL, 'G3DSA:1.25.40.690:FF:000005', NULL, NULL, 'Related to Nucleoporin nup189 (SonB)', NULL, NULL, NULL, NULL, NULL, 4),
(172382, NULL, 'G3DSA:1.10.750.10:FF:000001', NULL, NULL, 'von Hippel-Lindau disease tumor suppressor', NULL, NULL, NULL, NULL, NULL, 4),
(172383, NULL, 'G3DSA:1.20.1560.10:FF:000809', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172384, NULL, 'G3DSA:2.10.25.10:FF:001550', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172385, NULL, 'G3DSA:3.30.70.2870:FF:000001', NULL, NULL, 'E4 11 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(172386, NULL, 'G3DSA:3.50.50.60:FF:000995', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(172387, NULL, 'G3DSA:3.10.450.10:FF:000055', NULL, NULL, 'Si:ch211-262h13.5', NULL, NULL, NULL, NULL, NULL, 4),
(172388, NULL, 'G3DSA:1.50.40.10:FF:000164', NULL, NULL, 'Dicarboxylate transporter', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(172389, NULL, 'G3DSA:3.40.50.11040:FF:000009', NULL, NULL, 'N-acetyltransferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(172390, NULL, 'G3DSA:2.130.10.10:FF:001533', NULL, NULL, 'UTP13p Nucleolar protein', NULL, NULL, NULL, NULL, NULL, 4),
(172391, NULL, 'G3DSA:3.90.730.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172392, NULL, 'G3DSA:3.40.50.1000:FF:000612', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172393, NULL, 'G3DSA:3.40.50.150:FF:001735', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172394, NULL, 'G3DSA:3.20.20.140:FF:000157', NULL, NULL, 'D-amino acid aminohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(172395, NULL, 'G3DSA:3.40.50.10810:FF:000070', NULL, NULL, 'DNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172396, NULL, 'G3DSA:1.10.287.370:FF:000083', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(172397, NULL, 'G3DSA:3.40.30.10:FF:000305', NULL, NULL, 'SelT-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(172398, NULL, 'G3DSA:1.20.1260.10:FF:000079', NULL, NULL, 'Ferritin 2 light chain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(172399, NULL, 'G3DSA:3.20.20.70:FF:000733', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172400, NULL, 'G3DSA:3.50.50.60:FF:000776', NULL, NULL, 'Sulfide Quinone oxidoReDuctase', NULL, NULL, NULL, NULL, NULL, 4),
(172401, NULL, 'G3DSA:1.10.510.10:FF:001496', NULL, NULL, 'Cell division cycle 7 homolog (S. cerevisiae)', NULL, NULL, NULL, NULL, NULL, 4),
(172402, NULL, 'G3DSA:3.90.190.10:FF:000360', NULL, NULL, 'AGAP012901-PA', NULL, NULL, NULL, NULL, NULL, 4),
(172403, NULL, 'G3DSA:3.40.50.1460:FF:000115', NULL, NULL, 'GPI-anchor transamidase', NULL, NULL, NULL, NULL, NULL, 4),
(172404, NULL, 'G3DSA:3.90.1410.10:FF:000152', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(172405, NULL, 'G3DSA:2.60.40.10:FF:005366', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172406, NULL, 'G3DSA:1.25.40.10:FF:003336', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(172407, NULL, 'G3DSA:3.40.50.11030:FF:000006', NULL, NULL, 'Threonylcarbamoyl-AMP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(172408, NULL, 'G3DSA:3.30.60.20:FF:000041', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(172409, NULL, 'G3DSA:3.30.70.980:FF:000001', NULL, NULL, 'Probable transcriptional regulatory protein YebC', NULL, NULL, NULL, NULL, NULL, 4),
(172410, NULL, 'G3DSA:2.30.29.30:FF:000608', NULL, NULL, 'Myosin 28B1, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(172411, NULL, 'G3DSA:2.30.30.140:FF:000149', NULL, NULL, 'WGS project CABT00000000 data, contig 2.3', NULL, NULL, NULL, NULL, NULL, 4),
(172412, NULL, 'G3DSA:3.40.50.150:FF:000723', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(172413, NULL, 'G3DSA:1.20.1050.10:FF:000198', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(172414, NULL, 'G3DSA:1.20.1280.50:FF:000013', NULL, NULL, 'F-box/LRR-repeat protein 20 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(172415, NULL, 'G3DSA:1.10.220.30:FF:000035', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(172416, NULL, 'G3DSA:2.30.29.30:FF:001154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172417, NULL, 'G3DSA:1.20.1560.10:FF:000068', NULL, NULL, 'Transporter 1 ATP-binding cassette sub-family B', NULL, NULL, NULL, NULL, NULL, 4),
(172418, NULL, 'G3DSA:1.10.1760.20:FF:000004', NULL, NULL, 'Riboflavin transporter', NULL, NULL, NULL, NULL, NULL, 4),
(172419, NULL, 'G3DSA:2.60.40.60:FF:000069', NULL, NULL, 'Protocadherin-11 X-linked', NULL, NULL, NULL, NULL, NULL, 4),
(172420, NULL, 'G3DSA:3.30.365.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172421, NULL, 'G3DSA:3.30.160.60:FF:005984', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172422, NULL, 'G3DSA:3.30.1330.60:FF:000005', NULL, NULL, 'Outer membrane porin F', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(172423, NULL, 'G3DSA:1.10.1410.20:FF:000012', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(172424, NULL, 'G3DSA:1.10.533.10:FF:000222', NULL, NULL, 'NLR family, CARD domain-containing 3-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(172425, NULL, 'G3DSA:1.10.630.10:FF:000190', NULL, NULL, 'Cytochrome P450, family 2, subfamily K, polypeptide17', NULL, NULL, NULL, NULL, NULL, 4),
(172426, NULL, 'G3DSA:3.40.50.12370:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172427, NULL, 'G3DSA:3.30.60.30:FF:000044', NULL, NULL, 'Serine protease inhibitor dipetalogastin', NULL, NULL, NULL, NULL, NULL, 4),
(172428, NULL, 'G3DSA:3.30.160.60:FF:002145', NULL, NULL, 'Zinc finger protein 354B', NULL, NULL, NULL, NULL, NULL, 4),
(172429, NULL, 'G3DSA:3.30.420.40:FF:000052', NULL, NULL, 'Ectonucleoside triphosphate diphosphohydrolase 5', NULL, NULL, NULL, NULL, NULL, 4),
(172430, NULL, 'G3DSA:3.40.50.300:FF:002146', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(172431, NULL, 'G3DSA:3.20.20.80:FF:000793', NULL, NULL, 'Probable glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(172432, NULL, 'G3DSA:1.25.40.10:FF:003741', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172433, NULL, 'G3DSA:2.60.40.1180:FF:000145', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(172434, NULL, 'G3DSA:1.20.58.2220:FF:000034', NULL, NULL, 'Diaphanous-related formin 2', NULL, NULL, NULL, NULL, NULL, 4),
(172435, NULL, 'G3DSA:3.80.10.10:FF:000010', NULL, NULL, 'F-box/LRR-repeat protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(172436, NULL, 'G3DSA:2.130.10.10:FF:005462', NULL, NULL, 'Nucleolar protein, component of the U3 processome', NULL, NULL, NULL, NULL, NULL, 4),
(172437, NULL, 'G3DSA:3.20.20.80:FF:000736', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172438, NULL, 'G3DSA:1.10.10.2420:FF:000001', NULL, NULL, 'Glutamine--tRNA ligase cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(172439, NULL, 'G3DSA:3.30.1460.50:FF:000006', NULL, NULL, 'Ubiquitin-like-conjugating enzyme ATG10', NULL, NULL, NULL, NULL, NULL, 4),
(172440, NULL, 'G3DSA:1.25.40.10:FF:004230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172441, NULL, 'G3DSA:3.60.40.10:FF:000294', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172442, NULL, 'G3DSA:3.30.70.330:FF:001228', NULL, NULL, 'RNA-binding protein RBP10, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172443, NULL, 'G3DSA:2.40.30.10:FF:000313', NULL, NULL, 'GD11452', NULL, NULL, NULL, NULL, NULL, 4),
(172444, NULL, 'G3DSA:2.10.90.10:FF:000048', NULL, NULL, 'Glycoprotein hormone beta 5', NULL, NULL, NULL, NULL, NULL, 4),
(172445, NULL, 'G3DSA:1.20.58.390:FF:000054', NULL, NULL, 'Gamma-aminobutyric acid (GABA-A) receptor, subunit theta', NULL, NULL, NULL, NULL, NULL, 4),
(172446, NULL, 'G3DSA:1.20.5.110:FF:000066', NULL, NULL, 'Putative SNARE protein', NULL, NULL, NULL, NULL, NULL, 4),
(172447, NULL, 'G3DSA:1.25.10.10:FF:001148', NULL, NULL, 'cilia- and flagella-associated protein 69 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(172448, NULL, 'G3DSA:2.80.10.50:FF:000182', NULL, NULL, 'Fascin', NULL, NULL, NULL, NULL, NULL, 4),
(172449, NULL, 'G3DSA:3.40.50.1820:FF:001201', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(172450, NULL, 'G3DSA:1.25.10.10:FF:003278', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(172451, NULL, 'G3DSA:3.30.1330.20:FF:000022', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(172452, NULL, 'G3DSA:3.10.50.40:FF:000103', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(172453, NULL, 'G3DSA:1.20.58.390:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172454, NULL, 'G3DSA:1.20.1250.20:FF:001424', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172455, NULL, 'G3DSA:2.60.40.60:FF:000176', NULL, NULL, 'FAT atypical cadherin 4', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(172456, NULL, 'G3DSA:2.60.40.10:FF:005591', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172457, NULL, 'G3DSA:2.60.40.10:FF:004023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172458, NULL, 'G3DSA:3.40.50.1110:FF:000027', NULL, NULL, 'Esterase EstA', NULL, NULL, NULL, NULL, NULL, 4),
(172459, NULL, 'G3DSA:3.30.200.20:FF:001991', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172460, NULL, 'G3DSA:3.90.1410.10:FF:000101', NULL, NULL, 'CIA6', NULL, NULL, NULL, NULL, NULL, 4),
(172461, NULL, 'G3DSA:1.25.40.860:FF:000028', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(172462, NULL, 'G3DSA:3.30.930.10:FF:000228', NULL, NULL, 'phenylalanine--tRNA ligase beta subunit isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(172463, NULL, 'G3DSA:3.90.1410.10:FF:000045', NULL, NULL, 'SET domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(172464, NULL, 'G3DSA:1.25.50.20:FF:000063', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(172465, NULL, 'G3DSA:1.20.1070.10:FF:001216', NULL, NULL, 'Protein CBR-SER-1', NULL, NULL, NULL, NULL, NULL, 4),
(172466, NULL, 'G3DSA:2.60.40.1180:FF:000201', NULL, NULL, 'Alpha-glucosidase AlgA', NULL, NULL, NULL, NULL, NULL, 4),
(172467, NULL, 'G3DSA:2.60.40.1180:FF:000151', NULL, NULL, 'Alpha glucosidase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(172468, NULL, 'G3DSA:3.40.630.30:FF:000063', NULL, NULL, 'RNA cytidine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(172469, NULL, 'G3DSA:3.40.50.720:FF:002446', NULL, NULL, 'Ketopantoate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(172470, NULL, 'G3DSA:2.60.220.50:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172471, NULL, 'G3DSA:2.60.40.10:FF:000751', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(172472, NULL, 'G3DSA:2.60.40.2430:FF:000003', NULL, NULL, 'Agglutinin-like protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(172473, NULL, 'G3DSA:3.10.250.10:FF:000012', NULL, NULL, 'CD163 molecule like 1', NULL, NULL, NULL, NULL, NULL, 4),
(172474, NULL, 'G3DSA:3.80.10.10:FF:003118', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(172475, NULL, 'G3DSA:3.10.170.20:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172476, NULL, 'G3DSA:1.20.1250.20:FF:000862', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(172477, NULL, 'G3DSA:1.10.533.10:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172478, NULL, 'G3DSA:1.10.150.50:FF:000198', NULL, NULL, 'Kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172479, NULL, 'G3DSA:2.30.29.30:FF:000715', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(172480, NULL, 'G3DSA:2.60.40.200:FF:000039', NULL, NULL, 'AGAP007026-PA', NULL, NULL, NULL, NULL, NULL, 4),
(172481, NULL, 'G3DSA:3.40.30.10:FF:000362', NULL, NULL, 'Iodothyronine deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(172482, NULL, 'G3DSA:3.20.20.70:FF:000407', NULL, NULL, '2-isopropylmalate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(172483, NULL, 'G3DSA:2.10.90.10:FF:000009', NULL, NULL, 'Vascular endothelial growth factor A', NULL, NULL, NULL, NULL, NULL, 4),
(172484, NULL, 'G3DSA:2.60.120.10:FF:000720', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172485, NULL, 'G3DSA:3.40.50.300:FF:000061', NULL, NULL, 'ATPase family, AAA domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(172486, NULL, 'G3DSA:3.10.20.90:FF:000032', NULL, NULL, 'Fermitin family homolog 2 (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(172487, NULL, 'G3DSA:2.60.40.2440:FF:000006', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(172488, NULL, 'G3DSA:3.40.50.1100:FF:000024', NULL, NULL, 'Probable threonine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(172489, NULL, 'G3DSA:2.40.480.10:FF:000003', NULL, NULL, 'Dirigent protein', NULL, NULL, NULL, NULL, NULL, 4),
(172490, NULL, 'G3DSA:2.30.180.10:FF:000067', NULL, NULL, 'Transforming growth factor-beta-induced protein ig-h3', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(172491, NULL, 'G3DSA:3.40.140.10:FF:000036', NULL, NULL, 'tRNA-specific adenosine deaminase 2', NULL, NULL, NULL, NULL, NULL, 4),
(172492, NULL, 'G3DSA:3.40.50.410:FF:000324', NULL, NULL, '60 kDa SS-A/Ro ribonucleoprotein-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(172493, NULL, 'G3DSA:3.40.50.1110:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172494, NULL, 'G3DSA:3.30.40.10:FF:001621', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(172495, NULL, 'G3DSA:3.40.50.720:FF:000299', NULL, NULL, 'Bifunctional pinoresinol-lariciresinol reductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(172496, NULL, 'G3DSA:2.130.10.10:FF:005187', NULL, NULL, 'Proteasomal ATPase associated factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(172497, NULL, 'G3DSA:2.60.40.10:FF:000419', NULL, NULL, 'KDEL (Lys-Asp-Glu-Leu) containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(172498, NULL, 'G3DSA:3.80.10.10:FF:003500', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172499, NULL, 'G3DSA:3.40.50.300:FF:004332', NULL, NULL, 'Rad51 recombinase D', NULL, NULL, NULL, NULL, NULL, 4),
(172500, NULL, 'G3DSA:2.30.29.30:FF:001266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172501, NULL, 'G3DSA:3.80.10.10:FF:003450', NULL, NULL, 'Si:ch211-214j8.12', NULL, NULL, NULL, NULL, NULL, 4),
(172502, NULL, 'G3DSA:3.40.50.1100:FF:000081', NULL, NULL, 'D-cysteine desulfhydrase 2 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(172503, NULL, 'G3DSA:3.30.930.10:FF:000267', NULL, NULL, 'Threonine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(172504, NULL, 'G3DSA:2.80.10.50:FF:000125', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(172505, NULL, 'G3DSA:3.90.1230.10:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172506, NULL, 'G3DSA:1.10.418.20:FF:000036', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(172507, NULL, 'G3DSA:2.60.40.10:FF:005478', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172508, NULL, 'G3DSA:1.10.287.110:FF:000319', NULL, NULL, 'Chaperone protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172509, NULL, 'G3DSA:2.40.110.10:FF:000072', NULL, NULL, 'Acyl-Coenzyme A dehydrogenase family, member 12', NULL, NULL, NULL, NULL, NULL, 4),
(172510, NULL, 'G3DSA:1.20.120.350:FF:000108', NULL, NULL, 'Sodium channel, voltage-gated, type VIII, alpha subunit b', NULL, NULL, NULL, NULL, NULL, 4),
(172511, NULL, 'G3DSA:3.30.1460.50:FF:000012', NULL, NULL, 'WGS project CABT00000000 data, contig 2.1', NULL, NULL, NULL, NULL, NULL, 4),
(172512, NULL, 'G3DSA:3.30.572.10:FF:000007', NULL, NULL, 'thymidylate synthase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(172513, NULL, 'G3DSA:1.10.287.690:FF:000004', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(172514, NULL, 'G3DSA:3.10.100.10:FF:000012', NULL, NULL, 'Attractin', NULL, NULL, NULL, NULL, NULL, 4),
(172515, NULL, 'G3DSA:3.40.50.300:FF:007727', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(172516, NULL, 'G3DSA:3.40.50.10190:FF:000007', NULL, NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(172517, NULL, 'G3DSA:1.10.418.10:FF:000033', NULL, NULL, 'nesprin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(172518, NULL, 'G3DSA:3.40.50.300:FF:002152', NULL, NULL, 'RAD51 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(172519, NULL, 'G3DSA:3.40.50.720:FF:001193', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(172520, NULL, 'G3DSA:3.80.10.10:FF:001027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172521, NULL, 'G3DSA:1.10.357.20:FF:000012', NULL, NULL, 'Solute carrier family 41', NULL, NULL, NULL, NULL, NULL, 4),
(172522, NULL, 'G3DSA:3.40.50.10240:FF:000045', NULL, NULL, 'Thiamine pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(172523, NULL, 'G3DSA:1.10.510.10:FF:002260', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172524, NULL, 'G3DSA:2.30.33.40:FF:000014', NULL, NULL, '10 kDa heat shock protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(172525, NULL, 'G3DSA:3.20.20.140:FF:000163', NULL, NULL, 'Dihydroorotase', NULL, NULL, NULL, NULL, NULL, 4),
(172526, NULL, 'G3DSA:3.20.20.80:FF:000742', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172527, NULL, 'G3DSA:1.10.1200.10:FF:000145', NULL, NULL, 'Putative peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(172528, NULL, 'G3DSA:3.30.470.20:FF:000246', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(172529, NULL, 'G3DSA:1.25.10.10:FF:003391', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172530, NULL, 'G3DSA:2.130.10.10:FF:001185', NULL, NULL, 'WD_domain', NULL, NULL, NULL, NULL, NULL, 4),
(172531, NULL, 'G3DSA:1.25.40.10:FF:003960', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172532, NULL, 'G3DSA:4.10.280.10:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172533, NULL, 'G3DSA:3.40.50.10170:FF:000001', NULL, NULL, 'DegV domain-containing protein Rv2417c', NULL, NULL, NULL, NULL, NULL, 4),
(172534, NULL, 'G3DSA:3.30.70.330:FF:001560', NULL, NULL, 'RNA Binding Motif protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(172535, NULL, 'G3DSA:3.40.50.10180:FF:000004', NULL, NULL, 'Glycerate 2-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(172536, NULL, 'G3DSA:3.20.80.10:FF:000028', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(172537, NULL, 'G3DSA:3.40.605.10:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172538, NULL, 'G3DSA:3.30.70.1020:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172539, NULL, 'G3DSA:1.10.455.10:FF:000006', NULL, NULL, '37S ribosomal protein S7, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(172540, NULL, 'G3DSA:2.60.40.10:FF:003348', NULL, NULL, 'Transglutaminase 1', NULL, NULL, NULL, NULL, NULL, 4),
(172541, NULL, 'G3DSA:3.50.4.10:FF:000015', NULL, NULL, 'No-mechanoreceptor potential A long isoform', NULL, NULL, NULL, NULL, NULL, 4),
(172542, NULL, 'G3DSA:2.30.29.30:FF:000659', NULL, NULL, 'Rhotekin 2', NULL, NULL, NULL, NULL, NULL, 4),
(172543, NULL, 'G3DSA:1.25.40.690:FF:000011', NULL, NULL, 'Nuclear pore complex protein Nup98-Nup96', NULL, NULL, NULL, NULL, NULL, 4),
(172544, NULL, 'G3DSA:3.30.2320.80:FF:000011', NULL, NULL, 'Hydrogenase maturation factor HypA', NULL, NULL, NULL, NULL, NULL, 4),
(172545, NULL, 'G3DSA:2.30.180.10:FF:000123', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172546, NULL, 'G3DSA:1.20.1530.20:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172547, NULL, 'G3DSA:3.40.1390.20:FF:000017', NULL, NULL, 'Manganese-dependent inorganic pyrophosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172548, NULL, 'G3DSA:2.60.40.790:FF:000002', NULL, NULL, 'Small heat shock protein IbpA', NULL, NULL, NULL, NULL, NULL, 4),
(172549, NULL, 'G3DSA:2.40.10.10:FF:000312', NULL, NULL, 'Coagulation factor precursor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172550, NULL, 'G3DSA:2.60.120.10:FF:000607', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(172551, NULL, 'G3DSA:3.40.50.410:FF:000268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172552, NULL, 'G3DSA:3.40.50.300:FF:006423', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172553, NULL, 'G3DSA:2.60.40.150:FF:000333', NULL, NULL, 'Protein Kinase N (PKN) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(172554, NULL, 'G3DSA:2.30.180.10:FF:000180', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172555, NULL, 'G3DSA:3.50.50.60:FF:001501', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172556, NULL, 'G3DSA:2.40.50.140:FF:000988', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172557, NULL, 'G3DSA:1.20.1560.10:FF:000517', NULL, NULL, 'ATP-binding cassette transporter, subfamily C, member 5, group MRP protein PpABCC5', NULL, NULL, NULL, NULL, NULL, 4),
(172558, NULL, 'G3DSA:1.25.40.10:FF:005247', NULL, NULL, 'PIKK family atypical protein kinase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(172559, NULL, 'G3DSA:2.60.40.10:FF:005439', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172560, NULL, 'G3DSA:3.20.20.70:FF:000464', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(172561, NULL, 'G3DSA:3.10.105.10:FF:000052', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(172562, NULL, 'G3DSA:3.40.1500.10:FF:000013', NULL, NULL, 'Oxygen-dependent coproporphyrinogen-III oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(172563, NULL, 'G3DSA:3.20.20.80:FF:000467', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(172564, NULL, 'G3DSA:1.25.40.10:FF:002431', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g56690, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(172565, NULL, 'G3DSA:1.10.132.60:FF:000030', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(172566, NULL, 'G3DSA:1.10.510.10:FF:002221', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172567, NULL, 'G3DSA:3.40.50.720:FF:001086', NULL, NULL, 'Thiamin biosynthesis protein (ThiF)', NULL, NULL, NULL, NULL, NULL, 4),
(172568, NULL, 'G3DSA:1.10.510.10:FF:002041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172569, NULL, 'G3DSA:3.30.930.10:FF:000380', NULL, NULL, 'Threonyl-tRNA synthetase-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(172570, NULL, 'G3DSA:1.50.10.10:FF:000123', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(172571, NULL, 'G3DSA:2.60.40.420:FF:000049', NULL, NULL, 'Laccase', NULL, NULL, NULL, NULL, NULL, 4),
(172572, NULL, 'G3DSA:2.40.160.20:FF:000022', NULL, NULL, 'Accessory colonization factor AcfA', NULL, NULL, NULL, NULL, NULL, 4),
(172573, NULL, 'G3DSA:3.30.559.30:FF:000101', NULL, NULL, 'Hydroxamate-type ferrichrome siderophore peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(172574, NULL, 'G3DSA:2.40.180.10:FF:000020', NULL, NULL, 'Catalase-related peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(172575, NULL, 'G3DSA:3.30.479.20:FF:000058', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(172576, NULL, 'G3DSA:3.40.50.300:FF:001477', NULL, NULL, 'Zinc finger helicase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(172577, NULL, 'G3DSA:3.80.10.10:FF:002663', NULL, NULL, 'Os01g0742400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(172578, NULL, 'G3DSA:3.80.10.10:FF:002775', NULL, NULL, 'Si:dkey-23k10.2', NULL, NULL, NULL, NULL, NULL, 4),
(172579, NULL, 'G3DSA:3.90.470.20:FF:000002', NULL, NULL, 'Holo-(Acyl carrier protein) synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(172580, NULL, 'G3DSA:1.10.630.10:FF:000638', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(172581, NULL, 'G3DSA:3.90.290.10:FF:000013', NULL, NULL, 'Follistatin a', NULL, NULL, NULL, NULL, NULL, 4),
(172582, NULL, 'G3DSA:3.40.50.300:FF:005693', NULL, NULL, 'Selenocysteine-specific translation elongation factor', NULL, NULL, NULL, NULL, NULL, 4),
(172583, NULL, 'G3DSA:3.30.160.60:FF:005815', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172584, NULL, 'G3DSA:2.70.170.10:FF:000041', NULL, NULL, 'Acetylcholine receptor subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(172585, NULL, 'G3DSA:3.90.370.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172586, NULL, 'G3DSA:3.30.70.1230:FF:000072', NULL, NULL, 'Adenylate/guanylate cyclase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(172587, NULL, 'G3DSA:1.10.510.10:FF:003570', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172588, NULL, 'G3DSA:1.25.40.180:FF:000089', NULL, NULL, 'Nuclear cap-binding protein complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(172589, NULL, 'G3DSA:1.20.1070.10:FF:000873', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172590, NULL, 'G3DSA:1.10.10.1540:FF:000001', NULL, NULL, 'Actin-binding Rho-activating protein a', NULL, NULL, NULL, NULL, NULL, 4),
(172591, NULL, 'G3DSA:2.30.29.30:FF:000991', NULL, NULL, 'Vacuolar protein-sorting-associated protein 36', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(172592, NULL, 'G3DSA:3.40.50.300:FF:002202', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(172593, NULL, 'G3DSA:1.20.1250.20:FF:001643', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172594, NULL, 'G3DSA:3.40.50.300:FF:004057', NULL, NULL, 'Os11g0649100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(172595, NULL, 'G3DSA:2.80.10.50:FF:000069', NULL, NULL, 'O-mannosyl-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(172596, NULL, 'G3DSA:3.30.70.890:FF:000069', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(172597, NULL, 'G3DSA:2.70.170.10:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172598, NULL, 'G3DSA:3.80.10.10:FF:001320', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(172599, NULL, 'G3DSA:1.25.10.10:FF:001480', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(172600, NULL, 'G3DSA:3.30.40.10:FF:001402', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(172601, NULL, 'G3DSA:1.10.510.10:FF:004132', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172602, NULL, 'G3DSA:3.30.160.60:FF:000021', NULL, NULL, 'Basic krueppel-like factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(172603, NULL, 'G3DSA:2.30.29.30:FF:000934', NULL, NULL, 'UDP-sugar-dependent glycosyltransferase 52', NULL, NULL, NULL, NULL, NULL, 4),
(172604, NULL, 'G3DSA:3.50.50.60:FF:001445', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172605, NULL, 'G3DSA:3.40.50.300:FF:005636', NULL, NULL, 'Sca1 complex protein phr', NULL, NULL, NULL, NULL, NULL, 4),
(172606, NULL, 'G3DSA:3.40.80.10:FF:000022', NULL, NULL, 'AGAP005552-PA', NULL, NULL, NULL, NULL, NULL, 4),
(172607, NULL, 'G3DSA:3.30.9.10:FF:000150', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(172608, NULL, 'G3DSA:3.40.220.10:FF:000037', NULL, NULL, 'Putative leucine aminopeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(172609, NULL, 'G3DSA:2.20.70.10:FF:000024', NULL, NULL, 'Rho GTPase activating protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(172610, NULL, 'G3DSA:3.20.20.70:FF:000683', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172611, NULL, 'G3DSA:1.10.510.10:FF:003238', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172612, NULL, 'G3DSA:2.80.10.50:FF:000013', NULL, NULL, 'Interleukin-1', NULL, NULL, NULL, NULL, NULL, 4),
(172613, NULL, 'G3DSA:3.40.30.10:FF:000255', NULL, NULL, 'Grx4 family monothiol glutaredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(172614, NULL, 'G3DSA:3.10.490.10:FF:000052', NULL, NULL, 'Protein CBG21104', NULL, NULL, NULL, NULL, NULL, 4),
(172615, NULL, 'G3DSA:2.40.460.10:FF:000002', NULL, NULL, 'Biotin carboxylase subunit of acetyl CoA carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(172616, NULL, 'G3DSA:2.60.120.10:FF:000377', NULL, NULL, 'Agc protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(172617, NULL, 'G3DSA:1.20.1610.10:FF:000005', NULL, NULL, 'Alpha-1,2-mannosidase, family protein', NULL, NULL, NULL, NULL, NULL, 4),
(172618, NULL, 'G3DSA:3.10.50.40:FF:000160', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(172619, NULL, 'G3DSA:2.40.10.10:FF:000531', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172620, NULL, 'G3DSA:1.10.530.10:FF:000018', NULL, NULL, 'Lysozyme g-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(172621, NULL, 'G3DSA:3.40.50.1110:FF:000140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172622, NULL, 'G3DSA:3.30.420.40:FF:000013', NULL, NULL, 'Actin-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(172623, NULL, 'G3DSA:3.20.20.80:FF:000686', NULL, NULL, 'Endo-alpha-mannosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172624, NULL, 'G3DSA:3.40.50.300:FF:004276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172625, NULL, 'G3DSA:1.20.1270.90:FF:000002', NULL, NULL, 'Zinc metalloprotease ZmpB', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(172626, NULL, 'G3DSA:1.25.10.10:FF:002896', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(172627, NULL, 'G3DSA:1.10.730.10:FF:000062', NULL, NULL, 'Putative methionyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(172628, NULL, 'G3DSA:3.90.850.10:FF:000040', NULL, NULL, 'Mitochondrion protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172629, NULL, 'G3DSA:2.40.155.10:FF:000001', NULL, NULL, 'Nidogen 1', NULL, NULL, NULL, NULL, NULL, 4),
(172630, NULL, 'G3DSA:1.20.1630.10:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172631, NULL, 'G3DSA:1.10.555.10:FF:000059', NULL, NULL, 'rho GTPase-activating protein 30 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(172632, NULL, 'G3DSA:3.40.1170.60:FF:000018', NULL, NULL, 'DNA repair protein REV1', NULL, NULL, NULL, NULL, NULL, 4),
(172633, NULL, 'G3DSA:3.30.70.890:FF:000013', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(172634, NULL, 'G3DSA:2.20.25.10:FF:000116', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(172635, NULL, 'G3DSA:1.10.530.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172636, NULL, 'G3DSA:2.40.50.140:FF:000140', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(172637, NULL, 'G3DSA:3.40.1370.10:FF:000013', NULL, NULL, 'Putative mitochondrial ribosomal protein L4', NULL, NULL, NULL, NULL, NULL, 4),
(172638, NULL, 'G3DSA:2.10.25.10:FF:000089', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(172639, NULL, 'G3DSA:1.10.1420.10:FF:000127', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(172640, NULL, 'G3DSA:2.10.90.10:FF:000161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172641, NULL, 'G3DSA:3.30.1120.30:FF:000037', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(172642, NULL, 'G3DSA:2.10.70.10:FF:000272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172643, NULL, 'G3DSA:2.70.150.10:FF:000152', NULL, NULL, 'P-type phospholipid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(172644, NULL, 'G3DSA:3.50.50.60:FF:001158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172645, NULL, 'G3DSA:3.30.1120.10:FF:000031', NULL, NULL, 'N-acetylgalactosamine 6-sulfatase (GALNS)', NULL, NULL, NULL, NULL, NULL, 4),
(172646, NULL, 'G3DSA:1.20.58.830:FF:000051', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(172647, NULL, 'G3DSA:1.10.30.10:FF:000171', NULL, NULL, 'HMG box-containing protein C10F6.08c', NULL, NULL, NULL, NULL, NULL, 4),
(172648, NULL, 'G3DSA:1.10.225.10:FF:000017', NULL, NULL, 'SaPosin-like Protein family', NULL, NULL, NULL, NULL, NULL, 4),
(172649, NULL, 'G3DSA:1.10.150.300:FF:000001', NULL, NULL, 'Ribosome-binding ATPase YchF', NULL, NULL, NULL, NULL, NULL, 4),
(172650, NULL, 'G3DSA:2.70.160.11:FF:000047', NULL, NULL, 'Arginine methyltransferase 6', NULL, NULL, NULL, NULL, NULL, 4),
(172651, NULL, 'G3DSA:3.40.50.2300:FF:001418', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172652, NULL, 'G3DSA:2.110.10.10:FF:000011', NULL, NULL, 'Matrix metalloproteinase-9', NULL, NULL, NULL, NULL, NULL, 4),
(172653, NULL, 'G3DSA:3.30.70.890:FF:000070', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(172654, NULL, 'G3DSA:1.20.58.530:FF:000023', NULL, NULL, 'Myosin heavy chain subunit', NULL, NULL, NULL, NULL, NULL, 4),
(172655, NULL, 'G3DSA:1.10.150.310:FF:000004', NULL, NULL, 'Ribosomal protein S1, RNA binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(172656, NULL, 'G3DSA:1.20.1250.20:FF:002099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172657, NULL, 'G3DSA:3.40.1090.10:FF:000031', NULL, NULL, 'Patatin', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(172658, NULL, 'G3DSA:3.30.160.60:FF:002106', NULL, NULL, 'GD13139', NULL, NULL, NULL, NULL, NULL, 4),
(172659, NULL, 'G3DSA:1.10.8.270:FF:000161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172660, NULL, 'G3DSA:3.20.20.190:FF:000094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172661, NULL, 'G3DSA:1.25.10.10:FF:000462', NULL, NULL, 'Splicing factor 3B subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(172662, NULL, 'G3DSA:2.70.98.30:FF:000002', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(172663, NULL, 'G3DSA:1.20.920.50:FF:000002', NULL, NULL, 'Salivary androgen-binding protein beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(172664, NULL, 'G3DSA:3.40.50.1100:FF:000204', NULL, NULL, 'Cbs-1', NULL, NULL, NULL, NULL, NULL, 4),
(172665, NULL, 'G3DSA:3.40.309.10:FF:000001', NULL, NULL, 'Mitochondrial aldehyde dehydrogenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(172666, NULL, 'G3DSA:3.30.230.80:FF:000004', NULL, NULL, 'Heat shock protein 75 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(172667, NULL, 'G3DSA:3.40.1170.10:FF:000032', NULL, NULL, 'DNA mismatch repair protein MutS 2', NULL, NULL, NULL, NULL, NULL, 4),
(172668, NULL, 'G3DSA:2.40.30.10:FF:000201', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(172669, NULL, 'G3DSA:4.10.60.10:FF:000042', NULL, NULL, 'Transcription or splicing factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(172670, NULL, 'G3DSA:2.60.40.10:FF:003909', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172671, NULL, 'G3DSA:2.40.50.140:FF:000882', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172672, NULL, 'G3DSA:1.10.540.10:FF:000137', NULL, NULL, 'Medium-chain acyl-CoA dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172673, NULL, 'G3DSA:1.20.5.110:FF:000246', NULL, NULL, 'Qa-SNARE protein, Ufe1/Syntaxin 18 family', NULL, NULL, NULL, NULL, NULL, 4),
(172674, NULL, 'G3DSA:2.60.40.10:FF:002044', NULL, NULL, 'Mesocentin', NULL, NULL, NULL, NULL, NULL, 4),
(172675, NULL, 'G3DSA:2.30.40.10:FF:000168', NULL, NULL, 'Aminodeoxyfutalosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(172676, NULL, 'G3DSA:1.10.8.50:FF:000023', NULL, NULL, 'Type 2 DNA topoisomerase 6 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(172677, NULL, 'G3DSA:3.40.50.2020:FF:000025', NULL, NULL, 'Uridine monophosphate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(172678, NULL, 'G3DSA:3.50.50.60:FF:000141', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(172679, NULL, 'G3DSA:2.60.40.60:FF:000070', NULL, NULL, 'protocadherin-15 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(172680, NULL, 'G3DSA:1.10.506.10:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172681, NULL, 'G3DSA:1.25.40.10:FF:001537', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g37310', NULL, NULL, NULL, NULL, NULL, 4),
(172682, NULL, 'G3DSA:1.20.120.980:FF:000011', NULL, NULL, 'Prolyl Carboxy Peptidase like', NULL, NULL, NULL, NULL, NULL, 4),
(172683, NULL, 'G3DSA:2.60.40.10:FF:003567', NULL, NULL, 'CD8 alpha antigen', NULL, NULL, NULL, NULL, NULL, 4),
(172684, NULL, 'G3DSA:3.40.1190.10:FF:000027', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(172685, NULL, 'G3DSA:3.30.1330.30:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172686, NULL, 'G3DSA:1.25.40.10:FF:000014', NULL, NULL, 'SMG7 nonsense mediated mRNA decay factor', NULL, NULL, NULL, NULL, NULL, 4),
(172687, NULL, 'G3DSA:3.40.50.10330:FF:000072', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(172688, NULL, 'G3DSA:1.10.1520.10:FF:000017', NULL, NULL, 'Ribonuclease 3', NULL, NULL, NULL, NULL, NULL, 4),
(172689, NULL, 'G3DSA:1.10.150.240:FF:000011', NULL, NULL, 'Bifunctional epoxide hydrolase 2', NULL, NULL, NULL, NULL, NULL, 4),
(172690, NULL, 'G3DSA:2.130.10.10:FF:003950', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(172691, NULL, 'G3DSA:1.10.8.60:FF:000026', NULL, NULL, 'vesicle-fusing ATPase isoform X1', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(172692, NULL, 'G3DSA:3.80.30.20:FF:000014', NULL, NULL, 'RNA modification enzyme, MiaB family', NULL, NULL, NULL, NULL, NULL, 4),
(172693, NULL, 'G3DSA:1.25.40.20:FF:000017', NULL, NULL, 'KN motif and ankyrin repeat domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(172694, NULL, 'G3DSA:1.20.1270.60:FF:000173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172695, NULL, 'G3DSA:2.60.40.10:FF:001768', NULL, NULL, 'Interleukin-21 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(172696, NULL, 'G3DSA:1.10.3210.10:FF:000090', NULL, NULL, 'HD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(172697, NULL, 'G3DSA:3.30.110.110:FF:000014', NULL, NULL, 'DNA repair protein (Mre11)', NULL, NULL, NULL, NULL, NULL, 4),
(172698, NULL, 'G3DSA:1.10.8.870:FF:000026', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(172699, NULL, 'G3DSA:3.40.50.2300:FF:001531', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172700, NULL, 'G3DSA:3.90.79.10:FF:000134', NULL, NULL, 'Nudix hydrolase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(172701, NULL, 'G3DSA:1.10.238.10:FF:000322', NULL, NULL, 'Probable calcium-binding protein CML17', NULL, NULL, NULL, NULL, NULL, 4),
(172702, NULL, 'G3DSA:1.10.10.10:FF:001586', NULL, NULL, 'SAM-dependent methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(172703, NULL, 'G3DSA:2.170.150.40:FF:000002', NULL, NULL, 'DUF427 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(172704, NULL, 'G3DSA:3.40.960.10:FF:000003', NULL, NULL, 'RAP domain-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(172705, NULL, 'G3DSA:1.10.720.30:FF:000062', NULL, NULL, 'DNA-binding protein VF_0530', NULL, NULL, NULL, NULL, NULL, 4),
(172706, NULL, 'G3DSA:4.10.400.10:FF:000065', NULL, NULL, 'Transmembrane protease serine 7', NULL, NULL, NULL, NULL, NULL, 4),
(172707, NULL, 'G3DSA:1.10.287.1480:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172708, NULL, 'G3DSA:2.60.40.10:FF:003966', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172709, NULL, 'G3DSA:2.40.150.20:FF:000015', NULL, NULL, '60S ribosomal protein L23, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172710, NULL, 'G3DSA:1.25.40.20:FF:001597', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172711, NULL, 'G3DSA:3.30.1390.20:FF:000020', NULL, NULL, 'GD23812', NULL, NULL, NULL, NULL, NULL, 4),
(172712, NULL, 'G3DSA:2.10.25.10:FF:001106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172713, NULL, 'G3DSA:1.10.238.10:FF:000266', NULL, NULL, 'TPPP family protein', NULL, NULL, NULL, NULL, NULL, 4),
(172714, NULL, 'G3DSA:1.10.10.60:FF:000212', NULL, NULL, 'Zinc fingers and homeoboxes protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(172715, NULL, 'G3DSA:3.40.50.620:FF:000617', NULL, NULL, 'Bifunctional NMN adenylyltransferase/Nudix hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(172716, NULL, 'G3DSA:3.40.50.10810:FF:000120', NULL, NULL, 'SNF2 family N-terminal domain/Helicase conserved C-terminal domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172717, NULL, 'G3DSA:3.40.50.150:FF:000611', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172718, NULL, 'G3DSA:1.10.506.10:FF:000024', NULL, NULL, 'Plexin D1', NULL, NULL, NULL, NULL, NULL, 4),
(172719, NULL, 'G3DSA:2.30.30.140:FF:000037', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(172720, NULL, 'G3DSA:3.40.1190.20:FF:000087', NULL, NULL, 'Pyridoxal kinase', NULL, NULL, NULL, NULL, NULL, 4),
(172721, NULL, 'G3DSA:1.10.287.1490:FF:000009', NULL, NULL, 'Golgin subfamily A member 5', NULL, NULL, NULL, NULL, NULL, 4),
(172722, NULL, 'G3DSA:1.10.3210.10:FF:000033', NULL, NULL, 'GTP pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(172723, NULL, 'G3DSA:3.40.50.10880:FF:000006', NULL, NULL, 'DUF89 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(172724, NULL, 'G3DSA:2.40.128.20:FF:000037', NULL, NULL, 'Chromophore lyase CpcS/CpeS', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(172725, NULL, 'G3DSA:1.20.1250.20:FF:000643', NULL, NULL, 'Sucrose transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172726, NULL, 'G3DSA:2.130.10.10:FF:003219', NULL, NULL, 'Probable cleavage and polyadenylation specificity factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(172727, NULL, 'G3DSA:3.30.160.60:FF:005872', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172728, NULL, 'G3DSA:1.10.10.830:FF:000012', NULL, NULL, 'Isoleucine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(172729, NULL, 'G3DSA:1.20.120.230:FF:000022', NULL, NULL, 'Catenin alpha like 1', NULL, NULL, NULL, NULL, NULL, 4),
(172730, NULL, 'G3DSA:1.10.575.10:FF:000004', NULL, NULL, 'Nuclease S1', NULL, NULL, NULL, NULL, NULL, 4),
(172731, NULL, 'G3DSA:3.30.70.2390:FF:000003', NULL, NULL, 'Tuberculin related peptide', NULL, NULL, NULL, NULL, NULL, 4),
(172732, NULL, 'G3DSA:3.30.420.10:FF:000745', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172733, NULL, 'G3DSA:3.40.50.10610:FF:000009', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(172734, NULL, 'G3DSA:1.20.1460.10:FF:000009', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(172735, NULL, 'G3DSA:3.30.420.10:FF:000689', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172736, NULL, 'G3DSA:1.25.40.10:FF:001594', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(172737, NULL, 'G3DSA:1.20.120.350:FF:000165', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172738, NULL, 'G3DSA:3.40.1350.60:FF:000004', NULL, NULL, 'Sugar fermentation stimulation protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(172739, NULL, 'G3DSA:3.40.50.300:FF:002258', NULL, NULL, 'ZO-1 (Zonula Occludens tight junctional protein) Ortholog', NULL, NULL, NULL, NULL, NULL, 4),
(172740, NULL, 'G3DSA:1.20.5.110:FF:000302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172741, NULL, 'G3DSA:3.80.10.10:FF:001084', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(172742, NULL, 'G3DSA:3.90.132.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172743, NULL, 'G3DSA:2.130.10.10:FF:000223', NULL, NULL, 'semaphorin-7A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(172744, NULL, 'G3DSA:3.40.50.1000:FF:000382', NULL, NULL, 'Putative proton motive ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(172745, NULL, 'G3DSA:3.40.630.30:FF:000624', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172746, NULL, 'G3DSA:2.60.40.60:FF:000412', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172747, NULL, 'G3DSA:2.130.10.10:FF:000280', NULL, NULL, 'Wd40 repeat-containing protein smu1', NULL, NULL, NULL, NULL, NULL, 4),
(172748, NULL, 'G3DSA:1.20.58.60:FF:000659', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172749, NULL, 'G3DSA:3.40.1190.20:FF:000143', NULL, NULL, 'Putative pyridoxal kinase C6F6.11c', NULL, NULL, NULL, NULL, NULL, 4),
(172750, NULL, 'G3DSA:3.40.30.10:FF:000075', NULL, NULL, 'Glutathione S-transferase omega-1', NULL, NULL, NULL, NULL, NULL, 4),
(172751, NULL, 'G3DSA:1.10.20.10:FF:000013', NULL, NULL, 'Core histone macro-H2A', NULL, NULL, NULL, NULL, NULL, 4),
(172752, NULL, 'G3DSA:3.30.360.10:FF:000072', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(172753, NULL, 'G3DSA:1.10.405.20:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172754, NULL, 'G3DSA:1.20.58.60:FF:000698', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172755, NULL, 'G3DSA:2.170.170.11:FF:000001', NULL, NULL, 'Malate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(172756, NULL, 'G3DSA:3.30.450.50:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172757, NULL, 'G3DSA:3.30.9.10:FF:000094', NULL, NULL, 'tRNA 5-methylaminomethyl-2-thiouridine biosynthesis bifunctional protein MnmC', NULL, NULL, NULL, NULL, NULL, 4),
(172758, NULL, 'G3DSA:1.10.405.10:FF:000003', NULL, NULL, 'Rab proteins geranylgeranyltransferase component A', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(172759, NULL, 'G3DSA:3.30.9.10:FF:000037', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(172760, NULL, 'G3DSA:3.30.200.20:FF:001603', NULL, NULL, 'AaceriAEL083Wp', NULL, NULL, NULL, NULL, NULL, 4),
(172761, NULL, 'G3DSA:3.30.1360.120:FF:000043', NULL, NULL, 'Nuclear encoded Mitochondrial TRNA Carboxymethyl-amino-methyl modification of Uridine residues', NULL, NULL, NULL, NULL, NULL, 4),
(172762, NULL, 'G3DSA:3.30.428.70:FF:000005', NULL, NULL, 'YALI0F30349p', NULL, NULL, NULL, NULL, NULL, 4),
(172763, NULL, 'G3DSA:1.10.287.70:FF:000515', NULL, NULL, 'Tetrameric potassium-selective cyclic nucleotide gated channel', NULL, NULL, NULL, NULL, NULL, 4),
(172764, NULL, 'G3DSA:3.30.565.10:FF:000042', NULL, NULL, 'Two-component sensor histidine kinase KdpD', NULL, NULL, NULL, NULL, NULL, 4),
(172765, NULL, 'G3DSA:1.20.1260.140:FF:000005', NULL, NULL, 'Alternative oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(172766, NULL, 'G3DSA:3.90.70.10:FF:000047', NULL, NULL, 'ubiquitin carboxyl-terminal hydrolase 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(172767, NULL, 'G3DSA:3.40.50.10490:FF:000159', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172768, NULL, 'G3DSA:3.40.50.300:FF:003837', NULL, NULL, 'Phosphoryl Seryl-TRNA (Ser/Sec) Kinase', NULL, NULL, NULL, NULL, NULL, 4),
(172769, NULL, 'G3DSA:2.60.120.1440:FF:000004', NULL, NULL, 'Sigma factor regulatory protein, FecR/PupR family', NULL, NULL, NULL, NULL, NULL, 4),
(172770, NULL, 'G3DSA:3.90.180.10:FF:000185', NULL, NULL, 'Alcohol dehydrogenase-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(172771, NULL, 'G3DSA:2.30.30.140:FF:000150', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(172772, NULL, 'G3DSA:3.30.559.10:FF:000275', NULL, NULL, 'Carnitine O-acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172773, NULL, 'G3DSA:3.40.50.10190:FF:000226', NULL, NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(172774, NULL, 'G3DSA:3.30.200.20:FF:000024', NULL, NULL, 'B-Raf proto-oncogene serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(172775, NULL, 'G3DSA:3.40.50.12160:FF:000014', NULL, NULL, 'Ribosomal protein S12 methylthiotransferase RimO', NULL, NULL, NULL, NULL, NULL, 4),
(172776, NULL, 'G3DSA:1.50.10.10:FF:000067', NULL, NULL, 'Phosphorylase b kinase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(172777, NULL, 'G3DSA:3.30.710.10:FF:000285', NULL, NULL, 'kelch-like protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(172778, NULL, 'G3DSA:2.160.20.80:FF:000013', NULL, NULL, 'Synaptic vesicle glycoprotein 2B-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(172779, NULL, 'G3DSA:1.10.472.80:FF:000235', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172780, NULL, 'G3DSA:3.30.420.210:FF:000013', NULL, NULL, 'UBX domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(172781, NULL, 'G3DSA:3.30.160.60:FF:004236', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172782, NULL, 'G3DSA:3.40.50.11260:FF:000019', NULL, NULL, 'Chaperone protein HtpG', NULL, NULL, NULL, NULL, NULL, 4),
(172783, NULL, 'G3DSA:3.40.50.300:FF:007766', NULL, NULL, 'DEAH (Asp-Glu-Ala-His) box polypeptide 37', NULL, NULL, NULL, NULL, NULL, 4),
(172784, NULL, 'G3DSA:1.25.40.10:FF:000290', NULL, NULL, 'Protein LOW PSII ACCUMULATION 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(172785, NULL, 'G3DSA:3.30.70.920:FF:000005', NULL, NULL, 'Lrp/AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(172786, NULL, 'G3DSA:1.10.3260.10:FF:000036', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(172787, NULL, 'G3DSA:3.80.10.10:FF:001140', NULL, NULL, 'GM24892', NULL, NULL, NULL, NULL, NULL, 4),
(172788, NULL, 'G3DSA:3.30.70.240:FF:000009', NULL, NULL, 'SBDS ribosome maturation factor', NULL, NULL, NULL, NULL, NULL, 4),
(172789, NULL, 'G3DSA:3.40.50.300:FF:008222', NULL, NULL, 'Dynein heavy chain 9-related protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(172790, NULL, 'G3DSA:1.10.240.10:FF:000030', NULL, NULL, 'Tryptophanyl-tRNA synthetase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(172791, NULL, 'G3DSA:3.30.160.60:FF:000307', NULL, NULL, 'Zinc finger protein ZFP69 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(172792, NULL, 'G3DSA:2.120.10.80:FF:000014', NULL, NULL, 'Kelch-like protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(172793, NULL, 'G3DSA:2.90.10.10:FF:000001', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(172794, NULL, 'G3DSA:1.10.287.110:FF:000432', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172795, NULL, 'G3DSA:3.40.630.30:FF:000568', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172796, NULL, 'G3DSA:1.10.510.10:FF:004351', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172797, NULL, 'G3DSA:3.40.50.1240:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172798, NULL, 'G3DSA:2.120.10.90:FF:000017', NULL, NULL, 'DNA topoisomerase 4 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(172799, NULL, 'G3DSA:3.40.30.10:FF:000693', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(172800, NULL, 'G3DSA:1.25.40.20:FF:001872', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(172801, NULL, 'G3DSA:3.40.50.300:FF:008042', NULL, NULL, 'Caspase recruitment domain family, member 14', NULL, NULL, NULL, NULL, NULL, 4),
(172802, NULL, 'G3DSA:3.90.1150.10:FF:000002', NULL, NULL, 'Cysteine desulfurase IscS', NULL, NULL, NULL, NULL, NULL, 4),
(172803, NULL, 'G3DSA:2.130.10.10:FF:003096', NULL, NULL, '77 kDa echinoderm microtubule-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(172804, NULL, 'G3DSA:3.10.20.90:FF:000537', NULL, NULL, 'UBX domain protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(172805, NULL, 'G3DSA:1.25.40.20:FF:000236', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(172806, NULL, 'G3DSA:1.10.10.10:FF:001529', NULL, NULL, 'Phenylalanine--tRNA ligase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(172807, NULL, 'G3DSA:3.30.30.30:FF:000042', NULL, NULL, 'Hsp70 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172808, NULL, 'G3DSA:1.25.40.20:FF:000293', NULL, NULL, 'Ankyrin repeat domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(172809, NULL, 'G3DSA:1.10.1750.10:FF:000006', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(172810, NULL, 'G3DSA:2.60.40.3110:FF:000005', NULL, NULL, 'Fimbrial biogenesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(172811, NULL, 'G3DSA:3.90.230.10:FF:000015', NULL, NULL, 'Methionine aminopeptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(172812, NULL, 'G3DSA:3.40.50.10190:FF:000283', NULL, NULL, 'DNA topoisomerase II-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(172813, NULL, 'G3DSA:2.130.10.10:FF:004113', NULL, NULL, 'SD02661p', NULL, NULL, NULL, NULL, NULL, 4),
(172814, NULL, 'G3DSA:3.30.70.330:FF:001559', NULL, NULL, 'RNA-binding region RNP-1 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(172815, NULL, 'G3DSA:1.25.40.10:FF:001650', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(172816, NULL, 'G3DSA:1.20.1070.10:FF:001093', NULL, NULL, 'Prokineticin receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(172817, NULL, 'G3DSA:1.20.1050.80:FF:000016', NULL, NULL, 'Alsin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(172818, NULL, 'G3DSA:1.10.1040.10:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172819, NULL, 'G3DSA:1.25.10.10:FF:003059', NULL, NULL, 'HEAT repeat domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(172820, NULL, 'G3DSA:1.25.40.20:FF:001653', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(172821, NULL, 'G3DSA:1.10.510.10:FF:003676', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172822, NULL, 'G3DSA:3.90.226.10:FF:000016', NULL, NULL, 'Propionyl-CoA carboxylase, beta subunit', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(172823, NULL, 'G3DSA:1.10.287.70:FF:000392', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172824, NULL, 'G3DSA:3.10.250.10:FF:000068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172825, NULL, 'G3DSA:4.10.1060.10:FF:000007', NULL, NULL, 'Zinc finger Ran-binding domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(172826, NULL, 'G3DSA:3.40.50.300:FF:003276', NULL, NULL, 'Si:ch211-209n20.1', NULL, NULL, NULL, NULL, NULL, 4),
(172827, NULL, 'G3DSA:3.30.160.60:FF:003893', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172828, NULL, 'G3DSA:3.80.10.10:FF:000864', NULL, NULL, 'BRASSINOSTEROID INSENSITIVE 1-associated receptor kinase 1, putative, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(172829, NULL, 'G3DSA:3.20.20.220:FF:000029', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(172830, NULL, 'G3DSA:1.10.441.10:FF:000008', NULL, NULL, 'Phosphomannose isomerase type I, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172831, NULL, 'G3DSA:3.30.460.10:FF:000181', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(172832, NULL, 'G3DSA:1.20.58.1210:FF:000012', NULL, NULL, 'Exocyst complex component 8', NULL, NULL, NULL, NULL, NULL, 4),
(172833, NULL, 'G3DSA:1.20.1070.10:FF:000199', NULL, NULL, 'Gonadotropin-releasing hormone II receptor', NULL, NULL, NULL, NULL, NULL, 4),
(172834, NULL, 'G3DSA:3.40.50.300:FF:000460', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(172835, NULL, 'G3DSA:3.30.200.20:FF:001660', NULL, NULL, 'Cell division control protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172836, NULL, 'G3DSA:1.10.10.10:FF:002024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172837, NULL, 'G3DSA:2.130.10.10:FF:003837', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172838, NULL, 'G3DSA:2.60.40.1670:FF:000022', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(172839, NULL, 'G3DSA:2.60.40.60:FF:000631', NULL, NULL, 'Cadherin-related neuronal receptor 7', NULL, NULL, NULL, NULL, NULL, 4),
(172840, NULL, 'G3DSA:1.20.1250.20:FF:000587', NULL, NULL, 'Multi-drug resistance efflux pump PmrA', NULL, NULL, NULL, NULL, NULL, 4),
(172841, NULL, 'G3DSA:3.30.70.330:FF:002577', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172842, NULL, 'G3DSA:1.10.8.720:FF:000009', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172843, NULL, 'G3DSA:1.10.510.10:FF:000309', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(172844, NULL, 'G3DSA:2.60.40.10:FF:003680', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172845, NULL, 'G3DSA:3.30.70.330:FF:002919', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172846, NULL, 'G3DSA:2.160.20.70:FF:000010', NULL, NULL, 'Adenylyl cyclase-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(172847, NULL, 'G3DSA:3.20.20.330:FF:000006', NULL, NULL, 'Methionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(172848, NULL, 'G3DSA:3.80.10.10:FF:001207', NULL, NULL, 'GM20089', NULL, NULL, NULL, NULL, NULL, 4),
(172849, NULL, 'G3DSA:1.10.10.10:FF:002081', NULL, NULL, 'Spo11-like type II topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(172850, NULL, 'G3DSA:3.40.50.300:FF:000403', NULL, NULL, 'ATP-binding cassette sub-family B member 8, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(172851, NULL, 'G3DSA:1.10.340.30:FF:000021', NULL, NULL, '8-oxoguanine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(172852, NULL, 'G3DSA:3.40.250.10:FF:000207', NULL, NULL, 'Tyrosine protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(172853, NULL, 'G3DSA:2.130.10.10:FF:000403', NULL, NULL, 'PH-interacting protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(172854, NULL, 'G3DSA:3.40.50.300:FF:007547', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172855, NULL, 'G3DSA:3.40.50.880:FF:000032', NULL, NULL, 'Glyoxalase', NULL, NULL, NULL, NULL, NULL, 4),
(172856, NULL, 'G3DSA:3.40.50.300:FF:003894', NULL, NULL, 'Arf family GTPase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(172857, NULL, 'G3DSA:3.30.40.10:FF:001346', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(172858, NULL, 'G3DSA:2.30.39.10:FF:000154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172859, NULL, 'G3DSA:1.10.8.710:FF:000006', NULL, NULL, 'cytoplasmic dynein 2 heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(172860, NULL, 'G3DSA:3.40.50.740:FF:000018', NULL, NULL, 'Tetrathionate reductase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(172861, NULL, 'G3DSA:2.60.40.1530:FF:000008', NULL, NULL, 'Integrin subunit alpha L', NULL, NULL, NULL, NULL, NULL, 4),
(172862, NULL, 'G3DSA:2.60.120.330:FF:000216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172863, NULL, 'G3DSA:2.40.50.140:FF:001045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172864, NULL, 'G3DSA:1.10.287.110:FF:000090', NULL, NULL, 'Mitochondrial import inner membrane translocase subunit TIM16, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172865, NULL, 'G3DSA:1.25.40.10:FF:001717', NULL, NULL, 'Tetratricopeptide repeat domain 21B', NULL, NULL, NULL, NULL, NULL, 4),
(172866, NULL, 'G3DSA:1.10.510.10:FF:004019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172867, NULL, 'G3DSA:1.20.1050.60:FF:000010', NULL, NULL, 'Glycoside hydrolase family 92 protein', NULL, NULL, NULL, NULL, NULL, 4),
(172868, NULL, 'G3DSA:3.20.20.190:FF:000150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172869, NULL, 'G3DSA:4.10.400.10:FF:000245', NULL, NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(172870, NULL, 'G3DSA:1.20.1070.10:FF:001036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172871, NULL, 'G3DSA:3.40.1190.20:FF:000098', NULL, NULL, 'Tagatose-6-phosphate kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172872, NULL, 'G3DSA:3.30.1490.180:FF:000016', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(172873, NULL, 'G3DSA:3.30.1490.190:FF:000019', NULL, NULL, 'Ferric uptake regulator family protein', NULL, NULL, NULL, NULL, NULL, 4),
(172874, NULL, 'G3DSA:3.40.50.1390:FF:000015', NULL, NULL, 'Recombinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(172875, NULL, 'G3DSA:3.10.100.10:FF:000203', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(172876, NULL, 'G3DSA:3.80.10.10:FF:004349', NULL, NULL, 'Dc50, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172877, NULL, 'G3DSA:2.60.40.10:FF:005927', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172878, NULL, 'G3DSA:1.25.40.1030:FF:000037', NULL, NULL, 'COPII coat assembly protein SEC16', NULL, NULL, NULL, NULL, NULL, 4),
(172879, NULL, 'G3DSA:1.10.8.720:FF:000032', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(172880, NULL, 'G3DSA:3.40.630.30:FF:000260', NULL, NULL, 'Acetyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(172881, NULL, 'G3DSA:1.20.1440.340:FF:000011', NULL, NULL, 'Galactokinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172882, NULL, 'G3DSA:1.10.260.40:FF:000097', NULL, NULL, 'Octamer-binding transcription factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(172883, NULL, 'G3DSA:2.60.40.10:FF:002701', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172884, NULL, 'G3DSA:3.30.70.330:FF:002993', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172885, NULL, 'G3DSA:1.25.40.10:FF:003549', NULL, NULL, 'Prolyl 3-hydroxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(172886, NULL, 'G3DSA:1.25.40.10:FF:001425', NULL, NULL, 'Alpha-SNAP, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172887, NULL, 'G3DSA:3.90.850.10:FF:000017', NULL, NULL, 'Acylpyruvase FAHD1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(172888, NULL, 'G3DSA:2.130.10.10:FF:005861', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172889, NULL, 'G3DSA:2.40.110.20:FF:000002', NULL, NULL, 'Acyl-CoA dehydrogenase, C-terminal domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(172890, NULL, 'G3DSA:1.10.287.70:FF:000723', NULL, NULL, 'Calcium voltage-gated channel subunit alpha1 A', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(172891, NULL, 'G3DSA:4.10.640.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172892, NULL, 'G3DSA:3.40.50.1010:FF:000065', NULL, NULL, 'Mitochondrial structure specific endonuclease I (SSE-1)', NULL, NULL, NULL, NULL, NULL, 4),
(172893, NULL, 'G3DSA:3.30.160.60:FF:002134', NULL, NULL, 'Zinc finger protein 616', NULL, NULL, NULL, NULL, NULL, 4),
(172894, NULL, 'G3DSA:3.30.40.10:FF:000868', NULL, NULL, 'RING-H2 finger protein ATL3', NULL, NULL, NULL, NULL, NULL, 4),
(172895, NULL, 'G3DSA:1.10.3090.10:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(172896, NULL, 'G3DSA:2.80.10.50:FF:000002', NULL, NULL, 'Inositol 1,4,5-trisphosphate receptor type 2', NULL, NULL, NULL, NULL, NULL, 4),
(172897, NULL, 'G3DSA:2.30.30.140:FF:000352', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(172898, NULL, 'G3DSA:3.80.10.10:FF:001123', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(172899, NULL, 'G3DSA:3.40.50.300:FF:008003', NULL, NULL, 'Dynein heavy chain, cytosolic, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172900, NULL, 'G3DSA:4.10.400.10:FF:000251', NULL, NULL, 'Low-density lipoprotein RecePtor related', NULL, NULL, NULL, NULL, NULL, 4),
(172901, NULL, 'G3DSA:3.30.160.20:FF:000138', NULL, NULL, 'Probable RNA-binding protein 46', NULL, NULL, NULL, NULL, NULL, 4),
(172902, NULL, 'G3DSA:3.10.110.10:FF:000131', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 25', NULL, NULL, NULL, NULL, NULL, 4),
(172903, NULL, 'G3DSA:1.10.3500.10:FF:000022', NULL, NULL, 'Transcription elongation factor SPT6', NULL, NULL, NULL, NULL, NULL, 4),
(172904, NULL, 'G3DSA:1.50.10.10:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172905, NULL, 'G3DSA:3.40.50.450:FF:000038', NULL, NULL, 'Diphosphate-fructose-6-phosphate 1-phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(172906, NULL, 'G3DSA:3.40.50.150:FF:000055', NULL, NULL, '5-methylcytosine rRNA methyltransferase NSUN4', NULL, NULL, NULL, NULL, NULL, 4),
(172907, NULL, 'G3DSA:3.90.1570.50:FF:000001', NULL, NULL, 'Type I restriction-modification system restriction subunit R', NULL, NULL, NULL, NULL, NULL, 4),
(172908, NULL, 'G3DSA:2.60.40.10:FF:005883', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172909, NULL, 'G3DSA:1.25.10.10:FF:001923', NULL, NULL, 'Protein CBR-DAAM-1', NULL, NULL, NULL, NULL, NULL, 4),
(172910, NULL, 'G3DSA:3.40.50.720:FF:001114', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(172911, NULL, 'G3DSA:3.40.50.1380:FF:000012', NULL, NULL, 'Bifunctional purine biosynthesis protein PurH', NULL, NULL, NULL, NULL, NULL, 4),
(172912, NULL, 'G3DSA:3.30.1240.10:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172913, NULL, 'G3DSA:1.50.10.10:FF:000207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172914, NULL, 'G3DSA:2.102.10.10:FF:000017', NULL, NULL, 'Ferrodoxin reductase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(172915, NULL, 'G3DSA:1.10.580.10:FF:000027', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(172916, NULL, 'G3DSA:3.40.720.10:FF:000373', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(172917, NULL, 'G3DSA:3.40.50.12370:FF:000009', NULL, NULL, 'Cation/H(+) antiporter 14', NULL, NULL, NULL, NULL, NULL, 4),
(172918, NULL, 'G3DSA:3.40.50.300:FF:004304', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(172919, NULL, 'G3DSA:3.30.1640.10:FF:000020', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(172920, NULL, 'G3DSA:1.20.120.980:FF:000016', NULL, NULL, 'IP20428p', NULL, NULL, NULL, NULL, NULL, 4),
(172921, NULL, 'G3DSA:1.25.40.10:FF:004022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172922, NULL, 'G3DSA:3.30.750.44:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(172923, NULL, 'G3DSA:3.40.50.12350:FF:000003', NULL, NULL, 'Eyes absent homolog', NULL, NULL, NULL, NULL, NULL, 4),
(172924, NULL, 'G3DSA:4.10.280.10:FF:000162', NULL, NULL, 'Transcription factor BHLH148', NULL, NULL, NULL, NULL, NULL, 4),
(172925, NULL, 'G3DSA:3.90.76.10:FF:000032', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(172926, NULL, 'G3DSA:2.130.10.10:FF:001527', NULL, NULL, 'WD repeat-containing protein SAZD, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172927, NULL, 'G3DSA:1.10.1410.10:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172928, NULL, 'G3DSA:1.20.990.10:FF:000039', NULL, NULL, 'NADPH-dependent diflavin oxidoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(172929, NULL, 'G3DSA:1.10.630.10:FF:000526', NULL, NULL, 'Cytochrome P450, family 2, subfamily k, polypeptide 19', NULL, NULL, NULL, NULL, NULL, 4),
(172930, NULL, 'G3DSA:2.30.29.240:FF:000020', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(172931, NULL, 'G3DSA:3.40.720.10:FF:000047', NULL, NULL, 'Arylsulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(172932, NULL, 'G3DSA:3.30.559.30:FF:000022', NULL, NULL, 'L-2-aminoadipate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(172933, NULL, 'G3DSA:3.50.50.60:FF:001248', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(172934, NULL, 'G3DSA:1.10.1620.20:FF:000005', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(172935, NULL, 'G3DSA:3.40.50.720:FF:000967', NULL, NULL, 'Probable polyketide synthase 30', NULL, NULL, NULL, NULL, NULL, 4),
(172936, NULL, 'G3DSA:1.10.225.10:FF:000012', NULL, NULL, 'Proactivator polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(172937, NULL, 'G3DSA:3.40.50.300:FF:004630', NULL, NULL, 'Transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(172938, NULL, 'G3DSA:3.30.1840.10:FF:000001', NULL, NULL, 'Polyphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(172939, NULL, 'G3DSA:2.60.40.10:FF:004146', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172940, NULL, 'G3DSA:3.90.1420.10:FF:000001', NULL, NULL, 'histone-lysine N-methyltransferase setd3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(172941, NULL, 'G3DSA:2.130.10.10:FF:005905', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172942, NULL, 'G3DSA:3.40.50.300:FF:000252', NULL, NULL, 'Uridine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(172943, NULL, 'G3DSA:3.30.70.330:FF:001891', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172944, NULL, 'G3DSA:3.40.50.1000:FF:000062', NULL, NULL, 'Cation-transporting ATPase I', NULL, NULL, NULL, NULL, NULL, 4),
(172945, NULL, 'G3DSA:1.10.220.30:FF:000029', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(172946, NULL, 'G3DSA:2.60.40.1730:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172947, NULL, 'G3DSA:1.25.40.20:FF:000326', NULL, NULL, 'Calmodulin-binding transcription activator 2', NULL, NULL, NULL, NULL, NULL, 4),
(172948, NULL, 'G3DSA:1.10.8.1310:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172949, NULL, 'G3DSA:2.40.170.20:FF:000011', NULL, NULL, 'Ferrioxamine B receptor', NULL, NULL, NULL, NULL, NULL, 4),
(172950, NULL, 'G3DSA:1.50.40.10:FF:000035', NULL, NULL, 'Mitochondrial carrier homolog 2 variant', NULL, NULL, NULL, NULL, NULL, 4),
(172951, NULL, 'G3DSA:1.25.40.10:FF:000323', NULL, NULL, 'Gamma-soluble NSF attachment protein', NULL, NULL, NULL, NULL, NULL, 4),
(172952, NULL, 'G3DSA:3.30.1120.10:FF:000008', NULL, NULL, 'Arylsulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(172953, NULL, 'G3DSA:2.130.10.10:FF:003618', NULL, NULL, 'Ribosomal RNA processing 9, U3 small nucleolar RNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(172954, NULL, 'G3DSA:1.10.630.10:FF:000835', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(172955, NULL, 'G3DSA:2.130.10.10:FF:005535', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(172956, NULL, 'G3DSA:1.20.58.830:FF:000028', NULL, NULL, 'Erythrocyte membrane protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(172957, NULL, 'G3DSA:3.90.228.10:FF:000015', NULL, NULL, 'C2H2-like zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(172958, NULL, 'G3DSA:1.20.1560.10:FF:000697', NULL, NULL, 'Lantibiotic mersacidin transporter system', NULL, NULL, NULL, NULL, NULL, 4),
(172959, NULL, 'G3DSA:3.30.70.80:FF:000008', NULL, NULL, 'Alkaline protease 1', NULL, NULL, NULL, NULL, NULL, 4),
(172960, NULL, 'G3DSA:3.50.50.100:FF:000009', NULL, NULL, 'Internal alternative NAD(P)H-ubiquinone oxidoreductase A1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(172961, NULL, 'G3DSA:1.25.40.150:FF:000001', NULL, NULL, 'V-type proton ATPase subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(172962, NULL, 'G3DSA:3.80.10.10:FF:000943', NULL, NULL, 'Disease resistance protein Pik-2', NULL, NULL, NULL, NULL, NULL, 4),
(172963, NULL, 'G3DSA:3.90.228.20:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172964, NULL, 'G3DSA:1.25.10.10:FF:000142', NULL, NULL, 'TOG array regulator of axonemal microtubules 1', NULL, NULL, NULL, NULL, NULL, 4),
(172965, NULL, 'G3DSA:3.40.50.300:FF:001707', NULL, NULL, 'ABC transporter ATP-binding protein/permease', NULL, NULL, NULL, NULL, NULL, 4),
(172966, NULL, 'G3DSA:3.40.50.720:FF:000288', NULL, NULL, '2,4-dienoyl-CoA reductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(172967, NULL, 'G3DSA:2.40.10.10:FF:000222', NULL, NULL, 'GH15905p', NULL, NULL, NULL, NULL, NULL, 4),
(172968, NULL, 'G3DSA:3.40.710.10:FF:000075', NULL, NULL, 'Possible penicillin-binding lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(172969, NULL, 'G3DSA:3.30.1490.20:FF:000106', NULL, NULL, 'Succinate-CoA ligase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(172970, NULL, 'G3DSA:3.30.930.10:FF:000138', NULL, NULL, 'Glycyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172971, NULL, 'G3DSA:3.30.450.40:FF:000104', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(172972, NULL, 'G3DSA:3.30.160.60:FF:005686', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172973, NULL, 'G3DSA:2.60.40.1180:FF:000156', NULL, NULL, 'AAR017Wp', NULL, NULL, NULL, NULL, NULL, 4),
(172974, NULL, 'G3DSA:3.90.70.80:FF:000079', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(172975, NULL, 'G3DSA:4.10.372.10:FF:000004', NULL, NULL, 'Linoleate 13S-lipoxygenase 2-1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(172976, NULL, 'G3DSA:3.40.710.10:FF:000119', NULL, NULL, 'Penicillin-binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(172977, NULL, 'G3DSA:1.10.3210.10:FF:000112', NULL, NULL, 'Dihydroneopterin 2'',3''-cyclic phosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(172978, NULL, 'G3DSA:1.10.287.110:FF:000134', NULL, NULL, 'DnaJ protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172979, NULL, 'G3DSA:3.40.980.10:FF:000021', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(172980, NULL, 'G3DSA:2.60.40.10:FF:001875', NULL, NULL, 'Leucine rich repeat neuronal 4', NULL, NULL, NULL, NULL, NULL, 4),
(172981, NULL, 'G3DSA:3.40.1620.10:FF:000005', NULL, NULL, 'Antitoxin RelJ', NULL, NULL, NULL, NULL, NULL, 4),
(172982, NULL, 'G3DSA:3.40.50.300:FF:003787', NULL, NULL, 'ATP-dependent DNA helicase Hel308', NULL, NULL, NULL, NULL, NULL, 4),
(172983, NULL, 'G3DSA:3.40.50.2300:FF:001188', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(172984, NULL, 'G3DSA:2.30.33.40:FF:000003', NULL, NULL, '10 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(172985, NULL, 'G3DSA:1.10.287.1490:FF:000021', NULL, NULL, 'Elastin microfibril interfacer 3', NULL, NULL, NULL, NULL, NULL, 4),
(172986, NULL, 'G3DSA:3.40.50.300:FF:000605', NULL, NULL, 'multidrug resistance-associated protein 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(172987, NULL, 'G3DSA:3.40.50.1000:FF:000415', NULL, NULL, 'HAD superfamily, subfamily IIIB acid phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(172988, NULL, 'G3DSA:1.10.10.10:FF:001597', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(172989, NULL, 'G3DSA:3.40.50.720:FF:001440', NULL, NULL, 'Autophagy-related protein 7, putative', NULL, NULL, NULL, NULL, NULL, 4),
(172990, NULL, 'G3DSA:1.20.5.490:FF:000011', NULL, NULL, 'cGMP-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(172991, NULL, 'G3DSA:3.30.300.20:FF:000083', NULL, NULL, 'GTP-binding protein ERG', NULL, NULL, NULL, NULL, NULL, 4),
(172992, NULL, 'G3DSA:1.20.5.190:FF:000011', NULL, NULL, 'unconventional myosin-Ib isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(172993, NULL, 'G3DSA:3.30.40.10:FF:001048', NULL, NULL, 'Ring finger protein 32', NULL, NULL, NULL, NULL, NULL, 4),
(172994, NULL, 'G3DSA:3.90.640.10:FF:000097', NULL, NULL, 'Molecular chaperone HscC', NULL, NULL, NULL, NULL, NULL, 4),
(172995, NULL, 'G3DSA:3.40.50.720:FF:000597', NULL, NULL, 'Dihydroflavonol 4-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(172996, NULL, 'G3DSA:2.20.28.10:FF:000016', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(172997, NULL, 'G3DSA:3.80.10.10:FF:001432', NULL, NULL, 'Toll-like receptor 11', NULL, NULL, NULL, NULL, NULL, 4),
(172998, NULL, 'G3DSA:3.60.21.10:FF:000233', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(172999, NULL, 'G3DSA:1.20.1250.20:FF:000727', NULL, NULL, 'AGAP001782-PA', NULL, NULL, NULL, NULL, NULL, 4),
(173000, NULL, 'G3DSA:1.25.40.20:FF:000652', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(173001, NULL, 'G3DSA:3.40.140.10:FF:000070', NULL, NULL, 'Cell division protein DedD', NULL, NULL, NULL, NULL, NULL, 4),
(173002, NULL, 'G3DSA:1.20.1270.60:FF:000162', NULL, NULL, 'Rho GTPase-activating protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(173003, NULL, 'G3DSA:1.20.140.10:FF:000127', NULL, NULL, 'Acyl-CoA dehydrogenase short chain', NULL, NULL, NULL, NULL, NULL, 4),
(173004, NULL, 'G3DSA:3.40.1230.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173005, NULL, 'G3DSA:3.30.160.60:FF:001954', NULL, NULL, 'Zinc finger protein 787', NULL, NULL, NULL, NULL, NULL, 4),
(173006, NULL, 'G3DSA:2.130.10.10:FF:004124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173007, NULL, 'G3DSA:2.60.260.20:FF:000103', NULL, NULL, 'DnaJ family chaperone protein, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173008, NULL, 'G3DSA:3.30.160.60:FF:002443', NULL, NULL, 'Zinc finger protein 687', NULL, NULL, NULL, NULL, NULL, 4),
(173009, NULL, 'G3DSA:1.25.40.10:FF:001734', NULL, NULL, 'Os01g0589900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(173010, NULL, 'G3DSA:1.10.630.10:FF:000482', NULL, NULL, 'Cytochrome P450, family 2, subfamily K, polypeptide 8', NULL, NULL, NULL, NULL, NULL, 4),
(173011, NULL, 'G3DSA:1.10.555.10:FF:000177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173012, NULL, 'G3DSA:3.40.190.80:FF:000015', NULL, NULL, 'Inositol polyphosphate 1-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(173013, NULL, 'G3DSA:1.10.3860.10:FF:000026', NULL, NULL, 'SDF family transport protein (Probable substrate glutamate/aspartate)', NULL, NULL, NULL, NULL, NULL, 4),
(173014, NULL, 'G3DSA:3.90.550.50:FF:000040', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(173015, NULL, 'G3DSA:3.30.200.20:FF:001480', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(173016, NULL, 'G3DSA:1.10.238.10:FF:000272', NULL, NULL, 'ubiquitin carboxyl-terminal hydrolase 32', NULL, NULL, NULL, NULL, NULL, 4),
(173017, NULL, 'G3DSA:3.30.70.330:FF:001239', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(173018, NULL, 'G3DSA:3.40.50.1820:FF:001280', NULL, NULL, 'Lipase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173019, NULL, 'G3DSA:1.25.40.20:FF:001737', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173020, NULL, 'G3DSA:2.60.120.920:FF:000163', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(173021, NULL, 'G3DSA:3.30.200.20:FF:002160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(173022, NULL, 'G3DSA:2.30.29.30:FF:001204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173023, NULL, 'G3DSA:1.10.510.10:FF:003968', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173024, NULL, 'G3DSA:3.40.50.1820:FF:001600', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173025, NULL, 'G3DSA:1.10.10.980:FF:000001', NULL, NULL, 'CST complex subunit STN1', NULL, NULL, NULL, NULL, NULL, 4),
(173026, NULL, 'G3DSA:3.30.1330.30:FF:000042', NULL, NULL, 'Ribonuclease P protein subunit p38', NULL, NULL, NULL, NULL, NULL, 4),
(173027, NULL, 'G3DSA:3.40.50.2300:FF:001351', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173028, NULL, 'G3DSA:3.30.9.10:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173029, NULL, 'G3DSA:3.40.50.10140:FF:000009', NULL, NULL, 'X-linked interleukin-1 receptor accessory protein-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(173030, NULL, 'G3DSA:1.20.1560.10:FF:000708', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173031, NULL, 'G3DSA:3.30.470.160:FF:000013', NULL, NULL, 'Uncharacterized inositol polyphosphate kinase C607.04', NULL, NULL, NULL, NULL, NULL, 4),
(173032, NULL, 'G3DSA:1.50.40.10:FF:000361', NULL, NULL, 'Mitochondrial carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173033, NULL, 'G3DSA:3.30.1460.50:FF:000017', NULL, NULL, 'YALI0D23386p', NULL, NULL, NULL, NULL, NULL, 4),
(173034, NULL, 'G3DSA:3.30.160.60:FF:005995', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173035, NULL, 'G3DSA:3.20.20.140:FF:000360', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(173036, NULL, 'G3DSA:3.90.25.10:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173037, NULL, 'G3DSA:3.40.50.300:FF:005939', NULL, NULL, 'Putative ATP-dependent RNA helicase DHX40', NULL, NULL, NULL, NULL, NULL, 4),
(173038, NULL, 'G3DSA:3.90.1750.10:FF:000020', NULL, NULL, 'LOW QUALITY PROTEIN: probable E3 ubiquitin-protein ligase HERC1', NULL, NULL, NULL, NULL, NULL, 4),
(173039, NULL, 'G3DSA:1.10.510.10:FF:003761', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173040, NULL, 'G3DSA:3.40.50.10130:FF:000006', NULL, NULL, 'Fanconi anemia core complex-associated protein 24', NULL, NULL, NULL, NULL, NULL, 4),
(173041, NULL, 'G3DSA:3.30.70.330:FF:002684', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173042, NULL, 'G3DSA:2.60.120.10:FF:000719', NULL, NULL, 'Cyclic GMP-binding protein D', NULL, NULL, NULL, NULL, NULL, 4),
(173043, NULL, 'G3DSA:1.10.10.990:FF:000004', NULL, NULL, 'RecBCD enzyme subunit RecC', NULL, NULL, NULL, NULL, NULL, 4),
(173044, NULL, 'G3DSA:2.60.120.620:FF:000163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173045, NULL, 'G3DSA:3.90.1480.20:FF:000030', NULL, NULL, 'ST6 beta-galactosamide alpha-2,6-sialyltranferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(173046, NULL, 'G3DSA:3.40.50.300:FF:003478', NULL, NULL, 'ATP-dependent RNA helicase YTHDC2', NULL, NULL, NULL, NULL, NULL, 4),
(173047, NULL, 'G3DSA:3.40.50.2300:FF:001660', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173048, NULL, 'G3DSA:3.30.310.10:FF:000035', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(173049, NULL, 'G3DSA:3.40.50.2000:FF:000862', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173050, NULL, 'G3DSA:1.25.40.570:FF:000037', NULL, NULL, 'COP9 signalosome complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(173051, NULL, 'G3DSA:1.10.150.290:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173052, NULL, 'G3DSA:3.30.9.10:FF:000234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173053, NULL, 'G3DSA:3.30.30.10:FF:000002', NULL, NULL, 'Alpha-like toxin BmK-M1', NULL, NULL, NULL, NULL, NULL, 4),
(173054, NULL, 'G3DSA:3.40.920.10:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173055, NULL, 'G3DSA:3.20.20.80:FF:000377', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(173056, NULL, 'G3DSA:3.40.50.300:FF:002713', NULL, NULL, 'Sulfate adenylyltransferase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(173057, NULL, 'G3DSA:2.130.10.130:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173058, NULL, 'G3DSA:3.40.50.1820:FF:000465', NULL, NULL, 'Kynurenine formamidase', NULL, NULL, NULL, NULL, NULL, 4),
(173059, NULL, 'G3DSA:3.30.70.1220:FF:000006', NULL, NULL, 'General transcription factor IIH subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(173060, NULL, 'G3DSA:3.30.70.1230:FF:000009', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(173061, NULL, 'G3DSA:2.130.10.10:FF:004450', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173062, NULL, 'G3DSA:3.40.109.10:FF:000025', NULL, NULL, 'Putative nitroreductase', NULL, NULL, NULL, NULL, NULL, 4),
(173063, NULL, 'G3DSA:3.40.850.10:FF:000394', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(173064, NULL, 'G3DSA:3.40.50.1110:FF:000095', NULL, NULL, 'Lipase', NULL, NULL, NULL, NULL, NULL, 4),
(173065, NULL, 'G3DSA:3.40.1810.10:FF:000031', NULL, NULL, 'MADS-box transcription factor 54', NULL, NULL, NULL, NULL, NULL, 4),
(173066, NULL, 'G3DSA:2.10.25.10:FF:000297', NULL, NULL, 'Nidogen 1', NULL, NULL, NULL, NULL, NULL, 4),
(173067, NULL, 'G3DSA:1.10.560.10:FF:000144', NULL, NULL, '60 kDa heat shock protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(173068, NULL, 'G3DSA:2.60.120.330:FF:000211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173069, NULL, 'G3DSA:3.40.50.1100:FF:000092', NULL, NULL, '1-aminocyclopropane-1-carboxylate deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(173070, NULL, 'G3DSA:3.30.750.44:FF:000003', NULL, NULL, 'S41 family peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(173071, NULL, 'G3DSA:3.30.70.3250:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173072, NULL, 'G3DSA:1.20.120.1960:FF:000003', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(173073, NULL, 'G3DSA:3.10.20.90:FF:000436', NULL, NULL, 'Phosphatidylinositol 4-kinase gamma 4', NULL, NULL, NULL, NULL, NULL, 4),
(173074, NULL, 'G3DSA:3.40.50.2300:FF:001334', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173075, NULL, 'G3DSA:3.40.50.1820:FF:001263', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(173076, NULL, 'G3DSA:1.20.272.10:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173077, NULL, 'G3DSA:3.30.559.30:FF:000005', NULL, NULL, 'Nonribosomal peptide synthase Pes1', NULL, NULL, NULL, NULL, NULL, 4),
(173078, NULL, 'G3DSA:1.20.1250.20:FF:001542', NULL, NULL, 'YALI0D22000p', NULL, NULL, NULL, NULL, NULL, 4),
(173079, NULL, 'G3DSA:1.10.630.10:FF:000509', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173080, NULL, 'G3DSA:3.30.420.80:FF:000002', NULL, NULL, '40S ribosomal protein S14', NULL, NULL, NULL, NULL, NULL, 4),
(173081, NULL, 'G3DSA:2.60.200.20:FF:000111', NULL, NULL, 'Serine/threonine protein kinase Chk2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173082, NULL, 'G3DSA:1.10.3090.10:FF:000006', NULL, NULL, 'tRNA nucleotidyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173083, NULL, 'G3DSA:2.130.10.10:FF:005552', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173084, NULL, 'G3DSA:3.80.10.10:FF:000959', NULL, NULL, 'Osteomodulin', NULL, NULL, NULL, NULL, NULL, 4),
(173085, NULL, 'G3DSA:3.30.750.80:FF:000004', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(173086, NULL, 'G3DSA:1.10.246.220:FF:000001', NULL, NULL, 'Telomere repeat-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(173087, NULL, 'G3DSA:1.20.144.10:FF:000012', NULL, NULL, 'Phospholipid phosphatase-related protein type 4', NULL, NULL, NULL, NULL, NULL, 4),
(173088, NULL, 'G3DSA:3.30.420.510:FF:000007', NULL, NULL, 'Pantothenate kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(173089, NULL, 'G3DSA:1.25.40.1010:FF:000014', NULL, NULL, 'N-terminal acetyltransferase A complex subunit-like protein C418.02', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(173090, NULL, 'G3DSA:3.30.30.30:FF:000008', NULL, NULL, 'heat shock 70 kDa protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(173091, NULL, 'G3DSA:3.30.70.3550:FF:000003', NULL, NULL, 'Leucyl/phenylalanyl-tRNA--protein transferase', NULL, NULL, NULL, NULL, NULL, 4),
(173092, NULL, 'G3DSA:3.30.40.10:FF:000559', NULL, NULL, 'Cellulose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(173093, NULL, 'G3DSA:1.10.510.10:FF:002007', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(173094, NULL, 'G3DSA:3.40.50.300:FF:006221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173095, NULL, 'G3DSA:3.60.130.10:FF:000048', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(173096, NULL, 'G3DSA:1.10.390.10:FF:000018', NULL, NULL, 'transcription initiation factor TFIID subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(173097, NULL, 'G3DSA:2.60.120.10:FF:000192', NULL, NULL, 'Vacuolar protein', NULL, NULL, NULL, NULL, NULL, 4),
(173098, NULL, 'G3DSA:2.60.40.10:FF:000105', NULL, NULL, 'filamin-C isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(173099, NULL, 'G3DSA:2.130.10.10:FF:005198', NULL, NULL, 'Damage-specific DNA binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173100, NULL, 'G3DSA:3.90.470.20:FF:000007', NULL, NULL, 'Phosphopantetheinyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(173101, NULL, 'G3DSA:3.40.50.300:FF:002067', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(173102, NULL, 'G3DSA:1.20.1250.20:FF:002189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173103, NULL, 'G3DSA:1.10.510.10:FF:002350', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173104, NULL, 'G3DSA:1.10.1200.10:FF:000173', NULL, NULL, 'Non-ribosomal peptide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(173105, NULL, 'G3DSA:3.60.40.10:FF:000288', NULL, NULL, 'Protein IcfG', NULL, NULL, NULL, NULL, NULL, 4),
(173106, NULL, 'G3DSA:2.90.10.10:FF:000006', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(173107, NULL, 'G3DSA:2.30.180.10:FF:000101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173108, NULL, 'G3DSA:1.10.472.80:FF:000084', NULL, NULL, 'Mdr1p', NULL, NULL, NULL, NULL, NULL, 4),
(173109, NULL, 'G3DSA:2.60.20.10:FF:000014', NULL, NULL, 'Syncollin', NULL, NULL, NULL, NULL, NULL, 4),
(173110, NULL, 'G3DSA:1.20.140.50:FF:000015', NULL, NULL, 'Enhancer of Glp-One (Glp-1)', NULL, NULL, NULL, NULL, NULL, 4),
(173111, NULL, 'G3DSA:2.60.40.10:FF:002229', NULL, NULL, 'Twitchin', NULL, NULL, NULL, NULL, NULL, 4),
(173112, NULL, 'G3DSA:3.30.160.60:FF:005669', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173113, NULL, 'G3DSA:3.30.460.10:FF:000147', NULL, NULL, '2''-5''-oligoadenylate synthase 3', NULL, NULL, NULL, NULL, NULL, 4),
(173114, NULL, 'G3DSA:1.10.357.60:FF:000001', NULL, NULL, 'Exocyst complex component EXO70', NULL, NULL, NULL, NULL, NULL, 4),
(173115, NULL, 'G3DSA:1.20.5.110:FF:000061', NULL, NULL, 'Synaptosome associated protein 47', NULL, NULL, NULL, NULL, NULL, 4),
(173116, NULL, 'G3DSA:4.10.1060.10:FF:000069', NULL, NULL, 'RAN-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(173117, NULL, 'G3DSA:3.30.750.70:FF:000001', NULL, NULL, 'DeoR/GlpR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(173118, NULL, 'G3DSA:3.90.1410.10:FF:000062', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(173119, NULL, 'G3DSA:3.40.50.300:FF:000914', NULL, NULL, 'ADP-ribosylation factor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(173120, NULL, 'G3DSA:1.10.150.80:FF:000010', NULL, NULL, 'ATP-dependent DNA helicase Q-like 4A', NULL, NULL, NULL, NULL, NULL, 4),
(173121, NULL, 'G3DSA:1.10.220.20:FF:000009', NULL, NULL, 'GTP exchange factor for ARFs 1', NULL, NULL, NULL, NULL, NULL, 4),
(173122, NULL, 'G3DSA:1.10.10.10:FF:001743', NULL, NULL, 'SirR/DtxR family transcription regulator SirR', NULL, NULL, NULL, NULL, NULL, 4),
(173123, NULL, 'G3DSA:1.10.506.10:FF:000002', NULL, NULL, 'Ras GTPase-activating protein nGAP isoform 2', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(173124, NULL, 'G3DSA:3.40.250.10:FF:000056', NULL, NULL, 'TBC domain-containing protein kinase protein', NULL, NULL, NULL, NULL, NULL, 4),
(173125, NULL, 'G3DSA:1.20.58.530:FF:000028', NULL, NULL, 'Heavy chain, Unconventional Myosin', NULL, NULL, NULL, NULL, NULL, 4),
(173126, NULL, 'G3DSA:2.30.40.10:FF:000039', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(173127, NULL, 'G3DSA:1.10.8.10:FF:000096', NULL, NULL, 'UBX domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(173128, NULL, 'G3DSA:2.10.25.10:FF:000752', NULL, NULL, 'Draper, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(173129, NULL, 'G3DSA:1.10.357.70:FF:000004', NULL, NULL, 'Tumor necrosis factor alpha-induced protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(173130, NULL, 'G3DSA:3.40.640.10:FF:000063', NULL, NULL, 'probable low-specificity L-threonine aldolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(173131, NULL, 'G3DSA:3.80.10.10:FF:001106', NULL, NULL, 'Toll-like receptor Tollo', NULL, NULL, NULL, NULL, NULL, 4),
(173132, NULL, 'G3DSA:1.20.58.1070:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173133, NULL, 'G3DSA:1.10.285.10:FF:000004', NULL, NULL, 'Glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(173134, NULL, 'G3DSA:3.40.50.300:FF:008020', NULL, NULL, 'ABC transporter, transmembrane ATP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173135, NULL, 'G3DSA:3.40.50.150:FF:000408', NULL, NULL, 'D12 class N6 adenine-specific DNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(173136, NULL, 'G3DSA:3.40.630.30:FF:000467', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(173137, NULL, 'G3DSA:2.130.10.10:FF:002016', NULL, NULL, 'Protein CBG22378', NULL, NULL, NULL, NULL, NULL, 4),
(173138, NULL, 'G3DSA:2.102.10.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173139, NULL, 'G3DSA:1.10.533.10:FF:000132', NULL, NULL, 'Cell death protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(173140, NULL, 'G3DSA:1.25.40.10:FF:002105', NULL, NULL, 'Pentatricopeptide repeat domain-containing protein 3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(173141, NULL, 'G3DSA:1.20.58.60:FF:000687', NULL, NULL, 'Si:ch211-207i1.2', NULL, NULL, NULL, NULL, NULL, 4),
(173142, NULL, 'G3DSA:1.10.10.1840:FF:000001', NULL, NULL, 'Acanthaporin', NULL, NULL, NULL, NULL, NULL, 4),
(173143, NULL, 'G3DSA:2.60.40.10:FF:002005', NULL, NULL, 'Putative Defective proboscis extension response', NULL, NULL, NULL, NULL, NULL, 4),
(173144, NULL, 'G3DSA:1.10.10.10:FF:001288', NULL, NULL, 'Putative peroxin 14', NULL, NULL, NULL, NULL, NULL, 4),
(173145, NULL, 'G3DSA:1.10.472.80:FF:000230', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173146, NULL, 'G3DSA:3.90.850.10:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173147, NULL, 'G3DSA:3.40.20.10:FF:000018', NULL, NULL, 'Coactosin-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(173148, NULL, 'G3DSA:1.20.140.40:FF:000012', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(173149, NULL, 'G3DSA:1.10.220.10:FF:000006', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(173150, NULL, 'G3DSA:2.130.10.10:FF:003298', NULL, NULL, 'Cleavage and polyadenylation specificity factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173151, NULL, 'G3DSA:3.40.50.12760:FF:000019', NULL, NULL, 'Cap-specific mRNA (nucleoside-2''-O-)-methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(173152, NULL, 'G3DSA:1.50.10.10:FF:000224', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(173153, NULL, 'G3DSA:2.130.10.10:FF:000408', NULL, NULL, 'protein DAMAGED DNA-BINDING 2', NULL, NULL, NULL, NULL, NULL, 4),
(173154, NULL, 'G3DSA:3.30.160.60:FF:002460', NULL, NULL, 'Zgc:174574', NULL, NULL, NULL, NULL, NULL, 4),
(173155, NULL, 'G3DSA:3.40.630.60:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173156, NULL, 'G3DSA:3.40.50.300:FF:004321', NULL, NULL, 'Protein ImuA', NULL, NULL, NULL, NULL, NULL, 4),
(173157, NULL, 'G3DSA:4.10.95.10:FF:000004', NULL, NULL, 'Cytochrome c oxidase subunit VIa', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(173158, NULL, 'G3DSA:2.60.120.560:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173159, NULL, 'G3DSA:2.40.50.140:FF:001253', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173160, NULL, 'G3DSA:1.25.40.10:FF:002240', NULL, NULL, 'U3 small nucleolar RNA-associated protein 6-like', NULL, NULL, NULL, NULL, NULL, 4),
(173161, NULL, 'G3DSA:3.30.420.10:FF:000717', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173162, NULL, 'G3DSA:2.30.30.140:FF:000026', NULL, NULL, 'SAGA-associated factor 29 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(173163, NULL, 'G3DSA:1.25.40.10:FF:001751', NULL, NULL, 'Phosphatidyl inositol 3-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(173164, NULL, 'G3DSA:3.80.10.10:FF:003231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173165, NULL, 'G3DSA:1.20.5.110:FF:000268', NULL, NULL, 'Synaptosomal-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(173166, NULL, 'G3DSA:1.50.10.150:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173167, NULL, 'G3DSA:3.10.20.30:FF:000025', NULL, NULL, 'Succinate dehydrogenase/fumarate reductase iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4),
(173168, NULL, 'G3DSA:1.10.510.10:FF:002333', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173169, NULL, 'G3DSA:1.10.1200.10:FF:000156', NULL, NULL, 'Nonribosomal peptide synthetase easA', NULL, NULL, NULL, NULL, NULL, 4),
(173170, NULL, 'G3DSA:3.40.50.80:FF:000001', NULL, NULL, 'NADPH--cytochrome P450 reductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(173171, NULL, 'G3DSA:3.30.2140.20:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173172, NULL, 'G3DSA:2.60.40.790:FF:000064', NULL, NULL, 'Protein SHQ1', NULL, NULL, NULL, NULL, NULL, 4),
(173173, NULL, 'G3DSA:1.10.565.10:FF:000149', NULL, NULL, 'Nuclear hormone receptor family member nhr-115', NULL, NULL, NULL, NULL, NULL, 4),
(173174, NULL, 'G3DSA:1.10.1420.10:FF:000021', NULL, NULL, 'DNA mismatch repair protein MSH2', NULL, NULL, NULL, NULL, NULL, 4),
(173175, NULL, 'G3DSA:2.130.10.10:FF:001836', NULL, NULL, 'WD-repeat membrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173176, NULL, 'G3DSA:3.20.20.140:FF:000376', NULL, NULL, 'Ribonuclease P subunit p30, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173177, NULL, 'G3DSA:3.40.850.20:FF:000003', NULL, NULL, 'Spindle pole body-associated protein VIK1', NULL, NULL, NULL, NULL, NULL, 4),
(173178, NULL, 'G3DSA:1.20.1280.50:FF:000070', NULL, NULL, 'F-box protein GID2', NULL, NULL, NULL, NULL, NULL, 4),
(173179, NULL, 'G3DSA:1.25.40.540:FF:000011', NULL, NULL, 'Serine/threonine-protein phosphatase 4 regulatory subunit ppfr-4', NULL, NULL, NULL, NULL, NULL, 4),
(173180, NULL, 'G3DSA:3.30.70.1730:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173181, NULL, 'G3DSA:1.25.40.20:FF:001754', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173182, NULL, 'G3DSA:3.40.50.620:FF:000376', NULL, NULL, 'Phosphopantetheine adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(173183, NULL, 'G3DSA:1.10.238.10:FF:000507', NULL, NULL, '45 kDa calcium-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(173184, NULL, 'G3DSA:3.40.30.10:FF:000272', NULL, NULL, 'Calsequestrin', NULL, NULL, NULL, NULL, NULL, 4),
(173185, NULL, 'G3DSA:1.25.10.10:FF:001586', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173186, NULL, 'G3DSA:2.60.120.920:FF:000146', NULL, NULL, 'Butyrophilin subfamily 1 member A1', NULL, NULL, NULL, NULL, NULL, 4),
(173187, NULL, 'G3DSA:2.30.30.490:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173188, NULL, 'G3DSA:3.50.50.60:FF:001265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173189, NULL, 'G3DSA:1.25.40.550:FF:000014', NULL, NULL, 'A1 cistron-splicing factor', NULL, NULL, NULL, NULL, NULL, 4),
(173190, NULL, 'G3DSA:3.30.160.60:FF:003562', NULL, NULL, 'Zinc finger protein 586', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(173191, NULL, 'G3DSA:3.30.390.60:FF:000009', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(173192, NULL, 'G3DSA:1.20.1070.10:FF:000968', NULL, NULL, 'Melanin-concentrating hormone receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(173193, NULL, 'G3DSA:1.10.287.70:FF:000577', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173194, NULL, 'G3DSA:3.90.70.10:FF:000165', NULL, NULL, 'Tubulointerstitial nephritis antigen-like', NULL, NULL, NULL, NULL, NULL, 4),
(173195, NULL, 'G3DSA:1.10.268.10:FF:000009', NULL, NULL, 'Gcn5-related N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(173196, NULL, 'G3DSA:2.60.40.10:FF:003775', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173197, NULL, 'G3DSA:1.10.10.10:FF:001417', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(173198, NULL, 'G3DSA:1.20.58.2220:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173199, NULL, 'G3DSA:3.30.70.100:FF:000136', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173200, NULL, 'G3DSA:1.10.287.850:FF:000002', NULL, NULL, 'PE family immunomodulator PE15', NULL, NULL, NULL, NULL, NULL, 4),
(173201, NULL, 'G3DSA:2.60.40.10:FF:002022', NULL, NULL, 'Sidekick, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(173202, NULL, 'G3DSA:1.25.10.10:FF:002997', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173203, NULL, 'G3DSA:3.30.450.150:FF:000012', NULL, NULL, 'YALI0B05808p', NULL, NULL, NULL, NULL, NULL, 4),
(173204, NULL, 'G3DSA:3.40.50.300:FF:005586', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(173205, NULL, 'G3DSA:3.30.497.10:FF:000012', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(173206, NULL, 'G3DSA:3.40.50.2300:FF:001008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173207, NULL, 'G3DSA:1.10.220.10:FF:000023', NULL, NULL, 'AnNEXin family', NULL, NULL, NULL, NULL, NULL, 4),
(173208, NULL, 'G3DSA:1.20.58.1060:FF:000006', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(173209, NULL, 'G3DSA:1.25.40.10:FF:003651', NULL, NULL, 'RNA polymerase II transcription elongation factor (Ctr9), putative (AFU_orthologue AFUA_5G05870)', NULL, NULL, NULL, NULL, NULL, 4),
(173210, NULL, 'G3DSA:1.10.510.10:FF:000433', NULL, NULL, 'MAP kinase kinase PBS2', NULL, NULL, NULL, NULL, NULL, 4),
(173211, NULL, 'G3DSA:2.60.60.20:FF:000008', NULL, NULL, 'Polycystic kidney disease 1-like 2, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(173212, NULL, 'G3DSA:1.10.3290.10:FF:000004', NULL, NULL, 'Cell filamentation protein Fic', NULL, NULL, NULL, NULL, NULL, 4),
(173213, NULL, 'G3DSA:3.30.160.60:FF:004360', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173214, NULL, 'G3DSA:3.30.60.90:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173215, NULL, 'G3DSA:3.20.20.70:FF:000391', NULL, NULL, 'Shikimate biosynthesis protein AroDE', NULL, NULL, NULL, NULL, NULL, 4),
(173216, NULL, 'G3DSA:2.30.29.30:FF:001160', NULL, NULL, 'Rhotekin 2b', NULL, NULL, NULL, NULL, NULL, 4),
(173217, NULL, 'G3DSA:1.20.1110.10:FF:000231', NULL, NULL, 'Calcium transporting rt-atpase', NULL, NULL, NULL, NULL, NULL, 4),
(173218, NULL, 'G3DSA:2.60.120.10:FF:000736', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(173219, NULL, 'G3DSA:3.90.1480.20:FF:000013', NULL, NULL, 'ST6 N-acetylgalactosaminide alpha-2,6-sialyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(173220, NULL, 'G3DSA:3.30.160.60:FF:003871', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173221, NULL, 'G3DSA:2.130.10.10:FF:006041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173222, NULL, 'G3DSA:1.10.630.10:FF:000818', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(173223, NULL, 'G3DSA:3.30.40.10:FF:000885', NULL, NULL, 'Alkylbase DNA N-glycosylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173224, NULL, 'G3DSA:3.30.930.10:FF:000155', NULL, NULL, 'Biotin:apoprotein ligase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(173225, NULL, 'G3DSA:1.20.1250.20:FF:001233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173226, NULL, 'G3DSA:3.30.160.60:FF:003769', NULL, NULL, 'Zinc finger protein 574', NULL, NULL, NULL, NULL, NULL, 4),
(173227, NULL, 'G3DSA:1.20.1270.220:FF:000003', NULL, NULL, 'Global transcription factor group E8', NULL, NULL, NULL, NULL, NULL, 4),
(173228, NULL, 'G3DSA:3.20.20.80:FF:000394', NULL, NULL, 'Neopullulanase SusA', NULL, NULL, NULL, NULL, NULL, 4),
(173229, NULL, 'G3DSA:3.40.50.2300:FF:001643', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173230, NULL, 'G3DSA:2.130.10.10:FF:004141', NULL, NULL, 'ERCC excision repair 8, CSA ubiquitin ligase complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(173231, NULL, 'G3DSA:3.40.50.200:FF:000031', NULL, NULL, 'Serine protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173232, NULL, 'G3DSA:3.30.160.60:FF:004051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173233, NULL, 'G3DSA:3.90.1420.10:FF:000017', NULL, NULL, 'SET domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(173234, NULL, 'G3DSA:1.10.472.130:FF:000012', NULL, NULL, 'Dynein heavy chain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(173235, NULL, 'G3DSA:3.40.50.1820:FF:000774', NULL, NULL, 'Lysophospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(173236, NULL, 'G3DSA:3.90.730.10:FF:000042', NULL, NULL, 'Ribonuclease T2', NULL, NULL, NULL, NULL, NULL, 4),
(173237, NULL, 'G3DSA:1.10.510.10:FF:000079', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(173238, NULL, 'G3DSA:1.10.20.10:FF:000260', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173239, NULL, 'G3DSA:3.30.450.20:FF:000683', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(173240, NULL, 'G3DSA:3.40.1810.10:FF:000014', NULL, NULL, 'MADS-box transcription factor 41', NULL, NULL, NULL, NULL, NULL, 4),
(173241, NULL, 'G3DSA:3.40.1360.10:FF:000041', NULL, NULL, 'DNA primase DnaG', NULL, NULL, NULL, NULL, NULL, 4),
(173242, NULL, 'G3DSA:2.30.30.140:FF:000335', NULL, NULL, 'Splicing factor spf30', NULL, NULL, NULL, NULL, NULL, 4),
(173243, NULL, 'G3DSA:3.40.980.10:FF:000004', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(173244, NULL, 'G3DSA:3.30.2180.10:FF:000001', NULL, NULL, 'ATP synthase mitochondrial F1 complex assembly factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(173245, NULL, 'G3DSA:2.60.120.650:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173246, NULL, 'G3DSA:2.80.10.50:FF:000209', NULL, NULL, 'Proline-tRNA ligase (DUF1680)', NULL, NULL, NULL, NULL, NULL, 4),
(173247, NULL, 'G3DSA:1.10.287.70:FF:000706', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(173248, NULL, 'G3DSA:2.60.120.10:FF:000427', NULL, NULL, 'CRP/FNR family transcriptional regulator, anaerobic regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(173249, NULL, 'G3DSA:2.60.40.10:FF:000431', NULL, NULL, 'motile sperm domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(173250, NULL, 'G3DSA:3.30.70.330:FF:000885', NULL, NULL, 'GPI mannosyltransferase 3', NULL, NULL, NULL, NULL, NULL, 4),
(173251, NULL, 'G3DSA:3.90.105.20:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173252, NULL, 'G3DSA:3.50.4.10:FF:000021', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(173253, NULL, 'G3DSA:3.60.40.10:FF:000390', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173254, NULL, 'G3DSA:1.25.40.10:FF:001397', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(173255, NULL, 'G3DSA:2.160.20.10:FF:000110', NULL, NULL, 'Pectin lyase-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(173256, NULL, 'G3DSA:3.40.50.150:FF:000072', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase J', NULL, NULL, NULL, NULL, NULL, 4),
(173257, NULL, 'G3DSA:1.10.238.10:FF:000300', NULL, NULL, 'Calpain-C', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(173258, NULL, 'G3DSA:2.60.120.380:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173259, NULL, 'G3DSA:1.25.10.10:FF:001895', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173260, NULL, 'G3DSA:1.10.1520.10:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173261, NULL, 'G3DSA:1.10.510.10:FF:001844', NULL, NULL, 'GD24137', NULL, NULL, NULL, NULL, NULL, 4),
(173262, NULL, 'G3DSA:3.30.505.10:FF:000050', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(173263, NULL, 'G3DSA:1.10.510.10:FF:002024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173264, NULL, 'G3DSA:1.10.1490.10:FF:000002', NULL, NULL, 'DNA fragmentation factor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(173265, NULL, 'G3DSA:3.40.50.10190:FF:000108', NULL, NULL, 'Pescadillo homolog', NULL, NULL, NULL, NULL, NULL, 4),
(173266, NULL, 'G3DSA:2.60.40.1910:FF:000004', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(173267, NULL, 'G3DSA:3.90.550.10:FF:000314', NULL, NULL, 'Glycosyltransferase 8 domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(173268, NULL, 'G3DSA:2.70.130.10:FF:000156', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173269, NULL, 'G3DSA:3.30.830.10:FF:000271', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(173270, NULL, 'G3DSA:2.60.120.290:FF:000238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173271, NULL, 'G3DSA:3.40.50.150:FF:000381', NULL, NULL, 'Fibrillarin-like rRNA/tRNA 2''-O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(173272, NULL, 'G3DSA:1.20.140.100:FF:000004', NULL, NULL, 'Dynein axonemal heavy chain 6', NULL, NULL, NULL, NULL, NULL, 4),
(173273, NULL, 'G3DSA:1.10.530.10:FF:000007', NULL, NULL, 'Endo-type membrane-bound lytic murein transglycosylase A', NULL, NULL, NULL, NULL, NULL, 4),
(173274, NULL, 'G3DSA:3.30.70.330:FF:003038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173275, NULL, 'G3DSA:1.20.58.830:FF:000012', NULL, NULL, 'Erythrocyte binding antigen-140', NULL, NULL, NULL, NULL, NULL, 4),
(173276, NULL, 'G3DSA:1.10.555.10:FF:000194', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173277, NULL, 'G3DSA:1.20.1250.20:FF:000744', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(173278, NULL, 'G3DSA:3.30.70.1070:FF:000017', NULL, NULL, 'Type I secretion outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(173279, NULL, 'G3DSA:1.10.10.790:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173280, NULL, 'G3DSA:3.30.2410.10:FF:000020', NULL, NULL, 'E3 ubiquitin-protein ligase UPL5', NULL, NULL, NULL, NULL, NULL, 4),
(173281, NULL, 'G3DSA:3.30.830.10:FF:000063', NULL, NULL, 'Zinc protease', NULL, NULL, NULL, NULL, NULL, 4),
(173282, NULL, 'G3DSA:1.25.40.10:FF:003325', NULL, NULL, 'TPR repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173283, NULL, 'G3DSA:6.10.140.2220:FF:000037', NULL, NULL, 'Methionine aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(173284, NULL, 'G3DSA:2.60.40.10:FF:003983', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173285, NULL, 'G3DSA:3.20.20.80:FF:000259', NULL, NULL, 'GLB1 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(173286, NULL, 'G3DSA:2.60.40.10:FF:004601', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173287, NULL, 'G3DSA:2.60.120.10:FF:000074', NULL, NULL, 'Potassium channel KAT2', NULL, NULL, NULL, NULL, NULL, 4),
(173288, NULL, 'G3DSA:3.30.160.60:FF:004034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173289, NULL, 'G3DSA:3.30.200.20:FF:001463', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(173290, NULL, 'G3DSA:3.40.50.12160:FF:000036', NULL, NULL, 'Ribosomal protein S12 methylthiotransferase RimO', NULL, NULL, NULL, NULL, NULL, 4),
(173291, NULL, 'G3DSA:2.10.70.10:FF:000047', NULL, NULL, 'CUB and Sushi multiple domains 3', NULL, NULL, NULL, NULL, NULL, 4),
(173292, NULL, 'G3DSA:3.30.70.1620:FF:000019', NULL, NULL, 'Mitotic chromosome and X-chromosome-associated protein mix-1', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(173293, NULL, 'G3DSA:3.30.460.10:FF:000164', NULL, NULL, 'Bifunctional uridylyltransferase/uridylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(173294, NULL, 'G3DSA:3.10.250.10:FF:000107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173295, NULL, 'G3DSA:3.40.50.2300:FF:001216', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173296, NULL, 'G3DSA:1.20.1560.10:FF:000725', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173297, NULL, 'G3DSA:3.40.50.2020:FF:000137', NULL, NULL, 'Ribose-phosphate pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(173298, NULL, 'G3DSA:3.80.10.10:FF:003023', NULL, NULL, 'AGAP011930-PA', NULL, NULL, NULL, NULL, NULL, 4),
(173299, NULL, 'G3DSA:3.30.70.980:FF:000012', NULL, NULL, 'Probable transcriptional regulatory protein WHON_01306', NULL, NULL, NULL, NULL, NULL, 4),
(173300, NULL, 'G3DSA:1.10.555.10:FF:000222', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173301, NULL, 'G3DSA:2.80.10.50:FF:000226', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(173302, NULL, 'G3DSA:3.10.290.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173303, NULL, 'G3DSA:2.90.10.10:FF:000023', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(173304, NULL, 'G3DSA:1.10.510.10:FF:000225', NULL, NULL, 'calcium-dependent protein kinase 28-like', NULL, NULL, NULL, NULL, NULL, 4),
(173305, NULL, 'G3DSA:4.10.410.10:FF:000077', NULL, NULL, 'AGAP012307-PA', NULL, NULL, NULL, NULL, NULL, 4),
(173306, NULL, 'G3DSA:3.60.40.10:FF:000373', NULL, NULL, 'SigmaB regulation protein RsbU, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173307, NULL, 'G3DSA:2.10.25.10:FF:000960', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(173308, NULL, 'G3DSA:3.30.710.10:FF:000392', NULL, NULL, 'Protein CBG04368', NULL, NULL, NULL, NULL, NULL, 4),
(173309, NULL, 'G3DSA:1.10.565.10:FF:000150', NULL, NULL, 'Protein CBG20720', NULL, NULL, NULL, NULL, NULL, 4),
(173310, NULL, 'G3DSA:3.40.30.10:FF:000833', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173311, NULL, 'G3DSA:3.40.50.300:FF:001679', NULL, NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(173312, NULL, 'G3DSA:3.30.1490.20:FF:000078', NULL, NULL, 'Succinate--CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(173313, NULL, 'G3DSA:3.40.630.30:FF:000484', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173314, NULL, 'G3DSA:3.20.20.70:FF:000256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173315, NULL, 'G3DSA:3.70.10.10:FF:000027', NULL, NULL, 'Unplaced genomic scaffold supercont2.10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(173316, NULL, 'G3DSA:3.40.50.620:FF:000100', NULL, NULL, 'probable leucine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(173317, NULL, 'G3DSA:1.10.10.10:FF:001625', NULL, NULL, 'Putative DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(173318, NULL, 'G3DSA:1.10.510.10:FF:001861', NULL, NULL, 'Hormonally up-regulated neu tumor-associated kinase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(173319, NULL, 'G3DSA:3.30.70.2190:FF:000016', NULL, NULL, 'Bll6224 protein', NULL, NULL, NULL, NULL, NULL, 4),
(173320, NULL, 'G3DSA:1.10.8.60:FF:000341', NULL, NULL, 'ATP-dependent Zn protease', NULL, NULL, NULL, NULL, NULL, 4),
(173321, NULL, 'G3DSA:1.10.3730.20:FF:000025', NULL, NULL, 'EamA/RhaT family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(173322, NULL, 'G3DSA:3.90.215.10:FF:000019', NULL, NULL, 'Angiopoietin-like 4', NULL, NULL, NULL, NULL, NULL, 4),
(173323, NULL, 'G3DSA:2.30.30.40:FF:000513', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173324, NULL, 'G3DSA:3.15.10.10:FF:000008', NULL, NULL, 'BPI fold containing family B member 1', NULL, NULL, NULL, NULL, NULL, 4),
(173325, NULL, 'G3DSA:3.30.160.60:FF:000190', NULL, NULL, 'C2H2 finger domain protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(173326, NULL, 'G3DSA:3.40.50.300:FF:008227', NULL, NULL, 'Probable disease resistance protein At5g47260', NULL, NULL, NULL, NULL, NULL, 4),
(173327, NULL, 'G3DSA:1.20.1250.20:FF:000699', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173328, NULL, 'G3DSA:3.30.70.1730:FF:000036', NULL, NULL, 'Ribosomal protein L10', NULL, NULL, NULL, NULL, NULL, 4),
(173329, NULL, 'G3DSA:3.30.9.10:FF:000251', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(173330, NULL, 'G3DSA:4.10.1000.10:FF:000094', NULL, NULL, 'Zinc finger CCCH domain-containing protein 34 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(173331, NULL, 'G3DSA:2.130.10.10:FF:003635', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173332, NULL, 'G3DSA:2.40.10.10:FF:000205', NULL, NULL, 'Lysyl endopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(173333, NULL, 'G3DSA:3.80.10.10:FF:000752', NULL, NULL, 'Tubulin-folding cofactor E', NULL, NULL, NULL, NULL, NULL, 4),
(173334, NULL, 'G3DSA:1.10.560.10:FF:000161', NULL, NULL, 'T-complex protein 1 subunitTheta, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173335, NULL, 'G3DSA:1.10.8.60:FF:000442', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173336, NULL, 'G3DSA:3.60.21.10:FF:000042', NULL, NULL, 'Serine/threonine-protein phosphatase with EF-hands', NULL, NULL, NULL, NULL, NULL, 4),
(173337, NULL, 'G3DSA:3.20.20.105:FF:000016', NULL, NULL, 'Queuine tRNA-ribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(173338, NULL, 'G3DSA:2.40.70.10:FF:000422', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173339, NULL, 'G3DSA:3.40.50.300:FF:006092', NULL, NULL, 'Branched-chain amino acid ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(173340, NULL, 'G3DSA:3.60.21.50:FF:000003', NULL, NULL, 'DNA polymerase II small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(173341, NULL, 'G3DSA:3.40.50.2300:FF:000699', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(173342, NULL, 'G3DSA:3.30.60.30:FF:000206', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(173343, NULL, 'G3DSA:1.10.390.10:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173344, NULL, 'G3DSA:2.60.40.10:FF:006046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173345, NULL, 'G3DSA:2.30.180.10:FF:000073', NULL, NULL, 'Stabilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(173346, NULL, 'G3DSA:3.40.50.2300:FF:001317', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173347, NULL, 'G3DSA:2.40.440.10:FF:000001', NULL, NULL, 'L,D-transpeptidase YbiS', NULL, NULL, NULL, NULL, NULL, 4),
(173348, NULL, 'G3DSA:3.30.70.590:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173349, NULL, 'G3DSA:2.10.60.10:FF:000075', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(173350, NULL, 'G3DSA:3.30.559.10:FF:000258', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(173351, NULL, 'G3DSA:3.30.30.170:FF:000003', NULL, NULL, 'Translation initiation factor 2 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(173352, NULL, 'G3DSA:2.60.40.10:FF:005692', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173353, NULL, 'G3DSA:1.10.287.110:FF:000117', NULL, NULL, 'Putative DnaJ protein', NULL, NULL, NULL, NULL, NULL, 4),
(173354, NULL, 'G3DSA:3.30.160.60:FF:000234', NULL, NULL, 'GLIS family zinc finger 3', NULL, NULL, NULL, NULL, NULL, 4),
(173355, NULL, 'G3DSA:2.60.120.260:FF:000021', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(173356, NULL, 'G3DSA:3.30.450.20:FF:000239', NULL, NULL, 'Sensory box/GGDEF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(173357, NULL, 'G3DSA:1.10.10.60:FF:001281', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173358, NULL, 'G3DSA:3.40.50.1100:FF:000018', NULL, NULL, 'D-serine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(173359, NULL, 'G3DSA:3.30.530.20:FF:000127', NULL, NULL, 'Phosphatidylinositol transfer protein alpha isoform', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(173360, NULL, 'G3DSA:3.30.70.330:FF:001610', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173361, NULL, 'G3DSA:3.30.200.20:FF:001036', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(173362, NULL, 'G3DSA:1.25.40.20:FF:000091', NULL, NULL, 'NF-kappa-B inhibitor delta', NULL, NULL, NULL, NULL, NULL, 4),
(173363, NULL, 'G3DSA:2.130.10.10:FF:002325', NULL, NULL, 'Eukaryotic translation initiation factor 2A', NULL, NULL, NULL, NULL, NULL, 4),
(173364, NULL, 'G3DSA:2.130.10.10:FF:001292', NULL, NULL, 'Periodic tryptophan protein 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(173365, NULL, 'G3DSA:3.30.160.60:FF:001971', NULL, NULL, 'zinc finger and SCAN domain-containing protein 20 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(173366, NULL, 'G3DSA:3.10.250.10:FF:000006', NULL, NULL, 'neurotrypsin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(173367, NULL, 'G3DSA:1.20.5.1930:FF:000008', NULL, NULL, 'Sensor protein UhpB', NULL, NULL, NULL, NULL, NULL, 4),
(173368, NULL, 'G3DSA:3.30.30.30:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173369, NULL, 'G3DSA:1.10.630.10:FF:000291', NULL, NULL, 'Cytochrome P450 monooxygenase asqL', NULL, NULL, NULL, NULL, NULL, 4),
(173370, NULL, 'G3DSA:3.20.20.120:FF:000011', NULL, NULL, 'D-galactonate dehydratase family member VSWAT3_13707', NULL, NULL, NULL, NULL, NULL, 4),
(173371, NULL, 'G3DSA:2.30.29.30:FF:001159', NULL, NULL, 'Protein CBR-UNC-34', NULL, NULL, NULL, NULL, NULL, 4),
(173372, NULL, 'G3DSA:3.40.50.300:FF:003832', NULL, NULL, 'WGS project CABT00000000 data, contig 2.20', NULL, NULL, NULL, NULL, NULL, 4),
(173373, NULL, 'G3DSA:2.170.270.10:FF:000125', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(173374, NULL, 'G3DSA:2.130.10.10:FF:005759', NULL, NULL, 'Glr0823 protein', NULL, NULL, NULL, NULL, NULL, 4),
(173375, NULL, 'G3DSA:1.10.287.950:FF:000032', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(173376, NULL, 'G3DSA:1.10.10.10:FF:000799', NULL, NULL, 'Crossover junction endonuclease MUS81', NULL, NULL, NULL, NULL, NULL, 4),
(173377, NULL, 'G3DSA:3.90.550.10:FF:000522', NULL, NULL, 'UDP-N-acetylglucosamine pyrophosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(173378, NULL, 'G3DSA:3.60.21.60:FF:000006', NULL, NULL, 'DNA polymerase epsilon subunit', NULL, NULL, NULL, NULL, NULL, 4),
(173379, NULL, 'G3DSA:3.50.50.60:FF:000759', NULL, NULL, 'AIFM3 isoform 8', NULL, NULL, NULL, NULL, NULL, 4),
(173380, NULL, 'G3DSA:1.50.40.10:FF:000259', NULL, NULL, 'Solute carrier family 25 member 13', NULL, NULL, NULL, NULL, NULL, 4),
(173381, NULL, 'G3DSA:1.25.10.10:FF:000260', NULL, NULL, 'Coatomer subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(173382, NULL, 'G3DSA:3.10.450.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173383, NULL, 'G3DSA:1.10.510.10:FF:003659', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173384, NULL, 'G3DSA:2.130.10.10:FF:003326', NULL, NULL, 'WD40-repeat-containing domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(173385, NULL, 'G3DSA:1.20.920.10:FF:000119', NULL, NULL, 'SNF2-family ATP dependent chromatin remodeling factor snf21', NULL, NULL, NULL, NULL, NULL, 4),
(173386, NULL, 'G3DSA:3.90.226.10:FF:000033', NULL, NULL, 'Protease 4', NULL, NULL, NULL, NULL, NULL, 4),
(173387, NULL, 'G3DSA:3.40.50.300:FF:002505', NULL, NULL, 'Probable conserved ATP-binding protein ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(173388, NULL, 'G3DSA:1.50.40.10:FF:000153', NULL, NULL, 'Transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173389, NULL, 'G3DSA:3.90.740.10:FF:000014', NULL, NULL, 'valine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(173390, NULL, 'G3DSA:1.20.990.10:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173391, NULL, 'G3DSA:3.40.50.300:FF:001887', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(173392, NULL, 'G3DSA:2.40.30.10:FF:000105', NULL, NULL, 'NADH-cytochrome b5 reductase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(173393, NULL, 'G3DSA:3.80.10.10:FF:002197', NULL, NULL, 'ADP-ribosylation factor-related', NULL, NULL, NULL, NULL, NULL, 4),
(173394, NULL, 'G3DSA:4.10.970.10:FF:000001', NULL, NULL, 'X-ray repair cross-complementing protein 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(173395, NULL, 'G3DSA:1.10.1370.30:FF:000016', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(173396, NULL, 'G3DSA:3.30.420.10:FF:000408', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173397, NULL, 'G3DSA:2.40.40.20:FF:000036', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(173398, NULL, 'G3DSA:3.30.1180.10:FF:000001', NULL, NULL, 'DegV domain-containing protein Mb2440c', NULL, NULL, NULL, NULL, NULL, 4),
(173399, NULL, 'G3DSA:2.60.120.970:FF:000037', NULL, NULL, 'Bone morphogenetic protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(173400, NULL, 'G3DSA:2.60.40.150:FF:000030', NULL, NULL, 'Phospholipase A2', NULL, NULL, NULL, NULL, NULL, 4),
(173401, NULL, 'G3DSA:1.10.150.50:FF:000097', NULL, NULL, 'Chromosome 19 C19orf47 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(173402, NULL, 'G3DSA:3.90.1200.10:FF:000018', NULL, NULL, 'Fructosamine-3-kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173403, NULL, 'G3DSA:1.20.58.60:FF:000816', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173404, NULL, 'G3DSA:2.40.128.150:FF:000003', NULL, NULL, 'Arylamine N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(173405, NULL, 'G3DSA:1.25.10.10:FF:002620', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173406, NULL, 'G3DSA:3.30.160.60:FF:005877', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173407, NULL, 'G3DSA:3.30.2320.80:FF:000005', NULL, NULL, 'Hydrogenase maturation factor HypA', NULL, NULL, NULL, NULL, NULL, 4),
(173408, NULL, 'G3DSA:3.40.630.30:FF:000276', NULL, NULL, 'Acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173409, NULL, 'G3DSA:3.30.1180.20:FF:000004', NULL, NULL, 'Probable dihydroxyacetone kinase', NULL, NULL, NULL, NULL, NULL, 4),
(173410, NULL, 'G3DSA:1.25.40.20:FF:000343', NULL, NULL, 'Prosap, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(173411, NULL, 'G3DSA:1.10.8.60:FF:000133', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(173412, NULL, 'G3DSA:3.30.230.130:FF:000024', NULL, NULL, 'Cullin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(173413, NULL, 'G3DSA:1.10.287.2610:FF:000003', NULL, NULL, 'Dynein heavy chain 9', NULL, NULL, NULL, NULL, NULL, 4),
(173414, NULL, 'G3DSA:1.50.40.10:FF:000052', NULL, NULL, 'Solute carrier family 25 member 16', NULL, NULL, NULL, NULL, NULL, 4),
(173415, NULL, 'G3DSA:3.40.50.300:FF:007873', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173416, NULL, 'G3DSA:3.30.200.20:FF:001800', NULL, NULL, 'Serine/threonine-protein kinase NEK', NULL, NULL, NULL, NULL, NULL, 4),
(173417, NULL, 'G3DSA:1.25.40.10:FF:001942', NULL, NULL, 'Transcription factor BIM2', NULL, NULL, NULL, NULL, NULL, 4),
(173418, NULL, 'G3DSA:2.40.290.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173419, NULL, 'G3DSA:3.40.50.300:FF:001578', NULL, NULL, 'Multidrug resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(173420, NULL, 'G3DSA:2.60.390.10:FF:000003', NULL, NULL, 'Putative secreted beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(173421, NULL, 'G3DSA:2.10.70.10:FF:000148', NULL, NULL, 'Neurogenic locus notch, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173422, NULL, 'G3DSA:1.10.287.110:FF:000016', NULL, NULL, 'DnaJ (Hsp40) homolog, subfamily A, member 2', NULL, NULL, NULL, NULL, NULL, 4),
(173423, NULL, 'G3DSA:1.10.530.10:FF:000081', NULL, NULL, 'Acidic endochitinase WIN6.2C', NULL, NULL, NULL, NULL, NULL, 4),
(173424, NULL, 'G3DSA:2.130.10.10:FF:000201', NULL, NULL, 'WD and tetratricopeptide repeats protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(173425, NULL, 'G3DSA:3.40.1350.10:FF:000012', NULL, NULL, 'Probable tRNA-splicing endonuclease subunit sen-15', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(173426, NULL, 'G3DSA:3.30.1120.10:FF:000025', NULL, NULL, 'Putative arylsulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(173427, NULL, 'G3DSA:3.30.70.330:FF:003055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173428, NULL, 'G3DSA:2.60.40.10:FF:004500', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173429, NULL, 'G3DSA:1.10.10.2670:FF:000008', NULL, NULL, 'Related to ubiquitin-protein ligase e3 component', NULL, NULL, NULL, NULL, NULL, 4),
(173430, NULL, 'G3DSA:1.10.520.10:FF:000035', NULL, NULL, 'L-ascorbate peroxidase, cytosolic', NULL, NULL, NULL, NULL, NULL, 4),
(173431, NULL, 'G3DSA:3.80.10.10:FF:002876', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173432, NULL, 'G3DSA:3.40.50.150:FF:001819', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173433, NULL, 'G3DSA:1.10.10.1100:FF:000015', NULL, NULL, 'Bacterioferritin', NULL, NULL, NULL, NULL, NULL, 4),
(173434, NULL, 'G3DSA:2.60.120.1440:FF:000021', NULL, NULL, 'FpvR', NULL, NULL, NULL, NULL, NULL, 4),
(173435, NULL, 'G3DSA:2.60.120.330:FF:000166', NULL, NULL, 'Sexual differentiation process protein isp7', NULL, NULL, NULL, NULL, NULL, 4),
(173436, NULL, 'G3DSA:3.40.50.10240:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173437, NULL, 'G3DSA:2.40.70.10:FF:000214', NULL, NULL, 'Pepsin-type aspartyl protease', NULL, NULL, NULL, NULL, NULL, 4),
(173438, NULL, 'G3DSA:3.40.50.300:FF:005378', NULL, NULL, 'Guanine nucleotide-binding protein alpha-4 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(173439, NULL, 'G3DSA:2.40.30.290:FF:000001', NULL, NULL, 'Distal tail protein', NULL, NULL, NULL, NULL, NULL, 4),
(173440, NULL, 'G3DSA:1.20.120.850:FF:000028', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(173441, NULL, 'G3DSA:1.20.58.390:FF:000323', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(173442, NULL, 'G3DSA:3.40.1190.20:FF:000227', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173443, NULL, 'G3DSA:1.20.1560.10:FF:000388', NULL, NULL, 'Transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(173444, NULL, 'G3DSA:1.10.510.10:FF:000534', NULL, NULL, 'Serine/threonine-protein kinase PKH2', NULL, NULL, NULL, NULL, NULL, 4),
(173445, NULL, 'G3DSA:3.90.70.10:FF:000182', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 37', NULL, NULL, NULL, NULL, NULL, 4),
(173446, NULL, 'G3DSA:3.90.810.10:FF:000026', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(173447, NULL, 'G3DSA:3.10.20.90:FF:000453', NULL, NULL, 'CBN-UNC-112 protein', NULL, NULL, NULL, NULL, NULL, 4),
(173448, NULL, 'G3DSA:2.40.10.10:FF:000093', NULL, NULL, 'Mannan-binding lectin serine protease 2', NULL, NULL, NULL, NULL, NULL, 4),
(173449, NULL, 'G3DSA:2.10.50.10:FF:000147', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 8', NULL, NULL, NULL, NULL, NULL, 4),
(173450, NULL, 'G3DSA:1.10.1510.30:FF:000005', NULL, NULL, 'tRNA pseudouridine synthase D', NULL, NULL, NULL, NULL, NULL, 4),
(173451, NULL, 'G3DSA:3.10.270.10:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173452, NULL, 'G3DSA:3.40.50.410:FF:000167', NULL, NULL, 'Collagen, type VI, alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(173453, NULL, 'G3DSA:1.25.10.10:FF:003385', NULL, NULL, 'Condensin-2 complex subunit D3', NULL, NULL, NULL, NULL, NULL, 4),
(173454, NULL, 'G3DSA:3.30.70.330:FF:001711', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173455, NULL, 'G3DSA:1.10.287.110:FF:000325', NULL, NULL, 'Chaperone protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173456, NULL, 'G3DSA:2.30.140.10:FF:000008', NULL, NULL, 'spermine synthase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(173457, NULL, 'G3DSA:1.50.10.10:FF:000179', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(173458, NULL, 'G3DSA:1.10.472.10:FF:000006', NULL, NULL, 'Cyclin I', NULL, NULL, NULL, NULL, NULL, 4),
(173459, NULL, 'G3DSA:2.10.25.10:FF:000651', NULL, NULL, 'neurogenic locus notch homolog protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(173460, NULL, 'G3DSA:3.30.420.510:FF:000024', NULL, NULL, 'Fumble family protein', NULL, NULL, NULL, NULL, NULL, 4),
(173461, NULL, 'G3DSA:3.40.50.150:FF:000616', NULL, NULL, 'DUF890 domain protein (AFU_orthologue AFUA_7G05590)', NULL, NULL, NULL, NULL, NULL, 4),
(173462, NULL, 'G3DSA:2.60.120.200:FF:000739', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173463, NULL, 'G3DSA:3.30.457.60:FF:000002', NULL, NULL, 'Mitotic spindle assembly checkpoint protein MAD1', NULL, NULL, NULL, NULL, NULL, 4),
(173464, NULL, 'G3DSA:3.30.40.10:FF:001239', NULL, NULL, 'XIAP associated factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(173465, NULL, 'G3DSA:1.20.1740.10:FF:000245', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(173466, NULL, 'G3DSA:1.20.1250.20:FF:001087', NULL, NULL, 'MFS multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173467, NULL, 'G3DSA:1.10.510.10:FF:000107', NULL, NULL, 'kinase suppressor of Ras 1', NULL, NULL, NULL, NULL, NULL, 4),
(173468, NULL, 'G3DSA:1.10.3080.10:FF:000067', NULL, NULL, 'Putative eukaryotic translation initiation factor 3E subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(173469, NULL, 'G3DSA:3.30.160.60:FF:002252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173470, NULL, 'G3DSA:1.25.40.10:FF:003634', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g39620', NULL, NULL, NULL, NULL, NULL, 4),
(173471, NULL, 'G3DSA:3.40.50.150:FF:000100', NULL, NULL, 'Methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(173472, NULL, 'G3DSA:1.10.20.10:FF:000125', NULL, NULL, 'Transcription initiation factor TFIID subunit 9', NULL, NULL, NULL, NULL, NULL, 4),
(173473, NULL, 'G3DSA:1.20.1070.10:FF:000867', NULL, NULL, 'CholecystoKinin Receptor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(173474, NULL, 'G3DSA:3.30.40.10:FF:000986', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173475, NULL, 'G3DSA:1.10.720.30:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173476, NULL, 'G3DSA:2.60.40.10:FF:000094', NULL, NULL, 'Kirre like nephrin family adhesion molecule 3', NULL, NULL, NULL, NULL, NULL, 4),
(173477, NULL, 'G3DSA:1.20.120.1900:FF:000024', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(173478, NULL, 'G3DSA:1.20.58.2220:FF:000039', NULL, NULL, 'Formin B', NULL, NULL, NULL, NULL, NULL, 4),
(173479, NULL, 'G3DSA:3.40.50.300:FF:005069', NULL, NULL, 'ADP ribosylation factor like GTPase 8B', NULL, NULL, NULL, NULL, NULL, 4),
(173480, NULL, 'G3DSA:2.80.10.50:FF:000120', NULL, NULL, 'Glucan 13-beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(173481, NULL, 'G3DSA:3.40.1110.10:FF:000247', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173482, NULL, 'G3DSA:1.20.120.1910:FF:000027', NULL, NULL, 'AGAP011821-PA', NULL, NULL, NULL, NULL, NULL, 4),
(173483, NULL, 'G3DSA:1.10.150.50:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173484, NULL, 'G3DSA:2.20.25.10:FF:000111', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(173485, NULL, 'G3DSA:3.30.40.10:FF:002358', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173486, NULL, 'G3DSA:3.40.50.1700:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173487, NULL, 'G3DSA:3.40.50.2060:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173488, NULL, 'G3DSA:3.90.76.10:FF:000015', NULL, NULL, 'Peptide ABC transporter, periplasmic peptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(173489, NULL, 'G3DSA:3.40.30.10:FF:000480', NULL, NULL, 'GLutaRedoXin', NULL, NULL, NULL, NULL, NULL, 4),
(173490, NULL, 'G3DSA:1.20.120.140:FF:000012', NULL, NULL, 'Unplaced genomic scaffold supercont1.35, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(173491, NULL, 'G3DSA:1.10.10.10:FF:001934', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173492, NULL, 'G3DSA:3.40.50.1240:FF:000021', NULL, NULL, 'Acid phosphatase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(173493, NULL, 'G3DSA:1.10.3720.10:FF:000212', NULL, NULL, 'Oligopeptide ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(173494, NULL, 'G3DSA:3.30.70.100:FF:000035', NULL, NULL, 'Heavy metal-associated isoprenylated plant protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(173495, NULL, 'G3DSA:1.25.40.20:FF:000309', NULL, NULL, 'No mechanoreceptor potential C, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(173496, NULL, 'G3DSA:2.130.10.10:FF:001499', NULL, NULL, 'WD domain, G-beta repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(173497, NULL, 'G3DSA:1.20.1250.20:FF:000935', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173498, NULL, 'G3DSA:3.40.50.150:FF:001499', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173499, NULL, 'G3DSA:3.20.20.10:FF:000036', NULL, NULL, 'Alanine racemase', NULL, NULL, NULL, NULL, NULL, 4),
(173500, NULL, 'G3DSA:3.30.70.590:FF:000002', NULL, NULL, 'Nuclear poly(A) polymerase 4', NULL, NULL, NULL, NULL, NULL, 4),
(173501, NULL, 'G3DSA:2.40.40.20:FF:000070', NULL, NULL, 'NADH-quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(173502, NULL, 'G3DSA:3.40.50.300:FF:007839', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173503, NULL, 'G3DSA:1.20.1110.10:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173504, NULL, 'G3DSA:1.10.510.10:FF:001198', NULL, NULL, 'NIMA related kinase 11', NULL, NULL, NULL, NULL, NULL, 4),
(173505, NULL, 'G3DSA:1.20.1560.10:FF:000843', NULL, NULL, 'FI20190p1', NULL, NULL, NULL, NULL, NULL, 4),
(173506, NULL, 'G3DSA:2.30.30.140:FF:000234', NULL, NULL, 'Hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(173507, NULL, 'G3DSA:1.25.10.10:FF:002412', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173508, NULL, 'G3DSA:3.30.505.10:FF:000049', NULL, NULL, 'Suppressor of cytokine signaling 2', NULL, NULL, NULL, NULL, NULL, 4),
(173509, NULL, 'G3DSA:1.20.144.10:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173510, NULL, 'G3DSA:3.40.50.740:FF:000035', NULL, NULL, 'Molybdopterin oxidoreductase Fe4S4 region', NULL, NULL, NULL, NULL, NULL, 4),
(173511, NULL, 'G3DSA:1.20.1560.10:FF:000489', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173512, NULL, 'G3DSA:3.30.200.20:FF:001345', NULL, NULL, 'Putative tyrosine-protein kinase Wsck-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(173513, NULL, 'G3DSA:1.20.120.160:FF:000018', NULL, NULL, 'Sensory box sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(173514, NULL, 'G3DSA:1.10.8.710:FF:000012', NULL, NULL, 'Glutathione S-transferase class-mu 26 kDa isozyme', NULL, NULL, NULL, NULL, NULL, 4),
(173515, NULL, 'G3DSA:1.10.630.10:FF:000498', NULL, NULL, 'Sterol 14 desaturase', NULL, NULL, NULL, NULL, NULL, 4),
(173516, NULL, 'G3DSA:3.40.50.1260:FF:000027', NULL, NULL, 'Phosphoglycerate kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(173517, NULL, 'G3DSA:1.25.40.10:FF:000306', NULL, NULL, 'Cell cycle control protein cwf4', NULL, NULL, NULL, NULL, NULL, 4),
(173518, NULL, 'G3DSA:1.20.120.1200:FF:000011', NULL, NULL, 'NADH-quinone oxidoreductase subunit J', NULL, NULL, NULL, NULL, NULL, 4),
(173519, NULL, 'G3DSA:2.130.10.10:FF:001853', NULL, NULL, 'Zinc finger CCCH domain-containing protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(173520, NULL, 'G3DSA:3.30.450.20:FF:000548', NULL, NULL, 'PAS sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(173521, NULL, 'G3DSA:1.10.10.440:FF:000058', NULL, NULL, 'Pre-mRNA-processing protein 40C', NULL, NULL, NULL, NULL, NULL, 4),
(173522, NULL, 'G3DSA:3.30.420.10:FF:000397', NULL, NULL, 'Transposase', NULL, NULL, NULL, NULL, NULL, 4),
(173523, NULL, 'G3DSA:2.60.40.10:FF:000195', NULL, NULL, 'Fibronectin type III domain containing 3A', NULL, NULL, NULL, NULL, NULL, 4),
(173524, NULL, 'G3DSA:3.30.200.20:FF:001816', NULL, NULL, 'Protein NSP-INTERACTING KINASE 1', NULL, NULL, NULL, NULL, NULL, 4),
(173525, NULL, 'G3DSA:3.40.50.410:FF:000285', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(173526, NULL, 'G3DSA:3.30.450.20:FF:000649', NULL, NULL, 'PAS sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(173527, NULL, 'G3DSA:3.40.33.10:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173528, NULL, 'G3DSA:1.20.1250.40:FF:000019', NULL, NULL, 'Related to Rpb4-16 kD subunit of DNA-directed RNA polymerase II', NULL, NULL, NULL, NULL, NULL, 4),
(173529, NULL, 'G3DSA:2.60.40.10:FF:005574', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173530, NULL, 'G3DSA:3.40.1110.10:FF:000348', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173531, NULL, 'G3DSA:3.10.20.90:FF:000245', NULL, NULL, 'Small ubiquitin-related modifier', NULL, NULL, NULL, NULL, NULL, 4),
(173532, NULL, 'G3DSA:3.30.565.10:FF:000311', NULL, NULL, 'Protein CBG23571', NULL, NULL, NULL, NULL, NULL, 4),
(173533, NULL, 'G3DSA:2.170.270.10:FF:000007', NULL, NULL, 'PR domain zinc finger protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(173534, NULL, 'G3DSA:3.40.50.1820:FF:000566', NULL, NULL, 'CHO cell elongating factor', NULL, NULL, NULL, NULL, NULL, 4),
(173535, NULL, 'G3DSA:3.40.50.10330:FF:000066', NULL, NULL, 'NAD kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(173536, NULL, 'G3DSA:3.40.50.10190:FF:000209', NULL, NULL, 'DNA-directed DNA/RNA polymerase mu', NULL, NULL, NULL, NULL, NULL, 4),
(173537, NULL, 'G3DSA:2.30.110.10:FF:000052', NULL, NULL, 'Flavin reductase (DIM6/NTAB) family NADH-FMN oxidoreductase RutF', NULL, NULL, NULL, NULL, NULL, 4),
(173538, NULL, 'G3DSA:1.25.10.10:FF:002311', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173539, NULL, 'G3DSA:1.25.40.1040:FF:000057', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(173540, NULL, 'G3DSA:3.40.50.1010:FF:000082', NULL, NULL, 'Ribonuclease VapC', NULL, NULL, NULL, NULL, NULL, 4),
(173541, NULL, 'G3DSA:2.160.20.70:FF:000004', NULL, NULL, 'Protein XRP2', NULL, NULL, NULL, NULL, NULL, 4),
(173542, NULL, 'G3DSA:1.20.1250.20:FF:000845', NULL, NULL, 'Putative Sugar transporter', NULL, NULL, NULL, NULL, NULL, 4),
(173543, NULL, 'G3DSA:1.25.40.1030:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173544, NULL, 'G3DSA:1.20.120.1220:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173545, NULL, 'G3DSA:3.30.300.160:FF:000022', NULL, NULL, 'PilB/PulE/GspE family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(173546, NULL, 'G3DSA:3.80.10.10:FF:000297', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase PXL1', NULL, NULL, NULL, NULL, NULL, 4),
(173547, NULL, 'G3DSA:3.80.10.10:FF:002758', NULL, NULL, 'Peroxidasin', NULL, NULL, NULL, NULL, NULL, 4),
(173548, NULL, 'G3DSA:3.80.10.10:FF:000858', NULL, NULL, 'Mhp1p', NULL, NULL, NULL, NULL, NULL, 4),
(173549, NULL, 'G3DSA:3.90.550.10:FF:000213', NULL, NULL, 'Blast:Beta-1,4-N-acetylgalactosaminyltransferase bre-4', NULL, NULL, NULL, NULL, NULL, 4),
(173550, NULL, 'G3DSA:3.30.360.10:FF:000100', NULL, NULL, '4-hydroxy-tetrahydrodipicolinate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(173551, NULL, 'G3DSA:2.60.40.10:FF:002140', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(173552, NULL, 'G3DSA:3.40.190.10:FF:000101', NULL, NULL, 'Porphobilinogen deaminase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(173553, NULL, 'G3DSA:3.90.230.10:FF:000032', NULL, NULL, 'Proliferation-associated protein 2G4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173554, NULL, 'G3DSA:3.40.50.2000:FF:001008', NULL, NULL, 'UDP-glucose,sterol transferase', NULL, NULL, NULL, NULL, NULL, 4),
(173555, NULL, 'G3DSA:1.20.58.80:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173556, NULL, 'G3DSA:1.50.40.10:FF:000462', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173557, NULL, 'G3DSA:3.30.70.890:FF:000075', NULL, NULL, 'Galactokinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(173558, NULL, 'G3DSA:3.40.1000.70:FF:000004', NULL, NULL, 'Transmembrane serine/threonine-protein kinase PknJ', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(173559, NULL, 'G3DSA:2.160.20.80:FF:000007', NULL, NULL, 'SPI-2 type III secretion system effector PipB', NULL, NULL, NULL, NULL, NULL, 4),
(173560, NULL, 'G3DSA:3.30.160.60:FF:000543', NULL, NULL, 'Zinc finger protein 384 like', NULL, NULL, NULL, NULL, NULL, 4),
(173561, NULL, 'G3DSA:3.10.20.310:FF:000014', NULL, NULL, 'Outer envelope protein 80, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(173562, NULL, 'G3DSA:3.90.79.10:FF:000140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173563, NULL, 'G3DSA:3.30.70.1620:FF:000003', NULL, NULL, 'Structural maintenance of chromosomes 4', NULL, NULL, NULL, NULL, NULL, 4),
(173564, NULL, 'G3DSA:3.80.10.10:FF:002096', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(173565, NULL, 'G3DSA:3.40.50.11380:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173566, NULL, 'G3DSA:2.40.50.140:FF:001118', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173567, NULL, 'G3DSA:3.40.50.1820:FF:001072', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(173568, NULL, 'G3DSA:3.40.250.10:FF:000191', NULL, NULL, 'MBL fold metallo-hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(173569, NULL, 'G3DSA:2.30.130.40:FF:000011', NULL, NULL, 'Lon protease homolog 2, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(173570, NULL, 'G3DSA:2.130.10.10:FF:003753', NULL, NULL, 'Membrane glycoprotein spo14', NULL, NULL, NULL, NULL, NULL, 4),
(173571, NULL, 'G3DSA:2.30.30.380:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173572, NULL, 'G3DSA:1.20.1250.20:FF:001441', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173573, NULL, 'G3DSA:1.10.472.10:FF:000214', NULL, NULL, 'Cyclin, N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(173574, NULL, 'G3DSA:1.10.510.10:FF:003098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173575, NULL, 'G3DSA:1.25.10.10:FF:001794', NULL, NULL, 'Putative adaptor protein complex large chain subunit BetaA', NULL, NULL, NULL, NULL, NULL, 4),
(173576, NULL, 'G3DSA:2.60.120.10:FF:000383', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(173577, NULL, 'G3DSA:3.40.50.2300:FF:000963', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173578, NULL, 'G3DSA:2.60.40.60:FF:000305', NULL, NULL, 'protocadherin-23 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(173579, NULL, 'G3DSA:3.40.720.10:FF:000356', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173580, NULL, 'G3DSA:3.40.50.150:FF:000173', NULL, NULL, 'methyltransferase-like protein 23 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(173581, NULL, 'G3DSA:1.20.1600.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173582, NULL, 'G3DSA:1.10.8.60:FF:000548', NULL, NULL, 'Transitional endoplasmic reticulum', NULL, NULL, NULL, NULL, NULL, 4),
(173583, NULL, 'G3DSA:2.10.25.10:FF:001123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173584, NULL, 'G3DSA:1.10.540.10:FF:000053', NULL, NULL, 'Probable acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(173585, NULL, 'G3DSA:3.90.180.10:FF:000179', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(173586, NULL, 'G3DSA:3.40.50.1100:FF:000120', NULL, NULL, 'Cysteine synthase, chloroplastic/chromoplastic', NULL, NULL, NULL, NULL, NULL, 4),
(173587, NULL, 'G3DSA:2.30.30.140:FF:000144', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(173588, NULL, 'G3DSA:3.20.20.70:FF:000402', NULL, NULL, 'Putative 12-oxophytodienoate reductase 10', NULL, NULL, NULL, NULL, NULL, 4),
(173589, NULL, 'G3DSA:3.60.40.10:FF:000389', NULL, NULL, '5-azacytidine resistance protein azr1', NULL, NULL, NULL, NULL, NULL, 4),
(173590, NULL, 'G3DSA:2.10.220.10:FF:000042', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(173591, NULL, 'G3DSA:1.10.1200.10:FF:000038', NULL, NULL, 'Phthiocerol synthesis polyketide synthase type I PpsD', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(173592, NULL, 'G3DSA:2.130.10.130:FF:000017', NULL, NULL, 'Glycosylphosphatidylinositol specific phospholipase D1', NULL, NULL, NULL, NULL, NULL, 4),
(173593, NULL, 'G3DSA:2.40.70.10:FF:000113', NULL, NULL, 'Lysosomal aspartic protease', NULL, NULL, NULL, NULL, NULL, 4),
(173594, NULL, 'G3DSA:1.20.1110.10:FF:000130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173595, NULL, 'G3DSA:1.20.1280.50:FF:000114', NULL, NULL, 'F-box protein SKP2A isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(173596, NULL, 'G3DSA:3.40.50.300:FF:006193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173597, NULL, 'G3DSA:3.50.50.60:FF:000877', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(173598, NULL, 'G3DSA:1.25.40.10:FF:003533', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(173599, NULL, 'G3DSA:3.90.190.10:FF:000461', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173600, NULL, 'G3DSA:3.30.160.60:FF:004242', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173601, NULL, 'G3DSA:3.40.50.1240:FF:000111', NULL, NULL, '6-phosphofructo-2-kinase/fructose-2, 6-bisphosphatase 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(173602, NULL, 'G3DSA:3.30.70.330:FF:001256', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(173603, NULL, 'G3DSA:2.60.40.10:FF:000240', NULL, NULL, 'MAM domain containing glycosylphosphatidylinositol anchor 1', NULL, NULL, NULL, NULL, NULL, 4),
(173604, NULL, 'G3DSA:2.60.120.920:FF:000028', NULL, NULL, 'Ryanodine receptor, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(173605, NULL, 'G3DSA:3.30.70.330:FF:003156', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173606, NULL, 'G3DSA:2.80.10.50:FF:000210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173607, NULL, 'G3DSA:3.40.30.10:FF:000390', NULL, NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(173608, NULL, 'G3DSA:2.130.10.120:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173609, NULL, 'G3DSA:2.60.120.1000:FF:000018', NULL, NULL, 'Collagen alpha-1(XXVII) chain A', NULL, NULL, NULL, NULL, NULL, 4),
(173610, NULL, 'G3DSA:2.30.30.40:FF:000305', NULL, NULL, 'Nostrin, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(173611, NULL, 'G3DSA:1.20.120.350:FF:000182', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173612, NULL, 'G3DSA:2.130.10.10:FF:005653', NULL, NULL, 'Leucine zipper transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173613, NULL, 'G3DSA:1.20.1310.10:FF:000212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173614, NULL, 'G3DSA:3.40.50.450:FF:000072', NULL, NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase LOG3', NULL, NULL, NULL, NULL, NULL, 4),
(173615, NULL, 'G3DSA:2.130.10.10:FF:002207', NULL, NULL, 'Protein NEDD1', NULL, NULL, NULL, NULL, NULL, 4),
(173616, NULL, 'G3DSA:1.10.555.10:FF:000076', NULL, NULL, 'Rho GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(173617, NULL, 'G3DSA:2.130.10.10:FF:000100', NULL, NULL, 'Cleavage and polyadenylation specificity factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(173618, NULL, 'G3DSA:1.10.533.10:FF:000031', NULL, NULL, 'Caspase 1, isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(173619, NULL, 'G3DSA:2.30.29.30:FF:000996', NULL, NULL, 'Epidermal growth factor receptor kinase substrate 8', NULL, NULL, NULL, NULL, NULL, 4),
(173620, NULL, 'G3DSA:3.20.20.70:FF:000048', NULL, NULL, 'Delta-aminolevulinic acid dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(173621, NULL, 'G3DSA:3.30.450.60:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173622, NULL, 'G3DSA:1.25.40.10:FF:001279', NULL, NULL, 'Pentatricopeptide repeat-containing protein ELI1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(173623, NULL, 'G3DSA:2.130.10.10:FF:005344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(173624, NULL, 'G3DSA:1.10.472.80:FF:000229', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173625, NULL, 'G3DSA:2.30.29.30:FF:000687', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173626, NULL, 'G3DSA:1.25.40.710:FF:000006', NULL, NULL, 'AGAP004870-PA', NULL, NULL, NULL, NULL, NULL, 4),
(173627, NULL, 'G3DSA:3.20.20.70:FF:000711', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173628, NULL, 'G3DSA:1.25.40.700:FF:000003', NULL, NULL, 'Nuclear pore complex protein Nup133', NULL, NULL, NULL, NULL, NULL, 4),
(173629, NULL, 'G3DSA:3.80.10.10:FF:002860', NULL, NULL, 'Toll-like receptor 20, tandem duplicate 2', NULL, NULL, NULL, NULL, NULL, 4),
(173630, NULL, 'G3DSA:1.10.510.10:FF:001653', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173631, NULL, 'G3DSA:1.10.533.10:FF:000250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173632, NULL, 'G3DSA:3.20.20.60:FF:000045', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(173633, NULL, 'G3DSA:3.30.310.10:FF:000052', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(173634, NULL, 'G3DSA:1.10.287.370:FF:000055', NULL, NULL, 'Prefoldin, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(173635, NULL, 'G3DSA:3.30.60.30:FF:000162', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(173636, NULL, 'G3DSA:1.20.1560.10:FF:000798', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173637, NULL, 'G3DSA:3.40.1170.10:FF:000015', NULL, NULL, 'DNA mismatch repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173638, NULL, 'G3DSA:4.10.400.10:FF:000149', NULL, NULL, 'enteropeptidase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(173639, NULL, 'G3DSA:1.10.8.720:FF:000015', NULL, NULL, 'Dynein heavy chain 5, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(173640, NULL, 'G3DSA:1.20.1250.20:FF:001351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173641, NULL, 'G3DSA:3.30.200.20:FF:001906', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173642, NULL, 'G3DSA:3.40.50.10810:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173643, NULL, 'G3DSA:2.60.40.10:FF:003674', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173644, NULL, 'G3DSA:3.80.10.10:FF:000960', NULL, NULL, 'Tsukushin', NULL, NULL, NULL, NULL, NULL, 4),
(173645, NULL, 'G3DSA:3.40.50.300:FF:001988', NULL, NULL, 'Dicer-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(173646, NULL, 'G3DSA:1.25.40.240:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173647, NULL, 'G3DSA:3.20.20.70:FF:000357', NULL, NULL, 'Ribulose-phosphate 3-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(173648, NULL, 'G3DSA:3.30.70.330:FF:001565', NULL, NULL, 'AT5g60980/MSL3_100', NULL, NULL, NULL, NULL, NULL, 4),
(173649, NULL, 'G3DSA:3.20.20.70:FF:000609', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(173650, NULL, 'G3DSA:2.60.40.150:FF:000136', NULL, NULL, 'Calpain 5', NULL, NULL, NULL, NULL, NULL, 4),
(173651, NULL, 'G3DSA:1.25.10.10:FF:000979', NULL, NULL, 'TAF2 RNA polymerase II, TATA box binding (TBP)-associated factor, 150 kDa (TAF2), mRNA protein', NULL, NULL, NULL, NULL, NULL, 4),
(173652, NULL, 'G3DSA:3.40.50.360:FF:000146', NULL, NULL, 'Protein NrdI', NULL, NULL, NULL, NULL, NULL, 4),
(173653, NULL, 'G3DSA:3.30.40.10:FF:001133', NULL, NULL, 'Autoimmune regulator', NULL, NULL, NULL, NULL, NULL, 4),
(173654, NULL, 'G3DSA:3.30.70.2820:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173655, NULL, 'G3DSA:1.10.510.10:FF:001962', NULL, NULL, 'Serine/threonine-protein kinase cbk1', NULL, NULL, NULL, NULL, NULL, 4),
(173656, NULL, 'G3DSA:1.20.1070.10:FF:001441', NULL, NULL, 'Olfactory receptor H12', NULL, NULL, NULL, NULL, NULL, 4),
(173657, NULL, 'G3DSA:1.10.287.70:FF:000386', NULL, NULL, 'Potassium voltage-gated channel subfamily H member 2', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(173658, NULL, 'G3DSA:1.10.455.10:FF:000012', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(173659, NULL, 'G3DSA:3.40.50.10190:FF:000097', NULL, NULL, 'Kinetoplastid kinetochore protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(173660, NULL, 'G3DSA:3.40.1000.10:FF:000003', NULL, NULL, 'hemojuvelin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(173661, NULL, 'G3DSA:1.25.10.10:FF:001906', NULL, NULL, 'importin subunit beta-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(173662, NULL, 'G3DSA:1.10.287.690:FF:000010', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(173663, NULL, 'G3DSA:2.40.50.140:FF:000033', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(173664, NULL, 'G3DSA:2.40.50.150:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173665, NULL, 'G3DSA:3.40.50.300:FF:003933', NULL, NULL, 'Tyrosine-protein kinase (Capsular polysaccharide biosynthesis)', NULL, NULL, NULL, NULL, NULL, 4),
(173666, NULL, 'G3DSA:1.20.120.350:FF:000092', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(173667, NULL, 'G3DSA:3.10.400.20:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173668, NULL, 'G3DSA:1.10.10.2120:FF:000001', NULL, NULL, 'Mutant tan', NULL, NULL, NULL, NULL, NULL, 4),
(173669, NULL, 'G3DSA:1.20.5.170:FF:000264', NULL, NULL, 'Tropomyosin-1, isoforms 9A/A/B-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(173670, NULL, 'G3DSA:2.20.20.10:FF:000004', NULL, NULL, 'Defensin-like peptide 1', NULL, NULL, NULL, NULL, NULL, 4),
(173671, NULL, 'G3DSA:2.130.10.10:FF:003399', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(173672, NULL, 'G3DSA:3.60.21.10:FF:000250', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(173673, NULL, 'G3DSA:3.40.50.720:FF:000496', NULL, NULL, 'Trk system potassium uptake protein TrkA', NULL, NULL, NULL, NULL, NULL, 4),
(173674, NULL, 'G3DSA:2.130.10.10:FF:000307', NULL, NULL, 'WD repeat domain 3', NULL, NULL, NULL, NULL, NULL, 4),
(173675, NULL, 'G3DSA:3.30.1610.10:FF:000001', NULL, NULL, 'Nuclear pore complex protein Nup98-Nup96', NULL, NULL, NULL, NULL, NULL, 4),
(173676, NULL, 'G3DSA:3.30.420.110:FF:000011', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(173677, NULL, 'G3DSA:3.30.710.10:FF:000498', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173678, NULL, 'G3DSA:3.40.525.10:FF:000020', NULL, NULL, 'Chromosome 15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(173679, NULL, 'G3DSA:3.30.1240.10:FF:000057', NULL, NULL, 'Hydrolase (HAD superfamily)', NULL, NULL, NULL, NULL, NULL, 4),
(173680, NULL, 'G3DSA:1.25.40.250:FF:000014', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit K', NULL, NULL, NULL, NULL, NULL, 4),
(173681, NULL, 'G3DSA:3.30.420.10:FF:000509', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173682, NULL, 'G3DSA:1.20.120.1080:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173683, NULL, 'G3DSA:1.25.40.10:FF:003179', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g46050, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(173684, NULL, 'G3DSA:3.40.140.10:FF:000053', NULL, NULL, 'MPN domain-containing protein CG4751', NULL, NULL, NULL, NULL, NULL, 4),
(173685, NULL, 'G3DSA:2.60.40.60:FF:000193', NULL, NULL, 'Protocadherin 12', NULL, NULL, NULL, NULL, NULL, 4),
(173686, NULL, 'G3DSA:1.10.287.70:FF:000695', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173687, NULL, 'G3DSA:1.20.1070.10:FF:001132', NULL, NULL, 'Melanopsin-B', NULL, NULL, NULL, NULL, NULL, 4),
(173688, NULL, 'G3DSA:1.20.140.10:FF:000144', NULL, NULL, 'Probable acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(173689, NULL, 'G3DSA:2.70.150.10:FF:000202', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(173690, NULL, 'G3DSA:3.40.50.150:FF:001584', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(173691, NULL, 'G3DSA:3.10.105.10:FF:000080', NULL, NULL, 'Peptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(173692, NULL, 'G3DSA:1.20.1610.10:FF:000016', NULL, NULL, 'Glycoside hydrolase family 92 protein', NULL, NULL, NULL, NULL, NULL, 4),
(173693, NULL, 'G3DSA:3.30.9.10:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173694, NULL, 'G3DSA:3.65.10.10:FF:000017', NULL, NULL, 'UDP-N-acetylglucosamine 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(173695, NULL, 'G3DSA:3.40.30.10:FF:000064', NULL, NULL, 'Nucleoredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(173696, NULL, 'G3DSA:3.30.70.330:FF:001464', NULL, NULL, 'Putative RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(173697, NULL, 'G3DSA:3.40.390.30:FF:000004', NULL, NULL, 'Sugar phosphatase YidA', NULL, NULL, NULL, NULL, NULL, 4),
(173698, NULL, 'G3DSA:1.20.120.550:FF:000028', NULL, NULL, 'Microsomal glutathione S-transferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(173699, NULL, 'G3DSA:3.20.20.80:FF:000495', NULL, NULL, 'Putative glucan endo-13-beta-glucosidase BG1', NULL, NULL, NULL, NULL, NULL, 4),
(173700, NULL, 'G3DSA:3.40.1110.10:FF:000129', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(173701, NULL, 'G3DSA:3.90.190.10:FF:000197', NULL, NULL, 'Protein tyrosine phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173702, NULL, 'G3DSA:3.60.20.40:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173703, NULL, 'G3DSA:1.10.8.60:FF:000088', NULL, NULL, 'ORC1-type DNA replication protein', NULL, NULL, NULL, NULL, NULL, 4),
(173704, NULL, 'G3DSA:2.130.10.10:FF:002090', NULL, NULL, 'Probable cleavage and polyadenylation specificity factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(173705, NULL, 'G3DSA:3.30.420.40:FF:000350', NULL, NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(173706, NULL, 'G3DSA:3.40.50.300:FF:007429', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173707, NULL, 'G3DSA:2.70.130.10:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173708, NULL, 'G3DSA:3.20.20.70:FF:000492', NULL, NULL, 'Dihydroorotate dehydrogenase (quinone)', NULL, NULL, NULL, NULL, NULL, 4),
(173709, NULL, 'G3DSA:3.20.80.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173710, NULL, 'G3DSA:3.40.50.1000:FF:000207', NULL, NULL, '2,3-diketo-5-methylthio-1-phosphopentane phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(173711, NULL, 'G3DSA:3.40.50.300:FF:000504', NULL, NULL, 'ABC transporter G family member 11', NULL, NULL, NULL, NULL, NULL, 4),
(173712, NULL, 'G3DSA:3.10.580.10:FF:000216', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(173713, NULL, 'G3DSA:3.10.580.10:FF:000065', NULL, NULL, 'Protein MAM3', NULL, NULL, NULL, NULL, NULL, 4),
(173714, NULL, 'G3DSA:3.30.160.60:FF:003770', NULL, NULL, 'Zinc finger 30C', NULL, NULL, NULL, NULL, NULL, 4),
(173715, NULL, 'G3DSA:3.40.20.10:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173716, NULL, 'G3DSA:1.20.140.150:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173717, NULL, 'G3DSA:2.30.29.30:FF:000895', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173718, NULL, 'G3DSA:1.10.1660.10:FF:000010', NULL, NULL, 'MerR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(173719, NULL, 'G3DSA:2.40.150.20:FF:000010', NULL, NULL, 'Mitochondrial ribosomal protein L14, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173720, NULL, 'G3DSA:3.40.50.410:FF:000077', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(173721, NULL, 'G3DSA:2.60.40.10:FF:002230', NULL, NULL, 'Beta-galactosidase BoGH2A', NULL, NULL, NULL, NULL, NULL, 4),
(173722, NULL, 'G3DSA:1.50.10.20:FF:000098', NULL, NULL, 'Pre-alpha-onocerin synthase LCC', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(173723, NULL, 'G3DSA:1.20.120.350:FF:000210', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173724, NULL, 'G3DSA:1.20.120.530:FF:000022', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(173725, NULL, 'G3DSA:3.50.50.60:FF:001349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173726, NULL, 'G3DSA:2.40.10.10:FF:000014', NULL, NULL, 'Complement factor D', NULL, NULL, NULL, NULL, NULL, 4),
(173727, NULL, 'G3DSA:3.30.160.60:FF:003663', NULL, NULL, 'Longitudinals lacking protein, isoforms J/P/Q/S/Z', NULL, NULL, NULL, NULL, NULL, 4),
(173728, NULL, 'G3DSA:1.25.40.10:FF:001526', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g63130, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(173729, NULL, 'G3DSA:3.80.10.10:FF:002652', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173730, NULL, 'G3DSA:3.20.20.70:FF:000503', NULL, NULL, 'Indole-3-glycerol-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(173731, NULL, 'G3DSA:2.60.40.60:FF:000530', NULL, NULL, 'Dachsous cadherin-related 1a', NULL, NULL, NULL, NULL, NULL, 4),
(173732, NULL, 'G3DSA:1.10.8.60:FF:000565', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173733, NULL, 'G3DSA:3.30.70.1230:FF:000083', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(173734, NULL, 'G3DSA:1.50.10.10:FF:000095', NULL, NULL, 'lanC-like protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(173735, NULL, 'G3DSA:3.30.1490.120:FF:000004', NULL, NULL, 'RNA polymerase I subunit Rpa43', NULL, NULL, NULL, NULL, NULL, 4),
(173736, NULL, 'G3DSA:1.10.506.10:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173737, NULL, 'G3DSA:2.60.120.10:FF:000309', NULL, NULL, 'Cysteine dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(173738, NULL, 'G3DSA:2.10.25.10:FF:001224', NULL, NULL, 'Nimrod C1, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(173739, NULL, 'G3DSA:3.30.420.10:FF:000279', NULL, NULL, 'Three prime repair exonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173740, NULL, 'G3DSA:3.40.50.300:FF:003686', NULL, NULL, 'Stage V sporulation protein K', NULL, NULL, NULL, NULL, NULL, 4),
(173741, NULL, 'G3DSA:3.30.40.10:FF:000969', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(173742, NULL, 'G3DSA:1.20.1070.10:FF:001031', NULL, NULL, 'Olfactory receptor 53', NULL, NULL, NULL, NULL, NULL, 4),
(173743, NULL, 'G3DSA:1.10.510.10:FF:002232', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173744, NULL, 'G3DSA:2.40.50.100:FF:000162', NULL, NULL, 'Putative exosomal 3''-5'' exoribonuclease complex subunit ski4', NULL, NULL, NULL, NULL, NULL, 4),
(173745, NULL, 'G3DSA:2.60.120.330:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173746, NULL, 'G3DSA:3.30.160.60:FF:000088', NULL, NULL, 'Zinc finger and SCAN domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(173747, NULL, 'G3DSA:1.25.40.20:FF:001529', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(173748, NULL, 'G3DSA:3.90.550.10:FF:000067', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(173749, NULL, 'G3DSA:3.40.1170.60:FF:000013', NULL, NULL, 'DNA repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(173750, NULL, 'G3DSA:3.30.1490.110:FF:000001', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(173751, NULL, 'G3DSA:1.10.287.660:FF:000035', NULL, NULL, 'Subunit of the ESCRT-I complex', NULL, NULL, NULL, NULL, NULL, 4),
(173752, NULL, 'G3DSA:3.30.930.10:FF:000363', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173753, NULL, 'G3DSA:3.80.10.10:FF:001550', NULL, NULL, 'Leucine-rich repeat transmembrane protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(173754, NULL, 'G3DSA:3.30.9.10:FF:000009', NULL, NULL, 'Sarcosine dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(173755, NULL, 'G3DSA:3.40.630.30:FF:000361', NULL, NULL, 'GNAT family acetyltransferase YjcF', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(173756, NULL, 'G3DSA:2.60.40.60:FF:000423', NULL, NULL, 'putative protocadherin beta-18', NULL, NULL, NULL, NULL, NULL, 4),
(173757, NULL, 'G3DSA:3.10.310.20:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173758, NULL, 'G3DSA:3.40.50.300:FF:007957', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(173759, NULL, 'G3DSA:3.40.50.720:FF:001215', NULL, NULL, 'Putative short chain dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(173760, NULL, 'G3DSA:3.30.420.40:FF:000501', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(173761, NULL, 'G3DSA:3.20.10.10:FF:000018', NULL, NULL, 'Aminodeoxychorismate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(173762, NULL, 'G3DSA:1.10.238.10:FF:000390', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173763, NULL, 'G3DSA:1.10.8.60:FF:000239', NULL, NULL, 'Meiotic spindle formation protein mei-1', NULL, NULL, NULL, NULL, NULL, 4),
(173764, NULL, 'G3DSA:2.130.10.10:FF:003871', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173765, NULL, 'G3DSA:1.25.40.10:FF:003078', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(173766, NULL, 'G3DSA:3.40.430.10:FF:000036', NULL, NULL, 'Dihydrofolate reductase-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(173767, NULL, 'G3DSA:2.60.40.10:FF:002123', NULL, NULL, 'Titin, tandem duplicate 1', NULL, NULL, NULL, NULL, NULL, 4),
(173768, NULL, 'G3DSA:3.20.20.140:FF:000461', NULL, NULL, 'N-acetyl-glucosamine-6-phosphate deacetylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173769, NULL, 'G3DSA:3.40.50.1000:FF:000314', NULL, NULL, 'Haloacid dehalogenase-like hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(173770, NULL, 'G3DSA:2.60.120.1000:FF:000035', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(173771, NULL, 'G3DSA:3.30.160.60:FF:006411', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173772, NULL, 'G3DSA:3.40.50.300:FF:007755', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173773, NULL, 'G3DSA:3.90.290.10:FF:000024', NULL, NULL, 'Fibrillin-1', NULL, NULL, NULL, NULL, NULL, 4),
(173774, NULL, 'G3DSA:3.40.50.1360:FF:000057', NULL, NULL, 'Glucosamine-6-phosphate isomerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173775, NULL, 'G3DSA:3.30.160.60:FF:002033', NULL, NULL, 'Zinc finger protein 473', NULL, NULL, NULL, NULL, NULL, 4),
(173776, NULL, 'G3DSA:1.10.510.10:FF:003553', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173777, NULL, 'G3DSA:3.40.50.12780:FF:000099', NULL, NULL, 'Fatty-acid-CoA ligase FadD9', NULL, NULL, NULL, NULL, NULL, 4),
(173778, NULL, 'G3DSA:3.40.50.10260:FF:000011', NULL, NULL, 'NAD(P)H-hydrate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(173779, NULL, 'G3DSA:3.10.20.90:FF:000330', NULL, NULL, 'NPL4-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(173780, NULL, 'G3DSA:3.10.110.10:FF:000030', NULL, NULL, 'AKT-interacting protein-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(173781, NULL, 'G3DSA:1.10.510.10:FF:002125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173782, NULL, 'G3DSA:2.10.70.10:FF:000238', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(173783, NULL, 'G3DSA:3.20.20.140:FF:000152', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(173784, NULL, 'G3DSA:2.30.30.140:FF:000251', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(173785, NULL, 'G3DSA:3.20.20.80:FF:000169', NULL, NULL, 'Putative alpha-glucosidase AgdA', NULL, NULL, NULL, NULL, NULL, 4),
(173786, NULL, 'G3DSA:2.130.10.10:FF:002101', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173787, NULL, 'G3DSA:3.40.440.10:FF:000008', NULL, NULL, 'Adenylosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(173788, NULL, 'G3DSA:3.30.160.60:FF:005787', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173789, NULL, 'G3DSA:3.50.40.10:FF:000002', NULL, NULL, 'phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(173790, NULL, 'G3DSA:3.80.10.10:FF:000179', NULL, NULL, 'leucine-rich repeat serine/threonine-protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(173791, NULL, 'G3DSA:3.20.20.70:FF:000166', NULL, NULL, 'Heme chaperone HemW', NULL, NULL, NULL, NULL, NULL, 4),
(173792, NULL, 'G3DSA:3.40.50.2300:FF:001452', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173793, NULL, 'G3DSA:1.10.238.10:FF:000401', NULL, NULL, 'Troponin C 25D', NULL, NULL, NULL, NULL, NULL, 4),
(173794, NULL, 'G3DSA:3.30.160.60:FF:001729', NULL, NULL, 'Zinc finger protein 337', NULL, NULL, NULL, NULL, NULL, 4),
(173795, NULL, 'G3DSA:3.10.100.10:FF:000304', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173796, NULL, 'G3DSA:1.20.58.60:FF:000890', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173797, NULL, 'G3DSA:3.40.30.10:FF:000171', NULL, NULL, 'Glutathione amide-dependent peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(173798, NULL, 'G3DSA:1.20.1060.20:FF:000004', NULL, NULL, 'Structural maintenance of chromosomes flexible hinge domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(173799, NULL, 'G3DSA:2.30.36.90:FF:000002', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(173800, NULL, 'G3DSA:1.25.10.10:FF:003469', NULL, NULL, 'Importin subunit alpha-5', NULL, NULL, NULL, NULL, NULL, 4),
(173801, NULL, 'G3DSA:3.60.40.10:FF:000182', NULL, NULL, 'Protein phosphatase fem-2', NULL, NULL, NULL, NULL, NULL, 4),
(173802, NULL, 'G3DSA:3.30.930.10:FF:000256', NULL, NULL, 'Octanoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(173803, NULL, 'G3DSA:2.40.10.10:FF:000340', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173804, NULL, 'G3DSA:2.130.10.10:FF:001954', NULL, NULL, 'Actin-related protein 2/3 complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(173805, NULL, 'G3DSA:3.10.250.10:FF:000079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173806, NULL, 'G3DSA:1.10.10.440:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173807, NULL, 'G3DSA:3.50.30.30:FF:000086', NULL, NULL, 'YALI0A20416p', NULL, NULL, NULL, NULL, NULL, 4),
(173808, NULL, 'G3DSA:1.20.1560.10:FF:000579', NULL, NULL, 'ABC transporter NFT1', NULL, NULL, NULL, NULL, NULL, 4),
(173809, NULL, 'G3DSA:3.10.450.720:FF:000002', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase F', NULL, NULL, NULL, NULL, NULL, 4),
(173810, NULL, 'G3DSA:3.40.50.1820:FF:000549', NULL, NULL, 'Neuroligin 1', NULL, NULL, NULL, NULL, NULL, 4),
(173811, NULL, 'G3DSA:1.10.510.10:FF:001759', NULL, NULL, 'Os08g0376600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(173812, NULL, 'G3DSA:4.10.410.10:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173813, NULL, 'G3DSA:2.60.40.1080:FF:000020', NULL, NULL, 'Surface layer protein', NULL, NULL, NULL, NULL, NULL, 4),
(173814, NULL, 'G3DSA:2.30.29.30:FF:001305', NULL, NULL, 'GTC2', NULL, NULL, NULL, NULL, NULL, 4),
(173815, NULL, 'G3DSA:1.25.10.10:FF:002160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173816, NULL, 'G3DSA:2.40.50.100:FF:000055', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(173817, NULL, 'G3DSA:3.30.160.60:FF:006304', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173818, NULL, 'G3DSA:1.20.1250.20:FF:000828', NULL, NULL, 'Multidrug MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(173819, NULL, 'G3DSA:1.10.3270.10:FF:000003', NULL, NULL, '3-hydroxy-3-methylglutaryl coenzyme A reductase', NULL, NULL, NULL, NULL, NULL, 4),
(173820, NULL, 'G3DSA:3.30.160.60:FF:005568', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173821, NULL, 'G3DSA:3.30.160.60:FF:002342', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173822, NULL, 'G3DSA:1.25.50.20:FF:000029', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(173823, NULL, 'G3DSA:3.10.120.10:FF:000002', NULL, NULL, 'Cytochrome b5 type B', NULL, NULL, NULL, NULL, NULL, 4),
(173824, NULL, 'G3DSA:3.10.20.80:FF:000001', NULL, NULL, 'Translation initiation factor IF-3', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(173825, NULL, 'G3DSA:1.25.40.10:FF:000222', NULL, NULL, 'SARP family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(173826, NULL, 'G3DSA:3.20.20.70:FF:000812', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173827, NULL, 'G3DSA:3.40.33.10:FF:000087', NULL, NULL, 'GLIPR1-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(173828, NULL, 'G3DSA:1.10.1040.10:FF:000076', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(173829, NULL, 'G3DSA:2.30.29.30:FF:001075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173830, NULL, 'G3DSA:3.30.70.1230:FF:000190', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(173831, NULL, 'G3DSA:1.25.40.20:FF:000225', NULL, NULL, 'caskin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(173832, NULL, 'G3DSA:3.40.1280.30:FF:000006', NULL, NULL, 'tRNA methyltransferase 10B', NULL, NULL, NULL, NULL, NULL, 4),
(173833, NULL, 'G3DSA:3.30.160.60:FF:003972', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173834, NULL, 'G3DSA:3.40.720.10:FF:000165', NULL, NULL, 'Phosphatidylinositol glycan anchor biosynthesis class N', NULL, NULL, NULL, NULL, NULL, 4),
(173835, NULL, 'G3DSA:2.60.40.10:FF:001757', NULL, NULL, 'Fibronectin type III and SPRY domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(173836, NULL, 'G3DSA:2.60.40.10:FF:001976', NULL, NULL, 'Mesocentin', NULL, NULL, NULL, NULL, NULL, 4),
(173837, NULL, 'G3DSA:3.40.50.150:FF:000307', NULL, NULL, 'mRNA-capping enzyme catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(173838, NULL, 'G3DSA:3.30.70.330:FF:001801', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173839, NULL, 'G3DSA:1.10.510.10:FF:001299', NULL, NULL, 'BUB1B, mitotic checkpoint serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(173840, NULL, 'G3DSA:2.140.10.30:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173841, NULL, 'G3DSA:1.10.167.10:FF:000011', NULL, NULL, 'Regulator of G protein signaling 22', NULL, NULL, NULL, NULL, NULL, 4),
(173842, NULL, 'G3DSA:3.20.20.80:FF:000815', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173843, NULL, 'G3DSA:1.10.287.940:FF:000012', NULL, NULL, 'P2X receptor A', NULL, NULL, NULL, NULL, NULL, 4),
(173844, NULL, 'G3DSA:2.60.40.10:FF:002600', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(173845, NULL, 'G3DSA:1.25.10.10:FF:003267', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(173846, NULL, 'G3DSA:2.60.40.10:FF:003539', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173847, NULL, 'G3DSA:1.10.287.950:FF:000015', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(173848, NULL, 'G3DSA:3.30.160.60:FF:000318', NULL, NULL, 'Odd-skipped-related transciption factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(173849, NULL, 'G3DSA:2.60.40.3510:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173850, NULL, 'G3DSA:3.30.160.20:FF:000239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173851, NULL, 'G3DSA:2.60.40.10:FF:004028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173852, NULL, 'G3DSA:2.130.10.10:FF:005760', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(173853, NULL, 'G3DSA:2.30.39.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173854, NULL, 'G3DSA:3.40.1110.10:FF:000438', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173855, NULL, 'G3DSA:1.20.1250.20:FF:000519', NULL, NULL, 'Inorganic phosphate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(173856, NULL, 'G3DSA:3.90.190.10:FF:000562', NULL, NULL, 'Dual specificity protein phosphatase CDC14A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173857, NULL, 'G3DSA:3.80.10.10:FF:002966', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173858, NULL, 'G3DSA:3.30.160.60:FF:002561', NULL, NULL, 'Zinc finger protein 517', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(173859, NULL, 'G3DSA:2.130.10.10:FF:001735', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(173860, NULL, 'G3DSA:3.60.10.10:FF:000354', NULL, NULL, 'Zgc:136374 protein', NULL, NULL, NULL, NULL, NULL, 4),
(173861, NULL, 'G3DSA:2.10.25.10:FF:000858', NULL, NULL, 'Notch receptor protein', NULL, NULL, NULL, NULL, NULL, 4),
(173862, NULL, 'G3DSA:3.10.280.10:FF:000025', NULL, NULL, 'complement component 1 Q subcomponent-binding protein, mitochondrial-like', NULL, NULL, NULL, NULL, NULL, 4),
(173863, NULL, 'G3DSA:3.40.50.2300:FF:001233', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173864, NULL, 'G3DSA:3.40.50.1240:FF:000004', NULL, NULL, 'Phosphohistidine phosphatase SixA', NULL, NULL, NULL, NULL, NULL, 4),
(173865, NULL, 'G3DSA:1.20.1250.20:FF:000289', NULL, NULL, 'Acetyl-coenzyme A transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(173866, NULL, 'G3DSA:2.60.40.10:FF:005782', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173867, NULL, 'G3DSA:2.130.10.10:FF:000324', NULL, NULL, 'WD repeat-containing protein 7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(173868, NULL, 'G3DSA:2.30.29.30:FF:000586', NULL, NULL, 'Dynamin', NULL, NULL, NULL, NULL, NULL, 4),
(173869, NULL, 'G3DSA:3.40.50.300:FF:003916', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173870, NULL, 'G3DSA:2.60.11.10:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173871, NULL, 'G3DSA:2.120.10.30:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173872, NULL, 'G3DSA:2.60.40.60:FF:000221', NULL, NULL, 'Cadherin related family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(173873, NULL, 'G3DSA:3.30.1490.10:FF:000002', NULL, NULL, '40S ribosomal protein S15a', NULL, NULL, NULL, NULL, NULL, 4),
(173874, NULL, 'G3DSA:3.30.860.10:FF:000008', NULL, NULL, '40S ribosomal protein S19, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(173875, NULL, 'G3DSA:1.10.630.10:FF:000734', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173876, NULL, 'G3DSA:3.40.50.1010:FF:000290', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173877, NULL, 'G3DSA:2.70.9.10:FF:000001', NULL, NULL, 'Hexon protein', NULL, NULL, NULL, NULL, NULL, 4),
(173878, NULL, 'G3DSA:2.60.120.430:FF:000016', NULL, NULL, 'Kinesin-like protein KIN-14R', NULL, NULL, NULL, NULL, NULL, 4),
(173879, NULL, 'G3DSA:3.50.80.10:FF:000004', NULL, NULL, 'Threonine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(173880, NULL, 'G3DSA:1.25.10.10:FF:001671', NULL, NULL, 'Importin-5', NULL, NULL, NULL, NULL, NULL, 4),
(173881, NULL, 'G3DSA:2.10.90.10:FF:000133', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(173882, NULL, 'G3DSA:3.30.70.1370:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173883, NULL, 'G3DSA:2.60.40.830:FF:000003', NULL, NULL, 'Cytochrome f', NULL, NULL, NULL, NULL, NULL, 4),
(173884, NULL, 'G3DSA:1.20.5.350:FF:000003', NULL, NULL, 'Troponin T isoform 5', NULL, NULL, NULL, NULL, NULL, 4),
(173885, NULL, 'G3DSA:2.60.40.840:FF:000006', NULL, NULL, 'beta-arrestin-2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(173886, NULL, 'G3DSA:3.40.720.10:FF:000255', NULL, NULL, 'Alkaline-phosphatase-like family protein', NULL, NULL, NULL, NULL, NULL, 4),
(173887, NULL, 'G3DSA:3.40.50.300:FF:008121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173888, NULL, 'G3DSA:3.30.1140.32:FF:000018', NULL, NULL, 'SSU ribosomal protein S3P', NULL, NULL, NULL, NULL, NULL, 4),
(173889, NULL, 'G3DSA:1.50.40.10:FF:000243', NULL, NULL, 'Mitochondrial carrier', NULL, NULL, NULL, NULL, NULL, 4),
(173890, NULL, 'G3DSA:3.30.70.330:FF:001790', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173891, NULL, 'G3DSA:1.25.40.20:FF:000534', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(173892, NULL, 'G3DSA:1.20.1420.10:FF:000007', NULL, NULL, 'Talin 2', NULL, NULL, NULL, NULL, NULL, 4),
(173893, NULL, 'G3DSA:3.30.70.240:FF:000021', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(173894, NULL, 'G3DSA:1.10.510.10:FF:001389', NULL, NULL, 'Endonuclease III homolog', NULL, NULL, NULL, NULL, NULL, 4),
(173895, NULL, 'G3DSA:1.10.533.10:FF:000233', NULL, NULL, 'Ssl-1', NULL, NULL, NULL, NULL, NULL, 4),
(173896, NULL, 'G3DSA:1.25.70.10:FF:000033', NULL, NULL, 'F19K23.4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(173897, NULL, 'G3DSA:2.60.40.10:FF:005473', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173898, NULL, 'G3DSA:3.30.420.40:FF:000041', NULL, NULL, 'Acetate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(173899, NULL, 'G3DSA:1.25.40.10:FF:000531', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(173900, NULL, 'G3DSA:1.20.1440.200:FF:000003', NULL, NULL, 'Vacuolar protein sorting-associated protein 28', NULL, NULL, NULL, NULL, NULL, 4),
(173901, NULL, 'G3DSA:2.60.40.10:FF:003865', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173902, NULL, 'G3DSA:2.40.50.100:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173903, NULL, 'G3DSA:1.10.238.10:FF:000081', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 32', NULL, NULL, NULL, NULL, NULL, 4),
(173904, NULL, 'G3DSA:1.25.40.10:FF:001835', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(173905, NULL, 'G3DSA:1.10.10.10:FF:000107', NULL, NULL, 'Stage 0 sporulation protein A', NULL, NULL, NULL, NULL, NULL, 4),
(173906, NULL, 'G3DSA:2.60.40.60:FF:000114', NULL, NULL, 'FAT atypical cadherin 4', NULL, NULL, NULL, NULL, NULL, 4),
(173907, NULL, 'G3DSA:3.40.50.300:FF:001915', NULL, NULL, 'ADP-ribosylation factor 6-like', NULL, NULL, NULL, NULL, NULL, 4),
(173908, NULL, 'G3DSA:3.40.140.10:FF:000154', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 14', NULL, NULL, NULL, NULL, NULL, 4),
(173909, NULL, 'G3DSA:1.25.40.20:FF:001838', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173910, NULL, 'G3DSA:2.130.10.10:FF:003652', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173911, NULL, 'G3DSA:3.30.2350.20:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173912, NULL, 'G3DSA:3.40.50.300:FF:000813', NULL, NULL, 'helicase POLQ-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(173913, NULL, 'G3DSA:3.40.50.300:FF:007974', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173914, NULL, 'G3DSA:3.90.550.10:FF:000062', NULL, NULL, 'beta-1,4-galactosyltransferase 7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(173915, NULL, 'G3DSA:1.10.8.270:FF:000060', NULL, NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', NULL, NULL, NULL, NULL, NULL, 4),
(173916, NULL, 'G3DSA:2.60.40.150:FF:000120', NULL, NULL, 'extended synaptotagmin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(173917, NULL, 'G3DSA:2.40.10.10:FF:000430', NULL, NULL, 'Aquarius', NULL, NULL, NULL, NULL, NULL, 4),
(173918, NULL, 'G3DSA:1.20.930.40:FF:000016', NULL, NULL, 'Putative zinc metalloprotease', NULL, NULL, NULL, NULL, NULL, 4),
(173919, NULL, 'G3DSA:3.40.50.300:FF:001797', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(173920, NULL, 'G3DSA:3.30.160.60:FF:003298', NULL, NULL, 'Zinc finger protein 667', NULL, NULL, NULL, NULL, NULL, 4),
(173921, NULL, 'G3DSA:2.10.25.10:FF:000842', NULL, NULL, 'Transmembrane protein with EGF-like and two follistatin-like domains 2b', NULL, NULL, NULL, NULL, NULL, 4),
(173922, NULL, 'G3DSA:3.80.10.10:FF:000488', NULL, NULL, 'MDIS1-interacting receptor like kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(173923, NULL, 'G3DSA:1.20.120.1110:FF:000001', NULL, NULL, 'RUNX1 translocation partner 1', NULL, NULL, NULL, NULL, NULL, 4),
(173924, NULL, 'G3DSA:2.30.30.40:FF:000204', NULL, NULL, 'Amidase', NULL, NULL, NULL, NULL, NULL, 4),
(173925, NULL, 'G3DSA:3.40.50.10190:FF:000198', NULL, NULL, 'Protein CBR-MUS-101', NULL, NULL, NULL, NULL, NULL, 4),
(173926, NULL, 'G3DSA:3.90.70.10:FF:000390', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173927, NULL, 'G3DSA:2.60.110.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(173928, NULL, 'G3DSA:2.60.40.1360:FF:000002', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(173929, NULL, 'G3DSA:3.90.550.10:FF:000404', NULL, NULL, 'Mannose-1-phosphate guanyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(173930, NULL, 'G3DSA:3.90.1100.10:FF:000061', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(173931, NULL, 'G3DSA:3.40.50.720:FF:000849', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(173932, NULL, 'G3DSA:3.40.50.300:FF:006120', NULL, NULL, 'Rab GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(173933, NULL, 'G3DSA:1.10.10.10:FF:002013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173934, NULL, 'G3DSA:2.130.10.10:FF:001398', NULL, NULL, 'Putative peptidyl-prolyl cis-trans isomerase and WD40 repeat domain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(173935, NULL, 'G3DSA:1.20.5.110:FF:000145', NULL, NULL, 'synaptobrevin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(173936, NULL, 'G3DSA:3.10.620.30:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173937, NULL, 'G3DSA:1.10.3720.10:FF:000111', NULL, NULL, 'Peptide ABC transporter permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(173938, NULL, 'G3DSA:3.40.50.300:FF:007738', NULL, NULL, 'GTP-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(173939, NULL, 'G3DSA:1.25.40.20:FF:000444', NULL, NULL, 'Protein cfxQ like', NULL, NULL, NULL, NULL, NULL, 4),
(173940, NULL, 'G3DSA:1.10.510.10:FF:003867', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173941, NULL, 'G3DSA:3.20.20.80:FF:000478', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173942, NULL, 'G3DSA:4.10.860.20:FF:000001', NULL, NULL, 'PKHD-type hydroxylase YbiX', NULL, NULL, NULL, NULL, NULL, 4),
(173943, NULL, 'G3DSA:3.20.20.70:FF:000817', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173944, NULL, 'G3DSA:3.40.50.2000:FF:000946', NULL, NULL, 'Os06g0271000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(173945, NULL, 'G3DSA:3.30.1140.60:FF:000007', NULL, NULL, 'F-actin-capping protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(173946, NULL, 'G3DSA:3.30.930.10:FF:000239', NULL, NULL, 'Prolyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(173947, NULL, 'G3DSA:3.30.70.330:FF:001155', NULL, NULL, 'Zinc finger c-x8-c-x5-c-x3-h type (And similar) domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(173948, NULL, 'G3DSA:1.10.10.10:FF:001833', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(173949, NULL, 'G3DSA:2.60.40.640:FF:000053', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(173950, NULL, 'G3DSA:1.10.150.50:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173951, NULL, 'G3DSA:1.25.10.10:FF:000703', NULL, NULL, 'Pumilio RNA-binding family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(173952, NULL, 'G3DSA:3.40.30.10:FF:000047', NULL, NULL, 'Calsequestrin', NULL, NULL, NULL, NULL, NULL, 4),
(173953, NULL, 'G3DSA:3.30.200.20:FF:001446', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(173954, NULL, 'G3DSA:3.40.120.10:FF:000052', NULL, NULL, 'Putative phosphomannomutase', NULL, NULL, NULL, NULL, NULL, 4),
(173955, NULL, 'G3DSA:3.40.50.12160:FF:000019', NULL, NULL, 'MiaB family tRNA modifying enzyme, archaeal-type protein', NULL, NULL, NULL, NULL, NULL, 4),
(173956, NULL, 'G3DSA:3.30.420.40:FF:000131', NULL, NULL, 'Actin, alpha skeletal muscle', NULL, NULL, NULL, NULL, NULL, 4),
(173957, NULL, 'G3DSA:2.70.130.10:FF:000072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173958, NULL, 'G3DSA:1.10.132.60:FF:000041', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(173959, NULL, 'G3DSA:2.30.180.10:FF:000191', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173960, NULL, 'G3DSA:1.25.40.10:FF:000205', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(173961, NULL, 'G3DSA:2.30.29.30:FF:000923', NULL, NULL, 'CDC42 binding protein kinase beta', NULL, NULL, NULL, NULL, NULL, 4),
(173962, NULL, 'G3DSA:2.40.70.10:FF:000006', NULL, NULL, 'Cathepsin E', NULL, NULL, NULL, NULL, NULL, 4),
(173963, NULL, 'G3DSA:1.20.58.390:FF:000059', NULL, NULL, 'Nicotinic acetylcholine receptor alpha6, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(173964, NULL, 'G3DSA:1.10.630.10:FF:000397', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173965, NULL, 'G3DSA:3.20.20.70:FF:000475', NULL, NULL, 'Putative 2-isopropylmalate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(173966, NULL, 'G3DSA:1.20.1730.10:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173967, NULL, 'G3DSA:3.80.10.10:FF:003129', NULL, NULL, 'All-trans retinoic acid-induced differentiation factor', NULL, NULL, NULL, NULL, NULL, 4),
(173968, NULL, 'G3DSA:3.30.70.330:FF:002768', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173969, NULL, 'G3DSA:1.50.10.10:FF:000078', NULL, NULL, 'Protein-glucosylgalactosylhydroxylysine glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(173970, NULL, 'G3DSA:3.30.420.270:FF:000036', NULL, NULL, 'ExbD/TolR family protein', NULL, NULL, NULL, NULL, NULL, 4),
(173971, NULL, 'G3DSA:1.25.40.20:FF:000208', NULL, NULL, 'Ankyrin repeat domain-containing protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(173972, NULL, 'G3DSA:1.10.510.10:FF:000343', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 28', NULL, NULL, NULL, NULL, NULL, 4),
(173973, NULL, 'G3DSA:1.10.510.10:FF:000208', NULL, NULL, 'serine/threonine-protein kinase BLUS1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(173974, NULL, 'G3DSA:3.30.200.20:FF:000142', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 10', NULL, NULL, NULL, NULL, NULL, 4),
(173975, NULL, 'G3DSA:3.40.50.300:FF:007648', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(173976, NULL, 'G3DSA:3.90.640.10:FF:000288', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(173977, NULL, 'G3DSA:3.30.70.100:FF:000119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173978, NULL, 'G3DSA:3.80.10.10:FF:001241', NULL, NULL, 'F-box/leucine rich repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(173979, NULL, 'G3DSA:4.10.800.20:FF:000008', NULL, NULL, 'Putative AMP deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(173980, NULL, 'G3DSA:1.20.1440.200:FF:000008', NULL, NULL, 'Vacuolar protein sorting-associated protein 28', NULL, NULL, NULL, NULL, NULL, 4),
(173981, NULL, 'G3DSA:3.30.1360.120:FF:000048', NULL, NULL, 'Glycine cleavage system T protein', NULL, NULL, NULL, NULL, NULL, 4),
(173982, NULL, 'G3DSA:1.20.1310.10:FF:000111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(173983, NULL, 'G3DSA:2.60.40.10:FF:000341', NULL, NULL, 'inactive tyrosine-protein kinase 7', NULL, NULL, NULL, NULL, NULL, 4),
(173984, NULL, 'G3DSA:3.40.30.10:FF:000850', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(173985, NULL, 'G3DSA:2.60.40.1180:FF:000072', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(173986, NULL, 'G3DSA:1.10.10.10:FF:001491', NULL, NULL, 'Probable IclR family regulator (Putative secreted protein)', NULL, NULL, NULL, NULL, NULL, 4),
(173987, NULL, 'G3DSA:3.40.50.300:FF:004175', NULL, NULL, 'DNA mismatch repair protein MSH3', NULL, NULL, NULL, NULL, NULL, 4),
(173988, NULL, 'G3DSA:1.10.510.10:FF:000450', NULL, NULL, 'Tyrosine-protein kinase STYK1', NULL, NULL, NULL, NULL, NULL, 4),
(173989, NULL, 'G3DSA:1.20.1070.10:FF:001340', NULL, NULL, 'Protein PIEZO homolog', NULL, NULL, NULL, NULL, NULL, 4),
(173990, NULL, 'G3DSA:3.40.50.360:FF:000045', NULL, NULL, 'NADPH-dependent diflavin oxidoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(173991, NULL, 'G3DSA:2.60.200.20:FF:000010', NULL, NULL, 'aprataxin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(173992, NULL, 'G3DSA:3.30.160.60:FF:000116', NULL, NULL, 'Zinc finger protein 107', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(173993, NULL, 'G3DSA:2.60.200.30:FF:000013', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(173994, NULL, 'G3DSA:1.10.287.70:FF:000487', NULL, NULL, 'Twk-1', NULL, NULL, NULL, NULL, NULL, 4),
(173995, NULL, 'G3DSA:4.10.860.120:FF:000021', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(173996, NULL, 'G3DSA:2.60.120.330:FF:000065', NULL, NULL, 'Similar to oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(173997, NULL, 'G3DSA:4.10.240.10:FF:000159', NULL, NULL, 'Zcf3p', NULL, NULL, NULL, NULL, NULL, 4),
(173998, NULL, 'G3DSA:3.30.160.60:FF:003646', NULL, NULL, 'Similar to transcription factor Zn, C2H2', NULL, NULL, NULL, NULL, NULL, 4),
(173999, NULL, 'G3DSA:1.25.40.10:FF:001509', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(174000, NULL, 'G3DSA:3.30.70.330:FF:001374', NULL, NULL, 'RNA-binding protein 45', NULL, NULL, NULL, NULL, NULL, 4),
(174001, NULL, 'G3DSA:2.60.40.640:FF:000070', NULL, NULL, 'beta-arrestin-2 isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(174002, NULL, 'G3DSA:1.20.850.10:FF:000001', NULL, NULL, 'Hydrazine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(174003, NULL, 'G3DSA:1.10.287.1040:FF:000015', NULL, NULL, 'Exodeoxyribonuclease 7 small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(174004, NULL, 'G3DSA:2.60.40.60:FF:000204', NULL, NULL, 'Neural-cadherin', NULL, NULL, NULL, NULL, NULL, 4),
(174005, NULL, 'G3DSA:3.10.50.40:FF:000081', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(174006, NULL, 'G3DSA:1.10.238.10:FF:000171', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(174007, NULL, 'G3DSA:1.10.150.50:FF:000226', NULL, NULL, 'Eph receptor A4,-like', NULL, NULL, NULL, NULL, NULL, 4),
(174008, NULL, 'G3DSA:3.40.30.10:FF:000608', NULL, NULL, 'Glutathione S-Transferase', NULL, NULL, NULL, NULL, NULL, 4),
(174009, NULL, 'G3DSA:3.30.300.10:FF:000006', NULL, NULL, 'S-adenosylmethionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(174010, NULL, 'G3DSA:3.40.50.10090:FF:000067', NULL, NULL, 'Uroporphyrinogen III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(174011, NULL, 'G3DSA:2.40.50.640:FF:000003', NULL, NULL, 'Exoribonuclease 2', NULL, NULL, NULL, NULL, NULL, 4),
(174012, NULL, 'G3DSA:3.90.190.10:FF:000567', NULL, NULL, 'Tyrosine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(174013, NULL, 'G3DSA:2.60.40.60:FF:000440', NULL, NULL, 'Dachsous, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(174014, NULL, 'G3DSA:3.80.10.10:FF:001331', NULL, NULL, 'Promastigote surface antigen protein PSA', NULL, NULL, NULL, NULL, NULL, 4),
(174015, NULL, 'G3DSA:2.10.25.10:FF:000735', NULL, NULL, 'adhesion G protein-coupled receptor L4', NULL, NULL, NULL, NULL, NULL, 4),
(174016, NULL, 'G3DSA:2.60.120.260:FF:000398', NULL, NULL, 'Endo-1,4-beta-xylanase A', NULL, NULL, NULL, NULL, NULL, 4),
(174017, NULL, 'G3DSA:3.40.50.300:FF:003377', NULL, NULL, 'Rad25/xp-B DNA repair helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(174018, NULL, 'G3DSA:3.40.50.10190:FF:000288', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(174019, NULL, 'G3DSA:3.30.565.10:FF:000160', NULL, NULL, 'Mismatch repair endonuclease PMS2', NULL, NULL, NULL, NULL, NULL, 4),
(174020, NULL, 'G3DSA:3.40.630.30:FF:000692', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174021, NULL, 'G3DSA:1.20.1070.10:FF:001250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174022, NULL, 'G3DSA:3.40.710.10:FF:000193', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(174023, NULL, 'G3DSA:3.30.300.20:FF:000009', NULL, NULL, 'Ribosome-binding factor A', NULL, NULL, NULL, NULL, NULL, 4),
(174024, NULL, 'G3DSA:1.20.1370.30:FF:000003', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(174025, NULL, 'G3DSA:3.10.20.90:FF:000661', NULL, NULL, 'Protein SDE2-like', NULL, NULL, NULL, NULL, NULL, 4),
(174026, NULL, 'G3DSA:2.10.90.10:FF:000150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(174027, NULL, 'G3DSA:3.30.160.60:FF:000425', NULL, NULL, 'PLAG1 like zinc finger 1', NULL, NULL, NULL, NULL, NULL, 4),
(174028, NULL, 'G3DSA:1.10.510.10:FF:000124', NULL, NULL, 'cyclin-dependent kinase 11B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(174029, NULL, 'G3DSA:3.90.1170.20:FF:000012', NULL, NULL, 'ModD protein', NULL, NULL, NULL, NULL, NULL, 4),
(174030, NULL, 'G3DSA:1.20.120.350:FF:000103', NULL, NULL, 'Voltage-gated Ion Channel (VIC) Superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(174031, NULL, 'G3DSA:3.90.1170.30:FF:000015', NULL, NULL, 'Thymidine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(174032, NULL, 'G3DSA:4.10.400.10:FF:000150', NULL, NULL, 'Glucosidase 2 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(174033, NULL, 'G3DSA:1.20.58.870:FF:000001', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(174034, NULL, 'G3DSA:3.90.1440.10:FF:000002', NULL, NULL, 'Protein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(174035, NULL, 'G3DSA:3.30.70.330:FF:002785', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174036, NULL, 'G3DSA:3.30.710.10:FF:000509', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174037, NULL, 'G3DSA:1.20.1070.10:FF:001901', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174038, NULL, 'G3DSA:3.80.10.10:FF:002961', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174039, NULL, 'G3DSA:1.10.8.60:FF:000234', NULL, NULL, 'Replication factor C small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(174040, NULL, 'G3DSA:2.40.128.20:FF:000048', NULL, NULL, 'Vomeronasal secretory protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(174041, NULL, 'G3DSA:3.40.50.1100:FF:000209', NULL, NULL, 'Threonine synthase like 2', NULL, NULL, NULL, NULL, NULL, 4),
(174042, NULL, 'G3DSA:3.30.200.20:FF:001137', NULL, NULL, 'CMGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(174043, NULL, 'G3DSA:3.30.160.60:FF:000083', NULL, NULL, 'Immunodeficiency virus type I enhancer binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(174044, NULL, 'G3DSA:1.20.120.350:FF:000064', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(174045, NULL, 'G3DSA:3.40.605.10:FF:000077', NULL, NULL, 'Probable aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(174046, NULL, 'G3DSA:3.50.50.60:FF:000040', NULL, NULL, 'Methylenetetrahydrofolate--tRNA-(uracil-5-)-methyltransferase TrmFO', NULL, NULL, NULL, NULL, NULL, 4),
(174047, NULL, 'G3DSA:1.25.40.10:FF:003297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174048, NULL, 'G3DSA:3.30.530.20:FF:000021', NULL, NULL, 'Abscisic acid receptor PYL5', NULL, NULL, NULL, NULL, NULL, 4),
(174049, NULL, 'G3DSA:3.30.800.10:FF:000011', NULL, NULL, 'Phosphatidylinositol 4-phosphate 5-kinase-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(174050, NULL, 'G3DSA:1.25.10.10:FF:003486', NULL, NULL, 'Sister chromatid cohesion protein', NULL, NULL, NULL, NULL, NULL, 4),
(174051, NULL, 'G3DSA:2.40.50.140:FF:001236', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174052, NULL, 'G3DSA:3.30.1330.30:FF:000148', NULL, NULL, 'Peptide chain release factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(174053, NULL, 'G3DSA:3.30.420.10:FF:000588', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174054, NULL, 'G3DSA:1.10.560.10:FF:000054', NULL, NULL, 'Chaperonin 1 60 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(174055, NULL, 'G3DSA:1.10.287.40:FF:000017', NULL, NULL, 'GM23510', NULL, NULL, NULL, NULL, NULL, 4),
(174056, NULL, 'G3DSA:3.30.565.10:FF:000502', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174057, NULL, 'G3DSA:3.40.50.150:FF:000510', NULL, NULL, 'Probable methyltransferase PMT15', NULL, NULL, NULL, NULL, NULL, 4),
(174058, NULL, 'G3DSA:3.20.200.10:FF:000006', NULL, NULL, 'Elongation factor 2 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(174059, NULL, 'G3DSA:3.40.50.12710:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(174060, NULL, 'G3DSA:3.30.390.110:FF:000002', NULL, NULL, '60S ribosomal protein L28', NULL, NULL, NULL, NULL, NULL, 4),
(174061, NULL, 'G3DSA:3.30.460.10:FF:000057', NULL, NULL, 'CCA-adding enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(174062, NULL, 'G3DSA:3.30.160.60:FF:004141', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174063, NULL, 'G3DSA:2.40.10.10:FF:000121', NULL, NULL, 'Peptidase S46 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(174064, NULL, 'G3DSA:3.40.1190.10:FF:000022', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(174065, NULL, 'G3DSA:3.30.40.10:FF:001503', NULL, NULL, 'E3 ubiquitin-protein ligase RNF170', NULL, NULL, NULL, NULL, NULL, 4),
(174066, NULL, 'G3DSA:3.30.70.260:FF:000162', NULL, NULL, 'Homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(174067, NULL, 'G3DSA:1.25.40.10:FF:002330', NULL, NULL, 'Transcription factor BIM2', NULL, NULL, NULL, NULL, NULL, 4),
(174068, NULL, 'G3DSA:3.50.30.30:FF:000081', NULL, NULL, 'Probable M28 family peptidase (Homolog to aminopeptidase YwaD)', NULL, NULL, NULL, NULL, NULL, 4),
(174069, NULL, 'G3DSA:3.40.50.300:FF:000830', NULL, NULL, 'Endonuclease MutS2', NULL, NULL, NULL, NULL, NULL, 4),
(174070, NULL, 'G3DSA:2.40.50.100:FF:000072', NULL, NULL, 'Biotin carboxylase subunit of acetyl CoA carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(174071, NULL, 'G3DSA:2.40.170.20:FF:000112', NULL, NULL, 'SusC homolog', NULL, NULL, NULL, NULL, NULL, 4),
(174072, NULL, 'G3DSA:3.40.50.300:FF:000027', NULL, NULL, '26S protease regulatory subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(174073, NULL, 'G3DSA:1.25.40.20:FF:000118', NULL, NULL, 'Myotrophin', NULL, NULL, NULL, NULL, NULL, 4),
(174074, NULL, 'G3DSA:2.130.10.30:FF:000095', NULL, NULL, 'RCC1 Chromatin-associated guanine nucleotide exchange factor for Ran (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(174075, NULL, 'G3DSA:1.10.1040.10:FF:000059', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(174076, NULL, 'G3DSA:3.40.140.100:FF:000015', NULL, NULL, 'Autophagy protein', NULL, NULL, NULL, NULL, NULL, 4),
(174077, NULL, 'G3DSA:3.90.640.10:FF:000198', NULL, NULL, 'Actin, gamma', NULL, NULL, NULL, NULL, NULL, 4),
(174078, NULL, 'G3DSA:2.30.29.30:FF:001058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174079, NULL, 'G3DSA:2.60.40.10:FF:003904', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174080, NULL, 'G3DSA:1.10.510.10:FF:003558', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174081, NULL, 'G3DSA:1.20.930.40:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174082, NULL, 'G3DSA:3.40.50.1100:FF:000119', NULL, NULL, 'Cystathionine Beta-Synthase', NULL, NULL, NULL, NULL, NULL, 4),
(174083, NULL, 'G3DSA:3.80.10.10:FF:001022', NULL, NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g53420', NULL, NULL, NULL, NULL, NULL, 4),
(174084, NULL, 'G3DSA:2.60.40.10:FF:001959', NULL, NULL, 'Cilia and flagella associated protein 74', NULL, NULL, NULL, NULL, NULL, 4),
(174085, NULL, 'G3DSA:3.90.550.10:FF:000623', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174086, NULL, 'G3DSA:1.25.40.20:FF:000427', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(174087, NULL, 'G3DSA:3.80.10.10:FF:000398', NULL, NULL, 'Slit guidance ligand 2', NULL, NULL, NULL, NULL, NULL, 4),
(174088, NULL, 'G3DSA:3.30.160.60:FF:000335', NULL, NULL, 'PR domain zinc finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(174089, NULL, 'G3DSA:1.20.1270.60:FF:000268', NULL, NULL, 'Zgc:158689', NULL, NULL, NULL, NULL, NULL, 4),
(174090, NULL, 'G3DSA:2.30.30.180:FF:000015', NULL, NULL, 'Ribosome maturation factor RimP', NULL, NULL, NULL, NULL, NULL, 4),
(174091, NULL, 'G3DSA:3.30.160.60:FF:000644', NULL, NULL, 'Zinc finger protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(174092, NULL, 'G3DSA:1.10.287.70:FF:000268', NULL, NULL, 'TWiK family of potassium channels', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(174093, NULL, 'G3DSA:1.10.150.40:FF:000004', NULL, NULL, 'Barrier-to-autointegration factor', NULL, NULL, NULL, NULL, NULL, 4),
(174094, NULL, 'G3DSA:3.30.70.890:FF:000002', NULL, NULL, 'Homoserine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(174095, NULL, 'G3DSA:2.130.10.10:FF:003961', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174096, NULL, 'G3DSA:1.25.40.10:FF:005242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174097, NULL, 'G3DSA:3.30.479.20:FF:000069', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(174098, NULL, 'G3DSA:3.30.70.330:FF:001683', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174099, NULL, 'G3DSA:2.30.30.190:FF:000018', NULL, NULL, 'BIK1p Microtubule-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(174100, NULL, 'G3DSA:4.10.400.10:FF:000060', NULL, NULL, 'Sortilin related receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(174101, NULL, 'G3DSA:1.25.40.10:FF:000115', NULL, NULL, 'Gamma-soluble NSF attachment protein', NULL, NULL, NULL, NULL, NULL, 4),
(174102, NULL, 'G3DSA:3.30.160.60:FF:005771', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174103, NULL, 'G3DSA:2.60.40.10:FF:003556', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174104, NULL, 'G3DSA:3.40.470.10:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174105, NULL, 'G3DSA:3.30.40.10:FF:001812', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174106, NULL, 'G3DSA:3.30.50.10:FF:000110', NULL, NULL, 'Putative GATA transcription factor 22', NULL, NULL, NULL, NULL, NULL, 4),
(174107, NULL, 'G3DSA:1.10.1140.10:FF:000010', NULL, NULL, 'ATP synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(174108, NULL, 'G3DSA:3.10.600.10:FF:000005', NULL, NULL, 'Pyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(174109, NULL, 'G3DSA:2.60.40.10:FF:000122', NULL, NULL, 'filamin-C isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(174110, NULL, 'G3DSA:2.10.25.10:FF:001005', NULL, NULL, 'Laminin subunit gamma-1', NULL, NULL, NULL, NULL, NULL, 4),
(174111, NULL, 'G3DSA:3.30.160.60:FF:001864', NULL, NULL, 'zinc finger protein 883-like', NULL, NULL, NULL, NULL, NULL, 4),
(174112, NULL, 'G3DSA:3.90.190.10:FF:000545', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174113, NULL, 'G3DSA:1.20.58.70:FF:000004', NULL, NULL, 'Syntaxin-22 like', NULL, NULL, NULL, NULL, NULL, 4),
(174114, NULL, 'G3DSA:3.20.20.190:FF:000026', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(174115, NULL, 'G3DSA:3.80.10.10:FF:000853', NULL, NULL, 'GL13952', NULL, NULL, NULL, NULL, NULL, 4),
(174116, NULL, 'G3DSA:2.170.210.10:FF:000015', NULL, NULL, 'Non-homologous end-joining factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(174117, NULL, 'G3DSA:2.30.130.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174118, NULL, 'G3DSA:1.20.140.10:FF:000037', NULL, NULL, 'Similar to acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(174119, NULL, 'G3DSA:1.10.287.110:FF:000218', NULL, NULL, 'Heat shock protein cognate 20', NULL, NULL, NULL, NULL, NULL, 4),
(174120, NULL, 'G3DSA:1.20.1050.80:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174121, NULL, 'G3DSA:3.20.20.70:FF:000834', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174122, NULL, 'G3DSA:1.50.40.10:FF:000467', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174123, NULL, 'G3DSA:3.40.33.10:FF:000177', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174124, NULL, 'G3DSA:1.20.120.1760:FF:000038', NULL, NULL, 'Aminoalcoholphosphotransferase putative', NULL, NULL, NULL, NULL, NULL, 4),
(174125, NULL, 'G3DSA:3.40.50.300:FF:002831', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174126, NULL, 'G3DSA:2.40.50.140:FF:001034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174127, NULL, 'G3DSA:2.30.110.10:FF:000035', NULL, NULL, 'Flavin reductase ActVB', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(174128, NULL, 'G3DSA:3.30.160.60:FF:003994', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174129, NULL, 'G3DSA:1.25.40.20:FF:000079', NULL, NULL, 'Protein phosphatase 1 regulatory subunit 16B', NULL, NULL, NULL, NULL, NULL, 4),
(174130, NULL, 'G3DSA:3.40.50.300:FF:002303', NULL, NULL, 'Rab_A02 protein', NULL, NULL, NULL, NULL, NULL, 4),
(174131, NULL, 'G3DSA:1.10.510.10:FF:004031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174132, NULL, 'G3DSA:1.10.3210.10:FF:000022', NULL, NULL, 'Ribonuclease Y', NULL, NULL, NULL, NULL, NULL, 4),
(174133, NULL, 'G3DSA:1.20.58.80:FF:000007', NULL, NULL, 'Suppressor of K+ transport growth defect 1', NULL, NULL, NULL, NULL, NULL, 4),
(174134, NULL, 'G3DSA:3.40.50.360:FF:000129', NULL, NULL, 'NAD(P)H dehydrogenase, quinone family', NULL, NULL, NULL, NULL, NULL, 4),
(174135, NULL, 'G3DSA:3.30.60.20:FF:000052', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(174136, NULL, 'G3DSA:3.40.50.11350:FF:000035', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174137, NULL, 'G3DSA:3.80.10.10:FF:002983', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174138, NULL, 'G3DSA:1.10.10.10:FF:000523', NULL, NULL, 'Rrf2 family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(174139, NULL, 'G3DSA:3.40.50.300:FF:000162', NULL, NULL, 'septin-7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(174140, NULL, 'G3DSA:3.20.20.80:FF:000837', NULL, NULL, 'Chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(174141, NULL, 'G3DSA:3.80.10.10:FF:003601', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174142, NULL, 'G3DSA:3.40.250.10:FF:000073', NULL, NULL, 'YCH1p Phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(174143, NULL, 'G3DSA:3.40.30.10:FF:000406', NULL, NULL, 'ThioredoXin Domain Containing protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(174144, NULL, 'G3DSA:3.40.50.150:FF:000190', NULL, NULL, 'Spermidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(174145, NULL, 'G3DSA:1.10.10.10:FF:001518', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174146, NULL, 'G3DSA:3.30.420.10:FF:000734', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174147, NULL, 'G3DSA:2.130.10.10:FF:000302', NULL, NULL, 'protein NEDD1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(174148, NULL, 'G3DSA:2.120.10.80:FF:000025', NULL, NULL, 'Kelch-like family member 41', NULL, NULL, NULL, NULL, NULL, 4),
(174149, NULL, 'G3DSA:3.40.50.300:FF:005956', NULL, NULL, 'DNA mismatch repair protein msh-3', NULL, NULL, NULL, NULL, NULL, 4),
(174150, NULL, 'G3DSA:2.60.40.10:FF:005703', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174151, NULL, 'G3DSA:1.10.150.240:FF:000022', NULL, NULL, 'Phosphonoacetaldehyde hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(174152, NULL, 'G3DSA:1.10.510.10:FF:001760', NULL, NULL, 'Serine/threonine-protein kinase RIO3', NULL, NULL, NULL, NULL, NULL, 4),
(174153, NULL, 'G3DSA:1.25.10.10:FF:000052', NULL, NULL, 'Cytoskeleton associated protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(174154, NULL, 'G3DSA:2.60.40.10:FF:000324', NULL, NULL, 'Down syndrome cell adhesion molecule, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(174155, NULL, 'G3DSA:1.10.287.110:FF:000224', NULL, NULL, 'TPR-repeat-containing chaperone protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(174156, NULL, 'G3DSA:3.40.525.10:FF:000003', NULL, NULL, 'kalirin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(174157, NULL, 'G3DSA:3.40.50.300:FF:007087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174158, NULL, 'G3DSA:3.30.420.40:FF:001098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174159, NULL, 'G3DSA:3.50.30.30:FF:000064', NULL, NULL, 'Peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(174160, NULL, 'G3DSA:1.25.40.10:FF:002223', NULL, NULL, 'CCR4-NOT transcription complex subunit 10', NULL, NULL, NULL, NULL, NULL, 4),
(174161, NULL, 'G3DSA:3.40.50.300:FF:005485', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(174162, NULL, 'G3DSA:1.10.510.10:FF:004502', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174163, NULL, 'G3DSA:3.30.1390.20:FF:000031', NULL, NULL, '60S ribosomal protein L7-2', NULL, NULL, NULL, NULL, NULL, 4),
(174164, NULL, 'G3DSA:2.40.30.10:FF:000212', NULL, NULL, 'Elongation factor 1-alpha', NULL, NULL, NULL, NULL, NULL, 4),
(174165, NULL, 'G3DSA:1.20.58.390:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174166, NULL, 'G3DSA:3.40.50.300:FF:000049', NULL, NULL, 'Dynein, axonemal, heavy chain 5', NULL, NULL, NULL, NULL, NULL, 4),
(174167, NULL, 'G3DSA:3.80.10.10:FF:003130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174168, NULL, 'G3DSA:1.20.5.110:FF:000167', NULL, NULL, 'Putative syntaxin-3', NULL, NULL, NULL, NULL, NULL, 4),
(174169, NULL, 'G3DSA:2.10.25.10:FF:000426', NULL, NULL, 'Vitamin K-dependent protein S', NULL, NULL, NULL, NULL, NULL, 4),
(174170, NULL, 'G3DSA:1.20.120.1900:FF:000007', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(174171, NULL, 'G3DSA:2.60.120.560:FF:000004', NULL, NULL, 'Invertase 2', NULL, NULL, NULL, NULL, NULL, 4),
(174172, NULL, 'G3DSA:3.40.1190.10:FF:000016', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(174173, NULL, 'G3DSA:2.60.40.10:FF:001960', NULL, NULL, 'Unc-5 netrin receptor D', NULL, NULL, NULL, NULL, NULL, 4),
(174174, NULL, 'G3DSA:3.40.1190.20:FF:000019', NULL, NULL, 'Ribokinase', NULL, NULL, NULL, NULL, NULL, 4),
(174175, NULL, 'G3DSA:1.25.40.10:FF:001616', NULL, NULL, 'CCR4-NOT transcription complex subunit 10 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(174176, NULL, 'G3DSA:1.20.1250.20:FF:001323', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174177, NULL, 'G3DSA:2.60.120.550:FF:000001', NULL, NULL, 'Penton protein', NULL, NULL, NULL, NULL, NULL, 4),
(174178, NULL, 'G3DSA:3.40.50.620:FF:000685', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174179, NULL, 'G3DSA:3.40.50.10190:FF:000327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174180, NULL, 'G3DSA:3.30.830.10:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174181, NULL, 'G3DSA:3.30.460.10:FF:000063', NULL, NULL, 'GTP pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(174182, NULL, 'G3DSA:3.40.1360.10:FF:000029', NULL, NULL, 'Topoisomerase-like enzyme1', NULL, NULL, NULL, NULL, NULL, 4),
(174183, NULL, 'G3DSA:1.20.1560.10:FF:000618', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(174184, NULL, 'G3DSA:1.10.10.60:FF:000280', NULL, NULL, 'jerky protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(174185, NULL, 'G3DSA:3.40.50.1820:FF:001044', NULL, NULL, 'Abhydrolase domain-containing 8a', NULL, NULL, NULL, NULL, NULL, 4),
(174186, NULL, 'G3DSA:3.50.50.60:FF:000984', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(174187, NULL, 'G3DSA:2.20.25.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174188, NULL, 'G3DSA:3.30.1330.30:FF:000058', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(174189, NULL, 'G3DSA:2.60.40.1230:FF:000014', NULL, NULL, 'AP-2 complex subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(174190, NULL, 'G3DSA:2.60.120.200:FF:000638', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174191, NULL, 'G3DSA:1.10.20.10:FF:000024', NULL, NULL, 'Histone H3', NULL, NULL, NULL, NULL, NULL, 4),
(174192, NULL, 'G3DSA:3.50.30.30:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174193, NULL, 'G3DSA:3.40.50.150:FF:000201', NULL, NULL, 'tRNA wybutosine-synthesizing protein 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(174194, NULL, 'G3DSA:3.30.710.10:FF:000493', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174195, NULL, 'G3DSA:1.20.1280.50:FF:000221', NULL, NULL, 'Putative F-box protein At3g47020', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(174196, NULL, 'G3DSA:2.30.29.30:FF:000816', NULL, NULL, 'Rho GTPase activating protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(174197, NULL, 'G3DSA:1.20.920.10:FF:000193', NULL, NULL, 'Chromatin structure-remodeling complex subunit rsc1', NULL, NULL, NULL, NULL, NULL, 4),
(174198, NULL, 'G3DSA:1.10.533.10:FF:000014', NULL, NULL, 'Apoptotic protease-activating factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(174199, NULL, 'G3DSA:3.30.40.10:FF:001138', NULL, NULL, 'Ankyrin_repeats_(Many_copies)/Ankyrin_repeats_(3_ copies)/Zinc_finger_-_C3HC4_type_(RING_finger )_containing_protein_-_putativ', NULL, NULL, NULL, NULL, NULL, 4),
(174200, NULL, 'G3DSA:3.30.420.10:FF:000482', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174201, NULL, 'G3DSA:2.130.10.10:FF:000291', NULL, NULL, 'Cilia-and flagella-associated protein 52 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(174202, NULL, 'G3DSA:3.40.50.720:FF:001350', NULL, NULL, 'Cation transport protein, Trk system', NULL, NULL, NULL, NULL, NULL, 4),
(174203, NULL, 'G3DSA:1.20.1150.12:FF:000005', NULL, NULL, 'Protein disulfide-isomerase like 2-1', NULL, NULL, NULL, NULL, NULL, 4),
(174204, NULL, 'G3DSA:3.40.50.2300:FF:000013', NULL, NULL, 'Glutamate receptor, metabotropic 4', NULL, NULL, NULL, NULL, NULL, 4),
(174205, NULL, 'G3DSA:1.20.140.150:FF:000013', NULL, NULL, 'lens fiber membrane intrinsic protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(174206, NULL, 'G3DSA:1.20.1250.20:FF:000963', NULL, NULL, 'Siderophore iron transporter mirC', NULL, NULL, NULL, NULL, NULL, 4),
(174207, NULL, 'G3DSA:2.30.40.10:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174208, NULL, 'G3DSA:3.30.750.44:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174209, NULL, 'G3DSA:2.130.10.10:FF:005670', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(174210, NULL, 'G3DSA:1.10.8.50:FF:000012', NULL, NULL, 'DNA lyase', NULL, NULL, NULL, NULL, NULL, 4),
(174211, NULL, 'G3DSA:3.30.1380.20:FF:000002', NULL, NULL, 'Trafficking protein particle complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(174212, NULL, 'G3DSA:3.40.50.300:FF:006103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174213, NULL, 'G3DSA:3.30.200.20:FF:000035', NULL, NULL, 'Serine/threonine protein kinase Stk1', NULL, NULL, NULL, NULL, NULL, 4),
(174214, NULL, 'G3DSA:3.90.70.10:FF:000081', NULL, NULL, 'cathepsin B-like protease 2', NULL, NULL, NULL, NULL, NULL, 4),
(174215, NULL, 'G3DSA:1.25.40.180:FF:000353', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174216, NULL, 'G3DSA:3.30.70.330:FF:000986', NULL, NULL, 'Nucleolysin TIAR-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(174217, NULL, 'G3DSA:2.40.128.20:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174218, NULL, 'G3DSA:2.60.40.1220:FF:000011', NULL, NULL, 'Copper resistance protein CopC', NULL, NULL, NULL, NULL, NULL, 4),
(174219, NULL, 'G3DSA:2.130.10.10:FF:002432', NULL, NULL, 'Uncharacterized protein AT4g01860', NULL, NULL, NULL, NULL, NULL, 4),
(174220, NULL, 'G3DSA:3.40.630.30:FF:000158', NULL, NULL, 'Uncharacterized N-acetyltransferase B9W62_25615', NULL, NULL, NULL, NULL, NULL, 4),
(174221, NULL, 'G3DSA:3.30.160.60:FF:004135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174222, NULL, 'G3DSA:3.40.50.740:FF:000052', NULL, NULL, 'Extracellular oxidoreductase molybdopterin-binding lipoprotein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(174223, NULL, 'G3DSA:1.10.510.10:FF:003884', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174224, NULL, 'G3DSA:3.20.20.80:FF:000585', NULL, NULL, 'Si:ch211-226m16.2', NULL, NULL, NULL, NULL, NULL, 4),
(174225, NULL, 'G3DSA:2.60.40.3510:FF:000029', NULL, NULL, 'Jag2 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(174226, NULL, 'G3DSA:2.10.50.10:FF:000046', NULL, NULL, 'Cysteine repeat modular protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(174227, NULL, 'G3DSA:3.10.20.90:FF:000127', NULL, NULL, 'serine/threonine-protein kinase WNK4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(174228, NULL, 'G3DSA:1.20.120.160:FF:000035', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(174229, NULL, 'G3DSA:3.30.200.20:FF:001890', NULL, NULL, 'Inhibitor of nuclear factor kappa-B kinase subunit beta-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(174230, NULL, 'G3DSA:3.40.50.10190:FF:000182', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(174231, NULL, 'G3DSA:3.40.50.2300:FF:001542', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174232, NULL, 'G3DSA:1.10.10.140:FF:000002', NULL, NULL, 'Cytochrome c oxidase assembly factor 6 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(174233, NULL, 'G3DSA:1.20.1250.20:FF:000598', NULL, NULL, 'YBR241C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(174234, NULL, 'G3DSA:1.10.10.10:FF:001850', NULL, NULL, 'Rab family protein', NULL, NULL, NULL, NULL, NULL, 4),
(174235, NULL, 'G3DSA:2.60.120.10:FF:000276', NULL, NULL, 'Uncharacterized NTE family protein ZK370.4', NULL, NULL, NULL, NULL, NULL, 4),
(174236, NULL, 'G3DSA:3.30.1360.210:FF:000002', NULL, NULL, '60S ribosomal protein L22-2', NULL, NULL, NULL, NULL, NULL, 4),
(174237, NULL, 'G3DSA:1.20.1250.20:FF:001216', NULL, NULL, 'Major facilitator superfamily MFS_1', NULL, NULL, NULL, NULL, NULL, 4),
(174238, NULL, 'G3DSA:3.40.50.790:FF:000016', NULL, NULL, 'Ribosomal protein L1p/L10e family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(174239, NULL, 'G3DSA:1.10.510.10:FF:003777', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174240, NULL, 'G3DSA:3.90.1290.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174241, NULL, 'G3DSA:3.30.70.3000:FF:000001', NULL, NULL, 'tRNA(His) guanylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(174242, NULL, 'G3DSA:3.40.50.1820:FF:000791', NULL, NULL, 'Dienelactone hydrolase family protein (AFU_orthologue AFUA_6G12740)', NULL, NULL, NULL, NULL, NULL, 4),
(174243, NULL, 'G3DSA:1.10.287.370:FF:000072', NULL, NULL, 'Prefoldin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(174244, NULL, 'G3DSA:3.30.200.20:FF:001671', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174245, NULL, 'G3DSA:2.130.10.10:FF:003736', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174246, NULL, 'G3DSA:3.20.80.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174247, NULL, 'G3DSA:3.20.20.70:FF:000582', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174248, NULL, 'G3DSA:3.40.190.80:FF:000088', NULL, NULL, 'Inositol monophosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(174249, NULL, 'G3DSA:3.30.1360.220:FF:000005', NULL, NULL, 'A kinase anchor protein', NULL, NULL, NULL, NULL, NULL, 4),
(174250, NULL, 'G3DSA:1.10.20.10:FF:000243', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174251, NULL, 'G3DSA:2.60.40.150:FF:000119', NULL, NULL, 'C2 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(174252, NULL, 'G3DSA:3.40.50.880:FF:000043', NULL, NULL, 'Catalase', NULL, NULL, NULL, NULL, NULL, 4),
(174253, NULL, 'G3DSA:3.30.9.10:FF:000026', NULL, NULL, 'FAD-dependent oxidoreductase domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(174254, NULL, 'G3DSA:3.30.200.20:FF:001901', NULL, NULL, 'Protein CBR-CHK-2', NULL, NULL, NULL, NULL, NULL, 4),
(174255, NULL, 'G3DSA:3.30.160.60:FF:000009', NULL, NULL, 'zinc finger protein 79 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(174256, NULL, 'G3DSA:1.25.40.20:FF:000192', NULL, NULL, 'Ankyrin repeat, SAM and basic leucine zipper domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(174257, NULL, 'G3DSA:3.20.20.140:FF:000258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174258, NULL, 'G3DSA:3.40.1000.10:FF:000020', NULL, NULL, 'RGM domain family member drag-1', NULL, NULL, NULL, NULL, NULL, 4),
(174259, NULL, 'G3DSA:1.25.40.10:FF:002004', NULL, NULL, 'Putative signal protein with GGDEF domain', NULL, NULL, NULL, NULL, NULL, 4),
(174260, NULL, 'G3DSA:1.20.58.190:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(174261, NULL, 'G3DSA:1.10.1410.10:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174262, NULL, 'G3DSA:3.40.50.300:FF:007194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174263, NULL, 'G3DSA:1.20.58.2010:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174264, NULL, 'G3DSA:1.10.287.110:FF:000443', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174265, NULL, 'G3DSA:3.30.160.60:FF:000560', NULL, NULL, 'Scratch family transcriptional repressor 1', NULL, NULL, NULL, NULL, NULL, 4),
(174266, NULL, 'G3DSA:1.20.5.110:FF:000280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174267, NULL, 'G3DSA:3.40.50.10330:FF:000038', NULL, NULL, 'NAD kinase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(174268, NULL, 'G3DSA:2.40.160.120:FF:000014', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(174269, NULL, 'G3DSA:3.40.50.2020:FF:000036', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(174270, NULL, 'G3DSA:3.30.497.10:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174271, NULL, 'G3DSA:2.60.120.620:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174272, NULL, 'G3DSA:3.40.50.620:FF:000792', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174273, NULL, 'G3DSA:4.10.1240.10:FF:000061', NULL, NULL, 'Adhesion G protein-coupled receptor L1', NULL, NULL, NULL, NULL, NULL, 4),
(174274, NULL, 'G3DSA:3.30.1370.110:FF:000031', NULL, NULL, 'Protein CBG17965', NULL, NULL, NULL, NULL, NULL, 4),
(174275, NULL, 'G3DSA:2.60.120.10:FF:000512', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174276, NULL, 'G3DSA:3.30.160.60:FF:005916', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174277, NULL, 'G3DSA:2.60.40.10:FF:000015', NULL, NULL, 'receptor-type tyrosine-protein phosphatase delta isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(174278, NULL, 'G3DSA:1.25.40.10:FF:005348', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174279, NULL, 'G3DSA:1.10.10.350:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174280, NULL, 'G3DSA:1.25.40.10:FF:005096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174281, NULL, 'G3DSA:1.10.540.10:FF:000036', NULL, NULL, 'Acyl-CoA dehydrogenase FadE24', NULL, NULL, NULL, NULL, NULL, 4),
(174282, NULL, 'G3DSA:3.40.50.300:FF:003596', NULL, NULL, 'Small GTPase EhRabX26, putative', NULL, NULL, NULL, NULL, NULL, 4),
(174283, NULL, 'G3DSA:1.20.1070.10:FF:001115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174284, NULL, 'G3DSA:3.40.30.10:FF:000625', NULL, NULL, 'Protein disulfide isomerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(174285, NULL, 'G3DSA:3.40.605.10:FF:000061', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(174286, NULL, 'G3DSA:1.25.40.10:FF:001970', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174287, NULL, 'G3DSA:1.20.1070.10:FF:000497', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174288, NULL, 'G3DSA:3.40.830.10:FF:000010', NULL, NULL, 'Gallate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(174289, NULL, 'G3DSA:3.30.200.20:FF:001362', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174290, NULL, 'G3DSA:1.20.1070.10:FF:000749', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174291, NULL, 'G3DSA:2.40.10.230:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174292, NULL, 'G3DSA:3.30.70.330:FF:001481', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174293, NULL, 'G3DSA:2.130.10.10:FF:003427', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174294, NULL, 'G3DSA:4.10.240.10:FF:000069', NULL, NULL, 'C6 zinc finger domain protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(174295, NULL, 'G3DSA:3.10.20.30:FF:000008', NULL, NULL, 'Ferredoxin, 2Fe-2S type, ISC system', NULL, NULL, NULL, NULL, NULL, 4),
(174296, NULL, 'G3DSA:1.25.40.450:FF:000001', NULL, NULL, 'Nuclear pore complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(174297, NULL, 'G3DSA:2.10.25.10:FF:001140', NULL, NULL, 'Protein S', NULL, NULL, NULL, NULL, NULL, 4),
(174298, NULL, 'G3DSA:1.10.287.810:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174299, NULL, 'G3DSA:2.60.40.10:FF:003758', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174300, NULL, 'G3DSA:1.10.510.10:FF:004250', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174301, NULL, 'G3DSA:1.10.720.30:FF:000051', NULL, NULL, 'SAP domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(174302, NULL, 'G3DSA:3.30.40.10:FF:001357', NULL, NULL, 'Protein CBG08753', NULL, NULL, NULL, NULL, NULL, 4),
(174303, NULL, 'G3DSA:4.10.640.10:FF:000015', NULL, NULL, '30S ribosomal protein S18', NULL, NULL, NULL, NULL, NULL, 4),
(174304, NULL, 'G3DSA:3.60.21.10:FF:000452', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(174305, NULL, 'G3DSA:2.130.10.10:FF:005451', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174306, NULL, 'G3DSA:1.10.268.10:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174307, NULL, 'G3DSA:3.30.160.60:FF:001645', NULL, NULL, 'Zinc finger protein 646', NULL, NULL, NULL, NULL, NULL, 4),
(174308, NULL, 'G3DSA:2.130.10.10:FF:003197', NULL, NULL, 'AGAP006092-PA', NULL, NULL, NULL, NULL, NULL, 4),
(174309, NULL, 'G3DSA:1.20.1560.10:FF:000950', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(174310, NULL, 'G3DSA:2.60.40.10:FF:003197', NULL, NULL, 'Diverse immunoglobulin domain-containing protein 2.1', NULL, NULL, NULL, NULL, NULL, 4),
(174311, NULL, 'G3DSA:2.60.40.10:FF:003449', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174312, NULL, 'G3DSA:1.10.1600.10:FF:000012', NULL, NULL, 'AGAP002690-PA', NULL, NULL, NULL, NULL, NULL, 4),
(174313, NULL, 'G3DSA:2.60.40.790:FF:000210', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174314, NULL, 'G3DSA:1.20.1600.10:FF:000066', NULL, NULL, 'Outer membrane efflux protein', NULL, NULL, NULL, NULL, NULL, 4),
(174315, NULL, 'G3DSA:3.40.50.1950:FF:000009', NULL, NULL, 'Coenzyme A biosynthesis bifunctional protein CoaBC', NULL, NULL, NULL, NULL, NULL, 4),
(174316, NULL, 'G3DSA:3.40.50.2000:FF:000030', NULL, NULL, 'Sterol 3-beta-glucosyltransferase UGT80A2', NULL, NULL, NULL, NULL, NULL, 4),
(174317, NULL, 'G3DSA:3.40.50.720:FF:002289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174318, NULL, 'G3DSA:1.20.140.90:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174319, NULL, 'G3DSA:2.130.10.30:FF:000078', NULL, NULL, 'Serine/threonine-protein kinase Nek8', NULL, NULL, NULL, NULL, NULL, 4),
(174320, NULL, 'G3DSA:3.40.30.10:FF:000934', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(174321, NULL, 'G3DSA:3.30.1430.10:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174322, NULL, 'G3DSA:1.10.10.10:FF:001827', NULL, NULL, 'O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(174323, NULL, 'G3DSA:1.20.120.350:FF:000209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174324, NULL, 'G3DSA:3.90.70.10:FF:000620', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174325, NULL, 'G3DSA:2.130.10.10:FF:000072', NULL, NULL, 'Regulatory-associated protein of MTOR, complex 1', NULL, NULL, NULL, NULL, NULL, 4),
(174326, NULL, 'G3DSA:1.25.40.10:FF:003965', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174327, NULL, 'G3DSA:1.20.1110.10:FF:000214', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174328, NULL, 'G3DSA:2.130.10.10:FF:004034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174329, NULL, 'G3DSA:3.40.50.720:FF:001131', NULL, NULL, 'Zinc-binding dehydrogenase-like protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(174330, NULL, 'G3DSA:3.50.50.60:FF:001350', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(174331, NULL, 'G3DSA:3.30.60.30:FF:000055', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(174332, NULL, 'G3DSA:2.40.10.10:FF:000104', NULL, NULL, 'Serine protease HtrA', NULL, NULL, NULL, NULL, NULL, 4),
(174333, NULL, 'G3DSA:3.60.21.10:FF:000143', NULL, NULL, 'Acid sphingomyelinase-like phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(174334, NULL, 'G3DSA:1.10.510.10:FF:001428', NULL, NULL, 'Serine/threonine-protein kinase Nek6', NULL, NULL, NULL, NULL, NULL, 4),
(174335, NULL, 'G3DSA:1.10.287.160:FF:000008', NULL, NULL, 'serine/threonine-protein kinase N isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(174336, NULL, 'G3DSA:3.40.50.300:FF:000471', NULL, NULL, 'ATP-binding cassette, sub-family F (GCN20), member 1', NULL, NULL, NULL, NULL, NULL, 4),
(174337, NULL, 'G3DSA:3.40.190.10:FF:000938', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174338, NULL, 'G3DSA:4.10.910.10:FF:000008', NULL, NULL, 'Putative mitochondrial 37S ribosomal protein SWS2', NULL, NULL, NULL, NULL, NULL, 4),
(174339, NULL, 'G3DSA:1.10.10.60:FF:000061', NULL, NULL, 'Trihelix transcription factor GT-2', NULL, NULL, NULL, NULL, NULL, 4),
(174340, NULL, 'G3DSA:2.10.220.10:FF:000126', NULL, NULL, 'Endoprotease bli-4', NULL, NULL, NULL, NULL, NULL, 4),
(174341, NULL, 'G3DSA:4.10.400.10:FF:000166', NULL, NULL, 'Low-density lipoprotein receptor-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(174342, NULL, 'G3DSA:3.40.1390.30:FF:000009', NULL, NULL, 'YbgI/family dinuclear metal center protein', NULL, NULL, NULL, NULL, NULL, 4),
(174343, NULL, 'G3DSA:3.40.50.300:FF:006209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174344, NULL, 'G3DSA:1.25.40.10:FF:004241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174345, NULL, 'G3DSA:2.60.40.10:FF:005809', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174346, NULL, 'G3DSA:2.60.40.10:FF:005467', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174347, NULL, 'G3DSA:3.30.930.10:FF:000346', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174348, NULL, 'G3DSA:3.30.200.20:FF:001923', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174349, NULL, 'G3DSA:1.20.1070.10:FF:000188', NULL, NULL, 'Neuropeptide S receptor', NULL, NULL, NULL, NULL, NULL, 4),
(174350, NULL, 'G3DSA:3.40.50.10810:FF:000221', NULL, NULL, 'E3 ubiquitin-protein ligase SHPRH-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(174351, NULL, 'G3DSA:3.40.50.200:FF:000132', NULL, NULL, 'Furin2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(174352, NULL, 'G3DSA:2.40.240.10:FF:000008', NULL, NULL, 'probable glutamine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(174353, NULL, 'G3DSA:1.25.40.10:FF:003095', NULL, NULL, 'YALI0B00528p', NULL, NULL, NULL, NULL, NULL, 4),
(174354, NULL, 'G3DSA:3.40.50.300:FF:005850', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174355, NULL, 'G3DSA:3.40.1380.10:FF:000031', NULL, NULL, 'ATP synthase gamma subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(174356, NULL, 'G3DSA:3.30.460.90:FF:000007', NULL, NULL, 'Mitochondrial elongation factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(174357, NULL, 'G3DSA:3.40.50.2000:FF:001115', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(174358, NULL, 'G3DSA:3.40.33.10:FF:000071', NULL, NULL, 'Probable pathogenesis-related protein CaO19.2336', NULL, NULL, NULL, NULL, NULL, 4),
(174359, NULL, 'G3DSA:1.10.10.60:FF:000313', NULL, NULL, 'major centromere autoantigen B', NULL, NULL, NULL, NULL, NULL, 4),
(174360, NULL, 'G3DSA:1.10.275.10:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174361, NULL, 'G3DSA:3.30.200.20:FF:001581', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174362, NULL, 'G3DSA:1.10.510.10:FF:001737', NULL, NULL, 'Protein CBG04906', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(174363, NULL, 'G3DSA:3.40.630.150:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174364, NULL, 'G3DSA:3.40.1390.20:FF:000006', NULL, NULL, 'HPr kinase/phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(174365, NULL, 'G3DSA:3.40.1380.20:FF:000034', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(174366, NULL, 'G3DSA:3.10.250.10:FF:000080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174367, NULL, 'G3DSA:3.90.70.10:FF:000311', NULL, NULL, 'Toxin secretion transporter', NULL, NULL, NULL, NULL, NULL, 4),
(174368, NULL, 'G3DSA:1.25.40.70:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174369, NULL, 'G3DSA:3.30.70.2330:FF:000002', NULL, NULL, 'Fanconi-associated nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(174370, NULL, 'G3DSA:2.130.10.10:FF:002123', NULL, NULL, 'Elongator subunit', NULL, NULL, NULL, NULL, NULL, 4),
(174371, NULL, 'G3DSA:1.25.40.800:FF:000005', NULL, NULL, 'NOT family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(174372, NULL, 'G3DSA:3.40.50.1000:FF:000281', NULL, NULL, 'Copper-transporting ATPase PAA1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(174373, NULL, 'G3DSA:3.30.160.60:FF:001499', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(174374, NULL, 'G3DSA:1.20.5.2440:FF:000004', NULL, NULL, 'rab11 family-interacting protein 5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(174375, NULL, 'G3DSA:3.40.1390.10:FF:000003', NULL, NULL, 'UDP-N-acetylmuramoyl-L-alanyl-D-glutamate--2, 6-diaminopimelate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(174376, NULL, 'G3DSA:2.60.40.1080:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174377, NULL, 'G3DSA:3.40.50.1010:FF:000284', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174378, NULL, 'G3DSA:3.10.20.350:FF:000003', NULL, NULL, 'ORF1a protein', NULL, NULL, NULL, NULL, NULL, 4),
(174379, NULL, 'G3DSA:3.30.40.10:FF:001610', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174380, NULL, 'G3DSA:2.60.120.10:FF:000528', NULL, NULL, 'cGMP binding protein with small GTPase-serine/threonine kinase-dep-rasgef-gram-and two cGMP binding domains', NULL, NULL, NULL, NULL, NULL, 4),
(174381, NULL, 'G3DSA:3.40.50.1110:FF:000016', NULL, NULL, '9-O-acetyl-N-acetylneuraminic acid deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(174382, NULL, 'G3DSA:2.40.10.10:FF:000323', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174383, NULL, 'G3DSA:3.20.20.80:FF:000276', NULL, NULL, 'Putative secreted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174384, NULL, 'G3DSA:1.10.8.10:FF:000360', NULL, NULL, 'OTU deubiquitinase 7B', NULL, NULL, NULL, NULL, NULL, 4),
(174385, NULL, 'G3DSA:2.130.10.10:FF:005119', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174386, NULL, 'G3DSA:2.170.16.10:FF:000050', NULL, NULL, 'DNA gyrase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(174387, NULL, 'G3DSA:3.40.30.10:FF:000373', NULL, NULL, 'Transmembrane serine/threonine-protein kinase E', NULL, NULL, NULL, NULL, NULL, 4),
(174388, NULL, 'G3DSA:3.20.20.220:FF:000041', NULL, NULL, 'GD14304', NULL, NULL, NULL, NULL, NULL, 4),
(174389, NULL, 'G3DSA:1.20.1070.10:FF:002189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174390, NULL, 'G3DSA:1.25.10.10:FF:001687', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174391, NULL, 'G3DSA:3.40.50.300:FF:001808', NULL, NULL, 'Rab GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(174392, NULL, 'G3DSA:3.20.20.70:FF:000273', NULL, NULL, '4-hydroxy-tetrahydrodipicolinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(174393, NULL, 'G3DSA:3.40.50.300:FF:002522', NULL, NULL, 'DNA polymerase III subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(174394, NULL, 'G3DSA:3.90.190.10:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174395, NULL, 'G3DSA:3.40.50.800:FF:000093', NULL, NULL, 'Glycyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(174396, NULL, 'G3DSA:1.25.40.10:FF:003550', NULL, NULL, 'SET and MYND domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(174397, NULL, 'G3DSA:3.10.20.360:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174398, NULL, 'G3DSA:3.40.50.1460:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174399, NULL, 'G3DSA:3.40.50.1000:FF:000623', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174400, NULL, 'G3DSA:3.40.850.10:FF:000495', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174401, NULL, 'G3DSA:3.80.10.10:FF:003040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174402, NULL, 'G3DSA:1.10.555.10:FF:000093', NULL, NULL, 'RhoGAP domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(174403, NULL, 'G3DSA:1.25.40.20:FF:001299', NULL, NULL, 'BCL3 transcription coactivator', NULL, NULL, NULL, NULL, NULL, 4),
(174404, NULL, 'G3DSA:3.40.50.300:FF:004068', NULL, NULL, 'Telomerase protein component 1', NULL, NULL, NULL, NULL, NULL, 4),
(174405, NULL, 'G3DSA:1.10.472.10:FF:000698', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174406, NULL, 'G3DSA:3.30.70.20:FF:000114', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174407, NULL, 'G3DSA:3.20.20.80:FF:000731', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174408, NULL, 'G3DSA:1.10.2000.10:FF:000085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174409, NULL, 'G3DSA:3.10.170.20:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174410, NULL, 'G3DSA:1.25.40.10:FF:001296', NULL, NULL, 'Prolyl-4-hydroxylase-alpha NE2', NULL, NULL, NULL, NULL, NULL, 4),
(174411, NULL, 'G3DSA:2.60.40.150:FF:000013', NULL, NULL, 'copine-9 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(174412, NULL, 'G3DSA:1.20.1070.10:FF:000862', NULL, NULL, 'alpha-2A adrenergic receptor isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(174413, NULL, 'G3DSA:1.10.630.10:FF:000408', NULL, NULL, 'Cytochrome P450, putative (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(174414, NULL, 'G3DSA:1.10.287.550:FF:000002', NULL, NULL, 'Steroid sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(174415, NULL, 'G3DSA:3.90.70.10:FF:000401', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(174416, NULL, 'G3DSA:3.40.50.150:FF:000280', NULL, NULL, 'mRNA cap guanine-N7 methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(174417, NULL, 'G3DSA:3.30.70.3400:FF:000014', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(174418, NULL, 'G3DSA:2.130.10.10:FF:001409', NULL, NULL, 'NACHT and WD repeat domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(174419, NULL, 'G3DSA:2.30.30.1020:FF:000014', NULL, NULL, 'Not1_N-terminal_domain_-_CCR4-Not_complex_component/NOT2_/_NOT3_/_NOT5_family_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(174420, NULL, 'G3DSA:3.40.1260.20:FF:000002', NULL, NULL, 'Ribonuclease E', NULL, NULL, NULL, NULL, NULL, 4),
(174421, NULL, 'G3DSA:2.170.270.10:FF:000232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174422, NULL, 'G3DSA:3.50.50.60:FF:001366', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(174423, NULL, 'G3DSA:1.10.30.10:FF:000070', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(174424, NULL, 'G3DSA:1.20.1560.10:FF:000927', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174425, NULL, 'G3DSA:3.30.505.10:FF:000201', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174426, NULL, 'G3DSA:3.10.580.10:FF:000087', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(174427, NULL, 'G3DSA:3.30.420.10:FF:000173', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(174428, NULL, 'G3DSA:3.40.1160.10:FF:000048', NULL, NULL, 'Amino-acid acetyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(174429, NULL, 'G3DSA:3.40.630.30:FF:000613', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(174430, NULL, 'G3DSA:1.10.10.10:FF:001608', NULL, NULL, 'HSF transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(174431, NULL, 'G3DSA:2.60.40.10:FF:001196', NULL, NULL, 'Sallimus, isoform P', NULL, NULL, NULL, NULL, NULL, 4),
(174432, NULL, 'G3DSA:3.40.50.1980:FF:000012', NULL, NULL, 'Iron ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(174433, NULL, 'G3DSA:1.10.418.10:FF:000044', NULL, NULL, 'utrophin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(174434, NULL, 'G3DSA:3.20.20.60:FF:000028', NULL, NULL, '2-keto-3-deoxy-L-rhamnonate aldolase-like', NULL, NULL, NULL, NULL, NULL, 4),
(174435, NULL, 'G3DSA:3.40.50.1100:FF:000103', NULL, NULL, 'Threonine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(174436, NULL, 'G3DSA:3.40.30.10:FF:000715', NULL, NULL, 'Iodothyronine deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(174437, NULL, 'G3DSA:3.80.10.10:FF:001095', NULL, NULL, 'Early embryogenesis protein zyg-11', NULL, NULL, NULL, NULL, NULL, 4),
(174438, NULL, 'G3DSA:1.25.10.10:FF:001468', NULL, NULL, 'Dynein, axonemal, assembly factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(174439, NULL, 'G3DSA:3.40.50.150:FF:001836', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174440, NULL, 'G3DSA:3.60.21.60:FF:000023', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(174441, NULL, 'G3DSA:1.20.1250.20:FF:002088', NULL, NULL, 'SD04201p', NULL, NULL, NULL, NULL, NULL, 4),
(174442, NULL, 'G3DSA:1.10.510.10:FF:002451', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174443, NULL, 'G3DSA:2.60.40.10:FF:005557', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174444, NULL, 'G3DSA:4.10.1000.10:FF:000077', NULL, NULL, 'Zinc finger C-x8-C-x5-C-x3-H type family protein', NULL, NULL, NULL, NULL, NULL, 4),
(174445, NULL, 'G3DSA:1.20.5.1930:FF:000003', NULL, NULL, 'Sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(174446, NULL, 'G3DSA:1.10.506.10:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174447, NULL, 'G3DSA:2.130.10.10:FF:001718', NULL, NULL, 'AaceriADR331Cp', NULL, NULL, NULL, NULL, NULL, 4),
(174448, NULL, 'G3DSA:1.10.357.20:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174449, NULL, 'G3DSA:1.20.900.10:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174450, NULL, 'G3DSA:2.60.120.10:FF:000618', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174451, NULL, 'G3DSA:1.20.1740.10:FF:000262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174452, NULL, 'G3DSA:1.10.565.10:FF:000043', NULL, NULL, 'Peroxisome proliferator-activated receptor gamma', NULL, NULL, NULL, NULL, NULL, 4),
(174453, NULL, 'G3DSA:1.10.630.10:FF:000717', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174454, NULL, 'G3DSA:2.30.30.1160:FF:000005', NULL, NULL, 'AER067Cp', NULL, NULL, NULL, NULL, NULL, 4),
(174455, NULL, 'G3DSA:3.30.1490.120:FF:000021', NULL, NULL, 'DNA-directed RNA polymerase I subunit RPA43', NULL, NULL, NULL, NULL, NULL, 4),
(174456, NULL, 'G3DSA:1.10.357.10:FF:000020', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(174457, NULL, 'G3DSA:2.130.10.10:FF:001376', NULL, NULL, 'Os07g0693700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(174458, NULL, 'G3DSA:2.60.120.290:FF:000047', NULL, NULL, 'Cubilin', NULL, NULL, NULL, NULL, NULL, 4),
(174459, NULL, 'G3DSA:2.60.40.1180:FF:000050', NULL, NULL, '1,4-alpha-glucan branching enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(174460, NULL, 'G3DSA:1.10.10.60:FF:000999', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174461, NULL, 'G3DSA:1.25.40.860:FF:000017', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(174462, NULL, 'G3DSA:1.20.80.10:FF:000078', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174463, NULL, 'G3DSA:3.90.1750.10:FF:000104', NULL, NULL, 'Protein CBR-HECD-1', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(174464, NULL, 'G3DSA:3.40.50.2000:FF:001025', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(174465, NULL, 'G3DSA:1.10.630.10:FF:000066', NULL, NULL, 'Cytochrome P450 71D7', NULL, NULL, NULL, NULL, NULL, 4),
(174466, NULL, 'G3DSA:3.30.160.60:FF:002027', NULL, NULL, 'Blast:Sal-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(174467, NULL, 'G3DSA:1.10.630.10:FF:000375', NULL, NULL, 'Cytochrome p450 CYP199A2', NULL, NULL, NULL, NULL, NULL, 4),
(174468, NULL, 'G3DSA:3.40.630.30:FF:000052', NULL, NULL, 'Ribosomal-protein-serine acetyltransferase RimL', NULL, NULL, NULL, NULL, NULL, 4),
(174469, NULL, 'G3DSA:3.30.70.1620:FF:000020', NULL, NULL, 'Structural maintenance of chromosomes protein', NULL, NULL, NULL, NULL, NULL, 4),
(174470, NULL, 'G3DSA:3.10.20.90:FF:000021', NULL, NULL, 'focal adhesion kinase 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(174471, NULL, 'G3DSA:3.30.63.20:FF:000002', NULL, NULL, '40S ribosomal protein S25', NULL, NULL, NULL, NULL, NULL, 4),
(174472, NULL, 'G3DSA:1.10.530.10:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174473, NULL, 'G3DSA:2.30.30.380:FF:000047', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(174474, NULL, 'G3DSA:3.40.50.300:FF:002051', NULL, NULL, 'Spr3p', NULL, NULL, NULL, NULL, NULL, 4),
(174475, NULL, 'G3DSA:1.25.10.10:FF:001777', NULL, NULL, 'AT21921p', NULL, NULL, NULL, NULL, NULL, 4),
(174476, NULL, 'G3DSA:2.60.200.20:FF:000212', NULL, NULL, 'Kinesin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(174477, NULL, 'G3DSA:3.60.21.10:FF:000014', NULL, NULL, '3'',5''-cyclic adenosine monophosphate phosphodiesterase CpdA', NULL, NULL, NULL, NULL, NULL, 4),
(174478, NULL, 'G3DSA:1.10.510.10:FF:002142', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(174479, NULL, 'G3DSA:3.60.21.50:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174480, NULL, 'G3DSA:2.60.40.10:FF:005248', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174481, NULL, 'G3DSA:4.10.410.10:FF:000116', NULL, NULL, 'Serine proteinase inhibitor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(174482, NULL, 'G3DSA:2.10.25.10:FF:000499', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174483, NULL, 'G3DSA:3.40.50.300:FF:006013', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174484, NULL, 'G3DSA:3.40.50.300:FF:000358', NULL, NULL, 'RAB39B, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(174485, NULL, 'G3DSA:3.30.420.40:FF:000024', NULL, NULL, 'Heat shock protein SSB1', NULL, NULL, NULL, NULL, NULL, 4),
(174486, NULL, 'G3DSA:3.40.30.10:FF:000154', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(174487, NULL, 'G3DSA:1.10.486.10:FF:000078', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(174488, NULL, 'G3DSA:2.60.120.10:FF:000057', NULL, NULL, 'Cyclic nucleotide-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(174489, NULL, 'G3DSA:3.30.70.2740:FF:000018', NULL, NULL, 'FAD linked oxidase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(174490, NULL, 'G3DSA:3.40.50.300:FF:002612', NULL, NULL, 'RAD24p Checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(174491, NULL, 'G3DSA:3.10.100.10:FF:000220', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174492, NULL, 'G3DSA:3.30.450.20:FF:000565', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174493, NULL, 'G3DSA:3.10.100.10:FF:000310', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174494, NULL, 'G3DSA:3.30.930.10:FF:000037', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(174495, NULL, 'G3DSA:3.50.50.60:FF:001456', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(174496, NULL, 'G3DSA:3.40.50.150:FF:001617', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174497, NULL, 'G3DSA:3.40.50.720:FF:001237', NULL, NULL, 'Redox-sensing transcriptional repressor Rex', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(174498, NULL, 'G3DSA:1.25.70.10:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174499, NULL, 'G3DSA:1.10.287.90:FF:000010', NULL, NULL, 'Cytochrome c oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(174500, NULL, 'G3DSA:3.40.50.300:FF:002270', NULL, NULL, 'Probable DNA helicase MCM9', NULL, NULL, NULL, NULL, NULL, 4),
(174501, NULL, 'G3DSA:3.30.559.30:FF:000112', NULL, NULL, 'Siderophore peptide synthetase fer3', NULL, NULL, NULL, NULL, NULL, 4),
(174502, NULL, 'G3DSA:2.80.10.50:FF:000081', NULL, NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(174503, NULL, 'G3DSA:2.60.220.30:FF:000014', NULL, NULL, 'ankyrin-3-like isoform X7', NULL, NULL, NULL, NULL, NULL, 4),
(174504, NULL, 'G3DSA:3.40.50.2000:FF:000968', NULL, NULL, 'Glycosyl transferase group 1', NULL, NULL, NULL, NULL, NULL, 4),
(174505, NULL, 'G3DSA:1.25.40.840:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174506, NULL, 'G3DSA:1.20.58.830:FF:000040', NULL, NULL, 'PfEMP1 variant 1 of strain MC', NULL, NULL, NULL, NULL, NULL, 4),
(174507, NULL, 'G3DSA:3.40.720.10:FF:000272', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174508, NULL, 'G3DSA:3.30.870.10:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174509, NULL, 'G3DSA:2.10.110.10:FF:000011', NULL, NULL, 'Lim and senescent cell antigen-like-containing', NULL, NULL, NULL, NULL, NULL, 4),
(174510, NULL, 'G3DSA:1.20.1070.10:FF:000952', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174511, NULL, 'G3DSA:3.40.50.300:FF:006322', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174512, NULL, 'G3DSA:2.40.30.10:FF:000122', NULL, NULL, 'Elongation factor Tu', NULL, NULL, NULL, NULL, NULL, 4),
(174513, NULL, 'G3DSA:3.30.200.20:FF:001468', NULL, NULL, 'Epidermal growth factor receptor a (erythroblastic leukemia viral (v-erb-b) oncogene homolog, avian)', NULL, NULL, NULL, NULL, NULL, 4),
(174514, NULL, 'G3DSA:3.30.70.1070:FF:000012', NULL, NULL, 'Endolytic peptidoglycan transglycosylase RlpA', NULL, NULL, NULL, NULL, NULL, 4),
(174515, NULL, 'G3DSA:3.30.2230.10:FF:000028', NULL, NULL, 'Ubiquitin-specific peptidase 32', NULL, NULL, NULL, NULL, NULL, 4),
(174516, NULL, 'G3DSA:3.10.105.10:FF:000063', NULL, NULL, 'Peptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(174517, NULL, 'G3DSA:1.50.40.10:FF:000136', NULL, NULL, 'Mitochondrial carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(174518, NULL, 'G3DSA:1.25.40.990:FF:000005', NULL, NULL, 'Putative SAC3/GANP family protein', NULL, NULL, NULL, NULL, NULL, 4),
(174519, NULL, 'G3DSA:2.130.10.10:FF:001937', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174520, NULL, 'G3DSA:3.30.530.20:FF:000043', NULL, NULL, 'StAR-related lipid transfer protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(174521, NULL, 'G3DSA:1.10.287.410:FF:000011', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(174522, NULL, 'G3DSA:3.40.50.2300:FF:001087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174523, NULL, 'G3DSA:3.30.800.10:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174524, NULL, 'G3DSA:3.30.160.60:FF:002117', NULL, NULL, 'Zinc finger protein 142', NULL, NULL, NULL, NULL, NULL, 4),
(174525, NULL, 'G3DSA:3.60.130.30:FF:000003', NULL, NULL, 'Tet-like dioxygenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(174526, NULL, 'G3DSA:1.10.630.10:FF:000627', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174527, NULL, 'G3DSA:1.20.900.10:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174528, NULL, 'G3DSA:1.20.5.730:FF:000010', NULL, NULL, 'Rho kinase', NULL, NULL, NULL, NULL, NULL, 4),
(174529, NULL, 'G3DSA:1.10.10.790:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174530, NULL, 'G3DSA:1.20.120.830:FF:000005', NULL, NULL, 'Breast cancer anti-estrogen resistance protein 1', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(174531, NULL, 'G3DSA:2.30.30.1150:FF:000002', NULL, NULL, 'PHD finger protein 14 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(174532, NULL, 'G3DSA:3.30.70.330:FF:000767', NULL, NULL, 'Os07g0615400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(174533, NULL, 'G3DSA:3.30.70.1230:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174534, NULL, 'G3DSA:3.30.230.130:FF:000041', NULL, NULL, 'Cullin family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(174535, NULL, 'G3DSA:2.70.150.10:FF:000163', NULL, NULL, 'Cation transporting ATPase (PacS)', NULL, NULL, NULL, NULL, NULL, 4),
(174536, NULL, 'G3DSA:3.50.50.60:FF:001147', NULL, NULL, 'Long-chain-alcohol oxidase FAO1', NULL, NULL, NULL, NULL, NULL, 4),
(174537, NULL, 'G3DSA:1.10.287.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174538, NULL, 'G3DSA:3.40.50.300:FF:005395', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174539, NULL, 'G3DSA:2.40.30.10:FF:000431', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174540, NULL, 'G3DSA:1.10.390.10:FF:000097', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174541, NULL, 'G3DSA:3.30.60.30:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174542, NULL, 'G3DSA:2.130.10.10:FF:001628', NULL, NULL, 'WD domain, G-beta repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(174543, NULL, 'G3DSA:3.40.1170.60:FF:000007', NULL, NULL, 'DNA polymerase iota', NULL, NULL, NULL, NULL, NULL, 4),
(174544, NULL, 'G3DSA:1.10.10.10:FF:000214', NULL, NULL, 'Methylated-DNA--protein-cysteine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(174545, NULL, 'G3DSA:2.60.40.10:FF:005355', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174546, NULL, 'G3DSA:3.40.50.10900:FF:000012', NULL, NULL, 'Proteasome assembly chaperone 2', NULL, NULL, NULL, NULL, NULL, 4),
(174547, NULL, 'G3DSA:1.20.1560.10:FF:000383', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(174548, NULL, 'G3DSA:3.50.50.60:FF:001355', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174549, NULL, 'G3DSA:3.40.50.10190:FF:000092', NULL, NULL, 'BRCA1-associated RING domain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(174550, NULL, 'G3DSA:3.40.50.10490:FF:000075', NULL, NULL, 'Apicoplast ribosomal protein S2', NULL, NULL, NULL, NULL, NULL, 4),
(174551, NULL, 'G3DSA:2.130.10.10:FF:005428', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174552, NULL, 'G3DSA:3.90.870.10:FF:000024', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(174553, NULL, 'G3DSA:1.25.40.10:FF:001953', NULL, NULL, 'Prolyl 4-hydroxylase subunit alpha-2', NULL, NULL, NULL, NULL, NULL, 4),
(174554, NULL, 'G3DSA:3.80.10.10:FF:002753', NULL, NULL, 'Owl monkey involucrin (small allele)', NULL, NULL, NULL, NULL, NULL, 4),
(174555, NULL, 'G3DSA:3.40.50.300:FF:003585', NULL, NULL, 'GD16400', NULL, NULL, NULL, NULL, NULL, 4),
(174556, NULL, 'G3DSA:1.20.1610.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174557, NULL, 'G3DSA:3.30.160.60:FF:003764', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174558, NULL, 'G3DSA:1.10.10.2660:FF:000016', NULL, NULL, 'Ubiquitin-activating enzyme E1', NULL, NULL, NULL, NULL, NULL, 4),
(174559, NULL, 'G3DSA:3.10.20.600:FF:000005', NULL, NULL, 'NADH-quinone oxidoreductase subunit F', NULL, NULL, NULL, NULL, NULL, 4),
(174560, NULL, 'G3DSA:1.25.40.470:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174561, NULL, 'G3DSA:3.90.550.10:FF:000180', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(174562, NULL, 'G3DSA:3.30.420.10:FF:000392', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174563, NULL, 'G3DSA:1.20.120.850:FF:000017', NULL, NULL, 'DNA repair and recombination protein RAD54B', NULL, NULL, NULL, NULL, NULL, 4),
(174564, NULL, 'G3DSA:1.10.8.10:FF:000135', NULL, NULL, 'UBA/TS-N domain protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(174565, NULL, 'G3DSA:1.10.3450.40:FF:000009', NULL, NULL, 'Signal recognition particle subunit SRP68', NULL, NULL, NULL, NULL, NULL, 4),
(174566, NULL, 'G3DSA:1.10.10.2670:FF:000019', NULL, NULL, 'RNA polymerase II elongation factor ell1', NULL, NULL, NULL, NULL, NULL, 4),
(174567, NULL, 'G3DSA:1.10.472.130:FF:000017', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(174568, NULL, 'G3DSA:3.20.20.70:FF:000604', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174569, NULL, 'G3DSA:2.40.20.10:FF:000043', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(174570, NULL, 'G3DSA:1.10.510.10:FF:002131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174571, NULL, 'G3DSA:3.10.20.310:FF:000025', NULL, NULL, 'Outer membrane protein assembly factor', NULL, NULL, NULL, NULL, NULL, 4),
(174572, NULL, 'G3DSA:3.30.200.20:FF:001805', NULL, NULL, 'LIM domain kinase 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(174573, NULL, 'G3DSA:1.10.287.850:FF:000007', NULL, NULL, 'PE family protein', NULL, NULL, NULL, NULL, NULL, 4),
(174574, NULL, 'G3DSA:3.20.20.10:FF:000047', NULL, NULL, 'Antizyme inhibitor 1b', NULL, NULL, NULL, NULL, NULL, 4),
(174575, NULL, 'G3DSA:1.10.8.60:FF:000094', NULL, NULL, 'Cell division control protein', NULL, NULL, NULL, NULL, NULL, 4),
(174576, NULL, 'G3DSA:4.10.280.10:FF:000055', NULL, NULL, 'DNA-binding protein inhibitor ID-2', NULL, NULL, NULL, NULL, NULL, 4),
(174577, NULL, 'G3DSA:3.40.1020.10:FF:000004', NULL, NULL, 'Threonine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(174578, NULL, 'G3DSA:3.30.1120.10:FF:000020', NULL, NULL, 'Arylsulfatase A', NULL, NULL, NULL, NULL, NULL, 4),
(174579, NULL, 'G3DSA:3.30.2140.20:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174580, NULL, 'G3DSA:3.40.50.300:FF:002062', NULL, NULL, 'Rab-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(174581, NULL, 'G3DSA:3.40.50.10190:FF:000187', NULL, NULL, 'PAX transcription activation domain interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(174582, NULL, 'G3DSA:1.25.10.10:FF:003475', NULL, NULL, 'eIF-2-alpha kinase activator GCN1', NULL, NULL, NULL, NULL, NULL, 4),
(174583, NULL, 'G3DSA:1.10.2000.10:FF:000068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174584, NULL, 'G3DSA:1.10.287.810:FF:000007', NULL, NULL, 'Mitochondrial import inner membrane translocase', NULL, NULL, NULL, NULL, NULL, 4),
(174585, NULL, 'G3DSA:1.20.1070.10:FF:000845', NULL, NULL, 'Oxytocin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(174586, NULL, 'G3DSA:2.130.10.10:FF:000532', NULL, NULL, 'semaphorin-4F isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(174587, NULL, 'G3DSA:3.20.20.80:FF:000607', NULL, NULL, 'Beta-glucuronidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(174588, NULL, 'G3DSA:3.10.105.10:FF:000074', NULL, NULL, 'Peptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(174589, NULL, 'G3DSA:3.40.470.10:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174590, NULL, 'G3DSA:2.30.30.570:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174591, NULL, 'G3DSA:1.20.120.1510:FF:000008', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(174592, NULL, 'G3DSA:3.40.1160.10:FF:000065', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(174593, NULL, 'G3DSA:2.60.120.920:FF:000039', NULL, NULL, 'Tripartite motif-containing protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(174594, NULL, 'G3DSA:2.10.25.10:FF:001230', NULL, NULL, 'GD23945', NULL, NULL, NULL, NULL, NULL, 4),
(174595, NULL, 'G3DSA:1.20.5.340:FF:000101', NULL, NULL, 'Non-muscle myosin heavy chain II', NULL, NULL, NULL, NULL, NULL, 4),
(174596, NULL, 'G3DSA:3.90.1110.10:FF:000022', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(174597, NULL, 'G3DSA:1.20.1050.10:FF:000299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(174598, NULL, 'G3DSA:2.40.10.10:FF:000441', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174599, NULL, 'G3DSA:3.20.20.80:FF:000596', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174600, NULL, 'G3DSA:3.40.50.1240:FF:000010', NULL, NULL, 'Prostatic acid phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(174601, NULL, 'G3DSA:1.10.287.950:FF:000021', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(174602, NULL, 'G3DSA:3.20.20.70:FF:000593', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174603, NULL, 'G3DSA:1.20.1270.280:FF:000004', NULL, NULL, 'Cytoplasmic dynein heavy chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(174604, NULL, 'G3DSA:1.10.1100.10:FF:000002', NULL, NULL, 'Transcription initiation factor TFIID subunit', NULL, NULL, NULL, NULL, NULL, 4),
(174605, NULL, 'G3DSA:2.60.40.60:FF:000103', NULL, NULL, 'protocadherin-18 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(174606, NULL, 'G3DSA:1.20.1070.10:FF:001351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174607, NULL, 'G3DSA:1.20.990.10:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174608, NULL, 'G3DSA:4.10.970.10:FF:000006', NULL, NULL, 'Inverted repeat-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(174609, NULL, 'G3DSA:2.60.120.330:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174610, NULL, 'G3DSA:1.20.120.1080:FF:000065', NULL, NULL, 'RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(174611, NULL, 'G3DSA:1.10.1200.10:FF:000049', NULL, NULL, 'Nonribosomal siderophore peptide synthase SidC', NULL, NULL, NULL, NULL, NULL, 4),
(174612, NULL, 'G3DSA:2.130.10.10:FF:000206', NULL, NULL, 'Rho guanine nucleotide exchange factor 17', NULL, NULL, NULL, NULL, NULL, 4),
(174613, NULL, 'G3DSA:1.25.40.20:FF:000433', NULL, NULL, 'Probable serine/threonine-protein kinase DDB_G0278535', NULL, NULL, NULL, NULL, NULL, 4),
(174614, NULL, 'G3DSA:2.130.10.10:FF:001729', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174615, NULL, 'G3DSA:3.30.2290.10:FF:000015', NULL, NULL, 'Zinc metalloprotease TldD homolog', NULL, NULL, NULL, NULL, NULL, 4),
(174616, NULL, 'G3DSA:1.10.30.10:FF:000081', NULL, NULL, 'High mobility group protein B4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(174617, NULL, 'G3DSA:1.10.510.10:FF:004160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174618, NULL, 'G3DSA:1.10.238.10:FF:000070', NULL, NULL, 'Centrin-1', NULL, NULL, NULL, NULL, NULL, 4),
(174619, NULL, 'G3DSA:3.30.70.330:FF:001037', NULL, NULL, 'IGF-II mRNA-binding protein, isoform L', NULL, NULL, NULL, NULL, NULL, 4),
(174620, NULL, 'G3DSA:1.25.40.20:FF:001861', NULL, NULL, 'Phosphocholine transferase AnkX', NULL, NULL, NULL, NULL, NULL, 4),
(174621, NULL, 'G3DSA:1.25.40.90:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174622, NULL, 'G3DSA:2.30.29.30:FF:000794', NULL, NULL, 'BEACH domain-containing protein C1', NULL, NULL, NULL, NULL, NULL, 4),
(174623, NULL, 'G3DSA:2.60.40.840:FF:000012', NULL, NULL, 'Cone arrestin', NULL, NULL, NULL, NULL, NULL, 4),
(174624, NULL, 'G3DSA:1.20.140.150:FF:000002', NULL, NULL, 'Voltage-dependent calcium channel gamma-2 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(174625, NULL, 'G3DSA:2.10.50.10:FF:000142', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174626, NULL, 'G3DSA:1.10.510.10:FF:000091', NULL, NULL, 'Calcium/calmodulin-dependent protein kinase kinase 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(174627, NULL, 'G3DSA:3.40.50.10330:FF:000055', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(174628, NULL, 'G3DSA:1.25.10.10:FF:003380', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174629, NULL, 'G3DSA:3.80.10.10:FF:000499', NULL, NULL, 'Relaxin family peptide receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(174630, NULL, 'G3DSA:1.10.530.10:FF:000002', NULL, NULL, 'Membrane-bound lytic murein transglycosylase C', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(174631, NULL, 'G3DSA:1.20.58.70:FF:000100', NULL, NULL, 'Syntaxin 4', NULL, NULL, NULL, NULL, NULL, 4),
(174632, NULL, 'G3DSA:1.50.10.10:FF:000089', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174633, NULL, 'G3DSA:1.25.40.10:FF:000430', NULL, NULL, 'Tetratricopeptide repeat protein 30A', NULL, NULL, NULL, NULL, NULL, 4),
(174634, NULL, 'G3DSA:3.30.160.60:FF:000212', NULL, NULL, 'zinc finger protein 382 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(174635, NULL, 'G3DSA:1.20.120.350:FF:000204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174636, NULL, 'G3DSA:1.10.630.10:FF:000728', NULL, NULL, 'CYtochrome P450 family', NULL, NULL, NULL, NULL, NULL, 4),
(174637, NULL, 'G3DSA:3.40.50.300:FF:003000', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(174638, NULL, 'G3DSA:1.20.5.110:FF:000263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174639, NULL, 'G3DSA:2.60.40.3710:FF:000005', NULL, NULL, 'Lipoprotein-anchoring transpeptidase ErfK/SrfK', NULL, NULL, NULL, NULL, NULL, 4),
(174640, NULL, 'G3DSA:3.80.10.10:FF:001230', NULL, NULL, 'Leucine Rich repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(174641, NULL, 'G3DSA:3.60.21.50:FF:000014', NULL, NULL, 'Probable DNA polymerase delta small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(174642, NULL, 'G3DSA:3.30.40.10:FF:000880', NULL, NULL, 'Unplaced genomic scaffold supercont2.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(174643, NULL, 'G3DSA:1.25.10.10:FF:003149', NULL, NULL, 'Unc-45 myosin chaperone A', NULL, NULL, NULL, NULL, NULL, 4),
(174644, NULL, 'G3DSA:2.40.150.20:FF:000004', NULL, NULL, '39S ribosomal protein L14, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(174645, NULL, 'G3DSA:1.20.58.80:FF:000092', NULL, NULL, 'Vacuolar sorting protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(174646, NULL, 'G3DSA:1.25.40.20:FF:000219', NULL, NULL, 'Leucine-rich repeat serine/threonine-protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(174647, NULL, 'G3DSA:2.60.40.10:FF:004253', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174648, NULL, 'G3DSA:3.40.30.10:FF:000491', NULL, NULL, 'TlpA family protein disulfide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(174649, NULL, 'G3DSA:1.10.533.10:FF:000025', NULL, NULL, 'THO complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(174650, NULL, 'G3DSA:1.20.120.550:FF:000034', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(174651, NULL, 'G3DSA:1.20.140.160:FF:000005', NULL, NULL, 'RNA polymerase subunit sigma-70', NULL, NULL, NULL, NULL, NULL, 4),
(174652, NULL, 'G3DSA:2.60.40.10:FF:005681', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174653, NULL, 'G3DSA:1.25.50.20:FF:000035', NULL, NULL, 'Putative aminopeptidase-2', NULL, NULL, NULL, NULL, NULL, 4),
(174654, NULL, 'G3DSA:3.40.1360.10:FF:000046', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(174655, NULL, 'G3DSA:3.40.50.1820:FF:000667', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174656, NULL, 'G3DSA:3.40.120.10:FF:000063', NULL, NULL, 'Phosphomannomutase PmmA', NULL, NULL, NULL, NULL, NULL, 4),
(174657, NULL, 'G3DSA:3.90.105.10:FF:000022', NULL, NULL, 'Molybdenum cofactor biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(174658, NULL, 'G3DSA:2.60.40.60:FF:000092', NULL, NULL, 'Protocadherin 8', NULL, NULL, NULL, NULL, NULL, 4),
(174659, NULL, 'G3DSA:3.40.50.360:FF:000039', NULL, NULL, 'Nitric oxide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(174660, NULL, 'G3DSA:3.40.50.300:FF:004523', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(174661, NULL, 'G3DSA:2.80.10.50:FF:000204', NULL, NULL, 'Protein let-756', NULL, NULL, NULL, NULL, NULL, 4),
(174662, NULL, 'G3DSA:2.60.40.10:FF:000228', NULL, NULL, 'obscurin isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(174663, NULL, 'G3DSA:2.40.50.140:FF:000966', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174664, NULL, 'G3DSA:1.10.287.40:FF:000023', NULL, NULL, 'Serine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(174665, NULL, 'G3DSA:1.20.1250.20:FF:001340', NULL, NULL, 'Putative MFS-type transporter C09D4.1', NULL, NULL, NULL, NULL, NULL, 4),
(174666, NULL, 'G3DSA:3.60.40.10:FF:000283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174667, NULL, 'G3DSA:3.20.20.105:FF:000005', NULL, NULL, 'Queuine tRNA-ribosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(174668, NULL, 'G3DSA:3.40.50.1820:FF:001061', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(174669, NULL, 'G3DSA:1.10.10.60:FF:000521', NULL, NULL, 'SWR1-complex protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(174670, NULL, 'G3DSA:3.60.21.60:FF:000017', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(174671, NULL, 'G3DSA:3.30.70.580:FF:000010', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(174672, NULL, 'G3DSA:1.25.10.10:FF:000602', NULL, NULL, 'Vps15p', NULL, NULL, NULL, NULL, NULL, 4),
(174673, NULL, 'G3DSA:1.10.472.10:FF:000321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174674, NULL, 'G3DSA:2.140.10.30:FF:000009', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(174675, NULL, 'G3DSA:2.40.50.120:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174676, NULL, 'G3DSA:2.100.10.50:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174677, NULL, 'G3DSA:3.40.50.720:FF:001221', NULL, NULL, 'Os02g0151600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(174678, NULL, 'G3DSA:3.40.50.300:FF:007749', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174679, NULL, 'G3DSA:3.40.47.10:FF:000012', NULL, NULL, '3-ketoacyl-CoA thiolase, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(174680, NULL, 'G3DSA:3.30.70.3250:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174681, NULL, 'G3DSA:3.90.70.10:FF:000530', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 4', NULL, NULL, NULL, NULL, NULL, 4),
(174682, NULL, 'G3DSA:3.50.80.10:FF:000010', NULL, NULL, 'D-aminoacyl-tRNA deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(174683, NULL, 'G3DSA:1.20.1250.20:FF:000946', NULL, NULL, 'Major facilitator superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(174684, NULL, 'G3DSA:3.40.50.2300:FF:000030', NULL, NULL, 'PTS system, ascorbate-specific, IIB component', NULL, NULL, NULL, NULL, NULL, 4),
(174685, NULL, 'G3DSA:4.10.320.30:FF:000003', NULL, NULL, 'Myelin transcription factor 1a', NULL, NULL, NULL, NULL, NULL, 4),
(174686, NULL, 'G3DSA:2.30.30.1020:FF:000008', NULL, NULL, 'CCR4-NOT transcription complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(174687, NULL, 'G3DSA:4.10.410.10:FF:000004', NULL, NULL, 'Tissue factor pathway inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(174688, NULL, 'G3DSA:3.10.250.10:FF:000085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174689, NULL, 'G3DSA:1.20.58.390:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174690, NULL, 'G3DSA:1.10.455.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174691, NULL, 'G3DSA:2.30.29.30:FF:000468', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174692, NULL, 'G3DSA:3.40.50.2300:FF:001227', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174693, NULL, 'G3DSA:4.10.220.110:FF:000003', NULL, NULL, 'Type IV secretion protein Rhs', NULL, NULL, NULL, NULL, NULL, 4),
(174694, NULL, 'G3DSA:1.25.40.70:FF:000083', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174695, NULL, 'G3DSA:3.40.50.150:FF:001376', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174696, NULL, 'G3DSA:2.30.42.10:FF:000549', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174697, NULL, 'G3DSA:3.30.930.10:FF:000357', NULL, NULL, 'ATP phosphoribosyltransferase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(174698, NULL, 'G3DSA:1.20.1250.20:FF:001435', NULL, NULL, 'Inositol transporter 4', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(174699, NULL, 'G3DSA:1.10.10.1830:FF:000003', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(174700, NULL, 'G3DSA:2.130.10.10:FF:003293', NULL, NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', NULL, NULL, NULL, NULL, NULL, 4),
(174701, NULL, 'G3DSA:3.90.70.10:FF:000058', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 21', NULL, NULL, NULL, NULL, NULL, 4),
(174702, NULL, 'G3DSA:1.10.238.10:FF:000182', NULL, NULL, 'E3 ubiquitin-protein ligase CBL-C', NULL, NULL, NULL, NULL, NULL, 4),
(174703, NULL, 'G3DSA:3.40.50.300:FF:004102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174704, NULL, 'G3DSA:2.30.30.490:FF:000092', NULL, NULL, 'Nucleic acid binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(174705, NULL, 'G3DSA:1.25.40.10:FF:003656', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174706, NULL, 'G3DSA:3.40.30.10:FF:000165', NULL, NULL, 'glutaredoxin-3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(174707, NULL, 'G3DSA:1.20.1070.10:FF:001025', NULL, NULL, 'Olfactory receptor 1262', NULL, NULL, NULL, NULL, NULL, 4),
(174708, NULL, 'G3DSA:2.40.30.10:FF:000324', NULL, NULL, 'YALI0C21362p', NULL, NULL, NULL, NULL, NULL, 4),
(174709, NULL, 'G3DSA:2.10.90.10:FF:000037', NULL, NULL, 'neurturin', NULL, NULL, NULL, NULL, NULL, 4),
(174710, NULL, 'G3DSA:3.30.40.10:FF:001481', NULL, NULL, 'YALI0F22561p', NULL, NULL, NULL, NULL, NULL, 4),
(174711, NULL, 'G3DSA:3.90.180.10:FF:000168', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174712, NULL, 'G3DSA:3.40.50.2000:FF:000738', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(174713, NULL, 'G3DSA:2.60.40.60:FF:000215', NULL, NULL, 'FAT atypical cadherin 2', NULL, NULL, NULL, NULL, NULL, 4),
(174714, NULL, 'G3DSA:3.40.50.720:FF:001900', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(174715, NULL, 'G3DSA:1.20.1560.10:FF:000478', NULL, NULL, 'Uncharacterized ABC transporter ATP-binding protein HI_0663', NULL, NULL, NULL, NULL, NULL, 4),
(174716, NULL, 'G3DSA:3.30.420.10:FF:000487', NULL, NULL, 'REV3 like, DNA directed polymerase zeta catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(174717, NULL, 'G3DSA:3.40.50.1100:FF:000013', NULL, NULL, 'Threonine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(174718, NULL, 'G3DSA:1.20.58.60:FF:000468', NULL, NULL, 'AGAP009554-PA', NULL, NULL, NULL, NULL, NULL, 4),
(174719, NULL, 'G3DSA:1.25.40.20:FF:000096', NULL, NULL, 'Ankyrin repeat and SOCS box containing 12', NULL, NULL, NULL, NULL, NULL, 4),
(174720, NULL, 'G3DSA:3.30.1680.10:FF:000022', NULL, NULL, 'Semaphorin 4B', NULL, NULL, NULL, NULL, NULL, 4),
(174721, NULL, 'G3DSA:3.40.50.300:FF:001668', NULL, NULL, 'Non-structural polyprotein pORF1', NULL, NULL, NULL, NULL, NULL, 4),
(174722, NULL, 'G3DSA:3.30.70.330:FF:001149', NULL, NULL, 'RNA binding motif protein X-linked 2', NULL, NULL, NULL, NULL, NULL, 4),
(174723, NULL, 'G3DSA:2.10.25.10:FF:001016', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(174724, NULL, 'G3DSA:1.10.472.80:FF:000218', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174725, NULL, 'G3DSA:3.40.630.30:FF:000153', NULL, NULL, 'GNAT family acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(174726, NULL, 'G3DSA:3.10.50.40:FF:000058', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(174727, NULL, 'G3DSA:3.40.50.720:FF:001007', NULL, NULL, 'Arogenate dehydrogenase 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(174728, NULL, 'G3DSA:1.50.10.160:FF:000016', NULL, NULL, 'Os11g0474900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(174729, NULL, 'G3DSA:1.20.920.10:FF:000198', NULL, NULL, 'Putative SWI/SNF catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(174730, NULL, 'G3DSA:4.10.800.20:FF:000014', NULL, NULL, 'AMP deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(174731, NULL, 'G3DSA:3.80.10.10:FF:000387', NULL, NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g06840', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(174732, NULL, 'G3DSA:3.30.160.60:FF:000324', NULL, NULL, 'Early growth response protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(174733, NULL, 'G3DSA:2.30.29.30:FF:000682', NULL, NULL, 'WASP (Actin cytoskeleton modulator) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(174734, NULL, 'G3DSA:3.30.70.590:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174735, NULL, 'G3DSA:1.20.140.100:FF:000015', NULL, NULL, 'Dynein Heavy Chain', NULL, NULL, NULL, NULL, NULL, 4),
(174736, NULL, 'G3DSA:1.20.1250.20:FF:000851', NULL, NULL, 'Gon-2 Extragenic Modifier', NULL, NULL, NULL, NULL, NULL, 4),
(174737, NULL, 'G3DSA:3.80.10.10:FF:003028', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174738, NULL, 'G3DSA:3.80.30.20:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174739, NULL, 'G3DSA:3.20.20.120:FF:000016', NULL, NULL, 'Mandelate racemase/muconate lactonizing protein', NULL, NULL, NULL, NULL, NULL, 4),
(174740, NULL, 'G3DSA:1.10.1520.10:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174741, NULL, 'G3DSA:3.40.50.1100:FF:000108', NULL, NULL, 'Threonine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(174742, NULL, 'G3DSA:3.40.50.1820:FF:001156', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(174743, NULL, 'G3DSA:4.10.800.10:FF:000011', NULL, NULL, 'Thyroglobulin', NULL, NULL, NULL, NULL, NULL, 4),
(174744, NULL, 'G3DSA:2.130.10.10:FF:003079', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174745, NULL, 'G3DSA:3.10.20.90:FF:000122', NULL, NULL, 'Fas associated factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(174746, NULL, 'G3DSA:3.80.10.10:FF:001342', NULL, NULL, 'F-box and leucine-rich repeat protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(174747, NULL, 'G3DSA:3.40.190.10:FF:000106', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(174748, NULL, 'G3DSA:1.10.150.50:FF:000018', NULL, NULL, 'Polycomb protein scmh1 isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(174749, NULL, 'G3DSA:1.50.10.150:FF:000013', NULL, NULL, 'Tellurite resistance protein TehA', NULL, NULL, NULL, NULL, NULL, 4),
(174750, NULL, 'G3DSA:1.25.40.10:FF:000104', NULL, NULL, 'Fem-1 homolog c (C.elegans)', NULL, NULL, NULL, NULL, NULL, 4),
(174751, NULL, 'G3DSA:1.10.555.10:FF:000087', NULL, NULL, 'RalA-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(174752, NULL, 'G3DSA:3.90.190.10:FF:000096', NULL, NULL, 'Tyrosine-protein phosphatase 69D', NULL, NULL, NULL, NULL, NULL, 4),
(174753, NULL, 'G3DSA:3.40.50.12160:FF:000025', NULL, NULL, '(Dimethylallyl)adenosine tRNA methylthiotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(174754, NULL, 'G3DSA:2.160.20.80:FF:000002', NULL, NULL, 'Potassium channel tetramerization domain-containing 9a', NULL, NULL, NULL, NULL, NULL, 4),
(174755, NULL, 'G3DSA:3.30.40.10:FF:000992', NULL, NULL, 'LD19244p', NULL, NULL, NULL, NULL, NULL, 4),
(174756, NULL, 'G3DSA:3.40.50.1240:FF:000122', NULL, NULL, 'Phosphoglycerate mutase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(174757, NULL, 'G3DSA:3.30.70.1620:FF:000008', NULL, NULL, 'Structural maintenance of chromosomes protein', NULL, NULL, NULL, NULL, NULL, 4),
(174758, NULL, 'G3DSA:3.80.10.10:FF:002539', NULL, NULL, 'TOLl (Drosophila) family', NULL, NULL, NULL, NULL, NULL, 4),
(174759, NULL, 'G3DSA:2.130.10.10:FF:003972', NULL, NULL, 'Breast carcinoma AMPlified sequence, putative', NULL, NULL, NULL, NULL, NULL, 4),
(174760, NULL, 'G3DSA:3.30.70.330:FF:001363', NULL, NULL, 'Os02g0815200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(174761, NULL, 'G3DSA:2.40.50.100:FF:000061', NULL, NULL, '50S ribosomal protein L27', NULL, NULL, NULL, NULL, NULL, 4),
(174762, NULL, 'G3DSA:1.20.58.60:FF:000682', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174763, NULL, 'G3DSA:1.20.920.10:FF:000209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174764, NULL, 'G3DSA:3.40.50.300:FF:007963', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(174765, NULL, 'G3DSA:1.25.40.20:FF:000107', NULL, NULL, 'cyclin-dependent kinase 4 inhibitor B', NULL, NULL, NULL, NULL, NULL, 4),
(174766, NULL, 'G3DSA:3.10.20.90:FF:000801', NULL, NULL, 'Serine/threonine-protein kinase TBK1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(174767, NULL, 'G3DSA:3.20.20.70:FF:000716', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174768, NULL, 'G3DSA:2.130.10.10:FF:003646', NULL, NULL, 'POC1 centriolar protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(174769, NULL, 'G3DSA:3.10.590.10:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174770, NULL, 'G3DSA:1.20.990.10:FF:000034', NULL, NULL, 'Nitric oxide synthase, inducible', NULL, NULL, NULL, NULL, NULL, 4),
(174771, NULL, 'G3DSA:3.20.10.10:FF:000007', NULL, NULL, 'Branched-chain-amino-acid aminotransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(174772, NULL, 'G3DSA:1.10.510.10:FF:004143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174773, NULL, 'G3DSA:2.30.30.140:FF:000228', NULL, NULL, 'LD30829p', NULL, NULL, NULL, NULL, NULL, 4),
(174774, NULL, 'G3DSA:1.10.510.10:FF:001967', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174775, NULL, 'G3DSA:1.25.40.10:FF:001841', NULL, NULL, 'Hepatocellular carcinoma-associated antigen, putative', NULL, NULL, NULL, NULL, NULL, 4),
(174776, NULL, 'G3DSA:1.20.1250.20:FF:001014', NULL, NULL, 'Nodulin-like, putative', NULL, NULL, NULL, NULL, NULL, 4),
(174777, NULL, 'G3DSA:3.20.20.80:FF:000719', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174778, NULL, 'G3DSA:1.20.120.1080:FF:000048', NULL, NULL, 'ATP-dependent RNA helicase prh1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(174779, NULL, 'G3DSA:3.80.10.10:FF:002865', NULL, NULL, 'AGAP005805-PA', NULL, NULL, NULL, NULL, NULL, 4),
(174780, NULL, 'G3DSA:3.40.50.300:FF:003697', NULL, NULL, 'Dynein alpha chain, flagellar outer arm', NULL, NULL, NULL, NULL, NULL, 4),
(174781, NULL, 'G3DSA:3.30.30.170:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174782, NULL, 'G3DSA:1.10.287.1390:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174783, NULL, 'G3DSA:2.30.30.870:FF:000008', NULL, NULL, 'Protein pelota homolog', NULL, NULL, NULL, NULL, NULL, 4),
(174784, NULL, 'G3DSA:1.10.287.1490:FF:000144', NULL, NULL, 'Structural maintenance of chromosomes protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(174785, NULL, 'G3DSA:2.60.120.290:FF:000154', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(174786, NULL, 'G3DSA:3.40.140.10:FF:000160', NULL, NULL, 'Pre-mRNA-processing-splicing factor 8A', NULL, NULL, NULL, NULL, NULL, 4),
(174787, NULL, 'G3DSA:3.30.160.60:FF:000650', NULL, NULL, 'Zinc finger protein 197', NULL, NULL, NULL, NULL, NULL, 4),
(174788, NULL, 'G3DSA:1.10.287.130:FF:000247', NULL, NULL, 'Hybrid signal transduction histidine kinase H', NULL, NULL, NULL, NULL, NULL, 4),
(174789, NULL, 'G3DSA:3.40.50.300:FF:001909', NULL, NULL, 'DNA mismatch repair protein msh3', NULL, NULL, NULL, NULL, NULL, 4),
(174790, NULL, 'G3DSA:3.30.60.30:FF:000173', NULL, NULL, 'Agr-1', NULL, NULL, NULL, NULL, NULL, 4),
(174791, NULL, 'G3DSA:2.30.29.30:FF:001283', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174792, NULL, 'G3DSA:3.40.50.300:FF:000050', NULL, NULL, 'DNA repair protein RadA', NULL, NULL, NULL, NULL, NULL, 4),
(174793, NULL, 'G3DSA:1.20.1250.20:FF:002296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174794, NULL, 'G3DSA:1.10.510.10:FF:002243', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174795, NULL, 'G3DSA:1.10.20.10:FF:000041', NULL, NULL, 'DNA polymerase epsilon subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(174796, NULL, 'G3DSA:1.20.5.170:FF:000157', NULL, NULL, 'DNA repair protein Swi5/Sae3', NULL, NULL, NULL, NULL, NULL, 4),
(174797, NULL, 'G3DSA:1.25.40.180:FF:000229', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174798, NULL, 'G3DSA:1.10.287.470:FF:000091', NULL, NULL, 'Probable membrane-fusion protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(174799, NULL, 'G3DSA:3.30.160.60:FF:005681', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174800, NULL, 'G3DSA:1.20.5.2440:FF:000010', NULL, NULL, 'Rab-11 Family Interacting-Protein', NULL, NULL, NULL, NULL, NULL, 4),
(174801, NULL, 'G3DSA:2.60.40.10:FF:002241', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(174802, NULL, 'G3DSA:3.40.250.10:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174803, NULL, 'G3DSA:4.10.280.10:FF:000167', NULL, NULL, 'Helix-loop-helix protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(174804, NULL, 'G3DSA:1.25.40.10:FF:003870', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174805, NULL, 'G3DSA:1.20.1070.10:FF:000957', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174806, NULL, 'G3DSA:3.40.50.300:FF:005951', NULL, NULL, 'DNA mismatch repair protein MSH3', NULL, NULL, NULL, NULL, NULL, 4),
(174807, NULL, 'G3DSA:1.10.287.110:FF:000011', NULL, NULL, 'Co-chaperone protein DjlA', NULL, NULL, NULL, NULL, NULL, 4),
(174808, NULL, 'G3DSA:1.20.58.400:FF:000029', NULL, NULL, 'Vesicle transport v-SNARE protein', NULL, NULL, NULL, NULL, NULL, 4),
(174809, NULL, 'G3DSA:1.10.1420.10:FF:000144', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(174810, NULL, 'G3DSA:3.20.80.10:FF:000039', NULL, NULL, 'Heme binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(174811, NULL, 'G3DSA:3.30.70.330:FF:000969', NULL, NULL, 'Nuclear RNA export factor', NULL, NULL, NULL, NULL, NULL, 4),
(174812, NULL, 'G3DSA:2.60.40.10:FF:001965', NULL, NULL, 'Cilia and flagella associated protein 65', NULL, NULL, NULL, NULL, NULL, 4),
(174813, NULL, 'G3DSA:2.130.10.10:FF:005445', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174814, NULL, 'G3DSA:3.40.50.1820:FF:000993', NULL, NULL, 'Carboxylesterase', NULL, NULL, NULL, NULL, NULL, 4),
(174815, NULL, 'G3DSA:1.20.58.530:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174816, NULL, 'G3DSA:3.40.50.300:FF:005597', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174817, NULL, 'G3DSA:3.90.226.10:FF:000140', NULL, NULL, 'ATP-dependent Clp protease proteolytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(174818, NULL, 'G3DSA:3.30.1360.120:FF:000054', NULL, NULL, 'Folate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(174819, NULL, 'G3DSA:1.20.58.60:FF:000889', NULL, NULL, 'Short stop/Kakapo isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(174820, NULL, 'G3DSA:3.30.200.20:FF:001452', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(174821, NULL, 'G3DSA:3.40.50.720:FF:001119', NULL, NULL, '6-phosphogluconate dehydrogenase, decarboxylating', NULL, NULL, NULL, NULL, NULL, 4),
(174822, NULL, 'G3DSA:1.20.1280.50:FF:000103', NULL, NULL, 'Leucine rich repeat containing 29', NULL, NULL, NULL, NULL, NULL, 4),
(174823, NULL, 'G3DSA:3.40.50.300:FF:007851', NULL, NULL, 'DNA replication licensing factor, MCM2/3/5 family', NULL, NULL, NULL, NULL, NULL, 4),
(174824, NULL, 'G3DSA:1.25.50.20:FF:000052', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(174825, NULL, 'G3DSA:1.20.5.110:FF:000049', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(174826, NULL, 'G3DSA:3.30.40.10:FF:000649', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(174827, NULL, 'G3DSA:3.10.20.90:FF:000329', NULL, NULL, 'Wnk kinase, isoform L', NULL, NULL, NULL, NULL, NULL, 4),
(174828, NULL, 'G3DSA:2.80.10.50:FF:000221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174829, NULL, 'G3DSA:2.80.10.50:FF:000193', NULL, NULL, 'Tetanus toxin', NULL, NULL, NULL, NULL, NULL, 4),
(174830, NULL, 'G3DSA:3.40.50.10190:FF:000075', NULL, NULL, 'Nijmegen breakage syndrome 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(174831, NULL, 'G3DSA:2.40.40.20:FF:000058', NULL, NULL, 'Peroxisomal biogenesis factor 1', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(174832, NULL, 'G3DSA:1.20.920.10:FF:000086', NULL, NULL, 'ATP-dependent chromatin assembly factor large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(174833, NULL, 'G3DSA:3.30.420.10:FF:000375', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174834, NULL, 'G3DSA:3.40.532.10:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174835, NULL, 'G3DSA:1.10.10.440:FF:000070', NULL, NULL, 'Pre-mRNA-processing protein 40B', NULL, NULL, NULL, NULL, NULL, 4),
(174836, NULL, 'G3DSA:3.40.640.10:FF:000102', NULL, NULL, '1-aminocyclopropane-1-carboxylate synthase homolog (inactive)', NULL, NULL, NULL, NULL, NULL, 4),
(174837, NULL, 'G3DSA:3.40.50.300:FF:006114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174838, NULL, 'G3DSA:3.30.930.10:FF:000245', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(174839, NULL, 'G3DSA:2.40.20.10:FF:000060', NULL, NULL, 'Plasminogen', NULL, NULL, NULL, NULL, NULL, 4),
(174840, NULL, 'G3DSA:1.20.1270.60:FF:000038', NULL, NULL, 'Rho GTPase activating protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(174841, NULL, 'G3DSA:3.40.5.90:FF:000002', NULL, NULL, 'CDGSH iron-sulfur domain-containing protein 3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(174842, NULL, 'G3DSA:3.60.40.10:FF:000378', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174843, NULL, 'G3DSA:1.10.3730.20:FF:000036', NULL, NULL, 'EamA family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(174844, NULL, 'G3DSA:1.20.1110.10:FF:000219', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174845, NULL, 'G3DSA:1.10.150.90:FF:000002', NULL, NULL, 'Gag polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(174846, NULL, 'G3DSA:1.10.720.60:FF:000014', NULL, NULL, 'Enolase-phosphatase E1', NULL, NULL, NULL, NULL, NULL, 4),
(174847, NULL, 'G3DSA:3.40.20.10:FF:000125', NULL, NULL, 'Cofilin-2', NULL, NULL, NULL, NULL, NULL, 4),
(174848, NULL, 'G3DSA:2.60.40.150:FF:000344', NULL, NULL, 'Extended SYnapTotagmin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(174849, NULL, 'G3DSA:3.40.50.300:FF:007396', NULL, NULL, 'GTP-binding protein-related', NULL, NULL, NULL, NULL, NULL, 4),
(174850, NULL, 'G3DSA:3.30.420.40:FF:000142', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(174851, NULL, 'G3DSA:2.10.70.10:FF:000042', NULL, NULL, 'Membrane cofactor protein', NULL, NULL, NULL, NULL, NULL, 4),
(174852, NULL, 'G3DSA:3.30.160.60:FF:001398', NULL, NULL, 'zinc finger protein 830', NULL, NULL, NULL, NULL, NULL, 4),
(174853, NULL, 'G3DSA:1.10.8.60:FF:000217', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(174854, NULL, 'G3DSA:1.10.10.10:FF:001395', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(174855, NULL, 'G3DSA:3.40.50.200:FF:000019', NULL, NULL, 'Protease S8 tripeptidyl peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(174856, NULL, 'G3DSA:2.40.30.330:FF:000013', NULL, NULL, 'mRNA cleavage and polyadenylation factor complex II subunit', NULL, NULL, NULL, NULL, NULL, 4),
(174857, NULL, 'G3DSA:1.10.238.10:FF:001267', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(174858, NULL, 'G3DSA:3.30.70.330:FF:001251', NULL, NULL, 'HIV Tat-specific factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(174859, NULL, 'G3DSA:3.50.50.60:FF:000866', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(174860, NULL, 'G3DSA:1.10.287.990:FF:000004', NULL, NULL, 'Dihydrolipoamide dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(174861, NULL, 'G3DSA:1.25.10.10:FF:001463', NULL, NULL, 'Protein CELLULOSE SYNTHASE INTERACTIVE 3', NULL, NULL, NULL, NULL, NULL, 4),
(174862, NULL, 'G3DSA:1.25.10.10:FF:000035', NULL, NULL, 'adenomatous polyposis coli protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(174863, NULL, 'G3DSA:3.90.1570.40:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174864, NULL, 'G3DSA:3.40.430.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(174865, NULL, 'G3DSA:1.10.287.110:FF:000241', NULL, NULL, 'Chaperone protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(174866, NULL, 'G3DSA:1.10.560.10:FF:000037', NULL, NULL, 'T-complex protein 1 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(174867, NULL, 'G3DSA:3.40.1060.10:FF:000001', NULL, NULL, 'Aconitate hydratase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(174868, NULL, 'G3DSA:3.30.160.60:FF:004039', NULL, NULL, 'Protein suppressor of hairy wing', NULL, NULL, NULL, NULL, NULL, 4),
(174869, NULL, 'G3DSA:1.10.510.10:FF:003980', NULL, NULL, 'Negative regulator of sexual conjugation and meiosis', NULL, NULL, NULL, NULL, NULL, 4),
(174870, NULL, 'G3DSA:2.10.220.10:FF:000031', NULL, NULL, 'Furin 2, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(174871, NULL, 'G3DSA:2.60.40.10:FF:000116', NULL, NULL, 'HLA class II histocompatibility antigen, DRB1-1 beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(174872, NULL, 'G3DSA:1.10.520.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174873, NULL, 'G3DSA:2.130.10.10:FF:000083', NULL, NULL, 'WD repeat domain phosphoinositide-interacting protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(174874, NULL, 'G3DSA:3.30.1320.10:FF:000001', NULL, NULL, '30S ribosomal protein S16', NULL, NULL, NULL, NULL, NULL, 4),
(174875, NULL, 'G3DSA:1.20.1070.10:FF:000396', NULL, NULL, 'D(2) dopamine receptor A', NULL, NULL, NULL, NULL, NULL, 4),
(174876, NULL, 'G3DSA:3.40.50.740:FF:000046', NULL, NULL, 'Formate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(174877, NULL, 'G3DSA:2.60.120.10:FF:000394', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(174878, NULL, 'G3DSA:1.10.10.250:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174879, NULL, 'G3DSA:3.40.30.10:FF:000614', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174880, NULL, 'G3DSA:3.40.50.1820:FF:001173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174881, NULL, 'G3DSA:3.30.160.60:FF:004702', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174882, NULL, 'G3DSA:3.10.50.40:FF:000075', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase FKBP42', NULL, NULL, NULL, NULL, NULL, 4),
(174883, NULL, 'G3DSA:1.20.1110.10:FF:000012', NULL, NULL, 'Plasma membrane ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(174884, NULL, 'G3DSA:1.10.510.10:FF:000118', NULL, NULL, 'G protein-coupled receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(174885, NULL, 'G3DSA:3.40.1110.10:FF:000449', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174886, NULL, 'G3DSA:3.90.1750.10:FF:000093', NULL, NULL, 'Ubiquitin-protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(174887, NULL, 'G3DSA:1.20.1070.10:FF:001008', NULL, NULL, 'Purinergic receptor P2Y, G-protein-coupled 10B', NULL, NULL, NULL, NULL, NULL, 4),
(174888, NULL, 'G3DSA:2.130.10.10:FF:003742', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174889, NULL, 'G3DSA:2.10.70.10:FF:000025', NULL, NULL, 'seizure 6-like protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(174890, NULL, 'G3DSA:1.25.40.10:FF:003639', NULL, NULL, 'Tetratricopeptide repeat protein 21B', NULL, NULL, NULL, NULL, NULL, 4),
(174891, NULL, 'G3DSA:3.30.710.10:FF:000476', NULL, NULL, 'Protein CBG25771', NULL, NULL, NULL, NULL, NULL, 4),
(174892, NULL, 'G3DSA:2.130.10.30:FF:000089', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174893, NULL, 'G3DSA:2.60.220.50:FF:000099', NULL, NULL, 'Contactin-6', NULL, NULL, NULL, NULL, NULL, 4),
(174894, NULL, 'G3DSA:3.40.50.300:FF:006440', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174895, NULL, 'G3DSA:3.40.50.300:FF:005625', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174896, NULL, 'G3DSA:2.130.10.10:FF:005771', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174897, NULL, 'G3DSA:1.25.40.10:FF:001739', NULL, NULL, 'Pentatricopeptide repeat-containing protein OTP51, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(174898, NULL, 'G3DSA:1.25.40.1030:FF:000032', NULL, NULL, 'COP-II coat subunit', NULL, NULL, NULL, NULL, NULL, 4),
(174899, NULL, 'G3DSA:1.10.10.10:FF:001378', NULL, NULL, 'Demethylsterigmatocystin 6-O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(174900, NULL, 'G3DSA:1.10.268.10:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174901, NULL, 'G3DSA:3.30.40.10:FF:001155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174902, NULL, 'G3DSA:3.50.50.60:FF:001029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174903, NULL, 'G3DSA:3.80.10.10:FF:001016', NULL, NULL, 'Leucine Rich Repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(174904, NULL, 'G3DSA:3.40.720.10:FF:000154', NULL, NULL, 'N-sulfoglucosamine sulfohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(174905, NULL, 'G3DSA:3.40.50.720:FF:001445', NULL, NULL, 'uncharacterized protein LOC100179743', NULL, NULL, NULL, NULL, NULL, 4),
(174906, NULL, 'G3DSA:3.40.50.410:FF:000178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174907, NULL, 'G3DSA:3.40.33.10:FF:000076', NULL, NULL, 'CRISP/Allergen/PR-1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(174908, NULL, 'G3DSA:3.90.190.10:FF:000337', NULL, NULL, 'Pps1p', NULL, NULL, NULL, NULL, NULL, 4),
(174909, NULL, 'G3DSA:1.10.600.10:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174910, NULL, 'G3DSA:2.60.40.10:FF:001398', NULL, NULL, 'Echinoid, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(174911, NULL, 'G3DSA:2.40.50.90:FF:000097', NULL, NULL, 'Tudor domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(174912, NULL, 'G3DSA:3.40.50.1820:FF:000897', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174913, NULL, 'G3DSA:3.30.160.60:FF:005804', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174914, NULL, 'G3DSA:1.50.10.10:FF:000191', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(174915, NULL, 'G3DSA:1.10.8.680:FF:000003', NULL, NULL, 'TBC1 domain family member', NULL, NULL, NULL, NULL, NULL, 4),
(174916, NULL, 'G3DSA:2.60.200.10:FF:000001', NULL, NULL, 'Mothers against decapentaplegic homolog', NULL, NULL, NULL, NULL, NULL, 4),
(174917, NULL, 'G3DSA:3.30.70.330:FF:002998', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174918, NULL, 'G3DSA:6.10.140.2220:FF:000026', NULL, NULL, 'protein msta', NULL, NULL, NULL, NULL, NULL, 4),
(174919, NULL, 'G3DSA:2.120.10.30:FF:000050', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM56', NULL, NULL, NULL, NULL, NULL, 4),
(174920, NULL, 'G3DSA:4.10.240.10:FF:000176', NULL, NULL, 'AflR-like C6 zinc cluster transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(174921, NULL, 'G3DSA:3.60.20.10:FF:000169', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174922, NULL, 'G3DSA:3.40.30.10:FF:001103', NULL, NULL, 'Glutathione S-transferase L2 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(174923, NULL, 'G3DSA:2.60.200.20:FF:000004', NULL, NULL, 'pleckstrin homology-like domain family B member 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(174924, NULL, 'G3DSA:3.30.200.20:FF:001682', NULL, NULL, 'Mn2+-dependent serine-threonine protein kinase Signal transduction', NULL, NULL, NULL, NULL, NULL, 4),
(174925, NULL, 'G3DSA:3.60.21.10:FF:000126', NULL, NULL, 'Serine/threonine-protein phosphatase with EF-hands', NULL, NULL, NULL, NULL, NULL, 4),
(174926, NULL, 'G3DSA:1.10.10.60:FF:000072', NULL, NULL, 'Homeobox protein Hox-B8', NULL, NULL, NULL, NULL, NULL, 4),
(174927, NULL, 'G3DSA:3.20.20.70:FF:000481', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(174928, NULL, 'G3DSA:3.40.50.2300:FF:001553', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174929, NULL, 'G3DSA:3.30.40.10:FF:000975', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174930, NULL, 'G3DSA:1.10.3210.10:FF:000005', NULL, NULL, 'Bifunctional uridylyltransferase/uridylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(174931, NULL, 'G3DSA:2.30.30.140:FF:000245', NULL, NULL, 'Histone-lysine N-methyltransferase SETDB1-A', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(174932, NULL, 'G3DSA:3.80.10.10:FF:000836', NULL, NULL, 'Os08g0322500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(174933, NULL, 'G3DSA:3.30.160.60:FF:002241', NULL, NULL, 'Weckle, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(174934, NULL, 'G3DSA:3.30.160.60:FF:001959', NULL, NULL, 'Zinc finger protein 564', NULL, NULL, NULL, NULL, NULL, 4),
(174935, NULL, 'G3DSA:2.60.40.150:FF:000018', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(174936, NULL, 'G3DSA:3.40.50.300:FF:004540', NULL, NULL, 'Adenosinetriphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(174937, NULL, 'G3DSA:2.40.10.10:FF:000115', NULL, NULL, 'ORF1a polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(174938, NULL, 'G3DSA:2.10.25.10:FF:000078', NULL, NULL, 'Fibulin-1', NULL, NULL, NULL, NULL, NULL, 4),
(174939, NULL, 'G3DSA:3.90.870.10:FF:000007', NULL, NULL, 'YrdC N6-threonylcarbamoyltransferase domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(174940, NULL, 'G3DSA:2.60.120.10:FF:000517', NULL, NULL, 'cGMP-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(174941, NULL, 'G3DSA:3.20.20.105:FF:000022', NULL, NULL, 'Queuine tRNA-ribosyltransferase accessory subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(174942, NULL, 'G3DSA:3.30.450.40:FF:000211', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(174943, NULL, 'G3DSA:2.170.270.10:FF:000131', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(174944, NULL, 'G3DSA:3.20.20.80:FF:000484', NULL, NULL, 'Alpha-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(174945, NULL, 'G3DSA:3.30.230.30:FF:000001', NULL, NULL, 'IMPACT isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(174946, NULL, 'G3DSA:1.10.510.10:FF:003654', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174947, NULL, 'G3DSA:2.60.40.10:FF:005804', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174948, NULL, 'G3DSA:2.60.200.30:FF:000007', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(174949, NULL, 'G3DSA:1.10.510.10:FF:000214', NULL, NULL, 'Dual specificity mitogen-activated protein kinase kinase 7', NULL, NULL, NULL, NULL, NULL, 4),
(174950, NULL, 'G3DSA:3.40.1110.10:FF:000242', NULL, NULL, 'Cation transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(174951, NULL, 'G3DSA:1.20.120.890:FF:000001', NULL, NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', NULL, NULL, NULL, NULL, NULL, 4),
(174952, NULL, 'G3DSA:2.130.10.10:FF:005900', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174953, NULL, 'G3DSA:3.90.70.10:FF:000513', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(174954, NULL, 'G3DSA:1.10.472.170:FF:000001', NULL, NULL, 'Transcription initiation factor IIB', NULL, NULL, NULL, NULL, NULL, 4),
(174955, NULL, 'G3DSA:1.10.3520.10:FF:000012', NULL, NULL, 'Os08g0556300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(174956, NULL, 'G3DSA:2.30.29.30:FF:000917', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174957, NULL, 'G3DSA:1.20.1740.10:FF:000138', NULL, NULL, 'Solute carrier family 7 (cationic amino acid transporter, y+ system), member 2, gene 1', NULL, NULL, NULL, NULL, NULL, 4),
(174958, NULL, 'G3DSA:3.90.290.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174959, NULL, 'G3DSA:2.60.120.200:FF:000728', NULL, NULL, 'Concanavalin A-like lectin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(174960, NULL, 'G3DSA:3.30.457.60:FF:000013', NULL, NULL, 'Spindle assembly checkpoint component MAD1', NULL, NULL, NULL, NULL, NULL, 4),
(174961, NULL, 'G3DSA:1.10.8.60:FF:000447', NULL, NULL, 'Lon protease homolog 2, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(174962, NULL, 'G3DSA:1.25.40.10:FF:002021', NULL, NULL, 'Os12g0552300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(174963, NULL, 'G3DSA:3.90.70.10:FF:000300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174964, NULL, 'G3DSA:3.90.660.10:FF:000087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(174965, NULL, 'G3DSA:3.40.50.1000:FF:000522', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174966, NULL, 'G3DSA:3.30.830.10:FF:000310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174967, NULL, 'G3DSA:3.90.1200.10:FF:000029', NULL, NULL, 'GNAT family N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(174968, NULL, 'G3DSA:2.60.40.1120:FF:000060', NULL, NULL, 'Glycoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(174969, NULL, 'G3DSA:2.10.25.10:FF:000971', NULL, NULL, 'Laminin alpha 5', NULL, NULL, NULL, NULL, NULL, 4),
(174970, NULL, 'G3DSA:2.30.30.40:FF:000171', NULL, NULL, 'Nephrocystin 1', NULL, NULL, NULL, NULL, NULL, 4),
(174971, NULL, 'G3DSA:3.40.1370.10:FF:000002', NULL, NULL, '60S ribosomal protein L4', NULL, NULL, NULL, NULL, NULL, 4),
(174972, NULL, 'G3DSA:3.20.20.140:FF:000253', NULL, NULL, 'TatD related DNase', NULL, NULL, NULL, NULL, NULL, 4),
(174973, NULL, 'G3DSA:3.40.50.150:FF:000420', NULL, NULL, 'Ribosomal lysine N-methyltransferase 5', NULL, NULL, NULL, NULL, NULL, 4),
(174974, NULL, 'G3DSA:3.40.50.2020:FF:000053', NULL, NULL, 'Hypoxanthine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(174975, NULL, 'G3DSA:3.40.50.720:FF:000962', NULL, NULL, '4-hydroxy-tetrahydrodipicolinate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(174976, NULL, 'G3DSA:2.30.29.30:FF:001406', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174977, NULL, 'G3DSA:1.50.40.10:FF:000254', NULL, NULL, 'Mitochondrial carrier protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(174978, NULL, 'G3DSA:3.90.740.10:FF:000003', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(174979, NULL, 'G3DSA:1.20.1110.10:FF:000220', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174980, NULL, 'G3DSA:3.30.60.30:FF:000061', NULL, NULL, 'Follistatin, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(174981, NULL, 'G3DSA:3.30.505.10:FF:000173', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174982, NULL, 'G3DSA:2.40.70.10:FF:000321', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174983, NULL, 'G3DSA:3.30.1490.20:FF:000090', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(174984, NULL, 'G3DSA:3.30.160.60:FF:006164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174985, NULL, 'G3DSA:1.10.506.10:FF:000007', NULL, NULL, 'RAS p21 protein activator 1', NULL, NULL, NULL, NULL, NULL, 4),
(174986, NULL, 'G3DSA:2.60.40.10:FF:001853', NULL, NULL, 'fasciclin-2 isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(174987, NULL, 'G3DSA:1.10.287.1490:FF:000026', NULL, NULL, 'AGAP005583-PA', NULL, NULL, NULL, NULL, NULL, 4),
(174988, NULL, 'G3DSA:3.40.630.60:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174989, NULL, 'G3DSA:3.40.50.1000:FF:000410', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174990, NULL, 'G3DSA:2.30.29.30:FF:001171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174991, NULL, 'G3DSA:2.30.29.140:FF:000001', NULL, NULL, 'Stomatal closure-related actin-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(174992, NULL, 'G3DSA:3.10.600.10:FF:000011', NULL, NULL, 'Pyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(174993, NULL, 'G3DSA:3.15.10.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(174994, NULL, 'G3DSA:3.40.50.2300:FF:000598', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(174995, NULL, 'G3DSA:3.40.1280.30:FF:000001', NULL, NULL, 'tRNA methyltransferase 10 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(174996, NULL, 'G3DSA:3.30.450.20:FF:000672', NULL, NULL, 'Hybrid signal transduction histidine kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(174997, NULL, 'G3DSA:3.30.420.10:FF:000728', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(174998, NULL, 'G3DSA:2.130.10.10:FF:003534', NULL, NULL, 'WD40-repeat-containing domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(174999, NULL, 'G3DSA:3.20.20.470:FF:000003', NULL, NULL, 'Dextransucrase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(175000, NULL, 'G3DSA:2.10.25.10:FF:000527', NULL, NULL, 'versican core protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(175001, NULL, 'G3DSA:3.30.2410.10:FF:000008', NULL, NULL, 'Putative E3 ubiquitin-protein ligase UBR5', NULL, NULL, NULL, NULL, NULL, 4),
(175002, NULL, 'G3DSA:2.60.40.1670:FF:000005', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(175003, NULL, 'G3DSA:3.40.50.12760:FF:000014', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(175004, NULL, 'G3DSA:1.10.510.10:FF:001849', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175005, NULL, 'G3DSA:4.10.400.10:FF:000048', NULL, NULL, 'Sortilin related receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(175006, NULL, 'G3DSA:3.40.710.10:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175007, NULL, 'G3DSA:1.25.40.180:FF:000347', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175008, NULL, 'G3DSA:2.60.40.1090:FF:000039', NULL, NULL, 'Fimbrial-like adhesin protein', NULL, NULL, NULL, NULL, NULL, 4),
(175009, NULL, 'G3DSA:2.140.10.30:FF:000010', NULL, NULL, 'Prolyl oligopeptidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(175010, NULL, 'G3DSA:3.70.10.10:FF:000134', NULL, NULL, 'Checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(175011, NULL, 'G3DSA:3.40.50.620:FF:000578', NULL, NULL, 'Pantoate--beta-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(175012, NULL, 'G3DSA:1.20.140.50:FF:000010', NULL, NULL, 'BRO1-like domain/ALIX V-shaped domain binding to HIV, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175013, NULL, 'G3DSA:3.30.1360.30:FF:000004', NULL, NULL, 'tRNA synthetase class II family protein', NULL, NULL, NULL, NULL, NULL, 4),
(175014, NULL, 'G3DSA:3.40.250.10:FF:000067', NULL, NULL, 'Metallo-beta-lactamase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(175015, NULL, 'G3DSA:2.40.128.20:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175016, NULL, 'G3DSA:1.10.510.10:FF:000326', NULL, NULL, 'leucine-rich repeat serine/threonine-protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(175017, NULL, 'G3DSA:2.60.40.1220:FF:000005', NULL, NULL, 'S-layer protein sap', NULL, NULL, NULL, NULL, NULL, 4),
(175018, NULL, 'G3DSA:1.10.101.10:FF:000045', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(175019, NULL, 'G3DSA:2.40.50.140:FF:001129', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175020, NULL, 'G3DSA:2.40.100.10:FF:000150', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(175021, NULL, 'G3DSA:1.50.40.10:FF:000372', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175022, NULL, 'G3DSA:3.30.800.10:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175023, NULL, 'G3DSA:1.10.630.10:FF:000279', NULL, NULL, 'Cytochrome P450 monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175024, NULL, 'G3DSA:1.20.5.430:FF:000010', NULL, NULL, 'Uncharacterized protein C16E9.15', NULL, NULL, NULL, NULL, NULL, 4),
(175025, NULL, 'G3DSA:2.60.40.1660:FF:000002', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(175026, NULL, 'G3DSA:3.80.10.10:FF:000948', NULL, NULL, 'Centrosomal protein 78', NULL, NULL, NULL, NULL, NULL, 4),
(175027, NULL, 'G3DSA:2.60.120.260:FF:000499', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175028, NULL, 'G3DSA:3.90.1420.10:FF:000023', NULL, NULL, 'Nucleus protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175029, NULL, 'G3DSA:3.30.310.50:FF:000024', NULL, NULL, 'Phosphoacetylglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(175030, NULL, 'G3DSA:2.10.25.10:FF:001134', NULL, NULL, 'Putative wall-associated receptor protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(175031, NULL, 'G3DSA:3.30.1360.20:FF:000001', NULL, NULL, 'Pterin-4-alpha-carbinolamine dehydratase 2', NULL, NULL, NULL, NULL, NULL, 4),
(175032, NULL, 'G3DSA:2.30.29.150:FF:000004', NULL, NULL, 'FACT complex subunit SPT16', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(175033, NULL, 'G3DSA:2.40.50.140:FF:001028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175034, NULL, 'G3DSA:3.40.50.12160:FF:000042', NULL, NULL, 'Zgc:162738 protein', NULL, NULL, NULL, NULL, NULL, 4),
(175035, NULL, 'G3DSA:3.40.30.10:FF:000940', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(175036, NULL, 'G3DSA:3.60.21.10:FF:000238', NULL, NULL, 'DNA double-strand break repair protein Mre11', NULL, NULL, NULL, NULL, NULL, 4),
(175037, NULL, 'G3DSA:3.40.50.200:FF:000115', NULL, NULL, 'Tripeptidyl peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(175038, NULL, 'G3DSA:3.30.420.10:FF:000049', NULL, NULL, 'Ribonuclease H1', NULL, NULL, NULL, NULL, NULL, 4),
(175039, NULL, 'G3DSA:1.10.540.10:FF:000154', NULL, NULL, 'Acyl-CoA dehydrogenase family member 9, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(175040, NULL, 'G3DSA:3.30.40.10:FF:001251', NULL, NULL, 'Structure-specific endonuclease subunit SLX1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(175041, NULL, 'G3DSA:3.40.980.10:FF:000026', NULL, NULL, 'Competence-damage associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(175042, NULL, 'G3DSA:3.30.450.20:FF:000559', NULL, NULL, 'PAS/PAC sensor signal transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(175043, NULL, 'G3DSA:3.30.10.20:FF:000015', NULL, NULL, 'Transmembrane serine/threonine-protein kinase B', NULL, NULL, NULL, NULL, NULL, 4),
(175044, NULL, 'G3DSA:3.40.250.10:FF:000180', NULL, NULL, 'Mercaptopyruvate sulfurtransferase SseA', NULL, NULL, NULL, NULL, NULL, 4),
(175045, NULL, 'G3DSA:2.60.40.10:FF:003882', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175046, NULL, 'G3DSA:1.10.565.10:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175047, NULL, 'G3DSA:1.10.1420.10:FF:000032', NULL, NULL, 'DNA mismatch repair protein MSH2', NULL, NULL, NULL, NULL, NULL, 4),
(175048, NULL, 'G3DSA:1.10.3210.10:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175049, NULL, 'G3DSA:1.10.287.70:FF:000476', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(175050, NULL, 'G3DSA:3.40.50.2000:FF:001132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175051, NULL, 'G3DSA:3.30.342.10:FF:000047', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(175052, NULL, 'G3DSA:2.60.120.560:FF:000010', NULL, NULL, 'Glycoside hydrolase family 32 protein', NULL, NULL, NULL, NULL, NULL, 4),
(175053, NULL, 'G3DSA:3.30.70.80:FF:000003', NULL, NULL, 'Subtilisin-like protease SBT1.9', NULL, NULL, NULL, NULL, NULL, 4),
(175054, NULL, 'G3DSA:3.90.80.10:FF:000014', NULL, NULL, 'Inorganic pyrophosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175055, NULL, 'G3DSA:3.40.50.300:FF:008126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175056, NULL, 'G3DSA:1.10.510.10:FF:001754', NULL, NULL, 'Kinase, CAMK CAMK1', NULL, NULL, NULL, NULL, NULL, 4),
(175057, NULL, 'G3DSA:4.10.400.10:FF:000161', NULL, NULL, 'Terribly reduced optic lobes, isoform AZ', NULL, NULL, NULL, NULL, NULL, 4),
(175058, NULL, 'G3DSA:3.10.28.10:FF:000020', NULL, NULL, 'tRNA-splicing ligase RtcB', NULL, NULL, NULL, NULL, NULL, 4),
(175059, NULL, 'G3DSA:2.60.40.10:FF:002027', NULL, NULL, 'Tyrosine-protein kinase-like otk', NULL, NULL, NULL, NULL, NULL, 4),
(175060, NULL, 'G3DSA:3.30.200.20:FF:001356', NULL, NULL, 'Os11g0556400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(175061, NULL, 'G3DSA:1.25.40.150:FF:000006', NULL, NULL, 'V-type proton ATPase subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(175062, NULL, 'G3DSA:1.25.40.10:FF:001498', NULL, NULL, 'Pentatricopeptide repeat (PPR-like) superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(175063, NULL, 'G3DSA:2.70.150.10:FF:000303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175064, NULL, 'G3DSA:3.30.450.60:FF:000094', NULL, NULL, 'AP complex subunit sigma', NULL, NULL, NULL, NULL, NULL, 4),
(175065, NULL, 'G3DSA:2.60.40.10:FF:000330', NULL, NULL, 'Apoptosis resistant E3 ubiquitin protein ligase 1', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(175066, NULL, 'G3DSA:1.10.8.1310:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175067, NULL, 'G3DSA:1.25.40.10:FF:001178', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(175068, NULL, 'G3DSA:3.30.70.1230:FF:000004', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(175069, NULL, 'G3DSA:3.30.70.240:FF:000026', NULL, NULL, 'Elongation factor G2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(175070, NULL, 'G3DSA:1.10.1410.10:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175071, NULL, 'G3DSA:1.10.357.70:FF:000015', NULL, NULL, 'Exocyst complex component Sec6-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(175072, NULL, 'G3DSA:3.30.360.10:FF:000111', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(175073, NULL, 'G3DSA:1.10.3720.10:FF:000201', NULL, NULL, 'ABC transporter permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(175074, NULL, 'G3DSA:3.10.110.10:FF:000041', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 T', NULL, NULL, NULL, NULL, NULL, 4),
(175075, NULL, 'G3DSA:3.40.50.10810:FF:000103', NULL, NULL, 'DNA repair and recombination protein RAD54B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175076, NULL, 'G3DSA:3.10.20.30:FF:000014', NULL, NULL, 'Ferredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(175077, NULL, 'G3DSA:2.10.25.10:FF:000628', NULL, NULL, 'Wall-associated receptor kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(175078, NULL, 'G3DSA:3.40.50.300:FF:000263', NULL, NULL, 'Ras-related protein RABB1c', NULL, NULL, NULL, NULL, NULL, 4),
(175079, NULL, 'G3DSA:3.30.70.250:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175080, NULL, 'G3DSA:1.10.472.80:FF:000095', NULL, NULL, 'Rab-GTPase-TBC_domain_containing_protein', NULL, NULL, NULL, NULL, NULL, 4),
(175081, NULL, 'G3DSA:1.10.238.10:FF:000305', NULL, NULL, 'Calmodulin, variant', NULL, NULL, NULL, NULL, NULL, 4),
(175082, NULL, 'G3DSA:3.30.70.1220:FF:000001', NULL, NULL, 'General transcription factor IIH subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(175083, NULL, 'G3DSA:3.40.50.1820:FF:000785', NULL, NULL, 'Pyochelin biosynthetic protein PchC', NULL, NULL, NULL, NULL, NULL, 4),
(175084, NULL, 'G3DSA:3.40.50.800:FF:000076', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(175085, NULL, 'G3DSA:3.40.190.80:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175086, NULL, 'G3DSA:2.40.50.140:FF:001242', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175087, NULL, 'G3DSA:3.30.1490.120:FF:000015', NULL, NULL, 'AGAP012084-PA', NULL, NULL, NULL, NULL, NULL, 4),
(175088, NULL, 'G3DSA:1.10.510.10:FF:003199', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175089, NULL, 'G3DSA:2.60.120.1000:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175090, NULL, 'G3DSA:3.40.850.10:FF:000478', NULL, NULL, 'Kinesin motor domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(175091, NULL, 'G3DSA:4.10.860.120:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175092, NULL, 'G3DSA:3.90.1750.10:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175093, NULL, 'G3DSA:3.30.1140.60:FF:000002', NULL, NULL, 'F-actin-capping protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(175094, NULL, 'G3DSA:2.60.120.10:FF:000282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175095, NULL, 'G3DSA:3.40.50.10140:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175096, NULL, 'G3DSA:2.130.10.10:FF:003854', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175097, NULL, 'G3DSA:3.40.50.1100:FF:000226', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(175098, NULL, 'G3DSA:3.30.420.40:FF:000260', NULL, NULL, 'Heat shock protein 110, putative', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(175099, NULL, 'G3DSA:1.25.40.10:FF:001291', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(175100, NULL, 'G3DSA:1.10.10.540:FF:000009', NULL, NULL, 'AGAP000733-PA', NULL, NULL, NULL, NULL, NULL, 4),
(175101, NULL, 'G3DSA:3.90.79.10:FF:000050', NULL, NULL, 'Nudix hydrolase 14 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(175102, NULL, 'G3DSA:1.20.1250.20:FF:001222', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(175103, NULL, 'G3DSA:2.102.10.10:FF:000028', NULL, NULL, 'Protein TIC 55, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(175104, NULL, 'G3DSA:2.130.10.10:FF:001488', NULL, NULL, 'WD domain, G-beta repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(175105, NULL, 'G3DSA:3.30.160.60:FF:000442', NULL, NULL, 'Zinc finger and AT-hook domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(175106, NULL, 'G3DSA:1.10.630.10:FF:000487', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175107, NULL, 'G3DSA:2.110.10.10:FF:000033', NULL, NULL, 'Matrix metallopeptidase 28', NULL, NULL, NULL, NULL, NULL, 4),
(175108, NULL, 'G3DSA:3.30.530.20:FF:000026', NULL, NULL, 'Homeobox-leucine zipper protein GLABRA 2', NULL, NULL, NULL, NULL, NULL, 4),
(175109, NULL, 'G3DSA:3.30.70.3160:FF:000004', NULL, NULL, 'tRNA pseudouridine synthase D', NULL, NULL, NULL, NULL, NULL, 4),
(175110, NULL, 'G3DSA:1.20.1560.10:FF:000832', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175111, NULL, 'G3DSA:3.20.20.60:FF:000034', NULL, NULL, 'Pyruvate kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(175112, NULL, 'G3DSA:2.40.170.20:FF:000101', NULL, NULL, 'SusC homolog', NULL, NULL, NULL, NULL, NULL, 4),
(175113, NULL, 'G3DSA:3.30.70.3150:FF:000001', NULL, NULL, 'Eukaryotic translation initiation factor 2 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(175114, NULL, 'G3DSA:1.50.40.10:FF:000580', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(175115, NULL, 'G3DSA:3.30.9.10:FF:000239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175116, NULL, 'G3DSA:2.60.40.10:FF:004270', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175117, NULL, 'G3DSA:3.40.50.2300:FF:001115', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175118, NULL, 'G3DSA:3.30.160.60:FF:001639', NULL, NULL, 'Si:dkey-7i4.21', NULL, NULL, NULL, NULL, NULL, 4),
(175119, NULL, 'G3DSA:3.40.50.300:FF:000600', NULL, NULL, 'Nuclear valosin-containing protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(175120, NULL, 'G3DSA:1.20.1560.10:FF:000944', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175121, NULL, 'G3DSA:1.10.10.10:FF:001945', NULL, NULL, 'Protein CBG00836', NULL, NULL, NULL, NULL, NULL, 4),
(175122, NULL, 'G3DSA:3.20.20.220:FF:000046', NULL, NULL, 'Proline dehydrogenase / 1-pyrroline-5-carboxylate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(175123, NULL, 'G3DSA:3.40.920.10:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175124, NULL, 'G3DSA:4.10.400.10:FF:000262', NULL, NULL, 'complement component C9', NULL, NULL, NULL, NULL, NULL, 4),
(175125, NULL, 'G3DSA:1.20.1310.10:FF:000201', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175126, NULL, 'G3DSA:3.40.50.1010:FF:000188', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175127, NULL, 'G3DSA:2.130.10.10:FF:005872', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175128, NULL, 'G3DSA:3.90.700.10:FF:000006', NULL, NULL, 'Succinate dehydrogenase flavoprotein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(175129, NULL, 'G3DSA:3.80.10.10:FF:004439', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', NULL, NULL, NULL, NULL, NULL, 4),
(175130, NULL, 'G3DSA:3.30.70.1230:FF:000088', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(175131, NULL, 'G3DSA:1.10.560.10:FF:000043', NULL, NULL, 'Heat shock protein family D (Hsp60) member 1', NULL, NULL, NULL, NULL, NULL, 4),
(175132, NULL, 'G3DSA:1.10.220.50:FF:000001', NULL, NULL, 'Loader of gp41 DNA helicase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(175133, NULL, 'G3DSA:3.50.50.60:FF:000978', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(175134, NULL, 'G3DSA:1.10.238.10:FF:000406', NULL, NULL, 'Calcium channel subunit Cch1', NULL, NULL, NULL, NULL, NULL, 4),
(175135, NULL, 'G3DSA:1.10.8.60:FF:000560', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(175136, NULL, 'G3DSA:3.40.50.620:FF:000477', NULL, NULL, 'Asparagine synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175137, NULL, 'G3DSA:3.40.50.1820:FF:001622', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175138, NULL, 'G3DSA:3.90.1170.20:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175139, NULL, 'G3DSA:3.80.10.10:FF:003242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175140, NULL, 'G3DSA:1.10.565.10:FF:000026', NULL, NULL, 'Hepatocyte nuclear factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(175141, NULL, 'G3DSA:1.10.540.10:FF:000042', NULL, NULL, 'Putative acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(175142, NULL, 'G3DSA:1.20.1280.50:FF:000215', NULL, NULL, 'F-box/WD repeat-containing protein 4-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(175143, NULL, 'G3DSA:3.40.50.300:FF:007188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175144, NULL, 'G3DSA:1.20.1070.10:FF:001121', NULL, NULL, 'Beta-1 adrenergic receptor', NULL, NULL, NULL, NULL, NULL, 4),
(175145, NULL, 'G3DSA:1.20.1250.40:FF:000031', NULL, NULL, 'DNA-directed RNA polymerases II subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175146, NULL, 'G3DSA:1.10.8.50:FF:000006', NULL, NULL, 'DNA topoisomerase 6 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(175147, NULL, 'G3DSA:2.130.10.10:FF:001393', NULL, NULL, 'Elongator complex protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(175148, NULL, 'G3DSA:3.40.50.150:FF:001589', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175149, NULL, 'G3DSA:2.130.10.10:FF:002011', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(175150, NULL, 'G3DSA:3.40.20.10:FF:000119', NULL, NULL, 'Protein transport protein Sec24-like CEF', NULL, NULL, NULL, NULL, NULL, 4),
(175151, NULL, 'G3DSA:2.60.120.1040:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175152, NULL, 'G3DSA:3.30.565.10:FF:000401', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(175153, NULL, 'G3DSA:1.25.40.20:FF:000321', NULL, NULL, 'No mechanoreceptor potential C, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(175154, NULL, 'G3DSA:3.30.40.210:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175155, NULL, 'G3DSA:3.40.50.12060:FF:000001', NULL, NULL, 'Rif2p', NULL, NULL, NULL, NULL, NULL, 4),
(175156, NULL, 'G3DSA:3.30.200.20:FF:000041', NULL, NULL, 'Vascular endothelial growth factor receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(175157, NULL, 'G3DSA:2.130.10.130:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175158, NULL, 'G3DSA:2.60.40.1730:FF:000052', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(175159, NULL, 'G3DSA:2.60.120.290:FF:000249', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(175160, NULL, 'G3DSA:3.30.200.20:FF:001244', NULL, NULL, 'Serine/threonine-protein kinase ATG1c', NULL, NULL, NULL, NULL, NULL, 4),
(175161, NULL, 'G3DSA:1.25.40.10:FF:003752', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g31850, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(175162, NULL, 'G3DSA:1.20.120.350:FF:000081', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(175163, NULL, 'G3DSA:2.130.10.10:FF:002106', NULL, NULL, 'Polyadenylation factor subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(175164, NULL, 'G3DSA:3.90.640.10:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175165, NULL, 'G3DSA:3.40.630.30:FF:000366', NULL, NULL, 'Putative exported protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(175166, NULL, 'G3DSA:3.90.550.10:FF:000421', NULL, NULL, 'Bifunctional phosphatase/dolichol-phosphate glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(175167, NULL, 'G3DSA:2.160.20.20:FF:000006', NULL, NULL, 'Antigen 43', NULL, NULL, NULL, NULL, NULL, 4),
(175168, NULL, 'G3DSA:3.30.300.150:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175169, NULL, 'G3DSA:1.20.1640.10:FF:000080', NULL, NULL, 'Putative multidrug resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(175170, NULL, 'G3DSA:1.10.8.60:FF:000009', NULL, NULL, '26S protease regulatory subunit 6A', NULL, NULL, NULL, NULL, NULL, 4),
(175171, NULL, 'G3DSA:3.30.70.100:FF:000125', NULL, NULL, 'Probable copper-exporting P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(175172, NULL, 'G3DSA:1.10.10.10:FF:000321', NULL, NULL, 'DNA-binding transcriptional repressor LldR', NULL, NULL, NULL, NULL, NULL, 4),
(175173, NULL, 'G3DSA:1.10.630.10:FF:000392', NULL, NULL, 'Cytochrome P450, putative (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(175174, NULL, 'G3DSA:3.90.550.10:FF:000303', NULL, NULL, 'Dolichyl-phosphate beta-glucosyltransferase ALG5D', NULL, NULL, NULL, NULL, NULL, 4),
(175175, NULL, 'G3DSA:3.30.1120.10:FF:000003', NULL, NULL, 'Arylsulfatase A', NULL, NULL, NULL, NULL, NULL, 4),
(175176, NULL, 'G3DSA:1.10.3090.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175177, NULL, 'G3DSA:3.10.20.90:FF:000335', NULL, NULL, 'UBX domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(175178, NULL, 'G3DSA:3.40.50.300:FF:008025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175179, NULL, 'G3DSA:2.40.290.10:FF:000039', NULL, NULL, 'DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(175180, NULL, 'G3DSA:1.20.930.40:FF:000022', NULL, NULL, 'YALI0B05258p', NULL, NULL, NULL, NULL, NULL, 4),
(175181, NULL, 'G3DSA:1.25.10.10:FF:001575', NULL, NULL, 'Zgc:136656 protein', NULL, NULL, NULL, NULL, NULL, 4),
(175182, NULL, 'G3DSA:3.40.50.12360:FF:000001', NULL, NULL, 'HDA1 complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(175183, NULL, 'G3DSA:1.10.287.70:FF:000375', NULL, NULL, 'Glutamate receptor, ionotropic, N-methyl D-aspartate 2D, b', NULL, NULL, NULL, NULL, NULL, 4),
(175184, NULL, 'G3DSA:2.60.40.10:FF:002128', NULL, NULL, 'Sucrose-6-phosphate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(175185, NULL, 'G3DSA:1.10.287.550:FF:000007', NULL, NULL, 'Arylsulfatase H', NULL, NULL, NULL, NULL, NULL, 4),
(175186, NULL, 'G3DSA:1.10.220.60:FF:000004', NULL, NULL, 'GG17233', NULL, NULL, NULL, NULL, NULL, 4),
(175187, NULL, 'G3DSA:2.10.220.10:FF:000143', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(175188, NULL, 'G3DSA:3.40.50.1000:FF:000067', NULL, NULL, 'HAD phosphatase, family IIIA', NULL, NULL, NULL, NULL, NULL, 4),
(175189, NULL, 'G3DSA:2.30.30.100:FF:000149', NULL, NULL, 'Small nuclear ribonucleoprotein f, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175190, NULL, 'G3DSA:3.30.70.1670:FF:000001', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase subunit PurL', NULL, NULL, NULL, NULL, NULL, 4),
(175191, NULL, 'G3DSA:3.50.50.60:FF:001243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175192, NULL, 'G3DSA:2.60.200.20:FF:000105', NULL, NULL, 'Nibrin', NULL, NULL, NULL, NULL, NULL, 4),
(175193, NULL, 'G3DSA:3.20.20.70:FF:000380', NULL, NULL, '7-carboxy-7-deazaguanine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(175194, NULL, 'G3DSA:3.30.40.10:FF:001604', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175195, NULL, 'G3DSA:3.50.50.60:FF:001473', NULL, NULL, '3-oxo-5-alpha-steroid 4-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(175196, NULL, 'G3DSA:1.20.1280.50:FF:000204', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(175197, NULL, 'G3DSA:2.60.120.200:FF:000279', NULL, NULL, 'Os09g0251100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(175198, NULL, 'G3DSA:3.50.30.30:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(175199, NULL, 'G3DSA:2.60.40.10:FF:000436', NULL, NULL, 'Neural cell adhesion molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(175200, NULL, 'G3DSA:2.40.33.10:FF:000022', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(175201, NULL, 'G3DSA:3.30.160.60:FF:003876', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175202, NULL, 'G3DSA:1.20.1300.10:FF:000032', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit A, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(175203, NULL, 'G3DSA:1.20.58.1120:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175204, NULL, 'G3DSA:2.80.10.50:FF:000108', NULL, NULL, 'Protein frg1', NULL, NULL, NULL, NULL, NULL, 4),
(175205, NULL, 'G3DSA:3.20.20.80:FF:000383', NULL, NULL, 'Lactase', NULL, NULL, NULL, NULL, NULL, 4),
(175206, NULL, 'G3DSA:3.20.20.70:FF:000722', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175207, NULL, 'G3DSA:1.10.418.10:FF:000050', NULL, NULL, 'nesprin-2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(175208, NULL, 'G3DSA:1.10.10.10:FF:002007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175209, NULL, 'G3DSA:3.10.310.20:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175210, NULL, 'G3DSA:1.20.58.830:FF:000023', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(175211, NULL, 'G3DSA:2.10.220.10:FF:000132', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(175212, NULL, 'G3DSA:1.10.1420.10:FF:000043', NULL, NULL, 'MutS homolog 4', NULL, NULL, NULL, NULL, NULL, 4),
(175213, NULL, 'G3DSA:3.90.1480.20:FF:000018', NULL, NULL, 'Sialyltransferase, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(175214, NULL, 'G3DSA:1.20.1280.50:FF:000092', NULL, NULL, 'F-box protein At5g67140', NULL, NULL, NULL, NULL, NULL, 4),
(175215, NULL, 'G3DSA:2.60.120.970:FF:000026', NULL, NULL, 'Growth differentiation factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(175216, NULL, 'G3DSA:3.90.1420.10:FF:000012', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(175217, NULL, 'G3DSA:3.30.505.10:FF:000061', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(175218, NULL, 'G3DSA:1.25.40.990:FF:000022', NULL, NULL, 'YPR045C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(175219, NULL, 'G3DSA:3.20.20.80:FF:000725', NULL, NULL, 'Amylo-1, 6-glucosidase, 4-alpha-glucanotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(175220, NULL, 'G3DSA:3.50.50.60:FF:000967', NULL, NULL, 'Prolycopene isomerase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(175221, NULL, 'G3DSA:1.25.10.10:FF:002070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175222, NULL, 'G3DSA:1.25.10.10:FF:001564', NULL, NULL, 'Meiotic PUF family protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(175223, NULL, 'G3DSA:3.30.160.60:FF:005776', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175224, NULL, 'G3DSA:4.10.75.10:FF:000003', NULL, NULL, 'WAP four-disulfide core domain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(175225, NULL, 'G3DSA:3.40.50.300:FF:002174', NULL, NULL, 'ATP-dependent RNA helicase DBP3', NULL, NULL, NULL, NULL, NULL, 4),
(175226, NULL, 'G3DSA:3.40.50.10090:FF:000062', NULL, NULL, 'Uroporphyrin-III C-methyltransferase/uroporphyrinogen-III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(175227, NULL, 'G3DSA:3.30.800.10:FF:000016', NULL, NULL, 'Phosphoinositide kinase putative', NULL, NULL, NULL, NULL, NULL, 4),
(175228, NULL, 'G3DSA:3.30.1600.10:FF:000028', NULL, NULL, 'NAD-dependent protein deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(175229, NULL, 'G3DSA:3.30.70.330:FF:001700', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175230, NULL, 'G3DSA:3.30.460.90:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175231, NULL, 'G3DSA:1.25.40.10:FF:003089', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At1g28020', NULL, NULL, NULL, NULL, NULL, 4),
(175232, NULL, 'G3DSA:3.40.50.150:FF:000515', NULL, NULL, 'Asparaginyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(175233, NULL, 'G3DSA:2.30.29.30:FF:000676', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175234, NULL, 'G3DSA:2.130.10.10:FF:000420', NULL, NULL, 'WD repeat-containing protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(175235, NULL, 'G3DSA:2.130.10.10:FF:004017', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(175236, NULL, 'G3DSA:3.90.760.10:FF:000004', NULL, NULL, 'Flavocytochrome C sulfide dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(175237, NULL, 'G3DSA:3.90.1750.10:FF:000008', NULL, NULL, 'Putative ubiquitin-protein ligase E3A', NULL, NULL, NULL, NULL, NULL, 4),
(175238, NULL, 'G3DSA:3.40.50.450:FF:000049', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(175239, NULL, 'G3DSA:1.20.120.1760:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175240, NULL, 'G3DSA:3.30.160.60:FF:002123', NULL, NULL, 'C2H2 transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175241, NULL, 'G3DSA:3.40.20.10:FF:000097', NULL, NULL, 'Gelsolin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(175242, NULL, 'G3DSA:3.30.460.80:FF:000010', NULL, NULL, 'Proton-translocating NADH-quinone oxidoreductase, C subunit', NULL, NULL, NULL, NULL, NULL, 4),
(175243, NULL, 'G3DSA:3.30.40.10:FF:001363', NULL, NULL, 'Probable E3 ubiquitin-protein ligase WAVH2', NULL, NULL, NULL, NULL, NULL, 4),
(175244, NULL, 'G3DSA:3.90.1440.10:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175245, NULL, 'G3DSA:3.90.70.80:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175246, NULL, 'G3DSA:2.10.60.10:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175247, NULL, 'G3DSA:3.40.50.300:FF:001898', NULL, NULL, 'Dynein beta chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175248, NULL, 'G3DSA:3.30.160.60:FF:004152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175249, NULL, 'G3DSA:2.10.25.10:FF:001342', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(175250, NULL, 'G3DSA:3.40.50.2300:FF:001435', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175251, NULL, 'G3DSA:3.30.70.330:FF:001475', NULL, NULL, 'GM17146', NULL, NULL, NULL, NULL, NULL, 4),
(175252, NULL, 'G3DSA:2.60.40.10:FF:003764', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175253, NULL, 'G3DSA:3.30.9.10:FF:000133', NULL, NULL, 'D-amino acid oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(175254, NULL, 'G3DSA:1.25.40.10:FF:003544', NULL, NULL, 'YALI0E30217p', NULL, NULL, NULL, NULL, NULL, 4),
(175255, NULL, 'G3DSA:3.30.160.60:FF:004253', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175256, NULL, 'G3DSA:3.40.710.10:FF:000086', NULL, NULL, 'Probable lipase lipe', NULL, NULL, NULL, NULL, NULL, 4),
(175257, NULL, 'G3DSA:1.10.10.1450:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175258, NULL, 'G3DSA:2.130.10.10:FF:001943', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175259, NULL, 'G3DSA:3.30.160.60:FF:001847', NULL, NULL, 'Zinc finger and BTB domain containing 11', NULL, NULL, NULL, NULL, NULL, 4),
(175260, NULL, 'G3DSA:3.90.1290.10:FF:000080', NULL, NULL, 'Dystonin', NULL, NULL, NULL, NULL, NULL, 4),
(175261, NULL, 'G3DSA:3.30.160.60:FF:003977', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175262, NULL, 'G3DSA:3.20.20.140:FF:000365', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175263, NULL, 'G3DSA:3.40.190.10:FF:000011', NULL, NULL, 'ATP phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(175264, NULL, 'G3DSA:3.90.70.10:FF:000064', NULL, NULL, 'calpain-6', NULL, NULL, NULL, NULL, NULL, 4),
(175265, NULL, 'G3DSA:1.25.40.10:FF:001392', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(175266, NULL, 'G3DSA:2.60.40.10:FF:005916', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175267, NULL, 'G3DSA:1.20.1070.10:FF:000637', NULL, NULL, '5-hydroxytryptamine receptor 2B isoform X2', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(175268, NULL, 'G3DSA:1.10.510.10:FF:001288', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175269, NULL, 'G3DSA:2.60.40.10:FF:004040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175270, NULL, 'G3DSA:3.40.50.300:FF:000145', NULL, NULL, 'probable ATP-dependent RNA helicase DHX40', NULL, NULL, NULL, NULL, NULL, 4),
(175271, NULL, 'G3DSA:2.60.120.920:FF:000157', NULL, NULL, 'Si:dkey-172k15.6', NULL, NULL, NULL, NULL, NULL, 4),
(175272, NULL, 'G3DSA:3.40.30.10:FF:000277', NULL, NULL, 'Probable nadh-ubiquinone oxidoreductase 10.5 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(175273, NULL, 'G3DSA:2.60.120.10:FF:000635', NULL, NULL, 'Glr1108 protein', NULL, NULL, NULL, NULL, NULL, 4),
(175274, NULL, 'G3DSA:1.25.40.120:FF:000026', NULL, NULL, 'FarNesylTransferase, Alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(175275, NULL, 'G3DSA:3.40.1110.10:FF:000450', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175276, NULL, 'G3DSA:1.20.140.150:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175277, NULL, 'G3DSA:3.30.710.10:FF:000268', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(175278, NULL, 'G3DSA:3.90.640.10:FF:000086', NULL, NULL, 'Actin-related protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(175279, NULL, 'G3DSA:3.40.630.30:FF:000265', NULL, NULL, 'Acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175280, NULL, 'G3DSA:3.40.50.1360:FF:000046', NULL, NULL, 'Probable 6-phosphogluconolactonase', NULL, NULL, NULL, NULL, NULL, 4),
(175281, NULL, 'G3DSA:1.20.1740.10:FF:000037', NULL, NULL, 'Uncharacterized protein, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(175282, NULL, 'G3DSA:3.40.605.10:FF:000066', NULL, NULL, 'Alh-11', NULL, NULL, NULL, NULL, NULL, 4),
(175283, NULL, 'G3DSA:3.30.1430.10:FF:000004', NULL, NULL, '60S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(175284, NULL, 'G3DSA:2.60.120.820:FF:000009', NULL, NULL, 'E3 ubiquitin-protein ligase rpm-1', NULL, NULL, NULL, NULL, NULL, 4),
(175285, NULL, 'G3DSA:1.10.357.70:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175286, NULL, 'G3DSA:3.30.160.60:FF:002353', NULL, NULL, 'Zinc finger protein 646', NULL, NULL, NULL, NULL, NULL, 4),
(175287, NULL, 'G3DSA:2.60.40.2300:FF:000009', NULL, NULL, 'neutral ceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(175288, NULL, 'G3DSA:3.30.1370.100:FF:000011', NULL, NULL, 'Mismatch repair protein PMS1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175289, NULL, 'G3DSA:3.30.70.330:FF:001930', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175290, NULL, 'G3DSA:3.60.21.10:FF:000031', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(175291, NULL, 'G3DSA:1.10.10.10:FF:002108', NULL, NULL, 'Forkhead box P, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(175292, NULL, 'G3DSA:1.25.40.10:FF:005343', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(175293, NULL, 'G3DSA:3.30.160.60:FF:006052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175294, NULL, 'G3DSA:1.10.240.10:FF:000013', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(175295, NULL, 'G3DSA:3.40.50.1000:FF:000421', NULL, NULL, 'HAD superfamily hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(175296, NULL, 'G3DSA:3.90.228.10:FF:000004', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(175297, NULL, 'G3DSA:2.60.40.10:FF:005905', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175298, NULL, 'G3DSA:3.10.580.10:FF:000183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175299, NULL, 'G3DSA:2.60.120.40:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175300, NULL, 'G3DSA:1.10.150.850:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175301, NULL, 'G3DSA:1.20.58.60:FF:000794', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175302, NULL, 'G3DSA:3.30.160.60:FF:003438', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(175303, NULL, 'G3DSA:3.30.1330.30:FF:000053', NULL, NULL, '50S ribosomal protein L30e', NULL, NULL, NULL, NULL, NULL, 4),
(175304, NULL, 'G3DSA:3.40.1110.10:FF:000337', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175305, NULL, 'G3DSA:1.10.10.60:FF:001269', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175306, NULL, 'G3DSA:3.30.1330.40:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175307, NULL, 'G3DSA:2.30.39.10:FF:000058', NULL, NULL, 'Putative serpin A13', NULL, NULL, NULL, NULL, NULL, 4),
(175308, NULL, 'G3DSA:3.30.1330.20:FF:000050', NULL, NULL, 'Tubulin beta', NULL, NULL, NULL, NULL, NULL, 4),
(175309, NULL, 'G3DSA:1.10.8.10:FF:000343', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175310, NULL, 'G3DSA:1.10.10.10:FF:001844', NULL, NULL, 'RPS10-NUDT3 readthrough', NULL, NULL, NULL, NULL, NULL, 4),
(175311, NULL, 'G3DSA:3.30.420.40:FF:000030', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(175312, NULL, 'G3DSA:2.10.70.10:FF:000137', NULL, NULL, 'Beta-microseminoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(175313, NULL, 'G3DSA:3.10.20.90:FF:000234', NULL, NULL, 'Ubiquitin D', NULL, NULL, NULL, NULL, NULL, 4),
(175314, NULL, 'G3DSA:3.90.980.20:FF:000001', NULL, NULL, 'metal-response element-binding transcription factor 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(175315, NULL, 'G3DSA:3.80.10.10:FF:001443', NULL, NULL, 'ELRR (Extracellular Leucine-Rich Repeat) ONly', NULL, NULL, NULL, NULL, NULL, 4),
(175316, NULL, 'G3DSA:3.40.30.10:FF:000502', NULL, NULL, 'Maleylacetoacetate isomerase/glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(175317, NULL, 'G3DSA:3.30.1640.10:FF:000025', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(175318, NULL, 'G3DSA:1.20.1560.10:FF:000933', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175319, NULL, 'G3DSA:3.40.50.410:FF:000296', NULL, NULL, 'Ubiquitin interaction motif family protein', NULL, NULL, NULL, NULL, NULL, 4),
(175320, NULL, 'G3DSA:4.10.240.10:FF:000064', NULL, NULL, 'WGS project CABT00000000 data, contig 2.7', NULL, NULL, NULL, NULL, NULL, 4),
(175321, NULL, 'G3DSA:3.40.720.10:FF:000266', NULL, NULL, 'Iduronate-2-sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(175322, NULL, 'G3DSA:3.30.300.30:FF:000097', NULL, NULL, 'Nonribosomal peptide synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175323, NULL, 'G3DSA:2.130.10.10:FF:005883', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175324, NULL, 'G3DSA:1.25.40.10:FF:002116', NULL, NULL, 'Heat shock protein 70 (HSP70)-interacting protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175325, NULL, 'G3DSA:3.30.1300.30:FF:000006', NULL, NULL, 'Type II secretion system protein I', NULL, NULL, NULL, NULL, NULL, 4),
(175326, NULL, 'G3DSA:1.10.510.10:FF:000006', NULL, NULL, 'Serine/threonine-protein kinase WNK1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(175327, NULL, 'G3DSA:1.10.150.450:FF:000001', NULL, NULL, 'SDT1p Pyrimidine nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(175328, NULL, 'G3DSA:1.25.10.10:FF:002401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175329, NULL, 'G3DSA:3.40.50.2020:FF:000148', NULL, NULL, 'Adenine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(175330, NULL, 'G3DSA:2.60.120.10:FF:000405', NULL, NULL, 'cGMP-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(175331, NULL, 'G3DSA:1.20.5.190:FF:000022', NULL, NULL, 'Unconventional myosin-IXb', NULL, NULL, NULL, NULL, NULL, 4),
(175332, NULL, 'G3DSA:1.10.260.60:FF:000001', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', NULL, NULL, NULL, NULL, NULL, 4),
(175333, NULL, 'G3DSA:3.30.40.10:FF:001043', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(175334, NULL, 'G3DSA:2.60.40.10:FF:001864', NULL, NULL, 'Ferredoxin, 4Fe-4S bacterial type', NULL, NULL, NULL, NULL, NULL, 4),
(175335, NULL, 'G3DSA:2.20.28.10:FF:000005', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(175336, NULL, 'G3DSA:2.30.180.10:FF:000106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175337, NULL, 'G3DSA:3.40.30.10:FF:000732', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(175338, NULL, 'G3DSA:3.90.190.10:FF:000449', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175339, NULL, 'G3DSA:1.20.58.390:FF:000312', NULL, NULL, 'Protein CBG01449', NULL, NULL, NULL, NULL, NULL, 4),
(175340, NULL, 'G3DSA:3.80.10.10:FF:000628', NULL, NULL, 'F-box and leucine-rich repeat protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(175341, NULL, 'G3DSA:1.20.120.1560:FF:000001', NULL, NULL, 'Type-3 glutamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(175342, NULL, 'G3DSA:3.40.50.720:FF:001333', NULL, NULL, 'Dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(175343, NULL, 'G3DSA:3.30.60.30:FF:000072', NULL, NULL, 'Agrin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175344, NULL, 'G3DSA:3.40.710.10:FF:000108', NULL, NULL, 'Beta-lactamase', NULL, NULL, NULL, NULL, NULL, 4),
(175345, NULL, 'G3DSA:3.40.50.150:FF:001488', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175346, NULL, 'G3DSA:3.80.10.10:FF:004338', NULL, NULL, 'Slit guidance ligand 3', NULL, NULL, NULL, NULL, NULL, 4),
(175347, NULL, 'G3DSA:3.40.50.300:FF:006226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175348, NULL, 'G3DSA:3.30.505.10:FF:000072', NULL, NULL, 'SH2 domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(175349, NULL, 'G3DSA:3.40.50.300:FF:003798', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(175350, NULL, 'G3DSA:2.60.40.1090:FF:000028', NULL, NULL, 'Fimbrial adhesin FimH', NULL, NULL, NULL, NULL, NULL, 4),
(175351, NULL, 'G3DSA:2.40.50.140:FF:000865', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175352, NULL, 'G3DSA:2.60.120.10:FF:000293', NULL, NULL, 'Transcription regulator, Crp family', NULL, NULL, NULL, NULL, NULL, 4),
(175353, NULL, 'G3DSA:2.30.29.30:FF:001182', NULL, NULL, 'BEACH domain-containing protein lvsD', NULL, NULL, NULL, NULL, NULL, 4),
(175354, NULL, 'G3DSA:3.40.50.790:FF:000033', NULL, NULL, '54S ribosomal protein L1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(175355, NULL, 'G3DSA:2.60.220.30:FF:000008', NULL, NULL, 'SH3 domain-binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(175356, NULL, 'G3DSA:3.65.10.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175357, NULL, 'G3DSA:1.25.40.20:FF:000551', NULL, NULL, 'Calmodulin-binding transcription activator 3', NULL, NULL, NULL, NULL, NULL, 4),
(175358, NULL, 'G3DSA:1.20.58.2220:FF:000062', NULL, NULL, 'Formin-G', NULL, NULL, NULL, NULL, NULL, 4),
(175359, NULL, 'G3DSA:3.40.50.11350:FF:000018', NULL, NULL, 'alpha-(1,6)-fucosyltransferase-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(175360, NULL, 'G3DSA:1.20.1250.20:FF:001109', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(175361, NULL, 'G3DSA:3.30.160.20:FF:000228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175362, NULL, 'G3DSA:1.10.3580.10:FF:000004', NULL, NULL, 'ATP12-like chaperone protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175363, NULL, 'G3DSA:3.20.20.70:FF:000267', NULL, NULL, 'Glycerol uptake operon antiterminator regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(175364, NULL, 'G3DSA:3.40.50.300:FF:005833', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175365, NULL, 'G3DSA:3.30.200.20:FF:001564', NULL, NULL, 'Probable cyclin-dependent serine/threonine-protein kinase DDB_G0292550', NULL, NULL, NULL, NULL, NULL, 4),
(175366, NULL, 'G3DSA:3.40.640.10:FF:000310', NULL, NULL, 'Similar to aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(175367, NULL, 'G3DSA:3.40.50.800:FF:000087', NULL, NULL, 'Histidyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(175368, NULL, 'G3DSA:1.20.1110.10:FF:000107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175369, NULL, 'G3DSA:3.40.50.1820:FF:000908', NULL, NULL, 'Acetylcholinesterase 2 precursor, putative', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(175370, NULL, 'G3DSA:3.40.1380.20:FF:000051', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(175371, NULL, 'G3DSA:1.10.8.60:FF:000329', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(175372, NULL, 'G3DSA:1.10.10.10:FF:000310', NULL, NULL, 'Bloom syndrome RecQ-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(175373, NULL, 'G3DSA:3.30.70.1230:FF:000212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175374, NULL, 'G3DSA:3.40.50.11340:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175375, NULL, 'G3DSA:1.10.510.10:FF:003772', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175376, NULL, 'G3DSA:1.10.20.10:FF:000136', NULL, NULL, 'Histone H2B', NULL, NULL, NULL, NULL, NULL, 4),
(175377, NULL, 'G3DSA:3.40.50.300:FF:000706', NULL, NULL, 'Cytoplasmic dynein 2 heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(175378, NULL, 'G3DSA:1.10.3090.10:FF:000017', NULL, NULL, 'Polynucleotide adenylyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(175379, NULL, 'G3DSA:1.25.10.10:FF:000147', NULL, NULL, 'exportin-6 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(175380, NULL, 'G3DSA:1.20.1170.10:FF:000004', NULL, NULL, 'Hemolysin E, chromosomal', NULL, NULL, NULL, NULL, NULL, 4),
(175381, NULL, 'G3DSA:1.10.10.10:FF:001283', NULL, NULL, 'Transcriptional regulator, ArsR family', NULL, NULL, NULL, NULL, NULL, 4),
(175382, NULL, 'G3DSA:1.10.150.110:FF:000017', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(175383, NULL, 'G3DSA:1.20.1560.10:FF:000591', NULL, NULL, 'Os01g0534700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(175384, NULL, 'G3DSA:3.30.559.30:FF:000016', NULL, NULL, 'Peptide synthetase mbtE', NULL, NULL, NULL, NULL, NULL, 4),
(175385, NULL, 'G3DSA:3.40.50.300:FF:004074', NULL, NULL, 'UvrD/REP helicase N-terminal domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(175386, NULL, 'G3DSA:3.10.290.10:FF:000082', NULL, NULL, '30S ribosomal protein S4', NULL, NULL, NULL, NULL, NULL, 4),
(175387, NULL, 'G3DSA:3.30.420.80:FF:000013', NULL, NULL, 'Mitochondrial ribosomal protein S11', NULL, NULL, NULL, NULL, NULL, 4),
(175388, NULL, 'G3DSA:3.30.750.44:FF:000014', NULL, NULL, 'Carboxy-terminal processing protease', NULL, NULL, NULL, NULL, NULL, 4),
(175389, NULL, 'G3DSA:2.130.10.10:FF:002117', NULL, NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', NULL, NULL, NULL, NULL, NULL, 4),
(175390, NULL, 'G3DSA:3.30.160.60:FF:000004', NULL, NULL, 'zinc finger protein 184 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(175391, NULL, 'G3DSA:1.10.3450.20:FF:000003', NULL, NULL, 'Nuclear pore complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(175392, NULL, 'G3DSA:2.60.40.10:FF:005793', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175393, NULL, 'G3DSA:3.30.365.10:FF:000083', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(175394, NULL, 'G3DSA:3.30.70.980:FF:000023', NULL, NULL, 'DUF28 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(175395, NULL, 'G3DSA:3.40.50.300:FF:004203', NULL, NULL, 'Putative RAD51D', NULL, NULL, NULL, NULL, NULL, 4),
(175396, NULL, 'G3DSA:2.40.10.230:FF:000007', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(175397, NULL, 'G3DSA:1.10.287.70:FF:000717', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(175398, NULL, 'G3DSA:3.30.559.30:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175399, NULL, 'G3DSA:2.40.10.220:FF:000004', NULL, NULL, 'Cyclic diguanosine monophosphate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(175400, NULL, 'G3DSA:1.20.1250.40:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175401, NULL, 'G3DSA:3.40.50.2000:FF:000963', NULL, NULL, 'Os01g0869400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(175402, NULL, 'G3DSA:3.30.40.10:FF:000874', NULL, NULL, 'E3 ubiquitin-protein ligase RHF1A', NULL, NULL, NULL, NULL, NULL, 4),
(175403, NULL, 'G3DSA:1.20.1560.10:FF:000377', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(175404, NULL, 'G3DSA:3.30.420.10:FF:000386', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175405, NULL, 'G3DSA:2.60.40.10:FF:005349', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175406, NULL, 'G3DSA:2.30.30.140:FF:000346', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(175407, NULL, 'G3DSA:3.40.50.1820:FF:001381', NULL, NULL, 'Phospholipase ABHD3', NULL, NULL, NULL, NULL, NULL, 4),
(175408, NULL, 'G3DSA:1.10.472.130:FF:000023', NULL, NULL, 'Dynein heavy chain 10, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(175409, NULL, 'G3DSA:3.40.50.10330:FF:000049', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(175410, NULL, 'G3DSA:3.30.160.60:FF:005905', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175411, NULL, 'G3DSA:1.10.1270.10:FF:000003', NULL, NULL, 'Trp operon repressor', NULL, NULL, NULL, NULL, NULL, 4),
(175412, NULL, 'G3DSA:1.10.10.10:FF:001277', NULL, NULL, 'ForKHead transcription factor family', NULL, NULL, NULL, NULL, NULL, 4),
(175413, NULL, 'G3DSA:1.25.10.10:FF:003481', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175414, NULL, 'G3DSA:3.40.50.300:FF:007862', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175415, NULL, 'G3DSA:3.40.50.300:FF:003579', NULL, NULL, 'D-glycerate 3-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(175416, NULL, 'G3DSA:1.10.10.540:FF:000010', NULL, NULL, 'UV excision repair RAD23 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175417, NULL, 'G3DSA:2.10.70.10:FF:000250', NULL, NULL, 'Plasminogen activator', NULL, NULL, NULL, NULL, NULL, 4),
(175418, NULL, 'G3DSA:2.60.260.20:FF:000002', NULL, NULL, 'Dnaj homolog subfamily b member', NULL, NULL, NULL, NULL, NULL, 4),
(175419, NULL, 'G3DSA:3.50.50.60:FF:001361', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(175420, NULL, 'G3DSA:1.10.472.10:FF:000001', NULL, NULL, 'G2/mitotic-specific cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(175421, NULL, 'G3DSA:1.10.8.720:FF:000026', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(175422, NULL, 'G3DSA:2.60.120.200:FF:000397', NULL, NULL, 'vitamin K-dependent protein S-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(175423, NULL, 'G3DSA:3.40.50.10490:FF:000069', NULL, NULL, 'Glucose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(175424, NULL, 'G3DSA:2.70.150.10:FF:000062', NULL, NULL, 'Calcium/mangenease P-type ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175425, NULL, 'G3DSA:1.10.8.10:FF:000129', NULL, NULL, 'CUE4p protein', NULL, NULL, NULL, NULL, NULL, 4),
(175426, NULL, 'G3DSA:4.10.1240.10:FF:000066', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase F', NULL, NULL, NULL, NULL, NULL, 4),
(175427, NULL, 'G3DSA:1.20.58.60:FF:000676', NULL, NULL, 'Nesprin-1', NULL, NULL, NULL, NULL, NULL, 4),
(175428, NULL, 'G3DSA:2.40.160.120:FF:000003', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(175429, NULL, 'G3DSA:3.80.10.10:FF:001224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175430, NULL, 'G3DSA:3.40.50.300:FF:002056', NULL, NULL, 'ADP-ribosylation factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(175431, NULL, 'G3DSA:3.80.10.10:FF:001117', NULL, NULL, 'Leucine rich repeat and phosphatase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(175432, NULL, 'G3DSA:3.10.20.310:FF:000031', NULL, NULL, 'Outer membrane protein assembly factor BamA', NULL, NULL, NULL, NULL, NULL, 4),
(175433, NULL, 'G3DSA:3.30.160.60:FF:002128', NULL, NULL, 'Zinc finger protein 142', NULL, NULL, NULL, NULL, NULL, 4),
(175434, NULL, 'G3DSA:3.20.20.70:FF:000610', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175435, NULL, 'G3DSA:1.25.40.1040:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175436, NULL, 'G3DSA:1.20.1440.340:FF:000005', NULL, NULL, 'Galactokinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(175437, NULL, 'G3DSA:1.25.40.1030:FF:000043', NULL, NULL, 'Protein transport protein sec16', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(175438, NULL, 'G3DSA:2.10.25.10:FF:000179', NULL, NULL, 'FAT atypical cadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(175439, NULL, 'G3DSA:3.40.50.720:FF:001013', NULL, NULL, 'Glyoxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(175440, NULL, 'G3DSA:3.40.50.300:FF:003591', NULL, NULL, 'Rab family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(175441, NULL, 'G3DSA:1.20.1070.10:FF:001019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175442, NULL, 'G3DSA:3.40.50.2300:FF:001547', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175443, NULL, 'G3DSA:1.10.8.10:FF:000236', NULL, NULL, 'Ubiquitin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(175444, NULL, 'G3DSA:1.10.10.10:FF:000080', NULL, NULL, 'paired box protein Pax-3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(175445, NULL, 'G3DSA:2.30.29.30:FF:000788', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175446, NULL, 'G3DSA:3.90.320.10:FF:000039', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(175447, NULL, 'G3DSA:3.40.50.300:FF:004192', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175448, NULL, 'G3DSA:3.40.190.10:FF:000697', NULL, NULL, 'Sll0540 protein', NULL, NULL, NULL, NULL, NULL, 4),
(175449, NULL, 'G3DSA:3.90.1640.20:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175450, NULL, 'G3DSA:3.40.50.10190:FF:000086', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(175451, NULL, 'G3DSA:2.40.40.20:FF:000047', NULL, NULL, 'Transitional endoplasmic reticulum ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175452, NULL, 'G3DSA:3.30.160.60:FF:002235', NULL, NULL, 'Zinc finger protein 549', NULL, NULL, NULL, NULL, NULL, 4),
(175453, NULL, 'G3DSA:3.30.830.10:FF:000304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175454, NULL, 'G3DSA:3.40.50.2300:FF:000946', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175455, NULL, 'G3DSA:2.60.220.30:FF:000003', NULL, NULL, 'Unc-5 netrin receptor C', NULL, NULL, NULL, NULL, NULL, 4),
(175456, NULL, 'G3DSA:1.20.5.4980:FF:000002', NULL, NULL, 'Centromere protein X', NULL, NULL, NULL, NULL, NULL, 4),
(175457, NULL, 'G3DSA:3.40.50.1100:FF:000221', NULL, NULL, 'Cysteine synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175458, NULL, 'G3DSA:3.40.50.790:FF:000027', NULL, NULL, 'Ribosomal protein L1p/L10e family protein', NULL, NULL, NULL, NULL, NULL, 4),
(175459, NULL, 'G3DSA:3.80.10.10:FF:003360', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175460, NULL, 'G3DSA:3.30.70.330:FF:001357', NULL, NULL, 'Related to nucleolar phosphoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(175461, NULL, 'G3DSA:1.20.120.1080:FF:000059', NULL, NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase PRP43, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175462, NULL, 'G3DSA:3.40.50.620:FF:000819', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175463, NULL, 'G3DSA:2.10.25.10:FF:000286', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(175464, NULL, 'G3DSA:3.20.20.140:FF:000247', NULL, NULL, '5-methylthioadenosine/S-adenosylhomocysteine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(175465, NULL, 'G3DSA:3.30.40.10:FF:000767', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(175466, NULL, 'G3DSA:1.10.238.10:FF:000064', NULL, NULL, 'calcium-binding mitochondrial carrier protein Aralar1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(175467, NULL, 'G3DSA:3.10.100.10:FF:000102', NULL, NULL, 'Killer cell lectin-like receptor subfamily F member 2', NULL, NULL, NULL, NULL, NULL, 4),
(175468, NULL, 'G3DSA:3.40.1160.10:FF:000059', NULL, NULL, 'Bifunctional aspartokinase-homoserine dehydrogenase protein', NULL, NULL, NULL, NULL, NULL, 4),
(175469, NULL, 'G3DSA:1.10.1200.10:FF:000055', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(175470, NULL, 'G3DSA:2.60.120.620:FF:000062', NULL, NULL, 'CurA', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(175471, NULL, 'G3DSA:3.40.50.2300:FF:000839', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175472, NULL, 'G3DSA:1.20.1250.20:FF:001227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175473, NULL, 'G3DSA:1.20.58.390:FF:000183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175474, NULL, 'G3DSA:3.30.70.330:FF:002892', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175475, NULL, 'G3DSA:3.10.330.20:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175476, NULL, 'G3DSA:3.40.50.300:FF:004310', NULL, NULL, 'Glr0464 protein', NULL, NULL, NULL, NULL, NULL, 4),
(175477, NULL, 'G3DSA:1.10.287.160:FF:000003', NULL, NULL, 'Putative serine/threonine-protein kinase N2', NULL, NULL, NULL, NULL, NULL, 4),
(175478, NULL, 'G3DSA:1.10.510.10:FF:002018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175479, NULL, 'G3DSA:1.20.1270.60:FF:000156', NULL, NULL, 'SLIT-ROBO Rho GTPase-activating protein 2 isoform X8', NULL, NULL, NULL, NULL, NULL, 4),
(175480, NULL, 'G3DSA:2.102.10.10:FF:000023', NULL, NULL, '3-phenylpropionate/trans-cinnamate dioxygenase ferredoxin subunit', NULL, NULL, NULL, NULL, NULL, 4),
(175481, NULL, 'G3DSA:2.40.50.360:FF:000009', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(175482, NULL, 'G3DSA:3.30.160.60:FF:005894', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175483, NULL, 'G3DSA:2.60.120.10:FF:000742', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175484, NULL, 'G3DSA:3.40.720.10:FF:000367', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175485, NULL, 'G3DSA:1.20.1250.20:FF:000952', NULL, NULL, 'Multidrug efflux pump', NULL, NULL, NULL, NULL, NULL, 4),
(175486, NULL, 'G3DSA:3.10.20.600:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175487, NULL, 'G3DSA:1.10.10.10:FF:001384', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175488, NULL, 'G3DSA:1.20.1070.10:FF:000744', NULL, NULL, 'Growth hormone releasing hormone receptor', NULL, NULL, NULL, NULL, NULL, 4),
(175489, NULL, 'G3DSA:3.10.105.10:FF:000068', NULL, NULL, 'Solute binding protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(175490, NULL, 'G3DSA:1.10.150.170:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175491, NULL, 'G3DSA:2.40.10.10:FF:000109', NULL, NULL, 'Hepsin', NULL, NULL, NULL, NULL, NULL, 4),
(175492, NULL, 'G3DSA:3.40.630.30:FF:000147', NULL, NULL, 'GNAT family N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(175493, NULL, 'G3DSA:3.40.1810.10:FF:000020', NULL, NULL, 'MADS-box protein FLOWERING LOCUS C', NULL, NULL, NULL, NULL, NULL, 4),
(175494, NULL, 'G3DSA:3.20.20.10:FF:000053', NULL, NULL, 'Pyridoxal phosphate homeostasis protein', NULL, NULL, NULL, NULL, NULL, 4),
(175495, NULL, 'G3DSA:2.10.90.10:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175496, NULL, 'G3DSA:2.40.30.10:FF:000223', NULL, NULL, 'Protein CBR-MRPS-18C', NULL, NULL, NULL, NULL, NULL, 4),
(175497, NULL, 'G3DSA:1.10.150.50:FF:000119', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(175498, NULL, 'G3DSA:1.20.920.10:FF:000097', NULL, NULL, 'Nucleosome-remodeling factor subunit NURF301-like', NULL, NULL, NULL, NULL, NULL, 4),
(175499, NULL, 'G3DSA:1.10.10.250:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175500, NULL, 'G3DSA:1.10.2000.10:FF:000074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175501, NULL, 'G3DSA:1.20.58.390:FF:000290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175502, NULL, 'G3DSA:2.60.260.40:FF:000008', NULL, NULL, 'Cytochrome c oxidase polypeptide Vb', NULL, NULL, NULL, NULL, NULL, 4),
(175503, NULL, 'G3DSA:2.40.50.200:FF:000001', NULL, NULL, 'TIGR00156 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(175504, NULL, 'G3DSA:1.25.10.10:FF:000501', NULL, NULL, 'Blast:Protein VAC14 homolog', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(175505, NULL, 'G3DSA:3.30.420.10:FF:000493', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175506, NULL, 'G3DSA:1.10.10.2660:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175507, NULL, 'G3DSA:2.40.128.20:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175508, NULL, 'G3DSA:3.20.20.140:FF:000028', NULL, NULL, 'DNA polymerase III subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(175509, NULL, 'G3DSA:1.20.1250.20:FF:001334', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175510, NULL, 'G3DSA:1.25.40.10:FF:003757', NULL, NULL, 'Protein smg7, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175511, NULL, 'G3DSA:2.60.40.60:FF:000316', NULL, NULL, 'Cadherin 74A, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(175512, NULL, 'G3DSA:1.25.40.10:FF:001633', NULL, NULL, 'Tetratricopeptide repeat/TPR repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175513, NULL, 'G3DSA:3.40.50.1110:FF:000117', NULL, NULL, 'Phospholipase B1, membrane-associated', NULL, NULL, NULL, NULL, NULL, 4),
(175514, NULL, 'G3DSA:2.80.10.50:FF:000092', NULL, NULL, 'recombining binding protein suppressor of hairless', NULL, NULL, NULL, NULL, NULL, 4),
(175515, NULL, 'G3DSA:3.80.10.10:FF:004097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175516, NULL, 'G3DSA:3.40.630.10:FF:000141', NULL, NULL, 'Peptide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(175517, NULL, 'G3DSA:3.30.70.2740:FF:000007', NULL, NULL, 'FAD-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(175518, NULL, 'G3DSA:3.40.50.150:FF:000740', NULL, NULL, 'Anamorsin homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(175519, NULL, 'G3DSA:3.40.33.10:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175520, NULL, 'G3DSA:3.40.30.10:FF:001002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175521, NULL, 'G3DSA:3.30.70.580:FF:000004', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(175522, NULL, 'G3DSA:2.130.10.10:FF:004130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175523, NULL, 'G3DSA:1.10.390.10:FF:000007', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(175524, NULL, 'G3DSA:3.20.20.120:FF:000022', NULL, NULL, 'Enolase 4', NULL, NULL, NULL, NULL, NULL, 4),
(175525, NULL, 'G3DSA:3.40.50.1100:FF:000114', NULL, NULL, 'Cysteine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(175526, NULL, 'G3DSA:3.10.20.90:FF:000116', NULL, NULL, 'band 4.1-like protein 4A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(175527, NULL, 'G3DSA:2.30.39.10:FF:000070', NULL, NULL, 'Blast:Serpin B8', NULL, NULL, NULL, NULL, NULL, 4),
(175528, NULL, 'G3DSA:2.130.10.10:FF:003966', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175529, NULL, 'G3DSA:1.10.1200.10:FF:000162', NULL, NULL, 'Siderophore peptide synthetase fer3', NULL, NULL, NULL, NULL, NULL, 4),
(175530, NULL, 'G3DSA:1.10.3290.10:FF:000010', NULL, NULL, 'Type III effector protein XopAC', NULL, NULL, NULL, NULL, NULL, 4),
(175531, NULL, 'G3DSA:3.30.40.10:FF:001149', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(175532, NULL, 'G3DSA:3.10.25.10:FF:000002', NULL, NULL, '10-formyltetrahydrofolate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(175533, NULL, 'G3DSA:1.25.40.850:FF:000003', NULL, NULL, 'Vacuolar protein sorting 33', NULL, NULL, NULL, NULL, NULL, 4),
(175534, NULL, 'G3DSA:3.30.160.60:FF:000330', NULL, NULL, 'Zinc finger with KRAB and SCAN domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(175535, NULL, 'G3DSA:3.40.50.300:FF:002275', NULL, NULL, 'ATP-binding cassette, subfamily A (ABC1), member 16', NULL, NULL, NULL, NULL, NULL, 4),
(175536, NULL, 'G3DSA:3.30.1490.20:FF:000089', NULL, NULL, 'Synapsin', NULL, NULL, NULL, NULL, NULL, 4),
(175537, NULL, 'G3DSA:2.30.30.40:FF:000070', NULL, NULL, 'Alpha-(1,6)-fucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(175538, NULL, 'G3DSA:3.40.50.12160:FF:000031', NULL, NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(175539, NULL, 'G3DSA:3.10.290.10:FF:000104', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(175540, NULL, 'G3DSA:1.10.1450.10:FF:000101', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(175541, NULL, 'G3DSA:2.20.25.10:FF:000083', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(175542, NULL, 'G3DSA:3.30.420.270:FF:000019', NULL, NULL, 'Biopolymer transporter ExbD', NULL, NULL, NULL, NULL, NULL, 4),
(175543, NULL, 'G3DSA:3.30.530.20:FF:000144', NULL, NULL, 'Phosphatidylinositol transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(175544, NULL, 'G3DSA:2.60.40.150:FF:000243', NULL, NULL, 'Copine-3', NULL, NULL, NULL, NULL, NULL, 4),
(175545, NULL, 'G3DSA:3.30.160.380:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175546, NULL, 'G3DSA:4.10.400.10:FF:000043', NULL, NULL, 'Very low density lipoprotein receptor', NULL, NULL, NULL, NULL, NULL, 4),
(175547, NULL, 'G3DSA:2.10.70.10:FF:000036', NULL, NULL, 'Sushi repeat containing protein X-linked', NULL, NULL, NULL, NULL, NULL, 4),
(175548, NULL, 'G3DSA:3.40.1110.10:FF:000343', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175549, NULL, 'G3DSA:3.40.190.10:FF:000112', NULL, NULL, 'Hca operon transcriptional activator', NULL, NULL, NULL, NULL, NULL, 4),
(175550, NULL, 'G3DSA:2.30.30.490:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175551, NULL, 'G3DSA:3.60.40.10:FF:000277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175552, NULL, 'G3DSA:2.80.10.50:FF:000103', NULL, NULL, 'Protein CBG12091', NULL, NULL, NULL, NULL, NULL, 4),
(175553, NULL, 'G3DSA:3.30.70.590:FF:000007', NULL, NULL, 'Poly(A) polymerase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(175554, NULL, 'G3DSA:3.40.50.1820:FF:000673', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(175555, NULL, 'G3DSA:2.10.50.10:FF:000029', NULL, NULL, 'Signal peptide, CUB domain and EGF like domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(175556, NULL, 'G3DSA:3.40.30.10:FF:000378', NULL, NULL, 'Protein disulfide isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(175557, NULL, 'G3DSA:3.40.50.1820:FF:001162', NULL, NULL, 'Lipase precursor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175558, NULL, 'G3DSA:1.25.40.10:FF:001852', NULL, NULL, 'ER membrane protein complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(175559, NULL, 'G3DSA:3.30.2290.10:FF:000009', NULL, NULL, 'Putative peptidase TldD', NULL, NULL, NULL, NULL, NULL, 4),
(175560, NULL, 'G3DSA:3.30.200.20:FF:000968', NULL, NULL, 'Serine/threonine protein kinase-56', NULL, NULL, NULL, NULL, NULL, 4),
(175561, NULL, 'G3DSA:2.10.25.10:FF:001022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175562, NULL, 'G3DSA:3.30.40.10:FF:001705', NULL, NULL, 'Metal-response element-binding transcription factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(175563, NULL, 'G3DSA:3.30.1360.120:FF:000060', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(175564, NULL, 'G3DSA:3.30.300.110:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175565, NULL, 'G3DSA:1.10.472.10:FF:000220', NULL, NULL, 'Cyclin superfamily protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175566, NULL, 'G3DSA:1.10.472.80:FF:000090', NULL, NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', NULL, NULL, NULL, NULL, NULL, 4),
(175567, NULL, 'G3DSA:2.10.25.10:FF:000398', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(175568, NULL, 'G3DSA:3.40.50.410:FF:000291', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175569, NULL, 'G3DSA:1.10.1200.10:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175570, NULL, 'G3DSA:1.10.287.110:FF:000235', NULL, NULL, 'Chaperone protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175571, NULL, 'G3DSA:1.10.510.10:FF:004154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175572, NULL, 'G3DSA:3.10.50.40:FF:000064', NULL, NULL, 'Chaperone SurA', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(175573, NULL, 'G3DSA:1.20.58.390:FF:000071', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(175574, NULL, 'G3DSA:3.50.50.100:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175575, NULL, 'G3DSA:1.10.533.10:FF:000019', NULL, NULL, 'NACHT, LRR and PYD domains-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(175576, NULL, 'G3DSA:2.30.30.180:FF:000004', NULL, NULL, 'Ribosome maturation factor RimP', NULL, NULL, NULL, NULL, NULL, 4),
(175577, NULL, 'G3DSA:3.40.30.10:FF:000159', NULL, NULL, 'Peroxiredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(175578, NULL, 'G3DSA:2.60.120.920:FF:000045', NULL, NULL, 'E3 ubiquitin/ISG15 ligase TRIM25', NULL, NULL, NULL, NULL, NULL, 4),
(175579, NULL, 'G3DSA:2.60.40.10:FF:004152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175580, NULL, 'G3DSA:3.40.50.720:FF:000389', NULL, NULL, 'Dihydrodipicolinate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(175581, NULL, 'G3DSA:1.25.10.10:FF:000041', NULL, NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(175582, NULL, 'G3DSA:1.20.1560.10:FF:000484', NULL, NULL, 'ABC transporter, ATP-binding/membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(175583, NULL, 'G3DSA:2.60.40.10:FF:001297', NULL, NULL, 'Interleukin 18 binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(175584, NULL, 'G3DSA:1.10.287.10:FF:000048', NULL, NULL, 'Tryptophanyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(175585, NULL, 'G3DSA:3.90.80.10:FF:000019', NULL, NULL, 'Os01g0322300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(175586, NULL, 'G3DSA:2.60.120.820:FF:000015', NULL, NULL, 'BTB domain containing 6', NULL, NULL, NULL, NULL, NULL, 4),
(175587, NULL, 'G3DSA:3.30.420.10:FF:000616', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175588, NULL, 'G3DSA:1.20.58.60:FF:000895', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(175589, NULL, 'G3DSA:2.60.120.10:FF:000630', NULL, NULL, 'cGMP-dependent protein kinase, isozyme 2 forms cD5/T2', NULL, NULL, NULL, NULL, NULL, 4),
(175590, NULL, 'G3DSA:3.40.50.300:FF:005726', NULL, NULL, 'ATP-dependent RNA helicase SUPV3L1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(175591, NULL, 'G3DSA:1.10.287.1080:FF:000010', NULL, NULL, 'MazG-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(175592, NULL, 'G3DSA:3.40.50.300:FF:000044', NULL, NULL, 'Dynein heavy chain 5, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(175593, NULL, 'G3DSA:2.130.10.10:FF:005327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175594, NULL, 'G3DSA:2.100.10.50:FF:000006', NULL, NULL, 'Multivesicular body subunit 12B', NULL, NULL, NULL, NULL, NULL, 4),
(175595, NULL, 'G3DSA:1.20.1070.10:FF:001452', NULL, NULL, 'Coagulation factor II thrombin receptor like 2', NULL, NULL, NULL, NULL, NULL, 4),
(175596, NULL, 'G3DSA:1.25.40.20:FF:001855', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175597, NULL, 'G3DSA:1.20.5.110:FF:000162', NULL, NULL, 'GD12459', NULL, NULL, NULL, NULL, NULL, 4),
(175598, NULL, 'G3DSA:3.90.870.10:FF:000018', NULL, NULL, 'Riboflavin biosynthesis protein RibBA', NULL, NULL, NULL, NULL, NULL, 4),
(175599, NULL, 'G3DSA:3.30.70.20:FF:000013', NULL, NULL, 'Formate dehydrogenase iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4),
(175600, NULL, 'G3DSA:3.20.90.10:FF:000001', NULL, NULL, 'Tubby-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(175601, NULL, 'G3DSA:3.20.20.105:FF:000011', NULL, NULL, 'Queuine tRNA-ribosyltransferase accessory subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(175602, NULL, 'G3DSA:3.30.160.60:FF:003758', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175603, NULL, 'G3DSA:4.10.280.10:FF:000061', NULL, NULL, 'Transcription factor SPEECHLESS', NULL, NULL, NULL, NULL, NULL, 4),
(175604, NULL, 'G3DSA:3.40.50.620:FF:000696', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(175605, NULL, 'G3DSA:3.30.559.30:FF:000011', NULL, NULL, 'Nonribosomal siderophore peptide synthase SidC', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(175606, NULL, 'G3DSA:3.40.1810.10:FF:000025', NULL, NULL, 'AGAMOUS-like 76', NULL, NULL, NULL, NULL, NULL, 4),
(175607, NULL, 'G3DSA:3.30.160.60:FF:001746', NULL, NULL, 'Protein SENSITIVE TO PROTON RHIZOTOXICITY 1', NULL, NULL, NULL, NULL, NULL, 4),
(175608, NULL, 'G3DSA:4.10.970.10:FF:000017', NULL, NULL, 'ATP dependent DNA ligase 1', NULL, NULL, NULL, NULL, NULL, 4),
(175609, NULL, 'G3DSA:3.40.50.300:FF:004315', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175610, NULL, 'G3DSA:3.30.9.10:FF:000240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175611, NULL, 'G3DSA:3.30.420.40:FF:000029', NULL, NULL, 'Actin-related protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(175612, NULL, 'G3DSA:1.10.10.10:FF:001389', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(175613, NULL, 'G3DSA:3.90.1750.10:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175614, NULL, 'G3DSA:3.40.50.300:FF:001567', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175615, NULL, 'G3DSA:2.130.10.10:FF:005546', NULL, NULL, 'WD repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175616, NULL, 'G3DSA:3.20.20.140:FF:000466', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(175617, NULL, 'G3DSA:4.10.270.10:FF:000009', NULL, NULL, 'Myosin II heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(175618, NULL, 'G3DSA:3.40.50.720:FF:001232', NULL, NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(175619, NULL, 'G3DSA:3.40.440.10:FF:000003', NULL, NULL, 'Adenylosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(175620, NULL, 'G3DSA:3.30.1180.20:FF:000009', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(175621, NULL, 'G3DSA:3.40.50.300:FF:007750', NULL, NULL, 'ATP-dependent RNA helicase Ddx1', NULL, NULL, NULL, NULL, NULL, 4),
(175622, NULL, 'G3DSA:2.60.40.10:FF:001971', NULL, NULL, 'Protein-glutamine gamma-glutamyltransferase 5', NULL, NULL, NULL, NULL, NULL, 4),
(175623, NULL, 'G3DSA:1.10.472.10:FF:000113', NULL, NULL, 'Cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(175624, NULL, 'G3DSA:1.10.287.990:FF:000010', NULL, NULL, 'Putative 37S ribosomal protein S26A, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(175625, NULL, 'G3DSA:2.60.120.290:FF:000148', NULL, NULL, 'AGAP005526-PA', NULL, NULL, NULL, NULL, NULL, 4),
(175626, NULL, 'G3DSA:1.10.20.10:FF:000035', NULL, NULL, 'Nuclear transcription factor Y subunit B-3', NULL, NULL, NULL, NULL, NULL, 4),
(175627, NULL, 'G3DSA:1.10.220.20:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175628, NULL, 'G3DSA:2.130.10.10:FF:001168', NULL, NULL, 'G beta-like protein GBL', NULL, NULL, NULL, NULL, NULL, 4),
(175629, NULL, 'G3DSA:1.25.10.10:FF:001805', NULL, NULL, 'protein unc-45 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(175630, NULL, 'G3DSA:3.80.10.10:FF:001005', NULL, NULL, 'F-box/LRR-repeat protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(175631, NULL, 'G3DSA:3.40.50.150:FF:000414', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(175632, NULL, 'G3DSA:1.50.40.10:FF:000260', NULL, NULL, 'Solute carrier family 25 member 33', NULL, NULL, NULL, NULL, NULL, 4),
(175633, NULL, 'G3DSA:3.40.50.720:FF:000956', NULL, NULL, 'Alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(175634, NULL, 'G3DSA:3.40.50.2300:FF:001328', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175635, NULL, 'G3DSA:1.10.220.10:FF:000012', NULL, NULL, 'Annexin A10', NULL, NULL, NULL, NULL, NULL, 4),
(175636, NULL, 'G3DSA:3.40.640.10:FF:000203', NULL, NULL, 'serine palmitoyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(175637, NULL, 'G3DSA:3.90.780.10:FF:000011', NULL, NULL, 'YHR202W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(175638, NULL, 'G3DSA:2.60.120.380:FF:000057', NULL, NULL, 'Cysteine peptidase, Clan CA, family C2, putative', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(175639, NULL, 'G3DSA:3.30.70.140:FF:000002', NULL, NULL, 'Aspartate carbamoyltransferase / Aspartate carbamoyltransferase regulatory chain (PyrI)', NULL, NULL, NULL, NULL, NULL, 4),
(175640, NULL, 'G3DSA:3.60.40.10:FF:000384', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175641, NULL, 'G3DSA:2.40.50.140:FF:001247', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175642, NULL, 'G3DSA:3.40.50.1010:FF:000183', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175643, NULL, 'G3DSA:3.30.160.60:FF:002016', NULL, NULL, 'Zinc finger protein 432', NULL, NULL, NULL, NULL, NULL, 4),
(175644, NULL, 'G3DSA:1.10.630.10:FF:000167', NULL, NULL, 'GM16491', NULL, NULL, NULL, NULL, NULL, 4),
(175645, NULL, 'G3DSA:1.10.287.90:FF:000015', NULL, NULL, 'Cytochrome c oxidase subunit II', NULL, NULL, NULL, NULL, NULL, 4),
(175646, NULL, 'G3DSA:2.60.120.290:FF:000255', NULL, NULL, 'Cubilin-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(175647, NULL, 'G3DSA:1.20.1250.20:FF:001008', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(175648, NULL, 'G3DSA:3.40.50.10380:FF:000036', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(175649, NULL, 'G3DSA:2.60.120.10:FF:000304', NULL, NULL, 'Sll1785 protein', NULL, NULL, NULL, NULL, NULL, 4),
(175650, NULL, 'G3DSA:3.20.20.70:FF:000368', NULL, NULL, 'Pyruvate formate-lyase 3 activating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(175651, NULL, 'G3DSA:1.10.3520.10:FF:000006', NULL, NULL, 'Pleckstrin homology domain-containing family A member 8', NULL, NULL, NULL, NULL, NULL, 4),
(175652, NULL, 'G3DSA:2.60.40.150:FF:000350', NULL, NULL, 'Similar to synaptotagmin XII', NULL, NULL, NULL, NULL, NULL, 4),
(175653, NULL, 'G3DSA:1.20.120.1080:FF:000054', NULL, NULL, 'Benign gonial cell neoplasm', NULL, NULL, NULL, NULL, NULL, 4),
(175654, NULL, 'G3DSA:1.10.630.10:FF:000274', NULL, NULL, 'Cytochrome P450 71D11, putative, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(175655, NULL, 'G3DSA:3.80.10.10:FF:003141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175656, NULL, 'G3DSA:1.10.8.10:FF:000348', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(175657, NULL, 'G3DSA:1.20.1280.50:FF:000193', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(175658, NULL, 'G3DSA:1.10.3860.10:FF:000037', NULL, NULL, 'Ulip2 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175659, NULL, 'G3DSA:1.25.40.20:FF:000220', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(175660, NULL, 'G3DSA:3.40.50.300:FF:001674', NULL, NULL, 'E1A-binding protein p400 isoform X7', NULL, NULL, NULL, NULL, NULL, 4),
(175661, NULL, 'G3DSA:3.40.50.1000:FF:000180', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(175662, NULL, 'G3DSA:1.20.140.100:FF:000021', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(175663, NULL, 'G3DSA:3.40.50.1980:FF:000001', NULL, NULL, 'Histidinol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(175664, NULL, 'G3DSA:3.40.50.410:FF:000307', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175665, NULL, 'G3DSA:1.25.40.10:FF:004140', NULL, NULL, 'Protein O-mannosyl-transferase TMTC1', NULL, NULL, NULL, NULL, NULL, 4),
(175666, NULL, 'G3DSA:3.30.160.60:FF:003539', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175667, NULL, 'G3DSA:3.50.50.60:FF:001142', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(175668, NULL, 'G3DSA:1.20.1560.10:FF:000596', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175669, NULL, 'G3DSA:2.130.10.10:FF:005439', NULL, NULL, 'WD repeat-containing protein PCN', NULL, NULL, NULL, NULL, NULL, 4),
(175670, NULL, 'G3DSA:2.40.30.10:FF:000330', NULL, NULL, 'Translation initiation factor IF-2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175671, NULL, 'G3DSA:3.30.2410.10:FF:000003', NULL, NULL, 'probable E3 ubiquitin-protein ligase HERC4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(175672, NULL, 'G3DSA:3.30.200.20:FF:002300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175673, NULL, 'G3DSA:2.130.10.10:FF:005097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175674, NULL, 'G3DSA:3.60.40.10:FF:000058', NULL, NULL, 'Stage II sporulation protein E', NULL, NULL, NULL, NULL, NULL, 4),
(175675, NULL, 'G3DSA:3.50.30.30:FF:000069', NULL, NULL, 'Subtilisin-like protease SBT2.1', NULL, NULL, NULL, NULL, NULL, 4),
(175676, NULL, 'G3DSA:2.10.25.10:FF:000746', NULL, NULL, 'Dumpy, isoform Z', NULL, NULL, NULL, NULL, NULL, 4),
(175677, NULL, 'G3DSA:4.10.410.10:FF:000105', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(175678, NULL, 'G3DSA:1.25.40.410:FF:000006', NULL, NULL, 'Guanine nucleotide exchange factor SPIKE 1', NULL, NULL, NULL, NULL, NULL, 4),
(175679, NULL, 'G3DSA:3.40.50.150:FF:000066', NULL, NULL, 'Trimethylguanosine synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(175680, NULL, 'G3DSA:1.10.1070.11:FF:000112', NULL, NULL, 'PIKK family atypical protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(175681, NULL, 'G3DSA:2.60.40.10:FF:005894', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175682, NULL, 'G3DSA:3.30.200.20:FF:001676', NULL, NULL, 'Serine/threonine-protein kinase SSN3', NULL, NULL, NULL, NULL, NULL, 4),
(175683, NULL, 'G3DSA:2.30.30.40:FF:000300', NULL, NULL, 'Actin cytoskeleton-regulatory complex protein SLA1', NULL, NULL, NULL, NULL, NULL, 4),
(175684, NULL, 'G3DSA:1.10.287.70:FF:000594', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(175685, NULL, 'G3DSA:3.20.80.10:FF:000045', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(175686, NULL, 'G3DSA:2.60.40.150:FF:000024', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(175687, NULL, 'G3DSA:1.20.1070.10:FF:001233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175688, NULL, 'G3DSA:1.10.630.10:FF:000622', NULL, NULL, 'Os01g0197100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(175689, NULL, 'G3DSA:3.40.50.300:FF:005945', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175690, NULL, 'G3DSA:3.40.50.300:FF:005496', NULL, NULL, 'DEAD/DEAH box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(175691, NULL, 'G3DSA:1.25.40.10:FF:003864', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175692, NULL, 'G3DSA:3.90.1200.10:FF:000035', NULL, NULL, 'Juvenile hormone-inducible protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(175693, NULL, 'G3DSA:1.20.58.1610:FF:000008', NULL, NULL, 'NADH-quinone oxidoreductase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(175694, NULL, 'G3DSA:2.40.160.210:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175695, NULL, 'G3DSA:3.60.21.10:FF:000351', NULL, NULL, 'Protein CBG24260', NULL, NULL, NULL, NULL, NULL, 4),
(175696, NULL, 'G3DSA:3.30.70.330:FF:000975', NULL, NULL, 'Sbp1p', NULL, NULL, NULL, NULL, NULL, 4),
(175697, NULL, 'G3DSA:1.20.58.190:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175698, NULL, 'G3DSA:3.40.50.300:FF:005838', NULL, NULL, 'ABC transporter ATP-binding/permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(175699, NULL, 'G3DSA:1.20.58.740:FF:000007', NULL, NULL, 'Protein CBR-CED-5', NULL, NULL, NULL, NULL, NULL, 4),
(175700, NULL, 'G3DSA:3.30.1120.60:FF:000001', NULL, NULL, 'Colicin N', NULL, NULL, NULL, NULL, NULL, 4),
(175701, NULL, 'G3DSA:1.20.1110.10:FF:000006', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(175702, NULL, 'G3DSA:1.10.1420.10:FF:000150', NULL, NULL, 'MSH (MutS Homolog) family', NULL, NULL, NULL, NULL, NULL, 4),
(175703, NULL, 'G3DSA:1.10.3210.10:FF:000011', NULL, NULL, 'HD domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(175704, NULL, 'G3DSA:3.40.50.300:FF:001893', NULL, NULL, 'DNA repair protein RAD5', NULL, NULL, NULL, NULL, NULL, 4),
(175705, NULL, 'G3DSA:2.60.120.920:FF:000152', NULL, NULL, 'Si:ch211-22k7.9', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(175706, NULL, 'G3DSA:2.10.25.10:FF:001241', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(175707, NULL, 'G3DSA:2.130.10.10:FF:001842', NULL, NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', NULL, NULL, NULL, NULL, NULL, 4),
(175708, NULL, 'G3DSA:1.10.520.10:FF:000052', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(175709, NULL, 'G3DSA:3.40.1110.10:FF:000455', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175710, NULL, 'G3DSA:1.25.40.70:FF:000077', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(175711, NULL, 'G3DSA:2.60.40.10:FF:005675', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175712, NULL, 'G3DSA:3.40.50.300:FF:005277', NULL, NULL, 'YALI0D22154p', NULL, NULL, NULL, NULL, NULL, 4),
(175713, NULL, 'G3DSA:1.25.40.10:FF:003645', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(175714, NULL, 'G3DSA:1.10.630.10:FF:000841', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175715, NULL, 'G3DSA:1.20.1070.10:FF:001014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175716, NULL, 'G3DSA:3.30.160.60:FF:002802', NULL, NULL, 'Kruppel-Like Factor (Zinc finger protein)', NULL, NULL, NULL, NULL, NULL, 4),
(175717, NULL, 'G3DSA:1.10.10.60:FF:001157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175718, NULL, 'G3DSA:1.10.10.10:FF:001726', NULL, NULL, 'Probable metalloprotease ARX1', NULL, NULL, NULL, NULL, NULL, 4),
(175719, NULL, 'G3DSA:1.10.630.10:FF:000493', NULL, NULL, '(S)-N-methylcoclaurine 3''-hydroxylase isozyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(175720, NULL, 'G3DSA:3.30.160.60:FF:005456', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175721, NULL, 'G3DSA:2.30.29.30:FF:000569', NULL, NULL, 'pleckstrin homology domain-containing family A member 3', NULL, NULL, NULL, NULL, NULL, 4),
(175722, NULL, 'G3DSA:3.40.430.10:FF:000053', NULL, NULL, 'Diaminohydroxyphosphoribosylaminopyrimidine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(175723, NULL, 'G3DSA:1.10.510.10:FF:001529', NULL, NULL, 'Ribosomal protein S6 kinase C1', NULL, NULL, NULL, NULL, NULL, 4),
(175724, NULL, 'G3DSA:3.40.50.1440:FF:000070', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(175725, NULL, 'G3DSA:3.40.50.410:FF:000184', NULL, NULL, 'Proteasome 26S subunit, non-ATPase 4', NULL, NULL, NULL, NULL, NULL, 4),
(175726, NULL, 'G3DSA:1.20.58.80:FF:000002', NULL, NULL, 'Vacuolar protein sorting-associated protein 4A', NULL, NULL, NULL, NULL, NULL, 4),
(175727, NULL, 'G3DSA:3.40.30.10:FF:000620', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(175728, NULL, 'G3DSA:3.20.20.60:FF:000146', NULL, NULL, 'Aldolase like', NULL, NULL, NULL, NULL, NULL, 4),
(175729, NULL, 'G3DSA:3.40.630.150:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175730, NULL, 'G3DSA:3.20.20.70:FF:000149', NULL, NULL, 'Nicotinate-nucleotide pyrophosphorylase [carboxylating]', NULL, NULL, NULL, NULL, NULL, 4),
(175731, NULL, 'G3DSA:1.25.40.550:FF:000020', NULL, NULL, 'AGR376Wp', NULL, NULL, NULL, NULL, NULL, 4),
(175732, NULL, 'G3DSA:2.60.120.10:FF:000523', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(175733, NULL, 'G3DSA:1.20.5.490:FF:000005', NULL, NULL, 'Nucleoporin complex subunit 54', NULL, NULL, NULL, NULL, NULL, 4),
(175734, NULL, 'G3DSA:3.40.50.2020:FF:000047', NULL, NULL, 'Ribose-phosphate pyrophosphokinase II', NULL, NULL, NULL, NULL, NULL, 4),
(175735, NULL, 'G3DSA:1.10.555.10:FF:000188', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175736, NULL, 'G3DSA:3.30.420.10:FF:000723', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175737, NULL, 'G3DSA:2.130.10.10:FF:005765', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175738, NULL, 'G3DSA:2.10.70.10:FF:000255', NULL, NULL, 'Cellular communication network factor 5', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(175739, NULL, 'G3DSA:2.130.10.10:FF:001494', NULL, NULL, 'PRP4p Splicing factor', NULL, NULL, NULL, NULL, NULL, 4),
(175740, NULL, 'G3DSA:2.10.25.10:FF:000965', NULL, NULL, 'Transmembrane protein with EGF-like and two follistatin-like domains 1b', NULL, NULL, NULL, NULL, NULL, 4),
(175741, NULL, 'G3DSA:2.60.40.1180:FF:000055', NULL, NULL, 'META domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(175742, NULL, 'G3DSA:3.80.10.10:FF:002298', NULL, NULL, 'lumican', NULL, NULL, NULL, NULL, NULL, 4),
(175743, NULL, 'G3DSA:3.20.20.80:FF:000490', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175744, NULL, 'G3DSA:3.30.70.330:FF:001138', NULL, NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(175745, NULL, 'G3DSA:1.25.40.10:FF:002015', NULL, NULL, 'Intraflagellar transport protein 139', NULL, NULL, NULL, NULL, NULL, 4),
(175746, NULL, 'G3DSA:3.40.50.1460:FF:000076', NULL, NULL, 'Senescence enhanced2b', NULL, NULL, NULL, NULL, NULL, 4),
(175747, NULL, 'G3DSA:2.60.40.10:FF:005456', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175748, NULL, 'G3DSA:3.40.50.2000:FF:001126', NULL, NULL, 'Glycogen [starch] synthase', NULL, NULL, NULL, NULL, NULL, 4),
(175749, NULL, 'G3DSA:3.40.33.10:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175750, NULL, 'G3DSA:3.30.160.60:FF:001965', NULL, NULL, 'Zinc finger protein SNAI3', NULL, NULL, NULL, NULL, NULL, 4),
(175751, NULL, 'G3DSA:3.30.450.20:FF:000447', NULL, NULL, 'Sensory box histidine kinase SdeK', NULL, NULL, NULL, NULL, NULL, 4),
(175752, NULL, 'G3DSA:3.40.1110.10:FF:000236', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175753, NULL, 'G3DSA:2.80.10.50:FF:000215', NULL, NULL, 'UDP-N-acetyl-alpha-D-galactosamine:polypeptide N-acetylgalactosaminyltransferase-like 6', NULL, NULL, NULL, NULL, NULL, 4),
(175754, NULL, 'G3DSA:3.30.450.40:FF:000205', NULL, NULL, 'Stage II sporulation E family protein', NULL, NULL, NULL, NULL, NULL, 4),
(175755, NULL, 'G3DSA:3.40.50.300:FF:006108', NULL, NULL, 'Kurz protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175756, NULL, 'G3DSA:3.40.50.300:FF:002730', NULL, NULL, 'Iron(III) ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(175757, NULL, 'G3DSA:2.60.40.10:FF:001752', NULL, NULL, 'obscurin-like isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(175758, NULL, 'G3DSA:1.10.3730.20:FF:000042', NULL, NULL, 'Nucleotide Sugar TransPorter family', NULL, NULL, NULL, NULL, NULL, 4),
(175759, NULL, 'G3DSA:1.10.510.10:FF:000220', NULL, NULL, 'dual specificity protein kinase CLK4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(175760, NULL, 'G3DSA:2.40.30.10:FF:000004', NULL, NULL, '50S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(175761, NULL, 'G3DSA:3.60.21.10:FF:000132', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(175762, NULL, 'G3DSA:1.20.140.10:FF:000026', NULL, NULL, 'Acyl-CoA dehydrogenase FadE24', NULL, NULL, NULL, NULL, NULL, 4),
(175763, NULL, 'G3DSA:1.25.50.20:FF:000046', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(175764, NULL, 'G3DSA:3.30.1370.100:FF:000016', NULL, NULL, 'MutL homolog 3 (E. coli)', NULL, NULL, NULL, NULL, NULL, 4),
(175765, NULL, 'G3DSA:3.30.40.10:FF:000981', NULL, NULL, 'RING/U-box superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(175766, NULL, 'G3DSA:1.20.140.50:FF:000009', NULL, NULL, 'Programmed cell death 6-interacting protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175767, NULL, 'G3DSA:2.130.10.10:FF:002331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175768, NULL, 'G3DSA:2.30.30.140:FF:000239', NULL, NULL, 'Putative ATP-dependent RNA helicase TDRD12', NULL, NULL, NULL, NULL, NULL, 4),
(175769, NULL, 'G3DSA:3.20.20.80:FF:000832', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175770, NULL, 'G3DSA:3.40.80.10:FF:000005', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(175771, NULL, 'G3DSA:3.30.1370.110:FF:000019', NULL, NULL, 'Endonuclease MutS2', NULL, NULL, NULL, NULL, NULL, 4),
(175772, NULL, 'G3DSA:2.60.40.10:FF:004045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175773, NULL, 'G3DSA:1.10.268.10:FF:000015', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(175774, NULL, 'G3DSA:3.10.580.10:FF:000082', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(175775, NULL, 'G3DSA:1.10.510.10:FF:002237', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175776, NULL, 'G3DSA:1.10.3380.10:FF:000017', NULL, NULL, 'U5 small nuclear ribonucleoprotein helicase', NULL, NULL, NULL, NULL, NULL, 4),
(175777, NULL, 'G3DSA:2.60.40.10:FF:003769', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175778, NULL, 'G3DSA:3.40.50.720:FF:001451', NULL, NULL, 'Putative cinnamyl alcohol dehydrogenase 6', NULL, NULL, NULL, NULL, NULL, 4),
(175779, NULL, 'G3DSA:1.20.1110.10:FF:000225', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175780, NULL, 'G3DSA:1.20.920.10:FF:000092', NULL, NULL, 'Transcription initiation factor tfiid, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175781, NULL, 'G3DSA:3.30.930.10:FF:000251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175782, NULL, 'G3DSA:1.10.720.60:FF:000020', NULL, NULL, 'Enolase-phosphatase E1', NULL, NULL, NULL, NULL, NULL, 4),
(175783, NULL, 'G3DSA:3.40.50.300:FF:005619', NULL, NULL, 'MutS homolog1', NULL, NULL, NULL, NULL, NULL, 4),
(175784, NULL, 'G3DSA:1.20.970.10:FF:000038', NULL, NULL, 'Anthranilate phosphoribosyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(175785, NULL, 'G3DSA:3.10.280.10:FF:000036', NULL, NULL, 'Uncharacterized protein C15D4.11c', NULL, NULL, NULL, NULL, NULL, 4),
(175786, NULL, 'G3DSA:3.60.10.10:FF:000337', NULL, NULL, 'Fgr24p', NULL, NULL, NULL, NULL, NULL, 4),
(175787, NULL, 'G3DSA:1.10.287.470:FF:000085', NULL, NULL, 'Cation efflux system (CzcB-like)', NULL, NULL, NULL, NULL, NULL, 4),
(175788, NULL, 'G3DSA:3.80.10.10:FF:002859', NULL, NULL, 'Protein CBG18939', NULL, NULL, NULL, NULL, NULL, 4),
(175789, NULL, 'G3DSA:3.30.9.40:FF:000001', NULL, NULL, 'Styrene monooxygenase StyA', NULL, NULL, NULL, NULL, NULL, 4),
(175790, NULL, 'G3DSA:3.30.160.60:FF:005675', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175791, NULL, 'G3DSA:2.60.120.10:FF:000175', NULL, NULL, 'AGC protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(175792, NULL, 'G3DSA:3.30.420.10:FF:000381', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(175793, NULL, 'G3DSA:2.40.30.20:FF:000007', NULL, NULL, 'Riboflavin synthase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(175794, NULL, 'G3DSA:3.40.720.10:FF:000148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175795, NULL, 'G3DSA:3.15.10.10:FF:000014', NULL, NULL, 'BPI fold-containing family A member 2', NULL, NULL, NULL, NULL, NULL, 4),
(175796, NULL, 'G3DSA:3.40.50.200:FF:000014', NULL, NULL, 'Proteinase K', NULL, NULL, NULL, NULL, NULL, 4),
(175797, NULL, 'G3DSA:1.20.58.340:FF:000084', NULL, NULL, 'Mg2+ transporter protein, CorA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(175798, NULL, 'G3DSA:1.10.357.70:FF:000021', NULL, NULL, 'Si:dkey-45k15.1', NULL, NULL, NULL, NULL, NULL, 4),
(175799, NULL, 'G3DSA:2.130.10.10:FF:003528', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175800, NULL, 'G3DSA:3.20.20.70:FF:000262', NULL, NULL, 'NADH:flavin oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(175801, NULL, 'G3DSA:2.30.29.150:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175802, NULL, 'G3DSA:3.30.460.10:FF:000158', NULL, NULL, 'DNA-directed DNA polymerase, family X', NULL, NULL, NULL, NULL, NULL, 4),
(175803, NULL, 'G3DSA:1.20.1560.10:FF:000719', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(175804, NULL, 'G3DSA:2.60.120.10:FF:000068', NULL, NULL, 'cGMP-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(175805, NULL, 'G3DSA:1.10.510.10:FF:001855', NULL, NULL, 'Tyrosine-protein kinase hopscotch', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(175806, NULL, 'G3DSA:3.40.50.620:FF:000584', NULL, NULL, 'Probable tRNA sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(175807, NULL, 'G3DSA:3.30.450.20:FF:000666', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175808, NULL, 'G3DSA:3.30.390.30:FF:000046', NULL, NULL, 'Glr2871 protein', NULL, NULL, NULL, NULL, NULL, 4),
(175809, NULL, 'G3DSA:2.170.270.10:FF:000024', NULL, NULL, 'Histone-lysine N-methyltransferase SETD7', NULL, NULL, NULL, NULL, NULL, 4),
(175810, NULL, 'G3DSA:3.30.160.60:FF:006170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175811, NULL, 'G3DSA:1.10.3720.10:FF:000100', NULL, NULL, 'Sulfate ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(175812, NULL, 'G3DSA:1.25.10.10:FF:001676', NULL, NULL, 'Importin-alpha export receptor', NULL, NULL, NULL, NULL, NULL, 4),
(175813, NULL, 'G3DSA:1.25.40.10:FF:003319', NULL, NULL, 'Superkiller protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(175814, NULL, 'G3DSA:2.130.10.10:FF:005658', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(175815, NULL, 'G3DSA:1.10.287.1490:FF:000032', NULL, NULL, 'Atg11p', NULL, NULL, NULL, NULL, NULL, 4),
(175816, NULL, 'G3DSA:1.10.8.60:FF:000335', NULL, NULL, 'Cell division control protein', NULL, NULL, NULL, NULL, NULL, 4),
(175817, NULL, 'G3DSA:3.30.310.50:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175818, NULL, 'G3DSA:1.20.5.740:FF:000002', NULL, NULL, 'NudC domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(175819, NULL, 'G3DSA:1.10.287.70:FF:000369', NULL, NULL, 'Si:dkey-183j2.10', NULL, NULL, NULL, NULL, NULL, 4),
(175820, NULL, 'G3DSA:3.40.630.30:FF:000602', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175821, NULL, 'G3DSA:3.10.620.30:FF:000018', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(175822, NULL, 'G3DSA:3.30.40.10:FF:001150', NULL, NULL, 'E3 ubiquitin-protein ligase RMA1H1 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(175823, NULL, 'G3DSA:1.10.630.10:FF:000386', NULL, NULL, 'Os03g0568400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(175824, NULL, 'G3DSA:3.40.50.150:FF:000291', NULL, NULL, 'Benzoquinone methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(175825, NULL, 'G3DSA:3.10.20.90:FF:000560', NULL, NULL, 'E3 ubiquitin-protein ligase parkin', NULL, NULL, NULL, NULL, NULL, 4),
(175826, NULL, 'G3DSA:3.30.70.330:FF:001812', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175827, NULL, 'G3DSA:2.140.10.30:FF:000004', NULL, NULL, 'Omega, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(175828, NULL, 'G3DSA:1.20.120.1760:FF:000050', NULL, NULL, 'Phosphatidylcholine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(175829, NULL, 'G3DSA:2.60.40.10:FF:002353', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175830, NULL, 'G3DSA:2.30.30.1020:FF:000003', NULL, NULL, 'CCR4-NOT transcription complex subunit 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(175831, NULL, 'G3DSA:2.130.10.10:FF:001387', NULL, NULL, 'serine/threonine-protein kinase/endoribonuclease IRE1', NULL, NULL, NULL, NULL, NULL, 4),
(175832, NULL, 'G3DSA:1.10.472.80:FF:000089', NULL, NULL, 'GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(175833, NULL, 'G3DSA:3.40.1380.20:FF:000045', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(175834, NULL, 'G3DSA:1.10.510.10:FF:000332', NULL, NULL, 'TBC domain-containing protein kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(175835, NULL, 'G3DSA:1.20.1070.10:FF:001800', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175836, NULL, 'G3DSA:3.30.70.330:FF:001705', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175837, NULL, 'G3DSA:3.90.1750.10:FF:000003', NULL, NULL, 'E3 ubiquitin-protein ligase UPL1', NULL, NULL, NULL, NULL, NULL, 4),
(175838, NULL, 'G3DSA:1.10.287.110:FF:000123', NULL, NULL, 'Exported protein family 1', NULL, NULL, NULL, NULL, NULL, 4),
(175839, NULL, 'G3DSA:3.30.450.60:FF:000088', NULL, NULL, 'SRP54-type protein, putative', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(175840, NULL, 'G3DSA:4.10.1000.10:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175841, NULL, 'G3DSA:3.70.10.10:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175842, NULL, 'G3DSA:3.40.250.10:FF:000174', NULL, NULL, 'Putative rhodanese-like proteiny domain superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(175843, NULL, 'G3DSA:3.40.50.150:FF:000302', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175844, NULL, 'G3DSA:3.30.200.20:FF:001457', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175845, NULL, 'G3DSA:2.40.170.20:FF:000090', NULL, NULL, 'TonB-dependent receptor', NULL, NULL, NULL, NULL, NULL, 4),
(175846, NULL, 'G3DSA:3.40.50.720:FF:000844', NULL, NULL, 'Mitochondrial enoyl reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175847, NULL, 'G3DSA:3.30.360.10:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175848, NULL, 'G3DSA:3.30.70.260:FF:000038', NULL, NULL, 'Methionine import ATP-binding protein MetN', NULL, NULL, NULL, NULL, NULL, 4),
(175849, NULL, 'G3DSA:3.40.50.300:FF:003927', NULL, NULL, 'Small GTPase EhRabX35, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175850, NULL, 'G3DSA:1.25.40.800:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175851, NULL, 'G3DSA:3.40.630.30:FF:000591', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175852, NULL, 'G3DSA:3.40.50.300:FF:001786', NULL, NULL, 'DEAD/DEAH box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(175853, NULL, 'G3DSA:3.30.160.60:FF:004040', NULL, NULL, 'Suppressor of hairy wing, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(175854, NULL, 'G3DSA:2.40.70.10:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175855, NULL, 'G3DSA:3.30.70.1360:FF:000003', NULL, NULL, 'Global nitrogen regulator NrpR', NULL, NULL, NULL, NULL, NULL, 4),
(175856, NULL, 'G3DSA:1.25.40.10:FF:003426', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(175857, NULL, 'G3DSA:1.10.472.80:FF:000106', NULL, NULL, 'TBC/Rab GTPase activating domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(175858, NULL, 'G3DSA:1.25.10.10:FF:001569', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(175859, NULL, 'G3DSA:3.40.50.10810:FF:000210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175860, NULL, 'G3DSA:3.30.200.20:FF:001570', NULL, NULL, 'Ribosomal protein S6 kinase a, polypeptide 1', NULL, NULL, NULL, NULL, NULL, 4),
(175861, NULL, 'G3DSA:3.90.80.10:FF:000020', NULL, NULL, 'Inorganic pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(175862, NULL, 'G3DSA:2.10.60.10:FF:000081', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(175863, NULL, 'G3DSA:2.10.220.10:FF:000137', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5a', NULL, NULL, NULL, NULL, NULL, 4),
(175864, NULL, 'G3DSA:4.10.400.10:FF:000155', NULL, NULL, 'Low-density lipoprotein receptor', NULL, NULL, NULL, NULL, NULL, 4),
(175865, NULL, 'G3DSA:3.30.365.10:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175866, NULL, 'G3DSA:1.20.140.10:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175867, NULL, 'G3DSA:3.20.20.190:FF:000127', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175868, NULL, 'G3DSA:1.20.1110.10:FF:000113', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(175869, NULL, 'G3DSA:3.20.20.70:FF:000155', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(175870, NULL, 'G3DSA:1.10.238.10:FF:000412', NULL, NULL, 'Chromatin accessibility complex protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(175871, NULL, 'G3DSA:1.10.150.110:FF:000023', NULL, NULL, 'DNA polymerase/3''-5'' exonuclease PolX', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(175872, NULL, 'G3DSA:2.60.120.10:FF:000181', NULL, NULL, 'Beta-conglycinin beta subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(175873, NULL, 'G3DSA:1.25.10.10:FF:000153', NULL, NULL, 'Unc-45 myosin chaperone B', NULL, NULL, NULL, NULL, NULL, 4),
(175874, NULL, 'G3DSA:2.40.50.140:FF:001135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175875, NULL, 'G3DSA:3.90.550.10:FF:000415', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(175876, NULL, 'G3DSA:2.60.40.10:FF:000223', NULL, NULL, 'Platelet-derived growth factor receptor beta', NULL, NULL, NULL, NULL, NULL, 4),
(175877, NULL, 'G3DSA:3.60.21.10:FF:000244', NULL, NULL, 'Protein CBG04124', NULL, NULL, NULL, NULL, NULL, 4),
(175878, NULL, 'G3DSA:2.140.10.20:FF:000001', NULL, NULL, 'Nitrite reductase NirS', NULL, NULL, NULL, NULL, NULL, 4),
(175879, NULL, 'G3DSA:3.40.50.1000:FF:000303', NULL, NULL, 'Mitochondrial import inner membrane translocase subunit TIM50', NULL, NULL, NULL, NULL, NULL, 4),
(175880, NULL, 'G3DSA:3.80.10.10:FF:000954', NULL, NULL, 'Leucine_Rich_Repeat_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(175881, NULL, 'G3DSA:2.130.10.10:FF:002005', NULL, NULL, 'WD repeat domain 70', NULL, NULL, NULL, NULL, NULL, 4),
(175882, NULL, 'G3DSA:3.30.160.60:FF:005563', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175883, NULL, 'G3DSA:2.60.40.1730:FF:000046', NULL, NULL, 'Endoplasmic reticulum aminopeptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(175884, NULL, 'G3DSA:2.130.10.10:FF:003860', NULL, NULL, 'WD repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175885, NULL, 'G3DSA:3.30.420.510:FF:000018', NULL, NULL, 'Pantothenate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(175886, NULL, 'G3DSA:2.130.10.10:FF:005990', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(175887, NULL, 'G3DSA:3.30.160.60:FF:000436', NULL, NULL, 'PR domain zinc finger protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(175888, NULL, 'G3DSA:3.90.700.10:FF:000012', NULL, NULL, '3-ketosteroid-delta-1-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(175889, NULL, 'G3DSA:1.10.510.10:FF:000219', NULL, NULL, 'Putative serine/threonine-protein kinase Nek4', NULL, NULL, NULL, NULL, NULL, 4),
(175890, NULL, 'G3DSA:2.130.10.10:FF:002112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175891, NULL, 'G3DSA:1.10.10.10:FF:001619', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(175892, NULL, 'G3DSA:3.40.50.12760:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175893, NULL, 'G3DSA:1.20.5.300:FF:000005', NULL, NULL, 'cyclic nucleotide-gated cation channel alpha-4', NULL, NULL, NULL, NULL, NULL, 4),
(175894, NULL, 'G3DSA:3.40.50.300:FF:002404', NULL, NULL, 'ATP-dependent dethiobiotin synthetase BioD', NULL, NULL, NULL, NULL, NULL, 4),
(175895, NULL, 'G3DSA:3.30.70.1230:FF:000217', NULL, NULL, 'Adenylate cyclase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175896, NULL, 'G3DSA:1.10.12.10:FF:000045', NULL, NULL, 'Probable enoyl-CoA hydratase/isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(175897, NULL, 'G3DSA:2.30.29.30:FF:001070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175898, NULL, 'G3DSA:3.30.505.10:FF:000066', NULL, NULL, 'suppressor of cytokine signaling 3', NULL, NULL, NULL, NULL, NULL, 4),
(175899, NULL, 'G3DSA:3.40.1170.10:FF:000009', NULL, NULL, 'Mismatch repair ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(175900, NULL, 'G3DSA:1.50.40.10:FF:000366', NULL, NULL, 'Peroxisomal adenine nucleotide carrier 1 isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(175901, NULL, 'G3DSA:1.10.10.10:FF:000422', NULL, NULL, 'DNA-binding protein RFX7', NULL, NULL, NULL, NULL, NULL, 4),
(175902, NULL, 'G3DSA:3.90.1600.10:FF:000003', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(175903, NULL, 'G3DSA:3.40.50.150:FF:001825', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175904, NULL, 'G3DSA:1.25.40.10:FF:001285', NULL, NULL, 'Bardet-Biedl syndrome 4 (BBS4) protein-like protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(175905, NULL, 'G3DSA:3.30.950.10:FF:000027', NULL, NULL, 'Uroporphyrin-III C-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(175906, NULL, 'G3DSA:2.40.30.10:FF:000111', NULL, NULL, 'NADPH--cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(175907, NULL, 'G3DSA:3.40.50.300:FF:008019', NULL, NULL, 'Rho related BTB domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(175908, NULL, 'G3DSA:1.50.40.10:FF:000147', NULL, NULL, 'Solute carrier family 25 (Mitochondrial aspartate/glutamate transporter), member 12/13', NULL, NULL, NULL, NULL, NULL, 4),
(175909, NULL, 'G3DSA:3.40.50.300:FF:002511', NULL, NULL, 'Cytidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(175910, NULL, 'G3DSA:1.10.3080.10:FF:000073', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit E', NULL, NULL, NULL, NULL, NULL, 4),
(175911, NULL, 'G3DSA:3.40.50.300:FF:002623', NULL, NULL, 'Telomere length regulation protein ELG1', NULL, NULL, NULL, NULL, NULL, 4),
(175912, NULL, 'G3DSA:3.40.50.150:FF:001718', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175913, NULL, 'G3DSA:2.40.70.10:FF:000001', NULL, NULL, 'Gag-Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(175914, NULL, 'G3DSA:1.20.5.2050:FF:000005', NULL, NULL, 'Transcription factor with AP2 domain(S), putative', NULL, NULL, NULL, NULL, NULL, 4),
(175915, NULL, 'G3DSA:1.10.10.10:FF:001732', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(175916, NULL, 'G3DSA:2.130.10.10:FF:004242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175917, NULL, 'G3DSA:2.60.40.10:FF:003657', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175918, NULL, 'G3DSA:3.10.580.10:FF:000188', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(175919, NULL, 'G3DSA:1.25.40.10:FF:004033', NULL, NULL, 'Anaphase-promoting complex subunit cut9', NULL, NULL, NULL, NULL, NULL, 4),
(175920, NULL, 'G3DSA:3.80.10.10:FF:004445', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175921, NULL, 'G3DSA:3.30.70.330:FF:000868', NULL, NULL, 'RNA-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(175922, NULL, 'G3DSA:3.30.2160.10:FF:000011', NULL, NULL, 'LOW QUALITY PROTEIN: probable E3 ubiquitin-protein ligase HERC1', NULL, NULL, NULL, NULL, NULL, 4),
(175923, NULL, 'G3DSA:1.10.10.10:FF:000203', NULL, NULL, 'Vacuolar protein sorting 36 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(175924, NULL, 'G3DSA:3.40.30.10:FF:000726', NULL, NULL, 'Iodothyronine deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(175925, NULL, 'G3DSA:1.10.10.10:FF:000315', NULL, NULL, 'Developmental regulator FlbA', NULL, NULL, NULL, NULL, NULL, 4),
(175926, NULL, 'G3DSA:2.10.70.10:FF:000249', NULL, NULL, 'fibropellin-1-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(175927, NULL, 'G3DSA:2.40.100.10:FF:000043', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(175928, NULL, 'G3DSA:2.60.120.1000:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175929, NULL, 'G3DSA:3.40.1000.10:FF:000008', NULL, NULL, 'DUF1795 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(175930, NULL, 'G3DSA:3.40.50.1010:FF:000076', NULL, NULL, 'Ribonuclease VapC', NULL, NULL, NULL, NULL, NULL, 4),
(175931, NULL, 'G3DSA:1.20.1310.10:FF:000100', NULL, NULL, 'WGS project CABT00000000 data, contig 2.1', NULL, NULL, NULL, NULL, NULL, 4),
(175932, NULL, 'G3DSA:3.30.70.2030:FF:000002', NULL, NULL, 'Lysin N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(175933, NULL, 'G3DSA:3.60.20.40:FF:000037', NULL, NULL, 'Gamma-glutamyltransferase 5', NULL, NULL, NULL, NULL, NULL, 4),
(175934, NULL, 'G3DSA:3.30.530.20:FF:000032', NULL, NULL, 'Oligoketide cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(175935, NULL, 'G3DSA:1.25.40.10:FF:002122', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(175936, NULL, 'G3DSA:2.60.40.10:FF:002134', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(175937, NULL, 'G3DSA:3.20.20.60:FF:000152', NULL, NULL, 'Phosphonopyruvate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(175938, NULL, 'G3DSA:1.10.400.20:FF:000001', NULL, NULL, 'D-tagatose-1,6-bisphosphate aldolase subunit GatZ', NULL, NULL, NULL, NULL, NULL, 4),
(175939, NULL, 'G3DSA:3.30.200.20:FF:001238', NULL, NULL, 'Os08g0179000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(175940, NULL, 'G3DSA:1.10.8.1310:FF:000005', NULL, NULL, 'GTPase-activating protein gyp10', NULL, NULL, NULL, NULL, NULL, 4),
(175941, NULL, 'G3DSA:2.60.40.10:FF:005911', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175942, NULL, 'G3DSA:3.40.50.1000:FF:000073', NULL, NULL, 'Trehalose 6-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(175943, NULL, 'G3DSA:2.60.40.150:FF:000131', NULL, NULL, 'calpain-6', NULL, NULL, NULL, NULL, NULL, 4),
(175944, NULL, 'G3DSA:1.10.287.550:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175945, NULL, 'G3DSA:3.90.870.50:FF:000002', NULL, NULL, 'Carbamoyltransferase HypF', NULL, NULL, NULL, NULL, NULL, 4),
(175946, NULL, 'G3DSA:3.60.40.10:FF:000165', NULL, NULL, 'protein phosphatase 1F', NULL, NULL, NULL, NULL, NULL, 4),
(175947, NULL, 'G3DSA:1.20.1280.50:FF:000209', NULL, NULL, 'Os09g0555300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(175948, NULL, 'G3DSA:1.20.58.190:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175949, NULL, 'G3DSA:3.30.70.100:FF:000131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175950, NULL, 'G3DSA:3.90.190.10:FF:000444', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175951, NULL, 'G3DSA:1.10.10.10:FF:001951', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175952, NULL, 'G3DSA:3.20.20.140:FF:000359', NULL, NULL, 'Histidinol-phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175953, NULL, 'G3DSA:2.10.220.10:FF:000025', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(175954, NULL, 'G3DSA:3.30.70.330:FF:003049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175955, NULL, 'G3DSA:3.40.30.10:FF:000507', NULL, NULL, 'Thioredoxin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(175956, NULL, 'G3DSA:1.25.10.10:FF:001457', NULL, NULL, 'Related to VPS15-ser/thr protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(175957, NULL, 'G3DSA:3.40.50.150:FF:001595', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175958, NULL, 'G3DSA:2.30.30.380:FF:000058', NULL, NULL, 'Thioredoxin 1', NULL, NULL, NULL, NULL, NULL, 4),
(175959, NULL, 'G3DSA:3.60.21.60:FF:000012', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(175960, NULL, 'G3DSA:3.40.850.10:FF:000377', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175961, NULL, 'G3DSA:3.10.450.350:FF:000009', NULL, NULL, 'Peptidase M23', NULL, NULL, NULL, NULL, NULL, 4),
(175962, NULL, 'G3DSA:3.30.9.10:FF:000127', NULL, NULL, 'FAD-dependent oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(175963, NULL, 'G3DSA:2.130.10.130:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175964, NULL, 'G3DSA:3.20.20.60:FF:000040', NULL, NULL, 'Pyruvate, phosphate dikinase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(175965, NULL, 'G3DSA:3.40.50.300:FF:006002', NULL, NULL, 'Cell division control protein 48', NULL, NULL, NULL, NULL, NULL, 4),
(175966, NULL, 'G3DSA:3.30.10.20:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175967, NULL, 'G3DSA:1.10.8.60:FF:000554', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175968, NULL, 'G3DSA:2.130.10.10:FF:001617', NULL, NULL, 'WD40-repeat-containing domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(175969, NULL, 'G3DSA:2.30.30.40:FF:000412', NULL, NULL, 'Dynamin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(175970, NULL, 'G3DSA:3.30.70.1230:FF:000094', NULL, NULL, 'Guanylate cyclase soluble subunit beta-1', NULL, NULL, NULL, NULL, NULL, 4),
(175971, NULL, 'G3DSA:1.50.10.10:FF:000090', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(175972, NULL, 'G3DSA:3.40.50.300:FF:000257', NULL, NULL, 'UvrABC system protein B', NULL, NULL, NULL, NULL, NULL, 4),
(175973, NULL, 'G3DSA:2.130.10.10:FF:000190', NULL, NULL, 'Nuclear pore complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(175974, NULL, 'G3DSA:3.30.230.130:FF:000030', NULL, NULL, 'Cullin-4', NULL, NULL, NULL, NULL, NULL, 4),
(175975, NULL, 'G3DSA:1.20.120.1910:FF:000022', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(175976, NULL, 'G3DSA:1.20.1070.10:FF:000963', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175977, NULL, 'G3DSA:2.60.40.10:FF:001639', NULL, NULL, 'Putative beta-D-xylosidase 5', NULL, NULL, NULL, NULL, NULL, 4),
(175978, NULL, 'G3DSA:3.30.1490.110:FF:000006', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(175979, NULL, 'G3DSA:3.40.50.2300:FF:001109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175980, NULL, 'G3DSA:2.130.10.10:FF:002224', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit wuho', NULL, NULL, NULL, NULL, NULL, 4),
(175981, NULL, 'G3DSA:3.30.70.1230:FF:000105', NULL, NULL, 'Receptor-type guanylate cyclase gcy-21', NULL, NULL, NULL, NULL, NULL, 4),
(175982, NULL, 'G3DSA:1.10.287.70:FF:000588', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175983, NULL, 'G3DSA:3.30.160.60:FF:005782', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175984, NULL, 'G3DSA:4.10.860.120:FF:000026', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(175985, NULL, 'G3DSA:3.90.215.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175986, NULL, 'G3DSA:1.20.1560.10:FF:000826', NULL, NULL, 'ABC transporter multi-drug efflux transporter-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(175987, NULL, 'G3DSA:1.10.630.10:FF:000616', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175988, NULL, 'G3DSA:1.10.565.10:FF:000144', NULL, NULL, 'Nuclear receptor subfamily 4, group A, member 3', NULL, NULL, NULL, NULL, NULL, 4),
(175989, NULL, 'G3DSA:3.30.1490.120:FF:000009', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC8', NULL, NULL, NULL, NULL, NULL, 4),
(175990, NULL, 'G3DSA:2.60.120.380:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175991, NULL, 'G3DSA:2.60.40.10:FF:000442', NULL, NULL, 'Immunoglobulin lambda variable 2-8', NULL, NULL, NULL, NULL, NULL, 4),
(175992, NULL, 'G3DSA:2.60.40.10:FF:003876', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175993, NULL, 'G3DSA:3.40.50.10090:FF:000056', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(175994, NULL, 'G3DSA:1.25.40.10:FF:003538', NULL, NULL, 'Putative TPR repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(175995, NULL, 'G3DSA:3.40.50.2300:FF:001098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(175996, NULL, 'G3DSA:3.40.50.10140:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175997, NULL, 'G3DSA:1.10.540.10:FF:000160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(175998, NULL, 'G3DSA:3.40.50.10190:FF:000316', NULL, NULL, 'BRCA1-associated RING domain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(175999, NULL, 'G3DSA:1.10.287.90:FF:000021', NULL, NULL, 'Ubiquinol oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(176000, NULL, 'G3DSA:1.25.40.10:FF:005337', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g12300, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(176001, NULL, 'G3DSA:3.20.20.70:FF:000374', NULL, NULL, 'Pyridoxal 5''-phosphate synthase subunit PdxS', NULL, NULL, NULL, NULL, NULL, 4),
(176002, NULL, 'G3DSA:3.80.10.10:FF:000735', NULL, NULL, 'Erbb2 interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(176003, NULL, 'G3DSA:2.30.180.10:FF:000090', NULL, NULL, 'Fasciclin-1 fasciclin i fas i fcn', NULL, NULL, NULL, NULL, NULL, 4),
(176004, NULL, 'G3DSA:3.60.21.10:FF:000025', NULL, NULL, 'Protein UshA', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(176005, NULL, 'G3DSA:1.25.10.10:FF:002064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176006, NULL, 'G3DSA:3.30.420.10:FF:000274', NULL, NULL, '3''-5'' exoribonuclease parn-1', NULL, NULL, NULL, NULL, NULL, 4),
(176007, NULL, 'G3DSA:3.30.160.60:FF:004146', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176008, NULL, 'G3DSA:3.40.50.300:FF:004309', NULL, NULL, 'Small GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(176009, NULL, 'G3DSA:3.30.70.330:FF:001582', NULL, NULL, 'U1 small nuclear ribonucleoprotein 70 kDa homolog', NULL, NULL, NULL, NULL, NULL, 4),
(176010, NULL, 'G3DSA:4.10.240.10:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176011, NULL, 'G3DSA:3.30.70.330:FF:002200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176012, NULL, 'G3DSA:1.10.287.110:FF:000342', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176013, NULL, 'G3DSA:2.60.40.2300:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176014, NULL, 'G3DSA:1.20.58.1120:FF:000064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176015, NULL, 'G3DSA:3.30.160.60:FF:000217', NULL, NULL, 'Combgap, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(176016, NULL, 'G3DSA:2.30.29.30:FF:001300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176017, NULL, 'G3DSA:3.80.10.10:FF:001336', NULL, NULL, 'Tyrosine-sulfated glycopeptide receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(176018, NULL, 'G3DSA:3.40.1080.10:FF:000002', NULL, NULL, 'Succinyl-CoA:3-ketoacid-coenzyme A transferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(176019, NULL, 'G3DSA:3.10.20.90:FF:000341', NULL, NULL, 'Ubiquitin-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(176020, NULL, 'G3DSA:3.30.40.10:FF:001256', NULL, NULL, 'Dynein light chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(176021, NULL, 'G3DSA:1.20.58.60:FF:000788', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176022, NULL, 'G3DSA:3.30.1600.10:FF:000034', NULL, NULL, 'Histone deacetylase HDAC silent information regulator protein 2 Sir2 sirtuin', NULL, NULL, NULL, NULL, NULL, 4),
(176023, NULL, 'G3DSA:1.20.1280.50:FF:000086', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(176024, NULL, 'G3DSA:3.90.1750.10:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176025, NULL, 'G3DSA:3.40.630.30:FF:000372', NULL, NULL, 'Acyl-homoserine-lactone synthase', NULL, NULL, NULL, NULL, NULL, 4),
(176026, NULL, 'G3DSA:2.30.30.170:FF:000001', NULL, NULL, 'Internalin B', NULL, NULL, NULL, NULL, NULL, 4),
(176027, NULL, 'G3DSA:3.90.640.10:FF:000193', NULL, NULL, 'YALI0B10538p', NULL, NULL, NULL, NULL, NULL, 4),
(176028, NULL, 'G3DSA:3.30.160.60:FF:006400', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176029, NULL, 'G3DSA:3.30.450.40:FF:000312', NULL, NULL, 'Phosphodiesterase 11a,-like', NULL, NULL, NULL, NULL, NULL, 4),
(176030, NULL, 'G3DSA:3.40.1810.10:FF:000019', NULL, NULL, 'Agamous-like MADS-box protein AGL8', NULL, NULL, NULL, NULL, NULL, 4),
(176031, NULL, 'G3DSA:3.40.50.11340:FF:000021', NULL, NULL, 'Probable fucosyltransferase 9', NULL, NULL, NULL, NULL, NULL, 4),
(176032, NULL, 'G3DSA:3.40.605.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176033, NULL, 'G3DSA:1.10.20.10:FF:000142', NULL, NULL, 'DNA polymerase epsilon subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(176034, NULL, 'G3DSA:1.25.40.10:FF:003196', NULL, NULL, 'Os05g0534900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(176035, NULL, 'G3DSA:3.10.20.70:FF:000003', NULL, NULL, 'Glutamine synthetase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(176036, NULL, 'G3DSA:2.60.120.970:FF:000032', NULL, NULL, 'Growth differentiation factor 7', NULL, NULL, NULL, NULL, NULL, 4),
(176037, NULL, 'G3DSA:3.10.20.80:FF:000006', NULL, NULL, 'Translation initiation factor IF-3', NULL, NULL, NULL, NULL, NULL, 4),
(176038, NULL, 'G3DSA:1.20.120.350:FF:000075', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(176039, NULL, 'G3DSA:1.25.10.10:FF:001912', NULL, NULL, 'E3 ubiquitin-protein ligase listerin', NULL, NULL, NULL, NULL, NULL, 4),
(176040, NULL, 'G3DSA:3.40.50.300:FF:000038', NULL, NULL, 'Dynein heavy chain 5, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(176041, NULL, 'G3DSA:3.30.70.330:FF:001924', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176042, NULL, 'G3DSA:3.30.420.110:FF:000005', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(176043, NULL, 'G3DSA:1.10.510.10:FF:000113', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(176044, NULL, 'G3DSA:3.40.630.10:FF:000034', NULL, NULL, 'Succinyl-diaminopimelate desuccinylase', NULL, NULL, NULL, NULL, NULL, 4),
(176045, NULL, 'G3DSA:2.60.40.10:FF:005568', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176046, NULL, 'G3DSA:3.40.50.2300:FF:001441', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176047, NULL, 'G3DSA:2.30.30.140:FF:000127', NULL, NULL, 'YLR455W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(176048, NULL, 'G3DSA:3.10.20.90:FF:000009', NULL, NULL, 'Ubiquitin-60S ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(176049, NULL, 'G3DSA:3.10.50.40:FF:000070', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(176050, NULL, 'G3DSA:1.10.10.790:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176051, NULL, 'G3DSA:3.30.70.940:FF:000034', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(176052, NULL, 'G3DSA:3.40.50.300:FF:004080', NULL, NULL, 'GM17107', NULL, NULL, NULL, NULL, NULL, 4),
(176053, NULL, 'G3DSA:1.10.510.10:FF:001636', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(176054, NULL, 'G3DSA:1.25.40.10:FF:001740', NULL, NULL, 'Clustered mitochondria protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(176055, NULL, 'G3DSA:2.30.110.10:FF:000046', NULL, NULL, 'Transcriptional repressor of sporulation and protease synthase', NULL, NULL, NULL, NULL, NULL, 4),
(176056, NULL, 'G3DSA:3.40.50.300:FF:003708', NULL, NULL, 'Suppressor of ascus dominance 3', NULL, NULL, NULL, NULL, NULL, 4),
(176057, NULL, 'G3DSA:1.10.510.10:FF:004042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176058, NULL, 'G3DSA:1.20.1250.20:FF:000497', NULL, NULL, 'Putative MFS sugar transporter', NULL, NULL, NULL, NULL, NULL, 4),
(176059, NULL, 'G3DSA:3.40.50.2020:FF:000154', NULL, NULL, 'Hypoxanthine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(176060, NULL, 'G3DSA:1.10.510.10:FF:003766', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176061, NULL, 'G3DSA:3.20.20.60:FF:000039', NULL, NULL, '2,4-dihydroxyhept-2-ene-1,7-dioic acid aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(176062, NULL, 'G3DSA:3.40.50.1820:FF:000892', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(176063, NULL, 'G3DSA:2.10.50.10:FF:000035', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 3', NULL, NULL, NULL, NULL, NULL, 4),
(176064, NULL, 'G3DSA:3.40.50.1820:FF:001510', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176065, NULL, 'G3DSA:3.40.50.150:FF:000521', NULL, NULL, 'Ribosomal RNA-processing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(176066, NULL, 'G3DSA:1.10.1370.30:FF:000033', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(176067, NULL, 'G3DSA:3.30.160.60:FF:001853', NULL, NULL, 'Zinc finger protein 84', NULL, NULL, NULL, NULL, NULL, 4),
(176068, NULL, 'G3DSA:3.90.70.10:FF:000070', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 17-like protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(176069, NULL, 'G3DSA:3.40.190.10:FF:000005', NULL, NULL, 'Porphobilinogen deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(176070, NULL, 'G3DSA:2.40.290.10:FF:000045', NULL, NULL, 'ATP-dependent DNA helicase II subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(176071, NULL, 'G3DSA:2.40.10.10:FF:000003', NULL, NULL, 'Transmembrane serine protease 3', NULL, NULL, NULL, NULL, NULL, 4),
(176072, NULL, 'G3DSA:3.40.50.300:FF:007637', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(176073, NULL, 'G3DSA:1.20.1270.60:FF:000263', NULL, NULL, 'Rho GTPase-activating protein 26-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(176074, NULL, 'G3DSA:3.30.40.10:FF:001711', NULL, NULL, 'Non-structural maintenance of chromosomes element 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(176075, NULL, 'G3DSA:2.60.40.10:FF:001858', NULL, NULL, 'Hemicentin 2', NULL, NULL, NULL, NULL, NULL, 4),
(176076, NULL, 'G3DSA:3.90.70.10:FF:000412', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(176077, NULL, 'G3DSA:3.40.50.740:FF:000041', NULL, NULL, 'Putative oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(176078, NULL, 'G3DSA:3.40.50.300:FF:000370', NULL, NULL, 'Structural maintenance of chromosomes 3', NULL, NULL, NULL, NULL, NULL, 4),
(176079, NULL, 'G3DSA:3.40.50.300:FF:008351', NULL, NULL, 'ABC transporter ATP-binding protein RamB', NULL, NULL, NULL, NULL, NULL, 4),
(176080, NULL, 'G3DSA:3.30.1490.20:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176081, NULL, 'G3DSA:2.180.10.10:FF:000002', NULL, NULL, 'Teneurin transmembrane protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(176082, NULL, 'G3DSA:3.50.50.60:FF:000973', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(176083, NULL, 'G3DSA:4.10.410.10:FF:000094', NULL, NULL, 'Seminal fluid protein 24C1', NULL, NULL, NULL, NULL, NULL, 4),
(176084, NULL, 'G3DSA:3.40.50.450:FF:000055', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(176085, NULL, 'G3DSA:2.60.40.60:FF:000209', NULL, NULL, 'neural-cadherin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(176086, NULL, 'G3DSA:2.160.20.20:FF:000001', NULL, NULL, 'Possible enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(176087, NULL, 'G3DSA:1.20.1280.50:FF:000210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176088, NULL, 'G3DSA:1.20.1070.10:FF:000289', NULL, NULL, 'G protein-coupled receptor 78', NULL, NULL, NULL, NULL, NULL, 4),
(176089, NULL, 'G3DSA:3.30.420.270:FF:000025', NULL, NULL, 'Biopolymer transporter ExbD', NULL, NULL, NULL, NULL, NULL, 4),
(176090, NULL, 'G3DSA:2.60.120.10:FF:000287', NULL, NULL, 'Mannose-6-phosphate isomerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(176091, NULL, 'G3DSA:3.90.76.10:FF:000021', NULL, NULL, 'Putative ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(176092, NULL, 'G3DSA:2.60.40.1230:FF:000003', NULL, NULL, 'AP-2 complex subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(176093, NULL, 'G3DSA:3.30.160.60:FF:004601', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176094, NULL, 'G3DSA:3.40.30.10:FF:000384', NULL, NULL, 'Glutaredoxin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(176095, NULL, 'G3DSA:2.60.40.10:FF:005787', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176096, NULL, 'G3DSA:3.90.105.20:FF:000019', NULL, NULL, 'Ribosome assembly factor mrt4', NULL, NULL, NULL, NULL, NULL, 4),
(176097, NULL, 'G3DSA:3.20.20.220:FF:000052', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(176098, NULL, 'G3DSA:1.20.58.390:FF:000306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176099, NULL, 'G3DSA:3.30.300.150:FF:000002', NULL, NULL, 'DNA polymerase III subunit gamma/tau', NULL, NULL, NULL, NULL, NULL, 4),
(176100, NULL, 'G3DSA:3.10.20.90:FF:000228', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(176101, NULL, 'G3DSA:2.60.40.10:FF:000004', NULL, NULL, 'DCC isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(176102, NULL, 'G3DSA:2.60.120.330:FF:000183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176103, NULL, 'G3DSA:3.30.1330.30:FF:000047', NULL, NULL, '40S ribosomal protein S12', NULL, NULL, NULL, NULL, NULL, 4),
(176104, NULL, 'G3DSA:3.30.1640.10:FF:000031', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(176105, NULL, 'G3DSA:1.20.1070.10:FF:001126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176106, NULL, 'G3DSA:1.25.40.10:FF:001627', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(176107, NULL, 'G3DSA:1.10.287.4290:FF:000001', NULL, NULL, 'Peroxisomal multifunctional enzyme type 2', NULL, NULL, NULL, NULL, NULL, 4),
(176108, NULL, 'G3DSA:1.25.10.10:FF:003368', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176109, NULL, 'G3DSA:2.60.40.10:FF:006063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176110, NULL, 'G3DSA:4.10.240.10:FF:000058', NULL, NULL, 'Unplaced genomic scaffold supercont1.35, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(176111, NULL, 'G3DSA:3.40.50.1820:FF:000779', NULL, NULL, 'Serine hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(176112, NULL, 'G3DSA:1.10.10.10:FF:001838', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(176113, NULL, 'G3DSA:3.10.250.10:FF:000091', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176114, NULL, 'G3DSA:1.10.238.10:FF:000631', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176115, NULL, 'G3DSA:1.10.510.10:FF:000551', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(176116, NULL, 'G3DSA:3.30.70.980:FF:000017', NULL, NULL, 'Probable transcriptional regulatory protein HP_0162', NULL, NULL, NULL, NULL, NULL, 4),
(176117, NULL, 'G3DSA:2.10.90.10:FF:000032', NULL, NULL, 'Artemin', NULL, NULL, NULL, NULL, NULL, 4),
(176118, NULL, 'G3DSA:3.30.750.44:FF:000008', NULL, NULL, 'retinol-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(176119, NULL, 'G3DSA:1.10.10.10:FF:002114', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(176120, NULL, 'G3DSA:3.40.50.1820:FF:001055', NULL, NULL, 'Neuroligin 1', NULL, NULL, NULL, NULL, NULL, 4),
(176121, NULL, 'G3DSA:1.10.150.850:FF:000008', NULL, NULL, 'Putative transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(176122, NULL, 'G3DSA:1.10.287.950:FF:000026', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(176123, NULL, 'G3DSA:2.20.25.630:FF:000002', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(176124, NULL, 'G3DSA:1.10.10.980:FF:000006', NULL, NULL, 'CST complex subunit STN1', NULL, NULL, NULL, NULL, NULL, 4),
(176125, NULL, 'G3DSA:2.10.70.10:FF:000143', NULL, NULL, 'CUB and sushi domain-containing protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(176126, NULL, 'G3DSA:2.10.25.10:FF:000634', NULL, NULL, 'Starry night, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(176127, NULL, 'G3DSA:3.40.50.300:FF:007295', NULL, NULL, 'Si:dkey-79f11.7', NULL, NULL, NULL, NULL, NULL, 4),
(176128, NULL, 'G3DSA:1.20.58.60:FF:000569', NULL, NULL, 'Spectrin, beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(176129, NULL, 'G3DSA:2.60.40.1090:FF:000034', NULL, NULL, 'Fimbrial family protein', NULL, NULL, NULL, NULL, NULL, 4),
(176130, NULL, 'G3DSA:3.30.200.20:FF:001912', NULL, NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 156', NULL, NULL, NULL, NULL, NULL, 4),
(176131, NULL, 'G3DSA:1.10.10.60:FF:000302', NULL, NULL, 'Transcription factor TT2', NULL, NULL, NULL, NULL, NULL, 4),
(176132, NULL, 'G3DSA:1.10.468.10:FF:000002', NULL, NULL, 'Photosynthetic reaction center cytochrome c subunit', NULL, NULL, NULL, NULL, NULL, 4),
(176133, NULL, 'G3DSA:1.20.5.2440:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176134, NULL, 'G3DSA:3.40.50.300:FF:000712', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(176135, NULL, 'G3DSA:1.20.5.5200:FF:000001', NULL, NULL, 'Stimulator of interferon genes protein', NULL, NULL, NULL, NULL, NULL, 4),
(176136, NULL, 'G3DSA:1.20.5.170:FF:000258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176137, NULL, 'G3DSA:1.20.58.480:FF:000002', NULL, NULL, 'Tryptophan 2,3-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(176138, NULL, 'G3DSA:2.10.25.10:FF:000853', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(176139, NULL, 'G3DSA:2.30.39.10:FF:000064', NULL, NULL, 'GM19657', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(176140, NULL, 'G3DSA:2.60.40.60:FF:000322', NULL, NULL, 'Protocadherin Fat', NULL, NULL, NULL, NULL, NULL, 4),
(176141, NULL, 'G3DSA:3.30.1330.20:FF:000044', NULL, NULL, 'Tubulin-like protein CetZ', NULL, NULL, NULL, NULL, NULL, 4),
(176142, NULL, 'G3DSA:3.30.160.60:FF:003983', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176143, NULL, 'G3DSA:1.20.1250.20:FF:000839', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(176144, NULL, 'G3DSA:3.30.70.330:FF:002886', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176145, NULL, 'G3DSA:2.130.10.10:FF:000313', NULL, NULL, 'Chromatin assembly factor 1 subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(176146, NULL, 'G3DSA:1.10.540.10:FF:000047', NULL, NULL, 'Putative acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(176147, NULL, 'G3DSA:3.40.50.11380:FF:000004', NULL, NULL, 'UDP-N-acetylglucosaminyltransferase (AFU_orthologue AFUA_1G03380)', NULL, NULL, NULL, NULL, NULL, 4),
(176148, NULL, 'G3DSA:1.20.1070.10:FF:001345', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176149, NULL, 'G3DSA:2.40.50.140:FF:000859', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176150, NULL, 'G3DSA:3.90.1290.10:FF:000074', NULL, NULL, 'Short stop, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(176151, NULL, 'G3DSA:1.10.287.70:FF:000482', NULL, NULL, 'TWiK family of potassium channels', NULL, NULL, NULL, NULL, NULL, 4),
(176152, NULL, 'G3DSA:3.40.710.10:FF:000092', NULL, NULL, 'Cell division protein FtsI (Penicillin-binding protein 3)', NULL, NULL, NULL, NULL, NULL, 4),
(176153, NULL, 'G3DSA:3.40.50.300:FF:004422', NULL, NULL, 'Aerobic cobaltochelatase subunit CobS', NULL, NULL, NULL, NULL, NULL, 4),
(176154, NULL, 'G3DSA:2.130.10.10:FF:003747', NULL, NULL, 'Protein FAM234A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(176155, NULL, 'G3DSA:1.25.40.10:FF:005118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176156, NULL, 'G3DSA:3.30.30.30:FF:000019', NULL, NULL, 'Heat shock 70 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(176157, NULL, 'G3DSA:1.20.1250.20:FF:001115', NULL, NULL, 'AGAP006349-PA', NULL, NULL, NULL, NULL, NULL, 4),
(176158, NULL, 'G3DSA:2.60.40.10:FF:003770', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176159, NULL, 'G3DSA:1.10.720.30:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176160, NULL, 'G3DSA:3.10.20.30:FF:000020', NULL, NULL, 'Xanthine dehydrogenase iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4),
(176161, NULL, 'G3DSA:2.60.40.60:FF:000541', NULL, NULL, 'protocadherin-11 X-linked', NULL, NULL, NULL, NULL, NULL, 4),
(176162, NULL, 'G3DSA:1.20.58.1360:FF:000006', NULL, NULL, 'Lysine (K)-specific demethylase 2Aa', NULL, NULL, NULL, NULL, NULL, 4),
(176163, NULL, 'G3DSA:1.10.150.50:FF:000125', NULL, NULL, 'Protein CBG01454', NULL, NULL, NULL, NULL, NULL, 4),
(176164, NULL, 'G3DSA:1.25.40.10:FF:001408', NULL, NULL, 'NASP-like protein sim3', NULL, NULL, NULL, NULL, NULL, 4),
(176165, NULL, 'G3DSA:3.40.50.10190:FF:000193', NULL, NULL, 'DNA-directed DNA/RNA polymerase mu', NULL, NULL, NULL, NULL, NULL, 4),
(176166, NULL, 'G3DSA:1.10.240.10:FF:000007', NULL, NULL, 'Tryptophan--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(176167, NULL, 'G3DSA:2.20.28.10:FF:000011', NULL, NULL, 'DNA replication licensing factor MCM5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(176168, NULL, 'G3DSA:2.60.120.620:FF:000056', NULL, NULL, 'GD12338', NULL, NULL, NULL, NULL, NULL, 4),
(176169, NULL, 'G3DSA:3.30.70.240:FF:000032', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(176170, NULL, 'G3DSA:2.130.10.10:FF:004023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176171, NULL, 'G3DSA:2.60.40.10:FF:003438', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176172, NULL, 'G3DSA:1.10.555.10:FF:000205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176173, NULL, 'G3DSA:3.70.10.10:FF:000022', NULL, NULL, 'Checkpoint protein MEC3', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(176174, NULL, 'G3DSA:3.30.40.10:FF:001037', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(176175, NULL, 'G3DSA:3.40.50.300:FF:000151', NULL, NULL, 'Lipopolysaccharide ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(176176, NULL, 'G3DSA:1.10.10.10:FF:001496', NULL, NULL, 'P protein', NULL, NULL, NULL, NULL, NULL, 4),
(176177, NULL, 'G3DSA:3.30.310.10:FF:000046', NULL, NULL, 'TATA-box binding protein like 2', NULL, NULL, NULL, NULL, NULL, 4),
(176178, NULL, 'G3DSA:3.40.50.300:FF:008132', NULL, NULL, 'Kl-2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(176179, NULL, 'G3DSA:3.40.50.1240:FF:000015', NULL, NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(176180, NULL, 'G3DSA:1.10.510.10:FF:003985', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176181, NULL, 'G3DSA:1.10.3500.10:FF:000005', NULL, NULL, 'Transcription elongation factor Spt6', NULL, NULL, NULL, NULL, NULL, 4),
(176182, NULL, 'G3DSA:2.170.16.10:FF:000038', NULL, NULL, 'Vitamin B12-dependent ribonucleotide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(176183, NULL, 'G3DSA:3.40.630.30:FF:000259', NULL, NULL, 'Protein CBG07665', NULL, NULL, NULL, NULL, NULL, 4),
(176184, NULL, 'G3DSA:2.40.40.20:FF:000053', NULL, NULL, 'Formate dehydrogenase, alpha subunit, selenocysteine-containing', NULL, NULL, NULL, NULL, NULL, 4),
(176185, NULL, 'G3DSA:3.40.50.300:FF:007856', NULL, NULL, 'Putative ABC transporter ATP-binding MG390', NULL, NULL, NULL, NULL, NULL, 4),
(176186, NULL, 'G3DSA:3.30.60.30:FF:000066', NULL, NULL, 'Blast:Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(176187, NULL, 'G3DSA:2.130.10.10:FF:003186', NULL, NULL, 'Transducin/WD-40 repeat protein family', NULL, NULL, NULL, NULL, NULL, 4),
(176188, NULL, 'G3DSA:1.20.144.10:FF:000130', NULL, NULL, 'PAP2 superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(176189, NULL, 'G3DSA:3.40.50.10470:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176190, NULL, 'G3DSA:1.10.3210.10:FF:000123', NULL, NULL, 'Uncharacterized protein MG461', NULL, NULL, NULL, NULL, NULL, 4),
(176191, NULL, 'G3DSA:3.30.70.100:FF:000018', NULL, NULL, 'MscS mechanosensitive ion channel', NULL, NULL, NULL, NULL, NULL, 4),
(176192, NULL, 'G3DSA:1.10.510.10:FF:004261', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176193, NULL, 'G3DSA:3.30.160.60:FF:002152', NULL, NULL, 'zinc finger protein ZFP69 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(176194, NULL, 'G3DSA:3.40.50.2000:FF:000441', NULL, NULL, 'Trehalose 6-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(176195, NULL, 'G3DSA:1.10.167.10:FF:000074', NULL, NULL, 'RGS domain-containing serine/threonine-protein kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(176196, NULL, 'G3DSA:1.25.40.10:FF:001959', NULL, NULL, 'Tetratricopeptide repeat domain 21B', NULL, NULL, NULL, NULL, NULL, 4),
(176197, NULL, 'G3DSA:3.40.50.300:FF:004159', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(176198, NULL, 'G3DSA:2.60.40.2220:FF:000003', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(176199, NULL, 'G3DSA:3.40.50.410:FF:000038', NULL, NULL, 'integrator complex subunit 14 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(176200, NULL, 'G3DSA:2.130.10.10:FF:002208', NULL, NULL, 'Lethal giant larvae', NULL, NULL, NULL, NULL, NULL, 4),
(176201, NULL, 'G3DSA:3.30.40.10:FF:001392', NULL, NULL, 'SNF2 family N-terminal domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(176202, NULL, 'G3DSA:3.60.15.10:FF:000028', NULL, NULL, 'Integrator complex subunit 11 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(176203, NULL, 'G3DSA:3.30.200.20:FF:002335', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176204, NULL, 'G3DSA:2.120.10.30:FF:000270', NULL, NULL, 'Putative low-density lipoprotein receptor', NULL, NULL, NULL, NULL, NULL, 4),
(176205, NULL, 'G3DSA:3.80.10.10:FF:002759', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(176206, NULL, 'G3DSA:3.40.50.1010:FF:000127', NULL, NULL, 'Putative endonuclease or glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(176207, NULL, 'G3DSA:2.40.70.10:FF:000569', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176208, NULL, 'G3DSA:1.10.150.80:FF:000039', NULL, NULL, 'ATP-dependent DNA helicase RecQ family protein', NULL, NULL, NULL, NULL, NULL, 4),
(176209, NULL, 'G3DSA:3.40.50.10470:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176210, NULL, 'G3DSA:3.40.50.300:FF:007918', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176211, NULL, 'G3DSA:1.10.630.10:FF:000061', NULL, NULL, 'Cytochrome P450 90B1', NULL, NULL, NULL, NULL, NULL, 4),
(176212, NULL, 'G3DSA:4.10.400.10:FF:000313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176213, NULL, 'G3DSA:1.25.40.1030:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176214, NULL, 'G3DSA:3.40.367.20:FF:000004', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(176215, NULL, 'G3DSA:1.10.10.580:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176216, NULL, 'G3DSA:1.20.1270.220:FF:000004', NULL, NULL, 'Bdf1p', NULL, NULL, NULL, NULL, NULL, 4),
(176217, NULL, 'G3DSA:2.160.20.10:FF:000257', NULL, NULL, 'Os04g0553650 protein', NULL, NULL, NULL, NULL, NULL, 4),
(176218, NULL, 'G3DSA:3.30.160.60:FF:004922', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176219, NULL, 'G3DSA:2.60.40.10:FF:001567', NULL, NULL, 'PKHD1 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(176220, NULL, 'G3DSA:3.40.30.10:FF:000497', NULL, NULL, 'Glutathione S-Transferase', NULL, NULL, NULL, NULL, NULL, 4),
(176221, NULL, 'G3DSA:1.20.58.760:FF:000014', NULL, NULL, 'ATP-dependent zinc metalloprotease FTSH 12, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(176222, NULL, 'G3DSA:1.50.40.10:FF:000086', NULL, NULL, 'Mitochondrial carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(176223, NULL, 'G3DSA:3.30.1490.120:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176224, NULL, 'G3DSA:2.20.25.10:FF:000044', NULL, NULL, 'BRF (Transcription factor) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(176225, NULL, 'G3DSA:1.25.40.180:FF:000224', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176226, NULL, 'G3DSA:3.40.190.10:FF:000809', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176227, NULL, 'G3DSA:3.40.50.300:FF:003703', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(176228, NULL, 'G3DSA:3.30.1520.10:FF:000118', NULL, NULL, 'Sorting nexin', NULL, NULL, NULL, NULL, NULL, 4),
(176229, NULL, 'G3DSA:3.40.640.10:FF:000238', NULL, NULL, 'Molybdenum cofactor sulfurase', NULL, NULL, NULL, NULL, NULL, 4),
(176230, NULL, 'G3DSA:1.20.990.10:FF:000057', NULL, NULL, 'Nitric oxide synthase, inducible', NULL, NULL, NULL, NULL, NULL, 4),
(176231, NULL, 'G3DSA:2.30.30.40:FF:000340', NULL, NULL, 'Cytokinesis protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(176232, NULL, 'G3DSA:3.40.50.300:FF:008493', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176233, NULL, 'G3DSA:2.20.100.10:FF:000149', NULL, NULL, 'Protein CBR-MADD-4', NULL, NULL, NULL, NULL, NULL, 4),
(176234, NULL, 'G3DSA:2.30.33.40:FF:000021', NULL, NULL, 'Chaperonin 20', NULL, NULL, NULL, NULL, NULL, 4),
(176235, NULL, 'G3DSA:3.40.50.300:FF:005148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176236, NULL, 'G3DSA:3.40.50.150:FF:000443', NULL, NULL, 'Magnesium-protoporphyrin ix methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(176237, NULL, 'G3DSA:3.40.50.800:FF:000065', NULL, NULL, 'Histidine--tRNA ligase protein', NULL, NULL, NULL, NULL, NULL, 4),
(176238, NULL, 'G3DSA:1.25.40.10:FF:003084', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(176239, NULL, 'G3DSA:1.10.287.690:FF:000011', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(176240, NULL, 'G3DSA:3.40.50.300:FF:002394', NULL, NULL, 'Possible conserved transmembrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(176241, NULL, 'G3DSA:3.30.110.30:FF:000009', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(176242, NULL, 'G3DSA:3.40.50.2020:FF:000008', NULL, NULL, 'Orotate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(176243, NULL, 'G3DSA:3.20.20.140:FF:000259', NULL, NULL, 'Amidohydrolase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(176244, NULL, 'G3DSA:1.10.287.110:FF:000326', NULL, NULL, 'DnaJ domain protein (AFU_orthologue AFUA_1G03520)', NULL, NULL, NULL, NULL, NULL, 4),
(176245, NULL, 'G3DSA:1.25.40.10:FF:004040', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(176246, NULL, 'G3DSA:1.20.1250.10:FF:000096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176247, NULL, 'G3DSA:3.40.640.10:FF:000390', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176248, NULL, 'G3DSA:3.40.50.720:FF:001648', NULL, NULL, 'Epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(176249, NULL, 'G3DSA:2.30.30.490:FF:000098', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(176250, NULL, 'G3DSA:1.20.58.1250:FF:000007', NULL, NULL, 'Tubulin-specific chaperone C', NULL, NULL, NULL, NULL, NULL, 4),
(176251, NULL, 'G3DSA:3.40.50.1820:FF:000836', NULL, NULL, 'Protein phosphatase methylesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(176252, NULL, 'G3DSA:3.80.10.10:FF:000994', NULL, NULL, 'Cytoskeleton associated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(176253, NULL, 'G3DSA:1.25.10.10:FF:001339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176254, NULL, 'G3DSA:2.60.40.10:FF:002556', NULL, NULL, 'Protein CBG19196', NULL, NULL, NULL, NULL, NULL, 4),
(176255, NULL, 'G3DSA:1.10.8.720:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176256, NULL, 'G3DSA:1.20.1070.10:FF:000531', NULL, NULL, 'G-protein coupled octopamine receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(176257, NULL, 'G3DSA:1.10.565.10:FF:000021', NULL, NULL, 'Vitamin D3 receptor B', NULL, NULL, NULL, NULL, NULL, 4),
(176258, NULL, 'G3DSA:3.90.70.80:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176259, NULL, 'G3DSA:1.10.510.10:FF:003340', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176260, NULL, 'G3DSA:3.40.50.11030:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176261, NULL, 'G3DSA:1.20.120.1750:FF:000137', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(176262, NULL, 'G3DSA:1.20.5.340:FF:000063', NULL, NULL, 'Putative unconventional myosin-XVIIIa', NULL, NULL, NULL, NULL, NULL, 4),
(176263, NULL, 'G3DSA:3.30.70.580:FF:000016', NULL, NULL, 'Pseudouridylate synthase 3', NULL, NULL, NULL, NULL, NULL, 4),
(176264, NULL, 'G3DSA:3.40.50.80:FF:000148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176265, NULL, 'G3DSA:2.60.40.2840:FF:000014', NULL, NULL, 'Putative e3 ubiquitin ligase', NULL, NULL, NULL, NULL, NULL, 4),
(176266, NULL, 'G3DSA:1.25.40.20:FF:000827', NULL, NULL, 'Ankyrin 1', NULL, NULL, NULL, NULL, NULL, 4),
(176267, NULL, 'G3DSA:2.120.10.80:FF:000291', NULL, NULL, 'TatD related DNase', NULL, NULL, NULL, NULL, NULL, 4),
(176268, NULL, 'G3DSA:3.90.1100.10:FF:000005', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(176269, NULL, 'G3DSA:1.10.132.70:FF:000022', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(176270, NULL, 'G3DSA:1.10.472.10:FF:000541', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176271, NULL, 'G3DSA:3.20.20.60:FF:000124', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(176272, NULL, 'G3DSA:3.80.10.10:FF:003748', NULL, NULL, 'AGAP007451-PA', NULL, NULL, NULL, NULL, NULL, 4),
(176273, NULL, 'G3DSA:3.30.160.60:FF:005378', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(176274, NULL, 'G3DSA:3.30.160.60:FF:003141', NULL, NULL, 'Zinc finger protein 585B-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(176275, NULL, 'G3DSA:1.10.150.60:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176276, NULL, 'G3DSA:3.40.30.10:FF:000025', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(176277, NULL, 'G3DSA:1.10.150.50:FF:000176', NULL, NULL, 'Protein tyrosine phosphatase, receptor type, f polypeptide (PTPRF),-interacting protein (liprin), alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(176278, NULL, 'G3DSA:3.10.20.90:FF:000280', NULL, NULL, 'Small ubiquitin-related modifier', NULL, NULL, NULL, NULL, NULL, 4),
(176279, NULL, 'G3DSA:3.90.420.10:FF:000002', NULL, NULL, 'sulfite oxidase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(176280, NULL, 'G3DSA:1.10.230.10:FF:000013', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(176281, NULL, 'G3DSA:1.10.10.1050:FF:000012', NULL, NULL, 'DCP2 decapping enzyme homolog (S. cerevisiae)', NULL, NULL, NULL, NULL, NULL, 4),
(176282, NULL, 'G3DSA:3.30.60.30:FF:000033', NULL, NULL, 'Serine peptidase inhibitor, Kazal type 5', NULL, NULL, NULL, NULL, NULL, 4),
(176283, NULL, 'G3DSA:1.10.287.70:FF:000465', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176284, NULL, 'G3DSA:1.10.533.10:FF:000211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176285, NULL, 'G3DSA:1.20.1110.10:FF:000086', NULL, NULL, 'Putative calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(176286, NULL, 'G3DSA:2.60.40.420:FF:000179', NULL, NULL, 'Multicopper oxidase, manganese oxidase family', NULL, NULL, NULL, NULL, NULL, 4),
(176287, NULL, 'G3DSA:1.10.472.80:FF:000129', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(176288, NULL, 'G3DSA:3.40.50.1000:FF:000450', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176289, NULL, 'G3DSA:3.30.310.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176290, NULL, 'G3DSA:3.30.160.60:FF:004130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176291, NULL, 'G3DSA:2.60.40.1090:FF:000017', NULL, NULL, 'Type 1 fimbrin D-mannose specific adhesin', NULL, NULL, NULL, NULL, NULL, 4),
(176292, NULL, 'G3DSA:1.20.1050.130:FF:000001', NULL, NULL, 'Putative Elongation factor 1-beta', NULL, NULL, NULL, NULL, NULL, 4),
(176293, NULL, 'G3DSA:2.60.40.10:FF:003545', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176294, NULL, 'G3DSA:2.10.90.10:FF:000111', NULL, NULL, 'Platelet-derived growth factor subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(176295, NULL, 'G3DSA:2.30.110.10:FF:000069', NULL, NULL, 'Pyridoxine/pyridoxamine 5''-phosphate oxidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(176296, NULL, 'G3DSA:3.30.460.10:FF:000198', NULL, NULL, 'Ribosomal silencing factor RsfS', NULL, NULL, NULL, NULL, NULL, 4),
(176297, NULL, 'G3DSA:2.170.270.10:FF:000008', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(176298, NULL, 'G3DSA:3.50.50.80:FF:000007', NULL, NULL, 'Ubiquitin-activating enzyme E1', NULL, NULL, NULL, NULL, NULL, 4),
(176299, NULL, 'G3DSA:1.20.1250.20:FF:000306', NULL, NULL, 'MFS multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(176300, NULL, 'G3DSA:2.60.120.920:FF:000164', NULL, NULL, 'Ash2-like, histone lysine methyltransferase complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(176301, NULL, 'G3DSA:3.20.20.80:FF:000782', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176302, NULL, 'G3DSA:2.130.10.10:FF:005114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176303, NULL, 'G3DSA:1.10.10.60:FF:000432', NULL, NULL, 'SWR1-complex protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(176304, NULL, 'G3DSA:3.30.420.10:FF:000252', NULL, NULL, 'Ydc2-catalyt-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(176305, NULL, 'G3DSA:2.130.10.10:FF:004625', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(176306, NULL, 'G3DSA:2.30.30.620:FF:000007', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(176307, NULL, 'G3DSA:2.10.25.10:FF:001141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176308, NULL, 'G3DSA:3.10.20.90:FF:000128', NULL, NULL, 'Plexin C1', NULL, NULL, NULL, NULL, NULL, 4),
(176309, NULL, 'G3DSA:3.40.30.10:FF:000817', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(176310, NULL, 'G3DSA:3.40.630.10:FF:000153', NULL, NULL, 'Silver, isoform N', NULL, NULL, NULL, NULL, NULL, 4),
(176311, NULL, 'G3DSA:3.60.21.10:FF:000121', NULL, NULL, 'Probable phosphoesterase', NULL, NULL, NULL, NULL, NULL, 4),
(176312, NULL, 'G3DSA:3.50.50.60:FF:000440', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(176313, NULL, 'G3DSA:1.50.40.10:FF:000406', NULL, NULL, 'ADP,ATP carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(176314, NULL, 'G3DSA:3.40.1190.20:FF:000014', NULL, NULL, 'ADO1p Adenosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(176315, NULL, 'G3DSA:2.10.220.10:FF:000121', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(176316, NULL, 'G3DSA:2.60.40.60:FF:000340', NULL, NULL, 'Protocadherin Fat 4', NULL, NULL, NULL, NULL, NULL, 4),
(176317, NULL, 'G3DSA:3.40.630.30:FF:000159', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(176318, NULL, 'G3DSA:3.30.70.330:FF:000638', NULL, NULL, 'Serine/arginine-rich splicing factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(176319, NULL, 'G3DSA:1.25.40.10:FF:001167', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(176320, NULL, 'G3DSA:2.60.120.650:FF:000240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176321, NULL, 'G3DSA:2.130.10.10:FF:000443', NULL, NULL, 'U4/U6 small nuclear ribonucleoprotein Prp4', NULL, NULL, NULL, NULL, NULL, 4),
(176322, NULL, 'G3DSA:1.25.40.10:FF:002095', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(176323, NULL, 'G3DSA:2.60.120.290:FF:000109', NULL, NULL, 'GD15286', NULL, NULL, NULL, NULL, NULL, 4),
(176324, NULL, 'G3DSA:3.20.20.190:FF:000021', NULL, NULL, 'PI-PLC X domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(176325, NULL, 'G3DSA:1.10.238.10:FF:000834', NULL, NULL, 'GM20995', NULL, NULL, NULL, NULL, NULL, 4),
(176326, NULL, 'G3DSA:1.20.1560.10:FF:000759', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(176327, NULL, 'G3DSA:1.10.10.10:FF:000350', NULL, NULL, 'Selenocysteine-specific translation elongation factor', NULL, NULL, NULL, NULL, NULL, 4),
(176328, NULL, 'G3DSA:3.50.50.60:FF:000001', NULL, NULL, 'Dihydrolipoyl dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(176329, NULL, 'G3DSA:1.20.950.20:FF:000001', NULL, NULL, 'Respiratory nitrate reductase subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(176330, NULL, 'G3DSA:3.30.40.10:FF:002229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176331, NULL, 'G3DSA:3.80.10.10:FF:000522', NULL, NULL, 'Leucine rich repeat neuronal 2', NULL, NULL, NULL, NULL, NULL, 4),
(176332, NULL, 'G3DSA:3.40.50.1460:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176333, NULL, 'G3DSA:1.10.150.240:FF:000113', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(176334, NULL, 'G3DSA:2.60.40.10:FF:003484', NULL, NULL, 'MIP27932p', NULL, NULL, NULL, NULL, NULL, 4),
(176335, NULL, 'G3DSA:3.30.200.20:FF:000418', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(176336, NULL, 'G3DSA:4.10.280.10:FF:000224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176337, NULL, 'G3DSA:2.60.40.10:FF:000139', NULL, NULL, 'Protein kinase AMP-activated non-catalytic subunit beta 1', NULL, NULL, NULL, NULL, NULL, 4),
(176338, NULL, 'G3DSA:1.10.238.10:FF:000773', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(176339, NULL, 'G3DSA:2.40.128.150:FF:000004', NULL, NULL, 'N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(176340, NULL, 'G3DSA:3.30.160.60:FF:002505', NULL, NULL, 'Transcription factor steA', NULL, NULL, NULL, NULL, NULL, 4),
(176341, NULL, 'G3DSA:1.25.40.990:FF:000080', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(176342, NULL, 'G3DSA:3.40.50.300:FF:006929', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176343, NULL, 'G3DSA:1.20.1110.10:FF:000147', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(176344, NULL, 'G3DSA:1.10.510.10:FF:002412', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176345, NULL, 'G3DSA:3.90.640.10:FF:000013', NULL, NULL, 'Chaperone protein HscA', NULL, NULL, NULL, NULL, NULL, 4),
(176346, NULL, 'G3DSA:1.10.10.60:FF:000371', NULL, NULL, 'MYB transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(176347, NULL, 'G3DSA:1.10.150.20:FF:000280', NULL, NULL, 'DNA repair protein RAD51 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(176348, NULL, 'G3DSA:1.10.560.10:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176349, NULL, 'G3DSA:2.130.10.10:FF:003669', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176350, NULL, 'G3DSA:3.30.200.20:FF:000570', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(176351, NULL, 'G3DSA:3.40.50.300:FF:007565', NULL, NULL, 'Regulator of nonsense transcripts 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(176352, NULL, 'G3DSA:1.10.730.10:FF:000006', NULL, NULL, 'Arginyl-tRNA synthetase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(176353, NULL, 'G3DSA:1.10.3720.10:FF:000067', NULL, NULL, 'ABC amino acid transporter, permease component', NULL, NULL, NULL, NULL, NULL, 4),
(176354, NULL, 'G3DSA:2.30.30.30:FF:000011', NULL, NULL, 'Elongation factor P-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(176355, NULL, 'G3DSA:3.30.40.10:FF:001712', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176356, NULL, 'G3DSA:1.10.8.270:FF:000044', NULL, NULL, 'TBC Kinase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(176357, NULL, 'G3DSA:3.30.160.60:FF:006367', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176358, NULL, 'G3DSA:3.40.50.300:FF:008054', NULL, NULL, 'Caspase recruitment domain family, member 10', NULL, NULL, NULL, NULL, NULL, 4),
(176359, NULL, 'G3DSA:3.50.30.30:FF:000042', NULL, NULL, 'Tre1p', NULL, NULL, NULL, NULL, NULL, 4),
(176360, NULL, 'G3DSA:1.25.40.70:FF:000089', NULL, NULL, 'PI3K-CA alpha', NULL, NULL, NULL, NULL, NULL, 4),
(176361, NULL, 'G3DSA:1.20.1070.10:FF:001520', NULL, NULL, 'Zg05', NULL, NULL, NULL, NULL, NULL, 4),
(176362, NULL, 'G3DSA:2.10.25.10:FF:000505', NULL, NULL, 'Low-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(176363, NULL, 'G3DSA:1.20.1560.10:FF:000698', NULL, NULL, 'Putative ABC transporter ATP-binding protein MG015', NULL, NULL, NULL, NULL, NULL, 4),
(176364, NULL, 'G3DSA:1.20.58.390:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176365, NULL, 'G3DSA:3.30.160.60:FF:000235', NULL, NULL, 'Zinc finger and BTB domain containing 38', NULL, NULL, NULL, NULL, NULL, 4),
(176366, NULL, 'G3DSA:3.30.360.10:FF:000134', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(176367, NULL, 'G3DSA:3.30.2460.10:FF:000001', NULL, NULL, 'Putative tail fibers protein', NULL, NULL, NULL, NULL, NULL, 4),
(176368, NULL, 'G3DSA:2.60.40.1390:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176369, NULL, 'G3DSA:3.40.190.10:FF:000017', NULL, NULL, 'Glycine cleavage system transcriptional activator', NULL, NULL, NULL, NULL, NULL, 4),
(176370, NULL, 'G3DSA:1.10.3260.10:FF:000048', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(176371, NULL, 'G3DSA:3.40.50.620:FF:000455', NULL, NULL, 'Glutamine-dependent NAD(+) synthetase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(176372, NULL, 'G3DSA:1.25.40.10:FF:003876', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176373, NULL, 'G3DSA:1.10.510.10:FF:002351', NULL, NULL, 'CAMK CAMKL CHK1 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(176374, NULL, 'G3DSA:3.30.70.330:FF:001274', NULL, NULL, 'Putative ribonucleo protein', NULL, NULL, NULL, NULL, NULL, 4),
(176375, NULL, 'G3DSA:2.60.40.1180:FF:000191', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(176376, NULL, 'G3DSA:3.30.200.20:FF:001407', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(176377, NULL, 'G3DSA:3.40.50.150:FF:000382', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(176378, NULL, 'G3DSA:1.20.1070.10:FF:001048', NULL, NULL, 'G-protein coupled receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(176379, NULL, 'G3DSA:3.30.457.60:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176380, NULL, 'G3DSA:3.30.160.60:FF:001516', NULL, NULL, 'Zinc finger protein 142', NULL, NULL, NULL, NULL, NULL, 4),
(176381, NULL, 'G3DSA:1.25.40.20:FF:001316', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176382, NULL, 'G3DSA:1.25.40.20:FF:001496', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176383, NULL, 'G3DSA:2.60.40.10:FF:002495', NULL, NULL, 'Pre T cell antigen receptor alpha', NULL, NULL, NULL, NULL, NULL, 4),
(176384, NULL, 'G3DSA:1.25.50.10:FF:000004', NULL, NULL, 'Aminopeptidase N', NULL, NULL, NULL, NULL, NULL, 4),
(176385, NULL, 'G3DSA:3.30.160.60:FF:001696', NULL, NULL, 'ZFP2 zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(176386, NULL, 'G3DSA:3.50.70.10:FF:000010', NULL, NULL, 'Uncharacterized protein C18G6.01c', NULL, NULL, NULL, NULL, NULL, 4),
(176387, NULL, 'G3DSA:3.50.50.60:FF:001249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176388, NULL, 'G3DSA:1.25.40.10:FF:002595', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(176389, NULL, 'G3DSA:1.10.1420.10:FF:000055', NULL, NULL, 'DNA mismatch repair protein Msh2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(176390, NULL, 'G3DSA:1.10.405.10:FF:000009', NULL, NULL, 'Amine oxidase, flavin-containing', NULL, NULL, NULL, NULL, NULL, 4),
(176391, NULL, 'G3DSA:2.120.10.80:FF:000352', NULL, NULL, 'tRNA wybutosine-synthesizing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(176392, NULL, 'G3DSA:1.20.920.30:FF:000002', NULL, NULL, 'Dynein axonemal heavy chain 3', NULL, NULL, NULL, NULL, NULL, 4),
(176393, NULL, 'G3DSA:3.40.50.620:FF:000808', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176394, NULL, 'G3DSA:3.40.50.300:FF:008554', NULL, NULL, 'Probable atp-dependent DNA helicase Q5', NULL, NULL, NULL, NULL, NULL, 4),
(176395, NULL, 'G3DSA:3.40.50.300:FF:000769', NULL, NULL, 'Helicase arip4 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(176396, NULL, 'G3DSA:3.30.200.20:FF:001879', NULL, NULL, 'DsRNA activated Z-DNA binding protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(176397, NULL, 'G3DSA:3.20.20.330:FF:000018', NULL, NULL, 'Homocysteine S-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(176398, NULL, 'G3DSA:1.10.10.10:FF:001598', NULL, NULL, 'O-methyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(176399, NULL, 'G3DSA:1.25.10.10:FF:000530', NULL, NULL, 'UTP10p Nucleolar protein', NULL, NULL, NULL, NULL, NULL, 4),
(176400, NULL, 'G3DSA:2.130.10.10:FF:000382', NULL, NULL, 'WD repeat-containing protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(176401, NULL, 'G3DSA:1.25.40.20:FF:001788', NULL, NULL, 'MIB (MIndBomb) ubiquitin ligase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(176402, NULL, 'G3DSA:3.40.605.10:FF:000140', NULL, NULL, 'Aldehyde dehydrogenase 4 family member A1', NULL, NULL, NULL, NULL, NULL, 4),
(176403, NULL, 'G3DSA:1.10.510.10:FF:003840', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176404, NULL, 'G3DSA:2.130.10.10:FF:002860', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(176405, NULL, 'G3DSA:3.30.40.10:FF:000756', NULL, NULL, 'RiNg Finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(176406, NULL, 'G3DSA:2.60.120.260:FF:000213', NULL, NULL, 'Beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(176407, NULL, 'G3DSA:2.60.40.1180:FF:000039', NULL, NULL, 'Alpha-glucosidase YihQ', NULL, NULL, NULL, NULL, NULL, 4),
(176408, NULL, 'G3DSA:1.10.287.1490:FF:000055', NULL, NULL, 'Centrosomal protein 135kDa, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(176409, NULL, 'G3DSA:2.60.40.10:FF:002056', NULL, NULL, 'MHC class I antigen', NULL, NULL, NULL, NULL, NULL, 4),
(176410, NULL, 'G3DSA:3.40.50.300:FF:004631', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(176411, NULL, 'G3DSA:2.60.120.200:FF:000302', NULL, NULL, 'Trans-sialidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(176412, NULL, 'G3DSA:3.10.290.10:FF:000088', NULL, NULL, 'Putative 40S ribosomal protein S4', NULL, NULL, NULL, NULL, NULL, 4),
(176413, NULL, 'G3DSA:1.25.40.10:FF:005349', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g52620', NULL, NULL, NULL, NULL, NULL, 4),
(176414, NULL, 'G3DSA:3.40.50.300:FF:000477', NULL, NULL, 'UvrABC system protein B', NULL, NULL, NULL, NULL, NULL, 4),
(176415, NULL, 'G3DSA:1.20.142.10:FF:000031', NULL, NULL, 'Poly [ADP-ribose] polymerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(176416, NULL, 'G3DSA:3.60.40.10:FF:000160', NULL, NULL, 'Phosphoserine phosphatase RsbX', NULL, NULL, NULL, NULL, NULL, 4),
(176417, NULL, 'G3DSA:3.80.10.10:FF:003395', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176418, NULL, 'G3DSA:1.10.472.10:FF:000069', NULL, NULL, 'Cyclin-D5-1', NULL, NULL, NULL, NULL, NULL, 4),
(176419, NULL, 'G3DSA:1.25.40.20:FF:000035', NULL, NULL, 'Palmitoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(176420, NULL, 'G3DSA:3.40.850.10:FF:000164', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(176421, NULL, 'G3DSA:1.10.10.10:FF:001159', NULL, NULL, 'Putative ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(176422, NULL, 'G3DSA:3.40.50.740:FF:000053', NULL, NULL, 'DMSO reductase chain A', NULL, NULL, NULL, NULL, NULL, 4),
(176423, NULL, 'G3DSA:1.50.10.20:FF:000087', NULL, NULL, 'Terpene cyclase/mutase family member', NULL, NULL, NULL, NULL, NULL, 4),
(176424, NULL, 'G3DSA:1.10.472.80:FF:000281', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176425, NULL, 'G3DSA:1.25.40.10:FF:002415', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176426, NULL, 'G3DSA:1.20.910.10:FF:000018', NULL, NULL, 'Phosphomethylpyrimidine kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(176427, NULL, 'G3DSA:3.80.10.10:FF:004384', NULL, NULL, 'NACHT, LRR and PYD domains-containing protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(176428, NULL, 'G3DSA:2.60.120.200:FF:000482', NULL, NULL, 'Clade XVII lectin receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(176429, NULL, 'G3DSA:3.10.250.10:FF:000142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176430, NULL, 'G3DSA:3.40.47.10:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176431, NULL, 'G3DSA:1.10.8.540:FF:000001', NULL, NULL, 'Flagellar biosynthesis protein FlhA', NULL, NULL, NULL, NULL, NULL, 4),
(176432, NULL, 'G3DSA:2.130.10.10:FF:001371', NULL, NULL, 'Os03g0145600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(176433, NULL, 'G3DSA:1.10.418.10:FF:000219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176434, NULL, 'G3DSA:1.20.81.10:FF:000002', NULL, NULL, 'LDL receptor related protein associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(176435, NULL, 'G3DSA:3.40.50.2300:FF:001189', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176436, NULL, 'G3DSA:2.130.10.10:FF:004125', NULL, NULL, 'Autophagy-related protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(176437, NULL, 'G3DSA:1.20.1270.60:FF:000241', NULL, NULL, 'Nitric oxide synthase-trafficking', NULL, NULL, NULL, NULL, NULL, 4),
(176438, NULL, 'G3DSA:1.10.555.10:FF:000195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(176439, NULL, 'G3DSA:1.25.40.10:FF:000650', NULL, NULL, 'Pre-mRNA-processing factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(176440, NULL, 'G3DSA:2.30.30.140:FF:000077', NULL, NULL, 'Chromatin modification-related protein eaf3', NULL, NULL, NULL, NULL, NULL, 4),
(176441, NULL, 'G3DSA:3.30.160.60:FF:005439', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176442, NULL, 'G3DSA:2.40.10.10:FF:000301', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176443, NULL, 'G3DSA:2.30.29.30:FF:001194', NULL, NULL, 'Ran-binding protein 1 homolog a', NULL, NULL, NULL, NULL, NULL, 4),
(176444, NULL, 'G3DSA:3.40.50.720:FF:002284', NULL, NULL, 'Short-chain dehydrogenase/reductase SDR', NULL, NULL, NULL, NULL, NULL, 4),
(176445, NULL, 'G3DSA:3.40.710.10:FF:000154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176446, NULL, 'G3DSA:1.20.900.10:FF:000080', NULL, NULL, 'FERM, ARHGEF and pleckstrin domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(176447, NULL, 'G3DSA:1.10.238.10:FF:000334', NULL, NULL, 'N-terminal EF-hand calcium binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(176448, NULL, 'G3DSA:3.30.160.60:FF:002944', NULL, NULL, 'Prophage lambda integrase', NULL, NULL, NULL, NULL, NULL, 4),
(176449, NULL, 'G3DSA:1.10.533.10:FF:000150', NULL, NULL, 'CASP2 and RIPK1 domain containing adaptor with death domain', NULL, NULL, NULL, NULL, NULL, 4),
(176450, NULL, 'G3DSA:2.40.50.100:FF:000016', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(176451, NULL, 'G3DSA:2.60.40.10:FF:000639', NULL, NULL, 'collagen alpha-1(XII) chain isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(176452, NULL, 'G3DSA:3.50.50.100:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176453, NULL, 'G3DSA:1.10.357.30:FF:000004', NULL, NULL, 'Exocyst complex component SEC15', NULL, NULL, NULL, NULL, NULL, 4),
(176454, NULL, 'G3DSA:3.40.50.150:FF:001871', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176455, NULL, 'G3DSA:1.10.486.10:FF:000011', NULL, NULL, 'ATP-depentend DNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(176456, NULL, 'G3DSA:3.75.10.10:FF:000012', NULL, NULL, 'Agmatine deiminase', NULL, NULL, NULL, NULL, NULL, 4),
(176457, NULL, 'G3DSA:1.25.40.10:FF:002887', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176458, NULL, 'G3DSA:1.10.10.60:FF:000724', NULL, NULL, 'Homeobox protein vex1', NULL, NULL, NULL, NULL, NULL, 4),
(176459, NULL, 'G3DSA:3.30.70.330:FF:002263', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176460, NULL, 'G3DSA:2.60.40.150:FF:000255', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(176461, NULL, 'G3DSA:3.60.20.10:FF:000097', NULL, NULL, 'Proteasome subunit alpha type', NULL, NULL, NULL, NULL, NULL, 4),
(176462, NULL, 'G3DSA:2.30.30.140:FF:000105', NULL, NULL, 'R-interacting factor1', NULL, NULL, NULL, NULL, NULL, 4),
(176463, NULL, 'G3DSA:2.60.60.20:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176464, NULL, 'G3DSA:1.25.10.10:FF:001278', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(176465, NULL, 'G3DSA:3.60.21.10:FF:000088', NULL, NULL, 'Double-strand break repair protein MRE11', NULL, NULL, NULL, NULL, NULL, 4),
(176466, NULL, 'G3DSA:1.10.10.2670:FF:000014', NULL, NULL, 'AAL147Cp', NULL, NULL, NULL, NULL, NULL, 4),
(176467, NULL, 'G3DSA:1.10.238.10:FF:000042', NULL, NULL, 'Calmodulin', NULL, NULL, NULL, NULL, NULL, 4),
(176468, NULL, 'G3DSA:1.20.80.10:FF:000011', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type 13', NULL, NULL, NULL, NULL, NULL, 4),
(176469, NULL, 'G3DSA:3.40.50.1820:FF:001033', NULL, NULL, 'Lipase-like PAD4', NULL, NULL, NULL, NULL, NULL, 4),
(176470, NULL, 'G3DSA:2.160.20.80:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176471, NULL, 'G3DSA:2.60.40.10:FF:000611', NULL, NULL, 'Tenascin C', NULL, NULL, NULL, NULL, NULL, 4),
(176472, NULL, 'G3DSA:3.30.160.60:FF:001224', NULL, NULL, 'zinc finger protein 771-like', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(176473, NULL, 'G3DSA:2.60.40.1220:FF:000012', NULL, NULL, 'Surface layer protein', NULL, NULL, NULL, NULL, NULL, 4),
(176474, NULL, 'G3DSA:3.80.10.10:FF:001511', NULL, NULL, 'Os11g0197000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(176475, NULL, 'G3DSA:1.20.272.10:FF:000035', NULL, NULL, 'DNA polymerase III subunit gamma/tau', NULL, NULL, NULL, NULL, NULL, 4),
(176476, NULL, 'G3DSA:2.60.40.10:FF:004001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176477, NULL, 'G3DSA:2.30.30.710:FF:000001', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(176478, NULL, 'G3DSA:1.20.1250.20:FF:000486', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(176479, NULL, 'G3DSA:2.120.10.30:FF:000118', NULL, NULL, 'Blast:Low-density lipoprotein receptor-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(176480, NULL, 'G3DSA:3.40.50.300:FF:003203', NULL, NULL, 'Protein CBG22588', NULL, NULL, NULL, NULL, NULL, 4),
(176481, NULL, 'G3DSA:3.40.50.1000:FF:000742', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176482, NULL, 'G3DSA:3.40.50.2300:FF:001430', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176483, NULL, 'G3DSA:3.30.70.330:FF:000346', NULL, NULL, 'Nucleolar protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(176484, NULL, 'G3DSA:2.60.40.640:FF:000014', NULL, NULL, 'arrestin domain-containing protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(176485, NULL, 'G3DSA:1.10.150.250:FF:000003', NULL, NULL, 'Succinate dehydrogenase assembly factor', NULL, NULL, NULL, NULL, NULL, 4),
(176486, NULL, 'G3DSA:1.10.287.990:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176487, NULL, 'G3DSA:1.10.287.70:FF:000757', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(176488, NULL, 'G3DSA:2.10.25.10:FF:000213', NULL, NULL, 'sushi, nidogen and EGF-like domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(176489, NULL, 'G3DSA:3.40.30.10:FF:001014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176490, NULL, 'G3DSA:2.60.40.1900:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176491, NULL, 'G3DSA:3.10.100.10:FF:000367', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176492, NULL, 'G3DSA:1.10.10.940:FF:000001', NULL, NULL, 'Pyruvate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(176493, NULL, 'G3DSA:3.30.420.40:FF:000620', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176494, NULL, 'G3DSA:2.130.10.10:FF:002708', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176495, NULL, 'G3DSA:1.20.1250.20:FF:000778', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(176496, NULL, 'G3DSA:3.40.50.1110:FF:000011', NULL, NULL, 'Possible lipase/acylhydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(176497, NULL, 'G3DSA:2.90.10.10:FF:000007', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(176498, NULL, 'G3DSA:3.40.50.970:FF:000037', NULL, NULL, '2-oxoacid:ferredoxin oxidoreductase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(176499, NULL, 'G3DSA:3.80.10.10:FF:001803', NULL, NULL, 'Dynein regulatory complex subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(176500, NULL, 'G3DSA:1.25.10.10:FF:003256', NULL, NULL, 'Serine/threonine-protein kinase tor', NULL, NULL, NULL, NULL, NULL, 4),
(176501, NULL, 'G3DSA:1.25.40.10:FF:003904', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176502, NULL, 'G3DSA:3.30.1330.30:FF:000121', NULL, NULL, 'rRNA methyltransferase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(176503, NULL, 'G3DSA:1.20.120.980:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176504, NULL, 'G3DSA:3.30.50.10:FF:000049', NULL, NULL, 'bile acid receptor isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(176505, NULL, 'G3DSA:1.25.10.10:FF:002767', NULL, NULL, '1700016M24Rik protein', NULL, NULL, NULL, NULL, NULL, 4),
(176506, NULL, 'G3DSA:1.10.540.10:FF:000115', NULL, NULL, 'AGAP000454-PA', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(176507, NULL, 'G3DSA:2.30.29.240:FF:000021', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(176508, NULL, 'G3DSA:1.10.472.10:FF:000480', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176509, NULL, 'G3DSA:2.10.109.10:FF:000014', NULL, NULL, 'Inner membrane protease subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(176510, NULL, 'G3DSA:3.40.50.10330:FF:000027', NULL, NULL, 'NADH kinase', NULL, NULL, NULL, NULL, NULL, 4),
(176511, NULL, 'G3DSA:2.130.10.10:FF:005586', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(176512, NULL, 'G3DSA:2.40.30.170:FF:000067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176513, NULL, 'G3DSA:1.25.10.10:FF:001839', NULL, NULL, 'Anaphase-promoting complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(176514, NULL, 'G3DSA:3.20.20.80:FF:000310', NULL, NULL, 'Glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(176515, NULL, 'G3DSA:3.30.70.330:FF:002555', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176516, NULL, 'G3DSA:3.30.40.10:FF:001420', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(176517, NULL, 'G3DSA:3.40.50.300:FF:002714', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(176518, NULL, 'G3DSA:1.50.40.10:FF:000114', NULL, NULL, 'Solute carrier family 25 member 37', NULL, NULL, NULL, NULL, NULL, 4),
(176519, NULL, 'G3DSA:3.40.1690.20:FF:000007', NULL, NULL, 'ATP dependent metalloprotease', NULL, NULL, NULL, NULL, NULL, 4),
(176520, NULL, 'G3DSA:1.25.40.10:FF:004540', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(176521, NULL, 'G3DSA:3.40.630.10:FF:000445', NULL, NULL, 'Putative carboxypeptidase (Putative secreted protein)', NULL, NULL, NULL, NULL, NULL, 4),
(176522, NULL, 'G3DSA:3.40.50.1820:FF:001825', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(176523, NULL, 'G3DSA:3.30.9.40:FF:000002', NULL, NULL, 'Styrene monooxygenase StyA', NULL, NULL, NULL, NULL, NULL, 4),
(176524, NULL, 'G3DSA:2.60.120.10:FF:000119', NULL, NULL, 'cAMP-dependent protein kinase type II-alpha regulatory subunit isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(176525, NULL, 'G3DSA:1.20.1250.20:FF:001234', NULL, NULL, 'Solute carrier family 16 member 3', NULL, NULL, NULL, NULL, NULL, 4),
(176526, NULL, 'G3DSA:1.10.510.10:FF:001895', NULL, NULL, 'eIF-2 alpha kinase', NULL, NULL, NULL, NULL, NULL, 4),
(176527, NULL, 'G3DSA:3.30.70.330:FF:001627', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176528, NULL, 'G3DSA:3.30.1360.120:FF:000111', NULL, NULL, 'Sarcosine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(176529, NULL, 'G3DSA:3.30.565.40:FF:000001', NULL, NULL, 'Probable conserved secreted protein TB22.2', NULL, NULL, NULL, NULL, NULL, 4),
(176530, NULL, 'G3DSA:3.40.50.620:FF:000163', NULL, NULL, 'Predicted phosphoadenosine phosphosulfate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(176531, NULL, 'G3DSA:4.10.1240.10:FF:000022', NULL, NULL, 'Adenylate cyclase-activating polypeptide 1a (pituitary) receptor type I', NULL, NULL, NULL, NULL, NULL, 4),
(176532, NULL, 'G3DSA:2.40.30.130:FF:000050', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(176533, NULL, 'G3DSA:3.40.50.10950:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176534, NULL, 'G3DSA:3.30.390.30:FF:000029', NULL, NULL, 'FAD-dependent pyridine nucleotide-disulphide oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(176535, NULL, 'G3DSA:1.10.1320.10:FF:000019', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(176536, NULL, 'G3DSA:2.80.10.50:FF:000053', NULL, NULL, 'Fibroblast growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(176537, NULL, 'G3DSA:1.10.3710.10:FF:000010', NULL, NULL, 'ATPase, AAA family', NULL, NULL, NULL, NULL, NULL, 4),
(176538, NULL, 'G3DSA:3.40.50.720:FF:000159', NULL, NULL, 'dTDP-4-dehydrorhamnose reductase', NULL, NULL, NULL, NULL, NULL, 4),
(176539, NULL, 'G3DSA:3.30.1370.100:FF:000017', NULL, NULL, 'DNA mismatch repair protein pms2, putative', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(176540, NULL, 'G3DSA:3.30.420.10:FF:000544', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176541, NULL, 'G3DSA:1.20.144.10:FF:000013', NULL, NULL, 'Phospholipid phosphatase 3', NULL, NULL, NULL, NULL, NULL, 4),
(176542, NULL, 'G3DSA:1.20.5.3310:FF:000002', NULL, NULL, 'Sec-independent protein translocase protein TatB', NULL, NULL, NULL, NULL, NULL, 4),
(176543, NULL, 'G3DSA:2.30.22.10:FF:000009', NULL, NULL, 'Unplaced genomic scaffold supercont1.138, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(176544, NULL, 'G3DSA:2.60.40.10:FF:004973', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176545, NULL, 'G3DSA:1.20.58.70:FF:000123', NULL, NULL, 'Syntaxin 2a', NULL, NULL, NULL, NULL, NULL, 4),
(176546, NULL, 'G3DSA:1.20.1510.10:FF:000015', NULL, NULL, 'Metal tolerance protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(176547, NULL, 'G3DSA:3.40.30.10:FF:000525', NULL, NULL, 'Glutaredoxin-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(176548, NULL, 'G3DSA:3.80.10.10:FF:001950', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(176549, NULL, 'G3DSA:1.50.40.10:FF:000378', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176550, NULL, 'G3DSA:3.40.50.300:FF:006076', NULL, NULL, 'V -type Na-ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(176551, NULL, 'G3DSA:3.90.226.10:FF:000208', NULL, NULL, 'Carboxyl-terminal proteinase', NULL, NULL, NULL, NULL, NULL, 4),
(176552, NULL, 'G3DSA:3.30.465.10:FF:000041', NULL, NULL, 'Glycolate oxidase, subunit GlcE', NULL, NULL, NULL, NULL, NULL, 4),
(176553, NULL, 'G3DSA:1.20.58.1040:FF:000001', NULL, NULL, 'Glucan endo-1,3-beta-glucosidase 4', NULL, NULL, NULL, NULL, NULL, 4),
(176554, NULL, 'G3DSA:3.40.1380.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176555, NULL, 'G3DSA:3.40.50.10190:FF:000261', NULL, NULL, 'Chromatin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(176556, NULL, 'G3DSA:3.90.190.10:FF:000523', NULL, NULL, 'Dual-specificity protein phosphatase 3', NULL, NULL, NULL, NULL, NULL, 4),
(176557, NULL, 'G3DSA:2.30.230.10:FF:000016', NULL, NULL, 'AGAP008369-PA', NULL, NULL, NULL, NULL, NULL, 4),
(176558, NULL, 'G3DSA:3.20.20.70:FF:000392', NULL, NULL, 'Similar to quinate pathway repressor protein QutR', NULL, NULL, NULL, NULL, NULL, 4),
(176559, NULL, 'G3DSA:3.40.50.150:FF:000943', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176560, NULL, 'G3DSA:1.10.287.370:FF:000033', NULL, NULL, 'Prefoldin subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(176561, NULL, 'G3DSA:3.40.50.720:FF:002104', NULL, NULL, '2,4-diaminopentanoate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(176562, NULL, 'G3DSA:2.130.10.10:FF:000090', NULL, NULL, 'E3 ubiquitin-protein ligase RFWD2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(176563, NULL, 'G3DSA:3.80.10.10:FF:000494', NULL, NULL, 'F-box/LRR-repeat protein 10 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(176564, NULL, 'G3DSA:3.90.550.10:FF:000186', NULL, NULL, 'Translation initiation factor eIF-2B epsilon subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(176565, NULL, 'G3DSA:3.30.420.40:FF:000087', NULL, NULL, 'Glucokinase', NULL, NULL, NULL, NULL, NULL, 4),
(176566, NULL, 'G3DSA:1.10.238.10:FF:000481', NULL, NULL, 'EF-hand domain pair/EF-hand domain/EF hand', NULL, NULL, NULL, NULL, NULL, 4),
(176567, NULL, 'G3DSA:3.30.470.30:FF:000002', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(176568, NULL, 'G3DSA:3.40.50.1980:FF:000131', NULL, NULL, 'Putative histidinol dehydrogenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(176569, NULL, 'G3DSA:2.60.120.10:FF:000271', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(176570, NULL, 'G3DSA:3.90.190.20:FF:000060', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(176571, NULL, 'G3DSA:3.40.140.10:FF:000245', NULL, NULL, 'MPN domain-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(176572, NULL, 'G3DSA:3.10.430.100:FF:000021', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(176573, NULL, 'G3DSA:1.20.1300.10:FF:000010', NULL, NULL, 'Succinate dehydrogenase subunit 3-1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(176574, NULL, 'G3DSA:1.10.506.10:FF:000036', NULL, NULL, 'PLeXin', NULL, NULL, NULL, NULL, NULL, 4),
(176575, NULL, 'G3DSA:1.10.630.10:FF:000353', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(176576, NULL, 'G3DSA:1.10.510.10:FF:000434', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(176577, NULL, 'G3DSA:3.40.50.300:FF:001697', NULL, NULL, 'ComF operon protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(176578, NULL, 'G3DSA:3.30.1490.20:FF:000096', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(176579, NULL, 'G3DSA:1.10.150.850:FF:000003', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(176580, NULL, 'G3DSA:1.10.8.240:FF:000001', NULL, NULL, '2-phospho-L-lactate transferase', NULL, NULL, NULL, NULL, NULL, 4),
(176581, NULL, 'G3DSA:3.30.200.20:FF:002043', NULL, NULL, 'Protein CBG05605', NULL, NULL, NULL, NULL, NULL, 4),
(176582, NULL, 'G3DSA:3.80.10.10:FF:002467', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176583, NULL, 'G3DSA:2.60.40.10:FF:001859', NULL, NULL, 'Hemicentin 2', NULL, NULL, NULL, NULL, NULL, 4),
(176584, NULL, 'G3DSA:3.40.50.1110:FF:000039', NULL, NULL, 'SGNH/GDSL hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(176585, NULL, 'G3DSA:1.25.40.10:FF:001667', NULL, NULL, 'Os12g0163600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(176586, NULL, 'G3DSA:3.90.190.10:FF:000023', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type', NULL, NULL, NULL, NULL, NULL, 4),
(176587, NULL, 'G3DSA:3.90.1410.10:FF:000107', NULL, NULL, 'SET domain-containing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(176588, NULL, 'G3DSA:1.10.10.60:FF:000932', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176589, NULL, 'G3DSA:3.30.40.10:FF:001212', NULL, NULL, 'RING/FYVE/PHD-type zinc finger family protein', NULL, NULL, NULL, NULL, NULL, 4),
(176590, NULL, 'G3DSA:2.130.10.10:FF:002388', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit TRM82', NULL, NULL, NULL, NULL, NULL, 4),
(176591, NULL, 'G3DSA:4.10.410.10:FF:000050', NULL, NULL, 'Trypsin protease inhibitor-like 4', NULL, NULL, NULL, NULL, NULL, 4),
(176592, NULL, 'G3DSA:3.30.160.60:FF:005086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176593, NULL, 'G3DSA:3.30.70.330:FF:002763', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176594, NULL, 'G3DSA:3.40.50.11660:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176595, NULL, 'G3DSA:2.20.25.240:FF:000009', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(176596, NULL, 'G3DSA:1.10.390.10:FF:000053', NULL, NULL, 'Membrane alanine aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(176597, NULL, 'G3DSA:2.60.120.10:FF:000619', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176598, NULL, 'G3DSA:3.40.50.2020:FF:000155', NULL, NULL, 'Putative competence protein F', NULL, NULL, NULL, NULL, NULL, 4),
(176599, NULL, 'G3DSA:3.30.1360.120:FF:000083', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(176600, NULL, 'G3DSA:2.40.30.10:FF:000331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176601, NULL, 'G3DSA:2.40.10.10:FF:000268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176602, NULL, 'G3DSA:3.50.50.60:FF:000029', NULL, NULL, 'Lysine-specific histone demethylase', NULL, NULL, NULL, NULL, NULL, 4),
(176603, NULL, 'G3DSA:3.90.190.10:FF:000495', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(176604, NULL, 'G3DSA:3.30.360.20:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176605, NULL, 'G3DSA:3.90.740.10:FF:000077', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(176606, NULL, 'G3DSA:3.40.50.720:FF:001356', NULL, NULL, 'NADPH-dependent methylglyoxal reductase, putative', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(176607, NULL, 'G3DSA:1.25.40.10:FF:004332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176608, NULL, 'G3DSA:3.30.160.60:FF:004630', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176609, NULL, 'G3DSA:3.30.360.10:FF:000073', NULL, NULL, 'Inositol 2-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(176610, NULL, 'G3DSA:3.90.660.10:FF:000076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176611, NULL, 'G3DSA:3.40.50.2300:FF:001661', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176612, NULL, 'G3DSA:1.10.510.10:FF:001923', NULL, NULL, 'Cell Division Cycle related', NULL, NULL, NULL, NULL, NULL, 4),
(176613, NULL, 'G3DSA:1.20.120.720:FF:000052', NULL, NULL, 'Myosin IA heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(176614, NULL, 'G3DSA:1.20.58.60:FF:000025', NULL, NULL, 'microtubule-actin cross-linking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(176615, NULL, 'G3DSA:1.10.10.750:FF:000034', NULL, NULL, 'Ankyrin repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(176616, NULL, 'G3DSA:3.40.30.10:FF:000789', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(176617, NULL, 'G3DSA:1.10.418.60:FF:000009', NULL, NULL, 'Probable kinetochore protein NUF2', NULL, NULL, NULL, NULL, NULL, 4),
(176618, NULL, 'G3DSA:3.40.50.300:FF:004400', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176619, NULL, 'G3DSA:3.40.50.2300:FF:000233', NULL, NULL, 'Eg435916, gene 1', NULL, NULL, NULL, NULL, NULL, 4),
(176620, NULL, 'G3DSA:3.30.1360.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176621, NULL, 'G3DSA:3.20.20.70:FF:000745', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176622, NULL, 'G3DSA:2.30.110.10:FF:000041', NULL, NULL, 'PROBABLE OXIDOREDUCTASE', NULL, NULL, NULL, NULL, NULL, 4),
(176623, NULL, 'G3DSA:2.10.70.10:FF:000020', NULL, NULL, 'fibronectin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(176624, NULL, 'G3DSA:3.30.420.40:FF:000120', NULL, NULL, 'N-acetyl-D-glucosamine kinase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(176625, NULL, 'G3DSA:1.20.1280.50:FF:000177', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(176626, NULL, 'G3DSA:1.10.510.10:FF:002912', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176627, NULL, 'G3DSA:3.40.109.10:FF:000060', NULL, NULL, 'NAD(P)H-flavin oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(176628, NULL, 'G3DSA:1.10.287.470:FF:000029', NULL, NULL, 'Efflux transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(176629, NULL, 'G3DSA:1.20.1250.20:FF:001003', NULL, NULL, 'Sugar transporter', NULL, NULL, NULL, NULL, NULL, 4),
(176630, NULL, 'G3DSA:3.10.110.10:FF:000340', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 C-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(176631, NULL, 'G3DSA:3.40.50.200:FF:000065', NULL, NULL, 'Furin putative serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(176632, NULL, 'G3DSA:3.30.70.330:FF:001127', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein Q', NULL, NULL, NULL, NULL, NULL, 4),
(176633, NULL, 'G3DSA:2.60.40.10:FF:002848', NULL, NULL, 'O-GlcNAcase NagJ', NULL, NULL, NULL, NULL, NULL, 4),
(176634, NULL, 'G3DSA:3.30.780.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176635, NULL, 'G3DSA:2.130.10.10:FF:004097', NULL, NULL, 'Autophagy-related protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(176636, NULL, 'G3DSA:1.20.1560.10:FF:000198', NULL, NULL, 'ATP-binding cassette protein subfamily B, member 3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(176637, NULL, 'G3DSA:3.40.190.80:FF:000049', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(176638, NULL, 'G3DSA:2.30.42.10:FF:000544', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176639, NULL, 'G3DSA:1.20.1050.10:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176640, NULL, 'G3DSA:1.10.1540.10:FF:000002', NULL, NULL, 'WD repeat and FYVE domain containing 3', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(176641, NULL, 'G3DSA:3.40.630.30:FF:000659', NULL, NULL, 'Uncharacterized N-acetyltransferase C1271.07c', NULL, NULL, NULL, NULL, NULL, 4),
(176642, NULL, 'G3DSA:3.60.130.30:FF:000004', NULL, NULL, 'Calnexin-independence factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(176643, NULL, 'G3DSA:3.80.10.10:FF:004176', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(176644, NULL, 'G3DSA:2.30.30.40:FF:000632', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176645, NULL, 'G3DSA:3.40.50.1100:FF:000093', NULL, NULL, 'Threonine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(176646, NULL, 'G3DSA:1.25.40.20:FF:000535', NULL, NULL, 'Uncharacterized protein, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(176647, NULL, 'G3DSA:3.10.170.20:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176648, NULL, 'G3DSA:3.40.50.1820:FF:001264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176649, NULL, 'G3DSA:3.40.390.10:FF:000145', NULL, NULL, 'Peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(176650, NULL, 'G3DSA:3.40.50.300:FF:002422', NULL, NULL, 'ATP-binding cassette (ABC) transporter, putative Pdr11p', NULL, NULL, NULL, NULL, NULL, 4),
(176651, NULL, 'G3DSA:2.10.25.10:FF:001202', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(176652, NULL, 'G3DSA:3.40.30.10:FF:000317', NULL, NULL, 'Glutaredoxin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(176653, NULL, 'G3DSA:3.10.20.90:FF:000628', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 24', NULL, NULL, NULL, NULL, NULL, 4),
(176654, NULL, 'G3DSA:1.10.510.10:FF:004088', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176655, NULL, 'G3DSA:3.10.20.90:FF:000572', NULL, NULL, 'Putative small ubiquitin-related modifier 6', NULL, NULL, NULL, NULL, NULL, 4),
(176656, NULL, 'G3DSA:2.60.40.60:FF:000632', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176657, NULL, 'G3DSA:1.25.40.10:FF:000678', NULL, NULL, 'Pentatricopeptide repeat-containing protein MRL1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(176658, NULL, 'G3DSA:1.20.1070.10:FF:001279', NULL, NULL, 'Histamine receptor H1', NULL, NULL, NULL, NULL, NULL, 4),
(176659, NULL, 'G3DSA:3.30.160.60:FF:002005', NULL, NULL, 'Zinc finger protein 200', NULL, NULL, NULL, NULL, NULL, 4),
(176660, NULL, 'G3DSA:3.80.10.10:FF:003456', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176661, NULL, 'G3DSA:4.10.900.10:FF:000014', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(176662, NULL, 'G3DSA:1.10.1520.10:FF:000091', NULL, NULL, 'Endoribonuclease dcr-1', NULL, NULL, NULL, NULL, NULL, 4),
(176663, NULL, 'G3DSA:2.130.10.10:FF:006042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176664, NULL, 'G3DSA:3.80.10.10:FF:003720', NULL, NULL, 'AGAP007463-PA', NULL, NULL, NULL, NULL, NULL, 4),
(176665, NULL, 'G3DSA:2.30.29.30:FF:000766', NULL, NULL, 'Bud site selection protein BUD4', NULL, NULL, NULL, NULL, NULL, 4),
(176666, NULL, 'G3DSA:3.90.70.10:FF:000149', NULL, NULL, 'Type I secretion system permease/ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(176667, NULL, 'G3DSA:3.90.228.10:FF:000050', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(176668, NULL, 'G3DSA:1.10.418.40:FF:000003', NULL, NULL, 'Beclin-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(176669, NULL, 'G3DSA:3.90.470.10:FF:000005', NULL, NULL, '60S ribosomal protein L17', NULL, NULL, NULL, NULL, NULL, 4),
(176670, NULL, 'G3DSA:3.90.550.10:FF:000006', NULL, NULL, 'Bifunctional protein GlmU', NULL, NULL, NULL, NULL, NULL, 4),
(176671, NULL, 'G3DSA:2.20.70.10:FF:000087', NULL, NULL, 'PArtner of DroSHa (DRSH-1 interactor)', NULL, NULL, NULL, NULL, NULL, 4),
(176672, NULL, 'G3DSA:2.30.30.40:FF:000368', NULL, NULL, 'Chemotaxis protein CheW', NULL, NULL, NULL, NULL, NULL, 4),
(176673, NULL, 'G3DSA:1.10.510.10:FF:003368', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176674, NULL, 'G3DSA:2.130.10.10:FF:001932', NULL, NULL, 'Yeast SEC homolog', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(176675, NULL, 'G3DSA:3.30.40.10:FF:000695', NULL, NULL, 'Chromatin modification-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(176676, NULL, 'G3DSA:3.40.190.290:FF:000088', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(176677, NULL, 'G3DSA:3.30.1140.32:FF:000013', NULL, NULL, '40S ribosomal protein S3', NULL, NULL, NULL, NULL, NULL, 4),
(176678, NULL, 'G3DSA:3.40.1110.10:FF:000326', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176679, NULL, 'G3DSA:3.30.160.60:FF:000735', NULL, NULL, 'Transcription factor Sp7', NULL, NULL, NULL, NULL, NULL, 4),
(176680, NULL, 'G3DSA:1.10.533.10:FF:000178', NULL, NULL, 'THO complex subunit 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(176681, NULL, 'G3DSA:3.60.21.50:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176682, NULL, 'G3DSA:3.40.950.10:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176683, NULL, 'G3DSA:1.10.8.720:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176684, NULL, 'G3DSA:3.30.70.1230:FF:000235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176685, NULL, 'G3DSA:3.10.100.10:FF:000075', NULL, NULL, 'C-type lectin domain family 9 member A', NULL, NULL, NULL, NULL, NULL, 4),
(176686, NULL, 'G3DSA:3.20.80.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176687, NULL, 'G3DSA:1.10.287.510:FF:000002', NULL, NULL, 'DNA double-strand break repair Rad50 ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(176688, NULL, 'G3DSA:2.40.50.140:FF:000208', NULL, NULL, 'Ribonuclease E/G-like protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(176689, NULL, 'G3DSA:2.60.40.10:FF:006007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176690, NULL, 'G3DSA:3.20.20.60:FF:000063', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(176691, NULL, 'G3DSA:1.10.287.950:FF:000050', NULL, NULL, 'Putative bifunctional protein [include methyl-accepting chemotaxis protein and an extracellular solute-binding protein]', NULL, NULL, NULL, NULL, NULL, 4),
(176692, NULL, 'G3DSA:2.60.40.10:FF:000078', NULL, NULL, 'Neuronal cell adhesion molecule', NULL, NULL, NULL, NULL, NULL, 4),
(176693, NULL, 'G3DSA:2.130.10.10:FF:002652', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176694, NULL, 'G3DSA:3.10.580.10:FF:000043', NULL, NULL, 'Sds23p', NULL, NULL, NULL, NULL, NULL, 4),
(176695, NULL, 'G3DSA:1.25.10.10:FF:000761', NULL, NULL, 'Adenomatous polyposis coli protein-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(176696, NULL, 'G3DSA:3.40.47.10:FF:000209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176697, NULL, 'G3DSA:3.10.20.620:FF:000006', NULL, NULL, 'Autophagy protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(176698, NULL, 'G3DSA:3.90.190.10:FF:000231', NULL, NULL, 'Glomerular epithelial protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(176699, NULL, 'G3DSA:3.30.420.340:FF:000013', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(176700, NULL, 'G3DSA:2.20.100.10:FF:000088', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 18', NULL, NULL, NULL, NULL, NULL, 4),
(176701, NULL, 'G3DSA:1.10.472.10:FF:000041', NULL, NULL, 'Cyclin J like', NULL, NULL, NULL, NULL, NULL, 4),
(176702, NULL, 'G3DSA:3.30.200.20:FF:000098', NULL, NULL, 'Nuclear receptor-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(176703, NULL, 'G3DSA:3.40.50.300:FF:005592', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(176704, NULL, 'G3DSA:3.40.50.720:FF:002076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176705, NULL, 'G3DSA:2.10.220.10:FF:000060', NULL, NULL, 'Fraser extracellular matrix complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(176706, NULL, 'G3DSA:1.25.40.10:FF:003612', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176707, NULL, 'G3DSA:3.80.10.10:FF:001039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(176708, NULL, 'G3DSA:3.30.830.10:FF:000238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176709, NULL, 'G3DSA:2.40.10.10:FF:000532', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176710, NULL, 'G3DSA:3.40.50.300:FF:006429', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176711, NULL, 'G3DSA:3.90.180.10:FF:000197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176712, NULL, 'G3DSA:1.25.40.10:FF:002623', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g52850, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(176713, NULL, 'G3DSA:3.40.50.720:FF:000367', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(176714, NULL, 'G3DSA:3.40.1090.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176715, NULL, 'G3DSA:1.10.357.140:FF:000003', NULL, NULL, '4-hydroxybenzoate polyprenyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(176716, NULL, 'G3DSA:3.90.640.10:FF:000277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176717, NULL, 'G3DSA:2.60.40.10:FF:003692', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176718, NULL, 'G3DSA:3.40.50.150:FF:000590', NULL, NULL, 'Protein CBG17953', NULL, NULL, NULL, NULL, NULL, 4),
(176719, NULL, 'G3DSA:3.40.1190.20:FF:000194', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176720, NULL, 'G3DSA:3.40.50.450:FF:000090', NULL, NULL, 'Os03g0697200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(176721, NULL, 'G3DSA:1.10.30.10:FF:000172', NULL, NULL, 'High mobility group B protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(176722, NULL, 'G3DSA:2.120.10.80:FF:000144', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(176723, NULL, 'G3DSA:1.10.8.270:FF:000105', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(176724, NULL, 'G3DSA:4.10.400.10:FF:000285', NULL, NULL, 'HGF/MSP/plasminogen-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(176725, NULL, 'G3DSA:1.20.1060.10:FF:000002', NULL, NULL, 'Polymerase (DNA directed), theta', NULL, NULL, NULL, NULL, NULL, 4),
(176726, NULL, 'G3DSA:3.30.160.60:FF:000999', NULL, NULL, 'zinc finger protein 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(176727, NULL, 'G3DSA:1.10.1070.11:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176728, NULL, 'G3DSA:1.10.287.810:FF:000002', NULL, NULL, 'Mitochondrial import inner membrane translocase subunit tim10', NULL, NULL, NULL, NULL, NULL, 4),
(176729, NULL, 'G3DSA:2.40.33.10:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176730, NULL, 'G3DSA:3.30.160.60:FF:005850', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176731, NULL, 'G3DSA:3.40.50.1820:FF:000336', NULL, NULL, 'Probable serine protease EDA2', NULL, NULL, NULL, NULL, NULL, 4),
(176732, NULL, 'G3DSA:2.60.40.60:FF:000840', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176733, NULL, 'G3DSA:1.20.20.10:FF:000002', NULL, NULL, 'ATP synthase subunit c', NULL, NULL, NULL, NULL, NULL, 4),
(176734, NULL, 'G3DSA:3.30.70.370:FF:000010', NULL, NULL, 'DNA polymerase A', NULL, NULL, NULL, NULL, NULL, 4),
(176735, NULL, 'G3DSA:1.10.760.10:FF:000065', NULL, NULL, '40-residue YVTN family beta-propeller', NULL, NULL, NULL, NULL, NULL, 4),
(176736, NULL, 'G3DSA:2.60.120.920:FF:000017', NULL, NULL, 'F-box/SPRY domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(176737, NULL, 'G3DSA:2.60.40.150:FF:000463', NULL, NULL, 'Copine-1', NULL, NULL, NULL, NULL, NULL, 4),
(176738, NULL, 'G3DSA:2.30.30.280:FF:000006', NULL, NULL, 'Mitochondrial tRNA-specific 2-thiouridylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(176739, NULL, 'G3DSA:3.40.50.300:FF:002686', NULL, NULL, 'RAB14, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(176740, NULL, 'G3DSA:4.10.372.10:FF:000005', NULL, NULL, 'Lipoxygenase 7, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(176741, NULL, 'G3DSA:2.60.40.10:FF:000111', NULL, NULL, 'Myosin-binding protein C, slow type', NULL, NULL, NULL, NULL, NULL, 4),
(176742, NULL, 'G3DSA:3.30.1540.20:FF:000010', NULL, NULL, 'Mlh3p', NULL, NULL, NULL, NULL, NULL, 4),
(176743, NULL, 'G3DSA:3.30.70.330:FF:001335', NULL, NULL, 'serine/threonine-protein kinase Kist isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(176744, NULL, 'G3DSA:1.10.10.60:FF:000224', NULL, NULL, 'HTH-type transcriptional regulator RutR', NULL, NULL, NULL, NULL, NULL, 4),
(176745, NULL, 'G3DSA:2.130.10.10:FF:000943', NULL, NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', NULL, NULL, NULL, NULL, NULL, 4),
(176746, NULL, 'G3DSA:1.25.40.20:FF:000327', NULL, NULL, 'Ankyrin repeat-containing protein NPR4', NULL, NULL, NULL, NULL, NULL, 4),
(176747, NULL, 'G3DSA:1.10.510.10:FF:000142', NULL, NULL, 'Octicosapeptide/phox/Bem1p domain kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(176748, NULL, 'G3DSA:1.20.140.150:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176749, NULL, 'G3DSA:1.10.10.10:FF:000378', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit K', NULL, NULL, NULL, NULL, NULL, 4),
(176750, NULL, 'G3DSA:3.80.10.10:FF:003248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176751, NULL, 'G3DSA:2.60.120.260:FF:000393', NULL, NULL, 'Beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(176752, NULL, 'G3DSA:4.10.400.10:FF:000021', NULL, NULL, 'Low density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(176753, NULL, 'G3DSA:3.30.160.60:FF:003641', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176754, NULL, 'G3DSA:1.10.238.200:FF:000006', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(176755, NULL, 'G3DSA:2.60.120.10:FF:000563', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176756, NULL, 'G3DSA:3.30.565.10:FF:000458', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176757, NULL, 'G3DSA:1.20.1160.20:FF:000007', NULL, NULL, 'PDZ domain containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(176758, NULL, 'G3DSA:3.30.60.30:FF:000180', NULL, NULL, 'AGAP005450-PA', NULL, NULL, NULL, NULL, NULL, 4),
(176759, NULL, 'G3DSA:2.60.40.10:FF:005754', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176760, NULL, 'G3DSA:2.30.30.100:FF:000060', NULL, NULL, 'LSM5 homolog, U6 small nuclear RNA and mRNA degradation associated', NULL, NULL, NULL, NULL, NULL, 4),
(176761, NULL, 'G3DSA:2.130.10.10:FF:005878', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(176762, NULL, 'G3DSA:4.10.320.10:FF:000020', NULL, NULL, 'Dihydrolipoyllysine-residue acetyltransferase component 3 of pyruvate dehydrogenase complex, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(176763, NULL, 'G3DSA:1.10.238.10:FF:001262', NULL, NULL, 'Calcium-binding EF-hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(176764, NULL, 'G3DSA:3.40.50.300:FF:006368', NULL, NULL, 'TAP2', NULL, NULL, NULL, NULL, NULL, 4),
(176765, NULL, 'G3DSA:2.30.29.30:FF:000558', NULL, NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', NULL, NULL, NULL, NULL, NULL, 4),
(176766, NULL, 'G3DSA:2.40.150.20:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176767, NULL, 'G3DSA:3.10.28.10:FF:000032', NULL, NULL, 'Intron-encoded endonuclease I-SceI', NULL, NULL, NULL, NULL, NULL, 4),
(176768, NULL, 'G3DSA:3.90.1150.10:FF:000508', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176769, NULL, 'G3DSA:3.30.870.10:FF:000100', NULL, NULL, 'Tyrosyl-DNA phosphodiesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(176770, NULL, 'G3DSA:3.30.420.140:FF:000009', NULL, NULL, 'Holliday junction resolvase', NULL, NULL, NULL, NULL, NULL, 4),
(176771, NULL, 'G3DSA:1.20.5.500:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176772, NULL, 'G3DSA:3.80.10.10:FF:002731', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(176773, NULL, 'G3DSA:1.20.120.140:FF:000030', NULL, NULL, 'Signal recognition particle receptor FtsY', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(176774, NULL, 'G3DSA:3.40.1370.10:FF:000014', NULL, NULL, '50S ribosomal protein L4', NULL, NULL, NULL, NULL, NULL, 4),
(176775, NULL, 'G3DSA:3.10.20.10:FF:000003', NULL, NULL, 'Sulfur carrier protein FdhD', NULL, NULL, NULL, NULL, NULL, 4),
(176776, NULL, 'G3DSA:3.30.160.60:FF:004158', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176777, NULL, 'G3DSA:1.25.40.10:FF:002123', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(176778, NULL, 'G3DSA:3.40.50.1100:FF:000154', NULL, NULL, 'Cystathionine beta-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(176779, NULL, 'G3DSA:2.40.50.140:FF:000360', NULL, NULL, 'Rne/Rng family ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(176780, NULL, 'G3DSA:3.40.50.300:FF:005912', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(176781, NULL, 'G3DSA:1.10.510.10:FF:004149', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176782, NULL, 'G3DSA:1.20.970.10:FF:000027', NULL, NULL, 'Anthranilate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(176783, NULL, 'G3DSA:1.10.510.10:FF:001687', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176784, NULL, 'G3DSA:3.40.1110.10:FF:000265', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(176785, NULL, 'G3DSA:3.40.50.300:FF:008262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176786, NULL, 'G3DSA:3.40.50.720:FF:000631', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(176787, NULL, 'G3DSA:3.40.930.10:FF:000018', NULL, NULL, 'Sodium bicarbonate transporter protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(176788, NULL, 'G3DSA:1.10.286.70:FF:000002', NULL, NULL, 'Ubiquitin-like protein MDY2', NULL, NULL, NULL, NULL, NULL, 4),
(176789, NULL, 'G3DSA:1.10.287.70:FF:000257', NULL, NULL, 'TWiK family of potassium channels', NULL, NULL, NULL, NULL, NULL, 4),
(176790, NULL, 'G3DSA:3.40.50.880:FF:000162', NULL, NULL, 'Aspartate carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(176791, NULL, 'G3DSA:3.40.50.150:FF:000090', NULL, NULL, 'Probable methyltransferase PMT18', NULL, NULL, NULL, NULL, NULL, 4),
(176792, NULL, 'G3DSA:2.40.30.330:FF:000019', NULL, NULL, 'mRNA cleavage and polyadenylation factor CLP1', NULL, NULL, NULL, NULL, NULL, 4),
(176793, NULL, 'G3DSA:3.30.559.30:FF:000023', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(176794, NULL, 'G3DSA:3.30.200.20:FF:001115', NULL, NULL, 'Serine/threonine-protein kinase WARTS homolog', NULL, NULL, NULL, NULL, NULL, 4),
(176795, NULL, 'G3DSA:3.40.50.1000:FF:000006', NULL, NULL, 'Plasma membrane ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(176796, NULL, 'G3DSA:1.20.1560.10:FF:000259', NULL, NULL, 'ATP-binding cassette (ABC) transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(176797, NULL, 'G3DSA:2.40.50.140:FF:000944', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176798, NULL, 'G3DSA:3.30.70.330:FF:000610', NULL, NULL, 'Putative G3BP-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(176799, NULL, 'G3DSA:1.10.510.10:FF:004296', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176800, NULL, 'G3DSA:3.40.50.80:FF:000120', NULL, NULL, 'Ferric reductase', NULL, NULL, NULL, NULL, NULL, 4),
(176801, NULL, 'G3DSA:3.30.1120.10:FF:000009', NULL, NULL, 'Arylsulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(176802, NULL, 'G3DSA:1.25.10.10:FF:002559', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176803, NULL, 'G3DSA:3.40.430.10:FF:000025', NULL, NULL, 'Dihydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(176804, NULL, 'G3DSA:3.40.50.300:FF:002922', NULL, NULL, 'ATP-dependent DNA helicase RecG', NULL, NULL, NULL, NULL, NULL, 4),
(176805, NULL, 'G3DSA:2.70.170.10:FF:000249', NULL, NULL, 'Cholinergic receptor nicotinic alpha 10 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(176806, NULL, 'G3DSA:3.40.50.1980:FF:000070', NULL, NULL, 'Zinc ABC transporter, periplasmic zinc-binding protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(176807, NULL, 'G3DSA:2.130.10.10:FF:000235', NULL, NULL, 'POC1 centriolar protein homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(176808, NULL, 'G3DSA:3.80.10.10:FF:000022', NULL, NULL, 'Erbin isoform 7', NULL, NULL, NULL, NULL, NULL, 4),
(176809, NULL, 'G3DSA:1.10.472.80:FF:000101', NULL, NULL, 'Rab GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(176810, NULL, 'G3DSA:3.30.60.30:FF:000241', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(176811, NULL, 'G3DSA:1.25.40.10:FF:003404', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(176812, NULL, 'G3DSA:2.130.10.10:FF:003169', NULL, NULL, 'Cilia and flagella-associated protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(176813, NULL, 'G3DSA:3.40.50.1820:FF:001617', NULL, NULL, 'Os09g0462901 protein', NULL, NULL, NULL, NULL, NULL, 4),
(176814, NULL, 'G3DSA:2.130.10.10:FF:005614', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176815, NULL, 'G3DSA:3.30.160.60:FF:001808', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176816, NULL, 'G3DSA:4.10.1290.10:FF:000002', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 13B', NULL, NULL, NULL, NULL, NULL, 4),
(176817, NULL, 'G3DSA:3.40.50.720:FF:002576', NULL, NULL, 'L-lactate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(176818, NULL, 'G3DSA:3.40.50.1970:FF:000010', NULL, NULL, 'Probable hydroxyacid-oxoacid transhydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(176819, NULL, 'G3DSA:2.130.10.10:FF:004597', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176820, NULL, 'G3DSA:3.30.70.330:FF:001835', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176821, NULL, 'G3DSA:2.70.130.10:FF:000011', NULL, NULL, 'Insulin-like growth factor 2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(176822, NULL, 'G3DSA:3.30.200.20:FF:000598', NULL, NULL, 'PEK/GCN2 protein kinase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(176823, NULL, 'G3DSA:3.20.20.190:FF:000049', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(176824, NULL, 'G3DSA:1.25.40.820:FF:000017', NULL, NULL, 'Rtr1/RPAP2 family-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(176825, NULL, 'G3DSA:2.40.110.10:FF:000016', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(176826, NULL, 'G3DSA:2.60.40.10:FF:003192', NULL, NULL, 'Beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(176827, NULL, 'G3DSA:1.20.1600.10:FF:000022', NULL, NULL, 'Outer membrane protein RaxC', NULL, NULL, NULL, NULL, NULL, 4),
(176828, NULL, 'G3DSA:1.25.40.10:FF:000942', NULL, NULL, 'BnaC07g00040D protein', NULL, NULL, NULL, NULL, NULL, 4),
(176829, NULL, 'G3DSA:2.70.50.80:FF:000003', NULL, NULL, 'Scalloped, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(176830, NULL, 'G3DSA:3.90.70.10:FF:000621', NULL, NULL, 'Cathepsin F', NULL, NULL, NULL, NULL, NULL, 4),
(176831, NULL, 'G3DSA:3.30.710.10:FF:000471', NULL, NULL, 'SKp1 Related (Ubiquitin ligase complex component)', NULL, NULL, NULL, NULL, NULL, 4),
(176832, NULL, 'G3DSA:3.80.10.10:FF:001450', NULL, NULL, 'Uncharacterized F-box/LRR-repeat protein C02F5.7', NULL, NULL, NULL, NULL, NULL, 4),
(176833, NULL, 'G3DSA:1.25.40.20:FF:000799', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176834, NULL, 'G3DSA:3.40.50.1000:FF:000681', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176835, NULL, 'G3DSA:1.10.510.10:FF:002851', NULL, NULL, 'AT13713p', NULL, NULL, NULL, NULL, NULL, 4),
(176836, NULL, 'G3DSA:1.25.40.800:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176837, NULL, 'G3DSA:3.30.40.10:FF:001920', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176838, NULL, 'G3DSA:3.40.50.1370:FF:000038', NULL, NULL, 'Aspartate carbamoyltransferase PyrB', NULL, NULL, NULL, NULL, NULL, 4),
(176839, NULL, 'G3DSA:3.40.50.300:FF:001758', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(176840, NULL, 'G3DSA:3.65.10.20:FF:000010', NULL, NULL, 'Rtc1', NULL, NULL, NULL, NULL, NULL, 4),
(176841, NULL, 'G3DSA:2.60.40.3500:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176842, NULL, 'G3DSA:3.40.630.10:FF:000092', NULL, NULL, 'Peptidase M14', NULL, NULL, NULL, NULL, NULL, 4),
(176843, NULL, 'G3DSA:3.90.550.10:FF:000394', NULL, NULL, 'Glycosyltransferase family 2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(176844, NULL, 'G3DSA:1.10.10.250:FF:000007', NULL, NULL, '50S ribosomal protein L11', NULL, NULL, NULL, NULL, NULL, 4),
(176845, NULL, 'G3DSA:3.30.200.20:FF:001790', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(176846, NULL, 'G3DSA:1.20.1250.20:FF:000806', NULL, NULL, 'Peptide transporter 3', NULL, NULL, NULL, NULL, NULL, 4),
(176847, NULL, 'G3DSA:1.10.287.110:FF:000298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176848, NULL, 'G3DSA:3.40.140.10:FF:000037', NULL, NULL, 'COP9 signalosome subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(176849, NULL, 'G3DSA:3.30.980.10:FF:000046', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(176850, NULL, 'G3DSA:3.30.160.60:FF:005350', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176851, NULL, 'G3DSA:1.25.40.10:FF:001459', NULL, NULL, 'Os02g0625100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(176852, NULL, 'G3DSA:3.40.50.300:FF:004367', NULL, NULL, 'Arsenical pump-driving ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(176853, NULL, 'G3DSA:1.10.10.10:FF:002115', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(176854, NULL, 'G3DSA:2.10.25.10:FF:000685', NULL, NULL, 'Weary, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(176855, NULL, 'G3DSA:1.10.555.10:FF:000256', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176856, NULL, 'G3DSA:3.30.2350.20:FF:000001', NULL, NULL, 'tRNA pseudouridine synthase D', NULL, NULL, NULL, NULL, NULL, 4),
(176857, NULL, 'G3DSA:2.60.40.10:FF:005962', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176858, NULL, 'G3DSA:1.25.40.10:FF:004068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176859, NULL, 'G3DSA:2.60.120.10:FF:000063', NULL, NULL, 'cyclic nucleotide-gated ion channel 4', NULL, NULL, NULL, NULL, NULL, 4),
(176860, NULL, 'G3DSA:3.30.60.20:FF:000143', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(176861, NULL, 'G3DSA:3.30.1330.60:FF:000017', NULL, NULL, 'Outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(176862, NULL, 'G3DSA:2.130.10.10:FF:001724', NULL, NULL, 'WD repeat containing protein 48', NULL, NULL, NULL, NULL, NULL, 4),
(176863, NULL, 'G3DSA:3.30.497.10:FF:000092', NULL, NULL, 'Flagellar associated protein, protease inhibitor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(176864, NULL, 'G3DSA:3.40.50.300:FF:000977', NULL, NULL, 'BRCA1 interacting protein C-terminal helicase 1', NULL, NULL, NULL, NULL, NULL, 4),
(176865, NULL, 'G3DSA:1.25.10.10:FF:000030', NULL, NULL, 'AP-1 complex subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(176866, NULL, 'G3DSA:3.40.50.10420:FF:000021', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(176867, NULL, 'G3DSA:3.40.50.2300:FF:000172', NULL, NULL, 'G-protein coupled receptor family C group 6 member A', NULL, NULL, NULL, NULL, NULL, 4),
(176868, NULL, 'G3DSA:1.20.210.10:FF:000044', NULL, NULL, 'Laglidadg endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(176869, NULL, 'G3DSA:3.30.379.10:FF:000008', NULL, NULL, 'Beta-hexosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(176870, NULL, 'G3DSA:3.40.50.11500:FF:000002', NULL, NULL, 'MAP kinase-activating death domain protein-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(176871, NULL, 'G3DSA:1.25.40.10:FF:002387', NULL, NULL, 'Pre-mRNA-splicing factor CLF1', NULL, NULL, NULL, NULL, NULL, 4),
(176872, NULL, 'G3DSA:3.40.1740.10:FF:000003', NULL, NULL, 'Electron transporter, putative (DUF179)', NULL, NULL, NULL, NULL, NULL, 4),
(176873, NULL, 'G3DSA:1.50.10.10:FF:000197', NULL, NULL, 'Non-lysosomal glucosylceramidase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(176874, NULL, 'G3DSA:1.10.510.10:FF:001423', NULL, NULL, 'Calcium-dependent protein kinase 7', NULL, NULL, NULL, NULL, NULL, 4),
(176875, NULL, 'G3DSA:3.40.720.10:FF:000183', NULL, NULL, 'Cell number regulator 8', NULL, NULL, NULL, NULL, NULL, 4),
(176876, NULL, 'G3DSA:3.40.50.410:FF:000246', NULL, NULL, '60-kDa SS-A/Ro ribonucleoprotein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(176877, NULL, 'G3DSA:1.10.630.10:FF:000561', NULL, NULL, 'CYP2A13 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(176878, NULL, 'G3DSA:1.25.50.20:FF:000041', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(176879, NULL, 'G3DSA:3.40.50.11980:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176880, NULL, 'G3DSA:1.10.20.10:FF:000143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176881, NULL, 'G3DSA:1.20.58.1380:FF:000018', NULL, NULL, 'Nucleoporin nup132', NULL, NULL, NULL, NULL, NULL, 4),
(176882, NULL, 'G3DSA:3.50.50.60:FF:001457', NULL, NULL, 'Guanosine nucleotide diphosphate dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(176883, NULL, 'G3DSA:2.60.120.10:FF:000771', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176884, NULL, 'G3DSA:2.30.29.210:FF:000006', NULL, NULL, 'Nucleosome binding factor SPN, SPT16 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(176885, NULL, 'G3DSA:2.10.50.10:FF:000018', NULL, NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(176886, NULL, 'G3DSA:3.30.160.60:FF:002360', NULL, NULL, 'Zinc finger protein 418', NULL, NULL, NULL, NULL, NULL, 4),
(176887, NULL, 'G3DSA:2.40.30.10:FF:000123', NULL, NULL, 'GTP-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(176888, NULL, 'G3DSA:1.20.58.390:FF:000150', NULL, NULL, 'Neurotransmitter-gated ion-channel ligand binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(176889, NULL, 'G3DSA:3.30.200.20:FF:001379', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176890, NULL, 'G3DSA:3.40.1080.10:FF:000003', NULL, NULL, 'Acetyl-coA hydrolase Ach1', NULL, NULL, NULL, NULL, NULL, 4),
(176891, NULL, 'G3DSA:2.60.40.10:FF:004473', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176892, NULL, 'G3DSA:3.40.50.300:FF:001197', NULL, NULL, 'Putative ATP-binding cassette family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(176893, NULL, 'G3DSA:2.130.10.10:FF:000590', NULL, NULL, 'WD repeat domain 90', NULL, NULL, NULL, NULL, NULL, 4),
(176894, NULL, 'G3DSA:1.50.40.10:FF:000586', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176895, NULL, 'G3DSA:1.10.238.10:FF:000542', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(176896, NULL, 'G3DSA:3.40.50.300:FF:005648', NULL, NULL, 'ATP-dependent RNA helicase DHR1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(176897, NULL, 'G3DSA:3.30.720.90:FF:000006', NULL, NULL, 'Os08g0541950 protein', NULL, NULL, NULL, NULL, NULL, 4),
(176898, NULL, 'G3DSA:1.10.287.110:FF:000034', NULL, NULL, 'Chaperone protein DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(176899, NULL, 'G3DSA:1.10.287.770:FF:000029', NULL, NULL, 'Pickpocket 22, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(176900, NULL, 'G3DSA:3.20.110.10:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(176901, NULL, 'G3DSA:2.30.29.30:FF:001222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176902, NULL, 'G3DSA:3.30.70.1660:FF:000038', NULL, NULL, 'Mitochondrial translational release factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(176903, NULL, 'G3DSA:3.40.50.300:FF:000269', NULL, NULL, 'ATP-dependent RNA helicase SUPV3L1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(176904, NULL, 'G3DSA:2.60.200.20:FF:000157', NULL, NULL, 'PHD finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(176905, NULL, 'G3DSA:3.30.450.40:FF:000004', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(176906, NULL, 'G3DSA:1.10.510.10:FF:003632', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(176907, NULL, 'G3DSA:2.130.10.10:FF:001871', NULL, NULL, 'DAF-15', NULL, NULL, NULL, NULL, NULL, 4),
(176908, NULL, 'G3DSA:2.170.270.10:FF:000188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176909, NULL, 'G3DSA:3.30.160.60:FF:004422', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176910, NULL, 'G3DSA:1.10.10.10:FF:001659', NULL, NULL, 'IS3 family transposase orfA', NULL, NULL, NULL, NULL, NULL, 4),
(176911, NULL, 'G3DSA:3.40.50.1220:FF:000044', NULL, NULL, 'NAD-dependent histone deacetylase SIR2', NULL, NULL, NULL, NULL, NULL, 4),
(176912, NULL, 'G3DSA:2.40.10.220:FF:000005', NULL, NULL, 'Type 4 fimbrial biogenesis protein PilZ', NULL, NULL, NULL, NULL, NULL, 4),
(176913, NULL, 'G3DSA:3.40.50.720:FF:001148', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(176914, NULL, 'G3DSA:2.60.40.10:FF:002264', NULL, NULL, 'dyslexia-associated protein KIAA0319-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(176915, NULL, 'G3DSA:2.40.100.10:FF:000134', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(176916, NULL, 'G3DSA:1.25.40.10:FF:000178', NULL, NULL, 'Anaphase promoting complex subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(176917, NULL, 'G3DSA:1.10.8.60:FF:000476', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176918, NULL, 'G3DSA:1.10.510.10:FF:002704', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176919, NULL, 'G3DSA:3.40.50.300:FF:007857', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176920, NULL, 'G3DSA:3.40.50.10810:FF:000076', NULL, NULL, 'ATP-dependent helicase ULS1', NULL, NULL, NULL, NULL, NULL, 4),
(176921, NULL, 'G3DSA:3.30.9.10:FF:000167', NULL, NULL, 'FAD-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(176922, NULL, 'G3DSA:1.10.287.130:FF:000192', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(176923, NULL, 'G3DSA:3.40.50.300:FF:002214', NULL, NULL, 'ABC transporter related protein', NULL, NULL, NULL, NULL, NULL, 4),
(176924, NULL, 'G3DSA:3.10.20.90:FF:000780', NULL, NULL, 'YALI0D16335p', NULL, NULL, NULL, NULL, NULL, 4),
(176925, NULL, 'G3DSA:3.40.1110.10:FF:000118', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(176926, NULL, 'G3DSA:3.90.1290.10:FF:000018', NULL, NULL, 'microtubule-actin cross-linking factor 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(176927, NULL, 'G3DSA:1.20.1070.10:FF:000031', NULL, NULL, '5-hydroxytryptamine (Serotonin) receptor 2A', NULL, NULL, NULL, NULL, NULL, 4),
(176928, NULL, 'G3DSA:3.30.160.60:FF:002213', NULL, NULL, 'Zinc finger protein 1152', NULL, NULL, NULL, NULL, NULL, 4),
(176929, NULL, 'G3DSA:3.30.160.60:FF:000527', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(176930, NULL, 'G3DSA:3.40.50.150:FF:001371', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176931, NULL, 'G3DSA:3.40.50.720:FF:001856', NULL, NULL, 'Inositol-3-phosphate synthase isozyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(176932, NULL, 'G3DSA:1.10.10.10:FF:000581', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(176933, NULL, 'G3DSA:3.40.50.2300:FF:001397', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176934, NULL, 'G3DSA:3.50.50.60:FF:000232', NULL, NULL, 'Rab GDP dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(176935, NULL, 'G3DSA:1.10.8.10:FF:000158', NULL, NULL, 'Caspar, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(176936, NULL, 'G3DSA:3.80.10.10:FF:002528', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176937, NULL, 'G3DSA:1.10.3730.20:FF:000014', NULL, NULL, 'EamA family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(176938, NULL, 'G3DSA:3.40.50.2300:FF:000733', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One component system)', NULL, NULL, NULL, NULL, NULL, 4),
(176939, NULL, 'G3DSA:1.20.1250.20:FF:001734', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(176940, NULL, 'G3DSA:3.40.50.620:FF:000747', NULL, NULL, 'Uncharacterized protein HI_1701', NULL, NULL, NULL, NULL, NULL, 4),
(176941, NULL, 'G3DSA:3.30.70.330:FF:002055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176942, NULL, 'G3DSA:3.90.70.10:FF:000357', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176943, NULL, 'G3DSA:1.20.190.50:FF:000013', NULL, NULL, 'Nuclear pore complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(176944, NULL, 'G3DSA:1.20.1250.20:FF:001998', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176945, NULL, 'G3DSA:3.30.1380.20:FF:000003', NULL, NULL, 'Trafficking protein particle complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(176946, NULL, 'G3DSA:3.30.230.10:FF:000389', NULL, NULL, 'Diphosphomevalonate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(176947, NULL, 'G3DSA:1.20.58.70:FF:000062', NULL, NULL, 'Syntaxin-16', NULL, NULL, NULL, NULL, NULL, 4),
(176948, NULL, 'G3DSA:3.30.1370.210:FF:000022', NULL, NULL, 'Zinc finger CCCH domain-containing protein 42', NULL, NULL, NULL, NULL, NULL, 4),
(176949, NULL, 'G3DSA:3.40.640.10:FF:000182', NULL, NULL, '4-aminobutyrate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(176950, NULL, 'G3DSA:2.70.150.10:FF:000074', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(176951, NULL, 'G3DSA:2.10.90.10:FF:000083', NULL, NULL, 'Neurturin', NULL, NULL, NULL, NULL, NULL, 4),
(176952, NULL, 'G3DSA:3.40.50.300:FF:000005', NULL, NULL, 'ATP-dependent Clp protease ATP-binding subunit ClpX', NULL, NULL, NULL, NULL, NULL, 4),
(176953, NULL, 'G3DSA:3.30.70.1230:FF:000027', NULL, NULL, 'ACXA, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(176954, NULL, 'G3DSA:2.10.50.10:FF:000165', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(176955, NULL, 'G3DSA:1.25.10.10:FF:003464', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176956, NULL, 'G3DSA:3.40.50.1820:FF:001764', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176957, NULL, 'G3DSA:3.30.930.10:FF:000190', NULL, NULL, 'Seryl-tRNA synthetase putative', NULL, NULL, NULL, NULL, NULL, 4),
(176958, NULL, 'G3DSA:1.10.12.10:FF:000040', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(176959, NULL, 'G3DSA:1.25.40.10:FF:001870', NULL, NULL, 'Outer membrane protein assembly factor BamD', NULL, NULL, NULL, NULL, NULL, 4),
(176960, NULL, 'G3DSA:2.130.10.10:FF:004333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176961, NULL, 'G3DSA:3.10.420.10:FF:000003', NULL, NULL, 'SecB-like chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(176962, NULL, 'G3DSA:1.20.58.1340:FF:000001', NULL, NULL, 'Envelope glycoprotein H', NULL, NULL, NULL, NULL, NULL, 4),
(176963, NULL, 'G3DSA:3.40.50.720:FF:001295', NULL, NULL, 'Bifunctional rhamnulose-1-phosphate aldolase/short-chain dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(176964, NULL, 'G3DSA:3.30.479.30:FF:000022', NULL, NULL, 'Membrane protease subunit, stomatin/prohibitin', NULL, NULL, NULL, NULL, NULL, 4),
(176965, NULL, 'G3DSA:1.10.10.10:FF:001098', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(176966, NULL, 'G3DSA:1.25.10.10:FF:001778', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176967, NULL, 'G3DSA:3.30.420.80:FF:000020', NULL, NULL, '30S ribosomal protein S11', NULL, NULL, NULL, NULL, NULL, 4),
(176968, NULL, 'G3DSA:3.30.450.40:FF:000268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176969, NULL, 'G3DSA:3.90.470.20:FF:000042', NULL, NULL, '4''-phosphopantetheinyl transferase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(176970, NULL, 'G3DSA:3.90.550.10:FF:000506', NULL, NULL, 'Chitin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(176971, NULL, 'G3DSA:2.60.220.50:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176972, NULL, 'G3DSA:3.40.33.10:FF:000178', NULL, NULL, 'SCP-Like extracellular protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(176973, NULL, 'G3DSA:4.10.280.10:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176974, NULL, 'G3DSA:3.30.200.20:FF:000862', NULL, NULL, 'CILIATE-E2/CILIATE-E2-UNCLASSIFIED protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(176975, NULL, 'G3DSA:1.10.8.60:FF:000212', NULL, NULL, 'Sigma-54 dependent transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(176976, NULL, 'G3DSA:3.10.20.90:FF:000072', NULL, NULL, 'Next to BRCA1 gene 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(176977, NULL, 'G3DSA:1.25.40.20:FF:001816', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(176978, NULL, 'G3DSA:2.10.110.10:FF:000231', NULL, NULL, 'LIM and PET domains protein', NULL, NULL, NULL, NULL, NULL, 4),
(176979, NULL, 'G3DSA:3.80.10.10:FF:001303', NULL, NULL, 'NACHT, LRR and PYD domains-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(176980, NULL, 'G3DSA:1.20.1280.260:FF:000001', NULL, NULL, 'Envelope glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(176981, NULL, 'G3DSA:1.10.510.10:FF:002087', NULL, NULL, 'Serine/threonine-protein kinase SKY1', NULL, NULL, NULL, NULL, NULL, 4),
(176982, NULL, 'G3DSA:1.10.287.70:FF:000201', NULL, NULL, 'Two pore segment channel 1', NULL, NULL, NULL, NULL, NULL, 4),
(176983, NULL, 'G3DSA:1.25.40.10:FF:004129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176984, NULL, 'G3DSA:3.30.70.3170:FF:000002', NULL, NULL, 'Galactokinase', NULL, NULL, NULL, NULL, NULL, 4),
(176985, NULL, 'G3DSA:3.10.100.10:FF:000159', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176986, NULL, 'G3DSA:3.30.70.100:FF:000070', NULL, NULL, 'Small-conductance mechanosensitive channel', NULL, NULL, NULL, NULL, NULL, 4),
(176987, NULL, 'G3DSA:1.10.630.10:FF:000645', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176988, NULL, 'G3DSA:1.10.287.70:FF:000673', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176989, NULL, 'G3DSA:2.40.70.10:FF:000041', NULL, NULL, 'Basic 7S globulin', NULL, NULL, NULL, NULL, NULL, 4),
(176990, NULL, 'G3DSA:3.40.50.1010:FF:000071', NULL, NULL, 'Putative 5''-3'' exonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(176991, NULL, 'G3DSA:3.30.559.10:FF:000129', NULL, NULL, 'Nonribosomal peptide synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(176992, NULL, 'G3DSA:1.25.10.10:FF:002503', NULL, NULL, 'Chromosome 12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(176993, NULL, 'G3DSA:2.130.10.10:FF:005378', NULL, NULL, 'Striatin', NULL, NULL, NULL, NULL, NULL, 4),
(176994, NULL, 'G3DSA:3.40.50.300:FF:001989', NULL, NULL, 'GTPase MSS1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(176995, NULL, 'G3DSA:2.10.70.10:FF:000256', NULL, NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(176996, NULL, 'G3DSA:2.10.25.10:FF:000769', NULL, NULL, 'Laminin subunit gamma-1', NULL, NULL, NULL, NULL, NULL, 4),
(176997, NULL, 'G3DSA:2.40.70.10:FF:000480', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(176998, NULL, 'G3DSA:3.90.550.50:FF:000203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(176999, NULL, 'G3DSA:1.10.630.10:FF:000589', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177000, NULL, 'G3DSA:1.25.10.10:FF:002975', NULL, NULL, 'Importin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177001, NULL, 'G3DSA:3.40.50.12230:FF:000013', NULL, NULL, 'Methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(177002, NULL, 'G3DSA:1.10.730.10:FF:000214', NULL, NULL, 'Valyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(177003, NULL, 'G3DSA:2.60.40.10:FF:004265', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177004, NULL, 'G3DSA:3.90.1110.10:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177005, NULL, 'G3DSA:3.40.30.80:FF:000001', NULL, NULL, 'Alkyl hydroperoxide reductase subunit F', NULL, NULL, NULL, NULL, NULL, 4),
(177006, NULL, 'G3DSA:2.60.40.10:FF:000050', NULL, NULL, 'Titin isoform B', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(177007, NULL, 'G3DSA:3.40.720.10:FF:000008', NULL, NULL, 'Alkaline phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(177008, NULL, 'G3DSA:3.40.1190.20:FF:000222', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177009, NULL, 'G3DSA:1.10.10.60:FF:000163', NULL, NULL, 'Arabinose operon transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(177010, NULL, 'G3DSA:2.20.100.10:FF:000060', NULL, NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 17', NULL, NULL, NULL, NULL, NULL, 4),
(177011, NULL, 'G3DSA:1.20.58.480:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177012, NULL, 'G3DSA:3.30.530.20:FF:000055', NULL, NULL, 'Unplaced genomic scaffold supercont1.10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(177013, NULL, 'G3DSA:1.20.1740.10:FF:000116', NULL, NULL, 'Amino acid permease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(177014, NULL, 'G3DSA:1.20.920.10:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177015, NULL, 'G3DSA:1.10.10.60:FF:000640', NULL, NULL, 'Putative Myb-like transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(177016, NULL, 'G3DSA:3.30.420.10:FF:000460', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177017, NULL, 'G3DSA:2.10.250.10:FF:000005', NULL, NULL, 'Calreticulin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(177018, NULL, 'G3DSA:3.30.70.330:FF:001419', NULL, NULL, 'RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(177019, NULL, 'G3DSA:1.25.40.10:FF:000386', NULL, NULL, 'Signal recognition particle subunit SRP72', NULL, NULL, NULL, NULL, NULL, 4),
(177020, NULL, 'G3DSA:3.60.10.10:FF:000096', NULL, NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(177021, NULL, 'G3DSA:2.40.10.10:FF:000032', NULL, NULL, 'Kallikrein 1-related peptidase C9', NULL, NULL, NULL, NULL, NULL, 4),
(177022, NULL, 'G3DSA:2.130.10.10:FF:002591', NULL, NULL, 'Src-associated protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(177023, NULL, 'G3DSA:1.10.520.10:FF:000024', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(177024, NULL, 'G3DSA:3.30.40.10:FF:001009', NULL, NULL, 'Nucleosome-remodeling factor subunit NURF301-like', NULL, NULL, NULL, NULL, NULL, 4),
(177025, NULL, 'G3DSA:3.10.400.20:FF:000005', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(177026, NULL, 'G3DSA:3.30.70.2610:FF:000008', NULL, NULL, 'RNA polymerase II transcription factor B subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(177027, NULL, 'G3DSA:2.60.120.10:FF:000327', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(177028, NULL, 'G3DSA:1.10.10.10:FF:000142', NULL, NULL, 'Cullin 5', NULL, NULL, NULL, NULL, NULL, 4),
(177029, NULL, 'G3DSA:2.40.50.140:FF:000091', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(177030, NULL, 'G3DSA:3.30.160.60:FF:000443', NULL, NULL, 'Zinc finger protein 41', NULL, NULL, NULL, NULL, NULL, 4),
(177031, NULL, 'G3DSA:3.40.50.300:FF:007773', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(177032, NULL, 'G3DSA:1.10.10.10:FF:001867', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177033, NULL, 'G3DSA:2.60.40.60:FF:000924', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177034, NULL, 'G3DSA:1.10.287.70:FF:000196', NULL, NULL, 'Voltage-dependent T-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(177035, NULL, 'G3DSA:2.60.40.10:FF:005198', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177036, NULL, 'G3DSA:3.40.50.720:FF:000075', NULL, NULL, 'Mannitol-1-phosphate 5-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(177037, NULL, 'G3DSA:3.90.640.10:FF:000221', NULL, NULL, 'Actin-like protein 1-1', NULL, NULL, NULL, NULL, NULL, 4),
(177038, NULL, 'G3DSA:3.40.50.620:FF:000247', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(177039, NULL, 'G3DSA:3.90.950.10:FF:000031', NULL, NULL, 'Maf-like protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(177040, NULL, 'G3DSA:1.20.120.160:FF:000013', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(177041, NULL, 'G3DSA:1.10.600.10:FF:000025', NULL, NULL, 'squalene synthase isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(177042, NULL, 'G3DSA:2.30.29.30:FF:000002', NULL, NULL, 'Band 4.1-like protein 5 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(177043, NULL, 'G3DSA:3.40.50.720:FF:002020', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(177044, NULL, 'G3DSA:1.25.40.20:FF:000771', NULL, NULL, 'LOW QUALITY PROTEIN: ankyrin repeat domain-containing protein 33', NULL, NULL, NULL, NULL, NULL, 4),
(177045, NULL, 'G3DSA:3.40.190.10:FF:000720', NULL, NULL, 'Carbohydrate ABC transporter substrate-binding protein, CUT1 family (TC 3.A.1.1.-)', NULL, NULL, NULL, NULL, NULL, 4),
(177046, NULL, 'G3DSA:1.20.80.10:FF:000039', NULL, NULL, 'Myosin 28B1, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(177047, NULL, 'G3DSA:3.80.10.10:FF:004468', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(177048, NULL, 'G3DSA:3.20.20.30:FF:000020', NULL, NULL, 'F420-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(177049, NULL, 'G3DSA:2.115.10.20:FF:000015', NULL, NULL, 'Exoinulinase InuD', NULL, NULL, NULL, NULL, NULL, 4),
(177050, NULL, 'G3DSA:1.10.238.10:FF:000565', NULL, NULL, 'Calcium-binding EF-hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(177051, NULL, 'G3DSA:3.40.50.1970:FF:000038', NULL, NULL, 'Alcohol dehydrogenase, iron-dependent', NULL, NULL, NULL, NULL, NULL, 4),
(177052, NULL, 'G3DSA:3.80.10.10:FF:000730', NULL, NULL, 'Toll-like receptor 11', NULL, NULL, NULL, NULL, NULL, 4),
(177053, NULL, 'G3DSA:3.40.50.150:FF:001163', NULL, NULL, 'NOP2/Sun domain family, member 3', NULL, NULL, NULL, NULL, NULL, 4),
(177054, NULL, 'G3DSA:1.10.3430.10:FF:000056', NULL, NULL, 'Blr0607 protein', NULL, NULL, NULL, NULL, NULL, 4),
(177055, NULL, 'G3DSA:2.30.30.40:FF:000076', NULL, NULL, 'Growth factor receptor-bound protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(177056, NULL, 'G3DSA:2.130.10.10:FF:003405', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177057, NULL, 'G3DSA:2.60.120.620:FF:000080', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(177058, NULL, 'G3DSA:3.90.1150.10:FF:000424', NULL, NULL, 'Uga11p', NULL, NULL, NULL, NULL, NULL, 4),
(177059, NULL, 'G3DSA:1.20.1280.290:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177060, NULL, 'G3DSA:1.20.1280.170:FF:000007', NULL, NULL, 'Exocyst subunit Exo70 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(177061, NULL, 'G3DSA:2.20.70.10:FF:000115', NULL, NULL, 'WW domain-containing oxidoreductase isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(177062, NULL, 'G3DSA:3.40.800.10:FF:000009', NULL, NULL, 'Arginase', NULL, NULL, NULL, NULL, NULL, 4),
(177063, NULL, 'G3DSA:3.40.190.290:FF:000060', NULL, NULL, 'HTH-type transcriptional regulator ArgP', NULL, NULL, NULL, NULL, NULL, 4),
(177064, NULL, 'G3DSA:2.60.120.200:FF:000566', NULL, NULL, 'Calreticulin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(177065, NULL, 'G3DSA:2.60.120.10:FF:000799', NULL, NULL, 'Mannose-6-phosphate isomerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177066, NULL, 'G3DSA:3.30.70.330:FF:001482', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177067, NULL, 'G3DSA:3.30.930.10:FF:000274', NULL, NULL, 'Histidine--tRNA ligase protein', NULL, NULL, NULL, NULL, NULL, 4),
(177068, NULL, 'G3DSA:3.40.30.10:FF:001222', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(177069, NULL, 'G3DSA:3.30.160.60:FF:004658', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177070, NULL, 'G3DSA:3.30.40.10:FF:000987', NULL, NULL, 'Putative E3 ubiquitin-protein ligase ubr7', NULL, NULL, NULL, NULL, NULL, 4),
(177071, NULL, 'G3DSA:1.10.1670.10:FF:000006', NULL, NULL, 'A/G-specific adenine glycosylase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(177072, NULL, 'G3DSA:2.60.40.1730:FF:000018', NULL, NULL, 'M1 family aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(177073, NULL, 'G3DSA:1.25.10.10:FF:003487', NULL, NULL, 'Protein kinase domain-containing protein ppk3', NULL, NULL, NULL, NULL, NULL, 4),
(177074, NULL, 'G3DSA:1.25.10.10:FF:001250', NULL, NULL, 'Dynein axonemal assembly factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(177075, NULL, 'G3DSA:3.10.129.10:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177076, NULL, 'G3DSA:1.10.510.10:FF:000642', NULL, NULL, 'Serine/threonine-protein kinase srpk2', NULL, NULL, NULL, NULL, NULL, 4),
(177077, NULL, 'G3DSA:1.25.40.10:FF:003668', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177078, NULL, 'G3DSA:3.40.50.300:FF:005884', NULL, NULL, 'Protein CBG00906', NULL, NULL, NULL, NULL, NULL, 4),
(177079, NULL, 'G3DSA:4.10.60.10:FF:000262', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(177080, NULL, 'G3DSA:1.10.10.60:FF:001096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177081, NULL, 'G3DSA:1.20.5.4770:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177082, NULL, 'G3DSA:3.40.50.10190:FF:000053', NULL, NULL, 'Microcephalin', NULL, NULL, NULL, NULL, NULL, 4),
(177083, NULL, 'G3DSA:1.10.150.120:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177084, NULL, 'G3DSA:3.40.50.1100:FF:000070', NULL, NULL, 'Diaminopropionate ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(177085, NULL, 'G3DSA:3.40.50.1000:FF:000506', NULL, NULL, 'Phospholipid-transporting ATPase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(177086, NULL, 'G3DSA:1.10.10.10:FF:000934', NULL, NULL, 'Forkhead box protein O3', NULL, NULL, NULL, NULL, NULL, 4),
(177087, NULL, 'G3DSA:1.20.1280.50:FF:000238', NULL, NULL, 'F-box/leucine rich repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177088, NULL, 'G3DSA:1.20.1540.10:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177089, NULL, 'G3DSA:3.40.50.300:FF:000685', NULL, NULL, 'ATP-dependent DNA helicase DinG', NULL, NULL, NULL, NULL, NULL, 4),
(177090, NULL, 'G3DSA:3.30.2410.10:FF:000054', NULL, NULL, 'Protein CBG00511', NULL, NULL, NULL, NULL, NULL, 4),
(177091, NULL, 'G3DSA:3.10.20.80:FF:000007', NULL, NULL, 'Translation initiation factor IF3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177092, NULL, 'G3DSA:3.40.1350.60:FF:000005', NULL, NULL, 'Sugar fermentation stimulation protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(177093, NULL, 'G3DSA:2.60.40.10:FF:000847', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(177094, NULL, 'G3DSA:2.130.10.10:FF:000174', NULL, NULL, 'Protein phosphatase PP2A regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(177095, NULL, 'G3DSA:1.10.510.10:FF:004065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177096, NULL, 'G3DSA:2.10.25.10:FF:000393', NULL, NULL, 'Neurogenic locus notch homolog protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(177097, NULL, 'G3DSA:1.20.1070.10:FF:001312', NULL, NULL, 'Archaeal-type opsin 2', NULL, NULL, NULL, NULL, NULL, 4),
(177098, NULL, 'G3DSA:3.40.50.1820:FF:001680', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177099, NULL, 'G3DSA:3.90.70.40:FF:000017', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(177100, NULL, 'G3DSA:1.10.510.10:FF:003429', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177101, NULL, 'G3DSA:3.30.505.10:FF:000157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177102, NULL, 'G3DSA:2.60.40.10:FF:001359', NULL, NULL, '1,4-alpha-glucan-branching enzyme 3, chloroplastic/amyloplastic', NULL, NULL, NULL, NULL, NULL, 4),
(177103, NULL, 'G3DSA:1.25.40.120:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177104, NULL, 'G3DSA:2.30.140.40:FF:000001', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(177105, NULL, 'G3DSA:2.130.10.10:FF:003580', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(177106, NULL, 'G3DSA:1.10.220.60:FF:000005', NULL, NULL, 'GRIP and coiled-coil domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(177107, NULL, 'G3DSA:3.20.20.105:FF:000017', NULL, NULL, 'Queuine tRNA-ribosyltransferase accessory subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(177108, NULL, 'G3DSA:3.30.160.60:FF:004714', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177109, NULL, 'G3DSA:3.60.40.10:FF:000188', NULL, NULL, 'Protein phosphatase, Mg2+/Mn2+ dependent 1M', NULL, NULL, NULL, NULL, NULL, 4),
(177110, NULL, 'G3DSA:1.20.5.170:FF:000135', NULL, NULL, 'Transcriptional activator in the Cbf1p-Met4p-Met28p complex', NULL, NULL, NULL, NULL, NULL, 4),
(177111, NULL, 'G3DSA:3.30.160.60:FF:005642', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177112, NULL, 'G3DSA:1.20.1080.10:FF:000032', NULL, NULL, 'Aquaporin-2', NULL, NULL, NULL, NULL, NULL, 4),
(177113, NULL, 'G3DSA:2.60.40.10:FF:002287', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(177114, NULL, 'G3DSA:2.60.40.10:FF:005518', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177115, NULL, 'G3DSA:2.60.40.790:FF:000211', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177116, NULL, 'G3DSA:3.40.50.300:FF:004900', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(177117, NULL, 'G3DSA:3.40.50.10810:FF:000104', NULL, NULL, 'Protein CHROMATIN REMODELING 20', NULL, NULL, NULL, NULL, NULL, 4),
(177118, NULL, 'G3DSA:1.10.10.10:FF:000878', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(177119, NULL, 'G3DSA:1.20.58.630:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177120, NULL, 'G3DSA:3.30.70.330:FF:001858', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177121, NULL, 'G3DSA:1.20.5.710:FF:000016', NULL, NULL, '54S ribosomal protein L12, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(177122, NULL, 'G3DSA:3.40.1230.10:FF:000004', NULL, NULL, 'Blast:NADH dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(177123, NULL, 'G3DSA:3.30.450.20:FF:000493', NULL, NULL, 'Diguanylate cyclase and metal dependent phosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(177124, NULL, 'G3DSA:1.20.140.140:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177125, NULL, 'G3DSA:1.10.472.10:FF:000277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177126, NULL, 'G3DSA:1.10.10.10:FF:001923', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177127, NULL, 'G3DSA:3.30.160.60:FF:000819', NULL, NULL, 'zinc finger protein 213 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(177128, NULL, 'G3DSA:1.25.40.10:FF:003292', NULL, NULL, 'Vacuolar protein sorting-associated protein 41', NULL, NULL, NULL, NULL, NULL, 4),
(177129, NULL, 'G3DSA:3.90.1410.10:FF:000046', NULL, NULL, 'SET domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(177130, NULL, 'G3DSA:2.60.40.4060:FF:000010', NULL, NULL, 'SPONdin (Extracellular matrix glycoprotein) family', NULL, NULL, NULL, NULL, NULL, 4),
(177131, NULL, 'G3DSA:3.30.9.10:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177132, NULL, 'G3DSA:1.10.238.10:FF:000126', NULL, NULL, 'DCN1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(177133, NULL, 'G3DSA:2.10.60.10:FF:000047', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(177134, NULL, 'G3DSA:3.30.200.20:FF:002104', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(177135, NULL, 'G3DSA:1.20.1270.60:FF:000325', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(177136, NULL, 'G3DSA:2.30.30.40:FF:000132', NULL, NULL, 'jouberin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(177137, NULL, 'G3DSA:3.30.160.60:FF:000971', NULL, NULL, 'Zinc finger and BTB domain-containing protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(177138, NULL, 'G3DSA:3.90.70.200:FF:000024', NULL, NULL, 'Caldesmon, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177139, NULL, 'G3DSA:4.10.400.10:FF:000049', NULL, NULL, 'Very low density lipoprotein receptor', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(177140, NULL, 'G3DSA:1.10.30.10:FF:000025', NULL, NULL, 'HMG domain-containing protein 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(177141, NULL, 'G3DSA:3.90.70.10:FF:000126', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(177142, NULL, 'G3DSA:1.10.400.10:FF:000021', NULL, NULL, 'Guanine nucleotide-binding protein (G protein), alpha 15 (Gq class)', NULL, NULL, NULL, NULL, NULL, 4),
(177143, NULL, 'G3DSA:3.30.40.10:FF:000195', NULL, NULL, 'E3 ubiquitin-protein ligase RNF220', NULL, NULL, NULL, NULL, NULL, 4),
(177144, NULL, 'G3DSA:3.40.50.20:FF:000029', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(177145, NULL, 'G3DSA:3.80.10.10:FF:003956', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177146, NULL, 'G3DSA:1.20.1080.10:FF:000088', NULL, NULL, 'AQuaPorin or aquaglyceroporin related', NULL, NULL, NULL, NULL, NULL, 4),
(177147, NULL, 'G3DSA:1.20.140.10:FF:000133', NULL, NULL, 'Glutaryl-CoA dehydrogenase a', NULL, NULL, NULL, NULL, NULL, 4),
(177148, NULL, 'G3DSA:3.30.160.360:FF:000015', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(177149, NULL, 'G3DSA:1.10.1410.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177150, NULL, 'G3DSA:1.20.1250.20:FF:001503', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177151, NULL, 'G3DSA:3.30.70.100:FF:000007', NULL, NULL, 'protein NipSnap homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(177152, NULL, 'G3DSA:2.130.10.10:FF:001955', NULL, NULL, 'Cleavage stimulation factor 50K chain', NULL, NULL, NULL, NULL, NULL, 4),
(177153, NULL, 'G3DSA:2.60.40.2030:FF:000013', NULL, NULL, 'Adhesion G-protein coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(177154, NULL, 'G3DSA:1.10.101.10:FF:000023', NULL, NULL, 'Uncharacterized membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(177155, NULL, 'G3DSA:3.90.79.10:FF:000085', NULL, NULL, 'Nudix hydrolase 23, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(177156, NULL, 'G3DSA:3.40.120.10:FF:000007', NULL, NULL, 'Phosphoglucomutase 5', NULL, NULL, NULL, NULL, NULL, 4),
(177157, NULL, 'G3DSA:1.25.40.10:FF:000442', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g49710', NULL, NULL, NULL, NULL, NULL, 4),
(177158, NULL, 'G3DSA:3.40.1800.20:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177159, NULL, 'G3DSA:2.80.10.50:FF:000109', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(177160, NULL, 'G3DSA:3.80.10.10:FF:003220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177161, NULL, 'G3DSA:2.60.40.10:FF:001831', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(177162, NULL, 'G3DSA:3.40.50.300:FF:005356', NULL, NULL, 'Protein translocase subunit SecA 2', NULL, NULL, NULL, NULL, NULL, 4),
(177163, NULL, 'G3DSA:1.20.1050.80:FF:000005', NULL, NULL, 'alsin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(177164, NULL, 'G3DSA:3.50.50.60:FF:001165', NULL, NULL, 'FAD/NAD(P)-binding oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(177165, NULL, 'G3DSA:1.10.472.130:FF:000029', NULL, NULL, 'Dynein gamma chain, flagellar outer arm', NULL, NULL, NULL, NULL, NULL, 4),
(177166, NULL, 'G3DSA:3.40.1110.10:FF:000349', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177167, NULL, 'G3DSA:4.10.240.10:FF:000047', NULL, NULL, 'Oleate activated transcription factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(177168, NULL, 'G3DSA:3.40.50.720:FF:000923', NULL, NULL, '3-alpha-hydroxysteroid dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177169, NULL, 'G3DSA:1.20.1740.10:FF:000240', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(177170, NULL, 'G3DSA:3.40.50.1440:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177171, NULL, 'G3DSA:3.40.50.300:FF:003467', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(177172, NULL, 'G3DSA:1.10.287.940:FF:000013', NULL, NULL, 'P2X purinoceptor', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(177173, NULL, 'G3DSA:1.20.1300.10:FF:000038', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(177174, NULL, 'G3DSA:2.120.10.80:FF:000060', NULL, NULL, 'Kelch like family member 8', NULL, NULL, NULL, NULL, NULL, 4),
(177175, NULL, 'G3DSA:2.60.120.620:FF:000141', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(177176, NULL, 'G3DSA:3.90.480.10:FF:000006', NULL, NULL, 'Sulfite reductase subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177177, NULL, 'G3DSA:1.10.472.80:FF:000045', NULL, NULL, 'TBC1 domain family member 9B isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(177178, NULL, 'G3DSA:2.60.40.10:FF:005193', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177179, NULL, 'G3DSA:2.70.98.30:FF:000008', NULL, NULL, 'Alpha-mannosidase mngB', NULL, NULL, NULL, NULL, NULL, 4),
(177180, NULL, 'G3DSA:2.60.40.10:FF:003629', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177181, NULL, 'G3DSA:2.70.98.10:FF:000002', NULL, NULL, 'Aldose 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(177182, NULL, 'G3DSA:2.60.40.830:FF:000004', NULL, NULL, 'Cytochrome f, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(177183, NULL, 'G3DSA:1.25.40.10:FF:005057', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g50420', NULL, NULL, NULL, NULL, NULL, 4),
(177184, NULL, 'G3DSA:2.40.50.140:FF:000888', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177185, NULL, 'G3DSA:3.40.50.1000:FF:000478', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177186, NULL, 'G3DSA:3.40.50.880:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177187, NULL, 'G3DSA:1.25.40.420:FF:000021', NULL, NULL, 'BTB/POZ domain-containing protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(177188, NULL, 'G3DSA:3.30.300.30:FF:000075', NULL, NULL, 'Nonribosomal peptide synthetase 7', NULL, NULL, NULL, NULL, NULL, 4),
(177189, NULL, 'G3DSA:3.40.50.1440:FF:000054', NULL, NULL, 'Tubulin gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(177190, NULL, 'G3DSA:1.25.40.10:FF:005293', NULL, NULL, 'Clustered mitochondria protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(177191, NULL, 'G3DSA:3.30.70.240:FF:000055', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(177192, NULL, 'G3DSA:2.60.40.60:FF:000076', NULL, NULL, 'Protocadherin alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(177193, NULL, 'G3DSA:1.10.510.10:FF:000703', NULL, NULL, 'Casein kinase I gamma', NULL, NULL, NULL, NULL, NULL, 4),
(177194, NULL, 'G3DSA:2.10.25.10:FF:001225', NULL, NULL, 'Nimrod C1, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(177195, NULL, 'G3DSA:3.50.4.10:FF:000022', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(177196, NULL, 'G3DSA:2.10.25.10:FF:001169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177197, NULL, 'G3DSA:1.10.340.30:FF:000084', NULL, NULL, 'N-glycosylase/DNA lyase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(177198, NULL, 'G3DSA:3.80.10.10:FF:001539', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177199, NULL, 'G3DSA:1.10.1070.11:FF:000023', NULL, NULL, 'serine/threonine-protein kinase SMG1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(177200, NULL, 'G3DSA:3.20.20.70:FF:000684', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177201, NULL, 'G3DSA:3.40.50.150:FF:000674', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(177202, NULL, 'G3DSA:3.40.50.150:FF:000179', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(177203, NULL, 'G3DSA:1.20.58.340:FF:000040', NULL, NULL, 'Magnesium transporter', NULL, NULL, NULL, NULL, NULL, 4),
(177204, NULL, 'G3DSA:2.10.25.10:FF:001410', NULL, NULL, 'FEEL-1', NULL, NULL, NULL, NULL, NULL, 4),
(177205, NULL, 'G3DSA:3.40.50.1860:FF:000005', NULL, NULL, 'Glutamate racemase', NULL, NULL, NULL, NULL, NULL, 4),
(177206, NULL, 'G3DSA:2.60.120.200:FF:000190', NULL, NULL, 'Protein eyes shut homolog', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(177207, NULL, 'G3DSA:3.40.50.360:FF:000096', NULL, NULL, 'Putative flavodoxin', NULL, NULL, NULL, NULL, NULL, 4),
(177208, NULL, 'G3DSA:2.60.40.60:FF:000132', NULL, NULL, 'Proto-oncogene tyrosine-protein kinase receptor Ret', NULL, NULL, NULL, NULL, NULL, 4),
(177209, NULL, 'G3DSA:1.25.40.10:FF:005113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177210, NULL, 'G3DSA:3.10.450.10:FF:000062', NULL, NULL, 'Si:ch211-284e20.8', NULL, NULL, NULL, NULL, NULL, 4),
(177211, NULL, 'G3DSA:2.40.50.100:FF:000163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177212, NULL, 'G3DSA:3.40.50.720:FF:000867', NULL, NULL, 'Ubiquitin activating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(177213, NULL, 'G3DSA:3.40.50.2300:FF:000969', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177214, NULL, 'G3DSA:3.40.120.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177215, NULL, 'G3DSA:3.30.40.10:FF:002140', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(177216, NULL, 'G3DSA:2.30.29.30:FF:001014', NULL, NULL, 'band 4.1-like protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(177217, NULL, 'G3DSA:3.30.70.1660:FF:000015', NULL, NULL, 'Peptide chain release factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(177218, NULL, 'G3DSA:1.10.8.270:FF:000128', NULL, NULL, 'RabGAP/TBC protein', NULL, NULL, NULL, NULL, NULL, 4),
(177219, NULL, 'G3DSA:1.10.1030.10:FF:000008', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(177220, NULL, 'G3DSA:2.60.40.1170:FF:000093', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177221, NULL, 'G3DSA:3.60.10.10:FF:000416', NULL, NULL, 'LP11751p', NULL, NULL, NULL, NULL, NULL, 4),
(177222, NULL, 'G3DSA:1.10.510.10:FF:000518', NULL, NULL, 'serine/threonine-protein kinase 31 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(177223, NULL, 'G3DSA:1.10.640.10:FF:000095', NULL, NULL, 'Peroxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177224, NULL, 'G3DSA:3.30.1060.10:FF:000010', NULL, NULL, 'Peptide methionine sulfoxide reductase msrA', NULL, NULL, NULL, NULL, NULL, 4),
(177225, NULL, 'G3DSA:3.30.60.160:FF:000001', NULL, NULL, 'MBT domain-containing protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(177226, NULL, 'G3DSA:1.20.5.1030:FF:000003', NULL, NULL, 'Preprotein translocase subunit SecE', NULL, NULL, NULL, NULL, NULL, 4),
(177227, NULL, 'G3DSA:1.20.1250.20:FF:001942', NULL, NULL, 'AGAP003495-PA', NULL, NULL, NULL, NULL, NULL, 4),
(177228, NULL, 'G3DSA:3.40.50.720:FF:001620', NULL, NULL, 'Short-chain dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177229, NULL, 'G3DSA:3.40.50.2300:FF:001161', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177230, NULL, 'G3DSA:1.20.1560.10:FF:000170', NULL, NULL, 'MDR-like ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(177231, NULL, 'G3DSA:3.90.70.10:FF:000565', NULL, NULL, 'Putative ABC transporter ATP-binding MG390', NULL, NULL, NULL, NULL, NULL, 4),
(177232, NULL, 'G3DSA:3.30.760.10:FF:000002', NULL, NULL, 'Eukaryotic translation initiation factor 4E', NULL, NULL, NULL, NULL, NULL, 4),
(177233, NULL, 'G3DSA:3.30.160.60:FF:002713', NULL, NULL, 'Zinc finger protein 285', NULL, NULL, NULL, NULL, NULL, 4),
(177234, NULL, 'G3DSA:1.20.1270.60:FF:000269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177235, NULL, 'G3DSA:3.20.20.70:FF:000009', NULL, NULL, '1-(5-phosphoribosyl)-5-[(5-phosphoribosylamino)methylideneamino] imidazole-4-carboxamide isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(177236, NULL, 'G3DSA:1.20.58.1080:FF:000018', NULL, NULL, 'Chromosome 15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(177237, NULL, 'G3DSA:3.40.50.300:FF:002006', NULL, NULL, 'Pantothenate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(177238, NULL, 'G3DSA:3.90.226.10:FF:000096', NULL, NULL, 'Enoyl-CoA hydratase EchA14', NULL, NULL, NULL, NULL, NULL, 4),
(177239, NULL, 'G3DSA:3.40.50.720:FF:001087', NULL, NULL, 'Aflatoxin biosynthesis ketoreductase nor-1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(177240, NULL, 'G3DSA:3.30.200.20:FF:000362', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(177241, NULL, 'G3DSA:3.40.50.300:FF:007357', NULL, NULL, 'Dicer-1', NULL, NULL, NULL, NULL, NULL, 4),
(177242, NULL, 'G3DSA:3.40.50.300:FF:004428', NULL, NULL, 'Cell division protein ZapE', NULL, NULL, NULL, NULL, NULL, 4),
(177243, NULL, 'G3DSA:1.10.287.550:FF:000019', NULL, NULL, 'Steroid sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(177244, NULL, 'G3DSA:1.20.1250.20:FF:002015', NULL, NULL, 'Membrane protein, major facilitator transporter family', NULL, NULL, NULL, NULL, NULL, 4),
(177245, NULL, 'G3DSA:2.40.50.40:FF:000021', NULL, NULL, 'chromodomain Y-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(177246, NULL, 'G3DSA:1.25.40.10:FF:001370', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(177247, NULL, 'G3DSA:2.130.10.10:FF:005322', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177248, NULL, 'G3DSA:3.40.50.450:FF:000027', NULL, NULL, 'Possible lysine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(177249, NULL, 'G3DSA:3.30.160.60:FF:000027', NULL, NULL, 'zinc finger protein 3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(177250, NULL, 'G3DSA:1.10.1450.10:FF:000175', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(177251, NULL, 'G3DSA:1.25.40.1040:FF:000029', NULL, NULL, 'N-terminal acetyltransferase A complex auxiliary subunit NAA15', NULL, NULL, NULL, NULL, NULL, 4),
(177252, NULL, 'G3DSA:1.10.238.10:FF:001054', NULL, NULL, 'Reticulocalbin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177253, NULL, 'G3DSA:3.50.7.10:FF:000028', NULL, NULL, 'Chaperonin 60 subunit beta 2 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(177254, NULL, 'G3DSA:2.40.180.10:FF:000026', NULL, NULL, 'Catalase', NULL, NULL, NULL, NULL, NULL, 4),
(177255, NULL, 'G3DSA:1.20.1280.290:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177256, NULL, 'G3DSA:3.30.160.360:FF:000010', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(177257, NULL, 'G3DSA:1.10.3470.10:FF:000002', NULL, NULL, 'Zinc ABC transporter permease subunit ZnuB', NULL, NULL, NULL, NULL, NULL, 4),
(177258, NULL, 'G3DSA:1.10.730.10:FF:000153', NULL, NULL, 'Valyl tRNA Synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(177259, NULL, 'G3DSA:1.25.10.10:FF:000558', NULL, NULL, 'Fem-3 mRNA-binding factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(177260, NULL, 'G3DSA:1.10.3090.10:FF:000012', NULL, NULL, 'Bifunctional uridylyltransferase/uridylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(177261, NULL, 'G3DSA:2.20.28.120:FF:000003', NULL, NULL, '50S ribosomal protein L33', NULL, NULL, NULL, NULL, NULL, 4),
(177262, NULL, 'G3DSA:1.20.1050.10:FF:000204', NULL, NULL, 'Rpt-6', NULL, NULL, NULL, NULL, NULL, 4),
(177263, NULL, 'G3DSA:3.40.50.300:FF:000213', NULL, NULL, 'ATP-dependent protease ATPase subunit HslU', NULL, NULL, NULL, NULL, NULL, 4),
(177264, NULL, 'G3DSA:1.10.20.10:FF:000351', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177265, NULL, 'G3DSA:3.30.430.20:FF:000019', NULL, NULL, 'Cysteine-rich repeat secretory protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(177266, NULL, 'G3DSA:1.10.3170.10:FF:000013', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(177267, NULL, 'G3DSA:1.10.8.60:FF:000420', NULL, NULL, 'AaceriADL303Cp', NULL, NULL, NULL, NULL, NULL, 4),
(177268, NULL, 'G3DSA:2.60.260.20:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177269, NULL, 'G3DSA:2.130.10.10:FF:005030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177270, NULL, 'G3DSA:2.60.40.790:FF:000155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177271, NULL, 'G3DSA:3.90.550.10:FF:000714', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177272, NULL, 'G3DSA:2.20.200.10:FF:000005', NULL, NULL, 'Multidrug resistance protein, putative', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(177273, NULL, 'G3DSA:3.30.750.24:FF:000099', NULL, NULL, 'Anion transporter SULP-2', NULL, NULL, NULL, NULL, NULL, 4),
(177274, NULL, 'G3DSA:3.30.200.20:FF:002251', NULL, NULL, 'CMGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(177275, NULL, 'G3DSA:3.60.10.10:FF:000040', NULL, NULL, 'Inositol polyphosphate 5-phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177276, NULL, 'G3DSA:1.10.3550.10:FF:000003', NULL, NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(177277, NULL, 'G3DSA:1.25.10.10:FF:000266', NULL, NULL, 'mRNA transport regulator MTR10', NULL, NULL, NULL, NULL, NULL, 4),
(177278, NULL, 'G3DSA:1.10.418.20:FF:000025', NULL, NULL, 'Sentrin-specific protease 2', NULL, NULL, NULL, NULL, NULL, 4),
(177279, NULL, 'G3DSA:3.40.50.300:FF:000741', NULL, NULL, 'Putative mitochondrial dynamin GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(177280, NULL, 'G3DSA:2.60.40.1730:FF:000013', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(177281, NULL, 'G3DSA:3.40.50.410:FF:000010', NULL, NULL, 'Integrator complex subunit 6 like', NULL, NULL, NULL, NULL, NULL, 4),
(177282, NULL, 'G3DSA:2.60.120.1220:FF:000001', NULL, NULL, 'Surface-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(177283, NULL, 'G3DSA:1.10.20.10:FF:000199', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177284, NULL, 'G3DSA:3.10.50.40:FF:000019', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(177285, NULL, 'G3DSA:1.25.10.10:FF:001194', NULL, NULL, 'Armadillo/beta-catenin repeat-like', NULL, NULL, NULL, NULL, NULL, 4),
(177286, NULL, 'G3DSA:2.60.40.790:FF:000008', NULL, NULL, 'Alpha-crystallin A chain', NULL, NULL, NULL, NULL, NULL, 4),
(177287, NULL, 'G3DSA:3.30.160.40:FF:000021', NULL, NULL, 'Probable porphobilinogen deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(177288, NULL, 'G3DSA:2.10.110.10:FF:000170', NULL, NULL, 'LIM domain-containing protein B', NULL, NULL, NULL, NULL, NULL, 4),
(177289, NULL, 'G3DSA:1.25.40.10:FF:002331', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(177290, NULL, 'G3DSA:3.30.70.330:FF:003044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177291, NULL, 'G3DSA:1.20.140.10:FF:000077', NULL, NULL, 'Putative acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(177292, NULL, 'G3DSA:1.10.287.2250:FF:000002', NULL, NULL, 'Cysteine proteinase falcipain 2a', NULL, NULL, NULL, NULL, NULL, 4),
(177293, NULL, 'G3DSA:1.10.287.470:FF:000001', NULL, NULL, 'Disks large 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(177294, NULL, 'G3DSA:2.60.40.10:FF:000903', NULL, NULL, 'obscurin isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(177295, NULL, 'G3DSA:3.40.50.11610:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177296, NULL, 'G3DSA:3.50.50.60:FF:000237', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(177297, NULL, 'G3DSA:3.40.50.1820:FF:001117', NULL, NULL, 'Acetylcholinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(177298, NULL, 'G3DSA:3.30.505.10:FF:000213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177299, NULL, 'G3DSA:3.40.50.300:FF:001141', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(177300, NULL, 'G3DSA:3.30.2160.10:FF:000017', NULL, NULL, 'Putative ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(177301, NULL, 'G3DSA:3.40.1110.10:FF:000057', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(177302, NULL, 'G3DSA:1.25.40.10:FF:001931', NULL, NULL, 'TPR-containing protein DDB_G0280363', NULL, NULL, NULL, NULL, NULL, 4),
(177303, NULL, 'G3DSA:3.40.50.300:FF:005412', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(177304, NULL, 'G3DSA:3.10.290.10:FF:000060', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(177305, NULL, 'G3DSA:3.30.428.10:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177306, NULL, 'G3DSA:1.10.8.500:FF:000012', NULL, NULL, 'Hybrid signal transduction histidine kinase J', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(177307, NULL, 'G3DSA:3.40.50.2300:FF:000941', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177308, NULL, 'G3DSA:2.170.150.10:FF:000033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(177309, NULL, 'G3DSA:2.30.30.140:FF:000341', NULL, NULL, 'SAGA complex associated factor 29', NULL, NULL, NULL, NULL, NULL, 4),
(177310, NULL, 'G3DSA:3.40.50.720:FF:000131', NULL, NULL, 'Short-chain dehydrogenase/reductase 3', NULL, NULL, NULL, NULL, NULL, 4),
(177311, NULL, 'G3DSA:1.10.275.10:FF:000010', NULL, NULL, 'Adenylosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(177312, NULL, 'G3DSA:2.40.170.20:FF:000113', NULL, NULL, 'SusC homolog', NULL, NULL, NULL, NULL, NULL, 4),
(177313, NULL, 'G3DSA:1.25.10.10:FF:001542', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177314, NULL, 'G3DSA:3.40.640.10:FF:000007', NULL, NULL, 'glycine dehydrogenase (Decarboxylating), mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(177315, NULL, 'G3DSA:3.20.180.20:FF:000002', NULL, NULL, 'Cytoplasmic dynein heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(177316, NULL, 'G3DSA:3.50.50.60:FF:001221', NULL, NULL, 'Thiamine thiazole synthase', NULL, NULL, NULL, NULL, NULL, 4),
(177317, NULL, 'G3DSA:1.10.3210.10:FF:000129', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(177318, NULL, 'G3DSA:2.60.40.1860:FF:000001', NULL, NULL, 'Protein-arginine deiminase type-2', NULL, NULL, NULL, NULL, NULL, 4),
(177319, NULL, 'G3DSA:3.30.830.10:FF:000215', NULL, NULL, 'Insulin degrading enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(177320, NULL, 'G3DSA:1.25.40.10:FF:001398', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(177321, NULL, 'G3DSA:1.25.10.10:FF:000614', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(177322, NULL, 'G3DSA:2.130.10.10:FF:003377', NULL, NULL, 'Protein tipD', NULL, NULL, NULL, NULL, NULL, 4),
(177323, NULL, 'G3DSA:2.130.10.10:FF:005406', NULL, NULL, 'Kinesin family member 21A', NULL, NULL, NULL, NULL, NULL, 4),
(177324, NULL, 'G3DSA:3.90.650.10:FF:000042', NULL, NULL, 'Probable phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(177325, NULL, 'G3DSA:3.30.40.10:FF:000223', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 1 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(177326, NULL, 'G3DSA:3.90.70.10:FF:000418', NULL, NULL, 'Ubiquitin C-terminal hydrolase, putative (AFU_orthologue AFUA_2G08440)', NULL, NULL, NULL, NULL, NULL, 4),
(177327, NULL, 'G3DSA:3.40.640.10:FF:000154', NULL, NULL, 'Aminotransferase, class V', NULL, NULL, NULL, NULL, NULL, 4),
(177328, NULL, 'G3DSA:1.10.510.10:FF:000698', NULL, NULL, 'Serine/threonine-protein kinase tousled-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(177329, NULL, 'G3DSA:2.130.10.10:FF:000651', NULL, NULL, 'RaBConnectin related', NULL, NULL, NULL, NULL, NULL, 4),
(177330, NULL, 'G3DSA:1.10.390.10:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177331, NULL, 'G3DSA:1.10.510.10:FF:002120', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177332, NULL, 'G3DSA:4.10.280.10:FF:000140', NULL, NULL, 'High-copy mep suppressor', NULL, NULL, NULL, NULL, NULL, 4),
(177333, NULL, 'G3DSA:1.10.20.10:FF:000204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177334, NULL, 'G3DSA:2.130.10.10:FF:004389', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177335, NULL, 'G3DSA:3.30.200.20:FF:001290', NULL, NULL, 'Spore coat, CotS family protein', NULL, NULL, NULL, NULL, NULL, 4),
(177336, NULL, 'G3DSA:3.40.50.300:FF:008285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177337, NULL, 'G3DSA:2.40.30.10:FF:000100', NULL, NULL, 'NADPH--cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(177338, NULL, 'G3DSA:3.30.450.20:FF:000021', NULL, NULL, 'Neuronal PAS domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(177339, NULL, 'G3DSA:2.130.10.10:FF:001663', NULL, NULL, 'GG22837', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(177340, NULL, 'G3DSA:1.20.58.1210:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177341, NULL, 'G3DSA:1.25.40.180:FF:000308', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177342, NULL, 'G3DSA:2.60.120.290:FF:000025', NULL, NULL, 'Seizure related 6 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(177343, NULL, 'G3DSA:2.60.40.10:FF:003776', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177344, NULL, 'G3DSA:3.90.780.10:FF:000046', NULL, NULL, '5''-nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(177345, NULL, 'G3DSA:1.20.58.240:FF:000009', NULL, NULL, 'Signal transducer and activator of transcription B', NULL, NULL, NULL, NULL, NULL, 4),
(177346, NULL, 'G3DSA:3.40.50.300:FF:005064', NULL, NULL, 'ADP ribosylation factor like GTPase 8A', NULL, NULL, NULL, NULL, NULL, 4),
(177347, NULL, 'G3DSA:3.40.640.10:FF:000502', NULL, NULL, 'Aminotransferase, conjectural', NULL, NULL, NULL, NULL, NULL, 4),
(177348, NULL, 'G3DSA:3.40.50.10190:FF:000289', NULL, NULL, 'DNA ligase 4', NULL, NULL, NULL, NULL, NULL, 4),
(177349, NULL, 'G3DSA:3.60.40.10:FF:000244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177350, NULL, 'G3DSA:3.50.50.60:FF:000996', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(177351, NULL, 'G3DSA:1.10.510.10:FF:002643', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177352, NULL, 'G3DSA:2.160.20.10:FF:000021', NULL, NULL, 'SHC binding and spindle associated 1 like', NULL, NULL, NULL, NULL, NULL, 4),
(177353, NULL, 'G3DSA:3.30.300.30:FF:000108', NULL, NULL, 'Phenyloxazoline synthase MbtB (Mycobactin synthetaseprotein B)', NULL, NULL, NULL, NULL, NULL, 4),
(177354, NULL, 'G3DSA:1.10.510.10:FF:001631', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177355, NULL, 'G3DSA:3.30.160.60:FF:005586', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177356, NULL, 'G3DSA:1.10.287.210:FF:000007', NULL, NULL, 'O-antigen chain length determinant', NULL, NULL, NULL, NULL, NULL, 4),
(177357, NULL, 'G3DSA:3.40.1410.10:FF:000046', NULL, NULL, 'Putative GntR-family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(177358, NULL, 'G3DSA:3.40.50.150:FF:000235', NULL, NULL, 'Protein-L-isoaspartate O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(177359, NULL, 'G3DSA:1.20.1280.50:FF:000233', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(177360, NULL, 'G3DSA:3.10.100.10:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177361, NULL, 'G3DSA:3.30.50.10:FF:000021', NULL, NULL, 'bile acid receptor isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(177362, NULL, 'G3DSA:3.30.40.10:FF:001684', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177363, NULL, 'G3DSA:1.25.40.20:FF:000299', NULL, NULL, 'Ankyrin repeat and KH domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(177364, NULL, 'G3DSA:3.90.1170.10:FF:000010', NULL, NULL, '60S ribosomal protein L16, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(177365, NULL, 'G3DSA:1.10.555.10:FF:000048', NULL, NULL, 'CHN2 isoform 6', NULL, NULL, NULL, NULL, NULL, 4),
(177366, NULL, 'G3DSA:3.30.160.60:FF:002860', NULL, NULL, 'Zinc finger imprinted 2', NULL, NULL, NULL, NULL, NULL, 4),
(177367, NULL, 'G3DSA:1.10.472.10:FF:000333', NULL, NULL, 'TFIIH complex kinase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(177368, NULL, 'G3DSA:3.40.395.10:FF:000021', NULL, NULL, 'Clan CE, family C48, Ulp1-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(177369, NULL, 'G3DSA:3.40.190.170:FF:000018', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(177370, NULL, 'G3DSA:1.10.510.10:FF:004357', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177371, NULL, 'G3DSA:3.30.1050.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177372, NULL, 'G3DSA:1.10.10.10:FF:000406', NULL, NULL, 'DNA-binding transcriptional LysR family regulator', NULL, NULL, NULL, NULL, NULL, 4),
(177373, NULL, 'G3DSA:2.40.10.480:FF:000004', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(177374, NULL, 'G3DSA:3.40.50.2000:FF:000677', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(177375, NULL, 'G3DSA:1.25.50.20:FF:000069', NULL, NULL, 'Protease m1 zinc metalloprotease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177376, NULL, 'G3DSA:2.10.25.10:FF:000005', NULL, NULL, 'Fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(177377, NULL, 'G3DSA:2.120.10.30:FF:000034', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM32', NULL, NULL, NULL, NULL, NULL, 4),
(177378, NULL, 'G3DSA:3.30.1330.20:FF:000028', NULL, NULL, 'Tubulin gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(177379, NULL, 'G3DSA:3.30.160.60:FF:002388', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(177380, NULL, 'G3DSA:2.40.70.10:FF:000277', NULL, NULL, 'Eukaryotic aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(177381, NULL, 'G3DSA:1.25.40.570:FF:000015', NULL, NULL, '26S proteasome regulatory subunit RPN6', NULL, NULL, NULL, NULL, NULL, 4),
(177382, NULL, 'G3DSA:2.10.25.10:FF:000477', NULL, NULL, 'Stabilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(177383, NULL, 'G3DSA:2.130.10.10:FF:004102', NULL, NULL, 'AGAP009862-PA', NULL, NULL, NULL, NULL, NULL, 4),
(177384, NULL, 'G3DSA:3.40.50.300:FF:004395', NULL, NULL, 'Ras-related protein RACG putative', NULL, NULL, NULL, NULL, NULL, 4),
(177385, NULL, 'G3DSA:2.40.100.10:FF:000162', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(177386, NULL, 'G3DSA:3.40.50.300:FF:003411', NULL, NULL, 'Ciliary dynein heavy chain 11', NULL, NULL, NULL, NULL, NULL, 4),
(177387, NULL, 'G3DSA:1.20.1560.10:FF:000675', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177388, NULL, 'G3DSA:1.10.150.530:FF:000020', NULL, NULL, 'Probable dual-specificity RNA methyltransferase RlmN', NULL, NULL, NULL, NULL, NULL, 4),
(177389, NULL, 'G3DSA:1.10.287.600:FF:000001', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(177390, NULL, 'G3DSA:2.60.40.150:FF:000194', NULL, NULL, 'Phosphatidylserine decarboxylase proenzyme 2', NULL, NULL, NULL, NULL, NULL, 4),
(177391, NULL, 'G3DSA:3.40.50.720:FF:001851', NULL, NULL, 'Malate dehydrogenase 1B', NULL, NULL, NULL, NULL, NULL, 4),
(177392, NULL, 'G3DSA:2.170.220.10:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177393, NULL, 'G3DSA:3.40.50.300:FF:003883', NULL, NULL, 'Protein CBG01915', NULL, NULL, NULL, NULL, NULL, 4),
(177394, NULL, 'G3DSA:1.25.40.20:FF:001732', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(177395, NULL, 'G3DSA:3.30.70.330:FF:001190', NULL, NULL, 'Related to NSR1-nuclear localization sequence binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(177396, NULL, 'G3DSA:1.10.443.20:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177397, NULL, 'G3DSA:1.10.3290.20:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177398, NULL, 'G3DSA:1.20.1560.10:FF:000203', NULL, NULL, 'Probable ''component linked with the assembly of cytochrome'' transport transmembrane ATP-binding protein ABC transporter CydC', NULL, NULL, NULL, NULL, NULL, 4),
(177399, NULL, 'G3DSA:3.30.40.10:FF:000700', NULL, NULL, 'E3 ubiquitin-protein ligase RNF213 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(177400, NULL, 'G3DSA:2.30.110.50:FF:000002', NULL, NULL, 'Actin cross-linking toxin VgrG1', NULL, NULL, NULL, NULL, NULL, 4),
(177401, NULL, 'G3DSA:1.20.120.50:FF:000003', NULL, NULL, 'Metal-binding diguanylate cyclase (GGDEF) domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(177402, NULL, 'G3DSA:3.30.60.90:FF:000028', NULL, NULL, 'Unplaced genomic scaffold supercont1.170, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(177403, NULL, 'G3DSA:3.30.390.50:FF:000007', NULL, NULL, 'Lipoate-protein ligase 1', NULL, NULL, NULL, NULL, NULL, 4),
(177404, NULL, 'G3DSA:3.40.50.300:FF:008138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177405, NULL, 'G3DSA:3.90.550.10:FF:000478', NULL, NULL, 'Alpha-L-glycero-D-manno-heptose beta-1,4-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(177406, NULL, 'G3DSA:3.90.70.10:FF:000093', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177407, NULL, 'G3DSA:3.90.640.10:FF:000069', NULL, NULL, 'Actin-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(177408, NULL, 'G3DSA:1.25.10.10:FF:002211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177409, NULL, 'G3DSA:2.30.30.90:FF:000006', NULL, NULL, 'Iron dependent repressor', NULL, NULL, NULL, NULL, NULL, 4),
(177410, NULL, 'G3DSA:1.10.10.60:FF:000455', NULL, NULL, 'Transcription factor MYB1', NULL, NULL, NULL, NULL, NULL, 4),
(177411, NULL, 'G3DSA:2.40.50.700:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177412, NULL, 'G3DSA:1.10.240.10:FF:000014', NULL, NULL, 'Tryptophanyl-tRNA synthetase, cytoplasmic, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177413, NULL, 'G3DSA:1.50.10.160:FF:000011', NULL, NULL, '(E,E)-geranyllinalool synthase', NULL, NULL, NULL, NULL, NULL, 4),
(177414, NULL, 'G3DSA:3.10.150.10:FF:000022', NULL, NULL, 'Beta sliding clamp', NULL, NULL, NULL, NULL, NULL, 4),
(177415, NULL, 'G3DSA:3.30.470.20:FF:000089', NULL, NULL, 'Dur1,2p', NULL, NULL, NULL, NULL, NULL, 4),
(177416, NULL, 'G3DSA:3.40.50.300:FF:007626', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177417, NULL, 'G3DSA:3.40.50.11380:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177418, NULL, 'G3DSA:3.30.70.2850:FF:000029', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(177419, NULL, 'G3DSA:2.10.70.10:FF:000109', NULL, NULL, 'Coagulation factor XIII B chain', NULL, NULL, NULL, NULL, NULL, 4),
(177420, NULL, 'G3DSA:3.20.20.140:FF:000023', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(177421, NULL, 'G3DSA:2.120.10.30:FF:000562', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177422, NULL, 'G3DSA:3.40.50.150:FF:001399', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177423, NULL, 'G3DSA:1.25.40.10:FF:003820', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177424, NULL, 'G3DSA:2.130.10.10:FF:005086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177425, NULL, 'G3DSA:3.40.50.2000:FF:000733', NULL, NULL, 'Lipid-A-disaccharide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(177426, NULL, 'G3DSA:2.170.140.10:FF:000004', NULL, NULL, 'Chitinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(177427, NULL, 'G3DSA:3.80.10.10:FF:000758', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(177428, NULL, 'G3DSA:2.130.10.10:FF:000735', NULL, NULL, 'Quinoprotein amine dehydrogenase beta chain-like', NULL, NULL, NULL, NULL, NULL, 4),
(177429, NULL, 'G3DSA:3.40.50.150:FF:001455', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177430, NULL, 'G3DSA:2.20.28.10:FF:000017', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(177431, NULL, 'G3DSA:3.30.420.10:FF:000752', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177432, NULL, 'G3DSA:3.30.70.920:FF:000012', NULL, NULL, 'AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(177433, NULL, 'G3DSA:3.30.160.20:FF:000190', NULL, NULL, 'Ribonuclease III domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(177434, NULL, 'G3DSA:3.10.450.50:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177435, NULL, 'G3DSA:4.10.240.10:FF:000194', NULL, NULL, 'Transcription activator of gluconeogenesis ERT1', NULL, NULL, NULL, NULL, NULL, 4),
(177436, NULL, 'G3DSA:3.40.50.10800:FF:000011', NULL, NULL, 'Quinolinate synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(177437, NULL, 'G3DSA:2.30.39.10:FF:000053', NULL, NULL, 'Serpin-2 precursor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177438, NULL, 'G3DSA:3.60.15.10:FF:000231', NULL, NULL, 'Zinc metallohydrolase, glyoxalase II family', NULL, NULL, NULL, NULL, NULL, 4),
(177439, NULL, 'G3DSA:2.170.120.20:FF:000006', NULL, NULL, 'Ribosomal protein L25/Gln-tRNA synthetase, anti-codon-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(177440, NULL, 'G3DSA:2.30.40.10:FF:000118', NULL, NULL, 'Putative dihydroorotase', NULL, NULL, NULL, NULL, NULL, 4),
(177441, NULL, 'G3DSA:1.10.8.60:FF:000448', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(177442, NULL, 'G3DSA:3.40.50.300:FF:001702', NULL, NULL, 'Transcriptional regulator, LuxR family', NULL, NULL, NULL, NULL, NULL, 4),
(177443, NULL, 'G3DSA:3.40.850.10:FF:000400', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177444, NULL, 'G3DSA:1.10.10.60:FF:000016', NULL, NULL, 'Transcriptional activator Myb isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(177445, NULL, 'G3DSA:3.40.50.300:FF:005120', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(177446, NULL, 'G3DSA:1.10.3210.10:FF:000040', NULL, NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(177447, NULL, 'G3DSA:3.40.190.10:FF:000517', NULL, NULL, 'Phosphate binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(177448, NULL, 'G3DSA:2.10.90.10:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177449, NULL, 'G3DSA:3.40.120.10:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177450, NULL, 'G3DSA:3.10.20.410:FF:000005', NULL, NULL, 'Putative fimbrial outer membrane usher', NULL, NULL, NULL, NULL, NULL, 4),
(177451, NULL, 'G3DSA:3.30.2350.20:FF:000029', NULL, NULL, 'Pseudouridine_synthase_TruD_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(177452, NULL, 'G3DSA:1.10.10.10:FF:002087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177453, NULL, 'G3DSA:3.30.160.60:FF:006283', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177454, NULL, 'G3DSA:1.25.10.10:FF:003195', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(177455, NULL, 'G3DSA:3.30.1240.10:FF:000052', NULL, NULL, 'Putative phosphatase YxeH', NULL, NULL, NULL, NULL, NULL, 4),
(177456, NULL, 'G3DSA:1.10.238.10:FF:000273', NULL, NULL, 'troponin C', NULL, NULL, NULL, NULL, NULL, 4),
(177457, NULL, 'G3DSA:2.40.170.20:FF:000057', NULL, NULL, 'Ferripyoverdine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(177458, NULL, 'G3DSA:1.10.10.10:FF:001103', NULL, NULL, 'Rrf2 family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(177459, NULL, 'G3DSA:1.10.510.10:FF:000934', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(177460, NULL, 'G3DSA:2.60.40.60:FF:000401', NULL, NULL, 'AGAP009716-PA', NULL, NULL, NULL, NULL, NULL, 4),
(177461, NULL, 'G3DSA:3.30.160.60:FF:001932', NULL, NULL, 'Zinc finger protein 76', NULL, NULL, NULL, NULL, NULL, 4),
(177462, NULL, 'G3DSA:2.60.40.10:FF:001011', NULL, NULL, 'leukemia inhibitory factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(177463, NULL, 'G3DSA:3.30.200.20:FF:001851', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177464, NULL, 'G3DSA:3.40.80.10:FF:000028', NULL, NULL, 'Amidase', NULL, NULL, NULL, NULL, NULL, 4),
(177465, NULL, 'G3DSA:3.80.10.10:FF:002523', NULL, NULL, 'Probable inactive serine/threonine-protein kinase roco10', NULL, NULL, NULL, NULL, NULL, 4),
(177466, NULL, 'G3DSA:3.30.1110.10:FF:000008', NULL, NULL, 'Adenosine kinase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(177467, NULL, 'G3DSA:2.30.29.30:FF:000997', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177468, NULL, 'G3DSA:3.40.50.2300:FF:000177', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(177469, NULL, 'G3DSA:3.30.160.60:FF:004153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177470, NULL, 'G3DSA:1.20.1250.20:FF:001178', NULL, NULL, 'Jen2p', NULL, NULL, NULL, NULL, NULL, 4),
(177471, NULL, 'G3DSA:2.60.40.10:FF:004029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177472, NULL, 'G3DSA:2.40.70.10:FF:000333', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177473, NULL, 'G3DSA:1.10.3120.10:FF:000010', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(177474, NULL, 'G3DSA:3.40.50.10810:FF:000071', NULL, NULL, 'SNF2 domain-containing protein / helicase domain-containing protein / zinc finger protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(177475, NULL, 'G3DSA:3.30.300.150:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177476, NULL, 'G3DSA:1.10.1200.10:FF:000044', NULL, NULL, '10-formyltetrahydrofolate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(177477, NULL, 'G3DSA:1.10.10.1730:FF:000002', NULL, NULL, 'Blast:Folliculin', NULL, NULL, NULL, NULL, NULL, 4),
(177478, NULL, 'G3DSA:1.20.120.540:FF:000003', NULL, NULL, 'Cyclic nucleotide-gated potassium channel mll3241', NULL, NULL, NULL, NULL, NULL, 4),
(177479, NULL, 'G3DSA:3.30.200.20:FF:001795', NULL, NULL, 'Cyclin T-dependent kinase CDK9, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177480, NULL, 'G3DSA:3.40.50.300:FF:006340', NULL, NULL, 'Dicer-like ribonuclease with helicase and Rnase III domains', NULL, NULL, NULL, NULL, NULL, 4),
(177481, NULL, 'G3DSA:3.40.50.1820:FF:001533', NULL, NULL, 'Os06g0520000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(177482, NULL, 'G3DSA:3.90.1150.10:FF:000008', NULL, NULL, 'Cystathionine gamma-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(177483, NULL, 'G3DSA:3.30.2350.10:FF:000083', NULL, NULL, 'RNA pseudouridylate synthase protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177484, NULL, 'G3DSA:3.40.850.10:FF:000080', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(177485, NULL, 'G3DSA:1.10.510.10:FF:001007', NULL, NULL, 'Hal5p', NULL, NULL, NULL, NULL, NULL, 4),
(177486, NULL, 'G3DSA:2.60.40.1180:FF:000011', NULL, NULL, 'Alpha-L-arabinofuranosidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(177487, NULL, 'G3DSA:2.40.40.20:FF:000042', NULL, NULL, 'Molybdopterin guanine dinucleotide-containing S/N-oxide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(177488, NULL, 'G3DSA:1.25.10.10:FF:000322', NULL, NULL, 'U-box domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(177489, NULL, 'G3DSA:1.20.1720.10:FF:000025', NULL, NULL, 'Major facilitator superfamily MFS_1', NULL, NULL, NULL, NULL, NULL, 4),
(177490, NULL, 'G3DSA:1.10.472.10:FF:000625', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177491, NULL, 'G3DSA:1.25.40.10:FF:001875', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177492, NULL, 'G3DSA:2.30.31.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177493, NULL, 'G3DSA:3.30.300.130:FF:000002', NULL, NULL, 'Fe/S biogenesis protein NfuA', NULL, NULL, NULL, NULL, NULL, 4),
(177494, NULL, 'G3DSA:1.20.1070.10:FF:000823', NULL, NULL, 'KISS1R isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(177495, NULL, 'G3DSA:2.40.20.10:FF:000089', NULL, NULL, 'HGF/MSP/plasminogen-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(177496, NULL, 'G3DSA:1.10.150.20:FF:000044', NULL, NULL, 'DnaJ protein ERDJ2A', NULL, NULL, NULL, NULL, NULL, 4),
(177497, NULL, 'G3DSA:2.70.150.10:FF:000158', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(177498, NULL, 'G3DSA:3.40.50.1010:FF:000099', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(177499, NULL, 'G3DSA:1.20.120.1910:FF:000028', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(177500, NULL, 'G3DSA:1.20.5.340:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177501, NULL, 'G3DSA:3.20.20.80:FF:000602', NULL, NULL, 'Os03g0600600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(177502, NULL, 'G3DSA:1.20.120.1900:FF:000082', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(177503, NULL, 'G3DSA:2.60.120.200:FF:000274', NULL, NULL, 'Uip5p', NULL, NULL, NULL, NULL, NULL, 4),
(177504, NULL, 'G3DSA:3.60.21.10:FF:000357', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177505, NULL, 'G3DSA:3.30.160.60:FF:000499', NULL, NULL, 'ZXD family zinc finger C', NULL, NULL, NULL, NULL, NULL, 4),
(177506, NULL, 'G3DSA:3.40.50.300:FF:004715', NULL, NULL, 'ADP-ribosylation factor-like protein 5', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(177507, NULL, 'G3DSA:1.10.486.10:FF:000039', NULL, NULL, 'UvrD/REP helicase N-terminal domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(177508, NULL, 'G3DSA:3.40.50.150:FF:000151', NULL, NULL, 'Methyltransferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(177509, NULL, 'G3DSA:1.10.510.10:FF:001715', NULL, NULL, 'Probable cyclin-dependent kinase 9', NULL, NULL, NULL, NULL, NULL, 4),
(177510, NULL, 'G3DSA:3.40.309.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177511, NULL, 'G3DSA:1.20.120.560:FF:000009', NULL, NULL, 'BRO1-like domain/ALIX V-shaped domain binding to HIV, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177512, NULL, 'G3DSA:1.20.1250.20:FF:001650', NULL, NULL, 'Putative glucose transporter rco-3', NULL, NULL, NULL, NULL, NULL, 4),
(177513, NULL, 'G3DSA:1.20.120.350:FF:000244', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177514, NULL, 'G3DSA:3.50.50.60:FF:001018', NULL, NULL, 'Rab proteins geranylgeranyltransferase component A', NULL, NULL, NULL, NULL, NULL, 4),
(177515, NULL, 'G3DSA:1.20.1640.10:FF:000024', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(177516, NULL, 'G3DSA:2.40.10.10:FF:000537', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177517, NULL, 'G3DSA:3.30.1640.10:FF:000037', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(177518, NULL, 'G3DSA:1.20.1260.60:FF:000004', NULL, NULL, 'Increased Sodium Tolerance Related', NULL, NULL, NULL, NULL, NULL, 4),
(177519, NULL, 'G3DSA:3.40.1370.10:FF:000019', NULL, NULL, '50S ribosomal protein L4', NULL, NULL, NULL, NULL, NULL, 4),
(177520, NULL, 'G3DSA:3.40.50.720:FF:001564', NULL, NULL, 'E1 ubiquitin-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(177521, NULL, 'G3DSA:3.30.420.210:FF:000002', NULL, NULL, 'UBX domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(177522, NULL, 'G3DSA:3.60.20.10:FF:000158', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177523, NULL, 'G3DSA:3.30.70.100:FF:000154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177524, NULL, 'G3DSA:3.30.200.20:FF:001087', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(177525, NULL, 'G3DSA:3.40.50.300:FF:005917', NULL, NULL, 'ABC multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177526, NULL, 'G3DSA:2.60.40.10:FF:004181', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177527, NULL, 'G3DSA:3.30.70.890:FF:000076', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(177528, NULL, 'G3DSA:2.30.30.380:FF:000065', NULL, NULL, 'Nei like DNA glycosylase 3', NULL, NULL, NULL, NULL, NULL, 4),
(177529, NULL, 'G3DSA:3.40.640.10:FF:000210', NULL, NULL, 'Aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(177530, NULL, 'G3DSA:1.20.140.100:FF:000022', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(177531, NULL, 'G3DSA:3.40.50.300:FF:006901', NULL, NULL, 'Branched-chain amino acid ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(177532, NULL, 'G3DSA:3.40.47.10:FF:000204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177533, NULL, 'G3DSA:1.20.5.190:FF:000113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177534, NULL, 'G3DSA:3.30.160.60:FF:004097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177535, NULL, 'G3DSA:3.30.1540.20:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177536, NULL, 'G3DSA:3.40.50.150:FF:000527', NULL, NULL, 'Unplaced genomic scaffold supercont2.5, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(177537, NULL, 'G3DSA:1.25.40.10:FF:003112', NULL, NULL, 'Developmental protein', NULL, NULL, NULL, NULL, NULL, 4),
(177538, NULL, 'G3DSA:2.130.10.10:FF:005850', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(177539, NULL, 'G3DSA:3.30.420.40:FF:000351', NULL, NULL, 'Heat shock cognate 70 kDa protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(177540, NULL, 'G3DSA:2.10.25.10:FF:001641', NULL, NULL, 'Matrilin 3b', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(177541, NULL, 'G3DSA:3.30.160.60:FF:005878', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177542, NULL, 'G3DSA:2.70.150.10:FF:000102', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(177543, NULL, 'G3DSA:1.10.10.10:FF:001575', NULL, NULL, 'Transcriptional regulator, FUR family', NULL, NULL, NULL, NULL, NULL, 4),
(177544, NULL, 'G3DSA:3.30.160.60:FF:003697', NULL, NULL, 'Zinc finger protein 142', NULL, NULL, NULL, NULL, NULL, 4),
(177545, NULL, 'G3DSA:1.10.437.10:FF:000055', NULL, NULL, 'BCL2 associated X, apoptosis regulator', NULL, NULL, NULL, NULL, NULL, 4),
(177546, NULL, 'G3DSA:3.40.630.30:FF:000395', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(177547, NULL, 'G3DSA:1.25.10.10:FF:002470', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(177548, NULL, 'G3DSA:1.10.630.10:FF:000830', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177549, NULL, 'G3DSA:1.10.8.60:FF:000184', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(177550, NULL, 'G3DSA:3.30.1490.190:FF:000014', NULL, NULL, 'Ferric uptake regulation protein', NULL, NULL, NULL, NULL, NULL, 4),
(177551, NULL, 'G3DSA:2.60.120.650:FF:000004', NULL, NULL, 'Putative lysine-specific demethylase 3B', NULL, NULL, NULL, NULL, NULL, 4),
(177552, NULL, 'G3DSA:3.30.1490.20:FF:000101', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(177553, NULL, 'G3DSA:3.90.226.10:FF:000152', NULL, NULL, 'Glutaconyl-CoA decarboxylase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(177554, NULL, 'G3DSA:3.40.50.300:FF:000972', NULL, NULL, 'Uncharacterized protein, isoform K', NULL, NULL, NULL, NULL, NULL, 4),
(177555, NULL, 'G3DSA:1.10.8.60:FF:000504', NULL, NULL, 'Katanin p60 ATPase-containing subunit A-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(177556, NULL, 'G3DSA:3.10.20.90:FF:000364', NULL, NULL, 'Unplaced genomic scaffold supercont1.163, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(177557, NULL, 'G3DSA:3.10.110.10:FF:000132', NULL, NULL, 'Ubiquitin-conjugating enzyme E2-17 kDa 3', NULL, NULL, NULL, NULL, NULL, 4),
(177558, NULL, 'G3DSA:1.20.1310.10:FF:000067', NULL, NULL, 'Cul3p', NULL, NULL, NULL, NULL, NULL, 4),
(177559, NULL, 'G3DSA:1.20.5.1500:FF:000010', NULL, NULL, 'AGAP002712-PA', NULL, NULL, NULL, NULL, NULL, 4),
(177560, NULL, 'G3DSA:1.25.40.10:FF:000094', NULL, NULL, 'telomerase-binding protein EST1A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(177561, NULL, 'G3DSA:2.60.40.10:FF:000286', NULL, NULL, 'Myosin binding protein C, slow type', NULL, NULL, NULL, NULL, NULL, 4),
(177562, NULL, 'G3DSA:1.10.1450.10:FF:000091', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(177563, NULL, 'G3DSA:1.10.10.1540:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177564, NULL, 'G3DSA:3.40.50.300:FF:002630', NULL, NULL, 'ATP-dependent kinase YFH7', NULL, NULL, NULL, NULL, NULL, 4),
(177565, NULL, 'G3DSA:2.130.10.10:FF:000207', NULL, NULL, 'Cilia- and flagella-associated protein 52', NULL, NULL, NULL, NULL, NULL, 4),
(177566, NULL, 'G3DSA:3.30.420.40:FF:000912', NULL, NULL, 'Actin-like protein 1-1', NULL, NULL, NULL, NULL, NULL, 4),
(177567, NULL, 'G3DSA:3.30.450.20:FF:000526', NULL, NULL, 'Response receiver sensor protein serine/threonine phosphatase, PP2C family, PAS and PAS domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(177568, NULL, 'G3DSA:1.25.10.10:FF:001486', NULL, NULL, 'GTP binding protein, putative (AFU_orthologue AFUA_4G04560)', NULL, NULL, NULL, NULL, NULL, 4),
(177569, NULL, 'G3DSA:2.30.30.140:FF:000285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177570, NULL, 'G3DSA:1.10.580.10:FF:000028', NULL, NULL, 'Citrate synthase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(177571, NULL, 'G3DSA:1.10.530.10:FF:000025', NULL, NULL, 'Resuscitation-promoting factor RpfC', NULL, NULL, NULL, NULL, NULL, 4),
(177572, NULL, 'G3DSA:3.30.460.10:FF:000018', NULL, NULL, 'Mitochondrial assembly of ribosomal large subunit 1', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(177573, NULL, 'G3DSA:3.30.300.180:FF:000023', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(177574, NULL, 'G3DSA:3.30.160.60:FF:002444', NULL, NULL, 'Zgc:171929', NULL, NULL, NULL, NULL, NULL, 4),
(177575, NULL, 'G3DSA:3.40.50.10490:FF:000058', NULL, NULL, 'Glucose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(177576, NULL, 'G3DSA:3.30.540.10:FF:000019', NULL, NULL, 'Fructose-1,6-bisphosphatase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(177577, NULL, 'G3DSA:1.20.1070.10:FF:001548', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177578, NULL, 'G3DSA:2.60.120.970:FF:000038', NULL, NULL, 'Transforming growth factor beta-2', NULL, NULL, NULL, NULL, NULL, 4),
(177579, NULL, 'G3DSA:3.30.565.10:FF:000430', NULL, NULL, 'GAF domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(177580, NULL, 'G3DSA:2.60.40.10:FF:004557', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177581, NULL, 'G3DSA:1.10.287.70:FF:000229', NULL, NULL, 'Potassium/sodium hyperpolarization-activated cyclic nucleotide-gated channel 4', NULL, NULL, NULL, NULL, NULL, 4),
(177582, NULL, 'G3DSA:1.10.10.10:FF:000850', NULL, NULL, 'DNA-binding transcriptional regulator, MarR family', NULL, NULL, NULL, NULL, NULL, 4),
(177583, NULL, 'G3DSA:2.130.10.10:FF:001808', NULL, NULL, 'DNA damage-binding protein CMR1', NULL, NULL, NULL, NULL, NULL, 4),
(177584, NULL, 'G3DSA:2.40.50.140:FF:000596', NULL, NULL, 'AGAP010177-PA', NULL, NULL, NULL, NULL, NULL, 4),
(177585, NULL, 'G3DSA:1.10.510.10:FF:000411', NULL, NULL, 'Probable Ste20-like kinase Don3', NULL, NULL, NULL, NULL, NULL, 4),
(177586, NULL, 'G3DSA:2.20.25.10:FF:000067', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(177587, NULL, 'G3DSA:3.30.70.330:FF:000262', NULL, NULL, 'Probable rna-binding protein 23 isoform', NULL, NULL, NULL, NULL, NULL, 4),
(177588, NULL, 'G3DSA:3.30.170.10:FF:000007', NULL, NULL, 'Cyclin-dependent kinases regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(177589, NULL, 'G3DSA:3.30.160.60:FF:001988', NULL, NULL, 'transcription factor E4F1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(177590, NULL, 'G3DSA:3.40.50.300:FF:008610', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177591, NULL, 'G3DSA:2.80.10.50:FF:000076', NULL, NULL, 'Beta-galactoside-specific lectin 1', NULL, NULL, NULL, NULL, NULL, 4),
(177592, NULL, 'G3DSA:2.30.30.40:FF:000363', NULL, NULL, 'Bridging integrator 1', NULL, NULL, NULL, NULL, NULL, 4),
(177593, NULL, 'G3DSA:3.30.1010.10:FF:000063', NULL, NULL, 'Serine/threonine-protein kinase ATM', NULL, NULL, NULL, NULL, NULL, 4),
(177594, NULL, 'G3DSA:2.40.50.140:FF:000124', NULL, NULL, 'Ribonuclease R', NULL, NULL, NULL, NULL, NULL, 4),
(177595, NULL, 'G3DSA:1.25.40.20:FF:001024', NULL, NULL, 'Ankyrin repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(177596, NULL, 'G3DSA:2.60.40.420:FF:000095', NULL, NULL, 'Nitrous-oxide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(177597, NULL, 'G3DSA:1.10.510.10:FF:001395', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(177598, NULL, 'G3DSA:3.40.50.2000:FF:000497', NULL, NULL, 'AGAP009137-PA', NULL, NULL, NULL, NULL, NULL, 4),
(177599, NULL, 'G3DSA:3.40.630.10:FF:000237', NULL, NULL, 'Leucine aminopeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(177600, NULL, 'G3DSA:2.60.40.10:FF:005485', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177601, NULL, 'G3DSA:1.10.565.10:FF:000077', NULL, NULL, 'Nuclear hormone receptor family member nhr-153', NULL, NULL, NULL, NULL, NULL, 4),
(177602, NULL, 'G3DSA:1.10.10.10:FF:001070', NULL, NULL, 'Similar to anaphase-promoting complex subunit ApcB', NULL, NULL, NULL, NULL, NULL, 4),
(177603, NULL, 'G3DSA:3.40.850.10:FF:000456', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(177604, NULL, 'G3DSA:1.10.150.50:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177605, NULL, 'G3DSA:2.30.29.30:FF:001306', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(177606, NULL, 'G3DSA:2.40.70.10:FF:000513', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177607, NULL, 'G3DSA:3.40.50.720:FF:001379', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(177608, NULL, 'G3DSA:1.25.40.10:FF:004601', NULL, NULL, 'U4/U6-U5 snRNP complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(177609, NULL, 'G3DSA:6.10.140.2220:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177610, NULL, 'G3DSA:1.20.58.60:FF:000558', NULL, NULL, 'Microtubule actin crosslinking factor 1a', NULL, NULL, NULL, NULL, NULL, 4),
(177611, NULL, 'G3DSA:2.130.10.10:FF:005794', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177612, NULL, 'G3DSA:3.40.630.20:FF:000010', NULL, NULL, 'Pyroglutamyl-peptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(177613, NULL, 'G3DSA:2.10.50.10:FF:000081', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 6B', NULL, NULL, NULL, NULL, NULL, 4),
(177614, NULL, 'G3DSA:3.30.70.330:FF:002347', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177615, NULL, 'G3DSA:1.10.220.160:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177616, NULL, 'G3DSA:2.80.10.50:FF:000261', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177617, NULL, 'G3DSA:2.60.40.420:FF:000151', NULL, NULL, 'Similar to azurin', NULL, NULL, NULL, NULL, NULL, 4),
(177618, NULL, 'G3DSA:2.170.270.10:FF:000160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177619, NULL, 'G3DSA:2.60.40.1120:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177620, NULL, 'G3DSA:3.40.50.1000:FF:000242', NULL, NULL, 'Phosphomannomutase', NULL, NULL, NULL, NULL, NULL, 4),
(177621, NULL, 'G3DSA:3.30.200.20:FF:000070', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(177622, NULL, 'G3DSA:2.130.10.130:FF:000018', NULL, NULL, 'YJL132W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(177623, NULL, 'G3DSA:3.30.500.10:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177624, NULL, 'G3DSA:1.10.540.10:FF:000054', NULL, NULL, 'Acyl-CoA dehydrogenase FadE27', NULL, NULL, NULL, NULL, NULL, 4),
(177625, NULL, 'G3DSA:3.30.1330.30:FF:000093', NULL, NULL, 'rRNA methyltransferase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(177626, NULL, 'G3DSA:3.30.1370.10:FF:000112', NULL, NULL, 'Scp160p', NULL, NULL, NULL, NULL, NULL, 4),
(177627, NULL, 'G3DSA:2.60.40.10:FF:004501', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177628, NULL, 'G3DSA:3.30.420.10:FF:000044', NULL, NULL, 'Sporulation inhibitor KapD', NULL, NULL, NULL, NULL, NULL, 4),
(177629, NULL, 'G3DSA:3.10.280.10:FF:000031', NULL, NULL, 'Putative uncharacterized protein DDB_G0288137', NULL, NULL, NULL, NULL, NULL, 4),
(177630, NULL, 'G3DSA:3.40.50.1370:FF:000010', NULL, NULL, 'Ornithine carbamoyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(177631, NULL, 'G3DSA:3.10.20.90:FF:000600', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(177632, NULL, 'G3DSA:3.40.50.1820:FF:000100', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(177633, NULL, 'G3DSA:2.130.10.110:FF:000012', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(177634, NULL, 'G3DSA:3.30.1330.40:FF:000039', NULL, NULL, 'Enamine/imine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(177635, NULL, 'G3DSA:1.50.10.10:FF:000202', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(177636, NULL, 'G3DSA:3.15.10.10:FF:000003', NULL, NULL, 'BPI fold-containing family A member 1', NULL, NULL, NULL, NULL, NULL, 4),
(177637, NULL, 'G3DSA:3.10.450.50:FF:000023', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(177638, NULL, 'G3DSA:1.20.1070.10:FF:000115', NULL, NULL, 'Melanin-concentrating hormone receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(177639, NULL, 'G3DSA:3.30.230.70:FF:000064', NULL, NULL, 'Exosome complex exonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(177640, NULL, 'G3DSA:3.30.420.40:FF:000295', NULL, NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(177641, NULL, 'G3DSA:3.40.50.1390:FF:000016', NULL, NULL, 'Site-specific recombinase', NULL, NULL, NULL, NULL, NULL, 4),
(177642, NULL, 'G3DSA:3.90.550.10:FF:000422', NULL, NULL, '2-phospho-L-lactate guanylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(177643, NULL, 'G3DSA:3.80.10.10:FF:004092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177644, NULL, 'G3DSA:2.60.40.1670:FF:000006', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(177645, NULL, 'G3DSA:1.25.40.10:FF:003640', NULL, NULL, 'Tetratricopeptide repeat protein 21B', NULL, NULL, NULL, NULL, NULL, 4),
(177646, NULL, 'G3DSA:3.10.350.10:FF:000003', NULL, NULL, 'Membrane-bound lytic murein transglycosylase D', NULL, NULL, NULL, NULL, NULL, 4),
(177647, NULL, 'G3DSA:3.20.20.460:FF:000001', NULL, NULL, 'Monomethylamine methyltransferase MtmB1', NULL, NULL, NULL, NULL, NULL, 4),
(177648, NULL, 'G3DSA:3.30.70.1230:FF:000263', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(177649, NULL, 'G3DSA:3.40.50.200:FF:000037', NULL, NULL, 'Epidermin leader peptide processing serine protease EpiP', NULL, NULL, NULL, NULL, NULL, 4),
(177650, NULL, 'G3DSA:3.60.10.10:FF:000332', NULL, NULL, 'Gll4079 protein', NULL, NULL, NULL, NULL, NULL, 4),
(177651, NULL, 'G3DSA:1.10.10.1390:FF:000001', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(177652, NULL, 'G3DSA:3.20.20.10:FF:000042', NULL, NULL, 'Pyridoxal phosphate homeostasis protein', NULL, NULL, NULL, NULL, NULL, 4),
(177653, NULL, 'G3DSA:3.30.420.510:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177654, NULL, 'G3DSA:3.30.160.60:FF:003169', NULL, NULL, 'Zinc finger protein 1157', NULL, NULL, NULL, NULL, NULL, 4),
(177655, NULL, 'G3DSA:1.20.272.10:FF:000012', NULL, NULL, 'DNA polymerase III subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(177656, NULL, 'G3DSA:3.90.740.10:FF:000072', NULL, NULL, 'Leucyl-tRNA synthetase b', NULL, NULL, NULL, NULL, NULL, 4),
(177657, NULL, 'G3DSA:2.10.25.10:FF:001697', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(177658, NULL, 'G3DSA:2.60.120.10:FF:000294', NULL, NULL, 'HTH-type transcriptional regulator Cmr', NULL, NULL, NULL, NULL, NULL, 4),
(177659, NULL, 'G3DSA:3.40.50.1000:FF:000186', NULL, NULL, 'CCC2p Cu(+2)-transporting P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(177660, NULL, 'G3DSA:3.40.50.300:FF:007065', NULL, NULL, 'ATP binding cassette subfamily G member 4', NULL, NULL, NULL, NULL, NULL, 4),
(177661, NULL, 'G3DSA:2.10.25.10:FF:000713', NULL, NULL, 'Aggrecan core protein', NULL, NULL, NULL, NULL, NULL, 4),
(177662, NULL, 'G3DSA:2.60.40.10:FF:005670', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177663, NULL, 'G3DSA:3.30.160.60:FF:006098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177664, NULL, 'G3DSA:3.20.20.80:FF:000546', NULL, NULL, 'Alpha-L-arabinofuranosidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(177665, NULL, 'G3DSA:3.30.1490.220:FF:000006', NULL, NULL, 'Inositol-tetrakisphosphate 1-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(177666, NULL, 'G3DSA:3.40.1670.10:FF:000003', NULL, NULL, 'Phenolic acid decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(177667, NULL, 'G3DSA:3.80.10.10:FF:001742', NULL, NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(177668, NULL, 'G3DSA:3.40.50.300:FF:006284', NULL, NULL, 'ATP-dependent RecD-like DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(177669, NULL, 'G3DSA:3.40.30.10:FF:000733', NULL, NULL, 'Mitochondrial ribosome protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177670, NULL, 'G3DSA:2.30.29.170:FF:000005', NULL, NULL, 'Nucleoside diphosphate kinase 7', NULL, NULL, NULL, NULL, NULL, 4),
(177671, NULL, 'G3DSA:3.15.10.30:FF:000009', NULL, NULL, 'AGAP008182-PA', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(177672, NULL, 'G3DSA:2.10.220.10:FF:000088', NULL, NULL, 'Insulin-like receptor', NULL, NULL, NULL, NULL, NULL, 4),
(177673, NULL, 'G3DSA:3.30.559.30:FF:000107', NULL, NULL, 'Ferrichrome siderophore peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(177674, NULL, 'G3DSA:3.90.70.10:FF:000273', NULL, NULL, 'Papain family cysteine protease domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(177675, NULL, 'G3DSA:3.90.640.10:FF:000249', NULL, NULL, 'HSP70-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(177676, NULL, 'G3DSA:3.40.630.30:FF:000631', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177677, NULL, 'G3DSA:3.40.630.30:FF:000428', NULL, NULL, 'GNAT family N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(177678, NULL, 'G3DSA:3.90.1530.30:FF:000004', NULL, NULL, 'Transcriptional repressor protein KorB', NULL, NULL, NULL, NULL, NULL, 4),
(177679, NULL, 'G3DSA:3.90.660.20:FF:000017', NULL, NULL, 'NAD(P)/FAD-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(177680, NULL, 'G3DSA:3.30.70.1170:FF:000020', NULL, NULL, 'Sun (Fmu) protein (Sun-2)', NULL, NULL, NULL, NULL, NULL, 4),
(177681, NULL, 'G3DSA:3.40.50.620:FF:000663', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177682, NULL, 'G3DSA:3.10.490.10:FF:000036', NULL, NULL, 'Gamma-glutamyl cyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(177683, NULL, 'G3DSA:1.10.510.10:FF:000226', NULL, NULL, 'NUAK family SNF1-like kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(177684, NULL, 'G3DSA:1.10.150.20:FF:000100', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(177685, NULL, 'G3DSA:3.90.190.10:FF:000579', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177686, NULL, 'G3DSA:3.10.120.10:FF:000014', NULL, NULL, 'Chitin synthase 6', NULL, NULL, NULL, NULL, NULL, 4),
(177687, NULL, 'G3DSA:3.30.2140.20:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177688, NULL, 'G3DSA:3.30.559.10:FF:000101', NULL, NULL, 'Nonribosomal peptide synthetase 13', NULL, NULL, NULL, NULL, NULL, 4),
(177689, NULL, 'G3DSA:2.130.10.10:FF:002360', NULL, NULL, 'DDB1- and CUL4-associated factor 13', NULL, NULL, NULL, NULL, NULL, 4),
(177690, NULL, 'G3DSA:2.60.40.10:FF:001775', NULL, NULL, 'Jitterbug, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(177691, NULL, 'G3DSA:3.30.420.40:FF:001076', NULL, NULL, 'Pantothenate kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(177692, NULL, 'G3DSA:1.20.1070.10:FF:001751', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177693, NULL, 'G3DSA:4.10.60.10:FF:000026', NULL, NULL, 'cellular nucleic acid-binding protein-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(177694, NULL, 'G3DSA:4.10.410.10:FF:000078', NULL, NULL, 'GH02025p', NULL, NULL, NULL, NULL, NULL, 4),
(177695, NULL, 'G3DSA:2.40.160.20:FF:000028', NULL, NULL, 'Outer membrane protein W', NULL, NULL, NULL, NULL, NULL, 4),
(177696, NULL, 'G3DSA:3.90.79.10:FF:000141', NULL, NULL, 'GDP-mannose pyrophosphatase nudK', NULL, NULL, NULL, NULL, NULL, 4),
(177697, NULL, 'G3DSA:3.40.50.10050:FF:000005', NULL, NULL, 'Translation initiation factor aIF-2', NULL, NULL, NULL, NULL, NULL, 4),
(177698, NULL, 'G3DSA:2.30.180.10:FF:000074', NULL, NULL, 'Stabilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(177699, NULL, 'G3DSA:2.40.50.150:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177700, NULL, 'G3DSA:3.30.559.10:FF:000045', NULL, NULL, 'Putative siderophore biosysnthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(177701, NULL, 'G3DSA:1.25.40.10:FF:001111', NULL, NULL, 'WGS project CABT00000000 data, contig 2.14', NULL, NULL, NULL, NULL, NULL, 4),
(177702, NULL, 'G3DSA:3.40.50.300:FF:006137', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(177703, NULL, 'G3DSA:3.40.50.800:FF:000088', NULL, NULL, 'Threonine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(177704, NULL, 'G3DSA:2.30.29.30:FF:000289', NULL, NULL, 'Epidermal growth factor receptor kinase substrate 8', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(177705, NULL, 'G3DSA:1.10.510.10:FF:004121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177706, NULL, 'G3DSA:3.30.160.60:FF:004861', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177707, NULL, 'G3DSA:1.10.472.10:FF:000569', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177708, NULL, 'G3DSA:1.10.8.840:FF:000001', NULL, NULL, 'dnaJ homolog subfamily C member 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(177709, NULL, 'G3DSA:3.30.420.40:FF:000148', NULL, NULL, 'Actin, alpha skeletal muscle', NULL, NULL, NULL, NULL, NULL, 4),
(177710, NULL, 'G3DSA:3.90.1290.10:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177711, NULL, 'G3DSA:4.10.400.10:FF:000105', NULL, NULL, 'Lipophorin receptor 1, isoform K', NULL, NULL, NULL, NULL, NULL, 4),
(177712, NULL, 'G3DSA:1.20.1070.10:FF:002004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177713, NULL, 'G3DSA:1.10.3450.20:FF:000004', NULL, NULL, 'Nuclear pore complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(177714, NULL, 'G3DSA:1.25.40.10:FF:004416', NULL, NULL, 'Pentatricopeptide repeat protein PPR868-14 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(177715, NULL, 'G3DSA:3.30.342.10:FF:000025', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(177716, NULL, 'G3DSA:1.20.1070.10:FF:001604', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(177717, NULL, 'G3DSA:1.20.5.70:FF:000001', NULL, NULL, 'Glycophorin B', NULL, NULL, NULL, NULL, NULL, 4),
(177718, NULL, 'G3DSA:2.60.40.10:FF:001067', NULL, NULL, 'Leucine-rich repeat transmembrane protein FLRT1', NULL, NULL, NULL, NULL, NULL, 4),
(177719, NULL, 'G3DSA:1.10.510.10:FF:003284', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177720, NULL, 'G3DSA:1.20.1250.20:FF:000722', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(177721, NULL, 'G3DSA:3.30.160.60:FF:003933', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177722, NULL, 'G3DSA:3.30.420.40:FF:000856', NULL, NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(177723, NULL, 'G3DSA:3.90.660.10:FF:000104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177724, NULL, 'G3DSA:3.30.70.2660:FF:000001', NULL, NULL, 'CRISPR system Cascade subunit CasD', NULL, NULL, NULL, NULL, NULL, 4),
(177725, NULL, 'G3DSA:3.30.470.10:FF:000047', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(177726, NULL, 'G3DSA:3.80.10.10:FF:003164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177727, NULL, 'G3DSA:3.10.20.90:FF:000544', NULL, NULL, 'Protein CLMP1', NULL, NULL, NULL, NULL, NULL, 4),
(177728, NULL, 'G3DSA:1.20.1250.20:FF:000014', NULL, NULL, 'synaptic vesicle glycoprotein 2A', NULL, NULL, NULL, NULL, NULL, 4),
(177729, NULL, 'G3DSA:1.10.1520.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177730, NULL, 'G3DSA:3.30.750.24:FF:000043', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(177731, NULL, 'G3DSA:2.60.40.10:FF:002612', NULL, NULL, 'Chitodextrinase', NULL, NULL, NULL, NULL, NULL, 4),
(177732, NULL, 'G3DSA:3.40.630.30:FF:000575', NULL, NULL, 'Acetyltransferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(177733, NULL, 'G3DSA:1.25.40.20:FF:000619', NULL, NULL, 'Ankyrin repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(177734, NULL, 'G3DSA:1.25.40.10:FF:000706', NULL, NULL, 'gamma-soluble NSF attachment protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(177735, NULL, 'G3DSA:2.30.42.10:FF:000628', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177736, NULL, 'G3DSA:3.30.930.10:FF:000127', NULL, NULL, 'Phenylalanine--tRNA ligase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(177737, NULL, 'G3DSA:1.25.40.20:FF:000243', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(177738, NULL, 'G3DSA:1.20.58.60:FF:000761', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(177739, NULL, 'G3DSA:1.50.10.20:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177740, NULL, 'G3DSA:2.60.40.150:FF:000755', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177741, NULL, 'G3DSA:2.30.42.10:FF:000252', NULL, NULL, 'MAGI (Membrane Associated Guanylate kinase Inverted) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(177742, NULL, 'G3DSA:1.20.140.40:FF:000092', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177743, NULL, 'G3DSA:2.60.40.10:FF:003012', NULL, NULL, 'Glycoprotein (transmembrane) nmb', NULL, NULL, NULL, NULL, NULL, 4),
(177744, NULL, 'G3DSA:3.20.20.70:FF:000453', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177745, NULL, 'G3DSA:3.20.20.80:FF:000366', NULL, NULL, 'Alpha-L-fucosidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(177746, NULL, 'G3DSA:3.40.50.300:FF:006845', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177747, NULL, 'G3DSA:3.90.25.10:FF:000022', NULL, NULL, 'GDP-L-fucose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(177748, NULL, 'G3DSA:1.20.1070.10:FF:000059', NULL, NULL, 'G protein-coupled receptor 37', NULL, NULL, NULL, NULL, NULL, 4),
(177749, NULL, 'G3DSA:3.10.200.10:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177750, NULL, 'G3DSA:2.130.10.10:FF:001899', NULL, NULL, 'Activating molecule in BECN1-regulated autophagy protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(177751, NULL, 'G3DSA:3.10.129.10:FF:000006', NULL, NULL, 'YbgC/FadM family acyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(177752, NULL, 'G3DSA:1.20.5.190:FF:000057', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(177753, NULL, 'G3DSA:3.20.20.70:FF:000829', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177754, NULL, 'G3DSA:3.40.390.10:FF:000229', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177755, NULL, 'G3DSA:1.25.40.10:FF:003584', NULL, NULL, 'SARP family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(177756, NULL, 'G3DSA:3.40.50.1820:FF:000044', NULL, NULL, 'Abhydrolase domain containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(177757, NULL, 'G3DSA:3.40.50.1240:FF:000022', NULL, NULL, 'Phosphoglycerate mutase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(177758, NULL, 'G3DSA:1.25.40.10:FF:000150', NULL, NULL, 'Nephrocystin-3', NULL, NULL, NULL, NULL, NULL, 4),
(177759, NULL, 'G3DSA:2.60.40.1110:FF:000007', NULL, NULL, 'Phosphatidylinositol 3,4,5-trisphosphate 3-phosphatase and protein-tyrosine-phosphatase PTEN1', NULL, NULL, NULL, NULL, NULL, 4),
(177760, NULL, 'G3DSA:3.30.870.10:FF:000072', NULL, NULL, 'Phospholipase D, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177761, NULL, 'G3DSA:2.10.110.10:FF:000259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177762, NULL, 'G3DSA:1.10.10.10:FF:002031', NULL, NULL, 'Cell division control protein', NULL, NULL, NULL, NULL, NULL, 4),
(177763, NULL, 'G3DSA:3.30.160.60:FF:003225', NULL, NULL, 'Tripartite motif-containing protein 73', NULL, NULL, NULL, NULL, NULL, 4),
(177764, NULL, 'G3DSA:3.40.50.720:FF:002492', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(177765, NULL, 'G3DSA:2.60.120.380:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177766, NULL, 'G3DSA:3.80.10.10:FF:000106', NULL, NULL, 'F-box/LRR-repeat protein 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(177767, NULL, 'G3DSA:1.20.1070.10:FF:000767', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177768, NULL, 'G3DSA:3.30.70.330:FF:001566', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177769, NULL, 'G3DSA:3.30.465.10:FF:000102', NULL, NULL, 'FAD linked oxidase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(177770, NULL, 'G3DSA:1.20.120.1750:FF:000053', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(177771, NULL, 'G3DSA:2.60.40.150:FF:000047', NULL, NULL, 'Putative E3 ubiquitin-protein ligase NEDD4-like', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(177772, NULL, 'G3DSA:3.60.21.10:FF:000413', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(177773, NULL, 'G3DSA:3.60.130.10:FF:000026', NULL, NULL, 'Related to COX10-farnesyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(177774, NULL, 'G3DSA:1.10.1040.10:FF:000037', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(P)+]', NULL, NULL, NULL, NULL, NULL, 4),
(177775, NULL, 'G3DSA:3.40.630.10:FF:000417', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177776, NULL, 'G3DSA:2.60.40.10:FF:001628', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(177777, NULL, 'G3DSA:1.20.5.170:FF:000051', NULL, NULL, 'mitotic spindle assembly checkpoint protein MAD1', NULL, NULL, NULL, NULL, NULL, 4),
(177778, NULL, 'G3DSA:3.40.30.10:FF:000553', NULL, NULL, 'Peroxiredoxin-2C', NULL, NULL, NULL, NULL, NULL, 4),
(177779, NULL, 'G3DSA:1.10.10.10:FF:000086', NULL, NULL, 'Holliday junction ATP-dependent DNA helicase RuvB', NULL, NULL, NULL, NULL, NULL, 4),
(177780, NULL, 'G3DSA:1.10.8.710:FF:000013', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(177781, NULL, 'G3DSA:2.40.50.140:FF:000652', NULL, NULL, 'GD16141', NULL, NULL, NULL, NULL, NULL, 4),
(177782, NULL, 'G3DSA:1.20.1270.60:FF:000033', NULL, NULL, 'Sorting nexin', NULL, NULL, NULL, NULL, NULL, 4),
(177783, NULL, 'G3DSA:3.30.230.10:FF:000361', NULL, NULL, 'Ribonuclease P protein component', NULL, NULL, NULL, NULL, NULL, 4),
(177784, NULL, 'G3DSA:2.130.10.10:FF:006047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177785, NULL, 'G3DSA:2.40.30.170:FF:000011', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(177786, NULL, 'G3DSA:1.25.40.20:FF:000804', NULL, NULL, 'Ankyrin repeat and KH domain-containing protein mask', NULL, NULL, NULL, NULL, NULL, 4),
(177787, NULL, 'G3DSA:1.25.10.10:FF:002267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177788, NULL, 'G3DSA:3.90.980.20:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177789, NULL, 'G3DSA:3.30.70.1730:FF:000031', NULL, NULL, '50S ribosomal protein L10', NULL, NULL, NULL, NULL, NULL, 4),
(177790, NULL, 'G3DSA:3.40.50.1820:FF:000752', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(177791, NULL, 'G3DSA:3.80.10.10:FF:000814', NULL, NULL, 'Related to mRNA export factor mex67', NULL, NULL, NULL, NULL, NULL, 4),
(177792, NULL, 'G3DSA:3.40.50.10480:FF:000016', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(177793, NULL, 'G3DSA:3.90.1750.10:FF:000009', NULL, NULL, 'E3 ubiquitin-protein ligase HUWE1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(177794, NULL, 'G3DSA:2.40.50.690:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177795, NULL, 'G3DSA:3.30.420.10:FF:000605', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177796, NULL, 'G3DSA:2.30.180.10:FF:000107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177797, NULL, 'G3DSA:3.90.550.10:FF:000681', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177798, NULL, 'G3DSA:1.10.20.10:FF:000171', NULL, NULL, 'Histone H2B', NULL, NULL, NULL, NULL, NULL, 4),
(177799, NULL, 'G3DSA:3.40.50.300:FF:000421', NULL, NULL, 'Branched-chain amino acid ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(177800, NULL, 'G3DSA:3.50.50.60:FF:000849', NULL, NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(177801, NULL, 'G3DSA:2.60.40.10:FF:003809', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177802, NULL, 'G3DSA:2.60.40.10:FF:001623', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(177803, NULL, 'G3DSA:3.40.50.261:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177804, NULL, 'G3DSA:2.160.20.10:FF:000313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177805, NULL, 'G3DSA:1.10.150.340:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(177806, NULL, 'G3DSA:1.20.120.350:FF:000160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177807, NULL, 'G3DSA:3.30.505.10:FF:000005', NULL, NULL, 'SHC-transforming protein 1 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(177808, NULL, 'G3DSA:2.40.30.20:FF:000036', NULL, NULL, 'Riboflavin synthase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(177809, NULL, 'G3DSA:3.40.50.2000:FF:000385', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177810, NULL, 'G3DSA:2.60.200.20:FF:000005', NULL, NULL, 'Kinesin family member 16B', NULL, NULL, NULL, NULL, NULL, 4),
(177811, NULL, 'G3DSA:2.10.25.10:FF:000680', NULL, NULL, 'Laminin subunit alpha-3', NULL, NULL, NULL, NULL, NULL, 4),
(177812, NULL, 'G3DSA:1.10.3480.10:FF:000003', NULL, NULL, 'Chaperone, TorD family', NULL, NULL, NULL, NULL, NULL, 4),
(177813, NULL, 'G3DSA:3.90.70.10:FF:000334', NULL, NULL, 'Cathepsin B-like cysteine proteinase', NULL, NULL, NULL, NULL, NULL, 4),
(177814, NULL, 'G3DSA:3.30.160.60:FF:002680', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(177815, NULL, 'G3DSA:3.30.1540.20:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177816, NULL, 'G3DSA:4.10.860.120:FF:000016', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(177817, NULL, 'G3DSA:1.25.10.10:FF:002391', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177818, NULL, 'G3DSA:3.20.20.60:FF:000068', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(177819, NULL, 'G3DSA:3.40.430.10:FF:000048', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(177820, NULL, 'G3DSA:1.20.58.60:FF:000261', NULL, NULL, 'Muscle-specific protein 300 kDa, isoform L', NULL, NULL, NULL, NULL, NULL, 4),
(177821, NULL, 'G3DSA:2.60.120.1030:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177822, NULL, 'G3DSA:1.20.58.60:FF:000210', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(177823, NULL, 'G3DSA:3.80.10.10:FF:003804', NULL, NULL, 'AGAP007463-PA', NULL, NULL, NULL, NULL, NULL, 4),
(177824, NULL, 'G3DSA:1.10.950.10:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177825, NULL, 'G3DSA:3.90.550.10:FF:000242', NULL, NULL, 'Glucosyl-3-phosphoglycerate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(177826, NULL, 'G3DSA:3.40.50.880:FF:000038', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(177827, NULL, 'G3DSA:1.10.3720.10:FF:000191', NULL, NULL, 'Putative anion ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(177828, NULL, 'G3DSA:3.90.1600.10:FF:000061', NULL, NULL, 'DNA polymerase epsilon catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(177829, NULL, 'G3DSA:3.30.70.100:FF:000159', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177830, NULL, 'G3DSA:2.30.30.380:FF:000042', NULL, NULL, 'Thioredoxin TrxC', NULL, NULL, NULL, NULL, NULL, 4),
(177831, NULL, 'G3DSA:3.30.160.60:FF:005434', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177832, NULL, 'G3DSA:3.30.70.330:FF:000341', NULL, NULL, 'Hephaestus, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(177833, NULL, 'G3DSA:1.20.120.1910:FF:000056', NULL, NULL, 'Cysteinyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(177834, NULL, 'G3DSA:2.60.40.2690:FF:000003', NULL, NULL, 'Splicing factor 3a, subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(177835, NULL, 'G3DSA:3.40.50.10380:FF:000025', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(177836, NULL, 'G3DSA:3.40.50.740:FF:000030', NULL, NULL, 'NADH-quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(177837, NULL, 'G3DSA:2.60.40.10:FF:005838', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177838, NULL, 'G3DSA:3.40.350.10:FF:000047', NULL, NULL, 'FACT complex subunit SPT16', NULL, NULL, NULL, NULL, NULL, 4),
(177839, NULL, 'G3DSA:3.65.10.10:FF:000029', NULL, NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(177840, NULL, 'G3DSA:3.30.2170.10:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(177841, NULL, 'G3DSA:3.40.50.10330:FF:000022', NULL, NULL, 'Ceramide kinase', NULL, NULL, NULL, NULL, NULL, 4),
(177842, NULL, 'G3DSA:1.10.8.60:FF:000156', NULL, NULL, 'Ribosome biogenesis ATPase RIX7', NULL, NULL, NULL, NULL, NULL, 4),
(177843, NULL, 'G3DSA:1.25.40.20:FF:001440', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177844, NULL, 'G3DSA:3.60.10.10:FF:000208', NULL, NULL, 'YALI0D19778p', NULL, NULL, NULL, NULL, NULL, 4),
(177845, NULL, 'G3DSA:3.40.50.300:FF:005204', NULL, NULL, 'Adenylate kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177846, NULL, 'G3DSA:2.170.270.10:FF:000183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177847, NULL, 'G3DSA:1.10.472.10:FF:000485', NULL, NULL, 'Lipoate protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(177848, NULL, 'G3DSA:1.20.1070.10:FF:000907', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177849, NULL, 'G3DSA:3.40.50.300:FF:001882', NULL, NULL, 'ABC efflux transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177850, NULL, 'G3DSA:1.10.8.750:FF:000002', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(177851, NULL, 'G3DSA:3.30.200.20:FF:000093', NULL, NULL, 'Putative map kinase-interacting serine/threonine-protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(177852, NULL, 'G3DSA:3.90.1200.10:FF:000064', NULL, NULL, 'Choline Kinase B', NULL, NULL, NULL, NULL, NULL, 4),
(177853, NULL, 'G3DSA:2.60.40.10:FF:002079', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(177854, NULL, 'G3DSA:3.10.450.50:FF:000051', NULL, NULL, 'Nuclear transport factor 2 (NTF2) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(177855, NULL, 'G3DSA:2.130.10.10:FF:000707', NULL, NULL, 'prolactin regulatory element-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(177856, NULL, 'G3DSA:3.40.50.620:FF:000399', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(177857, NULL, 'G3DSA:1.10.1420.10:FF:000078', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(177858, NULL, 'G3DSA:2.60.120.290:FF:000233', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(177859, NULL, 'G3DSA:3.40.630.30:FF:000687', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177860, NULL, 'G3DSA:1.10.20.10:FF:000120', NULL, NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(177861, NULL, 'G3DSA:1.20.920.30:FF:000025', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177862, NULL, 'G3DSA:3.40.50.300:FF:000472', NULL, NULL, 'ATP-binding cassette, sub-family F (GCN20), member 1', NULL, NULL, NULL, NULL, NULL, 4),
(177863, NULL, 'G3DSA:2.130.10.30:FF:000073', NULL, NULL, 'Regulator of chromosome condensation, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177864, NULL, 'G3DSA:1.20.120.150:FF:000004', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(177865, NULL, 'G3DSA:1.10.10.10:FF:001715', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(177866, NULL, 'G3DSA:1.20.20.10:FF:000030', NULL, NULL, 'ATP synthase C subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177867, NULL, 'G3DSA:1.20.5.370:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177868, NULL, 'G3DSA:3.90.1200.10:FF:000013', NULL, NULL, 'Methylthioribose kinase', NULL, NULL, NULL, NULL, NULL, 4),
(177869, NULL, 'G3DSA:1.25.40.730:FF:000018', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(177870, NULL, 'G3DSA:1.25.40.20:FF:001491', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177871, NULL, 'G3DSA:3.40.47.10:FF:000176', NULL, NULL, 'Trifunctional enzyme subunit beta, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(177872, NULL, 'G3DSA:3.40.50.150:FF:001747', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177873, NULL, 'G3DSA:1.20.1600.10:FF:000050', NULL, NULL, 'Putative outer membrane efflux protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(177874, NULL, 'G3DSA:3.30.200.20:FF:000042', NULL, NULL, 'Aurora kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(177875, NULL, 'G3DSA:2.130.10.10:FF:003725', NULL, NULL, 'Serine/threonine-protein phosphatase 2A regulatory subunit phr2AB', NULL, NULL, NULL, NULL, NULL, 4),
(177876, NULL, 'G3DSA:1.20.1250.20:FF:002279', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(177877, NULL, 'G3DSA:2.60.40.10:FF:002180', NULL, NULL, 'Uncharacterized protein, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(177878, NULL, 'G3DSA:3.40.30.10:FF:000992', NULL, NULL, 'Iodothyronine deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(177879, NULL, 'G3DSA:2.40.50.140:FF:001225', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177880, NULL, 'G3DSA:4.10.400.10:FF:000257', NULL, NULL, 'Low-density lipoprotein RecePtor related', NULL, NULL, NULL, NULL, NULL, 4),
(177881, NULL, 'G3DSA:3.30.160.60:FF:003877', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177882, NULL, 'G3DSA:3.10.110.10:FF:000137', NULL, NULL, 'NEDD8-conjugating enzyme Ubc12', NULL, NULL, NULL, NULL, NULL, 4),
(177883, NULL, 'G3DSA:1.10.10.10:FF:000294', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(177884, NULL, 'G3DSA:3.40.50.720:FF:002109', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(177885, NULL, 'G3DSA:2.170.270.10:FF:000132', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(177886, NULL, 'G3DSA:3.40.50.300:FF:004687', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(177887, NULL, 'G3DSA:3.20.20.70:FF:000717', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177888, NULL, 'G3DSA:1.20.5.170:FF:000287', NULL, NULL, 'Keratin, type I cytoskeletal 14', NULL, NULL, NULL, NULL, NULL, 4),
(177889, NULL, 'G3DSA:1.20.58.2220:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177890, NULL, 'G3DSA:3.40.50.1820:FF:001769', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(177891, NULL, 'G3DSA:3.30.470.30:FF:000025', NULL, NULL, 'Mrna capping', NULL, NULL, NULL, NULL, NULL, 4),
(177892, NULL, 'G3DSA:2.30.42.10:FF:000196', NULL, NULL, 'Inturned planar cell polarity protein', NULL, NULL, NULL, NULL, NULL, 4),
(177893, NULL, 'G3DSA:1.10.506.10:FF:000059', NULL, NULL, 'Plexin A', NULL, NULL, NULL, NULL, NULL, 4),
(177894, NULL, 'G3DSA:3.40.50.720:FF:000715', NULL, NULL, 'Possible molybdopterin biosynthesis protein moeW', NULL, NULL, NULL, NULL, NULL, 4),
(177895, NULL, 'G3DSA:3.30.565.10:FF:000453', NULL, NULL, 'Hybrid signal transduction histidine kinase K', NULL, NULL, NULL, NULL, NULL, 4),
(177896, NULL, 'G3DSA:1.20.120.1760:FF:000090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177897, NULL, 'G3DSA:3.30.70.330:FF:002999', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177898, NULL, 'G3DSA:3.20.20.220:FF:000081', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(177899, NULL, 'G3DSA:3.60.40.10:FF:000036', NULL, NULL, 'Protein phosphatase, Mg2+/Mn2+ dependent 1J', NULL, NULL, NULL, NULL, NULL, 4),
(177900, NULL, 'G3DSA:3.40.50.300:FF:002219', NULL, NULL, 'Transitional endoplasmic reticulum ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(177901, NULL, 'G3DSA:3.40.50.2020:FF:000183', NULL, NULL, 'Ribose-phosphate pyrophosphokinase 2 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(177902, NULL, 'G3DSA:6.10.140.2220:FF:000009', NULL, NULL, 'Zinc finger MYND domain-containing protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(177903, NULL, 'G3DSA:1.20.58.670:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177904, NULL, 'G3DSA:3.80.10.10:FF:004209', NULL, NULL, '60S ribosomal protein L36', NULL, NULL, NULL, NULL, NULL, 4),
(177905, NULL, 'G3DSA:3.80.10.10:FF:002383', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177906, NULL, 'G3DSA:3.30.200.20:FF:001435', NULL, NULL, 'Spore coat protein YsxE', NULL, NULL, NULL, NULL, NULL, 4),
(177907, NULL, 'G3DSA:1.25.40.10:FF:002151', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(177908, NULL, 'G3DSA:1.10.390.10:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177909, NULL, 'G3DSA:3.40.30.10:FF:000941', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177910, NULL, 'G3DSA:3.30.450.30:FF:000063', NULL, NULL, 'IP01982p', NULL, NULL, NULL, NULL, NULL, 4),
(177911, NULL, 'G3DSA:3.90.660.10:FF:000071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177912, NULL, 'G3DSA:3.30.70.940:FF:000023', NULL, NULL, 'Probable NusG-like protein-putative transcription activator', NULL, NULL, NULL, NULL, NULL, 4),
(177913, NULL, 'G3DSA:3.40.250.10:FF:000163', NULL, NULL, 'tRNA 2-selenouridine/geranyl-2-thiouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(177914, NULL, 'G3DSA:3.80.10.10:FF:000819', NULL, NULL, 'Brassinosteroid LRR receptor kinase BRI1', NULL, NULL, NULL, NULL, NULL, 4),
(177915, NULL, 'G3DSA:3.90.70.80:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177916, NULL, 'G3DSA:3.70.10.10:FF:000135', NULL, NULL, 'Checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(177917, NULL, 'G3DSA:3.30.40.10:FF:001768', NULL, NULL, 'E3 ubiquitin-protein ligase RNF13', NULL, NULL, NULL, NULL, NULL, 4),
(177918, NULL, 'G3DSA:3.40.50.720:FF:000311', NULL, NULL, 'Ornithine cyclodeaminase', NULL, NULL, NULL, NULL, NULL, 4),
(177919, NULL, 'G3DSA:3.40.630.10:FF:000029', NULL, NULL, 'Glutaminyl-peptide cyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(177920, NULL, 'G3DSA:3.50.30.30:FF:000098', NULL, NULL, 'Enriched in surface-labeled proteome protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(177921, NULL, 'G3DSA:1.50.40.10:FF:000530', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177922, NULL, 'G3DSA:3.30.420.510:FF:000002', NULL, NULL, 'Pantothenate kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(177923, NULL, 'G3DSA:1.10.630.10:FF:000437', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177924, NULL, 'G3DSA:2.10.25.10:FF:001017', NULL, NULL, 'Otogelin', NULL, NULL, NULL, NULL, NULL, 4),
(177925, NULL, 'G3DSA:1.20.58.1040:FF:000006', NULL, NULL, 'Os07g0539400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(177926, NULL, 'G3DSA:1.25.40.990:FF:000017', NULL, NULL, 'SAC3/GANP/Nin1/mts3/eIF-3 p25 family-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(177927, NULL, 'G3DSA:1.20.1310.10:FF:000039', NULL, NULL, 'Cullin-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177928, NULL, 'G3DSA:3.30.160.60:FF:000263', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(177929, NULL, 'G3DSA:3.10.250.10:FF:000147', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177930, NULL, 'G3DSA:1.20.1250.20:FF:000430', NULL, NULL, 'Jen1p', NULL, NULL, NULL, NULL, NULL, 4),
(177931, NULL, 'G3DSA:1.10.287.1490:FF:000078', NULL, NULL, 'Filament-like plant protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(177932, NULL, 'G3DSA:1.10.287.10:FF:000026', NULL, NULL, 'SD01014p', NULL, NULL, NULL, NULL, NULL, 4),
(177933, NULL, 'G3DSA:1.25.10.10:FF:001834', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177934, NULL, 'G3DSA:1.25.40.10:FF:005326', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177935, NULL, 'G3DSA:3.30.160.60:FF:003517', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177936, NULL, 'G3DSA:1.10.10.750:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177937, NULL, 'G3DSA:3.10.450.120:FF:000003', NULL, NULL, 'PUA domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(177938, NULL, 'G3DSA:3.30.70.330:FF:002139', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177939, NULL, 'G3DSA:1.10.510.10:FF:000378', NULL, NULL, 'Cell division cycle 7-related protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(177940, NULL, 'G3DSA:2.40.30.330:FF:000014', NULL, NULL, 'mRNA cleavage and polyadenylation factor CLP1', NULL, NULL, NULL, NULL, NULL, 4),
(177941, NULL, 'G3DSA:3.30.420.10:FF:000549', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(177942, NULL, 'G3DSA:2.60.40.150:FF:000750', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177943, NULL, 'G3DSA:1.20.1420.30:FF:000019', NULL, NULL, 'Sodium/calcium exchanger NCL2', NULL, NULL, NULL, NULL, NULL, 4),
(177944, NULL, 'G3DSA:2.130.10.10:FF:002383', NULL, NULL, 'Putative WD-repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(177945, NULL, 'G3DSA:1.10.30.50:FF:000009', NULL, NULL, 'Conserved 13E12 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(177946, NULL, 'G3DSA:3.30.60.30:FF:000056', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(177947, NULL, 'G3DSA:3.40.50.2020:FF:000132', NULL, NULL, 'Adenine phosphoribosyltransferase 4', NULL, NULL, NULL, NULL, NULL, 4),
(177948, NULL, 'G3DSA:1.20.140.100:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177949, NULL, 'G3DSA:2.70.50.30:FF:000005', NULL, NULL, 'Probable rho GDP-dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(177950, NULL, 'G3DSA:1.50.40.10:FF:000581', NULL, NULL, 'Mitochondrial succinate-fumarate antiporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(177951, NULL, 'G3DSA:2.130.10.10:FF:000819', NULL, NULL, 'Dynein-associated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177952, NULL, 'G3DSA:3.40.50.720:FF:001772', NULL, NULL, 'NAD-dependent glycerol-3-phosphate dehydrogenase C-terminus family protein', NULL, NULL, NULL, NULL, NULL, 4),
(177953, NULL, 'G3DSA:3.40.50.1820:FF:001348', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177954, NULL, 'G3DSA:1.10.555.10:FF:000251', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177955, NULL, 'G3DSA:2.60.40.4070:FF:000007', NULL, NULL, 'Subtilisin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(177956, NULL, 'G3DSA:1.10.1510.30:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177957, NULL, 'G3DSA:2.130.10.10:FF:004069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177958, NULL, 'G3DSA:1.20.1310.10:FF:000191', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177959, NULL, 'G3DSA:3.30.565.10:FF:000402', NULL, NULL, 'Sensor histidine kinase, NtrB-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(177960, NULL, 'G3DSA:2.30.30.40:FF:000284', NULL, NULL, 'Peptidase M24', NULL, NULL, NULL, NULL, NULL, 4),
(177961, NULL, 'G3DSA:3.40.50.2300:FF:000317', NULL, NULL, 'Low molecular weight phosphotyrosine protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(177962, NULL, 'G3DSA:1.10.238.10:FF:000278', NULL, NULL, 'probable calcium-binding protein CML13', NULL, NULL, NULL, NULL, NULL, 4),
(177963, NULL, 'G3DSA:3.40.50.300:FF:003698', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(177964, NULL, 'G3DSA:1.25.40.10:FF:002100', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(177965, NULL, 'G3DSA:2.130.10.10:FF:003613', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(177966, NULL, 'G3DSA:2.170.130.20:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177967, NULL, 'G3DSA:3.30.710.10:FF:000004', NULL, NULL, 'Potassium voltage-gated channel subfamily D member 3', NULL, NULL, NULL, NULL, NULL, 4),
(177968, NULL, 'G3DSA:3.10.110.10:FF:000188', NULL, NULL, 'Uncharacterized protein CaJ7.0157', NULL, NULL, NULL, NULL, NULL, 4),
(177969, NULL, 'G3DSA:3.10.250.10:FF:000086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177970, NULL, 'G3DSA:3.30.360.10:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177971, NULL, 'G3DSA:3.30.460.10:FF:000142', NULL, NULL, 'ATPase synthesis protein 25, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(177972, NULL, 'G3DSA:3.30.160.60:FF:004866', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177973, NULL, 'G3DSA:1.10.510.10:FF:001951', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177974, NULL, 'G3DSA:2.10.25.10:FF:001517', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(177975, NULL, 'G3DSA:3.40.1110.10:FF:000321', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177976, NULL, 'G3DSA:1.20.1250.20:FF:000481', NULL, NULL, 'MonoCarboxylate Transporter family', NULL, NULL, NULL, NULL, NULL, 4),
(177977, NULL, 'G3DSA:2.40.70.10:FF:000221', NULL, NULL, 'ASpartyl Protease', NULL, NULL, NULL, NULL, NULL, 4),
(177978, NULL, 'G3DSA:1.20.1050.130:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177979, NULL, 'G3DSA:1.10.472.80:FF:000253', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177980, NULL, 'G3DSA:1.25.40.10:FF:004888', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177981, NULL, 'G3DSA:2.60.40.60:FF:000716', NULL, NULL, 'Protocadherin fat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(177982, NULL, 'G3DSA:3.10.100.10:FF:000423', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177983, NULL, 'G3DSA:3.40.50.300:FF:006553', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177984, NULL, 'G3DSA:1.10.3720.10:FF:000039', NULL, NULL, 'Inner membrane ABC transporter permease ydcV', NULL, NULL, NULL, NULL, NULL, 4),
(177985, NULL, 'G3DSA:2.40.50.100:FF:000011', NULL, NULL, 'Glycine cleavage system H protein', NULL, NULL, NULL, NULL, NULL, 4),
(177986, NULL, 'G3DSA:2.40.30.10:FF:000207', NULL, NULL, 'NADPH--cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(177987, NULL, 'G3DSA:3.10.310.20:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177988, NULL, 'G3DSA:2.10.10.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177989, NULL, 'G3DSA:3.30.200.20:FF:000446', NULL, NULL, 'Wall-associated receptor kinase-like 20', NULL, NULL, NULL, NULL, NULL, 4),
(177990, NULL, 'G3DSA:1.20.1050.10:FF:000092', NULL, NULL, 'Glutathionyl-hydroquinone reductase YqjG', NULL, NULL, NULL, NULL, NULL, 4),
(177991, NULL, 'G3DSA:3.30.890.10:FF:000011', NULL, NULL, 'Histone-lysine N-methyltransferase eggless', NULL, NULL, NULL, NULL, NULL, 4),
(177992, NULL, 'G3DSA:3.30.2080.10:FF:000011', NULL, NULL, 'ADR339Cp', NULL, NULL, NULL, NULL, NULL, 4),
(177993, NULL, 'G3DSA:1.10.10.10:FF:001654', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(177994, NULL, 'G3DSA:2.40.50.140:FF:001164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(177995, NULL, 'G3DSA:2.10.22.10:FF:000004', NULL, NULL, 'cysteine-rich motor neuron 1 protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(177996, NULL, 'G3DSA:3.30.1370.210:FF:000027', NULL, NULL, 'Protein CBG07137', NULL, NULL, NULL, NULL, NULL, 4),
(177997, NULL, 'G3DSA:2.130.10.10:FF:002332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(177998, NULL, 'G3DSA:3.30.60.30:FF:000005', NULL, NULL, 'Follistatin a', NULL, NULL, NULL, NULL, NULL, 4),
(177999, NULL, 'G3DSA:3.40.1170.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178000, NULL, 'G3DSA:3.40.50.300:FF:000825', NULL, NULL, 'ABC bile acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(178001, NULL, 'G3DSA:3.20.20.140:FF:000236', NULL, NULL, 'Putative AMP deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(178002, NULL, 'G3DSA:3.30.930.10:FF:000066', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(178003, NULL, 'G3DSA:4.10.60.10:FF:000054', NULL, NULL, 'AGAP008075-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(178004, NULL, 'G3DSA:3.90.260.10:FF:000023', NULL, NULL, 'AGAP003345-PA', NULL, NULL, NULL, NULL, NULL, 4),
(178005, NULL, 'G3DSA:3.20.20.60:FF:000147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178006, NULL, 'G3DSA:2.30.30.620:FF:000002', NULL, NULL, 'Major vault protein', NULL, NULL, NULL, NULL, NULL, 4),
(178007, NULL, 'G3DSA:3.50.50.60:FF:001305', NULL, NULL, 'Glr2871 protein', NULL, NULL, NULL, NULL, NULL, 4),
(178008, NULL, 'G3DSA:3.30.160.60:FF:006491', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178009, NULL, 'G3DSA:1.10.510.10:FF:003637', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(178010, NULL, 'G3DSA:1.25.40.10:FF:001611', NULL, NULL, 'Clustered mitochondria (cluA/CLU1) homolog b', NULL, NULL, NULL, NULL, NULL, 4),
(178011, NULL, 'G3DSA:2.70.98.20:FF:000011', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(178012, NULL, 'G3DSA:2.60.260.20:FF:000082', NULL, NULL, 'DnaJ family protein', NULL, NULL, NULL, NULL, NULL, 4),
(178013, NULL, 'G3DSA:3.60.21.70:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178014, NULL, 'G3DSA:3.40.50.10330:FF:000090', NULL, NULL, 'ATP-NAD kinase-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(178015, NULL, 'G3DSA:1.25.40.10:FF:002067', NULL, NULL, 'SET (Trithorax/polycomb) domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(178016, NULL, 'G3DSA:1.20.5.110:FF:000308', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(178017, NULL, 'G3DSA:1.20.1070.10:FF:001104', NULL, NULL, 'G protein-coupled receptor Tc 45', NULL, NULL, NULL, NULL, NULL, 4),
(178018, NULL, 'G3DSA:3.40.190.10:FF:000512', NULL, NULL, 'Bacterial extracellular solute-binding s, 5 Middle family protein', NULL, NULL, NULL, NULL, NULL, 4),
(178019, NULL, 'G3DSA:3.40.850.10:FF:000512', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(178020, NULL, 'G3DSA:3.30.460.10:FF:000193', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(178021, NULL, 'G3DSA:2.10.25.10:FF:000949', NULL, NULL, 'FlaMIngo (Cadherin plus 7TM domain) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(178022, NULL, 'G3DSA:1.20.5.930:FF:000003', NULL, NULL, 'Integrin subunit alpha 7', NULL, NULL, NULL, NULL, NULL, 4),
(178023, NULL, 'G3DSA:3.40.30.10:FF:000492', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(178024, NULL, 'G3DSA:2.130.10.10:FF:003793', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178025, NULL, 'G3DSA:3.90.190.10:FF:000079', NULL, NULL, 'Protein-tyrosine-phosphatase IBR5', NULL, NULL, NULL, NULL, NULL, 4),
(178026, NULL, 'G3DSA:3.30.930.10:FF:000358', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(178027, NULL, 'G3DSA:3.40.50.2000:FF:000025', NULL, NULL, 'Starch synthase, chloroplastic/amyloplastic', NULL, NULL, NULL, NULL, NULL, 4),
(178028, NULL, 'G3DSA:3.30.70.330:FF:002639', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178029, NULL, 'G3DSA:3.30.10.20:FF:000016', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(178030, NULL, 'G3DSA:3.30.360.10:FF:000078', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178031, NULL, 'G3DSA:1.10.10.10:FF:000373', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(178032, NULL, 'G3DSA:1.10.1610.10:FF:000002', NULL, NULL, 'Nicotinate-nucleotide--dimethylbenzimidazole phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(178033, NULL, 'G3DSA:3.40.50.10860:FF:000006', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(178034, NULL, 'G3DSA:4.10.1000.10:FF:000072', NULL, NULL, 'Zinc finger protein family member', NULL, NULL, NULL, NULL, NULL, 4),
(178035, NULL, 'G3DSA:3.30.930.10:FF:000015', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(178036, NULL, 'G3DSA:2.70.170.10:FF:000160', NULL, NULL, 'Achbp', NULL, NULL, NULL, NULL, NULL, 4),
(178037, NULL, 'G3DSA:1.10.1740.10:FF:000006', NULL, NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(178038, NULL, 'G3DSA:3.30.70.870:FF:000042', NULL, NULL, 'AaceriAEL124Wp', NULL, NULL, NULL, NULL, NULL, 4),
(178039, NULL, 'G3DSA:3.30.160.60:FF:001168', NULL, NULL, 'Zinc finger and SCAN domain containing 10', NULL, NULL, NULL, NULL, NULL, 4),
(178040, NULL, 'G3DSA:1.10.287.1350:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178041, NULL, 'G3DSA:1.10.8.60:FF:000268', NULL, NULL, 'Peroxisome biosynthesis protein (PAS1/Peroxin-1), putative', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(178042, NULL, 'G3DSA:1.10.1780.10:FF:000020', NULL, NULL, 'ClpC-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(178043, NULL, 'G3DSA:3.40.50.150:FF:001808', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178044, NULL, 'G3DSA:1.20.58.70:FF:000090', NULL, NULL, 'STX1A protein', NULL, NULL, NULL, NULL, NULL, 4),
(178045, NULL, 'G3DSA:3.30.420.40:FF:000143', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(178046, NULL, 'G3DSA:4.10.60.10:FF:000003', NULL, NULL, 'serine/arginine-rich splicing factor RS2Z32-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(178047, NULL, 'G3DSA:3.30.160.60:FF:002449', NULL, NULL, 'Zinc finger protein 1144', NULL, NULL, NULL, NULL, NULL, 4),
(178048, NULL, 'G3DSA:1.10.10.790:FF:000023', NULL, NULL, 'Nuclear acid binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178049, NULL, 'G3DSA:3.80.10.10:FF:002736', NULL, NULL, 'At1g25320/F4F7_17', NULL, NULL, NULL, NULL, NULL, 4),
(178050, NULL, 'G3DSA:1.10.510.10:FF:003396', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178051, NULL, 'G3DSA:2.130.10.30:FF:000005', NULL, NULL, 'E3 ubiquitin-protein ligase MYCBP2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(178052, NULL, 'G3DSA:1.10.8.710:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178053, NULL, 'G3DSA:1.25.40.80:FF:000002', NULL, NULL, 'cryptochrome-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(178054, NULL, 'G3DSA:1.20.1270.60:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178055, NULL, 'G3DSA:2.110.10.10:FF:000017', NULL, NULL, 'Matrix metallopeptidase 19', NULL, NULL, NULL, NULL, NULL, 4),
(178056, NULL, 'G3DSA:3.20.20.80:FF:000254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178057, NULL, 'G3DSA:1.10.260.40:FF:000092', NULL, NULL, 'HipB protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178058, NULL, 'G3DSA:3.40.50.1240:FF:000174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178059, NULL, 'G3DSA:1.10.30.10:FF:000177', NULL, NULL, 'AFL219Wp', NULL, NULL, NULL, NULL, NULL, 4),
(178060, NULL, 'G3DSA:1.20.120.330:FF:000002', NULL, NULL, 'ARF GTPase-activating protein GIT2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(178061, NULL, 'G3DSA:1.10.8.270:FF:000021', NULL, NULL, 'Ypt/Rab-GAP domain of gyp1p superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(178062, NULL, 'G3DSA:2.60.40.10:FF:000263', NULL, NULL, 'Pro-neuregulin-1, membrane-bound isoform', NULL, NULL, NULL, NULL, NULL, 4),
(178063, NULL, 'G3DSA:3.40.50.720:FF:002340', NULL, NULL, 'Homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(178064, NULL, 'G3DSA:3.30.160.60:FF:003017', NULL, NULL, 'Si:cabz01054396.2', NULL, NULL, NULL, NULL, NULL, 4),
(178065, NULL, 'G3DSA:3.80.10.10:FF:003304', NULL, NULL, 'Toll-like receptor13', NULL, NULL, NULL, NULL, NULL, 4),
(178066, NULL, 'G3DSA:2.40.70.10:FF:000272', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178067, NULL, 'G3DSA:1.20.1070.10:FF:000879', NULL, NULL, 'Apelin receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(178068, NULL, 'G3DSA:1.50.40.10:FF:000081', NULL, NULL, 'NAD+ transporter', NULL, NULL, NULL, NULL, NULL, 4),
(178069, NULL, 'G3DSA:2.30.42.10:FF:000128', NULL, NULL, 'T cell lymphoma invasion and metastasis 2', NULL, NULL, NULL, NULL, NULL, 4),
(178070, NULL, 'G3DSA:3.40.30.10:FF:000441', NULL, NULL, 'YFR016C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(178071, NULL, 'G3DSA:3.40.50.720:FF:001272', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(178072, NULL, 'G3DSA:3.30.160.60:FF:005030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178073, NULL, 'G3DSA:3.80.10.10:FF:003400', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178074, NULL, 'G3DSA:1.10.510.10:FF:003688', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178075, NULL, 'G3DSA:1.20.120.350:FF:000008', NULL, NULL, 'Voltage-dependent T-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(178076, NULL, 'G3DSA:2.130.10.10:FF:005642', NULL, NULL, 'Semaphorin-5A, putative', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(178077, NULL, 'G3DSA:2.60.40.420:FF:000235', NULL, NULL, 'Bll2293 protein', NULL, NULL, NULL, NULL, NULL, 4),
(178078, NULL, 'G3DSA:3.90.470.20:FF:000065', NULL, NULL, 'Putative 4''-phosphopantetheinyl transferase HI_0152', NULL, NULL, NULL, NULL, NULL, 4),
(178079, NULL, 'G3DSA:3.40.50.300:FF:000921', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(178080, NULL, 'G3DSA:3.40.50.1820:FF:000864', NULL, NULL, 'Esterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178081, NULL, 'G3DSA:1.20.1440.100:FF:000013', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(178082, NULL, 'G3DSA:3.20.20.140:FF:000287', NULL, NULL, 'Histidinol-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(178083, NULL, 'G3DSA:3.30.1360.120:FF:000055', NULL, NULL, 'GTPase mss1/trme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178084, NULL, 'G3DSA:1.25.40.10:FF:001662', NULL, NULL, 'WGS project CABT00000000 data, contig 2.13', NULL, NULL, NULL, NULL, NULL, 4),
(178085, NULL, 'G3DSA:2.130.10.10:FF:002624', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit wdr4', NULL, NULL, NULL, NULL, NULL, 4),
(178086, NULL, 'G3DSA:1.20.58.90:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178087, NULL, 'G3DSA:1.25.40.70:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178088, NULL, 'G3DSA:2.60.40.10:FF:003017', NULL, NULL, 'CD47 glycoprotein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(178089, NULL, 'G3DSA:2.60.40.10:FF:002112', NULL, NULL, 'Twitchin', NULL, NULL, NULL, NULL, NULL, 4),
(178090, NULL, 'G3DSA:2.60.40.10:FF:004445', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178091, NULL, 'G3DSA:3.40.50.300:FF:004136', NULL, NULL, 'PrgJ', NULL, NULL, NULL, NULL, NULL, 4),
(178092, NULL, 'G3DSA:3.80.10.10:FF:003012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178093, NULL, 'G3DSA:1.10.630.10:FF:000729', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178094, NULL, 'G3DSA:6.10.250.3260:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178095, NULL, 'G3DSA:3.40.50.2300:FF:001374', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178096, NULL, 'G3DSA:1.20.1110.10:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178097, NULL, 'G3DSA:1.25.40.10:FF:003409', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(178098, NULL, 'G3DSA:3.30.200.20:FF:001323', NULL, NULL, 'CAMKK/ELM protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(178099, NULL, 'G3DSA:1.10.1420.10:FF:000139', NULL, NULL, 'AGAP012245-PA', NULL, NULL, NULL, NULL, NULL, 4),
(178100, NULL, 'G3DSA:3.40.630.30:FF:000636', NULL, NULL, 'Acetyltransferase, GNAT family protein', NULL, NULL, NULL, NULL, NULL, 4),
(178101, NULL, 'G3DSA:3.40.50.1000:FF:000394', NULL, NULL, 'Haloacid dehalogenase family hydrolase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(178102, NULL, 'G3DSA:3.30.70.330:FF:000402', NULL, NULL, 'Lupus La protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(178103, NULL, 'G3DSA:2.60.40.10:FF:003961', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178104, NULL, 'G3DSA:2.130.10.10:FF:000027', NULL, NULL, 'Splicing factor 3B subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(178105, NULL, 'G3DSA:3.40.50.300:FF:008110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178106, NULL, 'G3DSA:3.10.20.90:FF:000605', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178107, NULL, 'G3DSA:3.30.160.60:FF:002528', NULL, NULL, 'Transcription factor Sp3', NULL, NULL, NULL, NULL, NULL, 4),
(178108, NULL, 'G3DSA:1.10.225.10:FF:000035', NULL, NULL, 'Ecdysone dependent glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(178109, NULL, 'G3DSA:2.40.70.10:FF:000193', NULL, NULL, 'Pro-Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(178110, NULL, 'G3DSA:2.40.10.10:FF:000116', NULL, NULL, 'Serine protease P16', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(178111, NULL, 'G3DSA:1.20.120.1910:FF:000005', NULL, NULL, 'Cysteine-tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178112, NULL, 'G3DSA:3.30.160.60:FF:001140', NULL, NULL, 'Zinc finger protein 219', NULL, NULL, NULL, NULL, NULL, 4),
(178113, NULL, 'G3DSA:3.50.20.20:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178114, NULL, 'G3DSA:3.30.2090.10:FF:000017', NULL, NULL, 'Transporter, AcrB/D/F family', NULL, NULL, NULL, NULL, NULL, 4),
(178115, NULL, 'G3DSA:1.10.287.690:FF:000016', NULL, NULL, 'DNA-directed DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(178116, NULL, 'G3DSA:2.60.120.200:FF:000779', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(178117, NULL, 'G3DSA:3.30.1380.20:FF:000031', NULL, NULL, 'Trafficking protein particle complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(178118, NULL, 'G3DSA:3.30.830.10:FF:000002', NULL, NULL, 'Mitochondrial-processing peptidase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(178119, NULL, 'G3DSA:2.60.40.60:FF:000637', NULL, NULL, 'AGAP002828-PA', NULL, NULL, NULL, NULL, NULL, 4),
(178120, NULL, 'G3DSA:3.30.160.60:FF:003809', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178121, NULL, 'G3DSA:2.60.40.10:FF:003068', NULL, NULL, 'filamin-A isoform X8', NULL, NULL, NULL, NULL, NULL, 4),
(178122, NULL, 'G3DSA:1.25.10.10:FF:002239', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(178123, NULL, 'G3DSA:3.30.980.10:FF:000018', NULL, NULL, 'Phosphoribulokinase/uridine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(178124, NULL, 'G3DSA:2.30.29.30:FF:000710', NULL, NULL, 'Serine/threonine-protein kinase pakC', NULL, NULL, NULL, NULL, NULL, 4),
(178125, NULL, 'G3DSA:3.90.470.20:FF:000014', NULL, NULL, 'AflYg/ npgA protein', NULL, NULL, NULL, NULL, NULL, 4),
(178126, NULL, 'G3DSA:3.40.50.620:FF:000511', NULL, NULL, 'Isoleucine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(178127, NULL, 'G3DSA:1.10.20.10:FF:000019', NULL, NULL, 'Negative cofactor 2 beta', NULL, NULL, NULL, NULL, NULL, 4),
(178128, NULL, 'G3DSA:3.30.450.60:FF:000010', NULL, NULL, 'AP complex subunit sigma', NULL, NULL, NULL, NULL, NULL, 4),
(178129, NULL, 'G3DSA:3.30.70.330:FF:002027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178130, NULL, 'G3DSA:3.30.1360.150:FF:000002', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(178131, NULL, 'G3DSA:1.20.1250.20:FF:001762', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178132, NULL, 'G3DSA:3.20.20.70:FF:000768', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178133, NULL, 'G3DSA:2.130.10.10:FF:000466', NULL, NULL, 'Chromatin assembly factor 1 subunit FAS2', NULL, NULL, NULL, NULL, NULL, 4),
(178134, NULL, 'G3DSA:3.10.20.90:FF:000656', NULL, NULL, 'midnolin homolog isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(178135, NULL, 'G3DSA:2.10.110.30:FF:000001', NULL, NULL, 'E3 ubiquitin-protein ligase UBR2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(178136, NULL, 'G3DSA:1.10.510.10:FF:002295', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178137, NULL, 'G3DSA:2.60.40.10:FF:000555', NULL, NULL, 'Dystroglycan 1', NULL, NULL, NULL, NULL, NULL, 4),
(178138, NULL, 'G3DSA:2.40.50.140:FF:001113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178139, NULL, 'G3DSA:3.40.50.300:FF:007621', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178140, NULL, 'G3DSA:3.10.450.240:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178141, NULL, 'G3DSA:3.90.550.10:FF:000630', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(178142, NULL, 'G3DSA:3.40.50.200:FF:000149', NULL, NULL, 'Surface-associated serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(178143, NULL, 'G3DSA:1.10.10.10:FF:001603', NULL, NULL, 'Fork head domain 3F', NULL, NULL, NULL, NULL, NULL, 4),
(178144, NULL, 'G3DSA:2.10.220.10:FF:000065', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(178145, NULL, 'G3DSA:1.10.620.20:FF:000029', NULL, NULL, 'Os02g0504800 protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(178146, NULL, 'G3DSA:3.30.160.60:FF:005934', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178147, NULL, 'G3DSA:1.20.1070.10:FF:000003', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(178148, NULL, 'G3DSA:3.40.50.10440:FF:000004', NULL, NULL, 'Dihydroxyacetone kinase', NULL, NULL, NULL, NULL, NULL, 4),
(178149, NULL, 'G3DSA:3.40.50.300:FF:000180', NULL, NULL, 'Member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(178150, NULL, 'G3DSA:1.10.287.70:FF:000460', NULL, NULL, 'Ionotropic receptor 7a', NULL, NULL, NULL, NULL, NULL, 4),
(178151, NULL, 'G3DSA:4.10.280.10:FF:000168', NULL, NULL, 'transcription factor protein', NULL, NULL, NULL, NULL, NULL, 4),
(178152, NULL, 'G3DSA:1.10.560.10:FF:000089', NULL, NULL, 'T-complex protein 1, zeta subunit isoform 3-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(178153, NULL, 'G3DSA:2.40.30.270:FF:000035', NULL, NULL, 'YALI0A04279p', NULL, NULL, NULL, NULL, NULL, 4),
(178154, NULL, 'G3DSA:1.10.1900.40:FF:000005', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(178155, NULL, 'G3DSA:3.40.50.620:FF:000899', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(178156, NULL, 'G3DSA:2.10.110.10:FF:000203', NULL, NULL, 'LIM domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(178157, NULL, 'G3DSA:3.30.160.60:FF:000651', NULL, NULL, 'Putative zinc finger protein 653', NULL, NULL, NULL, NULL, NULL, 4),
(178158, NULL, 'G3DSA:1.10.40.30:FF:000009', NULL, NULL, 'Argininosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(178159, NULL, 'G3DSA:3.40.47.10:FF:000064', NULL, NULL, 'Acetyl-CoA acetyltransferase FadA5', NULL, NULL, NULL, NULL, NULL, 4),
(178160, NULL, 'G3DSA:2.30.130.40:FF:000023', NULL, NULL, 'Lon protease', NULL, NULL, NULL, NULL, NULL, 4),
(178161, NULL, 'G3DSA:3.30.70.1230:FF:000151', NULL, NULL, 'Adenylate cyclase 10', NULL, NULL, NULL, NULL, NULL, 4),
(178162, NULL, 'G3DSA:2.60.120.20:FF:000004', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(178163, NULL, 'G3DSA:1.10.1060.10:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178164, NULL, 'G3DSA:1.10.1020.10:FF:000002', NULL, NULL, 'D12 Class N6 Adenine-Specific DNA Methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(178165, NULL, 'G3DSA:3.40.50.300:FF:004575', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(178166, NULL, 'G3DSA:3.40.50.300:FF:006261', NULL, NULL, 'SWI2/SNF2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(178167, NULL, 'G3DSA:3.40.50.300:FF:002950', NULL, NULL, 'ATP-dependent RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178168, NULL, 'G3DSA:3.30.60.190:FF:000021', NULL, NULL, 'Zinc finger HIT domain-containing protein 3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(178169, NULL, 'G3DSA:3.90.1300.10:FF:000009', NULL, NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(178170, NULL, 'G3DSA:1.10.1100.10:FF:000003', NULL, NULL, 'AGAP003882-PA', NULL, NULL, NULL, NULL, NULL, 4),
(178171, NULL, 'G3DSA:3.30.160.60:FF:004574', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178172, NULL, 'G3DSA:3.90.70.10:FF:000385', NULL, NULL, 'Apoptosis inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(178173, NULL, 'G3DSA:1.20.1070.10:FF:000828', NULL, NULL, 'Adrenoceptor alpha 1B', NULL, NULL, NULL, NULL, NULL, 4),
(178174, NULL, 'G3DSA:1.20.1560.10:FF:000815', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178175, NULL, 'G3DSA:3.30.160.60:FF:003961', NULL, NULL, 'Protein CBG19597', NULL, NULL, NULL, NULL, NULL, 4),
(178176, NULL, 'G3DSA:3.10.600.10:FF:000012', NULL, NULL, 'Pyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(178177, NULL, 'G3DSA:3.40.50.10260:FF:000006', NULL, NULL, 'NAD(P)H-hydrate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(178178, NULL, 'G3DSA:3.30.530.20:FF:000139', NULL, NULL, 'Uncharacterized protein C577.11', NULL, NULL, NULL, NULL, NULL, 4),
(178179, NULL, 'G3DSA:3.40.1090.10:FF:000116', NULL, NULL, 'Patatin', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(178180, NULL, 'G3DSA:3.30.830.10:FF:000182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178181, NULL, 'G3DSA:3.90.25.10:FF:000078', NULL, NULL, 'Delta-1-pyrroline-5-carboxylate synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(178182, NULL, 'G3DSA:3.40.190.10:FF:000433', NULL, NULL, 'Probable periplasmic oligopeptide-binding lipoprotein oppA', NULL, NULL, NULL, NULL, NULL, 4),
(178183, NULL, 'G3DSA:3.10.440.10:FF:000010', NULL, NULL, '50S ribosomal protein L31e', NULL, NULL, NULL, NULL, NULL, 4),
(178184, NULL, 'G3DSA:3.30.70.330:FF:001690', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178185, NULL, 'G3DSA:3.40.1160.10:FF:000032', NULL, NULL, 'Delta-1-pyrroline-5-carboxylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(178186, NULL, 'G3DSA:3.40.710.10:FF:000070', NULL, NULL, 'GLS isoform 12', NULL, NULL, NULL, NULL, NULL, 4),
(178187, NULL, 'G3DSA:2.10.70.10:FF:000172', NULL, NULL, 'Complement factor H related 5', NULL, NULL, NULL, NULL, NULL, 4),
(178188, NULL, 'G3DSA:2.30.29.30:FF:001278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178189, NULL, 'G3DSA:3.30.1780.10:FF:000019', NULL, NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(178190, NULL, 'G3DSA:2.10.70.10:FF:000076', NULL, NULL, 'Furrowed, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(178191, NULL, 'G3DSA:1.10.287.950:FF:000055', NULL, NULL, 'Putative methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(178192, NULL, 'G3DSA:3.40.50.150:FF:001247', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178193, NULL, 'G3DSA:3.30.420.10:FF:000196', NULL, NULL, 'Poly(A)-specific ribonuclease PARN', NULL, NULL, NULL, NULL, NULL, 4),
(178194, NULL, 'G3DSA:1.10.890.30:FF:000001', NULL, NULL, 'YmgD family protein', NULL, NULL, NULL, NULL, NULL, 4),
(178195, NULL, 'G3DSA:2.70.130.10:FF:000067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178196, NULL, 'G3DSA:1.20.58.240:FF:000004', NULL, NULL, 'O-GlcNAc selective N-Acetyl-beta-D-glucosaminidase (O-GlcNAcase)', NULL, NULL, NULL, NULL, NULL, 4),
(178197, NULL, 'G3DSA:3.40.50.150:FF:001404', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178198, NULL, 'G3DSA:1.10.3730.20:FF:000037', NULL, NULL, 'Nucleotide Sugar TransPorter family', NULL, NULL, NULL, NULL, NULL, 4),
(178199, NULL, 'G3DSA:2.60.120.40:FF:000050', NULL, NULL, 'Tumor necrosis factor ligand superfamily member 18', NULL, NULL, NULL, NULL, NULL, 4),
(178200, NULL, 'G3DSA:1.25.40.10:FF:001723', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(178201, NULL, 'G3DSA:3.40.50.2020:FF:000099', NULL, NULL, 'Adenine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(178202, NULL, 'G3DSA:2.60.40.10:FF:001915', NULL, NULL, 'Glucans biosynthesis protein G', NULL, NULL, NULL, NULL, NULL, 4),
(178203, NULL, 'G3DSA:2.60.40.60:FF:000188', NULL, NULL, 'Cadherin 17', NULL, NULL, NULL, NULL, NULL, 4),
(178204, NULL, 'G3DSA:3.30.60.20:FF:000120', NULL, NULL, 'Diacylglycerol kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(178205, NULL, 'G3DSA:2.130.10.10:FF:002444', NULL, NULL, 'Transducin beta-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(178206, NULL, 'G3DSA:2.60.40.10:FF:003989', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178207, NULL, 'G3DSA:3.40.605.10:FF:000016', NULL, NULL, '4-trimethylaminobutyraldehyde dehydrogenase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(178208, NULL, 'G3DSA:3.90.79.10:FF:000225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178209, NULL, 'G3DSA:3.40.50.2000:FF:000205', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(178210, NULL, 'G3DSA:3.40.50.300:FF:000713', NULL, NULL, 'Ras-related small GTP-binding family protein', NULL, NULL, NULL, NULL, NULL, 4),
(178211, NULL, 'G3DSA:4.10.800.10:FF:000006', NULL, NULL, 'testican-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(178212, NULL, 'G3DSA:3.40.50.410:FF:000274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(178213, NULL, 'G3DSA:3.30.1390.20:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178214, NULL, 'G3DSA:2.40.30.10:FF:000275', NULL, NULL, 'Adenylyl-sulfate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(178215, NULL, 'G3DSA:3.30.413.10:FF:000016', NULL, NULL, 'Sulfite reductase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(178216, NULL, 'G3DSA:3.90.190.10:FF:000607', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(178217, NULL, 'G3DSA:2.130.10.10:FF:005581', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(178218, NULL, 'G3DSA:3.80.10.10:FF:001955', NULL, NULL, 'Pollen receptor-like kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(178219, NULL, 'G3DSA:1.25.40.10:FF:002179', NULL, NULL, 'Pentatricopeptide repeat-containing protein MRL1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(178220, NULL, 'G3DSA:1.10.10.2740:FF:000002', NULL, NULL, 'Transcription elongation factor Spt6', NULL, NULL, NULL, NULL, NULL, 4),
(178221, NULL, 'G3DSA:1.25.40.10:FF:004860', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(178222, NULL, 'G3DSA:1.20.58.60:FF:000502', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178223, NULL, 'G3DSA:1.20.1270.60:FF:000246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178224, NULL, 'G3DSA:3.30.160.60:FF:005142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178225, NULL, 'G3DSA:2.60.40.790:FF:000071', NULL, NULL, '17.9 kDa heat shock protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(178226, NULL, 'G3DSA:3.90.105.10:FF:000006', NULL, NULL, 'Arginine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(178227, NULL, 'G3DSA:3.30.760.10:FF:000007', NULL, NULL, 'Eukaryotic translation initiation factor 4E family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(178228, NULL, 'G3DSA:1.10.730.10:FF:000029', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(178229, NULL, 'G3DSA:2.40.10.10:FF:000324', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178230, NULL, 'G3DSA:3.30.565.10:FF:000161', NULL, NULL, 'Heat shock protein 90', NULL, NULL, NULL, NULL, NULL, 4),
(178231, NULL, 'G3DSA:3.15.20.10:FF:000004', NULL, NULL, 'BPI fold containing family B member 2', NULL, NULL, NULL, NULL, NULL, 4),
(178232, NULL, 'G3DSA:3.40.50.300:FF:004928', NULL, NULL, 'Eng_C102 protein', NULL, NULL, NULL, NULL, NULL, 4),
(178233, NULL, 'G3DSA:1.20.1070.10:FF:000615', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(178234, NULL, 'G3DSA:1.20.1250.20:FF:000773', NULL, NULL, 'Quinidine resistance', NULL, NULL, NULL, NULL, NULL, 4),
(178235, NULL, 'G3DSA:3.30.40.10:FF:001740', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178236, NULL, 'G3DSA:2.10.90.10:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178237, NULL, 'G3DSA:2.130.10.10:FF:000258', NULL, NULL, 'WD repeat-containing protein 92', NULL, NULL, NULL, NULL, NULL, 4),
(178238, NULL, 'G3DSA:1.10.1410.10:FF:000021', NULL, NULL, 'poly(A) polymerase alpha isoform X7', NULL, NULL, NULL, NULL, NULL, 4),
(178239, NULL, 'G3DSA:3.30.1360.70:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178240, NULL, 'G3DSA:2.60.40.150:FF:000339', NULL, NULL, 'U5 small nuclear ribonucleoprotein helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178241, NULL, 'G3DSA:1.25.40.10:FF:003909', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178242, NULL, 'G3DSA:3.30.70.660:FF:000029', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(178243, NULL, 'G3DSA:1.10.510.10:FF:003424', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178244, NULL, 'G3DSA:2.170.260.10:FF:000007', NULL, NULL, 'Dicer-like 105', NULL, NULL, NULL, NULL, NULL, 4),
(178245, NULL, 'G3DSA:2.60.40.10:FF:000763', NULL, NULL, 'Insulin-like growth factor binding protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(178246, NULL, 'G3DSA:1.20.5.780:FF:000020', NULL, NULL, 'FXYD domain-containing ion transport regulator', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(178247, NULL, 'G3DSA:2.60.40.10:FF:002904', NULL, NULL, 'Fc receptor like 3', NULL, NULL, NULL, NULL, NULL, 4),
(178248, NULL, 'G3DSA:3.40.50.2000:FF:000093', NULL, NULL, 'UDP-GlcNAc:PI a1-6 GlcNAc-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(178249, NULL, 'G3DSA:2.10.110.10:FF:000175', NULL, NULL, 'GD25476', NULL, NULL, NULL, NULL, NULL, 4),
(178250, NULL, 'G3DSA:3.50.30.30:FF:000126', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(178251, NULL, 'G3DSA:3.40.50.1820:FF:000600', NULL, NULL, 'Abhydrolase domain-containing protein lid-1', NULL, NULL, NULL, NULL, NULL, 4),
(178252, NULL, 'G3DSA:3.40.50.300:FF:006109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178253, NULL, 'G3DSA:1.10.533.10:FF:000234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178254, NULL, 'G3DSA:3.30.200.20:FF:000334', NULL, NULL, 'Fibroblast growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(178255, NULL, 'G3DSA:2.60.40.150:FF:000671', NULL, NULL, 'Synaptotagmin V, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178256, NULL, 'G3DSA:2.60.40.10:FF:005226', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178257, NULL, 'G3DSA:3.10.105.10:FF:000007', NULL, NULL, 'Nickel ABC transporter, periplasmic nickel-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(178258, NULL, 'G3DSA:2.20.25.570:FF:000001', NULL, NULL, 'LmbJ', NULL, NULL, NULL, NULL, NULL, 4),
(178259, NULL, 'G3DSA:3.40.525.10:FF:000015', NULL, NULL, 'retinaldehyde-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(178260, NULL, 'G3DSA:1.25.40.20:FF:000479', NULL, NULL, 'Osm-9 and Capsaicin receptor-Related', NULL, NULL, NULL, NULL, NULL, 4),
(178261, NULL, 'G3DSA:1.10.2020.20:FF:000005', NULL, NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(178262, NULL, 'G3DSA:1.10.8.10:FF:000282', NULL, NULL, 'UBA/TS-N domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(178263, NULL, 'G3DSA:3.30.70.330:FF:001279', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(178264, NULL, 'G3DSA:3.80.10.10:FF:001326', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178265, NULL, 'G3DSA:3.20.20.70:FF:000689', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178266, NULL, 'G3DSA:2.130.10.10:FF:000415', NULL, NULL, 'WD repeat domain 63', NULL, NULL, NULL, NULL, NULL, 4),
(178267, NULL, 'G3DSA:2.40.50.1000:FF:000001', NULL, NULL, '40S ribosomal protein S11', NULL, NULL, NULL, NULL, NULL, 4),
(178268, NULL, 'G3DSA:3.20.20.70:FF:000425', NULL, NULL, 'Quinate repressor', NULL, NULL, NULL, NULL, NULL, 4),
(178269, NULL, 'G3DSA:2.60.40.1170:FF:000098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178270, NULL, 'G3DSA:3.30.70.3560:FF:000001', NULL, NULL, 'Late genes activator p4', NULL, NULL, NULL, NULL, NULL, 4),
(178271, NULL, 'G3DSA:3.40.50.10190:FF:000345', NULL, NULL, 'ADL145Cp', NULL, NULL, NULL, NULL, NULL, 4),
(178272, NULL, 'G3DSA:3.30.160.60:FF:005726', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178273, NULL, 'G3DSA:3.30.160.60:FF:003585', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178274, NULL, 'G3DSA:1.25.40.10:FF:003871', NULL, NULL, 'Translocase outer membrane 20-1', NULL, NULL, NULL, NULL, NULL, 4),
(178275, NULL, 'G3DSA:3.30.420.10:FF:000600', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178276, NULL, 'G3DSA:2.30.39.10:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178277, NULL, 'G3DSA:3.40.50.300:FF:002158', NULL, NULL, 'P-type DNA transfer ATPase VirB11', NULL, NULL, NULL, NULL, NULL, 4),
(178278, NULL, 'G3DSA:1.20.58.390:FF:000173', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(178279, NULL, 'G3DSA:3.30.1370.10:FF:000084', NULL, NULL, 'KH domain-containing, RNA-binding, signal transduction-associated protein 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(178280, NULL, 'G3DSA:3.10.20.90:FF:000948', NULL, NULL, 'CHD gene family protein containing chromodomain, helicase domain, and DNA-binding domain', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(178281, NULL, 'G3DSA:3.30.70.980:FF:000075', NULL, NULL, 'uncharacterized protein LOC100179843', NULL, NULL, NULL, NULL, NULL, 4),
(178282, NULL, 'G3DSA:3.90.290.10:FF:000031', NULL, NULL, 'Fibrillin-1', NULL, NULL, NULL, NULL, NULL, 4),
(178283, NULL, 'G3DSA:3.40.50.10860:FF:000074', NULL, NULL, 'Methylenetetrahydrofolate dehydrogenase/ methylenetetrahydrofolate cyclohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(178284, NULL, 'G3DSA:2.60.40.1090:FF:000012', NULL, NULL, 'Minor fimbrial subunit StfG', NULL, NULL, NULL, NULL, NULL, 4),
(178285, NULL, 'G3DSA:3.60.40.10:FF:000328', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(178286, NULL, 'G3DSA:1.10.10.60:FF:000404', NULL, NULL, 'Transcription factor MYB97', NULL, NULL, NULL, NULL, NULL, 4),
(178287, NULL, 'G3DSA:3.40.50.720:FF:000423', NULL, NULL, 'Saccharopine dehydrogenase [NAD(+), L-lysine-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(178288, NULL, 'G3DSA:3.30.710.10:FF:000347', NULL, NULL, 'Uncharacterized protein BTB2', NULL, NULL, NULL, NULL, NULL, 4),
(178289, NULL, 'G3DSA:3.20.20.100:FF:000062', NULL, NULL, 'Oxidoreductase, aldo/keto reductase family', NULL, NULL, NULL, NULL, NULL, 4),
(178290, NULL, 'G3DSA:3.10.100.10:FF:000311', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178291, NULL, 'G3DSA:1.10.150.510:FF:000014', NULL, NULL, 'Si:ch73-193i22.1', NULL, NULL, NULL, NULL, NULL, 4),
(178292, NULL, 'G3DSA:3.90.245.10:FF:000016', NULL, NULL, 'Inosine-uridine preferring nucleoside hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178293, NULL, 'G3DSA:2.120.10.80:FF:000088', NULL, NULL, 'Protein GLUTELIN PRECURSOR ACCUMULATION 3', NULL, NULL, NULL, NULL, NULL, 4),
(178294, NULL, 'G3DSA:3.30.420.40:FF:000064', NULL, NULL, 'Rhamnulokinase', NULL, NULL, NULL, NULL, NULL, 4),
(178295, NULL, 'G3DSA:3.30.420.40:FF:000704', NULL, NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(178296, NULL, 'G3DSA:2.60.110.10:FF:000006', NULL, NULL, 'Osmotin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(178297, NULL, 'G3DSA:1.10.1200.270:FF:000008', NULL, NULL, 'OSJNBa0087O24.14 protein', NULL, NULL, NULL, NULL, NULL, 4),
(178298, NULL, 'G3DSA:2.10.110.10:FF:000023', NULL, NULL, 'LIM homeobox 6', NULL, NULL, NULL, NULL, NULL, 4),
(178299, NULL, 'G3DSA:3.30.40.10:FF:002196', NULL, NULL, 'Ubiquitin-conjugating enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(178300, NULL, 'G3DSA:3.10.20.90:FF:000095', NULL, NULL, 'Ubiquilin 4', NULL, NULL, NULL, NULL, NULL, 4),
(178301, NULL, 'G3DSA:1.20.5.5160:FF:000006', NULL, NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', NULL, NULL, NULL, NULL, NULL, 4),
(178302, NULL, 'G3DSA:3.90.70.10:FF:000042', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(178303, NULL, 'G3DSA:3.40.50.720:FF:001204', NULL, NULL, 'NAD(P)-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(178304, NULL, 'G3DSA:2.10.25.10:FF:000157', NULL, NULL, 'Neurogenic locus notch protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(178305, NULL, 'G3DSA:3.30.70.330:FF:002971', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178306, NULL, 'G3DSA:3.30.160.60:FF:002236', NULL, NULL, 'Zinc finger protein 226', NULL, NULL, NULL, NULL, NULL, 4),
(178307, NULL, 'G3DSA:3.40.50.300:FF:004187', NULL, NULL, 'RAD3-like DNA-binding helicase protein', NULL, NULL, NULL, NULL, NULL, 4),
(178308, NULL, 'G3DSA:3.40.50.150:FF:000466', NULL, NULL, 'Polyamine aminopropyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(178309, NULL, 'G3DSA:3.30.1600.10:FF:000035', NULL, NULL, 'NAD-dependent deacetylase sir2C', NULL, NULL, NULL, NULL, NULL, 4),
(178310, NULL, 'G3DSA:2.130.10.10:FF:002596', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178311, NULL, 'G3DSA:2.60.120.970:FF:000010', NULL, NULL, 'Transforming growth factor beta', NULL, NULL, NULL, NULL, NULL, 4),
(178312, NULL, 'G3DSA:3.40.640.10:FF:000423', NULL, NULL, 'Serine--pyruvate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(178313, NULL, 'G3DSA:2.40.270.10:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(178314, NULL, 'G3DSA:1.25.10.10:FF:002891', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178315, NULL, 'G3DSA:1.10.8.60:FF:000499', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178316, NULL, 'G3DSA:1.25.40.10:FF:002443', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g19720', NULL, NULL, NULL, NULL, NULL, 4),
(178317, NULL, 'G3DSA:1.10.10.10:FF:000822', NULL, NULL, 'Iron-regulated virulence regulatory protein IrgB', NULL, NULL, NULL, NULL, NULL, 4),
(178318, NULL, 'G3DSA:3.30.160.60:FF:004366', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178319, NULL, 'G3DSA:1.25.40.10:FF:000381', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(178320, NULL, 'G3DSA:3.40.50.460:FF:000036', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(178321, NULL, 'G3DSA:1.10.20.10:FF:000087', NULL, NULL, 'Probable histone 3', NULL, NULL, NULL, NULL, NULL, 4),
(178322, NULL, 'G3DSA:2.40.110.10:FF:000039', NULL, NULL, 'Short-chain-specific acyl-CoA dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(178323, NULL, 'G3DSA:3.40.630.30:FF:000344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178324, NULL, 'G3DSA:1.20.1250.20:FF:000981', NULL, NULL, 'Protein BTN', NULL, NULL, NULL, NULL, NULL, 4),
(178325, NULL, 'G3DSA:3.40.50.10190:FF:000058', NULL, NULL, 'Epithelial cell transforming 2', NULL, NULL, NULL, NULL, NULL, 4),
(178326, NULL, 'G3DSA:1.10.510.10:FF:000439', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(178327, NULL, 'G3DSA:2.30.29.30:FF:000890', NULL, NULL, 'actin filament-associated protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(178328, NULL, 'G3DSA:2.40.50.140:FF:000736', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178329, NULL, 'G3DSA:4.10.1240.30:FF:000005', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(178330, NULL, 'G3DSA:1.25.40.1010:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178331, NULL, 'G3DSA:3.20.20.380:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178332, NULL, 'G3DSA:3.30.1120.10:FF:000037', NULL, NULL, 'Putative sulfatase yidJ', NULL, NULL, NULL, NULL, NULL, 4),
(178333, NULL, 'G3DSA:1.20.1250.20:FF:001711', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178334, NULL, 'G3DSA:3.40.50.300:FF:005704', NULL, NULL, 'Os11g0649100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(178335, NULL, 'G3DSA:3.20.20.80:FF:000597', NULL, NULL, 'Alpha-L-fucosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178336, NULL, 'G3DSA:3.40.1180.10:FF:000044', NULL, NULL, 'Undecaprenyl pyrophosphate synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178337, NULL, 'G3DSA:1.10.472.130:FF:000001', NULL, NULL, 'Dynein, axonemal, heavy chain 9', NULL, NULL, NULL, NULL, NULL, 4),
(178338, NULL, 'G3DSA:3.40.140.10:FF:000161', NULL, NULL, 'Nuclear protein localization protein 4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(178339, NULL, 'G3DSA:3.50.50.60:FF:001513', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178340, NULL, 'G3DSA:3.10.20.90:FF:000313', NULL, NULL, 'Blast:E3 ubiquitin-protein ligase MYLIP-A', NULL, NULL, NULL, NULL, NULL, 4),
(178341, NULL, 'G3DSA:1.10.8.870:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178342, NULL, 'G3DSA:1.10.510.10:FF:004413', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178343, NULL, 'G3DSA:3.90.1150.10:FF:000132', NULL, NULL, 'L-tryptophan--pyruvate aminotransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(178344, NULL, 'G3DSA:1.25.40.690:FF:000017', NULL, NULL, 'YALI0D17886p', NULL, NULL, NULL, NULL, NULL, 4),
(178345, NULL, 'G3DSA:1.10.287.70:FF:000701', NULL, NULL, 'Inward rectifier potassium channel irk-1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(178346, NULL, 'G3DSA:1.10.730.10:FF:000181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(178347, NULL, 'G3DSA:3.30.40.10:FF:000751', NULL, NULL, 'Tnf receptor associated factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178348, NULL, 'G3DSA:3.40.390.10:FF:000089', NULL, NULL, 'DUF3152 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(178349, NULL, 'G3DSA:1.10.10.10:FF:001154', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(178350, NULL, 'G3DSA:3.40.50.1820:FF:001320', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(178351, NULL, 'G3DSA:2.60.120.200:FF:000487', NULL, NULL, 'Si:ch211-241e1.3', NULL, NULL, NULL, NULL, NULL, 4),
(178352, NULL, 'G3DSA:1.10.10.60:FF:000247', NULL, NULL, 'Zinc fingers and homeoboxes protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(178353, NULL, 'G3DSA:1.10.100.10:FF:000004', NULL, NULL, 'insulin-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(178354, NULL, 'G3DSA:1.10.150.50:FF:000209', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(178355, NULL, 'G3DSA:1.10.510.10:FF:001390', NULL, NULL, 'protein kinase with WD repeats', NULL, NULL, NULL, NULL, NULL, 4),
(178356, NULL, 'G3DSA:1.10.286.20:FF:000004', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(178357, NULL, 'G3DSA:2.40.70.10:FF:000485', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178358, NULL, 'G3DSA:3.30.160.100:FF:000016', NULL, NULL, 'Ribosome hibernation promoting factor', NULL, NULL, NULL, NULL, NULL, 4),
(178359, NULL, 'G3DSA:1.25.40.20:FF:000355', NULL, NULL, 'Ankyrin repeat domain-containing protein 50', NULL, NULL, NULL, NULL, NULL, 4),
(178360, NULL, 'G3DSA:1.20.5.650:FF:000009', NULL, NULL, 'Unplaced genomic scaffold supercont1.24, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(178361, NULL, 'G3DSA:1.10.533.10:FF:000026', NULL, NULL, 'astrocytic phosphoprotein PEA-15 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(178362, NULL, 'G3DSA:3.40.1090.10:FF:000037', NULL, NULL, 'Lipase 4', NULL, NULL, NULL, NULL, NULL, 4),
(178363, NULL, 'G3DSA:2.60.260.20:FF:000110', NULL, NULL, 'Heat shock protein 40', NULL, NULL, NULL, NULL, NULL, 4),
(178364, NULL, 'G3DSA:2.20.70.10:FF:000143', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-36 specific', NULL, NULL, NULL, NULL, NULL, 4),
(178365, NULL, 'G3DSA:1.10.418.10:FF:000163', NULL, NULL, 'Fimbrin', NULL, NULL, NULL, NULL, NULL, 4),
(178366, NULL, 'G3DSA:3.90.850.10:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178367, NULL, 'G3DSA:3.10.20.90:FF:000836', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178368, NULL, 'G3DSA:3.30.2160.10:FF:000012', NULL, NULL, 'probable E3 ubiquitin-protein ligase HECTD4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(178369, NULL, 'G3DSA:3.40.50.1000:FF:000473', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178370, NULL, 'G3DSA:3.60.15.10:FF:000023', NULL, NULL, 'Zinc phosphodiesterase ELAC protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(178371, NULL, 'G3DSA:3.90.70.10:FF:000413', NULL, NULL, 'Cathepsin Z', NULL, NULL, NULL, NULL, NULL, 4),
(178372, NULL, 'G3DSA:3.20.20.70:FF:000537', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178373, NULL, 'G3DSA:3.90.70.10:FF:000677', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178374, NULL, 'G3DSA:3.30.70.330:FF:001982', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178375, NULL, 'G3DSA:1.25.40.10:FF:003168', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(178376, NULL, 'G3DSA:1.10.8.1190:FF:000003', NULL, NULL, 'Replicase polyprotein 1ab', NULL, NULL, NULL, NULL, NULL, 4),
(178377, NULL, 'G3DSA:3.40.30.10:FF:000261', NULL, NULL, 'TXNL4A isoform 9', NULL, NULL, NULL, NULL, NULL, 4),
(178378, NULL, 'G3DSA:3.90.550.50:FF:000226', NULL, NULL, 'Protein CBG18379', NULL, NULL, NULL, NULL, NULL, 4),
(178379, NULL, 'G3DSA:3.90.1480.20:FF:000002', NULL, NULL, 'CMP-N-acetylneuraminate-beta-galactosamide- alpha-2,3-sialyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(178380, NULL, 'G3DSA:1.20.1070.10:FF:002009', NULL, NULL, 'Protein CBR-NPR-17', NULL, NULL, NULL, NULL, NULL, 4),
(178381, NULL, 'G3DSA:1.25.40.570:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178382, NULL, 'G3DSA:1.20.120.1900:FF:000019', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(178383, NULL, 'G3DSA:2.60.120.920:FF:000141', NULL, NULL, 'neuralized-a protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(178384, NULL, 'G3DSA:3.40.50.2300:FF:000413', NULL, NULL, 'Glutamate metabotropic receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(178385, NULL, 'G3DSA:1.25.40.470:FF:000070', NULL, NULL, 'WD repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178386, NULL, 'G3DSA:2.30.180.10:FF:000079', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(178387, NULL, 'G3DSA:3.40.30.10:FF:000109', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(178388, NULL, 'G3DSA:1.10.8.50:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178389, NULL, 'G3DSA:1.20.1070.10:FF:001335', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(178390, NULL, 'G3DSA:3.40.50.300:FF:003670', NULL, NULL, 'ATP binding cassette subfamily C member 3', NULL, NULL, NULL, NULL, NULL, 4),
(178391, NULL, 'G3DSA:3.40.50.620:FF:000803', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178392, NULL, 'G3DSA:1.10.510.10:FF:003576', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178393, NULL, 'G3DSA:1.10.287.1490:FF:000139', NULL, NULL, 'Structural maintenance of chromosomes protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(178394, NULL, 'G3DSA:3.40.190.10:FF:000725', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(178395, NULL, 'G3DSA:1.10.8.270:FF:000072', NULL, NULL, 'Cell division control protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(178396, NULL, 'G3DSA:1.25.40.420:FF:000049', NULL, NULL, 'Speckle-type POZ protein', NULL, NULL, NULL, NULL, NULL, 4),
(178397, NULL, 'G3DSA:1.10.10.60:FF:000808', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178398, NULL, 'G3DSA:1.10.150.20:FF:000105', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(178399, NULL, 'G3DSA:2.60.40.60:FF:000929', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178400, NULL, 'G3DSA:3.90.1640.20:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178401, NULL, 'G3DSA:1.10.3080.10:FF:000074', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(178402, NULL, 'G3DSA:3.40.718.10:FF:000031', NULL, NULL, 'Isocitrate dehydrogenase [NAD] subunit alpha, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(178403, NULL, 'G3DSA:1.25.40.560:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178404, NULL, 'G3DSA:3.40.50.300:FF:004344', NULL, NULL, 'Pre-mRNA cleavage complex II Clp1-like, conserved', NULL, NULL, NULL, NULL, NULL, 4),
(178405, NULL, 'G3DSA:3.40.50.300:FF:007913', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178406, NULL, 'G3DSA:1.10.10.1820:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178407, NULL, 'G3DSA:1.10.357.30:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178408, NULL, 'G3DSA:1.10.510.10:FF:000939', NULL, NULL, 'Z-DNA binding protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(178409, NULL, 'G3DSA:1.10.400.10:FF:000049', NULL, NULL, 'Guanine nucleotide-binding protein G(I) subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(178410, NULL, 'G3DSA:2.40.170.20:FF:000034', NULL, NULL, 'SusC/RagA family TonB-linked outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(178411, NULL, 'G3DSA:2.30.30.110:FF:000006', NULL, NULL, 'mRNA interferase', NULL, NULL, NULL, NULL, NULL, 4),
(178412, NULL, 'G3DSA:1.25.10.10:FF:002683', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178413, NULL, 'G3DSA:3.30.200.20:FF:000542', NULL, NULL, 'Receptor-like serine/threonine-protein kinase At4g25390', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(178414, NULL, 'G3DSA:3.30.230.70:FF:000013', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(178415, NULL, 'G3DSA:2.30.30.490:FF:000075', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(178416, NULL, 'G3DSA:3.30.160.60:FF:000712', NULL, NULL, 'Drumstick, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(178417, NULL, 'G3DSA:2.120.10.30:FF:000146', NULL, NULL, 'Protein cueball', NULL, NULL, NULL, NULL, NULL, 4),
(178418, NULL, 'G3DSA:1.10.132.60:FF:000008', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(178419, NULL, 'G3DSA:1.20.272.10:FF:000063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178420, NULL, 'G3DSA:2.30.180.10:FF:000158', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178421, NULL, 'G3DSA:3.50.50.60:FF:001013', NULL, NULL, 'FAD/NAD(P)-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(178422, NULL, 'G3DSA:3.40.50.300:FF:002719', NULL, NULL, 'GTPase Der', NULL, NULL, NULL, NULL, NULL, 4),
(178423, NULL, 'G3DSA:3.50.50.60:FF:000153', NULL, NULL, 'Salicylate hydroxylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178424, NULL, 'G3DSA:2.30.30.40:FF:000071', NULL, NULL, 'Epidermal growth factor receptor kinase substrate 8', NULL, NULL, NULL, NULL, NULL, 4),
(178425, NULL, 'G3DSA:3.40.50.1100:FF:000210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178426, NULL, 'G3DSA:3.40.50.300:FF:000533', NULL, NULL, 'Helicase, Snf2 family', NULL, NULL, NULL, NULL, NULL, 4),
(178427, NULL, 'G3DSA:1.10.510.10:FF:001159', NULL, NULL, 'Protein kinase D4', NULL, NULL, NULL, NULL, NULL, 4),
(178428, NULL, 'G3DSA:3.30.40.10:FF:000228', NULL, NULL, 'Remodeling and spacing factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(178429, NULL, 'G3DSA:3.40.970.40:FF:000002', NULL, NULL, 'Fibronectin-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(178430, NULL, 'G3DSA:1.25.10.10:FF:000474', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(178431, NULL, 'G3DSA:3.30.450.90:FF:000002', NULL, NULL, 'Twitching motility protein PilT', NULL, NULL, NULL, NULL, NULL, 4),
(178432, NULL, 'G3DSA:3.40.50.1100:FF:000098', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(178433, NULL, 'G3DSA:1.50.40.10:FF:000119', NULL, NULL, 'Mitochondrial carrier domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(178434, NULL, 'G3DSA:3.30.420.40:FF:000300', NULL, NULL, 'Actin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178435, NULL, 'G3DSA:1.25.10.10:FF:002615', NULL, NULL, 'Serine/threonine protein phosphatase 2A 59 kDa regulatory subunit B'' eta isoform', NULL, NULL, NULL, NULL, NULL, 4),
(178436, NULL, 'G3DSA:1.10.510.10:FF:001890', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178437, NULL, 'G3DSA:3.60.40.10:FF:000249', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(178438, NULL, 'G3DSA:1.10.238.10:FF:000918', NULL, NULL, 'EF-hand calcium-binding domain-containing protein 6-like', NULL, NULL, NULL, NULL, NULL, 4),
(178439, NULL, 'G3DSA:2.60.40.10:FF:004153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178440, NULL, 'G3DSA:2.40.30.10:FF:000387', NULL, NULL, 'translation initiation factor IF-2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(178441, NULL, 'G3DSA:1.10.510.10:FF:003929', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178442, NULL, 'G3DSA:3.90.215.10:FF:000008', NULL, NULL, 'Angiopoietin like 3', NULL, NULL, NULL, NULL, NULL, 4),
(178443, NULL, 'G3DSA:3.10.20.90:FF:000448', NULL, NULL, 'Ubiquitin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(178444, NULL, 'G3DSA:3.90.550.10:FF:000130', NULL, NULL, 'Family 2 glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(178445, NULL, 'G3DSA:2.30.30.100:FF:000228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178446, NULL, 'G3DSA:2.30.29.30:FF:000502', NULL, NULL, 'Unc-112-related protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(178447, NULL, 'G3DSA:3.40.50.800:FF:000060', NULL, NULL, 'Threonine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(178448, NULL, 'G3DSA:3.40.630.30:FF:000136', NULL, NULL, 'Glucosamine 6-phosphate N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(178449, NULL, 'G3DSA:1.10.3110.10:FF:000004', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(178450, NULL, 'G3DSA:1.25.10.10:FF:001334', NULL, NULL, 'Plakophilin 1b', NULL, NULL, NULL, NULL, NULL, 4),
(178451, NULL, 'G3DSA:1.20.1560.10:FF:000462', NULL, NULL, 'ABC-type Ni2+/Co2+ export system bifunctional ATPase and permease components AtmA', NULL, NULL, NULL, NULL, NULL, 4),
(178452, NULL, 'G3DSA:1.20.58.930:FF:000003', NULL, NULL, 'Arginine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(178453, NULL, 'G3DSA:3.60.20.10:FF:000153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178454, NULL, 'G3DSA:3.10.20.90:FF:000105', NULL, NULL, 'phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(178455, NULL, 'G3DSA:3.50.50.60:FF:000737', NULL, NULL, 'FAD-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(178456, NULL, 'G3DSA:3.40.630.30:FF:000479', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178457, NULL, 'G3DSA:4.10.400.10:FF:000077', NULL, NULL, 'atrial natriuretic peptide-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(178458, NULL, 'G3DSA:1.20.1250.20:FF:001211', NULL, NULL, 'Related to multidrug resistant protein', NULL, NULL, NULL, NULL, NULL, 4),
(178459, NULL, 'G3DSA:3.40.50.2000:FF:000317', NULL, NULL, 'UDP-N-acetylglucosamine transferase subunit ALG14', NULL, NULL, NULL, NULL, NULL, 4),
(178460, NULL, 'G3DSA:1.10.1380.10:FF:000023', NULL, NULL, 'NEPrilysin metallopeptidase family', NULL, NULL, NULL, NULL, NULL, 4),
(178461, NULL, 'G3DSA:1.10.10.10:FF:001362', NULL, NULL, 'Amine oxidase family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(178462, NULL, 'G3DSA:1.10.238.10:FF:001138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178463, NULL, 'G3DSA:1.10.510.10:FF:004205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178464, NULL, 'G3DSA:1.25.40.10:FF:001903', NULL, NULL, 'RCM-1', NULL, NULL, NULL, NULL, NULL, 4),
(178465, NULL, 'G3DSA:1.20.140.10:FF:000072', NULL, NULL, 'Acyl-CoA dehydrogenase FadE27', NULL, NULL, NULL, NULL, NULL, 4),
(178466, NULL, 'G3DSA:1.20.1050.130:FF:000006', NULL, NULL, 'Elongation factor 1-delta 1', NULL, NULL, NULL, NULL, NULL, 4),
(178467, NULL, 'G3DSA:3.30.530.20:FF:000078', NULL, NULL, 'Phosphatidylcholine transfer protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(178468, NULL, 'G3DSA:2.60.120.10:FF:000439', NULL, NULL, 'Seed storage protein', NULL, NULL, NULL, NULL, NULL, 4),
(178469, NULL, 'G3DSA:3.30.160.60:FF:003309', NULL, NULL, 'Zgc:171551', NULL, NULL, NULL, NULL, NULL, 4),
(178470, NULL, 'G3DSA:2.60.40.10:FF:000842', NULL, NULL, 'Interferon receptor 1 isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(178471, NULL, 'G3DSA:2.130.10.10:FF:002091', NULL, NULL, 'POC1 centriolar protein homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(178472, NULL, 'G3DSA:3.80.10.10:FF:001394', NULL, NULL, 'Disease resistance-like protein DSC1', NULL, NULL, NULL, NULL, NULL, 4),
(178473, NULL, 'G3DSA:1.10.1040.50:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178474, NULL, 'G3DSA:1.10.287.370:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178475, NULL, 'G3DSA:3.90.190.10:FF:000528', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(178476, NULL, 'G3DSA:1.10.8.10:FF:000214', NULL, NULL, 'Protein phosphatase regulator', NULL, NULL, NULL, NULL, NULL, 4),
(178477, NULL, 'G3DSA:3.30.70.980:FF:000007', NULL, NULL, 'Probable transcriptional regulatory protein BACUNI_02276', NULL, NULL, NULL, NULL, NULL, 4),
(178478, NULL, 'G3DSA:3.30.1520.10:FF:000034', NULL, NULL, 'Vacuolar protein sorting-associated protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(178479, NULL, 'G3DSA:2.60.220.50:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(178480, NULL, 'G3DSA:3.40.50.2300:FF:000205', NULL, NULL, 'Two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(178481, NULL, 'G3DSA:3.30.505.10:FF:000218', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178482, NULL, 'G3DSA:2.30.30.140:FF:000049', NULL, NULL, 'PHD finger protein 20 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(178483, NULL, 'G3DSA:3.50.50.60:FF:000496', NULL, NULL, 'tRNA 5-methylaminomethyl-2-thiouridine biosynthesis bifunctional protein MnmC', NULL, NULL, NULL, NULL, NULL, 4),
(178484, NULL, 'G3DSA:3.40.50.300:FF:006761', NULL, NULL, 'Heparan-sulfate 6-O-sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(178485, NULL, 'G3DSA:1.25.40.10:FF:003348', NULL, NULL, 'Prp-6', NULL, NULL, NULL, NULL, NULL, 4),
(178486, NULL, 'G3DSA:3.40.50.170:FF:000005', NULL, NULL, 'Phosphoribosylglycinamide formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(178487, NULL, 'G3DSA:2.60.40.3210:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178488, NULL, 'G3DSA:2.130.10.120:FF:000021', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(178489, NULL, 'G3DSA:2.60.40.10:FF:002972', NULL, NULL, 'fibrocystin-L-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(178490, NULL, 'G3DSA:1.10.238.10:FF:000014', NULL, NULL, 'Dystrobrevin alpha', NULL, NULL, NULL, NULL, NULL, 4),
(178491, NULL, 'G3DSA:3.30.160.60:FF:002157', NULL, NULL, 'Transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(178492, NULL, 'G3DSA:1.25.40.180:FF:000140', NULL, NULL, 'Putative eukaryotic translation initiation factor 4 gamma 3', NULL, NULL, NULL, NULL, NULL, 4),
(178493, NULL, 'G3DSA:3.30.70.960:FF:000001', NULL, NULL, 'NtA agrin', NULL, NULL, NULL, NULL, NULL, 4),
(178494, NULL, 'G3DSA:2.40.30.180:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178495, NULL, 'G3DSA:2.80.10.50:FF:000025', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(178496, NULL, 'G3DSA:3.40.50.10810:FF:000132', NULL, NULL, 'Excision repair cross-complementation group 6-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(178497, NULL, 'G3DSA:1.10.510.10:FF:000198', NULL, NULL, 'receptor protein kinase TMK1', NULL, NULL, NULL, NULL, NULL, 4),
(178498, NULL, 'G3DSA:2.30.30.140:FF:000280', NULL, NULL, 'Protein CBR-RAD-54', NULL, NULL, NULL, NULL, NULL, 4),
(178499, NULL, 'G3DSA:3.40.50.720:FF:001328', NULL, NULL, 'mRNA, partial cds, clone: RAFL22-45-J20', NULL, NULL, NULL, NULL, NULL, 4),
(178500, NULL, 'G3DSA:3.30.830.10:FF:000070', NULL, NULL, 'Mitochondrial processing peptidase alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178501, NULL, 'G3DSA:1.20.1560.10:FF:000703', NULL, NULL, 'HlyB/MsbA family ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(178502, NULL, 'G3DSA:2.60.40.10:FF:005777', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178503, NULL, 'G3DSA:3.40.50.1480:FF:000015', NULL, NULL, 'Adenosylhomocysteinase', NULL, NULL, NULL, NULL, NULL, 4),
(178504, NULL, 'G3DSA:1.20.58.420:FF:000002', NULL, NULL, 'Alpha-hemoglobin-stabilizing protein', NULL, NULL, NULL, NULL, NULL, 4),
(178505, NULL, 'G3DSA:1.10.630.10:FF:000358', NULL, NULL, 'Cytochrome P450, putative (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(178506, NULL, 'G3DSA:2.10.70.10:FF:000284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178507, NULL, 'G3DSA:3.30.70.270:FF:000070', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(178508, NULL, 'G3DSA:1.20.1070.10:FF:000211', NULL, NULL, 'Melanocyte-stimulating hormone receptor', NULL, NULL, NULL, NULL, NULL, 4),
(178509, NULL, 'G3DSA:3.40.140.10:FF:000222', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(178510, NULL, 'G3DSA:1.10.420.10:FF:000051', NULL, NULL, 'Peroxidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(178511, NULL, 'G3DSA:2.30.170.20:FF:000019', NULL, NULL, 'Os07g0224000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(178512, NULL, 'G3DSA:3.40.50.300:FF:008077', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(178513, NULL, 'G3DSA:4.10.400.10:FF:000318', NULL, NULL, 'Cortical granule serine protease 1; Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178514, NULL, 'G3DSA:3.40.50.720:FF:000103', NULL, NULL, 'Glyoxylate/hydroxypyruvate reductase B', NULL, NULL, NULL, NULL, NULL, 4),
(178515, NULL, 'G3DSA:2.60.200.20:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178516, NULL, 'G3DSA:3.40.309.10:FF:000013', NULL, NULL, 'N-succinylglutamate 5-semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(178517, NULL, 'G3DSA:3.40.50.300:FF:005468', NULL, NULL, 'RAD50 DNA repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178518, NULL, 'G3DSA:2.130.10.10:FF:004861', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178519, NULL, 'G3DSA:3.40.640.10:FF:000362', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(178520, NULL, 'G3DSA:1.10.472.10:FF:000221', NULL, NULL, 'G1/S-specific cyclin e2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(178521, NULL, 'G3DSA:2.30.29.30:FF:001166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178522, NULL, 'G3DSA:2.40.10.10:FF:000088', NULL, NULL, 'kallikrein-6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(178523, NULL, 'G3DSA:3.40.50.2300:FF:001306', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178524, NULL, 'G3DSA:3.40.50.300:FF:006896', NULL, NULL, 'GPN-loop GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(178525, NULL, 'G3DSA:1.20.144.10:FF:000018', NULL, NULL, 'Glucose-6-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(178526, NULL, 'G3DSA:3.30.390.30:FF:000024', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(178527, NULL, 'G3DSA:3.50.30.30:FF:000047', NULL, NULL, 'Lipoprotein aminopeptidase LpqL', NULL, NULL, NULL, NULL, NULL, 4),
(178528, NULL, 'G3DSA:3.30.1120.100:FF:000001', NULL, NULL, 'Fatty acid synthase beta subunit dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(178529, NULL, 'G3DSA:1.20.120.980:FF:000023', NULL, NULL, 'Serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(178530, NULL, 'G3DSA:2.30.29.30:FF:000261', NULL, NULL, 'Epidermal growth factor receptor kinase substrate 8-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(178531, NULL, 'G3DSA:3.30.497.10:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178532, NULL, 'G3DSA:3.50.50.60:FF:001277', NULL, NULL, 'Polyamine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(178533, NULL, 'G3DSA:2.150.10.10:FF:000009', NULL, NULL, 'Mannuronan C-5-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(178534, NULL, 'G3DSA:3.80.10.10:FF:002495', NULL, NULL, 'Protein phosphatase 2C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178535, NULL, 'G3DSA:2.120.10.80:FF:000200', NULL, NULL, 'Kelch like family member 40', NULL, NULL, NULL, NULL, NULL, 4),
(178536, NULL, 'G3DSA:3.20.20.70:FF:000184', NULL, NULL, 'Stachyose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(178537, NULL, 'G3DSA:3.10.100.10:FF:000131', NULL, NULL, 'Lymphocyte antigen 75', NULL, NULL, NULL, NULL, NULL, 4),
(178538, NULL, 'G3DSA:1.10.1750.10:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178539, NULL, 'G3DSA:1.10.1420.10:FF:000027', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(178540, NULL, 'G3DSA:3.30.40.10:FF:001476', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178541, NULL, 'G3DSA:3.30.450.20:FF:000638', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(178542, NULL, 'G3DSA:3.40.250.10:FF:000051', NULL, NULL, 'Protein tyrosine phosphatase (Pyp1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(178543, NULL, 'G3DSA:2.20.100.10:FF:000144', NULL, NULL, 'AGAP011765-PA', NULL, NULL, NULL, NULL, NULL, 4),
(178544, NULL, 'G3DSA:3.30.160.20:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178545, NULL, 'G3DSA:2.120.10.80:FF:000324', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(178546, NULL, 'G3DSA:1.20.58.60:FF:000710', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178547, NULL, 'G3DSA:1.10.238.10:FF:000357', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(178548, NULL, 'G3DSA:3.40.50.300:FF:001253', NULL, NULL, 'ATP-binding cassette protein subfamily A, member 10', NULL, NULL, NULL, NULL, NULL, 4),
(178549, NULL, 'G3DSA:3.40.50.2000:FF:000593', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178550, NULL, 'G3DSA:2.40.50.40:FF:000026', NULL, NULL, 'C-C motif chemokine 25', NULL, NULL, NULL, NULL, NULL, 4),
(178551, NULL, 'G3DSA:3.30.300.10:FF:000041', NULL, NULL, 'S-adenosylmethionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(178552, NULL, 'G3DSA:3.30.70.141:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178553, NULL, 'G3DSA:3.30.565.10:FF:000514', NULL, NULL, 'Two component signal transduction system histidine kinase RstB', NULL, NULL, NULL, NULL, NULL, 4),
(178554, NULL, 'G3DSA:1.20.1530.20:FF:000019', NULL, NULL, 'Cation/H(+) antiporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(178555, NULL, 'G3DSA:1.10.3210.10:FF:000124', NULL, NULL, 'Metal dependent phosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(178556, NULL, 'G3DSA:3.20.20.140:FF:000444', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178557, NULL, 'G3DSA:2.170.130.10:FF:000026', NULL, NULL, 'TonB-dependent siderophore receptor', NULL, NULL, NULL, NULL, NULL, 4),
(178558, NULL, 'G3DSA:1.25.40.20:FF:001783', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178559, NULL, 'G3DSA:3.40.50.2300:FF:000025', NULL, NULL, 'glutamate receptor ionotropic, NMDA 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(178560, NULL, 'G3DSA:3.30.420.40:FF:000643', NULL, NULL, 'Ppx/GppA phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(178561, NULL, 'G3DSA:2.40.50.1020:FF:000007', NULL, NULL, 'Two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(178562, NULL, 'G3DSA:3.30.40.10:FF:001656', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178563, NULL, 'G3DSA:2.70.150.10:FF:000107', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(178564, NULL, 'G3DSA:3.40.50.150:FF:000387', NULL, NULL, 'dTDP-3-amino-3,6-dideoxy-alpha-D-glucopyranose N,N-dimethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(178565, NULL, 'G3DSA:3.40.50.1440:FF:000115', NULL, NULL, 'Tubulin gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(178566, NULL, 'G3DSA:3.40.50.300:FF:004423', NULL, NULL, 'ATP-dependent chaperone, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178567, NULL, 'G3DSA:3.50.4.10:FF:000027', NULL, NULL, 'Plasminogen', NULL, NULL, NULL, NULL, NULL, 4),
(178568, NULL, 'G3DSA:3.30.160.60:FF:000151', NULL, NULL, 'Zinc finger and SCAN domain-containing 21', NULL, NULL, NULL, NULL, NULL, 4),
(178569, NULL, 'G3DSA:3.10.110.10:FF:000216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178570, NULL, 'G3DSA:3.80.10.10:FF:002675', NULL, NULL, 'Receptor protein-tyrosine kinase CEPR2 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(178571, NULL, 'G3DSA:2.50.20.10:FF:000009', NULL, NULL, 'Outer-membrane lipoprotein LolB', NULL, NULL, NULL, NULL, NULL, 4),
(178572, NULL, 'G3DSA:3.90.550.10:FF:000473', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(178573, NULL, 'G3DSA:2.40.30.160:FF:000002', NULL, NULL, 'Aminomethyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178574, NULL, 'G3DSA:3.30.1680.10:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178575, NULL, 'G3DSA:1.10.10.10:FF:002059', NULL, NULL, 'AI-3-responsive two component signal transduction system response regulator QseB', NULL, NULL, NULL, NULL, NULL, 4),
(178576, NULL, 'G3DSA:2.30.33.40:FF:000026', NULL, NULL, 'Sterile alpha motif (SAM) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(178577, NULL, 'G3DSA:1.10.510.10:FF:002519', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(178578, NULL, 'G3DSA:3.40.50.10190:FF:000137', NULL, NULL, 'Mutagen-sensitive 101', NULL, NULL, NULL, NULL, NULL, 4),
(178579, NULL, 'G3DSA:2.130.10.10:FF:003349', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(178580, NULL, 'G3DSA:2.30.30.40:FF:000576', NULL, NULL, 'Cdc42 guanine nucleotide exchange factor (GEF) 9b', NULL, NULL, NULL, NULL, NULL, 4),
(178581, NULL, 'G3DSA:3.40.50.1820:FF:001056', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(178582, NULL, 'G3DSA:1.10.510.10:FF:003188', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178583, NULL, 'G3DSA:2.130.10.10:FF:001539', NULL, NULL, 'AASDH isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(178584, NULL, 'G3DSA:2.60.40.150:FF:000519', NULL, NULL, 'Probable serine/threonine-protein kinase DDB_G0288795', NULL, NULL, NULL, NULL, NULL, 4),
(178585, NULL, 'G3DSA:3.30.70.330:FF:001914', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178586, NULL, 'G3DSA:3.20.80.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178587, NULL, 'G3DSA:3.80.10.10:FF:000202', NULL, NULL, 'protein scribble homolog isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(178588, NULL, 'G3DSA:3.30.230.130:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178589, NULL, 'G3DSA:1.20.1070.10:FF:001964', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178590, NULL, 'G3DSA:3.40.390.10:FF:000201', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178591, NULL, 'G3DSA:3.30.450.20:FF:000077', NULL, NULL, 'Hybrid signal transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(178592, NULL, 'G3DSA:1.25.40.10:FF:000886', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(178593, NULL, 'G3DSA:3.10.450.40:FF:000014', NULL, NULL, 'Peroxisomal primary amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(178594, NULL, 'G3DSA:2.30.42.10:FF:000016', NULL, NULL, 'peripheral plasma membrane protein CASK isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(178595, NULL, 'G3DSA:2.170.190.11:FF:000020', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(178596, NULL, 'G3DSA:3.40.50.720:FF:001480', NULL, NULL, 'dTDP-fucopyranose mutase', NULL, NULL, NULL, NULL, NULL, 4),
(178597, NULL, 'G3DSA:1.10.3080.10:FF:000006', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(178598, NULL, 'G3DSA:1.25.40.10:FF:001162', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(178599, NULL, 'G3DSA:3.40.50.300:FF:006609', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178600, NULL, 'G3DSA:3.30.200.20:FF:000154', NULL, NULL, 'probable serine/threonine-protein kinase At4g35230', NULL, NULL, NULL, NULL, NULL, 4),
(178601, NULL, 'G3DSA:3.30.420.10:FF:000257', NULL, NULL, 'Os07g0112200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(178602, NULL, 'G3DSA:3.80.10.10:FF:003512', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(178603, NULL, 'G3DSA:1.10.357.10:FF:000021', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(178604, NULL, 'G3DSA:1.10.10.60:FF:000168', NULL, NULL, 'Telomere repeat-binding factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(178605, NULL, 'G3DSA:3.40.50.1980:FF:000103', NULL, NULL, 'Nitrogenase MoFe cofactor biosynthesis protein NifN', NULL, NULL, NULL, NULL, NULL, 4),
(178606, NULL, 'G3DSA:3.30.1640.10:FF:000032', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(178607, NULL, 'G3DSA:2.20.25.10:FF:000016', NULL, NULL, 'DNA-directed RNA polymerase II subunit RPB9', NULL, NULL, NULL, NULL, NULL, 4),
(178608, NULL, 'G3DSA:1.10.510.10:FF:004481', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178609, NULL, 'G3DSA:1.20.58.60:FF:000789', NULL, NULL, 'Muscle-specific protein 300 kDa, isoform M', NULL, NULL, NULL, NULL, NULL, 4),
(178610, NULL, 'G3DSA:3.30.160.60:FF:005647', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(178611, NULL, 'G3DSA:2.130.10.10:FF:002832', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178612, NULL, 'G3DSA:1.25.10.10:FF:000553', NULL, NULL, 'dnaJ homolog subfamily C GRV2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(178613, NULL, 'G3DSA:2.60.40.790:FF:000132', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178614, NULL, 'G3DSA:3.20.20.70:FF:000801', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178615, NULL, 'G3DSA:3.10.290.10:FF:000032', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(178616, NULL, 'G3DSA:2.40.160.110:FF:000001', NULL, NULL, 'lysosome-associated membrane glycoprotein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(178617, NULL, 'G3DSA:3.30.160.60:FF:006047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178618, NULL, 'G3DSA:1.20.120.1080:FF:000032', NULL, NULL, 'ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(178619, NULL, 'G3DSA:2.130.10.10:FF:000179', NULL, NULL, 'Target of rapamycin complex subunit LST8', NULL, NULL, NULL, NULL, NULL, 4),
(178620, NULL, 'G3DSA:1.10.10.200:FF:000009', NULL, NULL, 'Endogenous retrovirus group K member 10 Pol protein', NULL, NULL, NULL, NULL, NULL, 4),
(178621, NULL, 'G3DSA:3.40.50.80:FF:000064', NULL, NULL, 'Flavohemoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(178622, NULL, 'G3DSA:3.30.70.330:FF:000554', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(178623, NULL, 'G3DSA:1.20.930.80:FF:000001', NULL, NULL, 'DNA primase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(178624, NULL, 'G3DSA:2.60.40.10:FF:005434', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178625, NULL, 'G3DSA:1.25.40.10:FF:004596', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178626, NULL, 'G3DSA:1.25.40.20:FF:001108', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(178627, NULL, 'G3DSA:1.20.5.170:FF:000079', NULL, NULL, 'Outer capsid protein VP4', NULL, NULL, NULL, NULL, NULL, 4),
(178628, NULL, 'G3DSA:3.60.21.10:FF:000065', NULL, NULL, 'Purple acid phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(178629, NULL, 'G3DSA:2.60.40.10:FF:002000', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(178630, NULL, 'G3DSA:3.30.30.10:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178631, NULL, 'G3DSA:1.10.640.10:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178632, NULL, 'G3DSA:3.40.50.720:FF:000991', NULL, NULL, 'Oxidoreductase, short-chain dehydrogenase/reductase family', NULL, NULL, NULL, NULL, NULL, 4),
(178633, NULL, 'G3DSA:3.30.160.100:FF:000011', NULL, NULL, 'Ribosome hibernation promoting factor', NULL, NULL, NULL, NULL, NULL, 4),
(178634, NULL, 'G3DSA:3.90.190.10:FF:000315', NULL, NULL, 'Tyrosine-protein phosphatase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(178635, NULL, 'G3DSA:3.80.10.10:FF:001663', NULL, NULL, 'F-box/LRR-repeat protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(178636, NULL, 'G3DSA:3.40.190.10:FF:000276', NULL, NULL, 'Glutamate receptor 2.3', NULL, NULL, NULL, NULL, NULL, 4),
(178637, NULL, 'G3DSA:2.70.98.10:FF:000070', NULL, NULL, 'Aldose 1-epimerase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(178638, NULL, 'G3DSA:2.10.270.10:FF:000012', NULL, NULL, 'Dextransucrase', NULL, NULL, NULL, NULL, NULL, 4),
(178639, NULL, 'G3DSA:3.30.420.40:FF:000412', NULL, NULL, 'Polyphosphate glucokinase', NULL, NULL, NULL, NULL, NULL, 4),
(178640, NULL, 'G3DSA:2.130.10.10:FF:005873', NULL, NULL, 'PAN2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(178641, NULL, 'G3DSA:3.80.10.10:FF:002231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178642, NULL, 'G3DSA:3.90.190.10:FF:000259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178643, NULL, 'G3DSA:3.80.10.10:FF:002175', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(178644, NULL, 'G3DSA:2.130.10.10:FF:002152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(178645, NULL, 'G3DSA:2.60.40.10:FF:003753', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178646, NULL, 'G3DSA:2.60.40.10:FF:003697', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178647, NULL, 'G3DSA:3.90.1590.10:FF:000002', NULL, NULL, 'Uncharacterized lyase C29B12.13', NULL, NULL, NULL, NULL, NULL, 4),
(178648, NULL, 'G3DSA:2.120.10.30:FF:000326', NULL, NULL, 'Protein yellow-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(178649, NULL, 'G3DSA:1.20.1250.20:FF:001094', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(178650, NULL, 'G3DSA:2.130.10.10:FF:001584', NULL, NULL, 'Mtor (MTOR) associated protein, LST8 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(178651, NULL, 'G3DSA:3.30.420.40:FF:000356', NULL, NULL, 'T(6)A37 threonylcarbamoyladenosine biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(178652, NULL, 'G3DSA:1.20.1250.20:FF:001150', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178653, NULL, 'G3DSA:3.30.160.60:FF:002736', NULL, NULL, 'Zinc finger protein 655', NULL, NULL, NULL, NULL, NULL, 4),
(178654, NULL, 'G3DSA:1.20.1280.290:FF:000021', NULL, NULL, 'Solute carrier family 50 member 1', NULL, NULL, NULL, NULL, NULL, 4),
(178655, NULL, 'G3DSA:3.40.50.1000:FF:000118', NULL, NULL, 'Phospholysine phosphohistidine inorganic pyrophosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(178656, NULL, 'G3DSA:4.10.240.10:FF:000098', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(178657, NULL, 'G3DSA:2.60.120.1040:FF:000008', NULL, NULL, 'Zn finger containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(178658, NULL, 'G3DSA:3.30.40.10:FF:001976', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(178659, NULL, 'G3DSA:3.40.30.10:FF:000609', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(178660, NULL, 'G3DSA:3.40.20.10:FF:000047', NULL, NULL, 'Villin like', NULL, NULL, NULL, NULL, NULL, 4),
(178661, NULL, 'G3DSA:3.30.56.70:FF:000007', NULL, NULL, 'tRNA (guanine(26)-N(2)/guanine(27)-N(2))-dimethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(178662, NULL, 'G3DSA:3.30.70.330:FF:000958', NULL, NULL, 'RNA binding protein (Rbm8A), putative', NULL, NULL, NULL, NULL, NULL, 4),
(178663, NULL, 'G3DSA:3.20.10.10:FF:000036', NULL, NULL, '4-amino-4-deoxychorismate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(178664, NULL, 'G3DSA:3.40.630.10:FF:000361', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178665, NULL, 'G3DSA:3.30.40.10:FF:001925', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178666, NULL, 'G3DSA:3.10.129.10:FF:000186', NULL, NULL, 'Acyl-[acyl-carrier-protein] hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(178667, NULL, 'G3DSA:1.25.40.10:FF:001375', NULL, NULL, 'Tetratricopeptide repeat domain 21A', NULL, NULL, NULL, NULL, NULL, 4),
(178668, NULL, 'G3DSA:1.10.540.10:FF:000031', NULL, NULL, 'Nitroalkane oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(178669, NULL, 'G3DSA:3.40.30.10:FF:001166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178670, NULL, 'G3DSA:3.40.50.1820:FF:001505', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178671, NULL, 'G3DSA:3.10.580.10:FF:000127', NULL, NULL, 'Manganese-dependent inorganic pyrophosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178672, NULL, 'G3DSA:3.90.1150.10:FF:000475', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178673, NULL, 'G3DSA:1.10.4080.10:FF:000012', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(178674, NULL, 'G3DSA:1.10.238.10:FF:000514', NULL, NULL, 'Serine/threonine-protein phosphatase with EF-hands', NULL, NULL, NULL, NULL, NULL, 4),
(178675, NULL, 'G3DSA:3.40.50.300:FF:006840', NULL, NULL, 'GPN-loop GTPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(178676, NULL, 'G3DSA:3.30.500.10:FF:000022', NULL, NULL, 'UL16 binding protein 1, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(178677, NULL, 'G3DSA:3.10.20.90:FF:000336', NULL, NULL, 'E3 ubiquitin-protein ligase UHRF2 isoform A', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(178678, NULL, 'G3DSA:3.30.160.60:FF:000494', NULL, NULL, 'ras-responsive element-binding protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(178679, NULL, 'G3DSA:2.40.50.990:FF:000002', NULL, NULL, 'mRNA export factor elf1', NULL, NULL, NULL, NULL, NULL, 4),
(178680, NULL, 'G3DSA:3.60.21.10:FF:000352', NULL, NULL, 'Uncharacterized protein F44B9.9', NULL, NULL, NULL, NULL, NULL, 4),
(178681, NULL, 'G3DSA:2.60.120.650:FF:000032', NULL, NULL, 'Ribosomal oxygenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(178682, NULL, 'G3DSA:3.40.50.1820:FF:000252', NULL, NULL, 'Related to calmodulin-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(178683, NULL, 'G3DSA:3.40.50.2300:FF:000525', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(178684, NULL, 'G3DSA:3.90.1670.10:FF:000003', NULL, NULL, 'Formate dehydrogenase accessory protein FdhE, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178685, NULL, 'G3DSA:3.80.10.10:FF:001618', NULL, NULL, 'Os06g0587900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(178686, NULL, 'G3DSA:1.10.510.10:FF:003076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178687, NULL, 'G3DSA:1.10.437.10:FF:000027', NULL, NULL, 'Anti-apoptotic protein NR13', NULL, NULL, NULL, NULL, NULL, 4),
(178688, NULL, 'G3DSA:2.60.40.770:FF:000025', NULL, NULL, 'Lymphocyte antigen 86', NULL, NULL, NULL, NULL, NULL, 4),
(178689, NULL, 'G3DSA:2.30.42.10:FF:000460', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178690, NULL, 'G3DSA:3.50.50.60:FF:001518', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178691, NULL, 'G3DSA:1.20.1070.10:FF:000267', NULL, NULL, 'Blast:Neuromedin-U receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(178692, NULL, 'G3DSA:3.40.630.30:FF:000367', NULL, NULL, 'GM25645', NULL, NULL, NULL, NULL, NULL, 4),
(178693, NULL, 'G3DSA:3.90.226.10:FF:000028', NULL, NULL, 'Protease SohB family protein', NULL, NULL, NULL, NULL, NULL, 4),
(178694, NULL, 'G3DSA:1.25.10.10:FF:002059', NULL, NULL, 'AP-3 complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(178695, NULL, 'G3DSA:1.10.140.10:FF:000001', NULL, NULL, 'Met repressor', NULL, NULL, NULL, NULL, NULL, 4),
(178696, NULL, 'G3DSA:2.60.40.10:FF:002236', NULL, NULL, 'Lin-12 And Glp-1 phenotype', NULL, NULL, NULL, NULL, NULL, 4),
(178697, NULL, 'G3DSA:1.20.5.1500:FF:000015', NULL, NULL, 'Testis-specific Y-encoded-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(178698, NULL, 'G3DSA:3.40.50.1820:FF:000196', NULL, NULL, 'Endoprotease endo-Pro', NULL, NULL, NULL, NULL, NULL, 4),
(178699, NULL, 'G3DSA:1.20.200.10:FF:000015', NULL, NULL, 'argininosuccinate lyase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(178700, NULL, 'G3DSA:1.10.287.940:FF:000018', NULL, NULL, 'Purinergic receptor P2X5-2', NULL, NULL, NULL, NULL, NULL, 4),
(178701, NULL, 'G3DSA:3.40.50.300:FF:003170', NULL, NULL, 'Dda DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(178702, NULL, 'G3DSA:3.40.50.2300:FF:000469', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178703, NULL, 'G3DSA:2.60.40.60:FF:000429', NULL, NULL, 'Cadherin 3', NULL, NULL, NULL, NULL, NULL, 4),
(178704, NULL, 'G3DSA:1.25.40.10:FF:002628', NULL, NULL, 'Multidomain-containing protein family', NULL, NULL, NULL, NULL, NULL, 4),
(178705, NULL, 'G3DSA:1.10.510.10:FF:002620', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178706, NULL, 'G3DSA:1.10.287.110:FF:000270', NULL, NULL, 'Cell division protein Ftn2, contains DnaJ domain', NULL, NULL, NULL, NULL, NULL, 4),
(178707, NULL, 'G3DSA:2.60.120.260:FF:000477', NULL, NULL, 'Anaphase-promoting complex subunit 10', NULL, NULL, NULL, NULL, NULL, 4),
(178708, NULL, 'G3DSA:3.40.630.10:FF:000209', NULL, NULL, 'Nicalin', NULL, NULL, NULL, NULL, NULL, 4),
(178709, NULL, 'G3DSA:3.90.70.10:FF:000177', NULL, NULL, 'Cysteine proteinase RD21A', NULL, NULL, NULL, NULL, NULL, 4),
(178710, NULL, 'G3DSA:1.10.3210.10:FF:000068', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(178711, NULL, 'G3DSA:3.40.50.720:FF:000928', NULL, NULL, 'Probable oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(178712, NULL, 'G3DSA:3.40.50.1820:FF:001556', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178713, NULL, 'G3DSA:3.40.30.10:FF:000761', NULL, NULL, 'Thioredoxin domain-containing protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(178714, NULL, 'G3DSA:3.40.50.300:FF:007278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178715, NULL, 'G3DSA:1.20.120.1240:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178716, NULL, 'G3DSA:1.20.140.150:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178717, NULL, 'G3DSA:3.40.50.150:FF:000123', NULL, NULL, 'Putative methyltransferase PMT15', NULL, NULL, NULL, NULL, NULL, 4),
(178718, NULL, 'G3DSA:2.60.120.970:FF:000015', NULL, NULL, 'Left-right determination factor', NULL, NULL, NULL, NULL, NULL, 4),
(178719, NULL, 'G3DSA:2.30.30.40:FF:000571', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178720, NULL, 'G3DSA:3.30.70.260:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178721, NULL, 'G3DSA:2.130.10.10:FF:005766', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase, cyclophilin-type family protein', NULL, NULL, NULL, NULL, NULL, 4),
(178722, NULL, 'G3DSA:3.40.50.2300:FF:001082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178723, NULL, 'G3DSA:3.40.50.300:FF:003967', NULL, NULL, 'Hypothetical ABC transporter ATP-binding protein ybiT', NULL, NULL, NULL, NULL, NULL, 4),
(178724, NULL, 'G3DSA:3.40.50.300:FF:007385', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178725, NULL, 'G3DSA:1.10.10.1590:FF:000005', NULL, NULL, 'NADH dehydrogenase I, E subunit', NULL, NULL, NULL, NULL, NULL, 4),
(178726, NULL, 'G3DSA:3.40.190.10:FF:000225', NULL, NULL, 'Amino acid ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(178727, NULL, 'G3DSA:1.10.150.240:FF:000080', NULL, NULL, 'HAD superfamily hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178728, NULL, 'G3DSA:3.30.160.60:FF:001432', NULL, NULL, 'Zinc finger protein 571', NULL, NULL, NULL, NULL, NULL, 4),
(178729, NULL, 'G3DSA:2.60.40.1730:FF:000081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178730, NULL, 'G3DSA:1.10.357.10:FF:000026', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(178731, NULL, 'G3DSA:2.120.10.80:FF:000032', NULL, NULL, 'Gigaxonin', NULL, NULL, NULL, NULL, NULL, 4),
(178732, NULL, 'G3DSA:3.40.50.150:FF:000230', NULL, NULL, 'tRNA (Guanine-N(7)-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(178733, NULL, 'G3DSA:3.30.160.60:FF:001836', NULL, NULL, 'HKR1, GLI-Kruppel zinc finger family member', NULL, NULL, NULL, NULL, NULL, 4),
(178734, NULL, 'G3DSA:2.40.160.210:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178735, NULL, 'G3DSA:2.40.50.140:FF:000388', NULL, NULL, 'SsDNA binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178736, NULL, 'G3DSA:3.40.250.10:FF:000219', NULL, NULL, 'Dual specificity phosphatase ibp1', NULL, NULL, NULL, NULL, NULL, 4),
(178737, NULL, 'G3DSA:3.30.70.330:FF:000110', NULL, NULL, 'RNA-binding protein 10 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(178738, NULL, 'G3DSA:1.25.40.10:FF:002679', NULL, NULL, 'peroxisomal targeting signal 1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(178739, NULL, 'G3DSA:3.40.50.620:FF:000668', NULL, NULL, 'Probable isoleucine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(178740, NULL, 'G3DSA:3.30.40.10:FF:001240', NULL, NULL, 'JmjC domain-containing histone demethylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178741, NULL, 'G3DSA:3.60.15.10:FF:000236', NULL, NULL, 'Protein CBR-NAPE-2', NULL, NULL, NULL, NULL, NULL, 4),
(178742, NULL, 'G3DSA:3.40.50.10810:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178743, NULL, 'G3DSA:3.30.310.50:FF:000031', NULL, NULL, 'Phosphohexomutase (Phosphoglucomutase / phosphomannomutase)', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(178744, NULL, 'G3DSA:3.40.1690.10:FF:000010', NULL, NULL, 'FlhB/HrpN/YscU/SpaS domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(178745, NULL, 'G3DSA:3.40.850.10:FF:000304', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(178746, NULL, 'G3DSA:3.30.70.920:FF:000017', NULL, NULL, 'Transcriptional regulator, AsnC family', NULL, NULL, NULL, NULL, NULL, 4),
(178747, NULL, 'G3DSA:2.60.120.970:FF:000066', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(178748, NULL, 'G3DSA:1.20.120.730:FF:000021', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(178749, NULL, 'G3DSA:3.30.70.330:FF:001807', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178750, NULL, 'G3DSA:3.40.50.300:FF:005480', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(178751, NULL, 'G3DSA:3.90.1290.10:FF:000013', NULL, NULL, 'dystonin isoform X7', NULL, NULL, NULL, NULL, NULL, 4),
(178752, NULL, 'G3DSA:3.20.20.150:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178753, NULL, 'G3DSA:3.80.10.10:FF:002967', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178754, NULL, 'G3DSA:2.30.30.40:FF:000008', NULL, NULL, 'Disks large homolog 1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(178755, NULL, 'G3DSA:1.50.40.10:FF:000294', NULL, NULL, 'Mitochondrial glycine transporter', NULL, NULL, NULL, NULL, NULL, 4),
(178756, NULL, 'G3DSA:1.20.1070.10:FF:002184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178757, NULL, 'G3DSA:1.20.1070.10:FF:001672', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178758, NULL, 'G3DSA:2.130.10.10:FF:005081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178759, NULL, 'G3DSA:3.30.450.40:FF:000184', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(178760, NULL, 'G3DSA:3.40.50.450:FF:000095', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(178761, NULL, 'G3DSA:3.30.160.60:FF:006215', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178762, NULL, 'G3DSA:3.30.160.60:FF:006103', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178763, NULL, 'G3DSA:3.80.10.10:FF:001770', NULL, NULL, 'Si:dkey-121n8.7', NULL, NULL, NULL, NULL, NULL, 4),
(178764, NULL, 'G3DSA:3.30.30.30:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178765, NULL, 'G3DSA:3.30.200.20:FF:001615', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178766, NULL, 'G3DSA:3.30.300.30:FF:000024', NULL, NULL, 'Lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(178767, NULL, 'G3DSA:1.10.340.30:FF:000033', NULL, NULL, 'DNA-3-methyladenine glycosidase II', NULL, NULL, NULL, NULL, NULL, 4),
(178768, NULL, 'G3DSA:1.10.510.10:FF:003924', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178769, NULL, 'G3DSA:3.30.160.60:FF:003293', NULL, NULL, 'Expressed sequence AI877918', NULL, NULL, NULL, NULL, NULL, 4),
(178770, NULL, 'G3DSA:3.30.70.240:FF:000027', NULL, NULL, 'U5 small nuclear ribonucleoprotein component, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178771, NULL, 'G3DSA:3.40.190.10:FF:000169', NULL, NULL, 'ABC transporter, substrate-binding protein, family 3', NULL, NULL, NULL, NULL, NULL, 4),
(178772, NULL, 'G3DSA:1.10.510.10:FF:004436', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178773, NULL, 'G3DSA:1.10.3110.10:FF:000009', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(178774, NULL, 'G3DSA:3.90.550.10:FF:000450', NULL, NULL, 'UDP-N-acetylglucosamine diphosphorylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(178775, NULL, 'G3DSA:2.120.10.80:FF:000083', NULL, NULL, 'Regulatory protein ral2, variant', NULL, NULL, NULL, NULL, NULL, 4),
(178776, NULL, 'G3DSA:3.20.20.70:FF:000133', NULL, NULL, 'N-acetylneuraminate pyruvate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(178777, NULL, 'G3DSA:1.10.8.60:FF:000532', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(178778, NULL, 'G3DSA:3.40.50.2000:FF:001110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178779, NULL, 'G3DSA:1.10.1070.11:FF:000046', NULL, NULL, 'Phosphatidylinositol 3-kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178780, NULL, 'G3DSA:2.10.60.10:FF:000019', NULL, NULL, 'Urokinase plasminogen activator surface receptor', NULL, NULL, NULL, NULL, NULL, 4),
(178781, NULL, 'G3DSA:3.40.50.300:FF:002506', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(178782, NULL, 'G3DSA:2.130.10.10:FF:005822', NULL, NULL, 'WD repeat and HMG-box DNA-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(178783, NULL, 'G3DSA:3.30.230.70:FF:000036', NULL, NULL, 'Exosome complex subunit Rrp46, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178784, NULL, 'G3DSA:1.10.720.30:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178785, NULL, 'G3DSA:1.25.40.720:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178786, NULL, 'G3DSA:2.40.33.10:FF:000017', NULL, NULL, 'AT14039p', NULL, NULL, NULL, NULL, NULL, 4),
(178787, NULL, 'G3DSA:1.25.10.10:FF:001547', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178788, NULL, 'G3DSA:2.10.25.10:FF:000718', NULL, NULL, 'Notch receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(178789, NULL, 'G3DSA:1.20.120.1220:FF:000001', NULL, NULL, 'Type 4 prepilin-like proteins leader peptide-processing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(178790, NULL, 'G3DSA:1.10.10.1340:FF:000003', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 31', NULL, NULL, NULL, NULL, NULL, 4),
(178791, NULL, 'G3DSA:1.10.10.10:FF:000018', NULL, NULL, 'DNA-binding response regulator ResD', NULL, NULL, NULL, NULL, NULL, 4),
(178792, NULL, 'G3DSA:2.40.50.100:FF:000224', NULL, NULL, 'Sulfate/molybdate ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(178793, NULL, 'G3DSA:2.60.40.10:FF:002348', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(178794, NULL, 'G3DSA:3.90.79.10:FF:000146', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(178795, NULL, 'G3DSA:3.40.30.10:FF:001273', NULL, NULL, 'Calsequestrin', NULL, NULL, NULL, NULL, NULL, 4),
(178796, NULL, 'G3DSA:1.10.510.10:FF:002564', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178797, NULL, 'G3DSA:3.30.870.10:FF:000128', NULL, NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(178798, NULL, 'G3DSA:3.90.70.10:FF:000065', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 32', NULL, NULL, NULL, NULL, NULL, 4),
(178799, NULL, 'G3DSA:3.90.226.10:FF:000091', NULL, NULL, 'Probable methylcrotonyl-CoA carboxylase beta chain, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(178800, NULL, 'G3DSA:3.40.50.300:FF:003855', NULL, NULL, 'Chromosome 23, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(178801, NULL, 'G3DSA:1.10.287.110:FF:000118', NULL, NULL, 'DnaJ domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(178802, NULL, 'G3DSA:2.10.25.10:FF:001293', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178803, NULL, 'G3DSA:3.30.2010.10:FF:000001', NULL, NULL, 'Protease HtpX', NULL, NULL, NULL, NULL, NULL, 4),
(178804, NULL, 'G3DSA:2.60.40.10:FF:004653', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178805, NULL, 'G3DSA:3.90.132.10:FF:000029', NULL, NULL, 'GP63-like', NULL, NULL, NULL, NULL, NULL, 4),
(178806, NULL, 'G3DSA:3.30.10.30:FF:000002', NULL, NULL, 'Dual specificity tyrosine-phosphorylation-regulated kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(178807, NULL, 'G3DSA:3.30.70.330:FF:002471', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178808, NULL, 'G3DSA:1.10.472.10:FF:000721', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(178809, NULL, 'G3DSA:2.130.10.10:FF:002096', NULL, NULL, 'WD repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(178810, NULL, 'G3DSA:1.20.1250.20:FF:000694', NULL, NULL, 'Vesicular acetylcholine transporter unc-17', NULL, NULL, NULL, NULL, NULL, 4),
(178811, NULL, 'G3DSA:1.10.3210.10:FF:000045', NULL, NULL, 'Two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(178812, NULL, 'G3DSA:3.40.50.360:FF:000068', NULL, NULL, 'S-adenosyl-L-methionine-dependent tRNA 4-demethylwyosine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(178813, NULL, 'G3DSA:1.10.510.10:FF:000203', NULL, NULL, 'Cyclin-dependent kinase 9', NULL, NULL, NULL, NULL, NULL, 4),
(178814, NULL, 'G3DSA:3.20.20.70:FF:000189', NULL, NULL, 'Nitronate monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(178815, NULL, 'G3DSA:2.130.10.10:FF:003456', NULL, NULL, 'Protein kinase family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(178816, NULL, 'G3DSA:3.30.1390.20:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178817, NULL, 'G3DSA:1.20.140.10:FF:000009', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(178818, NULL, 'G3DSA:1.20.1070.10:FF:000323', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178819, NULL, 'G3DSA:3.90.79.20:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178820, NULL, 'G3DSA:2.60.120.560:FF:000005', NULL, NULL, 'LCCL domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(178821, NULL, 'G3DSA:3.30.1520.10:FF:000085', NULL, NULL, 'Liver stage antigen-like protein/ PX domain', NULL, NULL, NULL, NULL, NULL, 4),
(178822, NULL, 'G3DSA:1.25.10.10:FF:000261', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(178823, NULL, 'G3DSA:1.25.10.10:FF:002907', NULL, NULL, 'Os07g0693400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(178824, NULL, 'G3DSA:3.60.21.10:FF:000296', NULL, NULL, 'Phosphoprotein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178825, NULL, 'G3DSA:2.10.25.10:FF:000893', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178826, NULL, 'G3DSA:2.40.30.10:FF:000095', NULL, NULL, 'Elongation factor Tu family protein', NULL, NULL, NULL, NULL, NULL, 4),
(178827, NULL, 'G3DSA:1.20.950.20:FF:000029', NULL, NULL, 'Glr1270 protein', NULL, NULL, NULL, NULL, NULL, 4),
(178828, NULL, 'G3DSA:1.10.510.10:FF:001215', NULL, NULL, 'Protein kinase domain containing protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(178829, NULL, 'G3DSA:3.30.450.20:FF:000318', NULL, NULL, 'Hypoxia-inducible factor 1 subunit alpha,-like', NULL, NULL, NULL, NULL, NULL, 4),
(178830, NULL, 'G3DSA:3.30.200.20:FF:000603', NULL, NULL, 'EKC/KEOPS complex subunit bud32', NULL, NULL, NULL, NULL, NULL, 4),
(178831, NULL, 'G3DSA:1.10.510.10:FF:002019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178832, NULL, 'G3DSA:1.25.40.20:FF:001608', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178833, NULL, 'G3DSA:2.60.40.1820:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178834, NULL, 'G3DSA:2.30.30.110:FF:000001', NULL, NULL, 'Endoribonuclease toxin MazF', NULL, NULL, NULL, NULL, NULL, 4),
(178835, NULL, 'G3DSA:3.30.200.20:FF:000311', NULL, NULL, 'N-terminal kinase-like protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(178836, NULL, 'G3DSA:3.30.497.10:FF:000064', NULL, NULL, 'Serine (or cysteine) peptidase inhibitor, clade B, member 6b', NULL, NULL, NULL, NULL, NULL, 4),
(178837, NULL, 'G3DSA:3.80.10.10:FF:004529', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178838, NULL, 'G3DSA:3.90.80.10:FF:000003', NULL, NULL, 'Inorganic pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(178839, NULL, 'G3DSA:3.10.20.30:FF:000009', NULL, NULL, 'Succinate dehydrogenase iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4),
(178840, NULL, 'G3DSA:1.20.5.110:FF:000196', NULL, NULL, 'Probable Golgi SNAP receptor complex member 2', NULL, NULL, NULL, NULL, NULL, 4),
(178841, NULL, 'G3DSA:1.10.3130.10:FF:000011', NULL, NULL, 'Serine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(178842, NULL, 'G3DSA:2.60.120.10:FF:000451', NULL, NULL, 'Phosphomannose isomerase type I', NULL, NULL, NULL, NULL, NULL, 4),
(178843, NULL, 'G3DSA:3.40.190.10:FF:000164', NULL, NULL, 'ATP phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(178844, NULL, 'G3DSA:2.120.10.30:FF:000438', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178845, NULL, 'G3DSA:3.90.1150.10:FF:000071', NULL, NULL, 'Kynureninase', NULL, NULL, NULL, NULL, NULL, 4),
(178846, NULL, 'G3DSA:1.10.720.30:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178847, NULL, 'G3DSA:3.30.160.60:FF:005198', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178848, NULL, 'G3DSA:3.30.70.330:FF:001414', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178849, NULL, 'G3DSA:3.30.70.330:FF:001358', NULL, NULL, 'WGS project CABT00000000 data, contig 2.5', NULL, NULL, NULL, NULL, NULL, 4),
(178850, NULL, 'G3DSA:3.30.160.60:FF:004653', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178851, NULL, 'G3DSA:3.30.200.20:FF:001059', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(178852, NULL, 'G3DSA:2.30.29.30:FF:000497', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(178853, NULL, 'G3DSA:2.10.90.10:FF:000139', NULL, NULL, 'Bone morphogenetic protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178854, NULL, 'G3DSA:1.20.58.80:FF:000036', NULL, NULL, 'Vacuolar sorting protein-associating protein 4A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178855, NULL, 'G3DSA:1.10.238.20:FF:000051', NULL, NULL, 'Odorant-binding protein 83ef', NULL, NULL, NULL, NULL, NULL, 4),
(178856, NULL, 'G3DSA:1.10.2000.10:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178857, NULL, 'G3DSA:2.130.10.10:FF:003905', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178858, NULL, 'G3DSA:3.40.50.300:FF:005709', NULL, NULL, 'Peptidase S24-like family protein', NULL, NULL, NULL, NULL, NULL, 4),
(178859, NULL, 'G3DSA:3.80.30.20:FF:000026', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(178860, NULL, 'G3DSA:3.30.750.24:FF:000048', NULL, NULL, 'Sulfate permease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(178861, NULL, 'G3DSA:1.20.5.190:FF:000118', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178862, NULL, 'G3DSA:2.60.40.60:FF:000368', NULL, NULL, 'Cadherin 74A, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(178863, NULL, 'G3DSA:2.60.40.10:FF:001387', NULL, NULL, 'CD101 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(178864, NULL, 'G3DSA:1.20.90.10:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178865, NULL, 'G3DSA:1.10.287.3810:FF:000004', NULL, NULL, 'Tryptophan 2,3-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(178866, NULL, 'G3DSA:1.10.3210.10:FF:000101', NULL, NULL, 'Cyclic di-GMP hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(178867, NULL, 'G3DSA:3.80.10.10:FF:000258', NULL, NULL, 'Nyctalopin', NULL, NULL, NULL, NULL, NULL, 4),
(178868, NULL, 'G3DSA:1.10.533.10:FF:000003', NULL, NULL, 'Caspase recruitment domain family, member 11', NULL, NULL, NULL, NULL, NULL, 4),
(178869, NULL, 'G3DSA:2.60.120.920:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178870, NULL, 'G3DSA:2.30.29.30:FF:000845', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(178871, NULL, 'G3DSA:3.30.160.60:FF:006108', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178872, NULL, 'G3DSA:1.10.520.10:FF:000047', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(178873, NULL, 'G3DSA:3.40.50.300:FF:004923', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178874, NULL, 'G3DSA:2.40.30.10:FF:000151', NULL, NULL, 'Translation elongation factor EF-G', NULL, NULL, NULL, NULL, NULL, 4),
(178875, NULL, 'G3DSA:3.30.1490.20:FF:000073', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(178876, NULL, 'G3DSA:1.10.1740.140:FF:000001', NULL, NULL, 'ATP-dependent RNA helicase SUPV3L1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(178877, NULL, 'G3DSA:3.30.160.60:FF:000471', NULL, NULL, 'Zinc finger protein AEBP2', NULL, NULL, NULL, NULL, NULL, 4),
(178878, NULL, 'G3DSA:3.30.420.10:FF:000757', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178879, NULL, 'G3DSA:2.40.10.10:FF:000329', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178880, NULL, 'G3DSA:3.30.70.2850:FF:000024', NULL, NULL, 'DNA-directed RNA polymerase I subunit rpa1', NULL, NULL, NULL, NULL, NULL, 4),
(178881, NULL, 'G3DSA:1.10.357.10:FF:000077', NULL, NULL, 'TetR/AcrR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(178882, NULL, 'G3DSA:3.20.20.70:FF:000245', NULL, NULL, 'Bifunctional UMP-synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(178883, NULL, 'G3DSA:3.80.10.10:FF:000606', NULL, NULL, 'F-box and leucine-rich repeat protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(178884, NULL, 'G3DSA:3.40.50.10900:FF:000007', NULL, NULL, 'Proteasome assembly chaperone 2', NULL, NULL, NULL, NULL, NULL, 4),
(178885, NULL, 'G3DSA:1.25.40.90:FF:000011', NULL, NULL, 'ADP-ribosylation factor-binding protein GGA3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(178886, NULL, 'G3DSA:3.30.470.20:FF:000140', NULL, NULL, 'Probable alpha-L-glutamate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(178887, NULL, 'G3DSA:2.60.40.10:FF:001836', NULL, NULL, 'Immunoglobulin heavy constant mu', NULL, NULL, NULL, NULL, NULL, 4),
(178888, NULL, 'G3DSA:3.30.160.60:FF:006159', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178889, NULL, 'G3DSA:4.10.240.10:FF:000042', NULL, NULL, 'Lysine requiring protein', NULL, NULL, NULL, NULL, NULL, 4),
(178890, NULL, 'G3DSA:2.60.40.10:FF:002404', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178891, NULL, 'G3DSA:3.40.50.300:FF:001438', NULL, NULL, 'ATP-binding cassette sub-family F member 3', NULL, NULL, NULL, NULL, NULL, 4),
(178892, NULL, 'G3DSA:2.170.210.10:FF:000004', NULL, NULL, 'XRCC4-like factor-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(178893, NULL, 'G3DSA:3.80.10.10:FF:000314', NULL, NULL, 'centriolin isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(178894, NULL, 'G3DSA:3.30.450.200:FF:000005', NULL, NULL, 'DENN domain-containing protein 5A isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(178895, NULL, 'G3DSA:3.20.20.80:FF:000574', NULL, NULL, 'AFR597Wp', NULL, NULL, NULL, NULL, NULL, 4),
(178896, NULL, 'G3DSA:3.40.50.1950:FF:000004', NULL, NULL, 'Phosphopantothenoylcysteine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(178897, NULL, 'G3DSA:1.10.10.60:FF:001028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178898, NULL, 'G3DSA:3.40.1770.10:FF:000011', NULL, NULL, 'Urocanate hydratase 1', NULL, NULL, NULL, NULL, NULL, 4),
(178899, NULL, 'G3DSA:1.25.40.10:FF:003792', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178900, NULL, 'G3DSA:1.20.5.420:FF:000002', NULL, NULL, 'Small glutamine-rich tetratricopeptide repeat-containing protein alpha', NULL, NULL, NULL, NULL, NULL, 4),
(178901, NULL, 'G3DSA:3.20.20.190:FF:000105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178902, NULL, 'G3DSA:1.10.510.10:FF:000254', NULL, NULL, 'Serine/threonine-protein kinase RIO3', NULL, NULL, NULL, NULL, NULL, 4),
(178903, NULL, 'G3DSA:2.130.10.10:FF:001039', NULL, NULL, 'Polyadenylation factor subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(178904, NULL, 'G3DSA:1.10.10.10:FF:000081', NULL, NULL, 'DeoR/GlpR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(178905, NULL, 'G3DSA:1.10.400.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178906, NULL, 'G3DSA:2.130.10.10:FF:003849', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178907, NULL, 'G3DSA:3.80.10.10:FF:003535', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178908, NULL, 'G3DSA:2.30.29.30:FF:000446', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178909, NULL, 'G3DSA:2.160.20.10:FF:000105', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(178910, NULL, 'G3DSA:3.30.160.60:FF:000319', NULL, NULL, 'myoneurin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(178911, NULL, 'G3DSA:1.25.40.10:FF:004360', NULL, NULL, 'PPR8522', NULL, NULL, NULL, NULL, NULL, 4),
(178912, NULL, 'G3DSA:1.20.1250.20:FF:001498', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178913, NULL, 'G3DSA:2.70.150.10:FF:000282', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(178914, NULL, 'G3DSA:1.50.10.10:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178915, NULL, 'G3DSA:3.30.720.150:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178916, NULL, 'G3DSA:2.60.120.290:FF:000076', NULL, NULL, 'Complement C1r subcomponent like', NULL, NULL, NULL, NULL, NULL, 4),
(178917, NULL, 'G3DSA:4.10.400.10:FF:000133', NULL, NULL, 'LDL receptor related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(178918, NULL, 'G3DSA:3.30.70.330:FF:001066', NULL, NULL, 'U2 small nuclear ribonucleoprotein B', NULL, NULL, NULL, NULL, NULL, 4),
(178919, NULL, 'G3DSA:3.30.230.10:FF:000153', NULL, NULL, 'AGAP005013-PA', NULL, NULL, NULL, NULL, NULL, 4),
(178920, NULL, 'G3DSA:3.30.70.100:FF:000002', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(178921, NULL, 'G3DSA:1.20.5.440:FF:000008', NULL, NULL, 'ATP synthase epsilon chain', NULL, NULL, NULL, NULL, NULL, 4),
(178922, NULL, 'G3DSA:2.60.40.1670:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178923, NULL, 'G3DSA:3.30.1640.30:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178924, NULL, 'G3DSA:3.30.200.20:FF:000654', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178925, NULL, 'G3DSA:1.10.10.10:FF:001946', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178926, NULL, 'G3DSA:3.50.30.20:FF:000005', NULL, NULL, 'Carbamoyl-phosphate synthase small chain', NULL, NULL, NULL, NULL, NULL, 4),
(178927, NULL, 'G3DSA:2.130.10.10:FF:002944', NULL, NULL, 'Dynein intermediate chain 2, ciliary-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(178928, NULL, 'G3DSA:1.20.120.1220:FF:000006', NULL, NULL, 'Conserved membrane protein of uncharacterized function', NULL, NULL, NULL, NULL, NULL, 4),
(178929, NULL, 'G3DSA:3.40.50.12650:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178930, NULL, 'G3DSA:3.30.40.10:FF:001072', NULL, NULL, 'Probable E3 ubiquitin-protein ligase XERICO', NULL, NULL, NULL, NULL, NULL, 4),
(178931, NULL, 'G3DSA:3.40.1170.60:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178932, NULL, 'G3DSA:3.30.70.980:FF:000052', NULL, NULL, 'Probable transcriptional regulatory protein DR_2548', NULL, NULL, NULL, NULL, NULL, 4),
(178933, NULL, 'G3DSA:3.30.70.330:FF:000054', NULL, NULL, 'Cytoplasmic polyadenylation element-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(178934, NULL, 'G3DSA:3.60.10.10:FF:000091', NULL, NULL, 'DNase I-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(178935, NULL, 'G3DSA:2.130.10.10:FF:003164', NULL, NULL, 'Periodic tryptophan protein 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(178936, NULL, 'G3DSA:3.90.550.50:FF:000119', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(178937, NULL, 'G3DSA:2.40.50.140:FF:000444', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(178938, NULL, 'G3DSA:1.20.1560.10:FF:000467', NULL, NULL, 'Putative ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(178939, NULL, 'G3DSA:3.40.850.10:FF:000248', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(178940, NULL, 'G3DSA:2.60.40.10:FF:005277', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178941, NULL, 'G3DSA:2.40.50.140:FF:000152', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(178942, NULL, 'G3DSA:3.90.660.20:FF:000012', NULL, NULL, 'Phytoene desaturase', NULL, NULL, NULL, NULL, NULL, 4),
(178943, NULL, 'G3DSA:2.60.200.20:FF:000269', NULL, NULL, 'Microspherule protein 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(178944, NULL, 'G3DSA:1.10.10.10:FF:000642', NULL, NULL, 'Probable two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(178945, NULL, 'G3DSA:3.60.110.10:FF:000019', NULL, NULL, 'Glutamine-dependent NAD(+) synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(178946, NULL, 'G3DSA:1.10.4160.10:FF:000018', NULL, NULL, 'Cytosine permease', NULL, NULL, NULL, NULL, NULL, 4),
(178947, NULL, 'G3DSA:2.60.120.260:FF:000533', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178948, NULL, 'G3DSA:1.10.10.10:FF:000586', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(178949, NULL, 'G3DSA:1.25.40.20:FF:000248', NULL, NULL, 'Ankyrin repeat and BTB/POZ domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(178950, NULL, 'G3DSA:1.25.40.510:FF:000008', NULL, NULL, 'Nucleoporin GLE1', NULL, NULL, NULL, NULL, NULL, 4),
(178951, NULL, 'G3DSA:3.10.20.90:FF:000387', NULL, NULL, 'Polyubiquitin', NULL, NULL, NULL, NULL, NULL, 4),
(178952, NULL, 'G3DSA:3.40.50.10490:FF:000053', NULL, NULL, 'Glucose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(178953, NULL, 'G3DSA:1.10.510.10:FF:002171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178954, NULL, 'G3DSA:1.20.58.60:FF:000766', NULL, NULL, 'Alpha-actinin A', NULL, NULL, NULL, NULL, NULL, 4),
(178955, NULL, 'G3DSA:3.40.50.300:FF:003563', NULL, NULL, 'GPN-loop GTPase 3', NULL, NULL, NULL, NULL, NULL, 4),
(178956, NULL, 'G3DSA:3.40.30.10:FF:001161', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(178957, NULL, 'G3DSA:3.40.109.10:FF:000032', NULL, NULL, 'Putative NAD(P)H nitroreductase', NULL, NULL, NULL, NULL, NULL, 4),
(178958, NULL, 'G3DSA:1.25.40.20:FF:000304', NULL, NULL, 'Ankyrin repeat and sterile alpha motif domain containing 1A', NULL, NULL, NULL, NULL, NULL, 4),
(178959, NULL, 'G3DSA:2.60.40.150:FF:000019', NULL, NULL, 'Multiple C2 and transmembrane domain-containing protein 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(178960, NULL, 'G3DSA:3.20.20.140:FF:000467', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178961, NULL, 'G3DSA:3.40.50.1820:FF:001612', NULL, NULL, 'Cathepsin A', NULL, NULL, NULL, NULL, NULL, 4),
(178962, NULL, 'G3DSA:1.20.1070.10:FF:001380', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178963, NULL, 'G3DSA:3.30.160.60:FF:004310', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178964, NULL, 'G3DSA:2.160.20.10:FF:000049', NULL, NULL, 'Putative exo-beta-1,3-glucanase', NULL, NULL, NULL, NULL, NULL, 4),
(178965, NULL, 'G3DSA:3.90.180.10:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178966, NULL, 'G3DSA:1.10.3430.10:FF:000051', NULL, NULL, 'Ammonium transporter', NULL, NULL, NULL, NULL, NULL, 4),
(178967, NULL, 'G3DSA:1.25.40.470:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178968, NULL, 'G3DSA:3.40.50.360:FF:000124', NULL, NULL, 'Neuronal nitric oxide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(178969, NULL, 'G3DSA:1.25.40.10:FF:004192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178970, NULL, 'G3DSA:1.20.1250.40:FF:000020', NULL, NULL, 'DNA-directed RNA polymerase III subunit rpc9', NULL, NULL, NULL, NULL, NULL, 4),
(178971, NULL, 'G3DSA:2.40.50.140:FF:000096', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(178972, NULL, 'G3DSA:1.20.1070.10:FF:001627', NULL, NULL, 'Putative olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(178973, NULL, 'G3DSA:2.130.10.10:FF:002888', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178974, NULL, 'G3DSA:3.10.100.10:FF:000154', NULL, NULL, 'C-type lectin domain family 4 member G', NULL, NULL, NULL, NULL, NULL, 4),
(178975, NULL, 'G3DSA:2.60.120.1040:FF:000003', NULL, NULL, 'Zinc finger protein zpr1', NULL, NULL, NULL, NULL, NULL, 4),
(178976, NULL, 'G3DSA:3.30.200.20:FF:000710', NULL, NULL, 'WNK lysine deficient protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(178977, NULL, 'G3DSA:3.10.50.10:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178978, NULL, 'G3DSA:2.30.30.40:FF:000520', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(178979, NULL, 'G3DSA:3.30.9.10:FF:000111', NULL, NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(178980, NULL, 'G3DSA:1.25.10.10:FF:002115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178981, NULL, 'G3DSA:3.30.559.30:FF:000051', NULL, NULL, 'Nonribosomal peptide synthase Pes1', NULL, NULL, NULL, NULL, NULL, 4),
(178982, NULL, 'G3DSA:3.40.50.300:FF:008234', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(178983, NULL, 'G3DSA:3.90.70.10:FF:000121', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(178984, NULL, 'G3DSA:2.40.50.140:FF:000500', NULL, NULL, 'Interferon-activable protein 202', NULL, NULL, NULL, NULL, NULL, 4),
(178985, NULL, 'G3DSA:3.40.50.1440:FF:000138', NULL, NULL, 'Exosome complex exonuclease RRP44 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(178986, NULL, 'G3DSA:1.10.490.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178987, NULL, 'G3DSA:3.40.50.300:FF:003911', NULL, NULL, 'Terminase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(178988, NULL, 'G3DSA:2.115.10.20:FF:000010', NULL, NULL, 'Arabinanase/levansucrase/invertase', NULL, NULL, NULL, NULL, NULL, 4),
(178989, NULL, 'G3DSA:1.10.238.10:FF:000121', NULL, NULL, 'EF-hand calcium-binding domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(178990, NULL, 'G3DSA:3.40.50.12780:FF:000150', NULL, NULL, 'Enniatin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(178991, NULL, 'G3DSA:3.40.50.300:FF:007834', NULL, NULL, 'ClpC-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(178992, NULL, 'G3DSA:1.20.5.190:FF:000181', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178993, NULL, 'G3DSA:1.25.40.20:FF:000647', NULL, NULL, 'BTB/POZ domain and ankyrin repeat-containing protein NH5.2', NULL, NULL, NULL, NULL, NULL, 4),
(178994, NULL, 'G3DSA:2.30.180.10:FF:000135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178995, NULL, 'G3DSA:1.20.58.100:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(178996, NULL, 'G3DSA:3.40.630.30:FF:000423', NULL, NULL, 'uncharacterized protein LOC100176877', NULL, NULL, NULL, NULL, NULL, 4),
(178997, NULL, 'G3DSA:2.60.120.10:FF:000794', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(178998, NULL, 'G3DSA:3.40.50.1000:FF:000181', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(178999, NULL, 'G3DSA:3.30.70.330:FF:001015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179000, NULL, 'G3DSA:3.30.930.10:FF:000279', NULL, NULL, 'Probable serine/threonine-protein kinase ifkC', NULL, NULL, NULL, NULL, NULL, 4),
(179001, NULL, 'G3DSA:1.10.1170.10:FF:000041', NULL, NULL, 'Inhibitor of apoptosis protein 1 and 2, iap1, iap2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(179002, NULL, 'G3DSA:3.30.470.20:FF:000084', NULL, NULL, 'Pyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(179003, NULL, 'G3DSA:1.10.510.10:FF:003132', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179004, NULL, 'G3DSA:1.10.540.10:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179005, NULL, 'G3DSA:2.40.160.210:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179006, NULL, 'G3DSA:3.90.79.10:FF:000202', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(179007, NULL, 'G3DSA:1.25.40.10:FF:004208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179008, NULL, 'G3DSA:2.40.50.140:FF:000101', NULL, NULL, 'Myeloid cell nuclear differentiation antigen', NULL, NULL, NULL, NULL, NULL, 4),
(179009, NULL, 'G3DSA:1.10.1070.11:FF:000102', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(179010, NULL, 'G3DSA:3.40.50.1260:FF:000056', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(179011, NULL, 'G3DSA:1.20.140.40:FF:000064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179012, NULL, 'G3DSA:3.30.1600.10:FF:000012', NULL, NULL, 'NAD-dependent protein deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(179013, NULL, 'G3DSA:3.40.630.20:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179014, NULL, 'G3DSA:3.30.479.10:FF:000016', NULL, NULL, 'Queuosine biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(179015, NULL, 'G3DSA:1.10.510.10:FF:004144', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179016, NULL, 'G3DSA:3.90.1750.10:FF:000037', NULL, NULL, 'Apoptosis resistant E3 ubiquitin protein ligase 1', NULL, NULL, NULL, NULL, NULL, 4),
(179017, NULL, 'G3DSA:2.60.40.60:FF:000424', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179018, NULL, 'G3DSA:3.30.565.10:FF:000110', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(179019, NULL, 'G3DSA:3.10.129.10:FF:000130', NULL, NULL, 'Probable 3-hydroxyacyl-thioester dehydratase HtdX', NULL, NULL, NULL, NULL, NULL, 4),
(179020, NULL, 'G3DSA:2.40.70.10:FF:000541', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179021, NULL, 'G3DSA:3.30.160.60:FF:004361', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179022, NULL, 'G3DSA:3.40.30.10:FF:000710', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179023, NULL, 'G3DSA:3.30.750.24:FF:000104', NULL, NULL, 'Sulfate transporter N-terminal domain with GLY motif/Sulfate transporter family', NULL, NULL, NULL, NULL, NULL, 4),
(179024, NULL, 'G3DSA:1.10.510.10:FF:003868', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179025, NULL, 'G3DSA:3.40.190.10:FF:000220', NULL, NULL, 'Phosphate binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(179026, NULL, 'G3DSA:1.25.40.10:FF:000830', NULL, NULL, 'Tetratricopeptide repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(179027, NULL, 'G3DSA:2.60.40.150:FF:000171', NULL, NULL, 'Phosphatidylinositol 3-kinase VPS34', NULL, NULL, NULL, NULL, NULL, 4),
(179028, NULL, 'G3DSA:3.65.10.20:FF:000015', NULL, NULL, 'RNA 3''-terminal phosphate cyclase, putative (AFU_orthologue AFUA_5G07640)', NULL, NULL, NULL, NULL, NULL, 4),
(179029, NULL, 'G3DSA:1.10.1200.270:FF:000003', NULL, NULL, 'Salicylate/benzoate carboxyl methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(179030, NULL, 'G3DSA:3.40.50.300:FF:003962', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(179031, NULL, 'G3DSA:3.10.490.10:FF:000013', NULL, NULL, 'Gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(179032, NULL, 'G3DSA:2.130.10.80:FF:000003', NULL, NULL, 'cDNA FLJ40400 fis, clone TESTI2037103', NULL, NULL, NULL, NULL, NULL, 4),
(179033, NULL, 'G3DSA:2.60.200.20:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179034, NULL, 'G3DSA:3.10.20.370:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179035, NULL, 'G3DSA:3.40.720.10:FF:000244', NULL, NULL, 'Arylsulfatase H', NULL, NULL, NULL, NULL, NULL, 4),
(179036, NULL, 'G3DSA:1.10.10.250:FF:000002', NULL, NULL, '60S ribosomal protein L12', NULL, NULL, NULL, NULL, NULL, 4),
(179037, NULL, 'G3DSA:3.30.750.80:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179038, NULL, 'G3DSA:1.10.150.240:FF:000085', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(179039, NULL, 'G3DSA:1.10.8.10:FF:000219', NULL, NULL, 'baculoviral IAP repeat-containing protein 3-like', NULL, NULL, NULL, NULL, NULL, 4),
(179040, NULL, 'G3DSA:1.25.40.10:FF:000026', NULL, NULL, 'Interferon-induced protein with tetratricopeptide repeats 5', NULL, NULL, NULL, NULL, NULL, 4),
(179041, NULL, 'G3DSA:3.40.50.2000:FF:000997', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179042, NULL, 'G3DSA:1.50.40.10:FF:000350', NULL, NULL, 'Phosphate carrier protein, mitochondrial-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(179043, NULL, 'G3DSA:1.20.1730.10:FF:000003', NULL, NULL, 'Sodium/pantothenate symporter', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(179044, NULL, 'G3DSA:1.10.510.10:FF:002856', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179045, NULL, 'G3DSA:2.30.29.30:FF:000789', NULL, NULL, 'ADP ribosylation factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(179046, NULL, 'G3DSA:3.40.50.300:FF:007273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179047, NULL, 'G3DSA:3.30.1330.30:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179048, NULL, 'G3DSA:1.20.1070.10:FF:001228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179049, NULL, 'G3DSA:3.30.60.30:FF:000117', NULL, NULL, 'GH09228p2', NULL, NULL, NULL, NULL, NULL, 4),
(179050, NULL, 'G3DSA:3.30.497.10:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179051, NULL, 'G3DSA:3.40.50.1100:FF:000042', NULL, NULL, 'Bifunctional D-cysteine desulfhydrase/1-aminocyclopropane-1-carboxylate deaminase mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(179052, NULL, 'G3DSA:2.130.10.10:FF:001876', NULL, NULL, 'Si:dkey-17m8.1', NULL, NULL, NULL, NULL, NULL, 4),
(179053, NULL, 'G3DSA:3.30.420.40:FF:000648', NULL, NULL, 'Actin-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(179054, NULL, 'G3DSA:1.25.10.10:FF:001098', NULL, NULL, 'TELO2-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(179055, NULL, 'G3DSA:3.10.50.40:FF:000115', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(179056, NULL, 'G3DSA:4.10.800.20:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179057, NULL, 'G3DSA:1.10.555.10:FF:000172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179058, NULL, 'G3DSA:3.30.1370.10:FF:000033', NULL, NULL, 'vigilin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(179059, NULL, 'G3DSA:3.40.50.920:FF:000039', NULL, NULL, 'Transketolase', NULL, NULL, NULL, NULL, NULL, 4),
(179060, NULL, 'G3DSA:2.60.40.1180:FF:000163', NULL, NULL, 'Glycoside hydrolase, family 29, subgroup', NULL, NULL, NULL, NULL, NULL, 4),
(179061, NULL, 'G3DSA:2.30.29.30:FF:001227', NULL, NULL, 'Si:ch211-248g20.5', NULL, NULL, NULL, NULL, NULL, 4),
(179062, NULL, 'G3DSA:2.60.40.10:FF:001331', NULL, NULL, 'receptor-type tyrosine-protein phosphatase beta isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(179063, NULL, 'G3DSA:3.90.190.20:FF:000032', NULL, NULL, 'Bifunctional folylpolyglutamate synthase/dihydrofolate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(179064, NULL, 'G3DSA:3.40.50.300:FF:006492', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(179065, NULL, 'G3DSA:3.40.50.1820:FF:001213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179066, NULL, 'G3DSA:3.40.1110.10:FF:000377', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179067, NULL, 'G3DSA:1.20.5.110:FF:000084', NULL, NULL, 'Syntaxin, Qa-SNARE family', NULL, NULL, NULL, NULL, NULL, 4),
(179068, NULL, 'G3DSA:3.40.50.1580:FF:000039', NULL, NULL, 'S-methyl-5''-thioadenosine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(179069, NULL, 'G3DSA:3.30.1330.40:FF:000034', NULL, NULL, 'RidA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(179070, NULL, 'G3DSA:3.30.780.10:FF:000014', NULL, NULL, 'Translation machinery-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(179071, NULL, 'G3DSA:1.10.238.10:FF:000806', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(179072, NULL, 'G3DSA:3.40.50.11980:FF:000016', NULL, NULL, 'PRP38 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(179073, NULL, 'G3DSA:3.60.21.10:FF:000060', NULL, NULL, 'Acid sphingomyelinase family phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(179074, NULL, 'G3DSA:3.40.120.10:FF:000002', NULL, NULL, 'Phosphoglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(179075, NULL, 'G3DSA:1.20.120.1750:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179076, NULL, 'G3DSA:1.10.1450.10:FF:000023', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(179077, NULL, 'G3DSA:2.60.120.200:FF:000594', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(179078, NULL, 'G3DSA:3.10.20.90:FF:000044', NULL, NULL, 'Ubiquitin-fold modifier 1', NULL, NULL, NULL, NULL, NULL, 4),
(179079, NULL, 'G3DSA:2.10.50.10:FF:000013', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 16', NULL, NULL, NULL, NULL, NULL, 4),
(179080, NULL, 'G3DSA:1.20.5.110:FF:000140', NULL, NULL, 'Syntaxin 13', NULL, NULL, NULL, NULL, NULL, 4),
(179081, NULL, 'G3DSA:1.20.58.390:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179082, NULL, 'G3DSA:4.10.60.10:FF:000234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179083, NULL, 'G3DSA:2.60.40.10:FF:001275', NULL, NULL, 'Immunoglobulin superfamily DCC subclass member 4', NULL, NULL, NULL, NULL, NULL, 4),
(179084, NULL, 'G3DSA:3.40.630.30:FF:000075', NULL, NULL, 'Glycine N-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(179085, NULL, 'G3DSA:1.10.220.10:FF:000007', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(179086, NULL, 'G3DSA:1.20.1270.60:FF:000297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179087, NULL, 'G3DSA:1.20.120.330:FF:000025', NULL, NULL, 'Mannitol operon repressor', NULL, NULL, NULL, NULL, NULL, 4),
(179088, NULL, 'G3DSA:3.90.70.10:FF:000626', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(179089, NULL, 'G3DSA:3.20.20.80:FF:000810', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(179090, NULL, 'G3DSA:1.20.1250.20:FF:000930', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179091, NULL, 'G3DSA:1.10.40.60:FF:000001', NULL, NULL, 'Type II secretion system protein K', NULL, NULL, NULL, NULL, NULL, 4),
(179092, NULL, 'G3DSA:2.20.28.290:FF:000003', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(179093, NULL, 'G3DSA:3.40.640.10:FF:000530', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179094, NULL, 'G3DSA:2.60.120.920:FF:000192', NULL, NULL, 'Bloodthirsty-related gene family, member 1', NULL, NULL, NULL, NULL, NULL, 4),
(179095, NULL, 'G3DSA:2.130.10.10:FF:003057', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(179096, NULL, 'G3DSA:3.40.720.10:FF:000188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179097, NULL, 'G3DSA:1.20.58.60:FF:000553', NULL, NULL, 'Spectrin, beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(179098, NULL, 'G3DSA:3.40.50.10860:FF:000029', NULL, NULL, 'Shikimate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(179099, NULL, 'G3DSA:1.25.10.10:FF:000710', NULL, NULL, 'Nuclear_condensing_complex_subunits_-_C-term_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(179100, NULL, 'G3DSA:1.20.1250.20:FF:001442', NULL, NULL, 'sodium-dependent phosphate transport protein 3 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(179101, NULL, 'G3DSA:3.10.290.10:FF:000083', NULL, NULL, 'Probable tyrosine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(179102, NULL, 'G3DSA:2.60.40.60:FF:000137', NULL, NULL, 'FAT atypical cadherin 4', NULL, NULL, NULL, NULL, NULL, 4),
(179103, NULL, 'G3DSA:2.130.10.10:FF:003113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179104, NULL, 'G3DSA:3.30.1490.80:FF:000012', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(179105, NULL, 'G3DSA:1.10.238.10:FF:000913', NULL, NULL, 'WD repeat domain 66', NULL, NULL, NULL, NULL, NULL, 4),
(179106, NULL, 'G3DSA:2.60.40.340:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179107, NULL, 'G3DSA:1.25.40.20:FF:001103', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(179108, NULL, 'G3DSA:3.30.60.20:FF:000019', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(179109, NULL, 'G3DSA:1.20.58.530:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179110, NULL, 'G3DSA:3.40.50.150:FF:000735', NULL, NULL, 'Fmu (Sun) domain protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(179111, NULL, 'G3DSA:3.30.40.10:FF:002089', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(179112, NULL, 'G3DSA:1.25.70.10:FF:000034', NULL, NULL, 'Os11g0206300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(179113, NULL, 'G3DSA:1.10.418.10:FF:000051', NULL, NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(179114, NULL, 'G3DSA:2.40.50.140:FF:000949', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179115, NULL, 'G3DSA:3.10.120.10:FF:000037', NULL, NULL, 'GD22062', NULL, NULL, NULL, NULL, NULL, 4),
(179116, NULL, 'G3DSA:3.80.10.10:FF:004024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179117, NULL, 'G3DSA:2.60.40.10:FF:005546', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179118, NULL, 'G3DSA:2.20.25.10:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179119, NULL, 'G3DSA:2.70.170.10:FF:000221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179120, NULL, 'G3DSA:1.20.1070.10:FF:000559', NULL, NULL, 'tachykinin-like peptides receptor 99D', NULL, NULL, NULL, NULL, NULL, 4),
(179121, NULL, 'G3DSA:2.70.170.10:FF:000165', NULL, NULL, 'Protein CBR-ACR-8', NULL, NULL, NULL, NULL, NULL, 4),
(179122, NULL, 'G3DSA:3.40.50.300:FF:000764', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(179123, NULL, 'G3DSA:3.40.1160.10:FF:000037', NULL, NULL, 'Acetylglutamate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(179124, NULL, 'G3DSA:3.10.310.40:FF:000009', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(179125, NULL, 'G3DSA:3.10.590.10:FF:000009', NULL, NULL, 'EVE domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(179126, NULL, 'G3DSA:1.25.40.10:FF:000206', NULL, NULL, '43 kDa receptor-associated protein of the synapse', NULL, NULL, NULL, NULL, NULL, 4),
(179127, NULL, 'G3DSA:1.10.287.130:FF:000040', NULL, NULL, 'PAS domain-containing sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(179128, NULL, 'G3DSA:3.90.1150.10:FF:000183', NULL, NULL, 'Transcriptional regulator, GntR family', NULL, NULL, NULL, NULL, NULL, 4),
(179129, NULL, 'G3DSA:3.40.50.300:FF:004979', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179130, NULL, 'G3DSA:1.25.40.180:FF:000196', NULL, NULL, 'Nuclear cap-binding protein subunit 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(179131, NULL, 'G3DSA:3.30.70.2450:FF:000005', NULL, NULL, '2-polyprenyl-6-methoxyphenol hydroxylase and related FAD-dependent oxidoreductases', NULL, NULL, NULL, NULL, NULL, 4),
(179132, NULL, 'G3DSA:1.25.40.10:FF:005265', NULL, NULL, 'Heat shock protein 70 (HSP70)-interacting protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(179133, NULL, 'G3DSA:3.40.50.1260:FF:000005', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(179134, NULL, 'G3DSA:3.30.70.1320:FF:000003', NULL, NULL, 'Multidrug resistance protein MdtC', NULL, NULL, NULL, NULL, NULL, 4),
(179135, NULL, 'G3DSA:1.20.1300.10:FF:000033', NULL, NULL, 'Succinate dehydrogenase subunit b560', NULL, NULL, NULL, NULL, NULL, 4),
(179136, NULL, 'G3DSA:1.20.120.1080:FF:000037', NULL, NULL, 'ATP-dependent RNA helicase DHX33', NULL, NULL, NULL, NULL, NULL, 4),
(179137, NULL, 'G3DSA:2.60.40.10:FF:002528', NULL, NULL, 'Immunoglobulin heavy variable 1-49', NULL, NULL, NULL, NULL, NULL, 4),
(179138, NULL, 'G3DSA:1.25.40.10:FF:002336', NULL, NULL, 'General transcriptional corepressor CYC8', NULL, NULL, NULL, NULL, NULL, 4),
(179139, NULL, 'G3DSA:3.40.570.10:FF:000030', NULL, NULL, 'DNA/RNA non-specific endonuclease-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(179140, NULL, 'G3DSA:2.170.120.40:FF:000012', NULL, NULL, 'Diadenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(179141, NULL, 'G3DSA:1.10.30.10:FF:000020', NULL, NULL, 'HMG box-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(179142, NULL, 'G3DSA:3.40.930.10:FF:000013', NULL, NULL, 'Solute carrier family 4 member 11', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(179143, NULL, 'G3DSA:3.40.50.1820:FF:000544', NULL, NULL, 'WGS project CABT00000000 data, contig 2.28', NULL, NULL, NULL, NULL, NULL, 4),
(179144, NULL, 'G3DSA:1.20.970.10:FF:000022', NULL, NULL, 'Anthranilate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(179145, NULL, 'G3DSA:2.60.120.260:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179146, NULL, 'G3DSA:3.40.50.2300:FF:000817', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179147, NULL, 'G3DSA:3.30.160.60:FF:001668', NULL, NULL, 'transcriptional repressor CTCF', NULL, NULL, NULL, NULL, NULL, 4),
(179148, NULL, 'G3DSA:1.10.357.150:FF:000012', NULL, NULL, 'AFR652Wp', NULL, NULL, NULL, NULL, NULL, 4),
(179149, NULL, 'G3DSA:3.40.50.300:FF:008526', NULL, NULL, 'DEAH (Asp-Glu-Ala-His) box polypeptide 40', NULL, NULL, NULL, NULL, NULL, 4),
(179150, NULL, 'G3DSA:3.40.50.300:FF:001545', NULL, NULL, 'DEAD/DEAH box helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(179151, NULL, 'G3DSA:1.10.246.20:FF:000002', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 15', NULL, NULL, NULL, NULL, NULL, 4),
(179152, NULL, 'G3DSA:2.60.40.10:FF:002635', NULL, NULL, 'Protein-tyrosine-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(179153, NULL, 'G3DSA:3.80.10.10:FF:003187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179154, NULL, 'G3DSA:2.60.120.320:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179155, NULL, 'G3DSA:2.40.50.140:FF:000332', NULL, NULL, 'Primosomal replication protein N', NULL, NULL, NULL, NULL, NULL, 4),
(179156, NULL, 'G3DSA:3.40.50.300:FF:008402', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179157, NULL, 'G3DSA:3.40.50.1000:FF:000686', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179158, NULL, 'G3DSA:3.30.40.10:FF:001364', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(179159, NULL, 'G3DSA:2.60.40.10:FF:003309', NULL, NULL, 'Myosin-light-chain kinase', NULL, NULL, NULL, NULL, NULL, 4),
(179160, NULL, 'G3DSA:3.40.50.300:FF:004131', NULL, NULL, 'ATP-dependent RNA helicase DHX34', NULL, NULL, NULL, NULL, NULL, 4),
(179161, NULL, 'G3DSA:3.30.40.10:FF:000964', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179162, NULL, 'G3DSA:3.30.9.10:FF:000162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179163, NULL, 'G3DSA:3.20.20.70:FF:000476', NULL, NULL, 'Glutamate synthase 1 [NADH] chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(179164, NULL, 'G3DSA:3.20.20.70:FF:000532', NULL, NULL, 'Putative imidazole glycerol phosphate synthase subunit hisF2', NULL, NULL, NULL, NULL, NULL, 4),
(179165, NULL, 'G3DSA:3.90.550.10:FF:000181', NULL, NULL, 'Gastricsin', NULL, NULL, NULL, NULL, NULL, 4),
(179166, NULL, 'G3DSA:3.10.450.10:FF:000067', NULL, NULL, 'Cystatin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(179167, NULL, 'G3DSA:1.10.472.140:FF:000010', NULL, NULL, 'AGAP006477-PA', NULL, NULL, NULL, NULL, NULL, 4),
(179168, NULL, 'G3DSA:2.60.40.2690:FF:000008', NULL, NULL, 'Pre-mrna splicing factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(179169, NULL, 'G3DSA:3.30.70.330:FF:001919', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179170, NULL, 'G3DSA:1.20.920.10:FF:000199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179171, NULL, 'G3DSA:1.10.10.10:FF:001367', NULL, NULL, 'Apoptotic protease-activating factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(179172, NULL, 'G3DSA:3.40.50.300:FF:006216', NULL, NULL, 'GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(179173, NULL, 'G3DSA:1.10.630.10:FF:000089', NULL, NULL, 'Cytochrome P450 720B1 family', NULL, NULL, NULL, NULL, NULL, 4),
(179174, NULL, 'G3DSA:3.90.1200.10:FF:000069', NULL, NULL, 'Fructosamine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(179175, NULL, 'G3DSA:2.60.120.260:FF:000241', NULL, NULL, 'Peptidase, M23 family', NULL, NULL, NULL, NULL, NULL, 4),
(179176, NULL, 'G3DSA:2.30.29.30:FF:001334', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(179177, NULL, 'G3DSA:2.40.30.10:FF:000382', NULL, NULL, 'Translation elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(179178, NULL, 'G3DSA:1.25.40.10:FF:005321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179179, NULL, 'G3DSA:2.130.10.10:FF:005474', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179180, NULL, 'G3DSA:1.20.920.10:FF:000075', NULL, NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(179181, NULL, 'G3DSA:3.40.30.10:FF:000997', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179182, NULL, 'G3DSA:3.30.160.60:FF:006339', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179183, NULL, 'G3DSA:1.25.10.10:FF:002508', NULL, NULL, 'Condensin subunit', NULL, NULL, NULL, NULL, NULL, 4),
(179184, NULL, 'G3DSA:1.10.287.980:FF:000002', NULL, NULL, 'Cytochrome b6-f complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(179185, NULL, 'G3DSA:2.130.10.10:FF:005294', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179186, NULL, 'G3DSA:3.30.930.10:FF:000335', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179187, NULL, 'G3DSA:2.130.10.10:FF:001983', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179188, NULL, 'G3DSA:3.40.50.1000:FF:000630', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179189, NULL, 'G3DSA:3.30.160.60:FF:001488', NULL, NULL, 'Krueppel-like factor 15', NULL, NULL, NULL, NULL, NULL, 4),
(179190, NULL, 'G3DSA:3.30.40.10:FF:000015', NULL, NULL, 'E3 ubiquitin-protein ligase CBL', NULL, NULL, NULL, NULL, NULL, 4),
(179191, NULL, 'G3DSA:2.30.30.490:FF:000070', NULL, NULL, 'RSC complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(179192, NULL, 'G3DSA:3.40.50.300:FF:002894', NULL, NULL, 'AIG1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(179193, NULL, 'G3DSA:3.40.1810.10:FF:000003', NULL, NULL, 'MADS-box transcription factor MADS-MC', NULL, NULL, NULL, NULL, NULL, 4),
(179194, NULL, 'G3DSA:3.30.420.10:FF:000364', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179195, NULL, 'G3DSA:3.80.10.10:FF:002787', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179196, NULL, 'G3DSA:3.30.160.60:FF:005939', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179197, NULL, 'G3DSA:1.10.287.110:FF:000450', NULL, NULL, 'DnaJ domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(179198, NULL, 'G3DSA:3.40.50.300:FF:001489', NULL, NULL, 'Adenylate kinase 7', NULL, NULL, NULL, NULL, NULL, 4),
(179199, NULL, 'G3DSA:1.10.630.10:FF:000706', NULL, NULL, 'Cytochrome P450, family 4, subfamily a, polypeptide 31', NULL, NULL, NULL, NULL, NULL, 4),
(179200, NULL, 'G3DSA:1.20.1070.10:FF:000379', NULL, NULL, 'prostaglandin D2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(179201, NULL, 'G3DSA:3.30.1460.50:FF:000024', NULL, NULL, 'Ubiquitin-like-conjugating enzyme ATG10', NULL, NULL, NULL, NULL, NULL, 4),
(179202, NULL, 'G3DSA:3.40.50.12780:FF:000094', NULL, NULL, 'Acyl-CoA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(179203, NULL, 'G3DSA:3.40.50.1820:FF:000488', NULL, NULL, 'Enterochelin esterase', NULL, NULL, NULL, NULL, NULL, 4),
(179204, NULL, 'G3DSA:2.60.40.10:FF:006058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179205, NULL, 'G3DSA:3.10.105.10:FF:000119', NULL, NULL, 'Oligopeptide ABC transporter, solute-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(179206, NULL, 'G3DSA:2.80.10.50:FF:000137', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(179207, NULL, 'G3DSA:2.60.40.10:FF:002680', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179208, NULL, 'G3DSA:3.20.20.120:FF:000017', NULL, NULL, 'Dipeptide epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(179209, NULL, 'G3DSA:3.40.50.150:FF:000679', NULL, NULL, 'Methyltransferase GliN', NULL, NULL, NULL, NULL, NULL, 4),
(179210, NULL, 'G3DSA:3.30.860.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(179211, NULL, 'G3DSA:3.40.630.30:FF:000131', NULL, NULL, 'Acetyltransferase, GNAT family', NULL, NULL, NULL, NULL, NULL, 4),
(179212, NULL, 'G3DSA:1.10.2000.10:FF:000001', NULL, NULL, 'secreted frizzled-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(179213, NULL, 'G3DSA:2.40.10.10:FF:000037', NULL, NULL, 'Complement C1r subcomponent', NULL, NULL, NULL, NULL, NULL, 4),
(179214, NULL, 'G3DSA:1.25.40.90:FF:000067', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(179215, NULL, 'G3DSA:3.30.70.3030:FF:000022', NULL, NULL, 'Nucleolar protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(179216, NULL, 'G3DSA:3.30.450.20:FF:000369', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(179217, NULL, 'G3DSA:3.90.20.20:FF:000008', NULL, NULL, 'Protein GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(179218, NULL, 'G3DSA:3.60.20.40:FF:000021', NULL, NULL, 'Putative inactive glutathione hydrolase 4', NULL, NULL, NULL, NULL, NULL, 4),
(179219, NULL, 'G3DSA:3.50.50.60:FF:001226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179220, NULL, 'G3DSA:2.130.10.10:FF:002601', NULL, NULL, 'Transcription initiation factor TFIID subunit taf73', NULL, NULL, NULL, NULL, NULL, 4),
(179221, NULL, 'G3DSA:1.10.10.10:FF:001311', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(179222, NULL, 'G3DSA:1.25.40.20:FF:000939', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179223, NULL, 'G3DSA:3.40.50.720:FF:000479', NULL, NULL, '4-hydroxy-tetrahydrodipicolinate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(179224, NULL, 'G3DSA:1.20.1250.20:FF:002167', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(179225, NULL, 'G3DSA:1.10.510.10:FF:000726', NULL, NULL, 'Calcium-dependent protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(179226, NULL, 'G3DSA:3.30.40.10:FF:002201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179227, NULL, 'G3DSA:3.40.30.170:FF:000001', NULL, NULL, 'Methionine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(179228, NULL, 'G3DSA:3.20.20.370:FF:000007', NULL, NULL, 'Poly-beta-1,6-N-acetyl-D-glucosamine N-deacetylase PgaB', NULL, NULL, NULL, NULL, NULL, 4),
(179229, NULL, 'G3DSA:3.50.80.10:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179230, NULL, 'G3DSA:1.10.10.160:FF:000020', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(179231, NULL, 'G3DSA:3.10.20.90:FF:000100', NULL, NULL, 'Autophagy related 5', NULL, NULL, NULL, NULL, NULL, 4),
(179232, NULL, 'G3DSA:1.25.40.10:FF:000318', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(179233, NULL, 'G3DSA:1.25.40.1040:FF:000024', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(179234, NULL, 'G3DSA:3.30.420.110:FF:000057', NULL, NULL, 'DNA mismatch repair protein MutS 1', NULL, NULL, NULL, NULL, NULL, 4),
(179235, NULL, 'G3DSA:3.30.420.10:FF:000488', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179236, NULL, 'G3DSA:3.30.540.30:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179237, NULL, 'G3DSA:1.10.287.70:FF:000752', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179238, NULL, 'G3DSA:3.90.700.10:FF:000007', NULL, NULL, 'NADH-dependent fumarate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(179239, NULL, 'G3DSA:2.60.40.1170:FF:000103', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179240, NULL, 'G3DSA:1.10.510.10:FF:002963', NULL, NULL, 'Mitogen-activated protein kinase kinase 9', NULL, NULL, NULL, NULL, NULL, 4),
(179241, NULL, 'G3DSA:3.20.20.100:FF:000011', NULL, NULL, 'Aldo/keto reductase', NULL, NULL, NULL, NULL, NULL, 4),
(179242, NULL, 'G3DSA:2.60.220.50:FF:000088', NULL, NULL, 'Adhesion G protein-coupled receptor L2', NULL, NULL, NULL, NULL, NULL, 4),
(179243, NULL, 'G3DSA:1.25.40.70:FF:000061', NULL, NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(179244, NULL, 'G3DSA:2.60.260.20:FF:000161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179245, NULL, 'G3DSA:1.10.238.10:FF:000065', NULL, NULL, 'calpain-3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(179246, NULL, 'G3DSA:1.10.510.10:FF:004037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179247, NULL, 'G3DSA:3.30.900.10:FF:000002', NULL, NULL, 'Mitotic spindle assembly checkpoint protein MAD2A', NULL, NULL, NULL, NULL, NULL, 4),
(179248, NULL, 'G3DSA:3.30.230.10:FF:000041', NULL, NULL, '37S ribosomal protein S5', NULL, NULL, NULL, NULL, NULL, 4),
(179249, NULL, 'G3DSA:2.60.120.330:FF:000234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179250, NULL, 'G3DSA:3.30.160.60:FF:003854', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179251, NULL, 'G3DSA:3.90.180.10:FF:000146', NULL, NULL, 'L-idonate 5-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(179252, NULL, 'G3DSA:3.40.640.10:FF:000474', NULL, NULL, 'Serine hydroxymethyltransferase 4', NULL, NULL, NULL, NULL, NULL, 4),
(179253, NULL, 'G3DSA:3.20.20.140:FF:000175', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(179254, NULL, 'G3DSA:3.20.20.80:FF:000754', NULL, NULL, 'Putative chitinase 3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(179255, NULL, 'G3DSA:1.10.730.10:FF:000130', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(179256, NULL, 'G3DSA:1.10.940.10:FF:000011', NULL, NULL, 'Transcription antitermination protein NusB', NULL, NULL, NULL, NULL, NULL, 4),
(179257, NULL, 'G3DSA:3.30.160.60:FF:000943', NULL, NULL, 'probable E3 ubiquitin-protein ligase TRIM8', NULL, NULL, NULL, NULL, NULL, 4),
(179258, NULL, 'G3DSA:1.20.58.60:FF:000497', NULL, NULL, 'Guanine nucleotide exchange factor UNC-73A', NULL, NULL, NULL, NULL, NULL, 4),
(179259, NULL, 'G3DSA:1.20.930.10:FF:000025', NULL, NULL, 'BAH and TFIIS domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(179260, NULL, 'G3DSA:1.10.287.660:FF:000024', NULL, NULL, 'YALI0F18524p', NULL, NULL, NULL, NULL, NULL, 4),
(179261, NULL, 'G3DSA:2.130.10.10:FF:002040', NULL, NULL, 'WD domain, G-beta repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(179262, NULL, 'G3DSA:3.50.50.60:FF:000445', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179263, NULL, 'G3DSA:1.10.287.370:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179264, NULL, 'G3DSA:3.40.50.1820:FF:001325', NULL, NULL, 'Homoserine O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(179265, NULL, 'G3DSA:2.10.110.30:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179266, NULL, 'G3DSA:3.40.50.2000:FF:000609', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(179267, NULL, 'G3DSA:1.20.58.890:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179268, NULL, 'G3DSA:2.60.220.50:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179269, NULL, 'G3DSA:1.10.510.10:FF:001507', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(179270, NULL, 'G3DSA:1.20.58.390:FF:000178', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(179271, NULL, 'G3DSA:3.40.1190.10:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179272, NULL, 'G3DSA:3.30.160.60:FF:000420', NULL, NULL, 'Putative transcriptional repressor ctcf', NULL, NULL, NULL, NULL, NULL, 4),
(179273, NULL, 'G3DSA:3.40.50.410:FF:000162', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(179274, NULL, 'G3DSA:1.20.1250.20:FF:001262', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(179275, NULL, 'G3DSA:2.60.120.200:FF:000774', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179276, NULL, 'G3DSA:3.30.497.10:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179277, NULL, 'G3DSA:3.50.50.60:FF:000501', NULL, NULL, 'FI13301p', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(179278, NULL, 'G3DSA:3.20.180.20:FF:000030', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(179279, NULL, 'G3DSA:3.10.20.90:FF:000156', NULL, NULL, 'Phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(179280, NULL, 'G3DSA:1.25.10.10:FF:001042', NULL, NULL, 'Ser/Thr phosphatase 2A, 65kDa reg sub A', NULL, NULL, NULL, NULL, NULL, 4),
(179281, NULL, 'G3DSA:1.20.144.10:FF:000069', NULL, NULL, 'Phosphatidic acid phosphatase type 2/haloperoxidase', NULL, NULL, NULL, NULL, NULL, 4),
(179282, NULL, 'G3DSA:1.10.150.50:FF:000092', NULL, NULL, 'Liprin-beta', NULL, NULL, NULL, NULL, NULL, 4),
(179283, NULL, 'G3DSA:3.40.50.1820:FF:001269', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(179284, NULL, 'G3DSA:2.40.160.50:FF:000020', NULL, NULL, 'Patatin-like protein, PlpD', NULL, NULL, NULL, NULL, NULL, 4),
(179285, NULL, 'G3DSA:1.20.1560.10:FF:000754', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179286, NULL, 'G3DSA:1.10.238.10:FF:000626', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(179287, NULL, 'G3DSA:2.40.100.10:FF:000038', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(179288, NULL, 'G3DSA:2.60.40.790:FF:000183', NULL, NULL, 'Small heat shock protein HSP16.5', NULL, NULL, NULL, NULL, NULL, 4),
(179289, NULL, 'G3DSA:3.30.70.330:FF:000846', NULL, NULL, 'zinc finger CCHC-type and RNA-binding motif-containing protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(179290, NULL, 'G3DSA:1.10.287.1060:FF:000016', NULL, NULL, 'ESAT-6-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(179291, NULL, 'G3DSA:2.60.210.10:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179292, NULL, 'G3DSA:3.40.50.1220:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179293, NULL, 'G3DSA:2.130.10.10:FF:004417', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(179294, NULL, 'G3DSA:2.30.29.30:FF:000210', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(179295, NULL, 'G3DSA:2.40.170.20:FF:000085', NULL, NULL, 'SusC/RagA family TonB-linked outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(179296, NULL, 'G3DSA:1.10.10.1050:FF:000017', NULL, NULL, 'Hydrolase, NUDIX family protein', NULL, NULL, NULL, NULL, NULL, 4),
(179297, NULL, 'G3DSA:3.40.50.300:FF:000241', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(179298, NULL, 'G3DSA:2.40.50.90:FF:000131', NULL, NULL, 'Transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(179299, NULL, 'G3DSA:3.40.50.300:FF:001146', NULL, NULL, 'DNA-binding protein SMUBP-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(179300, NULL, 'G3DSA:1.10.533.10:FF:000239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179301, NULL, 'G3DSA:2.60.40.10:FF:005726', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179302, NULL, 'G3DSA:3.40.630.30:FF:000187', NULL, NULL, 'Ribosomal-protein-serine acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(179303, NULL, 'G3DSA:2.102.10.10:FF:000006', NULL, NULL, 'Menaquinol-cytochrome c reductase, iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4),
(179304, NULL, 'G3DSA:2.60.40.10:FF:006002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179305, NULL, 'G3DSA:1.20.58.390:FF:000234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179306, NULL, 'G3DSA:3.40.50.1460:FF:000060', NULL, NULL, 'Zgc:171731', NULL, NULL, NULL, NULL, NULL, 4),
(179307, NULL, 'G3DSA:1.10.287.70:FF:000696', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(179308, NULL, 'G3DSA:6.10.250.3260:FF:000001', NULL, NULL, '60S ribosomal protein L21', NULL, NULL, NULL, NULL, NULL, 4),
(179309, NULL, 'G3DSA:3.40.50.1470:FF:000006', NULL, NULL, 'Peptidyl-tRNA hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(179310, NULL, 'G3DSA:3.30.830.10:FF:000007', NULL, NULL, 'Insulin-degrading enzyme', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(179311, NULL, 'G3DSA:1.10.1450.10:FF:000147', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(179312, NULL, 'G3DSA:3.30.230.10:FF:000097', NULL, NULL, 'Phosphomevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(179313, NULL, 'G3DSA:1.25.10.10:FF:000822', NULL, NULL, 'protein CIP2A isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(179314, NULL, 'G3DSA:1.20.1730.10:FF:000059', NULL, NULL, 'Sodium/glucose cotransporter 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(179315, NULL, 'G3DSA:3.30.70.330:FF:001122', NULL, NULL, 'SUPpressor', NULL, NULL, NULL, NULL, NULL, 4),
(179316, NULL, 'G3DSA:3.30.1740.20:FF:000014', NULL, NULL, '40S ribosomal protein S26', NULL, NULL, NULL, NULL, NULL, 4),
(179317, NULL, 'G3DSA:3.30.160.60:FF:000763', NULL, NULL, 'Probable lysine-specific demethylase ELF6', NULL, NULL, NULL, NULL, NULL, 4),
(179318, NULL, 'G3DSA:2.60.120.330:FF:000054', NULL, NULL, '1-aminocyclopropane-1-carboxylic acid oxidase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(179319, NULL, 'G3DSA:1.20.1280.50:FF:000025', NULL, NULL, 'F-box and WD repeat domain containing 8', NULL, NULL, NULL, NULL, NULL, 4),
(179320, NULL, 'G3DSA:1.10.150.550:FF:000003', NULL, NULL, 'Nucleoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(179321, NULL, 'G3DSA:1.25.40.10:FF:000594', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(179322, NULL, 'G3DSA:2.20.28.10:FF:000045', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(179323, NULL, 'G3DSA:2.60.40.10:FF:000550', NULL, NULL, '1,4-alpha-glucan-branching enzyme isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(179324, NULL, 'G3DSA:2.30.29.30:FF:000154', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(179325, NULL, 'G3DSA:3.40.1280.30:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179326, NULL, 'G3DSA:3.30.530.20:FF:000027', NULL, NULL, 'StAR-related lipid transfer protein 7, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(179327, NULL, 'G3DSA:3.30.200.20:FF:000946', NULL, NULL, 'Transmembrane serine/threonine-protein kinase PknJ', NULL, NULL, NULL, NULL, NULL, 4),
(179328, NULL, 'G3DSA:2.60.40.10:FF:000494', NULL, NULL, 'Leptin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(179329, NULL, 'G3DSA:3.30.70.20:FF:000121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179330, NULL, 'G3DSA:1.25.40.10:FF:001954', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(179331, NULL, 'G3DSA:1.20.120.350:FF:000183', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179332, NULL, 'G3DSA:1.10.357.50:FF:000010', NULL, NULL, 'exocyst complex component 3', NULL, NULL, NULL, NULL, NULL, 4),
(179333, NULL, 'G3DSA:3.90.550.10:FF:000742', NULL, NULL, 'Glr3787 protein', NULL, NULL, NULL, NULL, NULL, 4),
(179334, NULL, 'G3DSA:3.10.620.10:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179335, NULL, 'G3DSA:1.25.40.560:FF:000001', NULL, NULL, 'ubiquitin thioesterase ZRANB1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(179336, NULL, 'G3DSA:1.10.20.10:FF:000194', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179337, NULL, 'G3DSA:2.30.29.30:FF:000553', NULL, NULL, 'Protein CBR-STN-1', NULL, NULL, NULL, NULL, NULL, 4),
(179338, NULL, 'G3DSA:2.60.120.650:FF:000212', NULL, NULL, 'Putative lysine-specific demethylase JMJ16', NULL, NULL, NULL, NULL, NULL, 4),
(179339, NULL, 'G3DSA:3.90.550.10:FF:000686', NULL, NULL, 'UDP-N-acetyl-alpha-D-galactosamine:polypeptide N-acetylgalactosaminyltransferase 6 (GalNAc-T6)', NULL, NULL, NULL, NULL, NULL, 4),
(179340, NULL, 'G3DSA:1.10.1410.10:FF:000026', NULL, NULL, 'U3 small nucleolar RNA-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(179341, NULL, 'G3DSA:4.10.1240.10:FF:000050', NULL, NULL, 'Glucagon-like peptide 1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(179342, NULL, 'G3DSA:2.60.40.10:FF:003984', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179343, NULL, 'G3DSA:2.40.50.90:FF:000075', NULL, NULL, 'Nuclease domain containing protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(179344, NULL, 'G3DSA:3.40.980.10:FF:000016', NULL, NULL, 'YMR178W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(179345, NULL, 'G3DSA:3.40.50.300:FF:000185', NULL, NULL, 'GTPase Obg', NULL, NULL, NULL, NULL, NULL, 4),
(179346, NULL, 'G3DSA:1.10.287.1490:FF:000027', NULL, NULL, 'Myosin heavy chain-like', NULL, NULL, NULL, NULL, NULL, 4),
(179347, NULL, 'G3DSA:1.20.144.10:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179348, NULL, 'G3DSA:3.30.565.10:FF:000222', NULL, NULL, 'Putative two-component system sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(179349, NULL, 'G3DSA:3.10.20.30:FF:000110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179350, NULL, 'G3DSA:1.10.510.10:FF:003020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179351, NULL, 'G3DSA:3.90.1170.10:FF:000015', NULL, NULL, '50S ribosomal protein L16', NULL, NULL, NULL, NULL, NULL, 4),
(179352, NULL, 'G3DSA:1.10.101.10:FF:000028', NULL, NULL, 'Plastid transcriptionally active 5', NULL, NULL, NULL, NULL, NULL, 4),
(179353, NULL, 'G3DSA:4.10.40.20:FF:000005', NULL, NULL, 'Insulin-like growth factor-binding protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(179354, NULL, 'G3DSA:1.20.890.10:FF:000021', NULL, NULL, 'Protein CBG08105', NULL, NULL, NULL, NULL, NULL, 4),
(179355, NULL, 'G3DSA:2.40.30.130:FF:000055', NULL, NULL, 'Alanyl-tRNA synthetase-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(179356, NULL, 'G3DSA:2.60.40.10:FF:004260', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179357, NULL, 'G3DSA:3.80.10.10:FF:003243', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(179358, NULL, 'G3DSA:3.40.710.10:FF:000182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179359, NULL, 'G3DSA:1.10.287.770:FF:000001', NULL, NULL, 'Acid-sensing ion channel subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(179360, NULL, 'G3DSA:2.60.40.10:FF:004765', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179361, NULL, 'G3DSA:3.50.50.60:FF:000788', NULL, NULL, 'L-amino acid oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(179362, NULL, 'G3DSA:3.30.450.20:FF:000026', NULL, NULL, 'single-minded homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(179363, NULL, 'G3DSA:1.20.1270.10:FF:000035', NULL, NULL, 'Heat shock cognate 71 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(179364, NULL, 'G3DSA:1.10.510.10:FF:000546', NULL, NULL, 'SCY1 like pseudokinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(179365, NULL, 'G3DSA:3.40.720.10:FF:000132', NULL, NULL, 'AT28040p', NULL, NULL, NULL, NULL, NULL, 4),
(179366, NULL, 'G3DSA:3.40.50.2000:FF:000885', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179367, NULL, 'G3DSA:1.10.630.10:FF:000145', NULL, NULL, 'Cytochrome P450 family 26 subfamily C member 1', NULL, NULL, NULL, NULL, NULL, 4),
(179368, NULL, 'G3DSA:1.25.10.20:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179369, NULL, 'G3DSA:3.30.160.60:FF:002000', NULL, NULL, 'Zinc finger protein 445', NULL, NULL, NULL, NULL, NULL, 4),
(179370, NULL, 'G3DSA:1.10.10.10:FF:000530', NULL, NULL, 'Forkhead box protein (AaegFOXM2)', NULL, NULL, NULL, NULL, NULL, 4),
(179371, NULL, 'G3DSA:3.30.200.20:FF:002127', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(179372, NULL, 'G3DSA:3.40.640.10:FF:000131', NULL, NULL, 'HISTIDINE BIOSYNTHESIS 6B', NULL, NULL, NULL, NULL, NULL, 4),
(179373, NULL, 'G3DSA:3.40.850.10:FF:000012', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(179374, NULL, 'G3DSA:3.30.40.10:FF:001184', NULL, NULL, 'APC11, cyclin metabolism', NULL, NULL, NULL, NULL, NULL, 4),
(179375, NULL, 'G3DSA:3.30.190.20:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179376, NULL, 'G3DSA:3.30.200.20:FF:001727', NULL, NULL, 'Putative serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(179377, NULL, 'G3DSA:1.25.40.10:FF:005085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(179378, NULL, 'G3DSA:3.40.50.300:FF:004075', NULL, NULL, 'Putative dynein heavy chain, cytosolic', NULL, NULL, NULL, NULL, NULL, 4),
(179379, NULL, 'G3DSA:4.10.400.10:FF:000026', NULL, NULL, 'Low-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(179380, NULL, 'G3DSA:2.10.25.10:FF:000449', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(179381, NULL, 'G3DSA:1.10.472.80:FF:000073', NULL, NULL, 'TBC/Rab GTPase activating domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(179382, NULL, 'G3DSA:3.30.70.2190:FF:000017', NULL, NULL, 'D-2-hydroxyglutarate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(179383, NULL, 'G3DSA:2.10.25.10:FF:000269', NULL, NULL, 'Adhesion G protein-coupled receptor E2', NULL, NULL, NULL, NULL, NULL, 4),
(179384, NULL, 'G3DSA:3.30.160.60:FF:004074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179385, NULL, 'G3DSA:2.60.120.260:FF:000421', NULL, NULL, 'Cellulase/esterase CelE', NULL, NULL, NULL, NULL, NULL, 4),
(179386, NULL, 'G3DSA:1.20.58.1880:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179387, NULL, 'G3DSA:1.20.1560.10:FF:000411', NULL, NULL, 'Vacuolar glutathione S-conjugate transporter of the ATP-binding cassette family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(179388, NULL, 'G3DSA:3.30.160.60:FF:001724', NULL, NULL, 'zinc finger protein 787 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(179389, NULL, 'G3DSA:3.30.460.10:FF:000086', NULL, NULL, 'tRNA nucleotidyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(179390, NULL, 'G3DSA:1.10.8.60:FF:000425', NULL, NULL, 'Replication factor C small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(179391, NULL, 'G3DSA:4.10.280.10:FF:000145', NULL, NULL, 'Helix-loop-helix DNA-binding domain containing protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(179392, NULL, 'G3DSA:1.10.238.200:FF:000001', NULL, NULL, 'DCN1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(179393, NULL, 'G3DSA:3.90.76.10:FF:000016', NULL, NULL, 'Possible conserved lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(179394, NULL, 'G3DSA:3.40.50.300:FF:003675', NULL, NULL, 'Molybdopterin synthase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(179395, NULL, 'G3DSA:3.40.140.10:FF:000273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179396, NULL, 'G3DSA:4.10.520.10:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179397, NULL, 'G3DSA:3.20.20.140:FF:000231', NULL, NULL, 'Sodium/hydrogen exchanger 2', NULL, NULL, NULL, NULL, NULL, 4),
(179398, NULL, 'G3DSA:3.40.190.290:FF:000116', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(179399, NULL, 'G3DSA:3.90.1420.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179400, NULL, 'G3DSA:2.60.40.10:FF:004821', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179401, NULL, 'G3DSA:2.60.40.10:FF:000370', NULL, NULL, 'CMRF35-like molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(179402, NULL, 'G3DSA:1.20.1250.20:FF:002223', NULL, NULL, 'Arabinose-proton symporter (Arabinose transporter)', NULL, NULL, NULL, NULL, NULL, 4),
(179403, NULL, 'G3DSA:3.40.50.720:FF:000659', NULL, NULL, 'Protein YIM1', NULL, NULL, NULL, NULL, NULL, 4),
(179404, NULL, 'G3DSA:1.10.510.10:FF:001783', NULL, NULL, 'Protein kinase domain-containing protein (AFU_orthologue AFUA_2G14650)', NULL, NULL, NULL, NULL, NULL, 4),
(179405, NULL, 'G3DSA:3.30.200.20:FF:001907', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179406, NULL, 'G3DSA:3.30.50.10:FF:000173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179407, NULL, 'G3DSA:1.25.10.10:FF:002003', NULL, NULL, 'HEAT domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(179408, NULL, 'G3DSA:2.60.200.30:FF:000042', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(179409, NULL, 'G3DSA:3.40.50.1360:FF:000029', NULL, NULL, 'Ribose 5-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(179410, NULL, 'G3DSA:1.10.510.10:FF:000147', NULL, NULL, 'Inhibitor of nuclear factor kappa-B kinase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(179411, NULL, 'G3DSA:3.70.10.10:FF:000112', NULL, NULL, 'Cell cycle checkpoint control protein RAD9A-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(179412, NULL, 'G3DSA:1.25.40.10:FF:002735', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179413, NULL, 'G3DSA:3.30.565.10:FF:000166', NULL, NULL, 'Sporulation kinase B', NULL, NULL, NULL, NULL, NULL, 4),
(179414, NULL, 'G3DSA:3.40.50.300:FF:008346', NULL, NULL, 'Outer dynein arm heavy chain beta', NULL, NULL, NULL, NULL, NULL, 4),
(179415, NULL, 'G3DSA:6.20.250.70:FF:000005', NULL, NULL, 'DNA-directed RNA polymerase I subunit rpa34', NULL, NULL, NULL, NULL, NULL, 4),
(179416, NULL, 'G3DSA:3.40.50.150:FF:000174', NULL, NULL, 'TRM2p tRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(179417, NULL, 'G3DSA:2.40.160.110:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179418, NULL, 'G3DSA:3.40.50.2000:FF:000941', NULL, NULL, 'ADP-heptose:LPS heptosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(179419, NULL, 'G3DSA:1.20.1250.20:FF:001947', NULL, NULL, 'Probable sugar-transport integral membrane protein SugI', NULL, NULL, NULL, NULL, NULL, 4),
(179420, NULL, 'G3DSA:1.10.3860.10:FF:000021', NULL, NULL, 'Amino acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(179421, NULL, 'G3DSA:1.10.630.10:FF:000201', NULL, NULL, 'Os06g0328900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(179422, NULL, 'G3DSA:3.40.50.10380:FF:000020', NULL, NULL, 'NADP-dependent malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(179423, NULL, 'G3DSA:1.10.357.70:FF:000016', NULL, NULL, 'Exocyst complex component 3-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(179424, NULL, 'G3DSA:1.25.40.10:FF:002174', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(179425, NULL, 'G3DSA:1.20.5.100:FF:000024', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(179426, NULL, 'G3DSA:3.40.50.970:FF:000032', NULL, NULL, '2-oxoisovalerate dehydrogenase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(179427, NULL, 'G3DSA:1.25.40.90:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179428, NULL, 'G3DSA:1.10.20.10:FF:000356', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179429, NULL, 'G3DSA:2.70.98.10:FF:000025', NULL, NULL, 'GAL10 bifunctional protein', NULL, NULL, NULL, NULL, NULL, 4),
(179430, NULL, 'G3DSA:3.30.40.10:FF:002145', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(179431, NULL, 'G3DSA:1.10.4200.10:FF:000005', NULL, NULL, 'Probable 2-(5''''-triphosphoribosyl)-3''-dephosphocoenzyme-A synthase', NULL, NULL, NULL, NULL, NULL, 4),
(179432, NULL, 'G3DSA:3.30.200.20:FF:001166', NULL, NULL, 'Camk camk1 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(179433, NULL, 'G3DSA:3.30.56.50:FF:000001', NULL, NULL, 'Translation initiation factor IF-2', NULL, NULL, NULL, NULL, NULL, 4),
(179434, NULL, 'G3DSA:2.130.10.10:FF:004237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179435, NULL, 'G3DSA:3.40.50.261:FF:000022', NULL, NULL, 'Succinate--CoA ligase [ADP/GDP-forming] subunit alpha, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(179436, NULL, 'G3DSA:3.90.1100.10:FF:000028', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(179437, NULL, 'G3DSA:2.30.30.140:FF:000217', NULL, NULL, 'E3 ubiquitin-protein ligase UHRF1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(179438, NULL, 'G3DSA:2.60.120.1520:FF:000001', NULL, NULL, 'Alkylated DNA repair protein alkB homolog 8', NULL, NULL, NULL, NULL, NULL, 4),
(179439, NULL, 'G3DSA:2.30.29.100:FF:000001', NULL, NULL, 'Envelope glycoprotein B', NULL, NULL, NULL, NULL, NULL, 4),
(179440, NULL, 'G3DSA:1.10.472.10:FF:000272', NULL, NULL, 'WGS project CABT00000000 data, contig 2.7', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(179441, NULL, 'G3DSA:2.40.50.140:FF:001169', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179442, NULL, 'G3DSA:2.130.10.10:FF:000527', NULL, NULL, 'POC1 centriolar protein homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(179443, NULL, 'G3DSA:1.25.40.10:FF:001898', NULL, NULL, 'Putative leaf protein', NULL, NULL, NULL, NULL, NULL, 4),
(179444, NULL, 'G3DSA:2.130.10.10:FF:005530', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179445, NULL, 'G3DSA:3.40.50.2300:FF:001037', NULL, NULL, 'Glutamate receptor ionotropic, delta-1', NULL, NULL, NULL, NULL, NULL, 4),
(179446, NULL, 'G3DSA:3.40.50.150:FF:000915', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179447, NULL, 'G3DSA:3.30.70.330:FF:000902', NULL, NULL, 'La RNA binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(179448, NULL, 'G3DSA:1.10.287.1040:FF:000010', NULL, NULL, 'Exodeoxyribonuclease 7 small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(179449, NULL, 'G3DSA:1.20.1280.170:FF:000002', NULL, NULL, 'Exocyst complex component 7', NULL, NULL, NULL, NULL, NULL, 4),
(179450, NULL, 'G3DSA:2.40.50.100:FF:000168', NULL, NULL, 'Putative exosome complex component rrp40', NULL, NULL, NULL, NULL, NULL, 4),
(179451, NULL, 'G3DSA:1.20.1110.10:FF:000203', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179452, NULL, 'G3DSA:2.10.70.10:FF:000233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179453, NULL, 'G3DSA:4.10.400.10:FF:000369', NULL, NULL, 'Cortical granule serine protease 1; Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179454, NULL, 'G3DSA:3.40.366.10:FF:000044', NULL, NULL, '[acyl-carrier-protein] S-malonyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(179455, NULL, 'G3DSA:3.30.450.40:FF:000240', NULL, NULL, 'Sensor histidine kinase, GAF domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(179456, NULL, 'G3DSA:2.40.10.10:FF:000616', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179457, NULL, 'G3DSA:3.30.300.20:FF:000038', NULL, NULL, 'Cleavage and polyadenylation specificity factor', NULL, NULL, NULL, NULL, NULL, 4),
(179458, NULL, 'G3DSA:1.20.1250.20:FF:000986', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179459, NULL, 'G3DSA:1.10.10.60:FF:000516', NULL, NULL, 'Transcription factor Toy', NULL, NULL, NULL, NULL, NULL, 4),
(179460, NULL, 'G3DSA:3.40.50.300:FF:004636', NULL, NULL, 'GTPase Era', NULL, NULL, NULL, NULL, NULL, 4),
(179461, NULL, 'G3DSA:3.30.70.330:FF:002976', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179462, NULL, 'G3DSA:3.10.50.10:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179463, NULL, 'G3DSA:3.40.50.300:FF:001202', NULL, NULL, 'Translation elongation factor EF-1 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(179464, NULL, 'G3DSA:1.10.10.790:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179465, NULL, 'G3DSA:3.40.47.10:FF:000125', NULL, NULL, '3-ketoacyl-CoA thiolase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(179466, NULL, 'G3DSA:2.60.40.10:FF:000218', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(179467, NULL, 'G3DSA:1.25.10.10:FF:000766', NULL, NULL, 'Cell differentiation family, rcd1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(179468, NULL, 'G3DSA:1.20.1250.20:FF:001386', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(179469, NULL, 'G3DSA:2.60.120.1000:FF:000019', NULL, NULL, 'Collagen type XI alpha 2 pseudogene 1', NULL, NULL, NULL, NULL, NULL, 4),
(179470, NULL, 'G3DSA:1.10.1370.30:FF:000028', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(179471, NULL, 'G3DSA:2.60.40.10:FF:004422', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179472, NULL, 'G3DSA:2.30.30.210:FF:000025', NULL, NULL, 'Ribonuclease P protein subunit p29-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(179473, NULL, 'G3DSA:2.130.10.10:FF:003248', NULL, NULL, 'Periodic tryptophan protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(179474, NULL, 'G3DSA:3.30.40.10:FF:000352', NULL, NULL, 'Breast cancer associated RING 1', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(179475, NULL, 'G3DSA:3.80.10.10:FF:000573', NULL, NULL, 'Leucine-rich repeat-containing protein 41', NULL, NULL, NULL, NULL, NULL, 4),
(179476, NULL, 'G3DSA:3.30.160.60:FF:001584', NULL, NULL, 'Zinc finger protein 660', NULL, NULL, NULL, NULL, NULL, 4),
(179477, NULL, 'G3DSA:1.25.40.10:FF:002527', NULL, NULL, 'Pentatricopeptide (PPR) repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(179478, NULL, 'G3DSA:3.40.50.620:FF:000404', NULL, NULL, 'Adenine nucleotide alpha hydrolases-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(179479, NULL, 'G3DSA:4.10.110.10:FF:000015', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(179480, NULL, 'G3DSA:3.90.226.10:FF:000129', NULL, NULL, 'Methylcrotonoyl-CoA carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(179481, NULL, 'G3DSA:1.25.40.10:FF:002999', NULL, NULL, 'Crooked neck protein, putative, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(179482, NULL, 'G3DSA:3.40.50.300:FF:008442', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(179483, NULL, 'G3DSA:2.60.40.10:FF:000999', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(179484, NULL, 'G3DSA:3.40.50.620:FF:000876', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179485, NULL, 'G3DSA:3.30.160.60:FF:004338', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179486, NULL, 'G3DSA:3.20.20.220:FF:000036', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(179487, NULL, 'G3DSA:3.80.10.10:FF:003327', NULL, NULL, 'Si:ch73-233m11.2', NULL, NULL, NULL, NULL, NULL, 4),
(179488, NULL, 'G3DSA:3.80.20.20:FF:000065', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(179489, NULL, 'G3DSA:2.70.170.10:FF:000036', NULL, NULL, 'Gamma-aminobutyric acid receptor subunit beta-like', NULL, NULL, NULL, NULL, NULL, 4),
(179490, NULL, 'G3DSA:3.90.1170.20:FF:000007', NULL, NULL, 'Nicotinate-nucleotide pyrophosphorylase (Carboxylating)', NULL, NULL, NULL, NULL, NULL, 4),
(179491, NULL, 'G3DSA:2.60.40.10:FF:000527', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM71', NULL, NULL, NULL, NULL, NULL, 4),
(179492, NULL, 'G3DSA:2.60.40.1120:FF:000049', NULL, NULL, 'Transporter, outer membrane receptor (OMR) family', NULL, NULL, NULL, NULL, NULL, 4),
(179493, NULL, 'G3DSA:2.130.10.10:FF:000494', NULL, NULL, 'DDB1- and CUL4-associated factor 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(179494, NULL, 'G3DSA:3.90.1580.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179495, NULL, 'G3DSA:2.70.150.10:FF:000023', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(179496, NULL, 'G3DSA:1.25.40.1030:FF:000004', NULL, NULL, 'Protein transport protein SEC31 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(179497, NULL, 'G3DSA:2.60.40.60:FF:000391', NULL, NULL, 'Dachsous, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(179498, NULL, 'G3DSA:1.20.1070.10:FF:001419', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179499, NULL, 'G3DSA:2.60.40.10:FF:004905', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179500, NULL, 'G3DSA:1.10.30.10:FF:000149', NULL, NULL, 'High mobility group protein C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(179501, NULL, 'G3DSA:3.40.50.300:FF:004743', NULL, NULL, 'GTPase HflX', NULL, NULL, NULL, NULL, NULL, 4),
(179502, NULL, 'G3DSA:3.30.70.270:FF:000238', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179503, NULL, 'G3DSA:3.80.10.10:FF:003799', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179504, NULL, 'G3DSA:3.30.930.10:FF:000431', NULL, NULL, 'Putative histidyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(179505, NULL, 'G3DSA:3.30.70.870:FF:000047', NULL, NULL, 'Putative tetracycline resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(179506, NULL, 'G3DSA:3.90.550.10:FF:000135', NULL, NULL, 'Cellulose synthase-like protein G3', NULL, NULL, NULL, NULL, NULL, 4),
(179507, NULL, 'G3DSA:3.90.1100.10:FF:000056', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(179508, NULL, 'G3DSA:1.20.120.140:FF:000007', NULL, NULL, 'Signal recognition particle receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(179509, NULL, 'G3DSA:1.10.246.10:FF:000016', NULL, NULL, 'Serum albumin', NULL, NULL, NULL, NULL, NULL, 4),
(179510, NULL, 'G3DSA:2.120.10.80:FF:000240', NULL, NULL, 'Attractin-like 1b', NULL, NULL, NULL, NULL, NULL, 4),
(179511, NULL, 'G3DSA:3.40.50.150:FF:000494', NULL, NULL, 'Arginine N-methyltransferase, type II, putative', NULL, NULL, NULL, NULL, NULL, 4),
(179512, NULL, 'G3DSA:1.10.510.10:FF:004228', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179513, NULL, 'G3DSA:3.40.50.2000:FF:000020', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(179514, NULL, 'G3DSA:1.20.58.390:FF:000257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179515, NULL, 'G3DSA:2.70.130.10:FF:000123', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179516, NULL, 'G3DSA:3.30.230.120:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179517, NULL, 'G3DSA:3.10.450.10:FF:000039', NULL, NULL, 'Putative cysteine proteinase CG12163', NULL, NULL, NULL, NULL, NULL, 4),
(179518, NULL, 'G3DSA:2.60.34.10:FF:000114', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(179519, NULL, 'G3DSA:3.40.50.720:FF:000890', NULL, NULL, 'Erythronate-4-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(179520, NULL, 'G3DSA:3.30.160.60:FF:002101', NULL, NULL, 'Zinc finger protein 224', NULL, NULL, NULL, NULL, NULL, 4),
(179521, NULL, 'G3DSA:1.10.490.10:FF:000021', NULL, NULL, 'GEO09476p1', NULL, NULL, NULL, NULL, NULL, 4),
(179522, NULL, 'G3DSA:3.30.40.10:FF:001341', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179523, NULL, 'G3DSA:2.60.40.10:FF:003596', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179524, NULL, 'G3DSA:3.20.120.10:FF:000001', NULL, NULL, 'Hydrophobin', NULL, NULL, NULL, NULL, NULL, 4),
(179525, NULL, 'G3DSA:2.60.40.150:FF:000643', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(179526, NULL, 'G3DSA:3.30.160.60:FF:005962', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179527, NULL, 'G3DSA:3.40.50.1010:FF:000178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179528, NULL, 'G3DSA:3.80.10.10:FF:002708', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(179529, NULL, 'G3DSA:1.25.40.10:FF:001908', NULL, NULL, 'Pet309p', NULL, NULL, NULL, NULL, NULL, 4),
(179530, NULL, 'G3DSA:2.60.40.1510:FF:000043', NULL, NULL, 'G-protein coupled receptor 98-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(179531, NULL, 'G3DSA:2.40.70.10:FF:000518', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179532, NULL, 'G3DSA:3.40.30.10:FF:001065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179533, NULL, 'G3DSA:3.40.50.300:FF:004260', NULL, NULL, 'General secretion pathway protein E', NULL, NULL, NULL, NULL, NULL, 4),
(179534, NULL, 'G3DSA:1.25.40.10:FF:003472', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(179535, NULL, 'G3DSA:2.60.120.330:FF:000150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179536, NULL, 'G3DSA:2.130.10.10:FF:004193', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(179537, NULL, 'G3DSA:3.30.70.330:FF:003140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179538, NULL, 'G3DSA:3.30.460.50:FF:000002', NULL, NULL, 'RET2, RNA editing complex MP57', NULL, NULL, NULL, NULL, NULL, 4),
(179539, NULL, 'G3DSA:1.10.510.10:FF:002300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179540, NULL, 'G3DSA:2.60.40.790:FF:000031', NULL, NULL, 'Small heat-shock protein', NULL, NULL, NULL, NULL, NULL, 4),
(179541, NULL, 'G3DSA:3.40.50.150:FF:001011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179542, NULL, 'G3DSA:3.10.110.10:FF:000244', NULL, NULL, 'Ubiquitin-conjugating enzyme E2Ka (UBC1 homolog)', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(179543, NULL, 'G3DSA:1.20.58.60:FF:000637', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179544, NULL, 'G3DSA:3.10.330.70:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179545, NULL, 'G3DSA:2.60.120.10:FF:000479', NULL, NULL, '3-hydroxyanthranilate 3,4-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(179546, NULL, 'G3DSA:2.10.70.10:FF:000099', NULL, NULL, 'Seizure related 6 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(179547, NULL, 'G3DSA:3.40.50.300:FF:003754', NULL, NULL, 'Probable pre-mRNA-splicing factor ATP-dependent RNA helicase DEAH8', NULL, NULL, NULL, NULL, NULL, 4),
(179548, NULL, 'G3DSA:3.90.1150.10:FF:000104', NULL, NULL, 'Kynureninase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(179549, NULL, 'G3DSA:3.30.565.10:FF:000346', NULL, NULL, 'MORC family CW-type zinc finger 2', NULL, NULL, NULL, NULL, NULL, 4),
(179550, NULL, 'G3DSA:1.20.5.1430:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179551, NULL, 'G3DSA:1.10.8.10:FF:000079', NULL, NULL, 'Ubiquitin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(179552, NULL, 'G3DSA:3.80.10.10:FF:000090', NULL, NULL, 'Leucine-rich repeat neuronal protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(179553, NULL, 'G3DSA:3.30.110.110:FF:000015', NULL, NULL, 'Double-strand break repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(179554, NULL, 'G3DSA:2.30.29.30:FF:001273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179555, NULL, 'G3DSA:1.10.1200.10:FF:000123', NULL, NULL, 'Amino acid adenylation domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(179556, NULL, 'G3DSA:1.20.58.60:FF:000154', NULL, NULL, 'nesprin-1 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(179557, NULL, 'G3DSA:1.10.10.10:FF:001238', NULL, NULL, 'PCI domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(179558, NULL, 'G3DSA:1.10.620.20:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179559, NULL, 'G3DSA:2.10.25.10:FF:001192', NULL, NULL, 'Laminin subunit gamma-1', NULL, NULL, NULL, NULL, NULL, 4),
(179560, NULL, 'G3DSA:2.40.160.120:FF:000066', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(179561, NULL, 'G3DSA:3.40.50.300:FF:006508', NULL, NULL, 'Ras family protein', NULL, NULL, NULL, NULL, NULL, 4),
(179562, NULL, 'G3DSA:1.20.1310.20:FF:000036', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(179563, NULL, 'G3DSA:3.40.50.300:FF:006188', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(179564, NULL, 'G3DSA:3.30.160.60:FF:000639', NULL, NULL, 'Zinc finger and BTB domain-containing protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(179565, NULL, 'G3DSA:3.30.200.20:FF:001328', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179566, NULL, 'G3DSA:1.10.287.1490:FF:000134', NULL, NULL, 'AER045Cp', NULL, NULL, NULL, NULL, NULL, 4),
(179567, NULL, 'G3DSA:2.130.10.10:FF:001011', NULL, NULL, 'Cleavage and polyadenylation specificity factor (CPSF) A subunit protein', NULL, NULL, NULL, NULL, NULL, 4),
(179568, NULL, 'G3DSA:3.40.50.200:FF:000161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179569, NULL, 'G3DSA:1.10.3080.10:FF:000051', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(179570, NULL, 'G3DSA:3.30.420.40:FF:000199', NULL, NULL, 'Related to glucose regulated stress protein, HSP70-like', NULL, NULL, NULL, NULL, NULL, 4),
(179571, NULL, 'G3DSA:4.10.400.10:FF:000364', NULL, NULL, 'Transmembrane cell adhesion receptor mua-3', NULL, NULL, NULL, NULL, NULL, 4),
(179572, NULL, 'G3DSA:3.80.10.10:FF:000101', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase ERECTA', NULL, NULL, NULL, NULL, NULL, 4),
(179573, NULL, 'G3DSA:3.60.20.10:FF:000029', NULL, NULL, 'Proteasome subunit alpha type', NULL, NULL, NULL, NULL, NULL, 4),
(179574, NULL, 'G3DSA:1.10.630.10:FF:000010', NULL, NULL, 'cytochrome P450 2W1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(179575, NULL, 'G3DSA:3.40.1190.20:FF:000065', NULL, NULL, 'Ribokinase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(179576, NULL, 'G3DSA:1.10.730.10:FF:000057', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(179577, NULL, 'G3DSA:3.90.550.10:FF:000618', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(179578, NULL, 'G3DSA:3.30.1370.240:FF:000014', NULL, NULL, 'Phenylalanine--tRNA ligase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(179579, NULL, 'G3DSA:1.25.40.10:FF:005080', NULL, NULL, 'Os11g0109800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(179580, NULL, 'G3DSA:3.30.1390.20:FF:000009', NULL, NULL, '60S ribosomal protein L7-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(179581, NULL, 'G3DSA:3.90.25.10:FF:000073', NULL, NULL, 'NAD-dependent epimerase/dehydratase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(179582, NULL, 'G3DSA:3.30.1120.130:FF:000004', NULL, NULL, 'serine/threonine-protein kinase PLK4-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(179583, NULL, 'G3DSA:3.30.450.20:FF:000178', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(179584, NULL, 'G3DSA:3.60.10.10:FF:000383', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179585, NULL, 'G3DSA:2.130.10.10:FF:001792', NULL, NULL, 'WD repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(179586, NULL, 'G3DSA:1.10.510.10:FF:001827', NULL, NULL, 'Serine/threonine-protein_kinase_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(179587, NULL, 'G3DSA:1.20.990.10:FF:000006', NULL, NULL, 'Nitric oxide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(179588, NULL, 'G3DSA:3.30.530.20:FF:000212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179589, NULL, 'G3DSA:3.40.50.1240:FF:000179', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179590, NULL, 'G3DSA:3.10.28.10:FF:000009', NULL, NULL, 'HO endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(179591, NULL, 'G3DSA:3.40.50.300:FF:005569', NULL, NULL, 'Sca1 complex protein phr', NULL, NULL, NULL, NULL, NULL, 4),
(179592, NULL, 'G3DSA:3.20.20.190:FF:000072', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(179593, NULL, 'G3DSA:3.30.470.30:FF:000070', NULL, NULL, 'mRNA capping enzyme, catalytic domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(179594, NULL, 'G3DSA:1.20.120.1760:FF:000045', NULL, NULL, 'CDP-diacylglycerol--inositol 3-phosphatidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(179595, NULL, 'G3DSA:3.30.70.330:FF:000234', NULL, NULL, 'Polyadenylate-binding protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(179596, NULL, 'G3DSA:2.70.20.10:FF:000003', NULL, NULL, 'DNA topoisomerase 3', NULL, NULL, NULL, NULL, NULL, 4),
(179597, NULL, 'G3DSA:3.40.50.80:FF:000199', NULL, NULL, 'FRE family ferric-chelate reductase, putative (AFU_orthologue AFUA_1G17270)', NULL, NULL, NULL, NULL, NULL, 4),
(179598, NULL, 'G3DSA:3.30.1360.40:FF:000047', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(179599, NULL, 'G3DSA:2.40.10.120:FF:000014', NULL, NULL, 'Pro-apoptotic serine protease NMA111', NULL, NULL, NULL, NULL, NULL, 4),
(179600, NULL, 'G3DSA:3.40.50.300:FF:001837', NULL, NULL, 'Putative DEAD box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(179601, NULL, 'G3DSA:1.20.1070.10:FF:000110', NULL, NULL, 'olfactory receptor 10H1-like', NULL, NULL, NULL, NULL, NULL, 4),
(179602, NULL, 'G3DSA:3.90.230.10:FF:000027', NULL, NULL, 'Methionine aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(179603, NULL, 'G3DSA:3.40.50.300:FF:002343', NULL, NULL, 'ATP-binding Cassette (ABC) Superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(179604, NULL, 'G3DSA:3.30.70.330:FF:001678', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179605, NULL, 'G3DSA:3.40.190.10:FF:000068', NULL, NULL, 'Phosphate ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(179606, NULL, 'G3DSA:3.30.420.10:FF:000673', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179607, NULL, 'G3DSA:3.40.30.10:FF:000446', NULL, NULL, 'Thioredoxin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(179608, NULL, 'G3DSA:3.90.1300.10:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(179609, NULL, 'G3DSA:3.10.20.90:FF:000549', NULL, NULL, 'Sacsin molecular chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(179610, NULL, 'G3DSA:2.60.120.430:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179611, NULL, 'G3DSA:1.10.510.10:FF:002772', NULL, NULL, 'Serine/threonine-protein kinase NEK', NULL, NULL, NULL, NULL, NULL, 4),
(179612, NULL, 'G3DSA:2.10.25.10:FF:000926', NULL, NULL, 'Multiple epidermal growth factor-like domains protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(179613, NULL, 'G3DSA:2.10.25.10:FF:001545', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179614, NULL, 'G3DSA:3.40.250.10:FF:000039', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(179615, NULL, 'G3DSA:1.25.10.10:FF:003335', NULL, NULL, 'Nucleolar protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(179616, NULL, 'G3DSA:3.10.620.10:FF:000002', NULL, NULL, 'Protein N-terminal glutamine amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(179617, NULL, 'G3DSA:3.40.225.10:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179618, NULL, 'G3DSA:1.25.40.10:FF:003825', NULL, NULL, 'Coatomer subunit epsilon-1', NULL, NULL, NULL, NULL, NULL, 4),
(179619, NULL, 'G3DSA:1.10.1520.10:FF:000068', NULL, NULL, 'Ribonuclease 3 2', NULL, NULL, NULL, NULL, NULL, 4),
(179620, NULL, 'G3DSA:3.10.290.10:FF:000037', NULL, NULL, 'BnaA05g14690D protein', NULL, NULL, NULL, NULL, NULL, 4),
(179621, NULL, 'G3DSA:2.60.200.40:FF:000056', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(179622, NULL, 'G3DSA:1.10.533.10:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179623, NULL, 'G3DSA:3.90.70.80:FF:000029', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(179624, NULL, 'G3DSA:3.40.50.300:FF:007014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179625, NULL, 'G3DSA:2.130.10.10:FF:001803', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(179626, NULL, 'G3DSA:3.20.20.140:FF:000208', NULL, NULL, 'DNA polymerase III PolC-type', NULL, NULL, NULL, NULL, NULL, 4),
(179627, NULL, 'G3DSA:3.80.10.10:FF:001871', NULL, NULL, 'Leucine-rich repeats and IQ motif containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(179628, NULL, 'G3DSA:2.120.10.30:FF:000039', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM32', NULL, NULL, NULL, NULL, NULL, 4),
(179629, NULL, 'G3DSA:3.30.200.210:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179630, NULL, 'G3DSA:3.30.60.90:FF:000023', NULL, NULL, 'Protein NBR1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(179631, NULL, 'G3DSA:1.10.630.10:FF:000802', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179632, NULL, 'G3DSA:3.30.160.60:FF:000286', NULL, NULL, 'Zinc finger protein 770', NULL, NULL, NULL, NULL, NULL, 4),
(179633, NULL, 'G3DSA:2.30.30.90:FF:000001', NULL, NULL, 'Ferrous iron transporter A', NULL, NULL, NULL, NULL, NULL, 4),
(179634, NULL, 'G3DSA:2.60.200.20:FF:000050', NULL, NULL, 'Kinesin-like protein, KLP38B', NULL, NULL, NULL, NULL, NULL, 4),
(179635, NULL, 'G3DSA:1.20.1560.10:FF:000647', NULL, NULL, 'AGAP008437-PA', NULL, NULL, NULL, NULL, NULL, 4),
(179636, NULL, 'G3DSA:1.10.510.10:FF:003609', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179637, NULL, 'G3DSA:1.10.238.10:FF:000722', NULL, NULL, 'Calcium-binding allergen Ole e 8', NULL, NULL, NULL, NULL, NULL, 4),
(179638, NULL, 'G3DSA:2.10.50.10:FF:000086', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(179639, NULL, 'G3DSA:3.90.215.10:FF:000003', NULL, NULL, 'angiopoietin-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(179640, NULL, 'G3DSA:3.40.50.150:FF:000814', NULL, NULL, 'Methyltransferase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(179641, NULL, 'G3DSA:1.25.40.10:FF:000066', NULL, NULL, 'Tetratricopeptide repeat domain 7A', NULL, NULL, NULL, NULL, NULL, 4),
(179642, NULL, 'G3DSA:1.20.1050.90:FF:000014', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(179643, NULL, 'G3DSA:3.90.640.90:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179644, NULL, 'G3DSA:2.130.10.10:FF:002629', NULL, NULL, 'WD repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(179645, NULL, 'G3DSA:3.40.1110.10:FF:000186', NULL, NULL, 'Calcium-transporting ATPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(179646, NULL, 'G3DSA:1.10.8.60:FF:000280', NULL, NULL, 'Spermatogenesis associated 5', NULL, NULL, NULL, NULL, NULL, 4),
(179647, NULL, 'G3DSA:1.10.418.10:FF:000011', NULL, NULL, 'Parvin, beta', NULL, NULL, NULL, NULL, NULL, 4),
(179648, NULL, 'G3DSA:1.10.287.3240:FF:000007', NULL, NULL, 'V-type ATP synthase subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(179649, NULL, 'G3DSA:3.40.47.10:FF:000232', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179650, NULL, 'G3DSA:2.40.10.10:FF:000189', NULL, NULL, 'Ovochymase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(179651, NULL, 'G3DSA:1.25.40.10:FF:003516', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(179652, NULL, 'G3DSA:1.20.1250.20:FF:000357', NULL, NULL, 'Glucose transporter, lmgt1', NULL, NULL, NULL, NULL, NULL, 4),
(179653, NULL, 'G3DSA:1.10.8.100:FF:000021', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(179654, NULL, 'G3DSA:3.40.50.1700:FF:000025', NULL, NULL, 'Putative sugar hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(179655, NULL, 'G3DSA:1.20.1560.10:FF:000338', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(179656, NULL, 'G3DSA:2.70.98.20:FF:000016', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(179657, NULL, 'G3DSA:3.40.50.2300:FF:001301', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179658, NULL, 'G3DSA:2.130.10.10:FF:005974', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179659, NULL, 'G3DSA:1.10.510.10:FF:001002', NULL, NULL, 'Protein CBG10779', NULL, NULL, NULL, NULL, NULL, 4),
(179660, NULL, 'G3DSA:2.30.110.10:FF:000018', NULL, NULL, 'Deazaflavin-dependent oxidoreductase, nitroreductase family', NULL, NULL, NULL, NULL, NULL, 4),
(179661, NULL, 'G3DSA:2.40.50.1070:FF:000005', NULL, NULL, 'tRNA (Uracil-5-)-methyltransferase homolog A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(179662, NULL, 'G3DSA:3.30.40.10:FF:000043', NULL, NULL, 'Putative e3 ubiquitin-protein ligase march8', NULL, NULL, NULL, NULL, NULL, 4),
(179663, NULL, 'G3DSA:3.30.1310.10:FF:000001', NULL, NULL, 'Nucleoid-associated protein YbaB', NULL, NULL, NULL, NULL, NULL, 4),
(179664, NULL, 'G3DSA:3.40.1700.10:FF:000006', NULL, NULL, 'Diadenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(179665, NULL, 'G3DSA:3.40.1090.10:FF:000009', NULL, NULL, 'Patatin like phospholipase domain containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(179666, NULL, 'G3DSA:1.10.210.10:FF:000001', NULL, NULL, 'Uteroglobin', NULL, NULL, NULL, NULL, NULL, 4),
(179667, NULL, 'G3DSA:4.10.1060.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179668, NULL, 'G3DSA:2.40.10.10:FF:000509', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179669, NULL, 'G3DSA:3.30.160.60:FF:004990', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179670, NULL, 'G3DSA:2.60.40.10:FF:006030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179671, NULL, 'G3DSA:3.80.10.10:FF:000882', NULL, NULL, 'Tubulin-folding cofactor E', NULL, NULL, NULL, NULL, NULL, 4),
(179672, NULL, 'G3DSA:3.10.20.90:FF:000179', NULL, NULL, 'Plant UBX domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(179673, NULL, 'G3DSA:2.60.40.10:FF:002444', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(179674, NULL, 'G3DSA:3.90.70.10:FF:000278', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(179675, NULL, 'G3DSA:3.60.21.10:FF:000172', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(179676, NULL, 'G3DSA:1.50.40.10:FF:000457', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(179677, NULL, 'G3DSA:1.10.510.10:FF:003391', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179678, NULL, 'G3DSA:3.30.70.580:FF:000067', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(179679, NULL, 'G3DSA:1.10.510.10:FF:000046', NULL, NULL, 'probable serine/threonine-protein kinase WNK9', NULL, NULL, NULL, NULL, NULL, 4),
(179680, NULL, 'G3DSA:1.25.40.10:FF:004461', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g28050', NULL, NULL, NULL, NULL, NULL, 4),
(179681, NULL, 'G3DSA:2.130.10.10:FF:000022', NULL, NULL, 'Coatomer subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(179682, NULL, 'G3DSA:1.10.10.60:FF:000011', NULL, NULL, 'Myb transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(179683, NULL, 'G3DSA:2.60.40.60:FF:000744', NULL, NULL, 'Fat-like cadherin-related tumor suppressor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(179684, NULL, 'G3DSA:3.40.50.10470:FF:000024', NULL, NULL, 'Translation initiation factor eIF-2B subunit alpha, putative', NULL, NULL, NULL, NULL, NULL, 4),
(179685, NULL, 'G3DSA:1.25.40.10:FF:004091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179686, NULL, 'G3DSA:3.40.190.10:FF:000540', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179687, NULL, 'G3DSA:3.30.200.20:FF:001767', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(179688, NULL, 'G3DSA:3.30.950.10:FF:000005', NULL, NULL, 'Uroporphyrin-III c-methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(179689, NULL, 'G3DSA:2.60.40.10:FF:005850', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179690, NULL, 'G3DSA:3.30.70.330:FF:000689', NULL, NULL, 'Small nuclear ribonucleoprotein U1 subunit 70', NULL, NULL, NULL, NULL, NULL, 4),
(179691, NULL, 'G3DSA:2.60.120.920:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179692, NULL, 'G3DSA:3.40.50.1000:FF:000821', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179693, NULL, 'G3DSA:3.30.559.30:FF:000091', NULL, NULL, 'Nonribosomal peptide synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(179694, NULL, 'G3DSA:2.130.10.120:FF:000009', NULL, NULL, 'Probable peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(179695, NULL, 'G3DSA:2.30.29.30:FF:000654', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(179696, NULL, 'G3DSA:1.10.3380.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179697, NULL, 'G3DSA:3.80.10.10:FF:001399', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179698, NULL, 'G3DSA:2.60.40.200:FF:000017', NULL, NULL, 'Extracellular superoxide dismutase [Cu-Zn] 2', NULL, NULL, NULL, NULL, NULL, 4),
(179699, NULL, 'G3DSA:2.30.29.30:FF:001143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179700, NULL, 'G3DSA:1.10.1420.10:FF:000134', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(179701, NULL, 'G3DSA:3.30.40.10:FF:001324', NULL, NULL, 'RING-H2 finger protein ATL7', NULL, NULL, NULL, NULL, NULL, 4),
(179702, NULL, 'G3DSA:3.30.160.60:FF:000948', NULL, NULL, 'Zinc finger protein 641', NULL, NULL, NULL, NULL, NULL, 4),
(179703, NULL, 'G3DSA:3.40.910.10:FF:000023', NULL, NULL, 'Deoxyhypusine synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(179704, NULL, 'G3DSA:1.10.10.60:FF:000820', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179705, NULL, 'G3DSA:3.40.720.10:FF:000323', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179706, NULL, 'G3DSA:1.10.510.10:FF:003289', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179707, NULL, 'G3DSA:2.130.10.10:FF:002276', NULL, NULL, 'Zinc finger CCCH domain-containing protein 48', NULL, NULL, NULL, NULL, NULL, 4),
(179708, NULL, 'G3DSA:3.40.50.1820:FF:000757', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179709, NULL, 'G3DSA:3.40.50.850:FF:000018', NULL, NULL, 'Streptothricin hydrolase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(179710, NULL, 'G3DSA:3.20.20.110:FF:000003', NULL, NULL, 'Ribulose bisphosphate carboxylase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(179711, NULL, 'G3DSA:1.10.506.10:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179712, NULL, 'G3DSA:2.40.70.10:FF:000209', NULL, NULL, 'Endopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(179713, NULL, 'G3DSA:3.40.50.2300:FF:001638', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179714, NULL, 'G3DSA:3.30.810.10:FF:000012', NULL, NULL, 'Phosphatidylinositol-4-phosphate 5-Kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(179715, NULL, 'G3DSA:1.10.100.10:FF:000009', NULL, NULL, 'Insulin-like peptide 4', NULL, NULL, NULL, NULL, NULL, 4),
(179716, NULL, 'G3DSA:3.40.50.2300:FF:000020', NULL, NULL, 'Glutamate receptor ionotropic, NMDA 2B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(179717, NULL, 'G3DSA:2.60.40.10:FF:005541', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179718, NULL, 'G3DSA:1.20.1530.20:FF:000047', NULL, NULL, 'Glutathione-regulated potassium-efflux system protein', NULL, NULL, NULL, NULL, NULL, 4),
(179719, NULL, 'G3DSA:3.40.190.10:FF:000877', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179720, NULL, 'G3DSA:3.10.150.10:FF:000027', NULL, NULL, 'Beta sliding clamp', NULL, NULL, NULL, NULL, NULL, 4),
(179721, NULL, 'G3DSA:3.30.70.330:FF:002504', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179722, NULL, 'G3DSA:1.20.1270.360:FF:000001', NULL, NULL, 'Copper storage protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(179723, NULL, 'G3DSA:1.25.10.10:FF:002716', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179724, NULL, 'G3DSA:1.25.40.10:FF:004444', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(179725, NULL, 'G3DSA:3.60.21.10:FF:000329', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(179726, NULL, 'G3DSA:3.40.50.720:FF:002233', NULL, NULL, '2-hydroxyacid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(179727, NULL, 'G3DSA:3.30.160.60:FF:002073', NULL, NULL, 'Zinc finger protein 214', NULL, NULL, NULL, NULL, NULL, 4),
(179728, NULL, 'G3DSA:3.80.10.10:FF:001062', NULL, NULL, 'lumican', NULL, NULL, NULL, NULL, NULL, 4),
(179729, NULL, 'G3DSA:3.80.10.10:FF:002490', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179730, NULL, 'G3DSA:1.10.10.10:FF:001890', NULL, NULL, 'Ferric uptake regulator, Fur family', NULL, NULL, NULL, NULL, NULL, 4),
(179731, NULL, 'G3DSA:1.10.437.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179732, NULL, 'G3DSA:3.90.550.10:FF:000265', NULL, NULL, 'Protein CBG07620', NULL, NULL, NULL, NULL, NULL, 4),
(179733, NULL, 'G3DSA:1.10.10.160:FF:000048', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(179734, NULL, 'G3DSA:3.30.40.10:FF:001763', NULL, NULL, 'AGAP003004-PA', NULL, NULL, NULL, NULL, NULL, 4),
(179735, NULL, 'G3DSA:3.30.420.300:FF:000001', NULL, NULL, '2-oxo-3-deoxygalactonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(179736, NULL, 'G3DSA:2.30.42.10:FF:000140', NULL, NULL, 'Multiple PDZ domain crumbs cell polarity complex component', NULL, NULL, NULL, NULL, NULL, 4),
(179737, NULL, 'G3DSA:3.80.10.10:FF:000926', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(179738, NULL, 'G3DSA:1.20.1050.10:FF:000108', NULL, NULL, 'Thiol-dependent reductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(179739, NULL, 'G3DSA:1.20.1070.10:FF:001099', NULL, NULL, '5-hydroxytryptamine receptor-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(179740, NULL, 'G3DSA:2.120.10.80:FF:000223', NULL, NULL, 'Kelch repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(179741, NULL, 'G3DSA:1.10.3080.10:FF:000034', NULL, NULL, 'Voltage-gated chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(179742, NULL, 'G3DSA:1.10.1420.10:FF:000004', NULL, NULL, 'DNA mismatch repair protein Msh3', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(179743, NULL, 'G3DSA:1.10.10.10:FF:000721', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(179744, NULL, 'G3DSA:1.20.870.10:FF:000031', NULL, NULL, 'Rap Guanine nucleotide Exchange Factor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(179745, NULL, 'G3DSA:3.30.160.60:FF:004029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179746, NULL, 'G3DSA:1.10.10.10:FF:001547', NULL, NULL, 'Putative dna-directed rna polymerase iii subunit rpc3', NULL, NULL, NULL, NULL, NULL, 4),
(179747, NULL, 'G3DSA:3.80.10.10:FF:002388', NULL, NULL, 'GD10134', NULL, NULL, NULL, NULL, NULL, 4),
(179748, NULL, 'G3DSA:3.30.420.610:FF:000021', NULL, NULL, 'Tudor domain-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(179749, NULL, 'G3DSA:2.130.10.10:FF:000831', NULL, NULL, 'Polyadenylation factor subunit 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(179750, NULL, 'G3DSA:3.20.20.70:FF:000341', NULL, NULL, 'Glycoside hydrolase family 36', NULL, NULL, NULL, NULL, NULL, 4),
(179751, NULL, 'G3DSA:3.40.50.620:FF:000859', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179752, NULL, 'G3DSA:1.10.1220.10:FF:000006', NULL, NULL, 'Bifunctional protein PutA', NULL, NULL, NULL, NULL, NULL, 4),
(179753, NULL, 'G3DSA:3.40.30.10:FF:000093', NULL, NULL, 'Glutaredoxin 2', NULL, NULL, NULL, NULL, NULL, 4),
(179754, NULL, 'G3DSA:1.25.10.10:FF:001862', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(179755, NULL, 'G3DSA:3.40.50.2300:FF:001481', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179756, NULL, 'G3DSA:3.40.50.1000:FF:000719', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179757, NULL, 'G3DSA:2.40.50.140:FF:000231', NULL, NULL, 'RNA methyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(179758, NULL, 'G3DSA:1.25.40.180:FF:000292', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179759, NULL, 'G3DSA:1.20.1250.20:FF:001846', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179760, NULL, 'G3DSA:3.40.630.10:FF:000102', NULL, NULL, 'N-acetylated-alpha-linked acidic dipeptidase protein', NULL, NULL, NULL, NULL, NULL, 4),
(179761, NULL, 'G3DSA:3.30.1520.10:FF:000186', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(179762, NULL, 'G3DSA:1.25.40.70:FF:000038', NULL, NULL, 'Phosphoinositide-3-kinase, catalytic, alpha polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(179763, NULL, 'G3DSA:3.40.50.300:FF:000426', NULL, NULL, 'Ferrous iron transport protein B', NULL, NULL, NULL, NULL, NULL, 4),
(179764, NULL, 'G3DSA:3.30.1330.10:FF:000014', NULL, NULL, 'Selenophosphate synthetase 2', NULL, NULL, NULL, NULL, NULL, 4),
(179765, NULL, 'G3DSA:2.40.30.170:FF:000016', NULL, NULL, 'Efflux transporter, RND family, MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(179766, NULL, 'G3DSA:3.30.160.60:FF:003692', NULL, NULL, 'Zinc finger protein ZAT10', NULL, NULL, NULL, NULL, NULL, 4),
(179767, NULL, 'G3DSA:3.30.60.60:FF:000008', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(179768, NULL, 'G3DSA:2.130.10.10:FF:002731', NULL, NULL, 'WD repeat domain phosphoinositide-interacting protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(179769, NULL, 'G3DSA:3.40.30.10:FF:000576', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(179770, NULL, 'G3DSA:2.60.40.10:FF:004922', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179771, NULL, 'G3DSA:1.10.10.60:FF:001000', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179772, NULL, 'G3DSA:2.20.25.530:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179773, NULL, 'G3DSA:2.60.40.1400:FF:000010', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(179774, NULL, 'G3DSA:2.60.40.10:FF:001488', NULL, NULL, 'Interleukin-10 receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(179775, NULL, 'G3DSA:3.30.420.10:FF:000201', NULL, NULL, 'Piwi-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(179776, NULL, 'G3DSA:1.25.40.10:FF:000419', NULL, NULL, 'Outer membrane protein assembly factor BamD', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(179777, NULL, 'G3DSA:3.40.1360.10:FF:000036', NULL, NULL, 'SPO11 meiotic protein covalently-bound to DSB', NULL, NULL, NULL, NULL, NULL, 4),
(179778, NULL, 'G3DSA:3.30.160.60:FF:006255', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179779, NULL, 'G3DSA:2.60.120.200:FF:000431', NULL, NULL, 'Concanavalin A-like lectin/glucanase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(179780, NULL, 'G3DSA:2.40.320.10:FF:000021', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 18', NULL, NULL, NULL, NULL, NULL, 4),
(179781, NULL, 'G3DSA:3.40.50.740:FF:000002', NULL, NULL, 'NADH-ubiquinone oxidoreductase 75 kDa subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(179782, NULL, 'G3DSA:3.60.20.30:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179783, NULL, 'G3DSA:1.20.1250.10:FF:000028', NULL, NULL, 'Granulocyte-macrophage colony-stimulating factor', NULL, NULL, NULL, NULL, NULL, 4),
(179784, NULL, 'G3DSA:1.10.720.50:FF:000001', NULL, NULL, 'DNA (Cytosine-5)-methyltransferase 3B isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(179785, NULL, 'G3DSA:2.60.120.10:FF:000703', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179786, NULL, 'G3DSA:1.10.10.2210:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179787, NULL, 'G3DSA:3.40.630.30:FF:000108', NULL, NULL, 'Polyamine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(179788, NULL, 'G3DSA:3.30.70.330:FF:001987', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179789, NULL, 'G3DSA:1.20.920.30:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179790, NULL, 'G3DSA:1.25.40.10:FF:003163', NULL, NULL, 'Os08g0340900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(179791, NULL, 'G3DSA:3.40.50.2300:FF:000312', NULL, NULL, 'Glutamate ionotropic receptor NMDA type subunit 2B', NULL, NULL, NULL, NULL, NULL, 4),
(179792, NULL, 'G3DSA:2.40.30.10:FF:000191', NULL, NULL, 'Sulfate adenylyltransferase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(179793, NULL, 'G3DSA:2.30.330.10:FF:000001', NULL, NULL, 'Flagellar motor switch protein FliN', NULL, NULL, NULL, NULL, NULL, 4),
(179794, NULL, 'G3DSA:1.10.10.200:FF:000004', NULL, NULL, 'Probable transcriptional regulatory protein BSBG_02618', NULL, NULL, NULL, NULL, NULL, 4),
(179795, NULL, 'G3DSA:3.10.129.110:FF:000010', NULL, NULL, 'CurK', NULL, NULL, NULL, NULL, NULL, 4),
(179796, NULL, 'G3DSA:2.30.30.40:FF:000391', NULL, NULL, 'ITSN (Intersectin) family', NULL, NULL, NULL, NULL, NULL, 4),
(179797, NULL, 'G3DSA:2.60.40.200:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179798, NULL, 'G3DSA:2.30.30.490:FF:000047', NULL, NULL, 'Protein CBR-LIN-40', NULL, NULL, NULL, NULL, NULL, 4),
(179799, NULL, 'G3DSA:2.60.40.150:FF:000334', NULL, NULL, 'Phosphatidylinositol 3-kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(179800, NULL, 'G3DSA:1.20.1250.20:FF:001054', NULL, NULL, 'Glucitol/sorbitol-specific transport protein GutA', NULL, NULL, NULL, NULL, NULL, 4),
(179801, NULL, 'G3DSA:1.10.555.10:FF:000144', NULL, NULL, 'inositol polyphosphate 5-phosphatase OCRL-1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(179802, NULL, 'G3DSA:4.10.1060.10:FF:000036', NULL, NULL, 'SUPPRESSOR OF ABI3-5 like', NULL, NULL, NULL, NULL, NULL, 4),
(179803, NULL, 'G3DSA:2.60.34.20:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179804, NULL, 'G3DSA:3.90.1720.10:FF:000013', NULL, NULL, 'Calcium-binding mitochondrial carrier protein SCaMC-1', NULL, NULL, NULL, NULL, NULL, 4),
(179805, NULL, 'G3DSA:3.40.50.1700:FF:000042', NULL, NULL, 'Glycoside hydrolase superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(179806, NULL, 'G3DSA:1.10.287.3240:FF:000024', NULL, NULL, 'V-type ATP synthase subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(179807, NULL, 'G3DSA:1.25.40.20:FF:000086', NULL, NULL, 'Death associated protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(179808, NULL, 'G3DSA:2.60.40.10:FF:004361', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(179809, NULL, 'G3DSA:2.40.170.20:FF:000080', NULL, NULL, 'SusC/RagA family TonB-linked outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(179810, NULL, 'G3DSA:3.50.30.30:FF:000154', NULL, NULL, 'Glutamate carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(179811, NULL, 'G3DSA:3.20.20.80:FF:000670', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(179812, NULL, 'G3DSA:3.40.50.720:FF:000108', NULL, NULL, 'dTDP-glucose 4,6-dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(179813, NULL, 'G3DSA:3.40.50.1000:FF:000158', NULL, NULL, 'Phosphoserine phosphatase SerB', NULL, NULL, NULL, NULL, NULL, 4),
(179814, NULL, 'G3DSA:2.130.10.10:FF:001320', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(179815, NULL, 'G3DSA:1.25.40.180:FF:000275', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179816, NULL, 'G3DSA:2.40.240.10:FF:000048', NULL, NULL, 'Glutamine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(179817, NULL, 'G3DSA:3.30.1520.10:FF:000169', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(179818, NULL, 'G3DSA:1.10.510.10:FF:003744', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179819, NULL, 'G3DSA:3.40.50.620:FF:000904', NULL, NULL, 'Peptidase family M48 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(179820, NULL, 'G3DSA:1.10.565.10:FF:000072', NULL, NULL, 'Nuclear hormone receptor family member nhr-3', NULL, NULL, NULL, NULL, NULL, 4),
(179821, NULL, 'G3DSA:2.170.270.10:FF:000076', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(179822, NULL, 'G3DSA:3.40.1190.20:FF:000082', NULL, NULL, 'ADP-dependent (S)-NAD(P)H-hydrate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(179823, NULL, 'G3DSA:3.30.160.60:FF:000156', NULL, NULL, 'Zinc finger protein 568', NULL, NULL, NULL, NULL, NULL, 4),
(179824, NULL, 'G3DSA:2.40.10.10:FF:000644', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179825, NULL, 'G3DSA:3.40.50.300:FF:004608', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(179826, NULL, 'G3DSA:1.20.1070.10:FF:000582', NULL, NULL, 'Muscarinic acetylcholine receptor gar-3', NULL, NULL, NULL, NULL, NULL, 4),
(179827, NULL, 'G3DSA:2.40.50.180:FF:000001', NULL, NULL, 'Chemotaxis protein CheW', NULL, NULL, NULL, NULL, NULL, 4),
(179828, NULL, 'G3DSA:1.10.10.10:FF:001255', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(179829, NULL, 'G3DSA:2.60.120.650:FF:000009', NULL, NULL, 'Putative lysine-specific demethylase 6B', NULL, NULL, NULL, NULL, NULL, 4),
(179830, NULL, 'G3DSA:1.20.1070.10:FF:000891', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179831, NULL, 'G3DSA:1.20.120.790:FF:000033', NULL, NULL, 'Endoplasmin', NULL, NULL, NULL, NULL, NULL, 4),
(179832, NULL, 'G3DSA:3.40.50.150:FF:001792', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179833, NULL, 'G3DSA:1.25.40.10:FF:003955', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g29710, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(179834, NULL, 'G3DSA:2.60.40.150:FF:000204', NULL, NULL, 'No pollen', NULL, NULL, NULL, NULL, NULL, 4),
(179835, NULL, 'G3DSA:1.10.730.10:FF:000074', NULL, NULL, 'Nam2p', NULL, NULL, NULL, NULL, NULL, 4),
(179836, NULL, 'G3DSA:3.10.490.20:FF:000022', NULL, NULL, 'Cytoplasmic dynein 2 heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(179837, NULL, 'G3DSA:3.80.10.10:FF:000590', NULL, NULL, 'Leucine-rich receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(179838, NULL, 'G3DSA:3.30.160.60:FF:001567', NULL, NULL, 'Paternally expressed 3', NULL, NULL, NULL, NULL, NULL, 4),
(179839, NULL, 'G3DSA:1.25.40.20:FF:000395', NULL, NULL, 'caskin-1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(179840, NULL, 'G3DSA:3.40.1500.10:FF:000008', NULL, NULL, 'Coproporphyrinogen-III oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(179841, NULL, 'G3DSA:3.30.70.3250:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179842, NULL, 'G3DSA:3.30.70.330:FF:001195', NULL, NULL, 'RNA-binding protein TIA-1, putative', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(179843, NULL, 'G3DSA:3.40.720.10:FF:000340', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179844, NULL, 'G3DSA:1.20.120.230:FF:000034', NULL, NULL, 'Alpha-catenin-like protein hmp-1', NULL, NULL, NULL, NULL, NULL, 4),
(179845, NULL, 'G3DSA:3.40.50.300:FF:006997', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(179846, NULL, 'G3DSA:3.30.420.40:FF:000699', NULL, NULL, 'L-fuculose kinase', NULL, NULL, NULL, NULL, NULL, 4),
(179847, NULL, 'G3DSA:3.40.50.1110:FF:000062', NULL, NULL, 'GDSL-motif lipase/hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(179848, NULL, 'G3DSA:3.40.50.150:FF:000359', NULL, NULL, 'S-adenosyl-methyltransferase Mraw', NULL, NULL, NULL, NULL, NULL, 4),
(179849, NULL, 'G3DSA:1.20.1070.10:FF:001071', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(179850, NULL, 'G3DSA:3.80.10.10:FF:001854', NULL, NULL, 'YALI0B18759p', NULL, NULL, NULL, NULL, NULL, 4),
(179851, NULL, 'G3DSA:2.10.25.10:FF:000264', NULL, NULL, 'Fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(179852, NULL, 'G3DSA:1.25.40.10:FF:003808', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179853, NULL, 'G3DSA:3.30.40.10:FF:000835', NULL, NULL, 'E3 ubiquitin-protein ligase CIP8', NULL, NULL, NULL, NULL, NULL, 4),
(179854, NULL, 'G3DSA:3.30.420.40:FF:000671', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179855, NULL, 'G3DSA:2.130.10.10:FF:006019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179856, NULL, 'G3DSA:2.60.40.60:FF:000261', NULL, NULL, 'Cadherin-related family member 5', NULL, NULL, NULL, NULL, NULL, 4),
(179857, NULL, 'G3DSA:3.40.640.10:FF:000030', NULL, NULL, 'Low-specificity L-threonine aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(179858, NULL, 'G3DSA:3.30.300.20:FF:000066', NULL, NULL, '30S ribosomal protein S3, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(179859, NULL, 'G3DSA:1.25.10.10:FF:000890', NULL, NULL, 'Hsh155p', NULL, NULL, NULL, NULL, NULL, 4),
(179860, NULL, 'G3DSA:3.30.40.10:FF:001471', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179861, NULL, 'G3DSA:3.30.40.10:FF:002297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179862, NULL, 'G3DSA:1.20.120.1320:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179863, NULL, 'G3DSA:3.40.190.10:FF:000085', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(179864, NULL, 'G3DSA:3.30.420.40:FF:000980', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(179865, NULL, 'G3DSA:2.10.220.10:FF:000200', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5a', NULL, NULL, NULL, NULL, NULL, 4),
(179866, NULL, 'G3DSA:3.40.50.300:FF:007486', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(179867, NULL, 'G3DSA:3.40.50.10090:FF:000017', NULL, NULL, 'Uroporphyrinogen-III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(179868, NULL, 'G3DSA:1.10.287.110:FF:000438', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179869, NULL, 'G3DSA:1.10.10.10:FF:000619', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(179870, NULL, 'G3DSA:3.40.50.300:FF:001045', NULL, NULL, 'ATP-dependent RNA helicase DDX50 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(179871, NULL, 'G3DSA:2.10.25.10:FF:000573', NULL, NULL, 'Neurocan core protein', NULL, NULL, NULL, NULL, NULL, 4),
(179872, NULL, 'G3DSA:1.20.1420.30:FF:000031', NULL, NULL, 'K+-dependent Na+/Ca+ exchanger related-protein', NULL, NULL, NULL, NULL, NULL, 4),
(179873, NULL, 'G3DSA:1.25.10.10:FF:000581', NULL, NULL, 'HEAT repeat-containing protein 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(179874, NULL, 'G3DSA:3.30.930.10:FF:000414', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(179875, NULL, 'G3DSA:3.40.630.10:FF:000232', NULL, NULL, 'Carboxypeptidase T, putative', NULL, NULL, NULL, NULL, NULL, 4),
(179876, NULL, 'G3DSA:3.70.10.10:FF:000079', NULL, NULL, 'DNA polymerase sliding clamp 2', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(179877, NULL, 'G3DSA:1.25.40.10:FF:001038', NULL, NULL, 'Transmembrane and tetratricopeptide repeat containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(179878, NULL, 'G3DSA:3.40.1050.10:FF:000035', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(179879, NULL, 'G3DSA:1.20.120.1750:FF:000025', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(179880, NULL, 'G3DSA:3.30.200.20:FF:000339', NULL, NULL, 'serine/threonine-protein kinase Nek10', NULL, NULL, NULL, NULL, NULL, 4),
(179881, NULL, 'G3DSA:3.40.50.150:FF:000022', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase B', NULL, NULL, NULL, NULL, NULL, 4),
(179882, NULL, 'G3DSA:3.40.1340.10:FF:000006', NULL, NULL, 'RNA polymerase Rpb5 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(179883, NULL, 'G3DSA:3.40.800.10:FF:000032', NULL, NULL, 'Arginase', NULL, NULL, NULL, NULL, NULL, 4),
(179884, NULL, 'G3DSA:2.10.25.10:FF:001062', NULL, NULL, 'Stabilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(179885, NULL, 'G3DSA:2.40.50.140:FF:000129', NULL, NULL, 'Single-stranded DNA-binding protein 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(179886, NULL, 'G3DSA:1.10.238.10:FF:000385', NULL, NULL, 'AGAP010191-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(179887, NULL, 'G3DSA:1.25.40.10:FF:002544', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(179888, NULL, 'G3DSA:3.30.40.10:FF:001780', NULL, NULL, 'General transcription factor IIH subunit', NULL, NULL, NULL, NULL, NULL, 4),
(179889, NULL, 'G3DSA:2.60.40.60:FF:000289', NULL, NULL, 'cadherin-86C isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(179890, NULL, 'G3DSA:1.10.287.1490:FF:000004', NULL, NULL, 'nucleoprotein TPR isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(179891, NULL, 'G3DSA:1.10.150.20:FF:000212', NULL, NULL, 'AGAP002805-PA', NULL, NULL, NULL, NULL, NULL, 4),
(179892, NULL, 'G3DSA:1.10.150.50:FF:000064', NULL, NULL, 'arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(179893, NULL, 'G3DSA:1.10.287.110:FF:000410', NULL, NULL, 'Chaperone protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(179894, NULL, 'G3DSA:3.30.1330.10:FF:000031', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(179895, NULL, 'G3DSA:1.10.3200.20:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179896, NULL, 'G3DSA:1.25.40.10:FF:002191', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g18110, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(179897, NULL, 'G3DSA:1.20.1420.10:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179898, NULL, 'G3DSA:3.40.50.1240:FF:000207', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179899, NULL, 'G3DSA:2.60.40.10:FF:005069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179900, NULL, 'G3DSA:3.40.50.300:FF:000657', NULL, NULL, 'Probable ATP-dependent RNA helicase DDX41', NULL, NULL, NULL, NULL, NULL, 4),
(179901, NULL, 'G3DSA:3.40.50.920:FF:000051', NULL, NULL, '2-oxoacid:ferredoxin oxidoreductase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(179902, NULL, 'G3DSA:2.60.300.12:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179903, NULL, 'G3DSA:1.20.58.390:FF:000066', NULL, NULL, 'Acetylcholine receptor subunit alpha-type unc-63', NULL, NULL, NULL, NULL, NULL, 4),
(179904, NULL, 'G3DSA:1.10.510.10:FF:003952', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179905, NULL, 'G3DSA:1.20.5.190:FF:000006', NULL, NULL, 'Myosin VA', NULL, NULL, NULL, NULL, NULL, 4),
(179906, NULL, 'G3DSA:3.40.1670.10:FF:000008', NULL, NULL, 'UbiD family decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(179907, NULL, 'G3DSA:1.25.40.90:FF:000016', NULL, NULL, 'mRNA cleavage factor complex component Pcf11', NULL, NULL, NULL, NULL, NULL, 4),
(179908, NULL, 'G3DSA:2.130.10.10:FF:002500', NULL, NULL, 'HEAT repeat domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(179909, NULL, 'G3DSA:3.50.7.10:FF:000023', NULL, NULL, 'T-complex protein 1 subunit beta, putative', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(179910, NULL, 'G3DSA:2.60.120.40:FF:000038', NULL, NULL, 'CD70 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(179911, NULL, 'G3DSA:3.40.50.150:FF:001348', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179912, NULL, 'G3DSA:3.80.10.10:FF:001427', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(179913, NULL, 'G3DSA:1.20.1250.20:FF:001863', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179914, NULL, 'G3DSA:2.60.120.650:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179915, NULL, 'G3DSA:1.20.1440.90:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179916, NULL, 'G3DSA:1.20.120.1750:FF:000008', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(179917, NULL, 'G3DSA:3.40.1280.10:FF:000052', NULL, NULL, 'Putative tRNA (cytidine(34)-2''-O)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(179918, NULL, 'G3DSA:2.60.120.10:FF:000142', NULL, NULL, 'Solute carrier family 9 member C2 (putative)', NULL, NULL, NULL, NULL, NULL, 4),
(179919, NULL, 'G3DSA:3.30.160.60:FF:006238', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179920, NULL, 'G3DSA:2.60.40.3980:FF:000002', NULL, NULL, 'Cell fusion protein aff-1', NULL, NULL, NULL, NULL, NULL, 4),
(179921, NULL, 'G3DSA:2.30.30.1020:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179922, NULL, 'G3DSA:3.40.50.1820:FF:001685', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(179923, NULL, 'G3DSA:2.130.10.10:FF:001348', NULL, NULL, 'DDB1-and CUL4-associated factor 12-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(179924, NULL, 'G3DSA:3.80.10.10:FF:004496', NULL, NULL, 'Probable serine/threonine-protein kinase DDB_G0278509', NULL, NULL, NULL, NULL, NULL, 4),
(179925, NULL, 'G3DSA:3.10.20.90:FF:000960', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179926, NULL, 'G3DSA:2.20.100.10:FF:000245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179927, NULL, 'G3DSA:3.40.30.10:FF:000901', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179928, NULL, 'G3DSA:1.25.40.20:FF:001575', NULL, NULL, 'Diversin', NULL, NULL, NULL, NULL, NULL, 4),
(179929, NULL, 'G3DSA:1.10.10.440:FF:000042', NULL, NULL, 'Pre-mRNA-splicing factor URN1', NULL, NULL, NULL, NULL, NULL, 4),
(179930, NULL, 'G3DSA:3.30.450.50:FF:000046', NULL, NULL, 'Synaptobrevin-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(179931, NULL, 'G3DSA:3.90.660.60:FF:000001', NULL, NULL, 'Tryptophan 2-monooxygenase oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(179932, NULL, 'G3DSA:3.30.505.10:FF:000241', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179933, NULL, 'G3DSA:3.10.50.40:FF:000014', NULL, NULL, 'Chaperone SurA', NULL, NULL, NULL, NULL, NULL, 4),
(179934, NULL, 'G3DSA:1.25.40.20:FF:000147', NULL, NULL, 'Ankyrin repeat and SOCS box containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(179935, NULL, 'G3DSA:3.30.470.160:FF:000008', NULL, NULL, 'Kinase', NULL, NULL, NULL, NULL, NULL, 4),
(179936, NULL, 'G3DSA:1.25.10.10:FF:001199', NULL, NULL, 'Armadillo/beta-catenin repeat-like', NULL, NULL, NULL, NULL, NULL, 4),
(179937, NULL, 'G3DSA:1.20.58.930:FF:000008', NULL, NULL, 'Arginine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(179938, NULL, 'G3DSA:2.30.30.60:FF:000003', NULL, NULL, 'Predicted mechanosensitive ion channel', NULL, NULL, NULL, NULL, NULL, 4),
(179939, NULL, 'G3DSA:3.90.950.10:FF:000003', NULL, NULL, 'Inosine triphosphate pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(179940, NULL, 'G3DSA:3.40.50.150:FF:001303', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179941, NULL, 'G3DSA:1.10.260.100:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179942, NULL, 'G3DSA:3.40.50.10490:FF:000002', NULL, NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', NULL, NULL, NULL, NULL, NULL, 4),
(179943, NULL, 'G3DSA:1.10.275.10:FF:000015', NULL, NULL, '3-carboxy-cis,cis-muconate cycloisomerase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(179944, NULL, 'G3DSA:3.40.50.1820:FF:001112', NULL, NULL, 'Secreted tripeptidyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(179945, NULL, 'G3DSA:1.10.510.10:FF:002328', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179946, NULL, 'G3DSA:2.40.110.10:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179947, NULL, 'G3DSA:3.80.10.10:FF:001270', NULL, NULL, 'F-box/LRR-repeat protein 4 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(179948, NULL, 'G3DSA:1.10.1200.10:FF:000095', NULL, NULL, 'Acyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(179949, NULL, 'G3DSA:3.30.470.30:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179950, NULL, 'G3DSA:2.60.40.10:FF:003416', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179951, NULL, 'G3DSA:1.10.287.70:FF:000544', NULL, NULL, 'TOK2 potassium channel', NULL, NULL, NULL, NULL, NULL, 4),
(179952, NULL, 'G3DSA:3.90.70.40:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179953, NULL, 'G3DSA:1.25.10.10:FF:000007', NULL, NULL, 'ARVCF, delta catenin family member', NULL, NULL, NULL, NULL, NULL, 4),
(179954, NULL, 'G3DSA:3.40.190.10:FF:000669', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179955, NULL, 'G3DSA:3.40.50.300:FF:007677', NULL, NULL, 'Putative ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(179956, NULL, 'G3DSA:3.30.160.60:FF:002865', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(179957, NULL, 'G3DSA:3.30.200.20:FF:002464', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(179958, NULL, 'G3DSA:3.40.50.720:FF:002508', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(179959, NULL, 'G3DSA:3.40.50.1820:FF:001584', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179960, NULL, 'G3DSA:1.10.405.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179961, NULL, 'G3DSA:2.60.200.20:FF:000078', NULL, NULL, 'Unplaced genomic scaffold supercont1.19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(179962, NULL, 'G3DSA:3.20.20.80:FF:000653', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179963, NULL, 'G3DSA:3.90.550.50:FF:000018', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(179964, NULL, 'G3DSA:1.25.40.10:FF:000049', NULL, NULL, 'Alpha-soluble NSF attachment protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(179965, NULL, 'G3DSA:3.40.470.10:FF:000022', NULL, NULL, 'Uracil-DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(179966, NULL, 'G3DSA:3.10.250.10:FF:000063', NULL, NULL, 'RIKEN cDNA 5830411N06 gene', NULL, NULL, NULL, NULL, NULL, 4),
(179967, NULL, 'G3DSA:2.30.30.380:FF:000014', NULL, NULL, 'sharpin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(179968, NULL, 'G3DSA:3.60.20.10:FF:000001', NULL, NULL, 'Glutamate synthase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(179969, NULL, 'G3DSA:1.25.10.10:FF:002155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179970, NULL, 'G3DSA:3.40.50.720:FF:002497', NULL, NULL, 'Sterigmatocystin biosynthesis fatty acid synthase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(179971, NULL, 'G3DSA:1.10.1670.10:FF:000034', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(179972, NULL, 'G3DSA:3.40.630.10:FF:000024', NULL, NULL, 'ATP/GTP binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(179973, NULL, 'G3DSA:2.40.10.170:FF:000018', NULL, NULL, 'ATP synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(179974, NULL, 'G3DSA:3.90.1150.10:FF:000076', NULL, NULL, 'Cysteine desulfurase', NULL, NULL, NULL, NULL, NULL, 4),
(179975, NULL, 'G3DSA:1.20.1070.10:FF:001863', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179976, NULL, 'G3DSA:1.10.720.30:FF:000006', NULL, NULL, 'Cell division cycle and apoptosis regulator protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(179977, NULL, 'G3DSA:1.10.10.10:FF:001210', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(179978, NULL, 'G3DSA:1.10.10.60:FF:000511', NULL, NULL, 'Bacterial regulatory s, tetR family protein', NULL, NULL, NULL, NULL, NULL, 4),
(179979, NULL, 'G3DSA:3.30.1390.30:FF:000001', NULL, NULL, 'Peptidoglycan D,D-transpeptidase MrdA', NULL, NULL, NULL, NULL, NULL, 4),
(179980, NULL, 'G3DSA:1.25.40.210:FF:000008', NULL, NULL, 'Telomeric repeat binding factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(179981, NULL, 'G3DSA:2.30.30.40:FF:000048', NULL, NULL, 'Chemotaxis protein CheA, putative', NULL, NULL, NULL, NULL, NULL, 4),
(179982, NULL, 'G3DSA:2.130.10.10:FF:000522', NULL, NULL, 'WD repeat domain 90', NULL, NULL, NULL, NULL, NULL, 4),
(179983, NULL, 'G3DSA:2.60.40.10:FF:000971', NULL, NULL, 'leucine-rich repeat, immunoglobulin-like domain and transmembrane domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(179984, NULL, 'G3DSA:3.90.70.10:FF:000380', NULL, NULL, 'Protein CBG01315', NULL, NULL, NULL, NULL, NULL, 4),
(179985, NULL, 'G3DSA:2.60.120.620:FF:000113', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(179986, NULL, 'G3DSA:3.50.50.60:FF:000361', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(179987, NULL, 'G3DSA:1.25.40.660:FF:000014', NULL, NULL, 'Vacuolar protein sorting-associated protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(179988, NULL, 'G3DSA:3.30.70.260:FF:000089', NULL, NULL, 'Arogenate dehydratase/prephenate dehydratase 1', NULL, NULL, NULL, NULL, NULL, 4),
(179989, NULL, 'G3DSA:2.60.120.1440:FF:000016', NULL, NULL, 'Putative anti-sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(179990, NULL, 'G3DSA:1.25.40.1010:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179991, NULL, 'G3DSA:3.40.50.300:FF:000909', NULL, NULL, 'Putative ATP-dependent RNA helicase DDX11', NULL, NULL, NULL, NULL, NULL, 4),
(179992, NULL, 'G3DSA:1.10.510.10:FF:001491', NULL, NULL, 'Kinase, CAMK CAMKL', NULL, NULL, NULL, NULL, NULL, 4),
(179993, NULL, 'G3DSA:3.80.10.10:FF:001219', NULL, NULL, 'Serine/threonine-protein kinase 11-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(179994, NULL, 'G3DSA:3.40.50.10330:FF:000106', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(179995, NULL, 'G3DSA:3.40.640.10:FF:000261', NULL, NULL, 'Aromatic aminotransferase ISS1', NULL, NULL, NULL, NULL, NULL, 4),
(179996, NULL, 'G3DSA:1.20.58.60:FF:000654', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(179997, NULL, 'G3DSA:3.30.565.10:FF:000481', NULL, NULL, 'Postmeiotic segregation increased 2-like protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(179998, NULL, 'G3DSA:1.10.3060.10:FF:000016', NULL, NULL, 'Protein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(179999, NULL, 'G3DSA:2.20.100.10:FF:000200', NULL, NULL, 'Semaphorin 5c, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(180000, NULL, 'G3DSA:1.20.1070.10:FF:000935', NULL, NULL, 'Serpentine receptor class gamma', NULL, NULL, NULL, NULL, NULL, 4),
(180001, NULL, 'G3DSA:3.30.160.60:FF:005518', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180002, NULL, 'G3DSA:3.40.50.300:FF:007469', NULL, NULL, 'ATP-binding cassette transporter pdr1', NULL, NULL, NULL, NULL, NULL, 4),
(180003, NULL, 'G3DSA:1.10.3720.10:FF:000163', NULL, NULL, 'Putative 2-aminoethylphosphonate ABC transporter permease subunit', NULL, NULL, NULL, NULL, NULL, 4),
(180004, NULL, 'G3DSA:1.20.1250.20:FF:001655', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180005, NULL, 'G3DSA:3.40.50.300:FF:001062', NULL, NULL, 'NLR family CARD domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(180006, NULL, 'G3DSA:3.60.110.10:FF:000087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180007, NULL, 'G3DSA:1.10.472.10:FF:000412', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180008, NULL, 'G3DSA:2.130.10.10:FF:003692', NULL, NULL, 'Transducin beta chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180009, NULL, 'G3DSA:3.30.565.10:FF:000054', NULL, NULL, 'Heat shock protein 90', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(180010, NULL, 'G3DSA:1.25.40.10:FF:004652', NULL, NULL, 'Tetratricopeptide repeat domain 21A', NULL, NULL, NULL, NULL, NULL, 4),
(180011, NULL, 'G3DSA:3.40.30.10:FF:000593', NULL, NULL, 'DSBA family oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(180012, NULL, 'G3DSA:3.10.450.240:FF:000027', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(180013, NULL, 'G3DSA:3.90.226.10:FF:000101', NULL, NULL, 'ATP-dependent Clp protease proteolytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(180014, NULL, 'G3DSA:3.40.630.10:FF:000333', NULL, NULL, 'Carboxypeptidase M', NULL, NULL, NULL, NULL, NULL, 4),
(180015, NULL, 'G3DSA:2.130.10.10:FF:002068', NULL, NULL, 'Polyadenylation factor subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(180016, NULL, 'G3DSA:2.170.120.30:FF:000003', NULL, NULL, 'YbbR-like domain-containing protein ybbR', NULL, NULL, NULL, NULL, NULL, 4),
(180017, NULL, 'G3DSA:2.102.10.10:FF:000001', NULL, NULL, 'Cytochrome b-c1 complex subunit Rieske, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(180018, NULL, 'G3DSA:1.25.40.120:FF:000072', NULL, NULL, 'Protein prenyltransferase alpha subunit repeat-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(180019, NULL, 'G3DSA:3.30.70.330:FF:002959', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180020, NULL, 'G3DSA:3.60.10.10:FF:000192', NULL, NULL, 'DNA-(apurinic or apyrimidinic site) lyase', NULL, NULL, NULL, NULL, NULL, 4),
(180021, NULL, 'G3DSA:1.20.5.110:FF:000353', NULL, NULL, 'Syntaxin-22', NULL, NULL, NULL, NULL, NULL, 4),
(180022, NULL, 'G3DSA:1.10.1280.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180023, NULL, 'G3DSA:3.30.505.10:FF:000033', NULL, NULL, 'RAS p21 protein activator 1', NULL, NULL, NULL, NULL, NULL, 4),
(180024, NULL, 'G3DSA:2.120.10.30:FF:000247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180025, NULL, 'G3DSA:3.90.320.10:FF:000017', NULL, NULL, 'Probable ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(180026, NULL, 'G3DSA:3.40.30.10:FF:000137', NULL, NULL, 'DnaJ homolog subfamily C member 10', NULL, NULL, NULL, NULL, NULL, 4),
(180027, NULL, 'G3DSA:3.30.160.60:FF:002281', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180028, NULL, 'G3DSA:1.10.1070.11:FF:000074', NULL, NULL, 'DJ576K7.1 (FK506 binding protein 12-rapamycin associated protein 1)', NULL, NULL, NULL, NULL, NULL, 4),
(180029, NULL, 'G3DSA:2.60.40.10:FF:004130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180030, NULL, 'G3DSA:3.40.50.150:FF:000623', NULL, NULL, 'Glutathione S-transferase C-terminal domain-containing protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(180031, NULL, 'G3DSA:3.40.50.300:FF:007941', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180032, NULL, 'G3DSA:3.20.20.210:FF:000016', NULL, NULL, 'Uroporphyrinogen decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(180033, NULL, 'G3DSA:2.40.30.10:FF:000044', NULL, NULL, 'Ferredoxin--NADP(+) reductase', NULL, NULL, NULL, NULL, NULL, 4),
(180034, NULL, 'G3DSA:3.40.50.1820:FF:001376', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180035, NULL, 'G3DSA:1.20.1310.10:FF:000163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180036, NULL, 'G3DSA:1.20.1250.20:FF:001155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180037, NULL, 'G3DSA:3.30.450.150:FF:000007', NULL, NULL, 'Cob(I)yrinic acid a,c-diamide adenosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(180038, NULL, 'G3DSA:3.90.1600.10:FF:000066', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(180039, NULL, 'G3DSA:2.130.10.10:FF:004529', NULL, NULL, 'WD40-repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(180040, NULL, 'G3DSA:3.20.20.300:FF:000043', NULL, NULL, 'Glycoside hydrolase family 3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(180041, NULL, 'G3DSA:3.40.50.720:FF:001536', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(180042, NULL, 'G3DSA:2.60.40.10:FF:004344', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(180043, NULL, 'G3DSA:3.30.70.100:FF:000103', NULL, NULL, 'Stress-response A/B barrel domain-containing protein UP3', NULL, NULL, NULL, NULL, NULL, 4),
(180044, NULL, 'G3DSA:4.10.280.10:FF:000128', NULL, NULL, 'Basic helix-loop-helix protein', NULL, NULL, NULL, NULL, NULL, 4),
(180045, NULL, 'G3DSA:1.10.287.630:FF:000004', NULL, NULL, 'Cyclic nucleotide-gated olfactory channel', NULL, NULL, NULL, NULL, NULL, 4),
(180046, NULL, 'G3DSA:3.40.50.1010:FF:000048', NULL, NULL, 'Ribonuclease VapC', NULL, NULL, NULL, NULL, NULL, 4),
(180047, NULL, 'G3DSA:3.30.1370.10:FF:000140', NULL, NULL, 'RNA-binding KH domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(180048, NULL, 'G3DSA:1.20.1270.10:FF:000119', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(180049, NULL, 'G3DSA:2.60.120.230:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180050, NULL, 'G3DSA:2.60.40.1120:FF:000021', NULL, NULL, 'Carboxypeptidase Z', NULL, NULL, NULL, NULL, NULL, 4),
(180051, NULL, 'G3DSA:3.10.10.10:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180052, NULL, 'G3DSA:2.60.40.10:FF:005878', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180053, NULL, 'G3DSA:1.20.58.2220:FF:000023', NULL, NULL, 'DAAM (Disheveled-Associated Activator of Morphogenesis) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(180054, NULL, 'G3DSA:2.70.150.10:FF:000006', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(180055, NULL, 'G3DSA:2.60.490.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180056, NULL, 'G3DSA:3.90.290.10:FF:000019', NULL, NULL, 'latent-transforming growth factor beta-binding protein 2 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(180057, NULL, 'G3DSA:1.10.220.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180058, NULL, 'G3DSA:2.60.120.200:FF:000223', NULL, NULL, 'Wing blister, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(180059, NULL, 'G3DSA:1.10.1410.10:FF:000077', NULL, NULL, 'Nucleotidyltransferase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(180060, NULL, 'G3DSA:3.40.50.10300:FF:000002', NULL, NULL, 'Phosphopantothenate--cysteine ligase 2', NULL, NULL, NULL, NULL, NULL, 4),
(180061, NULL, 'G3DSA:3.30.160.60:FF:003484', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180062, NULL, 'G3DSA:2.40.50.120:FF:000045', NULL, NULL, 'WAP, follistatin/kazal, immunoglobulin, kunitz and netrin domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(180063, NULL, 'G3DSA:3.50.50.60:FF:001069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180064, NULL, 'G3DSA:4.10.70.10:FF:000004', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(180065, NULL, 'G3DSA:2.60.40.10:FF:000499', NULL, NULL, 'CD276 antigen', NULL, NULL, NULL, NULL, NULL, 4),
(180066, NULL, 'G3DSA:2.30.30.40:FF:000256', NULL, NULL, 'Actin cytoskeleton-regulatory complex protein SLA1', NULL, NULL, NULL, NULL, NULL, 4),
(180067, NULL, 'G3DSA:3.30.2350.10:FF:000032', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(180068, NULL, 'G3DSA:3.30.530.20:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180069, NULL, 'G3DSA:3.40.30.10:FF:000238', NULL, NULL, 'Soluble secreted antigen Mpt53', NULL, NULL, NULL, NULL, NULL, 4),
(180070, NULL, 'G3DSA:3.30.420.40:FF:000244', NULL, NULL, 'pantothenate kinase 1-like isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(180071, NULL, 'G3DSA:3.30.70.330:FF:000026', NULL, NULL, 'APOBEC1 complementation factor isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(180072, NULL, 'G3DSA:3.10.20.90:FF:000651', NULL, NULL, 'Autophagy-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(180073, NULL, 'G3DSA:1.20.5.100:FF:000007', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(180074, NULL, 'G3DSA:3.40.50.12780:FF:000043', NULL, NULL, 'Acyl-CoA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(180075, NULL, 'G3DSA:3.30.160.60:FF:002556', NULL, NULL, 'Krueppel-like factor 5', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(180076, NULL, 'G3DSA:3.30.230.10:FF:000046', NULL, NULL, 'galactokinase-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(180077, NULL, 'G3DSA:1.10.238.10:FF:000930', NULL, NULL, 'Calcium-binding protein G', NULL, NULL, NULL, NULL, NULL, 4),
(180078, NULL, 'G3DSA:1.10.20.10:FF:000339', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180079, NULL, 'G3DSA:3.40.250.10:FF:000247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180080, NULL, 'G3DSA:3.30.70.330:FF:000498', NULL, NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(180081, NULL, 'G3DSA:3.40.630.30:FF:000682', NULL, NULL, 'N-acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180082, NULL, 'G3DSA:3.40.50.1010:FF:000239', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180083, NULL, 'G3DSA:1.10.510.10:FF:002980', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180084, NULL, 'G3DSA:3.10.105.10:FF:000030', NULL, NULL, 'SgrR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(180085, NULL, 'G3DSA:1.20.1740.10:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180086, NULL, 'G3DSA:1.10.10.60:FF:000039', NULL, NULL, 'MYB transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(180087, NULL, 'G3DSA:1.25.40.250:FF:000009', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit K', NULL, NULL, NULL, NULL, NULL, 4),
(180088, NULL, 'G3DSA:2.60.40.10:FF:000398', NULL, NULL, 'Tenascin C', NULL, NULL, NULL, NULL, NULL, 4),
(180089, NULL, 'G3DSA:3.30.750.170:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180090, NULL, 'G3DSA:1.10.238.10:FF:001239', NULL, NULL, 'Sarcoplasmic calcium-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(180091, NULL, 'G3DSA:3.40.50.300:FF:002135', NULL, NULL, 'Multidrug resistance-associated protein 4 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(180092, NULL, 'G3DSA:2.60.40.10:FF:001016', NULL, NULL, 'Uncharacterized protein, isoform J', NULL, NULL, NULL, NULL, NULL, 4),
(180093, NULL, 'G3DSA:3.30.70.1180:FF:000017', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(180094, NULL, 'G3DSA:3.40.50.300:FF:001629', NULL, NULL, 'Probable ATP-dependent helicase PF08_0048', NULL, NULL, NULL, NULL, NULL, 4),
(180095, NULL, 'G3DSA:1.10.530.10:FF:000076', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(180096, NULL, 'G3DSA:1.10.1450.10:FF:000040', NULL, NULL, 'Peripherin 2b (retinal degeneration, slow)', NULL, NULL, NULL, NULL, NULL, 4),
(180097, NULL, 'G3DSA:3.40.50.300:FF:003771', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180098, NULL, 'G3DSA:3.40.50.10470:FF:000007', NULL, NULL, 'Translation initiation factor eIF-2B subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(180099, NULL, 'G3DSA:3.30.70.1230:FF:000156', NULL, NULL, 'Photoactivated adenylate cyclase subunit beta-like protein 1224-5/9F', NULL, NULL, NULL, NULL, NULL, 4),
(180100, NULL, 'G3DSA:1.10.1200.10:FF:000140', NULL, NULL, 'Ferrichrome siderophore peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(180101, NULL, 'G3DSA:2.60.40.10:FF:001679', NULL, NULL, 'filamin-A isoform X7', NULL, NULL, NULL, NULL, NULL, 4),
(180102, NULL, 'G3DSA:1.10.510.10:FF:000063', NULL, NULL, 'Mitogen-activated protein kinase 14', NULL, NULL, NULL, NULL, NULL, 4),
(180103, NULL, 'G3DSA:3.30.160.60:FF:003837', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180104, NULL, 'G3DSA:1.10.472.10:FF:000620', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180105, NULL, 'G3DSA:3.30.230.70:FF:000160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180106, NULL, 'G3DSA:3.30.460.20:FF:000004', NULL, NULL, 'Magnesium transport protein CorA', NULL, NULL, NULL, NULL, NULL, 4),
(180107, NULL, 'G3DSA:1.10.10.60:FF:001129', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180108, NULL, 'G3DSA:1.20.1270.60:FF:000084', NULL, NULL, 'BAI1-associated protein 2-like 2b', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(180109, NULL, 'G3DSA:2.40.70.10:FF:000165', NULL, NULL, 'Transposon Tf2-9 polyprotein-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(180110, NULL, 'G3DSA:3.30.450.30:FF:000035', NULL, NULL, 'Profilin', NULL, NULL, NULL, NULL, NULL, 4),
(180111, NULL, 'G3DSA:2.10.110.10:FF:000310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180112, NULL, 'G3DSA:2.40.50.140:FF:001220', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180113, NULL, 'G3DSA:1.10.287.4070:FF:000003', NULL, NULL, 'U4/U6 small nuclear ribonucleoprotein PRP31', NULL, NULL, NULL, NULL, NULL, 4),
(180114, NULL, 'G3DSA:2.10.25.10:FF:001118', NULL, NULL, 'Fibulin-1', NULL, NULL, NULL, NULL, NULL, 4),
(180115, NULL, 'G3DSA:2.70.150.10:FF:000153', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(180116, NULL, 'G3DSA:3.10.120.10:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180117, NULL, 'G3DSA:1.10.238.110:FF:000002', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(180118, NULL, 'G3DSA:3.30.160.60:FF:004810', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180119, NULL, 'G3DSA:3.30.590.20:FF:000008', NULL, NULL, 'Putative glutamate--cysteine ligase 2', NULL, NULL, NULL, NULL, NULL, 4),
(180120, NULL, 'G3DSA:3.30.870.10:FF:000021', NULL, NULL, 'Cardiolipin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(180121, NULL, 'G3DSA:1.25.40.10:FF:003747', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180122, NULL, 'G3DSA:2.40.50.90:FF:000024', NULL, NULL, 'Chromosome 3 C3orf33 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(180123, NULL, 'G3DSA:1.25.40.20:FF:000411', NULL, NULL, 'Calmodulin-binding transcription activator 4 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(180124, NULL, 'G3DSA:1.20.58.390:FF:000127', NULL, NULL, 'AcetylCholine Receptor', NULL, NULL, NULL, NULL, NULL, 4),
(180125, NULL, 'G3DSA:3.40.630.30:FF:000535', NULL, NULL, 'Uncharacterized protein MJ1136', NULL, NULL, NULL, NULL, NULL, 4),
(180126, NULL, 'G3DSA:1.10.640.10:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180127, NULL, 'G3DSA:3.10.20.90:FF:000049', NULL, NULL, 'RB1-inducible coiled-coil protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(180128, NULL, 'G3DSA:3.40.50.1400:FF:000042', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(180129, NULL, 'G3DSA:2.40.50.140:FF:000601', NULL, NULL, 'RNA-editing complex protein MP63', NULL, NULL, NULL, NULL, NULL, 4),
(180130, NULL, 'G3DSA:3.30.760.10:FF:000030', NULL, NULL, 'Translation initiation factor 4e, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180131, NULL, 'G3DSA:1.20.120.530:FF:000017', NULL, NULL, 'FadR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(180132, NULL, 'G3DSA:3.20.20.80:FF:000198', NULL, NULL, 'Chitinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(180133, NULL, 'G3DSA:3.40.50.300:FF:005671', NULL, NULL, 'Transitional endoplasmic reticulum ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(180134, NULL, 'G3DSA:3.40.50.300:FF:002490', NULL, NULL, 'Nicotinamide riboside kinase', NULL, NULL, NULL, NULL, NULL, 4),
(180135, NULL, 'G3DSA:3.40.50.300:FF:004951', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180136, NULL, 'G3DSA:2.20.25.420:FF:000007', NULL, NULL, 'Zinc finger protein zpr1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180137, NULL, 'G3DSA:2.160.10.10:FF:000116', NULL, NULL, '40S ribosomal protein S4-3', NULL, NULL, NULL, NULL, NULL, 4),
(180138, NULL, 'G3DSA:3.30.420.10:FF:000095', NULL, NULL, 'Transcription elongation factor, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(180139, NULL, 'G3DSA:3.40.50.880:FF:000033', NULL, NULL, 'Glutamine amidotransferase class-I', NULL, NULL, NULL, NULL, NULL, 4),
(180140, NULL, 'G3DSA:2.60.40.10:FF:002652', NULL, NULL, 'semaphorin-4D isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(180141, NULL, 'G3DSA:1.25.40.10:FF:001690', NULL, NULL, 'Os03g0624800 protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(180142, NULL, 'G3DSA:1.10.510.10:FF:000838', NULL, NULL, 'NIMA related kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(180143, NULL, 'G3DSA:1.25.10.10:FF:001435', NULL, NULL, 'E3 ubiquitin-protein ligase listerin', NULL, NULL, NULL, NULL, NULL, 4),
(180144, NULL, 'G3DSA:3.30.40.10:FF:000627', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(180145, NULL, 'G3DSA:3.30.200.20:FF:000210', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(180146, NULL, 'G3DSA:1.10.8.270:FF:000173', NULL, NULL, 'Si:ch211-266k8.4', NULL, NULL, NULL, NULL, NULL, 4),
(180147, NULL, 'G3DSA:3.40.1110.10:FF:000394', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180148, NULL, 'G3DSA:2.70.150.10:FF:000254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180149, NULL, 'G3DSA:1.20.1070.10:FF:001436', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180150, NULL, 'G3DSA:2.30.29.30:FF:001351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180151, NULL, 'G3DSA:2.30.130.10:FF:000020', NULL, NULL, 'Unplaced genomic scaffold supercont1.64, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(180152, NULL, 'G3DSA:3.30.70.2570:FF:000002', NULL, NULL, 'Translation factor GUF1 homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(180153, NULL, 'G3DSA:2.20.25.400:FF:000001', NULL, NULL, 'Protein transport protein SEC31', NULL, NULL, NULL, NULL, NULL, 4),
(180154, NULL, 'G3DSA:2.40.10.10:FF:000291', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180155, NULL, 'G3DSA:2.60.40.1760:FF:000005', NULL, NULL, 'Putative alpha-glucosidase AgdA', NULL, NULL, NULL, NULL, NULL, 4),
(180156, NULL, 'G3DSA:2.60.40.10:FF:004552', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180157, NULL, 'G3DSA:1.10.400.10:FF:000072', NULL, NULL, 'Guanine nucleotide binding protein, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(180158, NULL, 'G3DSA:3.40.640.10:FF:000159', NULL, NULL, 'Uncharacterized protein R102.4', NULL, NULL, NULL, NULL, NULL, 4),
(180159, NULL, 'G3DSA:3.20.20.80:FF:000759', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180160, NULL, 'G3DSA:3.40.50.300:FF:000348', NULL, NULL, 'tRNA dimethylallyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(180161, NULL, 'G3DSA:2.10.25.10:FF:000365', NULL, NULL, 'Sushi, nidogen and EGF like domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(180162, NULL, 'G3DSA:3.30.479.20:FF:000053', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(180163, NULL, 'G3DSA:3.40.50.300:FF:002034', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180164, NULL, 'G3DSA:1.20.1110.10:FF:000198', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180165, NULL, 'G3DSA:2.60.40.420:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180166, NULL, 'G3DSA:1.20.1070.10:FF:000008', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(180167, NULL, 'G3DSA:2.70.130.10:FF:000140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180168, NULL, 'G3DSA:2.60.120.620:FF:000012', NULL, NULL, 'Phytanoyl-CoA dioxygenase, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(180169, NULL, 'G3DSA:3.40.50.150:FF:000831', NULL, NULL, 'Putative methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180170, NULL, 'G3DSA:3.30.9.10:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180171, NULL, 'G3DSA:2.60.450.20:FF:000001', NULL, NULL, 'Centromere protein J', NULL, NULL, NULL, NULL, NULL, 4),
(180172, NULL, 'G3DSA:1.20.1740.10:FF:000083', NULL, NULL, 'Putative alanine,valine and leucine rich integral membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(180173, NULL, 'G3DSA:3.10.20.90:FF:000504', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180174, NULL, 'G3DSA:2.60.40.10:FF:001943', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(180175, NULL, 'G3DSA:2.40.128.590:FF:000001', NULL, NULL, 'Chromophore lyase CRL, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(180176, NULL, 'G3DSA:3.30.310.10:FF:000002', NULL, NULL, 'TATA-box-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(180177, NULL, 'G3DSA:2.40.50.140:FF:000040', NULL, NULL, 'Ribonuclease E', NULL, NULL, NULL, NULL, NULL, 4),
(180178, NULL, 'G3DSA:3.30.200.20:FF:001559', NULL, NULL, 'STE family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(180179, NULL, 'G3DSA:2.40.160.10:FF:000031', NULL, NULL, 'Mitochondrial distribution and morphology protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(180180, NULL, 'G3DSA:1.25.40.790:FF:000002', NULL, NULL, 'Transcription regulator', NULL, NULL, NULL, NULL, NULL, 4),
(180181, NULL, 'G3DSA:2.130.10.10:FF:005957', NULL, NULL, 'Phosphoinositide-3-kinase, regulatory subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(180182, NULL, 'G3DSA:3.20.20.10:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180183, NULL, 'G3DSA:1.20.120.350:FF:000132', NULL, NULL, 'Potassium voltage-gated channel, subfamily G, member 4a', NULL, NULL, NULL, NULL, NULL, 4),
(180184, NULL, 'G3DSA:2.10.110.10:FF:000208', NULL, NULL, 'Protein CBG11874', NULL, NULL, NULL, NULL, NULL, 4),
(180185, NULL, 'G3DSA:1.10.10.60:FF:000612', NULL, NULL, 'PROBABLE TRANSCRIPTIONAL REGULATORY PROTEIN', NULL, NULL, NULL, NULL, NULL, 4),
(180186, NULL, 'G3DSA:3.40.50.300:FF:004243', NULL, NULL, 'Replication factor C small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(180187, NULL, 'G3DSA:3.30.70.330:FF:001206', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(180188, NULL, 'G3DSA:1.20.1310.20:FF:000053', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(180189, NULL, 'G3DSA:2.40.100.10:FF:000010', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase E', NULL, NULL, NULL, NULL, NULL, 4),
(180190, NULL, 'G3DSA:1.10.12.10:FF:000017', NULL, NULL, 'Putative enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(180191, NULL, 'G3DSA:1.10.287.1150:FF:000015', NULL, NULL, 'Putative 2-oxoglutarate dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(180192, NULL, 'G3DSA:1.25.10.10:FF:002054', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(180193, NULL, 'G3DSA:1.10.510.10:FF:000277', NULL, NULL, 'protein kinase PINOID', NULL, NULL, NULL, NULL, NULL, 4),
(180194, NULL, 'G3DSA:1.10.1740.10:FF:000051', NULL, NULL, 'Alpha amylase (Amylosucrase), Chain A', NULL, NULL, NULL, NULL, NULL, 4),
(180195, NULL, 'G3DSA:1.10.472.10:FF:000209', NULL, NULL, 'Cyclin C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180196, NULL, 'G3DSA:2.60.40.1180:FF:000123', NULL, NULL, 'Beta-1,6-glucanase Neg1', NULL, NULL, NULL, NULL, NULL, 4),
(180197, NULL, 'G3DSA:2.20.25.90:FF:000012', NULL, NULL, 'Anaerobic selenocysteine-containing dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(180198, NULL, 'G3DSA:3.30.230.10:FF:000310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180199, NULL, 'G3DSA:3.30.70.330:FF:001094', NULL, NULL, 'Splicing factor MUD2', NULL, NULL, NULL, NULL, NULL, 4),
(180200, NULL, 'G3DSA:3.40.50.1820:FF:000965', NULL, NULL, 'Protein ABHD15', NULL, NULL, NULL, NULL, NULL, 4),
(180201, NULL, 'G3DSA:1.10.540.10:FF:000003', NULL, NULL, 'glutaryl-CoA dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(180202, NULL, 'G3DSA:3.40.50.300:FF:006497', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180203, NULL, 'G3DSA:1.20.1440.100:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180204, NULL, 'G3DSA:3.90.70.10:FF:000233', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 26', NULL, NULL, NULL, NULL, NULL, 4),
(180205, NULL, 'G3DSA:3.30.420.10:FF:000656', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180206, NULL, 'G3DSA:3.10.50.10:FF:000016', NULL, NULL, 'Chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180207, NULL, 'G3DSA:3.40.50.150:FF:001803', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180208, NULL, 'G3DSA:3.30.930.10:FF:000223', NULL, NULL, 'Phenylalanyl-tRNA synthetase alpha chain', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(180209, NULL, 'G3DSA:3.90.260.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180210, NULL, 'G3DSA:1.20.1250.20:FF:002274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180211, NULL, 'G3DSA:1.20.120.550:FF:000012', NULL, NULL, 'Hypothetical glutathione S-transferase like protein', NULL, NULL, NULL, NULL, NULL, 4),
(180212, NULL, 'G3DSA:3.30.40.10:FF:001532', NULL, NULL, 'CDK-activating kinase assembly factor MAT1', NULL, NULL, NULL, NULL, NULL, 4),
(180213, NULL, 'G3DSA:3.20.20.70:FF:000240', NULL, NULL, 'Lipoyl synthase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(180214, NULL, 'G3DSA:1.10.1200.150:FF:000001', NULL, NULL, 'Transcriptional regulator CtsR', NULL, NULL, NULL, NULL, NULL, 4),
(180215, NULL, 'G3DSA:3.90.180.10:FF:000129', NULL, NULL, 'Alcohol dehydrogenase 5 (class III), chi polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(180216, NULL, 'G3DSA:2.30.30.40:FF:000609', NULL, NULL, 'Rho GTPase-activating protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(180217, NULL, 'G3DSA:3.50.50.60:FF:001333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180218, NULL, 'G3DSA:2.130.10.10:FF:005182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180219, NULL, 'G3DSA:2.60.200.20:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180220, NULL, 'G3DSA:3.30.160.60:FF:001376', NULL, NULL, 'Zinc finger and BTB domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(180221, NULL, 'G3DSA:3.30.2310.20:FF:000004', NULL, NULL, 'Toxin RelE', NULL, NULL, NULL, NULL, NULL, 4),
(180222, NULL, 'G3DSA:1.10.10.10:FF:001682', NULL, NULL, 'SirR/DtxR family transcription regulator Idr2', NULL, NULL, NULL, NULL, NULL, 4),
(180223, NULL, 'G3DSA:2.30.29.30:FF:000637', NULL, NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', NULL, NULL, NULL, NULL, NULL, 4),
(180224, NULL, 'G3DSA:1.10.8.10:FF:000181', NULL, NULL, 'GD24956', NULL, NULL, NULL, NULL, NULL, 4),
(180225, NULL, 'G3DSA:2.30.30.190:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180226, NULL, 'G3DSA:3.40.50.300:FF:004288', NULL, NULL, 'Ras-related protein Rab-1B', NULL, NULL, NULL, NULL, NULL, 4),
(180227, NULL, 'G3DSA:1.10.287.70:FF:000336', NULL, NULL, 'I[[h]] channel, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(180228, NULL, 'G3DSA:2.60.120.920:FF:000085', NULL, NULL, 'Ssh4p', NULL, NULL, NULL, NULL, NULL, 4),
(180229, NULL, 'G3DSA:3.40.50.1380:FF:000007', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(180230, NULL, 'G3DSA:3.40.970.10:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180231, NULL, 'G3DSA:4.10.60.10:FF:000239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180232, NULL, 'G3DSA:2.130.10.10:FF:000623', NULL, NULL, 'Peptidylprolyl isomerase domain and WD repeat-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(180233, NULL, 'G3DSA:1.10.287.600:FF:000006', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(180234, NULL, 'G3DSA:3.30.1110.10:FF:000003', NULL, NULL, 'Adenosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(180235, NULL, 'G3DSA:3.40.50.2300:FF:001273', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180236, NULL, 'G3DSA:1.10.1420.10:FF:000212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180237, NULL, 'G3DSA:2.60.40.10:FF:001724', NULL, NULL, 'Polycystin 1, transient receptor potential channel-interacting', NULL, NULL, NULL, NULL, NULL, 4),
(180238, NULL, 'G3DSA:3.90.1150.10:FF:000312', NULL, NULL, 'Saframycin Mx1 synthetase B', NULL, NULL, NULL, NULL, NULL, 4),
(180239, NULL, 'G3DSA:2.70.170.10:FF:000053', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(180240, NULL, 'G3DSA:2.60.40.10:FF:003624', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180241, NULL, 'G3DSA:3.40.50.450:FF:000022', NULL, NULL, 'Probable ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(180242, NULL, 'G3DSA:2.40.30.10:FF:000090', NULL, NULL, '50S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(180243, NULL, 'G3DSA:3.30.830.10:FF:000058', NULL, NULL, 'Mitochondrial-processing peptidase subunit alpha-like', NULL, NULL, NULL, NULL, NULL, 4),
(180244, NULL, 'G3DSA:1.25.40.180:FF:000084', NULL, NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(180245, NULL, 'G3DSA:2.60.120.10:FF:000804', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180246, NULL, 'G3DSA:1.20.1280.50:FF:000261', NULL, NULL, 'F-box protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(180247, NULL, 'G3DSA:3.40.190.10:FF:000405', NULL, NULL, 'ABC transporter, periplasmic substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(180248, NULL, 'G3DSA:2.60.120.260:FF:000325', NULL, NULL, 'Beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(180249, NULL, 'G3DSA:1.10.10.10:FF:001991', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180250, NULL, 'G3DSA:1.20.1250.20:FF:002010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180251, NULL, 'G3DSA:3.40.50.300:FF:004390', NULL, NULL, 'Dephospho-CoA kinase', NULL, NULL, NULL, NULL, NULL, 4),
(180252, NULL, 'G3DSA:3.30.160.60:FF:004546', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180253, NULL, 'G3DSA:2.60.40.60:FF:000609', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(180254, NULL, 'G3DSA:3.10.20.90:FF:000196', NULL, NULL, 'UBX domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(180255, NULL, 'G3DSA:1.10.510.10:FF:002671', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180256, NULL, 'G3DSA:3.20.20.80:FF:000462', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(180257, NULL, 'G3DSA:1.20.58.390:FF:000274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180258, NULL, 'G3DSA:2.30.30.100:FF:000195', NULL, NULL, 'YALI0B14773p', NULL, NULL, NULL, NULL, NULL, 4),
(180259, NULL, 'G3DSA:2.60.40.10:FF:003933', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180260, NULL, 'G3DSA:1.10.1200.270:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180261, NULL, 'G3DSA:1.20.1090.10:FF:000010', NULL, NULL, 'Maleylacetate reductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(180262, NULL, 'G3DSA:1.20.5.680:FF:000001', NULL, NULL, 'Glutaconyl-CoA decarboxylase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(180263, NULL, 'G3DSA:3.40.50.20:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180264, NULL, 'G3DSA:3.40.1010.10:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180265, NULL, 'G3DSA:3.30.559.10:FF:000096', NULL, NULL, 'Nonribosomal peptide synthase GliP2', NULL, NULL, NULL, NULL, NULL, 4),
(180266, NULL, 'G3DSA:1.10.287.70:FF:000645', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180267, NULL, 'G3DSA:3.60.21.10:FF:000200', NULL, NULL, 'Mre11, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180268, NULL, 'G3DSA:3.30.9.10:FF:000302', NULL, NULL, 'Putative D-amino acid oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(180269, NULL, 'G3DSA:2.160.20.10:FF:000206', NULL, NULL, 'Bifunctional pectinolytic enzyme/cytochrome c', NULL, NULL, NULL, NULL, NULL, 4),
(180270, NULL, 'G3DSA:2.40.20.10:FF:000015', NULL, NULL, 'Prothrombin', NULL, NULL, NULL, NULL, NULL, 4),
(180271, NULL, 'G3DSA:1.25.10.10:FF:002363', NULL, NULL, 'Os02g0169800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(180272, NULL, 'G3DSA:2.130.10.10:FF:005743', NULL, NULL, 'ELM2 domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(180273, NULL, 'G3DSA:3.40.140.20:FF:000006', NULL, NULL, 'Bifunctional purine biosynthesis protein PurH', NULL, NULL, NULL, NULL, NULL, 4),
(180274, NULL, 'G3DSA:1.10.472.10:FF:000518', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(180275, NULL, 'G3DSA:3.30.420.10:FF:000701', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(180276, NULL, 'G3DSA:2.60.260.20:FF:000054', NULL, NULL, 'Curved DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(180277, NULL, 'G3DSA:3.30.160.60:FF:001937', NULL, NULL, 'Zinc finger protein 613', NULL, NULL, NULL, NULL, NULL, 4),
(180278, NULL, 'G3DSA:3.30.710.10:FF:000448', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180279, NULL, 'G3DSA:3.30.160.60:FF:001112', NULL, NULL, 'Zinc finger protein 366', NULL, NULL, NULL, NULL, NULL, 4),
(180280, NULL, 'G3DSA:2.130.10.10:FF:000606', NULL, NULL, 'PH-interacting protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(180281, NULL, 'G3DSA:3.90.360.10:FF:000008', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(180282, NULL, 'G3DSA:3.90.640.10:FF:000272', NULL, NULL, 'Actin-like protein arp10', NULL, NULL, NULL, NULL, NULL, 4),
(180283, NULL, 'G3DSA:3.40.1110.10:FF:000085', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(180284, NULL, 'G3DSA:3.40.50.620:FF:000298', NULL, NULL, 'Phosphoadenosine phosphosulfate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(180285, NULL, 'G3DSA:1.10.238.10:FF:000019', NULL, NULL, 'Myosin light chain 1 skeletal', NULL, NULL, NULL, NULL, NULL, 4),
(180286, NULL, 'G3DSA:1.10.600.10:FF:000076', NULL, NULL, 'Terpene synthase', NULL, NULL, NULL, NULL, NULL, 4),
(180287, NULL, 'G3DSA:1.25.10.10:FF:002008', NULL, NULL, 'Armadillo repeat-containing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(180288, NULL, 'G3DSA:3.40.50.300:FF:003063', NULL, NULL, 'ABC transporter ATP-binding protein YnjD', NULL, NULL, NULL, NULL, NULL, 4),
(180289, NULL, 'G3DSA:2.130.10.10:FF:004338', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180290, NULL, 'G3DSA:3.40.50.1000:FF:000130', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(180291, NULL, 'G3DSA:1.25.40.20:FF:000294', NULL, NULL, 'Palmitoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(180292, NULL, 'G3DSA:1.10.510.10:FF:001575', NULL, NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 73', NULL, NULL, NULL, NULL, NULL, 4),
(180293, NULL, 'G3DSA:3.40.50.150:FF:000600', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180294, NULL, 'G3DSA:3.30.450.20:FF:000386', NULL, NULL, 'Transcriptional regulator, PpsR', NULL, NULL, NULL, NULL, NULL, 4),
(180295, NULL, 'G3DSA:1.25.40.10:FF:003617', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g74600, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(180296, NULL, 'G3DSA:3.40.50.970:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180297, NULL, 'G3DSA:2.10.25.10:FF:001770', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(180298, NULL, 'G3DSA:3.40.50.1440:FF:000166', NULL, NULL, 'Beta_tubulin,putative', NULL, NULL, NULL, NULL, NULL, 4),
(180299, NULL, 'G3DSA:1.10.630.10:FF:000701', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180300, NULL, 'G3DSA:2.40.30.130:FF:000027', NULL, NULL, 'Alanine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(180301, NULL, 'G3DSA:1.10.418.10:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180302, NULL, 'G3DSA:1.20.80.40:FF:000003', NULL, NULL, 'Splicing factor Prp8, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180303, NULL, 'G3DSA:2.30.30.280:FF:000001', NULL, NULL, 'tRNA-specific 2-thiouridylase MnmA', NULL, NULL, NULL, NULL, NULL, 4),
(180304, NULL, 'G3DSA:1.20.1070.10:FF:000374', NULL, NULL, 'probable G-protein coupled receptor 62', NULL, NULL, NULL, NULL, NULL, 4),
(180305, NULL, 'G3DSA:1.10.8.60:FF:000055', NULL, NULL, 'Katanin p60 ATPase-containing subunit A1', NULL, NULL, NULL, NULL, NULL, 4),
(180306, NULL, 'G3DSA:2.60.40.10:FF:004321', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180307, NULL, 'G3DSA:3.60.40.10:FF:000137', NULL, NULL, 'Calmodulin-binding protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(180308, NULL, 'G3DSA:2.60.120.920:FF:000012', NULL, NULL, 'Ryanodine receptor 2 (Cardiac)', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(180309, NULL, 'G3DSA:1.10.287.70:FF:000089', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(180310, NULL, 'G3DSA:3.20.20.140:FF:000416', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180311, NULL, 'G3DSA:3.90.1750.10:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180312, NULL, 'G3DSA:2.60.120.260:FF:000426', NULL, NULL, 'Glycosyl hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(180313, NULL, 'G3DSA:3.40.630.10:FF:000310', NULL, NULL, 'Carboxypeptidase A', NULL, NULL, NULL, NULL, NULL, 4),
(180314, NULL, 'G3DSA:3.30.190.20:FF:000034', NULL, NULL, 'Ribosomal protein L1p/L10e family protein', NULL, NULL, NULL, NULL, NULL, 4),
(180315, NULL, 'G3DSA:1.10.510.10:FF:004329', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180316, NULL, 'G3DSA:1.20.1720.10:FF:000109', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180317, NULL, 'G3DSA:2.60.40.150:FF:000103', NULL, NULL, 'Copine 2', NULL, NULL, NULL, NULL, NULL, 4),
(180318, NULL, 'G3DSA:1.10.10.10:FF:001339', NULL, NULL, 'AGAP002394-PA', NULL, NULL, NULL, NULL, NULL, 4),
(180319, NULL, 'G3DSA:1.20.1720.10:FF:000098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180320, NULL, 'G3DSA:3.40.50.1360:FF:000024', NULL, NULL, 'Lactose phosphotransferase system repressor', NULL, NULL, NULL, NULL, NULL, 4),
(180321, NULL, 'G3DSA:1.20.1250.20:FF:000110', NULL, NULL, 'Regulatory protein uhpC', NULL, NULL, NULL, NULL, NULL, 4),
(180322, NULL, 'G3DSA:2.30.29.30:FF:000429', NULL, NULL, 'CLNS1A isoform 7', NULL, NULL, NULL, NULL, NULL, 4),
(180323, NULL, 'G3DSA:1.20.58.60:FF:000738', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180324, NULL, 'G3DSA:2.150.10.10:FF:000004', NULL, NULL, 'RTX-I toxin determinant A', NULL, NULL, NULL, NULL, NULL, 4),
(180325, NULL, 'G3DSA:2.70.170.10:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180326, NULL, 'G3DSA:2.120.10.80:FF:000329', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180327, NULL, 'G3DSA:3.30.40.10:FF:000936', NULL, NULL, 'E3 ubiquitin-protein ligase MIEL1', NULL, NULL, NULL, NULL, NULL, 4),
(180328, NULL, 'G3DSA:2.60.120.380:FF:000007', NULL, NULL, 'Calpain 7', NULL, NULL, NULL, NULL, NULL, 4),
(180329, NULL, 'G3DSA:3.40.50.300:FF:000792', NULL, NULL, 'ABC transporter F family member 4', NULL, NULL, NULL, NULL, NULL, 4),
(180330, NULL, 'G3DSA:3.80.10.10:FF:000674', NULL, NULL, 'F-box protein SKIP1', NULL, NULL, NULL, NULL, NULL, 4),
(180331, NULL, 'G3DSA:3.40.930.10:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180332, NULL, 'G3DSA:3.30.40.10:FF:000251', NULL, NULL, 'Nitric oxide synthase-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(180333, NULL, 'G3DSA:3.30.70.1430:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180334, NULL, 'G3DSA:1.10.760.10:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180335, NULL, 'G3DSA:1.25.10.10:FF:002610', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180336, NULL, 'G3DSA:1.20.1280.120:FF:000004', NULL, NULL, 'Catalase-related peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(180337, NULL, 'G3DSA:1.10.630.10:FF:000690', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180338, NULL, 'G3DSA:2.60.40.10:FF:004214', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180339, NULL, 'G3DSA:3.40.50.300:FF:000320', NULL, NULL, 'Dynein, axonemal, heavy chain 5', NULL, NULL, NULL, NULL, NULL, 4),
(180340, NULL, 'G3DSA:3.40.50.620:FF:000303', NULL, NULL, 'tRNA (5-methylaminomethyl-2-thiouridylate)-methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180341, NULL, 'G3DSA:3.80.10.10:FF:002124', NULL, NULL, 'Leucine-rich repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(180342, NULL, 'G3DSA:3.40.50.720:FF:001980', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180343, NULL, 'G3DSA:2.130.10.10:FF:001691', NULL, NULL, 'Transcriptional regulator, AraC/XylS family', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(180344, NULL, 'G3DSA:3.30.420.40:FF:000463', NULL, NULL, 'Heat shock protein 70, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180345, NULL, 'G3DSA:1.10.630.10:FF:000696', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180346, NULL, 'G3DSA:3.40.50.300:FF:006733', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180347, NULL, 'G3DSA:3.30.160.60:FF:001483', NULL, NULL, 'Zinc finger protein 1005', NULL, NULL, NULL, NULL, NULL, 4),
(180348, NULL, 'G3DSA:1.10.10.60:FF:000056', NULL, NULL, 'POU domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(180349, NULL, 'G3DSA:3.30.160.60:FF:000387', NULL, NULL, 'Zinc finger protein 354A', NULL, NULL, NULL, NULL, NULL, 4),
(180350, NULL, 'G3DSA:1.10.238.10:FF:000621', NULL, NULL, 'WGS project CABT00000000 data, contig 2.4', NULL, NULL, NULL, NULL, NULL, 4),
(180351, NULL, 'G3DSA:2.30.29.30:FF:001042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180352, NULL, 'G3DSA:3.60.21.10:FF:000301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180353, NULL, 'G3DSA:3.40.50.1820:FF:000988', NULL, NULL, 'Esterase inpF', NULL, NULL, NULL, NULL, NULL, 4),
(180354, NULL, 'G3DSA:3.30.160.60:FF:001011', NULL, NULL, 'Zinc finger protein 793', NULL, NULL, NULL, NULL, NULL, 4),
(180355, NULL, 'G3DSA:1.10.510.10:FF:001682', NULL, NULL, 'SH2-protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(180356, NULL, 'G3DSA:2.40.10.10:FF:000397', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180357, NULL, 'G3DSA:4.10.260.10:FF:000009', NULL, NULL, 'Regulator of G-protein signaling 11', NULL, NULL, NULL, NULL, NULL, 4),
(180358, NULL, 'G3DSA:3.90.79.10:FF:000034', NULL, NULL, 'Nucleotide triphosphate diphosphatase NUDT15', NULL, NULL, NULL, NULL, NULL, 4),
(180359, NULL, 'G3DSA:1.10.10.10:FF:000827', NULL, NULL, 'RNA polymerase III subunit RPC82 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(180360, NULL, 'G3DSA:3.30.1960.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180361, NULL, 'G3DSA:3.80.10.10:FF:003905', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180362, NULL, 'G3DSA:2.130.10.10:FF:000067', NULL, NULL, 'Putative E3 ubiquitin-protein ligase TRAF7', NULL, NULL, NULL, NULL, NULL, 4),
(180363, NULL, 'G3DSA:2.60.40.150:FF:000098', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(180364, NULL, 'G3DSA:3.40.50.300:FF:005777', NULL, NULL, 'Putative DEAD-box ATP-dependent RNA helicase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(180365, NULL, 'G3DSA:2.40.30.110:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180366, NULL, 'G3DSA:1.20.120.1080:FF:000133', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(180367, NULL, 'G3DSA:3.30.540.10:FF:000042', NULL, NULL, 'Inositol-monophosphatase ImpA', NULL, NULL, NULL, NULL, NULL, 4),
(180368, NULL, 'G3DSA:2.60.40.1460:FF:000005', NULL, NULL, 'Integrin subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(180369, NULL, 'G3DSA:1.20.1260.10:FF:000074', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(180370, NULL, 'G3DSA:3.60.130.10:FF:000077', NULL, NULL, 'uncharacterized protein LOC100177042 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(180371, NULL, 'G3DSA:3.30.420.40:FF:000800', NULL, NULL, 'Heat shock protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180372, NULL, 'G3DSA:3.40.50.300:FF:004844', NULL, NULL, 'Replication factor C subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(180373, NULL, 'G3DSA:1.20.1250.20:FF:000582', NULL, NULL, 'POSSIBLE NITRATE/NITRITE TRANSPORTER NARK2', NULL, NULL, NULL, NULL, NULL, 4),
(180374, NULL, 'G3DSA:3.40.1380.20:FF:000017', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(180375, NULL, 'G3DSA:3.20.20.190:FF:000173', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180376, NULL, 'G3DSA:1.25.40.20:FF:000187', NULL, NULL, 'B-cell lymphoma 3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(180377, NULL, 'G3DSA:3.30.200.20:FF:001666', NULL, NULL, 'Serine/threonine-protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(180378, NULL, 'G3DSA:2.40.50.140:FF:000337', NULL, NULL, 'RNA guanylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(180379, NULL, 'G3DSA:1.10.357.150:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180380, NULL, 'G3DSA:3.30.70.2840:FF:000004', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(180381, NULL, 'G3DSA:2.130.10.10:FF:004445', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180382, NULL, 'G3DSA:2.60.40.10:FF:000426', NULL, NULL, 'Down syndrome cell adhesion molecule, isoform J', NULL, NULL, NULL, NULL, NULL, 4),
(180383, NULL, 'G3DSA:3.80.10.10:FF:003428', NULL, NULL, 'Os08g0203100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(180384, NULL, 'G3DSA:3.30.70.3490:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180385, NULL, 'G3DSA:3.30.830.10:FF:000159', NULL, NULL, 'Uncharacterized protein CaJ7.0411', NULL, NULL, NULL, NULL, NULL, 4),
(180386, NULL, 'G3DSA:1.20.58.400:FF:000007', NULL, NULL, 'Vesicle transport through interaction with t-SNAREs 1A', NULL, NULL, NULL, NULL, NULL, 4),
(180387, NULL, 'G3DSA:2.40.10.10:FF:000408', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180388, NULL, 'G3DSA:3.40.50.300:FF:007722', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180389, NULL, 'G3DSA:3.40.50.980:FF:000046', NULL, NULL, 'AMP dependent CoA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180390, NULL, 'G3DSA:2.60.34.10:FF:000013', NULL, NULL, 'Heat shock 70 kDa protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(180391, NULL, 'G3DSA:3.50.50.60:FF:000125', NULL, NULL, 'Anaerobic glycerol-3-phosphate dehydrogenase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(180392, NULL, 'G3DSA:2.170.16.10:FF:000005', NULL, NULL, 'Replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(180393, NULL, 'G3DSA:2.60.40.10:FF:002343', NULL, NULL, 'HEMCAM', NULL, NULL, NULL, NULL, NULL, 4),
(180394, NULL, 'G3DSA:3.40.1370.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180395, NULL, 'G3DSA:1.25.40.20:FF:001120', NULL, NULL, 'Putative leucine-rich repeat serine/threonine-protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(180396, NULL, 'G3DSA:1.25.40.10:FF:000493', NULL, NULL, 'Tetratricopeptide repeat domain 21B', NULL, NULL, NULL, NULL, NULL, 4),
(180397, NULL, 'G3DSA:2.40.50.730:FF:000003', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(180398, NULL, 'G3DSA:2.30.30.40:FF:000503', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180399, NULL, 'G3DSA:3.40.50.300:FF:000573', NULL, NULL, 'RHO family GTPase Rho2', NULL, NULL, NULL, NULL, NULL, 4),
(180400, NULL, 'G3DSA:3.30.450.70:FF:000024', NULL, NULL, 'Sybindin-like family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180401, NULL, 'G3DSA:2.60.220.50:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180402, NULL, 'G3DSA:2.160.20.10:FF:000061', NULL, NULL, 'F-box protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(180403, NULL, 'G3DSA:2.70.160.11:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180404, NULL, 'G3DSA:3.80.10.10:FF:004041', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(180405, NULL, 'G3DSA:4.10.60.10:FF:000138', NULL, NULL, 'Putative germ-line specific RNA helicase vasa protein', NULL, NULL, NULL, NULL, NULL, 4),
(180406, NULL, 'G3DSA:1.10.8.10:FF:000287', NULL, NULL, 'Elongation factor Ts, mitochondrial 2', NULL, NULL, NULL, NULL, NULL, 4),
(180407, NULL, 'G3DSA:3.30.160.60:FF:003618', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180408, NULL, 'G3DSA:3.10.129.10:FF:000135', NULL, NULL, 'Acyl-CoA thioester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(180409, NULL, 'G3DSA:2.60.40.10:FF:002871', NULL, NULL, 'MPL proto-oncogene, thrombopoietin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(180410, NULL, 'G3DSA:1.25.40.20:FF:000720', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(180411, NULL, 'G3DSA:3.30.40.10:FF:001116', NULL, NULL, 'Ring finger protein 213', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(180412, NULL, 'G3DSA:3.30.60.30:FF:000157', NULL, NULL, 'Follistatin', NULL, NULL, NULL, NULL, NULL, 4),
(180413, NULL, 'G3DSA:1.25.10.10:FF:000210', NULL, NULL, 'serine/threonine-protein kinase Nek10', NULL, NULL, NULL, NULL, NULL, 4),
(180414, NULL, 'G3DSA:1.10.30.10:FF:000048', NULL, NULL, 'Putative SWI/SNF-related matrix-associated actin-dependent regulator chromatin subfamily E member', NULL, NULL, NULL, NULL, NULL, 4),
(180415, NULL, 'G3DSA:2.130.10.10:FF:002540', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180416, NULL, 'G3DSA:3.90.70.10:FF:000014', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 34', NULL, NULL, NULL, NULL, NULL, 4),
(180417, NULL, 'G3DSA:2.130.10.10:FF:000286', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(180418, NULL, 'G3DSA:3.30.30.30:FF:000065', NULL, NULL, 'Putative Hsp70 family ATPase KAR2', NULL, NULL, NULL, NULL, NULL, 4),
(180419, NULL, 'G3DSA:3.30.160.60:FF:006154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180420, NULL, 'G3DSA:3.30.930.10:FF:000330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180421, NULL, 'G3DSA:2.60.40.60:FF:000183', NULL, NULL, 'Cadherin 17', NULL, NULL, NULL, NULL, NULL, 4),
(180422, NULL, 'G3DSA:3.30.310.50:FF:000019', NULL, NULL, 'Phosphomannomutase PmmA', NULL, NULL, NULL, NULL, NULL, 4),
(180423, NULL, 'G3DSA:2.60.40.1180:FF:000224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180424, NULL, 'G3DSA:1.20.120.1770:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180425, NULL, 'G3DSA:1.10.1670.10:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180426, NULL, 'G3DSA:1.20.1560.10:FF:000546', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180427, NULL, 'G3DSA:3.30.160.60:FF:005754', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180428, NULL, 'G3DSA:3.30.160.60:FF:001792', NULL, NULL, 'Zinc finger and BTB domain-containing 40', NULL, NULL, NULL, NULL, NULL, 4),
(180429, NULL, 'G3DSA:3.80.10.10:FF:000365', NULL, NULL, 'Toll-like receptor 5', NULL, NULL, NULL, NULL, NULL, 4),
(180430, NULL, 'G3DSA:3.40.50.300:FF:008211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180431, NULL, 'G3DSA:3.10.590.10:FF:000004', NULL, NULL, 'probable ATP-dependent RNA helicase YTHDC2', NULL, NULL, NULL, NULL, NULL, 4),
(180432, NULL, 'G3DSA:1.10.10.440:FF:000065', NULL, NULL, 'Pre-mRNA processing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180433, NULL, 'G3DSA:3.30.40.10:FF:001555', NULL, NULL, 'No poles, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(180434, NULL, 'G3DSA:2.10.25.10:FF:000348', NULL, NULL, 'Crumbs 1, cell polarity complex component', NULL, NULL, NULL, NULL, NULL, 4),
(180435, NULL, 'G3DSA:2.130.10.10:FF:002045', NULL, NULL, 'IP10750p', NULL, NULL, NULL, NULL, NULL, 4),
(180436, NULL, 'G3DSA:2.30.140.10:FF:000037', NULL, NULL, 'Os02g0254700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(180437, NULL, 'G3DSA:3.30.1360.140:FF:000010', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(180438, NULL, 'G3DSA:1.25.40.10:FF:003724', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180439, NULL, 'G3DSA:1.10.3130.10:FF:000016', NULL, NULL, 'Serine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(180440, NULL, 'G3DSA:2.30.30.30:FF:000135', NULL, NULL, 'Transcription elongation factor SPT5', NULL, NULL, NULL, NULL, NULL, 4),
(180441, NULL, 'G3DSA:3.40.50.150:FF:001539', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180442, NULL, 'G3DSA:3.40.50.300:FF:008341', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180443, NULL, 'G3DSA:3.80.10.10:FF:002596', NULL, NULL, 'Serine/threonine-protein kinase BRI1-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(180444, NULL, 'G3DSA:1.25.10.10:FF:000137', NULL, NULL, 'Protein MOR1', NULL, NULL, NULL, NULL, NULL, 4),
(180445, NULL, 'G3DSA:3.20.20.140:FF:000079', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(180446, NULL, 'G3DSA:1.50.10.10:FF:000062', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(180447, NULL, 'G3DSA:1.20.930.60:FF:000006', NULL, NULL, 'Protein CBG04453', NULL, NULL, NULL, NULL, NULL, 4),
(180448, NULL, 'G3DSA:1.20.58.390:FF:000043', NULL, NULL, 'AcetylCholine Receptor', NULL, NULL, NULL, NULL, NULL, 4),
(180449, NULL, 'G3DSA:3.30.230.80:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180450, NULL, 'G3DSA:1.20.58.2240:FF:000001', NULL, NULL, 'Ribulokinase', NULL, NULL, NULL, NULL, NULL, 4),
(180451, NULL, 'G3DSA:3.90.640.10:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180452, NULL, 'G3DSA:3.40.30.10:FF:000784', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(180453, NULL, 'G3DSA:1.10.287.70:FF:000780', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180454, NULL, 'G3DSA:1.10.510.10:FF:002194', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(180455, NULL, 'G3DSA:1.10.730.10:FF:000158', NULL, NULL, 'Putative arginine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(180456, NULL, 'G3DSA:2.30.30.40:FF:000508', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180457, NULL, 'G3DSA:1.20.58.60:FF:000845', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180458, NULL, 'G3DSA:1.25.40.10:FF:001802', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(180459, NULL, 'G3DSA:2.60.40.3120:FF:000003', NULL, NULL, 'cytosolic carboxypeptidase 6 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(180460, NULL, 'G3DSA:1.10.510.10:FF:003975', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180461, NULL, 'G3DSA:3.30.1330.90:FF:000009', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(180462, NULL, 'G3DSA:3.30.565.10:FF:000245', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(180463, NULL, 'G3DSA:3.40.50.1440:FF:000059', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(180464, NULL, 'G3DSA:3.15.20.10:FF:000009', NULL, NULL, 'Nose resistant to fluoxetine protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(180465, NULL, 'G3DSA:3.40.50.300:FF:006396', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180466, NULL, 'G3DSA:2.60.120.10:FF:000378', NULL, NULL, 'uncharacterized protein LOC100180193 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(180467, NULL, 'G3DSA:3.30.70.1820:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180468, NULL, 'G3DSA:3.40.1190.20:FF:000166', NULL, NULL, 'Ribokinase', NULL, NULL, NULL, NULL, NULL, 4),
(180469, NULL, 'G3DSA:1.10.150.240:FF:000017', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(180470, NULL, 'G3DSA:3.30.70.270:FF:000339', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180471, NULL, 'G3DSA:3.40.630.30:FF:000007', NULL, NULL, 'Spermidine N(1)-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(180472, NULL, 'G3DSA:2.60.40.60:FF:000492', NULL, NULL, 'Cadherin 17, LI cadherin (Liver-intestine)', NULL, NULL, NULL, NULL, NULL, 4),
(180473, NULL, 'G3DSA:1.10.3370.10:FF:000017', NULL, NULL, 'Os09g0512600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(180474, NULL, 'G3DSA:1.10.10.60:FF:000584', NULL, NULL, 'Unplaced genomic scaffold supercont1.70, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(180475, NULL, 'G3DSA:3.80.10.10:FF:004417', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180476, NULL, 'G3DSA:4.10.900.10:FF:000019', NULL, NULL, 'Si:ch73-74h11.1', NULL, NULL, NULL, NULL, NULL, 4),
(180477, NULL, 'G3DSA:1.20.1070.10:FF:002133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180478, NULL, 'G3DSA:3.40.190.80:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180479, NULL, 'G3DSA:3.30.530.20:FF:000004', NULL, NULL, 'Phosphatidylinositol transfer protein alpha isoform', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(180480, NULL, 'G3DSA:3.40.630.10:FF:000001', NULL, NULL, 'Carboxypeptidase B', NULL, NULL, NULL, NULL, NULL, 4),
(180481, NULL, 'G3DSA:3.40.630.30:FF:000316', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(180482, NULL, 'G3DSA:1.20.1070.10:FF:001644', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180483, NULL, 'G3DSA:1.10.390.10:FF:000058', NULL, NULL, 'Aminopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180484, NULL, 'G3DSA:2.130.10.10:FF:000595', NULL, NULL, 'DDB1 and CUL4 associated factor 13', NULL, NULL, NULL, NULL, NULL, 4),
(180485, NULL, 'G3DSA:2.60.120.10:FF:000687', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180486, NULL, 'G3DSA:1.10.510.10:FF:000754', NULL, NULL, 'Interleukin-1 receptor-associated kinase', NULL, NULL, NULL, NULL, NULL, 4),
(180487, NULL, 'G3DSA:3.40.50.2300:FF:000104', NULL, NULL, 'Two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(180488, NULL, 'G3DSA:3.30.750.24:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180489, NULL, 'G3DSA:3.90.660.10:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180490, NULL, 'G3DSA:3.40.50.150:FF:001112', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180491, NULL, 'G3DSA:3.30.420.10:FF:000100', NULL, NULL, '3''-5'' exonuclease/helicase (Wrn), putative', NULL, NULL, NULL, NULL, NULL, 4),
(180492, NULL, 'G3DSA:3.30.70.20:FF:000109', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180493, NULL, 'G3DSA:2.130.10.10:FF:003826', NULL, NULL, 'Neuroblastoma-amplified sequence', NULL, NULL, NULL, NULL, NULL, 4),
(180494, NULL, 'G3DSA:1.10.510.10:FF:003025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180495, NULL, 'G3DSA:3.40.50.300:FF:006952', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180496, NULL, 'G3DSA:3.30.470.20:FF:000033', NULL, NULL, 'Probable tubulin polyglutamylase TTLL1', NULL, NULL, NULL, NULL, NULL, 4),
(180497, NULL, 'G3DSA:1.10.8.10:FF:000315', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(180498, NULL, 'G3DSA:1.10.418.10:FF:000112', NULL, NULL, 'MICAL like 1', NULL, NULL, NULL, NULL, NULL, 4),
(180499, NULL, 'G3DSA:1.10.510.10:FF:000647', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(180500, NULL, 'G3DSA:3.30.1360.120:FF:000015', NULL, NULL, 'IBA57, iron-sulfur cluster assembly', NULL, NULL, NULL, NULL, NULL, 4),
(180501, NULL, 'G3DSA:3.30.200.20:FF:002155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180502, NULL, 'G3DSA:3.10.100.10:FF:000047', NULL, NULL, 'lymphocyte antigen 75', NULL, NULL, NULL, NULL, NULL, 4),
(180503, NULL, 'G3DSA:3.40.50.10130:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180504, NULL, 'G3DSA:3.10.310.40:FF:000004', NULL, NULL, 'Alanyl-tRNA synthetase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(180505, NULL, 'G3DSA:2.40.10.340:FF:000007', NULL, NULL, 'Cell shape-determining protein MreC', NULL, NULL, NULL, NULL, NULL, 4),
(180506, NULL, 'G3DSA:1.25.50.20:FF:000013', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(180507, NULL, 'G3DSA:1.10.3210.10:FF:000096', NULL, NULL, 'AGAP006056-PA', NULL, NULL, NULL, NULL, NULL, 4),
(180508, NULL, 'G3DSA:3.40.190.80:FF:000072', NULL, NULL, 'Inositol-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(180509, NULL, 'G3DSA:3.10.180.10:FF:000063', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(180510, NULL, 'G3DSA:3.40.50.150:FF:000730', NULL, NULL, 'Polyamine aminopropyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(180511, NULL, 'G3DSA:1.10.287.3510:FF:000009', NULL, NULL, 'Na(+)/H(+) antiporter subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(180512, NULL, 'G3DSA:3.40.50.300:FF:002681', NULL, NULL, 'Ctf18p', NULL, NULL, NULL, NULL, NULL, 4),
(180513, NULL, 'G3DSA:3.40.140.10:FF:000121', NULL, NULL, 'NPL4 family, putative', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(180514, NULL, 'G3DSA:2.120.10.30:FF:000450', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(180515, NULL, 'G3DSA:1.10.1450.10:FF:000046', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(180516, NULL, 'G3DSA:2.130.10.10:FF:002995', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(180517, NULL, 'G3DSA:2.30.29.30:FF:000738', NULL, NULL, 'Putative Rho guanine nucleotide exchange factor FGD-1', NULL, NULL, NULL, NULL, NULL, 4),
(180518, NULL, 'G3DSA:3.40.1520.20:FF:000001', NULL, NULL, 'Peptidoglycan-binding protein ArfA', NULL, NULL, NULL, NULL, NULL, 4),
(180519, NULL, 'G3DSA:3.30.160.60:FF:000078', NULL, NULL, 'Zinc finger protein 180', NULL, NULL, NULL, NULL, NULL, 4),
(180520, NULL, 'G3DSA:2.40.100.10:FF:000139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180521, NULL, 'G3DSA:2.60.470.10:FF:000027', NULL, NULL, 'Amiloride-sensitive sodium channel subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(180522, NULL, 'G3DSA:3.40.50.300:FF:006424', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180523, NULL, 'G3DSA:1.10.10.60:FF:000275', NULL, NULL, 'jerky protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(180524, NULL, 'G3DSA:2.30.29.30:FF:001357', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(180525, NULL, 'G3DSA:2.10.25.10:FF:001753', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180526, NULL, 'G3DSA:2.130.10.10:FF:005749', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180527, NULL, 'G3DSA:1.25.10.10:FF:001626', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180528, NULL, 'G3DSA:1.20.920.10:FF:000176', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(180529, NULL, 'G3DSA:3.30.70.330:FF:001307', NULL, NULL, 'AT20472p', NULL, NULL, NULL, NULL, NULL, 4),
(180530, NULL, 'G3DSA:1.25.40.690:FF:000012', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(180531, NULL, 'G3DSA:2.60.40.3210:FF:000002', NULL, NULL, 'Tectorin alpha', NULL, NULL, NULL, NULL, NULL, 4),
(180532, NULL, 'G3DSA:3.40.33.10:FF:000026', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(180533, NULL, 'G3DSA:2.60.40.10:FF:000162', NULL, NULL, 'Tenascin C', NULL, NULL, NULL, NULL, NULL, 4),
(180534, NULL, 'G3DSA:1.25.10.10:FF:001519', NULL, NULL, 'Formin homology 2 domain containing, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(180535, NULL, 'G3DSA:1.10.238.10:FF:001003', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(180536, NULL, 'G3DSA:1.10.238.150:FF:000008', NULL, NULL, 'Formin (Bud-site selection/polarity protein), putative', NULL, NULL, NULL, NULL, NULL, 4),
(180537, NULL, 'G3DSA:1.10.10.10:FF:000030', NULL, NULL, 'Forkhead box protein K2', NULL, NULL, NULL, NULL, NULL, 4),
(180538, NULL, 'G3DSA:3.30.230.70:FF:000148', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase 1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(180539, NULL, 'G3DSA:1.20.1280.50:FF:000053', NULL, NULL, 'F-box/LRR-repeat protein At3g48880', NULL, NULL, NULL, NULL, NULL, 4),
(180540, NULL, 'G3DSA:1.10.510.10:FF:001266', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180541, NULL, 'G3DSA:3.30.160.60:FF:000611', NULL, NULL, 'zinc finger protein 341 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(180542, NULL, 'G3DSA:3.30.740.10:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180543, NULL, 'G3DSA:1.20.5.110:FF:000089', NULL, NULL, 'Golgi vesicular membrane trafficking protein', NULL, NULL, NULL, NULL, NULL, 4),
(180544, NULL, 'G3DSA:3.40.50.1240:FF:000078', NULL, NULL, 'Phosphohistidine phosphatase SixA', NULL, NULL, NULL, NULL, NULL, 4),
(180545, NULL, 'G3DSA:1.10.510.10:FF:004014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180546, NULL, 'G3DSA:1.10.510.10:FF:002064', NULL, NULL, 'Kinase-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(180547, NULL, 'G3DSA:1.25.40.10:FF:005186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(180548, NULL, 'G3DSA:1.20.1250.20:FF:001071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180549, NULL, 'G3DSA:3.30.70.330:FF:000133', NULL, NULL, 'poly(U)-binding-splicing factor PUF60 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(180550, NULL, 'G3DSA:3.50.50.60:FF:000344', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(180551, NULL, 'G3DSA:3.40.50.2300:FF:001537', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180552, NULL, 'G3DSA:2.60.120.970:FF:000089', NULL, NULL, 'Bone morphogenetic protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(180553, NULL, 'G3DSA:3.90.190.20:FF:000037', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(180554, NULL, 'G3DSA:3.90.70.80:FF:000001', NULL, NULL, 'OTU domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(180555, NULL, 'G3DSA:3.40.50.2300:FF:000885', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180556, NULL, 'G3DSA:3.40.1110.10:FF:000080', NULL, NULL, 'Putative P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(180557, NULL, 'G3DSA:1.10.8.60:FF:000072', NULL, NULL, 'probable inactive ATP-dependent zinc metalloprotease FTSHI 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(180558, NULL, 'G3DSA:2.60.120.260:FF:000117', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(180559, NULL, 'G3DSA:3.40.50.410:FF:000353', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180560, NULL, 'G3DSA:1.25.40.420:FF:000072', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(180561, NULL, 'G3DSA:2.60.40.10:FF:003832', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180562, NULL, 'G3DSA:1.25.10.10:FF:000665', NULL, NULL, 'Pumilio protein 9, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180563, NULL, 'G3DSA:3.30.1640.10:FF:000088', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(180564, NULL, 'G3DSA:3.90.550.10:FF:000366', NULL, NULL, 'Glycosyl transferase family 8 protein', NULL, NULL, NULL, NULL, NULL, 4),
(180565, NULL, 'G3DSA:2.30.30.30:FF:000163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180566, NULL, 'G3DSA:3.40.640.10:FF:000070', NULL, NULL, 'O-phosphoseryl-tRNA(Sec) selenium transferase', NULL, NULL, NULL, NULL, NULL, 4),
(180567, NULL, 'G3DSA:3.30.420.10:FF:000465', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180568, NULL, 'G3DSA:3.40.1160.10:FF:000009', NULL, NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(180569, NULL, 'G3DSA:2.40.20.10:FF:000038', NULL, NULL, 'Coagulation factor II (thrombin)', NULL, NULL, NULL, NULL, NULL, 4),
(180570, NULL, 'G3DSA:3.40.20.10:FF:000075', NULL, NULL, 'DreBriN 1/DreBriN-like (Where Drebrin is from Developmentally REgulated BRaIN protein) family homolog', NULL, NULL, NULL, NULL, NULL, 4),
(180571, NULL, 'G3DSA:3.30.200.20:FF:001975', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180572, NULL, 'G3DSA:2.60.40.2170:FF:000010', NULL, NULL, 'tyrosine-protein kinase RYK', NULL, NULL, NULL, NULL, NULL, 4),
(180573, NULL, 'G3DSA:2.60.40.60:FF:000508', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(180574, NULL, 'G3DSA:2.40.40.20:FF:000019', NULL, NULL, 'DNA-directed RNA polymerase II subunit RPB1', NULL, NULL, NULL, NULL, NULL, 4),
(180575, NULL, 'G3DSA:1.10.287.380:FF:000002', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(180576, NULL, 'G3DSA:2.130.10.10:FF:004754', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180577, NULL, 'G3DSA:2.60.40.10:FF:000319', NULL, NULL, 'Dyslexia-associated protein KIAA0319 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(180578, NULL, 'G3DSA:2.130.10.10:FF:003956', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180579, NULL, 'G3DSA:3.40.190.10:FF:000776', NULL, NULL, 'Oligopeptide ABC transporter, periplasmic oligopeptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(180580, NULL, 'G3DSA:2.60.210.10:FF:000014', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 7', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(180581, NULL, 'G3DSA:3.40.309.10:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180582, NULL, 'G3DSA:3.40.50.720:FF:001435', NULL, NULL, 'Aspergillus niger contig An11c0010, genomic contig', NULL, NULL, NULL, NULL, NULL, 4),
(180583, NULL, 'G3DSA:3.40.50.720:FF:000996', NULL, NULL, '3-oxoacyl-(acyl-carrier protein) reductase fabG2', NULL, NULL, NULL, NULL, NULL, 4),
(180584, NULL, 'G3DSA:1.10.287.130:FF:000197', NULL, NULL, 'Sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(180585, NULL, 'G3DSA:2.10.25.10:FF:001309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180586, NULL, 'G3DSA:3.90.1490.10:FF:000011', NULL, NULL, 'Diphthamide biosynthesis protein Dph6', NULL, NULL, NULL, NULL, NULL, 4),
(180587, NULL, 'G3DSA:3.40.1110.10:FF:000422', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180588, NULL, 'G3DSA:2.30.180.10:FF:000186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180589, NULL, 'G3DSA:1.10.132.60:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180590, NULL, 'G3DSA:3.80.10.10:FF:001293', NULL, NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(180591, NULL, 'G3DSA:2.60.120.330:FF:000239', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(180592, NULL, 'G3DSA:3.80.10.10:FF:003119', NULL, NULL, 'Cilia and flagella-associated protein 410', NULL, NULL, NULL, NULL, NULL, 4),
(180593, NULL, 'G3DSA:3.40.1030.10:FF:000005', NULL, NULL, 'Anthranilate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(180594, NULL, 'G3DSA:3.40.830.10:FF:000005', NULL, NULL, 'AmmeMemoRadiSam system protein B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180595, NULL, 'G3DSA:3.40.50.2300:FF:000576', NULL, NULL, 'Chemotaxis protein CheV', NULL, NULL, NULL, NULL, NULL, 4),
(180596, NULL, 'G3DSA:3.30.160.60:FF:000864', NULL, NULL, 'Zinc fingers and homeoboxes protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(180597, NULL, 'G3DSA:3.40.630.50:FF:000002', NULL, NULL, 'D-aminoacyl-tRNA deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(180598, NULL, 'G3DSA:3.50.50.60:FF:000597', NULL, NULL, '2-octaprenyl-3-methyl-6-methoxy-1,4-benzoquinol hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(180599, NULL, 'G3DSA:2.60.40.4060:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180600, NULL, 'G3DSA:3.40.50.1820:FF:001477', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180601, NULL, 'G3DSA:1.25.40.10:FF:001347', NULL, NULL, 'Hsc70-interacting protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180602, NULL, 'G3DSA:2.30.29.230:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180603, NULL, 'G3DSA:1.20.58.390:FF:000026', NULL, NULL, 'Cholinergic receptor nicotinic beta 1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(180604, NULL, 'G3DSA:3.40.50.300:FF:004479', NULL, NULL, 'ATP-binding cassette transporter pdr1', NULL, NULL, NULL, NULL, NULL, 4),
(180605, NULL, 'G3DSA:3.30.1370.10:FF:000005', NULL, NULL, 'poly(RC)-binding protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(180606, NULL, 'G3DSA:3.40.1810.10:FF:000071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180607, NULL, 'G3DSA:3.30.160.60:FF:006024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180608, NULL, 'G3DSA:1.20.1730.10:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180609, NULL, 'G3DSA:2.70.150.10:FF:000231', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(180610, NULL, 'G3DSA:1.10.510.10:FF:000271', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(180611, NULL, 'G3DSA:3.40.50.2300:FF:000918', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180612, NULL, 'G3DSA:3.40.50.720:FF:001519', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(180613, NULL, 'G3DSA:3.40.605.10:FF:000044', NULL, NULL, 'Aldehyde dehydrogenase 16 family member A1', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(180614, NULL, 'G3DSA:3.80.10.10:FF:001635', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180615, NULL, 'G3DSA:2.10.230.10:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180616, NULL, 'G3DSA:3.10.580.10:FF:000155', NULL, NULL, 'UPF0053 protein sll1254', NULL, NULL, NULL, NULL, NULL, 4),
(180617, NULL, 'G3DSA:2.70.170.10:FF:000244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180618, NULL, 'G3DSA:1.20.1300.20:FF:000007', NULL, NULL, 'Ubiquitin thioesterase OTUB1', NULL, NULL, NULL, NULL, NULL, 4),
(180619, NULL, 'G3DSA:2.60.40.10:FF:000735', NULL, NULL, 'V-set and transmembrane domain containing 2 like', NULL, NULL, NULL, NULL, NULL, 4),
(180620, NULL, 'G3DSA:3.30.160.60:FF:005535', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180621, NULL, 'G3DSA:3.40.50.300:FF:004827', NULL, NULL, 'Excision repair cross-complementation group 6', NULL, NULL, NULL, NULL, NULL, 4),
(180622, NULL, 'G3DSA:2.60.40.10:FF:005625', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180623, NULL, 'G3DSA:1.20.1560.10:FF:000782', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180624, NULL, 'G3DSA:1.20.120.1380:FF:000009', NULL, NULL, 'Flagellar biosynthesis protein FlhF', NULL, NULL, NULL, NULL, NULL, 4),
(180625, NULL, 'G3DSA:2.60.40.1170:FF:000002', NULL, NULL, 'AP-1 complex subunit mu-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(180626, NULL, 'G3DSA:2.60.200.20:FF:000281', NULL, NULL, 'Meiosis-specific serine/threonine-protein kinase mek1', NULL, NULL, NULL, NULL, NULL, 4),
(180627, NULL, 'G3DSA:3.30.1360.10:FF:000050', NULL, NULL, 'AGAP008771-PA', NULL, NULL, NULL, NULL, NULL, 4),
(180628, NULL, 'G3DSA:3.40.50.410:FF:000370', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(180629, NULL, 'G3DSA:3.90.190.10:FF:000490', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type 7-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(180630, NULL, 'G3DSA:3.30.50.10:FF:000072', NULL, NULL, 'GATA zinc finger family protein', NULL, NULL, NULL, NULL, NULL, 4),
(180631, NULL, 'G3DSA:3.50.50.60:FF:000945', NULL, NULL, 'Sarcosine dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180632, NULL, 'G3DSA:3.40.50.2000:FF:000109', NULL, NULL, 'Chitobiosyldiphosphodolichol beta-mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(180633, NULL, 'G3DSA:2.130.10.10:FF:005934', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180634, NULL, 'G3DSA:3.90.79.10:FF:000253', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(180635, NULL, 'G3DSA:2.130.10.10:FF:003809', NULL, NULL, 'Uncharacterized WD repeat-containing protein C25H1.06', NULL, NULL, NULL, NULL, NULL, 4),
(180636, NULL, 'G3DSA:3.40.50.2300:FF:001065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180637, NULL, 'G3DSA:2.40.10.10:FF:000425', NULL, NULL, 'AGAP012315-PA', NULL, NULL, NULL, NULL, NULL, 4),
(180638, NULL, 'G3DSA:3.40.50.300:FF:005805', NULL, NULL, 'Pilus assembly protein PilB', NULL, NULL, NULL, NULL, NULL, 4),
(180639, NULL, 'G3DSA:3.10.110.10:FF:000328', NULL, NULL, 'Ubiquitin-conjugating enzyme E2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180640, NULL, 'G3DSA:2.10.70.10:FF:000205', NULL, NULL, 'sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(180641, NULL, 'G3DSA:3.40.1110.10:FF:000405', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180642, NULL, 'G3DSA:1.10.287.1130:FF:000015', NULL, NULL, 'Copper metallochaperone', NULL, NULL, NULL, NULL, NULL, 4),
(180643, NULL, 'G3DSA:3.30.300.30:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180644, NULL, 'G3DSA:3.30.70.240:FF:000004', NULL, NULL, '116 kDa U5 small nuclear ribonucleoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(180645, NULL, 'G3DSA:3.30.70.3290:FF:000004', NULL, NULL, 'Sterigmatocystin biosynthesis polyketide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(180646, NULL, 'G3DSA:1.20.5.510:FF:000001', NULL, NULL, 'Photosystem I reaction center subunit IX', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(180647, NULL, 'G3DSA:3.30.430.20:FF:000042', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 42', NULL, NULL, NULL, NULL, NULL, 4),
(180648, NULL, 'G3DSA:3.40.50.300:FF:004052', NULL, NULL, 'Armitage, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(180649, NULL, 'G3DSA:3.30.1370.10:FF:000224', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(180650, NULL, 'G3DSA:1.25.10.10:FF:000215', NULL, NULL, 'leucine-rich repeat serine/threonine-protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(180651, NULL, 'G3DSA:3.30.160.20:FF:000206', NULL, NULL, 'Eukaryotic translation initiation factor 2 alpha kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(180652, NULL, 'G3DSA:3.40.50.970:FF:000060', NULL, NULL, '1-deoxy-D-xylulose-5-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(180653, NULL, 'G3DSA:3.30.530.20:FF:000111', NULL, NULL, 'Phosphatidylinositol transfer protein, beta,-like', NULL, NULL, NULL, NULL, NULL, 4),
(180654, NULL, 'G3DSA:3.40.50.300:FF:000556', NULL, NULL, 'Methylenetetrahydrofolate dehydrogenase (NADP+ dependent) 1 like', NULL, NULL, NULL, NULL, NULL, 4),
(180655, NULL, 'G3DSA:3.50.50.60:FF:000260', NULL, NULL, 'Dihydrolipoyl dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(180656, NULL, 'G3DSA:3.40.50.10810:FF:000048', NULL, NULL, 'SNF2 helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180657, NULL, 'G3DSA:3.30.420.40:FF:000435', NULL, NULL, 'SWI/SNF nucleosome remodeling complex component', NULL, NULL, NULL, NULL, NULL, 4),
(180658, NULL, 'G3DSA:2.60.40.10:FF:000954', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', NULL, NULL, NULL, NULL, NULL, 4),
(180659, NULL, 'G3DSA:3.20.20.140:FF:000107', NULL, NULL, 'Adenosine deaminase putative', NULL, NULL, NULL, NULL, NULL, 4),
(180660, NULL, 'G3DSA:1.10.10.60:FF:000691', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(180661, NULL, 'G3DSA:3.40.50.720:FF:000816', NULL, NULL, 'HesA/MoeB/ThiF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(180662, NULL, 'G3DSA:1.10.510.10:FF:000086', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(180663, NULL, 'G3DSA:1.10.3730.10:FF:000017', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(180664, NULL, 'G3DSA:3.40.50.2000:FF:000784', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180665, NULL, 'G3DSA:2.40.10.10:FF:000083', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(180666, NULL, 'G3DSA:3.40.50.2300:FF:001407', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180667, NULL, 'G3DSA:3.30.980.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180668, NULL, 'G3DSA:4.10.400.10:FF:000217', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(180669, NULL, 'G3DSA:2.20.70.70:FF:000003', NULL, NULL, 'Dihydropteridine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(180670, NULL, 'G3DSA:3.30.70.330:FF:000003', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(180671, NULL, 'G3DSA:3.40.50.1820:FF:001792', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180672, NULL, 'G3DSA:2.60.40.1770:FF:000002', NULL, NULL, 'ephrin type-A receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(180673, NULL, 'G3DSA:2.10.25.10:FF:000825', NULL, NULL, 'Crumbs, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(180674, NULL, 'G3DSA:1.20.1600.10:FF:000027', NULL, NULL, 'Outer membrane protein TolC', NULL, NULL, NULL, NULL, NULL, 4),
(180675, NULL, 'G3DSA:2.30.130.60:FF:000001', NULL, NULL, 'Sun/nucleolar protein family protein-putative tRNA and rRNA cytosine-C5-methylase', NULL, NULL, NULL, NULL, NULL, 4),
(180676, NULL, 'G3DSA:3.40.50.720:FF:001305', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(180677, NULL, 'G3DSA:1.10.287.110:FF:000186', NULL, NULL, 'GD13648', NULL, NULL, NULL, NULL, NULL, 4),
(180678, NULL, 'G3DSA:3.40.50.300:FF:005463', NULL, NULL, 'ATPase, RecA superfamily', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(180679, NULL, 'G3DSA:2.40.10.10:FF:000392', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180680, NULL, 'G3DSA:1.20.1560.10:FF:000563', NULL, NULL, 'ATP-binding cassette transporter, subfamily B, member 20, group MDR/PGP protein PpABCB20', NULL, NULL, NULL, NULL, NULL, 4),
(180681, NULL, 'G3DSA:3.30.565.10:FF:000138', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(180682, NULL, 'G3DSA:1.20.1560.10:FF:000911', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180683, NULL, 'G3DSA:2.130.10.10:FF:005373', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180684, NULL, 'G3DSA:3.30.428.10:FF:000022', NULL, NULL, 'AP-4-A phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(180685, NULL, 'G3DSA:3.30.450.50:FF:000029', NULL, NULL, 'GD10048', NULL, NULL, NULL, NULL, NULL, 4),
(180686, NULL, 'G3DSA:1.25.40.20:FF:001592', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180687, NULL, 'G3DSA:2.60.40.3510:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180688, NULL, 'G3DSA:3.40.50.620:FF:000775', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(180689, NULL, 'G3DSA:2.70.130.10:FF:000163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180690, NULL, 'G3DSA:2.30.29.30:FF:000053', NULL, NULL, 'Engulfment and cell motility protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(180691, NULL, 'G3DSA:3.40.140.10:FF:000149', NULL, NULL, 'Translation initiation factor eIF3 subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180692, NULL, 'G3DSA:2.60.120.650:FF:000111', NULL, NULL, 'Jumonji/ARID domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(180693, NULL, 'G3DSA:3.40.50.300:FF:001753', NULL, NULL, 'Mitochondrial GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(180694, NULL, 'G3DSA:3.40.50.300:FF:005772', NULL, NULL, 'Os03g0810700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(180695, NULL, 'G3DSA:1.10.246.20:FF:000007', NULL, NULL, 'RNA polymerase II holoenzyme complex component', NULL, NULL, NULL, NULL, NULL, 4),
(180696, NULL, 'G3DSA:3.90.550.10:FF:000282', NULL, NULL, 'Bifunctional IPC transferase and DIPP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(180697, NULL, 'G3DSA:2.70.98.10:FF:000053', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(180698, NULL, 'G3DSA:3.30.160.20:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180699, NULL, 'G3DSA:3.30.70.330:FF:003095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180700, NULL, 'G3DSA:3.30.200.20:FF:001536', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180701, NULL, 'G3DSA:3.40.50.10190:FF:000165', NULL, NULL, 'PAX transcription activation domain interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(180702, NULL, 'G3DSA:2.60.40.10:FF:002899', NULL, NULL, 'Myotactin form B', NULL, NULL, NULL, NULL, NULL, 4),
(180703, NULL, 'G3DSA:2.130.10.10:FF:003012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180704, NULL, 'G3DSA:3.30.40.10:FF:000588', NULL, NULL, 'RING/U-box superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(180705, NULL, 'G3DSA:3.40.50.300:FF:002265', NULL, NULL, 'Elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(180706, NULL, 'G3DSA:1.20.1270.420:FF:000013', NULL, NULL, 'Inhibitor of nuclear factor kappa B kinase subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(180707, NULL, 'G3DSA:1.10.472.10:FF:000193', NULL, NULL, 'Cyclin-D1-1', NULL, NULL, NULL, NULL, NULL, 4),
(180708, NULL, 'G3DSA:3.40.50.1580:FF:000051', NULL, NULL, 'S-methyl-5''-thioadenosine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(180709, NULL, 'G3DSA:2.60.40.10:FF:003517', NULL, NULL, 'Guanine nucleotide exchange factor UNC-73A', NULL, NULL, NULL, NULL, NULL, 4),
(180710, NULL, 'G3DSA:3.80.10.10:FF:004069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180711, NULL, 'G3DSA:3.40.50.300:FF:003299', NULL, NULL, 'Os06g0114600 protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(180712, NULL, 'G3DSA:1.10.510.10:FF:000193', NULL, NULL, 'Serine/threonine-protein kinase CTR1', NULL, NULL, NULL, NULL, NULL, 4),
(180713, NULL, 'G3DSA:3.30.200.20:FF:001519', NULL, NULL, 'cyclin-dependent kinase 16-like', NULL, NULL, NULL, NULL, NULL, 4),
(180714, NULL, 'G3DSA:2.130.10.10:FF:003484', NULL, NULL, 'WD40 repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(180715, NULL, 'G3DSA:3.30.450.20:FF:000150', NULL, NULL, 'PAS domain-containing sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(180716, NULL, 'G3DSA:3.40.50.1000:FF:000366', NULL, NULL, 'HAD-superfamily phosphatase, subfamily IIIC containing protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(180717, NULL, 'G3DSA:2.30.42.10:FF:000595', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180718, NULL, 'G3DSA:1.10.760.10:FF:000014', NULL, NULL, 'Cytochrome c', NULL, NULL, NULL, NULL, NULL, 4),
(180719, NULL, 'G3DSA:3.30.300.10:FF:000046', NULL, NULL, 'S-adenosylmethionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(180720, NULL, 'G3DSA:3.40.50.1240:FF:000095', NULL, NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(180721, NULL, 'G3DSA:3.40.50.300:FF:005013', NULL, NULL, 'Mrp, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180722, NULL, 'G3DSA:1.25.40.20:FF:001676', NULL, NULL, 'Homeobox protein Wariai', NULL, NULL, NULL, NULL, NULL, 4),
(180723, NULL, 'G3DSA:1.25.40.20:FF:000642', NULL, NULL, 'transient receptor potential cation channel subfamily V member 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(180724, NULL, 'G3DSA:1.10.533.10:FF:000071', NULL, NULL, 'NACHT, LRR and PYD domains-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(180725, NULL, 'G3DSA:3.20.20.70:FF:000324', NULL, NULL, 'Dihydrouridine synthase (Dus), putative', NULL, NULL, NULL, NULL, NULL, 4),
(180726, NULL, 'G3DSA:3.30.160.60:FF:000842', NULL, NULL, 'Zinc finger protein 383', NULL, NULL, NULL, NULL, NULL, 4),
(180727, NULL, 'G3DSA:2.60.40.10:FF:002427', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180728, NULL, 'G3DSA:3.30.830.10:FF:000131', NULL, NULL, 'Zinc protease PQQL-like', NULL, NULL, NULL, NULL, NULL, 4),
(180729, NULL, 'G3DSA:3.30.390.60:FF:000016', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(180730, NULL, 'G3DSA:1.10.238.10:FF:000694', NULL, NULL, 'EF-hand domain pair, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180731, NULL, 'G3DSA:3.20.20.70:FF:000796', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180732, NULL, 'G3DSA:3.90.180.10:FF:000101', NULL, NULL, 'Alcohol dehydrogenase 6B (class V)', NULL, NULL, NULL, NULL, NULL, 4),
(180733, NULL, 'G3DSA:2.60.120.200:FF:000695', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180734, NULL, 'G3DSA:3.30.450.20:FF:000633', NULL, NULL, 'Sensor histidine kinase, HAMP domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(180735, NULL, 'G3DSA:3.40.720.10:FF:000087', NULL, NULL, 'Arylsulfatase B', NULL, NULL, NULL, NULL, NULL, 4),
(180736, NULL, 'G3DSA:3.10.260.30:FF:000002', NULL, NULL, 'AaceriAFR690Cp', NULL, NULL, NULL, NULL, NULL, 4),
(180737, NULL, 'G3DSA:1.10.10.10:FF:000485', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(180738, NULL, 'G3DSA:3.10.20.30:FF:000077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180739, NULL, 'G3DSA:2.40.10.170:FF:000012', NULL, NULL, 'ATP synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(180740, NULL, 'G3DSA:3.50.50.100:FF:000016', NULL, NULL, 'NAD(P)H dehydrogenase 3', NULL, NULL, NULL, NULL, NULL, 4),
(180741, NULL, 'G3DSA:2.40.30.10:FF:000174', NULL, NULL, 'Ferredoxin--NADP reductase', NULL, NULL, NULL, NULL, NULL, 4),
(180742, NULL, 'G3DSA:1.10.357.20:FF:000018', NULL, NULL, 'Solute carrier family 41, member 2', NULL, NULL, NULL, NULL, NULL, 4),
(180743, NULL, 'G3DSA:1.20.1070.10:FF:001172', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(180744, NULL, 'G3DSA:2.30.29.30:FF:001126', NULL, NULL, 'Pleckstrin homology domain-containing family J member 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(180745, NULL, 'G3DSA:2.40.128.200:FF:000002', NULL, NULL, 'Lipoprotein LprI', NULL, NULL, NULL, NULL, NULL, 4),
(180746, NULL, 'G3DSA:2.60.120.200:FF:000706', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(180747, NULL, 'G3DSA:3.40.390.10:FF:000196', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180748, NULL, 'G3DSA:1.10.472.10:FF:000204', NULL, NULL, 'Cyclin C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180749, NULL, 'G3DSA:1.10.1040.50:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180750, NULL, 'G3DSA:2.60.40.1080:FF:000003', NULL, NULL, 'Phage major tail protein', NULL, NULL, NULL, NULL, NULL, 4),
(180751, NULL, 'G3DSA:1.20.1270.280:FF:000044', NULL, NULL, 'Inner dynein arm 1 heavy chain 1-ALPHa', NULL, NULL, NULL, NULL, NULL, 4),
(180752, NULL, 'G3DSA:1.10.10.390:FF:000004', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(180753, NULL, 'G3DSA:3.90.226.10:FF:000332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180754, NULL, 'G3DSA:3.90.1150.10:FF:000340', NULL, NULL, 'Cysteine desulfurase IscS', NULL, NULL, NULL, NULL, NULL, 4),
(180755, NULL, 'G3DSA:3.90.190.10:FF:000074', NULL, NULL, 'Protein tyrosine phosphatase type IVA 2', NULL, NULL, NULL, NULL, NULL, 4),
(180756, NULL, 'G3DSA:3.30.160.60:FF:005619', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180757, NULL, 'G3DSA:1.10.287.40:FF:000001', NULL, NULL, 'Serine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(180758, NULL, 'G3DSA:1.10.630.10:FF:000774', NULL, NULL, 'Cytochrome P450, family 71, subfamily B, polypeptide 32', NULL, NULL, NULL, NULL, NULL, 4),
(180759, NULL, 'G3DSA:2.60.40.10:FF:004136', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180760, NULL, 'G3DSA:3.40.710.10:FF:000058', NULL, NULL, 'Transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(180761, NULL, 'G3DSA:3.40.50.720:FF:001744', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180762, NULL, 'G3DSA:3.30.1490.20:FF:000045', NULL, NULL, 'Bifunctional urea carboxylase/allophanate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(180763, NULL, 'G3DSA:1.10.472.80:FF:000258', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180764, NULL, 'G3DSA:3.90.1410.10:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180765, NULL, 'G3DSA:3.30.1330.30:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180766, NULL, 'G3DSA:3.30.530.20:FF:000095', NULL, NULL, 'Possible membrane oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(180767, NULL, 'G3DSA:3.50.30.10:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180768, NULL, 'G3DSA:2.60.40.10:FF:001808', NULL, NULL, 'Neuromusculin, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(180769, NULL, 'G3DSA:3.30.760.10:FF:000058', NULL, NULL, 'Eukaryotic translation initiation factor 4E family member 1B', NULL, NULL, NULL, NULL, NULL, 4),
(180770, NULL, 'G3DSA:3.30.70.380:FF:000007', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(180771, NULL, 'G3DSA:1.20.58.900:FF:000011', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(180772, NULL, 'G3DSA:2.60.40.10:FF:000870', NULL, NULL, 'sushi, nidogen and EGF-like domain-containing protein 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(180773, NULL, 'G3DSA:3.40.50.2020:FF:000104', NULL, NULL, 'Ribose-phosphate pyrophosphokinase 2 isoform x1', NULL, NULL, NULL, NULL, NULL, 4),
(180774, NULL, 'G3DSA:2.130.10.10:FF:001775', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180775, NULL, 'G3DSA:2.120.10.30:FF:000141', NULL, NULL, 'NHL repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(180776, NULL, 'G3DSA:3.40.50.2000:FF:001082', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(180777, NULL, 'G3DSA:3.30.420.10:FF:000696', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180778, NULL, 'G3DSA:1.10.357.140:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(180779, NULL, 'G3DSA:3.50.30.30:FF:000019', NULL, NULL, 'Signal peptide peptidase like 2A', NULL, NULL, NULL, NULL, NULL, 4),
(180780, NULL, 'G3DSA:3.40.50.10420:FF:000026', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(180781, NULL, 'G3DSA:1.25.40.10:FF:000526', NULL, NULL, 'Transmembrane and tetratricopeptide repeat-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(180782, NULL, 'G3DSA:1.20.1250.20:FF:001285', NULL, NULL, 'Drug resistance transporter, EmrB/QacA family', NULL, NULL, NULL, NULL, NULL, 4),
(180783, NULL, 'G3DSA:3.60.120.10:FF:000020', NULL, NULL, 'Salicylate synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180784, NULL, 'G3DSA:2.10.50.10:FF:000114', NULL, NULL, 'Fas cell surface death receptor', NULL, NULL, NULL, NULL, NULL, 4),
(180785, NULL, 'G3DSA:3.30.70.1450:FF:000014', NULL, NULL, 'Sulfur deprivation response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(180786, NULL, 'G3DSA:3.30.160.60:FF:002972', NULL, NULL, 'GM18664', NULL, NULL, NULL, NULL, NULL, 4),
(180787, NULL, 'G3DSA:3.40.50.300:FF:006160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180788, NULL, 'G3DSA:3.90.70.10:FF:000469', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180789, NULL, 'G3DSA:1.10.510.10:FF:002755', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180790, NULL, 'G3DSA:2.30.110.10:FF:000092', NULL, NULL, 'Flavin reductase like domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(180791, NULL, 'G3DSA:2.10.25.10:FF:000909', NULL, NULL, 'Notch receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(180792, NULL, 'G3DSA:2.30.30.140:FF:000173', NULL, NULL, 'GM24389', NULL, NULL, NULL, NULL, NULL, 4),
(180793, NULL, 'G3DSA:2.160.20.70:FF:000033', NULL, NULL, 'Adenylyl cyclase-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(180794, NULL, 'G3DSA:3.80.10.10:FF:003563', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180795, NULL, 'G3DSA:3.30.450.40:FF:000156', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(180796, NULL, 'G3DSA:3.30.200.20:FF:000103', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(180797, NULL, 'G3DSA:3.30.160.60:FF:005193', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180798, NULL, 'G3DSA:1.10.510.10:FF:003845', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180799, NULL, 'G3DSA:3.90.260.10:FF:000046', NULL, NULL, 'Xeroderma pigmentosum, complementation group C', NULL, NULL, NULL, NULL, NULL, 4),
(180800, NULL, 'G3DSA:2.60.40.790:FF:000059', NULL, NULL, '26.5 kDa heat shock protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(180801, NULL, 'G3DSA:3.30.70.330:FF:000150', NULL, NULL, 'msx2-interacting protein-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(180802, NULL, 'G3DSA:1.10.1450.10:FF:000068', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(180803, NULL, 'G3DSA:3.40.50.10470:FF:000047', NULL, NULL, 'Eukaryotic initiation factor', NULL, NULL, NULL, NULL, NULL, 4),
(180804, NULL, 'G3DSA:1.10.1410.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180805, NULL, 'G3DSA:2.160.10.20:FF:000001', NULL, NULL, 'Pre-neck appendage protein', NULL, NULL, NULL, NULL, NULL, 4),
(180806, NULL, 'G3DSA:3.30.450.40:FF:000263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180807, NULL, 'G3DSA:3.40.50.300:FF:000117', NULL, NULL, 'Putative DNA repair helicase rad25', NULL, NULL, NULL, NULL, NULL, 4),
(180808, NULL, 'G3DSA:2.60.120.970:FF:000111', NULL, NULL, 'Glass bottom boat2', NULL, NULL, NULL, NULL, NULL, 4),
(180809, NULL, 'G3DSA:1.20.5.110:FF:000128', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(180810, NULL, 'G3DSA:3.40.50.2000:FF:000929', NULL, NULL, 'Lipopolysaccharide core biosynthesis protein rfaQ', NULL, NULL, NULL, NULL, NULL, 4),
(180811, NULL, 'G3DSA:2.60.40.60:FF:000036', NULL, NULL, 'Protocadherin 9', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(180812, NULL, 'G3DSA:1.20.1580.10:FF:000002', NULL, NULL, 'UvrABC system protein A', NULL, NULL, NULL, NULL, NULL, 4),
(180813, NULL, 'G3DSA:1.25.40.10:FF:000835', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(180814, NULL, 'G3DSA:1.10.470.10:FF:000003', NULL, NULL, 'Variant surface glycoprotein (VSG), putative', NULL, NULL, NULL, NULL, NULL, 4),
(180815, NULL, 'G3DSA:3.40.50.1820:FF:000387', NULL, NULL, 'SAY1p Sterol deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(180816, NULL, 'G3DSA:3.90.70.10:FF:000834', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180817, NULL, 'G3DSA:3.30.1370.10:FF:000241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180818, NULL, 'G3DSA:1.20.58.760:FF:000042', NULL, NULL, 'Mitochondrial respiratory chain complexes assembly protein rca1', NULL, NULL, NULL, NULL, NULL, 4),
(180819, NULL, 'G3DSA:1.10.20.10:FF:000311', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180820, NULL, 'G3DSA:2.60.40.10:FF:003141', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180821, NULL, 'G3DSA:2.70.98.20:FF:000039', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(180822, NULL, 'G3DSA:3.40.30.10:FF:001082', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(180823, NULL, 'G3DSA:1.10.3470.10:FF:000053', NULL, NULL, 'Transport system permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(180824, NULL, 'G3DSA:3.40.190.290:FF:000037', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(180825, NULL, 'G3DSA:2.60.120.960:FF:000001', NULL, NULL, 'Spike glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(180826, NULL, 'G3DSA:1.10.287.110:FF:000293', NULL, NULL, 'DnaJ-like protein subfamily C member 27', NULL, NULL, NULL, NULL, NULL, 4),
(180827, NULL, 'G3DSA:2.130.10.10:FF:000628', NULL, NULL, 'Pre-mRNA-splicing factor RSE1', NULL, NULL, NULL, NULL, NULL, 4),
(180828, NULL, 'G3DSA:3.40.430.10:FF:000020', NULL, NULL, 'Dihydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(180829, NULL, 'G3DSA:2.30.30.140:FF:000318', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180830, NULL, 'G3DSA:3.40.50.11840:FF:000014', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(180831, NULL, 'G3DSA:1.20.58.150:FF:000005', NULL, NULL, 'putative clathrin assembly protein At2g25430', NULL, NULL, NULL, NULL, NULL, 4),
(180832, NULL, 'G3DSA:1.10.472.10:FF:000513', NULL, NULL, 'Cyclin, N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(180833, NULL, 'G3DSA:1.10.510.10:FF:002227', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180834, NULL, 'G3DSA:1.10.238.110:FF:000007', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(180835, NULL, 'G3DSA:2.130.10.10:FF:005827', NULL, NULL, 'Putative CPSF-domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(180836, NULL, 'G3DSA:1.10.238.10:FF:000469', NULL, NULL, 'Follistatin like 1', NULL, NULL, NULL, NULL, NULL, 4),
(180837, NULL, 'G3DSA:3.80.10.10:FF:001163', NULL, NULL, 'Leucine-rich repeat (LRR) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(180838, NULL, 'G3DSA:2.30.29.30:FF:001379', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180839, NULL, 'G3DSA:3.40.50.300:FF:006317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180840, NULL, 'G3DSA:1.10.238.10:FF:001110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180841, NULL, 'G3DSA:2.60.120.260:FF:000342', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180842, NULL, 'G3DSA:2.40.240.10:FF:000065', NULL, NULL, 'Glutaminyl-tRNA synthetase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(180843, NULL, 'G3DSA:3.40.50.10900:FF:000002', NULL, NULL, 'PAC2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(180844, NULL, 'G3DSA:3.30.450.260:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(180845, NULL, 'G3DSA:3.90.230.10:FF:000004', NULL, NULL, 'xaa-Pro aminopeptidase 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(180846, NULL, 'G3DSA:2.60.40.60:FF:000525', NULL, NULL, 'Dachsous cadherin-related 1a', NULL, NULL, NULL, NULL, NULL, 4),
(180847, NULL, 'G3DSA:2.170.190.11:FF:000025', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(180848, NULL, 'G3DSA:3.40.50.2300:FF:000992', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180849, NULL, 'G3DSA:3.30.70.360:FF:000001', NULL, NULL, 'N-acetyldiaminopimelate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(180850, NULL, 'G3DSA:1.20.920.20:FF:000033', NULL, NULL, 'Dynein heavy chain 5, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(180851, NULL, 'G3DSA:3.10.110.10:FF:000109', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 J2-like', NULL, NULL, NULL, NULL, NULL, 4),
(180852, NULL, 'G3DSA:2.60.120.10:FF:000350', NULL, NULL, '3'',5''-cyclic-nucleotide phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(180853, NULL, 'G3DSA:3.40.50.11040:FF:000004', NULL, NULL, 'RNA cytidine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(180854, NULL, 'G3DSA:3.40.50.10330:FF:000095', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(180855, NULL, 'G3DSA:1.10.220.150:FF:000052', NULL, NULL, 'zinc finger protein Ci-ArfGAP-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(180856, NULL, 'G3DSA:3.40.1050.10:FF:000018', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(180857, NULL, 'G3DSA:1.10.1660.10:FF:000005', NULL, NULL, 'MerR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(180858, NULL, 'G3DSA:3.30.2160.10:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180859, NULL, 'G3DSA:3.40.50.880:FF:000111', NULL, NULL, 'Catalase', NULL, NULL, NULL, NULL, NULL, 4),
(180860, NULL, 'G3DSA:3.40.800.20:FF:000023', NULL, NULL, 'Histone deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(180861, NULL, 'G3DSA:2.160.20.10:FF:000280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180862, NULL, 'G3DSA:3.90.79.10:FF:000118', NULL, NULL, 'MuT/nudix family protein', NULL, NULL, NULL, NULL, NULL, 4),
(180863, NULL, 'G3DSA:3.10.105.10:FF:000058', NULL, NULL, 'Oligopeptide transport system binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(180864, NULL, 'G3DSA:3.90.550.10:FF:000057', NULL, NULL, 'Glycosyltransferase-like protein, family 2', NULL, NULL, NULL, NULL, NULL, 4),
(180865, NULL, 'G3DSA:2.130.10.10:FF:005518', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180866, NULL, 'G3DSA:2.130.10.10:FF:001556', NULL, NULL, 'Elongator complex protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(180867, NULL, 'G3DSA:3.30.420.40:FF:000328', NULL, NULL, 'ROK family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(180868, NULL, 'G3DSA:2.20.70.10:FF:000031', NULL, NULL, 'pre-mRNA-processing factor 40 homolog A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(180869, NULL, 'G3DSA:3.30.40.10:FF:002044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180870, NULL, 'G3DSA:1.20.1110.10:FF:000271', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180871, NULL, 'G3DSA:1.25.40.20:FF:001367', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180872, NULL, 'G3DSA:1.25.40.10:FF:001454', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(180873, NULL, 'G3DSA:3.40.50.300:FF:001646', NULL, NULL, 'Pantothenate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(180874, NULL, 'G3DSA:3.60.15.10:FF:000051', NULL, NULL, 'Ribonuclease Z, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(180875, NULL, 'G3DSA:3.80.10.10:FF:004288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180876, NULL, 'G3DSA:3.30.40.10:FF:001425', NULL, NULL, 'Sister chromatid cohesion protein SCC2', NULL, NULL, NULL, NULL, NULL, 4),
(180877, NULL, 'G3DSA:3.30.1360.120:FF:000032', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(180878, NULL, 'G3DSA:1.10.150.50:FF:000171', NULL, NULL, 'sphingomyelin synthase-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(180879, NULL, 'G3DSA:1.10.238.20:FF:000039', NULL, NULL, 'GM10854', NULL, NULL, NULL, NULL, NULL, 4),
(180880, NULL, 'G3DSA:3.40.850.10:FF:000113', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(180881, NULL, 'G3DSA:2.60.120.10:FF:000726', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180882, NULL, 'G3DSA:1.10.418.10:FF:000039', NULL, NULL, 'Transgelin', NULL, NULL, NULL, NULL, NULL, 4),
(180883, NULL, 'G3DSA:2.60.290.11:FF:000003', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(180884, NULL, 'G3DSA:3.30.200.20:FF:001430', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(180885, NULL, 'G3DSA:2.130.10.10:FF:001247', NULL, NULL, 'U3 small nucleolar RNA-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(180886, NULL, 'G3DSA:3.40.50.1820:FF:000948', NULL, NULL, 'Esterase', NULL, NULL, NULL, NULL, NULL, 4),
(180887, NULL, 'G3DSA:3.30.420.40:FF:000019', NULL, NULL, 'Rod shape-determining protein MreB', NULL, NULL, NULL, NULL, NULL, 4),
(180888, NULL, 'G3DSA:3.80.10.10:FF:003344', NULL, NULL, 'Centrosomal protein 78', NULL, NULL, NULL, NULL, NULL, 4),
(180889, NULL, 'G3DSA:3.30.160.60:FF:006007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180890, NULL, 'G3DSA:3.80.10.10:FF:002944', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(180891, NULL, 'G3DSA:1.10.630.10:FF:000246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180892, NULL, 'G3DSA:3.30.160.60:FF:004315', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180893, NULL, 'G3DSA:1.25.40.10:FF:005164', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(180894, NULL, 'G3DSA:3.40.50.300:FF:001270', NULL, NULL, 'Thymidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(180895, NULL, 'G3DSA:1.10.150.670:FF:000028', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(180896, NULL, 'G3DSA:3.10.180.10:FF:000046', NULL, NULL, '4-hydroxyphenylpyruvate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(180897, NULL, 'G3DSA:3.80.20.20:FF:000048', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(180898, NULL, 'G3DSA:3.40.50.150:FF:000128', NULL, NULL, 'DNA (cytosine-5)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(180899, NULL, 'G3DSA:1.10.287.1050:FF:000002', NULL, NULL, 'DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(180900, NULL, 'G3DSA:2.60.40.10:FF:001123', NULL, NULL, 'Amphoterin-induced protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(180901, NULL, 'G3DSA:1.10.540.10:FF:000110', NULL, NULL, 'Acyl-CoA dehydrogenase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(180902, NULL, 'G3DSA:1.10.10.60:FF:001236', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180903, NULL, 'G3DSA:3.10.20.740:FF:000008', NULL, NULL, 'Periplasmic [Fe] hydrogenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(180904, NULL, 'G3DSA:2.70.170.10:FF:000013', NULL, NULL, 'Acetylcholine receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(180905, NULL, 'G3DSA:3.65.10.10:FF:000001', NULL, NULL, 'UDP-N-acetylglucosamine 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(180906, NULL, 'G3DSA:2.60.40.1170:FF:000042', NULL, NULL, 'APM2 (YHL019C)', NULL, NULL, NULL, NULL, NULL, 4),
(180907, NULL, 'G3DSA:3.60.20.10:FF:000102', NULL, NULL, 'Asparagine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(180908, NULL, 'G3DSA:4.10.400.10:FF:000234', NULL, NULL, 'LDL receptor repeat-containing protein egg-1', NULL, NULL, NULL, NULL, NULL, 4),
(180909, NULL, 'G3DSA:1.10.510.10:FF:004464', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180910, NULL, 'G3DSA:1.20.1250.20:FF:000918', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(180911, NULL, 'G3DSA:1.20.1250.20:FF:000666', NULL, NULL, 'MonoCarboxylate Transporter family', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(180912, NULL, 'G3DSA:3.20.20.10:FF:000019', NULL, NULL, 'Putative diaminopimelate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(180913, NULL, 'G3DSA:3.40.50.720:FF:000215', NULL, NULL, '3-hydroxyacyl-CoA dehydrogenase type-2', NULL, NULL, NULL, NULL, NULL, 4),
(180914, NULL, 'G3DSA:1.20.1560.10:FF:000310', NULL, NULL, 'HlyB/MsbA family ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(180915, NULL, 'G3DSA:3.40.50.2300:FF:001610', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180916, NULL, 'G3DSA:1.10.420.10:FF:000056', NULL, NULL, 'Peroxidase 12', NULL, NULL, NULL, NULL, NULL, 4),
(180917, NULL, 'G3DSA:2.30.170.20:FF:000014', NULL, NULL, '50S ribosomal protein L24e', NULL, NULL, NULL, NULL, NULL, 4),
(180918, NULL, 'G3DSA:3.20.20.60:FF:000012', NULL, NULL, 'Phosphoenolpyruvate-protein phosphotransferase PtsP', NULL, NULL, NULL, NULL, NULL, 4),
(180919, NULL, 'G3DSA:3.30.160.60:FF:006463', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180920, NULL, 'G3DSA:1.25.10.10:FF:000446', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(180921, NULL, 'G3DSA:3.30.160.60:FF:004681', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180922, NULL, 'G3DSA:1.25.40.180:FF:000191', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180923, NULL, 'G3DSA:2.40.10.10:FF:000161', NULL, NULL, 'Serine protease DegP', NULL, NULL, NULL, NULL, NULL, 4),
(180924, NULL, 'G3DSA:1.10.510.10:FF:002536', NULL, NULL, 'BMP-2-inducible protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(180925, NULL, 'G3DSA:3.40.50.10810:FF:000183', NULL, NULL, 'Helicase superfamily, c-terminal domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(180926, NULL, 'G3DSA:3.40.50.2300:FF:001290', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180927, NULL, 'G3DSA:1.25.40.20:FF:000748', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180928, NULL, 'G3DSA:3.40.50.300:FF:007806', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180929, NULL, 'G3DSA:1.20.5.190:FF:000080', NULL, NULL, 'Myosin', NULL, NULL, NULL, NULL, NULL, 4),
(180930, NULL, 'G3DSA:3.80.10.10:FF:002579', NULL, NULL, 'NLR family CARD domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(180931, NULL, 'G3DSA:1.25.40.10:FF:004017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180932, NULL, 'G3DSA:3.40.50.720:FF:001963', NULL, NULL, 'NADH dehydrogenase (Ubiquinone) 1 alpha subcomplex 9', NULL, NULL, NULL, NULL, NULL, 4),
(180933, NULL, 'G3DSA:1.25.70.10:FF:000011', NULL, NULL, 'Mitochondrial transcription termination factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(180934, NULL, 'G3DSA:3.30.497.10:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180935, NULL, 'G3DSA:3.30.1460.50:FF:000001', NULL, NULL, 'Autophagy-related protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(180936, NULL, 'G3DSA:3.40.50.1970:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180937, NULL, 'G3DSA:1.20.58.120:FF:000007', NULL, NULL, 'Starvin, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(180938, NULL, 'G3DSA:3.30.70.260:FF:000117', NULL, NULL, 'Ribose 5-phosphate isomerase A, variant', NULL, NULL, NULL, NULL, NULL, 4),
(180939, NULL, 'G3DSA:1.10.287.70:FF:000561', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180940, NULL, 'G3DSA:4.10.240.10:FF:000227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180941, NULL, 'G3DSA:2.20.70.10:FF:000227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180942, NULL, 'G3DSA:3.90.190.10:FF:000383', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(180943, NULL, 'G3DSA:1.25.40.10:FF:004545', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180944, NULL, 'G3DSA:1.25.40.10:FF:003399', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(180945, NULL, 'G3DSA:3.40.630.10:FF:000440', NULL, NULL, 'Gll0760 protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(180946, NULL, 'G3DSA:2.130.10.10:FF:005266', NULL, NULL, 'Elongator complex protein 2 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(180947, NULL, 'G3DSA:1.10.10.10:FF:000266', NULL, NULL, 'Forkhead box protein L1', NULL, NULL, NULL, NULL, NULL, 4),
(180948, NULL, 'G3DSA:3.90.226.10:FF:000023', NULL, NULL, 'Carboxyl-terminal processing protease', NULL, NULL, NULL, NULL, NULL, 4),
(180949, NULL, 'G3DSA:3.40.30.10:FF:000677', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180950, NULL, 'G3DSA:3.30.70.1020:FF:000003', NULL, NULL, 'Alpha,alpha-trehalose-phosphate synthase subunit Tps2', NULL, NULL, NULL, NULL, NULL, 4),
(180951, NULL, 'G3DSA:1.25.40.20:FF:000951', NULL, NULL, 'GM22773', NULL, NULL, NULL, NULL, NULL, 4),
(180952, NULL, 'G3DSA:3.10.10.10:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180953, NULL, 'G3DSA:3.80.10.10:FF:004491', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180954, NULL, 'G3DSA:2.60.40.1180:FF:000140', NULL, NULL, 'Neopullulanase SusA', NULL, NULL, NULL, NULL, NULL, 4),
(180955, NULL, 'G3DSA:3.40.50.1000:FF:000057', NULL, NULL, 'Copper-exporting P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(180956, NULL, 'G3DSA:1.10.3370.10:FF:000034', NULL, NULL, 'Sec61 alpha subunit putative', NULL, NULL, NULL, NULL, NULL, 4),
(180957, NULL, 'G3DSA:2.130.10.10:FF:003720', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180958, NULL, 'G3DSA:3.30.420.10:FF:000572', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180959, NULL, 'G3DSA:1.20.120.1080:FF:000116', NULL, NULL, 'ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(180960, NULL, 'G3DSA:3.40.50.720:FF:002469', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(P)+]', NULL, NULL, NULL, NULL, NULL, 4),
(180961, NULL, 'G3DSA:3.80.10.10:FF:003872', NULL, NULL, 'Si:ch211-196h24.2', NULL, NULL, NULL, NULL, NULL, 4),
(180962, NULL, 'G3DSA:1.20.58.2220:FF:000006', NULL, NULL, 'Cytokinesis protein sepA', NULL, NULL, NULL, NULL, NULL, 4),
(180963, NULL, 'G3DSA:1.20.1250.20:FF:002358', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180964, NULL, 'G3DSA:3.90.1740.10:FF:000003', NULL, NULL, '2'',3''-cyclic nucleotide 3'' phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(180965, NULL, 'G3DSA:1.25.40.10:FF:000274', NULL, NULL, 'Tetratricopeptide repeat domain 25', NULL, NULL, NULL, NULL, NULL, 4),
(180966, NULL, 'G3DSA:1.20.144.10:FF:000081', NULL, NULL, 'Phospholipid phosphatase 2b', NULL, NULL, NULL, NULL, NULL, 4),
(180967, NULL, 'G3DSA:1.25.50.20:FF:000092', NULL, NULL, 'AER426Cp', NULL, NULL, NULL, NULL, NULL, 4),
(180968, NULL, 'G3DSA:2.60.40.150:FF:000227', NULL, NULL, 'Metacaspase 1', NULL, NULL, NULL, NULL, NULL, 4),
(180969, NULL, 'G3DSA:2.30.40.10:FF:000085', NULL, NULL, 'Hydroxydechloroatrazine ethylaminohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(180970, NULL, 'G3DSA:2.60.40.150:FF:000412', NULL, NULL, 'Protein CBG04253', NULL, NULL, NULL, NULL, NULL, 4),
(180971, NULL, 'G3DSA:1.25.10.10:FF:002138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180972, NULL, 'G3DSA:2.130.10.10:FF:003265', NULL, NULL, 'Transducin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180973, NULL, 'G3DSA:3.30.110.30:FF:000004', NULL, NULL, 'Proline--tRNA ligase, chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(180974, NULL, 'G3DSA:1.25.10.10:FF:003228', NULL, NULL, 'HECT, UBA and WWE domain containing 1 isoform 1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(180975, NULL, 'G3DSA:1.10.238.210:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180976, NULL, 'G3DSA:2.30.30.40:FF:000492', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180977, NULL, 'G3DSA:3.30.9.10:FF:000083', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(180978, NULL, 'G3DSA:1.10.10.2740:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180979, NULL, 'G3DSA:3.40.50.300:FF:008425', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(180980, NULL, 'G3DSA:2.130.10.10:FF:002175', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(180981, NULL, 'G3DSA:4.10.60.10:FF:000155', NULL, NULL, 'tRNA-splicing endonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(180982, NULL, 'G3DSA:3.40.50.1000:FF:000585', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180983, NULL, 'G3DSA:3.50.50.60:FF:001294', NULL, NULL, 'Uncharacterized Rab geranylgeranyltransferase C15C4.03', NULL, NULL, NULL, NULL, NULL, 4),
(180984, NULL, 'G3DSA:2.60.220.50:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180985, NULL, 'G3DSA:1.10.340.30:FF:000005', NULL, NULL, 'Endonuclease III-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(180986, NULL, 'G3DSA:3.40.50.12650:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180987, NULL, 'G3DSA:1.20.1070.10:FF:001880', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180988, NULL, 'G3DSA:3.40.50.300:FF:002574', NULL, NULL, 'Protein CBG27386', NULL, NULL, NULL, NULL, NULL, 4),
(180989, NULL, 'G3DSA:1.20.1270.70:FF:000002', NULL, NULL, 'Putative secreted protein', NULL, NULL, NULL, NULL, NULL, 4),
(180990, NULL, 'G3DSA:1.25.40.10:FF:003056', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At1g10330', NULL, NULL, NULL, NULL, NULL, 4),
(180991, NULL, 'G3DSA:4.10.860.130:FF:000002', NULL, NULL, '30S ribosomal protein S15', NULL, NULL, NULL, NULL, NULL, 4),
(180992, NULL, 'G3DSA:1.20.1070.10:FF:000790', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180993, NULL, 'G3DSA:2.30.29.30:FF:000873', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(180994, NULL, 'G3DSA:3.30.70.330:FF:001223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(180995, NULL, 'G3DSA:2.10.25.10:FF:001298', NULL, NULL, 'LP19846p', NULL, NULL, NULL, NULL, NULL, 4),
(180996, NULL, 'G3DSA:1.25.40.20:FF:000063', NULL, NULL, 'SH3 and multiple ankyrin repeat domains protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(180997, NULL, 'G3DSA:2.30.30.40:FF:000020', NULL, NULL, 'SH3 and PX domain-containing protein 2A', NULL, NULL, NULL, NULL, NULL, 4),
(180998, NULL, 'G3DSA:1.50.10.10:FF:000146', NULL, NULL, 'YALI0E05203p', NULL, NULL, NULL, NULL, NULL, 4),
(180999, NULL, 'G3DSA:1.10.287.130:FF:000208', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(181000, NULL, 'G3DSA:1.10.3260.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181001, NULL, 'G3DSA:3.30.1310.10:FF:000007', NULL, NULL, 'Nucleoid-associated protein NMC1380', NULL, NULL, NULL, NULL, NULL, 4),
(181002, NULL, 'G3DSA:3.30.70.1070:FF:000007', NULL, NULL, 'Endolytic peptidoglycan transglycosylase RlpA', NULL, NULL, NULL, NULL, NULL, 4),
(181003, NULL, 'G3DSA:1.10.510.10:FF:004245', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181004, NULL, 'G3DSA:3.40.50.300:FF:005699', NULL, NULL, 'Putative apoptotic protease-activating factor', NULL, NULL, NULL, NULL, NULL, 4),
(181005, NULL, 'G3DSA:3.30.1120.10:FF:000054', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(181006, NULL, 'G3DSA:1.10.287.110:FF:000202', NULL, NULL, 'GM24961', NULL, NULL, NULL, NULL, NULL, 4),
(181007, NULL, 'G3DSA:3.30.40.10:FF:001572', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181008, NULL, 'G3DSA:1.20.120.1760:FF:000022', NULL, NULL, 'CDP-diacylglycerol--serine O-phosphatidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(181009, NULL, 'G3DSA:3.10.580.10:FF:000048', NULL, NULL, 'Chloride channel 2c', NULL, NULL, NULL, NULL, NULL, 4),
(181010, NULL, 'G3DSA:2.60.120.380:FF:000029', NULL, NULL, 'Microbial collagenase', NULL, NULL, NULL, NULL, NULL, 4),
(181011, NULL, 'G3DSA:3.60.40.10:FF:000356', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181012, NULL, 'G3DSA:3.40.50.1110:FF:000163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(181013, NULL, 'G3DSA:3.30.200.20:FF:002048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181014, NULL, 'G3DSA:3.30.40.10:FF:000279', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM37 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(181015, NULL, 'G3DSA:1.10.630.10:FF:000465', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181016, NULL, 'G3DSA:3.20.20.70:FF:000088', NULL, NULL, 'Transaldolase', NULL, NULL, NULL, NULL, NULL, 4),
(181017, NULL, 'G3DSA:3.30.60.20:FF:000047', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(181018, NULL, 'G3DSA:1.10.472.80:FF:000152', NULL, NULL, 'Rab-GTPase-TBC domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181019, NULL, 'G3DSA:1.20.1070.10:FF:001205', NULL, NULL, 'Novel 7 transmembrane receptor (Rhodopsin family)', NULL, NULL, NULL, NULL, NULL, 4),
(181020, NULL, 'G3DSA:1.10.1900.10:FF:000013', NULL, NULL, 'Polyadenylate-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181021, NULL, 'G3DSA:2.60.40.150:FF:000070', NULL, NULL, 'rab11 family-interacting protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(181022, NULL, 'G3DSA:1.20.140.40:FF:000069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181023, NULL, 'G3DSA:1.10.10.10:FF:001811', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(181024, NULL, 'G3DSA:1.25.40.20:FF:000372', NULL, NULL, 'Putative hect e3 ubiquitin ligase', NULL, NULL, NULL, NULL, NULL, 4),
(181025, NULL, 'G3DSA:3.40.190.10:FF:000321', NULL, NULL, 'ABC transporter, substrate-binding protein, family 5', NULL, NULL, NULL, NULL, NULL, 4),
(181026, NULL, 'G3DSA:3.40.120.10:FF:000030', NULL, NULL, 'Phosphoglucomutase 2', NULL, NULL, NULL, NULL, NULL, 4),
(181027, NULL, 'G3DSA:1.10.10.10:FF:000518', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(181028, NULL, 'G3DSA:3.40.640.10:FF:000266', NULL, NULL, 'Probable glycine dehydrogenase (decarboxylating) subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(181029, NULL, 'G3DSA:1.10.3860.10:FF:000009', NULL, NULL, 'Sodium:proton antiporter', NULL, NULL, NULL, NULL, NULL, 4),
(181030, NULL, 'G3DSA:3.90.132.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181031, NULL, 'G3DSA:3.80.30.20:FF:000021', NULL, NULL, 'MiaB-like tRNA modifying enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(181032, NULL, 'G3DSA:3.30.470.160:FF:000003', NULL, NULL, 'Kinase', NULL, NULL, NULL, NULL, NULL, 4),
(181033, NULL, 'G3DSA:3.30.870.10:FF:000049', NULL, NULL, 'Cardiolipin synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(181034, NULL, 'G3DSA:3.40.50.1000:FF:000618', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181035, NULL, 'G3DSA:3.30.930.10:FF:000094', NULL, NULL, 'Lysine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(181036, NULL, 'G3DSA:3.40.50.1010:FF:000279', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181037, NULL, 'G3DSA:3.60.10.10:FF:000309', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(181038, NULL, 'G3DSA:3.20.20.140:FF:000096', NULL, NULL, 'Phosphonate metabolism protein PhnM', NULL, NULL, NULL, NULL, NULL, 4),
(181039, NULL, 'G3DSA:1.20.85.10:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181040, NULL, 'G3DSA:3.40.50.620:FF:000320', NULL, NULL, 'Isoleucine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(181041, NULL, 'G3DSA:2.60.120.330:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181042, NULL, 'G3DSA:2.40.70.10:FF:000081', NULL, NULL, 'Plasmepsin X', NULL, NULL, NULL, NULL, NULL, 4),
(181043, NULL, 'G3DSA:3.30.710.10:FF:000420', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181044, NULL, 'G3DSA:3.10.280.10:FF:000008', NULL, NULL, 'Mam33p', NULL, NULL, NULL, NULL, NULL, 4),
(181045, NULL, 'G3DSA:3.30.200.20:FF:000811', NULL, NULL, 'L-type lectin-domain containing receptor kinase V.9', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(181046, NULL, 'G3DSA:1.20.58.60:FF:000053', NULL, NULL, 'Short stop, isoform K', NULL, NULL, NULL, NULL, NULL, 4),
(181047, NULL, 'G3DSA:3.10.310.10:FF:000006', NULL, NULL, 'Diaminopimelate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(181048, NULL, 'G3DSA:2.60.40.10:FF:001595', NULL, NULL, 'V-set and transmembrane domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(181049, NULL, 'G3DSA:1.10.10.10:FF:001446', NULL, NULL, 'ADL176Wp', NULL, NULL, NULL, NULL, NULL, 4),
(181050, NULL, 'G3DSA:3.30.70.330:FF:001751', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181051, NULL, 'G3DSA:1.10.287.80:FF:000002', NULL, NULL, 'Lysine-specific histone demethylase 1A', NULL, NULL, NULL, NULL, NULL, 4),
(181052, NULL, 'G3DSA:3.30.70.1050:FF:000001', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(181053, NULL, 'G3DSA:3.40.50.1820:FF:001005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181054, NULL, 'G3DSA:3.90.550.50:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181055, NULL, 'G3DSA:3.30.505.10:FF:000269', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181056, NULL, 'G3DSA:3.40.1110.10:FF:000169', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(181057, NULL, 'G3DSA:1.20.58.530:FF:000012', NULL, NULL, 'unconventional myosin-X', NULL, NULL, NULL, NULL, NULL, 4),
(181058, NULL, 'G3DSA:1.10.274.30:FF:000002', NULL, NULL, 'male-specific lethal 3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(181059, NULL, 'G3DSA:3.80.10.10:FF:004524', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(181060, NULL, 'G3DSA:3.30.70.1230:FF:000078', NULL, NULL, 'Adenylyl CYclase', NULL, NULL, NULL, NULL, NULL, 4),
(181061, NULL, 'G3DSA:3.30.900.10:FF:000047', NULL, NULL, 'MAD (Yeast Mitosis arrest DeFicient) related', NULL, NULL, NULL, NULL, NULL, 4),
(181062, NULL, 'G3DSA:1.10.30.10:FF:000065', NULL, NULL, 'Nhp10p', NULL, NULL, NULL, NULL, NULL, 4),
(181063, NULL, 'G3DSA:3.30.710.10:FF:000111', NULL, NULL, 'rho-related BTB domain-containing protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(181064, NULL, 'G3DSA:2.60.120.650:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181065, NULL, 'G3DSA:1.10.260.170:FF:000010', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', NULL, NULL, NULL, NULL, NULL, 4),
(181066, NULL, 'G3DSA:3.40.1090.10:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181067, NULL, 'G3DSA:1.50.40.10:FF:000226', NULL, NULL, 'Mitochondrial carrier protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(181068, NULL, 'G3DSA:3.30.1380.20:FF:000054', NULL, NULL, 'Trafficking protein particle complex 6b-like', NULL, NULL, NULL, NULL, NULL, 4),
(181069, NULL, 'G3DSA:3.40.30.10:FF:000929', NULL, NULL, 'Iodothyronine deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(181070, NULL, 'G3DSA:3.40.50.1820:FF:001713', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181071, NULL, 'G3DSA:3.80.10.10:FF:000781', NULL, NULL, 'PH domain and leucine rich repeat protein phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(181072, NULL, 'G3DSA:1.25.40.10:FF:004236', NULL, NULL, 'At4g28200', NULL, NULL, NULL, NULL, NULL, 4),
(181073, NULL, 'G3DSA:3.30.70.330:FF:001442', NULL, NULL, 'LD15419p', NULL, NULL, NULL, NULL, NULL, 4),
(181074, NULL, 'G3DSA:3.40.50.300:FF:007121', NULL, NULL, 'Septin homolog spn6', NULL, NULL, NULL, NULL, NULL, 4),
(181075, NULL, 'G3DSA:3.30.160.60:FF:005299', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181076, NULL, 'G3DSA:4.10.800.10:FF:000001', NULL, NULL, 'Testican-3 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(181077, NULL, 'G3DSA:1.20.20.10:FF:000007', NULL, NULL, 'ATP synthase subunit c', NULL, NULL, NULL, NULL, NULL, 4),
(181078, NULL, 'G3DSA:1.20.58.80:FF:000059', NULL, NULL, 'STAM binding protein like 1', NULL, NULL, NULL, NULL, NULL, 4),
(181079, NULL, 'G3DSA:3.30.559.30:FF:000074', NULL, NULL, 'Enniatin synthetase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(181080, NULL, 'G3DSA:3.30.200.20:FF:000250', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(181081, NULL, 'G3DSA:3.90.1430.10:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181082, NULL, 'G3DSA:2.60.40.10:FF:005086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181083, NULL, 'G3DSA:3.40.630.30:FF:000451', NULL, NULL, 'Acetyltransferase PA2578', NULL, NULL, NULL, NULL, NULL, 4),
(181084, NULL, 'G3DSA:3.40.50.2300:FF:000121', NULL, NULL, 'Sensor histidine kinase RcsC', NULL, NULL, NULL, NULL, NULL, 4),
(181085, NULL, 'G3DSA:2.60.34.10:FF:000030', NULL, NULL, 'Heat shock protein family A (Hsp70) member 4 like', NULL, NULL, NULL, NULL, NULL, 4),
(181086, NULL, 'G3DSA:2.70.160.11:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181087, NULL, 'G3DSA:1.25.40.510:FF:000003', NULL, NULL, 'Nucleoporin GLE1', NULL, NULL, NULL, NULL, NULL, 4),
(181088, NULL, 'G3DSA:3.90.70.10:FF:000705', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181089, NULL, 'G3DSA:3.30.70.330:FF:002712', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181090, NULL, 'G3DSA:3.40.50.2060:FF:000015', NULL, NULL, 'Carnation, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(181091, NULL, 'G3DSA:2.40.110.10:FF:000056', NULL, NULL, 'Putative acyl CoA oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(181092, NULL, 'G3DSA:3.40.50.300:FF:002826', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(181093, NULL, 'G3DSA:3.10.100.10:FF:000182', NULL, NULL, 'GD10399', NULL, NULL, NULL, NULL, NULL, 4),
(181094, NULL, 'G3DSA:3.40.50.720:FF:001199', NULL, NULL, 'Short-chain alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(181095, NULL, 'G3DSA:2.60.120.10:FF:000147', NULL, NULL, '2-oxoglutarate (2OG) and Fe(II)-dependent oxygenase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(181096, NULL, 'G3DSA:1.10.287.470:FF:000057', NULL, NULL, 'Disks large homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(181097, NULL, 'G3DSA:3.40.50.300:FF:002118', NULL, NULL, 'Obg family GTPase CgtA', NULL, NULL, NULL, NULL, NULL, 4),
(181098, NULL, 'G3DSA:3.30.499.10:FF:000023', NULL, NULL, '3-isopropylmalate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(181099, NULL, 'G3DSA:3.10.20.90:FF:000420', NULL, NULL, 'Phosphatidylinositol 3-kinase 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181100, NULL, 'G3DSA:3.60.10.10:FF:000276', NULL, NULL, 'Uncharacterized protein DDB_G0272682', NULL, NULL, NULL, NULL, NULL, 4),
(181101, NULL, 'G3DSA:2.40.50.40:FF:000077', NULL, NULL, 'Chemokine (C-C motif) ligand 35, duplicate 1', NULL, NULL, NULL, NULL, NULL, 4),
(181102, NULL, 'G3DSA:3.60.21.10:FF:000228', NULL, NULL, 'Sphingomyelin phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(181103, NULL, 'G3DSA:1.20.58.60:FF:000429', NULL, NULL, 'Beta-H spectrin', NULL, NULL, NULL, NULL, NULL, 4),
(181104, NULL, 'G3DSA:2.60.120.200:FF:000330', NULL, NULL, 'Protein tyrosine phosphatase, receptor type U', NULL, NULL, NULL, NULL, NULL, 4),
(181105, NULL, 'G3DSA:3.40.630.10:FF:000108', NULL, NULL, 'carboxypeptidase B', NULL, NULL, NULL, NULL, NULL, 4),
(181106, NULL, 'G3DSA:2.60.40.10:FF:002213', NULL, NULL, 'Myotactin form B', NULL, NULL, NULL, NULL, NULL, 4),
(181107, NULL, 'G3DSA:3.40.1360.10:FF:000013', NULL, NULL, 'Plastid replication-repair enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(181108, NULL, 'G3DSA:2.20.110.10:FF:000066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181109, NULL, 'G3DSA:1.50.40.10:FF:000535', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181110, NULL, 'G3DSA:3.40.50.200:FF:000060', NULL, NULL, 'Tripeptidyl peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(181111, NULL, 'G3DSA:3.40.30.10:FF:000368', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(181112, NULL, 'G3DSA:3.30.70.330:FF:002403', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181113, NULL, 'G3DSA:3.30.70.330:FF:002151', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(181114, NULL, 'G3DSA:3.40.50.1010:FF:000155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181115, NULL, 'G3DSA:3.20.20.70:FF:000577', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181116, NULL, 'G3DSA:2.130.10.10:FF:002736', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181117, NULL, 'G3DSA:1.25.10.10:FF:000901', NULL, NULL, 'Sister chromatid cohesion protein PDS5 homolog B-A', NULL, NULL, NULL, NULL, NULL, 4),
(181118, NULL, 'G3DSA:2.60.40.10:FF:005647', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181119, NULL, 'G3DSA:1.10.10.440:FF:000025', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(181120, NULL, 'G3DSA:1.10.238.10:FF:000705', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181121, NULL, 'G3DSA:1.20.5.340:FF:000068', NULL, NULL, 'myosin-9 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(181122, NULL, 'G3DSA:2.60.120.10:FF:000456', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181123, NULL, 'G3DSA:1.20.1250.10:FF:000101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181124, NULL, 'G3DSA:2.60.40.10:FF:002663', NULL, NULL, 'Immunoglobulin superfamily, member 8', NULL, NULL, NULL, NULL, NULL, 4),
(181125, NULL, 'G3DSA:3.30.559.30:FF:000079', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(181126, NULL, 'G3DSA:3.40.50.170:FF:000022', NULL, NULL, 'Related to glycinamide ribonucleotide transformylase', NULL, NULL, NULL, NULL, NULL, 4),
(181127, NULL, 'G3DSA:2.60.120.370:FF:000010', NULL, NULL, 'Flagellar motor-switch protein', NULL, NULL, NULL, NULL, NULL, 4),
(181128, NULL, 'G3DSA:3.30.9.10:FF:000066', NULL, NULL, 'L-2-hydroxyglutarate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(181129, NULL, 'G3DSA:1.20.140.150:FF:000071', NULL, NULL, 'Protein CBG10848', NULL, NULL, NULL, NULL, NULL, 4),
(181130, NULL, 'G3DSA:3.40.640.10:FF:000283', NULL, NULL, 'O-acetyl-L-homoserine sulfhydrylase', NULL, NULL, NULL, NULL, NULL, 4),
(181131, NULL, 'G3DSA:3.30.499.10:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181132, NULL, 'G3DSA:3.40.50.10190:FF:000154', NULL, NULL, 'FI02888p', NULL, NULL, NULL, NULL, NULL, 4),
(181133, NULL, 'G3DSA:3.40.50.300:FF:000893', NULL, NULL, 'Interferon-induced with helicase C domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(181134, NULL, 'G3DSA:3.30.160.60:FF:002096', NULL, NULL, 'Zinc finger protein 473', NULL, NULL, NULL, NULL, NULL, 4),
(181135, NULL, 'G3DSA:1.25.40.10:FF:003039', NULL, NULL, 'Os04g0221300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(181136, NULL, 'G3DSA:1.20.1280.50:FF:000042', NULL, NULL, 'F-box protein 31', NULL, NULL, NULL, NULL, NULL, 4),
(181137, NULL, 'G3DSA:3.60.15.10:FF:000040', NULL, NULL, 'Beta-lactamase', NULL, NULL, NULL, NULL, NULL, 4),
(181138, NULL, 'G3DSA:3.30.565.10:FF:000014', NULL, NULL, 'Mismatch repair endonuclease pms1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181139, NULL, 'G3DSA:2.40.50.140:FF:000236', NULL, NULL, '30S ribosomal protein S17', NULL, NULL, NULL, NULL, NULL, 4),
(181140, NULL, 'G3DSA:3.40.50.1000:FF:000714', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181141, NULL, 'G3DSA:2.40.20.10:FF:000010', NULL, NULL, 'Neurotrypsin', NULL, NULL, NULL, NULL, NULL, 4),
(181142, NULL, 'G3DSA:3.30.160.60:FF:005855', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181143, NULL, 'G3DSA:3.80.10.10:FF:003321', NULL, NULL, 'Si:ch73-233m11.2', NULL, NULL, NULL, NULL, NULL, 4),
(181144, NULL, 'G3DSA:1.10.1200.10:FF:000016', NULL, NULL, 'Non-ribosomal peptide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(181145, NULL, 'G3DSA:3.80.10.10:FF:002815', NULL, NULL, 'Leucine-rich repeat-containing protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(181146, NULL, 'G3DSA:3.30.750.24:FF:000071', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(181147, NULL, 'G3DSA:3.50.50.60:FF:001417', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(181148, NULL, 'G3DSA:1.25.40.20:FF:000400', NULL, NULL, 'Serine/threonine-protein phosphatase 6 regulatory ankyrin repeat subunit A', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(181149, NULL, 'G3DSA:2.120.10.80:FF:000228', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(181150, NULL, 'G3DSA:2.70.150.10:FF:000029', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(181151, NULL, 'G3DSA:3.30.56.10:FF:000040', NULL, NULL, 'Phenylalanyl-tRNA synthetase (Beta subunit), putative', NULL, NULL, NULL, NULL, NULL, 4),
(181152, NULL, 'G3DSA:2.60.40.10:FF:001140', NULL, NULL, 'Down syndrome cell adhesion molecule-like protein Dscam2', NULL, NULL, NULL, NULL, NULL, 4),
(181153, NULL, 'G3DSA:1.25.40.10:FF:000285', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(181154, NULL, 'G3DSA:2.60.40.1180:FF:000016', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(181155, NULL, 'G3DSA:2.70.130.10:FF:000016', NULL, NULL, 'Insulin-like growth factor 2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(181156, NULL, 'G3DSA:1.10.510.10:FF:003716', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181157, NULL, 'G3DSA:2.70.170.10:FF:000030', NULL, NULL, 'AcetylCholine Receptor', NULL, NULL, NULL, NULL, NULL, 4),
(181158, NULL, 'G3DSA:4.10.1240.10:FF:000027', NULL, NULL, 'Pituitary adenylate cyclase-activating polypeptide type I receptor isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(181159, NULL, 'G3DSA:1.10.8.270:FF:000151', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(181160, NULL, 'G3DSA:3.80.10.10:FF:001085', NULL, NULL, 'Leucine-rich repeat protein soc-2', NULL, NULL, NULL, NULL, NULL, 4),
(181161, NULL, 'G3DSA:1.20.1740.10:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181162, NULL, 'G3DSA:3.30.70.330:FF:003128', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181163, NULL, 'G3DSA:2.60.40.10:FF:005417', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181164, NULL, 'G3DSA:3.40.50.300:FF:007930', NULL, NULL, 'Type III restriction enzyme, res subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(181165, NULL, 'G3DSA:3.40.50.300:FF:000904', NULL, NULL, 'ABC transporter A family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(181166, NULL, 'G3DSA:4.10.280.10:FF:000117', NULL, NULL, 'Os01g0108400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(181167, NULL, 'G3DSA:3.90.1290.10:FF:000058', NULL, NULL, 'Microtubule-actin crosslinking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(181168, NULL, 'G3DSA:3.30.1550.10:FF:000002', NULL, NULL, '60S ribosomal protein L12', NULL, NULL, NULL, NULL, NULL, 4),
(181169, NULL, 'G3DSA:2.70.98.30:FF:000031', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(181170, NULL, 'G3DSA:2.70.150.10:FF:000130', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(181171, NULL, 'G3DSA:2.40.40.10:FF:000005', NULL, NULL, 'Barwin-related endoglucanase', NULL, NULL, NULL, NULL, NULL, 4),
(181172, NULL, 'G3DSA:3.40.50.10490:FF:000137', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181173, NULL, 'G3DSA:3.20.20.70:FF:000560', NULL, NULL, 'Ferredoxin-dependent glutamate synthase GlsF', NULL, NULL, NULL, NULL, NULL, 4),
(181174, NULL, 'G3DSA:2.10.110.10:FF:000315', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181175, NULL, 'G3DSA:3.40.50.300:FF:001410', NULL, NULL, 'Primosomal protein N''', NULL, NULL, NULL, NULL, NULL, 4),
(181176, NULL, 'G3DSA:3.30.1150.10:FF:000005', NULL, NULL, 'Protein TonB', NULL, NULL, NULL, NULL, NULL, 4),
(181177, NULL, 'G3DSA:1.10.287.70:FF:000100', NULL, NULL, 'Cyclic nucleotide-gated cation channel', NULL, NULL, NULL, NULL, NULL, 4),
(181178, NULL, 'G3DSA:2.130.10.10:FF:002315', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', NULL, NULL, NULL, NULL, NULL, 4),
(181179, NULL, 'G3DSA:1.10.472.10:FF:000064', NULL, NULL, 'Cyclin O', NULL, NULL, NULL, NULL, NULL, 4),
(181180, NULL, 'G3DSA:1.20.5.1700:FF:000002', NULL, NULL, 'Huntingtin interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(181181, NULL, 'G3DSA:3.30.70.1730:FF:000008', NULL, NULL, '50S ribosomal protein L10', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(181182, NULL, 'G3DSA:3.30.450.20:FF:000285', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(181183, NULL, 'G3DSA:3.30.70.1180:FF:000012', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(181184, NULL, 'G3DSA:3.30.40.10:FF:001347', NULL, NULL, 'E3 ubiquitin-protein ligase LubX', NULL, NULL, NULL, NULL, NULL, 4),
(181185, NULL, 'G3DSA:3.40.50.150:FF:000707', NULL, NULL, 'Zgc:113054', NULL, NULL, NULL, NULL, NULL, 4),
(181186, NULL, 'G3DSA:3.30.70.1710:FF:000002', NULL, NULL, 'Ethanolamine utilization protein EutS', NULL, NULL, NULL, NULL, NULL, 4),
(181187, NULL, 'G3DSA:3.40.50.300:FF:002450', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(181188, NULL, 'G3DSA:3.40.50.1100:FF:000177', NULL, NULL, 'Pyridoxal-phosphate dependent enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(181189, NULL, 'G3DSA:3.40.630.30:FF:000215', NULL, NULL, 'N-alpha-acetyltransferase 50 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(181190, NULL, 'G3DSA:3.90.70.10:FF:000817', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181191, NULL, 'G3DSA:3.40.50.2000:FF:000334', NULL, NULL, 'Glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(181192, NULL, 'G3DSA:1.10.238.10:FF:000941', NULL, NULL, 'Calcium-binding protein B', NULL, NULL, NULL, NULL, NULL, 4),
(181193, NULL, 'G3DSA:3.30.200.20:FF:001082', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(181194, NULL, 'G3DSA:1.10.8.10:FF:000186', NULL, NULL, 'Tyrosine kinase, non-receptor, 2b', NULL, NULL, NULL, NULL, NULL, 4),
(181195, NULL, 'G3DSA:3.30.930.10:FF:000419', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181196, NULL, 'G3DSA:1.20.1270.60:FF:000117', NULL, NULL, 'SynDaPiN (Synaptic dynamin binding protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(181197, NULL, 'G3DSA:1.10.246.10:FF:000010', NULL, NULL, 'Vitamin D-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(181198, NULL, 'G3DSA:2.60.120.620:FF:000118', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(181199, NULL, 'G3DSA:2.40.160.60:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181200, NULL, 'G3DSA:3.10.100.10:FF:000070', NULL, NULL, 'Low affinity immunoglobulin epsilon Fc receptor', NULL, NULL, NULL, NULL, NULL, 4),
(181201, NULL, 'G3DSA:3.40.50.2300:FF:001615', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181202, NULL, 'G3DSA:1.50.10.20:FF:000059', NULL, NULL, 'Complement C3', NULL, NULL, NULL, NULL, NULL, 4),
(181203, NULL, 'G3DSA:3.40.720.10:FF:000328', NULL, NULL, 'Uncharacterized protein HI_1316', NULL, NULL, NULL, NULL, NULL, 4),
(181204, NULL, 'G3DSA:3.40.50.2300:FF:000789', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181205, NULL, 'G3DSA:3.40.50.1780:FF:000015', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor nar1', NULL, NULL, NULL, NULL, NULL, 4),
(181206, NULL, 'G3DSA:3.20.20.140:FF:000315', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(181207, NULL, 'G3DSA:2.60.210.10:FF:000025', NULL, NULL, 'BTB and MATH domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(181208, NULL, 'G3DSA:2.60.40.60:FF:000284', NULL, NULL, 'Cadherin 96Cb, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(181209, NULL, 'G3DSA:1.10.150.50:FF:000069', NULL, NULL, 'mitochondrial import inner membrane translocase subunit TIM22-like', NULL, NULL, NULL, NULL, NULL, 4),
(181210, NULL, 'G3DSA:1.20.1070.10:FF:002032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181211, NULL, 'G3DSA:3.10.20.90:FF:000173', NULL, NULL, 'Tubulin-specific chaperone E', NULL, NULL, NULL, NULL, NULL, 4),
(181212, NULL, 'G3DSA:1.25.40.180:FF:000168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181213, NULL, 'G3DSA:1.10.510.10:FF:000962', NULL, NULL, 'Activated met oncogene, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181214, NULL, 'G3DSA:2.130.10.10:FF:000387', NULL, NULL, 'intraflagellar transport protein 172 homolog', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(181215, NULL, 'G3DSA:3.40.470.10:FF:000011', NULL, NULL, 'Uracil-DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(181216, NULL, 'G3DSA:1.20.58.390:FF:000251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181217, NULL, 'G3DSA:1.20.1560.10:FF:000771', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181218, NULL, 'G3DSA:1.10.275.20:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181219, NULL, 'G3DSA:3.40.30.10:FF:000132', NULL, NULL, 'SH3 domain-binding glutamic acid-rich-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(181220, NULL, 'G3DSA:3.90.1150.10:FF:000211', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(181221, NULL, 'G3DSA:3.40.50.300:FF:003647', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(181222, NULL, 'G3DSA:2.10.25.10:FF:001085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181223, NULL, 'G3DSA:2.60.11.10:FF:000005', NULL, NULL, 'Cytochrome c oxidase subunit 5b', NULL, NULL, NULL, NULL, NULL, 4),
(181224, NULL, 'G3DSA:3.20.20.10:FF:000014', NULL, NULL, 'Pyridoxal phosphate homeostasis protein', NULL, NULL, NULL, NULL, NULL, 4),
(181225, NULL, 'G3DSA:1.10.287.110:FF:000433', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(181226, NULL, 'G3DSA:1.10.238.200:FF:000029', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(181227, NULL, 'G3DSA:3.30.1330.30:FF:000109', NULL, NULL, 'Os01g0924800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(181228, NULL, 'G3DSA:1.10.510.10:FF:001367', NULL, NULL, 'Serine kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(181229, NULL, 'G3DSA:3.90.70.10:FF:000722', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181230, NULL, 'G3DSA:3.30.160.60:FF:004006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181231, NULL, 'G3DSA:3.40.1700.10:FF:000001', NULL, NULL, 'DNA integrity scanning protein DisA', NULL, NULL, NULL, NULL, NULL, 4),
(181232, NULL, 'G3DSA:2.130.10.10:FF:001798', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(181233, NULL, 'G3DSA:3.30.60.20:FF:000148', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(181234, NULL, 'G3DSA:3.30.420.40:FF:000564', NULL, NULL, 'Glycerol kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(181235, NULL, 'G3DSA:1.10.630.10:FF:000797', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181236, NULL, 'G3DSA:3.80.10.10:FF:002023', NULL, NULL, 'Leucine-rich repeat-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(181237, NULL, 'G3DSA:3.30.1390.30:FF:000006', NULL, NULL, 'Peptidoglycan D,D-transpeptidase MrdA', NULL, NULL, NULL, NULL, NULL, 4),
(181238, NULL, 'G3DSA:3.90.1410.10:FF:000147', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(181239, NULL, 'G3DSA:3.30.50.10:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181240, NULL, 'G3DSA:3.30.420.10:FF:000128', NULL, NULL, 'Poly(A)-specific ribonuclease PARN', NULL, NULL, NULL, NULL, NULL, 4),
(181241, NULL, 'G3DSA:2.30.42.10:FF:000145', NULL, NULL, 'serine protease HTRA2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(181242, NULL, 'G3DSA:3.40.718.10:FF:000059', NULL, NULL, 'Isocitrate dehydrogenase [NAD] subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(181243, NULL, 'G3DSA:2.30.30.30:FF:000034', NULL, NULL, '50S ribosomal protein L2', NULL, NULL, NULL, NULL, NULL, 4),
(181244, NULL, 'G3DSA:2.10.70.10:FF:000104', NULL, NULL, 'Complement component 4 binding protein beta', NULL, NULL, NULL, NULL, NULL, 4),
(181245, NULL, 'G3DSA:3.30.2020.30:FF:000030', NULL, NULL, 'AGAP005447-PA', NULL, NULL, NULL, NULL, NULL, 4),
(181246, NULL, 'G3DSA:3.30.420.40:FF:000204', NULL, NULL, 'Actin, epsilon 1', NULL, NULL, NULL, NULL, NULL, 4),
(181247, NULL, 'G3DSA:3.40.50.10860:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181248, NULL, 'G3DSA:3.40.50.1400:FF:000047', NULL, NULL, 'Ferrochelatase-like protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(181249, NULL, 'G3DSA:1.25.40.10:FF:004337', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(181250, NULL, 'G3DSA:3.30.160.60:FF:004445', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181251, NULL, 'G3DSA:3.30.830.10:FF:000053', NULL, NULL, 'Falcilysin', NULL, NULL, NULL, NULL, NULL, 4),
(181252, NULL, 'G3DSA:1.25.40.10:FF:003848', NULL, NULL, 'CCR4-NOT transcription complex subunit 10 homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(181253, NULL, 'G3DSA:1.10.1060.10:FF:000027', NULL, NULL, 'FAD linked oxidase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(181254, NULL, 'G3DSA:3.40.50.12100:FF:000002', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(181255, NULL, 'G3DSA:3.60.40.10:FF:000345', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181256, NULL, 'G3DSA:1.20.120.350:FF:000059', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(181257, NULL, 'G3DSA:1.25.40.70:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181258, NULL, 'G3DSA:2.30.29.30:FF:001149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181259, NULL, 'G3DSA:3.40.50.80:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181260, NULL, 'G3DSA:3.30.70.20:FF:000076', NULL, NULL, 'CoB--CoM heterodisulfide reductase iron-sulfur subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(181261, NULL, 'G3DSA:3.30.420.10:FF:000679', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181262, NULL, 'G3DSA:3.20.20.100:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181263, NULL, 'G3DSA:2.170.300.10:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181264, NULL, 'G3DSA:2.60.120.260:FF:000218', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(181265, NULL, 'G3DSA:1.20.1070.10:FF:000587', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181266, NULL, 'G3DSA:3.40.190.10:FF:000080', NULL, NULL, 'Spermidine/putrescine ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(181267, NULL, 'G3DSA:3.10.170.20:FF:000003', NULL, NULL, 'GP63-like', NULL, NULL, NULL, NULL, NULL, 4),
(181268, NULL, 'G3DSA:1.20.1530.20:FF:000042', NULL, NULL, 'Cation/H(+) antiporter 14', NULL, NULL, NULL, NULL, NULL, 4),
(181269, NULL, 'G3DSA:2.80.10.50:FF:000160', NULL, NULL, 'Dolichyl-phosphate-mannose--protein mannosyltransferase 5', NULL, NULL, NULL, NULL, NULL, 4),
(181270, NULL, 'G3DSA:2.60.40.4370:FF:000007', NULL, NULL, 'General transcription factor 3C polypeptide 6', NULL, NULL, NULL, NULL, NULL, 4),
(181271, NULL, 'G3DSA:3.40.50.300:FF:006502', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181272, NULL, 'G3DSA:3.30.40.10:FF:000728', NULL, NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(181273, NULL, 'G3DSA:1.20.1070.10:FF:000475', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181274, NULL, 'G3DSA:3.30.40.10:FF:001217', NULL, NULL, 'E3 ubiquitin-protein ligase TTC3 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(181275, NULL, 'G3DSA:2.160.10.10:FF:000015', NULL, NULL, 'Serine acetyltransferase, plasmid', NULL, NULL, NULL, NULL, NULL, 4),
(181276, NULL, 'G3DSA:2.10.70.10:FF:000093', NULL, NULL, 'Complement component C6', NULL, NULL, NULL, NULL, NULL, 4),
(181277, NULL, 'G3DSA:3.40.50.300:FF:002821', NULL, NULL, 'Multidrug resistance-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(181278, NULL, 'G3DSA:3.40.50.1240:FF:000218', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181279, NULL, 'G3DSA:1.20.1270.20:FF:000004', NULL, NULL, 'Hydroxylamine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(181280, NULL, 'G3DSA:1.10.150.50:FF:000199', NULL, NULL, 'NGFI-A-binding protein 1a (EGR1 binding protein 1)', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(181281, NULL, 'G3DSA:1.10.10.10:FF:001671', NULL, NULL, 'Rrf2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(181282, NULL, 'G3DSA:1.10.132.60:FF:000025', NULL, NULL, 'DNA-directed DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(181283, NULL, 'G3DSA:3.40.50.410:FF:000145', NULL, NULL, 'Telomerase-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(181284, NULL, 'G3DSA:2.60.120.330:FF:000138', NULL, NULL, 'Putative 2og-fe oxygenase protein', NULL, NULL, NULL, NULL, NULL, 4),
(181285, NULL, 'G3DSA:3.40.390.10:FF:000061', NULL, NULL, 'Related to mitochondrial intermediate peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(181286, NULL, 'G3DSA:1.25.40.20:FF:001709', NULL, NULL, 'LOC100005699 protein', NULL, NULL, NULL, NULL, NULL, 4),
(181287, NULL, 'G3DSA:3.50.50.60:FF:001322', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181288, NULL, 'G3DSA:3.40.50.1000:FF:000377', NULL, NULL, 'Hydrolase (HAD superfamily)', NULL, NULL, NULL, NULL, NULL, 4),
(181289, NULL, 'G3DSA:2.60.40.640:FF:000037', NULL, NULL, 'Arrestin 3a, retinal (X-arrestin)', NULL, NULL, NULL, NULL, NULL, 4),
(181290, NULL, 'G3DSA:2.30.30.40:FF:000604', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(181291, NULL, 'G3DSA:2.60.260.20:FF:000065', NULL, NULL, 'Xdj1p', NULL, NULL, NULL, NULL, NULL, 4),
(181292, NULL, 'G3DSA:3.90.660.10:FF:000020', NULL, NULL, 'Peroxisomal N(1)-acetyl-spermine/spermidine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(181293, NULL, 'G3DSA:3.30.930.10:FF:000307', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181294, NULL, 'G3DSA:3.10.28.10:FF:000004', NULL, NULL, 'Probable cell division protein WhiA', NULL, NULL, NULL, NULL, NULL, 4),
(181295, NULL, 'G3DSA:1.10.530.10:FF:000053', NULL, NULL, 'Basic endochitinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(181296, NULL, 'G3DSA:1.10.540.10:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181297, NULL, 'G3DSA:3.90.79.10:FF:000242', NULL, NULL, 'Gll1085 protein', NULL, NULL, NULL, NULL, NULL, 4),
(181298, NULL, 'G3DSA:2.30.180.10:FF:000175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181299, NULL, 'G3DSA:3.30.160.60:FF:004557', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181300, NULL, 'G3DSA:3.30.310.10:FF:000007', NULL, NULL, 'TATA-box-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(181301, NULL, 'G3DSA:3.40.50.2300:FF:000677', NULL, NULL, 'Gamma-aminobutyric acid type B receptor subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(181302, NULL, 'G3DSA:2.60.60.20:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181303, NULL, 'G3DSA:2.130.10.10:FF:004653', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181304, NULL, 'G3DSA:1.10.510.10:FF:000850', NULL, NULL, 'PRKACB isoform 14', NULL, NULL, NULL, NULL, NULL, 4),
(181305, NULL, 'G3DSA:2.60.120.20:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181306, NULL, 'G3DSA:3.30.160.60:FF:003826', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181307, NULL, 'G3DSA:3.90.100.10:FF:000001', NULL, NULL, 'Lysine decarboxylase, inducible', NULL, NULL, NULL, NULL, NULL, 4),
(181308, NULL, 'G3DSA:2.60.40.790:FF:000054', NULL, NULL, '17.4 kDa class III heat shock protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(181309, NULL, 'G3DSA:1.25.40.20:FF:001923', NULL, NULL, 'Ion channel NompC', NULL, NULL, NULL, NULL, NULL, 4),
(181310, NULL, 'G3DSA:2.40.30.10:FF:000516', NULL, NULL, 'Elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(181311, NULL, 'G3DSA:1.10.287.1490:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181312, NULL, 'G3DSA:3.40.50.300:FF:001298', NULL, NULL, 'Type VII secretion protein EccC', NULL, NULL, NULL, NULL, NULL, 4),
(181313, NULL, 'G3DSA:3.20.70.20:FF:000054', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(181314, NULL, 'G3DSA:1.20.1250.20:FF:000790', NULL, NULL, 'Solute carrier family 2 member 10', NULL, NULL, NULL, NULL, NULL, 4),
(181315, NULL, 'G3DSA:1.20.1270.60:FF:000229', NULL, NULL, 'Sdpn-1', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(181316, NULL, 'G3DSA:1.10.510.10:FF:004222', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181317, NULL, 'G3DSA:1.10.287.110:FF:000303', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(181318, NULL, 'G3DSA:3.40.140.10:FF:000138', NULL, NULL, 'Mov34/MPN/PAD-1 metallopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181319, NULL, 'G3DSA:2.60.40.10:FF:004006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181320, NULL, 'G3DSA:1.25.40.10:FF:002651', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181321, NULL, 'G3DSA:3.40.50.300:FF:000112', NULL, NULL, 'Eukaryotic translation initiation factor 5B', NULL, NULL, NULL, NULL, NULL, 4),
(181322, NULL, 'G3DSA:3.40.50.300:FF:007593', NULL, NULL, 'Putative uridine kinase C227.14', NULL, NULL, NULL, NULL, NULL, 4),
(181323, NULL, 'G3DSA:1.10.10.10:FF:000726', NULL, NULL, 'Adenosine deaminase, RNA-specific', NULL, NULL, NULL, NULL, NULL, 4),
(181324, NULL, 'G3DSA:2.60.120.40:FF:000027', NULL, NULL, 'CD70 antigen', NULL, NULL, NULL, NULL, NULL, 4),
(181325, NULL, 'G3DSA:2.60.40.10:FF:000634', NULL, NULL, 'Interleukin 1 receptor accessory protein', NULL, NULL, NULL, NULL, NULL, 4),
(181326, NULL, 'G3DSA:3.20.20.80:FF:000658', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181327, NULL, 'G3DSA:3.30.1330.30:FF:000014', NULL, NULL, 'RNA methyltransferase, TrmH family, group 3', NULL, NULL, NULL, NULL, NULL, 4),
(181328, NULL, 'G3DSA:3.90.1150.10:FF:000323', NULL, NULL, 'Serine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(181329, NULL, 'G3DSA:3.40.50.300:FF:003759', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(181330, NULL, 'G3DSA:3.40.50.720:FF:001188', NULL, NULL, '3-hydroxybutyrate dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181331, NULL, 'G3DSA:1.20.5.110:FF:000016', NULL, NULL, 'Syntaxin 12', NULL, NULL, NULL, NULL, NULL, 4),
(181332, NULL, 'G3DSA:1.20.1090.10:FF:000015', NULL, NULL, '3-dehydroquinate synthase protein', NULL, NULL, NULL, NULL, NULL, 4),
(181333, NULL, 'G3DSA:1.20.1280.50:FF:000154', NULL, NULL, 'Putative F-box protein At5g36200', NULL, NULL, NULL, NULL, NULL, 4),
(181334, NULL, 'G3DSA:3.60.15.10:FF:000152', NULL, NULL, 'Subunit of mRNA cleavage and polyadenylation specificity factor', NULL, NULL, NULL, NULL, NULL, 4),
(181335, NULL, 'G3DSA:3.30.160.60:FF:005985', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181336, NULL, 'G3DSA:3.30.1460.50:FF:000007', NULL, NULL, 'Autophagy-related protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(181337, NULL, 'G3DSA:3.40.50.2300:FF:001296', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181338, NULL, 'G3DSA:1.10.1420.10:FF:000111', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(181339, NULL, 'G3DSA:3.90.550.10:FF:000613', NULL, NULL, 'Glycosyltransferases', NULL, NULL, NULL, NULL, NULL, 4),
(181340, NULL, 'G3DSA:3.40.50.300:FF:000781', NULL, NULL, 'RAB, member RAS oncogene family like 6', NULL, NULL, NULL, NULL, NULL, 4),
(181341, NULL, 'G3DSA:2.60.40.10:FF:002551', NULL, NULL, 'putative ST2L protein isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(181342, NULL, 'G3DSA:1.25.40.210:FF:000003', NULL, NULL, 'Telomeric repeat-binding factor', NULL, NULL, NULL, NULL, NULL, 4),
(181343, NULL, 'G3DSA:3.40.950.10:FF:000025', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', NULL, NULL, NULL, NULL, NULL, 4),
(181344, NULL, 'G3DSA:3.90.70.10:FF:000694', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181345, NULL, 'G3DSA:3.40.710.10:FF:000047', NULL, NULL, 'Glycosyl transferase family 51', NULL, NULL, NULL, NULL, NULL, 4),
(181346, NULL, 'G3DSA:1.25.10.10:FF:000002', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(181347, NULL, 'G3DSA:3.40.50.1000:FF:000826', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181348, NULL, 'G3DSA:2.160.20.10:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181349, NULL, 'G3DSA:1.25.40.10:FF:000173', NULL, NULL, 'Tetratricopeptide repeat domain 8', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(181350, NULL, 'G3DSA:2.40.290.10:FF:000012', NULL, NULL, 'ATP-dependent DNA helicase II subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(181351, NULL, 'G3DSA:3.20.20.80:FF:000203', NULL, NULL, 'Glycogen debranching enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(181352, NULL, 'G3DSA:1.20.1250.20:FF:001318', NULL, NULL, 'monocarboxylate transporter 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(181353, NULL, 'G3DSA:3.40.50.300:FF:008318', NULL, NULL, 'Multidrug resistance protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181354, NULL, 'G3DSA:3.30.1460.30:FF:000001', NULL, NULL, 'TfoX family protein', NULL, NULL, NULL, NULL, NULL, 4),
(181355, NULL, 'G3DSA:3.30.160.60:FF:003938', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181356, NULL, 'G3DSA:1.10.472.10:FF:000081', NULL, NULL, 'Cyclin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(181357, NULL, 'G3DSA:2.120.10.80:FF:000116', NULL, NULL, 'Attractin like 1', NULL, NULL, NULL, NULL, NULL, 4),
(181358, NULL, 'G3DSA:1.10.472.10:FF:000417', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181359, NULL, 'G3DSA:3.90.950.10:FF:000008', NULL, NULL, 'Maf-like protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(181360, NULL, 'G3DSA:3.10.330.20:FF:000005', NULL, NULL, 'tRNA (Adenine-N(1)-)-methyltransferase catalytic subunit trm61', NULL, NULL, NULL, NULL, NULL, 4),
(181361, NULL, 'G3DSA:3.40.47.10:FF:000193', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181362, NULL, 'G3DSA:1.10.510.10:FF:000069', NULL, NULL, 'probable serine/threonine-protein kinase At5g41260', NULL, NULL, NULL, NULL, NULL, 4),
(181363, NULL, 'G3DSA:1.10.510.10:FF:003828', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181364, NULL, 'G3DSA:3.40.1090.10:FF:000133', NULL, NULL, 'Protein CBG15159', NULL, NULL, NULL, NULL, NULL, 4),
(181365, NULL, 'G3DSA:3.30.565.10:FF:000374', NULL, NULL, 'Response receiver histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(181366, NULL, 'G3DSA:1.10.287.110:FF:000062', NULL, NULL, 'DnaJ protein ERDJ3B', NULL, NULL, NULL, NULL, NULL, 4),
(181367, NULL, 'G3DSA:1.20.1250.20:FF:001739', NULL, NULL, 'Uncharacterized MFS-type transporter C18.02', NULL, NULL, NULL, NULL, NULL, 4),
(181368, NULL, 'G3DSA:1.20.5.170:FF:000219', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(181369, NULL, 'G3DSA:3.30.450.60:FF:000038', NULL, NULL, 'AP complex subunit sigma', NULL, NULL, NULL, NULL, NULL, 4),
(181370, NULL, 'G3DSA:2.170.270.10:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181371, NULL, 'G3DSA:3.40.50.300:FF:004283', NULL, NULL, 'Zgc:162239', NULL, NULL, NULL, NULL, NULL, 4),
(181372, NULL, 'G3DSA:3.30.70.270:FF:000199', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181373, NULL, 'G3DSA:1.10.287.130:FF:000068', NULL, NULL, 'PAS domain-containing sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(181374, NULL, 'G3DSA:3.30.470.30:FF:000042', NULL, NULL, 'Putative DNA ligase k alpha', NULL, NULL, NULL, NULL, NULL, 4),
(181375, NULL, 'G3DSA:2.70.130.10:FF:000146', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181376, NULL, 'G3DSA:3.90.70.10:FF:000025', NULL, NULL, 'Putative ubiquitin carboxyl-terminal hydrolase 8', NULL, NULL, NULL, NULL, NULL, 4),
(181377, NULL, 'G3DSA:3.30.230.120:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181378, NULL, 'G3DSA:3.90.70.130:FF:000003', NULL, NULL, 'Probable Ufm1-specific protease 1', NULL, NULL, NULL, NULL, NULL, 4),
(181379, NULL, 'G3DSA:3.30.470.20:FF:000168', NULL, NULL, 'Tubulin glycylase 3E', NULL, NULL, NULL, NULL, NULL, 4),
(181380, NULL, 'G3DSA:2.170.260.10:FF:000030', NULL, NULL, 'Dicer-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181381, NULL, 'G3DSA:1.10.540.10:FF:000008', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(181382, NULL, 'G3DSA:1.25.40.10:FF:002308', NULL, NULL, 'Signal recognition particle subunit SRP72', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(181383, NULL, 'G3DSA:3.50.50.60:FF:000024', NULL, NULL, 'Gamma-glutamylputrescine oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(181384, NULL, 'G3DSA:1.10.10.10:FF:001783', NULL, NULL, 'Vacuolar protein-sorting-associated protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(181385, NULL, 'G3DSA:3.40.50.12650:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181386, NULL, 'G3DSA:1.25.40.10:FF:004096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181387, NULL, 'G3DSA:2.60.40.10:FF:001932', NULL, NULL, 'Neural cell adhesion molecule 1a', NULL, NULL, NULL, NULL, NULL, 4),
(181388, NULL, 'G3DSA:3.20.20.70:FF:000329', NULL, NULL, 'Triosephosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(181389, NULL, 'G3DSA:3.20.20.220:FF:000013', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(181390, NULL, 'G3DSA:2.60.120.330:FF:000026', NULL, NULL, 'DIBOA-glucoside dioxygenase BX6', NULL, NULL, NULL, NULL, NULL, 4),
(181391, NULL, 'G3DSA:2.60.120.310:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181392, NULL, 'G3DSA:2.60.40.10:FF:005294', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181393, NULL, 'G3DSA:3.40.605.10:FF:000033', NULL, NULL, 'NAD-dependent succinate-semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(181394, NULL, 'G3DSA:4.10.410.10:FF:000055', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(181395, NULL, 'G3DSA:1.20.120.350:FF:000143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181396, NULL, 'G3DSA:3.80.10.10:FF:001404', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181397, NULL, 'G3DSA:2.30.30.230:FF:000008', NULL, NULL, 'Fumarylacetoacetase', NULL, NULL, NULL, NULL, NULL, 4),
(181398, NULL, 'G3DSA:1.25.10.10:FF:002031', NULL, NULL, 'Translational activator, putative (AFU_orthologue AFUA_2G07960)', NULL, NULL, NULL, NULL, NULL, 4),
(181399, NULL, 'G3DSA:3.80.10.10:FF:000578', NULL, NULL, 'F-box/LRR-repeat protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(181400, NULL, 'G3DSA:3.50.50.60:FF:001434', NULL, NULL, 'Probable lysine-specific histone demethylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(181401, NULL, 'G3DSA:2.120.10.90:FF:000006', NULL, NULL, 'DNA gyrase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(181402, NULL, 'G3DSA:2.60.40.1180:FF:000146', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(181403, NULL, 'G3DSA:1.25.10.10:FF:000345', NULL, NULL, 'Condensin-2 complex subunit D3', NULL, NULL, NULL, NULL, NULL, 4),
(181404, NULL, 'G3DSA:1.10.10.1940:FF:000003', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(181405, NULL, 'G3DSA:2.60.40.10:FF:000504', NULL, NULL, 'Bent, isoform J', NULL, NULL, NULL, NULL, NULL, 4),
(181406, NULL, 'G3DSA:2.30.30.380:FF:000025', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(181407, NULL, 'G3DSA:2.10.25.10:FF:000792', NULL, NULL, 'Uninflatable, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(181408, NULL, 'G3DSA:1.25.10.10:FF:000906', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(181409, NULL, 'G3DSA:1.25.40.10:FF:002994', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g08510', NULL, NULL, NULL, NULL, NULL, 4),
(181410, NULL, 'G3DSA:1.25.10.10:FF:001755', NULL, NULL, 'Exportin-4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(181411, NULL, 'G3DSA:2.30.110.10:FF:000013', NULL, NULL, 'Protein CREG1 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(181412, NULL, 'G3DSA:3.20.20.70:FF:000785', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181413, NULL, 'G3DSA:3.80.10.10:FF:002832', NULL, NULL, 'Ras guanine nucleotide exchange factor V', NULL, NULL, NULL, NULL, NULL, 4),
(181414, NULL, 'G3DSA:3.20.20.370:FF:000030', NULL, NULL, 'Chitin deacetylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(181415, NULL, 'G3DSA:3.40.850.10:FF:000563', NULL, NULL, 'Kinesin family member 1C', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(181416, NULL, 'G3DSA:2.60.40.1120:FF:000044', NULL, NULL, 'Bacillopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(181417, NULL, 'G3DSA:3.40.50.1820:FF:000960', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181418, NULL, 'G3DSA:3.30.160.60:FF:001117', NULL, NULL, 'Zinc finger and BTB domain containing 48', NULL, NULL, NULL, NULL, NULL, 4),
(181419, NULL, 'G3DSA:1.10.10.60:FF:000376', NULL, NULL, 'Chromodomain-helicase-DNA-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(181420, NULL, 'G3DSA:2.130.10.10:FF:004310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181421, NULL, 'G3DSA:3.40.50.200:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181422, NULL, 'G3DSA:3.30.450.40:FF:000032', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(181423, NULL, 'G3DSA:1.20.1070.10:FF:001543', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181424, NULL, 'G3DSA:2.60.40.10:FF:005855', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181425, NULL, 'G3DSA:3.90.120.10:FF:000013', NULL, NULL, 'Cytosine-C5 specific DNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(181426, NULL, 'G3DSA:3.40.50.1380:FF:000002', NULL, NULL, 'Methylglyoxal synthase', NULL, NULL, NULL, NULL, NULL, 4),
(181427, NULL, 'G3DSA:3.30.70.330:FF:002156', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181428, NULL, 'G3DSA:3.30.70.100:FF:000098', NULL, NULL, 'Ysine decarboxylase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(181429, NULL, 'G3DSA:3.30.379.10:FF:000003', NULL, NULL, 'Beta-hexosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(181430, NULL, 'G3DSA:2.130.10.10:FF:005951', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181431, NULL, 'G3DSA:2.60.120.230:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181432, NULL, 'G3DSA:1.20.1250.20:FF:000913', NULL, NULL, 'Ascus development protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(181433, NULL, 'G3DSA:1.20.1250.20:FF:001402', NULL, NULL, 'Transporter protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181434, NULL, 'G3DSA:2.60.40.10:FF:004349', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181435, NULL, 'G3DSA:3.30.200.20:FF:001986', NULL, NULL, 'Os12g0427000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(181436, NULL, 'G3DSA:3.40.33.10:FF:000155', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(181437, NULL, 'G3DSA:4.10.1240.50:FF:000011', NULL, NULL, 'Metastasis-associated protein MTA1', NULL, NULL, NULL, NULL, NULL, 4),
(181438, NULL, 'G3DSA:1.25.40.10:FF:001583', NULL, NULL, 'Tetratricopeptide repeat domain 7B', NULL, NULL, NULL, NULL, NULL, 4),
(181439, NULL, 'G3DSA:3.90.190.10:FF:000175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181440, NULL, 'G3DSA:2.40.30.10:FF:000179', NULL, NULL, 'Sulfate adenylyltransferase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(181441, NULL, 'G3DSA:3.30.230.70:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181442, NULL, 'G3DSA:1.20.120.530:FF:000006', NULL, NULL, 'HTH-type transcriptional repressor NanR', NULL, NULL, NULL, NULL, NULL, 4),
(181443, NULL, 'G3DSA:3.40.50.2020:FF:000003', NULL, NULL, 'Uracil phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(181444, NULL, 'G3DSA:3.40.50.300:FF:002579', NULL, NULL, 'Primosomal protein N''', NULL, NULL, NULL, NULL, NULL, 4),
(181445, NULL, 'G3DSA:3.30.160.60:FF:003034', NULL, NULL, 'Zinc finger protein 557', NULL, NULL, NULL, NULL, NULL, 4),
(181446, NULL, 'G3DSA:2.30.29.240:FF:000009', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(181447, NULL, 'G3DSA:6.10.140.2220:FF:000077', NULL, NULL, 'SD20045p', NULL, NULL, NULL, NULL, NULL, 4),
(181448, NULL, 'G3DSA:2.130.10.10:FF:005721', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181449, NULL, 'G3DSA:2.60.40.10:FF:003377', NULL, NULL, 'Adhesion G protein-coupled receptor L3', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(181450, NULL, 'G3DSA:1.20.58.530:FF:000018', NULL, NULL, 'myosin-VIIa isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(181451, NULL, 'G3DSA:3.40.50.720:FF:001755', NULL, NULL, 'Alcohol dehydrogenase GroES domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(181452, NULL, 'G3DSA:3.30.60.20:FF:000036', NULL, NULL, 'Rho-associated protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(181453, NULL, 'G3DSA:1.25.10.10:FF:001851', NULL, NULL, 'U3 small nucleolar RNA-associated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181454, NULL, 'G3DSA:3.80.10.10:FF:004277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181455, NULL, 'G3DSA:3.90.1750.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181456, NULL, 'G3DSA:3.30.70.330:FF:002611', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181457, NULL, 'G3DSA:1.10.220.150:FF:000035', NULL, NULL, 'Arf GTPase activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(181458, NULL, 'G3DSA:2.60.40.2130:FF:000004', NULL, NULL, 'M-spondin', NULL, NULL, NULL, NULL, NULL, 4),
(181459, NULL, 'G3DSA:2.60.34.10:FF:000119', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(181460, NULL, 'G3DSA:3.30.1240.10:FF:000029', NULL, NULL, 'Stress response protein YhaX', NULL, NULL, NULL, NULL, NULL, 4),
(181461, NULL, 'G3DSA:1.20.58.340:FF:000068', NULL, NULL, 'Cobalt/magnesium transport protein CorA', NULL, NULL, NULL, NULL, NULL, 4),
(181462, NULL, 'G3DSA:2.70.50.80:FF:000008', NULL, NULL, 'Transcriptional enhancer factor TEF-3', NULL, NULL, NULL, NULL, NULL, 4),
(181463, NULL, 'G3DSA:2.130.10.10:FF:005058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181464, NULL, 'G3DSA:3.40.50.2000:FF:000817', NULL, NULL, 'Lipopolysaccharide heptosyltransferase III, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181465, NULL, 'G3DSA:1.25.10.10:FF:002823', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181466, NULL, 'G3DSA:1.25.10.10:FF:003088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181467, NULL, 'G3DSA:3.40.50.720:FF:000783', NULL, NULL, '6-phosphogluconate dehydrogenase, decarboxylating, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181468, NULL, 'G3DSA:3.10.20.90:FF:000965', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181469, NULL, 'G3DSA:3.60.21.10:FF:000436', NULL, NULL, 'UDP-N-2, O-3-di-(3-hydroxyacyl)glucosamine/UDP-N-2, N-3-di-(3-hydroxyacyl)glucosediamine pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(181470, NULL, 'G3DSA:1.20.1740.10:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181471, NULL, 'G3DSA:3.30.70.330:FF:000711', NULL, NULL, 'Pre-mRNA splicing factor (Prp24), putative', NULL, NULL, NULL, NULL, NULL, 4),
(181472, NULL, 'G3DSA:3.30.70.330:FF:001330', NULL, NULL, 'Os03g0363800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(181473, NULL, 'G3DSA:3.30.310.50:FF:000008', NULL, NULL, 'Cancer/testis antigen 2', NULL, NULL, NULL, NULL, NULL, 4),
(181474, NULL, 'G3DSA:2.60.40.150:FF:000199', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(181475, NULL, 'G3DSA:1.20.1270.60:FF:000089', NULL, NULL, 'BAI1 associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(181476, NULL, 'G3DSA:1.10.10.10:FF:000277', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(181477, NULL, 'G3DSA:2.30.30.30:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181478, NULL, 'G3DSA:3.40.50.1000:FF:000034', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(181479, NULL, 'G3DSA:1.10.150.240:FF:000118', NULL, NULL, 'Phosphoglycolate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(181480, NULL, 'G3DSA:2.40.240.10:FF:000060', NULL, NULL, 'tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(181481, NULL, 'G3DSA:2.10.25.10:FF:001438', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(181482, NULL, 'G3DSA:1.20.120.1900:FF:000087', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(181483, NULL, 'G3DSA:1.10.3460.10:FF:000024', NULL, NULL, 'Photosystem I light harvesting protein', NULL, NULL, NULL, NULL, NULL, 4),
(181484, NULL, 'G3DSA:2.30.30.210:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181485, NULL, 'G3DSA:3.40.1110.10:FF:000293', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181486, NULL, 'G3DSA:2.20.25.90:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181487, NULL, 'G3DSA:3.40.30.10:FF:000924', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181488, NULL, 'G3DSA:3.30.40.10:FF:001105', NULL, NULL, 'RIKEN cDNA 4930595M18 gene', NULL, NULL, NULL, NULL, NULL, 4),
(181489, NULL, 'G3DSA:2.160.10.10:FF:000127', NULL, NULL, 'Probable mannose-1-phosphate guanyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(181490, NULL, 'G3DSA:3.30.565.10:FF:000470', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(181491, NULL, 'G3DSA:1.20.1050.10:FF:000024', NULL, NULL, 'Glutaredoxin 2', NULL, NULL, NULL, NULL, NULL, 4),
(181492, NULL, 'G3DSA:3.40.50.300:FF:002366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181493, NULL, 'G3DSA:1.20.120.290:FF:000001', NULL, NULL, 'Oxygen-evolving enhancer protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(181494, NULL, 'G3DSA:1.25.40.10:FF:000734', NULL, NULL, 'Binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(181495, NULL, 'G3DSA:3.40.250.10:FF:000242', NULL, NULL, 'Sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(181496, NULL, 'G3DSA:1.10.20.10:FF:000328', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181497, NULL, 'G3DSA:1.20.1110.10:FF:000193', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181498, NULL, 'G3DSA:3.90.190.10:FF:000388', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type 9', NULL, NULL, NULL, NULL, NULL, 4),
(181499, NULL, 'G3DSA:3.40.50.1580:FF:000062', NULL, NULL, 'Protein CBG16977', NULL, NULL, NULL, NULL, NULL, 4),
(181500, NULL, 'G3DSA:3.30.1330.60:FF:000012', NULL, NULL, 'Peptidoglycan-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(181501, NULL, 'G3DSA:1.10.167.10:FF:000051', NULL, NULL, 'Regulator of G-protein signaling 1', NULL, NULL, NULL, NULL, NULL, 4),
(181502, NULL, 'G3DSA:3.30.200.20:FF:001194', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(181503, NULL, 'G3DSA:3.30.70.330:FF:002948', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181504, NULL, 'G3DSA:2.130.10.10:FF:004209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181505, NULL, 'G3DSA:2.10.25.10:FF:000921', NULL, NULL, 'Protein gurken', NULL, NULL, NULL, NULL, NULL, 4),
(181506, NULL, 'G3DSA:3.30.60.30:FF:000140', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(181507, NULL, 'G3DSA:1.25.40.1010:FF:000004', NULL, NULL, 'N-acetyltransferase subunit Nat1', NULL, NULL, NULL, NULL, NULL, 4),
(181508, NULL, 'G3DSA:3.40.50.11030:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181509, NULL, 'G3DSA:2.40.50.150:FF:000014', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(181510, NULL, 'G3DSA:1.20.1050.10:FF:000120', NULL, NULL, 'glutathione S-transferase omega-1', NULL, NULL, NULL, NULL, NULL, 4),
(181511, NULL, 'G3DSA:3.30.2020.30:FF:000013', NULL, NULL, 'Trimethyllysine dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(181512, NULL, 'G3DSA:1.20.5.990:FF:000010', NULL, NULL, 'TNFAIP3 interacting protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(181513, NULL, 'G3DSA:2.30.29.30:FF:000761', NULL, NULL, 'Ran-binding protein (RanBP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(181514, NULL, 'G3DSA:1.10.533.10:FF:000094', NULL, NULL, 'Interleukin-1 receptor-associated kinase', NULL, NULL, NULL, NULL, NULL, 4),
(181515, NULL, 'G3DSA:3.30.160.60:FF:003377', NULL, NULL, 'LD33878p', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(181516, NULL, 'G3DSA:2.70.150.10:FF:000046', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(181517, NULL, 'G3DSA:3.30.160.60:FF:006474', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181518, NULL, 'G3DSA:2.30.29.30:FF:000401', NULL, NULL, 'FYVE, RhoGEF and PH domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(181519, NULL, 'G3DSA:3.40.640.10:FF:000406', NULL, NULL, 'Aminotransferase, class I', NULL, NULL, NULL, NULL, NULL, 4),
(181520, NULL, 'G3DSA:2.70.150.10:FF:000259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181521, NULL, 'G3DSA:3.40.50.80:FF:000221', NULL, NULL, 'Ferredoxin:NADP oxidoreductase, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(181522, NULL, 'G3DSA:2.30.29.30:FF:001250', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(181523, NULL, 'G3DSA:3.30.2350.20:FF:000024', NULL, NULL, 'tRNA pseudouridine synthase D, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181524, NULL, 'G3DSA:1.10.8.870:FF:000004', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(181525, NULL, 'G3DSA:1.10.510.10:FF:000299', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(181526, NULL, 'G3DSA:3.40.630.30:FF:000327', NULL, NULL, 'Ribosomal protein N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(181527, NULL, 'G3DSA:3.90.290.10:FF:000008', NULL, NULL, 'Fibrillin 3', NULL, NULL, NULL, NULL, NULL, 4),
(181528, NULL, 'G3DSA:3.80.10.10:FF:003451', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(181529, NULL, 'G3DSA:2.60.120.10:FF:000698', NULL, NULL, 'Predicted gene, 28042', NULL, NULL, NULL, NULL, NULL, 4),
(181530, NULL, 'G3DSA:3.40.50.300:FF:004266', NULL, NULL, 'Rab_B32 protein', NULL, NULL, NULL, NULL, NULL, 4),
(181531, NULL, 'G3DSA:3.30.1130.10:FF:000010', NULL, NULL, 'Folic acid synthesis protein fol1', NULL, NULL, NULL, NULL, NULL, 4),
(181532, NULL, 'G3DSA:3.10.129.10:FF:000034', NULL, NULL, 'Acyl-CoA thioester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(181533, NULL, 'G3DSA:3.40.630.10:FF:000097', NULL, NULL, 'Peptide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(181534, NULL, 'G3DSA:1.10.1240.40:FF:000005', NULL, NULL, 'ENT domain containing protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(181535, NULL, 'G3DSA:1.20.1070.10:FF:000924', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181536, NULL, 'G3DSA:1.20.1310.20:FF:000059', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(181537, NULL, 'G3DSA:1.20.5.190:FF:000085', NULL, NULL, 'Myosin IHa', NULL, NULL, NULL, NULL, NULL, 4),
(181538, NULL, 'G3DSA:1.20.1070.10:FF:001413', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181539, NULL, 'G3DSA:3.40.850.10:FF:000220', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(181540, NULL, 'G3DSA:3.40.50.620:FF:000871', NULL, NULL, 'Isoleucyl-tRNA synthetase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(181541, NULL, 'G3DSA:2.40.10.10:FF:000296', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181542, NULL, 'G3DSA:3.40.50.300:FF:005676', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181543, NULL, 'G3DSA:3.40.630.30:FF:000558', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181544, NULL, 'G3DSA:3.40.640.10:FF:000053', NULL, NULL, 'Aminotransferase, class I', NULL, NULL, NULL, NULL, NULL, 4),
(181545, NULL, 'G3DSA:1.10.287.70:FF:000437', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181546, NULL, 'G3DSA:3.40.390.10:FF:000302', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181547, NULL, 'G3DSA:1.20.1070.10:FF:000132', NULL, NULL, 'Neuromedin-B receptor', NULL, NULL, NULL, NULL, NULL, 4),
(181548, NULL, 'G3DSA:2.30.30.40:FF:000475', NULL, NULL, 'Cell division control protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(181549, NULL, 'G3DSA:1.10.472.80:FF:000157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(181550, NULL, 'G3DSA:2.10.25.10:FF:001540', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181551, NULL, 'G3DSA:3.40.50.150:FF:000258', NULL, NULL, 'Probable methyltransferase PMT28', NULL, NULL, NULL, NULL, NULL, 4),
(181552, NULL, 'G3DSA:2.60.40.60:FF:000733', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(181553, NULL, 'G3DSA:1.10.3380.10:FF:000074', NULL, NULL, 'Activating signal cointegrator 1 complex subunit 3, helc1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181554, NULL, 'G3DSA:1.25.40.10:FF:003269', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(181555, NULL, 'G3DSA:1.20.1080.10:FF:000060', NULL, NULL, 'Aquaporin 9, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181556, NULL, 'G3DSA:3.40.50.150:FF:001876', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181557, NULL, 'G3DSA:3.80.10.10:FF:000921', NULL, NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', NULL, NULL, NULL, NULL, NULL, 4),
(181558, NULL, 'G3DSA:3.30.70.1230:FF:000280', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(181559, NULL, 'G3DSA:3.50.50.60:FF:001081', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] flavoprotein subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(181560, NULL, 'G3DSA:2.30.30.140:FF:000072', NULL, NULL, 'Scm like with four mbt domains 2', NULL, NULL, NULL, NULL, NULL, 4),
(181561, NULL, 'G3DSA:1.10.510.10:FF:001822', NULL, NULL, 'Kinase, STE STE20', NULL, NULL, NULL, NULL, NULL, 4),
(181562, NULL, 'G3DSA:3.30.300.20:FF:000055', NULL, NULL, 'Ribosome-binding factor A', NULL, NULL, NULL, NULL, NULL, 4),
(181563, NULL, 'G3DSA:3.40.50.720:FF:000687', NULL, NULL, 'DgcA, Dimethylglycine catabolism', NULL, NULL, NULL, NULL, NULL, 4),
(181564, NULL, 'G3DSA:3.90.1300.10:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181565, NULL, 'G3DSA:3.30.1240.10:FF:000001', NULL, NULL, 'Sugar phosphatase YidA', NULL, NULL, NULL, NULL, NULL, 4),
(181566, NULL, 'G3DSA:3.30.160.60:FF:006131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181567, NULL, 'G3DSA:2.20.70.10:FF:000244', NULL, NULL, 'ADR159Cp', NULL, NULL, NULL, NULL, NULL, 4),
(181568, NULL, 'G3DSA:1.25.40.10:FF:000043', NULL, NULL, 'G-protein-signaling modulator 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(181569, NULL, 'G3DSA:3.40.630.10:FF:000125', NULL, NULL, 'Carboxypeptidase D', NULL, NULL, NULL, NULL, NULL, 4),
(181570, NULL, 'G3DSA:3.30.565.10:FF:000262', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(181571, NULL, 'G3DSA:3.40.50.300:FF:007149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181572, NULL, 'G3DSA:3.40.532.10:FF:000015', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(181573, NULL, 'G3DSA:3.10.110.10:FF:000008', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 G2', NULL, NULL, NULL, NULL, NULL, 4),
(181574, NULL, 'G3DSA:3.30.465.10:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181575, NULL, 'G3DSA:3.30.70.330:FF:001673', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181576, NULL, 'G3DSA:1.10.10.1200:FF:000006', NULL, NULL, 'Melanoma-associated antigen E1', NULL, NULL, NULL, NULL, NULL, 4),
(181577, NULL, 'G3DSA:3.30.160.60:FF:004102', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181578, NULL, 'G3DSA:3.30.810.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181579, NULL, 'G3DSA:1.20.120.1770:FF:000008', NULL, NULL, 'Translation initiation factor', NULL, NULL, NULL, NULL, NULL, 4),
(181580, NULL, 'G3DSA:2.160.20.10:FF:000072', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(181581, NULL, 'G3DSA:2.20.28.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181582, NULL, 'G3DSA:3.30.870.10:FF:000044', NULL, NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(181583, NULL, 'G3DSA:3.10.280.10:FF:000003', NULL, NULL, 'Mitochondrial glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(181584, NULL, 'G3DSA:3.10.250.10:FF:000069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181585, NULL, 'G3DSA:2.40.50.140:FF:001085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181586, NULL, 'G3DSA:2.40.50.140:FF:000579', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(181587, NULL, 'G3DSA:3.80.10.10:FF:003080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181588, NULL, 'G3DSA:3.30.1680.10:FF:000006', NULL, NULL, 'Macrophage-stimulating 1 receptor b', NULL, NULL, NULL, NULL, NULL, 4),
(181589, NULL, 'G3DSA:1.50.10.20:FF:000031', NULL, NULL, 'Protein farnesyltransferase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(181590, NULL, 'G3DSA:2.30.42.10:FF:000488', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181591, NULL, 'G3DSA:3.90.1720.10:FF:000018', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(181592, NULL, 'G3DSA:3.90.930.12:FF:000010', NULL, NULL, '50S ribosomal protein L6', NULL, NULL, NULL, NULL, NULL, 4),
(181593, NULL, 'G3DSA:4.10.400.10:FF:000009', NULL, NULL, 'Low-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(181594, NULL, 'G3DSA:3.40.50.1240:FF:000106', NULL, NULL, 'Protein CBG12398', NULL, NULL, NULL, NULL, NULL, 4),
(181595, NULL, 'G3DSA:2.80.10.50:FF:000289', NULL, NULL, 'Otogelin', NULL, NULL, NULL, NULL, NULL, 4),
(181596, NULL, 'G3DSA:3.40.50.620:FF:000539', NULL, NULL, 'TIGR00269 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(181597, NULL, 'G3DSA:2.60.120.590:FF:000076', NULL, NULL, 'Fto protein', NULL, NULL, NULL, NULL, NULL, 4),
(181598, NULL, 'G3DSA:3.40.50.1220:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181599, NULL, 'G3DSA:3.30.450.30:FF:000046', NULL, NULL, 'Dynein regulation protein LC7', NULL, NULL, NULL, NULL, NULL, 4),
(181600, NULL, 'G3DSA:3.30.160.60:FF:002545', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181601, NULL, 'G3DSA:1.25.40.10:FF:002090', NULL, NULL, 'Os06g0143500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(181602, NULL, 'G3DSA:3.40.50.10130:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181603, NULL, 'G3DSA:3.30.200.60:FF:000008', NULL, NULL, 'Ubiquitin thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(181604, NULL, 'G3DSA:2.60.120.10:FF:000035', NULL, NULL, 'cGMP-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(181605, NULL, 'G3DSA:1.20.1050.10:FF:000232', NULL, NULL, 'Chloride channel, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181606, NULL, 'G3DSA:2.120.10.30:FF:000455', NULL, NULL, 'Nhl repeat-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181607, NULL, 'G3DSA:3.30.70.380:FF:000001', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(181608, NULL, 'G3DSA:1.25.10.10:FF:002582', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181609, NULL, 'G3DSA:2.40.320.10:FF:000010', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 18', NULL, NULL, NULL, NULL, NULL, 4),
(181610, NULL, 'G3DSA:3.30.420.40:FF:000221', NULL, NULL, 'D-allose kinase', NULL, NULL, NULL, NULL, NULL, 4),
(181611, NULL, 'G3DSA:1.25.40.10:FF:004000', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181612, NULL, 'G3DSA:2.40.70.10:FF:000176', NULL, NULL, 'Protein CBG28002', NULL, NULL, NULL, NULL, NULL, 4),
(181613, NULL, 'G3DSA:1.25.10.10:FF:002262', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(181614, NULL, 'G3DSA:3.60.10.10:FF:000388', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181615, NULL, 'G3DSA:1.20.1440.180:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181616, NULL, 'G3DSA:1.20.144.10:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(181617, NULL, 'G3DSA:3.80.10.10:FF:002366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181618, NULL, 'G3DSA:3.40.1340.10:FF:000001', NULL, NULL, 'DNA-directed RNA polymerases I, II, and III subunit RPABC1', NULL, NULL, NULL, NULL, NULL, 4),
(181619, NULL, 'G3DSA:1.20.58.120:FF:000002', NULL, NULL, 'BAG family molecular chaperone regulator 5', NULL, NULL, NULL, NULL, NULL, 4),
(181620, NULL, 'G3DSA:3.30.260.10:FF:000014', NULL, NULL, 'T-complex protein 1, zeta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(181621, NULL, 'G3DSA:2.60.120.650:FF:000116', NULL, NULL, 'Jmjd2b-prov protein', NULL, NULL, NULL, NULL, NULL, 4),
(181622, NULL, 'G3DSA:3.90.1290.10:FF:000030', NULL, NULL, 'Epiplakin 1', NULL, NULL, NULL, NULL, NULL, 4),
(181623, NULL, 'G3DSA:1.20.1250.20:FF:002375', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(181624, NULL, 'G3DSA:3.30.70.20:FF:000093', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181625, NULL, 'G3DSA:3.30.50.10:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181626, NULL, 'G3DSA:1.10.150.20:FF:000313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181627, NULL, 'G3DSA:1.20.120.1750:FF:000002', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(181628, NULL, 'G3DSA:3.30.70.20:FF:000104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181629, NULL, 'G3DSA:1.25.40.10:FF:001139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181630, NULL, 'G3DSA:1.20.1070.10:FF:001756', NULL, NULL, 'Growth hormone-releasing hormone receptor form a', NULL, NULL, NULL, NULL, NULL, 4),
(181631, NULL, 'G3DSA:3.30.40.10:FF:001785', NULL, NULL, 'RING-H2 finger protein ATL46', NULL, NULL, NULL, NULL, NULL, 4),
(181632, NULL, 'G3DSA:1.10.238.10:FF:000380', NULL, NULL, 'Calmodulin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181633, NULL, 'G3DSA:1.10.565.10:FF:000206', NULL, NULL, 'PPARalpha-B', NULL, NULL, NULL, NULL, NULL, 4),
(181634, NULL, 'G3DSA:1.20.5.1430:FF:000011', NULL, NULL, 'Microtubule-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181635, NULL, 'G3DSA:1.20.1420.30:FF:000036', NULL, NULL, 'Sodium/calcium exchanger MaX1', NULL, NULL, NULL, NULL, NULL, 4),
(181636, NULL, 'G3DSA:3.40.50.300:FF:006053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181637, NULL, 'G3DSA:1.10.8.270:FF:000049', NULL, NULL, 'Si:dkey-238d18.4', NULL, NULL, NULL, NULL, NULL, 4),
(181638, NULL, 'G3DSA:1.20.58.60:FF:000289', NULL, NULL, 'Spectrin beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(181639, NULL, 'G3DSA:1.10.10.10:FF:000390', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(181640, NULL, 'G3DSA:1.10.8.60:FF:000285', NULL, NULL, 'ATPase family AAA domain-containing 5b', NULL, NULL, NULL, NULL, NULL, 4),
(181641, NULL, 'G3DSA:2.60.120.200:FF:000015', NULL, NULL, 'protein kinase C-binding protein NELL1', NULL, NULL, NULL, NULL, NULL, 4),
(181642, NULL, 'G3DSA:2.130.10.10:FF:004541', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181643, NULL, 'G3DSA:2.130.10.10:FF:000842', NULL, NULL, 'F-box and WD repeat domain-containing 9', NULL, NULL, NULL, NULL, NULL, 4),
(181644, NULL, 'G3DSA:3.40.50.300:FF:007481', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(181645, NULL, 'G3DSA:1.10.10.60:FF:000831', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181646, NULL, 'G3DSA:4.10.1000.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181647, NULL, 'G3DSA:1.20.930.10:FF:000008', NULL, NULL, 'mediator of RNA polymerase II transcription subunit 26', NULL, NULL, NULL, NULL, NULL, 4),
(181648, NULL, 'G3DSA:1.20.1110.10:FF:000063', NULL, NULL, 'Calcium-translocating P-type ATPase, PMCA-type', NULL, NULL, NULL, NULL, NULL, 4),
(181649, NULL, 'G3DSA:3.20.20.190:FF:000077', NULL, NULL, 'Phosphoinositide-specific phospholipase C, efhand-like/Phosphatidylinositol-specific phospholipase C, X domain/PDZ domain (Also known as DHR or GLGF)/PDZ domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(181650, NULL, 'G3DSA:3.30.1480.10:FF:000007', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(181651, NULL, 'G3DSA:2.130.10.10:FF:002192', NULL, NULL, 'THO Complex (Transcription factor/nuclear export) subunit', NULL, NULL, NULL, NULL, NULL, 4),
(181652, NULL, 'G3DSA:2.70.98.10:FF:000042', NULL, NULL, 'Alpha-1,2-mannosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181653, NULL, 'G3DSA:1.10.260.40:FF:000069', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(181654, NULL, 'G3DSA:2.10.110.10:FF:000332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181655, NULL, 'G3DSA:2.30.29.30:FF:001019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181656, NULL, 'G3DSA:3.30.40.10:FF:001004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181657, NULL, 'G3DSA:3.80.10.10:FF:001747', NULL, NULL, 'Leucine rich repeat containing 18a', NULL, NULL, NULL, NULL, NULL, 4),
(181658, NULL, 'G3DSA:3.30.1150.10:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181659, NULL, 'G3DSA:3.90.1100.10:FF:000045', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(181660, NULL, 'G3DSA:3.30.160.60:FF:000628', NULL, NULL, 'zinc finger protein 768', NULL, NULL, NULL, NULL, NULL, 4),
(181661, NULL, 'G3DSA:1.10.510.10:FF:001479', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(181662, NULL, 'G3DSA:3.40.190.10:FF:000192', NULL, NULL, 'Lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(181663, NULL, 'G3DSA:3.40.50.1010:FF:000043', NULL, NULL, 'MKT1 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(181664, NULL, 'G3DSA:3.40.50.200:FF:000172', NULL, NULL, 'Mbtps1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(181665, NULL, 'G3DSA:3.30.70.1430:FF:000008', NULL, NULL, 'Transporter AcrB/D/F family protein', NULL, NULL, NULL, NULL, NULL, 4),
(181666, NULL, 'G3DSA:3.30.70.1410:FF:000002', NULL, NULL, 'Kanosamine-6-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(181667, NULL, 'G3DSA:1.25.40.10:FF:003477', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g12100, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(181668, NULL, 'G3DSA:1.20.120.220:FF:000020', NULL, NULL, 'ATP synthase subunit a', NULL, NULL, NULL, NULL, NULL, 4),
(181669, NULL, 'G3DSA:3.80.10.10:FF:003900', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(181670, NULL, 'G3DSA:2.60.40.10:FF:001483', NULL, NULL, 'Ephrin type-A receptor 6', NULL, NULL, NULL, NULL, NULL, 4),
(181671, NULL, 'G3DSA:3.40.50.12280:FF:000011', NULL, NULL, 'Energy-conserving hydrogenase (Ferredoxin), subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(181672, NULL, 'G3DSA:2.60.40.60:FF:001014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181673, NULL, 'G3DSA:3.30.160.60:FF:000050', NULL, NULL, 'zinc finger protein ZIC 1', NULL, NULL, NULL, NULL, NULL, 4),
(181674, NULL, 'G3DSA:3.90.190.10:FF:000287', NULL, NULL, 'Laforin, isoform 9', NULL, NULL, NULL, NULL, NULL, 4),
(181675, NULL, 'G3DSA:3.30.420.40:FF:000452', NULL, NULL, 'Actin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181676, NULL, 'G3DSA:3.40.50.300:FF:000449', NULL, NULL, 'Probable ATP-dependent RNA helicase DDX41', NULL, NULL, NULL, NULL, NULL, 4),
(181677, NULL, 'G3DSA:1.10.620.20:FF:000046', NULL, NULL, 'Scarecrow-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(181678, NULL, 'G3DSA:3.30.70.1400:FF:000011', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(181679, NULL, 'G3DSA:1.20.1230.10:FF:000010', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(181680, NULL, 'G3DSA:2.60.40.1510:FF:000048', NULL, NULL, 'Uncharacterized integrin beta-like protein C05D9.3', NULL, NULL, NULL, NULL, NULL, 4),
(181681, NULL, 'G3DSA:3.30.200.20:FF:000233', NULL, NULL, 'Meiosis induction protein kinase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(181682, NULL, 'G3DSA:2.10.70.10:FF:000216', NULL, NULL, 'Protein lev-9', NULL, NULL, NULL, NULL, NULL, 4),
(181683, NULL, 'G3DSA:3.40.30.10:FF:000570', NULL, NULL, 'Os01g0950000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(181684, NULL, 'G3DSA:3.80.10.10:FF:000123', NULL, NULL, 'Volume-regulated anion channel subunit LRRC8D', NULL, NULL, NULL, NULL, NULL, 4),
(181685, NULL, 'G3DSA:3.30.160.60:FF:005294', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181686, NULL, 'G3DSA:3.30.1060.10:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181687, NULL, 'G3DSA:3.30.70.270:FF:000103', NULL, NULL, 'Sensory box/GGDEF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(181688, NULL, 'G3DSA:3.60.21.10:FF:000306', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(181689, NULL, 'G3DSA:2.60.40.150:FF:000087', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit gamma isoform', NULL, NULL, NULL, NULL, NULL, 4),
(181690, NULL, 'G3DSA:2.170.270.10:FF:000087', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(181691, NULL, 'G3DSA:2.40.290.30:FF:000001', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 25', NULL, NULL, NULL, NULL, NULL, 4),
(181692, NULL, 'G3DSA:2.20.110.10:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181693, NULL, 'G3DSA:3.90.70.10:FF:000256', NULL, NULL, 'Calpain-c', NULL, NULL, NULL, NULL, NULL, 4),
(181694, NULL, 'G3DSA:1.10.287.3510:FF:000004', NULL, NULL, 'NADH-ubiquinone oxidoreductase chain 4L', NULL, NULL, NULL, NULL, NULL, 4),
(181695, NULL, 'G3DSA:1.25.40.10:FF:004124', NULL, NULL, 'Chitin synthase regulatory factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(181696, NULL, 'G3DSA:2.40.100.10:FF:000111', NULL, NULL, 'YALI0E00132p', NULL, NULL, NULL, NULL, NULL, 4),
(181697, NULL, 'G3DSA:3.40.50.300:FF:004496', NULL, NULL, 'ABC transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(181698, NULL, 'G3DSA:2.30.330.10:FF:000007', NULL, NULL, 'Flagellar motor switch protein FliM', NULL, NULL, NULL, NULL, NULL, 4),
(181699, NULL, 'G3DSA:3.40.190.10:FF:000416', NULL, NULL, 'Transcriptional regulator LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(181700, NULL, 'G3DSA:3.40.190.10:FF:000304', NULL, NULL, 'Amino acid ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(181701, NULL, 'G3DSA:1.20.58.1180:FF:000003', NULL, NULL, 'Mitochondrial 54S ribosomal protein YmL35', NULL, NULL, NULL, NULL, NULL, 4),
(181702, NULL, 'G3DSA:3.90.1110.10:FF:000006', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(181703, NULL, 'G3DSA:2.10.25.10:FF:001326', NULL, NULL, 'Putative laminin beta 1a', NULL, NULL, NULL, NULL, NULL, 4),
(181704, NULL, 'G3DSA:1.10.490.10:FF:000010', NULL, NULL, 'Group 1 truncated hemoglobin', NULL, NULL, NULL, NULL, NULL, 4),
(181705, NULL, 'G3DSA:2.130.10.10:FF:002287', NULL, NULL, 'AGAP000990-PA', NULL, NULL, NULL, NULL, NULL, 4),
(181706, NULL, 'G3DSA:2.130.10.10:FF:001668', NULL, NULL, 'Cilia-and flagella-associated protein 52', NULL, NULL, NULL, NULL, NULL, 4),
(181707, NULL, 'G3DSA:2.40.30.130:FF:000038', NULL, NULL, 'Alanyl-tRNA editing protein AlaX-L', NULL, NULL, NULL, NULL, NULL, 4),
(181708, NULL, 'G3DSA:3.40.50.300:FF:003198', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(181709, NULL, 'G3DSA:1.50.40.10:FF:000221', NULL, NULL, 'Mitochondrial carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181710, NULL, 'G3DSA:1.10.246.60:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181711, NULL, 'G3DSA:1.25.40.790:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181712, NULL, 'G3DSA:3.90.550.50:FF:000012', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(181713, NULL, 'G3DSA:2.40.180.10:FF:000021', NULL, NULL, 'Catalase', NULL, NULL, NULL, NULL, NULL, 4),
(181714, NULL, 'G3DSA:3.30.450.20:FF:000397', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(181715, NULL, 'G3DSA:1.20.1250.20:FF:000121', NULL, NULL, 'Probable inositol transporter 2', NULL, NULL, NULL, NULL, NULL, 4),
(181716, NULL, 'G3DSA:1.10.1300.10:FF:000052', NULL, NULL, '3'', 5''-cyclic nucleotide phosphodiesterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181717, NULL, 'G3DSA:2.30.30.40:FF:000380', NULL, NULL, 'Variant sh3 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(181718, NULL, 'G3DSA:3.30.160.60:FF:002657', NULL, NULL, 'Tripartite motif containing 75, pseudogene', NULL, NULL, NULL, NULL, NULL, 4),
(181719, NULL, 'G3DSA:1.10.630.10:FF:000460', NULL, NULL, 'Thromboxane A synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(181720, NULL, 'G3DSA:3.40.50.1100:FF:000289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181721, NULL, 'G3DSA:3.40.50.300:FF:003304', NULL, NULL, 'ATP-dependent dethiobiotin synthetase BioD', NULL, NULL, NULL, NULL, NULL, 4),
(181722, NULL, 'G3DSA:3.10.490.20:FF:000027', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(181723, NULL, 'G3DSA:2.60.40.10:FF:003944', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181724, NULL, 'G3DSA:3.90.1150.10:FF:000109', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(181725, NULL, 'G3DSA:2.40.70.10:FF:000064', NULL, NULL, 'Eukaryotic aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(181726, NULL, 'G3DSA:1.20.120.350:FF:000031', NULL, NULL, 'Two pore calcium channel protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(181727, NULL, 'G3DSA:1.20.5.110:FF:000229', NULL, NULL, 'Protein BRICK1', NULL, NULL, NULL, NULL, NULL, 4),
(181728, NULL, 'G3DSA:3.30.830.10:FF:000261', NULL, NULL, 'Ubiquinol-cytochrome c reductase core protein 2a', NULL, NULL, NULL, NULL, NULL, 4),
(181729, NULL, 'G3DSA:3.30.160.60:FF:001123', NULL, NULL, 'Zinc finger and BTB domain-containing protein 49', NULL, NULL, NULL, NULL, NULL, 4),
(181730, NULL, 'G3DSA:2.130.10.10:FF:000044', NULL, NULL, 'echinoderm microtubule-associated protein-like 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(181731, NULL, 'G3DSA:1.25.40.10:FF:000414', NULL, NULL, 'Tetratricopeptide repeat domain 21B', NULL, NULL, NULL, NULL, NULL, 4),
(181732, NULL, 'G3DSA:3.90.79.20:FF:000003', NULL, NULL, 'Nucleoside diphosphate-linked moiety X motif 13', NULL, NULL, NULL, NULL, NULL, 4),
(181733, NULL, 'G3DSA:2.10.25.10:FF:000584', NULL, NULL, 'Vitamin K-dependent protein S', NULL, NULL, NULL, NULL, NULL, 4),
(181734, NULL, 'G3DSA:3.30.540.10:FF:000047', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(181735, NULL, 'G3DSA:3.40.50.1000:FF:000135', NULL, NULL, 'Glycerol-3-phosphate 2-O-acyltransferase 6', NULL, NULL, NULL, NULL, NULL, 4),
(181736, NULL, 'G3DSA:3.40.20.10:FF:000176', NULL, NULL, 'Protein transport protein Sec24A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181737, NULL, 'G3DSA:2.40.50.180:FF:000012', NULL, NULL, 'Purine-binding chemotaxis protein (CheW)', NULL, NULL, NULL, NULL, NULL, 4),
(181738, NULL, 'G3DSA:1.25.10.10:FF:002374', NULL, NULL, 'Calcium-binding protein 39-like', NULL, NULL, NULL, NULL, NULL, 4),
(181739, NULL, 'G3DSA:1.10.506.10:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181740, NULL, 'G3DSA:3.40.50.300:FF:000325', NULL, NULL, 'ATP-dependent RNA helicase DHX29', NULL, NULL, NULL, NULL, NULL, 4),
(181741, NULL, 'G3DSA:3.40.50.720:FF:000002', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(181742, NULL, 'G3DSA:3.50.50.60:FF:000928', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(181743, NULL, 'G3DSA:1.20.140.10:FF:000105', NULL, NULL, 'Acyl-CoA dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181744, NULL, 'G3DSA:1.20.58.80:FF:000076', NULL, NULL, 'Katanin p60 ATPase-containing subunit A1', NULL, NULL, NULL, NULL, NULL, 4),
(181745, NULL, 'G3DSA:1.10.510.10:FF:003733', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181746, NULL, 'G3DSA:2.170.150.80:FF:000014', NULL, NULL, 'NAC domain-containing protein 104', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(181747, NULL, 'G3DSA:1.20.58.60:FF:000070', NULL, NULL, 'utrophin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(181748, NULL, 'G3DSA:1.25.10.10:FF:001643', NULL, NULL, 'Putative death-receptor fusion protein-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(181749, NULL, 'G3DSA:3.30.70.330:FF:002499', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181750, NULL, 'G3DSA:2.60.40.60:FF:000396', NULL, NULL, 'Protocadherin gamma subfamily C, 4', NULL, NULL, NULL, NULL, NULL, 4),
(181751, NULL, 'G3DSA:2.30.130.30:FF:000003', NULL, NULL, 'activating signal cointegrator 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(181752, NULL, 'G3DSA:3.10.20.90:FF:000527', NULL, NULL, 'GM10755', NULL, NULL, NULL, NULL, NULL, 4),
(181753, NULL, 'G3DSA:1.10.510.10:FF:003267', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181754, NULL, 'G3DSA:3.40.1380.20:FF:000012', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(181755, NULL, 'G3DSA:1.10.3860.10:FF:000004', NULL, NULL, 'L-cystine transporter tcyP', NULL, NULL, NULL, NULL, NULL, 4),
(181756, NULL, 'G3DSA:2.40.420.20:FF:000048', NULL, NULL, 'Efflux pump, RND family, membrane fusion lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(181757, NULL, 'G3DSA:3.10.450.50:FF:000028', NULL, NULL, 'mRNA export factor MEX67', NULL, NULL, NULL, NULL, NULL, 4),
(181758, NULL, 'G3DSA:3.40.50.720:FF:001412', NULL, NULL, 'YALI0D20438p', NULL, NULL, NULL, NULL, NULL, 4),
(181759, NULL, 'G3DSA:1.10.1520.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181760, NULL, 'G3DSA:2.60.40.10:FF:002320', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(181761, NULL, 'G3DSA:3.40.33.10:FF:000043', NULL, NULL, 'AGAP007584-PA', NULL, NULL, NULL, NULL, NULL, 4),
(181762, NULL, 'G3DSA:2.60.40.1400:FF:000015', NULL, NULL, 'ATP-sensitive inward rectifier potassium channel 12-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(181763, NULL, 'G3DSA:1.25.40.20:FF:000512', NULL, NULL, 'Interferon antagonist K1L', NULL, NULL, NULL, NULL, NULL, 4),
(181764, NULL, 'G3DSA:3.40.275.10:FF:000001', NULL, NULL, 'L-fucose isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(181765, NULL, 'G3DSA:2.60.40.10:FF:001691', NULL, NULL, 'interleukin-27 receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(181766, NULL, 'G3DSA:3.40.50.10190:FF:000266', NULL, NULL, 'DNA topoisomerase 2-binding protein 1-A', NULL, NULL, NULL, NULL, NULL, 4),
(181767, NULL, 'G3DSA:2.30.30.140:FF:000178', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(181768, NULL, 'G3DSA:3.20.20.80:FF:000097', NULL, NULL, 'Probable chitinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(181769, NULL, 'G3DSA:1.10.1200.10:FF:000128', NULL, NULL, 'HC-toxin synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(181770, NULL, 'G3DSA:3.40.50.300:FF:001859', NULL, NULL, 'Formate--tetrahydrofolate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(181771, NULL, 'G3DSA:3.30.1640.10:FF:000009', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(181772, NULL, 'G3DSA:2.60.120.920:FF:000118', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(181773, NULL, 'G3DSA:3.40.50.200:FF:000088', NULL, NULL, 'S8 family serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(181774, NULL, 'G3DSA:1.10.275.40:FF:000002', NULL, NULL, 'TFIIH basal transcription factor complex helicase XPD subunit', NULL, NULL, NULL, NULL, NULL, 4),
(181775, NULL, 'G3DSA:2.60.40.150:FF:000648', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181776, NULL, 'G3DSA:3.40.50.1010:FF:000251', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181777, NULL, 'G3DSA:3.30.200.20:FF:001643', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181778, NULL, 'G3DSA:1.10.510.10:FF:002305', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181779, NULL, 'G3DSA:3.80.10.10:FF:002927', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181780, NULL, 'G3DSA:2.130.10.10:FF:003372', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase pek-1', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(181781, NULL, 'G3DSA:3.20.20.60:FF:000091', NULL, NULL, '2,4-dihydroxyhept-2-ene-1,7-dioic acid aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(181782, NULL, 'G3DSA:1.20.1050.20:FF:000010', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(181783, NULL, 'G3DSA:3.30.200.20:FF:000025', NULL, NULL, 'Platelet-derived growth factor receptor alpha', NULL, NULL, NULL, NULL, NULL, 4),
(181784, NULL, 'G3DSA:3.40.50.2000:FF:001065', NULL, NULL, 'Os11g0457000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(181785, NULL, 'G3DSA:1.50.40.10:FF:000322', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181786, NULL, 'G3DSA:4.10.280.50:FF:000005', NULL, NULL, 'Glutamate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(181787, NULL, 'G3DSA:3.40.50.300:FF:006177', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(181788, NULL, 'G3DSA:1.10.510.10:FF:004352', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181789, NULL, 'G3DSA:1.10.10.60:FF:000033', NULL, NULL, 'REST corepressor 3', NULL, NULL, NULL, NULL, NULL, 4),
(181790, NULL, 'G3DSA:1.10.630.10:FF:000229', NULL, NULL, 'Cytochrome P450 oxidoreductase OrdA-like, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181791, NULL, 'G3DSA:3.40.50.2300:FF:001054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181792, NULL, 'G3DSA:3.40.50.720:FF:000575', NULL, NULL, 'Malate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(181793, NULL, 'G3DSA:3.30.420.10:FF:000336', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181794, NULL, 'G3DSA:2.10.25.10:FF:001646', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181795, NULL, 'G3DSA:1.20.1320.30:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181796, NULL, 'G3DSA:1.20.1260.140:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181797, NULL, 'G3DSA:3.40.190.290:FF:000032', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(181798, NULL, 'G3DSA:3.30.420.390:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181799, NULL, 'G3DSA:3.30.70.330:FF:003016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181800, NULL, 'G3DSA:3.30.70.270:FF:000311', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181801, NULL, 'G3DSA:2.130.10.10:FF:005513', NULL, NULL, 'WD repeat domain 3', NULL, NULL, NULL, NULL, NULL, 4),
(181802, NULL, 'G3DSA:3.40.50.300:FF:004619', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181803, NULL, 'G3DSA:3.10.129.120:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181804, NULL, 'G3DSA:2.130.10.10:FF:002753', NULL, NULL, 'WD repeat-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181805, NULL, 'G3DSA:3.30.70.3490:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181806, NULL, 'G3DSA:3.40.50.1820:FF:001820', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181807, NULL, 'G3DSA:3.90.1580.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181808, NULL, 'G3DSA:3.30.450.20:FF:000509', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(181809, NULL, 'G3DSA:3.30.450.40:FF:000280', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(181810, NULL, 'G3DSA:3.30.1370.10:FF:000016', NULL, NULL, 'Putative splicing factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(181811, NULL, 'G3DSA:3.10.450.580:FF:000011', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(181812, NULL, 'G3DSA:3.90.1410.10:FF:000130', NULL, NULL, 'AGAP013401-PA', NULL, NULL, NULL, NULL, NULL, 4),
(181813, NULL, 'G3DSA:3.40.50.300:FF:000680', NULL, NULL, 'pachytene checkpoint protein 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(181814, NULL, 'G3DSA:1.10.20.120:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181815, NULL, 'G3DSA:3.30.60.60:FF:000020', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(181816, NULL, 'G3DSA:3.40.930.10:FF:000030', NULL, NULL, 'Nitrogen regulatory IIA protein', NULL, NULL, NULL, NULL, NULL, 4),
(181817, NULL, 'G3DSA:3.30.870.10:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181818, NULL, 'G3DSA:4.10.280.10:FF:000229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181819, NULL, 'G3DSA:1.10.455.10:FF:000007', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(181820, NULL, 'G3DSA:3.40.350.10:FF:000070', NULL, NULL, 'FACT complex subunit SPT16', NULL, NULL, NULL, NULL, NULL, 4),
(181821, NULL, 'G3DSA:1.25.40.10:FF:003932', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181822, NULL, 'G3DSA:2.40.10.10:FF:000633', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181823, NULL, 'G3DSA:1.20.1070.10:FF:000683', NULL, NULL, 'Serpentine receptor class alpha-12', NULL, NULL, NULL, NULL, NULL, 4),
(181824, NULL, 'G3DSA:3.40.47.10:FF:000108', NULL, NULL, 'Beta-ketoacyl-ACP synthase III', NULL, NULL, NULL, NULL, NULL, 4),
(181825, NULL, 'G3DSA:1.25.40.10:FF:001791', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g58590', NULL, NULL, NULL, NULL, NULL, 4),
(181826, NULL, 'G3DSA:3.80.10.10:FF:001646', NULL, NULL, 'Putative inactive leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(181827, NULL, 'G3DSA:2.120.10.30:FF:000017', NULL, NULL, 'Low-density lipoprotein receptor-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(181828, NULL, 'G3DSA:1.25.40.20:FF:001131', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(181829, NULL, 'G3DSA:3.30.200.20:FF:002020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181830, NULL, 'G3DSA:1.10.840.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181831, NULL, 'G3DSA:3.40.50.300:FF:002478', NULL, NULL, 'Flagellar biosynthesis regulator FlhF', NULL, NULL, NULL, NULL, NULL, 4),
(181832, NULL, 'G3DSA:1.10.10.10:FF:001463', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(181833, NULL, 'G3DSA:1.25.40.10:FF:000622', NULL, NULL, 'Signal recognition particle subunit SRP72', NULL, NULL, NULL, NULL, NULL, 4),
(181834, NULL, 'G3DSA:1.25.40.20:FF:000855', NULL, NULL, 'Calcium-independent phospholipase A2 VIA, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(181835, NULL, 'G3DSA:2.120.10.10:FF:000011', NULL, NULL, 'Sialidase 3b', NULL, NULL, NULL, NULL, NULL, 4),
(181836, NULL, 'G3DSA:3.10.350.10:FF:000099', NULL, NULL, 'Outer membrane antigenic lipoprotein B', NULL, NULL, NULL, NULL, NULL, 4),
(181837, NULL, 'G3DSA:3.30.160.20:FF:000066', NULL, NULL, '30S ribosomal protein S5', NULL, NULL, NULL, NULL, NULL, 4),
(181838, NULL, 'G3DSA:1.20.1260.10:FF:000057', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(181839, NULL, 'G3DSA:1.20.120.1080:FF:000009', NULL, NULL, 'Probable ATP-dependent RNA helicase DHX40', NULL, NULL, NULL, NULL, NULL, 4),
(181840, NULL, 'G3DSA:1.10.238.10:FF:000486', NULL, NULL, 'Probable calcium-binding protein CML44', NULL, NULL, NULL, NULL, NULL, 4),
(181841, NULL, 'G3DSA:1.20.58.900:FF:000039', NULL, NULL, 'RUN and FYVE domain-containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(181842, NULL, 'G3DSA:3.40.190.10:FF:000293', NULL, NULL, 'Probable sugar-binding lipoprotein lpqY', NULL, NULL, NULL, NULL, NULL, 4),
(181843, NULL, 'G3DSA:2.60.120.970:FF:000083', NULL, NULL, 'Putative Activin/Myostatin/TGF-beta-class TGF-beta signal molecule', NULL, NULL, NULL, NULL, NULL, 4),
(181844, NULL, 'G3DSA:1.10.510.10:FF:001024', NULL, NULL, 'AGC protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(181845, NULL, 'G3DSA:3.40.140.70:FF:000004', NULL, NULL, 'Ubiquitin-like modifier-activating enzyme atg7', NULL, NULL, NULL, NULL, NULL, 4),
(181846, NULL, 'G3DSA:1.20.920.10:FF:000047', NULL, NULL, 'Bromodomain-containing factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(181847, NULL, 'G3DSA:3.30.1510.10:FF:000005', NULL, NULL, 'Pugilist, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(181848, NULL, 'G3DSA:1.20.1160.11:FF:000011', NULL, NULL, 'Paired amphipathic helix protein Sin3-like 3', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(181849, NULL, 'G3DSA:3.40.800.10:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181850, NULL, 'G3DSA:3.40.50.620:FF:000770', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181851, NULL, 'G3DSA:3.40.50.10320:FF:000002', NULL, NULL, 'Probable N-acetylglucosaminyl-phosphatidylinositol de-N-acetylase', NULL, NULL, NULL, NULL, NULL, 4),
(181852, NULL, 'G3DSA:3.30.70.330:FF:002398', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181853, NULL, 'G3DSA:3.40.50.300:FF:001961', NULL, NULL, 'Multidrug resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(181854, NULL, 'G3DSA:2.40.50.140:FF:000028', NULL, NULL, 'Ribonuclease G', NULL, NULL, NULL, NULL, NULL, 4),
(181855, NULL, 'G3DSA:2.40.160.10:FF:000019', NULL, NULL, 'Outer membrane OprD family porin', NULL, NULL, NULL, NULL, NULL, 4),
(181856, NULL, 'G3DSA:3.30.420.40:FF:000772', NULL, NULL, 'Bifunctional 3-dehydroquinate synthase/phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(181857, NULL, 'G3DSA:3.30.160.60:FF:000280', NULL, NULL, 'PLAG1 like zinc finger 2', NULL, NULL, NULL, NULL, NULL, 4),
(181858, NULL, 'G3DSA:2.60.120.10:FF:000586', NULL, NULL, 'Crp/FNR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(181859, NULL, 'G3DSA:2.40.50.430:FF:000003', NULL, NULL, 'DNA polymerase delta, small subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181860, NULL, 'G3DSA:1.10.8.60:FF:000509', NULL, NULL, 'Vacuolar protein-sorting protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181861, NULL, 'G3DSA:2.10.25.10:FF:000820', NULL, NULL, 'CBN-MEC-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(181862, NULL, 'G3DSA:3.30.70.1820:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181863, NULL, 'G3DSA:1.10.510.10:FF:002648', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181864, NULL, 'G3DSA:2.130.10.10:FF:004996', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181865, NULL, 'G3DSA:3.10.150.10:FF:000005', NULL, NULL, 'Beta sliding clamp', NULL, NULL, NULL, NULL, NULL, 4),
(181866, NULL, 'G3DSA:4.10.530.10:FF:000002', NULL, NULL, 'Fibrinogen gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(181867, NULL, 'G3DSA:1.25.40.10:FF:002752', NULL, NULL, 'YALI0C23188p', NULL, NULL, NULL, NULL, NULL, 4),
(181868, NULL, 'G3DSA:2.60.40.60:FF:000497', NULL, NULL, 'DE-cadherin', NULL, NULL, NULL, NULL, NULL, 4),
(181869, NULL, 'G3DSA:3.30.200.20:FF:001744', NULL, NULL, 'Fibrillarin-like rRNA/tRNA 2''-O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(181870, NULL, 'G3DSA:1.10.565.10:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181871, NULL, 'G3DSA:3.30.70.2820:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181872, NULL, 'G3DSA:3.40.50.2000:FF:000789', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(181873, NULL, 'G3DSA:1.10.10.10:FF:000614', NULL, NULL, 'Unplaced genomic scaffold supercont1.238, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(181874, NULL, 'G3DSA:3.90.1290.10:FF:000041', NULL, NULL, 'VAB-10A protein', NULL, NULL, NULL, NULL, NULL, 4),
(181875, NULL, 'G3DSA:3.30.310.130:FF:000015', NULL, NULL, 'SUMO-specific peptidase 6b', NULL, NULL, NULL, NULL, NULL, 4),
(181876, NULL, 'G3DSA:1.20.920.30:FF:000042', NULL, NULL, 'YALI0E32857p', NULL, NULL, NULL, NULL, NULL, 4),
(181877, NULL, 'G3DSA:2.130.10.10:FF:004198', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(181878, NULL, 'G3DSA:3.40.50.1110:FF:000067', NULL, NULL, 'Acetylxylan esterase', NULL, NULL, NULL, NULL, NULL, 4),
(181879, NULL, 'G3DSA:3.30.160.60:FF:002180', NULL, NULL, 'Zinc finger protein 284', NULL, NULL, NULL, NULL, NULL, 4),
(181880, NULL, 'G3DSA:3.40.50.1820:FF:001241', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(181881, NULL, 'G3DSA:1.25.40.10:FF:001471', NULL, NULL, 'RNA polymerase-associated protein CTR9', NULL, NULL, NULL, NULL, NULL, 4),
(181882, NULL, 'G3DSA:3.40.50.300:FF:006632', NULL, NULL, 'Putative IS element ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(181883, NULL, 'G3DSA:3.40.50.300:FF:003439', NULL, NULL, 'ATP-dependent DNA helicase CHL1', NULL, NULL, NULL, NULL, NULL, 4),
(181884, NULL, 'G3DSA:2.40.30.10:FF:000067', NULL, NULL, '39S ribosomal protein L3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(181885, NULL, 'G3DSA:3.10.50.40:FF:000143', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(181886, NULL, 'G3DSA:3.30.70.330:FF:001881', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181887, NULL, 'G3DSA:3.30.200.20:FF:000463', NULL, NULL, 'Serine/threonine-protein kinase AFC2', NULL, NULL, NULL, NULL, NULL, 4),
(181888, NULL, 'G3DSA:3.30.40.10:FF:000032', NULL, NULL, 'Tripartite motif containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(181889, NULL, 'G3DSA:1.10.10.10:FF:002082', NULL, NULL, 'ADR025Wp', NULL, NULL, NULL, NULL, NULL, 4),
(181890, NULL, 'G3DSA:3.40.50.2300:FF:000334', NULL, NULL, 'Vomeronasal 2, receptor 56', NULL, NULL, NULL, NULL, NULL, 4),
(181891, NULL, 'G3DSA:3.30.160.60:FF:003276', NULL, NULL, 'Zinc finger protein 786', NULL, NULL, NULL, NULL, NULL, 4),
(181892, NULL, 'G3DSA:1.10.418.10:FF:000034', NULL, NULL, 'Fimbrin-2 like', NULL, NULL, NULL, NULL, NULL, 4),
(181893, NULL, 'G3DSA:2.40.70.10:FF:000417', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181894, NULL, 'G3DSA:1.20.1250.10:FF:000129', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181895, NULL, 'G3DSA:1.10.10.10:FF:000035', NULL, NULL, 'General transcription factor IIF subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(181896, NULL, 'G3DSA:2.40.128.30:FF:000001', NULL, NULL, 'Avidin-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(181897, NULL, 'G3DSA:2.30.30.40:FF:000267', NULL, NULL, 'E3 ubiquitin-protein ligase HECTD1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(181898, NULL, 'G3DSA:3.40.50.1820:FF:001365', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181899, NULL, 'G3DSA:1.20.1310.10:FF:000174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181900, NULL, 'G3DSA:1.10.1280.10:FF:000004', NULL, NULL, 'Hemocyanin subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(181901, NULL, 'G3DSA:3.40.50.720:FF:001513', NULL, NULL, 'Thiamine biosynthesis protein ThiF', NULL, NULL, NULL, NULL, NULL, 4),
(181902, NULL, 'G3DSA:2.80.10.50:FF:000154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181903, NULL, 'G3DSA:3.40.50.150:FF:001668', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181904, NULL, 'G3DSA:3.40.50.720:FF:000895', NULL, NULL, 'Uroporphyrinogen-III C-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(181905, NULL, 'G3DSA:1.20.1280.290:FF:000105', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(181906, NULL, 'G3DSA:1.10.560.10:FF:000122', NULL, NULL, 'TCP-1/cpn60 chaperonin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(181907, NULL, 'G3DSA:1.20.5.120:FF:000002', NULL, NULL, 'proteasome activator complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(181908, NULL, 'G3DSA:3.40.50.720:FF:001171', NULL, NULL, 'ARP protein (REF)', NULL, NULL, NULL, NULL, NULL, 4),
(181909, NULL, 'G3DSA:3.90.79.10:FF:000011', NULL, NULL, 'ADP-ribose pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(181910, NULL, 'G3DSA:2.40.50.90:FF:000159', NULL, NULL, 'AGAP004543-PA', NULL, NULL, NULL, NULL, NULL, 4),
(181911, NULL, 'G3DSA:4.10.110.10:FF:000010', NULL, NULL, 'LOC100145517 protein', NULL, NULL, NULL, NULL, NULL, 4),
(181912, NULL, 'G3DSA:3.40.50.720:FF:000232', NULL, NULL, 'Prephenate dehydrogenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(181913, NULL, 'G3DSA:1.10.132.30:FF:000033', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(181914, NULL, 'G3DSA:2.60.120.260:FF:000106', NULL, NULL, 'Beta-galactosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181915, NULL, 'G3DSA:1.20.1070.10:FF:001094', NULL, NULL, 'D(1) dopamine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(181916, NULL, 'G3DSA:3.40.910.10:FF:000028', NULL, NULL, 'Deoxyhypusine synthase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(181917, NULL, 'G3DSA:2.160.20.10:FF:000173', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(181918, NULL, 'G3DSA:1.20.58.980:FF:000001', NULL, NULL, 'Kinesin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181919, NULL, 'G3DSA:1.10.442.10:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181920, NULL, 'G3DSA:2.60.40.10:FF:003489', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181921, NULL, 'G3DSA:3.30.1370.30:FF:000011', NULL, NULL, '30S ribosomal protein S8, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(181922, NULL, 'G3DSA:1.10.510.10:FF:003497', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181923, NULL, 'G3DSA:3.90.226.10:FF:000236', NULL, NULL, '(3,5-dihydroxyphenyl)acetyl-CoA 1,2-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(181924, NULL, 'G3DSA:2.40.50.100:FF:000140', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(181925, NULL, 'G3DSA:2.40.50.1070:FF:000016', NULL, NULL, '23S rRNA (Uracil-5-)-methyltransferase RumA', NULL, NULL, NULL, NULL, NULL, 4),
(181926, NULL, 'G3DSA:1.25.10.10:FF:002924', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181927, NULL, 'G3DSA:2.60.120.200:FF:000690', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181928, NULL, 'G3DSA:3.40.250.10:FF:000028', NULL, NULL, 'Sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(181929, NULL, 'G3DSA:3.40.640.10:FF:000491', NULL, NULL, 'kynurenine/alpha-aminoadipate aminotransferase, mitochondrial-like isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(181930, NULL, 'G3DSA:3.40.50.150:FF:000819', NULL, NULL, 'Protein CBG14642', NULL, NULL, NULL, NULL, NULL, 4),
(181931, NULL, 'G3DSA:3.20.20.70:FF:000217', NULL, NULL, '3-dehydroquinate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(181932, NULL, 'G3DSA:2.120.10.80:FF:000015', NULL, NULL, 'host cell factor 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(181933, NULL, 'G3DSA:1.10.472.10:FF:000176', NULL, NULL, 'origin recognition complex subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(181934, NULL, 'G3DSA:3.30.559.70:FF:000063', NULL, NULL, 'Carnitine acyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181935, NULL, 'G3DSA:3.30.70.330:FF:000245', NULL, NULL, 'RNA-binding protein 33 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(181936, NULL, 'G3DSA:1.20.1560.10:FF:000658', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181937, NULL, 'G3DSA:3.90.1140.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181938, NULL, 'G3DSA:3.40.605.10:FF:000145', NULL, NULL, 'Aldehyde dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(181939, NULL, 'G3DSA:1.10.1170.10:FF:000013', NULL, NULL, 'Baculoviral IAP repeat-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(181940, NULL, 'G3DSA:3.30.160.60:FF:000403', NULL, NULL, 'Putative zinc finger protein 462', NULL, NULL, NULL, NULL, NULL, 4),
(181941, NULL, 'G3DSA:3.80.10.10:FF:000466', NULL, NULL, 'NLR family CARD domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(181942, NULL, 'G3DSA:2.30.42.10:FF:000600', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181943, NULL, 'G3DSA:3.30.160.60:FF:004237', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181944, NULL, 'G3DSA:1.10.565.10:FF:000094', NULL, NULL, 'Protein CBG10507', NULL, NULL, NULL, NULL, NULL, 4),
(181945, NULL, 'G3DSA:1.10.10.160:FF:000059', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(181946, NULL, 'G3DSA:3.40.50.800:FF:000037', NULL, NULL, 'GCN2p Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(181947, NULL, 'G3DSA:3.40.50.2300:FF:000997', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181948, NULL, 'G3DSA:2.60.40.10:FF:000055', NULL, NULL, 'roundabout homolog 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(181949, NULL, 'G3DSA:3.30.505.10:FF:000022', NULL, NULL, 'Growth factor receptor-bound protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(181950, NULL, 'G3DSA:1.25.10.10:FF:003200', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(181951, NULL, 'G3DSA:2.60.120.10:FF:000243', NULL, NULL, 'Phospholipase A2', NULL, NULL, NULL, NULL, NULL, 4),
(181952, NULL, 'G3DSA:2.130.10.10:FF:002523', NULL, NULL, 'Intraflagellar transport protein osm-1', NULL, NULL, NULL, NULL, NULL, 4),
(181953, NULL, 'G3DSA:3.40.720.10:FF:000216', NULL, NULL, 'DUF229 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(181954, NULL, 'G3DSA:3.30.460.10:FF:000125', NULL, NULL, 'DNA polymerase sigma-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(181955, NULL, 'G3DSA:2.130.10.10:FF:003933', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181956, NULL, 'G3DSA:3.40.30.10:FF:000340', NULL, NULL, 'Omega-class glutathione transferase', NULL, NULL, NULL, NULL, NULL, 4),
(181957, NULL, 'G3DSA:2.30.30.140:FF:000313', NULL, NULL, 'Excision repair cross-complementation group 6-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(181958, NULL, 'G3DSA:3.30.160.60:FF:006232', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181959, NULL, 'G3DSA:2.20.70.10:FF:000014', NULL, NULL, 'E3 ubiquitin-protein ligase SMURF1', NULL, NULL, NULL, NULL, NULL, 4),
(181960, NULL, 'G3DSA:3.40.50.150:FF:001770', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181961, NULL, 'G3DSA:1.20.5.340:FF:000040', NULL, NULL, 'GUK-holder, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(181962, NULL, 'G3DSA:1.25.40.10:FF:005181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181963, NULL, 'G3DSA:3.40.50.720:FF:002132', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(181964, NULL, 'G3DSA:1.10.3720.10:FF:000174', NULL, NULL, 'NitT/TauT family transport system permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(181965, NULL, 'G3DSA:3.30.1330.10:FF:000019', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(181966, NULL, 'G3DSA:3.30.40.10:FF:001908', NULL, NULL, 'Os12g0143750 protein', NULL, NULL, NULL, NULL, NULL, 4),
(181967, NULL, 'G3DSA:3.40.50.300:FF:003990', NULL, NULL, 'Si:ch73-63e15.2', NULL, NULL, NULL, NULL, NULL, 4),
(181968, NULL, 'G3DSA:2.60.120.200:FF:000358', NULL, NULL, 'Putative receptor kinase Lecrk', NULL, NULL, NULL, NULL, NULL, 4),
(181969, NULL, 'G3DSA:3.30.365.10:FF:000033', NULL, NULL, 'Nicotinate dehydrogenase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(181970, NULL, 'G3DSA:1.20.1070.10:FF:001655', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(181971, NULL, 'G3DSA:1.20.1410.10:FF:000007', NULL, NULL, 'Transmembrane protein 98', NULL, NULL, NULL, NULL, NULL, 4),
(181972, NULL, 'G3DSA:1.10.730.10:FF:000052', NULL, NULL, 'Valine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(181973, NULL, 'G3DSA:1.25.10.10:FF:001963', NULL, NULL, 'Serine/threonine-protein kinase atr', NULL, NULL, NULL, NULL, NULL, 4),
(181974, NULL, 'G3DSA:3.40.50.300:FF:004732', NULL, NULL, 'Protein CBR-GOA-1', NULL, NULL, NULL, NULL, NULL, 4),
(181975, NULL, 'G3DSA:2.30.130.10:FF:000008', NULL, NULL, 'Glutamate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(181976, NULL, 'G3DSA:3.30.1010.10:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181977, NULL, 'G3DSA:3.90.70.10:FF:000609', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181978, NULL, 'G3DSA:2.60.40.10:FF:000179', NULL, NULL, 'Myomesin 2', NULL, NULL, NULL, NULL, NULL, 4),
(181979, NULL, 'G3DSA:1.20.58.60:FF:000401', NULL, NULL, 'Dystrophin-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(181980, NULL, 'G3DSA:2.60.40.2430:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181981, NULL, 'G3DSA:3.60.20.30:FF:000001', NULL, NULL, 'Isoaspartyl peptidase/L-asparaginase', NULL, NULL, NULL, NULL, NULL, 4),
(181982, NULL, 'G3DSA:3.30.720.210:FF:000014', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(181983, NULL, 'G3DSA:1.10.3210.10:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181984, NULL, 'G3DSA:4.10.400.10:FF:000341', NULL, NULL, 'Vitellogenin receptor', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(181985, NULL, 'G3DSA:1.25.40.10:FF:003371', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g13040, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(181986, NULL, 'G3DSA:3.30.200.20:FF:002363', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(181987, NULL, 'G3DSA:3.40.47.10:FF:000221', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181988, NULL, 'G3DSA:2.40.340.10:FF:000005', NULL, NULL, 'Molybdopterin molybdenumtransferase MoeA', NULL, NULL, NULL, NULL, NULL, 4),
(181989, NULL, 'G3DSA:3.90.1150.10:FF:000003', NULL, NULL, 'Serine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(181990, NULL, 'G3DSA:3.30.70.330:FF:001779', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181991, NULL, 'G3DSA:3.90.550.50:FF:000147', NULL, NULL, 'Glycosyltransferase family 31 protein', NULL, NULL, NULL, NULL, NULL, 4),
(181992, NULL, 'G3DSA:3.30.200.20:FF:001183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181993, NULL, 'G3DSA:3.30.40.10:FF:001448', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(181994, NULL, 'G3DSA:4.10.280.10:FF:000123', NULL, NULL, 'Transcription factor bHLH113', NULL, NULL, NULL, NULL, NULL, 4),
(181995, NULL, 'G3DSA:3.30.479.20:FF:000036', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(181996, NULL, 'G3DSA:3.20.20.70:FF:000554', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181997, NULL, 'G3DSA:3.40.50.2300:FF:001514', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(181998, NULL, 'G3DSA:1.25.40.10:FF:005169', NULL, NULL, 'Putative UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SEC', NULL, NULL, NULL, NULL, NULL, 4),
(181999, NULL, 'G3DSA:1.10.1450.10:FF:000170', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(182000, NULL, 'G3DSA:2.130.10.10:FF:000600', NULL, NULL, 'Protein ROOT INITIATION DEFECTIVE 3', NULL, NULL, NULL, NULL, NULL, 4),
(182001, NULL, 'G3DSA:2.60.120.620:FF:000017', NULL, NULL, 'Transmembrane prolyl 4-hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(182002, NULL, 'G3DSA:1.10.20.10:FF:000227', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182003, NULL, 'G3DSA:2.130.10.10:FF:001112', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1', NULL, NULL, NULL, NULL, NULL, 4),
(182004, NULL, 'G3DSA:3.10.20.90:FF:000757', NULL, NULL, 'PDZ domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(182005, NULL, 'G3DSA:3.40.50.300:FF:006289', NULL, NULL, 'Putative tetracycline resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(182006, NULL, 'G3DSA:3.40.30.10:FF:000126', NULL, NULL, 'Protein disulfide-isomerase A4', NULL, NULL, NULL, NULL, NULL, 4),
(182007, NULL, 'G3DSA:1.25.40.180:FF:000067', NULL, NULL, 'Eukaryotic translation initiation factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(182008, NULL, 'G3DSA:3.30.420.10:FF:000448', NULL, NULL, 'DNA polymerase theta', NULL, NULL, NULL, NULL, NULL, 4),
(182009, NULL, 'G3DSA:2.40.160.50:FF:000003', NULL, NULL, 'Outer membrane protein, OMP85 family', NULL, NULL, NULL, NULL, NULL, 4),
(182010, NULL, 'G3DSA:3.30.710.10:FF:000212', NULL, NULL, 'Os02g0225100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(182011, NULL, 'G3DSA:1.10.150.20:FF:000072', NULL, NULL, 'Pre-mRNA-splicing helicase BRR2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182012, NULL, 'G3DSA:3.40.50.300:FF:002023', NULL, NULL, 'ATP-dependent DNA helicase Q1', NULL, NULL, NULL, NULL, NULL, 4),
(182013, NULL, 'G3DSA:3.40.50.720:FF:001064', NULL, NULL, '(+)-neomenthol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(182014, NULL, 'G3DSA:3.30.70.330:FF:002050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182015, NULL, 'G3DSA:3.30.70.330:FF:001431', NULL, NULL, 'Os05g0303600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(182016, NULL, 'G3DSA:2.60.40.1170:FF:000025', NULL, NULL, 'AP-5 complex subunit mu isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(182017, NULL, 'G3DSA:3.40.50.880:FF:000139', NULL, NULL, 'Imidazole glycerol phosphate synthase hisHF', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(182018, NULL, 'G3DSA:3.30.160.60:FF:003725', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182019, NULL, 'G3DSA:2.130.10.10:FF:005390', NULL, NULL, 'RaBConnectin related', NULL, NULL, NULL, NULL, NULL, 4),
(182020, NULL, 'G3DSA:1.25.40.10:FF:000279', NULL, NULL, 'Tetratricopeptide repeat domain 21A', NULL, NULL, NULL, NULL, NULL, 4),
(182021, NULL, 'G3DSA:2.60.40.1470:FF:000002', NULL, NULL, 'F-box only protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(182022, NULL, 'G3DSA:2.60.210.10:FF:000019', NULL, NULL, 'TNF-receptor-associated factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(182023, NULL, 'G3DSA:3.30.160.60:FF:003832', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182024, NULL, 'G3DSA:2.130.10.10:FF:006002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182025, NULL, 'G3DSA:3.40.50.300:FF:006401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182026, NULL, 'G3DSA:2.60.120.200:FF:000459', NULL, NULL, 'Laminin, alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(182027, NULL, 'G3DSA:3.40.50.10310:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182028, NULL, 'G3DSA:1.10.287.110:FF:000427', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182029, NULL, 'G3DSA:3.30.160.60:FF:000055', NULL, NULL, 'B-cell lymphoma/leukemia 11A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(182030, NULL, 'G3DSA:1.20.900.10:FF:000057', NULL, NULL, 'Rho guanine nucleotide exchange factor 38', NULL, NULL, NULL, NULL, NULL, 4),
(182031, NULL, 'G3DSA:3.40.50.10330:FF:000123', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(182032, NULL, 'G3DSA:3.30.499.10:FF:000028', NULL, NULL, 'Aconitate hydratase, hypothetical (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(182033, NULL, 'G3DSA:3.30.70.890:FF:000053', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(182034, NULL, 'G3DSA:1.50.10.10:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182035, NULL, 'G3DSA:2.60.40.10:FF:002657', NULL, NULL, 'Brother of ihog, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(182036, NULL, 'G3DSA:1.20.120.350:FF:000267', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182037, NULL, 'G3DSA:3.30.110.20:FF:000012', NULL, NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(182038, NULL, 'G3DSA:2.60.40.10:FF:003169', NULL, NULL, 'FiLamiN (Actin binding protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(182039, NULL, 'G3DSA:2.60.40.150:FF:000542', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(182040, NULL, 'G3DSA:1.20.1560.10:FF:000439', NULL, NULL, 'ATP-binding cassette transporter, subfamily B, member 21, group MDR/PGP protein PpABCB21', NULL, NULL, NULL, NULL, NULL, 4),
(182041, NULL, 'G3DSA:3.40.50.150:FF:000606', NULL, NULL, 'Hemolysin (Tly)', NULL, NULL, NULL, NULL, NULL, 4),
(182042, NULL, 'G3DSA:1.20.1070.10:FF:000795', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(182043, NULL, 'G3DSA:3.40.50.410:FF:000139', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(182044, NULL, 'G3DSA:3.30.230.10:FF:000170', NULL, NULL, 'Galactokinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(182045, NULL, 'G3DSA:3.10.105.10:FF:000035', NULL, NULL, 'Dipeptide-binding ABC transporter, periplasmic substrate-binding component', NULL, NULL, NULL, NULL, NULL, 4),
(182046, NULL, 'G3DSA:3.40.50.300:FF:002130', NULL, NULL, 'DNA mismatch repair protein MSH3', NULL, NULL, NULL, NULL, NULL, 4),
(182047, NULL, 'G3DSA:3.20.180.20:FF:000007', NULL, NULL, 'Dynein heavy chain domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(182048, NULL, 'G3DSA:3.40.395.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182049, NULL, 'G3DSA:1.10.287.210:FF:000002', NULL, NULL, 'Syncytin-2', NULL, NULL, NULL, NULL, NULL, 4),
(182050, NULL, 'G3DSA:3.10.20.90:FF:000864', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(182051, NULL, 'G3DSA:2.60.40.60:FF:000059', NULL, NULL, 'FAT atypical cadherin 3', NULL, NULL, NULL, NULL, NULL, 4),
(182052, NULL, 'G3DSA:2.60.40.10:FF:003276', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182053, NULL, 'G3DSA:3.40.50.300:FF:004058', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(182054, NULL, 'G3DSA:1.10.555.10:FF:000043', NULL, NULL, 'Rho GTPase activator Rga', NULL, NULL, NULL, NULL, NULL, 4),
(182055, NULL, 'G3DSA:1.10.238.10:FF:000935', NULL, NULL, 'Penta-EF hand domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(182056, NULL, 'G3DSA:1.10.470.10:FF:000008', NULL, NULL, 'Variant surface glycoprotein (VSG), putative', NULL, NULL, NULL, NULL, NULL, 4),
(182057, NULL, 'G3DSA:3.20.20.70:FF:000661', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182058, NULL, 'G3DSA:3.30.497.10:FF:000103', NULL, NULL, 'Serpin B10', NULL, NULL, NULL, NULL, NULL, 4),
(182059, NULL, 'G3DSA:3.40.140.10:FF:000144', NULL, NULL, 'Cytidine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(182060, NULL, 'G3DSA:2.60.40.60:FF:000053', NULL, NULL, 'FAT atypical cadherin 3', NULL, NULL, NULL, NULL, NULL, 4),
(182061, NULL, 'G3DSA:4.10.280.10:FF:000016', NULL, NULL, 'Sterol regulatory element-binding transcription factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(182062, NULL, 'G3DSA:1.20.5.110:FF:000224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182063, NULL, 'G3DSA:1.20.1250.20:FF:001526', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182064, NULL, 'G3DSA:3.30.160.60:FF:006468', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182065, NULL, 'G3DSA:1.25.40.470:FF:000047', NULL, NULL, 'Coatomer subunit beta''-3', NULL, NULL, NULL, NULL, NULL, 4),
(182066, NULL, 'G3DSA:2.40.30.10:FF:000522', NULL, NULL, 'Elongation factor Tu GTP binding domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(182067, NULL, 'G3DSA:3.30.200.20:FF:000238', NULL, NULL, 'Putative serine/threonine-protein kinase ULK3', NULL, NULL, NULL, NULL, NULL, 4),
(182068, NULL, 'G3DSA:3.30.830.10:FF:000266', NULL, NULL, 'Mitochondrial presequence protease', NULL, NULL, NULL, NULL, NULL, 4),
(182069, NULL, 'G3DSA:1.25.40.20:FF:001917', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182070, NULL, 'G3DSA:1.20.58.80:FF:000053', NULL, NULL, 'STAM-binding protein b', NULL, NULL, NULL, NULL, NULL, 4),
(182071, NULL, 'G3DSA:3.30.70.1230:FF:000050', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(182072, NULL, 'G3DSA:1.25.10.10:FF:003099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182073, NULL, 'G3DSA:1.25.10.10:FF:001986', NULL, NULL, 'Putative pumilio/PUF RNA binding protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(182074, NULL, 'G3DSA:3.40.50.1000:FF:000613', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182075, NULL, 'G3DSA:2.40.30.10:FF:000415', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(182076, NULL, 'G3DSA:3.30.420.610:FF:000010', NULL, NULL, 'Meiosis regulator and mRNA stability factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(182077, NULL, 'G3DSA:3.30.40.10:FF:002061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182078, NULL, 'G3DSA:1.10.238.20:FF:000034', NULL, NULL, 'Odorant-binding protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(182079, NULL, 'G3DSA:3.30.1490.20:FF:000056', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(182080, NULL, 'G3DSA:2.30.29.30:FF:000862', NULL, NULL, 'Ran-specific GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(182081, NULL, 'G3DSA:1.10.150.240:FF:000012', NULL, NULL, 'Glycerol-1-phosphate phosphohydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(182082, NULL, 'G3DSA:3.40.50.410:FF:000358', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182083, NULL, 'G3DSA:2.30.42.10:FF:000151', NULL, NULL, 'Still life isoforms C/SIF type 2', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(182084, NULL, 'G3DSA:2.130.10.10:FF:002416', NULL, NULL, 'Small nucleolar ribonucleoprotein complex subunit (SOF1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(182085, NULL, 'G3DSA:3.90.1410.10:FF:000023', NULL, NULL, 'YHL039W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(182086, NULL, 'G3DSA:3.30.1370.10:FF:000117', NULL, NULL, 'Poly(rC) binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(182087, NULL, 'G3DSA:1.20.1070.10:FF:000688', NULL, NULL, 'Neuropeptide FF receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(182088, NULL, 'G3DSA:2.130.10.10:FF:001904', NULL, NULL, 'Dynein intermediate chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182089, NULL, 'G3DSA:3.80.10.10:FF:002607', NULL, NULL, 'Nuclear RNA export factor 7', NULL, NULL, NULL, NULL, NULL, 4),
(182090, NULL, 'G3DSA:3.90.70.10:FF:000486', NULL, NULL, 'probable ubiquitin carboxyl-terminal hydrolase FAF-X isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(182091, NULL, 'G3DSA:2.60.98.50:FF:000003', NULL, NULL, 'Envelopment polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(182092, NULL, 'G3DSA:1.25.10.10:FF:000682', NULL, NULL, 'Putative splicing factor 3B subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(182093, NULL, 'G3DSA:2.60.40.10:FF:003383', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182094, NULL, 'G3DSA:1.20.1070.10:FF:001088', NULL, NULL, 'Rhodopsin, GQ-coupled', NULL, NULL, NULL, NULL, NULL, 4),
(182095, NULL, 'G3DSA:3.40.50.300:FF:004491', NULL, NULL, 'TFIIH basal transcription factor complex helicase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(182096, NULL, 'G3DSA:3.80.10.10:FF:003552', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(182097, NULL, 'G3DSA:3.30.200.60:FF:000003', NULL, NULL, 'Ubiquitin thioesterase OTUB1', NULL, NULL, NULL, NULL, NULL, 4),
(182098, NULL, 'G3DSA:2.30.30.100:FF:000088', NULL, NULL, 'Small nuclear ribonucleoprotein Sm-G', NULL, NULL, NULL, NULL, NULL, 4),
(182099, NULL, 'G3DSA:2.80.10.50:FF:000284', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(182100, NULL, 'G3DSA:3.55.40.20:FF:000012', NULL, NULL, 'Superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(182101, NULL, 'G3DSA:1.20.1560.10:FF:000670', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182102, NULL, 'G3DSA:3.30.70.660:FF:000001', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(182103, NULL, 'G3DSA:3.30.428.10:FF:000005', NULL, NULL, 'Histidine triad nucleotide-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(182104, NULL, 'G3DSA:1.20.5.1190:FF:000006', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(182105, NULL, 'G3DSA:3.90.226.10:FF:000337', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(182106, NULL, 'G3DSA:1.10.287.470:FF:000052', NULL, NULL, 'RND multidrug efflux membrane fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(182107, NULL, 'G3DSA:3.40.50.2020:FF:000109', NULL, NULL, 'Orotate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(182108, NULL, 'G3DSA:3.30.70.330:FF:002847', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182109, NULL, 'G3DSA:2.130.10.10:FF:004092', NULL, NULL, 'Uncharacterized WD repeat-containing protein C1A6.02', NULL, NULL, NULL, NULL, NULL, 4),
(182110, NULL, 'G3DSA:2.60.40.60:FF:000160', NULL, NULL, 'cadherin-23 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(182111, NULL, 'G3DSA:2.30.29.30:FF:000070', NULL, NULL, 'Neurofibromin 1', NULL, NULL, NULL, NULL, NULL, 4),
(182112, NULL, 'G3DSA:1.10.472.130:FF:000092', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182113, NULL, 'G3DSA:2.40.10.480:FF:000009', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(182114, NULL, 'G3DSA:2.30.39.10:FF:000137', NULL, NULL, 'Serpin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182115, NULL, 'G3DSA:2.30.39.10:FF:000025', NULL, NULL, 'Serpin 77Bb', NULL, NULL, NULL, NULL, NULL, 4),
(182116, NULL, 'G3DSA:3.40.720.10:FF:000115', NULL, NULL, 'GPI ethanolamine phosphate transferase 3', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(182117, NULL, 'G3DSA:1.20.1270.280:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182118, NULL, 'G3DSA:2.10.110.10:FF:000102', NULL, NULL, 'LIM and SH3 domain protein Lasp', NULL, NULL, NULL, NULL, NULL, 4),
(182119, NULL, 'G3DSA:1.25.40.10:FF:002319', NULL, NULL, 'DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(182120, NULL, 'G3DSA:2.70.70.10:FF:000034', NULL, NULL, 'Lipoprotein NlpD', NULL, NULL, NULL, NULL, NULL, 4),
(182121, NULL, 'G3DSA:3.40.50.720:FF:001749', NULL, NULL, 'Putative zinc-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(182122, NULL, 'G3DSA:2.30.180.10:FF:000051', NULL, NULL, 'YLR001C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(182123, NULL, 'G3DSA:3.80.10.10:FF:001410', NULL, NULL, 'PRAME family member 20', NULL, NULL, NULL, NULL, NULL, 4),
(182124, NULL, 'G3DSA:3.40.50.1110:FF:000168', NULL, NULL, 'Phospholipase B1, membrane-associated', NULL, NULL, NULL, NULL, NULL, 4),
(182125, NULL, 'G3DSA:3.30.160.60:FF:000847', NULL, NULL, 'Putative zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(182126, NULL, 'G3DSA:2.120.10.30:FF:000011', NULL, NULL, 'Teneurin transmembrane protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(182127, NULL, 'G3DSA:3.40.50.2000:FF:000340', NULL, NULL, 'Phosphatidylinositol N-acetylglucosaminyltransferase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(182128, NULL, 'G3DSA:3.50.7.10:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182129, NULL, 'G3DSA:1.10.418.10:FF:000135', NULL, NULL, 'Domain_of_Uncharacterized_Function_(DUF1042)_-_pu tative', NULL, NULL, NULL, NULL, NULL, 4),
(182130, NULL, 'G3DSA:2.40.50.140:FF:000023', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(182131, NULL, 'G3DSA:1.20.58.390:FF:000049', NULL, NULL, 'AcetylCholine Receptor', NULL, NULL, NULL, NULL, NULL, 4),
(182132, NULL, 'G3DSA:1.25.40.10:FF:003264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182133, NULL, 'G3DSA:1.10.10.10:FF:000513', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(182134, NULL, 'G3DSA:2.60.40.150:FF:000435', NULL, NULL, 'Double C2-like domains, alpha', NULL, NULL, NULL, NULL, NULL, 4),
(182135, NULL, 'G3DSA:1.10.555.10:FF:000155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182136, NULL, 'G3DSA:1.10.8.60:FF:000408', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182137, NULL, 'G3DSA:3.40.50.300:FF:003546', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182138, NULL, 'G3DSA:2.60.120.260:FF:000005', NULL, NULL, 'Netrin G1', NULL, NULL, NULL, NULL, NULL, 4),
(182139, NULL, 'G3DSA:3.40.50.2300:FF:000093', NULL, NULL, 'L-arabinose-binding periplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(182140, NULL, 'G3DSA:1.10.150.50:FF:000075', NULL, NULL, 'Serine/threonine-protein kinase STE11', NULL, NULL, NULL, NULL, NULL, 4),
(182141, NULL, 'G3DSA:1.10.2000.10:FF:000029', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(182142, NULL, 'G3DSA:3.80.10.10:FF:001186', NULL, NULL, 'GL12775', NULL, NULL, NULL, NULL, NULL, 4),
(182143, NULL, 'G3DSA:1.10.1450.10:FF:000063', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(182144, NULL, 'G3DSA:3.80.10.10:FF:000786', NULL, NULL, 'Preferentially-expressed antigen in melanoma', NULL, NULL, NULL, NULL, NULL, 4),
(182145, NULL, 'G3DSA:3.60.60.20:FF:000001', NULL, NULL, 'Phospholipase B-like', NULL, NULL, NULL, NULL, NULL, 4),
(182146, NULL, 'G3DSA:1.10.287.110:FF:000197', NULL, NULL, 'DnaJ domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(182147, NULL, 'G3DSA:2.60.120.260:FF:000550', NULL, NULL, 'Beta-glucuronidase', NULL, NULL, NULL, NULL, NULL, 4),
(182148, NULL, 'G3DSA:1.25.10.10:FF:000570', NULL, NULL, 'Ubiquitin-protein ligase, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(182149, NULL, 'G3DSA:2.60.120.200:FF:000678', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182150, NULL, 'G3DSA:3.40.50.2000:FF:000126', NULL, NULL, 'Glycosyltransferase 1 domain containing 1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(182151, NULL, 'G3DSA:3.30.200.20:FF:000019', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(182152, NULL, 'G3DSA:3.30.70.1020:FF:000009', NULL, NULL, 'Related to alpha,alpha-trehalose-phosphate synthase, 115 KD subunit', NULL, NULL, NULL, NULL, NULL, 4),
(182153, NULL, 'G3DSA:1.20.1300.20:FF:000002', NULL, NULL, 'Ubiquitin thioesterase otubain-like', NULL, NULL, NULL, NULL, NULL, 4),
(182154, NULL, 'G3DSA:3.30.70.360:FF:000029', NULL, NULL, 'Dug2p', NULL, NULL, NULL, NULL, NULL, 4),
(182155, NULL, 'G3DSA:3.10.20.870:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182156, NULL, 'G3DSA:3.40.50.300:FF:002815', NULL, NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(182157, NULL, 'G3DSA:3.40.140.10:FF:000014', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit F', NULL, NULL, NULL, NULL, NULL, 4),
(182158, NULL, 'G3DSA:3.30.70.2820:FF:000004', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(182159, NULL, 'G3DSA:1.25.10.10:FF:002132', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(182160, NULL, 'G3DSA:3.10.100.10:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182161, NULL, 'G3DSA:1.10.8.1220:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182162, NULL, 'G3DSA:1.10.418.20:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182163, NULL, 'G3DSA:3.40.50.300:FF:008217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182164, NULL, 'G3DSA:3.40.50.1240:FF:000090', NULL, NULL, '6-phosphofructo-2-kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(182165, NULL, 'G3DSA:2.40.40.20:FF:000014', NULL, NULL, 'NADH-quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(182166, NULL, 'G3DSA:2.130.10.10:FF:000730', NULL, NULL, 'Chromosome 15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(182167, NULL, 'G3DSA:3.90.930.12:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182168, NULL, 'G3DSA:1.20.5.4770:FF:000001', NULL, NULL, 'Zinc finger AN1-type containing 6', NULL, NULL, NULL, NULL, NULL, 4),
(182169, NULL, 'G3DSA:3.60.40.10:FF:000351', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(182170, NULL, 'G3DSA:3.10.110.10:FF:000345', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182171, NULL, 'G3DSA:3.40.30.10:FF:000233', NULL, NULL, 'Elongation factor 1-gamma', NULL, NULL, NULL, NULL, NULL, 4),
(182172, NULL, 'G3DSA:1.10.238.10:FF:000250', NULL, NULL, 'reticulocalbin-1', NULL, NULL, NULL, NULL, NULL, 4),
(182173, NULL, 'G3DSA:3.40.50.300:FF:007817', NULL, NULL, 'AGAP006939-PA', NULL, NULL, NULL, NULL, NULL, 4),
(182174, NULL, 'G3DSA:1.10.10.350:FF:000015', NULL, NULL, 'Glutamate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(182175, NULL, 'G3DSA:3.30.830.10:FF:000047', NULL, NULL, 'M16 family peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(182176, NULL, 'G3DSA:1.25.40.20:FF:000164', NULL, NULL, 'Mindbomb E3 ubiquitin protein ligase 1', NULL, NULL, NULL, NULL, NULL, 4),
(182177, NULL, 'G3DSA:2.60.40.150:FF:000654', NULL, NULL, 'Copine 6', NULL, NULL, NULL, NULL, NULL, 4),
(182178, NULL, 'G3DSA:3.50.50.60:FF:001193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182179, NULL, 'G3DSA:3.90.550.50:FF:000035', NULL, NULL, 'Fringe glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(182180, NULL, 'G3DSA:3.40.50.300:FF:004035', NULL, NULL, 'tRNA isopentenyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(182181, NULL, 'G3DSA:3.40.50.10130:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182182, NULL, 'G3DSA:3.60.10.10:FF:000175', NULL, NULL, 'Deoxyribonuclease 1 like 2', NULL, NULL, NULL, NULL, NULL, 4),
(182183, NULL, 'G3DSA:3.90.950.10:FF:000014', NULL, NULL, 'Inosine triphosphate pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(182184, NULL, 'G3DSA:3.40.50.1000:FF:000490', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(182185, NULL, 'G3DSA:3.30.70.340:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182186, NULL, 'G3DSA:3.30.559.10:FF:000197', NULL, NULL, 'Carnitine O-palmitoyltransferase II, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182187, NULL, 'G3DSA:1.50.10.10:FF:000045', NULL, NULL, 'Alpha-fucosidase A', NULL, NULL, NULL, NULL, NULL, 4),
(182188, NULL, 'G3DSA:3.40.630.30:FF:000440', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182189, NULL, 'G3DSA:1.25.40.10:FF:000521', NULL, NULL, 'ETO1-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(182190, NULL, 'G3DSA:3.10.100.10:FF:000283', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182191, NULL, 'G3DSA:3.30.450.20:FF:000498', NULL, NULL, 'Response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(182192, NULL, 'G3DSA:3.30.160.60:FF:004214', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182193, NULL, 'G3DSA:3.90.550.10:FF:000607', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(182194, NULL, 'G3DSA:1.10.238.10:FF:000149', NULL, NULL, 'Mitochondrial calcium uptake family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(182195, NULL, 'G3DSA:1.10.510.10:FF:002547', NULL, NULL, 'Protein O-mannose kinase', NULL, NULL, NULL, NULL, NULL, 4),
(182196, NULL, 'G3DSA:1.10.1170.10:FF:000018', NULL, NULL, 'X-linked inhibitor of apoptosis', NULL, NULL, NULL, NULL, NULL, 4),
(182197, NULL, 'G3DSA:2.30.30.380:FF:000019', NULL, NULL, 'Calpain 15', NULL, NULL, NULL, NULL, NULL, 4),
(182198, NULL, 'G3DSA:3.30.70.100:FF:000182', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182199, NULL, 'G3DSA:1.10.260.100:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182200, NULL, 'G3DSA:3.40.395.10:FF:000049', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(182201, NULL, 'G3DSA:2.60.120.230:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182202, NULL, 'G3DSA:1.20.58.100:FF:000007', NULL, NULL, 'L-aspartate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(182203, NULL, 'G3DSA:3.20.20.40:FF:000006', NULL, NULL, 'Glucanase', NULL, NULL, NULL, NULL, NULL, 4),
(182204, NULL, 'G3DSA:2.130.10.10:FF:001000', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(182205, NULL, 'G3DSA:1.20.58.60:FF:000862', NULL, NULL, 'Si:ch211-207i1.2', NULL, NULL, NULL, NULL, NULL, 4),
(182206, NULL, 'G3DSA:1.10.472.130:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182207, NULL, 'G3DSA:3.10.310.10:FF:000001', NULL, NULL, 'Diaminopimelate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(182208, NULL, 'G3DSA:1.10.510.10:FF:003492', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182209, NULL, 'G3DSA:3.30.505.10:FF:000264', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182210, NULL, 'G3DSA:3.30.70.330:FF:002162', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182211, NULL, 'G3DSA:3.30.450.50:FF:000041', NULL, NULL, 'vesicle-associated membrane protein 7 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(182212, NULL, 'G3DSA:1.20.1070.10:FF:001195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182213, NULL, 'G3DSA:2.60.40.10:FF:004681', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182214, NULL, 'G3DSA:3.40.50.720:FF:001194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182215, NULL, 'G3DSA:3.30.70.330:FF:001650', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182216, NULL, 'G3DSA:1.10.274.30:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182217, NULL, 'G3DSA:3.30.60.190:FF:000004', NULL, NULL, 'HIT-type Zinc finger family protein', NULL, NULL, NULL, NULL, NULL, 4),
(182218, NULL, 'G3DSA:3.30.420.10:FF:000229', NULL, NULL, 'exonuclease 3''-5'' domain-containing protein 2 isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(182219, NULL, 'G3DSA:2.60.40.10:FF:003388', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182220, NULL, 'G3DSA:1.10.510.10:FF:002199', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(182221, NULL, 'G3DSA:1.20.1250.20:FF:000222', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(182222, NULL, 'G3DSA:2.30.42.10:FF:000044', NULL, NULL, 'Multiple PDZ domain protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(182223, NULL, 'G3DSA:2.40.70.10:FF:000412', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182224, NULL, 'G3DSA:3.40.710.10:FF:000053', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(182225, NULL, 'G3DSA:2.40.128.20:FF:000015', NULL, NULL, 'Complement component C8 gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(182226, NULL, 'G3DSA:3.40.50.1440:FF:000161', NULL, NULL, 'Beta_tubulin,putative', NULL, NULL, NULL, NULL, NULL, 4),
(182227, NULL, 'G3DSA:1.10.510.10:FF:002204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182228, NULL, 'G3DSA:3.30.200.20:FF:001306', NULL, NULL, 'Protein kinase domain containing protein expressed', NULL, NULL, NULL, NULL, NULL, 4),
(182229, NULL, 'G3DSA:3.40.50.300:FF:007705', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182230, NULL, 'G3DSA:3.40.50.12780:FF:000178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182231, NULL, 'G3DSA:3.40.50.10860:FF:000046', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(182232, NULL, 'G3DSA:3.30.230.130:FF:000008', NULL, NULL, 'anaphase-promoting complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(182233, NULL, 'G3DSA:3.40.50.1010:FF:000150', NULL, NULL, 'Flap endonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(182234, NULL, 'G3DSA:3.30.930.10:FF:000195', NULL, NULL, 'Asparagine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(182235, NULL, 'G3DSA:1.25.40.10:FF:002314', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g66500, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(182236, NULL, 'G3DSA:3.30.160.60:FF:002421', NULL, NULL, 'Zinc finger protein 347', NULL, NULL, NULL, NULL, NULL, 4),
(182237, NULL, 'G3DSA:3.30.1330.20:FF:000005', NULL, NULL, 'Cell division protein FtsZ', NULL, NULL, NULL, NULL, NULL, 4),
(182238, NULL, 'G3DSA:2.60.40.150:FF:000547', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182239, NULL, 'G3DSA:2.40.50.140:FF:000461', NULL, NULL, 'Single-stranded DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(182240, NULL, 'G3DSA:2.40.30.10:FF:000308', NULL, NULL, 'Nitric oxide synthase, inducible', NULL, NULL, NULL, NULL, NULL, 4),
(182241, NULL, 'G3DSA:3.30.420.110:FF:000080', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(182242, NULL, 'G3DSA:1.10.510.10:FF:001928', NULL, NULL, 'RIO-type serine/threonine-protein kinase Rio2', NULL, NULL, NULL, NULL, NULL, 4),
(182243, NULL, 'G3DSA:2.60.40.60:FF:000952', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182244, NULL, 'G3DSA:3.60.10.10:FF:000068', NULL, NULL, 'Endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(182245, NULL, 'G3DSA:3.40.30.10:FF:000918', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182246, NULL, 'G3DSA:3.40.50.1580:FF:000056', NULL, NULL, 'S-methyl-5''-thioadenosine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(182247, NULL, 'G3DSA:3.20.20.140:FF:000091', NULL, NULL, 'Probable adenosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(182248, NULL, 'G3DSA:3.10.100.10:FF:000390', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182249, NULL, 'G3DSA:2.30.30.210:FF:000014', NULL, NULL, 'Ribonuclease P protein subunit p29', NULL, NULL, NULL, NULL, NULL, 4),
(182250, NULL, 'G3DSA:3.40.50.200:FF:000189', NULL, NULL, 'Surface layer-associated STABLE protease, conjectural', NULL, NULL, NULL, NULL, NULL, 4),
(182251, NULL, 'G3DSA:2.60.120.10:FF:000355', NULL, NULL, 'cGMP-dependent protein kinase, isozyme 2 forms cD4/T1/T3A/T3B-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(182252, NULL, 'G3DSA:3.30.160.60:FF:001797', NULL, NULL, 'Zinc finger protein 197', NULL, NULL, NULL, NULL, NULL, 4),
(182253, NULL, 'G3DSA:2.10.110.10:FF:000091', NULL, NULL, 'Sciellin', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(182254, NULL, 'G3DSA:1.20.1110.10:FF:000187', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182255, NULL, 'G3DSA:3.30.70.330:FF:001543', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182256, NULL, 'G3DSA:2.70.170.10:FF:000261', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182257, NULL, 'G3DSA:2.60.40.10:FF:005642', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182258, NULL, 'G3DSA:1.25.10.10:FF:002475', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182259, NULL, 'G3DSA:3.40.50.300:FF:000106', NULL, NULL, 'Adenylate kinase mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(182260, NULL, 'G3DSA:2.60.169.10:FF:000001', NULL, NULL, 'Capsid protein F', NULL, NULL, NULL, NULL, NULL, 4),
(182261, NULL, 'G3DSA:1.20.1280.290:FF:000004', NULL, NULL, 'Sugar transporter SWEET', NULL, NULL, NULL, NULL, NULL, 4),
(182262, NULL, 'G3DSA:2.60.40.790:FF:000048', NULL, NULL, 'Very-long-chain (3R)-3-hydroxyacyl-CoA dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(182263, NULL, 'G3DSA:2.130.10.10:FF:003821', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(182264, NULL, 'G3DSA:2.40.420.20:FF:000043', NULL, NULL, 'Component of multidrug efflux system', NULL, NULL, NULL, NULL, NULL, 4),
(182265, NULL, 'G3DSA:1.25.10.10:FF:002368', NULL, NULL, 'RNA-binding protein of the pumilio family', NULL, NULL, NULL, NULL, NULL, 4),
(182266, NULL, 'G3DSA:3.20.10.10:FF:000064', NULL, NULL, 'Branched chain amino-acid transaminase 1, cytosolic', NULL, NULL, NULL, NULL, NULL, 4),
(182267, NULL, 'G3DSA:1.20.58.810:FF:000001', NULL, NULL, 'Photosystem II lipoprotein Psb27', NULL, NULL, NULL, NULL, NULL, 4),
(182268, NULL, 'G3DSA:3.40.50.11710:FF:000003', NULL, NULL, 'Cyclo(L-leucyl-L-phenylalanyl) synthase', NULL, NULL, NULL, NULL, NULL, 4),
(182269, NULL, 'G3DSA:1.10.620.20:FF:000052', NULL, NULL, 'Stearoyl-[acyl-carrier-protein] 9-desaturase 7 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(182270, NULL, 'G3DSA:3.40.30.10:FF:000345', NULL, NULL, 'Glutathione S-Transferase', NULL, NULL, NULL, NULL, NULL, 4),
(182271, NULL, 'G3DSA:2.20.28.230:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182272, NULL, 'G3DSA:3.30.450.40:FF:000167', NULL, NULL, 'Diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(182273, NULL, 'G3DSA:1.50.40.10:FF:000558', NULL, NULL, 'Mitochondrial carrier protein, putative (AFU_orthologue AFUA_1G09980)', NULL, NULL, NULL, NULL, NULL, 4),
(182274, NULL, 'G3DSA:2.60.120.10:FF:000248', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(182275, NULL, 'G3DSA:3.90.550.50:FF:000142', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(182276, NULL, 'G3DSA:3.30.40.10:FF:000144', NULL, NULL, 'Tripartite motif-containing 5 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(182277, NULL, 'G3DSA:3.40.50.2000:FF:000469', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182278, NULL, 'G3DSA:3.30.160.60:FF:005979', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182279, NULL, 'G3DSA:3.10.50.40:FF:000031', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(182280, NULL, 'G3DSA:1.25.40.10:FF:003483', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At1g13800', NULL, NULL, NULL, NULL, NULL, 4),
(182281, NULL, 'G3DSA:3.40.20.10:FF:000171', NULL, NULL, 'Adseverin', NULL, NULL, NULL, NULL, NULL, 4),
(182282, NULL, 'G3DSA:1.25.40.20:FF:001232', NULL, NULL, 'Ada2a-containing complex component 3, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(182283, NULL, 'G3DSA:3.30.1360.170:FF:000013', NULL, NULL, 'Thymidylate synthase complementing protein ThyX', NULL, NULL, NULL, NULL, NULL, 4),
(182284, NULL, 'G3DSA:2.130.10.10:FF:002528', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182285, NULL, 'G3DSA:2.40.50.140:FF:001080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182286, NULL, 'G3DSA:3.30.390.10:FF:000018', NULL, NULL, 'Enolase 3, putative', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(182287, NULL, 'G3DSA:3.40.50.2000:FF:000121', NULL, NULL, 'bifunctional UDP-N-acetylglucosamine 2-epimerase/N-acetylmannosamine kinase isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(182288, NULL, 'G3DSA:3.30.65.10:FF:000010', NULL, NULL, 'DNA topoisomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(182289, NULL, 'G3DSA:3.50.50.60:FF:001209', NULL, NULL, 'Uncharacterized protein MJ1182', NULL, NULL, NULL, NULL, NULL, 4),
(182290, NULL, 'G3DSA:3.10.20.90:FF:000971', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182291, NULL, 'G3DSA:3.30.160.60:FF:003040', NULL, NULL, 'Putative endonuclease or glycosyl hydrolase with C2H2-type zinc finger domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(182292, NULL, 'G3DSA:2.30.30.40:FF:000155', NULL, NULL, 'FCH and double SH3 domains protein', NULL, NULL, NULL, NULL, NULL, 4),
(182293, NULL, 'G3DSA:3.20.20.70:FF:000116', NULL, NULL, 'Lipoyl synthase', NULL, NULL, NULL, NULL, NULL, 4),
(182294, NULL, 'G3DSA:2.60.40.10:FF:003725', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182295, NULL, 'G3DSA:3.30.160.60:FF:000504', NULL, NULL, 'C2H2 transcription factor swi5', NULL, NULL, NULL, NULL, NULL, 4),
(182296, NULL, 'G3DSA:2.60.40.10:FF:001819', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(182297, NULL, 'G3DSA:3.40.50.300:FF:002927', NULL, NULL, 'Putative ABC transporter protein', NULL, NULL, NULL, NULL, NULL, 4),
(182298, NULL, 'G3DSA:1.20.1310.10:FF:000062', NULL, NULL, 'Unplaced genomic scaffold supercont1.188, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(182299, NULL, 'G3DSA:2.60.120.10:FF:000827', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182300, NULL, 'G3DSA:3.30.60.20:FF:000042', NULL, NULL, 'differentially expressed in FDCP 8 homolog isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(182301, NULL, 'G3DSA:1.10.560.10:FF:000010', NULL, NULL, 'T-complex protein 1 theta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(182302, NULL, 'G3DSA:3.90.79.10:FF:000017', NULL, NULL, 'Phosphatase NudJ', NULL, NULL, NULL, NULL, NULL, 4),
(182303, NULL, 'G3DSA:3.30.70.1230:FF:000055', NULL, NULL, 'Adenylyl cyclase beta', NULL, NULL, NULL, NULL, NULL, 4),
(182304, NULL, 'G3DSA:3.40.50.150:FF:001556', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182305, NULL, 'G3DSA:2.40.50.1060:FF:000019', NULL, NULL, 'AGAP012084-PA', NULL, NULL, NULL, NULL, NULL, 4),
(182306, NULL, 'G3DSA:3.40.50.880:FF:000010', NULL, NULL, 'uncharacterized protein LOC100176842 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(182307, NULL, 'G3DSA:2.60.40.10:FF:002219', NULL, NULL, 'Tyrosine-protein phosphatase Lar-like', NULL, NULL, NULL, NULL, NULL, 4),
(182308, NULL, 'G3DSA:2.30.39.10:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182309, NULL, 'G3DSA:3.30.1330.50:FF:000003', NULL, NULL, '2-C-methyl-D-erythritol 2,4-cyclodiphosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(182310, NULL, 'G3DSA:3.30.70.1230:FF:000179', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(182311, NULL, 'G3DSA:1.20.1250.20:FF:000907', NULL, NULL, 'Similar to MFS multidrug transporter, partial sequence', NULL, NULL, NULL, NULL, NULL, 4),
(182312, NULL, 'G3DSA:2.40.50.430:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182313, NULL, 'G3DSA:3.30.360.10:FF:000050', NULL, NULL, 'Chimeric spermidine synthase/saccharopine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(182314, NULL, 'G3DSA:3.30.70.270:FF:000210', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182315, NULL, 'G3DSA:3.40.850.10:FF:000557', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182316, NULL, 'G3DSA:1.10.510.10:FF:003508', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182317, NULL, 'G3DSA:2.40.70.10:FF:000305', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182318, NULL, 'G3DSA:3.20.20.70:FF:000791', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182319, NULL, 'G3DSA:3.80.10.10:FF:003664', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(182320, NULL, 'G3DSA:1.10.30.10:FF:000042', NULL, NULL, 'High mobility group protein 1.2', NULL, NULL, NULL, NULL, NULL, 4),
(182321, NULL, 'G3DSA:1.20.1250.20:FF:000565', NULL, NULL, 'MFS multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182322, NULL, 'G3DSA:1.25.40.10:FF:004231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182323, NULL, 'G3DSA:2.60.40.650:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(182324, NULL, 'G3DSA:3.40.190.80:FF:000061', NULL, NULL, 'Fructose-1,6-bisphosphatase class 1', NULL, NULL, NULL, NULL, NULL, 4),
(182325, NULL, 'G3DSA:1.25.40.20:FF:000743', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(182326, NULL, 'G3DSA:3.60.20.30:FF:000007', NULL, NULL, 'Similar to threonine aspartase', NULL, NULL, NULL, NULL, NULL, 4),
(182327, NULL, 'G3DSA:3.80.10.10:FF:000230', NULL, NULL, 'Leucine-rich repeat-containing protein 57', NULL, NULL, NULL, NULL, NULL, 4),
(182328, NULL, 'G3DSA:2.130.10.10:FF:003473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182329, NULL, 'G3DSA:1.20.1720.10:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182330, NULL, 'G3DSA:3.90.1410.10:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182331, NULL, 'G3DSA:1.25.40.20:FF:000956', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182332, NULL, 'G3DSA:4.10.240.10:FF:000126', NULL, NULL, 'Rgt1p', NULL, NULL, NULL, NULL, NULL, 4),
(182333, NULL, 'G3DSA:1.10.20.10:FF:000334', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182334, NULL, 'G3DSA:3.40.50.720:FF:002368', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182335, NULL, 'G3DSA:1.25.10.10:FF:003436', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(182336, NULL, 'G3DSA:3.30.2350.10:FF:000015', NULL, NULL, 'Mitochondrial RNA pseudouridine synthase RPUSD4', NULL, NULL, NULL, NULL, NULL, 4),
(182337, NULL, 'G3DSA:2.60.34.10:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182338, NULL, 'G3DSA:3.10.250.10:FF:000046', NULL, NULL, 'Transmembrane protease serine 4', NULL, NULL, NULL, NULL, NULL, 4),
(182339, NULL, 'G3DSA:3.90.1480.20:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182340, NULL, 'G3DSA:3.40.50.880:FF:000134', NULL, NULL, 'Glutamine amidotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(182341, NULL, 'G3DSA:2.120.10.30:FF:000354', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182342, NULL, 'G3DSA:1.10.10.10:FF:001570', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182343, NULL, 'G3DSA:3.10.20.90:FF:000752', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182344, NULL, 'G3DSA:2.60.120.620:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182345, NULL, 'G3DSA:2.60.120.380:FF:000024', NULL, NULL, 'Serine protease/ABC transporter B family protein tagA', NULL, NULL, NULL, NULL, NULL, 4),
(182346, NULL, 'G3DSA:3.30.40.10:FF:000487', NULL, NULL, 'tripartite motif-containing protein 72', NULL, NULL, NULL, NULL, NULL, 4),
(182347, NULL, 'G3DSA:3.30.559.10:FF:000202', NULL, NULL, 'Carnitine Palmitoyl Transferase', NULL, NULL, NULL, NULL, NULL, 4),
(182348, NULL, 'G3DSA:1.20.5.580:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182349, NULL, 'G3DSA:2.130.10.10:FF:001909', NULL, NULL, 'WD repeat, SAM and U-box domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(182350, NULL, 'G3DSA:2.60.40.10:FF:001590', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(182351, NULL, 'G3DSA:1.10.340.40:FF:000002', NULL, NULL, 'Polyadenylated RNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(182352, NULL, 'G3DSA:2.130.10.10:FF:002309', NULL, NULL, 'WGS project CABT00000000 data, contig 2.18', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(182353, NULL, 'G3DSA:2.60.40.10:FF:002764', NULL, NULL, 'CRE-ZIG-5 protein', NULL, NULL, NULL, NULL, NULL, 4),
(182354, NULL, 'G3DSA:3.40.50.150:FF:000595', NULL, NULL, 'Endo-exonuclease NUCR', NULL, NULL, NULL, NULL, NULL, 4),
(182355, NULL, 'G3DSA:1.10.10.10:FF:000951', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(182356, NULL, 'G3DSA:3.40.50.300:FF:002242', NULL, NULL, 'Arsenical pump-driving ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(182357, NULL, 'G3DSA:1.25.40.20:FF:000271', NULL, NULL, 'Ankyrin repeat and SOCS box containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(182358, NULL, 'G3DSA:3.30.40.10:FF:001111', NULL, NULL, 'Vacuolar protein sorting-associated protein 11 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(182359, NULL, 'G3DSA:2.60.40.10:FF:003040', NULL, NULL, 'Prolactin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(182360, NULL, 'G3DSA:3.50.50.60:FF:001086', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(182361, NULL, 'G3DSA:3.90.70.10:FF:000481', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182362, NULL, 'G3DSA:3.30.60.30:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182363, NULL, 'G3DSA:3.30.2160.10:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182364, NULL, 'G3DSA:1.10.533.10:FF:000312', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182365, NULL, 'G3DSA:3.20.20.80:FF:000338', NULL, NULL, '1,4-alpha-glucan branching enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182366, NULL, 'G3DSA:2.40.160.20:FF:000005', NULL, NULL, 'Opacity protein opA54', NULL, NULL, NULL, NULL, NULL, 4),
(182367, NULL, 'G3DSA:3.40.50.2000:FF:001088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182368, NULL, 'G3DSA:1.20.58.1100:FF:000013', NULL, NULL, 'Unc-13 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(182369, NULL, 'G3DSA:1.25.40.10:FF:002196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182370, NULL, 'G3DSA:1.20.5.100:FF:000002', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(182371, NULL, 'G3DSA:3.30.160.60:FF:004670', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182372, NULL, 'G3DSA:3.30.9.10:FF:000291', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182373, NULL, 'G3DSA:2.80.10.50:FF:000177', NULL, NULL, 'Putative polypeptide N-acetylgalactosaminyltransferase 11', NULL, NULL, NULL, NULL, NULL, 4),
(182374, NULL, 'G3DSA:3.90.260.10:FF:000040', NULL, NULL, 'Erythrocyte membrane protein band 4.2', NULL, NULL, NULL, NULL, NULL, 4),
(182375, NULL, 'G3DSA:2.130.10.10:FF:001567', NULL, NULL, 'WD repeat domain 62', NULL, NULL, NULL, NULL, NULL, 4),
(182376, NULL, 'G3DSA:3.30.420.40:FF:000339', NULL, NULL, 'Protein CBG02163', NULL, NULL, NULL, NULL, NULL, 4),
(182377, NULL, 'G3DSA:1.10.10.10:FF:000058', NULL, NULL, 'DNA-binding response OmpR family regulator', NULL, NULL, NULL, NULL, NULL, 4),
(182378, NULL, 'G3DSA:2.10.110.10:FF:000107', NULL, NULL, 'Protein DA1-related 2', NULL, NULL, NULL, NULL, NULL, 4),
(182379, NULL, 'G3DSA:1.25.40.10:FF:001010', NULL, NULL, 'Bch2p', NULL, NULL, NULL, NULL, NULL, 4),
(182380, NULL, 'G3DSA:3.30.200.20:FF:001188', NULL, NULL, '3-phosphoinositide-dependent protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(182381, NULL, 'G3DSA:3.40.50.1820:FF:000628', NULL, NULL, 'Serine peptidase, Clan SC, Family S9D', NULL, NULL, NULL, NULL, NULL, 4),
(182382, NULL, 'G3DSA:2.130.10.10:FF:005619', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182383, NULL, 'G3DSA:2.60.40.10:FF:005861', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182384, NULL, 'G3DSA:3.40.50.300:FF:001966', NULL, NULL, 'Hypothetical ABC transporter ATP-binding protein YddA', NULL, NULL, NULL, NULL, NULL, 4),
(182385, NULL, 'G3DSA:3.30.70.330:FF:002954', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182386, NULL, 'G3DSA:3.30.1490.220:FF:000001', NULL, NULL, 'Inositol-tetrakisphosphate 1-kinase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(182387, NULL, 'G3DSA:1.10.630.10:FF:000566', NULL, NULL, 'CYP71A12 (Cytochrome P450 family 71 subfamily A polypeptide 12)', NULL, NULL, NULL, NULL, NULL, 4),
(182388, NULL, 'G3DSA:1.25.10.10:FF:003094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182389, NULL, 'G3DSA:1.20.1070.10:FF:001200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182390, NULL, 'G3DSA:2.30.30.40:FF:000025', NULL, NULL, 'SH3 and multiple ankyrin repeat domains protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(182391, NULL, 'G3DSA:1.10.565.10:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182392, NULL, 'G3DSA:4.10.60.10:FF:000150', NULL, NULL, 'Putative e3 ubiquitin ligase', NULL, NULL, NULL, NULL, NULL, 4),
(182393, NULL, 'G3DSA:2.30.29.30:FF:001374', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182394, NULL, 'G3DSA:3.30.1480.10:FF:000002', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(182395, NULL, 'G3DSA:1.20.920.10:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182396, NULL, 'G3DSA:3.20.20.370:FF:000024', NULL, NULL, 'Sll1306 protein', NULL, NULL, NULL, NULL, NULL, 4),
(182397, NULL, 'G3DSA:3.30.200.20:FF:000126', NULL, NULL, 'Dual specificity mitogen-activated protein kinase kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(182398, NULL, 'G3DSA:3.90.640.10:FF:000148', NULL, NULL, 'Heat shock 70 kDa protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(182399, NULL, 'G3DSA:1.20.1270.60:FF:000218', NULL, NULL, 'AEL147Wp', NULL, NULL, NULL, NULL, NULL, 4),
(182400, NULL, 'G3DSA:3.40.640.10:FF:000058', NULL, NULL, 'ethanolamine-phosphate phospho-lyase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(182401, NULL, 'G3DSA:3.40.50.11840:FF:000019', NULL, NULL, 'Trr-1', NULL, NULL, NULL, NULL, NULL, 4),
(182402, NULL, 'G3DSA:2.60.40.10:FF:005985', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182403, NULL, 'G3DSA:2.30.29.30:FF:000974', NULL, NULL, 'Oxysterol-binding protein-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(182404, NULL, 'G3DSA:1.20.1740.10:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182405, NULL, 'G3DSA:3.30.160.60:FF:002764', NULL, NULL, 'GG18288', NULL, NULL, NULL, NULL, NULL, 4),
(182406, NULL, 'G3DSA:1.20.58.1120:FF:000019', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182407, NULL, 'G3DSA:2.170.270.10:FF:000109', NULL, NULL, 'Histone-lysine N-methyltransferase SUVR5', NULL, NULL, NULL, NULL, NULL, 4),
(182408, NULL, 'G3DSA:2.40.30.10:FF:000527', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182409, NULL, 'G3DSA:1.10.510.10:FF:004453', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182410, NULL, 'G3DSA:2.40.50.100:FF:000039', NULL, NULL, 'HlyD family efflux transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(182411, NULL, 'G3DSA:1.10.3260.10:FF:000020', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(182412, NULL, 'G3DSA:1.20.1110.10:FF:000170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182413, NULL, 'G3DSA:3.30.470.110:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182414, NULL, 'G3DSA:3.40.710.10:FF:000159', NULL, NULL, 'Monacolin J acid methylbutanoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(182415, NULL, 'G3DSA:1.25.10.10:FF:000114', NULL, NULL, 'MMS19 nucleotide excision repair protein homolog isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(182416, NULL, 'G3DSA:3.40.630.30:FF:000552', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182417, NULL, 'G3DSA:3.40.50.10810:FF:000059', NULL, NULL, 'SNF2 family helicase/ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182418, NULL, 'G3DSA:4.10.1000.10:FF:000049', NULL, NULL, 'Protein CBG18471', NULL, NULL, NULL, NULL, NULL, 4),
(182419, NULL, 'G3DSA:3.40.250.10:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(182420, NULL, 'G3DSA:3.80.10.10:FF:000915', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase GSO1', NULL, NULL, NULL, NULL, NULL, 4),
(182421, NULL, 'G3DSA:2.130.10.120:FF:000004', NULL, NULL, 'prolyl endopeptidase-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(182422, NULL, 'G3DSA:2.130.10.10:FF:000836', NULL, NULL, 'Ribosome assembly protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(182423, NULL, 'G3DSA:1.20.1050.10:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182424, NULL, 'G3DSA:3.30.200.20:FF:001531', NULL, NULL, 'L-type lectin-domain containing receptor kinase S.4', NULL, NULL, NULL, NULL, NULL, 4),
(182425, NULL, 'G3DSA:3.40.50.2300:FF:001166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182426, NULL, 'G3DSA:2.60.40.10:FF:002421', NULL, NULL, 'Novel immune-type receptor 9', NULL, NULL, NULL, NULL, NULL, 4),
(182427, NULL, 'G3DSA:3.40.140.70:FF:000009', NULL, NULL, 'Autophagy-related protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(182428, NULL, 'G3DSA:3.40.50.300:FF:008094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182429, NULL, 'G3DSA:3.30.1370.60:FF:000003', NULL, NULL, 'Malate/L-lactate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(182430, NULL, 'G3DSA:3.30.300.200:FF:000001', NULL, NULL, 'Baseplate wedge protein gp6', NULL, NULL, NULL, NULL, NULL, 4),
(182431, NULL, 'G3DSA:3.30.70.1230:FF:000286', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(182432, NULL, 'G3DSA:3.40.1230.10:FF:000009', NULL, NULL, 'Unplaced genomic scaffold supercont2.10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(182433, NULL, 'G3DSA:3.30.70.330:FF:000138', NULL, NULL, 'Serine/arginine-rich splicing factor 5 alpha', NULL, NULL, NULL, NULL, NULL, 4),
(182434, NULL, 'G3DSA:3.40.50.300:FF:000218', NULL, NULL, 'Multidrug ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(182435, NULL, 'G3DSA:2.60.40.3510:FF:000002', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(182436, NULL, 'G3DSA:2.10.60.10:FF:000042', NULL, NULL, 'Pre-xenoxin-1', NULL, NULL, NULL, NULL, NULL, 4),
(182437, NULL, 'G3DSA:1.10.565.10:FF:000212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182438, NULL, 'G3DSA:2.60.40.3210:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182439, NULL, 'G3DSA:1.10.510.10:FF:002435', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182440, NULL, 'G3DSA:1.10.472.10:FF:000305', NULL, NULL, 'Transcription initiation factor IIB-2', NULL, NULL, NULL, NULL, NULL, 4),
(182441, NULL, 'G3DSA:3.30.365.10:FF:000038', NULL, NULL, 'Nicotinate dehydrogenase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(182442, NULL, 'G3DSA:1.10.287.110:FF:000085', NULL, NULL, 'Chaperone DnaJ-domain superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(182443, NULL, 'G3DSA:1.20.120.1770:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182444, NULL, 'G3DSA:2.30.130.10:FF:000003', NULL, NULL, 'Glutamate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(182445, NULL, 'G3DSA:3.90.550.10:FF:000377', NULL, NULL, 'Glycosyltransferase family 2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(182446, NULL, 'G3DSA:2.60.40.10:FF:000185', NULL, NULL, 'Fibronectin type III domain containing 3A', NULL, NULL, NULL, NULL, NULL, 4),
(182447, NULL, 'G3DSA:2.130.10.10:FF:005726', NULL, NULL, 'Probable inactive protein kinase DDB_G0270444', NULL, NULL, NULL, NULL, NULL, 4),
(182448, NULL, 'G3DSA:1.50.40.10:FF:000434', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182449, NULL, 'G3DSA:3.30.200.20:FF:000002', NULL, NULL, 'Calcium/calmodulin-dependent protein kinase type II subunit delta isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(182450, NULL, 'G3DSA:3.40.50.300:FF:004507', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(182451, NULL, 'G3DSA:3.30.870.10:FF:000151', NULL, NULL, 'AAR169Cp', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(182452, NULL, 'G3DSA:1.10.840.10:FF:000048', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(182453, NULL, 'G3DSA:2.120.10.30:FF:000461', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182454, NULL, 'G3DSA:2.60.120.1540:FF:000012', NULL, NULL, 'Blast:CD109 antigen', NULL, NULL, NULL, NULL, NULL, 4),
(182455, NULL, 'G3DSA:1.20.144.10:FF:000092', NULL, NULL, 'Lipid A 4''-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(182456, NULL, 'G3DSA:3.40.50.300:FF:006637', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(182457, NULL, 'G3DSA:3.30.830.10:FF:000030', NULL, NULL, 'Insulin-degrading enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(182458, NULL, 'G3DSA:2.60.120.200:FF:000807', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182459, NULL, 'G3DSA:2.60.200.20:FF:000185', NULL, NULL, 'YALI0E02508p', NULL, NULL, NULL, NULL, NULL, 4),
(182460, NULL, 'G3DSA:3.30.50.10:FF:000100', NULL, NULL, 'Hepatocyte nuclear factor 4 alpha', NULL, NULL, NULL, NULL, NULL, 4),
(182461, NULL, 'G3DSA:1.20.1420.30:FF:000042', NULL, NULL, 'Zydeco, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(182462, NULL, 'G3DSA:2.60.34.10:FF:000018', NULL, NULL, 'Heat shock 70 kDa protein 4L', NULL, NULL, NULL, NULL, NULL, 4),
(182463, NULL, 'G3DSA:1.10.10.370:FF:000004', NULL, NULL, 'Dissimilatory siroheme-sulfite reductase, gamma subunit-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(182464, NULL, 'G3DSA:3.30.160.60:FF:004001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182465, NULL, 'G3DSA:3.40.50.300:FF:003310', NULL, NULL, 'Ras family protein', NULL, NULL, NULL, NULL, NULL, 4),
(182466, NULL, 'G3DSA:2.40.50.180:FF:000006', NULL, NULL, 'Chemotaxis protein CheW', NULL, NULL, NULL, NULL, NULL, 4),
(182467, NULL, 'G3DSA:2.30.30.30:FF:000039', NULL, NULL, 'Elongation factor P', NULL, NULL, NULL, NULL, NULL, 4),
(182468, NULL, 'G3DSA:3.10.20.90:FF:000521', NULL, NULL, 'Polycomb group RING finger protein 5-B', NULL, NULL, NULL, NULL, NULL, 4),
(182469, NULL, 'G3DSA:2.120.10.90:FF:000001', NULL, NULL, 'DNA gyrase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(182470, NULL, 'G3DSA:3.40.50.1980:FF:000075', NULL, NULL, 'Hemin-binding periplasmic protein hmuT', NULL, NULL, NULL, NULL, NULL, 4),
(182471, NULL, 'G3DSA:2.60.120.290:FF:000093', NULL, NULL, 'Zinc metalloproteinase', NULL, NULL, NULL, NULL, NULL, 4),
(182472, NULL, 'G3DSA:3.30.1360.120:FF:000038', NULL, NULL, 'Sarcosine oxidase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(182473, NULL, 'G3DSA:1.25.40.10:FF:003376', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g30825, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(182474, NULL, 'G3DSA:3.90.190.10:FF:000394', NULL, NULL, 'Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(182475, NULL, 'G3DSA:3.40.50.1460:FF:000037', NULL, NULL, 'uncharacterized protein LOC100179627 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(182476, NULL, 'G3DSA:3.40.50.2000:FF:000576', NULL, NULL, 'Photosynthetic NDH subunit of subcomplex B 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(182477, NULL, 'G3DSA:1.20.1560.10:FF:000102', NULL, NULL, 'ABC multidrug transporter Mdr1', NULL, NULL, NULL, NULL, NULL, 4),
(182478, NULL, 'G3DSA:2.130.10.10:FF:001455', NULL, NULL, 'WD repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(182479, NULL, 'G3DSA:3.30.420.40:FF:000227', NULL, NULL, 'Actin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182480, NULL, 'G3DSA:3.30.200.40:FF:000008', NULL, NULL, 'm7GpppX diphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(182481, NULL, 'G3DSA:2.10.25.10:FF:000578', NULL, NULL, 'Fibulin 2', NULL, NULL, NULL, NULL, NULL, 4),
(182482, NULL, 'G3DSA:2.130.10.30:FF:000157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182483, NULL, 'G3DSA:3.40.50.1000:FF:000265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182484, NULL, 'G3DSA:3.30.9.10:FF:000307', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(182485, NULL, 'G3DSA:3.40.50.150:FF:001775', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(182486, NULL, 'G3DSA:2.60.40.1730:FF:000114', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182487, NULL, 'G3DSA:3.40.50.1010:FF:000256', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182488, NULL, 'G3DSA:2.60.40.3960:FF:000002', NULL, NULL, 'VeA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(182489, NULL, 'G3DSA:3.30.70.330:FF:001774', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182490, NULL, 'G3DSA:1.10.1000.11:FF:000013', NULL, NULL, 'Guanine-nucleotide exchange factor YEL1', NULL, NULL, NULL, NULL, NULL, 4),
(182491, NULL, 'G3DSA:3.40.30.10:FF:000469', NULL, NULL, '2-hydroxychromene-2-carboxylate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(182492, NULL, 'G3DSA:3.30.505.10:FF:000134', NULL, NULL, 'SH2-protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(182493, NULL, 'G3DSA:1.10.630.10:FF:000454', NULL, NULL, 'Tryptophan N-monooxygenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(182494, NULL, 'G3DSA:3.40.109.10:FF:000015', NULL, NULL, 'NAD(P)H nitroreductase', NULL, NULL, NULL, NULL, NULL, 4),
(182495, NULL, 'G3DSA:1.10.8.60:FF:000392', NULL, NULL, 'uncharacterized protein LOC100176493', NULL, NULL, NULL, NULL, NULL, 4),
(182496, NULL, 'G3DSA:3.90.226.10:FF:000231', NULL, NULL, '6-ketocyclohex-1-ene-1-carbonyl-CoA hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(182497, NULL, 'G3DSA:3.40.1800.20:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182498, NULL, 'G3DSA:1.20.58.340:FF:000045', NULL, NULL, 'Magnesium and cobalt transport protein CorA, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182499, NULL, 'G3DSA:1.10.510.10:FF:000294', NULL, NULL, 'Serine/threonine-protein kinase OXI1', NULL, NULL, NULL, NULL, NULL, 4),
(182500, NULL, 'G3DSA:3.40.50.300:FF:001854', NULL, NULL, 'ABC multidrug transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(182501, NULL, 'G3DSA:1.20.1070.10:FF:001649', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182502, NULL, 'G3DSA:3.40.50.360:FF:000091', NULL, NULL, 'NADPH-cytochrome P450 reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182503, NULL, 'G3DSA:3.30.70.330:FF:001667', NULL, NULL, 'Splicing factor U2AF 59 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(182504, NULL, 'G3DSA:2.160.20.10:FF:000066', NULL, NULL, 'F-box protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(182505, NULL, 'G3DSA:1.10.3720.10:FF:000062', NULL, NULL, 'D,D-dipeptide ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(182506, NULL, 'G3DSA:1.10.238.10:FF:000593', NULL, NULL, 'EF-hand domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(182507, NULL, 'G3DSA:1.10.3380.10:FF:000068', NULL, NULL, 'Activating signal cointegrator 1 complex subunit 3, helc1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182508, NULL, 'G3DSA:3.30.70.330:FF:000470', NULL, NULL, 'RNA-binding motif protein, Y chromosome, family 1 member F/J', NULL, NULL, NULL, NULL, NULL, 4),
(182509, NULL, 'G3DSA:1.50.40.10:FF:000327', NULL, NULL, 'Mitochondrial thiamine pyrophosphate carrier 1', NULL, NULL, NULL, NULL, NULL, 4),
(182510, NULL, 'G3DSA:2.60.120.200:FF:000122', NULL, NULL, 'Calreticulin 3', NULL, NULL, NULL, NULL, NULL, 4),
(182511, NULL, 'G3DSA:3.60.21.10:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182512, NULL, 'G3DSA:3.10.20.740:FF:000003', NULL, NULL, 'Formate dehydrogenase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(182513, NULL, 'G3DSA:2.10.220.10:FF:000205', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5a', NULL, NULL, NULL, NULL, NULL, 4),
(182514, NULL, 'G3DSA:1.10.10.440:FF:000048', NULL, NULL, 'Conserved expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(182515, NULL, 'G3DSA:3.30.460.10:FF:000119', NULL, NULL, 'Lmo1231 protein', NULL, NULL, NULL, NULL, NULL, 4),
(182516, NULL, 'G3DSA:1.10.340.30:FF:000016', NULL, NULL, 'Endonuclease III homolog', NULL, NULL, NULL, NULL, NULL, 4),
(182517, NULL, 'G3DSA:3.30.300.20:FF:000061', NULL, NULL, 'Ribosome-binding factor A', NULL, NULL, NULL, NULL, NULL, 4),
(182518, NULL, 'G3DSA:3.90.1300.10:FF:000032', NULL, NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit A, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(182519, NULL, 'G3DSA:1.25.40.10:FF:001246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182520, NULL, 'G3DSA:2.60.40.1510:FF:000054', NULL, NULL, 'Integrin beta-6', NULL, NULL, NULL, NULL, NULL, 4),
(182521, NULL, 'G3DSA:3.90.550.10:FF:000490', NULL, NULL, 'Putative xyloglucan 6-xylosyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(182522, NULL, 'G3DSA:3.40.50.970:FF:000161', NULL, NULL, 'Probable 2-hydroxyacyl-CoA lyase 1', NULL, NULL, NULL, NULL, NULL, 4),
(182523, NULL, 'G3DSA:3.60.21.10:FF:000312', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(182524, NULL, 'G3DSA:1.10.630.10:FF:000673', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182525, NULL, 'G3DSA:3.40.50.300:FF:002585', NULL, NULL, 'Glutathione import ATP-binding protein GsiA', NULL, NULL, NULL, NULL, NULL, 4),
(182526, NULL, 'G3DSA:3.30.1130.10:FF:000015', NULL, NULL, 'Folic acid synthesis protein fol1', NULL, NULL, NULL, NULL, NULL, 4),
(182527, NULL, 'G3DSA:1.10.580.10:FF:000005', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(182528, NULL, 'G3DSA:2.60.40.10:FF:001707', NULL, NULL, 'Frazzled, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(182529, NULL, 'G3DSA:1.20.120.230:FF:000017', NULL, NULL, 'Catenin alpha like 1', NULL, NULL, NULL, NULL, NULL, 4),
(182530, NULL, 'G3DSA:3.30.110.120:FF:000001', NULL, NULL, 'Carbamoyltransferase HypF', NULL, NULL, NULL, NULL, NULL, 4),
(182531, NULL, 'G3DSA:3.30.1150.10:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182532, NULL, 'G3DSA:3.80.10.10:FF:002259', NULL, NULL, 'Mhp1p', NULL, NULL, NULL, NULL, NULL, 4),
(182533, NULL, 'G3DSA:2.30.42.10:FF:000387', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182534, NULL, 'G3DSA:3.30.70.1430:FF:000014', NULL, NULL, 'Transporter, AcrB/D/F family', NULL, NULL, NULL, NULL, NULL, 4),
(182535, NULL, 'G3DSA:3.90.1140.10:FF:000047', NULL, NULL, 'U6 snRNA phosphodiesterase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(182536, NULL, 'G3DSA:2.20.70.10:FF:000019', NULL, NULL, 'Putative transcriptional coactivator YAP1', NULL, NULL, NULL, NULL, NULL, 4),
(182537, NULL, 'G3DSA:3.40.50.300:FF:002473', NULL, NULL, 'KappaB-Ras, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(182538, NULL, 'G3DSA:3.30.1440.10:FF:000005', NULL, NULL, 'Unplaced genomic scaffold supercont1.6, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(182539, NULL, 'G3DSA:3.10.450.40:FF:000031', NULL, NULL, 'Peptidase M4 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(182540, NULL, 'G3DSA:3.40.50.40:FF:000007', NULL, NULL, 'L-asparaginase', NULL, NULL, NULL, NULL, NULL, 4),
(182541, NULL, 'G3DSA:3.80.10.10:FF:004283', NULL, NULL, 'NLR family CARD domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(182542, NULL, 'G3DSA:3.30.160.60:FF:000634', NULL, NULL, 'Zinc finger X-chromosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(182543, NULL, 'G3DSA:3.30.70.330:FF:003123', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182544, NULL, 'G3DSA:3.30.40.10:FF:001903', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182545, NULL, 'G3DSA:1.10.260.40:FF:000075', NULL, NULL, 'Response regulator receiver', NULL, NULL, NULL, NULL, NULL, 4),
(182546, NULL, 'G3DSA:2.60.40.60:FF:000502', NULL, NULL, 'AGAP011529-PA', NULL, NULL, NULL, NULL, NULL, 4),
(182547, NULL, 'G3DSA:4.10.240.10:FF:000019', NULL, NULL, 'C6 transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182548, NULL, 'G3DSA:1.25.40.10:FF:004225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182549, NULL, 'G3DSA:1.20.58.2220:FF:000029', NULL, NULL, 'Formin 1', NULL, NULL, NULL, NULL, NULL, 4),
(182550, NULL, 'G3DSA:3.40.50.720:FF:002025', NULL, NULL, 'Protein PLASTID TRANSCRIPTIONALLY ACTIVE 16, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(182551, NULL, 'G3DSA:3.10.490.20:FF:000033', NULL, NULL, 'Cytoplasmic dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182552, NULL, 'G3DSA:3.90.226.10:FF:000124', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(182553, NULL, 'G3DSA:1.10.10.10:FF:000165', NULL, NULL, 'Vacuolar protein sorting protein (Vps36)', NULL, NULL, NULL, NULL, NULL, 4),
(182554, NULL, 'G3DSA:3.40.1380.20:FF:000006', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(182555, NULL, 'G3DSA:1.10.238.10:FF:001211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182556, NULL, 'G3DSA:2.60.40.1400:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182557, NULL, 'G3DSA:2.10.25.10:FF:000814', NULL, NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(182558, NULL, 'G3DSA:1.20.58.70:FF:000067', NULL, NULL, 'Putative syntaxin-5', NULL, NULL, NULL, NULL, NULL, 4),
(182559, NULL, 'G3DSA:3.30.1460.20:FF:000009', NULL, NULL, 'Arp2/3 complex 34 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(182560, NULL, 'G3DSA:3.40.800.20:FF:000046', NULL, NULL, 'Histone deacetylase 3', NULL, NULL, NULL, NULL, NULL, 4),
(182561, NULL, 'G3DSA:3.40.50.1000:FF:000141', NULL, NULL, 'Putative phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(182562, NULL, 'G3DSA:3.40.50.300:FF:006744', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182563, NULL, 'G3DSA:3.40.1410.10:FF:000001', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(182564, NULL, 'G3DSA:1.10.506.10:FF:000076', NULL, NULL, 'Folate gamma-glutamyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(182565, NULL, 'G3DSA:3.40.50.300:FF:007256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182566, NULL, 'G3DSA:3.40.630.10:FF:000338', NULL, NULL, 'Carboxypeptidase SOL1', NULL, NULL, NULL, NULL, NULL, 4),
(182567, NULL, 'G3DSA:2.60.120.660:FF:000001', NULL, NULL, 'Structural polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(182568, NULL, 'G3DSA:1.10.238.10:FF:001099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182569, NULL, 'G3DSA:1.25.40.10:FF:004101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182570, NULL, 'G3DSA:3.30.200.20:FF:002256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182571, NULL, 'G3DSA:1.20.1250.20:FF:000115', NULL, NULL, 'High-affinity glucose transporter', NULL, NULL, NULL, NULL, NULL, 4),
(182572, NULL, 'G3DSA:3.80.10.10:FF:001534', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182573, NULL, 'G3DSA:4.10.1000.10:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182574, NULL, 'G3DSA:3.40.50.1440:FF:000155', NULL, NULL, 'Epsilon tubulin', NULL, NULL, NULL, NULL, NULL, 4),
(182575, NULL, 'G3DSA:1.10.8.10:FF:000074', NULL, NULL, 'Ubiquitin-associated domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(182576, NULL, 'G3DSA:1.10.418.70:FF:000006', NULL, NULL, 'Ift-81', NULL, NULL, NULL, NULL, NULL, 4),
(182577, NULL, 'G3DSA:3.90.132.10:FF:000001', NULL, NULL, 'leishmanolysin-like peptidase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(182578, NULL, 'G3DSA:3.40.390.10:FF:000297', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182579, NULL, 'G3DSA:3.30.930.10:FF:000083', NULL, NULL, 'Phenylalanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(182580, NULL, 'G3DSA:3.30.310.130:FF:000010', NULL, NULL, 'Ubiquitin-like-specific protease 1C', NULL, NULL, NULL, NULL, NULL, 4),
(182581, NULL, 'G3DSA:3.40.50.1440:FF:000031', NULL, NULL, 'tubulin beta-4A chain isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(182582, NULL, 'G3DSA:3.30.160.20:FF:000178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182583, NULL, 'G3DSA:1.25.40.10:FF:002988', NULL, NULL, 'Protein CTR9-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(182584, NULL, 'G3DSA:2.130.10.10:FF:004440', NULL, NULL, 'Block of proliferation protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182585, NULL, 'G3DSA:2.40.160.10:FF:000014', NULL, NULL, 'Translocase of outer mitochondrial membrane 40 like', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(182586, NULL, 'G3DSA:3.20.20.140:FF:000427', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(182587, NULL, 'G3DSA:3.90.1750.10:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182588, NULL, 'G3DSA:1.20.58.60:FF:000749', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182589, NULL, 'G3DSA:3.30.9.10:FF:000089', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase SDP6 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(182590, NULL, 'G3DSA:3.40.50.720:FF:000788', NULL, NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(182591, NULL, 'G3DSA:1.20.1740.10:FF:000088', NULL, NULL, 'Sodium:alanine symporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(182592, NULL, 'G3DSA:1.10.238.10:FF:000374', NULL, NULL, 'Probable MDR1-Mac1p interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(182593, NULL, 'G3DSA:1.25.40.20:FF:000850', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(182594, NULL, 'G3DSA:2.60.450.20:FF:000006', NULL, NULL, 'T-complex protein 10, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182595, NULL, 'G3DSA:1.50.40.10:FF:000215', NULL, NULL, 'IP15246p', NULL, NULL, NULL, NULL, NULL, 4),
(182596, NULL, 'G3DSA:2.40.20.10:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182597, NULL, 'G3DSA:1.10.1740.10:FF:000034', NULL, NULL, 'Putative prophage LambdaBa02, RNA polymerase sigma-F factor', NULL, NULL, NULL, NULL, NULL, 4),
(182598, NULL, 'G3DSA:3.40.50.300:FF:006183', NULL, NULL, 'Flagellar outer dynein arm heavy chain gamma', NULL, NULL, NULL, NULL, NULL, 4),
(182599, NULL, 'G3DSA:3.80.10.10:FF:003771', NULL, NULL, 'Probable disease resistance protein At5g45510', NULL, NULL, NULL, NULL, NULL, 4),
(182600, NULL, 'G3DSA:3.40.30.10:FF:000688', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(182601, NULL, 'G3DSA:3.40.50.1820:FF:001472', NULL, NULL, 'Alpha/beta-Hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(182602, NULL, 'G3DSA:3.40.50.620:FF:000764', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182603, NULL, 'G3DSA:3.30.70.330:FF:001886', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182604, NULL, 'G3DSA:2.170.270.10:FF:000216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182605, NULL, 'G3DSA:2.60.120.200:FF:000010', NULL, NULL, 'neurobeachin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(182606, NULL, 'G3DSA:1.20.1560.10:FF:000883', NULL, NULL, 'Protein CBR-MRP-1', NULL, NULL, NULL, NULL, NULL, 4),
(182607, NULL, 'G3DSA:1.10.10.10:FF:001002', NULL, NULL, 'DEP domain-containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(182608, NULL, 'G3DSA:2.60.40.10:FF:001696', NULL, NULL, 'Transcription factor COE3', NULL, NULL, NULL, NULL, NULL, 4),
(182609, NULL, 'G3DSA:3.40.50.150:FF:001663', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182610, NULL, 'G3DSA:1.25.40.650:FF:000005', NULL, NULL, 'Outer membrane lipoprotein LppC', NULL, NULL, NULL, NULL, NULL, 4),
(182611, NULL, 'G3DSA:2.10.25.10:FF:001197', NULL, NULL, 'signal peptide, CUB and EGF-like domain-containing protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(182612, NULL, 'G3DSA:3.90.70.10:FF:000250', NULL, NULL, 'Cysteine protease 12', NULL, NULL, NULL, NULL, NULL, 4),
(182613, NULL, 'G3DSA:3.40.50.20:FF:000001', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(182614, NULL, 'G3DSA:2.60.40.10:FF:002096', NULL, NULL, 'Down syndrome cell adhesion molecule 3, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(182615, NULL, 'G3DSA:1.25.40.10:FF:000627', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(182616, NULL, 'G3DSA:2.60.40.150:FF:000093', NULL, NULL, 'Extended synaptotagmin 3', NULL, NULL, NULL, NULL, NULL, 4),
(182617, NULL, 'G3DSA:1.10.2020.20:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182618, NULL, 'G3DSA:3.40.640.10:FF:000507', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(182619, NULL, 'G3DSA:3.40.50.2300:FF:001060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182620, NULL, 'G3DSA:2.60.120.290:FF:000216', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(182621, NULL, 'G3DSA:2.40.110.10:FF:000067', NULL, NULL, 'AGAP000454-PA', NULL, NULL, NULL, NULL, NULL, 4),
(182622, NULL, 'G3DSA:1.20.5.1160:FF:000014', NULL, NULL, 'Lamin A/C', NULL, NULL, NULL, NULL, NULL, 4),
(182623, NULL, 'G3DSA:1.25.10.10:FF:000238', NULL, NULL, 'Non-SMC condensin II complex subunit G2', NULL, NULL, NULL, NULL, NULL, 4),
(182624, NULL, 'G3DSA:3.90.1290.10:FF:000035', NULL, NULL, 'AGAP011396-PA', NULL, NULL, NULL, NULL, NULL, 4),
(182625, NULL, 'G3DSA:3.40.50.10420:FF:000049', NULL, NULL, 'ADL385Cp', NULL, NULL, NULL, NULL, NULL, 4),
(182626, NULL, 'G3DSA:1.10.20.10:FF:000103', NULL, NULL, 'Histone H2A type 1', NULL, NULL, NULL, NULL, NULL, 4),
(182627, NULL, 'G3DSA:2.30.30.140:FF:000184', NULL, NULL, 'Tudor, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(182628, NULL, 'G3DSA:1.20.120.1750:FF:000132', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(182629, NULL, 'G3DSA:1.10.150.20:FF:000201', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(182630, NULL, 'G3DSA:3.20.80.10:FF:000006', NULL, NULL, 'heme-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(182631, NULL, 'G3DSA:3.30.160.60:FF:005743', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182632, NULL, 'G3DSA:1.20.1250.20:FF:000458', NULL, NULL, 'Inner membrane metabolite transport protein ydjE', NULL, NULL, NULL, NULL, NULL, 4),
(182633, NULL, 'G3DSA:3.90.228.10:FF:000055', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(182634, NULL, 'G3DSA:3.20.20.80:FF:000445', NULL, NULL, 'Os11g0118200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(182635, NULL, 'G3DSA:2.40.270.10:FF:000005', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(182636, NULL, 'G3DSA:3.80.10.10:FF:002591', NULL, NULL, 'Tubulin-specific chaperone, putative (AFU_orthologue AFUA_4G11870)', NULL, NULL, NULL, NULL, NULL, 4),
(182637, NULL, 'G3DSA:3.30.710.10:FF:000100', NULL, NULL, 'Zinc finger and BTB domain containing 47', NULL, NULL, NULL, NULL, NULL, 4),
(182638, NULL, 'G3DSA:3.40.50.1820:FF:000179', NULL, NULL, 'Lipase', NULL, NULL, NULL, NULL, NULL, 4),
(182639, NULL, 'G3DSA:3.40.50.300:FF:007694', NULL, NULL, 'Multidrug resistance protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182640, NULL, 'G3DSA:2.60.40.2130:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182641, NULL, 'G3DSA:1.20.120.350:FF:000036', NULL, NULL, 'Voltage-dependent sodium channel SCN10A', NULL, NULL, NULL, NULL, NULL, 4),
(182642, NULL, 'G3DSA:2.130.10.10:FF:005507', NULL, NULL, 'WD repeat domain 62', NULL, NULL, NULL, NULL, NULL, 4),
(182643, NULL, 'G3DSA:1.25.40.120:FF:000077', NULL, NULL, 'AEL288Wp', NULL, NULL, NULL, NULL, NULL, 4),
(182644, NULL, 'G3DSA:1.20.120.1070:FF:000012', NULL, NULL, 'Translation initiation factor eIF-2B alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(182645, NULL, 'G3DSA:2.60.40.60:FF:000845', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182646, NULL, 'G3DSA:2.60.200.20:FF:000073', NULL, NULL, 'Pre-mRNA leakage protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(182647, NULL, 'G3DSA:3.30.160.60:FF:000179', NULL, NULL, 'Zinc finger protein 711', NULL, NULL, NULL, NULL, NULL, 4),
(182648, NULL, 'G3DSA:3.40.50.2300:FF:000784', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182649, NULL, 'G3DSA:1.10.287.900:FF:000001', NULL, NULL, 'Putative diamine N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(182650, NULL, 'G3DSA:1.10.510.10:FF:002311', NULL, NULL, 'Cdc2-related kinase 10, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182651, NULL, 'G3DSA:1.10.3720.10:FF:000168', NULL, NULL, 'Tungstate ABC transporter, permease protein WtpB', NULL, NULL, NULL, NULL, NULL, 4),
(182652, NULL, 'G3DSA:3.40.50.300:FF:006525', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(182653, NULL, 'G3DSA:3.10.20.30:FF:000088', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182654, NULL, 'G3DSA:3.30.390.50:FF:000002', NULL, NULL, 'Lipoate-protein ligase A', NULL, NULL, NULL, NULL, NULL, 4),
(182655, NULL, 'G3DSA:3.30.200.20:FF:001295', NULL, NULL, 'serine/threonine-protein kinase PLK2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(182656, NULL, 'G3DSA:1.25.40.20:FF:001125', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(182657, NULL, 'G3DSA:3.40.50.720:FF:000682', NULL, NULL, 'Probable short-chain type dehydrogenase/reductase', NULL, NULL, NULL, NULL, NULL, 4),
(182658, NULL, 'G3DSA:1.20.5.540:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182659, NULL, 'G3DSA:3.90.190.10:FF:000282', NULL, NULL, 'Protein tyrosine phosphatase type IVA, member 2a', NULL, NULL, NULL, NULL, NULL, 4),
(182660, NULL, 'G3DSA:1.25.40.20:FF:001687', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182661, NULL, 'G3DSA:1.10.510.10:FF:000170', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(182662, NULL, 'G3DSA:3.40.50.2300:FF:000441', NULL, NULL, 'Fis family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(182663, NULL, 'G3DSA:1.20.1510.10:FF:000043', NULL, NULL, 'Cation transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182664, NULL, 'G3DSA:3.40.50.150:FF:000483', NULL, NULL, 'HPM1p AdoMet-dependent methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(182665, NULL, 'G3DSA:3.30.160.60:FF:003489', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182666, NULL, 'G3DSA:2.60.120.680:FF:000007', NULL, NULL, 'Oxysterol binding protein (Osh3)', NULL, NULL, NULL, NULL, NULL, 4),
(182667, NULL, 'G3DSA:1.10.418.10:FF:000247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182668, NULL, 'G3DSA:3.40.50.720:FF:000007', NULL, NULL, '6-phosphogluconate dehydrogenase, decarboxylating', NULL, NULL, NULL, NULL, NULL, 4),
(182669, NULL, 'G3DSA:3.90.70.10:FF:000593', NULL, NULL, 'Os11g0649100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(182670, NULL, 'G3DSA:4.10.81.10:FF:000001', NULL, NULL, 'Cytochrome c oxidase subunit 8B, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(182671, NULL, 'G3DSA:2.60.40.150:FF:000311', NULL, NULL, 'Phosphatidylserine decarboxylase proenzyme 2', NULL, NULL, NULL, NULL, NULL, 4),
(182672, NULL, 'G3DSA:3.90.100.10:FF:000006', NULL, NULL, 'Orn/Lys/Arg decarboxylase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(182673, NULL, 'G3DSA:3.20.20.80:FF:000102', NULL, NULL, 'Alpha-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(182674, NULL, 'G3DSA:1.10.10.10:FF:000507', NULL, NULL, 'Segregation and condensation protein B', NULL, NULL, NULL, NULL, NULL, 4),
(182675, NULL, 'G3DSA:3.80.10.10:FF:001298', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(182676, NULL, 'G3DSA:1.20.5.110:FF:000117', NULL, NULL, 'Synaptosomal-associated protein 47', NULL, NULL, NULL, NULL, NULL, 4),
(182677, NULL, 'G3DSA:3.90.190.10:FF:000624', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182678, NULL, 'G3DSA:3.30.160.60:FF:005069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182679, NULL, 'G3DSA:3.30.160.60:FF:004782', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182680, NULL, 'G3DSA:1.10.555.10:FF:000149', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182681, NULL, 'G3DSA:3.30.160.60:FF:004107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182682, NULL, 'G3DSA:2.10.25.10:FF:000472', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(182683, NULL, 'G3DSA:3.30.160.60:FF:006362', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182684, NULL, 'G3DSA:2.130.10.10:FF:004889', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182685, NULL, 'G3DSA:2.170.130.10:FF:000043', NULL, NULL, 'TonB-dependent siderophore receptor', NULL, NULL, NULL, NULL, NULL, 4),
(182686, NULL, 'G3DSA:3.30.40.10:FF:001892', NULL, NULL, 'RING/U-box superfamily protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(182687, NULL, 'G3DSA:3.40.190.10:FF:000641', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(182688, NULL, 'G3DSA:3.40.50.150:FF:000027', NULL, NULL, 'Protein-L-isoaspartate O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(182689, NULL, 'G3DSA:3.90.79.20:FF:000008', NULL, NULL, 'Nudix hydrolase 19, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(182690, NULL, 'G3DSA:2.60.40.60:FF:001121', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(182691, NULL, 'G3DSA:1.20.1310.10:FF:000168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182692, NULL, 'G3DSA:3.30.2130.10:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182693, NULL, 'G3DSA:3.40.20.10:FF:000064', NULL, NULL, 'Unplaced genomic scaffold supercont1.19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(182694, NULL, 'G3DSA:3.40.850.10:FF:000321', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(182695, NULL, 'G3DSA:3.40.50.2300:FF:000109', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(182696, NULL, 'G3DSA:3.30.930.10:FF:000206', NULL, NULL, 'Glycyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(182697, NULL, 'G3DSA:3.40.350.10:FF:000064', NULL, NULL, 'Xaa-Pro aminopeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(182698, NULL, 'G3DSA:3.40.50.460:FF:000019', NULL, NULL, 'Probable ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(182699, NULL, 'G3DSA:3.40.50.720:FF:001300', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(182700, NULL, 'G3DSA:2.60.40.10:FF:000746', NULL, NULL, 'Tissue factor', NULL, NULL, NULL, NULL, NULL, 4),
(182701, NULL, 'G3DSA:3.40.50.2300:FF:001402', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182702, NULL, 'G3DSA:2.130.10.10:FF:005165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182703, NULL, 'G3DSA:3.30.2130.30:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182704, NULL, 'G3DSA:3.30.565.10:FF:000037', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(182705, NULL, 'G3DSA:3.10.110.10:FF:000233', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 E3', NULL, NULL, NULL, NULL, NULL, 4),
(182706, NULL, 'G3DSA:3.30.160.60:FF:001359', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM11', NULL, NULL, NULL, NULL, NULL, 4),
(182707, NULL, 'G3DSA:3.30.40.10:FF:000599', NULL, NULL, 'Zinc finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182708, NULL, 'G3DSA:3.40.1180.10:FF:000016', NULL, NULL, 'Undecaprenyl diphosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(182709, NULL, 'G3DSA:3.10.20.710:FF:000005', NULL, NULL, 'Protein CBR-DVE-1', NULL, NULL, NULL, NULL, NULL, 4),
(182710, NULL, 'G3DSA:2.20.100.10:FF:000228', NULL, NULL, 'Putative salivary kunitz domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(182711, NULL, 'G3DSA:3.40.50.150:FF:001320', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182712, NULL, 'G3DSA:2.40.10.10:FF:000184', NULL, NULL, 'Prostasin', NULL, NULL, NULL, NULL, NULL, 4),
(182713, NULL, 'G3DSA:3.40.50.300:FF:005564', NULL, NULL, 'DNA 3''-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(182714, NULL, 'G3DSA:3.50.30.30:FF:000143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182715, NULL, 'G3DSA:3.30.160.60:FF:002652', NULL, NULL, 'zinc finger protein 514-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(182716, NULL, 'G3DSA:3.30.1390.10:FF:000012', NULL, NULL, 'ATP-dependent Clp protease adapter protein ClpS', NULL, NULL, NULL, NULL, NULL, 4),
(182717, NULL, 'G3DSA:1.25.40.20:FF:001468', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182718, NULL, 'G3DSA:2.60.40.10:FF:004237', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182719, NULL, 'G3DSA:2.40.50.140:FF:001192', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182720, NULL, 'G3DSA:1.10.510.10:FF:001131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(182721, NULL, 'G3DSA:3.40.50.2020:FF:000115', NULL, NULL, 'Hypoxanthine-guanine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(182722, NULL, 'G3DSA:2.70.98.30:FF:000036', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(182723, NULL, 'G3DSA:1.25.40.10:FF:001807', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(182724, NULL, 'G3DSA:1.20.1640.10:FF:000047', NULL, NULL, 'PaTched Related family', NULL, NULL, NULL, NULL, NULL, 4),
(182725, NULL, 'G3DSA:2.60.40.10:FF:003837', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182726, NULL, 'G3DSA:2.60.40.2150:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182727, NULL, 'G3DSA:3.40.50.720:FF:001643', NULL, NULL, 'SDR family oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(182728, NULL, 'G3DSA:3.80.10.10:FF:004389', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182729, NULL, 'G3DSA:2.40.70.10:FF:000069', NULL, NULL, 'Eukaryotic aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(182730, NULL, 'G3DSA:2.30.30.100:FF:000200', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm8', NULL, NULL, NULL, NULL, NULL, 4),
(182731, NULL, 'G3DSA:1.10.150.240:FF:000006', NULL, NULL, 'Phosphonoacetaldehyde hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(182732, NULL, 'G3DSA:1.25.10.10:FF:001418', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182733, NULL, 'G3DSA:3.40.1050.10:FF:000012', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(182734, NULL, 'G3DSA:3.40.50.2000:FF:000233', NULL, NULL, 'PGL/p-HBAD biosynthesis rhamnosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(182735, NULL, 'G3DSA:1.20.1250.20:FF:001638', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182736, NULL, 'G3DSA:2.60.40.10:FF:004113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182737, NULL, 'G3DSA:1.10.8.270:FF:000156', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(182738, NULL, 'G3DSA:3.40.50.11460:FF:000001', NULL, NULL, 'Probable polyketide synthase pks1', NULL, NULL, NULL, NULL, NULL, 4),
(182739, NULL, 'G3DSA:2.40.10.10:FF:000060', NULL, NULL, 'Acrosin', NULL, NULL, NULL, NULL, NULL, 4),
(182740, NULL, 'G3DSA:3.90.1100.10:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182741, NULL, 'G3DSA:1.25.10.10:FF:002711', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182742, NULL, 'G3DSA:1.10.510.10:FF:000855', NULL, NULL, 'Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(182743, NULL, 'G3DSA:3.90.79.10:FF:000129', NULL, NULL, 'Isopentenyl-diphosphate delta isomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(182744, NULL, 'G3DSA:2.70.130.10:FF:000039', NULL, NULL, 'AGAP000998-PA', NULL, NULL, NULL, NULL, NULL, 4),
(182745, NULL, 'G3DSA:2.120.10.60:FF:000003', NULL, NULL, 'Tricorn protease homolog', NULL, NULL, NULL, NULL, NULL, 4),
(182746, NULL, 'G3DSA:1.10.1280.10:FF:000010', NULL, NULL, 'Larval serum protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(182747, NULL, 'G3DSA:2.10.25.10:FF:001433', NULL, NULL, 'Cubilin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(182748, NULL, 'G3DSA:3.80.20.20:FF:000060', NULL, NULL, 'Related to sporulation-specific gene SPS2', NULL, NULL, NULL, NULL, NULL, 4),
(182749, NULL, 'G3DSA:1.10.10.60:FF:000483', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(182750, NULL, 'G3DSA:3.90.550.10:FF:000158', NULL, NULL, 'Glycosyl transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(182751, NULL, 'G3DSA:1.10.246.60:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182752, NULL, 'G3DSA:1.10.10.60:FF:000140', NULL, NULL, 'Myb transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(182753, NULL, 'G3DSA:3.30.70.370:FF:000015', NULL, NULL, 'DNA-directed DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(182754, NULL, 'G3DSA:1.10.3210.10:FF:000085', NULL, NULL, 'HDOD domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(182755, NULL, 'G3DSA:2.130.10.10:FF:000151', NULL, NULL, 'F-box/WD repeat-containing protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(182756, NULL, 'G3DSA:1.20.1250.20:FF:001419', NULL, NULL, 'Slr0616 protein', NULL, NULL, NULL, NULL, NULL, 4),
(182757, NULL, 'G3DSA:3.90.550.10:FF:000034', NULL, NULL, 'Exostosin 1', NULL, NULL, NULL, NULL, NULL, 4),
(182758, NULL, 'G3DSA:3.30.160.60:FF:001691', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(182759, NULL, 'G3DSA:2.120.10.80:FF:000009', NULL, NULL, 'Kelch domain-containing protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(182760, NULL, 'G3DSA:2.40.10.10:FF:000402', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182761, NULL, 'G3DSA:3.30.70.270:FF:000098', NULL, NULL, 'Diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(182762, NULL, 'G3DSA:2.60.120.40:FF:000010', NULL, NULL, 'EMILIN-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(182763, NULL, 'G3DSA:3.40.50.300:FF:000550', NULL, NULL, 'ras-related protein Rab-21', NULL, NULL, NULL, NULL, NULL, 4),
(182764, NULL, 'G3DSA:3.40.47.10:FF:000092', NULL, NULL, 'Alpha-pyrone synthesis polyketide synthase-like Pks18', NULL, NULL, NULL, NULL, NULL, 4),
(182765, NULL, 'G3DSA:2.130.10.10:FF:003585', NULL, NULL, 'Nucleoporin 214', NULL, NULL, NULL, NULL, NULL, 4),
(182766, NULL, 'G3DSA:3.40.1110.10:FF:000181', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(182767, NULL, 'G3DSA:1.20.140.150:FF:000076', NULL, NULL, 'Germ cell-specific gene 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(182768, NULL, 'G3DSA:3.30.160.60:FF:000398', NULL, NULL, 'Zinc finger and BTB domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(182769, NULL, 'G3DSA:1.20.120.980:FF:000006', NULL, NULL, 'Serine carboxypeptidase S28 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(182770, NULL, 'G3DSA:3.90.730.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182771, NULL, 'G3DSA:1.25.40.10:FF:002207', NULL, NULL, 'Anaphase-promoting complex, cyclosome, subunit 3/TPR repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182772, NULL, 'G3DSA:2.120.10.30:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182773, NULL, 'G3DSA:3.40.50.300:FF:003984', NULL, NULL, 'tRNA-splicing endonuclease positive effector, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182774, NULL, 'G3DSA:3.40.190.10:FF:000309', NULL, NULL, 'Phosphate ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(182775, NULL, 'G3DSA:3.10.580.10:FF:000150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182776, NULL, 'G3DSA:3.40.50.10140:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182777, NULL, 'G3DSA:3.40.50.2000:FF:000918', NULL, NULL, 'LOS biosynthesis enzyme LBGB', NULL, NULL, NULL, NULL, NULL, 4),
(182778, NULL, 'G3DSA:1.20.1250.20:FF:001970', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182779, NULL, 'G3DSA:3.50.50.60:FF:000136', NULL, NULL, 'Dihydrolipoyl dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(182780, NULL, 'G3DSA:1.10.287.610:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182781, NULL, 'G3DSA:3.30.200.20:FF:002150', NULL, NULL, 'Os12g0249300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(182782, NULL, 'G3DSA:1.20.1250.20:FF:000677', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(182783, NULL, 'G3DSA:1.10.10.60:FF:000825', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182784, NULL, 'G3DSA:1.10.510.10:FF:001816', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182785, NULL, 'G3DSA:3.40.50.10810:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182786, NULL, 'G3DSA:1.10.510.10:FF:001474', NULL, NULL, 'Pseudopodium-enriched atypical kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(182787, NULL, 'G3DSA:1.25.10.10:FF:001750', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(182788, NULL, 'G3DSA:3.30.200.20:FF:001750', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182789, NULL, 'G3DSA:1.25.10.10:FF:000457', NULL, NULL, 'Tubulin-folding cofactor D', NULL, NULL, NULL, NULL, NULL, 4),
(182790, NULL, 'G3DSA:1.20.1250.20:FF:001077', NULL, NULL, 'GD11715', NULL, NULL, NULL, NULL, NULL, 4),
(182791, NULL, 'G3DSA:2.60.120.260:FF:000112', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(182792, NULL, 'G3DSA:2.60.40.10:FF:000403', NULL, NULL, 'collagen alpha-1(XIV) chain isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(182793, NULL, 'G3DSA:1.10.10.60:FF:001101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182794, NULL, 'G3DSA:2.40.10.310:FF:000004', NULL, NULL, '30S ribosomal protein S8e', NULL, NULL, NULL, NULL, NULL, 4),
(182795, NULL, 'G3DSA:2.30.30.230:FF:000003', NULL, NULL, 'Fumarylacetoacetase', NULL, NULL, NULL, NULL, NULL, 4),
(182796, NULL, 'G3DSA:3.30.830.10:FF:000154', NULL, NULL, 'Mitochondrial presequence protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182797, NULL, 'G3DSA:3.30.200.20:FF:001874', NULL, NULL, 'Probable serine/threonine-protein kinase DDB_G0268642', NULL, NULL, NULL, NULL, NULL, 4),
(182798, NULL, 'G3DSA:3.30.160.60:FF:001016', NULL, NULL, 'zinc finger protein 850-like', NULL, NULL, NULL, NULL, NULL, 4),
(182799, NULL, 'G3DSA:1.10.10.60:FF:000264', NULL, NULL, 'zinc fingers and homeoboxes protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(182800, NULL, 'G3DSA:3.90.1150.10:FF:000216', NULL, NULL, 'Serine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(182801, NULL, 'G3DSA:1.10.150.650:FF:000011', NULL, NULL, 'PHP domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(182802, NULL, 'G3DSA:3.30.450.40:FF:000055', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(182803, NULL, 'G3DSA:3.40.33.10:FF:000150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182804, NULL, 'G3DSA:1.10.287.10:FF:000009', NULL, NULL, 'Methionine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(182805, NULL, 'G3DSA:3.90.550.10:FF:000719', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(182806, NULL, 'G3DSA:3.40.50.300:FF:005221', NULL, NULL, 'NOD-like receptor family B, member 5', NULL, NULL, NULL, NULL, NULL, 4),
(182807, NULL, 'G3DSA:2.130.10.10:FF:000275', NULL, NULL, 'Prolactin regulatory element binding', NULL, NULL, NULL, NULL, NULL, 4),
(182808, NULL, 'G3DSA:3.30.70.1400:FF:000016', NULL, NULL, 'Dimethylglycine dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(182809, NULL, 'G3DSA:1.10.132.20:FF:000024', NULL, NULL, 'Ribosome recycling factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182810, NULL, 'G3DSA:2.130.10.10:FF:004546', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182811, NULL, 'G3DSA:3.80.10.10:FF:000679', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', NULL, NULL, NULL, NULL, NULL, 4),
(182812, NULL, 'G3DSA:3.60.20.10:FF:000237', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182813, NULL, 'G3DSA:3.40.1190.20:FF:000177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182814, NULL, 'G3DSA:1.10.1390.10:FF:000001', NULL, NULL, 'Glucose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(182815, NULL, 'G3DSA:1.10.287.1880:FF:000003', NULL, NULL, 'Protein zwilch homolog', NULL, NULL, NULL, NULL, NULL, 4),
(182816, NULL, 'G3DSA:3.40.50.1220:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182817, NULL, 'G3DSA:3.40.50.2300:FF:001621', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182818, NULL, 'G3DSA:1.20.5.110:FF:000336', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182819, NULL, 'G3DSA:1.10.287.70:FF:000549', NULL, NULL, 'Calcium channel subunit Cch1', NULL, NULL, NULL, NULL, NULL, 4),
(182820, NULL, 'G3DSA:1.10.418.10:FF:000028', NULL, NULL, 'RP/EB family microtubule-associated protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(182821, NULL, 'G3DSA:3.30.70.100:FF:000075', NULL, NULL, 'Copper-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(182822, NULL, 'G3DSA:3.80.10.10:FF:001079', NULL, NULL, 'GM14853', NULL, NULL, NULL, NULL, NULL, 4),
(182823, NULL, 'G3DSA:2.20.50.20:FF:000010', NULL, NULL, 'vitellogenin-like', NULL, NULL, NULL, NULL, NULL, 4),
(182824, NULL, 'G3DSA:3.40.630.30:FF:000322', NULL, NULL, 'Spore coat maturation protein', NULL, NULL, NULL, NULL, NULL, 4),
(182825, NULL, 'G3DSA:1.10.357.110:FF:000005', NULL, NULL, 'CRE-VPS-53 protein', NULL, NULL, NULL, NULL, NULL, 4),
(182826, NULL, 'G3DSA:3.80.10.10:FF:003265', NULL, NULL, 'Putative inactive disease susceptibility protein LOV1', NULL, NULL, NULL, NULL, NULL, 4),
(182827, NULL, 'G3DSA:3.40.190.10:FF:000326', NULL, NULL, 'Ferric iron-binding periplasmic protein HitA', NULL, NULL, NULL, NULL, NULL, 4),
(182828, NULL, 'G3DSA:3.40.50.10190:FF:000098', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(182829, NULL, 'G3DSA:3.30.2180.10:FF:000002', NULL, NULL, 'Protein ATP12, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(182830, NULL, 'G3DSA:3.10.20.90:FF:000763', NULL, NULL, 'GA repeat binding protein alpha homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(182831, NULL, 'G3DSA:1.20.1560.10:FF:000389', NULL, NULL, 'ABC transporter, ATP-binding/permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(182832, NULL, 'G3DSA:1.10.287.70:FF:000095', NULL, NULL, 'Potassium sodium-activated channel subfamily T member 2', NULL, NULL, NULL, NULL, NULL, 4),
(182833, NULL, 'G3DSA:3.30.70.2380:FF:000001', NULL, NULL, 'Subtilisin-like protease 1', NULL, NULL, NULL, NULL, NULL, 4),
(182834, NULL, 'G3DSA:3.80.10.10:FF:001141', NULL, NULL, 'Si:ch211-250k18.7', NULL, NULL, NULL, NULL, NULL, 4),
(182835, NULL, 'G3DSA:3.30.160.60:FF:000544', NULL, NULL, 'zinc finger protein 384 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(182836, NULL, 'G3DSA:1.25.40.10:FF:000341', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(182837, NULL, 'G3DSA:1.10.357.120:FF:000008', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(182838, NULL, 'G3DSA:1.10.238.20:FF:000028', NULL, NULL, 'AGAP000643-PA', NULL, NULL, NULL, NULL, NULL, 4),
(182839, NULL, 'G3DSA:1.10.10.880:FF:000005', NULL, NULL, 'Regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(182840, NULL, 'G3DSA:3.40.50.1380:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182841, NULL, 'G3DSA:1.10.10.10:FF:000187', NULL, NULL, 'Transcription factor-like protein DPB', NULL, NULL, NULL, NULL, NULL, 4),
(182842, NULL, 'G3DSA:2.40.160.120:FF:000015', NULL, NULL, 'Oxysterol binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182843, NULL, 'G3DSA:2.130.10.10:FF:005923', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182844, NULL, 'G3DSA:3.40.50.720:FF:000030', NULL, NULL, 'Glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(182845, NULL, 'G3DSA:3.40.50.1000:FF:000080', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(182846, NULL, 'G3DSA:2.60.40.10:FF:004810', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182847, NULL, 'G3DSA:1.10.3930.10:FF:000004', NULL, NULL, 'Arginine deiminase', NULL, NULL, NULL, NULL, NULL, 4),
(182848, NULL, 'G3DSA:3.30.1360.220:FF:000006', NULL, NULL, 'Zinc finger FYVE domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(182849, NULL, 'G3DSA:3.30.450.20:FF:000392', NULL, NULL, 'Histidine kinase response regulator hybrid protein', NULL, NULL, NULL, NULL, NULL, 4),
(182850, NULL, 'G3DSA:1.25.40.20:FF:000344', NULL, NULL, 'ankyrin repeat domain-containing protein 50', NULL, NULL, NULL, NULL, NULL, 4),
(182851, NULL, 'G3DSA:1.25.10.10:FF:001941', NULL, NULL, 'Inositol kinase kinase (UvsB), putative', NULL, NULL, NULL, NULL, NULL, 4),
(182852, NULL, 'G3DSA:1.20.120.350:FF:000166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(182853, NULL, 'G3DSA:1.25.40.10:FF:003567', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182854, NULL, 'G3DSA:1.10.8.60:FF:000049', NULL, NULL, 'Vesicle-fusing ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(182855, NULL, 'G3DSA:3.30.70.330:FF:002100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182856, NULL, 'G3DSA:3.30.70.1230:FF:000044', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(182857, NULL, 'G3DSA:3.50.50.60:FF:000810', NULL, NULL, 'VisC protein', NULL, NULL, NULL, NULL, NULL, 4),
(182858, NULL, 'G3DSA:2.60.120.10:FF:000428', NULL, NULL, 'Catabolite gene activator', NULL, NULL, NULL, NULL, NULL, 4),
(182859, NULL, 'G3DSA:2.40.10.10:FF:000610', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182860, NULL, 'G3DSA:1.20.1310.10:FF:000084', NULL, NULL, 'Protein CBR-CUL-2', NULL, NULL, NULL, NULL, NULL, 4),
(182861, NULL, 'G3DSA:1.10.10.60:FF:000062', NULL, NULL, 'zinc fingers and homeoboxes protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(182862, NULL, 'G3DSA:3.30.450.40:FF:000285', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(182863, NULL, 'G3DSA:2.60.120.1190:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182864, NULL, 'G3DSA:3.30.559.30:FF:000040', NULL, NULL, 'Nonribosomal peptide synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(182865, NULL, 'G3DSA:3.30.40.10:FF:000886', NULL, NULL, 'Hypothetical_protein', NULL, NULL, NULL, NULL, NULL, 4),
(182866, NULL, 'G3DSA:3.40.50.12660:FF:000007', NULL, NULL, 'Metacaspase-4', NULL, NULL, NULL, NULL, NULL, 4),
(182867, NULL, 'G3DSA:2.10.25.10:FF:000668', NULL, NULL, 'LIN-12 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182868, NULL, 'G3DSA:1.25.10.10:FF:002604', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182869, NULL, 'G3DSA:1.25.10.10:FF:001295', NULL, NULL, 'ARVCF delta catenin family member b', NULL, NULL, NULL, NULL, NULL, 4),
(182870, NULL, 'G3DSA:1.20.1070.10:FF:001357', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182871, NULL, 'G3DSA:1.10.10.60:FF:000741', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182872, NULL, 'G3DSA:1.20.1600.10:FF:000005', NULL, NULL, 'ABC exporter outer membrane component', NULL, NULL, NULL, NULL, NULL, 4),
(182873, NULL, 'G3DSA:1.20.58.60:FF:000688', NULL, NULL, 'AGAP009554-PA', NULL, NULL, NULL, NULL, NULL, 4),
(182874, NULL, 'G3DSA:1.10.530.10:FF:000008', NULL, NULL, 'Lytic murein transglycosylase B', NULL, NULL, NULL, NULL, NULL, 4),
(182875, NULL, 'G3DSA:3.80.10.10:FF:003911', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182876, NULL, 'G3DSA:4.10.95.10:FF:000005', NULL, NULL, 'Cytochrome c oxidase subunit 6A1', NULL, NULL, NULL, NULL, NULL, 4),
(182877, NULL, 'G3DSA:2.40.50.690:FF:000013', NULL, NULL, 'Putative ribonuclease II-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(182878, NULL, 'G3DSA:3.90.550.50:FF:000102', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(182879, NULL, 'G3DSA:3.40.1090.10:FF:000110', NULL, NULL, 'Lysophospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(182880, NULL, 'G3DSA:3.40.50.12650:FF:000004', NULL, NULL, 'DNA cross-link repair 1A protein', NULL, NULL, NULL, NULL, NULL, 4),
(182881, NULL, 'G3DSA:1.10.10.10:FF:001289', NULL, NULL, 'Transcriptional regulator SlyA', NULL, NULL, NULL, NULL, NULL, 4),
(182882, NULL, 'G3DSA:1.10.238.10:FF:000025', NULL, NULL, 'serine/threonine-protein phosphatase 2A regulatory subunit B'''' subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(182883, NULL, 'G3DSA:2.30.30.40:FF:000177', NULL, NULL, 'Rho guanine nucleotide exchange factor (GEF) 37', NULL, NULL, NULL, NULL, NULL, 4),
(182884, NULL, 'G3DSA:2.130.10.10:FF:000073', NULL, NULL, 'DNA damage-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(182885, NULL, 'G3DSA:2.60.40.10:FF:005945', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182886, NULL, 'G3DSA:3.10.490.10:FF:000053', NULL, NULL, 'Gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(182887, NULL, 'G3DSA:3.30.230.80:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182888, NULL, 'G3DSA:1.10.20.10:FF:000126', NULL, NULL, 'Histone H2A', NULL, NULL, NULL, NULL, NULL, 4),
(182889, NULL, 'G3DSA:2.40.10.10:FF:000077', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(182890, NULL, 'G3DSA:1.10.520.10:FF:000069', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(182891, NULL, 'G3DSA:3.40.50.970:FF:000200', NULL, NULL, 'Acetolactate synthase, catabolic, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182892, NULL, 'G3DSA:2.60.40.10:FF:004164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182893, NULL, 'G3DSA:3.30.160.60:FF:001679', NULL, NULL, 'Zinc finger and BTB domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(182894, NULL, 'G3DSA:3.80.20.20:FF:000014', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(182895, NULL, 'G3DSA:3.50.50.60:FF:001266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182896, NULL, 'G3DSA:3.90.79.10:FF:000040', NULL, NULL, 'Nudix hydrolase 19, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(182897, NULL, 'G3DSA:3.40.50.300:FF:003220', NULL, NULL, 'ATP-dependent DNA helicase DDX11', NULL, NULL, NULL, NULL, NULL, 4),
(182898, NULL, 'G3DSA:3.40.50.300:FF:000786', NULL, NULL, 'E3 ubiquitin-protein ligase SHPRH isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(182899, NULL, 'G3DSA:3.30.40.10:FF:000301', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(182900, NULL, 'G3DSA:1.20.58.830:FF:000046', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(182901, NULL, 'G3DSA:1.10.510.10:FF:004166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182902, NULL, 'G3DSA:1.10.1420.10:FF:000072', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(182903, NULL, 'G3DSA:2.30.30.940:FF:000002', NULL, NULL, 'ATP-dependent RecD-like DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(182904, NULL, 'G3DSA:1.10.630.10:FF:000544', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182905, NULL, 'G3DSA:1.20.85.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182906, NULL, 'G3DSA:3.80.10.10:FF:001820', NULL, NULL, 'WGS project CABT00000000 data, contig 2.1', NULL, NULL, NULL, NULL, NULL, 4),
(182907, NULL, 'G3DSA:3.30.200.20:FF:001716', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182908, NULL, 'G3DSA:2.60.120.200:FF:000791', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182909, NULL, 'G3DSA:1.20.120.980:FF:000034', NULL, NULL, 'Clan SC, family S28, unassigned serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(182910, NULL, 'G3DSA:2.60.40.10:FF:000095', NULL, NULL, 'immunoglobulin superfamily member 11 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(182911, NULL, 'G3DSA:3.40.1110.10:FF:000248', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182912, NULL, 'G3DSA:3.60.21.10:FF:000251', NULL, NULL, 'Sphingomyelinase phosphodiesterase D', NULL, NULL, NULL, NULL, NULL, 4),
(182913, NULL, 'G3DSA:3.20.20.100:FF:000197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182914, NULL, 'G3DSA:3.30.830.10:FF:000316', NULL, NULL, 'Os02g0761400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(182915, NULL, 'G3DSA:2.130.10.10:FF:002051', NULL, NULL, 'GM25543', NULL, NULL, NULL, NULL, NULL, 4),
(182916, NULL, 'G3DSA:3.40.50.1820:FF:001342', NULL, NULL, 'Clan SC, family S9, acylaminoacyl-peptidase-like serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(182917, NULL, 'G3DSA:3.10.580.10:FF:000026', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(182918, NULL, 'G3DSA:3.40.50.2300:FF:001559', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182919, NULL, 'G3DSA:1.50.40.10:FF:000569', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(182920, NULL, 'G3DSA:3.40.50.150:FF:000073', NULL, NULL, 'THUMP domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(182921, NULL, 'G3DSA:1.10.510.10:FF:003823', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182922, NULL, 'G3DSA:3.30.1120.10:FF:000026', NULL, NULL, 'Sulfatase YidJ', NULL, NULL, NULL, NULL, NULL, 4),
(182923, NULL, 'G3DSA:2.60.40.10:FF:002073', NULL, NULL, 'Ig lambda-1 chain V regions MOPC 104E/RPC20/J558/S104', NULL, NULL, NULL, NULL, NULL, 4),
(182924, NULL, 'G3DSA:3.30.505.10:FF:000112', NULL, NULL, 'Si:ch211-25d12.7', NULL, NULL, NULL, NULL, NULL, 4),
(182925, NULL, 'G3DSA:2.60.120.40:FF:000004', NULL, NULL, 'Ectodysplasin-A isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(182926, NULL, 'G3DSA:3.90.70.10:FF:000227', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182927, NULL, 'G3DSA:1.10.238.10:FF:000351', NULL, NULL, 'cDNA clone:J023105D07, full insert sequence', NULL, NULL, NULL, NULL, NULL, 4),
(182928, NULL, 'G3DSA:3.40.1350.10:FF:000029', NULL, NULL, 'Endonuclease NucS', NULL, NULL, NULL, NULL, NULL, 4),
(182929, NULL, 'G3DSA:1.20.890.10:FF:000010', NULL, NULL, 'Putative adenylate kinase 7', NULL, NULL, NULL, NULL, NULL, 4),
(182930, NULL, 'G3DSA:2.40.20.10:FF:000049', NULL, NULL, 'Plasminogen', NULL, NULL, NULL, NULL, NULL, 4),
(182931, NULL, 'G3DSA:3.30.70.1820:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182932, NULL, 'G3DSA:3.40.630.10:FF:000462', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182933, NULL, 'G3DSA:3.40.850.10:FF:000001', NULL, NULL, 'Unconventional myosin XI', NULL, NULL, NULL, NULL, NULL, 4),
(182934, NULL, 'G3DSA:3.30.160.60:FF:000870', NULL, NULL, 'zinc finger protein 197 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(182935, NULL, 'G3DSA:1.25.40.10:FF:002432', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g17210', NULL, NULL, NULL, NULL, NULL, 4),
(182936, NULL, 'G3DSA:2.130.10.10:FF:002197', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(182937, NULL, 'G3DSA:3.40.640.10:FF:000401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182938, NULL, 'G3DSA:3.40.50.720:FF:001165', NULL, NULL, 'Pentafunctional AROM polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(182939, NULL, 'G3DSA:3.20.20.140:FF:000422', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182940, NULL, 'G3DSA:3.40.525.10:FF:000004', NULL, NULL, 'Neurofibromin 1', NULL, NULL, NULL, NULL, NULL, 4),
(182941, NULL, 'G3DSA:2.60.120.920:FF:000208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182942, NULL, 'G3DSA:3.40.50.720:FF:001811', NULL, NULL, 'Probable polyketide synthase 16', NULL, NULL, NULL, NULL, NULL, 4),
(182943, NULL, 'G3DSA:2.40.128.10:FF:000001', NULL, NULL, 'Protease inhibitor Inh', NULL, NULL, NULL, NULL, NULL, 4),
(182944, NULL, 'G3DSA:3.40.50.300:FF:002231', NULL, NULL, 'Cytidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(182945, NULL, 'G3DSA:2.130.10.10:FF:000752', NULL, NULL, 'Coatomer alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182946, NULL, 'G3DSA:3.30.9.10:FF:000268', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(182947, NULL, 'G3DSA:1.10.287.130:FF:000175', NULL, NULL, 'Sensory box histidine kinase SdeK', NULL, NULL, NULL, NULL, NULL, 4),
(182948, NULL, 'G3DSA:3.40.630.30:FF:000468', NULL, NULL, 'Acyl-CoA N-acyltransferase (NAT) superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(182949, NULL, 'G3DSA:3.40.50.10710:FF:000001', NULL, NULL, 'Ribonuclease J', NULL, NULL, NULL, NULL, NULL, 4),
(182950, NULL, 'G3DSA:3.40.50.300:FF:001303', NULL, NULL, 'ATP binding cassette subfamily C member 11', NULL, NULL, NULL, NULL, NULL, 4),
(182951, NULL, 'G3DSA:1.10.3730.20:FF:000059', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(182952, NULL, 'G3DSA:3.30.420.10:FF:000561', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182953, NULL, 'G3DSA:3.30.870.10:FF:000055', NULL, NULL, 'Tyrosyl-DNA phosphodiesterase 1', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(182954, NULL, 'G3DSA:2.60.40.150:FF:000272', NULL, NULL, 'Putative RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(182955, NULL, 'G3DSA:2.30.29.30:FF:000103', NULL, NULL, 'Pleckstrin homology domain-containing family A member 4', NULL, NULL, NULL, NULL, NULL, 4),
(182956, NULL, 'G3DSA:1.10.8.60:FF:000375', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(182957, NULL, 'G3DSA:3.30.420.510:FF:000008', NULL, NULL, 'Pantothenate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(182958, NULL, 'G3DSA:1.10.357.60:FF:000002', NULL, NULL, 'Exocyst complex protein EXO70', NULL, NULL, NULL, NULL, NULL, 4),
(182959, NULL, 'G3DSA:3.40.50.10130:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182960, NULL, 'G3DSA:2.10.25.10:FF:001450', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(182961, NULL, 'G3DSA:3.60.40.10:FF:000289', NULL, NULL, 'Protein phosphatase, Mg2+/Mn2+-dependent 1G', NULL, NULL, NULL, NULL, NULL, 4),
(182962, NULL, 'G3DSA:3.30.70.330:FF:001583', NULL, NULL, 'Activator of basal transcription 1', NULL, NULL, NULL, NULL, NULL, 4),
(182963, NULL, 'G3DSA:2.160.20.60:FF:000002', NULL, NULL, 'Glutamate synthase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(182964, NULL, 'G3DSA:2.60.40.1930:FF:000028', NULL, NULL, 'Thioester-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(182965, NULL, 'G3DSA:3.90.226.10:FF:000343', NULL, NULL, '4-chlorobenzoyl coenzyme A dehalogenase', NULL, NULL, NULL, NULL, NULL, 4),
(182966, NULL, 'G3DSA:3.30.70.80:FF:000043', NULL, NULL, 'Subtilisin-like protease SBT2.4', NULL, NULL, NULL, NULL, NULL, 4),
(182967, NULL, 'G3DSA:3.80.10.10:FF:002922', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182968, NULL, 'G3DSA:1.20.58.70:FF:000106', NULL, NULL, 'Qa-SNARE, Sso1/Syntaxin1-type, SYP13 group', NULL, NULL, NULL, NULL, NULL, 4),
(182969, NULL, 'G3DSA:3.40.50.300:FF:004322', NULL, NULL, 'Os03g0722400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(182970, NULL, 'G3DSA:3.40.50.150:FF:001854', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182971, NULL, 'G3DSA:3.40.50.300:FF:006093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182972, NULL, 'G3DSA:2.60.200.20:FF:000112', NULL, NULL, 'Serine/threonine protein kinase Chk2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182973, NULL, 'G3DSA:1.10.10.10:FF:000041', NULL, NULL, 'Interferon regulatory factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(182974, NULL, 'G3DSA:2.160.20.70:FF:000005', NULL, NULL, 'TBCC domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(182975, NULL, 'G3DSA:2.90.10.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182976, NULL, 'G3DSA:3.30.420.80:FF:000003', NULL, NULL, '30S ribosomal protein S11, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(182977, NULL, 'G3DSA:3.10.20.90:FF:000437', NULL, NULL, 'AFaDin (Actin filament binding protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(182978, NULL, 'G3DSA:1.25.10.10:FF:002284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182979, NULL, 'G3DSA:1.50.40.10:FF:000395', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182980, NULL, 'G3DSA:1.20.1020.10:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(182981, NULL, 'G3DSA:3.40.30.10:FF:000508', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(182982, NULL, 'G3DSA:2.10.50.10:FF:000148', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 1A', NULL, NULL, NULL, NULL, NULL, 4),
(182983, NULL, 'G3DSA:3.90.550.10:FF:000523', NULL, NULL, 'Dolichol-phosphate mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(182984, NULL, 'G3DSA:2.60.120.10:FF:000754', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(182985, NULL, 'G3DSA:1.10.287.370:FF:000016', NULL, NULL, 'Prefoldin subunit 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(182986, NULL, 'G3DSA:1.20.58.60:FF:000103', NULL, NULL, 'Nesprin-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(182987, NULL, 'G3DSA:3.15.20.10:FF:000015', NULL, NULL, 'Ovocalyxin-36 (Uncharacterized protein)', NULL, NULL, NULL, NULL, NULL, 4),
(182988, NULL, 'G3DSA:3.40.50.10810:FF:000031', NULL, NULL, 'Helicase, SNF2/RAD54 family', NULL, NULL, NULL, NULL, NULL, 4),
(182989, NULL, 'G3DSA:3.30.460.10:FF:000209', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(182990, NULL, 'G3DSA:1.10.1200.10:FF:000174', NULL, NULL, 'Microperfuranone synthase', NULL, NULL, NULL, NULL, NULL, 4),
(182991, NULL, 'G3DSA:2.130.10.10:FF:003978', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(182992, NULL, 'G3DSA:1.10.510.10:FF:000097', NULL, NULL, 'Putative cyclin-dependent kinase 7', NULL, NULL, NULL, NULL, NULL, 4),
(182993, NULL, 'G3DSA:1.10.506.10:FF:000053', NULL, NULL, 'Plexin A2', NULL, NULL, NULL, NULL, NULL, 4),
(182994, NULL, 'G3DSA:2.30.29.30:FF:000749', NULL, NULL, 'Vacuolar protein sorting protein (Vps36), putative', NULL, NULL, NULL, NULL, NULL, 4),
(182995, NULL, 'G3DSA:1.10.8.10:FF:000293', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(182996, NULL, 'G3DSA:2.160.20.80:FF:000008', NULL, NULL, 'Pentapeptide repeat protein MfpA', NULL, NULL, NULL, NULL, NULL, 4),
(182997, NULL, 'G3DSA:2.40.70.10:FF:000086', NULL, NULL, 'ASpartyl Protease', NULL, NULL, NULL, NULL, NULL, 4),
(182998, NULL, 'G3DSA:1.25.40.10:FF:002106', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(182999, NULL, 'G3DSA:1.10.390.10:FF:000036', NULL, NULL, 'Aminopeptidase-like protein AC3.5', NULL, NULL, NULL, NULL, NULL, 4),
(183000, NULL, 'G3DSA:3.30.457.60:FF:000003', NULL, NULL, 'Spindle assembly checkpoint component MAD1', NULL, NULL, NULL, NULL, NULL, 4),
(183001, NULL, 'G3DSA:3.30.420.10:FF:000089', NULL, NULL, 'Ribonuclease H', NULL, NULL, NULL, NULL, NULL, 4),
(183002, NULL, 'G3DSA:1.20.58.390:FF:000195', NULL, NULL, 'Gamma-aminobutyric acid type A receptor rho3 subunit (gene/pseudogene)', NULL, NULL, NULL, NULL, NULL, 4),
(183003, NULL, 'G3DSA:3.30.40.10:FF:001083', NULL, NULL, 'E3 ubiquitin ligase BIG BROTHER-related', NULL, NULL, NULL, NULL, NULL, 4),
(183004, NULL, 'G3DSA:3.40.50.300:FF:001888', NULL, NULL, 'GTP-binding protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(183005, NULL, 'G3DSA:3.40.50.10860:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183006, NULL, 'G3DSA:2.130.10.10:FF:003299', NULL, NULL, 'Putative elongator complex protein 2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(183007, NULL, 'G3DSA:4.10.60.10:FF:000161', NULL, NULL, 'Terminal uridylyltransferase 7', NULL, NULL, NULL, NULL, NULL, 4),
(183008, NULL, 'G3DSA:1.20.5.390:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183009, NULL, 'G3DSA:2.40.30.10:FF:000140', NULL, NULL, 'Translation initiation factor IF-2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183010, NULL, 'G3DSA:3.40.630.30:FF:000529', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(183011, NULL, 'G3DSA:3.30.1680.10:FF:000028', NULL, NULL, 'Semaphorin-5c', NULL, NULL, NULL, NULL, NULL, 4),
(183012, NULL, 'G3DSA:3.40.50.880:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183013, NULL, 'G3DSA:1.25.10.10:FF:003386', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183014, NULL, 'G3DSA:3.40.640.10:FF:000108', NULL, NULL, 'Serine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(183015, NULL, 'G3DSA:3.30.930.10:FF:000173', NULL, NULL, 'Octanoyl-[GcvH]:protein N-octanoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(183016, NULL, 'G3DSA:3.30.565.10:FF:000121', NULL, NULL, 'Putative DNA topoisomerase VI, b subunit', NULL, NULL, NULL, NULL, NULL, 4),
(183017, NULL, 'G3DSA:1.10.510.10:FF:002042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183018, NULL, 'G3DSA:2.60.40.1180:FF:000202', NULL, NULL, 'Alpha-L-arabinofuranosidase 1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(183019, NULL, 'G3DSA:3.40.50.1100:FF:000019', NULL, NULL, 'D-cysteine desulfhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(183020, NULL, 'G3DSA:3.40.50.1000:FF:000287', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(183021, NULL, 'G3DSA:1.25.10.10:FF:000513', NULL, NULL, 'Hym1p', NULL, NULL, NULL, NULL, NULL, 4),
(183022, NULL, 'G3DSA:2.60.40.10:FF:004490', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183023, NULL, 'G3DSA:1.20.272.10:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183024, NULL, 'G3DSA:3.30.30.10:FF:000003', NULL, NULL, 'Defensin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(183025, NULL, 'G3DSA:3.40.50.2020:FF:000138', NULL, NULL, 'Phosphoribosyl pyrophosphate synthase-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(183026, NULL, 'G3DSA:3.40.47.10:FF:000018', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(183027, NULL, 'G3DSA:4.10.1110.10:FF:000001', NULL, NULL, 'Zinc finger AN1-type containing 6', NULL, NULL, NULL, NULL, NULL, 4),
(183028, NULL, 'G3DSA:1.25.40.10:FF:000015', NULL, NULL, 'Outer membrane protein assembly factor BamD', NULL, NULL, NULL, NULL, NULL, 4),
(183029, NULL, 'G3DSA:2.40.160.110:FF:000012', NULL, NULL, 'LAMP (Lysosome-associated membrane protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(183030, NULL, 'G3DSA:1.10.287.470:FF:000046', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(183031, NULL, 'G3DSA:1.20.1070.10:FF:001150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183032, NULL, 'G3DSA:2.60.40.790:FF:000082', NULL, NULL, 'Heat shock protein Hsp', NULL, NULL, NULL, NULL, NULL, 4),
(183033, NULL, 'G3DSA:3.30.390.50:FF:000024', NULL, NULL, 'Lipoate-protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183034, NULL, 'G3DSA:1.10.510.10:FF:002721', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183035, NULL, 'G3DSA:3.30.70.330:FF:001644', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183036, NULL, 'G3DSA:1.10.533.10:FF:000048', NULL, NULL, 'MEFV, pyrin innate immunity regulator', NULL, NULL, NULL, NULL, NULL, 4),
(183037, NULL, 'G3DSA:1.10.275.40:FF:000007', NULL, NULL, 'DNA repair helicase rad3/xp-D, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183038, NULL, 'G3DSA:2.10.109.10:FF:000031', NULL, NULL, 'Phage repressor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(183039, NULL, 'G3DSA:3.40.449.10:FF:000001', NULL, NULL, 'Phosphoenolpyruvate carboxykinase (ATP)', NULL, NULL, NULL, NULL, NULL, 4),
(183040, NULL, 'G3DSA:1.10.287.1490:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183041, NULL, 'G3DSA:1.20.1250.20:FF:001251', NULL, NULL, 'AGAP011492-PA', NULL, NULL, NULL, NULL, NULL, 4),
(183042, NULL, 'G3DSA:1.10.10.60:FF:001197', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183043, NULL, 'G3DSA:2.70.130.10:FF:000174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183044, NULL, 'G3DSA:3.40.720.10:FF:000109', NULL, NULL, 'Arylsulfatase A', NULL, NULL, NULL, NULL, NULL, 4),
(183045, NULL, 'G3DSA:3.10.290.60:FF:000007', NULL, NULL, 'Ubiquitin-activating enzyme E1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183046, NULL, 'G3DSA:1.10.455.10:FF:000029', NULL, NULL, 'Ribosomal protein S7p/S5e', NULL, NULL, NULL, NULL, NULL, 4),
(183047, NULL, 'G3DSA:3.90.780.10:FF:000006', NULL, NULL, '2'',3''-cyclic-nucleotide 2''-phosphodiesterase / 3''-nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(183048, NULL, 'G3DSA:3.30.1360.210:FF:000003', NULL, NULL, '60S ribosomal protein L22-B', NULL, NULL, NULL, NULL, NULL, 4),
(183049, NULL, 'G3DSA:3.40.50.300:FF:005783', NULL, NULL, 'cGMP binding protein with small GTPase-serine/threonine kinase-dep-rasgef-gram-and two cGMP binding domains', NULL, NULL, NULL, NULL, NULL, 4),
(183050, NULL, 'G3DSA:1.10.3430.10:FF:000011', NULL, NULL, 'Ammonium transporter', NULL, NULL, NULL, NULL, NULL, 4),
(183051, NULL, 'G3DSA:2.60.40.1910:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(183052, NULL, 'G3DSA:3.90.70.10:FF:000492', NULL, NULL, 'ubiquitin carboxyl-terminal hydrolase 44-like', NULL, NULL, NULL, NULL, NULL, 4),
(183053, NULL, 'G3DSA:1.20.930.80:FF:000012', NULL, NULL, 'Eukaryotic-type DNA primase, large subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(183054, NULL, 'G3DSA:3.30.40.10:FF:001403', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(183055, NULL, 'G3DSA:1.25.40.20:FF:000018', NULL, NULL, 'Transient receptor potential cation channel subfamily V member 1', NULL, NULL, NULL, NULL, NULL, 4),
(183056, NULL, 'G3DSA:3.40.50.740:FF:000036', NULL, NULL, 'NADH-quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(183057, NULL, 'G3DSA:3.40.50.300:FF:004529', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(183058, NULL, 'G3DSA:3.40.30.10:FF:000660', NULL, NULL, 'Alkyl hydroperoxide reductase/ Thiol specific antioxidant/ Mal allergen', NULL, NULL, NULL, NULL, NULL, 4),
(183059, NULL, 'G3DSA:3.40.50.300:FF:007874', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183060, NULL, 'G3DSA:2.30.180.10:FF:000152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183061, NULL, 'G3DSA:1.10.418.10:FF:000062', NULL, NULL, 'Kinesin-like protein KIN-14I isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(183062, NULL, 'G3DSA:3.40.50.10810:FF:000177', NULL, NULL, 'SNF2 superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(183063, NULL, 'G3DSA:1.10.510.10:FF:000417', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(183064, NULL, 'G3DSA:2.40.33.10:FF:000028', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(183065, NULL, 'G3DSA:3.30.200.20:FF:002205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183066, NULL, 'G3DSA:3.90.70.10:FF:000520', NULL, NULL, 'Ubiquitin C-terminal hydrolase, putative (AFU_orthologue AFUA_2G08440)', NULL, NULL, NULL, NULL, NULL, 4),
(183067, NULL, 'G3DSA:3.80.10.10:FF:000977', NULL, NULL, 'Extracellular matrix protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(183068, NULL, 'G3DSA:3.30.160.20:FF:000173', NULL, NULL, 'Eukaryotic translation initiation factor 2 alpha kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(183069, NULL, 'G3DSA:3.30.1360.120:FF:000009', NULL, NULL, 'dimethylglycine dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(183070, NULL, 'G3DSA:3.40.50.300:FF:002377', NULL, NULL, 'Sulfate adenylyltransferase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(183071, NULL, 'G3DSA:1.25.70.10:FF:000017', NULL, NULL, 'Transcription termination factor MTEF18, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(183072, NULL, 'G3DSA:2.60.120.330:FF:000099', NULL, NULL, 'Protein SRG1', NULL, NULL, NULL, NULL, NULL, 4),
(183073, NULL, 'G3DSA:2.30.33.40:FF:000004', NULL, NULL, '10 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(183074, NULL, 'G3DSA:3.30.160.60:FF:003596', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183075, NULL, 'G3DSA:2.60.40.10:FF:000156', NULL, NULL, 'Tenascin N', NULL, NULL, NULL, NULL, NULL, 4),
(183076, NULL, 'G3DSA:1.10.132.60:FF:000002', NULL, NULL, 'DNA polymerase epsilon catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(183077, NULL, 'G3DSA:3.90.550.50:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183078, NULL, 'G3DSA:3.40.50.300:FF:004029', NULL, NULL, 'Os04g0658400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(183079, NULL, 'G3DSA:3.30.160.60:FF:006058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183080, NULL, 'G3DSA:1.20.144.10:FF:000030', NULL, NULL, 'Phosphatidic acid phosphatase type 2D', NULL, NULL, NULL, NULL, NULL, 4),
(183081, NULL, 'G3DSA:2.30.29.30:FF:001059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183082, NULL, 'G3DSA:3.40.50.10090:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183083, NULL, 'G3DSA:1.10.510.10:FF:000125', NULL, NULL, 'serine/threonine-protein kinase BLUS1-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(183084, NULL, 'G3DSA:3.40.50.720:FF:001665', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183085, NULL, 'G3DSA:3.40.50.12350:FF:000004', NULL, NULL, 'Eyes absent homolog', NULL, NULL, NULL, NULL, NULL, 4),
(183086, NULL, 'G3DSA:2.70.170.10:FF:000148', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(183087, NULL, 'G3DSA:3.90.70.10:FF:000166', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(183088, NULL, 'G3DSA:3.40.190.100:FF:000003', NULL, NULL, 'Glycine betaine-binding protein OpuAC', NULL, NULL, NULL, NULL, NULL, 4),
(183089, NULL, 'G3DSA:1.10.287.3510:FF:000015', NULL, NULL, 'NADH dehydrogenase subunit 4L (K,kappa)', NULL, NULL, NULL, NULL, NULL, 4),
(183090, NULL, 'G3DSA:3.40.50.2000:FF:000132', NULL, NULL, 'alpha-1,3/1,6-mannosyltransferase ALG2', NULL, NULL, NULL, NULL, NULL, 4),
(183091, NULL, 'G3DSA:3.30.565.10:FF:000267', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(183092, NULL, 'G3DSA:3.30.160.60:FF:002461', NULL, NULL, 'Zinc finger matrin-type protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(183093, NULL, 'G3DSA:1.20.5.110:FF:000095', NULL, NULL, 'TOMosyn synaptic protein', NULL, NULL, NULL, NULL, NULL, 4),
(183094, NULL, 'G3DSA:3.60.10.10:FF:000169', NULL, NULL, 'Endonuclease/exonuclease protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(183095, NULL, 'G3DSA:1.20.5.50:FF:000006', NULL, NULL, 'Fibrinogen alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(183096, NULL, 'G3DSA:3.40.80.10:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183097, NULL, 'G3DSA:3.40.50.1240:FF:000128', NULL, NULL, 'Histidine phosphatase superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(183098, NULL, 'G3DSA:3.40.50.410:FF:000347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183099, NULL, 'G3DSA:3.30.70.1230:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183100, NULL, 'G3DSA:3.40.50.300:FF:004176', NULL, NULL, 'Helicase conserved C-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(183101, NULL, 'G3DSA:3.40.50.1000:FF:000107', NULL, NULL, 'Bifunctional epoxide hydrolase 2', NULL, NULL, NULL, NULL, NULL, 4),
(183102, NULL, 'G3DSA:1.50.10.150:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183103, NULL, 'G3DSA:4.10.400.10:FF:000004', NULL, NULL, 'Low-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(183104, NULL, 'G3DSA:1.10.132.70:FF:000005', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(183105, NULL, 'G3DSA:3.40.720.10:FF:000374', NULL, NULL, 'Arylsulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(183106, NULL, 'G3DSA:3.30.160.60:FF:004259', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183107, NULL, 'G3DSA:2.60.40.1450:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183108, NULL, 'G3DSA:3.40.50.10490:FF:000098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183109, NULL, 'G3DSA:1.50.10.130:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183110, NULL, 'G3DSA:2.130.10.10:FF:002225', NULL, NULL, 'Notchless-like protein isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(183111, NULL, 'G3DSA:3.30.70.330:FF:003089', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183112, NULL, 'G3DSA:3.40.720.10:FF:000082', NULL, NULL, 'Protein CBG10792', NULL, NULL, NULL, NULL, NULL, 4),
(183113, NULL, 'G3DSA:3.40.50.1820:FF:001516', NULL, NULL, 'Triacylglycerol lipase 2', NULL, NULL, NULL, NULL, NULL, 4),
(183114, NULL, 'G3DSA:2.60.40.10:FF:001876', NULL, NULL, 'FiLamiN (Actin binding protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(183115, NULL, 'G3DSA:2.60.40.10:FF:001584', NULL, NULL, 'V-set and immunoglobulin domain-containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(183116, NULL, 'G3DSA:3.80.10.10:FF:002776', NULL, NULL, 'Leucine-rich repeat-containing protein 59-like Protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(183117, NULL, 'G3DSA:2.70.98.10:FF:000047', NULL, NULL, 'Chondroitin sulfate ABC lyase', NULL, NULL, NULL, NULL, NULL, 4),
(183118, NULL, 'G3DSA:3.30.1330.30:FF:000104', NULL, NULL, '50S ribosomal protein L30e', NULL, NULL, NULL, NULL, NULL, 4),
(183119, NULL, 'G3DSA:3.60.15.10:FF:000045', NULL, NULL, 'Hydroxyacylglutathione hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(183120, NULL, 'G3DSA:3.40.50.300:FF:001388', NULL, NULL, 'Probable pre-mRNA-splicing factor ATP-dependent RNA helicase DEAH4', NULL, NULL, NULL, NULL, NULL, 4),
(183121, NULL, 'G3DSA:3.30.110.40:FF:000001', NULL, NULL, 'SirA-like family protein', NULL, NULL, NULL, NULL, NULL, 4),
(183122, NULL, 'G3DSA:1.25.40.10:FF:004410', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(183123, NULL, 'G3DSA:2.40.30.180:FF:000002', NULL, NULL, 'Ubiquitin-activating enzyme E1 2', NULL, NULL, NULL, NULL, NULL, 4),
(183124, NULL, 'G3DSA:1.20.5.490:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183125, NULL, 'G3DSA:2.170.270.10:FF:000025', NULL, NULL, 'MDS1 and EVI1 complex locus protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(183126, NULL, 'G3DSA:2.10.25.10:FF:001803', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183127, NULL, 'G3DSA:2.60.40.10:FF:005592', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183128, NULL, 'G3DSA:3.70.10.10:FF:000028', NULL, NULL, 'DNA polymerase processivity factor', NULL, NULL, NULL, NULL, NULL, 4),
(183129, NULL, 'G3DSA:3.40.50.720:FF:001339', NULL, NULL, 'Ketoacyl reductase hetN', NULL, NULL, NULL, NULL, NULL, 4),
(183130, NULL, 'G3DSA:3.40.50.300:FF:002731', NULL, NULL, 'Protein CBG14243', NULL, NULL, NULL, NULL, NULL, 4),
(183131, NULL, 'G3DSA:2.40.50.430:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183132, NULL, 'G3DSA:3.30.360.10:FF:000090', NULL, NULL, 'Lysine-ketoglutarate reductase/saccharopine dehydrogenase bifunctional enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(183133, NULL, 'G3DSA:1.20.1390.10:FF:000004', NULL, NULL, 'RNA-binding motif protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(183134, NULL, 'G3DSA:1.40.20.10:FF:000001', NULL, NULL, 'Adenylate cyclase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183135, NULL, 'G3DSA:3.40.140.10:FF:000115', NULL, NULL, 'COP9 signalosome subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183136, NULL, 'G3DSA:1.10.220.10:FF:000024', NULL, NULL, 'AnNEXin family', NULL, NULL, NULL, NULL, NULL, 4),
(183137, NULL, 'G3DSA:2.60.40.60:FF:000031', NULL, NULL, 'Cadherin 3', NULL, NULL, NULL, NULL, NULL, 4),
(183138, NULL, 'G3DSA:1.10.10.60:FF:000415', NULL, NULL, 'Transcriptional activator MltR', NULL, NULL, NULL, NULL, NULL, 4),
(183139, NULL, 'G3DSA:1.50.40.10:FF:000423', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183140, NULL, 'G3DSA:3.30.70.20:FF:000132', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183141, NULL, 'G3DSA:4.10.960.10:FF:000006', NULL, NULL, 'Putative ribosomal protein L3, Translation protein, beta-barrel domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(183142, NULL, 'G3DSA:1.10.10.580:FF:000005', NULL, NULL, 'Double-strand-break repair protein rad21', NULL, NULL, NULL, NULL, NULL, 4),
(183143, NULL, 'G3DSA:2.60.34.10:FF:000035', NULL, NULL, 'Heat shock protein 70, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183144, NULL, 'G3DSA:1.10.510.10:FF:001878', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183145, NULL, 'G3DSA:2.60.40.1460:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183146, NULL, 'G3DSA:2.60.40.10:FF:006081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183147, NULL, 'G3DSA:2.130.10.10:FF:000426', NULL, NULL, 'intraflagellar transport protein 122 homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(183148, NULL, 'G3DSA:2.60.40.10:FF:004310', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183149, NULL, 'G3DSA:2.30.29.30:FF:000396', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(183150, NULL, 'G3DSA:1.10.10.570:FF:000002', NULL, NULL, 'Vacuolar protein sorting-associated protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(183151, NULL, 'G3DSA:3.90.79.10:FF:000247', NULL, NULL, 'MutT/NUDIX hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(183152, NULL, 'G3DSA:2.180.10.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183153, NULL, 'G3DSA:1.10.10.60:FF:000269', NULL, NULL, 'Transcription factor MYB46', NULL, NULL, NULL, NULL, NULL, 4),
(183154, NULL, 'G3DSA:1.10.150.240:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183155, NULL, 'G3DSA:2.20.28.10:FF:000034', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(183156, NULL, 'G3DSA:1.20.140.100:FF:000005', NULL, NULL, 'cytoplasmic dynein 2 heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(183157, NULL, 'G3DSA:4.10.1000.10:FF:000139', NULL, NULL, 'LP05025p', NULL, NULL, NULL, NULL, NULL, 4),
(183158, NULL, 'G3DSA:3.40.640.10:FF:000081', NULL, NULL, 'Cysteine desulfurase CsdA', NULL, NULL, NULL, NULL, NULL, 4),
(183159, NULL, 'G3DSA:2.60.40.150:FF:000564', NULL, NULL, 'Multiple C2 and transmembrane domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(183160, NULL, 'G3DSA:3.40.50.300:FF:002405', NULL, NULL, 'Cytidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(183161, NULL, 'G3DSA:2.30.29.90:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183162, NULL, 'G3DSA:3.10.105.10:FF:000108', NULL, NULL, 'Oligopeptide-binding protein oppA', NULL, NULL, NULL, NULL, NULL, 4),
(183163, NULL, 'G3DSA:1.10.3160.10:FF:000001', NULL, NULL, 'Putative antigen P35', NULL, NULL, NULL, NULL, NULL, 4),
(183164, NULL, 'G3DSA:4.10.280.10:FF:000207', NULL, NULL, 'Transcription factor bHLH117', NULL, NULL, NULL, NULL, NULL, 4),
(183165, NULL, 'G3DSA:2.60.40.10:FF:005619', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183166, NULL, 'G3DSA:3.30.160.190:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183167, NULL, 'G3DSA:2.130.10.10:FF:004142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183168, NULL, 'G3DSA:3.40.710.10:FF:000137', NULL, NULL, 'Penicillin-binding protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(183169, NULL, 'G3DSA:1.10.860.10:FF:000027', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(183170, NULL, 'G3DSA:1.10.287.110:FF:000461', NULL, NULL, 'Chaperone protein dnaJ 1 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(183171, NULL, 'G3DSA:3.10.330.10:FF:000013', NULL, NULL, 'N-ethylmaleimide-sensitive fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(183172, NULL, 'G3DSA:1.10.8.210:FF:000003', NULL, NULL, 'Siroheme synthase component enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(183173, NULL, 'G3DSA:3.30.70.330:FF:001318', NULL, NULL, 'Splicing factor U2AF subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183174, NULL, 'G3DSA:3.40.50.1820:FF:000499', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(183175, NULL, 'G3DSA:1.10.439.20:FF:000001', NULL, NULL, 'Phospholipase B-like', NULL, NULL, NULL, NULL, NULL, 4),
(183176, NULL, 'G3DSA:1.10.10.60:FF:000241', NULL, NULL, 'homeobox-leucine zipper protein ATHB-40', NULL, NULL, NULL, NULL, NULL, 4),
(183177, NULL, 'G3DSA:1.20.870.10:FF:000008', NULL, NULL, 'RAS guanyl-releasing protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(183178, NULL, 'G3DSA:1.10.8.270:FF:000061', NULL, NULL, 'GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(183179, NULL, 'G3DSA:2.130.10.10:FF:003686', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183180, NULL, 'G3DSA:1.10.10.2010:FF:000002', NULL, NULL, 'Smallminded, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(183181, NULL, 'G3DSA:3.10.20.90:FF:000263', NULL, NULL, 'gametogenetin-binding protein 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(183182, NULL, 'G3DSA:2.60.260.20:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(183183, NULL, 'G3DSA:3.10.330.20:FF:000016', NULL, NULL, 'tRNA (adenine(58)-N(1))-methyltransferase catalytic subunit TRMT61A', NULL, NULL, NULL, NULL, NULL, 4),
(183184, NULL, 'G3DSA:2.20.70.10:FF:000042', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(183185, NULL, 'G3DSA:3.30.160.60:FF:006204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183186, NULL, 'G3DSA:3.50.50.100:FF:000027', NULL, NULL, 'Mitochondrial apoptosis inducing factor', NULL, NULL, NULL, NULL, NULL, 4),
(183187, NULL, 'G3DSA:4.10.320.10:FF:000003', NULL, NULL, 'Acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(183188, NULL, 'G3DSA:3.90.228.10:FF:000033', NULL, NULL, 'UBA/TS-N domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(183189, NULL, 'G3DSA:3.30.160.60:FF:006384', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183190, NULL, 'G3DSA:3.90.1150.10:FF:000025', NULL, NULL, 'Glycine cleavage system P protein', NULL, NULL, NULL, NULL, NULL, 4),
(183191, NULL, 'G3DSA:1.20.1070.10:FF:001503', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183192, NULL, 'G3DSA:3.20.20.330:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183193, NULL, 'G3DSA:2.60.40.10:FF:005799', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183194, NULL, 'G3DSA:3.90.280.10:FF:000013', NULL, NULL, 'Protease inhibitor (Tfs1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(183195, NULL, 'G3DSA:3.30.70.980:FF:000029', NULL, NULL, 'Probable transcriptional regulatory protein ERS082928_00922', NULL, NULL, NULL, NULL, NULL, 4),
(183196, NULL, 'G3DSA:1.25.40.20:FF:000670', NULL, NULL, 'ankyrin repeat and KH domain-containing protein 1-like isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(183197, NULL, 'G3DSA:3.20.20.80:FF:000001', NULL, NULL, '1,4-alpha-glucan branching enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(183198, NULL, 'G3DSA:1.20.1440.340:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183199, NULL, 'G3DSA:2.130.10.10:FF:005895', NULL, NULL, 'Two component signal transduction system hybrid histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(183200, NULL, 'G3DSA:3.90.1100.10:FF:000022', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(183201, NULL, 'G3DSA:3.30.70.330:FF:001291', NULL, NULL, 'Nuclear transport factor 2 (NTF2) family protein with RNA binding (RRM-RBD-RNP motifs) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(183202, NULL, 'G3DSA:1.20.5.1930:FF:000009', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(183203, NULL, 'G3DSA:4.10.240.10:FF:000087', NULL, NULL, 'Sut2p', NULL, NULL, NULL, NULL, NULL, 4),
(183204, NULL, 'G3DSA:3.90.226.10:FF:000051', NULL, NULL, 'Protease 4', NULL, NULL, NULL, NULL, NULL, 4),
(183205, NULL, 'G3DSA:1.25.40.10:FF:004702', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183206, NULL, 'G3DSA:2.60.120.970:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183207, NULL, 'G3DSA:2.80.10.50:FF:000183', NULL, NULL, 'Fascin', NULL, NULL, NULL, NULL, NULL, 4),
(183208, NULL, 'G3DSA:3.40.630.30:FF:000294', NULL, NULL, 'N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(183209, NULL, 'G3DSA:3.30.40.100:FF:000007', NULL, NULL, 'B3 domain-containing transcription repressor VAL2', NULL, NULL, NULL, NULL, NULL, 4),
(183210, NULL, 'G3DSA:1.25.10.10:FF:000221', NULL, NULL, 'AP-3 adaptor complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(183211, NULL, 'G3DSA:3.20.20.70:FF:000083', NULL, NULL, 'tRNA-dihydrouridine(20/20a) synthase', NULL, NULL, NULL, NULL, NULL, 4),
(183212, NULL, 'G3DSA:1.10.3900.10:FF:000002', NULL, NULL, 'Cell division protein ZapD', NULL, NULL, NULL, NULL, NULL, 4),
(183213, NULL, 'G3DSA:3.40.50.2000:FF:001060', NULL, NULL, 'Protein CBG17822', NULL, NULL, NULL, NULL, NULL, 4),
(183214, NULL, 'G3DSA:2.60.40.10:FF:006108', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(183215, NULL, 'G3DSA:3.30.40.10:FF:001375', NULL, NULL, 'Fancl, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(183216, NULL, 'G3DSA:3.40.50.1000:FF:000433', NULL, NULL, 'Plasma membrane Ca2+ ATPase isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(183217, NULL, 'G3DSA:3.20.20.60:FF:000080', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(183218, NULL, 'G3DSA:3.30.1640.10:FF:000054', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(183219, NULL, 'G3DSA:2.120.10.80:FF:000043', NULL, NULL, 'Kelch domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(183220, NULL, 'G3DSA:2.10.70.10:FF:000211', NULL, NULL, 'Complement regulatory membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(183221, NULL, 'G3DSA:3.30.420.40:FF:000311', NULL, NULL, 'Xylulokinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183222, NULL, 'G3DSA:2.40.70.10:FF:000232', NULL, NULL, 'Acid protease', NULL, NULL, NULL, NULL, NULL, 4),
(183223, NULL, 'G3DSA:2.60.40.790:FF:000110', NULL, NULL, 'heat shock protein 67B3', NULL, NULL, NULL, NULL, NULL, 4),
(183224, NULL, 'G3DSA:3.30.70.340:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183225, NULL, 'G3DSA:1.10.1070.11:FF:000006', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(183226, NULL, 'G3DSA:3.20.80.10:FF:000029', NULL, NULL, 'AT1G78460 protein', NULL, NULL, NULL, NULL, NULL, 4),
(183227, NULL, 'G3DSA:1.25.10.10:FF:002430', NULL, NULL, 'Putative condensin subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(183228, NULL, 'G3DSA:2.40.30.10:FF:000314', NULL, NULL, 'Mitochondrial elongation factor G2', NULL, NULL, NULL, NULL, NULL, 4),
(183229, NULL, 'G3DSA:2.60.120.260:FF:000230', NULL, NULL, 'E3 ubiquitin-protein ligase HECTD1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(183230, NULL, 'G3DSA:3.30.70.330:FF:001936', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183231, NULL, 'G3DSA:3.40.50.300:FF:008071', NULL, NULL, 'F-box DNA helicase 1', NULL, NULL, NULL, NULL, NULL, 4),
(183232, NULL, 'G3DSA:1.20.5.110:FF:000269', NULL, NULL, 'Synaptosomal-associated protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(183233, NULL, 'G3DSA:3.10.20.30:FF:000026', NULL, NULL, 'MOSC domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(183234, NULL, 'G3DSA:1.10.1200.80:FF:000003', NULL, NULL, 'tRNA-dihydrouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(183235, NULL, 'G3DSA:3.90.70.10:FF:000727', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183236, NULL, 'G3DSA:2.40.10.10:FF:000431', NULL, NULL, 'GM19097', NULL, NULL, NULL, NULL, NULL, 4),
(183237, NULL, 'G3DSA:1.10.3290.10:FF:000005', NULL, NULL, 'Whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(183238, NULL, 'G3DSA:3.30.160.60:FF:004613', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183239, NULL, 'G3DSA:3.30.1360.70:FF:000011', NULL, NULL, 'Arginyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(183240, NULL, 'G3DSA:1.10.730.20:FF:000026', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(183241, NULL, 'G3DSA:3.40.120.10:FF:000053', NULL, NULL, '455aa long hypothetical phospho-sugar mutase', NULL, NULL, NULL, NULL, NULL, 4),
(183242, NULL, 'G3DSA:1.10.730.10:FF:000023', NULL, NULL, 'probable leucine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(183243, NULL, 'G3DSA:3.90.550.10:FF:000495', NULL, NULL, 'Putative UDP-N-acetylglucosamine pyrophosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(183244, NULL, 'G3DSA:3.40.50.300:FF:003866', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183245, NULL, 'G3DSA:3.10.110.10:FF:000210', NULL, NULL, 'Ubiquitin-conjugating enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183246, NULL, 'G3DSA:1.25.40.690:FF:000006', NULL, NULL, 'Unplaced genomic scaffold supercont1.219, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(183247, NULL, 'G3DSA:3.40.630.10:FF:000136', NULL, NULL, 'Silver, isoform N', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(183248, NULL, 'G3DSA:3.90.110.10:FF:000001', NULL, NULL, 'Malate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(183249, NULL, 'G3DSA:1.10.287.1490:FF:000100', NULL, NULL, 'AFR286Wp', NULL, NULL, NULL, NULL, NULL, 4),
(183250, NULL, 'G3DSA:2.70.170.10:FF:000120', NULL, NULL, 'Cholinergic receptor nicotinic epsilon subunit', NULL, NULL, NULL, NULL, NULL, 4),
(183251, NULL, 'G3DSA:2.130.10.10:FF:002551', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183252, NULL, 'G3DSA:3.40.30.10:FF:000834', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(183253, NULL, 'G3DSA:1.50.40.10:FF:000069', NULL, NULL, 'Solute carrier family 25 member 47', NULL, NULL, NULL, NULL, NULL, 4),
(183254, NULL, 'G3DSA:3.40.50.360:FF:000079', NULL, NULL, 'Putative NAD(P)H dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(183255, NULL, 'G3DSA:1.20.120.350:FF:000227', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183256, NULL, 'G3DSA:1.10.3080.10:FF:000085', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(183257, NULL, 'G3DSA:3.30.70.270:FF:000289', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183258, NULL, 'G3DSA:3.80.10.10:FF:004367', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183259, NULL, 'G3DSA:1.10.1050.20:FF:000001', NULL, NULL, 'DNA-binding protein rap1', NULL, NULL, NULL, NULL, NULL, 4),
(183260, NULL, 'G3DSA:3.20.20.70:FF:000318', NULL, NULL, 'Indole-3-glycerol phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(183261, NULL, 'G3DSA:2.60.40.10:FF:003467', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183262, NULL, 'G3DSA:1.25.40.10:FF:000633', NULL, NULL, 'Pre-mRNA splicing factor (Prp24), putative', NULL, NULL, NULL, NULL, NULL, 4),
(183263, NULL, 'G3DSA:2.30.180.10:FF:000034', NULL, NULL, 'fasciclin-1 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(183264, NULL, 'G3DSA:1.20.140.40:FF:000013', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(183265, NULL, 'G3DSA:2.10.110.10:FF:000130', NULL, NULL, 'Protein CBG03641', NULL, NULL, NULL, NULL, NULL, 4),
(183266, NULL, 'G3DSA:1.10.510.10:FF:000243', NULL, NULL, 'mitogen-activated protein kinase kinase kinase 20 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(183267, NULL, 'G3DSA:1.10.8.60:FF:000403', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(183268, NULL, 'G3DSA:2.30.30.40:FF:000531', NULL, NULL, 'BAR domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(183269, NULL, 'G3DSA:2.60.40.150:FF:000772', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(183270, NULL, 'G3DSA:3.40.50.1820:FF:000061', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(183271, NULL, 'G3DSA:1.20.1560.10:FF:000097', NULL, NULL, 'Inner membrane ABC-transporter YbtQ', NULL, NULL, NULL, NULL, NULL, 4),
(183272, NULL, 'G3DSA:2.160.10.10:FF:000037', NULL, NULL, 'Streptogramin A acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(183273, NULL, 'G3DSA:3.30.40.10:FF:000594', NULL, NULL, 'RING/U-box superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(183274, NULL, 'G3DSA:2.10.25.10:FF:001039', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(183275, NULL, 'G3DSA:2.80.10.50:FF:000244', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(183276, NULL, 'G3DSA:1.10.1410.10:FF:000009', NULL, NULL, 'Poly(A) RNA polymerase cid14', NULL, NULL, NULL, NULL, NULL, 4),
(183277, NULL, 'G3DSA:2.30.29.30:FF:001177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183278, NULL, 'G3DSA:2.10.50.30:FF:000013', NULL, NULL, 'Calcium-sensing receptor', NULL, NULL, NULL, NULL, NULL, 4),
(183279, NULL, 'G3DSA:1.10.510.10:FF:003469', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183280, NULL, 'G3DSA:1.20.140.50:FF:000016', NULL, NULL, 'Vacuolar protein-sorting protein bro1', NULL, NULL, NULL, NULL, NULL, 4),
(183281, NULL, 'G3DSA:1.20.1530.20:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(183282, NULL, 'G3DSA:1.20.1110.10:FF:000164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183283, NULL, 'G3DSA:3.30.160.60:FF:006176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183284, NULL, 'G3DSA:2.60.40.10:FF:002365', NULL, NULL, 'AGAP003610-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(183285, NULL, 'G3DSA:3.40.50.300:FF:007582', NULL, NULL, 'Ras family protein', NULL, NULL, NULL, NULL, NULL, 4),
(183286, NULL, 'G3DSA:1.25.40.550:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183287, NULL, 'G3DSA:6.10.140.2220:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183288, NULL, 'G3DSA:1.10.60.40:FF:000002', NULL, NULL, 'Alkaline phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(183289, NULL, 'G3DSA:2.30.140.10:FF:000026', NULL, NULL, 'Spermine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(183290, NULL, 'G3DSA:2.60.40.3210:FF:000007', NULL, NULL, 'Zona pellucida glycoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(183291, NULL, 'G3DSA:3.90.1150.10:FF:000233', NULL, NULL, 'AGAP013274-PA', NULL, NULL, NULL, NULL, NULL, 4),
(183292, NULL, 'G3DSA:1.25.40.540:FF:000012', NULL, NULL, 'TAP42-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(183293, NULL, 'G3DSA:1.10.1200.270:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183294, NULL, 'G3DSA:3.90.70.10:FF:000048', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 31', NULL, NULL, NULL, NULL, NULL, 4),
(183295, NULL, 'G3DSA:3.10.100.10:FF:000412', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183296, NULL, 'G3DSA:1.25.10.10:FF:001587', NULL, NULL, 'Anaphase promoting complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(183297, NULL, 'G3DSA:3.40.50.1220:FF:000089', NULL, NULL, 'Phenylpyruvate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(183298, NULL, 'G3DSA:3.40.50.300:FF:000168', NULL, NULL, 'DEAD-box ATP-dependent RNA helicase 56-like', NULL, NULL, NULL, NULL, NULL, 4),
(183299, NULL, 'G3DSA:2.60.120.260:FF:000668', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183300, NULL, 'G3DSA:3.80.10.10:FF:002894', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183301, NULL, 'G3DSA:3.50.30.30:FF:000025', NULL, NULL, 'PA and RING finger domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(183302, NULL, 'G3DSA:3.90.1480.20:FF:000047', NULL, NULL, 'ST6 N-acetylgalactosaminide alpha-2,6-sialyltransferase 5', NULL, NULL, NULL, NULL, NULL, 4),
(183303, NULL, 'G3DSA:1.10.10.10:FF:000007', NULL, NULL, 'Ferric uptake regulation protein', NULL, NULL, NULL, NULL, NULL, 4),
(183304, NULL, 'G3DSA:1.10.287.110:FF:000135', NULL, NULL, 'Curved DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(183305, NULL, 'G3DSA:3.50.50.100:FF:000061', NULL, NULL, 'Sulfide Quinone oxidoReDuctase', NULL, NULL, NULL, NULL, NULL, 4),
(183306, NULL, 'G3DSA:3.30.160.60:FF:000252', NULL, NULL, 'Zinc finger protein 287', NULL, NULL, NULL, NULL, NULL, 4),
(183307, NULL, 'G3DSA:1.20.1070.10:FF:001711', NULL, NULL, 'G protein-coupled receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183308, NULL, 'G3DSA:1.50.40.10:FF:000541', NULL, NULL, 'Mitochondrial carrier-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(183309, NULL, 'G3DSA:3.40.50.10110:FF:000001', NULL, NULL, 'DNA polymerase III subunit chi', NULL, NULL, NULL, NULL, NULL, 4),
(183310, NULL, 'G3DSA:3.30.200.20:FF:001896', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183311, NULL, 'G3DSA:3.10.20.90:FF:000471', NULL, NULL, 'RAD23 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183312, NULL, 'G3DSA:2.70.150.10:FF:000265', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(183313, NULL, 'G3DSA:3.30.70.330:FF:001083', NULL, NULL, 'Probable splicing factor, arginine/serine-rich 6', NULL, NULL, NULL, NULL, NULL, 4),
(183314, NULL, 'G3DSA:3.80.10.10:FF:003557', NULL, NULL, 'Secreted protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183315, NULL, 'G3DSA:1.25.40.20:FF:000636', NULL, NULL, 'Glycerophosphocholine phosphodiesterase Gde1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(183316, NULL, 'G3DSA:3.40.50.620:FF:000646', NULL, NULL, 'GMP synthase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(183317, NULL, 'G3DSA:3.40.630.30:FF:000614', NULL, NULL, 'Gll0913 protein', NULL, NULL, NULL, NULL, NULL, 4),
(183318, NULL, 'G3DSA:2.180.10.10:FF:000019', NULL, NULL, 'Teneurin transmembrane protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(183319, NULL, 'G3DSA:3.30.450.90:FF:000013', NULL, NULL, 'ComG operon protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(183320, NULL, 'G3DSA:3.40.50.300:FF:002259', NULL, NULL, 'Translation initiation factor IF-2', NULL, NULL, NULL, NULL, NULL, 4),
(183321, NULL, 'G3DSA:2.130.10.10:FF:002343', NULL, NULL, 'SnoRNA-binding rRNA-processing protein', NULL, NULL, NULL, NULL, NULL, 4),
(183322, NULL, 'G3DSA:3.40.50.2000:FF:000778', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(183323, NULL, 'G3DSA:3.40.50.300:FF:008571', NULL, NULL, 'Multidrug resistance protein ABC transporter family', NULL, NULL, NULL, NULL, NULL, 4),
(183324, NULL, 'G3DSA:3.40.50.300:FF:000814', NULL, NULL, 'Large 60S subunit nuclear export GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(183325, NULL, 'G3DSA:3.30.1330.30:FF:000076', NULL, NULL, 'NHP2 isoform 6', NULL, NULL, NULL, NULL, NULL, 4),
(183326, NULL, 'G3DSA:1.10.287.1080:FF:000005', NULL, NULL, 'Phosphoribosyl-ATP pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(183327, NULL, 'G3DSA:3.30.70.330:FF:000037', NULL, NULL, 'RNA-binding protein with multiple splicing 2', NULL, NULL, NULL, NULL, NULL, 4),
(183328, NULL, 'G3DSA:3.10.100.10:FF:000030', NULL, NULL, 'Mannose receptor C-type 1', NULL, NULL, NULL, NULL, NULL, 4),
(183329, NULL, 'G3DSA:2.10.25.10:FF:001096', NULL, NULL, 'Stabilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(183330, NULL, 'G3DSA:2.120.10.30:FF:000135', NULL, NULL, 'Nhl repeat-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183331, NULL, 'G3DSA:1.25.40.10:FF:001768', NULL, NULL, 'Pentatricopeptide repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(183332, NULL, 'G3DSA:1.10.357.10:FF:000009', NULL, NULL, 'HTH-type transcriptional regulator BetI', NULL, NULL, NULL, NULL, NULL, 4),
(183333, NULL, 'G3DSA:1.20.5.1160:FF:000031', NULL, NULL, 'Uveal autoantigen with coiled-coil domains and ankyrin repeats', NULL, NULL, NULL, NULL, NULL, 4),
(183334, NULL, 'G3DSA:3.40.50.970:FF:000054', NULL, NULL, 'Putative 2-hydroxyphytanoyl-CoA lyase', NULL, NULL, NULL, NULL, NULL, 4),
(183335, NULL, 'G3DSA:2.60.40.790:FF:000109', NULL, NULL, 'GD14174', NULL, NULL, NULL, NULL, NULL, 4),
(183336, NULL, 'G3DSA:1.10.287.190:FF:000001', NULL, NULL, 'Transcription initiation factor IIA subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(183337, NULL, 'G3DSA:1.25.40.10:FF:003921', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183338, NULL, 'G3DSA:2.60.450.20:FF:000012', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(183339, NULL, 'G3DSA:2.170.11.10:FF:000005', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(183340, NULL, 'G3DSA:3.30.870.10:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183341, NULL, 'G3DSA:2.130.10.10:FF:001769', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(183342, NULL, 'G3DSA:3.40.850.10:FF:000439', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183343, NULL, 'G3DSA:2.170.270.10:FF:000143', NULL, NULL, 'SET domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183344, NULL, 'G3DSA:1.20.1530.20:FF:000013', NULL, NULL, 'sodium/bile acid cotransporter 4', NULL, NULL, NULL, NULL, NULL, 4),
(183345, NULL, 'G3DSA:3.30.420.10:FF:000589', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183346, NULL, 'G3DSA:3.30.450.20:FF:000684', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(183347, NULL, 'G3DSA:2.40.70.10:FF:000440', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183348, NULL, 'G3DSA:1.20.1270.280:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(183349, NULL, 'G3DSA:1.20.120.350:FF:000019', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(183350, NULL, 'G3DSA:3.50.50.60:FF:000895', NULL, NULL, 'Probable flavin containing oxidoreductase (Homolog to phytoene desaturase / monoamine oxidase)', NULL, NULL, NULL, NULL, NULL, 4),
(183351, NULL, 'G3DSA:1.10.10.10:FF:000333', NULL, NULL, 'enhanced ethylene response protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(183352, NULL, 'G3DSA:1.10.238.10:FF:000643', NULL, NULL, 'EF-hand calcium-binding domain-containing protein 4B', NULL, NULL, NULL, NULL, NULL, 4),
(183353, NULL, 'G3DSA:1.20.5.4820:FF:000016', NULL, NULL, 'Myosin XXI', NULL, NULL, NULL, NULL, NULL, 4),
(183354, NULL, 'G3DSA:3.30.830.10:FF:000081', NULL, NULL, 'Axl1p', NULL, NULL, NULL, NULL, NULL, 4),
(183355, NULL, 'G3DSA:3.30.160.60:FF:003916', NULL, NULL, 'ZNF177 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(183356, NULL, 'G3DSA:3.30.450.40:FF:000313', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(183357, NULL, 'G3DSA:1.10.510.10:FF:004458', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183358, NULL, 'G3DSA:2.130.10.10:FF:005777', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(183359, NULL, 'G3DSA:3.40.50.2060:FF:000009', NULL, NULL, 'sec1 family domain-containing protein 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(183360, NULL, 'G3DSA:3.30.40.10:FF:001049', NULL, NULL, 'E3 ubiquitin-protein ligase EL5', NULL, NULL, NULL, NULL, NULL, 4),
(183361, NULL, 'G3DSA:3.30.30.30:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183362, NULL, 'G3DSA:3.30.830.10:FF:000024', NULL, NULL, 'Stromal processing peptidase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(183363, NULL, 'G3DSA:3.90.780.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183364, NULL, 'G3DSA:1.10.472.10:FF:000086', NULL, NULL, 'Cyclin domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(183365, NULL, 'G3DSA:2.40.10.10:FF:000223', NULL, NULL, 'GM13756', NULL, NULL, NULL, NULL, NULL, 4),
(183366, NULL, 'G3DSA:2.30.180.10:FF:000091', NULL, NULL, 'Fasciclin-1 fasciclin i fas i fcn', NULL, NULL, NULL, NULL, NULL, 4),
(183367, NULL, 'G3DSA:2.60.40.10:FF:001758', NULL, NULL, 'Fibronectin type III and SPRY domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(183368, NULL, 'G3DSA:3.40.1230.10:FF:000021', NULL, NULL, 'Nuclear protein E3-3, isoform a, putative, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(183369, NULL, 'G3DSA:3.40.50.980:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183370, NULL, 'G3DSA:1.50.40.10:FF:000277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183371, NULL, 'G3DSA:1.20.120.340:FF:000016', NULL, NULL, 'Perilipin', NULL, NULL, NULL, NULL, NULL, 4),
(183372, NULL, 'G3DSA:3.30.200.20:FF:000053', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(183373, NULL, 'G3DSA:1.10.510.10:FF:003795', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183374, NULL, 'G3DSA:3.30.200.20:FF:001481', NULL, NULL, 'Kinase, NEK-frag', NULL, NULL, NULL, NULL, NULL, 4),
(183375, NULL, 'G3DSA:3.90.730.10:FF:000003', NULL, NULL, 'Ribonuclease 3', NULL, NULL, NULL, NULL, NULL, 4),
(183376, NULL, 'G3DSA:3.90.1140.10:FF:000053', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(183377, NULL, 'G3DSA:3.40.390.10:FF:000100', NULL, NULL, 'Oligopeptidase A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183378, NULL, 'G3DSA:3.40.50.300:FF:001949', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(183379, NULL, 'G3DSA:3.90.70.10:FF:000312', NULL, NULL, 'RTX toxin transporter', NULL, NULL, NULL, NULL, NULL, 4),
(183380, NULL, 'G3DSA:1.10.420.10:FF:000005', NULL, NULL, 'L-ascorbate peroxidase T, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(183381, NULL, 'G3DSA:3.40.50.300:FF:002113', NULL, NULL, '3''-phosphoadenosine 5''-phosphosulfate synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(183382, NULL, 'G3DSA:2.80.10.50:FF:000036', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(183383, NULL, 'G3DSA:2.30.30.40:FF:000323', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(183384, NULL, 'G3DSA:3.30.530.20:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183385, NULL, 'G3DSA:2.60.40.1760:FF:000016', NULL, NULL, 'Alpha-1,4-glucosidase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(183386, NULL, 'G3DSA:3.30.1370.100:FF:000034', NULL, NULL, 'DNA mismatch repair protein (Mlh3), putative (AFU_orthologue AFUA_4G06490)', NULL, NULL, NULL, NULL, NULL, 4),
(183387, NULL, 'G3DSA:1.20.1280.50:FF:000132', NULL, NULL, 'Cyclic nucleotide-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(183388, NULL, 'G3DSA:4.10.640.10:FF:000016', NULL, NULL, '30S ribosomal protein S18', NULL, NULL, NULL, NULL, NULL, 4),
(183389, NULL, 'G3DSA:2.40.50.140:FF:001186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183390, NULL, 'G3DSA:1.20.1310.10:FF:000230', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183391, NULL, 'G3DSA:1.10.510.10:FF:002660', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183392, NULL, 'G3DSA:1.25.40.10:FF:001297', NULL, NULL, 'GM23710', NULL, NULL, NULL, NULL, NULL, 4),
(183393, NULL, 'G3DSA:3.30.70.580:FF:000033', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(183394, NULL, 'G3DSA:3.40.720.10:FF:000289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183395, NULL, 'G3DSA:3.90.1750.10:FF:000054', NULL, NULL, 'Ubiquitin protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183396, NULL, 'G3DSA:1.10.8.720:FF:000033', NULL, NULL, 'Dynein gamma chain, flagellar outer arm', NULL, NULL, NULL, NULL, NULL, 4),
(183397, NULL, 'G3DSA:1.10.520.10:FF:000070', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(183398, NULL, 'G3DSA:1.20.1250.20:FF:000969', NULL, NULL, 'Probable major facilitator superfamily (MFS) transporter', NULL, NULL, NULL, NULL, NULL, 4),
(183399, NULL, 'G3DSA:3.30.70.330:FF:003117', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183400, NULL, 'G3DSA:1.10.510.10:FF:004251', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183401, NULL, 'G3DSA:3.30.1140.60:FF:000025', NULL, NULL, 'F-actin-capping protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(183402, NULL, 'G3DSA:3.30.930.10:FF:000291', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(183403, NULL, 'G3DSA:3.30.540.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183404, NULL, 'G3DSA:3.80.10.10:FF:003411', NULL, NULL, 'F-box and leucine-rich repeat protein 20', NULL, NULL, NULL, NULL, NULL, 4),
(183405, NULL, 'G3DSA:2.110.10.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183406, NULL, 'G3DSA:3.30.9.10:FF:000061', NULL, NULL, 'Fructosyl amine: oxygen oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(183407, NULL, 'G3DSA:1.10.8.710:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183408, NULL, 'G3DSA:2.10.25.10:FF:001303', NULL, NULL, 'cadherin EGF LAG seven-pass G-type receptor 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(183409, NULL, 'G3DSA:1.10.510.10:FF:000451', NULL, NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', NULL, NULL, NULL, NULL, NULL, 4),
(183410, NULL, 'G3DSA:3.30.160.60:FF:004321', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183411, NULL, 'G3DSA:3.30.160.60:FF:001241', NULL, NULL, 'Spalt like transcription factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(183412, NULL, 'G3DSA:3.30.420.40:FF:001059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183413, NULL, 'G3DSA:3.20.20.70:FF:000375', NULL, NULL, 'Dihydroorotate reductase PyrE', NULL, NULL, NULL, NULL, NULL, 4),
(183414, NULL, 'G3DSA:1.10.472.10:FF:000350', NULL, NULL, 'Cyclin E-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(183415, NULL, 'G3DSA:2.60.120.1000:FF:000036', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(183416, NULL, 'G3DSA:3.40.50.1000:FF:000725', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(183417, NULL, 'G3DSA:3.30.500.10:FF:000005', NULL, NULL, 'MHC class I antigen ZKA transcript variant 1', NULL, NULL, NULL, NULL, NULL, 4),
(183418, NULL, 'G3DSA:4.10.410.10:FF:000095', NULL, NULL, 'Serine proteinase inhibitor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183419, NULL, 'G3DSA:1.25.40.10:FF:001976', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(183420, NULL, 'G3DSA:3.90.1750.10:FF:000083', NULL, NULL, 'Zn-finger in Ran binding protein and others/SPRY domain/HECT-domain (Ubiquitin-transferase), putative', NULL, NULL, NULL, NULL, NULL, 4),
(183421, NULL, 'G3DSA:3.40.50.2000:FF:000250', NULL, NULL, 'Glucosyltransferase I RfaG', NULL, NULL, NULL, NULL, NULL, 4),
(183422, NULL, 'G3DSA:1.10.287.70:FF:000656', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183423, NULL, 'G3DSA:1.10.630.10:FF:000836', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183424, NULL, 'G3DSA:1.10.455.10:FF:000030', NULL, NULL, '40S ribosomal protein S5', NULL, NULL, NULL, NULL, NULL, 4),
(183425, NULL, 'G3DSA:3.30.70.330:FF:000301', NULL, NULL, 'Nucleolysin TIAR-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(183426, NULL, 'G3DSA:3.40.30.10:FF:001031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183427, NULL, 'G3DSA:3.30.420.40:FF:000165', NULL, NULL, 'Propionate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(183428, NULL, 'G3DSA:4.10.400.10:FF:000330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183429, NULL, 'G3DSA:3.30.160.60:FF:004467', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183430, NULL, 'G3DSA:2.60.40.10:FF:000510', NULL, NULL, 'cell adhesion molecule 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(183431, NULL, 'G3DSA:3.90.76.10:FF:000033', NULL, NULL, 'Peptide/nickel transport system substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(183432, NULL, 'G3DSA:3.30.450.40:FF:000105', NULL, NULL, 'Transcriptional regulator, IclR family', NULL, NULL, NULL, NULL, NULL, 4),
(183433, NULL, 'G3DSA:1.20.1560.10:FF:000861', NULL, NULL, 'Multidrug resistance-associated protein Mrp2', NULL, NULL, NULL, NULL, NULL, 4),
(183434, NULL, 'G3DSA:2.60.120.380:FF:000092', NULL, NULL, 'Flagellar associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(183435, NULL, 'G3DSA:1.20.58.1880:FF:000005', NULL, NULL, 'REST corepressor 3 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(183436, NULL, 'G3DSA:3.40.50.300:FF:006154', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(183437, NULL, 'G3DSA:3.10.20.310:FF:000048', NULL, NULL, 'Translocon outer membrane complex 75-I', NULL, NULL, NULL, NULL, NULL, 4),
(183438, NULL, 'G3DSA:2.10.70.10:FF:000065', NULL, NULL, 'Coagulation factor XIII B chain', NULL, NULL, NULL, NULL, NULL, 4),
(183439, NULL, 'G3DSA:2.30.29.30:FF:001385', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(183440, NULL, 'G3DSA:2.40.20.10:FF:000083', NULL, NULL, 'Urokinase-type plasminogen activator', NULL, NULL, NULL, NULL, NULL, 4),
(183441, NULL, 'G3DSA:3.90.1420.10:FF:000035', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(183442, NULL, 'G3DSA:2.70.130.10:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183443, NULL, 'G3DSA:2.130.10.10:FF:005569', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(183444, NULL, 'G3DSA:3.30.420.10:FF:000527', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183445, NULL, 'G3DSA:3.30.1120.10:FF:000060', NULL, NULL, 'Aryl-sulphate sulphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(183446, NULL, 'G3DSA:3.40.1010.10:FF:000010', NULL, NULL, 'Cobalamin biosynthesis protein CobIJ', NULL, NULL, NULL, NULL, NULL, 4),
(183447, NULL, 'G3DSA:2.10.70.10:FF:000183', NULL, NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(183448, NULL, 'G3DSA:3.40.50.300:FF:008363', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(183449, NULL, 'G3DSA:3.40.50.2020:FF:000110', NULL, NULL, 'ribose-phosphate pyrophosphokinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(183450, NULL, 'G3DSA:2.20.25.10:FF:000027', NULL, NULL, 'Multifunctional methyltransferase subunit TRM112-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(183451, NULL, 'G3DSA:1.20.140.150:FF:000093', NULL, NULL, 'uncharacterized protein LOC100186093', NULL, NULL, NULL, NULL, NULL, 4),
(183452, NULL, 'G3DSA:2.60.40.60:FF:000531', NULL, NULL, 'Dachsous cadherin-related 1a', NULL, NULL, NULL, NULL, NULL, 4),
(183453, NULL, 'G3DSA:1.10.1420.10:FF:000038', NULL, NULL, 'Msh2p', NULL, NULL, NULL, NULL, NULL, 4),
(183454, NULL, 'G3DSA:3.30.565.10:FF:000149', NULL, NULL, 'heat shock protein HSP 90-beta isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(183455, NULL, 'G3DSA:1.10.10.60:FF:000623', NULL, NULL, 'Transcription factor MYB4', NULL, NULL, NULL, NULL, NULL, 4),
(183456, NULL, 'G3DSA:3.40.50.1400:FF:000019', NULL, NULL, 'Ferrochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(183457, NULL, 'G3DSA:3.10.250.10:FF:000125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183458, NULL, 'G3DSA:1.10.540.10:FF:000071', NULL, NULL, 'Putative acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(183459, NULL, 'G3DSA:2.40.50.140:FF:000051', NULL, NULL, 'RNA-binding transcriptional accessory protein', NULL, NULL, NULL, NULL, NULL, 4),
(183460, NULL, 'G3DSA:2.40.30.10:FF:000022', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(183461, NULL, 'G3DSA:1.20.1050.10:FF:000131', NULL, NULL, 'Glutathione S-transferase omega-2', NULL, NULL, NULL, NULL, NULL, 4),
(183462, NULL, 'G3DSA:4.10.1240.10:FF:000005', NULL, NULL, 'Parathyroid hormone/parathyroid hormone-related peptide receptor', NULL, NULL, NULL, NULL, NULL, 4),
(183463, NULL, 'G3DSA:2.20.80.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183464, NULL, 'G3DSA:2.130.10.10:FF:000634', NULL, NULL, 'syntaxin-binding protein 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(183465, NULL, 'G3DSA:2.40.50.100:FF:000207', NULL, NULL, 'Putative glycine cleavage system H protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(183466, NULL, 'G3DSA:3.40.50.2300:FF:000778', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183467, NULL, 'G3DSA:3.20.20.70:FF:000436', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(183468, NULL, 'G3DSA:3.80.10.10:FF:003147', NULL, NULL, 'Protein CBG00902', NULL, NULL, NULL, NULL, NULL, 4),
(183469, NULL, 'G3DSA:3.40.30.10:FF:000008', NULL, NULL, 'Stringent starvation protein A', NULL, NULL, NULL, NULL, NULL, 4),
(183470, NULL, 'G3DSA:1.25.40.20:FF:000226', NULL, NULL, 'Ankyrin repeat domain-containing protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(183471, NULL, 'G3DSA:1.10.510.10:FF:002249', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183472, NULL, 'G3DSA:1.25.40.10:FF:003449', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(183473, NULL, 'G3DSA:3.30.70.330:FF:001791', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183474, NULL, 'G3DSA:1.25.40.10:FF:004023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183475, NULL, 'G3DSA:1.25.40.10:FF:000223', NULL, NULL, 'Tetratricopeptide repeat domain 28', NULL, NULL, NULL, NULL, NULL, 4),
(183476, NULL, 'G3DSA:3.40.50.2300:FF:001352', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183477, NULL, 'G3DSA:3.30.2350.20:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183478, NULL, 'G3DSA:1.25.40.10:FF:001561', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g21090', NULL, NULL, NULL, NULL, NULL, 4),
(183479, NULL, 'G3DSA:3.20.140.10:FF:000013', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(183480, NULL, 'G3DSA:1.10.8.60:FF:000167', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(183481, NULL, 'G3DSA:3.40.50.720:FF:002475', NULL, NULL, 'Asperfuranone polyketide synthase afoG', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(183482, NULL, 'G3DSA:1.25.40.450:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183483, NULL, 'G3DSA:3.30.160.60:FF:000370', NULL, NULL, 'Metal regulatory transcription factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(183484, NULL, 'G3DSA:2.60.40.150:FF:000064', NULL, NULL, 'synaptotagmin-17 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(183485, NULL, 'G3DSA:2.10.25.10:FF:001511', NULL, NULL, 'Fibulin-1', NULL, NULL, NULL, NULL, NULL, 4),
(183486, NULL, 'G3DSA:3.20.20.70:FF:000583', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183487, NULL, 'G3DSA:2.130.10.10:FF:002079', NULL, NULL, 'Zinc finger CCCH domain-containing protein 59', NULL, NULL, NULL, NULL, NULL, 4),
(183488, NULL, 'G3DSA:3.30.160.60:FF:001033', NULL, NULL, 'Zinc finger protein 142', NULL, NULL, NULL, NULL, NULL, 4),
(183489, NULL, 'G3DSA:3.80.10.10:FF:004485', NULL, NULL, 'Probable serine/threonine-protein kinase DDB_G0278509', NULL, NULL, NULL, NULL, NULL, 4),
(183490, NULL, 'G3DSA:3.30.40.10:FF:001521', NULL, NULL, 'RING-H2 finger protein ATL67', NULL, NULL, NULL, NULL, NULL, 4),
(183491, NULL, 'G3DSA:1.25.10.10:FF:001469', NULL, NULL, 'Dynein axonemal assembly factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(183492, NULL, 'G3DSA:3.40.33.10:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183493, NULL, 'G3DSA:1.10.3720.10:FF:000230', NULL, NULL, 'Amino acid ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(183494, NULL, 'G3DSA:1.20.5.1010:FF:000003', NULL, NULL, 'Transient receptor potential cation channel trpm', NULL, NULL, NULL, NULL, NULL, 4),
(183495, NULL, 'G3DSA:2.40.37.20:FF:000001', NULL, NULL, 'D-3-hydroxyaspartate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(183496, NULL, 'G3DSA:3.30.160.60:FF:006412', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183497, NULL, 'G3DSA:2.40.50.1020:FF:000018', NULL, NULL, 'Two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(183498, NULL, 'G3DSA:3.90.226.10:FF:000017', NULL, NULL, 'Propionyl-CoA carboxylase subunit beta 5', NULL, NULL, NULL, NULL, NULL, 4),
(183499, NULL, 'G3DSA:3.30.200.20:FF:001834', NULL, NULL, 'Putative serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(183500, NULL, 'G3DSA:3.40.1170.60:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183501, NULL, 'G3DSA:1.10.10.10:FF:000069', NULL, NULL, 'Paired box protein Pax-6', NULL, NULL, NULL, NULL, NULL, 4),
(183502, NULL, 'G3DSA:3.30.160.60:FF:005395', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183503, NULL, 'G3DSA:3.30.1690.10:FF:000001', NULL, NULL, 'Toxin co-regulated pilin', NULL, NULL, NULL, NULL, NULL, 4),
(183504, NULL, 'G3DSA:3.50.50.60:FF:001148', NULL, NULL, 'FAD/NAD(P)-binding oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(183505, NULL, 'G3DSA:1.10.238.10:FF:000290', NULL, NULL, 'LETM1 and EF-hand domain-containing protein 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(183506, NULL, 'G3DSA:3.10.100.10:FF:000176', NULL, NULL, 'Killer cell lectin-like receptor subfamily G member 1', NULL, NULL, NULL, NULL, NULL, 4),
(183507, NULL, 'G3DSA:3.30.200.20:FF:001688', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183508, NULL, 'G3DSA:1.20.1250.20:FF:000031', NULL, NULL, 'Hexose phosphate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(183509, NULL, 'G3DSA:2.70.40.10:FF:000015', NULL, NULL, 'Deoxyuridine 5''-triphosphate nucleotidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(183510, NULL, 'G3DSA:1.25.10.10:FF:000075', NULL, NULL, 'Anaphase promoting complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(183511, NULL, 'G3DSA:1.10.510.10:FF:003941', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183512, NULL, 'G3DSA:1.25.50.20:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183513, NULL, 'G3DSA:3.40.50.150:FF:000191', NULL, NULL, 'mRNA cap guanine-N7 methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(183514, NULL, 'G3DSA:1.10.472.10:FF:000232', NULL, NULL, 'Cyclin box fold, protein binding domain protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(183515, NULL, 'G3DSA:1.10.10.440:FF:000076', NULL, NULL, 'YALI0D02827p', NULL, NULL, NULL, NULL, NULL, 4),
(183516, NULL, 'G3DSA:2.40.70.10:FF:000294', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183517, NULL, 'G3DSA:1.20.1250.40:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183518, NULL, 'G3DSA:3.40.50.720:FF:001250', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(183519, NULL, 'G3DSA:2.130.10.10:FF:000191', NULL, NULL, 'mRNA splicing factor', NULL, NULL, NULL, NULL, NULL, 4),
(183520, NULL, 'G3DSA:1.10.268.10:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183521, NULL, 'G3DSA:3.80.10.10:FF:001348', NULL, NULL, 'Toll receptor 13', NULL, NULL, NULL, NULL, NULL, 4),
(183522, NULL, 'G3DSA:3.40.50.300:FF:000932', NULL, NULL, 'ABC transporter G family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(183523, NULL, 'G3DSA:1.10.357.170:FF:000001', NULL, NULL, 'Multifunctional virulence effector protein DrrA', NULL, NULL, NULL, NULL, NULL, 4),
(183524, NULL, 'G3DSA:1.10.3260.10:FF:000003', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(183525, NULL, 'G3DSA:2.60.40.60:FF:000323', NULL, NULL, 'Protocadherin Fat 2', NULL, NULL, NULL, NULL, NULL, 4),
(183526, NULL, 'G3DSA:1.10.10.60:FF:000180', NULL, NULL, 'DnaJ (Hsp40) homolog, subfamily C, member 2', NULL, NULL, NULL, NULL, NULL, 4),
(183527, NULL, 'G3DSA:3.40.30.10:FF:000626', NULL, NULL, 'GM13104', NULL, NULL, NULL, NULL, NULL, 4),
(183528, NULL, 'G3DSA:3.30.160.60:FF:004260', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183529, NULL, 'G3DSA:1.20.58.2220:FF:000057', NULL, NULL, 'Formin 1', NULL, NULL, NULL, NULL, NULL, 4),
(183530, NULL, 'G3DSA:3.80.10.10:FF:003350', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183531, NULL, 'G3DSA:2.10.25.10:FF:000994', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(183532, NULL, 'G3DSA:3.10.20.30:FF:000060', NULL, NULL, 'Small GTP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(183533, NULL, 'G3DSA:2.130.10.10:FF:000134', NULL, NULL, 'striatin-3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(183534, NULL, 'G3DSA:3.40.630.10:FF:000344', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(183535, NULL, 'G3DSA:3.50.50.60:FF:001412', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(183536, NULL, 'G3DSA:3.40.50.150:FF:000134', NULL, NULL, 'protein-lysine methyltransferase METTL21D isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(183537, NULL, 'G3DSA:1.10.1740.10:FF:000028', NULL, NULL, 'RNA polymerase subunit sigma', NULL, NULL, NULL, NULL, NULL, 4),
(183538, NULL, 'G3DSA:1.10.150.880:FF:000001', NULL, NULL, 'Bacteriocin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183539, NULL, 'G3DSA:3.40.50.720:FF:000676', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(183540, NULL, 'G3DSA:1.10.8.530:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183541, NULL, 'G3DSA:1.25.40.840:FF:000012', NULL, NULL, 'CCR4-NOT transcription complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(183542, NULL, 'G3DSA:1.10.10.60:FF:000123', NULL, NULL, 'HTH-type transcriptional regulator AdiY', NULL, NULL, NULL, NULL, NULL, 4),
(183543, NULL, 'G3DSA:3.40.50.1820:FF:000999', NULL, NULL, 'Putative esterase', NULL, NULL, NULL, NULL, NULL, 4),
(183544, NULL, 'G3DSA:3.10.580.10:FF:000144', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(183545, NULL, 'G3DSA:3.90.79.10:FF:000101', NULL, NULL, 'U8 snoRNA-decapping enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(183546, NULL, 'G3DSA:1.25.40.10:FF:005158', NULL, NULL, 'RNA binding rRNA processing protein', NULL, NULL, NULL, NULL, NULL, 4),
(183547, NULL, 'G3DSA:1.20.5.170:FF:000298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183548, NULL, 'G3DSA:3.20.20.80:FF:000439', NULL, NULL, 'Chitinase, acidic.3', NULL, NULL, NULL, NULL, NULL, 4),
(183549, NULL, 'G3DSA:1.10.10.10:FF:001761', NULL, NULL, 'Regulatory protein RecX', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(183550, NULL, 'G3DSA:2.10.220.10:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183551, NULL, 'G3DSA:1.20.58.120:FF:000013', NULL, NULL, 'BAG family molecular chaperone regulator 5, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(183552, NULL, 'G3DSA:2.130.10.10:FF:003771', NULL, NULL, 'Uncharacterized WD repeat-containing protein C18H10.05', NULL, NULL, NULL, NULL, NULL, 4),
(183553, NULL, 'G3DSA:2.60.120.620:FF:000147', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(183554, NULL, 'G3DSA:2.60.40.60:FF:000177', NULL, NULL, 'Cadherin-related family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(183555, NULL, 'G3DSA:3.40.50.1100:FF:000199', NULL, NULL, 'O-acetyl-serine sulfhydrylase chain a, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183556, NULL, 'G3DSA:3.10.20.90:FF:000319', NULL, NULL, 'Ubiquitin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(183557, NULL, 'G3DSA:3.30.1360.40:FF:000053', NULL, NULL, 'Sugar transporter ERD6-like 6', NULL, NULL, NULL, NULL, NULL, 4),
(183558, NULL, 'G3DSA:2.60.120.330:FF:000127', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(183559, NULL, 'G3DSA:2.40.50.100:FF:000117', NULL, NULL, 'Multiple sugar ABC transporter ATP-bindingprotein', NULL, NULL, NULL, NULL, NULL, 4),
(183560, NULL, 'G3DSA:2.130.10.10:FF:001562', NULL, NULL, 'Inner dynein arm I1 intermediate chain IC138', NULL, NULL, NULL, NULL, NULL, 4),
(183561, NULL, 'G3DSA:3.10.450.50:FF:000040', NULL, NULL, 'Terephthalate 1,2-dioxygenase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(183562, NULL, 'G3DSA:3.30.160.60:FF:002522', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(183563, NULL, 'G3DSA:3.40.50.2300:FF:001088', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183564, NULL, 'G3DSA:3.40.50.150:FF:000752', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase G', NULL, NULL, NULL, NULL, NULL, 4),
(183565, NULL, 'G3DSA:3.30.420.10:FF:000735', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183566, NULL, 'G3DSA:1.10.10.10:FF:001968', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183567, NULL, 'G3DSA:1.10.530.10:FF:000042', NULL, NULL, 'Invertebrate LYSozyme', NULL, NULL, NULL, NULL, NULL, 4),
(183568, NULL, 'G3DSA:1.10.3720.10:FF:000084', NULL, NULL, 'Peptide ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(183569, NULL, 'G3DSA:1.10.287.110:FF:000343', NULL, NULL, 'Chaperone protein DNAj, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183570, NULL, 'G3DSA:1.25.70.10:FF:000051', NULL, NULL, 'Protein CBG08723', NULL, NULL, NULL, NULL, NULL, 4),
(183571, NULL, 'G3DSA:3.40.1550.10:FF:000011', NULL, NULL, 'CheY-P phosphatase CheX', NULL, NULL, NULL, NULL, NULL, 4),
(183572, NULL, 'G3DSA:2.130.10.10:FF:004024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183573, NULL, 'G3DSA:3.30.160.60:FF:000218', NULL, NULL, 'Zinc finger protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(183574, NULL, 'G3DSA:3.40.50.300:FF:007548', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183575, NULL, 'G3DSA:1.10.418.70:FF:000001', NULL, NULL, 'Intraflagellar transport protein 81 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(183576, NULL, 'G3DSA:2.60.40.10:FF:003967', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183577, NULL, 'G3DSA:2.60.40.10:FF:002573', NULL, NULL, 'fibrocystin-L-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(183578, NULL, 'G3DSA:1.10.287.1970:FF:000002', NULL, NULL, 'Alanine aminotransferase putative', NULL, NULL, NULL, NULL, NULL, 4),
(183579, NULL, 'G3DSA:1.10.20.10:FF:000305', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183580, NULL, 'G3DSA:3.40.1090.10:FF:000138', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(183581, NULL, 'G3DSA:1.10.1450.10:FF:000074', NULL, NULL, 'GD10450', NULL, NULL, NULL, NULL, NULL, 4),
(183582, NULL, 'G3DSA:1.10.10.10:FF:000215', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(183583, NULL, 'G3DSA:3.40.50.720:FF:001457', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(183584, NULL, 'G3DSA:1.10.510.10:FF:003677', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183585, NULL, 'G3DSA:1.10.10.2330:FF:000008', NULL, NULL, 'Phenylalanyl-tRNA synthetase alpha chain B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183586, NULL, 'G3DSA:3.65.10.10:FF:000018', NULL, NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(183587, NULL, 'G3DSA:1.25.40.10:FF:003713', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(183588, NULL, 'G3DSA:1.10.1410.10:FF:000066', NULL, NULL, 'U3 small nucleolar RNA-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(183589, NULL, 'G3DSA:1.10.472.170:FF:000007', NULL, NULL, 'Transcription initiation factor IIB-2', NULL, NULL, NULL, NULL, NULL, 4),
(183590, NULL, 'G3DSA:2.40.30.10:FF:000432', NULL, NULL, 'Translation elongation factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183591, NULL, 'G3DSA:3.90.70.10:FF:000519', NULL, NULL, 'Protein CBG00738', NULL, NULL, NULL, NULL, NULL, 4),
(183592, NULL, 'G3DSA:1.25.40.990:FF:000006', NULL, NULL, 'Putative SAC3/GANP domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(183593, NULL, 'G3DSA:3.10.310.10:FF:000012', NULL, NULL, '4-hydroxyproline 2-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(183594, NULL, 'G3DSA:1.10.30.10:FF:000071', NULL, NULL, 'High mobility group protein', NULL, NULL, NULL, NULL, NULL, 4),
(183595, NULL, 'G3DSA:1.10.10.2320:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183596, NULL, 'G3DSA:2.60.120.10:FF:000462', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183597, NULL, 'G3DSA:2.40.50.140:FF:000989', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183598, NULL, 'G3DSA:3.30.70.260:FF:000168', NULL, NULL, 'Probable septum site-determining protein MinC', NULL, NULL, NULL, NULL, NULL, 4),
(183599, NULL, 'G3DSA:2.30.30.140:FF:000268', NULL, NULL, 'Chromatin modification-related protein EAF3', NULL, NULL, NULL, NULL, NULL, 4),
(183600, NULL, 'G3DSA:1.10.10.2660:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183601, NULL, 'G3DSA:1.10.10.60:FF:000270', NULL, NULL, 'Sigma-54-dependent Fis family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(183602, NULL, 'G3DSA:1.10.565.10:FF:000184', NULL, NULL, 'Retinoid X receptor', NULL, NULL, NULL, NULL, NULL, 4),
(183603, NULL, 'G3DSA:2.130.10.10:FF:000281', NULL, NULL, 'Plexin B2', NULL, NULL, NULL, NULL, NULL, 4),
(183604, NULL, 'G3DSA:3.40.50.1000:FF:000315', NULL, NULL, 'TFIIF-stimulated CTD phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183605, NULL, 'G3DSA:1.10.238.10:FF:000233', NULL, NULL, 'CDPK-related kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(183606, NULL, 'G3DSA:3.90.1430.10:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183607, NULL, 'G3DSA:1.20.1070.10:FF:001565', NULL, NULL, 'Putative gustatory receptor clone PTE03', NULL, NULL, NULL, NULL, NULL, 4),
(183608, NULL, 'G3DSA:1.10.10.10:FF:001497', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(183609, NULL, 'G3DSA:3.40.50.300:FF:005339', NULL, NULL, 'Probable DNA helicase II homolog', NULL, NULL, NULL, NULL, NULL, 4),
(183610, NULL, 'G3DSA:2.10.25.10:FF:000022', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(183611, NULL, 'G3DSA:3.40.50.300:FF:001596', NULL, NULL, 'Secretion protein, partial', NULL, NULL, NULL, NULL, NULL, 4),
(183612, NULL, 'G3DSA:3.30.40.10:FF:001257', NULL, NULL, 'Uncharacterized RING finger protein P32A8.03c', NULL, NULL, NULL, NULL, NULL, 4),
(183613, NULL, 'G3DSA:3.40.50.1820:FF:001308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183614, NULL, 'G3DSA:2.30.31.10:FF:000007', NULL, NULL, 'Transcriptional coactivator p15 (Pc4), putative', NULL, NULL, NULL, NULL, NULL, 4),
(183615, NULL, 'G3DSA:2.130.10.10:FF:005159', NULL, NULL, 'ELongator complex Protein Component', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(183616, NULL, 'G3DSA:3.50.50.60:FF:001058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183617, NULL, 'G3DSA:1.10.510.10:FF:000804', NULL, NULL, 'Blast:Serine/threonine-protein kinase ULK3', NULL, NULL, NULL, NULL, NULL, 4),
(183618, NULL, 'G3DSA:1.25.40.20:FF:001041', NULL, NULL, 'Protein ACCELERATED CELL DEATH 6', NULL, NULL, NULL, NULL, NULL, 4),
(183619, NULL, 'G3DSA:3.40.250.10:FF:000118', NULL, NULL, 'Thiosulfate/3-mercaptopyruvate sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(183620, NULL, 'G3DSA:3.80.10.10:FF:001702', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(183621, NULL, 'G3DSA:3.30.450.80:FF:000010', NULL, NULL, 'Transcriptional activator protein LuxR', NULL, NULL, NULL, NULL, NULL, 4),
(183622, NULL, 'G3DSA:1.20.120.730:FF:000010', NULL, NULL, 'Sec23/sec24 transport family protein', NULL, NULL, NULL, NULL, NULL, 4),
(183623, NULL, 'G3DSA:3.40.50.300:FF:003748', NULL, NULL, 'Dynein heavy chain 7', NULL, NULL, NULL, NULL, NULL, 4),
(183624, NULL, 'G3DSA:2.30.110.10:FF:000086', NULL, NULL, 'Slr0001 protein', NULL, NULL, NULL, NULL, NULL, 4),
(183625, NULL, 'G3DSA:2.60.120.200:FF:000757', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183626, NULL, 'G3DSA:3.40.50.1820:FF:001550', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183627, NULL, 'G3DSA:3.40.50.11180:FF:000001', NULL, NULL, 'Transcription-repair-coupling factor', NULL, NULL, NULL, NULL, NULL, 4),
(183628, NULL, 'G3DSA:1.10.472.80:FF:000146', NULL, NULL, 'TBC1 domain family member 8', NULL, NULL, NULL, NULL, NULL, 4),
(183629, NULL, 'G3DSA:3.40.630.10:FF:000254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183630, NULL, 'G3DSA:1.20.1070.10:FF:000806', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183631, NULL, 'G3DSA:3.90.740.10:FF:000032', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(183632, NULL, 'G3DSA:3.40.50.300:FF:000578', NULL, NULL, 'probable ATP-dependent RNA helicase DHX35', NULL, NULL, NULL, NULL, NULL, 4),
(183633, NULL, 'G3DSA:3.30.70.330:FF:000155', NULL, NULL, 'serine/arginine-rich splicing factor 10 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(183634, NULL, 'G3DSA:3.40.50.300:FF:000314', NULL, NULL, 'Atlastin-2 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(183635, NULL, 'G3DSA:1.25.40.1030:FF:000038', NULL, NULL, 'Imidazole glycerol phosphate synthase hisHF chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(183636, NULL, 'G3DSA:1.25.40.10:FF:004995', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183637, NULL, 'G3DSA:3.80.10.10:FF:001612', NULL, NULL, 'Putative kinase-like protein TMKL1', NULL, NULL, NULL, NULL, NULL, 4),
(183638, NULL, 'G3DSA:3.40.120.10:FF:000114', NULL, NULL, 'Phosphoacetylglucosamine mutase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183639, NULL, 'G3DSA:3.10.310.20:FF:000015', NULL, NULL, 'Manganese-dependent inorganic pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(183640, NULL, 'G3DSA:1.25.10.10:FF:000805', NULL, NULL, 'Similar to transcription factor CBF/MAK21', NULL, NULL, NULL, NULL, NULL, 4),
(183641, NULL, 'G3DSA:1.20.5.340:FF:000107', NULL, NULL, 'Uncharacterized protein C27B12.07', NULL, NULL, NULL, NULL, NULL, 4),
(183642, NULL, 'G3DSA:1.20.1250.20:FF:001425', NULL, NULL, 'Proton-dependent oligopeptide transport family protein', NULL, NULL, NULL, NULL, NULL, 4),
(183643, NULL, 'G3DSA:3.90.180.10:FF:000096', NULL, NULL, 'Quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(183644, NULL, 'G3DSA:1.10.510.10:FF:000861', NULL, NULL, 'Serine/threonine-protein kinase RAD53', NULL, NULL, NULL, NULL, NULL, 4),
(183645, NULL, 'G3DSA:3.30.160.60:FF:004731', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183646, NULL, 'G3DSA:1.20.120.1900:FF:000008', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(183647, NULL, 'G3DSA:3.40.50.300:FF:005957', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(183648, NULL, 'G3DSA:3.30.420.150:FF:000001', NULL, NULL, 'Guanosine-5''-triphosphate,3''-diphosphate pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(183649, NULL, 'G3DSA:3.30.70.980:FF:000030', NULL, NULL, 'Translational Activator of Cytochrome c Oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(183650, NULL, 'G3DSA:2.60.120.330:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183651, NULL, 'G3DSA:3.60.20.10:FF:000198', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183652, NULL, 'G3DSA:3.40.50.300:FF:002523', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(183653, NULL, 'G3DSA:2.30.30.380:FF:000048', NULL, NULL, 'Vacuolar protein sorting protein (Vps36), putative', NULL, NULL, NULL, NULL, NULL, 4),
(183654, NULL, 'G3DSA:2.30.42.10:FF:000589', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183655, NULL, 'G3DSA:3.30.160.60:FF:005956', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183656, NULL, 'G3DSA:3.30.70.100:FF:000171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183657, NULL, 'G3DSA:1.10.238.10:FF:000851', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183658, NULL, 'G3DSA:1.10.8.60:FF:000583', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183659, NULL, 'G3DSA:2.60.40.3000:FF:000001', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(183660, NULL, 'G3DSA:3.30.559.30:FF:000129', NULL, NULL, 'N-(5-amino-5-carboxypentanoyl)-L-cysteinyl-D-valine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(183661, NULL, 'G3DSA:3.90.550.10:FF:000731', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183662, NULL, 'G3DSA:3.20.20.210:FF:000027', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(183663, NULL, 'G3DSA:1.10.510.10:FF:000535', NULL, NULL, 'Serine/threonine-protein kinase a', NULL, NULL, NULL, NULL, NULL, 4),
(183664, NULL, 'G3DSA:3.30.230.70:FF:000081', NULL, NULL, 'Exosome non-catalytic core subunit', NULL, NULL, NULL, NULL, NULL, 4),
(183665, NULL, 'G3DSA:1.20.140.150:FF:000121', NULL, NULL, 'PERP, TP53 apoptosis effector', NULL, NULL, NULL, NULL, NULL, 4),
(183666, NULL, 'G3DSA:3.40.50.150:FF:000544', NULL, NULL, '23S rRNA (Adenine(2058)-N(6))-methyltransferase Erm(37)', NULL, NULL, NULL, NULL, NULL, 4),
(183667, NULL, 'G3DSA:2.130.10.10:FF:001646', NULL, NULL, 'Protein HIRA', NULL, NULL, NULL, NULL, NULL, 4),
(183668, NULL, 'G3DSA:3.30.40.10:FF:002010', NULL, NULL, 'RING/U-box superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(183669, NULL, 'G3DSA:3.30.200.20:FF:000143', NULL, NULL, 'Ephrin type-B receptor 6', NULL, NULL, NULL, NULL, NULL, 4),
(183670, NULL, 'G3DSA:3.90.870.10:FF:000036', NULL, NULL, 'GTP cyclohydrolase II', NULL, NULL, NULL, NULL, NULL, 4),
(183671, NULL, 'G3DSA:3.30.160.60:FF:004821', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183672, NULL, 'G3DSA:3.40.50.150:FF:000488', NULL, NULL, 'histone-lysine N-methyltransferase, H3 lysine-79 specific isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(183673, NULL, 'G3DSA:2.170.270.10:FF:000233', NULL, NULL, 'PR/SET domain 12', NULL, NULL, NULL, NULL, NULL, 4),
(183674, NULL, 'G3DSA:2.170.190.11:FF:000003', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(183675, NULL, 'G3DSA:3.30.70.330:FF:001526', NULL, NULL, 'Modulo, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(183676, NULL, 'G3DSA:3.30.930.10:FF:000381', NULL, NULL, 'Glycine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(183677, NULL, 'G3DSA:3.30.200.20:FF:001773', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183678, NULL, 'G3DSA:3.40.50.150:FF:000016', NULL, NULL, 'Protein arginine N-methyltransferase 6', NULL, NULL, NULL, NULL, NULL, 4),
(183679, NULL, 'G3DSA:3.90.226.10:FF:000135', NULL, NULL, 'Protease 4', NULL, NULL, NULL, NULL, NULL, 4),
(183680, NULL, 'G3DSA:3.40.50.1000:FF:000169', NULL, NULL, 'Haloacid dehalogenase-like hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(183681, NULL, 'G3DSA:1.20.58.60:FF:000311', NULL, NULL, 'Protein CBG15811', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(183682, NULL, 'G3DSA:3.40.800.10:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183683, NULL, 'G3DSA:1.20.120.1080:FF:000077', NULL, NULL, 'ATP-dependent RNA helicase DEAH12 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(183684, NULL, 'G3DSA:3.40.1000.10:FF:000009', NULL, NULL, 'Secreted proline rich protein 28 kDa antigen', NULL, NULL, NULL, NULL, NULL, 4),
(183685, NULL, 'G3DSA:2.60.40.60:FF:000441', NULL, NULL, 'Dachsous, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(183686, NULL, 'G3DSA:1.25.10.10:FF:002492', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(183687, NULL, 'G3DSA:4.10.280.110:FF:000016', NULL, NULL, 'Splicing factor Prp18 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(183688, NULL, 'G3DSA:4.10.400.10:FF:000358', NULL, NULL, 'SOL-2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(183689, NULL, 'G3DSA:2.40.100.10:FF:000027', NULL, NULL, 'Allophanate hydrolase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(183690, NULL, 'G3DSA:3.40.800.20:FF:000057', NULL, NULL, 'HDAC4', NULL, NULL, NULL, NULL, NULL, 4),
(183691, NULL, 'G3DSA:3.40.30.10:FF:000716', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183692, NULL, 'G3DSA:1.10.10.520:FF:000010', NULL, NULL, 'SUMO-activating enzyme subunit', NULL, NULL, NULL, NULL, NULL, 4),
(183693, NULL, 'G3DSA:3.90.1580.10:FF:000018', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(183694, NULL, 'G3DSA:3.30.750.24:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183695, NULL, 'G3DSA:1.20.58.390:FF:000307', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183696, NULL, 'G3DSA:1.10.510.10:FF:001996', NULL, NULL, 'Kinase-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(183697, NULL, 'G3DSA:3.80.20.20:FF:000071', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(183698, NULL, 'G3DSA:3.40.50.140:FF:000013', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(183699, NULL, 'G3DSA:3.10.20.90:FF:000229', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 11', NULL, NULL, NULL, NULL, NULL, 4),
(183700, NULL, 'G3DSA:2.60.40.10:FF:001668', NULL, NULL, 'C3 and PZP like, alpha-2-macroglobulin domain containing 8', NULL, NULL, NULL, NULL, NULL, 4),
(183701, NULL, 'G3DSA:1.50.40.10:FF:000187', NULL, NULL, 'Protein CBG03436', NULL, NULL, NULL, NULL, NULL, 4),
(183702, NULL, 'G3DSA:2.30.180.10:FF:000181', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183703, NULL, 'G3DSA:3.30.70.1170:FF:000003', NULL, NULL, '16S rRNA (Cytosine(967)-C(5))-methyltransferase RsmB', NULL, NULL, NULL, NULL, NULL, 4),
(183704, NULL, 'G3DSA:2.30.29.30:FF:000957', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183705, NULL, 'G3DSA:1.20.810.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183706, NULL, 'G3DSA:2.40.30.10:FF:000078', NULL, NULL, 'Dual oxidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(183707, NULL, 'G3DSA:3.10.450.50:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183708, NULL, 'G3DSA:3.30.559.70:FF:000001', NULL, NULL, 'Carnitine O-palmitoyltransferase 1, liver isoform', NULL, NULL, NULL, NULL, NULL, 4),
(183709, NULL, 'G3DSA:3.30.379.10:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183710, NULL, 'G3DSA:1.10.1420.10:FF:000128', NULL, NULL, 'MutS domain III family protein', NULL, NULL, NULL, NULL, NULL, 4),
(183711, NULL, 'G3DSA:1.25.10.10:FF:000249', NULL, NULL, 'HEAT repeat-containing protein 5A isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(183712, NULL, 'G3DSA:3.30.160.60:FF:004175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183713, NULL, 'G3DSA:3.40.50.300:FF:000522', NULL, NULL, 'Gluconokinase', NULL, NULL, NULL, NULL, NULL, 4),
(183714, NULL, 'G3DSA:1.10.472.10:FF:000114', NULL, NULL, 'Cyclin-D5-1', NULL, NULL, NULL, NULL, NULL, 4),
(183715, NULL, 'G3DSA:3.30.56.30:FF:000001', NULL, NULL, 'signal recognition particle 19 kDa protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(183716, NULL, 'G3DSA:1.20.1500.20:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183717, NULL, 'G3DSA:2.60.40.420:FF:000078', NULL, NULL, 'Laccase-1', NULL, NULL, NULL, NULL, NULL, 4),
(183718, NULL, 'G3DSA:3.40.50.300:FF:004114', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(183719, NULL, 'G3DSA:1.10.287.160:FF:000009', NULL, NULL, 'Cytosolic regulator Pianissimo, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183720, NULL, 'G3DSA:2.70.98.30:FF:000025', NULL, NULL, 'Lysosomal alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(183721, NULL, 'G3DSA:3.40.50.1010:FF:000026', NULL, NULL, '20S-pre-rRNA D-site endonuclease NOB1', NULL, NULL, NULL, NULL, NULL, 4),
(183722, NULL, 'G3DSA:1.25.40.10:FF:005276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183723, NULL, 'G3DSA:1.10.10.10:FF:000625', NULL, NULL, 'Rrf2 family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(183724, NULL, 'G3DSA:2.60.40.10:FF:001466', NULL, NULL, 'SPEG neighbor', NULL, NULL, NULL, NULL, NULL, 4),
(183725, NULL, 'G3DSA:2.40.180.10:FF:000043', NULL, NULL, 'Catalase', NULL, NULL, NULL, NULL, NULL, 4),
(183726, NULL, 'G3DSA:3.40.47.10:FF:000226', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183727, NULL, 'G3DSA:3.40.50.1000:FF:000495', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183728, NULL, 'G3DSA:1.25.10.10:FF:000305', NULL, NULL, 'Adenomatous polyposis coli', NULL, NULL, NULL, NULL, NULL, 4),
(183729, NULL, 'G3DSA:3.30.420.10:FF:000297', NULL, NULL, 'Argonaut-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(183730, NULL, 'G3DSA:2.30.29.30:FF:001323', NULL, NULL, 'SH2B adapter protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(183731, NULL, 'G3DSA:2.10.25.10:FF:001242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183732, NULL, 'G3DSA:3.40.50.1100:FF:000227', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(183733, NULL, 'G3DSA:3.40.50.1000:FF:000023', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(183734, NULL, 'G3DSA:3.40.50.720:FF:000558', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(183735, NULL, 'G3DSA:2.60.40.1120:FF:000055', NULL, NULL, 'nodal modulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(183736, NULL, 'G3DSA:3.30.40.10:FF:001611', NULL, NULL, 'Transcription factor BYE1', NULL, NULL, NULL, NULL, NULL, 4),
(183737, NULL, 'G3DSA:2.10.70.10:FF:000149', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(183738, NULL, 'G3DSA:1.10.510.10:FF:004430', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183739, NULL, 'G3DSA:2.70.150.10:FF:000175', NULL, NULL, 'Na+ or K+ P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(183740, NULL, 'G3DSA:3.30.10.10:FF:000002', NULL, NULL, 'Elastase inhibitor AFUEI', NULL, NULL, NULL, NULL, NULL, 4),
(183741, NULL, 'G3DSA:2.70.170.10:FF:000182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183742, NULL, 'G3DSA:1.10.510.10:FF:002250', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183743, NULL, 'G3DSA:3.30.710.10:FF:000105', NULL, NULL, 'inhibitor of Bruton tyrosine kinase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(183744, NULL, 'G3DSA:1.25.10.10:FF:001879', NULL, NULL, 'TORTIFOLIA1-like protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(183745, NULL, 'G3DSA:3.30.565.10:FF:000503', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183746, NULL, 'G3DSA:3.40.50.1000:FF:000225', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(183747, NULL, 'G3DSA:1.20.5.110:FF:000331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183748, NULL, 'G3DSA:2.130.10.10:FF:005485', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183749, NULL, 'G3DSA:3.40.50.300:FF:002169', NULL, NULL, 'Nucleolar preribosomal GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183750, NULL, 'G3DSA:3.40.50.2300:FF:001470', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(183751, NULL, 'G3DSA:1.10.540.10:FF:000037', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(183752, NULL, 'G3DSA:2.130.10.130:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183753, NULL, 'G3DSA:2.120.10.80:FF:000127', NULL, NULL, 'Cellular morphogenesis protein (Rax2), putative', NULL, NULL, NULL, NULL, NULL, 4),
(183754, NULL, 'G3DSA:3.40.50.10900:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183755, NULL, 'G3DSA:2.40.50.100:FF:000180', NULL, NULL, 'Ddl-3', NULL, NULL, NULL, NULL, NULL, 4),
(183756, NULL, 'G3DSA:3.40.30.10:FF:001115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183757, NULL, 'G3DSA:3.10.100.10:FF:000322', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183758, NULL, 'G3DSA:4.10.400.10:FF:000094', NULL, NULL, 'Transmembrane serine protease 3', NULL, NULL, NULL, NULL, NULL, 4),
(183759, NULL, 'G3DSA:3.40.50.300:FF:004737', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(183760, NULL, 'G3DSA:1.20.1070.10:FF:001621', NULL, NULL, 'Frizzled-6', NULL, NULL, NULL, NULL, NULL, 4),
(183761, NULL, 'G3DSA:3.80.10.10:FF:004159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183762, NULL, 'G3DSA:3.10.20.340:FF:000001', NULL, NULL, 'Arginine biosynthesis bifunctional protein ArgJ, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(183763, NULL, 'G3DSA:3.40.50.1010:FF:000228', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183764, NULL, 'G3DSA:1.20.144.10:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183765, NULL, 'G3DSA:2.70.98.20:FF:000022', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(183766, NULL, 'G3DSA:2.40.10.120:FF:000020', NULL, NULL, 'Complement factor B', NULL, NULL, NULL, NULL, NULL, 4),
(183767, NULL, 'G3DSA:3.30.420.40:FF:000042', NULL, NULL, 'Acetate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(183768, NULL, 'G3DSA:2.30.30.40:FF:000441', NULL, NULL, 'Caspase recruitment domain family member 10', NULL, NULL, NULL, NULL, NULL, 4),
(183769, NULL, 'G3DSA:1.25.40.10:FF:003359', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g04760, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(183770, NULL, 'G3DSA:3.20.20.190:FF:000066', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(183771, NULL, 'G3DSA:1.10.510.10:FF:000333', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(183772, NULL, 'G3DSA:2.40.30.10:FF:000229', NULL, NULL, 'Putative translation initiation factor EIF-2B gamma subunit', NULL, NULL, NULL, NULL, NULL, 4),
(183773, NULL, 'G3DSA:3.40.50.720:FF:001873', NULL, NULL, 'Pyrroline-5-carboxylate reductase, flame shift', NULL, NULL, NULL, NULL, NULL, 4),
(183774, NULL, 'G3DSA:3.30.160.60:FF:000752', NULL, NULL, 'Zinc finger protein 384 like', NULL, NULL, NULL, NULL, NULL, 4),
(183775, NULL, 'G3DSA:6.20.10.30:FF:000001', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(183776, NULL, 'G3DSA:2.130.10.120:FF:000032', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(183777, NULL, 'G3DSA:3.40.50.10810:FF:000093', NULL, NULL, 'DNA repair protein rhp16, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183778, NULL, 'G3DSA:3.80.10.10:FF:003057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183779, NULL, 'G3DSA:1.10.10.10:FF:002014', NULL, NULL, 'Interferon regulatory factor', NULL, NULL, NULL, NULL, NULL, 4),
(183780, NULL, 'G3DSA:1.25.40.20:FF:000136', NULL, NULL, 'ankyrin repeat and sterile alpha motif domain-containing protein 1B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(183781, NULL, 'G3DSA:1.20.120.80:FF:000001', NULL, NULL, 'Cytochrome (Ubi)quinol oxidase subunit III', NULL, NULL, NULL, NULL, NULL, 4),
(183782, NULL, 'G3DSA:1.10.132.10:FF:000010', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(183783, NULL, 'G3DSA:1.20.1270.60:FF:000286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(183784, NULL, 'G3DSA:2.170.300.10:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183785, NULL, 'G3DSA:3.90.550.10:FF:000405', NULL, NULL, 'Glycosyltransferase, group 2 family', NULL, NULL, NULL, NULL, NULL, 4),
(183786, NULL, 'G3DSA:3.30.300.10:FF:000024', NULL, NULL, 'Arl-6', NULL, NULL, NULL, NULL, NULL, 4),
(183787, NULL, 'G3DSA:3.30.365.10:FF:000078', NULL, NULL, 'Caffeine dehydrogenase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(183788, NULL, 'G3DSA:2.80.10.50:FF:000098', NULL, NULL, 'Calcium up-regulated protein A', NULL, NULL, NULL, NULL, NULL, 4),
(183789, NULL, 'G3DSA:3.40.50.10190:FF:000362', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(183790, NULL, 'G3DSA:2.30.29.30:FF:001267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183791, NULL, 'G3DSA:3.40.50.300:FF:006031', NULL, NULL, 'Helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183792, NULL, 'G3DSA:1.20.120.1760:FF:000039', NULL, NULL, 'Ethanolamine phosphotransferase (EPT)', NULL, NULL, NULL, NULL, NULL, 4),
(183793, NULL, 'G3DSA:3.40.1380.20:FF:000068', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(183794, NULL, 'G3DSA:1.20.120.1750:FF:000036', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(183795, NULL, 'G3DSA:2.60.40.150:FF:000154', NULL, NULL, 'tandem C2 domains nuclear protein', NULL, NULL, NULL, NULL, NULL, 4),
(183796, NULL, 'G3DSA:1.10.510.10:FF:004374', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183797, NULL, 'G3DSA:3.60.21.60:FF:000041', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(183798, NULL, 'G3DSA:2.60.200.20:FF:000230', NULL, NULL, 'Formin-J', NULL, NULL, NULL, NULL, NULL, 4),
(183799, NULL, 'G3DSA:3.40.50.150:FF:000218', NULL, NULL, 'Sun-family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183800, NULL, 'G3DSA:2.40.160.210:FF:000008', NULL, NULL, 'Acyl-CoA thioesterase II', NULL, NULL, NULL, NULL, NULL, 4),
(183801, NULL, 'G3DSA:3.10.20.90:FF:000706', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183802, NULL, 'G3DSA:1.10.1370.10:FF:000011', NULL, NULL, 'Oligoendopeptidase F', NULL, NULL, NULL, NULL, NULL, 4),
(183803, NULL, 'G3DSA:3.40.50.1820:FF:000735', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(183804, NULL, 'G3DSA:4.10.400.10:FF:000212', NULL, NULL, 'Low-density lipoprotein receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183805, NULL, 'G3DSA:1.10.1450.10:FF:000012', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(183806, NULL, 'G3DSA:3.40.950.10:FF:000003', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor nar1', NULL, NULL, NULL, NULL, NULL, 4),
(183807, NULL, 'G3DSA:3.40.605.10:FF:000095', NULL, NULL, 'Aldehyde dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183808, NULL, 'G3DSA:1.10.510.10:FF:000209', NULL, NULL, 'Serine/threonine-protein kinase pim-1', NULL, NULL, NULL, NULL, NULL, 4),
(183809, NULL, 'G3DSA:2.40.128.20:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183810, NULL, 'G3DSA:3.40.50.11530:FF:000005', NULL, NULL, 'interleukin-17 receptor E isoform X11', NULL, NULL, NULL, NULL, NULL, 4),
(183811, NULL, 'G3DSA:3.30.460.10:FF:000097', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(183812, NULL, 'G3DSA:3.40.532.10:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183813, NULL, 'G3DSA:1.10.1200.10:FF:000117', NULL, NULL, 'Polyketide synthase RzxE', NULL, NULL, NULL, NULL, NULL, 4),
(183814, NULL, 'G3DSA:1.20.1070.10:FF:001149', NULL, NULL, 'Cephalotocin receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(183815, NULL, 'G3DSA:2.60.40.10:FF:001792', NULL, NULL, 'Fasciclin 3, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(183816, NULL, 'G3DSA:2.60.40.10:FF:004102', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183817, NULL, 'G3DSA:1.10.10.10:FF:001553', NULL, NULL, 'Cullin', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(183818, NULL, 'G3DSA:1.10.1370.30:FF:000017', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(183819, NULL, 'G3DSA:3.40.720.10:FF:000290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183820, NULL, 'G3DSA:1.10.472.10:FF:000316', NULL, NULL, 'G2/mitotic-specific cyclin-B3', NULL, NULL, NULL, NULL, NULL, 4),
(183821, NULL, 'G3DSA:3.30.70.1180:FF:000006', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(183822, NULL, 'G3DSA:1.10.287.230:FF:000002', NULL, NULL, 'Regulatory protein rop, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183823, NULL, 'G3DSA:3.30.830.10:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183824, NULL, 'G3DSA:1.25.10.10:FF:001177', NULL, NULL, 'Importin subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183825, NULL, 'G3DSA:3.40.50.1820:FF:001224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183826, NULL, 'G3DSA:1.10.287.140:FF:000003', NULL, NULL, 'Glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(183827, NULL, 'G3DSA:1.25.40.10:FF:000072', NULL, NULL, 'Crooked neck-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(183828, NULL, 'G3DSA:3.30.2160.10:FF:000034', NULL, NULL, 'Ubiquitin protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183829, NULL, 'G3DSA:1.10.132.60:FF:000031', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(183830, NULL, 'G3DSA:3.50.50.60:FF:001474', NULL, NULL, 'FAD-dependent oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(183831, NULL, 'G3DSA:1.20.1070.10:FF:001239', NULL, NULL, 'Frizzled 9/10', NULL, NULL, NULL, NULL, NULL, 4),
(183832, NULL, 'G3DSA:3.30.1360.120:FF:000010', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(183833, NULL, 'G3DSA:1.20.5.190:FF:000135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183834, NULL, 'G3DSA:3.10.290.10:FF:000015', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(183835, NULL, 'G3DSA:3.40.50.1700:FF:000019', NULL, NULL, 'Glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(183836, NULL, 'G3DSA:3.30.160.60:FF:005479', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183837, NULL, 'G3DSA:1.10.510.10:FF:001794', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183838, NULL, 'G3DSA:1.10.510.10:FF:004104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183839, NULL, 'G3DSA:1.10.10.750:FF:000017', NULL, NULL, 'GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(183840, NULL, 'G3DSA:1.10.132.30:FF:000016', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(183841, NULL, 'G3DSA:3.90.1290.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183842, NULL, 'G3DSA:1.10.132.20:FF:000013', NULL, NULL, 'Ribosome-recycling factor, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(183843, NULL, 'G3DSA:1.25.10.10:FF:000631', NULL, NULL, 'Vac14, PIKFYVE complex component', NULL, NULL, NULL, NULL, NULL, 4),
(183844, NULL, 'G3DSA:2.60.40.10:FF:003883', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183845, NULL, 'G3DSA:1.25.40.10:FF:000133', NULL, NULL, 'Signal recognition particle subunit SRP72', NULL, NULL, NULL, NULL, NULL, 4),
(183846, NULL, 'G3DSA:2.60.40.790:FF:000025', NULL, NULL, 'heat shock protein beta-2', NULL, NULL, NULL, NULL, NULL, 4),
(183847, NULL, 'G3DSA:1.10.1670.40:FF:000009', NULL, NULL, 'Base excision DNA repair protein, HhH-GPD family', NULL, NULL, NULL, NULL, NULL, 4),
(183848, NULL, 'G3DSA:4.10.60.10:FF:000043', NULL, NULL, 'Air1p', NULL, NULL, NULL, NULL, NULL, 4),
(183849, NULL, 'G3DSA:1.25.10.10:FF:002722', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183850, NULL, 'G3DSA:2.40.170.20:FF:000130', NULL, NULL, 'Transporter, outer membrane receptor (OMR) family', NULL, NULL, NULL, NULL, NULL, 4),
(183851, NULL, 'G3DSA:3.90.70.10:FF:000435', NULL, NULL, 'ubiquitin carboxyl-terminal hydrolase CYLD', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(183852, NULL, 'G3DSA:2.170.140.10:FF:000021', NULL, NULL, 'Chitin deacetylase-like 4', NULL, NULL, NULL, NULL, NULL, 4),
(183853, NULL, 'G3DSA:3.40.50.300:FF:007756', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183854, NULL, 'G3DSA:3.40.50.10190:FF:000036', NULL, NULL, 'PAX interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(183855, NULL, 'G3DSA:3.40.440.10:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183856, NULL, 'G3DSA:3.30.160.60:FF:000662', NULL, NULL, 'RE1-silencing transcription factor A', NULL, NULL, NULL, NULL, NULL, 4),
(183857, NULL, 'G3DSA:3.40.190.10:FF:000208', NULL, NULL, 'HTH-type transcriptional regulator XapR', NULL, NULL, NULL, NULL, NULL, 4),
(183858, NULL, 'G3DSA:1.10.287.440:FF:000003', NULL, NULL, 'Bifunctional purine biosynthesis protein PurH', NULL, NULL, NULL, NULL, NULL, 4),
(183859, NULL, 'G3DSA:1.10.510.10:FF:000361', NULL, NULL, 'Leucine-rich repeat serine/threonine-protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(183860, NULL, 'G3DSA:3.40.50.150:FF:001000', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183861, NULL, 'G3DSA:3.30.200.20:FF:000789', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(183862, NULL, 'G3DSA:1.25.40.10:FF:000751', NULL, NULL, 'Coatomer subunit epsilon, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183863, NULL, 'G3DSA:2.70.170.10:FF:000210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183864, NULL, 'G3DSA:3.30.230.10:FF:000288', NULL, NULL, 'Rad51/RecA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(183865, NULL, 'G3DSA:1.20.120.430:FF:000010', NULL, NULL, 'tRNA modification GTPase GTPBP3, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(183866, NULL, 'G3DSA:2.130.10.10:FF:005805', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(183867, NULL, 'G3DSA:1.20.5.190:FF:000130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183868, NULL, 'G3DSA:3.90.70.10:FF:000019', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(183869, NULL, 'G3DSA:1.10.238.10:FF:000379', NULL, NULL, 'Lysophosphatidylcholine acyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(183870, NULL, 'G3DSA:1.10.150.50:FF:000098', NULL, NULL, 'Liprin-beta', NULL, NULL, NULL, NULL, NULL, 4),
(183871, NULL, 'G3DSA:3.50.50.60:FF:000687', NULL, NULL, '2,6-dihydroxypyridine 3-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(183872, NULL, 'G3DSA:1.25.40.20:FF:000754', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183873, NULL, 'G3DSA:2.130.10.10:FF:000960', NULL, NULL, 'LEC14B protein-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(183874, NULL, 'G3DSA:1.20.1090.10:FF:000021', NULL, NULL, 'Alcohol dehydrogenase, iron-dependent', NULL, NULL, NULL, NULL, NULL, 4),
(183875, NULL, 'G3DSA:3.90.290.10:FF:000014', NULL, NULL, 'Fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(183876, NULL, 'G3DSA:3.30.160.60:FF:000426', NULL, NULL, 'Zinc finger and BTB domain-containing protein 20', NULL, NULL, NULL, NULL, NULL, 4),
(183877, NULL, 'G3DSA:3.30.40.10:FF:001318', NULL, NULL, 'Zinc finger domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(183878, NULL, 'G3DSA:2.60.40.10:FF:002781', NULL, NULL, 'Short-form leptin receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(183879, NULL, 'G3DSA:2.30.30.40:FF:000413', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(183880, NULL, 'G3DSA:1.10.8.140:FF:000016', NULL, NULL, 'DsDNA-binding protein PDCD5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183881, NULL, 'G3DSA:3.90.230.10:FF:000038', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(183882, NULL, 'G3DSA:2.130.10.10:FF:006025', NULL, NULL, 'Centriole proteome protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(183883, NULL, 'G3DSA:3.40.20.10:FF:000159', NULL, NULL, 'G-actin binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183884, NULL, 'G3DSA:4.10.400.10:FF:000184', NULL, NULL, 'Ecdysone-inducible gene E1', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(183885, NULL, 'G3DSA:1.20.120.350:FF:000137', NULL, NULL, 'Calcium channel protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183886, NULL, 'G3DSA:1.20.120.140:FF:000018', NULL, NULL, 'Putative signal peptide binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(183887, NULL, 'G3DSA:2.10.70.10:FF:000239', NULL, NULL, 'Peptidase domain-containing-associated with muscle regeneration 1', NULL, NULL, NULL, NULL, NULL, 4),
(183888, NULL, 'G3DSA:1.10.287.110:FF:000404', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183889, NULL, 'G3DSA:1.25.10.10:FF:003178', NULL, NULL, 'Probable inactive serine/threonine-protein kinase DDB_G0278909', NULL, NULL, NULL, NULL, NULL, 4),
(183890, NULL, 'G3DSA:3.90.550.10:FF:000315', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(183891, NULL, 'G3DSA:1.10.510.10:FF:003885', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183892, NULL, 'G3DSA:3.30.160.60:FF:006261', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183893, NULL, 'G3DSA:3.40.50.1980:FF:000114', NULL, NULL, 'Periplasmic divalent manganese/zinc-binding lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(183894, NULL, 'G3DSA:3.40.50.2300:FF:000014', NULL, NULL, 'PTS system fructose-like transporter subunit IIB', NULL, NULL, NULL, NULL, NULL, 4),
(183895, NULL, 'G3DSA:1.25.40.990:FF:000040', NULL, NULL, 'COP9 signalosome complex subunit 8', NULL, NULL, NULL, NULL, NULL, 4),
(183896, NULL, 'G3DSA:1.20.1110.10:FF:000046', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(183897, NULL, 'G3DSA:1.10.510.10:FF:002160', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(183898, NULL, 'G3DSA:1.10.630.10:FF:000336', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183899, NULL, 'G3DSA:1.10.8.10:FF:000259', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(183900, NULL, 'G3DSA:2.60.40.10:FF:004574', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183901, NULL, 'G3DSA:2.20.25.10:FF:000117', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(183902, NULL, 'G3DSA:2.40.320.10:FF:000015', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(183903, NULL, 'G3DSA:2.30.29.30:FF:001295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183904, NULL, 'G3DSA:2.80.10.50:FF:000126', NULL, NULL, 'Fibroblast growth factor 23', NULL, NULL, NULL, NULL, NULL, 4),
(183905, NULL, 'G3DSA:3.90.260.10:FF:000068', NULL, NULL, 'AGAP003342-PA', NULL, NULL, NULL, NULL, NULL, 4),
(183906, NULL, 'G3DSA:3.40.50.300:FF:004086', NULL, NULL, 'endoribonuclease Dicer homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(183907, NULL, 'G3DSA:3.30.450.150:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183908, NULL, 'G3DSA:1.20.58.390:FF:000077', NULL, NULL, 'Ligand-gated ion channel 50', NULL, NULL, NULL, NULL, NULL, 4),
(183909, NULL, 'G3DSA:3.40.50.720:FF:001542', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183910, NULL, 'G3DSA:1.10.418.20:FF:000008', NULL, NULL, 'Ubiquitin-like-specific protease 1', NULL, NULL, NULL, NULL, NULL, 4),
(183911, NULL, 'G3DSA:3.40.800.20:FF:000001', NULL, NULL, 'Histone deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(183912, NULL, 'G3DSA:3.40.640.10:FF:000316', NULL, NULL, 'Adenosylmethionine-8-amino-7-oxononanoate aminotransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(183913, NULL, 'G3DSA:3.30.160.60:FF:004349', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183914, NULL, 'G3DSA:1.50.10.10:FF:000096', NULL, NULL, 'Mannosyl_oligosaccharide_glucosidase_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(183915, NULL, 'G3DSA:1.20.58.390:FF:000279', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(183916, NULL, 'G3DSA:3.40.50.300:FF:005991', NULL, NULL, 'DnaA regulatory inactivator Hda', NULL, NULL, NULL, NULL, NULL, 4),
(183917, NULL, 'G3DSA:4.10.800.10:FF:000023', NULL, NULL, 'Iclp2 protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(183918, NULL, 'G3DSA:3.10.180.10:FF:000012', NULL, NULL, '2,3-dihydroxybiphenyl 1,2-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(183919, NULL, 'G3DSA:3.40.50.1100:FF:000053', NULL, NULL, '1-aminocyclopropane-1-carboxylate deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(183920, NULL, 'G3DSA:2.60.40.10:FF:004046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183921, NULL, 'G3DSA:2.60.120.40:FF:000033', NULL, NULL, 'BclA protein', NULL, NULL, NULL, NULL, NULL, 4),
(183922, NULL, 'G3DSA:3.90.640.10:FF:000199', NULL, NULL, 'Actin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183923, NULL, 'G3DSA:1.20.58.480:FF:000008', NULL, NULL, 'Putative 15-hydroxyprostaglandin dehydrogenase (Nad(+)) protein', NULL, NULL, NULL, NULL, NULL, 4),
(183924, NULL, 'G3DSA:1.25.40.10:FF:002550', NULL, NULL, 'Os01g0600400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(183925, NULL, 'G3DSA:2.40.10.10:FF:000341', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183926, NULL, 'G3DSA:3.80.10.10:FF:002686', NULL, NULL, 'Receptor protein-tyrosine kinase CEPR2 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(183927, NULL, 'G3DSA:3.30.1360.120:FF:000066', NULL, NULL, 'sarcosine dehydrogenase, mitochondrial-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(183928, NULL, 'G3DSA:3.40.50.12160:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183929, NULL, 'G3DSA:1.20.120.1910:FF:000045', NULL, NULL, 'Putative cysteine--tRNA ligase, mitochondrial-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(183930, NULL, 'G3DSA:2.130.10.10:FF:005659', NULL, NULL, 'WD repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183931, NULL, 'G3DSA:1.20.1560.10:FF:000653', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183932, NULL, 'G3DSA:3.80.10.10:FF:001056', NULL, NULL, 'Leucine-rich repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(183933, NULL, 'G3DSA:3.30.2300.10:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183934, NULL, 'G3DSA:3.30.70.1230:FF:000128', NULL, NULL, 'Adenylate/guanylate cyclase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(183935, NULL, 'G3DSA:2.60.120.10:FF:000344', NULL, NULL, 'Germin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(183936, NULL, 'G3DSA:3.40.50.300:FF:005749', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183937, NULL, 'G3DSA:3.40.140.10:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183938, NULL, 'G3DSA:2.30.29.30:FF:000311', NULL, NULL, 'GTP binding protein (Bud4)', NULL, NULL, NULL, NULL, NULL, 4),
(183939, NULL, 'G3DSA:2.70.130.10:FF:000090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183940, NULL, 'G3DSA:3.20.10.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183941, NULL, 'G3DSA:1.20.120.1900:FF:000042', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(183942, NULL, 'G3DSA:3.30.160.60:FF:006120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183943, NULL, 'G3DSA:3.10.450.10:FF:000022', NULL, NULL, 'Fetuin B', NULL, NULL, NULL, NULL, NULL, 4),
(183944, NULL, 'G3DSA:4.10.240.10:FF:000177', NULL, NULL, 'Zcf28p', NULL, NULL, NULL, NULL, NULL, 4),
(183945, NULL, 'G3DSA:2.40.50.140:FF:001068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183946, NULL, 'G3DSA:3.30.70.100:FF:000137', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183947, NULL, 'G3DSA:3.40.720.10:FF:000317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183948, NULL, 'G3DSA:3.30.40.10:FF:001465', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183949, NULL, 'G3DSA:1.10.418.10:FF:000005', NULL, NULL, 'Actinin alpha 4', NULL, NULL, NULL, NULL, NULL, 4),
(183950, NULL, 'G3DSA:3.40.50.2300:FF:001644', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183951, NULL, 'G3DSA:4.10.400.10:FF:000268', NULL, NULL, 'Apical endosomal glycoprotein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(183952, NULL, 'G3DSA:3.40.50.300:FF:007666', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183953, NULL, 'G3DSA:3.40.50.1110:FF:000056', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(183954, NULL, 'G3DSA:3.10.105.10:FF:000018', NULL, NULL, 'RGD-containing lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(183955, NULL, 'G3DSA:2.30.30.1020:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183956, NULL, 'G3DSA:3.40.50.300:FF:008155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183957, NULL, 'G3DSA:3.90.1150.10:FF:000115', NULL, NULL, 'Putative serine C-palmitoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(183958, NULL, 'G3DSA:3.30.70.890:FF:000036', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(183959, NULL, 'G3DSA:3.40.50.150:FF:000634', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183960, NULL, 'G3DSA:3.30.200.20:FF:002121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183961, NULL, 'G3DSA:1.10.238.10:FF:000109', NULL, NULL, 'calumenin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(183962, NULL, 'G3DSA:1.10.8.10:FF:000349', NULL, NULL, 'Baculoviral IAP repeat containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(183963, NULL, 'G3DSA:3.20.20.220:FF:000058', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(183964, NULL, 'G3DSA:3.80.10.10:FF:000893', NULL, NULL, 'Os08g0322500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(183965, NULL, 'G3DSA:3.40.50.300:FF:004119', NULL, NULL, 'GTPase HflX', NULL, NULL, NULL, NULL, NULL, 4),
(183966, NULL, 'G3DSA:3.30.160.60:FF:002404', NULL, NULL, 'Zinc finger protein with KRAB and SCAN domains 16', NULL, NULL, NULL, NULL, NULL, 4),
(183967, NULL, 'G3DSA:1.50.40.10:FF:000480', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(183968, NULL, 'G3DSA:3.40.190.10:FF:000118', NULL, NULL, 'ATP phosphoribosyltransferase 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(183969, NULL, 'G3DSA:1.10.287.70:FF:000179', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(183970, NULL, 'G3DSA:1.20.1250.20:FF:002032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183971, NULL, 'G3DSA:1.10.400.10:FF:000004', NULL, NULL, 'Guanine nucleotide-binding protein subunit alpha-12', NULL, NULL, NULL, NULL, NULL, 4),
(183972, NULL, 'G3DSA:3.40.50.720:FF:001401', NULL, NULL, 'Chlorophyll synthesis pathway protein BchC', NULL, NULL, NULL, NULL, NULL, 4),
(183973, NULL, 'G3DSA:3.30.450.200:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183974, NULL, 'G3DSA:1.25.50.20:FF:000047', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(183975, NULL, 'G3DSA:2.130.10.10:FF:000342', NULL, NULL, 'Nuclear distribution protein PAC1', NULL, NULL, NULL, NULL, NULL, 4),
(183976, NULL, 'G3DSA:3.30.160.60:FF:000336', NULL, NULL, 'zinc finger protein 768', NULL, NULL, NULL, NULL, NULL, 4),
(183977, NULL, 'G3DSA:1.20.120.530:FF:000012', NULL, NULL, 'HTH-type transcriptional regulator McbR', NULL, NULL, NULL, NULL, NULL, 4),
(183978, NULL, 'G3DSA:3.30.160.60:FF:005895', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183979, NULL, 'G3DSA:1.20.1560.10:FF:000597', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183980, NULL, 'G3DSA:1.10.10.10:FF:001558', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183981, NULL, 'G3DSA:3.10.250.10:FF:000097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183982, NULL, 'G3DSA:1.10.418.10:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183983, NULL, 'G3DSA:2.20.25.10:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183984, NULL, 'G3DSA:3.40.50.1000:FF:000079', NULL, NULL, 'Enolase-phosphatase E1', NULL, NULL, NULL, NULL, NULL, 4),
(183985, NULL, 'G3DSA:4.10.860.20:FF:000002', NULL, NULL, 'rabenosyn-5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(183986, NULL, 'G3DSA:3.90.70.10:FF:000109', NULL, NULL, 'Cysteine protease', NULL, NULL, NULL, NULL, NULL, 4),
(183987, NULL, 'G3DSA:2.130.10.10:FF:005715', NULL, NULL, 'GPI inositol-deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(183988, NULL, 'G3DSA:3.40.50.2300:FF:001560', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183989, NULL, 'G3DSA:2.40.170.20:FF:000074', NULL, NULL, 'Ligand-gated TonB-dependent outer membrane channel', NULL, NULL, NULL, NULL, NULL, 4),
(183990, NULL, 'G3DSA:2.10.25.10:FF:000876', NULL, NULL, 'Laminin subunit alpha-3', NULL, NULL, NULL, NULL, NULL, 4),
(183991, NULL, 'G3DSA:1.25.10.10:FF:000923', NULL, NULL, 'Ribosomal RNA processing protein', NULL, NULL, NULL, NULL, NULL, 4),
(183992, NULL, 'G3DSA:1.20.1250.20:FF:001543', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183993, NULL, 'G3DSA:3.30.310.40:FF:000011', NULL, NULL, 'Purine-specific oxidized base lesion DNA N-glycosylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(183994, NULL, 'G3DSA:1.10.510.10:FF:002805', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183995, NULL, 'G3DSA:1.25.40.10:FF:000077', NULL, NULL, 'CTR9 homolog, Paf1/RNA polymerase II complex component', NULL, NULL, NULL, NULL, NULL, 4),
(183996, NULL, 'G3DSA:1.10.150.20:FF:000206', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(183997, NULL, 'G3DSA:3.50.7.10:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(183998, NULL, 'G3DSA:2.130.10.10:FF:001972', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(183999, NULL, 'G3DSA:3.30.420.10:FF:000499', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184000, NULL, 'G3DSA:1.10.510.10:FF:001968', NULL, NULL, 'Death-associated protein kinase related-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(184001, NULL, 'G3DSA:3.40.50.300:FF:001011', NULL, NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', NULL, NULL, NULL, NULL, NULL, 4),
(184002, NULL, 'G3DSA:1.10.3210.10:FF:000062', NULL, NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(184003, NULL, 'G3DSA:3.80.10.10:FF:003703', NULL, NULL, 'Os12g0552700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(184004, NULL, 'G3DSA:4.10.170.10:FF:000002', NULL, NULL, 'serine/threonine-protein kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(184005, NULL, 'G3DSA:3.30.160.60:FF:001915', NULL, NULL, 'Zinc finger protein 287', NULL, NULL, NULL, NULL, NULL, 4),
(184006, NULL, 'G3DSA:3.10.20.30:FF:000116', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184007, NULL, 'G3DSA:3.40.1110.10:FF:000366', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184008, NULL, 'G3DSA:3.50.50.60:FF:000602', NULL, NULL, 'Thiol-specific monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(184009, NULL, 'G3DSA:1.25.10.10:FF:000575', NULL, NULL, 'Serine threonine protein phosphatase 2a 59 kDa regulatory subunit b', NULL, NULL, NULL, NULL, NULL, 4),
(184010, NULL, 'G3DSA:3.30.230.70:FF:000171', NULL, NULL, 'Polyribonucleotide phosphorylase PNPase', NULL, NULL, NULL, NULL, NULL, 4),
(184011, NULL, 'G3DSA:1.20.120.1750:FF:000031', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(184012, NULL, 'G3DSA:3.40.50.880:FF:000061', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(184013, NULL, 'G3DSA:3.40.50.300:FF:008099', NULL, NULL, 'Tudor domain containing 9', NULL, NULL, NULL, NULL, NULL, 4),
(184014, NULL, 'G3DSA:1.10.3060.10:FF:000022', NULL, NULL, 'Protein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(184015, NULL, 'G3DSA:2.30.30.40:FF:000385', NULL, NULL, 'Protein arginine N-methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(184016, NULL, 'G3DSA:3.30.565.10:FF:000413', NULL, NULL, 'Two component sensor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(184017, NULL, 'G3DSA:2.60.40.1360:FF:000020', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(184018, NULL, 'G3DSA:1.25.40.10:FF:002022', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g74850, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(184019, NULL, 'G3DSA:1.20.1070.10:FF:001065', NULL, NULL, 'Brain-specific angiogenesis inhibitor 2', NULL, NULL, NULL, NULL, NULL, 4),
(184020, NULL, 'G3DSA:1.10.246.220:FF:000002', NULL, NULL, 'Telomere repeat-binding factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(184021, NULL, 'G3DSA:3.40.250.10:FF:000236', NULL, NULL, 'Thiosulfate sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(184022, NULL, 'G3DSA:3.50.50.60:FF:001182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184023, NULL, 'G3DSA:1.10.472.130:FF:000046', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(184024, NULL, 'G3DSA:2.60.40.3360:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184025, NULL, 'G3DSA:3.40.190.10:FF:000091', NULL, NULL, 'Porphobilinogen deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(184026, NULL, 'G3DSA:1.10.287.40:FF:000018', NULL, NULL, 'Serine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(184027, NULL, 'G3DSA:2.170.260.10:FF:000024', NULL, NULL, 'LD36719p', NULL, NULL, NULL, NULL, NULL, 4),
(184028, NULL, 'G3DSA:1.10.630.10:FF:000752', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184029, NULL, 'G3DSA:3.40.50.1820:FF:001078', NULL, NULL, 'Polyketide synthase RzxF', NULL, NULL, NULL, NULL, NULL, 4),
(184030, NULL, 'G3DSA:3.40.1190.20:FF:000059', NULL, NULL, 'Ribokinase', NULL, NULL, NULL, NULL, NULL, 4),
(184031, NULL, 'G3DSA:1.20.1540.10:FF:000005', NULL, NULL, 'Presenilins-associated rhomboid-like protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(184032, NULL, 'G3DSA:3.40.50.300:FF:005839', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(184033, NULL, 'G3DSA:3.30.310.50:FF:000014', NULL, NULL, 'EKC/KEOPS complex subunit PCC1', NULL, NULL, NULL, NULL, NULL, 4),
(184034, NULL, 'G3DSA:1.25.10.10:FF:002520', NULL, NULL, 'EXPOrtin (Nuclear export receptor)', NULL, NULL, NULL, NULL, NULL, 4),
(184035, NULL, 'G3DSA:3.30.160.60:FF:002551', NULL, NULL, 'Zinc finger protein 613', NULL, NULL, NULL, NULL, NULL, 4),
(184036, NULL, 'G3DSA:1.10.472.10:FF:000024', NULL, NULL, 'G1/S-specific cyclin-E1', NULL, NULL, NULL, NULL, NULL, 4),
(184037, NULL, 'G3DSA:1.10.630.10:FF:000662', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184038, NULL, 'G3DSA:1.10.510.10:FF:004048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184039, NULL, 'G3DSA:1.10.472.10:FF:000642', NULL, NULL, 'Cyclin, N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(184040, NULL, 'G3DSA:3.30.70.920:FF:000034', NULL, NULL, 'AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(184041, NULL, 'G3DSA:1.10.287.1040:FF:000016', NULL, NULL, 'Exodeoxyribonuclease 7 small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(184042, NULL, 'G3DSA:1.10.287.1490:FF:000128', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184043, NULL, 'G3DSA:2.30.39.10:FF:000093', NULL, NULL, 'Proteinase inhibitor I4 serpin', NULL, NULL, NULL, NULL, NULL, 4),
(184044, NULL, 'G3DSA:2.130.10.10:FF:004703', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184045, NULL, 'G3DSA:3.10.110.10:FF:000238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184046, NULL, 'G3DSA:1.10.10.60:FF:000331', NULL, NULL, 'major centromere autoantigen B', NULL, NULL, NULL, NULL, NULL, 4),
(184047, NULL, 'G3DSA:1.20.120.850:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184048, NULL, 'G3DSA:2.10.220.10:FF:000161', NULL, NULL, 'Fraser extracellular matrix complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(184049, NULL, 'G3DSA:2.60.40.10:FF:000033', NULL, NULL, 'Killer cell immunoglobulin-like receptor', NULL, NULL, NULL, NULL, NULL, 4),
(184050, NULL, 'G3DSA:3.30.160.60:FF:005277', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184051, NULL, 'G3DSA:2.10.25.10:FF:000786', NULL, NULL, 'WAK53a-OsWAK receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(184052, NULL, 'G3DSA:3.30.160.60:FF:005625', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184053, NULL, 'G3DSA:3.40.1110.10:FF:000456', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184054, NULL, 'G3DSA:3.40.50.300:FF:000432', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit beta-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(184055, NULL, 'G3DSA:1.10.472.80:FF:000264', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184056, NULL, 'G3DSA:3.30.200.20:FF:001632', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184057, NULL, 'G3DSA:1.20.1250.20:FF:001048', NULL, NULL, 'YALI0C16225p', NULL, NULL, NULL, NULL, NULL, 4),
(184058, NULL, 'G3DSA:3.20.80.10:FF:000001', NULL, NULL, 'Right origin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(184059, NULL, 'G3DSA:3.40.50.1820:FF:001426', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(184060, NULL, 'G3DSA:1.20.58.870:FF:000002', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(184061, NULL, 'G3DSA:2.30.130.40:FF:000012', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(184062, NULL, 'G3DSA:2.60.40.150:FF:000300', NULL, NULL, 'C2 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(184063, NULL, 'G3DSA:3.30.60.20:FF:000070', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(184064, NULL, 'G3DSA:2.60.40.60:FF:000238', NULL, NULL, 'Desmoglein 1', NULL, NULL, NULL, NULL, NULL, 4),
(184065, NULL, 'G3DSA:1.10.555.10:FF:000178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184066, NULL, 'G3DSA:3.90.640.90:FF:000003', NULL, NULL, 'BTG1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(184067, NULL, 'G3DSA:3.40.50.300:FF:002321', NULL, NULL, 'YPL245W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(184068, NULL, 'G3DSA:3.40.50.10860:FF:000023', NULL, NULL, 'C-1-tetrahydrofolate synthase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(184069, NULL, 'G3DSA:3.40.190.10:FF:000034', NULL, NULL, 'Chorismate mutase/prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(184070, NULL, 'G3DSA:3.80.10.10:FF:001433', NULL, NULL, 'Toll-like receptor 15', NULL, NULL, NULL, NULL, NULL, 4),
(184071, NULL, 'G3DSA:2.60.40.10:FF:004607', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184072, NULL, 'G3DSA:3.30.505.10:FF:000235', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184073, NULL, 'G3DSA:1.10.8.260:FF:000001', NULL, NULL, 'Pyridine nucleotide-disulfide oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(184074, NULL, 'G3DSA:3.40.50.150:FF:000836', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(184075, NULL, 'G3DSA:1.10.30.10:FF:000008', NULL, NULL, 'transcription factor SOX-7', NULL, NULL, NULL, NULL, NULL, 4),
(184076, NULL, 'G3DSA:2.60.40.200:FF:000012', NULL, NULL, 'Superoxide dismutase [Cu-Zn]', NULL, NULL, NULL, NULL, NULL, 4),
(184077, NULL, 'G3DSA:1.10.510.10:FF:004520', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184078, NULL, 'G3DSA:2.10.50.10:FF:000058', NULL, NULL, 'Cysteine repeat modular protein 4 PbCRM4', NULL, NULL, NULL, NULL, NULL, 4),
(184079, NULL, 'G3DSA:3.90.79.10:FF:000163', NULL, NULL, 'Hydrolase, NUDIX family protein', NULL, NULL, NULL, NULL, NULL, 4),
(184080, NULL, 'G3DSA:1.10.150.240:FF:000040', NULL, NULL, 'HAD-superfamily hydrolase, subfamily IA, variant 3', NULL, NULL, NULL, NULL, NULL, 4),
(184081, NULL, 'G3DSA:1.25.40.10:FF:001089', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(184082, NULL, 'G3DSA:3.30.1380.20:FF:000020', NULL, NULL, 'Trafficking protein particle complex subunit 6B', NULL, NULL, NULL, NULL, NULL, 4),
(184083, NULL, 'G3DSA:1.10.8.270:FF:000004', NULL, NULL, 'TBC1 domain family, member 22B', NULL, NULL, NULL, NULL, NULL, 4),
(184084, NULL, 'G3DSA:3.40.50.300:FF:004445', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184085, NULL, 'G3DSA:1.10.150.280:FF:000001', NULL, NULL, 'Competence protein ComEA helix-hairpin-helix repeat region', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(184086, NULL, 'G3DSA:3.20.20.70:FF:000852', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184087, NULL, 'G3DSA:3.30.70.330:FF:002280', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184088, NULL, 'G3DSA:1.20.58.70:FF:000022', NULL, NULL, 'Syntaxin-5', NULL, NULL, NULL, NULL, NULL, 4),
(184089, NULL, 'G3DSA:3.40.50.720:FF:001255', NULL, NULL, 'Alcohol dehydrogenase GroES domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(184090, NULL, 'G3DSA:1.25.10.10:FF:002161', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184091, NULL, 'G3DSA:2.130.10.10:FF:000196', NULL, NULL, 'Apoptotic protease-activating factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(184092, NULL, 'G3DSA:2.60.120.560:FF:000022', NULL, NULL, 'Glycosyl hydrolases family 32 superfamily (AFU_orthologue AFUA_6G05000)', NULL, NULL, NULL, NULL, NULL, 4),
(184093, NULL, 'G3DSA:1.20.1250.20:FF:001341', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(184094, NULL, 'G3DSA:2.20.70.10:FF:000250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184095, NULL, 'G3DSA:2.40.30.230:FF:000001', NULL, NULL, 'Regulator of nonsense transcripts 1', NULL, NULL, NULL, NULL, NULL, 4),
(184096, NULL, 'G3DSA:1.20.58.80:FF:000025', NULL, NULL, 'serine/threonine-protein kinase ULK3', NULL, NULL, NULL, NULL, NULL, 4),
(184097, NULL, 'G3DSA:3.40.50.300:FF:006536', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184098, NULL, 'G3DSA:3.40.50.300:FF:008245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184099, NULL, 'G3DSA:3.40.30.10:FF:000424', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184100, NULL, 'G3DSA:3.30.160.60:FF:005569', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184101, NULL, 'G3DSA:1.25.10.10:FF:001738', NULL, NULL, 'YALI0E01232p', NULL, NULL, NULL, NULL, NULL, 4),
(184102, NULL, 'G3DSA:3.30.70.240:FF:000038', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(184103, NULL, 'G3DSA:1.50.40.10:FF:000479', NULL, NULL, 'AFR253Wp', NULL, NULL, NULL, NULL, NULL, 4),
(184104, NULL, 'G3DSA:3.30.1360.180:FF:000005', NULL, NULL, 'ectonucleotide pyrophosphatase/phosphodiesterase family member 7', NULL, NULL, NULL, NULL, NULL, 4),
(184105, NULL, 'G3DSA:1.25.40.10:FF:004910', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184106, NULL, 'G3DSA:3.40.630.10:FF:000018', NULL, NULL, 'Aminoacyl-histidine dipeptidase PepD', NULL, NULL, NULL, NULL, NULL, 4),
(184107, NULL, 'G3DSA:1.25.40.60:FF:000007', NULL, NULL, 'Vacuolar protein sorting-associated protein 45', NULL, NULL, NULL, NULL, NULL, 4),
(184108, NULL, 'G3DSA:1.20.58.90:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184109, NULL, 'G3DSA:3.40.33.10:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184110, NULL, 'G3DSA:3.90.190.10:FF:000506', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184111, NULL, 'G3DSA:1.10.510.10:FF:002334', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184112, NULL, 'G3DSA:2.60.200.20:FF:000084', NULL, NULL, 'FOG: FHA domain', NULL, NULL, NULL, NULL, NULL, 4),
(184113, NULL, 'G3DSA:3.60.21.10:FF:000048', NULL, NULL, 'Metallophosphoesterase', NULL, NULL, NULL, NULL, NULL, 4),
(184114, NULL, 'G3DSA:1.25.10.10:FF:000070', NULL, NULL, 'armadillo repeat-containing protein 8 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(184115, NULL, 'G3DSA:1.20.1270.60:FF:000196', NULL, NULL, 'AaceriAFR725Cp', NULL, NULL, NULL, NULL, NULL, 4),
(184116, NULL, 'G3DSA:1.10.150.290:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184117, NULL, 'G3DSA:3.30.420.110:FF:000012', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(184118, NULL, 'G3DSA:2.60.40.790:FF:000172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184119, NULL, 'G3DSA:3.30.497.10:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(184120, NULL, 'G3DSA:3.30.160.60:FF:003478', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184121, NULL, 'G3DSA:3.30.1330.60:FF:000034', NULL, NULL, 'Flagellar motor protein MotD', NULL, NULL, NULL, NULL, NULL, 4),
(184122, NULL, 'G3DSA:2.70.50.30:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184123, NULL, 'G3DSA:3.30.160.60:FF:001769', NULL, NULL, 'chromosome alignment-maintaining phosphoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(184124, NULL, 'G3DSA:3.10.20.10:FF:000020', NULL, NULL, 'DNA fragmentation factor, alpha polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(184125, NULL, 'G3DSA:3.30.810.10:FF:000017', NULL, NULL, '1-phosphatidylinositol-3-phosphate 5-kinase (Fab1), putative (AFU_orthologue AFUA_6G07440)', NULL, NULL, NULL, NULL, NULL, 4),
(184126, NULL, 'G3DSA:3.40.33.10:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184127, NULL, 'G3DSA:3.80.10.10:FF:002040', NULL, NULL, 'Insulin-like growth factor-binding protein acid labile subunit', NULL, NULL, NULL, NULL, NULL, 4),
(184128, NULL, 'G3DSA:3.30.1370.10:FF:000134', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(184129, NULL, 'G3DSA:3.40.50.300:FF:008301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184130, NULL, 'G3DSA:2.60.40.10:FF:003938', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184131, NULL, 'G3DSA:3.30.200.20:FF:001626', NULL, NULL, 'Ser/Thr protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184132, NULL, 'G3DSA:1.10.1420.10:FF:000100', NULL, NULL, 'Endonuclease MutS2', NULL, NULL, NULL, NULL, NULL, 4),
(184133, NULL, 'G3DSA:3.40.50.2020:FF:000048', NULL, NULL, 'Hypoxanthine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(184134, NULL, 'G3DSA:1.25.40.20:FF:001569', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184135, NULL, 'G3DSA:2.60.40.60:FF:000295', NULL, NULL, 'Cadherin 86C, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(184136, NULL, 'G3DSA:3.40.50.300:FF:004030', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(184137, NULL, 'G3DSA:1.10.510.10:FF:000720', NULL, NULL, 'Serine/threonine-protein kinase UCNL', NULL, NULL, NULL, NULL, NULL, 4),
(184138, NULL, 'G3DSA:1.25.10.10:FF:000159', NULL, NULL, 'Plakophilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(184139, NULL, 'G3DSA:3.30.1360.170:FF:000002', NULL, NULL, 'Thymidylate synthase ThyX', NULL, NULL, NULL, NULL, NULL, 4),
(184140, NULL, 'G3DSA:2.20.25.10:FF:000090', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(184141, NULL, 'G3DSA:3.30.200.60:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184142, NULL, 'G3DSA:2.60.40.10:FF:000920', NULL, NULL, 'NXPE family member 4', NULL, NULL, NULL, NULL, NULL, 4),
(184143, NULL, 'G3DSA:3.40.1810.10:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184144, NULL, 'G3DSA:1.20.58.60:FF:000396', NULL, NULL, 'VAB-10B protein', NULL, NULL, NULL, NULL, NULL, 4),
(184145, NULL, 'G3DSA:1.10.274.30:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184146, NULL, 'G3DSA:1.20.1440.90:FF:000010', NULL, NULL, 'Phosphoenolpyruvate carboxylase 4', NULL, NULL, NULL, NULL, NULL, 4),
(184147, NULL, 'G3DSA:2.40.10.10:FF:000700', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184148, NULL, 'G3DSA:3.40.50.790:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184149, NULL, 'G3DSA:3.40.630.10:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184150, NULL, 'G3DSA:2.40.30.10:FF:000230', NULL, NULL, 'Elongation factor Tu, apicoplast', NULL, NULL, NULL, NULL, NULL, 4),
(184151, NULL, 'G3DSA:1.10.8.810:FF:000003', NULL, NULL, 'Daxx-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(184152, NULL, 'G3DSA:3.40.50.2000:FF:000042', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(184153, NULL, 'G3DSA:3.40.50.300:FF:004406', NULL, NULL, 'Probable exopolysaccharide polymerization protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(184154, NULL, 'G3DSA:3.20.20.80:FF:000855', NULL, NULL, 'Brain chitinase like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(184155, NULL, 'G3DSA:2.130.10.10:FF:000252', NULL, NULL, 'Nucleolar protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(184156, NULL, 'G3DSA:1.20.1070.10:FF:000986', NULL, NULL, 'Melanin-concentrating hormone receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(184157, NULL, 'G3DSA:3.10.20.90:FF:000145', NULL, NULL, 'regulator of G-protein signaling 14 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(184158, NULL, 'G3DSA:1.10.287.1490:FF:000038', NULL, NULL, 'Zn-ribbon protein, possibly nucleic acid-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(184159, NULL, 'G3DSA:3.40.50.1980:FF:000030', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(184160, NULL, 'G3DSA:3.30.565.10:FF:000211', NULL, NULL, 'Sensor protein UhpB', NULL, NULL, NULL, NULL, NULL, 4),
(184161, NULL, 'G3DSA:3.40.50.2300:FF:001267', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184162, NULL, 'G3DSA:3.40.50.150:FF:000308', NULL, NULL, 'endothelin-converting enzyme 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(184163, NULL, 'G3DSA:1.25.10.10:FF:002048', NULL, NULL, 'cytoskeleton-associated protein 5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(184164, NULL, 'G3DSA:1.10.1780.10:FF:000003', NULL, NULL, 'ATP-dependent chaperone ClpB', NULL, NULL, NULL, NULL, NULL, 4),
(184165, NULL, 'G3DSA:1.20.5.110:FF:000185', NULL, NULL, 'Phosphoprotein P', NULL, NULL, NULL, NULL, NULL, 4),
(184166, NULL, 'G3DSA:1.25.40.10:FF:001566', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(184167, NULL, 'G3DSA:3.20.20.100:FF:000112', NULL, NULL, 'Probable L-fucose dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(184168, NULL, 'G3DSA:2.60.40.10:FF:005176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184169, NULL, 'G3DSA:3.30.40.10:FF:002100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184170, NULL, 'G3DSA:3.90.550.10:FF:000113', NULL, NULL, 'UDP-glucose pyrophosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(184171, NULL, 'G3DSA:3.30.160.60:FF:001882', NULL, NULL, 'Zinc finger protein 473', NULL, NULL, NULL, NULL, NULL, 4),
(184172, NULL, 'G3DSA:3.40.50.200:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184173, NULL, 'G3DSA:3.40.50.1460:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184174, NULL, 'G3DSA:3.30.160.60:FF:005951', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184175, NULL, 'G3DSA:2.60.40.150:FF:000502', NULL, NULL, 'Copine, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184176, NULL, 'G3DSA:3.40.50.2300:FF:000340', NULL, NULL, 'Catabolite control protein A', NULL, NULL, NULL, NULL, NULL, 4),
(184177, NULL, 'G3DSA:3.40.50.1100:FF:000194', NULL, NULL, 'L-serine ammonia-lyase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184178, NULL, 'G3DSA:1.10.8.10:FF:000175', NULL, NULL, 'Holliday junction ATP-dependent DNA helicase RuvA', NULL, NULL, NULL, NULL, NULL, 4),
(184179, NULL, 'G3DSA:2.130.10.10:FF:000516', NULL, NULL, 'WD repeat-containing protein 55-like', NULL, NULL, NULL, NULL, NULL, 4),
(184180, NULL, 'G3DSA:3.90.550.10:FF:000641', NULL, NULL, 'UDP-glucose pyrophosphorylase 2b', NULL, NULL, NULL, NULL, NULL, 4),
(184181, NULL, 'G3DSA:3.40.50.150:FF:000460', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', NULL, NULL, NULL, NULL, NULL, 4),
(184182, NULL, 'G3DSA:3.30.200.20:FF:002413', NULL, NULL, 'Putative S-locus receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(184183, NULL, 'G3DSA:2.60.40.10:FF:003793', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184184, NULL, 'G3DSA:1.10.3080.10:FF:000023', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(184185, NULL, 'G3DSA:1.20.1250.10:FF:000079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184186, NULL, 'G3DSA:3.40.50.1440:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(184187, NULL, 'G3DSA:1.10.287.70:FF:000595', NULL, NULL, 'Glutamate receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184188, NULL, 'G3DSA:2.60.40.10:FF:005884', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184189, NULL, 'G3DSA:2.30.30.40:FF:000093', NULL, NULL, 'Protein kinase activator Bem1', NULL, NULL, NULL, NULL, NULL, 4),
(184190, NULL, 'G3DSA:3.30.70.1230:FF:000134', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184191, NULL, 'G3DSA:1.10.10.60:FF:000185', NULL, NULL, 'MYB transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(184192, NULL, 'G3DSA:3.30.9.90:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184193, NULL, 'G3DSA:1.10.238.10:FF:000525', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184194, NULL, 'G3DSA:3.40.140.10:FF:000205', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 14-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(184195, NULL, 'G3DSA:3.40.50.1780:FF:000026', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', NULL, NULL, NULL, NULL, NULL, 4),
(184196, NULL, 'G3DSA:3.30.160.60:FF:000044', NULL, NULL, 'zinc finger protein 37 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(184197, NULL, 'G3DSA:1.25.10.10:FF:001795', NULL, NULL, 'AP-3 complex subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(184198, NULL, 'G3DSA:1.20.1250.20:FF:001812', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184199, NULL, 'G3DSA:1.25.10.10:FF:002104', NULL, NULL, 'LD16031p', NULL, NULL, NULL, NULL, NULL, 4),
(184200, NULL, 'G3DSA:3.10.105.10:FF:000081', NULL, NULL, 'Xyloglucan ABC transport system, sugar-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(184201, NULL, 'G3DSA:3.40.50.300:FF:000376', NULL, NULL, 'Putative heterogeneous nuclear ribonucleoprotein U', NULL, NULL, NULL, NULL, NULL, 4),
(184202, NULL, 'G3DSA:1.10.510.10:FF:002811', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184203, NULL, 'G3DSA:2.60.40.10:FF:002157', NULL, NULL, 'Wrapper protein', NULL, NULL, NULL, NULL, NULL, 4),
(184204, NULL, 'G3DSA:2.60.40.10:FF:004720', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184205, NULL, 'G3DSA:3.60.40.10:FF:000227', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(184206, NULL, 'G3DSA:2.130.10.10:FF:003916', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184207, NULL, 'G3DSA:1.10.560.10:FF:000072', NULL, NULL, 'Mitochondrial chaperone TCM62', NULL, NULL, NULL, NULL, NULL, 4),
(184208, NULL, 'G3DSA:3.90.550.10:FF:000169', NULL, NULL, 'Dolichyl-phosphate beta-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(184209, NULL, 'G3DSA:1.20.58.80:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184210, NULL, 'G3DSA:3.40.140.10:FF:000262', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184211, NULL, 'G3DSA:3.40.395.10:FF:000004', NULL, NULL, 'sentrin-specific protease 7 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(184212, NULL, 'G3DSA:1.20.120.350:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184213, NULL, 'G3DSA:3.30.40.10:FF:001459', NULL, NULL, 'Peroxisome assembly protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184214, NULL, 'G3DSA:1.10.287.70:FF:000538', NULL, NULL, 'Potassium intermediate/small conductance calcium-activated channel, subfamily N, member 4', NULL, NULL, NULL, NULL, NULL, 4),
(184215, NULL, 'G3DSA:3.30.70.3540:FF:000001', NULL, NULL, 'Orf1a polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(184216, NULL, 'G3DSA:3.30.70.2630:FF:000003', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(184217, NULL, 'G3DSA:3.30.160.60:FF:002135', NULL, NULL, 'ZAP1p Zinc-regulated transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(184218, NULL, 'G3DSA:2.40.30.70:FF:000017', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184219, NULL, 'G3DSA:1.20.1250.20:FF:001009', NULL, NULL, 'Unplaced genomic scaffold supercont2.19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(184220, NULL, 'G3DSA:1.10.10.10:FF:001699', NULL, NULL, 'PLP-dependent aminotransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(184221, NULL, 'G3DSA:3.30.420.40:FF:000603', NULL, NULL, 'Heat shock protein70, hsp70A2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184222, NULL, 'G3DSA:1.10.510.10:FF:001030', NULL, NULL, 'Protein kinase 7', NULL, NULL, NULL, NULL, NULL, 4),
(184223, NULL, 'G3DSA:1.10.10.10:FF:000541', NULL, NULL, 'Transcriptional regulator SarA', NULL, NULL, NULL, NULL, NULL, 4),
(184224, NULL, 'G3DSA:1.10.260.100:FF:000028', NULL, NULL, 'Hsp-70 Interacting Protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(184225, NULL, 'G3DSA:3.40.50.1100:FF:000137', NULL, NULL, 'Tryptophan synthase beta chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(184226, NULL, 'G3DSA:2.60.40.60:FF:000093', NULL, NULL, 'Protocadherin 10', NULL, NULL, NULL, NULL, NULL, 4),
(184227, NULL, 'G3DSA:3.40.50.2000:FF:000986', NULL, NULL, 'Sucrose synthase 3', NULL, NULL, NULL, NULL, NULL, 4),
(184228, NULL, 'G3DSA:2.40.50.100:FF:000090', NULL, NULL, 'Sugar ABC transporter ATP-binding protein SugC', NULL, NULL, NULL, NULL, NULL, 4),
(184229, NULL, 'G3DSA:2.120.10.30:FF:000253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184230, NULL, 'G3DSA:2.40.30.130:FF:000010', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(184231, NULL, 'G3DSA:3.30.70.80:FF:000009', NULL, NULL, 'Organelle RRM domain-containing protein 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(184232, NULL, 'G3DSA:2.40.30.10:FF:000050', NULL, NULL, 'NADH oxidoreductase hcr', NULL, NULL, NULL, NULL, NULL, 4),
(184233, NULL, 'G3DSA:2.30.30.1150:FF:000020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184234, NULL, 'G3DSA:3.30.1840.10:FF:000002', NULL, NULL, 'Polyphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(184235, NULL, 'G3DSA:2.60.40.10:FF:004248', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184236, NULL, 'G3DSA:1.10.10.60:FF:000505', NULL, NULL, 'Homeodomain-like transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(184237, NULL, 'G3DSA:3.50.50.60:FF:000310', NULL, NULL, 'FAD-dependent oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(184238, NULL, 'G3DSA:3.40.1110.10:FF:000282', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184239, NULL, 'G3DSA:3.30.70.20:FF:000042', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', NULL, NULL, NULL, NULL, NULL, 4),
(184240, NULL, 'G3DSA:2.100.10.30:FF:000001', NULL, NULL, 'Jacalin-related lectin 33', NULL, NULL, NULL, NULL, NULL, 4),
(184241, NULL, 'G3DSA:3.40.50.1820:FF:001842', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184242, NULL, 'G3DSA:3.30.559.30:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184243, NULL, 'G3DSA:2.60.40.10:FF:000538', NULL, NULL, 'Striated muscle preferentially expressed protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(184244, NULL, 'G3DSA:3.30.40.10:FF:001791', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184245, NULL, 'G3DSA:3.40.50.300:FF:005665', NULL, NULL, 'Replication factor C, subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(184246, NULL, 'G3DSA:3.40.50.2300:FF:000008', NULL, NULL, 'Two-component response regulator OmpR', NULL, NULL, NULL, NULL, NULL, 4),
(184247, NULL, 'G3DSA:1.10.246.190:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184248, NULL, 'G3DSA:2.60.220.30:FF:000032', NULL, NULL, 'Unc-5 netrin receptor C', NULL, NULL, NULL, NULL, NULL, 4),
(184249, NULL, 'G3DSA:3.30.200.20:FF:001806', NULL, NULL, 'Kinase, CAMKK', NULL, NULL, NULL, NULL, NULL, 4),
(184250, NULL, 'G3DSA:1.10.238.10:FF:000435', NULL, NULL, 'WGS project CABT00000000 data, contig 2.2', NULL, NULL, NULL, NULL, NULL, 4),
(184251, NULL, 'G3DSA:3.30.710.10:FF:000398', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184252, NULL, 'G3DSA:2.10.25.10:FF:001332', NULL, NULL, 'Notch receptor 3', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(184253, NULL, 'G3DSA:3.10.20.90:FF:000673', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184254, NULL, 'G3DSA:2.130.10.10:FF:004226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184255, NULL, 'G3DSA:2.130.10.10:FF:004411', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184256, NULL, 'G3DSA:1.10.405.10:FF:000026', NULL, NULL, 'Rab proteins geranylgeranyltransferase component A', NULL, NULL, NULL, NULL, NULL, 4),
(184257, NULL, 'G3DSA:3.80.10.10:FF:002692', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184258, NULL, 'G3DSA:3.30.160.60:FF:000605', NULL, NULL, 'zinc finger protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(184259, NULL, 'G3DSA:3.40.30.10:FF:000098', NULL, NULL, 'Hydrogenase-1 operon protein hyaE', NULL, NULL, NULL, NULL, NULL, 4),
(184260, NULL, 'G3DSA:1.10.20.10:FF:000036', NULL, NULL, 'CBF/NF-Y family transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(184261, NULL, 'G3DSA:1.10.8.60:FF:000493', NULL, NULL, 'ATPase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(184262, NULL, 'G3DSA:3.40.50.300:FF:000606', NULL, NULL, 'IS100 transposase orfB', NULL, NULL, NULL, NULL, NULL, 4),
(184263, NULL, 'G3DSA:3.40.920.10:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184264, NULL, 'G3DSA:3.30.70.60:FF:000003', NULL, NULL, '30S ribosomal protein S6', NULL, NULL, NULL, NULL, NULL, 4),
(184265, NULL, 'G3DSA:3.80.10.10:FF:001904', NULL, NULL, 'Photoactivated adenylate cyclase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(184266, NULL, 'G3DSA:3.40.50.300:FF:000286', NULL, NULL, 'ADP-ribosylation factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(184267, NULL, 'G3DSA:3.30.70.1130:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184268, NULL, 'G3DSA:2.60.40.60:FF:001020', NULL, NULL, 'Si:ch211-186j3.6', NULL, NULL, NULL, NULL, NULL, 4),
(184269, NULL, 'G3DSA:3.90.320.10:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184270, NULL, 'G3DSA:3.40.30.10:FF:000188', NULL, NULL, 'Chloride intracellular channel exc-4', NULL, NULL, NULL, NULL, NULL, 4),
(184271, NULL, 'G3DSA:1.25.40.20:FF:000462', NULL, NULL, 'Hos4p', NULL, NULL, NULL, NULL, NULL, 4),
(184272, NULL, 'G3DSA:1.20.1740.10:FF:000190', NULL, NULL, 'Solute carrier family 12 member 10, tandem duplicate 3', NULL, NULL, NULL, NULL, NULL, 4),
(184273, NULL, 'G3DSA:3.30.70.120:FF:000002', NULL, NULL, 'ATP phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(184274, NULL, 'G3DSA:1.10.1170.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184275, NULL, 'G3DSA:1.10.533.10:FF:000251', NULL, NULL, 'Caspase 10', NULL, NULL, NULL, NULL, NULL, 4),
(184276, NULL, 'G3DSA:3.30.160.60:FF:002606', NULL, NULL, 'Zinc finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184277, NULL, 'G3DSA:3.40.50.300:FF:007992', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184278, NULL, 'G3DSA:3.40.50.2300:FF:000250', NULL, NULL, 'Two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(184279, NULL, 'G3DSA:2.60.40.10:FF:006047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184280, NULL, 'G3DSA:2.60.98.10:FF:000008', NULL, NULL, 'Structural polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(184281, NULL, 'G3DSA:2.40.10.10:FF:000138', NULL, NULL, 'Kallikrein related peptidase 11', NULL, NULL, NULL, NULL, NULL, 4),
(184282, NULL, 'G3DSA:1.20.5.4820:FF:000011', NULL, NULL, 'Dachs, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(184283, NULL, 'G3DSA:2.60.340.10:FF:000001', NULL, NULL, 'Gp8 baseplate wedge subunit', NULL, NULL, NULL, NULL, NULL, 4),
(184284, NULL, 'G3DSA:1.10.10.10:FF:001884', NULL, NULL, 'Vacuolar-sorting protein SNF8', NULL, NULL, NULL, NULL, NULL, 4),
(184285, NULL, 'G3DSA:2.10.110.20:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184286, NULL, 'G3DSA:3.40.50.1820:FF:001039', NULL, NULL, 'Serine carboxypeptidase-like 18', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(184287, NULL, 'G3DSA:1.10.1450.10:FF:000102', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(184288, NULL, 'G3DSA:3.80.10.10:FF:000449', NULL, NULL, 'F-box protein SKIP2', NULL, NULL, NULL, NULL, NULL, 4),
(184289, NULL, 'G3DSA:3.20.20.140:FF:000186', NULL, NULL, 'PHP domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(184290, NULL, 'G3DSA:3.30.530.20:FF:000128', NULL, NULL, 'Phosphatidylinositol transfer protein alpha isoform', NULL, NULL, NULL, NULL, NULL, 4),
(184291, NULL, 'G3DSA:3.40.50.150:FF:001764', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184292, NULL, 'G3DSA:3.40.50.1820:FF:000819', NULL, NULL, 'ATP-dependent serine activating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(184293, NULL, 'G3DSA:1.10.287.2900:FF:000017', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184294, NULL, 'G3DSA:6.10.250.3280:FF:000001', NULL, NULL, 'Envelope glycoprotein B', NULL, NULL, NULL, NULL, NULL, 4),
(184295, NULL, 'G3DSA:2.60.120.10:FF:000018', NULL, NULL, '4-deoxy-L-threo-5-hexosulose-uronate ketol-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(184296, NULL, 'G3DSA:1.10.560.10:FF:000162', NULL, NULL, 'T-complex protein 1 subunit eta', NULL, NULL, NULL, NULL, NULL, 4),
(184297, NULL, 'G3DSA:3.40.30.10:FF:000391', NULL, NULL, 'Unplaced genomic scaffold supercont1.8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(184298, NULL, 'G3DSA:1.10.510.10:FF:003879', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184299, NULL, 'G3DSA:1.10.510.10:FF:003593', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184300, NULL, 'G3DSA:1.10.418.40:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184301, NULL, 'G3DSA:2.60.120.10:FF:000546', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184302, NULL, 'G3DSA:3.90.470.10:FF:000022', NULL, NULL, 'Mitochondrial ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(184303, NULL, 'G3DSA:2.70.150.10:FF:000091', NULL, NULL, 'Metal cation transporter P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(184304, NULL, 'G3DSA:2.60.40.1760:FF:000011', NULL, NULL, 'Glycosyl hydrolases family 31 protein', NULL, NULL, NULL, NULL, NULL, 4),
(184305, NULL, 'G3DSA:3.40.630.30:FF:000086', NULL, NULL, 'Acetyltransferase, GNAT family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184306, NULL, 'G3DSA:1.25.40.250:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184307, NULL, 'G3DSA:1.25.10.10:FF:000721', NULL, NULL, 'AP-4 complex subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(184308, NULL, 'G3DSA:1.25.40.240:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184309, NULL, 'G3DSA:3.90.550.10:FF:000023', NULL, NULL, 'Glucose-1-phosphate thymidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(184310, NULL, 'G3DSA:1.25.40.10:FF:001853', NULL, NULL, 'Soluble_NSF_attachment_protein_-_SNAP_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(184311, NULL, 'G3DSA:3.90.470.20:FF:000025', NULL, NULL, 'Mitochondrial holo-[acyl-carrier-protein] synthase', NULL, NULL, NULL, NULL, NULL, 4),
(184312, NULL, 'G3DSA:2.60.40.10:FF:000448', NULL, NULL, 'Neuronal cell adhesion molecule', NULL, NULL, NULL, NULL, NULL, 4),
(184313, NULL, 'G3DSA:3.90.550.10:FF:000080', NULL, NULL, 'D-ribitol-5-phosphate cytidylyltransferase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(184314, NULL, 'G3DSA:3.40.50.300:FF:002085', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(184315, NULL, 'G3DSA:2.60.40.10:FF:002303', NULL, NULL, 'Sortilin-related receptor', NULL, NULL, NULL, NULL, NULL, 4),
(184316, NULL, 'G3DSA:3.40.50.1820:FF:001281', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184317, NULL, 'G3DSA:3.40.50.300:FF:007464', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(184318, NULL, 'G3DSA:3.30.70.330:FF:001257', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(184319, NULL, 'G3DSA:2.60.120.610:FF:000003', NULL, NULL, 'Probable arabinosyltransferase A', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(184320, NULL, 'G3DSA:2.10.110.10:FF:000006', NULL, NULL, 'LIM homeobox transcription factor 1-beta', NULL, NULL, NULL, NULL, NULL, 4),
(184321, NULL, 'G3DSA:3.10.20.90:FF:000055', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(184322, NULL, 'G3DSA:3.90.550.20:FF:000026', NULL, NULL, 'Mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(184323, NULL, 'G3DSA:1.25.40.10:FF:004146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184324, NULL, 'G3DSA:3.40.50.300:FF:003102', NULL, NULL, 'Related to PRP12-involved in early maturation of pre-rRNA', NULL, NULL, NULL, NULL, NULL, 4),
(184325, NULL, 'G3DSA:3.30.40.10:FF:001173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184326, NULL, 'G3DSA:3.30.60.20:FF:000103', NULL, NULL, 'Phorbol esters/diacylglycerol binding domain (C1 domain) domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(184327, NULL, 'G3DSA:3.10.50.40:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184328, NULL, 'G3DSA:2.130.10.10:FF:002141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184329, NULL, 'G3DSA:3.40.50.2000:FF:000896', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(184330, NULL, 'G3DSA:2.60.40.4070:FF:000001', NULL, NULL, 'Basal-body rod modification protein FlgD', NULL, NULL, NULL, NULL, NULL, 4),
(184331, NULL, 'G3DSA:2.40.70.10:FF:000024', NULL, NULL, 'Endothiapepsin', NULL, NULL, NULL, NULL, NULL, 4),
(184332, NULL, 'G3DSA:3.30.450.20:FF:000599', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(184333, NULL, 'G3DSA:2.40.10.10:FF:000195', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(184334, NULL, 'G3DSA:3.40.50.10420:FF:000004', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase-like protein COG0212', NULL, NULL, NULL, NULL, NULL, 4),
(184335, NULL, 'G3DSA:3.30.60.30:FF:000106', NULL, NULL, 'Protein CBG17314', NULL, NULL, NULL, NULL, NULL, 4),
(184336, NULL, 'G3DSA:2.60.40.10:FF:002450', NULL, NULL, 'HMCN2 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(184337, NULL, 'G3DSA:1.25.10.10:FF:000103', NULL, NULL, 'Anaphase promoting complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(184338, NULL, 'G3DSA:1.20.1270.280:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184339, NULL, 'G3DSA:3.20.20.70:FF:000291', NULL, NULL, 'N-acetylneuraminate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(184340, NULL, 'G3DSA:1.10.560.10:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184341, NULL, 'G3DSA:1.20.58.390:FF:000133', NULL, NULL, 'Proton-gated ion channel', NULL, NULL, NULL, NULL, NULL, 4),
(184342, NULL, 'G3DSA:3.50.50.60:FF:000400', NULL, NULL, 'FAD-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(184343, NULL, 'G3DSA:2.20.20.10:FF:000005', NULL, NULL, 'Carboxypeptidase inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(184344, NULL, 'G3DSA:3.30.160.60:FF:004405', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184345, NULL, 'G3DSA:3.50.50.60:FF:001384', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184346, NULL, 'G3DSA:2.102.10.10:FF:000052', NULL, NULL, 'Cytidine monophosphate-N-acetylneuraminic acid hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(184347, NULL, 'G3DSA:2.60.40.60:FF:000800', NULL, NULL, 'Protocadherin 15a CD3 isoform', NULL, NULL, NULL, NULL, NULL, 4),
(184348, NULL, 'G3DSA:3.90.1410.10:FF:000068', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184349, NULL, 'G3DSA:3.10.250.10:FF:000041', NULL, NULL, 'Transmembrane protease, serine 5 (Spinesin), isoform CRA_c', NULL, NULL, NULL, NULL, NULL, 4),
(184350, NULL, 'G3DSA:2.60.40.60:FF:000710', NULL, NULL, 'Cadherin-4', NULL, NULL, NULL, NULL, NULL, 4),
(184351, NULL, 'G3DSA:2.60.120.10:FF:000636', NULL, NULL, '3-hydroxyanthranilate 3,4-dioxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(184352, NULL, 'G3DSA:2.60.40.1730:FF:000092', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184353, NULL, 'G3DSA:3.40.50.1000:FF:000641', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184354, NULL, 'G3DSA:1.10.730.10:FF:000231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184355, NULL, 'G3DSA:3.30.200.20:FF:001396', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(184356, NULL, 'G3DSA:3.90.105.10:FF:000023', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(184357, NULL, 'G3DSA:4.10.1120.10:FF:000002', NULL, NULL, 'Retinal cone rhodopsin-sensitive cGMP 3'',5''-cyclic phosphodiesterase subunit gamma-like', NULL, NULL, NULL, NULL, NULL, 4),
(184358, NULL, 'G3DSA:1.10.10.10:FF:000451', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(184359, NULL, 'G3DSA:1.10.1160.10:FF:000001', NULL, NULL, 'Glutamine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(184360, NULL, 'G3DSA:3.30.160.60:FF:004462', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184361, NULL, 'G3DSA:2.60.40.10:FF:005827', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184362, NULL, 'G3DSA:1.10.287.110:FF:000017', NULL, NULL, 'dnaJ homolog subfamily C member 5', NULL, NULL, NULL, NULL, NULL, 4),
(184363, NULL, 'G3DSA:2.30.29.30:FF:000688', NULL, NULL, 'Anillin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(184364, NULL, 'G3DSA:3.40.109.10:FF:000043', NULL, NULL, 'Nitroreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(184365, NULL, 'G3DSA:3.20.20.140:FF:000276', NULL, NULL, 'Adenosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(184366, NULL, 'G3DSA:1.20.1560.10:FF:000799', NULL, NULL, 'Putative ABC transporter C family member 15', NULL, NULL, NULL, NULL, NULL, 4),
(184367, NULL, 'G3DSA:3.30.420.10:FF:000443', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184368, NULL, 'G3DSA:1.10.510.10:FF:003969', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184369, NULL, 'G3DSA:3.20.20.60:FF:000046', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(184370, NULL, 'G3DSA:2.160.20.10:FF:000190', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(184371, NULL, 'G3DSA:3.30.497.10:FF:000018', NULL, NULL, 'Serpin family B member 8', NULL, NULL, NULL, NULL, NULL, 4),
(184372, NULL, 'G3DSA:2.60.120.200:FF:000673', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184373, NULL, 'G3DSA:2.40.50.140:FF:001271', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184374, NULL, 'G3DSA:2.60.40.640:FF:000121', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184375, NULL, 'G3DSA:3.30.160.60:FF:000134', NULL, NULL, 'Krueppel-like factor 11', NULL, NULL, NULL, NULL, NULL, 4),
(184376, NULL, 'G3DSA:3.30.530.20:FF:000038', NULL, NULL, 'Conserved protein TB16.3', NULL, NULL, NULL, NULL, NULL, 4),
(184377, NULL, 'G3DSA:3.80.10.10:FF:002978', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184378, NULL, 'G3DSA:1.10.418.60:FF:000026', NULL, NULL, 'Sterol regulatory element-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184379, NULL, 'G3DSA:1.20.1110.10:FF:000248', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184380, NULL, 'G3DSA:3.40.50.1820:FF:001371', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184381, NULL, 'G3DSA:2.60.40.10:FF:002247', NULL, NULL, 'AGAP005471-PA', NULL, NULL, NULL, NULL, NULL, 4),
(184382, NULL, 'G3DSA:3.90.1200.10:FF:000081', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(184383, NULL, 'G3DSA:1.20.920.10:FF:000154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184384, NULL, 'G3DSA:2.60.200.20:FF:000027', NULL, NULL, 'Peptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(184385, NULL, 'G3DSA:1.10.10.920:FF:000001', NULL, NULL, 'Coproporphyrinogen-III oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(184386, NULL, 'G3DSA:3.40.930.10:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(184387, NULL, 'G3DSA:3.30.40.10:FF:000678', NULL, NULL, 'Os01g0535300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(184388, NULL, 'G3DSA:3.40.50.1820:FF:000729', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(184389, NULL, 'G3DSA:1.10.274.100:FF:000010', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(184390, NULL, 'G3DSA:2.30.30.40:FF:000615', NULL, NULL, 'Probable serine/threonine-protein kinase mkcF', NULL, NULL, NULL, NULL, NULL, 4),
(184391, NULL, 'G3DSA:1.20.1060.20:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184392, NULL, 'G3DSA:3.40.50.150:FF:001798', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184393, NULL, 'G3DSA:3.20.20.220:FF:000002', NULL, NULL, 'Methylenetetrahydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(184394, NULL, 'G3DSA:3.40.630.30:FF:000176', NULL, NULL, 'Putative succinyl-CoA transferase Rv0802c', NULL, NULL, NULL, NULL, NULL, 4),
(184395, NULL, 'G3DSA:1.10.10.1200:FF:000001', NULL, NULL, 'Melanoma-associated antigen D1', NULL, NULL, NULL, NULL, NULL, 4),
(184396, NULL, 'G3DSA:1.20.140.150:FF:000031', NULL, NULL, 'Voltage-dependent calcium channel gamma-1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(184397, NULL, 'G3DSA:1.25.10.10:FF:000160', NULL, NULL, 'Cell differentiation protein', NULL, NULL, NULL, NULL, NULL, 4),
(184398, NULL, 'G3DSA:1.25.40.20:FF:000552', NULL, NULL, 'Ankyrin repeat-containing protein ITN1 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(184399, NULL, 'G3DSA:1.20.1070.10:FF:001913', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(184400, NULL, 'G3DSA:2.60.120.620:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184401, NULL, 'G3DSA:1.10.287.70:FF:000651', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184402, NULL, 'G3DSA:3.40.50.300:FF:002175', NULL, NULL, 'ABC transporter G family member 9', NULL, NULL, NULL, NULL, NULL, 4),
(184403, NULL, 'G3DSA:3.80.10.10:FF:003473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184404, NULL, 'G3DSA:3.40.30.10:FF:000334', NULL, NULL, 'Protein disulfide isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(184405, NULL, 'G3DSA:1.25.40.120:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184406, NULL, 'G3DSA:3.40.30.10:FF:000278', NULL, NULL, 'Peroxiredoxin (Alkyl hydroperoxide reductase subunit C)', NULL, NULL, NULL, NULL, NULL, 4),
(184407, NULL, 'G3DSA:1.25.40.10:FF:003893', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184408, NULL, 'G3DSA:2.60.260.20:FF:000003', NULL, NULL, 'DnaJ subfamily A member 2', NULL, NULL, NULL, NULL, NULL, 4),
(184409, NULL, 'G3DSA:2.30.29.30:FF:000598', NULL, NULL, 'Pleckstrin homology (PH) and lipid-binding START domains-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(184410, NULL, 'G3DSA:2.60.40.1180:FF:000117', NULL, NULL, 'Cytoskeleton-associated protein CAP5.5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184411, NULL, 'G3DSA:1.20.1740.10:FF:000077', NULL, NULL, 'Tpo5p', NULL, NULL, NULL, NULL, NULL, 4),
(184412, NULL, 'G3DSA:3.30.70.330:FF:001728', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184413, NULL, 'G3DSA:1.20.58.390:FF:000223', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184414, NULL, 'G3DSA:1.20.58.390:FF:000280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184415, NULL, 'G3DSA:3.30.60.30:FF:000163', NULL, NULL, 'Follistatin-related protein 5-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(184416, NULL, 'G3DSA:3.90.70.10:FF:000020', NULL, NULL, 'ubiquitin carboxyl-terminal hydrolase 19 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(184417, NULL, 'G3DSA:3.20.20.120:FF:000028', NULL, NULL, 'Muconate cycloisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(184418, NULL, 'G3DSA:3.30.420.40:FF:000081', NULL, NULL, 'Actin-related protein 10 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(184419, NULL, 'G3DSA:2.60.40.10:FF:002337', NULL, NULL, 'Beat protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(184420, NULL, 'G3DSA:2.60.40.10:FF:005737', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184421, NULL, 'G3DSA:3.40.30.10:FF:001205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184422, NULL, 'G3DSA:3.30.60.20:FF:000160', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(184423, NULL, 'G3DSA:2.60.40.150:FF:000446', NULL, NULL, 'RAC family serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(184424, NULL, 'G3DSA:2.60.40.1180:FF:000174', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(184425, NULL, 'G3DSA:2.40.70.10:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184426, NULL, 'G3DSA:2.30.30.100:FF:000189', NULL, NULL, 'SnRNP core Sm protein Sm-X5-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(184427, NULL, 'G3DSA:1.25.40.540:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184428, NULL, 'G3DSA:3.30.310.10:FF:000053', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(184429, NULL, 'G3DSA:1.20.1280.50:FF:000255', NULL, NULL, 'F-box protein At5g06550', NULL, NULL, NULL, NULL, NULL, 4),
(184430, NULL, 'G3DSA:3.30.60.30:FF:000016', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(184431, NULL, 'G3DSA:3.40.50.1000:FF:000551', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184432, NULL, 'G3DSA:2.130.10.10:FF:002427', NULL, NULL, 'dmX-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(184433, NULL, 'G3DSA:3.90.1410.10:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184434, NULL, 'G3DSA:1.10.1740.160:FF:000001', NULL, NULL, 'Phage portal', NULL, NULL, NULL, NULL, NULL, 4),
(184435, NULL, 'G3DSA:3.30.1490.20:FF:000079', NULL, NULL, 'Tubulin tyrosine ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184436, NULL, 'G3DSA:2.60.120.620:FF:000006', NULL, NULL, 'PKHD-type hydroxylase YbiX', NULL, NULL, NULL, NULL, NULL, 4),
(184437, NULL, 'G3DSA:2.60.40.10:FF:001994', NULL, NULL, 'tyrosine-protein phosphatase 10D isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(184438, NULL, 'G3DSA:3.30.590.20:FF:000014', NULL, NULL, 'Putative glutamate--cysteine ligase 2', NULL, NULL, NULL, NULL, NULL, 4),
(184439, NULL, 'G3DSA:3.30.1600.10:FF:000018', NULL, NULL, 'NAD-dependent deacetylase, Sir2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(184440, NULL, 'G3DSA:3.10.100.10:FF:000092', NULL, NULL, 'Polycystin 1 like 3, transient receptor potential channel interacting', NULL, NULL, NULL, NULL, NULL, 4),
(184441, NULL, 'G3DSA:3.30.70.330:FF:001167', NULL, NULL, 'SAFB-like, transcription modulator', NULL, NULL, NULL, NULL, NULL, 4),
(184442, NULL, 'G3DSA:2.60.120.920:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184443, NULL, 'G3DSA:2.40.50.140:FF:000253', NULL, NULL, 'mRNA-capping enzyme subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(184444, NULL, 'G3DSA:3.40.50.300:FF:003012', NULL, NULL, 'Cdc42 homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(184445, NULL, 'G3DSA:1.10.287.950:FF:000033', NULL, NULL, 'Methyl-accepting chemotaxis transmembrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(184446, NULL, 'G3DSA:3.30.60.20:FF:000013', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(184447, NULL, 'G3DSA:2.30.30.40:FF:000054', NULL, NULL, 'Putative e3 ubiquitin-protein ligase mind-bomb', NULL, NULL, NULL, NULL, NULL, 4),
(184448, NULL, 'G3DSA:3.30.2410.10:FF:000009', NULL, NULL, 'Probable E3 ubiquitin-protein ligase HECTD2', NULL, NULL, NULL, NULL, NULL, 4),
(184449, NULL, 'G3DSA:1.20.1520.10:FF:000004', NULL, NULL, 'The ARF-like 2 binding protein BART, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184450, NULL, 'G3DSA:2.60.120.920:FF:000181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184451, NULL, 'G3DSA:3.40.30.10:FF:000952', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184452, NULL, 'G3DSA:3.30.70.3490:FF:000002', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(184453, NULL, 'G3DSA:3.30.450.20:FF:000689', NULL, NULL, 'Hybrid signal transduction histidine kinase L', NULL, NULL, NULL, NULL, NULL, 4),
(184454, NULL, 'G3DSA:1.25.40.10:FF:004202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184455, NULL, 'G3DSA:1.20.1070.10:FF:001442', NULL, NULL, 'Olfactory receptor F6', NULL, NULL, NULL, NULL, NULL, 4),
(184456, NULL, 'G3DSA:1.10.10.10:FF:001845', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184457, NULL, 'G3DSA:1.20.120.790:FF:000005', NULL, NULL, 'Endoplasmin-like isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(184458, NULL, 'G3DSA:3.30.590.10:FF:000011', NULL, NULL, 'Glutamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(184459, NULL, 'G3DSA:2.30.30.30:FF:000051', NULL, NULL, '50S ribosomal protein L24', NULL, NULL, NULL, NULL, NULL, 4),
(184460, NULL, 'G3DSA:3.30.70.330:FF:001818', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184461, NULL, 'G3DSA:3.40.50.2000:FF:001059', NULL, NULL, 'Glycogen [starch] synthase', NULL, NULL, NULL, NULL, NULL, 4),
(184462, NULL, 'G3DSA:2.60.40.1180:FF:000084', NULL, NULL, 'Alpha-L-arabinofuranosidase', NULL, NULL, NULL, NULL, NULL, 4),
(184463, NULL, 'G3DSA:3.30.1300.10:FF:000001', NULL, NULL, 'Pantothenate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(184464, NULL, 'G3DSA:2.20.70.10:FF:000160', NULL, NULL, 'Pre-mRNA-splicing factor cwc2', NULL, NULL, NULL, NULL, NULL, 4),
(184465, NULL, 'G3DSA:1.10.10.10:FF:000395', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(184466, NULL, 'G3DSA:3.20.20.80:FF:000765', NULL, NULL, 'Beta-glucosidase 32', NULL, NULL, NULL, NULL, NULL, 4),
(184467, NULL, 'G3DSA:1.20.140.10:FF:000055', NULL, NULL, 'Acyl-CoA dehydrogenase FadE17', NULL, NULL, NULL, NULL, NULL, 4),
(184468, NULL, 'G3DSA:3.60.21.10:FF:000161', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(184469, NULL, 'G3DSA:3.90.1480.20:FF:000019', NULL, NULL, 'Glycosyl transferase family 29 protein', NULL, NULL, NULL, NULL, NULL, 4),
(184470, NULL, 'G3DSA:2.70.170.10:FF:000266', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184471, NULL, 'G3DSA:1.25.40.10:FF:003983', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184472, NULL, 'G3DSA:3.20.20.70:FF:000762', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184473, NULL, 'G3DSA:2.30.29.30:FF:001093', NULL, NULL, 'Phospholipase C gamma 1', NULL, NULL, NULL, NULL, NULL, 4),
(184474, NULL, 'G3DSA:2.160.10.10:FF:000032', NULL, NULL, 'Fucose-1-phosphate guanylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(184475, NULL, 'G3DSA:2.40.70.10:FF:000114', NULL, NULL, 'Endopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184476, NULL, 'G3DSA:3.30.60.30:FF:000073', NULL, NULL, 'Protein CBR-OST-1', NULL, NULL, NULL, NULL, NULL, 4),
(184477, NULL, 'G3DSA:2.30.30.210:FF:000019', NULL, NULL, 'Ribonuclease P protein subunit p29', NULL, NULL, NULL, NULL, NULL, 4),
(184478, NULL, 'G3DSA:1.25.40.10:FF:000307', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(184479, NULL, 'G3DSA:2.60.40.150:FF:000356', NULL, NULL, 'SYT15 isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(184480, NULL, 'G3DSA:3.90.260.10:FF:000012', NULL, NULL, 'XPC complex subunit, DNA damage recognition and repair factor', NULL, NULL, NULL, NULL, NULL, 4),
(184481, NULL, 'G3DSA:3.90.180.10:FF:000011', NULL, NULL, 'Crotonyl-CoA carboxylase/reductase', NULL, NULL, NULL, NULL, NULL, 4),
(184482, NULL, 'G3DSA:3.30.460.20:FF:000010', NULL, NULL, 'CorA family metal ion transporter', NULL, NULL, NULL, NULL, NULL, 4),
(184483, NULL, 'G3DSA:2.40.20.10:FF:000111', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(184484, NULL, 'G3DSA:3.40.50.300:FF:006446', NULL, NULL, 'Interferon gamma-inducible protein 47', NULL, NULL, NULL, NULL, NULL, 4),
(184485, NULL, 'G3DSA:3.40.50.720:FF:002559', NULL, NULL, 'Siroheme biosynthesis protein met8', NULL, NULL, NULL, NULL, NULL, 4),
(184486, NULL, 'G3DSA:3.30.420.40:FF:000457', NULL, NULL, 'actin-related protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(184487, NULL, 'G3DSA:1.20.1070.10:FF:000458', NULL, NULL, 'G protein-coupled receptor 150', NULL, NULL, NULL, NULL, NULL, 4),
(184488, NULL, 'G3DSA:2.40.50.140:FF:001276', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184489, NULL, 'G3DSA:1.20.1310.10:FF:000202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184490, NULL, 'G3DSA:3.10.100.10:FF:000209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184491, NULL, 'G3DSA:3.30.160.110:FF:000002', NULL, NULL, 'spermine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(184492, NULL, 'G3DSA:1.20.58.1100:FF:000002', NULL, NULL, 'Unc-13, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(184493, NULL, 'G3DSA:3.30.160.60:FF:000600', NULL, NULL, 'PLAG1 like zinc finger 2', NULL, NULL, NULL, NULL, NULL, 4),
(184494, NULL, 'G3DSA:2.110.10.10:FF:000034', NULL, NULL, 'Stromelysin-1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(184495, NULL, 'G3DSA:3.10.450.230:FF:000002', NULL, NULL, 'Protein virB8', NULL, NULL, NULL, NULL, NULL, 4),
(184496, NULL, 'G3DSA:1.20.810.10:FF:000027', NULL, NULL, 'Cytochrome b6', NULL, NULL, NULL, NULL, NULL, 4),
(184497, NULL, 'G3DSA:1.10.238.10:FF:000520', NULL, NULL, 'N-terminal EF-hand calcium-binding protein 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(184498, NULL, 'G3DSA:2.60.40.10:FF:004315', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184499, NULL, 'G3DSA:3.30.160.20:FF:000049', NULL, NULL, 'Uncharacterized protein, isoform I', NULL, NULL, NULL, NULL, NULL, 4),
(184500, NULL, 'G3DSA:1.10.3080.10:FF:000057', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(184501, NULL, 'G3DSA:1.25.40.20:FF:000872', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184502, NULL, 'G3DSA:1.10.510.10:FF:000541', NULL, NULL, 'CMGC/SRPK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(184503, NULL, 'G3DSA:2.130.10.10:FF:005867', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184504, NULL, 'G3DSA:1.20.1310.10:FF:000140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184505, NULL, 'G3DSA:3.30.230.130:FF:000031', NULL, NULL, 'Cullin', NULL, NULL, NULL, NULL, NULL, 4),
(184506, NULL, 'G3DSA:1.25.10.10:FF:000362', NULL, NULL, 'Importin 11, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184507, NULL, 'G3DSA:3.40.50.300:FF:002607', NULL, NULL, 'Nicotinamide riboside kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(184508, NULL, 'G3DSA:1.10.10.10:FF:001766', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184509, NULL, 'G3DSA:1.10.150.80:FF:000033', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(184510, NULL, 'G3DSA:3.40.630.30:FF:000266', NULL, NULL, 'Protein N-acetyltransferase, RimJ/RimL family', NULL, NULL, NULL, NULL, NULL, 4),
(184511, NULL, 'G3DSA:3.30.950.30:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184512, NULL, 'G3DSA:3.10.20.90:FF:000235', NULL, NULL, 'Autophagy-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(184513, NULL, 'G3DSA:3.10.450.240:FF:000005', NULL, NULL, 'Mitochondrial import inner membrane translocase subunit TIM44-2', NULL, NULL, NULL, NULL, NULL, 4),
(184514, NULL, 'G3DSA:1.50.40.10:FF:000193', NULL, NULL, 'Related to peroxisomal membrane protein PMP47B', NULL, NULL, NULL, NULL, NULL, 4),
(184515, NULL, 'G3DSA:1.25.10.10:FF:001885', NULL, NULL, 'MMS19 homolog, cytosolic iron-sulfur assembly component', NULL, NULL, NULL, NULL, NULL, 4),
(184516, NULL, 'G3DSA:1.20.120.1080:FF:000083', NULL, NULL, 'GM13326', NULL, NULL, NULL, NULL, NULL, 4),
(184517, NULL, 'G3DSA:2.130.10.10:FF:004344', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184518, NULL, 'G3DSA:2.40.20.10:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184519, NULL, 'G3DSA:2.130.10.10:FF:003681', NULL, NULL, 'WD repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184520, NULL, 'G3DSA:2.170.270.10:FF:000227', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(184521, NULL, 'G3DSA:1.20.1070.10:FF:000896', NULL, NULL, 'Protein CBR-SER-2', NULL, NULL, NULL, NULL, NULL, 4),
(184522, NULL, 'G3DSA:3.40.630.10:FF:000260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184523, NULL, 'G3DSA:3.30.450.190:FF:000002', NULL, NULL, 'Ras-related GTP-binding protein A', NULL, NULL, NULL, NULL, NULL, 4),
(184524, NULL, 'G3DSA:1.10.10.10:FF:000243', NULL, NULL, 'Ethanolamine utilization microcompartment protein EutK', NULL, NULL, NULL, NULL, NULL, 4),
(184525, NULL, 'G3DSA:1.20.1560.10:FF:000866', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184526, NULL, 'G3DSA:1.20.5.690:FF:000010', NULL, NULL, 'Importin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(184527, NULL, 'G3DSA:3.60.40.10:FF:000087', NULL, NULL, 'Type 2C protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(184528, NULL, 'G3DSA:3.40.50.300:FF:001944', NULL, NULL, 'DEAD box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(184529, NULL, 'G3DSA:2.60.120.10:FF:000277', NULL, NULL, 'Lysophospholipase NTE1', NULL, NULL, NULL, NULL, NULL, 4),
(184530, NULL, 'G3DSA:1.20.58.60:FF:000839', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184531, NULL, 'G3DSA:3.60.21.10:FF:000402', NULL, NULL, 'Sphingomyelinase phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(184532, NULL, 'G3DSA:3.30.160.60:FF:004815', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184533, NULL, 'G3DSA:2.60.40.2240:FF:000003', NULL, NULL, 'Protein CBG04103', NULL, NULL, NULL, NULL, NULL, 4),
(184534, NULL, 'G3DSA:3.40.50.1820:FF:000943', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184535, NULL, 'G3DSA:1.20.140.150:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184536, NULL, 'G3DSA:3.30.40.10:FF:002387', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184537, NULL, 'G3DSA:1.25.40.20:FF:000821', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(184538, NULL, 'G3DSA:3.90.740.10:FF:000004', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(184539, NULL, 'G3DSA:1.10.560.10:FF:000038', NULL, NULL, 'Chaperonin containing TCP1 subunit 6B', NULL, NULL, NULL, NULL, NULL, 4),
(184540, NULL, 'G3DSA:1.10.510.10:FF:002665', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184541, NULL, 'G3DSA:2.60.40.1120:FF:000061', NULL, NULL, 'Nodal modulator 3', NULL, NULL, NULL, NULL, NULL, 4),
(184542, NULL, 'G3DSA:3.90.70.10:FF:000290', NULL, NULL, 'Cathepsin W', NULL, NULL, NULL, NULL, NULL, 4),
(184543, NULL, 'G3DSA:3.90.1570.30:FF:000001', NULL, NULL, 'Type I restriction enzyme EcoKI subunit R', NULL, NULL, NULL, NULL, NULL, 4),
(184544, NULL, 'G3DSA:1.10.472.170:FF:000002', NULL, NULL, 'Transcription initiation factor IIB', NULL, NULL, NULL, NULL, NULL, 4),
(184545, NULL, 'G3DSA:2.40.50.140:FF:001181', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184546, NULL, 'G3DSA:1.10.472.10:FF:000108', NULL, NULL, 'Cyclin-dependent protein kinase regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184547, NULL, 'G3DSA:3.30.110.10:FF:000009', NULL, NULL, 'Translation initiation factor IF-3', NULL, NULL, NULL, NULL, NULL, 4),
(184548, NULL, 'G3DSA:3.40.50.720:FF:001660', NULL, NULL, 'Glyoxylate/hydroxypyruvate reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184549, NULL, 'G3DSA:2.60.40.10:FF:004366', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184550, NULL, 'G3DSA:1.10.540.10:FF:000076', NULL, NULL, 'Related to Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(184551, NULL, 'G3DSA:2.40.30.10:FF:000084', NULL, NULL, 'GTP-binding elongation factor Tu family', NULL, NULL, NULL, NULL, NULL, 4),
(184552, NULL, 'G3DSA:3.40.190.80:FF:000089', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(184553, NULL, 'G3DSA:2.130.10.10:FF:003355', NULL, NULL, 'Vacuolar assembly protein vps41, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184554, NULL, 'G3DSA:3.40.50.140:FF:000007', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(184555, NULL, 'G3DSA:3.30.565.10:FF:000065', NULL, NULL, '[Pyruvate dehydrogenase (Acetyl-transferring)] kinase mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(184556, NULL, 'G3DSA:2.40.100.10:FF:000033', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(184557, NULL, 'G3DSA:3.30.70.20:FF:000008', NULL, NULL, 'Respiratory nitrate reductase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(184558, NULL, 'G3DSA:1.20.1070.10:FF:000958', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184559, NULL, 'G3DSA:1.10.10.980:FF:000007', NULL, NULL, 'CST complex subunit STN1', NULL, NULL, NULL, NULL, NULL, 4),
(184560, NULL, 'G3DSA:1.10.10.10:FF:000305', NULL, NULL, 'Transcriptional regulator, PadR family', NULL, NULL, NULL, NULL, NULL, 4),
(184561, NULL, 'G3DSA:3.40.50.720:FF:000878', NULL, NULL, 'Oxidoreductase, short-chain dehydrogenase/reductase family', NULL, NULL, NULL, NULL, NULL, 4),
(184562, NULL, 'G3DSA:1.10.287.110:FF:000045', NULL, NULL, 'Molecular chaperone DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(184563, NULL, 'G3DSA:1.10.1370.30:FF:000023', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(184564, NULL, 'G3DSA:1.10.510.10:FF:003767', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184565, NULL, 'G3DSA:3.90.190.10:FF:000158', NULL, NULL, 'Tyrosine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(184566, NULL, 'G3DSA:1.10.472.10:FF:000434', NULL, NULL, 'Cyclin-D5-1', NULL, NULL, NULL, NULL, NULL, 4),
(184567, NULL, 'G3DSA:3.40.50.1820:FF:001606', NULL, NULL, 'Gsl3760 protein', NULL, NULL, NULL, NULL, NULL, 4),
(184568, NULL, 'G3DSA:3.10.110.10:FF:000300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184569, NULL, 'G3DSA:3.80.10.10:FF:001764', NULL, NULL, 'Toll-like receptor 19', NULL, NULL, NULL, NULL, NULL, 4),
(184570, NULL, 'G3DSA:1.25.10.10:FF:002109', NULL, NULL, 'HEAT repeat-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(184571, NULL, 'G3DSA:1.10.1600.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184572, NULL, 'G3DSA:3.40.50.10190:FF:000249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184573, NULL, 'G3DSA:3.30.160.60:FF:006002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184574, NULL, 'G3DSA:1.25.10.10:FF:002340', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184575, NULL, 'G3DSA:1.10.10.440:FF:000020', NULL, NULL, 'Pre-mRNA-processing protein 40C', NULL, NULL, NULL, NULL, NULL, 4),
(184576, NULL, 'G3DSA:3.40.50.300:FF:008009', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(184577, NULL, 'G3DSA:1.10.1650.20:FF:000002', NULL, NULL, 'Ribonucleoside-diphosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(184578, NULL, 'G3DSA:3.30.70.1230:FF:000246', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184579, NULL, 'G3DSA:1.10.30.10:FF:000194', NULL, NULL, 'Putative high mobility group B protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(184580, NULL, 'G3DSA:4.10.70.10:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184581, NULL, 'G3DSA:1.10.10.10:FF:002008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184582, NULL, 'G3DSA:3.30.160.60:FF:005485', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184583, NULL, 'G3DSA:1.10.510.10:FF:002570', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184584, NULL, 'G3DSA:1.10.1000.11:FF:000002', NULL, NULL, 'Cytohesin 1', NULL, NULL, NULL, NULL, NULL, 4),
(184585, NULL, 'G3DSA:1.20.1640.10:FF:000007', NULL, NULL, 'Protein patched homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(184586, NULL, 'G3DSA:2.60.120.380:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184587, NULL, 'G3DSA:2.30.30.40:FF:000233', NULL, NULL, 'NADPH oxidase organizer 1', NULL, NULL, NULL, NULL, NULL, 4),
(184588, NULL, 'G3DSA:1.10.3460.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(184589, NULL, 'G3DSA:3.40.1370.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184590, NULL, 'G3DSA:3.30.390.110:FF:000014', NULL, NULL, 'LRRGT00107', NULL, NULL, NULL, NULL, NULL, 4),
(184591, NULL, 'G3DSA:2.170.8.10:FF:000003', NULL, NULL, 'Phosphoenolpyruvate carboxykinase [GTP]', NULL, NULL, NULL, NULL, NULL, 4),
(184592, NULL, 'G3DSA:2.40.10.10:FF:000554', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184593, NULL, 'G3DSA:2.10.220.10:FF:000127', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(184594, NULL, 'G3DSA:1.20.120.730:FF:000015', NULL, NULL, 'Protein transport protein Sec24C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184595, NULL, 'G3DSA:3.30.40.10:FF:001931', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184596, NULL, 'G3DSA:3.90.550.50:FF:000046', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(184597, NULL, 'G3DSA:3.40.1090.10:FF:000054', NULL, NULL, 'Triacylglycerol lipase SDP1L', NULL, NULL, NULL, NULL, NULL, 4),
(184598, NULL, 'G3DSA:3.40.50.150:FF:000550', NULL, NULL, 'Conserved hypothetical alanine,valine and glycine rich protein', NULL, NULL, NULL, NULL, NULL, 4),
(184599, NULL, 'G3DSA:2.30.110.10:FF:000081', NULL, NULL, 'Cellular repressor of E1A stimulated genes 1', NULL, NULL, NULL, NULL, NULL, 4),
(184600, NULL, 'G3DSA:3.40.50.300:FF:008240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184601, NULL, 'G3DSA:3.80.10.10:FF:001343', NULL, NULL, 'Dynein assembly factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(184602, NULL, 'G3DSA:3.40.50.2300:FF:001262', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184603, NULL, 'G3DSA:3.80.10.10:FF:003063', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184604, NULL, 'G3DSA:2.130.10.10:FF:001438', NULL, NULL, 'Receptor of-activated protein C kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(184605, NULL, 'G3DSA:3.80.10.10:FF:000887', NULL, NULL, 'NLR family pyrin domain containing 11', NULL, NULL, NULL, NULL, NULL, 4),
(184606, NULL, 'G3DSA:3.30.200.20:FF:001391', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184607, NULL, 'G3DSA:3.40.50.1000:FF:000282', NULL, NULL, 'TFIIF-stimulated CTD phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184608, NULL, 'G3DSA:1.10.238.10:FF:000227', NULL, NULL, 'Rab11 family-interacting protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(184609, NULL, 'G3DSA:3.40.630.30:FF:000592', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184610, NULL, 'G3DSA:2.40.50.100:FF:000123', NULL, NULL, 'Exosome complex component CSL4', NULL, NULL, NULL, NULL, NULL, 4),
(184611, NULL, 'G3DSA:1.20.144.10:FF:000120', NULL, NULL, 'PAP2 superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(184612, NULL, 'G3DSA:1.10.510.10:FF:000327', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 8', NULL, NULL, NULL, NULL, NULL, 4),
(184613, NULL, 'G3DSA:1.10.730.20:FF:000021', NULL, NULL, 'Isoleucine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(184614, NULL, 'G3DSA:3.30.70.330:FF:001813', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184615, NULL, 'G3DSA:1.20.1050.10:FF:000041', NULL, NULL, 'Lambda class glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(184616, NULL, 'G3DSA:3.40.630.30:FF:000524', NULL, NULL, 'Acyl-CoA N-acyltransferase with RING/FYVE/PHD-type zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(184617, NULL, 'G3DSA:3.40.970.10:FF:000004', NULL, NULL, 'Ribonuclease H', NULL, NULL, NULL, NULL, NULL, 4),
(184618, NULL, 'G3DSA:3.40.50.1240:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184619, NULL, 'G3DSA:1.25.40.20:FF:000142', NULL, NULL, 'Ankyrin repeat and FYVE domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(184620, NULL, 'G3DSA:3.40.50.150:FF:000336', NULL, NULL, 'Protein-lysine N-methyltransferase PGSY75_0916600', NULL, NULL, NULL, NULL, NULL, 4),
(184621, NULL, 'G3DSA:3.40.50.150:FF:000224', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(184622, NULL, 'G3DSA:1.20.1070.10:FF:001801', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184623, NULL, 'G3DSA:1.10.3210.10:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184624, NULL, 'G3DSA:3.40.50.360:FF:000074', NULL, NULL, 'Sulfite reductase [NADPH] flavoprotein alpha-component', NULL, NULL, NULL, NULL, NULL, 4),
(184625, NULL, 'G3DSA:3.40.190.10:FF:000967', NULL, NULL, 'Oligopeptide ABC transporter, periplasmic oligopeptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(184626, NULL, 'G3DSA:3.60.10.10:FF:000259', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184627, NULL, 'G3DSA:3.40.190.80:FF:000038', NULL, NULL, 'Inositol monophosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(184628, NULL, 'G3DSA:3.90.1420.10:FF:000007', NULL, NULL, 'SET domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(184629, NULL, 'G3DSA:3.10.250.10:FF:000035', NULL, NULL, 'Lysyl oxidase-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(184630, NULL, 'G3DSA:3.40.190.290:FF:000110', NULL, NULL, 'Transcriptional regulator lysR family', NULL, NULL, NULL, NULL, NULL, 4),
(184631, NULL, 'G3DSA:3.30.70.330:FF:001734', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184632, NULL, 'G3DSA:2.60.120.10:FF:000226', NULL, NULL, 'DNA-binding transcriptional activator YeiL', NULL, NULL, NULL, NULL, NULL, 4),
(184633, NULL, 'G3DSA:3.40.50.300:FF:003861', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(184634, NULL, 'G3DSA:3.40.50.10420:FF:000009', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(184635, NULL, 'G3DSA:1.10.3720.10:FF:000202', NULL, NULL, 'ABC transporter permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(184636, NULL, 'G3DSA:3.30.830.10:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184637, NULL, 'G3DSA:3.30.365.10:FF:000016', NULL, NULL, 'Xanthine dehydrogenase yagR molybdenum-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(184638, NULL, 'G3DSA:3.40.50.1100:FF:000047', NULL, NULL, 'Threonine synthase like 2', NULL, NULL, NULL, NULL, NULL, 4),
(184639, NULL, 'G3DSA:2.40.33.10:FF:000023', NULL, NULL, 'Pyruvate kinase PKM', NULL, NULL, NULL, NULL, NULL, 4),
(184640, NULL, 'G3DSA:3.30.450.40:FF:000015', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(184641, NULL, 'G3DSA:1.10.132.20:FF:000007', NULL, NULL, 'Ribosome recycling factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184642, NULL, 'G3DSA:2.40.70.10:FF:000316', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184643, NULL, 'G3DSA:2.130.10.10:FF:005479', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184644, NULL, 'G3DSA:3.30.160.60:FF:004136', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184645, NULL, 'G3DSA:3.30.200.20:FF:002380', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(184646, NULL, 'G3DSA:1.10.510.10:FF:001676', NULL, NULL, 'Serine/threonine-protein kinase NEK', NULL, NULL, NULL, NULL, NULL, 4),
(184647, NULL, 'G3DSA:1.10.533.10:FF:000138', NULL, NULL, 'Interleukin-1 receptor-associated kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(184648, NULL, 'G3DSA:3.50.50.60:FF:001468', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(184649, NULL, 'G3DSA:3.30.450.30:FF:000012', NULL, NULL, 'Dynein light chain 2B, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(184650, NULL, 'G3DSA:1.10.132.10:FF:000004', NULL, NULL, 'Topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(184651, NULL, 'G3DSA:3.40.50.1440:FF:000065', NULL, NULL, 'Tubulin-like protein CetZ', NULL, NULL, NULL, NULL, NULL, 4),
(184652, NULL, 'G3DSA:1.10.10.10:FF:000631', NULL, NULL, 'Interferon regulatory factor 7', NULL, NULL, NULL, NULL, NULL, 4),
(184653, NULL, 'G3DSA:3.30.420.40:FF:000513', NULL, NULL, 'Glycerol kinase-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(184654, NULL, 'G3DSA:1.25.40.10:FF:004028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(184655, NULL, 'G3DSA:3.30.70.1620:FF:000009', NULL, NULL, 'Structural maintenance of chromosomes protein', NULL, NULL, NULL, NULL, NULL, 4),
(184656, NULL, 'G3DSA:2.40.30.10:FF:000196', NULL, NULL, 'Elongation factor 1-alpha, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184657, NULL, 'G3DSA:3.40.50.1010:FF:000234', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184658, NULL, 'G3DSA:3.40.50.1100:FF:000109', NULL, NULL, 'Cysteine synthase B (CysM)', NULL, NULL, NULL, NULL, NULL, 4),
(184659, NULL, 'G3DSA:3.30.200.20:FF:001486', NULL, NULL, 'Probable serine/threonine-protein kinase pkgA', NULL, NULL, NULL, NULL, NULL, 4),
(184660, NULL, 'G3DSA:1.25.40.20:FF:000193', NULL, NULL, 'Ankyrin repeat and SOCS box containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(184661, NULL, 'G3DSA:1.25.50.20:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184662, NULL, 'G3DSA:2.130.10.10:FF:002253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184663, NULL, 'G3DSA:3.30.420.40:FF:000255', NULL, NULL, 'Glycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(184664, NULL, 'G3DSA:1.10.630.10:FF:000488', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184665, NULL, 'G3DSA:2.40.37.10:FF:000003', NULL, NULL, 'Diaminopimelate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(184666, NULL, 'G3DSA:1.10.510.10:FF:001788', NULL, NULL, 'STE/STE20/FRAY protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(184667, NULL, 'G3DSA:3.30.1360.120:FF:000004', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(184668, NULL, 'G3DSA:3.40.50.150:FF:000275', NULL, NULL, 'DNA (cytosine-5)-methyltransferase 3-like', NULL, NULL, NULL, NULL, NULL, 4),
(184669, NULL, 'G3DSA:3.40.640.10:FF:000232', NULL, NULL, 'Adenosylmethionine-8-amino-7-oxononanoate transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(184670, NULL, 'G3DSA:3.40.50.2300:FF:001357', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184671, NULL, 'G3DSA:1.20.1250.20:FF:001902', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184672, NULL, 'G3DSA:2.40.37.20:FF:000006', NULL, NULL, 'D-threo-3-hydroxyaspartate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(184673, NULL, 'G3DSA:3.40.50.720:FF:000766', NULL, NULL, 'Putative short chain oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(184674, NULL, 'G3DSA:3.40.50.1820:FF:001718', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184675, NULL, 'G3DSA:1.20.58.1480:FF:000003', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(184676, NULL, 'G3DSA:1.10.472.10:FF:000322', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184677, NULL, 'G3DSA:2.40.100.10:FF:000145', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(184678, NULL, 'G3DSA:3.30.70.260:FF:000084', NULL, NULL, 'ACT domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(184679, NULL, 'G3DSA:3.30.160.60:FF:002045', NULL, NULL, 'Zinc finger protein 1079', NULL, NULL, NULL, NULL, NULL, 4),
(184680, NULL, 'G3DSA:3.30.830.10:FF:000114', NULL, NULL, 'Insulinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184681, NULL, 'G3DSA:3.60.21.10:FF:000453', NULL, NULL, '5''-nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(184682, NULL, 'G3DSA:1.25.40.10:FF:000190', NULL, NULL, 'Transmembrane and TPR repeat-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(184683, NULL, 'G3DSA:3.30.70.370:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184684, NULL, 'G3DSA:1.10.1900.10:FF:000007', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(184685, NULL, 'G3DSA:3.30.450.50:FF:000018', NULL, NULL, 'Vesicle-trafficking protein SEC22b', NULL, NULL, NULL, NULL, NULL, 4),
(184686, NULL, 'G3DSA:3.40.630.40:FF:000010', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(184687, NULL, 'G3DSA:3.40.50.1000:FF:000231', NULL, NULL, 'Polynucleotide kinase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(184688, NULL, 'G3DSA:1.20.58.340:FF:000085', NULL, NULL, 'Os04g0501100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(184689, NULL, 'G3DSA:3.30.1360.110:FF:000001', NULL, NULL, 'Phosphonoacetate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(184690, NULL, 'G3DSA:2.60.40.10:FF:001674', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(184691, NULL, 'G3DSA:3.30.50.10:FF:000010', NULL, NULL, 'Peroxisome proliferator-activated receptor gamma', NULL, NULL, NULL, NULL, NULL, 4),
(184692, NULL, 'G3DSA:3.40.50.300:FF:000258', NULL, NULL, 'Ribulose bisphosphate carboxylase/oxygenase activase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(184693, NULL, 'G3DSA:3.30.565.10:FF:000391', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', NULL, NULL, NULL, NULL, NULL, 4),
(184694, NULL, 'G3DSA:1.20.5.110:FF:000325', NULL, NULL, 'Syntaxin', NULL, NULL, NULL, NULL, NULL, 4),
(184695, NULL, 'G3DSA:3.90.550.10:FF:000293', NULL, NULL, 'Glycosyltransferase-like protein, family 2', NULL, NULL, NULL, NULL, NULL, 4),
(184696, NULL, 'G3DSA:3.40.50.1820:FF:001511', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(184697, NULL, 'G3DSA:1.10.10.440:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184698, NULL, 'G3DSA:4.10.400.10:FF:000206', NULL, NULL, 'Sortilin-related receptor', NULL, NULL, NULL, NULL, NULL, 4),
(184699, NULL, 'G3DSA:3.40.50.1000:FF:000017', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(184700, NULL, 'G3DSA:3.30.160.60:FF:005597', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184701, NULL, 'G3DSA:3.30.70.330:FF:003084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184702, NULL, 'G3DSA:2.60.40.10:FF:000325', NULL, NULL, 'kalirin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(184703, NULL, 'G3DSA:1.25.40.10:FF:003691', NULL, NULL, 'Tetratricopeptide repeat protein 21 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(184704, NULL, 'G3DSA:1.10.10.10:FF:000417', NULL, NULL, 'Transcriptional regulator, MarR family', NULL, NULL, NULL, NULL, NULL, 4),
(184705, NULL, 'G3DSA:2.130.10.10:FF:005693', NULL, NULL, 'GPI inositol-deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(184706, NULL, 'G3DSA:1.20.5.190:FF:000017', NULL, NULL, 'unconventional myosin-Ic isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(184707, NULL, 'G3DSA:2.70.40.10:FF:000010', NULL, NULL, 'DeoxyUTP pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(184708, NULL, 'G3DSA:3.40.532.10:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184709, NULL, 'G3DSA:2.40.440.10:FF:000024', NULL, NULL, 'Peptidoglycan L,D-transpeptidase, YkuD family, LysM domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(184710, NULL, 'G3DSA:1.20.58.1780:FF:000003', NULL, NULL, 'Non-repetitive nucleoporin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184711, NULL, 'G3DSA:1.25.40.800:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184712, NULL, 'G3DSA:3.30.200.20:FF:000997', NULL, NULL, 'NEK (NEver in mitosis Kinase) Like', NULL, NULL, NULL, NULL, NULL, 4),
(184713, NULL, 'G3DSA:3.90.1290.10:FF:000007', NULL, NULL, 'microtubule-actin cross-linking factor 1 isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(184714, NULL, 'G3DSA:3.40.605.10:FF:000128', NULL, NULL, 'Aldehyde dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184715, NULL, 'G3DSA:3.40.1280.30:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184716, NULL, 'G3DSA:2.40.240.10:FF:000043', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(184717, NULL, 'G3DSA:3.30.360.10:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184718, NULL, 'G3DSA:1.10.10.520:FF:000004', NULL, NULL, 'SUMO-activating enzyme subunit', NULL, NULL, NULL, NULL, NULL, 4),
(184719, NULL, 'G3DSA:2.60.40.1510:FF:000020', NULL, NULL, 'Integrin subunit alpha E', NULL, NULL, NULL, NULL, NULL, 4),
(184720, NULL, 'G3DSA:3.80.10.10:FF:001438', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(184721, NULL, 'G3DSA:2.20.25.530:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184722, NULL, 'G3DSA:3.30.70.2030:FF:000003', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(184723, NULL, 'G3DSA:2.40.160.210:FF:000014', NULL, NULL, 'Acyl-CoA thioesterase II', NULL, NULL, NULL, NULL, NULL, 4),
(184724, NULL, 'G3DSA:3.80.10.10:FF:000949', NULL, NULL, 'Protein phosphatase type 1 regulator-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(184725, NULL, 'G3DSA:2.40.160.10:FF:000042', NULL, NULL, 'Mitochondrial outer membrane protein porin 1', NULL, NULL, NULL, NULL, NULL, 4),
(184726, NULL, 'G3DSA:1.20.1310.20:FF:000031', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(184727, NULL, 'G3DSA:2.40.30.10:FF:000145', NULL, NULL, 'NADPH-dependent diflavin oxidoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(184728, NULL, 'G3DSA:2.60.40.1530:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184729, NULL, 'G3DSA:3.30.450.20:FF:000268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184730, NULL, 'G3DSA:2.60.120.620:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184731, NULL, 'G3DSA:3.40.1800.20:FF:000017', NULL, NULL, 'GG18045', NULL, NULL, NULL, NULL, NULL, 4),
(184732, NULL, 'G3DSA:2.40.30.10:FF:000437', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184733, NULL, 'G3DSA:1.10.510.10:FF:000653', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(184734, NULL, 'G3DSA:3.30.200.20:FF:001065', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184735, NULL, 'G3DSA:2.30.30.40:FF:000407', NULL, NULL, 'Related to YSC84-protein involved in the organization of actin cytoskeleton', NULL, NULL, NULL, NULL, NULL, 4),
(184736, NULL, 'G3DSA:3.40.50.300:FF:001101', NULL, NULL, '6-phosphofructo-2-kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(184737, NULL, 'G3DSA:2.130.10.10:FF:004232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184738, NULL, 'G3DSA:3.80.10.10:FF:003681', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184739, NULL, 'G3DSA:2.130.10.10:FF:005979', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184740, NULL, 'G3DSA:3.30.457.60:FF:000008', NULL, NULL, 'Spindle assembly checkpoint component MAD1', NULL, NULL, NULL, NULL, NULL, 4),
(184741, NULL, 'G3DSA:3.30.505.10:FF:000117', NULL, NULL, 'Non-specific protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(184742, NULL, 'G3DSA:3.40.50.720:FF:001721', NULL, NULL, '6-phosphogluconate dehydrogenase, decarboxylating', NULL, NULL, NULL, NULL, NULL, 4),
(184743, NULL, 'G3DSA:1.10.540.10:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184744, NULL, 'G3DSA:3.30.200.20:FF:002503', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 4-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(184745, NULL, 'G3DSA:1.10.10.60:FF:000617', NULL, NULL, 'ISPsy13, transposase OrfA', NULL, NULL, NULL, NULL, NULL, 4),
(184746, NULL, 'G3DSA:2.10.25.10:FF:000663', NULL, NULL, 'Dumpy, isoform Z', NULL, NULL, NULL, NULL, NULL, 4),
(184747, NULL, 'G3DSA:1.20.1250.20:FF:000885', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184748, NULL, 'G3DSA:2.130.10.10:FF:003855', NULL, NULL, 'Ribosome biogenesis protein WDR12 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(184749, NULL, 'G3DSA:1.10.510.10:FF:004290', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184750, NULL, 'G3DSA:3.40.50.300:FF:005659', NULL, NULL, 'Leucine-rich repeat and guanylate kinase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(184751, NULL, 'G3DSA:1.10.238.10:FF:000727', NULL, NULL, 'GM15808', NULL, NULL, NULL, NULL, NULL, 4),
(184752, NULL, 'G3DSA:1.10.238.10:FF:000441', NULL, NULL, 'Myosin light chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(184753, NULL, 'G3DSA:2.130.10.10:FF:000078', NULL, NULL, 'DDB1- and CUL4-associated factor 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(184754, NULL, 'G3DSA:3.30.160.60:FF:005838', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184755, NULL, 'G3DSA:3.20.70.20:FF:000037', NULL, NULL, 'Vitamin B12-dependent ribonucleotide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(184756, NULL, 'G3DSA:1.20.5.390:FF:000010', NULL, NULL, 'Optineurin', NULL, NULL, NULL, NULL, NULL, 4),
(184757, NULL, 'G3DSA:1.10.30.10:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184758, NULL, 'G3DSA:3.30.70.330:FF:001408', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184759, NULL, 'G3DSA:3.30.160.60:FF:004703', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184760, NULL, 'G3DSA:2.40.50.100:FF:000062', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(184761, NULL, 'G3DSA:1.20.1250.20:FF:001161', NULL, NULL, 'MFS quinate transporter, putative (AFU_orthologue AFUA_4G14670)', NULL, NULL, NULL, NULL, NULL, 4),
(184762, NULL, 'G3DSA:1.10.287.70:FF:000797', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184763, NULL, 'G3DSA:3.60.40.10:FF:000199', NULL, NULL, 'YALI0B18759p', NULL, NULL, NULL, NULL, NULL, 4),
(184764, NULL, 'G3DSA:3.40.140.10:FF:000059', NULL, NULL, 'Putative cytidine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(184765, NULL, 'G3DSA:1.10.540.10:FF:000104', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(184766, NULL, 'G3DSA:1.20.1070.10:FF:001773', NULL, NULL, 'Olfactory receptor 58', NULL, NULL, NULL, NULL, NULL, 4),
(184767, NULL, 'G3DSA:1.10.287.40:FF:000024', NULL, NULL, 'Serine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(184768, NULL, 'G3DSA:2.60.40.10:FF:000651', NULL, NULL, 'Fc receptor like 1', NULL, NULL, NULL, NULL, NULL, 4),
(184769, NULL, 'G3DSA:1.20.140.150:FF:000003', NULL, NULL, 'Voltage-dependent calcium channel gamma-7 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(184770, NULL, 'G3DSA:1.10.510.10:FF:000602', NULL, NULL, 'serine/threonine-protein kinase Nek9', NULL, NULL, NULL, NULL, NULL, 4),
(184771, NULL, 'G3DSA:3.40.190.10:FF:000450', NULL, NULL, 'Glutamate receptor ionotropic, kainate 3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(184772, NULL, 'G3DSA:2.30.29.30:FF:001407', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184773, NULL, 'G3DSA:3.20.20.10:FF:000082', NULL, NULL, 'Ornithine decarboxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(184774, NULL, 'G3DSA:1.10.472.130:FF:000052', NULL, NULL, 'Dynein heavy chain isotype 3A', NULL, NULL, NULL, NULL, NULL, 4),
(184775, NULL, 'G3DSA:3.30.2410.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184776, NULL, 'G3DSA:2.70.20.10:FF:000008', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(184777, NULL, 'G3DSA:2.30.30.40:FF:000172', NULL, NULL, 'Amphiphysin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(184778, NULL, 'G3DSA:1.10.8.60:FF:000370', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184779, NULL, 'G3DSA:3.30.540.10:FF:000013', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(184780, NULL, 'G3DSA:2.60.40.1360:FF:000014', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(184781, NULL, 'G3DSA:3.30.230.10:FF:000203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184782, NULL, 'G3DSA:3.10.490.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184783, NULL, 'G3DSA:3.30.559.30:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184784, NULL, 'G3DSA:3.40.1020.10:FF:000005', NULL, NULL, 'Threonine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(184785, NULL, 'G3DSA:3.30.200.20:FF:000704', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184786, NULL, 'G3DSA:3.10.280.10:FF:000037', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184787, NULL, 'G3DSA:3.40.50.1000:FF:000343', NULL, NULL, 'Haloacid dehalogenase/epoxide hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(184788, NULL, 'G3DSA:3.40.50.300:FF:008447', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184789, NULL, 'G3DSA:3.40.50.1820:FF:001432', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(184790, NULL, 'G3DSA:1.10.287.70:FF:000746', NULL, NULL, 'MKIAA1123 protein', NULL, NULL, NULL, NULL, NULL, 4),
(184791, NULL, 'G3DSA:2.60.40.10:FF:000600', NULL, NULL, 'Contactin 2', NULL, NULL, NULL, NULL, NULL, 4),
(184792, NULL, 'G3DSA:2.60.40.10:FF:001786', NULL, NULL, 'PKD1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(184793, NULL, 'G3DSA:1.10.405.10:FF:000021', NULL, NULL, 'Pseudooxynicotine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(184794, NULL, 'G3DSA:3.40.50.300:FF:003956', NULL, NULL, 'Rab family, other', NULL, NULL, NULL, NULL, NULL, 4),
(184795, NULL, 'G3DSA:3.30.457.50:FF:000005', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(184796, NULL, 'G3DSA:1.10.10.10:FF:001199', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(184797, NULL, 'G3DSA:2.60.40.60:FF:000654', NULL, NULL, 'AGAP003579-PA', NULL, NULL, NULL, NULL, NULL, 4),
(184798, NULL, 'G3DSA:3.40.50.300:FF:004524', NULL, NULL, 'AAA-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(184799, NULL, 'G3DSA:3.90.1110.10:FF:000023', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(184800, NULL, 'G3DSA:3.30.70.270:FF:000120', NULL, NULL, 'Diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(184801, NULL, 'G3DSA:3.40.50.880:FF:000055', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(184802, NULL, 'G3DSA:3.30.70.330:FF:002302', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184803, NULL, 'G3DSA:3.30.540.30:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184804, NULL, 'G3DSA:1.20.1070.10:FF:001447', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184805, NULL, 'G3DSA:1.25.40.20:FF:000760', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184806, NULL, 'G3DSA:2.30.31.10:FF:000002', NULL, NULL, 'Single-stranded DNA-binding protein WHY2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(184807, NULL, 'G3DSA:3.40.50.620:FF:000848', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184808, NULL, 'G3DSA:2.60.40.10:FF:004580', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184809, NULL, 'G3DSA:3.40.1110.10:FF:000372', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184810, NULL, 'G3DSA:3.30.160.60:FF:006440', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184811, NULL, 'G3DSA:1.20.1640.10:FF:000075', NULL, NULL, 'Niemann-Pick C1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(184812, NULL, 'G3DSA:1.10.1200.10:FF:000084', NULL, NULL, 'Nonribosomal peptide synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(184813, NULL, 'G3DSA:2.10.25.10:FF:001455', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184814, NULL, 'G3DSA:1.20.1070.10:FF:001155', NULL, NULL, 'Pyroglutamylated RFamide peptide receptor', NULL, NULL, NULL, NULL, NULL, 4),
(184815, NULL, 'G3DSA:3.40.47.10:FF:000013', NULL, NULL, 'Acetyl-CoA acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(184816, NULL, 'G3DSA:1.25.40.10:FF:002016', NULL, NULL, 'Pre-mRNA-splicing factor SYF1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(184817, NULL, 'G3DSA:1.20.5.340:FF:000102', NULL, NULL, 'Kinesin-like protein KIN-14C', NULL, NULL, NULL, NULL, NULL, 4),
(184818, NULL, 'G3DSA:3.40.50.300:FF:004232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184819, NULL, 'G3DSA:3.30.1960.10:FF:000005', NULL, NULL, 'Transcription factor INI', NULL, NULL, NULL, NULL, NULL, 4),
(184820, NULL, 'G3DSA:1.10.510.10:FF:000041', NULL, NULL, 'Ribosomal protein S6 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(184821, NULL, 'G3DSA:2.60.260.20:FF:000031', NULL, NULL, 'Molecular chaperone DnaJ', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(184822, NULL, 'G3DSA:1.25.10.10:FF:002514', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184823, NULL, 'G3DSA:3.90.780.10:FF:000001', NULL, NULL, 'NT5E isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(184824, NULL, 'G3DSA:1.20.1720.10:FF:000076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184825, NULL, 'G3DSA:3.40.50.12440:FF:000003', NULL, NULL, 'Anaerobic dimethyl sulfoxide reductase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(184826, NULL, 'G3DSA:3.60.21.10:FF:000127', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(184827, NULL, 'G3DSA:3.10.105.10:FF:000075', NULL, NULL, 'Oligopeptide-binding protein oppA', NULL, NULL, NULL, NULL, NULL, 4),
(184828, NULL, 'G3DSA:3.30.40.10:FF:001408', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184829, NULL, 'G3DSA:1.20.1280.50:FF:000188', NULL, NULL, 'F-box and WD repeat domain containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(184830, NULL, 'G3DSA:3.20.20.70:FF:000638', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184831, NULL, 'G3DSA:3.30.559.30:FF:000045', NULL, NULL, 'PKS-NRPS hybrid synthetase psoA', NULL, NULL, NULL, NULL, NULL, 4),
(184832, NULL, 'G3DSA:3.80.10.10:FF:003355', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184833, NULL, 'G3DSA:3.40.50.150:FF:000628', NULL, NULL, 'Predicted O-methyltransferase YrrM', NULL, NULL, NULL, NULL, NULL, 4),
(184834, NULL, 'G3DSA:1.25.40.20:FF:000434', NULL, NULL, 'Serine/threonine-protein phosphatase 6 regulatory ankyrin repeat subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(184835, NULL, 'G3DSA:3.40.1170.60:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184836, NULL, 'G3DSA:3.40.50.300:FF:007672', NULL, NULL, 'GPN-loop GTPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(184837, NULL, 'G3DSA:3.10.28.10:FF:000021', NULL, NULL, 'Intron-encoded DNA endonuclease ai2a', NULL, NULL, NULL, NULL, NULL, 4),
(184838, NULL, 'G3DSA:1.10.238.10:FF:000115', NULL, NULL, 'Calcium-binding protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(184839, NULL, 'G3DSA:2.60.40.1170:FF:000047', NULL, NULL, 'APM2p protein', NULL, NULL, NULL, NULL, NULL, 4),
(184840, NULL, 'G3DSA:3.30.360.10:FF:000027', NULL, NULL, 'Dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(184841, NULL, 'G3DSA:3.40.50.12650:FF:000009', NULL, NULL, 'DNA repair metallo-beta-lactamase protein', NULL, NULL, NULL, NULL, NULL, 4),
(184842, NULL, 'G3DSA:2.60.120.10:FF:000338', NULL, NULL, 'Protein CBG19118', NULL, NULL, NULL, NULL, NULL, 4),
(184843, NULL, 'G3DSA:3.40.50.1440:FF:000014', NULL, NULL, 'Cell division protein FtsZ', NULL, NULL, NULL, NULL, NULL, 4),
(184844, NULL, 'G3DSA:2.40.20.10:FF:000044', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(184845, NULL, 'G3DSA:3.30.540.10:FF:000064', NULL, NULL, 'Fructose-1,6-bisphosphatase class 1', NULL, NULL, NULL, NULL, NULL, 4),
(184846, NULL, 'G3DSA:3.40.50.1780:FF:000032', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NAR1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(184847, NULL, 'G3DSA:3.30.40.10:FF:000796', NULL, NULL, 'BnaCnng74270D protein', NULL, NULL, NULL, NULL, NULL, 4),
(184848, NULL, 'G3DSA:1.25.40.10:FF:000431', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(184849, NULL, 'G3DSA:2.10.25.10:FF:001129', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184850, NULL, 'G3DSA:6.10.140.2150:FF:000011', NULL, NULL, 'Sphingosine 1-phosphate lyase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184851, NULL, 'G3DSA:1.20.930.40:FF:000017', NULL, NULL, 'N-acetylated-alpha-linked acidic dipeptidase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(184852, NULL, 'G3DSA:1.10.287.110:FF:000219', NULL, NULL, 'DnaJ subfamily C member 3', NULL, NULL, NULL, NULL, NULL, 4),
(184853, NULL, 'G3DSA:2.130.10.10:FF:004670', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184854, NULL, 'G3DSA:3.40.50.360:FF:000169', NULL, NULL, 'Nitric oxide synthase, inducible', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(184855, NULL, 'G3DSA:3.30.160.60:FF:005889', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184856, NULL, 'G3DSA:2.60.40.10:FF:002449', NULL, NULL, 'CD4', NULL, NULL, NULL, NULL, NULL, 4),
(184857, NULL, 'G3DSA:3.10.20.600:FF:000006', NULL, NULL, 'Formate dehydrogenase, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(184858, NULL, 'G3DSA:3.30.450.20:FF:000594', NULL, NULL, 'Sensor histidine kinase, PAS and PAS domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(184859, NULL, 'G3DSA:1.10.510.10:FF:000248', NULL, NULL, 'S-receptor-like kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(184860, NULL, 'G3DSA:3.40.50.300:FF:000084', NULL, NULL, 'Guanylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(184861, NULL, 'G3DSA:1.10.287.1770:FF:000004', NULL, NULL, 'Ferrous iron transport protein B', NULL, NULL, NULL, NULL, NULL, 4),
(184862, NULL, 'G3DSA:3.40.50.2300:FF:001554', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184863, NULL, 'G3DSA:1.20.58.340:FF:000017', NULL, NULL, 'Magnesium transport protein CorA', NULL, NULL, NULL, NULL, NULL, 4),
(184864, NULL, 'G3DSA:3.40.50.300:FF:004850', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(184865, NULL, 'G3DSA:1.25.40.20:FF:001895', NULL, NULL, 'Espin like a', NULL, NULL, NULL, NULL, NULL, 4),
(184866, NULL, 'G3DSA:3.30.505.10:FF:000168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184867, NULL, 'G3DSA:3.30.160.60:FF:000549', NULL, NULL, 'zinc finger protein 384 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(184868, NULL, 'G3DSA:2.130.10.10:FF:005367', NULL, NULL, 'WD repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184869, NULL, 'G3DSA:3.30.60.30:FF:000168', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(184870, NULL, 'G3DSA:1.25.10.10:FF:000036', NULL, NULL, 'Formin-like protein 3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(184871, NULL, 'G3DSA:1.20.1540.10:FF:000011', NULL, NULL, 'Putative rhomboid domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(184872, NULL, 'G3DSA:2.120.10.80:FF:000133', NULL, NULL, 'Leucine carboxyl methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(184873, NULL, 'G3DSA:1.20.120.1510:FF:000009', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(184874, NULL, 'G3DSA:3.50.50.60:FF:001176', NULL, NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(184875, NULL, 'G3DSA:1.20.1280.50:FF:000137', NULL, NULL, 'F-box/wd-repeat protein lin-23, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184876, NULL, 'G3DSA:1.10.472.10:FF:000030', NULL, NULL, 'Retinoblastoma-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(184877, NULL, 'G3DSA:3.40.50.1240:FF:000044', NULL, NULL, 'Multiple inositol polyphosphate phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(184878, NULL, 'G3DSA:3.30.40.10:FF:001285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184879, NULL, 'G3DSA:2.60.40.10:FF:002242', NULL, NULL, 'Stretchin-Mlck, isoform U', NULL, NULL, NULL, NULL, NULL, 4),
(184880, NULL, 'G3DSA:2.160.20.10:FF:000330', NULL, NULL, 'Amidase2', NULL, NULL, NULL, NULL, NULL, 4),
(184881, NULL, 'G3DSA:2.120.10.30:FF:000051', NULL, NULL, 'Low-density lipoprotein receptor-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(184882, NULL, 'G3DSA:2.40.70.10:FF:000142', NULL, NULL, 'Os01g0937800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(184883, NULL, 'G3DSA:3.40.50.150:FF:001859', NULL, NULL, 'Probable polyketide synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(184884, NULL, 'G3DSA:1.25.40.580:FF:000001', NULL, NULL, 'DNA mismatch repair protein HSM3', NULL, NULL, NULL, NULL, NULL, 4),
(184885, NULL, 'G3DSA:3.80.10.10:FF:003142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184886, NULL, 'G3DSA:1.10.510.10:FF:000092', NULL, NULL, 'Ribosomal protein S6 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(184887, NULL, 'G3DSA:3.30.1330.30:FF:000082', NULL, NULL, '23S rRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(184888, NULL, 'G3DSA:3.40.50.300:FF:008161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184889, NULL, 'G3DSA:3.70.10.10:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184890, NULL, 'G3DSA:1.25.40.10:FF:004354', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184891, NULL, 'G3DSA:3.30.450.30:FF:000080', NULL, NULL, 'Uncharacterized protein C1778.05c', NULL, NULL, NULL, NULL, NULL, 4),
(184892, NULL, 'G3DSA:3.30.70.100:FF:000047', NULL, NULL, 'Copper-transporting ATPase PAA1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(184893, NULL, 'G3DSA:1.25.40.10:FF:001892', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g18520, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(184894, NULL, 'G3DSA:1.10.510.10:FF:002244', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184895, NULL, 'G3DSA:3.30.420.40:FF:000581', NULL, NULL, 'Actin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184896, NULL, 'G3DSA:2.130.10.10:FF:005772', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184897, NULL, 'G3DSA:3.80.10.10:FF:001146', NULL, NULL, 'F-box domain containing protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(184898, NULL, 'G3DSA:1.20.5.430:FF:000011', NULL, NULL, 'Glycine betaine transporter BetP', NULL, NULL, NULL, NULL, NULL, 4),
(184899, NULL, 'G3DSA:3.30.450.40:FF:000083', NULL, NULL, 'Sensor histidine kinase/response regulator, putative (AFU_orthologue AFUA_4G00660)', NULL, NULL, NULL, NULL, NULL, 4),
(184900, NULL, 'G3DSA:3.40.50.300:FF:005985', NULL, NULL, 'Vacuolar protein-sorting protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184901, NULL, 'G3DSA:3.40.1350.10:FF:000024', NULL, NULL, 'Fanconi-associated nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(184902, NULL, 'G3DSA:3.30.160.60:FF:001909', NULL, NULL, 'Zinc finger protein 425', NULL, NULL, NULL, NULL, NULL, 4),
(184903, NULL, 'G3DSA:1.10.1170.10:FF:000035', NULL, NULL, 'Death-associated inhibitor of apoptosis 2', NULL, NULL, NULL, NULL, NULL, 4),
(184904, NULL, 'G3DSA:1.10.150.530:FF:000003', NULL, NULL, 'Dual-specificity RNA methyltransferase RlmN', NULL, NULL, NULL, NULL, NULL, 4),
(184905, NULL, 'G3DSA:1.25.40.10:FF:003865', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184906, NULL, 'G3DSA:3.30.70.330:FF:000796', NULL, NULL, 'RNA binding motif protein 4.3', NULL, NULL, NULL, NULL, NULL, 4),
(184907, NULL, 'G3DSA:3.90.226.10:FF:000141', NULL, NULL, 'Carboxyl-terminal-processing peptidase 1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(184908, NULL, 'G3DSA:3.30.420.110:FF:000040', NULL, NULL, 'Putative DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(184909, NULL, 'G3DSA:3.30.160.60:FF:000246', NULL, NULL, 'Transcription factor Ovo-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(184910, NULL, 'G3DSA:3.40.50.1820:FF:000994', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184911, NULL, 'G3DSA:3.80.10.10:FF:002866', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184912, NULL, 'G3DSA:3.30.160.60:FF:006114', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184913, NULL, 'G3DSA:3.10.110.10:FF:000025', NULL, NULL, 'ubiquitin-conjugating enzyme E2 7', NULL, NULL, NULL, NULL, NULL, 4),
(184914, NULL, 'G3DSA:2.130.10.10:FF:003776', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit wuho', NULL, NULL, NULL, NULL, NULL, 4),
(184915, NULL, 'G3DSA:3.30.565.10:FF:000323', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(184916, NULL, 'G3DSA:1.25.10.10:FF:000311', NULL, NULL, 'Coatomer subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(184917, NULL, 'G3DSA:3.40.50.1820:FF:001483', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184918, NULL, 'G3DSA:1.10.287.110:FF:000371', NULL, NULL, 'Diphthamide biosynthesis protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(184919, NULL, 'G3DSA:1.10.1660.10:FF:000022', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(184920, NULL, 'G3DSA:3.90.190.10:FF:000484', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184921, NULL, 'G3DSA:1.25.10.10:FF:001497', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184922, NULL, 'G3DSA:2.30.30.40:FF:000121', NULL, NULL, 'Neutrophil cytosol factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(184923, NULL, 'G3DSA:3.30.450.60:FF:000089', NULL, NULL, 'AAL079Cp', NULL, NULL, NULL, NULL, NULL, 4),
(184924, NULL, 'G3DSA:2.60.40.10:FF:005889', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184925, NULL, 'G3DSA:2.130.10.10:FF:004052', NULL, NULL, 'WD repeatcontaining protein 34-like family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184926, NULL, 'G3DSA:2.130.10.10:FF:005928', NULL, NULL, 'Glr0823 protein', NULL, NULL, NULL, NULL, NULL, 4),
(184927, NULL, 'G3DSA:3.50.7.10:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184928, NULL, 'G3DSA:1.10.1740.10:FF:000023', NULL, NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(184929, NULL, 'G3DSA:3.20.19.10:FF:000011', NULL, NULL, 'Aconitate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(184930, NULL, 'G3DSA:3.40.470.10:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184931, NULL, 'G3DSA:3.40.50.1980:FF:000092', NULL, NULL, 'Iron(3+)-hydroxamate-binding protein FhuD', NULL, NULL, NULL, NULL, NULL, 4),
(184932, NULL, 'G3DSA:3.90.550.10:FF:000225', NULL, NULL, 'GNT1p N-acetylglucosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(184933, NULL, 'G3DSA:3.50.50.60:FF:000041', NULL, NULL, 'Glutamate synthase, small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(184934, NULL, 'G3DSA:3.40.50.1820:FF:000589', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(184935, NULL, 'G3DSA:1.10.150.850:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184936, NULL, 'G3DSA:3.40.50.1820:FF:001157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184937, NULL, 'G3DSA:1.25.40.20:FF:000580', NULL, NULL, 'Protein CBR-SHN-1', NULL, NULL, NULL, NULL, NULL, 4),
(184938, NULL, 'G3DSA:2.40.30.10:FF:000319', NULL, NULL, 'Mitochondrial tRNA-specific 2-thiouridylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(184939, NULL, 'G3DSA:1.10.555.10:FF:000234', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184940, NULL, 'G3DSA:2.60.40.200:FF:000006', NULL, NULL, 'Copper chaperone for superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(184941, NULL, 'G3DSA:1.10.287.310:FF:000015', NULL, NULL, '50S ribosomal protein L29', NULL, NULL, NULL, NULL, NULL, 4),
(184942, NULL, 'G3DSA:2.40.10.10:FF:000262', NULL, NULL, 'Transmembrane serine protease 5', NULL, NULL, NULL, NULL, NULL, 4),
(184943, NULL, 'G3DSA:2.80.10.50:FF:000188', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184944, NULL, 'G3DSA:3.40.449.10:FF:000006', NULL, NULL, 'Phosphoenolpyruvate carboxykinase (ATP)', NULL, NULL, NULL, NULL, NULL, 4),
(184945, NULL, 'G3DSA:2.60.120.920:FF:000186', NULL, NULL, 'Neuralized, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184946, NULL, 'G3DSA:3.80.10.10:FF:003029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184947, NULL, 'G3DSA:3.30.930.10:FF:000178', NULL, NULL, 'Phenylalanyl-tRNA synthetase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(184948, NULL, 'G3DSA:3.10.50.40:FF:000059', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(184949, NULL, 'G3DSA:2.30.170.40:FF:000014', NULL, NULL, '50S ribosomal protein L28', NULL, NULL, NULL, NULL, NULL, 4),
(184950, NULL, 'G3DSA:3.40.33.10:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184951, NULL, 'G3DSA:4.10.830.30:FF:000003', NULL, NULL, '50S ribosomal protein L31', NULL, NULL, NULL, NULL, NULL, 4),
(184952, NULL, 'G3DSA:3.20.20.80:FF:000760', NULL, NULL, 'Chitinase, acidic.3', NULL, NULL, NULL, NULL, NULL, 4),
(184953, NULL, 'G3DSA:2.130.10.10:FF:001938', NULL, NULL, 'Chromosome Transmission Fidelity factor homolog', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(184954, NULL, 'G3DSA:1.10.220.150:FF:000001', NULL, NULL, 'Arf-GAP with GTPase, ANK repeat and PH domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(184955, NULL, 'G3DSA:3.40.50.150:FF:000842', NULL, NULL, 'Methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(184956, NULL, 'G3DSA:3.50.50.100:FF:000022', NULL, NULL, 'NADH:ubiquinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(184957, NULL, 'G3DSA:1.10.418.20:FF:000003', NULL, NULL, 'SUMO specific peptidase 7', NULL, NULL, NULL, NULL, NULL, 4),
(184958, NULL, 'G3DSA:2.130.10.10:FF:001882', NULL, NULL, 'WD repeat domain 18', NULL, NULL, NULL, NULL, NULL, 4),
(184959, NULL, 'G3DSA:4.10.410.10:FF:000038', NULL, NULL, 'papilin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(184960, NULL, 'G3DSA:2.60.40.10:FF:005597', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184961, NULL, 'G3DSA:2.30.30.40:FF:000003', NULL, NULL, 'Sorbin and SH3 domain-containing protein 1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(184962, NULL, 'G3DSA:3.30.70.1320:FF:000009', NULL, NULL, 'RND multidrug efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(184963, NULL, 'G3DSA:3.20.20.140:FF:000074', NULL, NULL, 'Extracellular developmental signal biosynthesis protein FluG', NULL, NULL, NULL, NULL, NULL, 4),
(184964, NULL, 'G3DSA:1.10.760.10:FF:000020', NULL, NULL, 'Cytochrome c peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(184965, NULL, 'G3DSA:3.40.50.300:FF:005547', NULL, NULL, 'ArsA-type transport ATPase (Probable substrate arsenite)', NULL, NULL, NULL, NULL, NULL, 4),
(184966, NULL, 'G3DSA:3.40.50.300:FF:008239', NULL, NULL, 'Lon protease-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(184967, NULL, 'G3DSA:1.10.40.40:FF:000001', NULL, NULL, '5''(3'')-deoxyribonucleotidase, cytosolic type', NULL, NULL, NULL, NULL, NULL, 4),
(184968, NULL, 'G3DSA:2.60.120.260:FF:000140', NULL, NULL, 'Mannosidase beta', NULL, NULL, NULL, NULL, NULL, 4),
(184969, NULL, 'G3DSA:2.60.120.330:FF:000240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184970, NULL, 'G3DSA:1.10.510.10:FF:004043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184971, NULL, 'G3DSA:1.20.5.110:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184972, NULL, 'G3DSA:3.40.50.2300:FF:000126', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(184973, NULL, 'G3DSA:2.120.10.30:FF:000612', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184974, NULL, 'G3DSA:2.50.20.20:FF:000001', NULL, NULL, 'Putative conserved lipoprotein LppX', NULL, NULL, NULL, NULL, NULL, 4),
(184975, NULL, 'G3DSA:3.40.120.10:FF:000047', NULL, NULL, 'Phosphoacetylglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(184976, NULL, 'G3DSA:4.10.1000.40:FF:000013', NULL, NULL, 'YALI0E13794p', NULL, NULL, NULL, NULL, NULL, 4),
(184977, NULL, 'G3DSA:3.30.70.270:FF:000002', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(184978, NULL, 'G3DSA:1.10.8.1220:FF:000018', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(184979, NULL, 'G3DSA:1.20.1250.20:FF:001335', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184980, NULL, 'G3DSA:2.30.29.30:FF:001233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184981, NULL, 'G3DSA:1.10.3290.10:FF:000011', NULL, NULL, 'FicT toxin VbhT', NULL, NULL, NULL, NULL, NULL, 4),
(184982, NULL, 'G3DSA:1.10.1450.10:FF:000017', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(184983, NULL, 'G3DSA:1.10.30.10:FF:000014', NULL, NULL, 'HMG box transcription factor BBX', NULL, NULL, NULL, NULL, NULL, 4),
(184984, NULL, 'G3DSA:2.60.40.640:FF:000054', NULL, NULL, 'Vacuolar protein sorting-associated protein 26 containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(184985, NULL, 'G3DSA:3.10.129.10:FF:000051', NULL, NULL, 'Acyl-coa thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(184986, NULL, 'G3DSA:2.40.30.10:FF:000224', NULL, NULL, 'Selenocysteine-specific translation elongation factor', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(184987, NULL, 'G3DSA:3.30.40.10:FF:002302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184988, NULL, 'G3DSA:1.10.510.10:FF:000771', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184989, NULL, 'G3DSA:3.90.120.10:FF:000030', NULL, NULL, 'Cytosine-specific DNA methylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(184990, NULL, 'G3DSA:1.10.287.80:FF:000007', NULL, NULL, 'ATP synthase gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(184991, NULL, 'G3DSA:3.30.1460.50:FF:000030', NULL, NULL, 'AGAP000933-PA', NULL, NULL, NULL, NULL, NULL, 4),
(184992, NULL, 'G3DSA:2.70.170.10:FF:000272', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(184993, NULL, 'G3DSA:1.25.40.10:FF:000105', NULL, NULL, 'Tetratricopeptide repeat domain 7A', NULL, NULL, NULL, NULL, NULL, 4),
(184994, NULL, 'G3DSA:1.10.10.10:FF:000535', NULL, NULL, 'DNA-binding response regulator CiaR', NULL, NULL, NULL, NULL, NULL, 4),
(184995, NULL, 'G3DSA:2.10.10.20:FF:000002', NULL, NULL, 'Probable bifunctional chitinase/lysozyme', NULL, NULL, NULL, NULL, NULL, 4),
(184996, NULL, 'G3DSA:3.30.420.10:FF:000645', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(184997, NULL, 'G3DSA:1.10.390.10:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184998, NULL, 'G3DSA:2.20.100.10:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(184999, NULL, 'G3DSA:1.10.472.10:FF:000142', NULL, NULL, 'Cyclin, N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(185000, NULL, 'G3DSA:1.10.150.50:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185001, NULL, 'G3DSA:3.90.190.10:FF:000596', NULL, NULL, 'Protein tyrosine phosphatase, receptor type G', NULL, NULL, NULL, NULL, NULL, 4),
(185002, NULL, 'G3DSA:3.40.1110.10:FF:000276', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(185003, NULL, 'G3DSA:3.40.50.1820:FF:000494', NULL, NULL, 'Protein FAM135B isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(185004, NULL, 'G3DSA:1.20.58.830:FF:000018', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(185005, NULL, 'G3DSA:3.40.50.300:FF:006441', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(185006, NULL, 'G3DSA:1.10.510.10:FF:004082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185007, NULL, 'G3DSA:3.30.160.60:FF:004203', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185008, NULL, 'G3DSA:1.10.238.10:FF:000166', NULL, NULL, 'Naked cuticle homolog 1 (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(185009, NULL, 'G3DSA:1.10.10.480:FF:000003', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(185010, NULL, 'G3DSA:1.20.5.340:FF:000017', NULL, NULL, 'myosin-10 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(185011, NULL, 'G3DSA:1.25.40.60:FF:000013', NULL, NULL, 'Syntaxin binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185012, NULL, 'G3DSA:1.10.20.10:FF:000362', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185013, NULL, 'G3DSA:1.20.120.180:FF:000002', NULL, NULL, 'Proteasome activator complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(185014, NULL, 'G3DSA:3.10.290.10:FF:000077', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(185015, NULL, 'G3DSA:3.30.420.110:FF:000006', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(185016, NULL, 'G3DSA:1.20.1510.10:FF:000060', NULL, NULL, 'CDF transporter, membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(185017, NULL, 'G3DSA:2.60.120.10:FF:000518', NULL, NULL, 'Stage II sporulation E family protein', NULL, NULL, NULL, NULL, NULL, 4),
(185018, NULL, 'G3DSA:1.20.58.60:FF:000598', NULL, NULL, 'Dystrophin', NULL, NULL, NULL, NULL, NULL, 4),
(185019, NULL, 'G3DSA:2.60.40.60:FF:000351', NULL, NULL, 'Cadherin 74A, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(185020, NULL, 'G3DSA:1.10.220.160:FF:000004', NULL, NULL, 'Blast:Protein msta, isoform A', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(185021, NULL, 'G3DSA:3.30.160.60:FF:004523', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185022, NULL, 'G3DSA:3.30.160.60:FF:004580', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185023, NULL, 'G3DSA:2.30.30.1150:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185024, NULL, 'G3DSA:1.25.40.70:FF:000016', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit gamma, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185025, NULL, 'G3DSA:1.25.40.10:FF:002229', NULL, NULL, 'Pentatricopeptide repeat domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185026, NULL, 'G3DSA:2.10.50.10:FF:000064', NULL, NULL, 'Cysteine repeat modular protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(185027, NULL, 'G3DSA:1.20.120.350:FF:000076', NULL, NULL, 'Ion transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185028, NULL, 'G3DSA:1.10.220.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185029, NULL, 'G3DSA:2.60.120.260:FF:000235', NULL, NULL, 'Regulator', NULL, NULL, NULL, NULL, NULL, 4),
(185030, NULL, 'G3DSA:2.80.10.50:FF:000093', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(185031, NULL, 'G3DSA:3.40.50.620:FF:000005', NULL, NULL, 'Argininosuccinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(185032, NULL, 'G3DSA:1.10.510.10:FF:004138', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185033, NULL, 'G3DSA:2.70.150.10:FF:000001', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(185034, NULL, 'G3DSA:1.20.930.20:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185035, NULL, 'G3DSA:1.20.5.2440:FF:000005', NULL, NULL, 'ELKS/Rab6-interacting/CAST family member 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(185036, NULL, 'G3DSA:3.90.1460.10:FF:000004', NULL, NULL, 'general transcription factor II-I isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(185037, NULL, 'G3DSA:2.30.40.10:FF:000068', NULL, NULL, 'Triazine hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(185038, NULL, 'G3DSA:2.60.40.150:FF:000244', NULL, NULL, 'Rabphilin, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(185039, NULL, 'G3DSA:3.40.50.720:FF:001901', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(185040, NULL, 'G3DSA:2.40.50.140:FF:000899', NULL, NULL, 'Single-stranded DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(185041, NULL, 'G3DSA:1.10.167.10:FF:000028', NULL, NULL, 'G protein-coupled receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(185042, NULL, 'G3DSA:2.40.50.140:FF:000202', NULL, NULL, 'Aspartate--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(185043, NULL, 'G3DSA:3.30.420.100:FF:000003', NULL, NULL, '50S ribosomal protein L18', NULL, NULL, NULL, NULL, NULL, 4),
(185044, NULL, 'G3DSA:3.80.10.10:FF:003181', NULL, NULL, 'Protein CBG22695', NULL, NULL, NULL, NULL, NULL, 4),
(185045, NULL, 'G3DSA:1.25.40.20:FF:000260', NULL, NULL, 'Receptor-interacting serine/threonine-protein kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(185046, NULL, 'G3DSA:3.30.200.20:FF:001273', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185047, NULL, 'G3DSA:1.10.287.70:FF:000589', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185048, NULL, 'G3DSA:3.40.50.10470:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185049, NULL, 'G3DSA:1.10.10.60:FF:000067', NULL, NULL, 'NK6 homeobox 1', NULL, NULL, NULL, NULL, NULL, 4),
(185050, NULL, 'G3DSA:1.20.1270.10:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185051, NULL, 'G3DSA:1.10.630.10:FF:000549', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(185052, NULL, 'G3DSA:2.40.290.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185053, NULL, 'G3DSA:3.40.50.2300:FF:000868', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(185054, NULL, 'G3DSA:1.10.8.10:FF:000169', NULL, NULL, 'Ubiquitin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(185055, NULL, 'G3DSA:4.10.970.10:FF:000007', NULL, NULL, 'Related to ATP-dependent DNA helicase II, 70 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(185056, NULL, 'G3DSA:2.60.40.10:FF:002163', NULL, NULL, 'KETtiN (Drosophila actin-binding) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(185057, NULL, 'G3DSA:3.40.50.1240:FF:000005', NULL, NULL, 'GpmB, Fructose-2,6-bisphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(185058, NULL, 'G3DSA:3.90.70.10:FF:000840', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185059, NULL, 'G3DSA:1.10.20.10:FF:000249', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185060, NULL, 'G3DSA:1.10.132.130:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185061, NULL, 'G3DSA:1.10.3500.10:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185062, NULL, 'G3DSA:1.20.920.10:FF:000148', NULL, NULL, 'YALI0E32307p', NULL, NULL, NULL, NULL, NULL, 4),
(185063, NULL, 'G3DSA:3.30.420.10:FF:000437', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185064, NULL, 'G3DSA:1.25.10.10:FF:001789', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185065, NULL, 'G3DSA:3.40.50.2000:FF:000891', NULL, NULL, 'UDP-glycosyltransferase 73D1', NULL, NULL, NULL, NULL, NULL, 4),
(185066, NULL, 'G3DSA:1.10.940.10:FF:000005', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase B', NULL, NULL, NULL, NULL, NULL, 4),
(185067, NULL, 'G3DSA:3.40.50.790:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185068, NULL, 'G3DSA:1.10.246.130:FF:000014', NULL, NULL, 'RE13973p', NULL, NULL, NULL, NULL, NULL, 4),
(185069, NULL, 'G3DSA:2.130.10.10:FF:003804', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185070, NULL, 'G3DSA:3.40.190.290:FF:000043', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(185071, NULL, 'G3DSA:3.30.70.1450:FF:000020', NULL, NULL, 'Sodium/sulfate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185072, NULL, 'G3DSA:3.30.559.30:FF:000124', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(185073, NULL, 'G3DSA:1.20.1260.80:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185074, NULL, 'G3DSA:3.50.50.60:FF:001356', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(185075, NULL, 'G3DSA:3.40.50.1110:FF:000146', NULL, NULL, 'Os06g0149100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(185076, NULL, 'G3DSA:1.25.40.10:FF:003539', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185077, NULL, 'G3DSA:2.60.40.1180:FF:000112', NULL, NULL, 'Putative alpha-L-fucosidase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(185078, NULL, 'G3DSA:3.30.40.10:FF:001313', NULL, NULL, 'Zinc finger family protein', NULL, NULL, NULL, NULL, NULL, 4),
(185079, NULL, 'G3DSA:3.30.40.10:FF:001370', NULL, NULL, 'E3 ubiquitin-protein ligase rpm-1', NULL, NULL, NULL, NULL, NULL, 4),
(185080, NULL, 'G3DSA:3.40.50.1100:FF:000143', NULL, NULL, 'SH3 domain protein (Cyk3), putative (AFU_orthologue AFUA_5G03400)', NULL, NULL, NULL, NULL, NULL, 4),
(185081, NULL, 'G3DSA:2.70.170.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185082, NULL, 'G3DSA:3.10.120.10:FF:000031', NULL, NULL, 'Acyl-lipid (8-3)-desaturase', NULL, NULL, NULL, NULL, NULL, 4),
(185083, NULL, 'G3DSA:1.20.5.340:FF:000085', NULL, NULL, 'NHS-like 1a', NULL, NULL, NULL, NULL, NULL, 4),
(185084, NULL, 'G3DSA:2.60.40.10:FF:000443', NULL, NULL, 'host cell factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(185085, NULL, 'G3DSA:3.30.379.10:FF:000020', NULL, NULL, 'O-GlcNAcase BT_4395', NULL, NULL, NULL, NULL, NULL, 4),
(185086, NULL, 'G3DSA:3.40.50.1100:FF:000255', NULL, NULL, 'Cysteine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(185087, NULL, 'G3DSA:2.20.25.10:FF:000084', NULL, NULL, 'transcription factor IIIB 90 kDa subunit isoform X1', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(185088, NULL, 'G3DSA:2.60.120.260:FF:000027', NULL, NULL, 'Beta-glucuronidase', NULL, NULL, NULL, NULL, NULL, 4),
(185089, NULL, 'G3DSA:3.30.40.10:FF:001577', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185090, NULL, 'G3DSA:3.10.450.10:FF:000016', NULL, NULL, 'Cysteine proteinase inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(185091, NULL, 'G3DSA:4.10.280.10:FF:000090', NULL, NULL, 'Salivary gland-expressed bHLH', NULL, NULL, NULL, NULL, NULL, 4),
(185092, NULL, 'G3DSA:2.60.40.10:FF:004254', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185093, NULL, 'G3DSA:1.25.40.10:FF:004062', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(185094, NULL, 'G3DSA:2.60.120.1190:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185095, NULL, 'G3DSA:3.40.50.1000:FF:000843', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185096, NULL, 'G3DSA:3.90.228.10:FF:000038', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(185097, NULL, 'G3DSA:1.25.40.10:FF:002342', NULL, NULL, 'GM12139', NULL, NULL, NULL, NULL, NULL, 4),
(185098, NULL, 'G3DSA:3.40.1810.10:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185099, NULL, 'G3DSA:1.25.40.10:FF:001948', NULL, NULL, 'TPR-containing protein DDB_G0280363', NULL, NULL, NULL, NULL, NULL, 4),
(185100, NULL, 'G3DSA:2.60.40.60:FF:000087', NULL, NULL, 'Protocadherin 9', NULL, NULL, NULL, NULL, NULL, 4),
(185101, NULL, 'G3DSA:3.30.60.30:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185102, NULL, 'G3DSA:3.30.2300.10:FF:000001', NULL, NULL, 'THUMP domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(185103, NULL, 'G3DSA:3.80.10.10:FF:002574', NULL, NULL, 'Putative serine/threonine-protein kinase pats1', NULL, NULL, NULL, NULL, NULL, 4),
(185104, NULL, 'G3DSA:3.60.21.50:FF:000009', NULL, NULL, 'DNA polymerase epsilon subunit', NULL, NULL, NULL, NULL, NULL, 4),
(185105, NULL, 'G3DSA:2.10.90.10:FF:000072', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(185106, NULL, 'G3DSA:3.40.50.720:FF:001160', NULL, NULL, 'Alcohol dehydrogenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(185107, NULL, 'G3DSA:1.20.58.390:FF:000021', NULL, NULL, 'glutamate-gated chloride channel isoform X12', NULL, NULL, NULL, NULL, NULL, 4),
(185108, NULL, 'G3DSA:2.130.10.10:FF:001977', NULL, NULL, 'Histone acetyltransferase type B subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(185109, NULL, 'G3DSA:1.25.10.10:FF:002110', NULL, NULL, 'Darlin', NULL, NULL, NULL, NULL, NULL, 4),
(185110, NULL, 'G3DSA:4.10.40.20:FF:000011', NULL, NULL, 'insulin-like growth factor-binding protein 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(185111, NULL, 'G3DSA:1.20.1070.10:FF:000992', NULL, NULL, 'Olfactory receptor B6', NULL, NULL, NULL, NULL, NULL, 4),
(185112, NULL, 'G3DSA:1.20.58.390:FF:000285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185113, NULL, 'G3DSA:3.40.50.11840:FF:000008', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(185114, NULL, 'G3DSA:3.30.2170.10:FF:000001', NULL, NULL, 'Endonuclease V', NULL, NULL, NULL, NULL, NULL, 4),
(185115, NULL, 'G3DSA:1.20.58.190:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185116, NULL, 'G3DSA:3.30.160.60:FF:004411', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185117, NULL, 'G3DSA:2.102.10.10:FF:000057', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(185118, NULL, 'G3DSA:2.40.160.120:FF:000043', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(185119, NULL, 'G3DSA:2.30.110.10:FF:000047', NULL, NULL, 'Flavin reductase domain protein FMN-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(185120, NULL, 'G3DSA:3.10.100.10:FF:000210', NULL, NULL, 'C-type lectin domain family 12 member B', NULL, NULL, NULL, NULL, NULL, 4),
(185121, NULL, 'G3DSA:2.70.150.10:FF:000063', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(185122, NULL, 'G3DSA:3.30.160.60:FF:003708', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185123, NULL, 'G3DSA:3.30.200.20:FF:001952', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185124, NULL, 'G3DSA:3.30.160.60:FF:000196', NULL, NULL, 'Zinc finger protein 1026', NULL, NULL, NULL, NULL, NULL, 4),
(185125, NULL, 'G3DSA:3.90.550.10:FF:000175', NULL, NULL, 'Beta-1,4-mannosyltransferase bre-3', NULL, NULL, NULL, NULL, NULL, 4),
(185126, NULL, 'G3DSA:3.40.50.720:FF:001042', NULL, NULL, '5,10-methenyltetrahydromethanopterin hydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(185127, NULL, 'G3DSA:1.10.1450.10:FF:000130', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(185128, NULL, 'G3DSA:1.20.120.1200:FF:000017', NULL, NULL, 'NADH-quinone oxidoreductase subunit J', NULL, NULL, NULL, NULL, NULL, 4),
(185129, NULL, 'G3DSA:2.30.29.30:FF:001328', NULL, NULL, 'GM06875p', NULL, NULL, NULL, NULL, NULL, 4),
(185130, NULL, 'G3DSA:3.40.1110.10:FF:000164', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(185131, NULL, 'G3DSA:2.130.10.10:FF:005480', NULL, NULL, 'WD domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(185132, NULL, 'G3DSA:3.30.70.330:FF:001459', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185133, NULL, 'G3DSA:3.40.50.11980:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185134, NULL, 'G3DSA:3.30.160.60:FF:001674', NULL, NULL, 'Putative zinc finger E-box-binding homeobox 2', NULL, NULL, NULL, NULL, NULL, 4),
(185135, NULL, 'G3DSA:2.60.120.290:FF:000188', NULL, NULL, 'AGAP005526-PA', NULL, NULL, NULL, NULL, NULL, 4),
(185136, NULL, 'G3DSA:3.30.830.10:FF:000232', NULL, NULL, 'Protein CBG17023', NULL, NULL, NULL, NULL, NULL, 4),
(185137, NULL, 'G3DSA:1.10.720.60:FF:000009', NULL, NULL, 'Enolase-phosphatase E1', NULL, NULL, NULL, NULL, NULL, 4),
(185138, NULL, 'G3DSA:3.40.50.2300:FF:000986', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185139, NULL, 'G3DSA:3.20.180.20:FF:000024', NULL, NULL, 'Dynein-1-beta heavy chain, flagellar inner arm I1 complex', NULL, NULL, NULL, NULL, NULL, 4),
(185140, NULL, 'G3DSA:1.10.10.440:FF:000019', NULL, NULL, 'Pre-mRNA-processing protein 40A', NULL, NULL, NULL, NULL, NULL, 4),
(185141, NULL, 'G3DSA:2.10.110.10:FF:000012', NULL, NULL, 'Paxillin isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(185142, NULL, 'G3DSA:1.20.1250.20:FF:001256', NULL, NULL, 'Solute carrier family 46, member 2', NULL, NULL, NULL, NULL, NULL, 4),
(185143, NULL, 'G3DSA:3.40.50.300:FF:002433', NULL, NULL, 'Endoribonuclease Dicer homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(185144, NULL, 'G3DSA:2.60.40.10:FF:003591', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185145, NULL, 'G3DSA:3.30.420.80:FF:000008', NULL, NULL, 'Mitochondrial ribosomal protein S11', NULL, NULL, NULL, NULL, NULL, 4),
(185146, NULL, 'G3DSA:2.60.40.10:FF:006053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185147, NULL, 'G3DSA:3.90.480.20:FF:000003', NULL, NULL, 'Anaerobic sulfite reductase subunit AsrC', NULL, NULL, NULL, NULL, NULL, 4),
(185148, NULL, 'G3DSA:3.40.1190.10:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185149, NULL, 'G3DSA:3.90.70.10:FF:000222', NULL, NULL, 'Cathepsin B', NULL, NULL, NULL, NULL, NULL, 4),
(185150, NULL, 'G3DSA:2.30.40.10:FF:000079', NULL, NULL, 'Adenine deaminase 2', NULL, NULL, NULL, NULL, NULL, 4),
(185151, NULL, 'G3DSA:1.25.10.10:FF:001997', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185152, NULL, 'G3DSA:3.30.750.44:FF:000009', NULL, NULL, 'Retinol-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(185153, NULL, 'G3DSA:4.10.60.10:FF:000104', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(185154, NULL, 'G3DSA:3.30.200.20:FF:001891', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185155, NULL, 'G3DSA:1.50.40.10:FF:000367', NULL, NULL, 'Solute carrier family 25 member 33', NULL, NULL, NULL, NULL, NULL, 4),
(185156, NULL, 'G3DSA:3.40.50.300:FF:006362', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(185157, NULL, 'G3DSA:3.90.79.10:FF:000045', NULL, NULL, 'mRNA-decapping enzyme 2', NULL, NULL, NULL, NULL, NULL, 4),
(185158, NULL, 'G3DSA:1.20.1070.10:FF:000784', NULL, NULL, 'Opsin 3 (Encephalopsin, panopsin)', NULL, NULL, NULL, NULL, NULL, 4),
(185159, NULL, 'G3DSA:3.40.50.300:FF:000292', NULL, NULL, 'ATP-dependent dethiobiotin synthetase BioD', NULL, NULL, NULL, NULL, NULL, 4),
(185160, NULL, 'G3DSA:3.40.5.10:FF:000001', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(185161, NULL, 'G3DSA:2.130.10.10:FF:004462', NULL, NULL, 'Pre-mRNA-processing factor 19', NULL, NULL, NULL, NULL, NULL, 4),
(185162, NULL, 'G3DSA:3.40.109.10:FF:000037', NULL, NULL, 'Blr4539 protein', NULL, NULL, NULL, NULL, NULL, 4),
(185163, NULL, 'G3DSA:1.25.10.10:FF:000715', NULL, NULL, 'Os11g0518900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(185164, NULL, 'G3DSA:1.10.4020.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185165, NULL, 'G3DSA:3.40.30.10:FF:000536', NULL, NULL, 'Protein windbeutel', NULL, NULL, NULL, NULL, NULL, 4),
(185166, NULL, 'G3DSA:2.40.30.130:FF:000004', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(185167, NULL, 'G3DSA:2.60.40.1730:FF:000086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185168, NULL, 'G3DSA:3.30.60.270:FF:000017', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(185169, NULL, 'G3DSA:3.40.50.10470:FF:000064', NULL, NULL, 'methylthioribose-1-phosphate isomerase-like', NULL, NULL, NULL, NULL, NULL, 4),
(185170, NULL, 'G3DSA:3.30.160.60:FF:002612', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185171, NULL, 'G3DSA:2.60.40.10:FF:003877', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185172, NULL, 'G3DSA:3.90.226.10:FF:000202', NULL, NULL, 'Acetyl-CoA carboxylase/pyruvate carboxylase fusion protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185173, NULL, 'G3DSA:2.20.28.10:FF:000039', NULL, NULL, 'Minichromosome maintenance protein MCM', NULL, NULL, NULL, NULL, NULL, 4),
(185174, NULL, 'G3DSA:2.170.270.10:FF:000053', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(185175, NULL, 'G3DSA:3.50.50.60:FF:001390', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185176, NULL, 'G3DSA:1.20.1070.10:FF:001060', NULL, NULL, 'Olfactory receptor class A (V1r-like homolog)', NULL, NULL, NULL, NULL, NULL, 4),
(185177, NULL, 'G3DSA:2.130.10.10:FF:005687', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(185178, NULL, 'G3DSA:3.30.1010.10:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185179, NULL, 'G3DSA:2.40.70.10:FF:000108', NULL, NULL, 'Putative aspartyl protease', NULL, NULL, NULL, NULL, NULL, 4),
(185180, NULL, 'G3DSA:3.30.1330.20:FF:000045', NULL, NULL, 'Tubulin-like protein CetZ', NULL, NULL, NULL, NULL, NULL, 4),
(185181, NULL, 'G3DSA:1.20.120.790:FF:000011', NULL, NULL, 'Putative heat shock protein HSP 90-alpha A4', NULL, NULL, NULL, NULL, NULL, 4),
(185182, NULL, 'G3DSA:2.10.230.10:FF:000021', NULL, NULL, 'Chaperone protein DNAj, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185183, NULL, 'G3DSA:3.40.50.1000:FF:000635', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185184, NULL, 'G3DSA:1.10.510.10:FF:001558', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185185, NULL, 'G3DSA:1.10.230.10:FF:000002', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(185186, NULL, 'G3DSA:3.30.70.1130:FF:000008', NULL, NULL, 'Eukaryotic translation initiation factor 2 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(185187, NULL, 'G3DSA:3.40.120.10:FF:000058', NULL, NULL, 'Phosphomannomutase/phosphoglucomutase', NULL, NULL, NULL, NULL, NULL, 4),
(185188, NULL, 'G3DSA:3.30.160.60:FF:006209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185189, NULL, 'G3DSA:2.40.70.10:FF:000030', NULL, NULL, 'Eukaryotic aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(185190, NULL, 'G3DSA:1.25.40.10:FF:001448', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g06540', NULL, NULL, NULL, NULL, NULL, 4),
(185191, NULL, 'G3DSA:3.40.50.300:FF:006323', NULL, NULL, 'AGAP002581-PA', NULL, NULL, NULL, NULL, NULL, 4),
(185192, NULL, 'G3DSA:3.30.70.330:FF:001173', NULL, NULL, 'Nuclear acid binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185193, NULL, 'G3DSA:2.60.40.1180:FF:000090', NULL, NULL, 'Alpha-glucosidase/alpha-amylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185194, NULL, 'G3DSA:3.30.1330.30:FF:000048', NULL, NULL, 'Nucleolar protein family a member-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(185195, NULL, 'G3DSA:1.10.510.10:FF:002452', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185196, NULL, 'G3DSA:2.120.10.80:FF:000245', NULL, NULL, 'Dynein regulatory complex subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(185197, NULL, 'G3DSA:3.30.70.330:FF:000211', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(185198, NULL, 'G3DSA:3.30.40.10:FF:001077', NULL, NULL, 'Zinc finger protein-like 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(185199, NULL, 'G3DSA:2.10.250.10:FF:000016', NULL, NULL, 'Calreticulin-3', NULL, NULL, NULL, NULL, NULL, 4),
(185200, NULL, 'G3DSA:3.30.50.10:FF:000122', NULL, NULL, 'Nuclear hormone receptor family member nhr-115', NULL, NULL, NULL, NULL, NULL, 4),
(185201, NULL, 'G3DSA:1.10.555.10:FF:000245', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185202, NULL, 'G3DSA:2.60.40.150:FF:000233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185203, NULL, 'G3DSA:3.30.750.24:FF:000003', NULL, NULL, 'Chloride anion exchanger', NULL, NULL, NULL, NULL, NULL, 4),
(185204, NULL, 'G3DSA:1.25.40.10:FF:003977', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185205, NULL, 'G3DSA:3.30.70.330:FF:002010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185206, NULL, 'G3DSA:1.10.287.110:FF:000163', NULL, NULL, 'Chaperone protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185207, NULL, 'G3DSA:2.70.70.10:FF:000051', NULL, NULL, 'Phosphotransferase system, fructose-specific EI/HPr/EIIA components', NULL, NULL, NULL, NULL, NULL, 4),
(185208, NULL, 'G3DSA:3.30.930.10:FF:000167', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(185209, NULL, 'G3DSA:2.90.10.10:FF:000052', NULL, NULL, 'Curculin-like (Mannose-binding) lectin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(185210, NULL, 'G3DSA:2.60.40.10:FF:003259', NULL, NULL, 'Nectin cell adhesion molecule 4a', NULL, NULL, NULL, NULL, NULL, 4),
(185211, NULL, 'G3DSA:2.60.40.10:FF:004815', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185212, NULL, 'G3DSA:3.30.1330.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185213, NULL, 'G3DSA:1.10.150.20:FF:000004', NULL, NULL, 'U5 small nuclear ribonucleoprotein helicase', NULL, NULL, NULL, NULL, NULL, 4),
(185214, NULL, 'G3DSA:3.10.20.90:FF:000561', NULL, NULL, 'Ubiquitin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(185215, NULL, 'G3DSA:1.25.40.10:FF:003803', NULL, NULL, 'Gamma-soluble NSF attachment protein', NULL, NULL, NULL, NULL, NULL, 4),
(185216, NULL, 'G3DSA:3.40.50.1820:FF:001218', NULL, NULL, 'Lipase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185217, NULL, 'G3DSA:3.90.1410.10:FF:000001', NULL, NULL, 'histone-lysine N-methyltransferase setd3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(185218, NULL, 'G3DSA:3.30.390.10:FF:000029', NULL, NULL, 'Alpha-enolase', NULL, NULL, NULL, NULL, NULL, 4),
(185219, NULL, 'G3DSA:2.60.40.60:FF:000362', NULL, NULL, 'FlaMIngo (Cadherin plus 7TM domain) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(185220, NULL, 'G3DSA:3.40.50.1010:FF:000285', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185221, NULL, 'G3DSA:1.10.238.10:FF:000177', NULL, NULL, 'Troponin C Ia', NULL, NULL, NULL, NULL, NULL, 4),
(185222, NULL, 'G3DSA:1.10.510.10:FF:002339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(185223, NULL, 'G3DSA:1.25.40.280:FF:000001', NULL, NULL, 'programmed cell death 6-interacting protein-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(185224, NULL, 'G3DSA:2.60.40.10:FF:005389', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185225, NULL, 'G3DSA:3.80.10.10:FF:000775', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(185226, NULL, 'G3DSA:1.20.140.40:FF:000041', NULL, NULL, 'Pectinesterase inhibitor 8', NULL, NULL, NULL, NULL, NULL, 4),
(185227, NULL, 'G3DSA:1.20.1110.10:FF:000254', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185228, NULL, 'G3DSA:1.25.40.20:FF:000546', NULL, NULL, 'Ankyrin repeats (Many copies)/Ankyrin repeats (3 copies), putative', NULL, NULL, NULL, NULL, NULL, 4),
(185229, NULL, 'G3DSA:3.80.10.10:FF:003237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185230, NULL, 'G3DSA:1.10.418.10:FF:000264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185231, NULL, 'G3DSA:1.25.40.10:FF:000313', NULL, NULL, 'Transmembrane and tetratricopeptide repeat containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(185232, NULL, 'G3DSA:1.25.10.10:FF:000154', NULL, NULL, 'Phosphoinositide 3-kinase regulatory subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(185233, NULL, 'G3DSA:3.40.190.10:FF:000006', NULL, NULL, 'HTH-type transcriptional regulator CysB', NULL, NULL, NULL, NULL, NULL, 4),
(185234, NULL, 'G3DSA:2.60.120.620:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185235, NULL, 'G3DSA:1.10.1070.11:FF:000001', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(185236, NULL, 'G3DSA:2.30.30.40:FF:000621', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185237, NULL, 'G3DSA:1.10.287.130:FF:000169', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(185238, NULL, 'G3DSA:1.10.287.1490:FF:000033', NULL, NULL, 'GM14462', NULL, NULL, NULL, NULL, NULL, 4),
(185239, NULL, 'G3DSA:1.20.120.1200:FF:000006', NULL, NULL, 'NADH-quinone oxidoreductase subunit J', NULL, NULL, NULL, NULL, NULL, 4),
(185240, NULL, 'G3DSA:3.40.50.200:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185241, NULL, 'G3DSA:3.30.460.90:FF:000008', NULL, NULL, 'Mitochondrial elongation factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(185242, NULL, 'G3DSA:3.40.50.300:FF:007790', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185243, NULL, 'G3DSA:1.20.1280.50:FF:000076', NULL, NULL, 'F-box/WD repeat-containing protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(185244, NULL, 'G3DSA:3.30.572.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185245, NULL, 'G3DSA:3.40.850.10:FF:000006', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(185246, NULL, 'G3DSA:1.25.40.10:FF:000543', NULL, NULL, 'Transmembrane and tetratricopeptide repeat containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(185247, NULL, 'G3DSA:1.20.890.10:FF:000015', NULL, NULL, 'cAMP-dependent protein kinase type II regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(185248, NULL, 'G3DSA:3.80.10.10:FF:001051', NULL, NULL, 'Leucine-rich repeat-containing 23', NULL, NULL, NULL, NULL, NULL, 4),
(185249, NULL, 'G3DSA:1.10.3720.10:FF:000140', NULL, NULL, 'ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(185250, NULL, 'G3DSA:2.60.60.20:FF:000037', NULL, NULL, 'Phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(185251, NULL, 'G3DSA:3.30.460.10:FF:000092', NULL, NULL, 'Poly(A) polymerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185252, NULL, 'G3DSA:3.30.460.80:FF:000005', NULL, NULL, 'NADH dehydrogenase subunit 9', NULL, NULL, NULL, NULL, NULL, 4),
(185253, NULL, 'G3DSA:3.30.160.60:FF:006266', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185254, NULL, 'G3DSA:1.20.5.340:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185255, NULL, 'G3DSA:3.30.70.1450:FF:000031', NULL, NULL, 'Ribosomal protein S6 glutaminyl transferase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(185256, NULL, 'G3DSA:3.10.350.10:FF:000020', NULL, NULL, 'Peptidoglycan-binding LysM domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(185257, NULL, 'G3DSA:3.40.140.10:FF:000267', NULL, NULL, 'Cytidine/deoxycytidylate deaminase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(185258, NULL, 'G3DSA:2.30.22.10:FF:000003', NULL, NULL, 'GrpE protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(185259, NULL, 'G3DSA:3.40.50.300:FF:005867', NULL, NULL, 'ATP-dependent DNA helicase recQ', NULL, NULL, NULL, NULL, NULL, 4),
(185260, NULL, 'G3DSA:2.60.120.200:FF:000667', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185261, NULL, 'G3DSA:1.10.238.10:FF:000519', NULL, NULL, 'EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(185262, NULL, 'G3DSA:3.30.505.10:FF:000056', NULL, NULL, 'Transcription elongation factor Spt6', NULL, NULL, NULL, NULL, NULL, 4),
(185263, NULL, 'G3DSA:1.10.8.720:FF:000072', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(185264, NULL, 'G3DSA:3.30.40.10:FF:001818', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185265, NULL, 'G3DSA:3.20.20.80:FF:000529', NULL, NULL, '1,4-alpha-glucan branching enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185266, NULL, 'G3DSA:3.20.20.70:FF:000526', NULL, NULL, 'tRNA-dihydrouridine synthase 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185267, NULL, 'G3DSA:1.10.10.10:FF:000743', NULL, NULL, 'Rrf2 family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(185268, NULL, 'G3DSA:3.30.160.60:FF:002337', NULL, NULL, 'chorion transcription factor Cf2 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(185269, NULL, 'G3DSA:2.60.40.10:FF:003798', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185270, NULL, 'G3DSA:3.40.50.1000:FF:000405', NULL, NULL, 'Phospholysine phosphohistidine inorganic pyrophosphate phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185271, NULL, 'G3DSA:3.90.70.10:FF:000851', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185272, NULL, 'G3DSA:2.40.50.100:FF:000174', NULL, NULL, 'ABC-type transport system ATP-binding protein (Probable substrate glycerol-3-phosphate)', NULL, NULL, NULL, NULL, NULL, 4),
(185273, NULL, 'G3DSA:3.30.200.20:FF:001778', NULL, NULL, 'Probable serine/threonine-protein kinase DDB_G0279719', NULL, NULL, NULL, NULL, NULL, 4),
(185274, NULL, 'G3DSA:3.40.930.10:FF:000007', NULL, NULL, 'PTS system mannitol-specific transporter subunit IICBA', NULL, NULL, NULL, NULL, NULL, 4),
(185275, NULL, 'G3DSA:3.40.640.10:FF:000524', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185276, NULL, 'G3DSA:3.40.50.2300:FF:001649', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185277, NULL, 'G3DSA:3.30.200.20:FF:001514', NULL, NULL, 'Tribbles pseudokinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(185278, NULL, 'G3DSA:2.130.10.10:FF:002433', NULL, NULL, 'Periodic tryptophan protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(185279, NULL, 'G3DSA:2.60.40.10:FF:004074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185280, NULL, 'G3DSA:1.10.8.560:FF:000001', NULL, NULL, 'Antirestriction protein ArdA', NULL, NULL, NULL, NULL, NULL, 4),
(185281, NULL, 'G3DSA:3.10.580.10:FF:000178', NULL, NULL, 'Cystathionine beta-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(185282, NULL, 'G3DSA:3.30.420.40:FF:000805', NULL, NULL, 'Hexokinase-2', NULL, NULL, NULL, NULL, NULL, 4),
(185283, NULL, 'G3DSA:1.25.10.10:FF:001379', NULL, NULL, 'AP-3 complex subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(185284, NULL, 'G3DSA:1.10.630.10:FF:000196', NULL, NULL, 'Cytochrome P450 144', NULL, NULL, NULL, NULL, NULL, 4),
(185285, NULL, 'G3DSA:2.130.10.10:FF:005249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185286, NULL, 'G3DSA:3.40.50.300:FF:006098', NULL, NULL, 'Discs, large homolog 4a (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(185287, NULL, 'G3DSA:2.60.40.640:FF:000115', NULL, NULL, 'Arrestin domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(185288, NULL, 'G3DSA:1.20.1280.50:FF:000019', NULL, NULL, 'F-box only protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(185289, NULL, 'G3DSA:3.90.190.10:FF:000366', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(185290, NULL, 'G3DSA:1.20.1560.10:FF:000748', NULL, NULL, 'ABC transporter, multidrug resistance associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(185291, NULL, 'G3DSA:4.10.960.10:FF:000001', NULL, NULL, '60S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(185292, NULL, 'G3DSA:1.10.10.1050:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185293, NULL, 'G3DSA:3.30.200.20:FF:002054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185294, NULL, 'G3DSA:1.10.760.10:FF:000019', NULL, NULL, 'Di-heme cytochrome C peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(185295, NULL, 'G3DSA:1.20.81.30:FF:000002', NULL, NULL, 'Components of type IV pilus', NULL, NULL, NULL, NULL, NULL, 4),
(185296, NULL, 'G3DSA:2.40.50.730:FF:000008', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(185297, NULL, 'G3DSA:3.30.870.10:FF:000111', NULL, NULL, 'Phospholipase D1-like protein (PLD1)', NULL, NULL, NULL, NULL, NULL, 4),
(185298, NULL, 'G3DSA:2.60.200.20:FF:000090', NULL, NULL, 'Unplaced genomic scaffold supercont1.29, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(185299, NULL, 'G3DSA:3.10.20.90:FF:000381', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(185300, NULL, 'G3DSA:2.60.40.10:FF:000364', NULL, NULL, 'fibronectin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(185301, NULL, 'G3DSA:3.40.50.300:FF:007458', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(185302, NULL, 'G3DSA:3.40.50.720:FF:001547', NULL, NULL, 'YALI0B03190p', NULL, NULL, NULL, NULL, NULL, 4),
(185303, NULL, 'G3DSA:3.40.1110.10:FF:000484', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185304, NULL, 'G3DSA:3.40.50.150:FF:001005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185305, NULL, 'G3DSA:2.30.39.10:FF:000008', NULL, NULL, 'Serpin B5 isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(185306, NULL, 'G3DSA:1.10.510.10:FF:000153', NULL, NULL, 'Tribbles homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(185307, NULL, 'G3DSA:1.10.560.10:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185308, NULL, 'G3DSA:3.90.105.10:FF:000017', NULL, NULL, 'Molybdenum cofactor synthesis domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(185309, NULL, 'G3DSA:1.10.357.50:FF:000004', NULL, NULL, 'Exocyst complex component 3', NULL, NULL, NULL, NULL, NULL, 4),
(185310, NULL, 'G3DSA:3.40.800.20:FF:000063', NULL, NULL, 'Histone deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(185311, NULL, 'G3DSA:3.40.140.10:FF:000060', NULL, NULL, 'Cytidine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(185312, NULL, 'G3DSA:1.10.10.10:FF:000125', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(185313, NULL, 'G3DSA:1.10.630.10:FF:000538', NULL, NULL, 'Os10g0179200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(185314, NULL, 'G3DSA:1.10.510.10:FF:003587', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185315, NULL, 'G3DSA:1.20.1250.20:FF:001610', NULL, NULL, 'Tartrate MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185316, NULL, 'G3DSA:3.30.160.60:FF:004080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185317, NULL, 'G3DSA:1.10.10.10:FF:000182', NULL, NULL, 'DEP domain-containing protein 1B isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(185318, NULL, 'G3DSA:2.60.120.10:FF:000552', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185319, NULL, 'G3DSA:3.40.50.300:FF:004024', NULL, NULL, 'ADP-ribosylation factor-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(185320, NULL, 'G3DSA:3.30.450.20:FF:000476', NULL, NULL, 'Sensory box histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(185321, NULL, 'G3DSA:1.20.5.110:FF:000297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(185322, NULL, 'G3DSA:3.40.50.1380:FF:000024', NULL, NULL, 'Carbamoyl-phosphate synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185323, NULL, 'G3DSA:3.40.50.300:FF:002495', NULL, NULL, 'Cytoplasmic dynein 2 light intermediate chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(185324, NULL, 'G3DSA:3.30.230.130:FF:000025', NULL, NULL, 'Cullin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(185325, NULL, 'G3DSA:1.10.1070.11:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185326, NULL, 'G3DSA:3.40.47.10:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185327, NULL, 'G3DSA:3.30.230.120:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185328, NULL, 'G3DSA:3.40.50.300:FF:002551', NULL, NULL, 'ATP-dependent RNA helicase DHX33', NULL, NULL, NULL, NULL, NULL, 4),
(185329, NULL, 'G3DSA:2.120.10.30:FF:000320', NULL, NULL, 'Saposin B domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(185330, NULL, 'G3DSA:3.40.50.150:FF:001646', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185331, NULL, 'G3DSA:1.10.357.110:FF:000011', NULL, NULL, 'ACR044Cp', NULL, NULL, NULL, NULL, NULL, 4),
(185332, NULL, 'G3DSA:3.30.160.60:FF:002674', NULL, NULL, 'Si:dkey-7i4.21', NULL, NULL, NULL, NULL, NULL, 4),
(185333, NULL, 'G3DSA:3.40.50.720:FF:001603', NULL, NULL, 'Dihydroflavonol 4-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(185334, NULL, 'G3DSA:3.60.20.40:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185335, NULL, 'G3DSA:1.10.3520.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185336, NULL, 'G3DSA:2.10.25.10:FF:001337', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(185337, NULL, 'G3DSA:3.40.30.10:FF:000598', NULL, NULL, 'Thioredoxin (TrxA-2)', NULL, NULL, NULL, NULL, NULL, 4),
(185338, NULL, 'G3DSA:3.30.160.60:FF:000538', NULL, NULL, 'zinc finger protein 853', NULL, NULL, NULL, NULL, NULL, 4),
(185339, NULL, 'G3DSA:3.40.190.10:FF:000332', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(185340, NULL, 'G3DSA:3.30.2130.10:FF:000004', NULL, NULL, 'Cytosolic arginine sensor for mTORC1 subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(185341, NULL, 'G3DSA:3.30.70.2630:FF:000008', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(185342, NULL, 'G3DSA:3.90.550.10:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185343, NULL, 'G3DSA:1.10.580.10:FF:000039', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(185344, NULL, 'G3DSA:2.60.40.10:FF:000038', NULL, NULL, 'Neuronal cell adhesion molecule', NULL, NULL, NULL, NULL, NULL, 4),
(185345, NULL, 'G3DSA:1.20.1640.10:FF:000013', NULL, NULL, 'PaTched Related family', NULL, NULL, NULL, NULL, NULL, 4),
(185346, NULL, 'G3DSA:2.60.40.10:FF:003815', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185347, NULL, 'G3DSA:3.30.450.40:FF:000291', NULL, NULL, 'cGMP-specific 3'',5''-cyclic phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(185348, NULL, 'G3DSA:3.40.50.300:FF:000371', NULL, NULL, 'RAB40C, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(185349, NULL, 'G3DSA:2.60.40.10:FF:003759', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185350, NULL, 'G3DSA:2.60.40.10:FF:002129', NULL, NULL, 'Tyrosine-protein phosphatase 69D', NULL, NULL, NULL, NULL, NULL, 4),
(185351, NULL, 'G3DSA:3.40.50.300:FF:004642', NULL, NULL, 'BRCA1 interacting protein C-terminal helicase 1', NULL, NULL, NULL, NULL, NULL, 4),
(185352, NULL, 'G3DSA:2.130.10.10:FF:004350', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185353, NULL, 'G3DSA:2.60.40.1120:FF:000004', NULL, NULL, 'Carboxypeptidase E', NULL, NULL, NULL, NULL, NULL, 4),
(185354, NULL, 'G3DSA:1.50.40.10:FF:000249', NULL, NULL, 'Solute carrier family 25 member 10', NULL, NULL, NULL, NULL, NULL, 4),
(185355, NULL, 'G3DSA:3.40.30.10:FF:000654', NULL, NULL, 'Dolichyl-diphosphooligosaccharide--protein glycosyltransferase subunit, putative', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(185356, NULL, 'G3DSA:2.40.240.10:FF:000037', NULL, NULL, 'Putative glutaminyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(185357, NULL, 'G3DSA:3.40.50.1980:FF:000002', NULL, NULL, 'Histidinol dehydrogenase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(185358, NULL, 'G3DSA:1.10.510.10:FF:003817', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185359, NULL, 'G3DSA:2.40.160.10:FF:000036', NULL, NULL, 'GG16943', NULL, NULL, NULL, NULL, NULL, 4),
(185360, NULL, 'G3DSA:1.20.5.2950:FF:000006', NULL, NULL, 'Yop proteins translocation protein L', NULL, NULL, NULL, NULL, NULL, 4),
(185361, NULL, 'G3DSA:3.40.50.150:FF:000067', NULL, NULL, 'Salicylate/benzoate carboxyl methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(185362, NULL, 'G3DSA:1.25.40.10:FF:003573', NULL, NULL, 'Putative rrna processing protein rrp5', NULL, NULL, NULL, NULL, NULL, 4),
(185363, NULL, 'G3DSA:1.10.560.10:FF:000100', NULL, NULL, 'Chaperonin 60 subunit alpha 2 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(185364, NULL, 'G3DSA:3.40.50.450:FF:000106', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(185365, NULL, 'G3DSA:3.90.70.10:FF:000340', NULL, NULL, 'Cysteine protease 10', NULL, NULL, NULL, NULL, NULL, 4),
(185366, NULL, 'G3DSA:3.40.20.10:FF:000154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185367, NULL, 'G3DSA:1.20.58.2220:FF:000001', NULL, NULL, 'Formin-like 1, isoform CRA_c', NULL, NULL, NULL, NULL, NULL, 4),
(185368, NULL, 'G3DSA:3.40.50.300:FF:002613', NULL, NULL, 'Zgc:172075', NULL, NULL, NULL, NULL, NULL, 4),
(185369, NULL, 'G3DSA:3.40.50.720:FF:000024', NULL, NULL, 'Probable ATP-citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(185370, NULL, 'G3DSA:3.10.110.10:FF:000143', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 36', NULL, NULL, NULL, NULL, NULL, 4),
(185371, NULL, 'G3DSA:2.110.10.10:FF:000028', NULL, NULL, 'Serpentine receptor class gamma', NULL, NULL, NULL, NULL, NULL, 4),
(185372, NULL, 'G3DSA:3.40.50.1390:FF:000027', NULL, NULL, 'Putative integrase/recombinase', NULL, NULL, NULL, NULL, NULL, 4),
(185373, NULL, 'G3DSA:1.10.287.2900:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185374, NULL, 'G3DSA:2.60.40.1130:FF:000007', NULL, NULL, 'Rab geranylgeranyl transferase like protein', NULL, NULL, NULL, NULL, NULL, 4),
(185375, NULL, 'G3DSA:3.30.590.10:FF:000016', NULL, NULL, 'Glutamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(185376, NULL, 'G3DSA:2.130.10.10:FF:000016', NULL, NULL, 'Coatomer alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185377, NULL, 'G3DSA:1.20.120.1240:FF:000001', NULL, NULL, 'Dynamin 1 like', NULL, NULL, NULL, NULL, NULL, 4),
(185378, NULL, 'G3DSA:3.30.70.100:FF:000058', NULL, NULL, 'Antibiotic biosynthesis monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(185379, NULL, 'G3DSA:3.30.200.20:FF:002172', NULL, NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 62', NULL, NULL, NULL, NULL, NULL, 4),
(185380, NULL, 'G3DSA:1.10.1070.11:FF:000040', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(185381, NULL, 'G3DSA:3.30.160.60:FF:002051', NULL, NULL, 'Krueppel-like factor 17', NULL, NULL, NULL, NULL, NULL, 4),
(185382, NULL, 'G3DSA:2.60.120.290:FF:000183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185383, NULL, 'G3DSA:1.10.20.10:FF:000070', NULL, NULL, 'Nuclear transcription factor Y subunit C-3', NULL, NULL, NULL, NULL, NULL, 4),
(185384, NULL, 'G3DSA:2.60.120.380:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185385, NULL, 'G3DSA:3.30.70.260:FF:000078', NULL, NULL, 'Fis family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(185386, NULL, 'G3DSA:3.30.565.10:FF:000059', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(185387, NULL, 'G3DSA:1.20.1640.10:FF:000064', NULL, NULL, 'PaTched Related family', NULL, NULL, NULL, NULL, NULL, 4),
(185388, NULL, 'G3DSA:1.10.168.20:FF:000005', NULL, NULL, '40S ribosomal protein S8', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(185389, NULL, 'G3DSA:3.40.50.1440:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185390, NULL, 'G3DSA:3.20.20.70:FF:000077', NULL, NULL, 'Coproporphyrinogen-III oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(185391, NULL, 'G3DSA:1.10.472.80:FF:000028', NULL, NULL, 'TBC1 domain family member 7', NULL, NULL, NULL, NULL, NULL, 4),
(185392, NULL, 'G3DSA:1.20.1110.10:FF:000041', NULL, NULL, 'Putative phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(185393, NULL, 'G3DSA:1.20.1250.20:FF:001043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185394, NULL, 'G3DSA:3.40.91.60:FF:000001', NULL, NULL, 'RNA-directed RNA polymerase L', NULL, NULL, NULL, NULL, NULL, 4),
(185395, NULL, 'G3DSA:3.30.70.100:FF:000165', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185396, NULL, 'G3DSA:1.10.275.40:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185397, NULL, 'G3DSA:2.60.40.10:FF:005951', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185398, NULL, 'G3DSA:3.30.890.10:FF:000005', NULL, NULL, 'methyl-CpG-binding domain protein 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(185399, NULL, 'G3DSA:3.20.20.60:FF:000074', NULL, NULL, '4-hydroxy-2-oxovalerate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(185400, NULL, 'G3DSA:2.160.20.10:FF:000212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185401, NULL, 'G3DSA:3.40.50.12650:FF:000010', NULL, NULL, 'Interstrand crosslink repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(185402, NULL, 'G3DSA:3.30.160.60:FF:006322', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185403, NULL, 'G3DSA:1.10.246.190:FF:000004', NULL, NULL, 'Autophagy protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(185404, NULL, 'G3DSA:3.40.50.150:FF:000393', NULL, NULL, 'Regulator of secondary metabolism LaeA', NULL, NULL, NULL, NULL, NULL, 4),
(185405, NULL, 'G3DSA:2.130.10.10:FF:005980', NULL, NULL, 'Myosin heavy chain kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(185406, NULL, 'G3DSA:1.50.40.10:FF:000305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185407, NULL, 'G3DSA:1.20.930.80:FF:000006', NULL, NULL, 'DNA primase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(185408, NULL, 'G3DSA:3.40.190.80:FF:000095', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(185409, NULL, 'G3DSA:1.20.58.870:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185410, NULL, 'G3DSA:3.40.50.11320:FF:000004', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(185411, NULL, 'G3DSA:3.30.450.50:FF:000024', NULL, NULL, 'SNARE protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185412, NULL, 'G3DSA:4.10.1130.20:FF:000005', NULL, NULL, 'Cysteine and histidine-rich domain-containing protein RAR1', NULL, NULL, NULL, NULL, NULL, 4),
(185413, NULL, 'G3DSA:3.30.450.40:FF:000021', NULL, NULL, 'Anaerobic nitric oxide reductase transcription regulator NorR', NULL, NULL, NULL, NULL, NULL, 4),
(185414, NULL, 'G3DSA:4.10.1130.10:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185415, NULL, 'G3DSA:2.70.130.10:FF:000168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185416, NULL, 'G3DSA:3.30.70.1230:FF:000196', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(185417, NULL, 'G3DSA:1.10.560.10:FF:000044', NULL, NULL, 'Bardet-Biedl syndrome 12 protein', NULL, NULL, NULL, NULL, NULL, 4),
(185418, NULL, 'G3DSA:3.30.70.330:FF:003090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185419, NULL, 'G3DSA:3.90.70.10:FF:000284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185420, NULL, 'G3DSA:1.10.275.30:FF:000010', NULL, NULL, 'DEAD_2 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(185421, NULL, 'G3DSA:1.25.40.10:FF:004989', NULL, NULL, 'Intraflagellar transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(185422, NULL, 'G3DSA:2.10.25.10:FF:000674', NULL, NULL, 'Mucin-2', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(185423, NULL, 'G3DSA:3.90.550.10:FF:000287', NULL, NULL, 'Lipopolysaccharide biosynthesis glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(185424, NULL, 'G3DSA:3.90.1440.10:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185425, NULL, 'G3DSA:1.20.58.340:FF:000023', NULL, NULL, 'Magnesium transporter MRS2-E', NULL, NULL, NULL, NULL, NULL, 4),
(185426, NULL, 'G3DSA:3.30.160.60:FF:002730', NULL, NULL, 'Blast:Zinc finger protein 568', NULL, NULL, NULL, NULL, NULL, 4),
(185427, NULL, 'G3DSA:4.10.240.10:FF:000109', NULL, NULL, 'Fungal specific transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(185428, NULL, 'G3DSA:2.60.40.60:FF:000536', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185429, NULL, 'G3DSA:3.30.200.20:FF:001278', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(185430, NULL, 'G3DSA:1.10.510.10:FF:002513', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(185431, NULL, 'G3DSA:3.30.565.10:FF:000115', NULL, NULL, 'PAS domain-containing sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(185432, NULL, 'G3DSA:3.40.50.11310:FF:000001', NULL, NULL, 'Phosphonate C-P lyase system protein PhnH', NULL, NULL, NULL, NULL, NULL, 4),
(185433, NULL, 'G3DSA:3.30.420.40:FF:000249', NULL, NULL, 'Actin-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185434, NULL, 'G3DSA:2.10.25.10:FF:000781', NULL, NULL, 'Attractin', NULL, NULL, NULL, NULL, NULL, 4),
(185435, NULL, 'G3DSA:3.30.870.10:FF:000173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185436, NULL, 'G3DSA:1.10.840.10:FF:000026', NULL, NULL, 'GTP/GDP exchange factor for Rsr1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(185437, NULL, 'G3DSA:2.20.20.110:FF:000001', NULL, NULL, 'DNA repair protein complementing XP-C cells', NULL, NULL, NULL, NULL, NULL, 4),
(185438, NULL, 'G3DSA:3.30.70.1660:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185439, NULL, 'G3DSA:3.30.70.330:FF:001852', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185440, NULL, 'G3DSA:3.30.40.10:FF:001291', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185441, NULL, 'G3DSA:2.60.40.60:FF:000643', NULL, NULL, 'AGAP004166-PA', NULL, NULL, NULL, NULL, NULL, 4),
(185442, NULL, 'G3DSA:2.60.200.20:FF:000106', NULL, NULL, 'FHA domain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(185443, NULL, 'G3DSA:3.40.50.2000:FF:001054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185444, NULL, 'G3DSA:3.30.460.80:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185445, NULL, 'G3DSA:3.30.9.10:FF:000229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185446, NULL, 'G3DSA:3.30.800.10:FF:000017', NULL, NULL, '1-phosphatidylinositol 3-phosphate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(185447, NULL, 'G3DSA:3.40.50.2300:FF:001144', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185448, NULL, 'G3DSA:2.60.40.10:FF:002511', NULL, NULL, 'NCAM (Neural cell adhesion molecule) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(185449, NULL, 'G3DSA:3.40.50.200:FF:000048', NULL, NULL, 'Peptidase S8 and S53 subtilisin kexin sedolisin', NULL, NULL, NULL, NULL, NULL, 4),
(185450, NULL, 'G3DSA:3.40.50.10140:FF:000038', NULL, NULL, 'interleukin-18 receptor 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(185451, NULL, 'G3DSA:3.60.10.10:FF:000377', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185452, NULL, 'G3DSA:3.40.50.10130:FF:000035', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(185453, NULL, 'G3DSA:2.40.50.100:FF:000005', NULL, NULL, 'Acetyl-CoA carboxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(185454, NULL, 'G3DSA:2.130.10.10:FF:003568', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(185455, NULL, 'G3DSA:3.90.230.10:FF:000033', NULL, NULL, 'xaa-Pro dipeptidase isoform X2', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(185456, NULL, 'G3DSA:3.30.40.100:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185457, NULL, 'G3DSA:1.25.10.10:FF:002166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185458, NULL, 'G3DSA:1.25.10.10:FF:001733', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(185459, NULL, 'G3DSA:1.10.8.60:FF:000257', NULL, NULL, 'Transitional endoplasmic reticulum ATPase TER94-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(185460, NULL, 'G3DSA:3.40.525.10:FF:000010', NULL, NULL, 'motile sperm domain-containing protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(185461, NULL, 'G3DSA:1.20.58.2220:FF:000052', NULL, NULL, 'Dishevelled-associated activator of morphogenesis 1a', NULL, NULL, NULL, NULL, NULL, 4),
(185462, NULL, 'G3DSA:3.40.630.30:FF:000530', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(185463, NULL, 'G3DSA:3.10.20.90:FF:000555', NULL, NULL, 'Cdc24', NULL, NULL, NULL, NULL, NULL, 4),
(185464, NULL, 'G3DSA:2.40.440.10:FF:000018', NULL, NULL, 'Putative L,D-transpeptidase YciB', NULL, NULL, NULL, NULL, NULL, 4),
(185465, NULL, 'G3DSA:1.20.58.860:FF:000004', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase calypso', NULL, NULL, NULL, NULL, NULL, 4),
(185466, NULL, 'G3DSA:3.90.550.10:FF:000517', NULL, NULL, 'Glycosyl transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(185467, NULL, 'G3DSA:2.10.25.10:FF:000399', NULL, NULL, 'Laminin subunit gamma 2', NULL, NULL, NULL, NULL, NULL, 4),
(185468, NULL, 'G3DSA:3.40.630.30:FF:000586', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185469, NULL, 'G3DSA:3.30.160.60:FF:000257', NULL, NULL, 'ZXD family zinc finger C', NULL, NULL, NULL, NULL, NULL, 4),
(185470, NULL, 'G3DSA:1.25.10.10:FF:002222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185471, NULL, 'G3DSA:1.10.10.60:FF:000409', NULL, NULL, 'Sigma-54-dependent Fis family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(185472, NULL, 'G3DSA:3.30.9.10:FF:000274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185473, NULL, 'G3DSA:3.30.160.60:FF:003978', NULL, NULL, 'GD17432', NULL, NULL, NULL, NULL, NULL, 4),
(185474, NULL, 'G3DSA:2.120.10.30:FF:000601', NULL, NULL, 'Dipeptidyl-peptidase 5', NULL, NULL, NULL, NULL, NULL, 4),
(185475, NULL, 'G3DSA:3.30.70.20:FF:000014', NULL, NULL, 'Cytochrome c nitrite reductase, Fe-S protein', NULL, NULL, NULL, NULL, NULL, 4),
(185476, NULL, 'G3DSA:3.30.505.10:FF:000230', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185477, NULL, 'G3DSA:3.40.50.1440:FF:000008', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(185478, NULL, 'G3DSA:3.30.70.330:FF:001796', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185479, NULL, 'G3DSA:3.30.450.40:FF:000072', NULL, NULL, 'PAS domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(185480, NULL, 'G3DSA:3.10.110.10:FF:000036', NULL, NULL, 'ubiquitin-conjugating enzyme E2Q-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(185481, NULL, 'G3DSA:2.30.29.30:FF:001172', NULL, NULL, 'Meiotically up-regulated gene 183 protein', NULL, NULL, NULL, NULL, NULL, 4),
(185482, NULL, 'G3DSA:1.25.10.10:FF:001677', NULL, NULL, 'Nipped-B protein', NULL, NULL, NULL, NULL, NULL, 4),
(185483, NULL, 'G3DSA:2.40.420.20:FF:000026', NULL, NULL, 'Efflux transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(185484, NULL, 'G3DSA:3.40.50.1820:FF:001724', NULL, NULL, 'Serine carboxypeptidase-like 33', NULL, NULL, NULL, NULL, NULL, 4),
(185485, NULL, 'G3DSA:3.30.830.10:FF:000171', NULL, NULL, 'Axl1p', NULL, NULL, NULL, NULL, NULL, 4),
(185486, NULL, 'G3DSA:1.10.8.60:FF:000369', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185487, NULL, 'G3DSA:3.30.70.330:FF:001577', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185488, NULL, 'G3DSA:3.30.160.60:FF:006092', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185489, NULL, 'G3DSA:3.20.20.70:FF:000818', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(185490, NULL, 'G3DSA:3.30.1360.120:FF:000061', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(185491, NULL, 'G3DSA:3.30.1330.10:FF:000036', NULL, NULL, 'Selenide, water dikinase', NULL, NULL, NULL, NULL, NULL, 4),
(185492, NULL, 'G3DSA:1.10.238.10:FF:000407', NULL, NULL, 'Voltage-gated Ion Channel (VIC) Superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(185493, NULL, 'G3DSA:3.30.710.10:FF:000010', NULL, NULL, 'Potassium voltage-gated channel subfamily B member', NULL, NULL, NULL, NULL, NULL, 4),
(185494, NULL, 'G3DSA:3.40.640.10:FF:000075', NULL, NULL, 'Maltose regulon modulator MalY', NULL, NULL, NULL, NULL, NULL, 4),
(185495, NULL, 'G3DSA:3.30.50.10:FF:000004', NULL, NULL, 'Retinoic acid receptor beta isoform', NULL, NULL, NULL, NULL, NULL, 4),
(185496, NULL, 'G3DSA:2.60.40.60:FF:001099', NULL, NULL, 'Cadherin 31', NULL, NULL, NULL, NULL, NULL, 4),
(185497, NULL, 'G3DSA:3.40.50.300:FF:006036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185498, NULL, 'G3DSA:3.30.70.1230:FF:000252', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185499, NULL, 'G3DSA:1.10.10.60:FF:000005', NULL, NULL, 'POU domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(185500, NULL, 'G3DSA:3.40.970.10:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185501, NULL, 'G3DSA:1.20.1280.50:FF:000250', NULL, NULL, 'F-box/LRR-repeat/kelch-repeat protein At1g09650', NULL, NULL, NULL, NULL, NULL, 4),
(185502, NULL, 'G3DSA:2.60.40.790:FF:000076', NULL, NULL, '15.4 kDa class V heat shock protein', NULL, NULL, NULL, NULL, NULL, 4),
(185503, NULL, 'G3DSA:3.40.1350.10:FF:000035', NULL, NULL, 'tRNA-splicing endonuclease subunit Sen15', NULL, NULL, NULL, NULL, NULL, 4),
(185504, NULL, 'G3DSA:2.40.70.10:FF:000092', NULL, NULL, 'Aspartic endopeptidase (AP1)', NULL, NULL, NULL, NULL, NULL, 4),
(185505, NULL, 'G3DSA:1.10.287.490:FF:000001', NULL, NULL, 'Surfactin synthase subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(185506, NULL, 'G3DSA:3.30.160.60:FF:002781', NULL, NULL, 'PR/SET domain 2', NULL, NULL, NULL, NULL, NULL, 4),
(185507, NULL, 'G3DSA:2.60.120.200:FF:000032', NULL, NULL, 'pikachurin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(185508, NULL, 'G3DSA:1.25.40.10:FF:002224', NULL, NULL, 'Alpha-snap', NULL, NULL, NULL, NULL, NULL, 4),
(185509, NULL, 'G3DSA:3.40.50.150:FF:000281', NULL, NULL, 'Thiocyanate methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(185510, NULL, 'G3DSA:2.60.40.640:FF:000059', NULL, NULL, 'Vacuolar protein sorting-associated protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(185511, NULL, 'G3DSA:3.40.50.980:FF:000023', NULL, NULL, 'Putative peptide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(185512, NULL, 'G3DSA:2.160.20.10:FF:000100', NULL, NULL, 'Right handed beta helix region', NULL, NULL, NULL, NULL, NULL, 4),
(185513, NULL, 'G3DSA:1.20.1280.140:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185514, NULL, 'G3DSA:2.130.10.10:FF:002107', NULL, NULL, 'POC1 centriolar protein homolog isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(185515, NULL, 'G3DSA:2.60.40.10:FF:003708', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185516, NULL, 'G3DSA:2.60.40.10:FF:004372', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185517, NULL, 'G3DSA:3.30.160.60:FF:001887', NULL, NULL, 'Zinc finger protein 398', NULL, NULL, NULL, NULL, NULL, 4),
(185518, NULL, 'G3DSA:2.40.50.140:FF:001063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185519, NULL, 'G3DSA:1.10.10.430:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(185520, NULL, 'G3DSA:1.20.58.340:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185521, NULL, 'G3DSA:2.60.40.60:FF:000862', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185522, NULL, 'G3DSA:3.40.50.300:FF:000634', NULL, NULL, 'Molybdenum import ATP-binding protein ModC', NULL, NULL, NULL, NULL, NULL, 4),
(185523, NULL, 'G3DSA:3.40.250.10:FF:000096', NULL, NULL, 'Adenylyltransferase and sulfurtransferase uba4', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(185524, NULL, 'G3DSA:3.40.50.1820:FF:001494', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185525, NULL, 'G3DSA:3.80.10.10:FF:001556', NULL, NULL, 'Geranylgeranyl transferase type-2 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(185526, NULL, 'G3DSA:2.120.10.30:FF:000101', NULL, NULL, 'Low-density lipoprotein receptor-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(185527, NULL, 'G3DSA:3.70.10.10:FF:000062', NULL, NULL, 'DNA polymerase sliding clamp 3', NULL, NULL, NULL, NULL, NULL, 4),
(185528, NULL, 'G3DSA:2.60.40.60:FF:000317', NULL, NULL, 'Protocadherin beta-17', NULL, NULL, NULL, NULL, NULL, 4),
(185529, NULL, 'G3DSA:3.90.1350.10:FF:000001', NULL, NULL, 'Exotoxin A', NULL, NULL, NULL, NULL, NULL, 4),
(185530, NULL, 'G3DSA:3.30.1330.20:FF:000039', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(185531, NULL, 'G3DSA:3.30.565.10:FF:000273', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(185532, NULL, 'G3DSA:1.10.10.440:FF:000014', NULL, NULL, 'rho GTPase-activating protein 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(185533, NULL, 'G3DSA:3.40.50.720:FF:001373', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase, putative (SerA-2)', NULL, NULL, NULL, NULL, NULL, 4),
(185534, NULL, 'G3DSA:2.30.30.1020:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185535, NULL, 'G3DSA:3.30.870.10:FF:000061', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(185536, NULL, 'G3DSA:1.20.5.170:FF:000186', NULL, NULL, 'Basic-leucine zipper (BZIP) transcription factor family protein', NULL, NULL, NULL, NULL, NULL, 4),
(185537, NULL, 'G3DSA:2.70.130.10:FF:000117', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185538, NULL, 'G3DSA:3.80.10.10:FF:002916', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185539, NULL, 'G3DSA:1.20.144.10:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185540, NULL, 'G3DSA:1.10.472.10:FF:000440', NULL, NULL, 'Cya-1', NULL, NULL, NULL, NULL, NULL, 4),
(185541, NULL, 'G3DSA:4.10.400.10:FF:000263', NULL, NULL, 'LDL receptor repeat-containing protein egg-1', NULL, NULL, NULL, NULL, NULL, 4),
(185542, NULL, 'G3DSA:1.10.287.110:FF:000051', NULL, NULL, 'Molecular chaperone DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(185543, NULL, 'G3DSA:1.20.1250.20:FF:000879', NULL, NULL, 'Putative alternative sulfate transporter protein', NULL, NULL, NULL, NULL, NULL, 4),
(185544, NULL, 'G3DSA:2.120.10.30:FF:000371', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(185545, NULL, 'G3DSA:1.20.58.1040:FF:000012', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(185546, NULL, 'G3DSA:2.60.40.10:FF:002281', NULL, NULL, 'Protein sidekick homolog', NULL, NULL, NULL, NULL, NULL, 4),
(185547, NULL, 'G3DSA:3.30.450.40:FF:000133', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(185548, NULL, 'G3DSA:2.30.29.150:FF:000005', NULL, NULL, 'FACT complex subunit SPT16', NULL, NULL, NULL, NULL, NULL, 4),
(185549, NULL, 'G3DSA:3.40.50.720:FF:000884', NULL, NULL, 'Formate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(185550, NULL, 'G3DSA:3.30.70.80:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185551, NULL, 'G3DSA:3.30.420.40:FF:000137', NULL, NULL, 'Actin-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(185552, NULL, 'G3DSA:3.80.20.20:FF:000020', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(185553, NULL, 'G3DSA:3.40.190.10:FF:000113', NULL, NULL, 'Amino acid ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(185554, NULL, 'G3DSA:3.40.50.150:FF:000342', NULL, NULL, 'Probable methyltransferase PMT19', NULL, NULL, NULL, NULL, NULL, 4),
(185555, NULL, 'G3DSA:2.90.10.10:FF:000018', NULL, NULL, 'EP1-like glycoprotein 2', NULL, NULL, NULL, NULL, NULL, 4),
(185556, NULL, 'G3DSA:3.30.70.3150:FF:000002', NULL, NULL, 'Translation initiation factor eIF-5', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(185557, NULL, 'G3DSA:3.90.260.10:FF:000017', NULL, NULL, 'Xeroderma pigmentosum, complementation group C', NULL, NULL, NULL, NULL, NULL, 4),
(185558, NULL, 'G3DSA:3.10.20.90:FF:000881', NULL, NULL, 'Homocysteine-inducible, endoplasmic reticulum stress-inducible, ubiquitin-like domain member 1', NULL, NULL, NULL, NULL, NULL, 4),
(185559, NULL, 'G3DSA:3.40.50.300:FF:002383', NULL, NULL, 'ABC transporter G family member 8', NULL, NULL, NULL, NULL, NULL, 4),
(185560, NULL, 'G3DSA:3.90.1430.10:FF:000002', NULL, NULL, 'Elongation factor like GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(185561, NULL, 'G3DSA:3.40.33.10:FF:000077', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(185562, NULL, 'G3DSA:3.30.530.20:FF:000072', NULL, NULL, 'BnaC09g47310D protein', NULL, NULL, NULL, NULL, NULL, 4),
(185563, NULL, 'G3DSA:3.40.50.300:FF:000819', NULL, NULL, 'ATP dependent RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185564, NULL, 'G3DSA:3.30.160.800:FF:000001', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(185565, NULL, 'G3DSA:3.40.1170.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185566, NULL, 'G3DSA:2.10.25.10:FF:000904', NULL, NULL, 'LAMinin related. See also lmb', NULL, NULL, NULL, NULL, NULL, 4),
(185567, NULL, 'G3DSA:2.30.30.40:FF:000115', NULL, NULL, 'Small G protein signaling modulator 3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(185568, NULL, 'G3DSA:3.30.60.30:FF:000011', NULL, NULL, 'reversion-inducing cysteine-rich protein with Kazal motifs isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(185569, NULL, 'G3DSA:1.20.1310.10:FF:000022', NULL, NULL, 'Cullin-2 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(185570, NULL, 'G3DSA:2.60.40.10:FF:005732', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185571, NULL, 'G3DSA:3.30.160.810:FF:000004', NULL, NULL, '50S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(185572, NULL, 'G3DSA:3.10.150.10:FF:000033', NULL, NULL, 'Beta sliding clamp', NULL, NULL, NULL, NULL, NULL, 4),
(185573, NULL, 'G3DSA:1.20.58.340:FF:000028', NULL, NULL, 'Magnesium transport protein CorA', NULL, NULL, NULL, NULL, NULL, 4),
(185574, NULL, 'G3DSA:3.40.30.10:FF:000486', NULL, NULL, 'Uncharacterized monothiol glutaredoxin F10D7.3', NULL, NULL, NULL, NULL, NULL, 4),
(185575, NULL, 'G3DSA:1.20.1640.10:FF:000069', NULL, NULL, 'Transporter, AcrB/D/F family', NULL, NULL, NULL, NULL, NULL, 4),
(185576, NULL, 'G3DSA:2.130.10.10:FF:001770', NULL, NULL, 'GG22870', NULL, NULL, NULL, NULL, NULL, 4),
(185577, NULL, 'G3DSA:3.30.1610.10:FF:000018', NULL, NULL, 'Nucleoporin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185578, NULL, 'G3DSA:1.20.58.390:FF:000228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185579, NULL, 'G3DSA:1.10.579.10:FF:000013', NULL, NULL, 'DNA photolyase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185580, NULL, 'G3DSA:2.60.34.10:FF:000041', NULL, NULL, 'Endoplasmic reticulum chaperone BiP', NULL, NULL, NULL, NULL, NULL, 4),
(185581, NULL, 'G3DSA:1.10.1200.10:FF:000090', NULL, NULL, 'Nonribosomal peptide synthetase 6', NULL, NULL, NULL, NULL, NULL, 4),
(185582, NULL, 'G3DSA:3.40.30.10:FF:000828', NULL, NULL, 'P4HB isoform 13', NULL, NULL, NULL, NULL, NULL, 4),
(185583, NULL, 'G3DSA:1.20.58.80:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185584, NULL, 'G3DSA:2.60.120.10:FF:000395', NULL, NULL, 'cAMP-binding domain of CRP or a regulatory subunit of cAMP-dependent protein kinases', NULL, NULL, NULL, NULL, NULL, 4),
(185585, NULL, 'G3DSA:3.40.470.10:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185586, NULL, 'G3DSA:1.25.40.70:FF:000078', NULL, NULL, 'Acyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(185587, NULL, 'G3DSA:2.30.30.30:FF:000112', NULL, NULL, '60S ribosomal protein RML2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(185588, NULL, 'G3DSA:3.40.30.10:FF:000542', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(185589, NULL, 'G3DSA:1.50.40.10:FF:000075', NULL, NULL, 'Nicotinamide adenine dinucleotide transporter 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(185590, NULL, 'G3DSA:3.30.200.20:FF:000255', NULL, NULL, 'serine/threonine-protein kinase Chk2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(185591, NULL, 'G3DSA:2.30.29.30:FF:001121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185592, NULL, 'G3DSA:3.30.40.10:FF:001813', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185593, NULL, 'G3DSA:3.10.110.10:FF:000031', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 22', NULL, NULL, NULL, NULL, NULL, 4),
(185594, NULL, 'G3DSA:1.10.20.10:FF:000300', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185595, NULL, 'G3DSA:1.20.1600.10:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185596, NULL, 'G3DSA:1.25.40.10:FF:003685', NULL, NULL, 'Pre-mRNA-splicing factor SYF1', NULL, NULL, NULL, NULL, NULL, 4),
(185597, NULL, 'G3DSA:3.40.50.11580:FF:000003', NULL, NULL, 'Polyprotein ORF1ab', NULL, NULL, NULL, NULL, NULL, 4),
(185598, NULL, 'G3DSA:1.10.10.10:FF:000423', NULL, NULL, 'Transcriptional regulator ArsR', NULL, NULL, NULL, NULL, NULL, 4),
(185599, NULL, 'G3DSA:3.40.50.300:FF:002725', NULL, NULL, 'GPN-loop GTPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(185600, NULL, 'G3DSA:3.80.10.10:FF:001551', NULL, NULL, 'Protein ARABIDILLO 2', NULL, NULL, NULL, NULL, NULL, 4),
(185601, NULL, 'G3DSA:3.40.50.150:FF:000960', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185602, NULL, 'G3DSA:2.60.40.60:FF:000025', NULL, NULL, 'Calsyntenin 1', NULL, NULL, NULL, NULL, NULL, 4),
(185603, NULL, 'G3DSA:3.90.70.10:FF:000514', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(185604, NULL, 'G3DSA:3.40.50.300:FF:004530', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(185605, NULL, 'G3DSA:2.10.22.10:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185606, NULL, 'G3DSA:3.30.930.10:FF:000408', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185607, NULL, 'G3DSA:1.10.10.60:FF:001079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185608, NULL, 'G3DSA:1.10.30.10:FF:000076', NULL, NULL, 'Axial regulator YABBY 4', NULL, NULL, NULL, NULL, NULL, 4),
(185609, NULL, 'G3DSA:3.40.720.10:FF:000076', NULL, NULL, 'Phosphoglycerol transferase MdoB-like protein, alkaline phosphatase superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(185610, NULL, 'G3DSA:3.40.850.10:FF:000299', NULL, NULL, 'Unconventional myosin-XIX', NULL, NULL, NULL, NULL, NULL, 4),
(185611, NULL, 'G3DSA:3.40.50.300:FF:002618', NULL, NULL, 'PAPS-dependent sulfotransferase Stf3', NULL, NULL, NULL, NULL, NULL, 4),
(185612, NULL, 'G3DSA:1.25.40.10:FF:000700', NULL, NULL, 'Soluble n-ethylmaleimide sensitive factor,putative', NULL, NULL, NULL, NULL, NULL, 4),
(185613, NULL, 'G3DSA:3.40.50.300:FF:007907', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185614, NULL, 'G3DSA:3.30.160.60:FF:000813', NULL, NULL, 'ras-responsive element-binding protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(185615, NULL, 'G3DSA:3.90.190.10:FF:000478', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185616, NULL, 'G3DSA:3.30.1780.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185617, NULL, 'G3DSA:1.20.1270.60:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185618, NULL, 'G3DSA:1.10.20.10:FF:000244', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185619, NULL, 'G3DSA:2.110.10.10:FF:000023', NULL, NULL, 'Matrix metalloproteinase-C', NULL, NULL, NULL, NULL, NULL, 4),
(185620, NULL, 'G3DSA:2.30.30.770:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185621, NULL, 'G3DSA:3.30.2160.10:FF:000006', NULL, NULL, 'E3 ubiquitin-protein ligase UBR5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(185622, NULL, 'G3DSA:3.40.50.300:FF:008453', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185623, NULL, 'G3DSA:1.25.40.20:FF:001889', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(185624, NULL, 'G3DSA:1.20.120.350:FF:000233', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185625, NULL, 'G3DSA:2.60.120.1190:FF:000020', NULL, NULL, 'RE47056p', NULL, NULL, NULL, NULL, NULL, 4),
(185626, NULL, 'G3DSA:3.30.9.10:FF:000055', NULL, NULL, 'D-amino acid dehydrogenase small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(185627, NULL, 'G3DSA:1.25.40.20:FF:000703', NULL, NULL, 'Protein fem-1 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(185628, NULL, 'G3DSA:1.20.1250.20:FF:001099', NULL, NULL, 'Solute carrier family 2 (facilitated glucose transporter), member 6', NULL, NULL, NULL, NULL, NULL, 4),
(185629, NULL, 'G3DSA:2.130.10.10:FF:002219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185630, NULL, 'G3DSA:2.40.50.100:FF:000112', NULL, NULL, 'ABC transporter related protein', NULL, NULL, NULL, NULL, NULL, 4),
(185631, NULL, 'G3DSA:3.40.50.720:FF:001047', NULL, NULL, 'UDP-N-acetylmuramoylalanine--D-glutamate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(185632, NULL, 'G3DSA:3.40.50.2300:FF:001149', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185633, NULL, 'G3DSA:3.40.1090.10:FF:000043', NULL, NULL, 'Triacylglycerol lipase SDP1', NULL, NULL, NULL, NULL, NULL, 4),
(185634, NULL, 'G3DSA:3.90.550.50:FF:000220', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(185635, NULL, 'G3DSA:3.40.50.300:FF:004182', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(185636, NULL, 'G3DSA:3.80.10.10:FF:001500', NULL, NULL, 'Leucine-rich repeat-containing protein let-4', NULL, NULL, NULL, NULL, NULL, 4),
(185637, NULL, 'G3DSA:1.20.120.230:FF:000040', NULL, NULL, 'TaLiN', NULL, NULL, NULL, NULL, NULL, 4),
(185638, NULL, 'G3DSA:2.120.10.30:FF:000045', NULL, NULL, 'Blast:Protein yellow', NULL, NULL, NULL, NULL, NULL, 4),
(185639, NULL, 'G3DSA:2.40.50.100:FF:000056', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(185640, NULL, 'G3DSA:3.40.630.10:FF:000142', NULL, NULL, 'Acetylornithine deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(185641, NULL, 'G3DSA:3.30.2000.30:FF:000001', NULL, NULL, 'Tail completion protein gp17', NULL, NULL, NULL, NULL, NULL, 4),
(185642, NULL, 'G3DSA:3.40.80.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185643, NULL, 'G3DSA:3.30.360.10:FF:000033', NULL, NULL, 'Myo-Inositol-1-Phosphate Synthase', NULL, NULL, NULL, NULL, NULL, 4),
(185644, NULL, 'G3DSA:2.30.30.40:FF:000059', NULL, NULL, 'SH3 and PX domain-containing protein 2A', NULL, NULL, NULL, NULL, NULL, 4),
(185645, NULL, 'G3DSA:2.30.30.30:FF:000056', NULL, NULL, '50S ribosomal subunit L24', NULL, NULL, NULL, NULL, NULL, 4),
(185646, NULL, 'G3DSA:2.70.170.10:FF:000058', NULL, NULL, 'Ligand-gated chloride channel', NULL, NULL, NULL, NULL, NULL, 4),
(185647, NULL, 'G3DSA:1.25.10.10:FF:003419', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185648, NULL, 'G3DSA:4.10.280.10:FF:000095', NULL, NULL, 'Basic helix-loop-helix family protein', NULL, NULL, NULL, NULL, NULL, 4),
(185649, NULL, 'G3DSA:2.40.70.10:FF:000322', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185650, NULL, 'G3DSA:2.10.25.10:FF:000955', NULL, NULL, 'Neurogenic locus notch homolog protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(185651, NULL, 'G3DSA:3.40.50.300:FF:000078', NULL, NULL, 'Elongation factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(185652, NULL, 'G3DSA:3.30.70.1350:FF:000001', NULL, NULL, 'Metal tolerance protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(185653, NULL, 'G3DSA:3.60.21.10:FF:000166', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(185654, NULL, 'G3DSA:3.40.640.10:FF:000024', NULL, NULL, 'Kynurenine--oxoglutarate transaminase 3', NULL, NULL, NULL, NULL, NULL, 4),
(185655, NULL, 'G3DSA:3.40.50.300:FF:006654', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185656, NULL, 'G3DSA:3.30.1740.10:FF:000028', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(185657, NULL, 'G3DSA:1.20.1310.20:FF:000025', NULL, NULL, 'Erythrocyte membrane protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(185658, NULL, 'G3DSA:3.30.40.10:FF:000919', NULL, NULL, 'Bccti6', NULL, NULL, NULL, NULL, NULL, 4),
(185659, NULL, 'G3DSA:1.20.120.1450:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185660, NULL, 'G3DSA:1.25.40.10:FF:003298', NULL, NULL, 'Os09g0555400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(185661, NULL, 'G3DSA:1.20.1250.20:FF:001217', NULL, NULL, 'Major facilitator superfamily domain-containing protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(185662, NULL, 'G3DSA:2.60.120.330:FF:000009', NULL, NULL, 'Flavonol synthase', NULL, NULL, NULL, NULL, NULL, 4),
(185663, NULL, 'G3DSA:3.40.50.1820:FF:000201', NULL, NULL, 'Alpha/beta fold hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(185664, NULL, 'G3DSA:3.80.10.10:FF:003349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185665, NULL, 'G3DSA:3.20.20.80:FF:000299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185666, NULL, 'G3DSA:1.25.40.10:FF:003247', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(185667, NULL, 'G3DSA:3.20.20.70:FF:000296', NULL, NULL, 'N-(5''-phosphoribosyl)anthranilate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(185668, NULL, 'G3DSA:3.40.50.10190:FF:000238', NULL, NULL, 'Cell wall chitin catabolism-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185669, NULL, 'G3DSA:2.60.40.10:FF:002803', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(185670, NULL, 'G3DSA:4.10.1240.10:FF:000067', NULL, NULL, 'Adhesion G protein-coupled receptor L3', NULL, NULL, NULL, NULL, NULL, 4),
(185671, NULL, 'G3DSA:3.10.20.90:FF:000611', NULL, NULL, 'Serine/threonine protein kinase wnk1', NULL, NULL, NULL, NULL, NULL, 4),
(185672, NULL, 'G3DSA:1.10.510.10:FF:002457', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185673, NULL, 'G3DSA:3.20.20.70:FF:000644', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185674, NULL, 'G3DSA:1.20.120.350:FF:000014', NULL, NULL, 'Potassium channel, voltage-gated Shaw-related subfamily C, member 4', NULL, NULL, NULL, NULL, NULL, 4),
(185675, NULL, 'G3DSA:3.40.720.10:FF:000295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185676, NULL, 'G3DSA:2.60.120.310:FF:000003', NULL, NULL, 'Dopamine beta-hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(185677, NULL, 'G3DSA:2.70.130.10:FF:000112', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185678, NULL, 'G3DSA:3.30.70.890:FF:000087', NULL, NULL, 'Isopentenyl-diphosphate Delta-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(185679, NULL, 'G3DSA:3.10.20.90:FF:000443', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 7', NULL, NULL, NULL, NULL, NULL, 4),
(185680, NULL, 'G3DSA:4.10.240.10:FF:000093', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(185681, NULL, 'G3DSA:1.10.8.10:FF:000057', NULL, NULL, 'Vacuolar protein sorting 13 homolog D', NULL, NULL, NULL, NULL, NULL, 4),
(185682, NULL, 'G3DSA:3.40.630.30:FF:000642', NULL, NULL, 'Gll0091 protein', NULL, NULL, NULL, NULL, NULL, 4),
(185683, NULL, 'G3DSA:1.20.5.90:FF:000001', NULL, NULL, 'Protein Vpr', NULL, NULL, NULL, NULL, NULL, 4),
(185684, NULL, 'G3DSA:2.60.200.20:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185685, NULL, 'G3DSA:2.60.40.150:FF:000570', NULL, NULL, 'Extended synaptotagmin-like protein 2b', NULL, NULL, NULL, NULL, NULL, 4),
(185686, NULL, 'G3DSA:3.40.630.30:FF:000474', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185687, NULL, 'G3DSA:3.80.10.10:FF:000657', NULL, NULL, 'Leucine-rich repeat-containing protein 69', NULL, NULL, NULL, NULL, NULL, 4),
(185688, NULL, 'G3DSA:1.10.8.1050:FF:000001', NULL, NULL, 'Antitoxin VbhA', NULL, NULL, NULL, NULL, NULL, 4),
(185689, NULL, 'G3DSA:3.40.50.300:FF:007958', NULL, NULL, 'Lon peptidase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(185690, NULL, 'G3DSA:3.90.470.20:FF:000020', NULL, NULL, '4phosphopantetheinyl transferase EC 278', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(185691, NULL, 'G3DSA:1.10.30.10:FF:000183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185692, NULL, 'G3DSA:2.60.120.200:FF:000549', NULL, NULL, 'Trans-sialidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185693, NULL, 'G3DSA:3.40.50.300:FF:006328', NULL, NULL, 'Cell division control protein 48 homolog C', NULL, NULL, NULL, NULL, NULL, 4),
(185694, NULL, 'G3DSA:3.30.60.30:FF:000230', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(185695, NULL, 'G3DSA:3.90.980.20:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185696, NULL, 'G3DSA:3.90.550.10:FF:000231', NULL, NULL, 'Acylneuraminate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(185697, NULL, 'G3DSA:1.10.3720.10:FF:000022', NULL, NULL, 'Glutathione ABC transporter permease GsiD', NULL, NULL, NULL, NULL, NULL, 4),
(185698, NULL, 'G3DSA:2.70.170.10:FF:000114', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(185699, NULL, 'G3DSA:1.10.510.10:FF:004306', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185700, NULL, 'G3DSA:1.10.510.10:FF:000035', NULL, NULL, 'Putative receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(185701, NULL, 'G3DSA:2.170.270.10:FF:000019', NULL, NULL, 'PR domain zinc finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(185702, NULL, 'G3DSA:1.25.40.10:FF:000425', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g26540', NULL, NULL, NULL, NULL, NULL, 4),
(185703, NULL, 'G3DSA:2.30.130.40:FF:000017', NULL, NULL, 'ATP-dependent protease La (LON) domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(185704, NULL, 'G3DSA:3.40.30.10:FF:000216', NULL, NULL, 'Putative Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(185705, NULL, 'G3DSA:3.30.830.10:FF:000176', NULL, NULL, 'Mitochondrial processing peptidase alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185706, NULL, 'G3DSA:3.40.50.150:FF:000286', NULL, NULL, 'Leucine carboxyl methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(185707, NULL, 'G3DSA:3.30.450.40:FF:000077', NULL, NULL, 'PTS-dependent dihydroxyacetone kinase operon regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(185708, NULL, 'G3DSA:2.60.120.320:FF:000006', NULL, NULL, 'Thiamine pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(185709, NULL, 'G3DSA:3.30.420.40:FF:000305', NULL, NULL, 'Exopolyphosphatase 2', NULL, NULL, NULL, NULL, NULL, 4),
(185710, NULL, 'G3DSA:3.30.160.60:FF:003686', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185711, NULL, 'G3DSA:3.10.28.10:FF:000015', NULL, NULL, 'Laglidadg endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(185712, NULL, 'G3DSA:1.25.40.20:FF:000428', NULL, NULL, 'Ankyrin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(185713, NULL, 'G3DSA:1.20.58.530:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185714, NULL, 'G3DSA:3.30.497.10:FF:000013', NULL, NULL, 'Serpin family G member 1', NULL, NULL, NULL, NULL, NULL, 4),
(185715, NULL, 'G3DSA:3.40.50.1000:FF:000523', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185716, NULL, 'G3DSA:3.30.2410.10:FF:000037', NULL, NULL, 'E3 ubiquitin-protein ligase pub2', NULL, NULL, NULL, NULL, NULL, 4),
(185717, NULL, 'G3DSA:3.30.70.100:FF:000053', NULL, NULL, 'Antibiotic biosynthesis monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(185718, NULL, 'G3DSA:3.90.1410.10:FF:000006', NULL, NULL, 'Ribulose-1,5 bisphosphate carboxylase/oxygenase large subunit N-methyltransferase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(185719, NULL, 'G3DSA:1.20.120.980:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185720, NULL, 'G3DSA:3.40.1350.10:FF:000030', NULL, NULL, 'tRNA-splicing endonuclease subunit Sen2', NULL, NULL, NULL, NULL, NULL, 4),
(185721, NULL, 'G3DSA:1.20.1440.340:FF:000006', NULL, NULL, 'Galactokinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(185722, NULL, 'G3DSA:3.90.70.10:FF:000733', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185723, NULL, 'G3DSA:3.30.40.10:FF:001139', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(185724, NULL, 'G3DSA:1.20.1110.10:FF:000097', NULL, NULL, 'Calcium-transporting ATPase 9 plasma membrane-type', NULL, NULL, NULL, NULL, NULL, 4),
(185725, NULL, 'G3DSA:3.90.1110.10:FF:000017', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(185726, NULL, 'G3DSA:2.60.120.10:FF:000670', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185727, NULL, 'G3DSA:2.20.70.10:FF:000036', NULL, NULL, 'Phosphorylated CTD-interacting factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(185728, NULL, 'G3DSA:2.60.40.1110:FF:000001', NULL, NULL, 'cyclin-G-associated kinase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(185729, NULL, 'G3DSA:3.30.70.330:FF:001285', NULL, NULL, 'Minichromosome maintenance complex component 3-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(185730, NULL, 'G3DSA:3.30.505.10:FF:000174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185731, NULL, 'G3DSA:1.10.238.10:FF:000733', NULL, NULL, 'GM10264', NULL, NULL, NULL, NULL, NULL, 4),
(185732, NULL, 'G3DSA:3.40.950.10:FF:000008', NULL, NULL, 'Nuclear prelamin A recognition factor', NULL, NULL, NULL, NULL, NULL, 4),
(185733, NULL, 'G3DSA:2.170.120.12:FF:000005', NULL, NULL, 'DNA-directed RNA polymerase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(185734, NULL, 'G3DSA:1.20.58.420:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185735, NULL, 'G3DSA:1.20.5.170:FF:000293', NULL, NULL, 'cAMP-responsive element modulator a', NULL, NULL, NULL, NULL, NULL, 4),
(185736, NULL, 'G3DSA:3.10.330.20:FF:000022', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(185737, NULL, 'G3DSA:3.40.720.10:FF:000368', NULL, NULL, 'Protein CBG04200', NULL, NULL, NULL, NULL, NULL, 4),
(185738, NULL, 'G3DSA:3.30.360.10:FF:000084', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase GAPCP1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(185739, NULL, 'G3DSA:3.30.160.60:FF:002455', NULL, NULL, 'FI03704p', NULL, NULL, NULL, NULL, NULL, 4),
(185740, NULL, 'G3DSA:3.40.30.10:FF:001110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185741, NULL, 'G3DSA:1.50.40.10:FF:000417', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185742, NULL, 'G3DSA:1.10.30.10:FF:000132', NULL, NULL, 'HMG box protein, putative (AFU_orthologue AFUA_1G10040)', NULL, NULL, NULL, NULL, NULL, 4),
(185743, NULL, 'G3DSA:1.10.238.10:FF:000172', NULL, NULL, 'Cell division control protein', NULL, NULL, NULL, NULL, NULL, 4),
(185744, NULL, 'G3DSA:2.60.40.10:FF:005676', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185745, NULL, 'G3DSA:1.10.220.160:FF:000010', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(185746, NULL, 'G3DSA:2.130.10.10:FF:003563', NULL, NULL, 'Protein CBG03683', NULL, NULL, NULL, NULL, NULL, 4),
(185747, NULL, 'G3DSA:1.25.40.180:FF:000269', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185748, NULL, 'G3DSA:3.30.1380.20:FF:000025', NULL, NULL, 'NO signaling/Golgi transport ligand-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(185749, NULL, 'G3DSA:2.30.29.30:FF:001065', NULL, NULL, 'Ezrin', NULL, NULL, NULL, NULL, NULL, 4),
(185750, NULL, 'G3DSA:1.20.120.340:FF:000011', NULL, NULL, 'Flagellar secretion chaperone FliS', NULL, NULL, NULL, NULL, NULL, 4),
(185751, NULL, 'G3DSA:1.20.58.70:FF:000084', NULL, NULL, 't-SNARE', NULL, NULL, NULL, NULL, NULL, 4),
(185752, NULL, 'G3DSA:1.10.730.10:FF:000080', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(185753, NULL, 'G3DSA:3.30.160.60:FF:002056', NULL, NULL, 'transcription factor E4F1 isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(185754, NULL, 'G3DSA:2.60.40.1180:FF:000056', NULL, NULL, 'Alpha-galactosidase A', NULL, NULL, NULL, NULL, NULL, 4),
(185755, NULL, 'G3DSA:1.10.565.10:FF:000066', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(185756, NULL, 'G3DSA:3.20.20.80:FF:000647', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(185757, NULL, 'G3DSA:3.40.50.300:FF:002057', NULL, NULL, 'Pre-mRNA splicing factor RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185758, NULL, 'G3DSA:1.20.140.30:FF:000004', NULL, NULL, 'CBK1 kinase activator protein MOB2', NULL, NULL, NULL, NULL, NULL, 4),
(185759, NULL, 'G3DSA:3.90.70.10:FF:000172', NULL, NULL, 'Probable ubiquitin carboxyl-terminal hydrolase 2', NULL, NULL, NULL, NULL, NULL, 4),
(185760, NULL, 'G3DSA:3.15.10.10:FF:000009', NULL, NULL, 'phospholipid transfer protein isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(185761, NULL, 'G3DSA:2.130.10.10:FF:005985', NULL, NULL, 'Myosin heavy chain kinase B', NULL, NULL, NULL, NULL, NULL, 4),
(185762, NULL, 'G3DSA:2.60.40.10:FF:002455', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185763, NULL, 'G3DSA:1.20.1280.50:FF:000194', NULL, NULL, 'Protein CBG09205', NULL, NULL, NULL, NULL, NULL, 4),
(185764, NULL, 'G3DSA:2.60.40.10:FF:001909', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(185765, NULL, 'G3DSA:3.40.50.1820:FF:000937', NULL, NULL, 'Slr1944 protein', NULL, NULL, NULL, NULL, NULL, 4),
(185766, NULL, 'G3DSA:2.70.20.10:FF:000014', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(185767, NULL, 'G3DSA:2.60.40.10:FF:001966', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185768, NULL, 'G3DSA:1.10.357.120:FF:000014', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(185769, NULL, 'G3DSA:1.25.40.10:FF:004141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185770, NULL, 'G3DSA:1.10.287.110:FF:000225', NULL, NULL, 'DnaJ homolog subfamily C member 2', NULL, NULL, NULL, NULL, NULL, 4),
(185771, NULL, 'G3DSA:2.60.40.1170:FF:000053', NULL, NULL, 'APM2p protein', NULL, NULL, NULL, NULL, NULL, 4),
(185772, NULL, 'G3DSA:3.30.70.330:FF:001178', NULL, NULL, 'ELAV-like protein 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(185773, NULL, 'G3DSA:3.10.610.10:FF:000001', NULL, NULL, 'General secretion pathway protein J', NULL, NULL, NULL, NULL, NULL, 4),
(185774, NULL, 'G3DSA:3.30.160.60:FF:002382', NULL, NULL, 'Regular, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(185775, NULL, 'G3DSA:1.10.533.10:FF:000133', NULL, NULL, 'Caspase b', NULL, NULL, NULL, NULL, NULL, 4),
(185776, NULL, 'G3DSA:3.40.50.620:FF:000112', NULL, NULL, 'Sensor histidine kinase KdpD', NULL, NULL, NULL, NULL, NULL, 4),
(185777, NULL, 'G3DSA:3.30.420.40:FF:000070', NULL, NULL, 'Hypoxia up-regulated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(185778, NULL, 'G3DSA:3.40.50.150:FF:001298', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185779, NULL, 'G3DSA:1.20.1270.60:FF:000308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185780, NULL, 'G3DSA:2.10.110.10:FF:000124', NULL, NULL, 'Cysteine and glycine-rich protein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(185781, NULL, 'G3DSA:3.30.420.10:FF:000651', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185782, NULL, 'G3DSA:2.30.140.10:FF:000032', NULL, NULL, 'Polyamine aminopropyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(185783, NULL, 'G3DSA:3.90.1410.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185784, NULL, 'G3DSA:2.30.39.10:FF:000098', NULL, NULL, 'Serine protease inhibitor (Serpin-2)', NULL, NULL, NULL, NULL, NULL, 4),
(185785, NULL, 'G3DSA:3.40.50.1400:FF:000025', NULL, NULL, 'Ferrochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(185786, NULL, 'G3DSA:1.10.533.10:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185787, NULL, 'G3DSA:3.20.20.140:FF:000068', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(185788, NULL, 'G3DSA:1.10.10.60:FF:000410', NULL, NULL, 'Homeobox-leucine zipper protein HOX25-like', NULL, NULL, NULL, NULL, NULL, 4),
(185789, NULL, 'G3DSA:3.30.40.10:FF:000060', NULL, NULL, 'ubiquitin conjugation factor E4 B', NULL, NULL, NULL, NULL, NULL, 4),
(185790, NULL, 'G3DSA:3.30.40.140:FF:000002', NULL, NULL, 'Putative RING zinc finger domain superfamily protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(185791, NULL, 'G3DSA:3.10.50.40:FF:000121', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(185792, NULL, 'G3DSA:2.70.20.60:FF:000001', NULL, NULL, 'Matrix protein', NULL, NULL, NULL, NULL, NULL, 4),
(185793, NULL, 'G3DSA:3.10.50.40:FF:000065', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(185794, NULL, 'G3DSA:2.130.10.10:FF:000308', NULL, NULL, 'F-box and WD repeat domain containing 8', NULL, NULL, NULL, NULL, NULL, 4),
(185795, NULL, 'G3DSA:2.160.10.10:FF:000043', NULL, NULL, 'K1 capsule O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(185796, NULL, 'G3DSA:2.60.40.640:FF:000060', NULL, NULL, 'Vacuolar sorting protein 26, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185797, NULL, 'G3DSA:3.40.50.2300:FF:000132', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(185798, NULL, 'G3DSA:3.90.1310.10:FF:000004', NULL, NULL, 'Penicillin-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(185799, NULL, 'G3DSA:3.40.140.10:FF:000054', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit 5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185800, NULL, 'G3DSA:1.20.1070.10:FF:001234', NULL, NULL, 'Frizzled class receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(185801, NULL, 'G3DSA:1.25.10.10:FF:000603', NULL, NULL, 'Diaphanous, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(185802, NULL, 'G3DSA:3.20.20.80:FF:000698', NULL, NULL, 'Alpha-amylase 4', NULL, NULL, NULL, NULL, NULL, 4),
(185803, NULL, 'G3DSA:4.10.1000.40:FF:000007', NULL, NULL, 'Polyadenylated RNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(185804, NULL, 'G3DSA:1.25.40.550:FF:000009', NULL, NULL, 'protein AAR2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(185805, NULL, 'G3DSA:2.10.90.10:FF:000066', NULL, NULL, 'Nerve growth factor a (beta polypeptide)', NULL, NULL, NULL, NULL, NULL, 4),
(185806, NULL, 'G3DSA:1.25.10.10:FF:003296', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(185807, NULL, 'G3DSA:1.10.10.60:FF:000393', NULL, NULL, 'Small nuclear RNA activating complex polypeptide 4', NULL, NULL, NULL, NULL, NULL, 4),
(185808, NULL, 'G3DSA:6.10.300.40:FF:000003', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(185809, NULL, 'G3DSA:3.10.20.90:FF:000050', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 13', NULL, NULL, NULL, NULL, NULL, 4),
(185810, NULL, 'G3DSA:1.25.50.20:FF:000081', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(185811, NULL, 'G3DSA:2.60.40.150:FF:000238', NULL, NULL, 'Phosphatidylinositol 3-kinase VPS34', NULL, NULL, NULL, NULL, NULL, 4),
(185812, NULL, 'G3DSA:3.30.420.10:FF:000595', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185813, NULL, 'G3DSA:1.10.3270.10:FF:000004', NULL, NULL, 'NAD(P)-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(185814, NULL, 'G3DSA:2.30.180.10:FF:000028', NULL, NULL, 'Midline fasciclin, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(185815, NULL, 'G3DSA:2.20.100.10:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185816, NULL, 'G3DSA:1.20.1250.20:FF:000880', NULL, NULL, 'Nitrite transporter NrtP', NULL, NULL, NULL, NULL, NULL, 4),
(185817, NULL, 'G3DSA:1.20.120.30:FF:000003', NULL, NULL, 'Methyl-accepting chemotaxis protein III', NULL, NULL, NULL, NULL, NULL, 4),
(185818, NULL, 'G3DSA:3.20.20.70:FF:000695', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185819, NULL, 'G3DSA:1.20.58.390:FF:000015', NULL, NULL, 'Gamma-aminobutyric acid (GABA-A) receptor, subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(185820, NULL, 'G3DSA:1.20.58.390:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185821, NULL, 'G3DSA:1.25.40.10:FF:003859', NULL, NULL, 'PPR repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(185822, NULL, 'G3DSA:2.130.10.10:FF:002438', NULL, NULL, 'Small nucleolar ribonucleoprotein complex subunit (SOF1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(185823, NULL, 'G3DSA:3.10.100.10:FF:000024', NULL, NULL, 'C-type lectin domain family 4 member A', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(185824, NULL, 'G3DSA:3.90.1410.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185825, NULL, 'G3DSA:3.20.20.70:FF:000369', NULL, NULL, 'N-(5''-phosphoribosyl)anthranilate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(185826, NULL, 'G3DSA:1.10.287.740:FF:000003', NULL, NULL, 'Photosystem II reaction center protein Z', NULL, NULL, NULL, NULL, NULL, 4),
(185827, NULL, 'G3DSA:2.70.160.11:FF:000059', NULL, NULL, 'Protein arginine N-methyltransferase PRMT1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185828, NULL, 'G3DSA:1.10.455.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185829, NULL, 'G3DSA:3.30.450.90:FF:000007', NULL, NULL, 'ComG operon protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(185830, NULL, 'G3DSA:1.10.287.80:FF:000013', NULL, NULL, 'ATP synthase subunit gamma, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(185831, NULL, 'G3DSA:3.40.50.1000:FF:000517', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(185832, NULL, 'G3DSA:2.60.120.330:FF:000178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185833, NULL, 'G3DSA:1.10.720.60:FF:000015', NULL, NULL, '2,3-diketo-5-methylthio-1-phosphopentane phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(185834, NULL, 'G3DSA:3.40.50.410:FF:000229', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(185835, NULL, 'G3DSA:2.130.10.10:FF:002545', NULL, NULL, 'Sensor histidine kinase TodS', NULL, NULL, NULL, NULL, NULL, 4),
(185836, NULL, 'G3DSA:1.50.10.10:FF:000028', NULL, NULL, 'Alpha-L-fucosidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(185837, NULL, 'G3DSA:3.30.40.10:FF:001583', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185838, NULL, 'G3DSA:1.20.1070.10:FF:001273', NULL, NULL, 'Cadherin, EGF LAG seven-pass G-type receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(185839, NULL, 'G3DSA:1.20.1070.10:FF:001560', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185840, NULL, 'G3DSA:2.60.40.640:FF:000003', NULL, NULL, 'beta-arrestin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(185841, NULL, 'G3DSA:2.40.50.730:FF:000014', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(185842, NULL, 'G3DSA:1.10.287.70:FF:000010', NULL, NULL, 'Putative glutamate receptor ionotropic kainate 1', NULL, NULL, NULL, NULL, NULL, 4),
(185843, NULL, 'G3DSA:2.60.120.920:FF:000203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185844, NULL, 'G3DSA:2.30.39.10:FF:000059', NULL, NULL, 'Serpin family B member 8', NULL, NULL, NULL, NULL, NULL, 4),
(185845, NULL, 'G3DSA:3.40.50.300:FF:002944', NULL, NULL, 'DEAD-box ATP-dependent RNA helicase 39', NULL, NULL, NULL, NULL, NULL, 4),
(185846, NULL, 'G3DSA:4.10.1000.30:FF:000004', NULL, NULL, 'Sut-2', NULL, NULL, NULL, NULL, NULL, 4),
(185847, NULL, 'G3DSA:1.25.40.540:FF:000006', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(185848, NULL, 'G3DSA:2.60.120.920:FF:000147', NULL, NULL, 'Si:dkey-207m2.4', NULL, NULL, NULL, NULL, NULL, 4),
(185849, NULL, 'G3DSA:2.40.50.140:FF:000045', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(185850, NULL, 'G3DSA:1.25.40.530:FF:000003', NULL, NULL, 'Rho GTPase-activating protein 39', NULL, NULL, NULL, NULL, NULL, 4),
(185851, NULL, 'G3DSA:1.20.200.20:FF:000001', NULL, NULL, 'SWI5-dependent HO expression protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(185852, NULL, 'G3DSA:3.40.50.300:FF:004350', NULL, NULL, 'Protein SMG9 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(185853, NULL, 'G3DSA:2.40.110.10:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185854, NULL, 'G3DSA:3.40.50.300:FF:005873', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(185855, NULL, 'G3DSA:3.40.605.10:FF:000123', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(185856, NULL, 'G3DSA:3.30.160.60:FF:002343', NULL, NULL, 'Zinc finger protein 33A', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(185857, NULL, 'G3DSA:3.30.930.10:FF:000285', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(185858, NULL, 'G3DSA:3.40.1110.10:FF:000490', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185859, NULL, 'G3DSA:1.25.40.10:FF:000195', NULL, NULL, 'Putative TPR repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(185860, NULL, 'G3DSA:1.20.1070.10:FF:000666', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185861, NULL, 'G3DSA:2.60.40.790:FF:000020', NULL, NULL, 'heat shock protein beta-7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(185862, NULL, 'G3DSA:1.10.510.10:FF:003475', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185863, NULL, 'G3DSA:3.20.20.140:FF:000394', NULL, NULL, 'Putative N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(185864, NULL, 'G3DSA:2.80.10.50:FF:000250', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(185865, NULL, 'G3DSA:3.30.420.40:FF:000811', NULL, NULL, 'SWI/SNF and RSC complexes subunit arp9', NULL, NULL, NULL, NULL, NULL, 4),
(185866, NULL, 'G3DSA:3.90.105.10:FF:000012', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(185867, NULL, 'G3DSA:3.30.420.10:FF:000319', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(185868, NULL, 'G3DSA:1.25.40.20:FF:000198', NULL, NULL, 'Myosin binding subunit, isoform P', NULL, NULL, NULL, NULL, NULL, 4),
(185869, NULL, 'G3DSA:2.60.40.650:FF:000006', NULL, NULL, 'SUlfite OXidase', NULL, NULL, NULL, NULL, NULL, 4),
(185870, NULL, 'G3DSA:3.20.19.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185871, NULL, 'G3DSA:2.60.40.640:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185872, NULL, 'G3DSA:3.10.310.20:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185873, NULL, 'G3DSA:2.10.70.10:FF:000071', NULL, NULL, 'CUB and Sushi multiple domains 3', NULL, NULL, NULL, NULL, NULL, 4),
(185874, NULL, 'G3DSA:3.30.20.10:FF:000002', NULL, NULL, 'Acidic endochitinase pcht28', NULL, NULL, NULL, NULL, NULL, 4),
(185875, NULL, 'G3DSA:2.30.42.10:FF:000061', NULL, NULL, 'sorting nexin-27 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(185876, NULL, 'G3DSA:3.90.1480.20:FF:000053', NULL, NULL, 'ST3 beta-galactoside alpha-2,3-sialyltransferase 1,-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(185877, NULL, 'G3DSA:3.40.970.10:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185878, NULL, 'G3DSA:3.50.4.10:FF:000033', NULL, NULL, 'Protein let-653', NULL, NULL, NULL, NULL, NULL, 4),
(185879, NULL, 'G3DSA:1.20.5.190:FF:000051', NULL, NULL, 'Myosin-VIIa', NULL, NULL, NULL, NULL, NULL, 4),
(185880, NULL, 'G3DSA:3.30.720.170:FF:000002', NULL, NULL, 'Perilipin', NULL, NULL, NULL, NULL, NULL, 4),
(185881, NULL, 'G3DSA:3.40.30.10:FF:000267', NULL, NULL, 'Peroxidoxin bcpB', NULL, NULL, NULL, NULL, NULL, 4),
(185882, NULL, 'G3DSA:3.30.160.60:FF:004473', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185883, NULL, 'G3DSA:1.20.5.190:FF:000012', NULL, NULL, 'Myosin VIIA', NULL, NULL, NULL, NULL, NULL, 4),
(185884, NULL, 'G3DSA:1.20.1250.20:FF:000767', NULL, NULL, 'Equilibrative nucleoside transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185885, NULL, 'G3DSA:1.10.287.90:FF:000016', NULL, NULL, 'Cytochrome c oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(185886, NULL, 'G3DSA:2.60.120.10:FF:000664', NULL, NULL, '12-dihydroxy-3-keto-5-methylthiopentene dioxygenase 4', NULL, NULL, NULL, NULL, NULL, 4),
(185887, NULL, 'G3DSA:3.30.1360.70:FF:000016', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(185888, NULL, 'G3DSA:3.30.60.30:FF:000224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185889, NULL, 'G3DSA:1.10.287.110:FF:000337', NULL, NULL, 'Chaperone protein dnaJ 49', NULL, NULL, NULL, NULL, NULL, 4),
(185890, NULL, 'G3DSA:1.20.1560.10:FF:000299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(185891, NULL, 'G3DSA:3.30.70.1560:FF:000002', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(185892, NULL, 'G3DSA:3.80.10.10:FF:001225', NULL, NULL, 'Antagonist of mitotic exit network protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(185893, NULL, 'G3DSA:2.130.10.10:FF:000640', NULL, NULL, 'Splicing factor 3B subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(185894, NULL, 'G3DSA:3.40.50.300:FF:007964', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185895, NULL, 'G3DSA:2.60.40.150:FF:000620', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(185896, NULL, 'G3DSA:3.40.50.300:FF:007784', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(185897, NULL, 'G3DSA:1.25.40.20:FF:000254', NULL, NULL, 'Ankyrin repeat and SOCS box containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(185898, NULL, 'G3DSA:2.30.29.30:FF:000896', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(185899, NULL, 'G3DSA:1.10.510.10:FF:002165', NULL, NULL, 'Os10g0141200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(185900, NULL, 'G3DSA:3.30.70.330:FF:002072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185901, NULL, 'G3DSA:2.60.120.1440:FF:000022', NULL, NULL, 'Probable transmembrane sensor', NULL, NULL, NULL, NULL, NULL, 4),
(185902, NULL, 'G3DSA:2.70.130.10:FF:000062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185903, NULL, 'G3DSA:3.40.50.11140:FF:000001', NULL, NULL, 'Transcription-repair-coupling factor', NULL, NULL, NULL, NULL, NULL, 4),
(185904, NULL, 'G3DSA:3.30.1960.10:FF:000011', NULL, NULL, 'Methyltransferase TYW3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185905, NULL, 'G3DSA:1.20.1250.20:FF:000548', NULL, NULL, 'Monocarboxylate permease', NULL, NULL, NULL, NULL, NULL, 4),
(185906, NULL, 'G3DSA:1.10.287.690:FF:000022', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(185907, NULL, 'G3DSA:1.10.167.10:FF:000034', NULL, NULL, 'Related to RAX1-Protein involved in determination of budding patterns', NULL, NULL, NULL, NULL, NULL, 4),
(185908, NULL, 'G3DSA:1.10.510.10:FF:003582', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185909, NULL, 'G3DSA:2.40.110.10:FF:000033', NULL, NULL, 'Acyl-[acyl-carrier-protein] dehydrogenase MbtN', NULL, NULL, NULL, NULL, NULL, 4),
(185910, NULL, 'G3DSA:3.20.20.70:FF:000588', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185911, NULL, 'G3DSA:1.10.510.10:FF:004200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185912, NULL, 'G3DSA:1.20.5.350:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185913, NULL, 'G3DSA:3.30.40.10:FF:001526', NULL, NULL, 'Par-2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(185914, NULL, 'G3DSA:3.65.10.10:FF:000024', NULL, NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(185915, NULL, 'G3DSA:3.40.50.620:FF:000854', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(185916, NULL, 'G3DSA:3.30.2350.20:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185917, NULL, 'G3DSA:3.30.70.330:FF:001465', NULL, NULL, '31 kDa ribonucleoprotein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(185918, NULL, 'G3DSA:1.20.120.1750:FF:000154', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(185919, NULL, 'G3DSA:1.10.510.10:FF:004312', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185920, NULL, 'G3DSA:2.70.150.10:FF:000057', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(185921, NULL, 'G3DSA:3.30.465.10:FF:000001', NULL, NULL, 'D-2-hydroxyglutarate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(185922, NULL, 'G3DSA:1.10.287.550:FF:000008', NULL, NULL, 'Arylsulfatase D', NULL, NULL, NULL, NULL, NULL, 4),
(185923, NULL, 'G3DSA:2.60.40.10:FF:000656', NULL, NULL, 'collagen alpha-1(XIV) chain isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(185924, NULL, 'G3DSA:1.50.40.10:FF:000182', NULL, NULL, 'ADP/ATP mitochondrial carrier-like protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(185925, NULL, 'G3DSA:3.30.830.10:FF:000283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185926, NULL, 'G3DSA:1.25.10.10:FF:001946', NULL, NULL, 'CYtoKinesis defect', NULL, NULL, NULL, NULL, NULL, 4),
(185927, NULL, 'G3DSA:4.10.640.10:FF:000022', NULL, NULL, 'Protein CBR-MRPS-18B', NULL, NULL, NULL, NULL, NULL, 4),
(185928, NULL, 'G3DSA:1.25.40.20:FF:001890', NULL, NULL, 'Protein 21.1', NULL, NULL, NULL, NULL, NULL, 4),
(185929, NULL, 'G3DSA:1.20.930.40:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185930, NULL, 'G3DSA:1.20.5.340:FF:000023', NULL, NULL, 'Rho-associated protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(185931, NULL, 'G3DSA:3.40.50.720:FF:001098', NULL, NULL, 'Methionine adenosyltransferase 2 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(185932, NULL, 'G3DSA:3.40.50.10190:FF:000244', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(185933, NULL, 'G3DSA:2.30.36.90:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185934, NULL, 'G3DSA:3.30.572.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185935, NULL, 'G3DSA:2.30.29.30:FF:001391', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185936, NULL, 'G3DSA:3.90.400.10:FF:000012', NULL, NULL, 'Alpha-amylase', NULL, NULL, NULL, NULL, NULL, 4),
(185937, NULL, 'G3DSA:1.10.287.1080:FF:000011', NULL, NULL, 'NTP Pyrophosphohydrolase MazG-related, RS21-C6', NULL, NULL, NULL, NULL, NULL, 4),
(185938, NULL, 'G3DSA:3.90.1150.10:FF:000020', NULL, NULL, 'Sphingosine-1-phosphate lyase 1', NULL, NULL, NULL, NULL, NULL, 4),
(185939, NULL, 'G3DSA:2.170.270.10:FF:000238', NULL, NULL, 'Nuclear receptor-binding SET domain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(185940, NULL, 'G3DSA:1.10.287.540:FF:000005', NULL, NULL, 'Pilus assembly protein, PilO', NULL, NULL, NULL, NULL, NULL, 4),
(185941, NULL, 'G3DSA:1.25.40.10:FF:000251', NULL, NULL, 'FK506-binding protein-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(185942, NULL, 'G3DSA:2.130.10.10:FF:000421', NULL, NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', NULL, NULL, NULL, NULL, NULL, 4),
(185943, NULL, 'G3DSA:2.30.180.10:FF:000085', NULL, NULL, 'Uncharacterized protein CaJ7.0034', NULL, NULL, NULL, NULL, NULL, 4),
(185944, NULL, 'G3DSA:3.40.50.2300:FF:001475', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185945, NULL, 'G3DSA:3.40.50.300:FF:002164', NULL, NULL, 'ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(185946, NULL, 'G3DSA:1.10.472.10:FF:000092', NULL, NULL, 'RNA polymerase II holoenzyme cyclin-like subunit', NULL, NULL, NULL, NULL, NULL, 4),
(185947, NULL, 'G3DSA:3.40.50.1820:FF:001106', NULL, NULL, 'AGAP002090-PA', NULL, NULL, NULL, NULL, NULL, 4),
(185948, NULL, 'G3DSA:3.10.20.90:FF:000830', NULL, NULL, 'Small ubiquitin-related modifier', NULL, NULL, NULL, NULL, NULL, 4),
(185949, NULL, 'G3DSA:3.10.50.40:FF:000008', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(185950, NULL, 'G3DSA:3.10.20.340:FF:000006', NULL, NULL, 'Arginine biosynthesis bifunctional protein ArgJ', NULL, NULL, NULL, NULL, NULL, 4),
(185951, NULL, 'G3DSA:3.20.20.10:FF:000048', NULL, NULL, 'Alanine racemase', NULL, NULL, NULL, NULL, NULL, 4),
(185952, NULL, 'G3DSA:3.80.10.10:FF:002568', NULL, NULL, 'MDIS1-interacting receptor like kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(185953, NULL, 'G3DSA:1.10.533.10:FF:000172', NULL, NULL, 'X-linked inhibitor of apoptosis', NULL, NULL, NULL, NULL, NULL, 4),
(185954, NULL, 'G3DSA:3.40.50.12780:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185955, NULL, 'G3DSA:1.10.20.10:FF:000250', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185956, NULL, 'G3DSA:1.10.8.720:FF:000027', NULL, NULL, 'Dynein heavy chain 6, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(185957, NULL, 'G3DSA:4.10.410.10:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185958, NULL, 'G3DSA:3.90.1480.20:FF:000008', NULL, NULL, 'ST6 N-acetylgalactosaminide alpha-2,6-sialyltransferase 3', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(185959, NULL, 'G3DSA:3.40.525.10:FF:000009', NULL, NULL, 'SEC14-like 2 (S. cerevisiae)', NULL, NULL, NULL, NULL, NULL, 4),
(185960, NULL, 'G3DSA:3.40.50.300:FF:000820', NULL, NULL, 'MutS homolog 5 (E. coli)', NULL, NULL, NULL, NULL, NULL, 4),
(185961, NULL, 'G3DSA:3.30.559.30:FF:000006', NULL, NULL, 'Yersiniabactin polyketide/non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(185962, NULL, 'G3DSA:3.90.70.10:FF:000407', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(185963, NULL, 'G3DSA:3.40.50.1100:FF:000261', NULL, NULL, 'Tryptophan synthase beta subunit (TrpB), authentic frameshift', NULL, NULL, NULL, NULL, NULL, 4),
(185964, NULL, 'G3DSA:3.40.605.10:FF:000067', NULL, NULL, 'Delta-1-pyrroline-5-carboxylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(185965, NULL, 'G3DSA:1.25.10.10:FF:002840', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185966, NULL, 'G3DSA:1.10.8.710:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185967, NULL, 'G3DSA:1.10.3810.10:FF:000029', NULL, NULL, 'Multimodular transpeptidase-transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(185968, NULL, 'G3DSA:3.40.50.10470:FF:000002', NULL, NULL, 'Probable translation initiation factor eIF-2B subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(185969, NULL, 'G3DSA:3.60.40.10:FF:000379', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185970, NULL, 'G3DSA:1.25.40.10:FF:003915', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185971, NULL, 'G3DSA:4.10.280.10:FF:000089', NULL, NULL, 'Transcription factor LAX PANICLE', NULL, NULL, NULL, NULL, NULL, 4),
(185972, NULL, 'G3DSA:3.30.56.30:FF:000006', NULL, NULL, 'Signal recognition particle subunit SRP19', NULL, NULL, NULL, NULL, NULL, 4),
(185973, NULL, 'G3DSA:2.30.39.10:FF:000115', NULL, NULL, 'Serpin peptidase inhibitor 1', NULL, NULL, NULL, NULL, NULL, 4),
(185974, NULL, 'G3DSA:1.20.1530.20:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185975, NULL, 'G3DSA:3.30.565.10:FF:000060', NULL, NULL, 'Structural maintenance of chromosomes flexible hinge domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(185976, NULL, 'G3DSA:1.10.10.10:FF:000075', NULL, NULL, 'Histone H1 like', NULL, NULL, NULL, NULL, NULL, 4),
(185977, NULL, 'G3DSA:3.40.140.10:FF:000110', NULL, NULL, 'GD11395', NULL, NULL, NULL, NULL, NULL, 4),
(185978, NULL, 'G3DSA:3.30.30.170:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185979, NULL, 'G3DSA:3.30.160.60:FF:004254', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185980, NULL, 'G3DSA:2.30.29.30:FF:000839', NULL, NULL, 'Si:dkey-40c11.1', NULL, NULL, NULL, NULL, NULL, 4),
(185981, NULL, 'G3DSA:3.40.50.300:FF:005598', NULL, NULL, 'HELicase Q homolog', NULL, NULL, NULL, NULL, NULL, 4),
(185982, NULL, 'G3DSA:2.40.70.10:FF:000434', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185983, NULL, 'G3DSA:2.10.230.10:FF:000015', NULL, NULL, 'Chaperone protein DNAJ-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(185984, NULL, 'G3DSA:3.40.50.300:FF:002107', NULL, NULL, 'ATP-dependent RNA helicase ROK1', NULL, NULL, NULL, NULL, NULL, 4),
(185985, NULL, 'G3DSA:2.40.50.140:FF:000787', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185986, NULL, 'G3DSA:1.25.40.10:FF:003972', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185987, NULL, 'G3DSA:3.30.565.10:FF:000003', NULL, NULL, 'DNA mismatch repair endonuclease MutL', NULL, NULL, NULL, NULL, NULL, 4),
(185988, NULL, 'G3DSA:1.10.10.10:FF:002042', NULL, NULL, 'RNA polymerase sigma factor SigW, putative', NULL, NULL, NULL, NULL, NULL, 4),
(185989, NULL, 'G3DSA:3.40.50.1820:FF:001163', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(185990, NULL, 'G3DSA:3.30.200.20:FF:000204', NULL, NULL, 'Serine/threonine-protein kinase Nek7', NULL, NULL, NULL, NULL, NULL, 4),
(185991, NULL, 'G3DSA:3.10.50.30:FF:000005', NULL, NULL, 'Transcription elongation factor GreA', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(185992, NULL, 'G3DSA:1.20.1070.10:FF:000778', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185993, NULL, 'G3DSA:3.30.160.60:FF:002163', NULL, NULL, 'Jing, isoform I', NULL, NULL, NULL, NULL, NULL, 4),
(185994, NULL, 'G3DSA:3.30.200.20:FF:000261', NULL, NULL, 'MAP kinase kinase Ste7', NULL, NULL, NULL, NULL, NULL, 4),
(185995, NULL, 'G3DSA:3.80.10.10:FF:003405', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(185996, NULL, 'G3DSA:2.60.40.10:FF:005384', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(185997, NULL, 'G3DSA:1.20.120.790:FF:000016', NULL, NULL, 'Chaperone protein HtpG', NULL, NULL, NULL, NULL, NULL, 4),
(185998, NULL, 'G3DSA:3.40.50.10260:FF:000001', NULL, NULL, 'Enhancer of mRNA-decapping protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(185999, NULL, 'G3DSA:3.30.30.10:FF:000008', NULL, NULL, 'Toxin-like peptide AaF1CA7', NULL, NULL, NULL, NULL, NULL, 4),
(186000, NULL, 'G3DSA:1.25.40.10:FF:001555', NULL, NULL, 'GD13877', NULL, NULL, NULL, NULL, NULL, 4),
(186001, NULL, 'G3DSA:1.25.40.10:FF:001499', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g18520, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(186002, NULL, 'G3DSA:3.30.1680.10:FF:000023', NULL, NULL, 'semaphorin-4G isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(186003, NULL, 'G3DSA:2.130.10.10:FF:004170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186004, NULL, 'G3DSA:2.60.40.10:FF:003585', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186005, NULL, 'G3DSA:2.40.10.350:FF:000010', NULL, NULL, 'Rod shape-determining protein mreC', NULL, NULL, NULL, NULL, NULL, 4),
(186006, NULL, 'G3DSA:1.20.1250.20:FF:001548', NULL, NULL, 'MFS transporter, putative (AFU_orthologue AFUA_4G01480)', NULL, NULL, NULL, NULL, NULL, 4),
(186007, NULL, 'G3DSA:1.20.58.70:FF:000101', NULL, NULL, 'Protein CBR-SYX-5', NULL, NULL, NULL, NULL, NULL, 4),
(186008, NULL, 'G3DSA:3.30.230.80:FF:000022', NULL, NULL, 'Grp94/Hsp90', NULL, NULL, NULL, NULL, NULL, 4),
(186009, NULL, 'G3DSA:2.10.25.10:FF:001163', NULL, NULL, 'Protein glp-1', NULL, NULL, NULL, NULL, NULL, 4),
(186010, NULL, 'G3DSA:2.130.10.10:FF:003894', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186011, NULL, 'G3DSA:2.10.70.10:FF:000177', NULL, NULL, 'GG11343', NULL, NULL, NULL, NULL, NULL, 4),
(186012, NULL, 'G3DSA:3.40.1380.10:FF:000037', NULL, NULL, 'ATP synthase F1 gamma subunit', NULL, NULL, NULL, NULL, NULL, 4),
(186013, NULL, 'G3DSA:2.30.29.30:FF:001115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186014, NULL, 'G3DSA:1.20.1270.60:FF:000078', NULL, NULL, 'Slm1p', NULL, NULL, NULL, NULL, NULL, 4),
(186015, NULL, 'G3DSA:2.40.10.10:FF:000436', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186016, NULL, 'G3DSA:3.30.160.60:FF:002904', NULL, NULL, 'Zgc:112977', NULL, NULL, NULL, NULL, NULL, 4),
(186017, NULL, 'G3DSA:2.10.25.10:FF:000848', NULL, NULL, 'Fibrillin-1', NULL, NULL, NULL, NULL, NULL, 4),
(186018, NULL, 'G3DSA:3.40.33.10:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186019, NULL, 'G3DSA:1.10.1600.10:FF:000018', NULL, NULL, 'ATP-dependent DNA helicase ku70', NULL, NULL, NULL, NULL, NULL, 4),
(186020, NULL, 'G3DSA:2.40.340.10:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186021, NULL, 'G3DSA:1.20.5.110:FF:000207', NULL, NULL, 'LOC100127544 protein', NULL, NULL, NULL, NULL, NULL, 4),
(186022, NULL, 'G3DSA:1.10.10.10:FF:000131', NULL, NULL, 'la-related protein 1B isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(186023, NULL, 'G3DSA:2.60.120.260:FF:000022', NULL, NULL, 'Laminin subunit alpha 5', NULL, NULL, NULL, NULL, NULL, 4),
(186024, NULL, 'G3DSA:2.60.40.150:FF:000126', NULL, NULL, 'Copine 6', NULL, NULL, NULL, NULL, NULL, 4),
(186025, NULL, 'G3DSA:3.40.50.880:FF:000212', NULL, NULL, 'Aminodeoxychorismate synthase component 2', NULL, NULL, NULL, NULL, NULL, 4),
(186026, NULL, 'G3DSA:1.20.1250.20:FF:001604', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(186027, NULL, 'G3DSA:3.30.160.60:FF:000364', NULL, NULL, 'Zinc finger and BTB domain-containing protein 34', NULL, NULL, NULL, NULL, NULL, 4),
(186028, NULL, 'G3DSA:1.25.40.10:FF:003354', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g11690', NULL, NULL, NULL, NULL, NULL, 4),
(186029, NULL, 'G3DSA:3.10.110.10:FF:000362', NULL, NULL, 'Protein IMPACT homolog', NULL, NULL, NULL, NULL, NULL, 4),
(186030, NULL, 'G3DSA:3.90.79.10:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186031, NULL, 'G3DSA:1.20.272.10:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186032, NULL, 'G3DSA:1.10.3090.10:FF:000018', NULL, NULL, 'CCA-adding enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(186033, NULL, 'G3DSA:1.10.8.270:FF:000066', NULL, NULL, 'GTPase activating protein (Gyp5), putative', NULL, NULL, NULL, NULL, NULL, 4),
(186034, NULL, 'G3DSA:1.10.510.10:FF:002800', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186035, NULL, 'G3DSA:3.40.50.300:FF:006710', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(186036, NULL, 'G3DSA:1.10.418.10:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186037, NULL, 'G3DSA:3.40.50.300:FF:000584', NULL, NULL, 'probable ATP-dependent RNA helicase DDX46', NULL, NULL, NULL, NULL, NULL, 4),
(186038, NULL, 'G3DSA:1.10.10.60:FF:000174', NULL, NULL, 'MYB-related transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(186039, NULL, 'G3DSA:2.130.10.10:FF:001764', NULL, NULL, 'Putative WD-repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(186040, NULL, 'G3DSA:3.30.420.40:FF:000250', NULL, NULL, 'Putative actin-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(186041, NULL, 'G3DSA:1.20.210.10:FF:000004', NULL, NULL, 'Cytochrome c oxidase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(186042, NULL, 'G3DSA:3.90.930.12:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186043, NULL, 'G3DSA:3.30.70.330:FF:000503', NULL, NULL, 'Calcineurin binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186044, NULL, 'G3DSA:3.30.519.10:FF:000003', NULL, NULL, 'Rab GDP dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(186045, NULL, 'G3DSA:3.60.21.50:FF:000004', NULL, NULL, 'DNA polymerase epsilon subunit b, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186046, NULL, 'G3DSA:2.130.10.10:FF:000128', NULL, NULL, 'WD repeat domain 46', NULL, NULL, NULL, NULL, NULL, 4),
(186047, NULL, 'G3DSA:3.40.50.300:FF:000527', NULL, NULL, 'Tyrosine-protein kinase etk', NULL, NULL, NULL, NULL, NULL, 4),
(186048, NULL, 'G3DSA:2.130.10.10:FF:000185', NULL, NULL, 'TBC1 domain family member 31 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(186049, NULL, 'G3DSA:3.30.260.10:FF:000031', NULL, NULL, 'T-complex protein 1, theta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(186050, NULL, 'G3DSA:3.30.2020.30:FF:000002', NULL, NULL, 'Putative gamma-butyrobetaine dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(186051, NULL, 'G3DSA:4.10.860.10:FF:000004', NULL, NULL, 'ATP-dependent Clp protease ATP-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(186052, NULL, 'G3DSA:4.10.410.10:FF:000033', NULL, NULL, 'CRE-MEC-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(186053, NULL, 'G3DSA:3.40.50.300:FF:000640', NULL, NULL, 'MoxR family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(186054, NULL, 'G3DSA:1.10.760.10:FF:000025', NULL, NULL, 'Cytochrome c2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186055, NULL, 'G3DSA:2.20.25.10:FF:000022', NULL, NULL, 'LytR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(186056, NULL, 'G3DSA:3.40.1110.10:FF:000158', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(186057, NULL, 'G3DSA:3.90.550.50:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186058, NULL, 'G3DSA:3.30.70.330:FF:000161', NULL, NULL, 'RNA binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(186059, NULL, 'G3DSA:2.120.10.80:FF:000251', NULL, NULL, 'Kel1p', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(186060, NULL, 'G3DSA:1.25.40.10:FF:002230', NULL, NULL, 'Nuclear autoantigenic sperm protein (histone-binding)', NULL, NULL, NULL, NULL, NULL, 4),
(186061, NULL, 'G3DSA:1.25.10.10:FF:000423', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(186062, NULL, 'G3DSA:1.10.565.10:FF:000178', NULL, NULL, 'Protein CBR-NHR-221', NULL, NULL, NULL, NULL, NULL, 4),
(186063, NULL, 'G3DSA:4.10.860.20:FF:000007', NULL, NULL, 'Vacuolar segregation protein pep7', NULL, NULL, NULL, NULL, NULL, 4),
(186064, NULL, 'G3DSA:3.10.100.10:FF:000204', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(186065, NULL, 'G3DSA:1.20.5.340:FF:000080', NULL, NULL, 'Polycystin 2 like 1, transient receptor potential cation channel', NULL, NULL, NULL, NULL, NULL, 4),
(186066, NULL, 'G3DSA:3.50.50.60:FF:000102', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(186067, NULL, 'G3DSA:2.60.40.10:FF:004602', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186068, NULL, 'G3DSA:3.40.50.300:FF:008127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186069, NULL, 'G3DSA:3.90.1150.180:FF:000002', NULL, NULL, 'L-seryl-tRNA(Sec) selenium transferase', NULL, NULL, NULL, NULL, NULL, 4),
(186070, NULL, 'G3DSA:3.50.50.60:FF:001064', NULL, NULL, 'Flavin containing monooxygenase 5', NULL, NULL, NULL, NULL, NULL, 4),
(186071, NULL, 'G3DSA:1.10.510.10:FF:004256', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186072, NULL, 'G3DSA:3.40.50.10470:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186073, NULL, 'G3DSA:2.40.30.10:FF:000106', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(186074, NULL, 'G3DSA:2.30.30.140:FF:000055', NULL, NULL, 'SAGA complex component', NULL, NULL, NULL, NULL, NULL, 4),
(186075, NULL, 'G3DSA:1.25.10.10:FF:000081', NULL, NULL, 'Coatomer subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(186076, NULL, 'G3DSA:1.10.246.130:FF:000008', NULL, NULL, 'Ecm38p', NULL, NULL, NULL, NULL, NULL, 4),
(186077, NULL, 'G3DSA:2.10.25.10:FF:001562', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186078, NULL, 'G3DSA:1.10.1820.10:FF:000001', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(186079, NULL, 'G3DSA:3.70.10.10:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186080, NULL, 'G3DSA:3.30.200.20:FF:001840', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(186081, NULL, 'G3DSA:1.10.510.10:FF:001906', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186082, NULL, 'G3DSA:1.10.150.20:FF:000111', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(186083, NULL, 'G3DSA:1.25.10.10:FF:001385', NULL, NULL, 'Cell division control protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186084, NULL, 'G3DSA:1.10.238.10:FF:000284', NULL, NULL, 'RAB11 family interacting protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(186085, NULL, 'G3DSA:1.10.443.10:FF:000013', NULL, NULL, 'Putative integrase', NULL, NULL, NULL, NULL, NULL, 4),
(186086, NULL, 'G3DSA:3.90.226.10:FF:000253', NULL, NULL, 'Enoyl-CoA hydratase/isomerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186087, NULL, 'G3DSA:2.10.25.10:FF:001124', NULL, NULL, 'Protein eyes shut homolog', NULL, NULL, NULL, NULL, NULL, 4),
(186088, NULL, 'G3DSA:1.10.238.10:FF:001189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186089, NULL, 'G3DSA:2.130.10.10:FF:004911', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186090, NULL, 'G3DSA:1.10.1900.10:FF:000002', NULL, NULL, 'E3 ubiquitin-protein ligase UBR5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(186091, NULL, 'G3DSA:3.60.21.10:FF:000458', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(186092, NULL, 'G3DSA:3.30.70.330:FF:001521', NULL, NULL, 'Heteroproteinous nuclear ribonucleoprotein r rrm superfamily', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(186093, NULL, 'G3DSA:1.25.10.10:FF:000480', NULL, NULL, 'Transportin', NULL, NULL, NULL, NULL, NULL, 4),
(186094, NULL, 'G3DSA:2.30.30.550:FF:000003', NULL, NULL, 'Major vault protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(186095, NULL, 'G3DSA:3.40.50.300:FF:004417', NULL, NULL, 'ADP-ribosylation factor family-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(186096, NULL, 'G3DSA:2.40.40.20:FF:000048', NULL, NULL, 'Putative vesicle-fusing ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(186097, NULL, 'G3DSA:3.40.120.10:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186098, NULL, 'G3DSA:1.10.3500.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186099, NULL, 'G3DSA:1.25.40.20:FF:001558', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186100, NULL, 'G3DSA:2.40.100.10:FF:000151', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(186101, NULL, 'G3DSA:3.40.50.620:FF:000798', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186102, NULL, 'G3DSA:1.10.1900.20:FF:000005', NULL, NULL, '50S ribosomal protein L20, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(186103, NULL, 'G3DSA:3.80.10.10:FF:004479', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(186104, NULL, 'G3DSA:2.170.120.20:FF:000017', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(186105, NULL, 'G3DSA:2.30.30.560:FF:000006', NULL, NULL, 'Major vault protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186106, NULL, 'G3DSA:2.130.10.10:FF:004018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186107, NULL, 'G3DSA:1.10.30.50:FF:000003', NULL, NULL, 'HNH endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(186108, NULL, 'G3DSA:3.30.70.890:FF:000031', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(186109, NULL, 'G3DSA:1.20.120.1200:FF:000012', NULL, NULL, 'NADH-quinone oxidoreductase chain 6 protein', NULL, NULL, NULL, NULL, NULL, 4),
(186110, NULL, 'G3DSA:3.40.50.300:FF:004237', NULL, NULL, 'SNF2 family helicase/ATPase, putative (AFU_orthologue AFUA_3G08400)', NULL, NULL, NULL, NULL, NULL, 4),
(186111, NULL, 'G3DSA:3.40.50.150:FF:000516', NULL, NULL, 'Unplaced genomic scaffold supercont2.5, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(186112, NULL, 'G3DSA:3.40.50.10810:FF:000025', NULL, NULL, 'E3 ubiquitin-protein ligase SHPRH isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(186113, NULL, 'G3DSA:3.40.50.10190:FF:000188', NULL, NULL, 'PAX transcription activation domain interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(186114, NULL, 'G3DSA:3.30.160.60:FF:005833', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186115, NULL, 'G3DSA:3.30.70.330:FF:000104', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein L like', NULL, NULL, NULL, NULL, NULL, 4),
(186116, NULL, 'G3DSA:1.10.260.100:FF:000017', NULL, NULL, 'Stress-induced protein sti1', NULL, NULL, NULL, NULL, NULL, 4),
(186117, NULL, 'G3DSA:1.10.1580.10:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186118, NULL, 'G3DSA:1.10.8.60:FF:000549', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186119, NULL, 'G3DSA:3.30.200.20:FF:002003', NULL, NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 201', NULL, NULL, NULL, NULL, NULL, 4),
(186120, NULL, 'G3DSA:1.10.8.60:FF:000263', NULL, NULL, '26S protease regulatory subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(186121, NULL, 'G3DSA:2.130.10.10:FF:000460', NULL, NULL, 'TBC1 domain family member 31 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(186122, NULL, 'G3DSA:3.30.460.90:FF:000014', NULL, NULL, 'IP12463p', NULL, NULL, NULL, NULL, NULL, 4),
(186123, NULL, 'G3DSA:1.10.472.80:FF:000197', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186124, NULL, 'G3DSA:2.30.29.30:FF:000952', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(186125, NULL, 'G3DSA:2.60.120.590:FF:000059', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(186126, NULL, 'G3DSA:3.30.160.60:FF:005777', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186127, NULL, 'G3DSA:3.30.200.20:FF:001565', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186128, NULL, 'G3DSA:2.60.120.430:FF:000039', NULL, NULL, 'Uncharacterized protein C9E9.15', NULL, NULL, NULL, NULL, NULL, 4),
(186129, NULL, 'G3DSA:3.40.640.10:FF:000311', NULL, NULL, 'Aminotransferase class-III', NULL, NULL, NULL, NULL, NULL, 4),
(186130, NULL, 'G3DSA:3.40.50.80:FF:000013', NULL, NULL, 'Ferredoxin--NADP(+) reductase', NULL, NULL, NULL, NULL, NULL, 4),
(186131, NULL, 'G3DSA:1.10.1420.10:FF:000033', NULL, NULL, 'Probable DNA mismatch repair protein MSH2', NULL, NULL, NULL, NULL, NULL, 4),
(186132, NULL, 'G3DSA:1.10.287.70:FF:000297', NULL, NULL, 'Ionotropic glutamate receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186133, NULL, 'G3DSA:1.10.530.10:FF:000036', NULL, NULL, 'Lytic murein transglycosylase B', NULL, NULL, NULL, NULL, NULL, 4),
(186134, NULL, 'G3DSA:3.40.250.10:FF:000169', NULL, NULL, 'Methyltransferase domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186135, NULL, 'G3DSA:1.20.5.650:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186136, NULL, 'G3DSA:3.80.10.10:FF:000769', NULL, NULL, 'Receptor-like protein kinase 7 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(186137, NULL, 'G3DSA:3.40.50.2300:FF:000019', NULL, NULL, 'Chemotaxis response regulator CheY', NULL, NULL, NULL, NULL, NULL, 4),
(186138, NULL, 'G3DSA:1.10.1450.10:FF:000080', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(186139, NULL, 'G3DSA:3.90.1290.10:FF:000069', NULL, NULL, 'Dystonin', NULL, NULL, NULL, NULL, NULL, 4),
(186140, NULL, 'G3DSA:3.40.50.300:FF:000308', NULL, NULL, 'ras-related protein RABE1c-like', NULL, NULL, NULL, NULL, NULL, 4),
(186141, NULL, 'G3DSA:3.30.200.20:FF:000148', NULL, NULL, 'Serine/threonine-protein kinase RIO1', NULL, NULL, NULL, NULL, NULL, 4),
(186142, NULL, 'G3DSA:3.10.660.10:FF:000004', NULL, NULL, 'Diphthamide biosynthesis protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(186143, NULL, 'G3DSA:2.60.40.10:FF:000151', NULL, NULL, 'neural cell adhesion molecule 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(186144, NULL, 'G3DSA:3.90.550.10:FF:000343', NULL, NULL, 'Glycoside transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(186145, NULL, 'G3DSA:1.25.10.10:FF:001727', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(186146, NULL, 'G3DSA:1.10.150.20:FF:000330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186147, NULL, 'G3DSA:1.20.1250.20:FF:001661', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186148, NULL, 'G3DSA:2.60.40.150:FF:000800', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186149, NULL, 'G3DSA:1.20.120.1900:FF:000014', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(186150, NULL, 'G3DSA:1.10.12.70:FF:000001', NULL, NULL, 'Programmed cell death protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(186151, NULL, 'G3DSA:2.70.170.10:FF:000002', NULL, NULL, 'Glycine receptor alpha 1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(186152, NULL, 'G3DSA:1.10.555.10:FF:000239', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186153, NULL, 'G3DSA:3.10.20.30:FF:000054', NULL, NULL, 'Iron-sulfur cluster-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(186154, NULL, 'G3DSA:3.30.160.60:FF:003798', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186155, NULL, 'G3DSA:3.50.50.60:FF:001406', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186156, NULL, 'G3DSA:3.40.50.10810:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186157, NULL, 'G3DSA:1.10.150.50:FF:000159', NULL, NULL, 'Putative adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(186158, NULL, 'G3DSA:1.10.510.10:FF:002126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(186159, NULL, 'G3DSA:1.10.10.60:FF:000117', NULL, NULL, 'BEL1-like homeodomain protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(186160, NULL, 'G3DSA:3.40.50.300:FF:003799', NULL, NULL, 'DEAD/DEAH box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(186161, NULL, 'G3DSA:3.30.160.60:FF:006053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186162, NULL, 'G3DSA:3.40.50.2020:FF:000082', NULL, NULL, 'Phosphoribosylpyrophosphate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(186163, NULL, 'G3DSA:1.10.418.10:FF:000213', NULL, NULL, 'Rac guanyl-nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(186164, NULL, 'G3DSA:3.40.50.300:FF:000926', NULL, NULL, 'NACHT and WD repeat domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(186165, NULL, 'G3DSA:1.10.472.130:FF:000018', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186166, NULL, 'G3DSA:2.60.40.10:FF:004080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186167, NULL, 'G3DSA:1.20.1560.10:FF:000012', NULL, NULL, 'ATP binding cassette subfamily C member 5', NULL, NULL, NULL, NULL, NULL, 4),
(186168, NULL, 'G3DSA:1.20.120.140:FF:000013', NULL, NULL, 'Signal recognition particle receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(186169, NULL, 'G3DSA:2.40.10.10:FF:000217', NULL, NULL, 'HGF/MSP/plasminogen-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(186170, NULL, 'G3DSA:3.30.200.20:FF:002060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186171, NULL, 'G3DSA:3.30.1640.10:FF:000026', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(186172, NULL, 'G3DSA:1.25.40.10:FF:002050', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(186173, NULL, 'G3DSA:1.25.10.10:FF:000367', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(186174, NULL, 'G3DSA:3.10.105.10:FF:000013', NULL, NULL, 'Oligopeptide ABC transporter, oligopeptide-binding protein AliB', NULL, NULL, NULL, NULL, NULL, 4),
(186175, NULL, 'G3DSA:2.60.40.10:FF:000712', NULL, NULL, 'Poliovirus receptor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(186176, NULL, 'G3DSA:3.50.50.60:FF:000046', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(186177, NULL, 'G3DSA:1.10.530.10:FF:000093', NULL, NULL, 'Lysozyme', NULL, NULL, NULL, NULL, NULL, 4),
(186178, NULL, 'G3DSA:3.40.50.300:FF:004294', NULL, NULL, 'Rab-type small G protein', NULL, NULL, NULL, NULL, NULL, 4),
(186179, NULL, 'G3DSA:1.25.40.990:FF:000012', NULL, NULL, 'SAC3 family protein C', NULL, NULL, NULL, NULL, NULL, 4),
(186180, NULL, 'G3DSA:1.10.10.2660:FF:000017', NULL, NULL, 'Ubiquitin activating enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186181, NULL, 'G3DSA:1.20.1640.10:FF:000070', NULL, NULL, 'GM10585', NULL, NULL, NULL, NULL, NULL, 4),
(186182, NULL, 'G3DSA:1.10.1200.10:FF:000089', NULL, NULL, 'Nonribosomal peptide synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186183, NULL, 'G3DSA:3.30.200.20:FF:001508', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186184, NULL, 'G3DSA:3.40.1370.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186185, NULL, 'G3DSA:3.30.450.40:FF:000307', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(186186, NULL, 'G3DSA:3.30.565.10:FF:000508', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(186187, NULL, 'G3DSA:1.10.8.270:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186188, NULL, 'G3DSA:3.50.30.30:FF:000177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186189, NULL, 'G3DSA:2.30.30.140:FF:000274', NULL, NULL, 'Retinoblastoma-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(186190, NULL, 'G3DSA:3.90.79.10:FF:000039', NULL, NULL, 'Nucleoside triphosphatase NudI', NULL, NULL, NULL, NULL, NULL, 4),
(186191, NULL, 'G3DSA:1.10.510.10:FF:002401', NULL, NULL, 'Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(186192, NULL, 'G3DSA:3.80.10.10:FF:002681', NULL, NULL, 'Phytosulfokine receptor 1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(186193, NULL, 'G3DSA:2.10.50.10:FF:000069', NULL, NULL, 'Cysteine repeat modular protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(186194, NULL, 'G3DSA:1.25.40.20:FF:001777', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(186195, NULL, 'G3DSA:3.40.50.720:FF:001334', NULL, NULL, 'Short chain oxidoreductase/dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186196, NULL, 'G3DSA:1.25.10.10:FF:002402', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186197, NULL, 'G3DSA:3.80.10.10:FF:001264', NULL, NULL, 'Insulin-like growth factor-binding protein complex acid labile subunit', NULL, NULL, NULL, NULL, NULL, 4),
(186198, NULL, 'G3DSA:1.10.418.10:FF:000270', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(186199, NULL, 'G3DSA:3.40.50.2300:FF:001436', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186200, NULL, 'G3DSA:3.20.20.10:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186201, NULL, 'G3DSA:2.70.150.10:FF:000113', NULL, NULL, 'Cation transport ATPase, E1-E2 family', NULL, NULL, NULL, NULL, NULL, 4),
(186202, NULL, 'G3DSA:2.30.30.100:FF:000110', NULL, NULL, 'Small nuclear ribonucleoprotein E', NULL, NULL, NULL, NULL, NULL, 4),
(186203, NULL, 'G3DSA:2.80.10.50:FF:000031', NULL, NULL, 'FRG1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(186204, NULL, 'G3DSA:1.25.40.10:FF:001774', NULL, NULL, 'Crooked neck-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(186205, NULL, 'G3DSA:2.70.150.10:FF:000170', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(186206, NULL, 'G3DSA:3.40.20.10:FF:000098', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(186207, NULL, 'G3DSA:1.10.510.10:FF:002137', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(186208, NULL, 'G3DSA:2.10.250.10:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186209, NULL, 'G3DSA:2.40.10.10:FF:000026', NULL, NULL, 'Hepatocyte growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(186210, NULL, 'G3DSA:1.20.120.230:FF:000051', NULL, NULL, 'Talin-A', NULL, NULL, NULL, NULL, NULL, 4),
(186211, NULL, 'G3DSA:1.20.920.30:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186212, NULL, 'G3DSA:3.30.420.40:FF:000362', NULL, NULL, 'Heat shock protein 70 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(186213, NULL, 'G3DSA:6.10.250.3450:FF:000002', NULL, NULL, '60S ribosomal protein L35', NULL, NULL, NULL, NULL, NULL, 4),
(186214, NULL, 'G3DSA:3.60.20.40:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186215, NULL, 'G3DSA:1.20.272.10:FF:000001', NULL, NULL, 'Putative AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(186216, NULL, 'G3DSA:1.10.3450.20:FF:000009', NULL, NULL, 'Nuclear pore complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(186217, NULL, 'G3DSA:3.90.1110.10:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186218, NULL, 'G3DSA:3.40.30.10:FF:000076', NULL, NULL, 'Protein disulfide-isomerase A4', NULL, NULL, NULL, NULL, NULL, 4),
(186219, NULL, 'G3DSA:3.30.420.40:FF:000406', NULL, NULL, 'Chaperone protein DnaK HSP70', NULL, NULL, NULL, NULL, NULL, 4),
(186220, NULL, 'G3DSA:1.10.630.10:FF:000639', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186221, NULL, 'G3DSA:3.40.50.1820:FF:001393', NULL, NULL, 'Chromosome 23, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(186222, NULL, 'G3DSA:3.40.1000.10:FF:000015', NULL, NULL, 'PsbP-like protein 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(186223, NULL, 'G3DSA:3.40.50.2300:FF:001464', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186224, NULL, 'G3DSA:2.130.10.10:FF:004400', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186225, NULL, 'G3DSA:3.40.50.880:FF:000050', NULL, NULL, 'Catalase', NULL, NULL, NULL, NULL, NULL, 4),
(186226, NULL, 'G3DSA:2.130.10.10:FF:002146', NULL, NULL, 'E3 ubiquitin-protein ligase PEP5', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(186227, NULL, 'G3DSA:3.40.50.300:FF:005199', NULL, NULL, 'Conserved expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(186228, NULL, 'G3DSA:3.40.50.1000:FF:000219', NULL, NULL, 'P-type cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(186229, NULL, 'G3DSA:3.30.160.60:FF:005799', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186230, NULL, 'G3DSA:3.30.160.60:FF:003675', NULL, NULL, 'CTCF', NULL, NULL, NULL, NULL, NULL, 4),
(186231, NULL, 'G3DSA:3.90.550.10:FF:000091', NULL, NULL, 'UDP-sugar pyrophosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(186232, NULL, 'G3DSA:1.25.40.10:FF:000436', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g39350 family', NULL, NULL, NULL, NULL, NULL, 4),
(186233, NULL, 'G3DSA:3.40.50.2000:FF:000975', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186234, NULL, 'G3DSA:3.40.50.1820:FF:001404', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186235, NULL, 'G3DSA:1.10.10.10:FF:000092', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(186236, NULL, 'G3DSA:1.25.40.10:FF:001864', NULL, NULL, 'DnaJ homolog subfamily C member 7', NULL, NULL, NULL, NULL, NULL, 4),
(186237, NULL, 'G3DSA:1.20.1740.10:FF:000066', NULL, NULL, 'SPS-sensor component SSY1', NULL, NULL, NULL, NULL, NULL, 4),
(186238, NULL, 'G3DSA:2.60.40.10:FF:004259', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186239, NULL, 'G3DSA:1.10.730.10:FF:000220', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(186240, NULL, 'G3DSA:3.10.580.10:FF:000077', NULL, NULL, 'Cystathionine beta-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(186241, NULL, 'G3DSA:3.40.50.300:FF:000365', NULL, NULL, 'Ribosome biogenesis ATPase RIX7', NULL, NULL, NULL, NULL, NULL, 4),
(186242, NULL, 'G3DSA:1.10.10.830:FF:000002', NULL, NULL, 'Isoleucine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(186243, NULL, 'G3DSA:2.10.70.10:FF:000262', NULL, NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(186244, NULL, 'G3DSA:3.30.70.330:FF:001369', NULL, NULL, 'AGAP005505-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(186245, NULL, 'G3DSA:3.40.50.300:FF:006351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186246, NULL, 'G3DSA:1.50.40.10:FF:000148', NULL, NULL, 'Mitochondrial substrate carrier family protein', NULL, NULL, NULL, NULL, NULL, 4),
(186247, NULL, 'G3DSA:3.40.630.10:FF:000411', NULL, NULL, 'Novel protein aminoacylase 1 family 2 ACY1L2 (Homo sapiens), putative', NULL, NULL, NULL, NULL, NULL, 4),
(186248, NULL, 'G3DSA:1.25.40.10:FF:001538', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(186249, NULL, 'G3DSA:3.40.50.300:FF:007969', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186250, NULL, 'G3DSA:3.30.160.60:FF:002573', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186251, NULL, 'G3DSA:3.30.519.10:FF:000020', NULL, NULL, 'Rab proteins geranylgeranyltransferase component A', NULL, NULL, NULL, NULL, NULL, 4),
(186252, NULL, 'G3DSA:3.90.70.10:FF:000441', NULL, NULL, 'HlyB family protein', NULL, NULL, NULL, NULL, NULL, 4),
(186253, NULL, 'G3DSA:3.30.160.60:FF:004181', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186254, NULL, 'G3DSA:1.25.40.10:FF:002044', NULL, NULL, 'Os05g0112900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(186255, NULL, 'G3DSA:2.80.10.50:FF:000115', NULL, NULL, 'GALNT13 isoform 8', NULL, NULL, NULL, NULL, NULL, 4),
(186256, NULL, 'G3DSA:1.25.40.20:FF:000439', NULL, NULL, 'Integrin-linked protein kinase family', NULL, NULL, NULL, NULL, NULL, 4),
(186257, NULL, 'G3DSA:1.25.40.20:FF:001867', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186258, NULL, 'G3DSA:3.40.50.1460:FF:000127', NULL, NULL, 'CASP8 and FADD like apoptosis regulator', NULL, NULL, NULL, NULL, NULL, 4),
(186259, NULL, 'G3DSA:1.20.1110.10:FF:000035', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(186260, NULL, 'G3DSA:2.60.40.60:FF:000109', NULL, NULL, 'neural-cadherin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(186261, NULL, 'G3DSA:3.30.160.60:FF:002247', NULL, NULL, 'Zinc finger protein 560', NULL, NULL, NULL, NULL, NULL, 4),
(186262, NULL, 'G3DSA:3.40.630.30:FF:000417', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186263, NULL, 'G3DSA:1.10.8.80:FF:000010', NULL, NULL, 'MoxR family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(186264, NULL, 'G3DSA:3.20.20.70:FF:000515', NULL, NULL, 'Dihydroorotate dehydrogenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(186265, NULL, 'G3DSA:3.30.530.20:FF:000049', NULL, NULL, 'SRPBCC family protein', NULL, NULL, NULL, NULL, NULL, 4),
(186266, NULL, 'G3DSA:3.40.50.300:FF:004108', NULL, NULL, 'Si:dkey-23k10.5', NULL, NULL, NULL, NULL, NULL, 4),
(186267, NULL, 'G3DSA:1.20.5.110:FF:000174', NULL, NULL, 'Protein CBR-SYX-18', NULL, NULL, NULL, NULL, NULL, 4),
(186268, NULL, 'G3DSA:3.50.50.60:FF:001480', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186269, NULL, 'G3DSA:1.20.1250.20:FF:001672', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(186270, NULL, 'G3DSA:3.40.50.11530:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186271, NULL, 'G3DSA:2.40.10.10:FF:000661', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186272, NULL, 'G3DSA:1.10.510.10:FF:004380', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186273, NULL, 'G3DSA:3.40.50.300:FF:000409', NULL, NULL, 'Neuron navigator 1', NULL, NULL, NULL, NULL, NULL, 4),
(186274, NULL, 'G3DSA:3.30.40.10:FF:001824', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186275, NULL, 'G3DSA:1.20.1070.10:FF:001262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186276, NULL, 'G3DSA:1.20.1070.10:FF:001571', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186277, NULL, 'G3DSA:2.60.120.10:FF:000333', NULL, NULL, 'Germin-like protein subfamily 3 member 1', NULL, NULL, NULL, NULL, NULL, 4),
(186278, NULL, 'G3DSA:1.10.510.10:FF:004071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186279, NULL, 'G3DSA:3.40.50.300:FF:000039', NULL, NULL, '26S proteasome regulatory subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(186280, NULL, 'G3DSA:1.10.3520.10:FF:000035', NULL, NULL, 'Ceramide-1-phosphate transfer protein-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(186281, NULL, 'G3DSA:3.40.140.10:FF:000183', NULL, NULL, 'tRNA-sepcific adenosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(186282, NULL, 'G3DSA:3.40.350.10:FF:000103', NULL, NULL, 'FACT complex subunit spt16, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186283, NULL, 'G3DSA:1.10.510.10:FF:002463', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(186284, NULL, 'G3DSA:1.10.287.370:FF:000067', NULL, NULL, 'Prefoldin 5', NULL, NULL, NULL, NULL, NULL, 4),
(186285, NULL, 'G3DSA:1.25.40.120:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186286, NULL, 'G3DSA:1.20.120.350:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186287, NULL, 'G3DSA:3.50.80.10:FF:000016', NULL, NULL, 'D-aminoacyl-tRNA deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(186288, NULL, 'G3DSA:3.40.50.1440:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186289, NULL, 'G3DSA:3.30.70.1230:FF:000139', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(186290, NULL, 'G3DSA:1.20.58.480:FF:000019', NULL, NULL, 'Tryptophan 2,3-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(186291, NULL, 'G3DSA:3.40.50.300:FF:004097', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(186292, NULL, 'G3DSA:3.10.450.320:FF:000001', NULL, NULL, 'Mitochondrial import inner membrane translocase subunit Tim21', NULL, NULL, NULL, NULL, NULL, 4),
(186293, NULL, 'G3DSA:3.30.497.10:FF:000142', NULL, NULL, 'Si:ch1073-416d2.3', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(186294, NULL, 'G3DSA:1.20.1270.60:FF:000292', NULL, NULL, 'Bridging integrator 2b', NULL, NULL, NULL, NULL, NULL, 4),
(186295, NULL, 'G3DSA:3.30.70.920:FF:000023', NULL, NULL, 'HTH-type transcriptional regulator LrpC', NULL, NULL, NULL, NULL, NULL, 4),
(186296, NULL, 'G3DSA:1.10.287.40:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186297, NULL, 'G3DSA:2.40.50.100:FF:000067', NULL, NULL, 'Glycerol-3-phosphate ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(186298, NULL, 'G3DSA:1.10.20.10:FF:000373', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186299, NULL, 'G3DSA:3.90.105.10:FF:000028', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(186300, NULL, 'G3DSA:3.40.50.1820:FF:001067', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(186301, NULL, 'G3DSA:1.10.150.50:FF:000238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186302, NULL, 'G3DSA:3.30.70.940:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186303, NULL, 'G3DSA:3.30.565.10:FF:000216', NULL, NULL, 'Sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(186304, NULL, 'G3DSA:3.20.20.80:FF:000844', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186305, NULL, 'G3DSA:3.30.930.10:FF:000268', NULL, NULL, 'DNA polymerase subunit gamma-2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(186306, NULL, 'G3DSA:2.60.40.150:FF:000160', NULL, NULL, 'phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit gamma isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(186307, NULL, 'G3DSA:1.25.10.10:FF:000608', NULL, NULL, 'Centrosomal protein 224', NULL, NULL, NULL, NULL, NULL, 4),
(186308, NULL, 'G3DSA:1.20.1280.50:FF:000244', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(186309, NULL, 'G3DSA:3.40.50.10860:FF:000001', NULL, NULL, 'Bifunctional protein FolD', NULL, NULL, NULL, NULL, NULL, 4),
(186310, NULL, 'G3DSA:1.10.510.10:FF:003918', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186311, NULL, 'G3DSA:3.30.160.60:FF:004501', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186312, NULL, 'G3DSA:2.40.30.10:FF:000235', NULL, NULL, 'Elongation factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(186313, NULL, 'G3DSA:3.90.190.10:FF:000591', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(186314, NULL, 'G3DSA:2.10.220.10:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186315, NULL, 'G3DSA:3.40.640.10:FF:000013', NULL, NULL, '4-aminobutyrate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(186316, NULL, 'G3DSA:3.60.40.10:FF:000194', NULL, NULL, 'Probable protein phosphatase 2C 80', NULL, NULL, NULL, NULL, NULL, 4),
(186317, NULL, 'G3DSA:1.20.1250.20:FF:000857', NULL, NULL, 'Glucose transporter 1B/1C/1D/1F/2B', NULL, NULL, NULL, NULL, NULL, 4),
(186318, NULL, 'G3DSA:1.50.40.10:FF:000518', NULL, NULL, 'Uncharacterized mitochondrial carrier C227.03c', NULL, NULL, NULL, NULL, NULL, 4),
(186319, NULL, 'G3DSA:4.10.240.10:FF:000199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186320, NULL, 'G3DSA:2.40.170.20:FF:000124', NULL, NULL, 'Probable TonB-dependent receptor', NULL, NULL, NULL, NULL, NULL, 4),
(186321, NULL, 'G3DSA:3.30.160.60:FF:004490', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186322, NULL, 'G3DSA:3.30.730.10:FF:000011', NULL, NULL, 'Ethylene-responsive transcription factor ERF120', NULL, NULL, NULL, NULL, NULL, 4),
(186323, NULL, 'G3DSA:1.25.40.10:FF:003781', NULL, NULL, 'ER membrane protein complex subunit 2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(186324, NULL, 'G3DSA:1.20.140.150:FF:000008', NULL, NULL, 'Transmembrane protein 204', NULL, NULL, NULL, NULL, NULL, 4),
(186325, NULL, 'G3DSA:3.30.160.60:FF:006316', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186326, NULL, 'G3DSA:1.25.40.710:FF:000018', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(186327, NULL, 'G3DSA:1.10.30.10:FF:000003', NULL, NULL, 'Putative transcription factor SOX-6', NULL, NULL, NULL, NULL, NULL, 4),
(186328, NULL, 'G3DSA:1.10.10.60:FF:000320', NULL, NULL, 'jerky protein homolog-like', NULL, NULL, NULL, NULL, NULL, 4),
(186329, NULL, 'G3DSA:2.60.40.1670:FF:000012', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(186330, NULL, 'G3DSA:2.60.40.10:FF:005687', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186331, NULL, 'G3DSA:2.30.30.760:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186332, NULL, 'G3DSA:3.50.50.60:FF:001171', NULL, NULL, 'Electron transfer flavoprotein ubiquinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(186333, NULL, 'G3DSA:2.40.10.10:FF:000352', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186334, NULL, 'G3DSA:2.10.90.10:FF:000162', NULL, NULL, 'Glycoprotein hormones alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(186335, NULL, 'G3DSA:2.30.30.770:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186336, NULL, 'G3DSA:3.30.40.10:FF:001178', NULL, NULL, 'Ring finger protein 24', NULL, NULL, NULL, NULL, NULL, 4),
(186337, NULL, 'G3DSA:1.20.1250.20:FF:001346', NULL, NULL, 'Putative small intestine urate exporter', NULL, NULL, NULL, NULL, NULL, 4),
(186338, NULL, 'G3DSA:1.20.5.190:FF:000141', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186339, NULL, 'G3DSA:3.40.50.300:FF:004434', NULL, NULL, 'Elongator complex protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(186340, NULL, 'G3DSA:3.40.50.300:FF:002652', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(186341, NULL, 'G3DSA:3.90.1440.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186342, NULL, 'G3DSA:3.30.200.20:FF:001930', NULL, NULL, 'Lectin receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(186343, NULL, 'G3DSA:1.25.50.20:FF:000058', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(186344, NULL, 'G3DSA:2.60.40.10:FF:003916', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186345, NULL, 'G3DSA:3.20.20.70:FF:000841', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186346, NULL, 'G3DSA:3.40.50.2300:FF:001138', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186347, NULL, 'G3DSA:3.40.30.10:FF:000755', NULL, NULL, 'SH3-binding', NULL, NULL, NULL, NULL, NULL, 4),
(186348, NULL, 'G3DSA:3.40.33.10:FF:000099', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(186349, NULL, 'G3DSA:2.60.40.10:FF:002814', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186350, NULL, 'G3DSA:3.30.2160.10:FF:000040', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(186351, NULL, 'G3DSA:1.20.1250.20:FF:001037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186352, NULL, 'G3DSA:3.40.50.10810:FF:000126', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(186353, NULL, 'G3DSA:1.10.10.430:FF:000005', NULL, NULL, 'GG12191', NULL, NULL, NULL, NULL, NULL, 4),
(186354, NULL, 'G3DSA:3.40.630.30:FF:000373', NULL, NULL, 'GNAT family N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(186355, NULL, 'G3DSA:2.60.40.640:FF:000065', NULL, NULL, 'Arrestin domain-containing protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(186356, NULL, 'G3DSA:3.40.50.1820:FF:000578', NULL, NULL, 'Dipeptidyl peptidase 7', NULL, NULL, NULL, NULL, NULL, 4),
(186357, NULL, 'G3DSA:2.130.10.10:FF:000331', NULL, NULL, 'Actin-related protein 2/3 complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(186358, NULL, 'G3DSA:1.10.10.440:FF:000008', NULL, NULL, 'Transcription elongation regulator 1 (CA150)', NULL, NULL, NULL, NULL, NULL, 4),
(186359, NULL, 'G3DSA:3.30.310.280:FF:000004', NULL, NULL, 'NTP-dependent putrebactin synthetase PubC', NULL, NULL, NULL, NULL, NULL, 4),
(186360, NULL, 'G3DSA:4.10.860.10:FF:000010', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(186361, NULL, 'G3DSA:3.30.60.20:FF:000081', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(186362, NULL, 'G3DSA:3.30.200.20:FF:001458', NULL, NULL, 'Putative inactive G-type lectin S-receptor-like serine/threonine-protein kinase SRK', NULL, NULL, NULL, NULL, NULL, 4),
(186363, NULL, 'G3DSA:3.80.10.10:FF:001562', NULL, NULL, 'Receptor kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(186364, NULL, 'G3DSA:3.10.20.90:FF:000342', NULL, NULL, 'Ubiquitin B', NULL, NULL, NULL, NULL, NULL, 4),
(186365, NULL, 'G3DSA:3.40.50.300:FF:002282', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(186366, NULL, 'G3DSA:3.40.190.10:FF:000231', NULL, NULL, 'Transcriptional activator MetR', NULL, NULL, NULL, NULL, NULL, 4),
(186367, NULL, 'G3DSA:3.40.50.720:FF:001906', NULL, NULL, 'Malate dehydrogenase:SUBUNIT=A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186368, NULL, 'G3DSA:1.25.10.10:FF:001699', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186369, NULL, 'G3DSA:1.10.20.10:FF:000064', NULL, NULL, 'Transcription initiation factor TFIID subunit 9', NULL, NULL, NULL, NULL, NULL, 4),
(186370, NULL, 'G3DSA:3.30.200.20:FF:002110', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(186371, NULL, 'G3DSA:1.10.238.10:FF:000413', NULL, NULL, 'Calmodulin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(186372, NULL, 'G3DSA:4.10.1240.10:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186373, NULL, 'G3DSA:3.30.60.30:FF:000084', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(186374, NULL, 'G3DSA:1.10.533.10:FF:000262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186375, NULL, 'G3DSA:3.40.50.150:FF:000185', NULL, NULL, 'O-methyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(186376, NULL, 'G3DSA:2.60.120.40:FF:000055', NULL, NULL, 'Elastin microfibril interfacer 1', NULL, NULL, NULL, NULL, NULL, 4),
(186377, NULL, 'G3DSA:3.30.70.1230:FF:000095', NULL, NULL, 'Adenylate cyclase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186378, NULL, 'G3DSA:2.130.10.10:FF:003883', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186379, NULL, 'G3DSA:2.60.40.10:FF:000353', NULL, NULL, 'receptor-type tyrosine-protein phosphatase F isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(186380, NULL, 'G3DSA:3.10.490.20:FF:000005', NULL, NULL, 'Dynein axonemal heavy chain 6', NULL, NULL, NULL, NULL, NULL, 4),
(186381, NULL, 'G3DSA:3.40.50.720:FF:001227', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(186382, NULL, 'G3DSA:1.10.287.110:FF:000264', NULL, NULL, 'DnaJ domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(186383, NULL, 'G3DSA:1.10.10.2170:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186384, NULL, 'G3DSA:1.20.140.140:FF:000005', NULL, NULL, 'calcium release-activated calcium channel protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(186385, NULL, 'G3DSA:1.10.1450.10:FF:000006', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(186386, NULL, 'G3DSA:3.30.70.240:FF:000049', NULL, NULL, 'Elongation factor G, domain IV family protein', NULL, NULL, NULL, NULL, NULL, 4),
(186387, NULL, 'G3DSA:3.30.450.40:FF:000190', NULL, NULL, 'ATP-binding region ATPase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(186388, NULL, 'G3DSA:1.20.58.860:FF:000010', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase BAP1', NULL, NULL, NULL, NULL, NULL, 4),
(186389, NULL, 'G3DSA:2.60.40.60:FF:000435', NULL, NULL, 'Cadherin 9', NULL, NULL, NULL, NULL, NULL, 4),
(186390, NULL, 'G3DSA:3.40.605.10:FF:000089', NULL, NULL, 'Os12g0177900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(186391, NULL, 'G3DSA:3.40.50.1820:FF:000887', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186392, NULL, 'G3DSA:3.10.490.10:FF:000002', NULL, NULL, 'Gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(186393, NULL, 'G3DSA:3.80.10.10:FF:002973', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186394, NULL, 'G3DSA:3.40.50.1360:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(186395, NULL, 'G3DSA:3.30.160.60:FF:002910', NULL, NULL, 'Zinc finger protein 557', NULL, NULL, NULL, NULL, NULL, 4),
(186396, NULL, 'G3DSA:2.130.10.10:FF:005665', NULL, NULL, 'Rho guanine nucleotide exchange factor 10 like', NULL, NULL, NULL, NULL, NULL, 4),
(186397, NULL, 'G3DSA:2.60.120.260:FF:000151', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(186398, NULL, 'G3DSA:3.40.20.10:FF:000148', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(186399, NULL, 'G3DSA:3.30.70.20:FF:000020', NULL, NULL, 'Hydrogenase 2 operon protein HybA', NULL, NULL, NULL, NULL, NULL, 4),
(186400, NULL, 'G3DSA:3.30.590.10:FF:000022', NULL, NULL, 'Glutamine synthetase I', NULL, NULL, NULL, NULL, NULL, 4),
(186401, NULL, 'G3DSA:2.30.30.140:FF:000139', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(186402, NULL, 'G3DSA:3.40.50.1100:FF:000233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186403, NULL, 'G3DSA:2.10.25.10:FF:001236', NULL, NULL, 'Laminin, beta 1b', NULL, NULL, NULL, NULL, NULL, 4),
(186404, NULL, 'G3DSA:3.30.505.10:FF:000224', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186405, NULL, 'G3DSA:2.60.40.10:FF:002505', NULL, NULL, 'Synaptogenesis protein syg-2', NULL, NULL, NULL, NULL, NULL, 4),
(186406, NULL, 'G3DSA:3.30.1300.10:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186407, NULL, 'G3DSA:3.10.20.90:FF:000712', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186408, NULL, 'G3DSA:2.60.40.10:FF:002135', NULL, NULL, 'Soluble starch synthase 3a, chloroplastic/amyloplastic', NULL, NULL, NULL, NULL, NULL, 4),
(186409, NULL, 'G3DSA:3.30.870.10:FF:000004', NULL, NULL, 'protein FAM83H isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(186410, NULL, 'G3DSA:3.40.50.1240:FF:000033', NULL, NULL, 'Chromosome 12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(186411, NULL, 'G3DSA:1.10.357.10:FF:000032', NULL, NULL, 'Transcriptional regulatory protein (Probably AsnC-family)', NULL, NULL, NULL, NULL, NULL, 4),
(186412, NULL, 'G3DSA:3.90.198.10:FF:000001', NULL, NULL, 'Single-stranded DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(186413, NULL, 'G3DSA:3.90.70.10:FF:000750', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186414, NULL, 'G3DSA:2.130.10.10:FF:005991', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186415, NULL, 'G3DSA:3.40.50.1980:FF:000108', NULL, NULL, 'Iron(III) dicitrate-binding periplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(186416, NULL, 'G3DSA:3.40.50.300:FF:005862', NULL, NULL, 'Putative RNA helicase armi-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(186417, NULL, 'G3DSA:1.10.287.70:FF:000499', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186418, NULL, 'G3DSA:3.30.50.10:FF:000015', NULL, NULL, 'Nuclear receptor subfamily 2, group C, member 1', NULL, NULL, NULL, NULL, NULL, 4),
(186419, NULL, 'G3DSA:1.20.1300.10:FF:000044', NULL, NULL, 'Succinate dehydrogenase subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(186420, NULL, 'G3DSA:1.20.1280.50:FF:000098', NULL, NULL, 'F-box/kelch-repeat protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(186421, NULL, 'G3DSA:3.80.10.10:FF:001253', NULL, NULL, 'GD14431', NULL, NULL, NULL, NULL, NULL, 4),
(186422, NULL, 'G3DSA:2.60.120.380:FF:000069', NULL, NULL, 'Probable subtilase-type serine protease DR_A0283', NULL, NULL, NULL, NULL, NULL, 4),
(186423, NULL, 'G3DSA:3.40.50.720:FF:000873', NULL, NULL, 'Epimerase family protein MT2273', NULL, NULL, NULL, NULL, NULL, 4),
(186424, NULL, 'G3DSA:3.10.110.10:FF:000261', NULL, NULL, 'Ubiquitin conjugating enzyme E2 E3', NULL, NULL, NULL, NULL, NULL, 4),
(186425, NULL, 'G3DSA:2.170.150.20:FF:000002', NULL, NULL, 'Cereblon, isoform CRA_c', NULL, NULL, NULL, NULL, NULL, 4),
(186426, NULL, 'G3DSA:2.130.10.10:FF:000229', NULL, NULL, 'Small nuclear ribonucleoprotein U5 subunit 40', NULL, NULL, NULL, NULL, NULL, 4),
(186427, NULL, 'G3DSA:2.170.150.30:FF:000005', NULL, NULL, 'Dicer Related Helicase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(186428, NULL, 'G3DSA:3.40.50.300:FF:006660', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186429, NULL, 'G3DSA:1.10.238.10:FF:000093', NULL, NULL, 'Calcineurin B homologous protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(186430, NULL, 'G3DSA:1.10.132.20:FF:000002', NULL, NULL, 'Ribosome-recycling factor', NULL, NULL, NULL, NULL, NULL, 4),
(186431, NULL, 'G3DSA:3.40.50.1260:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186432, NULL, 'G3DSA:3.10.100.10:FF:000333', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186433, NULL, 'G3DSA:2.30.30.40:FF:000109', NULL, NULL, 'Peroxisomal biogenesis factor 13', NULL, NULL, NULL, NULL, NULL, 4),
(186434, NULL, 'G3DSA:1.20.1310.10:FF:000016', NULL, NULL, 'Cullin 2', NULL, NULL, NULL, NULL, NULL, 4),
(186435, NULL, 'G3DSA:3.30.830.10:FF:000204', NULL, NULL, 'Peptidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(186436, NULL, 'G3DSA:3.30.420.10:FF:000286', NULL, NULL, 'GM18382', NULL, NULL, NULL, NULL, NULL, 4),
(186437, NULL, 'G3DSA:1.25.40.10:FF:003646', NULL, NULL, 'GH04440p', NULL, NULL, NULL, NULL, NULL, 4),
(186438, NULL, 'G3DSA:2.30.30.30:FF:000062', NULL, NULL, 'Putative 40S ribosomal protein L14', NULL, NULL, NULL, NULL, NULL, 4),
(186439, NULL, 'G3DSA:3.40.50.140:FF:000002', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(186440, NULL, 'G3DSA:1.20.120.420:FF:000001', NULL, NULL, 'Methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(186441, NULL, 'G3DSA:3.40.140.10:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186442, NULL, 'G3DSA:1.20.1310.20:FF:000019', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(186443, NULL, 'G3DSA:3.30.70.1950:FF:000001', NULL, NULL, 'Adapter protein MecA', NULL, NULL, NULL, NULL, NULL, 4),
(186444, NULL, 'G3DSA:3.30.1330.30:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186445, NULL, 'G3DSA:1.10.510.10:FF:004054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186446, NULL, 'G3DSA:3.20.190.20:FF:000002', NULL, NULL, 'Protease Do-like 9', NULL, NULL, NULL, NULL, NULL, 4),
(186447, NULL, 'G3DSA:3.60.21.10:FF:000037', NULL, NULL, 'Bifunctional 2'',3''-cyclic-nucleotide 2''-phosphodiesterase/3''-nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(186448, NULL, 'G3DSA:2.40.30.230:FF:000012', NULL, NULL, 'Regulator of nonsense transcripts 1', NULL, NULL, NULL, NULL, NULL, 4),
(186449, NULL, 'G3DSA:4.10.60.10:FF:000110', NULL, NULL, 'Glycine-rich RNA-binding protein RZ1B isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(186450, NULL, 'G3DSA:2.30.30.40:FF:000065', NULL, NULL, 'adapter molecule crk isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(186451, NULL, 'G3DSA:3.40.50.1440:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186452, NULL, 'G3DSA:3.40.50.150:FF:000005', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4),
(186453, NULL, 'G3DSA:1.20.120.1910:FF:000051', NULL, NULL, 'Probable cysteinyl-trna synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(186454, NULL, 'G3DSA:1.10.510.10:FF:000355', NULL, NULL, 'Integrin-linked protein kinase family', NULL, NULL, NULL, NULL, NULL, 4),
(186455, NULL, 'G3DSA:1.20.120.430:FF:000004', NULL, NULL, 'tRNA modification GTPase TrmE', NULL, NULL, NULL, NULL, NULL, 4),
(186456, NULL, 'G3DSA:3.30.70.330:FF:002212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186457, NULL, 'G3DSA:2.130.10.10:FF:001949', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 16', NULL, NULL, NULL, NULL, NULL, 4),
(186458, NULL, 'G3DSA:3.30.2300.10:FF:000012', NULL, NULL, 'Thump domain-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186459, NULL, 'G3DSA:2.10.25.10:FF:000556', NULL, NULL, 'Blast:Protein slit', NULL, NULL, NULL, NULL, NULL, 4),
(186460, NULL, 'G3DSA:1.20.930.40:FF:000028', NULL, NULL, 'AAL107Wp', NULL, NULL, NULL, NULL, NULL, 4),
(186461, NULL, 'G3DSA:1.20.1070.10:FF:001245', NULL, NULL, 'Adhesion G protein-coupled receptor G7, tandem duplicate 2', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(186462, NULL, 'G3DSA:3.40.630.30:FF:000390', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186463, NULL, 'G3DSA:1.10.240.10:FF:000019', NULL, NULL, 'Tryptophan--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(186464, NULL, 'G3DSA:3.30.310.270:FF:000001', NULL, NULL, 'BicC family RNA binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(186465, NULL, 'G3DSA:3.30.70.920:FF:000040', NULL, NULL, 'AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(186466, NULL, 'G3DSA:1.10.510.10:FF:002154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186467, NULL, 'G3DSA:3.40.50.300:FF:002326', NULL, NULL, 'ATP-dependent RNA helicase DBP7', NULL, NULL, NULL, NULL, NULL, 4),
(186468, NULL, 'G3DSA:2.40.10.10:FF:000009', NULL, NULL, 'Serine endoprotease DegS, periplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(186469, NULL, 'G3DSA:3.20.20.140:FF:000490', NULL, NULL, 'Gll3171 protein', NULL, NULL, NULL, NULL, NULL, 4),
(186470, NULL, 'G3DSA:1.20.58.390:FF:000083', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(186471, NULL, 'G3DSA:2.130.10.10:FF:003557', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186472, NULL, 'G3DSA:3.30.750.24:FF:000110', NULL, NULL, 'Sulfate permease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(186473, NULL, 'G3DSA:1.20.120.1800:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186474, NULL, 'G3DSA:3.80.20.20:FF:000082', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(186475, NULL, 'G3DSA:3.30.160.60:FF:000465', NULL, NULL, 'zinc finger protein 536', NULL, NULL, NULL, NULL, NULL, 4),
(186476, NULL, 'G3DSA:3.90.190.10:FF:000574', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186477, NULL, 'G3DSA:3.30.565.10:FF:000200', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(186478, NULL, 'G3DSA:3.40.50.300:FF:008503', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186479, NULL, 'G3DSA:2.130.10.10:FF:002129', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(186480, NULL, 'G3DSA:3.30.559.30:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186481, NULL, 'G3DSA:3.90.550.10:FF:000309', NULL, NULL, 'Glycosyl transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(186482, NULL, 'G3DSA:3.30.420.40:FF:000053', NULL, NULL, 'Bifunctional UDP-N-acetylglucosamine 2-epimerase/N-acetylmannosamine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(186483, NULL, 'G3DSA:2.40.50.140:FF:001057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186484, NULL, 'G3DSA:2.10.230.10:FF:000009', NULL, NULL, 'Xdj1p', NULL, NULL, NULL, NULL, NULL, 4),
(186485, NULL, 'G3DSA:2.120.10.80:FF:000301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186486, NULL, 'G3DSA:1.25.10.10:FF:000401', NULL, NULL, 'Ranbp16, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(186487, NULL, 'G3DSA:3.30.160.60:FF:005592', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186488, NULL, 'G3DSA:3.30.505.10:FF:000180', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186489, NULL, 'G3DSA:3.90.550.10:FF:000444', NULL, NULL, 'Probable UDP-N-acetylglucosamine pyrophosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(186490, NULL, 'G3DSA:3.30.70.1660:FF:000021', NULL, NULL, 'Peptide chain release factor 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186491, NULL, 'G3DSA:4.10.400.10:FF:000055', NULL, NULL, 'Low-density lipoprotein receptor-related protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(186492, NULL, 'G3DSA:1.10.440.10:FF:000001', NULL, NULL, 'Endonuclease V', NULL, NULL, NULL, NULL, NULL, 4),
(186493, NULL, 'G3DSA:3.40.50.10810:FF:000110', NULL, NULL, 'Putative SNF2 family helicase', NULL, NULL, NULL, NULL, NULL, 4),
(186494, NULL, 'G3DSA:2.80.10.50:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186495, NULL, 'G3DSA:3.40.1380.20:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(186496, NULL, 'G3DSA:1.10.472.10:FF:000018', NULL, NULL, 'Cyclin-K (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(186497, NULL, 'G3DSA:2.10.90.10:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186498, NULL, 'G3DSA:1.10.245.10:FF:000008', NULL, NULL, 'E3 ubiquitin-protein ligase Mdm2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(186499, NULL, 'G3DSA:3.40.50.300:FF:000718', NULL, NULL, 'Ras-like protein family member 11A', NULL, NULL, NULL, NULL, NULL, 4),
(186500, NULL, 'G3DSA:1.10.150.240:FF:000051', NULL, NULL, 'Probable hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(186501, NULL, 'G3DSA:1.10.730.10:FF:000203', NULL, NULL, 'Valyl tRNA Synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(186502, NULL, 'G3DSA:1.10.3720.10:FF:000016', NULL, NULL, 'Oligopeptide transport system permease OppB', NULL, NULL, NULL, NULL, NULL, 4),
(186503, NULL, 'G3DSA:1.20.1250.20:FF:001363', NULL, NULL, 'Major facilitator superfamily transporter', NULL, NULL, NULL, NULL, NULL, 4),
(186504, NULL, 'G3DSA:1.10.510.10:FF:003891', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186505, NULL, 'G3DSA:3.30.70.330:FF:001706', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186506, NULL, 'G3DSA:4.10.400.10:FF:000190', NULL, NULL, 'Low-density lipoprotein receptor-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(186507, NULL, 'G3DSA:2.60.120.430:FF:000028', NULL, NULL, 'Rhamnogalacturonan acetylesterase RhgT', NULL, NULL, NULL, NULL, NULL, 4),
(186508, NULL, 'G3DSA:3.40.50.300:FF:006334', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186509, NULL, 'G3DSA:3.20.20.70:FF:000824', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186510, NULL, 'G3DSA:4.10.1240.10:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186511, NULL, 'G3DSA:2.60.40.10:FF:002461', NULL, NULL, 'Sushi, nidogen and EGF-like domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(186512, NULL, 'G3DSA:3.40.50.300:FF:002635', NULL, NULL, 'helicase POLQ-like', NULL, NULL, NULL, NULL, NULL, 4),
(186513, NULL, 'G3DSA:1.10.287.70:FF:000527', NULL, NULL, 'Sodium channel, voltage-gated, type VIII, alpha subunit b', NULL, NULL, NULL, NULL, NULL, 4),
(186514, NULL, 'G3DSA:2.130.10.130:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186515, NULL, 'G3DSA:2.20.25.10:FF:000095', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(186516, NULL, 'G3DSA:3.40.50.150:FF:000640', NULL, NULL, 'DNA adenine methylase', NULL, NULL, NULL, NULL, NULL, 4),
(186517, NULL, 'G3DSA:3.30.2160.10:FF:000023', NULL, NULL, 'Os09g0484300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(186518, NULL, 'G3DSA:1.10.472.10:FF:000327', NULL, NULL, 'Cyclin D2', NULL, NULL, NULL, NULL, NULL, 4),
(186519, NULL, 'G3DSA:1.10.287.1490:FF:000151', NULL, NULL, 'AT2G24420 protein', NULL, NULL, NULL, NULL, NULL, 4),
(186520, NULL, 'G3DSA:2.40.30.140:FF:000002', NULL, NULL, 'Alpha-amylase', NULL, NULL, NULL, NULL, NULL, 4),
(186521, NULL, 'G3DSA:3.90.70.10:FF:000424', NULL, NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', NULL, NULL, NULL, NULL, NULL, 4),
(186522, NULL, 'G3DSA:1.50.40.10:FF:000474', NULL, NULL, 'Mitochondrial carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186523, NULL, 'G3DSA:1.25.10.10:FF:000272', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(186524, NULL, 'G3DSA:2.10.25.10:FF:000882', NULL, NULL, 'Mucin apoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(186525, NULL, 'G3DSA:2.60.40.790:FF:000014', NULL, NULL, 'AT-rich interactive domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(186526, NULL, 'G3DSA:2.10.25.10:FF:001371', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186527, NULL, 'G3DSA:3.30.70.330:FF:000060', NULL, NULL, 'CUGBP Elav-like family member 4', NULL, NULL, NULL, NULL, NULL, 4),
(186528, NULL, 'G3DSA:3.40.50.300:FF:006025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186529, NULL, 'G3DSA:3.30.420.40:FF:000036', NULL, NULL, 'ARP3 actin-related protein 3 homolog', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(186530, NULL, 'G3DSA:1.10.238.10:FF:000430', NULL, NULL, 'Endonuclease/exonuclease/phosphatase family protein, putative, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(186531, NULL, 'G3DSA:1.10.510.10:FF:000029', NULL, NULL, 'Homeodomain-interacting protein kinase 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(186532, NULL, 'G3DSA:3.90.70.10:FF:000295', NULL, NULL, 'MATH and UCH domain protein, putaitve', NULL, NULL, NULL, NULL, NULL, 4),
(186533, NULL, 'G3DSA:3.40.1260.20:FF:000008', NULL, NULL, 'Ribonuclease, Rne/Rng family', NULL, NULL, NULL, NULL, NULL, 4),
(186534, NULL, 'G3DSA:2.60.40.820:FF:000012', NULL, NULL, 'T-box transcription factor TBX2', NULL, NULL, NULL, NULL, NULL, 4),
(186535, NULL, 'G3DSA:2.60.200.20:FF:000224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186536, NULL, 'G3DSA:1.20.120.1080:FF:000088', NULL, NULL, 'AGAP008081-PA', NULL, NULL, NULL, NULL, NULL, 4),
(186537, NULL, 'G3DSA:3.20.20.140:FF:000473', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(186538, NULL, 'G3DSA:1.25.10.10:FF:002172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186539, NULL, 'G3DSA:3.30.160.360:FF:000004', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(186540, NULL, 'G3DSA:2.70.20.10:FF:000020', NULL, NULL, 'DNA topoisomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(186541, NULL, 'G3DSA:1.10.287.370:FF:000084', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(186542, NULL, 'G3DSA:3.30.505.10:FF:000207', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186543, NULL, 'G3DSA:2.60.40.10:FF:002152', NULL, NULL, 'Lachesin', NULL, NULL, NULL, NULL, NULL, 4),
(186544, NULL, 'G3DSA:2.60.40.1180:FF:000062', NULL, NULL, 'Alpha-amylase 3, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(186545, NULL, 'G3DSA:2.60.40.10:FF:000027', NULL, NULL, 'receptor-type tyrosine-protein phosphatase delta isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(186546, NULL, 'G3DSA:2.30.39.10:FF:000087', NULL, NULL, 'Serpin 1', NULL, NULL, NULL, NULL, NULL, 4),
(186547, NULL, 'G3DSA:1.10.1420.10:FF:000151', NULL, NULL, 'MutS family', NULL, NULL, NULL, NULL, NULL, 4),
(186548, NULL, 'G3DSA:1.10.510.10:FF:003874', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186549, NULL, 'G3DSA:1.20.5.350:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186550, NULL, 'G3DSA:2.30.30.140:FF:000156', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(186551, NULL, 'G3DSA:1.20.5.340:FF:000012', NULL, NULL, 'Wiskott-Aldrich syndrome protein family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(186552, NULL, 'G3DSA:2.130.10.10:FF:003866', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186553, NULL, 'G3DSA:2.130.10.120:FF:000026', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(186554, NULL, 'G3DSA:3.40.50.300:FF:000735', NULL, NULL, 'Lactation elevated 1 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(186555, NULL, 'G3DSA:1.10.510.10:FF:002480', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186556, NULL, 'G3DSA:2.60.40.10:FF:004052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186557, NULL, 'G3DSA:2.170.120.12:FF:000011', NULL, NULL, 'DNA-directed RNA polymerase, alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186558, NULL, 'G3DSA:3.40.50.150:FF:000331', NULL, NULL, 'Macrocin O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(186559, NULL, 'G3DSA:2.80.10.50:FF:000087', NULL, NULL, 'Putative frg1-like family protein', NULL, NULL, NULL, NULL, NULL, 4),
(186560, NULL, 'G3DSA:1.10.10.10:FF:001873', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(186561, NULL, 'G3DSA:2.60.40.1670:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186562, NULL, 'G3DSA:3.40.605.10:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186563, NULL, 'G3DSA:3.30.70.1230:FF:000241', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(186564, NULL, 'G3DSA:1.25.40.490:FF:000002', NULL, NULL, 'FA complementation group F', NULL, NULL, NULL, NULL, NULL, 4),
(186565, NULL, 'G3DSA:3.40.50.410:FF:000089', NULL, NULL, 'Protein transport protein Sec24A', NULL, NULL, NULL, NULL, NULL, 4),
(186566, NULL, 'G3DSA:1.10.8.60:FF:000454', NULL, NULL, '26S protease regulatory subunit 6B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186567, NULL, 'G3DSA:3.40.50.1820:FF:001084', NULL, NULL, 'Amino acid adenylation domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(186568, NULL, 'G3DSA:2.30.180.10:FF:000129', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186569, NULL, 'G3DSA:3.80.10.10:FF:001236', NULL, NULL, 'Leucine-rich repeat (LRR) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(186570, NULL, 'G3DSA:3.40.50.790:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186571, NULL, 'G3DSA:2.130.10.10:FF:005682', NULL, NULL, 'WD repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186572, NULL, 'G3DSA:3.90.230.10:FF:000044', NULL, NULL, 'AGAP012802-PA', NULL, NULL, NULL, NULL, NULL, 4),
(186573, NULL, 'G3DSA:1.10.472.10:FF:000120', NULL, NULL, 'G1/S-specific cyclin-D1', NULL, NULL, NULL, NULL, NULL, 4),
(186574, NULL, 'G3DSA:2.60.40.150:FF:000025', NULL, NULL, 'Extended synaptotagmin 2', NULL, NULL, NULL, NULL, NULL, 4),
(186575, NULL, 'G3DSA:2.10.110.10:FF:000017', NULL, NULL, 'Lim and senescent cell antigen-like-containing', NULL, NULL, NULL, NULL, NULL, 4),
(186576, NULL, 'G3DSA:3.40.1000.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186577, NULL, 'G3DSA:3.40.190.290:FF:000054', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(186578, NULL, 'G3DSA:3.40.30.10:FF:000429', NULL, NULL, 'Protein CBG18827', NULL, NULL, NULL, NULL, NULL, 4),
(186579, NULL, 'G3DSA:3.90.1640.10:FF:000012', NULL, NULL, 'DHH phosphoesterase', NULL, NULL, NULL, NULL, NULL, 4),
(186580, NULL, 'G3DSA:1.10.238.10:FF:000076', NULL, NULL, 'SPARC-related modular calcium binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(186581, NULL, 'G3DSA:3.10.100.10:FF:000316', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186582, NULL, 'G3DSA:2.40.30.10:FF:000218', NULL, NULL, 'NAD(P)H-flavin reductase', NULL, NULL, NULL, NULL, NULL, 4),
(186583, NULL, 'G3DSA:2.160.10.10:FF:000060', NULL, NULL, 'UTP--glucose-1-phosphate uridylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(186584, NULL, 'G3DSA:2.60.40.60:FF:000570', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186585, NULL, 'G3DSA:2.70.130.10:FF:000106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186586, NULL, 'G3DSA:3.30.830.10:FF:000221', NULL, NULL, '[Pyruvate dehydrogenase (Acetyl-transferring)] kinase mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(186587, NULL, 'G3DSA:3.90.70.10:FF:000115', NULL, NULL, 'DOA4p Ubiquitin hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(186588, NULL, 'G3DSA:1.10.1780.10:FF:000008', NULL, NULL, 'Chaperone protein ClpB', NULL, NULL, NULL, NULL, NULL, 4),
(186589, NULL, 'G3DSA:3.40.50.10330:FF:000078', NULL, NULL, 'Mitochondrial NADH kinase POS5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186590, NULL, 'G3DSA:1.50.40.10:FF:000165', NULL, NULL, 'Mitochondrial Carrier (MC) Family', NULL, NULL, NULL, NULL, NULL, 4),
(186591, NULL, 'G3DSA:1.10.400.10:FF:000010', NULL, NULL, 'Guanine nucleotide-binding protein alpha-13 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(186592, NULL, 'G3DSA:3.40.50.2300:FF:000975', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186593, NULL, 'G3DSA:1.10.10.60:FF:000292', NULL, NULL, 'Acetoacetate metabolism regulatory protein AtoC', NULL, NULL, NULL, NULL, NULL, 4),
(186594, NULL, 'G3DSA:2.30.29.30:FF:001317', NULL, NULL, 'SHANK associated RH domain interactor', NULL, NULL, NULL, NULL, NULL, 4),
(186595, NULL, 'G3DSA:3.40.50.300:FF:004451', NULL, NULL, 'AGAP004685-PA', NULL, NULL, NULL, NULL, NULL, 4),
(186596, NULL, 'G3DSA:2.40.100.10:FF:000156', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(186597, NULL, 'G3DSA:3.40.50.300:FF:004760', NULL, NULL, 'Guanine nucleotide-binding protein G(k) subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(186598, NULL, 'G3DSA:3.10.20.90:FF:000566', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186599, NULL, 'G3DSA:2.40.50.140:FF:000894', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186600, NULL, 'G3DSA:2.30.30.40:FF:000082', NULL, NULL, 'SH3 and PX domain-containing protein 2B', NULL, NULL, NULL, NULL, NULL, 4),
(186601, NULL, 'G3DSA:3.40.1620.60:FF:000009', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs adt-2', NULL, NULL, NULL, NULL, NULL, 4),
(186602, NULL, 'G3DSA:1.20.5.190:FF:000124', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186603, NULL, 'G3DSA:2.70.98.110:FF:000003', NULL, NULL, 'Probable mannosyl-oligosaccharide glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(186604, NULL, 'G3DSA:2.130.10.10:FF:001966', NULL, NULL, 'Ribosome biogenesis protein NSA1', NULL, NULL, NULL, NULL, NULL, 4),
(186605, NULL, 'G3DSA:3.40.630.30:FF:000597', NULL, NULL, 'Glucosamine 6-phosphate N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(186606, NULL, 'G3DSA:3.70.10.10:FF:000051', NULL, NULL, 'Proliferating cell nuclear antigen', NULL, NULL, NULL, NULL, NULL, 4),
(186607, NULL, 'G3DSA:2.40.10.10:FF:000335', NULL, NULL, 'Serine protease H65', NULL, NULL, NULL, NULL, NULL, 4),
(186608, NULL, 'G3DSA:2.30.29.30:FF:000828', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186609, NULL, 'G3DSA:1.10.8.960:FF:000003', NULL, NULL, 'Gamma-glutamylcysteine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(186610, NULL, 'G3DSA:3.10.100.10:FF:000007', NULL, NULL, 'L-selectin', NULL, NULL, NULL, NULL, NULL, 4),
(186611, NULL, 'G3DSA:3.40.30.10:FF:000738', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186612, NULL, 'G3DSA:4.10.670.10:FF:000001', NULL, NULL, 'cholecystokinin receptor type A', NULL, NULL, NULL, NULL, NULL, 4),
(186613, NULL, 'G3DSA:3.30.200.20:FF:001593', NULL, NULL, 'AGAP005763-PA', NULL, NULL, NULL, NULL, NULL, 4),
(186614, NULL, 'G3DSA:1.20.1270.60:FF:000275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186615, NULL, 'G3DSA:3.40.1280.30:FF:000013', NULL, NULL, 'tRNA methyltransferase 10 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(186616, NULL, 'G3DSA:1.25.10.10:FF:000064', NULL, NULL, 'Sister chromatid cohesion protein PDS5 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(186617, NULL, 'G3DSA:3.40.50.300:FF:005980', NULL, NULL, 'CRISPR-associated helicase/endonuclease Cas3', NULL, NULL, NULL, NULL, NULL, 4),
(186618, NULL, 'G3DSA:3.55.50.30:FF:000004', NULL, NULL, 'Type III secretion outer membrane pore YscC', NULL, NULL, NULL, NULL, NULL, 4),
(186619, NULL, 'G3DSA:3.40.50.1700:FF:000008', NULL, NULL, 'Beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(186620, NULL, 'G3DSA:3.40.190.10:FF:000040', NULL, NULL, 'Glutamate receptor, ionotropic, delta 2', NULL, NULL, NULL, NULL, NULL, 4),
(186621, NULL, 'G3DSA:3.90.70.10:FF:000632', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186622, NULL, 'G3DSA:3.40.50.150:FF:000314', NULL, NULL, '2-methoxy-6-polyprenyl-1,4-benzoquinol methylase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(186623, NULL, 'G3DSA:3.40.50.10810:FF:000109', NULL, NULL, 'SNF2 domain-containing protein CLASSY 4', NULL, NULL, NULL, NULL, NULL, 4),
(186624, NULL, 'G3DSA:3.30.60.30:FF:000067', NULL, NULL, 'Thrombin inhibitor rhodniin', NULL, NULL, NULL, NULL, NULL, 4),
(186625, NULL, 'G3DSA:3.30.60.20:FF:000064', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(186626, NULL, 'G3DSA:3.30.160.60:FF:004046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186627, NULL, 'G3DSA:3.90.1310.10:FF:000010', NULL, NULL, 'Probable peptidoglycan D,D-transpeptidase PenA', NULL, NULL, NULL, NULL, NULL, 4),
(186628, NULL, 'G3DSA:2.60.120.260:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186629, NULL, 'G3DSA:3.90.70.10:FF:000087', NULL, NULL, 'Counting factor associated protein D', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(186630, NULL, 'G3DSA:3.90.190.10:FF:000557', NULL, NULL, 'Dual-specificity protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186631, NULL, 'G3DSA:2.60.40.60:FF:000244', NULL, NULL, 'Cadherin related family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(186632, NULL, 'G3DSA:3.30.160.60:FF:001876', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186633, NULL, 'G3DSA:3.40.50.1820:FF:000595', NULL, NULL, 'Alpha/beta hydrolase family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186634, NULL, 'G3DSA:3.80.10.10:FF:000865', NULL, NULL, 'Leucine-rich repeat-containing protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(186635, NULL, 'G3DSA:3.80.10.10:FF:001371', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186636, NULL, 'G3DSA:1.20.140.40:FF:000007', NULL, NULL, 'Pectinesterase inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(186637, NULL, 'G3DSA:2.40.70.10:FF:000327', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186638, NULL, 'G3DSA:3.60.21.10:FF:000155', NULL, NULL, 'Metallophosphoesterase', NULL, NULL, NULL, NULL, NULL, 4),
(186639, NULL, 'G3DSA:1.20.144.10:FF:000142', NULL, NULL, 'Putative lipid phosphate phosphatase 3 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(186640, NULL, 'G3DSA:3.40.1360.10:FF:000053', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(186641, NULL, 'G3DSA:1.10.10.10:FF:002036', NULL, NULL, 'Putative DNA processing protein DprA', NULL, NULL, NULL, NULL, NULL, 4),
(186642, NULL, 'G3DSA:2.160.20.10:FF:000015', NULL, NULL, 'F-box only protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(186643, NULL, 'G3DSA:3.30.70.1660:FF:000004', NULL, NULL, 'Peptide chain release factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(186644, NULL, 'G3DSA:1.10.238.10:FF:000222', NULL, NULL, 'Secretagogin', NULL, NULL, NULL, NULL, NULL, 4),
(186645, NULL, 'G3DSA:2.60.40.10:FF:000235', NULL, NULL, 'Leucine-rich repeat and fibronectin type III domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(186646, NULL, 'G3DSA:3.30.1340.30:FF:000009', NULL, NULL, 'Tri-BON domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(186647, NULL, 'G3DSA:1.20.140.10:FF:000049', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(186648, NULL, 'G3DSA:3.90.550.10:FF:000427', NULL, NULL, 'Procollagen-lysine,2-oxoglutarate 5-dioxygenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(186649, NULL, 'G3DSA:3.40.1380.20:FF:000057', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(186650, NULL, 'G3DSA:1.10.150.240:FF:000034', NULL, NULL, 'Putative phosphoglycolate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(186651, NULL, 'G3DSA:3.30.40.10:FF:001633', NULL, NULL, 'Structure-specific endonuclease subunit SLX1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(186652, NULL, 'G3DSA:1.10.510.10:FF:002272', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186653, NULL, 'G3DSA:3.40.50.1240:FF:000050', NULL, NULL, 'Fructose-2,6-bisphosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186654, NULL, 'G3DSA:3.30.70.330:FF:001723', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186655, NULL, 'G3DSA:2.40.50.100:FF:000084', NULL, NULL, 'AGAP005119-PA', NULL, NULL, NULL, NULL, NULL, 4),
(186656, NULL, 'G3DSA:1.20.58.390:FF:000009', NULL, NULL, 'Cholinergic receptor nicotinic alpha 9 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(186657, NULL, 'G3DSA:2.60.40.150:FF:000351', NULL, NULL, 'Copine-A', NULL, NULL, NULL, NULL, NULL, 4),
(186658, NULL, 'G3DSA:3.30.497.10:FF:000125', NULL, NULL, 'Serpin family B member 2', NULL, NULL, NULL, NULL, NULL, 4),
(186659, NULL, 'G3DSA:1.10.1070.11:FF:000012', NULL, NULL, 'Phosphatidylinositol 4-kinase alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(186660, NULL, 'G3DSA:1.10.720.60:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186661, NULL, 'G3DSA:2.60.40.340:FF:000008', NULL, NULL, 'Dif, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(186662, NULL, 'G3DSA:2.40.50.730:FF:000020', NULL, NULL, 'DNA polymerase alpha catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(186663, NULL, 'G3DSA:3.40.1370.10:FF:000025', NULL, NULL, 'Related to 50S ribosomal protein L4', NULL, NULL, NULL, NULL, NULL, 4),
(186664, NULL, 'G3DSA:1.25.40.10:FF:000212', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g03380, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(186665, NULL, 'G3DSA:1.10.8.60:FF:000246', NULL, NULL, 'Phosphoglycerate transport system transcriptional regulatory protein PgtA', NULL, NULL, NULL, NULL, NULL, 4),
(186666, NULL, 'G3DSA:2.40.70.10:FF:000226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186667, NULL, 'G3DSA:1.20.1280.50:FF:000227', NULL, NULL, 'F-box protein pof7', NULL, NULL, NULL, NULL, NULL, 4),
(186668, NULL, 'G3DSA:3.30.160.60:FF:001775', NULL, NULL, 'PR domain containing 9', NULL, NULL, NULL, NULL, NULL, 4),
(186669, NULL, 'G3DSA:4.10.1060.10:FF:000019', NULL, NULL, 'Calpain 15', NULL, NULL, NULL, NULL, NULL, 4),
(186670, NULL, 'G3DSA:3.40.720.10:FF:000306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186671, NULL, 'G3DSA:3.90.1750.10:FF:000015', NULL, NULL, 'E3 ubiquitin-protein ligase HERC2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(186672, NULL, 'G3DSA:2.70.170.10:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186673, NULL, 'G3DSA:3.20.20.140:FF:000489', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(186674, NULL, 'G3DSA:1.20.1070.10:FF:001127', NULL, NULL, 'Rhodopsin, GQ-coupled', NULL, NULL, NULL, NULL, NULL, 4),
(186675, NULL, 'G3DSA:3.30.460.10:FF:000069', NULL, NULL, 'Mitochondrial editosome-like complex associated TUTase', NULL, NULL, NULL, NULL, NULL, 4),
(186676, NULL, 'G3DSA:3.30.70.330:FF:001824', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186677, NULL, 'G3DSA:1.20.120.1760:FF:000062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186678, NULL, 'G3DSA:2.120.10.30:FF:000511', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186679, NULL, 'G3DSA:2.60.40.10:FF:003888', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186680, NULL, 'G3DSA:1.25.10.10:FF:001492', NULL, NULL, 'Catenin (cadherin-associated protein), delta 2b', NULL, NULL, NULL, NULL, NULL, 4),
(186681, NULL, 'G3DSA:1.20.58.2220:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186682, NULL, 'G3DSA:4.10.365.10:FF:000005', NULL, NULL, 'Cyclin-dependent kinase inhibitor 7', NULL, NULL, NULL, NULL, NULL, 4),
(186683, NULL, 'G3DSA:2.130.10.10:FF:000213', NULL, NULL, 'gem-associated protein 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(186684, NULL, 'G3DSA:2.60.120.10:FF:000187', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(186685, NULL, 'G3DSA:1.20.58.80:FF:000031', NULL, NULL, 'Protein CBG12661', NULL, NULL, NULL, NULL, NULL, 4),
(186686, NULL, 'G3DSA:3.80.10.10:FF:003136', NULL, NULL, 'Predicted gene 45213', NULL, NULL, NULL, NULL, NULL, 4),
(186687, NULL, 'G3DSA:2.10.220.10:FF:000155', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(186688, NULL, 'G3DSA:1.10.8.270:FF:000010', NULL, NULL, 'Putative USP6 N-terminal-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(186689, NULL, 'G3DSA:1.20.120.1900:FF:000031', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(186690, NULL, 'G3DSA:3.30.160.60:FF:006081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186691, NULL, 'G3DSA:2.60.200.20:FF:000241', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(186692, NULL, 'G3DSA:1.20.1560.10:FF:000838', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186693, NULL, 'G3DSA:2.40.100.10:FF:000055', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(186694, NULL, 'G3DSA:1.20.1070.10:FF:001806', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(186695, NULL, 'G3DSA:3.90.550.10:FF:000326', NULL, NULL, 'Procollagen-lysine,2-oxoglutarate 5-dioxygenase 2', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(186696, NULL, 'G3DSA:1.10.287.700:FF:000003', NULL, NULL, 'Late embryogenesis abundant protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(186697, NULL, 'G3DSA:1.25.10.10:FF:002407', NULL, NULL, 'Proteasome/cyclosome repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(186698, NULL, 'G3DSA:1.10.10.60:FF:000191', NULL, NULL, 'GON-4-like protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(186699, NULL, 'G3DSA:3.40.50.300:FF:004552', NULL, NULL, 'Death-associated protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(186700, NULL, 'G3DSA:3.40.30.10:FF:000946', NULL, NULL, 'Thioredoxin-1', NULL, NULL, NULL, NULL, NULL, 4),
(186701, NULL, 'G3DSA:3.30.1340.10:FF:000003', NULL, NULL, 'Phosphocarrier protein HPr', NULL, NULL, NULL, NULL, NULL, 4),
(186702, NULL, 'G3DSA:3.30.160.60:FF:000347', NULL, NULL, 'PR domain zinc finger protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(186703, NULL, 'G3DSA:3.10.20.90:FF:000358', NULL, NULL, 'Serine/threonine-protein kinase WNK', NULL, NULL, NULL, NULL, NULL, 4),
(186704, NULL, 'G3DSA:1.20.1250.20:FF:000874', NULL, NULL, 'SoLute Carrier Family', NULL, NULL, NULL, NULL, NULL, 4),
(186705, NULL, 'G3DSA:3.30.160.60:FF:000095', NULL, NULL, 'Vascular endothelial zinc finger 1', NULL, NULL, NULL, NULL, NULL, 4),
(186706, NULL, 'G3DSA:1.20.1070.10:FF:000773', NULL, NULL, 'Olfactory receptor family 2 subfamily B member 6', NULL, NULL, NULL, NULL, NULL, 4),
(186707, NULL, 'G3DSA:2.60.40.1970:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186708, NULL, 'G3DSA:3.40.140.10:FF:000211', NULL, NULL, 'tRNA(cytosine(8)) deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(186709, NULL, 'G3DSA:1.20.1560.10:FF:000529', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186710, NULL, 'G3DSA:2.30.30.40:FF:000418', NULL, NULL, 'Meiotically up-regulated gene 137 protein', NULL, NULL, NULL, NULL, NULL, 4),
(186711, NULL, 'G3DSA:1.20.120.1910:FF:000034', NULL, NULL, 'Cysteinyl-tRNA synthetase, class Ia family protein', NULL, NULL, NULL, NULL, NULL, 4),
(186712, NULL, 'G3DSA:3.40.50.300:FF:008251', NULL, NULL, 'Ribosomal protein L22p/L17e family protein', NULL, NULL, NULL, NULL, NULL, 4),
(186713, NULL, 'G3DSA:3.40.50.720:FF:001261', NULL, NULL, 'Ergot alkaloid biosynthetic protein A', NULL, NULL, NULL, NULL, NULL, 4),
(186714, NULL, 'G3DSA:3.40.630.30:FF:000389', NULL, NULL, 'Bifunctional protein argC, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(186715, NULL, 'G3DSA:1.10.240.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186716, NULL, 'G3DSA:2.40.50.100:FF:000185', NULL, NULL, 'Spermidine/putrescine ABC transporter ATP-binding', NULL, NULL, NULL, NULL, NULL, 4),
(186717, NULL, 'G3DSA:3.30.9.10:FF:000038', NULL, NULL, 'N-methyl-L-tryptophan oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(186718, NULL, 'G3DSA:3.10.20.90:FF:000903', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186719, NULL, 'G3DSA:3.30.499.10:FF:000006', NULL, NULL, '3-isopropylmalate dehydratase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(186720, NULL, 'G3DSA:1.10.510.10:FF:000563', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(186721, NULL, 'G3DSA:3.40.50.300:FF:004125', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(186722, NULL, 'G3DSA:3.30.230.130:FF:000053', NULL, NULL, 'Anaphase-promoting complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(186723, NULL, 'G3DSA:1.10.8.60:FF:000555', NULL, NULL, 'Cell division control protein 48 homolog C', NULL, NULL, NULL, NULL, NULL, 4),
(186724, NULL, 'G3DSA:1.10.10.10:FF:001738', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(186725, NULL, 'G3DSA:3.30.1680.10:FF:000051', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(186726, NULL, 'G3DSA:3.30.40.230:FF:000001', NULL, NULL, 'Glycine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(186727, NULL, 'G3DSA:3.30.230.70:FF:000103', NULL, NULL, 'Exosome complex component RRP42', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(186728, NULL, 'G3DSA:2.130.10.10:FF:004254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186729, NULL, 'G3DSA:3.30.9.10:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186730, NULL, 'G3DSA:3.30.160.60:FF:002590', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186731, NULL, 'G3DSA:3.30.200.20:FF:001149', NULL, NULL, 'SAPK/ERK kinase', NULL, NULL, NULL, NULL, NULL, 4),
(186732, NULL, 'G3DSA:3.40.50.261:FF:000005', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit alpha, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(186733, NULL, 'G3DSA:3.30.497.10:FF:000024', NULL, NULL, 'Spn43Ac', NULL, NULL, NULL, NULL, NULL, 4),
(186734, NULL, 'G3DSA:2.60.40.150:FF:000042', NULL, NULL, 'Copine 3', NULL, NULL, NULL, NULL, NULL, 4),
(186735, NULL, 'G3DSA:3.40.47.10:FF:000041', NULL, NULL, 'Lipid-transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(186736, NULL, 'G3DSA:3.20.20.140:FF:000388', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186737, NULL, 'G3DSA:1.20.58.390:FF:000318', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186738, NULL, 'G3DSA:3.30.9.90:FF:000005', NULL, NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186739, NULL, 'G3DSA:1.50.10.10:FF:000129', NULL, NULL, 'Endoplasmic reticulum mannosyl-oligosaccharide 1,2-alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(186740, NULL, 'G3DSA:3.90.1750.10:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186741, NULL, 'G3DSA:3.10.450.10:FF:000011', NULL, NULL, 'Cysteine proteinase inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(186742, NULL, 'G3DSA:1.10.10.1890:FF:000005', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(186743, NULL, 'G3DSA:1.25.40.20:FF:001884', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(186744, NULL, 'G3DSA:1.10.1140.10:FF:000005', NULL, NULL, 'ATP synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(186745, NULL, 'G3DSA:2.110.10.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186746, NULL, 'G3DSA:3.60.21.10:FF:000363', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186747, NULL, 'G3DSA:1.10.10.60:FF:000202', NULL, NULL, 'REST corepressor 2', NULL, NULL, NULL, NULL, NULL, 4),
(186748, NULL, 'G3DSA:2.30.29.30:FF:001290', NULL, NULL, 'Wiskott-Aldrich syndrome', NULL, NULL, NULL, NULL, NULL, 4),
(186749, NULL, 'G3DSA:3.40.50.300:FF:003737', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(186750, NULL, 'G3DSA:3.30.160.60:FF:002601', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186751, NULL, 'G3DSA:1.20.140.150:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186752, NULL, 'G3DSA:3.30.160.60:FF:000448', NULL, NULL, 'RE1-silencing transcription factor A', NULL, NULL, NULL, NULL, NULL, 4),
(186753, NULL, 'G3DSA:1.20.5.110:FF:000191', NULL, NULL, 'Syntaxin 16', NULL, NULL, NULL, NULL, NULL, 4),
(186754, NULL, 'G3DSA:1.10.287.90:FF:000022', NULL, NULL, 'Cytochrome c oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(186755, NULL, 'G3DSA:3.40.50.10800:FF:000005', NULL, NULL, 'Quinolinate synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(186756, NULL, 'G3DSA:3.40.50.300:FF:001000', NULL, NULL, 'Helicase and polymerase-containing protein TEBICHI', NULL, NULL, NULL, NULL, NULL, 4),
(186757, NULL, 'G3DSA:3.30.160.60:FF:005827', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186758, NULL, 'G3DSA:2.60.120.10:FF:000288', NULL, NULL, 'HSPB1-associated protein 1 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(186759, NULL, 'G3DSA:3.30.420.10:FF:000494', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186760, NULL, 'G3DSA:3.10.450.10:FF:000073', NULL, NULL, 'Stefin A3-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(186761, NULL, 'G3DSA:3.90.550.10:FF:000635', NULL, NULL, 'Glycoside transferase family 2', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(186762, NULL, 'G3DSA:3.40.630.30:FF:000182', NULL, NULL, 'Putative acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(186763, NULL, 'G3DSA:1.10.150.50:FF:000047', NULL, NULL, 'SEC23 interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(186764, NULL, 'G3DSA:3.10.20.90:FF:000151', NULL, NULL, 'NEDD8 ultimate buster 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(186765, NULL, 'G3DSA:2.60.40.10:FF:004405', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186766, NULL, 'G3DSA:1.25.40.10:FF:002561', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186767, NULL, 'G3DSA:3.40.640.10:FF:000204', NULL, NULL, 'Putative aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(186768, NULL, 'G3DSA:3.30.530.20:FF:000033', NULL, NULL, 'S-norcoclaurine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(186769, NULL, 'G3DSA:3.50.50.60:FF:001378', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(186770, NULL, 'G3DSA:3.40.50.2300:FF:001329', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186771, NULL, 'G3DSA:3.40.395.10:FF:000010', NULL, NULL, 'Sentrin-specific protease 1', NULL, NULL, NULL, NULL, NULL, 4),
(186772, NULL, 'G3DSA:3.40.250.10:FF:000186', NULL, NULL, 'Rhodanese-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(186773, NULL, 'G3DSA:4.10.860.120:FF:000027', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(186774, NULL, 'G3DSA:1.10.3120.10:FF:000004', NULL, NULL, 'Chloroplast trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(186775, NULL, 'G3DSA:1.10.1370.30:FF:000045', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(186776, NULL, 'G3DSA:3.80.10.10:FF:000764', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(186777, NULL, 'G3DSA:1.10.555.10:FF:000127', NULL, NULL, 'Rho GTPase activating protein 39', NULL, NULL, NULL, NULL, NULL, 4),
(186778, NULL, 'G3DSA:3.30.420.150:FF:000012', NULL, NULL, 'Golgi apyrase', NULL, NULL, NULL, NULL, NULL, 4),
(186779, NULL, 'G3DSA:3.40.50.300:FF:002534', NULL, NULL, 'Putative RecF protein', NULL, NULL, NULL, NULL, NULL, 4),
(186780, NULL, 'G3DSA:4.10.20.10:FF:000001', NULL, NULL, 'Protein Tat', NULL, NULL, NULL, NULL, NULL, 4),
(186781, NULL, 'G3DSA:3.40.50.10810:FF:000008', NULL, NULL, 'Chromatin structure-remodeling complex subunit snf21', NULL, NULL, NULL, NULL, NULL, 4),
(186782, NULL, 'G3DSA:2.60.40.10:FF:004714', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186783, NULL, 'G3DSA:1.10.10.10:FF:001429', NULL, NULL, 'Diphtheria toxin repressor', NULL, NULL, NULL, NULL, NULL, 4),
(186784, NULL, 'G3DSA:2.60.40.10:FF:000662', NULL, NULL, 'Tyrosine-protein kinase receptor UFO', NULL, NULL, NULL, NULL, NULL, 4),
(186785, NULL, 'G3DSA:1.25.40.10:FF:004152', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g34160', NULL, NULL, NULL, NULL, NULL, 4),
(186786, NULL, 'G3DSA:2.10.25.10:FF:000865', NULL, NULL, 'von Willebrand factor D and EGF domains', NULL, NULL, NULL, NULL, NULL, 4),
(186787, NULL, 'G3DSA:2.60.120.330:FF:000116', NULL, NULL, 'Oxidoreductase, 2OG-Fe(II) oxygenase family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186788, NULL, 'G3DSA:3.20.20.120:FF:000023', NULL, NULL, 'o-succinylbenzoate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(186789, NULL, 'G3DSA:2.40.170.20:FF:000006', NULL, NULL, 'Catecholate siderophore receptor fiu', NULL, NULL, NULL, NULL, NULL, 4),
(186790, NULL, 'G3DSA:3.90.1170.10:FF:000021', NULL, NULL, '50S ribosomal protein L10e', NULL, NULL, NULL, NULL, NULL, 4),
(186791, NULL, 'G3DSA:3.30.572.10:FF:000019', NULL, NULL, 'Bifunctional dihydrofolate reductase-thymidylate synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(186792, NULL, 'G3DSA:1.10.730.10:FF:000091', NULL, NULL, 'Methionine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(186793, NULL, 'G3DSA:3.40.50.300:FF:000073', NULL, NULL, 'Holliday junction ATP-dependent DNA helicase RuvB', NULL, NULL, NULL, NULL, NULL, 4),
(186794, NULL, 'G3DSA:1.25.10.10:FF:000300', NULL, NULL, 'U-box domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(186795, NULL, 'G3DSA:1.10.565.10:FF:000055', NULL, NULL, 'Nuclear hormone receptor family member nhr-31', NULL, NULL, NULL, NULL, NULL, 4),
(186796, NULL, 'G3DSA:3.40.120.10:FF:000103', NULL, NULL, 'Phosphoacetylglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(186797, NULL, 'G3DSA:3.30.70.330:FF:000998', NULL, NULL, 'U4/U6 snRNP-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(186798, NULL, 'G3DSA:1.10.150.80:FF:000005', NULL, NULL, 'Werner syndrome ATP-dependent helicase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(186799, NULL, 'G3DSA:1.10.150.530:FF:000014', NULL, NULL, 'Predicted Fe-S-cluster redox enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(186800, NULL, 'G3DSA:3.30.160.60:FF:000139', NULL, NULL, 'zinc finger protein 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(186801, NULL, 'G3DSA:3.40.120.10:FF:000092', NULL, NULL, 'Slr1334 protein', NULL, NULL, NULL, NULL, NULL, 4),
(186802, NULL, 'G3DSA:1.25.40.20:FF:000911', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186803, NULL, 'G3DSA:3.60.21.10:FF:000054', NULL, NULL, 'DCR2p Phosphoesterase', NULL, NULL, NULL, NULL, NULL, 4),
(186804, NULL, 'G3DSA:2.30.40.10:FF:000169', NULL, NULL, 'Probable chlorohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(186805, NULL, 'G3DSA:1.25.40.10:FF:001881', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186806, NULL, 'G3DSA:2.40.170.10:FF:000003', NULL, NULL, 'Maltoporin 2', NULL, NULL, NULL, NULL, NULL, 4),
(186807, NULL, 'G3DSA:3.40.50.300:FF:002843', NULL, NULL, 'Mitofusin 2', NULL, NULL, NULL, NULL, NULL, 4),
(186808, NULL, 'G3DSA:3.40.50.300:FF:007778', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186809, NULL, 'G3DSA:1.20.120.430:FF:000021', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(186810, NULL, 'G3DSA:1.20.1070.10:FF:000874', NULL, NULL, 'Wnt-receptor frizzled protein variant 2', NULL, NULL, NULL, NULL, NULL, 4),
(186811, NULL, 'G3DSA:3.30.930.10:FF:000386', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186812, NULL, 'G3DSA:1.10.238.10:FF:000531', NULL, NULL, 'GM20994', NULL, NULL, NULL, NULL, NULL, 4),
(186813, NULL, 'G3DSA:3.40.50.300:FF:000382', NULL, NULL, 'Lon protease homolog 2, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(186814, NULL, 'G3DSA:1.10.287.550:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186815, NULL, 'G3DSA:3.80.10.10:FF:001680', NULL, NULL, 'F-box domain protein (AFU_orthologue AFUA_2G02860)', NULL, NULL, NULL, NULL, NULL, 4),
(186816, NULL, 'G3DSA:1.10.238.10:FF:000104', NULL, NULL, 'calumenin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(186817, NULL, 'G3DSA:3.30.70.3000:FF:000007', NULL, NULL, 'tRNA(His) guanylyltransferase 2 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(186818, NULL, 'G3DSA:2.120.10.30:FF:000410', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186819, NULL, 'G3DSA:2.60.40.10:FF:003787', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186820, NULL, 'G3DSA:1.10.510.10:FF:001766', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186821, NULL, 'G3DSA:1.25.70.10:FF:000040', NULL, NULL, 'Mitochondrial transcription termination factor family protein', NULL, NULL, NULL, NULL, NULL, 4),
(186822, NULL, 'G3DSA:1.20.120.1750:FF:000160', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(186823, NULL, 'G3DSA:2.60.40.150:FF:000704', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186824, NULL, 'G3DSA:1.20.210.10:FF:000010', NULL, NULL, 'Nitric oxide reductase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(186825, NULL, 'G3DSA:2.130.10.10:FF:001758', NULL, NULL, 'Transcription factor TFIIIC complex subunit Tfc6, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186826, NULL, 'G3DSA:1.25.40.10:FF:002353', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186827, NULL, 'G3DSA:3.40.50.1820:FF:001275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(186828, NULL, 'G3DSA:1.10.630.10:FF:000757', NULL, NULL, 'Cytochrome P-450b (phenobarbital-inducible)', NULL, NULL, NULL, NULL, NULL, 4),
(186829, NULL, 'G3DSA:3.30.40.20:FF:000001', NULL, NULL, 'ORF1a polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(186830, NULL, 'G3DSA:3.40.50.1010:FF:000195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186831, NULL, 'G3DSA:3.40.50.1820:FF:001319', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186832, NULL, 'G3DSA:1.10.167.10:FF:000006', NULL, NULL, 'G protein-coupled receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(186833, NULL, 'G3DSA:3.30.160.60:FF:000656', NULL, NULL, 'Zinc finger protein 541', NULL, NULL, NULL, NULL, NULL, 4),
(186834, NULL, 'G3DSA:3.40.50.2300:FF:001582', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186835, NULL, 'G3DSA:2.60.40.10:FF:002253', NULL, NULL, 'Ig heavy chain V region 36-60', NULL, NULL, NULL, NULL, NULL, 4),
(186836, NULL, 'G3DSA:3.40.50.1000:FF:000192', NULL, NULL, 'CTD small phosphatase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(186837, NULL, 'G3DSA:3.30.40.10:FF:001280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186838, NULL, 'G3DSA:3.90.550.10:FF:000118', NULL, NULL, 'Molybdenum cofactor guanylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(186839, NULL, 'G3DSA:1.10.472.10:FF:000119', NULL, NULL, 'Cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(186840, NULL, 'G3DSA:2.170.270.10:FF:000154', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(186841, NULL, 'G3DSA:3.30.1490.20:FF:000028', NULL, NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(186842, NULL, 'G3DSA:1.10.533.10:FF:000245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186843, NULL, 'G3DSA:1.25.40.20:FF:000810', NULL, NULL, 'Ankyrin repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(186844, NULL, 'G3DSA:1.25.40.20:FF:000456', NULL, NULL, 'Ankyrin repeat and SOCS box protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(186845, NULL, 'G3DSA:3.90.470.20:FF:000019', NULL, NULL, 'L-aminoadipate-semialdehyde dehydrogenase-phosphopantetheinyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(186846, NULL, 'G3DSA:4.10.75.10:FF:000009', NULL, NULL, 'GD21069', NULL, NULL, NULL, NULL, NULL, 4),
(186847, NULL, 'G3DSA:3.30.360.10:FF:000005', NULL, NULL, 'Homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(186848, NULL, 'G3DSA:2.130.10.10:FF:000005', NULL, NULL, 'Putative echinoderm microtubule-associated protein-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(186849, NULL, 'G3DSA:1.25.40.60:FF:000002', NULL, NULL, 'Sec1 family domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(186850, NULL, 'G3DSA:3.30.565.10:FF:000424', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(186851, NULL, 'G3DSA:1.20.120.350:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186852, NULL, 'G3DSA:1.10.287.470:FF:000097', NULL, NULL, 'Gll2840 protein', NULL, NULL, NULL, NULL, NULL, 4),
(186853, NULL, 'G3DSA:3.90.740.10:FF:000009', NULL, NULL, 'Isoleucyl-tRNA synthetase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(186854, NULL, 'G3DSA:3.40.50.300:FF:004861', NULL, NULL, 'MutS domain III family protein', NULL, NULL, NULL, NULL, NULL, 4),
(186855, NULL, 'G3DSA:3.20.20.220:FF:000053', NULL, NULL, 'Putative proline dehydrogenase (Monofunctional)', NULL, NULL, NULL, NULL, NULL, 4),
(186856, NULL, 'G3DSA:3.40.30.10:FF:000385', NULL, NULL, 'NADH:ubiquinone oxidoreductase subunit A2', NULL, NULL, NULL, NULL, NULL, 4),
(186857, NULL, 'G3DSA:3.10.110.10:FF:000070', NULL, NULL, 'RWD domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(186858, NULL, 'G3DSA:3.30.450.190:FF:000013', NULL, NULL, 'RAs-related GTP-binding protein A', NULL, NULL, NULL, NULL, NULL, 4),
(186859, NULL, 'G3DSA:3.10.250.10:FF:000092', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186860, NULL, 'G3DSA:3.40.50.200:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(186861, NULL, 'G3DSA:3.40.50.200:FF:000043', NULL, NULL, 'Peptidase S8', NULL, NULL, NULL, NULL, NULL, 4),
(186862, NULL, 'G3DSA:2.10.220.10:FF:000037', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(186863, NULL, 'G3DSA:1.10.760.10:FF:000031', NULL, NULL, 'Di-heme cytochrome C peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(186864, NULL, 'G3DSA:2.60.40.10:FF:005479', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186865, NULL, 'G3DSA:4.10.410.10:FF:000027', NULL, NULL, 'Si:dkeyp-73b11.8', NULL, NULL, NULL, NULL, NULL, 4),
(186866, NULL, 'G3DSA:3.60.21.10:FF:000464', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186867, NULL, 'G3DSA:1.20.1250.20:FF:001554', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186868, NULL, 'G3DSA:3.30.230.10:FF:000001', NULL, NULL, '30S ribosomal protein S9', NULL, NULL, NULL, NULL, NULL, 4),
(186869, NULL, 'G3DSA:2.60.40.10:FF:005833', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186870, NULL, 'G3DSA:2.40.10.10:FF:000144', NULL, NULL, 'AGAP011783-PA', NULL, NULL, NULL, NULL, NULL, 4),
(186871, NULL, 'G3DSA:3.40.50.300:FF:008604', NULL, NULL, 'Transitional endoplasmic reticulum ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186872, NULL, 'G3DSA:3.40.630.150:FF:000029', NULL, NULL, 'Malonyl-CoA decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(186873, NULL, 'G3DSA:2.60.120.700:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186874, NULL, 'G3DSA:3.40.50.1100:FF:000025', NULL, NULL, 'Tryptophan synthase beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(186875, NULL, 'G3DSA:1.10.10.10:FF:001839', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186876, NULL, 'G3DSA:2.10.25.10:FF:001028', NULL, NULL, 'Drosophila CRumBs homolog', NULL, NULL, NULL, NULL, NULL, 4),
(186877, NULL, 'G3DSA:2.60.120.1000:FF:000025', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(186878, NULL, 'G3DSA:3.40.50.1460:FF:000099', NULL, NULL, 'Caspase 1b', NULL, NULL, NULL, NULL, NULL, 4),
(186879, NULL, 'G3DSA:3.50.50.60:FF:000052', NULL, NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(186880, NULL, 'G3DSA:1.10.540.10:FF:000048', NULL, NULL, 'Acyl-CoA dehydrogenase FadE18', NULL, NULL, NULL, NULL, NULL, 4),
(186881, NULL, 'G3DSA:3.30.300.10:FF:000029', NULL, NULL, 'S-adenosylmethionine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(186882, NULL, 'G3DSA:2.60.40.10:FF:005378', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186883, NULL, 'G3DSA:1.20.1070.10:FF:001700', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186884, NULL, 'G3DSA:2.30.30.380:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186885, NULL, 'G3DSA:2.60.120.10:FF:000642', NULL, NULL, 'Jumonji domain-containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(186886, NULL, 'G3DSA:3.40.50.2020:FF:000076', NULL, NULL, 'Phosphoribosylpyrophosphate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(186887, NULL, 'G3DSA:3.40.50.300:FF:008133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186888, NULL, 'G3DSA:2.30.180.10:FF:000113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186889, NULL, 'G3DSA:3.90.550.10:FF:000220', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(186890, NULL, 'G3DSA:1.20.5.340:FF:000130', NULL, NULL, 'ATP-dependent RNA helicase DHH1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186891, NULL, 'G3DSA:1.20.810.10:FF:000022', NULL, NULL, 'Cytochrome b', NULL, NULL, NULL, NULL, NULL, 4),
(186892, NULL, 'G3DSA:3.90.70.10:FF:000071', NULL, NULL, 'ubiquitin carboxyl-terminal hydrolase 30 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(186893, NULL, 'G3DSA:3.90.550.50:FF:000170', NULL, NULL, 'Glycoprotein-N-acetylgalactosamine 3-beta-galactosyltransferase 1-B-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(186894, NULL, 'G3DSA:3.30.1490.150:FF:000002', NULL, NULL, 'YOR289W-like protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(186895, NULL, 'G3DSA:3.40.532.10:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186896, NULL, 'G3DSA:3.30.200.20:FF:001492', NULL, NULL, 'Protein kinase, putative (AFU_orthologue AFUA_6G09240)', NULL, NULL, NULL, NULL, NULL, 4),
(186897, NULL, 'G3DSA:2.40.30.10:FF:000252', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(186898, NULL, 'G3DSA:3.30.160.60:FF:000241', NULL, NULL, 'Wilms tumor 1-KTS isoform', NULL, NULL, NULL, NULL, NULL, 4),
(186899, NULL, 'G3DSA:1.10.472.130:FF:000024', NULL, NULL, 'Putative dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(186900, NULL, 'G3DSA:2.60.40.1120:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186901, NULL, 'G3DSA:2.40.70.10:FF:000120', NULL, NULL, 'Aspartic proteinase nepenthesin-2', NULL, NULL, NULL, NULL, NULL, 4),
(186902, NULL, 'G3DSA:3.40.50.720:FF:001570', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186903, NULL, 'G3DSA:3.30.70.3400:FF:000004', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(186904, NULL, 'G3DSA:3.30.310.10:FF:000047', NULL, NULL, 'TATA-box-binding protein C', NULL, NULL, NULL, NULL, NULL, 4),
(186905, NULL, 'G3DSA:2.30.180.10:FF:000023', NULL, NULL, 'periostin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(186906, NULL, 'G3DSA:3.30.70.330:FF:000897', NULL, NULL, 'Scaffold attachment factor B2', NULL, NULL, NULL, NULL, NULL, 4),
(186907, NULL, 'G3DSA:1.50.40.10:FF:000266', NULL, NULL, 'Putative ADP,ATP carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(186908, NULL, 'G3DSA:1.25.10.10:FF:002525', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186909, NULL, 'G3DSA:3.90.550.10:FF:000074', NULL, NULL, 'N-acylneuraminate cytidylyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(186910, NULL, 'G3DSA:3.30.200.20:FF:000064', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(186911, NULL, 'G3DSA:3.30.565.10:FF:000172', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(186912, NULL, 'G3DSA:3.30.160.60:FF:002702', NULL, NULL, 'Zinc finger protein 668', NULL, NULL, NULL, NULL, NULL, 4),
(186913, NULL, 'G3DSA:1.20.1310.10:FF:000207', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186914, NULL, 'G3DSA:3.30.450.20:FF:000695', NULL, NULL, 'Chemotaxis signal transduction system methyl accepting sensory transducer', NULL, NULL, NULL, NULL, NULL, 4),
(186915, NULL, 'G3DSA:1.25.40.540:FF:000023', NULL, NULL, 'Chromosome 21, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(186916, NULL, 'G3DSA:3.40.30.10:FF:000637', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(186917, NULL, 'G3DSA:3.40.50.1820:FF:001421', NULL, NULL, 'Autocrine proliferation repressor protein A', NULL, NULL, NULL, NULL, NULL, 4),
(186918, NULL, 'G3DSA:3.40.50.1820:FF:001730', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186919, NULL, 'G3DSA:3.30.1370.140:FF:000001', NULL, NULL, 'Putative hydrogenase expression/formation protein', NULL, NULL, NULL, NULL, NULL, 4),
(186920, NULL, 'G3DSA:1.10.1760.10:FF:000007', NULL, NULL, 'Actin-related protein 2/3 complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(186921, NULL, 'G3DSA:3.30.70.100:FF:000148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186922, NULL, 'G3DSA:1.20.5.2440:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186923, NULL, 'G3DSA:3.50.30.30:FF:000093', NULL, NULL, 'YALI0D09735p', NULL, NULL, NULL, NULL, NULL, 4),
(186924, NULL, 'G3DSA:2.60.40.1180:FF:000168', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(186925, NULL, 'G3DSA:1.25.10.10:FF:001598', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186926, NULL, 'G3DSA:3.40.50.2000:FF:000992', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186927, NULL, 'G3DSA:3.40.50.1000:FF:000293', NULL, NULL, 'Aminophospholipid transporter, putative', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(186928, NULL, 'G3DSA:3.90.70.10:FF:000323', NULL, NULL, 'Calpain family cysteine protease-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(186929, NULL, 'G3DSA:2.120.10.30:FF:000056', NULL, NULL, 'Low-density lipoprotein receptor-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(186930, NULL, 'G3DSA:2.30.29.30:FF:001109', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(186931, NULL, 'G3DSA:3.10.660.10:FF:000010', NULL, NULL, 'Diphthamide biosynthesis protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(186932, NULL, 'G3DSA:1.10.1600.10:FF:000024', NULL, NULL, 'X-ray repair cross-complementing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(186933, NULL, 'G3DSA:3.30.160.60:FF:003984', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186934, NULL, 'G3DSA:1.25.40.10:FF:001847', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(186935, NULL, 'G3DSA:3.90.226.10:FF:000146', NULL, NULL, 'Carboxy-terminal processing protease', NULL, NULL, NULL, NULL, NULL, 4),
(186936, NULL, 'G3DSA:2.120.10.30:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186937, NULL, 'G3DSA:2.60.40.10:FF:003579', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186938, NULL, 'G3DSA:3.40.50.300:FF:002091', NULL, NULL, 'Dynein-related AAA-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(186939, NULL, 'G3DSA:2.170.190.11:FF:000008', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(186940, NULL, 'G3DSA:2.10.25.10:FF:001270', NULL, NULL, 'Receptor tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(186941, NULL, 'G3DSA:2.30.30.140:FF:000347', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(186942, NULL, 'G3DSA:3.40.50.300:FF:007986', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186943, NULL, 'G3DSA:1.25.40.10:FF:004253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186944, NULL, 'G3DSA:1.25.10.10:FF:000373', NULL, NULL, 'Importin beta-5 subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186945, NULL, 'G3DSA:2.90.20.10:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186946, NULL, 'G3DSA:1.20.5.4820:FF:000005', NULL, NULL, 'Myosin IIIB', NULL, NULL, NULL, NULL, NULL, 4),
(186947, NULL, 'G3DSA:3.40.50.300:FF:002181', NULL, NULL, 'ATP-dependent RNA helicase DBP9, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186948, NULL, 'G3DSA:3.30.70.240:FF:000033', NULL, NULL, 'Elongation factor Tu GTP binding domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(186949, NULL, 'G3DSA:2.60.40.60:FF:000098', NULL, NULL, 'cadherin-23 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(186950, NULL, 'G3DSA:2.60.40.10:FF:001781', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(186951, NULL, 'G3DSA:3.30.420.40:FF:000154', NULL, NULL, 'Fructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(186952, NULL, 'G3DSA:2.60.40.640:FF:000082', NULL, NULL, 'Vacuolar sorting protein 26 putative', NULL, NULL, NULL, NULL, NULL, 4),
(186953, NULL, 'G3DSA:3.10.120.10:FF:000008', NULL, NULL, 'Nitrate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(186954, NULL, 'G3DSA:2.30.29.30:FF:000946', NULL, NULL, 'General transcription factor IIH subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(186955, NULL, 'G3DSA:3.10.25.10:FF:000020', NULL, NULL, 'Aldehyde dehydrogenase 1 family, member L2', NULL, NULL, NULL, NULL, NULL, 4),
(186956, NULL, 'G3DSA:3.30.1360.10:FF:000021', NULL, NULL, 'DNA-directed RNA polymerase II subunit RPB3', NULL, NULL, NULL, NULL, NULL, 4),
(186957, NULL, 'G3DSA:1.10.510.10:FF:002581', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186958, NULL, 'G3DSA:3.30.70.890:FF:000025', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(186959, NULL, 'G3DSA:3.30.160.60:FF:006401', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186960, NULL, 'G3DSA:2.60.200.10:FF:000030', NULL, NULL, 'Interferon regulatory factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(186961, NULL, 'G3DSA:1.10.560.10:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(186962, NULL, 'G3DSA:2.130.10.10:FF:001848', NULL, NULL, 'UTP13p Nucleolar protein', NULL, NULL, NULL, NULL, NULL, 4),
(186963, NULL, 'G3DSA:2.30.42.10:FF:000201', NULL, NULL, 'delphilin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(186964, NULL, 'G3DSA:3.40.50.150:FF:000522', NULL, NULL, 'Glycine/sarcosine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(186965, NULL, 'G3DSA:3.30.160.60:FF:000802', NULL, NULL, 'CCCTC-binding factor like', NULL, NULL, NULL, NULL, NULL, 4),
(186966, NULL, 'G3DSA:3.30.160.60:FF:004708', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186967, NULL, 'G3DSA:3.30.450.40:FF:000234', NULL, NULL, 'Sensor domain-containing diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(186968, NULL, 'G3DSA:3.90.1480.20:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186969, NULL, 'G3DSA:3.40.50.2300:FF:001672', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186970, NULL, 'G3DSA:3.40.50.10810:FF:000211', NULL, NULL, 'SWI/SNF chromatin remodeling complex component', NULL, NULL, NULL, NULL, NULL, 4),
(186971, NULL, 'G3DSA:1.25.40.10:FF:003680', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g57430, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(186972, NULL, 'G3DSA:3.30.540.30:FF:000008', NULL, NULL, 'Dipeptidyl peptidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(186973, NULL, 'G3DSA:1.10.510.10:FF:004262', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186974, NULL, 'G3DSA:3.40.1160.10:FF:000088', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(186975, NULL, 'G3DSA:3.30.160.650:FF:000001', NULL, NULL, 'Alkylglycerone-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(186976, NULL, 'G3DSA:3.30.70.330:FF:001515', NULL, NULL, 'YHR086Wp-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(186977, NULL, 'G3DSA:2.70.170.10:FF:000215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186978, NULL, 'G3DSA:3.40.50.300:FF:006143', NULL, NULL, 'Cdc42 homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(186979, NULL, 'G3DSA:2.10.70.10:FF:000054', NULL, NULL, 'Complement inhibitory factor H', NULL, NULL, NULL, NULL, NULL, 4),
(186980, NULL, 'G3DSA:1.20.1530.20:FF:000081', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(186981, NULL, 'G3DSA:3.90.1420.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(186982, NULL, 'G3DSA:3.30.40.10:FF:001841', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(186983, NULL, 'G3DSA:3.80.10.10:FF:001028', NULL, NULL, 'Putative leucine-rich repeat receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(186984, NULL, 'G3DSA:2.60.40.60:FF:000452', NULL, NULL, 'Cadherin-89D', NULL, NULL, NULL, NULL, NULL, 4),
(186985, NULL, 'G3DSA:2.60.40.60:FF:000761', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(186986, NULL, 'G3DSA:1.25.10.10:FF:002216', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(186987, NULL, 'G3DSA:1.20.1250.20:FF:001700', NULL, NULL, 'Protein CBG12921', NULL, NULL, NULL, NULL, NULL, 4),
(186988, NULL, 'G3DSA:3.30.540.10:FF:000002', NULL, NULL, 'Fructose-1,6-bisphosphatase class 1', NULL, NULL, NULL, NULL, NULL, 4),
(186989, NULL, 'G3DSA:3.30.2140.20:FF:000025', NULL, NULL, 'Arylamine N-acetyltransferase 4', NULL, NULL, NULL, NULL, NULL, 4),
(186990, NULL, 'G3DSA:3.90.1150.220:FF:000003', NULL, NULL, 'Putative DNA repair protein Nse1', NULL, NULL, NULL, NULL, NULL, 4),
(186991, NULL, 'G3DSA:3.30.70.330:FF:002797', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(186992, NULL, 'G3DSA:1.10.3380.10:FF:000046', NULL, NULL, 'Type III restriction enzyme, res subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(186993, NULL, 'G3DSA:3.20.20.370:FF:000002', NULL, NULL, 'Probable 4-deoxy-4-formamido-L-arabinose-phosphoundecaprenol deformylase ArnD', NULL, NULL, NULL, NULL, NULL, 4),
(186994, NULL, 'G3DSA:2.10.25.10:FF:000764', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(186995, NULL, 'G3DSA:3.30.830.10:FF:000103', NULL, NULL, 'Metalloprotease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(186996, NULL, 'G3DSA:1.10.3720.10:FF:000207', NULL, NULL, 'Molybdenum transport system permease', NULL, NULL, NULL, NULL, NULL, 4),
(186997, NULL, 'G3DSA:1.10.1040.10:FF:000088', NULL, NULL, 'Ketopantoate reductase PanE/ApbA-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(186998, NULL, 'G3DSA:4.10.640.10:FF:000027', NULL, NULL, '30S ribosomal protein S18', NULL, NULL, NULL, NULL, NULL, 4),
(186999, NULL, 'G3DSA:3.40.50.150:FF:000213', NULL, NULL, 'Methyltransferases,nucleic acid binding', NULL, NULL, NULL, NULL, NULL, 4),
(187000, NULL, 'G3DSA:3.50.4.10:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187001, NULL, 'G3DSA:1.20.1280.50:FF:000109', NULL, NULL, 'F-box protein family-like', NULL, NULL, NULL, NULL, NULL, 4),
(187002, NULL, 'G3DSA:2.20.25.10:FF:000106', NULL, NULL, '2-oxo-1,2-dihydroquinoline 8-monooxygenase, oxygenase component', NULL, NULL, NULL, NULL, NULL, 4),
(187003, NULL, 'G3DSA:3.40.50.1240:FF:000016', NULL, NULL, 'Ubiquitin-associated and SH3 domain-containing protein A', NULL, NULL, NULL, NULL, NULL, 4),
(187004, NULL, 'G3DSA:3.80.10.10:FF:003170', NULL, NULL, 'Protein pof5', NULL, NULL, NULL, NULL, NULL, 4),
(187005, NULL, 'G3DSA:3.40.1190.10:FF:000028', NULL, NULL, 'GD22722', NULL, NULL, NULL, NULL, NULL, 4),
(187006, NULL, 'G3DSA:2.60.40.10:FF:001988', NULL, NULL, 'Juxtamembrane domain-associated catenin', NULL, NULL, NULL, NULL, NULL, 4),
(187007, NULL, 'G3DSA:1.10.287.940:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187008, NULL, 'G3DSA:2.130.10.10:FF:003439', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187009, NULL, 'G3DSA:2.60.40.150:FF:000143', NULL, NULL, 'Type II inositol 3,4-bisphosphate 4-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(187010, NULL, 'G3DSA:2.40.10.10:FF:000453', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187011, NULL, 'G3DSA:3.40.50.12790:FF:000001', NULL, NULL, 'Flagellar biosynthesis protein FlhA', NULL, NULL, NULL, NULL, NULL, 4),
(187012, NULL, 'G3DSA:1.10.150.130:FF:000001', NULL, NULL, 'Tyrosine recombinase XerC', NULL, NULL, NULL, NULL, NULL, 4),
(187013, NULL, 'G3DSA:1.25.40.10:FF:003438', NULL, NULL, 'Tetratricopeptide repeat domain 21B', NULL, NULL, NULL, NULL, NULL, 4),
(187014, NULL, 'G3DSA:3.40.50.800:FF:000127', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(187015, NULL, 'G3DSA:3.20.20.70:FF:000307', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(187016, NULL, 'G3DSA:3.30.160.60:FF:004147', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187017, NULL, 'G3DSA:3.40.50.1220:FF:000010', NULL, NULL, '2-succinyl-5-enolpyruvyl-6-hydroxy-3-cyclohexene-1-carboxylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(187018, NULL, 'G3DSA:1.10.287.950:FF:000027', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(187019, NULL, 'G3DSA:2.40.50.140:FF:001265', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187020, NULL, 'G3DSA:2.60.120.290:FF:000177', NULL, NULL, 'mannan-binding lectin serine protease 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(187021, NULL, 'G3DSA:3.40.390.10:FF:000111', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(187022, NULL, 'G3DSA:1.10.30.10:FF:000104', NULL, NULL, 'Transcription factor SOX-2', NULL, NULL, NULL, NULL, NULL, 4),
(187023, NULL, 'G3DSA:1.20.58.480:FF:000003', NULL, NULL, 'Indoleamine 2,3-dioxygenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(187024, NULL, 'G3DSA:4.10.400.10:FF:000156', NULL, NULL, 'basement membrane-specific heparan sulfate proteoglycan core protein isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(187025, NULL, 'G3DSA:3.40.800.10:FF:000003', NULL, NULL, 'Agmatinase', NULL, NULL, NULL, NULL, NULL, 4),
(187026, NULL, 'G3DSA:3.20.20.140:FF:000282', NULL, NULL, 'Metal-dependent hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(187027, NULL, 'G3DSA:1.10.3210.10:FF:000034', NULL, NULL, 'HD domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(187028, NULL, 'G3DSA:3.40.50.300:FF:006233', NULL, NULL, 'AGAP010699-PA', NULL, NULL, NULL, NULL, NULL, 4),
(187029, NULL, 'G3DSA:3.40.50.11380:FF:000005', NULL, NULL, 'Probable UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SPINDLY', NULL, NULL, NULL, NULL, NULL, 4),
(187030, NULL, 'G3DSA:2.130.10.10:FF:003748', NULL, NULL, 'Uncharacterized WD repeat-containing protein C1773.01', NULL, NULL, NULL, NULL, NULL, 4),
(187031, NULL, 'G3DSA:1.10.3450.20:FF:000010', NULL, NULL, 'Nuclear pore complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(187032, NULL, 'G3DSA:2.60.40.10:FF:003990', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187033, NULL, 'G3DSA:1.20.140.150:FF:000025', NULL, NULL, 'germ cell-specific gene 1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(187034, NULL, 'G3DSA:1.10.460.10:FF:000002', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(187035, NULL, 'G3DSA:3.40.800.20:FF:000006', NULL, NULL, 'Histone deacetylase 8', NULL, NULL, NULL, NULL, NULL, 4),
(187036, NULL, 'G3DSA:1.10.10.60:FF:000303', NULL, NULL, 'MYB transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(187037, NULL, 'G3DSA:2.60.200.40:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187038, NULL, 'G3DSA:2.60.200.20:FF:000033', NULL, NULL, 'proliferation marker protein Ki-67', NULL, NULL, NULL, NULL, NULL, 4),
(187039, NULL, 'G3DSA:3.30.1330.60:FF:000040', NULL, NULL, 'OmpA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(187040, NULL, 'G3DSA:1.20.1270.280:FF:000027', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(187041, NULL, 'G3DSA:3.30.559.70:FF:000006', NULL, NULL, 'Peroxisomal carnitine O-octanoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(187042, NULL, 'G3DSA:2.130.10.10:FF:000314', NULL, NULL, 'mitogen-activated protein kinase-binding protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(187043, NULL, 'G3DSA:3.40.50.670:FF:000003', NULL, NULL, 'DNA topoisomerase 4 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(187044, NULL, 'G3DSA:2.60.20.10:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187045, NULL, 'G3DSA:3.40.50.11370:FF:000002', NULL, NULL, 'Inositol-tetrakisphosphate 1-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(187046, NULL, 'G3DSA:2.40.70.10:FF:000018', NULL, NULL, 'Aspartic proteinase-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(187047, NULL, 'G3DSA:1.10.510.10:FF:004172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187048, NULL, 'G3DSA:2.40.20.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187049, NULL, 'G3DSA:3.80.10.10:FF:001118', NULL, NULL, 'Leucine rich repeat and phosphatase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(187050, NULL, 'G3DSA:3.30.200.20:FF:001913', NULL, NULL, 'Ribosomal protein S6 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(187051, NULL, 'G3DSA:1.25.40.20:FF:000765', NULL, NULL, 'Ankyrin repeat domain 9', NULL, NULL, NULL, NULL, NULL, 4),
(187052, NULL, 'G3DSA:3.30.60.30:FF:000112', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187053, NULL, 'G3DSA:2.60.200.30:FF:000036', NULL, NULL, 'ATP-NAD kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(187054, NULL, 'G3DSA:3.40.50.300:FF:004081', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(187055, NULL, 'G3DSA:3.40.50.300:FF:001938', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187056, NULL, 'G3DSA:1.25.50.20:FF:000075', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(187057, NULL, 'G3DSA:1.20.1250.20:FF:001138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187058, NULL, 'G3DSA:2.110.10.10:FF:000040', NULL, NULL, 'Matrix metalloproteinase-A', NULL, NULL, NULL, NULL, NULL, 4),
(187059, NULL, 'G3DSA:1.10.10.2660:FF:000028', NULL, NULL, 'ThiF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(187060, NULL, 'G3DSA:3.40.33.10:FF:000009', NULL, NULL, 'Pathogenesis-related protein 1', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(187061, NULL, 'G3DSA:3.40.50.300:FF:004209', NULL, NULL, 'RAP1A, member of RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(187062, NULL, 'G3DSA:2.60.40.180:FF:000011', NULL, NULL, 'Probable 5-hydroxyisourate hydrolase R09H10.3', NULL, NULL, NULL, NULL, NULL, 4),
(187063, NULL, 'G3DSA:2.40.30.10:FF:000027', NULL, NULL, 'Sulfate adenylyltransferase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(187064, NULL, 'G3DSA:3.30.1050.10:FF:000003', NULL, NULL, 'stomatin-like protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(187065, NULL, 'G3DSA:1.25.40.20:FF:000350', NULL, NULL, 'Death associated protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(187066, NULL, 'G3DSA:3.10.100.10:FF:000215', NULL, NULL, 'Mannose receptor, C type 1b', NULL, NULL, NULL, NULL, NULL, 4),
(187067, NULL, 'G3DSA:1.10.510.40:FF:000004', NULL, NULL, 'Aerobactin synthase IucA', NULL, NULL, NULL, NULL, NULL, 4),
(187068, NULL, 'G3DSA:1.10.3430.10:FF:000005', NULL, NULL, 'Ammonium transporter', NULL, NULL, NULL, NULL, NULL, 4),
(187069, NULL, 'G3DSA:2.40.50.690:FF:000007', NULL, NULL, 'DIS3-like exonuclease 2', NULL, NULL, NULL, NULL, NULL, 4),
(187070, NULL, 'G3DSA:2.30.30.40:FF:000183', NULL, NULL, 'Epidermal growth factor receptor kinase substrate 8', NULL, NULL, NULL, NULL, NULL, 4),
(187071, NULL, 'G3DSA:3.80.10.10:FF:003271', NULL, NULL, 'AGAP010669-PA', NULL, NULL, NULL, NULL, NULL, 4),
(187072, NULL, 'G3DSA:3.40.350.10:FF:000002', NULL, NULL, 'Xaa-Pro dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(187073, NULL, 'G3DSA:3.40.50.300:FF:007880', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187074, NULL, 'G3DSA:3.20.20.10:FF:000059', NULL, NULL, 'Antizyme inhibitor 1a', NULL, NULL, NULL, NULL, NULL, 4),
(187075, NULL, 'G3DSA:2.130.10.10:FF:005917', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187076, NULL, 'G3DSA:3.30.1490.180:FF:000028', NULL, NULL, 'DNA-directed RNA polymerase I subunit rpa1', NULL, NULL, NULL, NULL, NULL, 4),
(187077, NULL, 'G3DSA:1.10.3500.10:FF:000034', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(187078, NULL, 'G3DSA:2.60.220.10:FF:000003', NULL, NULL, 'Blood-group-substance endo-1,4-beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(187079, NULL, 'G3DSA:3.10.20.90:FF:000813', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187080, NULL, 'G3DSA:1.10.10.580:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187081, NULL, 'G3DSA:3.40.50.300:FF:006250', NULL, NULL, 'SNF2 family DNA-dependent ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(187082, NULL, 'G3DSA:2.60.40.10:FF:000471', NULL, NULL, 'Tripartite motif-containing 46, isoform CRA_c', NULL, NULL, NULL, NULL, NULL, 4),
(187083, NULL, 'G3DSA:3.90.550.10:FF:000192', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase 9', NULL, NULL, NULL, NULL, NULL, 4),
(187084, NULL, 'G3DSA:1.20.120.980:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187085, NULL, 'G3DSA:1.10.8.270:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187086, NULL, 'G3DSA:3.30.1370.100:FF:000039', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(187087, NULL, 'G3DSA:2.40.10.10:FF:000560', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187088, NULL, 'G3DSA:3.90.226.10:FF:000040', NULL, NULL, 'Ethylmalonyl-CoA decarboxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(187089, NULL, 'G3DSA:3.40.50.10470:FF:000069', NULL, NULL, 'Initiation factor 2B related', NULL, NULL, NULL, NULL, NULL, 4),
(187090, NULL, 'G3DSA:2.102.10.10:FF:000029', NULL, NULL, 'Protochlorophyllide-dependent translocon component 52, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(187091, NULL, 'G3DSA:3.30.200.20:FF:001722', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187092, NULL, 'G3DSA:1.10.1410.10:FF:000094', NULL, NULL, 'Nucleolar protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(187093, NULL, 'G3DSA:1.10.10.60:FF:000112', NULL, NULL, 'TyrR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(187094, NULL, 'G3DSA:2.30.34.10:FF:000003', NULL, NULL, 'Major surface protease gp63, putative', NULL, NULL, NULL, NULL, NULL, 4),
(187095, NULL, 'G3DSA:3.40.1000.50:FF:000021', NULL, NULL, 'Repressor of RNA polymerase III transcription MAF1', NULL, NULL, NULL, NULL, NULL, 4),
(187096, NULL, 'G3DSA:3.40.1090.10:FF:000060', NULL, NULL, 'Lysophospholipase NTE1', NULL, NULL, NULL, NULL, NULL, 4),
(187097, NULL, 'G3DSA:2.60.120.10:FF:000434', NULL, NULL, 'Fumarate and nitrate reduction regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(187098, NULL, 'G3DSA:2.70.150.10:FF:000068', NULL, NULL, 'Copper resistance-associated P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(187099, NULL, 'G3DSA:2.130.10.10:FF:000123', NULL, NULL, 'Semaphorin 3C', NULL, NULL, NULL, NULL, NULL, 4),
(187100, NULL, 'G3DSA:1.20.1070.10:FF:000857', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187101, NULL, 'G3DSA:1.20.5.110:FF:000275', NULL, NULL, 'TNF receptor-associated factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(187102, NULL, 'G3DSA:1.25.40.10:FF:001965', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187103, NULL, 'G3DSA:1.25.10.10:FF:001935', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187104, NULL, 'G3DSA:3.30.70.330:FF:003078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187105, NULL, 'G3DSA:3.90.1600.10:FF:000004', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(187106, NULL, 'G3DSA:3.30.160.60:FF:004282', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187107, NULL, 'G3DSA:3.30.1120.10:FF:000032', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(187108, NULL, 'G3DSA:1.10.510.10:FF:003666', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187109, NULL, 'G3DSA:1.10.287.70:FF:000735', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187110, NULL, 'G3DSA:1.25.40.10:FF:001437', NULL, NULL, 'Putative Dynein binding protein/ TPR repeat family', NULL, NULL, NULL, NULL, NULL, 4),
(187111, NULL, 'G3DSA:3.40.309.10:FF:000030', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(187112, NULL, 'G3DSA:1.10.20.10:FF:000165', NULL, NULL, 'Histone H2A', NULL, NULL, NULL, NULL, NULL, 4),
(187113, NULL, 'G3DSA:3.40.50.720:FF:000979', NULL, NULL, 'Chanoclavine-I dehydrogenase easD', NULL, NULL, NULL, NULL, NULL, 4),
(187114, NULL, 'G3DSA:2.40.20.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187115, NULL, 'G3DSA:3.30.1680.10:FF:000034', NULL, NULL, 'PLeXin', NULL, NULL, NULL, NULL, NULL, 4),
(187116, NULL, 'G3DSA:2.30.30.40:FF:000290', NULL, NULL, 'Microtubule-actin cross-linking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(187117, NULL, 'G3DSA:3.30.572.10:FF:000020', NULL, NULL, 'AGAP010457-PA', NULL, NULL, NULL, NULL, NULL, 4),
(187118, NULL, 'G3DSA:3.40.50.12350:FF:000015', NULL, NULL, 'EYES ABSENT-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(187119, NULL, 'G3DSA:2.30.42.10:FF:000302', NULL, NULL, 'Membrane metalloprotease ARASP, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(187120, NULL, 'G3DSA:1.20.1070.10:FF:001037', NULL, NULL, 'Olfactory receptor 1348', NULL, NULL, NULL, NULL, NULL, 4),
(187121, NULL, 'G3DSA:2.60.40.10:FF:002606', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(187122, NULL, 'G3DSA:3.90.780.10:FF:000012', NULL, NULL, 'LPXTG cell wall anchor domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(187123, NULL, 'G3DSA:2.60.40.10:FF:002034', NULL, NULL, 'Mesocentin', NULL, NULL, NULL, NULL, NULL, 4),
(187124, NULL, 'G3DSA:2.130.10.10:FF:006053', NULL, NULL, 'F-box and WD-40 domain protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(187125, NULL, 'G3DSA:2.60.40.10:FF:005788', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187126, NULL, 'G3DSA:1.20.120.1150:FF:000002', NULL, NULL, 'Serine/threonine-protein phosphatase 2A activator', NULL, NULL, NULL, NULL, NULL, 4),
(187127, NULL, 'G3DSA:3.40.1170.60:FF:000019', NULL, NULL, 'DNA polymerase kappa', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(187128, NULL, 'G3DSA:2.40.160.110:FF:000006', NULL, NULL, 'Lysosome-associated membrane glycoprotein 3', NULL, NULL, NULL, NULL, NULL, 4),
(187129, NULL, 'G3DSA:3.40.47.10:FF:000024', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(187130, NULL, 'G3DSA:3.90.280.10:FF:000007', NULL, NULL, 'Raf kinase inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(187131, NULL, 'G3DSA:1.20.1310.10:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187132, NULL, 'G3DSA:3.10.100.10:FF:000108', NULL, NULL, 'C-type lectin receptor-like tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(187133, NULL, 'G3DSA:1.20.140.10:FF:000139', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(187134, NULL, 'G3DSA:1.25.10.10:FF:002290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187135, NULL, 'G3DSA:4.10.400.10:FF:000307', NULL, NULL, 'Transmembrane cell adhesion receptor mua-3', NULL, NULL, NULL, NULL, NULL, 4),
(187136, NULL, 'G3DSA:3.40.50.720:FF:001126', NULL, NULL, '4-hydroxy-tetrahydrodipicolinate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(187137, NULL, 'G3DSA:1.25.10.10:FF:001609', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187138, NULL, 'G3DSA:3.30.160.60:FF:005698', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187139, NULL, 'G3DSA:2.60.220.30:FF:000009', NULL, NULL, 'Ankyrin 2, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(187140, NULL, 'G3DSA:3.30.420.110:FF:000034', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(187141, NULL, 'G3DSA:3.40.50.1820:FF:000786', NULL, NULL, 'Acyl-protein thioesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(187142, NULL, 'G3DSA:3.40.50.300:FF:008048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187143, NULL, 'G3DSA:2.40.160.120:FF:000009', NULL, NULL, 'oxysterol-binding protein-related protein 3C', NULL, NULL, NULL, NULL, NULL, 4),
(187144, NULL, 'G3DSA:1.10.10.10:FF:000344', NULL, NULL, 'AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(187145, NULL, 'G3DSA:2.30.180.10:FF:000130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187146, NULL, 'G3DSA:1.20.1310.10:FF:000090', NULL, NULL, 'Cullin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(187147, NULL, 'G3DSA:1.20.1270.60:FF:000067', NULL, NULL, 'NOSTRIN isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(187148, NULL, 'G3DSA:2.10.25.10:FF:001135', NULL, NULL, 'Coagulation factor VIIi', NULL, NULL, NULL, NULL, NULL, 4),
(187149, NULL, 'G3DSA:3.30.160.60:FF:000920', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187150, NULL, 'G3DSA:3.30.1460.50:FF:000029', NULL, NULL, 'Autophagy 10 variant 1', NULL, NULL, NULL, NULL, NULL, 4),
(187151, NULL, 'G3DSA:3.40.50.1820:FF:000679', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187152, NULL, 'G3DSA:1.20.1020.10:FF:000005', NULL, NULL, 'Nejire, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(187153, NULL, 'G3DSA:3.30.160.60:FF:000550', NULL, NULL, 'Zinc finger and BTB domain-containing 47', NULL, NULL, NULL, NULL, NULL, 4),
(187154, NULL, 'G3DSA:2.40.30.10:FF:000134', NULL, NULL, 'Electron transfer protein FDXB', NULL, NULL, NULL, NULL, NULL, 4),
(187155, NULL, 'G3DSA:1.10.287.4280:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187156, NULL, 'G3DSA:3.40.50.300:FF:004007', NULL, NULL, 'DNA ligase-associated DEXH box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(187157, NULL, 'G3DSA:2.70.170.10:FF:000300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187158, NULL, 'G3DSA:2.130.10.10:FF:004136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187159, NULL, 'G3DSA:1.20.1740.10:FF:000274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187160, NULL, 'G3DSA:1.10.3730.20:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(187161, NULL, 'G3DSA:1.25.40.20:FF:000664', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187162, NULL, 'G3DSA:3.40.50.2000:FF:000767', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187163, NULL, 'G3DSA:3.30.160.60:FF:002348', NULL, NULL, 'paternally-expressed gene 3 protein isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(187164, NULL, 'G3DSA:2.60.40.10:FF:004523', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187165, NULL, 'G3DSA:3.30.505.10:FF:000095', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(187166, NULL, 'G3DSA:2.40.30.10:FF:000353', NULL, NULL, 'Eukaryotic initiation factor', NULL, NULL, NULL, NULL, NULL, 4),
(187167, NULL, 'G3DSA:1.10.10.1050:FF:000006', NULL, NULL, 'Related to decapping enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(187168, NULL, 'G3DSA:1.25.40.10:FF:001763', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g16010', NULL, NULL, NULL, NULL, NULL, 4),
(187169, NULL, 'G3DSA:1.25.40.530:FF:000020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187170, NULL, 'G3DSA:3.30.1360.120:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187171, NULL, 'G3DSA:1.25.40.10:FF:000021', NULL, NULL, 'Lipoprotein NlpI', NULL, NULL, NULL, NULL, NULL, 4),
(187172, NULL, 'G3DSA:1.25.10.10:FF:002301', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187173, NULL, 'G3DSA:3.30.60.30:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187174, NULL, 'G3DSA:1.10.1200.10:FF:000168', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187175, NULL, 'G3DSA:2.130.10.10:FF:002354', NULL, NULL, 'LRS1', NULL, NULL, NULL, NULL, NULL, 4),
(187176, NULL, 'G3DSA:1.10.455.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187177, NULL, 'G3DSA:3.40.50.720:FF:001345', NULL, NULL, 'Putative oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(187178, NULL, 'G3DSA:2.130.10.10:FF:000230', NULL, NULL, 'Transducin beta-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(187179, NULL, 'G3DSA:1.10.10.10:FF:001974', NULL, NULL, 'Cullin-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(187180, NULL, 'G3DSA:1.20.5.190:FF:000040', NULL, NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(187181, NULL, 'G3DSA:1.10.730.20:FF:000015', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(187182, NULL, 'G3DSA:3.30.160.60:FF:003883', NULL, NULL, 'Transcription factor btd', NULL, NULL, NULL, NULL, NULL, 4),
(187183, NULL, 'G3DSA:3.30.70.330:FF:001280', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(187184, NULL, 'G3DSA:3.60.21.10:FF:000245', NULL, NULL, 'Purple acid phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(187185, NULL, 'G3DSA:1.10.565.10:FF:000173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187186, NULL, 'G3DSA:2.130.10.10:FF:004501', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187187, NULL, 'G3DSA:3.20.90.10:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187188, NULL, 'G3DSA:1.10.790.10:FF:000004', NULL, NULL, 'Prion protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(187189, NULL, 'G3DSA:1.10.287.110:FF:000146', NULL, NULL, 'Chaperone protein DNAj', NULL, NULL, NULL, NULL, NULL, 4),
(187190, NULL, 'G3DSA:2.40.50.140:FF:000978', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187191, NULL, 'G3DSA:3.30.160.60:FF:004602', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187192, NULL, 'G3DSA:3.30.160.60:FF:002039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187193, NULL, 'G3DSA:2.30.110.10:FF:000075', NULL, NULL, 'Nitrilotriacetate monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(187194, NULL, 'G3DSA:2.40.100.10:FF:000072', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(187195, NULL, 'G3DSA:1.10.3210.10:FF:000017', NULL, NULL, 'Deoxynucleoside triphosphate triphosphohydrolase SAMHD1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(187196, NULL, 'G3DSA:3.30.70.330:FF:002420', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187197, NULL, 'G3DSA:3.40.50.300:FF:004535', NULL, NULL, 'Flagellar associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(187198, NULL, 'G3DSA:3.40.30.10:FF:000284', NULL, NULL, 'NADH dehydrogenase subunit NI8M', NULL, NULL, NULL, NULL, NULL, 4),
(187199, NULL, 'G3DSA:3.40.50.300:FF:000264', NULL, NULL, 'ATP-binding cassette, sub-family A (ABC1), member 1', NULL, NULL, NULL, NULL, NULL, 4),
(187200, NULL, 'G3DSA:1.10.3720.10:FF:000090', NULL, NULL, 'Dipeptide ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(187201, NULL, 'G3DSA:3.10.330.20:FF:000027', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187202, NULL, 'G3DSA:3.90.920.10:FF:000001', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(187203, NULL, 'G3DSA:3.40.1810.10:FF:000026', NULL, NULL, 'MADS-box transcription factor 29', NULL, NULL, NULL, NULL, NULL, 4),
(187204, NULL, 'G3DSA:1.10.730.10:FF:000012', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(187205, NULL, 'G3DSA:3.30.1490.100:FF:000004', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(187206, NULL, 'G3DSA:3.30.505.10:FF:000106', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(187207, NULL, 'G3DSA:1.20.140.100:FF:000044', NULL, NULL, 'Dynein heavy chain 11', NULL, NULL, NULL, NULL, NULL, 4),
(187208, NULL, 'G3DSA:2.60.120.10:FF:000069', NULL, NULL, 'Homogentisate 1,2-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(187209, NULL, 'G3DSA:2.60.40.10:FF:004158', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187210, NULL, 'G3DSA:2.60.40.10:FF:001887', NULL, NULL, 'Twitchin', NULL, NULL, NULL, NULL, NULL, 4),
(187211, NULL, 'G3DSA:1.20.1390.10:FF:000010', NULL, NULL, 'U1 small nuclear ribonucleoprotein component SNU71', NULL, NULL, NULL, NULL, NULL, 4),
(187212, NULL, 'G3DSA:3.30.200.20:FF:002065', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(187213, NULL, 'G3DSA:1.10.472.80:FF:000096', NULL, NULL, 'GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(187214, NULL, 'G3DSA:2.40.70.10:FF:000243', NULL, NULL, 'Secreted aspartic proteinase', NULL, NULL, NULL, NULL, NULL, 4),
(187215, NULL, 'G3DSA:1.25.40.840:FF:000006', NULL, NULL, 'CCR4-NOT transcriptional complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(187216, NULL, 'G3DSA:1.25.70.10:FF:000039', NULL, NULL, 'F8K4.20 protein', NULL, NULL, NULL, NULL, NULL, 4),
(187217, NULL, 'G3DSA:3.40.50.150:FF:000437', NULL, NULL, 'tRNA wybutosine-synthesizing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(187218, NULL, 'G3DSA:3.30.360.10:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187219, NULL, 'G3DSA:1.10.472.80:FF:000135', NULL, NULL, 'LD17019p', NULL, NULL, NULL, NULL, NULL, 4),
(187220, NULL, 'G3DSA:2.70.130.10:FF:000180', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187221, NULL, 'G3DSA:3.30.1490.110:FF:000007', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(187222, NULL, 'G3DSA:2.60.40.150:FF:000805', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187223, NULL, 'G3DSA:3.90.1410.10:FF:000074', NULL, NULL, 'YALI0E34397p', NULL, NULL, NULL, NULL, NULL, 4),
(187224, NULL, 'G3DSA:2.30.42.10:FF:000578', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187225, NULL, 'G3DSA:3.40.630.30:FF:000625', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187226, NULL, 'G3DSA:1.10.472.10:FF:000226', NULL, NULL, 'Cyclin-A1-1', NULL, NULL, NULL, NULL, NULL, 4),
(187227, NULL, 'G3DSA:1.25.10.10:FF:000047', NULL, NULL, 'Cullin-associated NEDD8-dissociated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(187228, NULL, 'G3DSA:3.30.420.510:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187229, NULL, 'G3DSA:1.25.40.10:FF:004034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187230, NULL, 'G3DSA:3.30.160.60:FF:000701', NULL, NULL, 'Zinc finger and BTB domain containing 40', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(187231, NULL, 'G3DSA:1.10.533.10:FF:000144', NULL, NULL, 'Apoptosis-associated speck-like protein-containing a CARD', NULL, NULL, NULL, NULL, NULL, 4),
(187232, NULL, 'G3DSA:2.60.120.1040:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187233, NULL, 'G3DSA:3.30.160.60:FF:001859', NULL, NULL, 'Flt3-interacting zinc finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(187234, NULL, 'G3DSA:2.60.120.10:FF:000097', NULL, NULL, 'Eag-like K[+] channel, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(187235, NULL, 'G3DSA:1.10.287.70:FF:000628', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187236, NULL, 'G3DSA:3.30.750.44:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187237, NULL, 'G3DSA:1.25.10.10:FF:002317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187238, NULL, 'G3DSA:1.20.990.10:FF:000063', NULL, NULL, 'NADPH--cytochrome p450 reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(187239, NULL, 'G3DSA:3.40.50.300:FF:004316', NULL, NULL, 'GM18634', NULL, NULL, NULL, NULL, NULL, 4),
(187240, NULL, 'G3DSA:3.40.630.30:FF:000491', NULL, NULL, 'Aminoglycoside N(6'')-acetyltransferase type 1', NULL, NULL, NULL, NULL, NULL, 4),
(187241, NULL, 'G3DSA:1.10.8.1210:FF:000004', NULL, NULL, 'Glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(187242, NULL, 'G3DSA:3.10.20.90:FF:000460', NULL, NULL, 'Tea4', NULL, NULL, NULL, NULL, NULL, 4),
(187243, NULL, 'G3DSA:3.30.450.40:FF:000009', NULL, NULL, 'DNA-binding transcriptional regulator KdgR', NULL, NULL, NULL, NULL, NULL, 4),
(187244, NULL, 'G3DSA:1.25.10.10:FF:001828', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(187245, NULL, 'G3DSA:3.30.420.40:FF:000261', NULL, NULL, 'Heat shock protein 110', NULL, NULL, NULL, NULL, NULL, 4),
(187246, NULL, 'G3DSA:3.50.50.100:FF:000038', NULL, NULL, 'FAD-dependent pyridine nucleotide-disulphide oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(187247, NULL, 'G3DSA:2.60.120.10:FF:000748', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187248, NULL, 'G3DSA:2.60.40.150:FF:000249', NULL, NULL, 'Phosphatidylserine decarboxylase proenzyme 2', NULL, NULL, NULL, NULL, NULL, 4),
(187249, NULL, 'G3DSA:1.10.10.10:FF:000193', NULL, NULL, 'histone H2A deubiquitinase MYSM1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(187250, NULL, 'G3DSA:1.25.10.10:FF:002071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187251, NULL, 'G3DSA:1.10.220.10:FF:000018', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(187252, NULL, 'G3DSA:3.20.20.70:FF:000723', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187253, NULL, 'G3DSA:2.60.260.20:FF:000132', NULL, NULL, 'Chaperone DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(187254, NULL, 'G3DSA:2.170.270.10:FF:000031', NULL, NULL, 'probable histone-lysine N-methyltransferase PRDM7', NULL, NULL, NULL, NULL, NULL, 4),
(187255, NULL, 'G3DSA:3.30.1330.30:FF:000071', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(187256, NULL, 'G3DSA:1.25.40.20:FF:001766', NULL, NULL, 'Leucine-rich repeat serine/threonine-protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(187257, NULL, 'G3DSA:2.60.40.10:FF:005939', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187258, NULL, 'G3DSA:3.30.460.80:FF:000016', NULL, NULL, 'Hydrogenase subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(187259, NULL, 'G3DSA:1.20.58.70:FF:000112', NULL, NULL, 't-SNARE affecting a late Golgi compartment protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(187260, NULL, 'G3DSA:2.20.70.10:FF:000053', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(187261, NULL, 'G3DSA:3.90.190.10:FF:000473', NULL, NULL, 'Phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(187262, NULL, 'G3DSA:3.40.50.1000:FF:000444', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(187263, NULL, 'G3DSA:3.40.50.150:FF:001848', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187264, NULL, 'G3DSA:3.40.50.1010:FF:000077', NULL, NULL, 'Ribonuclease VapC', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(187265, NULL, 'G3DSA:3.40.50.1000:FF:000074', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(187266, NULL, 'G3DSA:3.40.630.10:FF:000147', NULL, NULL, 'Aminoacyl-histidine dipeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(187267, NULL, 'G3DSA:3.40.30.10:FF:001003', NULL, NULL, 'Glutathione S-transferase U10', NULL, NULL, NULL, NULL, NULL, 4),
(187268, NULL, 'G3DSA:2.60.40.10:FF:005569', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187269, NULL, 'G3DSA:1.10.238.10:FF:001020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187270, NULL, 'G3DSA:2.60.40.10:FF:000780', NULL, NULL, 'Tyrosine-protein kinase receptor TYRO3', NULL, NULL, NULL, NULL, NULL, 4),
(187271, NULL, 'G3DSA:3.40.30.10:FF:000194', NULL, NULL, 'Iodothyronine deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(187272, NULL, 'G3DSA:3.30.559.30:FF:000034', NULL, NULL, 'Nonribosomal peptide synthetase easA', NULL, NULL, NULL, NULL, NULL, 4),
(187273, NULL, 'G3DSA:1.10.10.10:FF:000900', NULL, NULL, '6-O-methylguanine_DNA_methyltransferase_-_DNA_binding_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(187274, NULL, 'G3DSA:4.10.280.10:FF:000191', NULL, NULL, 'Transcription factor UDT1', NULL, NULL, NULL, NULL, NULL, 4),
(187275, NULL, 'G3DSA:2.120.10.80:FF:000402', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187276, NULL, 'G3DSA:1.20.1640.10:FF:000081', NULL, NULL, 'Transporter, AcrB/D/F family', NULL, NULL, NULL, NULL, NULL, 4),
(187277, NULL, 'G3DSA:3.30.230.10:FF:000102', NULL, NULL, 'Similar to galactokinase', NULL, NULL, NULL, NULL, NULL, 4),
(187278, NULL, 'G3DSA:1.10.1420.10:FF:000061', NULL, NULL, 'Putative DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(187279, NULL, 'G3DSA:1.25.10.10:FF:000182', NULL, NULL, 'Importin-5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(187280, NULL, 'G3DSA:1.10.1200.10:FF:000078', NULL, NULL, 'Probable non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(187281, NULL, 'G3DSA:3.30.200.20:FF:001357', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187282, NULL, 'G3DSA:2.60.120.620:FF:000085', NULL, NULL, 'Procollagen-proline, 2-oxoglutarate-4-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(187283, NULL, 'G3DSA:2.40.33.10:FF:000034', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(187284, NULL, 'G3DSA:3.40.50.720:FF:001671', NULL, NULL, 'Os02g0640600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(187285, NULL, 'G3DSA:1.10.8.60:FF:000471', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187286, NULL, 'G3DSA:2.130.10.10:FF:000432', NULL, NULL, 'WD repeat domain 7', NULL, NULL, NULL, NULL, NULL, 4),
(187287, NULL, 'G3DSA:1.10.510.10:FF:003790', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187288, NULL, 'G3DSA:2.40.50.140:FF:001158', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187289, NULL, 'G3DSA:2.60.120.10:FF:000743', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187290, NULL, 'G3DSA:2.40.40.20:FF:000082', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187291, NULL, 'G3DSA:1.10.150.50:FF:000154', NULL, NULL, 'Protein CBG04143', NULL, NULL, NULL, NULL, NULL, 4),
(187292, NULL, 'G3DSA:3.30.457.60:FF:000014', NULL, NULL, 'Chromosome 15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(187293, NULL, 'G3DSA:1.10.287.1080:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187294, NULL, 'G3DSA:3.90.1680.10:FF:000003', NULL, NULL, 'SOS response-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(187295, NULL, 'G3DSA:2.10.220.10:FF:000138', NULL, NULL, 'Fraser extracellular matrix complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(187296, NULL, 'G3DSA:3.50.50.60:FF:001255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187297, NULL, 'G3DSA:3.40.50.300:FF:008032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187298, NULL, 'G3DSA:2.40.30.10:FF:000443', NULL, NULL, 'Elongation factor Tu', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(187299, NULL, 'G3DSA:1.10.418.10:FF:000056', NULL, NULL, 'leucine-rich repeat and calponin homology domain-containing protein 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(187300, NULL, 'G3DSA:3.40.50.300:FF:000483', NULL, NULL, 'Sensor histidine kinase KdpD', NULL, NULL, NULL, NULL, NULL, 4),
(187301, NULL, 'G3DSA:1.10.730.10:FF:000102', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(187302, NULL, 'G3DSA:3.80.10.10:FF:003922', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187303, NULL, 'G3DSA:2.10.25.10:FF:001461', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(187304, NULL, 'G3DSA:3.30.160.60:FF:004591', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187305, NULL, 'G3DSA:3.80.10.10:FF:002782', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187306, NULL, 'G3DSA:3.90.76.10:FF:000027', NULL, NULL, 'Peptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(187307, NULL, 'G3DSA:3.40.50.720:FF:001143', NULL, NULL, 'Tar1', NULL, NULL, NULL, NULL, NULL, 4),
(187308, NULL, 'G3DSA:3.40.50.280:FF:000010', NULL, NULL, 'Methylmalonyl-CoA mutase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(187309, NULL, 'G3DSA:2.130.10.10:FF:000084', NULL, NULL, 'mRNA export factor', NULL, NULL, NULL, NULL, NULL, 4),
(187310, NULL, 'G3DSA:3.10.290.10:FF:000094', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(187311, NULL, 'G3DSA:2.10.25.10:FF:000657', NULL, NULL, 'vasorin', NULL, NULL, NULL, NULL, NULL, 4),
(187312, NULL, 'G3DSA:1.10.8.720:FF:000061', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(187313, NULL, 'G3DSA:3.80.10.10:FF:003580', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187314, NULL, 'G3DSA:1.20.1370.60:FF:000001', NULL, NULL, 'Catalase', NULL, NULL, NULL, NULL, NULL, 4),
(187315, NULL, 'G3DSA:1.20.1250.20:FF:000649', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187316, NULL, 'G3DSA:1.10.510.10:FF:001884', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(187317, NULL, 'G3DSA:1.20.1560.10:FF:000855', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187318, NULL, 'G3DSA:3.30.160.60:FF:003793', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187319, NULL, 'G3DSA:4.10.1000.40:FF:000002', NULL, NULL, 'Nuclear polyadenylated RNA-binding protein Nab2', NULL, NULL, NULL, NULL, NULL, 4),
(187320, NULL, 'G3DSA:3.20.20.190:FF:000156', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187321, NULL, 'G3DSA:3.40.50.300:FF:000303', NULL, NULL, 'GTP-binding protein Di-Ras2', NULL, NULL, NULL, NULL, NULL, 4),
(187322, NULL, 'G3DSA:1.10.10.10:FF:001648', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187323, NULL, 'G3DSA:2.60.40.60:FF:000660', NULL, NULL, 'Cadherin 17', NULL, NULL, NULL, NULL, NULL, 4),
(187324, NULL, 'G3DSA:2.130.10.10:FF:004355', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187325, NULL, 'G3DSA:3.10.100.10:FF:000232', NULL, NULL, 'GD19722', NULL, NULL, NULL, NULL, NULL, 4),
(187326, NULL, 'G3DSA:3.30.200.20:FF:002211', NULL, NULL, 'Serine/threonine-protein kinase RIO3', NULL, NULL, NULL, NULL, NULL, 4),
(187327, NULL, 'G3DSA:1.10.10.41:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187328, NULL, 'G3DSA:1.10.510.10:FF:001991', NULL, NULL, 'Uncharacterized protein CaJ7.0258', NULL, NULL, NULL, NULL, NULL, 4),
(187329, NULL, 'G3DSA:3.30.910.20:FF:000011', NULL, NULL, 'OmpH family outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(187330, NULL, 'G3DSA:2.60.220.30:FF:000026', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187331, NULL, 'G3DSA:3.80.10.10:FF:003052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187332, NULL, 'G3DSA:1.10.510.10:FF:001749', NULL, NULL, 'Serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(187333, NULL, 'G3DSA:3.30.1640.10:FF:000060', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(187334, NULL, 'G3DSA:3.40.50.1240:FF:000134', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187335, NULL, 'G3DSA:1.10.530.10:FF:000031', NULL, NULL, 'Lytic transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(187336, NULL, 'G3DSA:3.40.50.10130:FF:000018', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NUBP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(187337, NULL, 'G3DSA:2.130.10.10:FF:004029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187338, NULL, 'G3DSA:3.40.50.1820:FF:001168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187339, NULL, 'G3DSA:2.60.40.10:FF:006092', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187340, NULL, 'G3DSA:2.20.80.10:FF:000020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187341, NULL, 'G3DSA:3.30.230.70:FF:000120', NULL, NULL, 'AFR109Wp', NULL, NULL, NULL, NULL, NULL, 4),
(187342, NULL, 'G3DSA:3.40.50.1440:FF:000003', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(187343, NULL, 'G3DSA:3.30.390.50:FF:000030', NULL, NULL, 'Xanthine dehydrogenase, A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(187344, NULL, 'G3DSA:3.30.830.10:FF:000092', NULL, NULL, 'Protein CBG19672', NULL, NULL, NULL, NULL, NULL, 4),
(187345, NULL, 'G3DSA:2.40.10.10:FF:000251', NULL, NULL, 'Zgc:92511', NULL, NULL, NULL, NULL, NULL, 4),
(187346, NULL, 'G3DSA:2.10.70.80:FF:000001', NULL, NULL, 'Sortilin-related VPS10 domain-containing receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(187347, NULL, 'G3DSA:3.90.550.10:FF:000219', NULL, NULL, 'Eukaryotic initiation factor eIF2B gamma subunit', NULL, NULL, NULL, NULL, NULL, 4),
(187348, NULL, 'G3DSA:2.40.155.10:FF:000007', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187349, NULL, 'G3DSA:1.10.533.10:FF:000054', NULL, NULL, 'Unc-5 family C-terminal like', NULL, NULL, NULL, NULL, NULL, 4),
(187350, NULL, 'G3DSA:2.130.10.10:FF:004271', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187351, NULL, 'G3DSA:3.30.1360.70:FF:000005', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(187352, NULL, 'G3DSA:3.40.50.11340:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187353, NULL, 'G3DSA:3.30.1360.60:FF:000002', NULL, NULL, 'N-Acetyl-D-Glucosamine phosphotransferase system transporter', NULL, NULL, NULL, NULL, NULL, 4),
(187354, NULL, 'G3DSA:1.25.40.10:FF:000352', NULL, NULL, 'Kinase with tetratricopeptide repeat domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(187355, NULL, 'G3DSA:2.60.40.10:FF:001882', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(187356, NULL, 'G3DSA:2.60.40.10:FF:000117', NULL, NULL, 'Fibronectin type III domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(187357, NULL, 'G3DSA:3.40.30.10:FF:000840', NULL, NULL, 'Protein disulfide isomerase1-1', NULL, NULL, NULL, NULL, NULL, 4),
(187358, NULL, 'G3DSA:3.40.140.10:FF:000065', NULL, NULL, 'tRNA-specific adenosine deaminase 2', NULL, NULL, NULL, NULL, NULL, 4),
(187359, NULL, 'G3DSA:3.40.50.1450:FF:000006', NULL, NULL, 'Hydrogenase maturation protease', NULL, NULL, NULL, NULL, NULL, 4),
(187360, NULL, 'G3DSA:3.30.160.270:FF:000011', NULL, NULL, '2-isopropylmalate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(187361, NULL, 'G3DSA:2.60.40.10:FF:000252', NULL, NULL, 'Fibroblast growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(187362, NULL, 'G3DSA:3.30.830.10:FF:000305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187363, NULL, 'G3DSA:1.20.5.110:FF:000292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187364, NULL, 'G3DSA:1.10.287.110:FF:000348', NULL, NULL, 'DnaJ domain protein (AFU_orthologue AFUA_5G03040)', NULL, NULL, NULL, NULL, NULL, 4),
(187365, NULL, 'G3DSA:2.40.480.10:FF:000004', NULL, NULL, 'Dirigent protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(187366, NULL, 'G3DSA:3.60.21.10:FF:000273', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(187367, NULL, 'G3DSA:3.30.70.580:FF:000005', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(187368, NULL, 'G3DSA:3.40.50.11610:FF:000001', NULL, NULL, '2-oxoglutarate dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(187369, NULL, 'G3DSA:3.50.50.100:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187370, NULL, 'G3DSA:1.10.3720.10:FF:000101', NULL, NULL, 'Peptide ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(187371, NULL, 'G3DSA:3.40.1080.10:FF:000008', NULL, NULL, 'Acetate CoA-transferase YdiF', NULL, NULL, NULL, NULL, NULL, 4),
(187372, NULL, 'G3DSA:1.25.10.10:FF:001918', NULL, NULL, 'Protein ARABIDILLO 2', NULL, NULL, NULL, NULL, NULL, 4),
(187373, NULL, 'G3DSA:3.30.460.10:FF:000187', NULL, NULL, 'Poly A polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(187374, NULL, 'G3DSA:3.30.160.60:FF:005709', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187375, NULL, 'G3DSA:1.10.510.10:FF:000119', NULL, NULL, 'Putative map kinase-interacting serine/threonine-protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(187376, NULL, 'G3DSA:1.10.20.10:FF:000148', NULL, NULL, 'Os07g0612500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(187377, NULL, 'G3DSA:3.10.105.10:FF:000114', NULL, NULL, 'Oligopeptide ABC transporter, solute-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(187378, NULL, 'G3DSA:3.80.10.10:FF:000983', NULL, NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(187379, NULL, 'G3DSA:2.60.120.260:FF:000050', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(187380, NULL, 'G3DSA:3.30.70.590:FF:000008', NULL, NULL, 'Unplaced genomic scaffold supercont1.129, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(187381, NULL, 'G3DSA:1.25.40.10:FF:001982', NULL, NULL, 'Probable pre-mRNA splicing factor prp1', NULL, NULL, NULL, NULL, NULL, 4),
(187382, NULL, 'G3DSA:4.10.280.10:FF:000084', NULL, NULL, 'class A basic helix-loop-helix protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(187383, NULL, 'G3DSA:3.30.160.60:FF:002129', NULL, NULL, 'Zinc finger protein 304', NULL, NULL, NULL, NULL, NULL, 4),
(187384, NULL, 'G3DSA:1.20.1530.20:FF:000002', NULL, NULL, 'K(+)/H(+) antiporter NhaP2', NULL, NULL, NULL, NULL, NULL, 4),
(187385, NULL, 'G3DSA:1.10.287.70:FF:000398', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187386, NULL, 'G3DSA:3.30.40.10:FF:001369', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187387, NULL, 'G3DSA:2.30.30.170:FF:000007', NULL, NULL, 'Fibronectin binding autolysin', NULL, NULL, NULL, NULL, NULL, 4),
(187388, NULL, 'G3DSA:3.30.60.30:FF:000185', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(187389, NULL, 'G3DSA:3.30.160.60:FF:006390', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187390, NULL, 'G3DSA:2.60.40.10:FF:004630', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187391, NULL, 'G3DSA:3.40.30.10:FF:001008', NULL, NULL, 'Glutathione S-transferase U10', NULL, NULL, NULL, NULL, NULL, 4),
(187392, NULL, 'G3DSA:1.10.3080.10:FF:000079', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(187393, NULL, 'G3DSA:3.40.50.1000:FF:000220', NULL, NULL, 'Haloacid dehalogenase', NULL, NULL, NULL, NULL, NULL, 4),
(187394, NULL, 'G3DSA:2.60.40.1230:FF:000009', NULL, NULL, 'AP-2 complex subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(187395, NULL, 'G3DSA:3.70.10.10:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187396, NULL, 'G3DSA:1.20.870.10:FF:000014', NULL, NULL, 'Kinase non-catalytic C-lobe domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(187397, NULL, 'G3DSA:2.20.28.10:FF:000040', NULL, NULL, 'Rubredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(187398, NULL, 'G3DSA:1.20.1110.10:FF:000136', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187399, NULL, 'G3DSA:3.20.80.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187400, NULL, 'G3DSA:1.10.630.10:FF:000387', NULL, NULL, 'Zgc:123299', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(187401, NULL, 'G3DSA:3.40.50.2020:FF:000177', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187402, NULL, 'G3DSA:1.10.340.30:FF:000050', NULL, NULL, 'Slr0231 protein', NULL, NULL, NULL, NULL, NULL, 4),
(187403, NULL, 'G3DSA:1.25.40.10:FF:003910', NULL, NULL, 'Potassium ion transmembrane transporter', NULL, NULL, NULL, NULL, NULL, 4),
(187404, NULL, 'G3DSA:2.60.40.10:FF:004175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187405, NULL, 'G3DSA:3.90.226.10:FF:000045', NULL, NULL, 'Propionyl-CoA carboxylase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(187406, NULL, 'G3DSA:2.60.40.1220:FF:000006', NULL, NULL, 'Copper resistance D domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(187407, NULL, 'G3DSA:3.30.1360.210:FF:000014', NULL, NULL, '60S ribosomal protein L22-2', NULL, NULL, NULL, NULL, NULL, 4),
(187408, NULL, 'G3DSA:2.60.40.1210:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187409, NULL, 'G3DSA:1.25.40.860:FF:000029', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(187410, NULL, 'G3DSA:2.60.40.10:FF:005934', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187411, NULL, 'G3DSA:3.30.1360.200:FF:000011', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(187412, NULL, 'G3DSA:2.160.20.80:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187413, NULL, 'G3DSA:2.40.160.110:FF:000023', NULL, NULL, 'Lysosome-associated membrane glycoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(187414, NULL, 'G3DSA:3.30.160.60:FF:001966', NULL, NULL, 'Zinc finger protein 445', NULL, NULL, NULL, NULL, NULL, 4),
(187415, NULL, 'G3DSA:1.10.510.10:FF:001665', NULL, NULL, 'Serine/threonine protein kinase-9', NULL, NULL, NULL, NULL, NULL, 4),
(187416, NULL, 'G3DSA:3.80.10.10:FF:003361', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187417, NULL, 'G3DSA:1.10.10.60:FF:000073', NULL, NULL, 'Putative LIM/homeobox protein Lhx3', NULL, NULL, NULL, NULL, NULL, 4),
(187418, NULL, 'G3DSA:2.40.160.120:FF:000026', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(187419, NULL, 'G3DSA:3.40.50.300:FF:000157', NULL, NULL, 'ABC transporter G family member 34', NULL, NULL, NULL, NULL, NULL, 4),
(187420, NULL, 'G3DSA:2.160.20.70:FF:000016', NULL, NULL, 'Tubulin binding cofactor c, putative', NULL, NULL, NULL, NULL, NULL, 4),
(187421, NULL, 'G3DSA:3.30.565.10:FF:000290', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One component system)', NULL, NULL, NULL, NULL, NULL, 4),
(187422, NULL, 'G3DSA:3.20.19.10:FF:000005', NULL, NULL, 'Iron-responsive element-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(187423, NULL, 'G3DSA:1.20.1560.10:FF:000939', NULL, NULL, 'Mating factor M secretion protein mam1', NULL, NULL, NULL, NULL, NULL, 4),
(187424, NULL, 'G3DSA:3.90.1150.10:FF:000031', NULL, NULL, 'Serine--glyoxylate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(187425, NULL, 'G3DSA:3.30.1490.50:FF:000003', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(187426, NULL, 'G3DSA:2.90.10.10:FF:000030', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(187427, NULL, 'G3DSA:3.40.140.10:FF:000082', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit F', NULL, NULL, NULL, NULL, NULL, 4),
(187428, NULL, 'G3DSA:2.10.25.10:FF:001500', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187429, NULL, 'G3DSA:3.30.160.60:FF:004607', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187430, NULL, 'G3DSA:3.30.200.20:FF:001683', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187431, NULL, 'G3DSA:2.10.25.10:FF:001152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187432, NULL, 'G3DSA:1.20.1250.20:FF:000958', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(187433, NULL, 'G3DSA:3.30.450.40:FF:000116', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(187434, NULL, 'G3DSA:3.40.50.2000:FF:001037', NULL, NULL, 'Glycosyl transferase; group 1', NULL, NULL, NULL, NULL, NULL, 4),
(187435, NULL, 'G3DSA:2.60.120.290:FF:000059', NULL, NULL, 'Zinc metalloproteinase', NULL, NULL, NULL, NULL, NULL, 4),
(187436, NULL, 'G3DSA:2.10.90.10:FF:000061', NULL, NULL, 'Inhibin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(187437, NULL, 'G3DSA:1.25.40.10:FF:002145', NULL, NULL, 'Os02g0552100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(187438, NULL, 'G3DSA:3.40.850.10:FF:000130', NULL, NULL, 'Kinesin protein', NULL, NULL, NULL, NULL, NULL, 4),
(187439, NULL, 'G3DSA:1.10.287.110:FF:000039', NULL, NULL, 'Protein translocation complex component (Npl1)', NULL, NULL, NULL, NULL, NULL, 4),
(187440, NULL, 'G3DSA:3.10.20.550:FF:000002', NULL, NULL, 'Histone deacetylase complex subunit SAP18', NULL, NULL, NULL, NULL, NULL, 4),
(187441, NULL, 'G3DSA:3.40.50.720:FF:001452', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187442, NULL, 'G3DSA:3.30.70.20:FF:000126', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187443, NULL, 'G3DSA:1.10.10.60:FF:000421', NULL, NULL, 'Mating-type protein ALPHA2', NULL, NULL, NULL, NULL, NULL, 4),
(187444, NULL, 'G3DSA:1.20.120.140:FF:000041', NULL, NULL, 'Signal recognition particle alpha', NULL, NULL, NULL, NULL, NULL, 4),
(187445, NULL, 'G3DSA:2.160.20.60:FF:000013', NULL, NULL, 'Putative formylmethanofurane dehydrogenase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(187446, NULL, 'G3DSA:3.40.50.150:FF:000421', NULL, NULL, 'Possible methyltransferase (Methylase)', NULL, NULL, NULL, NULL, NULL, 4),
(187447, NULL, 'G3DSA:3.50.50.60:FF:000170', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(187448, NULL, 'G3DSA:1.25.10.10:FF:003397', NULL, NULL, 'mRNA-binding U2 snRNP complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(187449, NULL, 'G3DSA:1.10.8.60:FF:000364', NULL, NULL, 'AAA ATPase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(187450, NULL, 'G3DSA:3.40.30.10:FF:000531', NULL, NULL, 'Peroxiredoxin Q/BCP', NULL, NULL, NULL, NULL, NULL, 4),
(187451, NULL, 'G3DSA:1.10.246.140:FF:000006', NULL, NULL, 'Transcription and mRNA export factor ENY2', NULL, NULL, NULL, NULL, NULL, 4),
(187452, NULL, 'G3DSA:1.10.510.10:FF:000580', NULL, NULL, 'AGC protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(187453, NULL, 'G3DSA:3.40.50.300:FF:007885', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(187454, NULL, 'G3DSA:4.10.280.10:FF:000174', NULL, NULL, 'YALI0D24167p', NULL, NULL, NULL, NULL, NULL, 4),
(187455, NULL, 'G3DSA:2.60.40.10:FF:004304', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187456, NULL, 'G3DSA:2.120.10.30:FF:000303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187457, NULL, 'G3DSA:3.40.50.720:FF:001800', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187458, NULL, 'G3DSA:3.30.1370.100:FF:000023', NULL, NULL, 'ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(187459, NULL, 'G3DSA:1.25.40.10:FF:001656', NULL, NULL, 'Transcription factor BIM2', NULL, NULL, NULL, NULL, NULL, 4),
(187460, NULL, 'G3DSA:3.40.50.10810:FF:000020', NULL, NULL, 'DNA repair and recombination protein RAD54B', NULL, NULL, NULL, NULL, NULL, 4),
(187461, NULL, 'G3DSA:2.60.120.560:FF:000016', NULL, NULL, '2,6-beta-D-fructofuranosidase', NULL, NULL, NULL, NULL, NULL, 4),
(187462, NULL, 'G3DSA:3.30.160.60:FF:005928', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187463, NULL, 'G3DSA:3.30.160.60:FF:006210', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187464, NULL, 'G3DSA:1.20.1440.240:FF:000004', NULL, NULL, 'Flavin monoamine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(187465, NULL, 'G3DSA:1.20.1250.20:FF:001447', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187466, NULL, 'G3DSA:3.90.1410.10:FF:000102', NULL, NULL, 'N-lysine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(187467, NULL, 'G3DSA:1.20.1640.10:FF:000108', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(187468, NULL, 'G3DSA:6.10.140.2150:FF:000005', NULL, NULL, 'S phingosine-1-phosphate lyase 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(187469, NULL, 'G3DSA:2.120.10.80:FF:000037', NULL, NULL, 'Kelch-like family member 40', NULL, NULL, NULL, NULL, NULL, 4),
(187470, NULL, 'G3DSA:3.30.160.60:FF:000555', NULL, NULL, 'Zinc finger protein 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(187471, NULL, 'G3DSA:2.60.260.20:FF:000115', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187472, NULL, 'G3DSA:1.10.246.130:FF:000003', NULL, NULL, 'Glutathione hydrolase 7', NULL, NULL, NULL, NULL, NULL, 4),
(187473, NULL, 'G3DSA:3.50.50.60:FF:001272', NULL, NULL, 'Putative dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(187474, NULL, 'G3DSA:3.90.550.10:FF:000534', NULL, NULL, 'Mannosylglycerate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(187475, NULL, 'G3DSA:3.40.1190.20:FF:000149', NULL, NULL, 'Ribokinase', NULL, NULL, NULL, NULL, NULL, 4),
(187476, NULL, 'G3DSA:3.30.200.20:FF:002520', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187477, NULL, 'G3DSA:3.20.20.70:FF:000740', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187478, NULL, 'G3DSA:1.25.40.20:FF:001659', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(187479, NULL, 'G3DSA:1.25.40.10:FF:001746', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(187480, NULL, 'G3DSA:1.20.120.160:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187481, NULL, 'G3DSA:3.90.76.10:FF:000044', NULL, NULL, 'ABC-type transport system periplasmic substrate-binding protein (Probable substrate dipeptide/oligopeptide)', NULL, NULL, NULL, NULL, NULL, 4),
(187482, NULL, 'G3DSA:3.40.50.740:FF:000047', NULL, NULL, 'Thiosulfate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(187483, NULL, 'G3DSA:3.40.50.300:FF:006115', NULL, NULL, 'AGAP011982-PA', NULL, NULL, NULL, NULL, NULL, 4),
(187484, NULL, 'G3DSA:2.40.170.20:FF:000023', NULL, NULL, 'TonB-dependent siderophore receptor', NULL, NULL, NULL, NULL, NULL, 4),
(187485, NULL, 'G3DSA:1.20.58.2010:FF:000005', NULL, NULL, 'Rop guanine nucleotide exchange factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(187486, NULL, 'G3DSA:2.40.440.10:FF:000013', NULL, NULL, 'Hypothetical Exported Protein', NULL, NULL, NULL, NULL, NULL, 4),
(187487, NULL, 'G3DSA:3.40.50.450:FF:000078', NULL, NULL, 'Phosphofructokinase, liver a', NULL, NULL, NULL, NULL, NULL, 4),
(187488, NULL, 'G3DSA:3.40.50.720:FF:001362', NULL, NULL, 'Prephenate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(187489, NULL, 'G3DSA:3.30.160.60:FF:006171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187490, NULL, 'G3DSA:1.20.1440.230:FF:000001', NULL, NULL, 'Mitochondrial NADH dehydrogenase flavoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(187491, NULL, 'G3DSA:3.40.630.30:FF:000288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187492, NULL, 'G3DSA:2.140.10.20:FF:000002', NULL, NULL, 'Probable c-type cytochrome', NULL, NULL, NULL, NULL, NULL, 4),
(187493, NULL, 'G3DSA:2.80.10.50:FF:000216', NULL, NULL, 'Trypsin inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(187494, NULL, 'G3DSA:2.60.40.3450:FF:000001', NULL, NULL, 'SbsB protein', NULL, NULL, NULL, NULL, NULL, 4),
(187495, NULL, 'G3DSA:3.10.20.90:FF:000257', NULL, NULL, 'Ras interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(187496, NULL, 'G3DSA:1.20.120.350:FF:000188', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187497, NULL, 'G3DSA:3.30.30.30:FF:000048', NULL, NULL, 'Heat shock protein 70, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4),
(187498, NULL, 'G3DSA:3.30.565.10:FF:000071', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(187499, NULL, 'G3DSA:1.10.3380.30:FF:000001', NULL, NULL, 'Ski2 ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(187500, NULL, 'G3DSA:1.20.5.490:FF:000006', NULL, NULL, 'cGMP-dependent protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(187501, NULL, 'G3DSA:3.90.228.10:FF:000027', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(187502, NULL, 'G3DSA:3.40.50.720:FF:000041', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(187503, NULL, 'G3DSA:1.10.510.10:FF:000338', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase', NULL, NULL, NULL, NULL, NULL, 4),
(187504, NULL, 'G3DSA:1.25.10.10:FF:000524', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(187505, NULL, 'G3DSA:3.40.630.190:FF:000002', NULL, NULL, 'LytR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(187506, NULL, 'G3DSA:3.30.160.60:FF:004265', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187507, NULL, 'G3DSA:1.10.238.10:FF:000328', NULL, NULL, 'Calcium-binding EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(187508, NULL, 'G3DSA:3.10.20.310:FF:000037', NULL, NULL, 'Heme/hemopexin transporter protein HuxB', NULL, NULL, NULL, NULL, NULL, 4),
(187509, NULL, 'G3DSA:1.20.5.390:FF:000004', NULL, NULL, 'Optineurin', NULL, NULL, NULL, NULL, NULL, 4),
(187510, NULL, 'G3DSA:3.30.70.330:FF:000312', NULL, NULL, 'RNA-binding protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(187511, NULL, 'G3DSA:1.25.10.10:FF:001593', NULL, NULL, 'Sil1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(187512, NULL, 'G3DSA:1.20.1270.220:FF:000010', NULL, NULL, 'IP01291p', NULL, NULL, NULL, NULL, NULL, 4),
(187513, NULL, 'G3DSA:1.10.287.110:FF:000129', NULL, NULL, 'J domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(187514, NULL, 'G3DSA:1.10.287.1490:FF:000061', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(187515, NULL, 'G3DSA:3.80.10.10:FF:003035', NULL, NULL, 'S-phase kinase-associated protein 2, E3 ubiquitin protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(187516, NULL, 'G3DSA:3.40.50.1000:FF:000422', NULL, NULL, 'HAD family phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(187517, NULL, 'G3DSA:3.20.20.70:FF:000268', NULL, NULL, 'Pyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(187518, NULL, 'G3DSA:3.40.50.11350:FF:000047', NULL, NULL, 'Glycoprotein 6-alpha-L-fucosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(187519, NULL, 'G3DSA:3.40.630.30:FF:000608', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187520, NULL, 'G3DSA:3.40.640.10:FF:000103', NULL, NULL, 'L-allo-threonine aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(187521, NULL, 'G3DSA:3.40.50.2300:FF:001228', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187522, NULL, 'G3DSA:2.60.40.150:FF:000250', NULL, NULL, 'copine-9 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(187523, NULL, 'G3DSA:2.60.40.10:FF:001865', NULL, NULL, 'Polycystin 1, transient receptor potential channel interacting', NULL, NULL, NULL, NULL, NULL, 4),
(187524, NULL, 'G3DSA:2.130.10.10:FF:004046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187525, NULL, 'G3DSA:3.30.70.980:FF:000024', NULL, NULL, 'Probable transcriptional regulatory protein RPR_05505', NULL, NULL, NULL, NULL, NULL, 4),
(187526, NULL, 'G3DSA:1.20.1110.10:FF:000226', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187527, NULL, 'G3DSA:1.10.357.70:FF:000027', NULL, NULL, 'SEC6 homologue, putative', NULL, NULL, NULL, NULL, NULL, 4),
(187528, NULL, 'G3DSA:3.40.50.1240:FF:000151', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187529, NULL, 'G3DSA:3.30.505.10:FF:000179', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187530, NULL, 'G3DSA:3.30.40.10:FF:001734', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(187531, NULL, 'G3DSA:2.180.10.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187532, NULL, 'G3DSA:3.90.230.10:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187533, NULL, 'G3DSA:3.30.830.10:FF:000075', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(187534, NULL, 'G3DSA:3.40.50.970:FF:000003', NULL, NULL, 'Transketolase', NULL, NULL, NULL, NULL, NULL, 4),
(187535, NULL, 'G3DSA:1.10.555.10:FF:000228', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187536, NULL, 'G3DSA:1.25.40.10:FF:002235', NULL, NULL, 'Probable UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SPINDLY', NULL, NULL, NULL, NULL, NULL, 4),
(187537, NULL, 'G3DSA:3.40.50.980:FF:000006', NULL, NULL, 'Enterobactin synthase component F', NULL, NULL, NULL, NULL, NULL, 4),
(187538, NULL, 'G3DSA:2.30.30.40:FF:000525', NULL, NULL, 'Teichoic acids export ATP-binding protein TagH', NULL, NULL, NULL, NULL, NULL, 4),
(187539, NULL, 'G3DSA:3.30.2410.10:FF:000032', NULL, NULL, 'E3 ubiquitin-protein ligase HACE1', NULL, NULL, NULL, NULL, NULL, 4),
(187540, NULL, 'G3DSA:4.10.320.10:FF:000014', NULL, NULL, 'Hef nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(187541, NULL, 'G3DSA:3.90.550.10:FF:000528', NULL, NULL, 'Glycoside transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(187542, NULL, 'G3DSA:4.10.400.10:FF:000072', NULL, NULL, 'Low density lipoprotein receptor', NULL, NULL, NULL, NULL, NULL, 4),
(187543, NULL, 'G3DSA:3.30.2340.10:FF:000003', NULL, NULL, 'tRNA pseudouridine synthase D', NULL, NULL, NULL, NULL, NULL, 4),
(187544, NULL, 'G3DSA:3.50.30.30:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187545, NULL, 'G3DSA:2.60.40.10:FF:000336', NULL, NULL, 'fibronectin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(187546, NULL, 'G3DSA:4.10.410.40:FF:000002', NULL, NULL, 'Lambda phage major tail protein V', NULL, NULL, NULL, NULL, NULL, 4),
(187547, NULL, 'G3DSA:1.10.10.10:FF:000428', NULL, NULL, 'Zinc finger CCCH-type containing, antiviral 1', NULL, NULL, NULL, NULL, NULL, 4),
(187548, NULL, 'G3DSA:2.130.10.10:FF:003973', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187549, NULL, 'G3DSA:3.40.50.2020:FF:000161', NULL, NULL, 'Hypoxanthine-guanine phosphoribosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(187550, NULL, 'G3DSA:2.60.120.260:FF:000033', NULL, NULL, 'E3 ubiquitin-protein ligase HERC2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(187551, NULL, 'G3DSA:2.60.40.10:FF:004613', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187552, NULL, 'G3DSA:2.60.40.10:FF:000813', NULL, NULL, 'Vesicle-associated protein 1-1', NULL, NULL, NULL, NULL, NULL, 4),
(187553, NULL, 'G3DSA:3.30.160.60:FF:005676', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187554, NULL, 'G3DSA:2.10.70.10:FF:000059', NULL, NULL, 'Thyroid peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(187555, NULL, 'G3DSA:6.10.140.2220:FF:000049', NULL, NULL, 'MYND finger containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(187556, NULL, 'G3DSA:3.90.1420.10:FF:000041', NULL, NULL, 'Rubisco small subunit N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(187557, NULL, 'G3DSA:3.30.160.60:FF:002500', NULL, NULL, 'Schnurri, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(187558, NULL, 'G3DSA:2.30.29.30:FF:001183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187559, NULL, 'G3DSA:2.80.10.50:FF:000238', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(187560, NULL, 'G3DSA:2.10.25.10:FF:001045', NULL, NULL, 'Fibulin 2', NULL, NULL, NULL, NULL, NULL, 4),
(187561, NULL, 'G3DSA:2.130.10.10:FF:005575', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187562, NULL, 'G3DSA:2.60.40.790:FF:000115', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(187563, NULL, 'G3DSA:1.10.1420.10:FF:000044', NULL, NULL, 'Putative DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(187564, NULL, 'G3DSA:1.10.510.10:FF:000664', NULL, NULL, 'Serine threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(187565, NULL, 'G3DSA:3.10.28.10:FF:000026', NULL, NULL, 'Intron-encoded DNA endonuclease aI5 alpha', NULL, NULL, NULL, NULL, NULL, 4),
(187566, NULL, 'G3DSA:2.60.40.150:FF:000721', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(187567, NULL, 'G3DSA:3.30.530.20:FF:000151', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187568, NULL, 'G3DSA:2.60.120.380:FF:000086', NULL, NULL, 'Calpain 6', NULL, NULL, NULL, NULL, NULL, 4),
(187569, NULL, 'G3DSA:1.10.1520.10:FF:000097', NULL, NULL, 'Os03g0121800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(187570, NULL, 'G3DSA:2.60.120.970:FF:000061', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187571, NULL, 'G3DSA:3.80.10.10:FF:003506', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187572, NULL, 'G3DSA:3.40.50.10810:FF:000216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187573, NULL, 'G3DSA:3.30.160.60:FF:000881', NULL, NULL, 'Zinc finger protein 605', NULL, NULL, NULL, NULL, NULL, 4),
(187574, NULL, 'G3DSA:3.30.200.20:FF:001374', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(187575, NULL, 'G3DSA:3.40.50.150:FF:000415', NULL, NULL, '2-phytyl-1,4-beta-naphthoquinone methyltransferase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(187576, NULL, 'G3DSA:1.10.150.110:FF:000029', NULL, NULL, 'Pol lambda-related class X DNA repair polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(187577, NULL, 'G3DSA:3.30.420.40:FF:000171', NULL, NULL, 'Heat shock 70 kDa protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(187578, NULL, 'G3DSA:3.40.50.300:FF:002208', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(187579, NULL, 'G3DSA:3.90.70.10:FF:000525', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 30', NULL, NULL, NULL, NULL, NULL, 4),
(187580, NULL, 'G3DSA:3.30.160.60:FF:003899', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187581, NULL, 'G3DSA:3.30.1490.70:FF:000009', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(187582, NULL, 'G3DSA:3.40.50.450:FF:000084', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(187583, NULL, 'G3DSA:3.40.50.1820:FF:000010', NULL, NULL, 'Acyl-protein thioesterase 2', NULL, NULL, NULL, NULL, NULL, 4),
(187584, NULL, 'G3DSA:1.25.10.10:FF:002632', NULL, NULL, 'Serine/threonine protein phosphatase 2A 55 kDa regulatory subunit B'' delta isoform', NULL, NULL, NULL, NULL, NULL, 4),
(187585, NULL, 'G3DSA:1.25.10.10:FF:000491', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(187586, NULL, 'G3DSA:3.30.40.10:FF:001263', NULL, NULL, 'E3 ubiquitin-protein ligase AMFR', NULL, NULL, NULL, NULL, NULL, 4),
(187587, NULL, 'G3DSA:3.10.25.10:FF:000003', NULL, NULL, 'Methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(187588, NULL, 'G3DSA:2.70.150.10:FF:000214', NULL, NULL, 'P-type ATPase, putative (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(187589, NULL, 'G3DSA:3.40.30.10:FF:000839', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(187590, NULL, 'G3DSA:3.30.420.80:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187591, NULL, 'G3DSA:2.60.40.10:FF:006070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187592, NULL, 'G3DSA:3.20.20.70:FF:000739', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187593, NULL, 'G3DSA:1.25.40.20:FF:000681', NULL, NULL, 'Os09g0337300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(187594, NULL, 'G3DSA:3.30.450.40:FF:000010', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(187595, NULL, 'G3DSA:3.30.1610.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187596, NULL, 'G3DSA:3.30.420.10:FF:000639', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187597, NULL, 'G3DSA:1.25.40.10:FF:003764', NULL, NULL, 'Pentatricopeptide repeat-containing protein 3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(187598, NULL, 'G3DSA:3.40.50.10090:FF:000079', NULL, NULL, 'Chromosome 12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(187599, NULL, 'G3DSA:1.10.10.10:FF:000013', NULL, NULL, 'Paired box 8 isoform 1', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(187600, NULL, 'G3DSA:1.50.40.10:FF:000064', NULL, NULL, 'Mitochondrial tricarboxylate transporter (Ctp)', NULL, NULL, NULL, NULL, NULL, 4),
(187601, NULL, 'G3DSA:2.40.170.20:FF:000107', NULL, NULL, 'TonB-dependent siderophore receptor', NULL, NULL, NULL, NULL, NULL, 4),
(187602, NULL, 'G3DSA:1.10.1410.10:FF:000015', NULL, NULL, 'Terminal nucleotidyltransferase 4B', NULL, NULL, NULL, NULL, NULL, 4),
(187603, NULL, 'G3DSA:2.60.40.1180:FF:000207', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(187604, NULL, 'G3DSA:3.30.565.10:FF:000407', NULL, NULL, 'Sensor histidine kinase/response regulator, putative (AFU_orthologue AFUA_4G00660)', NULL, NULL, NULL, NULL, NULL, 4),
(187605, NULL, 'G3DSA:2.10.25.10:FF:000966', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187606, NULL, 'G3DSA:1.10.1200.210:FF:000002', NULL, NULL, 'Chaperonin-like RbcX protein 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(187607, NULL, 'G3DSA:1.10.506.10:FF:000031', NULL, NULL, 'RAS protein activator like 3', NULL, NULL, NULL, NULL, NULL, 4),
(187608, NULL, 'G3DSA:3.30.360.10:FF:000022', NULL, NULL, 'Oxidoreductase, NAD-binding', NULL, NULL, NULL, NULL, NULL, 4),
(187609, NULL, 'G3DSA:2.20.25.240:FF:000015', NULL, NULL, 'Modifier of mdg4', NULL, NULL, NULL, NULL, NULL, 4),
(187610, NULL, 'G3DSA:1.10.10.10:FF:000120', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(187611, NULL, 'G3DSA:3.40.50.150:FF:000095', NULL, NULL, '2-methyl-6-phytyl-1,4-hydroquinone methyltransferase, chloroplastic-like', NULL, NULL, NULL, NULL, NULL, 4),
(187612, NULL, 'G3DSA:3.40.1350.10:FF:000018', NULL, NULL, 'Mrr restriction system protein', NULL, NULL, NULL, NULL, NULL, 4),
(187613, NULL, 'G3DSA:1.25.40.450:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187614, NULL, 'G3DSA:1.20.5.730:FF:000005', NULL, NULL, 'RABaptiN (Rab effector)', NULL, NULL, NULL, NULL, NULL, 4),
(187615, NULL, 'G3DSA:2.60.40.10:FF:003995', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187616, NULL, 'G3DSA:1.20.960.40:FF:000002', NULL, NULL, 'LisH domain-containing protein FOPNL', NULL, NULL, NULL, NULL, NULL, 4),
(187617, NULL, 'G3DSA:3.30.70.3290:FF:000021', NULL, NULL, 'Lovastatin diketide synthase LovF', NULL, NULL, NULL, NULL, NULL, 4),
(187618, NULL, 'G3DSA:1.20.82.10:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187619, NULL, 'G3DSA:1.10.510.10:FF:002047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187620, NULL, 'G3DSA:2.40.30.270:FF:000001', NULL, NULL, 'Immunoglobulin mu DNA-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(187621, NULL, 'G3DSA:3.40.910.10:FF:000006', NULL, NULL, 'Probable deoxyhypusine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(187622, NULL, 'G3DSA:3.30.2320.10:FF:000002', NULL, NULL, 'Major capsid subunit', NULL, NULL, NULL, NULL, NULL, 4),
(187623, NULL, 'G3DSA:3.30.360.20:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187624, NULL, 'G3DSA:1.10.510.10:FF:001974', NULL, NULL, 'CMGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(187625, NULL, 'G3DSA:3.40.50.300:FF:000174', NULL, NULL, 'HPr kinase/phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(187626, NULL, 'G3DSA:3.40.50.1820:FF:001314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187627, NULL, 'G3DSA:3.80.10.10:FF:001472', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(187628, NULL, 'G3DSA:3.90.550.50:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187629, NULL, 'G3DSA:2.40.50.140:FF:001248', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187630, NULL, 'G3DSA:2.120.10.80:FF:000150', NULL, NULL, 'Protein CBG04780', NULL, NULL, NULL, NULL, NULL, 4),
(187631, NULL, 'G3DSA:3.30.1370.100:FF:000040', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(187632, NULL, 'G3DSA:1.10.510.10:FF:000445', NULL, NULL, 'MDIS1-interacting receptor like kinase 2', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(187633, NULL, 'G3DSA:2.40.30.10:FF:000117', NULL, NULL, 'Translation initiation factor IF-2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(187634, NULL, 'G3DSA:3.30.160.40:FF:000015', NULL, NULL, 'Hydroxymethylbilane synthase', NULL, NULL, NULL, NULL, NULL, 4),
(187635, NULL, 'G3DSA:3.30.560.10:FF:000003', NULL, NULL, 'Blast:Glucose dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(187636, NULL, 'G3DSA:1.10.418.10:FF:000202', NULL, NULL, 'Actin bundling protein', NULL, NULL, NULL, NULL, NULL, 4),
(187637, NULL, 'G3DSA:3.30.160.60:FF:000572', NULL, NULL, 'Zinc finger and BTB domain containing 7C', NULL, NULL, NULL, NULL, NULL, 4),
(187638, NULL, 'G3DSA:2.60.40.10:FF:005940', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187639, NULL, 'G3DSA:1.20.1280.50:FF:000126', NULL, NULL, 'WGS project CABT00000000 data, contig 2.5', NULL, NULL, NULL, NULL, NULL, 4),
(187640, NULL, 'G3DSA:1.10.1070.11:FF:000113', NULL, NULL, 'Serine/threonine-protein kinase Tel1', NULL, NULL, NULL, NULL, NULL, 4),
(187641, NULL, 'G3DSA:1.10.20.10:FF:000255', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187642, NULL, 'G3DSA:3.40.50.720:FF:000957', NULL, NULL, 'Glucose 1-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(187643, NULL, 'G3DSA:3.30.200.20:FF:002301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187644, NULL, 'G3DSA:2.70.170.10:FF:000070', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(187645, NULL, 'G3DSA:2.60.40.10:FF:000561', NULL, NULL, 'Neural cell adhesion molecule L1', NULL, NULL, NULL, NULL, NULL, 4),
(187646, NULL, 'G3DSA:1.10.510.10:FF:004407', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187647, NULL, 'G3DSA:2.40.10.10:FF:000470', NULL, NULL, 'Transmembrane protease serine 9-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(187648, NULL, 'G3DSA:1.20.1250.20:FF:001228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187649, NULL, 'G3DSA:3.30.200.20:FF:001267', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(187650, NULL, 'G3DSA:3.30.160.60:FF:004372', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187651, NULL, 'G3DSA:1.10.30.10:FF:000121', NULL, NULL, 'LD26355p', NULL, NULL, NULL, NULL, NULL, 4),
(187652, NULL, 'G3DSA:2.60.120.330:FF:000077', NULL, NULL, '2-oxoglutarate-dependent dioxygenase DAO', NULL, NULL, NULL, NULL, NULL, 4),
(187653, NULL, 'G3DSA:1.10.1370.30:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187654, NULL, 'G3DSA:1.10.10.10:FF:000209', NULL, NULL, 'Regulatory protein RecX', NULL, NULL, NULL, NULL, NULL, 4),
(187655, NULL, 'G3DSA:1.10.1450.10:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187656, NULL, 'G3DSA:3.30.200.20:FF:000047', NULL, NULL, 'focal adhesion kinase 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(187657, NULL, 'G3DSA:2.130.10.10:FF:005356', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187658, NULL, 'G3DSA:1.20.50.20:FF:000001', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(187659, NULL, 'G3DSA:2.10.70.10:FF:000278', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187660, NULL, 'G3DSA:1.10.510.10:FF:003789', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187661, NULL, 'G3DSA:1.10.287.110:FF:000455', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187662, NULL, 'G3DSA:3.40.50.150:FF:000106', NULL, NULL, 'Trans-aconitate 2-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(187663, NULL, 'G3DSA:3.10.110.10:FF:000154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187664, NULL, 'G3DSA:2.60.40.60:FF:000345', NULL, NULL, 'Cadherin 2', NULL, NULL, NULL, NULL, NULL, 4),
(187665, NULL, 'G3DSA:3.50.50.60:FF:001507', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(187666, NULL, 'G3DSA:3.40.50.1820:FF:000696', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187667, NULL, 'G3DSA:3.40.50.300:FF:005755', NULL, NULL, 'Dynein-1-beta heavy chain, flagellar inner arm I1 complex', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(187668, NULL, 'G3DSA:1.10.510.10:FF:000136', NULL, NULL, 'mitogen-activated protein kinase 6', NULL, NULL, NULL, NULL, NULL, 4),
(187669, NULL, 'G3DSA:3.30.310.220:FF:000003', NULL, NULL, 'YALI0E06519p', NULL, NULL, NULL, NULL, NULL, 4),
(187670, NULL, 'G3DSA:3.30.70.330:FF:001931', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187671, NULL, 'G3DSA:3.40.50.720:FF:001036', NULL, NULL, 'Saccharopine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(187672, NULL, 'G3DSA:3.30.200.20:FF:001576', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187673, NULL, 'G3DSA:1.20.1110.10:FF:000119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187674, NULL, 'G3DSA:1.10.860.10:FF:000016', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(187675, NULL, 'G3DSA:3.40.640.10:FF:000322', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(187676, NULL, 'G3DSA:2.160.20.10:FF:000223', NULL, NULL, 'Glr0404 protein', NULL, NULL, NULL, NULL, NULL, 4),
(187677, NULL, 'G3DSA:2.30.30.40:FF:000110', NULL, NULL, 'Cytoplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(187678, NULL, 'G3DSA:3.90.80.10:FF:000026', NULL, NULL, 'Pyrophosphatase (inorganic) 2', NULL, NULL, NULL, NULL, NULL, 4),
(187679, NULL, 'G3DSA:3.60.21.50:FF:000015', NULL, NULL, 'DNA polymerase III (Delta) subunit (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(187680, NULL, 'G3DSA:1.20.1640.10:FF:000002', NULL, NULL, 'Efflux pump membrane transporter', NULL, NULL, NULL, NULL, NULL, 4),
(187681, NULL, 'G3DSA:1.10.579.10:FF:000002', NULL, NULL, 'Deoxyribodipyrimidine photolyase', NULL, NULL, NULL, NULL, NULL, 4),
(187682, NULL, 'G3DSA:2.60.40.1230:FF:000026', NULL, NULL, 'Probable ADP-ribosylation factor-binding protein C1F3.05', NULL, NULL, NULL, NULL, NULL, 4),
(187683, NULL, 'G3DSA:1.10.10.60:FF:000218', NULL, NULL, 'Myb transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(187684, NULL, 'G3DSA:3.40.50.300:FF:004226', NULL, NULL, 'eukaryotic peptide chain release factor GTP-binding subunit ERF3A', NULL, NULL, NULL, NULL, NULL, 4),
(187685, NULL, 'G3DSA:2.60.175.20:FF:000001', NULL, NULL, 'Major capsid protein L1', NULL, NULL, NULL, NULL, NULL, 4),
(187686, NULL, 'G3DSA:3.40.50.10190:FF:000339', NULL, NULL, 'Pescadillo homolog', NULL, NULL, NULL, NULL, NULL, 4),
(187687, NULL, 'G3DSA:3.40.50.1000:FF:000113', NULL, NULL, 'Putative haloacid dehalogenase-like hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(187688, NULL, 'G3DSA:3.40.50.10190:FF:000087', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(187689, NULL, 'G3DSA:3.20.20.10:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187690, NULL, 'G3DSA:1.25.40.180:FF:000258', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187691, NULL, 'G3DSA:3.90.226.10:FF:000062', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase-like protein 3 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(187692, NULL, 'G3DSA:2.130.10.10:FF:004810', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187693, NULL, 'G3DSA:3.30.70.330:FF:001622', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187694, NULL, 'G3DSA:3.40.50.300:FF:006008', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187695, NULL, 'G3DSA:3.60.21.60:FF:000018', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(187696, NULL, 'G3DSA:3.30.200.20:FF:001828', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187697, NULL, 'G3DSA:2.60.40.10:FF:005917', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187698, NULL, 'G3DSA:3.40.190.10:FF:000141', NULL, NULL, 'Taurine ABC transporter, periplasmic taurine-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(187699, NULL, 'G3DSA:2.10.25.10:FF:001354', NULL, NULL, 'Cysteine-rich with EGF-like domain protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(187700, NULL, 'G3DSA:1.10.560.10:FF:000049', NULL, NULL, 'T-complex protein 1 subunitTheta, putative', NULL, NULL, NULL, NULL, NULL, 4),
(187701, NULL, 'G3DSA:3.40.50.2300:FF:001447', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(187702, NULL, 'G3DSA:1.20.1070.10:FF:001481', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187703, NULL, 'G3DSA:2.60.200.20:FF:000140', NULL, NULL, 'Serine/threonine-protein kinase RAD53', NULL, NULL, NULL, NULL, NULL, 4),
(187704, NULL, 'G3DSA:3.30.160.60:FF:006406', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187705, NULL, 'G3DSA:3.40.50.300:FF:007099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187706, NULL, 'G3DSA:1.20.5.780:FF:000014', NULL, NULL, 'FXYD domain-containing ion transport regulator', NULL, NULL, NULL, NULL, NULL, 4),
(187707, NULL, 'G3DSA:2.10.25.10:FF:000747', NULL, NULL, 'Protein eyes shut homolog', NULL, NULL, NULL, NULL, NULL, 4),
(187708, NULL, 'G3DSA:1.25.40.20:FF:000349', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187709, NULL, 'G3DSA:4.10.400.10:FF:000291', NULL, NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(187710, NULL, 'G3DSA:3.40.50.620:FF:000697', NULL, NULL, 'Aminoacyl-tRNA synthetase class Ib', NULL, NULL, NULL, NULL, NULL, 4),
(187711, NULL, 'G3DSA:1.20.1250.20:FF:000975', NULL, NULL, 'Proton-dependent oligopeptide transport family protein', NULL, NULL, NULL, NULL, NULL, 4),
(187712, NULL, 'G3DSA:2.30.30.1020:FF:000009', NULL, NULL, 'Related to CDC36-transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(187713, NULL, 'G3DSA:2.60.120.10:FF:000417', NULL, NULL, 'bifunctional peptidase and (3S)-lysyl hydroxylase JMJD7 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(187714, NULL, 'G3DSA:3.50.50.60:FF:000889', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187715, NULL, 'G3DSA:1.10.8.270:FF:000111', NULL, NULL, 'GTPase-activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(187716, NULL, 'G3DSA:2.10.220.10:FF:000054', NULL, NULL, 'Fraser extracellular matrix complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(187717, NULL, 'G3DSA:3.90.79.10:FF:000270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187718, NULL, 'G3DSA:1.25.40.10:FF:002128', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g33350', NULL, NULL, NULL, NULL, NULL, 4),
(187719, NULL, 'G3DSA:1.10.8.720:FF:000055', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(187720, NULL, 'G3DSA:2.60.40.10:FF:005608', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187721, NULL, 'G3DSA:3.30.160.60:FF:004624', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187722, NULL, 'G3DSA:2.130.10.10:FF:002231', NULL, NULL, 'NACHT and WD domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(187723, NULL, 'G3DSA:1.20.120.140:FF:000024', NULL, NULL, 'Signal recognition particle receptor FtsY', NULL, NULL, NULL, NULL, NULL, 4),
(187724, NULL, 'G3DSA:3.40.980.10:FF:000050', NULL, NULL, 'Flavin adenine dinucleotide synthetase 1', NULL, NULL, NULL, NULL, NULL, 4),
(187725, NULL, 'G3DSA:1.10.8.10:FF:000265', NULL, NULL, 'Translation elongation factor EF-1 alpha/Tu, putative', NULL, NULL, NULL, NULL, NULL, 4),
(187726, NULL, 'G3DSA:1.20.58.830:FF:000035', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(187727, NULL, 'G3DSA:3.30.160.60:FF:002264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187728, NULL, 'G3DSA:3.30.420.40:FF:000480', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187729, NULL, 'G3DSA:2.20.25.10:FF:000123', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(187730, NULL, 'G3DSA:3.40.1110.10:FF:000259', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187731, NULL, 'G3DSA:3.30.70.20:FF:000019', NULL, NULL, 'Ferredoxin-type protein NapG', NULL, NULL, NULL, NULL, NULL, 4),
(187732, NULL, 'G3DSA:1.10.10.10:FF:000119', NULL, NULL, 'DNA damage and replication checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(187733, NULL, 'G3DSA:1.20.58.1250:FF:000002', NULL, NULL, 'Tubulin-specific chaperone c, putative', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(187734, NULL, 'G3DSA:1.20.58.380:FF:000001', NULL, NULL, 'Flagellar protein FliT', NULL, NULL, NULL, NULL, NULL, 4),
(187735, NULL, 'G3DSA:2.170.130.30:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187736, NULL, 'G3DSA:2.60.40.10:FF:006103', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187737, NULL, 'G3DSA:3.30.70.330:FF:001841', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187738, NULL, 'G3DSA:3.40.50.1000:FF:000528', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187739, NULL, 'G3DSA:3.90.79.10:FF:000051', NULL, NULL, 'Probable NADH pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(187740, NULL, 'G3DSA:2.60.200.20:FF:000117', NULL, NULL, 'FHA domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(187741, NULL, 'G3DSA:2.60.40.60:FF:000126', NULL, NULL, 'Cadherin-related family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(187742, NULL, 'G3DSA:2.60.120.920:FF:000068', NULL, NULL, 'SPRY domain', NULL, NULL, NULL, NULL, NULL, 4),
(187743, NULL, 'G3DSA:3.40.50.1820:FF:001623', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187744, NULL, 'G3DSA:2.40.100.10:FF:000050', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(187745, NULL, 'G3DSA:3.30.559.10:FF:000011', NULL, NULL, '2-oxoglutarate dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(187746, NULL, 'G3DSA:3.30.420.40:FF:000822', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(187747, NULL, 'G3DSA:1.20.58.390:FF:000004', NULL, NULL, 'Gamma-aminobutyric acid receptor subunit beta-2 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(187748, NULL, 'G3DSA:3.40.50.1980:FF:000120', NULL, NULL, 'Iron-siderophore ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(187749, NULL, 'G3DSA:1.25.40.10:FF:003455', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g21300', NULL, NULL, NULL, NULL, NULL, 4),
(187750, NULL, 'G3DSA:3.10.580.10:FF:000195', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187751, NULL, 'G3DSA:1.25.10.10:FF:002323', NULL, NULL, 'LP05312p', NULL, NULL, NULL, NULL, NULL, 4),
(187752, NULL, 'G3DSA:3.30.160.60:FF:006064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187753, NULL, 'G3DSA:1.25.40.10:FF:000217', NULL, NULL, 'Pentatricopeptide repeat domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(187754, NULL, 'G3DSA:3.20.20.80:FF:000636', NULL, NULL, 'Glycosyl hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(187755, NULL, 'G3DSA:1.20.1070.10:FF:001352', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187756, NULL, 'G3DSA:3.20.20.70:FF:000633', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187757, NULL, 'G3DSA:3.30.2350.20:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187758, NULL, 'G3DSA:3.90.1010.20:FF:000001', NULL, NULL, 'Chlorophenol reductase', NULL, NULL, NULL, NULL, NULL, 4),
(187759, NULL, 'G3DSA:1.20.58.2220:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187760, NULL, 'G3DSA:3.90.1660.10:FF:000002', NULL, NULL, 'Coenzyme F420:L-glutamate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(187761, NULL, 'G3DSA:1.20.1310.10:FF:000123', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187762, NULL, 'G3DSA:1.20.144.10:FF:000024', NULL, NULL, 'dolichyldiphosphatase 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(187763, NULL, 'G3DSA:1.10.150.20:FF:000010', NULL, NULL, 'DNA polymerase lambda', NULL, NULL, NULL, NULL, NULL, 4),
(187764, NULL, 'G3DSA:2.40.50.100:FF:000213', NULL, NULL, 'Sugar ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(187765, NULL, 'G3DSA:3.30.360.10:FF:000128', NULL, NULL, 'Glucose-6-phosphate 1-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(187766, NULL, 'G3DSA:2.40.110.10:FF:000022', NULL, NULL, 'Nitroalkane oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(187767, NULL, 'G3DSA:3.30.40.10:FF:000897', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(187768, NULL, 'G3DSA:3.40.190.80:FF:000027', NULL, NULL, 'Inositol monophosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(187769, NULL, 'G3DSA:1.10.510.10:FF:004155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187770, NULL, 'G3DSA:3.30.1330.20:FF:000051', NULL, NULL, 'Cell division protein FtsZ', NULL, NULL, NULL, NULL, NULL, 4),
(187771, NULL, 'G3DSA:3.40.1060.10:FF:000007', NULL, NULL, 'Aconitate hydratase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(187772, NULL, 'G3DSA:3.30.160.60:FF:004063', NULL, NULL, 'Zinc finger protein 423', NULL, NULL, NULL, NULL, NULL, 4),
(187773, NULL, 'G3DSA:1.20.1270.220:FF:000009', NULL, NULL, 'Transcription factor GTE6', NULL, NULL, NULL, NULL, NULL, 4),
(187774, NULL, 'G3DSA:3.30.559.30:FF:000017', NULL, NULL, 'Phenolpthiocerol synthesis type-I polyketide synthase PPSE', NULL, NULL, NULL, NULL, NULL, 4),
(187775, NULL, 'G3DSA:3.40.50.300:FF:008026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187776, NULL, 'G3DSA:2.40.50.730:FF:000025', NULL, NULL, 'DNA polymerase alpha subunit one', NULL, NULL, NULL, NULL, NULL, 4),
(187777, NULL, 'G3DSA:2.30.30.40:FF:000216', NULL, NULL, 'growth arrest-specific protein 7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(187778, NULL, 'G3DSA:2.60.40.340:FF:000003', NULL, NULL, 'NFkB p65 transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(187779, NULL, 'G3DSA:1.20.1420.10:FF:000019', NULL, NULL, 'YLR287C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(187780, NULL, 'G3DSA:3.80.10.10:FF:000848', NULL, NULL, 'Si:dkey-22a18.2', NULL, NULL, NULL, NULL, NULL, 4),
(187781, NULL, 'G3DSA:1.25.40.20:FF:000333', NULL, NULL, 'ankyrin repeat domain-containing protein 13C isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(187782, NULL, 'G3DSA:1.10.510.10:FF:002356', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187783, NULL, 'G3DSA:1.25.40.10:FF:000330', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(187784, NULL, 'G3DSA:3.90.1140.10:FF:000002', NULL, NULL, 'U6 snRNA phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(187785, NULL, 'G3DSA:3.40.50.410:FF:000297', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(187786, NULL, 'G3DSA:2.40.30.10:FF:000336', NULL, NULL, 'Sulfate adenylyltransferase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(187787, NULL, 'G3DSA:3.30.200.20:FF:000412', NULL, NULL, 'interleukin-1 receptor-associated kinase-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(187788, NULL, 'G3DSA:1.20.1280.50:FF:000199', NULL, NULL, 'F-box only protein 6-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(187789, NULL, 'G3DSA:3.80.10.10:FF:003254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187790, NULL, 'G3DSA:3.30.230.130:FF:000036', NULL, NULL, 'Cullin_family /Cullin_protein_neddylation_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(187791, NULL, 'G3DSA:1.20.5.190:FF:000023', NULL, NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(187792, NULL, 'G3DSA:3.30.500.10:FF:000011', NULL, NULL, 'Histocompatibility antigen 60b', NULL, NULL, NULL, NULL, NULL, 4),
(187793, NULL, 'G3DSA:1.10.472.170:FF:000013', NULL, NULL, 'Transcription initiation factor IIB 5', NULL, NULL, NULL, NULL, NULL, 4),
(187794, NULL, 'G3DSA:3.30.1140.60:FF:000019', NULL, NULL, 'F-actin-capping protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(187795, NULL, 'G3DSA:3.60.21.10:FF:000138', NULL, NULL, 'Calcineurin-like phosphoesterase', NULL, NULL, NULL, NULL, NULL, 4),
(187796, NULL, 'G3DSA:3.90.1480.20:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187797, NULL, 'G3DSA:1.10.3720.10:FF:000123', NULL, NULL, 'NitT/TauT family transport system permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(187798, NULL, 'G3DSA:1.20.120.1200:FF:000023', NULL, NULL, 'NADH-quinone oxidoreductase subunit J', NULL, NULL, NULL, NULL, NULL, 4),
(187799, NULL, 'G3DSA:3.40.50.300:FF:006811', NULL, NULL, 'GTPase Rho, putative', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(187800, NULL, 'G3DSA:3.30.70.330:FF:001695', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187801, NULL, 'G3DSA:2.130.10.10:FF:001865', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(187802, NULL, 'G3DSA:3.30.70.330:FF:002313', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187803, NULL, 'G3DSA:2.130.10.10:FF:005884', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187804, NULL, 'G3DSA:3.90.70.10:FF:000216', NULL, NULL, 'Pre-mRNA-splicing factor SAD1', NULL, NULL, NULL, NULL, NULL, 4),
(187805, NULL, 'G3DSA:1.20.1250.20:FF:000756', NULL, NULL, 'Similar to MFS sugar transporter', NULL, NULL, NULL, NULL, NULL, 4),
(187806, NULL, 'G3DSA:1.10.3080.10:FF:000080', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(187807, NULL, 'G3DSA:1.20.58.390:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187808, NULL, 'G3DSA:2.40.50.140:FF:000995', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187809, NULL, 'G3DSA:1.25.40.10:FF:000127', NULL, NULL, 'anaphase-promoting complex subunit 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(187810, NULL, 'G3DSA:1.10.4020.10:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187811, NULL, 'G3DSA:2.30.29.30:FF:001216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187812, NULL, 'G3DSA:3.30.1120.10:FF:000015', NULL, NULL, 'Arylsulfatase H', NULL, NULL, NULL, NULL, NULL, 4),
(187813, NULL, 'G3DSA:3.30.70.80:FF:000032', NULL, NULL, 'Minor extracellular protease VpR', NULL, NULL, NULL, NULL, NULL, 4),
(187814, NULL, 'G3DSA:1.20.5.340:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187815, NULL, 'G3DSA:3.30.70.1730:FF:000065', NULL, NULL, 'Ribosomal protein L10 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(187816, NULL, 'G3DSA:2.130.10.10:FF:003664', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187817, NULL, 'G3DSA:2.60.40.790:FF:000205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187818, NULL, 'G3DSA:3.90.980.20:FF:000002', NULL, NULL, 'Ash2 like, histone lysine methyltransferase complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(187819, NULL, 'G3DSA:2.130.10.10:FF:002702', NULL, NULL, 'Ribosome biogenesis protein NSA1', NULL, NULL, NULL, NULL, NULL, 4),
(187820, NULL, 'G3DSA:3.30.70.330:FF:001386', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187821, NULL, 'G3DSA:3.40.720.10:FF:000267', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187822, NULL, 'G3DSA:3.90.1750.10:FF:000032', NULL, NULL, 'E3 ubiquitin-protein ligase UPL5', NULL, NULL, NULL, NULL, NULL, 4),
(187823, NULL, 'G3DSA:2.60.40.60:FF:000216', NULL, NULL, 'protocadherin gamma-C5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(187824, NULL, 'G3DSA:3.30.40.10:FF:001515', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187825, NULL, 'G3DSA:3.30.1540.20:FF:000004', NULL, NULL, 'DNA mismatch repair protein Mlh3', NULL, NULL, NULL, NULL, NULL, 4),
(187826, NULL, 'G3DSA:1.10.260.60:FF:000002', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', NULL, NULL, NULL, NULL, NULL, 4),
(187827, NULL, 'G3DSA:1.50.40.10:FF:000373', NULL, NULL, 'Mitochondrial carrier', NULL, NULL, NULL, NULL, NULL, 4),
(187828, NULL, 'G3DSA:3.30.505.10:FF:000073', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(187829, NULL, 'G3DSA:3.90.1410.10:FF:000091', NULL, NULL, 'Rubisco large subunit N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(187830, NULL, 'G3DSA:1.25.70.10:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187831, NULL, 'G3DSA:3.40.50.300:FF:002517', NULL, NULL, 'Genetic interactor of prohibitins 3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(187832, NULL, 'G3DSA:3.40.50.1100:FF:000008', NULL, NULL, 'L-threonine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(187833, NULL, 'G3DSA:3.10.100.10:FF:000125', NULL, NULL, 'Mannan-binding lectin H3', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(187834, NULL, 'G3DSA:2.20.60.10:FF:000002', NULL, NULL, 'Midkine a', NULL, NULL, NULL, NULL, NULL, 4),
(187835, NULL, 'G3DSA:3.40.50.300:FF:001899', NULL, NULL, 'ATP dependent DEAD-box helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(187836, NULL, 'G3DSA:1.10.533.10:FF:000161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187837, NULL, 'G3DSA:3.30.1600.10:FF:000041', NULL, NULL, 'Sirtuin 7', NULL, NULL, NULL, NULL, NULL, 4),
(187838, NULL, 'G3DSA:2.10.80.10:FF:000009', NULL, NULL, 'Colipase like 1', NULL, NULL, NULL, NULL, NULL, 4),
(187839, NULL, 'G3DSA:2.60.120.920:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187840, NULL, 'G3DSA:3.40.50.11990:FF:000008', NULL, NULL, 'Hyrax', NULL, NULL, NULL, NULL, NULL, 4),
(187841, NULL, 'G3DSA:1.50.40.10:FF:000592', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187842, NULL, 'G3DSA:2.10.50.10:FF:000171', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187843, NULL, 'G3DSA:3.30.420.10:FF:000078', NULL, NULL, 'Ribonuclease HII', NULL, NULL, NULL, NULL, NULL, 4),
(187844, NULL, 'G3DSA:3.30.160.60:FF:003568', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187845, NULL, 'G3DSA:2.60.40.10:FF:002051', NULL, NULL, 'Mesocentin', NULL, NULL, NULL, NULL, NULL, 4),
(187846, NULL, 'G3DSA:3.10.20.70:FF:000010', NULL, NULL, 'Glutamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(187847, NULL, 'G3DSA:3.40.720.10:FF:000177', NULL, NULL, '23-bisphosphoglycerate-independent phosphoglycerate mutase 1', NULL, NULL, NULL, NULL, NULL, 4),
(187848, NULL, 'G3DSA:3.30.870.10:FF:000105', NULL, NULL, 'Phosphatidylcholine-hydrolyzing phospholipase D (PLD) protein', NULL, NULL, NULL, NULL, NULL, 4),
(187849, NULL, 'G3DSA:1.20.58.60:FF:000828', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187850, NULL, 'G3DSA:1.10.510.10:FF:003992', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187851, NULL, 'G3DSA:3.30.420.10:FF:000729', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187852, NULL, 'G3DSA:3.60.21.10:FF:000380', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187853, NULL, 'G3DSA:3.40.190.10:FF:000012', NULL, NULL, 'glutamate receptor ionotropic, NMDA 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(187854, NULL, 'G3DSA:3.20.20.70:FF:000178', NULL, NULL, 'Thiamine-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(187855, NULL, 'G3DSA:2.60.120.10:FF:000765', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187856, NULL, 'G3DSA:1.25.40.570:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187857, NULL, 'G3DSA:3.90.700.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187858, NULL, 'G3DSA:1.20.920.10:FF:000098', NULL, NULL, 'SWI/SNF nucleosome remodeling complex component', NULL, NULL, NULL, NULL, NULL, 4),
(187859, NULL, 'G3DSA:3.40.630.10:FF:000041', NULL, NULL, 'Carboxypeptidase M', NULL, NULL, NULL, NULL, NULL, 4),
(187860, NULL, 'G3DSA:3.30.420.10:FF:000387', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187861, NULL, 'G3DSA:1.10.150.80:FF:000022', NULL, NULL, 'Exosome complex exonuclease RRP6', NULL, NULL, NULL, NULL, NULL, 4),
(187862, NULL, 'G3DSA:1.10.220.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187863, NULL, 'G3DSA:3.40.50.1440:FF:000076', NULL, NULL, 'Tubulin beta-3 chain-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(187864, NULL, 'G3DSA:1.25.10.10:FF:000502', NULL, NULL, 'TATA-binding protein-associated factor BTAF1', NULL, NULL, NULL, NULL, NULL, 4),
(187865, NULL, 'G3DSA:1.10.1410.10:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187866, NULL, 'G3DSA:3.40.1550.10:FF:000005', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(187867, NULL, 'G3DSA:1.10.238.10:FF:000306', NULL, NULL, 'Solute carrier family 25 member 12', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(187868, NULL, 'G3DSA:3.40.30.10:FF:000862', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187869, NULL, 'G3DSA:3.30.365.10:FF:000084', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187870, NULL, 'G3DSA:3.90.290.10:FF:000036', NULL, NULL, 'Follistatin', NULL, NULL, NULL, NULL, NULL, 4),
(187871, NULL, 'G3DSA:1.20.1250.40:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187872, NULL, 'G3DSA:1.50.40.10:FF:000283', NULL, NULL, 'Flavin adenine dinucleotide transporter', NULL, NULL, NULL, NULL, NULL, 4),
(187873, NULL, 'G3DSA:3.40.50.1100:FF:000250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187874, NULL, 'G3DSA:4.10.60.10:FF:000211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187875, NULL, 'G3DSA:3.40.1280.30:FF:000018', NULL, NULL, 'Os02g0725600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(187876, NULL, 'G3DSA:1.10.510.10:FF:000810', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187877, NULL, 'G3DSA:3.40.1550.20:FF:000008', NULL, NULL, 'Transcriptional regulator MraZ', NULL, NULL, NULL, NULL, NULL, 4),
(187878, NULL, 'G3DSA:3.40.50.11980:FF:000005', NULL, NULL, 'CCAAT-box DNA binding protein subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(187879, NULL, 'G3DSA:3.10.20.80:FF:000013', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187880, NULL, 'G3DSA:3.40.630.30:FF:000518', NULL, NULL, 'N-acetyltransferase, GNAT family', NULL, NULL, NULL, NULL, NULL, 4),
(187881, NULL, 'G3DSA:1.10.510.10:FF:004301', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187882, NULL, 'G3DSA:3.20.20.70:FF:000487', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187883, NULL, 'G3DSA:3.30.70.330:FF:002004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187884, NULL, 'G3DSA:3.30.565.10:FF:000301', NULL, NULL, 'Hybrid signal transduction histidine kinase B', NULL, NULL, NULL, NULL, NULL, 4),
(187885, NULL, 'G3DSA:3.40.1110.10:FF:000478', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187886, NULL, 'G3DSA:3.90.70.10:FF:000306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187887, NULL, 'G3DSA:1.10.10.10:FF:001755', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187888, NULL, 'G3DSA:3.30.200.20:FF:000502', NULL, NULL, 'Tyrosine-protein kinase Drl', NULL, NULL, NULL, NULL, NULL, 4),
(187889, NULL, 'G3DSA:1.50.10.10:FF:000236', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(187890, NULL, 'G3DSA:3.30.497.10:FF:000041', NULL, NULL, 'Serpin 42Dc, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(187891, NULL, 'G3DSA:2.60.40.10:FF:002360', NULL, NULL, 'Si:dkey-222p3.1', NULL, NULL, NULL, NULL, NULL, 4),
(187892, NULL, 'G3DSA:3.40.50.10470:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187893, NULL, 'G3DSA:3.40.50.150:FF:001489', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187894, NULL, 'G3DSA:1.10.3430.10:FF:000022', NULL, NULL, 'Os01g0831300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(187895, NULL, 'G3DSA:2.60.40.10:FF:002270', NULL, NULL, 'Myotactin form B', NULL, NULL, NULL, NULL, NULL, 4),
(187896, NULL, 'G3DSA:1.10.10.10:FF:002121', NULL, NULL, 'Putative asnC-family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(187897, NULL, 'G3DSA:2.10.60.10:FF:000087', NULL, NULL, 'Serine/threonine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(187898, NULL, 'G3DSA:3.60.10.10:FF:000366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187899, NULL, 'G3DSA:3.40.50.620:FF:000011', NULL, NULL, 'Electron transfer flavoprotein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(187900, NULL, 'G3DSA:3.40.30.10:FF:000059', NULL, NULL, 'Thioredoxin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(187901, NULL, 'G3DSA:1.10.167.10:FF:000023', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(187902, NULL, 'G3DSA:3.40.50.1970:FF:000004', NULL, NULL, 'N5-carboxyaminoimidazole ribonucleotide mutase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(187903, NULL, 'G3DSA:1.20.1740.10:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187904, NULL, 'G3DSA:1.10.110.10:FF:000010', NULL, NULL, 'Bifunctional inhibitor/lipid-transfer protein/seed storage 2S albumin superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(187905, NULL, 'G3DSA:3.40.50.200:FF:000127', NULL, NULL, 'Clan SB, family S8, subtilisin-like serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(187906, NULL, 'G3DSA:1.10.506.10:FF:000008', NULL, NULL, 'RAS p21 protein activator 1', NULL, NULL, NULL, NULL, NULL, 4),
(187907, NULL, 'G3DSA:2.130.10.10:FF:002337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187908, NULL, 'G3DSA:3.40.50.300:FF:007863', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187909, NULL, 'G3DSA:3.30.40.10:FF:001605', NULL, NULL, 'Putative RING finger domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(187910, NULL, 'G3DSA:3.90.1150.120:FF:000001', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 17', NULL, NULL, NULL, NULL, NULL, 4),
(187911, NULL, 'G3DSA:3.80.10.10:FF:002888', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187912, NULL, 'G3DSA:2.170.270.10:FF:000137', NULL, NULL, 'Putative transcription factor blimp-1/prdi-bf1', NULL, NULL, NULL, NULL, NULL, 4),
(187913, NULL, 'G3DSA:3.40.50.300:FF:002736', NULL, NULL, 'Spindle B', NULL, NULL, NULL, NULL, NULL, 4),
(187914, NULL, 'G3DSA:2.170.260.10:FF:000002', NULL, NULL, 'Putative Endoribonuclease Dicer', NULL, NULL, NULL, NULL, NULL, 4),
(187915, NULL, 'G3DSA:3.40.50.1980:FF:000007', NULL, NULL, 'Vitamin B12-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(187916, NULL, 'G3DSA:1.20.58.390:FF:000313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187917, NULL, 'G3DSA:2.60.40.10:FF:002028', NULL, NULL, 'Twitchin', NULL, NULL, NULL, NULL, NULL, 4),
(187918, NULL, 'G3DSA:1.10.510.10:FF:000900', NULL, NULL, 'Protein kinase C alpha', NULL, NULL, NULL, NULL, NULL, 4),
(187919, NULL, 'G3DSA:3.30.310.50:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187920, NULL, 'G3DSA:3.10.250.10:FF:000018', NULL, NULL, 'Complement factor I', NULL, NULL, NULL, NULL, NULL, 4),
(187921, NULL, 'G3DSA:3.30.710.10:FF:000021', NULL, NULL, 'Zinc finger and BTB domain-containing protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(187922, NULL, 'G3DSA:3.40.50.1000:FF:000309', NULL, NULL, 'Glycosyl hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(187923, NULL, 'G3DSA:2.60.40.1730:FF:000069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187924, NULL, 'G3DSA:2.130.10.10:FF:002028', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(187925, NULL, 'G3DSA:3.90.1200.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187926, NULL, 'G3DSA:2.170.130.20:FF:000001', NULL, NULL, 'Cysteine-rich secretory protein LCCL domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(187927, NULL, 'G3DSA:2.70.40.10:FF:000021', NULL, NULL, 'Gag-Pro polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(187928, NULL, 'G3DSA:1.20.1070.10:FF:001043', NULL, NULL, 'delta-type opioid receptor', NULL, NULL, NULL, NULL, NULL, 4),
(187929, NULL, 'G3DSA:1.10.287.110:FF:000040', NULL, NULL, 'dnaJ homolog subfamily B member 11', NULL, NULL, NULL, NULL, NULL, 4),
(187930, NULL, 'G3DSA:3.30.9.10:FF:000263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187931, NULL, 'G3DSA:1.10.10.440:FF:000082', NULL, NULL, 'Pre-mRNA-processing factor 40, putative', NULL, NULL, NULL, NULL, NULL, 4),
(187932, NULL, 'G3DSA:3.40.50.300:FF:002427', NULL, NULL, 'Dipeptide-transport ATP-binding protein ABC transporter dppD', NULL, NULL, NULL, NULL, NULL, 4),
(187933, NULL, 'G3DSA:2.60.40.10:FF:002921', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(187934, NULL, 'G3DSA:1.10.510.10:FF:003683', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(187935, NULL, 'G3DSA:1.10.472.10:FF:000013', NULL, NULL, 'Cyclin A1', NULL, NULL, NULL, NULL, NULL, 4),
(187936, NULL, 'G3DSA:1.10.472.130:FF:000035', NULL, NULL, 'AGAP003271-PA', NULL, NULL, NULL, NULL, NULL, 4),
(187937, NULL, 'G3DSA:1.10.8.710:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187938, NULL, 'G3DSA:3.40.50.1000:FF:000652', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187939, NULL, 'G3DSA:1.20.120.350:FF:000222', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187940, NULL, 'G3DSA:3.20.20.10:FF:000065', NULL, NULL, 'Arginine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(187941, NULL, 'G3DSA:1.25.10.10:FF:000406', NULL, NULL, 'transportin-3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(187942, NULL, 'G3DSA:2.80.10.50:FF:000008', NULL, NULL, 'Fascin', NULL, NULL, NULL, NULL, NULL, 4),
(187943, NULL, 'G3DSA:2.10.230.10:FF:000004', NULL, NULL, 'Molecular chaperone DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(187944, NULL, 'G3DSA:3.30.160.60:FF:005917', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187945, NULL, 'G3DSA:2.60.40.10:FF:004271', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187946, NULL, 'G3DSA:3.40.50.300:FF:006339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187947, NULL, 'G3DSA:1.10.8.60:FF:000577', NULL, NULL, 'Os09g0533400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(187948, NULL, 'G3DSA:2.40.10.230:FF:000019', NULL, NULL, 'H/ACA ribonucleoprotein complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(187949, NULL, 'G3DSA:1.10.287.70:FF:000729', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187950, NULL, 'G3DSA:1.10.510.10:FF:004273', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187951, NULL, 'G3DSA:3.40.50.10900:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187952, NULL, 'G3DSA:2.130.10.10:FF:000550', NULL, NULL, 'WD repeat-containing protein 82-B', NULL, NULL, NULL, NULL, NULL, 4),
(187953, NULL, 'G3DSA:1.25.40.10:FF:001971', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g04840', NULL, NULL, NULL, NULL, NULL, 4),
(187954, NULL, 'G3DSA:1.20.120.1810:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187955, NULL, 'G3DSA:2.30.30.140:FF:000263', NULL, NULL, 'Histone acetyltransferase esa1', NULL, NULL, NULL, NULL, NULL, 4),
(187956, NULL, 'G3DSA:3.20.20.140:FF:000366', NULL, NULL, 'Putative capsular polysaccharide biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(187957, NULL, 'G3DSA:2.60.40.10:FF:005794', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187958, NULL, 'G3DSA:1.20.1070.10:FF:001464', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187959, NULL, 'G3DSA:3.30.160.60:FF:006423', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187960, NULL, 'G3DSA:1.10.3090.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187961, NULL, 'G3DSA:3.90.76.10:FF:000038', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(187962, NULL, 'G3DSA:3.30.200.20:FF:001823', NULL, NULL, 'Os07g0133000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(187963, NULL, 'G3DSA:3.40.50.300:FF:006244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187964, NULL, 'G3DSA:1.10.150.20:FF:000122', NULL, NULL, 'DNA-directed RNA polymerase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(187965, NULL, 'G3DSA:3.40.1160.10:FF:000083', NULL, NULL, 'AaceriAAL061Cp', NULL, NULL, NULL, NULL, NULL, 4),
(187966, NULL, 'G3DSA:3.10.105.10:FF:000092', NULL, NULL, 'Extracellular solute-binding protein family 5', NULL, NULL, NULL, NULL, NULL, 4),
(187967, NULL, 'G3DSA:3.40.50.300:FF:004215', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(187968, NULL, 'G3DSA:2.40.170.20:FF:000017', NULL, NULL, 'TonB-dependent siderophore receptor', NULL, NULL, NULL, NULL, NULL, 4),
(187969, NULL, 'G3DSA:3.40.50.2000:FF:000868', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(187970, NULL, 'G3DSA:1.10.8.720:FF:000038', NULL, NULL, 'Dynein heavy chain, cytosolic, putative', NULL, NULL, NULL, NULL, NULL, 4),
(187971, NULL, 'G3DSA:3.40.50.150:FF:000645', NULL, NULL, 'SAM-dependent methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(187972, NULL, 'G3DSA:1.20.1250.40:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187973, NULL, 'G3DSA:3.30.160.40:FF:000010', NULL, NULL, 'Unplaced genomic scaffold supercont1.28, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(187974, NULL, 'G3DSA:2.60.260.20:FF:000014', NULL, NULL, 'dnaJ homolog subfamily B member 11', NULL, NULL, NULL, NULL, NULL, 4),
(187975, NULL, 'G3DSA:1.10.10.60:FF:000213', NULL, NULL, 'Homeodomain-only protein', NULL, NULL, NULL, NULL, NULL, 4),
(187976, NULL, 'G3DSA:2.60.120.920:FF:000057', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM17', NULL, NULL, NULL, NULL, NULL, 4),
(187977, NULL, 'G3DSA:2.120.10.30:FF:000163', NULL, NULL, 'Strictosidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(187978, NULL, 'G3DSA:3.40.50.300:FF:002080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187979, NULL, 'G3DSA:3.40.50.300:FF:000842', NULL, NULL, 'ATP-dependent RNA helicase DRS1', NULL, NULL, NULL, NULL, NULL, 4),
(187980, NULL, 'G3DSA:3.30.559.30:FF:000028', NULL, NULL, 'Non-ribosomal peptide synthetase OfaC', NULL, NULL, NULL, NULL, NULL, 4),
(187981, NULL, 'G3DSA:3.30.40.10:FF:002111', NULL, NULL, 'PHd Finger family', NULL, NULL, NULL, NULL, NULL, 4),
(187982, NULL, 'G3DSA:3.30.930.10:FF:000049', NULL, NULL, 'aspartate--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(187983, NULL, 'G3DSA:1.25.40.20:FF:000451', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(187984, NULL, 'G3DSA:1.10.400.10:FF:000015', NULL, NULL, 'G protein alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(187985, NULL, 'G3DSA:3.40.47.10:FF:000030', NULL, NULL, 'Acetyl-CoA acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(187986, NULL, 'G3DSA:2.30.30.870:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187987, NULL, 'G3DSA:2.130.10.10:FF:001747', NULL, NULL, 'Cytoplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(187988, NULL, 'G3DSA:3.90.260.10:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187989, NULL, 'G3DSA:3.20.20.70:FF:000397', NULL, NULL, 'Putative 12-oxophytodienoate reductase-like protein 2A', NULL, NULL, NULL, NULL, NULL, 4),
(187990, NULL, 'G3DSA:3.10.20.310:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187991, NULL, 'G3DSA:1.10.1200.10:FF:000067', NULL, NULL, 'Nonribosomal peptide synthetase easA', NULL, NULL, NULL, NULL, NULL, 4),
(187992, NULL, 'G3DSA:3.80.10.10:FF:003158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(187993, NULL, 'G3DSA:1.20.1250.20:FF:001239', NULL, NULL, 'GM25658', NULL, NULL, NULL, NULL, NULL, 4),
(187994, NULL, 'G3DSA:2.60.40.10:FF:005468', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187995, NULL, 'G3DSA:3.30.200.20:FF:001918', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(187996, NULL, 'G3DSA:3.80.10.10:FF:001034', NULL, NULL, 'Leucine-rich receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(187997, NULL, 'G3DSA:3.40.50.300:FF:000516', NULL, NULL, 'RAB33B, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(187998, NULL, 'G3DSA:3.40.50.880:FF:000201', NULL, NULL, 'Biotin--protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(187999, NULL, 'G3DSA:3.40.30.120:FF:000003', NULL, NULL, 'Aklavinone 12-hydroxylase RdmE', NULL, NULL, NULL, NULL, NULL, 4),
(188000, NULL, 'G3DSA:2.60.120.330:FF:000094', NULL, NULL, 'Oxidoreductase, 2OG-Fe(II) oxygenase family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188001, NULL, 'G3DSA:1.20.1280.50:FF:000093', NULL, NULL, 'F-box/WD repeat-containing protein 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(188002, NULL, 'G3DSA:3.40.140.10:FF:000290', NULL, NULL, 'STAM-binding protein-like 1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(188003, NULL, 'G3DSA:2.40.40.20:FF:000059', NULL, NULL, 'Vesicle-fusing ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(188004, NULL, 'G3DSA:3.30.750.44:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188005, NULL, 'G3DSA:3.20.20.105:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188006, NULL, 'G3DSA:3.40.50.1820:FF:001286', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(188007, NULL, 'G3DSA:3.30.572.10:FF:000014', NULL, NULL, 'Putative thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(188008, NULL, 'G3DSA:3.40.50.10330:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188009, NULL, 'G3DSA:1.20.1250.20:FF:001470', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188010, NULL, 'G3DSA:1.25.10.10:FF:001929', NULL, NULL, 'PIKK family atypical protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(188011, NULL, 'G3DSA:1.20.1270.280:FF:000022', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188012, NULL, 'G3DSA:1.10.260.50:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188013, NULL, 'G3DSA:3.50.4.10:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188014, NULL, 'G3DSA:3.30.1330.40:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188015, NULL, 'G3DSA:1.10.3500.10:FF:000028', NULL, NULL, 'Transcription elongation factor SPT6', NULL, NULL, NULL, NULL, NULL, 4),
(188016, NULL, 'G3DSA:3.40.980.10:FF:000027', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(188017, NULL, 'G3DSA:2.40.150.20:FF:000022', NULL, NULL, '60S ribosomal protein L23 isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(188018, NULL, 'G3DSA:3.40.50.300:FF:005738', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188019, NULL, 'G3DSA:1.25.10.10:FF:000732', NULL, NULL, 'Unplaced genomic scaffold supercont2.16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(188020, NULL, 'G3DSA:3.90.1600.10:FF:000010', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(188021, NULL, 'G3DSA:1.20.870.10:FF:000003', NULL, NULL, 'Ral guanine nucleotide dissociation stimulator isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(188022, NULL, 'G3DSA:1.10.10.60:FF:000308', NULL, NULL, 'HTH-type transcriptional activator RhaR', NULL, NULL, NULL, NULL, NULL, 4),
(188023, NULL, 'G3DSA:1.25.40.20:FF:000237', NULL, NULL, 'NF-kappa-B inhibitor epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(188024, NULL, 'G3DSA:4.10.1240.10:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188025, NULL, 'G3DSA:1.20.1740.10:FF:000268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188026, NULL, 'G3DSA:3.40.390.10:FF:000010', NULL, NULL, '72 kDa type IV collagenase', NULL, NULL, NULL, NULL, NULL, 4),
(188027, NULL, 'G3DSA:1.25.40.10:FF:000234', NULL, NULL, 'Bardet-Biedl syndrome 4 (Human)', NULL, NULL, NULL, NULL, NULL, 4),
(188028, NULL, 'G3DSA:2.60.40.10:FF:000572', NULL, NULL, 'Platelet-derived growth factor receptor beta', NULL, NULL, NULL, NULL, NULL, 4),
(188029, NULL, 'G3DSA:2.60.40.150:FF:000148', NULL, NULL, 'UV radiation resistance associated gene', NULL, NULL, NULL, NULL, NULL, 4),
(188030, NULL, 'G3DSA:2.40.110.10:FF:000005', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(188031, NULL, 'G3DSA:1.10.630.10:FF:000746', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188032, NULL, 'G3DSA:1.20.140.150:FF:000020', NULL, NULL, 'lipoma HMGIC fusion partner-like 2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(188033, NULL, 'G3DSA:3.50.50.60:FF:001373', NULL, NULL, 'Monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188034, NULL, 'G3DSA:3.30.210.10:FF:000011', NULL, NULL, 'Lmo1231 protein', NULL, NULL, NULL, NULL, NULL, 4),
(188035, NULL, 'G3DSA:3.50.50.60:FF:001047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(188036, NULL, 'G3DSA:1.25.40.150:FF:000007', NULL, NULL, 'Related to vacuolar ATP synthase subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(188037, NULL, 'G3DSA:2.40.10.10:FF:000228', NULL, NULL, 'Probable serine protease PepD (Serine proteinase) (MTB32B)', NULL, NULL, NULL, NULL, NULL, 4),
(188038, NULL, 'G3DSA:3.30.200.20:FF:002071', NULL, NULL, 'Serine/threonine-protein kinase ppk33', NULL, NULL, NULL, NULL, NULL, 4),
(188039, NULL, 'G3DSA:2.30.130.40:FF:000040', NULL, NULL, 'Os11g0219000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(188040, NULL, 'G3DSA:2.60.120.330:FF:000189', NULL, NULL, 'Flavonol synthase/flavanone 3-hydroxylase, putative, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(188041, NULL, 'G3DSA:1.10.510.10:FF:004059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188042, NULL, 'G3DSA:3.40.50.300:FF:003389', NULL, NULL, 'Helicase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(188043, NULL, 'G3DSA:3.30.160.60:FF:002466', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(188044, NULL, 'G3DSA:3.10.50.40:FF:000093', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(188045, NULL, 'G3DSA:3.30.160.60:FF:002354', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188046, NULL, 'G3DSA:1.25.40.10:FF:001757', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(188047, NULL, 'G3DSA:3.30.420.40:FF:000160', NULL, NULL, 'Autoinducer-2 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(188048, NULL, 'G3DSA:3.50.50.60:FF:001159', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(188049, NULL, 'G3DSA:3.40.50.2300:FF:001666', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188050, NULL, 'G3DSA:2.60.120.560:FF:000027', NULL, NULL, 'Galactocerebrosidase', NULL, NULL, NULL, NULL, NULL, 4),
(188051, NULL, 'G3DSA:3.30.1330.20:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188052, NULL, 'G3DSA:3.30.830.10:FF:000209', NULL, NULL, 'Peptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188053, NULL, 'G3DSA:2.60.40.10:FF:001769', NULL, NULL, 'Interleukin-2 receptor subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(188054, NULL, 'G3DSA:3.40.50.10260:FF:000023', NULL, NULL, 'Enhancer of mRNA-decapping protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188055, NULL, 'G3DSA:3.40.50.720:FF:001351', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase B, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(188056, NULL, 'G3DSA:3.40.50.300:FF:002287', NULL, NULL, 'MIT domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(188057, NULL, 'G3DSA:1.20.1270.60:FF:000168', NULL, NULL, 'Sorting nexin 7', NULL, NULL, NULL, NULL, NULL, 4),
(188058, NULL, 'G3DSA:2.70.150.10:FF:000181', NULL, NULL, 'P-type transport ATPase (Probable substrate copper/metal cation)', NULL, NULL, NULL, NULL, NULL, 4),
(188059, NULL, 'G3DSA:2.10.25.160:FF:000010', NULL, NULL, 'Progranulin', NULL, NULL, NULL, NULL, NULL, 4),
(188060, NULL, 'G3DSA:3.40.50.1000:FF:000326', NULL, NULL, 'Haloacid dehalogenase-like hydrolase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(188061, NULL, 'G3DSA:2.60.40.10:FF:004057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188062, NULL, 'G3DSA:3.40.50.300:FF:000163', NULL, NULL, 'Multidrug resistance-associated protein member 4', NULL, NULL, NULL, NULL, NULL, 4),
(188063, NULL, 'G3DSA:1.10.10.10:FF:001396', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(188064, NULL, 'G3DSA:3.40.1110.10:FF:000467', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188065, NULL, 'G3DSA:3.40.50.12710:FF:000039', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7', NULL, NULL, NULL, NULL, NULL, 4),
(188066, NULL, 'G3DSA:4.10.60.10:FF:000200', NULL, NULL, 'Branchpoint-bridging protein', NULL, NULL, NULL, NULL, NULL, 4),
(188067, NULL, 'G3DSA:3.90.940.10:FF:000002', NULL, NULL, 'DNA-directed RNA polymerase subunit omega', NULL, NULL, NULL, NULL, NULL, 4),
(188068, NULL, 'G3DSA:1.10.510.10:FF:000911', NULL, NULL, 'Serine/threonine kinase like domain containing 1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(188069, NULL, 'G3DSA:3.40.50.1820:FF:001191', NULL, NULL, 'Clan SC, family S28, unassigned serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(188070, NULL, 'G3DSA:1.10.760.10:FF:000036', NULL, NULL, 'Thiosulfate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(188071, NULL, 'G3DSA:3.10.660.10:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188072, NULL, 'G3DSA:3.30.1330.30:FF:000065', NULL, NULL, 'Nucleolar protein family A, member 2', NULL, NULL, NULL, NULL, NULL, 4),
(188073, NULL, 'G3DSA:1.10.3210.10:FF:000023', NULL, NULL, 'HD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(188074, NULL, 'G3DSA:3.40.50.11380:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188075, NULL, 'G3DSA:2.10.90.10:FF:000038', NULL, NULL, 'Interleukin-17A', NULL, NULL, NULL, NULL, NULL, 4),
(188076, NULL, 'G3DSA:2.130.10.10:FF:004602', NULL, NULL, 'Dynein assembly factor with WDR repeat domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(188077, NULL, 'G3DSA:3.60.21.10:FF:000144', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(188078, NULL, 'G3DSA:3.30.750.24:FF:000020', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(188079, NULL, 'G3DSA:1.10.405.10:FF:000004', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(188080, NULL, 'G3DSA:2.130.10.130:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188081, NULL, 'G3DSA:2.60.40.1180:FF:000067', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(188082, NULL, 'G3DSA:3.40.50.10110:FF:000006', NULL, NULL, 'DNA polymerase III subunit chi', NULL, NULL, NULL, NULL, NULL, 4),
(188083, NULL, 'G3DSA:2.30.39.10:FF:000082', NULL, NULL, 'Putative non-inhibitory serpin-Z11', NULL, NULL, NULL, NULL, NULL, 4),
(188084, NULL, 'G3DSA:2.10.70.10:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188085, NULL, 'G3DSA:3.40.1110.10:FF:000355', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188086, NULL, 'G3DSA:1.10.225.10:FF:000018', NULL, NULL, 'SaPosin-like Protein family', NULL, NULL, NULL, NULL, NULL, 4),
(188087, NULL, 'G3DSA:1.20.1000.10:FF:000004', NULL, NULL, 'Interferon-induced guanylate-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(188088, NULL, 'G3DSA:3.30.530.20:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188089, NULL, 'G3DSA:1.10.555.10:FF:000088', NULL, NULL, 'RhoGAP domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(188090, NULL, 'G3DSA:3.30.300.10:FF:000018', NULL, NULL, 'GMP synthase (Glutamine-hydrolyzing) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(188091, NULL, 'G3DSA:1.20.140.40:FF:000018', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(188092, NULL, 'G3DSA:3.90.79.10:FF:000303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188093, NULL, 'G3DSA:3.80.10.10:FF:003372', NULL, NULL, 'Leucine-rich repeat-containing protein egg-6', NULL, NULL, NULL, NULL, NULL, 4),
(188094, NULL, 'G3DSA:3.40.50.980:FF:000001', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(188095, NULL, 'G3DSA:1.25.40.10:FF:001645', NULL, NULL, 'Os04g0676200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(188096, NULL, 'G3DSA:1.10.510.10:FF:003458', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188097, NULL, 'G3DSA:2.60.120.10:FF:000535', NULL, NULL, 'Cyclic nucleotide-binding domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188098, NULL, 'G3DSA:3.40.720.10:FF:000284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188099, NULL, 'G3DSA:3.40.50.410:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188100, NULL, 'G3DSA:3.90.190.10:FF:000467', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188101, NULL, 'G3DSA:2.30.180.10:FF:000124', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188102, NULL, 'G3DSA:2.130.10.10:FF:004035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(188103, NULL, 'G3DSA:3.30.40.10:FF:000993', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188104, NULL, 'G3DSA:2.60.120.620:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188105, NULL, 'G3DSA:2.130.10.10:FF:001859', NULL, NULL, 'Serine/threonine-protein kinase VPS15', NULL, NULL, NULL, NULL, NULL, 4),
(188106, NULL, 'G3DSA:3.30.200.20:FF:000300', NULL, NULL, 'Interleukin-1 receptor-associated kinase 1 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(188107, NULL, 'G3DSA:2.60.120.920:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188108, NULL, 'G3DSA:2.30.140.10:FF:000015', NULL, NULL, 'Putative spermidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(188109, NULL, 'G3DSA:3.40.630.30:FF:000619', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188110, NULL, 'G3DSA:3.90.550.10:FF:000079', NULL, NULL, 'Probable glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(188111, NULL, 'G3DSA:3.40.50.300:FF:000730', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(188112, NULL, 'G3DSA:3.10.100.10:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188113, NULL, 'G3DSA:1.25.70.10:FF:000062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188114, NULL, 'G3DSA:3.30.70.980:FF:000041', NULL, NULL, 'Probable transcriptional regulatory protein CO678_22745', NULL, NULL, NULL, NULL, NULL, 4),
(188115, NULL, 'G3DSA:3.20.20.70:FF:000285', NULL, NULL, 'GTP 3'',8-cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(188116, NULL, 'G3DSA:1.25.40.20:FF:000563', NULL, NULL, 'Gated outwardly-rectifying K+ channel', NULL, NULL, NULL, NULL, NULL, 4),
(188117, NULL, 'G3DSA:1.10.510.10:FF:000232', NULL, NULL, 'Serine/threonine-protein kinase RIO1', NULL, NULL, NULL, NULL, NULL, 4),
(188118, NULL, 'G3DSA:3.40.1570.10:FF:000001', NULL, NULL, 'Hemin degrading factor', NULL, NULL, NULL, NULL, NULL, 4),
(188119, NULL, 'G3DSA:2.40.20.10:FF:000061', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188120, NULL, 'G3DSA:2.60.40.150:FF:000811', NULL, NULL, 'FAM62', NULL, NULL, NULL, NULL, NULL, 4),
(188121, NULL, 'G3DSA:3.30.40.10:FF:000779', NULL, NULL, 'Cellulose synthase A catalytic subunit 1 [UDP-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(188122, NULL, 'G3DSA:1.10.8.520:FF:000001', NULL, NULL, 'ExsD', NULL, NULL, NULL, NULL, NULL, 4),
(188123, NULL, 'G3DSA:2.60.40.1170:FF:000064', NULL, NULL, 'Mu-adaptin 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188124, NULL, 'G3DSA:2.40.10.10:FF:000133', NULL, NULL, 'Glyoxysomal processing protease glyoxysomal', NULL, NULL, NULL, NULL, NULL, 4),
(188125, NULL, 'G3DSA:1.25.40.10:FF:000560', NULL, NULL, 'CNS1p TPR-containing co-chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(188126, NULL, 'G3DSA:3.40.50.300:FF:002192', NULL, NULL, 'Dynein beta chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188127, NULL, 'G3DSA:3.40.30.10:FF:001121', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(188128, NULL, 'G3DSA:3.30.1490.100:FF:000010', NULL, NULL, 'DNA-directed polymerase kappa', NULL, NULL, NULL, NULL, NULL, 4),
(188129, NULL, 'G3DSA:1.10.418.10:FF:000281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188130, NULL, 'G3DSA:3.60.20.10:FF:000187', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188131, NULL, 'G3DSA:1.20.1530.20:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188132, NULL, 'G3DSA:3.80.10.10:FF:001129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188133, NULL, 'G3DSA:3.30.70.330:FF:001829', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188134, NULL, 'G3DSA:1.20.5.490:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188135, NULL, 'G3DSA:1.25.40.10:FF:004500', NULL, NULL, 'Os09g0411600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(188136, NULL, 'G3DSA:3.30.70.3400:FF:000009', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(188137, NULL, 'G3DSA:1.10.1070.11:FF:000017', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(188138, NULL, 'G3DSA:3.30.1490.120:FF:000016', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188139, NULL, 'G3DSA:3.40.720.10:FF:000379', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188140, NULL, 'G3DSA:3.30.160.60:FF:004720', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188141, NULL, 'G3DSA:3.50.30.30:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188142, NULL, 'G3DSA:3.40.50.2300:FF:001571', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188143, NULL, 'G3DSA:3.40.1370.10:FF:000020', NULL, NULL, '50S ribosomal protein L4', NULL, NULL, NULL, NULL, NULL, 4),
(188144, NULL, 'G3DSA:3.40.50.2020:FF:000071', NULL, NULL, 'ribose-phosphate pyrophosphokinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(188145, NULL, 'G3DSA:1.10.3410.10:FF:000004', NULL, NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(188146, NULL, 'G3DSA:1.10.287.160:FF:000015', NULL, NULL, 'Protein Kinase N (PKN) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(188147, NULL, 'G3DSA:3.20.20.80:FF:000288', NULL, NULL, 'Chitinase-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(188148, NULL, 'G3DSA:2.30.33.40:FF:000009', NULL, NULL, '10 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(188149, NULL, 'G3DSA:3.40.525.10:FF:000032', NULL, NULL, 'IRA1p GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(188150, NULL, 'G3DSA:1.10.287.90:FF:000027', NULL, NULL, 'Cytochrome c oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(188151, NULL, 'G3DSA:3.40.605.10:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188152, NULL, 'G3DSA:3.30.40.10:FF:001268', NULL, NULL, 'U-box domain-containing protein 48', NULL, NULL, NULL, NULL, NULL, 4),
(188153, NULL, 'G3DSA:1.10.287.80:FF:000024', NULL, NULL, 'ATP synthase gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(188154, NULL, 'G3DSA:3.40.50.10810:FF:000233', NULL, NULL, 'Swi/snf family helicase_2', NULL, NULL, NULL, NULL, NULL, 4),
(188155, NULL, 'G3DSA:4.10.400.10:FF:000178', NULL, NULL, 'Tequila, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(188156, NULL, 'G3DSA:3.30.70.580:FF:000011', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(188157, NULL, 'G3DSA:1.10.510.10:FF:002261', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188158, NULL, 'G3DSA:2.120.10.80:FF:000054', NULL, NULL, 'Leucine-zipper-like transcription regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(188159, NULL, 'G3DSA:3.40.630.30:FF:000378', NULL, NULL, 'GNAT family N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(188160, NULL, 'G3DSA:2.40.50.140:FF:000062', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(188161, NULL, 'G3DSA:1.20.1070.10:FF:000975', NULL, NULL, 'SERotonin/octopamine receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(188162, NULL, 'G3DSA:3.90.550.10:FF:000551', NULL, NULL, 'UDP-N-acetylglucosamine pyrophosphorylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(188163, NULL, 'G3DSA:3.40.50.10810:FF:000003', NULL, NULL, 'chromodomain-helicase-DNA-binding protein 8 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(188164, NULL, 'G3DSA:3.80.10.10:FF:001017', NULL, NULL, 'Tubulin-specific chaperone E', NULL, NULL, NULL, NULL, NULL, 4),
(188165, NULL, 'G3DSA:3.40.50.10190:FF:000328', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(188166, NULL, 'G3DSA:1.10.510.10:FF:003784', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188167, NULL, 'G3DSA:2.40.40.20:FF:000076', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188168, NULL, 'G3DSA:1.20.58.1480:FF:000020', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(188169, NULL, 'G3DSA:2.30.180.10:FF:000096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188170, NULL, 'G3DSA:2.70.170.10:FF:000204', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(188171, NULL, 'G3DSA:1.10.10.10:FF:000322', NULL, NULL, 'Probable disease resistance protein At1g63360', NULL, NULL, NULL, NULL, NULL, 4),
(188172, NULL, 'G3DSA:1.20.120.1900:FF:000036', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(188173, NULL, 'G3DSA:4.10.280.10:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188174, NULL, 'G3DSA:1.10.150.50:FF:000148', NULL, NULL, 'Probable serine/threonine-protein kinase samkC', NULL, NULL, NULL, NULL, NULL, 4),
(188175, NULL, 'G3DSA:3.30.420.110:FF:000023', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(188176, NULL, 'G3DSA:2.30.110.10:FF:000064', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(188177, NULL, 'G3DSA:2.70.130.10:FF:000084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188178, NULL, 'G3DSA:3.80.10.10:FF:002883', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188179, NULL, 'G3DSA:3.10.20.90:FF:000347', NULL, NULL, 'Autophagy protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(188180, NULL, 'G3DSA:1.20.1250.20:FF:001453', NULL, NULL, 'MFS multidrug transporter, putative (AFU_orthologue AFUA_1G16910)', NULL, NULL, NULL, NULL, NULL, 4),
(188181, NULL, 'G3DSA:2.10.220.10:FF:000144', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(188182, NULL, 'G3DSA:3.40.50.720:FF:001137', NULL, NULL, 'Glutathione-regulated potassium-efflux system protein', NULL, NULL, NULL, NULL, NULL, 4),
(188183, NULL, 'G3DSA:2.40.70.10:FF:000451', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188184, NULL, 'G3DSA:2.160.20.10:FF:000004', NULL, NULL, 'Pectin lyase-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(188185, NULL, 'G3DSA:3.30.200.20:FF:001935', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188186, NULL, 'G3DSA:3.30.250.20:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188187, NULL, 'G3DSA:3.20.20.70:FF:000734', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188188, NULL, 'G3DSA:3.30.60.30:FF:000191', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188189, NULL, 'G3DSA:3.40.50.300:FF:006132', NULL, NULL, 'Elongation factor G, domain IV family protein', NULL, NULL, NULL, NULL, NULL, 4),
(188190, NULL, 'G3DSA:3.40.1080.10:FF:000014', NULL, NULL, 'Citrate lyase alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(188191, NULL, 'G3DSA:1.25.40.10:FF:002600', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g04370', NULL, NULL, NULL, NULL, NULL, 4),
(188192, NULL, 'G3DSA:3.30.70.330:FF:001588', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188193, NULL, 'G3DSA:2.160.20.20:FF:000007', NULL, NULL, 'Autotransporting adhesin factor family member', NULL, NULL, NULL, NULL, NULL, 4),
(188194, NULL, 'G3DSA:1.20.1280.50:FF:000216', NULL, NULL, 'F-box protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(188195, NULL, 'G3DSA:3.30.420.10:FF:000179', NULL, NULL, 'CAF1 family ribonuclease containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(188196, NULL, 'G3DSA:3.30.830.10:FF:000311', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188197, NULL, 'G3DSA:3.30.420.100:FF:000020', NULL, NULL, '60S ribosomal protein L5', NULL, NULL, NULL, NULL, NULL, 4),
(188198, NULL, 'G3DSA:2.20.28.40:FF:000003', NULL, NULL, 'H/ACA ribonucleoprotein complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(188199, NULL, 'G3DSA:1.10.287.110:FF:000354', NULL, NULL, 'Chaperone protein DNAj, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188200, NULL, 'G3DSA:3.50.50.60:FF:000979', NULL, NULL, 'FAD/NAD(P)-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(188201, NULL, 'G3DSA:4.10.320.60:FF:000001', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(188202, NULL, 'G3DSA:1.10.10.60:FF:000325', NULL, NULL, 'Double homeobox protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(188203, NULL, 'G3DSA:3.20.20.80:FF:000737', NULL, NULL, 'Glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(188204, NULL, 'G3DSA:3.40.250.10:FF:000197', NULL, NULL, 'Probable molybdopterin biosynthesis protein MoeB', NULL, NULL, NULL, NULL, NULL, 4),
(188205, NULL, 'G3DSA:3.40.1390.20:FF:000018', NULL, NULL, 'HPr kinase/phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(188206, NULL, 'G3DSA:1.25.10.10:FF:001576', NULL, NULL, 'Os01g0626100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(188207, NULL, 'G3DSA:2.60.40.10:FF:001983', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(188208, NULL, 'G3DSA:3.40.50.2300:FF:001245', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188209, NULL, 'G3DSA:3.40.50.300:FF:007655', NULL, NULL, 'ATP-dependent DNA helicase DDX11', NULL, NULL, NULL, NULL, NULL, 4),
(188210, NULL, 'G3DSA:2.40.10.10:FF:000245', NULL, NULL, 'Elastase, neutrophil expressed', NULL, NULL, NULL, NULL, NULL, 4),
(188211, NULL, 'G3DSA:3.30.1300.10:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188212, NULL, 'G3DSA:3.10.20.70:FF:000015', NULL, NULL, 'Putative glutamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(188213, NULL, 'G3DSA:1.20.1170.10:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188214, NULL, 'G3DSA:3.40.640.10:FF:000120', NULL, NULL, 'Putative cystathionine beta-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(188215, NULL, 'G3DSA:3.40.50.300:FF:007879', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188216, NULL, 'G3DSA:3.80.20.20:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188217, NULL, 'G3DSA:1.10.1450.10:FF:000001', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(188218, NULL, 'G3DSA:3.30.40.10:FF:001717', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM36 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(188219, NULL, 'G3DSA:1.10.10.10:FF:000226', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(188220, NULL, 'G3DSA:1.25.40.10:FF:002460', NULL, NULL, 'Os02g0468800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(188221, NULL, 'G3DSA:3.40.50.300:FF:002528', NULL, NULL, 'RAD50 double strand break repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(188222, NULL, 'G3DSA:2.60.40.10:FF:002500', NULL, NULL, 'AXL2p Integral plasma membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(188223, NULL, 'G3DSA:3.40.630.10:FF:000046', NULL, NULL, 'transferrin receptor protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(188224, NULL, 'G3DSA:2.130.10.10:FF:000319', NULL, NULL, 'Phosphoinositide 3-kinase regulatory subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(188225, NULL, 'G3DSA:1.25.50.20:FF:000070', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(188226, NULL, 'G3DSA:1.10.510.10:FF:001985', NULL, NULL, 'Cell_division_protein_kinase_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(188227, NULL, 'G3DSA:2.60.40.10:FF:003782', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188228, NULL, 'G3DSA:3.30.160.60:FF:004832', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188229, NULL, 'G3DSA:3.40.50.150:FF:000319', NULL, NULL, 'Fire dancer', NULL, NULL, NULL, NULL, NULL, 4),
(188230, NULL, 'G3DSA:2.60.120.10:FF:000209', NULL, NULL, 'YML079W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(188231, NULL, 'G3DSA:1.10.150.490:FF:000002', NULL, NULL, 'Gag polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(188232, NULL, 'G3DSA:1.10.1410.10:FF:000004', NULL, NULL, 'terminal uridylyltransferase 4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(188233, NULL, 'G3DSA:1.10.560.10:FF:000055', NULL, NULL, 'T-complex protein 1 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(188234, NULL, 'G3DSA:3.40.50.720:FF:001581', NULL, NULL, 'Oxidoreductase HTATIP2', NULL, NULL, NULL, NULL, NULL, 4),
(188235, NULL, 'G3DSA:3.40.1160.10:FF:000066', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(188236, NULL, 'G3DSA:3.30.310.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188237, NULL, 'G3DSA:3.30.420.10:FF:000628', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188238, NULL, 'G3DSA:3.30.1360.210:FF:000008', NULL, NULL, '60S ribosomal protein L22-2', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(188239, NULL, 'G3DSA:1.10.10.2100:FF:000001', NULL, NULL, 'Nucleophosmin 1', NULL, NULL, NULL, NULL, NULL, 4),
(188240, NULL, 'G3DSA:3.30.160.60:FF:002371', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188241, NULL, 'G3DSA:1.25.10.10:FF:000053', NULL, NULL, 'Importin 7', NULL, NULL, NULL, NULL, NULL, 4),
(188242, NULL, 'G3DSA:1.20.1560.10:FF:000849', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188243, NULL, 'G3DSA:3.20.20.140:FF:000383', NULL, NULL, 'GH06023p', NULL, NULL, NULL, NULL, NULL, 4),
(188244, NULL, 'G3DSA:3.90.70.10:FF:000643', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188245, NULL, 'G3DSA:1.20.1560.10:FF:000945', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188246, NULL, 'G3DSA:1.20.140.80:FF:000002', NULL, NULL, 'Transcription factor-like protein DPB', NULL, NULL, NULL, NULL, NULL, 4),
(188247, NULL, 'G3DSA:2.40.33.10:FF:000040', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(188248, NULL, 'G3DSA:1.10.8.60:FF:000139', NULL, NULL, 'Fis family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(188249, NULL, 'G3DSA:1.10.540.10:FF:000059', NULL, NULL, 'Acyl-CoA dehydrogenase, mitochondrial,putative', NULL, NULL, NULL, NULL, NULL, 4),
(188250, NULL, 'G3DSA:3.40.190.10:FF:000124', NULL, NULL, 'Amino acid ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(188251, NULL, 'G3DSA:1.25.40.10:FF:004045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188252, NULL, 'G3DSA:3.40.50.920:FF:000011', NULL, NULL, 'Transketolase', NULL, NULL, NULL, NULL, NULL, 4),
(188253, NULL, 'G3DSA:3.40.50.300:FF:008470', NULL, NULL, 'Putative ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(188254, NULL, 'G3DSA:3.40.50.1010:FF:000217', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188255, NULL, 'G3DSA:1.10.455.10:FF:000041', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188256, NULL, 'G3DSA:1.25.40.10:FF:001869', NULL, NULL, 'Peroxisomal biogenesis factor 5 isoform d', NULL, NULL, NULL, NULL, NULL, 4),
(188257, NULL, 'G3DSA:3.30.420.40:FF:000272', NULL, NULL, 'Actin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188258, NULL, 'G3DSA:2.20.80.10:FF:000003', NULL, NULL, 'Apolipoprotein lipid transfer particle', NULL, NULL, NULL, NULL, NULL, 4),
(188259, NULL, 'G3DSA:3.40.50.1100:FF:000126', NULL, NULL, 'Cystathionine beta-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(188260, NULL, 'G3DSA:1.20.1070.10:FF:001138', NULL, NULL, 'G-protein coupled receptor 15', NULL, NULL, NULL, NULL, NULL, 4),
(188261, NULL, 'G3DSA:3.20.20.70:FF:000408', NULL, NULL, 'L-2-keto-3-deoxyarabonate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(188262, NULL, 'G3DSA:1.10.533.10:FF:000043', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 10A', NULL, NULL, NULL, NULL, NULL, 4),
(188263, NULL, 'G3DSA:1.25.40.10:FF:003769', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188264, NULL, 'G3DSA:1.20.140.90:FF:000005', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188265, NULL, 'G3DSA:2.130.10.10:FF:002236', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(188266, NULL, 'G3DSA:1.10.510.10:FF:001659', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(188267, NULL, 'G3DSA:1.10.238.10:FF:000295', NULL, NULL, 'Myosin-2 essential light chain', NULL, NULL, NULL, NULL, NULL, 4),
(188268, NULL, 'G3DSA:3.60.21.60:FF:000035', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(188269, NULL, 'G3DSA:3.40.50.300:FF:006570', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188270, NULL, 'G3DSA:3.80.10.10:FF:002557', NULL, NULL, 'TOLl (Drosophila) family', NULL, NULL, NULL, NULL, NULL, 4),
(188271, NULL, 'G3DSA:3.40.50.1000:FF:000214', NULL, NULL, '4-nitrophenylphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(188272, NULL, 'G3DSA:2.60.40.10:FF:001657', NULL, NULL, 'Neuromusculin, isoform E', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(188273, NULL, 'G3DSA:2.60.40.10:FF:000246', NULL, NULL, 'Fibroblast growth factor receptor like 1', NULL, NULL, NULL, NULL, NULL, 4),
(188274, NULL, 'G3DSA:2.10.90.10:FF:000055', NULL, NULL, 'Placenta growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(188275, NULL, 'G3DSA:2.60.120.10:FF:000647', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188276, NULL, 'G3DSA:3.40.50.300:FF:004541', NULL, NULL, 'Peroxisome assembly protein Pex1p', NULL, NULL, NULL, NULL, NULL, 4),
(188277, NULL, 'G3DSA:1.20.1270.280:FF:000005', NULL, NULL, 'Dynein axonemal heavy chain 10', NULL, NULL, NULL, NULL, NULL, 4),
(188278, NULL, 'G3DSA:2.70.150.10:FF:000208', NULL, NULL, 'Phospholipid-transporting ATPase IA, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188279, NULL, 'G3DSA:3.40.220.20:FF:000001', NULL, NULL, 'Replicase polyprotein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(188280, NULL, 'G3DSA:1.25.40.10:FF:003562', NULL, NULL, 'Clustered mitochondria protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(188281, NULL, 'G3DSA:2.130.10.10:FF:000336', NULL, NULL, 'Neutral sphingomyelinase activation-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(188282, NULL, 'G3DSA:4.10.400.10:FF:000274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188283, NULL, 'G3DSA:1.20.1070.10:FF:000649', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188284, NULL, 'G3DSA:1.10.730.10:FF:000113', NULL, NULL, 'Valyl-tRNA synthetase 2, mitochondrial (putative)', NULL, NULL, NULL, NULL, NULL, 4),
(188285, NULL, 'G3DSA:1.10.10.440:FF:000003', NULL, NULL, 'Pre-mRNA processing factor 40 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(188286, NULL, 'G3DSA:2.30.30.1020:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188287, NULL, 'G3DSA:1.20.5.190:FF:000034', NULL, NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(188288, NULL, 'G3DSA:3.30.160.60:FF:004271', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188289, NULL, 'G3DSA:1.20.120.350:FF:000194', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188290, NULL, 'G3DSA:3.20.20.220:FF:000064', NULL, NULL, 'Methylenetetrahydrofolate reductase 2', NULL, NULL, NULL, NULL, NULL, 4),
(188291, NULL, 'G3DSA:3.90.550.10:FF:000096', NULL, NULL, 'Glycosyltransferases', NULL, NULL, NULL, NULL, NULL, 4),
(188292, NULL, 'G3DSA:3.30.1360.120:FF:000072', NULL, NULL, 'Glycine cleavage T protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188293, NULL, 'G3DSA:1.10.238.10:FF:000418', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(188294, NULL, 'G3DSA:3.30.40.10:FF:001594', NULL, NULL, 'PHD zinc finger-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(188295, NULL, 'G3DSA:3.60.21.10:FF:000256', NULL, NULL, 'Kinetoplastid-specific phospho-protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188296, NULL, 'G3DSA:3.80.10.10:FF:001455', NULL, NULL, 'Glycoprotein V platelet', NULL, NULL, NULL, NULL, NULL, 4),
(188297, NULL, 'G3DSA:3.40.50.1580:FF:000011', NULL, NULL, 'Purine nucleoside phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(188298, NULL, 'G3DSA:3.30.420.40:FF:000401', NULL, NULL, 'Actin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188299, NULL, 'G3DSA:3.80.10.10:FF:000966', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188300, NULL, 'G3DSA:3.30.230.70:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188301, NULL, 'G3DSA:3.10.50.40:FF:000076', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(188302, NULL, 'G3DSA:3.60.15.10:FF:000101', NULL, NULL, 'Putative metallo-beta-lactamase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(188303, NULL, 'G3DSA:3.80.10.10:FF:003046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188304, NULL, 'G3DSA:3.30.70.1660:FF:000009', NULL, NULL, 'Peptide chain release factor H', NULL, NULL, NULL, NULL, NULL, 4),
(188305, NULL, 'G3DSA:3.10.20.90:FF:000914', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(188306, NULL, 'G3DSA:3.40.710.10:FF:000098', NULL, NULL, 'PROBABLE ESTERASE LIPL', NULL, NULL, NULL, NULL, NULL, 4),
(188307, NULL, 'G3DSA:1.25.40.20:FF:000125', NULL, NULL, 'Putative espin', NULL, NULL, NULL, NULL, NULL, 4),
(188308, NULL, 'G3DSA:1.10.287.70:FF:000488', NULL, NULL, 'Ionotropic receptor 67c', NULL, NULL, NULL, NULL, NULL, 4),
(188309, NULL, 'G3DSA:2.40.30.10:FF:000128', NULL, NULL, '50S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(188310, NULL, 'G3DSA:3.40.50.300:FF:007981', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(188311, NULL, 'G3DSA:3.30.200.20:FF:000272', NULL, NULL, 'Cyclin-dependent kinase C-2', NULL, NULL, NULL, NULL, NULL, 4),
(188312, NULL, 'G3DSA:3.40.50.1240:FF:000140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188313, NULL, 'G3DSA:3.10.180.10:FF:000102', NULL, NULL, 'Putative lyase', NULL, NULL, NULL, NULL, NULL, 4),
(188314, NULL, 'G3DSA:3.30.9.10:FF:000145', NULL, NULL, 'Glycine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(188315, NULL, 'G3DSA:1.20.1250.20:FF:000964', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(188316, NULL, 'G3DSA:1.20.5.110:FF:000179', NULL, NULL, 'AGAP006100-PA', NULL, NULL, NULL, NULL, NULL, 4),
(188317, NULL, 'G3DSA:2.180.10.10:FF:000008', NULL, NULL, 'Odz, odd Oz/ten-m homolog', NULL, NULL, NULL, NULL, NULL, 4),
(188318, NULL, 'G3DSA:3.40.30.10:FF:000183', NULL, NULL, 'NADH-quinone oxidoreductase subunit NuoE', NULL, NULL, NULL, NULL, NULL, 4),
(188319, NULL, 'G3DSA:1.20.120.140:FF:000035', NULL, NULL, 'Signal recognition particle receptor FtsY', NULL, NULL, NULL, NULL, NULL, 4),
(188320, NULL, 'G3DSA:3.40.50.720:FF:001704', NULL, NULL, 'UDP-glucose dehydrogenase Ugd1, putative (AFU_orthologue AFUA_8G00920)', NULL, NULL, NULL, NULL, NULL, 4),
(188321, NULL, 'G3DSA:3.30.1140.60:FF:000020', NULL, NULL, 'F-actin-capping protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(188322, NULL, 'G3DSA:1.10.8.270:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188323, NULL, 'G3DSA:2.60.40.10:FF:000342', NULL, NULL, 'Junctional adhesion molecule A', NULL, NULL, NULL, NULL, NULL, 4),
(188324, NULL, 'G3DSA:2.130.10.10:FF:004361', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188325, NULL, 'G3DSA:2.30.30.40:FF:000430', NULL, NULL, 'Chemotaxis protein CheW', NULL, NULL, NULL, NULL, NULL, 4),
(188326, NULL, 'G3DSA:3.40.50.1010:FF:000088', NULL, NULL, 'Unplaced genomic scaffold supercont1.6, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(188327, NULL, 'G3DSA:1.50.40.10:FF:000513', NULL, NULL, 'Solute carrier family 25 member 22b', NULL, NULL, NULL, NULL, NULL, 4),
(188328, NULL, 'G3DSA:3.40.50.1820:FF:001174', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188329, NULL, 'G3DSA:1.20.1000.10:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188330, NULL, 'G3DSA:3.30.40.10:FF:001510', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188331, NULL, 'G3DSA:1.25.40.990:FF:000034', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(188332, NULL, 'G3DSA:3.40.50.150:FF:000196', NULL, NULL, 'methyltransferase-like protein 17, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(188333, NULL, 'G3DSA:3.30.160.60:FF:003989', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188334, NULL, 'G3DSA:3.90.70.10:FF:000076', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 32', NULL, NULL, NULL, NULL, NULL, 4),
(188335, NULL, 'G3DSA:3.20.200.10:FF:000007', NULL, NULL, 'Elongation factor 2 kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188336, NULL, 'G3DSA:3.30.160.270:FF:000005', NULL, NULL, '2-isopropylmalate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(188337, NULL, 'G3DSA:1.20.120.1910:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188338, NULL, 'G3DSA:3.40.50.1000:FF:000085', NULL, NULL, 'Membrane-associated phosphatidylinositol transfer protein 3', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(188339, NULL, 'G3DSA:3.30.930.10:FF:000375', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188340, NULL, 'G3DSA:3.40.50.300:FF:000393', NULL, NULL, 'ADP-ribosylation factor-like 2, arl2', NULL, NULL, NULL, NULL, NULL, 4),
(188341, NULL, 'G3DSA:3.30.70.330:FF:001381', NULL, NULL, 'AGAP002654-PB', NULL, NULL, NULL, NULL, NULL, 4),
(188342, NULL, 'G3DSA:1.25.10.10:FF:000620', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(188343, NULL, 'G3DSA:3.90.550.10:FF:000321', NULL, NULL, 'Glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(188344, NULL, 'G3DSA:1.25.40.10:FF:000122', NULL, NULL, 'DnaJ (Hsp40) homolog, subfamily C, member 3', NULL, NULL, NULL, NULL, NULL, 4),
(188345, NULL, 'G3DSA:2.60.120.380:FF:000081', NULL, NULL, 'Putative calpain-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(188346, NULL, 'G3DSA:2.60.40.60:FF:000328', NULL, NULL, 'CaDHerin family', NULL, NULL, NULL, NULL, NULL, 4),
(188347, NULL, 'G3DSA:3.40.50.2300:FF:000143', NULL, NULL, 'DNA-binding response regulator CiaR', NULL, NULL, NULL, NULL, NULL, 4),
(188348, NULL, 'G3DSA:1.10.10.10:FF:000552', NULL, NULL, 'Putative transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(188349, NULL, 'G3DSA:3.40.50.1110:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188350, NULL, 'G3DSA:3.40.50.280:FF:000004', NULL, NULL, 'Methionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(188351, NULL, 'G3DSA:2.70.170.10:FF:000081', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(188352, NULL, 'G3DSA:3.90.1420.10:FF:000024', NULL, NULL, 'Putative countin receptor Cnr9', NULL, NULL, NULL, NULL, NULL, 4),
(188353, NULL, 'G3DSA:3.30.160.60:FF:002707', NULL, NULL, 'IKAROS family zinc finger 4', NULL, NULL, NULL, NULL, NULL, 4),
(188354, NULL, 'G3DSA:1.25.10.10:FF:002082', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(188355, NULL, 'G3DSA:3.50.50.60:FF:001485', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188356, NULL, 'G3DSA:3.30.160.60:FF:000342', NULL, NULL, 'zinc finger protein 394', NULL, NULL, NULL, NULL, NULL, 4),
(188357, NULL, 'G3DSA:3.30.2410.10:FF:000026', NULL, NULL, 'Zn-finger in Ran binding protein and others/SPRY domain/HECT-domain (Ubiquitin-transferase), putative', NULL, NULL, NULL, NULL, NULL, 4),
(188358, NULL, 'G3DSA:3.40.50.300:FF:002315', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(188359, NULL, 'G3DSA:3.30.40.10:FF:001156', NULL, NULL, 'Degringolade, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(188360, NULL, 'G3DSA:2.70.20.10:FF:000025', NULL, NULL, 'DNA topoisomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(188361, NULL, 'G3DSA:1.10.472.10:FF:000243', NULL, NULL, 'Cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(188362, NULL, 'G3DSA:2.90.10.10:FF:000029', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(188363, NULL, 'G3DSA:3.30.160.60:FF:000780', NULL, NULL, 'myc-associated zinc finger protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(188364, NULL, 'G3DSA:1.10.10.440:FF:000087', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188365, NULL, 'G3DSA:1.20.5.730:FF:000011', NULL, NULL, 'Rabaptin, RAB GTPase-binding effector protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(188366, NULL, 'G3DSA:3.30.200.20:FF:001469', NULL, NULL, 'RE24176p', NULL, NULL, NULL, NULL, NULL, 4),
(188367, NULL, 'G3DSA:1.10.510.10:FF:002373', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188368, NULL, 'G3DSA:1.10.238.10:FF:000750', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188369, NULL, 'G3DSA:1.10.506.10:FF:000025', NULL, NULL, 'Plexin D1', NULL, NULL, NULL, NULL, NULL, 4),
(188370, NULL, 'G3DSA:2.170.14.10:FF:000001', NULL, NULL, 'Tail spike protein', NULL, NULL, NULL, NULL, NULL, 4),
(188371, NULL, 'G3DSA:2.60.40.1670:FF:000023', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(188372, NULL, 'G3DSA:3.40.50.300:FF:008144', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188373, NULL, 'G3DSA:1.10.3720.10:FF:000106', NULL, NULL, 'Inner membrane ABC transporter permease ynjC', NULL, NULL, NULL, NULL, NULL, 4),
(188374, NULL, 'G3DSA:1.20.1080.10:FF:000110', NULL, NULL, 'Aquaporin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188375, NULL, 'G3DSA:3.40.50.300:FF:005968', NULL, NULL, 'ABC transporter H family member 4', NULL, NULL, NULL, NULL, NULL, 4),
(188376, NULL, 'G3DSA:1.10.10.10:FF:000434', NULL, NULL, 'Selenocysteine-specific translation elongation factor', NULL, NULL, NULL, NULL, NULL, 4),
(188377, NULL, 'G3DSA:2.60.40.1660:FF:000020', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(188378, NULL, 'G3DSA:3.40.50.300:FF:003939', NULL, NULL, 'AGAP006279-PA', NULL, NULL, NULL, NULL, NULL, 4),
(188379, NULL, 'G3DSA:1.10.510.10:FF:004514', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188380, NULL, 'G3DSA:3.30.160.60:FF:002921', NULL, NULL, 'Human immunodeficiency virus type I enhancer binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(188381, NULL, 'G3DSA:2.130.10.10:FF:005676', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188382, NULL, 'G3DSA:3.40.50.1820:FF:001640', NULL, NULL, 'Serine carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188383, NULL, 'G3DSA:3.30.70.80:FF:000015', NULL, NULL, 'Probable PRB1-protease B, vacuolar', NULL, NULL, NULL, NULL, NULL, 4),
(188384, NULL, 'G3DSA:3.40.50.300:FF:003838', NULL, NULL, 'ATP-dependent bile acid permease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188385, NULL, 'G3DSA:3.30.1320.10:FF:000002', NULL, NULL, '30S ribosomal protein S16', NULL, NULL, NULL, NULL, NULL, 4),
(188386, NULL, 'G3DSA:3.80.10.10:FF:001910', NULL, NULL, 'RANGAP2', NULL, NULL, NULL, NULL, NULL, 4),
(188387, NULL, 'G3DSA:3.30.565.10:FF:000306', NULL, NULL, 'Chaperone protein HtpG', NULL, NULL, NULL, NULL, NULL, 4),
(188388, NULL, 'G3DSA:4.10.400.10:FF:000066', NULL, NULL, 'LDL receptor related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(188389, NULL, 'G3DSA:3.30.450.40:FF:000212', NULL, NULL, 'GAF domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(188390, NULL, 'G3DSA:1.20.58.1780:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188391, NULL, 'G3DSA:3.70.10.10:FF:000039', NULL, NULL, 'Contig, possible fusion of chromosomes 20 and 34', NULL, NULL, NULL, NULL, NULL, 4),
(188392, NULL, 'G3DSA:1.10.510.10:FF:003997', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188393, NULL, 'G3DSA:1.25.40.10:FF:003770', NULL, NULL, 'Cell division cycle 16 homolog (S. cerevisiae)', NULL, NULL, NULL, NULL, NULL, 4),
(188394, NULL, 'G3DSA:1.10.390.30:FF:000002', NULL, NULL, 'Metallprotease, enhancin', NULL, NULL, NULL, NULL, NULL, 4),
(188395, NULL, 'G3DSA:3.90.226.10:FF:000270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188396, NULL, 'G3DSA:3.20.20.70:FF:000846', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188397, NULL, 'G3DSA:2.30.30.30:FF:000101', NULL, NULL, 'Elongation factor P', NULL, NULL, NULL, NULL, NULL, 4),
(188398, NULL, 'G3DSA:2.130.10.10:FF:001298', NULL, NULL, 'WD repeat-containing protein 3 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(188399, NULL, 'G3DSA:2.60.40.1510:FF:000003', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(188400, NULL, 'G3DSA:2.140.10.10:FF:000004', NULL, NULL, 'Quinate/shikimate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(188401, NULL, 'G3DSA:3.40.1260.20:FF:000003', NULL, NULL, 'Ribonuclease E', NULL, NULL, NULL, NULL, NULL, 4),
(188402, NULL, 'G3DSA:1.50.40.10:FF:000390', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188403, NULL, 'G3DSA:1.10.630.10:FF:000297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188404, NULL, 'G3DSA:1.10.287.110:FF:000242', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(188405, NULL, 'G3DSA:2.10.25.10:FF:000972', NULL, NULL, 'Adhesion G protein-coupled receptor E5b, duplicate 3', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(188406, NULL, 'G3DSA:3.30.505.10:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188407, NULL, 'G3DSA:2.60.40.10:FF:002472', NULL, NULL, 'Protein CBR-UNC-22', NULL, NULL, NULL, NULL, NULL, 4),
(188408, NULL, 'G3DSA:3.80.10.10:FF:002995', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188409, NULL, 'G3DSA:3.30.565.10:FF:000205', NULL, NULL, 'Pyruvate dehydrogenase (Lipoamide) kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188410, NULL, 'G3DSA:3.30.310.50:FF:000042', NULL, NULL, 'Phosphoglucomutase/phosphomannomutase alpha/beta/alpha domain I', NULL, NULL, NULL, NULL, NULL, 4),
(188411, NULL, 'G3DSA:2.20.28.10:FF:000023', NULL, NULL, 'DNA replication factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188412, NULL, 'G3DSA:1.10.287.1490:FF:000044', NULL, NULL, 'Kelch-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(188413, NULL, 'G3DSA:3.40.50.2020:FF:000054', NULL, NULL, 'ComF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(188414, NULL, 'G3DSA:3.20.20.80:FF:000849', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188415, NULL, 'G3DSA:2.30.30.40:FF:000104', NULL, NULL, 'Bacterial SH3 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(188416, NULL, 'G3DSA:1.25.10.10:FF:001688', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188417, NULL, 'G3DSA:3.40.250.10:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188418, NULL, 'G3DSA:2.60.40.10:FF:003568', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188419, NULL, 'G3DSA:2.40.50.140:FF:001147', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188420, NULL, 'G3DSA:2.60.40.10:FF:004506', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188421, NULL, 'G3DSA:1.25.40.440:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188422, NULL, 'G3DSA:3.40.50.300:FF:000612', NULL, NULL, 'ATP-binding cassette, sub-family A (ABC1), member 2', NULL, NULL, NULL, NULL, NULL, 4),
(188423, NULL, 'G3DSA:3.40.33.10:FF:000088', NULL, NULL, 'AGAP000357-PA', NULL, NULL, NULL, NULL, NULL, 4),
(188424, NULL, 'G3DSA:1.10.10.10:FF:001957', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188425, NULL, 'G3DSA:1.10.20.10:FF:000042', NULL, NULL, 'Transcription initiation factor TFIID subunit 13', NULL, NULL, NULL, NULL, NULL, 4),
(188426, NULL, 'G3DSA:2.130.10.10:FF:002023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188427, NULL, 'G3DSA:2.130.10.10:FF:004153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188428, NULL, 'G3DSA:1.25.40.10:FF:002134', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(188429, NULL, 'G3DSA:1.20.1640.10:FF:000092', NULL, NULL, 'Patched domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(188430, NULL, 'G3DSA:1.10.510.10:FF:000344', NULL, NULL, 'striated muscle preferentially expressed protein kinase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(188431, NULL, 'G3DSA:3.40.640.10:FF:000092', NULL, NULL, 'Tyrosine phenol-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(188432, NULL, 'G3DSA:2.60.40.1530:FF:000009', NULL, NULL, 'Integrin subunit alpha 11', NULL, NULL, NULL, NULL, NULL, 4),
(188433, NULL, 'G3DSA:1.20.1310.10:FF:000011', NULL, NULL, 'Cullin 1', NULL, NULL, NULL, NULL, NULL, 4),
(188434, NULL, 'G3DSA:3.30.230.80:FF:000005', NULL, NULL, 'heat shock protein 90-5, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(188435, NULL, 'G3DSA:3.40.30.10:FF:000750', NULL, NULL, 'Ferredoxin, 2Fe-2s', NULL, NULL, NULL, NULL, NULL, 4),
(188436, NULL, 'G3DSA:3.10.450.320:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188437, NULL, 'G3DSA:3.30.420.10:FF:000746', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188438, NULL, 'G3DSA:1.10.510.10:FF:000670', NULL, NULL, 'Serine/threonin protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188439, NULL, 'G3DSA:3.30.450.20:FF:000577', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(188440, NULL, 'G3DSA:1.10.150.190:FF:000002', NULL, NULL, 'Translation initiation factor 2, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(188441, NULL, 'G3DSA:2.60.200.20:FF:000134', NULL, NULL, 'E3 ubiquitin-protein ligase CHFR-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(188442, NULL, 'G3DSA:4.10.240.10:FF:000188', NULL, NULL, 'Activator of stress genes protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(188443, NULL, 'G3DSA:1.25.10.10:FF:002205', NULL, NULL, 'Proteasome/cyclosome repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(188444, NULL, 'G3DSA:3.30.9.10:FF:000257', NULL, NULL, 'Gll0956 protein', NULL, NULL, NULL, NULL, NULL, 4),
(188445, NULL, 'G3DSA:2.10.25.10:FF:001146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188446, NULL, 'G3DSA:1.10.1420.10:FF:000050', NULL, NULL, 'DNA mismatch repair protein Msh5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188447, NULL, 'G3DSA:1.20.1310.20:FF:000014', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(188448, NULL, 'G3DSA:3.10.20.30:FF:000032', NULL, NULL, 'Stearoyl-CoA 9-desaturase', NULL, NULL, NULL, NULL, NULL, 4),
(188449, NULL, 'G3DSA:3.40.50.1820:FF:001741', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188450, NULL, 'G3DSA:1.10.238.10:FF:000323', NULL, NULL, 'Actin cytoskeleton-regulatory complex protein end3', NULL, NULL, NULL, NULL, NULL, 4),
(188451, NULL, 'G3DSA:3.30.70.20:FF:000143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188452, NULL, 'G3DSA:3.40.228.10:FF:000010', NULL, NULL, 'Tetrathionate reductase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(188453, NULL, 'G3DSA:2.60.40.10:FF:005709', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188454, NULL, 'G3DSA:1.10.510.10:FF:001867', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase gcn-2', NULL, NULL, NULL, NULL, NULL, 4),
(188455, NULL, 'G3DSA:3.30.1360.10:FF:000010', NULL, NULL, 'DNA-directed RNA polymerase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(188456, NULL, 'G3DSA:1.25.40.10:FF:003657', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188457, NULL, 'G3DSA:3.40.50.10810:FF:000121', NULL, NULL, 'DNA repair and recombination protein RAD54B', NULL, NULL, NULL, NULL, NULL, 4),
(188458, NULL, 'G3DSA:3.40.50.300:FF:002742', NULL, NULL, 'Superkiller protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(188459, NULL, 'G3DSA:3.40.50.1440:FF:000082', NULL, NULL, 'Misato 1, mitochondrial distribution and morphology regulator', NULL, NULL, NULL, NULL, NULL, 4),
(188460, NULL, 'G3DSA:1.10.357.70:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188461, NULL, 'G3DSA:1.25.40.10:FF:001196', NULL, NULL, 'Tonsoku like, DNA repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(188462, NULL, 'G3DSA:1.10.220.110:FF:000001', NULL, NULL, 'GDNF family receptor alpha', NULL, NULL, NULL, NULL, NULL, 4),
(188463, NULL, 'G3DSA:3.30.70.330:FF:000520', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(188464, NULL, 'G3DSA:3.30.70.240:FF:000044', NULL, NULL, 'CRISPR-associated endonuclease Cas2', NULL, NULL, NULL, NULL, NULL, 4),
(188465, NULL, 'G3DSA:1.10.287.70:FF:000494', NULL, NULL, 'T calcium channel alpha1G subunit +34+35 splice variant', NULL, NULL, NULL, NULL, NULL, 4),
(188466, NULL, 'G3DSA:3.80.10.10:FF:003613', NULL, NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', NULL, NULL, NULL, NULL, NULL, 4),
(188467, NULL, 'G3DSA:2.60.40.1730:FF:000064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188468, NULL, 'G3DSA:2.60.40.10:FF:003669', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188469, NULL, 'G3DSA:2.20.20.110:FF:000012', NULL, NULL, 'AGR162Cp', NULL, NULL, NULL, NULL, NULL, 4),
(188470, NULL, 'G3DSA:2.40.70.10:FF:000007', NULL, NULL, 'Beta-secretase 1', NULL, NULL, NULL, NULL, NULL, 4),
(188471, NULL, 'G3DSA:3.40.50.1820:FF:001409', NULL, NULL, 'GPI inositol-deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(188472, NULL, 'G3DSA:3.30.1640.10:FF:000043', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(188473, NULL, 'G3DSA:1.20.1280.50:FF:000008', NULL, NULL, 'F-box only protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(188474, NULL, 'G3DSA:3.40.630.30:FF:000406', NULL, NULL, 'Nudix hydrolase 6', NULL, NULL, NULL, NULL, NULL, 4),
(188475, NULL, 'G3DSA:3.40.50.1820:FF:001527', NULL, NULL, 'Os01g0958800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(188476, NULL, 'G3DSA:2.60.40.3440:FF:000003', NULL, NULL, 'RTX toxins and related Ca2+-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(188477, NULL, 'G3DSA:2.10.220.10:FF:000048', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 6', NULL, NULL, NULL, NULL, NULL, 4),
(188478, NULL, 'G3DSA:1.25.40.10:FF:002033', NULL, NULL, 'ESX-3 secretion system protein EccA3', NULL, NULL, NULL, NULL, NULL, 4),
(188479, NULL, 'G3DSA:2.120.10.30:FF:000180', NULL, NULL, 'Gluconolaconase', NULL, NULL, NULL, NULL, NULL, 4),
(188480, NULL, 'G3DSA:1.10.520.10:FF:000058', NULL, NULL, 'Thylakoid lumenal 29 kDa protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(188481, NULL, 'G3DSA:3.40.50.970:FF:000211', NULL, NULL, '2-oxoisovalerate dehydrogenase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(188482, NULL, 'G3DSA:3.40.630.10:FF:000400', NULL, NULL, 'Carboxypeptidase D, b', NULL, NULL, NULL, NULL, NULL, 4),
(188483, NULL, 'G3DSA:2.40.70.10:FF:000119', NULL, NULL, 'Eukaryotic aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(188484, NULL, 'G3DSA:3.40.50.300:FF:004653', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(188485, NULL, 'G3DSA:3.40.50.1980:FF:000024', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(188486, NULL, 'G3DSA:1.10.287.370:FF:000078', NULL, NULL, 'Prefoldin subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(188487, NULL, 'G3DSA:1.10.135.10:FF:000011', NULL, NULL, 'Arginine kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(188488, NULL, 'G3DSA:1.10.10.10:FF:001862', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(188489, NULL, 'G3DSA:3.30.70.2330:FF:000003', NULL, NULL, 'Fanconi-associated nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(188490, NULL, 'G3DSA:2.60.40.10:FF:000134', NULL, NULL, 'Myomesin 1', NULL, NULL, NULL, NULL, NULL, 4),
(188491, NULL, 'G3DSA:2.40.50.930:FF:000001', NULL, NULL, 'Serine/threonine-protein kinase PLK4', NULL, NULL, NULL, NULL, NULL, 4),
(188492, NULL, 'G3DSA:1.10.10.60:FF:001287', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188493, NULL, 'G3DSA:2.40.150.20:FF:000005', NULL, NULL, '50S ribosomal protein L14', NULL, NULL, NULL, NULL, NULL, 4),
(188494, NULL, 'G3DSA:3.40.980.10:FF:000044', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(188495, NULL, 'G3DSA:3.30.70.330:FF:001616', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188496, NULL, 'G3DSA:1.20.58.390:FF:000330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188497, NULL, 'G3DSA:3.40.50.740:FF:000058', NULL, NULL, 'Gll2176 protein', NULL, NULL, NULL, NULL, NULL, 4),
(188498, NULL, 'G3DSA:2.130.10.10:FF:003647', NULL, NULL, 'Protein raptor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(188499, NULL, 'G3DSA:3.60.20.40:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188500, NULL, 'G3DSA:3.40.50.880:FF:000072', NULL, NULL, 'Aminodeoxychorismate synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(188501, NULL, 'G3DSA:2.60.40.10:FF:002045', NULL, NULL, 'Putative adhesin', NULL, NULL, NULL, NULL, NULL, 4),
(188502, NULL, 'G3DSA:1.10.10.820:FF:000010', NULL, NULL, 'Chitin synthase 6', NULL, NULL, NULL, NULL, NULL, 4),
(188503, NULL, 'G3DSA:3.40.47.10:FF:000142', NULL, NULL, 'Hydroxymethylglutaryl-CoA synthase', NULL, NULL, NULL, NULL, NULL, 4),
(188504, NULL, 'G3DSA:1.20.1070.10:FF:001026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188505, NULL, 'G3DSA:3.40.50.2300:FF:001453', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188506, NULL, 'G3DSA:1.10.10.140:FF:000014', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(188507, NULL, 'G3DSA:1.10.287.950:FF:000038', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(188508, NULL, 'G3DSA:1.10.510.10:FF:000024', NULL, NULL, 'Probable serine/threonine-protein kinase cot-1', NULL, NULL, NULL, NULL, NULL, 4),
(188509, NULL, 'G3DSA:3.40.350.10:FF:000013', NULL, NULL, 'probable Xaa-Pro aminopeptidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(188510, NULL, 'G3DSA:3.30.230.70:FF:000002', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(188511, NULL, 'G3DSA:3.90.550.10:FF:000208', NULL, NULL, '2-C-methyl-D-erythritol 4-phosphate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(188512, NULL, 'G3DSA:1.25.10.10:FF:001368', NULL, NULL, 'YALI0C07909p', NULL, NULL, NULL, NULL, NULL, 4),
(188513, NULL, 'G3DSA:3.30.160.60:FF:002820', NULL, NULL, 'Transcriptional regulator MET31', NULL, NULL, NULL, NULL, NULL, 4),
(188514, NULL, 'G3DSA:3.30.200.20:FF:001368', NULL, NULL, 'Putative serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(188515, NULL, 'G3DSA:1.20.1110.10:FF:000125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188516, NULL, 'G3DSA:1.25.10.10:FF:000165', NULL, NULL, 'Protein MOR1', NULL, NULL, NULL, NULL, NULL, 4),
(188517, NULL, 'G3DSA:1.25.40.450:FF:000007', NULL, NULL, 'Nuclear Pore complex Protein', NULL, NULL, NULL, NULL, NULL, 4),
(188518, NULL, 'G3DSA:1.10.20.10:FF:000154', NULL, NULL, 'Transcription initiation factor tfiid, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188519, NULL, 'G3DSA:3.40.50.970:FF:000110', NULL, NULL, 'Pyruvate-flavodoxin oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(188520, NULL, 'G3DSA:1.20.1250.20:FF:001127', NULL, NULL, 'MFS multidrug transporter', NULL, NULL, NULL, NULL, NULL, 4),
(188521, NULL, 'G3DSA:4.10.60.10:FF:000071', NULL, NULL, 'Cleavage and polyadenylation-specific factor 4-like', NULL, NULL, NULL, NULL, NULL, 4),
(188522, NULL, 'G3DSA:1.20.210.10:FF:000021', NULL, NULL, 'Cytochrome c oxidase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(188523, NULL, 'G3DSA:2.70.98.10:FF:000103', NULL, NULL, 'Aldose 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(188524, NULL, 'G3DSA:1.25.10.10:FF:000283', NULL, NULL, 'Anaphase-promoting complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(188525, NULL, 'G3DSA:3.20.20.190:FF:000139', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188526, NULL, 'G3DSA:1.10.1420.10:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188527, NULL, 'G3DSA:2.130.10.10:FF:003759', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188528, NULL, 'G3DSA:3.40.50.720:FF:001249', NULL, NULL, 'D-amino acid oxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188529, NULL, 'G3DSA:3.30.200.20:FF:002200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188530, NULL, 'G3DSA:3.30.70.3450:FF:000002', NULL, NULL, 'Alkyldihydroxyacetonephosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(188531, NULL, 'G3DSA:3.30.200.20:FF:001582', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188532, NULL, 'G3DSA:3.40.50.300:FF:004092', NULL, NULL, 'Ribosome-binding ATPase YchF', NULL, NULL, NULL, NULL, NULL, 4),
(188533, NULL, 'G3DSA:2.60.200.20:FF:000022', NULL, NULL, 'E3 ubiquitin-protein ligase CHFR isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(188534, NULL, 'G3DSA:3.30.1010.10:FF:000012', NULL, NULL, 'Phosphatidylinositol 4-kinase alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(188535, NULL, 'G3DSA:1.20.58.480:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188536, NULL, 'G3DSA:2.70.98.110:FF:000014', NULL, NULL, 'Mannosyl-oligosaccharide glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(188537, NULL, 'G3DSA:3.30.1380.10:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188538, NULL, 'G3DSA:1.10.10.60:FF:000090', NULL, NULL, 'Transcriptional regulator ArgR, AraC family', NULL, NULL, NULL, NULL, NULL, 4),
(188539, NULL, 'G3DSA:1.10.10.830:FF:000013', NULL, NULL, 'Isoleucyl-tRNA synthetase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(188540, NULL, 'G3DSA:2.130.10.10:FF:005996', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188541, NULL, 'G3DSA:3.30.1380.20:FF:000014', NULL, NULL, 'Trafficking protein particle complex subunit 6A', NULL, NULL, NULL, NULL, NULL, 4),
(188542, NULL, 'G3DSA:1.10.10.10:FF:000114', NULL, NULL, 'Lrp/AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(188543, NULL, 'G3DSA:3.40.50.1820:FF:000926', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188544, NULL, 'G3DSA:1.10.510.10:FF:004161', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188545, NULL, 'G3DSA:3.10.580.10:FF:000099', NULL, NULL, 'Sugar isomerase, KpsF/GutQ family', NULL, NULL, NULL, NULL, NULL, 4),
(188546, NULL, 'G3DSA:1.10.3720.10:FF:000011', NULL, NULL, 'Glutamine ABC transporter permease GlnP', NULL, NULL, NULL, NULL, NULL, 4),
(188547, NULL, 'G3DSA:1.20.1560.10:FF:000737', NULL, NULL, 'ABC transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(188548, NULL, 'G3DSA:1.10.357.120:FF:000003', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(188549, NULL, 'G3DSA:3.30.420.80:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188550, NULL, 'G3DSA:1.20.58.80:FF:000019', NULL, NULL, 'AAA-type ATPase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(188551, NULL, 'G3DSA:3.30.160.60:FF:001983', NULL, NULL, 'Transcriptional regulator Nrg1', NULL, NULL, NULL, NULL, NULL, 4),
(188552, NULL, 'G3DSA:2.60.200.30:FF:000025', NULL, NULL, 'NAD kinase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(188553, NULL, 'G3DSA:1.20.1310.10:FF:000106', NULL, NULL, 'Ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(188554, NULL, 'G3DSA:3.90.70.10:FF:000104', NULL, NULL, 'Cathepsin L 1', NULL, NULL, NULL, NULL, NULL, 4),
(188555, NULL, 'G3DSA:1.20.5.340:FF:000118', NULL, NULL, 'Myosin-2 heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(188556, NULL, 'G3DSA:3.40.30.10:FF:000845', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(188557, NULL, 'G3DSA:3.40.1000.50:FF:000004', NULL, NULL, 'Repressor of RNA polymerase III transcription MAF1', NULL, NULL, NULL, NULL, NULL, 4),
(188558, NULL, 'G3DSA:1.50.40.10:FF:000058', NULL, NULL, 'Solute carrier family 25 member 48', NULL, NULL, NULL, NULL, NULL, 4),
(188559, NULL, 'G3DSA:2.60.40.420:FF:000269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188560, NULL, 'G3DSA:3.90.740.10:FF:000021', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(188561, NULL, 'G3DSA:3.10.110.10:FF:000160', NULL, NULL, 'Putative pre-mrna-splicing factor atp-dependent rna helicase prp22 protein', NULL, NULL, NULL, NULL, NULL, 4),
(188562, NULL, 'G3DSA:1.20.58.70:FF:000016', NULL, NULL, 'Syntaxin-32 like', NULL, NULL, NULL, NULL, NULL, 4),
(188563, NULL, 'G3DSA:2.130.10.10:FF:002135', NULL, NULL, 'WD repeat and FYVE domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(188564, NULL, 'G3DSA:3.90.470.20:FF:000031', NULL, NULL, '4''phosphopantetheinyl transferase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(188565, NULL, 'G3DSA:1.10.8.60:FF:000347', NULL, NULL, 'WGS project CABT00000000 data, contig 2.3', NULL, NULL, NULL, NULL, NULL, 4),
(188566, NULL, 'G3DSA:2.40.10.10:FF:000015', NULL, NULL, 'Atrial natriuretic peptide-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(188567, NULL, 'G3DSA:1.50.40.10:FF:000485', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188568, NULL, 'G3DSA:3.90.230.10:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188569, NULL, 'G3DSA:3.30.505.10:FF:000185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188570, NULL, 'G3DSA:1.20.1730.10:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188571, NULL, 'G3DSA:3.40.1000.40:FF:000001', NULL, NULL, 'Respiratory growth induced protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(188572, NULL, 'G3DSA:3.90.70.10:FF:000531', NULL, NULL, 'Haemolysin secretion ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(188573, NULL, 'G3DSA:3.40.30.10:FF:000418', NULL, NULL, 'Chloride intracellular channel exc-4', NULL, NULL, NULL, NULL, NULL, 4),
(188574, NULL, 'G3DSA:1.10.238.10:FF:000087', NULL, NULL, 'Sorcin', NULL, NULL, NULL, NULL, NULL, 4),
(188575, NULL, 'G3DSA:2.60.40.10:FF:004383', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188576, NULL, 'G3DSA:3.40.50.150:FF:000432', NULL, NULL, 'Unplaced genomic scaffold supercont2.10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(188577, NULL, 'G3DSA:2.60.40.10:FF:001977', NULL, NULL, 'KETtiN (Drosophila actin-binding) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(188578, NULL, 'G3DSA:1.10.8.60:FF:000465', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188579, NULL, 'G3DSA:2.60.120.970:FF:000044', NULL, NULL, 'Inhibin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(188580, NULL, 'G3DSA:3.40.640.10:FF:000215', NULL, NULL, 'Probable aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(188581, NULL, 'G3DSA:1.20.1250.20:FF:001026', NULL, NULL, 'AGL069Cp', NULL, NULL, NULL, NULL, NULL, 4),
(188582, NULL, 'G3DSA:2.130.10.10:FF:002562', NULL, NULL, 'Intraflagellar transport particle protein 80', NULL, NULL, NULL, NULL, NULL, 4),
(188583, NULL, 'G3DSA:2.20.100.10:FF:000178', NULL, NULL, 'Pancreatic trypsin inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(188584, NULL, 'G3DSA:1.10.472.10:FF:000131', NULL, NULL, 'G1 cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(188585, NULL, 'G3DSA:3.40.50.1000:FF:000534', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188586, NULL, 'G3DSA:3.30.160.60:FF:002028', NULL, NULL, 'Fruitless, isoform I', NULL, NULL, NULL, NULL, NULL, 4),
(188587, NULL, 'G3DSA:1.20.120.1110:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188588, NULL, 'G3DSA:1.10.240.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188589, NULL, 'G3DSA:3.30.565.10:FF:000082', NULL, NULL, 'Sensor histidine kinase ComD', NULL, NULL, NULL, NULL, NULL, 4),
(188590, NULL, 'G3DSA:1.20.58.830:FF:000041', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(188591, NULL, 'G3DSA:3.30.70.20:FF:000025', NULL, NULL, 'Ferredoxin-type protein NapF', NULL, NULL, NULL, NULL, NULL, 4),
(188592, NULL, 'G3DSA:3.30.40.10:FF:001622', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188593, NULL, 'G3DSA:2.60.40.150:FF:000362', NULL, NULL, 'coiled-coil and C2 domain-containing protein 2A', NULL, NULL, NULL, NULL, NULL, 4),
(188594, NULL, 'G3DSA:1.10.287.110:FF:000253', NULL, NULL, 'Guanine nucleotide-binding protein subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(188595, NULL, 'G3DSA:3.40.50.300:FF:004333', NULL, NULL, 'Iron(III) ABC superfamily ATP binding cassette transporter, ABC protein', NULL, NULL, NULL, NULL, NULL, 4),
(188596, NULL, 'G3DSA:3.30.160.60:FF:000128', NULL, NULL, 'zinc finger protein 268 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(188597, NULL, 'G3DSA:2.60.40.790:FF:000003', NULL, NULL, 'prostaglandin E synthase 3', NULL, NULL, NULL, NULL, NULL, 4),
(188598, NULL, 'G3DSA:3.40.50.300:FF:002079', NULL, NULL, 'ATP-dependent dethiobiotin synthetase BioD', NULL, NULL, NULL, NULL, NULL, 4),
(188599, NULL, 'G3DSA:2.40.460.10:FF:000003', NULL, NULL, 'Acetyl-CoA carboxylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(188600, NULL, 'G3DSA:1.20.1310.10:FF:000117', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188601, NULL, 'G3DSA:2.10.25.10:FF:001360', NULL, NULL, 'Laminin, beta 1b', NULL, NULL, NULL, NULL, NULL, 4),
(188602, NULL, 'G3DSA:2.130.10.10:FF:005788', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188603, NULL, 'G3DSA:3.30.450.40:FF:000223', NULL, NULL, 'Pca regulon regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(188604, NULL, 'G3DSA:3.40.50.150:FF:000078', NULL, NULL, 'Protein arginine methyltransferase 9', NULL, NULL, NULL, NULL, NULL, 4),
(188605, NULL, 'G3DSA:3.30.160.60:FF:003894', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(188606, NULL, 'G3DSA:2.60.40.10:FF:000454', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type substrate 1', NULL, NULL, NULL, NULL, NULL, 4),
(188607, NULL, 'G3DSA:3.30.70.330:FF:002111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188608, NULL, 'G3DSA:3.90.1530.30:FF:000010', NULL, NULL, 'Replication protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188609, NULL, 'G3DSA:1.10.10.10:FF:002025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188610, NULL, 'G3DSA:1.10.10.140:FF:000003', NULL, NULL, 'Cytochrome c oxidase assembly factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(188611, NULL, 'G3DSA:2.40.70.10:FF:000350', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188612, NULL, 'G3DSA:3.30.160.60:FF:004170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188613, NULL, 'G3DSA:3.40.50.450:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188614, NULL, 'G3DSA:1.20.120.1750:FF:000070', NULL, NULL, 'Os11g0300800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(188615, NULL, 'G3DSA:3.90.660.10:FF:000099', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188616, NULL, 'G3DSA:3.30.60.30:FF:000090', NULL, NULL, 'GH09510p', NULL, NULL, NULL, NULL, NULL, 4),
(188617, NULL, 'G3DSA:2.130.10.10:FF:003658', NULL, NULL, 'Chromatin modification-related protein rik1', NULL, NULL, NULL, NULL, NULL, 4),
(188618, NULL, 'G3DSA:3.30.160.60:FF:006311', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188619, NULL, 'G3DSA:3.30.160.60:FF:002258', NULL, NULL, 'Zinc finger protein ZIC 3', NULL, NULL, NULL, NULL, NULL, 4),
(188620, NULL, 'G3DSA:3.30.9.10:FF:000246', NULL, NULL, 'Amino acid oxidase fmpA', NULL, NULL, NULL, NULL, NULL, 4),
(188621, NULL, 'G3DSA:2.60.120.330:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188622, NULL, 'G3DSA:3.90.1480.20:FF:000036', NULL, NULL, 'ST3 beta-galactoside alpha-2,3-sialyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(188623, NULL, 'G3DSA:3.10.20.90:FF:000690', NULL, NULL, 'YALI0E14927p', NULL, NULL, NULL, NULL, NULL, 4),
(188624, NULL, 'G3DSA:3.90.1750.10:FF:000026', NULL, NULL, 'E3 ubiquitin-protein ligase HACE1', NULL, NULL, NULL, NULL, NULL, 4),
(188625, NULL, 'G3DSA:1.20.5.170:FF:000169', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188626, NULL, 'G3DSA:3.20.20.140:FF:000478', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188627, NULL, 'G3DSA:3.80.10.10:FF:001247', NULL, NULL, 'Os06g0557400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(188628, NULL, 'G3DSA:3.30.800.10:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188629, NULL, 'G3DSA:1.25.40.10:FF:005248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188630, NULL, 'G3DSA:3.30.930.10:FF:000257', NULL, NULL, 'Octanoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(188631, NULL, 'G3DSA:3.20.80.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188632, NULL, 'G3DSA:1.20.120.1760:FF:000073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188633, NULL, 'G3DSA:1.10.20.10:FF:000053', NULL, NULL, 'Centromere protein W', NULL, NULL, NULL, NULL, NULL, 4),
(188634, NULL, 'G3DSA:2.60.200.20:FF:000123', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188635, NULL, 'G3DSA:3.40.50.720:FF:001912', NULL, NULL, 'Os07g0602050 protein', NULL, NULL, NULL, NULL, NULL, 4),
(188636, NULL, 'G3DSA:2.130.10.10:FF:005912', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188637, NULL, 'G3DSA:1.10.630.10:FF:000628', NULL, NULL, 'Os07g0464700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(188638, NULL, 'G3DSA:3.40.50.150:FF:000533', NULL, NULL, 'Site-specific DNA-methyltransferase (adenine-specific)', NULL, NULL, NULL, NULL, NULL, 4),
(188639, NULL, 'G3DSA:3.10.20.90:FF:000802', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188640, NULL, 'G3DSA:2.30.30.40:FF:000542', NULL, NULL, 'EPS8 like 1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(188641, NULL, 'G3DSA:2.130.10.10:FF:005890', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188642, NULL, 'G3DSA:3.40.50.2020:FF:000166', NULL, NULL, 'Ribose-phosphate pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(188643, NULL, 'G3DSA:3.30.160.60:FF:004057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188644, NULL, 'G3DSA:2.60.120.920:FF:000175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188645, NULL, 'G3DSA:3.40.50.720:FF:000974', NULL, NULL, 'NAD-dependent malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(188646, NULL, 'G3DSA:2.60.40.1910:FF:000016', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(188647, NULL, 'G3DSA:2.30.30.40:FF:000312', NULL, NULL, 'Related to Cell division control protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(188648, NULL, 'G3DSA:3.40.630.30:FF:000283', NULL, NULL, 'Acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188649, NULL, 'G3DSA:1.10.1070.11:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188650, NULL, 'G3DSA:2.60.120.40:FF:000061', NULL, NULL, 'Complement C1q B chain', NULL, NULL, NULL, NULL, NULL, 4),
(188651, NULL, 'G3DSA:3.30.40.10:FF:001167', NULL, NULL, 'DSC E3 ubiquitin ligase complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(188652, NULL, 'G3DSA:2.70.130.10:FF:000101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188653, NULL, 'G3DSA:3.10.100.10:FF:000002', NULL, NULL, 'Hyaluronan proteoglycan link protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(188654, NULL, 'G3DSA:3.30.43.10:FF:000010', NULL, NULL, 'probable D-lactate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(188655, NULL, 'G3DSA:3.30.160.60:FF:005794', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188656, NULL, 'G3DSA:2.10.110.10:FF:000141', NULL, NULL, 'LIM domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(188657, NULL, 'G3DSA:3.20.20.70:FF:000493', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188658, NULL, 'G3DSA:1.25.10.10:FF:002183', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188659, NULL, 'G3DSA:3.40.30.10:FF:000295', NULL, NULL, 'Glutathione S-transferase unclassified 1', NULL, NULL, NULL, NULL, NULL, 4),
(188660, NULL, 'G3DSA:1.20.5.110:FF:000067', NULL, NULL, 't-SNARE', NULL, NULL, NULL, NULL, NULL, 4),
(188661, NULL, 'G3DSA:3.10.20.90:FF:000252', NULL, NULL, 'Probable serine/threonine-protein kinase WNK3', NULL, NULL, NULL, NULL, NULL, 4),
(188662, NULL, 'G3DSA:3.40.50.300:FF:002304', NULL, NULL, 'Nucleotide binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(188663, NULL, 'G3DSA:3.40.50.80:FF:000030', NULL, NULL, 'NADPH-dependent diflavin oxidoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(188664, NULL, 'G3DSA:1.20.120.1080:FF:000066', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(188665, NULL, 'G3DSA:2.160.20.70:FF:000011', NULL, NULL, 'Tubulin-specific chaperone c, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188666, NULL, 'G3DSA:2.10.70.10:FF:000273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188667, NULL, 'G3DSA:1.20.1070.10:FF:001930', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188668, NULL, 'G3DSA:3.30.420.40:FF:000373', NULL, NULL, 'Golgi apyrase', NULL, NULL, NULL, NULL, NULL, 4),
(188669, NULL, 'G3DSA:1.10.530.10:FF:000019', NULL, NULL, 'lysozyme', NULL, NULL, NULL, NULL, NULL, 4),
(188670, NULL, 'G3DSA:2.130.10.10:FF:001961', NULL, NULL, 'Protein purity of essence', NULL, NULL, NULL, NULL, NULL, 4),
(188671, NULL, 'G3DSA:3.30.160.60:FF:004512', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188672, NULL, 'G3DSA:3.20.20.70:FF:000835', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188673, NULL, 'G3DSA:3.20.20.80:FF:000496', NULL, NULL, 'Glycogen debranching enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188674, NULL, 'G3DSA:1.10.287.850:FF:000008', NULL, NULL, 'PE family protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(188675, NULL, 'G3DSA:3.10.290.10:FF:000009', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(188676, NULL, 'G3DSA:2.10.25.10:FF:001601', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188677, NULL, 'G3DSA:1.10.238.10:FF:000312', NULL, NULL, 'EF-hand domain-containing protein 1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(188678, NULL, 'G3DSA:3.30.70.330:FF:001493', NULL, NULL, 'Spliceosome-associated protein 49', NULL, NULL, NULL, NULL, NULL, 4),
(188679, NULL, 'G3DSA:3.30.565.10:FF:000183', NULL, NULL, 'Heat shock protein 90-2', NULL, NULL, NULL, NULL, NULL, 4),
(188680, NULL, 'G3DSA:2.30.29.30:FF:001312', NULL, NULL, 'FERM, RhoGEF and pleckstrin domain-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188681, NULL, 'G3DSA:1.20.140.100:FF:000027', NULL, NULL, 'Dynein alpha chain, flagellar outer arm', NULL, NULL, NULL, NULL, NULL, 4),
(188682, NULL, 'G3DSA:2.60.120.10:FF:000198', NULL, NULL, 'Mannose-6-phosphate isomerase, class I', NULL, NULL, NULL, NULL, NULL, 4),
(188683, NULL, 'G3DSA:3.30.160.60:FF:006070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188684, NULL, 'G3DSA:1.10.268.10:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188685, NULL, 'G3DSA:3.30.160.60:FF:000460', NULL, NULL, 'Putative zinc finger protein 740', NULL, NULL, NULL, NULL, NULL, 4),
(188686, NULL, 'G3DSA:3.20.20.120:FF:000034', NULL, NULL, 'Aromatic dipeptide epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(188687, NULL, 'G3DSA:3.30.530.20:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188688, NULL, 'G3DSA:2.10.25.10:FF:001247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188689, NULL, 'G3DSA:2.130.10.10:FF:002124', NULL, NULL, 'WD repeat-containing protein PCN', NULL, NULL, NULL, NULL, NULL, 4),
(188690, NULL, 'G3DSA:1.10.760.10:FF:000042', NULL, NULL, 'Cytochrome c peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(188691, NULL, 'G3DSA:3.40.50.300:FF:000281', NULL, NULL, 'ADP-ribosylation factor-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(188692, NULL, 'G3DSA:1.20.1070.10:FF:001256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188693, NULL, 'G3DSA:1.10.472.10:FF:000451', NULL, NULL, 'Cyclin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(188694, NULL, 'G3DSA:3.90.70.10:FF:000542', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(188695, NULL, 'G3DSA:3.40.630.150:FF:000018', NULL, NULL, 'Malonyl-CoA decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(188696, NULL, 'G3DSA:3.40.50.800:FF:000094', NULL, NULL, 'Prolyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(188697, NULL, 'G3DSA:3.40.1360.10:FF:000064', NULL, NULL, 'Spo11-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(188698, NULL, 'G3DSA:3.40.50.1100:FF:000244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188699, NULL, 'G3DSA:3.30.1120.40:FF:000001', NULL, NULL, 'Putative septation protein SpoVG', NULL, NULL, NULL, NULL, NULL, 4),
(188700, NULL, 'G3DSA:3.30.70.1730:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188701, NULL, 'G3DSA:3.40.50.1460:FF:000088', NULL, NULL, 'AGAP011693-PA', NULL, NULL, NULL, NULL, NULL, 4),
(188702, NULL, 'G3DSA:3.80.10.10:FF:002984', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188703, NULL, 'G3DSA:3.40.120.10:FF:000081', NULL, NULL, 'Phosphoglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(188704, NULL, 'G3DSA:3.20.20.80:FF:000838', NULL, NULL, 'CHItinase-Like', NULL, NULL, NULL, NULL, NULL, 4),
(188705, NULL, 'G3DSA:2.60.40.2030:FF:000030', NULL, NULL, 'Adhesion G-protein coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(188706, NULL, 'G3DSA:2.10.25.10:FF:001040', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(188707, NULL, 'G3DSA:3.40.50.300:FF:006452', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188708, NULL, 'G3DSA:3.90.1170.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(188709, NULL, 'G3DSA:1.25.40.10:FF:000004', NULL, NULL, 'Photosystem I assembly protein Ycf3', NULL, NULL, NULL, NULL, NULL, 4),
(188710, NULL, 'G3DSA:1.10.506.10:FF:000014', NULL, NULL, 'Neurofibromin 1', NULL, NULL, NULL, NULL, NULL, 4),
(188711, NULL, 'G3DSA:3.30.70.2740:FF:000019', NULL, NULL, 'D-lactate dehydrogenase (acceptor)', NULL, NULL, NULL, NULL, NULL, 4),
(188712, NULL, 'G3DSA:3.10.100.10:FF:000440', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188713, NULL, 'G3DSA:3.30.70.1230:FF:000117', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(188714, NULL, 'G3DSA:3.10.580.10:FF:000088', NULL, NULL, 'Glycine betaine/L-proline ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(188715, NULL, 'G3DSA:3.90.550.10:FF:000107', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase-like 6', NULL, NULL, NULL, NULL, NULL, 4),
(188716, NULL, 'G3DSA:1.20.58.60:FF:000699', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188717, NULL, 'G3DSA:1.20.58.60:FF:000002', NULL, NULL, 'Actinin, alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(188718, NULL, 'G3DSA:3.80.10.10:FF:001921', NULL, NULL, 'Probable WRKY transcription factor 19', NULL, NULL, NULL, NULL, NULL, 4),
(188719, NULL, 'G3DSA:2.60.40.10:FF:005698', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188720, NULL, 'G3DSA:2.130.10.10:FF:000224', NULL, NULL, 'cell division cycle protein 20 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(188721, NULL, 'G3DSA:3.80.10.10:FF:003260', NULL, NULL, 'Leucine-rich transmembrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188722, NULL, 'G3DSA:2.30.29.30:FF:001087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188723, NULL, 'G3DSA:1.10.3730.20:FF:000048', NULL, NULL, 'EamA family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(188724, NULL, 'G3DSA:2.60.40.60:FF:000233', NULL, NULL, 'Protocadherin gamma-A3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(188725, NULL, 'G3DSA:3.40.980.10:FF:000033', NULL, NULL, 'Molybdopterin biosynthesis protein (MoeA-2)', NULL, NULL, NULL, NULL, NULL, 4),
(188726, NULL, 'G3DSA:1.20.1560.10:FF:000496', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(188727, NULL, 'G3DSA:3.80.10.10:FF:001360', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188728, NULL, 'G3DSA:3.30.40.10:FF:001509', NULL, NULL, 'YALI0E33869p', NULL, NULL, NULL, NULL, NULL, 4),
(188729, NULL, 'G3DSA:4.10.410.10:FF:000117', NULL, NULL, 'Trypsin inhibitor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188730, NULL, 'G3DSA:1.10.510.10:FF:000462', NULL, NULL, 'Receptor tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(188731, NULL, 'G3DSA:3.90.550.50:FF:000080', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(188732, NULL, 'G3DSA:2.110.10.10:FF:000051', NULL, NULL, 'Albumin-2', NULL, NULL, NULL, NULL, NULL, 4),
(188733, NULL, 'G3DSA:3.40.50.300:FF:007767', NULL, NULL, 'NF-X1 finger and helicase domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188734, NULL, 'G3DSA:3.40.50.300:FF:000404', NULL, NULL, 'Putative ras-related protein Rab-35', NULL, NULL, NULL, NULL, NULL, 4),
(188735, NULL, 'G3DSA:1.10.3720.10:FF:000117', NULL, NULL, 'ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(188736, NULL, 'G3DSA:3.30.1680.10:FF:000040', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(188737, NULL, 'G3DSA:1.10.8.80:FF:000004', NULL, NULL, 'Methanol dehydrogenase transcriptional regulator MoxR', NULL, NULL, NULL, NULL, NULL, 4),
(188738, NULL, 'G3DSA:3.10.20.90:FF:000139', NULL, NULL, 'ubiquitin-like protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(188739, NULL, 'G3DSA:1.10.510.10:FF:002362', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188740, NULL, 'G3DSA:2.130.10.10:FF:003990', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188741, NULL, 'G3DSA:1.10.472.80:FF:000236', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188742, NULL, 'G3DSA:2.60.40.1180:FF:000180', NULL, NULL, 'Alpha-L-arabinofuranosidase A', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(188743, NULL, 'G3DSA:1.10.590.10:FF:000006', NULL, NULL, 'Chorismate mutase 2', NULL, NULL, NULL, NULL, NULL, 4),
(188744, NULL, 'G3DSA:1.20.120.350:FF:000109', NULL, NULL, 'Calcium channel subunit Cch1', NULL, NULL, NULL, NULL, NULL, 4),
(188745, NULL, 'G3DSA:1.20.58.1040:FF:000023', NULL, NULL, '1,3-beta-glucanosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(188746, NULL, 'G3DSA:1.10.10.10:FF:001749', NULL, NULL, 'Probable D-xylose utilization operon transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(188747, NULL, 'G3DSA:1.10.8.10:FF:000248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188748, NULL, 'G3DSA:3.10.450.10:FF:000084', NULL, NULL, 'Cysteine proteinase inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(188749, NULL, 'G3DSA:1.20.58.70:FF:000005', NULL, NULL, 'syntaxin-5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(188750, NULL, 'G3DSA:1.10.150.80:FF:000016', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(188751, NULL, 'G3DSA:3.80.10.10:FF:003821', NULL, NULL, 'Si:ch211-213a13.5', NULL, NULL, NULL, NULL, NULL, 4),
(188752, NULL, 'G3DSA:1.10.540.10:FF:000060', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(188753, NULL, 'G3DSA:2.130.10.10:FF:005558', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188754, NULL, 'G3DSA:1.25.40.20:FF:000900', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188755, NULL, 'G3DSA:1.50.40.10:FF:000496', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188756, NULL, 'G3DSA:2.40.420.20:FF:000009', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(188757, NULL, 'G3DSA:1.25.10.10:FF:003279', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188758, NULL, 'G3DSA:3.90.780.10:FF:000017', NULL, NULL, 'SA0140 protein', NULL, NULL, NULL, NULL, NULL, 4),
(188759, NULL, 'G3DSA:1.20.1060.20:FF:000016', NULL, NULL, 'Structural maintenance of chromosomes protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(188760, NULL, 'G3DSA:1.10.510.10:FF:003896', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188761, NULL, 'G3DSA:3.40.30.10:FF:000407', NULL, NULL, 'Putative glutaredoxin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(188762, NULL, 'G3DSA:1.20.1330.10:FF:000006', NULL, NULL, 'Flagellar hook-associated protein FlgL', NULL, NULL, NULL, NULL, NULL, 4),
(188763, NULL, 'G3DSA:3.40.50.720:FF:001238', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(188764, NULL, 'G3DSA:3.30.70.330:FF:001605', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188765, NULL, 'G3DSA:1.20.144.10:FF:000041', NULL, NULL, 'Wunen-2, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(188766, NULL, 'G3DSA:2.102.10.10:FF:000046', NULL, NULL, 'Carbazole 1,9a-dioxygenase ferredoxin subunit', NULL, NULL, NULL, NULL, NULL, 4),
(188767, NULL, 'G3DSA:1.20.58.80:FF:000008', NULL, NULL, 'serine/threonine-protein kinase ULK3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(188768, NULL, 'G3DSA:3.60.21.10:FF:000374', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188769, NULL, 'G3DSA:3.40.50.12350:FF:000009', NULL, NULL, 'Eyes absent homolog', NULL, NULL, NULL, NULL, NULL, 4),
(188770, NULL, 'G3DSA:1.10.533.10:FF:000155', NULL, NULL, 'Zgc:194469', NULL, NULL, NULL, NULL, NULL, 4),
(188771, NULL, 'G3DSA:2.70.170.10:FF:000305', NULL, NULL, 'Protein CBG01074', NULL, NULL, NULL, NULL, NULL, 4),
(188772, NULL, 'G3DSA:1.20.58.390:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188773, NULL, 'G3DSA:3.20.20.70:FF:000616', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188774, NULL, 'G3DSA:3.40.1810.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188775, NULL, 'G3DSA:2.40.30.10:FF:000342', NULL, NULL, 'Elongation factor Tu', NULL, NULL, NULL, NULL, NULL, 4),
(188776, NULL, 'G3DSA:1.25.10.10:FF:002306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(188777, NULL, 'G3DSA:1.10.287.130:FF:000259', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(188778, NULL, 'G3DSA:3.30.200.20:FF:002306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188779, NULL, 'G3DSA:3.40.50.300:FF:008043', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188780, NULL, 'G3DSA:1.10.220.10:FF:000029', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(188781, NULL, 'G3DSA:2.130.10.10:FF:003198', NULL, NULL, 'Protein CFT1', NULL, NULL, NULL, NULL, NULL, 4),
(188782, NULL, 'G3DSA:3.40.50.300:FF:000943', NULL, NULL, 'Cellulose synthase operon protein YhjQ', NULL, NULL, NULL, NULL, NULL, 4),
(188783, NULL, 'G3DSA:2.60.40.10:FF:002713', NULL, NULL, 'Ephrin receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(188784, NULL, 'G3DSA:3.20.20.70:FF:000498', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188785, NULL, 'G3DSA:1.10.418.10:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188786, NULL, 'G3DSA:3.40.50.2300:FF:001458', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188787, NULL, 'G3DSA:3.10.105.10:FF:000086', NULL, NULL, 'Putative oligopeptide ABC transporter,substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(188788, NULL, 'G3DSA:3.40.50.300:FF:007868', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(188789, NULL, 'G3DSA:2.60.260.20:FF:000008', NULL, NULL, 'Curved DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(188790, NULL, 'G3DSA:3.40.50.10490:FF:000087', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188791, NULL, 'G3DSA:3.90.850.10:FF:000029', NULL, NULL, 'Fumarylacetoacetate hydrolase domain-containing protein 2A', NULL, NULL, NULL, NULL, NULL, 4),
(188792, NULL, 'G3DSA:2.60.40.150:FF:000480', NULL, NULL, 'Phosphatidylinositol 3-kinase VPS34', NULL, NULL, NULL, NULL, NULL, 4),
(188793, NULL, 'G3DSA:3.30.70.3190:FF:000002', NULL, NULL, 'tRNA pseudouridine(54/55) synthase', NULL, NULL, NULL, NULL, NULL, 4),
(188794, NULL, 'G3DSA:1.20.120.350:FF:000216', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188795, NULL, 'G3DSA:1.10.10.60:FF:000207', NULL, NULL, 'paired mesoderm homeobox protein 2A', NULL, NULL, NULL, NULL, NULL, 4),
(188796, NULL, 'G3DSA:1.25.40.10:FF:000335', NULL, NULL, 'Factor VIII intron 22 protein', NULL, NULL, NULL, NULL, NULL, 4),
(188797, NULL, 'G3DSA:2.40.150.20:FF:000016', NULL, NULL, 'Apicoplast ribosomal protein L14', NULL, NULL, NULL, NULL, NULL, 4),
(188798, NULL, 'G3DSA:3.40.1160.10:FF:000077', NULL, NULL, 'Uridylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(188799, NULL, 'G3DSA:1.10.472.130:FF:000041', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(188800, NULL, 'G3DSA:3.40.50.2000:FF:000969', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188801, NULL, 'G3DSA:1.20.5.340:FF:000113', NULL, NULL, 'Viral A-type inclusion protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188802, NULL, 'G3DSA:3.40.50.300:FF:004221', NULL, NULL, 'Bifunctional fructose-2,6-bisphosphate 2-phosphatase/6-phosphofructo-2-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(188803, NULL, 'G3DSA:3.20.20.140:FF:000265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188804, NULL, 'G3DSA:1.25.40.10:FF:003994', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188805, NULL, 'G3DSA:2.70.170.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188806, NULL, 'G3DSA:1.10.150.20:FF:000021', NULL, NULL, 'DNA-directed RNA polymerase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(188807, NULL, 'G3DSA:2.40.110.10:FF:000011', NULL, NULL, 'Acyl-CoA dehydrogenase FadE34', NULL, NULL, NULL, NULL, NULL, 4),
(188808, NULL, 'G3DSA:2.70.150.10:FF:000080', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(188809, NULL, 'G3DSA:2.30.30.140:FF:000257', NULL, NULL, 'SAGA-associated factor 29', NULL, NULL, NULL, NULL, NULL, 4),
(188810, NULL, 'G3DSA:3.30.1490.10:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(188811, NULL, 'G3DSA:3.30.830.10:FF:000322', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188812, NULL, 'G3DSA:2.130.10.10:FF:000544', NULL, NULL, 'cleavage and polyadenylation specificity factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(188813, NULL, 'G3DSA:3.10.100.10:FF:000120', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188814, NULL, 'G3DSA:3.80.10.10:FF:001135', NULL, NULL, 'Leucine Rich Repeat family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(188815, NULL, 'G3DSA:3.30.930.10:FF:000369', NULL, NULL, 'Glycyl tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(188816, NULL, 'G3DSA:3.30.70.3400:FF:000015', NULL, NULL, 'Protein-export membrane protein SecD', NULL, NULL, NULL, NULL, NULL, 4),
(188817, NULL, 'G3DSA:4.10.280.10:FF:000067', NULL, NULL, 'upstream stimulatory factor 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(188818, NULL, 'G3DSA:3.40.50.300:FF:002074', NULL, NULL, 'Elongator acetyltransferase complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(188819, NULL, 'G3DSA:2.60.120.620:FF:000068', NULL, NULL, 'Procollagen-lysine, 2-oxoglutarate 5-dioxygenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(188820, NULL, 'G3DSA:2.40.160.120:FF:000021', NULL, NULL, 'Unplaced genomic scaffold supercont2.12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(188821, NULL, 'G3DSA:1.20.890.10:FF:000004', NULL, NULL, 'ropporin-1-like protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(188822, NULL, 'G3DSA:3.30.160.60:FF:002146', NULL, NULL, 'zinc finger protein 596-like', NULL, NULL, NULL, NULL, NULL, 4),
(188823, NULL, 'G3DSA:3.30.40.10:FF:001386', NULL, NULL, 'RUM1', NULL, NULL, NULL, NULL, NULL, 4),
(188824, NULL, 'G3DSA:1.20.50.20:FF:000006', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(188825, NULL, 'G3DSA:1.10.20.10:FF:000272', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188826, NULL, 'G3DSA:2.40.10.10:FF:000127', NULL, NULL, 'Probable threonine protease PRSS50', NULL, NULL, NULL, NULL, NULL, 4),
(188827, NULL, 'G3DSA:1.10.510.10:FF:002036', NULL, NULL, 'Gliding motility related CaM kinase', NULL, NULL, NULL, NULL, NULL, 4),
(188828, NULL, 'G3DSA:3.10.20.90:FF:000920', NULL, NULL, 'Histidine ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(188829, NULL, 'G3DSA:1.20.1440.200:FF:000009', NULL, NULL, 'Vacuolar protein sorting-associated protein 28 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(188830, NULL, 'G3DSA:3.40.1390.10:FF:000004', NULL, NULL, 'UDP-N-acetylmuramoyl-tripeptide--D-alanyl-D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(188831, NULL, 'G3DSA:3.40.640.10:FF:000440', NULL, NULL, 'Perosamine synthetase-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(188832, NULL, 'G3DSA:3.40.50.2300:FF:001565', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188833, NULL, 'G3DSA:3.30.40.10:FF:001493', NULL, NULL, 'Zinc finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188834, NULL, 'G3DSA:3.40.50.1820:FF:001292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188835, NULL, 'G3DSA:2.40.40.20:FF:000065', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(188836, NULL, 'G3DSA:3.30.160.40:FF:000004', NULL, NULL, 'Porphobilinogen deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(188837, NULL, 'G3DSA:3.30.160.60:FF:002253', NULL, NULL, 'Zinc finger protein 334', NULL, NULL, NULL, NULL, NULL, 4),
(188838, NULL, 'G3DSA:3.30.70.890:FF:000008', NULL, NULL, 'L-arabinokinase', NULL, NULL, NULL, NULL, NULL, 4),
(188839, NULL, 'G3DSA:2.30.33.40:FF:000015', NULL, NULL, '10 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(188840, NULL, 'G3DSA:2.130.10.10:FF:003877', NULL, NULL, 'WD repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188841, NULL, 'G3DSA:2.60.40.10:FF:002820', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(188842, NULL, 'G3DSA:3.40.140.10:FF:000200', NULL, NULL, 'Cytidine deaminase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(188843, NULL, 'G3DSA:1.10.418.10:FF:000073', NULL, NULL, 'Kinesin-like protein KIN-14L', NULL, NULL, NULL, NULL, NULL, 4),
(188844, NULL, 'G3DSA:1.10.1200.10:FF:000073', NULL, NULL, 'Yersiniabactin polyketide/non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(188845, NULL, 'G3DSA:1.20.5.350:FF:000009', NULL, NULL, 'Troponin T, slow skeletal muscle', NULL, NULL, NULL, NULL, NULL, 4),
(188846, NULL, 'G3DSA:3.30.70.330:FF:001375', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(188847, NULL, 'G3DSA:2.130.10.10:FF:000437', NULL, NULL, 'cleavage and polyadenylation specificity factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(188848, NULL, 'G3DSA:1.20.1250.20:FF:001245', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188849, NULL, 'G3DSA:2.40.170.20:FF:000118', NULL, NULL, 'SusC homolog', NULL, NULL, NULL, NULL, NULL, 4),
(188850, NULL, 'G3DSA:1.25.40.10:FF:001858', NULL, NULL, 'TPR_repeat/Tetratricopeptide_repeat/Uncharacterized_protein_family_(UPF0121)_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(188851, NULL, 'G3DSA:3.90.550.10:FF:000085', NULL, NULL, 'Glycogenin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(188852, NULL, 'G3DSA:1.20.58.390:FF:000212', NULL, NULL, 'Nicotinic acetylcholine receptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(188853, NULL, 'G3DSA:3.90.470.20:FF:000036', NULL, NULL, 'Lipopeptide antibiotics iturin a biosynthesisprotein', NULL, NULL, NULL, NULL, NULL, 4),
(188854, NULL, 'G3DSA:3.30.70.870:FF:000002', NULL, NULL, 'Translation elongation factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(188855, NULL, 'G3DSA:1.20.5.340:FF:000006', NULL, NULL, 'Myosin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(188856, NULL, 'G3DSA:1.10.510.10:FF:002822', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188857, NULL, 'G3DSA:2.10.90.10:FF:000156', NULL, NULL, 'Glycoprotein hormone beta, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188858, NULL, 'G3DSA:3.40.50.300:FF:006345', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188859, NULL, 'G3DSA:3.10.20.90:FF:000134', NULL, NULL, 'UBX domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(188860, NULL, 'G3DSA:3.90.980.20:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188861, NULL, 'G3DSA:3.80.10.10:FF:002765', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188862, NULL, 'G3DSA:1.10.730.10:FF:000107', NULL, NULL, 'Protein CBG19783', NULL, NULL, NULL, NULL, NULL, 4),
(188863, NULL, 'G3DSA:3.10.450.10:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188864, NULL, 'G3DSA:3.40.720.10:FF:000278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188865, NULL, 'G3DSA:1.10.287.110:FF:000472', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188866, NULL, 'G3DSA:3.40.50.2300:FF:000042', NULL, NULL, 'Metabotropic glutamate receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(188867, NULL, 'G3DSA:3.30.40.10:FF:001504', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188868, NULL, 'G3DSA:3.40.50.300:FF:003597', NULL, NULL, 'UMP-CMP kinase, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188869, NULL, 'G3DSA:3.40.50.300:FF:006238', NULL, NULL, 'Myb domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(188870, NULL, 'G3DSA:1.10.533.10:FF:000256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188871, NULL, 'G3DSA:2.60.120.10:FF:000760', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188872, NULL, 'G3DSA:3.20.20.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188873, NULL, 'G3DSA:3.80.10.10:FF:002658', NULL, NULL, 'MDIS1-interacting receptor like kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(188874, NULL, 'G3DSA:3.40.630.30:FF:000165', NULL, NULL, 'IAA acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(188875, NULL, 'G3DSA:3.40.50.720:FF:001019', NULL, NULL, '2-hydroxyacid dehydrogenase family protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(188876, NULL, 'G3DSA:3.40.50.720:FF:001805', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188877, NULL, 'G3DSA:1.10.1450.10:FF:000107', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(188878, NULL, 'G3DSA:1.10.510.10:FF:002143', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(188879, NULL, 'G3DSA:2.30.180.10:FF:000006', NULL, NULL, 'Fasciclin-like arabinogalactan protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(188880, NULL, 'G3DSA:2.120.10.30:FF:000062', NULL, NULL, 'NHL repeat containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(188881, NULL, 'G3DSA:1.25.40.10:FF:001639', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(188882, NULL, 'G3DSA:1.20.140.90:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188883, NULL, 'G3DSA:3.40.50.2020:FF:000065', NULL, NULL, 'Ribose-phosphate pyrophosphokinase putative', NULL, NULL, NULL, NULL, NULL, 4),
(188884, NULL, 'G3DSA:3.30.40.10:FF:000200', NULL, NULL, 'Lysine-specific demethylase 5B', NULL, NULL, NULL, NULL, NULL, 4),
(188885, NULL, 'G3DSA:1.10.555.10:FF:000094', NULL, NULL, 'RhoGAP domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(188886, NULL, 'G3DSA:3.40.50.1820:FF:001185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188887, NULL, 'G3DSA:3.40.50.1820:FF:001073', NULL, NULL, 'Endo-1,4-beta-xylanase Y', NULL, NULL, NULL, NULL, NULL, 4),
(188888, NULL, 'G3DSA:2.30.180.10:FF:000118', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188889, NULL, 'G3DSA:3.80.10.10:FF:001461', NULL, NULL, 'Leucine-rich repeat-containing protein 49', NULL, NULL, NULL, NULL, NULL, 4),
(188890, NULL, 'G3DSA:2.60.40.10:FF:004063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188891, NULL, 'G3DSA:3.10.50.40:FF:000087', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(188892, NULL, 'G3DSA:1.20.58.390:FF:000094', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(188893, NULL, 'G3DSA:3.10.25.10:FF:000008', NULL, NULL, 'Putative methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(188894, NULL, 'G3DSA:1.20.1330.10:FF:000001', NULL, NULL, 'Flagellin', NULL, NULL, NULL, NULL, NULL, 4),
(188895, NULL, 'G3DSA:2.100.10.30:FF:000006', NULL, NULL, 'Prostatic spermine-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(188896, NULL, 'G3DSA:2.40.10.10:FF:000346', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188897, NULL, 'G3DSA:2.60.120.330:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188898, NULL, 'G3DSA:2.40.10.10:FF:000234', NULL, NULL, 'Coagulation factor VIIi', NULL, NULL, NULL, NULL, NULL, 4),
(188899, NULL, 'G3DSA:3.30.1300.10:FF:000006', NULL, NULL, 'Pantoate--beta-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(188900, NULL, 'G3DSA:1.10.269.10:FF:000001', NULL, NULL, 'DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(188901, NULL, 'G3DSA:3.30.70.330:FF:001268', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(188902, NULL, 'G3DSA:2.20.28.10:FF:000028', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(188903, NULL, 'G3DSA:1.10.510.10:FF:000905', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(188904, NULL, 'G3DSA:3.30.70.330:FF:001156', NULL, NULL, 'U2 snRNP auxiliary factor small subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188905, NULL, 'G3DSA:3.30.210.10:FF:000005', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(188906, NULL, 'G3DSA:2.60.120.10:FF:000541', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188907, NULL, 'G3DSA:1.20.1000.10:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188908, NULL, 'G3DSA:3.30.310.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188909, NULL, 'G3DSA:3.30.160.60:FF:002472', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(188910, NULL, 'G3DSA:1.10.220.100:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188911, NULL, 'G3DSA:2.30.39.10:FF:000076', NULL, NULL, 'Serine protease inhibitor (SERPIN) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(188912, NULL, 'G3DSA:1.20.1070.10:FF:001144', NULL, NULL, 'Probable G-protein coupled receptor C06G4.5', NULL, NULL, NULL, NULL, NULL, 4),
(188913, NULL, 'G3DSA:2.60.120.560:FF:000033', NULL, NULL, 'Putative galactocerebrosidase', NULL, NULL, NULL, NULL, NULL, 4),
(188914, NULL, 'G3DSA:3.40.50.920:FF:000005', NULL, NULL, 'Pyruvate dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(188915, NULL, 'G3DSA:2.60.120.470:FF:000006', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(188916, NULL, 'G3DSA:2.60.40.1180:FF:000185', NULL, NULL, 'Glycoside hydrolase family 13 protein', NULL, NULL, NULL, NULL, NULL, 4),
(188917, NULL, 'G3DSA:2.60.40.1170:FF:000070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188918, NULL, 'G3DSA:3.40.1110.10:FF:000473', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188919, NULL, 'G3DSA:1.10.10.60:FF:000314', NULL, NULL, 'Small nuclear RNA-activating complex, polypeptide 4', NULL, NULL, NULL, NULL, NULL, 4),
(188920, NULL, 'G3DSA:1.10.10.60:FF:000533', NULL, NULL, 'Homeobox-leucine zipper protein ATHB-52', NULL, NULL, NULL, NULL, NULL, 4),
(188921, NULL, 'G3DSA:2.80.10.50:FF:000233', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(188922, NULL, 'G3DSA:2.10.25.160:FF:000004', NULL, NULL, 'Granulin precursor', NULL, NULL, NULL, NULL, NULL, 4),
(188923, NULL, 'G3DSA:2.60.40.1180:FF:000073', NULL, NULL, 'Alpha-amylase', NULL, NULL, NULL, NULL, NULL, 4),
(188924, NULL, 'G3DSA:3.40.630.10:FF:000052', NULL, NULL, 'Amidohydrolase amhX', NULL, NULL, NULL, NULL, NULL, 4),
(188925, NULL, 'G3DSA:1.20.58.60:FF:000587', NULL, NULL, 'Plectin', NULL, NULL, NULL, NULL, NULL, 4),
(188926, NULL, 'G3DSA:2.30.29.30:FF:000587', NULL, NULL, 'FERM domain (Protein4.1-ezrin-radixin-moesin) family', NULL, NULL, NULL, NULL, NULL, 4),
(188927, NULL, 'G3DSA:2.10.25.10:FF:000983', NULL, NULL, 'Eyes shut, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(188928, NULL, 'G3DSA:1.25.40.10:FF:000228', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(188929, NULL, 'G3DSA:3.30.1320.10:FF:000013', NULL, NULL, 'Mitochondrial ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(188930, NULL, 'G3DSA:1.20.1370.10:FF:000003', NULL, NULL, 'Larval serum protein 1 gamma', NULL, NULL, NULL, NULL, NULL, 4),
(188931, NULL, 'G3DSA:3.40.1360.10:FF:000058', NULL, NULL, 'Zinc finger CHC2-family protein', NULL, NULL, NULL, NULL, NULL, 4),
(188932, NULL, 'G3DSA:3.20.20.70:FF:000279', NULL, NULL, 'tRNA-dihydrouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(188933, NULL, 'G3DSA:3.40.640.10:FF:000114', NULL, NULL, 'Transcriptional regulator, GntR family', NULL, NULL, NULL, NULL, NULL, 4),
(188934, NULL, 'G3DSA:3.10.20.70:FF:000021', NULL, NULL, 'L-glutamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(188935, NULL, 'G3DSA:1.25.40.10:FF:000009', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(188936, NULL, 'G3DSA:1.20.5.110:FF:000168', NULL, NULL, 'Ehsyntaxin 1B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188937, NULL, 'G3DSA:3.30.70.330:FF:000071', NULL, NULL, 'heterogeneous nuclear ribonucleoprotein H isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(188938, NULL, 'G3DSA:3.40.1550.20:FF:000003', NULL, NULL, 'Transcriptional regulator MraZ', NULL, NULL, NULL, NULL, NULL, 4),
(188939, NULL, 'G3DSA:3.40.50.150:FF:000651', NULL, NULL, 'Mycinamicin VI 2''''-O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(188940, NULL, 'G3DSA:3.40.50.300:FF:000724', NULL, NULL, 'F-box DNA helicase 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(188941, NULL, 'G3DSA:3.20.20.70:FF:000509', NULL, NULL, 'Biotin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(188942, NULL, 'G3DSA:3.30.1370.10:FF:000050', NULL, NULL, 'vigilin isoform X1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(188943, NULL, 'G3DSA:3.30.2320.80:FF:000006', NULL, NULL, 'Hydrogenase maturation factor HypA 1', NULL, NULL, NULL, NULL, NULL, 4),
(188944, NULL, 'G3DSA:4.10.1240.10:FF:000084', NULL, NULL, 'C1A receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188945, NULL, 'G3DSA:2.40.30.220:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188946, NULL, 'G3DSA:3.40.720.10:FF:000166', NULL, NULL, 'Type I phosphodiesterase/nucleotide pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(188947, NULL, 'G3DSA:1.25.10.10:FF:000507', NULL, NULL, 'Exportin-2', NULL, NULL, NULL, NULL, NULL, 4),
(188948, NULL, 'G3DSA:2.160.20.10:FF:000010', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(188949, NULL, 'G3DSA:2.130.10.10:FF:004041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188950, NULL, 'G3DSA:1.10.3730.20:FF:000060', NULL, NULL, 'solute carrier family 35 member G1-like', NULL, NULL, NULL, NULL, NULL, 4),
(188951, NULL, 'G3DSA:1.25.50.20:FF:000064', NULL, NULL, 'Peptidase family m1 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188952, NULL, 'G3DSA:3.10.120.10:FF:000003', NULL, NULL, 'membrane-associated progesterone receptor component 1', NULL, NULL, NULL, NULL, NULL, 4),
(188953, NULL, 'G3DSA:1.20.1110.10:FF:000243', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(188954, NULL, 'G3DSA:2.40.30.230:FF:000006', NULL, NULL, 'Unplaced genomic scaffold supercont2.5, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(188955, NULL, 'G3DSA:1.20.140.40:FF:000024', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(188956, NULL, 'G3DSA:2.130.10.10:FF:000325', NULL, NULL, 'TAF5-like RNA polymerase II p300/CBP-associated factor-associated factor 65 kDa subunit 5L', NULL, NULL, NULL, NULL, NULL, 4),
(188957, NULL, 'G3DSA:1.25.40.10:FF:002252', NULL, NULL, 'TPR repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188958, NULL, 'G3DSA:3.30.70.330:FF:002898', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188959, NULL, 'G3DSA:2.60.40.10:FF:005693', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188960, NULL, 'G3DSA:3.40.50.300:FF:004440', NULL, NULL, 'tRNA (Adenosine(37)-N6)-threonylcarbamoyltransferase complex ATPase subunit type 1 TsaE', NULL, NULL, NULL, NULL, NULL, 4),
(188961, NULL, 'G3DSA:1.20.120.1760:FF:000067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188962, NULL, 'G3DSA:3.20.20.140:FF:000484', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188963, NULL, 'G3DSA:3.30.200.20:FF:001924', NULL, NULL, 'Receptor-like protein kinase FERONIA', NULL, NULL, NULL, NULL, NULL, 4),
(188964, NULL, 'G3DSA:1.10.240.10:FF:000025', NULL, NULL, 'Tryptophanyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(188965, NULL, 'G3DSA:2.60.120.920:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188966, NULL, 'G3DSA:3.40.50.10330:FF:000067', NULL, NULL, 'Ceramide kinase-like isoform 12', NULL, NULL, NULL, NULL, NULL, 4),
(188967, NULL, 'G3DSA:1.20.1270.280:FF:000016', NULL, NULL, 'Dynein beta chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188968, NULL, 'G3DSA:2.10.220.10:FF:000150', NULL, NULL, 'R-spondin-3', NULL, NULL, NULL, NULL, NULL, 4),
(188969, NULL, 'G3DSA:2.130.10.10:FF:002910', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188970, NULL, 'G3DSA:1.20.1250.20:FF:001464', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188971, NULL, 'G3DSA:3.80.10.10:FF:002877', NULL, NULL, 'Septation initiation network scaffold protein cdc11', NULL, NULL, NULL, NULL, NULL, 4),
(188972, NULL, 'G3DSA:3.60.21.10:FF:000150', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(188973, NULL, 'G3DSA:1.20.1070.10:FF:001363', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188974, NULL, 'G3DSA:3.10.20.30:FF:000037', NULL, NULL, 'YGR210C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(188975, NULL, 'G3DSA:1.25.40.1030:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(188976, NULL, 'G3DSA:3.30.160.60:FF:005693', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188977, NULL, 'G3DSA:3.30.160.60:FF:003669', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188978, NULL, 'G3DSA:2.10.25.10:FF:001702', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(188979, NULL, 'G3DSA:4.10.640.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188980, NULL, 'G3DSA:3.40.50.300:FF:006126', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(188981, NULL, 'G3DSA:2.60.40.60:FF:000008', NULL, NULL, 'Cadherin 24', NULL, NULL, NULL, NULL, NULL, 4),
(188982, NULL, 'G3DSA:3.80.10.10:FF:003501', NULL, NULL, 'Protein phosphatase 1 regulatory subunit SDS22 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(188983, NULL, 'G3DSA:1.10.510.10:FF:002255', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(188984, NULL, 'G3DSA:1.10.3090.10:FF:000035', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188985, NULL, 'G3DSA:2.60.120.380:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188986, NULL, 'G3DSA:3.50.50.60:FF:001479', NULL, NULL, 'Rab GDP dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(188987, NULL, 'G3DSA:3.10.20.690:FF:000004', NULL, NULL, 'DNA gyrase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(188988, NULL, 'G3DSA:3.30.200.20:FF:001587', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188989, NULL, 'G3DSA:3.10.20.90:FF:000701', NULL, NULL, 'Myosin-G heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(188990, NULL, 'G3DSA:3.20.20.70:FF:000386', NULL, NULL, 'Mutator MutT protein', NULL, NULL, NULL, NULL, NULL, 4),
(188991, NULL, 'G3DSA:2.40.50.140:FF:000410', NULL, NULL, 'CST complex subunit TEN1', NULL, NULL, NULL, NULL, NULL, 4),
(188992, NULL, 'G3DSA:1.20.1070.10:FF:000981', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(188993, NULL, 'G3DSA:3.40.605.10:FF:000090', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(188994, NULL, 'G3DSA:1.25.10.10:FF:002076', NULL, NULL, 'PIKK family atypical protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(188995, NULL, 'G3DSA:3.40.50.1240:FF:000027', NULL, NULL, '3-phytase A', NULL, NULL, NULL, NULL, NULL, 4),
(188996, NULL, 'G3DSA:2.60.40.60:FF:000901', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(188997, NULL, 'G3DSA:3.40.630.30:FF:000384', NULL, NULL, 'N-acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(188998, NULL, 'G3DSA:1.10.510.10:FF:001979', NULL, NULL, 'Receptor protein kinase TMK1', NULL, NULL, NULL, NULL, NULL, 4),
(188999, NULL, 'G3DSA:3.40.50.300:FF:005856', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189000, NULL, 'G3DSA:3.20.20.80:FF:000389', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189001, NULL, 'G3DSA:2.40.160.10:FF:000053', NULL, NULL, 'Porin', NULL, NULL, NULL, NULL, NULL, 4),
(189002, NULL, 'G3DSA:1.10.510.10:FF:002603', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189003, NULL, 'G3DSA:1.10.238.10:FF:000205', NULL, NULL, 'calcineurin B homologous protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(189004, NULL, 'G3DSA:3.40.1350.10:FF:000007', NULL, NULL, 'tRNA-splicing endonuclease subunit Sen2', NULL, NULL, NULL, NULL, NULL, 4),
(189005, NULL, 'G3DSA:1.10.1420.10:FF:000049', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(189006, NULL, 'G3DSA:1.10.510.10:FF:003778', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189007, NULL, 'G3DSA:3.10.270.10:FF:000008', NULL, NULL, 'Uricase', NULL, NULL, NULL, NULL, NULL, 4),
(189008, NULL, 'G3DSA:3.60.21.10:FF:000043', NULL, NULL, 'Ser/Thr protein phosphatase family', NULL, NULL, NULL, NULL, NULL, 4),
(189009, NULL, 'G3DSA:1.25.10.10:FF:002424', NULL, NULL, 'Sister chromatid cohesion protein mis4', NULL, NULL, NULL, NULL, NULL, 4),
(189010, NULL, 'G3DSA:2.60.40.60:FF:000553', NULL, NULL, 'cadherin EGF LAG seven-pass G-type receptor 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(189011, NULL, 'G3DSA:1.10.560.10:FF:000061', NULL, NULL, '60 kDa chaperonin GROEL', NULL, NULL, NULL, NULL, NULL, 4),
(189012, NULL, 'G3DSA:2.60.40.790:FF:000104', NULL, NULL, 'PTGES3L isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(189013, NULL, 'G3DSA:1.10.555.10:FF:000099', NULL, NULL, 'T-cell activation Rho GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(189014, NULL, 'G3DSA:3.20.20.140:FF:000377', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189015, NULL, 'G3DSA:1.10.510.10:FF:004402', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189016, NULL, 'G3DSA:2.70.150.10:FF:000192', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(189017, NULL, 'G3DSA:2.60.40.10:FF:004400', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189018, NULL, 'G3DSA:1.25.40.10:FF:003882', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189019, NULL, 'G3DSA:1.10.287.890:FF:000003', NULL, NULL, 'Adenylate isopentenyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(189020, NULL, 'G3DSA:3.40.50.12350:FF:000010', NULL, NULL, 'Eyes absent homolog', NULL, NULL, NULL, NULL, NULL, 4),
(189021, NULL, 'G3DSA:3.70.10.10:FF:000034', NULL, NULL, 'Checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(189022, NULL, 'G3DSA:1.20.1250.20:FF:001801', NULL, NULL, 'Solute carrier family 22 member 12', NULL, NULL, NULL, NULL, NULL, 4),
(189023, NULL, 'G3DSA:3.40.50.300:FF:002186', NULL, NULL, 'Chromatin structure-remodeling complex subunit snf21', NULL, NULL, NULL, NULL, NULL, 4),
(189024, NULL, 'G3DSA:3.40.50.1820:FF:001180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189025, NULL, 'G3DSA:3.40.50.300:FF:002860', NULL, NULL, 'Rab32/ GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(189026, NULL, 'G3DSA:1.20.1000.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189027, NULL, 'G3DSA:3.30.420.40:FF:000047', NULL, NULL, 'Actin-like protein 6A', NULL, NULL, NULL, NULL, NULL, 4),
(189028, NULL, 'G3DSA:3.40.30.10:FF:000963', NULL, NULL, 'Uncharacterized protein C1840.08c', NULL, NULL, NULL, NULL, NULL, 4),
(189029, NULL, 'G3DSA:3.30.160.60:FF:000903', NULL, NULL, 'Tripartite motif-containing protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(189030, NULL, 'G3DSA:3.40.50.360:FF:000158', NULL, NULL, 'AGAP000500-PA', NULL, NULL, NULL, NULL, NULL, 4),
(189031, NULL, 'G3DSA:1.20.1300.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189032, NULL, 'G3DSA:3.30.160.60:FF:000229', NULL, NULL, 'Zinc finger protein 90 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(189033, NULL, 'G3DSA:1.10.220.10:FF:000030', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(189034, NULL, 'G3DSA:1.10.8.10:FF:000366', NULL, NULL, 'Protein CBG07636', NULL, NULL, NULL, NULL, NULL, 4),
(189035, NULL, 'G3DSA:2.60.40.150:FF:000603', NULL, NULL, 'Zgc:158659', NULL, NULL, NULL, NULL, NULL, 4),
(189036, NULL, 'G3DSA:2.60.40.10:FF:004282', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189037, NULL, 'G3DSA:2.30.29.30:FF:001188', NULL, NULL, 'Uncharacterized PH domain-containing protein PB16A4.02c', NULL, NULL, NULL, NULL, NULL, 4),
(189038, NULL, 'G3DSA:3.90.190.10:FF:000568', NULL, NULL, 'Tyrosine specific protein phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(189039, NULL, 'G3DSA:3.90.230.10:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189040, NULL, 'G3DSA:2.130.10.10:FF:002461', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189041, NULL, 'G3DSA:3.30.60.30:FF:000078', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189042, NULL, 'G3DSA:3.90.1420.10:FF:000030', NULL, NULL, 'Protein CBR-SET-27', NULL, NULL, NULL, NULL, NULL, 4),
(189043, NULL, 'G3DSA:3.30.540.10:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189044, NULL, 'G3DSA:3.30.420.100:FF:000014', NULL, NULL, 'Ribosomal protein L5', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(189045, NULL, 'G3DSA:1.10.287.1490:FF:000049', NULL, NULL, 'Cingulin', NULL, NULL, NULL, NULL, NULL, 4),
(189046, NULL, 'G3DSA:3.10.20.90:FF:000027', NULL, NULL, 'Ras association (RalGDS/AF-6) and pleckstrin homology domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(189047, NULL, 'G3DSA:1.20.5.730:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189048, NULL, 'G3DSA:3.40.50.2300:FF:001239', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189049, NULL, 'G3DSA:3.30.420.110:FF:000017', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(189050, NULL, 'G3DSA:1.25.40.20:FF:000905', NULL, NULL, 'Ankyrin repeat and SOCS box protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(189051, NULL, 'G3DSA:1.25.40.20:FF:000119', NULL, NULL, 'Ankyrin repeat and SOCS box containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(189052, NULL, 'G3DSA:3.30.70.980:FF:000035', NULL, NULL, 'WGS project CABT00000000 data, contig 2.5', NULL, NULL, NULL, NULL, NULL, 4),
(189053, NULL, 'G3DSA:1.20.1070.10:FF:001251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189054, NULL, 'G3DSA:2.130.10.10:FF:005457', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189055, NULL, 'G3DSA:3.40.50.300:FF:000387', NULL, NULL, 'neuronal-specific septin-3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(189056, NULL, 'G3DSA:3.30.40.10:FF:001942', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189057, NULL, 'G3DSA:1.10.510.10:FF:004060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189058, NULL, 'G3DSA:3.30.70.3000:FF:000002', NULL, NULL, 'tRNA(His) guanylyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(189059, NULL, 'G3DSA:3.40.630.30:FF:000058', NULL, NULL, 'N-acetyltransferase (Nat5)', NULL, NULL, NULL, NULL, NULL, 4),
(189060, NULL, 'G3DSA:2.10.90.10:FF:000049', NULL, NULL, 'Glycoprotein hormone alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(189061, NULL, 'G3DSA:2.60.40.1260:FF:000001', NULL, NULL, 'Lamin A/C', NULL, NULL, NULL, NULL, NULL, 4),
(189062, NULL, 'G3DSA:3.40.1000.10:FF:000026', NULL, NULL, 'RGM domain family, member B, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(189063, NULL, 'G3DSA:2.130.10.10:FF:000106', NULL, NULL, 'WD repeat domain 24', NULL, NULL, NULL, NULL, NULL, 4),
(189064, NULL, 'G3DSA:2.40.30.10:FF:000241', NULL, NULL, 'Elongation factor Tu', NULL, NULL, NULL, NULL, NULL, 4),
(189065, NULL, 'G3DSA:3.20.20.70:FF:000728', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189066, NULL, 'G3DSA:1.20.58.390:FF:000105', NULL, NULL, 'AcetylCholine Receptor', NULL, NULL, NULL, NULL, NULL, 4),
(189067, NULL, 'G3DSA:3.90.1600.10:FF:000021', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(189068, NULL, 'G3DSA:3.30.200.20:FF:001929', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189069, NULL, 'G3DSA:1.25.70.10:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189070, NULL, 'G3DSA:2.30.42.10:FF:000100', NULL, NULL, 'Shroom family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(189071, NULL, 'G3DSA:3.30.200.20:FF:001705', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189072, NULL, 'G3DSA:1.25.40.20:FF:000557', NULL, NULL, 'Os07g0193200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(189073, NULL, 'G3DSA:2.30.30.40:FF:000211', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(189074, NULL, 'G3DSA:3.30.1330.30:FF:000059', NULL, NULL, 'Protein pelota homolog', NULL, NULL, NULL, NULL, NULL, 4),
(189075, NULL, 'G3DSA:3.60.21.60:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189076, NULL, 'G3DSA:2.130.10.10:FF:002242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189077, NULL, 'G3DSA:3.30.200.20:FF:000401', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase SD1-29', NULL, NULL, NULL, NULL, NULL, 4),
(189078, NULL, 'G3DSA:3.30.420.40:FF:000614', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(189079, NULL, 'G3DSA:2.10.110.10:FF:000040', NULL, NULL, 'LIM homeobox transcription factor 1 beta', NULL, NULL, NULL, NULL, NULL, 4),
(189080, NULL, 'G3DSA:2.60.40.10:FF:006075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189081, NULL, 'G3DSA:3.90.70.10:FF:000430', NULL, NULL, 'Cysteine protease XCP1', NULL, NULL, NULL, NULL, NULL, 4),
(189082, NULL, 'G3DSA:3.40.50.300:FF:002293', NULL, NULL, 'Putative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(189083, NULL, 'G3DSA:3.60.21.50:FF:000026', NULL, NULL, 'Polymerase (DNA directed), delta 2, accessory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(189084, NULL, 'G3DSA:3.30.1490.120:FF:000027', NULL, NULL, 'Putative DNA-directed RNA polymerase III subunit', NULL, NULL, NULL, NULL, NULL, 4),
(189085, NULL, 'G3DSA:3.40.50.300:FF:000505', NULL, NULL, 'Gluconokinase', NULL, NULL, NULL, NULL, NULL, 4),
(189086, NULL, 'G3DSA:1.25.40.10:FF:004051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189087, NULL, 'G3DSA:3.40.50.300:FF:006019', NULL, NULL, 'Si:ch211-108d22.2', NULL, NULL, NULL, NULL, NULL, 4),
(189088, NULL, 'G3DSA:3.40.50.300:FF:002641', NULL, NULL, 'MAK5p nucleolar protein', NULL, NULL, NULL, NULL, NULL, 4),
(189089, NULL, 'G3DSA:3.40.50.1100:FF:000132', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189090, NULL, 'G3DSA:1.50.40.10:FF:000159', NULL, NULL, 'solute carrier family 25 member 39 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(189091, NULL, 'G3DSA:3.40.50.1820:FF:001303', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(189092, NULL, 'G3DSA:1.20.5.1230:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189093, NULL, 'G3DSA:3.20.20.60:FF:000057', NULL, NULL, 'Pyruvate kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(189094, NULL, 'G3DSA:3.30.750.24:FF:000014', NULL, NULL, 'Testis anion transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(189095, NULL, 'G3DSA:2.60.40.60:FF:000334', NULL, NULL, 'Protocadherin-related 15b', NULL, NULL, NULL, NULL, NULL, 4),
(189096, NULL, 'G3DSA:3.30.1330.20:FF:000056', NULL, NULL, 'Tubulin beta-7 chain', NULL, NULL, NULL, NULL, NULL, 4),
(189097, NULL, 'G3DSA:1.25.40.10:FF:003775', NULL, NULL, 'Tetratricopeptide repeat protein 36 homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(189098, NULL, 'G3DSA:3.30.160.60:FF:003995', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189099, NULL, 'G3DSA:3.30.530.20:FF:000162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189100, NULL, 'G3DSA:1.10.533.10:FF:000037', NULL, NULL, 'Receptor-interacting serine/threonine-protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(189101, NULL, 'G3DSA:1.10.260.50:FF:000004', NULL, NULL, 'Cysteine desulfurase/ selenocysteine lyase', NULL, NULL, NULL, NULL, NULL, 4),
(189102, NULL, 'G3DSA:2.40.50.690:FF:000002', NULL, NULL, 'exosome complex exonuclease RRP44 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(189103, NULL, 'G3DSA:2.10.50.10:FF:000047', NULL, NULL, 'Thyroglobulin', NULL, NULL, NULL, NULL, NULL, 4),
(189104, NULL, 'G3DSA:3.30.1140.60:FF:000014', NULL, NULL, 'F-actin-capping protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(189105, NULL, 'G3DSA:3.30.870.10:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189106, NULL, 'G3DSA:3.40.30.10:FF:000744', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189107, NULL, 'G3DSA:1.10.10.580:FF:000011', NULL, NULL, 'Cohesin complex subunit SCC1', NULL, NULL, NULL, NULL, NULL, 4),
(189108, NULL, 'G3DSA:3.60.40.10:FF:000295', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189109, NULL, 'G3DSA:1.10.510.10:FF:003559', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189110, NULL, 'G3DSA:1.50.40.10:FF:000507', NULL, NULL, 'Solute carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(189111, NULL, 'G3DSA:1.10.3080.10:FF:000091', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(189112, NULL, 'G3DSA:2.60.40.10:FF:005586', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(189113, NULL, 'G3DSA:1.10.8.1310:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189114, NULL, 'G3DSA:1.10.1140.10:FF:000011', NULL, NULL, 'V-type ATP synthase alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(189115, NULL, 'G3DSA:2.30.29.30:FF:000699', NULL, NULL, 'Serine/threonine-protein kinase dkf-2', NULL, NULL, NULL, NULL, NULL, 4),
(189116, NULL, 'G3DSA:1.10.620.20:FF:000001', NULL, NULL, 'Ribonucleoside-diphosphate reductase 1 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(189117, NULL, 'G3DSA:1.25.40.10:FF:000116', NULL, NULL, 'General transcription factor 3C polypeptide 3', NULL, NULL, NULL, NULL, NULL, 4),
(189118, NULL, 'G3DSA:3.30.70.590:FF:000025', NULL, NULL, 'Putative poly(A) polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(189119, NULL, 'G3DSA:3.30.420.40:FF:000266', NULL, NULL, '2-hydroxyisocaproyl-CoA dehydratase activator', NULL, NULL, NULL, NULL, NULL, 4),
(189120, NULL, 'G3DSA:3.40.50.1000:FF:000091', NULL, NULL, 'HAD hydrolase family', NULL, NULL, NULL, NULL, NULL, 4),
(189121, NULL, 'G3DSA:3.40.50.1000:FF:000427', NULL, NULL, 'Haloacid dehalogenase family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(189122, NULL, 'G3DSA:3.40.30.10:FF:000396', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(189123, NULL, 'G3DSA:3.20.200.10:FF:000013', NULL, NULL, 'Myosin heavy chain kinase A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(189124, NULL, 'G3DSA:3.40.190.10:FF:000130', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(189125, NULL, 'G3DSA:1.10.238.10:FF:000082', NULL, NULL, 'Myosin light chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(189126, NULL, 'G3DSA:3.50.50.100:FF:000050', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189127, NULL, 'G3DSA:3.40.30.10:FF:000177', NULL, NULL, 'Protein disulfide isomerase like, testis expressed', NULL, NULL, NULL, NULL, NULL, 4),
(189128, NULL, 'G3DSA:1.20.1150.12:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189129, NULL, 'G3DSA:3.40.30.10:FF:001020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189130, NULL, 'G3DSA:3.30.70.580:FF:000022', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(189131, NULL, 'G3DSA:3.90.70.10:FF:000082', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 16', NULL, NULL, NULL, NULL, NULL, 4),
(189132, NULL, 'G3DSA:2.60.40.150:FF:000261', NULL, NULL, 'Phosphatidylserine decarboxylase proenzyme 2', NULL, NULL, NULL, NULL, NULL, 4),
(189133, NULL, 'G3DSA:2.130.10.130:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189134, NULL, 'G3DSA:3.30.70.330:FF:001049', NULL, NULL, 'Putative nuclear mrna splicing factor-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(189135, NULL, 'G3DSA:3.20.20.140:FF:000158', NULL, NULL, 'Hydrolase TatD family protein', NULL, NULL, NULL, NULL, NULL, 4),
(189136, NULL, 'G3DSA:3.40.50.300:FF:007649', NULL, NULL, 'Uncharacterized protein ABCE1', NULL, NULL, NULL, NULL, NULL, 4),
(189137, NULL, 'G3DSA:3.30.505.10:FF:000078', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(189138, NULL, 'G3DSA:3.40.50.1400:FF:000008', NULL, NULL, 'Ferrochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(189139, NULL, 'G3DSA:3.80.10.10:FF:001242', NULL, NULL, 'Gp150, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(189140, NULL, 'G3DSA:2.30.30.40:FF:000424', NULL, NULL, 'Nephronophthisis 1', NULL, NULL, NULL, NULL, NULL, 4),
(189141, NULL, 'G3DSA:1.10.357.10:FF:000043', NULL, NULL, 'TetR/AcrR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(189142, NULL, 'G3DSA:2.180.10.10:FF:000014', NULL, NULL, 'Teneurin-m-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(189143, NULL, 'G3DSA:3.40.50.1010:FF:000094', NULL, NULL, 'Ribonuclease VapC', NULL, NULL, NULL, NULL, NULL, 4),
(189144, NULL, 'G3DSA:1.10.510.10:FF:002148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189145, NULL, 'G3DSA:3.30.200.20:FF:000620', NULL, NULL, 'Putative unc-89', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(189146, NULL, 'G3DSA:3.30.160.60:FF:002365', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189147, NULL, 'G3DSA:3.30.9.10:FF:000139', NULL, NULL, 'Gamma-glutamylputrescine oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(189148, NULL, 'G3DSA:3.30.70.330:FF:001942', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189149, NULL, 'G3DSA:2.60.120.970:FF:000049', NULL, NULL, 'Protein DVR-1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(189150, NULL, 'G3DSA:4.10.400.10:FF:000280', NULL, NULL, 'low-density lipoprotein receptor-related protein 6 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(189151, NULL, 'G3DSA:3.30.40.10:FF:001381', NULL, NULL, 'MBD9', NULL, NULL, NULL, NULL, NULL, 4),
(189152, NULL, 'G3DSA:1.10.750.20:FF:000005', NULL, NULL, 'Suppressor of cytokine signaling 1', NULL, NULL, NULL, NULL, NULL, 4),
(189153, NULL, 'G3DSA:3.30.420.10:FF:000634', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189154, NULL, 'G3DSA:3.30.250.20:FF:000005', NULL, NULL, 'LINE-1 retrotransposable element ORF1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(189155, NULL, 'G3DSA:2.40.30.10:FF:000460', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189156, NULL, 'G3DSA:3.30.160.60:FF:006417', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189157, NULL, 'G3DSA:1.20.850.10:FF:000002', NULL, NULL, 'Hydroxylamine oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(189158, NULL, 'G3DSA:2.60.120.10:FF:000299', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189159, NULL, 'G3DSA:3.30.420.270:FF:000037', NULL, NULL, 'Biopolymer transport protein ExbD', NULL, NULL, NULL, NULL, NULL, 4),
(189160, NULL, 'G3DSA:3.10.50.40:FF:000082', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(189161, NULL, 'G3DSA:1.20.1250.20:FF:001240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189162, NULL, 'G3DSA:3.30.160.60:FF:003776', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189163, NULL, 'G3DSA:1.10.238.10:FF:000424', NULL, NULL, 'GM18042', NULL, NULL, NULL, NULL, NULL, 4),
(189164, NULL, 'G3DSA:2.60.40.10:FF:002146', NULL, NULL, 'Major histocompatibility complex class I UKA', NULL, NULL, NULL, NULL, NULL, 4),
(189165, NULL, 'G3DSA:1.20.5.190:FF:000028', NULL, NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(189166, NULL, 'G3DSA:3.30.70.330:FF:001594', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189167, NULL, 'G3DSA:2.130.10.10:FF:003872', NULL, NULL, 'Uncharacterized WD repeat-containing protein C17D11.08', NULL, NULL, NULL, NULL, NULL, 4),
(189168, NULL, 'G3DSA:3.40.50.1580:FF:000005', NULL, NULL, 'AMP nucleosidase', NULL, NULL, NULL, NULL, NULL, 4),
(189169, NULL, 'G3DSA:2.60.40.1910:FF:000011', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(189170, NULL, 'G3DSA:2.30.110.10:FF:000058', NULL, NULL, 'Pyridoxamine 5-phosphate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(189171, NULL, 'G3DSA:1.10.260.60:FF:000007', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', NULL, NULL, NULL, NULL, NULL, 4),
(189172, NULL, 'G3DSA:1.10.8.720:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189173, NULL, 'G3DSA:3.30.160.60:FF:006075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189174, NULL, 'G3DSA:2.60.40.60:FF:000115', NULL, NULL, 'FAT atypical cadherin 4', NULL, NULL, NULL, NULL, NULL, 4),
(189175, NULL, 'G3DSA:1.25.40.20:FF:000338', NULL, NULL, '85/88 kDa calcium-independent phospholipase A2', NULL, NULL, NULL, NULL, NULL, 4),
(189176, NULL, 'G3DSA:1.10.510.10:FF:003907', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189177, NULL, 'G3DSA:3.40.1390.10:FF:000009', NULL, NULL, 'UDP-3-O-acylglucosamine N-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(189178, NULL, 'G3DSA:3.30.1490.100:FF:000021', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(189179, NULL, 'G3DSA:2.60.120.920:FF:000063', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(189180, NULL, 'G3DSA:1.25.40.10:FF:003556', NULL, NULL, 'Probable DNA-directed RNA polymerase alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(189181, NULL, 'G3DSA:2.60.120.10:FF:000086', NULL, NULL, 'Lysophospholipase NTE1', NULL, NULL, NULL, NULL, NULL, 4),
(189182, NULL, 'G3DSA:3.10.20.90:FF:000353', NULL, NULL, '40S ribosomal protein S30', NULL, NULL, NULL, NULL, NULL, 4),
(189183, NULL, 'G3DSA:3.30.40.10:FF:001723', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(189184, NULL, 'G3DSA:2.40.10.10:FF:000239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189185, NULL, 'G3DSA:1.10.30.10:FF:000093', NULL, NULL, 'AGAP002022-PA', NULL, NULL, NULL, NULL, NULL, 4),
(189186, NULL, 'G3DSA:3.40.50.1820:FF:001522', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189187, NULL, 'G3DSA:3.30.2290.10:FF:000027', NULL, NULL, 'Peptidase U62 modulator of DNA gyrase', NULL, NULL, NULL, NULL, NULL, 4),
(189188, NULL, 'G3DSA:3.30.70.420:FF:000002', NULL, NULL, '3-hydroxy-3-methylglutaryl-coenzyme A reductase 2', NULL, NULL, NULL, NULL, NULL, 4),
(189189, NULL, 'G3DSA:1.20.1070.10:FF:001470', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189190, NULL, 'G3DSA:3.40.720.10:FF:000059', NULL, NULL, 'Arylsulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(189191, NULL, 'G3DSA:3.30.160.60:FF:004400', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189192, NULL, 'G3DSA:1.10.287.70:FF:000387', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189193, NULL, 'G3DSA:3.30.1360.120:FF:000077', NULL, NULL, 'tRNA modification GTPase MnmE', NULL, NULL, NULL, NULL, NULL, 4),
(189194, NULL, 'G3DSA:2.60.40.1960:FF:000003', NULL, NULL, 'phytepsin', NULL, NULL, NULL, NULL, NULL, 4),
(189195, NULL, 'G3DSA:1.25.40.880:FF:000001', NULL, NULL, 'SDS hydrolase SdsA1', NULL, NULL, NULL, NULL, NULL, 4),
(189196, NULL, 'G3DSA:3.40.50.300:FF:008150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189197, NULL, 'G3DSA:2.60.40.10:FF:002371', NULL, NULL, 'Papilin', NULL, NULL, NULL, NULL, NULL, 4),
(189198, NULL, 'G3DSA:1.10.506.10:FF:000019', NULL, NULL, 'Neurofibromin 1', NULL, NULL, NULL, NULL, NULL, 4),
(189199, NULL, 'G3DSA:3.30.200.20:FF:001475', NULL, NULL, 'LD20874p', NULL, NULL, NULL, NULL, NULL, 4),
(189200, NULL, 'G3DSA:3.80.10.10:FF:000859', NULL, NULL, 'YDR306C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(189201, NULL, 'G3DSA:3.40.630.30:FF:000496', NULL, NULL, 'UDP-N-acetylmuramoylpentapeptide-lysine N(6)-alanyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(189202, NULL, 'G3DSA:3.80.10.10:FF:002989', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189203, NULL, 'G3DSA:3.60.21.10:FF:000149', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(189204, NULL, 'G3DSA:1.25.10.10:FF:000058', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(189205, NULL, 'G3DSA:2.60.40.1660:FF:000014', NULL, NULL, 'GM26920', NULL, NULL, NULL, NULL, NULL, 4),
(189206, NULL, 'G3DSA:3.40.50.300:FF:002309', NULL, NULL, 'Ras-related protein Ral-A', NULL, NULL, NULL, NULL, NULL, 4),
(189207, NULL, 'G3DSA:3.40.1380.20:FF:000063', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(189208, NULL, 'G3DSA:1.10.10.440:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189209, NULL, 'G3DSA:2.140.10.30:FF:000016', NULL, NULL, 'Dipeptidyl peptidase 8', NULL, NULL, NULL, NULL, NULL, 4),
(189210, NULL, 'G3DSA:3.40.250.10:FF:000079', NULL, NULL, 'Adenylyltransferase and sulfurtransferase uba4', NULL, NULL, NULL, NULL, NULL, 4),
(189211, NULL, 'G3DSA:1.10.510.10:FF:000237', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(189212, NULL, 'G3DSA:3.40.50.720:FF:000749', NULL, NULL, 'N(5)-(carboxyethyl)ornithine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(189213, NULL, 'G3DSA:3.40.50.10810:FF:000115', NULL, NULL, 'Nucleosome remodeling complex ATPase subunit (Snf2h)', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(189214, NULL, 'G3DSA:3.40.1280.30:FF:000007', NULL, NULL, 'Unplaced genomic scaffold supercont2.5, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(189215, NULL, 'G3DSA:1.10.287.110:FF:000141', NULL, NULL, 'Chaperone protein dnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(189216, NULL, 'G3DSA:1.20.1070.10:FF:001705', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189217, NULL, 'G3DSA:3.30.160.60:FF:004052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189218, NULL, 'G3DSA:1.10.238.10:FF:000317', NULL, NULL, 'Follistatin like 4', NULL, NULL, NULL, NULL, NULL, 4),
(189219, NULL, 'G3DSA:3.30.450.40:FF:000111', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(189220, NULL, 'G3DSA:2.30.29.30:FF:001082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189221, NULL, 'G3DSA:3.30.360.10:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189222, NULL, 'G3DSA:3.30.565.10:FF:000312', NULL, NULL, 'PMS1 protein homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(189223, NULL, 'G3DSA:3.30.30.30:FF:000037', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(189224, NULL, 'G3DSA:3.30.505.10:FF:000191', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189225, NULL, 'G3DSA:3.90.230.10:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189226, NULL, 'G3DSA:1.20.1250.20:FF:001913', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189227, NULL, 'G3DSA:3.30.360.10:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189228, NULL, 'G3DSA:3.30.70.1660:FF:000010', NULL, NULL, 'Peptide chain release factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(189229, NULL, 'G3DSA:3.40.50.300:FF:003945', NULL, NULL, 'ADP ribosylation factor 3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(189230, NULL, 'G3DSA:3.30.710.10:FF:000499', NULL, NULL, 'TD and POZ domain-containing protein 3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(189231, NULL, 'G3DSA:3.30.450.20:FF:000678', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(189232, NULL, 'G3DSA:1.25.10.10:FF:002312', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189233, NULL, 'G3DSA:1.10.10.440:FF:000104', NULL, NULL, 'TransCription Elongation Regulator homolog', NULL, NULL, NULL, NULL, NULL, 4),
(189234, NULL, 'G3DSA:3.10.250.10:FF:000119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189235, NULL, 'G3DSA:1.25.40.10:FF:004270', NULL, NULL, 'ABL108Cp', NULL, NULL, NULL, NULL, NULL, 4),
(189236, NULL, 'G3DSA:1.20.1070.10:FF:001812', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189237, NULL, 'G3DSA:1.20.1310.20:FF:000008', NULL, NULL, 'Erythrocyte binding antigen-140', NULL, NULL, NULL, NULL, NULL, 4),
(189238, NULL, 'G3DSA:2.90.10.10:FF:000035', NULL, NULL, 'Putative S-receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(189239, NULL, 'G3DSA:3.40.30.10:FF:000851', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(189240, NULL, 'G3DSA:1.10.3210.10:FF:000028', NULL, NULL, 'HD superfamily phosphohydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(189241, NULL, 'G3DSA:2.30.29.90:FF:000003', NULL, NULL, 'Exocyst complex component Sec3', NULL, NULL, NULL, NULL, NULL, 4),
(189242, NULL, 'G3DSA:2.60.40.1970:FF:000006', NULL, NULL, 'Transcription initiation factor TFIID subunit 14', NULL, NULL, NULL, NULL, NULL, 4),
(189243, NULL, 'G3DSA:1.10.10.10:FF:001963', NULL, NULL, 'Histone H1-I-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(189244, NULL, 'G3DSA:2.70.98.110:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189245, NULL, 'G3DSA:2.70.20.10:FF:000031', NULL, NULL, 'DNA topoisomerase type IA core', NULL, NULL, NULL, NULL, NULL, 4),
(189246, NULL, 'G3DSA:3.30.40.10:FF:001162', NULL, NULL, 'RING-H2 finger protein ATL2', NULL, NULL, NULL, NULL, NULL, 4),
(189247, NULL, 'G3DSA:3.30.160.60:FF:006069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(189248, NULL, 'G3DSA:1.20.120.80:FF:000012', NULL, NULL, 'Cytochrome oxidase subunit III', NULL, NULL, NULL, NULL, NULL, 4),
(189249, NULL, 'G3DSA:3.30.1380.20:FF:000008', NULL, NULL, 'trafficking protein particle complex subunit 6B', NULL, NULL, NULL, NULL, NULL, 4),
(189250, NULL, 'G3DSA:2.130.10.10:FF:004147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189251, NULL, 'G3DSA:2.60.40.1670:FF:000017', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(189252, NULL, 'G3DSA:2.60.200.20:FF:000235', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(189253, NULL, 'G3DSA:3.40.50.1000:FF:000321', NULL, NULL, '5-amino-6-(5-phospho-D-ribitylamino)uracil phosphatase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(189254, NULL, 'G3DSA:3.40.630.30:FF:000507', NULL, NULL, 'RNA cytidine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(189255, NULL, 'G3DSA:1.20.272.10:FF:000080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189256, NULL, 'G3DSA:3.40.640.10:FF:000002', NULL, NULL, 'Serine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(189257, NULL, 'G3DSA:3.40.50.1980:FF:000125', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(189258, NULL, 'G3DSA:2.130.10.130:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189259, NULL, 'G3DSA:3.30.70.330:FF:001830', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189260, NULL, 'G3DSA:2.10.220.10:FF:000149', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(189261, NULL, 'G3DSA:2.60.200.20:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189262, NULL, 'G3DSA:1.25.10.10:FF:000171', NULL, NULL, 'HEAT repeat-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(189263, NULL, 'G3DSA:3.90.1420.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189264, NULL, 'G3DSA:1.50.40.10:FF:000491', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189265, NULL, 'G3DSA:1.20.120.730:FF:000004', NULL, NULL, 'SEC24 homolog B, COPII coat complex component', NULL, NULL, NULL, NULL, NULL, 4),
(189266, NULL, 'G3DSA:1.10.630.10:FF:000398', NULL, NULL, 'Dammarenediol 12-hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(189267, NULL, 'G3DSA:2.60.40.10:FF:004512', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189268, NULL, 'G3DSA:3.40.33.10:FF:000094', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(189269, NULL, 'G3DSA:3.40.980.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189270, NULL, 'G3DSA:3.30.505.10:FF:000084', NULL, NULL, 'Signal transducing adaptor family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(189271, NULL, 'G3DSA:3.40.30.10:FF:000519', NULL, NULL, 'Cytochrome C biogenesis protein transmembrane region', NULL, NULL, NULL, NULL, NULL, 4),
(189272, NULL, 'G3DSA:2.130.10.10:FF:001399', NULL, NULL, 'Sortilin-related VPS10 domain-containing receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(189273, NULL, 'G3DSA:2.160.20.10:FF:000122', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(189274, NULL, 'G3DSA:3.90.70.10:FF:000205', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(189275, NULL, 'G3DSA:1.20.1640.10:FF:000086', NULL, NULL, 'Bifunctional preprotein translocase subunit SecD/SecF', NULL, NULL, NULL, NULL, NULL, 4),
(189276, NULL, 'G3DSA:3.40.50.620:FF:000489', NULL, NULL, 'GMP synthase [glutamine-hydrolyzing] subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(189277, NULL, 'G3DSA:1.20.1310.10:FF:000005', NULL, NULL, 'Cullin 3', NULL, NULL, NULL, NULL, NULL, 4),
(189278, NULL, 'G3DSA:1.10.510.10:FF:000350', NULL, NULL, 'Mitogen-activated protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(189279, NULL, 'G3DSA:1.20.58.70:FF:000117', NULL, NULL, 'Syntaxin-4-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(189280, NULL, 'G3DSA:1.10.565.10:FF:000156', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(189281, NULL, 'G3DSA:1.10.10.10:FF:001637', NULL, NULL, 'Transcription factor E', NULL, NULL, NULL, NULL, NULL, 4),
(189282, NULL, 'G3DSA:1.25.40.10:FF:002140', NULL, NULL, 'Pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(189283, NULL, 'G3DSA:1.20.120.430:FF:000015', NULL, NULL, 'Nuclear encoded Mitochondrial TRNA Carboxymethyl-amino-methyl modification of Uridine residues', NULL, NULL, NULL, NULL, NULL, 4),
(189284, NULL, 'G3DSA:2.40.400.10:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189285, NULL, 'G3DSA:3.40.50.300:FF:001798', NULL, NULL, 'ADP-ribosylation factor-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(189286, NULL, 'G3DSA:1.20.120.140:FF:000029', NULL, NULL, 'Signal recognition particle receptor FtsY', NULL, NULL, NULL, NULL, NULL, 4),
(189287, NULL, 'G3DSA:3.30.70.330:FF:001717', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189288, NULL, 'G3DSA:1.10.3720.10:FF:000112', NULL, NULL, 'Phosphate transport system permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(189289, NULL, 'G3DSA:2.60.40.10:FF:002258', NULL, NULL, 'Chaperone protein EcpD', NULL, NULL, NULL, NULL, NULL, 4),
(189290, NULL, 'G3DSA:3.90.740.10:FF:000026', NULL, NULL, 'Leucyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(189291, NULL, 'G3DSA:1.50.40.10:FF:000384', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189292, NULL, 'G3DSA:3.30.460.10:FF:000176', NULL, NULL, 'Zinc finger RNA-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(189293, NULL, 'G3DSA:3.10.20.90:FF:000465', NULL, NULL, 'E3 ubiquitin-protein ligase UHRF1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(189294, NULL, 'G3DSA:2.60.40.10:FF:000241', NULL, NULL, 'obscurin-like protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(189295, NULL, 'G3DSA:1.25.10.10:FF:001694', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189296, NULL, 'G3DSA:3.80.10.10:FF:000972', NULL, NULL, 'Brassinosteroid LRR receptor kinase BRL2', NULL, NULL, NULL, NULL, NULL, 4),
(189297, NULL, 'G3DSA:3.40.630.10:FF:000501', NULL, NULL, 'Peptide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(189298, NULL, 'G3DSA:2.130.10.10:FF:000095', NULL, NULL, 'Cytoplasmic dynein 1 intermediate chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(189299, NULL, 'G3DSA:3.20.20.220:FF:000070', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(189300, NULL, 'G3DSA:1.10.3720.10:FF:000005', NULL, NULL, 'Microcin C ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(189301, NULL, 'G3DSA:3.60.21.10:FF:000262', NULL, NULL, 'Phosphoesterase', NULL, NULL, NULL, NULL, NULL, 4),
(189302, NULL, 'G3DSA:3.40.109.10:FF:000054', NULL, NULL, 'NADPH-flavin oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(189303, NULL, 'G3DSA:3.40.50.1820:FF:001634', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(189304, NULL, 'G3DSA:1.10.30.10:FF:000109', NULL, NULL, 'Lysine-specific histone demethylase Aof2', NULL, NULL, NULL, NULL, NULL, 4),
(189305, NULL, 'G3DSA:3.10.180.10:FF:000001', NULL, NULL, '4-hydroxyphenylpyruvate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(189306, NULL, 'G3DSA:1.10.3380.10:FF:000029', NULL, NULL, 'U5 small nuclear ribonucleoprotein helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(189307, NULL, 'G3DSA:2.170.270.10:FF:000036', NULL, NULL, 'Blimp-1, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(189308, NULL, 'G3DSA:3.40.50.300:FF:000494', NULL, NULL, 'tRNA modification GTPase MnmE', NULL, NULL, NULL, NULL, NULL, 4),
(189309, NULL, 'G3DSA:1.10.10.10:FF:000440', NULL, NULL, 'AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(189310, NULL, 'G3DSA:1.20.1060.20:FF:000011', NULL, NULL, 'Structural maintenance of chromosomes protein', NULL, NULL, NULL, NULL, NULL, 4),
(189311, NULL, 'G3DSA:3.90.550.10:FF:000433', NULL, NULL, 'Glr1066 protein', NULL, NULL, NULL, NULL, NULL, 4),
(189312, NULL, 'G3DSA:3.90.79.10:FF:000062', NULL, NULL, 'Nudix hydrolase 9', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(189313, NULL, 'G3DSA:3.10.180.20:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189314, NULL, 'G3DSA:2.60.40.10:FF:005816', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189315, NULL, 'G3DSA:3.50.50.60:FF:000411', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(189316, NULL, 'G3DSA:2.10.25.10:FF:000539', NULL, NULL, 'Latent transforming growth factor beta binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(189317, NULL, 'G3DSA:3.40.50.12760:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189318, NULL, 'G3DSA:3.30.160.60:FF:000454', NULL, NULL, 'Zinc finger protein 624', NULL, NULL, NULL, NULL, NULL, 4),
(189319, NULL, 'G3DSA:3.55.50.30:FF:000010', NULL, NULL, 'Probable transmembrane sensor', NULL, NULL, NULL, NULL, NULL, 4),
(189320, NULL, 'G3DSA:1.10.287.950:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189321, NULL, 'G3DSA:1.10.10.140:FF:000008', NULL, NULL, 'Probable cytochrome c oxidase subunit 6B', NULL, NULL, NULL, NULL, NULL, 4),
(189322, NULL, 'G3DSA:3.90.190.10:FF:000349', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189323, NULL, 'G3DSA:2.40.70.10:FF:000125', NULL, NULL, 'Eukaryotic aspartyl protease family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(189324, NULL, 'G3DSA:2.40.70.10:FF:000013', NULL, NULL, 'Aspartyl protease AED1', NULL, NULL, NULL, NULL, NULL, 4),
(189325, NULL, 'G3DSA:1.20.120.980:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189326, NULL, 'G3DSA:2.40.50.100:FF:000191', NULL, NULL, 'Efflux pump, RND family, membrane fusion lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(189327, NULL, 'G3DSA:3.30.70.100:FF:000036', NULL, NULL, 'Transporter, major facilitator family', NULL, NULL, NULL, NULL, NULL, 4),
(189328, NULL, 'G3DSA:1.10.540.10:FF:000065', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(189329, NULL, 'G3DSA:1.10.10.10:FF:001856', NULL, NULL, 'DNA replication licensing factor, MCM2/3/5 family', NULL, NULL, NULL, NULL, NULL, 4),
(189330, NULL, 'G3DSA:2.120.10.30:FF:000404', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189331, NULL, 'G3DSA:1.10.10.820:FF:000004', NULL, NULL, 'unconventional myosin-XVIIIa isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(189332, NULL, 'G3DSA:3.40.50.1820:FF:000797', NULL, NULL, 'Os01g0315600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(189333, NULL, 'G3DSA:3.30.200.20:FF:000171', NULL, NULL, 'Putative cyclin-dependent kinase-like 5', NULL, NULL, NULL, NULL, NULL, 4),
(189334, NULL, 'G3DSA:2.30.30.40:FF:000317', NULL, NULL, 'Bud emergence protein', NULL, NULL, NULL, NULL, NULL, 4),
(189335, NULL, 'G3DSA:2.30.30.40:FF:000205', NULL, NULL, 'SH3 domain containing 19', NULL, NULL, NULL, NULL, NULL, 4),
(189336, NULL, 'G3DSA:3.40.50.1820:FF:001415', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189337, NULL, 'G3DSA:1.20.58.390:FF:000324', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189338, NULL, 'G3DSA:3.90.1600.10:FF:000015', NULL, NULL, 'DNA polymerase epsilon catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(189339, NULL, 'G3DSA:3.30.497.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189340, NULL, 'G3DSA:1.10.287.110:FF:000028', NULL, NULL, 'DnaJ domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(189341, NULL, 'G3DSA:3.40.630.10:FF:000271', NULL, NULL, 'Peptide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(189342, NULL, 'G3DSA:3.90.260.10:FF:000001', NULL, NULL, 'Protein-glutamine gamma-glutamyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(189343, NULL, 'G3DSA:1.20.810.10:FF:000005', NULL, NULL, 'Menaquinol-cytochrome c reductase cytochrome b/c subunit', NULL, NULL, NULL, NULL, NULL, 4),
(189344, NULL, 'G3DSA:3.40.1000.50:FF:000010', NULL, NULL, 'Unplaced genomic scaffold supercont1.9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(189345, NULL, 'G3DSA:3.30.70.1230:FF:000229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189346, NULL, 'G3DSA:1.20.58.480:FF:000020', NULL, NULL, 'Tryptophan 2,3-dioxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(189347, NULL, 'G3DSA:2.130.10.10:FF:003765', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189348, NULL, 'G3DSA:1.20.1070.10:FF:000868', NULL, NULL, 'Cholecystokinin-like receptor at 17D1', NULL, NULL, NULL, NULL, NULL, 4),
(189349, NULL, 'G3DSA:1.10.10.10:FF:000327', NULL, NULL, 'Two-component system response regulator RstA', NULL, NULL, NULL, NULL, NULL, 4),
(189350, NULL, 'G3DSA:1.20.5.4570:FF:000003', NULL, NULL, 'UbiD-like decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(189351, NULL, 'G3DSA:1.10.10.830:FF:000007', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(189352, NULL, 'G3DSA:2.40.50.100:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189353, NULL, 'G3DSA:3.40.50.1000:FF:000208', NULL, NULL, 'Bifunctional polynucleotide phosphatase/kinase', NULL, NULL, NULL, NULL, NULL, 4),
(189354, NULL, 'G3DSA:1.20.58.340:FF:000006', NULL, NULL, 'CorA family metal ion transporter', NULL, NULL, NULL, NULL, NULL, 4),
(189355, NULL, 'G3DSA:1.10.150.80:FF:000011', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(189356, NULL, 'G3DSA:2.40.170.20:FF:000012', NULL, NULL, 'TonB-dependent receptor', NULL, NULL, NULL, NULL, NULL, 4),
(189357, NULL, 'G3DSA:3.90.280.10:FF:000002', NULL, NULL, '39S ribosomal protein L38, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(189358, NULL, 'G3DSA:3.40.50.720:FF:001463', NULL, NULL, 'UDP-glucose/GDP-mannose dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(189359, NULL, 'G3DSA:2.130.10.10:FF:005783', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189360, NULL, 'G3DSA:1.10.565.10:FF:000049', NULL, NULL, 'Testicular nuclear receptor 2 variant 2', NULL, NULL, NULL, NULL, NULL, 4),
(189361, NULL, 'G3DSA:3.30.70.1220:FF:000007', NULL, NULL, 'Os05g0108500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(189362, NULL, 'G3DSA:3.30.160.60:FF:001977', NULL, NULL, 'Krueppel-like factor 17', NULL, NULL, NULL, NULL, NULL, 4),
(189363, NULL, 'G3DSA:3.40.50.1460:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189364, NULL, 'G3DSA:1.20.1310.10:FF:000224', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189365, NULL, 'G3DSA:1.10.10.10:FF:000108', NULL, NULL, 'Mn-dependent transcriptional regulator MntR', NULL, NULL, NULL, NULL, NULL, 4),
(189366, NULL, 'G3DSA:1.20.1310.10:FF:000112', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189367, NULL, 'G3DSA:3.40.50.800:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189368, NULL, 'G3DSA:3.30.1370.100:FF:000028', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(189369, NULL, 'G3DSA:2.40.33.10:FF:000039', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(189370, NULL, 'G3DSA:4.10.400.10:FF:000173', NULL, NULL, 'Transmembrane protease serine 3', NULL, NULL, NULL, NULL, NULL, 4),
(189371, NULL, 'G3DSA:3.40.50.300:FF:000511', NULL, NULL, 'ATP-binding cassette, sub-family A (ABC1), member 2', NULL, NULL, NULL, NULL, NULL, 4),
(189372, NULL, 'G3DSA:1.25.10.10:FF:002531', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189373, NULL, 'G3DSA:3.30.70.240:FF:000050', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(189374, NULL, 'G3DSA:3.20.20.70:FF:000167', NULL, NULL, 'tRNA-dihydrouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(189375, NULL, 'G3DSA:3.40.50.300:FF:002416', NULL, NULL, 'ABC multidrug transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(189376, NULL, 'G3DSA:3.30.70.1200:FF:000001', NULL, NULL, 'CRISPR system Cascade subunit CasE', NULL, NULL, NULL, NULL, NULL, 4),
(189377, NULL, 'G3DSA:3.40.1080.10:FF:000020', NULL, NULL, 'Acetyl-CoA hydrolase/transferase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(189378, NULL, 'G3DSA:1.10.287.1240:FF:000003', NULL, NULL, 'Exodeoxyribonuclease I', NULL, NULL, NULL, NULL, NULL, 4),
(189379, NULL, 'G3DSA:1.10.20.10:FF:000160', NULL, NULL, 'Transcription initiation factor TFIID subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(189380, NULL, 'G3DSA:3.40.390.80:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189381, NULL, 'G3DSA:1.10.268.10:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189382, NULL, 'G3DSA:3.30.40.10:FF:001055', NULL, NULL, 'Zinc finger family protein', NULL, NULL, NULL, NULL, NULL, 4),
(189383, NULL, 'G3DSA:3.10.450.620:FF:000001', NULL, NULL, 'Nucleotidyl transferase of uncharacterized function (DUF1814)', NULL, NULL, NULL, NULL, NULL, 4),
(189384, NULL, 'G3DSA:2.60.200.20:FF:000016', NULL, NULL, 'Angiogenic factor with G patch and FHA domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(189385, NULL, 'G3DSA:1.10.287.110:FF:000360', NULL, NULL, 'AAL008Wp', NULL, NULL, NULL, NULL, NULL, 4),
(189386, NULL, 'G3DSA:2.10.25.10:FF:000871', NULL, NULL, 'Matrilin 3', NULL, NULL, NULL, NULL, NULL, 4),
(189387, NULL, 'G3DSA:3.40.50.2000:FF:001138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189388, NULL, 'G3DSA:3.30.1360.10:FF:000004', NULL, NULL, 'DNA-directed RNA polymerase II subunit RPB3', NULL, NULL, NULL, NULL, NULL, 4),
(189389, NULL, 'G3DSA:2.60.40.1730:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189390, NULL, 'G3DSA:2.130.10.10:FF:002017', NULL, NULL, 'Probable cytosolic iron-sulfur protein assembly protein CIAO1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(189391, NULL, 'G3DSA:3.30.70.330:FF:001487', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein A3', NULL, NULL, NULL, NULL, NULL, 4),
(189392, NULL, 'G3DSA:4.10.240.10:FF:000076', NULL, NULL, 'Tac1p', NULL, NULL, NULL, NULL, NULL, 4),
(189393, NULL, 'G3DSA:3.80.10.10:FF:003714', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189394, NULL, 'G3DSA:3.30.70.330:FF:002105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189395, NULL, 'G3DSA:3.40.30.10:FF:000632', NULL, NULL, 'Plant UBX domain-containing protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(189396, NULL, 'G3DSA:1.10.287.1490:FF:000050', NULL, NULL, 'Kinectin', NULL, NULL, NULL, NULL, NULL, 4),
(189397, NULL, 'G3DSA:1.10.720.30:FF:000057', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(189398, NULL, 'G3DSA:1.10.1420.10:FF:000162', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189399, NULL, 'G3DSA:2.60.200.10:FF:000013', NULL, NULL, 'Interferon regulatory factor 8', NULL, NULL, NULL, NULL, NULL, 4),
(189400, NULL, 'G3DSA:1.20.1250.20:FF:001133', NULL, NULL, 'Tetracycline resistance MFS efflux pump', NULL, NULL, NULL, NULL, NULL, 4),
(189401, NULL, 'G3DSA:3.30.160.60:FF:006182', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189402, NULL, 'G3DSA:3.30.450.350:FF:000005', NULL, NULL, 'GGDEF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(189403, NULL, 'G3DSA:1.25.40.10:FF:003663', NULL, NULL, 'Peroxisomal biogenesis factor 5-like a', NULL, NULL, NULL, NULL, NULL, 4),
(189404, NULL, 'G3DSA:2.60.120.10:FF:000193', NULL, NULL, 'Lysophospholipase NTE1', NULL, NULL, NULL, NULL, NULL, 4),
(189405, NULL, 'G3DSA:3.10.20.90:FF:000246', NULL, NULL, 'NADPH oxidase regulator NoxR', NULL, NULL, NULL, NULL, NULL, 4),
(189406, NULL, 'G3DSA:3.90.550.10:FF:000214', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(189407, NULL, 'G3DSA:1.10.510.10:FF:000018', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(189408, NULL, 'G3DSA:1.10.630.10:FF:000179', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(189409, NULL, 'G3DSA:1.10.1410.10:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189410, NULL, 'G3DSA:3.30.160.60:FF:002814', NULL, NULL, 'Transcription factor IIIA', NULL, NULL, NULL, NULL, NULL, 4),
(189411, NULL, 'G3DSA:3.30.1360.20:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(189412, NULL, 'G3DSA:1.10.520.10:FF:000064', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(189413, NULL, 'G3DSA:3.90.1200.10:FF:000047', NULL, NULL, 'Spore coat protein', NULL, NULL, NULL, NULL, NULL, 4),
(189414, NULL, 'G3DSA:3.30.450.40:FF:000094', NULL, NULL, 'dual 3'',5''-cyclic-AMP and -GMP phosphodiesterase 11A-like', NULL, NULL, NULL, NULL, NULL, 4),
(189415, NULL, 'G3DSA:3.40.630.30:FF:000277', NULL, NULL, 'GNAT family acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(189416, NULL, 'G3DSA:1.10.135.10:FF:000005', NULL, NULL, 'Glycocyamine kinase beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(189417, NULL, 'G3DSA:3.60.21.10:FF:000481', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(189418, NULL, 'G3DSA:3.20.170.20:FF:000001', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189419, NULL, 'G3DSA:2.60.40.10:FF:002039', NULL, NULL, 'EGF-like, fibronectin type III and laminin G domains', NULL, NULL, NULL, NULL, NULL, 4),
(189420, NULL, 'G3DSA:1.10.3720.10:FF:000224', NULL, NULL, 'N-acetyltaurine ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(189421, NULL, 'G3DSA:2.60.40.10:FF:002601', NULL, NULL, 'Putative invasin', NULL, NULL, NULL, NULL, NULL, 4),
(189422, NULL, 'G3DSA:3.40.50.200:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189423, NULL, 'G3DSA:3.40.50.1000:FF:000540', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189424, NULL, 'G3DSA:1.20.140.150:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189425, NULL, 'G3DSA:2.60.40.150:FF:000036', NULL, NULL, 'phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(189426, NULL, 'G3DSA:3.40.1280.10:FF:000001', NULL, NULL, 'tRNA (guanine-N(1)-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(189427, NULL, 'G3DSA:3.60.15.10:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189428, NULL, 'G3DSA:1.10.1300.10:FF:000001', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(189429, NULL, 'G3DSA:3.80.10.10:FF:003153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189430, NULL, 'G3DSA:3.40.640.10:FF:000221', NULL, NULL, 'PLP-dependent transferase', NULL, NULL, NULL, NULL, NULL, 4),
(189431, NULL, 'G3DSA:3.40.50.2300:FF:001346', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189432, NULL, 'G3DSA:3.40.50.300:FF:004327', NULL, NULL, 'GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(189433, NULL, 'G3DSA:3.40.50.300:FF:001579', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(189434, NULL, 'G3DSA:3.30.40.10:FF:001616', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(189435, NULL, 'G3DSA:1.25.40.190:FF:000002', NULL, NULL, 'Actin-related protein 2/3 complex subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(189436, NULL, 'G3DSA:3.40.1370.10:FF:000008', NULL, NULL, '50S ribosomal protein L4', NULL, NULL, NULL, NULL, NULL, 4),
(189437, NULL, 'G3DSA:1.10.20.10:FF:000047', NULL, NULL, 'Histone H3', NULL, NULL, NULL, NULL, NULL, 4),
(189438, NULL, 'G3DSA:3.30.40.10:FF:000998', NULL, NULL, 'Zinc finger domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(189439, NULL, 'G3DSA:2.60.40.10:FF:004731', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189440, NULL, 'G3DSA:3.40.50.150:FF:000426', NULL, NULL, 'Putative N6-adenosine-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(189441, NULL, 'G3DSA:1.50.40.10:FF:000272', NULL, NULL, 'Mitochondrial thiamine pyrophosphate transporter, mitochondrial carrier family member, putative', NULL, NULL, NULL, NULL, NULL, 4),
(189442, NULL, 'G3DSA:3.30.160.60:FF:001758', NULL, NULL, 'Zinc finger protein 496', NULL, NULL, NULL, NULL, NULL, 4),
(189443, NULL, 'G3DSA:3.20.10.10:FF:000019', NULL, NULL, 'Aminotransferase class IV, putative', NULL, NULL, NULL, NULL, NULL, 4),
(189444, NULL, 'G3DSA:1.20.140.100:FF:000033', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(189445, NULL, 'G3DSA:3.30.160.60:FF:005687', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189446, NULL, 'G3DSA:3.30.160.60:FF:006305', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189447, NULL, 'G3DSA:3.30.160.60:FF:004164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189448, NULL, 'G3DSA:1.25.40.10:FF:002701', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189449, NULL, 'G3DSA:1.10.3520.10:FF:000018', NULL, NULL, 'Glycolipid transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(189450, NULL, 'G3DSA:3.40.50.300:FF:000056', NULL, NULL, 'Cell division ATP-binding protein FtsE', NULL, NULL, NULL, NULL, NULL, 4),
(189451, NULL, 'G3DSA:1.10.287.1490:FF:000156', NULL, NULL, 'Viral A-type inclusion protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(189452, NULL, 'G3DSA:2.40.20.10:FF:000066', NULL, NULL, 'Plasminogen', NULL, NULL, NULL, NULL, NULL, 4),
(189453, NULL, 'G3DSA:3.90.70.10:FF:000317', NULL, NULL, 'Calpain-like cysteine peptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(189454, NULL, 'G3DSA:1.25.40.10:FF:005355', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189455, NULL, 'G3DSA:3.30.830.10:FF:000210', NULL, NULL, 'Peptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(189456, NULL, 'G3DSA:3.90.780.10:FF:000023', NULL, NULL, '2'',3''-cyclic-nucleotide 2''-phosphodiesterase (CpdB)', NULL, NULL, NULL, NULL, NULL, 4),
(189457, NULL, 'G3DSA:4.10.280.10:FF:000179', NULL, NULL, 'Aryl hydrocarbon receptor nuclear translocator-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(189458, NULL, 'G3DSA:3.30.160.60:FF:004506', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189459, NULL, 'G3DSA:1.10.287.110:FF:000247', NULL, NULL, 'DnaJ like protein subfamily C member 24', NULL, NULL, NULL, NULL, NULL, 4),
(189460, NULL, 'G3DSA:2.70.150.10:FF:000203', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(189461, NULL, 'G3DSA:3.50.30.30:FF:000087', NULL, NULL, 'Putative zinc metalloprotease', NULL, NULL, NULL, NULL, NULL, 4),
(189462, NULL, 'G3DSA:3.80.20.20:FF:000003', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(189463, NULL, 'G3DSA:2.60.40.10:FF:000347', NULL, NULL, 'Neuronal cell adhesion molecule', NULL, NULL, NULL, NULL, NULL, 4),
(189464, NULL, 'G3DSA:3.40.1810.10:FF:000037', NULL, NULL, 'MADS-box protein SVP isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(189465, NULL, 'G3DSA:3.30.420.40:FF:000721', NULL, NULL, 'Actin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(189466, NULL, 'G3DSA:2.60.200.30:FF:000019', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(189467, NULL, 'G3DSA:3.40.50.720:FF:001244', NULL, NULL, '4-hydroxy-tetrahydrodipicolinate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(189468, NULL, 'G3DSA:3.30.160.60:FF:002034', NULL, NULL, 'transcription factor Ken', NULL, NULL, NULL, NULL, NULL, 4),
(189469, NULL, 'G3DSA:3.30.40.10:FF:001274', NULL, NULL, 'Unplaced genomic scaffold supercont1.17, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(189470, NULL, 'G3DSA:2.40.30.10:FF:000016', NULL, NULL, 'GTP-binding protein TypA', NULL, NULL, NULL, NULL, NULL, 4),
(189471, NULL, 'G3DSA:3.20.80.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189472, NULL, 'G3DSA:3.40.190.10:FF:000023', NULL, NULL, 'ATP phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(189473, NULL, 'G3DSA:1.10.1370.30:FF:000051', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(189474, NULL, 'G3DSA:3.40.30.10:FF:000289', NULL, NULL, 'Plasmoredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(189475, NULL, 'G3DSA:3.30.200.20:FF:002312', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189476, NULL, 'G3DSA:3.80.10.10:FF:001354', NULL, NULL, 'TRK (Vertebrate neurotrophin receptor tyrosine kinase) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(189477, NULL, 'G3DSA:3.40.50.300:FF:005963', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(189478, NULL, 'G3DSA:1.10.3730.20:FF:000054', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189479, NULL, 'G3DSA:2.60.40.60:FF:000227', NULL, NULL, 'Dachsous cadherin-related 2', NULL, NULL, NULL, NULL, NULL, 4),
(189480, NULL, 'G3DSA:1.20.1110.10:FF:000237', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189481, NULL, 'G3DSA:4.10.400.10:FF:000279', NULL, NULL, 'LDL receptor related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(189482, NULL, 'G3DSA:1.20.120.350:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189483, NULL, 'G3DSA:1.10.10.60:FF:000426', NULL, NULL, 'NK3 homeobox 1', NULL, NULL, NULL, NULL, NULL, 4),
(189484, NULL, 'G3DSA:2.130.10.10:FF:005564', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189485, NULL, 'G3DSA:3.30.200.20:FF:001694', NULL, NULL, 'ADR163Wp', NULL, NULL, NULL, NULL, NULL, 4),
(189486, NULL, 'G3DSA:3.40.50.2020:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189487, NULL, 'G3DSA:3.40.50.720:FF:000968', NULL, NULL, 'Phenolpthiocerol synthesis type-I polyketide synthase ppsC', NULL, NULL, NULL, NULL, NULL, 4),
(189488, NULL, 'G3DSA:3.30.450.40:FF:000217', NULL, NULL, 'PleD gene product', NULL, NULL, NULL, NULL, NULL, 4),
(189489, NULL, 'G3DSA:2.30.140.10:FF:000009', NULL, NULL, 'Polyamine aminopropyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(189490, NULL, 'G3DSA:2.30.29.30:FF:000929', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189491, NULL, 'G3DSA:2.40.30.20:FF:000019', NULL, NULL, 'ATP synthase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(189492, NULL, 'G3DSA:2.30.29.30:FF:001205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189493, NULL, 'G3DSA:1.10.10.10:FF:002019', NULL, NULL, 'MarR family transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(189494, NULL, 'G3DSA:2.130.10.10:FF:003984', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189495, NULL, 'G3DSA:3.30.565.10:FF:000531', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189496, NULL, 'G3DSA:3.30.160.60:FF:003888', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189497, NULL, 'G3DSA:1.10.238.10:FF:000536', NULL, NULL, 'Calcium channel protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(189498, NULL, 'G3DSA:1.20.58.70:FF:000011', NULL, NULL, 'Syntaxin 4', NULL, NULL, NULL, NULL, NULL, 4),
(189499, NULL, 'G3DSA:1.20.1250.20:FF:001352', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189500, NULL, 'G3DSA:1.10.8.60:FF:000459', NULL, NULL, 'Transitional endoplasmic reticulum ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(189501, NULL, 'G3DSA:3.10.580.10:FF:000094', NULL, NULL, 'Magnesium transporter MgtE', NULL, NULL, NULL, NULL, NULL, 4),
(189502, NULL, 'G3DSA:2.130.10.10:FF:001854', NULL, NULL, 'Protein CBR-CHE-11', NULL, NULL, NULL, NULL, NULL, 4),
(189503, NULL, 'G3DSA:2.110.10.10:FF:000045', NULL, NULL, 'Peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(189504, NULL, 'G3DSA:1.10.10.60:FF:000084', NULL, NULL, 'Homeobox protein Hox-D13', NULL, NULL, NULL, NULL, NULL, 4),
(189505, NULL, 'G3DSA:3.40.50.150:FF:000084', NULL, NULL, 'probable methyltransferase PMT23', NULL, NULL, NULL, NULL, NULL, 4),
(189506, NULL, 'G3DSA:3.30.565.10:FF:000076', NULL, NULL, 'Molecular chaperone HtpG', NULL, NULL, NULL, NULL, NULL, 4),
(189507, NULL, 'G3DSA:2.130.10.10:FF:004260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189508, NULL, 'G3DSA:2.60.40.10:FF:003675', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189509, NULL, 'G3DSA:3.40.50.450:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189510, NULL, 'G3DSA:2.60.40.150:FF:000710', NULL, NULL, 'C2 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(189511, NULL, 'G3DSA:1.10.472.10:FF:000125', NULL, NULL, 'Transcription initiation factor TFIIB, putative', NULL, NULL, NULL, NULL, NULL, 4),
(189512, NULL, 'G3DSA:3.10.25.10:FF:000014', NULL, NULL, 'Methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(189513, NULL, 'G3DSA:1.20.1640.10:FF:000103', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189514, NULL, 'G3DSA:3.40.50.300:FF:006800', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189515, NULL, 'G3DSA:3.40.50.1100:FF:000238', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189516, NULL, 'G3DSA:3.10.580.10:FF:000217', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(189517, NULL, 'G3DSA:1.20.1260.30:FF:000001', NULL, NULL, 'Type I restriction enzyme StySJI M protein', NULL, NULL, NULL, NULL, NULL, 4),
(189518, NULL, 'G3DSA:2.60.40.60:FF:000446', NULL, NULL, 'Si:dkey-30k22.7', NULL, NULL, NULL, NULL, NULL, 4),
(189519, NULL, 'G3DSA:3.40.50.300:FF:000617', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(189520, NULL, 'G3DSA:1.20.58.80:FF:000014', NULL, NULL, 'Vacuolar protein-sorting-associated protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(189521, NULL, 'G3DSA:3.30.420.40:FF:000502', NULL, NULL, 'Actin-Related Proteins', NULL, NULL, NULL, NULL, NULL, 4),
(189522, NULL, 'G3DSA:3.40.120.10:FF:000075', NULL, NULL, 'Phosphopentomutase', NULL, NULL, NULL, NULL, NULL, 4),
(189523, NULL, 'G3DSA:3.40.50.2020:FF:000059', NULL, NULL, 'Orotate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(189524, NULL, 'G3DSA:3.30.559.70:FF:000012', NULL, NULL, 'Yat2p', NULL, NULL, NULL, NULL, NULL, 4),
(189525, NULL, 'G3DSA:1.10.420.10:FF:000011', NULL, NULL, 'Adenylate/guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(189526, NULL, 'G3DSA:2.130.10.10:FF:002130', NULL, NULL, 'Probable elongator complex protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(189527, NULL, 'G3DSA:3.30.1320.10:FF:000007', NULL, NULL, '30S ribosomal protein S16', NULL, NULL, NULL, NULL, NULL, 4),
(189528, NULL, 'G3DSA:1.20.1110.10:FF:000018', NULL, NULL, 'Magnesium-translocating P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(189529, NULL, 'G3DSA:1.10.533.10:FF:000149', NULL, NULL, 'Viral CASP8 and FADD-like apoptosis regulator', NULL, NULL, NULL, NULL, NULL, 4),
(189530, NULL, 'G3DSA:1.25.40.10:FF:002027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189531, NULL, 'G3DSA:3.30.530.20:FF:000050', NULL, NULL, 'Abscisic acid receptor PYL13', NULL, NULL, NULL, NULL, NULL, 4),
(189532, NULL, 'G3DSA:2.10.25.10:FF:000977', NULL, NULL, 'Wing blister, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(189533, NULL, 'G3DSA:3.30.457.60:FF:000019', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189534, NULL, 'G3DSA:3.40.50.300:FF:008037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189535, NULL, 'G3DSA:3.90.70.10:FF:000194', NULL, NULL, 'Ubiquitin C-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(189536, NULL, 'G3DSA:1.10.8.50:FF:000018', NULL, NULL, '40S ribosomal protein S18, putative', NULL, NULL, NULL, NULL, NULL, 4),
(189537, NULL, 'G3DSA:2.10.50.10:FF:000159', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189538, NULL, 'G3DSA:3.30.160.60:FF:005468', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189539, NULL, 'G3DSA:1.20.144.10:FF:000035', NULL, NULL, 'Putative Lipid phosphate phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(189540, NULL, 'G3DSA:1.10.1450.10:FF:000113', NULL, NULL, 'Uroplakin 1A', NULL, NULL, NULL, NULL, NULL, 4),
(189541, NULL, 'G3DSA:1.20.120.720:FF:000001', NULL, NULL, 'Myosin heavy chain, muscle', NULL, NULL, NULL, NULL, NULL, 4),
(189542, NULL, 'G3DSA:2.10.70.10:FF:000267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189543, NULL, 'G3DSA:3.20.20.105:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189544, NULL, 'G3DSA:3.80.10.10:FF:002990', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189545, NULL, 'G3DSA:1.25.10.10:FF:000390', NULL, NULL, 'Ataxin-10', NULL, NULL, NULL, NULL, NULL, 4),
(189546, NULL, 'G3DSA:2.60.40.10:FF:000128', NULL, NULL, 'receptor-type tyrosine-protein phosphatase delta isoform X2', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(189547, NULL, 'G3DSA:2.40.100.10:FF:000061', NULL, NULL, 'Cpr8p', NULL, NULL, NULL, NULL, NULL, 4),
(189548, NULL, 'G3DSA:3.30.160.60:FF:004383', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189549, NULL, 'G3DSA:1.10.238.10:FF:000194', NULL, NULL, 'rhomboid-related protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(189550, NULL, 'G3DSA:2.10.25.10:FF:001253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189551, NULL, 'G3DSA:2.100.10.30:FF:000012', NULL, NULL, 'Jacalin-related lectin 34', NULL, NULL, NULL, NULL, NULL, 4),
(189552, NULL, 'G3DSA:1.10.730.10:FF:000001', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(189553, NULL, 'G3DSA:1.10.8.60:FF:000572', NULL, NULL, 'CDC48/VCP homolog, AAA superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(189554, NULL, 'G3DSA:3.40.50.300:FF:001112', NULL, NULL, 'Dynein heavy chain 12, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(189555, NULL, 'G3DSA:2.40.10.10:FF:000240', NULL, NULL, 'Serine protease H29', NULL, NULL, NULL, NULL, NULL, 4),
(189556, NULL, 'G3DSA:3.40.190.10:FF:000242', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(189557, NULL, 'G3DSA:1.20.58.390:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189558, NULL, 'G3DSA:2.60.120.330:FF:000088', NULL, NULL, '1-aminocyclopropane-1-carboxylate oxidase-like 9', NULL, NULL, NULL, NULL, NULL, 4),
(189559, NULL, 'G3DSA:2.60.40.10:FF:004170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189560, NULL, 'G3DSA:1.10.1070.11:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189561, NULL, 'G3DSA:2.40.50.140:FF:001259', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189562, NULL, 'G3DSA:3.30.160.60:FF:000673', NULL, NULL, 'Zinc finger and BTB domain-containing 7B', NULL, NULL, NULL, NULL, NULL, 4),
(189563, NULL, 'G3DSA:2.60.40.10:FF:000802', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(189564, NULL, 'G3DSA:2.130.10.10:FF:005906', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189565, NULL, 'G3DSA:1.10.510.10:FF:000456', NULL, NULL, 'Casein kinase I isoform gamma-3', NULL, NULL, NULL, NULL, NULL, 4),
(189566, NULL, 'G3DSA:1.20.1270.10:FF:000069', NULL, NULL, 'Putative heat shock 70 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(189567, NULL, 'G3DSA:3.40.50.150:FF:000207', NULL, NULL, 'Leucine carboxyl methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(189568, NULL, 'G3DSA:2.10.25.10:FF:001034', NULL, NULL, 'Transmembrane cell adhesion receptor mua-3', NULL, NULL, NULL, NULL, NULL, 4),
(189569, NULL, 'G3DSA:3.90.920.10:FF:000012', NULL, NULL, 'DNA primase small subunit-like', NULL, NULL, NULL, NULL, NULL, 4),
(189570, NULL, 'G3DSA:2.10.220.10:FF:000043', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5b', NULL, NULL, NULL, NULL, NULL, 4),
(189571, NULL, 'G3DSA:3.30.70.330:FF:003067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189572, NULL, 'G3DSA:2.10.70.10:FF:000048', NULL, NULL, 'Haptoglobin', NULL, NULL, NULL, NULL, NULL, 4),
(189573, NULL, 'G3DSA:3.10.110.10:FF:000053', NULL, NULL, 'Ubiquitin-fold modifier-conjugating enzyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(189574, NULL, 'G3DSA:2.130.10.10:FF:000218', NULL, NULL, 'WD40 repeat-containing protein HOS15', NULL, NULL, NULL, NULL, NULL, 4),
(189575, NULL, 'G3DSA:1.20.1250.20:FF:001571', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(189576, NULL, 'G3DSA:3.40.50.300:FF:008256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189577, NULL, 'G3DSA:3.40.50.300:FF:000275', NULL, NULL, 'Putative ras-related protein Rab-2A', NULL, NULL, NULL, NULL, NULL, 4),
(189578, NULL, 'G3DSA:1.20.120.1110:FF:000007', NULL, NULL, 'Core-binding factor, runt domain, alpha subunit 2; translocated to, 2', NULL, NULL, NULL, NULL, NULL, 4),
(189579, NULL, 'G3DSA:1.10.510.10:FF:001873', NULL, NULL, 'GG16618', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(189580, NULL, 'G3DSA:3.30.70.20:FF:000031', NULL, NULL, 'Dihydropyrimidine dehydrogenase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(189581, NULL, 'G3DSA:2.60.40.790:FF:000093', NULL, NULL, '17.4 kDa class I heat shock protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(189582, NULL, 'G3DSA:1.10.510.10:FF:002710', NULL, NULL, 'TRK (Vertebrate neurotrophin receptor tyrosine kinase) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(189583, NULL, 'G3DSA:2.60.40.10:FF:003894', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189584, NULL, 'G3DSA:2.10.25.10:FF:000758', NULL, NULL, 'Laminin subunit gamma 1', NULL, NULL, NULL, NULL, NULL, 4),
(189585, NULL, 'G3DSA:1.10.287.450:FF:000001', NULL, NULL, 'adenomatous polyposis coli protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(189586, NULL, 'G3DSA:3.30.200.20:FF:001817', NULL, NULL, 'DM1 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(189587, NULL, 'G3DSA:3.90.550.10:FF:000652', NULL, NULL, 'Chitin oligosaccharide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(189588, NULL, 'G3DSA:2.60.40.10:FF:000460', NULL, NULL, 'Bent, isoform J', NULL, NULL, NULL, NULL, NULL, 4),
(189589, NULL, 'G3DSA:1.25.10.10:FF:001817', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189590, NULL, 'G3DSA:1.10.10.10:FF:000221', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(189591, NULL, 'G3DSA:2.120.10.80:FF:000161', NULL, NULL, 'KLHDC2 isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(189592, NULL, 'G3DSA:1.20.5.780:FF:000003', NULL, NULL, 'FXYD domain-containing ion transport regulator', NULL, NULL, NULL, NULL, NULL, 4),
(189593, NULL, 'G3DSA:1.10.510.10:FF:001569', NULL, NULL, 'Myotonin-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(189594, NULL, 'G3DSA:2.60.40.180:FF:000005', NULL, NULL, '5-hydroxyisourate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(189595, NULL, 'G3DSA:3.90.830.10:FF:000022', NULL, NULL, 'Vacuolar protein sorting-associated protein 33A', NULL, NULL, NULL, NULL, NULL, 4),
(189596, NULL, 'G3DSA:1.10.150.50:FF:000030', NULL, NULL, 'transcription factor ETV6', NULL, NULL, NULL, NULL, NULL, 4),
(189597, NULL, 'G3DSA:3.90.1150.210:FF:000017', NULL, NULL, 'F-actin-capping protein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(189598, NULL, 'G3DSA:2.20.25.190:FF:000005', NULL, NULL, 'Transcription elongation factor 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(189599, NULL, 'G3DSA:1.20.1250.20:FF:001088', NULL, NULL, 'Solute carrier family 22 member 9', NULL, NULL, NULL, NULL, NULL, 4),
(189600, NULL, 'G3DSA:3.30.200.20:FF:001233', NULL, NULL, 'Serine/threonine-protein kinase OXI1', NULL, NULL, NULL, NULL, NULL, 4),
(189601, NULL, 'G3DSA:3.80.10.10:FF:001657', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189602, NULL, 'G3DSA:3.40.1110.10:FF:000091', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(189603, NULL, 'G3DSA:3.40.50.720:FF:000985', NULL, NULL, 'NmrA-like family protein', NULL, NULL, NULL, NULL, NULL, 4),
(189604, NULL, 'G3DSA:2.30.29.30:FF:000912', NULL, NULL, 'Rho guanine nucleotide exchange factor 10', NULL, NULL, NULL, NULL, NULL, 4),
(189605, NULL, 'G3DSA:2.60.40.60:FF:000014', NULL, NULL, 'Cadherin 8', NULL, NULL, NULL, NULL, NULL, 4),
(189606, NULL, 'G3DSA:2.60.40.420:FF:000033', NULL, NULL, 'Ceruloplasmin', NULL, NULL, NULL, NULL, NULL, 4),
(189607, NULL, 'G3DSA:3.40.20.10:FF:000053', NULL, NULL, 'Villin like', NULL, NULL, NULL, NULL, NULL, 4),
(189608, NULL, 'G3DSA:3.40.50.300:FF:003057', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(189609, NULL, 'G3DSA:2.70.98.10:FF:000064', NULL, NULL, 'Glycoside hydrolase family 2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(189610, NULL, 'G3DSA:2.10.270.10:FF:000006', NULL, NULL, 'Toxin B', NULL, NULL, NULL, NULL, NULL, 4),
(189611, NULL, 'G3DSA:3.90.76.10:FF:000050', NULL, NULL, 'Peptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(189612, NULL, 'G3DSA:3.40.50.150:FF:001106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(189613, NULL, 'G3DSA:3.90.1150.10:FF:000481', NULL, NULL, 'L-allo-threonine aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(189614, NULL, 'G3DSA:3.60.130.10:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189615, NULL, 'G3DSA:2.60.120.200:FF:000509', NULL, NULL, 'Laminin subunit alpha-1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(189616, NULL, 'G3DSA:2.60.40.60:FF:000486', NULL, NULL, 'Cadherin 16, KSP-cadherin', NULL, NULL, NULL, NULL, NULL, 4),
(189617, NULL, 'G3DSA:3.10.100.10:FF:000221', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189618, NULL, 'G3DSA:4.10.60.20:FF:000001', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189619, NULL, 'G3DSA:2.130.10.10:FF:000117', NULL, NULL, 'WD repeat-containing protein 82', NULL, NULL, NULL, NULL, NULL, 4),
(189620, NULL, 'G3DSA:3.40.50.150:FF:000117', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase G', NULL, NULL, NULL, NULL, NULL, 4),
(189621, NULL, 'G3DSA:2.130.10.10:FF:001106', NULL, NULL, 'LLGL scribble cell polarity complex component 1', NULL, NULL, NULL, NULL, NULL, 4),
(189622, NULL, 'G3DSA:3.30.70.330:FF:000964', NULL, NULL, 'Regulator of rDNA transcription protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(189623, NULL, 'G3DSA:2.130.10.10:FF:005440', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189624, NULL, 'G3DSA:2.30.29.30:FF:001368', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189625, NULL, 'G3DSA:1.25.40.1040:FF:000058', NULL, NULL, 'RNA processing protein', NULL, NULL, NULL, NULL, NULL, 4),
(189626, NULL, 'G3DSA:1.10.287.70:FF:000139', NULL, NULL, 'Potassium channel SKOR', NULL, NULL, NULL, NULL, NULL, 4),
(189627, NULL, 'G3DSA:2.60.40.10:FF:003219', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189628, NULL, 'G3DSA:3.30.420.10:FF:000398', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189629, NULL, 'G3DSA:2.30.29.30:FF:000379', NULL, NULL, 'dynamin-1 isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(189630, NULL, 'G3DSA:3.40.50.620:FF:000781', NULL, NULL, 'Pantoate-beta-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(189631, NULL, 'G3DSA:3.40.50.2300:FF:000907', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189632, NULL, 'G3DSA:2.10.25.10:FF:001287', NULL, NULL, 'AGAP005526-PA', NULL, NULL, NULL, NULL, NULL, 4),
(189633, NULL, 'G3DSA:3.20.20.80:FF:000456', NULL, NULL, 'Os01g0619800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(189634, NULL, 'G3DSA:1.25.40.10:FF:005175', NULL, NULL, 'Neutrophil cytosolic factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(189635, NULL, 'G3DSA:3.40.630.10:FF:000299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189636, NULL, 'G3DSA:3.30.200.20:FF:000244', NULL, NULL, 'Serine/threonine-protein kinase CDL1-like', NULL, NULL, NULL, NULL, NULL, 4),
(189637, NULL, 'G3DSA:3.40.50.720:FF:000513', NULL, NULL, 'D-amino acid oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(189638, NULL, 'G3DSA:3.40.50.150:FF:001545', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189639, NULL, 'G3DSA:2.30.42.10:FF:000398', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189640, NULL, 'G3DSA:3.30.450.20:FF:000436', NULL, NULL, 'Putative hypoxia-inducible factor 1/neuronal pas domain protein npas1', NULL, NULL, NULL, NULL, NULL, 4),
(189641, NULL, 'G3DSA:1.20.900.10:FF:000107', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189642, NULL, 'G3DSA:2.60.40.60:FF:001003', NULL, NULL, 'Protein CBR-CDH-7', NULL, NULL, NULL, NULL, NULL, 4),
(189643, NULL, 'G3DSA:3.30.1490.180:FF:000034', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(189644, NULL, 'G3DSA:3.40.50.1000:FF:000596', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189645, NULL, 'G3DSA:3.30.830.10:FF:000272', NULL, NULL, 'Insulinase-like metalloprotease', NULL, NULL, NULL, NULL, NULL, 4),
(189646, NULL, 'G3DSA:1.20.1260.10:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189647, NULL, 'G3DSA:1.20.1270.210:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(189648, NULL, 'G3DSA:3.30.1370.10:FF:000174', NULL, NULL, 'Zinc finger CCCH domain-containing protein 52', NULL, NULL, NULL, NULL, NULL, 4),
(189649, NULL, 'G3DSA:3.30.160.540:FF:000002', NULL, NULL, 'Probable septum site-determining protein MinC', NULL, NULL, NULL, NULL, NULL, 4),
(189650, NULL, 'G3DSA:3.40.50.300:FF:001612', NULL, NULL, 'ras-related protein Rap-2a-like', NULL, NULL, NULL, NULL, NULL, 4),
(189651, NULL, 'G3DSA:3.40.50.2300:FF:001043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189652, NULL, 'G3DSA:3.30.160.60:FF:003287', NULL, NULL, 'Zgc:113343', NULL, NULL, NULL, NULL, NULL, 4),
(189653, NULL, 'G3DSA:2.130.10.10:FF:001545', NULL, NULL, 'WD repeat-containing protein 48', NULL, NULL, NULL, NULL, NULL, 4),
(189654, NULL, 'G3DSA:2.40.10.10:FF:000447', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189655, NULL, 'G3DSA:1.20.1250.20:FF:000099', NULL, NULL, 'Hippocampus abundant gene transcript 1', NULL, NULL, NULL, NULL, NULL, 4),
(189656, NULL, 'G3DSA:1.20.58.60:FF:000851', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189657, NULL, 'G3DSA:3.30.420.140:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189658, NULL, 'G3DSA:3.40.50.2000:FF:001104', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(189659, NULL, 'G3DSA:1.20.58.2010:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189660, NULL, 'G3DSA:1.10.10.60:FF:000106', NULL, NULL, 'Chromodomain-helicase-DNA-binding protein 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(189661, NULL, 'G3DSA:1.10.150.20:FF:000015', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(189662, NULL, 'G3DSA:1.10.30.10:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189663, NULL, 'G3DSA:1.25.40.10:FF:004186', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(189664, NULL, 'G3DSA:1.10.220.10:FF:000041', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(189665, NULL, 'G3DSA:2.130.10.10:FF:000589', NULL, NULL, 'WD repeat-containing protein 70', NULL, NULL, NULL, NULL, NULL, 4),
(189666, NULL, 'G3DSA:3.30.110.20:FF:000006', NULL, NULL, 'Ribonuclease P protein subunit p25', NULL, NULL, NULL, NULL, NULL, 4),
(189667, NULL, 'G3DSA:1.10.510.10:FF:002997', NULL, NULL, 'Protein CBG17985', NULL, NULL, NULL, NULL, NULL, 4),
(189668, NULL, 'G3DSA:1.25.40.10:FF:000824', NULL, NULL, 'Serine/threonine-protein kinase PknG', NULL, NULL, NULL, NULL, NULL, 4),
(189669, NULL, 'G3DSA:1.10.10.60:FF:000578', NULL, NULL, 'Helicase/SANT-associated, DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(189670, NULL, 'G3DSA:3.30.46.10:FF:000005', NULL, NULL, 'Glycine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(189671, NULL, 'G3DSA:3.30.70.590:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189672, NULL, 'G3DSA:3.30.160.60:FF:005232', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189673, NULL, 'G3DSA:1.25.10.10:FF:003110', NULL, NULL, 'Exportin-T', NULL, NULL, NULL, NULL, NULL, 4),
(189674, NULL, 'G3DSA:3.40.50.300:FF:007239', NULL, NULL, 'Thymidine kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(189675, NULL, 'G3DSA:3.40.50.300:FF:001079', NULL, NULL, 'carbohydrate sulfotransferase 15', NULL, NULL, NULL, NULL, NULL, 4),
(189676, NULL, 'G3DSA:3.30.1360.140:FF:000004', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(189677, NULL, 'G3DSA:1.10.238.10:FF:000508', NULL, NULL, 'Probable calcium-binding protein CML35', NULL, NULL, NULL, NULL, NULL, 4),
(189678, NULL, 'G3DSA:2.30.30.100:FF:000026', NULL, NULL, 'Enhancer of mRNA-decapping protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(189679, NULL, 'G3DSA:2.10.25.10:FF:000831', NULL, NULL, 'von Willebrand factor D and EGF domains', NULL, NULL, NULL, NULL, NULL, 4),
(189680, NULL, 'G3DSA:1.10.1450.10:FF:000057', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(189681, NULL, 'G3DSA:3.30.160.60:FF:001050', NULL, NULL, 'zinc finger and BTB domain-containing protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(189682, NULL, 'G3DSA:1.20.1280.290:FF:000015', NULL, NULL, 'cystinosin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(189683, NULL, 'G3DSA:3.40.190.10:FF:000282', NULL, NULL, 'Nitrate ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(189684, NULL, 'G3DSA:1.20.58.100:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189685, NULL, 'G3DSA:2.60.40.150:FF:000429', NULL, NULL, 'SyNapTotagmin', NULL, NULL, NULL, NULL, NULL, 4),
(189686, NULL, 'G3DSA:3.40.50.150:FF:000589', NULL, NULL, 'tRNA methyltransferase 9B (putative)', NULL, NULL, NULL, NULL, NULL, 4),
(189687, NULL, 'G3DSA:3.40.1130.10:FF:000002', NULL, NULL, 'Glycerol-3-phosphate acyltransferase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(189688, NULL, 'G3DSA:3.20.20.70:FF:000127', NULL, NULL, 'Ferredoxin-dependent glutamate synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(189689, NULL, 'G3DSA:1.20.1720.10:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189690, NULL, 'G3DSA:1.20.58.1120:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189691, NULL, 'G3DSA:1.20.1250.20:FF:000632', NULL, NULL, 'YDR387C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(189692, NULL, 'G3DSA:3.40.120.10:FF:000069', NULL, NULL, 'Phosphomannomutase/phosphoglucomutase', NULL, NULL, NULL, NULL, NULL, 4),
(189693, NULL, 'G3DSA:3.40.50.410:FF:000364', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189694, NULL, 'G3DSA:3.40.1050.10:FF:000001', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(189695, NULL, 'G3DSA:3.40.50.80:FF:000002', NULL, NULL, 'Ferredoxin--NADP reductase', NULL, NULL, NULL, NULL, NULL, 4),
(189696, NULL, 'G3DSA:3.30.70.330:FF:000172', NULL, NULL, 'RNA splicing factor Pad-1', NULL, NULL, NULL, NULL, NULL, 4),
(189697, NULL, 'G3DSA:2.60.120.970:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189698, NULL, 'G3DSA:1.10.1410.40:FF:000007', NULL, NULL, 'Cyclic GMP-AMP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(189699, NULL, 'G3DSA:3.40.50.2000:FF:000587', NULL, NULL, 'Soyasaponin III rhamnosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(189700, NULL, 'G3DSA:2.120.10.80:FF:000026', NULL, NULL, 'Putative LOV domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(189701, NULL, 'G3DSA:3.30.40.10:FF:000610', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(189702, NULL, 'G3DSA:1.25.40.20:FF:001642', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189703, NULL, 'G3DSA:2.70.160.11:FF:000082', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(189704, NULL, 'G3DSA:3.90.180.10:FF:000079', NULL, NULL, 'Quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(189705, NULL, 'G3DSA:3.40.140.70:FF:000010', NULL, NULL, 'Ubiquitin-like modifier-activating enzyme ATG7', NULL, NULL, NULL, NULL, NULL, 4),
(189706, NULL, 'G3DSA:3.40.50.300:FF:004013', NULL, NULL, 'Putative DNA repair helicase', NULL, NULL, NULL, NULL, NULL, 4),
(189707, NULL, 'G3DSA:1.10.10.10:FF:000996', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189708, NULL, 'G3DSA:2.130.10.10:FF:003462', NULL, NULL, 'Type II inositol polyphosphate 5-phosphatase 15', NULL, NULL, NULL, NULL, NULL, 4),
(189709, NULL, 'G3DSA:3.10.20.30:FF:000043', NULL, NULL, 'Putative molybdenum cofactor biosynthesis protein D 2 moaD2', NULL, NULL, NULL, NULL, NULL, 4),
(189710, NULL, 'G3DSA:3.50.50.60:FF:000647', NULL, NULL, 'Putative oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(189711, NULL, 'G3DSA:3.30.40.10:FF:000138', NULL, NULL, 'CXXC-type zinc finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(189712, NULL, 'G3DSA:3.40.1190.10:FF:000011', NULL, NULL, 'Folylpolyglutamate synthase/dihydrofolate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(189713, NULL, 'G3DSA:3.90.1310.10:FF:000044', NULL, NULL, 'Peptidoglycan glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(189714, NULL, 'G3DSA:3.30.70.330:FF:002729', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189715, NULL, 'G3DSA:1.25.40.10:FF:002741', NULL, NULL, 'Outer membrane protein assembly factor BamD', NULL, NULL, NULL, NULL, NULL, 4),
(189716, NULL, 'G3DSA:3.30.70.20:FF:000115', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189717, NULL, 'G3DSA:3.10.110.10:FF:000339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189718, NULL, 'G3DSA:1.20.120.720:FF:000018', NULL, NULL, 'unconventional myosin-XVIIIa isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(189719, NULL, 'G3DSA:3.40.109.10:FF:000026', NULL, NULL, 'Nitroreductase', NULL, NULL, NULL, NULL, NULL, 4),
(189720, NULL, 'G3DSA:1.10.730.20:FF:000009', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(189721, NULL, 'G3DSA:1.10.3370.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189722, NULL, 'G3DSA:1.20.1070.10:FF:001666', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189723, NULL, 'G3DSA:3.40.190.80:FF:000050', NULL, NULL, 'Myo-inositol-1 phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(189724, NULL, 'G3DSA:3.40.50.2300:FF:000087', NULL, NULL, 'D-xylose ABC transporter, D-xylose-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(189725, NULL, 'G3DSA:3.30.70.3490:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189726, NULL, 'G3DSA:3.80.10.10:FF:002613', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189727, NULL, 'G3DSA:2.60.120.470:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189728, NULL, 'G3DSA:1.25.10.10:FF:002593', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189729, NULL, 'G3DSA:3.40.50.300:FF:005474', NULL, NULL, 'Type III restriction enzyme, res subunit', NULL, NULL, NULL, NULL, NULL, 4),
(189730, NULL, 'G3DSA:1.20.5.110:FF:000106', NULL, NULL, 'Vesicle-associated membrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(189731, NULL, 'G3DSA:2.70.170.10:FF:000283', NULL, NULL, 'Protein CBG01074', NULL, NULL, NULL, NULL, NULL, 4),
(189732, NULL, 'G3DSA:3.40.50.300:FF:003849', NULL, NULL, 'MRP family ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(189733, NULL, 'G3DSA:3.40.50.720:FF:001502', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189734, NULL, 'G3DSA:2.130.10.10:FF:003523', NULL, NULL, 'Small nucleolar ribonucleoprotein complex subunit Dip2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(189735, NULL, 'G3DSA:2.60.40.10:FF:004647', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189736, NULL, 'G3DSA:3.30.40.10:FF:000077', NULL, NULL, 'E3 ubiquitin-protein ligase SH3RF1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(189737, NULL, 'G3DSA:1.10.287.130:FF:000219', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(189738, NULL, 'G3DSA:2.130.10.10:FF:002534', NULL, NULL, 'WD40-repeat-containing domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(189739, NULL, 'G3DSA:1.25.40.510:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189740, NULL, 'G3DSA:1.10.1410.20:FF:000001', NULL, NULL, '2''-5''-oligoadenylate synthetase 1', NULL, NULL, NULL, NULL, NULL, 4),
(189741, NULL, 'G3DSA:1.20.140.10:FF:000015', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(189742, NULL, 'G3DSA:3.30.450.70:FF:000018', NULL, NULL, 'Unplaced genomic scaffold supercont2.18, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(189743, NULL, 'G3DSA:2.20.28.10:FF:000051', NULL, NULL, 'DNA replication licensing factor (Mcm)', NULL, NULL, NULL, NULL, NULL, 4),
(189744, NULL, 'G3DSA:2.40.40.20:FF:000071', NULL, NULL, 'AAA family ATPase, CDC48 subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(189745, NULL, 'G3DSA:3.30.1490.20:FF:000011', NULL, NULL, 'beta-citrylglutamate synthase B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(189746, NULL, 'G3DSA:3.30.160.20:FF:000156', NULL, NULL, 'APOBEC1 complementation factor isoform X1', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(189747, NULL, 'G3DSA:2.60.40.150:FF:000581', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189748, NULL, 'G3DSA:2.20.100.10:FF:000003', NULL, NULL, 'Adhesion G protein-coupled receptor B2', NULL, NULL, NULL, NULL, NULL, 4),
(189749, NULL, 'G3DSA:2.130.10.10:FF:003023', NULL, NULL, 'Cac2p', NULL, NULL, NULL, NULL, NULL, 4),
(189750, NULL, 'G3DSA:3.30.2460.20:FF:000004', NULL, NULL, 'Protein Wnt', NULL, NULL, NULL, NULL, NULL, 4),
(189751, NULL, 'G3DSA:1.20.1250.20:FF:002077', NULL, NULL, 'Plasma membrane hexose transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(189752, NULL, 'G3DSA:1.10.510.10:FF:002558', NULL, NULL, 'Air-1', NULL, NULL, NULL, NULL, NULL, 4),
(189753, NULL, 'G3DSA:3.20.20.190:FF:000167', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189754, NULL, 'G3DSA:1.10.510.10:FF:000260', NULL, NULL, 'TGF-beta receptor type-2', NULL, NULL, NULL, NULL, NULL, 4),
(189755, NULL, 'G3DSA:3.80.10.10:FF:003102', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(189756, NULL, 'G3DSA:3.40.50.2300:FF:000587', NULL, NULL, 'Transcriptional regulator, LacI family', NULL, NULL, NULL, NULL, NULL, 4),
(189757, NULL, 'G3DSA:1.10.1050.10:FF:000009', NULL, NULL, '30S ribosomal protein S4, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(189758, NULL, 'G3DSA:3.55.40.20:FF:000006', NULL, NULL, 'Superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(189759, NULL, 'G3DSA:3.30.40.10:FF:001919', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189760, NULL, 'G3DSA:1.20.1070.10:FF:000205', NULL, NULL, '[Arg8]-vasotocin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(189761, NULL, 'G3DSA:2.80.10.50:FF:000227', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(189762, NULL, 'G3DSA:2.30.39.10:FF:000019', NULL, NULL, 'Serpin 4', NULL, NULL, NULL, NULL, NULL, 4),
(189763, NULL, 'G3DSA:3.40.30.10:FF:000351', NULL, NULL, 'Protein disulfide isomerase-like 5-1', NULL, NULL, NULL, NULL, NULL, 4),
(189764, NULL, 'G3DSA:3.40.50.300:FF:004838', NULL, NULL, 'Response regulator receiver', NULL, NULL, NULL, NULL, NULL, 4),
(189765, NULL, 'G3DSA:3.90.228.10:FF:000016', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(189766, NULL, 'G3DSA:1.10.8.10:FF:000304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189767, NULL, 'G3DSA:3.90.70.10:FF:000183', NULL, NULL, 'Papain family cysteine protease', NULL, NULL, NULL, NULL, NULL, 4),
(189768, NULL, 'G3DSA:3.90.640.10:FF:000159', NULL, NULL, 'Heat shock protein 70 putative', NULL, NULL, NULL, NULL, NULL, 4),
(189769, NULL, 'G3DSA:2.60.120.200:FF:000156', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(189770, NULL, 'G3DSA:2.60.40.10:FF:005636', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189771, NULL, 'G3DSA:1.20.58.60:FF:000412', NULL, NULL, 'Dystonin isoform X9', NULL, NULL, NULL, NULL, NULL, 4),
(189772, NULL, 'G3DSA:1.20.1560.10:FF:000552', NULL, NULL, 'ABC Transporter, Mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(189773, NULL, 'G3DSA:3.100.10.10:FF:000002', NULL, NULL, '60S ribosomal protein L27a', NULL, NULL, NULL, NULL, NULL, 4),
(189774, NULL, 'G3DSA:2.10.55.10:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189775, NULL, 'G3DSA:3.40.50.300:FF:002068', NULL, NULL, 'CTP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(189776, NULL, 'G3DSA:1.10.510.10:FF:004503', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189777, NULL, 'G3DSA:2.70.150.10:FF:000248', NULL, NULL, 'Putative Pol polyprotein from transposon element Bs1', NULL, NULL, NULL, NULL, NULL, 4),
(189778, NULL, 'G3DSA:3.10.330.10:FF:000030', NULL, NULL, 'N-ethylmaleimide sensitive factor', NULL, NULL, NULL, NULL, NULL, 4),
(189779, NULL, 'G3DSA:2.40.50.140:FF:000826', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189780, NULL, 'G3DSA:1.20.1420.30:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189781, NULL, 'G3DSA:2.30.30.40:FF:000014', NULL, NULL, 'Kinase C and casein kinase substrate in neurons protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(189782, NULL, 'G3DSA:1.25.40.10:FF:003730', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At3g01580', NULL, NULL, NULL, NULL, NULL, 4),
(189783, NULL, 'G3DSA:3.40.140.10:FF:000071', NULL, NULL, 'Riboflavin biosynthesis protein PYRR, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(189784, NULL, 'G3DSA:3.30.1490.40:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189785, NULL, 'G3DSA:2.10.110.10:FF:000085', NULL, NULL, 'PDZ and LIM domain 2 (mystique)', NULL, NULL, NULL, NULL, NULL, 4),
(189786, NULL, 'G3DSA:3.90.640.10:FF:000098', NULL, NULL, 'Actin-related protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(189787, NULL, 'G3DSA:3.80.10.10:FF:000668', NULL, NULL, 'F-box/LRR-repeat protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(189788, NULL, 'G3DSA:3.90.226.10:FF:000034', NULL, NULL, 'Enoyl-CoA delta isomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(189789, NULL, 'G3DSA:3.30.430.20:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189790, NULL, 'G3DSA:3.30.160.60:FF:006221', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189791, NULL, 'G3DSA:1.25.10.10:FF:000204', NULL, NULL, 'Exportin 5', NULL, NULL, NULL, NULL, NULL, 4),
(189792, NULL, 'G3DSA:3.40.250.10:FF:000253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189793, NULL, 'G3DSA:1.20.120.1920:FF:000003', NULL, NULL, 'Ubiquitin-associated/translation elongation factor EF1B protein', NULL, NULL, NULL, NULL, NULL, 4),
(189794, NULL, 'G3DSA:3.40.1170.60:FF:000002', NULL, NULL, 'Polymerase (DNA directed) kappa', NULL, NULL, NULL, NULL, NULL, 4),
(189795, NULL, 'G3DSA:1.10.630.10:FF:000527', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189796, NULL, 'G3DSA:3.80.10.10:FF:002113', NULL, NULL, 'Leucine-rich repeat-containing protein 66', NULL, NULL, NULL, NULL, NULL, 4),
(189797, NULL, 'G3DSA:1.25.10.10:FF:002913', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189798, NULL, 'G3DSA:1.25.50.20:FF:000007', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(189799, NULL, 'G3DSA:1.10.555.10:FF:000110', NULL, NULL, 'RhoGAP domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(189800, NULL, 'G3DSA:2.40.10.340:FF:000013', NULL, NULL, 'Cell shape-determining protein MreC', NULL, NULL, NULL, NULL, NULL, 4),
(189801, NULL, 'G3DSA:3.30.60.30:FF:000179', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(189802, NULL, 'G3DSA:3.40.1350.10:FF:000013', NULL, NULL, 'Fanconi-associated nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(189803, NULL, 'G3DSA:2.60.40.1730:FF:000103', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189804, NULL, 'G3DSA:3.30.200.20:FF:002161', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189805, NULL, 'G3DSA:3.30.70.330:FF:002881', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189806, NULL, 'G3DSA:3.30.420.60:FF:000008', NULL, NULL, 'Pelota, putative', NULL, NULL, NULL, NULL, NULL, 4),
(189807, NULL, 'G3DSA:1.10.275.60:FF:000002', NULL, NULL, 'Adenylosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(189808, NULL, 'G3DSA:3.40.50.2300:FF:001104', NULL, NULL, 'Extracellular calcium-sensing receptor', NULL, NULL, NULL, NULL, NULL, 4),
(189809, NULL, 'G3DSA:3.30.470.20:FF:000027', NULL, NULL, 'Formate-dependent phosphoribosylglycinamide formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(189810, NULL, 'G3DSA:3.30.420.40:FF:000002', NULL, NULL, 'Muscle actin', NULL, NULL, NULL, NULL, NULL, 4),
(189811, NULL, 'G3DSA:3.30.160.60:FF:002798', NULL, NULL, 'Zinc finger protein 623', NULL, NULL, NULL, NULL, NULL, 4),
(189812, NULL, 'G3DSA:2.60.120.970:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189813, NULL, 'G3DSA:3.10.580.10:FF:000009', NULL, NULL, 'Glycine betaine/L-proline ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(189814, NULL, 'G3DSA:3.20.20.150:FF:000003', NULL, NULL, 'L-ribulose-5-phosphate 3-epimerase UlaE', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(189815, NULL, 'G3DSA:1.10.8.50:FF:000029', NULL, NULL, 'Type 2 DNA topoisomerase 6 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(189816, NULL, 'G3DSA:1.25.40.10:FF:001313', NULL, NULL, 'Os08g0162200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(189817, NULL, 'G3DSA:1.10.20.10:FF:000289', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189818, NULL, 'G3DSA:1.50.10.10:FF:000051', NULL, NULL, 'Cellobiose phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(189819, NULL, 'G3DSA:1.20.1560.10:FF:000905', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189820, NULL, 'G3DSA:3.40.1280.10:FF:000069', NULL, NULL, 'rRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(189821, NULL, 'G3DSA:1.10.10.10:FF:000496', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(189822, NULL, 'G3DSA:3.40.1770.10:FF:000005', NULL, NULL, 'Probable urocanate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(189823, NULL, 'G3DSA:1.20.58.60:FF:000379', NULL, NULL, 'Spectrin beta chain, non-erythrocytic', NULL, NULL, NULL, NULL, NULL, 4),
(189824, NULL, 'G3DSA:1.25.10.10:FF:003077', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189825, NULL, 'G3DSA:3.40.50.720:FF:001002', NULL, NULL, 'Molybdopterin biosynthesis protein MoeB', NULL, NULL, NULL, NULL, NULL, 4),
(189826, NULL, 'G3DSA:3.10.580.10:FF:000189', NULL, NULL, 'Hemolysin protein', NULL, NULL, NULL, NULL, NULL, 4),
(189827, NULL, 'G3DSA:1.25.40.10:FF:000032', NULL, NULL, 'Interferon-induced protein with tetratricopeptide repeats 5', NULL, NULL, NULL, NULL, NULL, 4),
(189828, NULL, 'G3DSA:1.20.5.1940:FF:000001', NULL, NULL, 'Vacuolar protein sorting-associated protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(189829, NULL, 'G3DSA:3.40.50.2000:FF:000907', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(189830, NULL, 'G3DSA:3.30.230.10:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189831, NULL, 'G3DSA:3.10.20.230:FF:000013', NULL, NULL, 'Serine/threonine-protein kinase DCLK3', NULL, NULL, NULL, NULL, NULL, 4),
(189832, NULL, 'G3DSA:2.40.10.10:FF:000386', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189833, NULL, 'G3DSA:3.50.50.60:FF:000147', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(189834, NULL, 'G3DSA:3.20.20.140:FF:000085', NULL, NULL, 'Enamidase', NULL, NULL, NULL, NULL, NULL, 4),
(189835, NULL, 'G3DSA:1.20.1740.10:FF:000178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189836, NULL, 'G3DSA:2.60.200.40:FF:000022', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(189837, NULL, 'G3DSA:3.40.50.300:FF:007891', NULL, NULL, 'Dynein heavy chain domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(189838, NULL, 'G3DSA:2.60.40.1170:FF:000036', NULL, NULL, 'stonin-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(189839, NULL, 'G3DSA:3.10.129.10:FF:000124', NULL, NULL, 'Putative esterase PA0474', NULL, NULL, NULL, NULL, NULL, 4),
(189840, NULL, 'G3DSA:1.10.10.10:FF:001513', NULL, NULL, 'Transcriptional adapter 2-beta', NULL, NULL, NULL, NULL, NULL, 4),
(189841, NULL, 'G3DSA:3.30.70.360:FF:000035', NULL, NULL, 'Probable hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(189842, NULL, 'G3DSA:3.30.497.10:FF:000058', NULL, NULL, 'Serpin family F member 2', NULL, NULL, NULL, NULL, NULL, 4),
(189843, NULL, 'G3DSA:3.40.50.720:FF:002430', NULL, NULL, '2-dehydropantoate 2-reductase, putative (AFU_orthologue AFUA_3G06390)', NULL, NULL, NULL, NULL, NULL, 4),
(189844, NULL, 'G3DSA:1.25.40.20:FF:000361', NULL, NULL, 'Swi4p', NULL, NULL, NULL, NULL, NULL, 4),
(189845, NULL, 'G3DSA:3.30.160.60:FF:000561', NULL, NULL, 'Zinc finger protein 30 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(189846, NULL, 'G3DSA:3.40.50.150:FF:000617', NULL, NULL, 'Endothelin-converting enzyme 2', NULL, NULL, NULL, NULL, NULL, 4),
(189847, NULL, 'G3DSA:3.30.70.1050:FF:000012', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(189848, NULL, 'G3DSA:2.60.40.10:FF:005136', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(189849, NULL, 'G3DSA:2.30.30.40:FF:000514', NULL, NULL, 'Protein CBR-SMA-1', NULL, NULL, NULL, NULL, NULL, 4),
(189850, NULL, 'G3DSA:3.40.50.1240:FF:000084', NULL, NULL, '2-phosphoxylose phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(189851, NULL, 'G3DSA:3.30.1120.30:FF:000021', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(189852, NULL, 'G3DSA:2.30.29.30:FF:000851', NULL, NULL, 'TFIIH/NER complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(189853, NULL, 'G3DSA:3.90.1410.10:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189854, NULL, 'G3DSA:3.40.640.10:FF:000064', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(189855, NULL, 'G3DSA:3.30.40.10:FF:000577', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(189856, NULL, 'G3DSA:2.10.25.10:FF:001348', NULL, NULL, 'von Willebrand factor D and EGF domains', NULL, NULL, NULL, NULL, NULL, 4),
(189857, NULL, 'G3DSA:1.20.140.40:FF:000030', NULL, NULL, 'OSJNBa0027P08.11 protein', NULL, NULL, NULL, NULL, NULL, 4),
(189858, NULL, 'G3DSA:3.40.190.10:FF:000343', NULL, NULL, 'NMDA receptor 2, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(189859, NULL, 'G3DSA:1.10.287.130:FF:000158', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(189860, NULL, 'G3DSA:3.30.1120.30:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189861, NULL, 'G3DSA:3.10.20.90:FF:000746', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189862, NULL, 'G3DSA:2.60.40.10:FF:002410', NULL, NULL, 'Synaptogenesis protein syg-1', NULL, NULL, NULL, NULL, NULL, 4),
(189863, NULL, 'G3DSA:1.25.40.10:FF:001460', NULL, NULL, 'SEL1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(189864, NULL, 'G3DSA:2.60.15.10:FF:000008', NULL, NULL, 'Putative Mitochondrial ATP synthase delta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(189865, NULL, 'G3DSA:1.10.2000.10:FF:000063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189866, NULL, 'G3DSA:1.10.238.20:FF:000045', NULL, NULL, 'GM23030', NULL, NULL, NULL, NULL, NULL, 4),
(189867, NULL, 'G3DSA:1.10.357.10:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189868, NULL, 'G3DSA:2.60.120.380:FF:000018', NULL, NULL, 'Calpain-c', NULL, NULL, NULL, NULL, NULL, 4),
(189869, NULL, 'G3DSA:1.20.5.190:FF:000175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189870, NULL, 'G3DSA:3.30.450.20:FF:000375', NULL, NULL, 'Sensor histidine kinase/response regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(189871, NULL, 'G3DSA:1.10.340.30:FF:000027', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(189872, NULL, 'G3DSA:1.10.510.10:FF:000760', NULL, NULL, 'Spire, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(189873, NULL, 'G3DSA:3.40.390.10:FF:000263', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189874, NULL, 'G3DSA:2.130.10.10:FF:005940', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189875, NULL, 'G3DSA:3.50.50.60:FF:000294', NULL, NULL, 'Probable monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(189876, NULL, 'G3DSA:1.10.510.10:FF:003486', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189877, NULL, 'G3DSA:3.30.9.10:FF:000105', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(189878, NULL, 'G3DSA:3.80.10.10:FF:001596', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(189879, NULL, 'G3DSA:1.10.1070.11:FF:000080', NULL, NULL, 'Acyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(189880, NULL, 'G3DSA:3.30.300.30:FF:000018', NULL, NULL, 'Non-ribosomal peptide synthetase 3', NULL, NULL, NULL, NULL, NULL, 4),
(189881, NULL, 'G3DSA:1.10.287.110:FF:000152', NULL, NULL, 'DnaJ family protein', NULL, NULL, NULL, NULL, NULL, 4),
(189882, NULL, 'G3DSA:3.20.20.140:FF:000113', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(189883, NULL, 'G3DSA:1.20.1720.10:FF:000087', NULL, NULL, 'Bcr/CflA family efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(189884, NULL, 'G3DSA:3.40.1110.10:FF:000411', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189885, NULL, 'G3DSA:1.10.472.10:FF:000715', NULL, NULL, 'G2/M mitosis-specific cyclin B, copy C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(189886, NULL, 'G3DSA:3.90.180.10:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189887, NULL, 'G3DSA:3.30.70.1070:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189888, NULL, 'G3DSA:1.20.1070.10:FF:000705', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189889, NULL, 'G3DSA:1.10.10.10:FF:000024', NULL, NULL, 'U5 small nuclear ribonucleoprotein helicase', NULL, NULL, NULL, NULL, NULL, 4),
(189890, NULL, 'G3DSA:3.30.70.1230:FF:000061', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(189891, NULL, 'G3DSA:2.120.10.30:FF:000444', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189892, NULL, 'G3DSA:3.30.900.10:FF:000036', NULL, NULL, 'Autophagy-related protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(189893, NULL, 'G3DSA:3.30.1140.60:FF:000008', NULL, NULL, 'F-actin-capping protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(189894, NULL, 'G3DSA:1.10.510.10:FF:004003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189895, NULL, 'G3DSA:1.10.437.20:FF:000002', NULL, NULL, 'Protein C6', NULL, NULL, NULL, NULL, NULL, 4),
(189896, NULL, 'G3DSA:2.60.40.650:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189897, NULL, 'G3DSA:2.130.10.10:FF:003170', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189898, NULL, 'G3DSA:2.160.20.70:FF:000022', NULL, NULL, 'Alpha tubulin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(189899, NULL, 'G3DSA:3.80.10.10:FF:003574', NULL, NULL, 'F-box and leucine rich repeat protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(189900, NULL, 'G3DSA:1.10.472.10:FF:000687', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189901, NULL, 'G3DSA:1.25.40.10:FF:002802', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189902, NULL, 'G3DSA:2.60.40.60:FF:000547', NULL, NULL, 'Cadherin-related hmr-1', NULL, NULL, NULL, NULL, NULL, 4),
(189903, NULL, 'G3DSA:2.60.40.4060:FF:000009', NULL, NULL, 'spondin-1', NULL, NULL, NULL, NULL, NULL, 4),
(189904, NULL, 'G3DSA:3.40.20.10:FF:000114', NULL, NULL, 'YALI0B14102p', NULL, NULL, NULL, NULL, NULL, 4),
(189905, NULL, 'G3DSA:1.20.5.170:FF:000017', NULL, NULL, 'Putative E3 ubiquitin-protein ligase TRIM9', NULL, NULL, NULL, NULL, NULL, 4),
(189906, NULL, 'G3DSA:1.10.357.20:FF:000001', NULL, NULL, 'Solute carrier family 41 member 2', NULL, NULL, NULL, NULL, NULL, 4),
(189907, NULL, 'G3DSA:1.10.510.10:FF:003514', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189908, NULL, 'G3DSA:1.25.40.20:FF:000653', NULL, NULL, 'Ankyrin repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(189909, NULL, 'G3DSA:3.90.850.10:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189910, NULL, 'G3DSA:3.40.50.12650:FF:000021', NULL, NULL, 'Protein artemis', NULL, NULL, NULL, NULL, NULL, 4),
(189911, NULL, 'G3DSA:3.30.70.330:FF:001009', NULL, NULL, 'Protein CBR-RSP-5', NULL, NULL, NULL, NULL, NULL, 4),
(189912, NULL, 'G3DSA:2.60.40.10:FF:001893', NULL, NULL, 'Twitchin', NULL, NULL, NULL, NULL, NULL, 4),
(189913, NULL, 'G3DSA:3.30.1140.40:FF:000002', NULL, NULL, 'Dynein light chain Tctex-type 3', NULL, NULL, NULL, NULL, NULL, 4),
(189914, NULL, 'G3DSA:1.10.287.2900:FF:000001', NULL, NULL, 'mitochondrial intermembrane space import and assembly protein 40', NULL, NULL, NULL, NULL, NULL, 4),
(189915, NULL, 'G3DSA:2.60.40.10:FF:003719', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189916, NULL, 'G3DSA:1.20.1250.20:FF:000132', NULL, NULL, 'sugar phosphate exchanger 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(189917, NULL, 'G3DSA:2.60.120.290:FF:000082', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(189918, NULL, 'G3DSA:3.30.1350.20:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189919, NULL, 'G3DSA:1.10.20.130:FF:000002', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(189920, NULL, 'G3DSA:2.40.50.140:FF:000798', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189921, NULL, 'G3DSA:3.30.300.30:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189922, NULL, 'G3DSA:1.25.40.10:FF:002269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189923, NULL, 'G3DSA:3.40.50.300:FF:003557', NULL, NULL, 'L-seryl-tRNA(Sec) kinase', NULL, NULL, NULL, NULL, NULL, 4),
(189924, NULL, 'G3DSA:3.10.450.10:FF:000005', NULL, NULL, 'Histidine-rich glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(189925, NULL, 'G3DSA:1.20.1560.10:FF:000113', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(189926, NULL, 'G3DSA:2.10.230.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189927, NULL, 'G3DSA:2.130.10.10:FF:001606', NULL, NULL, 'Uncharacterized protein, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(189928, NULL, 'G3DSA:3.30.750.24:FF:000161', NULL, NULL, 'Sodium-independent sulfate anion transporter-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(189929, NULL, 'G3DSA:3.40.50.2000:FF:000295', NULL, NULL, 'Phosphatidylinositol N-acetylglucosaminyltransferase subunit A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(189930, NULL, 'G3DSA:3.40.720.10:FF:000065', NULL, NULL, 'Arylsulfatase A', NULL, NULL, NULL, NULL, NULL, 4),
(189931, NULL, 'G3DSA:2.60.40.10:FF:005283', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189932, NULL, 'G3DSA:3.30.559.10:FF:000163', NULL, NULL, 'Nonribosomal peptide synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(189933, NULL, 'G3DSA:3.90.980.20:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189934, NULL, 'G3DSA:3.40.1380.20:FF:000023', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(189935, NULL, 'G3DSA:3.40.50.300:FF:004485', NULL, NULL, 'DNA repair protein RecN', NULL, NULL, NULL, NULL, NULL, 4),
(189936, NULL, 'G3DSA:3.30.565.10:FF:000104', NULL, NULL, 'Sensor histidine kinase/response regulator TcsB/Sln1', NULL, NULL, NULL, NULL, NULL, 4),
(189937, NULL, 'G3DSA:3.30.450.40:FF:000122', NULL, NULL, 'Phytochrome-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(189938, NULL, 'G3DSA:3.30.930.10:FF:000156', NULL, NULL, 'YER087W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(189939, NULL, 'G3DSA:4.10.60.10:FF:000144', NULL, NULL, 'ATP-dependent RNA helicase glh-2', NULL, NULL, NULL, NULL, NULL, 4),
(189940, NULL, 'G3DSA:1.20.5.170:FF:000197', NULL, NULL, 'C-type lectin domain family 4 member F', NULL, NULL, NULL, NULL, NULL, 4),
(189941, NULL, 'G3DSA:2.130.10.10:FF:004451', NULL, NULL, 'Ribosome biogenesis protein WDR12 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(189942, NULL, 'G3DSA:3.40.850.10:FF:000310', NULL, NULL, 'Kinesin family member C2', NULL, NULL, NULL, NULL, NULL, 4),
(189943, NULL, 'G3DSA:3.30.160.60:FF:002770', NULL, NULL, 'ZNF256 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(189944, NULL, 'G3DSA:3.20.10.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189945, NULL, 'G3DSA:1.20.1070.10:FF:002122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189946, NULL, 'G3DSA:1.10.1490.10:FF:000003', NULL, NULL, 'DNA fragmentation factor, alpha polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(189947, NULL, 'G3DSA:3.40.50.300:FF:005766', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189948, NULL, 'G3DSA:4.10.280.10:FF:000078', NULL, NULL, 'Transcription factor bHLH13', NULL, NULL, NULL, NULL, NULL, 4),
(189949, NULL, 'G3DSA:1.20.1250.20:FF:002105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189950, NULL, 'G3DSA:3.30.1120.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189951, NULL, 'G3DSA:2.70.130.10:FF:000157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(189952, NULL, 'G3DSA:3.90.70.10:FF:000475', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189953, NULL, 'G3DSA:3.30.429.10:FF:000007', NULL, NULL, 'Macrophage migration inhibitory factor', NULL, NULL, NULL, NULL, NULL, 4),
(189954, NULL, 'G3DSA:3.30.160.60:FF:001842', NULL, NULL, 'Zinc finger protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(189955, NULL, 'G3DSA:2.40.30.30:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189956, NULL, 'G3DSA:3.30.40.10:FF:001066', NULL, NULL, 'Zinc finger family protein', NULL, NULL, NULL, NULL, NULL, 4),
(189957, NULL, 'G3DSA:3.30.60.30:FF:000207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189958, NULL, 'G3DSA:2.60.34.10:FF:000052', NULL, NULL, 'Hsp70_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(189959, NULL, 'G3DSA:1.10.20.10:FF:000261', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189960, NULL, 'G3DSA:2.60.40.1910:FF:000005', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(189961, NULL, 'G3DSA:3.40.1690.10:FF:000004', NULL, NULL, 'SPI-2 type III secretion system apparatus protein SsaU', NULL, NULL, NULL, NULL, NULL, 4),
(189962, NULL, 'G3DSA:2.160.20.10:FF:000111', NULL, NULL, 'Pectin lyase-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(189963, NULL, 'G3DSA:1.20.58.1030:FF:000026', NULL, NULL, 'Psf-1', NULL, NULL, NULL, NULL, NULL, 4),
(189964, NULL, 'G3DSA:2.10.110.10:FF:000113', NULL, NULL, 'LIM domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(189965, NULL, 'G3DSA:3.30.310.80:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189966, NULL, 'G3DSA:1.10.490.10:FF:000055', NULL, NULL, 'Hemoglobin cathodic subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(189967, NULL, 'G3DSA:3.20.20.70:FF:000599', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189968, NULL, 'G3DSA:3.40.50.10810:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189969, NULL, 'G3DSA:3.40.50.10940:FF:000002', NULL, NULL, 'L-arabinose isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(189970, NULL, 'G3DSA:3.40.50.300:FF:007711', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189971, NULL, 'G3DSA:2.40.50.140:FF:001023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189972, NULL, 'G3DSA:1.20.1050.10:FF:000294', NULL, NULL, 'Safener induced1', NULL, NULL, NULL, NULL, NULL, 4),
(189973, NULL, 'G3DSA:3.40.50.2300:FF:000879', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189974, NULL, 'G3DSA:3.30.200.20:FF:000744', NULL, NULL, 'Aminoglycoside phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(189975, NULL, 'G3DSA:2.60.40.10:FF:003158', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(189976, NULL, 'G3DSA:3.30.160.60:FF:002359', NULL, NULL, 'Zinc finger protein 432', NULL, NULL, NULL, NULL, NULL, 4),
(189977, NULL, 'G3DSA:1.10.8.60:FF:000358', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(189978, NULL, 'G3DSA:2.40.128.20:FF:000021', NULL, NULL, 'Outer membrane lipoprotein Blc', NULL, NULL, NULL, NULL, NULL, 4),
(189979, NULL, 'G3DSA:3.40.33.10:FF:000032', NULL, NULL, 'Predicted extracellular protein', NULL, NULL, NULL, NULL, NULL, 4),
(189980, NULL, 'G3DSA:4.10.280.10:FF:000050', NULL, NULL, 'Basic helix-loop-helix transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(189981, NULL, 'G3DSA:1.20.1250.20:FF:002369', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189982, NULL, 'G3DSA:1.10.155.10:FF:000001', NULL, NULL, 'Chemotaxis methyltransferase CheR', NULL, NULL, NULL, NULL, NULL, 4),
(189983, NULL, 'G3DSA:3.80.10.10:FF:004058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189984, NULL, 'G3DSA:1.20.1560.10:FF:000260', NULL, NULL, 'ABC transporter ATP-binding/membrane-spanning-hemolysin secretion protein', NULL, NULL, NULL, NULL, NULL, 4),
(189985, NULL, 'G3DSA:2.40.160.120:FF:000032', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(189986, NULL, 'G3DSA:3.40.50.10130:FF:000024', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(189987, NULL, 'G3DSA:1.20.120.1070:FF:000001', NULL, NULL, 'Eukaryotic translation initiation factor 2B subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(189988, NULL, 'G3DSA:2.40.420.20:FF:000037', NULL, NULL, 'RND family efflux transporter, MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(189989, NULL, 'G3DSA:4.10.240.10:FF:000132', NULL, NULL, 'Transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(189990, NULL, 'G3DSA:3.80.10.10:FF:002905', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189991, NULL, 'G3DSA:2.60.40.10:FF:005928', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189992, NULL, 'G3DSA:3.40.850.10:FF:000490', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(189993, NULL, 'G3DSA:1.10.1670.10:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189994, NULL, 'G3DSA:3.40.50.620:FF:000601', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189995, NULL, 'G3DSA:1.10.10.60:FF:001034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(189996, NULL, 'G3DSA:1.25.10.10:FF:002121', NULL, NULL, 'Cell division control protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(189997, NULL, 'G3DSA:2.130.10.10:FF:003815', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(189998, NULL, 'G3DSA:3.20.20.80:FF:000395', NULL, NULL, 'AGAP001863-PB', NULL, NULL, NULL, NULL, NULL, 4),
(189999, NULL, 'G3DSA:3.30.70.330:FF:001420', NULL, NULL, 'RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(190000, NULL, 'G3DSA:3.40.50.300:FF:008228', NULL, NULL, 'TBC1 domain family member 15', NULL, NULL, NULL, NULL, NULL, 4),
(190001, NULL, 'G3DSA:1.10.287.380:FF:000036', NULL, NULL, 'ABC transporter ATP-binding protein uup-1', NULL, NULL, NULL, NULL, NULL, 4),
(190002, NULL, 'G3DSA:3.30.710.10:FF:000206', NULL, NULL, 'G protein RhoBTB', NULL, NULL, NULL, NULL, NULL, 4),
(190003, NULL, 'G3DSA:3.40.50.880:FF:000128', NULL, NULL, 'Os01g0217500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(190004, NULL, 'G3DSA:2.130.10.10:FF:001045', NULL, NULL, 'Cleavage stimulation factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(190005, NULL, 'G3DSA:1.20.1300.20:FF:000013', NULL, NULL, 'Ubiquitin thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(190006, NULL, 'G3DSA:4.10.260.10:FF:000015', NULL, NULL, 'Guanine nucleotide-binding protein (G protein), gamma 8', NULL, NULL, NULL, NULL, NULL, 4),
(190007, NULL, 'G3DSA:1.10.1670.10:FF:000068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190008, NULL, 'G3DSA:3.40.50.620:FF:000629', NULL, NULL, 'Electron transfer flavoprotein alpha-subunit', NULL, NULL, NULL, NULL, NULL, 4),
(190009, NULL, 'G3DSA:3.30.500.40:FF:000003', NULL, NULL, 'Zinc finger FYVE domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(190010, NULL, 'G3DSA:1.25.10.10:FF:001632', NULL, NULL, 'Plakophilin-4', NULL, NULL, NULL, NULL, NULL, 4),
(190011, NULL, 'G3DSA:1.20.58.390:FF:000032', NULL, NULL, 'gamma-aminobutyric acid receptor subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(190012, NULL, 'G3DSA:2.60.420.10:FF:000018', NULL, NULL, 'Nigerose phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(190013, NULL, 'G3DSA:3.90.70.10:FF:000211', NULL, NULL, 'Clan CA, family C1, cathepsin H-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(190014, NULL, 'G3DSA:1.10.260.140:FF:000001', NULL, NULL, 'Cytosine-specific methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(190015, NULL, 'G3DSA:3.40.30.10:FF:001099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190016, NULL, 'G3DSA:3.30.70.2850:FF:000030', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(190017, NULL, 'G3DSA:3.30.565.10:FF:000284', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(190018, NULL, 'G3DSA:3.40.50.1000:FF:000124', NULL, NULL, 'HAD-family hydrolase IIA', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(190019, NULL, 'G3DSA:2.60.120.10:FF:000737', NULL, NULL, 'Cyclic nucleotide-gated potassium channel', NULL, NULL, NULL, NULL, NULL, 4),
(190020, NULL, 'G3DSA:1.10.8.10:FF:000276', NULL, NULL, 'AaceriACL055Wp', NULL, NULL, NULL, NULL, NULL, 4),
(190021, NULL, 'G3DSA:2.60.200.20:FF:000275', NULL, NULL, 'Adenylate cyclase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(190022, NULL, 'G3DSA:3.40.50.2000:FF:000115', NULL, NULL, 'Alpha-(1-6)-phosphatidylinositol monomannoside mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(190023, NULL, 'G3DSA:3.40.50.720:FF:001974', NULL, NULL, 'Putative short-chain dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(190024, NULL, 'G3DSA:3.30.160.60:FF:004304', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190025, NULL, 'G3DSA:3.50.50.60:FF:000939', NULL, NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(190026, NULL, 'G3DSA:1.20.1730.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190027, NULL, 'G3DSA:3.30.40.10:FF:000638', NULL, NULL, 'PHD finger family protein', NULL, NULL, NULL, NULL, NULL, 4),
(190028, NULL, 'G3DSA:3.30.450.20:FF:000144', NULL, NULL, 'Nuclear receptor coactivator 2', NULL, NULL, NULL, NULL, NULL, 4),
(190029, NULL, 'G3DSA:3.40.50.1820:FF:001207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190030, NULL, 'G3DSA:3.30.200.20:FF:001525', NULL, NULL, 'Ribosomal protein S6 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(190031, NULL, 'G3DSA:3.80.10.10:FF:004119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190032, NULL, 'G3DSA:1.10.760.10:FF:000008', NULL, NULL, 'Cytochrome c', NULL, NULL, NULL, NULL, NULL, 4),
(190033, NULL, 'G3DSA:3.90.190.20:FF:000026', NULL, NULL, 'UDP-N-acetylmuramoylalanine--D-glutamate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(190034, NULL, 'G3DSA:3.40.50.300:FF:003349', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(190035, NULL, 'G3DSA:3.30.63.20:FF:000003', NULL, NULL, '40S ribosomal protein S25-2', NULL, NULL, NULL, NULL, NULL, 4),
(190036, NULL, 'G3DSA:3.40.50.1100:FF:000036', NULL, NULL, 'Threonine synthase like 2', NULL, NULL, NULL, NULL, NULL, 4),
(190037, NULL, 'G3DSA:2.30.170.20:FF:000020', NULL, NULL, 'Predicted gene 20509', NULL, NULL, NULL, NULL, NULL, 4),
(190038, NULL, 'G3DSA:3.30.70.1350:FF:000012', NULL, NULL, 'Cation diffusion facilitator 10', NULL, NULL, NULL, NULL, NULL, 4),
(190039, NULL, 'G3DSA:3.30.160.60:FF:001342', NULL, NULL, 'Combgap, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(190040, NULL, 'G3DSA:1.10.472.10:FF:000187', NULL, NULL, 'Putative cyclin 9', NULL, NULL, NULL, NULL, NULL, 4),
(190041, NULL, 'G3DSA:1.20.5.110:FF:000078', NULL, NULL, 'Vesicle transport through interaction with t-SNAREs 1A', NULL, NULL, NULL, NULL, NULL, 4),
(190042, NULL, 'G3DSA:3.30.780.10:FF:000008', NULL, NULL, 'eukaryotic translation initiation factor 2D', NULL, NULL, NULL, NULL, NULL, 4),
(190043, NULL, 'G3DSA:3.30.200.20:FF:001997', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190044, NULL, 'G3DSA:1.50.40.10:FF:000440', NULL, NULL, 'Solute carrier family 25, member 38b', NULL, NULL, NULL, NULL, NULL, 4),
(190045, NULL, 'G3DSA:1.20.1250.20:FF:000340', NULL, NULL, 'MFS transporter, SHS family, lactate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(190046, NULL, 'G3DSA:2.30.29.30:FF:000087', NULL, NULL, 'FERM, RhoGEF and pleckstrin domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(190047, NULL, 'G3DSA:3.30.70.3220:FF:000006', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(190048, NULL, 'G3DSA:3.30.70.250:FF:000002', NULL, NULL, 'Malonyl CoA-ACP transacylase', NULL, NULL, NULL, NULL, NULL, 4),
(190049, NULL, 'G3DSA:3.40.50.1000:FF:000416', NULL, NULL, 'Bifunctional epoxide hydrolase 2', NULL, NULL, NULL, NULL, NULL, 4),
(190050, NULL, 'G3DSA:3.30.1370.10:FF:000027', NULL, NULL, 'insulin-like growth factor 2 mRNA-binding protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(190051, NULL, 'G3DSA:2.170.270.10:FF:000042', NULL, NULL, 'Variant-silencing SET protein', NULL, NULL, NULL, NULL, NULL, 4),
(190052, NULL, 'G3DSA:2.60.120.10:FF:000092', NULL, NULL, 'Mannose-6-phosphate isomerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190053, NULL, 'G3DSA:3.20.20.80:FF:000748', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190054, NULL, 'G3DSA:3.40.50.300:FF:000123', NULL, NULL, 'Peptide chain release factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(190055, NULL, 'G3DSA:3.30.420.10:FF:000218', NULL, NULL, 'RNA exonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190056, NULL, 'G3DSA:3.90.79.10:FF:000264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190057, NULL, 'G3DSA:2.10.50.30:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190058, NULL, 'G3DSA:2.60.40.790:FF:000065', NULL, NULL, 'Heat shock protein', NULL, NULL, NULL, NULL, NULL, 4),
(190059, NULL, 'G3DSA:3.60.130.20:FF:000001', NULL, NULL, 'Putative oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(190060, NULL, 'G3DSA:3.40.50.300:FF:004985', NULL, NULL, 'Branched-chain amino acid ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(190061, NULL, 'G3DSA:2.60.120.200:FF:000656', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190062, NULL, 'G3DSA:1.10.10.60:FF:000286', NULL, NULL, 'Homeobox transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(190063, NULL, 'G3DSA:3.80.10.10:FF:004030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190064, NULL, 'G3DSA:3.40.850.10:FF:000338', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(190065, NULL, 'G3DSA:3.30.70.330:FF:000672', NULL, NULL, 'Splicing factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(190066, NULL, 'G3DSA:2.40.50.100:FF:000101', NULL, NULL, 'Exosome component 3', NULL, NULL, NULL, NULL, NULL, 4),
(190067, NULL, 'G3DSA:3.30.360.10:FF:000016', NULL, NULL, 'Probable aspartate-semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(190068, NULL, 'G3DSA:2.130.10.10:FF:000297', NULL, NULL, 'DDB1- and CUL4-associated factor 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(190069, NULL, 'G3DSA:3.10.20.870:FF:000002', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(190070, NULL, 'G3DSA:3.90.640.10:FF:000131', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(190071, NULL, 'G3DSA:3.90.180.10:FF:000051', NULL, NULL, 'Alcohol dehydrogenase (Zinc)', NULL, NULL, NULL, NULL, NULL, 4),
(190072, NULL, 'G3DSA:1.10.1520.10:FF:000001', NULL, NULL, 'Ribonuclease 3', NULL, NULL, NULL, NULL, NULL, 4),
(190073, NULL, 'G3DSA:3.40.50.150:FF:001253', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190074, NULL, 'G3DSA:3.30.2160.10:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190075, NULL, 'G3DSA:1.25.40.10:FF:000532', NULL, NULL, 'Clustered mitochondria protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(190076, NULL, 'G3DSA:2.130.10.10:FF:001253', NULL, NULL, 'Peroxin 7, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(190077, NULL, 'G3DSA:3.40.50.2300:FF:000615', NULL, NULL, 'Sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(190078, NULL, 'G3DSA:3.40.47.10:FF:000266', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190079, NULL, 'G3DSA:3.40.50.12780:FF:000032', NULL, NULL, 'Acyl--CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(190080, NULL, 'G3DSA:3.10.590.10:FF:000015', NULL, NULL, 'Benign gonial cell neoplasm', NULL, NULL, NULL, NULL, NULL, 4),
(190081, NULL, 'G3DSA:2.60.120.290:FF:000143', NULL, NULL, 'MGC130869 protein', NULL, NULL, NULL, NULL, NULL, 4),
(190082, NULL, 'G3DSA:3.90.550.10:FF:000540', NULL, NULL, 'Cellulose synthase-like D7, glycosyltransferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(190083, NULL, 'G3DSA:3.30.420.80:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(190084, NULL, 'G3DSA:3.30.230.10:FF:000035', NULL, NULL, '28S ribosomal protein S9, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(190085, NULL, 'G3DSA:3.40.50.300:FF:001904', NULL, NULL, 'U5 small nuclear ribonucleoprotein-specific protein', NULL, NULL, NULL, NULL, NULL, 4),
(190086, NULL, 'G3DSA:2.60.40.10:FF:006064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190087, NULL, 'G3DSA:1.20.58.530:FF:000029', NULL, NULL, 'Probable chitin synthase 8', NULL, NULL, NULL, NULL, NULL, 4),
(190088, NULL, 'G3DSA:3.30.860.10:FF:000009', NULL, NULL, 'Ribosomal protein S15', NULL, NULL, NULL, NULL, NULL, 4),
(190089, NULL, 'G3DSA:3.40.630.30:FF:000513', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(190090, NULL, 'G3DSA:3.30.530.20:FF:000145', NULL, NULL, 'Phosphatidylinositol transfer protein, membrane-associated 2', NULL, NULL, NULL, NULL, NULL, 4),
(190091, NULL, 'G3DSA:1.20.1270.60:FF:000095', NULL, NULL, 'Hydroxyproline-rich glycoprotein family protein', NULL, NULL, NULL, NULL, NULL, 4),
(190092, NULL, 'G3DSA:3.10.129.10:FF:000096', NULL, NULL, 'UPF0336 protein C9J59_003700', NULL, NULL, NULL, NULL, NULL, 4),
(190093, NULL, 'G3DSA:1.10.418.50:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190094, NULL, 'G3DSA:2.30.30.140:FF:000223', NULL, NULL, 'Serine/threonine-protein kinase ATM', NULL, NULL, NULL, NULL, NULL, 4),
(190095, NULL, 'G3DSA:1.20.5.4130:FF:000006', NULL, NULL, 'Disease resistance protein RPP13 variant', NULL, NULL, NULL, NULL, NULL, 4),
(190096, NULL, 'G3DSA:2.60.120.330:FF:000228', NULL, NULL, 'Oxidoreductase, 2OG-Fe(II) oxygenase family, putative (AFU_orthologue AFUA_5G12242)', NULL, NULL, NULL, NULL, NULL, 4),
(190097, NULL, 'G3DSA:1.20.1560.10:FF:000052', NULL, NULL, 'Multidrug ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(190098, NULL, 'G3DSA:3.40.50.150:FF:000297', NULL, NULL, '7SK snRNA methylphosphate capping enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(190099, NULL, 'G3DSA:1.20.1250.20:FF:000924', NULL, NULL, 'peptide transporter family 1', NULL, NULL, NULL, NULL, NULL, 4),
(190100, NULL, 'G3DSA:3.30.1460.50:FF:000018', NULL, NULL, 'Autophagy-related protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(190101, NULL, 'G3DSA:3.10.50.10:FF:000005', NULL, NULL, 'Endochitinase B1', NULL, NULL, NULL, NULL, NULL, 4),
(190102, NULL, 'G3DSA:3.40.50.720:FF:000221', NULL, NULL, 'Enoyl-[acyl-carrier-protein] reductase [NADH]', NULL, NULL, NULL, NULL, NULL, 4),
(190103, NULL, 'G3DSA:1.25.10.10:FF:000704', NULL, NULL, 'Transport and golgi organization 6 homolog (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(190104, NULL, 'G3DSA:3.90.550.20:FF:000009', NULL, NULL, 'Alpha-1,6-mannosyltransferase subunit (Hoc1)', NULL, NULL, NULL, NULL, NULL, 4),
(190105, NULL, 'G3DSA:3.30.310.130:FF:000004', NULL, NULL, 'sentrin-specific protease 6 isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(190106, NULL, 'G3DSA:2.60.40.1180:FF:000157', NULL, NULL, 'Glycoside hydrolase superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(190107, NULL, 'G3DSA:2.10.25.10:FF:001579', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190108, NULL, 'G3DSA:3.90.470.20:FF:000008', NULL, NULL, 'Phosphopantetheine-protein transferase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(190109, NULL, 'G3DSA:2.60.40.10:FF:004939', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190110, NULL, 'G3DSA:1.25.40.10:FF:004747', NULL, NULL, 'Os01g0263600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(190111, NULL, 'G3DSA:2.100.10.50:FF:000001', NULL, NULL, 'DENN domain containing 4C', NULL, NULL, NULL, NULL, NULL, 4),
(190112, NULL, 'G3DSA:3.30.160.20:FF:000009', NULL, NULL, 'Adenosine deaminase RNA-specific B2 (inactive)', NULL, NULL, NULL, NULL, NULL, 4),
(190113, NULL, 'G3DSA:2.30.230.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190114, NULL, 'G3DSA:3.10.250.10:FF:000024', NULL, NULL, 'CD6 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(190115, NULL, 'G3DSA:3.90.70.10:FF:000003', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 46', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(190116, NULL, 'G3DSA:3.80.10.10:FF:002793', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190117, NULL, 'G3DSA:2.90.10.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190118, NULL, 'G3DSA:1.10.1600.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190119, NULL, 'G3DSA:3.40.850.10:FF:000282', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(190120, NULL, 'G3DSA:3.30.70.330:FF:000200', NULL, NULL, 'transformer-2 protein homolog alpha', NULL, NULL, NULL, NULL, NULL, 4),
(190121, NULL, 'G3DSA:3.30.260.10:FF:000071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190122, NULL, 'G3DSA:3.40.1110.10:FF:000383', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190123, NULL, 'G3DSA:3.90.70.10:FF:000828', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190124, NULL, 'G3DSA:3.30.200.20:FF:002514', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(190125, NULL, 'G3DSA:3.90.70.80:FF:000012', NULL, NULL, 'OTU domain-containing protein DDB_G0284757', NULL, NULL, NULL, NULL, NULL, 4),
(190126, NULL, 'G3DSA:1.25.40.20:FF:001142', NULL, NULL, 'Putative ankyrin repeat domain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(190127, NULL, 'G3DSA:1.10.510.10:FF:001277', NULL, NULL, 'ALK2p Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(190128, NULL, 'G3DSA:1.10.12.10:FF:000006', NULL, NULL, 'Chromodomain Y-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(190129, NULL, 'G3DSA:3.10.50.40:FF:000109', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(190130, NULL, 'G3DSA:1.10.472.10:FF:000395', NULL, NULL, 'Cyclin-D2-1', NULL, NULL, NULL, NULL, NULL, 4),
(190131, NULL, 'G3DSA:3.30.40.10:FF:001358', NULL, NULL, 'Retroelement pol polyprotein-like', NULL, NULL, NULL, NULL, NULL, 4),
(190132, NULL, 'G3DSA:3.20.20.70:FF:000066', NULL, NULL, 'Dihydroorotate dehydrogenase (quinone), mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(190133, NULL, 'G3DSA:1.20.58.150:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190134, NULL, 'G3DSA:3.30.160.60:FF:001550', NULL, NULL, 'myc-associated zinc finger protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(190135, NULL, 'G3DSA:1.25.10.10:FF:000384', NULL, NULL, 'exportin-7 isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(190136, NULL, 'G3DSA:3.30.200.20:FF:002189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190137, NULL, 'G3DSA:2.60.40.10:FF:001713', NULL, NULL, 'Immunoglobulin lambda variable 3-19', NULL, NULL, NULL, NULL, NULL, 4),
(190138, NULL, 'G3DSA:3.40.50.300:FF:002629', NULL, NULL, 'tRNA ligase,putative Trl1p', NULL, NULL, NULL, NULL, NULL, 4),
(190139, NULL, 'G3DSA:3.40.50.300:FF:001551', NULL, NULL, 'RAB13 isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(190140, NULL, 'G3DSA:1.20.1560.10:FF:000405', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(190141, NULL, 'G3DSA:1.20.1740.10:FF:000150', NULL, NULL, 'Expressed sequence AU018091', NULL, NULL, NULL, NULL, NULL, 4),
(190142, NULL, 'G3DSA:1.10.287.70:FF:000111', NULL, NULL, 'Potassium voltage-gated channel subfamily D member 3', NULL, NULL, NULL, NULL, NULL, 4),
(190143, NULL, 'G3DSA:1.10.287.520:FF:000005', NULL, NULL, 'Bone morphogenetic protein antagonist noggin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190144, NULL, 'G3DSA:1.10.1660.10:FF:000011', NULL, NULL, 'MerR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(190145, NULL, 'G3DSA:2.20.130.20:FF:000008', NULL, NULL, 'Complement component C5', NULL, NULL, NULL, NULL, NULL, 4),
(190146, NULL, 'G3DSA:3.40.50.1100:FF:000300', NULL, NULL, 'Pyridoxal-5''-phosphate-dependent enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(190147, NULL, 'G3DSA:3.30.720.210:FF:000025', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(190148, NULL, 'G3DSA:1.20.1250.20:FF:001060', NULL, NULL, 'Major Facilitator Superfamily', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(190149, NULL, 'G3DSA:1.10.472.10:FF:000507', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190150, NULL, 'G3DSA:2.70.98.30:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190151, NULL, 'G3DSA:1.10.1420.10:FF:000201', NULL, NULL, 'DNA mismatch repair protein MSH2', NULL, NULL, NULL, NULL, NULL, 4),
(190152, NULL, 'G3DSA:1.10.238.10:FF:000952', NULL, NULL, 'Lysophosphatidylcholine acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(190153, NULL, 'G3DSA:1.10.150.300:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190154, NULL, 'G3DSA:1.20.58.400:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190155, NULL, 'G3DSA:3.30.1370.10:FF:000235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190156, NULL, 'G3DSA:3.40.50.2000:FF:000407', NULL, NULL, 'Exopolysaccharide biosynthesis protein EpsF', NULL, NULL, NULL, NULL, NULL, 4),
(190157, NULL, 'G3DSA:1.10.3520.10:FF:000001', NULL, NULL, 'Pleckstrin domain-containing family A member 8', NULL, NULL, NULL, NULL, NULL, 4),
(190158, NULL, 'G3DSA:2.40.50.140:FF:000326', NULL, NULL, 'Replication protein A1, small', NULL, NULL, NULL, NULL, NULL, 4),
(190159, NULL, 'G3DSA:1.10.357.150:FF:000006', NULL, NULL, 'Centromere/kinetochore protein zw10 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(190160, NULL, 'G3DSA:3.80.10.10:FF:000168', NULL, NULL, 'Distal membrane arm assembly complex 2', NULL, NULL, NULL, NULL, NULL, 4),
(190161, NULL, 'G3DSA:3.30.200.20:FF:001733', NULL, NULL, 'Ephrin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(190162, NULL, 'G3DSA:3.30.559.10:FF:000219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190163, NULL, 'G3DSA:3.40.50.300:FF:004777', NULL, NULL, 'Ras family protein', NULL, NULL, NULL, NULL, NULL, 4),
(190164, NULL, 'G3DSA:3.40.190.10:FF:000843', NULL, NULL, 'Ionotropic glutamate receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190165, NULL, 'G3DSA:1.25.40.470:FF:000013', NULL, NULL, 'intraflagellar transport protein 172 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(190166, NULL, 'G3DSA:1.10.10.160:FF:000014', NULL, NULL, 'Unplaced genomic scaffold supercont1.10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(190167, NULL, 'G3DSA:3.40.50.720:FF:000485', NULL, NULL, 'glyoxylate reductase/hydroxypyruvate reductase-like', NULL, NULL, NULL, NULL, NULL, 4),
(190168, NULL, 'G3DSA:3.60.21.10:FF:000475', NULL, NULL, 'Double-strand break repair protein MRE11', NULL, NULL, NULL, NULL, NULL, 4),
(190169, NULL, 'G3DSA:3.30.70.270:FF:000160', NULL, NULL, 'GGDEF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(190170, NULL, 'G3DSA:3.50.50.60:FF:000794', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(190171, NULL, 'G3DSA:1.10.8.270:FF:000162', NULL, NULL, 'RabGAP, TBC domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(190172, NULL, 'G3DSA:3.30.160.60:FF:004776', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190173, NULL, 'G3DSA:1.10.30.10:FF:000115', NULL, NULL, 'AGAP005183-PA', NULL, NULL, NULL, NULL, NULL, 4),
(190174, NULL, 'G3DSA:3.30.70.330:FF:001392', NULL, NULL, 'Cytoplasmic polyadenylation element-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(190175, NULL, 'G3DSA:3.30.70.3290:FF:000015', NULL, NULL, 'Probable polyketide synthase 16', NULL, NULL, NULL, NULL, NULL, 4),
(190176, NULL, 'G3DSA:3.80.10.10:FF:001096', NULL, NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(190177, NULL, 'G3DSA:3.20.20.140:FF:000405', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(190178, NULL, 'G3DSA:3.90.79.10:FF:000056', NULL, NULL, 'Nudix hydrolase 3', NULL, NULL, NULL, NULL, NULL, 4),
(190179, NULL, 'G3DSA:3.90.1750.10:FF:000099', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(190180, NULL, 'G3DSA:1.20.1060.20:FF:000005', NULL, NULL, 'Structural maintenance of chromosomes 2', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(190181, NULL, 'G3DSA:2.30.29.30:FF:000351', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(190182, NULL, 'G3DSA:3.20.20.140:FF:000293', NULL, NULL, 'PHP domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(190183, NULL, 'G3DSA:1.25.10.10:FF:000968', NULL, NULL, 'FAT domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(190184, NULL, 'G3DSA:2.130.10.10:FF:004743', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190185, NULL, 'G3DSA:1.20.1250.20:FF:001588', NULL, NULL, 'Autophagy-related protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(190186, NULL, 'G3DSA:1.10.238.110:FF:000013', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(190187, NULL, 'G3DSA:3.30.1490.20:FF:000039', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(190188, NULL, 'G3DSA:2.40.70.10:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190189, NULL, 'G3DSA:3.10.180.10:FF:000052', NULL, NULL, '4-hydroxyphenylpyruvate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(190190, NULL, 'G3DSA:3.40.50.2300:FF:001604', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190191, NULL, 'G3DSA:1.20.1280.50:FF:000031', NULL, NULL, 'F-box/WD repeat-containing protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(190192, NULL, 'G3DSA:3.40.1090.10:FF:000094', NULL, NULL, 'Patatin-like phospholipase domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(190193, NULL, 'G3DSA:1.10.10.10:FF:001305', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(190194, NULL, 'G3DSA:1.10.840.10:FF:000009', NULL, NULL, 'rap guanine nucleotide exchange factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(190195, NULL, 'G3DSA:1.20.120.850:FF:000006', NULL, NULL, 'Protein PHOTOPERIOD-INDEPENDENT EARLY FLOWERING 1', NULL, NULL, NULL, NULL, NULL, 4),
(190196, NULL, 'G3DSA:2.30.42.10:FF:000426', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190197, NULL, 'G3DSA:1.10.10.10:FF:001805', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(190198, NULL, 'G3DSA:3.80.10.10:FF:000640', NULL, NULL, 'Tubulin-specific chaperone e', NULL, NULL, NULL, NULL, NULL, 4),
(190199, NULL, 'G3DSA:1.10.1580.10:FF:000010', NULL, NULL, 'GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190200, NULL, 'G3DSA:3.30.40.10:FF:002347', NULL, NULL, 'LON peptidase N-terminal domain and RING finger protein C14F5.10c', NULL, NULL, NULL, NULL, NULL, 4),
(190201, NULL, 'G3DSA:1.10.418.10:FF:000045', NULL, NULL, 'Fimbrin-1 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(190202, NULL, 'G3DSA:3.30.1520.10:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190203, NULL, 'G3DSA:1.25.40.1040:FF:000030', NULL, NULL, 'N-terminal acetyltransferase A complex auxiliary subunit NAA15', NULL, NULL, NULL, NULL, NULL, 4),
(190204, NULL, 'G3DSA:2.70.150.10:FF:000220', NULL, NULL, 'Calcium-transporting ATPase 8 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(190205, NULL, 'G3DSA:3.30.40.10:FF:000285', NULL, NULL, 'RING-H2 finger protein ATL43', NULL, NULL, NULL, NULL, NULL, 4),
(190206, NULL, 'G3DSA:1.10.287.1150:FF:000004', NULL, NULL, '2-oxoglutarate dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(190207, NULL, 'G3DSA:1.20.1110.10:FF:000001', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(190208, NULL, 'G3DSA:1.10.287.820:FF:000005', NULL, NULL, 'Pickpocket 14', NULL, NULL, NULL, NULL, NULL, 4),
(190209, NULL, 'G3DSA:3.40.50.720:FF:002019', NULL, NULL, 'NAD-dependent epimerase/dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(190210, NULL, 'G3DSA:4.10.1000.10:FF:000010', NULL, NULL, 'zinc finger CCCH domain-containing protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(190211, NULL, 'G3DSA:2.30.29.30:FF:001076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190212, NULL, 'G3DSA:3.40.50.150:FF:000409', NULL, NULL, 'RNA methylase, PF01170 family', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(190213, NULL, 'G3DSA:3.30.450.260:FF:000006', NULL, NULL, 'head-specific guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(190214, NULL, 'G3DSA:2.130.10.10:FF:005732', NULL, NULL, 'Intraflagellar transport protein 122 homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(190215, NULL, 'G3DSA:1.25.40.180:FF:000106', NULL, NULL, 'Translation initiation factor 4G', NULL, NULL, NULL, NULL, NULL, 4),
(190216, NULL, 'G3DSA:1.10.238.210:FF:000009', NULL, NULL, 'glutaminase kidney isoform, mitochondrial-like', NULL, NULL, NULL, NULL, NULL, 4),
(190217, NULL, 'G3DSA:3.50.7.10:FF:000062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190218, NULL, 'G3DSA:1.25.40.10:FF:003758', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190219, NULL, 'G3DSA:1.10.1740.10:FF:000012', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(190220, NULL, 'G3DSA:3.60.40.10:FF:000098', NULL, NULL, 'Protein phosphatase 2C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190221, NULL, 'G3DSA:3.30.70.3030:FF:000016', NULL, NULL, 'Nucleolar protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(190222, NULL, 'G3DSA:3.40.50.1820:FF:000218', NULL, NULL, 'Dihydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(190223, NULL, 'G3DSA:3.40.190.10:FF:000782', NULL, NULL, 'Oligopeptide-binding protein oppA', NULL, NULL, NULL, NULL, NULL, 4),
(190224, NULL, 'G3DSA:2.130.10.10:FF:003670', NULL, NULL, 'Protein CBG10826', NULL, NULL, NULL, NULL, NULL, 4),
(190225, NULL, 'G3DSA:3.50.50.60:FF:000086', NULL, NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(190226, NULL, 'G3DSA:1.20.1270.60:FF:000207', NULL, NULL, 'YALI0F01694p', NULL, NULL, NULL, NULL, NULL, 4),
(190227, NULL, 'G3DSA:3.20.20.80:FF:000164', NULL, NULL, 'Chitinase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(190228, NULL, 'G3DSA:3.20.20.70:FF:000627', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190229, NULL, 'G3DSA:3.40.50.620:FF:000337', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(190230, NULL, 'G3DSA:3.30.760.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190231, NULL, 'G3DSA:3.30.70.270:FF:000221', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190232, NULL, 'G3DSA:1.20.1070.10:FF:001402', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190233, NULL, 'G3DSA:1.20.920.20:FF:000027', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(190234, NULL, 'G3DSA:1.20.1080.10:FF:000003', NULL, NULL, 'Lens fiber major intrinsic', NULL, NULL, NULL, NULL, NULL, 4),
(190235, NULL, 'G3DSA:2.60.40.820:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190236, NULL, 'G3DSA:1.25.40.10:FF:005203', NULL, NULL, 'Putative uncharacterized protein DDB_G0278921', NULL, NULL, NULL, NULL, NULL, 4),
(190237, NULL, 'G3DSA:1.20.920.10:FF:000081', NULL, NULL, 'Bromodomain and WD repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(190238, NULL, 'G3DSA:1.10.8.60:FF:000066', NULL, NULL, 'AAA-type ATPase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(190239, NULL, 'G3DSA:3.30.420.10:FF:000370', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190240, NULL, 'G3DSA:2.30.29.30:FF:000412', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(190241, NULL, 'G3DSA:1.20.5.110:FF:000286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190242, NULL, 'G3DSA:4.10.400.10:FF:000167', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(190243, NULL, 'G3DSA:1.10.238.10:FF:001205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190244, NULL, 'G3DSA:2.20.70.10:FF:000025', NULL, NULL, 'E3 ubiquitin-protein ligase NEDD4-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(190245, NULL, 'G3DSA:1.10.150.20:FF:000162', NULL, NULL, 'Probable DNA polymerase X-putative', NULL, NULL, NULL, NULL, NULL, 4),
(190246, NULL, 'G3DSA:2.40.30.10:FF:000477', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(190247, NULL, 'G3DSA:1.10.510.10:FF:000288', NULL, NULL, 'Receptor-interacting serine/threonine-protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(190248, NULL, 'G3DSA:1.10.510.10:FF:002497', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(190249, NULL, 'G3DSA:2.170.240.10:FF:000006', NULL, NULL, 'Collagen, type IV, alpha 4', NULL, NULL, NULL, NULL, NULL, 4),
(190250, NULL, 'G3DSA:2.40.70.10:FF:000395', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190251, NULL, 'G3DSA:3.40.50.10810:FF:000222', NULL, NULL, 'Protein CBR-RAD-54', NULL, NULL, NULL, NULL, NULL, 4),
(190252, NULL, 'G3DSA:2.60.40.60:FF:000986', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190253, NULL, 'G3DSA:3.20.20.450:FF:000003', NULL, NULL, 'RNase E specificity factor CsrD', NULL, NULL, NULL, NULL, NULL, 4),
(190254, NULL, 'G3DSA:1.10.220.150:FF:000046', NULL, NULL, 'ADP ribosylation factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190255, NULL, 'G3DSA:1.20.5.170:FF:000225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190256, NULL, 'G3DSA:3.90.190.10:FF:000377', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190257, NULL, 'G3DSA:3.40.50.410:FF:000156', NULL, NULL, 'General Transcription Factor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(190258, NULL, 'G3DSA:3.30.420.40:FF:000474', NULL, NULL, 'Rhamnulokinase', NULL, NULL, NULL, NULL, NULL, 4),
(190259, NULL, 'G3DSA:2.30.40.10:FF:000091', NULL, NULL, 'N-acyl-D-amino-acid deacylase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(190260, NULL, 'G3DSA:3.30.505.10:FF:000067', NULL, NULL, 'Src homology 2 domain-containing E', NULL, NULL, NULL, NULL, NULL, 4),
(190261, NULL, 'G3DSA:3.50.50.60:FF:000439', NULL, NULL, 'Prolycopene isomerase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(190262, NULL, 'G3DSA:2.130.10.10:FF:004951', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190263, NULL, 'G3DSA:3.80.10.10:FF:002585', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190264, NULL, 'G3DSA:3.40.50.2000:FF:000615', NULL, NULL, 'Alphaalpha-trehalose-phosphate synthase [UDP-forming] 5', NULL, NULL, NULL, NULL, NULL, 4),
(190265, NULL, 'G3DSA:3.30.160.60:FF:002270', NULL, NULL, 'PR/SET domain 16', NULL, NULL, NULL, NULL, NULL, 4),
(190266, NULL, 'G3DSA:1.25.40.10:FF:004539', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190267, NULL, 'G3DSA:3.30.160.20:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190268, NULL, 'G3DSA:3.30.1520.10:FF:000091', NULL, NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(190269, NULL, 'G3DSA:1.20.58.60:FF:000620', NULL, NULL, 'Nesprin-2', NULL, NULL, NULL, NULL, NULL, 4),
(190270, NULL, 'G3DSA:1.10.287.70:FF:000611', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190271, NULL, 'G3DSA:3.40.50.1010:FF:000009', NULL, NULL, 'Constitutive coactivator of PPAR-gamma-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(190272, NULL, 'G3DSA:1.10.3810.10:FF:000012', NULL, NULL, 'Glycosyl transferase family 51', NULL, NULL, NULL, NULL, NULL, 4),
(190273, NULL, 'G3DSA:2.60.220.50:FF:000026', NULL, NULL, 'Adhesion G protein-coupled receptor G5', NULL, NULL, NULL, NULL, NULL, 4),
(190274, NULL, 'G3DSA:1.10.10.10:FF:000788', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(190275, NULL, 'G3DSA:2.60.40.10:FF:001393', NULL, NULL, 'Junctional adhesion molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(190276, NULL, 'G3DSA:3.40.50.300:FF:004277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190277, NULL, 'G3DSA:3.40.50.1110:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190278, NULL, 'G3DSA:1.20.1560.10:FF:000613', NULL, NULL, 'Protein CBR-PGP-12', NULL, NULL, NULL, NULL, NULL, 4),
(190279, NULL, 'G3DSA:1.10.10.440:FF:000031', NULL, NULL, 'Pre-mRNA-processing protein 40C isoform C', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(190280, NULL, 'G3DSA:3.30.70.260:FF:000123', NULL, NULL, 'NagB/RpiA/CoA transferase-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(190281, NULL, 'G3DSA:3.30.40.10:FF:001566', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190282, NULL, 'G3DSA:2.160.20.10:FF:000083', NULL, NULL, 'Periplasmic copper-binding protein (NosD)/Right handed beta helix region containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190283, NULL, 'G3DSA:3.10.310.40:FF:000010', NULL, NULL, 'Alanine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(190284, NULL, 'G3DSA:3.60.110.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190285, NULL, 'G3DSA:2.130.10.10:FF:002034', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(190286, NULL, 'G3DSA:2.60.40.10:FF:001449', NULL, NULL, 'Echinoid, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(190287, NULL, 'G3DSA:3.10.20.90:FF:000162', NULL, NULL, 'E3 ubiquitin-protein ligase RING1', NULL, NULL, NULL, NULL, NULL, 4),
(190288, NULL, 'G3DSA:2.60.40.60:FF:000839', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190289, NULL, 'G3DSA:3.30.160.60:FF:006485', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190290, NULL, 'G3DSA:2.60.120.650:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190291, NULL, 'G3DSA:3.10.10.10:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190292, NULL, 'G3DSA:2.20.100.10:FF:000234', NULL, NULL, 'Semaphorin-5A', NULL, NULL, NULL, NULL, NULL, 4),
(190293, NULL, 'G3DSA:3.30.200.20:FF:002453', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190294, NULL, 'G3DSA:2.60.120.650:FF:000094', NULL, NULL, 'Protein associating with small stress protein PASS1', NULL, NULL, NULL, NULL, NULL, 4),
(190295, NULL, 'G3DSA:2.60.120.10:FF:000153', NULL, NULL, 'Hcp transcriptional regulator HcpR (Crp/Fnr family)', NULL, NULL, NULL, NULL, NULL, 4),
(190296, NULL, 'G3DSA:2.60.120.260:FF:000600', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190297, NULL, 'G3DSA:3.40.720.10:FF:000126', NULL, NULL, 'Arylsulfatase family member H', NULL, NULL, NULL, NULL, NULL, 4),
(190298, NULL, 'G3DSA:3.50.50.60:FF:000586', NULL, NULL, 'Sulfide quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(190299, NULL, 'G3DSA:1.25.40.10:FF:000324', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(190300, NULL, 'G3DSA:3.40.50.1980:FF:000013', NULL, NULL, 'Ferrichrome ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(190301, NULL, 'G3DSA:1.20.144.10:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190302, NULL, 'G3DSA:3.40.190.10:FF:000635', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(190303, NULL, 'G3DSA:1.20.58.830:FF:000029', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(190304, NULL, 'G3DSA:2.10.25.10:FF:000067', NULL, NULL, 'Laminin subunit gamma 1', NULL, NULL, NULL, NULL, NULL, 4),
(190305, NULL, 'G3DSA:3.30.230.130:FF:000042', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(190306, NULL, 'G3DSA:1.25.40.10:FF:003258', NULL, NULL, 'Os07g0172600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(190307, NULL, 'G3DSA:3.30.1460.10:FF:000001', NULL, NULL, 'CesT family type III secretion system chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(190308, NULL, 'G3DSA:1.25.40.10:FF:004686', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190309, NULL, 'G3DSA:2.30.29.30:FF:000148', NULL, NULL, 'pleckstrin homology domain-containing family M member 2', NULL, NULL, NULL, NULL, NULL, 4),
(190310, NULL, 'G3DSA:3.40.50.720:FF:002519', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190311, NULL, 'G3DSA:1.10.418.10:FF:000253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(190312, NULL, 'G3DSA:3.30.70.330:FF:001892', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190313, NULL, 'G3DSA:2.80.10.50:FF:000199', NULL, NULL, 'FSHD region gene 1', NULL, NULL, NULL, NULL, NULL, 4),
(190314, NULL, 'G3DSA:2.30.30.190:FF:000013', NULL, NULL, 'Tubulin-folding cofactor B', NULL, NULL, NULL, NULL, NULL, 4),
(190315, NULL, 'G3DSA:2.130.10.10:FF:000909', NULL, NULL, 'activating molecule in BECN1-regulated autophagy protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(190316, NULL, 'G3DSA:3.30.70.1840:FF:000002', NULL, NULL, 'Putative spike glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(190317, NULL, 'G3DSA:1.10.238.10:FF:000188', NULL, NULL, 'Protein S100', NULL, NULL, NULL, NULL, NULL, 4),
(190318, NULL, 'G3DSA:2.60.200.10:FF:000007', NULL, NULL, 'Interferon regulatory factor 7', NULL, NULL, NULL, NULL, NULL, 4),
(190319, NULL, 'G3DSA:2.30.30.40:FF:000222', NULL, NULL, 'SH3 domain-containing protein Dlish', NULL, NULL, NULL, NULL, NULL, 4),
(190320, NULL, 'G3DSA:2.30.180.10:FF:000197', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190321, NULL, 'G3DSA:3.40.50.11350:FF:000030', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(190322, NULL, 'G3DSA:1.10.8.60:FF:000566', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190323, NULL, 'G3DSA:3.40.50.1820:FF:000370', NULL, NULL, 'LIPaSe related', NULL, NULL, NULL, NULL, NULL, 4),
(190324, NULL, 'G3DSA:2.130.10.10:FF:003315', NULL, NULL, 'Elongator subunit', NULL, NULL, NULL, NULL, NULL, 4),
(190325, NULL, 'G3DSA:3.40.50.10190:FF:000227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190326, NULL, 'G3DSA:3.40.630.30:FF:000193', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(190327, NULL, 'G3DSA:1.20.120.1080:FF:000122', NULL, NULL, 'Putative ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(190328, NULL, 'G3DSA:3.40.50.20:FF:000063', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(190329, NULL, 'G3DSA:3.30.70.270:FF:000013', NULL, NULL, 'Polymerase (DNA directed) iota', NULL, NULL, NULL, NULL, NULL, 4),
(190330, NULL, 'G3DSA:1.10.8.1220:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190331, NULL, 'G3DSA:2.10.220.10:FF:000003', NULL, NULL, 'R-spondin 3', NULL, NULL, NULL, NULL, NULL, 4),
(190332, NULL, 'G3DSA:1.20.120.1530:FF:000009', NULL, NULL, 'Aerotaxis transducer Aer2', NULL, NULL, NULL, NULL, NULL, 4),
(190333, NULL, 'G3DSA:2.30.30.40:FF:000486', NULL, NULL, 'SH3 and PX domain-containing protein 2B', NULL, NULL, NULL, NULL, NULL, 4),
(190334, NULL, 'G3DSA:3.40.50.2300:FF:000379', NULL, NULL, 'Gamma-aminobutyric acid B receptor', NULL, NULL, NULL, NULL, NULL, 4),
(190335, NULL, 'G3DSA:1.25.40.180:FF:000050', NULL, NULL, 'Nuclear protein (Sgd1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(190336, NULL, 'G3DSA:3.40.50.1360:FF:000035', NULL, NULL, '6-phosphogluconolactonase', NULL, NULL, NULL, NULL, NULL, 4),
(190337, NULL, 'G3DSA:3.80.10.10:FF:003866', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(190338, NULL, 'G3DSA:3.40.50.620:FF:000129', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(190339, NULL, 'G3DSA:1.10.132.60:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190340, NULL, 'G3DSA:1.25.40.20:FF:000945', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190341, NULL, 'G3DSA:2.60.210.10:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190342, NULL, 'G3DSA:1.20.1070.10:FF:001874', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190343, NULL, 'G3DSA:3.30.200.20:FF:001172', NULL, NULL, 'Kinase, STE STE20', NULL, NULL, NULL, NULL, NULL, 4),
(190344, NULL, 'G3DSA:3.40.50.300:FF:002568', NULL, NULL, 'Cell division protein (FtsH)', NULL, NULL, NULL, NULL, NULL, 4),
(190345, NULL, 'G3DSA:2.130.10.10:FF:004804', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(190346, NULL, 'G3DSA:1.25.10.10:FF:001424', NULL, NULL, 'Related to Condensin complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(190347, NULL, 'G3DSA:3.80.10.10:FF:003602', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190348, NULL, 'G3DSA:1.20.58.390:FF:000240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190349, NULL, 'G3DSA:3.30.160.60:FF:003607', NULL, NULL, 'Metallothionein expression activator', NULL, NULL, NULL, NULL, NULL, 4),
(190350, NULL, 'G3DSA:2.20.70.10:FF:000233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190351, NULL, 'G3DSA:2.40.100.10:FF:000044', NULL, NULL, 'Cyclophilin 40', NULL, NULL, NULL, NULL, NULL, 4),
(190352, NULL, 'G3DSA:1.10.10.60:FF:001242', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190353, NULL, 'G3DSA:2.60.120.260:FF:000359', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190354, NULL, 'G3DSA:2.60.200.20:FF:000067', NULL, NULL, 'Vacuolar sorting protein', NULL, NULL, NULL, NULL, NULL, 4),
(190355, NULL, 'G3DSA:1.20.1070.10:FF:000385', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(190356, NULL, 'G3DSA:1.20.1250.20:FF:000863', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(190357, NULL, 'G3DSA:3.40.50.720:FF:001766', NULL, NULL, 'NmrA-like negative transcriptional regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190358, NULL, 'G3DSA:1.20.1560.10:FF:000760', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190359, NULL, 'G3DSA:3.30.70.2350:FF:000003', NULL, NULL, 'Probable glpG protein', NULL, NULL, NULL, NULL, NULL, 4),
(190360, NULL, 'G3DSA:3.40.630.10:FF:000035', NULL, NULL, 'Probable aminopeptidase NPEPL1', NULL, NULL, NULL, NULL, NULL, 4),
(190361, NULL, 'G3DSA:3.40.50.150:FF:000909', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190362, NULL, 'G3DSA:3.30.160.60:FF:006013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190363, NULL, 'G3DSA:1.25.40.10:FF:000796', NULL, NULL, 'Crooked neck pre-mRNA splicing factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(190364, NULL, 'G3DSA:1.20.5.1700:FF:000013', NULL, NULL, 'Transforming acidic coiled-coil containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190365, NULL, 'G3DSA:3.10.20.70:FF:000004', NULL, NULL, 'Glutamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(190366, NULL, 'G3DSA:1.10.1370.30:FF:000034', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(190367, NULL, 'G3DSA:4.10.1060.50:FF:000003', NULL, NULL, 'Double zinc ribbon and ankyrin repeat domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(190368, NULL, 'G3DSA:1.10.10.10:FF:001452', NULL, NULL, 'Meiotic recombination protein SPO11, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190369, NULL, 'G3DSA:1.25.40.20:FF:001350', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190370, NULL, 'G3DSA:3.30.200.20:FF:000805', NULL, NULL, 'L-type lectin-domain containing receptor kinase V.9', NULL, NULL, NULL, NULL, NULL, 4),
(190371, NULL, 'G3DSA:1.20.5.2700:FF:000004', NULL, NULL, 'NADH dehydrogenase I subunit L', NULL, NULL, NULL, NULL, NULL, 4),
(190372, NULL, 'G3DSA:3.40.50.720:FF:000721', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(190373, NULL, 'G3DSA:3.40.50.150:FF:001314', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190374, NULL, 'G3DSA:2.120.10.30:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190375, NULL, 'G3DSA:3.40.50.2000:FF:000879', NULL, NULL, 'AHPC/TSA protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190376, NULL, 'G3DSA:3.40.50.970:FF:000155', NULL, NULL, '2-oxoglutarate dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190377, NULL, 'G3DSA:3.30.450.30:FF:000001', NULL, NULL, 'Profilin', NULL, NULL, NULL, NULL, NULL, 4),
(190378, NULL, 'G3DSA:1.10.10.10:FF:000524', NULL, NULL, 'Heat shock factor, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(190379, NULL, 'G3DSA:1.10.510.10:FF:001777', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(190380, NULL, 'G3DSA:3.90.550.50:FF:000057', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(190381, NULL, 'G3DSA:3.50.50.60:FF:001103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190382, NULL, 'G3DSA:3.30.70.1450:FF:000008', NULL, NULL, 'Putative transport protein YidE', NULL, NULL, NULL, NULL, NULL, 4),
(190383, NULL, 'G3DSA:2.60.40.1730:FF:000075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190384, NULL, 'G3DSA:1.20.1740.10:FF:000206', NULL, NULL, 'Amino acid transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190385, NULL, 'G3DSA:1.10.10.60:FF:000786', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190386, NULL, 'G3DSA:3.60.20.10:FF:000243', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190387, NULL, 'G3DSA:3.40.50.1010:FF:000161', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190388, NULL, 'G3DSA:3.40.50.1000:FF:000624', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190389, NULL, 'G3DSA:3.30.70.80:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190390, NULL, 'G3DSA:3.30.450.50:FF:000007', NULL, NULL, 'SNARE complex subunit SEC22', NULL, NULL, NULL, NULL, NULL, 4),
(190391, NULL, 'G3DSA:2.60.120.200:FF:000448', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190392, NULL, 'G3DSA:2.40.30.130:FF:000049', NULL, NULL, 'Gll2349 protein', NULL, NULL, NULL, NULL, NULL, 4),
(190393, NULL, 'G3DSA:1.10.287.470:FF:000063', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(190394, NULL, 'G3DSA:3.40.50.300:FF:002832', NULL, NULL, 'ABC Transporter family', NULL, NULL, NULL, NULL, NULL, 4),
(190395, NULL, 'G3DSA:1.50.40.10:FF:000232', NULL, NULL, 'Mitochondrial succinate-fumarate transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(190396, NULL, 'G3DSA:3.30.40.10:FF:000902', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(190397, NULL, 'G3DSA:2.130.10.10:FF:005468', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190398, NULL, 'G3DSA:3.30.420.10:FF:000426', NULL, NULL, 'Chromosome-Segregation and RNAi deficient', NULL, NULL, NULL, NULL, NULL, 4),
(190399, NULL, 'G3DSA:3.30.70.330:FF:003073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190400, NULL, 'G3DSA:3.80.10.10:FF:004530', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190401, NULL, 'G3DSA:2.40.37.10:FF:000043', NULL, NULL, 'Ornithine decarboxylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190402, NULL, 'G3DSA:2.130.10.10:FF:000089', NULL, NULL, 'Cleavage stimulation factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(190403, NULL, 'G3DSA:2.40.50.40:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190404, NULL, 'G3DSA:1.10.510.10:FF:003986', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190405, NULL, 'G3DSA:3.40.50.10140:FF:000061', NULL, NULL, 'Transmembrane receptors / ATP binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(190406, NULL, 'G3DSA:3.80.10.10:FF:002321', NULL, NULL, 'Piriformospora indica-insensitive protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(190407, NULL, 'G3DSA:3.20.20.100:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190408, NULL, 'G3DSA:2.60.40.10:FF:005344', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190409, NULL, 'G3DSA:3.40.50.850:FF:000001', NULL, NULL, 'Isochorismatase domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(190410, NULL, 'G3DSA:3.40.50.11840:FF:000020', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(190411, NULL, 'G3DSA:1.20.920.10:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190412, NULL, 'G3DSA:2.40.290.10:FF:000001', NULL, NULL, 'X-ray repair cross complementing 6', NULL, NULL, NULL, NULL, NULL, 4),
(190413, NULL, 'G3DSA:3.10.110.10:FF:000047', NULL, NULL, 'ubiquitin-conjugating enzyme E2 20', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(190414, NULL, 'G3DSA:1.20.5.2210:FF:000009', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(190415, NULL, 'G3DSA:3.90.1200.10:FF:000007', NULL, NULL, 'hydroxylysine kinase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(190416, NULL, 'G3DSA:3.40.50.300:FF:000623', NULL, NULL, 'Elongator acetyltransferase complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(190417, NULL, 'G3DSA:3.30.70.330:FF:000464', NULL, NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(190418, NULL, 'G3DSA:3.30.190.20:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190419, NULL, 'G3DSA:1.10.10.60:FF:000078', NULL, NULL, 'NK2 homeobox 3', NULL, NULL, NULL, NULL, NULL, 4),
(190420, NULL, 'G3DSA:1.20.1270.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190421, NULL, 'G3DSA:1.25.40.10:FF:001252', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(190422, NULL, 'G3DSA:1.10.640.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190423, NULL, 'G3DSA:2.60.220.50:FF:000173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190424, NULL, 'G3DSA:3.40.50.620:FF:000281', NULL, NULL, 'Ethanolamine-phosphate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(190425, NULL, 'G3DSA:1.10.110.10:FF:000004', NULL, NULL, 'Alpha-amylase inhibitor 0.19', NULL, NULL, NULL, NULL, NULL, 4),
(190426, NULL, 'G3DSA:1.10.510.10:FF:000552', NULL, NULL, 'extracellular tyrosine-protein kinase PKDCC isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(190427, NULL, 'G3DSA:3.40.366.10:FF:000038', NULL, NULL, 'Malonyl CoA:ACP acyltransferase (mitochondrial)', NULL, NULL, NULL, NULL, NULL, 4),
(190428, NULL, 'G3DSA:3.40.640.10:FF:000272', NULL, NULL, 'Probable 8-amino-7-oxononanoate synthase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(190429, NULL, 'G3DSA:3.40.50.2300:FF:000115', NULL, NULL, 'Two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(190430, NULL, 'G3DSA:1.20.1730.10:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190431, NULL, 'G3DSA:3.40.50.300:FF:005182', NULL, NULL, 'Elongator subunit', NULL, NULL, NULL, NULL, NULL, 4),
(190432, NULL, 'G3DSA:3.30.160.60:FF:005440', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190433, NULL, 'G3DSA:3.40.50.300:FF:007391', NULL, NULL, 'GPA1 heterotrimeric G protein alpha subunit protein', NULL, NULL, NULL, NULL, NULL, 4),
(190434, NULL, 'G3DSA:2.130.10.10:FF:000797', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(190435, NULL, 'G3DSA:1.10.510.10:FF:003014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190436, NULL, 'G3DSA:2.170.300.10:FF:000096', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(190437, NULL, 'G3DSA:3.80.10.10:FF:000376', NULL, NULL, 'Slit guidance ligand 2', NULL, NULL, NULL, NULL, NULL, 4),
(190438, NULL, 'G3DSA:3.40.1280.30:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190439, NULL, 'G3DSA:3.40.630.30:FF:000305', NULL, NULL, 'N(alpha)-acetyltransferase 80, NatH catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(190440, NULL, 'G3DSA:3.40.50.720:FF:000013', NULL, NULL, 'Malate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(190441, NULL, 'G3DSA:3.90.226.10:FF:000326', NULL, NULL, 'Glr1525 protein', NULL, NULL, NULL, NULL, NULL, 4),
(190442, NULL, 'G3DSA:3.90.550.10:FF:000040', NULL, NULL, 'cellulose synthase-like protein D3', NULL, NULL, NULL, NULL, NULL, 4),
(190443, NULL, 'G3DSA:1.25.40.20:FF:001873', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190444, NULL, 'G3DSA:1.20.120.1240:FF:000046', NULL, NULL, 'Dynamin central region-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(190445, NULL, 'G3DSA:1.10.510.10:FF:001069', NULL, NULL, 'Germinal center kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(190446, NULL, 'G3DSA:2.60.40.10:FF:000673', NULL, NULL, 'Titin a', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(190447, NULL, 'G3DSA:3.30.572.10:FF:000008', NULL, NULL, 'thymidylate synthase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(190448, NULL, 'G3DSA:3.60.60.10:FF:000009', NULL, NULL, 'Choloylglycine hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(190449, NULL, 'G3DSA:3.30.1330.30:FF:000003', NULL, NULL, '60S ribosomal protein L7a', NULL, NULL, NULL, NULL, NULL, 4),
(190450, NULL, 'G3DSA:3.40.50.300:FF:001287', NULL, NULL, 'Ras-related protein Rab-1B', NULL, NULL, NULL, NULL, NULL, 4),
(190451, NULL, 'G3DSA:2.10.25.10:FF:000331', NULL, NULL, 'Multiple epidermal growth factor-like domains 8', NULL, NULL, NULL, NULL, NULL, 4),
(190452, NULL, 'G3DSA:1.10.10.650:FF:000004', NULL, NULL, 'Transcription elongation factor Spt6', NULL, NULL, NULL, NULL, NULL, 4),
(190453, NULL, 'G3DSA:3.40.50.300:FF:003496', NULL, NULL, 'Cullin-associated NEDD8-dissociated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(190454, NULL, 'G3DSA:1.25.40.10:FF:001813', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(190455, NULL, 'G3DSA:2.40.160.50:FF:000014', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(190456, NULL, 'G3DSA:3.30.160.60:FF:003495', NULL, NULL, 'Zinc finger protein 680', NULL, NULL, NULL, NULL, NULL, 4),
(190457, NULL, 'G3DSA:3.30.50.10:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190458, NULL, 'G3DSA:1.10.287.660:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190459, NULL, 'G3DSA:2.40.50.120:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190460, NULL, 'G3DSA:3.60.10.10:FF:000006', NULL, NULL, 'Exodeoxyribonuclease III', NULL, NULL, NULL, NULL, NULL, 4),
(190461, NULL, 'G3DSA:3.40.50.300:FF:000887', NULL, NULL, 'Ras-related protein Rab-19', NULL, NULL, NULL, NULL, NULL, 4),
(190462, NULL, 'G3DSA:3.40.50.1820:FF:001707', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190463, NULL, 'G3DSA:3.30.160.60:FF:000061', NULL, NULL, 'Transcription factor Sp3', NULL, NULL, NULL, NULL, NULL, 4),
(190464, NULL, 'G3DSA:2.60.40.10:FF:002882', NULL, NULL, 'CD166 antigen homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(190465, NULL, 'G3DSA:3.40.50.11000:FF:000004', NULL, NULL, 'Fe-S cluster assembly protein DRE2', NULL, NULL, NULL, NULL, NULL, 4),
(190466, NULL, 'G3DSA:1.10.600.10:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190467, NULL, 'G3DSA:3.40.50.300:FF:000062', NULL, NULL, 'U5 small nuclear ribonucleoprotein helicase', NULL, NULL, NULL, NULL, NULL, 4),
(190468, NULL, 'G3DSA:3.40.50.1000:FF:000708', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190469, NULL, 'G3DSA:1.10.472.10:FF:000479', NULL, NULL, 'Nol-5', NULL, NULL, NULL, NULL, NULL, 4),
(190470, NULL, 'G3DSA:3.40.50.1820:FF:001387', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(190471, NULL, 'G3DSA:3.50.50.60:FF:001367', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190472, NULL, 'G3DSA:1.20.1270.10:FF:000102', NULL, NULL, 'Hsp70 protein-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(190473, NULL, 'G3DSA:1.20.1070.10:FF:000913', NULL, NULL, 'Olfactory receptor 1447', NULL, NULL, NULL, NULL, NULL, 4),
(190474, NULL, 'G3DSA:3.40.1110.10:FF:000147', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(190475, NULL, 'G3DSA:3.30.1370.130:FF:000003', NULL, NULL, 'Type IV pilus secretin PilQ', NULL, NULL, NULL, NULL, NULL, 4),
(190476, NULL, 'G3DSA:1.25.10.10:FF:001396', NULL, NULL, 'AER219Cp', NULL, NULL, NULL, NULL, NULL, 4),
(190477, NULL, 'G3DSA:1.20.1070.10:FF:001897', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(190478, NULL, 'G3DSA:1.20.1070.10:FF:001458', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(190479, NULL, 'G3DSA:1.10.10.10:FF:001244', NULL, NULL, 'AGAP002394-PA', NULL, NULL, NULL, NULL, NULL, 4),
(190480, NULL, 'G3DSA:1.10.472.10:FF:000007', NULL, NULL, 'Transcription factor IIIB 90 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(190481, NULL, 'G3DSA:2.60.120.200:FF:000420', NULL, NULL, 'cadherin EGF LAG seven-pass G-type receptor 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(190482, NULL, 'G3DSA:2.60.40.10:FF:005900', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190483, NULL, 'G3DSA:2.20.110.10:FF:000032', NULL, NULL, 'Radial spoke protein RSP10, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190484, NULL, 'G3DSA:1.20.870.10:FF:000048', NULL, NULL, 'Ras guanine nucleotide exchange factor N', NULL, NULL, NULL, NULL, NULL, 4),
(190485, NULL, 'G3DSA:1.10.10.10:FF:001188', NULL, NULL, 'Putative prophage LambdaBa01, positive control factor Xpf', NULL, NULL, NULL, NULL, NULL, 4),
(190486, NULL, 'G3DSA:3.50.50.60:FF:000855', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190487, NULL, 'G3DSA:1.10.238.260:FF:000002', NULL, NULL, 'Homocitrate synthase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(190488, NULL, 'G3DSA:1.25.10.10:FF:000884', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(190489, NULL, 'G3DSA:3.80.10.10:FF:004322', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(190490, NULL, 'G3DSA:2.60.40.10:FF:005844', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190491, NULL, 'G3DSA:3.40.50.300:FF:005682', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190492, NULL, 'G3DSA:2.130.10.10:FF:002742', NULL, NULL, 'Bilobe protein, conserved', NULL, NULL, NULL, NULL, NULL, 4),
(190493, NULL, 'G3DSA:2.70.130.10:FF:000073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190494, NULL, 'G3DSA:3.40.1440.10:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190495, NULL, 'G3DSA:2.130.10.10:FF:005968', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(190496, NULL, 'G3DSA:3.40.50.410:FF:000100', NULL, NULL, 'Inter alpha-trypsin inhibitor, heavy chain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(190497, NULL, 'G3DSA:2.60.40.1400:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190498, NULL, 'G3DSA:1.10.510.10:FF:004267', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190499, NULL, 'G3DSA:3.30.40.10:FF:000785', NULL, NULL, 'RING-H2 finger protein ATL5H', NULL, NULL, NULL, NULL, NULL, 4),
(190500, NULL, 'G3DSA:3.10.400.10:FF:000002', NULL, NULL, 'ATP sulfurylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(190501, NULL, 'G3DSA:1.25.40.20:FF:000389', NULL, NULL, 'Ankyrin repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(190502, NULL, 'G3DSA:1.10.287.3240:FF:000013', NULL, NULL, 'V-type ATP synthase subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(190503, NULL, 'G3DSA:1.20.58.390:FF:000296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190504, NULL, 'G3DSA:1.10.3520.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190505, NULL, 'G3DSA:1.20.1270.60:FF:000123', NULL, NULL, 'Related to SYP1/YCR030C', NULL, NULL, NULL, NULL, NULL, 4),
(190506, NULL, 'G3DSA:1.20.1560.10:FF:000288', NULL, NULL, 'ABC transporter B family member 19', NULL, NULL, NULL, NULL, NULL, 4),
(190507, NULL, 'G3DSA:3.40.190.10:FF:000866', NULL, NULL, 'TF protein', NULL, NULL, NULL, NULL, NULL, 4),
(190508, NULL, 'G3DSA:2.60.120.920:FF:000107', NULL, NULL, 'Tripartite motif-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(190509, NULL, 'G3DSA:1.10.287.70:FF:000050', NULL, NULL, 'ATP-sensitive inward rectifier potassium channel 11', NULL, NULL, NULL, NULL, NULL, 4),
(190510, NULL, 'G3DSA:3.40.50.2300:FF:000323', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(190511, NULL, 'G3DSA:3.40.50.300:FF:007975', NULL, NULL, 'Rhogtpase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190512, NULL, 'G3DSA:2.40.30.300:FF:000005', NULL, NULL, 'Putative ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(190513, NULL, 'G3DSA:3.90.1100.10:FF:000062', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(190514, NULL, 'G3DSA:3.60.15.10:FF:000085', NULL, NULL, 'Ribonuclease Z', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(190515, NULL, 'G3DSA:3.40.50.970:FF:000094', NULL, NULL, '2-oxoisovalerate dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(190516, NULL, 'G3DSA:1.10.8.10:FF:000192', NULL, NULL, 'Ubiquitin-like 7b (bone marrow stromal cell-derived)', NULL, NULL, NULL, NULL, NULL, 4),
(190517, NULL, 'G3DSA:1.25.40.10:FF:001544', NULL, NULL, 'Pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(190518, NULL, 'G3DSA:3.40.50.2300:FF:000795', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190519, NULL, 'G3DSA:3.90.1640.10:FF:000006', NULL, NULL, 'Exopolyphosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190520, NULL, 'G3DSA:3.30.1330.100:FF:000003', NULL, NULL, 'Coenzyme F420:L-glutamate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(190521, NULL, 'G3DSA:2.40.50.140:FF:001231', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190522, NULL, 'G3DSA:3.40.50.300:FF:007503', NULL, NULL, 'ATPase, RecA superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(190523, NULL, 'G3DSA:3.40.190.10:FF:000427', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(190524, NULL, 'G3DSA:3.40.50.10190:FF:000199', NULL, NULL, 'DNA ligase 4', NULL, NULL, NULL, NULL, NULL, 4),
(190525, NULL, 'G3DSA:3.30.200.20:FF:000828', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190526, NULL, 'G3DSA:1.10.510.10:FF:000052', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(190527, NULL, 'G3DSA:1.10.167.10:FF:000017', NULL, NULL, 'G protein-coupled receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(190528, NULL, 'G3DSA:3.80.10.10:FF:004266', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(190529, NULL, 'G3DSA:1.20.1090.10:FF:000004', NULL, NULL, 'Glycerol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(190530, NULL, 'G3DSA:3.30.70.330:FF:002145', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190531, NULL, 'G3DSA:3.30.160.60:FF:002567', NULL, NULL, 'Zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(190532, NULL, 'G3DSA:1.20.1560.10:FF:000821', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190533, NULL, 'G3DSA:3.30.40.10:FF:000841', NULL, NULL, 'Os02g0727700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(190534, NULL, 'G3DSA:2.60.260.20:FF:000020', NULL, NULL, 'Chaperone protein DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(190535, NULL, 'G3DSA:3.90.226.10:FF:000242', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(190536, NULL, 'G3DSA:3.40.50.620:FF:000837', NULL, NULL, 'Leucyl Amino-acyl tRNA Synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(190537, NULL, 'G3DSA:3.20.70.20:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190538, NULL, 'G3DSA:2.60.120.200:FF:000364', NULL, NULL, 'NeuReXin related', NULL, NULL, NULL, NULL, NULL, 4),
(190539, NULL, 'G3DSA:3.65.10.10:FF:000035', NULL, NULL, '3-phosphoshikimate 1-carboxyvinyltransferase (AroA)', NULL, NULL, NULL, NULL, NULL, 4),
(190540, NULL, 'G3DSA:2.40.320.10:FF:000032', NULL, NULL, '5-methylthioadenosine/S-adenosylhomocysteine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(190541, NULL, 'G3DSA:3.90.550.10:FF:000568', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190542, NULL, 'G3DSA:1.10.405.10:FF:000010', NULL, NULL, 'Guanosine nucleotide diphosphate dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(190543, NULL, 'G3DSA:3.30.710.10:FF:000414', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190544, NULL, 'G3DSA:1.25.10.10:FF:002649', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190545, NULL, 'G3DSA:2.60.120.10:FF:000529', NULL, NULL, 'MBL fold metallo-hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(190546, NULL, 'G3DSA:1.20.1560.10:FF:000344', NULL, NULL, 'Cadmium ion transporter', NULL, NULL, NULL, NULL, NULL, 4),
(190547, NULL, 'G3DSA:3.40.50.300:FF:007008', NULL, NULL, 'ATP-dependent dethiobiotin synthetase BioD', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(190548, NULL, 'G3DSA:3.40.710.10:FF:000036', NULL, NULL, 'Penicillin-binding protein, 1A family', NULL, NULL, NULL, NULL, NULL, 4),
(190549, NULL, 'G3DSA:3.30.420.40:FF:001019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190550, NULL, 'G3DSA:1.25.10.10:FF:000412', NULL, NULL, 'RIC8 guanine nucleotide exchange factor B', NULL, NULL, NULL, NULL, NULL, 4),
(190551, NULL, 'G3DSA:1.20.1250.70:FF:000006', NULL, NULL, 'Interleukin-21', NULL, NULL, NULL, NULL, NULL, 4),
(190552, NULL, 'G3DSA:3.40.350.10:FF:000053', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(190553, NULL, 'G3DSA:3.40.33.10:FF:000116', NULL, NULL, 'Golgi-associated plant pathogenesis-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(190554, NULL, 'G3DSA:3.90.960.10:FF:000003', NULL, NULL, 'YbaK / prolyl-tRNA synthetases associated domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(190555, NULL, 'G3DSA:3.30.160.60:FF:000589', NULL, NULL, 'B-box zinc finger protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(190556, NULL, 'G3DSA:3.40.50.720:FF:002166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190557, NULL, 'G3DSA:3.40.50.1000:FF:000332', NULL, NULL, 'Unplaced genomic scaffold supercont1.8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(190558, NULL, 'G3DSA:3.40.30.10:FF:000082', NULL, NULL, 'Thioredoxin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(190559, NULL, 'G3DSA:1.10.3060.10:FF:000005', NULL, NULL, 'Protein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(190560, NULL, 'G3DSA:3.40.605.10:FF:000106', NULL, NULL, '10-formyltetrahydrofolate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(190561, NULL, 'G3DSA:3.40.50.300:FF:006986', NULL, NULL, 'Rab GTPase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(190562, NULL, 'G3DSA:1.25.40.180:FF:000281', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190563, NULL, 'G3DSA:1.20.58.830:FF:000001', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(190564, NULL, 'G3DSA:3.30.450.30:FF:000057', NULL, NULL, 'Ragulator complex protein LAMTOR3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(190565, NULL, 'G3DSA:3.30.470.30:FF:000064', NULL, NULL, 'DNA ligase 4-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(190566, NULL, 'G3DSA:3.90.640.10:FF:000070', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(190567, NULL, 'G3DSA:3.40.50.300:FF:003265', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(190568, NULL, 'G3DSA:1.25.40.10:FF:004950', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190569, NULL, 'G3DSA:3.80.10.10:FF:002377', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190570, NULL, 'G3DSA:2.10.25.10:FF:001079', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(190571, NULL, 'G3DSA:2.130.10.10:FF:005176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190572, NULL, 'G3DSA:3.90.190.10:FF:000585', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(190573, NULL, 'G3DSA:1.20.1050.90:FF:000008', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(190574, NULL, 'G3DSA:3.30.1390.30:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190575, NULL, 'G3DSA:3.30.70.850:FF:000002', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 7', NULL, NULL, NULL, NULL, NULL, 4),
(190576, NULL, 'G3DSA:3.40.30.10:FF:000935', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190577, NULL, 'G3DSA:3.40.50.1580:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190578, NULL, 'G3DSA:1.25.40.700:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190579, NULL, 'G3DSA:6.10.140.2220:FF:000015', NULL, NULL, 'egl nine homolog 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(190580, NULL, 'G3DSA:2.60.120.10:FF:000653', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(190581, NULL, 'G3DSA:2.170.120.12:FF:000022', NULL, NULL, 'DNA-directed RNA polymerase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(190582, NULL, 'G3DSA:3.30.160.60:FF:004012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190583, NULL, 'G3DSA:2.60.40.420:FF:000241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190584, NULL, 'G3DSA:3.40.30.10:FF:000879', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(190585, NULL, 'G3DSA:1.10.150.130:FF:000018', NULL, NULL, 'Site-specific recombinase, phage integrase family', NULL, NULL, NULL, NULL, NULL, 4),
(190586, NULL, 'G3DSA:3.30.70.330:FF:002201', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190587, NULL, 'G3DSA:2.60.120.40:FF:000049', NULL, NULL, 'Novel protein similar to vertebrate gliacolin (C1Q)', NULL, NULL, NULL, NULL, NULL, 4),
(190588, NULL, 'G3DSA:3.40.50.720:FF:000305', NULL, NULL, 'Kef family K(+) transporter', NULL, NULL, NULL, NULL, NULL, 4),
(190589, NULL, 'G3DSA:3.30.710.10:FF:000061', NULL, NULL, 'Zinc finger and BTB domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(190590, NULL, 'G3DSA:1.10.730.10:FF:000063', NULL, NULL, 'Mitochondrial methionyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(190591, NULL, 'G3DSA:3.30.420.40:FF:000997', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(190592, NULL, 'G3DSA:3.10.310.20:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190593, NULL, 'G3DSA:2.30.29.30:FF:000648', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190594, NULL, 'G3DSA:2.130.10.10:FF:005232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190595, NULL, 'G3DSA:2.60.40.10:FF:000196', NULL, NULL, 'Exocyst complex component 2', NULL, NULL, NULL, NULL, NULL, 4),
(190596, NULL, 'G3DSA:1.25.40.990:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190597, NULL, 'G3DSA:1.10.10.10:FF:000288', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(190598, NULL, 'G3DSA:1.25.40.10:FF:004894', NULL, NULL, 'Os09g0555400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(190599, NULL, 'G3DSA:1.25.40.10:FF:004455', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190600, NULL, 'G3DSA:3.90.226.10:FF:000298', NULL, NULL, 'ATP-dependent Clp protease proteolytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(190601, NULL, 'G3DSA:3.40.50.300:FF:006671', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190602, NULL, 'G3DSA:3.40.50.620:FF:000573', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(190603, NULL, 'G3DSA:1.20.1250.20:FF:002285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190604, NULL, 'G3DSA:2.60.40.10:FF:003427', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190605, NULL, 'G3DSA:1.20.120.1320:FF:000003', NULL, NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(190606, NULL, 'G3DSA:3.40.50.1110:FF:000073', NULL, NULL, 'Si:dkey-177p2.18', NULL, NULL, NULL, NULL, NULL, 4),
(190607, NULL, 'G3DSA:3.40.50.300:FF:003760', NULL, NULL, 'ATP-dependent DEAD/H DNA helicase recQ family-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(190608, NULL, 'G3DSA:1.20.1310.20:FF:000042', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(190609, NULL, 'G3DSA:1.20.5.640:FF:000001', NULL, NULL, '50S ribosomal protein L32', NULL, NULL, NULL, NULL, NULL, 4),
(190610, NULL, 'G3DSA:1.10.238.10:FF:000891', NULL, NULL, 'Phospholipase C, epsilon 1', NULL, NULL, NULL, NULL, NULL, 4),
(190611, NULL, 'G3DSA:3.30.420.40:FF:000682', NULL, NULL, 'Glucose kinase', NULL, NULL, NULL, NULL, NULL, 4),
(190612, NULL, 'G3DSA:4.10.1000.10:FF:000038', NULL, NULL, 'putative ATP-dependent RNA helicase DHX57', NULL, NULL, NULL, NULL, NULL, 4),
(190613, NULL, 'G3DSA:2.10.25.140:FF:000004', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(190614, NULL, 'G3DSA:3.80.10.10:FF:003366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190615, NULL, 'G3DSA:1.20.120.350:FF:000121', NULL, NULL, 'Potassium channel', NULL, NULL, NULL, NULL, NULL, 4),
(190616, NULL, 'G3DSA:1.20.1280.50:FF:000087', NULL, NULL, 'UFO1p F-box receptor protein', NULL, NULL, NULL, NULL, NULL, 4),
(190617, NULL, 'G3DSA:3.90.199.10:FF:000009', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(190618, NULL, 'G3DSA:1.25.40.20:FF:000445', NULL, NULL, 'E3 ubiquitin-protein ligase mind-bomb', NULL, NULL, NULL, NULL, NULL, 4),
(190619, NULL, 'G3DSA:3.40.50.150:FF:000797', NULL, NULL, 'Spermine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(190620, NULL, 'G3DSA:3.80.10.10:FF:001040', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(190621, NULL, 'G3DSA:2.130.10.10:FF:001337', NULL, NULL, 'Sec 13 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190622, NULL, 'G3DSA:2.60.40.10:FF:002938', NULL, NULL, 'Non-specific protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(190623, NULL, 'G3DSA:3.30.310.10:FF:000013', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(190624, NULL, 'G3DSA:2.30.30.490:FF:000036', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(190625, NULL, 'G3DSA:2.30.30.790:FF:000013', NULL, NULL, '50S ribosomal protein L19', NULL, NULL, NULL, NULL, NULL, 4),
(190626, NULL, 'G3DSA:2.60.120.290:FF:000227', NULL, NULL, 'GPRIN family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(190627, NULL, 'G3DSA:3.30.160.60:FF:003079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190628, NULL, 'G3DSA:3.40.50.300:FF:002776', NULL, NULL, 'ABC transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(190629, NULL, 'G3DSA:1.20.140.150:FF:000014', NULL, NULL, 'p53 apoptosis effector related to PMP-22', NULL, NULL, NULL, NULL, NULL, 4),
(190630, NULL, 'G3DSA:3.30.710.10:FF:000437', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190631, NULL, 'G3DSA:1.10.8.100:FF:000015', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(190632, NULL, 'G3DSA:3.40.390.10:FF:000055', NULL, NULL, 'Related to mitochondrial intermediate peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(190633, NULL, 'G3DSA:1.20.1250.20:FF:000363', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(190634, NULL, 'G3DSA:1.10.1510.30:FF:000006', NULL, NULL, 'Pseudouridine synthase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(190635, NULL, 'G3DSA:3.30.519.10:FF:000014', NULL, NULL, 'Rab GDP dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(190636, NULL, 'G3DSA:2.60.40.10:FF:003922', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190637, NULL, 'G3DSA:2.40.20.10:FF:000004', NULL, NULL, 'Hepatocyte growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(190638, NULL, 'G3DSA:3.40.50.300:FF:005210', NULL, NULL, 'Polynucleotide 5''-hydroxyl-kinase GRC3', NULL, NULL, NULL, NULL, NULL, 4),
(190639, NULL, 'G3DSA:3.30.40.10:FF:001830', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(190640, NULL, 'G3DSA:2.10.25.10:FF:000623', NULL, NULL, 'Matrilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(190641, NULL, 'G3DSA:3.10.660.10:FF:000015', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(190642, NULL, 'G3DSA:1.25.10.10:FF:000940', NULL, NULL, 'Interferon-related developmental regulator family protein / IFRD protein family', NULL, NULL, NULL, NULL, NULL, 4),
(190643, NULL, 'G3DSA:1.10.8.1290:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190644, NULL, 'G3DSA:3.40.1110.10:FF:000203', NULL, NULL, 'Plasma membrane calcium-transporting ATPase 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190645, NULL, 'G3DSA:3.30.160.60:FF:005024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190646, NULL, 'G3DSA:1.25.40.990:FF:000023', NULL, NULL, 'Leukocyte receptor cluster (Lrc) member, putative', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(190647, NULL, 'G3DSA:3.30.60.60:FF:000014', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(190648, NULL, 'G3DSA:1.20.1070.10:FF:000593', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190649, NULL, 'G3DSA:3.40.50.300:FF:007447', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190650, NULL, 'G3DSA:3.90.70.80:FF:000035', NULL, NULL, 'RNA-directed RNA polymerase L', NULL, NULL, NULL, NULL, NULL, 4),
(190651, NULL, 'G3DSA:1.20.1110.10:FF:000029', NULL, NULL, 'Plasma membrane ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(190652, NULL, 'G3DSA:3.90.1720.10:FF:000002', NULL, NULL, 'HRAS like suppressor 2', NULL, NULL, NULL, NULL, NULL, 4),
(190653, NULL, 'G3DSA:3.50.30.80:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190654, NULL, 'G3DSA:3.30.70.330:FF:001217', NULL, NULL, 'Rumpelstiltskin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(190655, NULL, 'G3DSA:3.20.20.100:FF:000096', NULL, NULL, 'Aldo-keto reductase family 4 member C9', NULL, NULL, NULL, NULL, NULL, 4),
(190656, NULL, 'G3DSA:1.10.510.10:FF:001805', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(190657, NULL, 'G3DSA:3.90.1860.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190658, NULL, 'G3DSA:3.30.70.330:FF:000256', NULL, NULL, 'oligouridylate-binding protein 1-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(190659, NULL, 'G3DSA:2.70.98.20:FF:000005', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(190660, NULL, 'G3DSA:1.25.10.10:FF:000468', NULL, NULL, 'mRNA-binding protein PUF2', NULL, NULL, NULL, NULL, NULL, 4),
(190661, NULL, 'G3DSA:1.20.1540.10:FF:000022', NULL, NULL, 'Rhomboid family intramembrane serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(190662, NULL, 'G3DSA:2.60.40.1180:FF:000101', NULL, NULL, '1,3-beta-galactosyl-N-acetylhexosamine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(190663, NULL, 'G3DSA:1.10.10.200:FF:000010', NULL, NULL, 'Gag-Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(190664, NULL, 'G3DSA:2.60.40.10:FF:000701', NULL, NULL, 'Tenascin-X', NULL, NULL, NULL, NULL, NULL, 4),
(190665, NULL, 'G3DSA:2.60.260.20:FF:000076', NULL, NULL, 'Chaperone protein dnaJ GFA2 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(190666, NULL, 'G3DSA:3.30.70.330:FF:002206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190667, NULL, 'G3DSA:3.40.47.10:FF:000243', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190668, NULL, 'G3DSA:3.40.50.300:FF:001051', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(190669, NULL, 'G3DSA:3.40.50.150:FF:001814', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190670, NULL, 'G3DSA:3.60.20.10:FF:000012', NULL, NULL, 'Proteasome subunit alpha type', NULL, NULL, NULL, NULL, NULL, 4),
(190671, NULL, 'G3DSA:3.90.70.10:FF:000744', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190672, NULL, 'G3DSA:3.40.250.10:FF:000017', NULL, NULL, 'ubiquitin carboxyl-terminal hydrolase 8', NULL, NULL, NULL, NULL, NULL, 4),
(190673, NULL, 'G3DSA:2.30.110.10:FF:000070', NULL, NULL, 'Styrene monooxygenase component 2', NULL, NULL, NULL, NULL, NULL, 4),
(190674, NULL, 'G3DSA:1.25.40.430:FF:000024', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(190675, NULL, 'G3DSA:2.60.40.820:FF:000001', NULL, NULL, 'T-box transcription factor TBX18', NULL, NULL, NULL, NULL, NULL, 4),
(190676, NULL, 'G3DSA:3.30.200.20:FF:001941', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190677, NULL, 'G3DSA:1.20.5.110:FF:000022', NULL, NULL, 'Syntaxin 19', NULL, NULL, NULL, NULL, NULL, 4),
(190678, NULL, 'G3DSA:3.30.160.60:FF:005496', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190679, NULL, 'G3DSA:2.10.70.10:FF:000082', NULL, NULL, 'Complement component C6', NULL, NULL, NULL, NULL, NULL, 4),
(190680, NULL, 'G3DSA:3.60.20.30:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190681, NULL, 'G3DSA:3.40.50.1820:FF:000954', NULL, NULL, 'Alpha/beta hydrolase family, putative', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(190682, NULL, 'G3DSA:3.90.1420.10:FF:000018', NULL, NULL, 'Actin-histidine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(190683, NULL, 'G3DSA:3.50.50.60:FF:001491', NULL, NULL, 'L-amino-acid oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(190684, NULL, 'G3DSA:1.20.1250.20:FF:001796', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190685, NULL, 'G3DSA:1.10.565.10:FF:000083', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(190686, NULL, 'G3DSA:3.20.20.60:FF:000006', NULL, NULL, 'Isocitrate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(190687, NULL, 'G3DSA:3.40.47.10:FF:000058', NULL, NULL, 'Acetyl-CoA C-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(190688, NULL, 'G3DSA:1.20.1070.10:FF:000969', NULL, NULL, 'G-protein coupled receptor aex-2', NULL, NULL, NULL, NULL, NULL, 4),
(190689, NULL, 'G3DSA:1.20.1530.20:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190690, NULL, 'G3DSA:1.10.150.670:FF:000011', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(190691, NULL, 'G3DSA:1.10.10.10:FF:000316', NULL, NULL, 'Transcriptional regulator, ArsR', NULL, NULL, NULL, NULL, NULL, 4),
(190692, NULL, 'G3DSA:3.90.79.10:FF:000287', NULL, NULL, 'Nudix hydrolase 7', NULL, NULL, NULL, NULL, NULL, 4),
(190693, NULL, 'G3DSA:1.10.472.10:FF:000423', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190694, NULL, 'G3DSA:3.30.70.270:FF:000249', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190695, NULL, 'G3DSA:1.20.120.230:FF:000028', NULL, NULL, 'Alpha-CaTuliN (Catenin/vinculin related)', NULL, NULL, NULL, NULL, NULL, 4),
(190696, NULL, 'G3DSA:3.40.50.850:FF:000024', NULL, NULL, 'Isochorismatase domain-containing protein 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190697, NULL, 'G3DSA:3.30.930.10:FF:000072', NULL, NULL, 'Lipoate--protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(190698, NULL, 'G3DSA:3.40.50.300:FF:000831', NULL, NULL, 'ATP-binding cassette sub-family G member 8', NULL, NULL, NULL, NULL, NULL, 4),
(190699, NULL, 'G3DSA:1.10.10.60:FF:000814', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190700, NULL, 'G3DSA:3.40.50.300:FF:004569', NULL, NULL, 'DNA helicase HCS1', NULL, NULL, NULL, NULL, NULL, 4),
(190701, NULL, 'G3DSA:2.60.40.10:FF:001213', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(190702, NULL, 'G3DSA:3.40.50.300:FF:004754', NULL, NULL, 'Ras-related protein RabZ', NULL, NULL, NULL, NULL, NULL, 4),
(190703, NULL, 'G3DSA:3.30.160.60:FF:001281', NULL, NULL, 'C2H2 transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190704, NULL, 'G3DSA:1.20.1050.10:FF:000058', NULL, NULL, 'metaxin-1', NULL, NULL, NULL, NULL, NULL, 4),
(190705, NULL, 'G3DSA:3.90.45.10:FF:000023', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(190706, NULL, 'G3DSA:3.40.850.10:FF:000107', NULL, NULL, 'Kinesin family member 20/23', NULL, NULL, NULL, NULL, NULL, 4),
(190707, NULL, 'G3DSA:3.90.1800.10:FF:000008', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(190708, NULL, 'G3DSA:2.130.10.10:FF:000825', NULL, NULL, 'Regulatory-associated protein of TOR 2', NULL, NULL, NULL, NULL, NULL, 4),
(190709, NULL, 'G3DSA:1.10.260.40:FF:000086', NULL, NULL, 'Transcription factor protein', NULL, NULL, NULL, NULL, NULL, 4),
(190710, NULL, 'G3DSA:1.10.510.10:FF:000788', NULL, NULL, 'Serine/threonine-protein kinase Nek3', NULL, NULL, NULL, NULL, NULL, 4),
(190711, NULL, 'G3DSA:3.30.40.10:FF:002263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190712, NULL, 'G3DSA:3.40.50.150:FF:000853', NULL, NULL, 'Methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(190713, NULL, 'G3DSA:3.80.10.10:FF:000584', NULL, NULL, 'NACHT, LRR and PYD domains-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(190714, NULL, 'G3DSA:2.20.70.30:FF:000003', NULL, NULL, 'Nascent polypeptide-associated complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(190715, NULL, 'G3DSA:1.25.40.20:FF:001373', NULL, NULL, 'ArfGAP with SH3 domain, ankyrin repeat and PH domain 1b', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(190716, NULL, 'G3DSA:3.90.640.90:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190717, NULL, 'G3DSA:3.30.160.60:FF:003023', NULL, NULL, 'NSDC', NULL, NULL, NULL, NULL, NULL, 4),
(190718, NULL, 'G3DSA:3.30.200.20:FF:000452', NULL, NULL, 'Receptor-like protein kinase THESEUS 1', NULL, NULL, NULL, NULL, NULL, 4),
(190719, NULL, 'G3DSA:1.10.8.60:FF:000274', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(190720, NULL, 'G3DSA:1.10.3380.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190721, NULL, 'G3DSA:3.30.930.10:FF:000420', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190722, NULL, 'G3DSA:2.60.40.60:FF:000750', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(190723, NULL, 'G3DSA:3.40.50.150:FF:001629', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190724, NULL, 'G3DSA:3.40.1000.30:FF:000004', NULL, NULL, 'Putative proteasome inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(190725, NULL, 'G3DSA:1.10.3080.10:FF:000040', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(190726, NULL, 'G3DSA:1.50.40.10:FF:000024', NULL, NULL, 'MIR1p Mitochondrial phosphate carrier', NULL, NULL, NULL, NULL, NULL, 4),
(190727, NULL, 'G3DSA:3.30.160.60:FF:001573', NULL, NULL, 'Zinc finger protein 407', NULL, NULL, NULL, NULL, NULL, 4),
(190728, NULL, 'G3DSA:1.25.10.10:FF:001716', NULL, NULL, 'AaceriADL093Wp', NULL, NULL, NULL, NULL, NULL, 4),
(190729, NULL, 'G3DSA:1.20.1280.20:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190730, NULL, 'G3DSA:3.30.160.60:FF:001078', NULL, NULL, 'Zinc finger protein 329', NULL, NULL, NULL, NULL, NULL, 4),
(190731, NULL, 'G3DSA:1.25.40.70:FF:000027', NULL, NULL, 'Phosphatidylinositol 4-kinase putative', NULL, NULL, NULL, NULL, NULL, 4),
(190732, NULL, 'G3DSA:1.10.10.10:FF:001249', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(190733, NULL, 'G3DSA:1.20.930.40:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190734, NULL, 'G3DSA:2.40.10.10:FF:000678', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190735, NULL, 'G3DSA:2.70.150.10:FF:000012', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(190736, NULL, 'G3DSA:3.30.300.20:FF:000072', NULL, NULL, 'Osmotically inducible family protein', NULL, NULL, NULL, NULL, NULL, 4),
(190737, NULL, 'G3DSA:1.10.150.20:FF:000246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190738, NULL, 'G3DSA:3.90.1150.10:FF:000250', NULL, NULL, 'Aspartate aminotransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(190739, NULL, 'G3DSA:3.10.20.310:FF:000003', NULL, NULL, 'Outer membrane protein assembly factor BamA', NULL, NULL, NULL, NULL, NULL, 4),
(190740, NULL, 'G3DSA:1.25.40.20:FF:001878', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(190741, NULL, 'G3DSA:3.80.10.10:FF:004294', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190742, NULL, 'G3DSA:2.60.40.640:FF:000071', NULL, NULL, 'Vacuolar protein sorting-associated protein 26 containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(190743, NULL, 'G3DSA:2.40.50.140:FF:001107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190744, NULL, 'G3DSA:1.10.150.900:FF:000002', NULL, NULL, 'M20/M25/M40 family peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(190745, NULL, 'G3DSA:2.60.40.10:FF:000988', NULL, NULL, 'obscurin isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(190746, NULL, 'G3DSA:2.10.25.10:FF:001551', NULL, NULL, 'Neurexin I isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(190747, NULL, 'G3DSA:1.10.150.110:FF:000012', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(190748, NULL, 'G3DSA:1.20.58.1070:FF:000015', NULL, NULL, 'Gem-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(190749, NULL, 'G3DSA:3.80.10.10:FF:001888', NULL, NULL, 'TOLl (Drosophila) family', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(190750, NULL, 'G3DSA:3.40.50.720:FF:000249', NULL, NULL, 'Fatty acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(190751, NULL, 'G3DSA:1.10.1300.10:FF:000046', NULL, NULL, 'cGMP-dependent 3'',5''-cyclic phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(190752, NULL, 'G3DSA:3.40.50.10240:FF:000034', NULL, NULL, 'Thiamin pyrophosphokinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190753, NULL, 'G3DSA:1.10.630.10:FF:000443', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190754, NULL, 'G3DSA:2.40.70.10:FF:000187', NULL, NULL, 'Aspartic-type endopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190755, NULL, 'G3DSA:3.10.100.10:FF:000013', NULL, NULL, 'Attractin like 1', NULL, NULL, NULL, NULL, NULL, 4),
(190756, NULL, 'G3DSA:3.40.50.1760:FF:000003', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(190757, NULL, 'G3DSA:3.30.1360.120:FF:000049', NULL, NULL, 'Putative transferase CAF17, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(190758, NULL, 'G3DSA:1.10.510.10:FF:001013', NULL, NULL, 'CMGC/CDK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(190759, NULL, 'G3DSA:3.30.200.20:FF:001317', NULL, NULL, 'Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(190760, NULL, 'G3DSA:3.30.160.60:FF:001606', NULL, NULL, 'zinc finger protein 502 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(190761, NULL, 'G3DSA:2.60.40.10:FF:004355', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190762, NULL, 'G3DSA:1.10.150.50:FF:000058', NULL, NULL, 'ephrin type-A receptor 8', NULL, NULL, NULL, NULL, NULL, 4),
(190763, NULL, 'G3DSA:3.30.160.60:FF:004484', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190764, NULL, 'G3DSA:2.10.25.10:FF:000567', NULL, NULL, 'Vitamin K-dependent protein C', NULL, NULL, NULL, NULL, NULL, 4),
(190765, NULL, 'G3DSA:3.30.43.10:FF:000027', NULL, NULL, 'L-gulonolactone oxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190766, NULL, 'G3DSA:1.25.40.10:FF:004039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190767, NULL, 'G3DSA:2.60.40.10:FF:004883', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190768, NULL, 'G3DSA:2.40.50.100:FF:000073', NULL, NULL, 'Putative Exosome complex component RRP40', NULL, NULL, NULL, NULL, NULL, 4),
(190769, NULL, 'G3DSA:1.10.287.3240:FF:000018', NULL, NULL, 'Vacuolar ATP synthase subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(190770, NULL, 'G3DSA:3.40.225.10:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190771, NULL, 'G3DSA:3.40.50.300:FF:000859', NULL, NULL, 'ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(190772, NULL, 'G3DSA:3.90.1720.10:FF:000007', NULL, NULL, 'Predicted lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(190773, NULL, 'G3DSA:3.40.50.300:FF:008464', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(190774, NULL, 'G3DSA:2.10.70.10:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190775, NULL, 'G3DSA:1.10.275.20:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190776, NULL, 'G3DSA:2.10.25.10:FF:001495', NULL, NULL, 'Protein CBR-CRB-1', NULL, NULL, NULL, NULL, NULL, 4),
(190777, NULL, 'G3DSA:3.30.50.10:FF:000111', NULL, NULL, 'Protein CBG19536', NULL, NULL, NULL, NULL, NULL, 4),
(190778, NULL, 'G3DSA:3.30.40.10:FF:001774', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(190779, NULL, 'G3DSA:3.40.1340.10:FF:000012', NULL, NULL, 'DNA binding / DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(190780, NULL, 'G3DSA:3.40.50.620:FF:000865', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(190781, NULL, 'G3DSA:2.60.120.20:FF:000010', NULL, NULL, 'Secreted protein ORF2', NULL, NULL, NULL, NULL, NULL, 4),
(190782, NULL, 'G3DSA:2.10.25.10:FF:000915', NULL, NULL, 'Fibrillin-1', NULL, NULL, NULL, NULL, NULL, 4),
(190783, NULL, 'G3DSA:2.30.30.30:FF:000073', NULL, NULL, '30S ribosomal protein S4e', NULL, NULL, NULL, NULL, NULL, 4),
(190784, NULL, 'G3DSA:1.50.40.10:FF:000171', NULL, NULL, 'Mitochondrial carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(190785, NULL, 'G3DSA:3.30.160.60:FF:001134', NULL, NULL, 'Zinc finger protein 70', NULL, NULL, NULL, NULL, NULL, 4),
(190786, NULL, 'G3DSA:3.30.1370.240:FF:000008', NULL, NULL, 'Phenylalanine--tRNA ligase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(190787, NULL, 'G3DSA:1.10.555.10:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190788, NULL, 'G3DSA:3.40.50.10090:FF:000023', NULL, NULL, 'Uroporphyrinogen-III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(190789, NULL, 'G3DSA:1.10.510.10:FF:001541', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(190790, NULL, 'G3DSA:3.30.1610.10:FF:000007', NULL, NULL, 'Nucleoporin autopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190791, NULL, 'G3DSA:1.10.533.10:FF:000088', NULL, NULL, 'P53-induced death domain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(190792, NULL, 'G3DSA:3.40.50.300:FF:001843', NULL, NULL, 'Putative dynein beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(190793, NULL, 'G3DSA:3.30.60.190:FF:000015', NULL, NULL, 'Protein CBR-ZHIT-2', NULL, NULL, NULL, NULL, NULL, 4),
(190794, NULL, 'G3DSA:1.20.1050.10:FF:000114', NULL, NULL, 'Glutathione S-transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190795, NULL, 'G3DSA:3.40.50.10260:FF:000012', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(190796, NULL, 'G3DSA:3.40.50.1000:FF:000388', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190797, NULL, 'G3DSA:1.25.40.10:FF:002977', NULL, NULL, 'ERAD-associated E3 ubiquitin-protein ligase component HRD3A', NULL, NULL, NULL, NULL, NULL, 4),
(190798, NULL, 'G3DSA:1.10.1060.10:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190799, NULL, 'G3DSA:3.40.50.150:FF:000325', NULL, NULL, 'Ribosomal RNA methyltransferase Nop2', NULL, NULL, NULL, NULL, NULL, 4),
(190800, NULL, 'G3DSA:3.50.50.60:FF:000378', NULL, NULL, 'Phytoene desaturase', NULL, NULL, NULL, NULL, NULL, 4),
(190801, NULL, 'G3DSA:1.20.120.150:FF:000010', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(190802, NULL, 'G3DSA:3.40.50.11210:FF:000005', NULL, NULL, 'Ral GTPase-activating protein, beta subunit (non-catalytic)', NULL, NULL, NULL, NULL, NULL, 4),
(190803, NULL, 'G3DSA:2.160.10.10:FF:000054', NULL, NULL, 'Translation initiation factor eIF-2B subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(190804, NULL, 'G3DSA:3.40.50.720:FF:001710', NULL, NULL, 'Dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(190805, NULL, 'G3DSA:2.40.110.10:FF:000078', NULL, NULL, 'Acyl-CoA dehydrogenase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(190806, NULL, 'G3DSA:3.30.160.60:FF:000645', NULL, NULL, 'Zinc finger and BTB domain containing 40', NULL, NULL, NULL, NULL, NULL, 4),
(190807, NULL, 'G3DSA:3.40.1640.10:FF:000001', NULL, NULL, 'D-glutamate cyclase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(190808, NULL, 'G3DSA:3.40.50.1240:FF:000168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190809, NULL, 'G3DSA:3.40.50.11860:FF:000003', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(190810, NULL, 'G3DSA:3.20.20.190:FF:000083', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(190811, NULL, 'G3DSA:1.10.8.60:FF:000330', NULL, NULL, 'Protein CBR-CDC-48.3', NULL, NULL, NULL, NULL, NULL, 4),
(190812, NULL, 'G3DSA:3.30.1680.50:FF:000001', NULL, NULL, 'Carboxypeptidase inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(190813, NULL, 'G3DSA:3.90.550.10:FF:000624', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(190814, NULL, 'G3DSA:3.30.200.20:FF:001380', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(190815, NULL, 'G3DSA:1.20.1270.10:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190816, NULL, 'G3DSA:3.20.20.80:FF:000220', NULL, NULL, 'Chitotriosidase-1', NULL, NULL, NULL, NULL, NULL, 4),
(190817, NULL, 'G3DSA:1.20.58.1610:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(190818, NULL, 'G3DSA:2.130.10.10:FF:004479', NULL, NULL, 'Regulatory-associated protein of mTOR-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(190819, NULL, 'G3DSA:2.60.40.60:FF:000694', NULL, NULL, 'Hedgehog protein', NULL, NULL, NULL, NULL, NULL, 4),
(190820, NULL, 'G3DSA:3.40.50.410:FF:000095', NULL, NULL, 'Dihydropyridine-sensitive l-type calcium channel', NULL, NULL, NULL, NULL, NULL, 4),
(190821, NULL, 'G3DSA:3.30.200.20:FF:000980', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(190822, NULL, 'G3DSA:2.130.10.30:FF:000039', NULL, NULL, 'probable E3 ubiquitin-protein ligase HERC4 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(190823, NULL, 'G3DSA:2.130.10.10:FF:001753', NULL, NULL, 'GATOR complex protein Wdr59', NULL, NULL, NULL, NULL, NULL, 4),
(190824, NULL, 'G3DSA:2.130.10.10:FF:000033', NULL, NULL, 'Semaphorin 4B', NULL, NULL, NULL, NULL, NULL, 4),
(190825, NULL, 'G3DSA:3.90.1150.10:FF:000334', NULL, NULL, 'Kynureninase', NULL, NULL, NULL, NULL, NULL, 4),
(190826, NULL, 'G3DSA:1.25.40.10:FF:000296', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(190827, NULL, 'G3DSA:3.90.190.10:FF:000580', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190828, NULL, 'G3DSA:3.30.160.60:FF:005316', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190829, NULL, 'G3DSA:3.50.50.60:FF:000911', NULL, NULL, 'Carotene 7,8-desaturase', NULL, NULL, NULL, NULL, NULL, 4),
(190830, NULL, 'G3DSA:2.30.29.30:FF:001104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190831, NULL, 'G3DSA:1.20.1250.20:FF:002341', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190832, NULL, 'G3DSA:1.10.287.370:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190833, NULL, 'G3DSA:2.30.29.30:FF:000704', NULL, NULL, 'Transcription initiation factor TFIIH subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(190834, NULL, 'G3DSA:3.30.70.330:FF:003134', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190835, NULL, 'G3DSA:3.30.590.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190836, NULL, 'G3DSA:3.50.50.60:FF:001311', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase, truncation', NULL, NULL, NULL, NULL, NULL, 4),
(190837, NULL, 'G3DSA:3.40.50.720:FF:000777', NULL, NULL, 'glyoxylate reductase/hydroxypyruvate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(190838, NULL, 'G3DSA:3.40.50.1780:FF:000009', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor nar1', NULL, NULL, NULL, NULL, NULL, 4),
(190839, NULL, 'G3DSA:3.30.160.60:FF:005501', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190840, NULL, 'G3DSA:1.10.287.70:FF:000055', NULL, NULL, 'Polycystic kidney disease 2-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(190841, NULL, 'G3DSA:2.60.120.920:FF:000102', NULL, NULL, 'Si:ch211-201o1.1', NULL, NULL, NULL, NULL, NULL, 4),
(190842, NULL, 'G3DSA:2.60.40.10:FF:004916', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190843, NULL, 'G3DSA:3.80.10.10:FF:001449', NULL, NULL, 'Serine/threonine kinase 11 interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(190844, NULL, 'G3DSA:3.40.50.2000:FF:000823', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190845, NULL, 'G3DSA:3.40.50.300:FF:005502', NULL, NULL, 'ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(190846, NULL, 'G3DSA:3.40.605.10:FF:000078', NULL, NULL, 'L-glutamate gamma-semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(190847, NULL, 'G3DSA:4.10.970.10:FF:000018', NULL, NULL, 'AGAP002690-PA', NULL, NULL, NULL, NULL, NULL, 4),
(190848, NULL, 'G3DSA:1.10.10.60:FF:000022', NULL, NULL, 'ISWI chromatin-remodeling complex ATPase CHR11 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(190849, NULL, 'G3DSA:3.40.50.1820:FF:000898', NULL, NULL, 'Clan SC, family S33, methylesterase-like serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(190850, NULL, 'G3DSA:3.30.450.20:FF:000291', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(190851, NULL, 'G3DSA:3.40.50.2300:FF:000851', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190852, NULL, 'G3DSA:1.20.1250.20:FF:001852', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190853, NULL, 'G3DSA:1.20.1270.60:FF:000179', NULL, NULL, 'sorting nexin-6', NULL, NULL, NULL, NULL, NULL, 4),
(190854, NULL, 'G3DSA:3.40.50.2300:FF:001251', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190855, NULL, 'G3DSA:3.40.190.10:FF:000490', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(190856, NULL, 'G3DSA:3.50.50.60:FF:001075', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(190857, NULL, 'G3DSA:1.25.40.10:FF:002241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190858, NULL, 'G3DSA:3.60.15.10:FF:000270', NULL, NULL, 'RNase Z-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(190859, NULL, 'G3DSA:1.10.10.10:FF:001536', NULL, NULL, 'Cullin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190860, NULL, 'G3DSA:3.40.605.10:FF:000022', NULL, NULL, 'Aldehyde dehydrogenase A', NULL, NULL, NULL, NULL, NULL, 4),
(190861, NULL, 'G3DSA:2.130.10.10:FF:000792', NULL, NULL, 'Dynein intermediate chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190862, NULL, 'G3DSA:1.25.40.10:FF:002185', NULL, NULL, 'Os03g0849700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(190863, NULL, 'G3DSA:2.60.40.3530:FF:000002', NULL, NULL, 'Early E3 18.5 kDa glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(190864, NULL, 'G3DSA:3.30.70.1630:FF:000001', NULL, NULL, 'tRNA-modifying protein YgfZ', NULL, NULL, NULL, NULL, NULL, 4),
(190865, NULL, 'G3DSA:2.170.200.10:FF:000004', NULL, NULL, 'Regulatory protein E2', NULL, NULL, NULL, NULL, NULL, 4),
(190866, NULL, 'G3DSA:2.30.30.770:FF:000002', NULL, NULL, '60S ribosomal protein L27', NULL, NULL, NULL, NULL, NULL, 4),
(190867, NULL, 'G3DSA:3.40.50.980:FF:000012', NULL, NULL, 'Acyl-CoA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(190868, NULL, 'G3DSA:2.60.40.10:FF:001921', NULL, NULL, 'KETtiN (Drosophila actin-binding) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(190869, NULL, 'G3DSA:3.30.50.10:FF:000139', NULL, NULL, 'Estrogen receptor beta a variant b', NULL, NULL, NULL, NULL, NULL, 4),
(190870, NULL, 'G3DSA:2.130.10.10:FF:002450', NULL, NULL, 'Inositol requiring 1-1', NULL, NULL, NULL, NULL, NULL, 4),
(190871, NULL, 'G3DSA:2.30.29.30:FF:000143', NULL, NULL, 'amyloid beta A4 precursor protein-binding family B member 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(190872, NULL, 'G3DSA:1.20.58.240:FF:000010', NULL, NULL, 'GH20986p', NULL, NULL, NULL, NULL, NULL, 4),
(190873, NULL, 'G3DSA:1.10.10.350:FF:000004', NULL, NULL, 'Glutamate--tRNA ligase chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(190874, NULL, 'G3DSA:3.70.10.10:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190875, NULL, 'G3DSA:3.40.50.1170:FF:000012', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(190876, NULL, 'G3DSA:1.20.1440.40:FF:000001', NULL, NULL, 'DUF446 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(190877, NULL, 'G3DSA:1.20.1410.10:FF:000013', NULL, NULL, 'Talin 1', NULL, NULL, NULL, NULL, NULL, 4),
(190878, NULL, 'G3DSA:1.20.1250.20:FF:000868', NULL, NULL, 'Uncharacterized symporter sll1374', NULL, NULL, NULL, NULL, NULL, 4),
(190879, NULL, 'G3DSA:3.40.50.1820:FF:001679', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190880, NULL, 'G3DSA:3.70.10.10:FF:000045', NULL, NULL, 'Cell cycle checkpoint control protein RAD9A', NULL, NULL, NULL, NULL, NULL, 4),
(190881, NULL, 'G3DSA:3.30.450.20:FF:000200', NULL, NULL, 'Sensor histidine kinase KinD', NULL, NULL, NULL, NULL, NULL, 4),
(190882, NULL, 'G3DSA:1.10.510.10:FF:003430', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190883, NULL, 'G3DSA:3.40.50.300:FF:000595', NULL, NULL, 'ATPase family AAA domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(190884, NULL, 'G3DSA:3.40.190.10:FF:000574', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(190885, NULL, 'G3DSA:3.30.420.40:FF:000710', NULL, NULL, 'Glucose kinase', NULL, NULL, NULL, NULL, NULL, 4),
(190886, NULL, 'G3DSA:3.40.50.1820:FF:001735', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190887, NULL, 'G3DSA:1.10.443.10:FF:000002', NULL, NULL, 'Tyrosine recombinase XerC', NULL, NULL, NULL, NULL, NULL, 4),
(190888, NULL, 'G3DSA:1.10.720.30:FF:000012', NULL, NULL, 'apoptotic chromatin condensation inducer in the nucleus isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(190889, NULL, 'G3DSA:2.130.10.10:FF:004535', NULL, NULL, 'WD-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190890, NULL, 'G3DSA:3.20.20.150:FF:000026', NULL, NULL, 'Putative hydroxypyruvate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(190891, NULL, 'G3DSA:3.40.366.10:FF:000033', NULL, NULL, 'Fatty acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(190892, NULL, 'G3DSA:3.40.1280.10:FF:000046', NULL, NULL, 'RNA methyltransferase, TrmH family', NULL, NULL, NULL, NULL, NULL, 4),
(190893, NULL, 'G3DSA:1.25.40.20:FF:000097', NULL, NULL, 'NF-kappa-B inhibitor zeta isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(190894, NULL, 'G3DSA:3.40.50.300:FF:007155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190895, NULL, 'G3DSA:1.10.238.10:FF:000688', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(190896, NULL, 'G3DSA:1.20.144.10:FF:000136', NULL, NULL, 'LD09836p', NULL, NULL, NULL, NULL, NULL, 4),
(190897, NULL, 'G3DSA:1.10.510.10:FF:001772', NULL, NULL, 'Protein CBG12760', NULL, NULL, NULL, NULL, NULL, 4),
(190898, NULL, 'G3DSA:3.90.190.10:FF:000613', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190899, NULL, 'G3DSA:3.40.50.720:FF:000693', NULL, NULL, 'Alcohol dehydrogenase B', NULL, NULL, NULL, NULL, NULL, 4),
(190900, NULL, 'G3DSA:1.20.120.20:FF:000045', NULL, NULL, 'Apolipoprotein A-IV', NULL, NULL, NULL, NULL, NULL, 4),
(190901, NULL, 'G3DSA:2.40.440.10:FF:000007', NULL, NULL, 'Murein L,D-transpeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(190902, NULL, 'G3DSA:3.40.140.20:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190903, NULL, 'G3DSA:3.30.160.60:FF:004568', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190904, NULL, 'G3DSA:3.30.428.10:FF:000016', NULL, NULL, 'Scavenger mRNA decapping enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(190905, NULL, 'G3DSA:1.10.287.610:FF:000004', NULL, NULL, '30S ribosomal protein S2', NULL, NULL, NULL, NULL, NULL, 4),
(190906, NULL, 'G3DSA:3.40.50.300:FF:001320', NULL, NULL, 'Heme ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(190907, NULL, 'G3DSA:3.40.50.300:FF:005974', NULL, NULL, 'Thymidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(190908, NULL, 'G3DSA:2.120.10.30:FF:000505', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190909, NULL, 'G3DSA:2.60.120.200:FF:000217', NULL, NULL, 'Gram-negative bacteria-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(190910, NULL, 'G3DSA:3.30.1330.10:FF:000025', NULL, NULL, 'Selenide, water dikinase', NULL, NULL, NULL, NULL, NULL, 4),
(190911, NULL, 'G3DSA:2.170.300.10:FF:000101', NULL, NULL, 'Scavenger receptor class F member 1', NULL, NULL, NULL, NULL, NULL, 4),
(190912, NULL, 'G3DSA:2.130.10.10:FF:000409', NULL, NULL, 'Flowering time control protein FY', NULL, NULL, NULL, NULL, NULL, 4),
(190913, NULL, 'G3DSA:3.50.50.60:FF:000563', NULL, NULL, 'FAD-binding domain', NULL, NULL, NULL, NULL, NULL, 4),
(190914, NULL, 'G3DSA:3.30.160.60:FF:002859', NULL, NULL, 'Zinc finger protein 866', NULL, NULL, NULL, NULL, NULL, 4),
(190915, NULL, 'G3DSA:1.10.60.30:FF:000005', NULL, NULL, 'UPF0307 protein B7D78_01970', NULL, NULL, NULL, NULL, NULL, 4),
(190916, NULL, 'G3DSA:1.10.8.10:FF:000012', NULL, NULL, 'ATP-dependent protease ATPase subunit HslU', NULL, NULL, NULL, NULL, NULL, 4),
(190917, NULL, 'G3DSA:3.20.180.20:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190918, NULL, 'G3DSA:3.60.40.10:FF:000334', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(190919, NULL, 'G3DSA:1.10.287.70:FF:000342', NULL, NULL, 'Calcium-activated potassium channel subunit alpha-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190920, NULL, 'G3DSA:3.30.2350.10:FF:000026', NULL, NULL, 'RNA-binding protein S4', NULL, NULL, NULL, NULL, NULL, 4),
(190921, NULL, 'G3DSA:3.30.200.20:FF:000536', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(190922, NULL, 'G3DSA:2.20.100.10:FF:000239', NULL, NULL, 'AGAP002424-PA', NULL, NULL, NULL, NULL, NULL, 4),
(190923, NULL, 'G3DSA:3.30.530.20:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190924, NULL, 'G3DSA:1.25.40.180:FF:000314', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190925, NULL, 'G3DSA:3.40.50.300:FF:007683', NULL, NULL, 'RAS protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190926, NULL, 'G3DSA:1.10.10.60:FF:000781', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190927, NULL, 'G3DSA:2.70.98.110:FF:000008', NULL, NULL, 'Cwh41p', NULL, NULL, NULL, NULL, NULL, 4),
(190928, NULL, 'G3DSA:3.60.10.10:FF:000242', NULL, NULL, 'Endonuclease/exonuclease/phosphatase family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190929, NULL, 'G3DSA:3.60.10.10:FF:000186', NULL, NULL, 'DNase I-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(190930, NULL, 'G3DSA:3.40.50.300:FF:007211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190931, NULL, 'G3DSA:3.40.1180.10:FF:000005', NULL, NULL, 'Alkyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(190932, NULL, 'G3DSA:3.40.190.10:FF:000719', NULL, NULL, 'No message in thiamine Nmt1', NULL, NULL, NULL, NULL, NULL, 4),
(190933, NULL, 'G3DSA:2.10.110.10:FF:000169', NULL, NULL, 'ISL LIM homeobox 2', NULL, NULL, NULL, NULL, NULL, 4),
(190934, NULL, 'G3DSA:1.20.1330.10:FF:000012', NULL, NULL, 'Flagellar hook-filament junction protein FlgL', NULL, NULL, NULL, NULL, NULL, 4),
(190935, NULL, 'G3DSA:3.40.1190.10:FF:000034', NULL, NULL, 'Bifunctional folylpolyglutamate synthase/dihydrofolate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(190936, NULL, 'G3DSA:1.20.1050.10:FF:000030', NULL, NULL, 'Glutathione S-transferase S1', NULL, NULL, NULL, NULL, NULL, 4),
(190937, NULL, 'G3DSA:2.10.25.10:FF:000062', NULL, NULL, 'Slit guidance ligand 2', NULL, NULL, NULL, NULL, NULL, 4),
(190938, NULL, 'G3DSA:2.60.40.640:FF:000099', NULL, NULL, 'Arrestin domain-containing protein A', NULL, NULL, NULL, NULL, NULL, 4),
(190939, NULL, 'G3DSA:3.30.160.60:FF:000297', NULL, NULL, 'Zinc finger and AT-hook domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(190940, NULL, 'G3DSA:3.40.1360.10:FF:000047', NULL, NULL, 'Spo11/DNA topoisomerase VI subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(190941, NULL, 'G3DSA:1.20.1560.10:FF:000636', NULL, NULL, 'ATP-binding cassette transporter, subfamily B, member 21, group MDR/PGP protein PpABCB21', NULL, NULL, NULL, NULL, NULL, 4),
(190942, NULL, 'G3DSA:1.20.210.10:FF:000015', NULL, NULL, 'Cytochrome c oxidase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(190943, NULL, 'G3DSA:3.30.70.330:FF:002437', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190944, NULL, 'G3DSA:1.10.3660.10:FF:000011', NULL, NULL, 'Prephenate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(190945, NULL, 'G3DSA:2.60.40.150:FF:000137', NULL, NULL, 'Piccolo presynaptic cytomatrix protein', NULL, NULL, NULL, NULL, NULL, 4),
(190946, NULL, 'G3DSA:3.40.1280.10:FF:000102', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4),
(190947, NULL, 'G3DSA:3.90.930.40:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190948, NULL, 'G3DSA:3.50.30.30:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190949, NULL, 'G3DSA:2.10.25.10:FF:000859', NULL, NULL, 'Fibulin-1', NULL, NULL, NULL, NULL, NULL, 4),
(190950, NULL, 'G3DSA:2.20.100.10:FF:000150', NULL, NULL, 'GM21753', NULL, NULL, NULL, NULL, NULL, 4),
(190951, NULL, 'G3DSA:1.20.58.60:FF:000648', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(190952, NULL, 'G3DSA:3.40.50.300:FF:000067', NULL, NULL, 'ras-related protein RABA1f', NULL, NULL, NULL, NULL, NULL, 4),
(190953, NULL, 'G3DSA:2.60.490.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190954, NULL, 'G3DSA:2.30.29.30:FF:000620', NULL, NULL, 'dynamin-3-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(190955, NULL, 'G3DSA:2.60.40.10:FF:000757', NULL, NULL, 'Beta-glucosidase G', NULL, NULL, NULL, NULL, NULL, 4),
(190956, NULL, 'G3DSA:2.10.90.10:FF:000021', NULL, NULL, 'vascular endothelial growth factor D', NULL, NULL, NULL, NULL, NULL, 4),
(190957, NULL, 'G3DSA:1.25.10.10:FF:003138', NULL, NULL, 'Protein VAC14-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(190958, NULL, 'G3DSA:2.60.120.10:FF:000237', NULL, NULL, 'Transcription regulator, Crp family', NULL, NULL, NULL, NULL, NULL, 4),
(190959, NULL, 'G3DSA:3.100.10.10:FF:000025', NULL, NULL, '50S ribosomal protein L15', NULL, NULL, NULL, NULL, NULL, 4),
(190960, NULL, 'G3DSA:3.10.50.40:FF:000020', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(190961, NULL, 'G3DSA:1.10.238.10:FF:000216', NULL, NULL, 'Putative calmodulin', NULL, NULL, NULL, NULL, NULL, 4),
(190962, NULL, 'G3DSA:1.10.3380.30:FF:000035', NULL, NULL, 'DNA-directed DNA polymerase theta, putative (AFU_orthologue AFUA_1G05260)', NULL, NULL, NULL, NULL, NULL, 4),
(190963, NULL, 'G3DSA:3.30.160.60:FF:002915', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190964, NULL, 'G3DSA:1.10.3200.20:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190965, NULL, 'G3DSA:1.10.10.10:FF:001160', NULL, NULL, 'Transcriptional activator domain', NULL, NULL, NULL, NULL, NULL, 4),
(190966, NULL, 'G3DSA:3.40.50.2300:FF:000031', NULL, NULL, 'HTH-type transcriptional repressor PurR', NULL, NULL, NULL, NULL, NULL, 4),
(190967, NULL, 'G3DSA:2.170.130.10:FF:000032', NULL, NULL, 'TonB-dependent outer membrane receptor', NULL, NULL, NULL, NULL, NULL, 4),
(190968, NULL, 'G3DSA:2.20.25.530:FF:000001', NULL, NULL, 'Ribonuclease H2 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(190969, NULL, 'G3DSA:2.60.40.60:FF:000778', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190970, NULL, 'G3DSA:2.40.10.10:FF:000650', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190971, NULL, 'G3DSA:3.30.40.10:FF:001010', NULL, NULL, 'PHD finger family', NULL, NULL, NULL, NULL, NULL, 4),
(190972, NULL, 'G3DSA:3.40.50.10810:FF:000014', NULL, NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily A containing DEAD/H box 1', NULL, NULL, NULL, NULL, NULL, 4),
(190973, NULL, 'G3DSA:3.30.413.10:FF:000022', NULL, NULL, 'Sulfite reductase, dissimilatory-type beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(190974, NULL, 'G3DSA:3.40.5.10:FF:000018', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(190975, NULL, 'G3DSA:3.40.50.300:FF:004193', NULL, NULL, 'Os05g0467501 protein', NULL, NULL, NULL, NULL, NULL, 4),
(190976, NULL, 'G3DSA:3.30.450.40:FF:000206', NULL, NULL, 'GAF domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(190977, NULL, 'G3DSA:1.10.4030.10:FF:000003', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(190978, NULL, 'G3DSA:1.10.286.20:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190979, NULL, 'G3DSA:2.130.10.10:FF:004248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190980, NULL, 'G3DSA:2.120.10.80:FF:000262', NULL, NULL, 'KAR-UP F-box 1', NULL, NULL, NULL, NULL, NULL, 4),
(190981, NULL, 'G3DSA:3.80.10.10:FF:002669', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(190982, NULL, 'G3DSA:3.40.50.12280:FF:000005', NULL, NULL, 'Hydrogenase-4, I subunit', NULL, NULL, NULL, NULL, NULL, 4),
(190983, NULL, 'G3DSA:3.40.50.2000:FF:001043', NULL, NULL, 'UDP-glycosyltransferase TURAN', NULL, NULL, NULL, NULL, NULL, 4),
(190984, NULL, 'G3DSA:3.40.50.2000:FF:000531', NULL, NULL, 'UDP-glycosyltransferase 83A1', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(190985, NULL, 'G3DSA:1.10.10.1740:FF:000005', NULL, NULL, 'BnaCnng46150D protein', NULL, NULL, NULL, NULL, NULL, 4),
(190986, NULL, 'G3DSA:3.10.580.10:FF:000161', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(190987, NULL, 'G3DSA:2.170.140.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(190988, NULL, 'G3DSA:1.10.150.50:FF:000114', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(190989, NULL, 'G3DSA:2.10.25.10:FF:000770', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(190990, NULL, 'G3DSA:2.30.24.10:FF:000002', NULL, NULL, 'Transcription antiterminator LicT', NULL, NULL, NULL, NULL, NULL, 4),
(190991, NULL, 'G3DSA:3.40.1190.20:FF:000076', NULL, NULL, 'Adenosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(190992, NULL, 'G3DSA:1.10.510.10:FF:003806', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190993, NULL, 'G3DSA:2.60.40.10:FF:004411', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(190994, NULL, 'G3DSA:3.40.50.261:FF:000011', NULL, NULL, 'Acetyl CoA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(190995, NULL, 'G3DSA:2.40.100.10:FF:000049', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(190996, NULL, 'G3DSA:3.40.50.10330:FF:000112', NULL, NULL, 'Uncharacterized kinase C24B10.02c', NULL, NULL, NULL, NULL, NULL, 4),
(190997, NULL, 'G3DSA:3.60.15.10:FF:000118', NULL, NULL, 'Metallo-beta-lactamase L1 type 3', NULL, NULL, NULL, NULL, NULL, 4),
(190998, NULL, 'G3DSA:1.10.3460.10:FF:000030', NULL, NULL, 'High intensity light-inducible lhc-like gene', NULL, NULL, NULL, NULL, NULL, 4),
(190999, NULL, 'G3DSA:2.30.40.10:FF:000175', NULL, NULL, 'Hydroxydechloroatrazine ethylaminohydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(191000, NULL, 'G3DSA:1.20.1260.10:FF:000040', NULL, NULL, 'Spore coat protein F', NULL, NULL, NULL, NULL, NULL, 4),
(191001, NULL, 'G3DSA:1.10.287.1490:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191002, NULL, 'G3DSA:3.40.50.300:FF:000915', NULL, NULL, 'DNA replication ATP-dependent helicase/nuclease DNA2', NULL, NULL, NULL, NULL, NULL, 4),
(191003, NULL, 'G3DSA:2.160.20.10:FF:000347', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(191004, NULL, 'G3DSA:3.30.40.210:FF:000001', NULL, NULL, 'Transcription elongation factor SPT4', NULL, NULL, NULL, NULL, NULL, 4),
(191005, NULL, 'G3DSA:1.20.120.550:FF:000006', NULL, NULL, 'Microsomal glutathione S-transferase 3', NULL, NULL, NULL, NULL, NULL, 4),
(191006, NULL, 'G3DSA:1.25.10.10:FF:001901', NULL, NULL, 'AaceriACL132Cp', NULL, NULL, NULL, NULL, NULL, 4),
(191007, NULL, 'G3DSA:3.40.850.10:FF:000546', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191008, NULL, 'G3DSA:2.60.120.640:FF:000001', NULL, NULL, 'Baseplate wedge tail fiber connector', NULL, NULL, NULL, NULL, NULL, 4),
(191009, NULL, 'G3DSA:3.30.1060.10:FF:000009', NULL, NULL, 'Methionine sulfoxide reductase A', NULL, NULL, NULL, NULL, NULL, 4),
(191010, NULL, 'G3DSA:2.40.10.10:FF:000594', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191011, NULL, 'G3DSA:3.40.1190.20:FF:000132', NULL, NULL, 'Bud polarity/site selection protein (BUD family), putative', NULL, NULL, NULL, NULL, NULL, 4),
(191012, NULL, 'G3DSA:1.10.287.3990:FF:000007', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 4-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(191013, NULL, 'G3DSA:3.60.40.10:FF:000103', NULL, NULL, 'Phosphatase 1G', NULL, NULL, NULL, NULL, NULL, 4),
(191014, NULL, 'G3DSA:3.30.56.10:FF:000006', NULL, NULL, 'Phenylalanyl-tRNA synthetase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(191015, NULL, 'G3DSA:1.10.3720.10:FF:000157', NULL, NULL, 'Peptide/nickel/opine uptake family ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(191016, NULL, 'G3DSA:3.30.70.330:FF:000880', NULL, NULL, 'Polypyrimidine tract-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(191017, NULL, 'G3DSA:1.10.630.10:FF:000027', NULL, NULL, 'lanosterol 14-alpha demethylase isoform X1', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(191018, NULL, 'G3DSA:3.10.110.10:FF:000278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191019, NULL, 'G3DSA:3.80.10.10:FF:003310', NULL, NULL, 'Toll-like receptor 5', NULL, NULL, NULL, NULL, NULL, 4),
(191020, NULL, 'G3DSA:3.30.40.10:FF:001482', NULL, NULL, 'Zinc finger FYVE domain-containing protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(191021, NULL, 'G3DSA:3.10.100.10:FF:000305', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191022, NULL, 'G3DSA:1.10.8.270:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191023, NULL, 'G3DSA:3.40.30.10:FF:000115', NULL, NULL, 'protein disulfide-isomerase TMX3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(191024, NULL, 'G3DSA:3.40.50.300:FF:002540', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(191025, NULL, 'G3DSA:3.30.1490.180:FF:000011', NULL, NULL, 'DNA-directed RNA polymerase I largest subunit', NULL, NULL, NULL, NULL, NULL, 4),
(191026, NULL, 'G3DSA:3.40.50.150:FF:001022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191027, NULL, 'G3DSA:2.70.170.10:FF:000103', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191028, NULL, 'G3DSA:1.20.120.1900:FF:000025', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(191029, NULL, 'G3DSA:3.30.70.890:FF:000019', NULL, NULL, 'Homoserine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(191030, NULL, 'G3DSA:2.30.30.380:FF:000008', NULL, NULL, 'nuclear protein localization protein 4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(191031, NULL, 'G3DSA:1.10.10.60:FF:000494', NULL, NULL, 'Snt1p', NULL, NULL, NULL, NULL, NULL, 4),
(191032, NULL, 'G3DSA:2.60.210.10:FF:000008', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM37 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(191033, NULL, 'G3DSA:1.10.287.70:FF:000286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191034, NULL, 'G3DSA:3.40.50.2300:FF:000407', NULL, NULL, 'RteA, two-component system histidine kinase, with response regulator receiver domain', NULL, NULL, NULL, NULL, NULL, 4),
(191035, NULL, 'G3DSA:1.25.10.10:FF:001429', NULL, NULL, 'STU2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(191036, NULL, 'G3DSA:3.30.1010.10:FF:000006', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(191037, NULL, 'G3DSA:1.25.40.570:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191038, NULL, 'G3DSA:3.40.640.10:FF:000356', NULL, NULL, 'C4 aminotransferase for PseB product PseC', NULL, NULL, NULL, NULL, NULL, 4),
(191039, NULL, 'G3DSA:2.60.40.10:FF:000229', NULL, NULL, 'Down syndrome cell adhesion molecule homolog', NULL, NULL, NULL, NULL, NULL, 4),
(191040, NULL, 'G3DSA:2.60.34.10:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191041, NULL, 'G3DSA:1.10.1370.30:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191042, NULL, 'G3DSA:1.25.40.790:FF:000019', NULL, NULL, 'General negative regulator of transcription subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(191043, NULL, 'G3DSA:2.60.40.10:FF:003574', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191044, NULL, 'G3DSA:1.20.5.320:FF:000023', NULL, NULL, 'Collagen type XVI alpha 1 chain', NULL, NULL, NULL, NULL, NULL, 4),
(191045, NULL, 'G3DSA:3.30.160.60:FF:000353', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(191046, NULL, 'G3DSA:1.10.150.510:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191047, NULL, 'G3DSA:3.30.160.60:FF:003787', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191048, NULL, 'G3DSA:3.20.20.300:FF:000037', NULL, NULL, 'Periplasmic beta-glucosidase, xylosidase/arabinosidase', NULL, NULL, NULL, NULL, NULL, 4),
(191049, NULL, 'G3DSA:1.25.40.10:FF:003022', NULL, NULL, 'Os06g0694600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(191050, NULL, 'G3DSA:1.25.10.10:FF:001340', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(191051, NULL, 'G3DSA:3.40.50.80:FF:000238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191052, NULL, 'G3DSA:2.10.25.10:FF:001787', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191053, NULL, 'G3DSA:1.10.238.10:FF:001144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191054, NULL, 'G3DSA:3.30.450.20:FF:000583', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191055, NULL, 'G3DSA:3.40.50.1820:FF:001590', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191056, NULL, 'G3DSA:1.20.120.420:FF:000018', NULL, NULL, 'Methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(191057, NULL, 'G3DSA:1.25.40.770:FF:000013', NULL, NULL, 'TAF6-like RNA polymerase II p300/CBP-associated factor-associated factor 65 kDa subunit 6L', NULL, NULL, NULL, NULL, NULL, 4),
(191058, NULL, 'G3DSA:1.10.287.110:FF:000236', NULL, NULL, 'Chaperone protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(191059, NULL, 'G3DSA:1.20.900.10:FF:000046', NULL, NULL, 'Related to CDC24-GTP/GDP exchange factor for Cdc42p', NULL, NULL, NULL, NULL, NULL, 4),
(191060, NULL, 'G3DSA:3.90.1580.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191061, NULL, 'G3DSA:2.60.40.10:FF:000140', NULL, NULL, 'FiLamiN (Actin binding protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(191062, NULL, 'G3DSA:3.30.710.10:FF:000089', NULL, NULL, 'Zinc finger and BTB domain-containing protein 7B', NULL, NULL, NULL, NULL, NULL, 4),
(191063, NULL, 'G3DSA:3.90.550.10:FF:000332', NULL, NULL, 'Glycosyl transferase family 8 protein', NULL, NULL, NULL, NULL, NULL, 4),
(191064, NULL, 'G3DSA:1.20.1250.20:FF:001560', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(191065, NULL, 'G3DSA:1.25.10.10:FF:002413', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191066, NULL, 'G3DSA:1.10.1280.10:FF:000021', NULL, NULL, 'Tyrosinase', NULL, NULL, NULL, NULL, NULL, 4),
(191067, NULL, 'G3DSA:1.10.238.10:FF:000744', NULL, NULL, 'Calmodulin-like membrane associated Ca(2+)-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(191068, NULL, 'G3DSA:1.10.10.10:FF:000232', NULL, NULL, 'lysine-specific histone demethylase 1B', NULL, NULL, NULL, NULL, NULL, 4),
(191069, NULL, 'G3DSA:2.60.40.10:FF:002466', NULL, NULL, 'Muscle, skeletal, receptor tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(191070, NULL, 'G3DSA:3.30.460.10:FF:000075', NULL, NULL, 'Ribosomal silencing factor RsfS', NULL, NULL, NULL, NULL, NULL, 4),
(191071, NULL, 'G3DSA:2.30.30.30:FF:000157', NULL, NULL, 'Ribosomal protein L29', NULL, NULL, NULL, NULL, NULL, 4),
(191072, NULL, 'G3DSA:2.60.40.3320:FF:000001', NULL, NULL, 'ORF48', NULL, NULL, NULL, NULL, NULL, 4),
(191073, NULL, 'G3DSA:1.20.1250.20:FF:001649', NULL, NULL, 'MFS alpha-glucoside transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(191074, NULL, 'G3DSA:3.90.1210.10:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191075, NULL, 'G3DSA:3.30.1360.40:FF:000013', NULL, NULL, 'DNA gyrase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(191076, NULL, 'G3DSA:3.40.140.10:FF:000099', NULL, NULL, 'Cytidine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(191077, NULL, 'G3DSA:3.30.70.330:FF:002965', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191078, NULL, 'G3DSA:1.25.40.180:FF:000134', NULL, NULL, 'Nuclear cap-binding protein subunit 1-B', NULL, NULL, NULL, NULL, NULL, 4),
(191079, NULL, 'G3DSA:3.30.40.10:FF:001858', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191080, NULL, 'G3DSA:1.25.40.1010:FF:000015', NULL, NULL, 'Narg1b protein', NULL, NULL, NULL, NULL, NULL, 4),
(191081, NULL, 'G3DSA:1.10.2020.20:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191082, NULL, 'G3DSA:3.30.230.80:FF:000011', NULL, NULL, 'Heat shock protein', NULL, NULL, NULL, NULL, NULL, 4),
(191083, NULL, 'G3DSA:3.30.70.330:FF:000728', NULL, NULL, 'U1 small Nuclear ribonucleoprotein A, Putative', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(191084, NULL, 'G3DSA:3.30.230.70:FF:000154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191085, NULL, 'G3DSA:1.10.510.10:FF:001485', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(191086, NULL, 'G3DSA:3.30.160.60:FF:005732', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191087, NULL, 'G3DSA:3.60.40.10:FF:000070', NULL, NULL, 'Protein phosphatase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(191088, NULL, 'G3DSA:3.40.50.10490:FF:000019', NULL, NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', NULL, NULL, NULL, NULL, NULL, 4),
(191089, NULL, 'G3DSA:3.30.70.1180:FF:000023', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(191090, NULL, 'G3DSA:3.10.120.10:FF:000048', NULL, NULL, 'Chitin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(191091, NULL, 'G3DSA:3.30.70.3030:FF:000011', NULL, NULL, 'U3 small nucleolar RNA-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(191092, NULL, 'G3DSA:1.20.1270.60:FF:000090', NULL, NULL, 'Snx4p', NULL, NULL, NULL, NULL, NULL, 4),
(191093, NULL, 'G3DSA:3.80.10.10:FF:002293', NULL, NULL, 'YALI0C06556p', NULL, NULL, NULL, NULL, NULL, 4),
(191094, NULL, 'G3DSA:1.10.238.10:FF:000924', NULL, NULL, 'Mitochondrial Rho GTPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(191095, NULL, 'G3DSA:3.30.160.750:FF:000003', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(191096, NULL, 'G3DSA:3.40.309.10:FF:000007', NULL, NULL, 'Aldehyde-alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(191097, NULL, 'G3DSA:3.30.420.40:FF:000238', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(191098, NULL, 'G3DSA:3.60.21.10:FF:000470', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(191099, NULL, 'G3DSA:1.10.287.160:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191100, NULL, 'G3DSA:1.20.120.980:FF:000017', NULL, NULL, 'Dipeptidyl peptidase 7', NULL, NULL, NULL, NULL, NULL, 4),
(191101, NULL, 'G3DSA:1.25.40.10:FF:004978', NULL, NULL, 'Flagellar associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(191102, NULL, 'G3DSA:2.40.50.840:FF:000002', NULL, NULL, 'Acetyl-CoA acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(191103, NULL, 'G3DSA:3.30.70.330:FF:000548', NULL, NULL, 'Myelin expression factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(191104, NULL, 'G3DSA:3.30.30.10:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191105, NULL, 'G3DSA:3.30.420.40:FF:000766', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(191106, NULL, 'G3DSA:3.30.460.10:FF:000108', NULL, NULL, 'WGS project CABT00000000 data, contig 2.10', NULL, NULL, NULL, NULL, NULL, 4),
(191107, NULL, 'G3DSA:1.10.1600.10:FF:000030', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191108, NULL, 'G3DSA:3.90.740.10:FF:000015', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(191109, NULL, 'G3DSA:3.40.50.200:FF:000150', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191110, NULL, 'G3DSA:1.10.238.10:FF:001200', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(191111, NULL, 'G3DSA:3.40.50.300:FF:006699', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191112, NULL, 'G3DSA:3.30.710.10:FF:000145', NULL, NULL, 'leucine-zipper-like transcriptional regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(191113, NULL, 'G3DSA:1.10.510.10:FF:002974', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191114, NULL, 'G3DSA:3.30.70.330:FF:000695', NULL, NULL, 'Blast:CCR4-NOT transcription complex subunit 11', NULL, NULL, NULL, NULL, NULL, 4),
(191115, NULL, 'G3DSA:1.10.510.10:FF:002789', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191116, NULL, 'G3DSA:1.10.10.10:FF:000608', NULL, NULL, 'Transcriptional regulator, MarR family', NULL, NULL, NULL, NULL, NULL, 4),
(191117, NULL, 'G3DSA:2.40.30.10:FF:000393', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(191118, NULL, 'G3DSA:2.40.240.10:FF:000026', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(191119, NULL, 'G3DSA:2.60.40.3190:FF:000001', NULL, NULL, 'Envelope glycoprotein H', NULL, NULL, NULL, NULL, NULL, 4),
(191120, NULL, 'G3DSA:3.40.50.300:FF:005266', NULL, NULL, 'GTP-binding protein Rit1', NULL, NULL, NULL, NULL, NULL, 4),
(191121, NULL, 'G3DSA:3.90.70.10:FF:000891', NULL, NULL, 'Transporter, truncation', NULL, NULL, NULL, NULL, NULL, 4),
(191122, NULL, 'G3DSA:1.20.1420.30:FF:000053', NULL, NULL, 'Sodium/calcium exchanger membrane region', NULL, NULL, NULL, NULL, NULL, 4),
(191123, NULL, 'G3DSA:1.10.510.10:FF:000844', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(191124, NULL, 'G3DSA:1.20.58.60:FF:000087', NULL, NULL, 'microtubule-actin cross-linking factor 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(191125, NULL, 'G3DSA:3.40.50.80:FF:000058', NULL, NULL, 'Ferric reductase transmembrane component 4, variant', NULL, NULL, NULL, NULL, NULL, 4),
(191126, NULL, 'G3DSA:1.20.1250.20:FF:000071', NULL, NULL, 'Inner membrane transporter ynfM', NULL, NULL, NULL, NULL, NULL, 4),
(191127, NULL, 'G3DSA:3.40.50.1010:FF:000245', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191128, NULL, 'G3DSA:3.30.160.60:FF:005788', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191129, NULL, 'G3DSA:1.10.220.10:FF:000069', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(191130, NULL, 'G3DSA:1.10.510.10:FF:003250', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191131, NULL, 'G3DSA:3.40.50.620:FF:000045', NULL, NULL, 'Glutamate--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(191132, NULL, 'G3DSA:3.40.630.30:FF:000013', NULL, NULL, 'cysteine-rich protein 2-binding protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(191133, NULL, 'G3DSA:1.25.40.10:FF:001021', NULL, NULL, 'Clustered mitochondria protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(191134, NULL, 'G3DSA:1.25.40.20:FF:001081', NULL, NULL, 'Testis expressed 14, intercellular bridge forming factor', NULL, NULL, NULL, NULL, NULL, 4),
(191135, NULL, 'G3DSA:2.80.10.50:FF:000019', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(191136, NULL, 'G3DSA:2.10.60.10:FF:000053', NULL, NULL, 'Anti-Mullerian hormone type 2 receptor delta 2', NULL, NULL, NULL, NULL, NULL, 4),
(191137, NULL, 'G3DSA:2.60.40.10:FF:005052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191138, NULL, 'G3DSA:2.130.10.120:FF:000015', NULL, NULL, 'Prolyl endopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(191139, NULL, 'G3DSA:3.40.630.30:FF:000485', NULL, NULL, 'Acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(191140, NULL, 'G3DSA:2.30.42.10:FF:000342', NULL, NULL, 'Putative proteasome 26S non-ATPase subunit 9', NULL, NULL, NULL, NULL, NULL, 4),
(191141, NULL, 'G3DSA:2.60.40.1660:FF:000003', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(191142, NULL, 'G3DSA:2.30.180.10:FF:000017', NULL, NULL, 'Stabilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(191143, NULL, 'G3DSA:2.60.40.10:FF:002702', NULL, NULL, 'PKHD1 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(191144, NULL, 'G3DSA:3.40.50.1380:FF:000013', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(191145, NULL, 'G3DSA:3.30.200.20:FF:000160', NULL, NULL, 'Serine/threonine-protein kinase 32C', NULL, NULL, NULL, NULL, NULL, 4),
(191146, NULL, 'G3DSA:2.130.10.10:FF:003231', NULL, NULL, 'WD repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(191147, NULL, 'G3DSA:2.60.40.10:FF:002646', NULL, NULL, 'Disorganized muscle protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(191148, NULL, 'G3DSA:3.30.160.60:FF:003315', NULL, NULL, 'Maternal gene required for meiosis, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(191149, NULL, 'G3DSA:3.30.565.10:FF:000520', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(191150, NULL, 'G3DSA:1.10.840.10:FF:000037', NULL, NULL, 'Son of sevenless homolog', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(191151, NULL, 'G3DSA:3.80.10.10:FF:000904', NULL, NULL, 'AGAP010636-PA', NULL, NULL, NULL, NULL, NULL, 4),
(191152, NULL, 'G3DSA:2.60.120.260:FF:000067', NULL, NULL, 'Putative E3 ubiquitin-protein ligase HECTD3', NULL, NULL, NULL, NULL, NULL, 4),
(191153, NULL, 'G3DSA:3.40.50.1820:FF:000662', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(191154, NULL, 'G3DSA:2.130.10.10:FF:003607', NULL, NULL, 'chromatin assembly factor 1 subunit B-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(191155, NULL, 'G3DSA:3.30.160.60:FF:004804', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191156, NULL, 'G3DSA:3.90.660.10:FF:000014', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(191157, NULL, 'G3DSA:3.30.800.10:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191158, NULL, 'G3DSA:1.20.1070.10:FF:000880', NULL, NULL, 'Chlamyopsin-5 sensory rhodopsin', NULL, NULL, NULL, NULL, NULL, 4),
(191159, NULL, 'G3DSA:3.40.390.10:FF:000319', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191160, NULL, 'G3DSA:2.60.40.10:FF:005428', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191161, NULL, 'G3DSA:3.40.50.170:FF:000011', NULL, NULL, 'phosphoribosylglycinamide formyltransferase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(191162, NULL, 'G3DSA:3.15.10.20:FF:000006', NULL, NULL, 'Activator of Hsp90 ATPase, N-terminal/Activator of Hsp90 ATPase like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(191163, NULL, 'G3DSA:1.20.1310.10:FF:000157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191164, NULL, 'G3DSA:2.70.170.10:FF:000047', NULL, NULL, 'neuronal acetylcholine receptor subunit alpha-5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(191165, NULL, 'G3DSA:3.30.870.10:FF:000162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191166, NULL, 'G3DSA:2.60.40.10:FF:001157', NULL, NULL, 'Natural cytotoxicity triggering receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(191167, NULL, 'G3DSA:1.20.120.1880:FF:000002', NULL, NULL, 'Nuclear pore complex protein NUP155', NULL, NULL, NULL, NULL, NULL, 4),
(191168, NULL, 'G3DSA:1.50.40.10:FF:000316', NULL, NULL, 'Dicarboxylate carrier 3, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(191169, NULL, 'G3DSA:1.10.30.10:FF:000031', NULL, NULL, 'High mobility group protein 20A', NULL, NULL, NULL, NULL, NULL, 4),
(191170, NULL, 'G3DSA:1.20.58.60:FF:000143', NULL, NULL, 'Periplakin', NULL, NULL, NULL, NULL, NULL, 4),
(191171, NULL, 'G3DSA:3.10.350.10:FF:000060', NULL, NULL, 'Probable N-acetylmuramoyl-L-alanine amidase AmiB', NULL, NULL, NULL, NULL, NULL, 4),
(191172, NULL, 'G3DSA:3.40.50.300:FF:006227', NULL, NULL, 'Terminase, large subunit gp2', NULL, NULL, NULL, NULL, NULL, 4),
(191173, NULL, 'G3DSA:1.20.1070.10:FF:000677', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191174, NULL, 'G3DSA:3.90.1300.10:FF:000043', NULL, NULL, 'Protein CBG13308', NULL, NULL, NULL, NULL, NULL, 4),
(191175, NULL, 'G3DSA:3.10.20.90:FF:000454', NULL, NULL, 'UBX domain protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(191176, NULL, 'G3DSA:3.30.420.10:FF:000134', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(191177, NULL, 'G3DSA:2.170.16.10:FF:000011', NULL, NULL, 'Pre-mRNA-processing-splicing factor 8', NULL, NULL, NULL, NULL, NULL, 4),
(191178, NULL, 'G3DSA:3.20.20.70:FF:000543', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191179, NULL, 'G3DSA:3.40.50.1010:FF:000189', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191180, NULL, 'G3DSA:1.10.1200.10:FF:000134', NULL, NULL, 'HC-toxin synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(191181, NULL, 'G3DSA:3.30.9.10:FF:000044', NULL, NULL, 'Probable sarcosine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(191182, NULL, 'G3DSA:3.30.930.10:FF:000217', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(191183, NULL, 'G3DSA:1.10.565.10:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191184, NULL, 'G3DSA:1.20.1250.20:FF:001032', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(191185, NULL, 'G3DSA:3.40.30.10:FF:000587', NULL, NULL, 'Thioredoxin TrxC', NULL, NULL, NULL, NULL, NULL, 4),
(191186, NULL, 'G3DSA:1.10.10.10:FF:000760', NULL, NULL, 'Ferric uptake regulation protein', NULL, NULL, NULL, NULL, NULL, 4),
(191187, NULL, 'G3DSA:3.40.50.620:FF:000101', NULL, NULL, 'Nicotinamide-nucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(191188, NULL, 'G3DSA:3.40.640.10:FF:000209', NULL, NULL, 'PLP-dependent transferase', NULL, NULL, NULL, NULL, NULL, 4),
(191189, NULL, 'G3DSA:3.10.450.40:FF:000020', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(191190, NULL, 'G3DSA:1.25.10.10:FF:003341', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191191, NULL, 'G3DSA:3.40.50.620:FF:000606', NULL, NULL, 'Kinase with adenine nucleotide alpha hydrolases-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(191192, NULL, 'G3DSA:3.30.70.270:FF:000305', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191193, NULL, 'G3DSA:1.10.510.10:FF:003194', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191194, NULL, 'G3DSA:3.40.50.720:FF:001997', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191195, NULL, 'G3DSA:3.30.40.10:FF:000554', NULL, NULL, 'PHD finger protein MALE STERILITY 1', NULL, NULL, NULL, NULL, NULL, 4),
(191196, NULL, 'G3DSA:3.90.190.10:FF:000293', NULL, NULL, 'Cell division cycle 14A', NULL, NULL, NULL, NULL, NULL, 4),
(191197, NULL, 'G3DSA:3.40.1350.60:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191198, NULL, 'G3DSA:2.130.10.10:FF:003046', NULL, NULL, 'Utp5p', NULL, NULL, NULL, NULL, NULL, 4),
(191199, NULL, 'G3DSA:3.80.10.10:FF:004035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191200, NULL, 'G3DSA:3.40.390.10:FF:000286', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191201, NULL, 'G3DSA:3.10.100.10:FF:000249', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191202, NULL, 'G3DSA:3.30.470.20:FF:000235', NULL, NULL, 'Glutathione synthetase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(191203, NULL, 'G3DSA:1.20.1460.10:FF:000016', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(191204, NULL, 'G3DSA:1.10.10.440:FF:000059', NULL, NULL, 'Transcription elongation regulator', NULL, NULL, NULL, NULL, NULL, 4),
(191205, NULL, 'G3DSA:2.60.120.680:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191206, NULL, 'G3DSA:3.40.50.300:FF:003321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191207, NULL, 'G3DSA:3.30.230.10:FF:000304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191208, NULL, 'G3DSA:2.40.50.140:FF:000562', NULL, NULL, 'DNA-directed RNA polymerase II subunit putative', NULL, NULL, NULL, NULL, NULL, 4),
(191209, NULL, 'G3DSA:1.20.1250.10:FF:000011', NULL, NULL, 'Interleukin-10', NULL, NULL, NULL, NULL, NULL, 4),
(191210, NULL, 'G3DSA:3.40.850.10:FF:000366', NULL, NULL, 'Kinesin family member 16B', NULL, NULL, NULL, NULL, NULL, 4),
(191211, NULL, 'G3DSA:3.10.20.30:FF:000099', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191212, NULL, 'G3DSA:1.25.40.20:FF:001114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191213, NULL, 'G3DSA:1.20.1120.10:FF:000002', NULL, NULL, 'Botulinum neurotoxin type D', NULL, NULL, NULL, NULL, NULL, 4),
(191214, NULL, 'G3DSA:2.10.50.30:FF:000053', NULL, NULL, 'Vomeronasal 2 receptor o', NULL, NULL, NULL, NULL, NULL, 4),
(191215, NULL, 'G3DSA:2.10.70.80:FF:000018', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191216, NULL, 'G3DSA:2.30.40.10:FF:000028', NULL, NULL, 'Dal1p', NULL, NULL, NULL, NULL, NULL, 4),
(191217, NULL, 'G3DSA:1.25.40.180:FF:000078', NULL, NULL, 'Translation initiation factor eIF-2B epsilon subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(191218, NULL, 'G3DSA:3.40.630.10:FF:000327', NULL, NULL, 'F10A2.10 protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(191219, NULL, 'G3DSA:1.10.10.10:FF:001013', NULL, NULL, 'ISPsy8, transposase OrfA', NULL, NULL, NULL, NULL, NULL, 4),
(191220, NULL, 'G3DSA:2.60.120.260:FF:000595', NULL, NULL, 'Glycoside hydrolase family 95', NULL, NULL, NULL, NULL, NULL, 4),
(191221, NULL, 'G3DSA:3.10.10.10:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191222, NULL, 'G3DSA:2.40.70.10:FF:000423', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191223, NULL, 'G3DSA:1.25.10.10:FF:002357', NULL, NULL, 'Condensin complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(191224, NULL, 'G3DSA:2.40.50.140:FF:000742', NULL, NULL, 'Interferon-activable protein 202', NULL, NULL, NULL, NULL, NULL, 4),
(191225, NULL, 'G3DSA:1.25.40.10:FF:003674', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191226, NULL, 'G3DSA:2.130.10.10:FF:002826', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191227, NULL, 'G3DSA:2.60.40.10:FF:003630', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191228, NULL, 'G3DSA:3.90.370.10:FF:000003', NULL, NULL, 'TIMP2', NULL, NULL, NULL, NULL, NULL, 4),
(191229, NULL, 'G3DSA:2.130.10.10:FF:002118', NULL, NULL, 'Mitochondrial division protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(191230, NULL, 'G3DSA:2.40.160.10:FF:000025', NULL, NULL, 'Outer membrane porin OprE', NULL, NULL, NULL, NULL, NULL, 4),
(191231, NULL, 'G3DSA:1.25.10.10:FF:002885', NULL, NULL, 'pumilio homolog 3 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(191232, NULL, 'G3DSA:1.20.58.60:FF:000704', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191233, NULL, 'G3DSA:2.30.130.10:FF:000014', NULL, NULL, 'Pseudouridine synthase/archaeosine transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(191234, NULL, 'G3DSA:1.25.10.10:FF:002177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191235, NULL, 'G3DSA:3.90.1140.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191236, NULL, 'G3DSA:3.40.525.10:FF:000021', NULL, NULL, 'Sec14-like cytosolic factor or phosphatidylinositol/phosphatidylcholine transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(191237, NULL, 'G3DSA:3.30.70.3310:FF:000005', NULL, NULL, 'Notch, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(191238, NULL, 'G3DSA:3.30.465.10:FF:000012', NULL, NULL, 'delta(24)-sterol reductase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(191239, NULL, 'G3DSA:3.40.50.1100:FF:000031', NULL, NULL, 'L-serine dehydratase/L-threonine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(191240, NULL, 'G3DSA:3.40.30.10:FF:000643', NULL, NULL, 'Iodothyronine deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(191241, NULL, 'G3DSA:1.25.10.10:FF:003285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191242, NULL, 'G3DSA:2.40.50.140:FF:000034', NULL, NULL, 'Eukaryotic translation initiation factor 5A', NULL, NULL, NULL, NULL, NULL, 4),
(191243, NULL, 'G3DSA:2.40.10.120:FF:000003', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(191244, NULL, 'G3DSA:3.30.479.20:FF:000047', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(191245, NULL, 'G3DSA:2.10.110.10:FF:000349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191246, NULL, 'G3DSA:3.30.230.10:FF:000119', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(191247, NULL, 'G3DSA:3.90.400.10:FF:000001', NULL, NULL, 'Maltase A3, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(191248, NULL, 'G3DSA:3.30.1680.10:FF:000068', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(191249, NULL, 'G3DSA:3.40.50.1400:FF:000036', NULL, NULL, 'Protoporphyrin ferrochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(191250, NULL, 'G3DSA:3.30.780.10:FF:000003', NULL, NULL, 'Eukaryotic translation initiation factor 1b', NULL, NULL, NULL, NULL, NULL, 4),
(191251, NULL, 'G3DSA:3.40.50.12780:FF:000116', NULL, NULL, 'solute carrier family 27 member 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(191252, NULL, 'G3DSA:1.25.40.10:FF:000616', NULL, NULL, 'Tetratricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(191253, NULL, 'G3DSA:1.20.810.10:FF:000016', NULL, NULL, 'Cytochrome b/b6 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(191254, NULL, 'G3DSA:3.40.50.1820:FF:000134', NULL, NULL, 'Kynurenine formamidase', NULL, NULL, NULL, NULL, NULL, 4),
(191255, NULL, 'G3DSA:1.10.10.10:FF:001721', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191256, NULL, 'G3DSA:1.50.10.20:FF:000025', NULL, NULL, 'Geranylgeranyl transferase type-2 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(191257, NULL, 'G3DSA:1.50.10.10:FF:000112', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(191258, NULL, 'G3DSA:3.30.950.10:FF:000016', NULL, NULL, 'Probable uroporphyrin-III c-methyltransferase hemD', NULL, NULL, NULL, NULL, NULL, 4),
(191259, NULL, 'G3DSA:2.30.30.40:FF:000306', NULL, NULL, 'Protein CBG22463', NULL, NULL, NULL, NULL, NULL, 4),
(191260, NULL, 'G3DSA:3.40.50.200:FF:000003', NULL, NULL, 'Tripeptidyl peptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(191261, NULL, 'G3DSA:3.40.630.30:FF:000541', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191262, NULL, 'G3DSA:3.10.20.90:FF:000510', NULL, NULL, 'Ubiquitin-specific protease 5', NULL, NULL, NULL, NULL, NULL, 4),
(191263, NULL, 'G3DSA:3.40.50.10190:FF:000143', NULL, NULL, 'Protein hsr-9', NULL, NULL, NULL, NULL, NULL, 4),
(191264, NULL, 'G3DSA:3.30.40.10:FF:000369', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(191265, NULL, 'G3DSA:2.30.42.10:FF:000162', NULL, NULL, 'Tail-specific protease', NULL, NULL, NULL, NULL, NULL, 4),
(191266, NULL, 'G3DSA:4.10.640.10:FF:000033', NULL, NULL, 'Mitochondrial ribosomal protein S18', NULL, NULL, NULL, NULL, NULL, 4),
(191267, NULL, 'G3DSA:3.90.640.10:FF:000215', NULL, NULL, 'Actin-related protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(191268, NULL, 'G3DSA:4.10.110.10:FF:000004', NULL, NULL, 'zona pellucida sperm-binding protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(191269, NULL, 'G3DSA:1.10.940.10:FF:000022', NULL, NULL, 'SUN protein', NULL, NULL, NULL, NULL, NULL, 4),
(191270, NULL, 'G3DSA:3.90.215.10:FF:000014', NULL, NULL, 'Blast:Protein scabrous', NULL, NULL, NULL, NULL, NULL, 4),
(191271, NULL, 'G3DSA:3.30.70.330:FF:001509', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191272, NULL, 'G3DSA:1.25.40.20:FF:000153', NULL, NULL, 'inactive serine/threonine-protein kinase TEX14 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(191273, NULL, 'G3DSA:1.25.40.10:FF:000240', NULL, NULL, 'Tetratricopeptide repeat protein 19, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(191274, NULL, 'G3DSA:2.60.40.150:FF:000665', NULL, NULL, 'Copine 2', NULL, NULL, NULL, NULL, NULL, 4),
(191275, NULL, 'G3DSA:3.40.50.300:FF:006755', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191276, NULL, 'G3DSA:1.20.1070.10:FF:000149', NULL, NULL, 'Calcitonin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(191277, NULL, 'G3DSA:3.40.50.300:FF:006194', NULL, NULL, 'Helicase conserved C-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(191278, NULL, 'G3DSA:1.20.1310.10:FF:000213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191279, NULL, 'G3DSA:2.160.20.10:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191280, NULL, 'G3DSA:3.30.160.60:FF:003843', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191281, NULL, 'G3DSA:3.30.810.10:FF:000001', NULL, NULL, '1-phosphatidylinositol 3-phosphate 5-kinase FAB1', NULL, NULL, NULL, NULL, NULL, 4),
(191282, NULL, 'G3DSA:1.10.3720.10:FF:000213', NULL, NULL, 'Hydroxymethylpyrimidine ABC transporter, transmembrane component', NULL, NULL, NULL, NULL, NULL, 4),
(191283, NULL, 'G3DSA:3.90.180.10:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191284, NULL, 'G3DSA:2.60.120.260:FF:000628', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191285, NULL, 'G3DSA:1.10.510.10:FF:004211', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191286, NULL, 'G3DSA:3.90.530.10:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(191287, NULL, 'G3DSA:1.10.730.10:FF:000208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191288, NULL, 'G3DSA:1.10.1040.10:FF:000094', NULL, NULL, 'Putative 2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(191289, NULL, 'G3DSA:3.30.900.10:FF:000013', NULL, NULL, 'Autophagy-related protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(191290, NULL, 'G3DSA:1.10.630.10:FF:000499', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(191291, NULL, 'G3DSA:3.30.420.10:FF:000662', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191292, NULL, 'G3DSA:3.40.50.10470:FF:000013', NULL, NULL, 'Methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(191293, NULL, 'G3DSA:3.80.10.10:FF:000871', NULL, NULL, 'volume-regulated anion channel subunit LRRC8A', NULL, NULL, NULL, NULL, NULL, 4),
(191294, NULL, 'G3DSA:3.40.50.1000:FF:000860', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191295, NULL, 'G3DSA:1.10.260.40:FF:000030', NULL, NULL, 'Coactivator bridging factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(191296, NULL, 'G3DSA:2.60.40.10:FF:001685', NULL, NULL, 'phosphatidylinositol phosphatase PTPRQ isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(191297, NULL, 'G3DSA:4.10.240.10:FF:000008', NULL, NULL, 'C6 zinc finger domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(191298, NULL, 'G3DSA:3.30.160.60:FF:002298', NULL, NULL, 'zinc finger protein 133 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(191299, NULL, 'G3DSA:1.25.40.20:FF:000861', NULL, NULL, 'Ankyrin repeat domain-containing protein 42', NULL, NULL, NULL, NULL, NULL, 4),
(191300, NULL, 'G3DSA:1.20.120.1760:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191301, NULL, 'G3DSA:2.60.40.1530:FF:000015', NULL, NULL, 'Integrin alpha pat-2', NULL, NULL, NULL, NULL, NULL, 4),
(191302, NULL, 'G3DSA:3.40.50.300:FF:002484', NULL, NULL, 'ADP ribosylation factor like GTPase 8B', NULL, NULL, NULL, NULL, NULL, 4),
(191303, NULL, 'G3DSA:3.80.10.10:FF:003597', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191304, NULL, 'G3DSA:3.80.10.10:FF:003782', NULL, NULL, 'Os11g0695800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(191305, NULL, 'G3DSA:3.40.50.720:FF:000018', NULL, NULL, 'Malate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(191306, NULL, 'G3DSA:3.50.50.60:FF:000271', NULL, NULL, 'Hyaluronate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(191307, NULL, 'G3DSA:2.40.30.10:FF:000033', NULL, NULL, 'GTP-binding protein TypA', NULL, NULL, NULL, NULL, NULL, 4),
(191308, NULL, 'G3DSA:1.20.1740.10:FF:000122', NULL, NULL, 'Putative solute carrier family 12 member 8-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(191309, NULL, 'G3DSA:3.10.580.10:FF:000133', NULL, NULL, 'Protein SDS23', NULL, NULL, NULL, NULL, NULL, 4),
(191310, NULL, 'G3DSA:3.30.200.20:FF:000721', NULL, NULL, 'Myosin light chain kinase isoform-I', NULL, NULL, NULL, NULL, NULL, 4),
(191311, NULL, 'G3DSA:3.30.559.70:FF:000046', NULL, NULL, 'Carnitine O-octanoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(191312, NULL, 'G3DSA:1.10.1070.11:FF:000085', NULL, NULL, 'Chromosome 12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(191313, NULL, 'G3DSA:3.40.50.1360:FF:000030', NULL, NULL, 'Glucosamine-6-phosphate deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(191314, NULL, 'G3DSA:2.30.42.10:FF:000403', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191315, NULL, 'G3DSA:3.40.50.12230:FF:000007', NULL, NULL, 'Methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(191316, NULL, 'G3DSA:3.30.70.100:FF:000064', NULL, NULL, 'Photoactivated adenylate cyclase subunit beta-like protein ST-', NULL, NULL, NULL, NULL, NULL, 4),
(191317, NULL, 'G3DSA:3.90.1750.10:FF:000094', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(191318, NULL, 'G3DSA:3.30.70.330:FF:001004', NULL, NULL, 'Os04g0682400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(191319, NULL, 'G3DSA:3.40.309.10:FF:000131', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(191320, NULL, 'G3DSA:3.30.1490.480:FF:000011', NULL, NULL, 'Endolytic murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(191321, NULL, 'G3DSA:3.40.50.300:FF:006778', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191322, NULL, 'G3DSA:1.10.520.10:FF:000030', NULL, NULL, 'L-ascorbate peroxidase 2 cytosolic', NULL, NULL, NULL, NULL, NULL, 4),
(191323, NULL, 'G3DSA:3.40.50.720:FF:001497', NULL, NULL, 'Uncharacterized oxidoreductase C1739.08c', NULL, NULL, NULL, NULL, NULL, 4),
(191324, NULL, 'G3DSA:2.60.40.1120:FF:000010', NULL, NULL, 'Carboxypeptidase Z', NULL, NULL, NULL, NULL, NULL, 4),
(191325, NULL, 'G3DSA:3.40.50.300:FF:003113', NULL, NULL, 'Shikimate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(191326, NULL, 'G3DSA:3.40.50.20:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191327, NULL, 'G3DSA:3.10.450.60:FF:000003', NULL, NULL, 'Arachidonate 5-lipoxygenase a', NULL, NULL, NULL, NULL, NULL, 4),
(191328, NULL, 'G3DSA:3.40.30.10:FF:001216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191329, NULL, 'G3DSA:3.30.70.260:FF:000179', NULL, NULL, 'Guanosine-3'',5''-bis(diphosphate) 3''-pyrophosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(191330, NULL, 'G3DSA:1.10.10.60:FF:000634', NULL, NULL, 'Transcriptional regulator, AraC/XylS family', NULL, NULL, NULL, NULL, NULL, 4),
(191331, NULL, 'G3DSA:1.10.510.10:FF:001625', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(191332, NULL, 'G3DSA:3.40.800.20:FF:000012', NULL, NULL, 'Histone deacetylase 8', NULL, NULL, NULL, NULL, NULL, 4),
(191333, NULL, 'G3DSA:2.170.130.10:FF:000060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191334, NULL, 'G3DSA:3.30.2130.10:FF:000010', NULL, NULL, 'GATS protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(191335, NULL, 'G3DSA:3.20.10.10:FF:000042', NULL, NULL, 'Branched-chain amino acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(191336, NULL, 'G3DSA:3.40.50.1000:FF:000068', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(191337, NULL, 'G3DSA:3.30.70.330:FF:001897', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191338, NULL, 'G3DSA:2.10.25.10:FF:000775', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191339, NULL, 'G3DSA:1.25.10.10:FF:001508', NULL, NULL, 'AP-2 complex subunit beta-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(191340, NULL, 'G3DSA:3.30.750.24:FF:000166', NULL, NULL, 'Chemotaxis locus antisigma factor antogonist', NULL, NULL, NULL, NULL, NULL, 4),
(191341, NULL, 'G3DSA:2.40.50.90:FF:000013', NULL, NULL, 'Tudor domain containing 6', NULL, NULL, NULL, NULL, NULL, 4),
(191342, NULL, 'G3DSA:1.20.5.170:FF:000192', NULL, NULL, 'RSC chromatin remodeling complex ATPase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(191343, NULL, 'G3DSA:3.40.50.2000:FF:001048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191344, NULL, 'G3DSA:3.30.40.10:FF:001982', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191345, NULL, 'G3DSA:2.40.30.30:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191346, NULL, 'G3DSA:3.30.190.20:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191347, NULL, 'G3DSA:3.30.70.330:FF:001476', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191348, NULL, 'G3DSA:1.25.10.10:FF:003054', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191349, NULL, 'G3DSA:3.30.429.10:FF:000002', NULL, NULL, 'Tautomerase', NULL, NULL, NULL, NULL, NULL, 4),
(191350, NULL, 'G3DSA:3.30.160.60:FF:004771', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191351, NULL, 'G3DSA:2.60.40.10:FF:001718', NULL, NULL, 'Neuroglian, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(191352, NULL, 'G3DSA:1.10.630.10:FF:000651', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191353, NULL, 'G3DSA:3.90.190.10:FF:000321', NULL, NULL, 'Dual specificity protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(191354, NULL, 'G3DSA:1.10.600.10:FF:000082', NULL, NULL, 'Octaprenyl-diphosphate synthase / Dimethylallyltransferase / Geranyltranstransferase (Farnesyldiphosphate synthase) / Geranylgeranyl pyrophosphate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(191355, NULL, 'G3DSA:1.20.1640.10:FF:000058', NULL, NULL, 'PaTched Related family', NULL, NULL, NULL, NULL, NULL, 4),
(191356, NULL, 'G3DSA:2.20.70.10:FF:000109', NULL, NULL, 'Putative pre-mRNA-processing factor 40', NULL, NULL, NULL, NULL, NULL, 4),
(191357, NULL, 'G3DSA:1.25.40.1050:FF:000004', NULL, NULL, '5''-3'' exonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(191358, NULL, 'G3DSA:1.20.1720.10:FF:000059', NULL, NULL, 'Probable transport protein HsrA', NULL, NULL, NULL, NULL, NULL, 4),
(191359, NULL, 'G3DSA:2.60.40.150:FF:000053', NULL, NULL, 'synaptotagmin-17 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(191360, NULL, 'G3DSA:4.10.240.10:FF:000160', NULL, NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(191361, NULL, 'G3DSA:1.20.120.160:FF:000007', NULL, NULL, 'Multistep phosphorelay regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(191362, NULL, 'G3DSA:3.80.10.10:FF:000724', NULL, NULL, 'Class II major histocompatibility complex transactivator', NULL, NULL, NULL, NULL, NULL, 4),
(191363, NULL, 'G3DSA:1.25.40.10:FF:000768', NULL, NULL, 'Pentatricopeptide repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(191364, NULL, 'G3DSA:3.30.559.10:FF:000186', NULL, NULL, 'Transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(191365, NULL, 'G3DSA:1.25.10.10:FF:000199', NULL, NULL, 'plakophilin-3', NULL, NULL, NULL, NULL, NULL, 4),
(191366, NULL, 'G3DSA:3.30.70.260:FF:000128', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(191367, NULL, 'G3DSA:1.20.5.1500:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191368, NULL, 'G3DSA:3.30.160.60:FF:003343', NULL, NULL, 'Zinc finger protein 1053', NULL, NULL, NULL, NULL, NULL, 4),
(191369, NULL, 'G3DSA:3.30.200.20:FF:000772', NULL, NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 101', NULL, NULL, NULL, NULL, NULL, 4),
(191370, NULL, 'G3DSA:3.40.50.11260:FF:000031', NULL, NULL, 'Putative heat shock protein HSP 90-beta 4', NULL, NULL, NULL, NULL, NULL, 4),
(191371, NULL, 'G3DSA:1.20.200.10:FF:000009', NULL, NULL, 'Phenylalanine ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(191372, NULL, 'G3DSA:3.30.2130.30:FF:000016', NULL, NULL, 'N2-methylguanosine tRNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(191373, NULL, 'G3DSA:2.130.10.10:FF:001601', NULL, NULL, 'GD19179', NULL, NULL, NULL, NULL, NULL, 4),
(191374, NULL, 'G3DSA:3.30.70.3290:FF:000010', NULL, NULL, 'Aspergillus niger contig An11c0010, genomic contig', NULL, NULL, NULL, NULL, NULL, 4),
(191375, NULL, 'G3DSA:1.25.40.10:FF:004242', NULL, NULL, 'Signal recognition particle subunit SRP72', NULL, NULL, NULL, NULL, NULL, 4),
(191376, NULL, 'G3DSA:3.30.230.10:FF:000271', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(191377, NULL, 'G3DSA:1.20.920.20:FF:000022', NULL, NULL, 'Dynein_heavy_chain_-_N-terminal_region_2_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(191378, NULL, 'G3DSA:3.30.540.10:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191379, NULL, 'G3DSA:3.80.10.10:FF:002118', NULL, NULL, 'Protein CBG11124', NULL, NULL, NULL, NULL, NULL, 4),
(191380, NULL, 'G3DSA:3.30.160.20:FF:000212', NULL, NULL, 'Double-stranded RNA-specific editase Adar-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(191381, NULL, 'G3DSA:2.60.120.1040:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191382, NULL, 'G3DSA:3.60.90.10:FF:000022', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(191383, NULL, 'G3DSA:3.30.470.20:FF:000022', NULL, NULL, 'beta-citrylglutamate synthase B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(191384, NULL, 'G3DSA:1.20.1250.20:FF:000155', NULL, NULL, 'Uncharacterized MFS-type transporter YhhS', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(191385, NULL, 'G3DSA:1.10.8.10:FF:000040', NULL, NULL, 'UBX domain-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(191386, NULL, 'G3DSA:3.30.70.330:FF:002465', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191387, NULL, 'G3DSA:3.30.200.20:FF:002166', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191388, NULL, 'G3DSA:1.10.600.10:FF:000031', NULL, NULL, 'Syn-copalyl diphosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(191389, NULL, 'G3DSA:1.20.930.60:FF:000012', NULL, NULL, 'AaceriABR069Wp', NULL, NULL, NULL, NULL, NULL, 4),
(191390, NULL, 'G3DSA:3.40.50.360:FF:000006', NULL, NULL, 'Flavodoxin', NULL, NULL, NULL, NULL, NULL, 4),
(191391, NULL, 'G3DSA:1.20.120.1920:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191392, NULL, 'G3DSA:2.30.29.30:FF:000435', NULL, NULL, 'Si:ch211-193c2.2', NULL, NULL, NULL, NULL, NULL, 4),
(191393, NULL, 'G3DSA:2.150.10.10:FF:000010', NULL, NULL, 'Mannuronan C-5-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(191394, NULL, 'G3DSA:3.40.50.300:FF:003501', NULL, NULL, 'Si:dkey-187j14.7', NULL, NULL, NULL, NULL, NULL, 4),
(191395, NULL, 'G3DSA:1.10.238.10:FF:001121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191396, NULL, 'G3DSA:3.40.50.720:FF:001446', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(191397, NULL, 'G3DSA:3.40.50.20:FF:000035', NULL, NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(191398, NULL, 'G3DSA:1.25.10.10:FF:002969', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191399, NULL, 'G3DSA:3.90.1750.10:FF:000043', NULL, NULL, 'E3 ubiquitin-protein ligase UPL1', NULL, NULL, NULL, NULL, NULL, 4),
(191400, NULL, 'G3DSA:3.90.70.200:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191401, NULL, 'G3DSA:3.90.190.10:FF:000372', NULL, NULL, 'Dual specificity protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(191402, NULL, 'G3DSA:3.30.300.30:FF:000142', NULL, NULL, 'Nonribosomal peptide synthase, putative (JCVI)', NULL, NULL, NULL, NULL, NULL, 4),
(191403, NULL, 'G3DSA:2.130.10.10:FF:005816', NULL, NULL, 'WD repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(191404, NULL, 'G3DSA:2.60.40.10:FF:003714', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191405, NULL, 'G3DSA:1.10.800.10:FF:000012', NULL, NULL, 'Tryptophan hydroxylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(191406, NULL, 'G3DSA:2.130.10.10:FF:004395', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191407, NULL, 'G3DSA:2.60.260.20:FF:000109', NULL, NULL, 'DnaJ-class molecular chaperone CbpA', NULL, NULL, NULL, NULL, NULL, 4),
(191408, NULL, 'G3DSA:1.25.40.720:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191409, NULL, 'G3DSA:3.40.50.300:FF:002596', NULL, NULL, 'Putative ras-like small GTPases', NULL, NULL, NULL, NULL, NULL, 4),
(191410, NULL, 'G3DSA:2.60.120.10:FF:000440', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191411, NULL, 'G3DSA:3.40.630.10:FF:000355', NULL, NULL, 'Protein CBG05160', NULL, NULL, NULL, NULL, NULL, 4),
(191412, NULL, 'G3DSA:3.40.50.2000:FF:000643', NULL, NULL, 'Putative transferase', NULL, NULL, NULL, NULL, NULL, 4),
(191413, NULL, 'G3DSA:3.30.450.20:FF:000060', NULL, NULL, 'Sensor protein FixL', NULL, NULL, NULL, NULL, NULL, 4),
(191414, NULL, 'G3DSA:3.40.1350.10:FF:000041', NULL, NULL, 'tRNA intron endonuclease, catalytic C-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(191415, NULL, 'G3DSA:3.30.40.10:FF:001122', NULL, NULL, 'E3 ubiquitin-protein ligase SINAT4', NULL, NULL, NULL, NULL, NULL, 4),
(191416, NULL, 'G3DSA:3.90.110.10:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191417, NULL, 'G3DSA:1.20.58.1030:FF:000003', NULL, NULL, 'DNA replication complex GINS protein PSF1', NULL, NULL, NULL, NULL, NULL, 4),
(191418, NULL, 'G3DSA:1.10.510.10:FF:003019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(191419, NULL, 'G3DSA:1.10.472.10:FF:000159', NULL, NULL, 'G1/S-specific cyclin-E isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(191420, NULL, 'G3DSA:1.25.40.20:FF:000658', NULL, NULL, 'Espin-like b', NULL, NULL, NULL, NULL, NULL, 4),
(191421, NULL, 'G3DSA:3.30.160.60:FF:001426', NULL, NULL, 'zinc finger protein 784', NULL, NULL, NULL, NULL, NULL, 4),
(191422, NULL, 'G3DSA:3.40.5.50:FF:000002', NULL, NULL, 'DNA replication complex GINS protein PSF2', NULL, NULL, NULL, NULL, NULL, 4),
(191423, NULL, 'G3DSA:1.10.10.650:FF:000009', NULL, NULL, 'Transcription elongation factor spt6, putative', NULL, NULL, NULL, NULL, NULL, 4),
(191424, NULL, 'G3DSA:3.50.50.60:FF:000119', NULL, NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', NULL, NULL, NULL, NULL, NULL, 4),
(191425, NULL, 'G3DSA:1.20.1560.10:FF:000057', NULL, NULL, 'ABC multidrug transporter SitT', NULL, NULL, NULL, NULL, NULL, 4),
(191426, NULL, 'G3DSA:2.130.10.10:FF:000292', NULL, NULL, 'Lysosomal trafficking regulator', NULL, NULL, NULL, NULL, NULL, 4),
(191427, NULL, 'G3DSA:2.60.120.200:FF:000133', NULL, NULL, 'nephronectin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(191428, NULL, 'G3DSA:3.40.50.2300:FF:000582', NULL, NULL, 'Autoinducer 2-binding periplasmic protein LuxP', NULL, NULL, NULL, NULL, NULL, 4),
(191429, NULL, 'G3DSA:2.30.30.1020:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191430, NULL, 'G3DSA:3.30.160.330:FF:000001', NULL, NULL, 'Protein E7', NULL, NULL, NULL, NULL, NULL, 4),
(191431, NULL, 'G3DSA:1.20.1080.10:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191432, NULL, 'G3DSA:3.40.50.2000:FF:001099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191433, NULL, 'G3DSA:3.40.640.10:FF:000069', NULL, NULL, 'Serine decarboxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(191434, NULL, 'G3DSA:1.25.40.10:FF:002797', NULL, NULL, 'Intraflagellar transport protein 56 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(191435, NULL, 'G3DSA:1.10.10.10:FF:001036', NULL, NULL, 'HTH-type transcriptional regulator IlvY', NULL, NULL, NULL, NULL, NULL, 4),
(191436, NULL, 'G3DSA:2.60.40.2030:FF:000007', NULL, NULL, 'Adhesion G-protein coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(191437, NULL, 'G3DSA:3.40.250.10:FF:000225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191438, NULL, 'G3DSA:3.10.590.10:FF:000010', NULL, NULL, 'thymocyte nuclear protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(191439, NULL, 'G3DSA:1.25.40.10:FF:002685', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191440, NULL, 'G3DSA:3.30.450.40:FF:000066', NULL, NULL, 'Two-component system sensor histidine kinase KdpD', NULL, NULL, NULL, NULL, NULL, 4),
(191441, NULL, 'G3DSA:1.10.510.10:FF:004498', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191442, NULL, 'G3DSA:3.40.50.300:FF:000207', NULL, NULL, 'CTP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(191443, NULL, 'G3DSA:3.90.1150.10:FF:000418', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191444, NULL, 'G3DSA:3.30.30.30:FF:000003', NULL, NULL, 'Heat shock protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(191445, NULL, 'G3DSA:3.40.50.300:FF:003973', NULL, NULL, 'MCM3', NULL, NULL, NULL, NULL, NULL, 4),
(191446, NULL, 'G3DSA:2.60.40.790:FF:000149', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191447, NULL, 'G3DSA:2.60.40.10:FF:000729', NULL, NULL, 'Down syndrome cell adhesion molecule', NULL, NULL, NULL, NULL, NULL, 4),
(191448, NULL, 'G3DSA:3.10.110.10:FF:000042', NULL, NULL, 'Ubiquitin-fold modifier-conjugating enzyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(191449, NULL, 'G3DSA:3.90.70.10:FF:000059', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 38', NULL, NULL, NULL, NULL, NULL, 4),
(191450, NULL, 'G3DSA:3.90.550.10:FF:000388', NULL, NULL, 'LARGE xylosyl- and glucuronyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(191451, NULL, 'G3DSA:3.30.9.10:FF:000280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(191452, NULL, 'G3DSA:1.10.238.10:FF:000183', NULL, NULL, 'TBC1 domain family member 8B', NULL, NULL, NULL, NULL, NULL, 4),
(191453, NULL, 'G3DSA:2.70.150.10:FF:000276', NULL, NULL, 'E1-E2 ATPase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(191454, NULL, 'G3DSA:3.30.160.360:FF:000009', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(191455, NULL, 'G3DSA:3.30.70.330:FF:000048', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein a1 isoform', NULL, NULL, NULL, NULL, NULL, 4),
(191456, NULL, 'G3DSA:1.25.10.10:FF:002065', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(191457, NULL, 'G3DSA:1.20.1070.10:FF:002127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191458, NULL, 'G3DSA:3.20.20.70:FF:000190', NULL, NULL, 'Trans-o-hydroxybenzylidenepyruvate hydratase-aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(191459, NULL, 'G3DSA:2.40.50.140:FF:000450', NULL, NULL, 'Aspartate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(191460, NULL, 'G3DSA:3.40.50.1820:FF:000246', NULL, NULL, 'Hydrolases, acting on ester bond', NULL, NULL, NULL, NULL, NULL, 4),
(191461, NULL, 'G3DSA:2.60.120.260:FF:000483', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191462, NULL, 'G3DSA:1.10.357.10:FF:000088', NULL, NULL, 'Transcriptional regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(191463, NULL, 'G3DSA:3.40.50.300:FF:004962', NULL, NULL, 'Protein CBG08054', NULL, NULL, NULL, NULL, NULL, 4),
(191464, NULL, 'G3DSA:1.10.238.10:FF:001172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191465, NULL, 'G3DSA:3.30.60.20:FF:000053', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(191466, NULL, 'G3DSA:1.25.40.20:FF:000597', NULL, NULL, 'Serine/threonine-protein phosphatase 6 regulatory ankyrin repeat subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(191467, NULL, 'G3DSA:1.20.120.610:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191468, NULL, 'G3DSA:2.60.40.4060:FF:000004', NULL, NULL, 'Fat-spondin', NULL, NULL, NULL, NULL, NULL, 4),
(191469, NULL, 'G3DSA:1.25.40.10:FF:001336', NULL, NULL, 'AGAP003052-PA', NULL, NULL, NULL, NULL, NULL, 4),
(191470, NULL, 'G3DSA:2.30.42.10:FF:000454', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191471, NULL, 'G3DSA:3.30.530.20:FF:000061', NULL, NULL, 'Ribosome association toxin RatA', NULL, NULL, NULL, NULL, NULL, 4),
(191472, NULL, 'G3DSA:1.20.58.400:FF:000013', NULL, NULL, 'Qb-SNARE_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(191473, NULL, 'G3DSA:3.40.1170.60:FF:000025', NULL, NULL, 'Putative DNA polymerase kappa', NULL, NULL, NULL, NULL, NULL, 4),
(191474, NULL, 'G3DSA:3.40.50.2300:FF:000531', NULL, NULL, 'Sugar ABC transporter, periplasmic sugar-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(191475, NULL, 'G3DSA:3.10.310.10:FF:000023', NULL, NULL, 'Proline racemase', NULL, NULL, NULL, NULL, NULL, 4),
(191476, NULL, 'G3DSA:3.60.10.10:FF:000422', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191477, NULL, 'G3DSA:3.30.160.60:FF:002775', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191478, NULL, 'G3DSA:1.10.220.150:FF:000018', NULL, NULL, 'Arf-GAP domain and FG repeat-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(191479, NULL, 'G3DSA:3.20.20.140:FF:000057', NULL, NULL, 'Adenosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(191480, NULL, 'G3DSA:3.30.160.60:FF:005608', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191481, NULL, 'G3DSA:3.30.40.10:FF:002319', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191482, NULL, 'G3DSA:1.10.10.2250:FF:000001', NULL, NULL, 'Chromosome partition protein MukE', NULL, NULL, NULL, NULL, NULL, 4),
(191483, NULL, 'G3DSA:1.10.510.10:FF:001272', NULL, NULL, 'Protein kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(191484, NULL, 'G3DSA:3.40.50.12670:FF:000004', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(191485, NULL, 'G3DSA:3.30.160.60:FF:005760', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191486, NULL, 'G3DSA:1.10.287.70:FF:000634', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191487, NULL, 'G3DSA:2.60.40.10:FF:005260', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191488, NULL, 'G3DSA:1.10.357.90:FF:000005', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(191489, NULL, 'G3DSA:3.80.10.10:FF:004474', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191490, NULL, 'G3DSA:1.20.1070.10:FF:000380', NULL, NULL, 'D(3) dopamine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(191491, NULL, 'G3DSA:1.10.4080.10:FF:000006', NULL, NULL, 'ADP-ribosylglycohydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(191492, NULL, 'G3DSA:2.30.30.30:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191493, NULL, 'G3DSA:2.60.120.740:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191494, NULL, 'G3DSA:3.30.70.330:FF:002414', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191495, NULL, 'G3DSA:3.20.20.80:FF:000512', NULL, NULL, 'Di-N-acetylchitobiase', NULL, NULL, NULL, NULL, NULL, 4),
(191496, NULL, 'G3DSA:2.60.120.260:FF:000123', NULL, NULL, 'Clan SB, family S8, subtilisin-like serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(191497, NULL, 'G3DSA:2.60.120.650:FF:000150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191498, NULL, 'G3DSA:3.20.20.190:FF:000111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191499, NULL, 'G3DSA:1.10.150.560:FF:000001', NULL, NULL, 'Major DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(191500, NULL, 'G3DSA:3.40.120.10:FF:000064', NULL, NULL, 'Putative phosphoglucosamine mutase protein', NULL, NULL, NULL, NULL, NULL, 4),
(191501, NULL, 'G3DSA:1.10.4160.10:FF:000007', NULL, NULL, 'Pyridoxine transporter', NULL, NULL, NULL, NULL, NULL, 4),
(191502, NULL, 'G3DSA:1.10.287.2900:FF:000006', NULL, NULL, 'Protein CBG18121', NULL, NULL, NULL, NULL, NULL, 4),
(191503, NULL, 'G3DSA:2.130.10.10:FF:005704', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191504, NULL, 'G3DSA:3.90.70.10:FF:000008', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 47', NULL, NULL, NULL, NULL, NULL, 4),
(191505, NULL, 'G3DSA:2.70.50.40:FF:000008', NULL, NULL, 'Unc-119 lipid binding chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(191506, NULL, 'G3DSA:3.60.20.10:FF:000248', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191507, NULL, 'G3DSA:1.10.10.10:FF:001980', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191508, NULL, 'G3DSA:3.30.40.10:FF:000633', NULL, NULL, 'Putative BOI-related E3 ubiquitin-protein ligase 2', NULL, NULL, NULL, NULL, NULL, 4),
(191509, NULL, 'G3DSA:1.25.40.270:FF:000009', NULL, NULL, 'Vacuolar protein sorting-associated protein vts1', NULL, NULL, NULL, NULL, NULL, 4),
(191510, NULL, 'G3DSA:3.50.50.60:FF:001108', NULL, NULL, 'Ubiquinone monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(191511, NULL, 'G3DSA:1.20.1070.10:FF:001790', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191512, NULL, 'G3DSA:3.30.310.50:FF:000025', NULL, NULL, 'Transcription factor Pcc1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(191513, NULL, 'G3DSA:3.80.10.10:FF:002169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191514, NULL, 'G3DSA:3.60.21.10:FF:000239', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191515, NULL, 'G3DSA:3.40.50.1380:FF:000018', NULL, NULL, 'Carbamoyl-phosphate synthase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(191516, NULL, 'G3DSA:3.40.50.12780:FF:000037', NULL, NULL, 'Acyl-CoA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(191517, NULL, 'G3DSA:2.170.210.10:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191518, NULL, 'G3DSA:3.40.190.10:FF:000158', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(191519, NULL, 'G3DSA:3.40.50.300:FF:003001', NULL, NULL, 'Adenylate kinase isoenzyme 6', NULL, NULL, NULL, NULL, NULL, 4),
(191520, NULL, 'G3DSA:2.130.10.10:FF:001522', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(191521, NULL, 'G3DSA:3.30.60.20:FF:000002', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(191522, NULL, 'G3DSA:2.40.50.1000:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191523, NULL, 'G3DSA:1.20.5.320:FF:000028', NULL, NULL, 'pulmonary surfactant-associated protein A1-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(191524, NULL, 'G3DSA:3.30.430.20:FF:000025', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(191525, NULL, 'G3DSA:1.10.472.80:FF:000039', NULL, NULL, 'TBC1 domain family member 25 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(191526, NULL, 'G3DSA:1.10.533.10:FF:000301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191527, NULL, 'G3DSA:3.40.50.2000:FF:000559', NULL, NULL, 'Alpha,alpha-trehalose-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(191528, NULL, 'G3DSA:3.30.1370.10:FF:000151', NULL, NULL, 'Protein CBG06045', NULL, NULL, NULL, NULL, NULL, 4),
(191529, NULL, 'G3DSA:2.130.10.10:FF:005024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191530, NULL, 'G3DSA:3.30.300.30:FF:000081', NULL, NULL, 'NRPS-like enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(191531, NULL, 'G3DSA:3.90.190.10:FF:000433', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191532, NULL, 'G3DSA:3.40.50.150:FF:001522', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191533, NULL, 'G3DSA:1.25.10.10:FF:002857', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(191534, NULL, 'G3DSA:2.120.10.30:FF:000388', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(191535, NULL, 'G3DSA:3.60.21.60:FF:000001', NULL, NULL, 'DNA polymerase epsilon subunit', NULL, NULL, NULL, NULL, NULL, 4),
(191536, NULL, 'G3DSA:2.60.40.10:FF:000881', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', NULL, NULL, NULL, NULL, NULL, 4),
(191537, NULL, 'G3DSA:1.10.555.10:FF:000054', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(191538, NULL, 'G3DSA:3.20.20.190:FF:000162', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191539, NULL, 'G3DSA:3.80.10.10:FF:001781', NULL, NULL, 'Protein CBG00897', NULL, NULL, NULL, NULL, NULL, 4),
(191540, NULL, 'G3DSA:2.60.40.10:FF:003343', NULL, NULL, 'Immunoglobulin heavy variable 4-31', NULL, NULL, NULL, NULL, NULL, 4),
(191541, NULL, 'G3DSA:3.30.70.330:FF:002353', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191542, NULL, 'G3DSA:2.60.40.1820:FF:000006', NULL, NULL, 'Water stress/hypersensitive response protein', NULL, NULL, NULL, NULL, NULL, 4),
(191543, NULL, 'G3DSA:3.40.30.10:FF:001104', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191544, NULL, 'G3DSA:3.30.70.260:FF:000067', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(191545, NULL, 'G3DSA:1.25.40.10:FF:001257', NULL, NULL, 'Tetratricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(191546, NULL, 'G3DSA:1.25.10.10:FF:003425', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191547, NULL, 'G3DSA:3.60.130.10:FF:000060', NULL, NULL, 'Gll1897 protein', NULL, NULL, NULL, NULL, NULL, 4),
(191548, NULL, 'G3DSA:3.30.200.20:FF:000249', NULL, NULL, 'twitchin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(191549, NULL, 'G3DSA:1.10.730.10:FF:000147', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(191550, NULL, 'G3DSA:3.10.20.90:FF:000398', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191551, NULL, 'G3DSA:3.40.50.300:FF:007267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191552, NULL, 'G3DSA:1.10.3130.10:FF:000005', NULL, NULL, 'Serine acetyltransferase 4', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(191553, NULL, 'G3DSA:1.25.10.10:FF:002565', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191554, NULL, 'G3DSA:1.10.1450.10:FF:000085', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(191555, NULL, 'G3DSA:1.20.1070.10:FF:000441', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(191556, NULL, 'G3DSA:2.40.50.140:FF:000950', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191557, NULL, 'G3DSA:2.60.120.10:FF:000389', NULL, NULL, 'Acireductone dioxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(191558, NULL, 'G3DSA:1.20.58.80:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191559, NULL, 'G3DSA:3.50.30.20:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191560, NULL, 'G3DSA:3.30.160.60:FF:002854', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191561, NULL, 'G3DSA:3.30.70.330:FF:001072', NULL, NULL, 'Nucleolin', NULL, NULL, NULL, NULL, NULL, 4),
(191562, NULL, 'G3DSA:3.40.50.2300:FF:001099', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191563, NULL, 'G3DSA:1.25.40.20:FF:001614', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191564, NULL, 'G3DSA:3.80.10.10:FF:001601', NULL, NULL, 'CLL1A clavata1-like receptor S/T protein kinase protein', NULL, NULL, NULL, NULL, NULL, 4),
(191565, NULL, 'G3DSA:3.30.70.240:FF:000061', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(191566, NULL, 'G3DSA:3.30.450.200:FF:000011', NULL, NULL, 'DENN domain containing protein 2D', NULL, NULL, NULL, NULL, NULL, 4),
(191567, NULL, 'G3DSA:3.80.10.10:FF:004535', NULL, NULL, 'Putative F-box/LRR-repeat protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(191568, NULL, 'G3DSA:2.130.10.10:FF:004748', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191569, NULL, 'G3DSA:1.25.40.90:FF:000005', NULL, NULL, 'Clathrin assembly protein AP180', NULL, NULL, NULL, NULL, NULL, 4),
(191570, NULL, 'G3DSA:2.60.40.10:FF:003635', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191571, NULL, 'G3DSA:3.40.50.1910:FF:000009', NULL, NULL, 'Sec1 family superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(191572, NULL, 'G3DSA:3.40.190.10:FF:000107', NULL, NULL, 'Phosphate ABC transporter, phosphate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(191573, NULL, 'G3DSA:2.60.40.10:FF:003686', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191574, NULL, 'G3DSA:1.10.287.70:FF:000134', NULL, NULL, 'Glutamate receptor, ionotropic kainate', NULL, NULL, NULL, NULL, NULL, 4),
(191575, NULL, 'G3DSA:2.60.120.920:FF:000023', NULL, NULL, 'Tripartite motif-containing 5 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(191576, NULL, 'G3DSA:3.40.50.10190:FF:000171', NULL, NULL, 'DNA ligase 3', NULL, NULL, NULL, NULL, NULL, 4),
(191577, NULL, 'G3DSA:2.70.98.10:FF:000087', NULL, NULL, 'Glycoside hydrolase family 92 protein', NULL, NULL, NULL, NULL, NULL, 4),
(191578, NULL, 'G3DSA:1.20.58.60:FF:000727', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191579, NULL, 'G3DSA:2.40.50.100:FF:000106', NULL, NULL, 'Carbamoyl-phosphate synthase L chain, ATP-binding', NULL, NULL, NULL, NULL, NULL, 4),
(191580, NULL, 'G3DSA:3.30.40.10:FF:000133', NULL, NULL, 'E3 ubiquitin-protein ligase RNF123', NULL, NULL, NULL, NULL, NULL, 4),
(191581, NULL, 'G3DSA:1.10.533.10:FF:000060', NULL, NULL, 'disks large homolog 5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(191582, NULL, 'G3DSA:3.30.1490.180:FF:000039', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(191583, NULL, 'G3DSA:3.40.50.2300:FF:000935', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191584, NULL, 'G3DSA:3.30.70.330:FF:001976', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191585, NULL, 'G3DSA:3.40.50.12780:FF:000088', NULL, NULL, 'Possible o-succinylbenzoic acid--CoA ligase menE', NULL, NULL, NULL, NULL, NULL, 4),
(191586, NULL, 'G3DSA:3.40.50.300:FF:005030', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(191587, NULL, 'G3DSA:3.30.160.60:FF:004299', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191588, NULL, 'G3DSA:3.40.50.150:FF:001573', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191589, NULL, 'G3DSA:3.20.20.70:FF:000251', NULL, NULL, '2-isopropylmalate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(191590, NULL, 'G3DSA:3.30.30.30:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191591, NULL, 'G3DSA:2.60.40.150:FF:000457', NULL, NULL, 'RPGR-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(191592, NULL, 'G3DSA:3.40.50.10900:FF:000013', NULL, NULL, 'Proteasome assembly chaperone 2', NULL, NULL, NULL, NULL, NULL, 4),
(191593, NULL, 'G3DSA:3.40.50.300:FF:002624', NULL, NULL, 'YDR336W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(191594, NULL, 'G3DSA:1.10.720.30:FF:000017', NULL, NULL, 'heterogeneous nuclear ribonucleoprotein U-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(191595, NULL, 'G3DSA:3.80.30.20:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191596, NULL, 'G3DSA:3.30.70.660:FF:000012', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(191597, NULL, 'G3DSA:1.20.120.1240:FF:000069', NULL, NULL, 'Dynamin-related GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(191598, NULL, 'G3DSA:2.20.70.10:FF:000261', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191599, NULL, 'G3DSA:3.40.1190.20:FF:000104', NULL, NULL, 'GD12805', NULL, NULL, NULL, NULL, NULL, 4),
(191600, NULL, 'G3DSA:2.60.120.290:FF:000019', NULL, NULL, 'Adhesion G-protein coupled receptor G6', NULL, NULL, NULL, NULL, NULL, 4),
(191601, NULL, 'G3DSA:1.20.120.340:FF:000005', NULL, NULL, 'Perilipin', NULL, NULL, NULL, NULL, NULL, 4),
(191602, NULL, 'G3DSA:1.10.510.10:FF:002502', NULL, NULL, 'Serine/threonine-protein kinase flr-4', NULL, NULL, NULL, NULL, NULL, 4),
(191603, NULL, 'G3DSA:1.25.40.20:FF:001665', NULL, NULL, 'GH09064p', NULL, NULL, NULL, NULL, NULL, 4),
(191604, NULL, 'G3DSA:3.90.70.10:FF:000508', NULL, NULL, 'Cathepsin O', NULL, NULL, NULL, NULL, NULL, 4),
(191605, NULL, 'G3DSA:3.90.1150.10:FF:000065', NULL, NULL, 'Selenocysteine lyase', NULL, NULL, NULL, NULL, NULL, 4),
(191606, NULL, 'G3DSA:2.30.30.1190:FF:000015', NULL, NULL, 'Zinc finger CCCH domain-containing protein 34 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(191607, NULL, 'G3DSA:3.30.470.20:FF:000090', NULL, NULL, 'BnaA09g04240D protein', NULL, NULL, NULL, NULL, NULL, 4),
(191608, NULL, 'G3DSA:1.20.58.340:FF:000034', NULL, NULL, 'Magnesium and cobalt transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(191609, NULL, 'G3DSA:1.10.10.10:FF:000991', NULL, NULL, 'Deoxyribonucleoside regulator', NULL, NULL, NULL, NULL, NULL, 4),
(191610, NULL, 'G3DSA:2.70.98.30:FF:000014', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(191611, NULL, 'G3DSA:1.20.58.80:FF:000042', NULL, NULL, 'BMA-SPAS-1, isoform d', NULL, NULL, NULL, NULL, NULL, 4),
(191612, NULL, 'G3DSA:3.10.129.10:FF:000068', NULL, NULL, 'Thioesterase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(191613, NULL, 'G3DSA:2.60.40.4100:FF:000005', NULL, NULL, 'Deleted in malignant brain tumors 1', NULL, NULL, NULL, NULL, NULL, 4),
(191614, NULL, 'G3DSA:2.160.20.10:FF:000055', NULL, NULL, 'F-box only protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(191615, NULL, 'G3DSA:1.10.220.150:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191616, NULL, 'G3DSA:3.40.50.300:FF:001495', NULL, NULL, 'ATP-binding cassette protein subfamily G, member 4', NULL, NULL, NULL, NULL, NULL, 4),
(191617, NULL, 'G3DSA:1.10.510.10:FF:003930', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191618, NULL, 'G3DSA:3.40.605.10:FF:000050', NULL, NULL, 'Aldehyde dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(191619, NULL, 'G3DSA:3.90.226.10:FF:000039', NULL, NULL, 'Propionyl-CoA carboxylase subunit beta 6', NULL, NULL, NULL, NULL, NULL, 4),
(191620, NULL, 'G3DSA:3.30.160.60:FF:001786', NULL, NULL, 'Zinc finger and SCAN domain containing 10', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(191621, NULL, 'G3DSA:3.40.50.410:FF:000128', NULL, NULL, '26S proteasome regulatory subunit S5A (AFU_orthologue AFUA_2G15070)', NULL, NULL, NULL, NULL, NULL, 4),
(191622, NULL, 'G3DSA:3.40.50.2300:FF:000290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191623, NULL, 'G3DSA:3.30.200.20:FF:001609', NULL, NULL, 'Probable receptor-like serine/threonine-protein kinase At4g34500', NULL, NULL, NULL, NULL, NULL, 4),
(191624, NULL, 'G3DSA:3.30.160.60:FF:001494', NULL, NULL, 'zinc finger protein 10 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(191625, NULL, 'G3DSA:3.80.10.10:FF:000663', NULL, NULL, 'F-box/LRR-repeat protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(191626, NULL, 'G3DSA:3.40.50.150:FF:000292', NULL, NULL, 'SAM-dependent methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(191627, NULL, 'G3DSA:3.30.200.20:FF:002245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191628, NULL, 'G3DSA:1.20.120.1220:FF:000012', NULL, NULL, 'Components of type IV pilus, prepilin peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(191629, NULL, 'G3DSA:3.80.10.10:FF:000371', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3', NULL, NULL, NULL, NULL, NULL, 4),
(191630, NULL, 'G3DSA:1.10.132.60:FF:000042', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(191631, NULL, 'G3DSA:2.20.100.10:FF:000026', NULL, NULL, 'Spondin 1', NULL, NULL, NULL, NULL, NULL, 4),
(191632, NULL, 'G3DSA:2.40.37.10:FF:000020', NULL, NULL, 'Ornithine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(191633, NULL, 'G3DSA:1.25.40.10:FF:003253', NULL, NULL, 'Os12g0156900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(191634, NULL, 'G3DSA:1.10.630.10:FF:000263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191635, NULL, 'G3DSA:3.40.850.10:FF:000254', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(191636, NULL, 'G3DSA:2.40.70.10:FF:000479', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191637, NULL, 'G3DSA:3.30.1050.10:FF:000043', NULL, NULL, 'Stomatin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(191638, NULL, 'G3DSA:3.40.50.150:FF:000112', NULL, NULL, 'tRNA (Cytosine-5-)-methyltransferase NCL1', NULL, NULL, NULL, NULL, NULL, 4),
(191639, NULL, 'G3DSA:3.30.160.60:FF:002062', NULL, NULL, 'Ras-responsive element-binding protein 1 isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(191640, NULL, 'G3DSA:1.10.1370.10:FF:000028', NULL, NULL, 'Si:ch73-1a9.4', NULL, NULL, NULL, NULL, NULL, 4),
(191641, NULL, 'G3DSA:3.90.470.10:FF:000011', NULL, NULL, '50S ribosomal protein L22', NULL, NULL, NULL, NULL, NULL, 4),
(191642, NULL, 'G3DSA:1.25.40.10:FF:005147', NULL, NULL, 'Clathrin and VPS domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(191643, NULL, 'G3DSA:3.60.40.10:FF:000250', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(191644, NULL, 'G3DSA:3.40.1410.10:FF:000012', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(191645, NULL, 'G3DSA:2.30.180.10:FF:000192', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191646, NULL, 'G3DSA:3.30.565.10:FF:000048', NULL, NULL, 'Two-component system sensor histidine kinase PmrB', NULL, NULL, NULL, NULL, NULL, 4),
(191647, NULL, 'G3DSA:3.40.1190.20:FF:000155', NULL, NULL, 'Hypothetical sugar kinase', NULL, NULL, NULL, NULL, NULL, 4),
(191648, NULL, 'G3DSA:3.40.140.10:FF:000155', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191649, NULL, 'G3DSA:2.60.120.200:FF:000212', NULL, NULL, 'Axotactin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(191650, NULL, 'G3DSA:2.60.120.260:FF:000191', NULL, NULL, 'Putative wall-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(191651, NULL, 'G3DSA:3.60.110.10:FF:000025', NULL, NULL, 'N-carbamoylputrescine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(191652, NULL, 'G3DSA:3.30.40.10:FF:000925', NULL, NULL, 'Zinc finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(191653, NULL, 'G3DSA:1.20.1250.20:FF:000604', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(191654, NULL, 'G3DSA:1.10.287.110:FF:000096', NULL, NULL, 'DnaJ domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(191655, NULL, 'G3DSA:2.130.10.10:FF:002950', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191656, NULL, 'G3DSA:3.30.70.60:FF:000043', NULL, NULL, '30S ribosomal protein S6', NULL, NULL, NULL, NULL, NULL, 4),
(191657, NULL, 'G3DSA:1.10.10.10:FF:001328', NULL, NULL, 'Meiotic recombination protein spo-11', NULL, NULL, NULL, NULL, NULL, 4),
(191658, NULL, 'G3DSA:3.40.50.720:FF:002014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191659, NULL, 'G3DSA:3.30.160.60:FF:006165', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191660, NULL, 'G3DSA:3.55.40.20:FF:000001', NULL, NULL, 'Superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(191661, NULL, 'G3DSA:3.30.200.20:FF:001969', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(191662, NULL, 'G3DSA:1.10.238.10:FF:001060', NULL, NULL, 'Reticulocalbin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(191663, NULL, 'G3DSA:3.30.40.10:FF:002027', NULL, NULL, 'Chromosome 15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(191664, NULL, 'G3DSA:3.40.50.1820:FF:000538', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(191665, NULL, 'G3DSA:2.60.40.60:FF:000019', NULL, NULL, 'Cadherin 2', NULL, NULL, NULL, NULL, NULL, 4),
(191666, NULL, 'G3DSA:2.20.25.10:FF:000134', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191667, NULL, 'G3DSA:3.30.450.70:FF:000013', NULL, NULL, 'TRAPP complex subunit, variant', NULL, NULL, NULL, NULL, NULL, 4),
(191668, NULL, 'G3DSA:3.40.50.10190:FF:000019', NULL, NULL, 'BRCA1 associated RING domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(191669, NULL, 'G3DSA:2.60.120.470:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191670, NULL, 'G3DSA:3.80.10.10:FF:000320', NULL, NULL, 'Protein phosphatase 1 regulatory subunit pprA', NULL, NULL, NULL, NULL, NULL, 4),
(191671, NULL, 'G3DSA:2.30.30.40:FF:000458', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191672, NULL, 'G3DSA:2.60.120.10:FF:000001', NULL, NULL, 'cAMP-activated global transcriptional regulator CRP', NULL, NULL, NULL, NULL, NULL, 4),
(191673, NULL, 'G3DSA:3.60.10.10:FF:000034', NULL, NULL, 'Exodeoxyribonuclease III', NULL, NULL, NULL, NULL, NULL, 4),
(191674, NULL, 'G3DSA:2.130.10.10:FF:003107', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191675, NULL, 'G3DSA:1.10.238.10:FF:001088', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(191676, NULL, 'G3DSA:2.40.37.10:FF:000071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191677, NULL, 'G3DSA:2.130.10.10:FF:000645', NULL, NULL, 'Putative nuclear pore complex subunit Nup159', NULL, NULL, NULL, NULL, NULL, 4),
(191678, NULL, 'G3DSA:3.30.9.10:FF:000049', NULL, NULL, 'Glycine oxidase ThiO', NULL, NULL, NULL, NULL, NULL, 4),
(191679, NULL, 'G3DSA:2.40.30.110:FF:000015', NULL, NULL, 'N,N-dimethylglycine oxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(191680, NULL, 'G3DSA:1.10.600.10:FF:000143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191681, NULL, 'G3DSA:2.170.16.10:FF:000016', NULL, NULL, 'GRounDhog (Hedgehog-like family)', NULL, NULL, NULL, NULL, NULL, 4),
(191682, NULL, 'G3DSA:2.60.220.50:FF:000049', NULL, NULL, 'Latrophilin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(191683, NULL, 'G3DSA:3.30.160.60:FF:000033', NULL, NULL, 'Immunodeficiency virus type I enhancer binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(191684, NULL, 'G3DSA:3.90.550.10:FF:000012', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(191685, NULL, 'G3DSA:3.20.20.80:FF:000580', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191686, NULL, 'G3DSA:3.60.110.10:FF:000076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191687, NULL, 'G3DSA:1.20.120.1240:FF:000018', NULL, NULL, 'Dynamin-related protein 3A', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(191688, NULL, 'G3DSA:1.20.1250.20:FF:000655', NULL, NULL, 'Integral membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(191689, NULL, 'G3DSA:3.30.160.60:FF:002803', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191690, NULL, 'G3DSA:1.20.1280.290:FF:000038', NULL, NULL, 'PQ loop repeat containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(191691, NULL, 'G3DSA:2.130.10.10:FF:005412', NULL, NULL, 'Mitochondrial division protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(191692, NULL, 'G3DSA:2.60.40.10:FF:004703', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191693, NULL, 'G3DSA:3.40.50.300:FF:003905', NULL, NULL, 'ABC-2 type transport system ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(191694, NULL, 'G3DSA:2.130.10.10:FF:005316', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191695, NULL, 'G3DSA:1.20.58.150:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191696, NULL, 'G3DSA:3.40.30.10:FF:000699', NULL, NULL, 'thioredoxin-like protein AAED1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(191697, NULL, 'G3DSA:3.40.50.300:FF:006727', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191698, NULL, 'G3DSA:2.170.300.10:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191699, NULL, 'G3DSA:1.10.1410.10:FF:000088', NULL, NULL, 'Poly(A) polymerase alpha', NULL, NULL, NULL, NULL, NULL, 4),
(191700, NULL, 'G3DSA:3.30.70.2000:FF:000005', NULL, NULL, 'Inso-1', NULL, NULL, NULL, NULL, NULL, 4),
(191701, NULL, 'G3DSA:1.10.720.30:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191702, NULL, 'G3DSA:2.60.200.10:FF:000002', NULL, NULL, 'Mothers against decapentaplegic homolog', NULL, NULL, NULL, NULL, NULL, 4),
(191703, NULL, 'G3DSA:1.20.1250.20:FF:001144', NULL, NULL, 'Drug resistance transporter, EmrB/QacA subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(191704, NULL, 'G3DSA:1.20.1740.10:FF:000234', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191705, NULL, 'G3DSA:1.25.10.10:FF:003133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191706, NULL, 'G3DSA:1.50.40.10:FF:000204', NULL, NULL, 'Peroxisomal nicotinamide adenine dinucleotide carrier', NULL, NULL, NULL, NULL, NULL, 4),
(191707, NULL, 'G3DSA:1.10.472.10:FF:000390', NULL, NULL, 'Cyclin B3', NULL, NULL, NULL, NULL, NULL, 4),
(191708, NULL, 'G3DSA:3.40.50.300:FF:007216', NULL, NULL, 'Uncharacterized protein C2F7.09c', NULL, NULL, NULL, NULL, NULL, 4),
(191709, NULL, 'G3DSA:3.40.50.720:FF:001789', NULL, NULL, 'Siroheme synthase', NULL, NULL, NULL, NULL, NULL, 4),
(191710, NULL, 'G3DSA:1.20.120.1880:FF:000007', NULL, NULL, 'Similar to non-repetitive nucleoporin', NULL, NULL, NULL, NULL, NULL, 4),
(191711, NULL, 'G3DSA:3.40.50.360:FF:000118', NULL, NULL, 'Flavo-diiron protein FprA2', NULL, NULL, NULL, NULL, NULL, 4),
(191712, NULL, 'G3DSA:1.10.510.10:FF:001333', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(191713, NULL, 'G3DSA:1.20.120.310:FF:000013', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(191714, NULL, 'G3DSA:2.10.110.10:FF:000080', NULL, NULL, 'actin-binding LIM protein 1 isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(191715, NULL, 'G3DSA:3.40.50.300:FF:003405', NULL, NULL, 'RecBCD enzyme subunit RecD', NULL, NULL, NULL, NULL, NULL, 4),
(191716, NULL, 'G3DSA:2.180.10.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191717, NULL, 'G3DSA:2.30.30.190:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191718, NULL, 'G3DSA:3.30.60.90:FF:000034', NULL, NULL, 'Transcriptional adapter 2-alpha', NULL, NULL, NULL, NULL, NULL, 4),
(191719, NULL, 'G3DSA:2.60.120.200:FF:000712', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191720, NULL, 'G3DSA:1.20.120.790:FF:000022', NULL, NULL, 'Putative heat shock protein HSP 90-beta 2', NULL, NULL, NULL, NULL, NULL, 4),
(191721, NULL, 'G3DSA:3.40.50.2300:FF:000082', NULL, NULL, 'ABC transporter periplasmic-binding protein ytfQ', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(191722, NULL, 'G3DSA:1.50.10.130:FF:000002', NULL, NULL, 'Ent-copalyl diphosphate synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(191723, NULL, 'G3DSA:3.30.70.330:FF:001184', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(191724, NULL, 'G3DSA:3.40.50.1580:FF:000045', NULL, NULL, '5''-methylthioadenosine/S-adenosylhomocysteine nucleosidase', NULL, NULL, NULL, NULL, NULL, 4),
(191725, NULL, 'G3DSA:3.30.830.10:FF:000069', NULL, NULL, 'A-factor processing enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(191726, NULL, 'G3DSA:2.10.25.10:FF:001051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191727, NULL, 'G3DSA:3.40.50.620:FF:000106', NULL, NULL, 'Glutamine-dependent NAD(+) synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(191728, NULL, 'G3DSA:3.40.50.410:FF:000336', NULL, NULL, 'Fibronectin binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(191729, NULL, 'G3DSA:3.40.50.1400:FF:000031', NULL, NULL, 'Sirohydrochlorin cobaltochelatase CbiKP', NULL, NULL, NULL, NULL, NULL, 4),
(191730, NULL, 'G3DSA:1.10.510.10:FF:003519', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191731, NULL, 'G3DSA:1.20.120.330:FF:000019', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(191732, NULL, 'G3DSA:3.40.50.410:FF:000280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191733, NULL, 'G3DSA:3.30.60.30:FF:000123', NULL, NULL, 'GM10857', NULL, NULL, NULL, NULL, NULL, 4),
(191734, NULL, 'G3DSA:3.30.450.20:FF:000088', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(191735, NULL, 'G3DSA:3.30.497.10:FF:000182', NULL, NULL, 'Serpin-Z1', NULL, NULL, NULL, NULL, NULL, 4),
(191736, NULL, 'G3DSA:3.40.50.1110:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191737, NULL, 'G3DSA:3.30.70.980:FF:000018', NULL, NULL, 'DUF28 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(191738, NULL, 'G3DSA:1.20.58.390:FF:000116', NULL, NULL, 'Gamma-aminobutyric acid type A receptor beta2 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(191739, NULL, 'G3DSA:1.25.40.570:FF:000009', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(191740, NULL, 'G3DSA:2.40.50.90:FF:000193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191741, NULL, 'G3DSA:6.10.140.2220:FF:000010', NULL, NULL, 'Ankyrin repeat and MYND domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(191742, NULL, 'G3DSA:2.40.50.140:FF:000039', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(191743, NULL, 'G3DSA:3.40.225.10:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191744, NULL, 'G3DSA:3.40.140.10:FF:000104', NULL, NULL, 'Nuclear protein localization, putative', NULL, NULL, NULL, NULL, NULL, 4),
(191745, NULL, 'G3DSA:2.130.10.10:FF:003967', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191746, NULL, 'G3DSA:1.10.240.10:FF:000008', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(191747, NULL, 'G3DSA:3.30.40.10:FF:001690', NULL, NULL, 'Regulator Ustilago maydis 1 protein (Rum1)', NULL, NULL, NULL, NULL, NULL, 4),
(191748, NULL, 'G3DSA:1.20.1560.10:FF:000580', NULL, NULL, 'ABC transporter NFT1', NULL, NULL, NULL, NULL, NULL, 4),
(191749, NULL, 'G3DSA:1.20.1070.10:FF:000621', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191750, NULL, 'G3DSA:1.10.510.10:FF:003481', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191751, NULL, 'G3DSA:1.20.5.110:FF:000134', NULL, NULL, 'Sporulation-specific protein 20', NULL, NULL, NULL, NULL, NULL, 4),
(191752, NULL, 'G3DSA:3.80.10.10:FF:000820', NULL, NULL, 'slit homolog 2 protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(191753, NULL, 'G3DSA:2.60.40.640:FF:000104', NULL, NULL, 'Protein ttm-2', NULL, NULL, NULL, NULL, NULL, 4),
(191754, NULL, 'G3DSA:2.60.40.1180:FF:000213', NULL, NULL, 'Maltase-glucoamylase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(191755, NULL, 'G3DSA:3.40.50.150:FF:000741', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(191756, NULL, 'G3DSA:1.25.40.20:FF:001726', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191757, NULL, 'G3DSA:1.10.510.10:FF:004470', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191758, NULL, 'G3DSA:1.10.10.10:FF:002093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191759, NULL, 'G3DSA:3.90.650.10:FF:000008', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(191760, NULL, 'G3DSA:4.10.60.10:FF:000172', NULL, NULL, 'Zf-CCHC type zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(191761, NULL, 'G3DSA:2.60.40.10:FF:005552', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191762, NULL, 'G3DSA:3.40.50.300:FF:006486', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191763, NULL, 'G3DSA:1.20.1530.20:FF:000058', NULL, NULL, 'Na(+)/H(+) antiporter', NULL, NULL, NULL, NULL, NULL, 4),
(191764, NULL, 'G3DSA:4.10.800.20:FF:000009', NULL, NULL, 'AMP deaminase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(191765, NULL, 'G3DSA:1.25.40.20:FF:001086', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(191766, NULL, 'G3DSA:2.10.110.10:FF:000118', NULL, NULL, 'protein-methionine sulfoxide oxidase Mical isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(191767, NULL, 'G3DSA:2.40.160.210:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191768, NULL, 'G3DSA:1.20.120.1750:FF:000047', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(191769, NULL, 'G3DSA:3.40.50.620:FF:000157', NULL, NULL, 'Electron transfer flavoprotein subunit alpha, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(191770, NULL, 'G3DSA:3.30.70.330:FF:002173', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191771, NULL, 'G3DSA:3.30.160.60:FF:005029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191772, NULL, 'G3DSA:1.25.70.10:FF:000028', NULL, NULL, 'Os04g0637500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(191773, NULL, 'G3DSA:3.40.720.10:FF:000250', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191774, NULL, 'G3DSA:1.10.8.10:FF:000332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191775, NULL, 'G3DSA:1.10.150.240:FF:000091', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(191776, NULL, 'G3DSA:3.30.160.60:FF:000937', NULL, NULL, 'PR domain zinc finger protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(191777, NULL, 'G3DSA:3.30.1490.80:FF:000006', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(191778, NULL, 'G3DSA:3.90.190.10:FF:000080', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase mu', NULL, NULL, NULL, NULL, NULL, 4),
(191779, NULL, 'G3DSA:1.20.58.1970:FF:000010', NULL, NULL, 'Conserved oligomeric Golgi complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(191780, NULL, 'G3DSA:3.40.50.11350:FF:000002', NULL, NULL, 'GDP-fucose protein O-fucosyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(191781, NULL, 'G3DSA:2.40.10.10:FF:000099', NULL, NULL, 'Kallikrein related-peptidase 10', NULL, NULL, NULL, NULL, NULL, 4),
(191782, NULL, 'G3DSA:1.10.730.10:FF:000068', NULL, NULL, 'Methionyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(191783, NULL, 'G3DSA:1.20.1070.10:FF:001610', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191784, NULL, 'G3DSA:3.40.350.10:FF:000081', NULL, NULL, 'Os11g0539800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(191785, NULL, 'G3DSA:3.40.640.10:FF:000148', NULL, NULL, 'Arginine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(191786, NULL, 'G3DSA:2.60.260.20:FF:000099', NULL, NULL, 'Chaperone protein DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(191787, NULL, 'G3DSA:1.10.1040.10:FF:000099', NULL, NULL, 'Ketol-acid reductoisomerase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(191788, NULL, 'G3DSA:3.20.20.140:FF:000169', NULL, NULL, 'Histidinol-phosphatase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(191789, NULL, 'G3DSA:3.80.10.10:FF:000432', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(191790, NULL, 'G3DSA:3.40.640.10:FF:000480', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191791, NULL, 'G3DSA:3.40.710.10:FF:000064', NULL, NULL, 'Penicillin-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(191792, NULL, 'G3DSA:3.40.50.720:FF:001738', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(191793, NULL, 'G3DSA:1.25.40.10:FF:001780', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g30825, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(191794, NULL, 'G3DSA:3.40.50.300:FF:002888', NULL, NULL, 'ras-related protein RABH1e isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(191795, NULL, 'G3DSA:2.130.10.10:FF:002539', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(191796, NULL, 'G3DSA:3.90.25.10:FF:000084', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(191797, NULL, 'G3DSA:1.20.140.100:FF:000016', NULL, NULL, 'Ciliary dynein heavy chain 11', NULL, NULL, NULL, NULL, NULL, 4),
(191798, NULL, 'G3DSA:3.40.50.720:FF:001890', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(191799, NULL, 'G3DSA:1.20.900.10:FF:000023', NULL, NULL, 'dynamin-binding protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(191800, NULL, 'G3DSA:3.20.20.80:FF:000428', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191801, NULL, 'G3DSA:3.30.930.10:FF:000341', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191802, NULL, 'G3DSA:3.30.70.330:FF:002914', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191803, NULL, 'G3DSA:3.40.630.30:FF:000069', NULL, NULL, 'GNAT family acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(191804, NULL, 'G3DSA:3.50.80.10:FF:000005', NULL, NULL, 'D-aminoacyl-tRNA deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(191805, NULL, 'G3DSA:2.130.10.10:FF:004687', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191806, NULL, 'G3DSA:1.25.40.10:FF:003814', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191807, NULL, 'G3DSA:3.30.420.40:FF:000761', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191808, NULL, 'G3DSA:3.30.710.10:FF:000297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191809, NULL, 'G3DSA:1.10.3370.10:FF:000051', NULL, NULL, 'Uncharacterized protein C19G7.17', NULL, NULL, NULL, NULL, NULL, 4),
(191810, NULL, 'G3DSA:3.20.20.100:FF:000005', NULL, NULL, 'NADP(H)-dependent aldo-keto reductase', NULL, NULL, NULL, NULL, NULL, 4),
(191811, NULL, 'G3DSA:2.130.10.10:FF:005524', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191812, NULL, 'G3DSA:3.40.1090.10:FF:000150', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191813, NULL, 'G3DSA:3.30.1330.40:FF:000040', NULL, NULL, 'Diphthine--ammonia ligase', NULL, NULL, NULL, NULL, NULL, 4),
(191814, NULL, 'G3DSA:2.40.160.50:FF:000037', NULL, NULL, 'Sorting and assembly machinery component 50 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(191815, NULL, 'G3DSA:3.40.50.12710:FF:000005', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7', NULL, NULL, NULL, NULL, NULL, 4),
(191816, NULL, 'G3DSA:2.130.10.10:FF:005204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191817, NULL, 'G3DSA:2.30.29.30:FF:000727', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191818, NULL, 'G3DSA:1.25.40.10:FF:000088', NULL, NULL, 'Clustered mitochondria (CluA/CLU1) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(191819, NULL, 'G3DSA:2.80.10.50:FF:000143', NULL, NULL, 'Pierisin', NULL, NULL, NULL, NULL, NULL, 4),
(191820, NULL, 'G3DSA:3.10.20.90:FF:000038', NULL, NULL, 'Rap guanine nucleotide exchange factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(191821, NULL, 'G3DSA:3.40.50.300:FF:001264', NULL, NULL, 'Formate--tetrahydrofolate ligase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(191822, NULL, 'G3DSA:1.25.40.10:FF:000476', NULL, NULL, 'Bud site selection protein', NULL, NULL, NULL, NULL, NULL, 4),
(191823, NULL, 'G3DSA:3.30.700.20:FF:000001', NULL, NULL, 'AMME syndrome candidate gene 1', NULL, NULL, NULL, NULL, NULL, 4),
(191824, NULL, 'G3DSA:1.10.530.10:FF:000087', NULL, NULL, 'Alpha lactabumin', NULL, NULL, NULL, NULL, NULL, 4),
(191825, NULL, 'G3DSA:3.30.40.10:FF:002139', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(191826, NULL, 'G3DSA:1.10.418.10:FF:000101', NULL, NULL, 'Transgelin', NULL, NULL, NULL, NULL, NULL, 4),
(191827, NULL, 'G3DSA:3.30.420.10:FF:000550', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191828, NULL, 'G3DSA:2.130.10.10:FF:003490', NULL, NULL, 'Putative neurobeachin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(191829, NULL, 'G3DSA:2.60.220.50:FF:000150', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191830, NULL, 'G3DSA:3.30.70.960:FF:000012', NULL, NULL, 'MUC16 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(191831, NULL, 'G3DSA:3.20.70.20:FF:000020', NULL, NULL, 'Choline trimethylamine-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(191832, NULL, 'G3DSA:3.30.200.20:FF:001789', NULL, NULL, 'Myosin heavy chain kinase B', NULL, NULL, NULL, NULL, NULL, 4),
(191833, NULL, 'G3DSA:3.40.50.2300:FF:001548', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191834, NULL, 'G3DSA:3.30.70.100:FF:000160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191835, NULL, 'G3DSA:3.40.850.10:FF:000074', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(191836, NULL, 'G3DSA:3.40.50.300:FF:004069', NULL, NULL, 'GM13326', NULL, NULL, NULL, NULL, NULL, 4),
(191837, NULL, 'G3DSA:2.40.50.140:FF:000270', NULL, NULL, 'Conserved membrane protein of uncharacterized function', NULL, NULL, NULL, NULL, NULL, 4),
(191838, NULL, 'G3DSA:3.40.50.2300:FF:001020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191839, NULL, 'G3DSA:2.130.10.10:FF:003338', NULL, NULL, 'Myosin heavy chain kinase B', NULL, NULL, NULL, NULL, NULL, 4),
(191840, NULL, 'G3DSA:1.20.1250.20:FF:000076', NULL, NULL, 'Nucleoside transporter YegT', NULL, NULL, NULL, NULL, NULL, 4),
(191841, NULL, 'G3DSA:1.10.630.10:FF:000151', NULL, NULL, 'Cytochrome P450-like', NULL, NULL, NULL, NULL, NULL, 4),
(191842, NULL, 'G3DSA:3.40.1500.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191843, NULL, 'G3DSA:1.10.472.140:FF:000004', NULL, NULL, 'RB transcriptional corepressor like 2', NULL, NULL, NULL, NULL, NULL, 4),
(191844, NULL, 'G3DSA:3.40.50.2000:FF:000935', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191845, NULL, 'G3DSA:3.30.40.10:FF:000846', NULL, NULL, 'Ring-box protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(191846, NULL, 'G3DSA:1.10.150.50:FF:000002', NULL, NULL, 'PTPRF interacting protein alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(191847, NULL, 'G3DSA:3.30.70.120:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191848, NULL, 'G3DSA:1.25.40.10:FF:005259', NULL, NULL, 'Chaperone protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(191849, NULL, 'G3DSA:3.40.50.1000:FF:000568', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191850, NULL, 'G3DSA:1.20.1070.10:FF:002066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191851, NULL, 'G3DSA:3.30.200.20:FF:001677', NULL, NULL, 'Cell division control protein 2-like 2 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(191852, NULL, 'G3DSA:3.30.160.60:FF:006457', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191853, NULL, 'G3DSA:1.10.472.80:FF:000011', NULL, NULL, 'TBC1 domain family member 30', NULL, NULL, NULL, NULL, NULL, 4),
(191854, NULL, 'G3DSA:2.60.40.10:FF:004771', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191855, NULL, 'G3DSA:3.20.20.370:FF:000013', NULL, NULL, 'Carbohydrate degradation protein', NULL, NULL, NULL, NULL, NULL, 4),
(191856, NULL, 'G3DSA:4.10.520.10:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(191857, NULL, 'G3DSA:3.10.105.10:FF:000120', NULL, NULL, 'Maltose ABC transporter, maltose binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(191858, NULL, 'G3DSA:1.25.40.10:FF:004803', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g13270, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(191859, NULL, 'G3DSA:2.60.40.10:FF:001005', NULL, NULL, 'Beta-2-microglobulin', NULL, NULL, NULL, NULL, NULL, 4),
(191860, NULL, 'G3DSA:3.30.450.20:FF:000431', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191861, NULL, 'G3DSA:1.20.120.850:FF:000001', NULL, NULL, 'transcriptional regulator ATRX isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(191862, NULL, 'G3DSA:1.10.238.10:FF:000896', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191863, NULL, 'G3DSA:2.60.40.3620:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191864, NULL, 'G3DSA:1.10.287.110:FF:000388', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191865, NULL, 'G3DSA:2.60.120.780:FF:000009', NULL, NULL, 'Protein inhibitor of activated STAT', NULL, NULL, NULL, NULL, NULL, 4),
(191866, NULL, 'G3DSA:3.40.30.10:FF:001155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191867, NULL, 'G3DSA:3.10.20.90:FF:000370', NULL, NULL, 'Autophagy protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(191868, NULL, 'G3DSA:3.20.20.70:FF:000594', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191869, NULL, 'G3DSA:3.40.20.10:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191870, NULL, 'G3DSA:1.25.40.10:FF:003966', NULL, NULL, 'Os01g0686600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(191871, NULL, 'G3DSA:3.30.56.30:FF:000012', NULL, NULL, 'Signal recognition particle 19 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(191872, NULL, 'G3DSA:2.60.40.150:FF:000396', NULL, NULL, 'SYTF', NULL, NULL, NULL, NULL, NULL, 4),
(191873, NULL, 'G3DSA:1.20.870.10:FF:000020', NULL, NULL, 'Cell division control protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(191874, NULL, 'G3DSA:1.10.150.670:FF:000034', NULL, NULL, 'Crossover junction endonuclease mus81', NULL, NULL, NULL, NULL, NULL, 4),
(191875, NULL, 'G3DSA:3.30.460.10:FF:000024', NULL, NULL, 'Nucleotidyltransferase family protein isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(191876, NULL, 'G3DSA:2.40.70.10:FF:000428', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191877, NULL, 'G3DSA:3.30.160.60:FF:004248', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191878, NULL, 'G3DSA:1.10.238.20:FF:000017', NULL, NULL, 'Odorant-binding protein 59a', NULL, NULL, NULL, NULL, NULL, 4),
(191879, NULL, 'G3DSA:3.50.50.60:FF:000771', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191880, NULL, 'G3DSA:2.10.25.10:FF:000275', NULL, NULL, 'usherin', NULL, NULL, NULL, NULL, NULL, 4),
(191881, NULL, 'G3DSA:3.30.160.60:FF:006277', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191882, NULL, 'G3DSA:3.40.50.450:FF:000033', NULL, NULL, 'CRE-OLRN-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(191883, NULL, 'G3DSA:3.40.50.300:FF:006278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191884, NULL, 'G3DSA:1.10.437.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191885, NULL, 'G3DSA:1.25.40.90:FF:000073', NULL, NULL, 'I/LWEQ domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(191886, NULL, 'G3DSA:3.30.160.60:FF:003051', NULL, NULL, 'Molting defective, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(191887, NULL, 'G3DSA:3.80.10.10:FF:000612', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(191888, NULL, 'G3DSA:1.10.575.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191889, NULL, 'G3DSA:3.40.910.10:FF:000012', NULL, NULL, 'Probable deoxyhypusine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(191890, NULL, 'G3DSA:3.40.50.150:FF:001197', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(191891, NULL, 'G3DSA:1.10.630.10:FF:000712', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191892, NULL, 'G3DSA:1.10.8.60:FF:000190', NULL, NULL, 'DNA clamp loader, putative', NULL, NULL, NULL, NULL, NULL, 4),
(191893, NULL, 'G3DSA:3.40.50.300:FF:003052', NULL, NULL, 'Polynucleotide 5''-hydroxyl-kinase nol-9', NULL, NULL, NULL, NULL, NULL, 4),
(191894, NULL, 'G3DSA:3.10.350.10:FF:000065', NULL, NULL, 'LysM peptidoglycan-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(191895, NULL, 'G3DSA:1.20.1560.10:FF:000428', NULL, NULL, 'Multidrug resistance protein ABC transporter family', NULL, NULL, NULL, NULL, NULL, 4),
(191896, NULL, 'G3DSA:3.30.530.20:FF:000089', NULL, NULL, 'Protein CBG16522', NULL, NULL, NULL, NULL, NULL, 4),
(191897, NULL, 'G3DSA:1.10.8.60:FF:000038', NULL, NULL, 'spermatogenesis-associated protein 5-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(191898, NULL, 'G3DSA:2.10.25.10:FF:001635', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191899, NULL, 'G3DSA:1.50.40.10:FF:000176', NULL, NULL, 'TPC1p Mitochondrial membrane transporter', NULL, NULL, NULL, NULL, NULL, 4),
(191900, NULL, 'G3DSA:1.20.90.10:FF:000006', NULL, NULL, 'Otoconin-90', NULL, NULL, NULL, NULL, NULL, 4),
(191901, NULL, 'G3DSA:3.40.50.10090:FF:000028', NULL, NULL, 'Related to HEM4-Uroporphyrinogen III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(191902, NULL, 'G3DSA:2.30.30.140:FF:000167', NULL, NULL, 'MBD-R2', NULL, NULL, NULL, NULL, NULL, 4),
(191903, NULL, 'G3DSA:3.40.50.300:FF:005761', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191904, NULL, 'G3DSA:3.40.630.10:FF:000243', NULL, NULL, 'DNPEP isoform 10', NULL, NULL, NULL, NULL, NULL, 4),
(191905, NULL, 'G3DSA:3.40.50.720:FF:001558', NULL, NULL, 'Short chain dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(191906, NULL, 'G3DSA:1.25.10.10:FF:002626', NULL, NULL, 'Huntingtin', NULL, NULL, NULL, NULL, NULL, 4),
(191907, NULL, 'G3DSA:1.10.30.10:FF:000082', NULL, NULL, 'Mitochondrial transcription factor A, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(191908, NULL, 'G3DSA:3.40.30.10:FF:000727', NULL, NULL, 'Iodothyronine deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(191909, NULL, 'G3DSA:2.30.30.380:FF:000059', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(191910, NULL, 'G3DSA:2.60.40.650:FF:000012', NULL, NULL, 'Sulfite oxidase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(191911, NULL, 'G3DSA:2.60.210.10:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191912, NULL, 'G3DSA:2.70.170.10:FF:000159', NULL, NULL, 'Transmembrane ion channel', NULL, NULL, NULL, NULL, NULL, 4),
(191913, NULL, 'G3DSA:3.90.1150.10:FF:000014', NULL, NULL, 'Probable glycine dehydrogenase (decarboxylating) subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(191914, NULL, 'G3DSA:1.20.58.60:FF:000227', NULL, NULL, 'Karst, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(191915, NULL, 'G3DSA:2.40.10.10:FF:000442', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191916, NULL, 'G3DSA:1.20.1250.20:FF:001436', NULL, NULL, 'Similar to Na+ dependent glucose transporter 1 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(191917, NULL, 'G3DSA:2.60.40.790:FF:000121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191918, NULL, 'G3DSA:3.30.1240.10:FF:000046', NULL, NULL, 'Cof-type HAD-IIB family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(191919, NULL, 'G3DSA:1.25.40.10:FF:003702', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g64320, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(191920, NULL, 'G3DSA:1.10.510.10:FF:002682', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191921, NULL, 'G3DSA:2.30.30.100:FF:000003', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm5', NULL, NULL, NULL, NULL, NULL, 4),
(191922, NULL, 'G3DSA:1.25.10.10:FF:000592', NULL, NULL, 'Coatomer subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(191923, NULL, 'G3DSA:3.40.50.300:FF:003613', NULL, NULL, 'Hypothetical ABC transporter ATP-binding protein ybiT', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(191924, NULL, 'G3DSA:3.40.50.300:FF:005822', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(191925, NULL, 'G3DSA:3.40.50.150:FF:001073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191926, NULL, 'G3DSA:3.30.70.330:FF:001925', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191927, NULL, 'G3DSA:1.25.10.10:FF:001952', NULL, NULL, 'WD domain, G-beta repeat/PFU (PLAA family ubiquitin binding), putative', NULL, NULL, NULL, NULL, NULL, 4),
(191928, NULL, 'G3DSA:1.20.120.350:FF:000177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191929, NULL, 'G3DSA:1.25.10.10:FF:001216', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(191930, NULL, 'G3DSA:3.50.50.60:FF:000619', NULL, NULL, 'FAD/NAD(P)-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(191931, NULL, 'G3DSA:2.60.120.200:FF:000504', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(191932, NULL, 'G3DSA:2.60.40.10:FF:001269', NULL, NULL, 'Sallimus, isoform P', NULL, NULL, NULL, NULL, NULL, 4),
(191933, NULL, 'G3DSA:1.10.510.10:FF:000996', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(191934, NULL, 'G3DSA:1.10.287.110:FF:000449', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191935, NULL, 'G3DSA:4.10.60.10:FF:000228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191936, NULL, 'G3DSA:3.90.1640.10:FF:000001', NULL, NULL, 'Probable manganese-dependent inorganic pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(191937, NULL, 'G3DSA:1.10.8.100:FF:000010', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(191938, NULL, 'G3DSA:1.10.630.10:FF:000471', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(191939, NULL, 'G3DSA:1.10.132.50:FF:000005', NULL, NULL, 'V-type proton ATPase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(191940, NULL, 'G3DSA:3.40.50.11500:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191941, NULL, 'G3DSA:3.30.230.80:FF:000016', NULL, NULL, 'Heat shock protein 92', NULL, NULL, NULL, NULL, NULL, 4),
(191942, NULL, 'G3DSA:3.30.200.20:FF:002397', NULL, NULL, 'Phosphoacetylglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(191943, NULL, 'G3DSA:3.30.2040.10:FF:000003', NULL, NULL, 'D-glutamate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(191944, NULL, 'G3DSA:2.40.100.10:FF:000100', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(191945, NULL, 'G3DSA:2.60.120.200:FF:000780', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(191946, NULL, 'G3DSA:2.60.120.920:FF:000074', NULL, NULL, 'Neuralized protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(191947, NULL, 'G3DSA:3.30.70.1730:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191948, NULL, 'G3DSA:1.10.8.10:FF:000271', NULL, NULL, 'YALI0B12408p', NULL, NULL, NULL, NULL, NULL, 4),
(191949, NULL, 'G3DSA:2.40.50.140:FF:000118', NULL, NULL, 'NfeD family protein', NULL, NULL, NULL, NULL, NULL, 4),
(191950, NULL, 'G3DSA:1.20.930.10:FF:000019', NULL, NULL, 'mediator of RNA polymerase II transcription subunit 26 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(191951, NULL, 'G3DSA:3.40.50.300:FF:003529', NULL, NULL, 'NLR family member X1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(191952, NULL, 'G3DSA:1.10.10.1830:FF:000004', NULL, NULL, 'Non-ribosomal peptide synthetase OfaC', NULL, NULL, NULL, NULL, NULL, 4),
(191953, NULL, 'G3DSA:2.60.40.10:FF:001505', NULL, NULL, 'Titin novex-3', NULL, NULL, NULL, NULL, NULL, 4),
(191954, NULL, 'G3DSA:1.10.10.60:FF:000522', NULL, NULL, 'HTH-type transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(191955, NULL, 'G3DSA:1.10.510.10:FF:001513', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(191956, NULL, 'G3DSA:1.10.10.60:FF:000281', NULL, NULL, 'DNA-3-methyladenine glycosylase 2', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(191957, NULL, 'G3DSA:1.25.40.20:FF:001906', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191958, NULL, 'G3DSA:2.120.10.30:FF:000500', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191959, NULL, 'G3DSA:1.25.10.10:FF:002273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191960, NULL, 'G3DSA:1.20.1050.120:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191961, NULL, 'G3DSA:2.30.30.1150:FF:000003', NULL, NULL, 'PHD transcription factor Rum1', NULL, NULL, NULL, NULL, NULL, 4),
(191962, NULL, 'G3DSA:3.90.550.10:FF:000416', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(191963, NULL, 'G3DSA:3.30.160.60:FF:005260', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191964, NULL, 'G3DSA:2.10.50.10:FF:000075', NULL, NULL, 'Neurotrophin receptor associated death domain', NULL, NULL, NULL, NULL, NULL, 4),
(191965, NULL, 'G3DSA:2.40.50.140:FF:000793', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191966, NULL, 'G3DSA:1.20.1070.10:FF:001346', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(191967, NULL, 'G3DSA:1.25.40.470:FF:000036', NULL, NULL, 'Elongator complex protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(191968, NULL, 'G3DSA:1.25.40.10:FF:003461', NULL, NULL, 'Os11g0587100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(191969, NULL, 'G3DSA:3.30.160.60:FF:004984', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191970, NULL, 'G3DSA:4.10.280.110:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191971, NULL, 'G3DSA:3.30.420.510:FF:000019', NULL, NULL, 'Fumble, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(191972, NULL, 'G3DSA:1.20.58.390:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191973, NULL, 'G3DSA:3.40.50.1820:FF:001331', NULL, NULL, 'AB hydrolase superfamily protein C4A8.06c', NULL, NULL, NULL, NULL, NULL, 4),
(191974, NULL, 'G3DSA:3.40.50.800:FF:000003', NULL, NULL, 'Threonine--tRNA ligase 2, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(191975, NULL, 'G3DSA:2.130.10.10:FF:001814', NULL, NULL, 'LLGL1, scribble cell polarity complex component', NULL, NULL, NULL, NULL, NULL, 4),
(191976, NULL, 'G3DSA:3.40.50.410:FF:000212', NULL, NULL, 'Putative KU70 protein', NULL, NULL, NULL, NULL, NULL, 4),
(191977, NULL, 'G3DSA:2.40.50.90:FF:000081', NULL, NULL, 'Staphylococcal_nuclease_homologue /Tudor_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(191978, NULL, 'G3DSA:3.40.50.1820:FF:000038', NULL, NULL, '2-succinyl-6-hydroxy-2,4-cyclohexadiene-1-carboxylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(191979, NULL, 'G3DSA:1.25.40.10:FF:001549', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g21470', NULL, NULL, NULL, NULL, NULL, 4),
(191980, NULL, 'G3DSA:3.30.428.10:FF:000039', NULL, NULL, 'DUF4931 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(191981, NULL, 'G3DSA:3.30.1680.10:FF:000017', NULL, NULL, 'Semaphorin 7A', NULL, NULL, NULL, NULL, NULL, 4),
(191982, NULL, 'G3DSA:1.25.70.10:FF:000096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191983, NULL, 'G3DSA:2.130.10.10:FF:000853', NULL, NULL, 'WD repeat-containing protein RUP2', NULL, NULL, NULL, NULL, NULL, 4),
(191984, NULL, 'G3DSA:3.40.50.300:FF:000590', NULL, NULL, 'Ribosome biogenesis GTPase A', NULL, NULL, NULL, NULL, NULL, 4),
(191985, NULL, 'G3DSA:1.10.510.10:FF:000496', NULL, NULL, 'Calcium/calmodulin-regulated receptor-like kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(191986, NULL, 'G3DSA:3.40.50.150:FF:001281', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191987, NULL, 'G3DSA:1.20.1050.10:FF:000086', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(191988, NULL, 'G3DSA:3.40.1110.10:FF:000208', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(191989, NULL, 'G3DSA:2.10.50.30:FF:000002', NULL, NULL, 'Vomeronasal 2 receptor, h1', NULL, NULL, NULL, NULL, NULL, 4),
(191990, NULL, 'G3DSA:1.20.1730.10:FF:000065', NULL, NULL, 'Similar to solute carrier family 5 (Sodium/glucose cotransporter), member 1', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(191991, NULL, 'G3DSA:3.40.50.1820:FF:000426', NULL, NULL, 'PS-10 peptidase S37', NULL, NULL, NULL, NULL, NULL, 4),
(191992, NULL, 'G3DSA:3.40.50.2300:FF:000643', NULL, NULL, 'Response regulator receiver domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(191993, NULL, 'G3DSA:3.30.870.10:FF:000066', NULL, NULL, 'Tyrosyl-DNA phosphodiesterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(191994, NULL, 'G3DSA:1.10.287.130:FF:000214', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(191995, NULL, 'G3DSA:2.60.40.10:FF:002354', NULL, NULL, 'Protein-tyrosine-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(191996, NULL, 'G3DSA:1.10.287.310:FF:000004', NULL, NULL, '50S ribosomal protein L29, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(191997, NULL, 'G3DSA:2.30.42.10:FF:000634', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(191998, NULL, 'G3DSA:1.10.150.240:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(191999, NULL, 'G3DSA:2.130.10.10:FF:000533', NULL, NULL, 'Receptor for activated C kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(192000, NULL, 'G3DSA:2.102.10.10:FF:000012', NULL, NULL, '3-ketosteroid-9-alpha-hydroxylase oxygenase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(192001, NULL, 'G3DSA:1.10.287.70:FF:000426', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192002, NULL, 'G3DSA:3.10.200.10:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192003, NULL, 'G3DSA:3.30.230.70:FF:000070', NULL, NULL, 'Exosome-associated protein 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(192004, NULL, 'G3DSA:3.30.310.80:FF:000017', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(192005, NULL, 'G3DSA:3.20.20.100:FF:000073', NULL, NULL, 'Prostaglandin f synthase. putative', NULL, NULL, NULL, NULL, NULL, 4),
(192006, NULL, 'G3DSA:3.40.309.10:FF:000070', NULL, NULL, '2-aminomuconic acid semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(192007, NULL, 'G3DSA:1.20.144.10:FF:000075', NULL, NULL, 'Putative integral membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(192008, NULL, 'G3DSA:2.10.25.10:FF:000511', NULL, NULL, 'protein crumbs isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(192009, NULL, 'G3DSA:1.20.58.60:FF:000435', NULL, NULL, 'AGAP009554-PA', NULL, NULL, NULL, NULL, NULL, 4),
(192010, NULL, 'G3DSA:3.90.1150.10:FF:000357', NULL, NULL, 'DegT/DnrJ/EryC1/StrS family aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(192011, NULL, 'G3DSA:3.40.50.720:FF:000541', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(192012, NULL, 'G3DSA:1.10.238.10:FF:000003', NULL, NULL, 'Calmodulin A', NULL, NULL, NULL, NULL, NULL, 4),
(192013, NULL, 'G3DSA:3.40.50.1470:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192014, NULL, 'G3DSA:1.10.10.10:FF:000468', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(192015, NULL, 'G3DSA:1.10.238.10:FF:000632', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192016, NULL, 'G3DSA:1.10.400.10:FF:000083', NULL, NULL, 'Guanine nucleotide-binding protein (G protein), alpha 15 (Gq class), tandem duplicate 3', NULL, NULL, NULL, NULL, NULL, 4),
(192017, NULL, 'G3DSA:2.40.420.20:FF:000032', NULL, NULL, 'Putative periplasmic linker protein', NULL, NULL, NULL, NULL, NULL, 4),
(192018, NULL, 'G3DSA:2.40.70.10:FF:000507', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192019, NULL, 'G3DSA:3.40.50.300:FF:006839', NULL, NULL, 'Gll3884 protein', NULL, NULL, NULL, NULL, NULL, 4),
(192020, NULL, 'G3DSA:3.40.630.70:FF:000002', NULL, NULL, 'Leu/Phe-tRNA protein transferase', NULL, NULL, NULL, NULL, NULL, 4),
(192021, NULL, 'G3DSA:2.60.40.150:FF:000749', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(192022, NULL, 'G3DSA:2.30.29.30:FF:000204', NULL, NULL, 'kinesin-like protein unc-104 isoform X6', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(192023, NULL, 'G3DSA:3.30.497.10:FF:000114', NULL, NULL, 'Angiotensinogen', NULL, NULL, NULL, NULL, NULL, 4),
(192024, NULL, 'G3DSA:3.80.10.10:FF:002057', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3', NULL, NULL, NULL, NULL, NULL, 4),
(192025, NULL, 'G3DSA:3.40.50.1820:FF:001595', NULL, NULL, 'Uncharacterized esterase/lipase C417.12', NULL, NULL, NULL, NULL, NULL, 4),
(192026, NULL, 'G3DSA:1.10.510.10:FF:002053', NULL, NULL, 'STE20-related kinase adapter protein strd-1', NULL, NULL, NULL, NULL, NULL, 4),
(192027, NULL, 'G3DSA:3.30.160.60:FF:001718', NULL, NULL, 'Zinc finger and SCAN domain containing 5A', NULL, NULL, NULL, NULL, NULL, 4),
(192028, NULL, 'G3DSA:2.60.40.10:FF:002697', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(192029, NULL, 'G3DSA:1.20.1560.10:FF:000349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192030, NULL, 'G3DSA:1.10.1050.10:FF:000004', NULL, NULL, '30S ribosomal protein S4', NULL, NULL, NULL, NULL, NULL, 4),
(192031, NULL, 'G3DSA:3.90.550.50:FF:000237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192032, NULL, 'G3DSA:3.40.50.80:FF:000007', NULL, NULL, 'Respiratory burst oxidase protein A', NULL, NULL, NULL, NULL, NULL, 4),
(192033, NULL, 'G3DSA:1.10.3730.20:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192034, NULL, 'G3DSA:1.25.40.10:FF:000829', NULL, NULL, 'Bardet-Biedl syndrome 4 protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(192035, NULL, 'G3DSA:1.10.3860.10:FF:000015', NULL, NULL, 'Dicarboxylate/amino acid:cation symporter', NULL, NULL, NULL, NULL, NULL, 4),
(192036, NULL, 'G3DSA:2.60.40.10:FF:002915', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192037, NULL, 'G3DSA:3.80.10.10:FF:001337', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(192038, NULL, 'G3DSA:3.10.129.10:FF:000129', NULL, NULL, 'PaaI family thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(192039, NULL, 'G3DSA:3.40.80.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192040, NULL, 'G3DSA:3.30.160.60:FF:005108', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192041, NULL, 'G3DSA:3.30.40.10:FF:001302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192042, NULL, 'G3DSA:3.30.830.10:FF:000277', NULL, NULL, 'AGR251Cp', NULL, NULL, NULL, NULL, NULL, 4),
(192043, NULL, 'G3DSA:3.30.160.150:FF:000003', NULL, NULL, 'LPS-assembly lipoprotein LptE', NULL, NULL, NULL, NULL, NULL, 4),
(192044, NULL, 'G3DSA:3.10.120.10:FF:000020', NULL, NULL, 'Cytochrome b5-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(192045, NULL, 'G3DSA:1.25.40.10:FF:005091', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g26540', NULL, NULL, NULL, NULL, NULL, 4),
(192046, NULL, 'G3DSA:3.20.20.80:FF:000187', NULL, NULL, 'Alpha-1,4-glucan:maltose-1-phosphate maltosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(192047, NULL, 'G3DSA:2.60.40.10:FF:003135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192048, NULL, 'G3DSA:3.40.50.300:FF:008352', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192049, NULL, 'G3DSA:3.30.342.10:FF:000031', NULL, NULL, 'Putative DNA polymerase zeta catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(192050, NULL, 'G3DSA:1.25.40.10:FF:001105', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(192051, NULL, 'G3DSA:2.10.80.10:FF:000015', NULL, NULL, 'dickkopf-related protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(192052, NULL, 'G3DSA:3.90.320.10:FF:000028', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(192053, NULL, 'G3DSA:1.20.1250.20:FF:000716', NULL, NULL, 'Unplaced genomic scaffold supercont1.182, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(192054, NULL, 'G3DSA:3.30.40.10:FF:001190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(192055, NULL, 'G3DSA:3.60.40.10:FF:000362', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192056, NULL, 'G3DSA:1.20.1070.10:FF:001689', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192057, NULL, 'G3DSA:3.30.450.20:FF:000352', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192058, NULL, 'G3DSA:3.30.450.40:FF:000178', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(192059, NULL, 'G3DSA:1.10.10.60:FF:001186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192060, NULL, 'G3DSA:3.30.930.10:FF:000280', NULL, NULL, 'Alanine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(192061, NULL, 'G3DSA:3.30.200.20:FF:000952', NULL, NULL, 'Putative DUF26-domain protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(192062, NULL, 'G3DSA:3.40.50.1820:FF:001674', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192063, NULL, 'G3DSA:2.40.30.170:FF:000005', NULL, NULL, 'UPF0194 membrane protein YbhG', NULL, NULL, NULL, NULL, NULL, 4),
(192064, NULL, 'G3DSA:3.30.300.20:FF:000044', NULL, NULL, 'Osmotically inducible protein C', NULL, NULL, NULL, NULL, NULL, 4),
(192065, NULL, 'G3DSA:2.10.90.10:FF:000173', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192066, NULL, 'G3DSA:3.40.50.2300:FF:000823', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192067, NULL, 'G3DSA:1.20.1630.10:FF:000001', NULL, NULL, 'Formate-dependent nitrite reductase subunit NrfD', NULL, NULL, NULL, NULL, NULL, 4),
(192068, NULL, 'G3DSA:2.60.120.260:FF:000415', NULL, NULL, 'Alpha-N-arabinofuranosidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(192069, NULL, 'G3DSA:3.30.710.10:FF:000358', NULL, NULL, 'Protein CBG25600', NULL, NULL, NULL, NULL, NULL, 4),
(192070, NULL, 'G3DSA:2.70.150.10:FF:000164', NULL, NULL, 'Heavy metal translocating P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(192071, NULL, 'G3DSA:3.30.70.330:FF:001689', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192072, NULL, 'G3DSA:2.130.10.10:FF:001197', NULL, NULL, 'WD repeat domain 60', NULL, NULL, NULL, NULL, NULL, 4),
(192073, NULL, 'G3DSA:3.30.160.60:FF:003231', NULL, NULL, 'GD20654', NULL, NULL, NULL, NULL, NULL, 4),
(192074, NULL, 'G3DSA:3.30.160.60:FF:000437', NULL, NULL, 'zinc finger and BTB domain-containing protein 38', NULL, NULL, NULL, NULL, NULL, 4),
(192075, NULL, 'G3DSA:2.60.40.1510:FF:000037', NULL, NULL, 'Integrin beta-7', NULL, NULL, NULL, NULL, NULL, 4),
(192076, NULL, 'G3DSA:3.40.1180.10:FF:000033', NULL, NULL, 'Isoprenyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(192077, NULL, 'G3DSA:3.20.20.300:FF:000032', NULL, NULL, 'uncharacterized protein LOC100182860 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(192078, NULL, 'G3DSA:3.80.10.10:FF:002618', NULL, NULL, 'Leucine-rich repeat and death domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(192079, NULL, 'G3DSA:2.60.40.10:FF:005159', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192080, NULL, 'G3DSA:3.90.1170.10:FF:000009', NULL, NULL, '50S ribosomal protein L16', NULL, NULL, NULL, NULL, NULL, 4),
(192081, NULL, 'G3DSA:1.25.40.10:FF:004871', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192082, NULL, 'G3DSA:2.20.25.20:FF:000019', NULL, NULL, 'E3 ubiquitin-protein ligase parkin', NULL, NULL, NULL, NULL, NULL, 4),
(192083, NULL, 'G3DSA:3.80.10.10:FF:004086', NULL, NULL, 'Probable serine/threonine-protein kinase roco11', NULL, NULL, NULL, NULL, NULL, 4),
(192084, NULL, 'G3DSA:3.40.50.720:FF:001946', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192085, NULL, 'G3DSA:1.25.40.20:FF:001165', NULL, NULL, 'Zygote-specific protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(192086, NULL, 'G3DSA:3.30.499.10:FF:000017', NULL, NULL, 'Aconitate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(192087, NULL, 'G3DSA:3.30.40.10:FF:000341', NULL, NULL, 'FYVE and coiled-coil domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(192088, NULL, 'G3DSA:1.20.1740.10:FF:000173', NULL, NULL, 'Amino acid transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(192089, NULL, 'G3DSA:1.20.1270.380:FF:000001', NULL, NULL, 'Macrodomain Ter protein', NULL, NULL, NULL, NULL, NULL, 4),
(192090, NULL, 'G3DSA:3.40.50.150:FF:001129', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192091, NULL, 'G3DSA:2.60.120.620:FF:000102', NULL, NULL, '2OG-Fe(II) oxygenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(192092, NULL, 'G3DSA:3.40.50.150:FF:001461', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192093, NULL, 'G3DSA:2.60.120.330:FF:000060', NULL, NULL, 'Os01g0830500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(192094, NULL, 'G3DSA:1.10.238.10:FF:000975', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192095, NULL, 'G3DSA:2.30.29.30:FF:001396', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192096, NULL, 'G3DSA:1.10.260.40:FF:000058', NULL, NULL, 'Multiprotein-bridging factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(192097, NULL, 'G3DSA:3.30.70.330:FF:002706', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192098, NULL, 'G3DSA:2.60.40.60:FF:000542', NULL, NULL, 'Cadherin 17, LI cadherin (liver-intestine)', NULL, NULL, NULL, NULL, NULL, 4),
(192099, NULL, 'G3DSA:1.25.40.20:FF:000889', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192100, NULL, 'G3DSA:3.10.450.50:FF:000017', NULL, NULL, 'UBP3-associated protein BRE5', NULL, NULL, NULL, NULL, NULL, 4),
(192101, NULL, 'G3DSA:2.60.40.10:FF:005491', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192102, NULL, 'G3DSA:2.60.40.10:FF:000488', NULL, NULL, 'receptor-type tyrosine-protein phosphatase O isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(192103, NULL, 'G3DSA:3.20.20.80:FF:000804', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192104, NULL, 'G3DSA:1.20.58.1880:FF:000016', NULL, NULL, 'Myb family transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(192105, NULL, 'G3DSA:1.10.10.60:FF:001062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192106, NULL, 'G3DSA:3.50.50.60:FF:000850', NULL, NULL, 'YALI0C14806p', NULL, NULL, NULL, NULL, NULL, 4),
(192107, NULL, 'G3DSA:2.130.10.10:FF:001073', NULL, NULL, 'Protein HIR', NULL, NULL, NULL, NULL, NULL, 4),
(192108, NULL, 'G3DSA:3.40.50.300:FF:003681', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(192109, NULL, 'G3DSA:2.10.25.10:FF:001556', NULL, NULL, 'Notch receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(192110, NULL, 'G3DSA:3.30.70.20:FF:000059', NULL, NULL, 'Respiratory nitrate reductase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(192111, NULL, 'G3DSA:3.90.1290.10:FF:000075', NULL, NULL, 'Si:ch211-157f15.1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(192112, NULL, 'G3DSA:1.25.40.10:FF:000268', NULL, NULL, 'Formate-dependent nitrite reductase complex subunit nrfG', NULL, NULL, NULL, NULL, NULL, 4),
(192113, NULL, 'G3DSA:3.40.850.10:FF:000462', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192114, NULL, 'G3DSA:3.40.50.300:FF:002388', NULL, NULL, 'Polyphosphate:NDP phosphotransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(192115, NULL, 'G3DSA:2.30.30.40:FF:000519', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192116, NULL, 'G3DSA:1.20.1050.10:FF:000266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192117, NULL, 'G3DSA:3.40.1190.20:FF:000216', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192118, NULL, 'G3DSA:3.40.50.1220:FF:000134', NULL, NULL, 'Thiamine diphosphate dependent-3-acetyloctanal synthase PigD', NULL, NULL, NULL, NULL, NULL, 4),
(192119, NULL, 'G3DSA:3.30.160.60:FF:001994', NULL, NULL, 'Tramtrack, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(192120, NULL, 'G3DSA:3.40.1280.10:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192121, NULL, 'G3DSA:1.10.287.570:FF:000003', NULL, NULL, 'Anion exchange family protein', NULL, NULL, NULL, NULL, NULL, 4),
(192122, NULL, 'G3DSA:3.40.50.261:FF:000039', NULL, NULL, 'Succinyl-CoA synthetase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(192123, NULL, 'G3DSA:3.90.1150.50:FF:000003', NULL, NULL, 'Transcription-repair-coupling factor', NULL, NULL, NULL, NULL, NULL, 4),
(192124, NULL, 'G3DSA:3.90.1200.10:FF:000070', NULL, NULL, 'RE24176p', NULL, NULL, NULL, NULL, NULL, 4),
(192125, NULL, 'G3DSA:3.30.40.10:FF:000402', NULL, NULL, 'TRAF-type zinc finger domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(192126, NULL, 'G3DSA:1.25.40.20:FF:000866', NULL, NULL, 'Transient receptor potential cation channel subfamily A member 1', NULL, NULL, NULL, NULL, NULL, 4),
(192127, NULL, 'G3DSA:1.25.40.20:FF:001434', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192128, NULL, 'G3DSA:3.10.450.240:FF:000011', NULL, NULL, 'Mitochondrial import inner membrane translocase subunit TIM44', NULL, NULL, NULL, NULL, NULL, 4),
(192129, NULL, 'G3DSA:3.40.50.880:FF:000100', NULL, NULL, 'Anthranilate synthase component I', NULL, NULL, NULL, NULL, NULL, 4),
(192130, NULL, 'G3DSA:2.120.10.30:FF:000264', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(192131, NULL, 'G3DSA:1.20.920.30:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192132, NULL, 'G3DSA:3.30.70.330:FF:000380', NULL, NULL, 'Serine/arginine-rich splicing factor 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(192133, NULL, 'G3DSA:3.30.160.60:FF:001106', NULL, NULL, 'zinc finger and BTB domain-containing protein 8B', NULL, NULL, NULL, NULL, NULL, 4),
(192134, NULL, 'G3DSA:1.10.510.10:FF:001041', NULL, NULL, 'Cdc15p', NULL, NULL, NULL, NULL, NULL, 4),
(192135, NULL, 'G3DSA:2.60.120.1030:FF:000005', NULL, NULL, 'mRNA cleavage and polyadenylation factor CLP1', NULL, NULL, NULL, NULL, NULL, 4),
(192136, NULL, 'G3DSA:3.30.40.10:FF:000346', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(192137, NULL, 'G3DSA:2.130.10.30:FF:000016', NULL, NULL, 'E3 ubiquitin-protein ligase MYCBP2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(192138, NULL, 'G3DSA:3.10.490.20:FF:000011', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(192139, NULL, 'G3DSA:3.90.1600.10:FF:000055', NULL, NULL, 'DNA polymerase zeta catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(192140, NULL, 'G3DSA:3.80.10.10:FF:003810', NULL, NULL, 'RNI-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(192141, NULL, 'G3DSA:3.30.950.10:FF:000011', NULL, NULL, 'S-adenosylmethionine-dependent methyltransferase, YraL family', NULL, NULL, NULL, NULL, NULL, 4),
(192142, NULL, 'G3DSA:3.30.70.270:FF:000188', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192143, NULL, 'G3DSA:1.25.40.20:FF:001378', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192144, NULL, 'G3DSA:2.40.50.140:FF:001282', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192145, NULL, 'G3DSA:3.90.1100.10:FF:000011', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(192146, NULL, 'G3DSA:3.30.930.10:FF:000004', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(192147, NULL, 'G3DSA:3.40.50.300:FF:005261', NULL, NULL, 'AIG1 family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(192148, NULL, 'G3DSA:3.30.70.1230:FF:000145', NULL, NULL, 'Adenylate cyclase, aggregation specific', NULL, NULL, NULL, NULL, NULL, 4),
(192149, NULL, 'G3DSA:1.10.1740.10:FF:000017', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(192150, NULL, 'G3DSA:3.80.10.10:FF:003754', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192151, NULL, 'G3DSA:3.60.40.10:FF:000042', NULL, NULL, 'Protein phosphatase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(192152, NULL, 'G3DSA:2.130.10.10:FF:003731', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192153, NULL, 'G3DSA:3.30.160.60:FF:005384', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192154, NULL, 'G3DSA:3.30.70.270:FF:000244', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192155, NULL, 'G3DSA:2.40.37.20:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(192156, NULL, 'G3DSA:3.40.47.10:FF:000119', NULL, NULL, 'Anthraniloyl-CoA anthraniloyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(192157, NULL, 'G3DSA:1.10.10.60:FF:001303', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192158, NULL, 'G3DSA:2.60.120.340:FF:000001', NULL, NULL, 'Nucleophosmin 1', NULL, NULL, NULL, NULL, NULL, 4),
(192159, NULL, 'G3DSA:1.25.10.10:FF:002385', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192160, NULL, 'G3DSA:2.30.30.40:FF:000278', NULL, NULL, 'SAM domain, SH3 domain and nuclear localization signals 1', NULL, NULL, NULL, NULL, NULL, 4),
(192161, NULL, 'G3DSA:1.10.3460.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192162, NULL, 'G3DSA:2.60.40.10:FF:005895', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192163, NULL, 'G3DSA:2.40.50.140:FF:000770', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192164, NULL, 'G3DSA:1.20.1250.20:FF:001728', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192165, NULL, 'G3DSA:3.30.1010.10:FF:000001', NULL, NULL, 'Phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(192166, NULL, 'G3DSA:2.130.10.10:FF:004243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192167, NULL, 'G3DSA:2.30.36.70:FF:000008', NULL, NULL, 'actin-related protein 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(192168, NULL, 'G3DSA:1.10.565.10:FF:000015', NULL, NULL, 'Nuclear receptor subfamily 6 group A member 1', NULL, NULL, NULL, NULL, NULL, 4),
(192169, NULL, 'G3DSA:3.40.50.300:FF:000415', NULL, NULL, 'ADP-ribosylation factor-like GTPase 13B', NULL, NULL, NULL, NULL, NULL, 4),
(192170, NULL, 'G3DSA:1.20.5.110:FF:000319', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192171, NULL, 'G3DSA:3.80.10.10:FF:003861', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192172, NULL, 'G3DSA:1.25.40.10:FF:003466', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g52850, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(192173, NULL, 'G3DSA:3.40.50.720:FF:002222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192174, NULL, 'G3DSA:2.130.10.30:FF:000123', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192175, NULL, 'G3DSA:3.40.850.10:FF:000523', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(192176, NULL, 'G3DSA:3.40.50.2000:FF:000379', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(192177, NULL, 'G3DSA:1.25.40.10:FF:002954', NULL, NULL, 'General transcription factor 3C polypeptide 3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(192178, NULL, 'G3DSA:3.80.10.10:FF:000084', NULL, NULL, 'Leucine rich repeat neuronal 2', NULL, NULL, NULL, NULL, NULL, 4),
(192179, NULL, 'G3DSA:1.20.1310.10:FF:000185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192180, NULL, 'G3DSA:1.10.620.20:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192181, NULL, 'G3DSA:3.60.10.10:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192182, NULL, 'G3DSA:3.40.50.620:FF:000449', NULL, NULL, 'DUF218 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(192183, NULL, 'G3DSA:1.25.10.10:FF:001840', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192184, NULL, 'G3DSA:1.10.506.10:FF:000098', NULL, NULL, 'LD15833p', NULL, NULL, NULL, NULL, NULL, 4),
(192185, NULL, 'G3DSA:2.60.40.10:FF:001680', NULL, NULL, 'filamin-A isoform X7', NULL, NULL, NULL, NULL, NULL, 4),
(192186, NULL, 'G3DSA:3.10.110.10:FF:000250', NULL, NULL, 'E3 ubiquitin-protein ligase RNF25', NULL, NULL, NULL, NULL, NULL, 4),
(192187, NULL, 'G3DSA:3.30.40.10:FF:000397', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(192188, NULL, 'G3DSA:3.60.10.10:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192189, NULL, 'G3DSA:2.40.50.140:FF:001175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(192190, NULL, 'G3DSA:1.10.10.1580:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192191, NULL, 'G3DSA:1.10.3380.10:FF:000001', NULL, NULL, 'U5 small nuclear ribonucleoprotein helicase', NULL, NULL, NULL, NULL, NULL, 4),
(192192, NULL, 'G3DSA:2.30.30.380:FF:000003', NULL, NULL, 'SEC24 homolog D, COPII coat complex component', NULL, NULL, NULL, NULL, NULL, 4),
(192193, NULL, 'G3DSA:3.30.160.60:FF:001157', NULL, NULL, 'Zinc finger protein 793', NULL, NULL, NULL, NULL, NULL, 4),
(192194, NULL, 'G3DSA:3.30.230.10:FF:000327', NULL, NULL, 'Lon protease homolog 2 peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(192195, NULL, 'G3DSA:1.10.8.60:FF:000206', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(192196, NULL, 'G3DSA:3.30.70.330:FF:002089', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192197, NULL, 'G3DSA:3.10.180.10:FF:000080', NULL, NULL, 'SOS-regulated glyoxalase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(192198, NULL, 'G3DSA:1.10.150.20:FF:000167', NULL, NULL, 'Transcription and mRNA export factor ENY2', NULL, NULL, NULL, NULL, NULL, 4),
(192199, NULL, 'G3DSA:1.10.10.200:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192200, NULL, 'G3DSA:1.20.1700.10:FF:000001', NULL, NULL, 'Pantothenate kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(192201, NULL, 'G3DSA:1.10.1660.10:FF:000016', NULL, NULL, 'MerR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(192202, NULL, 'G3DSA:1.20.5.370:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192203, NULL, 'G3DSA:1.20.58.60:FF:000204', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(192204, NULL, 'G3DSA:3.90.70.10:FF:000391', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192205, NULL, 'G3DSA:3.60.40.10:FF:000093', NULL, NULL, 'Type 2C protein Phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(192206, NULL, 'G3DSA:3.10.180.90:FF:000002', NULL, NULL, 'ATP-dependent 6-phosphofructokinase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(192207, NULL, 'G3DSA:3.30.260.10:FF:000099', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192208, NULL, 'G3DSA:2.130.10.10:FF:003782', NULL, NULL, 'Cilia and flagella associated protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(192209, NULL, 'G3DSA:2.30.30.140:FF:000162', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(192210, NULL, 'G3DSA:3.40.50.300:FF:000359', NULL, NULL, 'Small GTP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(192211, NULL, 'G3DSA:2.60.40.820:FF:000006', NULL, NULL, 'T-box transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(192212, NULL, 'G3DSA:3.30.70.1230:FF:000089', NULL, NULL, 'AAA ATPase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(192213, NULL, 'G3DSA:1.25.40.430:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192214, NULL, 'G3DSA:1.20.1250.10:FF:000039', NULL, NULL, 'Placental prolactin-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(192215, NULL, 'G3DSA:3.10.110.10:FF:000194', NULL, NULL, 'Ubiquitin-conjugating enzyme E2-28.4 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(192216, NULL, 'G3DSA:3.40.50.880:FF:000044', NULL, NULL, 'Glutamine amidotransferase, class-I', NULL, NULL, NULL, NULL, NULL, 4),
(192217, NULL, 'G3DSA:3.30.565.10:FF:000492', NULL, NULL, 'MUTL protein homolog 3', NULL, NULL, NULL, NULL, NULL, 4),
(192218, NULL, 'G3DSA:1.10.630.10:FF:000319', NULL, NULL, 'Cytochrome P450 aromatase', NULL, NULL, NULL, NULL, NULL, 4),
(192219, NULL, 'G3DSA:3.40.250.10:FF:000045', NULL, NULL, 'Arsenate reductase (Arc2), putative', NULL, NULL, NULL, NULL, NULL, 4),
(192220, NULL, 'G3DSA:1.10.287.1260:FF:000014', NULL, NULL, 'Small-conductance mechanosensitive channel', NULL, NULL, NULL, NULL, NULL, 4),
(192221, NULL, 'G3DSA:3.40.50.720:FF:000665', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(192222, NULL, 'G3DSA:3.40.50.1220:FF:000111', NULL, NULL, 'Transcriptional regulator, Sir2 family protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(192223, NULL, 'G3DSA:2.60.40.10:FF:004591', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192224, NULL, 'G3DSA:1.50.40.10:FF:000412', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192225, NULL, 'G3DSA:1.25.40.10:FF:003522', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192226, NULL, 'G3DSA:2.130.10.10:FF:003675', NULL, NULL, 'Zgc:109932', NULL, NULL, NULL, NULL, NULL, 4),
(192227, NULL, 'G3DSA:2.60.40.10:FF:000145', NULL, NULL, 'Myosin light chain kinase, smooth muscle', NULL, NULL, NULL, NULL, NULL, 4),
(192228, NULL, 'G3DSA:1.10.3080.10:FF:000012', NULL, NULL, 'Chloride channel K', NULL, NULL, NULL, NULL, NULL, 4),
(192229, NULL, 'G3DSA:3.80.10.10:FF:000140', NULL, NULL, 'Outer arm dynein light chain 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(192230, NULL, 'G3DSA:2.40.50.140:FF:000618', NULL, NULL, 'DIS3 like exosome 3''-5'' exoribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(192231, NULL, 'G3DSA:4.10.240.10:FF:000216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192232, NULL, 'G3DSA:3.40.50.2300:FF:001363', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192233, NULL, 'G3DSA:2.60.40.10:FF:003074', NULL, NULL, 'Immunoglobulin heavy variable 11-1', NULL, NULL, NULL, NULL, NULL, 4),
(192234, NULL, 'G3DSA:1.20.1070.10:FF:001902', NULL, NULL, 'Serpentine receptor class X-43', NULL, NULL, NULL, NULL, NULL, 4),
(192235, NULL, 'G3DSA:2.60.40.1360:FF:000003', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(192236, NULL, 'G3DSA:1.10.3260.10:FF:000054', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(192237, NULL, 'G3DSA:1.10.1580.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192238, NULL, 'G3DSA:3.30.1490.80:FF:000029', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(192239, NULL, 'G3DSA:3.60.10.10:FF:000265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192240, NULL, 'G3DSA:3.30.70.330:FF:000228', NULL, NULL, 'RNA-binding motif protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(192241, NULL, 'G3DSA:3.40.50.2300:FF:001256', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192242, NULL, 'G3DSA:1.10.287.70:FF:000347', NULL, NULL, 'Related to TOK1-Voltage-gated, outward-rectifying K+ channel protein of the plasma membrane', NULL, NULL, NULL, NULL, NULL, 4),
(192243, NULL, 'G3DSA:2.130.10.10:FF:000876', NULL, NULL, 'Cft1p', NULL, NULL, NULL, NULL, NULL, 4),
(192244, NULL, 'G3DSA:1.10.510.10:FF:002345', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192245, NULL, 'G3DSA:1.10.510.10:FF:002289', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192246, NULL, 'G3DSA:1.10.10.60:FF:000842', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192247, NULL, 'G3DSA:2.90.10.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192248, NULL, 'G3DSA:1.20.58.200:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192249, NULL, 'G3DSA:3.30.1330.60:FF:000023', NULL, NULL, 'OmpA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(192250, NULL, 'G3DSA:1.20.120.1490:FF:000003', NULL, NULL, 'Zinc resistance-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(192251, NULL, 'G3DSA:2.10.10.100:FF:000004', NULL, NULL, 'UDP-N-acetylhexosamine pyrophosphorylase-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(192252, NULL, 'G3DSA:1.10.510.10:FF:001833', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192253, NULL, 'G3DSA:1.25.40.10:FF:002909', NULL, NULL, 'Putative TPR repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(192254, NULL, 'G3DSA:2.60.200.20:FF:000095', NULL, NULL, 'FHA domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(192255, NULL, 'G3DSA:1.10.238.10:FF:001296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192256, NULL, 'G3DSA:1.20.1250.20:FF:001773', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192257, NULL, 'G3DSA:2.60.40.10:FF:000201', NULL, NULL, 'Tenascin C', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(192258, NULL, 'G3DSA:3.30.870.10:FF:000010', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(192259, NULL, 'G3DSA:3.50.30.30:FF:000160', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192260, NULL, 'G3DSA:2.170.270.10:FF:000126', NULL, NULL, 'Euchromatic histone lysine N-methyltransferase 2a', NULL, NULL, NULL, NULL, NULL, 4),
(192261, NULL, 'G3DSA:1.25.40.10:FF:001049', NULL, NULL, 'Os07g0239600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(192262, NULL, 'G3DSA:3.30.300.20:FF:000021', NULL, NULL, '40S ribosomal protein S3', NULL, NULL, NULL, NULL, NULL, 4),
(192263, NULL, 'G3DSA:2.40.50.40:FF:000088', NULL, NULL, 'Lymphotactin', NULL, NULL, NULL, NULL, NULL, 4),
(192264, NULL, 'G3DSA:1.20.1510.10:FF:000077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192265, NULL, 'G3DSA:3.10.350.10:FF:000088', NULL, NULL, 'LysM domain receptor-like kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(192266, NULL, 'G3DSA:1.10.10.10:FF:002109', NULL, NULL, 'Forkhead box P3', NULL, NULL, NULL, NULL, NULL, 4),
(192267, NULL, 'G3DSA:2.30.42.10:FF:000078', NULL, NULL, 'Partitioning defective 3 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(192268, NULL, 'G3DSA:1.25.40.10:FF:000537', NULL, NULL, 'Tetratricopeptide repeat domain 25', NULL, NULL, NULL, NULL, NULL, 4),
(192269, NULL, 'G3DSA:3.90.520.10:FF:000004', NULL, NULL, 'Mothers against decapentaplegic homolog', NULL, NULL, NULL, NULL, NULL, 4),
(192270, NULL, 'G3DSA:2.130.10.10:FF:001314', NULL, NULL, 'Autophagy-related protein 18b', NULL, NULL, NULL, NULL, NULL, 4),
(192271, NULL, 'G3DSA:2.60.40.10:FF:003978', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192272, NULL, 'G3DSA:3.50.50.60:FF:001070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192273, NULL, 'G3DSA:2.60.40.2860:FF:000026', NULL, NULL, '6-cysteine protein', NULL, NULL, NULL, NULL, NULL, 4),
(192274, NULL, 'G3DSA:3.40.50.300:FF:008060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192275, NULL, 'G3DSA:2.60.40.60:FF:000699', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192276, NULL, 'G3DSA:3.30.450.60:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192277, NULL, 'G3DSA:3.30.260.10:FF:000104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192278, NULL, 'G3DSA:3.30.460.10:FF:000136', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(192279, NULL, 'G3DSA:3.20.20.80:FF:000136', NULL, NULL, 'Lysosomal glucosyl ceramidase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(192280, NULL, 'G3DSA:3.60.160.10:FF:000005', NULL, NULL, 'Altered inheritance of mitochondria protein 24, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(192281, NULL, 'G3DSA:3.30.710.10:FF:000465', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192282, NULL, 'G3DSA:3.30.70.330:FF:002196', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192283, NULL, 'G3DSA:1.20.1440.100:FF:000007', NULL, NULL, 'Putative hydrolase Mb0517c', NULL, NULL, NULL, NULL, NULL, 4),
(192284, NULL, 'G3DSA:3.30.450.20:FF:000644', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192285, NULL, 'G3DSA:3.30.40.10:FF:001706', NULL, NULL, 'UEV domain/Zinc finger, C3HC4 type (RING finger), putative', NULL, NULL, NULL, NULL, NULL, 4),
(192286, NULL, 'G3DSA:3.40.50.800:FF:000026', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(192287, NULL, 'G3DSA:1.20.1420.30:FF:000076', NULL, NULL, 'Putative cation exchanger C3A12.06c', NULL, NULL, NULL, NULL, NULL, 4),
(192288, NULL, 'G3DSA:1.10.472.80:FF:000247', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192289, NULL, 'G3DSA:3.40.50.150:FF:001753', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192290, NULL, 'G3DSA:3.40.250.10:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192291, NULL, 'G3DSA:3.40.50.200:FF:000099', NULL, NULL, 'Related to microbial serine proteinase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(192292, NULL, 'G3DSA:1.10.10.60:FF:000865', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192293, NULL, 'G3DSA:1.20.1110.10:FF:000153', NULL, NULL, 'Possible metal cation transporting P-type ATPase CtpH', NULL, NULL, NULL, NULL, NULL, 4),
(192294, NULL, 'G3DSA:3.40.50.300:FF:001764', NULL, NULL, 'ATP-dependent RNA helicase DEAH13', NULL, NULL, NULL, NULL, NULL, 4),
(192295, NULL, 'G3DSA:1.10.238.10:FF:000396', NULL, NULL, 'Calcium-binding mitochondrial carrier protein Aralar1', NULL, NULL, NULL, NULL, NULL, 4),
(192296, NULL, 'G3DSA:3.30.160.60:FF:002511', NULL, NULL, 'zinc finger and SCAN domain-containing protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(192297, NULL, 'G3DSA:3.40.1090.10:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192298, NULL, 'G3DSA:4.10.280.10:FF:000218', NULL, NULL, 'DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(192299, NULL, 'G3DSA:3.40.50.1010:FF:000240', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192300, NULL, 'G3DSA:2.60.40.1360:FF:000008', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(192301, NULL, 'G3DSA:3.60.20.10:FF:000035', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(192302, NULL, 'G3DSA:2.60.40.10:FF:003478', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192303, NULL, 'G3DSA:3.20.20.60:FF:000130', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(192304, NULL, 'G3DSA:2.30.30.140:FF:000111', NULL, NULL, 'Histone acetyltransferase SAGA associated factor SGF29', NULL, NULL, NULL, NULL, NULL, 4),
(192305, NULL, 'G3DSA:3.40.630.10:FF:000086', NULL, NULL, 'glutaminyl-peptide cyclotransferase-like protein isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(192306, NULL, 'G3DSA:2.60.120.200:FF:000717', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192307, NULL, 'G3DSA:2.60.120.10:FF:000232', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(192308, NULL, 'G3DSA:3.15.10.20:FF:000001', NULL, NULL, 'Activator of 90 kDa heat shock protein ATPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(192309, NULL, 'G3DSA:1.10.150.20:FF:000223', NULL, NULL, 'YALI0F20724p', NULL, NULL, NULL, NULL, NULL, 4),
(192310, NULL, 'G3DSA:3.30.160.60:FF:003523', NULL, NULL, 'Fibronectin type III and SPRY domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(192311, NULL, 'G3DSA:2.40.50.770:FF:000009', NULL, NULL, 'RMi1 (RMI1) Homolog', NULL, NULL, NULL, NULL, NULL, 4),
(192312, NULL, 'G3DSA:2.10.25.10:FF:000562', NULL, NULL, 'Neural-cadherin', NULL, NULL, NULL, NULL, NULL, 4),
(192313, NULL, 'G3DSA:3.30.70.1230:FF:000201', NULL, NULL, 'Guanylate cyclase 2d', NULL, NULL, NULL, NULL, NULL, 4),
(192314, NULL, 'G3DSA:2.40.10.10:FF:000655', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192315, NULL, 'G3DSA:3.30.70.1290:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192316, NULL, 'G3DSA:3.30.505.10:FF:000011', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(192317, NULL, 'G3DSA:1.10.3720.10:FF:000185', NULL, NULL, 'Phosphate transport system permease protein PstA', NULL, NULL, NULL, NULL, NULL, 4),
(192318, NULL, 'G3DSA:3.30.70.330:FF:001740', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192319, NULL, 'G3DSA:1.50.40.10:FF:000524', NULL, NULL, 'Carnitine/acylcarnitine translocase', NULL, NULL, NULL, NULL, NULL, 4),
(192320, NULL, 'G3DSA:1.20.1410.10:FF:000018', NULL, NULL, 'Protein CBG03842', NULL, NULL, NULL, NULL, NULL, 4),
(192321, NULL, 'G3DSA:3.40.50.2000:FF:000435', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(192322, NULL, 'G3DSA:1.25.40.10:FF:000588', NULL, NULL, 'Intraflagellar transport protein 56', NULL, NULL, NULL, NULL, NULL, 4),
(192323, NULL, 'G3DSA:2.30.29.30:FF:000227', NULL, NULL, 'krev interaction trapped protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(192324, NULL, 'G3DSA:3.40.30.10:FF:000379', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(192325, NULL, 'G3DSA:2.130.10.10:FF:001365', NULL, NULL, 'Protein CBR-PFS-2', NULL, NULL, NULL, NULL, NULL, 4),
(192326, NULL, 'G3DSA:1.20.1250.20:FF:000424', NULL, NULL, 'Major facilitator superfamily domain containing 4A', NULL, NULL, NULL, NULL, NULL, 4),
(192327, NULL, 'G3DSA:1.20.1050.10:FF:000035', NULL, NULL, 'Hematopoietic prostaglandin D synthase', NULL, NULL, NULL, NULL, NULL, 4),
(192328, NULL, 'G3DSA:3.30.160.60:FF:004809', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192329, NULL, 'G3DSA:2.130.10.10:FF:004187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192330, NULL, 'G3DSA:3.90.1260.10:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192331, NULL, 'G3DSA:3.70.10.10:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192332, NULL, 'G3DSA:2.40.170.20:FF:000091', NULL, NULL, 'SusC homolog', NULL, NULL, NULL, NULL, NULL, 4),
(192333, NULL, 'G3DSA:2.60.34.10:FF:000108', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(192334, NULL, 'G3DSA:3.30.1370.10:FF:000207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192335, NULL, 'G3DSA:3.10.250.10:FF:000029', NULL, NULL, 'Enteropeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(192336, NULL, 'G3DSA:1.10.150.810:FF:000008', NULL, NULL, 'DNA polymerase kappa-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(192337, NULL, 'G3DSA:3.90.70.60:FF:000001', NULL, NULL, 'Polyprotein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(192338, NULL, 'G3DSA:3.40.50.300:FF:003237', NULL, NULL, 'Dynein, axonemal, heavy chain 6', NULL, NULL, NULL, NULL, NULL, 4),
(192339, NULL, 'G3DSA:3.50.30.10:FF:000002', NULL, NULL, 'Phosphoenolpyruvate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(192340, NULL, 'G3DSA:1.10.260.40:FF:000035', NULL, NULL, 'Antitoxin MqsA', NULL, NULL, NULL, NULL, NULL, 4),
(192341, NULL, 'G3DSA:2.60.40.10:FF:004439', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192342, NULL, 'G3DSA:3.40.1190.10:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192343, NULL, 'G3DSA:1.25.40.10:FF:001605', NULL, NULL, 'Putative ESP1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(192344, NULL, 'G3DSA:2.120.10.30:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192345, NULL, 'G3DSA:3.30.300.350:FF:000001', NULL, NULL, 'GTPase Obg', NULL, NULL, NULL, NULL, NULL, 4),
(192346, NULL, 'G3DSA:3.90.190.10:FF:000141', NULL, NULL, 'Tyrosine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(192347, NULL, 'G3DSA:3.30.160.60:FF:003074', NULL, NULL, 'D19B', NULL, NULL, NULL, NULL, NULL, 4),
(192348, NULL, 'G3DSA:3.30.70.330:FF:002937', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192349, NULL, 'G3DSA:3.30.2350.10:FF:000049', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(192350, NULL, 'G3DSA:3.30.810.10:FF:000006', NULL, NULL, 'Phosphatidylinositol 4-phosphate 5-kinase-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(192351, NULL, 'G3DSA:1.20.910.10:FF:000024', NULL, NULL, 'Aminopyrimidine aminohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(192352, NULL, 'G3DSA:1.20.1070.10:FF:001054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192353, NULL, 'G3DSA:1.10.10.10:FF:001660', NULL, NULL, 'Peroxin 14', NULL, NULL, NULL, NULL, NULL, 4),
(192354, NULL, 'G3DSA:1.10.540.10:FF:000149', NULL, NULL, 'Probable acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(192355, NULL, 'G3DSA:3.40.50.2000:FF:000031', NULL, NULL, 'Trehalose-6-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(192356, NULL, 'G3DSA:2.40.70.10:FF:000215', NULL, NULL, 'Aspartyl protease family protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(192357, NULL, 'G3DSA:2.40.50.140:FF:001170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192358, NULL, 'G3DSA:3.40.910.10:FF:000017', NULL, NULL, 'Os09g0421100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(192359, NULL, 'G3DSA:3.20.20.100:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(192360, NULL, 'G3DSA:3.90.190.10:FF:000085', NULL, NULL, 'NAD kinase 2 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(192361, NULL, 'G3DSA:3.80.10.10:FF:001837', NULL, NULL, 'SHOC2 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(192362, NULL, 'G3DSA:1.25.40.20:FF:001322', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192363, NULL, 'G3DSA:3.90.1100.10:FF:000067', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(192364, NULL, 'G3DSA:3.20.20.330:FF:000024', NULL, NULL, '5-methyltetrahydrofolate--homocysteine S-methyltransferase and 5,10-methylenetetrahydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(192365, NULL, 'G3DSA:2.30.42.10:FF:000185', NULL, NULL, 'Protostome-specific GEF, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(192366, NULL, 'G3DSA:2.130.10.10:FF:002618', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192367, NULL, 'G3DSA:3.40.50.300:FF:007508', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192368, NULL, 'G3DSA:1.20.58.90:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192369, NULL, 'G3DSA:3.30.360.10:FF:000140', NULL, NULL, 'Nicotinate-nucleotide pyrophosphorylase AND conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(192370, NULL, 'G3DSA:1.10.405.10:FF:000015', NULL, NULL, 'RAB GDP-dissociation inhibitor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(192371, NULL, 'G3DSA:3.80.10.10:FF:004243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192372, NULL, 'G3DSA:2.60.130.10:FF:000002', NULL, NULL, 'Protocatechuate 3,4-dioxygenase beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(192373, NULL, 'G3DSA:1.10.238.10:FF:000340', NULL, NULL, 'Centrin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(192374, NULL, 'G3DSA:3.40.50.720:FF:002227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192375, NULL, 'G3DSA:3.10.110.10:FF:000255', NULL, NULL, 'RWD domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(192376, NULL, 'G3DSA:1.10.238.10:FF:000391', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192377, NULL, 'G3DSA:2.170.40.20:FF:000002', NULL, NULL, 'Envelope glycoprotein gp160', NULL, NULL, NULL, NULL, NULL, 4),
(192378, NULL, 'G3DSA:2.10.25.10:FF:000270', NULL, NULL, 'Nidogen 1', NULL, NULL, NULL, NULL, NULL, 4),
(192379, NULL, 'G3DSA:1.20.5.110:FF:000314', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192380, NULL, 'G3DSA:3.30.160.60:FF:001218', NULL, NULL, 'Zinc finger protein 574', NULL, NULL, NULL, NULL, NULL, 4),
(192381, NULL, 'G3DSA:2.60.120.200:FF:000768', NULL, NULL, 'POGO family transposase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(192382, NULL, 'G3DSA:1.20.1070.10:FF:001110', NULL, NULL, 'Putative G-protein coupled receptor 21', NULL, NULL, NULL, NULL, NULL, 4),
(192383, NULL, 'G3DSA:1.20.1270.60:FF:000128', NULL, NULL, 'FCH domain Only (FCH stands for Fes/CIP4 homology domain)', NULL, NULL, NULL, NULL, NULL, 4),
(192384, NULL, 'G3DSA:4.10.60.10:FF:000060', NULL, NULL, 'Zinc knuckle domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(192385, NULL, 'G3DSA:3.40.30.10:FF:000435', NULL, NULL, 'Phosducin/Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(192386, NULL, 'G3DSA:1.10.1520.10:FF:000029', NULL, NULL, 'Mrpl15p', NULL, NULL, NULL, NULL, NULL, 4),
(192387, NULL, 'G3DSA:3.40.50.10330:FF:000084', NULL, NULL, 'ATP-NAD kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(192388, NULL, 'G3DSA:3.30.70.330:FF:002701', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192389, NULL, 'G3DSA:1.10.3080.10:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192390, NULL, 'G3DSA:2.130.10.10:FF:002326', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(192391, NULL, 'G3DSA:1.10.10.490:FF:000001', NULL, NULL, 'beta-catenin-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(192392, NULL, 'G3DSA:3.30.70.330:FF:002589', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(192393, NULL, 'G3DSA:1.25.40.280:FF:000018', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type 23', NULL, NULL, NULL, NULL, NULL, 4),
(192394, NULL, 'G3DSA:3.80.10.10:FF:000876', NULL, NULL, 'Reduced ocelli, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(192395, NULL, 'G3DSA:3.40.50.300:FF:002332', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(192396, NULL, 'G3DSA:2.10.110.10:FF:000293', NULL, NULL, 'Probable Rho-type GTPase-activating protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(192397, NULL, 'G3DSA:4.10.1000.10:FF:000066', NULL, NULL, 'Zinc finger, matrin-type 5', NULL, NULL, NULL, NULL, NULL, 4),
(192398, NULL, 'G3DSA:1.20.1070.10:FF:000093', NULL, NULL, 'G-protein coupled estrogen receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(192399, NULL, 'G3DSA:2.60.40.10:FF:002674', NULL, NULL, 'HEMCAM', NULL, NULL, NULL, NULL, NULL, 4),
(192400, NULL, 'G3DSA:3.10.105.10:FF:000125', NULL, NULL, 'Solute-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(192401, NULL, 'G3DSA:3.30.420.270:FF:000003', NULL, NULL, 'Biopolymer transport protein ExbD/TolR', NULL, NULL, NULL, NULL, NULL, 4),
(192402, NULL, 'G3DSA:3.40.50.300:FF:003344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192403, NULL, 'G3DSA:1.10.1420.10:FF:000196', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(192404, NULL, 'G3DSA:3.40.50.300:FF:003288', NULL, NULL, 'Nucleolar GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(192405, NULL, 'G3DSA:3.90.320.10:FF:000023', NULL, NULL, 'ATP-dependent helicase/nuclease subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(192406, NULL, 'G3DSA:3.40.50.720:FF:000480', NULL, NULL, 'Myo-inositol-1-phosphate synthase Ino1', NULL, NULL, NULL, NULL, NULL, 4),
(192407, NULL, 'G3DSA:1.10.287.110:FF:000444', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192408, NULL, 'G3DSA:1.10.506.10:FF:000042', NULL, NULL, 'Plexin b2a', NULL, NULL, NULL, NULL, NULL, 4),
(192409, NULL, 'G3DSA:3.40.30.10:FF:000143', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(192410, NULL, 'G3DSA:3.40.50.10330:FF:000033', NULL, NULL, 'NADH kinase, variant 3', NULL, NULL, NULL, NULL, NULL, 4),
(192411, NULL, 'G3DSA:1.10.287.1770:FF:000010', NULL, NULL, 'Ferrous iron transport protein B', NULL, NULL, NULL, NULL, NULL, 4),
(192412, NULL, 'G3DSA:1.10.555.10:FF:000189', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192413, NULL, 'G3DSA:3.30.590.50:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192414, NULL, 'G3DSA:3.40.630.10:FF:000479', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192415, NULL, 'G3DSA:3.40.50.300:FF:006547', NULL, NULL, 'Abcd4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(192416, NULL, 'G3DSA:3.90.640.10:FF:000007', NULL, NULL, 'Actin like 7B', NULL, NULL, NULL, NULL, NULL, 4),
(192417, NULL, 'G3DSA:1.20.120.1080:FF:000094', NULL, NULL, 'DEAD/DEAH box RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(192418, NULL, 'G3DSA:1.20.1420.30:FF:000025', NULL, NULL, 'sodium/potassium/calcium exchanger 6, mitochondrial isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(192419, NULL, 'G3DSA:3.40.50.300:FF:003636', NULL, NULL, 'GD23047', NULL, NULL, NULL, NULL, NULL, 4),
(192420, NULL, 'G3DSA:1.20.120.20:FF:000017', NULL, NULL, 'Signal recognition particle receptor FtsY', NULL, NULL, NULL, NULL, NULL, 4),
(192421, NULL, 'G3DSA:2.60.40.10:FF:002062', NULL, NULL, 'Cell adhesion molecule L1-like b', NULL, NULL, NULL, NULL, NULL, 4),
(192422, NULL, 'G3DSA:3.30.390.110:FF:000003', NULL, NULL, 'Protein MAK16 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(192423, NULL, 'G3DSA:1.20.5.430:FF:000005', NULL, NULL, 'Non-structural glycoprotein 4', NULL, NULL, NULL, NULL, NULL, 4),
(192424, NULL, 'G3DSA:1.10.1780.10:FF:000014', NULL, NULL, 'ATP-dependent protease ATP-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(192425, NULL, 'G3DSA:3.50.30.30:FF:000008', NULL, NULL, 'Glutamate carboxypeptidase 2', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(192426, NULL, 'G3DSA:3.40.50.300:FF:007559', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192427, NULL, 'G3DSA:3.40.50.1820:FF:000718', NULL, NULL, 'Poly(3-hydroxyalkanoate) depolymerase', NULL, NULL, NULL, NULL, NULL, 4),
(192428, NULL, 'G3DSA:3.40.190.10:FF:000787', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(192429, NULL, 'G3DSA:3.80.10.10:FF:001152', NULL, NULL, 'F-box and leucine rich repeat protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(192430, NULL, 'G3DSA:3.40.47.10:FF:000294', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192431, NULL, 'G3DSA:3.30.730.10:FF:000005', NULL, NULL, 'ethylene-responsive transcription factor RAP2-11', NULL, NULL, NULL, NULL, NULL, 4),
(192432, NULL, 'G3DSA:1.20.1250.20:FF:000312', NULL, NULL, 'protein NRT1/ PTR FAMILY 4.5', NULL, NULL, NULL, NULL, NULL, 4),
(192433, NULL, 'G3DSA:3.40.50.300:FF:002276', NULL, NULL, 'Torsin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(192434, NULL, 'G3DSA:3.40.1690.20:FF:000013', NULL, NULL, 'AFG3-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(192435, NULL, 'G3DSA:3.30.160.60:FF:005940', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192436, NULL, 'G3DSA:3.30.1020.10:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192437, NULL, 'G3DSA:3.20.20.80:FF:000304', NULL, NULL, 'Alpha-amylase', NULL, NULL, NULL, NULL, NULL, 4),
(192438, NULL, 'G3DSA:3.40.50.1820:FF:001090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192439, NULL, 'G3DSA:3.30.450.20:FF:000588', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192440, NULL, 'G3DSA:3.10.290.20:FF:000012', NULL, NULL, 'SUMO-activating enzyme subunit', NULL, NULL, NULL, NULL, NULL, 4),
(192441, NULL, 'G3DSA:1.10.287.70:FF:000403', NULL, NULL, 'Potassium channel subfamily K member 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(192442, NULL, 'G3DSA:2.60.40.150:FF:000688', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(192443, NULL, 'G3DSA:3.40.50.1240:FF:000117', NULL, NULL, 'Probable phosphatase SPAC5H10.03', NULL, NULL, NULL, NULL, NULL, 4),
(192444, NULL, 'G3DSA:4.10.1000.10:FF:000015', NULL, NULL, 'Zinc finger CCCH domain-containing protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(192445, NULL, 'G3DSA:1.10.1420.10:FF:000145', NULL, NULL, 'Chromosome 23, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(192446, NULL, 'G3DSA:3.40.50.300:FF:006199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192447, NULL, 'G3DSA:2.40.37.20:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192448, NULL, 'G3DSA:3.90.550.50:FF:000001', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(192449, NULL, 'G3DSA:2.170.150.80:FF:000003', NULL, NULL, 'NAC domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(192450, NULL, 'G3DSA:1.10.510.10:FF:003750', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192451, NULL, 'G3DSA:2.60.40.1400:FF:000004', NULL, NULL, 'inward rectifier potassium channel 13 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(192452, NULL, 'G3DSA:3.40.50.12660:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192453, NULL, 'G3DSA:2.30.29.30:FF:001340', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192454, NULL, 'G3DSA:1.25.40.10:FF:005315', NULL, NULL, 'Tetratricopeptide repeat protein 37', NULL, NULL, NULL, NULL, NULL, 4),
(192455, NULL, 'G3DSA:3.60.15.10:FF:000062', NULL, NULL, 'DNA repair metallo-beta-lactamase protein', NULL, NULL, NULL, NULL, NULL, 4),
(192456, NULL, 'G3DSA:3.30.420.40:FF:000974', NULL, NULL, 'Xylose repressor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(192457, NULL, 'G3DSA:3.10.100.10:FF:000373', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192458, NULL, 'G3DSA:3.40.50.1000:FF:000736', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192459, NULL, 'G3DSA:1.25.40.10:FF:004826', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(192460, NULL, 'G3DSA:3.20.20.100:FF:000028', NULL, NULL, 'Oxidoreductase, aldo/keto reductase family', NULL, NULL, NULL, NULL, NULL, 4),
(192461, NULL, 'G3DSA:3.30.40.10:FF:001414', NULL, NULL, 'RING/U-box superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(192462, NULL, 'G3DSA:3.30.420.10:FF:000538', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192463, NULL, 'G3DSA:2.30.29.30:FF:001284', NULL, NULL, 'EPS8 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(192464, NULL, 'G3DSA:3.40.50.1820:FF:000870', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192465, NULL, 'G3DSA:3.30.70.330:FF:001684', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192466, NULL, 'G3DSA:3.30.710.10:FF:000173', NULL, NULL, 'BTB/POZ domain-containing protein NPY2', NULL, NULL, NULL, NULL, NULL, 4),
(192467, NULL, 'G3DSA:1.10.10.160:FF:000037', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(192468, NULL, 'G3DSA:1.10.1820.10:FF:000018', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(192469, NULL, 'G3DSA:3.10.600.10:FF:000006', NULL, NULL, 'Pyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(192470, NULL, 'G3DSA:1.50.40.10:FF:000468', NULL, NULL, 'Protein PGR', NULL, NULL, NULL, NULL, NULL, 4),
(192471, NULL, 'G3DSA:1.10.10.60:FF:001298', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192472, NULL, 'G3DSA:3.90.1300.10:FF:000015', NULL, NULL, 'Amidase', NULL, NULL, NULL, NULL, NULL, 4),
(192473, NULL, 'G3DSA:3.50.40.10:FF:000008', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(192474, NULL, 'G3DSA:2.30.230.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192475, NULL, 'G3DSA:1.25.40.10:FF:001044', NULL, NULL, 'Intraflagellar transport protein IFT88, putative', NULL, NULL, NULL, NULL, NULL, 4),
(192476, NULL, 'G3DSA:3.10.310.40:FF:000015', NULL, NULL, 'AGAP009701-PA', NULL, NULL, NULL, NULL, NULL, 4),
(192477, NULL, 'G3DSA:3.40.50.2300:FF:000800', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192478, NULL, 'G3DSA:1.20.5.4730:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192479, NULL, 'G3DSA:3.30.710.10:FF:000353', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192480, NULL, 'G3DSA:1.20.1070.10:FF:001846', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192481, NULL, 'G3DSA:3.10.450.240:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192482, NULL, 'G3DSA:1.20.120.1080:FF:000150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192483, NULL, 'G3DSA:1.25.10.10:FF:001896', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192484, NULL, 'G3DSA:1.10.4100.10:FF:000003', NULL, NULL, '2-methylcitrate dehydratase 1', NULL, NULL, NULL, NULL, NULL, 4),
(192485, NULL, 'G3DSA:2.60.120.200:FF:000425', NULL, NULL, 'Laminin alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(192486, NULL, 'G3DSA:3.30.200.20:FF:000036', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(192487, NULL, 'G3DSA:1.25.40.10:FF:004478', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192488, NULL, 'G3DSA:1.25.40.10:FF:000644', NULL, NULL, 'Os12g0289800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(192489, NULL, 'G3DSA:3.40.1280.10:FF:000041', NULL, NULL, 'tRNA (pseudouridine(54)-N(1))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(192490, NULL, 'G3DSA:3.40.50.150:FF:001865', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192491, NULL, 'G3DSA:3.20.20.80:FF:000248', NULL, NULL, 'Endo-b-N-acetylGlucosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(192492, NULL, 'G3DSA:2.130.10.30:FF:000011', NULL, NULL, 'inhibitor of Bruton tyrosine kinase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(192493, NULL, 'G3DSA:3.40.30.10:FF:000087', NULL, NULL, 'DnaJ homolog subfamily C member 10', NULL, NULL, NULL, NULL, NULL, 4),
(192494, NULL, 'G3DSA:3.40.50.10860:FF:000012', NULL, NULL, 'Methylenetetrahydrofolate dehydrogenase [NAD(+)]', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(192495, NULL, 'G3DSA:1.10.510.10:FF:002238', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192496, NULL, 'G3DSA:3.30.930.10:FF:000009', NULL, NULL, 'Threonine--tRNA ligase 2, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(192497, NULL, 'G3DSA:3.10.105.10:FF:000069', NULL, NULL, 'Putative lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(192498, NULL, 'G3DSA:2.60.40.150:FF:000637', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192499, NULL, 'G3DSA:2.60.40.10:FF:003130', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(192500, NULL, 'G3DSA:3.90.550.50:FF:000052', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(192501, NULL, 'G3DSA:3.40.50.200:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192502, NULL, 'G3DSA:3.40.630.30:FF:000693', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192503, NULL, 'G3DSA:1.20.1250.10:FF:000034', NULL, NULL, 'Interleukin-5', NULL, NULL, NULL, NULL, NULL, 4),
(192504, NULL, 'G3DSA:2.40.10.10:FF:000599', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192505, NULL, 'G3DSA:3.10.20.90:FF:000662', NULL, NULL, 'WLM domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(192506, NULL, 'G3DSA:2.30.42.10:FF:000134', NULL, NULL, 'syntaxin-binding protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(192507, NULL, 'G3DSA:3.30.479.20:FF:000019', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(192508, NULL, 'G3DSA:3.80.10.10:FF:000932', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(192509, NULL, 'G3DSA:3.30.160.60:FF:003467', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192510, NULL, 'G3DSA:1.10.455.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192511, NULL, 'G3DSA:3.30.70.270:FF:000300', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192512, NULL, 'G3DSA:2.160.20.10:FF:000324', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(192513, NULL, 'G3DSA:2.60.40.10:FF:002854', NULL, NULL, 'Immunoglobulin domain-containing protein oig-4', NULL, NULL, NULL, NULL, NULL, 4),
(192514, NULL, 'G3DSA:1.20.1070.10:FF:000672', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192515, NULL, 'G3DSA:3.40.50.80:FF:000182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192516, NULL, 'G3DSA:1.20.58.60:FF:000148', NULL, NULL, 'nesprin-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(192517, NULL, 'G3DSA:2.60.40.150:FF:000289', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(192518, NULL, 'G3DSA:1.20.1070.10:FF:001161', NULL, NULL, 'Somatostatin receptor type 4', NULL, NULL, NULL, NULL, NULL, 4),
(192519, NULL, 'G3DSA:3.40.50.1820:FF:001831', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192520, NULL, 'G3DSA:1.20.940.10:FF:000020', NULL, NULL, 'Protein transport protein SEC31', NULL, NULL, NULL, NULL, NULL, 4),
(192521, NULL, 'G3DSA:3.90.1470.20:FF:000002', NULL, NULL, 'Putative-diketo-5-methylthio-1-phosphopentane phosphatase protein', NULL, NULL, NULL, NULL, NULL, 4),
(192522, NULL, 'G3DSA:3.30.470.30:FF:000087', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192523, NULL, 'G3DSA:3.40.50.720:FF:002278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192524, NULL, 'G3DSA:1.25.10.10:FF:003346', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192525, NULL, 'G3DSA:3.10.250.10:FF:000136', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192526, NULL, 'G3DSA:1.10.150.240:FF:000028', NULL, NULL, 'Hydrolase, haloacid dehalogenase-like family', NULL, NULL, NULL, NULL, NULL, 4),
(192527, NULL, 'G3DSA:3.10.20.360:FF:000001', NULL, NULL, 'Calmodulin-regulated spectrin-associated protein 3 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(192528, NULL, 'G3DSA:3.30.750.70:FF:000002', NULL, NULL, 'Acetyl-CoA hydrolase Ach1', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(192529, NULL, 'G3DSA:3.40.50.300:FF:007003', NULL, NULL, 'YALI0F02717p', NULL, NULL, NULL, NULL, NULL, 4),
(192530, NULL, 'G3DSA:3.10.490.20:FF:000016', NULL, NULL, 'Dynein heavy chain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(192531, NULL, 'G3DSA:2.130.10.10:FF:001258', NULL, NULL, 'WD repeat-containing protein fzy-1', NULL, NULL, NULL, NULL, NULL, 4),
(192532, NULL, 'G3DSA:2.60.40.10:FF:000549', NULL, NULL, 'Protein tyrosine phosphatase, receptor type S', NULL, NULL, NULL, NULL, NULL, 4),
(192533, NULL, 'G3DSA:1.20.1070.10:FF:000885', NULL, NULL, 'p2Y purinoceptor 11', NULL, NULL, NULL, NULL, NULL, 4),
(192534, NULL, 'G3DSA:1.25.10.10:FF:002733', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192535, NULL, 'G3DSA:3.30.70.330:FF:001633', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192536, NULL, 'G3DSA:2.20.25.530:FF:000006', NULL, NULL, 'Protein CBG16435', NULL, NULL, NULL, NULL, NULL, 4),
(192537, NULL, 'G3DSA:1.25.40.20:FF:000029', NULL, NULL, 'histone-lysine N-methyltransferase EHMT1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(192538, NULL, 'G3DSA:3.20.20.20:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192539, NULL, 'G3DSA:3.20.70.20:FF:000043', NULL, NULL, 'Ribonucleoside-diphosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(192540, NULL, 'G3DSA:3.30.70.330:FF:002645', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192541, NULL, 'G3DSA:3.10.110.10:FF:000199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192542, NULL, 'G3DSA:3.40.710.10:FF:000013', NULL, NULL, 'Penicillin-binding protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(192543, NULL, 'G3DSA:3.30.420.10:FF:000139', NULL, NULL, 'Ribonuclease HII', NULL, NULL, NULL, NULL, NULL, 4),
(192544, NULL, 'G3DSA:1.10.506.10:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192545, NULL, 'G3DSA:1.10.10.60:FF:001247', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192546, NULL, 'G3DSA:3.30.160.60:FF:003815', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192547, NULL, 'G3DSA:3.40.449.10:FF:000012', NULL, NULL, 'Phosphoenolpyruvate carboxykinase (ATP)', NULL, NULL, NULL, NULL, NULL, 4),
(192548, NULL, 'G3DSA:4.10.800.10:FF:000012', NULL, NULL, 'Thyroglobulin', NULL, NULL, NULL, NULL, NULL, 4),
(192549, NULL, 'G3DSA:3.40.50.920:FF:000045', NULL, NULL, 'Pyruvate ferredoxin oxidoreductase, subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(192550, NULL, 'G3DSA:2.40.30.10:FF:000269', NULL, NULL, 'NADPH-cytochrome P450 reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(192551, NULL, 'G3DSA:3.80.10.10:FF:001949', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192552, NULL, 'G3DSA:3.30.70.60:FF:000048', NULL, NULL, 'General secretion pathway protein M', NULL, NULL, NULL, NULL, NULL, 4),
(192553, NULL, 'G3DSA:3.40.50.2020:FF:000149', NULL, NULL, 'Hypoxanthine-guanine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(192554, NULL, 'G3DSA:2.170.260.10:FF:000013', NULL, NULL, 'Argonaute 2, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(192555, NULL, 'G3DSA:1.10.10.10:FF:001480', NULL, NULL, 'Let-611 protein', NULL, NULL, NULL, NULL, NULL, 4),
(192556, NULL, 'G3DSA:2.30.30.490:FF:000013', NULL, NULL, 'DNA (cytosine-5)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(192557, NULL, 'G3DSA:1.10.390.10:FF:000047', NULL, NULL, 'GD21935', NULL, NULL, NULL, NULL, NULL, 4),
(192558, NULL, 'G3DSA:2.30.42.10:FF:000639', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192559, NULL, 'G3DSA:3.30.530.20:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192560, NULL, 'G3DSA:1.10.510.10:FF:000765', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(192561, NULL, 'G3DSA:1.25.40.70:FF:000022', NULL, NULL, 'Phosphatidylinositol 3-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(192562, NULL, 'G3DSA:3.40.50.1110:FF:000045', NULL, NULL, 'Arylesterase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(192563, NULL, 'G3DSA:2.80.10.50:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192564, NULL, 'G3DSA:3.40.50.2000:FF:000143', NULL, NULL, 'UDP-glycosyltransferase 89B1', NULL, NULL, NULL, NULL, NULL, 4),
(192565, NULL, 'G3DSA:3.40.50.300:FF:000707', NULL, NULL, 'RAB36, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(192566, NULL, 'G3DSA:1.10.10.60:FF:001011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192567, NULL, 'G3DSA:3.30.70.660:FF:000035', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(192568, NULL, 'G3DSA:3.30.60.20:FF:000058', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(192569, NULL, 'G3DSA:3.40.630.30:FF:000018', NULL, NULL, '[Ribosomal protein S18]-alanine N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(192570, NULL, 'G3DSA:1.20.5.420:FF:000019', NULL, NULL, 'Protein L', NULL, NULL, NULL, NULL, NULL, 4),
(192571, NULL, 'G3DSA:2.30.30.100:FF:000054', NULL, NULL, 'Polyadenylate-binding protein-interacting protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(192572, NULL, 'G3DSA:3.10.290.10:FF:000026', NULL, NULL, '30S ribosomal protein S4', NULL, NULL, NULL, NULL, NULL, 4),
(192573, NULL, 'G3DSA:3.40.30.10:FF:000323', NULL, NULL, 'Ypt homolog1', NULL, NULL, NULL, NULL, NULL, 4),
(192574, NULL, 'G3DSA:3.40.50.10190:FF:000351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192575, NULL, 'G3DSA:1.10.150.240:FF:000079', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(192576, NULL, 'G3DSA:1.20.140.10:FF:000010', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(192577, NULL, 'G3DSA:1.25.10.10:FF:002677', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192578, NULL, 'G3DSA:2.60.40.60:FF:000194', NULL, NULL, 'FAT atypical cadherin 2', NULL, NULL, NULL, NULL, NULL, 4),
(192579, NULL, 'G3DSA:2.40.30.10:FF:000325', NULL, NULL, 'NADPH--cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(192580, NULL, 'G3DSA:2.10.50.10:FF:000070', NULL, NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(192581, NULL, 'G3DSA:3.30.1330.30:FF:000031', NULL, NULL, 'Growth arrest and DNA damage-inducible protein GADD45 alpha', NULL, NULL, NULL, NULL, NULL, 4),
(192582, NULL, 'G3DSA:3.40.50.10860:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192583, NULL, 'G3DSA:2.60.120.40:FF:000044', NULL, NULL, 'Myeloid-specific peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(192584, NULL, 'G3DSA:3.40.1810.10:FF:000060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192585, NULL, 'G3DSA:3.30.40.10:FF:000054', NULL, NULL, 'E3 ubiquitin-protein ligase RLIM isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(192586, NULL, 'G3DSA:3.40.50.300:FF:002220', NULL, NULL, 'GTPase Era, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(192587, NULL, 'G3DSA:3.40.50.300:FF:002837', NULL, NULL, 'Rad57p', NULL, NULL, NULL, NULL, NULL, 4),
(192588, NULL, 'G3DSA:1.10.1040.10:FF:000104', NULL, NULL, 'AaceriAGL109Wp', NULL, NULL, NULL, NULL, NULL, 4),
(192589, NULL, 'G3DSA:1.20.1090.10:FF:000032', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(192590, NULL, 'G3DSA:3.20.20.70:FF:000419', NULL, NULL, 'Putative DNA modification/repair radical SAM protein', NULL, NULL, NULL, NULL, NULL, 4),
(192591, NULL, 'G3DSA:3.40.50.2000:FF:000828', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192592, NULL, 'G3DSA:3.30.200.20:FF:002458', NULL, NULL, 'CDC7 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(192593, NULL, 'G3DSA:1.25.40.10:FF:003174', NULL, NULL, 'YALI0A15686p', NULL, NULL, NULL, NULL, NULL, 4),
(192594, NULL, 'G3DSA:3.30.200.20:FF:000480', NULL, NULL, 'Mitogen-activated protein kinase kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(192595, NULL, 'G3DSA:2.60.40.10:FF:003366', NULL, NULL, 'Myotactin form A', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(192596, NULL, 'G3DSA:3.90.70.10:FF:000683', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192597, NULL, 'G3DSA:3.40.50.720:FF:002514', NULL, NULL, '3-methylornithyl-N6-L-lysine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(192598, NULL, 'G3DSA:1.25.40.10:FF:001100', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(192599, NULL, 'G3DSA:3.40.50.300:FF:004018', NULL, NULL, 'ATP-dependent RNA helicase RhlE', NULL, NULL, NULL, NULL, NULL, 4),
(192600, NULL, 'G3DSA:3.10.20.90:FF:000898', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192601, NULL, 'G3DSA:2.30.180.10:FF:000141', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192602, NULL, 'G3DSA:3.30.160.60:FF:003579', NULL, NULL, 'Zinc finger protein 235', NULL, NULL, NULL, NULL, NULL, 4),
(192603, NULL, 'G3DSA:2.60.40.10:FF:004708', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192604, NULL, 'G3DSA:1.20.140.40:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192605, NULL, 'G3DSA:3.40.50.2300:FF:001655', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192606, NULL, 'G3DSA:3.30.470.160:FF:000014', NULL, NULL, 'Kinase', NULL, NULL, NULL, NULL, NULL, 4),
(192607, NULL, 'G3DSA:3.30.710.10:FF:000066', NULL, NULL, 'kelch-like protein 8 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(192608, NULL, 'G3DSA:2.10.25.10:FF:001000', NULL, NULL, 'Stabilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(192609, NULL, 'G3DSA:3.30.160.60:FF:000201', NULL, NULL, 'C2H2 finger domain protein (Gli3)', NULL, NULL, NULL, NULL, NULL, 4),
(192610, NULL, 'G3DSA:3.30.60.30:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192611, NULL, 'G3DSA:3.30.160.60:FF:003635', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192612, NULL, 'G3DSA:3.40.50.720:FF:002458', NULL, NULL, 'Shikimate 5-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(192613, NULL, 'G3DSA:1.25.10.10:FF:003402', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192614, NULL, 'G3DSA:2.60.40.10:FF:003422', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192615, NULL, 'G3DSA:1.25.40.10:FF:003230', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(192616, NULL, 'G3DSA:2.40.50.120:FF:000051', NULL, NULL, 'Netrin-1', NULL, NULL, NULL, NULL, NULL, 4),
(192617, NULL, 'G3DSA:2.60.40.150:FF:000401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192618, NULL, 'G3DSA:3.30.160.60:FF:000145', NULL, NULL, 'Zinc finger protein 574', NULL, NULL, NULL, NULL, NULL, 4),
(192619, NULL, 'G3DSA:3.90.1150.160:FF:000007', NULL, NULL, 'Glutamate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(192620, NULL, 'G3DSA:3.40.190.10:FF:000894', NULL, NULL, 'Fe(III)-induced transcriptional regulator IfcR', NULL, NULL, NULL, NULL, NULL, 4),
(192621, NULL, 'G3DSA:1.25.40.10:FF:004534', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192622, NULL, 'G3DSA:3.90.550.10:FF:000629', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192623, NULL, 'G3DSA:2.10.70.10:FF:000014', NULL, NULL, 'Membrane cofactor protein', NULL, NULL, NULL, NULL, NULL, 4),
(192624, NULL, 'G3DSA:2.60.40.10:FF:000437', NULL, NULL, 'Beat-IIIc, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(192625, NULL, 'G3DSA:1.10.225.10:FF:000029', NULL, NULL, 'Aspartic proteinase A1', NULL, NULL, NULL, NULL, NULL, 4),
(192626, NULL, 'G3DSA:2.40.160.210:FF:000019', NULL, NULL, 'HotDog domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(192627, NULL, 'G3DSA:1.10.10.10:FF:000529', NULL, NULL, 'MurR/RpiR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(192628, NULL, 'G3DSA:3.40.50.1110:FF:000152', NULL, NULL, 'Os01g0543400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(192629, NULL, 'G3DSA:3.80.10.10:FF:001045', NULL, NULL, 'RANGAP1 isoform 5', NULL, NULL, NULL, NULL, NULL, 4),
(192630, NULL, 'G3DSA:2.130.10.10:FF:001022', NULL, NULL, 'Ubiquitin ligase subunit', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(192631, NULL, 'G3DSA:2.120.10.80:FF:000138', NULL, NULL, 'Calicin', NULL, NULL, NULL, NULL, NULL, 4),
(192632, NULL, 'G3DSA:2.130.10.10:FF:002770', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192633, NULL, 'G3DSA:3.40.50.720:FF:001154', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(192634, NULL, 'G3DSA:1.25.40.10:FF:004427', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(192635, NULL, 'G3DSA:3.40.50.150:FF:000792', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192636, NULL, 'G3DSA:3.30.70.2460:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192637, NULL, 'G3DSA:3.90.120.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192638, NULL, 'G3DSA:3.30.70.330:FF:002757', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192639, NULL, 'G3DSA:2.60.120.260:FF:000128', NULL, NULL, 'Allantoicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(192640, NULL, 'G3DSA:2.60.40.10:FF:005496', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192641, NULL, 'G3DSA:1.20.1270.10:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192642, NULL, 'G3DSA:1.50.10.10:FF:000135', NULL, NULL, 'Glucan 1,4-alpha-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(192643, NULL, 'G3DSA:1.10.287.2620:FF:000012', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(192644, NULL, 'G3DSA:3.40.640.10:FF:000417', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192645, NULL, 'G3DSA:1.10.10.10:FF:000816', NULL, NULL, 'Cell division control protein', NULL, NULL, NULL, NULL, NULL, 4),
(192646, NULL, 'G3DSA:2.70.98.70:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192647, NULL, 'G3DSA:3.40.50.300:FF:005710', NULL, NULL, 'SARP family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(192648, NULL, 'G3DSA:1.10.150.770:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192649, NULL, 'G3DSA:3.40.50.10190:FF:000120', NULL, NULL, 'WGS project CABT00000000 data, contig 2.8', NULL, NULL, NULL, NULL, NULL, 4),
(192650, NULL, 'G3DSA:2.70.98.90:FF:000009', NULL, NULL, 'Membrane protein insertase YidC', NULL, NULL, NULL, NULL, NULL, 4),
(192651, NULL, 'G3DSA:3.40.50.1820:FF:000269', NULL, NULL, 'Acyl-CoA thioesterase 6', NULL, NULL, NULL, NULL, NULL, 4),
(192652, NULL, 'G3DSA:3.80.10.10:FF:001101', NULL, NULL, 'Protein phosphatase 2C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(192653, NULL, 'G3DSA:1.20.58.60:FF:000772', NULL, NULL, 'Microtubule-actin crosslinking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(192654, NULL, 'G3DSA:3.30.1600.10:FF:000029', NULL, NULL, 'NAD-dependent protein deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(192655, NULL, 'G3DSA:3.50.50.60:FF:001283', NULL, NULL, 'Lycopene epsilon cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(192656, NULL, 'G3DSA:2.40.20.10:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192657, NULL, 'G3DSA:1.10.1420.10:FF:000089', NULL, NULL, 'mutS protein homolog 4', NULL, NULL, NULL, NULL, NULL, 4),
(192658, NULL, 'G3DSA:2.130.10.10:FF:006036', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192659, NULL, 'G3DSA:3.60.21.10:FF:000003', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(192660, NULL, 'G3DSA:1.20.120.350:FF:000126', NULL, NULL, 'Related to CCH1-Calcium channel (Alpha subunit)', NULL, NULL, NULL, NULL, NULL, 4),
(192661, NULL, 'G3DSA:2.40.33.40:FF:000003', NULL, NULL, 'PTS sorbitol transporter subunit IIA', NULL, NULL, NULL, NULL, NULL, 4),
(192662, NULL, 'G3DSA:1.10.10.1760:FF:000011', NULL, NULL, 'Ribosomal protein L36, putative', NULL, NULL, NULL, NULL, NULL, 4),
(192663, NULL, 'G3DSA:1.20.58.390:FF:000291', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192664, NULL, 'G3DSA:3.30.930.10:FF:000392', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192665, NULL, 'G3DSA:3.90.800.10:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(192666, NULL, 'G3DSA:3.30.70.330:FF:001341', NULL, NULL, 'Regulatory protein E2', NULL, NULL, NULL, NULL, NULL, 4),
(192667, NULL, 'G3DSA:1.10.10.10:FF:000636', NULL, NULL, 'Histone H1', NULL, NULL, NULL, NULL, NULL, 4),
(192668, NULL, 'G3DSA:2.60.40.10:FF:001218', NULL, NULL, 'Protein tyrosine phosphatase, receptor type B', NULL, NULL, NULL, NULL, NULL, 4),
(192669, NULL, 'G3DSA:3.30.710.10:FF:000122', NULL, NULL, 'potassium voltage-gated channel subfamily A member 7', NULL, NULL, NULL, NULL, NULL, 4),
(192670, NULL, 'G3DSA:2.60.120.260:FF:000460', NULL, NULL, 'Arabinofuranosidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(192671, NULL, 'G3DSA:2.102.10.10:FF:000063', NULL, NULL, 'RE52861p', NULL, NULL, NULL, NULL, NULL, 4),
(192672, NULL, 'G3DSA:2.30.29.30:FF:000772', NULL, NULL, 'RANBP3 isoform 10', NULL, NULL, NULL, NULL, NULL, 4),
(192673, NULL, 'G3DSA:2.20.25.10:FF:000078', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(192674, NULL, 'G3DSA:1.20.1070.10:FF:000941', NULL, NULL, 'Serotonin receptor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(192675, NULL, 'G3DSA:3.90.290.10:FF:000025', NULL, NULL, 'Fibrillin-1', NULL, NULL, NULL, NULL, NULL, 4),
(192676, NULL, 'G3DSA:2.60.40.420:FF:000117', NULL, NULL, 'Protein CBR-EFN-2', NULL, NULL, NULL, NULL, NULL, 4),
(192677, NULL, 'G3DSA:3.30.499.10:FF:000012', NULL, NULL, 'Iron-responsive element binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(192678, NULL, 'G3DSA:3.30.470.20:FF:000258', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192679, NULL, 'G3DSA:2.60.40.1150:FF:000002', NULL, NULL, 'Beta-adaptin-like protein C', NULL, NULL, NULL, NULL, NULL, 4),
(192680, NULL, 'G3DSA:3.30.160.60:FF:005996', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192681, NULL, 'G3DSA:3.30.70.340:FF:000001', NULL, NULL, 'Carboxypeptidase A5', NULL, NULL, NULL, NULL, NULL, 4),
(192682, NULL, 'G3DSA:2.60.120.620:FF:000107', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192683, NULL, 'G3DSA:1.10.287.990:FF:000005', NULL, NULL, 'Superoxide dismutase [Fe]', NULL, NULL, NULL, NULL, NULL, 4),
(192684, NULL, 'G3DSA:3.10.100.10:FF:000193', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192685, NULL, 'G3DSA:1.20.1070.10:FF:001453', NULL, NULL, 'AKH/corazonin-related peptide', NULL, NULL, NULL, NULL, NULL, 4),
(192686, NULL, 'G3DSA:3.10.100.10:FF:000081', NULL, NULL, 'FRAS1 related extracellular matrix 1', NULL, NULL, NULL, NULL, NULL, 4),
(192687, NULL, 'G3DSA:3.30.40.10:FF:000689', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(192688, NULL, 'G3DSA:1.25.40.10:FF:000936', NULL, NULL, 'Protein CTR9 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(192689, NULL, 'G3DSA:3.30.40.10:FF:001307', NULL, NULL, 'Peroxisome biosynthesis protein (PAS10/Peroxin-12), putative', NULL, NULL, NULL, NULL, NULL, 4),
(192690, NULL, 'G3DSA:1.20.120.1710:FF:000002', NULL, NULL, 'NAD-dependent histone deacetylase SIR2', NULL, NULL, NULL, NULL, NULL, 4),
(192691, NULL, 'G3DSA:2.30.30.40:FF:000626', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192692, NULL, 'G3DSA:1.10.150.50:FF:000053', NULL, NULL, 'Bifunctional apoptosis regulator', NULL, NULL, NULL, NULL, NULL, 4),
(192693, NULL, 'G3DSA:3.10.20.90:FF:000954', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192694, NULL, 'G3DSA:3.30.70.980:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192695, NULL, 'G3DSA:3.30.497.10:FF:000119', NULL, NULL, 'AGAP009212-PA', NULL, NULL, NULL, NULL, NULL, 4),
(192696, NULL, 'G3DSA:3.30.200.20:FF:000660', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192697, NULL, 'G3DSA:3.40.850.10:FF:000231', NULL, NULL, 'Kinesin like protein', NULL, NULL, NULL, NULL, NULL, 4),
(192698, NULL, 'G3DSA:2.60.40.10:FF:002910', NULL, NULL, 'Plexin A2', NULL, NULL, NULL, NULL, NULL, 4),
(192699, NULL, 'G3DSA:3.30.200.20:FF:000328', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(192700, NULL, 'G3DSA:3.20.140.10:FF:000030', NULL, NULL, 'Nicotinate phosphoribosyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(192701, NULL, 'G3DSA:3.40.20.10:FF:000030', NULL, NULL, 'protein flightless-1 homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(192702, NULL, 'G3DSA:3.40.50.300:FF:002040', NULL, NULL, 'ABC multidrug transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(192703, NULL, 'G3DSA:3.40.50.2300:FF:001599', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192704, NULL, 'G3DSA:1.20.1600.10:FF:000016', NULL, NULL, 'Outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(192705, NULL, 'G3DSA:3.40.390.10:FF:000151', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192706, NULL, 'G3DSA:1.10.600.10:FF:000087', NULL, NULL, 'Farnesyl pyrophosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(192707, NULL, 'G3DSA:2.60.40.150:FF:000345', NULL, NULL, 'DnaJ domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(192708, NULL, 'G3DSA:3.30.780.10:FF:000071', NULL, NULL, 'Translation machinery-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(192709, NULL, 'G3DSA:1.10.555.10:FF:000133', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192710, NULL, 'G3DSA:2.60.40.1180:FF:000106', NULL, NULL, 'Glucan 1,6-alpha-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(192711, NULL, 'G3DSA:1.25.40.1030:FF:000021', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192712, NULL, 'G3DSA:2.60.120.10:FF:000445', NULL, NULL, 'Probable mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(192713, NULL, 'G3DSA:3.30.460.20:FF:000021', NULL, NULL, 'CorA-like Mg2+ transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(192714, NULL, 'G3DSA:3.90.1580.10:FF:000007', NULL, NULL, 'Formylglycine-generating enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(192715, NULL, 'G3DSA:1.20.900.10:FF:000074', NULL, NULL, 'RHo Guanine nucleotide exchange Factor', NULL, NULL, NULL, NULL, NULL, 4),
(192716, NULL, 'G3DSA:3.40.50.2000:FF:000087', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(192717, NULL, 'G3DSA:3.20.20.70:FF:000751', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192718, NULL, 'G3DSA:3.40.50.300:FF:006435', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192719, NULL, 'G3DSA:3.30.70.870:FF:000036', NULL, NULL, 'Elongation factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(192720, NULL, 'G3DSA:1.10.510.10:FF:003694', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192721, NULL, 'G3DSA:2.130.10.10:FF:004799', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192722, NULL, 'G3DSA:1.10.510.10:FF:002906', NULL, NULL, 'CK1 family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(192723, NULL, 'G3DSA:2.60.260.20:FF:000104', NULL, NULL, 'DnaJ family protein chaperone, putative', NULL, NULL, NULL, NULL, NULL, 4),
(192724, NULL, 'G3DSA:3.40.50.1000:FF:000629', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192725, NULL, 'G3DSA:4.10.365.10:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192726, NULL, 'G3DSA:3.80.10.10:FF:003462', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192727, NULL, 'G3DSA:3.40.1620.70:FF:000001', NULL, NULL, 'Multiplexin collagen isoform Ap3', NULL, NULL, NULL, NULL, NULL, 4),
(192728, NULL, 'G3DSA:3.20.20.140:FF:000118', NULL, NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(192729, NULL, 'G3DSA:3.30.1520.10:FF:000028', NULL, NULL, 'sorting nexin 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(192730, NULL, 'G3DSA:3.90.640.10:FF:000283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192731, NULL, 'G3DSA:1.10.510.10:FF:003306', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192732, NULL, 'G3DSA:3.90.1410.10:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192733, NULL, 'G3DSA:3.20.20.220:FF:000047', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(192734, NULL, 'G3DSA:1.10.238.10:FF:000008', NULL, NULL, 'Dystrophin isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(192735, NULL, 'G3DSA:2.60.40.60:FF:000250', NULL, NULL, 'Cadherin related family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(192736, NULL, 'G3DSA:2.60.40.10:FF:004203', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192737, NULL, 'G3DSA:3.80.10.10:FF:002349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192738, NULL, 'G3DSA:3.40.50.2000:FF:000323', NULL, NULL, 'Starch synthase 3', NULL, NULL, NULL, NULL, NULL, 4),
(192739, NULL, 'G3DSA:3.30.450.30:FF:000029', NULL, NULL, 'Dynein light chain roadblock', NULL, NULL, NULL, NULL, NULL, 4),
(192740, NULL, 'G3DSA:2.120.10.30:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192741, NULL, 'G3DSA:1.10.490.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192742, NULL, 'G3DSA:2.60.40.10:FF:004147', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192743, NULL, 'G3DSA:3.40.50.970:FF:000071', NULL, NULL, '2-hydroxyphytanoyl-CoA lyase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(192744, NULL, 'G3DSA:1.25.40.10:FF:002117', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(192745, NULL, 'G3DSA:3.30.1490.20:FF:000034', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(192746, NULL, 'G3DSA:3.40.50.150:FF:001230', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192747, NULL, 'G3DSA:2.40.10.10:FF:000094', NULL, NULL, 'Phage baseplate hub subunit', NULL, NULL, NULL, NULL, NULL, 4),
(192748, NULL, 'G3DSA:1.25.10.10:FF:002621', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192749, NULL, 'G3DSA:1.25.40.10:FF:004247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192750, NULL, 'G3DSA:2.30.30.100:FF:000234', NULL, NULL, 'Sm-like protein LSM6A', NULL, NULL, NULL, NULL, NULL, 4),
(192751, NULL, 'G3DSA:3.90.550.10:FF:000068', NULL, NULL, 'ALG5, dolichyl-phosphate beta-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(192752, NULL, 'G3DSA:2.60.40.10:FF:003927', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192753, NULL, 'G3DSA:2.40.10.10:FF:000150', NULL, NULL, 'Chymotrypsin-like protease CTRL-1', NULL, NULL, NULL, NULL, NULL, 4),
(192754, NULL, 'G3DSA:1.20.58.1770:FF:000006', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(192755, NULL, 'G3DSA:2.60.120.10:FF:000501', NULL, NULL, 'Cyclic nucleotide-gated potassium channel', NULL, NULL, NULL, NULL, NULL, 4),
(192756, NULL, 'G3DSA:3.80.10.10:FF:002405', NULL, NULL, 'PH domain and leucine rich repeat protein phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(192757, NULL, 'G3DSA:2.60.120.260:FF:000308', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(192758, NULL, 'G3DSA:3.30.70.3250:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192759, NULL, 'G3DSA:2.130.10.10:FF:004456', NULL, NULL, 'Ribosome biogenesis protein WDR12 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(192760, NULL, 'G3DSA:2.40.70.10:FF:000159', NULL, NULL, 'Eukaryotic aspartyl protease family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(192761, NULL, 'G3DSA:3.30.420.80:FF:000014', NULL, NULL, 'Probable ribosomal protein S11, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(192762, NULL, 'G3DSA:1.10.3210.10:FF:000051', NULL, NULL, 'Cyclic di-GMP phosphodiesterase PA4781', NULL, NULL, NULL, NULL, NULL, 4),
(192763, NULL, 'G3DSA:2.30.30.100:FF:000178', NULL, NULL, 'YALI0F30426p', NULL, NULL, NULL, NULL, NULL, 4),
(192764, NULL, 'G3DSA:2.40.150.20:FF:000033', NULL, NULL, '60S ribosomal protein L14, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(192765, NULL, 'G3DSA:3.60.40.10:FF:000311', NULL, NULL, '2C-type protein phosphatase protein', NULL, NULL, NULL, NULL, NULL, 4),
(192766, NULL, 'G3DSA:2.30.38.10:FF:000023', NULL, NULL, 'N-(5-amino-5-carboxypentanoyl)-L-cysteinyl-D-valine synthase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(192767, NULL, 'G3DSA:3.60.110.10:FF:000002', NULL, NULL, 'Nitrilase family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(192768, NULL, 'G3DSA:3.30.70.1230:FF:000033', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(192769, NULL, 'G3DSA:3.40.50.1780:FF:000037', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NAR1', NULL, NULL, NULL, NULL, NULL, 4),
(192770, NULL, 'G3DSA:1.20.1270.280:FF:000033', NULL, NULL, 'Dynein heavy chain 5, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(192771, NULL, 'G3DSA:3.30.160.60:FF:002562', NULL, NULL, 'Zinc finger protein 556', NULL, NULL, NULL, NULL, NULL, 4),
(192772, NULL, 'G3DSA:3.40.50.2000:FF:000267', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(192773, NULL, 'G3DSA:3.40.50.2300:FF:000295', NULL, NULL, 'LacI family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(192774, NULL, 'G3DSA:3.40.50.300:FF:001820', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(192775, NULL, 'G3DSA:1.10.238.10:FF:000683', NULL, NULL, 'EH domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(192776, NULL, 'G3DSA:2.40.10.170:FF:000001', NULL, NULL, 'CarD family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(192777, NULL, 'G3DSA:3.30.200.20:FF:001784', NULL, NULL, 'AGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(192778, NULL, 'G3DSA:3.10.390.10:FF:000011', NULL, NULL, 'ski oncogene', NULL, NULL, NULL, NULL, NULL, 4),
(192779, NULL, 'G3DSA:1.10.8.10:FF:000220', NULL, NULL, 'YALI0A18007p', NULL, NULL, NULL, NULL, NULL, 4),
(192780, NULL, 'G3DSA:1.10.630.10:FF:000763', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192781, NULL, 'G3DSA:1.10.510.10:FF:001221', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(192782, NULL, 'G3DSA:3.40.1190.20:FF:000048', NULL, NULL, 'Fructoselysine 6-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(192783, NULL, 'G3DSA:2.60.40.10:FF:005108', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192784, NULL, 'G3DSA:3.80.10.10:FF:001444', NULL, NULL, 'ELRR (Extracellular Leucine-Rich Repeat) ONly', NULL, NULL, NULL, NULL, NULL, 4),
(192785, NULL, 'G3DSA:1.25.40.570:FF:000004', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(192786, NULL, 'G3DSA:1.10.8.10:FF:000164', NULL, NULL, 'XPC-binding_domain/UBA/TS-N_domain_containing_protein', NULL, NULL, NULL, NULL, NULL, 4),
(192787, NULL, 'G3DSA:2.60.40.10:FF:002966', NULL, NULL, 'Periplasmic beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(192788, NULL, 'G3DSA:3.40.50.720:FF:000772', NULL, NULL, 'Hydroxyacid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(192789, NULL, 'G3DSA:3.40.50.1460:FF:000003', NULL, NULL, 'GPI-anchor transamidase', NULL, NULL, NULL, NULL, NULL, 4),
(192790, NULL, 'G3DSA:3.30.50.10:FF:000116', NULL, NULL, 'Nuclear receptor subfamily 4, group A, member 1', NULL, NULL, NULL, NULL, NULL, 4),
(192791, NULL, 'G3DSA:1.10.1760.20:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192792, NULL, 'G3DSA:3.30.1740.10:FF:000011', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(192793, NULL, 'G3DSA:4.10.280.10:FF:000106', NULL, NULL, 'Transcription factor ILI5', NULL, NULL, NULL, NULL, NULL, 4),
(192794, NULL, 'G3DSA:3.20.20.190:FF:000055', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(192795, NULL, 'G3DSA:3.40.50.410:FF:000105', NULL, NULL, 'Mesocentin', NULL, NULL, NULL, NULL, NULL, 4),
(192796, NULL, 'G3DSA:3.30.70.120:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192797, NULL, 'G3DSA:3.40.50.2300:FF:000351', NULL, NULL, 'Diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(192798, NULL, 'G3DSA:1.10.533.10:FF:000296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192799, NULL, 'G3DSA:3.10.20.90:FF:000774', NULL, NULL, 'band 4.1-like protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(192800, NULL, 'G3DSA:3.40.50.1820:FF:001382', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192801, NULL, 'G3DSA:2.40.50.90:FF:000018', NULL, NULL, 'Ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(192802, NULL, 'G3DSA:2.70.50.30:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192803, NULL, 'G3DSA:3.40.50.10810:FF:000082', NULL, NULL, 'SNF2 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(192804, NULL, 'G3DSA:3.40.190.10:FF:000495', NULL, NULL, 'Hydrogen peroxide-inducible genes activator', NULL, NULL, NULL, NULL, NULL, 4),
(192805, NULL, 'G3DSA:1.10.287.370:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192806, NULL, 'G3DSA:4.10.1000.10:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192807, NULL, 'G3DSA:3.40.1160.10:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192808, NULL, 'G3DSA:4.10.40.10:FF:000002', NULL, NULL, 'Omega-hexatoxin-Hv2a', NULL, NULL, NULL, NULL, NULL, 4),
(192809, NULL, 'G3DSA:2.60.11.10:FF:000016', NULL, NULL, 'Mitochondrial cytochrome c oxidase subunit 4, 13 kD', NULL, NULL, NULL, NULL, NULL, 4),
(192810, NULL, 'G3DSA:3.20.20.80:FF:000012', NULL, NULL, 'Mannan endo-1,4-beta-mannosidase 6', NULL, NULL, NULL, NULL, NULL, 4),
(192811, NULL, 'G3DSA:1.10.1410.10:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192812, NULL, 'G3DSA:3.20.20.80:FF:000535', NULL, NULL, 'Beta-galactosidase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(192813, NULL, 'G3DSA:2.70.130.10:FF:000005', NULL, NULL, 'Insulin-like growth factor 2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(192814, NULL, 'G3DSA:3.30.830.10:FF:000120', NULL, NULL, 'Mitochondrial-processing peptidase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(192815, NULL, 'G3DSA:1.10.10.60:FF:000230', NULL, NULL, 'POU domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(192816, NULL, 'G3DSA:1.10.150.20:FF:000274', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192817, NULL, 'G3DSA:3.90.550.10:FF:000124', NULL, NULL, 'Glycosyl transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(192818, NULL, 'G3DSA:2.40.30.110:FF:000010', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(192819, NULL, 'G3DSA:2.50.20.10:FF:000015', NULL, NULL, 'Outer-membrane lipoprotein carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(192820, NULL, 'G3DSA:4.10.400.10:FF:000083', NULL, NULL, 'Atrial natriuretic peptide-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(192821, NULL, 'G3DSA:3.40.50.10130:FF:000029', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192822, NULL, 'G3DSA:1.25.40.180:FF:000157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192823, NULL, 'G3DSA:3.30.760.10:FF:000069', NULL, NULL, 'Translation initiation factor eIF 4e-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(192824, NULL, 'G3DSA:2.130.10.10:FF:000241', NULL, NULL, 'periodic tryptophan protein 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(192825, NULL, 'G3DSA:1.25.40.10:FF:005208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192826, NULL, 'G3DSA:3.40.50.1000:FF:000012', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(192827, NULL, 'G3DSA:1.10.287.70:FF:000078', NULL, NULL, 'Putative Inward rectifier potassium channel', NULL, NULL, NULL, NULL, NULL, 4),
(192828, NULL, 'G3DSA:3.40.50.2300:FF:000874', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192829, NULL, 'G3DSA:1.20.1070.10:FF:001397', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192830, NULL, 'G3DSA:3.30.450.20:FF:000083', NULL, NULL, 'Cyclic di-GMP phosphodiesterase Gmr', NULL, NULL, NULL, NULL, NULL, 4),
(192831, NULL, 'G3DSA:1.25.40.10:FF:002393', NULL, NULL, 'Os01g0914600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(192832, NULL, 'G3DSA:1.20.1270.420:FF:000002', NULL, NULL, 'Inhibitor of nuclear factor kappa B kinase subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(192833, NULL, 'G3DSA:1.10.8.1220:FF:000001', NULL, NULL, 'Dynein axonemal heavy chain 5', NULL, NULL, NULL, NULL, NULL, 4),
(192834, NULL, 'G3DSA:3.40.50.10420:FF:000015', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(192835, NULL, 'G3DSA:3.30.1360.40:FF:000036', NULL, NULL, 'Probable DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(192836, NULL, 'G3DSA:1.20.1250.20:FF:000368', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(192837, NULL, 'G3DSA:2.120.10.80:FF:000318', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192838, NULL, 'G3DSA:3.30.200.20:FF:001385', NULL, NULL, 'AGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(192839, NULL, 'G3DSA:3.40.50.2300:FF:001312', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192840, NULL, 'G3DSA:1.10.3380.10:FF:000052', NULL, NULL, 'ER-targeted preprotein translocase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(192841, NULL, 'G3DSA:1.10.238.210:FF:000004', NULL, NULL, 'CRE-GLNA-3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(192842, NULL, 'G3DSA:1.10.287.70:FF:000639', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192843, NULL, 'G3DSA:3.30.379.10:FF:000014', NULL, NULL, 'O-GlcNAcase NagJ', NULL, NULL, NULL, NULL, NULL, 4),
(192844, NULL, 'G3DSA:1.10.472.10:FF:000215', NULL, NULL, 'Transcription initiation factor IIIB chain BRF, putative', NULL, NULL, NULL, NULL, NULL, 4),
(192845, NULL, 'G3DSA:2.130.10.10:FF:000584', NULL, NULL, 'Dynein intermediate chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(192846, NULL, 'G3DSA:2.150.10.10:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192847, NULL, 'G3DSA:2.10.70.10:FF:000290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192848, NULL, 'G3DSA:1.20.1070.10:FF:002178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192849, NULL, 'G3DSA:3.90.1150.10:FF:000126', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(192850, NULL, 'G3DSA:1.10.20.10:FF:000137', NULL, NULL, 'DNA polymerase epsilon p12 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(192851, NULL, 'G3DSA:1.20.1110.10:FF:000260', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192852, NULL, 'G3DSA:3.30.160.60:FF:000089', NULL, NULL, 'DNA-binding protein creA', NULL, NULL, NULL, NULL, NULL, 4),
(192853, NULL, 'G3DSA:3.40.50.10240:FF:000006', NULL, NULL, 'Thiamin pyrophosphokinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(192854, NULL, 'G3DSA:2.130.10.10:FF:005255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192855, NULL, 'G3DSA:3.90.1150.10:FF:000306', NULL, NULL, 'Glutamic-oxaloacetic transaminase 1-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(192856, NULL, 'G3DSA:3.40.50.720:FF:000373', NULL, NULL, 'UDP-glucose 4-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(192857, NULL, 'G3DSA:3.30.390.30:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192858, NULL, 'G3DSA:1.20.91.20:FF:000011', NULL, NULL, 'Complement component C5', NULL, NULL, NULL, NULL, NULL, 4),
(192859, NULL, 'G3DSA:3.40.50.720:FF:001210', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(192860, NULL, 'G3DSA:3.40.50.300:FF:005654', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(192861, NULL, 'G3DSA:3.30.450.260:FF:000001', NULL, NULL, 'guanylate cyclase soluble subunit beta-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(192862, NULL, 'G3DSA:2.60.260.20:FF:000048', NULL, NULL, 'DnaJ family protein', NULL, NULL, NULL, NULL, NULL, 4),
(192863, NULL, 'G3DSA:3.40.50.11320:FF:000010', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192864, NULL, 'G3DSA:2.130.10.10:FF:004979', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192865, NULL, 'G3DSA:2.170.190.11:FF:000014', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(192866, NULL, 'G3DSA:1.10.510.10:FF:004475', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(192867, NULL, 'G3DSA:3.30.160.60:FF:005491', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192868, NULL, 'G3DSA:3.40.33.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192869, NULL, 'G3DSA:2.60.200.40:FF:000045', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(192870, NULL, 'G3DSA:1.10.510.10:FF:001564', NULL, NULL, 'Si:dkey-31m14.7', NULL, NULL, NULL, NULL, NULL, 4),
(192871, NULL, 'G3DSA:3.40.50.720:FF:000193', NULL, NULL, 'UDP-glucose 6-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(192872, NULL, 'G3DSA:3.30.200.20:FF:001441', NULL, NULL, 'TRAF2 and NCK-interacting kinase b', NULL, NULL, NULL, NULL, NULL, 4),
(192873, NULL, 'G3DSA:1.10.10.350:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192874, NULL, 'G3DSA:1.20.1070.10:FF:001958', NULL, NULL, 'Peptide receptor GPCR', NULL, NULL, NULL, NULL, NULL, 4),
(192875, NULL, 'G3DSA:3.30.830.10:FF:000064', NULL, NULL, 'Mitochondrial-processing peptidase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(192876, NULL, 'G3DSA:1.25.10.10:FF:000148', NULL, NULL, 'SIL1 nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(192877, NULL, 'G3DSA:1.10.8.60:FF:000482', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192878, NULL, 'G3DSA:1.10.510.10:FF:002002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192879, NULL, 'G3DSA:1.20.1280.180:FF:000005', NULL, NULL, 'Prx-14', NULL, NULL, NULL, NULL, NULL, 4),
(192880, NULL, 'G3DSA:3.40.1090.10:FF:000099', NULL, NULL, 'Phospholipase A2', NULL, NULL, NULL, NULL, NULL, 4),
(192881, NULL, 'G3DSA:1.20.1560.10:FF:000136', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(192882, NULL, 'G3DSA:3.40.47.10:FF:000182', NULL, NULL, 'Thiolase', NULL, NULL, NULL, NULL, NULL, 4),
(192883, NULL, 'G3DSA:3.30.160.60:FF:001449', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(192884, NULL, 'G3DSA:3.40.50.2000:FF:000666', NULL, NULL, 'Putative glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(192885, NULL, 'G3DSA:2.40.10.190:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192886, NULL, 'G3DSA:3.40.190.10:FF:000219', NULL, NULL, 'ATP phosphoribosyltransferase His1', NULL, NULL, NULL, NULL, NULL, 4),
(192887, NULL, 'G3DSA:1.10.630.10:FF:000420', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192888, NULL, 'G3DSA:3.30.1370.10:FF:000090', NULL, NULL, 'KRR1 small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4),
(192889, NULL, 'G3DSA:1.20.1250.20:FF:001880', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192890, NULL, 'G3DSA:3.40.50.1480:FF:000009', NULL, NULL, 'Adenosylhomocysteinase like 2', NULL, NULL, NULL, NULL, NULL, 4),
(192891, NULL, 'G3DSA:3.80.10.10:FF:001388', NULL, NULL, 'Protein NSP-INTERACTING KINASE 2', NULL, NULL, NULL, NULL, NULL, 4),
(192892, NULL, 'G3DSA:3.40.190.10:FF:000551', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(192893, NULL, 'G3DSA:2.110.10.10:FF:000079', NULL, NULL, 'Matrix metallopeptidase 17b', NULL, NULL, NULL, NULL, NULL, 4),
(192894, NULL, 'G3DSA:2.60.40.60:FF:001031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192895, NULL, 'G3DSA:1.20.5.110:FF:000027', NULL, NULL, 'ras association domain-containing protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(192896, NULL, 'G3DSA:3.30.160.60:FF:001781', NULL, NULL, 'zinc finger protein 496 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(192897, NULL, 'G3DSA:1.25.10.10:FF:001660', NULL, NULL, 'YALI0D05049p', NULL, NULL, NULL, NULL, NULL, 4),
(192898, NULL, 'G3DSA:1.20.1250.20:FF:002280', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192899, NULL, 'G3DSA:1.10.3730.20:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192900, NULL, 'G3DSA:3.30.160.60:FF:004692', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(192901, NULL, 'G3DSA:2.60.40.60:FF:000755', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192902, NULL, 'G3DSA:1.10.10.740:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192903, NULL, 'G3DSA:2.10.25.10:FF:001343', NULL, NULL, 'Fibulin-1', NULL, NULL, NULL, NULL, NULL, 4),
(192904, NULL, 'G3DSA:3.40.1110.10:FF:000271', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192905, NULL, 'G3DSA:3.40.50.300:FF:004693', NULL, NULL, 'ATP-dependent DNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(192906, NULL, 'G3DSA:1.25.40.10:FF:003410', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(192907, NULL, 'G3DSA:2.30.29.110:FF:000004', NULL, NULL, 'Inositol polyphosphate 5-phosphatase OCRL-1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(192908, NULL, 'G3DSA:3.30.160.60:FF:005092', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192909, NULL, 'G3DSA:1.10.420.10:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192910, NULL, 'G3DSA:3.40.50.300:FF:005530', NULL, NULL, 'Ras-related protein Rab-6A', NULL, NULL, NULL, NULL, NULL, 4),
(192911, NULL, 'G3DSA:3.40.430.10:FF:000031', NULL, NULL, 'Riboflavin biosynthesis protein PYRD, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(192912, NULL, 'G3DSA:3.40.50.880:FF:000156', NULL, NULL, 'DUF4434 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(192913, NULL, 'G3DSA:3.30.200.20:FF:001109', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(192914, NULL, 'G3DSA:2.130.10.30:FF:000067', NULL, NULL, 'RCC1 domain-containing protein RUG3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(192915, NULL, 'G3DSA:3.30.300.10:FF:000035', NULL, NULL, 'S-adenosylmethionine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(192916, NULL, 'G3DSA:1.10.10.60:FF:000573', NULL, NULL, 'Transcription factor Rap1, putative (AFU_orthologue AFUA_6G07560)', NULL, NULL, NULL, NULL, NULL, 4),
(192917, NULL, 'G3DSA:3.40.50.300:FF:000983', NULL, NULL, 'Rho family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(192918, NULL, 'G3DSA:3.30.200.20:FF:002402', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192919, NULL, 'G3DSA:4.10.900.10:FF:000008', NULL, NULL, 'Cadherin 5', NULL, NULL, NULL, NULL, NULL, 4),
(192920, NULL, 'G3DSA:1.25.10.10:FF:000709', NULL, NULL, 'HEAT repeat-containing protein 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(192921, NULL, 'G3DSA:2.60.40.10:FF:003186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192922, NULL, 'G3DSA:1.20.1250.20:FF:001329', NULL, NULL, 'Sugar transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(192923, NULL, 'G3DSA:3.30.230.10:FF:000164', NULL, NULL, 'MLH (MutL Homolog) family', NULL, NULL, NULL, NULL, NULL, 4),
(192924, NULL, 'G3DSA:3.90.190.10:FF:000265', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192925, NULL, 'G3DSA:2.40.40.20:FF:000020', NULL, NULL, 'Formate dehydrogenase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(192926, NULL, 'G3DSA:3.30.160.60:FF:003236', NULL, NULL, 'GM11812', NULL, NULL, NULL, NULL, NULL, 4),
(192927, NULL, 'G3DSA:3.30.200.20:FF:000665', NULL, NULL, 'MAP kinase kinase (Pbs2)', NULL, NULL, NULL, NULL, NULL, 4),
(192928, NULL, 'G3DSA:3.40.50.12780:FF:000161', NULL, NULL, 'Putative siderophore synthetase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(192929, NULL, 'G3DSA:1.25.40.10:FF:004135', NULL, NULL, 'U3 small nucleolar RNA-associated protein 6 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(192930, NULL, 'G3DSA:3.90.380.10:FF:000009', NULL, NULL, 'mRNA, clone: RTFL01-01-M20', NULL, NULL, NULL, NULL, NULL, 4),
(192931, NULL, 'G3DSA:1.20.58.1120:FF:000002', NULL, NULL, 'Dynein heavy chain 9, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(192932, NULL, 'G3DSA:2.40.10.10:FF:000498', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192933, NULL, 'G3DSA:3.30.230.130:FF:000019', NULL, NULL, 'Cullin-like protein-like protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(192934, NULL, 'G3DSA:3.60.10.10:FF:000057', NULL, NULL, 'Inositol-1, 4, 5-trisphosphate 5-Phosphatase-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(192935, NULL, 'G3DSA:3.90.550.50:FF:000153', NULL, NULL, 'Fringe-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(192936, NULL, 'G3DSA:3.30.200.20:FF:002273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192937, NULL, 'G3DSA:3.10.400.20:FF:000011', NULL, NULL, 'PUA domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(192938, NULL, 'G3DSA:3.40.50.300:FF:002489', NULL, NULL, 'Small GTP binding protein rab6-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(192939, NULL, 'G3DSA:3.40.50.450:FF:000005', NULL, NULL, 'CASP-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(192940, NULL, 'G3DSA:3.40.50.300:FF:007340', NULL, NULL, 'Probable DNA helicase II homolog', NULL, NULL, NULL, NULL, NULL, 4),
(192941, NULL, 'G3DSA:3.30.420.610:FF:000004', NULL, NULL, 'Meiosis regulator and mRNA stability factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(192942, NULL, 'G3DSA:3.40.309.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192943, NULL, 'G3DSA:3.90.190.10:FF:000309', NULL, NULL, 'Protein CBG09113', NULL, NULL, NULL, NULL, NULL, 4),
(192944, NULL, 'G3DSA:1.25.40.1040:FF:000007', NULL, NULL, 'N-alpha-acetyltransferase 25, NatB auxiliary subunit', NULL, NULL, NULL, NULL, NULL, 4),
(192945, NULL, 'G3DSA:3.30.70.330:FF:002521', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192946, NULL, 'G3DSA:1.50.10.10:FF:000163', NULL, NULL, 'Glucoamylase/glucan 1,4-alpha-glucosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(192947, NULL, 'G3DSA:3.40.50.720:FF:001553', NULL, NULL, 'Probable oxidoreductase (Short-chain dehydrogenase family)', NULL, NULL, NULL, NULL, NULL, 4),
(192948, NULL, 'G3DSA:2.10.25.10:FF:000247', NULL, NULL, 'Delta/notch like EGF repeat containing', NULL, NULL, NULL, NULL, NULL, 4),
(192949, NULL, 'G3DSA:3.90.1170.10:FF:000004', NULL, NULL, '60S ribosomal protein L10 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(192950, NULL, 'G3DSA:3.40.50.720:FF:001070', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(192951, NULL, 'G3DSA:2.40.30.170:FF:000033', NULL, NULL, 'AcrA/AcrE family protein', NULL, NULL, NULL, NULL, NULL, 4),
(192952, NULL, 'G3DSA:3.30.70.260:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192953, NULL, 'G3DSA:1.20.120.2010:FF:000002', NULL, NULL, 'Ci-NAB1/2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(192954, NULL, 'G3DSA:1.25.10.10:FF:003009', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192955, NULL, 'G3DSA:1.20.1250.20:FF:001200', NULL, NULL, 'BcDNA.LD28120', NULL, NULL, NULL, NULL, NULL, 4),
(192956, NULL, 'G3DSA:1.10.8.730:FF:000002', NULL, NULL, 'TrwK protein', NULL, NULL, NULL, NULL, NULL, 4),
(192957, NULL, 'G3DSA:3.40.50.300:FF:002017', NULL, NULL, 'Dynein-related AAA-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(192958, NULL, 'G3DSA:3.40.395.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192959, NULL, 'G3DSA:3.30.70.1400:FF:000022', NULL, NULL, 'Glycine cleavage system T protein', NULL, NULL, NULL, NULL, NULL, 4),
(192960, NULL, 'G3DSA:2.60.40.1730:FF:000024', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(192961, NULL, 'G3DSA:3.10.129.10:FF:000236', NULL, NULL, 'Gll1961 protein', NULL, NULL, NULL, NULL, NULL, 4),
(192962, NULL, 'G3DSA:1.25.40.10:FF:000875', NULL, NULL, 'Pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(192963, NULL, 'G3DSA:3.50.50.60:FF:000698', NULL, NULL, 'Octylphenol 4-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(192964, NULL, 'G3DSA:1.10.510.10:FF:000529', NULL, NULL, 'Kinase non-catalytic C-lobe domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(192965, NULL, 'G3DSA:1.10.510.10:FF:001148', NULL, NULL, 'Alk1p', NULL, NULL, NULL, NULL, NULL, 4),
(192966, NULL, 'G3DSA:1.10.1170.10:FF:000007', NULL, NULL, 'Baculoviral IAP repeat-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(192967, NULL, 'G3DSA:3.30.160.60:FF:005283', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192968, NULL, 'G3DSA:3.30.559.10:FF:000079', NULL, NULL, 'Carnitine palmitoyltransferase 1B', NULL, NULL, NULL, NULL, NULL, 4),
(192969, NULL, 'G3DSA:3.40.50.1820:FF:000302', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(192970, NULL, 'G3DSA:3.50.50.60:FF:000226', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(192971, NULL, 'G3DSA:3.40.50.1010:FF:000032', NULL, NULL, 'Flap endonuclease GEN-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(192972, NULL, 'G3DSA:2.120.10.30:FF:000365', NULL, NULL, 'Acylamino-acid-releasing enzyme, conjectural', NULL, NULL, NULL, NULL, NULL, 4),
(192973, NULL, 'G3DSA:2.40.30.10:FF:000398', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(192974, NULL, 'G3DSA:3.40.50.300:FF:007823', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192975, NULL, 'G3DSA:3.30.70.330:FF:002960', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192976, NULL, 'G3DSA:1.25.10.10:FF:000255', NULL, NULL, 'Telomere-associated protein RIF1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(192977, NULL, 'G3DSA:2.130.10.10:FF:000977', NULL, NULL, 'Transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(192978, NULL, 'G3DSA:2.60.120.620:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192979, NULL, 'G3DSA:2.60.40.10:FF:004698', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192980, NULL, 'G3DSA:3.40.720.10:FF:000014', NULL, NULL, 'Hydrolase, inner membrane', NULL, NULL, NULL, NULL, NULL, 4),
(192981, NULL, 'G3DSA:1.10.472.80:FF:000034', NULL, NULL, 'TBC1 domain family member 5', NULL, NULL, NULL, NULL, NULL, 4),
(192982, NULL, 'G3DSA:1.10.150.910:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192983, NULL, 'G3DSA:2.160.20.10:FF:000162', NULL, NULL, 'Pectin lyase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(192984, NULL, 'G3DSA:3.20.180.20:FF:000013', NULL, NULL, 'Putative dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(192985, NULL, 'G3DSA:2.60.40.10:FF:001033', NULL, NULL, 'Uncharacterized protein, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(192986, NULL, 'G3DSA:1.10.150.210:FF:000003', NULL, NULL, 'Phosphoserine phosphatase SerB', NULL, NULL, NULL, NULL, NULL, 4),
(192987, NULL, 'G3DSA:3.40.50.1000:FF:000175', NULL, NULL, 'Trehalose 6-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(192988, NULL, 'G3DSA:2.30.29.30:FF:000328', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate-binding protein SLM1', NULL, NULL, NULL, NULL, NULL, 4),
(192989, NULL, 'G3DSA:3.40.50.720:FF:000125', NULL, NULL, 'tRNA threonylcarbamoyladenosine dehydratase 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(192990, NULL, 'G3DSA:1.10.287.1890:FF:000001', NULL, NULL, 'tRNA (Adenine(22)-N(1))-methyltransferase TrmK', NULL, NULL, NULL, NULL, NULL, 4),
(192991, NULL, 'G3DSA:2.60.40.10:FF:005524', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192992, NULL, 'G3DSA:3.30.70.330:FF:001532', NULL, NULL, 'Multiple RNA-binding domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(192993, NULL, 'G3DSA:1.20.1270.50:FF:000007', NULL, NULL, 'Cytosolic alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(192994, NULL, 'G3DSA:2.130.10.10:FF:004872', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1', NULL, NULL, NULL, NULL, NULL, 4),
(192995, NULL, 'G3DSA:3.40.800.10:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(192996, NULL, 'G3DSA:3.30.342.10:FF:000019', NULL, NULL, 'DNA polymerase epsilon catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(192997, NULL, 'G3DSA:2.80.10.50:FF:000278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(192998, NULL, 'G3DSA:2.60.40.10:FF:002770', NULL, NULL, 'Glycoside hydrolase family 2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(192999, NULL, 'G3DSA:3.30.420.10:FF:000347', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(193000, NULL, 'G3DSA:3.10.100.10:FF:000272', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193001, NULL, 'G3DSA:2.40.50.100:FF:000230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193002, NULL, 'G3DSA:3.30.1240.10:FF:000041', NULL, NULL, 'Cof-type HAD-IIB family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(193003, NULL, 'G3DSA:3.30.1390.10:FF:000006', NULL, NULL, 'ATP-dependent Clp protease adapter protein CLPS1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(193004, NULL, 'G3DSA:1.20.920.10:FF:000058', NULL, NULL, 'WD40/YVTN repeat-like-containing domain', NULL, NULL, NULL, NULL, NULL, 4),
(193005, NULL, 'G3DSA:2.60.40.10:FF:005215', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193006, NULL, 'G3DSA:3.40.50.620:FF:000197', NULL, NULL, 'Valyl tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(193007, NULL, 'G3DSA:3.30.70.270:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193008, NULL, 'G3DSA:3.30.1490.20:FF:000062', NULL, NULL, 'Endospore coat-associated protein YheC', NULL, NULL, NULL, NULL, NULL, 4),
(193009, NULL, 'G3DSA:3.40.50.300:FF:000691', NULL, NULL, 'Regulator of telomere elongation helicase 1', NULL, NULL, NULL, NULL, NULL, 4),
(193010, NULL, 'G3DSA:1.20.1560.10:FF:000181', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193011, NULL, 'G3DSA:2.60.40.10:FF:001825', NULL, NULL, 'T cell receptor alpha variable 12D-1', NULL, NULL, NULL, NULL, NULL, 4),
(193012, NULL, 'G3DSA:1.25.40.20:FF:000602', NULL, NULL, 'Ankyrin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(193013, NULL, 'G3DSA:2.60.40.10:FF:000853', NULL, NULL, 'NPHS1, nephrin', NULL, NULL, NULL, NULL, NULL, 4),
(193014, NULL, 'G3DSA:2.60.120.290:FF:000014', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(193015, NULL, 'G3DSA:1.10.472.10:FF:000283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193016, NULL, 'G3DSA:3.30.40.10:FF:000498', NULL, NULL, 'Cysteine and histidine rich 1', NULL, NULL, NULL, NULL, NULL, 4),
(193017, NULL, 'G3DSA:1.10.840.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193018, NULL, 'G3DSA:3.40.50.1820:FF:000611', NULL, NULL, 'Kynurenine formamidase', NULL, NULL, NULL, NULL, NULL, 4),
(193019, NULL, 'G3DSA:3.80.10.10:FF:000247', NULL, NULL, 'TLR4 interactor with leucine rich repeats', NULL, NULL, NULL, NULL, NULL, 4),
(193020, NULL, 'G3DSA:1.25.70.10:FF:000101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193021, NULL, 'G3DSA:3.40.50.300:FF:002809', NULL, NULL, 'UvrD/REP helicase N-terminal domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(193022, NULL, 'G3DSA:3.40.850.10:FF:000198', NULL, NULL, 'Putative kinesin', NULL, NULL, NULL, NULL, NULL, 4),
(193023, NULL, 'G3DSA:3.30.260.10:FF:000003', NULL, NULL, 'T-complex protein 1 subunit eta', NULL, NULL, NULL, NULL, NULL, 4),
(193024, NULL, 'G3DSA:1.25.40.10:FF:004770', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193025, NULL, 'G3DSA:2.60.40.10:FF:003607', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193026, NULL, 'G3DSA:2.60.200.20:FF:000207', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193027, NULL, 'G3DSA:3.40.366.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193028, NULL, 'G3DSA:4.10.60.10:FF:000256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193029, NULL, 'G3DSA:3.40.50.1470:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193030, NULL, 'G3DSA:3.90.930.12:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193031, NULL, 'G3DSA:3.40.50.720:FF:002379', NULL, NULL, 'Zinc-type alcohol dehydrogenase-like protein C1198.01', NULL, NULL, NULL, NULL, NULL, 4),
(193032, NULL, 'G3DSA:3.30.200.20:FF:001621', NULL, NULL, 'Wee1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(193033, NULL, 'G3DSA:2.130.10.10:FF:003574', NULL, NULL, 'At2g20330/F11A3.12', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(193034, NULL, 'G3DSA:3.30.465.10:FF:000119', NULL, NULL, 'Putative oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(193035, NULL, 'G3DSA:3.40.140.10:FF:000020', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(193036, NULL, 'G3DSA:1.10.1370.10:FF:000005', NULL, NULL, 'Mitochondrial intermediate peptidase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(193037, NULL, 'G3DSA:3.80.10.10:FF:003653', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(193038, NULL, 'G3DSA:3.50.7.10:FF:000039', NULL, NULL, 'Bardet-Biedl syndrome 10', NULL, NULL, NULL, NULL, NULL, 4),
(193039, NULL, 'G3DSA:3.20.20.100:FF:000129', NULL, NULL, 'NADP(+) coupled glycerol dehydrogenase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(193040, NULL, 'G3DSA:1.10.101.10:FF:000017', NULL, NULL, 'Lytic transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(193041, NULL, 'G3DSA:3.40.50.620:FF:000730', NULL, NULL, 'Glutamate--tRNA ligase chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(193042, NULL, 'G3DSA:3.30.160.60:FF:006272', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193043, NULL, 'G3DSA:2.130.10.10:FF:004563', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193044, NULL, 'G3DSA:3.90.1150.10:FF:000093', NULL, NULL, 'DegT/DnrJ/EryC1/StrS aminotransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(193045, NULL, 'G3DSA:3.40.850.10:FF:000422', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(193046, NULL, 'G3DSA:1.25.10.10:FF:000564', NULL, NULL, 'Probable importin subunit beta-4-like', NULL, NULL, NULL, NULL, NULL, 4),
(193047, NULL, 'G3DSA:1.20.120.1750:FF:000042', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(193048, NULL, 'G3DSA:3.90.70.10:FF:000132', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 32', NULL, NULL, NULL, NULL, NULL, 4),
(193049, NULL, 'G3DSA:3.30.1370.50:FF:000011', NULL, NULL, 'Transcriptional repressor NF-X1', NULL, NULL, NULL, NULL, NULL, 4),
(193050, NULL, 'G3DSA:3.90.180.10:FF:000028', NULL, NULL, 'Probable polyketide synthase 16', NULL, NULL, NULL, NULL, NULL, 4),
(193051, NULL, 'G3DSA:3.40.50.300:FF:005362', NULL, NULL, 'Guanylate-binding family protein', NULL, NULL, NULL, NULL, NULL, 4),
(193052, NULL, 'G3DSA:1.20.1050.80:FF:000011', NULL, NULL, 'VPS9 domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(193053, NULL, 'G3DSA:1.10.3430.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193054, NULL, 'G3DSA:2.40.128.260:FF:000003', NULL, NULL, 'IcmE', NULL, NULL, NULL, NULL, NULL, 4),
(193055, NULL, 'G3DSA:1.10.3330.10:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193056, NULL, 'G3DSA:1.10.132.30:FF:000022', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(193057, NULL, 'G3DSA:3.40.190.170:FF:000001', NULL, NULL, 'TRAP dicarboxylate transporter, DctP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(193058, NULL, 'G3DSA:2.60.40.4330:FF:000001', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(193059, NULL, 'G3DSA:3.60.15.10:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193060, NULL, 'G3DSA:1.25.40.10:FF:003146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193061, NULL, 'G3DSA:1.10.443.10:FF:000007', NULL, NULL, 'Tyrosine recombinase XerC', NULL, NULL, NULL, NULL, NULL, 4),
(193062, NULL, 'G3DSA:3.90.70.10:FF:000587', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193063, NULL, 'G3DSA:1.10.10.10:FF:001081', NULL, NULL, 'Probable methyltransferase/methylase', NULL, NULL, NULL, NULL, NULL, 4),
(193064, NULL, 'G3DSA:1.10.150.50:FF:000081', NULL, NULL, 'EPS8 like 3', NULL, NULL, NULL, NULL, NULL, 4),
(193065, NULL, 'G3DSA:2.70.98.30:FF:000019', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(193066, NULL, 'G3DSA:1.10.287.2250:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(193067, NULL, 'G3DSA:1.10.437.10:FF:000033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(193068, NULL, 'G3DSA:2.40.50.1060:FF:000002', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(193069, NULL, 'G3DSA:3.40.1110.10:FF:000040', NULL, NULL, 'Calcium-transporting ATPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(193070, NULL, 'G3DSA:1.20.80.10:FF:000045', NULL, NULL, 'Kinesin-like calmodulin binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(193071, NULL, 'G3DSA:2.30.280.10:FF:000002', NULL, NULL, 'E3 ubiquitin-protein ligase ORTHRUS 2', NULL, NULL, NULL, NULL, NULL, 4),
(193072, NULL, 'G3DSA:3.40.50.300:FF:003428', NULL, NULL, 'Protein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(193073, NULL, 'G3DSA:1.50.40.10:FF:000311', NULL, NULL, 'Mitochondrial substrate carrier family protein Z', NULL, NULL, NULL, NULL, NULL, 4),
(193074, NULL, 'G3DSA:3.30.160.60:FF:000965', NULL, NULL, 'Neurotrophin receptor-interacting factor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(193075, NULL, 'G3DSA:3.10.50.40:FF:000132', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(193076, NULL, 'G3DSA:2.60.40.690:FF:000001', NULL, NULL, 'PZP, alpha-2-macroglobulin like', NULL, NULL, NULL, NULL, NULL, 4),
(193077, NULL, 'G3DSA:3.30.40.10:FF:000509', NULL, NULL, 'Blast:JmjC domain-containing histone demethylation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(193078, NULL, 'G3DSA:1.20.1250.20:FF:000211', NULL, NULL, 'MFS transporter, metabolite:H+ symporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(193079, NULL, 'G3DSA:3.30.420.110:FF:000079', NULL, NULL, 'DNA mismatch repair protein Msh2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193080, NULL, 'G3DSA:2.130.10.110:FF:000006', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(193081, NULL, 'G3DSA:3.50.30.30:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193082, NULL, 'G3DSA:1.10.8.270:FF:000139', NULL, NULL, 'Protein CBR-RBG-3', NULL, NULL, NULL, NULL, NULL, 4),
(193083, NULL, 'G3DSA:3.40.50.300:FF:001180', NULL, NULL, 'Elongation factor 2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(193084, NULL, 'G3DSA:2.30.29.30:FF:000963', NULL, NULL, 'Sorting nexin-17', NULL, NULL, NULL, NULL, NULL, 4),
(193085, NULL, 'G3DSA:3.30.450.20:FF:000487', NULL, NULL, 'Two-component sensor CbrA', NULL, NULL, NULL, NULL, NULL, 4),
(193086, NULL, 'G3DSA:3.30.1010.10:FF:000102', NULL, NULL, 'VPS34-like PI-3-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(193087, NULL, 'G3DSA:2.120.10.30:FF:000495', NULL, NULL, 'Os01g0698200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(193088, NULL, 'G3DSA:3.40.50.1820:FF:001230', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(193089, NULL, 'G3DSA:1.10.565.10:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193090, NULL, 'G3DSA:1.10.3110.10:FF:000015', NULL, NULL, 'Pcyox1l protein', NULL, NULL, NULL, NULL, NULL, 4),
(193091, NULL, 'G3DSA:3.30.70.1730:FF:000020', NULL, NULL, '50S ribosomal protein L10', NULL, NULL, NULL, NULL, NULL, 4),
(193092, NULL, 'G3DSA:2.130.10.10:FF:000168', NULL, NULL, 'Nucleoporin Nup37', NULL, NULL, NULL, NULL, NULL, 4),
(193093, NULL, 'G3DSA:3.40.50.1820:FF:000741', NULL, NULL, 'Glr4230 protein', NULL, NULL, NULL, NULL, NULL, 4),
(193094, NULL, 'G3DSA:1.10.10.60:FF:000466', NULL, NULL, 'Transcription factor TFIIIB subunit', NULL, NULL, NULL, NULL, NULL, 4),
(193095, NULL, 'G3DSA:2.60.40.10:FF:005996', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193096, NULL, 'G3DSA:3.30.160.60:FF:005636', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193097, NULL, 'G3DSA:1.10.238.10:FF:000929', NULL, NULL, 'Nucleobindin 2a', NULL, NULL, NULL, NULL, NULL, 4),
(193098, NULL, 'G3DSA:3.10.20.30:FF:000094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193099, NULL, 'G3DSA:3.60.40.10:FF:000255', NULL, NULL, 'Os10g0541200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(193100, NULL, 'G3DSA:1.25.40.20:FF:001119', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(193101, NULL, 'G3DSA:2.60.120.650:FF:000026', NULL, NULL, 'Transcription factor jumonji domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(193102, NULL, 'G3DSA:1.10.1530.10:FF:000007', NULL, NULL, 'L-sulfolactate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(193103, NULL, 'G3DSA:1.20.140.10:FF:000066', NULL, NULL, 'GM20419', NULL, NULL, NULL, NULL, NULL, 4),
(193104, NULL, 'G3DSA:2.60.40.10:FF:000044', NULL, NULL, 'Contactin 1', NULL, NULL, NULL, NULL, NULL, 4),
(193105, NULL, 'G3DSA:1.10.10.60:FF:000157', NULL, NULL, 'Myb transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(193106, NULL, 'G3DSA:1.10.150.20:FF:000066', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(193107, NULL, 'G3DSA:3.40.390.10:FF:000179', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193108, NULL, 'G3DSA:3.10.20.90:FF:000858', NULL, NULL, 'IQ and ubiquitin-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(193109, NULL, 'G3DSA:3.40.640.10:FF:000513', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193110, NULL, 'G3DSA:1.25.40.10:FF:004927', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193111, NULL, 'G3DSA:2.60.40.420:FF:000084', NULL, NULL, 'Ceruloplasmin', NULL, NULL, NULL, NULL, NULL, 4),
(193112, NULL, 'G3DSA:1.25.40.180:FF:000319', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193113, NULL, 'G3DSA:3.75.10.10:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193114, NULL, 'G3DSA:3.60.130.10:FF:000015', NULL, NULL, 'Gamma-butyrobetaine dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(193115, NULL, 'G3DSA:3.30.70.330:FF:000913', NULL, NULL, 'Unplaced genomic scaffold supercont1.13, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(193116, NULL, 'G3DSA:3.80.10.10:FF:001545', NULL, NULL, 'CAP-Gly domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(193117, NULL, 'G3DSA:2.60.40.10:FF:005187', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193118, NULL, 'G3DSA:1.20.1110.10:FF:000052', NULL, NULL, 'Sarcoplasmic/endoplasmic reticulum calcium ATPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(193119, NULL, 'G3DSA:3.90.1450.10:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193120, NULL, 'G3DSA:3.90.950.10:FF:000020', NULL, NULL, 'Probable bifunctional dTTP/UTP pyrophosphatase/methyltransferase protein', NULL, NULL, NULL, NULL, NULL, 4),
(193121, NULL, 'G3DSA:1.10.1170.10:FF:000024', NULL, NULL, 'baculoviral IAP repeat-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(193122, NULL, 'G3DSA:3.90.730.10:FF:000037', NULL, NULL, 'Self-incompatibility ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(193123, NULL, 'G3DSA:2.60.120.740:FF:000020', NULL, NULL, 'G-protein coupled receptor protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193124, NULL, 'G3DSA:2.30.29.30:FF:000980', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(193125, NULL, 'G3DSA:3.30.1640.30:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193126, NULL, 'G3DSA:2.60.40.150:FF:000660', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193127, NULL, 'G3DSA:2.10.25.10:FF:001219', NULL, NULL, 'CD248 molecule, endosialin a', NULL, NULL, NULL, NULL, NULL, 4),
(193128, NULL, 'G3DSA:3.10.20.90:FF:000875', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(193129, NULL, 'G3DSA:3.30.40.10:FF:000818', NULL, NULL, 'Sumoylation ligase MMS21', NULL, NULL, NULL, NULL, NULL, 4),
(193130, NULL, 'G3DSA:3.40.50.720:FF:000581', NULL, NULL, 'Ubiquitin-activating enzyme E1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193131, NULL, 'G3DSA:2.130.10.10:FF:003911', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193132, NULL, 'G3DSA:3.40.50.1820:FF:001567', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193133, NULL, 'G3DSA:3.30.200.20:FF:000795', NULL, NULL, 'Myosin light chain kinase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(193134, NULL, 'G3DSA:3.20.20.300:FF:000060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193135, NULL, 'G3DSA:2.60.40.10:FF:003287', NULL, NULL, 'Mcam protein', NULL, NULL, NULL, NULL, NULL, 4),
(193136, NULL, 'G3DSA:2.40.30.10:FF:000089', NULL, NULL, '50S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(193137, NULL, 'G3DSA:3.40.190.10:FF:000214', NULL, NULL, 'Porphobilinogen deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(193138, NULL, 'G3DSA:3.40.50.300:FF:005423', NULL, NULL, 'DNA repair protein RecN', NULL, NULL, NULL, NULL, NULL, 4),
(193139, NULL, 'G3DSA:3.10.129.10:FF:000175', NULL, NULL, 'Mesaconyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(193140, NULL, 'G3DSA:2.60.40.60:FF:000598', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193141, NULL, 'G3DSA:1.10.472.80:FF:000051', NULL, NULL, 'Probable MDR1-Mac1p interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(193142, NULL, 'G3DSA:3.30.70.330:FF:000604', NULL, NULL, 'Splicing factor 3B, subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(193143, NULL, 'G3DSA:3.30.230.10:FF:000294', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(193144, NULL, 'G3DSA:1.20.140.40:FF:000081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193145, NULL, 'G3DSA:3.30.450.40:FF:000173', NULL, NULL, 'Phosphoenolpyruvate-protein phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(193146, NULL, 'G3DSA:1.10.3860.10:FF:000010', NULL, NULL, 'Amino acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(193147, NULL, 'G3DSA:3.40.20.10:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193148, NULL, 'G3DSA:2.30.30.140:FF:000302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193149, NULL, 'G3DSA:3.90.1150.10:FF:000121', NULL, NULL, 'Phosphoserine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(193150, NULL, 'G3DSA:1.10.720.30:FF:000080', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(193151, NULL, 'G3DSA:1.10.3170.10:FF:000007', NULL, NULL, 'UvrD/REP helicase N-terminal domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(193152, NULL, 'G3DSA:3.30.160.60:FF:005153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193153, NULL, 'G3DSA:1.20.1070.10:FF:000256', NULL, NULL, 'Adhesion G protein-coupled receptor G7', NULL, NULL, NULL, NULL, NULL, 4),
(193154, NULL, 'G3DSA:1.20.1250.20:FF:001981', NULL, NULL, 'Solute carrier family 22 member 7', NULL, NULL, NULL, NULL, NULL, 4),
(193155, NULL, 'G3DSA:3.30.160.60:FF:002747', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193156, NULL, 'G3DSA:3.30.200.20:FF:000356', NULL, NULL, 'WEE protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(193157, NULL, 'G3DSA:2.60.40.60:FF:000418', NULL, NULL, 'Cadherin 16, KSP-cadherin', NULL, NULL, NULL, NULL, NULL, 4),
(193158, NULL, 'G3DSA:2.60.200.20:FF:000196', NULL, NULL, 'FHA domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(193159, NULL, 'G3DSA:1.10.150.20:FF:000083', NULL, NULL, 'Putative DNA polymerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(193160, NULL, 'G3DSA:3.50.4.10:FF:000016', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(193161, NULL, 'G3DSA:1.20.1250.20:FF:000711', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(193162, NULL, 'G3DSA:2.10.25.10:FF:001399', NULL, NULL, 'Drosophila CRumBs homolog', NULL, NULL, NULL, NULL, NULL, 4),
(193163, NULL, 'G3DSA:3.20.20.80:FF:000344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193164, NULL, 'G3DSA:1.10.418.20:FF:000014', NULL, NULL, 'Related to protease ULP2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(193165, NULL, 'G3DSA:1.25.40.10:FF:005063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193166, NULL, 'G3DSA:3.20.20.70:FF:000206', NULL, NULL, '4-hydroxy-tetrahydrodipicolinate synthase 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(193167, NULL, 'G3DSA:2.20.25.30:FF:000016', NULL, NULL, '60S ribosomal protein L37', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(193168, NULL, 'G3DSA:3.30.40.10:FF:001987', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193169, NULL, 'G3DSA:3.40.50.1000:FF:000484', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193170, NULL, 'G3DSA:3.30.420.40:FF:000345', NULL, NULL, 'Conserved hypothetical proline rich protein', NULL, NULL, NULL, NULL, NULL, 4),
(193171, NULL, 'G3DSA:3.80.10.10:FF:002164', NULL, NULL, 'AGAP003930-PA', NULL, NULL, NULL, NULL, NULL, 4),
(193172, NULL, 'G3DSA:1.10.555.10:FF:000161', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193173, NULL, 'G3DSA:3.40.50.300:FF:001528', NULL, NULL, 'ATP-dependent RNA helicase YTHDC2', NULL, NULL, NULL, NULL, NULL, 4),
(193174, NULL, 'G3DSA:3.30.1390.20:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193175, NULL, 'G3DSA:3.30.497.10:FF:000007', NULL, NULL, 'Serpin peptidase inhibitor clade H member 1', NULL, NULL, NULL, NULL, NULL, 4),
(193176, NULL, 'G3DSA:1.10.10.10:FF:000945', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(193177, NULL, 'G3DSA:1.25.40.10:FF:001364', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(193178, NULL, 'G3DSA:3.40.50.12500:FF:000004', NULL, NULL, 'Dcg1p', NULL, NULL, NULL, NULL, NULL, 4),
(193179, NULL, 'G3DSA:2.70.70.10:FF:000040', NULL, NULL, 'Peptidase, M23/M37 family', NULL, NULL, NULL, NULL, NULL, 4),
(193180, NULL, 'G3DSA:1.25.40.10:FF:004118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193181, NULL, 'G3DSA:1.20.58.1420:FF:000002', NULL, NULL, 'Protein transport protein TIP20', NULL, NULL, NULL, NULL, NULL, 4),
(193182, NULL, 'G3DSA:1.20.1250.20:FF:002009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193183, NULL, 'G3DSA:2.60.40.10:FF:003742', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193184, NULL, 'G3DSA:3.30.160.60:FF:004355', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193185, NULL, 'G3DSA:1.25.40.10:FF:002218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193186, NULL, 'G3DSA:3.30.160.60:FF:001893', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193187, NULL, 'G3DSA:3.10.20.90:FF:001022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193188, NULL, 'G3DSA:3.40.50.300:FF:006042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193189, NULL, 'G3DSA:3.30.9.10:FF:000201', NULL, NULL, 'Dimethylglycine dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(193190, NULL, 'G3DSA:3.30.40.10:FF:001807', NULL, NULL, 'Putative U-box domain-containing protein 47', NULL, NULL, NULL, NULL, NULL, 4),
(193191, NULL, 'G3DSA:2.10.60.10:FF:000025', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(193192, NULL, 'G3DSA:3.40.50.300:FF:000202', NULL, NULL, 'ras-related protein Rab-8A', NULL, NULL, NULL, NULL, NULL, 4),
(193193, NULL, 'G3DSA:2.40.50.140:FF:000455', NULL, NULL, 'Replication Factor A 28 kDa subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193194, NULL, 'G3DSA:3.40.1110.10:FF:000170', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(193195, NULL, 'G3DSA:3.30.160.60:FF:001921', NULL, NULL, 'Putative transcription factor Ovo-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(193196, NULL, 'G3DSA:2.130.10.10:FF:005709', NULL, NULL, 'phosphoinositide 3-kinase regulatory subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(193197, NULL, 'G3DSA:1.10.10.60:FF:001085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193198, NULL, 'G3DSA:1.10.520.10:FF:000002', NULL, NULL, 'Catalase-peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(193199, NULL, 'G3DSA:1.10.510.10:FF:002637', NULL, NULL, 'Si:ch211-22d5.2', NULL, NULL, NULL, NULL, NULL, 4),
(193200, NULL, 'G3DSA:1.10.30.10:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193201, NULL, 'G3DSA:3.40.1190.20:FF:000211', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(193202, NULL, 'G3DSA:1.10.630.10:FF:000095', NULL, NULL, 'Lanosterol 14-alpha-demethylase', NULL, NULL, NULL, NULL, NULL, 4),
(193203, NULL, 'G3DSA:3.40.50.300:FF:001972', NULL, NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(193204, NULL, 'G3DSA:1.20.1250.20:FF:000109', NULL, NULL, 'Putative vesicular acetylcholine transporter', NULL, NULL, NULL, NULL, NULL, 4),
(193205, NULL, 'G3DSA:3.30.1370.10:FF:000095', NULL, NULL, 'Exosome complex component Rrp4', NULL, NULL, NULL, NULL, NULL, 4),
(193206, NULL, 'G3DSA:1.10.1040.50:FF:000004', NULL, NULL, 'Peroxisomal fatty acid beta-oxidation multifunctional protein', NULL, NULL, NULL, NULL, NULL, 4),
(193207, NULL, 'G3DSA:3.20.20.70:FF:000678', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193208, NULL, 'G3DSA:1.20.920.20:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193209, NULL, 'G3DSA:2.60.40.1730:FF:000007', NULL, NULL, 'thyrotropin-releasing hormone-degrading ectoenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(193210, NULL, 'G3DSA:3.30.160.60:FF:002410', NULL, NULL, 'Zinc finger protein 354C', NULL, NULL, NULL, NULL, NULL, 4),
(193211, NULL, 'G3DSA:1.25.40.10:FF:001701', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(193212, NULL, 'G3DSA:2.60.120.330:FF:000015', NULL, NULL, 'Protein DMR6-LIKE OXYGENASE 1', NULL, NULL, NULL, NULL, NULL, 4),
(193213, NULL, 'G3DSA:3.40.50.620:FF:000421', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(193214, NULL, 'G3DSA:3.10.129.10:FF:000253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193215, NULL, 'G3DSA:1.25.10.10:FF:000917', NULL, NULL, 'EXPOrtin (Nuclear export receptor)', NULL, NULL, NULL, NULL, NULL, 4),
(193216, NULL, 'G3DSA:2.30.30.100:FF:000094', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm7p', NULL, NULL, NULL, NULL, NULL, 4),
(193217, NULL, 'G3DSA:3.40.50.2300:FF:000536', NULL, NULL, 'Catabolite control protein A', NULL, NULL, NULL, NULL, NULL, 4),
(193218, NULL, 'G3DSA:1.20.1050.10:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193219, NULL, 'G3DSA:2.30.42.10:FF:000477', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193220, NULL, 'G3DSA:3.40.50.720:FF:000434', NULL, NULL, 'NADPH-dependent pterin aldehyde reductase', NULL, NULL, NULL, NULL, NULL, 4),
(193221, NULL, 'G3DSA:1.20.58.60:FF:000328', NULL, NULL, 'Spectrin beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(193222, NULL, 'G3DSA:3.40.50.2000:FF:000475', NULL, NULL, 'Trehalose phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(193223, NULL, 'G3DSA:1.10.8.10:FF:000063', NULL, NULL, 'DNA polymerase III subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(193224, NULL, 'G3DSA:3.50.50.60:FF:001215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193225, NULL, 'G3DSA:1.20.1250.20:FF:002026', NULL, NULL, 'Drug resistance protein, conjectural', NULL, NULL, NULL, NULL, NULL, 4),
(193226, NULL, 'G3DSA:3.60.10.10:FF:000427', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193227, NULL, 'G3DSA:3.40.50.410:FF:000004', NULL, NULL, 'collagen alpha-6(VI) chain', NULL, NULL, NULL, NULL, NULL, 4),
(193228, NULL, 'G3DSA:1.25.40.270:FF:000004', NULL, NULL, 'Vacuolar protein sorting-associated protein VTA1', NULL, NULL, NULL, NULL, NULL, 4),
(193229, NULL, 'G3DSA:2.40.50.140:FF:001074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193230, NULL, 'G3DSA:1.20.120.350:FF:000250', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193231, NULL, 'G3DSA:2.120.10.80:FF:000094', NULL, NULL, 'Rab9 effector protein with kelch motifs', NULL, NULL, NULL, NULL, NULL, 4),
(193232, NULL, 'G3DSA:1.25.10.70:FF:000003', NULL, NULL, 'Nuclear pore complex protein Nup188', NULL, NULL, NULL, NULL, NULL, 4),
(193233, NULL, 'G3DSA:1.10.10.10:FF:001564', NULL, NULL, 'Phosphoserine phosphatase RsbU', NULL, NULL, NULL, NULL, NULL, 4),
(193234, NULL, 'G3DSA:1.20.190.20:FF:000004', NULL, NULL, '14-3-3 protein gamma', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(193235, NULL, 'G3DSA:1.10.490.10:FF:000004', NULL, NULL, 'Group 2 hemoglobin yjbI', NULL, NULL, NULL, NULL, NULL, 4),
(193236, NULL, 'G3DSA:1.10.1070.11:FF:000057', NULL, NULL, 'PIKK family atypical protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(193237, NULL, 'G3DSA:3.40.50.10490:FF:000047', NULL, NULL, 'MurR/RpiR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(193238, NULL, 'G3DSA:3.30.60.90:FF:000006', NULL, NULL, 'E3 ubiquitin-protein ligase HERC2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(193239, NULL, 'G3DSA:3.30.160.60:FF:001258', NULL, NULL, 'Uncharacterized protein TCIL3000_10_13860', NULL, NULL, NULL, NULL, NULL, 4),
(193240, NULL, 'G3DSA:2.130.10.10:FF:001096', NULL, NULL, 'WD repeat-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193241, NULL, 'G3DSA:3.30.870.10:FF:000167', NULL, NULL, 'Probable CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(193242, NULL, 'G3DSA:2.40.70.10:FF:000535', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193243, NULL, 'G3DSA:1.10.1200.10:FF:000106', NULL, NULL, 'PKS-NRPS hybrid synthetase psoA', NULL, NULL, NULL, NULL, NULL, 4),
(193244, NULL, 'G3DSA:3.90.550.10:FF:000591', NULL, NULL, 'N-acetylgalactosaminyl transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193245, NULL, 'G3DSA:1.25.40.10:FF:002853', NULL, NULL, 'PsbD mRNA maturation factor Nac2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(193246, NULL, 'G3DSA:1.50.10.20:FF:000020', NULL, NULL, 'Complement C5', NULL, NULL, NULL, NULL, NULL, 4),
(193247, NULL, 'G3DSA:3.40.30.10:FF:000222', NULL, NULL, 'Protein URE2', NULL, NULL, NULL, NULL, NULL, 4),
(193248, NULL, 'G3DSA:1.10.287.110:FF:000101', NULL, NULL, 'DNAJ heat shock N-terminal domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(193249, NULL, 'G3DSA:3.40.1090.10:FF:000026', NULL, NULL, 'Phospholipase A2', NULL, NULL, NULL, NULL, NULL, 4),
(193250, NULL, 'G3DSA:2.60.40.10:FF:005979', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193251, NULL, 'G3DSA:1.25.40.20:FF:001721', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193252, NULL, 'G3DSA:1.10.510.10:FF:004363', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193253, NULL, 'G3DSA:1.20.140.10:FF:000083', NULL, NULL, 'Acyl-CoA dehydrogenase, C-terminal domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(193254, NULL, 'G3DSA:3.30.160.60:FF:004664', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193255, NULL, 'G3DSA:2.60.260.20:FF:000172', NULL, NULL, 'DnaJ domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(193256, NULL, 'G3DSA:1.20.58.60:FF:000171', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(193257, NULL, 'G3DSA:2.170.150.10:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193258, NULL, 'G3DSA:3.30.160.20:FF:000077', NULL, NULL, 'Ribonuclease 3', NULL, NULL, NULL, NULL, NULL, 4),
(193259, NULL, 'G3DSA:1.20.5.110:FF:000218', NULL, NULL, 'Synaptosome-associated protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(193260, NULL, 'G3DSA:1.20.1080.10:FF:000071', NULL, NULL, 'Aquaporin', NULL, NULL, NULL, NULL, NULL, 4),
(193261, NULL, 'G3DSA:1.25.10.10:FF:002481', NULL, NULL, 'Exportin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193262, NULL, 'G3DSA:3.30.1060.10:FF:000004', NULL, NULL, 'Peptide methionine sulfoxide reductase A5', NULL, NULL, NULL, NULL, NULL, 4),
(193263, NULL, 'G3DSA:3.20.10.10:FF:000047', NULL, NULL, 'Methionine aminotransferase BCAT4', NULL, NULL, NULL, NULL, NULL, 4),
(193264, NULL, 'G3DSA:1.10.8.60:FF:000307', NULL, NULL, 'AAA family ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193265, NULL, 'G3DSA:3.60.40.10:FF:000238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193266, NULL, 'G3DSA:1.10.10.10:FF:000928', NULL, NULL, 'Regulatory protein RecX', NULL, NULL, NULL, NULL, NULL, 4),
(193267, NULL, 'G3DSA:2.40.180.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(193268, NULL, 'G3DSA:1.10.287.130:FF:000107', NULL, NULL, 'Sensor histidine kinase YycG', NULL, NULL, NULL, NULL, NULL, 4),
(193269, NULL, 'G3DSA:2.30.30.100:FF:000077', NULL, NULL, 'Scd6p', NULL, NULL, NULL, NULL, NULL, 4),
(193270, NULL, 'G3DSA:3.30.780.10:FF:000031', NULL, NULL, 'Translation initiation factor', NULL, NULL, NULL, NULL, NULL, 4),
(193271, NULL, 'G3DSA:3.40.950.10:FF:000014', NULL, NULL, 'Probable cytosolic Fe-S cluster assembly factor oxy-4', NULL, NULL, NULL, NULL, NULL, 4),
(193272, NULL, 'G3DSA:2.60.40.10:FF:004568', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193273, NULL, 'G3DSA:2.130.10.10:FF:001657', NULL, NULL, 'Periodic tryptophan protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(193274, NULL, 'G3DSA:1.10.20.10:FF:000238', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193275, NULL, 'G3DSA:1.10.287.70:FF:000218', NULL, NULL, 'Putative potassium channel subunit n2P17m2-1', NULL, NULL, NULL, NULL, NULL, 4),
(193276, NULL, 'G3DSA:2.40.50.140:FF:000585', NULL, NULL, '40S ribosomal protein S23-2', NULL, NULL, NULL, NULL, NULL, 4),
(193277, NULL, 'G3DSA:3.90.1150.10:FF:000430', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193278, NULL, 'G3DSA:3.10.20.410:FF:000011', NULL, NULL, 'Outer membrane usher protein PapC', NULL, NULL, NULL, NULL, NULL, 4),
(193279, NULL, 'G3DSA:2.30.29.30:FF:001008', NULL, NULL, 'Exocyst complex component EXO84', NULL, NULL, NULL, NULL, NULL, 4),
(193280, NULL, 'G3DSA:3.30.40.10:FF:001015', NULL, NULL, 'FHA domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(193281, NULL, 'G3DSA:1.10.630.10:FF:000656', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(193282, NULL, 'G3DSA:1.10.472.10:FF:000636', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193283, NULL, 'G3DSA:3.30.920.10:FF:000020', NULL, NULL, 'Frataxin homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(193284, NULL, 'G3DSA:1.25.40.10:FF:000392', NULL, NULL, 'Tetratricopeptide repeat domain 21A', NULL, NULL, NULL, NULL, NULL, 4),
(193285, NULL, 'G3DSA:3.30.260.10:FF:000020', NULL, NULL, 'T-complex protein 1 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(193286, NULL, 'G3DSA:3.30.70.330:FF:002858', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193287, NULL, 'G3DSA:3.30.70.330:FF:002297', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193288, NULL, 'G3DSA:3.40.630.30:FF:000081', NULL, NULL, 'Acetoin utilization protein AcuA', NULL, NULL, NULL, NULL, NULL, 4),
(193289, NULL, 'G3DSA:3.50.50.60:FF:000726', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(193290, NULL, 'G3DSA:3.30.470.20:FF:000078', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(193291, NULL, 'G3DSA:1.10.20.10:FF:000210', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193292, NULL, 'G3DSA:3.90.930.12:FF:000004', NULL, NULL, '60S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(193293, NULL, 'G3DSA:3.30.200.20:FF:001284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193294, NULL, 'G3DSA:1.20.1540.10:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193295, NULL, 'G3DSA:3.60.21.10:FF:000346', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(193296, NULL, 'G3DSA:2.130.10.10:FF:003602', NULL, NULL, 'AGAP006036-PA', NULL, NULL, NULL, NULL, NULL, 4),
(193297, NULL, 'G3DSA:2.30.42.10:FF:000038', NULL, NULL, 'Multiple PDZ domain protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(193298, NULL, 'G3DSA:2.60.40.2030:FF:000002', NULL, NULL, 'sodium/calcium exchanger 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(193299, NULL, 'G3DSA:4.10.240.10:FF:000036', NULL, NULL, 'Unplaced genomic scaffold supercont2.3, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(193300, NULL, 'G3DSA:3.40.50.720:FF:001053', NULL, NULL, 'GDP-mannose 4,6 dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(193301, NULL, 'G3DSA:1.10.1450.10:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(193302, NULL, 'G3DSA:1.10.8.140:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193303, NULL, 'G3DSA:2.10.25.10:FF:001528', NULL, NULL, 'Notch homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(193304, NULL, 'G3DSA:3.40.225.10:FF:000060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193305, NULL, 'G3DSA:3.30.300.30:FF:000069', NULL, NULL, 'Nonribosomal peptide synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(193306, NULL, 'G3DSA:3.30.160.60:FF:003719', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193307, NULL, 'G3DSA:1.10.2000.10:FF:000012', NULL, NULL, 'Carboxypeptidase Z', NULL, NULL, NULL, NULL, NULL, 4),
(193308, NULL, 'G3DSA:3.20.110.10:FF:000045', NULL, NULL, 'Mannosidase, alpha, class 2B, member 1', NULL, NULL, NULL, NULL, NULL, 4),
(193309, NULL, 'G3DSA:3.10.450.10:FF:000056', NULL, NULL, 'Kininogen 1', NULL, NULL, NULL, NULL, NULL, 4),
(193310, NULL, 'G3DSA:3.40.50.720:FF:000564', NULL, NULL, 'Short-chain type dehydrogenase/reductase', NULL, NULL, NULL, NULL, NULL, 4),
(193311, NULL, 'G3DSA:3.40.50.2300:FF:000666', NULL, NULL, 'Lysine decarboxylase, constitutive', NULL, NULL, NULL, NULL, NULL, 4),
(193312, NULL, 'G3DSA:3.30.930.10:FF:000105', NULL, NULL, 'Threonyl-tRNA synthetase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(193313, NULL, 'G3DSA:3.50.50.60:FF:001524', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193314, NULL, 'G3DSA:1.10.418.20:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193315, NULL, 'G3DSA:3.40.190.10:FF:000394', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(193316, NULL, 'G3DSA:1.25.10.10:FF:001536', NULL, NULL, 'V-type proton ATPase subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(193317, NULL, 'G3DSA:2.60.98.20:FF:000011', NULL, NULL, 'Flagellar hook protein FlgE', NULL, NULL, NULL, NULL, NULL, 4),
(193318, NULL, 'G3DSA:3.40.50.2300:FF:001155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193319, NULL, 'G3DSA:1.20.1250.20:FF:002156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193320, NULL, 'G3DSA:1.25.40.10:FF:000083', NULL, NULL, 'calcineurin-binding protein cabin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(193321, NULL, 'G3DSA:3.30.70.330:FF:002830', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193322, NULL, 'G3DSA:3.40.50.1100:FF:000087', NULL, NULL, 'Cysteine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(193323, NULL, 'G3DSA:3.30.160.60:FF:002438', NULL, NULL, 'Paternally expressed 3', NULL, NULL, NULL, NULL, NULL, 4),
(193324, NULL, 'G3DSA:3.40.50.300:FF:004389', NULL, NULL, 'Probable thymidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(193325, NULL, 'G3DSA:1.10.287.310:FF:000009', NULL, NULL, 'LSU ribosomal protein L29P', NULL, NULL, NULL, NULL, NULL, 4),
(193326, NULL, 'G3DSA:3.40.50.720:FF:001845', NULL, NULL, 'Ubiquitin activating enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193327, NULL, 'G3DSA:3.40.50.2300:FF:001172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193328, NULL, 'G3DSA:3.40.720.10:FF:000205', NULL, NULL, 'Metalloenzyme domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(193329, NULL, 'G3DSA:2.40.50.140:FF:001102', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193330, NULL, 'G3DSA:1.10.1200.120:FF:000003', NULL, NULL, 'Large-conductance mechanosensitive channel', NULL, NULL, NULL, NULL, NULL, 4),
(193331, NULL, 'G3DSA:3.40.50.10810:FF:000065', NULL, NULL, 'SNF2 DNA repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193332, NULL, 'G3DSA:2.40.10.480:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193333, NULL, 'G3DSA:2.120.10.30:FF:000556', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193334, NULL, 'G3DSA:1.20.120.1770:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193335, NULL, 'G3DSA:2.30.30.70:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(193336, NULL, 'G3DSA:3.40.50.2000:FF:000683', NULL, NULL, 'Glycosyl transferase group 1', NULL, NULL, NULL, NULL, NULL, 4),
(193337, NULL, 'G3DSA:1.25.40.10:FF:003281', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g48250, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(193338, NULL, 'G3DSA:1.10.510.10:FF:002429', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193339, NULL, 'G3DSA:3.30.420.40:FF:000654', NULL, NULL, 'YALI0B10538p', NULL, NULL, NULL, NULL, NULL, 4),
(193340, NULL, 'G3DSA:2.130.10.130:FF:000001', NULL, NULL, 'Integrin subunit alpha 10', NULL, NULL, NULL, NULL, NULL, 4),
(193341, NULL, 'G3DSA:2.70.70.10:FF:000023', NULL, NULL, 'Peptidase, M23 family', NULL, NULL, NULL, NULL, NULL, 4),
(193342, NULL, 'G3DSA:1.10.287.130:FF:000079', NULL, NULL, 'Unplaced genomic scaffold supercont1.240, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(193343, NULL, 'G3DSA:1.20.5.170:FF:000101', NULL, NULL, 'BZIP transcription factor HacA', NULL, NULL, NULL, NULL, NULL, 4),
(193344, NULL, 'G3DSA:3.40.140.10:FF:000048', NULL, NULL, 'CysO-cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(193345, NULL, 'G3DSA:3.40.50.300:FF:008088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193346, NULL, 'G3DSA:3.40.50.360:FF:000085', NULL, NULL, 'NAD(P)H-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(193347, NULL, 'G3DSA:2.40.240.130:FF:000003', NULL, NULL, 'Dixin isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(193348, NULL, 'G3DSA:1.10.10.1620:FF:000003', NULL, NULL, 'Amine oxidase, flavin-containing', NULL, NULL, NULL, NULL, NULL, 4),
(193349, NULL, 'G3DSA:3.30.450.60:FF:000049', NULL, NULL, 'Ap-3 complex subunit sigma, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193350, NULL, 'G3DSA:2.30.42.10:FF:000055', NULL, NULL, 'PDZ and LIM domain protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(193351, NULL, 'G3DSA:2.60.40.60:FF:000727', NULL, NULL, 'Cdh-4', NULL, NULL, NULL, NULL, NULL, 4),
(193352, NULL, 'G3DSA:2.40.420.20:FF:000060', NULL, NULL, 'Cation efflux system (CzcB-like)', NULL, NULL, NULL, NULL, NULL, 4),
(193353, NULL, 'G3DSA:3.40.190.10:FF:000523', NULL, NULL, 'Tungstate ABC transporter, periplasmic tungstate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(193354, NULL, 'G3DSA:2.130.10.10:FF:002877', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(193355, NULL, 'G3DSA:2.30.110.10:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193356, NULL, 'G3DSA:2.30.110.10:FF:000002', NULL, NULL, 'FMN reductase (NADH) RutF', NULL, NULL, NULL, NULL, NULL, 4),
(193357, NULL, 'G3DSA:1.20.1160.11:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193358, NULL, 'G3DSA:1.10.630.10:FF:000347', NULL, NULL, 'Uncharacterized loc100145084', NULL, NULL, NULL, NULL, NULL, 4),
(193359, NULL, 'G3DSA:1.20.1070.10:FF:002173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193360, NULL, 'G3DSA:1.10.238.10:FF:000267', NULL, NULL, 'Myosin light chain alkali', NULL, NULL, NULL, NULL, NULL, 4),
(193361, NULL, 'G3DSA:3.70.10.10:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193362, NULL, 'G3DSA:2.130.10.10:FF:005148', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(193363, NULL, 'G3DSA:3.30.160.60:FF:000302', NULL, NULL, 'Spalt-like transcription factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(193364, NULL, 'G3DSA:3.40.50.410:FF:000235', NULL, NULL, 'DumPY: shorter than wild-type', NULL, NULL, NULL, NULL, NULL, 4),
(193365, NULL, 'G3DSA:1.20.5.190:FF:000107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193366, NULL, 'G3DSA:1.10.630.10:FF:000448', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193367, NULL, 'G3DSA:2.30.40.10:FF:000124', NULL, NULL, 'Imidazolonepropionase', NULL, NULL, NULL, NULL, NULL, 4),
(193368, NULL, 'G3DSA:1.25.10.10:FF:003189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(193369, NULL, 'G3DSA:1.25.40.80:FF:000013', NULL, NULL, 'Deoxyribodipyrimidine photolyase, type II', NULL, NULL, NULL, NULL, NULL, 4),
(193370, NULL, 'G3DSA:2.60.40.150:FF:000188', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(193371, NULL, 'G3DSA:3.30.470.20:FF:000050', NULL, NULL, 'Acid phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193372, NULL, 'G3DSA:3.80.10.10:FF:000909', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(193373, NULL, 'G3DSA:3.40.630.30:FF:000125', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(193374, NULL, 'G3DSA:1.20.1560.10:FF:000681', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193375, NULL, 'G3DSA:2.120.10.80:FF:000369', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193376, NULL, 'G3DSA:2.60.40.10:FF:002798', NULL, NULL, 'Periplasmic beta-glucosidase, xylosidase/arabinosidase', NULL, NULL, NULL, NULL, NULL, 4),
(193377, NULL, 'G3DSA:3.30.200.20:FF:001104', NULL, NULL, 'Acr-10', NULL, NULL, NULL, NULL, NULL, 4),
(193378, NULL, 'G3DSA:3.10.50.30:FF:000011', NULL, NULL, 'Transcription elongation factor', NULL, NULL, NULL, NULL, NULL, 4),
(193379, NULL, 'G3DSA:2.60.120.620:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193380, NULL, 'G3DSA:3.90.1410.10:FF:000012', NULL, NULL, 'Protein SET DOMAIN GROUP 40', NULL, NULL, NULL, NULL, NULL, 4),
(193381, NULL, 'G3DSA:3.80.10.10:FF:001528', NULL, NULL, 'Si:ch211-214b16.4', NULL, NULL, NULL, NULL, NULL, 4),
(193382, NULL, 'G3DSA:3.80.10.10:FF:000808', NULL, NULL, 'F-box/LRR-repeat protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(193383, NULL, 'G3DSA:3.40.50.150:FF:000685', NULL, NULL, 'Methyltransferase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(193384, NULL, 'G3DSA:1.20.200.10:FF:000037', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(193385, NULL, 'G3DSA:2.130.10.10:FF:003383', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193386, NULL, 'G3DSA:3.30.40.10:FF:000161', NULL, NULL, 'Vacuolar protein sorting-associated protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(193387, NULL, 'G3DSA:3.40.50.2300:FF:000767', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193388, NULL, 'G3DSA:3.40.50.300:FF:005923', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193389, NULL, 'G3DSA:2.130.10.10:FF:001449', NULL, NULL, 'WD domain, G-beta repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(193390, NULL, 'G3DSA:1.10.3210.10:FF:000079', NULL, NULL, 'Metal dependent phosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(193391, NULL, 'G3DSA:3.40.30.10:FF:000800', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193392, NULL, 'G3DSA:1.10.730.20:FF:000032', NULL, NULL, 'Probable isoleucine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(193393, NULL, 'G3DSA:3.40.33.10:FF:000144', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(193394, NULL, 'G3DSA:1.25.40.10:FF:000728', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(193395, NULL, 'G3DSA:1.10.275.20:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193396, NULL, 'G3DSA:1.25.40.10:FF:002870', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(193397, NULL, 'G3DSA:2.170.140.10:FF:000010', NULL, NULL, 'Gasp, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(193398, NULL, 'G3DSA:3.30.2090.10:FF:000006', NULL, NULL, 'Multidrug resistance protein MdtB', NULL, NULL, NULL, NULL, NULL, 4),
(193399, NULL, 'G3DSA:1.10.10.10:FF:000283', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(193400, NULL, 'G3DSA:1.10.10.10:FF:000867', NULL, NULL, 'Beta-lactamase-like protein 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(193401, NULL, 'G3DSA:3.40.50.300:FF:006643', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(193402, NULL, 'G3DSA:4.10.60.10:FF:000273', NULL, NULL, 'Replication protein A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(193403, NULL, 'G3DSA:2.30.30.30:FF:000045', NULL, NULL, '50S ribosomal protein L14e', NULL, NULL, NULL, NULL, NULL, 4),
(193404, NULL, 'G3DSA:1.10.1080.10:FF:000017', NULL, NULL, 'Eukaryotic glutathione synthase', NULL, NULL, NULL, NULL, NULL, 4),
(193405, NULL, 'G3DSA:3.80.10.10:FF:003670', NULL, NULL, 'ELRR (Extracellular Leucine-Rich Repeat) ONly', NULL, NULL, NULL, NULL, NULL, 4),
(193406, NULL, 'G3DSA:1.10.150.810:FF:000003', NULL, NULL, 'DNA polymerase kappa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(193407, NULL, 'G3DSA:3.40.30.10:FF:000694', NULL, NULL, 'Endoplasmic reticulum protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(193408, NULL, 'G3DSA:2.130.10.10:FF:003703', NULL, NULL, 'TAF (TBP-associated transcription factor) family', NULL, NULL, NULL, NULL, NULL, 4),
(193409, NULL, 'G3DSA:2.60.450.10:FF:000009', NULL, NULL, 'LPS-assembly protein LptD', NULL, NULL, NULL, NULL, NULL, 4),
(193410, NULL, 'G3DSA:3.90.550.10:FF:000383', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(193411, NULL, 'G3DSA:2.40.50.140:FF:000910', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193412, NULL, 'G3DSA:3.20.20.70:FF:000650', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193413, NULL, 'G3DSA:3.30.1420.10:FF:000004', NULL, NULL, 'Sulfite reductase, dissimilatory-type gamma subunit', NULL, NULL, NULL, NULL, NULL, 4),
(193414, NULL, 'G3DSA:3.40.50.720:FF:002351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193415, NULL, 'G3DSA:1.25.10.10:FF:002834', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193416, NULL, 'G3DSA:2.40.70.10:FF:000283', NULL, NULL, 'Eukaryotic aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(193417, NULL, 'G3DSA:1.20.1250.20:FF:001964', NULL, NULL, 'Uncharacterized MFS-type transporter SPBC409.08', NULL, NULL, NULL, NULL, NULL, 4),
(193418, NULL, 'G3DSA:2.40.50.700:FF:000005', NULL, NULL, 'DIS3-like exonuclease 2', NULL, NULL, NULL, NULL, NULL, 4),
(193419, NULL, 'G3DSA:3.10.330.10:FF:000007', NULL, NULL, 'Vesicle-fusing ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(193420, NULL, 'G3DSA:3.40.1650.10:FF:000007', NULL, NULL, 'RbsD or FucU transport', NULL, NULL, NULL, NULL, NULL, 4),
(193421, NULL, 'G3DSA:1.25.10.10:FF:001744', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193422, NULL, 'G3DSA:3.40.250.10:FF:000141', NULL, NULL, 'Thiosulfate sulfurtransferase, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193423, NULL, 'G3DSA:3.30.450.20:FF:000296', NULL, NULL, 'Diguanylate cyclase (GGDEF) domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(193424, NULL, 'G3DSA:1.10.287.70:FF:000235', NULL, NULL, 'TWiK family of potassium channels', NULL, NULL, NULL, NULL, NULL, 4),
(193425, NULL, 'G3DSA:1.10.167.10:FF:000040', NULL, NULL, 'Rax1p', NULL, NULL, NULL, NULL, NULL, 4),
(193426, NULL, 'G3DSA:3.40.50.1100:FF:000188', NULL, NULL, 'Cysteine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(193427, NULL, 'G3DSA:3.50.50.60:FF:000243', NULL, NULL, 'L-aspartate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(193428, NULL, 'G3DSA:1.10.600.10:FF:000036', NULL, NULL, 'cis-abienol synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(193429, NULL, 'G3DSA:1.10.510.10:FF:003143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193430, NULL, 'G3DSA:1.10.472.10:FF:000619', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193431, NULL, 'G3DSA:3.40.50.300:FF:001371', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(193432, NULL, 'G3DSA:1.20.1250.20:FF:000020', NULL, NULL, 'Multidrug resistance protein MdtG', NULL, NULL, NULL, NULL, NULL, 4),
(193433, NULL, 'G3DSA:1.10.238.10:FF:000059', NULL, NULL, 'Plastin 1', NULL, NULL, NULL, NULL, NULL, 4),
(193434, NULL, 'G3DSA:1.10.3080.10:FF:000017', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(193435, NULL, 'G3DSA:3.30.70.330:FF:002066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193436, NULL, 'G3DSA:2.130.10.30:FF:000062', NULL, NULL, 'Regulator of chromosome condensation (RCC1) repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193437, NULL, 'G3DSA:3.40.50.300:FF:002591', NULL, NULL, 'DNA helicase B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(193438, NULL, 'G3DSA:3.40.50.300:FF:008296', NULL, NULL, 'tRNA dimethylallyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(193439, NULL, 'G3DSA:3.40.50.11860:FF:000008', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(193440, NULL, 'G3DSA:3.30.160.60:FF:005945', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193441, NULL, 'G3DSA:3.40.630.30:FF:000226', NULL, NULL, 'Si:dkey-183c6.8', NULL, NULL, NULL, NULL, NULL, 4),
(193442, NULL, 'G3DSA:3.40.50.300:FF:007262', NULL, NULL, 'Ras GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(193443, NULL, 'G3DSA:1.50.40.10:FF:000209', NULL, NULL, 'SLC (SoLute Carrier) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(193444, NULL, 'G3DSA:3.40.525.10:FF:000072', NULL, NULL, 'Phosphatidylinositol phosphatidylcholine transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(193445, NULL, 'G3DSA:3.10.110.10:FF:000227', NULL, NULL, 'RWD domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(193446, NULL, 'G3DSA:1.20.58.60:FF:000300', NULL, NULL, 'Spectrin beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(193447, NULL, 'G3DSA:3.90.950.10:FF:000048', NULL, NULL, 'Inosine triphosphate pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(193448, NULL, 'G3DSA:3.30.1130.10:FF:000021', NULL, NULL, 'Folic acid synthesis protein fol1', NULL, NULL, NULL, NULL, NULL, 4),
(193449, NULL, 'G3DSA:1.20.120.1900:FF:000076', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(193450, NULL, 'G3DSA:3.80.10.10:FF:004507', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193451, NULL, 'G3DSA:1.10.10.60:FF:000718', NULL, NULL, 'Sigma-54-dependent Fis family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(193452, NULL, 'G3DSA:3.30.70.330:FF:003005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193453, NULL, 'G3DSA:1.25.10.10:FF:001391', NULL, NULL, 'Protein phosphatase 4 regulatory subunit 1-like (pseudogene)', NULL, NULL, NULL, NULL, NULL, 4),
(193454, NULL, 'G3DSA:3.30.70.1430:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193455, NULL, 'G3DSA:1.20.1070.10:FF:001554', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193456, NULL, 'G3DSA:2.30.30.140:FF:000291', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193457, NULL, 'G3DSA:3.40.309.10:FF:000103', NULL, NULL, 'Phenylacetaldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(193458, NULL, 'G3DSA:2.10.25.10:FF:001427', NULL, NULL, 'Crumbs cell polarity complex component 2', NULL, NULL, NULL, NULL, NULL, 4),
(193459, NULL, 'G3DSA:3.50.50.60:FF:000670', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(193460, NULL, 'G3DSA:3.30.160.60:FF:003736', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193461, NULL, 'G3DSA:3.30.565.10:FF:000363', NULL, NULL, 'ATP-binding mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(193462, NULL, 'G3DSA:3.90.550.10:FF:000736', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193463, NULL, 'G3DSA:3.20.20.140:FF:000181', NULL, NULL, 'Allantoinase', NULL, NULL, NULL, NULL, NULL, 4),
(193464, NULL, 'G3DSA:2.170.120.40:FF:000006', NULL, NULL, 'YbbR-like domain-containing protein YbbR', NULL, NULL, NULL, NULL, NULL, 4),
(193465, NULL, 'G3DSA:2.130.10.10:FF:000729', NULL, NULL, 'SMU1, DNA replication regulator and spliceosomal factor', NULL, NULL, NULL, NULL, NULL, 4),
(193466, NULL, 'G3DSA:3.30.420.40:FF:000906', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(193467, NULL, 'G3DSA:3.30.2130.30:FF:000044', NULL, NULL, 'tRNA sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(193468, NULL, 'G3DSA:2.60.40.150:FF:000558', NULL, NULL, 'Calcium-dependent lipid-binding (CaLB domain) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(193469, NULL, 'G3DSA:1.10.10.10:FF:000592', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193470, NULL, 'G3DSA:1.10.238.10:FF:000368', NULL, NULL, 'Calcium-binding EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(193471, NULL, 'G3DSA:1.20.120.160:FF:000002', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(193472, NULL, 'G3DSA:3.40.50.1000:FF:000692', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193473, NULL, 'G3DSA:3.30.450.20:FF:000532', NULL, NULL, 'Hypoxia-inducible factor 1 alpha, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193474, NULL, 'G3DSA:2.40.50.140:FF:000146', NULL, NULL, 'S1 RNA-binding domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(193475, NULL, 'G3DSA:2.60.40.10:FF:002753', NULL, NULL, 'Transmembrane protein 130', NULL, NULL, NULL, NULL, NULL, 4),
(193476, NULL, 'G3DSA:2.40.10.10:FF:000043', NULL, NULL, 'serine proteases 1/2', NULL, NULL, NULL, NULL, NULL, 4),
(193477, NULL, 'G3DSA:1.10.8.10:FF:000080', NULL, NULL, 'UBC1p Ubiquitin-conjugating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(193478, NULL, 'G3DSA:3.40.50.410:FF:000021', NULL, NULL, 'Collagen, type VI, alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(193479, NULL, 'G3DSA:3.40.50.620:FF:000213', NULL, NULL, 'Methionine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(193480, NULL, 'G3DSA:3.30.930.10:FF:000077', NULL, NULL, 'Putative lipoate-protein ligase A', NULL, NULL, NULL, NULL, NULL, 4),
(193481, NULL, 'G3DSA:3.40.250.10:FF:000040', NULL, NULL, 'Zn-dependent hydroxyacylglutathione hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(193482, NULL, 'G3DSA:1.10.10.10:FF:001581', NULL, NULL, 'Uncharacterized HTH-type transcriptional regulator HI_0143', NULL, NULL, NULL, NULL, NULL, 4),
(193483, NULL, 'G3DSA:3.60.10.10:FF:000074', NULL, NULL, 'RNA exonuclease NGL2', NULL, NULL, NULL, NULL, NULL, 4),
(193484, NULL, 'G3DSA:3.30.497.10:FF:000081', NULL, NULL, 'Serpin-Z1', NULL, NULL, NULL, NULL, NULL, 4),
(193485, NULL, 'G3DSA:3.40.50.150:FF:001449', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193486, NULL, 'G3DSA:2.30.30.490:FF:000064', NULL, NULL, 'DNA (cytosine-5)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(193487, NULL, 'G3DSA:3.90.550.50:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193488, NULL, 'G3DSA:3.40.50.2000:FF:000374', NULL, NULL, 'LD38128p', NULL, NULL, NULL, NULL, NULL, 4),
(193489, NULL, 'G3DSA:1.25.40.10:FF:001572', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g33990', NULL, NULL, NULL, NULL, NULL, 4),
(193490, NULL, 'G3DSA:3.30.160.60:FF:003175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193491, NULL, 'G3DSA:1.20.1300.10:FF:000027', NULL, NULL, 'Succinate dehydrogenase cytochrome b560 subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(193492, NULL, 'G3DSA:1.25.40.10:FF:002398', NULL, NULL, 'PPR repeat/Pentatricopeptide repeat domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193493, NULL, 'G3DSA:3.90.1720.10:FF:000030', NULL, NULL, 'CHAP domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193494, NULL, 'G3DSA:2.130.10.10:FF:000477', NULL, NULL, 'Echinoderm microtubule-associated protein-like CG42247', NULL, NULL, NULL, NULL, NULL, 4),
(193495, NULL, 'G3DSA:1.10.510.10:FF:000872', NULL, NULL, 'CMGC/CDK/CRK7 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(193496, NULL, 'G3DSA:3.40.720.10:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193497, NULL, 'G3DSA:3.40.50.620:FF:000860', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193498, NULL, 'G3DSA:3.40.50.1980:FF:000081', NULL, NULL, 'Iron(III) dicitrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(193499, NULL, 'G3DSA:3.90.1200.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(193500, NULL, 'G3DSA:3.20.100.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193501, NULL, 'G3DSA:2.10.25.10:FF:000808', NULL, NULL, 'Nimrod C1, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(193502, NULL, 'G3DSA:1.10.287.2170:FF:000001', NULL, NULL, 'POSSIBLE RESOLVASE', NULL, NULL, NULL, NULL, NULL, 4),
(193503, NULL, 'G3DSA:3.90.640.10:FF:000255', NULL, NULL, 'Actin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(193504, NULL, 'G3DSA:1.20.1070.10:FF:000817', NULL, NULL, 'AGAP001499-PB', NULL, NULL, NULL, NULL, NULL, 4),
(193505, NULL, 'G3DSA:1.20.1070.10:FF:000565', NULL, NULL, 'Probable G-protein coupled receptor tkr-1', NULL, NULL, NULL, NULL, NULL, 4),
(193506, NULL, 'G3DSA:3.30.365.10:FF:000044', NULL, NULL, 'Aldehyde oxidase and xanthine dehydrogenase, a/b hammerhead domain', NULL, NULL, NULL, NULL, NULL, 4),
(193507, NULL, 'G3DSA:1.10.486.10:FF:000045', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(193508, NULL, 'G3DSA:1.25.10.10:FF:000816', NULL, NULL, 'V-type proton ATPase subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(193509, NULL, 'G3DSA:3.30.2350.20:FF:000035', NULL, NULL, 'tRNA pseudouridine synthase D', NULL, NULL, NULL, NULL, NULL, 4),
(193510, NULL, 'G3DSA:2.60.120.200:FF:000369', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193511, NULL, 'G3DSA:2.40.250.10:FF:000004', NULL, NULL, 'Core binding factor beta subunit isoform 5', NULL, NULL, NULL, NULL, NULL, 4),
(193512, NULL, 'G3DSA:2.30.42.10:FF:000269', NULL, NULL, 'Multiple PDZ domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(193513, NULL, 'G3DSA:3.40.1090.10:FF:000127', NULL, NULL, 'Protein CBG09699', NULL, NULL, NULL, NULL, NULL, 4),
(193514, NULL, 'G3DSA:3.40.50.300:FF:005114', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(193515, NULL, 'G3DSA:1.10.510.10:FF:001709', NULL, NULL, 'Protein NSP-INTERACTING KINASE 1', NULL, NULL, NULL, NULL, NULL, 4),
(193516, NULL, 'G3DSA:3.30.230.70:FF:000058', NULL, NULL, '3 exoribonuclease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(193517, NULL, 'G3DSA:1.25.10.10:FF:003453', NULL, NULL, 'Maestro heat-like repeat-containing protein family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(193518, NULL, 'G3DSA:1.20.190.50:FF:000002', NULL, NULL, 'Nuclear pore complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(193519, NULL, 'G3DSA:3.40.50.300:FF:007470', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193520, NULL, 'G3DSA:3.30.160.60:FF:001466', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193521, NULL, 'G3DSA:4.10.260.20:FF:000001', NULL, NULL, 'NADP-reducing hydrogenase subunit HndD', NULL, NULL, NULL, NULL, NULL, 4),
(193522, NULL, 'G3DSA:1.25.40.10:FF:002409', NULL, NULL, 'Pre-mRNA-splicing factor CLF1', NULL, NULL, NULL, NULL, NULL, 4),
(193523, NULL, 'G3DSA:3.30.1010.10:FF:000057', NULL, NULL, 'Phosphatidylinositol-4,5-bisphosphate 3-kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193524, NULL, 'G3DSA:3.20.80.10:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193525, NULL, 'G3DSA:3.30.450.20:FF:000032', NULL, NULL, 'Aerobic respiration control sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(193526, NULL, 'G3DSA:1.20.5.1160:FF:000020', NULL, NULL, 'Keratin 23', NULL, NULL, NULL, NULL, NULL, 4),
(193527, NULL, 'G3DSA:2.10.25.10:FF:000910', NULL, NULL, 'laminin subunit alpha-3', NULL, NULL, NULL, NULL, NULL, 4),
(193528, NULL, 'G3DSA:3.80.10.10:FF:000455', NULL, NULL, 'Osteomodulin', NULL, NULL, NULL, NULL, NULL, 4),
(193529, NULL, 'G3DSA:3.40.50.150:FF:001758', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193530, NULL, 'G3DSA:3.30.40.10:FF:000470', NULL, NULL, 'Putative RING finger U-box domain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(193531, NULL, 'G3DSA:1.10.1370.40:FF:000003', NULL, NULL, 'Endopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193532, NULL, 'G3DSA:2.40.50.90:FF:000069', NULL, NULL, 'Tapas, isoform B', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(193533, NULL, 'G3DSA:3.40.50.300:FF:001871', NULL, NULL, 'ATP-binding cassette, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193534, NULL, 'G3DSA:3.40.50.300:FF:005570', NULL, NULL, 'Uncharacterized protein spnA', NULL, NULL, NULL, NULL, NULL, 4),
(193535, NULL, 'G3DSA:3.40.50.720:FF:000917', NULL, NULL, '[NAD]-dependent malate oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(193536, NULL, 'G3DSA:2.40.170.20:FF:000079', NULL, NULL, 'Iron(III) dicitrate transport protein (FecA)', NULL, NULL, NULL, NULL, NULL, 4),
(193537, NULL, 'G3DSA:1.25.10.30:FF:000002', NULL, NULL, 'ryanodine receptor isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(193538, NULL, 'G3DSA:3.10.20.90:FF:000403', NULL, NULL, 'ESX-1 secretion system protein EccD1', NULL, NULL, NULL, NULL, NULL, 4),
(193539, NULL, 'G3DSA:1.10.510.10:FF:001457', NULL, NULL, 'Cyclin-dependent kinase C-2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193540, NULL, 'G3DSA:2.30.30.40:FF:000357', NULL, NULL, 'Crk oncogene, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(193541, NULL, 'G3DSA:1.10.150.240:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193542, NULL, 'G3DSA:3.90.226.10:FF:000247', NULL, NULL, 'Methylcrotonoyl-CoA carboxylase beta chain, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(193543, NULL, 'G3DSA:3.40.630.30:FF:000434', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(193544, NULL, 'G3DSA:2.60.120.10:FF:000496', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(193545, NULL, 'G3DSA:1.10.1410.10:FF:000032', NULL, NULL, 'PolyA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(193546, NULL, 'G3DSA:3.40.190.10:FF:000978', NULL, NULL, 'Dipeptide ABC transporter, solute-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(193547, NULL, 'G3DSA:2.60.40.2560:FF:000003', NULL, NULL, 'Serine/threonine-protein kinase PrkC', NULL, NULL, NULL, NULL, NULL, 4),
(193548, NULL, 'G3DSA:1.10.8.430:FF:000002', NULL, NULL, 'Disease resistance protein (TIR-NBS-LRR class)', NULL, NULL, NULL, NULL, NULL, 4),
(193549, NULL, 'G3DSA:1.10.238.10:FF:001195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193550, NULL, 'G3DSA:1.10.560.10:FF:000111', NULL, NULL, 'T-complex protein 1 subunit zeta', NULL, NULL, NULL, NULL, NULL, 4),
(193551, NULL, 'G3DSA:2.70.98.40:FF:000011', NULL, NULL, 'Glycoside hydrolase family 65 protein', NULL, NULL, NULL, NULL, NULL, 4),
(193552, NULL, 'G3DSA:1.20.1280.290:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193553, NULL, 'G3DSA:2.60.40.10:FF:002298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193554, NULL, 'G3DSA:3.90.740.10:FF:000066', NULL, NULL, 'Leucyl-tRNA synthetase a', NULL, NULL, NULL, NULL, NULL, 4),
(193555, NULL, 'G3DSA:3.40.1190.20:FF:000183', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193556, NULL, 'G3DSA:1.25.10.10:FF:000772', NULL, NULL, 'YDL063C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(193557, NULL, 'G3DSA:2.60.40.790:FF:000177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193558, NULL, 'G3DSA:1.10.287.370:FF:000100', NULL, NULL, 'YALI0D19822p', NULL, NULL, NULL, NULL, NULL, 4),
(193559, NULL, 'G3DSA:1.10.238.10:FF:000576', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(193560, NULL, 'G3DSA:2.30.30.140:FF:000190', NULL, NULL, 'Pro-Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(193561, NULL, 'G3DSA:3.30.428.70:FF:000006', NULL, NULL, 'ATP adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(193562, NULL, 'G3DSA:2.60.40.60:FF:001115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193563, NULL, 'G3DSA:3.10.200.10:FF:000009', NULL, NULL, 'receptor-type tyrosine-protein phosphatase zeta isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(193564, NULL, 'G3DSA:2.60.120.920:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193565, NULL, 'G3DSA:3.30.160.60:FF:003366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(193566, NULL, 'G3DSA:3.80.10.10:FF:004142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193567, NULL, 'G3DSA:2.60.120.200:FF:000105', NULL, NULL, 'Collagen type IX alpha 1 chain', NULL, NULL, NULL, NULL, NULL, 4),
(193568, NULL, 'G3DSA:1.20.1250.20:FF:000992', NULL, NULL, 'Cation symporter', NULL, NULL, NULL, NULL, NULL, 4),
(193569, NULL, 'G3DSA:3.40.50.300:FF:000191', NULL, NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(193570, NULL, 'G3DSA:3.90.190.10:FF:000618', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193571, NULL, 'G3DSA:3.90.70.10:FF:000795', NULL, NULL, 'Probable ubiquitin carboxyl-terminal hydrolase 16', NULL, NULL, NULL, NULL, NULL, 4),
(193572, NULL, 'G3DSA:1.25.10.10:FF:001183', NULL, NULL, 'Serine/threonine-protein phosphatase 4 regulatory subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(193573, NULL, 'G3DSA:3.30.160.60:FF:004456', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193574, NULL, 'G3DSA:3.30.460.10:FF:000001', NULL, NULL, 'GTP pyrophosphokinase RelA', NULL, NULL, NULL, NULL, NULL, 4),
(193575, NULL, 'G3DSA:1.20.1540.10:FF:000073', NULL, NULL, 'Rhomboid family serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(193576, NULL, 'G3DSA:3.80.10.10:FF:001736', NULL, NULL, 'GM22107', NULL, NULL, NULL, NULL, NULL, 4),
(193577, NULL, 'G3DSA:3.40.50.1220:FF:000078', NULL, NULL, 'Sirtuin type 2', NULL, NULL, NULL, NULL, NULL, 4),
(193578, NULL, 'G3DSA:1.20.120.520:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193579, NULL, 'G3DSA:3.30.40.10:FF:001223', NULL, NULL, 'Protein 21.1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193580, NULL, 'G3DSA:3.40.50.1820:FF:000050', NULL, NULL, 'prolyl endopeptidase-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(193581, NULL, 'G3DSA:3.40.50.150:FF:001657', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193582, NULL, 'G3DSA:2.160.10.10:FF:000026', NULL, NULL, 'Translation initiation factor eIF-2B subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(193583, NULL, 'G3DSA:3.30.1370.10:FF:000106', NULL, NULL, 'Scp160p', NULL, NULL, NULL, NULL, NULL, 4),
(193584, NULL, 'G3DSA:3.30.500.10:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193585, NULL, 'G3DSA:3.80.10.10:FF:000556', NULL, NULL, 'CLUMA_CG018969, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(193586, NULL, 'G3DSA:1.25.40.20:FF:001221', NULL, NULL, 'SH3 and multiple ankyrin repeat domains 2', NULL, NULL, NULL, NULL, NULL, 4),
(193587, NULL, 'G3DSA:3.90.550.10:FF:000692', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193588, NULL, 'G3DSA:3.30.450.70:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193589, NULL, 'G3DSA:3.30.160.60:FF:000757', NULL, NULL, 'Transcription factor Msn2p', NULL, NULL, NULL, NULL, NULL, 4),
(193590, NULL, 'G3DSA:3.30.1360.10:FF:000066', NULL, NULL, 'DNA-directed RNA polymerases II IV and V subunit 11', NULL, NULL, NULL, NULL, NULL, 4),
(193591, NULL, 'G3DSA:3.30.40.10:FF:000717', NULL, NULL, 'Enhancer of yellow 3, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(193592, NULL, 'G3DSA:1.20.120.720:FF:000041', NULL, NULL, 'Chitin synthase 6', NULL, NULL, NULL, NULL, NULL, 4),
(193593, NULL, 'G3DSA:3.90.640.10:FF:000047', NULL, NULL, 'Actin, alpha skeletal muscle', NULL, NULL, NULL, NULL, NULL, 4),
(193594, NULL, 'G3DSA:1.10.287.10:FF:000015', NULL, NULL, 'Mitochondrial ribosomal protein S15', NULL, NULL, NULL, NULL, NULL, 4),
(193595, NULL, 'G3DSA:2.60.40.10:FF:000544', NULL, NULL, 'Mast/stem cell growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(193596, NULL, 'G3DSA:1.25.40.20:FF:001693', NULL, NULL, 'LOC100005699 protein', NULL, NULL, NULL, NULL, NULL, 4),
(193597, NULL, 'G3DSA:3.20.20.70:FF:000195', NULL, NULL, 'ribulose-phosphate 3-epimerase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(193598, NULL, 'G3DSA:3.40.50.1440:FF:000149', NULL, NULL, 'Protein DML1', NULL, NULL, NULL, NULL, NULL, 4),
(193599, NULL, 'G3DSA:3.40.30.10:FF:001211', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(193600, NULL, 'G3DSA:3.30.930.10:FF:000313', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(193601, NULL, 'G3DSA:3.40.50.720:FF:002042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193602, NULL, 'G3DSA:1.10.1040.10:FF:000043', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(193603, NULL, 'G3DSA:1.10.510.10:FF:002890', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(193604, NULL, 'G3DSA:1.10.150.510:FF:000003', NULL, NULL, 'Receptor activity-modifying protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(193605, NULL, 'G3DSA:2.60.120.10:FF:000024', NULL, NULL, 'Cyclic nucleotide-gated ion channel 1', NULL, NULL, NULL, NULL, NULL, 4),
(193606, NULL, 'G3DSA:3.90.1150.10:FF:000222', NULL, NULL, 'Methionine S-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(193607, NULL, 'G3DSA:3.40.50.10890:FF:000015', NULL, NULL, 'Cleavage and polyadenylation specificity factor 73-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(193608, NULL, 'G3DSA:3.30.160.60:FF:000038', NULL, NULL, 'Zinc finger protein 624', NULL, NULL, NULL, NULL, NULL, 4),
(193609, NULL, 'G3DSA:3.10.110.10:FF:000126', NULL, NULL, 'Ubiquitin conjugating enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193610, NULL, 'G3DSA:3.30.830.10:FF:000013', NULL, NULL, 'Mitochondrial presequence protease', NULL, NULL, NULL, NULL, NULL, 4),
(193611, NULL, 'G3DSA:3.30.460.10:FF:000215', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(193612, NULL, 'G3DSA:2.40.10.10:FF:000543', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193613, NULL, 'G3DSA:1.25.40.10:FF:003590', NULL, NULL, 'Protein CBR-UTX-1', NULL, NULL, NULL, NULL, NULL, 4),
(193614, NULL, 'G3DSA:1.25.40.240:FF:000006', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(193615, NULL, 'G3DSA:3.30.200.20:FF:000896', NULL, NULL, 'Protein kinase domain containing protein expressed', NULL, NULL, NULL, NULL, NULL, 4),
(193616, NULL, 'G3DSA:1.20.58.60:FF:000755', NULL, NULL, 'Si:dkey-151c10.1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(193617, NULL, 'G3DSA:3.90.550.10:FF:000017', NULL, NULL, 'Mannan polymerase II complex ANP1 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(193618, NULL, 'G3DSA:2.160.20.110:FF:000002', NULL, NULL, 'Putative GLUG motif protein', NULL, NULL, NULL, NULL, NULL, 4),
(193619, NULL, 'G3DSA:3.50.50.60:FF:000827', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(193620, NULL, 'G3DSA:1.10.10.60:FF:000966', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193621, NULL, 'G3DSA:2.60.120.290:FF:000222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193622, NULL, 'G3DSA:3.40.50.150:FF:001096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193623, NULL, 'G3DSA:3.40.50.2000:FF:000227', NULL, NULL, 'Alpha-1,2-mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(193624, NULL, 'G3DSA:2.60.120.200:FF:000577', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193625, NULL, 'G3DSA:3.80.10.10:FF:002242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193626, NULL, 'G3DSA:3.40.640.10:FF:000305', NULL, NULL, '(S)-3,5-dihydroxyphenylglycine transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(193627, NULL, 'G3DSA:2.60.40.150:FF:000452', NULL, NULL, 'Coiled-coil and C2 domain containing 1A', NULL, NULL, NULL, NULL, NULL, 4),
(193628, NULL, 'G3DSA:3.40.50.2300:FF:000458', NULL, NULL, 'Fructose repressor FruR LacI family', NULL, NULL, NULL, NULL, NULL, 4),
(193629, NULL, 'G3DSA:3.40.50.300:FF:002697', NULL, NULL, 'Translation initiation factor IF-2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193630, NULL, 'G3DSA:2.60.40.1510:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193631, NULL, 'G3DSA:1.10.8.710:FF:000007', NULL, NULL, 'Putative dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(193632, NULL, 'G3DSA:2.30.180.10:FF:000068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193633, NULL, 'G3DSA:3.30.200.20:FF:000587', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(193634, NULL, 'G3DSA:3.40.50.2020:FF:000121', NULL, NULL, 'Uridine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(193635, NULL, 'G3DSA:1.10.555.10:FF:000026', NULL, NULL, 'Rho GTPase activating protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(193636, NULL, 'G3DSA:2.60.40.10:FF:002859', NULL, NULL, 'Sialoadhesin', NULL, NULL, NULL, NULL, NULL, 4),
(193637, NULL, 'G3DSA:1.20.920.10:FF:000160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193638, NULL, 'G3DSA:3.40.50.10190:FF:000356', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193639, NULL, 'G3DSA:3.40.50.300:FF:004597', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193640, NULL, 'G3DSA:1.10.1300.10:FF:000041', NULL, NULL, 'Phosphodiesterase 5A, cGMP-specific, a', NULL, NULL, NULL, NULL, NULL, 4),
(193641, NULL, 'G3DSA:1.20.1070.10:FF:001745', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193642, NULL, 'G3DSA:2.40.30.10:FF:000409', NULL, NULL, 'NADPH-dependent diflavin oxidoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(193643, NULL, 'G3DSA:3.30.200.20:FF:001093', NULL, NULL, 'Cyclin-dependent kinase-like 5', NULL, NULL, NULL, NULL, NULL, 4),
(193644, NULL, 'G3DSA:1.20.1270.60:FF:000336', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193645, NULL, 'G3DSA:3.90.470.20:FF:000076', NULL, NULL, 'Phosphopantetheinyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(193646, NULL, 'G3DSA:2.60.120.340:FF:000006', NULL, NULL, 'FK506-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(193647, NULL, 'G3DSA:2.10.25.10:FF:000455', NULL, NULL, 'neurogenic locus notch homolog protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(193648, NULL, 'G3DSA:3.40.50.150:FF:000168', NULL, NULL, 'Methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(193649, NULL, 'G3DSA:2.130.10.10:FF:005491', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193650, NULL, 'G3DSA:3.40.50.300:FF:005215', NULL, NULL, 'Cytidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(193651, NULL, 'G3DSA:3.30.70.330:FF:000588', NULL, NULL, 'Pre-mRNA splicing factor (Prp24), putative', NULL, NULL, NULL, NULL, NULL, 4),
(193652, NULL, 'G3DSA:1.25.40.90:FF:000050', NULL, NULL, 'Pol II C-terminal Interaction Domain Suppressor', NULL, NULL, NULL, NULL, NULL, 4),
(193653, NULL, 'G3DSA:3.40.50.300:FF:004709', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(193654, NULL, 'G3DSA:3.30.710.10:FF:000196', NULL, NULL, 'BTB/POZ domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(193655, NULL, 'G3DSA:3.30.1550.10:FF:000013', NULL, NULL, '50S ribosomal protein L11', NULL, NULL, NULL, NULL, NULL, 4),
(193656, NULL, 'G3DSA:1.10.10.60:FF:000819', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193657, NULL, 'G3DSA:1.20.144.10:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193658, NULL, 'G3DSA:3.40.50.300:FF:007368', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193659, NULL, 'G3DSA:1.10.630.10:FF:000139', NULL, NULL, '7-ethoxycoumarin O-deethylase', NULL, NULL, NULL, NULL, NULL, 4),
(193660, NULL, 'G3DSA:1.20.1070.10:FF:000464', NULL, NULL, 'Trace amine-associated receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(193661, NULL, 'G3DSA:1.25.40.10:FF:005271', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(193662, NULL, 'G3DSA:3.20.20.80:FF:000552', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(193663, NULL, 'G3DSA:1.20.1250.20:FF:000683', NULL, NULL, 'Multidrug efflux pump Tap', NULL, NULL, NULL, NULL, NULL, 4),
(193664, NULL, 'G3DSA:3.30.70.330:FF:002488', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193665, NULL, 'G3DSA:3.20.20.80:FF:000243', NULL, NULL, 'Beta-glucuronidase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(193666, NULL, 'G3DSA:1.25.10.10:FF:000463', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(193667, NULL, 'G3DSA:1.10.260.40:FF:000081', NULL, NULL, 'Helix-turn-helix XRE domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(193668, NULL, 'G3DSA:3.30.70.330:FF:001869', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193669, NULL, 'G3DSA:2.130.10.10:FF:000932', NULL, NULL, 'Related to Vacuolar assembly protein VPS41', NULL, NULL, NULL, NULL, NULL, 4),
(193670, NULL, 'G3DSA:2.30.29.30:FF:000171', NULL, NULL, 'Actin filament-associated protein 1-like 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(193671, NULL, 'G3DSA:2.30.31.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193672, NULL, 'G3DSA:3.30.450.50:FF:000030', NULL, NULL, 'Vesicle-associated membrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193673, NULL, 'G3DSA:1.25.40.10:FF:001229', NULL, NULL, 'Os04g0221300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(193674, NULL, 'G3DSA:3.30.70.2170:FF:000005', NULL, NULL, 'V-type ATP synthase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(193675, NULL, 'G3DSA:1.10.580.10:FF:000011', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(193676, NULL, 'G3DSA:3.30.420.340:FF:000002', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4),
(193677, NULL, 'G3DSA:2.60.40.10:FF:000089', NULL, NULL, 'calmodulin-binding transcription activator 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(193678, NULL, 'G3DSA:1.25.40.20:FF:000501', NULL, NULL, 'Ankyrin repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(193679, NULL, 'G3DSA:3.30.310.20:FF:000005', NULL, NULL, 'Ada regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(193680, NULL, 'G3DSA:2.30.42.10:FF:000510', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193681, NULL, 'G3DSA:3.30.1520.10:FF:000068', NULL, NULL, 'Atg20p', NULL, NULL, NULL, NULL, NULL, 4),
(193682, NULL, 'G3DSA:1.10.287.610:FF:000009', NULL, NULL, '30S ribosomal protein S2', NULL, NULL, NULL, NULL, NULL, 4),
(193683, NULL, 'G3DSA:1.10.10.60:FF:000921', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193684, NULL, 'G3DSA:3.40.50.300:FF:006851', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193685, NULL, 'G3DSA:1.20.1050.10:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193686, NULL, 'G3DSA:2.20.100.10:FF:000099', NULL, NULL, 'SCO-spondin', NULL, NULL, NULL, NULL, NULL, 4),
(193687, NULL, 'G3DSA:3.40.50.460:FF:000025', NULL, NULL, 'ATP-dependent 6-phosphofructokinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(193688, NULL, 'G3DSA:2.130.10.30:FF:000163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193689, NULL, 'G3DSA:2.60.40.10:FF:001472', NULL, NULL, 'Frazzled, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(193690, NULL, 'G3DSA:3.40.50.10190:FF:000047', NULL, NULL, 'Microcephalin', NULL, NULL, NULL, NULL, NULL, 4),
(193691, NULL, 'G3DSA:1.20.140.150:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193692, NULL, 'G3DSA:3.40.1800.20:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193693, NULL, 'G3DSA:3.40.30.10:FF:000031', NULL, NULL, 'Calsequestrin', NULL, NULL, NULL, NULL, NULL, 4),
(193694, NULL, 'G3DSA:3.30.40.10:FF:002151', NULL, NULL, 'PDZ/DHR/GLGF domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(193695, NULL, 'G3DSA:2.60.40.150:FF:000761', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193696, NULL, 'G3DSA:2.60.40.60:FF:000143', NULL, NULL, 'FAT atypical cadherin 4', NULL, NULL, NULL, NULL, NULL, 4),
(193697, NULL, 'G3DSA:3.30.590.10:FF:000005', NULL, NULL, 'Probable glutamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(193698, NULL, 'G3DSA:3.20.20.140:FF:000225', NULL, NULL, 'Putative deoxyribonuclease TATDN3', NULL, NULL, NULL, NULL, NULL, 4),
(193699, NULL, 'G3DSA:2.40.50.140:FF:000247', NULL, NULL, 'Exosome complex exonuclease exoribonuclease (Rrp44)', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(193700, NULL, 'G3DSA:1.20.5.500:FF:000004', NULL, NULL, 'ATPase inhibitor A, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(193701, NULL, 'G3DSA:3.40.50.1370:FF:000004', NULL, NULL, 'Ornithine carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(193702, NULL, 'G3DSA:1.25.40.10:FF:002662', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193703, NULL, 'G3DSA:3.40.50.150:FF:000729', NULL, NULL, 'Cypemycin methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(193704, NULL, 'G3DSA:2.130.10.10:FF:003591', NULL, NULL, 'Protein DECREASED SIZE EXCLUSION LIMIT 1', NULL, NULL, NULL, NULL, NULL, 4),
(193705, NULL, 'G3DSA:2.40.270.10:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193706, NULL, 'G3DSA:1.20.5.690:FF:000004', NULL, NULL, 'Importin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(193707, NULL, 'G3DSA:1.25.40.610:FF:000005', NULL, NULL, 'cadherin EGF LAG seven-pass G-type receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(193708, NULL, 'G3DSA:3.30.70.330:FF:003106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193709, NULL, 'G3DSA:3.30.2440.10:FF:000005', NULL, NULL, 'SPI-1 type III secretion system effector SopD', NULL, NULL, NULL, NULL, NULL, 4),
(193710, NULL, 'G3DSA:3.40.50.10380:FF:000014', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(193711, NULL, 'G3DSA:2.115.10.20:FF:000009', NULL, NULL, 'Extracellular invertase', NULL, NULL, NULL, NULL, NULL, 4),
(193712, NULL, 'G3DSA:3.40.350.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193713, NULL, 'G3DSA:3.40.140.10:FF:000003', NULL, NULL, 'COP9 signalosome complex subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(193714, NULL, 'G3DSA:3.20.20.150:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193715, NULL, 'G3DSA:3.40.47.10:FF:000086', NULL, NULL, '3-hydroxy-3-methylglutaryl-CoA synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193716, NULL, 'G3DSA:3.40.50.300:FF:001163', NULL, NULL, 'RAB6B, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(193717, NULL, 'G3DSA:1.10.510.10:FF:001912', NULL, NULL, 'Kinase-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(193718, NULL, 'G3DSA:1.20.120.1630:FF:000017', NULL, NULL, '3-oxo-5-alpha-steroid 4-dehydrogenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(193719, NULL, 'G3DSA:3.30.1120.160:FF:000002', NULL, NULL, 'Signal-induced proliferation-associated 1-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(193720, NULL, 'G3DSA:3.30.420.40:FF:000553', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193721, NULL, 'G3DSA:3.90.79.10:FF:000135', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(193722, NULL, 'G3DSA:3.40.50.300:FF:006542', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193723, NULL, 'G3DSA:3.90.190.10:FF:000057', NULL, NULL, 'Dual specificity phosphatase 5', NULL, NULL, NULL, NULL, NULL, 4),
(193724, NULL, 'G3DSA:3.30.160.60:FF:003630', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193725, NULL, 'G3DSA:3.40.50.150:FF:000477', NULL, NULL, 'Putative tRNA (cytidine(32)/guanosine(34)-2''-O)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(193726, NULL, 'G3DSA:2.60.120.260:FF:000016', NULL, NULL, 'Contactin-associated protein-like 4 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(193727, NULL, 'G3DSA:3.30.70.920:FF:000006', NULL, NULL, 'AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(193728, NULL, 'G3DSA:3.30.70.370:FF:000021', NULL, NULL, 'Polymerase (DNA directed), theta', NULL, NULL, NULL, NULL, NULL, 4),
(193729, NULL, 'G3DSA:2.60.40.10:FF:003181', NULL, NULL, 'Sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(193730, NULL, 'G3DSA:3.40.50.1820:FF:000403', NULL, NULL, 'RTX toxin RtxA', NULL, NULL, NULL, NULL, NULL, 4),
(193731, NULL, 'G3DSA:3.40.50.1010:FF:000133', NULL, NULL, 'Exonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(193732, NULL, 'G3DSA:3.40.50.410:FF:000044', NULL, NULL, 'Collagen type VI alpha 6 chain', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(193733, NULL, 'G3DSA:2.60.40.10:FF:001573', NULL, NULL, 'Interleukin-4 receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(193734, NULL, 'G3DSA:1.10.287.4070:FF:000020', NULL, NULL, 'NOP56 ribonucleoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(193735, NULL, 'G3DSA:1.10.472.10:FF:000535', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193736, NULL, 'G3DSA:2.60.40.1150:FF:000007', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(193737, NULL, 'G3DSA:1.10.10.10:FF:001772', NULL, NULL, 'Phosphate regulon transcriptional regulatory protein PhoB (SphR)', NULL, NULL, NULL, NULL, NULL, 4),
(193738, NULL, 'G3DSA:3.40.50.1370:FF:000027', NULL, NULL, 'Aspartate carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(193739, NULL, 'G3DSA:2.60.120.370:FF:000004', NULL, NULL, 'Putative mannitol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(193740, NULL, 'G3DSA:1.20.140.150:FF:000065', NULL, NULL, 'GM16516', NULL, NULL, NULL, NULL, NULL, 4),
(193741, NULL, 'G3DSA:1.20.1070.10:FF:002026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193742, NULL, 'G3DSA:3.40.50.2300:FF:000430', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(193743, NULL, 'G3DSA:2.160.20.10:FF:000307', NULL, NULL, 'F-box protein 11a', NULL, NULL, NULL, NULL, NULL, 4),
(193744, NULL, 'G3DSA:3.30.499.10:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193745, NULL, 'G3DSA:2.60.40.1450:FF:000002', NULL, NULL, 'Recombination signal binding protein for immunoglobulin kappa J region like', NULL, NULL, NULL, NULL, NULL, 4),
(193746, NULL, 'G3DSA:3.40.50.10330:FF:000016', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(193747, NULL, 'G3DSA:1.20.1280.50:FF:000036', NULL, NULL, 'F-box and leucine rich repeat protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(193748, NULL, 'G3DSA:3.50.50.60:FF:000799', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193749, NULL, 'G3DSA:3.40.50.1820:FF:000842', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(193750, NULL, 'G3DSA:3.40.50.2000:FF:000930', NULL, NULL, 'Probable heptosyl III transferase', NULL, NULL, NULL, NULL, NULL, 4),
(193751, NULL, 'G3DSA:3.40.140.10:FF:000239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193752, NULL, 'G3DSA:3.90.70.10:FF:000379', NULL, NULL, 'Cysteine proteinases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(193753, NULL, 'G3DSA:2.60.40.10:FF:000628', NULL, NULL, 'Beta-glucuronidase', NULL, NULL, NULL, NULL, NULL, 4),
(193754, NULL, 'G3DSA:1.10.1600.10:FF:000007', NULL, NULL, 'Yeast Ku70 protein', NULL, NULL, NULL, NULL, NULL, 4),
(193755, NULL, 'G3DSA:3.90.1520.10:FF:000003', NULL, NULL, 'Guanylate cyclase soluble subunit alpha-2', NULL, NULL, NULL, NULL, NULL, 4),
(193756, NULL, 'G3DSA:3.30.70.1150:FF:000003', NULL, NULL, 'Acetolactate synthase, small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(193757, NULL, 'G3DSA:1.20.1160.20:FF:000018', NULL, NULL, 'Regulator of telomere elongation helicase 1', NULL, NULL, NULL, NULL, NULL, 4),
(193758, NULL, 'G3DSA:3.30.70.260:FF:000090', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(193759, NULL, 'G3DSA:2.130.10.10:FF:001702', NULL, NULL, 'AGAP000009-PB', NULL, NULL, NULL, NULL, NULL, 4),
(193760, NULL, 'G3DSA:2.60.210.10:FF:000031', NULL, NULL, 'TNF receptor-associated factor homolog 1b', NULL, NULL, NULL, NULL, NULL, 4),
(193761, NULL, 'G3DSA:1.10.510.10:FF:000956', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(193762, NULL, 'G3DSA:3.20.20.140:FF:000309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193763, NULL, 'G3DSA:1.20.58.60:FF:000199', NULL, NULL, 'Alpha spectrin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(193764, NULL, 'G3DSA:3.30.160.60:FF:006373', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193765, NULL, 'G3DSA:1.25.10.10:FF:000356', NULL, NULL, 'Putative huntingtin', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(193766, NULL, 'G3DSA:3.30.160.60:FF:005861', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193767, NULL, 'G3DSA:3.10.450.50:FF:000045', NULL, NULL, 'UBA/TS-N domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(193768, NULL, 'G3DSA:3.30.70.330:FF:000279', NULL, NULL, 'G-rich RNA sequence binding factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(193769, NULL, 'G3DSA:3.40.50.300:FF:006879', NULL, NULL, 'Branched-chain amino acid transport ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(193770, NULL, 'G3DSA:3.40.50.300:FF:003214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193771, NULL, 'G3DSA:3.40.50.1820:FF:001022', NULL, NULL, 'GPI inositol-deacylase A', NULL, NULL, NULL, NULL, NULL, 4),
(193772, NULL, 'G3DSA:2.20.25.10:FF:000050', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(193773, NULL, 'G3DSA:1.20.5.1160:FF:000003', NULL, NULL, 'protein enabled homolog isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(193774, NULL, 'G3DSA:3.40.50.970:FF:000150', NULL, NULL, 'Pyruvate dehydrogenase E1 component beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(193775, NULL, 'G3DSA:1.10.472.10:FF:000428', NULL, NULL, 'Mitotic cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(193776, NULL, 'G3DSA:4.10.280.10:FF:000230', NULL, NULL, 'Extra macrochaetae-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(193777, NULL, 'G3DSA:3.40.850.10:FF:000097', NULL, NULL, 'Myosin E, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193778, NULL, 'G3DSA:1.20.1280.50:FF:000143', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(193779, NULL, 'G3DSA:1.10.510.10:FF:000428', NULL, NULL, 'inactive serine/threonine-protein kinase TEX14 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(193780, NULL, 'G3DSA:3.60.15.10:FF:000141', NULL, NULL, 'Ribonuclease Z 1', NULL, NULL, NULL, NULL, NULL, 4),
(193781, NULL, 'G3DSA:1.10.472.10:FF:000058', NULL, NULL, 'cyclin-C1-2-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(193782, NULL, 'G3DSA:1.25.10.10:FF:001289', NULL, NULL, 'INTegrator complex Subunit homolog', NULL, NULL, NULL, NULL, NULL, 4),
(193783, NULL, 'G3DSA:3.40.50.10190:FF:000255', NULL, NULL, 'PIS (Pax-2, IA-1/6, Smad-2 interacting protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(193784, NULL, 'G3DSA:3.30.70.2510:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193785, NULL, 'G3DSA:1.20.1280.110:FF:000001', NULL, NULL, 'Effector protein HopAB2', NULL, NULL, NULL, NULL, NULL, 4),
(193786, NULL, 'G3DSA:4.10.49.10:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193787, NULL, 'G3DSA:3.40.50.300:FF:000466', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(193788, NULL, 'G3DSA:2.60.120.200:FF:000471', NULL, NULL, 'Crumbs cell polarity complex component 1', NULL, NULL, NULL, NULL, NULL, 4),
(193789, NULL, 'G3DSA:1.20.1270.20:FF:000010', NULL, NULL, 'Hybrid-cluster protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193790, NULL, 'G3DSA:2.30.29.30:FF:000272', NULL, NULL, 'Rho guanine nucleotide exchange factor 15', NULL, NULL, NULL, NULL, NULL, 4),
(193791, NULL, 'G3DSA:3.40.50.410:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193792, NULL, 'G3DSA:2.130.10.10:FF:005283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193793, NULL, 'G3DSA:1.20.5.550:FF:000002', NULL, NULL, 'Bifunctional protein PutA', NULL, NULL, NULL, NULL, NULL, 4),
(193794, NULL, 'G3DSA:1.10.287.690:FF:000005', NULL, NULL, 'DNA polymerase epsilon catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(193795, NULL, 'G3DSA:1.25.40.10:FF:004562', NULL, NULL, 'Tetratricopeptide repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193796, NULL, 'G3DSA:3.30.1130.10:FF:000004', NULL, NULL, 'NADPH-dependent 7-cyano-7-deazaguanine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(193797, NULL, 'G3DSA:1.20.1070.10:FF:000481', NULL, NULL, 'AGAP001379-PA', NULL, NULL, NULL, NULL, NULL, 4),
(193798, NULL, 'G3DSA:3.30.160.60:FF:003927', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(193799, NULL, 'G3DSA:1.20.144.10:FF:000007', NULL, NULL, 'phospholipid phosphatase 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(193800, NULL, 'G3DSA:1.10.510.10:FF:003290', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193801, NULL, 'G3DSA:1.10.357.140:FF:000014', NULL, NULL, '4-hydroxybenzoate polyprenyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(193802, NULL, 'G3DSA:3.60.21.10:FF:000447', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193803, NULL, 'G3DSA:1.25.40.10:FF:000184', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(193804, NULL, 'G3DSA:2.60.60.20:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193805, NULL, 'G3DSA:3.30.70.141:FF:000043', NULL, NULL, 'Nucleoside diphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(193806, NULL, 'G3DSA:3.30.40.10:FF:001881', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193807, NULL, 'G3DSA:2.10.25.10:FF:001444', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(193808, NULL, 'G3DSA:1.10.8.270:FF:000038', NULL, NULL, 'Ypt/Rab-GAP domain of gyp1p superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(193809, NULL, 'G3DSA:3.30.40.10:FF:000734', NULL, NULL, 'PHD finger family protein', NULL, NULL, NULL, NULL, NULL, 4),
(193810, NULL, 'G3DSA:1.25.40.20:FF:000973', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193811, NULL, 'G3DSA:3.40.50.1820:FF:001819', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193812, NULL, 'G3DSA:3.10.20.90:FF:000959', NULL, NULL, 'FERM, ARH/RhoGEF and pleckstrin domain protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(193813, NULL, 'G3DSA:2.30.42.10:FF:000246', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(193814, NULL, 'G3DSA:1.10.287.130:FF:000051', NULL, NULL, 'Two-component system sensor histidine kinase CreC', NULL, NULL, NULL, NULL, NULL, 4),
(193815, NULL, 'G3DSA:3.40.50.300:FF:005098', NULL, NULL, 'Arsenical pump-driving ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(193816, NULL, 'G3DSA:2.60.120.650:FF:000127', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(193817, NULL, 'G3DSA:1.10.10.10:FF:001665', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(193818, NULL, 'G3DSA:3.30.70.330:FF:002622', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193819, NULL, 'G3DSA:3.20.20.330:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193820, NULL, 'G3DSA:3.40.50.880:FF:000151', NULL, NULL, 'Peptidase E', NULL, NULL, NULL, NULL, NULL, 4),
(193821, NULL, 'G3DSA:1.25.40.10:FF:000291', NULL, NULL, 'Pentatricopeptide repeat-containing protein PPR5, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(193822, NULL, 'G3DSA:1.10.486.10:FF:000022', NULL, NULL, 'Unplaced genomic scaffold supercont2.6, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(193823, NULL, 'G3DSA:3.40.50.80:FF:000098', NULL, NULL, 'Respiratory burst oxidase-like protein F isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(193824, NULL, 'G3DSA:3.90.1180.10:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193825, NULL, 'G3DSA:1.10.510.10:FF:001373', NULL, NULL, 'Ser/Thr protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193826, NULL, 'G3DSA:1.10.8.60:FF:000381', NULL, NULL, 'Checkpoint protein rad17', NULL, NULL, NULL, NULL, NULL, 4),
(193827, NULL, 'G3DSA:1.25.40.20:FF:000496', NULL, NULL, 'Zinc finger CCCH domain-containing protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(193828, NULL, 'G3DSA:1.20.1270.60:FF:000230', NULL, NULL, 'AaceriABR082Wp', NULL, NULL, NULL, NULL, NULL, 4),
(193829, NULL, 'G3DSA:3.30.420.40:FF:001082', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(193830, NULL, 'G3DSA:2.10.25.10:FF:000039', NULL, NULL, 'Crumbs cell polarity complex component 1', NULL, NULL, NULL, NULL, NULL, 4),
(193831, NULL, 'G3DSA:3.30.60.20:FF:000154', NULL, NULL, 'Protein kinase D4', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(193832, NULL, 'G3DSA:1.10.238.10:FF:000840', NULL, NULL, 'EF-hand domain pair/EF-hand domain/EF hand, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193833, NULL, 'G3DSA:3.40.30.10:FF:000328', NULL, NULL, 'Mitochondrial ribosomal protein L51 / S25 / CI-B8 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(193834, NULL, 'G3DSA:2.30.42.10:FF:000611', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193835, NULL, 'G3DSA:3.40.50.970:FF:000043', NULL, NULL, 'IlvB acetolactate synthase like', NULL, NULL, NULL, NULL, NULL, 4),
(193836, NULL, 'G3DSA:2.60.40.10:FF:004467', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193837, NULL, 'G3DSA:3.40.50.300:FF:002225', NULL, NULL, 'ATP-dependent RNA helicase DOB1', NULL, NULL, NULL, NULL, NULL, 4),
(193838, NULL, 'G3DSA:1.20.1560.10:FF:000237', NULL, NULL, 'ATP-binding cassette protein subfamily C, member 8', NULL, NULL, NULL, NULL, NULL, 4),
(193839, NULL, 'G3DSA:3.40.50.720:FF:002273', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(193840, NULL, 'G3DSA:3.30.390.30:FF:000018', NULL, NULL, 'Monodehydroascorbate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(193841, NULL, 'G3DSA:2.60.120.1560:FF:000007', NULL, NULL, 'Uncharacterized membrane protein YFL051C', NULL, NULL, NULL, NULL, NULL, 4),
(193842, NULL, 'G3DSA:3.40.33.10:FF:000161', NULL, NULL, 'Protein CBG03516', NULL, NULL, NULL, NULL, NULL, 4),
(193843, NULL, 'G3DSA:3.10.430.100:FF:000010', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(193844, NULL, 'G3DSA:3.40.50.300:FF:006626', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(193845, NULL, 'G3DSA:1.20.142.10:FF:000020', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(193846, NULL, 'G3DSA:1.20.1560.10:FF:000765', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(193847, NULL, 'G3DSA:1.25.50.20:FF:000103', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(193848, NULL, 'G3DSA:3.30.450.60:FF:000021', NULL, NULL, 'signal recognition particle receptor subunit alpha isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(193849, NULL, 'G3DSA:2.60.40.10:FF:002989', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(193850, NULL, 'G3DSA:2.60.120.10:FF:000597', NULL, NULL, 'Cyclic nucleotide-binding domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(193851, NULL, 'G3DSA:3.90.1150.10:FF:000194', NULL, NULL, '2-aminoethylphosphonate--pyruvate transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(193852, NULL, 'G3DSA:1.10.1060.10:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193853, NULL, 'G3DSA:1.25.40.10:FF:004343', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193854, NULL, 'G3DSA:3.90.1150.10:FF:000205', NULL, NULL, 'Aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(193855, NULL, 'G3DSA:1.10.150.240:FF:000107', NULL, NULL, 'AAL123Wp', NULL, NULL, NULL, NULL, NULL, 4),
(193856, NULL, 'G3DSA:3.30.160.60:FF:003028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193857, NULL, 'G3DSA:1.50.40.10:FF:000575', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193858, NULL, 'G3DSA:3.30.310.40:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193859, NULL, 'G3DSA:1.25.40.990:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193860, NULL, 'G3DSA:3.10.100.10:FF:000417', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193861, NULL, 'G3DSA:3.80.10.10:FF:002017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193862, NULL, 'G3DSA:2.70.40.10:FF:000004', NULL, NULL, 'Deoxyuridine triphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(193863, NULL, 'G3DSA:3.30.420.40:FF:000570', NULL, NULL, 'Acetate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(193864, NULL, 'G3DSA:1.20.1560.10:FF:000080', NULL, NULL, 'ABC transporter C family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(193865, NULL, 'G3DSA:3.40.50.300:FF:007571', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(193866, NULL, 'G3DSA:2.60.40.10:FF:002562', NULL, NULL, 'Beta-glucosidase BglS', NULL, NULL, NULL, NULL, NULL, 4),
(193867, NULL, 'G3DSA:3.30.1370.10:FF:000022', NULL, NULL, 'RNA-binding protein Nova-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(193868, NULL, 'G3DSA:3.40.50.150:FF:001421', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193869, NULL, 'G3DSA:3.30.200.20:FF:002374', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(193870, NULL, 'G3DSA:1.50.10.20:FF:000065', NULL, NULL, 'Complement component C3B', NULL, NULL, NULL, NULL, NULL, 4),
(193871, NULL, 'G3DSA:3.40.50.1000:FF:000383', NULL, NULL, 'Phosphorylated carbohydrates phosphatase TM_1254', NULL, NULL, NULL, NULL, NULL, 4),
(193872, NULL, 'G3DSA:1.10.533.20:FF:000001', NULL, NULL, 'NLR family CARD domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(193873, NULL, 'G3DSA:3.30.1330.80:FF:000006', NULL, NULL, 'AT-hook motif nuclear-localized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193874, NULL, 'G3DSA:1.10.8.60:FF:000162', NULL, NULL, 'ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193875, NULL, 'G3DSA:3.40.50.300:FF:001736', NULL, NULL, 'COMF operon protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(193876, NULL, 'G3DSA:1.20.272.10:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193877, NULL, 'G3DSA:2.10.110.10:FF:000309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193878, NULL, 'G3DSA:1.10.560.10:FF:000139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193879, NULL, 'G3DSA:3.90.190.10:FF:000164', NULL, NULL, 'GM24530', NULL, NULL, NULL, NULL, NULL, 4),
(193880, NULL, 'G3DSA:3.20.20.10:FF:000020', NULL, NULL, 'S-adenosylmethionine decarboxylase/ornithine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(193881, NULL, 'G3DSA:3.30.70.330:FF:002752', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193882, NULL, 'G3DSA:3.40.30.10:FF:000019', NULL, NULL, 'Glutathione S-transferase Mu', NULL, NULL, NULL, NULL, NULL, 4),
(193883, NULL, 'G3DSA:3.20.20.70:FF:000779', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193884, NULL, 'G3DSA:3.30.70.330:FF:002257', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193885, NULL, 'G3DSA:3.30.70.1230:FF:000038', NULL, NULL, 'soluble guanylate cyclase 89Da', NULL, NULL, NULL, NULL, NULL, 4),
(193886, NULL, 'G3DSA:3.30.70.640:FF:000001', NULL, NULL, 'Cyclic pyranopterin monophosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(193887, NULL, 'G3DSA:1.20.1070.10:FF:000109', NULL, NULL, 'Leukotriene B4 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(193888, NULL, 'G3DSA:3.30.1330.30:FF:000110', NULL, NULL, 'YALI0B20658p', NULL, NULL, NULL, NULL, NULL, 4),
(193889, NULL, 'G3DSA:1.25.40.20:FF:001805', NULL, NULL, 'Protein CBR-DAPK-1', NULL, NULL, NULL, NULL, NULL, 4),
(193890, NULL, 'G3DSA:1.10.1040.10:FF:000020', NULL, NULL, 'D-mannonate oxidoreductase, NAD-binding', NULL, NULL, NULL, NULL, NULL, 4),
(193891, NULL, 'G3DSA:2.130.10.10:FF:005608', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(193892, NULL, 'G3DSA:3.40.630.20:FF:000004', NULL, NULL, 'Pyroglutamyl-peptidase I like', NULL, NULL, NULL, NULL, NULL, 4),
(193893, NULL, 'G3DSA:3.40.630.10:FF:000456', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193894, NULL, 'G3DSA:3.30.720.110:FF:000001', NULL, NULL, 'Phenazine antibiotic resistance protein EhpR', NULL, NULL, NULL, NULL, NULL, 4),
(193895, NULL, 'G3DSA:3.10.290.70:FF:000010', NULL, NULL, '40S ribosomal protein S8', NULL, NULL, NULL, NULL, NULL, 4),
(193896, NULL, 'G3DSA:1.25.40.10:FF:002089', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(193897, NULL, 'G3DSA:3.90.550.20:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193898, NULL, 'G3DSA:2.40.30.330:FF:000008', NULL, NULL, 'ATP/GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193899, NULL, 'G3DSA:3.30.420.40:FF:000098', NULL, NULL, 'ARP5 actin-related protein 5 homolog', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(193900, NULL, 'G3DSA:3.30.420.10:FF:000246', NULL, NULL, 'CCR4-NOT transcription complex,subunit 7-like', NULL, NULL, NULL, NULL, NULL, 4),
(193901, NULL, 'G3DSA:2.60.120.10:FF:000602', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193902, NULL, 'G3DSA:3.30.420.10:FF:000555', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193903, NULL, 'G3DSA:1.20.1250.20:FF:002234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193904, NULL, 'G3DSA:1.20.1250.40:FF:000003', NULL, NULL, 'DNA-directed RNA polymerase II subunit rpb4', NULL, NULL, NULL, NULL, NULL, 4),
(193905, NULL, 'G3DSA:3.90.1240.10:FF:000004', NULL, NULL, 'Botulinum neurotoxin type D', NULL, NULL, NULL, NULL, NULL, 4),
(193906, NULL, 'G3DSA:3.40.50.300:FF:006087', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(193907, NULL, 'G3DSA:1.10.150.50:FF:000210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193908, NULL, 'G3DSA:6.10.140.2220:FF:000066', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(193909, NULL, 'G3DSA:3.30.479.30:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193910, NULL, 'G3DSA:2.60.40.10:FF:003051', NULL, NULL, 'Interleukin-1 receptor type I', NULL, NULL, NULL, NULL, NULL, 4),
(193911, NULL, 'G3DSA:1.10.1200.10:FF:000022', NULL, NULL, 'Polyketide synthase Pks13', NULL, NULL, NULL, NULL, NULL, 4),
(193912, NULL, 'G3DSA:3.40.50.720:FF:001654', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(193913, NULL, 'G3DSA:3.30.450.40:FF:000279', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(193914, NULL, 'G3DSA:3.50.50.80:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193915, NULL, 'G3DSA:1.20.20.10:FF:000024', NULL, NULL, 'ATP synthase F(0) complex subunit C1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(193916, NULL, 'G3DSA:3.30.160.60:FF:004439', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193917, NULL, 'G3DSA:1.20.58.60:FF:000536', NULL, NULL, 'Spectrin repeat containing nuclear envelope family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(193918, NULL, 'G3DSA:3.40.710.10:FF:000148', NULL, NULL, 'Penicillin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(193919, NULL, 'G3DSA:1.10.287.130:FF:000181', NULL, NULL, 'HAMP domain-containing histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(193920, NULL, 'G3DSA:3.20.140.10:FF:000002', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(193921, NULL, 'G3DSA:3.30.70.940:FF:000001', NULL, NULL, 'Transcription termination/antitermination protein NusG', NULL, NULL, NULL, NULL, NULL, 4),
(193922, NULL, 'G3DSA:3.40.50.2020:FF:000014', NULL, NULL, 'Ribose-phosphate pyrophosphokinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(193923, NULL, 'G3DSA:2.10.25.10:FF:001663', NULL, NULL, 'Crumbs 1, cell polarity complex component', NULL, NULL, NULL, NULL, NULL, 4),
(193924, NULL, 'G3DSA:3.40.50.10140:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193925, NULL, 'G3DSA:3.10.310.50:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193926, NULL, 'G3DSA:1.25.40.20:FF:001030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193927, NULL, 'G3DSA:3.40.50.300:FF:000775', NULL, NULL, 'Iron(III) dicitrate ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(193928, NULL, 'G3DSA:3.30.160.60:FF:001230', NULL, NULL, 'zinc finger protein WIP2-like', NULL, NULL, NULL, NULL, NULL, 4),
(193929, NULL, 'G3DSA:1.20.1050.10:FF:000007', NULL, NULL, 'Glutathione S-transferase 1-1', NULL, NULL, NULL, NULL, NULL, 4),
(193930, NULL, 'G3DSA:3.40.605.10:FF:000134', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(193931, NULL, 'G3DSA:2.120.10.80:FF:000346', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193932, NULL, 'G3DSA:3.90.1200.10:FF:000002', NULL, NULL, 'Ethanolamine kinase 1', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(193933, NULL, 'G3DSA:3.30.470.30:FF:000036', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(193934, NULL, 'G3DSA:1.10.260.170:FF:000009', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', NULL, NULL, NULL, NULL, NULL, 4),
(193935, NULL, 'G3DSA:3.30.470.10:FF:000030', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(193936, NULL, 'G3DSA:3.40.1110.10:FF:000315', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193937, NULL, 'G3DSA:3.10.310.30:FF:000001', NULL, NULL, 'Single-stranded-DNA-specific exonuclease recJ', NULL, NULL, NULL, NULL, NULL, 4),
(193938, NULL, 'G3DSA:2.60.120.590:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193939, NULL, 'G3DSA:2.40.50.140:FF:000702', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193940, NULL, 'G3DSA:1.25.40.10:FF:000509', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g16390, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(193941, NULL, 'G3DSA:3.30.200.20:FF:001413', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193942, NULL, 'G3DSA:3.90.70.10:FF:000688', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193943, NULL, 'G3DSA:3.40.47.10:FF:000007', NULL, NULL, 'acetyl-CoA acetyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(193944, NULL, 'G3DSA:4.10.60.10:FF:000048', NULL, NULL, 'CCHC-type zinc finger protein CG3800', NULL, NULL, NULL, NULL, NULL, 4),
(193945, NULL, 'G3DSA:3.30.420.10:FF:000241', NULL, NULL, 'Ribonuclease H', NULL, NULL, NULL, NULL, NULL, 4),
(193946, NULL, 'G3DSA:1.25.10.10:FF:001284', NULL, NULL, 'EXPOrtin (Nuclear export receptor)', NULL, NULL, NULL, NULL, NULL, 4),
(193947, NULL, 'G3DSA:3.40.50.300:FF:008560', NULL, NULL, 'G-protein alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(193948, NULL, 'G3DSA:3.30.200.20:FF:001885', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(193949, NULL, 'G3DSA:1.10.10.10:FF:000844', NULL, NULL, 'MCM family protein', NULL, NULL, NULL, NULL, NULL, 4),
(193950, NULL, 'G3DSA:3.30.160.60:FF:001027', NULL, NULL, 'Zinc finger protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(193951, NULL, 'G3DSA:3.40.50.620:FF:000522', NULL, NULL, 'tRNA synthetases class I-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(193952, NULL, 'G3DSA:3.30.450.20:FF:000616', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193953, NULL, 'G3DSA:1.10.357.140:FF:000037', NULL, NULL, 'Protoheme IX farnesyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(193954, NULL, 'G3DSA:3.60.40.10:FF:000210', NULL, NULL, 'Putative protein phosphatase 2C 63', NULL, NULL, NULL, NULL, NULL, 4),
(193955, NULL, 'G3DSA:1.25.40.10:FF:000167', NULL, NULL, 'Mitochondrial fission 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(193956, NULL, 'G3DSA:2.60.34.10:FF:000029', NULL, NULL, 'Ssz1p', NULL, NULL, NULL, NULL, NULL, 4),
(193957, NULL, 'G3DSA:2.40.170.20:FF:000040', NULL, NULL, 'Transferrin-binding protein 1 Tbp1', NULL, NULL, NULL, NULL, NULL, 4),
(193958, NULL, 'G3DSA:1.20.1250.20:FF:000891', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(193959, NULL, 'G3DSA:2.60.120.260:FF:000207', NULL, NULL, 'SD03917p', NULL, NULL, NULL, NULL, NULL, 4),
(193960, NULL, 'G3DSA:2.60.410.10:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193961, NULL, 'G3DSA:3.50.50.60:FF:001440', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(193962, NULL, 'G3DSA:1.10.150.20:FF:000302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193963, NULL, 'G3DSA:2.30.30.380:FF:000031', NULL, NULL, 'Rhomboid-like protein 14 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(193964, NULL, 'G3DSA:3.30.830.10:FF:000249', NULL, NULL, 'Mitochondrial processing peptidase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(193965, NULL, 'G3DSA:1.20.1270.60:FF:000235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193966, NULL, 'G3DSA:3.40.50.2300:FF:000683', NULL, NULL, 'Receptor-type guanylate cyclase gcy-21', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(193967, NULL, 'G3DSA:2.30.30.140:FF:000083', NULL, NULL, 'Tudor domain containing 6', NULL, NULL, NULL, NULL, NULL, 4),
(193968, NULL, 'G3DSA:1.10.486.10:FF:000005', NULL, NULL, 'ATP-dependent DNA helicase pcrA', NULL, NULL, NULL, NULL, NULL, 4),
(193969, NULL, 'G3DSA:1.10.357.30:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193970, NULL, 'G3DSA:2.60.40.10:FF:004012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193971, NULL, 'G3DSA:1.10.510.10:FF:001356', NULL, NULL, 'Protein kinase like protein', NULL, NULL, NULL, NULL, NULL, 4),
(193972, NULL, 'G3DSA:1.20.1310.10:FF:000073', NULL, NULL, 'Anaphase-promoting complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(193973, NULL, 'G3DSA:1.10.287.70:FF:000454', NULL, NULL, 'G protein-activated inward rectifier potassium channel 4', NULL, NULL, NULL, NULL, NULL, 4),
(193974, NULL, 'G3DSA:1.25.10.10:FF:001761', NULL, NULL, 'Importin-11', NULL, NULL, NULL, NULL, NULL, 4),
(193975, NULL, 'G3DSA:3.10.129.10:FF:000028', NULL, NULL, '(3R)-hydroxyacyl-ACP dehydratase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(193976, NULL, 'G3DSA:2.130.10.10:FF:004299', NULL, NULL, 'Anaphase-promoting complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(193977, NULL, 'G3DSA:2.40.50.150:FF:000020', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(193978, NULL, 'G3DSA:4.10.410.10:FF:000061', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(193979, NULL, 'G3DSA:3.20.20.60:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193980, NULL, 'G3DSA:2.60.120.290:FF:000115', NULL, NULL, 'LEV-10A protein', NULL, NULL, NULL, NULL, NULL, 4),
(193981, NULL, 'G3DSA:1.25.40.20:FF:000041', NULL, NULL, 'ankyrin repeat and KH domain-containing protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(193982, NULL, 'G3DSA:2.40.30.130:FF:000044', NULL, NULL, 'Threonyl/alanyl tRNA synthetase SAD', NULL, NULL, NULL, NULL, NULL, 4),
(193983, NULL, 'G3DSA:3.40.640.10:FF:000412', NULL, NULL, 'Alanine aminotransferase 2 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(193984, NULL, 'G3DSA:1.20.58.1880:FF:000011', NULL, NULL, 'Putative MYB DNA-binding domain superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(193985, NULL, 'G3DSA:3.30.70.250:FF:000007', NULL, NULL, 'Malonyl CoA-acyl carrier protein transacylase', NULL, NULL, NULL, NULL, NULL, 4),
(193986, NULL, 'G3DSA:1.20.5.520:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193987, NULL, 'G3DSA:2.120.10.90:FF:000012', NULL, NULL, 'DNA gyrase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(193988, NULL, 'G3DSA:3.40.50.300:FF:000882', NULL, NULL, 'Translation initiation regulator (Gcn20)', NULL, NULL, NULL, NULL, NULL, 4),
(193989, NULL, 'G3DSA:3.40.50.2000:FF:000458', NULL, NULL, 'Putative polysaccharide biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(193990, NULL, 'G3DSA:1.20.1070.10:FF:002043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193991, NULL, 'G3DSA:1.10.510.10:FF:002901', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(193992, NULL, 'G3DSA:2.30.30.40:FF:000166', NULL, NULL, 'RIM-binding protein, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(193993, NULL, 'G3DSA:1.25.40.10:FF:001128', NULL, NULL, 'HMG-CoA reductase degradation protein', NULL, NULL, NULL, NULL, NULL, 4),
(193994, NULL, 'G3DSA:2.130.10.10:FF:004647', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193995, NULL, 'G3DSA:2.130.10.10:FF:004794', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(193996, NULL, 'G3DSA:2.60.40.10:FF:001264', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(193997, NULL, 'G3DSA:2.10.109.10:FF:000008', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(193998, NULL, 'G3DSA:2.130.10.10:FF:001921', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(193999, NULL, 'G3DSA:3.10.110.10:FF:000019', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 variant 1C', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(194000, NULL, 'G3DSA:2.60.120.1540:FF:000001', NULL, NULL, 'Complement C4-A', NULL, NULL, NULL, NULL, NULL, 4),
(194001, NULL, 'G3DSA:3.40.570.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194002, NULL, 'G3DSA:1.10.10.60:FF:000365', NULL, NULL, 'Homeobox protein ceh-14', NULL, NULL, NULL, NULL, NULL, 4),
(194003, NULL, 'G3DSA:3.40.190.290:FF:000127', NULL, NULL, 'Rubisco operon transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(194004, NULL, 'G3DSA:1.25.10.10:FF:002464', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194005, NULL, 'G3DSA:3.40.50.300:FF:005322', NULL, NULL, 'Shikimate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(194006, NULL, 'G3DSA:1.10.3720.10:FF:000073', NULL, NULL, 'Nickel ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(194007, NULL, 'G3DSA:2.60.40.10:FF:002197', NULL, NULL, 'T-cell antigen CD7', NULL, NULL, NULL, NULL, NULL, 4),
(194008, NULL, 'G3DSA:3.40.47.10:FF:000187', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194009, NULL, 'G3DSA:3.30.565.10:FF:000464', NULL, NULL, 'Putative MLH3, MutL protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(194010, NULL, 'G3DSA:3.30.505.10:FF:000123', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(194011, NULL, 'G3DSA:3.90.190.10:FF:000034', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type 13', NULL, NULL, NULL, NULL, NULL, 4),
(194012, NULL, 'G3DSA:3.40.50.300:FF:005137', NULL, NULL, 'Putative prophage LambdaBa04, terminase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(194013, NULL, 'G3DSA:3.40.50.300:FF:004698', NULL, NULL, 'Dynein beta chain, ciliary', NULL, NULL, NULL, NULL, NULL, 4),
(194014, NULL, 'G3DSA:1.10.510.10:FF:000973', NULL, NULL, 'Serine/threonine kinase 16', NULL, NULL, NULL, NULL, NULL, 4),
(194015, NULL, 'G3DSA:2.130.10.10:FF:000376', NULL, NULL, 'F-box and WD repeat domain containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(194016, NULL, 'G3DSA:2.70.170.10:FF:000154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194017, NULL, 'G3DSA:2.60.40.10:FF:003490', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194018, NULL, 'G3DSA:1.10.510.10:FF:004099', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194019, NULL, 'G3DSA:3.40.50.150:FF:000269', NULL, NULL, 'Methyltransferase-like protein 7A', NULL, NULL, NULL, NULL, NULL, 4),
(194020, NULL, 'G3DSA:2.130.10.10:FF:005592', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(194021, NULL, 'G3DSA:1.25.50.10:FF:000010', NULL, NULL, 'Aminopeptidase N', NULL, NULL, NULL, NULL, NULL, 4),
(194022, NULL, 'G3DSA:3.20.20.140:FF:000326', NULL, NULL, 'Error-prone DNA polymerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(194023, NULL, 'G3DSA:3.30.160.60:FF:005844', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194024, NULL, 'G3DSA:1.20.142.10:FF:000025', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(194025, NULL, 'G3DSA:3.40.50.720:FF:001761', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194026, NULL, 'G3DSA:3.30.200.20:FF:000581', NULL, NULL, 'Wall-associated receptor kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(194027, NULL, 'G3DSA:3.30.70.2850:FF:000007', NULL, NULL, 'DNA-directed RNA polymerase I subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(194028, NULL, 'G3DSA:3.40.390.10:FF:000050', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(194029, NULL, 'G3DSA:3.30.540.10:FF:000058', NULL, NULL, 'Fructose-1,6-bisphosphatase/inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(194030, NULL, 'G3DSA:3.40.30.70:FF:000003', NULL, NULL, 'Probable GUS1-Glutamyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(194031, NULL, 'G3DSA:3.40.50.10860:FF:000063', NULL, NULL, 'Shikimate 5-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(194032, NULL, 'G3DSA:3.40.50.1460:FF:000026', NULL, NULL, 'Caspase 2, apoptosis-related cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(194033, NULL, 'G3DSA:1.10.510.10:FF:000737', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(194034, NULL, 'G3DSA:3.90.190.10:FF:000181', NULL, NULL, 'Putative tyrosine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(194035, NULL, 'G3DSA:3.40.50.1440:FF:000020', NULL, NULL, 'protein misato homolog 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(194036, NULL, 'G3DSA:1.20.272.10:FF:000029', NULL, NULL, 'Replication factor C small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(194037, NULL, 'G3DSA:4.10.1000.10:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194038, NULL, 'G3DSA:2.130.10.10:FF:004664', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194039, NULL, 'G3DSA:1.25.10.10:FF:001845', NULL, NULL, 'Importin 4', NULL, NULL, NULL, NULL, NULL, 4),
(194040, NULL, 'G3DSA:3.40.630.10:FF:000439', NULL, NULL, 'Nicastrin', NULL, NULL, NULL, NULL, NULL, 4),
(194041, NULL, 'G3DSA:1.10.10.60:FF:000730', NULL, NULL, 'homeobox protein slou', NULL, NULL, NULL, NULL, NULL, 4),
(194042, NULL, 'G3DSA:3.40.50.720:FF:000350', NULL, NULL, 'Enoyl-[acyl-carrier-protein] reductase [NADH]', NULL, NULL, NULL, NULL, NULL, 4),
(194043, NULL, 'G3DSA:1.10.287.70:FF:000763', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194044, NULL, 'G3DSA:1.10.238.10:FF:000475', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194045, NULL, 'G3DSA:2.60.40.1180:FF:000005', NULL, NULL, 'Maltase-glucoamylase, intestinal', NULL, NULL, NULL, NULL, NULL, 4),
(194046, NULL, 'G3DSA:1.10.510.10:FF:001721', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(194047, NULL, 'G3DSA:1.20.5.190:FF:000079', NULL, NULL, 'Myosin VIIB', NULL, NULL, NULL, NULL, NULL, 4),
(194048, NULL, 'G3DSA:2.60.40.10:FF:004670', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194049, NULL, 'G3DSA:2.10.220.10:FF:000110', NULL, NULL, 'High cysteine membrane protein TMK-like', NULL, NULL, NULL, NULL, NULL, 4),
(194050, NULL, 'G3DSA:3.40.1160.10:FF:000026', NULL, NULL, 'N-acetylglutamate synthase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(194051, NULL, 'G3DSA:1.20.1050.40:FF:000005', NULL, NULL, 'Metallopeptidase MepB', NULL, NULL, NULL, NULL, NULL, 4),
(194052, NULL, 'G3DSA:3.30.70.3280:FF:000001', NULL, NULL, 'Peptide chain release factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(194053, NULL, 'G3DSA:1.10.8.270:FF:000055', NULL, NULL, 'TBC1 domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194054, NULL, 'G3DSA:1.25.40.10:FF:003601', NULL, NULL, 'Tetratricopeptide repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(194055, NULL, 'G3DSA:3.30.200.20:FF:001992', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(194056, NULL, 'G3DSA:2.130.10.10:FF:000393', NULL, NULL, 'Phosphoinositide 3-kinase regulatory subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(194057, NULL, 'G3DSA:3.75.10.10:FF:000006', NULL, NULL, 'Eukaryotic translation initiation factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(194058, NULL, 'G3DSA:2.130.10.10:FF:004428', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194059, NULL, 'G3DSA:2.30.40.10:FF:000101', NULL, NULL, 'Adenine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(194060, NULL, 'G3DSA:1.20.1050.130:FF:000040', NULL, NULL, 'Phenylalanyl-tRNA synthetase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(194061, NULL, 'G3DSA:2.40.500.10:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194062, NULL, 'G3DSA:2.10.220.10:FF:000071', NULL, NULL, 'Gal/GalNAc lectin Igl2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194063, NULL, 'G3DSA:1.10.10.60:FF:000382', NULL, NULL, 'Transcription activator snf2l1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194064, NULL, 'G3DSA:3.30.160.60:FF:001819', NULL, NULL, 'zinc finger protein 407', NULL, NULL, NULL, NULL, NULL, 4),
(194065, NULL, 'G3DSA:2.130.10.10:FF:004119', NULL, NULL, 'Coronin, actin-binding protein, 1A', NULL, NULL, NULL, NULL, NULL, 4),
(194066, NULL, 'G3DSA:1.20.1250.70:FF:000001', NULL, NULL, 'Interleukin', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(194067, NULL, 'G3DSA:1.20.930.20:FF:000005', NULL, NULL, 'Mixed lineage kinase domain-like pseudokinase', NULL, NULL, NULL, NULL, NULL, 4),
(194068, NULL, 'G3DSA:3.40.50.300:FF:004142', NULL, NULL, 'ATP-dependent Clp protease ATP-binding subunit ClpX', NULL, NULL, NULL, NULL, NULL, 4),
(194069, NULL, 'G3DSA:3.40.50.700:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194070, NULL, 'G3DSA:3.40.50.300:FF:000808', NULL, NULL, 'Small GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194071, NULL, 'G3DSA:2.130.10.10:FF:000741', NULL, NULL, 'Angio-associated migratory cell protein', NULL, NULL, NULL, NULL, NULL, 4),
(194072, NULL, 'G3DSA:3.10.580.10:FF:000032', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(194073, NULL, 'G3DSA:3.30.160.60:FF:006480', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194074, NULL, 'G3DSA:1.25.10.10:FF:000339', NULL, NULL, 'Microtubule-associated protein TORTIFOLIA1', NULL, NULL, NULL, NULL, NULL, 4),
(194075, NULL, 'G3DSA:1.10.510.10:FF:001226', NULL, NULL, 'NimA-related protein kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(194076, NULL, 'G3DSA:3.30.420.360:FF:000002', NULL, NULL, 'Carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(194077, NULL, 'G3DSA:3.30.70.340:FF:000006', NULL, NULL, 'GD14014', NULL, NULL, NULL, NULL, NULL, 4),
(194078, NULL, 'G3DSA:3.90.650.10:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194079, NULL, 'G3DSA:3.40.50.300:FF:004518', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(194080, NULL, 'G3DSA:1.10.510.10:FF:001592', NULL, NULL, 'Peripheral plasma membrane protein CASK', NULL, NULL, NULL, NULL, NULL, 4),
(194081, NULL, 'G3DSA:2.60.40.10:FF:005316', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194082, NULL, 'G3DSA:1.20.80.10:FF:000005', NULL, NULL, 'FERM, RhoGEF and pleckstrin domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(194083, NULL, 'G3DSA:4.10.1240.10:FF:000016', NULL, NULL, 'Vasoactive intestinal peptide receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(194084, NULL, 'G3DSA:2.60.40.1090:FF:000006', NULL, NULL, 'Fimbrial protein SthA', NULL, NULL, NULL, NULL, NULL, 4),
(194085, NULL, 'G3DSA:3.40.430.10:FF:000003', NULL, NULL, 'Bifunctional dihydrofolate reductase-thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(194086, NULL, 'G3DSA:3.40.50.300:FF:000090', NULL, NULL, 'Elongation factor 1-alpha', NULL, NULL, NULL, NULL, NULL, 4),
(194087, NULL, 'G3DSA:3.40.50.2000:FF:000328', NULL, NULL, 'Putative ADP-heptose--LPS heptosyltransferase II', NULL, NULL, NULL, NULL, NULL, 4),
(194088, NULL, 'G3DSA:1.25.40.10:FF:002292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194089, NULL, 'G3DSA:1.10.1790.20:FF:000001', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(194090, NULL, 'G3DSA:2.10.10.10:FF:000005', NULL, NULL, 'Epididymal sperm binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(194091, NULL, 'G3DSA:2.10.70.10:FF:000115', NULL, NULL, 'Zona pellucida sperm-binding protein 3 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(194092, NULL, 'G3DSA:2.30.29.30:FF:000519', NULL, NULL, 'Muscle M-line assembly protein unc-89-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(194093, NULL, 'G3DSA:1.20.1250.20:FF:001756', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194094, NULL, 'G3DSA:2.10.109.10:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194095, NULL, 'G3DSA:1.10.287.1490:FF:000089', NULL, NULL, 'TNFAIP3-interacting protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(194096, NULL, 'G3DSA:1.10.150.20:FF:000297', NULL, NULL, 'PolI-like DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(194097, NULL, 'G3DSA:1.20.1560.10:FF:000872', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194098, NULL, 'G3DSA:3.30.160.60:FF:004916', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194099, NULL, 'G3DSA:2.60.120.200:FF:000476', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(194100, NULL, 'G3DSA:1.10.8.1220:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194101, NULL, 'G3DSA:2.60.120.10:FF:000125', NULL, NULL, 'Transcriptional activator ChrR', NULL, NULL, NULL, NULL, NULL, 4),
(194102, NULL, 'G3DSA:3.30.565.10:FF:000380', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(194103, NULL, 'G3DSA:1.10.287.470:FF:000035', NULL, NULL, 'Component of multidrug efflux system', NULL, NULL, NULL, NULL, NULL, 4),
(194104, NULL, 'G3DSA:3.90.226.10:FF:000354', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194105, NULL, 'G3DSA:3.90.1150.10:FF:000458', NULL, NULL, 'Serine palmitoyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(194106, NULL, 'G3DSA:3.30.70.330:FF:000835', NULL, NULL, 'RNA binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194107, NULL, 'G3DSA:2.60.40.10:FF:000645', NULL, NULL, 'T-cell surface glycoprotein CD8 beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(194108, NULL, 'G3DSA:2.130.10.10:FF:005064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194109, NULL, 'G3DSA:3.30.750.24:FF:000065', NULL, NULL, 'Sulfate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(194110, NULL, 'G3DSA:3.30.300.30:FF:000041', NULL, NULL, 'Fatty-acid-CoA ligase FadD8', NULL, NULL, NULL, NULL, NULL, 4),
(194111, NULL, 'G3DSA:3.80.10.10:FF:002809', NULL, NULL, 'Leucine-rich repeat protein lrrA', NULL, NULL, NULL, NULL, NULL, 4),
(194112, NULL, 'G3DSA:3.80.10.10:FF:002034', NULL, NULL, 'Negative regulator of reactive oxygen species', NULL, NULL, NULL, NULL, NULL, 4),
(194113, NULL, 'G3DSA:3.50.50.60:FF:000018', NULL, NULL, 'Sarcosine oxidase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(194114, NULL, 'G3DSA:3.40.50.2000:FF:000019', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(194115, NULL, 'G3DSA:2.60.120.200:FF:000785', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(194116, NULL, 'G3DSA:3.20.20.70:FF:000431', NULL, NULL, 'Homocitrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(194117, NULL, 'G3DSA:2.60.40.640:FF:000048', NULL, NULL, 'GL12550', NULL, NULL, NULL, NULL, NULL, 4),
(194118, NULL, 'G3DSA:3.30.497.10:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194119, NULL, 'G3DSA:2.30.29.240:FF:000015', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase beta-4', NULL, NULL, NULL, NULL, NULL, 4),
(194120, NULL, 'G3DSA:1.10.150.240:FF:000124', NULL, NULL, 'Probable phosphoglycolate phosphatase, HAD superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(194121, NULL, 'G3DSA:3.40.50.1820:FF:000639', NULL, NULL, 'Acylaminoacyl-peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(194122, NULL, 'G3DSA:3.30.40.10:FF:001206', NULL, NULL, 'Protein CBG02635', NULL, NULL, NULL, NULL, NULL, 4),
(194123, NULL, 'G3DSA:2.130.10.10:FF:002394', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One component system)', NULL, NULL, NULL, NULL, NULL, 4),
(194124, NULL, 'G3DSA:2.40.10.10:FF:000318', NULL, NULL, 'IP20273p', NULL, NULL, NULL, NULL, NULL, 4),
(194125, NULL, 'G3DSA:3.30.1360.10:FF:000049', NULL, NULL, 'Os02g0723600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(194126, NULL, 'G3DSA:1.25.40.10:FF:001673', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g14050, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(194127, NULL, 'G3DSA:3.10.129.10:FF:000045', NULL, NULL, 'Hotdog fold thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(194128, NULL, 'G3DSA:3.15.20.10:FF:000010', NULL, NULL, 'Protein TENP', NULL, NULL, NULL, NULL, NULL, 4),
(194129, NULL, 'G3DSA:3.50.50.60:FF:000035', NULL, NULL, 'Methylenetetrahydrofolate--tRNA-(uracil-5-)-methyltransferase TrmFO', NULL, NULL, NULL, NULL, NULL, 4),
(194130, NULL, 'G3DSA:2.70.50.30:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194131, NULL, 'G3DSA:3.40.50.300:FF:003900', NULL, NULL, 'Branched-chain amino acid ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(194132, NULL, 'G3DSA:2.30.180.10:FF:000040', NULL, NULL, 'Fasciclin-like AGP 6', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(194133, NULL, 'G3DSA:2.130.10.10:FF:001360', NULL, NULL, 'DDB1- and CUL4-associated factor 10', NULL, NULL, NULL, NULL, NULL, 4),
(194134, NULL, 'G3DSA:2.70.150.10:FF:000271', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(194135, NULL, 'G3DSA:3.30.300.20:FF:000049', NULL, NULL, 'Probable transcription termination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(194136, NULL, 'G3DSA:3.30.40.10:FF:001678', NULL, NULL, 'PDZ domain containing ring finger 4', NULL, NULL, NULL, NULL, NULL, 4),
(194137, NULL, 'G3DSA:3.40.50.300:FF:004934', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194138, NULL, 'G3DSA:1.25.40.10:FF:001145', NULL, NULL, 'Os07g0244400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(194139, NULL, 'G3DSA:3.20.20.140:FF:000080', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(194140, NULL, 'G3DSA:3.40.50.300:FF:005446', NULL, NULL, 'ATP-dependent DEAD/H DNA helicase recQ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194141, NULL, 'G3DSA:2.60.120.260:FF:000090', NULL, NULL, 'Probable allantoicase', NULL, NULL, NULL, NULL, NULL, 4),
(194142, NULL, 'G3DSA:3.40.50.12160:FF:000003', NULL, NULL, 'CDK5 regulatory subunit-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(194143, NULL, 'G3DSA:3.90.245.10:FF:000022', NULL, NULL, 'Inosine-uridine preferring nucleoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(194144, NULL, 'G3DSA:1.10.1040.10:FF:000003', NULL, NULL, 'Ketol-acid reductoisomerase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(194145, NULL, 'G3DSA:3.30.565.10:FF:000155', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(194146, NULL, 'G3DSA:2.40.340.10:FF:000011', NULL, NULL, 'Molybdopterin molybdenumtransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(194147, NULL, 'G3DSA:3.30.460.10:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194148, NULL, 'G3DSA:3.20.20.80:FF:000799', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194149, NULL, 'G3DSA:3.30.390.50:FF:000013', NULL, NULL, 'Lipoate--protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(194150, NULL, 'G3DSA:1.10.287.1060:FF:000005', NULL, NULL, 'Phage terminase, small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(194151, NULL, 'G3DSA:2.60.120.10:FF:000041', NULL, NULL, 'HTH-type transcriptional activator RhaS', NULL, NULL, NULL, NULL, NULL, 4),
(194152, NULL, 'G3DSA:1.10.400.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194153, NULL, 'G3DSA:4.10.1000.10:FF:000061', NULL, NULL, 'Zinc finger CCCH domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(194154, NULL, 'G3DSA:3.30.930.10:FF:000184', NULL, NULL, 'Polymerase (DNA directed), gamma 2, accessory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(194155, NULL, 'G3DSA:1.25.10.10:FF:001160', NULL, NULL, 'Catenin delta 2', NULL, NULL, NULL, NULL, NULL, 4),
(194156, NULL, 'G3DSA:1.20.1070.10:FF:001661', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(194157, NULL, 'G3DSA:3.90.660.10:FF:000138', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194158, NULL, 'G3DSA:2.130.10.10:FF:005047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194159, NULL, 'G3DSA:2.60.40.60:FF:000834', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194160, NULL, 'G3DSA:2.30.170.40:FF:000008', NULL, NULL, '50S ribosomal protein L28', NULL, NULL, NULL, NULL, NULL, 4),
(194161, NULL, 'G3DSA:3.40.50.300:FF:008195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194162, NULL, 'G3DSA:1.20.140.10:FF:000111', NULL, NULL, 'Short-chain-specific acyl-CoA dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(194163, NULL, 'G3DSA:1.10.10.60:FF:000926', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194164, NULL, 'G3DSA:3.30.780.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194165, NULL, 'G3DSA:2.10.25.10:FF:000483', NULL, NULL, 'Tissue-type plasminogen activator', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(194166, NULL, 'G3DSA:1.20.120.350:FF:000025', NULL, NULL, 'Potassium voltage-gated channel subfamily A member 2', NULL, NULL, NULL, NULL, NULL, 4),
(194167, NULL, 'G3DSA:1.10.357.10:FF:000015', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(194168, NULL, 'G3DSA:2.40.50.150:FF:000003', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(194169, NULL, 'G3DSA:1.25.40.10:FF:004798', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194170, NULL, 'G3DSA:3.40.50.2000:FF:000244', NULL, NULL, 'UDP-N-acetylglucosamine transferase subunit ALG13', NULL, NULL, NULL, NULL, NULL, 4),
(194171, NULL, 'G3DSA:3.30.200.20:FF:002138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194172, NULL, 'G3DSA:4.10.900.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194173, NULL, 'G3DSA:3.60.140.10:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194174, NULL, 'G3DSA:3.30.70.330:FF:001077', NULL, NULL, 'G3BP stress granule assembly factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(194175, NULL, 'G3DSA:2.40.50.140:FF:000377', NULL, NULL, 'Replication protein A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(194176, NULL, 'G3DSA:3.30.43.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194177, NULL, 'G3DSA:1.20.910.10:FF:000001', NULL, NULL, 'Heme oxygenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(194178, NULL, 'G3DSA:3.40.50.1000:FF:000837', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194179, NULL, 'G3DSA:1.25.40.20:FF:000529', NULL, NULL, 'Cyclin dependent kinase inhibitor Pho81, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194180, NULL, 'G3DSA:1.20.1050.10:FF:000226', NULL, NULL, 'Glutathione S-transferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(194181, NULL, 'G3DSA:2.10.110.10:FF:000225', NULL, NULL, 'LIM domain-containing protein F', NULL, NULL, NULL, NULL, NULL, 4),
(194182, NULL, 'G3DSA:1.20.950.20:FF:000018', NULL, NULL, 'Ni/Fe-hydrogenase, b-type cytochrome subunit', NULL, NULL, NULL, NULL, NULL, 4),
(194183, NULL, 'G3DSA:1.10.287.370:FF:000027', NULL, NULL, 'Prefoldin subunit alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(194184, NULL, 'G3DSA:3.30.1370.210:FF:000016', NULL, NULL, 'Putative muscleblind-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(194185, NULL, 'G3DSA:2.40.30.10:FF:000426', NULL, NULL, 'AGAP006250-PA', NULL, NULL, NULL, NULL, NULL, 4),
(194186, NULL, 'G3DSA:2.60.40.420:FF:000218', NULL, NULL, 'Laccase family multicopper oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(194187, NULL, 'G3DSA:4.10.400.10:FF:000015', NULL, NULL, 'Low-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(194188, NULL, 'G3DSA:1.10.533.10:FF:000228', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(194189, NULL, 'G3DSA:3.40.50.300:FF:005553', NULL, NULL, 'TFIIH basal transcription factor complex helicase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(194190, NULL, 'G3DSA:1.20.1070.10:FF:001329', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(194191, NULL, 'G3DSA:3.40.50.2300:FF:000227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194192, NULL, 'G3DSA:1.10.10.790:FF:000001', NULL, NULL, 'Splicing factor 3a, subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(194193, NULL, 'G3DSA:2.30.30.40:FF:000582', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194194, NULL, 'G3DSA:3.40.190.10:FF:000630', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(194195, NULL, 'G3DSA:3.30.70.330:FF:000043', NULL, NULL, 'paraspeckle component 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(194196, NULL, 'G3DSA:3.40.50.2300:FF:001071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194197, NULL, 'G3DSA:1.20.1080.10:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194198, NULL, 'G3DSA:2.40.70.10:FF:000390', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(194199, NULL, 'G3DSA:1.10.10.160:FF:000065', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(194200, NULL, 'G3DSA:2.40.50.90:FF:000142', NULL, NULL, 'Transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194201, NULL, 'G3DSA:4.10.280.10:FF:000027', NULL, NULL, 'Nescient helix-loop-helix 1', NULL, NULL, NULL, NULL, NULL, 4),
(194202, NULL, 'G3DSA:3.80.10.10:FF:002580', NULL, NULL, 'Protein TORNADO 1', NULL, NULL, NULL, NULL, NULL, 4),
(194203, NULL, 'G3DSA:2.30.30.100:FF:000211', NULL, NULL, 'Small nuclear ribonucleoprotein E', NULL, NULL, NULL, NULL, NULL, 4),
(194204, NULL, 'G3DSA:3.30.2400.10:FF:000003', NULL, NULL, 'Phage capsid protein', NULL, NULL, NULL, NULL, NULL, 4),
(194205, NULL, 'G3DSA:1.20.5.110:FF:000235', NULL, NULL, 'YALI0E17875p', NULL, NULL, NULL, NULL, NULL, 4),
(194206, NULL, 'G3DSA:3.30.70.1440:FF:000011', NULL, NULL, 'Probable Resistance-Nodulation-Cell Division (RND) efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(194207, NULL, 'G3DSA:1.10.287.770:FF:000012', NULL, NULL, 'Pickpocket 10', NULL, NULL, NULL, NULL, NULL, 4),
(194208, NULL, 'G3DSA:1.10.10.1970:FF:000001', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(194209, NULL, 'G3DSA:1.25.10.10:FF:001317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194210, NULL, 'G3DSA:2.160.10.30:FF:000004', NULL, NULL, 'UDP-sugar pyrophosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(194211, NULL, 'G3DSA:3.80.10.10:FF:002473', NULL, NULL, 'NLR family CARD domain-containing 9', NULL, NULL, NULL, NULL, NULL, 4),
(194212, NULL, 'G3DSA:1.10.10.750:FF:000040', NULL, NULL, 'Ecotropic viral integration site 5-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(194213, NULL, 'G3DSA:3.75.10.10:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194214, NULL, 'G3DSA:1.10.1040.30:FF:000009', NULL, NULL, 'YALI0D05775p', NULL, NULL, NULL, NULL, NULL, 4),
(194215, NULL, 'G3DSA:2.30.30.140:FF:000066', NULL, NULL, 'A-kinase anchor protein 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(194216, NULL, 'G3DSA:2.40.128.20:FF:000026', NULL, NULL, 'Apolipoprotein D-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(194217, NULL, 'G3DSA:4.10.410.10:FF:000044', NULL, NULL, 'Protein CBR-MLT-11', NULL, NULL, NULL, NULL, NULL, 4),
(194218, NULL, 'G3DSA:1.20.1250.20:FF:001537', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194219, NULL, 'G3DSA:3.80.10.10:FF:000325', NULL, NULL, 'Si:dkey-16p6.1', NULL, NULL, NULL, NULL, NULL, 4),
(194220, NULL, 'G3DSA:1.10.510.10:FF:001917', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194221, NULL, 'G3DSA:3.30.450.20:FF:000307', NULL, NULL, 'Sporulation-specific ATP-dependent proteinhistidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(194222, NULL, 'G3DSA:1.25.40.10:FF:003707', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(194223, NULL, 'G3DSA:1.20.1050.130:FF:000023', NULL, NULL, 'Glutamyl-prolyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(194224, NULL, 'G3DSA:2.60.40.420:FF:000061', NULL, NULL, 'Laccase TilA', NULL, NULL, NULL, NULL, NULL, 4),
(194225, NULL, 'G3DSA:2.60.40.60:FF:001132', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(194226, NULL, 'G3DSA:1.20.1250.20:FF:000447', NULL, NULL, 'MFS multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194227, NULL, 'G3DSA:1.20.58.1700:FF:000002', NULL, NULL, 'Allophanate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(194228, NULL, 'G3DSA:3.40.50.150:FF:001202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194229, NULL, 'G3DSA:3.20.20.80:FF:000113', NULL, NULL, 'Glucan 1,3-beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(194230, NULL, 'G3DSA:1.20.1730.10:FF:000048', NULL, NULL, 'Urea transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194231, NULL, 'G3DSA:1.20.58.160:FF:000008', NULL, NULL, 'GM11378', NULL, NULL, NULL, NULL, NULL, 4),
(194232, NULL, 'G3DSA:1.25.10.10:FF:002941', NULL, NULL, 'AP-3 complex subunit delta', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(194233, NULL, 'G3DSA:1.25.40.10:FF:002437', NULL, NULL, 'Os02g0670700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(194234, NULL, 'G3DSA:1.10.630.10:FF:000555', NULL, NULL, 'Cytochrome P450 family 51 subfamily A member 1', NULL, NULL, NULL, NULL, NULL, 4),
(194235, NULL, 'G3DSA:2.60.120.970:FF:000004', NULL, NULL, 'Bone morphogenetic protein 5 preproprotein', NULL, NULL, NULL, NULL, NULL, 4),
(194236, NULL, 'G3DSA:3.40.50.300:FF:001427', NULL, NULL, 'ATP-dependent RNA helicase DEAH13', NULL, NULL, NULL, NULL, NULL, 4),
(194237, NULL, 'G3DSA:1.10.418.10:FF:000258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194238, NULL, 'G3DSA:3.80.10.10:FF:001629', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194239, NULL, 'G3DSA:1.20.1560.10:FF:000001', NULL, NULL, 'ATP-binding cassette subfamily C member 1', NULL, NULL, NULL, NULL, NULL, 4),
(194240, NULL, 'G3DSA:3.90.930.1:FF:000001', NULL, NULL, 'Outer surface protein A', NULL, NULL, NULL, NULL, NULL, 4),
(194241, NULL, 'G3DSA:3.40.50.150:FF:000584', NULL, NULL, 'Methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(194242, NULL, 'G3DSA:1.20.80.10:FF:000022', NULL, NULL, 'acyl-CoA-binding domain-containing protein 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(194243, NULL, 'G3DSA:2.80.10.50:FF:000042', NULL, NULL, 'Fibroblast growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(194244, NULL, 'G3DSA:3.30.1480.10:FF:000013', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(194245, NULL, 'G3DSA:1.25.40.420:FF:000055', NULL, NULL, 'MigA', NULL, NULL, NULL, NULL, NULL, 4),
(194246, NULL, 'G3DSA:3.80.10.10:FF:002725', NULL, NULL, 'MDIS1-interacting receptor like kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(194247, NULL, 'G3DSA:3.10.100.10:FF:000069', NULL, NULL, 'C-type lectin domain family 7 member A', NULL, NULL, NULL, NULL, NULL, 4),
(194248, NULL, 'G3DSA:1.50.40.10:FF:000120', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(194249, NULL, 'G3DSA:3.20.20.540:FF:000002', NULL, NULL, 'Phosphomethylpyrimidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(194250, NULL, 'G3DSA:1.25.40.10:FF:000959', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(194251, NULL, 'G3DSA:1.10.246.130:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194252, NULL, 'G3DSA:2.60.120.290:FF:000194', NULL, NULL, 'AGAP005526-PA', NULL, NULL, NULL, NULL, NULL, 4),
(194253, NULL, 'G3DSA:3.30.980.10:FF:000024', NULL, NULL, 'Alanyl-tRNA synthetase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(194254, NULL, 'G3DSA:2.20.25.10:FF:000033', NULL, NULL, 'Transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194255, NULL, 'G3DSA:1.20.920.10:FF:000030', NULL, NULL, 'transcription intermediary factor 1-beta', NULL, NULL, NULL, NULL, NULL, 4),
(194256, NULL, 'G3DSA:1.20.5.190:FF:000096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194257, NULL, 'G3DSA:1.25.40.470:FF:000064', NULL, NULL, 'Coatomer subunit beta''-3', NULL, NULL, NULL, NULL, NULL, 4),
(194258, NULL, 'G3DSA:1.20.140.150:FF:000087', NULL, NULL, 'germ cell-specific gene 1 protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(194259, NULL, 'G3DSA:3.30.750.24:FF:000082', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(194260, NULL, 'G3DSA:2.10.25.10:FF:000590', NULL, NULL, 'von Willebrand factor D and EGF domains', NULL, NULL, NULL, NULL, NULL, 4),
(194261, NULL, 'G3DSA:2.60.40.10:FF:005760', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194262, NULL, 'G3DSA:3.90.550.10:FF:000697', NULL, NULL, 'O-glycoside alpha-1,2-mannosyltransferase homolog 6', NULL, NULL, NULL, NULL, NULL, 4),
(194263, NULL, 'G3DSA:4.10.400.10:FF:000324', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194264, NULL, 'G3DSA:2.40.50.1020:FF:000013', NULL, NULL, 'Transcriptional regulator protein', NULL, NULL, NULL, NULL, NULL, 4),
(194265, NULL, 'G3DSA:1.20.5.500:FF:000009', NULL, NULL, 'Intermediate filament protein ifc-2', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(194266, NULL, 'G3DSA:2.60.40.2860:FF:000003', NULL, NULL, '6-cysteine protein', NULL, NULL, NULL, NULL, NULL, 4),
(194267, NULL, 'G3DSA:3.30.9.10:FF:000100', NULL, NULL, 'FAD-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(194268, NULL, 'G3DSA:4.10.240.10:FF:000137', NULL, NULL, 'Fungus-specific transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194269, NULL, 'G3DSA:3.40.50.10810:FF:000273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194270, NULL, 'G3DSA:3.30.70.1590:FF:000005', NULL, NULL, 'unconventional myosin-Vc', NULL, NULL, NULL, NULL, NULL, 4),
(194271, NULL, 'G3DSA:2.130.10.10:FF:001090', NULL, NULL, 'Unplaced genomic scaffold supercont2.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(194272, NULL, 'G3DSA:3.30.420.10:FF:000010', NULL, NULL, 'DNA polymerase epsilon catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(194273, NULL, 'G3DSA:3.30.420.340:FF:000007', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4),
(194274, NULL, 'G3DSA:3.10.20.90:FF:000089', NULL, NULL, 'Fas associated factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(194275, NULL, 'G3DSA:1.25.40.10:FF:005040', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(194276, NULL, 'G3DSA:2.20.100.10:FF:000094', NULL, NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif, 18', NULL, NULL, NULL, NULL, NULL, 4),
(194277, NULL, 'G3DSA:3.30.70.370:FF:000004', NULL, NULL, 'DNA polymerase gamma, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(194278, NULL, 'G3DSA:3.40.50.300:FF:001955', NULL, NULL, 'ATP-dependent RNA helicase DBP4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194279, NULL, 'G3DSA:1.10.472.110:FF:000001', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(194280, NULL, 'G3DSA:3.40.50.2300:FF:001380', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194281, NULL, 'G3DSA:3.40.50.12780:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194282, NULL, 'G3DSA:1.20.920.30:FF:000036', NULL, NULL, 'AGAP011441-PA', NULL, NULL, NULL, NULL, NULL, 4),
(194283, NULL, 'G3DSA:3.10.129.10:FF:000259', NULL, NULL, 'Acyl-acyl carrier protein thioesterase ATL3 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(194284, NULL, 'G3DSA:2.70.98.10:FF:000036', NULL, NULL, 'Glucose-6-phosphate 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(194285, NULL, 'G3DSA:3.40.1010.10:FF:000004', NULL, NULL, 'Putative diphthine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(194286, NULL, 'G3DSA:3.90.228.10:FF:000044', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(194287, NULL, 'G3DSA:3.30.70.330:FF:000352', NULL, NULL, 'Putative serine/arginine-rich splicing factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(194288, NULL, 'G3DSA:3.30.70.3270:FF:000009', NULL, NULL, 'NADH-quinone oxidoreductase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(194289, NULL, 'G3DSA:3.40.50.1820:FF:001258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194290, NULL, 'G3DSA:3.40.50.300:FF:001394', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(194291, NULL, 'G3DSA:1.10.510.10:FF:002070', NULL, NULL, 'SH3 domain binding kinase family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(194292, NULL, 'G3DSA:2.130.10.10:FF:000937', NULL, NULL, 'Cft1p', NULL, NULL, NULL, NULL, NULL, 4),
(194293, NULL, 'G3DSA:3.20.20.70:FF:000015', NULL, NULL, 'Orotidine 5''-phosphate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(194294, NULL, 'G3DSA:2.10.25.10:FF:000224', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(194295, NULL, 'G3DSA:2.40.70.10:FF:000058', NULL, NULL, 'ASpartyl Protease', NULL, NULL, NULL, NULL, NULL, 4),
(194296, NULL, 'G3DSA:3.30.160.60:FF:000729', NULL, NULL, 'Zinc finger protein 646', NULL, NULL, NULL, NULL, NULL, 4),
(194297, NULL, 'G3DSA:1.25.40.20:FF:001457', NULL, NULL, 'Ankyrin repeat domain 2 (stretch-responsive muscle)', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(194298, NULL, 'G3DSA:1.20.1720.10:FF:000082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194299, NULL, 'G3DSA:1.20.930.10:FF:000014', NULL, NULL, 'Transcription factor SPN1', NULL, NULL, NULL, NULL, NULL, 4),
(194300, NULL, 'G3DSA:3.30.70.890:FF:000042', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(194301, NULL, 'G3DSA:2.130.10.10:FF:001101', NULL, NULL, 'Blast:U4/U6 small nuclear ribonucleoprotein Prp4', NULL, NULL, NULL, NULL, NULL, 4),
(194302, NULL, 'G3DSA:3.40.50.300:FF:001500', NULL, NULL, 'Dynein-related AAA-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(194303, NULL, 'G3DSA:1.10.20.140:FF:000016', NULL, NULL, 'tRNA isopentenyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(194304, NULL, 'G3DSA:2.40.50.140:FF:001091', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194305, NULL, 'G3DSA:3.40.47.10:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194306, NULL, 'G3DSA:1.20.1250.20:FF:002049', NULL, NULL, 'Organic anion transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194307, NULL, 'G3DSA:1.10.20.120:FF:000010', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(194308, NULL, 'G3DSA:3.40.190.10:FF:000287', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(194309, NULL, 'G3DSA:1.25.10.10:FF:001053', NULL, NULL, 'Microtubule associated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194310, NULL, 'G3DSA:3.90.550.10:FF:000708', NULL, NULL, 'Glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(194311, NULL, 'G3DSA:1.10.3970.10:FF:000001', NULL, NULL, 'synapse-associated protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(194312, NULL, 'G3DSA:2.60.120.1190:FF:000008', NULL, NULL, 'Discoidin domain-containing receptor A', NULL, NULL, NULL, NULL, NULL, 4),
(194313, NULL, 'G3DSA:1.20.5.1160:FF:000025', NULL, NULL, 'CAP-Gly domain-containing linker protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(194314, NULL, 'G3DSA:1.10.630.10:FF:000100', NULL, NULL, 'Cytochrome P450 71A26', NULL, NULL, NULL, NULL, NULL, 4),
(194315, NULL, 'G3DSA:1.10.10.10:FF:001901', NULL, NULL, 'Mitomycin biosynthesis 6-O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(194316, NULL, 'G3DSA:2.20.100.10:FF:000127', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs adt-2', NULL, NULL, NULL, NULL, NULL, 4),
(194317, NULL, 'G3DSA:1.20.1510.10:FF:000054', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(194318, NULL, 'G3DSA:3.80.10.10:FF:004378', NULL, NULL, 'Disease resistance RPP13-like protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(194319, NULL, 'G3DSA:1.10.1200.270:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194320, NULL, 'G3DSA:3.30.1510.10:FF:000011', NULL, NULL, '6,7,8-tetrahydrofolate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(194321, NULL, 'G3DSA:3.30.160.100:FF:000022', NULL, NULL, 'Ribosome hibernation promoting factor', NULL, NULL, NULL, NULL, NULL, 4),
(194322, NULL, 'G3DSA:3.10.580.10:FF:000138', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(194323, NULL, 'G3DSA:3.80.10.10:FF:001652', NULL, NULL, 'Probable LRR receptor-like serine/threonine-protein kinase RPK1', NULL, NULL, NULL, NULL, NULL, 4),
(194324, NULL, 'G3DSA:1.10.8.10:FF:000208', NULL, NULL, 'AT15685p', NULL, NULL, NULL, NULL, NULL, 4),
(194325, NULL, 'G3DSA:2.60.120.10:FF:000260', NULL, NULL, 'Homogentisate 1,2-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(194326, NULL, 'G3DSA:1.10.246.60:FF:000008', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit 1 putative', NULL, NULL, NULL, NULL, NULL, 4),
(194327, NULL, 'G3DSA:1.25.40.10:FF:002893', NULL, NULL, 'NRDE-2, necessary for RNA interference, domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(194328, NULL, 'G3DSA:3.40.50.300:FF:004625', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194329, NULL, 'G3DSA:3.10.50.10:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(194330, NULL, 'G3DSA:3.30.720.50:FF:000011', NULL, NULL, 'E3 ubiquitin protein ligase URE-B1 variant', NULL, NULL, NULL, NULL, NULL, 4),
(194331, NULL, 'G3DSA:1.10.3460.10:FF:000007', NULL, NULL, 'Chlorophyll a-b binding protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(194332, NULL, 'G3DSA:2.40.10.10:FF:000627', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194333, NULL, 'G3DSA:4.10.1240.30:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194334, NULL, 'G3DSA:3.40.50.2300:FF:001048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194335, NULL, 'G3DSA:1.10.238.10:FF:000492', NULL, NULL, 'EF-hand calcium binding domain 6', NULL, NULL, NULL, NULL, NULL, 4),
(194336, NULL, 'G3DSA:3.90.226.10:FF:000219', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(194337, NULL, 'G3DSA:2.120.10.80:FF:000239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194338, NULL, 'G3DSA:1.20.58.390:FF:000167', NULL, NULL, 'Nicotinic acetylcholine receptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(194339, NULL, 'G3DSA:2.60.40.10:FF:003826', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194340, NULL, 'G3DSA:3.90.1100.10:FF:000039', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(194341, NULL, 'G3DSA:3.30.70.1400:FF:000005', NULL, NULL, 'Dimethylglycine dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(194342, NULL, 'G3DSA:3.65.10.20:FF:000004', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(194343, NULL, 'G3DSA:2.10.70.10:FF:000222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194344, NULL, 'G3DSA:3.20.20.80:FF:000327', NULL, NULL, 'Arabinogalactan endo-beta-1,4-galactanase', NULL, NULL, NULL, NULL, NULL, 4),
(194345, NULL, 'G3DSA:3.40.50.80:FF:000114', NULL, NULL, 'Iron utilization protein', NULL, NULL, NULL, NULL, NULL, 4),
(194346, NULL, 'G3DSA:3.90.1150.10:FF:000227', NULL, NULL, 'PLP-dependent aminotransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(194347, NULL, 'G3DSA:1.20.120.720:FF:000046', NULL, NULL, 'Chitin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(194348, NULL, 'G3DSA:3.80.10.10:FF:001961', NULL, NULL, 'Probable inactive receptor kinase At5g10020', NULL, NULL, NULL, NULL, NULL, 4),
(194349, NULL, 'G3DSA:3.30.160.60:FF:001713', NULL, NULL, 'Zinc finger protein 619', NULL, NULL, NULL, NULL, NULL, 4),
(194350, NULL, 'G3DSA:1.20.1560.10:FF:000456', NULL, NULL, 'Cullin-associated NEDD8-dissociated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(194351, NULL, 'G3DSA:3.20.20.10:FF:000003', NULL, NULL, 'Diaminopimelate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(194352, NULL, 'G3DSA:2.130.10.30:FF:000146', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194353, NULL, 'G3DSA:1.20.58.110:FF:000004', NULL, NULL, '30S ribosomal protein S20', NULL, NULL, NULL, NULL, NULL, 4),
(194354, NULL, 'G3DSA:2.40.50.100:FF:000157', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(194355, NULL, 'G3DSA:2.30.29.30:FF:000199', NULL, NULL, 'Arf-GAP with GTPase, ANK repeat and PH domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(194356, NULL, 'G3DSA:3.40.930.10:FF:000024', NULL, NULL, 'Anion exchange protein', NULL, NULL, NULL, NULL, NULL, 4),
(194357, NULL, 'G3DSA:3.30.420.40:FF:001042', NULL, NULL, 'Heat shock protein 4b', NULL, NULL, NULL, NULL, NULL, 4),
(194358, NULL, 'G3DSA:3.80.10.10:FF:000691', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(194359, NULL, 'G3DSA:3.40.50.10190:FF:000272', NULL, NULL, 'Putative dna topoisomerase 2-binding protein 1 isoform x1', NULL, NULL, NULL, NULL, NULL, 4),
(194360, NULL, 'G3DSA:1.25.40.10:FF:000745', NULL, NULL, 'RNA polymerase II transcription elongation factor (Ctr9)', NULL, NULL, NULL, NULL, NULL, 4),
(194361, NULL, 'G3DSA:2.130.10.10:FF:001466', NULL, NULL, 'WD repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(194362, NULL, 'G3DSA:1.10.287.70:FF:000319', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(194363, NULL, 'G3DSA:3.40.50.1980:FF:000064', NULL, NULL, 'Hemin ABC transporter, periplasmic hemin-binding protein HutB', NULL, NULL, NULL, NULL, NULL, 4),
(194364, NULL, 'G3DSA:1.10.472.10:FF:000659', NULL, NULL, 'PHO85 cyclin-like protein psl1', NULL, NULL, NULL, NULL, NULL, 4),
(194365, NULL, 'G3DSA:3.40.50.20:FF:000012', NULL, NULL, 'Carbamoyl-phosphate synthase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(194366, NULL, 'G3DSA:3.40.50.800:FF:000054', NULL, NULL, 'Probable proline--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(194367, NULL, 'G3DSA:2.130.10.10:FF:000140', NULL, NULL, 'SMU1, DNA replication regulator and spliceosomal factor', NULL, NULL, NULL, NULL, NULL, 4),
(194368, NULL, 'G3DSA:3.40.50.1820:FF:000533', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(194369, NULL, 'G3DSA:2.60.120.260:FF:000196', NULL, NULL, 'Alpha-L-fucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(194370, NULL, 'G3DSA:1.10.10.10:FF:001356', NULL, NULL, 'Double-stranded RNA-specific adenosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(194371, NULL, 'G3DSA:3.80.10.10:FF:000016', NULL, NULL, 'Leucine-rich repeat and fibronectin type III domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(194372, NULL, 'G3DSA:1.10.287.920:FF:000001', NULL, NULL, 'Pheromone alpha factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(194373, NULL, 'G3DSA:1.25.10.10:FF:002609', NULL, NULL, 'Protein MOR1', NULL, NULL, NULL, NULL, NULL, 4),
(194374, NULL, 'G3DSA:3.30.40.10:FF:001914', NULL, NULL, 'Os03g0380100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(194375, NULL, 'G3DSA:1.20.1070.10:FF:001638', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(194376, NULL, 'G3DSA:2.60.120.200:FF:000240', NULL, NULL, 'MAM and LDL receptor class A domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(194377, NULL, 'G3DSA:3.40.50.300:FF:000011', NULL, NULL, 'Putative ABC transporter ATP-binding component', NULL, NULL, NULL, NULL, NULL, 4),
(194378, NULL, 'G3DSA:3.30.710.10:FF:000330', NULL, NULL, 'Rho-related BTB domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(194379, NULL, 'G3DSA:3.40.120.10:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194380, NULL, 'G3DSA:3.30.70.330:FF:001785', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194381, NULL, 'G3DSA:1.25.40.10:FF:005310', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(194382, NULL, 'G3DSA:3.30.110.20:FF:000001', NULL, NULL, 'Stage V sporulation protein S', NULL, NULL, NULL, NULL, NULL, 4),
(194383, NULL, 'G3DSA:1.10.238.200:FF:000012', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(194384, NULL, 'G3DSA:3.40.50.1000:FF:000731', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194385, NULL, 'G3DSA:1.10.287.940:FF:000007', NULL, NULL, 'p2X purinoceptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(194386, NULL, 'G3DSA:1.10.510.10:FF:002446', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194387, NULL, 'G3DSA:3.40.50.300:FF:003664', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(194388, NULL, 'G3DSA:1.25.10.10:FF:002380', NULL, NULL, 'Uncharacterized protein C1071.03c', NULL, NULL, NULL, NULL, NULL, 4),
(194389, NULL, 'G3DSA:3.30.70.330:FF:002061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194390, NULL, 'G3DSA:1.20.58.60:FF:000272', NULL, NULL, 'Spectrin alpha chain, erythrocytic 1', NULL, NULL, NULL, NULL, NULL, 4),
(194391, NULL, 'G3DSA:1.10.510.10:FF:003065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194392, NULL, 'G3DSA:2.60.40.150:FF:000789', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194393, NULL, 'G3DSA:3.40.250.10:FF:000124', NULL, NULL, 'Thiosulfate sulfurtransferase GlpE', NULL, NULL, NULL, NULL, NULL, 4),
(194394, NULL, 'G3DSA:1.50.10.20:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194395, NULL, 'G3DSA:2.60.40.1400:FF:000009', NULL, NULL, 'Inward rectifier potassium channel Kirbac3.1', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(194396, NULL, 'G3DSA:1.20.1070.10:FF:001970', NULL, NULL, 'Dopamine D2-like receptor', NULL, NULL, NULL, NULL, NULL, 4),
(194397, NULL, 'G3DSA:3.40.50.10490:FF:000148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194398, NULL, 'G3DSA:3.10.100.10:FF:000378', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194399, NULL, 'G3DSA:1.10.20.10:FF:000002', NULL, NULL, 'Histone H4', NULL, NULL, NULL, NULL, NULL, 4),
(194400, NULL, 'G3DSA:3.40.50.720:FF:002582', NULL, NULL, 'ThiF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(194401, NULL, 'G3DSA:3.30.160.60:FF:003259', NULL, NULL, 'ras-responsive element-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(194402, NULL, 'G3DSA:2.60.40.10:FF:004776', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194403, NULL, 'G3DSA:3.30.160.60:FF:005389', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194404, NULL, 'G3DSA:3.40.309.10:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194405, NULL, 'G3DSA:1.20.1270.60:FF:000319', NULL, NULL, 'Bridging integrator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194406, NULL, 'G3DSA:3.40.50.360:FF:000113', NULL, NULL, 'Glutathione-regulated potassium-efflux system ancillary protein KefG', NULL, NULL, NULL, NULL, NULL, 4),
(194407, NULL, 'G3DSA:3.30.1520.10:FF:000040', NULL, NULL, 'NADPH oxidase organizer 1', NULL, NULL, NULL, NULL, NULL, 4),
(194408, NULL, 'G3DSA:3.50.30.50:FF:000014', NULL, NULL, 'Uncharacterized protein MJ0783', NULL, NULL, NULL, NULL, NULL, 4),
(194409, NULL, 'G3DSA:3.30.160.60:FF:002663', NULL, NULL, 'Fez family zinc finger protein erm', NULL, NULL, NULL, NULL, NULL, 4),
(194410, NULL, 'G3DSA:2.130.10.10:FF:002955', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194411, NULL, 'G3DSA:3.90.70.10:FF:000615', NULL, NULL, 'Protein CBG21788', NULL, NULL, NULL, NULL, NULL, 4),
(194412, NULL, 'G3DSA:1.10.540.10:FF:000020', NULL, NULL, 'Acyl-CoA dehydrogenase family member 8', NULL, NULL, NULL, NULL, NULL, 4),
(194413, NULL, 'G3DSA:1.10.510.10:FF:001120', NULL, NULL, 'Serine/threonine kinase 17b (apoptosis-inducing)', NULL, NULL, NULL, NULL, NULL, 4),
(194414, NULL, 'G3DSA:1.10.3720.10:FF:000180', NULL, NULL, 'Amino acid ABC transporter, permease protein, His/Glu/Gln/Arg/opine family', NULL, NULL, NULL, NULL, NULL, 4),
(194415, NULL, 'G3DSA:3.30.70.330:FF:003022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194416, NULL, 'G3DSA:3.40.50.720:FF:001289', NULL, NULL, 'Os11g0229100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(194417, NULL, 'G3DSA:2.30.42.10:FF:000139', NULL, NULL, 'synaptopodin-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(194418, NULL, 'G3DSA:3.10.110.10:FF:000098', NULL, NULL, 'Ubiquitin conjugating enzyme (UbcJ)', NULL, NULL, NULL, NULL, NULL, 4),
(194419, NULL, 'G3DSA:3.30.70.1060:FF:000004', NULL, NULL, 'Ofr1p', NULL, NULL, NULL, NULL, NULL, 4),
(194420, NULL, 'G3DSA:3.30.160.60:FF:003500', NULL, NULL, 'zinc finger protein 271', NULL, NULL, NULL, NULL, NULL, 4),
(194421, NULL, 'G3DSA:3.40.50.1820:FF:000078', NULL, NULL, 'Homoserine O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(194422, NULL, 'G3DSA:1.10.287.3280:FF:000002', NULL, NULL, 'DNA damage-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(194423, NULL, 'G3DSA:2.130.10.10:FF:003810', NULL, NULL, 'WD repeat-containing protein srw1', NULL, NULL, NULL, NULL, NULL, 4),
(194424, NULL, 'G3DSA:2.40.50.140:FF:000938', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194425, NULL, 'G3DSA:2.130.10.10:FF:004900', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194426, NULL, 'G3DSA:2.60.120.260:FF:000651', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194427, NULL, 'G3DSA:3.30.710.10:FF:000201', NULL, NULL, 'Os10g0438100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(194428, NULL, 'G3DSA:3.30.230.10:FF:000395', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194429, NULL, 'G3DSA:1.20.120.1770:FF:000025', NULL, NULL, 'Transmembrane ascorbate ferrireductase 1', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(194430, NULL, 'G3DSA:3.30.200.20:FF:001520', NULL, NULL, 'Serine/threonine-protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194431, NULL, 'G3DSA:3.40.50.1100:FF:000160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194432, NULL, 'G3DSA:3.30.505.10:FF:000016', NULL, NULL, 'B-cell linker protein isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(194433, NULL, 'G3DSA:3.40.50.300:FF:002916', NULL, NULL, 'DNA topology modulation protein', NULL, NULL, NULL, NULL, NULL, 4),
(194434, NULL, 'G3DSA:2.60.40.10:FF:001342', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(194435, NULL, 'G3DSA:1.10.439.10:FF:000003', NULL, NULL, 'Acyl-homoserine lactone acylase PvdQ', NULL, NULL, NULL, NULL, NULL, 4),
(194436, NULL, 'G3DSA:2.160.10.10:FF:000009', NULL, NULL, '2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-succinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(194437, NULL, 'G3DSA:3.40.640.10:FF:000485', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194438, NULL, 'G3DSA:3.30.200.20:FF:002357', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194439, NULL, 'G3DSA:3.30.230.10:FF:000086', NULL, NULL, 'Translation elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(194440, NULL, 'G3DSA:2.130.10.10:FF:002646', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194441, NULL, 'G3DSA:3.40.50.150:FF:001674', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194442, NULL, 'G3DSA:1.25.40.10:FF:003365', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g11690', NULL, NULL, NULL, NULL, NULL, 4),
(194443, NULL, 'G3DSA:1.20.1310.10:FF:000180', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194444, NULL, 'G3DSA:1.25.40.20:FF:000838', NULL, NULL, 'TRPA1(A) isoform', NULL, NULL, NULL, NULL, NULL, 4),
(194445, NULL, 'G3DSA:3.30.470.20:FF:000179', NULL, NULL, 'Carbamoyl-phosphate synthase/carboxyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(194446, NULL, 'G3DSA:3.40.50.12780:FF:000083', NULL, NULL, 'NRPS-like enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194447, NULL, 'G3DSA:3.40.50.300:FF:007716', NULL, NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 10, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(194448, NULL, 'G3DSA:1.10.510.10:FF:000501', NULL, NULL, 'testis-specific serine/threonine-protein kinase 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(194449, NULL, 'G3DSA:2.60.120.920:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194450, NULL, 'G3DSA:3.80.10.10:FF:003759', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194451, NULL, 'G3DSA:1.20.1250.10:FF:000135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194452, NULL, 'G3DSA:2.120.10.30:FF:000472', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194453, NULL, 'G3DSA:2.20.70.10:FF:000137', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(194454, NULL, 'G3DSA:2.40.50.140:FF:000686', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194455, NULL, 'G3DSA:2.60.120.200:FF:000021', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(194456, NULL, 'G3DSA:3.40.630.10:FF:000350', NULL, NULL, 'Clan MH, family M18, aspartyl aminopeptidase-like metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(194457, NULL, 'G3DSA:1.25.10.10:FF:000811', NULL, NULL, 'rotatin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(194458, NULL, 'G3DSA:2.40.50.1070:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194459, NULL, 'G3DSA:2.60.34.10:FF:000007', NULL, NULL, 'Heat shock protein 105 kDa isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(194460, NULL, 'G3DSA:2.60.40.10:FF:005395', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194461, NULL, 'G3DSA:2.60.40.10:FF:006013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194462, NULL, 'G3DSA:3.40.50.10730:FF:000001', NULL, NULL, 'Urocanate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(194463, NULL, 'G3DSA:3.30.40.10:FF:000026', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(194464, NULL, 'G3DSA:1.20.120.1080:FF:000026', NULL, NULL, 'ATP-dependent RNA helicase (Hrh1)', NULL, NULL, NULL, NULL, NULL, 4),
(194465, NULL, 'G3DSA:2.60.40.420:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194466, NULL, 'G3DSA:1.20.1070.10:FF:000334', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194467, NULL, 'G3DSA:1.20.5.170:FF:000085', NULL, NULL, 'bZIP transcription factor 49', NULL, NULL, NULL, NULL, NULL, 4),
(194468, NULL, 'G3DSA:3.30.160.60:FF:003282', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194469, NULL, 'G3DSA:3.40.50.620:FF:000753', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194470, NULL, 'G3DSA:3.40.50.720:FF:002126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194471, NULL, 'G3DSA:1.20.58.70:FF:000056', NULL, NULL, 'Syntaxin-16', NULL, NULL, NULL, NULL, NULL, 4),
(194472, NULL, 'G3DSA:1.10.730.10:FF:000175', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(194473, NULL, 'G3DSA:1.20.58.60:FF:000519', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194474, NULL, 'G3DSA:3.30.365.10:FF:000027', NULL, NULL, 'Xanthine dehydrogenase, molybdenum binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(194475, NULL, 'G3DSA:1.10.238.10:FF:000020', NULL, NULL, 'spectrin alpha chain, non-erythrocytic 1', NULL, NULL, NULL, NULL, NULL, 4),
(194476, NULL, 'G3DSA:2.120.10.30:FF:000596', NULL, NULL, 'Adipocyte plasma membrane-associated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194477, NULL, 'G3DSA:3.30.160.60:FF:002882', NULL, NULL, 'Zinc finger protein 461', NULL, NULL, NULL, NULL, NULL, 4),
(194478, NULL, 'G3DSA:3.30.260.10:FF:000109', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194479, NULL, 'G3DSA:2.30.30.30:FF:000028', NULL, NULL, 'Transcription elongation factor SPT5', NULL, NULL, NULL, NULL, NULL, 4),
(194480, NULL, 'G3DSA:2.30.39.10:FF:000014', NULL, NULL, 'Serpin family B member 9', NULL, NULL, NULL, NULL, NULL, 4),
(194481, NULL, 'G3DSA:1.10.10.10:FF:000176', NULL, NULL, 'transcription factor ETV6 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(194482, NULL, 'G3DSA:1.25.40.20:FF:001822', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194483, NULL, 'G3DSA:3.40.640.10:FF:000176', NULL, NULL, 'Nucleotide sugar transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(194484, NULL, 'G3DSA:2.40.50.120:FF:000005', NULL, NULL, 'Metalloproteinase inhibitor 3 precursor', NULL, NULL, NULL, NULL, NULL, 4),
(194485, NULL, 'G3DSA:3.30.70.330:FF:000149', NULL, NULL, 'matrin-3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(194486, NULL, 'G3DSA:1.10.1200.10:FF:000005', NULL, NULL, 'Nonribosomal peptide synthetase 1', NULL, NULL, NULL, NULL, NULL, 4),
(194487, NULL, 'G3DSA:3.40.50.1000:FF:000276', NULL, NULL, 'HAD superfamily hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(194488, NULL, 'G3DSA:3.40.50.300:FF:003445', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(194489, NULL, 'G3DSA:2.10.25.10:FF:000803', NULL, NULL, 'C-type LECtin', NULL, NULL, NULL, NULL, NULL, 4),
(194490, NULL, 'G3DSA:3.10.310.20:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194491, NULL, 'G3DSA:1.20.90.10:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194492, NULL, 'G3DSA:3.30.479.30:FF:000016', NULL, NULL, 'SPFH domain/Band 7 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(194493, NULL, 'G3DSA:3.90.1290.10:FF:000024', NULL, NULL, 'Dystonin', NULL, NULL, NULL, NULL, NULL, 4),
(194494, NULL, 'G3DSA:3.30.70.330:FF:001908', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194495, NULL, 'G3DSA:3.60.21.10:FF:000071', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(194496, NULL, 'G3DSA:3.30.40.10:FF:000392', NULL, NULL, 'Structure-specific endonuclease subunit SLX1', NULL, NULL, NULL, NULL, NULL, 4),
(194497, NULL, 'G3DSA:3.30.9.10:FF:000173', NULL, NULL, 'FAD-dependent oxidoreductase domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(194498, NULL, 'G3DSA:1.20.120.1750:FF:000143', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(194499, NULL, 'G3DSA:2.60.40.4200:FF:000001', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(194500, NULL, 'G3DSA:1.20.1070.10:FF:000025', NULL, NULL, 'Lysophosphatidic acid receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(194501, NULL, 'G3DSA:2.30.30.40:FF:000273', NULL, NULL, 'Actin binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(194502, NULL, 'G3DSA:2.120.10.30:FF:000449', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194503, NULL, 'G3DSA:3.90.25.10:FF:000056', NULL, NULL, 'GDPmannose 4,6-dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(194504, NULL, 'G3DSA:3.30.60.20:FF:000137', NULL, NULL, 'Thymidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(194505, NULL, 'G3DSA:3.80.10.10:FF:000472', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RCH1', NULL, NULL, NULL, NULL, NULL, 4),
(194506, NULL, 'G3DSA:2.30.42.10:FF:000286', NULL, NULL, 'LIM domain kinase', NULL, NULL, NULL, NULL, NULL, 4),
(194507, NULL, 'G3DSA:3.20.20.30:FF:000014', NULL, NULL, 'LLM class F420-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(194508, NULL, 'G3DSA:3.80.10.10:FF:003198', NULL, NULL, 'AGAP010607-PA', NULL, NULL, NULL, NULL, NULL, 4),
(194509, NULL, 'G3DSA:3.30.40.10:FF:000245', NULL, NULL, 'B-cell CLL/lymphoma 9-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(194510, NULL, 'G3DSA:3.30.160.60:FF:003135', NULL, NULL, 'Zinc finger protein 557', NULL, NULL, NULL, NULL, NULL, 4),
(194511, NULL, 'G3DSA:1.25.10.10:FF:002918', NULL, NULL, 'Plakophilin 1', NULL, NULL, NULL, NULL, NULL, 4),
(194512, NULL, 'G3DSA:3.40.50.12190:FF:000001', NULL, NULL, 'torsin-1A-interacting protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(194513, NULL, 'G3DSA:3.40.630.30:FF:000209', NULL, NULL, 'Uncharacterized protein 93G11.120', NULL, NULL, NULL, NULL, NULL, 4),
(194514, NULL, 'G3DSA:2.40.40.20:FF:000003', NULL, NULL, 'Transitional endoplasmic reticulum ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(194515, NULL, 'G3DSA:1.10.510.10:FF:003374', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194516, NULL, 'G3DSA:2.170.270.10:FF:000194', NULL, NULL, 'Histone-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(194517, NULL, 'G3DSA:1.20.1250.20:FF:000812', NULL, NULL, 'Solute carrier organic anion transporter family member 5A1a', NULL, NULL, NULL, NULL, NULL, 4),
(194518, NULL, 'G3DSA:1.10.510.10:FF:003935', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194519, NULL, 'G3DSA:1.10.340.70:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194520, NULL, 'G3DSA:3.30.160.60:FF:003591', NULL, NULL, 'RE1-silencing transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(194521, NULL, 'G3DSA:3.40.50.300:FF:007031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194522, NULL, 'G3DSA:3.40.367.20:FF:000038', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(194523, NULL, 'G3DSA:1.10.10.10:FF:001137', NULL, NULL, 'Transcription regulator E2F/DP family protein', NULL, NULL, NULL, NULL, NULL, 4),
(194524, NULL, 'G3DSA:1.10.565.10:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194525, NULL, 'G3DSA:3.30.200.20:FF:000901', NULL, NULL, 'Unplaced genomic scaffold supercont1.38, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(194526, NULL, 'G3DSA:1.10.10.10:FF:000737', NULL, NULL, 'Forkhead domain 3F', NULL, NULL, NULL, NULL, NULL, 4),
(194527, NULL, 'G3DSA:1.25.10.10:FF:003318', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(194528, NULL, 'G3DSA:1.25.40.10:FF:001600', NULL, NULL, 'Signal recognition particle subunit SRP72', NULL, NULL, NULL, NULL, NULL, 4),
(194529, NULL, 'G3DSA:3.40.50.620:FF:000444', NULL, NULL, 'Adenine nucleotide alpha hydrolases-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(194530, NULL, 'G3DSA:2.60.220.50:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(194531, NULL, 'G3DSA:3.80.10.10:FF:004182', NULL, NULL, 'Si:dkey-126g1.7', NULL, NULL, NULL, NULL, NULL, 4),
(194532, NULL, 'G3DSA:1.20.58.60:FF:000305', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(194533, NULL, 'G3DSA:2.130.10.10:FF:002085', NULL, NULL, 'Dynein intermediate chain IC70', NULL, NULL, NULL, NULL, NULL, 4),
(194534, NULL, 'G3DSA:2.170.210.20:FF:000002', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(194535, NULL, 'G3DSA:1.25.40.10:FF:004326', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194536, NULL, 'G3DSA:3.30.40.10:FF:000953', NULL, NULL, 'LON peptidase N-terminal domain and RING finger protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(194537, NULL, 'G3DSA:3.10.20.770:FF:000006', NULL, NULL, 'Phosphatidylinositol-4-phosphate 3-kinase catalytic subunit type 2 gamma', NULL, NULL, NULL, NULL, NULL, 4),
(194538, NULL, 'G3DSA:1.10.510.10:FF:003626', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194539, NULL, 'G3DSA:2.60.120.620:FF:000023', NULL, NULL, 'Transmembrane prolyl 4-hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(194540, NULL, 'G3DSA:2.60.120.920:FF:000006', NULL, NULL, 'heterogeneous nuclear ribonucleoprotein U isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(194541, NULL, 'G3DSA:2.60.40.150:FF:000536', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(194542, NULL, 'G3DSA:2.60.120.330:FF:000043', NULL, NULL, 'Os04g0407800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(194543, NULL, 'G3DSA:1.10.8.60:FF:000061', NULL, NULL, 'Probable inactive ATP-dependent zinc metalloprotease FTSHI 4, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(194544, NULL, 'G3DSA:2.60.120.380:FF:000013', NULL, NULL, 'Alkaline serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(194545, NULL, 'G3DSA:3.40.50.1820:FF:000297', NULL, NULL, 'Lipase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194546, NULL, 'G3DSA:1.20.58.60:FF:000744', NULL, NULL, 'Spectrin, beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(194547, NULL, 'G3DSA:1.20.1250.20:FF:000104', NULL, NULL, 'Inner membrane transporter ydhP', NULL, NULL, NULL, NULL, NULL, 4),
(194548, NULL, 'G3DSA:1.25.40.180:FF:000073', NULL, NULL, 'Unplaced genomic scaffold supercont2.22, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(194549, NULL, 'G3DSA:3.40.50.2300:FF:001520', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194550, NULL, 'G3DSA:1.25.10.10:FF:002014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194551, NULL, 'G3DSA:3.90.550.10:FF:000725', NULL, NULL, 'Alginate synthesis-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(194552, NULL, 'G3DSA:3.60.10.10:FF:000051', NULL, NULL, 'Carbon catabolite repressor protein 4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194553, NULL, 'G3DSA:1.20.1560.10:FF:000445', NULL, NULL, 'ABC-type multidrug transport system, ATPase and permease component', NULL, NULL, NULL, NULL, NULL, 4),
(194554, NULL, 'G3DSA:1.25.40.470:FF:000053', NULL, NULL, 'Coatomer subunit alpha-1', NULL, NULL, NULL, NULL, NULL, 4),
(194555, NULL, 'G3DSA:3.10.100.10:FF:000165', NULL, NULL, 'Putative invasin', NULL, NULL, NULL, NULL, NULL, 4),
(194556, NULL, 'G3DSA:1.25.10.10:FF:002486', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194557, NULL, 'G3DSA:3.30.160.60:FF:003731', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194558, NULL, 'G3DSA:3.30.200.20:FF:000137', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(194559, NULL, 'G3DSA:3.30.479.20:FF:000042', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(194560, NULL, 'G3DSA:1.25.40.20:FF:000288', NULL, NULL, 'Serine/threonine-protein phosphatase 6 regulatory ankyrin repeat subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(194561, NULL, 'G3DSA:1.10.10.60:FF:001202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194562, NULL, 'G3DSA:2.20.50.20:FF:000004', NULL, NULL, 'Vitellogenin 7', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(194563, NULL, 'G3DSA:1.25.40.10:FF:004663', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194564, NULL, 'G3DSA:1.25.10.10:FF:000783', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(194565, NULL, 'G3DSA:1.20.120.1080:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194566, NULL, 'G3DSA:1.20.120.550:FF:000001', NULL, NULL, 'Inner membrane protein yecN', NULL, NULL, NULL, NULL, NULL, 4),
(194567, NULL, 'G3DSA:3.30.420.40:FF:000901', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194568, NULL, 'G3DSA:3.40.50.300:FF:003552', NULL, NULL, 'RAB13, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(194569, NULL, 'G3DSA:1.10.238.10:FF:000615', NULL, NULL, 'Plastin 1 (I isoform)', NULL, NULL, NULL, NULL, NULL, 4),
(194570, NULL, 'G3DSA:2.30.29.30:FF:000856', NULL, NULL, 'Putative Sprouty-related, EVH1 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(194571, NULL, 'G3DSA:2.130.10.10:FF:002641', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194572, NULL, 'G3DSA:1.10.238.20:FF:000040', NULL, NULL, 'AGAP006278-PA', NULL, NULL, NULL, NULL, NULL, 4),
(194573, NULL, 'G3DSA:2.40.40.20:FF:000008', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(194574, NULL, 'G3DSA:3.20.20.80:FF:000563', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(194575, NULL, 'G3DSA:2.20.100.10:FF:000110', NULL, NULL, 'Circumsporozoite-and TRAP-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(194576, NULL, 'G3DSA:2.130.10.10:FF:001213', NULL, NULL, 'Intraflagellar transport protein 172', NULL, NULL, NULL, NULL, NULL, 4),
(194577, NULL, 'G3DSA:3.40.50.12550:FF:000002', NULL, NULL, 'Putative ubiquitin-activating enzyme e1', NULL, NULL, NULL, NULL, NULL, 4),
(194578, NULL, 'G3DSA:1.10.10.60:FF:000590', NULL, NULL, 'Cyclin-D-binding Myb transcription factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(194579, NULL, 'G3DSA:1.20.1250.20:FF:000576', NULL, NULL, 'Probable nitrate/nitrite transporter NarK2', NULL, NULL, NULL, NULL, NULL, 4),
(194580, NULL, 'G3DSA:3.40.50.300:FF:002124', NULL, NULL, 'ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(194581, NULL, 'G3DSA:3.90.640.10:FF:000266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194582, NULL, 'G3DSA:2.60.270.50:FF:000001', NULL, NULL, 'Hemolysin', NULL, NULL, NULL, NULL, NULL, 4),
(194583, NULL, 'G3DSA:3.30.420.40:FF:000890', NULL, NULL, 'Glycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(194584, NULL, 'G3DSA:3.40.50.460:FF:000002', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(194585, NULL, 'G3DSA:3.40.50.300:FF:001505', NULL, NULL, 'Translation elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(194586, NULL, 'G3DSA:3.30.1960.10:FF:000022', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(194587, NULL, 'G3DSA:2.30.30.140:FF:000307', NULL, NULL, 'Putative ATP-dependent RNA helicase TDRD12-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(194588, NULL, 'G3DSA:3.90.340.10:FF:000007', NULL, NULL, 'Nitric oxide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(194589, NULL, 'G3DSA:2.20.25.80:FF:000014', NULL, NULL, 'WRKY transcription factor 55', NULL, NULL, NULL, NULL, NULL, 4),
(194590, NULL, 'G3DSA:4.10.60.10:FF:000037', NULL, NULL, 'DEAD-box ATP-dependent RNA helicase 3, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(194591, NULL, 'G3DSA:3.20.20.20:FF:000017', NULL, NULL, 'Methionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(194592, NULL, 'G3DSA:3.30.160.60:FF:002303', NULL, NULL, 'Zinc finger protein 559', NULL, NULL, NULL, NULL, NULL, 4),
(194593, NULL, 'G3DSA:2.40.50.140:FF:000141', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(194594, NULL, 'G3DSA:1.10.418.10:FF:000129', NULL, NULL, 'Cortexillin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194595, NULL, 'G3DSA:3.40.30.10:FF:000227', NULL, NULL, 'glutathione S-transferase theta-1', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(194596, NULL, 'G3DSA:2.60.120.10:FF:000810', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194597, NULL, 'G3DSA:1.20.140.40:FF:000086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194598, NULL, 'G3DSA:3.40.50.150:FF:001213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194599, NULL, 'G3DSA:3.30.1370.10:FF:000230', NULL, NULL, 'KH domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(194600, NULL, 'G3DSA:3.80.10.10:FF:000680', NULL, NULL, 'Probable leucine-rich repeat receptor-like protein kinase At2g33170', NULL, NULL, NULL, NULL, NULL, 4),
(194601, NULL, 'G3DSA:3.90.950.10:FF:000025', NULL, NULL, 'Maf-like_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(194602, NULL, 'G3DSA:1.10.8.430:FF:000007', NULL, NULL, 'Putative disease resistance protein At3g14460', NULL, NULL, NULL, NULL, NULL, 4),
(194603, NULL, 'G3DSA:1.10.510.10:FF:003621', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194604, NULL, 'G3DSA:3.30.420.40:FF:000789', NULL, NULL, 'Type II pantothenate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(194605, NULL, 'G3DSA:2.20.90.10:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194606, NULL, 'G3DSA:2.115.10.20:FF:000021', NULL, NULL, 'Alpha-L-arabinofuranosidase axhA-2', NULL, NULL, NULL, NULL, NULL, 4),
(194607, NULL, 'G3DSA:1.10.630.10:FF:000212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194608, NULL, 'G3DSA:3.30.160.60:FF:001477', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194609, NULL, 'G3DSA:2.60.40.10:FF:000960', NULL, NULL, 'NPHS1, nephrin', NULL, NULL, NULL, NULL, NULL, 4),
(194610, NULL, 'G3DSA:3.10.20.90:FF:000870', NULL, NULL, 'Plant UBX domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(194611, NULL, 'G3DSA:1.10.246.20:FF:000013', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 15', NULL, NULL, NULL, NULL, NULL, 4),
(194612, NULL, 'G3DSA:2.30.39.10:FF:000031', NULL, NULL, 'Probable non-inhibitory serpin-Z9', NULL, NULL, NULL, NULL, NULL, 4),
(194613, NULL, 'G3DSA:3.40.1190.20:FF:000172', NULL, NULL, 'Bifunctional protein HldE', NULL, NULL, NULL, NULL, NULL, 4),
(194614, NULL, 'G3DSA:3.40.50.300:FF:006295', NULL, NULL, 'DEAD/DEAH box helicase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(194615, NULL, 'G3DSA:2.10.25.10:FF:001764', NULL, NULL, 'Tyrosine protein kinase receptor tie-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194616, NULL, 'G3DSA:3.30.420.10:FF:000454', NULL, NULL, 'Piwi-like protein ergo-1', NULL, NULL, NULL, NULL, NULL, 4),
(194617, NULL, 'G3DSA:1.20.920.10:FF:000165', NULL, NULL, 'SNF2 family N-terminal domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(194618, NULL, 'G3DSA:3.60.20.10:FF:000136', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(194619, NULL, 'G3DSA:2.30.30.40:FF:000379', NULL, NULL, 'ITSN (Intersectin) family', NULL, NULL, NULL, NULL, NULL, 4),
(194620, NULL, 'G3DSA:2.10.25.10:FF:000354', NULL, NULL, 'Putative low-density lipoprotein receptor-related protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(194621, NULL, 'G3DSA:2.40.170.20:FF:000068', NULL, NULL, 'SusC homolog', NULL, NULL, NULL, NULL, NULL, 4),
(194622, NULL, 'G3DSA:1.10.730.10:FF:000164', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(194623, NULL, 'G3DSA:2.40.50.40:FF:000043', NULL, NULL, 'Testis-specific chromodomain protein Y 2', NULL, NULL, NULL, NULL, NULL, 4),
(194624, NULL, 'G3DSA:1.10.287.380:FF:000013', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(194625, NULL, 'G3DSA:1.10.10.10:FF:001345', NULL, NULL, 'ESCRT-II complex subunit-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(194626, NULL, 'G3DSA:3.30.980.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194627, NULL, 'G3DSA:3.40.50.720:FF:002486', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(194628, NULL, 'G3DSA:1.20.58.900:FF:000022', NULL, NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(194629, NULL, 'G3DSA:3.30.70.330:FF:001425', NULL, NULL, 'AGAP012853-PA', NULL, NULL, NULL, NULL, NULL, 4),
(194630, NULL, 'G3DSA:1.10.2000.10:FF:000035', NULL, NULL, 'AGAP000168-PA', NULL, NULL, NULL, NULL, NULL, 4),
(194631, NULL, 'G3DSA:1.10.1670.10:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194632, NULL, 'G3DSA:3.80.10.10:FF:004518', NULL, NULL, 'Phytosulfokine receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(194633, NULL, 'G3DSA:1.20.1070.10:FF:000812', NULL, NULL, 'Olfactory receptor 818', NULL, NULL, NULL, NULL, NULL, 4),
(194634, NULL, 'G3DSA:1.20.1250.20:FF:002133', NULL, NULL, 'Solute carrier family 15 member 3', NULL, NULL, NULL, NULL, NULL, 4),
(194635, NULL, 'G3DSA:1.10.1330.10:FF:000003', NULL, NULL, 'Endo-1,4-beta-xylanase Y', NULL, NULL, NULL, NULL, NULL, 4),
(194636, NULL, 'G3DSA:3.30.2410.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194637, NULL, 'G3DSA:1.25.50.20:FF:000002', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(194638, NULL, 'G3DSA:3.20.20.80:FF:000080', NULL, NULL, 'Beta-glucuronidase UidA', NULL, NULL, NULL, NULL, NULL, 4),
(194639, NULL, 'G3DSA:1.10.287.1150:FF:000009', NULL, NULL, '2-oxoglutarate dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(194640, NULL, 'G3DSA:2.60.40.60:FF:000963', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(194641, NULL, 'G3DSA:2.40.50.90:FF:000064', NULL, NULL, 'Endonuclease YncB', NULL, NULL, NULL, NULL, NULL, 4),
(194642, NULL, 'G3DSA:1.10.275.10:FF:000004', NULL, NULL, 'Argininosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(194643, NULL, 'G3DSA:1.10.1450.10:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194644, NULL, 'G3DSA:1.20.1070.10:FF:001998', NULL, NULL, 'Protein CBG05475', NULL, NULL, NULL, NULL, NULL, 4),
(194645, NULL, 'G3DSA:3.30.200.20:FF:000351', NULL, NULL, 'protein kinase PINOID 2', NULL, NULL, NULL, NULL, NULL, 4),
(194646, NULL, 'G3DSA:3.30.450.70:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194647, NULL, 'G3DSA:3.40.50.300:FF:007604', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(194648, NULL, 'G3DSA:3.30.760.10:FF:000041', NULL, NULL, 'Eukaryotic translation initiation factor 4E', NULL, NULL, NULL, NULL, NULL, 4),
(194649, NULL, 'G3DSA:1.10.10.790:FF:000006', NULL, NULL, 'U2 snRNP-associated SURP motif-containing protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(194650, NULL, 'G3DSA:3.90.70.40:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194651, NULL, 'G3DSA:1.10.3730.20:FF:000003', NULL, NULL, 'Probable 4-amino-4-deoxy-L-arabinose-phosphoundecaprenol flippase subunit ArnF', NULL, NULL, NULL, NULL, NULL, 4),
(194652, NULL, 'G3DSA:3.10.110.10:FF:000351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194653, NULL, 'G3DSA:3.30.40.10:FF:002162', NULL, NULL, 'Structure-specific endonuclease subunit SLX1', NULL, NULL, NULL, NULL, NULL, 4),
(194654, NULL, 'G3DSA:3.40.50.2300:FF:000222', NULL, NULL, 'Chemotaxis protein CheV', NULL, NULL, NULL, NULL, NULL, 4),
(194655, NULL, 'G3DSA:2.60.220.50:FF:000178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194656, NULL, 'G3DSA:3.80.10.10:FF:001989', NULL, NULL, 'Toll-like receptor 22', NULL, NULL, NULL, NULL, NULL, 4),
(194657, NULL, 'G3DSA:3.40.190.170:FF:000007', NULL, NULL, 'C4-dicarboxylate-binding periplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(194658, NULL, 'G3DSA:3.40.50.720:FF:001867', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194659, NULL, 'G3DSA:2.30.42.10:FF:000033', NULL, NULL, 'Rho guanine nucleotide exchange factor (GEF) 11', NULL, NULL, NULL, NULL, NULL, 4),
(194660, NULL, 'G3DSA:2.10.110.10:FF:000220', NULL, NULL, 'Rho-GTPase-activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194661, NULL, 'G3DSA:3.40.1650.10:FF:000002', NULL, NULL, 'D-ribose pyranase', NULL, NULL, NULL, NULL, NULL, 4),
(194662, NULL, 'G3DSA:3.90.260.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(194663, NULL, 'G3DSA:2.60.300.12:FF:000001', NULL, NULL, 'Iron-binding protein IscA', NULL, NULL, NULL, NULL, NULL, 4),
(194664, NULL, 'G3DSA:2.60.220.50:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194665, NULL, 'G3DSA:3.30.497.10:FF:000086', NULL, NULL, 'Serine protease inhibitor (SERPIN) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(194666, NULL, 'G3DSA:1.10.10.10:FF:000940', NULL, NULL, 'RpiR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(194667, NULL, 'G3DSA:3.30.310.180:FF:000002', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 20', NULL, NULL, NULL, NULL, NULL, 4),
(194668, NULL, 'G3DSA:3.90.930.12:FF:000009', NULL, NULL, '60S ribosomal protein L6', NULL, NULL, NULL, NULL, NULL, 4),
(194669, NULL, 'G3DSA:3.30.428.10:FF:000011', NULL, NULL, 'Fragile histidine triad', NULL, NULL, NULL, NULL, NULL, 4),
(194670, NULL, 'G3DSA:1.10.3680.10:FF:000001', NULL, NULL, 'Co-chaperone protein DjlA', NULL, NULL, NULL, NULL, NULL, 4),
(194671, NULL, 'G3DSA:3.20.20.140:FF:000220', NULL, NULL, 'Glr3518 protein', NULL, NULL, NULL, NULL, NULL, 4),
(194672, NULL, 'G3DSA:4.10.1030.10:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194673, NULL, 'G3DSA:4.10.400.10:FF:000111', NULL, NULL, 'Low density lipoprotein receptor', NULL, NULL, NULL, NULL, NULL, 4),
(194674, NULL, 'G3DSA:3.30.160.60:FF:005176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194675, NULL, 'G3DSA:1.25.40.10:FF:005282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194676, NULL, 'G3DSA:3.40.190.150:FF:000001', NULL, NULL, 'Tricarboxylate transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(194677, NULL, 'G3DSA:3.80.10.10:FF:004165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194678, NULL, 'G3DSA:3.50.7.10:FF:000034', NULL, NULL, 'T-complex protein 1 subunit zeta, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194679, NULL, 'G3DSA:2.130.10.10:FF:002399', NULL, NULL, 'Lethal (3) 72Dn, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(194680, NULL, 'G3DSA:4.10.900.10:FF:000025', NULL, NULL, 'Cadherin 26, tandem duplicate 1', NULL, NULL, NULL, NULL, NULL, 4),
(194681, NULL, 'G3DSA:1.50.10.10:FF:000056', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(194682, NULL, 'G3DSA:2.60.40.2170:FF:000004', NULL, NULL, 'tyrosine-protein kinase RYK', NULL, NULL, NULL, NULL, NULL, 4),
(194683, NULL, 'G3DSA:3.30.70.330:FF:000599', NULL, NULL, 'Poly(A) binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(194684, NULL, 'G3DSA:3.40.120.10:FF:000013', NULL, NULL, 'Phosphoacetylglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(194685, NULL, 'G3DSA:3.30.1010.10:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194686, NULL, 'G3DSA:3.40.190.10:FF:000658', NULL, NULL, 'ABC transporter, substrate-binding protein, family 5', NULL, NULL, NULL, NULL, NULL, 4),
(194687, NULL, 'G3DSA:1.20.1260.100:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194688, NULL, 'G3DSA:3.40.850.10:FF:000203', NULL, NULL, 'Kinesin motor domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(194689, NULL, 'G3DSA:3.40.50.300:FF:002933', NULL, NULL, 'Putative arsenical pump-driving ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(194690, NULL, 'G3DSA:1.10.532.10:FF:000001', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(194691, NULL, 'G3DSA:3.30.1330.20:FF:000011', NULL, NULL, 'Cell division protein FtsZ', NULL, NULL, NULL, NULL, NULL, 4),
(194692, NULL, 'G3DSA:1.25.40.10:FF:001706', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g16860', NULL, NULL, NULL, NULL, NULL, 4),
(194693, NULL, 'G3DSA:1.10.630.10:FF:000342', NULL, NULL, 'Os07g0482900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(194694, NULL, 'G3DSA:3.10.20.90:FF:000982', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194695, NULL, 'G3DSA:3.30.160.60:FF:001365', NULL, NULL, 'Flt3-interacting zinc finger protein 1', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(194696, NULL, 'G3DSA:3.90.660.20:FF:000023', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(194697, NULL, 'G3DSA:1.25.40.10:FF:005068', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g01030, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(194698, NULL, 'G3DSA:2.60.40.10:FF:004220', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194699, NULL, 'G3DSA:1.10.472.130:FF:000086', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(194700, NULL, 'G3DSA:1.25.40.10:FF:002746', NULL, NULL, 'Tetratricopeptide repeat domain 19, transcript variant X1', NULL, NULL, NULL, NULL, NULL, 4),
(194701, NULL, 'G3DSA:1.10.510.10:FF:000636', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(194702, NULL, 'G3DSA:1.20.1270.10:FF:000001', NULL, NULL, 'Molecular chaperone DnaK', NULL, NULL, NULL, NULL, NULL, 4),
(194703, NULL, 'G3DSA:3.30.420.40:FF:000659', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194704, NULL, 'G3DSA:3.80.10.10:FF:000792', NULL, NULL, 'Predicted gene 13102', NULL, NULL, NULL, NULL, NULL, 4),
(194705, NULL, 'G3DSA:1.10.8.60:FF:000414', NULL, NULL, 'Nitrogen fixation master sigma-54-dependent transcriptional response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(194706, NULL, 'G3DSA:3.40.1110.10:FF:000416', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194707, NULL, 'G3DSA:1.10.555.10:FF:000037', NULL, NULL, 'Phosphatidylinositol 3-kinase regulatory subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(194708, NULL, 'G3DSA:1.10.238.10:FF:000132', NULL, NULL, 'Ryanodine receptor 44F', NULL, NULL, NULL, NULL, NULL, 4),
(194709, NULL, 'G3DSA:2.40.320.10:FF:000009', NULL, NULL, 'Adenylate cyclase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194710, NULL, 'G3DSA:3.30.1330.40:FF:000017', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(194711, NULL, 'G3DSA:1.20.5.110:FF:000230', NULL, NULL, 'SNARE protein (Ufe1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(194712, NULL, 'G3DSA:2.130.10.10:FF:004439', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(194713, NULL, 'G3DSA:2.30.280.10:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194714, NULL, 'G3DSA:3.40.50.300:FF:008335', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(194715, NULL, 'G3DSA:2.30.29.30:FF:000064', NULL, NULL, 'Adaptin ear-binding coat-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(194716, NULL, 'G3DSA:3.80.10.10:FF:002478', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194717, NULL, 'G3DSA:2.30.110.10:FF:000108', NULL, NULL, 'Pyridoxine/pyridoxamine 5''-phosphate oxidase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(194718, NULL, 'G3DSA:3.40.50.2000:FF:000008', NULL, NULL, 'Glycogen synthase', NULL, NULL, NULL, NULL, NULL, 4),
(194719, NULL, 'G3DSA:3.30.40.10:FF:000942', NULL, NULL, 'SPRY domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(194720, NULL, 'G3DSA:3.40.50.720:FF:000457', NULL, NULL, 'NAD dependent epimerase/dehydratase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(194721, NULL, 'G3DSA:3.30.930.10:FF:000212', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(194722, NULL, 'G3DSA:3.90.79.10:FF:000028', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(194723, NULL, 'G3DSA:3.10.20.90:FF:000061', NULL, NULL, 'Inhibitor of nuclear factor kappa-B kinase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(194724, NULL, 'G3DSA:3.30.1370.210:FF:000011', NULL, NULL, 'Zinc finger CCCH domain-containing protein 28', NULL, NULL, NULL, NULL, NULL, 4),
(194725, NULL, 'G3DSA:2.70.70.10:FF:000028', NULL, NULL, 'Conserved protein of uncharacterized function, possibly extracellular', NULL, NULL, NULL, NULL, NULL, 4),
(194726, NULL, 'G3DSA:3.30.710.10:FF:000313', NULL, NULL, 'BTB domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(194727, NULL, 'G3DSA:3.30.70.330:FF:001313', NULL, NULL, 'Glycine-rich RNA-binding protein 7', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(194728, NULL, 'G3DSA:2.130.10.10:FF:005384', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194729, NULL, 'G3DSA:1.25.40.10:FF:001920', NULL, NULL, 'Pentatricopeptide (PPR) repeat-containing protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(194730, NULL, 'G3DSA:2.30.39.10:FF:000143', NULL, NULL, 'Serpin-Z1', NULL, NULL, NULL, NULL, NULL, 4),
(194731, NULL, 'G3DSA:1.20.1250.20:FF:002021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194732, NULL, 'G3DSA:2.60.120.260:FF:000432', NULL, NULL, 'Glycoside hydrolase family 29', NULL, NULL, NULL, NULL, NULL, 4),
(194733, NULL, 'G3DSA:2.40.70.10:FF:000530', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194734, NULL, 'G3DSA:2.20.25.160:FF:000002', NULL, NULL, 'N-acyl-aromatic-L-amino acid amidohydrolase (carboxylate-forming) B', NULL, NULL, NULL, NULL, NULL, 4),
(194735, NULL, 'G3DSA:3.30.40.10:FF:001673', NULL, NULL, 'RABenoSyn (Trafficking protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(194736, NULL, 'G3DSA:3.40.630.30:FF:000092', NULL, NULL, 'N-alpha-acetyltransferase 60 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(194737, NULL, 'G3DSA:3.30.200.20:FF:001177', NULL, NULL, 'IP11267p', NULL, NULL, NULL, NULL, NULL, 4),
(194738, NULL, 'G3DSA:3.40.50.300:FF:000567', NULL, NULL, 'ATPase, AAA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(194739, NULL, 'G3DSA:2.70.170.10:FF:000255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194740, NULL, 'G3DSA:2.10.25.10:FF:000466', NULL, NULL, 'adhesion G protein-coupled receptor L4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(194741, NULL, 'G3DSA:1.10.3330.10:FF:000003', NULL, NULL, '2-oxo-4-hydroxy-4-carboxy-5-ureidoimidazoline decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(194742, NULL, 'G3DSA:2.60.40.1180:FF:000230', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(194743, NULL, 'G3DSA:1.10.510.10:FF:001581', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194744, NULL, 'G3DSA:1.10.490.10:FF:000009', NULL, NULL, 'hemoglobin subunit mu', NULL, NULL, NULL, NULL, NULL, 4),
(194745, NULL, 'G3DSA:2.60.40.10:FF:001365', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(194746, NULL, 'G3DSA:3.30.70.330:FF:002044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194747, NULL, 'G3DSA:1.20.1250.20:FF:001987', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(194748, NULL, 'G3DSA:1.10.10.10:FF:001457', NULL, NULL, 'Replication protein', NULL, NULL, NULL, NULL, NULL, 4),
(194749, NULL, 'G3DSA:2.130.10.10:FF:000954', NULL, NULL, 'Tup1p', NULL, NULL, NULL, NULL, NULL, 4),
(194750, NULL, 'G3DSA:3.30.40.10:FF:002078', NULL, NULL, 'Ubiquitin-protein ligase peroxin 12', NULL, NULL, NULL, NULL, NULL, 4),
(194751, NULL, 'G3DSA:3.10.100.10:FF:000277', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194752, NULL, 'G3DSA:3.40.50.300:FF:003181', NULL, NULL, 'GTPase Era, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(194753, NULL, 'G3DSA:3.30.1600.10:FF:000001', NULL, NULL, 'NAD-dependent deacetylase sirtuin-3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(194754, NULL, 'G3DSA:1.20.1250.20:FF:000216', NULL, NULL, 'NRT1/ PTR FAMILY 8.3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(194755, NULL, 'G3DSA:3.10.180.10:FF:000057', NULL, NULL, 'Biphenyl-2,3-diol 1,2-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(194756, NULL, 'G3DSA:3.60.10.10:FF:000181', NULL, NULL, 'Sphingomyelin phosphodiesterase 2', NULL, NULL, NULL, NULL, NULL, 4),
(194757, NULL, 'G3DSA:2.130.10.10:FF:003130', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(194758, NULL, 'G3DSA:3.40.640.10:FF:000171', NULL, NULL, 'BnaA05g34080D protein', NULL, NULL, NULL, NULL, NULL, 4),
(194759, NULL, 'G3DSA:3.20.20.70:FF:000200', NULL, NULL, 'Anaerobic sulfatase maturase', NULL, NULL, NULL, NULL, NULL, 4),
(194760, NULL, 'G3DSA:3.80.10.10:FF:003097', NULL, NULL, 'Oligodendrocyte myelin glycoprotein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(194761, NULL, 'G3DSA:3.90.550.50:FF:000029', NULL, NULL, 'Glycosyltransferase family 31 protein', NULL, NULL, NULL, NULL, NULL, 4),
(194762, NULL, 'G3DSA:1.20.5.100:FF:000013', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(194763, NULL, 'G3DSA:2.60.40.10:FF:005529', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194764, NULL, 'G3DSA:3.10.105.10:FF:000024', NULL, NULL, 'Peptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(194765, NULL, 'G3DSA:2.130.10.10:FF:001230', NULL, NULL, 'WD repeat-containing protein 91', NULL, NULL, NULL, NULL, NULL, 4),
(194766, NULL, 'G3DSA:2.130.10.10:FF:000724', NULL, NULL, 'Protein transport protein SEC31', NULL, NULL, NULL, NULL, NULL, 4),
(194767, NULL, 'G3DSA:1.20.58.100:FF:000013', NULL, NULL, 'L-aspartate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(194768, NULL, 'G3DSA:2.60.40.10:FF:002775', NULL, NULL, 'Fibroblast growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(194769, NULL, 'G3DSA:3.40.50.150:FF:000724', NULL, NULL, 'PRIP-interacting protein PIPMT', NULL, NULL, NULL, NULL, NULL, 4),
(194770, NULL, 'G3DSA:1.20.1070.10:FF:000020', NULL, NULL, 'Frizzled class receptor 10', NULL, NULL, NULL, NULL, NULL, 4),
(194771, NULL, 'G3DSA:2.30.29.30:FF:000744', NULL, NULL, 'PH-protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(194772, NULL, 'G3DSA:3.80.10.10:FF:000803', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(194773, NULL, 'G3DSA:2.30.29.30:FF:000305', NULL, NULL, '3-phosphoinositide-dependent protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(194774, NULL, 'G3DSA:3.40.50.10190:FF:000042', NULL, NULL, 'PAX interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(194775, NULL, 'G3DSA:1.20.1560.10:FF:000557', NULL, NULL, 'Protein CBR-MRP-1', NULL, NULL, NULL, NULL, NULL, 4),
(194776, NULL, 'G3DSA:3.30.200.20:FF:002149', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(194777, NULL, 'G3DSA:1.10.20.10:FF:000345', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194778, NULL, 'G3DSA:3.30.450.50:FF:000035', NULL, NULL, 'Putative vesicle-associated membrane protein (Vamp)', NULL, NULL, NULL, NULL, NULL, 4),
(194779, NULL, 'G3DSA:3.30.160.60:FF:004220', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194780, NULL, 'G3DSA:2.60.40.420:FF:000201', NULL, NULL, 'Blue (Type 1) copper domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(194781, NULL, 'G3DSA:3.40.50.300:FF:006418', NULL, NULL, 'DAR GTPase 2 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(194782, NULL, 'G3DSA:1.10.437.10:FF:000038', NULL, NULL, 'Zgc:153993', NULL, NULL, NULL, NULL, NULL, 4),
(194783, NULL, 'G3DSA:1.10.150.20:FF:000190', NULL, NULL, 'DNA-binding protein MutS2', NULL, NULL, NULL, NULL, NULL, 4),
(194784, NULL, 'G3DSA:1.10.510.10:FF:004447', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194785, NULL, 'G3DSA:3.40.190.10:FF:000742', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(194786, NULL, 'G3DSA:1.25.10.10:FF:000671', NULL, NULL, 'Importin beta-4 subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194787, NULL, 'G3DSA:1.10.274.30:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194788, NULL, 'G3DSA:3.40.50.720:FF:001429', NULL, NULL, 'Polyketide synthase type I', NULL, NULL, NULL, NULL, NULL, 4),
(194789, NULL, 'G3DSA:3.30.420.110:FF:000074', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(194790, NULL, 'G3DSA:1.10.510.10:FF:002553', NULL, NULL, 'Serine/threonine kinase, cell division control protein 7 related', NULL, NULL, NULL, NULL, NULL, 4),
(194791, NULL, 'G3DSA:3.30.160.60:FF:004883', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194792, NULL, 'G3DSA:2.40.50.40:FF:000060', NULL, NULL, 'C-C motif chemokine', NULL, NULL, NULL, NULL, NULL, 4),
(194793, NULL, 'G3DSA:2.60.40.10:FF:000297', NULL, NULL, 'Myosin light chain kinase, smooth muscle', NULL, NULL, NULL, NULL, NULL, 4),
(194794, NULL, 'G3DSA:3.40.1160.10:FF:000015', NULL, NULL, 'Acetylglutamate kinase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(194795, NULL, 'G3DSA:3.50.50.60:FF:000693', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194796, NULL, 'G3DSA:1.20.840.10:FF:000001', NULL, NULL, 'Methyl-coenzyme M reductase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(194797, NULL, 'G3DSA:3.20.20.80:FF:000451', NULL, NULL, 'Os07g0538966 protein', NULL, NULL, NULL, NULL, NULL, 4),
(194798, NULL, 'G3DSA:1.25.40.180:FF:000185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194799, NULL, 'G3DSA:3.80.10.10:FF:001197', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(194800, NULL, 'G3DSA:3.60.40.10:FF:000019', NULL, NULL, 'PAS sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(194801, NULL, 'G3DSA:1.20.1730.10:FF:000020', NULL, NULL, 'sodium/glucose cotransporter 5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(194802, NULL, 'G3DSA:1.25.10.20:FF:000005', NULL, NULL, 'Apolipoprotein lipid transfer particle', NULL, NULL, NULL, NULL, NULL, 4),
(194803, NULL, 'G3DSA:1.10.8.10:FF:000309', NULL, NULL, 'UBA/TS-N domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(194804, NULL, 'G3DSA:3.40.50.20:FF:000018', NULL, NULL, 'Carnosine synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(194805, NULL, 'G3DSA:1.10.10.10:FF:001120', NULL, NULL, 'Transcriptional regulator, LuxR family', NULL, NULL, NULL, NULL, NULL, 4),
(194806, NULL, 'G3DSA:2.60.40.60:FF:000946', NULL, NULL, 'Cad74A isoform A family protein', NULL, NULL, NULL, NULL, NULL, 4),
(194807, NULL, 'G3DSA:3.90.640.10:FF:000154', NULL, NULL, 'Luminal-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(194808, NULL, 'G3DSA:3.40.50.300:FF:003422', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(194809, NULL, 'G3DSA:3.30.160.60:FF:000960', NULL, NULL, 'zinc finger protein Rlf', NULL, NULL, NULL, NULL, NULL, 4),
(194810, NULL, 'G3DSA:1.25.40.420:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194811, NULL, 'G3DSA:2.60.40.10:FF:001606', NULL, NULL, 'uncharacterized protein LOC108091111', NULL, NULL, NULL, NULL, NULL, 4),
(194812, NULL, 'G3DSA:2.40.128.20:FF:000009', NULL, NULL, 'Temperature-induced lipocalin', NULL, NULL, NULL, NULL, NULL, 4),
(194813, NULL, 'G3DSA:1.20.1270.60:FF:000331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194814, NULL, 'G3DSA:1.10.510.10:FF:001934', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(194815, NULL, 'G3DSA:2.130.10.10:FF:001573', NULL, NULL, 'F-box and WD domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(194816, NULL, 'G3DSA:2.60.40.150:FF:000553', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(194817, NULL, 'G3DSA:3.30.70.330:FF:000357', NULL, NULL, 'Ribonucleoprotein A, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(194818, NULL, 'G3DSA:3.40.50.410:FF:000257', NULL, NULL, 'voltage-dependent calcium channel subunit alpha-2/delta-3-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(194819, NULL, 'G3DSA:1.10.630.10:FF:000572', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194820, NULL, 'G3DSA:3.40.50.300:FF:002012', NULL, NULL, 'Large ribosomal subunit associated GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194821, NULL, 'G3DSA:2.60.40.10:FF:003394', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194822, NULL, 'G3DSA:3.30.1640.10:FF:000094', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(194823, NULL, 'G3DSA:3.40.50.12780:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194824, NULL, 'G3DSA:3.40.50.970:FF:000178', NULL, NULL, 'Indolepyruvate oxidoreductase subunit IorA', NULL, NULL, NULL, NULL, NULL, 4),
(194825, NULL, 'G3DSA:2.30.42.10:FF:000050', NULL, NULL, 'Periplasmic serine endoprotease DegP-like', NULL, NULL, NULL, NULL, NULL, 4),
(194826, NULL, 'G3DSA:1.20.1740.10:FF:000105', NULL, NULL, 'Amino acid transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194827, NULL, 'G3DSA:3.90.190.10:FF:000304', NULL, NULL, 'Dual-specificity phosphatase 10', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(194828, NULL, 'G3DSA:3.40.50.300:FF:007363', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194829, NULL, 'G3DSA:2.60.120.380:FF:000030', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194830, NULL, 'G3DSA:1.25.40.10:FF:004793', NULL, NULL, 'Enhanced entry protein enhC, tetratricopeptide repeat family', NULL, NULL, NULL, NULL, NULL, 4),
(194831, NULL, 'G3DSA:1.10.520.10:FF:000013', NULL, NULL, 'thylakoid lumenal 29 kDa protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(194832, NULL, 'G3DSA:3.50.50.60:FF:000350', NULL, NULL, 'Putative halogenase', NULL, NULL, NULL, NULL, NULL, 4),
(194833, NULL, 'G3DSA:1.20.58.1120:FF:000025', NULL, NULL, 'Dynein heavy chain 6, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(194834, NULL, 'G3DSA:1.10.510.10:FF:002210', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194835, NULL, 'G3DSA:1.10.10.60:FF:000713', NULL, NULL, 'Gon4-like family protein', NULL, NULL, NULL, NULL, NULL, 4),
(194836, NULL, 'G3DSA:1.25.40.10:FF:003270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194837, NULL, 'G3DSA:2.60.120.340:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194838, NULL, 'G3DSA:3.40.50.150:FF:000241', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(194839, NULL, 'G3DSA:2.170.150.80:FF:000020', NULL, NULL, 'ANAC097', NULL, NULL, NULL, NULL, NULL, 4),
(194840, NULL, 'G3DSA:1.25.10.10:FF:000569', NULL, NULL, 'Putative dentin phosphoryn protein', NULL, NULL, NULL, NULL, NULL, 4),
(194841, NULL, 'G3DSA:3.50.50.60:FF:000254', NULL, NULL, 'NAD(P)-binding Rossmann-like domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(194842, NULL, 'G3DSA:1.20.1560.10:FF:000220', NULL, NULL, 'Unplaced genomic scaffold supercont2.6, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(194843, NULL, 'G3DSA:3.30.710.10:FF:000190', NULL, NULL, 'YIL001W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(194844, NULL, 'G3DSA:1.10.510.10:FF:001704', NULL, NULL, 'Serine/threonine-protein kinase ATG1c', NULL, NULL, NULL, NULL, NULL, 4),
(194845, NULL, 'G3DSA:2.30.29.30:FF:001020', NULL, NULL, 'Rho GTPase-activating protein 20-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(194846, NULL, 'G3DSA:2.60.40.10:FF:005631', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194847, NULL, 'G3DSA:3.30.200.20:FF:000800', NULL, NULL, 'Os02g0194600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(194848, NULL, 'G3DSA:1.25.40.10:FF:000408', NULL, NULL, 'Pentatricopeptide repeat domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(194849, NULL, 'G3DSA:1.10.510.10:FF:004110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194850, NULL, 'G3DSA:3.10.250.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194851, NULL, 'G3DSA:4.10.280.10:FF:000134', NULL, NULL, 'Max-like protein X', NULL, NULL, NULL, NULL, NULL, 4),
(194852, NULL, 'G3DSA:3.40.50.300:FF:001186', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(194853, NULL, 'G3DSA:2.40.50.140:FF:000803', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194854, NULL, 'G3DSA:3.40.1110.10:FF:000063', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(194855, NULL, 'G3DSA:3.40.50.12230:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194856, NULL, 'G3DSA:3.60.130.10:FF:000088', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(194857, NULL, 'G3DSA:1.50.10.10:FF:000039', NULL, NULL, 'Glycogen debranching enzyme Gdb1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194858, NULL, 'G3DSA:3.30.160.60:FF:006148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194859, NULL, 'G3DSA:3.40.50.300:FF:000679', NULL, NULL, 'Thymidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(194860, NULL, 'G3DSA:3.10.20.90:FF:000639', NULL, NULL, 'Small ubiquitin-related modifier', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(194861, NULL, 'G3DSA:2.20.70.10:FF:000126', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(194862, NULL, 'G3DSA:2.40.160.20:FF:000011', NULL, NULL, 'Outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(194863, NULL, 'G3DSA:1.10.640.10:FF:000056', NULL, NULL, 'Probable ovoperoxidase', NULL, NULL, NULL, NULL, NULL, 4),
(194864, NULL, 'G3DSA:3.40.50.1820:FF:001123', NULL, NULL, 'AGAP007991-PA', NULL, NULL, NULL, NULL, NULL, 4),
(194865, NULL, 'G3DSA:1.25.40.10:FF:002325', NULL, NULL, 'BBS4 isoform 11', NULL, NULL, NULL, NULL, NULL, 4),
(194866, NULL, 'G3DSA:3.40.630.30:FF:000120', NULL, NULL, 'N(alpha)-acetyltransferase 40, NatD catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(194867, NULL, 'G3DSA:3.10.50.40:FF:000025', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(194868, NULL, 'G3DSA:2.30.29.230:FF:000006', NULL, NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', NULL, NULL, NULL, NULL, NULL, 4),
(194869, NULL, 'G3DSA:1.25.40.10:FF:001353', NULL, NULL, 'Os12g0289800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(194870, NULL, 'G3DSA:1.25.40.90:FF:000056', NULL, NULL, 'PCF11 cleavage and polyadenylation factor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(194871, NULL, 'G3DSA:1.10.510.10:FF:000395', NULL, NULL, 'receptor-like serine/threonine-protein kinase NCRK', NULL, NULL, NULL, NULL, NULL, 4),
(194872, NULL, 'G3DSA:3.40.720.10:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194873, NULL, 'G3DSA:3.30.40.10:FF:000150', NULL, NULL, 'Inactive histone-lysine N-methyltransferase 2E', NULL, NULL, NULL, NULL, NULL, 4),
(194874, NULL, 'G3DSA:1.25.10.10:FF:001188', NULL, NULL, 'MMS19 nucleotide excision repair protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(194875, NULL, 'G3DSA:1.20.120.520:FF:000003', NULL, NULL, 'Iron-sulfur cluster repair protein ScdA', NULL, NULL, NULL, NULL, NULL, 4),
(194876, NULL, 'G3DSA:1.20.5.4770:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194877, NULL, 'G3DSA:1.10.510.10:FF:003379', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194878, NULL, 'G3DSA:3.30.160.60:FF:002758', NULL, NULL, 'Zinc finger protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(194879, NULL, 'G3DSA:2.130.10.10:FF:004086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194880, NULL, 'G3DSA:3.10.260.10:FF:000007', NULL, NULL, 'DNA-binding domain of Mlu1-box binding protein MBP1', NULL, NULL, NULL, NULL, NULL, 4),
(194881, NULL, 'G3DSA:1.25.40.20:FF:001586', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(194882, NULL, 'G3DSA:3.40.50.2000:FF:000351', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(194883, NULL, 'G3DSA:1.10.418.10:FF:000146', NULL, NULL, 'Dystrophin', NULL, NULL, NULL, NULL, NULL, 4),
(194884, NULL, 'G3DSA:1.10.10.10:FF:001912', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194885, NULL, 'G3DSA:3.40.50.150:FF:001090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194886, NULL, 'G3DSA:2.40.430.10:FF:000001', NULL, NULL, 'Maltose ABC transporter permease MalF', NULL, NULL, NULL, NULL, NULL, 4),
(194887, NULL, 'G3DSA:3.40.50.1240:FF:000191', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194888, NULL, 'G3DSA:1.20.1600.10:FF:000033', NULL, NULL, 'Blr5467 protein', NULL, NULL, NULL, NULL, NULL, 4),
(194889, NULL, 'G3DSA:2.60.120.200:FF:000572', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194890, NULL, 'G3DSA:3.30.40.10:FF:002050', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(194891, NULL, 'G3DSA:3.30.2350.10:FF:000021', NULL, NULL, 'Pseudouridine synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194892, NULL, 'G3DSA:2.60.40.2120:FF:000001', NULL, NULL, 'Surface layer protein', NULL, NULL, NULL, NULL, NULL, 4),
(194893, NULL, 'G3DSA:2.30.30.40:FF:000149', NULL, NULL, 'neutrophil cytosol factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(194894, NULL, 'G3DSA:2.60.120.650:FF:000021', NULL, NULL, 'Lysine-specific demethylase 7A', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(194895, NULL, 'G3DSA:3.30.30.30:FF:000071', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(194896, NULL, 'G3DSA:3.30.930.10:FF:000324', NULL, NULL, 'Putative lipoyltransferase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(194897, NULL, 'G3DSA:3.20.20.70:FF:000122', NULL, NULL, '2-iminoacetate synthase ThiH', NULL, NULL, NULL, NULL, NULL, 4),
(194898, NULL, 'G3DSA:3.30.160.60:FF:000858', NULL, NULL, 'Zinc finger protein RFP', NULL, NULL, NULL, NULL, NULL, 4),
(194899, NULL, 'G3DSA:1.20.1280.290:FF:000010', NULL, NULL, 'Sugar transporter SWEET', NULL, NULL, NULL, NULL, NULL, 4),
(194900, NULL, 'G3DSA:3.40.50.620:FF:000202', NULL, NULL, 'Pantetheine-phosphate adenylyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(194901, NULL, 'G3DSA:1.25.40.20:FF:001226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194902, NULL, 'G3DSA:1.20.120.720:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194903, NULL, 'G3DSA:1.20.58.60:FF:000295', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(194904, NULL, 'G3DSA:3.30.70.330:FF:002482', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194905, NULL, 'G3DSA:4.10.480.10:FF:000003', NULL, NULL, 'Ni/Fe hydrogenase, small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(194906, NULL, 'G3DSA:3.90.550.10:FF:000276', NULL, NULL, 'UTP--glucose-1-phosphate uridylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(194907, NULL, 'G3DSA:2.60.120.10:FF:000361', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194908, NULL, 'G3DSA:1.25.10.10:FF:000699', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(194909, NULL, 'G3DSA:3.30.310.40:FF:000005', NULL, NULL, 'N-glycosylase/DNA lyase OGG1', NULL, NULL, NULL, NULL, NULL, 4),
(194910, NULL, 'G3DSA:1.10.565.10:FF:000111', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(194911, NULL, 'G3DSA:2.40.30.10:FF:000533', NULL, NULL, 'tRNA (5-methylaminomethyl-2-thiouridylate)-methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194912, NULL, 'G3DSA:2.30.39.10:FF:000126', NULL, NULL, 'Serpin-4 precursor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194913, NULL, 'G3DSA:3.40.50.1820:FF:000634', NULL, NULL, 'Bactin polyketide/non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(194914, NULL, 'G3DSA:1.20.1230.10:FF:000004', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(194915, NULL, 'G3DSA:1.10.472.80:FF:000270', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194916, NULL, 'G3DSA:4.10.400.10:FF:000223', NULL, NULL, 'Low-density lipoprotein receptor-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(194917, NULL, 'G3DSA:1.10.560.10:FF:000004', NULL, NULL, 'T-complex protein 1 subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(194918, NULL, 'G3DSA:1.20.1250.20:FF:001195', NULL, NULL, 'Alpha-ketoglutarate permease (KgtP)', NULL, NULL, NULL, NULL, NULL, 4),
(194919, NULL, 'G3DSA:3.60.20.10:FF:000119', NULL, NULL, '20S proteasome alpha subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(194920, NULL, 'G3DSA:3.40.50.1010:FF:000037', NULL, NULL, 'Rad2-like endonuclease, putative (AFU_orthologue AFUA_3G13260)', NULL, NULL, NULL, NULL, NULL, 4),
(194921, NULL, 'G3DSA:3.80.10.10:FF:000011', NULL, NULL, 'Lysine-specific demethylase 2B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(194922, NULL, 'G3DSA:3.30.70.330:FF:000487', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(194923, NULL, 'G3DSA:3.40.50.2000:FF:000790', NULL, NULL, 'Granule-bound starch synthase 1 chloroplastic/amyloplastic', NULL, NULL, NULL, NULL, NULL, 4),
(194924, NULL, 'G3DSA:3.90.245.10:FF:000033', NULL, NULL, 'Uncharacterized protein C800.11', NULL, NULL, NULL, NULL, NULL, 4),
(194925, NULL, 'G3DSA:3.40.50.300:FF:005901', NULL, NULL, 'GTP-binding protein TrmE N-terminus-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(194926, NULL, 'G3DSA:3.80.30.30:FF:000001', NULL, NULL, 'Spore photoproduct lyase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(194927, NULL, 'G3DSA:2.40.128.620:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194928, NULL, 'G3DSA:3.40.50.2000:FF:000694', NULL, NULL, 'Lipopolysaccharide heptosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(194929, NULL, 'G3DSA:1.10.101.10:FF:000012', NULL, NULL, 'Lytic murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(194930, NULL, 'G3DSA:2.130.10.10:FF:003467', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(194931, NULL, 'G3DSA:2.60.40.10:FF:002758', NULL, NULL, 'KDELC2 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(194932, NULL, 'G3DSA:3.30.200.40:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194933, NULL, 'G3DSA:3.10.105.10:FF:000041', NULL, NULL, 'Oligopeptide ABC transporter,oligopeptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(194934, NULL, 'G3DSA:3.10.110.10:FF:000334', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194935, NULL, 'G3DSA:2.60.120.260:FF:000095', NULL, NULL, 'Teneurin transmembrane protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(194936, NULL, 'G3DSA:3.10.100.10:FF:000406', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194937, NULL, 'G3DSA:3.40.50.2300:FF:001503', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194938, NULL, 'G3DSA:1.25.40.10:FF:002668', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(194939, NULL, 'G3DSA:1.25.10.10:FF:003442', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194940, NULL, 'G3DSA:1.10.10.160:FF:000060', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(194941, NULL, 'G3DSA:1.10.1240.30:FF:000002', NULL, NULL, 'Phosphoserine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(194942, NULL, 'G3DSA:3.80.10.10:FF:003658', NULL, NULL, 'Leucine rich repeat containing 29, isoform CRA_c', NULL, NULL, NULL, NULL, NULL, 4),
(194943, NULL, 'G3DSA:1.20.120.330:FF:000036', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(194944, NULL, 'G3DSA:3.40.190.80:FF:000055', NULL, NULL, 'Putative myo-inositol-1(Or 4)-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(194945, NULL, 'G3DSA:1.25.40.20:FF:000737', NULL, NULL, 'Ankyrin repeat domain 42', NULL, NULL, NULL, NULL, NULL, 4),
(194946, NULL, 'G3DSA:3.80.10.10:FF:000224', NULL, NULL, 'Leucine-rich repeat extensin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(194947, NULL, 'G3DSA:3.40.309.10:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194948, NULL, 'G3DSA:2.60.120.200:FF:000116', NULL, NULL, 'Laminin subunit alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(194949, NULL, 'G3DSA:3.30.70.270:FF:000328', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194950, NULL, 'G3DSA:2.40.50.140:FF:000933', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194951, NULL, 'G3DSA:3.80.10.10:FF:004406', NULL, NULL, 'At5g27920', NULL, NULL, NULL, NULL, NULL, 4),
(194952, NULL, 'G3DSA:2.130.10.10:FF:002978', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194953, NULL, 'G3DSA:3.30.160.60:FF:005529', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194954, NULL, 'G3DSA:2.120.10.30:FF:000360', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194955, NULL, 'G3DSA:2.60.40.10:FF:000858', NULL, NULL, 'Immunoglobin superfamily member 21', NULL, NULL, NULL, NULL, NULL, 4),
(194956, NULL, 'G3DSA:3.30.460.10:FF:000007', NULL, NULL, '2''-5''-oligoadenylate synthetase 1', NULL, NULL, NULL, NULL, NULL, 4),
(194957, NULL, 'G3DSA:3.40.1450.10:FF:000003', NULL, NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase putative', NULL, NULL, NULL, NULL, NULL, 4),
(194958, NULL, 'G3DSA:3.30.1360.120:FF:000021', NULL, NULL, 'Slr0635 protein', NULL, NULL, NULL, NULL, NULL, 4),
(194959, NULL, 'G3DSA:1.10.10.60:FF:000943', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194960, NULL, 'G3DSA:1.10.287.1010:FF:000001', NULL, NULL, 'Hypoxia-inducible factor 1-alpha inhibitor', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(194961, NULL, 'G3DSA:1.20.58.60:FF:000856', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194962, NULL, 'G3DSA:3.40.50.720:FF:002374', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194963, NULL, 'G3DSA:1.25.40.70:FF:000050', NULL, NULL, 'Phosphatidylinositol 3-kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(194964, NULL, 'G3DSA:3.40.50.2030:FF:000006', NULL, NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(194965, NULL, 'G3DSA:1.20.1270.50:FF:000002', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(194966, NULL, 'G3DSA:1.20.1070.10:FF:001189', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(194967, NULL, 'G3DSA:1.20.1310.10:FF:000056', NULL, NULL, 'GL25796', NULL, NULL, NULL, NULL, NULL, 4),
(194968, NULL, 'G3DSA:3.40.50.1440:FF:000048', NULL, NULL, 'Cell division protein FtsZ 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(194969, NULL, 'G3DSA:3.40.50.10330:FF:000117', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(194970, NULL, 'G3DSA:1.20.1250.20:FF:000559', NULL, NULL, 'Hexose transport-related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194971, NULL, 'G3DSA:3.40.50.300:FF:001747', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(194972, NULL, 'G3DSA:1.20.120.1780:FF:000011', NULL, NULL, '4-hydroxybenzoate polyprenyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(194973, NULL, 'G3DSA:3.60.10.10:FF:000293', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(194974, NULL, 'G3DSA:3.40.50.300:FF:005007', NULL, NULL, 'Polynucleotide 5''-hydroxyl-kinase grc3', NULL, NULL, NULL, NULL, NULL, 4),
(194975, NULL, 'G3DSA:3.30.70.330:FF:000144', NULL, NULL, 'Polyadenylate-binding protein RBP47B', NULL, NULL, NULL, NULL, NULL, 4),
(194976, NULL, 'G3DSA:3.30.470.20:FF:000151', NULL, NULL, 'Synapsin-2', NULL, NULL, NULL, NULL, NULL, 4),
(194977, NULL, 'G3DSA:1.10.10.10:FF:000968', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(194978, NULL, 'G3DSA:2.10.60.10:FF:000036', NULL, NULL, 'Serine/threonine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(194979, NULL, 'G3DSA:1.10.1040.50:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194980, NULL, 'G3DSA:1.10.340.30:FF:000022', NULL, NULL, 'DNA-3-methyladenine glycosylase, probable', NULL, NULL, NULL, NULL, NULL, 4),
(194981, NULL, 'G3DSA:2.60.40.10:FF:004563', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194982, NULL, 'G3DSA:3.90.660.10:FF:000037', NULL, NULL, 'Zgc:66484', NULL, NULL, NULL, NULL, NULL, 4),
(194983, NULL, 'G3DSA:3.30.1330.80:FF:000001', NULL, NULL, 'AT-hook motif nuclear-localized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194984, NULL, 'G3DSA:3.40.250.10:FF:000129', NULL, NULL, 'Thiosulfate sulfurtransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(194985, NULL, 'G3DSA:3.30.160.60:FF:001926', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194986, NULL, 'G3DSA:3.60.10.10:FF:000405', NULL, NULL, 'Inositol polyphosphate phosphatase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(194987, NULL, 'G3DSA:3.30.70.330:FF:002274', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194988, NULL, 'G3DSA:3.30.160.60:FF:005631', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(194989, NULL, 'G3DSA:2.120.10.30:FF:000028', NULL, NULL, 'Pro-epidermal growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(194990, NULL, 'G3DSA:2.30.130.40:FF:000006', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(194991, NULL, 'G3DSA:1.25.10.10:FF:000120', NULL, NULL, 'Sister chromatid cohesion protein PDS5 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(194992, NULL, 'G3DSA:1.20.1050.10:FF:000119', NULL, NULL, 'Glutathione S-transferase U10', NULL, NULL, NULL, NULL, NULL, 4),
(194993, NULL, 'G3DSA:3.60.21.10:FF:000099', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(194994, NULL, 'G3DSA:1.10.238.10:FF:001312', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194995, NULL, 'G3DSA:2.30.170.20:FF:000008', NULL, NULL, 'probable ribosome biogenesis protein RLP24', NULL, NULL, NULL, NULL, NULL, 4),
(194996, NULL, 'G3DSA:3.10.450.190:FF:000001', NULL, NULL, 'Baseplate hub subunit and tail lysozyme', NULL, NULL, NULL, NULL, NULL, 4),
(194997, NULL, 'G3DSA:2.60.200.20:FF:000191', NULL, NULL, 'SMAD/FHA domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(194998, NULL, 'G3DSA:3.30.870.10:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(194999, NULL, 'G3DSA:1.20.120.1760:FF:000005', NULL, NULL, 'Cardiolipin synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(195000, NULL, 'G3DSA:3.90.15.10:FF:000010', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(195001, NULL, 'G3DSA:3.30.1240.20:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195002, NULL, 'G3DSA:3.30.505.10:FF:000140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195003, NULL, 'G3DSA:1.20.58.340:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195004, NULL, 'G3DSA:1.25.40.20:FF:000046', NULL, NULL, 'Ankyrin repeat and KH domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(195005, NULL, 'G3DSA:3.20.20.100:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195006, NULL, 'G3DSA:2.130.10.10:FF:005625', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195007, NULL, 'G3DSA:3.90.550.10:FF:000484', NULL, NULL, 'Putative alpha-1,3-mannosyltransferase MNN12', NULL, NULL, NULL, NULL, NULL, 4),
(195008, NULL, 'G3DSA:1.25.40.20:FF:001682', NULL, NULL, 'Transient receptor potential cation channel subfamily V member 4', NULL, NULL, NULL, NULL, NULL, 4),
(195009, NULL, 'G3DSA:1.10.420.10:FF:000062', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(195010, NULL, 'G3DSA:3.40.50.1240:FF:000089', NULL, NULL, 'Phosphoglycerate mutase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(195011, NULL, 'G3DSA:2.60.40.10:FF:004462', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195012, NULL, 'G3DSA:3.40.50.300:FF:007576', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195013, NULL, 'G3DSA:1.10.3720.10:FF:000056', NULL, NULL, 'Phosphate transport system permease protein PstA', NULL, NULL, NULL, NULL, NULL, 4),
(195014, NULL, 'G3DSA:3.30.1370.10:FF:000128', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein K, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(195015, NULL, 'G3DSA:3.40.50.2000:FF:000582', NULL, NULL, 'ADP-heptose--lipooligosaccharide heptosyltransferase II', NULL, NULL, NULL, NULL, NULL, 4),
(195016, NULL, 'G3DSA:2.70.220.10:FF:000012', NULL, NULL, 'MD-2-related lipid-recognition protein ROSY1', NULL, NULL, NULL, NULL, NULL, 4),
(195017, NULL, 'G3DSA:2.60.40.10:FF:003034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195018, NULL, 'G3DSA:3.40.50.720:FF:000906', NULL, NULL, 'Alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(195019, NULL, 'G3DSA:3.30.300.10:FF:000052', NULL, NULL, 'S-adenosylmethionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(195020, NULL, 'G3DSA:3.40.50.10420:FF:000032', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(195021, NULL, 'G3DSA:3.40.710.10:FF:000165', NULL, NULL, 'Peptidoglycan transglycosylase and transpeptidase MrcA', NULL, NULL, NULL, NULL, NULL, 4),
(195022, NULL, 'G3DSA:2.60.40.10:FF:001814', NULL, NULL, 'Basement membrane proteoglycan', NULL, NULL, NULL, NULL, NULL, 4),
(195023, NULL, 'G3DSA:3.40.50.300:FF:001848', NULL, NULL, 'ABC transporter C family member 4', NULL, NULL, NULL, NULL, NULL, 4),
(195024, NULL, 'G3DSA:1.10.472.80:FF:000056', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(195025, NULL, 'G3DSA:1.10.8.60:FF:000302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(195026, NULL, 'G3DSA:3.30.230.10:FF:000299', NULL, NULL, 'DNA mismatch repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(195027, NULL, 'G3DSA:3.10.430.100:FF:000015', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(195028, NULL, 'G3DSA:1.10.287.660:FF:000007', NULL, NULL, 'WGS project CABT00000000 data, contig 2.58', NULL, NULL, NULL, NULL, NULL, 4),
(195029, NULL, 'G3DSA:3.40.50.150:FF:000937', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195030, NULL, 'G3DSA:3.40.1800.20:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195031, NULL, 'G3DSA:3.40.50.1820:FF:000746', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195032, NULL, 'G3DSA:3.40.50.1980:FF:000069', NULL, NULL, 'Probable FEIII-dicitrate-binding periplasmic lipoprotein FecB', NULL, NULL, NULL, NULL, NULL, 4),
(195033, NULL, 'G3DSA:1.20.1440.170:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195034, NULL, 'G3DSA:3.30.60.30:FF:000022', NULL, NULL, 'Transmembrane agrin', NULL, NULL, NULL, NULL, NULL, 4),
(195035, NULL, 'G3DSA:3.30.70.3250:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195036, NULL, 'G3DSA:2.60.40.10:FF:000864', NULL, NULL, 'Titin b', NULL, NULL, NULL, NULL, NULL, 4),
(195037, NULL, 'G3DSA:3.30.70.260:FF:000100', NULL, NULL, 'Prephenate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(195038, NULL, 'G3DSA:3.30.450.40:FF:000049', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(195039, NULL, 'G3DSA:2.40.10.10:FF:000419', NULL, NULL, 'prostasin-like', NULL, NULL, NULL, NULL, NULL, 4),
(195040, NULL, 'G3DSA:3.40.309.10:FF:000002', NULL, NULL, 'Methylmalonate-semialdehyde dehydrogenase (Acylating)', NULL, NULL, NULL, NULL, NULL, 4),
(195041, NULL, 'G3DSA:2.60.34.10:FF:000024', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(195042, NULL, 'G3DSA:2.30.30.90:FF:000012', NULL, NULL, 'Metal-dependent transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(195043, NULL, 'G3DSA:3.10.150.10:FF:000016', NULL, NULL, 'DNA polymerase III subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(195044, NULL, 'G3DSA:3.40.50.10140:FF:000049', NULL, NULL, 'Interleukin-1 receptor type I', NULL, NULL, NULL, NULL, NULL, 4),
(195045, NULL, 'G3DSA:3.30.1360.180:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195046, NULL, 'G3DSA:3.30.70.600:FF:000017', NULL, NULL, '40S ribosomal protein S10, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(195047, NULL, 'G3DSA:3.40.50.11030:FF:000007', NULL, NULL, 'Threonylcarbamoyl-AMP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(195048, NULL, 'G3DSA:3.30.1640.30:FF:000004', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(195049, NULL, 'G3DSA:2.60.40.790:FF:000166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195050, NULL, 'G3DSA:3.80.10.10:FF:001860', NULL, NULL, 'Ribonuclease inhibitor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(195051, NULL, 'G3DSA:3.30.50.10:FF:000190', NULL, NULL, 'GATA transcription factor 16', NULL, NULL, NULL, NULL, NULL, 4),
(195052, NULL, 'G3DSA:3.30.342.10:FF:000008', NULL, NULL, 'DNA polymerase zeta catalytic subunit isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(195053, NULL, 'G3DSA:3.40.140.70:FF:000015', NULL, NULL, 'Autophagy-related 7, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(195054, NULL, 'G3DSA:3.20.20.70:FF:000330', NULL, NULL, 'Fructose-bisphosphate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(195055, NULL, 'G3DSA:1.25.40.10:FF:004904', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(195056, NULL, 'G3DSA:3.40.1350.100:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195057, NULL, 'G3DSA:3.40.50.300:FF:000224', NULL, NULL, 'Energy-coupling factor transporter ATP-binding protein EcfA', NULL, NULL, NULL, NULL, NULL, 4),
(195058, NULL, 'G3DSA:2.60.120.290:FF:000087', NULL, NULL, 'LEV-10A protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(195059, NULL, 'G3DSA:3.40.190.290:FF:000138', NULL, NULL, 'Possible transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(195060, NULL, 'G3DSA:1.10.30.10:FF:000059', NULL, NULL, 'Protein pop-1', NULL, NULL, NULL, NULL, NULL, 4),
(195061, NULL, 'G3DSA:3.40.190.10:FF:000079', NULL, NULL, 'Glycine betaine ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(195062, NULL, 'G3DSA:1.10.510.10:FF:000187', NULL, NULL, 'integrin-linked protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(195063, NULL, 'G3DSA:3.40.720.10:FF:000093', NULL, NULL, 'arylsulfatase B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(195064, NULL, 'G3DSA:2.60.40.60:FF:000042', NULL, NULL, 'protocadherin-19 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(195065, NULL, 'G3DSA:3.40.50.720:FF:000114', NULL, NULL, 'UDP-glucose 6-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(195066, NULL, 'G3DSA:3.40.50.300:FF:004833', NULL, NULL, 'Probable mitochondrial Rho GTPase gemA', NULL, NULL, NULL, NULL, NULL, 4),
(195067, NULL, 'G3DSA:3.30.1440.10:FF:000011', NULL, NULL, 'Ribosomal protein L5', NULL, NULL, NULL, NULL, NULL, 4),
(195068, NULL, 'G3DSA:3.40.50.720:FF:002031', NULL, NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(195069, NULL, 'G3DSA:2.120.10.10:FF:000022', NULL, NULL, 'Sialidase', NULL, NULL, NULL, NULL, NULL, 4),
(195070, NULL, 'G3DSA:3.20.20.80:FF:000119', NULL, NULL, 'Alpha-amylase-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(195071, NULL, 'G3DSA:3.80.10.10:FF:002265', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(195072, NULL, 'G3DSA:3.40.50.300:FF:002467', NULL, NULL, 'AGAP010790-PA', NULL, NULL, NULL, NULL, NULL, 4),
(195073, NULL, 'G3DSA:3.30.160.60:FF:003152', NULL, NULL, 'Zinc finger protein 384', NULL, NULL, NULL, NULL, NULL, 4),
(195074, NULL, 'G3DSA:3.40.50.1820:FF:001011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195075, NULL, 'G3DSA:3.30.160.60:FF:004911', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195076, NULL, 'G3DSA:3.40.50.300:FF:006862', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195077, NULL, 'G3DSA:3.30.40.10:FF:000262', NULL, NULL, 'E3 ubiquitin-protein ligase MARCH5', NULL, NULL, NULL, NULL, NULL, 4),
(195078, NULL, 'G3DSA:1.25.40.10:FF:004219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195079, NULL, 'G3DSA:3.80.30.20:FF:000015', NULL, NULL, 'Ribosomal protein S12 methylthiotransferase RimO', NULL, NULL, NULL, NULL, NULL, 4),
(195080, NULL, 'G3DSA:3.90.1150.10:FF:000441', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195081, NULL, 'G3DSA:3.40.50.1000:FF:000040', NULL, NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(195082, NULL, 'G3DSA:3.30.450.20:FF:000408', NULL, NULL, 'Two component system histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(195083, NULL, 'G3DSA:3.30.40.10:FF:001886', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195084, NULL, 'G3DSA:1.20.1740.10:FF:000094', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(195085, NULL, 'G3DSA:3.80.10.10:FF:002141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195086, NULL, 'G3DSA:2.30.42.10:FF:000393', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195087, NULL, 'G3DSA:1.20.120.230:FF:000023', NULL, NULL, 'Rhea, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(195088, NULL, 'G3DSA:3.60.20.10:FF:000220', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195089, NULL, 'G3DSA:1.20.58.60:FF:000194', NULL, NULL, 'Uncharacterized protein, isoform I', NULL, NULL, NULL, NULL, NULL, 4),
(195090, NULL, 'G3DSA:1.10.472.10:FF:000631', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195091, NULL, 'G3DSA:3.40.50.2300:FF:000891', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195092, NULL, 'G3DSA:1.10.10.60:FF:001118', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(195093, NULL, 'G3DSA:1.10.238.10:FF:000587', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195094, NULL, 'G3DSA:2.30.29.30:FF:000194', NULL, NULL, 'Putative src kinase-associated phosphoprotein 2', NULL, NULL, NULL, NULL, NULL, 4),
(195095, NULL, 'G3DSA:2.60.40.60:FF:001138', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(195096, NULL, 'G3DSA:4.10.240.10:FF:000025', NULL, NULL, 'C6 transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(195097, NULL, 'G3DSA:3.40.50.1010:FF:000138', NULL, NULL, 'Flap endonuclease 1-1', NULL, NULL, NULL, NULL, NULL, 4),
(195098, NULL, 'G3DSA:1.25.40.10:FF:005170', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(195099, NULL, 'G3DSA:3.90.70.10:FF:000368', NULL, NULL, 'Cytoskeleton-associated protein CAP5.5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(195100, NULL, 'G3DSA:3.40.430.10:FF:000014', NULL, NULL, 'Dihydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(195101, NULL, 'G3DSA:3.30.160.60:FF:004799', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195102, NULL, 'G3DSA:3.30.160.60:FF:004675', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195103, NULL, 'G3DSA:2.130.10.10:FF:001129', NULL, NULL, 'Transducin beta-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(195104, NULL, 'G3DSA:3.40.1030.10:FF:000011', NULL, NULL, 'Anthranilate phosphoribosyltransferase like', NULL, NULL, NULL, NULL, NULL, 4),
(195105, NULL, 'G3DSA:1.10.1740.10:FF:000040', NULL, NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(195106, NULL, 'G3DSA:1.10.8.60:FF:000510', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195107, NULL, 'G3DSA:2.170.270.10:FF:000199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195108, NULL, 'G3DSA:1.10.510.10:FF:001125', NULL, NULL, 'Serine/threonine-protein kinase RIO1', NULL, NULL, NULL, NULL, NULL, 4),
(195109, NULL, 'G3DSA:1.10.630.10:FF:000128', NULL, NULL, 'Putative cytochrome P450 139', NULL, NULL, NULL, NULL, NULL, 4),
(195110, NULL, 'G3DSA:3.30.70.330:FF:002605', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195111, NULL, 'G3DSA:1.20.1250.20:FF:000672', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(195112, NULL, 'G3DSA:1.50.40.10:FF:000333', NULL, NULL, 'Mitochondrial glycine transporter', NULL, NULL, NULL, NULL, NULL, 4),
(195113, NULL, 'G3DSA:3.40.20.10:FF:000058', NULL, NULL, 'Quail, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(195114, NULL, 'G3DSA:3.40.50.170:FF:000039', NULL, NULL, 'Phosphoribosylglycinamide formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(195115, NULL, 'G3DSA:3.40.50.410:FF:000027', NULL, NULL, 'collagen alpha-2(VI) chain isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(195116, NULL, 'G3DSA:3.30.160.20:FF:000184', NULL, NULL, '39S ribosomal protein L44, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(195117, NULL, 'G3DSA:2.60.40.1730:FF:000002', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(195118, NULL, 'G3DSA:2.60.40.10:FF:005288', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195119, NULL, 'G3DSA:3.40.50.2300:FF:000559', NULL, NULL, 'Metabotropic glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(195120, NULL, 'G3DSA:3.60.15.10:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195121, NULL, 'G3DSA:1.10.1240.10:FF:000007', NULL, NULL, 'Methyltransferase cognate corrinoid protein', NULL, NULL, NULL, NULL, NULL, 4),
(195122, NULL, 'G3DSA:1.20.1250.10:FF:000118', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195123, NULL, 'G3DSA:3.40.50.2300:FF:000435', NULL, NULL, 'Protein CBG01593', NULL, NULL, NULL, NULL, NULL, 4),
(195124, NULL, 'G3DSA:3.80.10.10:FF:003338', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(195125, NULL, 'G3DSA:3.30.200.20:FF:000688', NULL, NULL, 'L-type lectin-domain containing receptor kinase IV.1', NULL, NULL, NULL, NULL, NULL, 4),
(195126, NULL, 'G3DSA:2.60.120.970:FF:000105', NULL, NULL, 'Left-right determination factor', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(195127, NULL, 'G3DSA:3.90.1180.10:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195128, NULL, 'G3DSA:3.30.40.10:FF:001431', NULL, NULL, 'G protein-coupled receptor', NULL, NULL, NULL, NULL, NULL, 4),
(195129, NULL, 'G3DSA:1.25.40.10:FF:003382', NULL, NULL, 'Pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(195130, NULL, 'G3DSA:1.25.10.10:FF:002469', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195131, NULL, 'G3DSA:3.40.50.300:FF:005238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195132, NULL, 'G3DSA:3.30.300.30:FF:000058', NULL, NULL, 'Nonribosomal peptide synthase GliP', NULL, NULL, NULL, NULL, NULL, 4),
(195133, NULL, 'G3DSA:3.60.40.10:FF:000233', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(195134, NULL, 'G3DSA:3.40.50.150:FF:000033', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', NULL, NULL, NULL, NULL, NULL, 4),
(195135, NULL, 'G3DSA:1.10.510.10:FF:002098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195136, NULL, 'G3DSA:2.60.120.200:FF:000813', NULL, NULL, 'Cnx', NULL, NULL, NULL, NULL, NULL, 4),
(195137, NULL, 'G3DSA:3.50.50.60:FF:000462', NULL, NULL, 'FAD/NAD(P)-binding oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(195138, NULL, 'G3DSA:2.60.40.10:FF:001578', NULL, NULL, 'immunoglobulin superfamily member 22', NULL, NULL, NULL, NULL, NULL, 4),
(195139, NULL, 'G3DSA:2.10.220.10:FF:000211', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(195140, NULL, 'G3DSA:3.40.50.150:FF:001781', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195141, NULL, 'G3DSA:1.20.1640.10:FF:000030', NULL, NULL, 'Patched homolog (Drosophila), isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(195142, NULL, 'G3DSA:3.40.140.10:FF:000256', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(195143, NULL, 'G3DSA:2.60.120.940:FF:000001', NULL, NULL, 'Membrane indolylacetylinositol arabinosyltransferase embC', NULL, NULL, NULL, NULL, NULL, 4),
(195144, NULL, 'G3DSA:3.60.21.10:FF:000211', NULL, NULL, 'Sphingomyelin phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(195145, NULL, 'G3DSA:3.40.50.720:FF:002143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195146, NULL, 'G3DSA:1.25.10.10:FF:001525', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(195147, NULL, 'G3DSA:1.20.58.70:FF:000073', NULL, NULL, 'Syntaxin-5', NULL, NULL, NULL, NULL, NULL, 4),
(195148, NULL, 'G3DSA:3.80.10.10:FF:003889', NULL, NULL, 'AGAP011649-PA', NULL, NULL, NULL, NULL, NULL, 4),
(195149, NULL, 'G3DSA:3.30.1460.20:FF:000015', NULL, NULL, 'Arp2/3 complex 34 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(195150, NULL, 'G3DSA:3.30.70.330:FF:001768', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195151, NULL, 'G3DSA:3.10.450.40:FF:000025', NULL, NULL, 'Primary amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(195152, NULL, 'G3DSA:3.90.190.10:FF:000512', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195153, NULL, 'G3DSA:1.10.287.110:FF:000079', NULL, NULL, 'DnaJ subfamily C member', NULL, NULL, NULL, NULL, NULL, 4),
(195154, NULL, 'G3DSA:1.10.10.2330:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195155, NULL, 'G3DSA:1.20.1250.20:FF:001745', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(195156, NULL, 'G3DSA:2.130.10.10:FF:004895', NULL, NULL, 'Protein HIRA', NULL, NULL, NULL, NULL, NULL, 4),
(195157, NULL, 'G3DSA:2.170.130.10:FF:000037', NULL, NULL, 'SusC/RagA family TonB-linked outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(195158, NULL, 'G3DSA:3.10.330.10:FF:000002', NULL, NULL, 'ubiquitin fusion degradation protein 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(195159, NULL, 'G3DSA:3.40.50.300:FF:008548', NULL, NULL, 'Mitochondrial GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(195160, NULL, 'G3DSA:3.30.70.330:FF:002510', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(195161, NULL, 'G3DSA:2.40.270.10:FF:000011', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(195162, NULL, 'G3DSA:3.40.50.1460:FF:000043', NULL, NULL, 'caspase-3-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(195163, NULL, 'G3DSA:3.30.230.10:FF:000411', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(195164, NULL, 'G3DSA:3.40.50.1820:FF:000393', NULL, NULL, 'N-formylmaleamate deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(195165, NULL, 'G3DSA:2.60.120.260:FF:000336', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(195166, NULL, 'G3DSA:2.60.120.680:FF:000013', NULL, NULL, 'Transmembrane emp24 domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(195167, NULL, 'G3DSA:2.10.25.10:FF:000011', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor', NULL, NULL, NULL, NULL, NULL, 4),
(195168, NULL, 'G3DSA:2.130.10.10:FF:003922', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195169, NULL, 'G3DSA:2.130.10.10:FF:001461', NULL, NULL, 'PRP4 pre-mRNA-processing factor 4 homolog (yeast)', NULL, NULL, NULL, NULL, NULL, 4),
(195170, NULL, 'G3DSA:3.40.50.1000:FF:000259', NULL, NULL, 'Magnesium dependent phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(195171, NULL, 'G3DSA:2.60.40.420:FF:000089', NULL, NULL, 'Cupredoxin superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(195172, NULL, 'G3DSA:3.80.10.10:FF:003203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195173, NULL, 'G3DSA:1.10.287.70:FF:000555', NULL, NULL, 'Acid-sensitive two pore domain K+ channel dTASK-7, putative', NULL, NULL, NULL, NULL, NULL, 4),
(195174, NULL, 'G3DSA:6.10.250.3320:FF:000002', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 1', NULL, NULL, NULL, NULL, NULL, 4),
(195175, NULL, 'G3DSA:3.40.50.11050:FF:000002', NULL, NULL, 'RTX toxin RtxA', NULL, NULL, NULL, NULL, NULL, 4),
(195176, NULL, 'G3DSA:3.30.2130.30:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195177, NULL, 'G3DSA:3.40.50.1820:FF:000185', NULL, NULL, 'Alpha/beta-Hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(195178, NULL, 'G3DSA:3.30.160.60:FF:003360', NULL, NULL, 'zinc finger and BTB domain-containing protein 42', NULL, NULL, NULL, NULL, NULL, 4),
(195179, NULL, 'G3DSA:1.50.10.20:FF:000042', NULL, NULL, 'Protein farnesyltransferase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(195180, NULL, 'G3DSA:1.10.2020.20:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195181, NULL, 'G3DSA:3.40.50.300:FF:007812', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(195182, NULL, 'G3DSA:2.40.110.10:FF:000073', NULL, NULL, 'Putative acyl-CoA oxidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(195183, NULL, 'G3DSA:1.20.1510.10:FF:000037', NULL, NULL, 'Cation Diffusion Facilitator (CDF) Family', NULL, NULL, NULL, NULL, NULL, 4),
(195184, NULL, 'G3DSA:2.170.270.10:FF:000098', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-9 specific SUVH4', NULL, NULL, NULL, NULL, NULL, 4),
(195185, NULL, 'G3DSA:1.10.3370.10:FF:000028', NULL, NULL, 'SecY subunit domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(195186, NULL, 'G3DSA:1.10.3430.10:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195187, NULL, 'G3DSA:1.25.40.20:FF:001018', NULL, NULL, 'Multiple ankyrin repeats single KH domain, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(195188, NULL, 'G3DSA:2.40.50.140:FF:001208', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195189, NULL, 'G3DSA:3.40.1120.10:FF:000001', NULL, NULL, 'Ribosomal protein L15', NULL, NULL, NULL, NULL, NULL, 4),
(195190, NULL, 'G3DSA:1.20.58.2220:FF:000012', NULL, NULL, 'Formin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(195191, NULL, 'G3DSA:1.20.5.1160:FF:000008', NULL, NULL, 'Lamin B2', NULL, NULL, NULL, NULL, NULL, 4),
(195192, NULL, 'G3DSA:3.40.50.2300:FF:000790', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(195193, NULL, 'G3DSA:2.130.10.10:FF:005171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195194, NULL, 'G3DSA:1.20.1070.10:FF:002150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195195, NULL, 'G3DSA:1.25.40.10:FF:004551', NULL, NULL, 'Os07g0476200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(195196, NULL, 'G3DSA:2.160.20.10:FF:000184', NULL, NULL, 'Protein CBG11506', NULL, NULL, NULL, NULL, NULL, 4),
(195197, NULL, 'G3DSA:3.90.70.10:FF:000267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195198, NULL, 'G3DSA:3.20.20.140:FF:000192', NULL, NULL, 'Histidinol-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(195199, NULL, 'G3DSA:3.40.50.300:FF:005558', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195200, NULL, 'G3DSA:1.10.418.40:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195201, NULL, 'G3DSA:1.25.40.20:FF:001794', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195202, NULL, 'G3DSA:1.25.40.10:FF:000397', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g40720', NULL, NULL, NULL, NULL, NULL, 4),
(195203, NULL, 'G3DSA:1.10.150.650:FF:000005', NULL, NULL, 'Phosphoesterase', NULL, NULL, NULL, NULL, NULL, 4),
(195204, NULL, 'G3DSA:1.20.1250.20:FF:000464', NULL, NULL, 'Monocarboxylate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(195205, NULL, 'G3DSA:1.10.10.750:FF:000023', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(195206, NULL, 'G3DSA:3.20.20.70:FF:000094', NULL, NULL, 'Imidazole glycerol phosphate synthase hisHF', NULL, NULL, NULL, NULL, NULL, 4),
(195207, NULL, 'G3DSA:2.10.25.10:FF:000707', NULL, NULL, 'Notch receptor 1b', NULL, NULL, NULL, NULL, NULL, 4),
(195208, NULL, 'G3DSA:4.10.1060.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195209, NULL, 'G3DSA:1.10.600.10:FF:000059', NULL, NULL, 'Phytoene-beta carotene synthase', NULL, NULL, NULL, NULL, NULL, 4),
(195210, NULL, 'G3DSA:1.10.510.10:FF:000748', NULL, NULL, 'NAK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(195211, NULL, 'G3DSA:1.10.390.10:FF:000064', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(195212, NULL, 'G3DSA:2.30.170.40:FF:000003', NULL, NULL, '54S ribosomal protein L24', NULL, NULL, NULL, NULL, NULL, 4),
(195213, NULL, 'G3DSA:1.50.10.10:FF:000152', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(195214, NULL, 'G3DSA:2.70.160.11:FF:000087', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(195215, NULL, 'G3DSA:3.40.50.300:FF:004378', NULL, NULL, 'Adenylyl-sulfate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(195216, NULL, 'G3DSA:3.40.50.10490:FF:000120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195217, NULL, 'G3DSA:3.40.50.1000:FF:000591', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195218, NULL, 'G3DSA:2.130.10.10:FF:003259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195219, NULL, 'G3DSA:3.60.10.10:FF:000282', NULL, NULL, 'Inositol 5-phosphatase 4', NULL, NULL, NULL, NULL, NULL, 4),
(195220, NULL, 'G3DSA:3.90.190.10:FF:000276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195221, NULL, 'G3DSA:3.30.70.100:FF:000081', NULL, NULL, 'Copper resistance-associated P-type ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(195222, NULL, 'G3DSA:1.10.533.10:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195223, NULL, 'G3DSA:2.60.120.200:FF:000004', NULL, NULL, 'neurexin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(195224, NULL, 'G3DSA:3.80.10.10:FF:003546', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195225, NULL, 'G3DSA:3.40.50.2000:FF:000800', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(195226, NULL, 'G3DSA:1.25.40.660:FF:000003', NULL, NULL, 'Vacuolar protein sorting-associated protein 35', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(195227, NULL, 'G3DSA:3.30.830.10:FF:000148', NULL, NULL, 'Mitochondrial presequence protease', NULL, NULL, NULL, NULL, NULL, 4),
(195228, NULL, 'G3DSA:1.25.40.120:FF:000083', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(195229, NULL, 'G3DSA:1.10.238.10:FF:001104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195230, NULL, 'G3DSA:1.10.472.10:FF:000530', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195231, NULL, 'G3DSA:3.80.10.10:FF:000112', NULL, NULL, 'F-box and leucine-rich repeat protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(195232, NULL, 'G3DSA:2.130.10.10:FF:005272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195233, NULL, 'G3DSA:2.60.120.260:FF:000544', NULL, NULL, 'Netrin-2', NULL, NULL, NULL, NULL, NULL, 4),
(195234, NULL, 'G3DSA:2.130.10.10:FF:000269', NULL, NULL, 'DDB1- and CUL4-associated factor 13', NULL, NULL, NULL, NULL, NULL, 4),
(195235, NULL, 'G3DSA:2.130.10.10:FF:004552', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195236, NULL, 'G3DSA:3.30.160.60:FF:005417', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195237, NULL, 'G3DSA:1.20.1070.10:FF:001301', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(195238, NULL, 'G3DSA:3.30.710.10:FF:000229', NULL, NULL, 'Os07g0409500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(195239, NULL, 'G3DSA:1.20.120.1750:FF:000126', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(195240, NULL, 'G3DSA:3.40.50.300:FF:006519', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195241, NULL, 'G3DSA:4.10.400.20:FF:000001', NULL, NULL, 'tumor necrosis factor receptor superfamily member 12A', NULL, NULL, NULL, NULL, NULL, 4),
(195242, NULL, 'G3DSA:1.10.238.260:FF:000007', NULL, NULL, 'Homocitrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(195243, NULL, 'G3DSA:2.120.10.80:FF:000099', NULL, NULL, 'Kelch like family member 14', NULL, NULL, NULL, NULL, NULL, 4),
(195244, NULL, 'G3DSA:3.30.160.60:FF:005737', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195245, NULL, 'G3DSA:1.10.10.10:FF:000159', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 12', NULL, NULL, NULL, NULL, NULL, 4),
(195246, NULL, 'G3DSA:1.20.1250.20:FF:001644', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195247, NULL, 'G3DSA:1.10.238.10:FF:000828', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195248, NULL, 'G3DSA:4.10.60.10:FF:000251', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(195249, NULL, 'G3DSA:3.80.20.20:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195250, NULL, 'G3DSA:1.20.200.10:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195251, NULL, 'G3DSA:1.20.120.1070:FF:000006', NULL, NULL, 'Translation initiation factor eIF-2B subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(195252, NULL, 'G3DSA:3.40.50.10330:FF:000005', NULL, NULL, 'Sphingosine kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(195253, NULL, 'G3DSA:2.120.10.30:FF:000579', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(195254, NULL, 'G3DSA:2.40.160.10:FF:000008', NULL, NULL, 'OprD family porin', NULL, NULL, NULL, NULL, NULL, 4),
(195255, NULL, 'G3DSA:3.40.50.1700:FF:000031', NULL, NULL, 'Beta-glucosidase C', NULL, NULL, NULL, NULL, NULL, 4),
(195256, NULL, 'G3DSA:2.10.70.10:FF:000110', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(195257, NULL, 'G3DSA:1.25.40.10:FF:002297', NULL, NULL, 'Pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(195258, NULL, 'G3DSA:3.90.228.10:FF:000061', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(195259, NULL, 'G3DSA:1.20.1250.20:FF:002364', NULL, NULL, 'LL-diaminopimelate aminotransferase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(195260, NULL, 'G3DSA:3.90.380.10:FF:000004', NULL, NULL, '3-ketosteroid-9-alpha-hydroxylase oxygenase subunit', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(195261, NULL, 'G3DSA:3.40.30.10:FF:001076', NULL, NULL, 'Thiol-disulfide oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(195262, NULL, 'G3DSA:2.60.40.10:FF:005400', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195263, NULL, 'G3DSA:3.40.50.10050:FF:000011', NULL, NULL, 'Translation initiation factor IF-2', NULL, NULL, NULL, NULL, NULL, 4),
(195264, NULL, 'G3DSA:4.10.1240.30:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195265, NULL, 'G3DSA:1.10.8.10:FF:000068', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(195266, NULL, 'G3DSA:2.40.30.10:FF:000297', NULL, NULL, 'GM15722', NULL, NULL, NULL, NULL, NULL, 4),
(195267, NULL, 'G3DSA:2.40.10.10:FF:000178', NULL, NULL, 'Trypsin-like serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(195268, NULL, 'G3DSA:3.40.50.150:FF:001438', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195269, NULL, 'G3DSA:3.40.50.620:FF:000314', NULL, NULL, 'ECT1p Ethanolamine-phosphate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(195270, NULL, 'G3DSA:3.30.200.20:FF:001205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195271, NULL, 'G3DSA:3.30.160.60:FF:000746', NULL, NULL, 'hypermethylated in cancer 2 protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(195272, NULL, 'G3DSA:3.30.230.70:FF:000047', NULL, NULL, 'Exosome complex exonuclease RRP41A', NULL, NULL, NULL, NULL, NULL, 4),
(195273, NULL, 'G3DSA:3.40.50.620:FF:000096', NULL, NULL, 'Arginine--tRNA ligase chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(195274, NULL, 'G3DSA:3.30.70.330:FF:002853', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195275, NULL, 'G3DSA:1.20.1050.60:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195276, NULL, 'G3DSA:3.30.70.100:FF:000204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195277, NULL, 'G3DSA:3.40.1110.10:FF:000175', NULL, NULL, 'Copper-exporting P-type ATPase A', NULL, NULL, NULL, NULL, NULL, 4),
(195278, NULL, 'G3DSA:1.20.1540.10:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195279, NULL, 'G3DSA:2.30.42.10:FF:000499', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195280, NULL, 'G3DSA:1.20.20.10:FF:000013', NULL, NULL, 'ATP synthase subunit C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(195281, NULL, 'G3DSA:3.40.50.150:FF:000696', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(195282, NULL, 'G3DSA:3.50.50.60:FF:000703', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(195283, NULL, 'G3DSA:1.10.510.10:FF:004239', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195284, NULL, 'G3DSA:3.90.132.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195285, NULL, 'G3DSA:1.20.1250.20:FF:000008', NULL, NULL, 'Galactose-proton symporter (Galactose transporter)', NULL, NULL, NULL, NULL, NULL, 4),
(195286, NULL, 'G3DSA:3.80.10.10:FF:004395', NULL, NULL, 'Peroxidasin', NULL, NULL, NULL, NULL, NULL, 4),
(195287, NULL, 'G3DSA:2.130.10.10:FF:002298', NULL, NULL, 'DCAF8 isoform 14', NULL, NULL, NULL, NULL, NULL, 4),
(195288, NULL, 'G3DSA:3.30.160.60:FF:002646', NULL, NULL, 'Protein suppressor of hairy wing-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(195289, NULL, 'G3DSA:1.25.40.20:FF:001474', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195290, NULL, 'G3DSA:3.30.200.20:FF:000929', NULL, NULL, 'Protein CBG16624', NULL, NULL, NULL, NULL, NULL, 4),
(195291, NULL, 'G3DSA:3.90.180.10:FF:000005', NULL, NULL, 'Quinone oxidoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(195292, NULL, 'G3DSA:3.40.50.300:FF:003097', NULL, NULL, 'Protein CBG04185', NULL, NULL, NULL, NULL, NULL, 4),
(195293, NULL, 'G3DSA:1.25.10.10:FF:001300', NULL, NULL, 'Calcium binding protein 39 (Predicted), isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(195294, NULL, 'G3DSA:1.20.5.1040:FF:000001', NULL, NULL, 'Sensor histidine kinase QseC', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(195295, NULL, 'G3DSA:3.30.780.10:FF:000054', NULL, NULL, 'Translation initiation factor Sui1', NULL, NULL, NULL, NULL, NULL, 4),
(195296, NULL, 'G3DSA:3.40.50.300:FF:005890', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(195297, NULL, 'G3DSA:3.30.70.20:FF:000082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195298, NULL, 'G3DSA:1.10.10.60:FF:001219', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195299, NULL, 'G3DSA:2.30.29.30:FF:000513', NULL, NULL, 'BRag/Iqsec/Schizo related Arf GEF family member', NULL, NULL, NULL, NULL, NULL, 4),
(195300, NULL, 'G3DSA:1.25.40.10:FF:002876', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195301, NULL, 'G3DSA:1.20.5.110:FF:000342', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195302, NULL, 'G3DSA:3.40.50.300:FF:004939', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195303, NULL, 'G3DSA:3.40.50.1000:FF:000489', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195304, NULL, 'G3DSA:3.90.210.10:FF:000003', NULL, NULL, 'ADP-ribosylating toxin CARDS', NULL, NULL, NULL, NULL, NULL, 4),
(195305, NULL, 'G3DSA:2.60.40.60:FF:000519', NULL, NULL, 'Cadherin-87A', NULL, NULL, NULL, NULL, NULL, 4),
(195306, NULL, 'G3DSA:3.60.40.10:FF:000339', NULL, NULL, 'Protein phosphatase 2C 29', NULL, NULL, NULL, NULL, NULL, 4),
(195307, NULL, 'G3DSA:1.10.10.1670:FF:000001', NULL, NULL, 'Heterocyst differentiation control protein', NULL, NULL, NULL, NULL, NULL, 4),
(195308, NULL, 'G3DSA:1.10.150.20:FF:000291', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(195309, NULL, 'G3DSA:3.40.50.720:FF:001637', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195310, NULL, 'G3DSA:3.30.160.60:FF:001022', NULL, NULL, 'zinc finger and BTB domain-containing protein 17 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(195311, NULL, 'G3DSA:1.25.10.10:FF:002705', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195312, NULL, 'G3DSA:1.20.1070.10:FF:000121', NULL, NULL, 'Histamine H2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(195313, NULL, 'G3DSA:2.60.40.10:FF:005182', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195314, NULL, 'G3DSA:1.20.1270.10:FF:000018', NULL, NULL, 'heat shock 70 kDa protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(195315, NULL, 'G3DSA:2.130.10.10:FF:005833', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195316, NULL, 'G3DSA:2.60.40.10:FF:003843', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195317, NULL, 'G3DSA:3.90.79.20:FF:000014', NULL, NULL, 'Nudix (nucleoside diphosphate linked moiety X)-type motif 12', NULL, NULL, NULL, NULL, NULL, 4),
(195318, NULL, 'G3DSA:1.10.10.10:FF:000389', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit K', NULL, NULL, NULL, NULL, NULL, 4),
(195319, NULL, 'G3DSA:3.20.20.80:FF:000771', NULL, NULL, 'Chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(195320, NULL, 'G3DSA:1.20.85.10:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195321, NULL, 'G3DSA:3.40.50.10810:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195322, NULL, 'G3DSA:1.10.510.10:FF:002761', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195323, NULL, 'G3DSA:3.30.450.20:FF:000043', NULL, NULL, 'DNA-binding transcriptional regulator TyrR', NULL, NULL, NULL, NULL, NULL, 4),
(195324, NULL, 'G3DSA:3.40.850.10:FF:000315', NULL, NULL, 'Kinesin-like protein KIN-12F', NULL, NULL, NULL, NULL, NULL, 4),
(195325, NULL, 'G3DSA:1.25.40.10:FF:000852', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(195326, NULL, 'G3DSA:2.60.40.10:FF:003282', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195327, NULL, 'G3DSA:3.60.15.10:FF:000253', NULL, NULL, 'RNA-metabolising metallo-beta-lactamase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(195328, NULL, 'G3DSA:1.10.510.10:FF:001468', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(195329, NULL, 'G3DSA:3.30.470.10:FF:000053', NULL, NULL, 'Branched-chain-amino-acid aminotransferase 3 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(195330, NULL, 'G3DSA:4.10.60.10:FF:000149', NULL, NULL, 'DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(195331, NULL, 'G3DSA:3.30.1490.20:FF:000051', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(195332, NULL, 'G3DSA:4.10.280.10:FF:000022', NULL, NULL, 'Basic helix-loop-helix transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(195333, NULL, 'G3DSA:1.10.287.70:FF:000212', NULL, NULL, 'No mechanoreceptor potential C, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(195334, NULL, 'G3DSA:1.10.3200.20:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195335, NULL, 'G3DSA:1.10.3260.10:FF:000037', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(195336, NULL, 'G3DSA:3.40.190.10:FF:000315', NULL, NULL, 'Transcriptional regulator LysR', NULL, NULL, NULL, NULL, NULL, 4),
(195337, NULL, 'G3DSA:3.10.129.10:FF:000152', NULL, NULL, 'Protein CBG07159', NULL, NULL, NULL, NULL, NULL, 4),
(195338, NULL, 'G3DSA:2.60.40.1730:FF:000108', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195339, NULL, 'G3DSA:1.10.1520.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195340, NULL, 'G3DSA:3.40.50.620:FF:000657', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(195341, NULL, 'G3DSA:3.40.630.30:FF:000569', NULL, NULL, 'GCN5-related N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(195342, NULL, 'G3DSA:1.20.1250.20:FF:001301', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(195343, NULL, 'G3DSA:1.10.510.10:FF:003278', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195344, NULL, 'G3DSA:1.10.10.10:FF:000491', NULL, NULL, 'PaaX domain-containing protein, C-domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(195345, NULL, 'G3DSA:3.30.160.60:FF:001685', NULL, NULL, 'Zinc finger and BTB domain-containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(195346, NULL, 'G3DSA:3.30.450.20:FF:000167', NULL, NULL, 'Sensory box/GGDEF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(195347, NULL, 'G3DSA:1.25.40.10:FF:000976', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g15720', NULL, NULL, NULL, NULL, NULL, 4),
(195348, NULL, 'G3DSA:3.50.50.60:FF:000142', NULL, NULL, 'FAD dependent oxidoreductase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(195349, NULL, 'G3DSA:2.60.40.10:FF:005743', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195350, NULL, 'G3DSA:2.30.30.100:FF:000071', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm1', NULL, NULL, NULL, NULL, NULL, 4),
(195351, NULL, 'G3DSA:2.30.29.30:FF:001132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195352, NULL, 'G3DSA:3.80.10.10:FF:002720', NULL, NULL, 'Receptor-like protein kinase 7', NULL, NULL, NULL, NULL, NULL, 4),
(195353, NULL, 'G3DSA:2.10.50.10:FF:000108', NULL, NULL, 'Si:ch211-261n11.8', NULL, NULL, NULL, NULL, NULL, 4),
(195354, NULL, 'G3DSA:2.30.29.30:FF:000295', NULL, NULL, 'pleckstrin homology domain-containing family H member 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(195355, NULL, 'G3DSA:3.10.20.90:FF:000538', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195356, NULL, 'G3DSA:2.130.10.10:FF:000488', NULL, NULL, 'Leucine-rich repeat and WD repeat-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(195357, NULL, 'G3DSA:3.30.160.60:FF:006356', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195358, NULL, 'G3DSA:3.30.230.10:FF:000400', NULL, NULL, 'Elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(195359, NULL, 'G3DSA:3.60.20.40:FF:000004', NULL, NULL, 'Glutathione hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(195360, NULL, 'G3DSA:1.10.510.10:FF:003722', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195361, NULL, 'G3DSA:2.60.40.2420:FF:000001', NULL, NULL, 'Curli assembly protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(195362, NULL, 'G3DSA:2.130.10.10:FF:001781', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(195363, NULL, 'G3DSA:1.10.630.10:FF:000780', NULL, NULL, 'Protein CBG01387', NULL, NULL, NULL, NULL, NULL, 4),
(195364, NULL, 'G3DSA:3.40.718.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195365, NULL, 'G3DSA:2.10.25.10:FF:000146', NULL, NULL, 'Putative neurogenic locus notch', NULL, NULL, NULL, NULL, NULL, 4),
(195366, NULL, 'G3DSA:3.10.129.10:FF:000276', NULL, NULL, 'Acyl-CoA thioesterase 11a', NULL, NULL, NULL, NULL, NULL, 4),
(195367, NULL, 'G3DSA:1.10.10.60:FF:000477', NULL, NULL, 'Pdc2p', NULL, NULL, NULL, NULL, NULL, 4),
(195368, NULL, 'G3DSA:2.40.70.10:FF:000075', NULL, NULL, 'Putative xylanase inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(195369, NULL, 'G3DSA:1.20.120.350:FF:000042', NULL, NULL, 'Potassium voltage-gated channel subfamily V member 2', NULL, NULL, NULL, NULL, NULL, 4),
(195370, NULL, 'G3DSA:1.10.238.10:FF:000609', NULL, NULL, 'EF-hand domain pair/EF-hand domain/EF hand, putative', NULL, NULL, NULL, NULL, NULL, 4),
(195371, NULL, 'G3DSA:2.60.40.60:FF:000851', NULL, NULL, 'Cadherin-related 23', NULL, NULL, NULL, NULL, NULL, 4),
(195372, NULL, 'G3DSA:3.30.565.10:FF:000469', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195373, NULL, 'G3DSA:2.120.10.80:FF:000234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195374, NULL, 'G3DSA:2.40.50.140:FF:000242', NULL, NULL, 'Mitochondrial ribosomal protein S17,putative', NULL, NULL, NULL, NULL, NULL, 4),
(195375, NULL, 'G3DSA:3.30.160.60:FF:002202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195376, NULL, 'G3DSA:3.40.50.300:FF:001511', NULL, NULL, 'Gliding motility protein MglA', NULL, NULL, NULL, NULL, NULL, 4),
(195377, NULL, 'G3DSA:1.10.10.10:FF:000732', NULL, NULL, 'Forkhead protein', NULL, NULL, NULL, NULL, NULL, 4),
(195378, NULL, 'G3DSA:3.80.20.20:FF:000059', NULL, NULL, 'Related to sporulation-specific gene SPS2', NULL, NULL, NULL, NULL, NULL, 4),
(195379, NULL, 'G3DSA:2.60.120.330:FF:000037', NULL, NULL, 'Blast:1-aminocyclopropane-1-carboxylate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(195380, NULL, 'G3DSA:1.10.1300.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195381, NULL, 'G3DSA:1.25.40.10:FF:003045', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(195382, NULL, 'G3DSA:3.30.160.60:FF:001578', NULL, NULL, 'Zinc finger protein 319', NULL, NULL, NULL, NULL, NULL, 4),
(195383, NULL, 'G3DSA:3.30.9.10:FF:000072', NULL, NULL, 'Monomeric sarcosine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(195384, NULL, 'G3DSA:1.10.8.10:FF:000203', NULL, NULL, 'GD21223', NULL, NULL, NULL, NULL, NULL, 4),
(195385, NULL, 'G3DSA:1.10.1220.10:FF:000017', NULL, NULL, 'Programmed cell death antitoxin', NULL, NULL, NULL, NULL, NULL, 4),
(195386, NULL, 'G3DSA:3.40.50.1820:FF:000409', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(195387, NULL, 'G3DSA:3.40.50.300:FF:007924', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195388, NULL, 'G3DSA:3.80.10.10:FF:000567', NULL, NULL, 'nischarin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(195389, NULL, 'G3DSA:3.20.20.80:FF:000557', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195390, NULL, 'G3DSA:3.40.50.10490:FF:000143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195391, NULL, 'G3DSA:1.25.40.10:FF:002533', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g16010', NULL, NULL, NULL, NULL, NULL, 4),
(195392, NULL, 'G3DSA:3.40.50.720:FF:002587', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195393, NULL, 'G3DSA:3.10.490.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195394, NULL, 'G3DSA:2.130.10.10:FF:003254', NULL, NULL, 'Transducin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(195395, NULL, 'G3DSA:3.30.559.30:FF:000085', NULL, NULL, 'NRPS-like enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(195396, NULL, 'G3DSA:3.40.850.10:FF:000102', NULL, NULL, 'CCAAT-box DNA binding protein subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(195397, NULL, 'G3DSA:3.40.640.10:FF:000277', NULL, NULL, 'UPF0425 pyridoxal phosphate-dependent protein MJ0158', NULL, NULL, NULL, NULL, NULL, 4),
(195398, NULL, 'G3DSA:4.10.1240.10:FF:000033', NULL, NULL, 'LOC100145780 protein', NULL, NULL, NULL, NULL, NULL, 4),
(195399, NULL, 'G3DSA:2.20.100.10:FF:000104', NULL, NULL, 'Papilin', NULL, NULL, NULL, NULL, NULL, 4),
(195400, NULL, 'G3DSA:3.30.110.110:FF:000009', NULL, NULL, 'Related to MRE11-DNA repair and meiotic recombination protein', NULL, NULL, NULL, NULL, NULL, 4),
(195401, NULL, 'G3DSA:1.20.58.60:FF:000750', NULL, NULL, 'Microtubule-actin crosslinking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(195402, NULL, 'G3DSA:1.10.150.900:FF:000007', NULL, NULL, 'AEL132Wp', NULL, NULL, NULL, NULL, NULL, 4),
(195403, NULL, 'G3DSA:2.60.40.1480:FF:000005', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(195404, NULL, 'G3DSA:2.70.130.10:FF:000022', NULL, NULL, 'Insulin-like growth factor 2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(195405, NULL, 'G3DSA:3.30.110.30:FF:000015', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(195406, NULL, 'G3DSA:3.30.980.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195407, NULL, 'G3DSA:3.40.190.10:FF:000759', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(195408, NULL, 'G3DSA:1.20.80.60:FF:000003', NULL, NULL, 'Sorting nexin-27', NULL, NULL, NULL, NULL, NULL, 4),
(195409, NULL, 'G3DSA:2.130.10.10:FF:004771', NULL, NULL, 'WD repeat domain-containing protein 83 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(195410, NULL, 'G3DSA:3.80.10.10:FF:002821', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', NULL, NULL, NULL, NULL, NULL, 4),
(195411, NULL, 'G3DSA:3.40.1190.20:FF:000071', NULL, NULL, 'Ribokinase', NULL, NULL, NULL, NULL, NULL, 4),
(195412, NULL, 'G3DSA:3.40.50.300:FF:003653', NULL, NULL, 'BnaA08g24620D protein', NULL, NULL, NULL, NULL, NULL, 4),
(195413, NULL, 'G3DSA:2.40.50.1070:FF:000011', NULL, NULL, '23S rRNA (uracil(1939)-C(5))-methyltransferase RlmD', NULL, NULL, NULL, NULL, NULL, 4),
(195414, NULL, 'G3DSA:1.10.167.10:FF:000068', NULL, NULL, 'Regulator of G-protein signaling rgs-10', NULL, NULL, NULL, NULL, NULL, 4),
(195415, NULL, 'G3DSA:1.10.730.10:FF:000170', NULL, NULL, 'Methionine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(195416, NULL, 'G3DSA:2.60.60.20:FF:000060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195417, NULL, 'G3DSA:3.40.50.170:FF:000016', NULL, NULL, 'Formyltetrahydrofolate deformylase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(195418, NULL, 'G3DSA:3.30.70.330:FF:002628', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195419, NULL, 'G3DSA:1.25.40.180:FF:000174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195420, NULL, 'G3DSA:3.40.50.10190:FF:000148', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(195421, NULL, 'G3DSA:3.30.565.10:FF:000020', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(195422, NULL, 'G3DSA:3.80.10.10:FF:002714', NULL, NULL, 'Receptor-like protein kinase HSL1', NULL, NULL, NULL, NULL, NULL, 4),
(195423, NULL, 'G3DSA:1.10.8.1120:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195424, NULL, 'G3DSA:1.20.5.570:FF:000002', NULL, NULL, '3-octaprenyl-4-hydroxybenzoate carboxy-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(195425, NULL, 'G3DSA:3.40.50.150:FF:001207', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195426, NULL, 'G3DSA:2.40.70.10:FF:000524', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195427, NULL, 'G3DSA:3.60.15.10:FF:000034', NULL, NULL, 'N-acyl homoserine lactonase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(195428, NULL, 'G3DSA:3.30.479.30:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195429, NULL, 'G3DSA:3.40.640.10:FF:000384', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(195430, NULL, 'G3DSA:1.20.1250.20:FF:000003', NULL, NULL, 'Solute carrier family 17 member 3', NULL, NULL, NULL, NULL, NULL, 4),
(195431, NULL, 'G3DSA:3.40.50.300:FF:008543', NULL, NULL, 'MutS domain III family protein', NULL, NULL, NULL, NULL, NULL, 4),
(195432, NULL, 'G3DSA:3.30.160.60:FF:002197', NULL, NULL, 'Metal regulatory transcription factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(195433, NULL, 'G3DSA:3.40.720.10:FF:000334', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195434, NULL, 'G3DSA:3.40.50.1820:FF:000398', NULL, NULL, 'DUF341 family oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(195435, NULL, 'G3DSA:1.20.5.190:FF:000091', NULL, NULL, 'FI18026p1', NULL, NULL, NULL, NULL, NULL, 4),
(195436, NULL, 'G3DSA:2.10.110.10:FF:000321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195437, NULL, 'G3DSA:2.30.180.10:FF:000169', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195438, NULL, 'G3DSA:1.20.1730.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195439, NULL, 'G3DSA:3.40.50.12780:FF:000060', NULL, NULL, 'Acyl-CoA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(195440, NULL, 'G3DSA:3.30.200.20:FF:001076', NULL, NULL, 'Putative tyrosine-protein kinase F09A5.2', NULL, NULL, NULL, NULL, NULL, 4),
(195441, NULL, 'G3DSA:1.25.40.10:FF:001914', NULL, NULL, 'General transcription factor 3C polypeptide 3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(195442, NULL, 'G3DSA:3.10.450.40:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195443, NULL, 'G3DSA:2.120.10.80:FF:000341', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195444, NULL, 'G3DSA:1.10.490.10:FF:000015', NULL, NULL, 'GLoBin related', NULL, NULL, NULL, NULL, NULL, 4),
(195445, NULL, 'G3DSA:3.20.180.10:FF:000004', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(195446, NULL, 'G3DSA:3.40.50.2000:FF:000014', NULL, NULL, 'Glycogen [starch] synthase', NULL, NULL, NULL, NULL, NULL, 4),
(195447, NULL, 'G3DSA:2.40.50.140:FF:000135', NULL, NULL, 'Exosome complex component CSL4', NULL, NULL, NULL, NULL, NULL, 4),
(195448, NULL, 'G3DSA:1.10.10.60:FF:000258', NULL, NULL, 'HTH-type transcriptional regulator ChbR', NULL, NULL, NULL, NULL, NULL, 4),
(195449, NULL, 'G3DSA:3.30.200.20:FF:001868', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195450, NULL, 'G3DSA:2.40.50.140:FF:000927', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195451, NULL, 'G3DSA:2.30.40.10:FF:000096', NULL, NULL, 'N-ethylammeline chlorohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(195452, NULL, 'G3DSA:3.90.550.10:FF:000141', NULL, NULL, 'Molybdenum cofactor cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(195453, NULL, 'G3DSA:3.30.450.20:FF:000279', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(195454, NULL, 'G3DSA:2.130.10.10:FF:002635', NULL, NULL, 'Beta-transducin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(195455, NULL, 'G3DSA:3.40.50.850:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195456, NULL, 'G3DSA:1.20.1250.20:FF:001189', NULL, NULL, 'Major facilitator transporter', NULL, NULL, NULL, NULL, NULL, 4),
(195457, NULL, 'G3DSA:3.30.1150.10:FF:000011', NULL, NULL, 'Energy transducer TonB', NULL, NULL, NULL, NULL, NULL, 4),
(195458, NULL, 'G3DSA:3.30.70.330:FF:000812', NULL, NULL, 'Splicing factor U2AF 50 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(195459, NULL, 'G3DSA:2.10.50.10:FF:000092', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(195460, NULL, 'G3DSA:3.40.50.720:FF:000356', NULL, NULL, 'Lambda-crystallin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(195461, NULL, 'G3DSA:1.25.40.10:FF:003949', NULL, NULL, 'Protein RMD9, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(195462, NULL, 'G3DSA:1.20.1560.10:FF:000451', NULL, NULL, 'p-GlycoProtein related', NULL, NULL, NULL, NULL, NULL, 4),
(195463, NULL, 'G3DSA:1.50.40.10:FF:000103', NULL, NULL, 'Mitochondrial glycine transporter', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(195464, NULL, 'G3DSA:1.10.238.10:FF:001228', NULL, NULL, 'EF-hand calcium-binding domain-containing protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(195465, NULL, 'G3DSA:1.50.40.10:FF:000092', NULL, NULL, 'Mitochondrial tricarboxylate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(195466, NULL, 'G3DSA:2.60.120.260:FF:000224', NULL, NULL, 'Alpha-L-fucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(195467, NULL, 'G3DSA:1.10.220.150:FF:000041', NULL, NULL, 'ARF GAP-like zinc finger-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(195468, NULL, 'G3DSA:3.40.30.10:FF:000452', NULL, NULL, 'RE10237p', NULL, NULL, NULL, NULL, NULL, 4),
(195469, NULL, 'G3DSA:2.60.120.260:FF:000331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195470, NULL, 'G3DSA:2.30.29.30:FF:000755', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(195471, NULL, 'G3DSA:1.10.510.10:FF:001480', NULL, NULL, 'Serine/threonine-protein kinase AKL1', NULL, NULL, NULL, NULL, NULL, 4),
(195472, NULL, 'G3DSA:2.10.109.10:FF:000025', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(195473, NULL, 'G3DSA:3.40.50.11740:FF:000001', NULL, NULL, 'Hydrogenase maturation factor', NULL, NULL, NULL, NULL, NULL, 4),
(195474, NULL, 'G3DSA:1.10.238.10:FF:000031', NULL, NULL, 'Short stop, isoform J', NULL, NULL, NULL, NULL, NULL, 4),
(195475, NULL, 'G3DSA:1.25.10.10:FF:002020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195476, NULL, 'G3DSA:2.60.40.10:FF:004804', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195477, NULL, 'G3DSA:3.40.50.300:FF:001399', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(195478, NULL, 'G3DSA:3.40.50.300:FF:008329', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195479, NULL, 'G3DSA:3.50.50.60:FF:001423', NULL, NULL, 'Amino acid oxidase fmpA', NULL, NULL, NULL, NULL, NULL, 4),
(195480, NULL, 'G3DSA:3.30.56.10:FF:000034', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(195481, NULL, 'G3DSA:3.30.70.330:FF:001105', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(195482, NULL, 'G3DSA:2.30.31.10:FF:000013', NULL, NULL, 'GD23514', NULL, NULL, NULL, NULL, NULL, 4),
(195483, NULL, 'G3DSA:3.90.1580.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195484, NULL, 'G3DSA:3.40.718.10:FF:000065', NULL, NULL, 'Isocitrate dehydrogenase [NAD] subunit beta, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(195485, NULL, 'G3DSA:2.60.40.10:FF:004911', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195486, NULL, 'G3DSA:3.40.50.300:FF:008436', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195487, NULL, 'G3DSA:3.50.50.60:FF:001316', NULL, NULL, 'Pyridine nucleotide-disulfide oxidoreductase domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(195488, NULL, 'G3DSA:2.60.40.1180:FF:000022', NULL, NULL, 'Glucosidase II alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(195489, NULL, 'G3DSA:1.10.132.60:FF:000019', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(195490, NULL, 'G3DSA:3.40.50.1460:FF:000020', NULL, NULL, 'Clan CD, family C13, asparaginyl endopeptidase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(195491, NULL, 'G3DSA:3.30.420.40:FF:000210', NULL, NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(195492, NULL, 'G3DSA:1.10.510.10:FF:000849', NULL, NULL, 'receptor-like cytosolic serine/threonine-protein kinase RBK1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(195493, NULL, 'G3DSA:2.10.110.10:FF:000214', NULL, NULL, 'FHL1 isoform 15', NULL, NULL, NULL, NULL, NULL, 4),
(195494, NULL, 'G3DSA:3.30.420.40:FF:000558', NULL, NULL, 'Actin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(195495, NULL, 'G3DSA:3.10.200.10:FF:000004', NULL, NULL, 'receptor-type tyrosine-protein phosphatase zeta isoform X1', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(195496, NULL, 'G3DSA:3.90.70.10:FF:000716', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195497, NULL, 'G3DSA:3.40.190.10:FF:000074', NULL, NULL, 'Phosphate-binding protein PstS', NULL, NULL, NULL, NULL, NULL, 4),
(195498, NULL, 'G3DSA:1.10.510.10:FF:001249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195499, NULL, 'G3DSA:2.60.40.10:FF:002983', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(195500, NULL, 'G3DSA:3.90.245.10:FF:000027', NULL, NULL, 'Inosine/uridine-preferring nucleoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(195501, NULL, 'G3DSA:3.30.780.10:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195502, NULL, 'G3DSA:2.60.220.50:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195503, NULL, 'G3DSA:3.40.190.10:FF:000534', NULL, NULL, 'ABC-type phosphate transport system, periplasmic component', NULL, NULL, NULL, NULL, NULL, 4),
(195504, NULL, 'G3DSA:3.50.50.60:FF:000485', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] flavoprotein subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(195505, NULL, 'G3DSA:3.50.30.30:FF:000036', NULL, NULL, 'E3 ubiquitin-protein ligase RNF13', NULL, NULL, NULL, NULL, NULL, 4),
(195506, NULL, 'G3DSA:2.60.40.60:FF:000278', NULL, NULL, 'LOW QUALITY PROTEIN: protocadherin-23', NULL, NULL, NULL, NULL, NULL, 4),
(195507, NULL, 'G3DSA:1.20.1260.100:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195508, NULL, 'G3DSA:3.30.70.3270:FF:000004', NULL, NULL, 'NADH-quinone oxidoreductase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(195509, NULL, 'G3DSA:2.10.25.10:FF:001539', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195510, NULL, 'G3DSA:3.30.1370.210:FF:000005', NULL, NULL, 'Muscleblind, isoform M', NULL, NULL, NULL, NULL, NULL, 4),
(195511, NULL, 'G3DSA:3.90.25.10:FF:000067', NULL, NULL, 'dTDP-4-dehydrorhamnose reductase', NULL, NULL, NULL, NULL, NULL, 4),
(195512, NULL, 'G3DSA:3.30.1370.30:FF:000005', NULL, NULL, '30S ribosomal protein S8', NULL, NULL, NULL, NULL, NULL, 4),
(195513, NULL, 'G3DSA:3.30.160.60:FF:000162', NULL, NULL, 'E3 ubiquitin-protein ligase ZFP91 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(195514, NULL, 'G3DSA:1.20.1050.60:FF:000005', NULL, NULL, 'Alpha-1,2-mannosidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(195515, NULL, 'G3DSA:1.10.287.370:FF:000022', NULL, NULL, 'Prefoldin subunit 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(195516, NULL, 'G3DSA:3.40.50.300:FF:007020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195517, NULL, 'G3DSA:3.40.50.1480:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195518, NULL, 'G3DSA:2.60.40.10:FF:001241', NULL, NULL, 'Hibris, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(195519, NULL, 'G3DSA:1.10.10.1230:FF:000004', NULL, NULL, 'Cell division protein ftsI', NULL, NULL, NULL, NULL, NULL, 4),
(195520, NULL, 'G3DSA:2.30.42.10:FF:000617', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195521, NULL, 'G3DSA:3.40.50.150:FF:001444', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195522, NULL, 'G3DSA:2.60.260.20:FF:000071', NULL, NULL, 'DnaJ homolog, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(195523, NULL, 'G3DSA:2.30.29.30:FF:000536', NULL, NULL, 'Syntrophin alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(195524, NULL, 'G3DSA:3.40.50.300:FF:007132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195525, NULL, 'G3DSA:1.10.630.10:FF:000004', NULL, NULL, 'cytochrome P450 2D15 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(195526, NULL, 'G3DSA:1.10.510.10:FF:002873', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195527, NULL, 'G3DSA:3.20.20.80:FF:000664', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(195528, NULL, 'G3DSA:1.25.10.10:FF:003329', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195529, NULL, 'G3DSA:1.25.10.10:FF:003217', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(195530, NULL, 'G3DSA:3.30.70.370:FF:000009', NULL, NULL, 'Mitochondrial DNA polymerase I protein C', NULL, NULL, NULL, NULL, NULL, 4),
(195531, NULL, 'G3DSA:3.90.120.10:FF:000002', NULL, NULL, 'DNA (cytosine-5)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(195532, NULL, 'G3DSA:2.40.50.90:FF:000058', NULL, NULL, 'Tudor domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(195533, NULL, 'G3DSA:2.130.10.10:FF:001005', NULL, NULL, 'Related to UTP21-U3 snoRNP protein', NULL, NULL, NULL, NULL, NULL, 4),
(195534, NULL, 'G3DSA:1.25.10.10:FF:002817', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(195535, NULL, 'G3DSA:1.10.1040.10:FF:000026', NULL, NULL, 'UDP-glucose 6-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(195536, NULL, 'G3DSA:2.10.90.10:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195537, NULL, 'G3DSA:3.30.160.60:FF:004563', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195538, NULL, 'G3DSA:2.60.40.10:FF:002438', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(195539, NULL, 'G3DSA:3.30.160.60:FF:005052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195540, NULL, 'G3DSA:3.30.1520.10:FF:000175', NULL, NULL, 'Protein CBR-SNX-6', NULL, NULL, NULL, NULL, NULL, 4),
(195541, NULL, 'G3DSA:3.30.40.10:FF:002286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195542, NULL, 'G3DSA:3.30.40.10:FF:001667', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195543, NULL, 'G3DSA:1.10.510.10:FF:003385', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195544, NULL, 'G3DSA:2.60.120.330:FF:000144', NULL, NULL, '2-oxoglutarate (2OG) and Fe(II)-dependent oxygenase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(195545, NULL, 'G3DSA:1.20.970.10:FF:000005', NULL, NULL, 'Glycosyl transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(195546, NULL, 'G3DSA:3.30.160.60:FF:005075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195547, NULL, 'G3DSA:3.90.120.10:FF:000007', NULL, NULL, 'DNA (Cytosine-5)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(195548, NULL, 'G3DSA:2.60.40.60:FF:000738', NULL, NULL, 'Cadherin-4', NULL, NULL, NULL, NULL, NULL, 4),
(195549, NULL, 'G3DSA:1.20.1250.20:FF:000784', NULL, NULL, 'MFS drug efflux pump', NULL, NULL, NULL, NULL, NULL, 4),
(195550, NULL, 'G3DSA:2.60.40.10:FF:001926', NULL, NULL, 'KETtiN (Drosophila actin-binding) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(195551, NULL, 'G3DSA:2.60.260.20:FF:000183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195552, NULL, 'G3DSA:3.40.470.10:FF:000005', NULL, NULL, 'Single-strand selective monofunctional uracil DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(195553, NULL, 'G3DSA:3.40.630.30:FF:000221', NULL, NULL, 'Aminoglycoside resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(195554, NULL, 'G3DSA:2.130.10.10:FF:003147', NULL, NULL, 'Intraflagellar transport protein 80', NULL, NULL, NULL, NULL, NULL, 4),
(195555, NULL, 'G3DSA:3.30.230.10:FF:000063', NULL, NULL, 'DNA repair protein RadA', NULL, NULL, NULL, NULL, NULL, 4),
(195556, NULL, 'G3DSA:1.20.1560.10:FF:000214', NULL, NULL, 'Multidrug resistance protein homolog 49', NULL, NULL, NULL, NULL, NULL, 4),
(195557, NULL, 'G3DSA:1.20.58.530:FF:000001', NULL, NULL, 'Myosin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(195558, NULL, 'G3DSA:3.30.200.20:FF:000564', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(195559, NULL, 'G3DSA:2.40.30.10:FF:000292', NULL, NULL, 'Elongation factor TU mitochondrial1', NULL, NULL, NULL, NULL, NULL, 4),
(195560, NULL, 'G3DSA:3.40.50.300:FF:001404', NULL, NULL, 'Magnesium chelatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(195561, NULL, 'G3DSA:1.20.1070.10:FF:000469', NULL, NULL, 'SERotonin/octopamine receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(195562, NULL, 'G3DSA:3.30.70.330:FF:000700', NULL, NULL, 'Pre-mRNA splicing factor, putative', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(195563, NULL, 'G3DSA:2.60.40.10:FF:000752', NULL, NULL, 'Putative glycerophosphocholine phosphodiesterase GPCPD1', NULL, NULL, NULL, NULL, NULL, 4),
(195564, NULL, 'G3DSA:1.20.5.1180:FF:000003', NULL, NULL, 'Spindle pole body component SPC42', NULL, NULL, NULL, NULL, NULL, 4),
(195565, NULL, 'G3DSA:3.30.465.10:FF:000080', NULL, NULL, 'FAD-linked oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(195566, NULL, 'G3DSA:1.10.1400.10:FF:000003', NULL, NULL, 'Acyl-homoserine lactone acylase PvdQ', NULL, NULL, NULL, NULL, NULL, 4),
(195567, NULL, 'G3DSA:3.30.160.60:FF:006249', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195568, NULL, 'G3DSA:3.10.290.10:FF:000043', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(195569, NULL, 'G3DSA:1.20.5.340:FF:000057', NULL, NULL, 'Unplaced genomic scaffold supercont1.163, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(195570, NULL, 'G3DSA:1.10.510.10:FF:003615', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195571, NULL, 'G3DSA:3.40.50.1820:FF:001814', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195572, NULL, 'G3DSA:3.40.50.720:FF:000333', NULL, NULL, 'Shikimate 5-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(195573, NULL, 'G3DSA:1.25.10.10:FF:001401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195574, NULL, 'G3DSA:2.60.40.10:FF:005423', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195575, NULL, 'G3DSA:2.40.360.10:FF:000001', NULL, NULL, 'YjbF family lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(195576, NULL, 'G3DSA:3.40.50.150:FF:000932', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195577, NULL, 'G3DSA:2.40.40.10:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195578, NULL, 'G3DSA:2.40.160.60:FF:000006', NULL, NULL, 'Aromatic hydrocarbon degradation protein', NULL, NULL, NULL, NULL, NULL, 4),
(195579, NULL, 'G3DSA:1.10.238.10:FF:000716', NULL, NULL, 'Ca(2+)-binding ATP:ADP antiporter', NULL, NULL, NULL, NULL, NULL, 4),
(195580, NULL, 'G3DSA:3.30.1240.10:FF:000018', NULL, NULL, 'HMP-PP phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(195581, NULL, 'G3DSA:1.20.120.1080:FF:000021', NULL, NULL, 'ATP-dependent RNA helicase DEAH13', NULL, NULL, NULL, NULL, NULL, 4),
(195582, NULL, 'G3DSA:2.60.120.1560:FF:000001', NULL, NULL, 'Flocculation protein FLO5', NULL, NULL, NULL, NULL, NULL, 4),
(195583, NULL, 'G3DSA:1.20.1290.10:FF:000008', NULL, NULL, '4-carboxymuconolactone decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(195584, NULL, 'G3DSA:2.60.40.10:FF:004799', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195585, NULL, 'G3DSA:3.50.50.60:FF:000804', NULL, NULL, 'Squalene monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(195586, NULL, 'G3DSA:3.40.50.80:FF:000210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195587, NULL, 'G3DSA:3.40.367.20:FF:000049', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(195588, NULL, 'G3DSA:3.80.10.10:FF:001865', NULL, NULL, 'Os06g0587900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(195589, NULL, 'G3DSA:2.60.40.2130:FF:000015', NULL, NULL, 'F-spondin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(195590, NULL, 'G3DSA:3.50.50.60:FF:001204', NULL, NULL, 'FAD-dependent monooxygenase dbaB', NULL, NULL, NULL, NULL, NULL, 4),
(195591, NULL, 'G3DSA:3.20.20.140:FF:000214', NULL, NULL, 'AMP deaminase Amd1, putative (AFU_orthologue AFUA_8G02860)', NULL, NULL, NULL, NULL, NULL, 4),
(195592, NULL, 'G3DSA:3.30.70.2810:FF:000001', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase M', NULL, NULL, NULL, NULL, NULL, 4),
(195593, NULL, 'G3DSA:3.30.930.10:FF:000425', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(195594, NULL, 'G3DSA:2.30.29.30:FF:000750', NULL, NULL, 'Binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(195595, NULL, 'G3DSA:3.40.50.150:FF:000718', NULL, NULL, 'Cytosine-C5 specific DNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(195596, NULL, 'G3DSA:1.50.10.20:FF:000048', NULL, NULL, 'Transcobalamin 1', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(195597, NULL, 'G3DSA:3.40.1380.40:FF:000001', NULL, NULL, 'Undecaprenyl-diphosphooligosaccharide--protein glycotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(195598, NULL, 'G3DSA:2.60.40.10:FF:002545', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(195599, NULL, 'G3DSA:3.40.950.10:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195600, NULL, 'G3DSA:1.25.40.10:FF:003157', NULL, NULL, 'TPR repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(195601, NULL, 'G3DSA:2.30.30.40:FF:000587', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195602, NULL, 'G3DSA:3.40.630.30:FF:000676', NULL, NULL, 'Uncharacterized N-acetyltransferase C663.13c', NULL, NULL, NULL, NULL, NULL, 4),
(195603, NULL, 'G3DSA:1.10.437.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195604, NULL, 'G3DSA:2.40.290.10:FF:000006', NULL, NULL, 'ATP-dependent DNA helicase 2 subunit KU80', NULL, NULL, NULL, NULL, NULL, 4),
(195605, NULL, 'G3DSA:1.20.1090.10:FF:000009', NULL, NULL, 'NADH-dependent butanol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(195606, NULL, 'G3DSA:1.10.472.10:FF:000075', NULL, NULL, 'Retinoblastoma-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(195607, NULL, 'G3DSA:1.10.8.590:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195608, NULL, 'G3DSA:3.40.50.1000:FF:000832', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195609, NULL, 'G3DSA:3.20.20.30:FF:000003', NULL, NULL, 'Pyrimidine monooxygenase RutA', NULL, NULL, NULL, NULL, NULL, 4),
(195610, NULL, 'G3DSA:3.40.390.10:FF:000078', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(195611, NULL, 'G3DSA:3.40.50.150:FF:000376', NULL, NULL, 'Gamma-tocopherol methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(195612, NULL, 'G3DSA:3.40.50.80:FF:000215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195613, NULL, 'G3DSA:3.10.20.90:FF:000645', NULL, NULL, 'Serine/threonine-protein kinase WNK2', NULL, NULL, NULL, NULL, NULL, 4),
(195614, NULL, 'G3DSA:3.40.850.10:FF:000214', NULL, NULL, 'Myosin, heavy polypeptide 9a, non-muscle', NULL, NULL, NULL, NULL, NULL, 4),
(195615, NULL, 'G3DSA:3.30.565.10:FF:000368', NULL, NULL, 'Hybrid signal transduction histidine kinase I', NULL, NULL, NULL, NULL, NULL, 4),
(195616, NULL, 'G3DSA:3.30.190.20:FF:000017', NULL, NULL, 'UvrABC system protein A', NULL, NULL, NULL, NULL, NULL, 4),
(195617, NULL, 'G3DSA:1.25.40.10:FF:004450', NULL, NULL, 'Os05g0370000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(195618, NULL, 'G3DSA:2.60.120.200:FF:000341', NULL, NULL, 'InTestinal NeureXin-like', NULL, NULL, NULL, NULL, NULL, 4),
(195619, NULL, 'G3DSA:1.25.40.180:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195620, NULL, 'G3DSA:2.30.110.10:FF:000114', NULL, NULL, 'Uncharacterized protein C1071.11', NULL, NULL, NULL, NULL, NULL, 4),
(195621, NULL, 'G3DSA:3.10.20.90:FF:000297', NULL, NULL, '30S small subunit ribosomal protein S27Ae', NULL, NULL, NULL, NULL, NULL, 4),
(195622, NULL, 'G3DSA:2.20.70.10:FF:000132', NULL, NULL, 'U1 snRNP protein', NULL, NULL, NULL, NULL, NULL, 4),
(195623, NULL, 'G3DSA:1.25.40.10:FF:004787', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(195624, NULL, 'G3DSA:2.60.60.20:FF:000065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195625, NULL, 'G3DSA:3.30.160.60:FF:003944', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195626, NULL, 'G3DSA:1.25.40.570:FF:000077', NULL, NULL, 'COP9 signalosome complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(195627, NULL, 'G3DSA:2.130.10.10:FF:002854', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195628, NULL, 'G3DSA:3.40.50.2000:FF:000806', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195629, NULL, 'G3DSA:3.80.10.10:FF:002826', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', NULL, NULL, NULL, NULL, NULL, 4),
(195630, NULL, 'G3DSA:3.80.10.10:FF:003445', NULL, NULL, 'Leucine-rich repeat and transmembrane domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(195631, NULL, 'G3DSA:3.50.50.60:FF:000248', NULL, NULL, 'Dihydrolipoyl dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(195632, NULL, 'G3DSA:3.40.50.1820:FF:001466', NULL, NULL, 'Lecithin-cholesterol acyltransferase-like 4', NULL, NULL, NULL, NULL, NULL, 4),
(195633, NULL, 'G3DSA:1.25.40.180:FF:000286', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195634, NULL, 'G3DSA:2.40.50.140:FF:000354', NULL, NULL, 'ATP-dependent RNA helicase DHX8', NULL, NULL, NULL, NULL, NULL, 4),
(195635, NULL, 'G3DSA:3.90.550.10:FF:000489', NULL, NULL, 'G protein-coupled receptor', NULL, NULL, NULL, NULL, NULL, 4),
(195636, NULL, 'G3DSA:3.40.50.620:FF:000758', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195637, NULL, 'G3DSA:3.60.15.10:FF:000146', NULL, NULL, 'MBL fold metallo-hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(195638, NULL, 'G3DSA:3.40.50.10810:FF:000278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195639, NULL, 'G3DSA:2.30.42.10:FF:000370', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195640, NULL, 'G3DSA:3.40.50.150:FF:001337', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195641, NULL, 'G3DSA:3.30.1330.30:FF:000008', NULL, NULL, 'Protein pelota homolog', NULL, NULL, NULL, NULL, NULL, 4),
(195642, NULL, 'G3DSA:3.40.50.11720:FF:000006', NULL, NULL, 'DNA mismatch repair protein MLH1', NULL, NULL, NULL, NULL, NULL, 4),
(195643, NULL, 'G3DSA:3.80.10.10:FF:002484', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(195644, NULL, 'G3DSA:1.25.40.10:FF:002538', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(195645, NULL, 'G3DSA:3.30.450.60:FF:000044', NULL, NULL, 'Zeta-cop, subunit of COP-I complex', NULL, NULL, NULL, NULL, NULL, 4),
(195646, NULL, 'G3DSA:1.20.1070.10:FF:000357', NULL, NULL, 'Rhodopsin', NULL, NULL, NULL, NULL, NULL, 4),
(195647, NULL, 'G3DSA:3.40.605.10:FF:000027', NULL, NULL, 'Aldehyde dehydrogenase, dimeric NADP-preferring', NULL, NULL, NULL, NULL, NULL, 4),
(195648, NULL, 'G3DSA:3.90.226.10:FF:000118', NULL, NULL, 'Probable enoyl-CoA hydratase echA10', NULL, NULL, NULL, NULL, NULL, 4),
(195649, NULL, 'G3DSA:3.90.79.10:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195650, NULL, 'G3DSA:1.10.510.10:FF:003166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195651, NULL, 'G3DSA:3.30.230.120:FF:000005', NULL, NULL, 'D-glycero-D-manno-heptose 1-phosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(195652, NULL, 'G3DSA:3.30.200.20:FF:002262', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(195653, NULL, 'G3DSA:3.30.1330.60:FF:000006', NULL, NULL, 'Outer membrane protein OmpA', NULL, NULL, NULL, NULL, NULL, 4),
(195654, NULL, 'G3DSA:3.30.70.330:FF:000363', NULL, NULL, 'RNA-binding motif protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(195655, NULL, 'G3DSA:1.20.1280.280:FF:000001', NULL, NULL, 'Multifunctional virulence effector protein DrrA', NULL, NULL, NULL, NULL, NULL, 4),
(195656, NULL, 'G3DSA:3.10.129.10:FF:000040', NULL, NULL, 'Acyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(195657, NULL, 'G3DSA:3.40.1050.10:FF:000029', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(195658, NULL, 'G3DSA:3.40.50.620:FF:000073', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(195659, NULL, 'G3DSA:1.25.40.20:FF:001451', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 10', NULL, NULL, NULL, NULL, NULL, 4),
(195660, NULL, 'G3DSA:1.10.10.10:FF:001221', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(195661, NULL, 'G3DSA:1.20.120.330:FF:000042', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(195662, NULL, 'G3DSA:1.10.510.10:FF:003727', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195663, NULL, 'G3DSA:3.30.40.10:FF:000037', NULL, NULL, 'Cdk-activating kinase assembly factor MAT1, centre', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(195664, NULL, 'G3DSA:3.90.70.10:FF:000031', NULL, NULL, 'Cathepsin B', NULL, NULL, NULL, NULL, NULL, 4),
(195665, NULL, 'G3DSA:3.30.70.1450:FF:000003', NULL, NULL, 'Putative transport protein YbjL', NULL, NULL, NULL, NULL, NULL, 4),
(195666, NULL, 'G3DSA:3.30.160.60:FF:002983', NULL, NULL, 'Zinc finger protein 107', NULL, NULL, NULL, NULL, NULL, 4),
(195667, NULL, 'G3DSA:1.10.10.160:FF:000054', NULL, NULL, 'ATP-dependent DNA helicase srs2', NULL, NULL, NULL, NULL, NULL, 4),
(195668, NULL, 'G3DSA:1.10.132.70:FF:000011', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(195669, NULL, 'G3DSA:1.10.10.10:FF:001114', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(195670, NULL, 'G3DSA:2.60.120.650:FF:000234', NULL, NULL, 'Histone lysine demethylase PHF8', NULL, NULL, NULL, NULL, NULL, 4),
(195671, NULL, 'G3DSA:3.20.20.140:FF:000433', NULL, NULL, 'Sodium/hydrogen exchanger 2', NULL, NULL, NULL, NULL, NULL, 4),
(195672, NULL, 'G3DSA:3.80.10.10:FF:004390', NULL, NULL, 'AGAP006974-PA', NULL, NULL, NULL, NULL, NULL, 4),
(195673, NULL, 'G3DSA:1.20.1280.50:FF:000160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195674, NULL, 'G3DSA:3.30.70.330:FF:000705', NULL, NULL, 'Splicing factor U2AF 50 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(195675, NULL, 'G3DSA:2.40.180.10:FF:000015', NULL, NULL, 'Catalase-related peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(195676, NULL, 'G3DSA:2.10.50.10:FF:000103', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(195677, NULL, 'G3DSA:1.10.510.10:FF:003834', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195678, NULL, 'G3DSA:3.30.420.40:FF:000665', NULL, NULL, 'Luminal-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(195679, NULL, 'G3DSA:3.30.40.10:FF:001330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195680, NULL, 'G3DSA:3.40.50.1360:FF:000007', NULL, NULL, 'L-fucose operon activator', NULL, NULL, NULL, NULL, NULL, 4),
(195681, NULL, 'G3DSA:2.130.10.30:FF:000140', NULL, NULL, 'Protein pim1', NULL, NULL, NULL, NULL, NULL, 4),
(195682, NULL, 'G3DSA:3.30.1060.10:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195683, NULL, 'G3DSA:3.40.50.2300:FF:000216', NULL, NULL, 'Vomeronasal 2, receptor 111', NULL, NULL, NULL, NULL, NULL, 4),
(195684, NULL, 'G3DSA:2.10.25.10:FF:000123', NULL, NULL, 'Crumbs homolog 1 (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(195685, NULL, 'G3DSA:1.20.58.60:FF:000513', NULL, NULL, 'Spectrin repeat containing, nuclear envelope 1a', NULL, NULL, NULL, NULL, NULL, 4),
(195686, NULL, 'G3DSA:1.10.10.10:FF:001906', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195687, NULL, 'G3DSA:3.40.50.1700:FF:000036', NULL, NULL, 'Putative lipoprotein YbbD', NULL, NULL, NULL, NULL, NULL, 4),
(195688, NULL, 'G3DSA:3.40.50.300:FF:006750', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195689, NULL, 'G3DSA:3.30.70.1030:FF:000001', NULL, NULL, 'Chlorite dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(195690, NULL, 'G3DSA:2.170.300.10:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195691, NULL, 'G3DSA:1.25.40.10:FF:000953', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(195692, NULL, 'G3DSA:3.90.190.20:FF:000054', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(195693, NULL, 'G3DSA:3.30.160.60:FF:003158', NULL, NULL, 'Zinc finger protein 560', NULL, NULL, NULL, NULL, NULL, 4),
(195694, NULL, 'G3DSA:3.30.1360.180:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195695, NULL, 'G3DSA:2.40.30.10:FF:000185', NULL, NULL, 'FAD/NAD(P)-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(195696, NULL, 'G3DSA:1.10.150.50:FF:000070', NULL, NULL, 'ArfGAP with RhoGAP domain, ankyrin repeat and PH domain 2', NULL, NULL, NULL, NULL, NULL, 4),
(195697, NULL, 'G3DSA:3.30.230.70:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(195698, NULL, 'G3DSA:3.90.190.10:FF:000517', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195699, NULL, 'G3DSA:3.30.930.10:FF:000318', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195700, NULL, 'G3DSA:3.30.1330.30:FF:000115', NULL, NULL, 'Protein pelota homolog', NULL, NULL, NULL, NULL, NULL, 4),
(195701, NULL, 'G3DSA:2.160.20.10:FF:000291', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(195702, NULL, 'G3DSA:2.60.40.150:FF:000328', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(195703, NULL, 'G3DSA:2.40.10.10:FF:000638', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195704, NULL, 'G3DSA:3.30.200.20:FF:002481', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(195705, NULL, 'G3DSA:1.10.287.660:FF:000002', NULL, NULL, 'Vacuolar protein sorting-associated protein 37A', NULL, NULL, NULL, NULL, NULL, 4),
(195706, NULL, 'G3DSA:3.10.129.110:FF:000004', NULL, NULL, 'Multifunctional mycocerosic acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(195707, NULL, 'G3DSA:3.40.630.30:FF:000114', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(195708, NULL, 'G3DSA:3.30.70.330:FF:001993', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195709, NULL, 'G3DSA:3.40.50.11010:FF:000001', NULL, NULL, 'Glycosyl transferase family 1', NULL, NULL, NULL, NULL, NULL, 4),
(195710, NULL, 'G3DSA:1.10.555.10:FF:000150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195711, NULL, 'G3DSA:3.30.160.60:FF:003506', NULL, NULL, 'Zinc finger and BTB domain containing 48', NULL, NULL, NULL, NULL, NULL, 4),
(195712, NULL, 'G3DSA:1.20.120.1750:FF:000019', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(195713, NULL, 'G3DSA:3.30.200.20:FF:000345', NULL, NULL, 'Calcium/calmodulin-dependent protein kinase type 1B', NULL, NULL, NULL, NULL, NULL, 4),
(195714, NULL, 'G3DSA:2.60.34.20:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195715, NULL, 'G3DSA:3.20.20.60:FF:000113', NULL, NULL, 'Oxaloacetate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(195716, NULL, 'G3DSA:1.10.1200.170:FF:000001', NULL, NULL, 'RNA silencing suppressor', NULL, NULL, NULL, NULL, NULL, 4),
(195717, NULL, 'G3DSA:2.60.40.640:FF:000020', NULL, NULL, 'Arrestin, Arr2', NULL, NULL, NULL, NULL, NULL, 4),
(195718, NULL, 'G3DSA:1.20.1070.10:FF:000918', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195719, NULL, 'G3DSA:3.40.50.300:FF:003872', NULL, NULL, 'Multidrug resistance associated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(195720, NULL, 'G3DSA:1.20.5.990:FF:000004', NULL, NULL, 'TNFAIP3 interacting protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(195721, NULL, 'G3DSA:1.25.40.70:FF:000044', NULL, NULL, 'Phosphatidylinositol 3-kinase vps34', NULL, NULL, NULL, NULL, NULL, 4),
(195722, NULL, 'G3DSA:3.40.710.10:FF:000160', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(195723, NULL, 'G3DSA:2.60.40.1120:FF:000038', NULL, NULL, 'M56 family peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(195724, NULL, 'G3DSA:1.25.40.10:FF:003831', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195725, NULL, 'G3DSA:2.40.50.120:FF:000028', NULL, NULL, 'Tissue Inhibitor of MetalloProtease', NULL, NULL, NULL, NULL, NULL, 4),
(195726, NULL, 'G3DSA:3.10.20.90:FF:000302', NULL, NULL, 'plexin-B3 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(195727, NULL, 'G3DSA:3.60.15.10:FF:000039', NULL, NULL, 'DNA repair metallo-beta-lactamase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(195728, NULL, 'G3DSA:1.20.1070.10:FF:000576', NULL, NULL, 'Calcitonin receptor-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(195729, NULL, 'G3DSA:3.40.140.80:FF:000001', NULL, NULL, 'UDP-2,3-diacylglucosamine pyrophosphatase LpxI', NULL, NULL, NULL, NULL, NULL, 4),
(195730, NULL, 'G3DSA:2.10.25.10:FF:000702', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(195731, NULL, 'G3DSA:1.10.510.10:FF:002766', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195732, NULL, 'G3DSA:2.20.100.10:FF:000211', NULL, NULL, 'Thrombospondin type-1 domain-containing protein 7B', NULL, NULL, NULL, NULL, NULL, 4),
(195733, NULL, 'G3DSA:2.60.120.330:FF:000032', NULL, NULL, 'Gibberellin 20-oxidase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(195734, NULL, 'G3DSA:1.20.1250.20:FF:000441', NULL, NULL, 'Solute carrier family 40 protein', NULL, NULL, NULL, NULL, NULL, 4),
(195735, NULL, 'G3DSA:3.40.50.1820:FF:000847', NULL, NULL, 'Serine carboxypeptidase S28 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(195736, NULL, 'G3DSA:1.20.1270.60:FF:000100', NULL, NULL, 'Unplaced genomic scaffold supercont2.8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(195737, NULL, 'G3DSA:2.30.110.10:FF:000007', NULL, NULL, 'General stress protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(195738, NULL, 'G3DSA:3.30.2350.20:FF:000018', NULL, NULL, 'U2 snRNA/tRNA pseudouridine synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(195739, NULL, 'G3DSA:3.40.630.30:FF:000333', NULL, NULL, 'Putative acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(195740, NULL, 'G3DSA:2.10.110.10:FF:000326', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195741, NULL, 'G3DSA:1.10.287.70:FF:000550', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195742, NULL, 'G3DSA:1.10.8.870:FF:000010', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(195743, NULL, 'G3DSA:1.10.1220.10:FF:000012', NULL, NULL, 'DNA partition complex ParG', NULL, NULL, NULL, NULL, NULL, 4),
(195744, NULL, 'G3DSA:1.10.510.10:FF:003042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195745, NULL, 'G3DSA:2.10.90.10:FF:000100', NULL, NULL, 'Putative glycoprotein hormone-beta5', NULL, NULL, NULL, NULL, NULL, 4),
(195746, NULL, 'G3DSA:3.40.850.10:FF:000091', NULL, NULL, 'Kinesin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(195747, NULL, 'G3DSA:3.40.630.10:FF:000226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195748, NULL, 'G3DSA:1.20.1050.10:FF:000018', NULL, NULL, 'Glutathione S-transferase U20', NULL, NULL, NULL, NULL, NULL, 4),
(195749, NULL, 'G3DSA:3.30.1520.10:FF:000045', NULL, NULL, 'Zinc finger CCHC domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(195750, NULL, 'G3DSA:1.25.40.10:FF:000740', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(195751, NULL, 'G3DSA:1.10.101.10:FF:000006', NULL, NULL, 'L,D-transpeptidase YcbB', NULL, NULL, NULL, NULL, NULL, 4),
(195752, NULL, 'G3DSA:1.10.472.10:FF:000294', NULL, NULL, 'Cyclin domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(195753, NULL, 'G3DSA:3.60.10.10:FF:000394', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195754, NULL, 'G3DSA:3.40.50.1820:FF:000286', NULL, NULL, 'YDL086W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(195755, NULL, 'G3DSA:2.60.120.10:FF:000029', NULL, NULL, 'HTH-type transcriptional regulator PuuR', NULL, NULL, NULL, NULL, NULL, 4),
(195756, NULL, 'G3DSA:3.40.50.720:FF:000912', NULL, NULL, '3-hydroxyisobutyrate dehydrogenase a', NULL, NULL, NULL, NULL, NULL, 4),
(195757, NULL, 'G3DSA:1.25.40.20:FF:001013', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(195758, NULL, 'G3DSA:3.30.40.10:FF:000829', NULL, NULL, 'RING-H2 finger protein ATL70', NULL, NULL, NULL, NULL, NULL, 4),
(195759, NULL, 'G3DSA:3.40.50.1820:FF:000162', NULL, NULL, 'Enterochelin esterase', NULL, NULL, NULL, NULL, NULL, 4),
(195760, NULL, 'G3DSA:2.40.50.100:FF:000022', NULL, NULL, 'Exosome complex component RRP4', NULL, NULL, NULL, NULL, NULL, 4),
(195761, NULL, 'G3DSA:3.40.309.10:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195762, NULL, 'G3DSA:1.10.10.10:FF:001351', NULL, NULL, 'Cyclic nucleotide-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(195763, NULL, 'G3DSA:1.20.58.60:FF:000643', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(195764, NULL, 'G3DSA:3.40.50.1820:FF:000510', NULL, NULL, 'AflJ/ estA/ esterase', NULL, NULL, NULL, NULL, NULL, 4),
(195765, NULL, 'G3DSA:1.10.287.130:FF:000074', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(195766, NULL, 'G3DSA:2.120.10.30:FF:000573', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195767, NULL, 'G3DSA:3.40.50.720:FF:002250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195768, NULL, 'G3DSA:1.25.10.10:FF:002149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195769, NULL, 'G3DSA:3.20.20.10:FF:000008', NULL, NULL, 'Ornithine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(195770, NULL, 'G3DSA:3.30.420.10:FF:000111', NULL, NULL, 'IS3-like element IS987 family transposase', NULL, NULL, NULL, NULL, NULL, 4),
(195771, NULL, 'G3DSA:1.20.920.30:FF:000047', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(195772, NULL, 'G3DSA:3.20.20.100:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195773, NULL, 'G3DSA:3.40.50.12230:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195774, NULL, 'G3DSA:3.40.50.2000:FF:000688', NULL, NULL, 'DUF3492 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(195775, NULL, 'G3DSA:1.10.10.750:FF:000028', NULL, NULL, 'Rab GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(195776, NULL, 'G3DSA:3.90.70.10:FF:000823', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195777, NULL, 'G3DSA:1.10.238.10:FF:000823', NULL, NULL, 'Putative calcium-binding protein CML27', NULL, NULL, NULL, NULL, NULL, 4),
(195778, NULL, 'G3DSA:3.30.470.20:FF:000174', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(195779, NULL, 'G3DSA:1.20.120.1900:FF:000093', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(195780, NULL, 'G3DSA:1.20.1070.10:FF:001537', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195781, NULL, 'G3DSA:1.10.3460.10:FF:000018', NULL, NULL, 'Photosystem II 22kDa chloroplast protein', NULL, NULL, NULL, NULL, NULL, 4),
(195782, NULL, 'G3DSA:2.60.120.260:FF:000443', NULL, NULL, 'Laminin subunit beta-1 variant', NULL, NULL, NULL, NULL, NULL, 4),
(195783, NULL, 'G3DSA:2.60.120.650:FF:000015', NULL, NULL, 'putative lysine-specific demethylase JMJ16', NULL, NULL, NULL, NULL, NULL, 4),
(195784, NULL, 'G3DSA:1.25.10.10:FF:002694', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195785, NULL, 'G3DSA:1.20.5.110:FF:000005', NULL, NULL, 'Syntaxin 1B', NULL, NULL, NULL, NULL, NULL, 4),
(195786, NULL, 'G3DSA:2.60.40.10:FF:001134', NULL, NULL, 'Calcium-activated chloride channel regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(195787, NULL, 'G3DSA:3.40.30.10:FF:001071', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(195788, NULL, 'G3DSA:4.10.400.10:FF:000010', NULL, NULL, 'Low-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(195789, NULL, 'G3DSA:1.10.540.10:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195790, NULL, 'G3DSA:2.60.120.260:FF:000567', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195791, NULL, 'G3DSA:2.40.240.10:FF:000054', NULL, NULL, 'Glutamate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(195792, NULL, 'G3DSA:3.30.70.330:FF:001324', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(195793, NULL, 'G3DSA:2.30.30.490:FF:000053', NULL, NULL, 'DNA (cytosine-5)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(195794, NULL, 'G3DSA:3.30.40.10:FF:000711', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195795, NULL, 'G3DSA:2.60.200.20:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195796, NULL, 'G3DSA:3.10.100.10:FF:000064', NULL, NULL, 'Natural killer cells antigen CD94', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(195797, NULL, 'G3DSA:1.20.58.670:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195798, NULL, 'G3DSA:3.40.30.10:FF:000795', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195799, NULL, 'G3DSA:2.60.40.10:FF:003506', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195800, NULL, 'G3DSA:3.80.10.10:FF:000348', NULL, NULL, 'Polygalacturonase inhibitor 1', NULL, NULL, NULL, NULL, NULL, 4),
(195801, NULL, 'G3DSA:4.10.1060.10:FF:000042', NULL, NULL, 'Zn-finger in Ran binding protein and others/SPRY domain/HECT-domain (Ubiquitin-transferase), putative', NULL, NULL, NULL, NULL, NULL, 4),
(195802, NULL, 'G3DSA:2.10.109.10:FF:000020', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(195803, NULL, 'G3DSA:3.40.50.300:FF:002708', NULL, NULL, 'FeS assembly ATPase SufC', NULL, NULL, NULL, NULL, NULL, 4),
(195804, NULL, 'G3DSA:3.50.30.30:FF:000031', NULL, NULL, 'RING finger protein 215', NULL, NULL, NULL, NULL, NULL, 4),
(195805, NULL, 'G3DSA:1.50.40.10:FF:000108', NULL, NULL, 'Solute carrier family 25 member 44', NULL, NULL, NULL, NULL, NULL, 4),
(195806, NULL, 'G3DSA:3.20.20.70:FF:000335', NULL, NULL, 'FO synthase', NULL, NULL, NULL, NULL, NULL, 4),
(195807, NULL, 'G3DSA:2.40.50.140:FF:000478', NULL, NULL, 'ATP-dependent DNA helicase RecG', NULL, NULL, NULL, NULL, NULL, 4),
(195808, NULL, 'G3DSA:3.40.1230.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195809, NULL, 'G3DSA:1.20.1540.10:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195810, NULL, 'G3DSA:1.20.1070.10:FF:000126', NULL, NULL, 'Probable G-protein coupled receptor 139', NULL, NULL, NULL, NULL, NULL, 4),
(195811, NULL, 'G3DSA:1.10.287.20:FF:000001', NULL, NULL, 'Cytochrome b-c1 complex subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(195812, NULL, 'G3DSA:1.10.1520.10:FF:000052', NULL, NULL, 'Mitochondrial 54S ribosomal protein YmL15', NULL, NULL, NULL, NULL, NULL, 4),
(195813, NULL, 'G3DSA:3.40.50.2300:FF:000660', NULL, NULL, 'Receptor-type guanylate cyclase gcy-19', NULL, NULL, NULL, NULL, NULL, 4),
(195814, NULL, 'G3DSA:3.40.50.720:FF:000805', NULL, NULL, '3-beta hydroxysteroid dehydrogenase/isomerase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(195815, NULL, 'G3DSA:3.40.630.10:FF:000119', NULL, NULL, 'Acetylornithine deacetylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(195816, NULL, 'G3DSA:1.20.120.1760:FF:000011', NULL, NULL, 'Cdp-diacylglycerol-inositol 3-phosphatidyltransferase pis', NULL, NULL, NULL, NULL, NULL, 4),
(195817, NULL, 'G3DSA:3.30.50.10:FF:000083', NULL, NULL, 'GATA transcription factor 27', NULL, NULL, NULL, NULL, NULL, 4),
(195818, NULL, 'G3DSA:2.40.50.170:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195819, NULL, 'G3DSA:1.10.287.70:FF:000443', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195820, NULL, 'G3DSA:3.90.640.10:FF:000030', NULL, NULL, 'Heat shock protein HSP70', NULL, NULL, NULL, NULL, NULL, 4),
(195821, NULL, 'G3DSA:3.30.565.10:FF:000256', NULL, NULL, 'Signal transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(195822, NULL, 'G3DSA:3.30.200.20:FF:002037', NULL, NULL, 'Misshapen like kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(195823, NULL, 'G3DSA:3.30.360.10:FF:000067', NULL, NULL, 'Dihydrodipicolinate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(195824, NULL, 'G3DSA:3.30.300.210:FF:000004', NULL, NULL, 'Spore germination protein, gerC', NULL, NULL, NULL, NULL, NULL, 4),
(195825, NULL, 'G3DSA:2.60.450.10:FF:000003', NULL, NULL, 'LPS-assembly protein LptD', NULL, NULL, NULL, NULL, NULL, 4),
(195826, NULL, 'G3DSA:3.40.50.300:FF:008200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195827, NULL, 'G3DSA:2.60.40.10:FF:005075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195828, NULL, 'G3DSA:1.10.472.80:FF:000163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195829, NULL, 'G3DSA:1.10.1040.50:FF:000009', NULL, NULL, 'Trifunctional enzyme alpha subunit, mitochondrial-like protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(195830, NULL, 'G3DSA:2.40.320.10:FF:000004', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 18', NULL, NULL, NULL, NULL, NULL, 4),
(195831, NULL, 'G3DSA:1.25.40.10:FF:004899', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195832, NULL, 'G3DSA:1.20.1050.90:FF:000003', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(195833, NULL, 'G3DSA:1.10.150.20:FF:000307', NULL, NULL, 'DNAJ domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(195834, NULL, 'G3DSA:1.10.1060.10:FF:000010', NULL, NULL, 'Fumarate reductase iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4),
(195835, NULL, 'G3DSA:1.20.120.1320:FF:000008', NULL, NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(195836, NULL, 'G3DSA:1.10.10.10:FF:000384', NULL, NULL, 'ArsR-family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(195837, NULL, 'G3DSA:3.90.640.10:FF:000024', NULL, NULL, 'Molecular chaperone HscC', NULL, NULL, NULL, NULL, NULL, 4),
(195838, NULL, 'G3DSA:2.60.40.10:FF:003950', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195839, NULL, 'G3DSA:3.40.462.40:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195840, NULL, 'G3DSA:3.30.260.10:FF:000008', NULL, NULL, 'T-complex protein 1 subunit theta', NULL, NULL, NULL, NULL, NULL, 4),
(195841, NULL, 'G3DSA:3.20.20.80:FF:000321', NULL, NULL, 'Os11g0701600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(195842, NULL, 'G3DSA:1.25.40.10:FF:002769', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195843, NULL, 'G3DSA:1.10.287.630:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195844, NULL, 'G3DSA:3.30.390.30:FF:000007', NULL, NULL, 'Putative apoptosis-inducing factor 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(195845, NULL, 'G3DSA:3.30.70.20:FF:000087', NULL, NULL, 'NAD-dependent dihydropyrimidine dehydrogenase subunit PreA', NULL, NULL, NULL, NULL, NULL, 4),
(195846, NULL, 'G3DSA:3.75.10.10:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195847, NULL, 'G3DSA:2.30.30.40:FF:000481', NULL, NULL, 'YALI0F27643p', NULL, NULL, NULL, NULL, NULL, 4),
(195848, NULL, 'G3DSA:3.40.50.1820:FF:001578', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195849, NULL, 'G3DSA:4.10.400.10:FF:000116', NULL, NULL, 'Low-density lipoprotein receptor', NULL, NULL, NULL, NULL, NULL, 4),
(195850, NULL, 'G3DSA:2.30.42.10:FF:000494', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195851, NULL, 'G3DSA:3.40.50.970:FF:000048', NULL, NULL, 'IlvB (bacterial acetolactate synthase)-like', NULL, NULL, NULL, NULL, NULL, 4),
(195852, NULL, 'G3DSA:3.10.10.10:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195853, NULL, 'G3DSA:2.60.40.150:FF:000766', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(195854, NULL, 'G3DSA:3.30.390.10:FF:000001', NULL, NULL, 'Enolase', NULL, NULL, NULL, NULL, NULL, 4),
(195855, NULL, 'G3DSA:2.60.120.590:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195856, NULL, 'G3DSA:3.30.470.30:FF:000047', NULL, NULL, 'mRNA-capping enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(195857, NULL, 'G3DSA:2.60.40.10:FF:003618', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195858, NULL, 'G3DSA:2.60.40.10:FF:004456', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195859, NULL, 'G3DSA:1.25.40.20:FF:001249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195860, NULL, 'G3DSA:3.30.1010.10:FF:000074', NULL, NULL, 'PIKK family atypical protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(195861, NULL, 'G3DSA:3.10.260.10:FF:000002', NULL, NULL, 'APSES transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(195862, NULL, 'G3DSA:1.20.1440.180:FF:000008', NULL, NULL, 'Probable serine/threonine-protein kinase irlF', NULL, NULL, NULL, NULL, NULL, 4),
(195863, NULL, 'G3DSA:1.10.510.10:FF:000400', NULL, NULL, 'MDIS1-interacting receptor like kinase 1', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(195864, NULL, 'G3DSA:3.40.50.1760:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195865, NULL, 'G3DSA:1.10.287.130:FF:000186', NULL, NULL, 'Bacteriophytochrome', NULL, NULL, NULL, NULL, NULL, 4),
(195866, NULL, 'G3DSA:2.130.10.10:FF:002293', NULL, NULL, 'DDB1- and CUL4-associated factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(195867, NULL, 'G3DSA:2.40.50.140:FF:001203', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195868, NULL, 'G3DSA:3.30.420.40:FF:001065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195869, NULL, 'G3DSA:3.30.870.10:FF:000038', NULL, NULL, 'Probable tyrosyl-DNA phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(195870, NULL, 'G3DSA:3.30.160.60:FF:004669', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195871, NULL, 'G3DSA:2.130.10.10:FF:005041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195872, NULL, 'G3DSA:1.10.472.10:FF:000288', NULL, NULL, 'Cyclin-C', NULL, NULL, NULL, NULL, NULL, 4),
(195873, NULL, 'G3DSA:3.40.50.620:FF:000545', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(195874, NULL, 'G3DSA:3.30.160.60:FF:001235', NULL, NULL, 'Si:ch211-119o8.6', NULL, NULL, NULL, NULL, NULL, 4),
(195875, NULL, 'G3DSA:3.30.40.10:FF:000493', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(195876, NULL, 'G3DSA:3.40.50.300:FF:006963', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195877, NULL, 'G3DSA:2.10.220.10:FF:000099', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(195878, NULL, 'G3DSA:3.30.230.10:FF:000405', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195879, NULL, 'G3DSA:1.25.40.10:FF:002084', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(195880, NULL, 'G3DSA:2.30.29.30:FF:000300', NULL, NULL, 'pleckstrin homology domain-containing family J member 1', NULL, NULL, NULL, NULL, NULL, 4),
(195881, NULL, 'G3DSA:3.80.10.10:FF:000005', NULL, NULL, 'leucine-rich repeat transmembrane neuronal protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(195882, NULL, 'G3DSA:2.60.470.10:FF:000016', NULL, NULL, 'Sodium channel protein Nach', NULL, NULL, NULL, NULL, NULL, 4),
(195883, NULL, 'G3DSA:3.40.50.1820:FF:001691', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(195884, NULL, 'G3DSA:1.20.1250.20:FF:001857', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195885, NULL, 'G3DSA:3.40.50.620:FF:000652', NULL, NULL, 'Isoleucyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(195886, NULL, 'G3DSA:3.30.160.60:FF:003490', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195887, NULL, 'G3DSA:3.10.130.10:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195888, NULL, 'G3DSA:1.20.5.170:FF:000202', NULL, NULL, 'Transcription factor AP-1', NULL, NULL, NULL, NULL, NULL, 4),
(195889, NULL, 'G3DSA:3.10.580.10:FF:000037', NULL, NULL, 'Transmembrane CBS domain transporter', NULL, NULL, NULL, NULL, NULL, 4),
(195890, NULL, 'G3DSA:3.80.10.10:FF:003883', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195891, NULL, 'G3DSA:2.170.270.10:FF:000093', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(195892, NULL, 'G3DSA:3.90.1150.10:FF:000435', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195893, NULL, 'G3DSA:1.25.10.10:FF:001637', NULL, NULL, 'Tubulin folding cofactor D', NULL, NULL, NULL, NULL, NULL, 4),
(195894, NULL, 'G3DSA:2.60.40.2840:FF:000003', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 5-phosphatase A', NULL, NULL, NULL, NULL, NULL, 4),
(195895, NULL, 'G3DSA:3.90.660.20:FF:000028', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(195896, NULL, 'G3DSA:1.25.40.20:FF:000052', NULL, NULL, 'Ankyrin repeat domain-containing protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(195897, NULL, 'G3DSA:3.90.190.10:FF:000169', NULL, NULL, 'Phosphotyrosine protein phosphatase PtpB', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(195898, NULL, 'G3DSA:3.40.630.10:FF:000451', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195899, NULL, 'G3DSA:2.30.30.30:FF:000152', NULL, NULL, '60S ribosomal protein L26-1', NULL, NULL, NULL, NULL, NULL, 4),
(195900, NULL, 'G3DSA:3.80.10.10:FF:001753', NULL, NULL, 'Putative disease resistance protein At3g14460', NULL, NULL, NULL, NULL, NULL, 4),
(195901, NULL, 'G3DSA:3.30.160.60:FF:005524', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195902, NULL, 'G3DSA:3.30.160.60:FF:003383', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195903, NULL, 'G3DSA:1.10.10.2330:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195904, NULL, 'G3DSA:2.60.40.2860:FF:000009', NULL, NULL, 'Transmission-blocking target antigen S230', NULL, NULL, NULL, NULL, NULL, 4),
(195905, NULL, 'G3DSA:3.40.50.300:FF:002692', NULL, NULL, 'Zinc finger, NFX1-type-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(195906, NULL, 'G3DSA:3.20.20.70:FF:000223', NULL, NULL, 'Triosephosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(195907, NULL, 'G3DSA:3.80.10.10:FF:003990', NULL, NULL, 'Toll-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(195908, NULL, 'G3DSA:3.30.60.60:FF:000019', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(195909, NULL, 'G3DSA:3.40.430.10:FF:000008', NULL, NULL, 'Dihydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(195910, NULL, 'G3DSA:3.40.50.800:FF:000043', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(195911, NULL, 'G3DSA:2.60.40.10:FF:001477', NULL, NULL, 'Titin b', NULL, NULL, NULL, NULL, NULL, 4),
(195912, NULL, 'G3DSA:3.30.300.30:FF:000064', NULL, NULL, 'Possible fatty-acid-CoA ligase fadD10', NULL, NULL, NULL, NULL, NULL, 4),
(195913, NULL, 'G3DSA:3.40.532.10:FF:000009', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(195914, NULL, 'G3DSA:1.10.10.1200:FF:000012', NULL, NULL, 'Non-structural maintenance of chromosome element 3', NULL, NULL, NULL, NULL, NULL, 4),
(195915, NULL, 'G3DSA:2.130.10.110:FF:000001', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(195916, NULL, 'G3DSA:3.30.2460.20:FF:000009', NULL, NULL, 'Protein Wnt-3a', NULL, NULL, NULL, NULL, NULL, 4),
(195917, NULL, 'G3DSA:3.40.33.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195918, NULL, 'G3DSA:2.120.10.30:FF:000348', NULL, NULL, 'NHL repeat-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(195919, NULL, 'G3DSA:2.60.120.200:FF:000009', NULL, NULL, 'Thrombospondin 1', NULL, NULL, NULL, NULL, NULL, 4),
(195920, NULL, 'G3DSA:3.10.450.50:FF:000034', NULL, NULL, 'Unplaced genomic scaffold supercont2.5, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(195921, NULL, 'G3DSA:2.130.10.10:FF:001674', NULL, NULL, 'Utp13 specific WD40 associated domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(195922, NULL, 'G3DSA:3.30.420.40:FF:000446', NULL, NULL, 'STCH (Truncated HSP) family', NULL, NULL, NULL, NULL, NULL, 4),
(195923, NULL, 'G3DSA:1.20.1070.10:FF:001981', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195924, NULL, 'G3DSA:3.30.1520.10:FF:000051', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(195925, NULL, 'G3DSA:2.60.34.10:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195926, NULL, 'G3DSA:2.30.42.10:FF:000263', NULL, NULL, 'Multiple PDZ domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(195927, NULL, 'G3DSA:3.90.70.10:FF:000374', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(195928, NULL, 'G3DSA:3.40.50.300:FF:000331', NULL, NULL, 'Arginine ABC transporter ATP-binding protein ArtP', NULL, NULL, NULL, NULL, NULL, 4),
(195929, NULL, 'G3DSA:3.30.160.60:FF:005288', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195930, NULL, 'G3DSA:2.30.29.30:FF:001025', NULL, NULL, 'Villidin', NULL, NULL, NULL, NULL, NULL, 4),
(195931, NULL, 'G3DSA:1.20.120.220:FF:000014', NULL, NULL, 'ATP synthase F1F0 subunit 6', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(195932, NULL, 'G3DSA:1.20.1560.10:FF:000900', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195933, NULL, 'G3DSA:3.40.50.1820:FF:000853', NULL, NULL, 'Serine peptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(195934, NULL, 'G3DSA:1.25.40.20:FF:000962', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195935, NULL, 'G3DSA:3.40.190.10:FF:000422', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(195936, NULL, 'G3DSA:3.40.800.10:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195937, NULL, 'G3DSA:2.130.10.10:FF:002186', NULL, NULL, 'WD repeat domain 34', NULL, NULL, NULL, NULL, NULL, 4),
(195938, NULL, 'G3DSA:3.40.50.720:FF:000120', NULL, NULL, 'D-amino-acid oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(195939, NULL, 'G3DSA:1.10.1200.30:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195940, NULL, 'G3DSA:3.40.850.10:FF:000445', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195941, NULL, 'G3DSA:3.30.70.330:FF:002381', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195942, NULL, 'G3DSA:1.20.1260.10:FF:000063', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(195943, NULL, 'G3DSA:3.30.160.60:FF:005400', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195944, NULL, 'G3DSA:3.40.50.720:FF:002149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195945, NULL, 'G3DSA:1.10.510.10:FF:003273', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195946, NULL, 'G3DSA:3.30.70.1440:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195947, NULL, 'G3DSA:1.20.1250.20:FF:000571', NULL, NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(195948, NULL, 'G3DSA:3.40.1380.10:FF:000003', NULL, NULL, 'ATP synthase subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(195949, NULL, 'G3DSA:3.20.20.60:FF:000107', NULL, NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(195950, NULL, 'G3DSA:3.40.50.300:FF:007475', NULL, NULL, 'Structural maintenance of chromosomes protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(195951, NULL, 'G3DSA:1.10.510.10:FF:002654', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195952, NULL, 'G3DSA:1.10.287.70:FF:000662', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195953, NULL, 'G3DSA:3.30.1640.10:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195954, NULL, 'G3DSA:1.20.1160.20:FF:000013', NULL, NULL, 'PDZ domain containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(195955, NULL, 'G3DSA:3.40.50.300:FF:006856', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(195956, NULL, 'G3DSA:1.20.5.170:FF:000096', NULL, NULL, 'BZIP transcription factor bZIP46', NULL, NULL, NULL, NULL, NULL, 4),
(195957, NULL, 'G3DSA:1.20.1070.10:FF:000233', NULL, NULL, 'CLUMA_CG012980, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(195958, NULL, 'G3DSA:2.60.40.10:FF:003731', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195959, NULL, 'G3DSA:3.30.160.60:FF:000510', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(195960, NULL, 'G3DSA:1.20.58.60:FF:000064', NULL, NULL, 'Short stop, isoform K', NULL, NULL, NULL, NULL, NULL, 4),
(195961, NULL, 'G3DSA:3.20.20.240:FF:000002', NULL, NULL, 'Methylmalonyl-CoA mutase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(195962, NULL, 'G3DSA:2.60.40.60:FF:000626', NULL, NULL, 'Protocadherin 12', NULL, NULL, NULL, NULL, NULL, 4),
(195963, NULL, 'G3DSA:3.30.160.60:FF:002539', NULL, NULL, 'GD10244', NULL, NULL, NULL, NULL, NULL, 4),
(195964, NULL, 'G3DSA:1.20.910.10:FF:000007', NULL, NULL, 'Bifunctional TENA-E protein', NULL, NULL, NULL, NULL, NULL, 4),
(195965, NULL, 'G3DSA:3.40.50.300:FF:003080', NULL, NULL, 'Small GTPase EhRabX10, putative', NULL, NULL, NULL, NULL, NULL, 4),
(195966, NULL, 'G3DSA:3.90.176.10:FF:000001', NULL, NULL, 'NAD(P)(+)--arginine ADP-ribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(195967, NULL, 'G3DSA:2.30.30.40:FF:000374', NULL, NULL, 'Putative purine-binding chemotaxis protein Chew', NULL, NULL, NULL, NULL, NULL, 4),
(195968, NULL, 'G3DSA:1.20.1250.20:FF:000239', NULL, NULL, 'Probable L-galactonate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(195969, NULL, 'G3DSA:3.40.1170.60:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195970, NULL, 'G3DSA:1.10.520.10:FF:000007', NULL, NULL, 'L-ascorbate peroxidase S chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(195971, NULL, 'G3DSA:3.40.1110.10:FF:000068', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(195972, NULL, 'G3DSA:1.10.246.90:FF:000017', NULL, NULL, 'Exocyst complex component SEC5A', NULL, NULL, NULL, NULL, NULL, 4),
(195973, NULL, 'G3DSA:2.60.40.1450:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195974, NULL, 'G3DSA:3.40.50.10330:FF:000011', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(195975, NULL, 'G3DSA:3.30.230.10:FF:000187', NULL, NULL, 'Os02g0543300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(195976, NULL, 'G3DSA:2.30.30.210:FF:000008', NULL, NULL, 'Ribonuclease P protein subunit p29', NULL, NULL, NULL, NULL, NULL, 4),
(195977, NULL, 'G3DSA:3.40.50.10050:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195978, NULL, 'G3DSA:2.60.40.10:FF:002202', NULL, NULL, 'CD48 antigen', NULL, NULL, NULL, NULL, NULL, 4),
(195979, NULL, 'G3DSA:2.20.110.10:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195980, NULL, 'G3DSA:3.40.50.200:FF:000071', NULL, NULL, 'Peptidase S8', NULL, NULL, NULL, NULL, NULL, 4),
(195981, NULL, 'G3DSA:1.20.1250.10:FF:000112', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195982, NULL, 'G3DSA:1.25.40.10:FF:003606', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195983, NULL, 'G3DSA:1.20.920.10:FF:000053', NULL, NULL, 'Blast:E3 ubiquitin-protein ligase TRIM33', NULL, NULL, NULL, NULL, NULL, 4),
(195984, NULL, 'G3DSA:3.40.50.1010:FF:000144', NULL, NULL, 'WGS project CABT00000000 data, contig 2.11', NULL, NULL, NULL, NULL, NULL, 4),
(195985, NULL, 'G3DSA:2.130.10.10:FF:002747', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195986, NULL, 'G3DSA:3.90.1600.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195987, NULL, 'G3DSA:3.60.110.10:FF:000093', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195988, NULL, 'G3DSA:3.30.342.10:FF:000014', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(195989, NULL, 'G3DSA:1.20.58.60:FF:000188', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(195990, NULL, 'G3DSA:1.20.1070.10:FF:001762', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195991, NULL, 'G3DSA:3.30.1360.10:FF:000061', NULL, NULL, 'RNA polymerase Rpb3/Rpb11 dimerisation domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(195992, NULL, 'G3DSA:3.30.160.60:FF:002871', NULL, NULL, 'Zinc finger protein 142', NULL, NULL, NULL, NULL, NULL, 4),
(195993, NULL, 'G3DSA:3.40.1360.10:FF:000002', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(195994, NULL, 'G3DSA:1.10.510.10:FF:004346', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(195995, NULL, 'G3DSA:3.30.70.1230:FF:000162', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(195996, NULL, 'G3DSA:3.80.10.10:FF:000117', NULL, NULL, 'leucine-rich repeat-containing protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(195997, NULL, 'G3DSA:3.30.420.10:FF:000342', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195998, NULL, 'G3DSA:1.25.40.20:FF:001581', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(195999, NULL, 'G3DSA:1.25.10.10:FF:000912', NULL, NULL, 'Adaptin N terminal region family protein', NULL, NULL, NULL, NULL, NULL, 4),
(196000, NULL, 'G3DSA:2.40.30.170:FF:000022', NULL, NULL, 'Efflux transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(196001, NULL, 'G3DSA:3.80.30.20:FF:000009', NULL, NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(196002, NULL, 'G3DSA:2.60.120.650:FF:000122', NULL, NULL, 'GM16352', NULL, NULL, NULL, NULL, NULL, 4),
(196003, NULL, 'G3DSA:2.40.70.10:FF:000182', NULL, NULL, 'Beta-secretase 1', NULL, NULL, NULL, NULL, NULL, 4),
(196004, NULL, 'G3DSA:1.25.10.10:FF:002256', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(196005, NULL, 'G3DSA:2.60.120.10:FF:000136', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(196006, NULL, 'G3DSA:3.30.200.20:FF:000912', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196007, NULL, 'G3DSA:2.20.70.10:FF:000238', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(196008, NULL, 'G3DSA:3.40.50.11850:FF:000011', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(196009, NULL, 'G3DSA:3.60.10.10:FF:000287', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196010, NULL, 'G3DSA:2.60.40.10:FF:000965', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', NULL, NULL, NULL, NULL, NULL, 4),
(196011, NULL, 'G3DSA:2.40.50.40:FF:000066', NULL, NULL, 'Protein CHROMATIN REMODELING 4', NULL, NULL, NULL, NULL, NULL, 4),
(196012, NULL, 'G3DSA:3.10.450.240:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196013, NULL, 'G3DSA:1.10.490.60:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196014, NULL, 'G3DSA:3.40.50.300:FF:001056', NULL, NULL, 'RAB1A, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(196015, NULL, 'G3DSA:2.60.120.260:FF:000674', NULL, NULL, 'Beta-galactosidase precursor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196016, NULL, 'G3DSA:2.30.29.30:FF:000188', NULL, NULL, 'Myotubularin related protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(196017, NULL, 'G3DSA:3.30.160.60:FF:004905', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196018, NULL, 'G3DSA:3.30.200.20:FF:001312', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(196019, NULL, 'G3DSA:1.25.40.660:FF:000008', NULL, NULL, 'Vacuolar protein sorting protein 35-2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196020, NULL, 'G3DSA:2.120.10.30:FF:000129', NULL, NULL, 'CRE-LIN-41 protein', NULL, NULL, NULL, NULL, NULL, 4),
(196021, NULL, 'G3DSA:3.40.50.1820:FF:000055', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(196022, NULL, 'G3DSA:2.30.30.40:FF:000593', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(196023, NULL, 'G3DSA:1.10.3430.10:FF:000067', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196024, NULL, 'G3DSA:3.20.100.10:FF:000011', NULL, NULL, 'mRNA-capping enzyme subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(196025, NULL, 'G3DSA:2.130.10.10:FF:003366', NULL, NULL, 'Rho guanine nucleotide exchange factor 10-like', NULL, NULL, NULL, NULL, NULL, 4),
(196026, NULL, 'G3DSA:3.30.70.3490:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196027, NULL, 'G3DSA:1.20.1070.10:FF:000014', NULL, NULL, 'Kappa-type opioid receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(196028, NULL, 'G3DSA:1.10.8.60:FF:000515', NULL, NULL, 'ATPase, AAA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(196029, NULL, 'G3DSA:3.40.50.720:FF:002481', NULL, NULL, 'Malate oxidoreductase, NAD-dependent', NULL, NULL, NULL, NULL, NULL, 4),
(196030, NULL, 'G3DSA:1.20.1050.10:FF:000249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196031, NULL, 'G3DSA:3.40.50.300:FF:001635', NULL, NULL, 'Disease resistance protein Pik-2', NULL, NULL, NULL, NULL, NULL, 4),
(196032, NULL, 'G3DSA:3.40.10.10:FF:000001', NULL, NULL, 'DNA-3-methyladenine glycosylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(196033, NULL, 'G3DSA:1.10.630.10:FF:000235', NULL, NULL, 'Cytochrome P450 family 93 subfamily D polypeptide 1', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(196034, NULL, 'G3DSA:3.40.50.2000:FF:000795', NULL, NULL, 'Alpha,alpha-trehalose-phosphate synthase [UDP-forming] B', NULL, NULL, NULL, NULL, NULL, 4),
(196035, NULL, 'G3DSA:4.10.280.10:FF:000235', NULL, NULL, 'Transcription factor bHLH130', NULL, NULL, NULL, NULL, NULL, 4),
(196036, NULL, 'G3DSA:1.20.1250.20:FF:001751', NULL, NULL, 'Proton:peptide symporter POT family', NULL, NULL, NULL, NULL, NULL, 4),
(196037, NULL, 'G3DSA:2.130.10.10:FF:003708', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196038, NULL, 'G3DSA:3.20.20.70:FF:000442', NULL, NULL, 'tRNA-dihydrouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(196039, NULL, 'G3DSA:3.40.30.10:FF:000014', NULL, NULL, 'Tau class glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(196040, NULL, 'G3DSA:3.40.50.300:FF:005906', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(196041, NULL, 'G3DSA:1.25.10.10:FF:001531', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196042, NULL, 'G3DSA:3.30.160.60:FF:001814', NULL, NULL, 'Zinc finger protein 572', NULL, NULL, NULL, NULL, NULL, 4),
(196043, NULL, 'G3DSA:1.20.1160.11:FF:000005', NULL, NULL, 'SIN3 transcription regulator family member B', NULL, NULL, NULL, NULL, NULL, 4),
(196044, NULL, 'G3DSA:3.20.140.10:FF:000007', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(196045, NULL, 'G3DSA:2.60.40.10:FF:004675', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196046, NULL, 'G3DSA:2.10.25.10:FF:001652', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196047, NULL, 'G3DSA:3.40.640.10:FF:000165', NULL, NULL, 'Protein CBG17192', NULL, NULL, NULL, NULL, NULL, 4),
(196048, NULL, 'G3DSA:1.25.40.10:FF:002645', NULL, NULL, 'Protein CTR9-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(196049, NULL, 'G3DSA:3.40.1160.10:FF:000021', NULL, NULL, 'Glutamate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(196050, NULL, 'G3DSA:3.30.60.190:FF:000010', NULL, NULL, 'Zinc finger, HIT-type-containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(196051, NULL, 'G3DSA:1.20.200.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196052, NULL, 'G3DSA:2.10.25.10:FF:000359', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(196053, NULL, 'G3DSA:3.90.55.10:FF:000001', NULL, NULL, 'Biotin sulfoxide reductase 2', NULL, NULL, NULL, NULL, NULL, 4),
(196054, NULL, 'G3DSA:3.10.20.870:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196055, NULL, 'G3DSA:3.30.420.390:FF:000005', NULL, NULL, 'Related to MIP1-DNA-directed DNA polymerase gamma catalytic subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(196056, NULL, 'G3DSA:1.20.120.1080:FF:000015', NULL, NULL, 'Putative ATP-dependent RNA helicase DHX33', NULL, NULL, NULL, NULL, NULL, 4),
(196057, NULL, 'G3DSA:3.10.350.10:FF:000104', NULL, NULL, 'Membrane-bound lytic murein transglycosylase D', NULL, NULL, NULL, NULL, NULL, 4),
(196058, NULL, 'G3DSA:3.50.50.60:FF:001210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196059, NULL, 'G3DSA:2.60.40.10:FF:000061', NULL, NULL, 'Dyslexia-associated protein KIAA0319 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(196060, NULL, 'G3DSA:3.40.50.880:FF:000027', NULL, NULL, 'Anthranilate synthase beta subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(196061, NULL, 'G3DSA:1.10.510.10:FF:001018', NULL, NULL, 'Related to CBK1-Serine/threonine protein kinase involved in cell wall biosynthesis', NULL, NULL, NULL, NULL, NULL, 4),
(196062, NULL, 'G3DSA:3.80.10.10:FF:002933', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase PEPR1', NULL, NULL, NULL, NULL, NULL, 4),
(196063, NULL, 'G3DSA:3.40.50.300:FF:003765', NULL, NULL, 'ATP-binding cassette sub-family A member 3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(196064, NULL, 'G3DSA:3.90.550.10:FF:000596', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196065, NULL, 'G3DSA:2.60.40.10:FF:003057', NULL, NULL, 'AAEL000536-PA', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(196066, NULL, 'G3DSA:3.40.190.120:FF:000003', NULL, NULL, 'Glycine betaine/L-proline ABC transporter, periplasmic substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(196067, NULL, 'G3DSA:1.10.1200.60:FF:000003', NULL, NULL, '50S ribosomal protein L19e', NULL, NULL, NULL, NULL, NULL, 4),
(196068, NULL, 'G3DSA:3.40.50.150:FF:000140', NULL, NULL, 'Calmodulin-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(196069, NULL, 'G3DSA:1.10.1070.11:FF:000068', NULL, NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(196070, NULL, 'G3DSA:2.60.120.20:FF:000015', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(196071, NULL, 'G3DSA:3.40.50.300:FF:004041', NULL, NULL, 'ATP-dependent RNA helicase A', NULL, NULL, NULL, NULL, NULL, 4),
(196072, NULL, 'G3DSA:2.130.10.10:FF:001236', NULL, NULL, 'Cilia- and flagella-associated protein 251', NULL, NULL, NULL, NULL, NULL, 4),
(196073, NULL, 'G3DSA:1.20.120.1370:FF:000001', NULL, NULL, 'Regulator of sigma D', NULL, NULL, NULL, NULL, NULL, 4),
(196074, NULL, 'G3DSA:3.40.50.2000:FF:001071', NULL, NULL, 'Protein CBG08858', NULL, NULL, NULL, NULL, NULL, 4),
(196075, NULL, 'G3DSA:1.10.287.600:FF:000012', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(196076, NULL, 'G3DSA:3.30.160.20:FF:000072', NULL, NULL, 'Dicer-like 105', NULL, NULL, NULL, NULL, NULL, 4),
(196077, NULL, 'G3DSA:1.25.40.20:FF:000849', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(196078, NULL, 'G3DSA:3.30.720.210:FF:000020', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(196079, NULL, 'G3DSA:3.30.60.90:FF:000017', NULL, NULL, 'E3 ubiquitin-protein ligase KCMF1', NULL, NULL, NULL, NULL, NULL, 4),
(196080, NULL, 'G3DSA:3.30.70.330:FF:002049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196081, NULL, 'G3DSA:3.30.40.10:FF:002179', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 20', NULL, NULL, NULL, NULL, NULL, 4),
(196082, NULL, 'G3DSA:1.10.10.350:FF:000009', NULL, NULL, 'Glutamate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(196083, NULL, 'G3DSA:2.40.50.140:FF:000697', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196084, NULL, 'G3DSA:2.10.25.10:FF:000016', NULL, NULL, 'Teneurin transmembrane protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(196085, NULL, 'G3DSA:2.60.40.200:FF:000023', NULL, NULL, 'Superoxide dismutase [Cu-Zn]', NULL, NULL, NULL, NULL, NULL, 4),
(196086, NULL, 'G3DSA:3.30.160.60:FF:000853', NULL, NULL, 'zinc finger protein 205 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(196087, NULL, 'G3DSA:3.20.20.100:FF:000101', NULL, NULL, 'Probable oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(196088, NULL, 'G3DSA:2.130.10.10:FF:004327', NULL, NULL, 'UTP18 small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4),
(196089, NULL, 'G3DSA:2.60.260.20:FF:000177', NULL, NULL, 'DnaJ-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(196090, NULL, 'G3DSA:3.40.1450.10:FF:000009', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196091, NULL, 'G3DSA:3.15.20.10:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196092, NULL, 'G3DSA:1.20.1070.10:FF:002049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196093, NULL, 'G3DSA:1.25.40.10:FF:001122', NULL, NULL, 'Putative TPR repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(196094, NULL, 'G3DSA:1.25.40.90:FF:000033', NULL, NULL, 'putative clathrin assembly protein At1g33340', NULL, NULL, NULL, NULL, NULL, 4),
(196095, NULL, 'G3DSA:2.130.10.10:FF:005620', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196096, NULL, 'G3DSA:1.10.390.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196097, NULL, 'G3DSA:2.60.40.10:FF:001022', NULL, NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein', NULL, NULL, NULL, NULL, NULL, 4),
(196098, NULL, 'G3DSA:3.30.450.40:FF:000274', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(196099, NULL, 'G3DSA:3.40.50.300:FF:004726', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196100, NULL, 'G3DSA:3.10.50.10:FF:000033', NULL, NULL, 'Chitinase 12', NULL, NULL, NULL, NULL, NULL, 4),
(196101, NULL, 'G3DSA:3.50.50.60:FF:000934', NULL, NULL, 'Dihydrolipoamide dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196102, NULL, 'G3DSA:3.30.750.24:FF:000088', NULL, NULL, 'Sulfate/bicarbonate/oxalate exchanger SAT-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196103, NULL, 'G3DSA:3.40.50.720:FF:000569', NULL, NULL, 'Glyoxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(196104, NULL, 'G3DSA:1.20.1250.20:FF:002257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196105, NULL, 'G3DSA:2.60.120.200:FF:000684', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196106, NULL, 'G3DSA:2.70.150.10:FF:000147', NULL, NULL, 'Phospholipid transporting ATPase-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196107, NULL, 'G3DSA:1.10.150.20:FF:000089', NULL, NULL, 'DNA repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(196108, NULL, 'G3DSA:3.30.70.330:FF:001212', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(196109, NULL, 'G3DSA:1.10.10.10:FF:001800', NULL, NULL, 'Selenocysteine-specific translation elongation factor', NULL, NULL, NULL, NULL, NULL, 4),
(196110, NULL, 'G3DSA:2.40.50.1020:FF:000024', NULL, NULL, 'Sensory transduction protein LytT', NULL, NULL, NULL, NULL, NULL, 4),
(196111, NULL, 'G3DSA:3.40.30.10:FF:001183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196112, NULL, 'G3DSA:1.10.510.10:FF:001693', NULL, NULL, 'Serine/threonine protein kinase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(196113, NULL, 'G3DSA:1.10.10.790:FF:000012', NULL, NULL, 'G patch domain-containing protein TGH', NULL, NULL, NULL, NULL, NULL, 4),
(196114, NULL, 'G3DSA:3.30.540.10:FF:000053', NULL, NULL, 'Si:ch211-160o17.2', NULL, NULL, NULL, NULL, NULL, 4),
(196115, NULL, 'G3DSA:3.30.420.40:FF:000103', NULL, NULL, 'Heat shock 70 kDa protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(196116, NULL, 'G3DSA:3.40.50.300:FF:005002', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196117, NULL, 'G3DSA:1.10.10.10:FF:002076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196118, NULL, 'G3DSA:3.40.50.1100:FF:000295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196119, NULL, 'G3DSA:3.40.50.450:FF:000016', NULL, NULL, 'Transient receptor potential cation channel subfamily M member 2', NULL, NULL, NULL, NULL, NULL, 4),
(196120, NULL, 'G3DSA:1.20.1560.10:FF:000664', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196121, NULL, 'G3DSA:3.30.70.330:FF:000936', NULL, NULL, 'Nucleolin', NULL, NULL, NULL, NULL, NULL, 4),
(196122, NULL, 'G3DSA:1.10.472.10:FF:000182', NULL, NULL, 'Cyclin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(196123, NULL, 'G3DSA:2.30.40.10:FF:000107', NULL, NULL, 'Phosphonate metabolism protein', NULL, NULL, NULL, NULL, NULL, 4),
(196124, NULL, 'G3DSA:3.40.50.720:FF:001862', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(196125, NULL, 'G3DSA:1.10.150.50:FF:000182', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196126, NULL, 'G3DSA:3.40.50.1820:FF:001359', NULL, NULL, 'Probable 2-oxo-3-(5-oxofuran-2-ylidene)propanoate lactonase', NULL, NULL, NULL, NULL, NULL, 4),
(196127, NULL, 'G3DSA:1.10.555.10:FF:000262', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196128, NULL, 'G3DSA:3.30.1370.10:FF:000123', NULL, NULL, 'KH domain-containing, RNA-binding, signal transduction-associated protein 3 isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(196129, NULL, 'G3DSA:1.10.287.1150:FF:000021', NULL, NULL, '2-oxoglutarate dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196130, NULL, 'G3DSA:3.40.190.10:FF:000528', NULL, NULL, 'ABC transporter, periplasmic substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(196131, NULL, 'G3DSA:3.50.50.60:FF:000355', NULL, NULL, 'Sarcosine oxidase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(196132, NULL, 'G3DSA:2.60.40.60:FF:001008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196133, NULL, 'G3DSA:3.40.190.10:FF:000186', NULL, NULL, 'Phosphate-binding protein PstS 3', NULL, NULL, NULL, NULL, NULL, 4),
(196134, NULL, 'G3DSA:3.50.50.60:FF:000479', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196135, NULL, 'G3DSA:4.10.900.10:FF:000031', NULL, NULL, 'Cadherin 20', NULL, NULL, NULL, NULL, NULL, 4),
(196136, NULL, 'G3DSA:3.40.47.10:FF:000215', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196137, NULL, 'G3DSA:1.20.80.10:FF:000028', NULL, NULL, 'Focal adhesion kinase, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(196138, NULL, 'G3DSA:3.30.200.20:FF:000457', NULL, NULL, 'Microtubule-associated serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(196139, NULL, 'G3DSA:1.20.58.390:FF:000268', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196140, NULL, 'G3DSA:3.90.190.10:FF:000405', NULL, NULL, 'Probable serine/threonine-protein kinase DDB_G0277071', NULL, NULL, NULL, NULL, NULL, 4),
(196141, NULL, 'G3DSA:2.30.30.380:FF:000020', NULL, NULL, 'Secretory 24AB, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(196142, NULL, 'G3DSA:1.25.10.10:FF:001076', NULL, NULL, 'Os06g0286351 protein', NULL, NULL, NULL, NULL, NULL, 4),
(196143, NULL, 'G3DSA:3.30.230.70:FF:000053', NULL, NULL, '3 exoribonuclease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(196144, NULL, 'G3DSA:1.25.40.10:FF:001465', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(196145, NULL, 'G3DSA:2.60.40.2160:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196146, NULL, 'G3DSA:2.60.40.10:FF:003495', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196147, NULL, 'G3DSA:3.20.20.60:FF:000001', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(196148, NULL, 'G3DSA:2.10.25.10:FF:000691', NULL, NULL, 'Scavenger receptor class F, member 1', NULL, NULL, NULL, NULL, NULL, 4),
(196149, NULL, 'G3DSA:1.10.486.10:FF:000028', NULL, NULL, 'ATP-dependent helicase/nuclease subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(196150, NULL, 'G3DSA:2.130.10.10:FF:001910', NULL, NULL, 'Intraflagellar transport protein 172-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(196151, NULL, 'G3DSA:3.30.565.10:FF:000475', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196152, NULL, 'G3DSA:3.30.70.360:FF:000012', NULL, NULL, 'Putative ureidoglycolate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(196153, NULL, 'G3DSA:3.60.40.10:FF:000126', NULL, NULL, 'Related to PTC5-putative 2C protein phosphatase (PP2Cs)', NULL, NULL, NULL, NULL, NULL, 4),
(196154, NULL, 'G3DSA:3.40.50.1480:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196155, NULL, 'G3DSA:3.90.550.20:FF:000037', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196156, NULL, 'G3DSA:3.40.1110.10:FF:000304', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196157, NULL, 'G3DSA:1.10.10.60:FF:001225', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196158, NULL, 'G3DSA:2.40.10.10:FF:000526', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196159, NULL, 'G3DSA:3.30.2160.10:FF:000079', NULL, NULL, 'Ubiquitin-protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196160, NULL, 'G3DSA:1.10.472.10:FF:000524', NULL, NULL, 'Cyclin, N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(196161, NULL, 'G3DSA:1.25.10.10:FF:000676', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(196162, NULL, 'G3DSA:1.20.1250.20:FF:001296', NULL, NULL, 'Sialin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196163, NULL, 'G3DSA:3.40.50.300:FF:004384', NULL, NULL, 'Dephospho-CoA kinase', NULL, NULL, NULL, NULL, NULL, 4),
(196164, NULL, 'G3DSA:1.10.10.60:FF:000949', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(196165, NULL, 'G3DSA:1.10.400.10:FF:000066', NULL, NULL, 'G-protein subunit alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(196166, NULL, 'G3DSA:1.20.5.520:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196167, NULL, 'G3DSA:2.130.10.10:FF:000617', NULL, NULL, 'U3 small nucleolar RNA-associated protein 4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(196168, NULL, 'G3DSA:3.40.50.2000:FF:000452', NULL, NULL, 'Lipopolysaccharide core biosynthesis protein rfaG', NULL, NULL, NULL, NULL, NULL, 4),
(196169, NULL, 'G3DSA:3.30.40.10:FF:001779', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196170, NULL, 'G3DSA:1.10.10.60:FF:000606', NULL, NULL, 'Resolvase TnpR', NULL, NULL, NULL, NULL, NULL, 4),
(196171, NULL, 'G3DSA:3.30.70.260:FF:000095', NULL, NULL, 'Aspartate kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196172, NULL, 'G3DSA:1.20.5.1430:FF:000005', NULL, NULL, 'Eb1, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(196173, NULL, 'G3DSA:3.30.70.600:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196174, NULL, 'G3DSA:2.60.40.2140:FF:000001', NULL, NULL, 'Beta-1,3-glucan-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(196175, NULL, 'G3DSA:1.10.510.10:FF:000979', NULL, NULL, 'Os07g0493200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(196176, NULL, 'G3DSA:1.20.58.760:FF:000053', NULL, NULL, 'Bll8085 protein', NULL, NULL, NULL, NULL, NULL, 4),
(196177, NULL, 'G3DSA:2.40.70.10:FF:000288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196178, NULL, 'G3DSA:3.40.50.10130:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196179, NULL, 'G3DSA:3.40.720.10:FF:000222', NULL, NULL, 'N-acetylgalactosamine-6-sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(196180, NULL, 'G3DSA:3.40.50.150:FF:001101', NULL, NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(196181, NULL, 'G3DSA:3.40.50.300:FF:000674', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(196182, NULL, 'G3DSA:3.40.50.1240:FF:000196', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196183, NULL, 'G3DSA:1.10.510.10:FF:001350', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(196184, NULL, 'G3DSA:2.160.20.10:FF:000302', NULL, NULL, 'F-box protein dre-1', NULL, NULL, NULL, NULL, NULL, 4),
(196185, NULL, 'G3DSA:3.30.40.10:FF:002055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196186, NULL, 'G3DSA:3.30.200.20:FF:001418', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196187, NULL, 'G3DSA:2.60.300.12:FF:000006', NULL, NULL, 'Iron-sulfur cluster assembly 2 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(196188, NULL, 'G3DSA:3.80.10.10:FF:002372', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196189, NULL, 'G3DSA:3.40.462.20:FF:000006', NULL, NULL, 'Aspergillus niger contig An11c0010, genomic contig', NULL, NULL, NULL, NULL, NULL, 4),
(196190, NULL, 'G3DSA:1.25.40.10:FF:002426', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(196191, NULL, 'G3DSA:3.30.70.330:FF:000251', NULL, NULL, 'ras GTPase-activating protein-binding protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(196192, NULL, 'G3DSA:2.60.40.10:FF:001820', NULL, NULL, 'Basement membrane proteoglycan', NULL, NULL, NULL, NULL, NULL, 4),
(196193, NULL, 'G3DSA:3.30.70.100:FF:000199', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196194, NULL, 'G3DSA:2.30.29.30:FF:000643', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(196195, NULL, 'G3DSA:3.60.40.10:FF:000002', NULL, NULL, 'Serine/threonine phosphatase stp', NULL, NULL, NULL, NULL, NULL, 4),
(196196, NULL, 'G3DSA:3.80.10.10:FF:001972', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(196197, NULL, 'G3DSA:3.40.50.150:FF:000825', NULL, NULL, 'S-adenosylmethionine-dependent methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(196198, NULL, 'G3DSA:1.10.260.100:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196199, NULL, 'G3DSA:1.20.1080.10:FF:000077', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196200, NULL, 'G3DSA:1.10.760.10:FF:000115', NULL, NULL, 'Diheme cytochrome c-type', NULL, NULL, NULL, NULL, NULL, 4),
(196201, NULL, 'G3DSA:2.40.50.90:FF:000165', NULL, NULL, 'Staphylococcal nuclease domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(196202, NULL, 'G3DSA:3.90.15.10:FF:000004', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(196203, NULL, 'G3DSA:1.10.132.30:FF:000027', NULL, NULL, 'RNA polymerase Rpb1, domain 2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(196204, NULL, 'G3DSA:3.40.50.300:FF:005345', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196205, NULL, 'G3DSA:2.40.50.90:FF:000041', NULL, NULL, 'Tudor staphylococcal nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(196206, NULL, 'G3DSA:3.40.50.80:FF:000103', NULL, NULL, 'Ferredoxin--NADP reductase', NULL, NULL, NULL, NULL, NULL, 4),
(196207, NULL, 'G3DSA:3.40.50.300:FF:004945', NULL, NULL, 'Developmental protein DG1120', NULL, NULL, NULL, NULL, NULL, 4),
(196208, NULL, 'G3DSA:3.30.450.20:FF:000515', NULL, NULL, 'Slr1385 protein', NULL, NULL, NULL, NULL, NULL, 4),
(196209, NULL, 'G3DSA:3.40.190.290:FF:000026', NULL, NULL, 'Transcriptional regulator MvfR', NULL, NULL, NULL, NULL, NULL, 4),
(196210, NULL, 'G3DSA:3.30.2310.20:FF:000010', NULL, NULL, 'Addiction module toxin, Txe/YoeB family', NULL, NULL, NULL, NULL, NULL, 4),
(196211, NULL, 'G3DSA:1.10.532.10:FF:000018', NULL, NULL, 'Novel protein', NULL, NULL, NULL, NULL, NULL, 4),
(196212, NULL, 'G3DSA:1.10.630.10:FF:000111', NULL, NULL, 'Flavonoid 3'',5''-hydroxylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(196213, NULL, 'G3DSA:3.20.20.140:FF:000321', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196214, NULL, 'G3DSA:2.40.100.10:FF:000128', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(196215, NULL, 'G3DSA:3.60.20.10:FF:000113', NULL, NULL, 'Asparagine synthase (Glutamine-hydrolysing)', NULL, NULL, NULL, NULL, NULL, 4),
(196216, NULL, 'G3DSA:3.30.450.30:FF:000052', NULL, NULL, 'Uncharacterized protein MJ1340', NULL, NULL, NULL, NULL, NULL, 4),
(196217, NULL, 'G3DSA:1.20.1050.130:FF:000046', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196218, NULL, 'G3DSA:1.10.8.60:FF:000173', NULL, NULL, 'Cell division cycle protein 48', NULL, NULL, NULL, NULL, NULL, 4),
(196219, NULL, 'G3DSA:3.40.50.720:FF:000226', NULL, NULL, 'Dipicolinic acid synthetase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(196220, NULL, 'G3DSA:1.20.1560.10:FF:000321', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(196221, NULL, 'G3DSA:3.40.50.410:FF:000252', NULL, NULL, 'Cutl-23', NULL, NULL, NULL, NULL, NULL, 4),
(196222, NULL, 'G3DSA:3.40.50.2300:FF:000328', NULL, NULL, 'Two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(196223, NULL, 'G3DSA:3.40.50.1820:FF:000353', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(196224, NULL, 'G3DSA:3.50.50.60:FF:000277', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(196225, NULL, 'G3DSA:3.40.50.2300:FF:000424', NULL, NULL, 'Metabotropic GLutamate receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(196226, NULL, 'G3DSA:2.30.42.10:FF:000409', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196227, NULL, 'G3DSA:3.40.50.300:FF:007402', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196228, NULL, 'G3DSA:3.40.50.2300:FF:000896', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196229, NULL, 'G3DSA:1.20.1070.10:FF:000368', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196230, NULL, 'G3DSA:3.90.1180.10:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196231, NULL, 'G3DSA:3.40.50.150:FF:001062', NULL, NULL, 'Sterol 24-C-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(196232, NULL, 'G3DSA:3.10.129.10:FF:000287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196233, NULL, 'G3DSA:3.40.50.720:FF:002121', NULL, NULL, 'Os10g0553450 protein', NULL, NULL, NULL, NULL, NULL, 4),
(196234, NULL, 'G3DSA:2.130.10.10:FF:001062', NULL, NULL, 'Intraflagellar transport 122', NULL, NULL, NULL, NULL, NULL, 4),
(196235, NULL, 'G3DSA:3.30.1370.120:FF:000012', NULL, NULL, 'Secretin GspD', NULL, NULL, NULL, NULL, NULL, 4),
(196236, NULL, 'G3DSA:1.20.58.1590:FF:000008', NULL, NULL, 'Tethering factor for nuclear proteasome STS1', NULL, NULL, NULL, NULL, NULL, 4),
(196237, NULL, 'G3DSA:1.10.150.320:FF:000002', NULL, NULL, 'Competence protein ComE', NULL, NULL, NULL, NULL, NULL, 4),
(196238, NULL, 'G3DSA:2.60.40.10:FF:003175', NULL, NULL, 'hydrocephalus-inducing protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(196239, NULL, 'G3DSA:1.10.2000.10:FF:000080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196240, NULL, 'G3DSA:3.90.550.10:FF:000669', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196241, NULL, 'G3DSA:2.130.10.10:FF:004288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196242, NULL, 'G3DSA:3.30.300.130:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196243, NULL, 'G3DSA:3.30.9.10:FF:000122', NULL, NULL, 'Amino acid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(196244, NULL, 'G3DSA:1.20.900.10:FF:000063', NULL, NULL, 'Rho guanine nucleotide exchange factor (GEF) 37', NULL, NULL, NULL, NULL, NULL, 4),
(196245, NULL, 'G3DSA:1.10.238.10:FF:001127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196246, NULL, 'G3DSA:1.10.10.10:FF:001822', NULL, NULL, 'Ras guanine nucleotide exchange factor Q', NULL, NULL, NULL, NULL, NULL, 4),
(196247, NULL, 'G3DSA:1.10.630.10:FF:000105', NULL, NULL, 'Cytochrome P450 daf-9', NULL, NULL, NULL, NULL, NULL, 4),
(196248, NULL, 'G3DSA:3.40.50.300:FF:005311', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196249, NULL, 'G3DSA:2.130.10.10:FF:003832', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196250, NULL, 'G3DSA:3.40.190.10:FF:000765', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196251, NULL, 'G3DSA:2.60.120.260:FF:000376', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196252, NULL, 'G3DSA:3.40.850.10:FF:000473', NULL, NULL, 'Kinesin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196253, NULL, 'G3DSA:3.40.50.20:FF:000080', NULL, NULL, 'Carbamoyl phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(196254, NULL, 'G3DSA:1.10.510.10:FF:001086', NULL, NULL, 'Probable serine/threonine-protein kinase KKQ8', NULL, NULL, NULL, NULL, NULL, 4),
(196255, NULL, 'G3DSA:2.60.40.60:FF:000969', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196256, NULL, 'G3DSA:3.30.750.24:FF:000059', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(196257, NULL, 'G3DSA:3.30.2130.30:FF:000010', NULL, NULL, 'tRNA sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(196258, NULL, 'G3DSA:1.10.940.10:FF:000028', NULL, NULL, 'Probable ribosomal RNA small subunit methyltransferase B', NULL, NULL, NULL, NULL, NULL, 4),
(196259, NULL, 'G3DSA:3.40.50.12780:FF:000223', NULL, NULL, 'Hydroxamate-type ferrichrome siderophore peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(196260, NULL, 'G3DSA:3.30.160.60:FF:001207', NULL, NULL, 'zinc finger protein 837 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(196261, NULL, 'G3DSA:3.40.50.10980:FF:000003', NULL, NULL, 'Nibrin', NULL, NULL, NULL, NULL, NULL, 4),
(196262, NULL, 'G3DSA:1.50.10.20:FF:000071', NULL, NULL, 'Mannan endo-1,6-alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(196263, NULL, 'G3DSA:3.40.50.1820:FF:001016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196264, NULL, 'G3DSA:3.30.540.10:FF:000036', NULL, NULL, 'Fructose-1,6-bisphosphatase class 1', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(196265, NULL, 'G3DSA:3.90.1150.10:FF:000525', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196266, NULL, 'G3DSA:1.20.58.60:FF:000249', NULL, NULL, 'VAB-10B protein', NULL, NULL, NULL, NULL, NULL, 4),
(196267, NULL, 'G3DSA:3.10.450.40:FF:000003', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(196268, NULL, 'G3DSA:3.90.360.10:FF:000014', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(196269, NULL, 'G3DSA:1.25.40.20:FF:001479', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196270, NULL, 'G3DSA:1.20.1730.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196271, NULL, 'G3DSA:3.40.50.10990:FF:000006', NULL, NULL, '3,4-dihydroxy-2-butanone 4-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(196272, NULL, 'G3DSA:3.30.230.70:FF:000137', NULL, NULL, 'Exosome complex component RRP45B', NULL, NULL, NULL, NULL, NULL, 4),
(196273, NULL, 'G3DSA:1.10.510.10:FF:003177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196274, NULL, 'G3DSA:3.30.40.10:FF:000447', NULL, NULL, 'Histone-lysine N-methyltransferase MLL3', NULL, NULL, NULL, NULL, NULL, 4),
(196275, NULL, 'G3DSA:3.30.40.10:FF:001875', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196276, NULL, 'G3DSA:2.130.10.10:FF:003153', NULL, NULL, 'Vacuolar protein sorting-associated protein 41', NULL, NULL, NULL, NULL, NULL, 4),
(196277, NULL, 'G3DSA:3.30.160.60:FF:001533', NULL, NULL, 'zinc finger protein 275', NULL, NULL, NULL, NULL, NULL, 4),
(196278, NULL, 'G3DSA:1.10.287.70:FF:000302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196279, NULL, 'G3DSA:3.40.50.300:FF:006885', NULL, NULL, 'Unclassified ABC-type transport system, ATPase component', NULL, NULL, NULL, NULL, NULL, 4),
(196280, NULL, 'G3DSA:3.90.550.50:FF:000248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196281, NULL, 'G3DSA:1.10.472.10:FF:000378', NULL, NULL, 'Putative cyclin-H', NULL, NULL, NULL, NULL, NULL, 4),
(196282, NULL, 'G3DSA:4.10.240.30:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196283, NULL, 'G3DSA:1.10.10.2270:FF:000001', NULL, NULL, 'Protein transport protein TIP20', NULL, NULL, NULL, NULL, NULL, 4),
(196284, NULL, 'G3DSA:3.40.50.2300:FF:001413', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196285, NULL, 'G3DSA:1.25.40.10:FF:002578', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(196286, NULL, 'G3DSA:3.10.100.10:FF:000058', NULL, NULL, 'Sushi domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(196287, NULL, 'G3DSA:1.25.10.10:FF:002930', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196288, NULL, 'G3DSA:1.20.1250.20:FF:000469', NULL, NULL, 'Nodulin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(196289, NULL, 'G3DSA:3.40.50.410:FF:000201', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196290, NULL, 'G3DSA:1.20.1740.10:FF:000015', NULL, NULL, 'B(0,+)-type amino acid transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(196291, NULL, 'G3DSA:2.60.40.10:FF:001730', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(196292, NULL, 'G3DSA:3.40.50.10190:FF:000305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196293, NULL, 'G3DSA:3.30.559.10:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196294, NULL, 'G3DSA:3.60.40.10:FF:000143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196295, NULL, 'G3DSA:1.25.10.10:FF:000985', NULL, NULL, 'HEAT repeat domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(196296, NULL, 'G3DSA:1.20.1250.20:FF:002240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196297, NULL, 'G3DSA:3.60.110.10:FF:000070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196298, NULL, 'G3DSA:3.40.50.1360:FF:000018', NULL, NULL, 'Deoxyribonucleoside regulator', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(196299, NULL, 'G3DSA:3.60.21.10:FF:000397', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196300, NULL, 'G3DSA:1.20.142.10:FF:000014', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(196301, NULL, 'G3DSA:2.60.120.650:FF:000077', NULL, NULL, 'Multicopy suppressor of chk1 protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(196302, NULL, 'G3DSA:3.30.70.330:FF:002572', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196303, NULL, 'G3DSA:1.10.510.10:FF:001732', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(196304, NULL, 'G3DSA:3.30.710.10:FF:000162', NULL, NULL, 'Centrosome-associated zinc finger protein CP190', NULL, NULL, NULL, NULL, NULL, 4),
(196305, NULL, 'G3DSA:1.25.10.10:FF:001502', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196306, NULL, 'G3DSA:2.60.110.10:FF:000017', NULL, NULL, 'Osmotin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(196307, NULL, 'G3DSA:2.60.200.30:FF:000002', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(196308, NULL, 'G3DSA:1.25.40.20:FF:001007', NULL, NULL, 'ankyrin repeat domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(196309, NULL, 'G3DSA:3.40.50.300:FF:002877', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196310, NULL, 'G3DSA:3.40.50.1220:FF:000061', NULL, NULL, 'NAD-dependent protein deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(196311, NULL, 'G3DSA:2.30.29.30:FF:000542', NULL, NULL, 'Inner membrane complex sub-compartment protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(196312, NULL, 'G3DSA:3.40.1110.10:FF:000102', NULL, NULL, 'Copper-transporting ATPase HMA5', NULL, NULL, NULL, NULL, NULL, 4),
(196313, NULL, 'G3DSA:3.40.50.2000:FF:000924', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(196314, NULL, 'G3DSA:2.60.40.1170:FF:000019', NULL, NULL, 'AP-4 complex subunit mu-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(196315, NULL, 'G3DSA:3.40.50.300:FF:001449', NULL, NULL, 'DNA repair and recombination protein RAD54', NULL, NULL, NULL, NULL, NULL, 4),
(196316, NULL, 'G3DSA:3.40.850.10:FF:000147', NULL, NULL, 'kinesin-like protein CG14535', NULL, NULL, NULL, NULL, NULL, 4),
(196317, NULL, 'G3DSA:1.25.40.10:FF:001004', NULL, NULL, 'Protein PTCD3 homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(196318, NULL, 'G3DSA:1.20.140.150:FF:000059', NULL, NULL, 'Transmembrane protein 114', NULL, NULL, NULL, NULL, NULL, 4),
(196319, NULL, 'G3DSA:1.10.418.10:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196320, NULL, 'G3DSA:2.40.30.30:FF:000033', NULL, NULL, 'Bifunctional riboflavin kinase/FMN adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(196321, NULL, 'G3DSA:2.60.200.40:FF:000005', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(196322, NULL, 'G3DSA:3.40.50.300:FF:004794', NULL, NULL, 'Guanylate kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196323, NULL, 'G3DSA:3.80.10.10:FF:001287', NULL, NULL, 'Nuclear RNA export factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(196324, NULL, 'G3DSA:3.40.50.1240:FF:000067', NULL, NULL, 'Probable conserved lipoprotein LpqD', NULL, NULL, NULL, NULL, NULL, 4),
(196325, NULL, 'G3DSA:1.20.1050.10:FF:000159', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(196326, NULL, 'G3DSA:2.60.40.150:FF:000738', NULL, NULL, 'Type III restriction enzyme, res subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(196327, NULL, 'G3DSA:3.90.25.10:FF:000005', NULL, NULL, 'GDP-mannose 4,6 dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(196328, NULL, 'G3DSA:3.30.2350.10:FF:000009', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(196329, NULL, 'G3DSA:3.30.310.80:FF:000028', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(196330, NULL, 'G3DSA:1.20.58.1030:FF:000009', NULL, NULL, 'DNA replication complex GINS protein SLD5', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(196331, NULL, 'G3DSA:3.40.50.620:FF:000146', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(196332, NULL, 'G3DSA:3.30.450.20:FF:000066', NULL, NULL, 'Period circadian protein', NULL, NULL, NULL, NULL, NULL, 4),
(196333, NULL, 'G3DSA:3.40.50.11350:FF:000013', NULL, NULL, 'L-Fucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(196334, NULL, 'G3DSA:3.30.70.2850:FF:000013', NULL, NULL, 'DNA-directed RNA polymerase I subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(196335, NULL, 'G3DSA:1.25.40.90:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196336, NULL, 'G3DSA:3.10.430.100:FF:000004', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(196337, NULL, 'G3DSA:3.30.70.1390:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196338, NULL, 'G3DSA:3.40.47.10:FF:000283', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196339, NULL, 'G3DSA:2.40.50.140:FF:001006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196340, NULL, 'G3DSA:3.40.50.300:FF:007109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196341, NULL, 'G3DSA:3.40.50.2300:FF:000750', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196342, NULL, 'G3DSA:1.20.1560.10:FF:000243', NULL, NULL, 'ABC transporter (MsbA subfamily)', NULL, NULL, NULL, NULL, NULL, 4),
(196343, NULL, 'G3DSA:3.40.50.1820:FF:000027', NULL, NULL, 'Esterase YqiA', NULL, NULL, NULL, NULL, NULL, 4),
(196344, NULL, 'G3DSA:1.10.510.10:FF:003031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196345, NULL, 'G3DSA:1.10.510.10:FF:002867', NULL, NULL, 'Chromosomal serine/threonine-protein kinase JIL-1', NULL, NULL, NULL, NULL, NULL, 4),
(196346, NULL, 'G3DSA:1.20.58.60:FF:000542', NULL, NULL, 'Calponin homology domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(196347, NULL, 'G3DSA:3.40.50.720:FF:002267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196348, NULL, 'G3DSA:3.40.50.11340:FF:000010', NULL, NULL, 'Probable fucosyltransferase 5', NULL, NULL, NULL, NULL, NULL, 4),
(196349, NULL, 'G3DSA:1.10.260.30:FF:000010', NULL, NULL, 'BnaCnng10600D protein', NULL, NULL, NULL, NULL, NULL, 4),
(196350, NULL, 'G3DSA:3.30.160.60:FF:002961', NULL, NULL, 'Zinc finger domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(196351, NULL, 'G3DSA:3.10.50.10:FF:000022', NULL, NULL, 'AGAP001863-PA', NULL, NULL, NULL, NULL, NULL, 4),
(196352, NULL, 'G3DSA:2.40.50.120:FF:000011', NULL, NULL, 'Secreted frizzled-related sequence protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(196353, NULL, 'G3DSA:3.30.160.60:FF:003450', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196354, NULL, 'G3DSA:3.40.50.200:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196355, NULL, 'G3DSA:1.10.405.20:FF:000001', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(196356, NULL, 'G3DSA:3.10.350.10:FF:000043', NULL, NULL, 'Lipoprotein NlpD', NULL, NULL, NULL, NULL, NULL, 4),
(196357, NULL, 'G3DSA:1.10.10.60:FF:001051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196358, NULL, 'G3DSA:2.20.70.10:FF:000216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196359, NULL, 'G3DSA:3.40.50.960:FF:000017', NULL, NULL, '6,7-dimethyl-8-ribityllumazine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(196360, NULL, 'G3DSA:1.10.12.10:FF:000023', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(196361, NULL, 'G3DSA:1.20.1510.10:FF:000032', NULL, NULL, 'Zinc transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196362, NULL, 'G3DSA:1.20.5.1190:FF:000012', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(196363, NULL, 'G3DSA:1.20.1250.20:FF:001897', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196364, NULL, 'G3DSA:1.20.5.170:FF:000034', NULL, NULL, 'Nucleoporin P54, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196365, NULL, 'G3DSA:3.40.50.1820:FF:001781', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(196366, NULL, 'G3DSA:3.40.50.2000:FF:000278', NULL, NULL, 'Glycogen synthase', NULL, NULL, NULL, NULL, NULL, 4),
(196367, NULL, 'G3DSA:1.20.120.1750:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196368, NULL, 'G3DSA:1.20.1070.10:FF:001211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196369, NULL, 'G3DSA:2.60.40.10:FF:004956', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196370, NULL, 'G3DSA:1.10.260.40:FF:000013', NULL, NULL, 'POU domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(196371, NULL, 'G3DSA:3.30.160.60:FF:005541', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196372, NULL, 'G3DSA:1.20.1070.10:FF:001796', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196373, NULL, 'G3DSA:2.40.50.90:FF:000120', NULL, NULL, 'Endonuclease domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(196374, NULL, 'G3DSA:3.90.190.10:FF:000540', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196375, NULL, 'G3DSA:3.50.50.60:FF:000956', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(196376, NULL, 'G3DSA:1.20.1440.180:FF:000003', NULL, NULL, 'Ribonuclease L', NULL, NULL, NULL, NULL, NULL, 4),
(196377, NULL, 'G3DSA:1.10.10.650:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196378, NULL, 'G3DSA:3.80.10.10:FF:000831', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(196379, NULL, 'G3DSA:3.40.50.150:FF:001415', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196380, NULL, 'G3DSA:1.10.10.60:FF:000887', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196381, NULL, 'G3DSA:2.60.220.50:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196382, NULL, 'G3DSA:1.10.630.10:FF:000370', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196383, NULL, 'G3DSA:3.40.50.10890:FF:000009', NULL, NULL, 'Cleavage and polyadenylation specificity factor, 73 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(196384, NULL, 'G3DSA:3.40.50.150:FF:000926', NULL, NULL, 'Putative trna and rrna cytosine-c5-methylase nucleolar protein nol1/nop2', NULL, NULL, NULL, NULL, NULL, 4),
(196385, NULL, 'G3DSA:2.60.40.10:FF:002865', NULL, NULL, 'HERV-H LTR-associating 2b, tandem duplicate 2', NULL, NULL, NULL, NULL, NULL, 4),
(196386, NULL, 'G3DSA:2.170.130.10:FF:000015', NULL, NULL, 'Ligand-gated channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(196387, NULL, 'G3DSA:1.10.510.10:FF:002188', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196388, NULL, 'G3DSA:3.40.50.1000:FF:000607', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196389, NULL, 'G3DSA:1.20.910.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196390, NULL, 'G3DSA:2.40.50.140:FF:000517', NULL, NULL, 'Cold-shock protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196391, NULL, 'G3DSA:1.10.510.10:FF:001406', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(196392, NULL, 'G3DSA:1.25.10.10:FF:000659', NULL, NULL, 'PDS5p Cohesion maintenance factor', NULL, NULL, NULL, NULL, NULL, 4),
(196393, NULL, 'G3DSA:3.90.190.10:FF:000040', NULL, NULL, 'mRNA-capping enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(196394, NULL, 'G3DSA:3.30.70.330:FF:000329', NULL, NULL, 'splicing factor U2AF-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(196395, NULL, 'G3DSA:1.25.40.20:FF:001333', NULL, NULL, 'Ankyrin repeat-containing protein C105.02c', NULL, NULL, NULL, NULL, NULL, 4),
(196396, NULL, 'G3DSA:2.120.10.80:FF:000335', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196397, NULL, 'G3DSA:2.130.10.10:FF:002989', NULL, NULL, 'Dynein axonemal intermediate chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(196398, NULL, 'G3DSA:3.30.559.10:FF:000028', NULL, NULL, 'Yat2p', NULL, NULL, NULL, NULL, NULL, 4),
(196399, NULL, 'G3DSA:1.20.1250.20:FF:001397', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(196400, NULL, 'G3DSA:3.40.50.11660:FF:000016', NULL, NULL, '4-galactosyl-N-acetylglucosaminide 3-alpha-L-fucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(196401, NULL, 'G3DSA:1.25.10.10:FF:003240', NULL, NULL, 'Protein CELLULOSE SYNTHASE INTERACTIVE 3', NULL, NULL, NULL, NULL, NULL, 4),
(196402, NULL, 'G3DSA:3.30.40.10:FF:001549', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196403, NULL, 'G3DSA:3.40.50.300:FF:004468', NULL, NULL, 'Putative disease resistance protein At3g14460', NULL, NULL, NULL, NULL, NULL, 4),
(196404, NULL, 'G3DSA:1.25.40.10:FF:001330', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g50420', NULL, NULL, NULL, NULL, NULL, 4),
(196405, NULL, 'G3DSA:2.130.10.10:FF:002843', NULL, NULL, 'actin-related protein 2/3 complex subunit 1A', NULL, NULL, NULL, NULL, NULL, 4),
(196406, NULL, 'G3DSA:3.40.1380.20:FF:000040', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(196407, NULL, 'G3DSA:3.30.70.2120:FF:000002', NULL, NULL, 'Flagellar hook protein FlgE', NULL, NULL, NULL, NULL, NULL, 4),
(196408, NULL, 'G3DSA:3.40.190.290:FF:000133', NULL, NULL, 'Transcriptional regulator LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(196409, NULL, 'G3DSA:2.10.50.10:FF:000002', NULL, NULL, 'signal peptide, CUB and EGF-like domain-containing protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(196410, NULL, 'G3DSA:3.30.450.20:FF:000127', NULL, NULL, 'C4-dicarboxylate transport sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(196411, NULL, 'G3DSA:3.40.50.720:FF:002328', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196412, NULL, 'G3DSA:2.20.110.10:FF:000077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196413, NULL, 'G3DSA:3.80.10.10:FF:000359', NULL, NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', NULL, NULL, NULL, NULL, NULL, 4),
(196414, NULL, 'G3DSA:1.20.1560.10:FF:000922', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196415, NULL, 'G3DSA:3.40.1280.10:FF:000086', NULL, NULL, 'tRNA (Cytidine/uridine-2''-O-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(196416, NULL, 'G3DSA:2.60.40.10:FF:001084', NULL, NULL, 'obscurin-like isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(196417, NULL, 'G3DSA:3.10.129.10:FF:000141', NULL, NULL, '4-hydroxybenzoyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(196418, NULL, 'G3DSA:2.40.70.10:FF:000406', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196419, NULL, 'G3DSA:3.40.50.300:FF:000140', NULL, NULL, 'Lipid A export ATP-binding/permease protein MsbA', NULL, NULL, NULL, NULL, NULL, 4),
(196420, NULL, 'G3DSA:1.20.58.60:FF:000042', NULL, NULL, 'Short stop, isoform N', NULL, NULL, NULL, NULL, NULL, 4),
(196421, NULL, 'G3DSA:1.25.40.10:FF:003421', NULL, NULL, 'Sll1384 protein', NULL, NULL, NULL, NULL, NULL, 4),
(196422, NULL, 'G3DSA:3.30.190.20:FF:000028', NULL, NULL, 'Ribosomal L1 domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(196423, NULL, 'G3DSA:3.30.160.60:FF:003950', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196424, NULL, 'G3DSA:1.20.58.1310:FF:000003', NULL, NULL, 'Rop guanine nucleotide exchange factor 7', NULL, NULL, NULL, NULL, NULL, 4),
(196425, NULL, 'G3DSA:3.40.50.720:FF:000176', NULL, NULL, 'Probable ion channel POLLUX', NULL, NULL, NULL, NULL, NULL, 4),
(196426, NULL, 'G3DSA:3.30.230.10:FF:000226', NULL, NULL, 'DNA mismatch repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196427, NULL, 'G3DSA:3.10.100.10:FF:000384', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196428, NULL, 'G3DSA:2.130.10.10:FF:004934', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(196429, NULL, 'G3DSA:2.60.40.10:FF:001404', NULL, NULL, 'Erythrocyte membrane protein band 4.2', NULL, NULL, NULL, NULL, NULL, 4),
(196430, NULL, 'G3DSA:1.20.58.1020:FF:000006', NULL, NULL, 'DNA replication complex GINS protein PSF2', NULL, NULL, NULL, NULL, NULL, 4),
(196431, NULL, 'G3DSA:3.30.200.20:FF:000727', NULL, NULL, 'Cysteine-rich RLK (RECEPTOR-like protein kinase) 23', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(196432, NULL, 'G3DSA:3.30.200.20:FF:002498', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(196433, NULL, 'G3DSA:3.30.470.10:FF:000007', NULL, NULL, 'Aminodeoxychorismate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(196434, NULL, 'G3DSA:2.60.120.200:FF:000465', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196435, NULL, 'G3DSA:3.40.850.10:FF:000208', NULL, NULL, 'kinesin-like protein KIF21B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(196436, NULL, 'G3DSA:3.30.160.60:FF:001180', NULL, NULL, 'Zinc finger protein 366', NULL, NULL, NULL, NULL, NULL, 4),
(196437, NULL, 'G3DSA:3.80.10.10:FF:003439', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196438, NULL, 'G3DSA:2.30.29.30:FF:000249', NULL, NULL, 'Capping protein regulator and myosin 1 linker 2', NULL, NULL, NULL, NULL, NULL, 4),
(196439, NULL, 'G3DSA:3.30.160.60:FF:003124', NULL, NULL, 'zinc finger protein 622', NULL, NULL, NULL, NULL, NULL, 4),
(196440, NULL, 'G3DSA:1.25.40.10:FF:000987', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g14330', NULL, NULL, NULL, NULL, NULL, 4),
(196441, NULL, 'G3DSA:3.40.50.300:FF:006946', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196442, NULL, 'G3DSA:1.25.40.180:FF:000241', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196443, NULL, 'G3DSA:3.80.10.10:FF:004193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196444, NULL, 'G3DSA:1.10.10.2570:FF:000001', NULL, NULL, 'Autophagy-related protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(196445, NULL, 'G3DSA:3.40.50.620:FF:000472', NULL, NULL, 'Queuosine synthesis-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(196446, NULL, 'G3DSA:3.30.1520.10:FF:000135', NULL, NULL, 'Putative nischarin modulator of integrin alpha5 subunit action', NULL, NULL, NULL, NULL, NULL, 4),
(196447, NULL, 'G3DSA:2.60.40.10:FF:002539', NULL, NULL, 'Zwei Ig domain protein zig-8', NULL, NULL, NULL, NULL, NULL, 4),
(196448, NULL, 'G3DSA:3.40.390.10:FF:000128', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(196449, NULL, 'G3DSA:3.30.70.330:FF:000981', NULL, NULL, 'NPL3p RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(196450, NULL, 'G3DSA:1.25.40.10:FF:000807', NULL, NULL, 'Os03g0735200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(196451, NULL, 'G3DSA:3.40.50.150:FF:000898', NULL, NULL, 'RNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(196452, NULL, 'G3DSA:2.30.39.10:FF:000036', NULL, NULL, 'Putative non-inhibitory serpin-10', NULL, NULL, NULL, NULL, NULL, 4),
(196453, NULL, 'G3DSA:1.10.8.10:FF:000321', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(196454, NULL, 'G3DSA:1.10.1370.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196455, NULL, 'G3DSA:2.60.40.2030:FF:000053', NULL, NULL, 'Adhesion G-protein coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(196456, NULL, 'G3DSA:1.10.40.30:FF:000021', NULL, NULL, 'Fumarate hydratase class II', NULL, NULL, NULL, NULL, NULL, 4),
(196457, NULL, 'G3DSA:3.30.2010.10:FF:000018', NULL, NULL, 'Peptidase family M48', NULL, NULL, NULL, NULL, NULL, 4),
(196458, NULL, 'G3DSA:2.60.120.200:FF:000818', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196459, NULL, 'G3DSA:3.40.50.720:FF:000204', NULL, NULL, 'Inositol-3-phosphate synthase 1-B', NULL, NULL, NULL, NULL, NULL, 4),
(196460, NULL, 'G3DSA:2.60.40.820:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196461, NULL, 'G3DSA:1.20.58.1280:FF:000005', NULL, NULL, 'DNA repair protein REV1', NULL, NULL, NULL, NULL, NULL, 4),
(196462, NULL, 'G3DSA:1.10.472.90:FF:000003', NULL, NULL, 'Pyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(196463, NULL, 'G3DSA:3.30.160.60:FF:004698', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196464, NULL, 'G3DSA:2.60.120.650:FF:000105', NULL, NULL, 'JmjC domain-containing histone demethylase, putative', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(196465, NULL, 'G3DSA:3.60.40.10:FF:000204', NULL, NULL, 'Protein phosphatase, Mg2+/Mn2+-dependent, 1J', NULL, NULL, NULL, NULL, NULL, 4),
(196466, NULL, 'G3DSA:2.30.30.100:FF:000043', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm7', NULL, NULL, NULL, NULL, NULL, 4),
(196467, NULL, 'G3DSA:3.40.50.80:FF:000165', NULL, NULL, 'Ferric-chelate reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196468, NULL, 'G3DSA:3.40.50.300:FF:001921', NULL, NULL, 'AAA ATPase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(196469, NULL, 'G3DSA:2.60.120.10:FF:000254', NULL, NULL, 'Cysteine dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(196470, NULL, 'G3DSA:2.30.230.10:FF:000033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196471, NULL, 'G3DSA:2.60.200.20:FF:000258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196472, NULL, 'G3DSA:2.40.50.140:FF:000843', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196473, NULL, 'G3DSA:1.10.510.10:FF:002688', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196474, NULL, 'G3DSA:3.40.50.300:FF:001096', NULL, NULL, 'Zinc finger NFX1-type containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(196475, NULL, 'G3DSA:3.40.50.720:FF:001957', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196476, NULL, 'G3DSA:2.130.10.10:FF:000898', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196477, NULL, 'G3DSA:2.20.100.10:FF:000133', NULL, NULL, 'Complement factor properdin', NULL, NULL, NULL, NULL, NULL, 4),
(196478, NULL, 'G3DSA:3.90.190.20:FF:000043', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(196479, NULL, 'G3DSA:1.20.1070.10:FF:000194', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(196480, NULL, 'G3DSA:3.40.1110.10:FF:000309', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196481, NULL, 'G3DSA:3.90.830.10:FF:000005', NULL, NULL, 'Sec1 family superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(196482, NULL, 'G3DSA:4.10.1060.10:FF:000002', NULL, NULL, 'RNA-binding protein EWS isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(196483, NULL, 'G3DSA:2.60.40.10:FF:004338', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196484, NULL, 'G3DSA:3.50.50.60:FF:001092', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(196485, NULL, 'G3DSA:3.30.200.20:FF:001250', NULL, NULL, 'Probable myosin light chain kinase DDB_G0275057', NULL, NULL, NULL, NULL, NULL, 4),
(196486, NULL, 'G3DSA:2.60.40.2440:FF:000001', NULL, NULL, 'Protein phosphatase 1 regulatory subunit 3C', NULL, NULL, NULL, NULL, NULL, 4),
(196487, NULL, 'G3DSA:1.10.510.10:FF:001586', NULL, NULL, 'Aurora kinase B', NULL, NULL, NULL, NULL, NULL, 4),
(196488, NULL, 'G3DSA:1.10.150.60:FF:000016', NULL, NULL, 'Putative Lysine-specific demethylase 5B', NULL, NULL, NULL, NULL, NULL, 4),
(196489, NULL, 'G3DSA:3.40.50.720:FF:000822', NULL, NULL, 'BnaA06g02810D protein', NULL, NULL, NULL, NULL, NULL, 4),
(196490, NULL, 'G3DSA:1.10.150.50:FF:000013', NULL, NULL, 'Protein Smaug homolog 1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(196491, NULL, 'G3DSA:3.30.200.20:FF:001542', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196492, NULL, 'G3DSA:1.10.287.70:FF:000448', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196493, NULL, 'G3DSA:3.30.70.330:FF:002600', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196494, NULL, 'G3DSA:1.20.1560.10:FF:000422', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196495, NULL, 'G3DSA:2.130.10.10:FF:001915', NULL, NULL, 'Sema domain, immunoglobulin domain (Ig), short basic domain, secreted, (Semaphorin) 3F', NULL, NULL, NULL, NULL, NULL, 4),
(196496, NULL, 'G3DSA:3.90.170.10:FF:000005', NULL, NULL, 'Adenylosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(196497, NULL, 'G3DSA:3.20.20.100:FF:000051', NULL, NULL, 'Putative pyridoxal reductase (AKR8)', NULL, NULL, NULL, NULL, NULL, 4),
(196498, NULL, 'G3DSA:1.20.58.760:FF:000031', NULL, NULL, 'FtsH-like AAA+ protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(196499, NULL, 'G3DSA:1.10.10.350:FF:000021', NULL, NULL, 'Glutamate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(196500, NULL, 'G3DSA:1.20.1070.10:FF:000840', NULL, NULL, 'tachykinin receptor isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(196501, NULL, 'G3DSA:1.25.40.10:FF:005012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196502, NULL, 'G3DSA:3.80.10.10:FF:001202', NULL, NULL, 'Gastrulation-defective protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(196503, NULL, 'G3DSA:3.30.160.20:FF:000026', NULL, NULL, 'ATP-dependent RNA helicase A', NULL, NULL, NULL, NULL, NULL, 4),
(196504, NULL, 'G3DSA:3.30.420.40:FF:000957', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(196505, NULL, 'G3DSA:2.60.40.60:FF:000469', NULL, NULL, 'Cadherin-related family member 5', NULL, NULL, NULL, NULL, NULL, 4),
(196506, NULL, 'G3DSA:3.40.1110.10:FF:000074', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(196507, NULL, 'G3DSA:3.40.50.410:FF:000055', NULL, NULL, 'X-ray repair cross-complementing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(196508, NULL, 'G3DSA:3.90.1150.10:FF:000464', NULL, NULL, 'Glutamine--scyllo-inositol transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(196509, NULL, 'G3DSA:2.60.120.260:FF:000437', NULL, NULL, 'Beta-galactosidase BoGH2A', NULL, NULL, NULL, NULL, NULL, 4),
(196510, NULL, 'G3DSA:1.25.40.470:FF:000030', NULL, NULL, 'Intraflagellar transport protein osm-1', NULL, NULL, NULL, NULL, NULL, 4),
(196511, NULL, 'G3DSA:3.40.50.1820:FF:000292', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(196512, NULL, 'G3DSA:3.30.50.10:FF:000066', NULL, NULL, 'Hormone receptor 83', NULL, NULL, NULL, NULL, NULL, 4),
(196513, NULL, 'G3DSA:3.40.50.300:FF:003074', NULL, NULL, 'GTP-binding protein TEM1', NULL, NULL, NULL, NULL, NULL, 4),
(196514, NULL, 'G3DSA:3.40.50.10490:FF:000070', NULL, NULL, 'MurR/RpiR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(196515, NULL, 'G3DSA:1.20.1530.20:FF:000098', NULL, NULL, 'Putative sodium/metabolite cotransporter BASS4 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(196516, NULL, 'G3DSA:3.30.830.10:FF:000255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196517, NULL, 'G3DSA:2.60.40.10:FF:000302', NULL, NULL, 'Down syndrome cell adhesion molecule, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(196518, NULL, 'G3DSA:1.20.1550.10:FF:000006', NULL, NULL, 'Disulfide bond formation protein B', NULL, NULL, NULL, NULL, NULL, 4),
(196519, NULL, 'G3DSA:2.30.42.10:FF:000089', NULL, NULL, 'multiple PDZ domain protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(196520, NULL, 'G3DSA:1.25.40.10:FF:004495', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196521, NULL, 'G3DSA:3.40.50.300:FF:005457', NULL, NULL, 'ABC multidrug transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(196522, NULL, 'G3DSA:3.40.50.2300:FF:000924', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196523, NULL, 'G3DSA:3.40.50.1820:FF:001808', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196524, NULL, 'G3DSA:1.10.10.750:FF:000051', NULL, NULL, 'AAR091Wp', NULL, NULL, NULL, NULL, NULL, 4),
(196525, NULL, 'G3DSA:3.10.390.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196526, NULL, 'G3DSA:3.40.50.300:FF:004968', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196527, NULL, 'G3DSA:3.40.50.150:FF:001562', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196528, NULL, 'G3DSA:1.10.10.2590:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196529, NULL, 'G3DSA:3.40.50.720:FF:000530', NULL, NULL, 'D-amino acid oxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196530, NULL, 'G3DSA:3.40.50.2000:FF:000750', NULL, NULL, 'Capsular polysaccharide biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(196531, NULL, 'G3DSA:3.30.70.330:FF:000655', NULL, NULL, 'serine/arginine-rich splicing factor RS41 isoform X2', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(196532, NULL, 'G3DSA:3.40.50.10090:FF:000040', NULL, NULL, 'Porphyrin biosynthesis protein [includes: uroporphyrin-III C-methyltransferase and uroporphyrinogen-III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(196533, NULL, 'G3DSA:3.30.450.20:FF:000453', NULL, NULL, 'Calcium voltage-gated channel auxiliary subunit alpha2delta 1', NULL, NULL, NULL, NULL, NULL, 4),
(196534, NULL, 'G3DSA:2.60.40.420:FF:000196', NULL, NULL, 'Cytochrome B', NULL, NULL, NULL, NULL, NULL, 4),
(196535, NULL, 'G3DSA:3.30.40.10:FF:000094', NULL, NULL, 'E3 ubiquitin-protein ligase MIB2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(196536, NULL, 'G3DSA:3.30.505.10:FF:000258', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196537, NULL, 'G3DSA:1.10.238.10:FF:000817', NULL, NULL, 'EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(196538, NULL, 'G3DSA:1.20.1250.20:FF:000262', NULL, NULL, 'Efflux MFS transporter YdeE', NULL, NULL, NULL, NULL, NULL, 4),
(196539, NULL, 'G3DSA:1.25.40.10:FF:003067', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g62890', NULL, NULL, NULL, NULL, NULL, 4),
(196540, NULL, 'G3DSA:3.90.1150.10:FF:000172', NULL, NULL, 'Kynureninase', NULL, NULL, NULL, NULL, NULL, 4),
(196541, NULL, 'G3DSA:3.30.70.330:FF:000801', NULL, NULL, 'U4/U6 snRNA-associated-splicing factor,putative', NULL, NULL, NULL, NULL, NULL, 4),
(196542, NULL, 'G3DSA:3.40.50.300:FF:007609', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196543, NULL, 'G3DSA:1.25.40.470:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196544, NULL, 'G3DSA:3.30.40.10:FF:000240', NULL, NULL, 'Nitric oxide synthase-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(196545, NULL, 'G3DSA:1.20.140.10:FF:000032', NULL, NULL, 'Thermophilic desulfurizing enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(196546, NULL, 'G3DSA:3.40.190.10:FF:000826', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196547, NULL, 'G3DSA:3.30.710.10:FF:000336', NULL, NULL, 'Zinc finger and BTB domain-containing 41', NULL, NULL, NULL, NULL, NULL, 4),
(196548, NULL, 'G3DSA:1.25.40.10:FF:000515', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(196549, NULL, 'G3DSA:2.70.220.10:FF:000001', NULL, NULL, 'GM2 ganglioside activator protein', NULL, NULL, NULL, NULL, NULL, 4),
(196550, NULL, 'G3DSA:3.40.50.12780:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196551, NULL, 'G3DSA:2.60.40.10:FF:005153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196552, NULL, 'G3DSA:3.30.230.10:FF:000198', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(196553, NULL, 'G3DSA:3.30.420.40:FF:000396', NULL, NULL, 'Actin, alpha 2, smooth muscle, aorta', NULL, NULL, NULL, NULL, NULL, 4),
(196554, NULL, 'G3DSA:3.30.200.20:FF:000699', NULL, NULL, 'Serine/threonine-protein kinase RAD53', NULL, NULL, NULL, NULL, NULL, 4),
(196555, NULL, 'G3DSA:1.10.238.10:FF:000790', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196556, NULL, 'G3DSA:1.20.1270.60:FF:000224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196557, NULL, 'G3DSA:3.40.640.10:FF:000373', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196558, NULL, 'G3DSA:2.60.120.830:FF:000007', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(196559, NULL, 'G3DSA:3.90.20.20:FF:000019', NULL, NULL, 'Protein GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(196560, NULL, 'G3DSA:3.30.70.3490:FF:000025', NULL, NULL, 'Oxysterol binding protein 5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196561, NULL, 'G3DSA:1.20.970.10:FF:000011', NULL, NULL, 'Thymidine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(196562, NULL, 'G3DSA:3.30.70.270:FF:000204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196563, NULL, 'G3DSA:1.10.287.70:FF:000241', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(196564, NULL, 'G3DSA:1.10.630.10:FF:000605', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196565, NULL, 'G3DSA:1.25.40.10:FF:004169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196566, NULL, 'G3DSA:1.10.10.10:FF:001204', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(196567, NULL, 'G3DSA:1.10.510.10:FF:003205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196568, NULL, 'G3DSA:3.30.300.30:FF:000035', NULL, NULL, 'L-2-aminoadipate reductase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(196569, NULL, 'G3DSA:3.40.390.10:FF:000280', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196570, NULL, 'G3DSA:1.20.1070.10:FF:000222', NULL, NULL, 'Adhesion G protein-coupled receptor G3', NULL, NULL, NULL, NULL, NULL, 4),
(196571, NULL, 'G3DSA:1.10.510.10:FF:000743', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196572, NULL, 'G3DSA:3.40.50.360:FF:000051', NULL, NULL, 'FMN-dependent NADPH-azoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(196573, NULL, 'G3DSA:2.130.10.10:FF:005070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196574, NULL, 'G3DSA:3.80.10.10:FF:000185', NULL, NULL, 'Podocan', NULL, NULL, NULL, NULL, NULL, 4),
(196575, NULL, 'G3DSA:3.40.718.10:FF:000020', NULL, NULL, 'Isocitrate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(196576, NULL, 'G3DSA:3.30.70.330:FF:001111', NULL, NULL, '31 kDa ribonucleoprotein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(196577, NULL, 'G3DSA:1.25.40.120:FF:000004', NULL, NULL, 'Protein farnesyltransferase/geranylgeranyltransferase type-1 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(196578, NULL, 'G3DSA:3.30.710.10:FF:000515', NULL, NULL, 'Protein CBG12958', NULL, NULL, NULL, NULL, NULL, 4),
(196579, NULL, 'G3DSA:4.10.240.10:FF:000002', NULL, NULL, 'Zn cluster transcription factor Rds2', NULL, NULL, NULL, NULL, NULL, 4),
(196580, NULL, 'G3DSA:2.40.180.10:FF:000009', NULL, NULL, 'Lipoxygenase homology domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(196581, NULL, 'G3DSA:3.30.70.330:FF:002246', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196582, NULL, 'G3DSA:3.40.50.300:FF:006385', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196583, NULL, 'G3DSA:2.10.25.10:FF:000522', NULL, NULL, 'Notch receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(196584, NULL, 'G3DSA:2.120.10.30:FF:000427', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196585, NULL, 'G3DSA:2.60.40.10:FF:000948', NULL, NULL, 'Roundabout 1', NULL, NULL, NULL, NULL, NULL, 4),
(196586, NULL, 'G3DSA:2.30.30.40:FF:000031', NULL, NULL, 'SH3 and PX domain-containing protein 2A', NULL, NULL, NULL, NULL, NULL, 4),
(196587, NULL, 'G3DSA:3.30.260.10:FF:000054', NULL, NULL, 'T-complex protein 1 subunit zeta', NULL, NULL, NULL, NULL, NULL, 4),
(196588, NULL, 'G3DSA:1.20.1720.10:FF:000132', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196589, NULL, 'G3DSA:3.30.430.20:FF:000036', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 25', NULL, NULL, NULL, NULL, NULL, 4),
(196590, NULL, 'G3DSA:3.30.40.10:FF:000801', NULL, NULL, 'PIB2p protein', NULL, NULL, NULL, NULL, NULL, 4),
(196591, NULL, 'G3DSA:1.25.10.10:FF:002458', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196592, NULL, 'G3DSA:1.10.510.10:FF:004020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196593, NULL, 'G3DSA:1.10.400.10:FF:000089', NULL, NULL, 'G protein subunit alpha 14', NULL, NULL, NULL, NULL, NULL, 4),
(196594, NULL, 'G3DSA:3.80.10.10:FF:002130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196595, NULL, 'G3DSA:2.40.128.110:FF:000003', NULL, NULL, 'Conserved hypothetical secreted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196596, NULL, 'G3DSA:1.10.510.10:FF:001232', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196597, NULL, 'G3DSA:3.20.20.480:FF:000001', NULL, NULL, 'Trimethylamine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(196598, NULL, 'G3DSA:2.60.440.10:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196599, NULL, 'G3DSA:2.10.25.10:FF:000168', NULL, NULL, 'FAT atypical cadherin 4', NULL, NULL, NULL, NULL, NULL, 4),
(196600, NULL, 'G3DSA:3.40.50.300:FF:005811', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196601, NULL, 'G3DSA:3.40.50.300:FF:008537', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196602, NULL, 'G3DSA:2.40.50.140:FF:000489', NULL, NULL, 'Putative RNA polymerase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(196603, NULL, 'G3DSA:2.60.120.200:FF:000611', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196604, NULL, 'G3DSA:3.40.50.150:FF:000691', NULL, NULL, 'Bifunctional 3-demethylubiquinone-9 3-methyltransferase/ 2-octaprenyl-6-hydroxy phenol methylase', NULL, NULL, NULL, NULL, NULL, 4),
(196605, NULL, 'G3DSA:1.25.40.20:FF:001187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196606, NULL, 'G3DSA:2.130.10.10:FF:004760', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196607, NULL, 'G3DSA:2.60.40.3180:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196608, NULL, 'G3DSA:3.30.1370.10:FF:000218', NULL, NULL, 'Vigilin 1', NULL, NULL, NULL, NULL, NULL, 4),
(196609, NULL, 'G3DSA:3.30.450.280:FF:000001', NULL, NULL, 'Two component sensor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(196610, NULL, 'G3DSA:1.10.630.10:FF:000044', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(196611, NULL, 'G3DSA:1.10.287.70:FF:000802', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196612, NULL, 'G3DSA:3.90.1310.10:FF:000027', NULL, NULL, 'Cell division protein ftsI', NULL, NULL, NULL, NULL, NULL, 4),
(196613, NULL, 'G3DSA:1.20.1160.20:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196614, NULL, 'G3DSA:1.10.1380.10:FF:000012', NULL, NULL, 'membrane metallo-endopeptidase-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(196615, NULL, 'G3DSA:1.10.10.10:FF:000979', NULL, NULL, 'Cullin-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196616, NULL, 'G3DSA:3.40.50.2000:FF:000424', NULL, NULL, '3-deoxy-D-manno-octulosonic acid transferase', NULL, NULL, NULL, NULL, NULL, 4),
(196617, NULL, 'G3DSA:2.60.40.420:FF:000016', NULL, NULL, 'Monocopper oxidase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(196618, NULL, 'G3DSA:3.90.190.10:FF:000214', NULL, NULL, 'Probable tyrosine-protein phosphatase F54C8.4', NULL, NULL, NULL, NULL, NULL, 4),
(196619, NULL, 'G3DSA:3.30.740.10:FF:000017', NULL, NULL, 'Dynein light chain', NULL, NULL, NULL, NULL, NULL, 4),
(196620, NULL, 'G3DSA:2.130.10.10:FF:004788', NULL, NULL, 'Novel protein-containing four WD domain, G-beta repeats', NULL, NULL, NULL, NULL, NULL, 4),
(196621, NULL, 'G3DSA:2.60.40.10:FF:001258', NULL, NULL, 'Down syndrome cell adhesion molecule 4, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(196622, NULL, 'G3DSA:1.25.10.10:FF:001323', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196623, NULL, 'G3DSA:3.30.420.10:FF:000235', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(196624, NULL, 'G3DSA:1.10.238.10:FF:000997', NULL, NULL, 'Calcium-binding protein CML42', NULL, NULL, NULL, NULL, NULL, 4),
(196625, NULL, 'G3DSA:1.10.287.1130:FF:000009', NULL, NULL, 'Cytochrome c oxidase copper chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(196626, NULL, 'G3DSA:3.40.50.300:FF:006300', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(196627, NULL, 'G3DSA:3.90.110.10:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196628, NULL, 'G3DSA:3.40.109.10:FF:000009', NULL, NULL, 'Coenzyme F420:L-glutamate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(196629, NULL, 'G3DSA:3.40.1190.20:FF:000031', NULL, NULL, '5-dehydro-2-deoxygluconokinase', NULL, NULL, NULL, NULL, NULL, 4),
(196630, NULL, 'G3DSA:2.60.40.10:FF:004664', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(196631, NULL, 'G3DSA:2.40.128.130:FF:000009', NULL, NULL, 'Extracellular serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(196632, NULL, 'G3DSA:2.10.220.10:FF:000104', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(196633, NULL, 'G3DSA:1.10.489.10:FF:000001', NULL, NULL, 'Aromatic peroxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(196634, NULL, 'G3DSA:2.130.10.10:FF:003506', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196635, NULL, 'G3DSA:2.130.10.10:FF:005277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196636, NULL, 'G3DSA:2.60.40.10:FF:001230', NULL, NULL, 'Immunoglobulin kappa variable 8-16', NULL, NULL, NULL, NULL, NULL, 4),
(196637, NULL, 'G3DSA:3.10.110.10:FF:000295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196638, NULL, 'G3DSA:3.40.1090.10:FF:000077', NULL, NULL, 'Cytosolic phospholipase A2 gamma', NULL, NULL, NULL, NULL, NULL, 4),
(196639, NULL, 'G3DSA:2.60.120.820:FF:000004', NULL, NULL, 'BTB/POZ domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(196640, NULL, 'G3DSA:3.30.200.20:FF:002559', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196641, NULL, 'G3DSA:4.10.860.10:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196642, NULL, 'G3DSA:3.30.200.20:FF:000435', NULL, NULL, 'MO15-related protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(196643, NULL, 'G3DSA:1.20.1070.10:FF:000076', NULL, NULL, 'Endothelin receptor type B', NULL, NULL, NULL, NULL, NULL, 4),
(196644, NULL, 'G3DSA:3.40.718.10:FF:000019', NULL, NULL, 'Homoisocitrate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(196645, NULL, 'G3DSA:2.40.50.140:FF:001040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196646, NULL, 'G3DSA:1.10.1520.10:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196647, NULL, 'G3DSA:1.10.357.10:FF:000066', NULL, NULL, 'TetR/AcrR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(196648, NULL, 'G3DSA:3.40.50.300:FF:004940', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196649, NULL, 'G3DSA:3.30.160.60:FF:000836', NULL, NULL, 'E3 SUMO-protein ligase ZNF451 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(196650, NULL, 'G3DSA:1.20.58.250:FF:000001', NULL, NULL, 'DNA polymerase III, theta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(196651, NULL, 'G3DSA:3.30.70.330:FF:000094', NULL, NULL, 'SR-related CTD associated factor 8', NULL, NULL, NULL, NULL, NULL, 4),
(196652, NULL, 'G3DSA:2.60.40.1940:FF:000003', NULL, NULL, 'CD109 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(196653, NULL, 'G3DSA:3.60.15.10:FF:000276', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196654, NULL, 'G3DSA:1.25.40.10:FF:001151', NULL, NULL, 'Pre-mRNA-splicing factor SYF1', NULL, NULL, NULL, NULL, NULL, 4),
(196655, NULL, 'G3DSA:3.30.200.110:FF:000002', NULL, NULL, 'Inositol-pentakisphosphate 2-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(196656, NULL, 'G3DSA:2.130.10.10:FF:003006', NULL, NULL, 'Dynein intermediate chain 1, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(196657, NULL, 'G3DSA:3.40.50.720:FF:002413', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196658, NULL, 'G3DSA:2.130.10.10:FF:001354', NULL, NULL, 'Flagellar outer dynein arm intermediate chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(196659, NULL, 'G3DSA:1.20.58.1030:FF:000043', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196660, NULL, 'G3DSA:1.10.357.50:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196661, NULL, 'G3DSA:3.80.10.10:FF:000331', NULL, NULL, 'Dynein assembly factor 1, axonemal homolog', NULL, NULL, NULL, NULL, NULL, 4),
(196662, NULL, 'G3DSA:1.20.58.1610:FF:000003', NULL, NULL, 'NADH-quinone oxidoreductase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(196663, NULL, 'G3DSA:3.40.570.10:FF:000018', NULL, NULL, 'endonuclease G, mitochondrial-like', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(196664, NULL, 'G3DSA:3.40.50.1820:FF:000645', NULL, NULL, 'Lipase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196665, NULL, 'G3DSA:1.10.490.160:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196666, NULL, 'G3DSA:3.40.390.10:FF:000246', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196667, NULL, 'G3DSA:2.60.120.260:FF:000084', NULL, NULL, 'CLUMA_CG013997, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(196668, NULL, 'G3DSA:2.60.120.200:FF:000173', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor', NULL, NULL, NULL, NULL, NULL, 4),
(196669, NULL, 'G3DSA:2.60.40.10:FF:005653', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196670, NULL, 'G3DSA:3.80.10.10:FF:004075', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196671, NULL, 'G3DSA:2.90.10.30:FF:000002', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(196672, NULL, 'G3DSA:1.25.40.10:FF:004377', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(196673, NULL, 'G3DSA:2.60.120.430:FF:000011', NULL, NULL, 'Os01g0140400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(196674, NULL, 'G3DSA:2.30.29.170:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196675, NULL, 'G3DSA:2.40.50.90:FF:000092', NULL, NULL, 'Staphylococcal_nuclease_homologue /Tudor_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(196676, NULL, 'G3DSA:1.10.400.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196677, NULL, 'G3DSA:2.60.410.10:FF:000001', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase dacA', NULL, NULL, NULL, NULL, NULL, 4),
(196678, NULL, 'G3DSA:1.20.1050.130:FF:000017', NULL, NULL, 'Multisynthetase complex auxiliary component p43', NULL, NULL, NULL, NULL, NULL, 4),
(196679, NULL, 'G3DSA:3.40.462.20:FF:000001', NULL, NULL, 'Berberine bridge enzyme-like 15', NULL, NULL, NULL, NULL, NULL, 4),
(196680, NULL, 'G3DSA:1.10.287.10:FF:000037', NULL, NULL, 'Methionine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(196681, NULL, 'G3DSA:3.30.720.50:FF:000005', NULL, NULL, 'Probable E3 ubiquitin-protein ligase DTX2', NULL, NULL, NULL, NULL, NULL, 4),
(196682, NULL, 'G3DSA:1.10.340.70:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196683, NULL, 'G3DSA:2.60.40.10:FF:004990', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196684, NULL, 'G3DSA:2.60.40.420:FF:000224', NULL, NULL, 'Copper resistance protein A', NULL, NULL, NULL, NULL, NULL, 4),
(196685, NULL, 'G3DSA:3.40.190.10:FF:000473', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(196686, NULL, 'G3DSA:3.30.160.60:FF:005041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196687, NULL, 'G3DSA:2.40.10.10:FF:000695', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196688, NULL, 'G3DSA:1.25.40.420:FF:000004', NULL, NULL, 'BTB/POZ domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(196689, NULL, 'G3DSA:3.90.1150.10:FF:000290', NULL, NULL, 'Probable acetylornithine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(196690, NULL, 'G3DSA:1.10.1040.10:FF:000054', NULL, NULL, 'Altronate oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(196691, NULL, 'G3DSA:1.25.40.10:FF:004848', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196692, NULL, 'G3DSA:3.30.930.10:FF:000234', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(196693, NULL, 'G3DSA:3.30.1010.10:FF:000136', NULL, NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(196694, NULL, 'G3DSA:2.10.50.10:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196695, NULL, 'G3DSA:2.30.30.140:FF:000122', NULL, NULL, 'Unplaced genomic scaffold supercont2.16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(196696, NULL, 'G3DSA:3.40.50.720:FF:000794', NULL, NULL, 'Probable polyketide synthase 33', NULL, NULL, NULL, NULL, NULL, 4),
(196697, NULL, 'G3DSA:2.30.42.10:FF:000117', NULL, NULL, 'partitioning defective 3 homolog B isoform X2', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(196698, NULL, 'G3DSA:3.40.50.10190:FF:000013', NULL, NULL, 'BRCA1 associated RING domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(196699, NULL, 'G3DSA:1.10.510.10:FF:003531', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196700, NULL, 'G3DSA:2.60.40.1730:FF:000120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196701, NULL, 'G3DSA:1.25.10.10:FF:000598', NULL, NULL, 'Importin beta-4 subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196702, NULL, 'G3DSA:1.20.1080.10:FF:000048', NULL, NULL, 'Putative uncharacterized protein YLL053C', NULL, NULL, NULL, NULL, NULL, 4),
(196703, NULL, 'G3DSA:1.25.40.410:FF:000001', NULL, NULL, 'dedicator of cytokinesis protein 9 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(196704, NULL, 'G3DSA:1.25.40.10:FF:001622', NULL, NULL, 'Trafficking protein particle complex 12', NULL, NULL, NULL, NULL, NULL, 4),
(196705, NULL, 'G3DSA:3.40.50.300:FF:007048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196706, NULL, 'G3DSA:1.25.10.10:FF:003301', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(196707, NULL, 'G3DSA:2.60.40.2300:FF:000010', NULL, NULL, 'Neutral ceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(196708, NULL, 'G3DSA:2.60.40.550:FF:000004', NULL, NULL, 'Ecotin-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(196709, NULL, 'G3DSA:3.40.50.1000:FF:000787', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196710, NULL, 'G3DSA:3.20.110.10:FF:000039', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(196711, NULL, 'G3DSA:3.10.580.20:FF:000001', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(196712, NULL, 'G3DSA:2.160.10.10:FF:000094', NULL, NULL, 'Serine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(196713, NULL, 'G3DSA:3.60.15.10:FF:000219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196714, NULL, 'G3DSA:3.40.50.300:FF:003248', NULL, NULL, 'Pre-mRNA-splicing helicase BRR2', NULL, NULL, NULL, NULL, NULL, 4),
(196715, NULL, 'G3DSA:2.130.10.10:FF:002489', NULL, NULL, 'WD repeat domain 66', NULL, NULL, NULL, NULL, NULL, 4),
(196716, NULL, 'G3DSA:3.40.50.2000:FF:000306', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(196717, NULL, 'G3DSA:1.10.630.10:FF:000252', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196718, NULL, 'G3DSA:1.25.40.20:FF:001625', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(196719, NULL, 'G3DSA:3.30.200.20:FF:002144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196720, NULL, 'G3DSA:3.30.70.330:FF:002864', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196721, NULL, 'G3DSA:2.40.128.680:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196722, NULL, 'G3DSA:1.25.40.10:FF:002286', NULL, NULL, 'UTP6 small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4),
(196723, NULL, 'G3DSA:3.30.900.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196724, NULL, 'G3DSA:3.30.450.330:FF:000005', NULL, NULL, 'Cell division protein FtsI [Peptidoglycan synthetase]', NULL, NULL, NULL, NULL, NULL, 4),
(196725, NULL, 'G3DSA:1.10.890.20:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196726, NULL, 'G3DSA:3.30.160.60:FF:001387', NULL, NULL, 'Zinc finger protein 354B', NULL, NULL, NULL, NULL, NULL, 4),
(196727, NULL, 'G3DSA:3.90.230.10:FF:000010', NULL, NULL, 'Methionine aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(196728, NULL, 'G3DSA:2.30.30.100:FF:000161', NULL, NULL, 'Small nuclear ribonucleoprotein G', NULL, NULL, NULL, NULL, NULL, 4),
(196729, NULL, 'G3DSA:3.40.50.11060:FF:000016', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196730, NULL, 'G3DSA:1.25.40.430:FF:000007', NULL, NULL, 'Mitotic checkpoint serine/threonine-protein kinase BUB1', NULL, NULL, NULL, NULL, NULL, 4),
(196731, NULL, 'G3DSA:2.10.25.10:FF:000376', NULL, NULL, 'usherin', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(196732, NULL, 'G3DSA:3.30.200.20:FF:000906', NULL, NULL, 'CRE-MNK-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(196733, NULL, 'G3DSA:3.30.70.330:FF:000773', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(196734, NULL, 'G3DSA:1.25.10.10:FF:001115', NULL, NULL, 'STE-group protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(196735, NULL, 'G3DSA:4.10.400.10:FF:000122', NULL, NULL, 'Suppressor of tumorigenicity 14 protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(196736, NULL, 'G3DSA:2.60.40.10:FF:000387', NULL, NULL, 'Neuroplastin b', NULL, NULL, NULL, NULL, NULL, 4),
(196737, NULL, 'G3DSA:3.30.390.30:FF:000013', NULL, NULL, 'Monodehydroascorbate reductase 3', NULL, NULL, NULL, NULL, NULL, 4),
(196738, NULL, 'G3DSA:1.10.10.10:FF:000479', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196739, NULL, 'G3DSA:3.30.70.330:FF:000829', NULL, NULL, 'Putative U2 auxiliary factor small subunit, Nucleotide-binding alpha-beta plait domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(196740, NULL, 'G3DSA:1.20.120.220:FF:000008', NULL, NULL, 'ATP synthase subunit a', NULL, NULL, NULL, NULL, NULL, 4),
(196741, NULL, 'G3DSA:2.30.29.30:FF:000250', NULL, NULL, 'Sesquipedalian-1 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(196742, NULL, 'G3DSA:3.80.10.10:FF:002630', NULL, NULL, 'Tubulin-specific chaperone E', NULL, NULL, NULL, NULL, NULL, 4),
(196743, NULL, 'G3DSA:3.90.1010.10:FF:000015', NULL, NULL, 'SufE-like protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(196744, NULL, 'G3DSA:3.30.70.330:FF:002807', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196745, NULL, 'G3DSA:1.10.890.10:FF:000001', NULL, NULL, 'Acid stress chaperone HdeA', NULL, NULL, NULL, NULL, NULL, 4),
(196746, NULL, 'G3DSA:2.130.10.10:FF:004434', NULL, NULL, 'WD-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196747, NULL, 'G3DSA:3.40.50.300:FF:005283', NULL, NULL, 'Ras-like small GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196748, NULL, 'G3DSA:1.20.120.1320:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196749, NULL, 'G3DSA:3.90.320.10:FF:000040', NULL, NULL, 'Yeast DNA helicase/endonuclease family', NULL, NULL, NULL, NULL, NULL, 4),
(196750, NULL, 'G3DSA:2.40.10.10:FF:000369', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196751, NULL, 'G3DSA:3.30.450.20:FF:000627', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(196752, NULL, 'G3DSA:3.40.50.300:FF:005603', NULL, NULL, 'Dicer-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196753, NULL, 'G3DSA:1.10.10.1500:FF:000001', NULL, NULL, 'ribosomal oxygenase 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(196754, NULL, 'G3DSA:3.30.70.360:FF:000052', NULL, NULL, 'Peptidase T', NULL, NULL, NULL, NULL, NULL, 4),
(196755, NULL, 'G3DSA:3.40.630.30:FF:000030', NULL, NULL, 'NATD1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(196756, NULL, 'G3DSA:3.40.50.11040:FF:000010', NULL, NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', NULL, NULL, NULL, NULL, NULL, 4),
(196757, NULL, 'G3DSA:3.30.200.20:FF:001424', NULL, NULL, 'Cyclin-dependent kinase 15', NULL, NULL, NULL, NULL, NULL, 4),
(196758, NULL, 'G3DSA:2.30.29.30:FF:001031', NULL, NULL, 'FERM, ARH/RhoGEF and pleckstrin domain protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(196759, NULL, 'G3DSA:1.10.287.130:FF:000236', NULL, NULL, 'Sensor histidine kinase, PAS and GAF domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(196760, NULL, 'G3DSA:2.30.30.40:FF:000677', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196761, NULL, 'G3DSA:3.30.70.330:FF:001026', NULL, NULL, 'Sporulation-specific protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(196762, NULL, 'G3DSA:3.30.40.10:FF:000386', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM13', NULL, NULL, NULL, NULL, NULL, 4),
(196763, NULL, 'G3DSA:1.10.8.10:FF:000113', NULL, NULL, 'Ubiquitin-associated and SH3 domain-containing protein A', NULL, NULL, NULL, NULL, NULL, 4),
(196764, NULL, 'G3DSA:3.40.50.2300:FF:001498', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(196765, NULL, 'G3DSA:2.130.10.10:FF:003214', NULL, NULL, 'Elongator acetyltransferase complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(196766, NULL, 'G3DSA:2.10.110.10:FF:000276', NULL, NULL, 'ABL207Wp', NULL, NULL, NULL, NULL, NULL, 4),
(196767, NULL, 'G3DSA:3.20.20.20:FF:000028', NULL, NULL, 'Dihydropteroate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(196768, NULL, 'G3DSA:1.10.10.60:FF:000680', NULL, NULL, 'Cone-rod homeobox, opposite strand', NULL, NULL, NULL, NULL, NULL, 4),
(196769, NULL, 'G3DSA:3.30.40.10:FF:002038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196770, NULL, 'G3DSA:3.10.180.10:FF:000097', NULL, NULL, 'Biphenyl-2,3-diol 1,2-dioxygenase III', NULL, NULL, NULL, NULL, NULL, 4),
(196771, NULL, 'G3DSA:3.80.20.20:FF:000099', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(196772, NULL, 'G3DSA:2.60.15.10:FF:000025', NULL, NULL, 'ATP synthase epsilon chain', NULL, NULL, NULL, NULL, NULL, 4),
(196773, NULL, 'G3DSA:3.30.479.20:FF:000064', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(196774, NULL, 'G3DSA:1.20.1050.10:FF:000277', NULL, NULL, 'Os02g0319300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(196775, NULL, 'G3DSA:3.30.200.20:FF:000761', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(196776, NULL, 'G3DSA:4.10.280.10:FF:000033', NULL, NULL, 'Transcription factor HES-5', NULL, NULL, NULL, NULL, NULL, 4),
(196777, NULL, 'G3DSA:3.20.20.10:FF:000025', NULL, NULL, 'Diaminopimelate decarboxylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196778, NULL, 'G3DSA:1.10.510.10:FF:002749', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196779, NULL, 'G3DSA:3.40.30.10:FF:000160', NULL, NULL, 'Peroxiredoxin family protein/glutaredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(196780, NULL, 'G3DSA:2.60.40.10:FF:002101', NULL, NULL, 'Cytotoxic T-lymphocyte protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(196781, NULL, 'G3DSA:2.130.10.10:FF:001680', NULL, NULL, 'Small nucleolar ribonucleoprotein complex subunit (Pwp2), putative', NULL, NULL, NULL, NULL, NULL, 4),
(196782, NULL, 'G3DSA:1.25.40.10:FF:000841', NULL, NULL, 'RNA polymerase-associated protein CTR9 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(196783, NULL, 'G3DSA:3.40.50.10680:FF:000003', NULL, NULL, '2-phospho-L-lactate transferase', NULL, NULL, NULL, NULL, NULL, 4),
(196784, NULL, 'G3DSA:2.60.40.10:FF:005445', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196785, NULL, 'G3DSA:3.40.50.300:FF:006738', NULL, NULL, 'Tight junction protein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(196786, NULL, 'G3DSA:2.60.120.380:FF:000035', NULL, NULL, 'Putative calpain', NULL, NULL, NULL, NULL, NULL, 4),
(196787, NULL, 'G3DSA:1.50.10.20:FF:000132', NULL, NULL, 'Protein farnesyltransferase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(196788, NULL, 'G3DSA:1.10.3430.10:FF:000039', NULL, NULL, 'Ammonium transporter family', NULL, NULL, NULL, NULL, NULL, 4),
(196789, NULL, 'G3DSA:2.40.50.40:FF:000127', NULL, NULL, 'C.Elegans Chromodomain protein', NULL, NULL, NULL, NULL, NULL, 4),
(196790, NULL, 'G3DSA:3.40.50.300:FF:004676', NULL, NULL, 'Type II secretion system protein E', NULL, NULL, NULL, NULL, NULL, 4),
(196791, NULL, 'G3DSA:3.40.190.10:FF:000944', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196792, NULL, 'G3DSA:2.30.30.100:FF:000009', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm2', NULL, NULL, NULL, NULL, NULL, 4),
(196793, NULL, 'G3DSA:3.30.300.110:FF:000002', NULL, NULL, 'tRNA wybutosine-synthesizing protein 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(196794, NULL, 'G3DSA:2.130.10.10:FF:005305', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196795, NULL, 'G3DSA:3.40.50.300:FF:002995', NULL, NULL, 'BRCA1-interacting protein C-terminal helicase 1', NULL, NULL, NULL, NULL, NULL, 4),
(196796, NULL, 'G3DSA:3.90.226.10:FF:000225', NULL, NULL, 'Ethylmalonyl-CoA decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(196797, NULL, 'G3DSA:3.30.160.60:FF:003332', NULL, NULL, 'GM26116', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(196798, NULL, 'G3DSA:1.10.20.140:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196799, NULL, 'G3DSA:1.25.40.20:FF:000844', NULL, NULL, 'Glycerophosphocholine phosphodiesterase GDE1', NULL, NULL, NULL, NULL, NULL, 4),
(196800, NULL, 'G3DSA:1.20.1560.10:FF:000361', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196801, NULL, 'G3DSA:1.20.1270.60:FF:000050', NULL, NULL, 'RhoGAP and Fes/CIP4 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(196802, NULL, 'G3DSA:1.10.510.10:FF:001614', NULL, NULL, 'Nerve growth factor receptor TRKA, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196803, NULL, 'G3DSA:3.40.50.720:FF:000058', NULL, NULL, 'Putative oxidoreductase GLYR1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(196804, NULL, 'G3DSA:3.80.10.10:FF:000477', NULL, NULL, 'Mimecan', NULL, NULL, NULL, NULL, NULL, 4),
(196805, NULL, 'G3DSA:3.40.30.10:FF:000042', NULL, NULL, 'protein disulfide-isomerase A2', NULL, NULL, NULL, NULL, NULL, 4),
(196806, NULL, 'G3DSA:3.80.10.10:FF:003765', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196807, NULL, 'G3DSA:3.40.47.10:FF:000165', NULL, NULL, 'Fatty acid synthase, putative (JCVI)', NULL, NULL, NULL, NULL, NULL, 4),
(196808, NULL, 'G3DSA:1.20.1560.10:FF:000304', NULL, NULL, 'ABC transporter B family member 15', NULL, NULL, NULL, NULL, NULL, 4),
(196809, NULL, 'G3DSA:1.20.1250.10:FF:000141', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196810, NULL, 'G3DSA:1.20.58.1120:FF:000036', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(196811, NULL, 'G3DSA:1.20.1250.20:FF:000615', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(196812, NULL, 'G3DSA:2.40.50.140:FF:000635', NULL, NULL, 'MoRTal germline', NULL, NULL, NULL, NULL, NULL, 4),
(196813, NULL, 'G3DSA:3.40.50.1950:FF:000015', NULL, NULL, 'Mersacidin decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(196814, NULL, 'G3DSA:1.10.4160.10:FF:000029', NULL, NULL, 'Probable conserved integral membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(196815, NULL, 'G3DSA:2.30.29.70:FF:000003', NULL, NULL, 'Regulatory particle non-ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(196816, NULL, 'G3DSA:3.90.810.10:FF:000004', NULL, NULL, 'CDC42 small effector protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(196817, NULL, 'G3DSA:3.40.50.1010:FF:000262', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196818, NULL, 'G3DSA:2.120.10.30:FF:000399', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(196819, NULL, 'G3DSA:3.90.1530.10:FF:000010', NULL, NULL, 'Sulfiredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(196820, NULL, 'G3DSA:3.20.180.20:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196821, NULL, 'G3DSA:1.20.1250.20:FF:001279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196822, NULL, 'G3DSA:2.40.30.10:FF:000168', NULL, NULL, 'Elongation factor 1-alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(196823, NULL, 'G3DSA:1.10.472.10:FF:000496', NULL, NULL, 'Retinoblastoma protein', NULL, NULL, NULL, NULL, NULL, 4),
(196824, NULL, 'G3DSA:2.130.10.10:FF:003271', NULL, NULL, 'Putative histone H3 lys4 methyltransferase complex and rna cleavage factor ii complex', NULL, NULL, NULL, NULL, NULL, 4),
(196825, NULL, 'G3DSA:3.90.190.10:FF:000068', NULL, NULL, 'receptor-type tyrosine-protein phosphatase zeta', NULL, NULL, NULL, NULL, NULL, 4),
(196826, NULL, 'G3DSA:2.160.20.10:FF:000274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196827, NULL, 'G3DSA:2.30.29.230:FF:000001', NULL, NULL, 'Small G protein signaling modulator 2', NULL, NULL, NULL, NULL, NULL, 4),
(196828, NULL, 'G3DSA:3.30.200.20:FF:002352', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(196829, NULL, 'G3DSA:2.30.29.30:FF:000721', NULL, NULL, 'Basic proline-rich protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196830, NULL, 'G3DSA:3.40.30.10:FF:001177', NULL, NULL, 'Glutathione S-transferase family protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(196831, NULL, 'G3DSA:2.40.240.20:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196832, NULL, 'G3DSA:3.30.420.40:FF:000749', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196833, NULL, 'G3DSA:2.30.30.100:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196834, NULL, 'G3DSA:3.80.10.10:FF:002422', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196835, NULL, 'G3DSA:2.130.10.10:FF:005423', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196836, NULL, 'G3DSA:3.40.1190.20:FF:000205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196837, NULL, 'G3DSA:3.30.710.10:FF:000128', NULL, NULL, 'galectin-3-binding protein precursor', NULL, NULL, NULL, NULL, NULL, 4),
(196838, NULL, 'G3DSA:2.60.40.60:FF:000677', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196839, NULL, 'G3DSA:3.40.367.20:FF:000021', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(196840, NULL, 'G3DSA:3.40.50.300:FF:001860', NULL, NULL, 'ATP-dependent RNA helicase A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196841, NULL, 'G3DSA:1.20.1250.20:FF:002206', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196842, NULL, 'G3DSA:1.25.40.10:FF:002932', NULL, NULL, 'Adenylate kinase isoenzyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(196843, NULL, 'G3DSA:3.40.50.2300:FF:000278', NULL, NULL, 'Glutamate receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(196844, NULL, 'G3DSA:2.30.29.30:FF:000042', NULL, NULL, 'pleckstrin homology domain-containing family A member 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(196845, NULL, 'G3DSA:2.60.40.10:FF:003236', NULL, NULL, 'Interferon gamma receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(196846, NULL, 'G3DSA:1.20.58.60:FF:000721', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196847, NULL, 'G3DSA:1.10.1200.240:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196848, NULL, 'G3DSA:1.10.620.20:FF:000018', NULL, NULL, 'Ribonucleoside-diphosphate reductase small chain', NULL, NULL, NULL, NULL, NULL, 4),
(196849, NULL, 'G3DSA:3.80.10.10:FF:000213', NULL, NULL, 'Tyrosine-sulfated glycopeptide receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(196850, NULL, 'G3DSA:1.25.40.10:FF:001358', NULL, NULL, 'Pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(196851, NULL, 'G3DSA:1.20.1070.10:FF:001975', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196852, NULL, 'G3DSA:3.40.50.300:FF:001803', NULL, NULL, 'Helicase with zinc finger 2', NULL, NULL, NULL, NULL, NULL, 4),
(196853, NULL, 'G3DSA:1.10.540.10:FF:000014', NULL, NULL, 'Acyl-coenzyme A oxidase 4, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(196854, NULL, 'G3DSA:2.60.40.10:FF:004838', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196855, NULL, 'G3DSA:2.130.10.10:FF:000691', NULL, NULL, 'Telomerase protein component 1', NULL, NULL, NULL, NULL, NULL, 4),
(196856, NULL, 'G3DSA:3.50.50.60:FF:000338', NULL, NULL, 'D-amino acid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(196857, NULL, 'G3DSA:3.30.200.20:FF:001216', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(196858, NULL, 'G3DSA:3.40.50.10380:FF:000003', NULL, NULL, 'NADP-dependent malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(196859, NULL, 'G3DSA:3.30.420.10:FF:000061', NULL, NULL, 'PARN like, ribonuclease domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(196860, NULL, 'G3DSA:2.10.109.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196861, NULL, 'G3DSA:1.10.4190.10:FF:000003', NULL, NULL, 'Uncharacterized urease accessory protein UreF-like', NULL, NULL, NULL, NULL, NULL, 4),
(196862, NULL, 'G3DSA:1.25.40.10:FF:005192', NULL, NULL, 'Tonsoku-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(196863, NULL, 'G3DSA:3.20.20.80:FF:000473', NULL, NULL, 'Putative exo-beta-1,3-glucanase (GH5-family) member of the ScExg1-family (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(196864, NULL, 'G3DSA:1.25.40.180:FF:000095', NULL, NULL, 'Nuclear cap binding protein subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(196865, NULL, 'G3DSA:1.10.10.10:FF:000687', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(196866, NULL, 'G3DSA:3.80.10.10:FF:001495', NULL, NULL, 'Protein CBR-DMA-1', NULL, NULL, NULL, NULL, NULL, 4),
(196867, NULL, 'G3DSA:1.20.5.360:FF:000001', NULL, NULL, 'Pulmonary surfactant-associated protein D', NULL, NULL, NULL, NULL, NULL, 4),
(196868, NULL, 'G3DSA:3.10.20.90:FF:000937', NULL, NULL, 'Rho GTPase-activating protein gacG', NULL, NULL, NULL, NULL, NULL, 4),
(196869, NULL, 'G3DSA:1.20.140.40:FF:000075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196870, NULL, 'G3DSA:1.10.510.10:FF:000597', NULL, NULL, 'serine/threonine-protein kinase Nek6 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(196871, NULL, 'G3DSA:1.10.10.10:FF:001704', NULL, NULL, 'Transcriptional regulator lysR family', NULL, NULL, NULL, NULL, NULL, 4),
(196872, NULL, 'G3DSA:3.30.230.130:FF:000087', NULL, NULL, 'LD29662p', NULL, NULL, NULL, NULL, NULL, 4),
(196873, NULL, 'G3DSA:1.25.40.10:FF:002639', NULL, NULL, 'Peroxisomal biogenesis factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(196874, NULL, 'G3DSA:1.10.3380.20:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196875, NULL, 'G3DSA:3.30.200.20:FF:000553', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(196876, NULL, 'G3DSA:1.10.3380.10:FF:000012', NULL, NULL, 'DEAD/DEAH box DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(196877, NULL, 'G3DSA:1.20.1050.10:FF:000013', NULL, NULL, 'Glutathione S-transferase GstB', NULL, NULL, NULL, NULL, NULL, 4),
(196878, NULL, 'G3DSA:1.25.40.90:FF:000084', NULL, NULL, 'zinc finger protein 55 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(196879, NULL, 'G3DSA:1.10.510.10:FF:001171', NULL, NULL, 'CMGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(196880, NULL, 'G3DSA:2.30.42.10:FF:000235', NULL, NULL, 'Tyrosine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(196881, NULL, 'G3DSA:3.30.70.1470:FF:000003', NULL, NULL, 'Caspase-1', NULL, NULL, NULL, NULL, NULL, 4),
(196882, NULL, 'G3DSA:1.25.40.20:FF:000170', NULL, NULL, 'Ankyrin repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(196883, NULL, 'G3DSA:3.40.50.2000:FF:001121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196884, NULL, 'G3DSA:1.20.58.1120:FF:000070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196885, NULL, 'G3DSA:3.40.50.800:FF:000048', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(196886, NULL, 'G3DSA:3.40.1180.10:FF:000022', NULL, NULL, 'Isoprenyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(196887, NULL, 'G3DSA:1.10.510.10:FF:003059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196888, NULL, 'G3DSA:1.20.5.190:FF:000074', NULL, NULL, 'Sperm surface protein Sp17', NULL, NULL, NULL, NULL, NULL, 4),
(196889, NULL, 'G3DSA:1.20.5.370:FF:000004', NULL, NULL, 'tropomyosin alpha-1 chain isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(196890, NULL, 'G3DSA:3.40.1390.30:FF:000015', NULL, NULL, 'Nif3-like dinuclear metal center hexameric protein', NULL, NULL, NULL, NULL, NULL, 4),
(196891, NULL, 'G3DSA:3.40.50.360:FF:000017', NULL, NULL, 'Protoporphyrinogen oxidase (PPO)', NULL, NULL, NULL, NULL, NULL, 4),
(196892, NULL, 'G3DSA:2.60.40.10:FF:000887', NULL, NULL, 'leucine-rich repeat neuronal protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(196893, NULL, 'G3DSA:1.10.8.60:FF:000521', NULL, NULL, 'Cell division control protein 48 homolog D', NULL, NULL, NULL, NULL, NULL, 4),
(196894, NULL, 'G3DSA:4.10.280.10:FF:000241', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196895, NULL, 'G3DSA:3.90.1720.30:FF:000002', NULL, NULL, 'Desumoylating isopeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(196896, NULL, 'G3DSA:1.10.10.1800:FF:000001', NULL, NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(196897, NULL, 'G3DSA:1.20.1560.10:FF:000804', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196898, NULL, 'G3DSA:1.10.510.10:FF:000951', NULL, NULL, 'EKC/KEOPS complex subunit BUD32', NULL, NULL, NULL, NULL, NULL, 4),
(196899, NULL, 'G3DSA:3.30.70.330:FF:002454', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196900, NULL, 'G3DSA:1.20.1250.20:FF:001689', NULL, NULL, 'Solute carrier family 16 member 12a', NULL, NULL, NULL, NULL, NULL, 4),
(196901, NULL, 'G3DSA:3.40.1110.10:FF:000220', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(196902, NULL, 'G3DSA:3.60.130.10:FF:000009', NULL, NULL, 'Putative Taurine catabolism dioxygenase TauD', NULL, NULL, NULL, NULL, NULL, 4),
(196903, NULL, 'G3DSA:3.30.2290.10:FF:000010', NULL, NULL, 'Metalloprotease TldD', NULL, NULL, NULL, NULL, NULL, 4),
(196904, NULL, 'G3DSA:2.30.29.30:FF:000603', NULL, NULL, 'Unconventional myosin heavy chain 6', NULL, NULL, NULL, NULL, NULL, 4),
(196905, NULL, 'G3DSA:3.30.565.10:FF:000559', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196906, NULL, 'G3DSA:3.30.230.10:FF:000344', NULL, NULL, '40S ribosomal protein S2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196907, NULL, 'G3DSA:1.10.1240.100:FF:000005', NULL, NULL, 'Polyketide synthase RzxE', NULL, NULL, NULL, NULL, NULL, 4),
(196908, NULL, 'G3DSA:3.40.50.1460:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196909, NULL, 'G3DSA:1.10.3380.30:FF:000018', NULL, NULL, 'DEAD/DEAH box helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196910, NULL, 'G3DSA:2.60.40.1840:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196911, NULL, 'G3DSA:1.20.1070.10:FF:001003', NULL, NULL, 'Protein CBG16999', NULL, NULL, NULL, NULL, NULL, 4),
(196912, NULL, 'G3DSA:2.40.30.10:FF:000286', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(196913, NULL, 'G3DSA:3.30.413.10:FF:000005', NULL, NULL, '4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase (flavodoxin)', NULL, NULL, NULL, NULL, NULL, 4),
(196914, NULL, 'G3DSA:2.60.40.60:FF:000795', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196915, NULL, 'G3DSA:3.80.10.10:FF:000685', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(196916, NULL, 'G3DSA:3.30.70.141:FF:000021', NULL, NULL, 'Nucleoside diphosphate kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(196917, NULL, 'G3DSA:3.40.50.1820:FF:000527', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196918, NULL, 'G3DSA:3.90.190.10:FF:000186', NULL, NULL, 'Dual specificity phosphatase 12', NULL, NULL, NULL, NULL, NULL, 4),
(196919, NULL, 'G3DSA:3.20.100.10:FF:000005', NULL, NULL, 'Ctl1p', NULL, NULL, NULL, NULL, NULL, 4),
(196920, NULL, 'G3DSA:3.40.50.300:FF:008419', NULL, NULL, 'RNA helicase aquarius', NULL, NULL, NULL, NULL, NULL, 4),
(196921, NULL, 'G3DSA:2.130.10.30:FF:000084', NULL, NULL, 'E3 ubiquitin-protein ligase rpm-1', NULL, NULL, NULL, NULL, NULL, 4),
(196922, NULL, 'G3DSA:2.130.10.10:FF:005069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196923, NULL, 'G3DSA:2.60.300.12:FF:000012', NULL, NULL, 'Iron-sulfur assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(196924, NULL, 'G3DSA:3.30.470.20:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196925, NULL, 'G3DSA:3.40.50.300:FF:001242', NULL, NULL, 'Protein-tyrosine sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(196926, NULL, 'G3DSA:3.30.160.60:FF:004113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196927, NULL, 'G3DSA:3.30.559.30:FF:000068', NULL, NULL, 'L-2-aminoadipate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(196928, NULL, 'G3DSA:2.70.50.40:FF:000002', NULL, NULL, 'Retinal rod rhodopsin-sensitive cGMP 3'',5''-cyclic phosphodiesterase subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(196929, NULL, 'G3DSA:3.30.160.60:FF:001707', NULL, NULL, 'Zinc finger protein 142', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(196930, NULL, 'G3DSA:3.40.50.150:FF:001623', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196931, NULL, 'G3DSA:3.30.559.10:FF:000062', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(196932, NULL, 'G3DSA:3.90.190.10:FF:000332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196933, NULL, 'G3DSA:3.80.10.10:FF:001966', NULL, NULL, 'PH domain and leucine rich repeat protein phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(196934, NULL, 'G3DSA:1.10.575.10:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196935, NULL, 'G3DSA:3.30.160.60:FF:001651', NULL, NULL, 'Zinc finger protein 311', NULL, NULL, NULL, NULL, NULL, 4),
(196936, NULL, 'G3DSA:3.30.420.40:FF:001093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196937, NULL, 'G3DSA:1.10.510.10:FF:001114', NULL, NULL, 'Receptor-type guanylate cyclase gcy-4', NULL, NULL, NULL, NULL, NULL, 4),
(196938, NULL, 'G3DSA:2.70.50.50:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196939, NULL, 'G3DSA:3.50.50.60:FF:000838', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196940, NULL, 'G3DSA:3.40.50.300:FF:000668', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(196941, NULL, 'G3DSA:3.30.40.10:FF:000329', NULL, NULL, 'Histone-lysine N-methyltransferase 2D', NULL, NULL, NULL, NULL, NULL, 4),
(196942, NULL, 'G3DSA:1.10.510.10:FF:002396', NULL, NULL, 'Serine/threonine protein kinase-36', NULL, NULL, NULL, NULL, NULL, 4),
(196943, NULL, 'G3DSA:1.25.40.10:FF:004641', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(196944, NULL, 'G3DSA:1.25.10.10:FF:002958', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196945, NULL, 'G3DSA:3.30.40.10:FF:002185', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196946, NULL, 'G3DSA:3.30.40.10:FF:000947', NULL, NULL, 'Zinc finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196947, NULL, 'G3DSA:1.10.20.10:FF:000098', NULL, NULL, 'Apoptosis-inducing TAF9-like domain 1 family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196948, NULL, 'G3DSA:3.40.50.300:FF:003658', NULL, NULL, 'BnaA08g24620D protein', NULL, NULL, NULL, NULL, NULL, 4),
(196949, NULL, 'G3DSA:1.10.3460.10:FF:000013', NULL, NULL, 'Chlorophyll a-b binding protein 3A, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(196950, NULL, 'G3DSA:1.20.1410.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196951, NULL, 'G3DSA:1.20.1070.10:FF:002021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196952, NULL, 'G3DSA:1.25.40.10:FF:005304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196953, NULL, 'G3DSA:3.40.190.10:FF:000591', NULL, NULL, 'p-protein', NULL, NULL, NULL, NULL, NULL, 4),
(196954, NULL, 'G3DSA:3.90.1640.30:FF:000001', NULL, NULL, 'Single-stranded-DNA-specific exonuclease RecJ', NULL, NULL, NULL, NULL, NULL, 4),
(196955, NULL, 'G3DSA:3.30.160.60:FF:005602', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196956, NULL, 'G3DSA:1.20.1560.10:FF:000714', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196957, NULL, 'G3DSA:2.60.40.10:FF:001292', NULL, NULL, 'PKHD1 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(196958, NULL, 'G3DSA:2.60.40.1090:FF:000001', NULL, NULL, 'Type-1 fimbrial major subunit', NULL, NULL, NULL, NULL, NULL, 4),
(196959, NULL, 'G3DSA:2.130.10.10:FF:002809', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196960, NULL, 'G3DSA:3.30.200.20:FF:000199', NULL, NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(196961, NULL, 'G3DSA:2.40.50.140:FF:000017', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(196962, NULL, 'G3DSA:3.30.750.24:FF:000060', NULL, NULL, 'STAS domain protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(196963, NULL, 'G3DSA:1.25.40.180:FF:000207', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196964, NULL, 'G3DSA:3.30.1330.90:FF:000015', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(196965, NULL, 'G3DSA:1.10.3210.30:FF:000006', NULL, NULL, 'Putative CRISPR-associated nuclease/helicase Cas3', NULL, NULL, NULL, NULL, NULL, 4),
(196966, NULL, 'G3DSA:1.10.287.70:FF:000156', NULL, NULL, 'Voltage-gated sodium channel Nav2.1', NULL, NULL, NULL, NULL, NULL, 4),
(196967, NULL, 'G3DSA:2.30.30.490:FF:000030', NULL, NULL, 'DNA (cytosine-5)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(196968, NULL, 'G3DSA:3.30.1330.80:FF:000012', NULL, NULL, 'Alpha-acetolactate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(196969, NULL, 'G3DSA:2.60.40.10:FF:000010', NULL, NULL, 'receptor-type tyrosine-protein phosphatase delta isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(196970, NULL, 'G3DSA:1.10.3370.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196971, NULL, 'G3DSA:2.130.10.10:FF:003714', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196972, NULL, 'G3DSA:1.10.45.10:FF:000003', NULL, NULL, 'Glycolate oxidase subunit GlcD', NULL, NULL, NULL, NULL, NULL, 4),
(196973, NULL, 'G3DSA:2.70.240.10:FF:000002', NULL, NULL, 'Alpha hemolysin', NULL, NULL, NULL, NULL, NULL, 4),
(196974, NULL, 'G3DSA:3.10.280.10:FF:000014', NULL, NULL, 'Mitochondrial glycoprotein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(196975, NULL, 'G3DSA:3.90.70.10:FF:000666', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196976, NULL, 'G3DSA:3.40.50.2300:FF:000688', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(196977, NULL, 'G3DSA:3.60.10.10:FF:000315', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196978, NULL, 'G3DSA:1.10.533.10:FF:000279', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(196979, NULL, 'G3DSA:2.60.40.60:FF:000941', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196980, NULL, 'G3DSA:1.20.1250.20:FF:002094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196981, NULL, 'G3DSA:2.60.120.200:FF:000139', NULL, NULL, 'FAT atypical cadherin 2', NULL, NULL, NULL, NULL, NULL, 4),
(196982, NULL, 'G3DSA:2.30.29.30:FF:000457', NULL, NULL, 'Insulin receptor substrate 1', NULL, NULL, NULL, NULL, NULL, 4),
(196983, NULL, 'G3DSA:1.20.5.320:FF:000006', NULL, NULL, 'Protein FAM132A', NULL, NULL, NULL, NULL, NULL, 4),
(196984, NULL, 'G3DSA:3.30.160.60:FF:003096', NULL, NULL, 'ZFP57 zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(196985, NULL, 'G3DSA:2.40.50.90:FF:000035', NULL, NULL, 'Probable endonuclease LCL3', NULL, NULL, NULL, NULL, NULL, 4),
(196986, NULL, 'G3DSA:3.30.60.20:FF:000098', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(196987, NULL, 'G3DSA:2.60.40.10:FF:005035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196988, NULL, 'G3DSA:1.25.40.10:FF:000487', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(196989, NULL, 'G3DSA:3.40.50.300:FF:007082', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(196990, NULL, 'G3DSA:2.10.25.10:FF:000640', NULL, NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(196991, NULL, 'G3DSA:1.20.1070.10:FF:000694', NULL, NULL, 'Chemokine (C-X-C motif) receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(196992, NULL, 'G3DSA:1.10.238.10:FF:001161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(196993, NULL, 'G3DSA:1.10.510.10:FF:003323', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196994, NULL, 'G3DSA:1.25.10.10:FF:003155', NULL, NULL, 'PIKK family atypical protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(196995, NULL, 'G3DSA:1.20.1070.10:FF:000340', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(196996, NULL, 'G3DSA:2.130.10.10:FF:003624', NULL, NULL, 'Eukaryotic translation initiation factor 2A', NULL, NULL, NULL, NULL, NULL, 4),
(196997, NULL, 'G3DSA:3.60.110.10:FF:000098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(196998, NULL, 'G3DSA:1.10.10.10:FF:001143', NULL, NULL, 'DEAD/DEAH box helicase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(196999, NULL, 'G3DSA:3.40.50.150:FF:001680', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197000, NULL, 'G3DSA:1.25.40.10:FF:002696', NULL, NULL, 'TPR repeat/Tetratricopeptide repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197001, NULL, 'G3DSA:2.60.40.10:FF:004782', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197002, NULL, 'G3DSA:3.40.50.10190:FF:000070', NULL, NULL, 'Transcription coactivator', NULL, NULL, NULL, NULL, NULL, 4),
(197003, NULL, 'G3DSA:3.30.40.10:FF:000239', NULL, NULL, 'probable BOI-related E3 ubiquitin-protein ligase 2', NULL, NULL, NULL, NULL, NULL, 4),
(197004, NULL, 'G3DSA:3.40.50.620:FF:000438', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(197005, NULL, 'G3DSA:3.40.50.12780:FF:000077', NULL, NULL, 'Putative long-chain-fatty-acid--CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(197006, NULL, 'G3DSA:3.30.590.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197007, NULL, 'G3DSA:2.170.180.11:FF:000002', NULL, NULL, 'Methuselah-like 15, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(197008, NULL, 'G3DSA:3.40.50.720:FF:000940', NULL, NULL, 'Prephenate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(197009, NULL, 'G3DSA:1.25.40.10:FF:001504', NULL, NULL, 'Tetratricopeptide repeat protein 21B', NULL, NULL, NULL, NULL, NULL, 4),
(197010, NULL, 'G3DSA:1.10.555.10:FF:000211', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197011, NULL, 'G3DSA:1.10.10.10:FF:000833', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(197012, NULL, 'G3DSA:3.30.160.380:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197013, NULL, 'G3DSA:3.80.10.10:FF:002012', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(197014, NULL, 'G3DSA:3.30.497.10:FF:000159', NULL, NULL, 'Serpin peptidase inhibitor 22', NULL, NULL, NULL, NULL, NULL, 4),
(197015, NULL, 'G3DSA:3.80.10.10:FF:002276', NULL, NULL, 'Fgr51p', NULL, NULL, NULL, NULL, NULL, 4),
(197016, NULL, 'G3DSA:2.170.140.10:FF:000044', NULL, NULL, 'Mucin related 89F, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(197017, NULL, 'G3DSA:1.10.510.10:FF:001378', NULL, NULL, 'Serine/threonine kinase 3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197018, NULL, 'G3DSA:2.130.10.10:FF:002697', NULL, NULL, 'G-protein beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(197019, NULL, 'G3DSA:1.20.120.310:FF:000002', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(197020, NULL, 'G3DSA:1.10.760.10:FF:000109', NULL, NULL, 'Cytochrome c family protein', NULL, NULL, NULL, NULL, NULL, 4),
(197021, NULL, 'G3DSA:3.30.460.10:FF:000035', NULL, NULL, 'Poly(A) polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(197022, NULL, 'G3DSA:2.120.10.80:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197023, NULL, 'G3DSA:1.20.1260.10:FF:000023', NULL, NULL, 'Rubrerythrin', NULL, NULL, NULL, NULL, NULL, 4),
(197024, NULL, 'G3DSA:2.130.10.10:FF:001415', NULL, NULL, 'aladin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(197025, NULL, 'G3DSA:2.20.70.10:FF:000188', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(197026, NULL, 'G3DSA:3.80.10.10:FF:004428', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(197027, NULL, 'G3DSA:3.40.20.10:FF:000070', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(197028, NULL, 'G3DSA:1.10.150.50:FF:000221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197029, NULL, 'G3DSA:2.60.40.10:FF:005092', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(197030, NULL, 'G3DSA:1.25.40.20:FF:001507', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197031, NULL, 'G3DSA:2.130.10.10:FF:004849', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197032, NULL, 'G3DSA:3.40.50.300:FF:005491', NULL, NULL, 'GM26572', NULL, NULL, NULL, NULL, NULL, 4),
(197033, NULL, 'G3DSA:3.30.40.10:FF:000740', NULL, NULL, 'Specific transcriptional repressor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197034, NULL, 'G3DSA:1.20.5.110:FF:000123', NULL, NULL, 'Vesicle transport through interaction with t-snares 1a', NULL, NULL, NULL, NULL, NULL, 4),
(197035, NULL, 'G3DSA:2.30.30.30:FF:000079', NULL, NULL, 'Transcription elongation factor SPT5', NULL, NULL, NULL, NULL, NULL, 4),
(197036, NULL, 'G3DSA:1.20.1070.10:FF:000430', NULL, NULL, 'Serpentine Receptor, class V', NULL, NULL, NULL, NULL, NULL, 4),
(197037, NULL, 'G3DSA:1.20.900.10:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197038, NULL, 'G3DSA:3.30.70.660:FF:000018', NULL, NULL, 'Pseudouridylate synthase 3', NULL, NULL, NULL, NULL, NULL, 4),
(197039, NULL, 'G3DSA:3.30.70.330:FF:002364', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197040, NULL, 'G3DSA:1.10.357.140:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197041, NULL, 'G3DSA:2.40.100.10:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197042, NULL, 'G3DSA:3.80.10.10:FF:000067', NULL, NULL, 'Leucine-rich repeat and calponin homology domain-containing protein 4 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(197043, NULL, 'G3DSA:2.130.10.10:FF:004642', NULL, NULL, 'Cilia and flagella associated protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(197044, NULL, 'G3DSA:3.90.640.10:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197045, NULL, 'G3DSA:1.10.10.1410:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197046, NULL, 'G3DSA:3.20.190.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197047, NULL, 'G3DSA:3.60.21.10:FF:000189', NULL, NULL, 'Lmo2106 protein', NULL, NULL, NULL, NULL, NULL, 4),
(197048, NULL, 'G3DSA:3.80.10.10:FF:004221', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(197049, NULL, 'G3DSA:1.25.40.90:FF:000027', NULL, NULL, 'Putative clathrin assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(197050, NULL, 'G3DSA:2.60.120.200:FF:000291', NULL, NULL, 'NeuReXin related', NULL, NULL, NULL, NULL, NULL, 4),
(197051, NULL, 'G3DSA:3.40.50.1000:FF:000579', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197052, NULL, 'G3DSA:1.25.40.10:FF:002078', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(197053, NULL, 'G3DSA:2.120.10.30:FF:000545', NULL, NULL, 'uncharacterized protein LOC100186233 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(197054, NULL, 'G3DSA:6.20.50.160:FF:000006', NULL, NULL, 'MHC-linked complement C4', NULL, NULL, NULL, NULL, NULL, 4),
(197055, NULL, 'G3DSA:1.25.40.10:FF:002786', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197056, NULL, 'G3DSA:4.10.270.10:FF:000004', NULL, NULL, 'unconventional myosin-XVIIIa isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(197057, NULL, 'G3DSA:3.40.50.620:FF:000590', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(197058, NULL, 'G3DSA:3.20.20.190:FF:000004', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(197059, NULL, 'G3DSA:2.40.10.10:FF:000577', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197060, NULL, 'G3DSA:3.30.450.20:FF:000419', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(197061, NULL, 'G3DSA:3.40.50.720:FF:000322', NULL, NULL, 'Putative malate dehydrogenase 1B', NULL, NULL, NULL, NULL, NULL, 4),
(197062, NULL, 'G3DSA:3.40.1110.10:FF:000310', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(197063, NULL, 'G3DSA:1.25.40.10:FF:000869', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g53700, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(197064, NULL, 'G3DSA:3.30.1520.10:FF:000017', NULL, NULL, 'ribosomal protein S6 kinase delta-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(197065, NULL, 'G3DSA:3.30.160.60:FF:003186', NULL, NULL, 'RT01028p', NULL, NULL, NULL, NULL, NULL, 4),
(197066, NULL, 'G3DSA:1.10.510.10:FF:000479', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(197067, NULL, 'G3DSA:1.25.40.10:FF:000925', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(197068, NULL, 'G3DSA:3.90.70.10:FF:000874', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197069, NULL, 'G3DSA:1.20.1250.20:FF:002178', NULL, NULL, 'Putative inorganic phosphate cotransporter-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(197070, NULL, 'G3DSA:1.20.1250.10:FF:000051', NULL, NULL, 'Type I interferon', NULL, NULL, NULL, NULL, NULL, 4),
(197071, NULL, 'G3DSA:3.30.70.330:FF:002038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197072, NULL, 'G3DSA:3.40.50.300:FF:005249', NULL, NULL, 'ras-related protein RABA2b-like', NULL, NULL, NULL, NULL, NULL, 4),
(197073, NULL, 'G3DSA:3.30.70.330:FF:000386', NULL, NULL, 'Zinc finger protein 638', NULL, NULL, NULL, NULL, NULL, 4),
(197074, NULL, 'G3DSA:3.40.50.300:FF:006828', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197075, NULL, 'G3DSA:3.40.50.10190:FF:000160', NULL, NULL, 'DNA damage response protein RcaA', NULL, NULL, NULL, NULL, NULL, 4),
(197076, NULL, 'G3DSA:3.30.160.60:FF:001590', NULL, NULL, 'zinc finger protein 189 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(197077, NULL, 'G3DSA:3.90.340.10:FF:000013', NULL, NULL, 'Nitric oxide synthase, inducible', NULL, NULL, NULL, NULL, NULL, 4),
(197078, NULL, 'G3DSA:2.20.25.30:FF:000005', NULL, NULL, 'Ribosomal protein L37', NULL, NULL, NULL, NULL, NULL, 4),
(197079, NULL, 'G3DSA:2.10.220.10:FF:000020', NULL, NULL, 'Furin-like protease 2', NULL, NULL, NULL, NULL, NULL, 4),
(197080, NULL, 'G3DSA:3.40.50.2000:FF:001003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197081, NULL, 'G3DSA:1.25.40.20:FF:000928', NULL, NULL, 'Protein 21.1', NULL, NULL, NULL, NULL, NULL, 4),
(197082, NULL, 'G3DSA:3.40.50.620:FF:000354', NULL, NULL, 'Unplaced genomic scaffold supercont1.25, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(197083, NULL, 'G3DSA:3.30.710.10:FF:000307', NULL, NULL, 'ZBTB49 isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(197084, NULL, 'G3DSA:3.30.160.60:FF:003242', NULL, NULL, 'Testis-specific zinc finger protein topi', NULL, NULL, NULL, NULL, NULL, 4),
(197085, NULL, 'G3DSA:2.40.50.40:FF:000037', NULL, NULL, 'Heterochromatin protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(197086, NULL, 'G3DSA:3.90.226.10:FF:000079', NULL, NULL, 'Enoyl-CoA hydratase/isomerase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(197087, NULL, 'G3DSA:1.10.8.60:FF:000111', NULL, NULL, 'Two component Fis family sigma54 specific transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(197088, NULL, 'G3DSA:2.20.25.20:FF:000002', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(197089, NULL, 'G3DSA:3.80.10.10:FF:003849', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197090, NULL, 'G3DSA:3.60.10.10:FF:000107', NULL, NULL, 'Calcium-binding endonuclease/exonuclease/phosphatase family', NULL, NULL, NULL, NULL, NULL, 4),
(197091, NULL, 'G3DSA:1.20.1270.50:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197092, NULL, 'G3DSA:3.40.50.620:FF:000410', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(197093, NULL, 'G3DSA:3.30.420.10:FF:000353', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197094, NULL, 'G3DSA:1.20.920.10:FF:000064', NULL, NULL, 'Polybromo 1', NULL, NULL, NULL, NULL, NULL, 4),
(197095, NULL, 'G3DSA:3.30.70.870:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(197096, NULL, 'G3DSA:1.20.58.60:FF:000160', NULL, NULL, 'Periplakin', NULL, NULL, NULL, NULL, NULL, 4),
(197097, NULL, 'G3DSA:1.10.1450.10:FF:000158', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(197098, NULL, 'G3DSA:3.30.565.10:FF:000498', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197099, NULL, 'G3DSA:3.60.20.10:FF:000142', NULL, NULL, 'Glucosamine-fructose-6-phosphate aminotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197100, NULL, 'G3DSA:2.10.25.10:FF:000730', NULL, NULL, 'Crumbs family member 1, photoreceptor morphogenesis associated', NULL, NULL, NULL, NULL, NULL, 4),
(197101, NULL, 'G3DSA:2.60.40.3180:FF:000009', NULL, NULL, 'EBF2', NULL, NULL, NULL, NULL, NULL, 4),
(197102, NULL, 'G3DSA:1.20.272.40:FF:000010', NULL, NULL, 'Putative RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(197103, NULL, 'G3DSA:2.20.70.10:FF:000008', NULL, NULL, 'E3 ubiquitin-protein ligase NEDD4-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(197104, NULL, 'G3DSA:1.20.1270.60:FF:000016', NULL, NULL, 'FCH domain only protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(197105, NULL, 'G3DSA:1.10.8.430:FF:000013', NULL, NULL, 'Disease resistance protein RPM1', NULL, NULL, NULL, NULL, NULL, 4),
(197106, NULL, 'G3DSA:3.30.160.60:FF:005333', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197107, NULL, 'G3DSA:2.60.120.260:FF:000319', NULL, NULL, 'Beta-galactosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197108, NULL, 'G3DSA:1.25.40.20:FF:001390', NULL, NULL, 'DNA-binding protein RFXANK', NULL, NULL, NULL, NULL, NULL, 4),
(197109, NULL, 'G3DSA:1.10.8.10:FF:000085', NULL, NULL, 'protein NBR1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(197110, NULL, 'G3DSA:3.40.50.300:FF:007290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197111, NULL, 'G3DSA:1.10.600.10:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197112, NULL, 'G3DSA:3.30.160.20:FF:000111', NULL, NULL, 'Peptide chain release factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(197113, NULL, 'G3DSA:3.30.200.20:FF:000671', NULL, NULL, 'Phosphoenolpyruvate carboxylase kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(197114, NULL, 'G3DSA:1.10.8.270:FF:000089', NULL, NULL, 'Rab GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197115, NULL, 'G3DSA:3.40.50.150:FF:000983', NULL, NULL, 'Leucine carboxyl methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(197116, NULL, 'G3DSA:1.20.920.20:FF:000067', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(197117, NULL, 'G3DSA:2.40.270.10:FF:000016', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(197118, NULL, 'G3DSA:3.40.50.300:FF:001360', NULL, NULL, 'ABC transporter I family member 10', NULL, NULL, NULL, NULL, NULL, 4),
(197119, NULL, 'G3DSA:2.10.25.10:FF:000084', NULL, NULL, 'Laminin subunit alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(197120, NULL, 'G3DSA:2.60.40.4100:FF:000027', NULL, NULL, 'Zona pellucida protein C', NULL, NULL, NULL, NULL, NULL, 4),
(197121, NULL, 'G3DSA:3.40.30.10:FF:001059', NULL, NULL, 'AER330Wp', NULL, NULL, NULL, NULL, NULL, 4),
(197122, NULL, 'G3DSA:3.30.2350.10:FF:000066', NULL, NULL, 'Ribosomal large subunit pseudouridine synthase D', NULL, NULL, NULL, NULL, NULL, 4),
(197123, NULL, 'G3DSA:3.30.300.30:FF:000092', NULL, NULL, 'Flagellar M-ring protein', NULL, NULL, NULL, NULL, NULL, 4),
(197124, NULL, 'G3DSA:2.170.120.40:FF:000001', NULL, NULL, 'YbbR-like domain-containing protein ybbR', NULL, NULL, NULL, NULL, NULL, 4),
(197125, NULL, 'G3DSA:3.30.420.40:FF:000839', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197126, NULL, 'G3DSA:3.40.50.1000:FF:000815', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197127, NULL, 'G3DSA:3.40.50.460:FF:000047', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(197128, NULL, 'G3DSA:3.80.10.10:FF:002068', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(197129, NULL, 'G3DSA:2.60.260.20:FF:000059', NULL, NULL, 'DnaJ homolog dnj-10', NULL, NULL, NULL, NULL, NULL, 4),
(197130, NULL, 'G3DSA:1.20.930.10:FF:000036', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(197131, NULL, 'G3DSA:3.60.21.10:FF:000020', NULL, NULL, 'NT5E isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(197132, NULL, 'G3DSA:2.130.10.10:FF:001207', NULL, NULL, 'Periodic tryptophan protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(197133, NULL, 'G3DSA:3.90.1150.10:FF:000087', NULL, NULL, 'Putative methionine gamma-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(197134, NULL, 'G3DSA:3.30.2350.20:FF:000069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197135, NULL, 'G3DSA:3.100.10.10:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197136, NULL, 'G3DSA:1.10.8.270:FF:000145', NULL, NULL, 'MGC16169 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197137, NULL, 'G3DSA:3.40.50.300:FF:005575', NULL, NULL, 'Dynein, axonemal, heavy chain 14', NULL, NULL, NULL, NULL, NULL, 4),
(197138, NULL, 'G3DSA:3.80.10.10:FF:001995', NULL, NULL, 'Probable leucine-rich repeat receptor-like protein kinase At2g33170', NULL, NULL, NULL, NULL, NULL, 4),
(197139, NULL, 'G3DSA:2.60.120.10:FF:000170', NULL, NULL, 'AGC protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(197140, NULL, 'G3DSA:3.40.1190.20:FF:000115', NULL, NULL, 'PfkB domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(197141, NULL, 'G3DSA:3.40.309.10:FF:000081', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(197142, NULL, 'G3DSA:3.30.160.60:FF:004967', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197143, NULL, 'G3DSA:2.40.50.140:FF:000725', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197144, NULL, 'G3DSA:1.25.40.10:FF:005130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197145, NULL, 'G3DSA:2.60.120.480:FF:000003', NULL, NULL, 'Ureidoglycolate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(197146, NULL, 'G3DSA:3.30.420.10:FF:000027', NULL, NULL, 'Putative CCR4-associated factor 1 7', NULL, NULL, NULL, NULL, NULL, 4),
(197147, NULL, 'G3DSA:2.60.40.10:FF:005361', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197148, NULL, 'G3DSA:2.60.120.200:FF:000257', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(197149, NULL, 'G3DSA:2.10.25.10:FF:000404', NULL, NULL, 'Weary, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(197150, NULL, 'G3DSA:3.30.428.10:FF:000056', NULL, NULL, 'Si:ch211-256m1.8', NULL, NULL, NULL, NULL, NULL, 4),
(197151, NULL, 'G3DSA:3.40.50.720:FF:001396', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197152, NULL, 'G3DSA:3.90.470.40:FF:000003', NULL, NULL, 'Charybde, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(197153, NULL, 'G3DSA:1.10.460.10:FF:000036', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(197154, NULL, 'G3DSA:3.90.1140.10:FF:000019', NULL, NULL, 'RNA 2'',3''-cyclic phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(197155, NULL, 'G3DSA:1.25.40.10:FF:001061', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(197156, NULL, 'G3DSA:2.60.40.10:FF:005209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197157, NULL, 'G3DSA:3.90.1750.20:FF:000001', NULL, NULL, 'Resolvase family site-specific recombinase', NULL, NULL, NULL, NULL, NULL, 4),
(197158, NULL, 'G3DSA:3.30.470.20:FF:000067', NULL, NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(197159, NULL, 'G3DSA:3.30.160.60:FF:003388', NULL, NULL, 'Zinc finger and BTB domain-containing protein 7A', NULL, NULL, NULL, NULL, NULL, 4),
(197160, NULL, 'G3DSA:2.130.10.10:FF:001270', NULL, NULL, 'WD repeat-containing protein 44 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(197161, NULL, 'G3DSA:3.40.605.10:FF:000100', NULL, NULL, 'Aldehyde dehydrogenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(197162, NULL, 'G3DSA:2.30.29.30:FF:000165', NULL, NULL, 'TBC1 domain family member 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(197163, NULL, 'G3DSA:3.80.10.10:FF:003001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197164, NULL, 'G3DSA:3.30.1490.80:FF:000023', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(197165, NULL, 'G3DSA:3.20.20.70:FF:000228', NULL, NULL, 'FMN-dependent dehydrogenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(197166, NULL, 'G3DSA:1.25.40.20:FF:001064', NULL, NULL, 'Protein lin-12', NULL, NULL, NULL, NULL, NULL, 4),
(197167, NULL, 'G3DSA:3.30.200.20:FF:000519', NULL, NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(197168, NULL, 'G3DSA:2.170.120.12:FF:000028', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(197169, NULL, 'G3DSA:4.10.410.10:FF:000010', NULL, NULL, 'Alpha1-microglobulin/bikunin (AMBP)', NULL, NULL, NULL, NULL, NULL, 4),
(197170, NULL, 'G3DSA:2.30.30.40:FF:000559', NULL, NULL, 'Si:dkey-40c11.2', NULL, NULL, NULL, NULL, NULL, 4),
(197171, NULL, 'G3DSA:3.40.850.10:FF:000416', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(197172, NULL, 'G3DSA:3.40.50.2300:FF:000806', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197173, NULL, 'G3DSA:2.30.30.140:FF:000206', NULL, NULL, 'Transcription elongation factor s-II', NULL, NULL, NULL, NULL, NULL, 4),
(197174, NULL, 'G3DSA:3.30.450.20:FF:000184', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(197175, NULL, 'G3DSA:3.40.50.300:FF:005047', NULL, NULL, 'Carbohydrate sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(197176, NULL, 'G3DSA:2.170.300.10:FF:000023', NULL, NULL, 'Platelet endothelial aggregation receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(197177, NULL, 'G3DSA:1.10.10.10:FF:001614', NULL, NULL, 'ELK1, ETS transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(197178, NULL, 'G3DSA:2.60.120.290:FF:000008', NULL, NULL, 'Attractin like 1', NULL, NULL, NULL, NULL, NULL, 4),
(197179, NULL, 'G3DSA:3.10.129.10:FF:000023', NULL, NULL, 'Acyl-coenzyme A thioesterase 9, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(197180, NULL, 'G3DSA:3.40.710.10:FF:000081', NULL, NULL, 'Penicillin-binding protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(197181, NULL, 'G3DSA:3.40.50.720:FF:000294', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(197182, NULL, 'G3DSA:3.10.129.10:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197183, NULL, 'G3DSA:3.40.50.300:FF:003451', NULL, NULL, 'Multidrug resistance protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(197184, NULL, 'G3DSA:4.10.1000.10:FF:000083', NULL, NULL, 'Zinc finger C-x8-C-x5-C-x3-H type family protein', NULL, NULL, NULL, NULL, NULL, 4),
(197185, NULL, 'G3DSA:1.20.144.10:FF:000058', NULL, NULL, 'Phospholipid phosphatase 3', NULL, NULL, NULL, NULL, NULL, 4),
(197186, NULL, 'G3DSA:3.30.1330.40:FF:000023', NULL, NULL, 'Cytoplasmic protein, variant', NULL, NULL, NULL, NULL, NULL, 4),
(197187, NULL, 'G3DSA:3.30.420.10:FF:000151', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(197188, NULL, 'G3DSA:2.130.10.10:FF:002961', NULL, NULL, 'Pre-rRNA-processing protein IPI3', NULL, NULL, NULL, NULL, NULL, 4),
(197189, NULL, 'G3DSA:1.25.40.10:FF:004764', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197190, NULL, 'G3DSA:3.40.50.300:FF:003804', NULL, NULL, 'DNA repair protein RAD50 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(197191, NULL, 'G3DSA:2.60.120.260:FF:000645', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197192, NULL, 'G3DSA:3.30.465.10:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197193, NULL, 'G3DSA:3.30.1890.10:FF:000005', NULL, NULL, 'Chain length determinant protein', NULL, NULL, NULL, NULL, NULL, 4),
(197194, NULL, 'G3DSA:3.30.1330.30:FF:000020', NULL, NULL, '50S ribosomal protein L7Ae', NULL, NULL, NULL, NULL, NULL, 4),
(197195, NULL, 'G3DSA:1.10.10.10:FF:000569', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(197196, NULL, 'G3DSA:2.130.10.10:FF:005541', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197197, NULL, 'G3DSA:3.90.960.10:FF:000009', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(197198, NULL, 'G3DSA:3.90.1150.10:FF:000317', NULL, NULL, 'Serine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(197199, NULL, 'G3DSA:1.20.58.1220:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197200, NULL, 'G3DSA:2.10.25.10:FF:001388', NULL, NULL, 'C-type lectin domain family 14 member A', NULL, NULL, NULL, NULL, NULL, 4),
(197201, NULL, 'G3DSA:3.40.50.1220:FF:000117', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(197202, NULL, 'G3DSA:3.40.50.10470:FF:000030', NULL, NULL, 'Translation initiation factor eIF2B subunit-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197203, NULL, 'G3DSA:1.20.990.10:FF:000012', NULL, NULL, 'NADPH-dependent diflavin oxidoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(197204, NULL, 'G3DSA:3.30.70.1730:FF:000014', NULL, NULL, 'Ribosome biogenesis protein MRT4', NULL, NULL, NULL, NULL, NULL, 4),
(197205, NULL, 'G3DSA:2.120.10.30:FF:000489', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197206, NULL, 'G3DSA:3.40.720.10:FF:000227', NULL, NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase putative', NULL, NULL, NULL, NULL, NULL, 4),
(197207, NULL, 'G3DSA:2.40.50.140:FF:001124', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197208, NULL, 'G3DSA:3.40.50.300:FF:007610', NULL, NULL, 'Zinc finger GRF-type containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(197209, NULL, 'G3DSA:1.10.510.10:FF:002896', NULL, NULL, 'CK1 family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(197210, NULL, 'G3DSA:3.40.50.10240:FF:000017', NULL, NULL, 'Thiamin pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(197211, NULL, 'G3DSA:3.40.50.1240:FF:000185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197212, NULL, 'G3DSA:1.25.10.10:FF:001087', NULL, NULL, 'Cytoskeleton-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(197213, NULL, 'G3DSA:3.30.40.10:FF:002156', NULL, NULL, 'Structure-specific endonuclease subunit slx1', NULL, NULL, NULL, NULL, NULL, 4),
(197214, NULL, 'G3DSA:1.10.150.240:FF:000068', NULL, NULL, 'HAD hydrolase, family IA, variant 3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197215, NULL, 'G3DSA:4.10.60.10:FF:000189', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(197216, NULL, 'G3DSA:3.40.50.1820:FF:000084', NULL, NULL, 'Isoprenylcysteine alpha-carbonyl methylesterase ICME', NULL, NULL, NULL, NULL, NULL, 4),
(197217, NULL, 'G3DSA:3.80.10.10:FF:000270', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(197218, NULL, 'G3DSA:3.40.50.10490:FF:000036', NULL, NULL, 'Glutamine-fructose-6-phosphate transaminase (Isomerizing), variant', NULL, NULL, NULL, NULL, NULL, 4),
(197219, NULL, 'G3DSA:3.40.50.920:FF:000028', NULL, NULL, 'Ferredoxin oxidoreductase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(197220, NULL, 'G3DSA:3.10.100.10:FF:000266', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197221, NULL, 'G3DSA:3.40.50.920:FF:000056', NULL, NULL, 'Putative branched-chain alpha-keto acid dehydrogenase subunit e1-beta', NULL, NULL, NULL, NULL, NULL, 4),
(197222, NULL, 'G3DSA:3.30.470.20:FF:000128', NULL, NULL, 'Tubulin--tyrosine ligase-like protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(197223, NULL, 'G3DSA:3.30.390.80:FF:000005', NULL, NULL, 'DNA repair protein RAD59', NULL, NULL, NULL, NULL, NULL, 4),
(197224, NULL, 'G3DSA:4.10.240.10:FF:000210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197225, NULL, 'G3DSA:3.40.50.300:FF:000994', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(197226, NULL, 'G3DSA:3.40.1110.10:FF:000192', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(197227, NULL, 'G3DSA:1.25.10.10:FF:000777', NULL, NULL, 'AGAP004782-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(197228, NULL, 'G3DSA:1.25.40.10:FF:005074', NULL, NULL, 'Rapsynoid, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197229, NULL, 'G3DSA:1.10.3860.10:FF:000032', NULL, NULL, 'Amino acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(197230, NULL, 'G3DSA:1.10.1750.10:FF:000001', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(197231, NULL, 'G3DSA:2.40.10.10:FF:000285', NULL, NULL, 'Granzyme-like I', NULL, NULL, NULL, NULL, NULL, 4),
(197232, NULL, 'G3DSA:3.40.50.410:FF:000263', NULL, NULL, 'Calcium voltage-gated channel auxiliary subunit alpha2delta 4', NULL, NULL, NULL, NULL, NULL, 4),
(197233, NULL, 'G3DSA:3.30.420.40:FF:000991', NULL, NULL, 'LL-diaminopimelate aminotransferase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(197234, NULL, 'G3DSA:4.10.80.40:FF:000002', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] flavoprotein subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(197235, NULL, 'G3DSA:2.60.40.10:FF:001522', NULL, NULL, 'immunoglobulin superfamily member 22', NULL, NULL, NULL, NULL, NULL, 4),
(197236, NULL, 'G3DSA:2.60.40.10:FF:003118', NULL, NULL, 'Penicillin-binding proteins 1A and 1B', NULL, NULL, NULL, NULL, NULL, 4),
(197237, NULL, 'G3DSA:3.40.1280.10:FF:000029', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4),
(197238, NULL, 'G3DSA:3.40.50.720:FF:000614', NULL, NULL, '3-oxoacyl-ACP reductase FabG', NULL, NULL, NULL, NULL, NULL, 4),
(197239, NULL, 'G3DSA:1.20.1740.10:FF:000223', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(197240, NULL, 'G3DSA:1.10.472.10:FF:000586', NULL, NULL, 'Cyclin, N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(197241, NULL, 'G3DSA:1.10.1420.10:FF:000010', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(197242, NULL, 'G3DSA:3.30.342.10:FF:000042', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(197243, NULL, 'G3DSA:1.20.58.2130:FF:000002', NULL, NULL, 'DNA replication regulator SLD3', NULL, NULL, NULL, NULL, NULL, 4),
(197244, NULL, 'G3DSA:3.40.50.620:FF:000882', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197245, NULL, 'G3DSA:3.10.20.90:FF:001016', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(197246, NULL, 'G3DSA:3.40.920.10:FF:000001', NULL, NULL, 'Pyruvate:ferredoxin (Flavodoxin) oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(197247, NULL, 'G3DSA:3.40.50.360:FF:000107', NULL, NULL, 'Potassium/proton antiporter ancillary protein', NULL, NULL, NULL, NULL, NULL, 4),
(197248, NULL, 'G3DSA:1.20.58.2140:FF:000005', NULL, NULL, 'Translin', NULL, NULL, NULL, NULL, NULL, 4),
(197249, NULL, 'G3DSA:1.20.1530.20:FF:000036', NULL, NULL, 'Kha1p', NULL, NULL, NULL, NULL, NULL, 4),
(197250, NULL, 'G3DSA:1.20.1070.10:FF:000604', NULL, NULL, 'G protein-coupled receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197251, NULL, 'G3DSA:3.40.50.720:FF:002385', NULL, NULL, 'Oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197252, NULL, 'G3DSA:2.40.37.10:FF:000060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197253, NULL, 'G3DSA:2.30.40.10:FF:000045', NULL, NULL, 'Imidazolonepropionase', NULL, NULL, NULL, NULL, NULL, 4),
(197254, NULL, 'G3DSA:3.80.10.10:FF:003647', NULL, NULL, 'Disease resistance protein SUMM2', NULL, NULL, NULL, NULL, NULL, 4),
(197255, NULL, 'G3DSA:3.40.50.800:FF:000020', NULL, NULL, 'Probable proline--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(197256, NULL, 'G3DSA:3.40.50.300:FF:006677', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(197257, NULL, 'G3DSA:3.30.1330.10:FF:000008', NULL, NULL, 'Thiamine-monophosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(197258, NULL, 'G3DSA:2.40.50.90:FF:000119', NULL, NULL, 'Thermococcal nuclease homolog', NULL, NULL, NULL, NULL, NULL, 4),
(197259, NULL, 'G3DSA:2.130.10.10:FF:001500', NULL, NULL, 'WD domain, G-beta repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(197260, NULL, 'G3DSA:3.30.420.40:FF:000688', NULL, NULL, '(R)-2-hydroxyacyl-CoA dehydratase-radicalizing ATPase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(197261, NULL, 'G3DSA:1.10.287.70:FF:000510', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(197262, NULL, 'G3DSA:1.25.10.10:FF:002868', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(197263, NULL, 'G3DSA:3.40.366.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197264, NULL, 'G3DSA:3.30.160.60:FF:002899', NULL, NULL, 'Zgc:162972 protein', NULL, NULL, NULL, NULL, NULL, 4),
(197265, NULL, 'G3DSA:3.30.710.10:FF:000370', NULL, NULL, 'BTB/POZ domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(197266, NULL, 'G3DSA:2.30.42.10:FF:000027', NULL, NULL, 'Signal-induced proliferation-associated 1-like protein 1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(197267, NULL, 'G3DSA:2.10.25.10:FF:000932', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1a', NULL, NULL, NULL, NULL, NULL, 4),
(197268, NULL, 'G3DSA:3.40.50.620:FF:000028', NULL, NULL, 'Bifunctional protein HldE', NULL, NULL, NULL, NULL, NULL, 4),
(197269, NULL, 'G3DSA:1.25.40.10:FF:000723', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(197270, NULL, 'G3DSA:1.20.1250.20:FF:000054', NULL, NULL, 'Fosmidomycin resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(197271, NULL, 'G3DSA:4.10.410.20:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197272, NULL, 'G3DSA:3.40.50.11210:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197273, NULL, 'G3DSA:1.25.10.10:FF:001031', NULL, NULL, 'Protein required for meiosis', NULL, NULL, NULL, NULL, NULL, 4),
(197274, NULL, 'G3DSA:3.30.160.60:FF:000898', NULL, NULL, 'zinc finger RNA-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(197275, NULL, 'G3DSA:1.25.40.20:FF:000698', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(197276, NULL, 'G3DSA:3.40.50.2300:FF:000542', NULL, NULL, 'Penicillin-binding protein activator LpoA', NULL, NULL, NULL, NULL, NULL, 4),
(197277, NULL, 'G3DSA:1.20.1270.60:FF:000140', NULL, NULL, 'Variant sh3 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(197278, NULL, 'G3DSA:3.30.9.10:FF:000004', NULL, NULL, 'D-amino-acid oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(197279, NULL, 'G3DSA:1.20.1110.10:FF:000102', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(197280, NULL, 'G3DSA:3.40.50.2300:FF:000486', NULL, NULL, 'PTS system, fructose-specific IIB component', NULL, NULL, NULL, NULL, NULL, 4),
(197281, NULL, 'G3DSA:2.60.120.290:FF:000160', NULL, NULL, 'Cubilin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(197282, NULL, 'G3DSA:3.30.540.10:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197283, NULL, 'G3DSA:3.10.129.10:FF:000169', NULL, NULL, 'Thioesterase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(197284, NULL, 'G3DSA:1.10.510.10:FF:003115', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197285, NULL, 'G3DSA:3.40.50.620:FF:000180', NULL, NULL, 'Cytidyltransferase isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(197286, NULL, 'G3DSA:3.40.50.720:FF:000092', NULL, NULL, 'Siroheme synthase', NULL, NULL, NULL, NULL, NULL, 4),
(197287, NULL, 'G3DSA:3.30.40.10:FF:000532', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(197288, NULL, 'G3DSA:1.25.40.720:FF:000004', NULL, NULL, 'WGS project CABT00000000 data, contig 2.6', NULL, NULL, NULL, NULL, NULL, 4),
(197289, NULL, 'G3DSA:3.90.180.10:FF:000157', NULL, NULL, 'Os11g0210600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(197290, NULL, 'G3DSA:3.40.640.10:FF:000463', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197291, NULL, 'G3DSA:1.20.80.10:FF:000056', NULL, NULL, 'band 4.1-like protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(197292, NULL, 'G3DSA:1.10.15.30:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197293, NULL, 'G3DSA:2.130.10.10:FF:003068', NULL, NULL, 'WD_domain_-_G-beta_repeat_-_putative', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(197294, NULL, 'G3DSA:3.30.160.60:FF:000954', NULL, NULL, 'Zinc finger and BTB domain containing 40', NULL, NULL, NULL, NULL, NULL, 4),
(197295, NULL, 'G3DSA:2.130.10.10:FF:003124', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(197296, NULL, 'G3DSA:2.130.10.10:FF:000718', NULL, NULL, 'cilia- and flagella-associated protein 52 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(197297, NULL, 'G3DSA:3.30.230.40:FF:000010', NULL, NULL, 'Imidazoleglycerol-phosphate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(197298, NULL, 'G3DSA:1.25.40.10:FF:000695', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g03800', NULL, NULL, NULL, NULL, NULL, 4),
(197299, NULL, 'G3DSA:1.25.40.710:FF:000001', NULL, NULL, 'Tripeptidyl peptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(197300, NULL, 'G3DSA:3.90.1150.10:FF:000407', NULL, NULL, 'Serine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(197301, NULL, 'G3DSA:2.60.40.10:FF:002011', NULL, NULL, 'B-cell receptor CD22', NULL, NULL, NULL, NULL, NULL, 4),
(197302, NULL, 'G3DSA:2.30.40.10:FF:000135', NULL, NULL, 'Guanine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(197303, NULL, 'G3DSA:1.20.1560.10:FF:000035', NULL, NULL, 'Multidrug ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(197304, NULL, 'G3DSA:3.60.40.10:FF:000025', NULL, NULL, 'Protein phosphatase 2C 16', NULL, NULL, NULL, NULL, NULL, 4),
(197305, NULL, 'G3DSA:1.10.490.10:FF:000038', NULL, NULL, 'Globin-like protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(197306, NULL, 'G3DSA:1.10.10.10:FF:000597', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(197307, NULL, 'G3DSA:3.30.70.330:FF:003151', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197308, NULL, 'G3DSA:1.20.1070.10:FF:001588', NULL, NULL, 'Odorant receptor 10', NULL, NULL, NULL, NULL, NULL, 4),
(197309, NULL, 'G3DSA:3.40.50.800:FF:000110', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(197310, NULL, 'G3DSA:3.40.50.300:FF:005373', NULL, NULL, 'mRNA cleavage and polyadenylation factor complex II subunit', NULL, NULL, NULL, NULL, NULL, 4),
(197311, NULL, 'G3DSA:1.10.100.10:FF:000015', NULL, NULL, 'Insulin-like peptide 6', NULL, NULL, NULL, NULL, NULL, 4),
(197312, NULL, 'G3DSA:2.130.10.10:FF:004698', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197313, NULL, 'G3DSA:2.10.25.10:FF:000606', NULL, NULL, 'Complement component C1q receptor', NULL, NULL, NULL, NULL, NULL, 4),
(197314, NULL, 'G3DSA:3.40.50.720:FF:000440', NULL, NULL, 'Short chain dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(197315, NULL, 'G3DSA:1.25.10.10:FF:001233', NULL, NULL, 'Armadillo/beta-catenin-like_repeat_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(197316, NULL, 'G3DSA:3.40.190.10:FF:000736', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(197317, NULL, 'G3DSA:3.40.50.1820:FF:001573', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197318, NULL, 'G3DSA:1.25.40.10:FF:003505', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(197319, NULL, 'G3DSA:1.20.58.610:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197320, NULL, 'G3DSA:3.40.220.10:FF:000032', NULL, NULL, 'Appr-1-p processing enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(197321, NULL, 'G3DSA:3.30.710.10:FF:000280', NULL, NULL, 'Growth/cell cycle/stress response regulation protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197322, NULL, 'G3DSA:3.40.50.150:FF:001472', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197323, NULL, 'G3DSA:3.40.50.10190:FF:000221', NULL, NULL, 'DNA repair protein XRCC1-like', NULL, NULL, NULL, NULL, NULL, 4),
(197324, NULL, 'G3DSA:1.20.1560.10:FF:000512', NULL, NULL, 'ABC transporter, multidrug resistance associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(197325, NULL, 'G3DSA:1.10.287.370:FF:000050', NULL, NULL, 'Coiled-coil protein, putative', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(197326, NULL, 'G3DSA:3.30.70.1450:FF:000054', NULL, NULL, 'Trk system potassium uptake protein TrkA (K(+)-uptake protein trkA)', NULL, NULL, NULL, NULL, NULL, 4),
(197327, NULL, 'G3DSA:2.60.40.10:FF:001612', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(197328, NULL, 'G3DSA:1.10.1200.10:FF:000027', NULL, NULL, 'Nonribosomal siderophore peptide synthase SidC', NULL, NULL, NULL, NULL, NULL, 4),
(197329, NULL, 'G3DSA:3.80.10.10:FF:002214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197330, NULL, 'G3DSA:2.60.40.10:FF:002596', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(197331, NULL, 'G3DSA:1.25.10.10:FF:002812', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197332, NULL, 'G3DSA:2.60.40.10:FF:003736', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197333, NULL, 'G3DSA:4.10.60.10:FF:000099', NULL, NULL, 'Cellular nucleic acid-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(197334, NULL, 'G3DSA:2.10.25.10:FF:000258', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(197335, NULL, 'G3DSA:3.10.400.20:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197336, NULL, 'G3DSA:2.130.10.10:FF:000483', NULL, NULL, 'U3 snoRNP-associated protein-like EMB2271', NULL, NULL, NULL, NULL, NULL, 4),
(197337, NULL, 'G3DSA:1.20.58.60:FF:000811', NULL, NULL, 'Spectrin repeat containing nuclear envelope protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(197338, NULL, 'G3DSA:1.20.1070.10:FF:000930', NULL, NULL, 'Olfactory receptor 1457', NULL, NULL, NULL, NULL, NULL, 4),
(197339, NULL, 'G3DSA:3.30.1250.10:FF:000002', NULL, NULL, 'YHR087W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(197340, NULL, 'G3DSA:2.60.40.10:FF:001320', NULL, NULL, 'Putative Defective proboscis extension response', NULL, NULL, NULL, NULL, NULL, 4),
(197341, NULL, 'G3DSA:1.10.4090.10:FF:000001', NULL, NULL, 'Capsid protein', NULL, NULL, NULL, NULL, NULL, 4),
(197342, NULL, 'G3DSA:1.25.40.10:FF:001712', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(197343, NULL, 'G3DSA:1.10.287.70:FF:000420', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(197344, NULL, 'G3DSA:3.40.50.300:FF:005721', NULL, NULL, 'Dynein heavy chain domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(197345, NULL, 'G3DSA:6.10.140.2220:FF:000032', NULL, NULL, 'GM24661', NULL, NULL, NULL, NULL, NULL, 4),
(197346, NULL, 'G3DSA:2.10.25.10:FF:000230', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(197347, NULL, 'G3DSA:3.90.1600.10:FF:000038', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(197348, NULL, 'G3DSA:1.20.120.550:FF:000023', NULL, NULL, 'Microsomal glutathione S-transferase 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(197349, NULL, 'G3DSA:2.60.120.590:FF:000036', NULL, NULL, 'AlkB homolog 3, alpha-ketoglutarate-dependent dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(197350, NULL, 'G3DSA:3.40.50.12780:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197351, NULL, 'G3DSA:3.30.160.20:FF:000116', NULL, NULL, 'Mitochondrial ribosomal protein L44', NULL, NULL, NULL, NULL, NULL, 4),
(197352, NULL, 'G3DSA:1.10.630.10:FF:000134', NULL, NULL, 'Cytochrome P450 family 2 subfamily S member 1', NULL, NULL, NULL, NULL, NULL, 4),
(197353, NULL, 'G3DSA:3.40.50.300:FF:001534', NULL, NULL, 'Interferon induced protein 44 like', NULL, NULL, NULL, NULL, NULL, 4),
(197354, NULL, 'G3DSA:1.25.40.20:FF:001715', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(197355, NULL, 'G3DSA:2.130.10.10:FF:004850', NULL, NULL, 'Cytoplasmic dynein intermediate chain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(197356, NULL, 'G3DSA:2.40.70.10:FF:000496', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197357, NULL, 'G3DSA:3.40.50.11660:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197358, NULL, 'G3DSA:1.20.5.220:FF:000009', NULL, NULL, 'Ubiquinol-Cytochrome c oxidoReductase complex', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(197359, NULL, 'G3DSA:1.10.510.10:FF:001850', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(197360, NULL, 'G3DSA:3.30.200.20:FF:002560', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197361, NULL, 'G3DSA:3.30.1550.10:FF:000019', NULL, NULL, '60S ribosomal protein L11, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(197362, NULL, 'G3DSA:1.25.40.630:FF:000005', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(197363, NULL, 'G3DSA:3.20.20.80:FF:000350', NULL, NULL, 'Endo-1,4-beta-xylanase Y', NULL, NULL, NULL, NULL, NULL, 4),
(197364, NULL, 'G3DSA:4.10.520.10:FF:000013', NULL, NULL, 'Probable DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(197365, NULL, 'G3DSA:1.25.10.10:FF:000867', NULL, NULL, 'Ecm29p', NULL, NULL, NULL, NULL, NULL, 4),
(197366, NULL, 'G3DSA:3.90.550.10:FF:000259', NULL, NULL, 'Bifunctional enzyme IspD/IspF', NULL, NULL, NULL, NULL, NULL, 4),
(197367, NULL, 'G3DSA:3.30.200.20:FF:001008', NULL, NULL, 'Serine/threonine-protein kinase cek1', NULL, NULL, NULL, NULL, NULL, 4),
(197368, NULL, 'G3DSA:1.20.58.60:FF:000250', NULL, NULL, 'Blast:Spectrin beta chain, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(197369, NULL, 'G3DSA:4.10.400.10:FF:000240', NULL, NULL, 'Terribly reduced optic lobes, isoform AH', NULL, NULL, NULL, NULL, NULL, 4),
(197370, NULL, 'G3DSA:2.30.36.70:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197371, NULL, 'G3DSA:3.40.50.720:FF:000384', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(P)+]', NULL, NULL, NULL, NULL, NULL, 4),
(197372, NULL, 'G3DSA:1.10.10.60:FF:000472', NULL, NULL, 'HTH-type transcriptional regulator AppY', NULL, NULL, NULL, NULL, NULL, 4),
(197373, NULL, 'G3DSA:1.20.1250.20:FF:002122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197374, NULL, 'G3DSA:3.30.700.10:FF:000009', NULL, NULL, 'Type IV pilin subunit protein', NULL, NULL, NULL, NULL, NULL, 4),
(197375, NULL, 'G3DSA:3.90.650.10:FF:000025', NULL, NULL, 'Phosphoribosylamine-glycine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(197376, NULL, 'G3DSA:3.80.10.10:FF:004013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197377, NULL, 'G3DSA:3.40.50.2300:FF:000632', NULL, NULL, 'Sensor histidine kinase/response regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197378, NULL, 'G3DSA:2.20.100.10:FF:000043', NULL, NULL, 'R-spondin 3', NULL, NULL, NULL, NULL, NULL, 4),
(197379, NULL, 'G3DSA:2.30.29.30:FF:000339', NULL, NULL, 'Rho guanine nucleotide exchange factor 39', NULL, NULL, NULL, NULL, NULL, 4),
(197380, NULL, 'G3DSA:1.25.40.10:FF:004438', NULL, NULL, 'Os03g0168400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(197381, NULL, 'G3DSA:2.60.40.10:FF:005535', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197382, NULL, 'G3DSA:3.90.1530.10:FF:000009', NULL, NULL, 'Chromosome partitioning protein ParB', NULL, NULL, NULL, NULL, NULL, 4),
(197383, NULL, 'G3DSA:1.25.40.620:FF:000002', NULL, NULL, 'GUN4 mutant', NULL, NULL, NULL, NULL, NULL, 4),
(197384, NULL, 'G3DSA:3.40.1280.10:FF:000024', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4),
(197385, NULL, 'G3DSA:3.40.190.10:FF:000883', NULL, NULL, 'Glutamate receptor ionotropic, delta-1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(197386, NULL, 'G3DSA:1.25.40.730:FF:000007', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(197387, NULL, 'G3DSA:1.10.238.10:FF:000874', NULL, NULL, 'Cell adhesion molecule, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197388, NULL, 'G3DSA:3.50.50.60:FF:000546', NULL, NULL, 'Geranylgeranyl hydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197389, NULL, 'G3DSA:3.60.10.10:FF:000079', NULL, NULL, 'DNA-(apurinic or apyrimidinic site) lyase', NULL, NULL, NULL, NULL, NULL, 4),
(197390, NULL, 'G3DSA:1.10.4160.10:FF:000030', NULL, NULL, 'Uracil transporter, putative (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(197391, NULL, 'G3DSA:2.130.10.10:FF:000808', NULL, NULL, 'Alternative splicing regulator', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(197392, NULL, 'G3DSA:3.10.260.10:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197393, NULL, 'G3DSA:2.130.10.10:FF:000988', NULL, NULL, 'Protein HIRA', NULL, NULL, NULL, NULL, NULL, 4),
(197394, NULL, 'G3DSA:3.90.70.10:FF:000784', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197395, NULL, 'G3DSA:3.30.1120.30:FF:000004', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(197396, NULL, 'G3DSA:3.80.10.10:FF:001579', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase GSO2', NULL, NULL, NULL, NULL, NULL, 4),
(197397, NULL, 'G3DSA:3.80.10.10:FF:002719', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(197398, NULL, 'G3DSA:1.20.1420.10:FF:000002', NULL, NULL, 'Talin 2', NULL, NULL, NULL, NULL, NULL, 4),
(197399, NULL, 'G3DSA:1.10.10.2520:FF:000003', NULL, NULL, 'Cell Wall hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(197400, NULL, 'G3DSA:3.60.15.10:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197401, NULL, 'G3DSA:3.10.450.50:FF:000096', NULL, NULL, 'Nuclear transport factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197402, NULL, 'G3DSA:2.60.120.290:FF:000244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197403, NULL, 'G3DSA:3.40.50.300:FF:008594', NULL, NULL, 'ATP-dependent Clp-type protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197404, NULL, 'G3DSA:3.40.50.620:FF:000556', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197405, NULL, 'G3DSA:1.10.238.230:FF:000004', NULL, NULL, 'Protein CBG16342', NULL, NULL, NULL, NULL, NULL, 4),
(197406, NULL, 'G3DSA:1.10.510.10:FF:000389', NULL, NULL, 'Uncharacterized protein, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(197407, NULL, 'G3DSA:3.20.20.190:FF:000122', NULL, NULL, 'Phosphate system positive regulatory protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197408, NULL, 'G3DSA:1.20.1420.30:FF:000008', NULL, NULL, 'Vacuolar cation/proton exchanger', NULL, NULL, NULL, NULL, NULL, 4),
(197409, NULL, 'G3DSA:2.30.30.140:FF:000032', NULL, NULL, 'MBT domain-containing protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(197410, NULL, 'G3DSA:2.60.40.150:FF:000210', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit gamma, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197411, NULL, 'G3DSA:3.40.50.2000:FF:000481', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(197412, NULL, 'G3DSA:3.40.50.10810:FF:000267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197413, NULL, 'G3DSA:2.60.60.20:FF:000014', NULL, NULL, 'Endothelial lipase', NULL, NULL, NULL, NULL, NULL, 4),
(197414, NULL, 'G3DSA:1.20.900.10:FF:000006', NULL, NULL, 'Rho guanine nucleotide exchange factor (GEF) 11', NULL, NULL, NULL, NULL, NULL, 4),
(197415, NULL, 'G3DSA:1.10.1070.11:FF:000063', NULL, NULL, 'GTOR', NULL, NULL, NULL, NULL, NULL, 4),
(197416, NULL, 'G3DSA:1.10.2000.10:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197417, NULL, 'G3DSA:3.50.50.60:FF:000069', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(197418, NULL, 'G3DSA:3.40.50.300:FF:005103', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(197419, NULL, 'G3DSA:2.60.40.10:FF:000679', NULL, NULL, 'Macrophage stimulating 1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(197420, NULL, 'G3DSA:3.90.1150.10:FF:000082', NULL, NULL, 'Tyrosine phenol-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(197421, NULL, 'G3DSA:3.30.930.10:FF:000111', NULL, NULL, 'ATP phosphoribosyltransferase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(197422, NULL, 'G3DSA:3.30.1240.10:FF:000035', NULL, NULL, 'Sugar-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(197423, NULL, 'G3DSA:1.10.472.30:FF:000002', NULL, NULL, 'Death-inducer obliterator 1', NULL, NULL, NULL, NULL, NULL, 4),
(197424, NULL, 'G3DSA:1.10.10.60:FF:000707', NULL, NULL, 'Dlx', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(197425, NULL, 'G3DSA:3.30.230.90:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197426, NULL, 'G3DSA:2.130.10.10:FF:005013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197427, NULL, 'G3DSA:1.20.1070.10:FF:002077', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(197428, NULL, 'G3DSA:3.30.160.60:FF:005187', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197429, NULL, 'G3DSA:3.40.350.10:FF:000036', NULL, NULL, 'X-Pro dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(197430, NULL, 'G3DSA:1.10.8.60:FF:000021', NULL, NULL, 'Replication factor C subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(197431, NULL, 'G3DSA:3.30.780.10:FF:000025', NULL, NULL, 'Eukaryotic translation initiation factor 1B', NULL, NULL, NULL, NULL, NULL, 4),
(197432, NULL, 'G3DSA:3.90.550.10:FF:000585', NULL, NULL, 'ACR246Wp', NULL, NULL, NULL, NULL, NULL, 4),
(197433, NULL, 'G3DSA:2.60.120.10:FF:000400', NULL, NULL, 'Os12g0529300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(197434, NULL, 'G3DSA:3.40.20.10:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197435, NULL, 'G3DSA:3.40.50.300:FF:001450', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(197436, NULL, 'G3DSA:2.60.40.10:FF:003091', NULL, NULL, 'Protein sidekick homolog', NULL, NULL, NULL, NULL, NULL, 4),
(197437, NULL, 'G3DSA:3.30.160.60:FF:001264', NULL, NULL, 'Zinc finger protein 219', NULL, NULL, NULL, NULL, NULL, 4),
(197438, NULL, 'G3DSA:1.25.40.180:FF:000151', NULL, NULL, 'Initiation factor eIF-4 gamma MA3', NULL, NULL, NULL, NULL, NULL, 4),
(197439, NULL, 'G3DSA:3.90.70.80:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197440, NULL, 'G3DSA:1.20.5.620:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197441, NULL, 'G3DSA:1.20.5.110:FF:000241', NULL, NULL, 'WASH complex subunit 3-like', NULL, NULL, NULL, NULL, NULL, 4),
(197442, NULL, 'G3DSA:1.10.220.150:FF:000029', NULL, NULL, 'Centaurin, alpha 1, isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(197443, NULL, 'G3DSA:2.40.128.630:FF:000007', NULL, NULL, 'Beta-alanine-activating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(197444, NULL, 'G3DSA:3.30.1360.40:FF:000030', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(197445, NULL, 'G3DSA:1.10.510.10:FF:001322', NULL, NULL, 'Kinase, AGC AKT', NULL, NULL, NULL, NULL, NULL, 4),
(197446, NULL, 'G3DSA:2.40.128.620:FF:000004', NULL, NULL, 'Putative GH16255p', NULL, NULL, NULL, NULL, NULL, 4),
(197447, NULL, 'G3DSA:3.40.50.2000:FF:000514', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(197448, NULL, 'G3DSA:1.10.287.2620:FF:000001', NULL, NULL, 'Cytoplasmic dynein heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(197449, NULL, 'G3DSA:3.30.160.60:FF:005810', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197450, NULL, 'G3DSA:3.50.50.60:FF:001002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197451, NULL, 'G3DSA:1.10.287.70:FF:000364', NULL, NULL, 'Ion transport protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(197452, NULL, 'G3DSA:2.10.25.10:FF:001186', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(197453, NULL, 'G3DSA:3.30.160.60:FF:005007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197454, NULL, 'G3DSA:3.40.190.10:FF:000181', NULL, NULL, 'ATP phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(197455, NULL, 'G3DSA:1.20.1720.10:FF:000042', NULL, NULL, 'Drug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197456, NULL, 'G3DSA:3.40.50.1000:FF:000697', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197457, NULL, 'G3DSA:3.80.10.10:FF:002158', NULL, NULL, 'Leucine rich immune protein (Coil-less)', NULL, NULL, NULL, NULL, NULL, 4),
(197458, NULL, 'G3DSA:1.10.10.10:FF:000715', NULL, NULL, 'HTH-type transcriptional regulator rot', NULL, NULL, NULL, NULL, NULL, 4),
(197459, NULL, 'G3DSA:3.50.50.60:FF:000872', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(197460, NULL, 'G3DSA:3.40.190.10:FF:000557', NULL, NULL, 'HTH-type transcriptional regulator PhcA', NULL, NULL, NULL, NULL, NULL, 4),
(197461, NULL, 'G3DSA:3.30.160.60:FF:004877', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197462, NULL, 'G3DSA:3.20.20.150:FF:000043', NULL, NULL, 'Xylose isomerase domain protein TIM barrel', NULL, NULL, NULL, NULL, NULL, 4),
(197463, NULL, 'G3DSA:3.30.40.10:FF:001993', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(197464, NULL, 'G3DSA:1.10.287.110:FF:000399', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197465, NULL, 'G3DSA:3.60.20.10:FF:000052', NULL, NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing] 2', NULL, NULL, NULL, NULL, NULL, 4),
(197466, NULL, 'G3DSA:1.25.40.10:FF:002640', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197467, NULL, 'G3DSA:2.60.40.60:FF:000385', NULL, NULL, 'Protocadherin-23', NULL, NULL, NULL, NULL, NULL, 4),
(197468, NULL, 'G3DSA:3.40.50.720:FF:000468', NULL, NULL, 'Short-chain dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197469, NULL, 'G3DSA:3.20.20.140:FF:000040', NULL, NULL, 'Putative tatD related deoxyribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(197470, NULL, 'G3DSA:1.10.510.10:FF:001940', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(197471, NULL, 'G3DSA:3.40.50.12470:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197472, NULL, 'G3DSA:1.10.486.10:FF:000056', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(197473, NULL, 'G3DSA:3.30.450.20:FF:000330', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(197474, NULL, 'G3DSA:1.20.1700.10:FF:000007', NULL, NULL, 'Pantothenate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(197475, NULL, 'G3DSA:1.10.510.10:FF:002952', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197476, NULL, 'G3DSA:2.10.25.10:FF:001101', NULL, NULL, 'AGAP005526-PA', NULL, NULL, NULL, NULL, NULL, 4),
(197477, NULL, 'G3DSA:3.40.50.300:FF:003158', NULL, NULL, 'ATP/GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197478, NULL, 'G3DSA:3.60.140.10:FF:000015', NULL, NULL, 'Polyphenol oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(197479, NULL, 'G3DSA:3.30.420.110:FF:000068', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(197480, NULL, 'G3DSA:1.10.238.220:FF:000001', NULL, NULL, 'Serine/threonine-protein phosphatase 2A regulatory subunit B'''' subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(197481, NULL, 'G3DSA:3.30.460.10:FF:000153', NULL, NULL, 'Poly polymerase central domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(197482, NULL, 'G3DSA:3.10.450.700:FF:000008', NULL, NULL, 'Transcriptional activator protein Pur-alpha', NULL, NULL, NULL, NULL, NULL, 4),
(197483, NULL, 'G3DSA:1.25.70.10:FF:000079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197484, NULL, 'G3DSA:1.25.40.10:FF:003275', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g19020, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(197485, NULL, 'G3DSA:3.90.1800.10:FF:000025', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(197486, NULL, 'G3DSA:3.30.160.60:FF:003006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197487, NULL, 'G3DSA:1.25.40.90:FF:000022', NULL, NULL, 'huntingtin-interacting protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(197488, NULL, 'G3DSA:3.90.70.10:FF:000582', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(197489, NULL, 'G3DSA:3.30.1760.10:FF:000001', NULL, NULL, 'Siderophore biosynthesis protein SbnI', NULL, NULL, NULL, NULL, NULL, 4),
(197490, NULL, 'G3DSA:1.25.40.820:FF:000034', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(197491, NULL, 'G3DSA:1.10.8.60:FF:000291', NULL, NULL, 'Stage V sporulation protein K', NULL, NULL, NULL, NULL, NULL, 4),
(197492, NULL, 'G3DSA:2.60.40.10:FF:002955', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(197493, NULL, 'G3DSA:3.40.640.10:FF:000047', NULL, NULL, 'serine palmitoyltransferase 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(197494, NULL, 'G3DSA:3.30.40.10:FF:002246', NULL, NULL, 'Zinc finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197495, NULL, 'G3DSA:3.10.20.90:FF:000999', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(197496, NULL, 'G3DSA:1.50.40.10:FF:000007', NULL, NULL, 'Mitochondrial tricarboxylate transport protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(197497, NULL, 'G3DSA:2.30.30.40:FF:000469', NULL, NULL, 'SH3 and F-BAR domain-containing protein DDB_G0271676', NULL, NULL, NULL, NULL, NULL, 4),
(197498, NULL, 'G3DSA:3.30.710.10:FF:000454', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197499, NULL, 'G3DSA:3.40.720.10:FF:000143', NULL, NULL, 'N-acetylgalactosamine-6-sulfate sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(197500, NULL, 'G3DSA:1.20.58.60:FF:000452', NULL, NULL, 'Spectrin, beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(197501, NULL, 'G3DSA:2.30.42.10:FF:000651', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197502, NULL, 'G3DSA:3.40.50.2300:FF:000716', NULL, NULL, 'Ribose ABC transporter periplasmic binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(197503, NULL, 'G3DSA:3.30.470.20:FF:000213', NULL, NULL, 'Pyruvate carboxylase, gene 2', NULL, NULL, NULL, NULL, NULL, 4),
(197504, NULL, 'G3DSA:3.30.1740.20:FF:000003', NULL, NULL, '40S ribosomal protein S26', NULL, NULL, NULL, NULL, NULL, 4),
(197505, NULL, 'G3DSA:3.40.50.300:FF:002793', NULL, NULL, 'ATP-dependent DNA helicase DinG', NULL, NULL, NULL, NULL, NULL, 4),
(197506, NULL, 'G3DSA:3.40.50.300:FF:004878', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197507, NULL, 'G3DSA:3.20.20.140:FF:000130', NULL, NULL, 'Sodium/hydrogen exchanger 2', NULL, NULL, NULL, NULL, NULL, 4),
(197508, NULL, 'G3DSA:1.20.1250.20:FF:001958', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197509, NULL, 'G3DSA:2.40.420.20:FF:000054', NULL, NULL, 'RND superfamily resistance-nodulation-cell division antiporter', NULL, NULL, NULL, NULL, NULL, 4),
(197510, NULL, 'G3DSA:3.80.10.10:FF:000269', NULL, NULL, 'Piriformospora indica-insensitive protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(197511, NULL, 'G3DSA:2.60.120.650:FF:000167', NULL, NULL, 'Os02g0109400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(197512, NULL, 'G3DSA:1.10.220.20:FF:000004', NULL, NULL, 'Golgi-specific brefeldin A-resistance guanine nucleotide exchange factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(197513, NULL, 'G3DSA:1.20.5.5270:FF:000005', NULL, NULL, 'Lon protease', NULL, NULL, NULL, NULL, NULL, 4),
(197514, NULL, 'G3DSA:3.30.70.330:FF:000571', NULL, NULL, 'Glycine-rich RNA-binding protein 3 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(197515, NULL, 'G3DSA:1.10.150.20:FF:000263', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4),
(197516, NULL, 'G3DSA:3.40.50.300:FF:004884', NULL, NULL, 'ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(197517, NULL, 'G3DSA:3.20.20.450:FF:000009', NULL, NULL, 'Cyclic diguanylate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(197518, NULL, 'G3DSA:1.10.10.60:FF:001017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197519, NULL, 'G3DSA:4.10.1000.10:FF:000111', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(197520, NULL, 'G3DSA:2.40.50.120:FF:000039', NULL, NULL, 'GD20727', NULL, NULL, NULL, NULL, NULL, 4),
(197521, NULL, 'G3DSA:1.20.5.5260:FF:000002', NULL, NULL, 'Two-component-system connector protein YcgZ', NULL, NULL, NULL, NULL, NULL, 4),
(197522, NULL, 'G3DSA:3.40.50.300:FF:000230', NULL, NULL, 'Lipoprotein-releasing system ATP-binding protein LolD', NULL, NULL, NULL, NULL, NULL, 4),
(197523, NULL, 'G3DSA:1.10.472.80:FF:000062', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(197524, NULL, 'G3DSA:2.60.260.20:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(197525, NULL, 'G3DSA:3.30.365.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197526, NULL, 'G3DSA:1.10.220.30:FF:000007', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(197527, NULL, 'G3DSA:2.10.25.10:FF:001534', NULL, NULL, 'Integrin subunit beta-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(197528, NULL, 'G3DSA:1.20.1000.10:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197529, NULL, 'G3DSA:3.80.10.10:FF:001848', NULL, NULL, 'AGAP011186-PA', NULL, NULL, NULL, NULL, NULL, 4),
(197530, NULL, 'G3DSA:1.25.40.10:FF:003331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197531, NULL, 'G3DSA:2.120.10.80:FF:000419', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(197532, NULL, 'G3DSA:1.25.10.10:FF:000013', NULL, NULL, 'Importin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(197533, NULL, 'G3DSA:3.30.497.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197534, NULL, 'G3DSA:2.30.130.110:FF:000003', NULL, NULL, 'D-galactarate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(197535, NULL, 'G3DSA:3.40.710.10:FF:000114', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(197536, NULL, 'G3DSA:3.40.250.10:FF:000034', NULL, NULL, 'Dual specificity phosphatase 2', NULL, NULL, NULL, NULL, NULL, 4),
(197537, NULL, 'G3DSA:1.20.1250.20:FF:000177', NULL, NULL, 'proton myo-inositol cotransporter isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(197538, NULL, 'G3DSA:3.40.50.720:FF:000704', NULL, NULL, 'Oxidoreductase, short-chain dehydrogenase/reductase family', NULL, NULL, NULL, NULL, NULL, 4),
(197539, NULL, 'G3DSA:1.25.10.20:FF:000016', NULL, NULL, 'Vitellogenin', NULL, NULL, NULL, NULL, NULL, 4),
(197540, NULL, 'G3DSA:3.40.50.300:FF:006593', NULL, NULL, 'ATP synthase subunit beta chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(197541, NULL, 'G3DSA:3.30.420.40:FF:000547', NULL, NULL, 'Cell growth defect factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(197542, NULL, 'G3DSA:1.10.10.10:FF:000917', NULL, NULL, 'Cullin-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197543, NULL, 'G3DSA:2.40.50.140:FF:000433', NULL, NULL, 'Sugar ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(197544, NULL, 'G3DSA:3.40.50.2300:FF:001121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197545, NULL, 'G3DSA:3.30.450.20:FF:000037', NULL, NULL, 'Cell wall metabolism sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(197546, NULL, 'G3DSA:2.60.220.50:FF:000043', NULL, NULL, 'Adhesion G protein-coupled receptor L3', NULL, NULL, NULL, NULL, NULL, 4),
(197547, NULL, 'G3DSA:3.30.70.260:FF:000050', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(197548, NULL, 'G3DSA:3.40.1690.20:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197549, NULL, 'G3DSA:3.90.20.20:FF:000020', NULL, NULL, 'Protein GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(197550, NULL, 'G3DSA:3.40.50.720:FF:001688', NULL, NULL, 'Bifunctional dTDP-4-dehydrorhamnose 3,5-epimerase/dTDP-4-dehydrorhamnose reductase', NULL, NULL, NULL, NULL, NULL, 4),
(197551, NULL, 'G3DSA:3.20.20.140:FF:000219', NULL, NULL, 'Lmo1231 protein', NULL, NULL, NULL, NULL, NULL, 4),
(197552, NULL, 'G3DSA:3.30.70.270:FF:000053', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(197553, NULL, 'G3DSA:1.25.40.10:FF:002724', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197554, NULL, 'G3DSA:1.20.1160.11:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197555, NULL, 'G3DSA:3.40.30.10:FF:000896', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197556, NULL, 'G3DSA:2.30.30.490:FF:000058', NULL, NULL, 'Arginine-glutamic acid dipeptide (RE) repeats a', NULL, NULL, NULL, NULL, NULL, 4),
(197557, NULL, 'G3DSA:3.40.50.11610:FF:000018', NULL, NULL, 'Probable 2-oxoglutarate dehydrogenase E1 component DHKTD1 homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(197558, NULL, 'G3DSA:3.30.2130.30:FF:000038', NULL, NULL, 'THUMP domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(197559, NULL, 'G3DSA:3.40.630.30:FF:000119', NULL, NULL, 'Putative acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(197560, NULL, 'G3DSA:3.30.450.50:FF:000052', NULL, NULL, 'SNARE-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(197561, NULL, 'G3DSA:3.40.50.2000:FF:000188', NULL, NULL, 'Phosphatidylinositol N-acetylglucosaminyltransferase gpi3 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(197562, NULL, 'G3DSA:2.60.40.10:FF:003028', NULL, NULL, 'Cytokine receptor-like factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(197563, NULL, 'G3DSA:3.40.50.1820:FF:000971', NULL, NULL, 'Lipase (Class 3), putative', NULL, NULL, NULL, NULL, NULL, 4),
(197564, NULL, 'G3DSA:3.40.50.300:FF:001157', NULL, NULL, 'Uncharacterized protein, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(197565, NULL, 'G3DSA:3.30.450.60:FF:000055', NULL, NULL, 'TSET complex member tstD', NULL, NULL, NULL, NULL, NULL, 4),
(197566, NULL, 'G3DSA:1.20.1250.20:FF:001487', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197567, NULL, 'G3DSA:3.30.1460.20:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197568, NULL, 'G3DSA:1.10.238.10:FF:001306', NULL, NULL, 'CDPK-related kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(197569, NULL, 'G3DSA:1.10.287.1490:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197570, NULL, 'G3DSA:1.10.287.470:FF:000080', NULL, NULL, 'Sensory rhodopsin II transducer', NULL, NULL, NULL, NULL, NULL, 4),
(197571, NULL, 'G3DSA:3.40.50.720:FF:001311', NULL, NULL, 'Phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(197572, NULL, 'G3DSA:3.40.710.10:FF:000171', NULL, NULL, 'Peptidoglycan transpeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(197573, NULL, 'G3DSA:2.130.10.10:FF:003540', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', NULL, NULL, NULL, NULL, NULL, 4),
(197574, NULL, 'G3DSA:1.20.1250.20:FF:002268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197575, NULL, 'G3DSA:2.130.10.10:FF:005631', NULL, NULL, 'Apoptotic protease-activating factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197576, NULL, 'G3DSA:2.60.40.10:FF:005030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197577, NULL, 'G3DSA:1.10.472.10:FF:000406', NULL, NULL, 'Mitotic cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(197578, NULL, 'G3DSA:2.60.120.650:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197579, NULL, 'G3DSA:3.90.1200.10:FF:000024', NULL, NULL, 'Acyl-CoA dehydrogenase FadE36', NULL, NULL, NULL, NULL, NULL, 4),
(197580, NULL, 'G3DSA:4.10.240.10:FF:000031', NULL, NULL, 'C6 transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197581, NULL, 'G3DSA:1.20.1070.10:FF:002167', NULL, NULL, 'Smoothend-like protein protein', NULL, NULL, NULL, NULL, NULL, 4),
(197582, NULL, 'G3DSA:3.40.50.1820:FF:000263', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(197583, NULL, 'G3DSA:2.60.40.10:FF:005119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197584, NULL, 'G3DSA:1.25.40.20:FF:001480', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197585, NULL, 'G3DSA:2.60.120.260:FF:000466', NULL, NULL, 'Ephrin type-B receptor 1-B', NULL, NULL, NULL, NULL, NULL, 4),
(197586, NULL, 'G3DSA:3.40.1690.10:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197587, NULL, 'G3DSA:3.90.190.10:FF:000130', NULL, NULL, 'Dual specificity protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197588, NULL, 'G3DSA:3.30.160.60:FF:001825', NULL, NULL, 'ZNF141 isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(197589, NULL, 'G3DSA:3.30.565.10:FF:000357', NULL, NULL, 'Heat shock protein HSP 90-beta', NULL, NULL, NULL, NULL, NULL, 4),
(197590, NULL, 'G3DSA:3.30.70.330:FF:000239', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(197591, NULL, 'G3DSA:1.10.8.10:FF:000231', NULL, NULL, 'Elongation factor 1-alpha 2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(197592, NULL, 'G3DSA:3.40.50.620:FF:000264', NULL, NULL, 'Diphthine--ammonia ligase', NULL, NULL, NULL, NULL, NULL, 4),
(197593, NULL, 'G3DSA:1.20.1070.10:FF:000278', NULL, NULL, 'Trace amine-associated receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(197594, NULL, 'G3DSA:1.10.510.10:FF:002103', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197595, NULL, 'G3DSA:1.20.1270.10:FF:000024', NULL, NULL, 'Heat shock protein 70', NULL, NULL, NULL, NULL, NULL, 4),
(197596, NULL, 'G3DSA:2.60.40.2660:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197597, NULL, 'G3DSA:3.30.1370.10:FF:000191', NULL, NULL, 'Protein CBG10565', NULL, NULL, NULL, NULL, NULL, 4),
(197598, NULL, 'G3DSA:2.60.40.770:FF:000014', NULL, NULL, 'GM12130', NULL, NULL, NULL, NULL, NULL, 4),
(197599, NULL, 'G3DSA:3.40.50.2300:FF:000396', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(197600, NULL, 'G3DSA:1.20.1730.10:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197601, NULL, 'G3DSA:3.40.50.150:FF:001146', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197602, NULL, 'G3DSA:3.40.50.300:FF:007374', NULL, NULL, 'Un-named sa911', NULL, NULL, NULL, NULL, NULL, 4),
(197603, NULL, 'G3DSA:2.60.40.10:FF:003085', NULL, NULL, 'Fibronectin type III domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(197604, NULL, 'G3DSA:3.30.160.20:FF:000083', NULL, NULL, 'Ribonuclease 3', NULL, NULL, NULL, NULL, NULL, 4),
(197605, NULL, 'G3DSA:3.90.550.50:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197606, NULL, 'G3DSA:1.20.1070.10:FF:001857', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197607, NULL, 'G3DSA:3.40.1110.10:FF:000225', NULL, NULL, 'Copper transporter', NULL, NULL, NULL, NULL, NULL, 4),
(197608, NULL, 'G3DSA:2.130.10.30:FF:000056', NULL, NULL, 'RCC1 domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(197609, NULL, 'G3DSA:3.30.160.60:FF:005423', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197610, NULL, 'G3DSA:1.10.10.10:FF:001266', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(197611, NULL, 'G3DSA:3.30.160.60:FF:006030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197612, NULL, 'G3DSA:2.130.10.10:FF:000050', NULL, NULL, 'breast carcinoma-amplified sequence 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(197613, NULL, 'G3DSA:3.20.20.140:FF:000332', NULL, NULL, 'L-rhamnono-gamma-lactonase', NULL, NULL, NULL, NULL, NULL, 4),
(197614, NULL, 'G3DSA:2.130.10.10:FF:001028', NULL, NULL, 'Antiviral protein SKI8', NULL, NULL, NULL, NULL, NULL, 4),
(197615, NULL, 'G3DSA:3.40.50.80:FF:000081', NULL, NULL, 'Probable metalloreductase AIM14', NULL, NULL, NULL, NULL, NULL, 4),
(197616, NULL, 'G3DSA:3.40.50.2000:FF:000840', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197617, NULL, 'G3DSA:1.25.40.10:FF:004579', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197618, NULL, 'G3DSA:3.40.50.620:FF:000500', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197619, NULL, 'G3DSA:3.50.50.60:FF:000833', NULL, NULL, 'AGR055Cp', NULL, NULL, NULL, NULL, NULL, 4),
(197620, NULL, 'G3DSA:1.25.10.10:FF:003447', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197621, NULL, 'G3DSA:2.60.120.260:FF:000522', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197622, NULL, 'G3DSA:1.25.40.10:FF:001999', NULL, NULL, 'Os11g0213500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(197623, NULL, 'G3DSA:3.10.20.310:FF:000020', NULL, NULL, 'Outer membrane protein assembly factor BamA', NULL, NULL, NULL, NULL, NULL, 4),
(197624, NULL, 'G3DSA:3.30.50.10:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197625, NULL, 'G3DSA:1.10.640.10:FF:000073', NULL, NULL, 'Peroxidase, putative', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(197626, NULL, 'G3DSA:2.130.10.10:FF:004844', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197627, NULL, 'G3DSA:1.10.510.10:FF:004189', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197628, NULL, 'G3DSA:2.60.40.60:FF:001076', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(197629, NULL, 'G3DSA:3.30.559.10:FF:000264', NULL, NULL, 'BAHD acyltransferase BIA1', NULL, NULL, NULL, NULL, NULL, 4),
(197630, NULL, 'G3DSA:3.60.10.10:FF:000023', NULL, NULL, 'Type IV inositol polyphosphate 5-phosphatase 7', NULL, NULL, NULL, NULL, NULL, 4),
(197631, NULL, 'G3DSA:1.10.287.660:FF:000013', NULL, NULL, 'AGAP002538-PA', NULL, NULL, NULL, NULL, NULL, 4),
(197632, NULL, 'G3DSA:1.10.1670.10:FF:000028', NULL, NULL, 'A/G-specific adenine glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(197633, NULL, 'G3DSA:1.25.40.10:FF:000779', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(197634, NULL, 'G3DSA:1.20.1070.10:FF:000514', NULL, NULL, 'G protein coupled receptor', NULL, NULL, NULL, NULL, NULL, 4),
(197635, NULL, 'G3DSA:1.20.920.10:FF:000210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197636, NULL, 'G3DSA:1.20.1250.20:FF:002324', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197637, NULL, 'G3DSA:3.40.190.10:FF:000265', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(197638, NULL, 'G3DSA:3.40.1480.10:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197639, NULL, 'G3DSA:2.120.10.80:FF:000217', NULL, NULL, 'Host cell factor-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(197640, NULL, 'G3DSA:3.90.1720.10:FF:000024', NULL, NULL, 'Probable endopeptidase MT2245', NULL, NULL, NULL, NULL, NULL, 4),
(197641, NULL, 'G3DSA:3.40.50.410:FF:000173', NULL, NULL, 'Collagen, type VI, alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(197642, NULL, 'G3DSA:1.10.287.3240:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197643, NULL, 'G3DSA:3.90.810.10:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197644, NULL, 'G3DSA:3.80.10.10:FF:002304', NULL, NULL, 'Leucine Rich Repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197645, NULL, 'G3DSA:1.25.40.10:FF:002494', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g09900', NULL, NULL, NULL, NULL, NULL, 4),
(197646, NULL, 'G3DSA:3.50.50.60:FF:000456', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(197647, NULL, 'G3DSA:2.130.10.10:FF:001831', NULL, NULL, 'WD repeat-containing protein 37-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(197648, NULL, 'G3DSA:2.60.40.60:FF:001109', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(197649, NULL, 'G3DSA:3.40.850.10:FF:000237', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(197650, NULL, 'G3DSA:3.40.50.2000:FF:000368', NULL, NULL, 'BnaA06g10670D protein', NULL, NULL, NULL, NULL, NULL, 4),
(197651, NULL, 'G3DSA:1.10.287.70:FF:000072', NULL, NULL, 'Cyclic nucleotide gated channel beta 3', NULL, NULL, NULL, NULL, NULL, 4),
(197652, NULL, 'G3DSA:2.40.50.140:FF:000197', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(197653, NULL, 'G3DSA:2.120.10.30:FF:000343', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(197654, NULL, 'G3DSA:1.10.510.10:FF:001176', NULL, NULL, 'Cell division control protein 2 like', NULL, NULL, NULL, NULL, NULL, 4),
(197655, NULL, 'G3DSA:2.60.40.10:FF:004866', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197656, NULL, 'G3DSA:3.30.70.330:FF:000419', NULL, NULL, 'CLUMA_CG006354, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(197657, NULL, 'G3DSA:1.20.59.10:FF:000012', NULL, NULL, 'Isochorismate pyruvate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(197658, NULL, 'G3DSA:1.10.287.130:FF:000028', NULL, NULL, 'Hybrid signal transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(197659, NULL, 'G3DSA:3.30.160.60:FF:002753', NULL, NULL, 'AGAP011403-PA', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(197660, NULL, 'G3DSA:3.40.50.1220:FF:000027', NULL, NULL, 'Unplaced genomic scaffold supercont1.13, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(197661, NULL, 'G3DSA:3.30.70.330:FF:002656', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197662, NULL, 'G3DSA:3.30.200.20:FF:002470', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197663, NULL, 'G3DSA:2.40.50.90:FF:000030', NULL, NULL, 'Transcription factor (Snd1/p100), putative', NULL, NULL, NULL, NULL, NULL, 4),
(197664, NULL, 'G3DSA:3.30.420.40:FF:000660', NULL, NULL, 'Actin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197665, NULL, 'G3DSA:3.40.50.300:FF:003574', NULL, NULL, 'Ras family protein', NULL, NULL, NULL, NULL, NULL, 4),
(197666, NULL, 'G3DSA:1.10.287.130:FF:000085', NULL, NULL, 'Signal transduction histidine-protein kinase atoS', NULL, NULL, NULL, NULL, NULL, 4),
(197667, NULL, 'G3DSA:1.10.510.10:FF:003121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197668, NULL, 'G3DSA:2.130.10.10:FF:001180', NULL, NULL, 'YBR246W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(197669, NULL, 'G3DSA:2.60.40.10:FF:000595', NULL, NULL, 'Immunoglobulin superfamily member 11', NULL, NULL, NULL, NULL, NULL, 4),
(197670, NULL, 'G3DSA:2.10.25.10:FF:001478', NULL, NULL, 'Hemicentin 2', NULL, NULL, NULL, NULL, NULL, 4),
(197671, NULL, 'G3DSA:1.10.640.10:FF:000016', NULL, NULL, 'Protein CBG02940', NULL, NULL, NULL, NULL, NULL, 4),
(197672, NULL, 'G3DSA:3.20.20.80:FF:000147', NULL, NULL, 'Maltooligosyl trehalose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(197673, NULL, 'G3DSA:2.30.42.10:FF:000471', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197674, NULL, 'G3DSA:2.60.40.1290:FF:000004', NULL, NULL, 'Sialidase (Neuraminidase)', NULL, NULL, NULL, NULL, NULL, 4),
(197675, NULL, 'G3DSA:3.40.50.300:FF:007520', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(197676, NULL, 'G3DSA:3.40.50.150:FF:001236', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197677, NULL, 'G3DSA:2.10.110.10:FF:000192', NULL, NULL, 'Wilms tumor protein 1-interacting protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(197678, NULL, 'G3DSA:1.20.1730.10:FF:000014', NULL, NULL, 'Cation acetate symporter', NULL, NULL, NULL, NULL, NULL, 4),
(197679, NULL, 'G3DSA:3.40.50.300:FF:001865', NULL, NULL, 'GTP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(197680, NULL, 'G3DSA:2.40.50.140:FF:001214', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197681, NULL, 'G3DSA:2.70.160.11:FF:000036', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(197682, NULL, 'G3DSA:3.30.420.140:FF:000026', NULL, NULL, 'Putative pre-16S rRNA nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(197683, NULL, 'G3DSA:1.10.533.10:FF:000195', NULL, NULL, 'MC160', NULL, NULL, NULL, NULL, NULL, 4),
(197684, NULL, 'G3DSA:3.20.20.70:FF:000144', NULL, NULL, 'sialic acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(197685, NULL, 'G3DSA:3.40.50.300:FF:002141', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(197686, NULL, 'G3DSA:1.20.1050.10:FF:000193', NULL, NULL, 'AGAP012839-PA', NULL, NULL, NULL, NULL, NULL, 4),
(197687, NULL, 'G3DSA:3.30.230.10:FF:000052', NULL, NULL, 'Mitochondrial ribosomal protein S5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197688, NULL, 'G3DSA:3.40.30.10:FF:000244', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(197689, NULL, 'G3DSA:4.10.1040.10:FF:000001', NULL, NULL, 'doublesex- and mab-3-related transcription factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(197690, NULL, 'G3DSA:1.10.10.10:FF:001412', NULL, NULL, 'Cadmium resistance transcriptional regulator CadC', NULL, NULL, NULL, NULL, NULL, 4),
(197691, NULL, 'G3DSA:1.20.1070.10:FF:001296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197692, NULL, 'G3DSA:3.80.10.10:FF:000505', NULL, NULL, 'Outer arm dynein light chain 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(197693, NULL, 'G3DSA:3.40.50.1460:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(197694, NULL, 'G3DSA:3.40.50.970:FF:000077', NULL, NULL, 'Pyruvate dehydrogenase E1 component subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(197695, NULL, 'G3DSA:3.30.760.10:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197696, NULL, 'G3DSA:1.20.1250.20:FF:000941', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197697, NULL, 'G3DSA:1.10.238.10:FF:000582', NULL, NULL, 'RCG62658, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(197698, NULL, 'G3DSA:1.10.287.70:FF:000033', NULL, NULL, 'Mucolipin 1', NULL, NULL, NULL, NULL, NULL, 4),
(197699, NULL, 'G3DSA:3.30.300.110:FF:000007', NULL, NULL, 'tRNA (guanine(37)-N1)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(197700, NULL, 'G3DSA:2.60.120.920:FF:000124', NULL, NULL, 'Neuralized-like protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(197701, NULL, 'G3DSA:1.20.120.1240:FF:000063', NULL, NULL, 'Dynamin-related GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(197702, NULL, 'G3DSA:2.120.10.10:FF:000005', NULL, NULL, 'Neuraminidase 4', NULL, NULL, NULL, NULL, NULL, 4),
(197703, NULL, 'G3DSA:2.60.120.200:FF:000526', NULL, NULL, 'Galectin-1', NULL, NULL, NULL, NULL, NULL, 4),
(197704, NULL, 'G3DSA:2.10.25.10:FF:000371', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(197705, NULL, 'G3DSA:3.90.226.10:FF:000309', NULL, NULL, 'ATP-dependent Clp protease proteolytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(197706, NULL, 'G3DSA:3.60.60.10:FF:000026', NULL, NULL, 'Bile salt hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(197707, NULL, 'G3DSA:3.10.129.10:FF:000225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197708, NULL, 'G3DSA:2.60.120.200:FF:000583', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197709, NULL, 'G3DSA:3.30.310.130:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197710, NULL, 'G3DSA:3.30.890.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197711, NULL, 'G3DSA:3.90.228.10:FF:000010', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(197712, NULL, 'G3DSA:1.10.10.1770:FF:000003', NULL, NULL, 'Slr1958 protein', NULL, NULL, NULL, NULL, NULL, 4),
(197713, NULL, 'G3DSA:3.30.200.20:FF:000845', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(197714, NULL, 'G3DSA:4.10.60.10:FF:000245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197715, NULL, 'G3DSA:3.90.640.10:FF:000092', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(197716, NULL, 'G3DSA:2.10.25.10:FF:000314', NULL, NULL, 'Low-density lipoprotein receptor-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(197717, NULL, 'G3DSA:2.60.120.200:FF:000055', NULL, NULL, 'Crumbs cell polarity complex component 1', NULL, NULL, NULL, NULL, NULL, 4),
(197718, NULL, 'G3DSA:1.25.10.10:FF:002666', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197719, NULL, 'G3DSA:1.10.101.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197720, NULL, 'G3DSA:2.60.220.50:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197721, NULL, 'G3DSA:1.10.196.10:FF:000011', NULL, NULL, 'Axin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(197722, NULL, 'G3DSA:3.90.228.20:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197723, NULL, 'G3DSA:3.30.830.10:FF:000199', NULL, NULL, 'Metalloprotease, insulinase family', NULL, NULL, NULL, NULL, NULL, 4),
(197724, NULL, 'G3DSA:3.60.10.10:FF:000080', NULL, NULL, 'Carbon catabolite repressor protein 4 homolog 3', NULL, NULL, NULL, NULL, NULL, 4),
(197725, NULL, 'G3DSA:3.40.50.720:FF:002183', NULL, NULL, 'Ubiquitin-like modifier-activating enzyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(197726, NULL, 'G3DSA:1.10.150.60:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197727, NULL, 'G3DSA:1.20.1560.10:FF:000366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(197728, NULL, 'G3DSA:3.40.50.150:FF:001707', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197729, NULL, 'G3DSA:3.90.640.10:FF:000053', NULL, NULL, 'Chaperone DnaK', NULL, NULL, NULL, NULL, NULL, 4),
(197730, NULL, 'G3DSA:2.130.10.10:FF:002517', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', NULL, NULL, NULL, NULL, NULL, 4),
(197731, NULL, 'G3DSA:3.90.850.10:FF:000006', NULL, NULL, '2-keto-4-pentenoate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(197732, NULL, 'G3DSA:1.20.90.10:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197733, NULL, 'G3DSA:3.30.1490.100:FF:000044', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(197734, NULL, 'G3DSA:1.25.40.10:FF:001420', NULL, NULL, 'MSHA biogenesis protein MshN', NULL, NULL, NULL, NULL, NULL, 4),
(197735, NULL, 'G3DSA:1.20.1740.10:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197736, NULL, 'G3DSA:1.20.1510.10:FF:000088', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197737, NULL, 'G3DSA:3.30.70.330:FF:002746', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197738, NULL, 'G3DSA:2.60.40.1690:FF:000001', NULL, NULL, 'Fusion glycoprotein F0', NULL, NULL, NULL, NULL, NULL, 4),
(197739, NULL, 'G3DSA:1.10.287.130:FF:000118', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(197740, NULL, 'G3DSA:3.40.50.10380:FF:000008', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(197741, NULL, 'G3DSA:1.10.565.10:FF:000004', NULL, NULL, 'Androgen receptor variant', NULL, NULL, NULL, NULL, NULL, 4),
(197742, NULL, 'G3DSA:3.40.50.620:FF:000915', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197743, NULL, 'G3DSA:1.25.10.10:FF:003032', NULL, NULL, 'Proteasome component ecm29', NULL, NULL, NULL, NULL, NULL, 4),
(197744, NULL, 'G3DSA:1.20.1250.20:FF:000323', NULL, NULL, 'protein NRT1/ PTR FAMILY 6.1', NULL, NULL, NULL, NULL, NULL, 4),
(197745, NULL, 'G3DSA:3.30.70.330:FF:000947', NULL, NULL, 'Probable splicing factor, arginine/serine-rich 4', NULL, NULL, NULL, NULL, NULL, 4),
(197746, NULL, 'G3DSA:1.10.730.10:FF:000046', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(197747, NULL, 'G3DSA:2.60.120.200:FF:000111', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(197748, NULL, 'G3DSA:3.40.50.300:FF:007317', NULL, NULL, 'Gll2992 protein', NULL, NULL, NULL, NULL, NULL, 4),
(197749, NULL, 'G3DSA:2.60.200.20:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197750, NULL, 'G3DSA:3.80.10.10:FF:004305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197751, NULL, 'G3DSA:1.10.8.10:FF:000118', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(197752, NULL, 'G3DSA:1.10.510.10:FF:003407', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197753, NULL, 'G3DSA:2.10.70.10:FF:000003', NULL, NULL, 'Versican core protein', NULL, NULL, NULL, NULL, NULL, 4),
(197754, NULL, 'G3DSA:3.40.225.10:FF:000015', NULL, NULL, 'Phosphomethylpyrimidine kinase (Hmp-phosphate kinase)', NULL, NULL, NULL, NULL, NULL, 4),
(197755, NULL, 'G3DSA:3.30.200.20:FF:000227', NULL, NULL, 'Cyclin-dependent kinase 9', NULL, NULL, NULL, NULL, NULL, 4),
(197756, NULL, 'G3DSA:3.40.50.1580:FF:000028', NULL, NULL, 'Phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(197757, NULL, 'G3DSA:3.80.10.10:FF:004344', NULL, NULL, 'AGAP011394-PA', NULL, NULL, NULL, NULL, NULL, 4),
(197758, NULL, 'G3DSA:3.30.200.20:FF:000935', NULL, NULL, 'Ygk3p', NULL, NULL, NULL, NULL, NULL, 4),
(197759, NULL, 'G3DSA:1.25.40.20:FF:001423', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197760, NULL, 'G3DSA:2.130.10.30:FF:000112', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197761, NULL, 'G3DSA:1.20.1270.60:FF:000342', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197762, NULL, 'G3DSA:3.60.20.40:FF:000010', NULL, NULL, 'Protein-glutamine gamma-glutamyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(197763, NULL, 'G3DSA:3.30.9.10:FF:000206', NULL, NULL, 'D-aspartate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(197764, NULL, 'G3DSA:1.10.287.130:FF:000231', NULL, NULL, 'ATP-binding region ATPase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(197765, NULL, 'G3DSA:1.10.600.10:FF:000042', NULL, NULL, 'Probable terpene synthase 3, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(197766, NULL, 'G3DSA:3.30.1140.40:FF:000008', NULL, NULL, 'Dynein light chain (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(197767, NULL, 'G3DSA:2.60.40.10:FF:003321', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197768, NULL, 'G3DSA:3.40.630.30:FF:000232', NULL, NULL, 'GG16894', NULL, NULL, NULL, NULL, NULL, 4),
(197769, NULL, 'G3DSA:3.20.20.80:FF:000057', NULL, NULL, 'Di-N-acetylchitobiase', NULL, NULL, NULL, NULL, NULL, 4),
(197770, NULL, 'G3DSA:1.25.40.660:FF:000020', NULL, NULL, 'Vacuolar protein sorting-associated protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(197771, NULL, 'G3DSA:2.40.50.140:FF:000904', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197772, NULL, 'G3DSA:3.80.10.10:FF:000415', NULL, NULL, 'Inactive LRR receptor-like serine/threonine-protein kinase BIR2', NULL, NULL, NULL, NULL, NULL, 4),
(197773, NULL, 'G3DSA:3.30.230.10:FF:000142', NULL, NULL, 'Ribonuclease P protein component', NULL, NULL, NULL, NULL, NULL, 4),
(197774, NULL, 'G3DSA:3.40.50.20:FF:000046', NULL, NULL, 'Phosphoribosylamine--glycine ligase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(197775, NULL, 'G3DSA:3.90.70.200:FF:000007', NULL, NULL, 'Plus-3 domain/Zinc finger', NULL, NULL, NULL, NULL, NULL, 4),
(197776, NULL, 'G3DSA:2.60.120.260:FF:000286', NULL, NULL, 'Protein CBG09205', NULL, NULL, NULL, NULL, NULL, 4),
(197777, NULL, 'G3DSA:2.30.42.10:FF:000319', NULL, NULL, 'Proteasome regulatory subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197778, NULL, 'G3DSA:3.30.70.560:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197779, NULL, 'G3DSA:1.20.58.60:FF:000339', NULL, NULL, 'Envoplakin like', NULL, NULL, NULL, NULL, NULL, 4),
(197780, NULL, 'G3DSA:3.40.50.1820:FF:000443', NULL, NULL, 'Putative serine esterase Mb1866c', NULL, NULL, NULL, NULL, NULL, 4),
(197781, NULL, 'G3DSA:1.20.5.270:FF:000002', NULL, NULL, 'Cytochrome b-c1 complex subunit Rieske, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(197782, NULL, 'G3DSA:2.30.42.10:FF:000561', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197783, NULL, 'G3DSA:1.20.1250.20:FF:000380', NULL, NULL, 'Transmembrane protein 180', NULL, NULL, NULL, NULL, NULL, 4),
(197784, NULL, 'G3DSA:3.90.800.10:FF:000003', NULL, NULL, 'Glutamate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(197785, NULL, 'G3DSA:3.30.70.330:FF:002128', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197786, NULL, 'G3DSA:1.25.40.10:FF:005220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197787, NULL, 'G3DSA:3.90.79.20:FF:000020', NULL, NULL, 'DNA mismatch repair protein MutT', NULL, NULL, NULL, NULL, NULL, 4),
(197788, NULL, 'G3DSA:3.10.20.90:FF:000853', NULL, NULL, 'Microtubule-associated proteins 1A/1B light chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197789, NULL, 'G3DSA:1.20.5.170:FF:000270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197790, NULL, 'G3DSA:3.40.30.10:FF:001262', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(197791, NULL, 'G3DSA:3.10.20.90:FF:000201', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 26', NULL, NULL, NULL, NULL, NULL, 4),
(197792, NULL, 'G3DSA:3.40.50.300:FF:003810', NULL, NULL, 'Ribosome-binding ATPase YchF', NULL, NULL, NULL, NULL, NULL, 4),
(197793, NULL, 'G3DSA:3.30.720.210:FF:000008', NULL, NULL, 'ATP-dependent zinc metalloprotease FTSH 7, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(197794, NULL, 'G3DSA:3.80.10.10:FF:003939', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197795, NULL, 'G3DSA:2.40.20.10:FF:000021', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(197796, NULL, 'G3DSA:3.30.160.60:FF:003624', NULL, NULL, 'Yin-yang1', NULL, NULL, NULL, NULL, NULL, 4),
(197797, NULL, 'G3DSA:1.20.920.10:FF:000007', NULL, NULL, 'Bromodomain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(197798, NULL, 'G3DSA:2.60.120.340:FF:000012', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(197799, NULL, 'G3DSA:3.30.40.10:FF:000863', NULL, NULL, 'U-box domain-containing protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(197800, NULL, 'G3DSA:3.30.559.70:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197801, NULL, 'G3DSA:3.40.390.10:FF:000162', NULL, NULL, 'AGAP011870-PA', NULL, NULL, NULL, NULL, NULL, 4),
(197802, NULL, 'G3DSA:3.40.50.300:FF:003630', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(197803, NULL, 'G3DSA:1.20.5.960:FF:000001', NULL, NULL, 'Baseplate wedge tail fiber connector', NULL, NULL, NULL, NULL, NULL, 4),
(197804, NULL, 'G3DSA:1.25.40.10:FF:004293', NULL, NULL, 'GH10889p', NULL, NULL, NULL, NULL, NULL, 4),
(197805, NULL, 'G3DSA:3.30.720.200:FF:000005', NULL, NULL, 'Glycyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(197806, NULL, 'G3DSA:2.40.50.140:FF:000343', NULL, NULL, 'Asparagine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(197807, NULL, 'G3DSA:2.120.10.30:FF:000197', NULL, NULL, 'tripartite motif-containing protein 3-like', NULL, NULL, NULL, NULL, NULL, 4),
(197808, NULL, 'G3DSA:3.40.850.10:FF:000057', NULL, NULL, 'kinesin-like protein KIN-14R', NULL, NULL, NULL, NULL, NULL, 4),
(197809, NULL, 'G3DSA:1.20.120.230:FF:000006', NULL, NULL, 'Catenin alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(197810, NULL, 'G3DSA:1.20.120.220:FF:000003', NULL, NULL, 'ATP synthase subunit a', NULL, NULL, NULL, NULL, NULL, 4),
(197811, NULL, 'G3DSA:3.30.1440.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197812, NULL, 'G3DSA:2.10.10.10:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197813, NULL, 'G3DSA:1.10.357.140:FF:000020', NULL, NULL, 'Protoheme ix farnesyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(197814, NULL, 'G3DSA:3.30.160.60:FF:002697', NULL, NULL, 'Transcription factor grauzone', NULL, NULL, NULL, NULL, NULL, 4),
(197815, NULL, 'G3DSA:3.30.1520.10:FF:000074', NULL, NULL, 'Sorting nexin', NULL, NULL, NULL, NULL, NULL, 4),
(197816, NULL, 'G3DSA:1.20.120.910:FF:000002', NULL, NULL, 'DksA/TraR family C4-type zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(197817, NULL, 'G3DSA:3.60.15.10:FF:000247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197818, NULL, 'G3DSA:1.10.8.480:FF:000005', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(197819, NULL, 'G3DSA:3.30.70.260:FF:000140', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(197820, NULL, 'G3DSA:2.40.50.140:FF:000719', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197821, NULL, 'G3DSA:3.80.10.10:FF:003288', NULL, NULL, 'Toll-like receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(197822, NULL, 'G3DSA:3.40.1170.10:FF:000021', NULL, NULL, 'MSH (MutS Homolog) family', NULL, NULL, NULL, NULL, NULL, 4),
(197823, NULL, 'G3DSA:3.30.760.10:FF:000024', NULL, NULL, 'Eukaryotic translation initiation factor 4E,putative', NULL, NULL, NULL, NULL, NULL, 4),
(197824, NULL, 'G3DSA:3.30.70.330:FF:002802', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197825, NULL, 'G3DSA:1.25.10.10:FF:002576', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197826, NULL, 'G3DSA:1.20.1250.20:FF:000470', NULL, NULL, 'Cyanate transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(197827, NULL, 'G3DSA:3.40.50.10090:FF:000045', NULL, NULL, 'Uroporphyrinogen decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(197828, NULL, 'G3DSA:2.40.50.140:FF:000961', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197829, NULL, 'G3DSA:3.40.50.300:FF:003720', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(197830, NULL, 'G3DSA:2.60.40.10:FF:001376', NULL, NULL, 'Protein tyrosine phosphatase, receptor type B', NULL, NULL, NULL, NULL, NULL, 4),
(197831, NULL, 'G3DSA:1.20.5.170:FF:000118', NULL, NULL, 'Adhesin', NULL, NULL, NULL, NULL, NULL, 4),
(197832, NULL, 'G3DSA:2.60.40.10:FF:001319', NULL, NULL, 'Thy-1 membrane glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(197833, NULL, 'G3DSA:2.30.30.100:FF:000099', NULL, NULL, 'Small nuclear ribonucleoprotein G', NULL, NULL, NULL, NULL, NULL, 4),
(197834, NULL, 'G3DSA:1.10.300.10:FF:000002', NULL, NULL, 'Adenylosuccinate synthetase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(197835, NULL, 'G3DSA:1.20.1250.20:FF:000413', NULL, NULL, 'Karmoisin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(197836, NULL, 'G3DSA:3.30.70.270:FF:000143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197837, NULL, 'G3DSA:1.10.10.160:FF:000031', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(197838, NULL, 'G3DSA:2.30.30.40:FF:000672', NULL, NULL, 'Protein CBG04143', NULL, NULL, NULL, NULL, NULL, 4),
(197839, NULL, 'G3DSA:3.40.50.720:FF:002093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197840, NULL, 'G3DSA:3.30.70.330:FF:001875', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197841, NULL, 'G3DSA:3.60.21.10:FF:000104', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(197842, NULL, 'G3DSA:1.20.5.400:FF:000002', NULL, NULL, 'Tropomyosin 2', NULL, NULL, NULL, NULL, NULL, 4),
(197843, NULL, 'G3DSA:1.10.10.10:FF:001322', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(197844, NULL, 'G3DSA:3.30.870.10:FF:000139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197845, NULL, 'G3DSA:1.25.40.1040:FF:000013', NULL, NULL, 'Rna14p', NULL, NULL, NULL, NULL, NULL, 4),
(197846, NULL, 'G3DSA:1.25.40.1030:FF:000010', NULL, NULL, 'Protein transport protein SEC31', NULL, NULL, NULL, NULL, NULL, 4),
(197847, NULL, 'G3DSA:3.30.160.60:FF:003534', NULL, NULL, 'Zgc:174234 protein', NULL, NULL, NULL, NULL, NULL, 4),
(197848, NULL, 'G3DSA:3.30.1640.10:FF:000077', NULL, NULL, 'DNA replication licensing factor mcm7', NULL, NULL, NULL, NULL, NULL, 4),
(197849, NULL, 'G3DSA:1.25.40.10:FF:004079', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(197850, NULL, 'G3DSA:3.90.70.10:FF:000868', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197851, NULL, 'G3DSA:3.40.50.620:FF:000348', NULL, NULL, 'Phosphoadenosine phosphosulfate reductase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(197852, NULL, 'G3DSA:3.40.50.1910:FF:000026', NULL, NULL, 'Sec1 family transport protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197853, NULL, 'G3DSA:2.130.10.10:FF:001590', NULL, NULL, 'WD repeat-containing protein 68', NULL, NULL, NULL, NULL, NULL, 4),
(197854, NULL, 'G3DSA:1.10.8.10:FF:000091', NULL, NULL, 'Cbl long isoform', NULL, NULL, NULL, NULL, NULL, 4),
(197855, NULL, 'G3DSA:2.130.10.30:FF:000022', NULL, NULL, 'RCC2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(197856, NULL, 'G3DSA:3.90.1170.40:FF:000007', NULL, NULL, 'Molybdenum cofactor biosynthesis protein MoaE', NULL, NULL, NULL, NULL, NULL, 4),
(197857, NULL, 'G3DSA:1.20.920.20:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197858, NULL, 'G3DSA:1.10.565.10:FF:000009', NULL, NULL, 'estrogen-related receptor gamma isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(197859, NULL, 'G3DSA:3.40.50.970:FF:000195', NULL, NULL, 'Pyruvate decarboxylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(197860, NULL, 'G3DSA:3.30.160.60:FF:000488', NULL, NULL, 'Insulinoma-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(197861, NULL, 'G3DSA:3.50.50.60:FF:000333', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(197862, NULL, 'G3DSA:3.10.110.10:FF:000093', NULL, NULL, 'Ubiquitin conjugating enzyme (UbcF), putative', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(197863, NULL, 'G3DSA:3.30.530.20:FF:000010', NULL, NULL, 'rho GTPase-activating protein 7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(197864, NULL, 'G3DSA:1.20.1270.60:FF:000022', NULL, NULL, 'Sorting nexin 3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(197865, NULL, 'G3DSA:3.40.50.300:FF:005255', NULL, NULL, 'Cytochrome c biogenesis ATP-binding export protein CcmA', NULL, NULL, NULL, NULL, NULL, 4),
(197866, NULL, 'G3DSA:1.20.920.10:FF:000070', NULL, NULL, 'Related to transcription regulator SPT7', NULL, NULL, NULL, NULL, NULL, 4),
(197867, NULL, 'G3DSA:1.25.40.10:FF:003623', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197868, NULL, 'G3DSA:3.40.47.10:FF:000081', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(197869, NULL, 'G3DSA:1.20.1250.20:FF:001627', NULL, NULL, 'Myo-inositol transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(197870, NULL, 'G3DSA:3.80.10.10:FF:004423', NULL, NULL, 'F-box family protein', NULL, NULL, NULL, NULL, NULL, 4),
(197871, NULL, 'G3DSA:1.10.10.60:FF:001253', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197872, NULL, 'G3DSA:2.20.25.30:FF:000011', NULL, NULL, 'Ribosomal protein L37', NULL, NULL, NULL, NULL, NULL, 4),
(197873, NULL, 'G3DSA:3.40.50.2000:FF:000429', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(197874, NULL, 'G3DSA:2.60.40.10:FF:000100', NULL, NULL, 'Neuronal cell adhesion molecule a', NULL, NULL, NULL, NULL, NULL, 4),
(197875, NULL, 'G3DSA:3.40.190.10:FF:000916', NULL, NULL, 'Putative bifunctional protein [include methyl-accepting chemotaxis protein and an extracellular solute-binding protein]', NULL, NULL, NULL, NULL, NULL, 4),
(197876, NULL, 'G3DSA:2.60.40.60:FF:001110', NULL, NULL, 'Protocadherin X-linked 11', NULL, NULL, NULL, NULL, NULL, 4),
(197877, NULL, 'G3DSA:3.80.10.10:FF:003760', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197878, NULL, 'G3DSA:3.40.50.300:FF:004592', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(197879, NULL, 'G3DSA:3.40.50.410:FF:000050', NULL, NULL, 'Collagen, type VI, alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(197880, NULL, 'G3DSA:3.90.380.10:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197881, NULL, 'G3DSA:1.25.10.10:FF:001446', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(197882, NULL, 'G3DSA:1.10.10.820:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197883, NULL, 'G3DSA:3.30.160.60:FF:001056', NULL, NULL, 'Zinc finger protein 358', NULL, NULL, NULL, NULL, NULL, 4),
(197884, NULL, 'G3DSA:2.60.40.60:FF:000379', NULL, NULL, 'CaDHerin family', NULL, NULL, NULL, NULL, NULL, 4),
(197885, NULL, 'G3DSA:3.30.40.10:FF:000296', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(197886, NULL, 'G3DSA:2.60.40.2030:FF:000058', NULL, NULL, 'Na/Ca-exchange protein, isoform I', NULL, NULL, NULL, NULL, NULL, 4),
(197887, NULL, 'G3DSA:3.40.190.290:FF:000009', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(197888, NULL, 'G3DSA:1.10.287.70:FF:000246', NULL, NULL, 'Inward rectifier potassium channel irk-1', NULL, NULL, NULL, NULL, NULL, 4),
(197889, NULL, 'G3DSA:3.90.1170.30:FF:000004', NULL, NULL, 'AMP phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(197890, NULL, 'G3DSA:3.40.50.2300:FF:000368', NULL, NULL, 'Diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(197891, NULL, 'G3DSA:3.10.28.10:FF:000072', NULL, NULL, 'ATP-dependent DNA helicase Hel308', NULL, NULL, NULL, NULL, NULL, 4),
(197892, NULL, 'G3DSA:3.60.15.10:FF:000135', NULL, NULL, 'Ribonuclease Z', NULL, NULL, NULL, NULL, NULL, 4),
(197893, NULL, 'G3DSA:3.40.50.1000:FF:000809', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197894, NULL, 'G3DSA:2.40.50.1040:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197895, NULL, 'G3DSA:2.40.128.160:FF:000001', NULL, NULL, 'Outer surface protein A', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(197896, NULL, 'G3DSA:1.10.287.70:FF:000572', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(197897, NULL, 'G3DSA:3.40.50.2020:FF:000020', NULL, NULL, 'Bifunctional protein PyrR', NULL, NULL, NULL, NULL, NULL, 4),
(197898, NULL, 'G3DSA:3.30.1010.10:FF:000046', NULL, NULL, 'Phosphatidylinositol 3-kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197899, NULL, 'G3DSA:1.25.40.20:FF:001277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197900, NULL, 'G3DSA:1.10.630.10:FF:000600', NULL, NULL, 'AhbB', NULL, NULL, NULL, NULL, NULL, 4),
(197901, NULL, 'G3DSA:1.20.1250.20:FF:000525', NULL, NULL, 'MFS drug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197902, NULL, 'G3DSA:1.20.1070.10:FF:001852', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197903, NULL, 'G3DSA:3.40.50.300:FF:003164', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(197904, NULL, 'G3DSA:3.40.190.10:FF:000175', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(197905, NULL, 'G3DSA:2.130.10.10:FF:002787', NULL, NULL, 'Coatomer subunit beta''-1', NULL, NULL, NULL, NULL, NULL, 4),
(197906, NULL, 'G3DSA:1.10.510.10:FF:000102', NULL, NULL, 'cyclin-dependent kinase 12 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(197907, NULL, 'G3DSA:2.60.200.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197908, NULL, 'G3DSA:1.25.40.10:FF:001274', NULL, NULL, 'ERAD-associated E3 ubiquitin-protein ligase component HRD3', NULL, NULL, NULL, NULL, NULL, 4),
(197909, NULL, 'G3DSA:3.40.50.300:FF:003490', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(197910, NULL, 'G3DSA:2.40.128.180:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197911, NULL, 'G3DSA:2.20.70.10:FF:000098', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(197912, NULL, 'G3DSA:3.40.50.300:FF:000988', NULL, NULL, 'peroxisome biogenesis factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(197913, NULL, 'G3DSA:1.20.1720.10:FF:000008', NULL, NULL, 'Multidrug transporter MdfA', NULL, NULL, NULL, NULL, NULL, 4),
(197914, NULL, 'G3DSA:3.30.70.330:FF:002370', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197915, NULL, 'G3DSA:3.30.1520.10:FF:000130', NULL, NULL, 'YALI0E07601p', NULL, NULL, NULL, NULL, NULL, 4),
(197916, NULL, 'G3DSA:2.40.50.140:FF:000287', NULL, NULL, 'Methionine-tRNA ligase, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(197917, NULL, 'G3DSA:3.10.330.10:FF:000036', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(197918, NULL, 'G3DSA:3.80.10.10:FF:003855', NULL, NULL, 'PH domain and leucine rich repeat protein phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(197919, NULL, 'G3DSA:3.90.226.10:FF:000192', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(197920, NULL, 'G3DSA:3.40.1180.10:FF:000027', NULL, NULL, 'Isoprenyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(197921, NULL, 'G3DSA:2.30.30.140:FF:000212', NULL, NULL, 'Chromatin modification-related protein EAF3', NULL, NULL, NULL, NULL, NULL, 4),
(197922, NULL, 'G3DSA:1.10.10.60:FF:000685', NULL, NULL, 'Earthbound 2, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(197923, NULL, 'G3DSA:2.60.120.200:FF:000616', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197924, NULL, 'G3DSA:3.40.30.10:FF:001172', NULL, NULL, 'Glutathione s-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(197925, NULL, 'G3DSA:2.60.40.10:FF:005322', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197926, NULL, 'G3DSA:2.60.40.60:FF:000593', NULL, NULL, 'Cadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(197927, NULL, 'G3DSA:2.60.40.150:FF:000002', NULL, NULL, 'Protein unc-13 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(197928, NULL, 'G3DSA:1.20.1070.10:FF:000424', NULL, NULL, 'D(3) dopamine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(197929, NULL, 'G3DSA:3.30.70.330:FF:003033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(197930, NULL, 'G3DSA:3.30.450.20:FF:000190', NULL, NULL, 'Histidine kinase sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(197931, NULL, 'G3DSA:3.90.180.10:FF:000073', NULL, NULL, 'Enoyl-[acyl-carrier-protein] reductase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(197932, NULL, 'G3DSA:1.10.510.10:FF:003233', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197933, NULL, 'G3DSA:2.70.98.10:FF:000019', NULL, NULL, 'Aldose 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(197934, NULL, 'G3DSA:3.40.50.10490:FF:000042', NULL, NULL, 'MurR/RpiR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(197935, NULL, 'G3DSA:1.25.40.10:FF:000931', NULL, NULL, 'Os07g0239600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(197936, NULL, 'G3DSA:3.30.260.10:FF:000110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197937, NULL, 'G3DSA:3.40.390.10:FF:000156', NULL, NULL, 'Endothelin-converting enzyme (AFU_orthologue AFUA_3G12420)', NULL, NULL, NULL, NULL, NULL, 4),
(197938, NULL, 'G3DSA:1.20.1280.20:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197939, NULL, 'G3DSA:1.20.58.60:FF:000047', NULL, NULL, 'Short stop, isoform N', NULL, NULL, NULL, NULL, NULL, 4),
(197940, NULL, 'G3DSA:3.90.640.10:FF:000171', NULL, NULL, 'Hsp70 protein-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(197941, NULL, 'G3DSA:2.10.25.10:FF:000724', NULL, NULL, 'Crumbs cell polarity complex component 2b', NULL, NULL, NULL, NULL, NULL, 4),
(197942, NULL, 'G3DSA:3.20.20.70:FF:000234', NULL, NULL, 'DUS1p Dihydrouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(197943, NULL, 'G3DSA:3.40.50.1820:FF:000151', NULL, NULL, 'Carboxymuconolactone decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(197944, NULL, 'G3DSA:1.20.1090.10:FF:000049', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(197945, NULL, 'G3DSA:1.10.1520.10:FF:000080', NULL, NULL, 'RNase3 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(197946, NULL, 'G3DSA:3.40.50.10810:FF:000149', NULL, NULL, 'Snf2-related CREBBP activator protein', NULL, NULL, NULL, NULL, NULL, 4),
(197947, NULL, 'G3DSA:3.20.20.80:FF:000349', NULL, NULL, 'Maltooligosyltrehalose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(197948, NULL, 'G3DSA:3.30.470.20:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197949, NULL, 'G3DSA:4.10.760.10:FF:000002', NULL, NULL, 'Agouti-signaling protein', NULL, NULL, NULL, NULL, NULL, 4),
(197950, NULL, 'G3DSA:1.10.1520.10:FF:000012', NULL, NULL, 'Ribonuclease 3', NULL, NULL, NULL, NULL, NULL, 4),
(197951, NULL, 'G3DSA:3.10.129.10:FF:000017', NULL, NULL, 'Fatty acid synthase beta subunit dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(197952, NULL, 'G3DSA:2.10.25.10:FF:000045', NULL, NULL, 'Slit guidance ligand 2', NULL, NULL, NULL, NULL, NULL, 4),
(197953, NULL, 'G3DSA:2.60.40.10:FF:005097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197954, NULL, 'G3DSA:1.10.150.240:FF:000074', NULL, NULL, 'Putative phosphoglycolate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(197955, NULL, 'G3DSA:1.25.40.10:FF:000717', NULL, NULL, 'Cilia- and flagella-associated protein 70', NULL, NULL, NULL, NULL, NULL, 4),
(197956, NULL, 'G3DSA:3.40.190.10:FF:000596', NULL, NULL, 'glutamate receptor 2-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(197957, NULL, 'G3DSA:1.20.1250.20:FF:001953', NULL, NULL, 'Zgc:171489', NULL, NULL, NULL, NULL, NULL, 4),
(197958, NULL, 'G3DSA:2.130.10.30:FF:000168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197959, NULL, 'G3DSA:3.40.50.620:FF:000674', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197960, NULL, 'G3DSA:3.80.10.10:FF:003529', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197961, NULL, 'G3DSA:3.20.20.80:FF:000237', NULL, NULL, 'Malto-oligosyltrehalose trehalohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(197962, NULL, 'G3DSA:3.30.1370.50:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(197963, NULL, 'G3DSA:3.30.930.10:FF:000150', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(197964, NULL, 'G3DSA:3.40.350.10:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197965, NULL, 'G3DSA:3.30.710.10:FF:000364', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197966, NULL, 'G3DSA:1.20.1070.10:FF:000166', NULL, NULL, 'Bombesin receptor subtype-3', NULL, NULL, NULL, NULL, NULL, 4),
(197967, NULL, 'G3DSA:2.130.10.110:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197968, NULL, 'G3DSA:2.40.50.40:FF:000094', NULL, NULL, 'Cbx3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(197969, NULL, 'G3DSA:3.40.720.10:FF:000233', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(197970, NULL, 'G3DSA:1.10.1870.10:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197971, NULL, 'G3DSA:3.30.160.60:FF:003394', NULL, NULL, 'CG18262-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(197972, NULL, 'G3DSA:1.10.40.30:FF:000026', NULL, NULL, 'Adenylosuccinate lyase (PurB)', NULL, NULL, NULL, NULL, NULL, 4),
(197973, NULL, 'G3DSA:1.20.1410.10:FF:000024', NULL, NULL, 'Transmembrane protein 98', NULL, NULL, NULL, NULL, NULL, 4),
(197974, NULL, 'G3DSA:3.30.160.780:FF:000001', NULL, NULL, 'Plectin a', NULL, NULL, NULL, NULL, NULL, 4),
(197975, NULL, 'G3DSA:3.40.50.10890:FF:000004', NULL, NULL, 'Cleavage and polyadenylation specifity factor', NULL, NULL, NULL, NULL, NULL, 4),
(197976, NULL, 'G3DSA:3.30.50.10:FF:000061', NULL, NULL, 'GATA transcription factor 14', NULL, NULL, NULL, NULL, NULL, 4),
(197977, NULL, 'G3DSA:3.30.420.10:FF:000033', NULL, NULL, 'Exodeoxyribonuclease I', NULL, NULL, NULL, NULL, NULL, 4),
(197978, NULL, 'G3DSA:1.25.40.10:FF:001206', NULL, NULL, 'Pentatricopeptide repeat protein (AFU_orthologue AFUA_5G10660)', NULL, NULL, NULL, NULL, NULL, 4),
(197979, NULL, 'G3DSA:3.100.10.10:FF:000008', NULL, NULL, '50S ribosomal protein L15', NULL, NULL, NULL, NULL, NULL, 4),
(197980, NULL, 'G3DSA:3.40.50.300:FF:001247', NULL, NULL, 'Erythrocyte membrane-associated antigen', NULL, NULL, NULL, NULL, NULL, 4),
(197981, NULL, 'G3DSA:3.30.70.330:FF:002095', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197982, NULL, 'G3DSA:4.10.800.30:FF:000001', NULL, NULL, 'crossover junction endonuclease EME1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(197983, NULL, 'G3DSA:2.60.120.260:FF:000527', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(197984, NULL, 'G3DSA:3.90.660.10:FF:000115', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197985, NULL, 'G3DSA:2.30.40.10:FF:000051', NULL, NULL, 'Adenine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(197986, NULL, 'G3DSA:1.20.150.20:FF:000002', NULL, NULL, 'ATP synthase subunit alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(197987, NULL, 'G3DSA:3.40.30.10:FF:001267', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(197988, NULL, 'G3DSA:3.30.470.20:FF:000073', NULL, NULL, 'Carbamoyl-phosphate synthase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(197989, NULL, 'G3DSA:3.40.50.720:FF:002391', NULL, NULL, 'Putative oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(197990, NULL, 'G3DSA:3.40.50.970:FF:000144', NULL, NULL, '1-deoxy-D-xylulose-5-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(197991, NULL, 'G3DSA:3.40.50.10880:FF:000001', NULL, NULL, 'Pantothenate kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(197992, NULL, 'G3DSA:1.25.40.10:FF:002808', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197993, NULL, 'G3DSA:2.160.20.10:FF:000038', NULL, NULL, 'F-box only protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(197994, NULL, 'G3DSA:3.40.50.2300:FF:001211', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(197995, NULL, 'G3DSA:2.170.150.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(197996, NULL, 'G3DSA:2.10.60.10:FF:000070', NULL, NULL, 'Prostate and testis expressed protein 4', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(197997, NULL, 'G3DSA:3.10.450.490:FF:000001', NULL, NULL, 'Bacillolysin', NULL, NULL, NULL, NULL, NULL, 4),
(197998, NULL, 'G3DSA:3.30.470.20:FF:000134', NULL, NULL, 'Putative tubulin tyrosine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(197999, NULL, 'G3DSA:1.20.1250.20:FF:000267', NULL, NULL, 'AT3g60070/T2O9_50', NULL, NULL, NULL, NULL, NULL, 4),
(198000, NULL, 'G3DSA:2.60.40.150:FF:000587', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(198001, NULL, 'G3DSA:3.30.700.10:FF:000015', NULL, NULL, 'Geopilin domain 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(198002, NULL, 'G3DSA:2.40.10.10:FF:000279', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(198003, NULL, 'G3DSA:3.30.70.1050:FF:000018', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(198004, NULL, 'G3DSA:3.30.300.30:FF:000030', NULL, NULL, 'Mutant e4 ebony', NULL, NULL, NULL, NULL, NULL, 4),
(198005, NULL, 'G3DSA:3.90.190.10:FF:000416', NULL, NULL, 'DEP-1b', NULL, NULL, NULL, NULL, NULL, 4),
(198006, NULL, 'G3DSA:2.40.50.140:FF:000545', NULL, NULL, '26S protease regulatory subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(198007, NULL, 'G3DSA:3.30.200.20:FF:002228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198008, NULL, 'G3DSA:3.80.10.10:FF:002332', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198009, NULL, 'G3DSA:3.30.160.20:FF:000150', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(198010, NULL, 'G3DSA:3.40.50.2000:FF:000222', NULL, NULL, 'Alpha-1,3-mannosyltransferase ALG2', NULL, NULL, NULL, NULL, NULL, 4),
(198011, NULL, 'G3DSA:1.20.58.60:FF:000098', NULL, NULL, 'dystonin isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(198012, NULL, 'G3DSA:3.30.2350.10:FF:000004', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(198013, NULL, 'G3DSA:2.60.200.20:FF:000168', NULL, NULL, 'Serine/threonine-protein kinase RAD53', NULL, NULL, NULL, NULL, NULL, 4),
(198014, NULL, 'G3DSA:3.30.420.10:FF:000712', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198015, NULL, 'G3DSA:1.20.5.170:FF:000062', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(198016, NULL, 'G3DSA:2.130.10.10:FF:005075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198017, NULL, 'G3DSA:1.20.120.1630:FF:000028', NULL, NULL, 'Protein-S-isoprenylcysteine O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(198018, NULL, 'G3DSA:2.130.10.10:FF:002899', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198019, NULL, 'G3DSA:3.40.47.10:FF:000288', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198020, NULL, 'G3DSA:3.30.200.20:FF:001340', NULL, NULL, 'Kinase, CMGC SRPK', NULL, NULL, NULL, NULL, NULL, 4),
(198021, NULL, 'G3DSA:1.25.10.70:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198022, NULL, 'G3DSA:1.10.287.130:FF:000152', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(198023, NULL, 'G3DSA:3.30.70.330:FF:000099', NULL, NULL, 'insulin-like growth factor 2 mRNA-binding protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(198024, NULL, 'G3DSA:3.90.1150.10:FF:000469', NULL, NULL, 'Aminotransferase, DegT/DnrJ/EryC1/StrS family', NULL, NULL, NULL, NULL, NULL, 4),
(198025, NULL, 'G3DSA:2.60.120.260:FF:000578', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198026, NULL, 'G3DSA:2.40.50.90:FF:000176', NULL, NULL, 'Qin', NULL, NULL, NULL, NULL, NULL, 4),
(198027, NULL, 'G3DSA:3.30.70.1450:FF:000048', NULL, NULL, 'SLC13 family permease', NULL, NULL, NULL, NULL, NULL, 4),
(198028, NULL, 'G3DSA:3.30.710.10:FF:000459', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198029, NULL, 'G3DSA:3.40.50.300:FF:007284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198030, NULL, 'G3DSA:3.90.1150.160:FF:000002', NULL, NULL, 'Glutamate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(198031, NULL, 'G3DSA:3.20.110.10:FF:000034', NULL, NULL, 'Alpha-mannosidase 2c1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198032, NULL, 'G3DSA:3.20.20.80:FF:000142', NULL, NULL, 'Alpha-xylosidase A', NULL, NULL, NULL, NULL, NULL, 4),
(198033, NULL, 'G3DSA:3.40.630.10:FF:000485', NULL, NULL, 'Glutaminylpeptide cyclotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198034, NULL, 'G3DSA:2.130.10.30:FF:000117', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198035, NULL, 'G3DSA:3.30.160.60:FF:001005', NULL, NULL, 'Zinc finger protein 75A', NULL, NULL, NULL, NULL, NULL, 4),
(198036, NULL, 'G3DSA:1.10.8.60:FF:000105', NULL, NULL, 'PeRoXisome assembly factor', NULL, NULL, NULL, NULL, NULL, 4),
(198037, NULL, 'G3DSA:1.25.40.10:FF:002960', NULL, NULL, 'Putative pentatricopeptide repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(198038, NULL, 'G3DSA:1.10.268.20:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198039, NULL, 'G3DSA:1.50.10.20:FF:000008', NULL, NULL, 'Complement C3', NULL, NULL, NULL, NULL, NULL, 4),
(198040, NULL, 'G3DSA:1.50.10.10:FF:000005', NULL, NULL, 'Glycosyl hydrolase, glucoamylase', NULL, NULL, NULL, NULL, NULL, 4),
(198041, NULL, 'G3DSA:3.40.50.300:FF:001152', NULL, NULL, 'tRNA-splicing endonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198042, NULL, 'G3DSA:1.10.760.10:FF:000087', NULL, NULL, 'Hydrazine synthase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(198043, NULL, 'G3DSA:2.30.42.10:FF:000084', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type 13', NULL, NULL, NULL, NULL, NULL, 4),
(198044, NULL, 'G3DSA:3.40.50.620:FF:000174', NULL, NULL, 'ATPase, PP-loop superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(198045, NULL, 'G3DSA:3.40.50.720:FF:000827', NULL, NULL, 'Glycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(198046, NULL, 'G3DSA:2.60.120.590:FF:000042', NULL, NULL, 'ALKylated DNA repair protein AlkB homolog', NULL, NULL, NULL, NULL, NULL, 4),
(198047, NULL, 'G3DSA:3.40.390.10:FF:000218', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198048, NULL, 'G3DSA:2.30.29.30:FF:000373', NULL, NULL, 'Protein still life, isoform SIF type', NULL, NULL, NULL, NULL, NULL, 4),
(198049, NULL, 'G3DSA:3.60.110.10:FF:000008', NULL, NULL, 'Beta-alanine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(198050, NULL, 'G3DSA:1.20.272.40:FF:000004', NULL, NULL, 'ATP-dependent RNA helicase SUV3', NULL, NULL, NULL, NULL, NULL, 4),
(198051, NULL, 'G3DSA:3.30.160.60:FF:002320', NULL, NULL, 'ras-responsive element-binding protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(198052, NULL, 'G3DSA:3.40.50.410:FF:000206', NULL, NULL, 'DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(198053, NULL, 'G3DSA:3.40.50.720:FF:000086', NULL, NULL, 'Quinate/shikimate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(198054, NULL, 'G3DSA:3.30.40.10:FF:000184', NULL, NULL, 'Baculoviral IAP repeat containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(198055, NULL, 'G3DSA:1.10.630.10:FF:000521', NULL, NULL, '5-methyl-1-naphthoate 3-hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(198056, NULL, 'G3DSA:1.10.10.720:FF:000008', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(198057, NULL, 'G3DSA:3.40.50.620:FF:000236', NULL, NULL, 'Valine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(198058, NULL, 'G3DSA:3.30.1520.10:FF:000079', NULL, NULL, 'PX domain protein (AFU_orthologue AFUA_3G08020)', NULL, NULL, NULL, NULL, NULL, 4),
(198059, NULL, 'G3DSA:3.80.10.10:FF:001489', NULL, NULL, 'GD12868', NULL, NULL, NULL, NULL, NULL, 4),
(198060, NULL, 'G3DSA:1.10.260.40:FF:000041', NULL, NULL, 'Asc operon transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(198061, NULL, 'G3DSA:3.40.50.300:FF:004799', NULL, NULL, 'YALI0F20724p', NULL, NULL, NULL, NULL, NULL, 4),
(198062, NULL, 'G3DSA:2.40.30.270:FF:000018', NULL, NULL, 'AaceriACL098Cp', NULL, NULL, NULL, NULL, NULL, 4),
(198063, NULL, 'G3DSA:1.20.1270.60:FF:000134', NULL, NULL, 'Glucosamine 6-phosphate N-acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(198064, NULL, 'G3DSA:1.20.910.10:FF:000030', NULL, NULL, 'Heme oxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(198065, NULL, 'G3DSA:3.40.50.300:FF:005367', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(198066, NULL, 'G3DSA:3.40.50.300:FF:005081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198067, NULL, 'G3DSA:1.20.142.10:FF:000019', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(198068, NULL, 'G3DSA:3.40.50.720:FF:000148', NULL, NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(198069, NULL, 'G3DSA:1.25.40.10:FF:004972', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g71420', NULL, NULL, NULL, NULL, NULL, 4),
(198070, NULL, 'G3DSA:1.20.920.10:FF:000182', NULL, NULL, 'Bromodomain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(198071, NULL, 'G3DSA:2.160.10.10:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198072, NULL, 'G3DSA:1.25.40.10:FF:003511', NULL, NULL, 'stress-induced-phosphoprotein 1-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(198073, NULL, 'G3DSA:3.40.50.1460:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198074, NULL, 'G3DSA:1.20.58.60:FF:000373', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(198075, NULL, 'G3DSA:2.10.90.10:FF:000004', NULL, NULL, 'Transforming growth factor beta', NULL, NULL, NULL, NULL, NULL, 4),
(198076, NULL, 'G3DSA:2.10.25.10:FF:001747', NULL, NULL, 'Laminin, alpha 4', NULL, NULL, NULL, NULL, NULL, 4),
(198077, NULL, 'G3DSA:3.30.70.330:FF:000745', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(198078, NULL, 'G3DSA:2.30.29.30:FF:000452', NULL, NULL, 'Rho GTPase activator (Bem3)', NULL, NULL, NULL, NULL, NULL, 4),
(198079, NULL, 'G3DSA:3.30.160.60:FF:005546', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198080, NULL, 'G3DSA:3.40.30.10:FF:000778', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198081, NULL, 'G3DSA:1.20.140.10:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198082, NULL, 'G3DSA:3.30.420.10:FF:000471', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198083, NULL, 'G3DSA:3.90.1260.10:FF:000005', NULL, NULL, 'Argininosuccinate synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(198084, NULL, 'G3DSA:2.60.120.740:FF:000008', NULL, NULL, 'Polycystic kidney disease 1-like 2a', NULL, NULL, NULL, NULL, NULL, 4),
(198085, NULL, 'G3DSA:2.30.40.10:FF:000129', NULL, NULL, '5-methylthioadenosine/S-adenosylhomocysteine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(198086, NULL, 'G3DSA:2.40.50.140:FF:000219', NULL, NULL, 'Ribonuclease R', NULL, NULL, NULL, NULL, NULL, 4),
(198087, NULL, 'G3DSA:1.10.472.10:FF:000373', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198088, NULL, 'G3DSA:3.40.50.720:FF:000378', NULL, NULL, 'Phosphoglycerate dehydrogenase, putative; 33424-31403', NULL, NULL, NULL, NULL, NULL, 4),
(198089, NULL, 'G3DSA:3.40.50.300:FF:001770', NULL, NULL, 'Nodulation protein H', NULL, NULL, NULL, NULL, NULL, 4),
(198090, NULL, 'G3DSA:1.10.10.10:FF:000709', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(198091, NULL, 'G3DSA:3.40.50.300:FF:002675', NULL, NULL, 'ATP-dependent RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198092, NULL, 'G3DSA:3.40.50.2300:FF:000194', NULL, NULL, 'Two-component system KDP operon response regulator KdpE', NULL, NULL, NULL, NULL, NULL, 4),
(198093, NULL, 'G3DSA:1.20.1250.20:FF:002116', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(198094, NULL, 'G3DSA:3.40.50.300:FF:005316', NULL, NULL, 'Septin', NULL, NULL, NULL, NULL, NULL, 4),
(198095, NULL, 'G3DSA:1.50.40.10:FF:000125', NULL, NULL, 'YMR166C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(198096, NULL, 'G3DSA:2.30.42.10:FF:000179', NULL, NULL, 'Uncharacterized protein, isoform G', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(198097, NULL, 'G3DSA:3.40.50.11260:FF:000014', NULL, NULL, '90 kDa heat shock protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(198098, NULL, 'G3DSA:3.30.70.1990:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198099, NULL, 'G3DSA:1.20.5.190:FF:000068', NULL, NULL, 'Tubulin glycylase 3E', NULL, NULL, NULL, NULL, NULL, 4),
(198100, NULL, 'G3DSA:2.30.42.10:FF:000533', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198101, NULL, 'G3DSA:3.40.720.10:FF:000019', NULL, NULL, 'Phosphoethanolamine transferase ybiP', NULL, NULL, NULL, NULL, NULL, 4),
(198102, NULL, 'G3DSA:1.10.150.110:FF:000001', NULL, NULL, 'Putative Crossover junction endonuclease MUS81', NULL, NULL, NULL, NULL, NULL, 4),
(198103, NULL, 'G3DSA:3.90.1150.10:FF:000520', NULL, NULL, 'Kynureninase', NULL, NULL, NULL, NULL, NULL, 4),
(198104, NULL, 'G3DSA:3.40.50.1950:FF:000010', NULL, NULL, 'Coenzyme A biosynthesis protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(198105, NULL, 'G3DSA:3.30.160.60:FF:005097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198106, NULL, 'G3DSA:1.20.1560.10:FF:000074', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(198107, NULL, 'G3DSA:1.10.1760.20:FF:000010', NULL, NULL, 'Thiamine precursor transporter HmpT', NULL, NULL, NULL, NULL, NULL, 4),
(198108, NULL, 'G3DSA:3.40.50.1820:FF:001140', NULL, NULL, 'Lipase', NULL, NULL, NULL, NULL, NULL, 4),
(198109, NULL, 'G3DSA:3.30.2140.20:FF:000002', NULL, NULL, 'Arylamine N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(198110, NULL, 'G3DSA:2.30.29.30:FF:000098', NULL, NULL, 'Fact complex subunit ssrp1', NULL, NULL, NULL, NULL, NULL, 4),
(198111, NULL, 'G3DSA:3.40.50.11660:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198112, NULL, 'G3DSA:3.80.10.10:FF:002220', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198113, NULL, 'G3DSA:3.30.160.60:FF:001623', NULL, NULL, 'Zinc finger protein 169', NULL, NULL, NULL, NULL, NULL, 4),
(198114, NULL, 'G3DSA:1.10.555.10:FF:000003', NULL, NULL, 'Putative rho GTPase-activating protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(198115, NULL, 'G3DSA:3.90.660.10:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198116, NULL, 'G3DSA:3.30.70.330:FF:000453', NULL, NULL, 'Protein MEI2-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(198117, NULL, 'G3DSA:3.30.420.10:FF:000145', NULL, NULL, 'Endogenous retrovirus group K member 18 Pol protein', NULL, NULL, NULL, NULL, NULL, 4),
(198118, NULL, 'G3DSA:1.25.40.20:FF:001209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198119, NULL, 'G3DSA:1.25.10.10:FF:002806', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198120, NULL, 'G3DSA:1.10.510.10:FF:001608', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198121, NULL, 'G3DSA:3.10.620.30:FF:000002', NULL, NULL, 'kyphoscoliosis peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(198122, NULL, 'G3DSA:3.90.580.10:FF:000002', NULL, NULL, 'Mitochondrial helicase twinkle', NULL, NULL, NULL, NULL, NULL, 4),
(198123, NULL, 'G3DSA:3.30.70.2850:FF:000018', NULL, NULL, 'Putative rna polymerase iii large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(198124, NULL, 'G3DSA:3.40.50.150:FF:001067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198125, NULL, 'G3DSA:3.10.100.10:FF:000148', NULL, NULL, 'Lymphocyte antigen 75', NULL, NULL, NULL, NULL, NULL, 4),
(198126, NULL, 'G3DSA:3.40.50.300:FF:003338', NULL, NULL, 'Ras family protein', NULL, NULL, NULL, NULL, NULL, 4),
(198127, NULL, 'G3DSA:2.60.120.620:FF:000040', NULL, NULL, 'Phytanoyl-CoA dioxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198128, NULL, 'G3DSA:3.10.50.40:FF:000042', NULL, NULL, 'Foldase protein PrsA', NULL, NULL, NULL, NULL, NULL, 4),
(198129, NULL, 'G3DSA:1.20.120.1080:FF:000144', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198130, NULL, 'G3DSA:1.25.40.990:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(198131, NULL, 'G3DSA:3.40.50.740:FF:000013', NULL, NULL, 'NADH-ubiquinone oxidoreductase 78 kDa subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(198132, NULL, 'G3DSA:3.30.56.10:FF:000023', NULL, NULL, 'Phenylalanyl-tRNA synthetase, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(198133, NULL, 'G3DSA:1.20.1070.10:FF:000492', NULL, NULL, 'Protein CBR-MOM-5', NULL, NULL, NULL, NULL, NULL, 4),
(198134, NULL, 'G3DSA:2.10.109.10:FF:000054', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(198135, NULL, 'G3DSA:1.10.10.1100:FF:000010', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198136, NULL, 'G3DSA:2.60.120.650:FF:000049', NULL, NULL, 'JmjC domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198137, NULL, 'G3DSA:2.60.60.20:FF:000020', NULL, NULL, 'Lipid-associated family protein', NULL, NULL, NULL, NULL, NULL, 4),
(198138, NULL, 'G3DSA:2.30.30.100:FF:000133', NULL, NULL, 'Small nuclear ribonucleoprotein F', NULL, NULL, NULL, NULL, NULL, 4),
(198139, NULL, 'G3DSA:1.10.10.2480:FF:000002', NULL, NULL, 'Translation initiation factor IF-2', NULL, NULL, NULL, NULL, NULL, 4),
(198140, NULL, 'G3DSA:2.70.170.10:FF:000289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198141, NULL, 'G3DSA:3.30.160.60:FF:004754', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198142, NULL, 'G3DSA:2.115.10.10:FF:000001', NULL, NULL, 'Repeat domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(198143, NULL, 'G3DSA:3.40.50.2000:FF:000508', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(198144, NULL, 'G3DSA:1.10.150.120:FF:000004', NULL, NULL, 'Selenate reductase subunit YgfN', NULL, NULL, NULL, NULL, NULL, 4),
(198145, NULL, 'G3DSA:2.120.10.30:FF:000337', NULL, NULL, 'Peptidase S9 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(198146, NULL, 'G3DSA:3.40.630.30:FF:000350', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198147, NULL, 'G3DSA:3.30.160.60:FF:003422', NULL, NULL, 'Transcription factor IIIA', NULL, NULL, NULL, NULL, NULL, 4),
(198148, NULL, 'G3DSA:2.30.29.30:FF:000047', NULL, NULL, 'vasodilator-stimulated phosphoprotein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(198149, NULL, 'G3DSA:1.25.40.180:FF:000331', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198150, NULL, 'G3DSA:1.10.437.10:FF:000010', NULL, NULL, 'BH3-interacting domain death agonist', NULL, NULL, NULL, NULL, NULL, 4),
(198151, NULL, 'G3DSA:3.20.20.20:FF:000034', NULL, NULL, 'Dihydropteroate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(198152, NULL, 'G3DSA:1.25.40.10:FF:003123', NULL, NULL, 'Developmental protein', NULL, NULL, NULL, NULL, NULL, 4),
(198153, NULL, 'G3DSA:3.20.20.10:FF:000031', NULL, NULL, 'Ornithine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(198154, NULL, 'G3DSA:3.90.640.10:FF:000120', NULL, NULL, 'Heat shock protein 70, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198155, NULL, 'G3DSA:1.20.1540.10:FF:000062', NULL, NULL, 'GlpG peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(198156, NULL, 'G3DSA:3.30.70.330:FF:000178', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(198157, NULL, 'G3DSA:4.10.1000.10:FF:000021', NULL, NULL, 'Zinc finger CCCH domain-containing protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(198158, NULL, 'G3DSA:2.130.10.10:FF:003158', NULL, NULL, 'AGAP006092-PA', NULL, NULL, NULL, NULL, NULL, 4),
(198159, NULL, 'G3DSA:1.25.40.10:FF:005309', NULL, NULL, 'Clathrin heavy chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(198160, NULL, 'G3DSA:3.40.50.1820:FF:000325', NULL, NULL, 'Haloalkane dehalogenase', NULL, NULL, NULL, NULL, NULL, 4),
(198161, NULL, 'G3DSA:3.10.450.700:FF:000014', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198162, NULL, 'G3DSA:1.20.120.670:FF:000003', NULL, NULL, 'Alpha-N-acetylglucosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(198163, NULL, 'G3DSA:2.130.10.10:FF:000696', NULL, NULL, 'Type II inositol polyphosphate 5-phosphatase 15', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(198164, NULL, 'G3DSA:3.90.70.10:FF:000790', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198165, NULL, 'G3DSA:3.90.660.10:FF:000003', NULL, NULL, 'spermine oxidase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(198166, NULL, 'G3DSA:3.60.10.10:FF:000085', NULL, NULL, 'Inositol-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(198167, NULL, 'G3DSA:3.20.20.30:FF:000037', NULL, NULL, '4-(gamma-L-glutamylamino)butanoyl-[BtrI acyl-carrier protein] monooxygenase BtrO', NULL, NULL, NULL, NULL, NULL, 4),
(198168, NULL, 'G3DSA:2.60.40.10:FF:005501', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198169, NULL, 'G3DSA:2.60.120.10:FF:000052', NULL, NULL, 'Rap guanine nucleotide exchange factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(198170, NULL, 'G3DSA:3.30.160.60:FF:000988', NULL, NULL, 'tripartite motif-containing protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(198171, NULL, 'G3DSA:3.30.2310.10:FF:000007', NULL, NULL, 'tRNA-thr(GGU) m(6)t(6)A37 methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(198172, NULL, 'G3DSA:2.20.100.10:FF:000256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198173, NULL, 'G3DSA:1.20.1460.10:FF:000010', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(198174, NULL, 'G3DSA:3.40.50.620:FF:000562', NULL, NULL, 'YALI0E17919p', NULL, NULL, NULL, NULL, NULL, 4),
(198175, NULL, 'G3DSA:1.10.10.1760:FF:000005', NULL, NULL, '60S ribosomal protein L36 putative', NULL, NULL, NULL, NULL, NULL, 4),
(198176, NULL, 'G3DSA:3.90.660.20:FF:000006', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(198177, NULL, 'G3DSA:1.25.40.770:FF:000002', NULL, NULL, 'TAF6-like RNA polymerase II p300/CBP-associated factor-associated factor 65 kDa subunit 6L', NULL, NULL, NULL, NULL, NULL, 4),
(198178, NULL, 'G3DSA:1.10.730.10:FF:000198', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(198179, NULL, 'G3DSA:2.130.10.10:FF:001264', NULL, NULL, 'Striatin, calmodulin-binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(198180, NULL, 'G3DSA:2.60.120.200:FF:000263', NULL, NULL, 'Cadherin-related tumor suppressor', NULL, NULL, NULL, NULL, NULL, 4),
(198181, NULL, 'G3DSA:2.30.110.10:FF:000030', NULL, NULL, 'Possible oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(198182, NULL, 'G3DSA:3.40.190.10:FF:000793', NULL, NULL, 'Peptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(198183, NULL, 'G3DSA:1.10.4160.10:FF:000024', NULL, NULL, 'Purine-cytosine permease FCY21', NULL, NULL, NULL, NULL, NULL, 4),
(198184, NULL, 'G3DSA:3.30.300.130:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198185, NULL, 'G3DSA:2.170.260.40:FF:000005', NULL, NULL, '5''-3'' exoribonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(198186, NULL, 'G3DSA:1.25.40.420:FF:000032', NULL, NULL, 'LP10161p', NULL, NULL, NULL, NULL, NULL, 4),
(198187, NULL, 'G3DSA:3.30.70.270:FF:000171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198188, NULL, 'G3DSA:2.170.300.10:FF:000017', NULL, NULL, 'Multiple epidermal growth factor-like domains protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(198189, NULL, 'G3DSA:1.20.940.10:FF:000014', NULL, NULL, 'Protein transport protein SEC31', NULL, NULL, NULL, NULL, NULL, 4),
(198190, NULL, 'G3DSA:1.10.10.60:FF:000359', NULL, NULL, 'Tigger transposable element derived 6', NULL, NULL, NULL, NULL, NULL, 4),
(198191, NULL, 'G3DSA:2.70.170.10:FF:000238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198192, NULL, 'G3DSA:3.65.10.20:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198193, NULL, 'G3DSA:1.25.40.10:FF:002634', NULL, NULL, 'DNA/RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198194, NULL, 'G3DSA:3.40.50.1820:FF:001786', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198195, NULL, 'G3DSA:1.10.220.30:FF:000041', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(198196, NULL, 'G3DSA:3.30.160.60:FF:003629', NULL, NULL, 'GG11973', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(198197, NULL, 'G3DSA:3.40.50.720:FF:000474', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(198198, NULL, 'G3DSA:3.80.10.10:FF:002506', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198199, NULL, 'G3DSA:3.30.70.330:FF:000127', NULL, NULL, 'RNA-binding protein EWS isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(198200, NULL, 'G3DSA:3.30.70.250:FF:000013', NULL, NULL, 'Malonyl CoA-acyl carrier protein transacylase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(198201, NULL, 'G3DSA:3.90.70.40:FF:000006', NULL, NULL, 'ataxin-3 isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(198202, NULL, 'G3DSA:3.30.420.40:FF:000429', NULL, NULL, 'N-acetyl-D-glucosamine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(198203, NULL, 'G3DSA:1.25.40.10:FF:000482', NULL, NULL, 'CesD/SycD/LcrH family type III secretion system chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(198204, NULL, 'G3DSA:3.40.50.300:FF:001444', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(198205, NULL, 'G3DSA:3.40.50.2000:FF:000660', NULL, NULL, 'UDP-glycosyltransferase 89C1', NULL, NULL, NULL, NULL, NULL, 4),
(198206, NULL, 'G3DSA:3.40.50.1010:FF:000060', NULL, NULL, 'DNA repair protein RAD2', NULL, NULL, NULL, NULL, NULL, 4),
(198207, NULL, 'G3DSA:3.90.1280.10:FF:000001', NULL, NULL, '33 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(198208, NULL, 'G3DSA:3.30.70.260:FF:000016', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(198209, NULL, 'G3DSA:3.30.160.60:FF:001443', NULL, NULL, 'Zinc finger protein 668', NULL, NULL, NULL, NULL, NULL, 4),
(198210, NULL, 'G3DSA:3.30.200.20:FF:002296', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198211, NULL, 'G3DSA:3.30.70.240:FF:000010', NULL, NULL, 'Elongation factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(198212, NULL, 'G3DSA:3.90.70.30:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198213, NULL, 'G3DSA:2.60.40.150:FF:000295', NULL, NULL, 'Phosphatidylserine decarboxylase proenzyme 2', NULL, NULL, NULL, NULL, NULL, 4),
(198214, NULL, 'G3DSA:3.30.2230.10:FF:000006', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 26', NULL, NULL, NULL, NULL, NULL, 4),
(198215, NULL, 'G3DSA:3.40.250.10:FF:000146', NULL, NULL, 'Putative 3-mercaptopyruvate sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(198216, NULL, 'G3DSA:3.30.70.330:FF:001021', NULL, NULL, 'Novel protein similar to human heterogeneous nuclear ribonucleoprotein C (C1/C2) (HNRPC)', NULL, NULL, NULL, NULL, NULL, 4),
(198217, NULL, 'G3DSA:2.60.120.260:FF:000606', NULL, NULL, 'Glr0080 protein', NULL, NULL, NULL, NULL, NULL, 4),
(198218, NULL, 'G3DSA:3.30.450.20:FF:000543', NULL, NULL, 'Hybrid signal transduction histidine kinase E', NULL, NULL, NULL, NULL, NULL, 4),
(198219, NULL, 'G3DSA:3.30.70.270:FF:000019', NULL, NULL, 'DNA repair protein REV1', NULL, NULL, NULL, NULL, NULL, 4),
(198220, NULL, 'G3DSA:1.25.10.10:FF:000980', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(198221, NULL, 'G3DSA:2.60.120.290:FF:000121', NULL, NULL, 'Cubilin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(198222, NULL, 'G3DSA:1.10.1200.10:FF:000033', NULL, NULL, 'Ss-alanyl conjugating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(198223, NULL, 'G3DSA:2.40.10.190:FF:000001', NULL, NULL, '60S ribosomal protein L35a', NULL, NULL, NULL, NULL, NULL, 4),
(198224, NULL, 'G3DSA:3.30.1360.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198225, NULL, 'G3DSA:1.20.58.60:FF:000547', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198226, NULL, 'G3DSA:1.10.150.20:FF:000173', NULL, NULL, 'DNA transformation protein TfoX1', NULL, NULL, NULL, NULL, NULL, 4),
(198227, NULL, 'G3DSA:1.20.920.10:FF:000131', NULL, NULL, 'MBD9', NULL, NULL, NULL, NULL, NULL, 4),
(198228, NULL, 'G3DSA:3.30.420.10:FF:000420', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198229, NULL, 'G3DSA:1.20.5.170:FF:000236', NULL, NULL, 'AP-1-like transcription factor YAP7', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(198230, NULL, 'G3DSA:2.10.25.10:FF:001798', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198231, NULL, 'G3DSA:3.90.1150.10:FF:000295', NULL, NULL, 'Glycine cleavage system P protein', NULL, NULL, NULL, NULL, NULL, 4),
(198232, NULL, 'G3DSA:3.20.20.100:FF:000174', NULL, NULL, 'Oxidoreductase, aldo/keto reductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(198233, NULL, 'G3DSA:1.20.1070.10:FF:001498', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198234, NULL, 'G3DSA:2.130.10.10:FF:004518', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198235, NULL, 'G3DSA:3.80.10.10:FF:003967', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198236, NULL, 'G3DSA:1.10.10.1800:FF:000006', NULL, NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG 1', NULL, NULL, NULL, NULL, NULL, 4),
(198237, NULL, 'G3DSA:3.40.50.10190:FF:000300', NULL, NULL, 'Replication factor C subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(198238, NULL, 'G3DSA:1.10.1820.10:FF:000024', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(198239, NULL, 'G3DSA:2.40.40.20:FF:000025', NULL, NULL, 'N-ethylmaleimide-sensitive fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(198240, NULL, 'G3DSA:1.20.5.700:FF:000002', NULL, NULL, 'Cytochrome b6-f complex iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4),
(198241, NULL, 'G3DSA:3.40.50.720:FF:002065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198242, NULL, 'G3DSA:2.60.40.60:FF:000997', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198243, NULL, 'G3DSA:3.40.50.300:FF:008189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198244, NULL, 'G3DSA:3.40.390.10:FF:000044', NULL, NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif, 13', NULL, NULL, NULL, NULL, NULL, 4),
(198245, NULL, 'G3DSA:3.30.710.10:FF:000167', NULL, NULL, 'Transcription factor Ken', NULL, NULL, NULL, NULL, NULL, 4),
(198246, NULL, 'G3DSA:3.60.40.10:FF:000148', NULL, NULL, 'Protein phosphatase 2C-2', NULL, NULL, NULL, NULL, NULL, 4),
(198247, NULL, 'G3DSA:2.40.30.10:FF:000488', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198248, NULL, 'G3DSA:3.30.160.60:FF:003068', NULL, NULL, 'GM23957', NULL, NULL, NULL, NULL, NULL, 4),
(198249, NULL, 'G3DSA:3.60.15.10:FF:000186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198250, NULL, 'G3DSA:1.25.40.20:FF:001535', NULL, NULL, 'Ankyrin repeat domain 31', NULL, NULL, NULL, NULL, NULL, 4),
(198251, NULL, 'G3DSA:2.10.25.10:FF:000612', NULL, NULL, 'Crumbs 2, cell polarity complex component', NULL, NULL, NULL, NULL, NULL, 4),
(198252, NULL, 'G3DSA:3.40.50.620:FF:000062', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(198253, NULL, 'G3DSA:3.30.1520.10:FF:000197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198254, NULL, 'G3DSA:3.30.420.40:FF:000598', NULL, NULL, 'WGS project CABT00000000 data, contig 2.85', NULL, NULL, NULL, NULL, NULL, 4),
(198255, NULL, 'G3DSA:1.25.10.10:FF:001154', NULL, NULL, 'Related to nuclear protein SA-1', NULL, NULL, NULL, NULL, NULL, 4),
(198256, NULL, 'G3DSA:1.10.287.130:FF:000091', NULL, NULL, 'Autoinducer 2 sensor kinase/phosphatase LuxQ', NULL, NULL, NULL, NULL, NULL, 4),
(198257, NULL, 'G3DSA:3.50.50.60:FF:001125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198258, NULL, 'G3DSA:3.30.710.10:FF:000460', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198259, NULL, 'G3DSA:3.30.780.10:FF:000020', NULL, NULL, '60S ribosomal protein IMG2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(198260, NULL, 'G3DSA:3.40.50.300:FF:002787', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(198261, NULL, 'G3DSA:3.30.740.10:FF:000012', NULL, NULL, 'Dynein light chain', NULL, NULL, NULL, NULL, NULL, 4),
(198262, NULL, 'G3DSA:2.40.128.20:FF:000032', NULL, NULL, 'Outer membrane lipoprotein Blc', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(198263, NULL, 'G3DSA:3.30.200.20:FF:000379', NULL, NULL, 'eIF-2-alpha kinase GCN2', NULL, NULL, NULL, NULL, NULL, 4),
(198264, NULL, 'G3DSA:1.20.1440.130:FF:000005', NULL, NULL, 'Vitamin K epoxide reductase family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198265, NULL, 'G3DSA:3.30.70.2890:FF:000002', NULL, NULL, 'XS domain-containing protein / XS zinc finger domain-containing protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(198266, NULL, 'G3DSA:3.90.180.10:FF:000039', NULL, NULL, 'Ast1p', NULL, NULL, NULL, NULL, NULL, 4),
(198267, NULL, 'G3DSA:3.10.110.10:FF:000379', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198268, NULL, 'G3DSA:3.90.70.10:FF:000576', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198269, NULL, 'G3DSA:3.10.20.230:FF:000024', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198270, NULL, 'G3DSA:3.40.50.1820:FF:000701', NULL, NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(198271, NULL, 'G3DSA:1.10.441.10:FF:000003', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(198272, NULL, 'G3DSA:2.40.50.90:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198273, NULL, 'G3DSA:3.30.450.60:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198274, NULL, 'G3DSA:3.80.10.10:FF:004131', NULL, NULL, 'Leucine-rich repeat family protein /protein kinase family protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(198275, NULL, 'G3DSA:1.20.5.710:FF:000005', NULL, NULL, '50S ribosomal protein L7/L12', NULL, NULL, NULL, NULL, NULL, 4),
(198276, NULL, 'G3DSA:1.20.140.10:FF:000004', NULL, NULL, 'Acyl-CoA dehydrogenase FadE25', NULL, NULL, NULL, NULL, NULL, 4),
(198277, NULL, 'G3DSA:3.60.21.10:FF:000110', NULL, NULL, 'Unplaced genomic scaffold supercont2.9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(198278, NULL, 'G3DSA:2.130.10.10:FF:004586', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198279, NULL, 'G3DSA:2.30.39.10:FF:000160', NULL, NULL, 'Serpin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198280, NULL, 'G3DSA:1.50.40.10:FF:000013', NULL, NULL, 'Mitochondrial 2-oxoglutarate/malate carrier protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(198281, NULL, 'G3DSA:1.25.10.10:FF:002778', NULL, NULL, 'Serine/threonine-protein kinase RUNKEL', NULL, NULL, NULL, NULL, NULL, 4),
(198282, NULL, 'G3DSA:3.30.160.60:FF:001831', NULL, NULL, 'Zinc finger protein Gfi-1b', NULL, NULL, NULL, NULL, NULL, 4),
(198283, NULL, 'G3DSA:1.10.510.10:FF:002862', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198284, NULL, 'G3DSA:3.30.160.60:FF:002966', NULL, NULL, 'LD24322p', NULL, NULL, NULL, NULL, NULL, 4),
(198285, NULL, 'G3DSA:3.60.20.10:FF:000265', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198286, NULL, 'G3DSA:3.40.570.10:FF:000024', NULL, NULL, 'Testis EndoG-Like 3', NULL, NULL, NULL, NULL, NULL, 4),
(198287, NULL, 'G3DSA:3.20.20.140:FF:000124', NULL, NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(198288, NULL, 'G3DSA:3.40.50.2000:FF:000194', NULL, NULL, 'UDP glucuronosyltransferase 2 family polypeptide a4 short isoform', NULL, NULL, NULL, NULL, NULL, 4),
(198289, NULL, 'G3DSA:3.40.190.10:FF:000624', NULL, NULL, 'Putative chorismate mutase/prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(198290, NULL, 'G3DSA:1.20.140.20:FF:000007', NULL, NULL, 'Pyruvate dehydrogenase (Lipoamide) kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198291, NULL, 'G3DSA:1.10.1200.10:FF:000151', NULL, NULL, 'Polyketide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(198292, NULL, 'G3DSA:3.50.7.10:FF:000068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198293, NULL, 'G3DSA:2.60.40.10:FF:001382', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(198294, NULL, 'G3DSA:3.40.50.150:FF:001360', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(198295, NULL, 'G3DSA:1.10.10.10:FF:001474', NULL, NULL, 'Histone H1', NULL, NULL, NULL, NULL, NULL, 4),
(198296, NULL, 'G3DSA:1.20.5.100:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198297, NULL, 'G3DSA:1.10.238.10:FF:000907', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198298, NULL, 'G3DSA:2.170.300.10:FF:000051', NULL, NULL, 'LAMinin related. See also lmb', NULL, NULL, NULL, NULL, NULL, 4),
(198299, NULL, 'G3DSA:3.30.70.1350:FF:000018', NULL, NULL, 'Mitochondrial protein with role in iron accumulation', NULL, NULL, NULL, NULL, NULL, 4),
(198300, NULL, 'G3DSA:3.90.20.20:FF:000014', NULL, NULL, 'Protein GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(198301, NULL, 'G3DSA:1.20.1440.120:FF:000002', NULL, NULL, 'DNA repair protein RecO', NULL, NULL, NULL, NULL, NULL, 4),
(198302, NULL, 'G3DSA:3.40.50.720:FF:000266', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(198303, NULL, 'G3DSA:3.30.1780.10:FF:000002', NULL, NULL, 'Ornithine cyclodeaminase', NULL, NULL, NULL, NULL, NULL, 4),
(198304, NULL, 'G3DSA:1.10.238.10:FF:000795', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(198305, NULL, 'G3DSA:1.20.5.110:FF:000033', NULL, NULL, 'bet1-like SNARE 1-1', NULL, NULL, NULL, NULL, NULL, 4),
(198306, NULL, 'G3DSA:2.30.42.10:FF:000645', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198307, NULL, 'G3DSA:1.25.40.90:FF:000117', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198308, NULL, 'G3DSA:2.120.10.80:FF:000425', NULL, NULL, 'Protein ral2', NULL, NULL, NULL, NULL, NULL, 4),
(198309, NULL, 'G3DSA:3.30.200.20:FF:000429', NULL, NULL, 'Calcium/calmodulin-dependent protein kinase kinase', NULL, NULL, NULL, NULL, NULL, 4),
(198310, NULL, 'G3DSA:2.60.40.10:FF:003523', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198311, NULL, 'G3DSA:3.40.50.720:FF:000209', NULL, NULL, 'Polyketide synthase Pks12', NULL, NULL, NULL, NULL, NULL, 4),
(198312, NULL, 'G3DSA:1.10.510.10:FF:001434', NULL, NULL, 'Si:ch211-171h4.3', NULL, NULL, NULL, NULL, NULL, 4),
(198313, NULL, 'G3DSA:1.20.1560.10:FF:000248', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(198314, NULL, 'G3DSA:3.90.1280.20:FF:000004', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(198315, NULL, 'G3DSA:3.40.50.300:FF:000758', NULL, NULL, 'Mov10 RISC complex RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(198316, NULL, 'G3DSA:3.60.120.10:FF:000014', NULL, NULL, 'Isochorismate synthase MenF', NULL, NULL, NULL, NULL, NULL, 4),
(198317, NULL, 'G3DSA:1.10.287.70:FF:000280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198318, NULL, 'G3DSA:2.130.10.10:FF:004001', NULL, NULL, 'WD repeat domain, phosphoinositide-interacting 1', NULL, NULL, NULL, NULL, NULL, 4),
(198319, NULL, 'G3DSA:3.20.140.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198320, NULL, 'G3DSA:3.30.70.3270:FF:000015', NULL, NULL, 'NADH-quinone oxidoreductase subunit I 1', NULL, NULL, NULL, NULL, NULL, 4),
(198321, NULL, 'G3DSA:2.130.10.10:FF:003063', NULL, NULL, 'WD40-repeat-containing domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(198322, NULL, 'G3DSA:3.40.50.300:FF:001652', NULL, NULL, 'Type VII secretion protein EccC', NULL, NULL, NULL, NULL, NULL, 4),
(198323, NULL, 'G3DSA:2.10.25.10:FF:000432', NULL, NULL, 'Delta-like 3 (Drosophila), isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(198324, NULL, 'G3DSA:2.130.10.10:FF:005193', NULL, NULL, 'Spliceosome associated factor 3b, subunit 3; 130kD spliceosome associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(198325, NULL, 'G3DSA:1.10.10.60:FF:000977', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198326, NULL, 'G3DSA:1.10.3170.10:FF:000002', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(198327, NULL, 'G3DSA:3.90.1210.10:FF:000002', NULL, NULL, 'Sialic acid synthase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(198328, NULL, 'G3DSA:3.30.70.940:FF:000006', NULL, NULL, 'Transcription termination/antitermination protein NusG', NULL, NULL, NULL, NULL, NULL, 4),
(198329, NULL, 'G3DSA:2.30.30.100:FF:000048', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm4', NULL, NULL, NULL, NULL, NULL, 4),
(198330, NULL, 'G3DSA:2.10.25.10:FF:000112', NULL, NULL, 'Netrin G1', NULL, NULL, NULL, NULL, NULL, 4),
(198331, NULL, 'G3DSA:3.50.50.60:FF:000951', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198332, NULL, 'G3DSA:3.40.50.300:FF:007733', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198333, NULL, 'G3DSA:2.60.120.200:FF:000324', NULL, NULL, 'Vesicular integral membrane protein VIP36, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198334, NULL, 'G3DSA:2.40.50.140:FF:001001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198335, NULL, 'G3DSA:2.60.40.10:FF:004658', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198336, NULL, 'G3DSA:1.10.10.10:FF:000923', NULL, NULL, 'Probable two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(198337, NULL, 'G3DSA:1.20.1250.20:FF:002055', NULL, NULL, 'CLN3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(198338, NULL, 'G3DSA:1.10.10.390:FF:000010', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(198339, NULL, 'G3DSA:2.10.70.10:FF:000121', NULL, NULL, 'Sushi domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(198340, NULL, 'G3DSA:3.90.550.10:FF:000579', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(198341, NULL, 'G3DSA:1.25.10.10:FF:003245', NULL, NULL, 'Unc-45 myosin chaperone B', NULL, NULL, NULL, NULL, NULL, 4),
(198342, NULL, 'G3DSA:3.80.10.10:FF:002950', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198343, NULL, 'G3DSA:1.25.10.10:FF:000654', NULL, NULL, 'Cullin-associated NEDD8-dissociated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(198344, NULL, 'G3DSA:1.20.1070.10:FF:000716', NULL, NULL, 'Adrenoceptor alpha 2C', NULL, NULL, NULL, NULL, NULL, 4),
(198345, NULL, 'G3DSA:1.10.510.10:FF:002957', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198346, NULL, 'G3DSA:1.10.1040.10:FF:000110', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198347, NULL, 'G3DSA:3.40.50.300:FF:003782', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198348, NULL, 'G3DSA:2.10.50.10:FF:000007', NULL, NULL, 'TNF receptor superfamily member 14', NULL, NULL, NULL, NULL, NULL, 4),
(198349, NULL, 'G3DSA:1.20.1250.20:FF:000817', NULL, NULL, 'Autophagy-related protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(198350, NULL, 'G3DSA:2.60.40.60:FF:000828', NULL, NULL, 'E-cadherin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(198351, NULL, 'G3DSA:1.10.287.110:FF:000287', NULL, NULL, 'DnaJ domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(198352, NULL, 'G3DSA:2.60.40.60:FF:001082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198353, NULL, 'G3DSA:1.10.472.10:FF:000676', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198354, NULL, 'G3DSA:3.90.1380.10:FF:000003', NULL, NULL, 'THR4p Threonine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(198355, NULL, 'G3DSA:1.10.510.10:FF:000827', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(198356, NULL, 'G3DSA:1.20.5.2210:FF:000003', NULL, NULL, 'ATP synthase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(198357, NULL, 'G3DSA:2.40.30.10:FF:000376', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198358, NULL, 'G3DSA:3.40.50.880:FF:000229', NULL, NULL, 'Carbamoyl-phosphate synthase small chain', NULL, NULL, NULL, NULL, NULL, 4),
(198359, NULL, 'G3DSA:3.30.70.660:FF:000080', NULL, NULL, 'Pseudouridylate synthase I, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198360, NULL, 'G3DSA:1.10.260.170:FF:000004', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(198361, NULL, 'G3DSA:3.40.50.300:FF:007104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198362, NULL, 'G3DSA:3.40.50.620:FF:000382', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(198363, NULL, 'G3DSA:3.40.1110.10:FF:000107', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(198364, NULL, 'G3DSA:2.60.40.420:FF:000055', NULL, NULL, 'Cytochrome c oxidase subunit II', NULL, NULL, NULL, NULL, NULL, 4),
(198365, NULL, 'G3DSA:1.10.8.60:FF:000201', NULL, NULL, 'AAA family ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198366, NULL, 'G3DSA:1.25.40.10:FF:003073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198367, NULL, 'G3DSA:1.20.58.760:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198368, NULL, 'G3DSA:1.10.1420.10:FF:000095', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(198369, NULL, 'G3DSA:2.60.40.10:FF:002629', NULL, NULL, 'MSP_(Major_sperm_protein )_domain_containing_protein_-__putative', NULL, NULL, NULL, NULL, NULL, 4),
(198370, NULL, 'G3DSA:1.10.2000.10:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198371, NULL, 'G3DSA:1.10.150.380:FF:000003', NULL, NULL, 'Aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(198372, NULL, 'G3DSA:3.40.50.300:FF:007380', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198373, NULL, 'G3DSA:3.30.160.60:FF:002112', NULL, NULL, 'ZNF415 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(198374, NULL, 'G3DSA:1.10.3470.10:FF:000047', NULL, NULL, 'Metal ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(198375, NULL, 'G3DSA:3.30.160.60:FF:001090', NULL, NULL, 'zinc finger protein 629 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(198376, NULL, 'G3DSA:3.10.100.10:FF:000199', NULL, NULL, 'Mannose binding lectin 2', NULL, NULL, NULL, NULL, NULL, 4),
(198377, NULL, 'G3DSA:1.10.3090.10:FF:000001', NULL, NULL, 'Multifunctional CCA protein', NULL, NULL, NULL, NULL, NULL, 4),
(198378, NULL, 'G3DSA:4.10.280.10:FF:000151', NULL, NULL, 'Transcription factor HES-1-B', NULL, NULL, NULL, NULL, NULL, 4),
(198379, NULL, 'G3DSA:3.80.10.10:FF:000707', NULL, NULL, 'NACHT, LRR and PYD domains-containing protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(198380, NULL, 'G3DSA:3.30.710.10:FF:000252', NULL, NULL, 'SKP1-like protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(198381, NULL, 'G3DSA:3.90.640.10:FF:000232', NULL, NULL, 'Actin-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(198382, NULL, 'G3DSA:3.90.550.10:FF:000759', NULL, NULL, 'Galactosylgalactosylxylosylprotein 3-beta-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(198383, NULL, 'G3DSA:3.30.70.2510:FF:000001', NULL, NULL, 'tRNA pseudouridine synthase Pus10', NULL, NULL, NULL, NULL, NULL, 4),
(198384, NULL, 'G3DSA:2.130.10.10:FF:001152', NULL, NULL, 'Cleavage and Polyadenylation Factor', NULL, NULL, NULL, NULL, NULL, 4),
(198385, NULL, 'G3DSA:3.30.230.10:FF:000254', NULL, NULL, 'Type 2 DNA topoisomerase 6 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(198386, NULL, 'G3DSA:3.40.50.150:FF:000578', NULL, NULL, 'SAM-dependent methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(198387, NULL, 'G3DSA:1.25.40.1030:FF:000015', NULL, NULL, 'Protein transport protein sec16', NULL, NULL, NULL, NULL, NULL, 4),
(198388, NULL, 'G3DSA:1.10.10.2670:FF:000003', NULL, NULL, 'E3 ubiquitin-protein ligase PRT6', NULL, NULL, NULL, NULL, NULL, 4),
(198389, NULL, 'G3DSA:3.20.20.70:FF:000700', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198390, NULL, 'G3DSA:3.30.479.30:FF:000011', NULL, NULL, 'stomatin-like protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(198391, NULL, 'G3DSA:3.30.160.60:FF:003860', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198392, NULL, 'G3DSA:3.30.450.40:FF:000257', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(198393, NULL, 'G3DSA:2.60.40.10:FF:001174', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(198394, NULL, 'G3DSA:3.90.180.10:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198395, NULL, 'G3DSA:1.25.40.10:FF:004697', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198396, NULL, 'G3DSA:1.25.40.10:FF:004585', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198397, NULL, 'G3DSA:1.20.1250.20:FF:000610', NULL, NULL, 'monocarboxylate transporter 12-like', NULL, NULL, NULL, NULL, NULL, 4),
(198398, NULL, 'G3DSA:3.20.20.80:FF:000703', NULL, NULL, 'Os02g0528200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(198399, NULL, 'G3DSA:3.40.50.10240:FF:000012', NULL, NULL, 'Thiamine pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(198400, NULL, 'G3DSA:1.10.287.130:FF:000034', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(198401, NULL, 'G3DSA:3.30.1330.30:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198402, NULL, 'G3DSA:1.10.510.10:FF:003851', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198403, NULL, 'G3DSA:2.60.40.10:FF:001117', NULL, NULL, 'Down syndrome cell adhesion molecule 4, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(198404, NULL, 'G3DSA:3.30.1120.30:FF:000043', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(198405, NULL, 'G3DSA:1.20.58.60:FF:000873', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(198406, NULL, 'G3DSA:2.70.98.50:FF:000003', NULL, NULL, 'Large secreted protein, putative, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(198407, NULL, 'G3DSA:3.30.450.20:FF:000251', NULL, NULL, 'Sensory box sensor histidine kinase/response regulator VieS', NULL, NULL, NULL, NULL, NULL, 4),
(198408, NULL, 'G3DSA:1.20.900.10:FF:000068', NULL, NULL, 'FUS2p Cell fusion regulator', NULL, NULL, NULL, NULL, NULL, 4),
(198409, NULL, 'G3DSA:1.10.1370.10:FF:000034', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198410, NULL, 'G3DSA:2.130.10.10:FF:002719', NULL, NULL, 'AEL226Wp', NULL, NULL, NULL, NULL, NULL, 4),
(198411, NULL, 'G3DSA:1.10.1300.10:FF:000029', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(198412, NULL, 'G3DSA:3.40.50.300:FF:000876', NULL, NULL, 'Mitochondrial GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(198413, NULL, 'G3DSA:3.30.160.60:FF:001617', NULL, NULL, 'zinc finger protein 420 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(198414, NULL, 'G3DSA:3.40.50.150:FF:001567', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198415, NULL, 'G3DSA:3.30.40.10:FF:002095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198416, NULL, 'G3DSA:3.30.470.20:FF:000252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198417, NULL, 'G3DSA:3.30.559.10:FF:000270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198418, NULL, 'G3DSA:3.40.50.720:FF:002452', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198419, NULL, 'G3DSA:1.25.40.20:FF:001827', NULL, NULL, 'MIB (MIndBomb) ubiquitin ligase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(198420, NULL, 'G3DSA:1.10.1090.10:FF:000001', NULL, NULL, 'Cytochrome b-c1 complex subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(198421, NULL, 'G3DSA:1.10.10.10:FF:000659', NULL, NULL, 'Putative serine/threonine protein kinase IREH1', NULL, NULL, NULL, NULL, NULL, 4),
(198422, NULL, 'G3DSA:2.130.10.10:FF:004962', NULL, NULL, 'Plexin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198423, NULL, 'G3DSA:3.30.980.10:FF:000001', NULL, NULL, 'Threonine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(198424, NULL, 'G3DSA:3.10.400.20:FF:000016', NULL, NULL, 'YALI0D12727p', NULL, NULL, NULL, NULL, NULL, 4),
(198425, NULL, 'G3DSA:1.25.40.10:FF:004528', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198426, NULL, 'G3DSA:3.30.70.330:FF:000565', NULL, NULL, 'RNA-binding protein 15B', NULL, NULL, NULL, NULL, NULL, 4),
(198427, NULL, 'G3DSA:3.40.50.2000:FF:000834', NULL, NULL, 'O-linked GlcNAc transferase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(198428, NULL, 'G3DSA:1.10.10.60:FF:001141', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198429, NULL, 'G3DSA:2.130.10.10:FF:001713', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(198430, NULL, 'G3DSA:3.30.40.10:FF:000419', NULL, NULL, 'RING finger protein 24', NULL, NULL, NULL, NULL, NULL, 4),
(198431, NULL, 'G3DSA:1.10.1670.10:FF:000079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198432, NULL, 'G3DSA:2.10.25.10:FF:000320', NULL, NULL, 'Proepiregulin', NULL, NULL, NULL, NULL, NULL, 4),
(198433, NULL, 'G3DSA:3.30.43.10:FF:000044', NULL, NULL, 'Fad-linked oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(198434, NULL, 'G3DSA:3.80.10.10:FF:004018', NULL, NULL, 'Si:dkey-286j17.4', NULL, NULL, NULL, NULL, NULL, 4),
(198435, NULL, 'G3DSA:2.10.70.10:FF:000008', NULL, NULL, 'Complement receptor type 1', NULL, NULL, NULL, NULL, NULL, 4),
(198436, NULL, 'G3DSA:3.30.465.10:FF:000052', NULL, NULL, 'Decaprenylphosphoryl-beta-D-ribose oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(198437, NULL, 'G3DSA:1.25.40.10:FF:004433', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198438, NULL, 'G3DSA:1.20.1250.20:FF:000705', NULL, NULL, 'Organic cation transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(198439, NULL, 'G3DSA:3.40.1690.20:FF:000018', NULL, NULL, 'Peptidase family M41-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(198440, NULL, 'G3DSA:3.40.50.720:FF:001103', NULL, NULL, 'Glyoxylate/hydroxypyruvate reductase A', NULL, NULL, NULL, NULL, NULL, 4),
(198441, NULL, 'G3DSA:1.20.1250.20:FF:002330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198442, NULL, 'G3DSA:3.40.50.300:FF:000016', NULL, NULL, 'Oligopeptide ABC transporter ATP-binding component', NULL, NULL, NULL, NULL, NULL, 4),
(198443, NULL, 'G3DSA:1.25.40.20:FF:000203', NULL, NULL, 'caseinolytic peptidase B protein homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(198444, NULL, 'G3DSA:1.25.10.20:FF:000022', NULL, NULL, 'Hemelipoglyco-carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(198445, NULL, 'G3DSA:1.10.560.10:FF:000021', NULL, NULL, 'Chaperonin containing TCP1, subunit 5 (epsilon)', NULL, NULL, NULL, NULL, NULL, 4),
(198446, NULL, 'G3DSA:1.10.510.10:FF:001058', NULL, NULL, 'Tau tubulin kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(198447, NULL, 'G3DSA:3.40.50.80:FF:000075', NULL, NULL, 'BnaA08g31310D protein', NULL, NULL, NULL, NULL, NULL, 4),
(198448, NULL, 'G3DSA:3.30.420.40:FF:000873', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198449, NULL, 'G3DSA:4.10.240.10:FF:000143', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(198450, NULL, 'G3DSA:2.60.40.10:FF:001735', NULL, NULL, 'CD244 molecule A', NULL, NULL, NULL, NULL, NULL, 4),
(198451, NULL, 'G3DSA:3.40.50.10490:FF:000154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198452, NULL, 'G3DSA:2.30.30.140:FF:000324', NULL, NULL, 'KIN17-like protein KLP', NULL, NULL, NULL, NULL, NULL, 4),
(198453, NULL, 'G3DSA:3.30.160.20:FF:000032', NULL, NULL, 'endoribonuclease Dicer homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(198454, NULL, 'G3DSA:3.30.390.150:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198455, NULL, 'G3DSA:3.40.50.2300:FF:000929', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198456, NULL, 'G3DSA:3.40.50.620:FF:000270', NULL, NULL, 'Leucine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(198457, NULL, 'G3DSA:2.130.10.10:FF:001472', NULL, NULL, 'WD_domain_-_G-beta_repeat_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(198458, NULL, 'G3DSA:2.60.40.2070:FF:000008', NULL, NULL, 'Probable fimbrial usher protein', NULL, NULL, NULL, NULL, NULL, 4),
(198459, NULL, 'G3DSA:3.30.420.140:FF:000032', NULL, NULL, 'Transcription elongation factor Spt6', NULL, NULL, NULL, NULL, NULL, 4),
(198460, NULL, 'G3DSA:3.40.50.1980:FF:000058', NULL, NULL, 'Iron (III) ABC transporter, periplasmic iron-bindin gprotein', NULL, NULL, NULL, NULL, NULL, 4),
(198461, NULL, 'G3DSA:3.40.50.2000:FF:000273', NULL, NULL, 'UDP-glucuronate:glycolipid 2-beta-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(198462, NULL, 'G3DSA:3.30.760.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198463, NULL, 'G3DSA:3.40.50.1970:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198464, NULL, 'G3DSA:2.60.40.10:FF:000943', NULL, NULL, 'Classical MHC class I molecule, alpha-chain', NULL, NULL, NULL, NULL, NULL, 4),
(198465, NULL, 'G3DSA:2.60.120.200:FF:000049', NULL, NULL, 'collagen alpha-2(XI) chain isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(198466, NULL, 'G3DSA:1.10.287.370:FF:000044', NULL, NULL, 'Prefoldin subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198467, NULL, 'G3DSA:3.30.70.330:FF:001116', NULL, NULL, 'UBP1-associated protein 2C', NULL, NULL, NULL, NULL, NULL, 4),
(198468, NULL, 'G3DSA:1.10.630.10:FF:000813', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198469, NULL, 'G3DSA:3.40.50.1460:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198470, NULL, 'G3DSA:3.40.50.10140:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198471, NULL, 'G3DSA:2.10.110.10:FF:000186', NULL, NULL, 'Actin binding LIM protein family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(198472, NULL, 'G3DSA:3.50.30.30:FF:000002', NULL, NULL, 'N-acetylated-alpha-linked acidic dipeptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(198473, NULL, 'G3DSA:1.10.533.10:FF:000189', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198474, NULL, 'G3DSA:3.40.50.300:FF:003243', NULL, NULL, 'ATP-dependent RNA helicase DDX3Y', NULL, NULL, NULL, NULL, NULL, 4),
(198475, NULL, 'G3DSA:3.30.40.10:FF:002370', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198476, NULL, 'G3DSA:3.40.50.300:FF:007172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198477, NULL, 'G3DSA:1.20.960.10:FF:000010', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198478, NULL, 'G3DSA:3.30.200.20:FF:000497', NULL, NULL, 'Serine/threonine-protein kinase Nek6', NULL, NULL, NULL, NULL, NULL, 4),
(198479, NULL, 'G3DSA:2.30.230.10:FF:000027', NULL, NULL, 'Vitellogenin 5', NULL, NULL, NULL, NULL, NULL, 4),
(198480, NULL, 'G3DSA:2.70.160.11:FF:000042', NULL, NULL, 'GM25898', NULL, NULL, NULL, NULL, NULL, 4),
(198481, NULL, 'G3DSA:3.30.420.40:FF:000188', NULL, NULL, 'Actin like 6B', NULL, NULL, NULL, NULL, NULL, 4),
(198482, NULL, 'G3DSA:1.10.510.10:FF:000895', NULL, NULL, 'SRSF protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(198483, NULL, 'G3DSA:1.10.10.60:FF:000567', NULL, NULL, 'Transcriptional regulator CmeR', NULL, NULL, NULL, NULL, NULL, 4),
(198484, NULL, 'G3DSA:3.60.20.10:FF:000254', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198485, NULL, 'G3DSA:1.25.40.10:FF:002842', NULL, NULL, 'Chs4p', NULL, NULL, NULL, NULL, NULL, 4),
(198486, NULL, 'G3DSA:2.40.50.90:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198487, NULL, 'G3DSA:1.10.472.10:FF:000665', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198488, NULL, 'G3DSA:3.80.10.10:FF:000157', NULL, NULL, 'Class II major histocompatibility complex transactivator', NULL, NULL, NULL, NULL, NULL, 4),
(198489, NULL, 'G3DSA:3.10.129.10:FF:000231', NULL, NULL, 'Fatty acid synthase beta subunit aflB', NULL, NULL, NULL, NULL, NULL, 4),
(198490, NULL, 'G3DSA:3.40.50.300:FF:002967', NULL, NULL, 'Transport ATP-binding protein CydD', NULL, NULL, NULL, NULL, NULL, 4),
(198491, NULL, 'G3DSA:1.20.1270.10:FF:000029', NULL, NULL, 'Heat shock 70 kDa protein cognate', NULL, NULL, NULL, NULL, NULL, 4),
(198492, NULL, 'G3DSA:3.30.420.40:FF:001036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198493, NULL, 'G3DSA:3.50.50.60:FF:000451', NULL, NULL, 'FAD-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(198494, NULL, 'G3DSA:3.40.50.1820:FF:000712', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(198495, NULL, 'G3DSA:3.40.630.10:FF:000434', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(198496, NULL, 'G3DSA:3.30.70.330:FF:002982', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198497, NULL, 'G3DSA:3.30.559.10:FF:000118', NULL, NULL, 'Carnitine O-palmitoyltransferase 1, muscle isoform', NULL, NULL, NULL, NULL, NULL, 4),
(198498, NULL, 'G3DSA:1.20.120.720:FF:000029', NULL, NULL, 'Myosin E', NULL, NULL, NULL, NULL, NULL, 4),
(198499, NULL, 'G3DSA:2.60.40.420:FF:000044', NULL, NULL, 'L-ascorbate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(198500, NULL, 'G3DSA:3.30.44.10:FF:000001', NULL, NULL, 'Salt-mediated killer protoxin 1', NULL, NULL, NULL, NULL, NULL, 4),
(198501, NULL, 'G3DSA:3.40.30.10:FF:000250', NULL, NULL, 'Thioredoxin F-type, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(198502, NULL, 'G3DSA:3.10.580.10:FF:000054', NULL, NULL, 'Magnesium transporter MgtE', NULL, NULL, NULL, NULL, NULL, 4),
(198503, NULL, 'G3DSA:1.25.40.10:FF:002168', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g50420', NULL, NULL, NULL, NULL, NULL, 4),
(198504, NULL, 'G3DSA:1.20.58.60:FF:000665', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198505, NULL, 'G3DSA:1.10.1300.10:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198506, NULL, 'G3DSA:1.25.40.10:FF:004197', NULL, NULL, 'Mitochondrial outer membrane 72K protein', NULL, NULL, NULL, NULL, NULL, 4),
(198507, NULL, 'G3DSA:3.40.50.150:FF:000567', NULL, NULL, 'tRNA (Cytosine-5-)-methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198508, NULL, 'G3DSA:1.10.150.60:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198509, NULL, 'G3DSA:3.30.160.60:FF:001331', NULL, NULL, 'zinc finger and BTB domain-containing protein 38', NULL, NULL, NULL, NULL, NULL, 4),
(198510, NULL, 'G3DSA:2.40.128.20:FF:000043', NULL, NULL, 'Extracellular fatty acid-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(198511, NULL, 'G3DSA:3.30.40.10:FF:000571', NULL, NULL, 'Zinc finger, C3HC4 type', NULL, NULL, NULL, NULL, NULL, 4),
(198512, NULL, 'G3DSA:2.30.42.10:FF:000292', NULL, NULL, 'Protein CBG16414', NULL, NULL, NULL, NULL, NULL, 4),
(198513, NULL, 'G3DSA:1.10.20.10:FF:000188', NULL, NULL, 'DNA polymerase epsilon subunit C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198514, NULL, 'G3DSA:2.30.29.30:FF:000901', NULL, NULL, 'Docking protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(198515, NULL, 'G3DSA:3.20.20.70:FF:000021', NULL, NULL, 'Fructose-bisphosphate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(198516, NULL, 'G3DSA:3.40.50.970:FF:000026', NULL, NULL, 'Glyoxylate carboligase', NULL, NULL, NULL, NULL, NULL, 4),
(198517, NULL, 'G3DSA:4.10.1000.10:FF:000116', NULL, NULL, 'CCCH-type zinc finger-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(198518, NULL, 'G3DSA:3.50.50.60:FF:001114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198519, NULL, 'G3DSA:1.10.12.10:FF:000028', NULL, NULL, '4-chlorobenzoyl coenzyme A dehalogenase', NULL, NULL, NULL, NULL, NULL, 4),
(198520, NULL, 'G3DSA:3.40.850.10:FF:000349', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(198521, NULL, 'G3DSA:3.30.1140.32:FF:000024', NULL, NULL, '30S ribosomal protein S3', NULL, NULL, NULL, NULL, NULL, 4),
(198522, NULL, 'G3DSA:1.10.472.10:FF:000608', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198523, NULL, 'G3DSA:3.30.70.330:FF:002544', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198524, NULL, 'G3DSA:3.40.50.2000:FF:000216', NULL, NULL, 'Chitobiosyldiphosphodolichol beta-mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(198525, NULL, 'G3DSA:1.25.10.10:FF:001093', NULL, NULL, 'Vac14, PIKFYVE complex component', NULL, NULL, NULL, NULL, NULL, 4),
(198526, NULL, 'G3DSA:3.30.565.10:FF:000239', NULL, NULL, 'Sensory box sensor histidine kinase/response regulator VieS', NULL, NULL, NULL, NULL, NULL, 4),
(198527, NULL, 'G3DSA:2.60.40.150:FF:000795', NULL, NULL, 'E3 ubiquitin-protein ligase NEDD4', NULL, NULL, NULL, NULL, NULL, 4),
(198528, NULL, 'G3DSA:1.10.472.80:FF:000202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(198529, NULL, 'G3DSA:2.130.10.10:FF:002169', NULL, NULL, 'Putative serine/threonine-protein kinase vps15', NULL, NULL, NULL, NULL, NULL, 4),
(198530, NULL, 'G3DSA:3.40.5.120:FF:000002', NULL, NULL, 'chromodomain-helicase-DNA-binding protein 9 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(198531, NULL, 'G3DSA:1.10.533.10:FF:000110', NULL, NULL, 'astrocytic phosphoprotein PEA-15 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(198532, NULL, 'G3DSA:2.130.10.10:FF:001359', NULL, NULL, 'DYnein Chain, light Intermediate', NULL, NULL, NULL, NULL, NULL, 4),
(198533, NULL, 'G3DSA:3.40.50.410:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198534, NULL, 'G3DSA:1.20.1070.10:FF:000727', NULL, NULL, 'Protein CBR-GAR-1', NULL, NULL, NULL, NULL, NULL, 4),
(198535, NULL, 'G3DSA:3.40.50.12470:FF:000012', NULL, NULL, 'Oxoglutarate dehydrogenase (Succinyl-transferring), E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(198536, NULL, 'G3DSA:2.60.120.200:FF:000381', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198537, NULL, 'G3DSA:3.40.1190.20:FF:000093', NULL, NULL, 'Fructokinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198538, NULL, 'G3DSA:2.20.110.10:FF:000015', NULL, NULL, 'Phosphatidylinositol 4-phosphate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(198539, NULL, 'G3DSA:3.40.190.10:FF:000349', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(198540, NULL, 'G3DSA:3.20.20.80:FF:000681', NULL, NULL, 'Heparanase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198541, NULL, 'G3DSA:2.60.120.260:FF:000292', NULL, NULL, 'Anaphase promoting complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(198542, NULL, 'G3DSA:2.60.40.10:FF:004872', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198543, NULL, 'G3DSA:3.40.50.720:FF:002177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198544, NULL, 'G3DSA:3.30.1380.20:FF:000048', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198545, NULL, 'G3DSA:3.10.20.230:FF:000035', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198546, NULL, 'G3DSA:3.40.366.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198547, NULL, 'G3DSA:3.40.50.300:FF:007115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198548, NULL, 'G3DSA:1.10.150.20:FF:000061', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(198549, NULL, 'G3DSA:1.20.5.170:FF:000124', NULL, NULL, 'Alcohol dehydrogenase 3', NULL, NULL, NULL, NULL, NULL, 4),
(198550, NULL, 'G3DSA:3.20.20.150:FF:000009', NULL, NULL, 'Xylose isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(198551, NULL, 'G3DSA:1.25.10.10:FF:003234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198552, NULL, 'G3DSA:3.30.260.10:FF:000082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198553, NULL, 'G3DSA:3.10.10.10:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198554, NULL, 'G3DSA:3.20.20.140:FF:000006', NULL, NULL, 'Dihydroorotase', NULL, NULL, NULL, NULL, NULL, 4),
(198555, NULL, 'G3DSA:2.60.120.590:FF:000008', NULL, NULL, 'Alpha-ketoglutarate-dependent dioxygenase alkB homolog 4', NULL, NULL, NULL, NULL, NULL, 4),
(198556, NULL, 'G3DSA:3.40.50.150:FF:001359', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198557, NULL, 'G3DSA:1.20.120.610:FF:000007', NULL, NULL, 'V-type proton ATPase proteolipid subunit', NULL, NULL, NULL, NULL, NULL, 4),
(198558, NULL, 'G3DSA:1.20.1250.90:FF:000001', NULL, NULL, 'Thymic stromal lymphopoietin', NULL, NULL, NULL, NULL, NULL, 4),
(198559, NULL, 'G3DSA:3.20.20.150:FF:000048', NULL, NULL, '5-keto-L-gluconate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(198560, NULL, 'G3DSA:1.20.1250.20:FF:000593', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(198561, NULL, 'G3DSA:1.10.10.60:FF:000909', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198562, NULL, 'G3DSA:3.10.450.40:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(198563, NULL, 'G3DSA:3.90.660.10:FF:000121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198564, NULL, 'G3DSA:2.30.130.10:FF:000031', NULL, NULL, 'Pseudouridine synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198565, NULL, 'G3DSA:3.80.10.10:FF:000421', NULL, NULL, 'Si:dkey-16p6.1', NULL, NULL, NULL, NULL, NULL, 4),
(198566, NULL, 'G3DSA:1.50.10.100:FF:000004', NULL, NULL, 'Chondroitin sulfate ABC lyase', NULL, NULL, NULL, NULL, NULL, 4),
(198567, NULL, 'G3DSA:2.60.40.630:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198568, NULL, 'G3DSA:1.10.472.130:FF:000069', NULL, NULL, 'Dynein heavy chain 3', NULL, NULL, NULL, NULL, NULL, 4),
(198569, NULL, 'G3DSA:1.10.8.60:FF:000431', NULL, NULL, 'Cell division cycle protein', NULL, NULL, NULL, NULL, NULL, 4),
(198570, NULL, 'G3DSA:3.40.50.1820:FF:000437', NULL, NULL, 'Probable peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(198571, NULL, 'G3DSA:2.10.60.10:FF:000002', NULL, NULL, 'Serine/threonine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(198572, NULL, 'G3DSA:1.25.40.10:FF:002729', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198573, NULL, 'G3DSA:3.20.20.80:FF:000063', NULL, NULL, 'Beta-hexosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(198574, NULL, 'G3DSA:1.10.10.350:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198575, NULL, 'G3DSA:3.20.20.70:FF:000060', NULL, NULL, 'IMP dehydrogenase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(198576, NULL, 'G3DSA:1.10.510.10:FF:000619', NULL, NULL, 'non-receptor tyrosine-protein kinase TNK1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(198577, NULL, 'G3DSA:3.60.15.10:FF:000068', NULL, NULL, 'Ribonuclease Z, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(198578, NULL, 'G3DSA:3.30.40.10:FF:002218', NULL, NULL, '60S ribosomal protein L13', NULL, NULL, NULL, NULL, NULL, 4),
(198579, NULL, 'G3DSA:3.40.50.720:FF:002441', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198580, NULL, 'G3DSA:3.10.20.90:FF:000847', NULL, NULL, 'Ubiquitin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198581, NULL, 'G3DSA:1.50.10.10:FF:000073', NULL, NULL, 'Glycogen debranching enzyme, hypothetical (TreX-like)', NULL, NULL, NULL, NULL, NULL, 4),
(198582, NULL, 'G3DSA:2.60.40.60:FF:000885', NULL, NULL, 'Si:dkey-30k22.7', NULL, NULL, NULL, NULL, NULL, 4),
(198583, NULL, 'G3DSA:3.40.50.300:FF:001539', NULL, NULL, 'ATP-dependent RNA helicase DDX51', NULL, NULL, NULL, NULL, NULL, 4),
(198584, NULL, 'G3DSA:3.30.465.10:FF:000063', NULL, NULL, 'L-gulono-1,4-lactone dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(198585, NULL, 'G3DSA:4.10.400.10:FF:000032', NULL, NULL, 'Low density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(198586, NULL, 'G3DSA:1.25.40.10:FF:003005', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(198587, NULL, 'G3DSA:2.40.128.330:FF:000007', NULL, NULL, 'Putative magnesium transporter MRS2-D', NULL, NULL, NULL, NULL, NULL, 4),
(198588, NULL, 'G3DSA:1.25.40.10:FF:004938', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198589, NULL, 'G3DSA:1.20.58.200:FF:000003', NULL, NULL, 'Translin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(198590, NULL, 'G3DSA:1.50.10.20:FF:000076', NULL, NULL, 'Prenyltransferase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(198591, NULL, 'G3DSA:2.20.110.10:FF:000072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198592, NULL, 'G3DSA:2.10.25.10:FF:001394', NULL, NULL, 'Fibrillin 1', NULL, NULL, NULL, NULL, NULL, 4),
(198593, NULL, 'G3DSA:3.40.50.720:FF:000586', NULL, NULL, 'Mannitol-1-phosphate 5-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(198594, NULL, 'G3DSA:1.25.10.10:FF:001654', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198595, NULL, 'G3DSA:1.20.58.220:FF:000009', NULL, NULL, 'Phosphate-specific transport system accessory protein PhoU', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(198596, NULL, 'G3DSA:3.30.160.60:FF:002955', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198597, NULL, 'G3DSA:3.75.10.10:FF:000001', NULL, NULL, 'Eukaryotic translation initiation factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(198598, NULL, 'G3DSA:3.40.50.620:FF:000680', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198599, NULL, 'G3DSA:2.20.70.10:FF:000278', NULL, NULL, 'WW domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(198600, NULL, 'G3DSA:3.40.190.10:FF:000681', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198601, NULL, 'G3DSA:1.25.40.10:FF:005214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198602, NULL, 'G3DSA:1.10.565.10:FF:000010', NULL, NULL, 'Estrogen receptor', NULL, NULL, NULL, NULL, NULL, 4),
(198603, NULL, 'G3DSA:2.60.40.10:FF:001106', NULL, NULL, 'MYCBP associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(198604, NULL, 'G3DSA:3.10.20.770:FF:000012', NULL, NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(198605, NULL, 'G3DSA:2.130.10.10:FF:000578', NULL, NULL, 'Nucleoporin seh1', NULL, NULL, NULL, NULL, NULL, 4),
(198606, NULL, 'G3DSA:2.60.40.10:FF:004597', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198607, NULL, 'G3DSA:3.30.9.10:FF:000212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198608, NULL, 'G3DSA:2.40.10.10:FF:000487', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198609, NULL, 'G3DSA:3.30.760.10:FF:000018', NULL, NULL, 'Eukaryotic initiation factor 4E, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198610, NULL, 'G3DSA:3.40.50.620:FF:000623', NULL, NULL, 'Transport protein (Probable substrate cationic amino acids)', NULL, NULL, NULL, NULL, NULL, 4),
(198611, NULL, 'G3DSA:1.20.58.900:FF:000005', NULL, NULL, 'RUN domain-containing protein 3A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(198612, NULL, 'G3DSA:2.130.10.10:FF:005125', NULL, NULL, 'Syntaxin-binding protein 5-like', NULL, NULL, NULL, NULL, NULL, 4),
(198613, NULL, 'G3DSA:3.40.50.300:FF:005581', NULL, NULL, 'Dynein axonemal heavy chain 14', NULL, NULL, NULL, NULL, NULL, 4),
(198614, NULL, 'G3DSA:3.30.420.40:FF:000929', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198615, NULL, 'G3DSA:1.10.8.480:FF:000011', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(198616, NULL, 'G3DSA:3.40.640.10:FF:000249', NULL, NULL, 'Aminotransferase class-III', NULL, NULL, NULL, NULL, NULL, 4),
(198617, NULL, 'G3DSA:3.30.70.330:FF:000953', NULL, NULL, 'Putative Serine/arginine-rich splicing factor', NULL, NULL, NULL, NULL, NULL, 4),
(198618, NULL, 'G3DSA:3.30.710.10:FF:000072', NULL, NULL, 'Potassium voltage-gated channel subfamily F member 1', NULL, NULL, NULL, NULL, NULL, 4),
(198619, NULL, 'G3DSA:1.10.150.20:FF:000268', NULL, NULL, 'FA core complex-associated protein 24', NULL, NULL, NULL, NULL, NULL, 4),
(198620, NULL, 'G3DSA:3.40.50.300:FF:003282', NULL, NULL, 'ATP-binding cassette, sub-family G (WHITE), member 3-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(198621, NULL, 'G3DSA:3.30.230.10:FF:000265', NULL, NULL, 'Putative phosphomevalonate kinase protein', NULL, NULL, NULL, NULL, NULL, 4),
(198622, NULL, 'G3DSA:1.20.1250.20:FF:000317', NULL, NULL, 'Equilibrative Nucleoside Transporter (ENT) Family', NULL, NULL, NULL, NULL, NULL, 4),
(198623, NULL, 'G3DSA:1.20.970.10:FF:000016', NULL, NULL, 'Anthranilate phosphoribosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198624, NULL, 'G3DSA:3.90.190.10:FF:000242', NULL, NULL, 'Protein CBG23275', NULL, NULL, NULL, NULL, NULL, 4),
(198625, NULL, 'G3DSA:3.40.33.10:FF:000054', NULL, NULL, 'PR-1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(198626, NULL, 'G3DSA:2.60.40.10:FF:003534', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198627, NULL, 'G3DSA:3.40.50.300:FF:006941', NULL, NULL, 'Branched-chain amino acid ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(198628, NULL, 'G3DSA:3.30.1740.20:FF:000008', NULL, NULL, '40S ribosomal protein S26', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(198629, NULL, 'G3DSA:2.60.34.10:FF:000058', NULL, NULL, 'ER-type hsp70', NULL, NULL, NULL, NULL, NULL, 4),
(198630, NULL, 'G3DSA:3.30.160.60:FF:001595', NULL, NULL, 'Zinc finger protein 142', NULL, NULL, NULL, NULL, NULL, 4),
(198631, NULL, 'G3DSA:3.30.160.60:FF:003129', NULL, NULL, 'FI23536p1', NULL, NULL, NULL, NULL, NULL, 4),
(198632, NULL, 'G3DSA:1.20.58.2190:FF:000008', NULL, NULL, 'Ubiquitin-conjugating enzyme E2', NULL, NULL, NULL, NULL, NULL, 4),
(198633, NULL, 'G3DSA:3.30.497.10:FF:000069', NULL, NULL, 'Serpin 28Db', NULL, NULL, NULL, NULL, NULL, 4),
(198634, NULL, 'G3DSA:1.25.40.330:FF:000011', NULL, NULL, 'Adenylyl cyclase-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(198635, NULL, 'G3DSA:1.20.1250.20:FF:001599', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198636, NULL, 'G3DSA:1.25.40.10:FF:003062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198637, NULL, 'G3DSA:2.40.70.10:FF:000384', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198638, NULL, 'G3DSA:3.40.850.10:FF:000063', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(198639, NULL, 'G3DSA:1.20.1260.10:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198640, NULL, 'G3DSA:3.90.1150.10:FF:000519', NULL, NULL, 'Sphingosine 1 phosphate lyase putative', NULL, NULL, NULL, NULL, NULL, 4),
(198641, NULL, 'G3DSA:1.10.630.10:FF:000072', NULL, NULL, '3-hydroxyphenylacetate 6 hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(198642, NULL, 'G3DSA:1.10.510.10:FF:003413', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198643, NULL, 'G3DSA:3.50.30.50:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198644, NULL, 'G3DSA:2.30.29.30:FF:000547', NULL, NULL, 'TIAM (Mammalian Tumor Invasion And Metastasis factor) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(198645, NULL, 'G3DSA:3.40.190.10:FF:000888', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198646, NULL, 'G3DSA:2.60.40.1390:FF:000006', NULL, NULL, 'Meiosis-specific transcription factor NDT80', NULL, NULL, NULL, NULL, NULL, 4),
(198647, NULL, 'G3DSA:3.90.1150.10:FF:000177', NULL, NULL, '4-aminobutyrate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(198648, NULL, 'G3DSA:3.80.10.10:FF:002219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198649, NULL, 'G3DSA:4.10.240.10:FF:000154', NULL, NULL, 'Zcf39p', NULL, NULL, NULL, NULL, NULL, 4),
(198650, NULL, 'G3DSA:1.10.287.1060:FF:000022', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198651, NULL, 'G3DSA:2.30.30.140:FF:000004', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(198652, NULL, 'G3DSA:3.30.70.100:FF:000114', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198653, NULL, 'G3DSA:2.30.38.10:FF:000017', NULL, NULL, '4-chlorobenzoate--CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(198654, NULL, 'G3DSA:3.40.50.1110:FF:000090', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198655, NULL, 'G3DSA:1.10.238.10:FF:001251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198656, NULL, 'G3DSA:3.80.10.10:FF:000718', NULL, NULL, 'F-box and leucine-rich repeat protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(198657, NULL, 'G3DSA:2.30.30.130:FF:000001', NULL, NULL, 'DDE-recombinase A', NULL, NULL, NULL, NULL, NULL, 4),
(198658, NULL, 'G3DSA:3.90.640.10:FF:000002', NULL, NULL, 'Heat shock 70 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(198659, NULL, 'G3DSA:3.40.50.2300:FF:000481', NULL, NULL, 'Glutamate receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(198660, NULL, 'G3DSA:3.30.1740.10:FF:000005', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(198661, NULL, 'G3DSA:3.90.1170.40:FF:000013', NULL, NULL, 'Molybdopterin (MPT) converting factor, subunit2', NULL, NULL, NULL, NULL, NULL, 4),
(198662, NULL, 'G3DSA:1.10.510.10:FF:001619', NULL, NULL, 'Kinase-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(198663, NULL, 'G3DSA:3.30.720.210:FF:000003', NULL, NULL, 'ATP-dependent zinc metalloprotease FTSH, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(198664, NULL, 'G3DSA:1.10.20.140:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198665, NULL, 'G3DSA:3.90.380.10:FF:000015', NULL, NULL, 'Terminal oxygenase component of carbazole', NULL, NULL, NULL, NULL, NULL, 4),
(198666, NULL, 'G3DSA:3.40.50.1100:FF:000278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198667, NULL, 'G3DSA:3.30.1370.120:FF:000006', NULL, NULL, 'Type III secretion system outer membrane pore InvG', NULL, NULL, NULL, NULL, NULL, 4),
(198668, NULL, 'G3DSA:3.30.1370.110:FF:000003', NULL, NULL, 'NEDD4-binding protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(198669, NULL, 'G3DSA:1.20.5.220:FF:000004', NULL, NULL, 'Cytochrome b-c1 complex subunit 10', NULL, NULL, NULL, NULL, NULL, 4),
(198670, NULL, 'G3DSA:3.90.1170.30:FF:000010', NULL, NULL, 'Pyrimidine-nucleoside phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(198671, NULL, 'G3DSA:3.90.1150.10:FF:000531', NULL, NULL, 'Aspartate aminotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198672, NULL, 'G3DSA:3.20.20.80:FF:000029', NULL, NULL, 'Beta-glucuronidase', NULL, NULL, NULL, NULL, NULL, 4),
(198673, NULL, 'G3DSA:2.60.120.1000:FF:000002', NULL, NULL, 'Collagen XI alpha 1 chain', NULL, NULL, NULL, NULL, NULL, 4),
(198674, NULL, 'G3DSA:3.40.50.2300:FF:000418', NULL, NULL, 'Diguanylate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(198675, NULL, 'G3DSA:1.10.640.10:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198676, NULL, 'G3DSA:2.30.42.10:FF:000297', NULL, NULL, 'Serine protease PepA', NULL, NULL, NULL, NULL, NULL, 4),
(198677, NULL, 'G3DSA:1.20.5.210:FF:000001', NULL, NULL, 'Cytochrome b-c1 complex subunit 8', NULL, NULL, NULL, NULL, NULL, 4),
(198678, NULL, 'G3DSA:2.60.40.10:FF:001617', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(198679, NULL, 'G3DSA:2.60.40.60:FF:001048', NULL, NULL, 'Protocadherin-16, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198680, NULL, 'G3DSA:1.10.510.10:FF:003183', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198681, NULL, 'G3DSA:2.60.34.10:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198682, NULL, 'G3DSA:2.60.40.60:FF:001104', NULL, NULL, 'Protocadherin 10', NULL, NULL, NULL, NULL, NULL, 4),
(198683, NULL, 'G3DSA:3.40.50.720:FF:002115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198684, NULL, 'G3DSA:1.10.472.10:FF:000491', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198685, NULL, 'G3DSA:3.40.50.12780:FF:000217', NULL, NULL, 'Putative long-chain-fatty-acid-CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(198686, NULL, 'G3DSA:3.20.20.70:FF:000026', NULL, NULL, 'Biotin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(198687, NULL, 'G3DSA:3.30.160.60:FF:004765', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198688, NULL, 'G3DSA:2.30.42.10:FF:000353', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198689, NULL, 'G3DSA:3.30.559.70:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198690, NULL, 'G3DSA:3.40.50.20:FF:000041', NULL, NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(198691, NULL, 'G3DSA:3.10.129.10:FF:000293', NULL, NULL, 'Fatty acid synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(198692, NULL, 'G3DSA:3.30.160.60:FF:001095', NULL, NULL, 'zinc finger and BTB domain-containing protein 24 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(198693, NULL, 'G3DSA:1.10.238.10:FF:001071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198694, NULL, 'G3DSA:1.10.10.60:FF:000679', NULL, NULL, 'Homeobox protein aristaless', NULL, NULL, NULL, NULL, NULL, 4),
(198695, NULL, 'G3DSA:3.40.1410.10:FF:000029', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(198696, NULL, 'G3DSA:3.40.50.300:FF:005305', NULL, NULL, 'Origin recognition complex subunit 5 C-terminus-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(198697, NULL, 'G3DSA:3.40.50.300:FF:001034', NULL, NULL, 'probable ATP-dependent RNA helicase DDX59', NULL, NULL, NULL, NULL, NULL, 4),
(198698, NULL, 'G3DSA:3.40.50.12670:FF:000010', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(198699, NULL, 'G3DSA:3.30.160.60:FF:004872', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198700, NULL, 'G3DSA:2.60.120.1020:FF:000008', NULL, NULL, 'peptide-N(4)-(N-acetyl-beta- glucosaminyl)asparagine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(198701, NULL, 'G3DSA:3.40.50.300:FF:007441', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198702, NULL, 'G3DSA:3.60.20.10:FF:000080', NULL, NULL, 'Gamma-glutamyl-hercynylcysteine sulfoxide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(198703, NULL, 'G3DSA:1.20.5.170:FF:000242', NULL, NULL, 'Transcription factor MafG, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198704, NULL, 'G3DSA:1.25.40.10:FF:004085', NULL, NULL, 'Rap phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(198705, NULL, 'G3DSA:3.30.40.10:FF:000453', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(198706, NULL, 'G3DSA:3.30.40.10:FF:001021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198707, NULL, 'G3DSA:3.30.559.10:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198708, NULL, 'G3DSA:3.30.160.60:FF:001213', NULL, NULL, 'Transcriptional repressor GATA binding 1', NULL, NULL, NULL, NULL, NULL, 4),
(198709, NULL, 'G3DSA:1.20.1250.20:FF:000149', NULL, NULL, 'MFS transporter, SP family, general alpha glucoside:H+ symporter', NULL, NULL, NULL, NULL, NULL, 4),
(198710, NULL, 'G3DSA:1.25.40.10:FF:000774', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(198711, NULL, 'G3DSA:1.10.472.10:FF:000384', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198712, NULL, 'G3DSA:2.40.290.10:FF:000023', NULL, NULL, 'ATP-dependent DNA helicase II subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(198713, NULL, 'G3DSA:3.90.190.10:FF:000208', NULL, NULL, 'Vh5 dual specificity phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198714, NULL, 'G3DSA:3.40.50.2000:FF:000486', NULL, NULL, 'UDP-N-acetylglucosamine 2-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(198715, NULL, 'G3DSA:1.20.1250.20:FF:000205', NULL, NULL, 'Solute carrier family 15 oligopeptide transporter member 1', NULL, NULL, NULL, NULL, NULL, 4),
(198716, NULL, 'G3DSA:2.60.200.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198717, NULL, 'G3DSA:2.120.10.30:FF:000219', NULL, NULL, 'Gluconolactonase', NULL, NULL, NULL, NULL, NULL, 4),
(198718, NULL, 'G3DSA:1.20.910.10:FF:000029', NULL, NULL, 'Si:ch1073-67j19.1', NULL, NULL, NULL, NULL, NULL, 4),
(198719, NULL, 'G3DSA:3.20.20.300:FF:000077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198720, NULL, 'G3DSA:3.90.190.10:FF:000422', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198721, NULL, 'G3DSA:4.10.910.10:FF:000003', NULL, NULL, 'Ribosomal protein S13', NULL, NULL, NULL, NULL, NULL, 4),
(198722, NULL, 'G3DSA:3.40.1280.10:FF:000092', NULL, NULL, 'Putative methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(198723, NULL, 'G3DSA:1.25.40.20:FF:001541', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(198724, NULL, 'G3DSA:2.130.10.10:FF:002837', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198725, NULL, 'G3DSA:3.40.630.10:FF:000198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198726, NULL, 'G3DSA:3.80.10.10:FF:003698', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198727, NULL, 'G3DSA:1.20.1250.10:FF:000146', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(198728, NULL, 'G3DSA:2.130.10.10:FF:004928', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198729, NULL, 'G3DSA:1.20.1050.10:FF:000272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198730, NULL, 'G3DSA:1.20.1250.20:FF:000475', NULL, NULL, 'MFS multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198731, NULL, 'G3DSA:1.25.10.10:FF:000946', NULL, NULL, 'AP-3 complex subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(198732, NULL, 'G3DSA:1.25.10.10:FF:003060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198733, NULL, 'G3DSA:3.10.110.10:FF:000087', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 N', NULL, NULL, NULL, NULL, NULL, 4),
(198734, NULL, 'G3DSA:1.25.10.10:FF:000839', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198735, NULL, 'G3DSA:1.10.238.10:FF:000458', NULL, NULL, 'Probable calcium-binding protein CML30', NULL, NULL, NULL, NULL, NULL, 4),
(198736, NULL, 'G3DSA:1.20.1250.20:FF:001779', NULL, NULL, 'Resistance protein, conjectural', NULL, NULL, NULL, NULL, NULL, 4),
(198737, NULL, 'G3DSA:3.40.50.720:FF:002059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198738, NULL, 'G3DSA:2.40.30.270:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198739, NULL, 'G3DSA:3.20.20.80:FF:000411', NULL, NULL, 'Brain chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198740, NULL, 'G3DSA:3.30.160.60:FF:005428', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198741, NULL, 'G3DSA:1.10.274.10:FF:000002', NULL, NULL, 'Phosphoenolpyruvate-protein phosphotransferase PtsP', NULL, NULL, NULL, NULL, NULL, 4),
(198742, NULL, 'G3DSA:3.40.850.10:FF:000467', NULL, NULL, 'Kinesin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(198743, NULL, 'G3DSA:3.30.70.330:FF:000335', NULL, NULL, 'RNA-binding protein with multiple splicing 2', NULL, NULL, NULL, NULL, NULL, 4),
(198744, NULL, 'G3DSA:1.25.40.10:FF:002898', NULL, NULL, 'Os11g0131400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(198745, NULL, 'G3DSA:3.90.1170.50:FF:000016', NULL, NULL, 'xanthine dehydrogenase/oxidase-like', NULL, NULL, NULL, NULL, NULL, 4),
(198746, NULL, 'G3DSA:3.40.50.1820:FF:001449', NULL, NULL, 'Serine protease F56F10.1-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(198747, NULL, 'G3DSA:3.30.465.10:FF:000018', NULL, NULL, 'UDP-N-acetylenolpyruvoylglucosamine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(198748, NULL, 'G3DSA:3.40.1110.10:FF:000141', NULL, NULL, 'Probable cation-transporting ATPase G', NULL, NULL, NULL, NULL, NULL, 4),
(198749, NULL, 'G3DSA:1.10.510.10:FF:001092', NULL, NULL, 'NAK/MPSK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(198750, NULL, 'G3DSA:1.25.40.20:FF:001327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198751, NULL, 'G3DSA:2.60.40.10:FF:003860', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198752, NULL, 'G3DSA:1.50.10.20:FF:000014', NULL, NULL, 'Protein farnesyltransferase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(198753, NULL, 'G3DSA:3.40.50.300:FF:001713', NULL, NULL, 'ATP-dependent RNA helicase DHX8', NULL, NULL, NULL, NULL, NULL, 4),
(198754, NULL, 'G3DSA:1.10.1870.10:FF:000004', NULL, NULL, 'AminoAdipate-Semialdehyde Synthase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(198755, NULL, 'G3DSA:3.80.10.10:FF:000825', NULL, NULL, 'MDIS1-interacting receptor like kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(198756, NULL, 'G3DSA:1.20.58.1020:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198757, NULL, 'G3DSA:2.60.120.290:FF:000132', NULL, NULL, 'Complement component 1, r subcomponent', NULL, NULL, NULL, NULL, NULL, 4),
(198758, NULL, 'G3DSA:1.20.1070.10:FF:000048', NULL, NULL, 'Adhesion G protein-coupled receptor B1', NULL, NULL, NULL, NULL, NULL, 4),
(198759, NULL, 'G3DSA:1.10.8.60:FF:000313', NULL, NULL, 'AAA ATPase, central domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(198760, NULL, 'G3DSA:3.40.50.150:FF:000808', NULL, NULL, 'Protein CBG20781', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(198761, NULL, 'G3DSA:3.40.50.200:FF:000104', NULL, NULL, 'Serine protease AprX', NULL, NULL, NULL, NULL, NULL, 4),
(198762, NULL, 'G3DSA:3.40.50.2300:FF:000744', NULL, NULL, 'Vomeronasal 2 receptor, a20', NULL, NULL, NULL, NULL, NULL, 4),
(198763, NULL, 'G3DSA:3.30.230.10:FF:000372', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198764, NULL, 'G3DSA:1.25.10.10:FF:000098', NULL, NULL, 'HEAT repeat-containing protein 5A isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(198765, NULL, 'G3DSA:1.10.220.30:FF:000002', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(198766, NULL, 'G3DSA:1.20.1050.10:FF:000165', NULL, NULL, 'Slr0236 protein', NULL, NULL, NULL, NULL, NULL, 4),
(198767, NULL, 'G3DSA:2.130.10.30:FF:000174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198768, NULL, 'G3DSA:3.40.50.1820:FF:000145', NULL, NULL, 'Pigment biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(198769, NULL, 'G3DSA:1.25.40.180:FF:000325', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198770, NULL, 'G3DSA:2.60.40.200:FF:000040', NULL, NULL, 'Copper chaperone for superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(198771, NULL, 'G3DSA:3.40.190.290:FF:000099', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(198772, NULL, 'G3DSA:3.30.200.20:FF:000873', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198773, NULL, 'G3DSA:2.60.40.150:FF:000744', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(198774, NULL, 'G3DSA:3.40.50.1820:FF:000033', NULL, NULL, 'Pancreatic triacylglycerol lipase', NULL, NULL, NULL, NULL, NULL, 4),
(198775, NULL, 'G3DSA:2.60.40.10:FF:003023', NULL, NULL, 'Protein tyrosine phosphatase, receptor type, s, a', NULL, NULL, NULL, NULL, NULL, 4),
(198776, NULL, 'G3DSA:2.60.40.2700:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198777, NULL, 'G3DSA:1.10.10.10:FF:000474', NULL, NULL, 'Putative transcriptional regulator, Crp/Fnr family', NULL, NULL, NULL, NULL, NULL, 4),
(198778, NULL, 'G3DSA:3.20.20.80:FF:000355', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198779, NULL, 'G3DSA:3.30.470.20:FF:000191', NULL, NULL, 'Succinate--CoA ligase [GDP-forming] subunit beta, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(198780, NULL, 'G3DSA:1.25.40.10:FF:003303', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198781, NULL, 'G3DSA:1.10.1520.10:FF:000074', NULL, NULL, 'Ribonuclease 3', NULL, NULL, NULL, NULL, NULL, 4),
(198782, NULL, 'G3DSA:3.60.140.10:FF:000010', NULL, NULL, 'Polyphenol oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(198783, NULL, 'G3DSA:1.50.10.10:FF:000011', NULL, NULL, 'Alkaline/neutral invertase A, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(198784, NULL, 'G3DSA:1.10.10.650:FF:000015', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(198785, NULL, 'G3DSA:3.40.50.1820:FF:001775', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(198786, NULL, 'G3DSA:3.10.20.120:FF:000002', NULL, NULL, 'Enterotoxin-like toxin X', NULL, NULL, NULL, NULL, NULL, 4),
(198787, NULL, 'G3DSA:1.10.150.20:FF:000229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198788, NULL, 'G3DSA:1.10.565.10:FF:000122', NULL, NULL, 'Hepatocyte nuclear factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(198789, NULL, 'G3DSA:2.60.40.60:FF:000587', NULL, NULL, 'Protocadherin 1 gamma 32', NULL, NULL, NULL, NULL, NULL, 4),
(198790, NULL, 'G3DSA:2.10.10.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198791, NULL, 'G3DSA:3.40.50.1220:FF:000055', NULL, NULL, 'Thi3p', NULL, NULL, NULL, NULL, NULL, 4),
(198792, NULL, 'G3DSA:2.60.120.740:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198793, NULL, 'G3DSA:3.40.50.720:FF:000709', NULL, NULL, 'Putative ion channel POLLUX-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(198794, NULL, 'G3DSA:1.20.1740.10:FF:000009', NULL, NULL, 'Low affinity cationic amino acid transporter 2', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(198795, NULL, 'G3DSA:2.40.50.90:FF:000182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198796, NULL, 'G3DSA:1.20.1050.10:FF:000221', NULL, NULL, 'Glutathione S-transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198797, NULL, 'G3DSA:3.40.50.360:FF:000012', NULL, NULL, 'Anaerobic nitric oxide reductase flavorubredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(198798, NULL, 'G3DSA:2.60.120.260:FF:000584', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198799, NULL, 'G3DSA:1.20.1070.10:FF:001739', NULL, NULL, 'Olfactory receptor 1262', NULL, NULL, NULL, NULL, NULL, 4),
(198800, NULL, 'G3DSA:2.30.30.100:FF:000127', NULL, NULL, 'Scd6-like Sm domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198801, NULL, 'G3DSA:2.30.29.30:FF:000660', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198802, NULL, 'G3DSA:1.20.1250.20:FF:001835', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198803, NULL, 'G3DSA:1.10.630.10:FF:000313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198804, NULL, 'G3DSA:2.60.40.10:FF:002399', NULL, NULL, 'Cytochrome c oxidase accessory protein CcoG', NULL, NULL, NULL, NULL, NULL, 4),
(198805, NULL, 'G3DSA:2.60.120.10:FF:000046', NULL, NULL, 'Cyclic nucleotide-gated cation channel alpha-4', NULL, NULL, NULL, NULL, NULL, 4),
(198806, NULL, 'G3DSA:3.20.20.70:FF:000352', NULL, NULL, 'Metallo cofactor biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(198807, NULL, 'G3DSA:1.10.357.90:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198808, NULL, 'G3DSA:2.40.320.10:FF:000038', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198809, NULL, 'G3DSA:1.20.58.670:FF:000009', NULL, NULL, 'RAD50-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(198810, NULL, 'G3DSA:1.10.472.10:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198811, NULL, 'G3DSA:3.30.900.10:FF:000058', NULL, NULL, 'AER420Cp', NULL, NULL, NULL, NULL, NULL, 4),
(198812, NULL, 'G3DSA:1.20.80.10:FF:000051', NULL, NULL, 'Acyl CoA binding protein family (AFU_orthologue AFUA_2G11060)', NULL, NULL, NULL, NULL, NULL, 4),
(198813, NULL, 'G3DSA:1.25.10.10:FF:000991', NULL, NULL, 'DAF-15', NULL, NULL, NULL, NULL, NULL, 4),
(198814, NULL, 'G3DSA:3.40.50.10140:FF:000015', NULL, NULL, 'Toll/interleukin-1 receptor domain-containing adapter protein', NULL, NULL, NULL, NULL, NULL, 4),
(198815, NULL, 'G3DSA:3.80.10.10:FF:004136', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198816, NULL, 'G3DSA:1.25.40.20:FF:001215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198817, NULL, 'G3DSA:3.90.199.10:FF:000003', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(198818, NULL, 'G3DSA:3.40.50.2300:FF:001205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198819, NULL, 'G3DSA:2.60.40.1730:FF:000030', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(198820, NULL, 'G3DSA:1.25.40.20:FF:001485', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198821, NULL, 'G3DSA:3.30.160.60:FF:002629', NULL, NULL, 'Zinc finger protein 985', NULL, NULL, NULL, NULL, NULL, 4),
(198822, NULL, 'G3DSA:3.30.200.20:FF:001334', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198823, NULL, 'G3DSA:3.40.190.10:FF:000383', NULL, NULL, 'Choline ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(198824, NULL, 'G3DSA:1.10.630.10:FF:000364', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(198825, NULL, 'G3DSA:3.40.33.10:FF:000110', NULL, NULL, 'Protein CBG01197', NULL, NULL, NULL, NULL, NULL, 4),
(198826, NULL, 'G3DSA:3.30.70.330:FF:003027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198827, NULL, 'G3DSA:2.60.40.10:FF:005114', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198828, NULL, 'G3DSA:2.30.29.30:FF:000160', NULL, NULL, 'DCC-interacting protein 13-beta isoform X2', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(198829, NULL, 'G3DSA:3.90.190.10:FF:000534', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198830, NULL, 'G3DSA:2.170.150.20:FF:000019', NULL, NULL, 'Protein cereblon', NULL, NULL, NULL, NULL, NULL, 4),
(198831, NULL, 'G3DSA:2.40.50.140:FF:000663', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198832, NULL, 'G3DSA:3.90.1150.10:FF:000256', NULL, NULL, 'Gamma-aminobutyrate transaminase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(198833, NULL, 'G3DSA:2.50.20.10:FF:000021', NULL, NULL, 'Uncharacterized protein aq_1483', NULL, NULL, NULL, NULL, NULL, 4),
(198834, NULL, 'G3DSA:1.25.40.10:FF:001482', NULL, NULL, 'Vacuolar protein sorting-associated protein 41', NULL, NULL, NULL, NULL, NULL, 4),
(198835, NULL, 'G3DSA:3.30.420.40:FF:001031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198836, NULL, 'G3DSA:2.10.70.60:FF:000001', NULL, NULL, 'Phospholipase B-like', NULL, NULL, NULL, NULL, NULL, 4),
(198837, NULL, 'G3DSA:2.170.150.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198838, NULL, 'G3DSA:3.40.50.300:FF:007166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198839, NULL, 'G3DSA:1.10.238.10:FF:000677', NULL, NULL, 'Acidocalcisomal pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(198840, NULL, 'G3DSA:1.10.10.750:FF:000045', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(198841, NULL, 'G3DSA:2.160.20.10:FF:000156', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(198842, NULL, 'G3DSA:3.40.50.300:FF:003400', NULL, NULL, 'Replication factor C subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(198843, NULL, 'G3DSA:3.40.50.150:FF:001702', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198844, NULL, 'G3DSA:1.25.40.20:FF:000996', NULL, NULL, 'Phosphate system positive regulatory protein PHO81', NULL, NULL, NULL, NULL, NULL, 4),
(198845, NULL, 'G3DSA:1.25.10.10:FF:001710', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198846, NULL, 'G3DSA:1.10.287.320:FF:000001', NULL, NULL, 'Phosphoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(198847, NULL, 'G3DSA:3.10.10.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198848, NULL, 'G3DSA:3.40.50.1970:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198849, NULL, 'G3DSA:3.40.50.970:FF:000138', NULL, NULL, 'NADH-dependent phenylglyoxylate dehydrogenase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(198850, NULL, 'G3DSA:3.20.20.100:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198851, NULL, 'G3DSA:3.40.47.10:FF:000075', NULL, NULL, 'Acetyl-CoA acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(198852, NULL, 'G3DSA:1.25.40.10:FF:001212', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(198853, NULL, 'G3DSA:1.10.238.10:FF:001301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198854, NULL, 'G3DSA:3.40.50.300:FF:008178', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198855, NULL, 'G3DSA:3.30.160.60:FF:005209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198856, NULL, 'G3DSA:2.130.10.10:FF:003001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198857, NULL, 'G3DSA:3.80.10.10:FF:002450', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198858, NULL, 'G3DSA:3.40.50.300:FF:004586', NULL, NULL, 'GTPase HflX', NULL, NULL, NULL, NULL, NULL, 4),
(198859, NULL, 'G3DSA:3.40.50.2000:FF:000716', NULL, NULL, 'PslH', NULL, NULL, NULL, NULL, NULL, 4),
(198860, NULL, 'G3DSA:1.20.1510.10:FF:000026', NULL, NULL, 'Zinc/cadmium resistance protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(198861, NULL, 'G3DSA:3.40.850.10:FF:000355', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(198862, NULL, 'G3DSA:3.50.50.60:FF:000395', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(198863, NULL, 'G3DSA:3.40.50.11350:FF:000007', NULL, NULL, 'Alpha-(1,6)-fucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(198864, NULL, 'G3DSA:2.40.30.270:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198865, NULL, 'G3DSA:2.40.10.10:FF:000200', NULL, NULL, 'Serine protease nudel', NULL, NULL, NULL, NULL, NULL, 4),
(198866, NULL, 'G3DSA:3.40.720.10:FF:000020', NULL, NULL, 'Phosphatidylinositol glycan anchor biosynthesis class N', NULL, NULL, NULL, NULL, NULL, 4),
(198867, NULL, 'G3DSA:3.40.50.10890:FF:000010', NULL, NULL, 'Integrator complex subunit 11', NULL, NULL, NULL, NULL, NULL, 4),
(198868, NULL, 'G3DSA:3.80.10.10:FF:004187', NULL, NULL, 'NLR family CARD domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(198869, NULL, 'G3DSA:3.40.140.100:FF:000004', NULL, NULL, 'Atg7p', NULL, NULL, NULL, NULL, NULL, 4),
(198870, NULL, 'G3DSA:2.10.110.10:FF:000248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198871, NULL, 'G3DSA:3.40.50.11260:FF:000020', NULL, NULL, 'Heat shock HSP 90-alpha-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(198872, NULL, 'G3DSA:3.30.2080.10:FF:000005', NULL, NULL, 'Unplaced genomic scaffold supercont1.5, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(198873, NULL, 'G3DSA:1.25.40.20:FF:001266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198874, NULL, 'G3DSA:1.10.555.10:FF:000060', NULL, NULL, 'Rho-GTPase-activating protein RGD2', NULL, NULL, NULL, NULL, NULL, 4),
(198875, NULL, 'G3DSA:3.90.190.10:FF:000427', NULL, NULL, 'Protein tyrosine phosphatase 4A1', NULL, NULL, NULL, NULL, NULL, 4),
(198876, NULL, 'G3DSA:3.40.50.1820:FF:000471', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(198877, NULL, 'G3DSA:3.40.190.10:FF:000388', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(198878, NULL, 'G3DSA:3.90.70.10:FF:000806', NULL, NULL, 'Putative ubiquitin carboxyl-terminal hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(198879, NULL, 'G3DSA:3.40.50.300:FF:002669', NULL, NULL, 'Chromosome transmission fidelity protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(198880, NULL, 'G3DSA:3.30.40.10:FF:000234', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(198881, NULL, 'G3DSA:2.60.40.10:FF:003293', NULL, NULL, '1,4-alpha-glucan branching enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(198882, NULL, 'G3DSA:4.10.1080.10:FF:000003', NULL, NULL, 'Thrombospondin 2', NULL, NULL, NULL, NULL, NULL, 4),
(198883, NULL, 'G3DSA:1.25.40.10:FF:001263', NULL, NULL, 'TeTratriCopeptide repeat domain protein related', NULL, NULL, NULL, NULL, NULL, 4),
(198884, NULL, 'G3DSA:3.30.70.270:FF:000058', NULL, NULL, 'Protein P', NULL, NULL, NULL, NULL, NULL, 4),
(198885, NULL, 'G3DSA:3.40.50.2300:FF:000306', NULL, NULL, 'Response regulator SaeR', NULL, NULL, NULL, NULL, NULL, 4),
(198886, NULL, 'G3DSA:2.30.42.10:FF:000527', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198887, NULL, 'G3DSA:1.10.287.950:FF:000010', NULL, NULL, 'Two-component osmosensing histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(198888, NULL, 'G3DSA:3.10.110.10:FF:000317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198889, NULL, 'G3DSA:3.40.50.1820:FF:000763', NULL, NULL, 'Carboxylesterase 4A', NULL, NULL, NULL, NULL, NULL, 4),
(198890, NULL, 'G3DSA:3.30.160.60:FF:002848', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198891, NULL, 'G3DSA:3.30.40.10:FF:000178', NULL, NULL, 'PML isoform 6', NULL, NULL, NULL, NULL, NULL, 4),
(198892, NULL, 'G3DSA:3.30.160.60:FF:003130', NULL, NULL, 'Zinc finger protein 672', NULL, NULL, NULL, NULL, NULL, 4),
(198893, NULL, 'G3DSA:1.20.1070.10:FF:000486', NULL, NULL, 'Dopamine receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(198894, NULL, 'G3DSA:3.30.160.60:FF:003416', NULL, NULL, 'LD12075p', NULL, NULL, NULL, NULL, NULL, 4),
(198895, NULL, 'G3DSA:1.10.510.10:FF:003351', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198896, NULL, 'G3DSA:1.20.1070.10:FF:000542', NULL, NULL, 'SERotonin/octopamine receptor family', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(198897, NULL, 'G3DSA:2.60.40.10:FF:004097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198898, NULL, 'G3DSA:2.30.30.1190:FF:000009', NULL, NULL, 'Zinc finger CCCH domain-containing protein 33', NULL, NULL, NULL, NULL, NULL, 4),
(198899, NULL, 'G3DSA:2.60.120.740:FF:000014', NULL, NULL, 'D-galactoside/L-rhamnose binding SUEL lectin protein', NULL, NULL, NULL, NULL, NULL, 4),
(198900, NULL, 'G3DSA:3.40.50.150:FF:001180', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198901, NULL, 'G3DSA:3.30.2160.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198902, NULL, 'G3DSA:3.40.50.2300:FF:000188', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(198903, NULL, 'G3DSA:2.60.40.3170:FF:000001', NULL, NULL, 'Tripeptidyl peptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(198904, NULL, 'G3DSA:3.40.50.300:FF:006598', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198905, NULL, 'G3DSA:3.60.150.10:FF:000016', NULL, NULL, 'Chorismate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(198906, NULL, 'G3DSA:3.80.10.10:FF:003973', NULL, NULL, 'Tubulin-specific chaperone E', NULL, NULL, NULL, NULL, NULL, 4),
(198907, NULL, 'G3DSA:3.60.40.10:FF:000261', NULL, NULL, 'Protein phosphatase, putative (AFU_orthologue AFUA_5G13740)', NULL, NULL, NULL, NULL, NULL, 4),
(198908, NULL, 'G3DSA:1.10.1670.10:FF:000023', NULL, NULL, 'Endonuclease III homolog', NULL, NULL, NULL, NULL, NULL, 4),
(198909, NULL, 'G3DSA:2.60.120.260:FF:000314', NULL, NULL, 'Beta-mannosidase A', NULL, NULL, NULL, NULL, NULL, 4),
(198910, NULL, 'G3DSA:3.60.10.10:FF:000028', NULL, NULL, 'Type IV inositol polyphosphate 5-phosphatase 7', NULL, NULL, NULL, NULL, NULL, 4),
(198911, NULL, 'G3DSA:1.25.10.10:FF:003127', NULL, NULL, 'Exportin 5', NULL, NULL, NULL, NULL, NULL, 4),
(198912, NULL, 'G3DSA:1.20.1070.10:FF:000834', NULL, NULL, 'Relaxin family peptide/INSL5 receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(198913, NULL, 'G3DSA:3.80.10.10:FF:000207', NULL, NULL, 'Relaxin family peptide receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(198914, NULL, 'G3DSA:3.40.50.300:FF:001039', NULL, NULL, 'ATP-dependent RNA helicase DDX60', NULL, NULL, NULL, NULL, NULL, 4),
(198915, NULL, 'G3DSA:3.40.50.300:FF:007222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198916, NULL, 'G3DSA:1.10.3470.10:FF:000042', NULL, NULL, 'Putative ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(198917, NULL, 'G3DSA:1.20.1740.10:FF:000228', NULL, NULL, 'Amino acid permease homolog ykbA', NULL, NULL, NULL, NULL, NULL, 4),
(198918, NULL, 'G3DSA:3.10.129.10:FF:000074', NULL, NULL, 'Acyl-CoA thioesterase II', NULL, NULL, NULL, NULL, NULL, 4),
(198919, NULL, 'G3DSA:1.20.58.60:FF:000334', NULL, NULL, 'SMAll', NULL, NULL, NULL, NULL, NULL, 4),
(198920, NULL, 'G3DSA:1.10.720.30:FF:000023', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(198921, NULL, 'G3DSA:3.40.30.10:FF:001054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198922, NULL, 'G3DSA:3.30.70.580:FF:000056', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(198923, NULL, 'G3DSA:2.40.50.510:FF:000004', NULL, NULL, 'RecQ-mediated genome instability protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(198924, NULL, 'G3DSA:3.40.50.10490:FF:000160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198925, NULL, 'G3DSA:3.30.1520.10:FF:000141', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198926, NULL, 'G3DSA:3.30.56.10:FF:000017', NULL, NULL, 'Putative phenylalanyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(198927, NULL, 'G3DSA:3.40.50.1010:FF:000003', NULL, NULL, 'Flap endonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(198928, NULL, 'G3DSA:3.30.70.260:FF:000022', NULL, NULL, 'Chorismate mutase/prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(198929, NULL, 'G3DSA:3.40.50.720:FF:002334', NULL, NULL, 'Acetyl-CoA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(198930, NULL, 'G3DSA:2.40.50.140:FF:000169', NULL, NULL, 'AAA ATPase forming ring-shaped complexes', NULL, NULL, NULL, NULL, NULL, 4),
(198931, NULL, 'G3DSA:2.60.40.10:FF:001494', NULL, NULL, 'Immunoglobulin superfamily DCC subclass member 3', NULL, NULL, NULL, NULL, NULL, 4),
(198932, NULL, 'G3DSA:3.80.10.10:FF:002394', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198933, NULL, 'G3DSA:2.40.37.10:FF:000065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198934, NULL, 'G3DSA:3.90.660.10:FF:000060', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(198935, NULL, 'G3DSA:2.30.30.40:FF:000464', NULL, NULL, 'Cytokinesis and cell polarization-associated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(198936, NULL, 'G3DSA:3.40.850.10:FF:000029', NULL, NULL, 'Kinesin-like protein KIF17', NULL, NULL, NULL, NULL, NULL, 4),
(198937, NULL, 'G3DSA:2.60.34.10:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198938, NULL, 'G3DSA:3.40.250.10:FF:000152', NULL, NULL, 'Putative thiosulfate sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(198939, NULL, 'G3DSA:3.30.420.40:FF:000867', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198940, NULL, 'G3DSA:2.170.16.10:FF:000022', NULL, NULL, 'Ribonucleoside-diphosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(198941, NULL, 'G3DSA:1.25.40.10:FF:004933', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198942, NULL, 'G3DSA:2.60.40.2950:FF:000002', NULL, NULL, 'CD109 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(198943, NULL, 'G3DSA:3.40.50.2000:FF:000430', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(198944, NULL, 'G3DSA:1.10.10.10:FF:000693', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(198945, NULL, 'G3DSA:1.10.472.80:FF:000180', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198946, NULL, 'G3DSA:1.10.287.70:FF:000128', NULL, NULL, 'Two-pore potassium channel 1', NULL, NULL, NULL, NULL, NULL, 4),
(198947, NULL, 'G3DSA:2.40.50.140:FF:000551', NULL, NULL, 'Single-stranded DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(198948, NULL, 'G3DSA:2.60.40.3180:FF:000004', NULL, NULL, 'Transcription factor COE1', NULL, NULL, NULL, NULL, NULL, 4),
(198949, NULL, 'G3DSA:3.30.40.10:FF:002033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198950, NULL, 'G3DSA:3.40.800.10:FF:000026', NULL, NULL, 'N(1)-aminopropylagmatine ureohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(198951, NULL, 'G3DSA:3.30.160.60:FF:002399', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198952, NULL, 'G3DSA:1.50.40.10:FF:000131', NULL, NULL, 'Mitochondrial phosphate carrier protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(198953, NULL, 'G3DSA:3.30.160.60:FF:003742', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198954, NULL, 'G3DSA:3.30.1370.50:FF:000028', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198955, NULL, 'G3DSA:1.25.40.1040:FF:000018', NULL, NULL, 'N-alpha-acetyltransferase 16, NatA auxiliary subunit isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(198956, NULL, 'G3DSA:3.90.180.10:FF:000034', NULL, NULL, 'L-idonate 5-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(198957, NULL, 'G3DSA:1.10.630.10:FF:000038', NULL, NULL, 'Cytochrome P450 84A1', NULL, NULL, NULL, NULL, NULL, 4),
(198958, NULL, 'G3DSA:2.60.120.650:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198959, NULL, 'G3DSA:3.30.70.330:FF:002252', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198960, NULL, 'G3DSA:2.160.20.10:FF:000268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198961, NULL, 'G3DSA:3.40.720.10:FF:000025', NULL, NULL, 'GPI ethanolamine phosphate transferase 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(198962, NULL, 'G3DSA:2.30.39.10:FF:000042', NULL, NULL, 'leukocyte elastase inhibitor-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(198963, NULL, 'G3DSA:3.40.367.20:FF:000015', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(198964, NULL, 'G3DSA:3.30.40.10:FF:001757', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(198965, NULL, 'G3DSA:1.25.40.10:FF:000369', NULL, NULL, 'Signal recognition particle subunit SRP72', NULL, NULL, NULL, NULL, NULL, 4),
(198966, NULL, 'G3DSA:3.80.10.10:FF:002512', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198967, NULL, 'G3DSA:1.20.1720.10:FF:000126', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198968, NULL, 'G3DSA:3.10.560.10:FF:000002', NULL, NULL, 'Sugar ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(198969, NULL, 'G3DSA:3.30.1360.10:FF:000038', NULL, NULL, 'Putative DNA-directed RNA polymerase,alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(198970, NULL, 'G3DSA:3.90.640.10:FF:000114', NULL, NULL, 'Chaperone protein HscA homolog', NULL, NULL, NULL, NULL, NULL, 4),
(198971, NULL, 'G3DSA:3.40.50.1010:FF:000054', NULL, NULL, 'Flap endonuclease GEN', NULL, NULL, NULL, NULL, NULL, 4),
(198972, NULL, 'G3DSA:2.10.90.10:FF:000010', NULL, NULL, 'Platelet derived growth factor C', NULL, NULL, NULL, NULL, NULL, 4),
(198973, NULL, 'G3DSA:3.40.190.10:FF:000506', NULL, NULL, 'Porphobilinogen deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(198974, NULL, 'G3DSA:1.20.1070.10:FF:000435', NULL, NULL, 'Olfactory receptor 6C2', NULL, NULL, NULL, NULL, NULL, 4),
(198975, NULL, 'G3DSA:1.20.1610.10:FF:000011', NULL, NULL, 'Glycoside hydrolase family 92 protein', NULL, NULL, NULL, NULL, NULL, 4),
(198976, NULL, 'G3DSA:1.10.40.30:FF:000015', NULL, NULL, 'Adenylosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(198977, NULL, 'G3DSA:2.30.110.10:FF:000024', NULL, NULL, 'Phenazine biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(198978, NULL, 'G3DSA:3.90.70.10:FF:000458', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198979, NULL, 'G3DSA:1.10.287.3240:FF:000030', NULL, NULL, 'V-type proton ATPase subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(198980, NULL, 'G3DSA:2.60.120.330:FF:000161', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198981, NULL, 'G3DSA:1.25.10.10:FF:002571', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198982, NULL, 'G3DSA:3.30.710.10:FF:000521', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(198983, NULL, 'G3DSA:1.10.287.130:FF:000113', NULL, NULL, 'PAS/PAC sensor hybrid histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(198984, NULL, 'G3DSA:2.70.160.11:FF:000008', NULL, NULL, 'Protein arginine N-methyltransferase 6', NULL, NULL, NULL, NULL, NULL, 4),
(198985, NULL, 'G3DSA:3.40.30.10:FF:000036', NULL, NULL, 'anterior gradient protein 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(198986, NULL, 'G3DSA:2.40.50.140:FF:000276', NULL, NULL, 'aspartate--tRNA ligase, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(198987, NULL, 'G3DSA:3.40.640.10:FF:000367', NULL, NULL, 'Serine--pyruvate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(198988, NULL, 'G3DSA:3.30.200.20:FF:002239', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(198989, NULL, 'G3DSA:1.10.10.10:FF:000766', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(198990, NULL, 'G3DSA:1.20.1250.20:FF:000256', NULL, NULL, 'Protein NRT1/ PTR FAMILY 8.3', NULL, NULL, NULL, NULL, NULL, 4),
(198991, NULL, 'G3DSA:3.10.310.10:FF:000068', NULL, NULL, 'Diaminopimelate epimerase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(198992, NULL, 'G3DSA:1.20.1070.10:FF:000216', NULL, NULL, 'Relaxin family peptide receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(198993, NULL, 'G3DSA:1.25.40.10:FF:002847', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(198994, NULL, 'G3DSA:3.40.50.300:FF:007492', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(198995, NULL, 'G3DSA:3.40.50.150:FF:001028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(198996, NULL, 'G3DSA:2.60.120.200:FF:000083', NULL, NULL, 'FAT atypical cadherin 4', NULL, NULL, NULL, NULL, NULL, 4),
(198997, NULL, 'G3DSA:3.90.110.10:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198998, NULL, 'G3DSA:3.40.50.1000:FF:000866', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(198999, NULL, 'G3DSA:3.90.1030.10:FF:000016', NULL, NULL, '50S ribosomal protein L17', NULL, NULL, NULL, NULL, NULL, 4),
(199000, NULL, 'G3DSA:3.40.50.2300:FF:001200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199001, NULL, 'G3DSA:1.25.40.820:FF:000006', NULL, NULL, 'Putative RNA polymerase II subunit B1 CTD phosphatase RPAP2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(199002, NULL, 'G3DSA:3.20.20.80:FF:000181', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(199003, NULL, 'G3DSA:2.60.40.10:FF:001168', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(199004, NULL, 'G3DSA:1.10.8.720:FF:000010', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199005, NULL, 'G3DSA:3.40.390.10:FF:000038', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(199006, NULL, 'G3DSA:3.90.1150.80:FF:000001', NULL, NULL, 'Chromosome segregation protein (Pcs1)', NULL, NULL, NULL, NULL, NULL, 4),
(199007, NULL, 'G3DSA:1.10.287.2720:FF:000003', NULL, NULL, 'Oxysterol binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(199008, NULL, 'G3DSA:1.25.40.10:FF:005102', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(199009, NULL, 'G3DSA:3.40.50.300:FF:006379', NULL, NULL, 'RAS related protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199010, NULL, 'G3DSA:2.60.40.10:FF:001224', NULL, NULL, 'Immunoglobulin superfamily member 10', NULL, NULL, NULL, NULL, NULL, 4),
(199011, NULL, 'G3DSA:1.10.287.1490:FF:000010', NULL, NULL, 'Ribosome binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(199012, NULL, 'G3DSA:2.130.10.10:FF:003512', NULL, NULL, 'Probable U3 small nucleolar RNA-associated protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(199013, NULL, 'G3DSA:1.20.120.1880:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199014, NULL, 'G3DSA:2.40.30.10:FF:000494', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199015, NULL, 'G3DSA:2.60.120.200:FF:000206', NULL, NULL, 'MAM and LDL-receptor class A domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(199016, NULL, 'G3DSA:3.80.10.10:FF:000191', NULL, NULL, 'Leucine rich repeats and guanylate kinase domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(199017, NULL, 'G3DSA:2.40.70.10:FF:000266', NULL, NULL, 'Aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(199018, NULL, 'G3DSA:3.30.40.10:FF:000127', NULL, NULL, 'E3 ubiquitin-protein ligase RNF181', NULL, NULL, NULL, NULL, NULL, 4),
(199019, NULL, 'G3DSA:3.40.190.10:FF:000905', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199020, NULL, 'G3DSA:2.10.280.10:FF:000001', NULL, NULL, 'Gp12 Short tail fibers', NULL, NULL, NULL, NULL, NULL, 4),
(199021, NULL, 'G3DSA:3.10.20.90:FF:000729', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199022, NULL, 'G3DSA:2.60.40.420:FF:000229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199023, NULL, 'G3DSA:1.20.142.10:FF:000008', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(199024, NULL, 'G3DSA:3.90.640.10:FF:000058', NULL, NULL, 'Heat shock 70 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(199025, NULL, 'G3DSA:2.40.40.20:FF:000031', NULL, NULL, 'Arginine N-succinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(199026, NULL, 'G3DSA:3.40.50.1820:FF:000319', NULL, NULL, 'Serine hydrolase (FSH1)', NULL, NULL, NULL, NULL, NULL, 4),
(199027, NULL, 'G3DSA:1.10.10.10:FF:000985', NULL, NULL, 'U5 small nuclear ribonucleoprotein helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199028, NULL, 'G3DSA:3.30.40.10:FF:000739', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(199029, NULL, 'G3DSA:1.25.40.660:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199030, NULL, 'G3DSA:2.40.50.140:FF:000225', NULL, NULL, 'tyrosine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(199031, NULL, 'G3DSA:1.20.990.10:FF:000017', NULL, NULL, 'NADPH--cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(199032, NULL, 'G3DSA:1.10.150.50:FF:000103', NULL, NULL, 'Bicaudal C, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(199033, NULL, 'G3DSA:3.40.50.300:FF:007615', NULL, NULL, 'DEAD-box helicase 3 X-linked b', NULL, NULL, NULL, NULL, NULL, 4),
(199034, NULL, 'G3DSA:3.40.50.1910:FF:000015', NULL, NULL, 'Syntaxin binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199035, NULL, 'G3DSA:2.40.240.130:FF:000008', NULL, NULL, 'Axin-like protein pry-1', NULL, NULL, NULL, NULL, NULL, 4),
(199036, NULL, 'G3DSA:1.10.600.10:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199037, NULL, 'G3DSA:1.25.10.10:FF:002790', NULL, NULL, 'Phospholipase A-2-activating protein-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(199038, NULL, 'G3DSA:2.130.10.10:FF:002669', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199039, NULL, 'G3DSA:3.30.1520.10:FF:000192', NULL, NULL, 'Phopholipase D, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199040, NULL, 'G3DSA:3.30.70.940:FF:000012', NULL, NULL, 'Transcription elongation factor SPT5', NULL, NULL, NULL, NULL, NULL, 4),
(199041, NULL, 'G3DSA:2.60.40.420:FF:000162', NULL, NULL, 'Blue (Type 1) copper domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(199042, NULL, 'G3DSA:2.60.9.10:FF:000001', NULL, NULL, 'oxytocin-neurophysin 1', NULL, NULL, NULL, NULL, NULL, 4),
(199043, NULL, 'G3DSA:3.30.70.330:FF:000739', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(199044, NULL, 'G3DSA:3.30.1010.10:FF:000052', NULL, NULL, 'ATR serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(199045, NULL, 'G3DSA:3.30.450.20:FF:000537', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199046, NULL, 'G3DSA:3.40.50.620:FF:000505', NULL, NULL, 'Deoxyribodipyrimidine photolyase, type II', NULL, NULL, NULL, NULL, NULL, 4),
(199047, NULL, 'G3DSA:1.20.1250.20:FF:000531', NULL, NULL, 'Major Facilitator Superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(199048, NULL, 'G3DSA:3.40.1280.10:FF:000108', NULL, NULL, 'Os01g0742000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(199049, NULL, 'G3DSA:2.40.50.140:FF:000495', NULL, NULL, 'Single-stranded TG1-3 telomere G-tails binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(199050, NULL, 'G3DSA:1.10.10.10:FF:001261', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(199051, NULL, 'G3DSA:3.30.70.990:FF:000004', NULL, NULL, 'UPF0234 protein CbuK_1936', NULL, NULL, NULL, NULL, NULL, 4),
(199052, NULL, 'G3DSA:1.10.510.10:FF:000310', NULL, NULL, 'Serine/threonine-protein kinase HT1', NULL, NULL, NULL, NULL, NULL, 4),
(199053, NULL, 'G3DSA:1.20.140.10:FF:000116', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(199054, NULL, 'G3DSA:3.30.260.10:FF:000048', NULL, NULL, 'Chaperonin HSP60/CNP60, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199055, NULL, 'G3DSA:2.30.29.30:FF:000665', NULL, NULL, 'FACT complex subunit SSRP1', NULL, NULL, NULL, NULL, NULL, 4),
(199056, NULL, 'G3DSA:3.80.10.10:FF:000039', NULL, NULL, 'slit homolog 2 protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(199057, NULL, 'G3DSA:1.10.10.10:FF:000367', NULL, NULL, 'Heat stress transcription factor A-8', NULL, NULL, NULL, NULL, NULL, 4),
(199058, NULL, 'G3DSA:2.60.120.260:FF:000258', NULL, NULL, 'Glycine-, glutamate-, thienylcyclohexylpiperidine-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(199059, NULL, 'G3DSA:2.60.40.60:FF:000300', NULL, NULL, 'Cadherin related family member 4', NULL, NULL, NULL, NULL, NULL, 4),
(199060, NULL, 'G3DSA:3.40.50.720:FF:002008', NULL, NULL, 'Tetraketide alpha-pyrone reductase 1', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(199061, NULL, 'G3DSA:2.60.40.10:FF:001443', NULL, NULL, 'Interleukin-7 receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(199062, NULL, 'G3DSA:2.40.50.90:FF:000187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199063, NULL, 'G3DSA:3.90.360.10:FF:000020', NULL, NULL, 'Histone acetyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(199064, NULL, 'G3DSA:3.30.710.10:FF:000302', NULL, NULL, 'Zinc finger and BTB domain containing 48', NULL, NULL, NULL, NULL, NULL, 4),
(199065, NULL, 'G3DSA:3.20.20.60:FF:000023', NULL, NULL, 'CitE, Citrate lyase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(199066, NULL, 'G3DSA:3.40.630.10:FF:000193', NULL, NULL, 'Putative glutaminyl cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(199067, NULL, 'G3DSA:2.10.220.10:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199068, NULL, 'G3DSA:3.60.15.10:FF:000129', NULL, NULL, 'N-acyl-phosphatidylethanolamine-hydrolyzing phospholipase D', NULL, NULL, NULL, NULL, NULL, 4),
(199069, NULL, 'G3DSA:3.90.1280.20:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199070, NULL, 'G3DSA:3.40.850.10:FF:000181', NULL, NULL, 'Kinesin family member 20Ba', NULL, NULL, NULL, NULL, NULL, 4),
(199071, NULL, 'G3DSA:3.30.1540.20:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199072, NULL, 'G3DSA:2.40.50.140:FF:000837', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199073, NULL, 'G3DSA:3.40.50.620:FF:000910', NULL, NULL, 'Arginyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(199074, NULL, 'G3DSA:3.40.50.300:FF:001657', NULL, NULL, 'ADP-ribosylation factor-like protein 5A isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(199075, NULL, 'G3DSA:2.70.70.10:FF:000017', NULL, NULL, 'Peptidase, M23 family', NULL, NULL, NULL, NULL, NULL, 4),
(199076, NULL, 'G3DSA:3.60.10.10:FF:000433', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199077, NULL, 'G3DSA:3.40.50.790:FF:000011', NULL, NULL, 'Unplaced genomic scaffold supercont1.18, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(199078, NULL, 'G3DSA:2.70.70.10:FF:000074', NULL, NULL, 'EppA', NULL, NULL, NULL, NULL, NULL, 4),
(199079, NULL, 'G3DSA:3.80.10.10:FF:000533', NULL, NULL, 'Leucine rich repeats and death domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(199080, NULL, 'G3DSA:1.10.630.10:FF:000257', NULL, NULL, 'Os02g0503850 protein', NULL, NULL, NULL, NULL, NULL, 4),
(199081, NULL, 'G3DSA:3.30.1460.20:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199082, NULL, 'G3DSA:1.10.1410.40:FF:000018', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199083, NULL, 'G3DSA:3.90.25.10:FF:000033', NULL, NULL, 'NmrA family transcriptional regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199084, NULL, 'G3DSA:3.30.760.10:FF:000013', NULL, NULL, 'eukaryotic translation initiation factor 4E type 3', NULL, NULL, NULL, NULL, NULL, 4),
(199085, NULL, 'G3DSA:1.25.40.20:FF:001092', NULL, NULL, 'Fibronectin type III and ankyrin repeat domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(199086, NULL, 'G3DSA:1.20.120.610:FF:000002', NULL, NULL, 'V-type proton ATPase proteolipid subunit', NULL, NULL, NULL, NULL, NULL, 4),
(199087, NULL, 'G3DSA:2.60.120.260:FF:000078', NULL, NULL, 'DAL2p Allantoicase', NULL, NULL, NULL, NULL, NULL, 4),
(199088, NULL, 'G3DSA:1.10.390.10:FF:000103', NULL, NULL, 'cDNA FLJ51269, highly similar to Aminopeptidase N', NULL, NULL, NULL, NULL, NULL, 4),
(199089, NULL, 'G3DSA:3.40.50.150:FF:001410', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199090, NULL, 'G3DSA:3.30.200.20:FF:002565', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199091, NULL, 'G3DSA:3.10.20.230:FF:000030', NULL, NULL, 'AT13713p', NULL, NULL, NULL, NULL, NULL, 4),
(199092, NULL, 'G3DSA:4.10.1060.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199093, NULL, 'G3DSA:3.40.50.720:FF:001839', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase 2 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(199094, NULL, 'G3DSA:3.30.310.10:FF:000030', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(199095, NULL, 'G3DSA:3.30.1330.40:FF:000028', NULL, NULL, 'ATP binding L-PSP endoribonuclease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(199096, NULL, 'G3DSA:1.20.1440.80:FF:000007', NULL, NULL, 'Gap junction delta-4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(199097, NULL, 'G3DSA:3.40.50.150:FF:001354', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199098, NULL, 'G3DSA:1.20.120.620:FF:000005', NULL, NULL, 'Sensor histidine kinase KdpD', NULL, NULL, NULL, NULL, NULL, 4),
(199099, NULL, 'G3DSA:3.40.50.300:FF:007110', NULL, NULL, 'Rab_C89 protein', NULL, NULL, NULL, NULL, NULL, 4),
(199100, NULL, 'G3DSA:1.20.58.1070:FF:000004', NULL, NULL, 'Gem-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(199101, NULL, 'G3DSA:1.10.510.10:FF:001327', NULL, NULL, 'Serine/threonine-protein kinase ELM1', NULL, NULL, NULL, NULL, NULL, 4),
(199102, NULL, 'G3DSA:1.10.10.2430:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199103, NULL, 'G3DSA:3.90.650.10:FF:000053', NULL, NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(199104, NULL, 'G3DSA:3.40.1110.10:FF:000433', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199105, NULL, 'G3DSA:3.40.630.40:FF:000027', NULL, NULL, 'Gll1363 protein', NULL, NULL, NULL, NULL, NULL, 4),
(199106, NULL, 'G3DSA:3.30.450.20:FF:000206', NULL, NULL, 'PAS domain-containing serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(199107, NULL, 'G3DSA:3.90.79.10:FF:000219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199108, NULL, 'G3DSA:3.40.50.620:FF:000056', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(199109, NULL, 'G3DSA:3.40.630.30:FF:000024', NULL, NULL, '[Citrate [pro-3S]-lyase] ligase', NULL, NULL, NULL, NULL, NULL, 4),
(199110, NULL, 'G3DSA:3.30.700.40:FF:000001', NULL, NULL, 'Methylcrotonoyl-CoA carboxylase subunit alpha, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(199111, NULL, 'G3DSA:2.10.110.10:FF:000074', NULL, NULL, 'Rho-type GTPase-activating protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(199112, NULL, 'G3DSA:2.30.30.190:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199113, NULL, 'G3DSA:3.30.200.20:FF:001003', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(199114, NULL, 'G3DSA:1.20.58.1060:FF:000001', NULL, NULL, 'dystonin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(199115, NULL, 'G3DSA:3.40.50.2300:FF:000076', NULL, NULL, 'Regulator of RpoS', NULL, NULL, NULL, NULL, NULL, 4),
(199116, NULL, 'G3DSA:3.30.1330.30:FF:000025', NULL, NULL, 'rRNA methyltransferase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(199117, NULL, 'G3DSA:3.40.630.20:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199118, NULL, 'G3DSA:3.30.70.360:FF:000046', NULL, NULL, 'Clan MH, family M20, peptidase T-like metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(199119, NULL, 'G3DSA:3.90.105.20:FF:000003', NULL, NULL, 'Ribosome assembly factor mrt4', NULL, NULL, NULL, NULL, NULL, 4),
(199120, NULL, 'G3DSA:1.20.1250.20:FF:000823', NULL, NULL, 'Inorganic phosphate transporter PHO84', NULL, NULL, NULL, NULL, NULL, 4),
(199121, NULL, 'G3DSA:3.90.550.20:FF:000003', NULL, NULL, 'Lactosylceramide 4-alpha-galactosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(199122, NULL, 'G3DSA:2.30.40.10:FF:000017', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(199123, NULL, 'G3DSA:2.70.70.10:FF:000068', NULL, NULL, 'Cell wall hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(199124, NULL, 'G3DSA:3.30.43.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199125, NULL, 'G3DSA:3.50.50.60:FF:000625', NULL, NULL, 'Nitrate reductase, NADH oxidase subunit', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(199126, NULL, 'G3DSA:3.30.70.960:FF:000018', NULL, NULL, 'Mucin 16', NULL, NULL, NULL, NULL, NULL, 4),
(199127, NULL, 'G3DSA:2.60.40.10:FF:002860', NULL, NULL, 'Sialoadhesin', NULL, NULL, NULL, NULL, NULL, 4),
(199128, NULL, 'G3DSA:3.40.50.720:FF:000316', NULL, NULL, 'Mannitol-1-phosphate 5-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(199129, NULL, 'G3DSA:2.10.110.10:FF:000068', NULL, NULL, 'Insulin gene enhancer protein ISL-2', NULL, NULL, NULL, NULL, NULL, 4),
(199130, NULL, 'G3DSA:1.20.58.60:FF:000603', NULL, NULL, 'Microtubule actin crosslinking factor 1a', NULL, NULL, NULL, NULL, NULL, 4),
(199131, NULL, 'G3DSA:2.10.25.10:FF:000382', NULL, NULL, 'Adhesion G protein-coupled receptor E2', NULL, NULL, NULL, NULL, NULL, 4),
(199132, NULL, 'G3DSA:3.40.718.10:FF:000025', NULL, NULL, 'Isocitrate dehydrogenase [NADP]', NULL, NULL, NULL, NULL, NULL, 4),
(199133, NULL, 'G3DSA:1.20.1250.20:FF:002004', NULL, NULL, 'Sugar transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199134, NULL, 'G3DSA:2.30.30.790:FF:000002', NULL, NULL, '39S ribosomal protein L19, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(199135, NULL, 'G3DSA:3.30.70.330:FF:002813', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199136, NULL, 'G3DSA:1.20.1070.10:FF:000722', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199137, NULL, 'G3DSA:1.20.58.1970:FF:000004', NULL, NULL, 'Exocyst complex component SEC10a', NULL, NULL, NULL, NULL, NULL, 4),
(199138, NULL, 'G3DSA:2.130.10.10:FF:004636', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199139, NULL, 'G3DSA:3.30.70.330:FF:001234', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(199140, NULL, 'G3DSA:2.10.25.10:FF:000106', NULL, NULL, 'Heparan sulfate proteoglycan 2', NULL, NULL, NULL, NULL, NULL, 4),
(199141, NULL, 'G3DSA:3.30.70.330:FF:002920', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199142, NULL, 'G3DSA:3.30.420.60:FF:000019', NULL, NULL, 'Protein pelota homolog', NULL, NULL, NULL, NULL, NULL, 4),
(199143, NULL, 'G3DSA:2.60.120.830:FF:000002', NULL, NULL, 'ADAMTS like 1', NULL, NULL, NULL, NULL, NULL, 4),
(199144, NULL, 'G3DSA:3.40.50.1700:FF:000053', NULL, NULL, 'Beta-glucosidase BoGH3A', NULL, NULL, NULL, NULL, NULL, 4),
(199145, NULL, 'G3DSA:1.10.150.50:FF:000215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199146, NULL, 'G3DSA:1.10.510.10:FF:001384', NULL, NULL, 'C-type lectin', NULL, NULL, NULL, NULL, NULL, 4),
(199147, NULL, 'G3DSA:3.90.25.10:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199148, NULL, 'G3DSA:1.25.50.20:FF:000024', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(199149, NULL, 'G3DSA:2.60.120.200:FF:000318', NULL, NULL, 'Protein S', NULL, NULL, NULL, NULL, NULL, 4),
(199150, NULL, 'G3DSA:3.30.450.20:FF:000189', NULL, NULL, 'AGAP000773-PA', NULL, NULL, NULL, NULL, NULL, 4),
(199151, NULL, 'G3DSA:1.25.10.10:FF:002784', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(199152, NULL, 'G3DSA:1.20.120.1750:FF:000098', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(199153, NULL, 'G3DSA:1.10.510.10:FF:001440', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199154, NULL, 'G3DSA:3.40.190.10:FF:000950', NULL, NULL, 'Dipeptide binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(199155, NULL, 'G3DSA:1.25.10.10:FF:003352', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199156, NULL, 'G3DSA:2.60.120.780:FF:000003', NULL, NULL, 'MIZ zinc finger protein, variant', NULL, NULL, NULL, NULL, NULL, 4),
(199157, NULL, 'G3DSA:4.10.60.10:FF:000127', NULL, NULL, 'Glycine-rich RNA-binding protein RZ1B', NULL, NULL, NULL, NULL, NULL, 4),
(199158, NULL, 'G3DSA:1.25.10.10:FF:001261', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199159, NULL, 'G3DSA:3.50.50.60:FF:000664', NULL, NULL, 'Flavin-containing monooxygenase, Fmo', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(199160, NULL, 'G3DSA:1.10.340.70:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199161, NULL, 'G3DSA:1.10.357.30:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199162, NULL, 'G3DSA:3.40.850.10:FF:000175', NULL, NULL, 'Myosin heavy chain 9', NULL, NULL, NULL, NULL, NULL, 4),
(199163, NULL, 'G3DSA:2.60.120.200:FF:000605', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199164, NULL, 'G3DSA:3.40.390.10:FF:000095', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(199165, NULL, 'G3DSA:3.90.1030.10:FF:000022', NULL, NULL, 'Ribosomal protein L17', NULL, NULL, NULL, NULL, NULL, 4),
(199166, NULL, 'G3DSA:2.20.25.100:FF:000001', NULL, NULL, '40S ribosomal protein S27', NULL, NULL, NULL, NULL, NULL, 4),
(199167, NULL, 'G3DSA:3.30.460.10:FF:000030', NULL, NULL, 'Putative GTP diphosphokinase RSH2 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(199168, NULL, 'G3DSA:1.10.510.10:FF:003525', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199169, NULL, 'G3DSA:1.10.238.10:FF:000789', NULL, NULL, 'Calpain 13', NULL, NULL, NULL, NULL, NULL, 4),
(199170, NULL, 'G3DSA:2.10.25.10:FF:001629', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199171, NULL, 'G3DSA:3.30.70.330:FF:000627', NULL, NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(199172, NULL, 'G3DSA:3.40.50.80:FF:000137', NULL, NULL, 'Probable metalloreductase AIM14', NULL, NULL, NULL, NULL, NULL, 4),
(199173, NULL, 'G3DSA:1.20.58.2190:FF:000003', NULL, NULL, 'UBX domain-containing protein 6 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(199174, NULL, 'G3DSA:2.60.40.1850:FF:000004', NULL, NULL, 'Sortase B protein-sorting domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(199175, NULL, 'G3DSA:1.25.40.180:FF:000033', NULL, NULL, 'Regulator of nonsense transcripts UPF2', NULL, NULL, NULL, NULL, NULL, 4),
(199176, NULL, 'G3DSA:3.40.50.1820:FF:000651', NULL, NULL, 'Clan SC, family S28, unassigned serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(199177, NULL, 'G3DSA:6.10.140.2220:FF:000004', NULL, NULL, 'ubiquitin carboxyl-terminal hydrolase 19 isoform X9', NULL, NULL, NULL, NULL, NULL, 4),
(199178, NULL, 'G3DSA:3.40.50.300:FF:007054', NULL, NULL, 'N-deacetylase/N-sulfotransferase (heparan glucosaminyl) 3', NULL, NULL, NULL, NULL, NULL, 4),
(199179, NULL, 'G3DSA:3.80.10.10:FF:004081', NULL, NULL, 'Protein lap1', NULL, NULL, NULL, NULL, NULL, 4),
(199180, NULL, 'G3DSA:3.30.230.10:FF:000260', NULL, NULL, 'Ribosomal protein S9/S16', NULL, NULL, NULL, NULL, NULL, 4),
(199181, NULL, 'G3DSA:1.25.10.10:FF:000547', NULL, NULL, 'Dynein assembly factor 5, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(199182, NULL, 'G3DSA:1.20.58.1120:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199183, NULL, 'G3DSA:3.40.50.300:FF:003512', NULL, NULL, '6-phosphofructo-2-kinase/fructose-2, 6-biphosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199184, NULL, 'G3DSA:1.10.8.10:FF:000107', NULL, NULL, 'Vacuolar protein sorting 13 homolog D', NULL, NULL, NULL, NULL, NULL, 4),
(199185, NULL, 'G3DSA:1.10.3430.10:FF:000045', NULL, NULL, 'Ammonium transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199186, NULL, 'G3DSA:1.10.510.10:FF:003418', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199187, NULL, 'G3DSA:3.50.7.10:FF:000017', NULL, NULL, 'Bardet-Biedl syndrome 10 protein', NULL, NULL, NULL, NULL, NULL, 4),
(199188, NULL, 'G3DSA:3.40.225.10:FF:000026', NULL, NULL, 'Ribulose-5-phosphate 4-epimerase and related epimerase and aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(199189, NULL, 'G3DSA:3.30.40.10:FF:000745', NULL, NULL, 'Chromatin modification-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(199190, NULL, 'G3DSA:2.60.40.1390:FF:000001', NULL, NULL, 'Myelin gene regulatory factor', NULL, NULL, NULL, NULL, NULL, 4),
(199191, NULL, 'G3DSA:1.20.1070.10:FF:000609', NULL, NULL, 'Si:dkey-6n21.13', NULL, NULL, NULL, NULL, NULL, 4),
(199192, NULL, 'G3DSA:2.10.25.10:FF:001686', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(199193, NULL, 'G3DSA:2.130.10.10:FF:005311', NULL, NULL, 'DmX-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(199194, NULL, 'G3DSA:3.40.50.1000:FF:000467', NULL, NULL, 'Phosphoserine phosphatase (SerB)', NULL, NULL, NULL, NULL, NULL, 4),
(199195, NULL, 'G3DSA:1.10.10.10:FF:001530', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199196, NULL, 'G3DSA:1.20.58.1080:FF:000007', NULL, NULL, 'RNA helicase like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199197, NULL, 'G3DSA:3.30.160.60:FF:001505', NULL, NULL, 'Zinc finger protein 540', NULL, NULL, NULL, NULL, NULL, 4),
(199198, NULL, 'G3DSA:6.10.140.2210:FF:000001', NULL, NULL, 'Putative e3 ubiquitin-protein ligase hakai', NULL, NULL, NULL, NULL, NULL, 4),
(199199, NULL, 'G3DSA:3.80.10.10:FF:002843', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(199200, NULL, 'G3DSA:3.10.350.10:FF:000071', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199201, NULL, 'G3DSA:1.20.1250.20:FF:000082', NULL, NULL, 'MFS multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199202, NULL, 'G3DSA:3.40.50.460:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199203, NULL, 'G3DSA:3.40.525.10:FF:000066', NULL, NULL, 'Clavesin 1', NULL, NULL, NULL, NULL, NULL, 4),
(199204, NULL, 'G3DSA:2.60.40.10:FF:002747', NULL, NULL, 'Ig kappa chain V region GOM', NULL, NULL, NULL, NULL, NULL, 4),
(199205, NULL, 'G3DSA:3.80.10.10:FF:003299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199206, NULL, 'G3DSA:3.60.10.10:FF:000141', NULL, NULL, 'Endonuclease/Exonuclease/phosphatase family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199207, NULL, 'G3DSA:3.40.50.10190:FF:000064', NULL, NULL, 'Protein BREAST CANCER SUSCEPTIBILITY 1 like', NULL, NULL, NULL, NULL, NULL, 4),
(199208, NULL, 'G3DSA:3.40.640.10:FF:000255', NULL, NULL, 'DegT/DnrJ/EryC1/StrS family aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(199209, NULL, 'G3DSA:2.60.120.380:FF:000041', NULL, NULL, 'Calpain-like protease palB/RIM13', NULL, NULL, NULL, NULL, NULL, 4),
(199210, NULL, 'G3DSA:1.20.58.60:FF:000660', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199211, NULL, 'G3DSA:3.40.850.10:FF:000068', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(199212, NULL, 'G3DSA:3.40.640.10:FF:000199', NULL, NULL, 'Glycine dehydrogenase [decarboxylating], mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(199213, NULL, 'G3DSA:3.40.50.300:FF:007840', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199214, NULL, 'G3DSA:3.40.50.10490:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199215, NULL, 'G3DSA:2.130.10.10:FF:003332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199216, NULL, 'G3DSA:3.80.10.10:FF:000483', NULL, NULL, 'NLR family, CARD domain-containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(199217, NULL, 'G3DSA:3.40.50.1000:FF:000574', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199218, NULL, 'G3DSA:3.40.720.10:FF:000351', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199219, NULL, 'G3DSA:2.115.10.20:FF:000004', NULL, NULL, 'Glucosamine inositolphosphorylceramide transferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(199220, NULL, 'G3DSA:1.50.10.20:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199221, NULL, 'G3DSA:2.60.40.60:FF:000935', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199222, NULL, 'G3DSA:1.10.286.10:FF:000007', NULL, NULL, 'GTP cyclohydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(199223, NULL, 'G3DSA:1.10.486.10:FF:000051', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(199224, NULL, 'G3DSA:2.130.10.10:FF:003220', NULL, NULL, 'Periodic tryptophan protein 2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(199225, NULL, 'G3DSA:1.10.510.10:FF:003800', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(199226, NULL, 'G3DSA:2.60.15.10:FF:000019', NULL, NULL, 'ATP synthase epsilon chain', NULL, NULL, NULL, NULL, NULL, 4),
(199227, NULL, 'G3DSA:2.20.25.80:FF:000003', NULL, NULL, 'WRKY transcription factor 57', NULL, NULL, NULL, NULL, NULL, 4),
(199228, NULL, 'G3DSA:3.30.40.10:FF:000852', NULL, NULL, 'Histone-lysine N-methyltransferase 2C', NULL, NULL, NULL, NULL, NULL, 4),
(199229, NULL, 'G3DSA:3.80.10.10:FF:000713', NULL, NULL, 'Receptor-like protein 48', NULL, NULL, NULL, NULL, NULL, 4),
(199230, NULL, 'G3DSA:3.40.50.300:FF:005816', NULL, NULL, 'Helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199231, NULL, 'G3DSA:3.40.50.300:FF:001365', NULL, NULL, 'Regulator of telomere elongation helicase 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(199232, NULL, 'G3DSA:3.30.479.20:FF:000002', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(199233, NULL, 'G3DSA:1.25.40.10:FF:000375', NULL, NULL, 'Sperm associated antigen 1', NULL, NULL, NULL, NULL, NULL, 4),
(199234, NULL, 'G3DSA:3.30.920.20:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199235, NULL, 'G3DSA:3.40.50.300:FF:000022', NULL, NULL, 'Signal recognition particle 54 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(199236, NULL, 'G3DSA:2.60.40.1840:FF:000001', NULL, NULL, 'Aminopeptidase N', NULL, NULL, NULL, NULL, NULL, 4),
(199237, NULL, 'G3DSA:1.20.1070.10:FF:002072', NULL, NULL, 'G-protein coupled receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199238, NULL, 'G3DSA:1.25.40.20:FF:001833', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199239, NULL, 'G3DSA:3.30.920.10:FF:000003', NULL, NULL, 'Frataxin, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(199240, NULL, 'G3DSA:3.40.50.10090:FF:000034', NULL, NULL, 'Uroporphyrinogen III synthase HEM4', NULL, NULL, NULL, NULL, NULL, 4),
(199241, NULL, 'G3DSA:3.20.20.140:FF:000450', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(199242, NULL, 'G3DSA:2.40.128.630:FF:000002', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(199243, NULL, 'G3DSA:3.30.479.30:FF:000005', NULL, NULL, 'Protease modulator HflC', NULL, NULL, NULL, NULL, NULL, 4),
(199244, NULL, 'G3DSA:2.40.70.10:FF:000558', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199245, NULL, 'G3DSA:2.20.25.90:FF:000006', NULL, NULL, 'Formate dehydrogenase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(199246, NULL, 'G3DSA:2.60.120.200:FF:000375', NULL, NULL, 'Lys-gingipain', NULL, NULL, NULL, NULL, NULL, 4),
(199247, NULL, 'G3DSA:1.20.58.1510:FF:000001', NULL, NULL, 'ATPase RavA', NULL, NULL, NULL, NULL, NULL, 4),
(199248, NULL, 'G3DSA:2.30.30.140:FF:000330', NULL, NULL, 'Bromodomain and PHD finger-containing, 3', NULL, NULL, NULL, NULL, NULL, 4),
(199249, NULL, 'G3DSA:3.30.710.10:FF:000246', NULL, NULL, 'T0060006 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(199250, NULL, 'G3DSA:3.30.160.60:FF:003181', NULL, NULL, 'Zinc finger protein 529', NULL, NULL, NULL, NULL, NULL, 4),
(199251, NULL, 'G3DSA:1.25.40.10:FF:001830', NULL, NULL, 'Os01g0913400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(199252, NULL, 'G3DSA:3.30.420.40:FF:000755', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199253, NULL, 'G3DSA:1.10.275.10:FF:000021', NULL, NULL, 'Aspartate ammonium lyase', NULL, NULL, NULL, NULL, NULL, 4),
(199254, NULL, 'G3DSA:2.60.40.10:FF:003242', NULL, NULL, 'Class II cytokine receptor crfb8', NULL, NULL, NULL, NULL, NULL, 4),
(199255, NULL, 'G3DSA:1.20.1070.10:FF:002015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199256, NULL, 'G3DSA:2.10.109.10:FF:000003', NULL, NULL, 'Signal peptidase complex catalytic subunit SEC11', NULL, NULL, NULL, NULL, NULL, 4),
(199257, NULL, 'G3DSA:3.40.190.10:FF:000731', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199258, NULL, 'G3DSA:3.90.1010.10:FF:000021', NULL, NULL, 'Nitrogen fixation protein NifU', NULL, NULL, NULL, NULL, NULL, 4),
(199259, NULL, 'G3DSA:2.130.10.10:FF:002495', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase, putative (AFU_orthologue AFUA_1G01750)', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(199260, NULL, 'G3DSA:2.10.25.10:FF:000163', NULL, NULL, 'laminin subunit gamma-1', NULL, NULL, NULL, NULL, NULL, 4),
(199261, NULL, 'G3DSA:1.20.58.1520:FF:000004', NULL, NULL, 'Spindle midzone component', NULL, NULL, NULL, NULL, NULL, 4),
(199262, NULL, 'G3DSA:3.40.50.2300:FF:000930', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199263, NULL, 'G3DSA:3.10.20.770:FF:000017', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(199264, NULL, 'G3DSA:3.30.70.330:FF:002870', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199265, NULL, 'G3DSA:3.40.50.720:FF:001896', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199266, NULL, 'G3DSA:1.25.10.10:FF:002964', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199267, NULL, 'G3DSA:3.30.450.20:FF:000245', NULL, NULL, 'C4-dicarboxylate transport sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(199268, NULL, 'G3DSA:3.90.190.10:FF:000192', NULL, NULL, 'MAP kinase phosphatase 6', NULL, NULL, NULL, NULL, NULL, 4),
(199269, NULL, 'G3DSA:3.90.1530.10:FF:000004', NULL, NULL, 'Chromosome partitioning protein ParB', NULL, NULL, NULL, NULL, NULL, 4),
(199270, NULL, 'G3DSA:1.50.10.10:FF:000180', NULL, NULL, 'Reducing-end xylose-releasing exo-oligoxylanase Rex8A', NULL, NULL, NULL, NULL, NULL, 4),
(199271, NULL, 'G3DSA:2.130.10.10:FF:001707', NULL, NULL, 'DIGIT', NULL, NULL, NULL, NULL, NULL, 4),
(199272, NULL, 'G3DSA:1.10.8.10:FF:000326', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199273, NULL, 'G3DSA:3.40.50.300:FF:003456', NULL, NULL, 'Helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199274, NULL, 'G3DSA:2.10.110.10:FF:000181', NULL, NULL, 'Rho-type GTPase-activating protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(199275, NULL, 'G3DSA:1.10.20.70:FF:000003', NULL, NULL, 'Polyadenylation factor subunit CstF64, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199276, NULL, 'G3DSA:3.40.50.410:FF:000049', NULL, NULL, 'von Willebrand factor A domain containing 8', NULL, NULL, NULL, NULL, NULL, 4),
(199277, NULL, 'G3DSA:3.30.1370.10:FF:000196', NULL, NULL, 'LOC553525 protein', NULL, NULL, NULL, NULL, NULL, 4),
(199278, NULL, 'G3DSA:1.20.1560.10:FF:000574', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199279, NULL, 'G3DSA:1.10.3370.10:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199280, NULL, 'G3DSA:1.25.10.10:FF:003239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199281, NULL, 'G3DSA:3.40.50.1860:FF:000016', NULL, NULL, 'Aspartate racemase', NULL, NULL, NULL, NULL, NULL, 4),
(199282, NULL, 'G3DSA:1.10.10.10:FF:001148', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(199283, NULL, 'G3DSA:2.40.70.10:FF:000491', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199284, NULL, 'G3DSA:1.10.510.10:FF:001620', NULL, NULL, 'Protein CBG03054', NULL, NULL, NULL, NULL, NULL, 4),
(199285, NULL, 'G3DSA:3.40.630.10:FF:000428', NULL, NULL, 'Bacterial leucyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(199286, NULL, 'G3DSA:2.60.40.10:FF:001056', NULL, NULL, 'Striated muscle preferentially expressed protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(199287, NULL, 'G3DSA:3.30.70.330:FF:002538', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199288, NULL, 'G3DSA:2.60.40.10:FF:004984', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199289, NULL, 'G3DSA:3.80.10.10:FF:000426', NULL, NULL, 'Follicle-stimulating hormone receptor-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(199290, NULL, 'G3DSA:2.130.10.10:FF:002725', NULL, NULL, 'YALI0E01276p', NULL, NULL, NULL, NULL, NULL, 4),
(199291, NULL, 'G3DSA:2.20.100.10:FF:000251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199292, NULL, 'G3DSA:3.30.300.320:FF:000003', NULL, NULL, 'Pappalysin 1', NULL, NULL, NULL, NULL, NULL, 4),
(199293, NULL, 'G3DSA:2.60.40.1110:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(199294, NULL, 'G3DSA:1.20.5.4010:FF:000004', NULL, NULL, 'Held out wings-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(199295, NULL, 'G3DSA:1.25.40.20:FF:001272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199296, NULL, 'G3DSA:2.30.30.40:FF:000683', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199297, NULL, 'G3DSA:1.25.40.10:FF:004646', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199298, NULL, 'G3DSA:3.30.70.330:FF:000447', NULL, NULL, 'Activator of basal transcription 1', NULL, NULL, NULL, NULL, NULL, 4),
(199299, NULL, 'G3DSA:3.50.50.60:FF:000900', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(199300, NULL, 'G3DSA:2.60.40.10:FF:005327', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199301, NULL, 'G3DSA:2.60.40.10:FF:001550', NULL, NULL, 'immunoglobulin superfamily member 22', NULL, NULL, NULL, NULL, NULL, 4),
(199302, NULL, 'G3DSA:3.40.50.300:FF:005075', NULL, NULL, 'Blr1666 protein', NULL, NULL, NULL, NULL, NULL, 4),
(199303, NULL, 'G3DSA:2.60.120.260:FF:000297', NULL, NULL, 'Ephrin receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(199304, NULL, 'G3DSA:2.60.120.200:FF:000650', NULL, NULL, 'Novel protein similar to human EGF LAG seven-pass G-type receptor 1 cadherin (CELSR1)', NULL, NULL, NULL, NULL, NULL, 4),
(199305, NULL, 'G3DSA:3.40.50.1820:FF:000432', NULL, NULL, 'Probable lignin peroxidase lipJ', NULL, NULL, NULL, NULL, NULL, 4),
(199306, NULL, 'G3DSA:1.10.1040.10:FF:000048', NULL, NULL, 'Putative 2-hydroxy-3-oxopropionate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(199307, NULL, 'G3DSA:3.30.70.1730:FF:000019', NULL, NULL, '50S ribosomal protein L10', NULL, NULL, NULL, NULL, NULL, 4),
(199308, NULL, 'G3DSA:3.80.10.10:FF:002063', NULL, NULL, 'Disease resistance protein RGA4', NULL, NULL, NULL, NULL, NULL, 4),
(199309, NULL, 'G3DSA:3.40.47.10:FF:000305', NULL, NULL, 'Polyketide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(199310, NULL, 'G3DSA:2.130.10.10:FF:005018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199311, NULL, 'G3DSA:1.10.510.10:FF:001165', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(199312, NULL, 'G3DSA:3.30.70.1990:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199313, NULL, 'G3DSA:3.10.450.50:FF:000068', NULL, NULL, 'Ras-Gtpase-activating protein SH3 (Three) domain-Binding Protein', NULL, NULL, NULL, NULL, NULL, 4),
(199314, NULL, 'G3DSA:1.20.120.1630:FF:000023', NULL, NULL, 'Phosphatidylethanolaminen-methyltransferase-lik e protein', NULL, NULL, NULL, NULL, NULL, 4),
(199315, NULL, 'G3DSA:2.60.40.840:FF:000001', NULL, NULL, 'beta-arrestin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(199316, NULL, 'G3DSA:3.50.50.60:FF:000389', NULL, NULL, '2-octaprenyl-6-methoxyphenyl hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(199317, NULL, 'G3DSA:2.10.110.10:FF:000304', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199318, NULL, 'G3DSA:3.30.430.20:FF:000031', NULL, NULL, 'Putative serine/threonine-specific protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(199319, NULL, 'G3DSA:3.30.1370.10:FF:000213', NULL, NULL, 'AGAP004351-PA', NULL, NULL, NULL, NULL, NULL, 4),
(199320, NULL, 'G3DSA:3.30.70.260:FF:000061', NULL, NULL, 'ACT domain repeat 1', NULL, NULL, NULL, NULL, NULL, 4),
(199321, NULL, 'G3DSA:3.30.200.20:FF:000547', NULL, NULL, 'Serine/threonine-protein kinase prk-2', NULL, NULL, NULL, NULL, NULL, 4),
(199322, NULL, 'G3DSA:3.90.226.10:FF:000197', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(199323, NULL, 'G3DSA:3.30.1370.10:FF:000157', NULL, NULL, 'KH homology domain-containing protein 1C', NULL, NULL, NULL, NULL, NULL, 4),
(199324, NULL, 'G3DSA:1.10.760.10:FF:000082', NULL, NULL, 'L-cysteine S-thiosulfotransferase subunit SoxA', NULL, NULL, NULL, NULL, NULL, 4),
(199325, NULL, 'G3DSA:1.10.8.100:FF:000004', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(199326, NULL, 'G3DSA:1.10.510.10:FF:000889', NULL, NULL, 'Calmodulin-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(199327, NULL, 'G3DSA:3.30.160.60:FF:005254', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199328, NULL, 'G3DSA:1.25.40.10:FF:000993', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(199329, NULL, 'G3DSA:2.60.40.10:FF:003641', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199330, NULL, 'G3DSA:1.20.920.60:FF:000005', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199331, NULL, 'G3DSA:3.40.47.10:FF:000249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199332, NULL, 'G3DSA:2.70.98.40:FF:000005', NULL, NULL, 'Cellobiose phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(199333, NULL, 'G3DSA:3.80.10.10:FF:001787', NULL, NULL, 'Leucine-rich HEV glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(199334, NULL, 'G3DSA:1.10.510.10:FF:003295', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199335, NULL, 'G3DSA:3.50.50.60:FF:001007', NULL, NULL, 'Rab proteins geranylgeranyltransferase component A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199336, NULL, 'G3DSA:2.40.30.170:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199337, NULL, 'G3DSA:1.20.1540.10:FF:000028', NULL, NULL, 'Peptidase, S54 family', NULL, NULL, NULL, NULL, NULL, 4),
(199338, NULL, 'G3DSA:1.10.540.10:FF:000099', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(199339, NULL, 'G3DSA:3.30.930.10:FF:000116', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(199340, NULL, 'G3DSA:2.30.42.10:FF:000241', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 9', NULL, NULL, NULL, NULL, NULL, 4),
(199341, NULL, 'G3DSA:1.10.10.10:FF:001710', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(199342, NULL, 'G3DSA:1.10.238.10:FF:001245', NULL, NULL, 'CPK5 (Calmodulin-domain protein kinase 5)', NULL, NULL, NULL, NULL, NULL, 4),
(199343, NULL, 'G3DSA:3.30.70.330:FF:000560', NULL, NULL, 'RNA-binding protein Musashi homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(199344, NULL, 'G3DSA:3.40.850.10:FF:000411', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(199345, NULL, 'G3DSA:2.60.40.10:FF:005440', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199346, NULL, 'G3DSA:3.30.160.60:FF:005215', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199347, NULL, 'G3DSA:1.25.40.10:FF:002792', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199348, NULL, 'G3DSA:2.10.50.10:FF:000125', NULL, NULL, 'signal peptide, CUB and EGF-like domain-containing protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(199349, NULL, 'G3DSA:3.30.750.24:FF:000054', NULL, NULL, 'Anti-sigma F factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(199350, NULL, 'G3DSA:1.20.1080.10:FF:000043', NULL, NULL, 'Aquaporin SIP1-1', NULL, NULL, NULL, NULL, NULL, 4),
(199351, NULL, 'G3DSA:3.30.160.60:FF:001269', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(199352, NULL, 'G3DSA:3.40.50.300:FF:004816', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199353, NULL, 'G3DSA:3.75.10.10:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199354, NULL, 'G3DSA:1.10.220.150:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199355, NULL, 'G3DSA:3.80.10.10:FF:001843', NULL, NULL, 'Leucine rich repeat containing 8 VRAC subunit E', NULL, NULL, NULL, NULL, NULL, 4),
(199356, NULL, 'G3DSA:1.10.510.10:FF:000945', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199357, NULL, 'G3DSA:3.20.20.140:FF:000012', NULL, NULL, 'PHP domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(199358, NULL, 'G3DSA:3.40.50.1970:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199359, NULL, 'G3DSA:3.30.70.270:FF:000064', NULL, NULL, 'Diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(199360, NULL, 'G3DSA:2.20.110.10:FF:000021', NULL, NULL, 'Histone H3 K4-specific methyltransferase SET7/9 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(199361, NULL, 'G3DSA:3.90.1280.20:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199362, NULL, 'G3DSA:1.10.472.10:FF:000558', NULL, NULL, 'Meiosis-specific cyclin crs1', NULL, NULL, NULL, NULL, NULL, 4),
(199363, NULL, 'G3DSA:2.40.100.10:FF:000095', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(199364, NULL, 'G3DSA:1.10.238.10:FF:000969', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199365, NULL, 'G3DSA:3.40.1390.30:FF:000021', NULL, NULL, 'GTP cyclohydrolase 1 type 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(199366, NULL, 'G3DSA:3.30.40.10:FF:002325', NULL, NULL, 'E3 ubiquitin-protein ligase SHPRH-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(199367, NULL, 'G3DSA:3.40.140.100:FF:000010', NULL, NULL, 'Autophagy-related protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(199368, NULL, 'G3DSA:3.30.420.40:FF:000536', NULL, NULL, 'Os01g0604600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(199369, NULL, 'G3DSA:3.30.559.10:FF:000056', NULL, NULL, 'Vibriobactin synthetase, amide synthase subunit VibH', NULL, NULL, NULL, NULL, NULL, 4),
(199370, NULL, 'G3DSA:2.20.25.350:FF:000003', NULL, NULL, 'Eukaryotic translation initiation factor 5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199371, NULL, 'G3DSA:3.30.40.10:FF:002364', NULL, NULL, 'Probable ubiquitin carboxyl-terminal hydrolase 8', NULL, NULL, NULL, NULL, NULL, 4),
(199372, NULL, 'G3DSA:3.30.1330.90:FF:000021', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(199373, NULL, 'G3DSA:3.30.200.20:FF:002346', NULL, NULL, 'AGAP011988-PA', NULL, NULL, NULL, NULL, NULL, 4),
(199374, NULL, 'G3DSA:3.40.190.10:FF:000057', NULL, NULL, 'Phosphate-binding protein PstS', NULL, NULL, NULL, NULL, NULL, 4),
(199375, NULL, 'G3DSA:2.20.100.10:FF:000071', NULL, NULL, 'ADAMTS like 4', NULL, NULL, NULL, NULL, NULL, 4),
(199376, NULL, 'G3DSA:3.40.50.1010:FF:000110', NULL, NULL, 'Phoh', NULL, NULL, NULL, NULL, NULL, 4),
(199377, NULL, 'G3DSA:3.30.2350.10:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199378, NULL, 'G3DSA:3.30.720.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199379, NULL, 'G3DSA:3.90.360.10:FF:000019', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(199380, NULL, 'G3DSA:1.25.40.180:FF:000090', NULL, NULL, 'eIF5-mimic protein', NULL, NULL, NULL, NULL, NULL, 4),
(199381, NULL, 'G3DSA:2.60.120.260:FF:000640', NULL, NULL, 'CUB domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(199382, NULL, 'G3DSA:1.10.268.20:FF:000002', NULL, NULL, 'Sarcalumenin', NULL, NULL, NULL, NULL, NULL, 4),
(199383, NULL, 'G3DSA:2.120.10.80:FF:000195', NULL, NULL, 'Kelch domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(199384, NULL, 'G3DSA:3.30.200.20:FF:001222', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(199385, NULL, 'G3DSA:3.60.20.10:FF:000147', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199386, NULL, 'G3DSA:3.30.160.60:FF:001943', NULL, NULL, 'Zinc finger protein 23', NULL, NULL, NULL, NULL, NULL, 4),
(199387, NULL, 'G3DSA:3.30.450.20:FF:000425', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(199388, NULL, 'G3DSA:1.10.1300.10:FF:000092', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(199389, NULL, 'G3DSA:3.50.50.60:FF:001120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199390, NULL, 'G3DSA:1.20.1540.10:FF:000067', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199391, NULL, 'G3DSA:3.30.70.330:FF:002690', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199392, NULL, 'G3DSA:2.130.10.10:FF:005417', NULL, NULL, 'Probable serine/threonine-protein kinase ireA', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(199393, NULL, 'G3DSA:1.20.1050.130:FF:000012', NULL, NULL, 'Glutathione S-transferase gliG', NULL, NULL, NULL, NULL, NULL, 4),
(199394, NULL, 'G3DSA:2.60.40.420:FF:000050', NULL, NULL, 'coagulation factor V isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(199395, NULL, 'G3DSA:1.10.10.60:FF:000859', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199396, NULL, 'G3DSA:3.40.50.150:FF:000859', NULL, NULL, 'tRNA/rRNA cytosine-C5-methylase', NULL, NULL, NULL, NULL, NULL, 4),
(199397, NULL, 'G3DSA:3.40.50.2000:FF:000722', NULL, NULL, 'Glycosyl transferase group 1', NULL, NULL, NULL, NULL, NULL, 4),
(199398, NULL, 'G3DSA:3.60.20.10:FF:000260', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199399, NULL, 'G3DSA:2.40.10.10:FF:000493', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199400, NULL, 'G3DSA:3.60.20.10:FF:000203', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199401, NULL, 'G3DSA:3.30.420.40:FF:001087', NULL, NULL, 'Glycerol kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199402, NULL, 'G3DSA:3.30.450.60:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199403, NULL, 'G3DSA:1.10.287.470:FF:000012', NULL, NULL, 'Efflux transporter, RND family, MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(199404, NULL, 'G3DSA:1.10.490.160:FF:000002', NULL, NULL, 'Ryanodine receptor 1 (skeletal)', NULL, NULL, NULL, NULL, NULL, 4),
(199405, NULL, 'G3DSA:3.40.50.80:FF:000070', NULL, NULL, 'NADH-cytochrome b5 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(199406, NULL, 'G3DSA:3.30.2230.10:FF:000001', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(199407, NULL, 'G3DSA:1.25.40.330:FF:000005', NULL, NULL, 'Adenylyl cyclase-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(199408, NULL, 'G3DSA:1.10.10.60:FF:001135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199409, NULL, 'G3DSA:3.20.110.10:FF:000040', NULL, NULL, 'Mannosidase, alpha, class 2B, member 1', NULL, NULL, NULL, NULL, NULL, 4),
(199410, NULL, 'G3DSA:3.30.70.20:FF:000065', NULL, NULL, 'Reductive dehalogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199411, NULL, 'G3DSA:3.40.50.1820:FF:000089', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(199412, NULL, 'G3DSA:3.90.70.10:FF:000789', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199413, NULL, 'G3DSA:3.30.160.60:FF:004939', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199414, NULL, 'G3DSA:2.60.120.290:FF:000126', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199415, NULL, 'G3DSA:1.10.287.110:FF:000394', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199416, NULL, 'G3DSA:2.130.10.10:FF:001146', NULL, NULL, 'Dmx like 1', NULL, NULL, NULL, NULL, NULL, 4),
(199417, NULL, 'G3DSA:2.40.37.10:FF:000026', NULL, NULL, 'Alanine racemase', NULL, NULL, NULL, NULL, NULL, 4),
(199418, NULL, 'G3DSA:3.60.10.10:FF:000321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199419, NULL, 'G3DSA:1.20.1070.10:FF:000104', NULL, NULL, 'Opsin 5', NULL, NULL, NULL, NULL, NULL, 4),
(199420, NULL, 'G3DSA:2.40.50.40:FF:000032', NULL, NULL, 'protein CHROMATIN REMODELING 5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(199421, NULL, 'G3DSA:1.25.10.10:FF:001328', NULL, NULL, 'Coatomer beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(199422, NULL, 'G3DSA:1.20.1560.10:FF:000810', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199423, NULL, 'G3DSA:2.60.120.10:FF:000102', NULL, NULL, 'Cupin, RmlC-type', NULL, NULL, NULL, NULL, NULL, 4),
(199424, NULL, 'G3DSA:3.40.50.10140:FF:000021', NULL, NULL, 'Toll receptor 13', NULL, NULL, NULL, NULL, NULL, 4),
(199425, NULL, 'G3DSA:3.10.280.10:FF:000020', NULL, NULL, 'Mitochondrial matrix acidic protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199426, NULL, 'G3DSA:1.20.5.460:FF:000003', NULL, NULL, 'Death-associated protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(199427, NULL, 'G3DSA:3.60.15.10:FF:000017', NULL, NULL, 'Lactamase beta 2', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(199428, NULL, 'G3DSA:1.25.40.340:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199429, NULL, 'G3DSA:1.10.510.10:FF:002744', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199430, NULL, 'G3DSA:3.30.390.140:FF:000001', NULL, NULL, 'Ribosomal protein PSRP-3/Ycf65', NULL, NULL, NULL, NULL, NULL, 4),
(199431, NULL, 'G3DSA:3.30.160.60:FF:001382', NULL, NULL, 'Transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(199432, NULL, 'G3DSA:2.130.10.10:FF:003276', NULL, NULL, 'Protein HIRA', NULL, NULL, NULL, NULL, NULL, 4),
(199433, NULL, 'G3DSA:1.25.40.10:FF:003011', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(199434, NULL, 'G3DSA:1.10.1300.10:FF:000035', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(199435, NULL, 'G3DSA:1.10.10.60:FF:000972', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199436, NULL, 'G3DSA:3.30.160.60:FF:004198', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199437, NULL, 'G3DSA:2.130.10.10:FF:001202', NULL, NULL, 'CTF4p Chromatin-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(199438, NULL, 'G3DSA:2.40.128.330:FF:000013', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199439, NULL, 'G3DSA:2.60.40.10:FF:005041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199440, NULL, 'G3DSA:3.30.465.10:FF:000057', NULL, NULL, 'Hemolysin C', NULL, NULL, NULL, NULL, NULL, 4),
(199441, NULL, 'G3DSA:2.20.100.10:FF:000138', NULL, NULL, 'No long nerve cord, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(199442, NULL, 'G3DSA:1.25.40.180:FF:000213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199443, NULL, 'G3DSA:3.40.50.150:FF:000050', NULL, NULL, 'Hnrnp arginine n-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(199444, NULL, 'G3DSA:1.20.1560.10:FF:000355', NULL, NULL, 'Putative ATP-binding cassette protein subfamily B,member 1', NULL, NULL, NULL, NULL, NULL, 4),
(199445, NULL, 'G3DSA:1.10.287.10:FF:000032', NULL, NULL, 'CTD phosphatase-related (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(199446, NULL, 'G3DSA:2.60.40.60:FF:000879', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199447, NULL, 'G3DSA:3.40.50.2300:FF:000694', NULL, NULL, 'Development and carotenogenesis control-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(199448, NULL, 'G3DSA:2.130.10.10:FF:000926', NULL, NULL, 'U3 small nucleolar RNA-associated protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(199449, NULL, 'G3DSA:1.25.40.320:FF:000002', NULL, NULL, 'Leukotriene A(4) hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(199450, NULL, 'G3DSA:1.20.1050.10:FF:000215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199451, NULL, 'G3DSA:2.120.10.30:FF:000551', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199452, NULL, 'G3DSA:3.10.450.40:FF:000008', NULL, NULL, 'Protein DCL, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(199453, NULL, 'G3DSA:1.25.10.10:FF:001441', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(199454, NULL, 'G3DSA:3.50.50.60:FF:000844', NULL, NULL, 'Protein containing FAD dependent oxidoreductase domain', NULL, NULL, NULL, NULL, NULL, 4),
(199455, NULL, 'G3DSA:3.30.160.60:FF:005653', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199456, NULL, 'G3DSA:1.20.900.10:FF:000130', NULL, NULL, 'Rho GTPase regulating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199457, NULL, 'G3DSA:2.170.130.10:FF:000077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199458, NULL, 'G3DSA:2.90.10.30:FF:000007', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(199459, NULL, 'G3DSA:2.130.10.10:FF:004855', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199460, NULL, 'G3DSA:3.50.30.30:FF:000053', NULL, NULL, 'LOC100135083 protein', NULL, NULL, NULL, NULL, NULL, 4),
(199461, NULL, 'G3DSA:3.30.70.330:FF:002358', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199462, NULL, 'G3DSA:3.80.20.20:FF:000037', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(199463, NULL, 'G3DSA:1.10.510.10:FF:001726', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199464, NULL, 'G3DSA:1.25.40.20:FF:001159', NULL, NULL, 'E3 ubiquitin-protein ligase mib1', NULL, NULL, NULL, NULL, NULL, 4),
(199465, NULL, 'G3DSA:2.10.25.10:FF:001742', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199466, NULL, 'G3DSA:1.25.40.10:FF:001156', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g61800', NULL, NULL, NULL, NULL, NULL, 4),
(199467, NULL, 'G3DSA:3.40.50.300:FF:001601', NULL, NULL, 'ABC multidrug transporter', NULL, NULL, NULL, NULL, NULL, 4),
(199468, NULL, 'G3DSA:1.10.8.60:FF:000083', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(199469, NULL, 'G3DSA:1.20.58.1220:FF:000015', NULL, NULL, 'Exocyst complex component EXO84', NULL, NULL, NULL, NULL, NULL, 4),
(199470, NULL, 'G3DSA:2.60.40.10:FF:000836', NULL, NULL, 'Neuronal cell adhesion molecule', NULL, NULL, NULL, NULL, NULL, 4),
(199471, NULL, 'G3DSA:3.40.50.10930:FF:000005', NULL, NULL, 'RecBCD enzyme subunit RecC', NULL, NULL, NULL, NULL, NULL, 4),
(199472, NULL, 'G3DSA:3.80.10.10:FF:002282', NULL, NULL, 'Leucine-rich repeat-containing protein 43', NULL, NULL, NULL, NULL, NULL, 4),
(199473, NULL, 'G3DSA:2.130.10.10:FF:004693', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199474, NULL, 'G3DSA:2.30.40.10:FF:000130', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase (GlcNAc 6-P deacetylase)', NULL, NULL, NULL, NULL, NULL, 4),
(199475, NULL, 'G3DSA:3.40.50.2000:FF:000542', NULL, NULL, 'Sucrose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(199476, NULL, 'G3DSA:2.130.10.10:FF:001421', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(199477, NULL, 'G3DSA:2.40.70.10:FF:000378', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199478, NULL, 'G3DSA:3.40.50.300:FF:001326', NULL, NULL, 'Putative ATP-dependent RNA helicase DHX35', NULL, NULL, NULL, NULL, NULL, 4),
(199479, NULL, 'G3DSA:1.10.10.1320:FF:000008', NULL, NULL, 'Anti-sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(199480, NULL, 'G3DSA:2.60.40.10:FF:003528', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199481, NULL, 'G3DSA:1.25.10.10:FF:001109', NULL, NULL, 'TATA-binding protein-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(199482, NULL, 'G3DSA:3.40.50.720:FF:001952', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199483, NULL, 'G3DSA:1.20.1720.10:FF:000014', NULL, NULL, 'MFS drug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199484, NULL, 'G3DSA:3.80.10.10:FF:002006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199485, NULL, 'G3DSA:3.30.40.10:FF:001869', NULL, NULL, 'RING finger protein 141-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(199486, NULL, 'G3DSA:3.30.200.20:FF:001042', NULL, NULL, 'Myosin heavy chain kinase B', NULL, NULL, NULL, NULL, NULL, 4),
(199487, NULL, 'G3DSA:2.60.40.10:FF:004546', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199488, NULL, 'G3DSA:3.80.10.10:FF:002624', NULL, NULL, 'Protein CBG02386', NULL, NULL, NULL, NULL, NULL, 4),
(199489, NULL, 'G3DSA:3.30.160.60:FF:001325', NULL, NULL, 'zinc finger protein 200', NULL, NULL, NULL, NULL, NULL, 4),
(199490, NULL, 'G3DSA:3.10.580.10:FF:000060', NULL, NULL, 'mRNA, clone: RTFL01-01-J02', NULL, NULL, NULL, NULL, NULL, 4),
(199491, NULL, 'G3DSA:3.40.50.720:FF:000934', NULL, NULL, 'Short chain dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(199492, NULL, 'G3DSA:2.60.40.10:FF:001112', NULL, NULL, 'probable beta-D-xylosidase 7', NULL, NULL, NULL, NULL, NULL, 4),
(199493, NULL, 'G3DSA:1.10.150.20:FF:000055', NULL, NULL, 'Mating-type switch/DNA repair protein Swi10/Rad10', NULL, NULL, NULL, NULL, NULL, 4),
(199494, NULL, 'G3DSA:3.40.50.2300:FF:000637', NULL, NULL, 'Glutamate receptor IIC', NULL, NULL, NULL, NULL, NULL, 4),
(199495, NULL, 'G3DSA:3.40.1800.30:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(199496, NULL, 'G3DSA:3.30.70.3270:FF:000021', NULL, NULL, 'NADH:ubiquinone oxidoreductase core subunit S8', NULL, NULL, NULL, NULL, NULL, 4),
(199497, NULL, 'G3DSA:2.130.10.10:FF:005131', NULL, NULL, 'Intraflagellar transport protein 122 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(199498, NULL, 'G3DSA:3.30.460.10:FF:000029', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(199499, NULL, 'G3DSA:1.10.10.60:FF:000915', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199500, NULL, 'G3DSA:2.130.10.10:FF:000983', NULL, NULL, 'rRNA processing protein Pwp1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199501, NULL, 'G3DSA:1.20.1260.60:FF:000015', NULL, NULL, 'IST1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(199502, NULL, 'G3DSA:1.25.40.10:FF:002516', NULL, NULL, 'Two-component signal transduction', NULL, NULL, NULL, NULL, NULL, 4),
(199503, NULL, 'G3DSA:1.10.287.130:FF:000096', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(199504, NULL, 'G3DSA:3.10.20.90:FF:000499', NULL, NULL, 'WGS project CABT00000000 data, contig 2.1', NULL, NULL, NULL, NULL, NULL, 4),
(199505, NULL, 'G3DSA:3.90.660.10:FF:000059', NULL, NULL, 'SWIRM domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(199506, NULL, 'G3DSA:2.30.29.30:FF:000334', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(199507, NULL, 'G3DSA:3.10.580.10:FF:000003', NULL, NULL, 'Protein kinase AMP-activated non-catalytic subunit gamma 1', NULL, NULL, NULL, NULL, NULL, 4),
(199508, NULL, 'G3DSA:3.40.50.720:FF:000535', NULL, NULL, 'Hydroxy-delta-5-steroid dehydrogenase, 3 beta- and steroid delta-isomerase 7', NULL, NULL, NULL, NULL, NULL, 4),
(199509, NULL, 'G3DSA:3.40.190.10:FF:000675', NULL, NULL, 'Uncharacterized solute-binding protein VNG_1595C', NULL, NULL, NULL, NULL, NULL, 4),
(199510, NULL, 'G3DSA:1.20.120.720:FF:000035', NULL, NULL, 'Unconventional myosin-XIX', NULL, NULL, NULL, NULL, NULL, 4),
(199511, NULL, 'G3DSA:3.30.160.60:FF:004759', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199512, NULL, 'G3DSA:3.40.50.720:FF:000592', NULL, NULL, 'Similar to saccharopine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(199513, NULL, 'G3DSA:1.20.1560.10:FF:000630', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199514, NULL, 'G3DSA:3.90.550.10:FF:000467', NULL, NULL, 'Sugar transferase-putative a glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(199515, NULL, 'G3DSA:2.10.90.10:FF:000122', NULL, NULL, 'Prepro-neurotrophin', NULL, NULL, NULL, NULL, NULL, 4),
(199516, NULL, 'G3DSA:3.90.79.10:FF:000096', NULL, NULL, 'Isopentenyl-diphosphate Delta-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(199517, NULL, 'G3DSA:2.130.10.10:FF:004294', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199518, NULL, 'G3DSA:3.20.20.300:FF:000083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199519, NULL, 'G3DSA:3.40.50.1820:FF:001668', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(199520, NULL, 'G3DSA:3.30.1490.190:FF:000025', NULL, NULL, 'Fe2+/Zn2+ uptake regulation proteins', NULL, NULL, NULL, NULL, NULL, 4),
(199521, NULL, 'G3DSA:1.10.287.2920:FF:000001', NULL, NULL, 'RNA polymerase II holoenzyme complex component', NULL, NULL, NULL, NULL, NULL, 4),
(199522, NULL, 'G3DSA:3.30.310.80:FF:000023', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(199523, NULL, 'G3DSA:1.10.510.10:FF:001108', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199524, NULL, 'G3DSA:3.20.20.300:FF:000026', NULL, NULL, 'Glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(199525, NULL, 'G3DSA:3.40.1110.10:FF:000214', NULL, NULL, 'Copper resistance-associated P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(199526, NULL, 'G3DSA:3.40.190.10:FF:000618', NULL, NULL, 'Sll0540 protein', NULL, NULL, NULL, NULL, NULL, 4),
(199527, NULL, 'G3DSA:3.10.580.20:FF:000006', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(199528, NULL, 'G3DSA:3.10.180.10:FF:000035', NULL, NULL, 'Glyoxalase I', NULL, NULL, NULL, NULL, NULL, 4),
(199529, NULL, 'G3DSA:2.130.10.10:FF:001820', NULL, NULL, 'Yeast SEC homolog', NULL, NULL, NULL, NULL, NULL, 4),
(199530, NULL, 'G3DSA:3.60.120.10:FF:000008', NULL, NULL, 'Anthranilate synthase component 1', NULL, NULL, NULL, NULL, NULL, 4),
(199531, NULL, 'G3DSA:3.30.160.60:FF:005035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199532, NULL, 'G3DSA:3.30.60.90:FF:000040', NULL, NULL, 'Ring finger domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(199533, NULL, 'G3DSA:3.30.565.10:FF:000565', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199534, NULL, 'G3DSA:3.30.200.20:FF:000766', NULL, NULL, 'AGC/NDR protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(199535, NULL, 'G3DSA:1.10.472.10:FF:000614', NULL, NULL, 'D-type cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(199536, NULL, 'G3DSA:1.20.58.60:FF:000800', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199537, NULL, 'G3DSA:3.20.20.70:FF:000032', NULL, NULL, 'Homocitrate synthase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(199538, NULL, 'G3DSA:1.25.40.10:FF:000919', NULL, NULL, 'HAT1-interacting factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(199539, NULL, 'G3DSA:3.40.50.300:FF:006834', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199540, NULL, 'G3DSA:1.25.40.20:FF:001384', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199541, NULL, 'G3DSA:1.25.10.10:FF:002981', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199542, NULL, 'G3DSA:1.25.40.10:FF:001381', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g50270', NULL, NULL, NULL, NULL, NULL, 4),
(199543, NULL, 'G3DSA:3.80.10.10:FF:002181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199544, NULL, 'G3DSA:3.30.70.100:FF:000120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199545, NULL, 'G3DSA:3.30.160.60:FF:003192', NULL, NULL, 'ZNF101 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(199546, NULL, 'G3DSA:1.25.40.20:FF:001428', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199547, NULL, 'G3DSA:3.90.1600.10:FF:000049', NULL, NULL, 'DNA polymerase Pol2', NULL, NULL, NULL, NULL, NULL, 4),
(199548, NULL, 'G3DSA:2.70.98.10:FF:000126', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199549, NULL, 'G3DSA:2.20.100.10:FF:000054', NULL, NULL, 'ADAMTS-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(199550, NULL, 'G3DSA:3.30.160.20:FF:000105', NULL, NULL, 'YOL114C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(199551, NULL, 'G3DSA:3.30.1520.10:FF:000023', NULL, NULL, 'Neutrophil cytosol factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(199552, NULL, 'G3DSA:3.40.50.1000:FF:000658', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199553, NULL, 'G3DSA:1.20.1250.20:FF:000048', NULL, NULL, 'High affinity nitrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(199554, NULL, 'G3DSA:3.80.10.10:FF:000617', NULL, NULL, 'Leucine-rich repeat and calponin homology domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(199555, NULL, 'G3DSA:1.25.40.10:FF:002483', NULL, NULL, 'Os07g0635800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(199556, NULL, 'G3DSA:1.10.472.30:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199557, NULL, 'G3DSA:3.40.50.10190:FF:000210', NULL, NULL, 'YALI0D12364p', NULL, NULL, NULL, NULL, NULL, 4),
(199558, NULL, 'G3DSA:1.10.238.10:FF:001065', NULL, NULL, 'Calcium-binding protein CML38', NULL, NULL, NULL, NULL, NULL, 4),
(199559, NULL, 'G3DSA:1.10.3470.10:FF:000019', NULL, NULL, 'Iron-compound ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(199560, NULL, 'G3DSA:3.30.1490.100:FF:000049', NULL, NULL, 'DNA repair protein REV1', NULL, NULL, NULL, NULL, NULL, 4),
(199561, NULL, 'G3DSA:3.20.20.80:FF:000035', NULL, NULL, 'Mannosidase beta', NULL, NULL, NULL, NULL, NULL, 4),
(199562, NULL, 'G3DSA:3.30.160.60:FF:001628', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(199563, NULL, 'G3DSA:1.10.640.10:FF:000084', NULL, NULL, 'Oxidase/peroxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199564, NULL, 'G3DSA:3.30.160.100:FF:000005', NULL, NULL, 'Ribosomal subunit interface protein', NULL, NULL, NULL, NULL, NULL, 4),
(199565, NULL, 'G3DSA:2.60.120.200:FF:000414', NULL, NULL, 'cadherin EGF LAG seven-pass G-type receptor 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(199566, NULL, 'G3DSA:1.25.40.10:FF:004618', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199567, NULL, 'G3DSA:3.40.50.80:FF:000053', NULL, NULL, 'NADH-cytochrome b5 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(199568, NULL, 'G3DSA:3.30.160.60:FF:000010', NULL, NULL, 'Zinc finger protein 34', NULL, NULL, NULL, NULL, NULL, 4),
(199569, NULL, 'G3DSA:1.20.1560.10:FF:000501', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199570, NULL, 'G3DSA:3.40.47.10:FF:000069', NULL, NULL, 'Acetyl-CoA C-acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199571, NULL, 'G3DSA:3.30.710.10:FF:000257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199572, NULL, 'G3DSA:4.10.240.10:FF:000053', NULL, NULL, 'C6 transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199573, NULL, 'G3DSA:3.100.10.10:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199574, NULL, 'G3DSA:3.40.50.150:FF:001157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199575, NULL, 'G3DSA:2.40.70.10:FF:000474', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199576, NULL, 'G3DSA:3.90.226.10:FF:000085', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(199577, NULL, 'G3DSA:3.40.50.620:FF:000360', NULL, NULL, 'Isoleucyl-tRNA synthetase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(199578, NULL, 'G3DSA:1.20.1250.10:FF:000045', NULL, NULL, 'Interferon C', NULL, NULL, NULL, NULL, NULL, 4),
(199579, NULL, 'G3DSA:1.20.90.10:FF:000017', NULL, NULL, 'Phospholipase A(2)', NULL, NULL, NULL, NULL, NULL, 4),
(199580, NULL, 'G3DSA:3.40.50.2300:FF:000519', NULL, NULL, 'Vomeronasal 2 receptor, a18', NULL, NULL, NULL, NULL, NULL, 4),
(199581, NULL, 'G3DSA:3.30.420.10:FF:000510', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199582, NULL, 'G3DSA:3.40.850.10:FF:000052', NULL, NULL, 'Kinesin-like protein KIN-12F', NULL, NULL, NULL, NULL, NULL, 4),
(199583, NULL, 'G3DSA:3.40.50.300:FF:005732', NULL, NULL, 'Disease resistance protein CHS1', NULL, NULL, NULL, NULL, NULL, 4),
(199584, NULL, 'G3DSA:3.80.10.10:FF:002225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199585, NULL, 'G3DSA:1.10.10.10:FF:001401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199586, NULL, 'G3DSA:1.20.1200.10:FF:000008', NULL, NULL, 'ATP-cobalamin adenosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(199587, NULL, 'G3DSA:3.40.50.2300:FF:000475', NULL, NULL, 'Olfactory receptor C family, g2', NULL, NULL, NULL, NULL, NULL, 4),
(199588, NULL, 'G3DSA:3.30.450.20:FF:000015', NULL, NULL, 'Hypoxia-inducible factor 1-alpha isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(199589, NULL, 'G3DSA:3.40.50.150:FF:001483', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199590, NULL, 'G3DSA:1.10.510.10:FF:001518', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(199591, NULL, 'G3DSA:1.10.10.500:FF:000004', NULL, NULL, 'Lissencephaly-1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(199592, NULL, 'G3DSA:1.10.510.10:FF:003126', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199593, NULL, 'G3DSA:1.10.8.10:FF:000242', NULL, NULL, 'Ubiquitin conjugating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(199594, NULL, 'G3DSA:3.30.40.10:FF:002117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199595, NULL, 'G3DSA:1.20.1260.10:FF:000017', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(199596, NULL, 'G3DSA:2.130.10.10:FF:002585', NULL, NULL, 'WD repeat-containing protein 44 isoform A', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(199597, NULL, 'G3DSA:2.130.10.10:FF:003091', NULL, NULL, 'Uncharacterized WD repeat-containing protein sll1491', NULL, NULL, NULL, NULL, NULL, 4),
(199598, NULL, 'G3DSA:1.25.40.10:FF:003000', NULL, NULL, 'Activator of C kinase protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(199599, NULL, 'G3DSA:3.40.50.1970:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199600, NULL, 'G3DSA:1.10.1300.10:FF:000024', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(199601, NULL, 'G3DSA:2.60.40.10:FF:003124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199602, NULL, 'G3DSA:3.80.10.10:FF:004316', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199603, NULL, 'G3DSA:1.10.238.10:FF:000885', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(199604, NULL, 'G3DSA:3.40.50.150:FF:000977', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199605, NULL, 'G3DSA:1.20.920.10:FF:000221', NULL, NULL, 'Bromodomain and WD repeat domain-containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(199606, NULL, 'G3DSA:2.40.50.140:FF:000085', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(199607, NULL, 'G3DSA:3.40.80.10:FF:000011', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(199608, NULL, 'G3DSA:1.20.120.1900:FF:000059', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(199609, NULL, 'G3DSA:3.10.10.10:FF:000008', NULL, NULL, 'Protein CBG24470', NULL, NULL, NULL, NULL, NULL, 4),
(199610, NULL, 'G3DSA:3.40.50.2300:FF:000845', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199611, NULL, 'G3DSA:1.20.1070.10:FF:000317', NULL, NULL, 'Neuropeptide FF receptor', NULL, NULL, NULL, NULL, NULL, 4),
(199612, NULL, 'G3DSA:2.120.10.80:FF:000077', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(199613, NULL, 'G3DSA:3.40.50.2000:FF:000536', NULL, NULL, 'Alphaalpha-trehalose-phosphate synthase [UDP-forming] 5', NULL, NULL, NULL, NULL, NULL, 4),
(199614, NULL, 'G3DSA:2.60.40.420:FF:000128', NULL, NULL, 'Extracellular dihydrogeodin oxidase/laccase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199615, NULL, 'G3DSA:3.40.50.1980:FF:000047', NULL, NULL, 'ABC transporter, periplasmic substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(199616, NULL, 'G3DSA:3.40.50.300:FF:008279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199617, NULL, 'G3DSA:3.10.129.10:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199618, NULL, 'G3DSA:3.40.50.720:FF:000608', NULL, NULL, 'SUMO1 activating enzyme subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(199619, NULL, 'G3DSA:3.90.180.10:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199620, NULL, 'G3DSA:1.20.1060.10:FF:000019', NULL, NULL, 'DNA polymerase theta', NULL, NULL, NULL, NULL, NULL, 4),
(199621, NULL, 'G3DSA:1.20.900.10:FF:000012', NULL, NULL, 'T cell lymphoma invasion and metastasis 1', NULL, NULL, NULL, NULL, NULL, 4),
(199622, NULL, 'G3DSA:1.10.630.10:FF:000156', NULL, NULL, 'Os06g0294600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(199623, NULL, 'G3DSA:1.20.1250.20:FF:001829', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199624, NULL, 'G3DSA:3.40.50.10240:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199625, NULL, 'G3DSA:2.60.40.60:FF:001054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199626, NULL, 'G3DSA:2.60.40.10:FF:004861', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199627, NULL, 'G3DSA:1.20.58.1880:FF:000039', NULL, NULL, 'REST corepressor 2', NULL, NULL, NULL, NULL, NULL, 4),
(199628, NULL, 'G3DSA:3.40.50.720:FF:002216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199629, NULL, 'G3DSA:2.130.10.10:FF:001157', NULL, NULL, 'Leucine-rich repeat and WD repeat-containing protein KIAA1239', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(199630, NULL, 'G3DSA:1.10.10.60:FF:001146', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199631, NULL, 'G3DSA:2.10.109.10:FF:000082', NULL, NULL, 'Mitochondrial inner membrane protease subunit', NULL, NULL, NULL, NULL, NULL, 4),
(199632, NULL, 'G3DSA:3.30.160.20:FF:000094', NULL, NULL, 'ATP-dependent RNA helicase A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199633, NULL, 'G3DSA:3.40.50.10810:FF:000256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199634, NULL, 'G3DSA:1.20.1560.10:FF:000490', NULL, NULL, 'ABC-type transporter, ATPase component and permease component', NULL, NULL, NULL, NULL, NULL, 4),
(199635, NULL, 'G3DSA:1.10.10.10:FF:000575', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(199636, NULL, 'G3DSA:1.10.10.60:FF:000792', NULL, NULL, 'Extraembryonic, spermatogenesis, homeobox 1', NULL, NULL, NULL, NULL, NULL, 4),
(199637, NULL, 'G3DSA:1.10.3450.40:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199638, NULL, 'G3DSA:2.70.160.11:FF:000031', NULL, NULL, 'Protein arginine N-methyltransferase 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199639, NULL, 'G3DSA:2.60.40.10:FF:001516', NULL, NULL, 'Signaling lymphocytic activation molecule', NULL, NULL, NULL, NULL, NULL, 4),
(199640, NULL, 'G3DSA:2.60.120.260:FF:000281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199641, NULL, 'G3DSA:2.40.50.140:FF:000764', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199642, NULL, 'G3DSA:3.40.50.1820:FF:000448', NULL, NULL, 'Protein CBG16920', NULL, NULL, NULL, NULL, NULL, 4),
(199643, NULL, 'G3DSA:3.20.20.80:FF:000361', NULL, NULL, 'Putative chitinase 2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(199644, NULL, 'G3DSA:1.20.1250.20:FF:000418', NULL, NULL, 'Folate-biopterin transporter 1, chloroplastic isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(199645, NULL, 'G3DSA:3.50.50.60:FF:001041', NULL, NULL, 'Guanosine nucleotide diphosphate dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(199646, NULL, 'G3DSA:2.120.10.80:FF:000386', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199647, NULL, 'G3DSA:1.10.287.70:FF:000353', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199648, NULL, 'G3DSA:3.40.50.11210:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199649, NULL, 'G3DSA:3.30.200.20:FF:000295', NULL, NULL, 'probable LRR receptor-like serine/threonine-protein kinase IRK', NULL, NULL, NULL, NULL, NULL, 4),
(199650, NULL, 'G3DSA:3.60.140.10:FF:000004', NULL, NULL, 'Polyphenol oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(199651, NULL, 'G3DSA:2.60.120.200:FF:000740', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199652, NULL, 'G3DSA:3.40.50.360:FF:000130', NULL, NULL, 'Uncharacterized NAD(P)H oxidoreductase HI_1544', NULL, NULL, NULL, NULL, NULL, 4),
(199653, NULL, 'G3DSA:3.90.640.10:FF:000064', NULL, NULL, 'Actin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199654, NULL, 'G3DSA:1.25.40.170:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199655, NULL, 'G3DSA:1.10.510.10:FF:001311', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(199656, NULL, 'G3DSA:1.10.10.10:FF:001390', NULL, NULL, '40S ribosomal protein S19', NULL, NULL, NULL, NULL, NULL, 4),
(199657, NULL, 'G3DSA:2.130.10.10:FF:002938', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199658, NULL, 'G3DSA:2.10.25.10:FF:000617', NULL, NULL, 'Fibulin 5', NULL, NULL, NULL, NULL, NULL, 4),
(199659, NULL, 'G3DSA:1.20.5.110:FF:000044', NULL, NULL, 'Golgi SNAP receptor complex member 2', NULL, NULL, NULL, NULL, NULL, 4),
(199660, NULL, 'G3DSA:1.25.10.10:FF:001244', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(199661, NULL, 'G3DSA:1.10.150.110:FF:000006', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(199662, NULL, 'G3DSA:3.40.50.2000:FF:000183', NULL, NULL, 'UDP-glycosyltransferase 83A1', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(199663, NULL, 'G3DSA:3.40.50.12780:FF:000009', NULL, NULL, 'Bifunctional protein Aas', NULL, NULL, NULL, NULL, NULL, 4),
(199664, NULL, 'G3DSA:2.30.30.40:FF:000565', NULL, NULL, 'C-terminal Src kinase', NULL, NULL, NULL, NULL, NULL, 4),
(199665, NULL, 'G3DSA:1.20.120.20:FF:000040', NULL, NULL, 'Apolipoprotein A-Ib', NULL, NULL, NULL, NULL, NULL, 4),
(199666, NULL, 'G3DSA:1.10.150.120:FF:000009', NULL, NULL, 'Aldehyde oxidase 6', NULL, NULL, NULL, NULL, NULL, 4),
(199667, NULL, 'G3DSA:3.80.10.10:FF:003962', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RCH1', NULL, NULL, NULL, NULL, NULL, 4),
(199668, NULL, 'G3DSA:1.25.40.20:FF:001058', NULL, NULL, 'Mitogen activated protein kinase kinase kinase 3, MAPKKK3, MEKK3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199669, NULL, 'G3DSA:1.25.10.10:FF:002655', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199670, NULL, 'G3DSA:2.10.25.10:FF:000410', NULL, NULL, 'Stabilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(199671, NULL, 'G3DSA:1.25.10.10:FF:001553', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199672, NULL, 'G3DSA:3.40.50.300:FF:002782', NULL, NULL, 'Si:dkey-110g7.8', NULL, NULL, NULL, NULL, NULL, 4),
(199673, NULL, 'G3DSA:3.40.50.300:FF:004889', NULL, NULL, 'Ras family protein', NULL, NULL, NULL, NULL, NULL, 4),
(199674, NULL, 'G3DSA:1.25.40.10:FF:001055', NULL, NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(199675, NULL, 'G3DSA:3.20.20.150:FF:000054', NULL, NULL, 'Hydroxypyruvate isomerase (putative)', NULL, NULL, NULL, NULL, NULL, 4),
(199676, NULL, 'G3DSA:3.60.20.10:FF:000181', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199677, NULL, 'G3DSA:3.30.40.10:FF:000189', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(199678, NULL, 'G3DSA:1.10.472.10:FF:000592', NULL, NULL, 'Cyclin G2', NULL, NULL, NULL, NULL, NULL, 4),
(199679, NULL, 'G3DSA:3.30.300.30:FF:000086', NULL, NULL, 'Peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(199680, NULL, 'G3DSA:3.40.50.880:FF:000196', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199681, NULL, 'G3DSA:1.10.287.3490:FF:000003', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 11', NULL, NULL, NULL, NULL, NULL, 4),
(199682, NULL, 'G3DSA:3.90.640.10:FF:000108', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(199683, NULL, 'G3DSA:3.40.50.300:FF:005053', NULL, NULL, 'Os03g0121901 protein', NULL, NULL, NULL, NULL, NULL, 4),
(199684, NULL, 'G3DSA:3.40.220.10:FF:000021', NULL, NULL, 'RNase III inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(199685, NULL, 'G3DSA:2.10.25.10:FF:000101', NULL, NULL, 'Laminin subunit beta 1', NULL, NULL, NULL, NULL, NULL, 4),
(199686, NULL, 'G3DSA:2.60.40.10:FF:001179', NULL, NULL, 'Sallimus, isoform Q', NULL, NULL, NULL, NULL, NULL, 4),
(199687, NULL, 'G3DSA:1.20.1280.170:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199688, NULL, 'G3DSA:2.70.150.10:FF:000299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199689, NULL, 'G3DSA:3.40.50.720:FF:000081', NULL, NULL, '2-deoxy-D-gluconate 3-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(199690, NULL, 'G3DSA:3.40.50.300:FF:003271', NULL, NULL, 'Origin recognition complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(199691, NULL, 'G3DSA:1.20.1070.10:FF:000626', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199692, NULL, 'G3DSA:2.130.10.30:FF:000180', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199693, NULL, 'G3DSA:3.40.190.10:FF:000377', NULL, NULL, 'Amino acid ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(199694, NULL, 'G3DSA:3.40.850.10:FF:000259', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(199695, NULL, 'G3DSA:3.40.50.2000:FF:000492', NULL, NULL, 'Lipopolysaccharide heptosyltransferase II', NULL, NULL, NULL, NULL, NULL, 4),
(199696, NULL, 'G3DSA:2.60.40.10:FF:003080', NULL, NULL, 'GM26564', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(199697, NULL, 'G3DSA:3.30.160.60:FF:000595', NULL, NULL, 'Krueppel-like factor 14', NULL, NULL, NULL, NULL, NULL, 4),
(199698, NULL, 'G3DSA:3.30.1050.10:FF:000048', NULL, NULL, 'Putative secreted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199699, NULL, 'G3DSA:2.60.120.590:FF:000014', NULL, NULL, 'Oxidoreductase, 2OG-Fe(II) oxygenase family family', NULL, NULL, NULL, NULL, NULL, 4),
(199700, NULL, 'G3DSA:1.25.40.10:FF:000566', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(199701, NULL, 'G3DSA:1.25.40.10:FF:004298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199702, NULL, 'G3DSA:2.60.40.10:FF:003450', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199703, NULL, 'G3DSA:3.40.50.720:FF:002542', NULL, NULL, 'Ubiquitin-like modifier-activating enzyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(199704, NULL, 'G3DSA:3.30.559.10:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199705, NULL, 'G3DSA:2.130.10.10:FF:001483', NULL, NULL, 'Tex1p', NULL, NULL, NULL, NULL, NULL, 4),
(199706, NULL, 'G3DSA:3.30.420.40:FF:001025', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(199707, NULL, 'G3DSA:2.10.25.10:FF:000090', NULL, NULL, 'laminin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(199708, NULL, 'G3DSA:3.30.530.20:FF:000179', NULL, NULL, 'Os03g0287100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(199709, NULL, 'G3DSA:3.30.470.20:FF:000224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199710, NULL, 'G3DSA:3.60.15.10:FF:000079', NULL, NULL, 'Metallo-hydrolase/oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199711, NULL, 'G3DSA:3.50.50.60:FF:000552', NULL, NULL, 'Anaerobic glycerol-3-phosphate dehydrogenase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(199712, NULL, 'G3DSA:3.20.20.140:FF:000051', NULL, NULL, 'Dihydroorotase protein', NULL, NULL, NULL, NULL, NULL, 4),
(199713, NULL, 'G3DSA:3.30.40.10:FF:000661', NULL, NULL, 'Rco1p', NULL, NULL, NULL, NULL, NULL, 4),
(199714, NULL, 'G3DSA:3.30.160.60:FF:001275', NULL, NULL, 'Zinc finger protein 425', NULL, NULL, NULL, NULL, NULL, 4),
(199715, NULL, 'G3DSA:3.40.1190.20:FF:000109', NULL, NULL, 'Ribokinase', NULL, NULL, NULL, NULL, NULL, 4),
(199716, NULL, 'G3DSA:3.90.45.10:FF:000017', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(199717, NULL, 'G3DSA:3.40.1410.10:FF:000035', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(199718, NULL, 'G3DSA:3.30.160.60:FF:003545', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199719, NULL, 'G3DSA:1.20.1050.10:FF:000064', NULL, NULL, 'tRNA-aminoacylation cofactor ARC1', NULL, NULL, NULL, NULL, NULL, 4),
(199720, NULL, 'G3DSA:1.10.150.770:FF:000002', NULL, NULL, 'Probable peptidoglycan D,D-transpeptidase PenA', NULL, NULL, NULL, NULL, NULL, 4),
(199721, NULL, 'G3DSA:1.25.40.10:FF:002836', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(199722, NULL, 'G3DSA:3.30.420.40:FF:000845', NULL, NULL, 'Actin-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(199723, NULL, 'G3DSA:2.130.10.10:FF:005209', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199724, NULL, 'G3DSA:3.90.79.10:FF:000298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199725, NULL, 'G3DSA:2.60.40.770:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199726, NULL, 'G3DSA:3.30.160.60:FF:005327', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199727, NULL, 'G3DSA:2.60.120.10:FF:000203', NULL, NULL, 'cAMP-dependent protein kinase regulatory subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199728, NULL, 'G3DSA:3.90.550.10:FF:000574', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199729, NULL, 'G3DSA:3.40.50.300:FF:001028', NULL, NULL, 'Class II major histocompatibility complex transactivator', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(199730, NULL, 'G3DSA:3.50.50.60:FF:000861', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199731, NULL, 'G3DSA:1.20.1250.20:FF:002291', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199732, NULL, 'G3DSA:1.10.238.10:FF:000559', NULL, NULL, 'Calcium-binding EF-hand domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(199733, NULL, 'G3DSA:2.30.26.10:FF:000006', NULL, NULL, 'Dihydroorotate dehydrogenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(199734, NULL, 'G3DSA:3.40.50.12760:FF:000003', NULL, NULL, 'Cap methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(199735, NULL, 'G3DSA:3.40.50.150:FF:001820', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199736, NULL, 'G3DSA:3.30.70.330:FF:000543', NULL, NULL, 'Pabp2, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(199737, NULL, 'G3DSA:3.30.450.20:FF:000650', NULL, NULL, 'Sensory box sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(199738, NULL, 'G3DSA:1.20.1070.10:FF:002190', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199739, NULL, 'G3DSA:1.10.510.10:FF:003452', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199740, NULL, 'G3DSA:1.10.510.10:FF:003082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199741, NULL, 'G3DSA:3.40.50.300:FF:001337', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199742, NULL, 'G3DSA:3.30.1330.40:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199743, NULL, 'G3DSA:1.20.5.170:FF:000129', NULL, NULL, 'Heme-responsive zinc finger transcription factor HAP1', NULL, NULL, NULL, NULL, NULL, 4),
(199744, NULL, 'G3DSA:1.10.287.70:FF:000044', NULL, NULL, 'Voltage-dependent N-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(199745, NULL, 'G3DSA:3.40.50.12470:FF:000006', NULL, NULL, '2-oxoglutarate dehydrogenase, mitochondrial isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(199746, NULL, 'G3DSA:3.30.450.20:FF:000341', NULL, NULL, 'Nuclear receptor coactivator 3', NULL, NULL, NULL, NULL, NULL, 4),
(199747, NULL, 'G3DSA:1.10.287.130:FF:000124', NULL, NULL, 'Two-component system, OmpR family, sensor histidine kinase KdpD', NULL, NULL, NULL, NULL, NULL, 4),
(199748, NULL, 'G3DSA:3.10.20.90:FF:000488', NULL, NULL, 'Predicted NADPH oxidase activator 1', NULL, NULL, NULL, NULL, NULL, 4),
(199749, NULL, 'G3DSA:1.20.1720.10:FF:000053', NULL, NULL, 'Bcr/CflA family efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(199750, NULL, 'G3DSA:3.80.10.10:FF:001719', NULL, NULL, 'AGAP011930-PA', NULL, NULL, NULL, NULL, NULL, 4),
(199751, NULL, 'G3DSA:3.40.20.10:FF:000002', NULL, NULL, 'Gelsolin', NULL, NULL, NULL, NULL, NULL, 4),
(199752, NULL, 'G3DSA:1.20.1510.10:FF:000083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199753, NULL, 'G3DSA:3.30.2060.10:FF:000004', NULL, NULL, 'Transcription-repair-coupling factor', NULL, NULL, NULL, NULL, NULL, 4),
(199754, NULL, 'G3DSA:1.10.510.10:FF:003109', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199755, NULL, 'G3DSA:3.40.50.150:FF:000668', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199756, NULL, 'G3DSA:3.90.190.10:FF:000091', NULL, NULL, 'Phosphatase domain containing paladin 1', NULL, NULL, NULL, NULL, NULL, 4),
(199757, NULL, 'G3DSA:3.40.50.2300:FF:000492', NULL, NULL, 'Sugar ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(199758, NULL, 'G3DSA:3.90.640.10:FF:000210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199759, NULL, 'G3DSA:1.25.40.720:FF:000010', NULL, NULL, 'Telomere length regulation protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199760, NULL, 'G3DSA:3.80.10.10:FF:004007', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199761, NULL, 'G3DSA:1.20.80.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199762, NULL, 'G3DSA:3.40.50.2300:FF:000828', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(199763, NULL, 'G3DSA:2.130.10.10:FF:003074', NULL, NULL, 'Ribosome biogenesis protein NSA1', NULL, NULL, NULL, NULL, NULL, 4),
(199764, NULL, 'G3DSA:3.30.70.330:FF:002651', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199765, NULL, 'G3DSA:1.25.40.10:FF:003207', NULL, NULL, 'XPA binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(199766, NULL, 'G3DSA:2.30.40.10:FF:000141', NULL, NULL, 'Alpha-D-ribose 1-methylphosphonate 5-triphosphate diphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(199767, NULL, 'G3DSA:2.30.29.30:FF:000800', NULL, NULL, 'Guanine nucleotide exchange factor Cdc24 homologue, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199768, NULL, 'G3DSA:3.40.50.1820:FF:000241', NULL, NULL, 'LipY', NULL, NULL, NULL, NULL, NULL, 4),
(199769, NULL, 'G3DSA:1.20.1560.10:FF:000029', NULL, NULL, 'ABC transporter B family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(199770, NULL, 'G3DSA:3.30.40.10:FF:000526', NULL, NULL, 'PHD and ring finger domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(199771, NULL, 'G3DSA:3.30.40.10:FF:001032', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(199772, NULL, 'G3DSA:3.40.1110.10:FF:000023', NULL, NULL, 'Copper-transporting ATPase 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199773, NULL, 'G3DSA:3.60.15.10:FF:000096', NULL, NULL, 'Metallo-beta-lactamase type 2', NULL, NULL, NULL, NULL, NULL, 4),
(199774, NULL, 'G3DSA:3.40.50.150:FF:001466', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199775, NULL, 'G3DSA:2.160.20.10:FF:000145', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(199776, NULL, 'G3DSA:3.40.710.10:FF:000103', NULL, NULL, 'Membrane carboxypeptidase/penicillin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(199777, NULL, 'G3DSA:2.20.28.30:FF:000006', NULL, NULL, 'DNA-directed RNA polymerasese, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199778, NULL, 'G3DSA:1.10.400.10:FF:000038', NULL, NULL, 'Guanine nucleotide binding protein (G protein), alpha 13b', NULL, NULL, NULL, NULL, NULL, 4),
(199779, NULL, 'G3DSA:1.10.510.10:FF:001209', NULL, NULL, 'Kinase like protein', NULL, NULL, NULL, NULL, NULL, 4),
(199780, NULL, 'G3DSA:3.40.720.10:FF:000031', NULL, NULL, 'arylsulfatase G isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(199781, NULL, 'G3DSA:3.90.190.10:FF:000135', NULL, NULL, 'Dual specificity protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199782, NULL, 'G3DSA:2.60.40.420:FF:000145', NULL, NULL, 'Auracyanin-A', NULL, NULL, NULL, NULL, NULL, 4),
(199783, NULL, 'G3DSA:2.20.28.20:FF:000003', NULL, NULL, 'Methionyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(199784, NULL, 'G3DSA:3.40.1410.10:FF:000052', NULL, NULL, 'Lmo2004 protein', NULL, NULL, NULL, NULL, NULL, 4),
(199785, NULL, 'G3DSA:1.10.630.10:FF:000173', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(199786, NULL, 'G3DSA:3.40.190.10:FF:000686', NULL, NULL, 'Mutant transferrin', NULL, NULL, NULL, NULL, NULL, 4),
(199787, NULL, 'G3DSA:3.40.30.10:FF:001048', NULL, NULL, 'Glr3964 protein', NULL, NULL, NULL, NULL, NULL, 4),
(199788, NULL, 'G3DSA:3.40.850.10:FF:000361', NULL, NULL, 'Chitin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(199789, NULL, 'G3DSA:2.70.170.10:FF:000199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199790, NULL, 'G3DSA:2.10.70.10:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199791, NULL, 'G3DSA:2.130.10.10:FF:001174', NULL, NULL, 'Mtc5p', NULL, NULL, NULL, NULL, NULL, 4),
(199792, NULL, 'G3DSA:3.30.930.10:FF:000122', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(199793, NULL, 'G3DSA:3.30.420.40:FF:000828', NULL, NULL, 'Actin-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(199794, NULL, 'G3DSA:2.60.120.260:FF:000488', NULL, NULL, 'Putative galactosidae', NULL, NULL, NULL, NULL, NULL, 4),
(199795, NULL, 'G3DSA:1.10.238.10:FF:000868', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199796, NULL, 'G3DSA:3.40.50.10240:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(199797, NULL, 'G3DSA:3.30.342.10:FF:000036', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(199798, NULL, 'G3DSA:3.30.365.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199799, NULL, 'G3DSA:2.60.34.10:FF:000086', NULL, NULL, 'YALI0B12474p', NULL, NULL, NULL, NULL, NULL, 4),
(199800, NULL, 'G3DSA:3.30.450.20:FF:000324', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(199801, NULL, 'G3DSA:2.40.128.330:FF:000002', NULL, NULL, 'Inner membrane magnesium transporter mrs2', NULL, NULL, NULL, NULL, NULL, 4),
(199802, NULL, 'G3DSA:2.60.40.10:FF:003107', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199803, NULL, 'G3DSA:4.10.60.10:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199804, NULL, 'G3DSA:3.90.920.10:FF:000029', NULL, NULL, 'Os05g0358200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(199805, NULL, 'G3DSA:2.60.40.380:FF:000009', NULL, NULL, 'Alkaline phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199806, NULL, 'G3DSA:1.10.510.10:FF:000794', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(199807, NULL, 'G3DSA:2.30.18.10:FF:000016', NULL, NULL, 'Transcription factor IIA, alpha/beta subunit-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(199808, NULL, 'G3DSA:3.90.1150.10:FF:000413', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199809, NULL, 'G3DSA:1.20.5.1500:FF:000004', NULL, NULL, 'Nucleosome assembly protein Nap1', NULL, NULL, NULL, NULL, NULL, 4),
(199810, NULL, 'G3DSA:3.40.630.10:FF:000187', NULL, NULL, 'Nicastrin', NULL, NULL, NULL, NULL, NULL, 4),
(199811, NULL, 'G3DSA:1.10.486.10:FF:000062', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199812, NULL, 'G3DSA:3.40.50.300:FF:003815', NULL, NULL, 'ATPase of the AAA+ class Posttranslational modification protein', NULL, NULL, NULL, NULL, NULL, 4),
(199813, NULL, 'G3DSA:3.90.180.10:FF:000163', NULL, NULL, 'Zinc-type alcohol dehydrogenase-like protein C2E1P3.01', NULL, NULL, NULL, NULL, NULL, 4),
(199814, NULL, 'G3DSA:3.80.10.10:FF:000308', NULL, NULL, 'tsukushin isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(199815, NULL, 'G3DSA:3.40.50.1820:FF:001859', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199816, NULL, 'G3DSA:2.60.40.10:FF:004389', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199817, NULL, 'G3DSA:1.20.1720.10:FF:000036', NULL, NULL, 'Multidrug transporter', NULL, NULL, NULL, NULL, NULL, 4),
(199818, NULL, 'G3DSA:1.10.1030.10:FF:000014', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(199819, NULL, 'G3DSA:3.30.160.20:FF:000122', NULL, NULL, 'Glycosyl hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(199820, NULL, 'G3DSA:1.10.8.60:FF:000100', NULL, NULL, 'Chaperone protein ClpB1', NULL, NULL, NULL, NULL, NULL, 4),
(199821, NULL, 'G3DSA:2.10.110.10:FF:000147', NULL, NULL, 'LIM/homeobox protein Awh-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(199822, NULL, 'G3DSA:3.80.10.10:FF:000410', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase PXL1', NULL, NULL, NULL, NULL, NULL, 4),
(199823, NULL, 'G3DSA:3.40.250.10:FF:000202', NULL, NULL, 'Dual specificity protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(199824, NULL, 'G3DSA:1.50.40.10:FF:000018', NULL, NULL, 'S-adenosylmethionine mitochondrial carrier protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(199825, NULL, 'G3DSA:3.40.50.300:FF:006817', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199826, NULL, 'G3DSA:3.90.650.10:FF:000036', NULL, NULL, 'AIR synthase related protein', NULL, NULL, NULL, NULL, NULL, 4),
(199827, NULL, 'G3DSA:3.40.50.300:FF:001680', NULL, NULL, 'BRCA1 interacting protein C-terminal helicase 1', NULL, NULL, NULL, NULL, NULL, 4),
(199828, NULL, 'G3DSA:3.90.380.10:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199829, NULL, 'G3DSA:3.40.630.30:FF:000243', NULL, NULL, 'GNAT family N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(199830, NULL, 'G3DSA:3.50.50.60:FF:000198', NULL, NULL, 'Lysine-specific histone demethylase', NULL, NULL, NULL, NULL, NULL, 4),
(199831, NULL, 'G3DSA:3.60.40.10:FF:000064', NULL, NULL, 'Protein phosphatase 2C 1', NULL, NULL, NULL, NULL, NULL, 4),
(199832, NULL, 'G3DSA:3.80.10.10:FF:000264', NULL, NULL, 'NLR family CARD domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(199833, NULL, 'G3DSA:3.40.50.2000:FF:000166', NULL, NULL, 'Trehalose-phosphatase, variant 2', NULL, NULL, NULL, NULL, NULL, 4),
(199834, NULL, 'G3DSA:1.10.1670.10:FF:000017', NULL, NULL, 'Related to 8-oxoguanine DNA-glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(199835, NULL, 'G3DSA:1.10.274.100:FF:000027', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(199836, NULL, 'G3DSA:2.170.120.12:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199837, NULL, 'G3DSA:3.90.810.10:FF:000010', NULL, NULL, 'Related to Neural Wiskott-Aldrich syndrome protein', NULL, NULL, NULL, NULL, NULL, 4),
(199838, NULL, 'G3DSA:1.50.10.20:FF:000003', NULL, NULL, 'Terpene cyclase/mutase family member', NULL, NULL, NULL, NULL, NULL, 4),
(199839, NULL, 'G3DSA:1.10.287.1260:FF:000003', NULL, NULL, 'MscS Mechanosensitive ion channel', NULL, NULL, NULL, NULL, NULL, 4),
(199840, NULL, 'G3DSA:1.10.287.70:FF:000370', NULL, NULL, 'Sodium channel protein 60E', NULL, NULL, NULL, NULL, NULL, 4),
(199841, NULL, 'G3DSA:2.60.120.260:FF:000590', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199842, NULL, 'G3DSA:3.40.50.300:FF:003580', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(199843, NULL, 'G3DSA:3.20.20.80:FF:000052', NULL, NULL, 'Putative alpha-L-fucosidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(199844, NULL, 'G3DSA:2.60.120.10:FF:000788', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199845, NULL, 'G3DSA:3.30.70.1350:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199846, NULL, 'G3DSA:3.30.750.24:FF:000138', NULL, NULL, 'AGAP013218-PA', NULL, NULL, NULL, NULL, NULL, 4),
(199847, NULL, 'G3DSA:1.20.120.850:FF:000012', NULL, NULL, 'protein PHOTOPERIOD-INDEPENDENT EARLY FLOWERING 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(199848, NULL, 'G3DSA:3.40.1280.10:FF:000035', NULL, NULL, 'Putative pseudouridine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(199849, NULL, 'G3DSA:3.30.160.60:FF:004647', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199850, NULL, 'G3DSA:3.10.20.90:FF:000212', NULL, NULL, 'Par-3 family cell polarity regulator', NULL, NULL, NULL, NULL, NULL, 4),
(199851, NULL, 'G3DSA:2.60.40.10:FF:001207', NULL, NULL, 'Sallimus, isoform P', NULL, NULL, NULL, NULL, NULL, 4),
(199852, NULL, 'G3DSA:1.10.510.10:FF:002929', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199853, NULL, 'G3DSA:2.60.40.1170:FF:000087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199854, NULL, 'G3DSA:1.20.920.10:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199855, NULL, 'G3DSA:3.40.50.1860:FF:000011', NULL, NULL, 'Aspartate-glutamate racemase family', NULL, NULL, NULL, NULL, NULL, 4),
(199856, NULL, 'G3DSA:3.80.10.10:FF:004333', NULL, NULL, 'Zyg-11-related, cell cycle regulator', NULL, NULL, NULL, NULL, NULL, 4),
(199857, NULL, 'G3DSA:3.20.20.150:FF:000037', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(199858, NULL, 'G3DSA:3.30.70.270:FF:000255', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199859, NULL, 'G3DSA:2.130.10.10:FF:002894', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199860, NULL, 'G3DSA:1.20.58.60:FF:000463', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199861, NULL, 'G3DSA:1.10.8.60:FF:000324', NULL, NULL, 'Lon protease homolog', NULL, NULL, NULL, NULL, NULL, 4),
(199862, NULL, 'G3DSA:3.40.50.150:FF:001174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199863, NULL, 'G3DSA:2.60.40.10:FF:002944', NULL, NULL, 'Cell adhesion molecule, putative', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(199864, NULL, 'G3DSA:3.40.50.11610:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199865, NULL, 'G3DSA:3.60.10.10:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199866, NULL, 'G3DSA:3.30.200.20:FF:000974', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199867, NULL, 'G3DSA:2.40.240.10:FF:000020', NULL, NULL, 'Glutamine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(199868, NULL, 'G3DSA:2.60.40.10:FF:003433', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199869, NULL, 'G3DSA:2.10.110.10:FF:000164', NULL, NULL, 'Prickle planar cell polarity protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(199870, NULL, 'G3DSA:1.25.40.20:FF:000310', NULL, NULL, 'Ankyrin repeat and SOCS box containing 15', NULL, NULL, NULL, NULL, NULL, 4),
(199871, NULL, 'G3DSA:3.30.43.10:FF:000033', NULL, NULL, 'Actin interacting protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(199872, NULL, 'G3DSA:2.60.120.200:FF:000077', NULL, NULL, 'vitamin K-dependent protein S', NULL, NULL, NULL, NULL, NULL, 4),
(199873, NULL, 'G3DSA:3.20.20.190:FF:000116', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199874, NULL, 'G3DSA:3.40.50.300:FF:001663', NULL, NULL, 'Superfamily I DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(199875, NULL, 'G3DSA:3.90.850.10:FF:000001', NULL, NULL, '2-oxo-hepta-3-ene-1,7-dioic acid hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(199876, NULL, 'G3DSA:2.20.110.10:FF:000010', NULL, NULL, 'Radial spoke head 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(199877, NULL, 'G3DSA:3.40.50.300:FF:000865', NULL, NULL, 'ATP-dependent RNA helicase DDX54', NULL, NULL, NULL, NULL, NULL, 4),
(199878, NULL, 'G3DSA:3.90.650.10:FF:000019', NULL, NULL, 'Trifunctional purine biosynthetic protein adenosine-3', NULL, NULL, NULL, NULL, NULL, 4),
(199879, NULL, 'G3DSA:3.30.420.40:FF:001008', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199880, NULL, 'G3DSA:1.10.510.10:FF:001535', NULL, NULL, 'Mitogen-activated protein kinase 9', NULL, NULL, NULL, NULL, NULL, 4),
(199881, NULL, 'G3DSA:1.20.1250.20:FF:002318', NULL, NULL, 'Organic cation/carnitine transporter 7', NULL, NULL, NULL, NULL, NULL, 4),
(199882, NULL, 'G3DSA:1.10.472.10:FF:000457', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199883, NULL, 'G3DSA:3.40.50.10330:FF:000050', NULL, NULL, 'Sphingosine kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(199884, NULL, 'G3DSA:1.25.40.10:FF:002499', NULL, NULL, 'SMG-7', NULL, NULL, NULL, NULL, NULL, 4),
(199885, NULL, 'G3DSA:1.25.40.20:FF:001412', NULL, NULL, 'Exodeoxyribonuclease V', NULL, NULL, NULL, NULL, NULL, 4),
(199886, NULL, 'G3DSA:3.40.50.150:FF:000994', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199887, NULL, 'G3DSA:3.30.160.60:FF:004973', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199888, NULL, 'G3DSA:3.40.50.1820:FF:000139', NULL, NULL, 'lysophospholipase-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(199889, NULL, 'G3DSA:1.10.8.10:FF:000225', NULL, NULL, 'UV excision repair RAD23 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199890, NULL, 'G3DSA:2.40.50.140:FF:000438', NULL, NULL, 'DNA repair protein BRCA2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199891, NULL, 'G3DSA:3.10.20.90:FF:001005', NULL, NULL, 'Ptk2.1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(199892, NULL, 'G3DSA:2.130.10.10:FF:005226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199893, NULL, 'G3DSA:3.20.20.140:FF:000034', NULL, NULL, 'putative deoxyribonuclease TATDN1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(199894, NULL, 'G3DSA:3.30.1490.190:FF:000003', NULL, NULL, 'Fur family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(199895, NULL, 'G3DSA:3.40.1280.10:FF:000018', NULL, NULL, 'uncharacterized protein LOC106771328 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(199896, NULL, 'G3DSA:1.25.10.10:FF:000738', NULL, NULL, 'VAC14p Enzyme regulator', NULL, NULL, NULL, NULL, NULL, 4),
(199897, NULL, 'G3DSA:2.130.10.10:FF:004737', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(199898, NULL, 'G3DSA:1.20.58.1070:FF:000009', NULL, NULL, 'Gem-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(199899, NULL, 'G3DSA:3.30.70.330:FF:000526', NULL, NULL, 'MKI67 (FHA domain) interacting nucleolar phosphoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(199900, NULL, 'G3DSA:3.40.50.720:FF:002188', NULL, NULL, 'Malate dehydrogenase 1Aa, NAD (soluble)', NULL, NULL, NULL, NULL, NULL, 4),
(199901, NULL, 'G3DSA:1.20.58.60:FF:000480', NULL, NULL, 'Spectrin repeat containing, nuclear envelope 1a', NULL, NULL, NULL, NULL, NULL, 4),
(199902, NULL, 'G3DSA:1.10.510.10:FF:002946', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199903, NULL, 'G3DSA:2.20.70.10:FF:000093', NULL, NULL, 'NEDD4-like E3 ubiquitin-protein ligase WWP1', NULL, NULL, NULL, NULL, NULL, 4),
(199904, NULL, 'G3DSA:3.40.50.720:FF:001699', NULL, NULL, 'D-glycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(199905, NULL, 'G3DSA:3.40.1000.30:FF:000010', NULL, NULL, 'F-box protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(199906, NULL, 'G3DSA:3.60.20.10:FF:000046', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(199907, NULL, 'G3DSA:2.60.40.10:FF:001533', NULL, NULL, 'Immunoglobulin heavy variable 2-26', NULL, NULL, NULL, NULL, NULL, 4),
(199908, NULL, 'G3DSA:3.40.30.10:FF:000885', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(199909, NULL, 'G3DSA:1.20.1560.10:FF:000473', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(199910, NULL, 'G3DSA:3.40.50.12470:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199911, NULL, 'G3DSA:3.40.50.300:FF:001354', NULL, NULL, 'ATP-binding cassette (ABC) transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199912, NULL, 'G3DSA:1.10.510.10:FF:003435', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199913, NULL, 'G3DSA:2.60.120.200:FF:000386', NULL, NULL, 'Pentaxin', NULL, NULL, NULL, NULL, NULL, 4),
(199914, NULL, 'G3DSA:1.20.5.170:FF:000146', NULL, NULL, 'Atg16p', NULL, NULL, NULL, NULL, NULL, 4),
(199915, NULL, 'G3DSA:2.70.160.11:FF:000014', NULL, NULL, 'Protein arginine N-methyltransferase 7', NULL, NULL, NULL, NULL, NULL, 4),
(199916, NULL, 'G3DSA:1.10.287.70:FF:000061', NULL, NULL, 'Sodium leak channel non-selective protein', NULL, NULL, NULL, NULL, NULL, 4),
(199917, NULL, 'G3DSA:2.40.50.140:FF:000747', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199918, NULL, 'G3DSA:3.20.20.140:FF:000343', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199919, NULL, 'G3DSA:3.40.50.300:FF:008588', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199920, NULL, 'G3DSA:3.40.50.10540:FF:000006', NULL, NULL, 'GG15379', NULL, NULL, NULL, NULL, NULL, 4),
(199921, NULL, 'G3DSA:3.30.450.20:FF:000195', NULL, NULL, 'Cell wall metabolism sensor histidine kinase WalK', NULL, NULL, NULL, NULL, NULL, 4),
(199922, NULL, 'G3DSA:2.60.40.10:FF:001842', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(199923, NULL, 'G3DSA:3.40.50.12780:FF:000144', NULL, NULL, 'NRPS-like enzyme, putative (AFU_orthologue AFUA_8G01222)', NULL, NULL, NULL, NULL, NULL, 4),
(199924, NULL, 'G3DSA:1.20.1560.10:FF:000164', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(199925, NULL, 'G3DSA:2.30.42.10:FF:000656', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199926, NULL, 'G3DSA:2.160.10.10:FF:000088', NULL, NULL, 'L-fucose kinase-like', NULL, NULL, NULL, NULL, NULL, 4),
(199927, NULL, 'G3DSA:3.60.15.10:FF:000225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199928, NULL, 'G3DSA:2.30.30.40:FF:000548', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199929, NULL, 'G3DSA:3.30.70.330:FF:000397', NULL, NULL, 'RNA binding protein Nrd1', NULL, NULL, NULL, NULL, NULL, 4),
(199930, NULL, 'G3DSA:3.30.200.20:FF:000648', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(199931, NULL, 'G3DSA:3.30.40.10:FF:000217', NULL, NULL, 'E3 ubiquitin-protein ligase At1g12760', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(199932, NULL, 'G3DSA:1.20.990.10:FF:000023', NULL, NULL, 'NADPH-cytochrome P450 reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199933, NULL, 'G3DSA:2.60.120.970:FF:000021', NULL, NULL, 'Growth differentiation factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(199934, NULL, 'G3DSA:2.60.120.290:FF:000031', NULL, NULL, 'Low-density lipoprotein receptor-related protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(199935, NULL, 'G3DSA:3.90.640.10:FF:000081', NULL, NULL, 'Actin-related protein RO7, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199936, NULL, 'G3DSA:3.30.230.10:FF:000147', NULL, NULL, 'Elongation factor 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199937, NULL, 'G3DSA:1.10.3470.10:FF:000036', NULL, NULL, 'Iron chelate uptake ABC transporter, FeCT family, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(199938, NULL, 'G3DSA:3.40.50.410:FF:000313', NULL, NULL, 'Phospholipase A(2)', NULL, NULL, NULL, NULL, NULL, 4),
(199939, NULL, 'G3DSA:3.40.50.300:FF:004917', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(199940, NULL, 'G3DSA:3.40.50.300:FF:003506', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199941, NULL, 'G3DSA:3.30.70.3320:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199942, NULL, 'G3DSA:3.60.10.10:FF:000220', NULL, NULL, 'Putative inositol polyphosphate phosphatase (Synaptogenin-like) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(199943, NULL, 'G3DSA:1.25.10.10:FF:001227', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(199944, NULL, 'G3DSA:3.40.50.1000:FF:000793', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199945, NULL, 'G3DSA:1.20.120.20:FF:000023', NULL, NULL, 'Apolipoprotein E', NULL, NULL, NULL, NULL, NULL, 4),
(199946, NULL, 'G3DSA:3.30.160.60:FF:005462', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199947, NULL, 'G3DSA:1.25.40.470:FF:000081', NULL, NULL, 'Coatomer subunit beta''-3', NULL, NULL, NULL, NULL, NULL, 4),
(199948, NULL, 'G3DSA:3.40.50.300:FF:005715', NULL, NULL, 'Si:dkey-11m19.5', NULL, NULL, NULL, NULL, NULL, 4),
(199949, NULL, 'G3DSA:1.20.120.1080:FF:000060', NULL, NULL, 'Helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(199950, NULL, 'G3DSA:3.40.50.300:FF:006688', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199951, NULL, 'G3DSA:3.40.50.80:FF:000036', NULL, NULL, 'Ferric reduction oxidase 6', NULL, NULL, NULL, NULL, NULL, 4),
(199952, NULL, 'G3DSA:1.10.340.30:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199953, NULL, 'G3DSA:3.90.70.80:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199954, NULL, 'G3DSA:1.20.1080.10:FF:000099', NULL, NULL, 'Entomoglyceroporin 1', NULL, NULL, NULL, NULL, NULL, 4),
(199955, NULL, 'G3DSA:3.40.50.300:FF:005406', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199956, NULL, 'G3DSA:1.25.40.10:FF:004753', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199957, NULL, 'G3DSA:2.30.42.10:FF:000347', NULL, NULL, 'Membrane associated guanylate kinase, WW and PDZ domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(199958, NULL, 'G3DSA:3.40.50.970:FF:000088', NULL, NULL, 'Putative acetolactate synthase IlvG', NULL, NULL, NULL, NULL, NULL, 4),
(199959, NULL, 'G3DSA:1.20.1070.10:FF:000273', NULL, NULL, 'Relaxin family peptide/INSL5 receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(199960, NULL, 'G3DSA:3.90.1800.10:FF:000014', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(199961, NULL, 'G3DSA:2.80.10.70:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199962, NULL, 'G3DSA:3.40.50.300:FF:007177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199963, NULL, 'G3DSA:3.40.50.300:FF:003254', NULL, NULL, 'Helicase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(199964, NULL, 'G3DSA:3.10.20.70:FF:000038', NULL, NULL, 'Glutamine synthetase, type I', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(199965, NULL, 'G3DSA:2.60.120.590:FF:000031', NULL, NULL, 'AlkB, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(199966, NULL, 'G3DSA:3.80.10.10:FF:001899', NULL, NULL, 'Tubulin folding cofactor E', NULL, NULL, NULL, NULL, NULL, 4),
(199967, NULL, 'G3DSA:4.10.1000.10:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199968, NULL, 'G3DSA:3.30.470.30:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199969, NULL, 'G3DSA:3.80.10.10:FF:002517', NULL, NULL, 'Toll-like receptor 4b, duplicate b', NULL, NULL, NULL, NULL, NULL, 4),
(199970, NULL, 'G3DSA:3.30.70.330:FF:000088', NULL, NULL, 'msx2-interacting protein-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(199971, NULL, 'G3DSA:3.30.470.20:FF:000095', NULL, NULL, 'SyNapsiN', NULL, NULL, NULL, NULL, NULL, 4),
(199972, NULL, 'G3DSA:1.25.40.570:FF:000021', NULL, NULL, 'Putative proteasome regulatory particle subunit', NULL, NULL, NULL, NULL, NULL, 4),
(199973, NULL, 'G3DSA:3.30.420.270:FF:000020', NULL, NULL, 'Biopolymer transport protein exbD', NULL, NULL, NULL, NULL, NULL, 4),
(199974, NULL, 'G3DSA:3.40.50.300:FF:007632', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199975, NULL, 'G3DSA:3.30.470.20:FF:000207', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199976, NULL, 'G3DSA:3.30.160.60:FF:003528', NULL, NULL, 'Meiotic P26, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(199977, NULL, 'G3DSA:2.60.40.420:FF:000263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199978, NULL, 'G3DSA:1.10.472.80:FF:000213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(199979, NULL, 'G3DSA:1.25.40.20:FF:000102', NULL, NULL, 'ankyrin repeat and KH domain-containing protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(199980, NULL, 'G3DSA:3.40.366.10:FF:000027', NULL, NULL, 'Malonyl CoA-acyl carrier protein transacylase', NULL, NULL, NULL, NULL, NULL, 4),
(199981, NULL, 'G3DSA:2.60.40.10:FF:001281', NULL, NULL, 'Interferon gamma receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(199982, NULL, 'G3DSA:3.30.160.390:FF:000002', NULL, NULL, 'Site-specific recombinase, phage integrase family', NULL, NULL, NULL, NULL, NULL, 4),
(199983, NULL, 'G3DSA:1.25.40.10:FF:002819', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199984, NULL, 'G3DSA:1.20.1050.10:FF:000081', NULL, NULL, 'Methionyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(199985, NULL, 'G3DSA:2.60.120.650:FF:000173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199986, NULL, 'G3DSA:3.40.50.300:FF:001219', NULL, NULL, 'Adenylyl-sulfate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(199987, NULL, 'G3DSA:3.30.870.10:FF:000089', NULL, NULL, 'Phospholipase D', NULL, NULL, NULL, NULL, NULL, 4),
(199988, NULL, 'G3DSA:2.30.29.30:FF:000137', NULL, NULL, 'Low density lipoprotein receptor adapter protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(199989, NULL, 'G3DSA:3.40.630.10:FF:000069', NULL, NULL, 'Acetylornithine deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(199990, NULL, 'G3DSA:3.30.390.30:FF:000052', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199991, NULL, 'G3DSA:1.20.58.1070:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199992, NULL, 'G3DSA:1.20.120.20:FF:000039', NULL, NULL, 'LOC100135198 protein', NULL, NULL, NULL, NULL, NULL, 4),
(199993, NULL, 'G3DSA:2.30.40.10:FF:000023', NULL, NULL, 'Imidazolonepropionase-like amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(199994, NULL, 'G3DSA:3.40.50.150:FF:000786', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(199995, NULL, 'G3DSA:1.20.58.60:FF:000446', NULL, NULL, 'Dystrophin-1', NULL, NULL, NULL, NULL, NULL, 4),
(199996, NULL, 'G3DSA:3.40.228.10:FF:000016', NULL, NULL, 'Probable oxidoreductase YyaE', NULL, NULL, NULL, NULL, NULL, 4),
(199997, NULL, 'G3DSA:3.40.5.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(199998, NULL, 'G3DSA:3.40.630.10:FF:000496', NULL, NULL, 'Aspartyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(199999, NULL, 'G3DSA:3.40.50.720:FF:002396', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200000, NULL, 'G3DSA:1.10.3380.30:FF:000041', NULL, NULL, 'ATP-dependent DNA helicase Hel308', NULL, NULL, NULL, NULL, NULL, 4),
(200001, NULL, 'G3DSA:1.10.10.60:FF:000348', NULL, NULL, 'Transcription factor MYB26', NULL, NULL, NULL, NULL, NULL, 4),
(200002, NULL, 'G3DSA:1.10.150.20:FF:000257', NULL, NULL, 'Flap endonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(200003, NULL, 'G3DSA:2.30.29.30:FF:000671', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(200004, NULL, 'G3DSA:1.20.1460.20:FF:000002', NULL, NULL, 'V-type ATP synthase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(200005, NULL, 'G3DSA:3.40.50.1820:FF:000550', NULL, NULL, 'LIPaSe related', NULL, NULL, NULL, NULL, NULL, 4),
(200006, NULL, 'G3DSA:3.60.40.10:FF:000272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200007, NULL, 'G3DSA:1.20.1070.10:FF:001599', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200008, NULL, 'G3DSA:2.40.420.20:FF:000003', NULL, NULL, 'Cation efflux system protein cusB', NULL, NULL, NULL, NULL, NULL, 4),
(200009, NULL, 'G3DSA:3.20.20.100:FF:000163', NULL, NULL, 'Oxidoreductase, aldo/keto reductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(200010, NULL, 'G3DSA:2.130.10.10:FF:000359', NULL, NULL, 'Eukaryotic translation initiation factor 2A', NULL, NULL, NULL, NULL, NULL, 4),
(200011, NULL, 'G3DSA:3.40.50.720:FF:002407', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200012, NULL, 'G3DSA:3.40.50.360:FF:000028', NULL, NULL, 'NAD(P)H-dependent FMN reductase', NULL, NULL, NULL, NULL, NULL, 4),
(200013, NULL, 'G3DSA:3.30.40.10:FF:002252', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(200014, NULL, 'G3DSA:2.60.120.740:FF:000003', NULL, NULL, 'Protein eva-1 homolog C', NULL, NULL, NULL, NULL, NULL, 4),
(200015, NULL, 'G3DSA:3.90.1800.10:FF:000031', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(200016, NULL, 'G3DSA:1.10.472.80:FF:000112', NULL, NULL, 'Rab GTPase activating protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(200017, NULL, 'G3DSA:2.40.50.140:FF:000955', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200018, NULL, 'G3DSA:1.25.40.10:FF:003180', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g19191, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(200019, NULL, 'G3DSA:2.60.40.10:FF:002961', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200020, NULL, 'G3DSA:3.40.640.10:FF:000098', NULL, NULL, 'Glutamic-oxaloacetic transaminase 1 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(200021, NULL, 'G3DSA:2.130.10.10:FF:000786', NULL, NULL, 'Ribosome biogenesis protein BOP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(200022, NULL, 'G3DSA:2.60.40.10:FF:001325', NULL, NULL, 'Leucine rich repeat containing 24', NULL, NULL, NULL, NULL, NULL, 4),
(200023, NULL, 'G3DSA:3.30.420.10:FF:000156', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(200024, NULL, 'G3DSA:2.60.220.50:FF:000094', NULL, NULL, 'Pkd1l2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200025, NULL, 'G3DSA:1.20.1250.20:FF:000183', NULL, NULL, 'sodium-dependent lysophosphatidylcholine symporter 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(200026, NULL, 'G3DSA:2.10.25.10:FF:000056', NULL, NULL, 'Latent-transforming growth factor beta-binding protein 3 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(200027, NULL, 'G3DSA:1.25.40.10:FF:003224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200028, NULL, 'G3DSA:3.30.230.10:FF:000355', NULL, NULL, '30S ribosomal protein S9', NULL, NULL, NULL, NULL, NULL, 4),
(200029, NULL, 'G3DSA:3.40.640.10:FF:000468', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200030, NULL, 'G3DSA:3.30.200.160:FF:000005', NULL, NULL, 'TFC1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(200031, NULL, 'G3DSA:3.30.70.330:FF:000189', NULL, NULL, 'RNA-binding protein 42 isoform X2', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(200032, NULL, 'G3DSA:3.30.470.20:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200033, NULL, 'G3DSA:1.25.40.10:FF:004961', NULL, NULL, 'Intraflagellar transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(200034, NULL, 'G3DSA:3.60.10.10:FF:000236', NULL, NULL, 'Serpentine receptor class gamma', NULL, NULL, NULL, NULL, NULL, 4),
(200035, NULL, 'G3DSA:3.30.428.10:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200036, NULL, 'G3DSA:3.30.710.10:FF:000403', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(200037, NULL, 'G3DSA:3.30.160.60:FF:004956', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200038, NULL, 'G3DSA:3.30.300.30:FF:000114', NULL, NULL, 'Nonribosomal peptide synthetase, discrete adenylation domain', NULL, NULL, NULL, NULL, NULL, 4),
(200039, NULL, 'G3DSA:1.25.50.20:FF:000030', NULL, NULL, 'GM24727', NULL, NULL, NULL, NULL, NULL, 4),
(200040, NULL, 'G3DSA:3.30.40.10:FF:000009', NULL, NULL, 'E3 ubiquitin-protein ligase RNF130', NULL, NULL, NULL, NULL, NULL, 4),
(200041, NULL, 'G3DSA:3.20.20.140:FF:000017', NULL, NULL, 'Adenosine deaminase 2', NULL, NULL, NULL, NULL, NULL, 4),
(200042, NULL, 'G3DSA:1.10.10.10:FF:001373', NULL, NULL, 'Ferric uptake regulator, Fur family', NULL, NULL, NULL, NULL, NULL, 4),
(200043, NULL, 'G3DSA:2.60.120.200:FF:000268', NULL, NULL, 'Sialidase B', NULL, NULL, NULL, NULL, NULL, 4),
(200044, NULL, 'G3DSA:1.10.800.10:FF:000001', NULL, NULL, 'tryptophan 5-hydroxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(200045, NULL, 'G3DSA:3.20.20.330:FF:000001', NULL, NULL, 'Methionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(200046, NULL, 'G3DSA:3.50.50.60:FF:001024', NULL, NULL, 'FAD/NAD(P)-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(200047, NULL, 'G3DSA:3.40.50.11500:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200048, NULL, 'G3DSA:3.50.50.60:FF:000518', NULL, NULL, 'Steroid monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200049, NULL, 'G3DSA:1.20.1720.10:FF:000019', NULL, NULL, 'DHA2 family efflux MFS transporter permease subunit', NULL, NULL, NULL, NULL, NULL, 4),
(200050, NULL, 'G3DSA:2.60.260.20:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200051, NULL, 'G3DSA:2.60.120.260:FF:000516', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(200052, NULL, 'G3DSA:3.90.1150.10:FF:000385', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200053, NULL, 'G3DSA:1.20.58.1780:FF:000026', NULL, NULL, 'Nuclear pore protein', NULL, NULL, NULL, NULL, NULL, 4),
(200054, NULL, 'G3DSA:2.10.25.10:FF:001736', NULL, NULL, 'Adhesion G protein-coupled receptor E1', NULL, NULL, NULL, NULL, NULL, 4),
(200055, NULL, 'G3DSA:1.20.1270.60:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200056, NULL, 'G3DSA:3.30.70.330:FF:001240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200057, NULL, 'G3DSA:1.25.40.20:FF:001530', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(200058, NULL, 'G3DSA:3.30.160.60:FF:005670', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200059, NULL, 'G3DSA:3.10.450.350:FF:000015', NULL, NULL, 'Murein DD-endopeptidase MepM and murein hydrolase activator NlpD, contain LysM domain', NULL, NULL, NULL, NULL, NULL, 4),
(200060, NULL, 'G3DSA:3.30.70.660:FF:000041', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(200061, NULL, 'G3DSA:3.40.1310.20:FF:000007', NULL, NULL, 'Protein Rep68', NULL, NULL, NULL, NULL, NULL, 4),
(200062, NULL, 'G3DSA:3.40.50.300:FF:003462', NULL, NULL, 'Mu phage large terminase subunit GpE', NULL, NULL, NULL, NULL, NULL, 4),
(200063, NULL, 'G3DSA:3.30.40.10:FF:000318', NULL, NULL, 'E3 ubiquitin-protein ligase MARCH4', NULL, NULL, NULL, NULL, NULL, 4),
(200064, NULL, 'G3DSA:2.40.50.140:FF:000540', NULL, NULL, 'Replication protein A 70 kDa DNA-binding subunit', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(200065, NULL, 'G3DSA:3.30.160.20:FF:000240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200066, NULL, 'G3DSA:1.10.10.800:FF:000004', NULL, NULL, 'DltD N-terminal domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(200067, NULL, 'G3DSA:2.120.10.80:FF:000268', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(200068, NULL, 'G3DSA:2.170.140.10:FF:000055', NULL, NULL, 'Cht-1', NULL, NULL, NULL, NULL, NULL, 4),
(200069, NULL, 'G3DSA:3.30.559.10:FF:000051', NULL, NULL, 'Nonribosomal peptide synthetase sidC', NULL, NULL, NULL, NULL, NULL, 4),
(200070, NULL, 'G3DSA:3.90.190.10:FF:000343', NULL, NULL, 'Protein-tyrosine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(200071, NULL, 'G3DSA:3.40.50.300:FF:003153', NULL, NULL, 'ATP binding cassette subfamily C member 3', NULL, NULL, NULL, NULL, NULL, 4),
(200072, NULL, 'G3DSA:3.60.15.10:FF:000124', NULL, NULL, 'DNA repair metallo-beta-lactamase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200073, NULL, 'G3DSA:2.60.40.10:FF:005333', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200074, NULL, 'G3DSA:1.20.1070.10:FF:000508', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(200075, NULL, 'G3DSA:1.10.150.50:FF:000108', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(200076, NULL, 'G3DSA:3.40.50.150:FF:001612', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200077, NULL, 'G3DSA:3.80.10.10:FF:004451', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase EFR', NULL, NULL, NULL, NULL, NULL, 4),
(200078, NULL, 'G3DSA:1.10.287.2620:FF:000006', NULL, NULL, 'Axonemal dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(200079, NULL, 'G3DSA:3.90.70.10:FF:000896', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(200080, NULL, 'G3DSA:3.40.50.720:FF:000951', NULL, NULL, 'Probable 2-hydroxyacid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(200081, NULL, 'G3DSA:1.20.1280.290:FF:000049', NULL, NULL, 'Lysosomal amino acid transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(200082, NULL, 'G3DSA:3.40.50.1260:FF:000011', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(200083, NULL, 'G3DSA:1.20.120.1080:FF:000043', NULL, NULL, 'PRP2p RNA-dependent DExD/H-box ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(200084, NULL, 'G3DSA:1.20.58.60:FF:000345', NULL, NULL, 'SMAll', NULL, NULL, NULL, NULL, NULL, 4),
(200085, NULL, 'G3DSA:3.30.160.60:FF:005361', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200086, NULL, 'G3DSA:1.25.40.180:FF:000128', NULL, NULL, 'MA3_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(200087, NULL, 'G3DSA:3.40.50.1820:FF:000920', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(200088, NULL, 'G3DSA:1.20.1250.20:FF:002173', NULL, NULL, 'Major facilitator superfamily transporter', NULL, NULL, NULL, NULL, NULL, 4),
(200089, NULL, 'G3DSA:3.30.40.10:FF:000970', NULL, NULL, 'Ring finger protein 43', NULL, NULL, NULL, NULL, NULL, 4),
(200090, NULL, 'G3DSA:1.20.1250.20:FF:002111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200091, NULL, 'G3DSA:1.10.10.60:FF:001163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200092, NULL, 'G3DSA:2.40.50.40:FF:000015', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(200093, NULL, 'G3DSA:3.80.10.10:FF:004350', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200094, NULL, 'G3DSA:3.30.70.330:FF:002443', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200095, NULL, 'G3DSA:3.40.1110.10:FF:000231', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(200096, NULL, 'G3DSA:3.60.10.10:FF:000135', NULL, NULL, 'Sphingomyelin phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(200097, NULL, 'G3DSA:1.10.10.60:FF:000775', NULL, NULL, 'Muscle segment homeobox 2a', NULL, NULL, NULL, NULL, NULL, 4),
(200098, NULL, 'G3DSA:3.10.20.770:FF:000023', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(200099, NULL, 'G3DSA:3.30.70.3490:FF:000019', NULL, NULL, 'Oxysterol binding protein (Osh3), putative', NULL, NULL, NULL, NULL, NULL, 4),
(200100, NULL, 'G3DSA:3.20.20.190:FF:000133', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200101, NULL, 'G3DSA:1.20.5.320:FF:000017', NULL, NULL, 'Collagen alpha-1(IX) chain', NULL, NULL, NULL, NULL, NULL, 4),
(200102, NULL, 'G3DSA:3.90.70.10:FF:000907', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(200103, NULL, 'G3DSA:3.40.190.10:FF:000259', NULL, NULL, 'ABC transporter substrate-binding protein-phosphate transport', NULL, NULL, NULL, NULL, NULL, 4),
(200104, NULL, 'G3DSA:1.10.510.10:FF:001182', NULL, NULL, 'OSJNBa0061C06.4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(200105, NULL, 'G3DSA:2.60.40.10:FF:005024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200106, NULL, 'G3DSA:3.40.50.970:FF:000234', NULL, NULL, '2-oxoglutarate dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(200107, NULL, 'G3DSA:1.20.58.400:FF:000041', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(200108, NULL, 'G3DSA:2.40.50.960:FF:000004', NULL, NULL, 'Telomere replication protein EST3', NULL, NULL, NULL, NULL, NULL, 4),
(200109, NULL, 'G3DSA:2.60.120.260:FF:000179', NULL, NULL, 'Possible hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(200110, NULL, 'G3DSA:3.40.50.300:FF:000966', NULL, NULL, 'Peroxisomal biogenesis factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(200111, NULL, 'G3DSA:1.10.600.10:FF:000093', NULL, NULL, 'Farnesyl pyrophosphate synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(200112, NULL, 'G3DSA:3.40.50.2300:FF:000183', NULL, NULL, 'Sugar ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(200113, NULL, 'G3DSA:3.30.160.60:FF:003427', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200114, NULL, 'G3DSA:3.40.50.620:FF:000359', NULL, NULL, 'Probable arginine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(200115, NULL, 'G3DSA:1.25.40.10:FF:002718', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200116, NULL, 'G3DSA:1.10.150.170:FF:000002', NULL, NULL, 'Probable methyltransferase-like protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(200117, NULL, 'G3DSA:3.40.710.10:FF:000120', NULL, NULL, 'Penicillin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(200118, NULL, 'G3DSA:3.40.1190.20:FF:000110', NULL, NULL, 'Fructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(200119, NULL, 'G3DSA:3.30.70.330:FF:000852', NULL, NULL, 'Ribosomal protein L23', NULL, NULL, NULL, NULL, NULL, 4),
(200120, NULL, 'G3DSA:1.10.238.10:FF:001048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200121, NULL, 'G3DSA:2.10.90.10:FF:000015', NULL, NULL, 'Glial cell line-derived neurotrophic factor', NULL, NULL, NULL, NULL, NULL, 4),
(200122, NULL, 'G3DSA:3.50.50.60:FF:001232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200123, NULL, 'G3DSA:1.20.1740.10:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200124, NULL, 'G3DSA:3.20.10.10:FF:000002', NULL, NULL, 'D-alanine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(200125, NULL, 'G3DSA:3.40.309.10:FF:000058', NULL, NULL, 'Succinate-semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(200126, NULL, 'G3DSA:3.40.50.720:FF:000390', NULL, NULL, 'GDH/6PGL endoplasmic bifunctional protein', NULL, NULL, NULL, NULL, NULL, 4),
(200127, NULL, 'G3DSA:2.60.220.50:FF:000105', NULL, NULL, 'Adhesion G protein-coupled receptor E5', NULL, NULL, NULL, NULL, NULL, 4),
(200128, NULL, 'G3DSA:1.20.5.300:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200129, NULL, 'G3DSA:3.80.10.10:FF:000056', NULL, NULL, 'Leucine-rich repeat neuronal protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(200130, NULL, 'G3DSA:1.20.5.1200:FF:000004', NULL, NULL, 'Retinaldehyde binding protein 1b', NULL, NULL, NULL, NULL, NULL, 4),
(200131, NULL, 'G3DSA:2.60.40.10:FF:003079', NULL, NULL, 'Sialic-acid binding protein-4', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(200132, NULL, 'G3DSA:1.20.1250.20:FF:000520', NULL, NULL, 'Major facilitator superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(200133, NULL, 'G3DSA:1.25.10.10:FF:003144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200134, NULL, 'G3DSA:2.130.10.10:FF:004838', NULL, NULL, 'WD-repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(200135, NULL, 'G3DSA:3.40.50.300:FF:007205', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(200136, NULL, 'G3DSA:1.20.1440.360:FF:000001', NULL, NULL, 'PATJ, crumbs cell polarity complex component', NULL, NULL, NULL, NULL, NULL, 4),
(200137, NULL, 'G3DSA:1.20.1730.10:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200138, NULL, 'G3DSA:1.20.58.2050:FF:000006', NULL, NULL, 'At1g19080', NULL, NULL, NULL, NULL, NULL, 4),
(200139, NULL, 'G3DSA:3.40.1160.10:FF:000043', NULL, NULL, 'Aspartate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(200140, NULL, 'G3DSA:3.40.50.1820:FF:000802', NULL, NULL, 'AGAP006956-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(200141, NULL, 'G3DSA:1.25.10.10:FF:000873', NULL, NULL, 'Heat repeat domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(200142, NULL, 'G3DSA:3.40.50.620:FF:000921', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(200143, NULL, 'G3DSA:3.40.50.300:FF:007323', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200144, NULL, 'G3DSA:1.25.10.10:FF:003026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200145, NULL, 'G3DSA:3.40.190.10:FF:000568', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(200146, NULL, 'G3DSA:2.60.34.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200147, NULL, 'G3DSA:1.10.10.10:FF:001272', NULL, NULL, 'RNA polymerase sigma-38 factor, stationary phase', NULL, NULL, NULL, NULL, NULL, 4),
(200148, NULL, 'G3DSA:3.80.10.10:FF:002208', NULL, NULL, 'Si:dkey-261p22.1', NULL, NULL, NULL, NULL, NULL, 4),
(200149, NULL, 'G3DSA:3.10.580.10:FF:000110', NULL, NULL, 'Os03g0674300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(200150, NULL, 'G3DSA:3.40.50.880:FF:000078', NULL, NULL, 'GMP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(200151, NULL, 'G3DSA:3.40.50.300:FF:005171', NULL, NULL, 'rab-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(200152, NULL, 'G3DSA:3.40.50.720:FF:000642', NULL, NULL, 'Short-chain dehydrogenase/reductase SDR', NULL, NULL, NULL, NULL, NULL, 4),
(200153, NULL, 'G3DSA:3.60.20.10:FF:000063', NULL, NULL, 'Proteasome subunit alpha type', NULL, NULL, NULL, NULL, NULL, 4),
(200154, NULL, 'G3DSA:1.20.90.10:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200155, NULL, 'G3DSA:2.60.40.10:FF:000819', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(200156, NULL, 'G3DSA:1.25.10.10:FF:001036', NULL, NULL, 'Putative CAS/CSE/importin domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(200157, NULL, 'G3DSA:3.60.90.10:FF:000011', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(200158, NULL, 'G3DSA:1.10.760.10:FF:000076', NULL, NULL, 'Probable cytochrome c', NULL, NULL, NULL, NULL, NULL, 4),
(200159, NULL, 'G3DSA:3.40.50.2020:FF:000031', NULL, NULL, 'Probable PRS4-ribose-phosphate pyrophosphokinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(200160, NULL, 'G3DSA:3.30.70.850:FF:000024', NULL, NULL, 'Neuroendocrine convertase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200161, NULL, 'G3DSA:2.40.50.140:FF:000646', NULL, NULL, 'Single-stranded DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(200162, NULL, 'G3DSA:3.20.20.70:FF:000150', NULL, NULL, 'Pyridoxine 5''-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(200163, NULL, 'G3DSA:3.30.200.20:FF:000839', NULL, NULL, 'Serine/threonine-protein kinase RIO3', NULL, NULL, NULL, NULL, NULL, 4),
(200164, NULL, 'G3DSA:2.130.10.10:FF:000668', NULL, NULL, 'WD repeat-containing protein 13 isoform X3', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(200165, NULL, 'G3DSA:2.130.10.10:FF:002568', NULL, NULL, 'Syntaxin-binding protein 5 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(200166, NULL, 'G3DSA:3.30.160.60:FF:003118', NULL, NULL, 'Zinc finger and AT-hook domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(200167, NULL, 'G3DSA:3.30.420.10:FF:000038', NULL, NULL, 'IS30-like element IS30 family transposase', NULL, NULL, NULL, NULL, NULL, 4),
(200168, NULL, 'G3DSA:1.25.40.430:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200169, NULL, 'G3DSA:1.20.930.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200170, NULL, 'G3DSA:3.30.70.3030:FF:000005', NULL, NULL, 'Nucleolar protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(200171, NULL, 'G3DSA:2.10.25.10:FF:000409', NULL, NULL, 'Pro-epidermal growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(200172, NULL, 'G3DSA:3.90.70.80:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200173, NULL, 'G3DSA:2.40.50.40:FF:000116', NULL, NULL, 'Chromobox homolog 6b', NULL, NULL, NULL, NULL, NULL, 4),
(200174, NULL, 'G3DSA:2.10.50.10:FF:000131', NULL, NULL, 'Tumor necrosis factor receptor superfamily, member 1a', NULL, NULL, NULL, NULL, NULL, 4),
(200175, NULL, 'G3DSA:3.30.710.10:FF:000139', NULL, NULL, 'Leucine-zipper transcriptional regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(200176, NULL, 'G3DSA:3.10.310.10:FF:000046', NULL, NULL, 'trans-L-3-hydroxyproline dehydratase-like', NULL, NULL, NULL, NULL, NULL, 4),
(200177, NULL, 'G3DSA:3.30.70.3040:FF:000008', NULL, NULL, 'Cell division protein FtsX', NULL, NULL, NULL, NULL, NULL, 4),
(200178, NULL, 'G3DSA:3.90.1280.20:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200179, NULL, 'G3DSA:2.60.40.1250:FF:000004', NULL, NULL, 'Thiol:disulfide interchange protein DsbD', NULL, NULL, NULL, NULL, NULL, 4),
(200180, NULL, 'G3DSA:1.10.510.10:FF:003643', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200181, NULL, 'G3DSA:2.40.30.110:FF:000004', NULL, NULL, 'Pyruvate dehydrogenase phosphatase regulatory subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(200182, NULL, 'G3DSA:1.20.1080.10:FF:000037', NULL, NULL, 'Formate/nitrite transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200183, NULL, 'G3DSA:2.60.40.60:FF:001071', NULL, NULL, 'Fat1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(200184, NULL, 'G3DSA:1.20.5.110:FF:000252', NULL, NULL, 'Syntaxin-7A', NULL, NULL, NULL, NULL, NULL, 4),
(200185, NULL, 'G3DSA:3.90.180.10:FF:000062', NULL, NULL, 'Related to ADH2-Alcohol dehydrogenase II', NULL, NULL, NULL, NULL, NULL, 4),
(200186, NULL, 'G3DSA:1.20.920.10:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200187, NULL, 'G3DSA:1.10.510.10:FF:002738', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200188, NULL, 'G3DSA:3.30.300.110:FF:000013', NULL, NULL, 'Methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(200189, NULL, 'G3DSA:1.20.58.1480:FF:000026', NULL, NULL, 'protein cereblon isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(200190, NULL, 'G3DSA:1.10.340.70:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200191, NULL, 'G3DSA:3.40.50.720:FF:000047', NULL, NULL, 'NADP-dependent L-serine/L-allo-threonine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(200192, NULL, 'G3DSA:3.20.20.20:FF:000039', NULL, NULL, 'Dihydropteroate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(200193, NULL, 'G3DSA:3.30.950.10:FF:000022', NULL, NULL, 'Uroporphyrin-III C-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(200194, NULL, 'G3DSA:1.20.58.60:FF:000137', NULL, NULL, 'nesprin-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(200195, NULL, 'G3DSA:3.40.225.10:FF:000009', NULL, NULL, 'Class II aldolase/adducin N-terminal', NULL, NULL, NULL, NULL, NULL, 4),
(200196, NULL, 'G3DSA:1.10.287.70:FF:000027', NULL, NULL, 'Small conductance calcium-activated potassium channel, isoform O', NULL, NULL, NULL, NULL, NULL, 4),
(200197, NULL, 'G3DSA:3.50.50.60:FF:000097', NULL, NULL, 'Fructosyl amino acid oxidase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(200198, NULL, 'G3DSA:1.25.40.10:FF:004309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200199, NULL, 'G3DSA:1.10.10.10:FF:000558', NULL, NULL, 'ETS variant 7', NULL, NULL, NULL, NULL, NULL, 4),
(200200, NULL, 'G3DSA:2.40.30.100:FF:000001', NULL, NULL, 'Chaperonin involved in protein secretion (CsaA protein)', NULL, NULL, NULL, NULL, NULL, 4),
(200201, NULL, 'G3DSA:3.40.50.300:FF:007514', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200202, NULL, 'G3DSA:1.25.40.180:FF:000336', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200203, NULL, 'G3DSA:3.30.160.60:FF:001319', NULL, NULL, 'Spalt like transcription factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(200204, NULL, 'G3DSA:3.30.160.60:FF:005018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200205, NULL, 'G3DSA:1.10.8.10:FF:000124', NULL, NULL, 'Defective in cullin neddylation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(200206, NULL, 'G3DSA:3.50.50.60:FF:000209', NULL, NULL, 'Rab GDP dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(200207, NULL, 'G3DSA:3.40.50.2000:FF:000845', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(200208, NULL, 'G3DSA:1.10.420.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200209, NULL, 'G3DSA:2.10.25.10:FF:000308', NULL, NULL, 'Sushi, nidogen and EGF like domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(200210, NULL, 'G3DSA:2.10.10.100:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200211, NULL, 'G3DSA:3.90.660.10:FF:000110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200212, NULL, 'G3DSA:3.40.50.620:FF:000567', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200213, NULL, 'G3DSA:3.30.160.60:FF:003219', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(200214, NULL, 'G3DSA:3.30.160.60:FF:005119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200215, NULL, 'G3DSA:3.40.50.620:FF:000051', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(200216, NULL, 'G3DSA:3.30.450.20:FF:000133', NULL, NULL, 'Methyl-accepting chemotaxis protein signaling domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(200217, NULL, 'G3DSA:2.60.40.10:FF:001634', NULL, NULL, 'Beat-IIIc, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(200218, NULL, 'G3DSA:1.20.58.60:FF:000036', NULL, NULL, 'Plectin a', NULL, NULL, NULL, NULL, NULL, 4),
(200219, NULL, 'G3DSA:3.40.50.2300:FF:000149', NULL, NULL, 'Ribose operon repressor', NULL, NULL, NULL, NULL, NULL, 4),
(200220, NULL, 'G3DSA:2.60.40.10:FF:003006', NULL, NULL, 'Ephrin type-A receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(200221, NULL, 'G3DSA:1.25.40.10:FF:000358', NULL, NULL, 'Intraflagellar transport protein 88 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(200222, NULL, 'G3DSA:1.25.40.20:FF:001075', NULL, NULL, 'Ankyrin repeat, SAM and basic leucine zipper domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(200223, NULL, 'G3DSA:1.25.40.10:FF:001072', NULL, NULL, 'Vacuolar protein sorting-associated protein 41 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(200224, NULL, 'G3DSA:1.10.10.60:FF:000657', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200225, NULL, 'G3DSA:3.30.160.60:FF:001067', NULL, NULL, 'C2H2 transcription factor (Egr2)', NULL, NULL, NULL, NULL, NULL, 4),
(200226, NULL, 'G3DSA:2.60.40.150:FF:000497', NULL, NULL, 'Synaptotagmin 1', NULL, NULL, NULL, NULL, NULL, 4),
(200227, NULL, 'G3DSA:1.20.1560.10:FF:000372', NULL, NULL, 'Related to multidrug resistance protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(200228, NULL, 'G3DSA:2.60.40.1090:FF:000040', NULL, NULL, 'Type 1 fimbrial protein', NULL, NULL, NULL, NULL, NULL, 4),
(200229, NULL, 'G3DSA:2.40.160.110:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200230, NULL, 'G3DSA:1.10.10.10:FF:001064', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(200231, NULL, 'G3DSA:1.20.58.70:FF:000039', NULL, NULL, 'Syntaxin VAM3', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(200232, NULL, 'G3DSA:3.40.50.620:FF:000713', NULL, NULL, 'Nicotinamide-nucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(200233, NULL, 'G3DSA:3.40.190.90:FF:000002', NULL, NULL, 'Fructose-1,6-bisphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(200234, NULL, 'G3DSA:3.40.50.300:FF:005614', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200235, NULL, 'G3DSA:3.40.50.12160:FF:000020', NULL, NULL, 'tRNA methylthiotransferase YqeV', NULL, NULL, NULL, NULL, NULL, 4),
(200236, NULL, 'G3DSA:3.40.50.300:FF:008397', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200237, NULL, 'G3DSA:2.60.120.200:FF:000723', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200238, NULL, 'G3DSA:3.40.50.150:FF:001039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200239, NULL, 'G3DSA:3.90.215.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200240, NULL, 'G3DSA:1.20.1070.10:FF:000065', NULL, NULL, 'G-protein coupled receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(200241, NULL, 'G3DSA:3.90.870.10:FF:000002', NULL, NULL, '3,4-dihydroxy-2-butanone 4-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(200242, NULL, 'G3DSA:3.30.40.10:FF:000560', NULL, NULL, 'Putative PHD finger domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(200243, NULL, 'G3DSA:2.30.29.30:FF:000019', NULL, NULL, 'Amyloid beta (A4) precursor protein-binding, family B, member 1 (Fe65)', NULL, NULL, NULL, NULL, NULL, 4),
(200244, NULL, 'G3DSA:2.150.10.10:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200245, NULL, 'G3DSA:3.40.50.11660:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200246, NULL, 'G3DSA:3.40.50.1370:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200247, NULL, 'G3DSA:3.10.180.10:FF:000029', NULL, NULL, 'Lactoylglutathione lyase', NULL, NULL, NULL, NULL, NULL, 4),
(200248, NULL, 'G3DSA:3.40.1440.60:FF:000006', NULL, NULL, 'Primosomal protein N''', NULL, NULL, NULL, NULL, NULL, 4),
(200249, NULL, 'G3DSA:3.40.50.10490:FF:000165', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200250, NULL, 'G3DSA:1.20.1050.10:FF:000209', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(200251, NULL, 'G3DSA:1.20.1560.10:FF:000063', NULL, NULL, 'Multidrug resistance protein ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(200252, NULL, 'G3DSA:2.60.40.10:FF:003315', NULL, NULL, 'Contactin rig-6', NULL, NULL, NULL, NULL, NULL, 4),
(200253, NULL, 'G3DSA:2.40.50.140:FF:000394', NULL, NULL, 'rRNA biogenesis protein RRP5', NULL, NULL, NULL, NULL, NULL, 4),
(200254, NULL, 'G3DSA:3.90.1860.10:FF:000006', NULL, NULL, 'tRNA-splicing_ligase_RtcB_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(200255, NULL, 'G3DSA:3.30.2350.10:FF:000077', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(200256, NULL, 'G3DSA:1.10.287.130:FF:000225', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(200257, NULL, 'G3DSA:2.60.40.10:FF:004759', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200258, NULL, 'G3DSA:3.40.50.1110:FF:000123', NULL, NULL, 'Membrane-bound dehydrogenase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(200259, NULL, 'G3DSA:3.30.1010.10:FF:000147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200260, NULL, 'G3DSA:3.40.50.300:FF:001781', NULL, NULL, 'septin-12 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(200261, NULL, 'G3DSA:4.10.520.10:FF:000018', NULL, NULL, 'DNA binding protein HU', NULL, NULL, NULL, NULL, NULL, 4),
(200262, NULL, 'G3DSA:3.30.710.10:FF:000049', NULL, NULL, 'leucine-zipper-like transcriptional regulator 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(200263, NULL, 'G3DSA:2.30.42.10:FF:000555', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200264, NULL, 'G3DSA:2.130.10.10:FF:002000', NULL, NULL, 'Protein HIRA', NULL, NULL, NULL, NULL, NULL, 4),
(200265, NULL, 'G3DSA:3.40.1190.20:FF:000126', NULL, NULL, 'Fructokinase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(200266, NULL, 'G3DSA:3.20.20.80:FF:000405', NULL, NULL, 'Glucosylceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(200267, NULL, 'G3DSA:3.60.20.10:FF:000164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200268, NULL, 'G3DSA:3.40.50.620:FF:000258', NULL, NULL, 'YdcF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(200269, NULL, 'G3DSA:3.40.50.300:FF:007059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200270, NULL, 'G3DSA:3.80.10.10:FF:002551', NULL, NULL, 'Protein zer-1', NULL, NULL, NULL, NULL, NULL, 4),
(200271, NULL, 'G3DSA:3.40.30.10:FF:001256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200272, NULL, 'G3DSA:3.15.10.30:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200273, NULL, 'G3DSA:3.30.420.40:FF:000862', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200274, NULL, 'G3DSA:1.25.10.10:FF:002879', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200275, NULL, 'G3DSA:3.90.226.10:FF:000293', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200276, NULL, 'G3DSA:3.30.56.10:FF:000012', NULL, NULL, 'Phenylalanine-tRNA ligase, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(200277, NULL, 'G3DSA:1.10.510.10:FF:002828', NULL, NULL, 'Receptor tyrosine-protein kinase erbB-2', NULL, NULL, NULL, NULL, NULL, 4),
(200278, NULL, 'G3DSA:3.100.10.10:FF:000019', NULL, NULL, '50S ribosomal protein L15', NULL, NULL, NULL, NULL, NULL, 4),
(200279, NULL, 'G3DSA:3.30.420.10:FF:000302', NULL, NULL, 'Poly(A)-specific ribonuclease PARN', NULL, NULL, NULL, NULL, NULL, 4),
(200280, NULL, 'G3DSA:1.20.920.10:FF:000013', NULL, NULL, 'Protein polybromo-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(200281, NULL, 'G3DSA:3.40.50.12230:FF:000002', NULL, NULL, 'Bifunctional polymyxin resistance protein ArnA', NULL, NULL, NULL, NULL, NULL, 4),
(200282, NULL, 'G3DSA:3.90.1150.10:FF:000267', NULL, NULL, 'UDP-4-amino-4,6-dideoxy-N-acetyl-beta-L-altrosamine transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(200283, NULL, 'G3DSA:3.90.640.10:FF:000209', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(200284, NULL, 'G3DSA:1.25.40.720:FF:000009', NULL, NULL, 'Putative Clathrin interactor', NULL, NULL, NULL, NULL, NULL, 4),
(200285, NULL, 'G3DSA:2.60.40.1930:FF:000011', NULL, NULL, 'Complement C5', NULL, NULL, NULL, NULL, NULL, 4),
(200286, NULL, 'G3DSA:3.60.130.10:FF:000032', NULL, NULL, 'Os01g0190000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(200287, NULL, 'G3DSA:3.80.10.10:FF:000409', NULL, NULL, 'NLR family CARD domain containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(200288, NULL, 'G3DSA:1.20.1270.60:FF:000027', NULL, NULL, 'dynamin-binding protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(200289, NULL, 'G3DSA:3.20.20.80:FF:000714', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200290, NULL, 'G3DSA:6.10.140.2220:FF:000021', NULL, NULL, 'Putative ubiquitin carboxyl-terminal hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(200291, NULL, 'G3DSA:3.40.920.10:FF:000012', NULL, NULL, 'Oxoglutarate--ferredoxin oxidoreductase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(200292, NULL, 'G3DSA:1.10.10.460:FF:000003', NULL, NULL, 'Ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(200293, NULL, 'G3DSA:3.10.100.10:FF:000255', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200294, NULL, 'G3DSA:2.10.50.30:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200295, NULL, 'G3DSA:3.30.200.20:FF:000278', NULL, NULL, 'Calcium/calmodulin-dependent protein kinase II', NULL, NULL, NULL, NULL, NULL, 4),
(200296, NULL, 'G3DSA:2.60.40.10:FF:006098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200297, NULL, 'G3DSA:3.40.50.720:FF:002087', NULL, NULL, 'Sepiapterin reductase', NULL, NULL, NULL, NULL, NULL, 4),
(200298, NULL, 'G3DSA:3.30.160.60:FF:001730', NULL, NULL, 'zinc finger protein 660', NULL, NULL, NULL, NULL, NULL, 4),
(200299, NULL, 'G3DSA:1.25.40.10:FF:000667', NULL, NULL, 'Transcription factor TFIIIC subunit', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(200300, NULL, 'G3DSA:3.90.660.10:FF:000065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200301, NULL, 'G3DSA:3.40.50.1820:FF:000095', NULL, NULL, 'Triglyceride lipase-cholesterol esterase', NULL, NULL, NULL, NULL, NULL, 4),
(200302, NULL, 'G3DSA:2.60.120.260:FF:000634', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200303, NULL, 'G3DSA:3.40.50.300:FF:005524', NULL, NULL, 'Putative helicase of the dead superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(200304, NULL, 'G3DSA:1.20.1250.20:FF:000065', NULL, NULL, 'Putative MFS pantothenate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(200305, NULL, 'G3DSA:1.20.58.1120:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200306, NULL, 'G3DSA:1.10.472.10:FF:000266', NULL, NULL, 'WGS project CABT00000000 data, contig 2.12', NULL, NULL, NULL, NULL, NULL, 4),
(200307, NULL, 'G3DSA:1.10.220.30:FF:000013', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(200308, NULL, 'G3DSA:3.30.70.260:FF:000044', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(200309, NULL, 'G3DSA:2.60.40.10:FF:004198', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200310, NULL, 'G3DSA:3.40.50.300:FF:001472', NULL, NULL, 'SNF2 family N-terminal domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(200311, NULL, 'G3DSA:1.10.150.20:FF:000049', NULL, NULL, 'Plastid replication-repair enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(200312, NULL, 'G3DSA:1.20.1560.10:FF:000282', NULL, NULL, 'ATP-binding cassette transporter', NULL, NULL, NULL, NULL, NULL, 4),
(200313, NULL, 'G3DSA:3.90.1070.20:FF:000005', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(200314, NULL, 'G3DSA:1.20.1250.20:FF:002217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200315, NULL, 'G3DSA:2.60.40.60:FF:000918', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200316, NULL, 'G3DSA:1.25.40.10:FF:005124', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(200317, NULL, 'G3DSA:1.25.10.10:FF:002672', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(200318, NULL, 'G3DSA:1.10.220.20:FF:000010', NULL, NULL, 'ArfGEF', NULL, NULL, NULL, NULL, NULL, 4),
(200319, NULL, 'G3DSA:2.170.130.10:FF:000083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200320, NULL, 'G3DSA:3.80.10.10:FF:003945', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200321, NULL, 'G3DSA:3.30.160.60:FF:003321', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200322, NULL, 'G3DSA:3.30.160.60:FF:001421', NULL, NULL, 'Zinc finger protein 646', NULL, NULL, NULL, NULL, NULL, 4),
(200323, NULL, 'G3DSA:3.40.50.1820:FF:000140', NULL, NULL, 'Esterase/lipase/thioesterase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(200324, NULL, 'G3DSA:1.10.101.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200325, NULL, 'G3DSA:2.60.120.260:FF:000589', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200326, NULL, 'G3DSA:2.30.30.830:FF:000003', NULL, NULL, 'General secretion pathway protein C', NULL, NULL, NULL, NULL, NULL, 4),
(200327, NULL, 'G3DSA:3.40.630.10:FF:000378', NULL, NULL, 'Glutamate carboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200328, NULL, 'G3DSA:2.30.29.30:FF:000480', NULL, NULL, 'Oxysterol-binding protein-related protein 2A', NULL, NULL, NULL, NULL, NULL, 4),
(200329, NULL, 'G3DSA:3.30.40.210:FF:000006', NULL, NULL, 'Transcription elongation factor SPT4', NULL, NULL, NULL, NULL, NULL, 4),
(200330, NULL, 'G3DSA:2.10.50.10:FF:000041', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 5', NULL, NULL, NULL, NULL, NULL, 4),
(200331, NULL, 'G3DSA:1.25.40.180:FF:000027', NULL, NULL, 'Eukaryotic translation initiation factor isoform 4G-2', NULL, NULL, NULL, NULL, NULL, 4),
(200332, NULL, 'G3DSA:1.50.10.160:FF:000005', NULL, NULL, 'Terpene synthase family protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(200333, NULL, 'G3DSA:1.50.10.150:FF:000002', NULL, NULL, 'Tellurite resistance protein TehA', NULL, NULL, NULL, NULL, NULL, 4),
(200334, NULL, 'G3DSA:2.30.30.100:FF:000138', NULL, NULL, 'Small nuclear ribonucleoprotein (LSM7), putative', NULL, NULL, NULL, NULL, NULL, 4),
(200335, NULL, 'G3DSA:3.80.10.10:FF:003636', NULL, NULL, 'Leucine rich repeat, Ig-like and transmembrane domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(200336, NULL, 'G3DSA:3.40.220.10:FF:000004', NULL, NULL, 'chromodomain-helicase-DNA-binding protein 1-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(200337, NULL, 'G3DSA:3.30.300.130:FF:000019', NULL, NULL, 'Nucleotide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(200338, NULL, 'G3DSA:1.20.920.20:FF:000016', NULL, NULL, 'Axonemal dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(200339, NULL, 'G3DSA:3.90.1070.10:FF:000002', NULL, NULL, 'Probable sucrose-phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(200340, NULL, 'G3DSA:3.40.850.10:FF:000405', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200341, NULL, 'G3DSA:3.30.160.60:FF:004855', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200342, NULL, 'G3DSA:1.10.8.10:FF:000034', NULL, NULL, 'Sequestosome 1', NULL, NULL, NULL, NULL, NULL, 4),
(200343, NULL, 'G3DSA:1.20.920.30:FF:000019', NULL, NULL, 'Dynein heavy chain at 89D, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(200344, NULL, 'G3DSA:3.30.470.20:FF:000241', NULL, NULL, 'GTP-specific succinyl-CoA synthetase, beta subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200345, NULL, 'G3DSA:2.60.40.1730:FF:000041', NULL, NULL, 'Protein CBG19917', NULL, NULL, NULL, NULL, NULL, 4),
(200346, NULL, 'G3DSA:3.20.20.80:FF:000153', NULL, NULL, 'Chitinase A1', NULL, NULL, NULL, NULL, NULL, 4),
(200347, NULL, 'G3DSA:1.20.1250.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200348, NULL, 'G3DSA:2.130.10.30:FF:000106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200349, NULL, 'G3DSA:3.30.70.270:FF:000047', NULL, NULL, 'Diguanylate cyclase (GGDEF) domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(200350, NULL, 'G3DSA:1.20.1250.20:FF:000374', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200351, NULL, 'G3DSA:2.60.40.10:FF:003225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200352, NULL, 'G3DSA:1.10.472.10:FF:000575', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200353, NULL, 'G3DSA:2.130.10.10:FF:003282', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(200354, NULL, 'G3DSA:3.90.70.200:FF:000013', NULL, NULL, 'RNA polymerase-associated protein RTF1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(200355, NULL, 'G3DSA:2.160.20.10:FF:000263', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(200356, NULL, 'G3DSA:3.40.50.1820:FF:000656', NULL, NULL, 'Lipase', NULL, NULL, NULL, NULL, NULL, 4),
(200357, NULL, 'G3DSA:3.40.367.20:FF:000010', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(200358, NULL, 'G3DSA:3.40.190.10:FF:000714', NULL, NULL, 'Arginine-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(200359, NULL, 'G3DSA:3.10.129.10:FF:000219', NULL, NULL, 'Thioesterase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(200360, NULL, 'G3DSA:3.30.70.3020:FF:000002', NULL, NULL, 'U3 small nucleolar RNA-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(200361, NULL, 'G3DSA:2.60.120.260:FF:000073', NULL, NULL, 'Laminin subunit beta 3', NULL, NULL, NULL, NULL, NULL, 4),
(200362, NULL, 'G3DSA:3.40.50.2300:FF:000374', NULL, NULL, 'Type 4 fimbriae expression regulatory protein pilR', NULL, NULL, NULL, NULL, NULL, 4),
(200363, NULL, 'G3DSA:3.40.50.2000:FF:000391', NULL, NULL, '2-deoxystreptamine N-acetyl-D-glucosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(200364, NULL, 'G3DSA:3.50.50.60:FF:000327', NULL, NULL, 'PROBABLE MONOXYGENASE', NULL, NULL, NULL, NULL, NULL, 4),
(200365, NULL, 'G3DSA:3.40.1440.10:FF:000008', NULL, NULL, 'Structure-specific endonuclease subunit SLX1 homolog', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(200366, NULL, 'G3DSA:1.20.1070.10:FF:001953', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200367, NULL, 'G3DSA:2.40.15.10:FF:000003', NULL, NULL, 'T cell leukemia/lymphoma 1B', NULL, NULL, NULL, NULL, NULL, 4),
(200368, NULL, 'G3DSA:1.10.510.10:FF:001103', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(200369, NULL, 'G3DSA:1.10.10.10:FF:001300', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(200370, NULL, 'G3DSA:3.40.50.10490:FF:000081', NULL, NULL, 'Glucose-6-phosphate isomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(200371, NULL, 'G3DSA:3.40.50.1910:FF:000032', NULL, NULL, 'Vacuolar protein sorting-associated protein 33B', NULL, NULL, NULL, NULL, NULL, 4),
(200372, NULL, 'G3DSA:3.30.559.10:FF:000141', NULL, NULL, 'Probable alcohol acetyltransferase crmB', NULL, NULL, NULL, NULL, NULL, 4),
(200373, NULL, 'G3DSA:3.90.1150.210:FF:000023', NULL, NULL, 'F-actin-capping protein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(200374, NULL, 'G3DSA:1.10.510.10:FF:003227', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200375, NULL, 'G3DSA:3.40.50.300:FF:000949', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(200376, NULL, 'G3DSA:1.10.150.60:FF:000027', NULL, NULL, 'Putative arid bright dna binding domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(200377, NULL, 'G3DSA:1.10.268.10:FF:000010', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(200378, NULL, 'G3DSA:3.30.200.20:FF:001227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200379, NULL, 'G3DSA:3.40.20.10:FF:000103', NULL, NULL, 'Gelsolin, isoform J', NULL, NULL, NULL, NULL, NULL, 4),
(200380, NULL, 'G3DSA:1.20.1270.10:FF:000046', NULL, NULL, 'Chaperone protein HscA homolog', NULL, NULL, NULL, NULL, NULL, 4),
(200381, NULL, 'G3DSA:3.90.810.10:FF:000009', NULL, NULL, 'Wiskott-Aldrich syndrome (eczema-thrombocytopenia) a', NULL, NULL, NULL, NULL, NULL, 4),
(200382, NULL, 'G3DSA:2.10.25.10:FF:000191', NULL, NULL, 'Multiple epidermal growth factor-like domains 8', NULL, NULL, NULL, NULL, NULL, 4),
(200383, NULL, 'G3DSA:2.30.29.30:FF:000906', NULL, NULL, 'pleckstrin-2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(200384, NULL, 'G3DSA:2.20.70.10:FF:000059', NULL, NULL, 'pleckstrin homology domain-containing family A member 7', NULL, NULL, NULL, NULL, NULL, 4),
(200385, NULL, 'G3DSA:1.10.287.70:FF:000145', NULL, NULL, 'Eag-like K[+] channel, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(200386, NULL, 'G3DSA:2.40.50.70:FF:000001', NULL, NULL, 'Shiga toxin 1 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(200387, NULL, 'G3DSA:3.40.50.1820:FF:000347', NULL, NULL, 'EF-hand calcium-binding domain protein, putative (AFU_orthologue AFUA_2G01310)', NULL, NULL, NULL, NULL, NULL, 4),
(200388, NULL, 'G3DSA:1.25.10.10:FF:001452', NULL, NULL, 'Formin, involved in spindle orientation, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200389, NULL, 'G3DSA:3.30.1120.30:FF:000032', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(200390, NULL, 'G3DSA:1.10.950.10:FF:000006', NULL, NULL, 'Villin-2', NULL, NULL, NULL, NULL, NULL, 4),
(200391, NULL, 'G3DSA:3.30.70.330:FF:002566', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200392, NULL, 'G3DSA:2.60.40.10:FF:001090', NULL, NULL, 'T cell receptor beta constant 1', NULL, NULL, NULL, NULL, NULL, 4),
(200393, NULL, 'G3DSA:1.25.10.10:FF:002447', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200394, NULL, 'G3DSA:3.40.50.10380:FF:000031', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(200395, NULL, 'G3DSA:1.10.10.10:FF:001182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200396, NULL, 'G3DSA:3.30.300.130:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200397, NULL, 'G3DSA:3.30.565.10:FF:000447', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(200398, NULL, 'G3DSA:3.30.70.330:FF:002459', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(200399, NULL, 'G3DSA:3.20.20.80:FF:000506', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200400, NULL, 'G3DSA:3.90.190.10:FF:000220', NULL, NULL, 'Putative dual-specificity protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200401, NULL, 'G3DSA:3.40.50.300:FF:005154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200402, NULL, 'G3DSA:3.30.2290.10:FF:000021', NULL, NULL, 'Microcin-processing peptidase 2 (TldD)', NULL, NULL, NULL, NULL, NULL, 4),
(200403, NULL, 'G3DSA:3.30.70.260:FF:000134', NULL, NULL, 'ACT domain-containing protein ACR11', NULL, NULL, NULL, NULL, NULL, 4),
(200404, NULL, 'G3DSA:1.50.10.20:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200405, NULL, 'G3DSA:3.40.50.880:FF:000095', NULL, NULL, 'Putative glutamine amidotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(200406, NULL, 'G3DSA:3.40.50.150:FF:001056', NULL, NULL, '23S rRNA (Guanine(748)-N(1))-methyltransferase Erm(32)', NULL, NULL, NULL, NULL, NULL, 4),
(200407, NULL, 'G3DSA:2.10.25.10:FF:000202', NULL, NULL, 'Multiple epidermal growth factor-like domains 8', NULL, NULL, NULL, NULL, NULL, 4),
(200408, NULL, 'G3DSA:3.40.50.720:FF:001598', NULL, NULL, 'YALI0C11451p', NULL, NULL, NULL, NULL, NULL, 4),
(200409, NULL, 'G3DSA:3.40.50.300:FF:002990', NULL, NULL, 'ATPase family AAA domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(200410, NULL, 'G3DSA:1.20.1070.10:FF:000418', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(200411, NULL, 'G3DSA:2.30.30.40:FF:000666', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(200412, NULL, 'G3DSA:3.30.70.270:FF:000137', NULL, NULL, 'Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(200413, NULL, 'G3DSA:1.20.1560.10:FF:000400', NULL, NULL, 'ABC transporter PGP-2', NULL, NULL, NULL, NULL, NULL, 4),
(200414, NULL, 'G3DSA:3.40.50.620:FF:000831', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200415, NULL, 'G3DSA:1.10.150.50:FF:000024', NULL, NULL, 'Putative sam and sh3 domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(200416, NULL, 'G3DSA:1.10.287.70:FF:000252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200417, NULL, 'G3DSA:3.40.50.300:FF:006935', NULL, NULL, 'Spr28p', NULL, NULL, NULL, NULL, NULL, 4),
(200418, NULL, 'G3DSA:3.30.470.20:FF:000016', NULL, NULL, 'Ribosomal protein S6--L-glutamate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(200419, NULL, 'G3DSA:1.25.40.10:FF:000818', NULL, NULL, 'Sperm-associated antigen 1A', NULL, NULL, NULL, NULL, NULL, 4),
(200420, NULL, 'G3DSA:1.10.1740.100:FF:000006', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(200421, NULL, 'G3DSA:3.40.50.1000:FF:000759', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200422, NULL, 'G3DSA:1.10.10.410:FF:000011', NULL, NULL, 'Aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(200423, NULL, 'G3DSA:1.20.910.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200424, NULL, 'G3DSA:3.10.28.10:FF:000066', NULL, NULL, 'Probable translation initiation factor IF-2', NULL, NULL, NULL, NULL, NULL, 4),
(200425, NULL, 'G3DSA:3.90.320.10:FF:000051', NULL, NULL, 'CRISPR-associated exonuclease Cas4', NULL, NULL, NULL, NULL, NULL, 4),
(200426, NULL, 'G3DSA:3.40.390.10:FF:000117', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(200427, NULL, 'G3DSA:1.50.10.20:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200428, NULL, 'G3DSA:2.10.110.10:FF:000265', NULL, NULL, 'transcription factor protein', NULL, NULL, NULL, NULL, NULL, 4),
(200429, NULL, 'G3DSA:2.30.42.10:FF:000448', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200430, NULL, 'G3DSA:3.30.470.10:FF:000013', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(200431, NULL, 'G3DSA:1.20.58.60:FF:000581', NULL, NULL, 'Plectin', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(200432, NULL, 'G3DSA:1.25.40.180:FF:000218', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200433, NULL, 'G3DSA:1.10.1320.10:FF:000025', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(200434, NULL, 'G3DSA:3.30.2230.10:FF:000012', NULL, NULL, 'Ubiquitin-specific protease 5', NULL, NULL, NULL, NULL, NULL, 4),
(200435, NULL, 'G3DSA:3.30.160.60:FF:003337', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200436, NULL, 'G3DSA:1.50.10.10:FF:000106', NULL, NULL, 'Alpha-L-fucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(200437, NULL, 'G3DSA:1.25.40.10:FF:005332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200438, NULL, 'G3DSA:3.40.50.800:FF:000071', NULL, NULL, 'Threonine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(200439, NULL, 'G3DSA:3.50.50.60:FF:000962', NULL, NULL, 'Thiamine biosynthesis oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(200440, NULL, 'G3DSA:1.25.40.10:FF:004719', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(200441, NULL, 'G3DSA:3.40.50.10090:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200442, NULL, 'G3DSA:1.20.1070.10:FF:000172', NULL, NULL, 'G protein-coupled receptor 50', NULL, NULL, NULL, NULL, NULL, 4),
(200443, NULL, 'G3DSA:3.30.70.330:FF:000442', NULL, NULL, 'Multiple RNA-binding domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(200444, NULL, 'G3DSA:3.60.110.10:FF:000031', NULL, NULL, 'Unplaced genomic scaffold supercont1.137, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(200445, NULL, 'G3DSA:3.50.50.60:FF:000653', NULL, NULL, 'D-amino acid dehydrogenase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(200446, NULL, 'G3DSA:3.40.190.10:FF:000922', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(200447, NULL, 'G3DSA:3.90.550.10:FF:000675', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200448, NULL, 'G3DSA:2.40.50.90:FF:000007', NULL, NULL, 'tudor domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(200449, NULL, 'G3DSA:1.20.1540.10:FF:000056', NULL, NULL, 'Peptidase, S54 family', NULL, NULL, NULL, NULL, NULL, 4),
(200450, NULL, 'G3DSA:3.30.460.10:FF:000041', NULL, NULL, 'PAP/25A associated domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(200451, NULL, 'G3DSA:1.20.120.1750:FF:000087', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(200452, NULL, 'G3DSA:1.25.40.10:FF:005023', NULL, NULL, 'Diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(200453, NULL, 'G3DSA:3.30.420.40:FF:000946', NULL, NULL, 'Actin-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(200454, NULL, 'G3DSA:3.60.120.10:FF:000003', NULL, NULL, 'Anthranilate synthase component 1', NULL, NULL, NULL, NULL, NULL, 4),
(200455, NULL, 'G3DSA:3.30.70.260:FF:000027', NULL, NULL, '(P)ppGpp synthetase II', NULL, NULL, NULL, NULL, NULL, 4),
(200456, NULL, 'G3DSA:3.40.50.10190:FF:000002', NULL, NULL, 'Pescadillo homolog', NULL, NULL, NULL, NULL, NULL, 4),
(200457, NULL, 'G3DSA:2.40.50.140:FF:001012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200458, NULL, 'G3DSA:3.30.160.60:FF:000696', NULL, NULL, 'Zinc finger and BTB domain containing 40', NULL, NULL, NULL, NULL, NULL, 4),
(200459, NULL, 'G3DSA:3.40.50.150:FF:001382', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200460, NULL, 'G3DSA:1.10.10.60:FF:000904', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200461, NULL, 'G3DSA:1.10.10.10:FF:001502', NULL, NULL, 'Transcriptional regulator, Crp/Fnr family', NULL, NULL, NULL, NULL, NULL, 4),
(200462, NULL, 'G3DSA:1.10.260.30:FF:000004', NULL, NULL, 'Signal recognition particle 54 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(200463, NULL, 'G3DSA:1.25.40.10:FF:002275', NULL, NULL, 'YALI0D16225p', NULL, NULL, NULL, NULL, NULL, 4),
(200464, NULL, 'G3DSA:2.30.30.10:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200465, NULL, 'G3DSA:3.30.70.250:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(200466, NULL, 'G3DSA:1.10.1410.40:FF:000013', NULL, NULL, 'ILF3 isoform 19', NULL, NULL, NULL, NULL, NULL, 4),
(200467, NULL, 'G3DSA:3.60.70.12:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200468, NULL, 'G3DSA:3.40.50.620:FF:000152', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(200469, NULL, 'G3DSA:1.25.10.10:FF:002773', NULL, NULL, 'Exportin-T', NULL, NULL, NULL, NULL, NULL, 4),
(200470, NULL, 'G3DSA:1.25.40.10:FF:004399', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200471, NULL, 'G3DSA:3.40.50.720:FF:000833', NULL, NULL, 'Phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(200472, NULL, 'G3DSA:1.25.40.530:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200473, NULL, 'G3DSA:3.10.20.90:FF:000004', NULL, NULL, 'Polyubiquitin Ubiquitin', NULL, NULL, NULL, NULL, NULL, 4),
(200474, NULL, 'G3DSA:3.40.50.150:FF:001258', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200475, NULL, 'G3DSA:3.30.70.330:FF:001150', NULL, NULL, 'RNP-1 like RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(200476, NULL, 'G3DSA:2.60.120.200:FF:000622', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200477, NULL, 'G3DSA:3.30.2090.10:FF:000023', NULL, NULL, 'Transporter, AcrB/D/F family', NULL, NULL, NULL, NULL, NULL, 4),
(200478, NULL, 'G3DSA:4.10.740.10:FF:000001', NULL, NULL, 'vitamin K-dependent protein S', NULL, NULL, NULL, NULL, NULL, 4),
(200479, NULL, 'G3DSA:1.25.40.10:FF:003415', NULL, NULL, 'TPR repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200480, NULL, 'G3DSA:3.30.310.80:FF:000034', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(200481, NULL, 'G3DSA:2.60.40.1090:FF:000023', NULL, NULL, 'Fimbrial protein YfcV', NULL, NULL, NULL, NULL, NULL, 4),
(200482, NULL, 'G3DSA:3.40.50.720:FF:000182', NULL, NULL, 'NAD-dependent malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(200483, NULL, 'G3DSA:3.30.70.330:FF:000661', NULL, NULL, 'Os08g0504600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(200484, NULL, 'G3DSA:2.60.120.200:FF:000162', NULL, NULL, 'Glycosidase', NULL, NULL, NULL, NULL, NULL, 4),
(200485, NULL, 'G3DSA:2.60.120.200:FF:000313', NULL, NULL, 'L-type lectin-domain containing receptor kinase S.6', NULL, NULL, NULL, NULL, NULL, 4),
(200486, NULL, 'G3DSA:3.40.850.10:FF:000260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200487, NULL, 'G3DSA:2.130.10.10:FF:005120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200488, NULL, 'G3DSA:3.40.570.10:FF:000013', NULL, NULL, 'Serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(200489, NULL, 'G3DSA:2.40.70.10:FF:000373', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200490, NULL, 'G3DSA:3.40.1190.20:FF:000020', NULL, NULL, 'ADP-dependent glucokinase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(200491, NULL, 'G3DSA:3.40.50.300:FF:007071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200492, NULL, 'G3DSA:3.40.50.300:FF:005631', NULL, NULL, 'MutS protein homolog him-14', NULL, NULL, NULL, NULL, NULL, 4),
(200493, NULL, 'G3DSA:3.40.50.620:FF:000612', NULL, NULL, 'Leucyl-tRNA synthetase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(200494, NULL, 'G3DSA:1.20.120.720:FF:000024', NULL, NULL, 'unconventional myosin-XV isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(200495, NULL, 'G3DSA:3.60.40.10:FF:000300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200496, NULL, 'G3DSA:2.10.50.10:FF:000024', NULL, NULL, 'signal peptide, CUB and EGF-like domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(200497, NULL, 'G3DSA:1.25.40.10:FF:002584', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(200498, NULL, 'G3DSA:2.60.40.10:FF:000898', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', NULL, NULL, NULL, NULL, NULL, 4),
(200499, NULL, 'G3DSA:3.10.620.30:FF:000013', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(200500, NULL, 'G3DSA:3.40.50.1980:FF:000148', NULL, NULL, 'Putative iron ABC transporter, periplasmic iron-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(200501, NULL, 'G3DSA:3.90.226.10:FF:000186', NULL, NULL, 'Enoyl-CoA_hydratase/isomerase_family/2-enoyl-CoA_Hydratase_C-terminal_region_containing_protein', NULL, NULL, NULL, NULL, NULL, 4),
(200502, NULL, 'G3DSA:3.40.50.300:FF:005940', NULL, NULL, 'AGAP008081-PA', NULL, NULL, NULL, NULL, NULL, 4),
(200503, NULL, 'G3DSA:3.40.50.620:FF:000461', NULL, NULL, 'Glutamine-dependent NAD(+) synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(200504, NULL, 'G3DSA:3.70.10.10:FF:000011', NULL, NULL, 'Damaged DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(200505, NULL, 'G3DSA:1.20.1090.10:FF:000055', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(200506, NULL, 'G3DSA:2.40.50.140:FF:000539', NULL, NULL, 'Replication protein A 70 kDa DNA-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(200507, NULL, 'G3DSA:3.30.470.30:FF:000019', NULL, NULL, 'Mitochondrial RNA ligase 1', NULL, NULL, NULL, NULL, NULL, 4),
(200508, NULL, 'G3DSA:2.10.110.10:FF:000063', NULL, NULL, 'LIM domain-binding protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(200509, NULL, 'G3DSA:2.130.10.10:FF:002377', NULL, NULL, 'Os01g0551900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(200510, NULL, 'G3DSA:1.20.5.460:FF:000008', NULL, NULL, 'Listeriolysin transcriptional regulator PrfA', NULL, NULL, NULL, NULL, NULL, 4),
(200511, NULL, 'G3DSA:3.30.160.20:FF:000004', NULL, NULL, 'Peptide chain release factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(200512, NULL, 'G3DSA:1.10.375.10:FF:000006', NULL, NULL, 'Gag polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(200513, NULL, 'G3DSA:2.60.40.10:FF:005142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200514, NULL, 'G3DSA:3.40.50.1110:FF:000022', NULL, NULL, 'Isoamyl acetate-hydrolyzing esterase', NULL, NULL, NULL, NULL, NULL, 4),
(200515, NULL, 'G3DSA:3.40.50.1460:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200516, NULL, 'G3DSA:3.80.10.10:FF:004108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200517, NULL, 'G3DSA:3.40.50.150:FF:001691', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200518, NULL, 'G3DSA:1.20.120.1630:FF:000034', NULL, NULL, 'Uncharacterized protein C7D4.09c', NULL, NULL, NULL, NULL, NULL, 4),
(200519, NULL, 'G3DSA:2.40.50.140:FF:000293', NULL, NULL, '26S protease regulatory subunit 6B homolog', NULL, NULL, NULL, NULL, NULL, 4),
(200520, NULL, 'G3DSA:3.60.10.10:FF:000326', NULL, NULL, 'Deoxyribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(200521, NULL, 'G3DSA:1.10.1520.10:FF:000113', NULL, NULL, 'Endoribonuclease Dicer homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(200522, NULL, 'G3DSA:1.10.10.60:FF:000893', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200523, NULL, 'G3DSA:1.10.238.10:FF:001166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200524, NULL, 'G3DSA:3.30.565.10:FF:000554', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(200525, NULL, 'G3DSA:2.70.70.10:FF:000006', NULL, NULL, 'M23 family peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(200526, NULL, 'G3DSA:3.60.15.10:FF:000197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200527, NULL, 'G3DSA:3.90.110.10:FF:000018', NULL, NULL, 'Malate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(200528, NULL, 'G3DSA:1.10.287.130:FF:000006', NULL, NULL, 'Osmolarity two-component histidine kinase EnvZ', NULL, NULL, NULL, NULL, NULL, 4),
(200529, NULL, 'G3DSA:3.30.1490.20:FF:000005', NULL, NULL, 'Probable alpha-L-glutamate ligase 1', NULL, NULL, NULL, NULL, NULL, 4),
(200530, NULL, 'G3DSA:3.20.20.80:FF:000260', NULL, NULL, '4-alpha-glucanotransferase DPE2', NULL, NULL, NULL, NULL, NULL, 4),
(200531, NULL, 'G3DSA:2.60.40.1240:FF:000001', NULL, NULL, 'Immunogenic protein MPT63', NULL, NULL, NULL, NULL, NULL, 4),
(200532, NULL, 'G3DSA:3.80.10.10:FF:002326', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(200533, NULL, 'G3DSA:3.40.630.150:FF:000001', NULL, NULL, 'Malonyl-CoA decarboxylase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(200534, NULL, 'G3DSA:3.30.200.20:FF:000194', NULL, NULL, 'protein-tyrosine kinase 2-beta isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(200535, NULL, 'G3DSA:2.130.10.10:FF:003517', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200536, NULL, 'G3DSA:2.60.40.820:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200537, NULL, 'G3DSA:1.10.510.10:FF:003334', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200538, NULL, 'G3DSA:3.40.50.80:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200539, NULL, 'G3DSA:1.25.40.20:FF:001620', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200540, NULL, 'G3DSA:2.60.210.10:FF:000087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200541, NULL, 'G3DSA:2.170.270.10:FF:000177', NULL, NULL, 'Myeloid/lymphoid or mixed-lineage leukemia', NULL, NULL, NULL, NULL, NULL, 4),
(200542, NULL, 'G3DSA:1.10.510.10:FF:002845', NULL, NULL, 'Receptor-like histidine kinase BpdS', NULL, NULL, NULL, NULL, NULL, 4),
(200543, NULL, 'G3DSA:2.60.120.650:FF:000083', NULL, NULL, 'Protein CBG17151', NULL, NULL, NULL, NULL, NULL, 4),
(200544, NULL, 'G3DSA:1.20.940.10:FF:000003', NULL, NULL, 'Protein transport protein SEC31 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(200545, NULL, 'G3DSA:3.80.10.10:FF:004541', NULL, NULL, 'Os08g0196200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(200546, NULL, 'G3DSA:2.170.130.10:FF:000009', NULL, NULL, 'SusC/RagA family TonB-linked outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(200547, NULL, 'G3DSA:2.40.128.180:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200548, NULL, 'G3DSA:3.40.850.10:FF:000170', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(200549, NULL, 'G3DSA:1.20.58.60:FF:000255', NULL, NULL, 'VAB-10B protein', NULL, NULL, NULL, NULL, NULL, 4),
(200550, NULL, 'G3DSA:3.30.70.360:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200551, NULL, 'G3DSA:1.20.920.10:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200552, NULL, 'G3DSA:3.40.30.10:FF:000969', NULL, NULL, 'Diacylglycerol O-acyltransferase 3', NULL, NULL, NULL, NULL, NULL, 4),
(200553, NULL, 'G3DSA:3.90.740.10:FF:000049', NULL, NULL, 'Os01g0120300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(200554, NULL, 'G3DSA:3.40.630.30:FF:000035', NULL, NULL, 'GNAT family N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(200555, NULL, 'G3DSA:3.30.70.1390:FF:000007', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(200556, NULL, 'G3DSA:1.25.40.90:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200557, NULL, 'G3DSA:3.40.50.10280:FF:000001', NULL, NULL, 'Putative methylene tetrahydromethanopterin dehydrogenase/methylenetetrahydrofolate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(200558, NULL, 'G3DSA:3.40.50.10190:FF:000311', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(200559, NULL, 'G3DSA:3.30.70.330:FF:000970', NULL, NULL, 'Flowering time control protein FCA isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(200560, NULL, 'G3DSA:2.130.10.10:FF:002686', NULL, NULL, 'YALI0C18117p', NULL, NULL, NULL, NULL, NULL, 4),
(200561, NULL, 'G3DSA:2.130.10.10:FF:000915', NULL, NULL, 'TLE family member 7', NULL, NULL, NULL, NULL, NULL, 4),
(200562, NULL, 'G3DSA:3.30.1370.10:FF:000168', NULL, NULL, 'Exosome non-catalytic core subunit', NULL, NULL, NULL, NULL, NULL, 4),
(200563, NULL, 'G3DSA:3.10.350.10:FF:000037', NULL, NULL, 'Class V chitinase Chi100', NULL, NULL, NULL, NULL, NULL, 4),
(200564, NULL, 'G3DSA:3.30.1520.10:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200565, NULL, 'G3DSA:1.20.1050.10:FF:000316', NULL, NULL, 'Methionine--tRNA ligase, cytoplasmic-like Protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(200566, NULL, 'G3DSA:3.40.50.2300:FF:000065', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(200567, NULL, 'G3DSA:3.40.630.170:FF:000007', NULL, NULL, 'Glycylpeptide N-tetradecanoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(200568, NULL, 'G3DSA:1.10.8.10:FF:000141', NULL, NULL, 'Release factor glutamine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(200569, NULL, 'G3DSA:1.10.287.70:FF:000471', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(200570, NULL, 'G3DSA:1.20.5.370:FF:000009', NULL, NULL, 'Myosin heavy chain, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(200571, NULL, 'G3DSA:3.50.50.60:FF:000434', NULL, NULL, 'Os04g0560500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(200572, NULL, 'G3DSA:3.60.15.10:FF:000208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200573, NULL, 'G3DSA:3.30.160.20:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200574, NULL, 'G3DSA:3.40.50.970:FF:000133', NULL, NULL, '1-deoxy-D-xylulose-5-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(200575, NULL, 'G3DSA:2.60.40.10:FF:005007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200576, NULL, 'G3DSA:1.25.10.10:FF:002863', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200577, NULL, 'G3DSA:2.60.40.10:FF:000937', NULL, NULL, 'phosphatidylinositol phosphatase PTPRQ isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(200578, NULL, 'G3DSA:1.10.20.10:FF:000295', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200579, NULL, 'G3DSA:1.10.3380.20:FF:000009', NULL, NULL, 'DNA double-strand break repair Rad50 ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200580, NULL, 'G3DSA:1.10.472.10:FF:000367', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200581, NULL, 'G3DSA:3.30.160.60:FF:001174', NULL, NULL, 'zinc finger protein 527 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(200582, NULL, 'G3DSA:1.10.640.10:FF:000022', NULL, NULL, 'Peroxinectin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200583, NULL, 'G3DSA:1.10.3120.10:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200584, NULL, 'G3DSA:3.80.10.10:FF:002107', NULL, NULL, 'EIN3-binding F-box protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(200585, NULL, 'G3DSA:3.80.10.10:FF:002287', NULL, NULL, 'F-box/LRR-repeat protein 20', NULL, NULL, NULL, NULL, NULL, 4),
(200586, NULL, 'G3DSA:3.30.70.2760:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200587, NULL, 'G3DSA:1.25.40.10:FF:004489', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200588, NULL, 'G3DSA:3.90.1010.10:FF:000010', NULL, NULL, 'Quinolinate synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(200589, NULL, 'G3DSA:3.30.70.330:FF:002875', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200590, NULL, 'G3DSA:1.20.59.10:FF:000006', NULL, NULL, 'Chorismate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(200591, NULL, 'G3DSA:2.60.40.2910:FF:000002', NULL, NULL, 'Major fimbrial subunit of aggregative adherence fimbria II', NULL, NULL, NULL, NULL, NULL, 4),
(200592, NULL, 'G3DSA:3.50.7.10:FF:000079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200593, NULL, 'G3DSA:3.30.300.30:FF:000131', NULL, NULL, 'Nonribosomal peptide synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(200594, NULL, 'G3DSA:3.30.1520.10:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200595, NULL, 'G3DSA:2.60.40.2030:FF:000047', NULL, NULL, 'Adhesion G-protein coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(200596, NULL, 'G3DSA:1.20.120.1130:FF:000007', NULL, NULL, 'Vacuolar protein sorting-associated protein 28 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(200597, NULL, 'G3DSA:3.80.10.10:FF:003737', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200598, NULL, 'G3DSA:3.50.50.60:FF:000743', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200599, NULL, 'G3DSA:3.40.50.620:FF:000466', NULL, NULL, 'Adenine nucleotide alpha hydrolases-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(200600, NULL, 'G3DSA:3.30.160.60:FF:004748', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200601, NULL, 'G3DSA:2.60.40.10:FF:000589', NULL, NULL, 'cell adhesion molecule 4', NULL, NULL, NULL, NULL, NULL, 4),
(200602, NULL, 'G3DSA:3.30.420.40:FF:000963', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200603, NULL, 'G3DSA:2.60.120.200:FF:000532', NULL, NULL, 'Lectin family integral membrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200604, NULL, 'G3DSA:2.170.300.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200605, NULL, 'G3DSA:3.30.40.10:FF:001864', NULL, NULL, 'Uncharacterized RING finger protein C23A1.07', NULL, NULL, NULL, NULL, NULL, 4),
(200606, NULL, 'G3DSA:1.20.58.60:FF:000564', NULL, NULL, 'SEC14 domain and spectrin repeat-containing protein 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(200607, NULL, 'G3DSA:1.20.5.190:FF:000169', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200608, NULL, 'G3DSA:3.30.160.60:FF:005445', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200609, NULL, 'G3DSA:1.25.40.10:FF:001307', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g14050, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(200610, NULL, 'G3DSA:3.90.550.10:FF:000658', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(200611, NULL, 'G3DSA:3.90.1150.10:FF:000059', NULL, NULL, 'Glycine dehydrogenase (decarboxylating)', NULL, NULL, NULL, NULL, NULL, 4),
(200612, NULL, 'G3DSA:1.10.555.10:FF:000104', NULL, NULL, 'RhoGAP domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(200613, NULL, 'G3DSA:1.10.472.10:FF:000709', NULL, NULL, 'Transcription factor IIIB 90 kDa subunit-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(200614, NULL, 'G3DSA:3.40.50.2000:FF:000418', NULL, NULL, 'Glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(200615, NULL, 'G3DSA:3.50.50.60:FF:000636', NULL, NULL, 'Anaerobic glycerol-3-phosphate dehydrogenase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(200616, NULL, 'G3DSA:1.20.1250.20:FF:002066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200617, NULL, 'G3DSA:3.30.1370.210:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200618, NULL, 'G3DSA:1.10.630.10:FF:000050', NULL, NULL, 'Cytochrome P450 monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(200619, NULL, 'G3DSA:1.10.287.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200620, NULL, 'G3DSA:2.20.100.10:FF:000172', NULL, NULL, 'Putative reeler', NULL, NULL, NULL, NULL, NULL, 4),
(200621, NULL, 'G3DSA:1.10.10.60:FF:001040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200622, NULL, 'G3DSA:4.10.280.10:FF:000044', NULL, NULL, 'Basic helix-loop-helix transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(200623, NULL, 'G3DSA:2.130.10.10:FF:001051', NULL, NULL, 'dynein assembly factor with WDR repeat domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(200624, NULL, 'G3DSA:3.30.160.60:FF:005900', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200625, NULL, 'G3DSA:3.20.110.10:FF:000028', NULL, NULL, 'Lysosomal alpha-mannosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200626, NULL, 'G3DSA:1.10.10.1320:FF:000003', NULL, NULL, 'Transcriptional activator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200627, NULL, 'G3DSA:3.30.1140.32:FF:000002', NULL, NULL, '30S ribosomal protein S3', NULL, NULL, NULL, NULL, NULL, 4),
(200628, NULL, 'G3DSA:3.90.1180.10:FF:000016', NULL, NULL, '50S ribosomal protein L13', NULL, NULL, NULL, NULL, NULL, 4),
(200629, NULL, 'G3DSA:3.40.50.10490:FF:000064', NULL, NULL, 'SIS domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(200630, NULL, 'G3DSA:3.90.20.20:FF:000042', NULL, NULL, 'Protein GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(200631, NULL, 'G3DSA:3.40.50.410:FF:000061', NULL, NULL, 'von Willebrand factor', NULL, NULL, NULL, NULL, NULL, 4),
(200632, NULL, 'G3DSA:3.40.50.720:FF:002290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(200633, NULL, 'G3DSA:3.30.70.60:FF:000037', NULL, NULL, '30S ribosomal protein S6', NULL, NULL, NULL, NULL, NULL, 4),
(200634, NULL, 'G3DSA:3.90.1150.10:FF:000514', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(200635, NULL, 'G3DSA:1.20.1250.20:FF:000273', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(200636, NULL, 'G3DSA:1.10.10.1420:FF:000005', NULL, NULL, 'DNA replication factor Cdt1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200637, NULL, 'G3DSA:3.40.50.2000:FF:000082', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(200638, NULL, 'G3DSA:1.20.1270.10:FF:000063', NULL, NULL, 'Heat shock protein70, hsp70A2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200639, NULL, 'G3DSA:1.20.140.150:FF:000048', NULL, NULL, 'LD29359p', NULL, NULL, NULL, NULL, NULL, 4),
(200640, NULL, 'G3DSA:2.30.30.490:FF:000002', NULL, NULL, 'protein polybromo-1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(200641, NULL, 'G3DSA:3.30.390.30:FF:000035', NULL, NULL, 'Worm AIF (Apoptosis inducing factor) Homolog', NULL, NULL, NULL, NULL, NULL, 4),
(200642, NULL, 'G3DSA:3.10.129.10:FF:000118', NULL, NULL, 'Unplaced genomic scaffold supercont1.38, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(200643, NULL, 'G3DSA:1.20.1530.20:FF:000087', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(200644, NULL, 'G3DSA:3.60.40.10:FF:000154', NULL, NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(200645, NULL, 'G3DSA:3.30.160.60:FF:005552', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200646, NULL, 'G3DSA:3.40.50.720:FF:000726', NULL, NULL, 'C-terminal binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(200647, NULL, 'G3DSA:3.30.930.10:FF:000021', NULL, NULL, 'Probable histidine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(200648, NULL, 'G3DSA:1.20.58.150:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200649, NULL, 'G3DSA:1.10.510.10:FF:001064', NULL, NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 196', NULL, NULL, NULL, NULL, NULL, 4),
(200650, NULL, 'G3DSA:1.10.1370.10:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200651, NULL, 'G3DSA:1.10.10.1410:FF:000002', NULL, NULL, '60S acidic ribosomal protein P2', NULL, NULL, NULL, NULL, NULL, 4),
(200652, NULL, 'G3DSA:2.40.10.240:FF:000005', NULL, NULL, 'S-adenosylmethionine:tRNA ribosyltransferase-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(200653, NULL, 'G3DSA:2.30.29.30:FF:000581', NULL, NULL, 'Myosin 28B1, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(200654, NULL, 'G3DSA:3.40.630.10:FF:000277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200655, NULL, 'G3DSA:3.30.50.10:FF:000162', NULL, NULL, 'Protein CBG01262', NULL, NULL, NULL, NULL, NULL, 4),
(200656, NULL, 'G3DSA:3.30.70.2740:FF:000002', NULL, NULL, 'D-2-hydroxyglutarate dehydrogenase mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(200657, NULL, 'G3DSA:2.40.30.30:FF:000022', NULL, NULL, 'Protein CBG08376', NULL, NULL, NULL, NULL, NULL, 4),
(200658, NULL, 'G3DSA:3.30.1490.190:FF:000020', NULL, NULL, 'Ferric uptake regulation protein', NULL, NULL, NULL, NULL, NULL, 4),
(200659, NULL, 'G3DSA:2.60.200.40:FF:000016', NULL, NULL, 'Ceramide kinase like', NULL, NULL, NULL, NULL, NULL, 4),
(200660, NULL, 'G3DSA:3.40.190.10:FF:000613', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(200661, NULL, 'G3DSA:2.60.40.3770:FF:000001', NULL, NULL, 'Envelopment polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(200662, NULL, 'G3DSA:2.40.10.230:FF:000002', NULL, NULL, 'H/ACA ribonucleoprotein complex non-core subunit NAF1', NULL, NULL, NULL, NULL, NULL, 4),
(200663, NULL, 'G3DSA:3.90.79.10:FF:000197', NULL, NULL, 'Isopentenyl-diphosphate delta-isomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(200664, NULL, 'G3DSA:3.40.850.10:FF:000506', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(200665, NULL, 'G3DSA:3.30.70.2750:FF:000005', NULL, NULL, 'V-type ATP synthase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(200666, NULL, 'G3DSA:1.20.5.170:FF:000163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200667, NULL, 'G3DSA:1.20.1260.60:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200668, NULL, 'G3DSA:1.10.238.10:FF:001150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200669, NULL, 'G3DSA:3.30.70.330:FF:000751', NULL, NULL, 'Polyadenylate-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(200670, NULL, 'G3DSA:1.10.510.10:FF:001412', NULL, NULL, 'Serine/threonine-protein kinase atg1', NULL, NULL, NULL, NULL, NULL, 4),
(200671, NULL, 'G3DSA:2.60.40.820:FF:000052', NULL, NULL, 'Protein CBG03975', NULL, NULL, NULL, NULL, NULL, 4),
(200672, NULL, 'G3DSA:2.60.40.60:FF:000817', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200673, NULL, 'G3DSA:1.20.58.1030:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200674, NULL, 'G3DSA:3.30.50.10:FF:000055', NULL, NULL, 'GATA transcription factor 21', NULL, NULL, NULL, NULL, NULL, 4),
(200675, NULL, 'G3DSA:1.25.40.10:FF:003106', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g46460, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(200676, NULL, 'G3DSA:2.130.10.10:FF:001612', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200677, NULL, 'G3DSA:3.40.50.720:FF:000491', NULL, NULL, 'Enoyl-[acyl-carrier-protein] reductase FabL', NULL, NULL, NULL, NULL, NULL, 4),
(200678, NULL, 'G3DSA:3.30.160.60:FF:001320', NULL, NULL, 'Zinc finger and SCAN domain containing 9', NULL, NULL, NULL, NULL, NULL, 4),
(200679, NULL, 'G3DSA:3.40.50.2300:FF:000593', NULL, NULL, 'Penicillin-binding protein activator', NULL, NULL, NULL, NULL, NULL, 4),
(200680, NULL, 'G3DSA:1.20.1250.20:FF:001594', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(200681, NULL, 'G3DSA:2.120.10.30:FF:000394', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200682, NULL, 'G3DSA:1.25.10.10:FF:001143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200683, NULL, 'G3DSA:2.10.25.10:FF:000207', NULL, NULL, 'Multiple epidermal growth factor-like domains 8', NULL, NULL, NULL, NULL, NULL, 4),
(200684, NULL, 'G3DSA:3.30.420.130:FF:000001', NULL, NULL, 'Nitrogenase cofactor biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(200685, NULL, 'G3DSA:3.40.50.970:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200686, NULL, 'G3DSA:1.10.630.10:FF:000611', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200687, NULL, 'G3DSA:3.80.10.10:FF:002433', NULL, NULL, 'Leucine-rich repeat protein (LRRP)', NULL, NULL, NULL, NULL, NULL, 4),
(200688, NULL, 'G3DSA:3.30.1370.10:FF:000185', NULL, NULL, 'KRR1 small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4),
(200689, NULL, 'G3DSA:3.30.470.20:FF:000123', NULL, NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(200690, NULL, 'G3DSA:2.60.120.820:FF:000010', NULL, NULL, 'BTB/POZ domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(200691, NULL, 'G3DSA:1.20.1250.20:FF:000492', NULL, NULL, 'Probable inorganic phosphate transporter 1-5', NULL, NULL, NULL, NULL, NULL, 4),
(200692, NULL, 'G3DSA:1.10.238.10:FF:000784', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200693, NULL, 'G3DSA:1.25.40.120:FF:000010', NULL, NULL, 'Geranylgeranyl transferase type-2 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(200694, NULL, 'G3DSA:3.10.580.10:FF:000211', NULL, NULL, 'Chloride channel protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(200695, NULL, 'G3DSA:2.10.25.10:FF:001618', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(200696, NULL, 'G3DSA:3.30.450.20:FF:000240', NULL, NULL, 'Sensory box/GGDEF family protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(200697, NULL, 'G3DSA:3.90.1150.10:FF:000368', NULL, NULL, 'Aminotransferase class I/II-fold pyridoxal phosphate-dependent enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(200698, NULL, 'G3DSA:1.10.238.10:FF:001273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200699, NULL, 'G3DSA:2.60.40.10:FF:005810', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200700, NULL, 'G3DSA:3.40.50.300:FF:004788', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200701, NULL, 'G3DSA:1.20.1410.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200702, NULL, 'G3DSA:3.30.420.40:FF:000744', NULL, NULL, 'Actin related protein', NULL, NULL, NULL, NULL, NULL, 4),
(200703, NULL, 'G3DSA:1.20.1070.10:FF:002116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200704, NULL, 'G3DSA:3.40.190.10:FF:000832', NULL, NULL, 'Sulfonate ABC transporter, periplasmic sulfonate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(200705, NULL, 'G3DSA:1.10.40.30:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200706, NULL, 'G3DSA:3.40.718.10:FF:000014', NULL, NULL, 'Isocitrate dehydrogenase (NAD(+))', NULL, NULL, NULL, NULL, NULL, 4),
(200707, NULL, 'G3DSA:1.25.40.10:FF:002691', NULL, NULL, 'Fis1 C-terminal tetratricopeptide repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200708, NULL, 'G3DSA:3.30.559.10:FF:000157', NULL, NULL, 'Nonribosomal peptide synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(200709, NULL, 'G3DSA:3.40.20.10:FF:000108', NULL, NULL, 'Villin-1', NULL, NULL, NULL, NULL, NULL, 4),
(200710, NULL, 'G3DSA:3.40.47.10:FF:000277', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200711, NULL, 'G3DSA:3.40.1190.20:FF:000025', NULL, NULL, 'Putative sugar kinase slr0537', NULL, NULL, NULL, NULL, NULL, 4),
(200712, NULL, 'G3DSA:1.20.1540.10:FF:000039', NULL, NULL, 'Derlin', NULL, NULL, NULL, NULL, NULL, 4),
(200713, NULL, 'G3DSA:1.20.1510.10:FF:000009', NULL, NULL, 'zinc transporter 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(200714, NULL, 'G3DSA:1.10.1740.30:FF:000001', NULL, NULL, 'Type III secretion system effector SifA', NULL, NULL, NULL, NULL, NULL, 4),
(200715, NULL, 'G3DSA:1.20.120.1240:FF:000024', NULL, NULL, 'Dynamin central region family protein', NULL, NULL, NULL, NULL, NULL, 4),
(200716, NULL, 'G3DSA:3.50.50.60:FF:000417', NULL, NULL, 'Ubiquinone biosynthesis hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(200717, NULL, 'G3DSA:3.80.10.10:FF:001944', NULL, NULL, 'Receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(200718, NULL, 'G3DSA:3.40.50.720:FF:000417', NULL, NULL, 'Glucose 1-dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200719, NULL, 'G3DSA:3.40.50.2000:FF:000637', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(200720, NULL, 'G3DSA:3.30.160.60:FF:005226', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200721, NULL, 'G3DSA:3.30.750.24:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200722, NULL, 'G3DSA:2.60.40.790:FF:000099', NULL, NULL, 'Chaperone binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200723, NULL, 'G3DSA:2.60.220.50:FF:000021', NULL, NULL, 'Adhesion G protein-coupled receptor F5', NULL, NULL, NULL, NULL, NULL, 4),
(200724, NULL, 'G3DSA:3.30.1520.10:FF:000096', NULL, NULL, 'PX domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(200725, NULL, 'G3DSA:2.10.25.10:FF:000174', NULL, NULL, 'Laminin subunit gamma-1', NULL, NULL, NULL, NULL, NULL, 4),
(200726, NULL, 'G3DSA:3.40.50.10140:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200727, NULL, 'G3DSA:3.40.50.720:FF:001828', NULL, NULL, 'Polyketide synthase, putative (JCVI)', NULL, NULL, NULL, NULL, NULL, 4),
(200728, NULL, 'G3DSA:3.30.160.60:FF:000679', NULL, NULL, 'Zinc finger protein 341', NULL, NULL, NULL, NULL, NULL, 4),
(200729, NULL, 'G3DSA:2.130.10.10:FF:000769', NULL, NULL, 'Apoptotic protease-activating factor 1', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(200730, NULL, 'G3DSA:3.50.50.60:FF:000288', NULL, NULL, 'Lysine-specific histone demethylase 1 homolog 3', NULL, NULL, NULL, NULL, NULL, 4),
(200731, NULL, 'G3DSA:1.20.1740.10:FF:000021', NULL, NULL, 'Cation-chloride cotransporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(200732, NULL, 'G3DSA:3.30.200.20:FF:000396', NULL, NULL, 'Cdc2-related kinase 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200733, NULL, 'G3DSA:1.20.1560.10:FF:000254', NULL, NULL, 'ABC transporter ATP-binding protein/permease', NULL, NULL, NULL, NULL, NULL, 4),
(200734, NULL, 'G3DSA:1.25.40.20:FF:001193', NULL, NULL, 'Ion channel NompC', NULL, NULL, NULL, NULL, NULL, 4),
(200735, NULL, 'G3DSA:1.25.40.10:FF:001280', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(200736, NULL, 'G3DSA:3.30.450.70:FF:000007', NULL, NULL, 'Putative sybindin-like family protein', NULL, NULL, NULL, NULL, NULL, 4),
(200737, NULL, 'G3DSA:1.10.8.10:FF:000006', NULL, NULL, 'Putative nascent polypeptide-associated complex subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(200738, NULL, 'G3DSA:3.90.1170.40:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200739, NULL, 'G3DSA:3.40.50.2300:FF:000267', NULL, NULL, 'Virulence factors transcription regulator', NULL, NULL, NULL, NULL, NULL, 4),
(200740, NULL, 'G3DSA:2.40.50.140:FF:001017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200741, NULL, 'G3DSA:3.80.10.10:FF:002742', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200742, NULL, 'G3DSA:3.30.310.80:FF:000051', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(200743, NULL, 'G3DSA:1.10.8.20:FF:000009', NULL, NULL, 'Blast:Clavesin-1', NULL, NULL, NULL, NULL, NULL, 4),
(200744, NULL, 'G3DSA:1.10.10.2670:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200745, NULL, 'G3DSA:3.30.450.60:FF:000004', NULL, NULL, 'AP complex subunit sigma', NULL, NULL, NULL, NULL, NULL, 4),
(200746, NULL, 'G3DSA:1.20.58.760:FF:000025', NULL, NULL, 'ATP-dependent metallopeptidase Hfl', NULL, NULL, NULL, NULL, NULL, 4),
(200747, NULL, 'G3DSA:3.40.50.720:FF:000165', NULL, NULL, '3-ketodihydrosphingosine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(200748, NULL, 'G3DSA:1.25.40.20:FF:001283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200749, NULL, 'G3DSA:3.30.70.270:FF:000165', NULL, NULL, 'Response regulator ActA', NULL, NULL, NULL, NULL, NULL, 4),
(200750, NULL, 'G3DSA:3.30.200.20:FF:000738', NULL, NULL, 'CMGC/CDK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(200751, NULL, 'G3DSA:3.40.50.720:FF:000507', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(200752, NULL, 'G3DSA:1.20.1560.10:FF:000602', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200753, NULL, 'G3DSA:2.60.40.1120:FF:000089', NULL, NULL, 'Carboxypeptidase D, b', NULL, NULL, NULL, NULL, NULL, 4),
(200754, NULL, 'G3DSA:3.30.450.50:FF:000001', NULL, NULL, 'AP-3 complex subunit delta-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200755, NULL, 'G3DSA:2.30.29.30:FF:000362', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(200756, NULL, 'G3DSA:2.130.10.10:FF:005103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200757, NULL, 'G3DSA:1.20.120.1910:FF:000011', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(200758, NULL, 'G3DSA:3.90.470.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200759, NULL, 'G3DSA:3.30.200.20:FF:000087', NULL, NULL, 'Dual specificity tyrosine-phosphorylation-regulated kinase 1A', NULL, NULL, NULL, NULL, NULL, 4),
(200760, NULL, 'G3DSA:3.90.1150.10:FF:000149', NULL, NULL, 'O-succinylhomoserine sulfhydrylase', NULL, NULL, NULL, NULL, NULL, 4),
(200761, NULL, 'G3DSA:3.90.226.10:FF:000169', NULL, NULL, 'Periplasmic protease', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(200762, NULL, 'G3DSA:1.10.150.50:FF:000007', NULL, NULL, 'Liprin-beta-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(200763, NULL, 'G3DSA:2.10.25.10:FF:000516', NULL, NULL, 'Notch receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(200764, NULL, 'G3DSA:3.30.70.330:FF:002549', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200765, NULL, 'G3DSA:1.10.10.60:FF:000758', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(200766, NULL, 'G3DSA:1.10.510.10:FF:001283', NULL, NULL, 'Probable inactive receptor kinase At5g53320', NULL, NULL, NULL, NULL, NULL, 4),
(200767, NULL, 'G3DSA:3.40.50.2000:FF:000727', NULL, NULL, 'OSJNBb0012E24.10 protein', NULL, NULL, NULL, NULL, NULL, 4),
(200768, NULL, 'G3DSA:3.30.450.20:FF:000094', NULL, NULL, 'Single-minded, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(200769, NULL, 'G3DSA:3.30.720.10:FF:000005', NULL, NULL, 'Signal recognition particle 9', NULL, NULL, NULL, NULL, NULL, 4),
(200770, NULL, 'G3DSA:1.25.40.10:FF:000583', NULL, NULL, 'Tetratricopeptide-like helical', NULL, NULL, NULL, NULL, NULL, 4),
(200771, NULL, 'G3DSA:3.40.390.10:FF:000252', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200772, NULL, 'G3DSA:3.40.850.10:FF:000276', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(200773, NULL, 'G3DSA:3.40.50.300:FF:003355', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(200774, NULL, 'G3DSA:3.40.50.11950:FF:000007', NULL, NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(200775, NULL, 'G3DSA:1.10.287.130:FF:000141', NULL, NULL, 'Sensor histidine kinase, KdpD', NULL, NULL, NULL, NULL, NULL, 4),
(200776, NULL, 'G3DSA:3.30.740.10:FF:000006', NULL, NULL, 'Dynein light chain', NULL, NULL, NULL, NULL, NULL, 4),
(200777, NULL, 'G3DSA:3.30.420.580:FF:000006', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(200778, NULL, 'G3DSA:3.30.710.10:FF:000510', NULL, NULL, 'Voltage-gated potassium channel, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200779, NULL, 'G3DSA:2.60.40.1910:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200780, NULL, 'G3DSA:2.30.30.140:FF:000116', NULL, NULL, 'Os04g0326000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(200781, NULL, 'G3DSA:3.30.450.380:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200782, NULL, 'G3DSA:3.80.10.10:FF:004125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200783, NULL, 'G3DSA:3.30.200.20:FF:000957', NULL, NULL, 'TP53-regulating kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200784, NULL, 'G3DSA:3.50.50.60:FF:001131', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(200785, NULL, 'G3DSA:2.130.10.10:FF:001410', NULL, NULL, 'Rabconnectin-3B, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(200786, NULL, 'G3DSA:3.20.20.190:FF:000032', NULL, NULL, 'Glycerophosphoryl diester phosphodiesterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200787, NULL, 'G3DSA:3.40.50.11660:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200788, NULL, 'G3DSA:3.30.40.10:FF:000116', NULL, NULL, 'Transcription factor 20 (AR1)', NULL, NULL, NULL, NULL, NULL, 4),
(200789, NULL, 'G3DSA:3.30.160.60:FF:005136', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200790, NULL, 'G3DSA:1.25.40.20:FF:001204', NULL, NULL, 'Poly [ADP-ribose] polymerase tankyrase', NULL, NULL, NULL, NULL, NULL, 4),
(200791, NULL, 'G3DSA:1.20.120.310:FF:000007', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(200792, NULL, 'G3DSA:1.20.1250.20:FF:000290', NULL, NULL, 'Unc-93 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(200793, NULL, 'G3DSA:1.25.10.10:FF:000648', NULL, NULL, 'CLIP-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(200794, NULL, 'G3DSA:1.20.1250.20:FF:001919', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200795, NULL, 'G3DSA:3.40.50.720:FF:000743', NULL, NULL, 'D-amino acid oxidase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(200796, NULL, 'G3DSA:1.25.40.120:FF:000009', NULL, NULL, 'CAAX geranylgeranyltransferase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(200797, NULL, 'G3DSA:3.30.160.60:FF:001404', NULL, NULL, 'vascular endothelial zinc finger 1-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(200798, NULL, 'G3DSA:1.20.1560.10:FF:000147', NULL, NULL, 'ABC transporter B family member 9', NULL, NULL, NULL, NULL, NULL, 4),
(200799, NULL, 'G3DSA:1.10.10.60:FF:000449', NULL, NULL, 'MYB-related transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(200800, NULL, 'G3DSA:1.25.40.10:FF:001201', NULL, NULL, 'Pentatricopeptide repeat-containing protein OGR1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(200801, NULL, 'G3DSA:3.40.50.10140:FF:000010', NULL, NULL, 'phosphoinositide 3-kinase adapter protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(200802, NULL, 'G3DSA:3.30.40.10:FF:000644', NULL, NULL, 'DNA repair protein rhp16', NULL, NULL, NULL, NULL, NULL, 4),
(200803, NULL, 'G3DSA:2.30.30.100:FF:000155', NULL, NULL, 'Small nuclear ribonucleoprotein family protein', NULL, NULL, NULL, NULL, NULL, 4),
(200804, NULL, 'G3DSA:2.30.29.30:FF:000564', NULL, NULL, 'Actin-binding protein anillin-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(200805, NULL, 'G3DSA:3.10.20.230:FF:000018', NULL, NULL, 'Echinoderm microtubule-associated protein-like CG42247', NULL, NULL, NULL, NULL, NULL, 4),
(200806, NULL, 'G3DSA:2.130.10.10:FF:004485', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(200807, NULL, 'G3DSA:3.40.190.290:FF:000094', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(200808, NULL, 'G3DSA:3.30.50.10:FF:000145', NULL, NULL, 'Retinoic acid receptor gamma, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200809, NULL, 'G3DSA:1.10.10.10:FF:001047', NULL, NULL, 'Putative type IIB DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(200810, NULL, 'G3DSA:1.20.1480.30:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200811, NULL, 'G3DSA:3.10.310.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200812, NULL, 'G3DSA:3.40.50.12760:FF:000020', NULL, NULL, 'Cap-specific mRNA (Nucleoside-2''-O-)-methyltransferase 2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(200813, NULL, 'G3DSA:2.40.50.90:FF:000086', NULL, NULL, 'Nuclease domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200814, NULL, 'G3DSA:1.25.40.10:FF:005001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200815, NULL, 'G3DSA:1.25.10.10:FF:003251', NULL, NULL, 'Unc-45 myosin chaperone A', NULL, NULL, NULL, NULL, NULL, 4),
(200816, NULL, 'G3DSA:3.40.1110.10:FF:000332', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200817, NULL, 'G3DSA:3.80.10.10:FF:001000', NULL, NULL, 'probable inactive leucine-rich repeat receptor-like protein kinase At3g03770', NULL, NULL, NULL, NULL, NULL, 4),
(200818, NULL, 'G3DSA:1.25.40.10:FF:001190', NULL, NULL, 'Kinetoplast_polyadenylation/uridylation_factor_1', NULL, NULL, NULL, NULL, NULL, 4),
(200819, NULL, 'G3DSA:3.20.20.80:FF:000170', NULL, NULL, 'Unplaced genomic scaffold supercont1.36, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(200820, NULL, 'G3DSA:3.30.1370.10:FF:000078', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(200821, NULL, 'G3DSA:2.10.25.10:FF:000533', NULL, NULL, 'Laminin subunit gamma 2', NULL, NULL, NULL, NULL, NULL, 4),
(200822, NULL, 'G3DSA:2.30.29.30:FF:000036', NULL, NULL, 'SHC-transforming protein 1 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(200823, NULL, 'G3DSA:1.25.40.860:FF:000001', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(200824, NULL, 'G3DSA:3.40.50.12710:FF:000011', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(200825, NULL, 'G3DSA:3.30.160.60:FF:002011', NULL, NULL, 'Paternally-expressed gene 3 protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(200826, NULL, 'G3DSA:3.90.190.10:FF:000017', NULL, NULL, 'receptor-type tyrosine-protein phosphatase-like N isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(200827, NULL, 'G3DSA:3.20.20.100:FF:000056', NULL, NULL, 'Aldo-keto reductase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(200828, NULL, 'G3DSA:4.10.410.10:FF:000100', NULL, NULL, 'Ankyrin repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(200829, NULL, 'G3DSA:1.10.10.60:FF:000983', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200830, NULL, 'G3DSA:1.20.1070.10:FF:000082', NULL, NULL, 'Olfactory receptor 1A1', NULL, NULL, NULL, NULL, NULL, 4),
(200831, NULL, 'G3DSA:3.80.10.10:FF:002416', NULL, NULL, 'Si:ch211-42i6.2', NULL, NULL, NULL, NULL, NULL, 4),
(200832, NULL, 'G3DSA:1.25.40.20:FF:001619', NULL, NULL, 'E3 ubiquitin-protein ligase mind-bomb-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(200833, NULL, 'G3DSA:2.40.50.140:FF:000629', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(200834, NULL, 'G3DSA:3.40.1110.10:FF:000006', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(200835, NULL, 'G3DSA:3.40.30.150:FF:000001', NULL, NULL, 'Orf1a polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(200836, NULL, 'G3DSA:2.30.30.140:FF:000009', NULL, NULL, 'AT-rich interactive domain-containing protein 4B', NULL, NULL, NULL, NULL, NULL, 4),
(200837, NULL, 'G3DSA:1.10.390.10:FF:000002', NULL, NULL, 'Aminopeptidase N', NULL, NULL, NULL, NULL, NULL, 4),
(200838, NULL, 'G3DSA:2.130.10.10:FF:000685', NULL, NULL, 'Autophagy-related protein 18c', NULL, NULL, NULL, NULL, NULL, 4),
(200839, NULL, 'G3DSA:3.40.50.1820:FF:000224', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(200840, NULL, 'G3DSA:2.30.42.10:FF:000538', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200841, NULL, 'G3DSA:1.10.820.10:FF:000002', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(200842, NULL, 'G3DSA:1.10.555.10:FF:000071', NULL, NULL, 'Rho GTPase activating protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(200843, NULL, 'G3DSA:1.25.40.10:FF:000998', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(200844, NULL, 'G3DSA:1.10.1580.10:FF:000004', NULL, NULL, 'Mitochondrial GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(200845, NULL, 'G3DSA:3.30.40.10:FF:002353', NULL, NULL, 'AFL108Cp', NULL, NULL, NULL, NULL, NULL, 4),
(200846, NULL, 'G3DSA:3.90.45.10:FF:000001', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(200847, NULL, 'G3DSA:3.30.465.10:FF:000046', NULL, NULL, 'Integral membrane protein, TerC family', NULL, NULL, NULL, NULL, NULL, 4),
(200848, NULL, 'G3DSA:3.30.70.330:FF:001133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200849, NULL, 'G3DSA:1.10.238.10:FF:001256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200850, NULL, 'G3DSA:1.10.1040.10:FF:000060', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(200851, NULL, 'G3DSA:2.130.10.10:FF:001303', NULL, NULL, 'Telomerase protein component 1', NULL, NULL, NULL, NULL, NULL, 4),
(200852, NULL, 'G3DSA:2.60.120.290:FF:000137', NULL, NULL, 'Cubilin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(200853, NULL, 'G3DSA:3.40.50.1220:FF:000050', NULL, NULL, 'NAD-dependent deacetylase, Sir2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(200854, NULL, 'G3DSA:3.30.230.10:FF:000029', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(200855, NULL, 'G3DSA:3.10.20.510:FF:000001', NULL, NULL, 'Bacterial RNA polymerase inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(200856, NULL, 'G3DSA:1.10.630.10:FF:000302', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(200857, NULL, 'G3DSA:3.60.20.10:FF:000271', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200858, NULL, 'G3DSA:3.40.50.1220:FF:000139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200859, NULL, 'G3DSA:2.20.70.10:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(200860, NULL, 'G3DSA:1.25.40.10:FF:002926', NULL, NULL, 'Tetratricopeptide repeat protein 19, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(200861, NULL, 'G3DSA:3.40.50.880:FF:000179', NULL, NULL, 'Imidazole glycerol phosphate synthase subunit HisH', NULL, NULL, NULL, NULL, NULL, 4),
(200862, NULL, 'G3DSA:3.30.1370.50:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200863, NULL, 'G3DSA:2.170.300.10:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200864, NULL, 'G3DSA:3.40.50.300:FF:005070', NULL, NULL, 'Ras-related protein RABC1', NULL, NULL, NULL, NULL, NULL, 4),
(200865, NULL, 'G3DSA:3.90.180.10:FF:000045', NULL, NULL, 'NADP-dependent alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(200866, NULL, 'G3DSA:3.40.50.300:FF:001118', NULL, NULL, 'ATP-dependent zinc metalloprotease FTSH 12, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(200867, NULL, 'G3DSA:1.10.287.10:FF:000043', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(200868, NULL, 'G3DSA:3.40.190.10:FF:000467', NULL, NULL, 'SgrR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(200869, NULL, 'G3DSA:1.20.1270.60:FF:000252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200870, NULL, 'G3DSA:3.90.70.10:FF:000778', NULL, NULL, 'Philibertain g 1', NULL, NULL, NULL, NULL, NULL, 4),
(200871, NULL, 'G3DSA:3.80.10.10:FF:000382', NULL, NULL, 'Leucine rich repeats and transmembrane domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(200872, NULL, 'G3DSA:1.25.40.10:FF:002617', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200873, NULL, 'G3DSA:1.20.120.1190:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200874, NULL, 'G3DSA:3.30.160.60:FF:005243', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200875, NULL, 'G3DSA:1.10.490.160:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200876, NULL, 'G3DSA:1.25.40.10:FF:004854', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200877, NULL, 'G3DSA:1.25.10.10:FF:000974', NULL, NULL, 'WD repeats protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(200878, NULL, 'G3DSA:1.25.40.990:FF:000057', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(200879, NULL, 'G3DSA:1.10.10.160:FF:000008', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(200880, NULL, 'G3DSA:2.60.120.290:FF:000250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200881, NULL, 'G3DSA:1.10.472.80:FF:000005', NULL, NULL, 'TBC1 domain family member 15', NULL, NULL, NULL, NULL, NULL, 4),
(200882, NULL, 'G3DSA:1.10.418.10:FF:000096', NULL, NULL, 'Parvin beta', NULL, NULL, NULL, NULL, NULL, 4),
(200883, NULL, 'G3DSA:3.30.230.10:FF:000248', NULL, NULL, 'Tetracycline resistance protein TetM', NULL, NULL, NULL, NULL, NULL, 4),
(200884, NULL, 'G3DSA:3.30.200.20:FF:000755', NULL, NULL, 'Proline-rich receptor-like protein kinase PERK3', NULL, NULL, NULL, NULL, NULL, 4),
(200885, NULL, 'G3DSA:2.20.130.20:FF:000014', NULL, NULL, 'Thiolester containing protein I', NULL, NULL, NULL, NULL, NULL, 4),
(200886, NULL, 'G3DSA:2.60.220.50:FF:000004', NULL, NULL, 'Adhesion G protein-coupled receptor B3', NULL, NULL, NULL, NULL, NULL, 4),
(200887, NULL, 'G3DSA:3.30.70.120:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200888, NULL, 'G3DSA:6.10.250.3410:FF:000001', NULL, NULL, 'Protein DBF4 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(200889, NULL, 'G3DSA:1.25.10.10:FF:001008', NULL, NULL, 'GD25408', NULL, NULL, NULL, NULL, NULL, 4),
(200890, NULL, 'G3DSA:3.40.1090.10:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200891, NULL, 'G3DSA:3.60.40.10:FF:000047', NULL, NULL, 'Protein phosphatase 2C 70', NULL, NULL, NULL, NULL, NULL, 4),
(200892, NULL, 'G3DSA:3.40.50.1010:FF:000211', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200893, NULL, 'G3DSA:2.10.25.10:FF:000281', NULL, NULL, 'Nidogen 1', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(200894, NULL, 'G3DSA:3.30.70.100:FF:000030', NULL, NULL, 'Copper-exporting P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(200895, NULL, 'G3DSA:3.30.70.141:FF:000026', NULL, NULL, 'Nucleoside diphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(200896, NULL, 'G3DSA:3.10.20.90:FF:000797', NULL, NULL, 'UBX domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(200897, NULL, 'G3DSA:2.30.29.30:FF:000345', NULL, NULL, 'unconventional myosin-XV isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(200898, NULL, 'G3DSA:3.40.50.2300:FF:000284', NULL, NULL, 'Vomeronasal 2, receptor 73', NULL, NULL, NULL, NULL, NULL, 4),
(200899, NULL, 'G3DSA:2.40.50.140:FF:000848', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200900, NULL, 'G3DSA:3.40.1110.10:FF:000113', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(200901, NULL, 'G3DSA:1.10.10.60:FF:000674', NULL, NULL, '3-methyladenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(200902, NULL, 'G3DSA:3.30.160.60:FF:001084', NULL, NULL, 'Zinc finger and BTB domain-containing 41', NULL, NULL, NULL, NULL, NULL, 4),
(200903, NULL, 'G3DSA:1.10.8.60:FF:000015', NULL, NULL, 'vacuolar protein sorting-associated protein 4A', NULL, NULL, NULL, NULL, NULL, 4),
(200904, NULL, 'G3DSA:3.30.60.290:FF:000006', NULL, NULL, 'AGR162Cp', NULL, NULL, NULL, NULL, NULL, 4),
(200905, NULL, 'G3DSA:2.10.109.10:FF:000065', NULL, NULL, 'LexA repressor', NULL, NULL, NULL, NULL, NULL, 4),
(200906, NULL, 'G3DSA:2.60.120.200:FF:000493', NULL, NULL, 'L-type lectin-domain containing receptor kinase VIII.1', NULL, NULL, NULL, NULL, NULL, 4),
(200907, NULL, 'G3DSA:3.30.70.270:FF:000272', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200908, NULL, 'G3DSA:2.130.10.10:FF:004956', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200909, NULL, 'G3DSA:3.40.630.10:FF:000294', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200910, NULL, 'G3DSA:3.30.70.1230:FF:000010', NULL, NULL, 'Adenylate cyclase 2', NULL, NULL, NULL, NULL, NULL, 4),
(200911, NULL, 'G3DSA:1.20.1080.10:FF:000009', NULL, NULL, 'aquaporin-4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(200912, NULL, 'G3DSA:2.60.40.10:FF:005451', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200913, NULL, 'G3DSA:3.40.50.720:FF:000524', NULL, NULL, '3-ketosteroid reductase', NULL, NULL, NULL, NULL, NULL, 4),
(200914, NULL, 'G3DSA:1.25.40.470:FF:000007', NULL, NULL, 'Intraflagellar transport 80 homolog (Chlamydomonas)', NULL, NULL, NULL, NULL, NULL, 4),
(200915, NULL, 'G3DSA:3.90.470.10:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200916, NULL, 'G3DSA:2.60.40.820:FF:000035', NULL, NULL, 'Protein CBG17250', NULL, NULL, NULL, NULL, NULL, 4),
(200917, NULL, 'G3DSA:1.20.5.170:FF:000247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200918, NULL, 'G3DSA:2.60.40.10:FF:005232', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200919, NULL, 'G3DSA:1.20.1050.10:FF:000283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200920, NULL, 'G3DSA:3.40.50.150:FF:001511', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200921, NULL, 'G3DSA:2.130.10.10:FF:000994', NULL, NULL, 'Os05g0519500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(200922, NULL, 'G3DSA:3.40.50.150:FF:001730', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200923, NULL, 'G3DSA:1.10.8.1070:FF:000001', NULL, NULL, 'Ribulose bisphosphate carboxylase/oxygenase activase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(200924, NULL, 'G3DSA:3.40.50.300:FF:005300', NULL, NULL, 'Helicase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(200925, NULL, 'G3DSA:3.30.200.20:FF:002195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200926, NULL, 'G3DSA:2.130.10.10:FF:003208', NULL, NULL, 'WD repeat-containing protein 44 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(200927, NULL, 'G3DSA:3.40.50.300:FF:003607', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(200928, NULL, 'G3DSA:1.20.1250.20:FF:002212', NULL, NULL, 'GM06782p', NULL, NULL, NULL, NULL, NULL, 4),
(200929, NULL, 'G3DSA:1.10.150.20:FF:000156', NULL, NULL, 'FA core complex associated protein 24', NULL, NULL, NULL, NULL, NULL, 4),
(200930, NULL, 'G3DSA:2.60.40.2310:FF:000007', NULL, NULL, 'Subtilisin-like protease SBT2.4', NULL, NULL, NULL, NULL, NULL, 4),
(200931, NULL, 'G3DSA:3.40.50.1370:FF:000044', NULL, NULL, 'Ornithine carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(200932, NULL, 'G3DSA:3.40.50.620:FF:000483', NULL, NULL, 'Tryptophan--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(200933, NULL, 'G3DSA:2.20.100.10:FF:000037', NULL, NULL, 'Spondin 2', NULL, NULL, NULL, NULL, NULL, 4),
(200934, NULL, 'G3DSA:3.40.390.10:FF:000033', NULL, NULL, 'A disintegrin and metallopeptidase domain 18', NULL, NULL, NULL, NULL, NULL, 4),
(200935, NULL, 'G3DSA:1.25.40.180:FF:000112', NULL, NULL, 'Eukaryotic translation initiation factor 4E-binding protein Mextli homolog', NULL, NULL, NULL, NULL, NULL, 4),
(200936, NULL, 'G3DSA:3.90.830.10:FF:000011', NULL, NULL, 'SNARE docking complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(200937, NULL, 'G3DSA:3.80.10.10:FF:001798', NULL, NULL, 'tsukushin', NULL, NULL, NULL, NULL, NULL, 4),
(200938, NULL, 'G3DSA:4.10.1000.10:FF:000004', NULL, NULL, 'roquin-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(200939, NULL, 'G3DSA:2.130.10.10:FF:003175', NULL, NULL, 'Elongator complex protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(200940, NULL, 'G3DSA:3.50.50.60:FF:000092', NULL, NULL, 'tRNA 5-methylaminomethyl-2-thiouridine biosynthesis bifunctional protein MnmC', NULL, NULL, NULL, NULL, NULL, 4),
(200941, NULL, 'G3DSA:1.20.1250.20:FF:000609', NULL, NULL, 'Multidrug resistance membrane efflux protein emrB', NULL, NULL, NULL, NULL, NULL, 4),
(200942, NULL, 'G3DSA:3.40.50.720:FF:002306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200943, NULL, 'G3DSA:2.60.40.710:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200944, NULL, 'G3DSA:2.60.40.10:FF:001432', NULL, NULL, 'Sidekick, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(200945, NULL, 'G3DSA:2.30.42.10:FF:000432', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200946, NULL, 'G3DSA:1.10.8.1080:FF:000004', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(200947, NULL, 'G3DSA:3.30.160.60:FF:004838', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200948, NULL, 'G3DSA:1.20.1730.10:FF:000071', NULL, NULL, 'Sodium/solute symporter, GAF and PP2C family protein serine/threonine phosphatase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(200949, NULL, 'G3DSA:1.20.1480.20:FF:000003', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200950, NULL, 'G3DSA:2.30.36.70:FF:000019', NULL, NULL, 'Actin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200951, NULL, 'G3DSA:1.10.287.70:FF:000162', NULL, NULL, 'Voltage-gated Ca2+ channel, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(200952, NULL, 'G3DSA:2.130.10.10:FF:005210', NULL, NULL, 'Chromatin modification-related protein rik1', NULL, NULL, NULL, NULL, NULL, 4),
(200953, NULL, 'G3DSA:2.40.50.40:FF:000133', NULL, NULL, 'Eukaryotic translation initiation factor 2 subunit 3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(200954, NULL, 'G3DSA:3.90.470.20:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200955, NULL, 'G3DSA:3.40.50.300:FF:004991', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200956, NULL, 'G3DSA:1.25.10.10:FF:000755', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(200957, NULL, 'G3DSA:1.20.120.1530:FF:000004', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(200958, NULL, 'G3DSA:1.10.472.10:FF:000682', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200959, NULL, 'G3DSA:2.30.250.10:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(200960, NULL, 'G3DSA:3.30.40.10:FF:000099', NULL, NULL, 'E3 ubiquitin-protein ligase RNF167', NULL, NULL, NULL, NULL, NULL, 4),
(200961, NULL, 'G3DSA:3.90.226.10:FF:000276', NULL, NULL, 'Zgc:158138 protein', NULL, NULL, NULL, NULL, NULL, 4),
(200962, NULL, 'G3DSA:3.30.710.10:FF:000274', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(200963, NULL, 'G3DSA:3.30.930.10:FF:000240', NULL, NULL, 'ATP phosphoribosyltransferase, predicted regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(200964, NULL, 'G3DSA:1.20.120.1520:FF:000001', NULL, NULL, 'Multifunctional virulence effector protein DrrA', NULL, NULL, NULL, NULL, NULL, 4),
(200965, NULL, 'G3DSA:1.10.10.250:FF:000013', NULL, NULL, 'LSU ribosomal protein L11P', NULL, NULL, NULL, NULL, NULL, 4),
(200966, NULL, 'G3DSA:1.20.1280.20:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200967, NULL, 'G3DSA:3.40.50.720:FF:000272', NULL, NULL, 'UDP-glucuronic acid decarboxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(200968, NULL, 'G3DSA:1.25.10.10:FF:001362', NULL, NULL, 'Sister chromatid cohesion protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200969, NULL, 'G3DSA:3.40.50.150:FF:000893', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200970, NULL, 'G3DSA:2.60.40.10:FF:001180', NULL, NULL, 'Down syndrome cell adhesion molecule-like protein Dscam2', NULL, NULL, NULL, NULL, NULL, 4),
(200971, NULL, 'G3DSA:1.10.3380.10:FF:000006', NULL, NULL, 'probable ATP-dependent DNA helicase HFM1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(200972, NULL, 'G3DSA:2.60.40.2300:FF:000004', NULL, NULL, 'Neutral/alkaline nonlysosomal ceramidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200973, NULL, 'G3DSA:3.40.50.1360:FF:000041', NULL, NULL, '6-phosphogluconolactonase', NULL, NULL, NULL, NULL, NULL, 4),
(200974, NULL, 'G3DSA:3.40.30.10:FF:001149', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(200975, NULL, 'G3DSA:1.10.840.10:FF:000003', NULL, NULL, 'Ras guanyl-releasing protein 3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(200976, NULL, 'G3DSA:2.40.50.360:FF:000004', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(200977, NULL, 'G3DSA:3.40.50.300:FF:002989', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(200978, NULL, 'G3DSA:3.30.160.60:FF:001393', NULL, NULL, 'zinc finger protein 133 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(200979, NULL, 'G3DSA:3.30.470.20:FF:000106', NULL, NULL, 'Multifunctional urea amidolyase', NULL, NULL, NULL, NULL, NULL, 4),
(200980, NULL, 'G3DSA:3.80.10.10:FF:002635', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(200981, NULL, 'G3DSA:3.90.1150.10:FF:000284', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(200982, NULL, 'G3DSA:1.10.220.30:FF:000030', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(200983, NULL, 'G3DSA:3.30.200.20:FF:001121', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(200984, NULL, 'G3DSA:1.10.1380.10:FF:000017', NULL, NULL, 'Endothelin-converting enzyme (AFU_orthologue AFUA_3G12420)', NULL, NULL, NULL, NULL, NULL, 4),
(200985, NULL, 'G3DSA:2.60.40.10:FF:001741', NULL, NULL, 'Basal cell adhesion molecule', NULL, NULL, NULL, NULL, NULL, 4),
(200986, NULL, 'G3DSA:1.20.970.10:FF:000033', NULL, NULL, 'Anthranilate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(200987, NULL, 'G3DSA:2.120.10.80:FF:000296', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(200988, NULL, 'G3DSA:1.10.10.10:FF:000794', NULL, NULL, 'Transcriptional regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(200989, NULL, 'G3DSA:3.40.50.720:FF:002525', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(200990, NULL, 'G3DSA:2.30.30.490:FF:000081', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(200991, NULL, 'G3DSA:3.30.40.10:FF:002134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(200992, NULL, 'G3DSA:2.40.50.140:FF:000068', NULL, NULL, '26S protease regulatory subunit 8', NULL, NULL, NULL, NULL, NULL, 4),
(200993, NULL, 'G3DSA:2.30.29.30:FF:000255', NULL, NULL, 'niban-like protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(200994, NULL, 'G3DSA:3.30.9.10:FF:000010', NULL, NULL, 'FAD-binding oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(200995, NULL, 'G3DSA:3.10.100.10:FF:000339', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(200996, NULL, 'G3DSA:3.20.20.140:FF:000242', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(200997, NULL, 'G3DSA:3.40.50.11260:FF:000008', NULL, NULL, 'Chaperone protein HtpG', NULL, NULL, NULL, NULL, NULL, 4),
(200998, NULL, 'G3DSA:3.30.200.20:FF:002447', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(200999, NULL, 'G3DSA:1.10.565.10:FF:000133', NULL, NULL, 'Nuclear receptor', NULL, NULL, NULL, NULL, NULL, 4),
(201000, NULL, 'G3DSA:3.60.10.10:FF:000219', NULL, NULL, 'Endonuclease/Exonuclease/phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(201001, NULL, 'G3DSA:1.25.40.10:FF:005107', NULL, NULL, 'SET domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(201002, NULL, 'G3DSA:2.40.50.120:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201003, NULL, 'G3DSA:3.40.50.12370:FF:000010', NULL, NULL, 'Cation/H(+) antiporter 15', NULL, NULL, NULL, NULL, NULL, 4),
(201004, NULL, 'G3DSA:3.40.50.360:FF:000023', NULL, NULL, 'NADPH--cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(201005, NULL, 'G3DSA:2.30.30.140:FF:000010', NULL, NULL, 'MBT domain-containing protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(201006, NULL, 'G3DSA:3.80.10.10:FF:004434', NULL, NULL, 'MDIS1-interacting receptor like kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(201007, NULL, 'G3DSA:3.40.30.10:FF:000300', NULL, NULL, 'Blast:Protein disulfide-isomerase TMX3', NULL, NULL, NULL, NULL, NULL, 4),
(201008, NULL, 'G3DSA:1.25.40.20:FF:001513', NULL, NULL, 'Ankyrin repeat domain 17', NULL, NULL, NULL, NULL, NULL, 4),
(201009, NULL, 'G3DSA:1.10.510.10:FF:003536', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201010, NULL, 'G3DSA:1.20.1070.10:FF:000733', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(201011, NULL, 'G3DSA:1.25.10.10:FF:003470', NULL, NULL, 'Importin subunit alpha-2', NULL, NULL, NULL, NULL, NULL, 4),
(201012, NULL, 'G3DSA:1.10.287.2720:FF:000008', NULL, NULL, 'Oxysterol binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(201013, NULL, 'G3DSA:3.40.50.2000:FF:000621', NULL, NULL, 'Slr0907 protein', NULL, NULL, NULL, NULL, NULL, 4),
(201014, NULL, 'G3DSA:2.60.40.10:FF:003208', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201015, NULL, 'G3DSA:3.30.1430.10:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201016, NULL, 'G3DSA:2.40.160.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201017, NULL, 'G3DSA:1.25.40.90:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201018, NULL, 'G3DSA:2.30.42.10:FF:000229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201019, NULL, 'G3DSA:3.30.1490.80:FF:000001', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(201020, NULL, 'G3DSA:1.20.1740.10:FF:000043', NULL, NULL, 'Inner membrane transporter YcaM', NULL, NULL, NULL, NULL, NULL, 4),
(201021, NULL, 'G3DSA:3.30.40.10:FF:000335', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(201022, NULL, 'G3DSA:1.25.40.10:FF:001510', NULL, NULL, 'Os07g0213300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(201023, NULL, 'G3DSA:3.30.230.70:FF:000098', NULL, NULL, 'Ribosomal RNA processing protein 41B', NULL, NULL, NULL, NULL, NULL, 4),
(201024, NULL, 'G3DSA:1.10.600.10:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201025, NULL, 'G3DSA:3.40.50.300:FF:005176', NULL, NULL, 'Thymidylate kinase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(201026, NULL, 'G3DSA:2.120.10.30:FF:000287', NULL, NULL, 'Ten-1', NULL, NULL, NULL, NULL, NULL, 4),
(201027, NULL, 'G3DSA:2.60.40.150:FF:000699', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201028, NULL, 'G3DSA:3.90.1860.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201029, NULL, 'G3DSA:3.40.50.1110:FF:000106', NULL, NULL, 'Membrane protein containing Lipase, GDSL domain', NULL, NULL, NULL, NULL, NULL, 4),
(201030, NULL, 'G3DSA:3.30.40.10:FF:000425', NULL, NULL, 'PHD finger protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(201031, NULL, 'G3DSA:1.25.40.10:FF:003308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201032, NULL, 'G3DSA:1.10.287.70:FF:000504', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201033, NULL, 'G3DSA:1.20.5.170:FF:000028', NULL, NULL, 'CCAAT/enhancer-binding protein beta', NULL, NULL, NULL, NULL, NULL, 4),
(201034, NULL, 'G3DSA:3.80.10.10:FF:000634', NULL, NULL, 'Partner of Paired', NULL, NULL, NULL, NULL, NULL, 4),
(201035, NULL, 'G3DSA:3.40.30.10:FF:001239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201036, NULL, 'G3DSA:1.20.1070.10:FF:001728', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201037, NULL, 'G3DSA:1.10.10.820:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201038, NULL, 'G3DSA:1.10.12.10:FF:000034', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(201039, NULL, 'G3DSA:3.30.1300.30:FF:000012', NULL, NULL, 'Necessary for collagen adhesion A1', NULL, NULL, NULL, NULL, NULL, 4),
(201040, NULL, 'G3DSA:2.40.37.10:FF:000037', NULL, NULL, 'Ornithine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(201041, NULL, 'G3DSA:3.90.190.10:FF:000326', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201042, NULL, 'G3DSA:3.30.420.40:FF:000637', NULL, NULL, 'Decarbamoylnovobiocin carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(201043, NULL, 'G3DSA:3.30.40.10:FF:000083', NULL, NULL, 'E3 ubiquitin-protein ligase MIB1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(201044, NULL, 'G3DSA:2.60.40.1390:FF:000012', NULL, NULL, 'Myelin gene regulatory factor-like A', NULL, NULL, NULL, NULL, NULL, 4),
(201045, NULL, 'G3DSA:2.60.40.10:FF:001409', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(201046, NULL, 'G3DSA:1.10.3810.10:FF:000006', NULL, NULL, 'Penicillin-binding protein 1C', NULL, NULL, NULL, NULL, NULL, 4),
(201047, NULL, 'G3DSA:2.40.30.10:FF:000483', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201048, NULL, 'G3DSA:1.20.960.10:FF:000004', NULL, NULL, 'Mitochondrial import receptor subunit TOM20 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(201049, NULL, 'G3DSA:1.20.140.10:FF:000021', NULL, NULL, 'Acyl-coenzyme A oxidase 4, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(201050, NULL, 'G3DSA:2.40.70.10:FF:000457', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201051, NULL, 'G3DSA:3.30.519.10:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201052, NULL, 'G3DSA:3.30.160.60:FF:003753', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201053, NULL, 'G3DSA:1.25.40.20:FF:000895', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201054, NULL, 'G3DSA:4.10.240.10:FF:000070', NULL, NULL, 'Aspergillus niger contig An11c0010, genomic contig', NULL, NULL, NULL, NULL, NULL, 4),
(201055, NULL, 'G3DSA:3.40.50.300:FF:006789', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201056, NULL, 'G3DSA:3.90.1030.20:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201057, NULL, 'G3DSA:1.25.40.10:FF:000892', NULL, NULL, 'SNAP protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(201058, NULL, 'G3DSA:2.60.40.10:FF:003540', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201059, NULL, 'G3DSA:1.25.10.10:FF:002756', NULL, NULL, 'Coatomer subunit beta', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(201060, NULL, 'G3DSA:2.60.120.260:FF:000409', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201061, NULL, 'G3DSA:3.30.70.330:FF:000296', NULL, NULL, 'RNA binding motif protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(201062, NULL, 'G3DSA:3.90.1030.10:FF:000011', NULL, NULL, 'Ribosomal protein L17', NULL, NULL, NULL, NULL, NULL, 4),
(201063, NULL, 'G3DSA:3.40.50.300:FF:003046', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(201064, NULL, 'G3DSA:3.90.110.10:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201065, NULL, 'G3DSA:3.30.230.10:FF:000338', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201066, NULL, 'G3DSA:1.20.5.700:FF:000007', NULL, NULL, 'Cytochrome b6-f complex iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4),
(201067, NULL, 'G3DSA:2.30.30.40:FF:000649', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201068, NULL, 'G3DSA:3.30.2290.10:FF:000004', NULL, NULL, 'Metalloprotease TldD', NULL, NULL, NULL, NULL, NULL, 4),
(201069, NULL, 'G3DSA:1.20.58.2190:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201070, NULL, 'G3DSA:1.10.10.10:FF:000884', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(201071, NULL, 'G3DSA:1.20.58.400:FF:000024', NULL, NULL, 'AaceriAFL168Wp', NULL, NULL, NULL, NULL, NULL, 4),
(201072, NULL, 'G3DSA:1.10.260.40:FF:000007', NULL, NULL, 'POU domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(201073, NULL, 'G3DSA:3.90.320.10:FF:000034', NULL, NULL, 'Mitochondrial genome maintenance exonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(201074, NULL, 'G3DSA:3.10.20.620:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201075, NULL, 'G3DSA:2.130.10.10:FF:003102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201076, NULL, 'G3DSA:3.30.1520.10:FF:000107', NULL, NULL, 'Phosphoinositide-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(201077, NULL, 'G3DSA:2.10.110.10:FF:000282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201078, NULL, 'G3DSA:1.10.4150.10:FF:000001', NULL, NULL, 'Invasin ipaA', NULL, NULL, NULL, NULL, NULL, 4),
(201079, NULL, 'G3DSA:1.50.10.20:FF:000082', NULL, NULL, 'Cycloartenol synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(201080, NULL, 'G3DSA:1.10.1090.10:FF:000006', NULL, NULL, 'Cytochrome b-c1 complex subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(201081, NULL, 'G3DSA:3.30.160.60:FF:003444', NULL, NULL, 'Zinc finger protein 142', NULL, NULL, NULL, NULL, NULL, 4),
(201082, NULL, 'G3DSA:1.10.510.10:FF:002699', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201083, NULL, 'G3DSA:1.20.5.1940:FF:000006', NULL, NULL, 'Signal transducing adapter molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(201084, NULL, 'G3DSA:3.90.1010.10:FF:000009', NULL, NULL, 'FeS cluster assembly scaffold protein NifU', NULL, NULL, NULL, NULL, NULL, 4),
(201085, NULL, 'G3DSA:1.10.510.10:FF:003317', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201086, NULL, 'G3DSA:2.60.40.10:FF:001651', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(201087, NULL, 'G3DSA:3.90.640.10:FF:000182', NULL, NULL, 'Actin-related protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(201088, NULL, 'G3DSA:2.130.10.10:FF:002484', NULL, NULL, 'DNA damage-binding protein 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(201089, NULL, 'G3DSA:2.60.120.200:FF:000307', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(201090, NULL, 'G3DSA:2.20.70.10:FF:000284', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(201091, NULL, 'G3DSA:3.20.20.190:FF:000010', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(201092, NULL, 'G3DSA:3.40.50.300:FF:007430', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(201093, NULL, 'G3DSA:2.130.10.10:FF:003630', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(201094, NULL, 'G3DSA:3.40.50.720:FF:002435', NULL, NULL, 'Probable 2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(201095, NULL, 'G3DSA:1.25.10.10:FF:003161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201096, NULL, 'G3DSA:3.20.190.10:FF:000022', NULL, NULL, 'LOC100135209 protein', NULL, NULL, NULL, NULL, NULL, 4),
(201097, NULL, 'G3DSA:3.30.465.10:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201098, NULL, 'G3DSA:3.20.70.20:FF:000014', NULL, NULL, 'Ribonucleoside-diphosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(201099, NULL, 'G3DSA:3.80.10.10:FF:000073', NULL, NULL, 'Lumican', NULL, NULL, NULL, NULL, NULL, 4),
(201100, NULL, 'G3DSA:2.60.40.10:FF:001286', NULL, NULL, 'Oncostatin-M-specific receptor subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(201101, NULL, 'G3DSA:3.30.420.10:FF:000263', NULL, NULL, 'Pro-Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(201102, NULL, 'G3DSA:2.130.10.10:FF:003411', NULL, NULL, 'GTPase activator protein', NULL, NULL, NULL, NULL, NULL, 4),
(201103, NULL, 'G3DSA:3.40.50.300:FF:007407', NULL, NULL, 'DNA polymerase theta (Helicase domain only), putative', NULL, NULL, NULL, NULL, NULL, 4),
(201104, NULL, 'G3DSA:3.40.50.300:FF:002883', NULL, NULL, 'Kurz, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(201105, NULL, 'G3DSA:1.20.142.10:FF:000003', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(201106, NULL, 'G3DSA:3.40.30.10:FF:000986', NULL, NULL, 'Glutaredoxin, CGFS type', NULL, NULL, NULL, NULL, NULL, 4),
(201107, NULL, 'G3DSA:1.25.40.10:FF:004944', NULL, NULL, 'Intraflagellar transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(201108, NULL, 'G3DSA:3.80.10.10:FF:004215', NULL, NULL, 'MAP kinase phosphatase with leucine-rich repeats protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(201109, NULL, 'G3DSA:2.60.40.10:FF:005029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201110, NULL, 'G3DSA:1.10.10.60:FF:001056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201111, NULL, 'G3DSA:3.30.160.380:FF:000004', NULL, NULL, 'Dicer-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(201112, NULL, 'G3DSA:2.120.10.30:FF:000539', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201113, NULL, 'G3DSA:3.30.1330.40:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201114, NULL, 'G3DSA:3.40.390.10:FF:000139', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(201115, NULL, 'G3DSA:3.40.50.11660:FF:000005', NULL, NULL, 'Glycoprotein 3-alpha-L-fucosyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(201116, NULL, 'G3DSA:2.130.10.10:FF:001067', NULL, NULL, 'Regulatory-associated protein of mTOR isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(201117, NULL, 'G3DSA:1.10.1520.10:FF:000006', NULL, NULL, 'Endoribonuclease Dicer isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(201118, NULL, 'G3DSA:2.170.140.10:FF:000038', NULL, NULL, 'Probable chitinase 10', NULL, NULL, NULL, NULL, NULL, 4),
(201119, NULL, 'G3DSA:1.20.1250.20:FF:000503', NULL, NULL, 'Drug resistance transporter, EmrB/QacA subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(201120, NULL, 'G3DSA:3.40.50.300:FF:003136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201121, NULL, 'G3DSA:1.10.510.10:FF:003008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201122, NULL, 'G3DSA:2.60.40.10:FF:005338', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201123, NULL, 'G3DSA:3.40.50.1400:FF:000002', NULL, NULL, 'Ferrochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(201124, NULL, 'G3DSA:3.40.50.1000:FF:000675', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201125, NULL, 'G3DSA:3.40.50.12780:FF:000026', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(201126, NULL, 'G3DSA:3.40.50.150:FF:001365', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201127, NULL, 'G3DSA:3.40.525.10:FF:000055', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type 9', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(201128, NULL, 'G3DSA:3.30.497.10:FF:000165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201129, NULL, 'G3DSA:3.30.70.1990:FF:000002', NULL, NULL, 'FAD-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(201130, NULL, 'G3DSA:2.60.40.420:FF:000038', NULL, NULL, 'Extracellular dihydrogeodin oxidase/laccase', NULL, NULL, NULL, NULL, NULL, 4),
(201131, NULL, 'G3DSA:3.40.50.620:FF:000135', NULL, NULL, 'Phosphoadenosine phosphosulfate reductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(201132, NULL, 'G3DSA:2.60.120.650:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201133, NULL, 'G3DSA:1.20.58.60:FF:000671', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201134, NULL, 'G3DSA:3.40.50.150:FF:001275', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201135, NULL, 'G3DSA:1.20.1280.290:FF:000066', NULL, NULL, 'Sugar_efflux_transporter_for_intercellular_exchange_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(201136, NULL, 'G3DSA:1.20.1420.30:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201137, NULL, 'G3DSA:1.10.10.1070:FF:000001', NULL, NULL, 'zinc finger protein 618 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(201138, NULL, 'G3DSA:3.40.1710.10:FF:000007', NULL, NULL, 'ABC transporter, permease protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(201139, NULL, 'G3DSA:1.20.1070.10:FF:000391', NULL, NULL, 'Parapinopsin b', NULL, NULL, NULL, NULL, NULL, 4),
(201140, NULL, 'G3DSA:2.60.110.10:FF:000012', NULL, NULL, 'TOND1', NULL, NULL, NULL, NULL, NULL, 4),
(201141, NULL, 'G3DSA:1.25.40.10:FF:004635', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201142, NULL, 'G3DSA:3.30.870.10:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201143, NULL, 'G3DSA:3.10.20.90:FF:000111', NULL, NULL, 'Histidine ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(201144, NULL, 'G3DSA:3.40.1190.20:FF:000003', NULL, NULL, 'Phosphomethylpyrimidine kinase ThiD', NULL, NULL, NULL, NULL, NULL, 4),
(201145, NULL, 'G3DSA:3.30.260.10:FF:000076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201146, NULL, 'G3DSA:3.30.300.70:FF:000002', NULL, NULL, 'Ribosome maturation factor RimP', NULL, NULL, NULL, NULL, NULL, 4),
(201147, NULL, 'G3DSA:2.130.10.10:FF:002793', NULL, NULL, 'Integrin alpha chain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(201148, NULL, 'G3DSA:1.20.58.60:FF:000362', NULL, NULL, 'Spectrin repeat containing nuclear envelope protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(201149, NULL, 'G3DSA:2.20.110.10:FF:000009', NULL, NULL, 'alsin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(201150, NULL, 'G3DSA:3.20.20.100:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201151, NULL, 'G3DSA:1.25.40.120:FF:000032', NULL, NULL, 'Putative farnesyl protein transferase', NULL, NULL, NULL, NULL, NULL, 4),
(201152, NULL, 'G3DSA:3.40.1440.10:FF:000014', NULL, NULL, 'Putative bifunctional exonuclease/endonuclease protein Rv2191', NULL, NULL, NULL, NULL, NULL, 4),
(201153, NULL, 'G3DSA:3.30.160.60:FF:002949', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(201154, NULL, 'G3DSA:3.30.70.330:FF:002460', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201155, NULL, 'G3DSA:3.40.630.30:FF:000142', NULL, NULL, 'Alpha-tubulin N-acetyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(201156, NULL, 'G3DSA:3.30.1120.30:FF:000026', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(201157, NULL, 'G3DSA:3.30.160.60:FF:000100', NULL, NULL, 'Zinc finger 45-like', NULL, NULL, NULL, NULL, NULL, 4),
(201158, NULL, 'G3DSA:2.130.10.10:FF:003321', NULL, NULL, 'YALI0C23386p', NULL, NULL, NULL, NULL, NULL, 4),
(201159, NULL, 'G3DSA:3.80.10.10:FF:000163', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(201160, NULL, 'G3DSA:3.60.110.10:FF:000047', NULL, NULL, 'N-carbamoyl-D-amino acid hydrolase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(201161, NULL, 'G3DSA:3.30.300.90:FF:000008', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(201162, NULL, 'G3DSA:3.10.590.10:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201163, NULL, 'G3DSA:1.20.1070.10:FF:000643', NULL, NULL, 'Methuselah-like 1, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(201164, NULL, 'G3DSA:2.60.40.10:FF:002736', NULL, NULL, 'Chitin biosynthesis protein CHS5', NULL, NULL, NULL, NULL, NULL, 4),
(201165, NULL, 'G3DSA:1.10.600.10:FF:000019', NULL, NULL, '2-methylisoborneol synthase', NULL, NULL, NULL, NULL, NULL, 4),
(201166, NULL, 'G3DSA:3.30.559.10:FF:000135', NULL, NULL, 'Nonribosomal peptide synthetase 9', NULL, NULL, NULL, NULL, NULL, 4),
(201167, NULL, 'G3DSA:2.40.50.140:FF:000192', NULL, NULL, 'Mitochondrial ribosomal protein S12', NULL, NULL, NULL, NULL, NULL, 4),
(201168, NULL, 'G3DSA:3.60.10.10:FF:000113', NULL, NULL, 'CRE-UNC-26 protein', NULL, NULL, NULL, NULL, NULL, 4),
(201169, NULL, 'G3DSA:3.40.50.300:FF:001461', NULL, NULL, 'GTP-binding protein ryh1', NULL, NULL, NULL, NULL, NULL, 4),
(201170, NULL, 'G3DSA:1.10.287.70:FF:000151', NULL, NULL, 'TWiK family of potassium channels', NULL, NULL, NULL, NULL, NULL, 4),
(201171, NULL, 'G3DSA:2.60.40.10:FF:003231', NULL, NULL, 'Cell surface glycoprotein CD200 receptor 1-A', NULL, NULL, NULL, NULL, NULL, 4),
(201172, NULL, 'G3DSA:3.90.550.50:FF:000097', NULL, NULL, 'Glycosyltransferase family 31 protein', NULL, NULL, NULL, NULL, NULL, 4),
(201173, NULL, 'G3DSA:1.10.10.10:FF:000682', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(201174, NULL, 'G3DSA:3.40.1000.30:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201175, NULL, 'G3DSA:1.10.238.10:FF:000992', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(201176, NULL, 'G3DSA:1.10.600.10:FF:000126', NULL, NULL, 'Quemao protein', NULL, NULL, NULL, NULL, NULL, 4),
(201177, NULL, 'G3DSA:2.120.10.80:FF:000184', NULL, NULL, 'GM15889', NULL, NULL, NULL, NULL, NULL, 4),
(201178, NULL, 'G3DSA:3.40.50.300:FF:008386', NULL, NULL, 'Regulator of nonsense transcripts putative', NULL, NULL, NULL, NULL, NULL, 4),
(201179, NULL, 'G3DSA:1.10.10.850:FF:000002', NULL, NULL, 'Isocitrate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(201180, NULL, 'G3DSA:2.60.40.10:FF:004849', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201181, NULL, 'G3DSA:2.10.25.10:FF:001826', NULL, NULL, 'AGAP001015-PA', NULL, NULL, NULL, NULL, NULL, 4),
(201182, NULL, 'G3DSA:3.30.70.330:FF:000436', NULL, NULL, '50S ribosomal protein L23', NULL, NULL, NULL, NULL, NULL, 4),
(201183, NULL, 'G3DSA:1.20.1070.10:FF:001947', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201184, NULL, 'G3DSA:3.40.190.10:FF:000821', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(201185, NULL, 'G3DSA:3.40.50.150:FF:001590', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201186, NULL, 'G3DSA:2.40.37.10:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201187, NULL, 'G3DSA:2.130.10.10:FF:002692', NULL, NULL, 'Ribosome biogenesis protein WDR12 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(201188, NULL, 'G3DSA:2.60.60.30:FF:000006', NULL, NULL, 'Putative Tellurium resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(201189, NULL, 'G3DSA:1.20.1250.20:FF:002184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201190, NULL, 'G3DSA:2.10.25.10:FF:000303', NULL, NULL, 'latent-transforming growth factor beta-binding protein 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(201191, NULL, 'G3DSA:3.30.70.330:FF:001959', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201192, NULL, 'G3DSA:1.20.1270.230:FF:000001', NULL, NULL, 'Primer terminal protein', NULL, NULL, NULL, NULL, NULL, 4),
(201193, NULL, 'G3DSA:3.30.420.10:FF:000403', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201194, NULL, 'G3DSA:2.60.60.20:FF:000003', NULL, NULL, 'Triacylglycerol lipase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(201195, NULL, 'G3DSA:1.20.920.10:FF:000114', NULL, NULL, 'SWI/SNF class chromatin remodeling complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(201196, NULL, 'G3DSA:3.40.140.10:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201197, NULL, 'G3DSA:3.30.565.10:FF:000548', NULL, NULL, 'Cytokinin receptor AtCKI2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(201198, NULL, 'G3DSA:3.90.470.10:FF:000045', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(201199, NULL, 'G3DSA:3.90.1150.10:FF:000048', NULL, NULL, 'Serine hydroxymethyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(201200, NULL, 'G3DSA:2.130.10.10:FF:005333', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(201201, NULL, 'G3DSA:3.30.420.40:FF:000952', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(201202, NULL, 'G3DSA:1.25.40.180:FF:000117', NULL, NULL, 'eIF4-gamma/eIF5/eIF2b-epsilon initiation factor, C-terminal domain', NULL, NULL, NULL, NULL, NULL, 4),
(201203, NULL, 'G3DSA:1.10.10.410:FF:000005', NULL, NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit B, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(201204, NULL, 'G3DSA:2.10.110.10:FF:000271', NULL, NULL, 'Four and a half LIM domains protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(201205, NULL, 'G3DSA:3.30.1470.10:FF:000001', NULL, NULL, 'Centrosomal protein of 164 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(201206, NULL, 'G3DSA:2.130.10.10:FF:003304', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(201207, NULL, 'G3DSA:1.20.1270.250:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201208, NULL, 'G3DSA:1.25.40.10:FF:004725', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(201209, NULL, 'G3DSA:3.40.50.620:FF:000253', NULL, NULL, 'NH(3)-dependent NAD(+) synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(201210, NULL, 'G3DSA:1.20.1270.10:FF:000052', NULL, NULL, 'Lumenal Hsp70 protein', NULL, NULL, NULL, NULL, NULL, 4),
(201211, NULL, 'G3DSA:3.30.2350.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201212, NULL, 'G3DSA:3.30.70.330:FF:000857', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(201213, NULL, 'G3DSA:2.60.120.200:FF:000521', NULL, NULL, 'YALI0E06347p', NULL, NULL, NULL, NULL, NULL, 4),
(201214, NULL, 'G3DSA:3.40.1190.20:FF:000121', NULL, NULL, 'Adenosine kinase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(201215, NULL, 'G3DSA:1.25.40.10:FF:002376', NULL, NULL, 'Os11g0114800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(201216, NULL, 'G3DSA:2.40.70.10:FF:000581', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201217, NULL, 'G3DSA:3.50.50.60:FF:000428', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(201218, NULL, 'G3DSA:3.30.70.120:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201219, NULL, 'G3DSA:3.40.50.2300:FF:000273', NULL, NULL, 'Two-component system response regulator RpfG', NULL, NULL, NULL, NULL, NULL, 4),
(201220, NULL, 'G3DSA:2.20.25.10:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201221, NULL, 'G3DSA:3.40.220.10:FF:000009', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(201222, NULL, 'G3DSA:1.25.10.10:FF:001025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201223, NULL, 'G3DSA:1.25.10.10:FF:002874', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(201224, NULL, 'G3DSA:3.40.50.300:FF:001556', NULL, NULL, 'ABC transporter G family member 6', NULL, NULL, NULL, NULL, NULL, 4),
(201225, NULL, 'G3DSA:3.30.67.10:FF:000003', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(201226, NULL, 'G3DSA:2.60.220.50:FF:000015', NULL, NULL, 'Adhesion G protein-coupled receptor F4', NULL, NULL, NULL, NULL, NULL, 4),
(201227, NULL, 'G3DSA:3.30.450.20:FF:000329', NULL, NULL, 'Sensory box histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(201228, NULL, 'G3DSA:3.30.9.10:FF:000015', NULL, NULL, 'FAD-dependent oxidoreductase domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(201229, NULL, 'G3DSA:1.10.10.10:FF:000777', NULL, NULL, 'Probable ATP dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(201230, NULL, 'G3DSA:3.40.50.10190:FF:000103', NULL, NULL, 'Pescadillo homolog', NULL, NULL, NULL, NULL, NULL, 4),
(201231, NULL, 'G3DSA:3.40.50.1260:FF:000016', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(201232, NULL, 'G3DSA:3.30.70.100:FF:000013', NULL, NULL, 'L-rhamnose mutarotase', NULL, NULL, NULL, NULL, NULL, 4),
(201233, NULL, 'G3DSA:2.40.50.140:FF:000871', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201234, NULL, 'G3DSA:1.20.58.60:FF:000356', NULL, NULL, 'VAB-10B protein', NULL, NULL, NULL, NULL, NULL, 4),
(201235, NULL, 'G3DSA:1.20.5.170:FF:000141', NULL, NULL, 'C6 transcription factor (Gal4), putative', NULL, NULL, NULL, NULL, NULL, 4),
(201236, NULL, 'G3DSA:1.10.510.10:FF:001530', NULL, NULL, 'Kinase, AGC MAST', NULL, NULL, NULL, NULL, NULL, 4),
(201237, NULL, 'G3DSA:2.60.40.10:FF:003326', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201238, NULL, 'G3DSA:2.60.40.10:FF:004754', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201239, NULL, 'G3DSA:2.20.100.10:FF:000161', NULL, NULL, 'F-spondin', NULL, NULL, NULL, NULL, NULL, 4),
(201240, NULL, 'G3DSA:3.30.430.20:FF:000008', NULL, NULL, 'cysteine-rich repeat secretory protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(201241, NULL, 'G3DSA:3.40.50.300:FF:002984', NULL, NULL, 'DNA mismatch repair protein MutS 1', NULL, NULL, NULL, NULL, NULL, 4),
(201242, NULL, 'G3DSA:2.30.40.10:FF:000146', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(201243, NULL, 'G3DSA:2.60.120.260:FF:000174', NULL, NULL, 'Beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(201244, NULL, 'G3DSA:3.30.70.330:FF:000762', NULL, NULL, 'Zinc finger CCCH domain-containing protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(201245, NULL, 'G3DSA:2.60.40.3170:FF:000012', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(201246, NULL, 'G3DSA:1.50.40.10:FF:000142', NULL, NULL, 'Solute carrier family 25 member 26', NULL, NULL, NULL, NULL, NULL, 4),
(201247, NULL, 'G3DSA:3.10.450.350:FF:000004', NULL, NULL, 'Glycyl-glycine endopeptidase ALE-1', NULL, NULL, NULL, NULL, NULL, 4),
(201248, NULL, 'G3DSA:3.30.160.60:FF:002837', NULL, NULL, 'Zinc finger protein 232', NULL, NULL, NULL, NULL, NULL, 4),
(201249, NULL, 'G3DSA:1.20.1080.10:FF:000026', NULL, NULL, 'Big brain', NULL, NULL, NULL, NULL, NULL, 4),
(201250, NULL, 'G3DSA:3.40.50.2300:FF:000952', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201251, NULL, 'G3DSA:1.25.40.180:FF:000022', NULL, NULL, 'Translation initiation factor eIF-2B epsilon subunit', NULL, NULL, NULL, NULL, NULL, 4),
(201252, NULL, 'G3DSA:3.30.160.60:FF:001640', NULL, NULL, 'Zinc finger and BTB domain containing 40', NULL, NULL, NULL, NULL, NULL, 4),
(201253, NULL, 'G3DSA:1.25.40.10:FF:003202', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g21065', NULL, NULL, NULL, NULL, NULL, 4),
(201254, NULL, 'G3DSA:3.40.50.720:FF:000395', NULL, NULL, 'ubiquitin-like modifier-activating enzyme ATG7', NULL, NULL, NULL, NULL, NULL, 4),
(201255, NULL, 'G3DSA:3.30.70.1230:FF:000100', NULL, NULL, '7TM diverse intracellular signaling', NULL, NULL, NULL, NULL, NULL, 4),
(201256, NULL, 'G3DSA:3.30.1360.230:FF:000003', NULL, NULL, 'Suppressor of fused homolog', NULL, NULL, NULL, NULL, NULL, 4),
(201257, NULL, 'G3DSA:3.30.200.20:FF:000188', NULL, NULL, 'Hepatocyte growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(201258, NULL, 'G3DSA:3.30.710.10:FF:000055', NULL, NULL, 'BTB/POZ domain-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(201259, NULL, 'G3DSA:3.40.50.150:FF:001601', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201260, NULL, 'G3DSA:2.30.29.30:FF:000805', NULL, NULL, 'AGAP003924-PA', NULL, NULL, NULL, NULL, NULL, 4),
(201261, NULL, 'G3DSA:2.40.510.10:FF:000002', NULL, NULL, 'Capsid protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(201262, NULL, 'G3DSA:1.10.630.10:FF:000049', NULL, NULL, 'steroid 21-hydroxylase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(201263, NULL, 'G3DSA:1.10.10.60:FF:001039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201264, NULL, 'G3DSA:3.40.50.2300:FF:000626', NULL, NULL, 'Glutamate ionotropic receptor NMDA type subunit 2D', NULL, NULL, NULL, NULL, NULL, 4),
(201265, NULL, 'G3DSA:1.10.10.10:FF:001620', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201266, NULL, 'G3DSA:1.10.150.50:FF:000232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201267, NULL, 'G3DSA:2.60.420.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201268, NULL, 'G3DSA:2.40.50.140:FF:001130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201269, NULL, 'G3DSA:3.40.50.1820:FF:000555', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(201270, NULL, 'G3DSA:1.25.40.20:FF:001182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201271, NULL, 'G3DSA:3.30.1230.20:FF:000009', NULL, NULL, 'Tubulin folding cofactor E', NULL, NULL, NULL, NULL, NULL, 4),
(201272, NULL, 'G3DSA:3.80.10.10:FF:002427', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RCH1', NULL, NULL, NULL, NULL, NULL, 4),
(201273, NULL, 'G3DSA:4.10.410.20:FF:000007', NULL, NULL, 'Poly(U)-specific endoribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(201274, NULL, 'G3DSA:1.10.555.10:FF:000200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201275, NULL, 'G3DSA:3.90.45.10:FF:000012', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(201276, NULL, 'G3DSA:3.90.190.10:FF:000107', NULL, NULL, 'Dual specificity phosphatase 28', NULL, NULL, NULL, NULL, NULL, 4),
(201277, NULL, 'G3DSA:3.80.10.10:FF:000303', NULL, NULL, 'Zyg-11 family member A, cell cycle regulator', NULL, NULL, NULL, NULL, NULL, 4),
(201278, NULL, 'G3DSA:3.30.160.60:FF:001314', NULL, NULL, 'Zinc finger protein 879', NULL, NULL, NULL, NULL, NULL, 4),
(201279, NULL, 'G3DSA:3.30.70.260:FF:000033', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(201280, NULL, 'G3DSA:3.30.497.10:FF:000148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201281, NULL, 'G3DSA:1.25.40.10:FF:005017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201282, NULL, 'G3DSA:2.40.70.10:FF:000367', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201283, NULL, 'G3DSA:3.40.50.300:FF:003259', NULL, NULL, 'U5 small nuclear ribonucleoprotein component, putative', NULL, NULL, NULL, NULL, NULL, 4),
(201284, NULL, 'G3DSA:2.30.29.170:FF:000011', NULL, NULL, 'Putative DUF1126 protein/EF-hand domain pair, putative', NULL, NULL, NULL, NULL, NULL, 4),
(201285, NULL, 'G3DSA:3.30.1360.10:FF:000027', NULL, NULL, 'RNA polymerases II subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(201286, NULL, 'G3DSA:1.10.510.10:FF:000687', NULL, NULL, 'MAP kinase kinase MKK1/SSP32', NULL, NULL, NULL, NULL, NULL, 4),
(201287, NULL, 'G3DSA:3.30.470.20:FF:000229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201288, NULL, 'G3DSA:3.40.1170.10:FF:000004', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(201289, NULL, 'G3DSA:2.120.10.30:FF:000534', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201290, NULL, 'G3DSA:3.30.70.270:FF:000036', NULL, NULL, 'Diguanylate cyclase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(201291, NULL, 'G3DSA:3.40.50.720:FF:001929', NULL, NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 9, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(201292, NULL, 'G3DSA:1.25.40.10:FF:003191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201293, NULL, 'G3DSA:3.40.50.300:FF:003922', NULL, NULL, 'Protein CBG13237', NULL, NULL, NULL, NULL, NULL, 4),
(201294, NULL, 'G3DSA:3.40.50.720:FF:000406', NULL, NULL, 'Acyl-CoA synthetase FdrA', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(201295, NULL, 'G3DSA:1.20.58.1220:FF:000004', NULL, NULL, 'Exocyst complex component Exo84, putative', NULL, NULL, NULL, NULL, NULL, 4),
(201296, NULL, 'G3DSA:2.60.40.1940:FF:000008', NULL, NULL, 'C3 and PZP-like alpha-2-macroglobulin domain-containing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(201297, NULL, 'G3DSA:3.90.650.10:FF:000031', NULL, NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(201298, NULL, 'G3DSA:3.30.70.660:FF:000063', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(201299, NULL, 'G3DSA:2.60.40.1930:FF:000005', NULL, NULL, 'complement C4-A isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(201300, NULL, 'G3DSA:3.90.79.10:FF:000079', NULL, NULL, 'mRNA decapping complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(201301, NULL, 'G3DSA:3.40.50.300:FF:005513', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201302, NULL, 'G3DSA:4.10.1000.10:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201303, NULL, 'G3DSA:3.40.1390.30:FF:000010', NULL, NULL, 'Putative GTP cyclohydrolase 1 type 2, NIF3 family', NULL, NULL, NULL, NULL, NULL, 4),
(201304, NULL, 'G3DSA:3.30.428.10:FF:000062', NULL, NULL, 'AGAP004084-PA', NULL, NULL, NULL, NULL, NULL, 4),
(201305, NULL, 'G3DSA:3.90.1150.10:FF:000374', NULL, NULL, 'PLP-dependent transferase', NULL, NULL, NULL, NULL, NULL, 4),
(201306, NULL, 'G3DSA:3.30.310.80:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201307, NULL, 'G3DSA:1.20.58.1070:FF:000021', NULL, NULL, 'Putative SNARE complex subunit Vam7 (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(201308, NULL, 'G3DSA:3.30.200.100:FF:000004', NULL, NULL, 'Sigma-E factor regulatory protein RseB', NULL, NULL, NULL, NULL, NULL, 4),
(201309, NULL, 'G3DSA:3.30.200.20:FF:001126', NULL, NULL, 'Cell Division Cycle related', NULL, NULL, NULL, NULL, NULL, 4),
(201310, NULL, 'G3DSA:3.40.50.150:FF:000775', NULL, NULL, 'Sterol 24-C-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(201311, NULL, 'G3DSA:3.80.10.10:FF:000292', NULL, NULL, 'Dynein regulatory complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(201312, NULL, 'G3DSA:3.60.70.12:FF:000006', NULL, NULL, 'Arginine biosynthesis bifunctional protein ArgJ, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(201313, NULL, 'G3DSA:3.40.50.150:FF:001264', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201314, NULL, 'G3DSA:3.80.10.10:FF:002074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201315, NULL, 'G3DSA:3.40.50.1000:FF:000877', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201316, NULL, 'G3DSA:3.20.70.20:FF:000003', NULL, NULL, 'Formate acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(201317, NULL, 'G3DSA:3.30.160.60:FF:003085', NULL, NULL, 'Transcriptional repressor CTCF', NULL, NULL, NULL, NULL, NULL, 4),
(201318, NULL, 'G3DSA:3.40.50.2000:FF:000059', NULL, NULL, 'Phosphatidylinositol glycan anchor biosynthesis class A', NULL, NULL, NULL, NULL, NULL, 4),
(201319, NULL, 'G3DSA:3.30.70.250:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201320, NULL, 'G3DSA:3.30.70.330:FF:002774', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201321, NULL, 'G3DSA:3.30.390.30:FF:000041', NULL, NULL, 'Nitrate reductase, NADH oxidase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(201322, NULL, 'G3DSA:2.30.30.100:FF:000150', NULL, NULL, 'AGAP003131-PA', NULL, NULL, NULL, NULL, NULL, 4),
(201323, NULL, 'G3DSA:3.30.760.10:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201324, NULL, 'G3DSA:3.30.60.20:FF:000087', NULL, NULL, 'Ras association domain family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(201325, NULL, 'G3DSA:3.40.50.720:FF:000620', NULL, NULL, '3-oxoacyl-(Acyl carrier protein) reductase', NULL, NULL, NULL, NULL, NULL, 4),
(201326, NULL, 'G3DSA:3.90.70.10:FF:000773', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201327, NULL, 'G3DSA:2.70.160.11:FF:000019', NULL, NULL, 'Protein arginine N-methyltransferase 7', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(201328, NULL, 'G3DSA:1.10.510.10:FF:003328', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201329, NULL, 'G3DSA:1.10.8.60:FF:000010', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(201330, NULL, 'G3DSA:3.40.50.300:FF:002658', NULL, NULL, 'Dephospho-CoA kinase', NULL, NULL, NULL, NULL, NULL, 4),
(201331, NULL, 'G3DSA:3.30.160.60:FF:001735', NULL, NULL, 'zinc finger CCCH domain-containing protein 7A', NULL, NULL, NULL, NULL, NULL, 4),
(201332, NULL, 'G3DSA:3.30.450.20:FF:000217', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(201333, NULL, 'G3DSA:3.30.60.90:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201334, NULL, 'G3DSA:2.60.120.260:FF:000269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201335, NULL, 'G3DSA:1.25.40.860:FF:000012', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(201336, NULL, 'G3DSA:3.80.10.10:FF:004114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201337, NULL, 'G3DSA:3.90.70.10:FF:000559', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(201338, NULL, 'G3DSA:1.10.1520.10:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201339, NULL, 'G3DSA:2.10.110.10:FF:000057', NULL, NULL, 'Zyxin', NULL, NULL, NULL, NULL, NULL, 4),
(201340, NULL, 'G3DSA:1.10.486.10:FF:000067', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(201341, NULL, 'G3DSA:1.10.420.10:FF:000028', NULL, NULL, 'Ascorbate peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(201342, NULL, 'G3DSA:1.20.1070.10:FF:000071', NULL, NULL, '5-hydroxytryptamine (serotonin) receptor 7a', NULL, NULL, NULL, NULL, NULL, 4),
(201343, NULL, 'G3DSA:3.20.20.80:FF:000821', NULL, NULL, 'Protein CBG10890', NULL, NULL, NULL, NULL, NULL, 4),
(201344, NULL, 'G3DSA:2.10.50.30:FF:000036', NULL, NULL, 'Vomeronasal 2, receptor27', NULL, NULL, NULL, NULL, NULL, 4),
(201345, NULL, 'G3DSA:3.40.50.300:FF:005608', NULL, NULL, 'Cell division control protein 48 homolog D', NULL, NULL, NULL, NULL, NULL, 4),
(201346, NULL, 'G3DSA:3.30.200.110:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201347, NULL, 'G3DSA:3.40.50.1820:FF:000460', NULL, NULL, 'Acetyl-hydrolase LipR', NULL, NULL, NULL, NULL, NULL, 4),
(201348, NULL, 'G3DSA:3.90.320.10:FF:000045', NULL, NULL, 'ATP-dependent nuclease subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(201349, NULL, 'G3DSA:1.50.40.10:FF:000030', NULL, NULL, 'Mitochondrial uncoupling protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(201350, NULL, 'G3DSA:3.10.250.10:FF:000001', NULL, NULL, 'Lysyl oxidase 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(201351, NULL, 'G3DSA:2.40.10.10:FF:000684', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201352, NULL, 'G3DSA:1.25.40.10:FF:005231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201353, NULL, 'G3DSA:3.20.20.100:FF:000039', NULL, NULL, 'Putative oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(201354, NULL, 'G3DSA:3.40.50.1820:FF:001657', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(201355, NULL, 'G3DSA:3.40.570.10:FF:000007', NULL, NULL, 'Alkaline nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(201356, NULL, 'G3DSA:3.20.20.300:FF:000015', NULL, NULL, 'Glycoside hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(201357, NULL, 'G3DSA:1.20.1070.10:FF:000750', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(201358, NULL, 'G3DSA:3.40.190.10:FF:000607', NULL, NULL, 'ABC-type transporter, periplasmic component', NULL, NULL, NULL, NULL, NULL, 4),
(201359, NULL, 'G3DSA:1.20.58.1210:FF:000001', NULL, NULL, 'exocyst complex component 8', NULL, NULL, NULL, NULL, NULL, 4),
(201360, NULL, 'G3DSA:2.60.220.50:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201361, NULL, 'G3DSA:3.30.50.10:FF:000156', NULL, NULL, 'AGAP009890-PA', NULL, NULL, NULL, NULL, NULL, 4),
(201362, NULL, 'G3DSA:3.30.200.20:FF:002537', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(201363, NULL, 'G3DSA:2.60.120.200:FF:000184', NULL, NULL, 'Botulinum neurotoxin type A', NULL, NULL, NULL, NULL, NULL, 4),
(201364, NULL, 'G3DSA:2.30.30.490:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201365, NULL, 'G3DSA:3.40.50.1000:FF:000782', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201366, NULL, 'G3DSA:3.30.200.20:FF:001031', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(201367, NULL, 'G3DSA:2.10.50.10:FF:000030', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 11B', NULL, NULL, NULL, NULL, NULL, 4),
(201368, NULL, 'G3DSA:1.25.40.1040:FF:000052', NULL, NULL, 'Tetratricopeptide repeat (TPR)-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(201369, NULL, 'G3DSA:1.10.220.30:FF:000024', NULL, NULL, 'FliG C-terminal domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(201370, NULL, 'G3DSA:1.10.3810.10:FF:000001', NULL, NULL, 'Penicillin-binding protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(201371, NULL, 'G3DSA:3.10.580.10:FF:000071', NULL, NULL, 'Hypoxic response protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(201372, NULL, 'G3DSA:4.10.80.390:FF:000001', NULL, NULL, 'ORF1a polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(201373, NULL, 'G3DSA:1.10.167.20:FF:000003', NULL, NULL, 'Nucleoporin NUP170, putative', NULL, NULL, NULL, NULL, NULL, 4),
(201374, NULL, 'G3DSA:2.130.10.10:FF:003416', NULL, NULL, 'Sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(201375, NULL, 'G3DSA:3.40.640.10:FF:000457', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201376, NULL, 'G3DSA:1.20.1250.20:FF:000508', NULL, NULL, 'Sodium-dependent glucose transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(201377, NULL, 'G3DSA:3.30.160.60:FF:001752', NULL, NULL, 'Transcriptional factor SWI5', NULL, NULL, NULL, NULL, NULL, 4),
(201378, NULL, 'G3DSA:3.40.50.970:FF:000127', NULL, NULL, 'Phosphonopyruvate decarboxylase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(201379, NULL, 'G3DSA:1.10.10.60:FF:000764', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201380, NULL, 'G3DSA:3.90.79.10:FF:000293', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(201381, NULL, 'G3DSA:3.50.7.10:FF:000085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201382, NULL, 'G3DSA:3.40.50.300:FF:003473', NULL, NULL, 'Dynamin GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(201383, NULL, 'G3DSA:3.30.70.2760:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201384, NULL, 'G3DSA:3.30.465.10:FF:000029', NULL, NULL, 'FAD binding domain in molybdopterin dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(201385, NULL, 'G3DSA:1.20.920.20:FF:000005', NULL, NULL, 'Dynein cytoplasmic 1 heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(201386, NULL, 'G3DSA:1.10.150.170:FF:000007', NULL, NULL, 'S-adenosyl-methyltransferase Mraw', NULL, NULL, NULL, NULL, NULL, 4),
(201387, NULL, 'G3DSA:3.40.50.800:FF:000104', NULL, NULL, 'YALI0D15620p', NULL, NULL, NULL, NULL, NULL, 4),
(201388, NULL, 'G3DSA:3.40.50.10240:FF:000028', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(201389, NULL, 'G3DSA:1.10.8.10:FF:000023', NULL, NULL, 'Putative ubiquitin carboxyl-terminal hydrolase 25', NULL, NULL, NULL, NULL, NULL, 4),
(201390, NULL, 'G3DSA:3.40.50.1220:FF:000033', NULL, NULL, 'Electron transfer flavoprotein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(201391, NULL, 'G3DSA:1.10.10.60:FF:000994', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201392, NULL, 'G3DSA:1.10.600.10:FF:000014', NULL, NULL, 'Heptaprenyl diphosphate synthase component II', NULL, NULL, NULL, NULL, NULL, 4),
(201393, NULL, 'G3DSA:1.20.1250.20:FF:000172', NULL, NULL, 'MFS multidrug resistance transporter', NULL, NULL, NULL, NULL, NULL, 4),
(201394, NULL, 'G3DSA:3.30.450.20:FF:000560', NULL, NULL, 'Nitrogen-responsive two component signal transduction system histidine kinase with PAS sensory domain GlnL', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(201395, NULL, 'G3DSA:3.40.50.300:FF:001573', NULL, NULL, 'Carbon monoxide dehydrogenase accessory protein CooC', NULL, NULL, NULL, NULL, NULL, 4),
(201396, NULL, 'G3DSA:2.60.40.10:FF:004737', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201397, NULL, 'G3DSA:3.40.220.10:FF:000026', NULL, NULL, 'Probable ADP-ribose 1''''-phosphate phosphatase YML087W', NULL, NULL, NULL, NULL, NULL, 4),
(201398, NULL, 'G3DSA:2.60.40.10:FF:005243', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201399, NULL, 'G3DSA:2.60.40.10:FF:002837', NULL, NULL, 'Natural cytotoxicity triggering receptor 3 ligand 1', NULL, NULL, NULL, NULL, NULL, 4),
(201400, NULL, 'G3DSA:3.30.230.10:FF:000350', NULL, NULL, 'Type 2 DNA topoisomerase 6 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(201401, NULL, 'G3DSA:1.20.1250.20:FF:002072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201402, NULL, 'G3DSA:3.30.200.20:FF:000851', NULL, NULL, 'Protein CBG21256', NULL, NULL, NULL, NULL, NULL, 4),
(201403, NULL, 'G3DSA:3.40.1280.10:FF:000125', NULL, NULL, 'Protein CBR-EXOS-8', NULL, NULL, NULL, NULL, NULL, 4),
(201404, NULL, 'G3DSA:1.25.40.20:FF:001844', NULL, NULL, 'Ankyrin repeat and SAM domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(201405, NULL, 'G3DSA:1.25.40.10:FF:002943', NULL, NULL, 'Tetratricopeptide repeat protein 17-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(201406, NULL, 'G3DSA:1.25.40.170:FF:000002', NULL, NULL, 'Protein Smaug homolog 1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(201407, NULL, 'G3DSA:1.25.40.410:FF:000012', NULL, NULL, 'Dedicator of cytokinesis protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(201408, NULL, 'G3DSA:3.30.230.40:FF:000004', NULL, NULL, 'Imidazoleglycerol-phosphate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(201409, NULL, 'G3DSA:3.40.50.620:FF:000820', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201410, NULL, 'G3DSA:1.25.40.10:FF:004837', NULL, NULL, 'Os01g0263600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(201411, NULL, 'G3DSA:1.25.10.10:FF:000957', NULL, NULL, 'rap1 GTPase-GDP dissociation stimulator 1 isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(201412, NULL, 'G3DSA:3.30.70.1350:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201413, NULL, 'G3DSA:3.30.160.60:FF:003652', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201414, NULL, 'G3DSA:3.30.300.30:FF:000125', NULL, NULL, 'Acyl-CoA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(201415, NULL, 'G3DSA:1.25.10.10:FF:003363', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201416, NULL, 'G3DSA:1.10.10.10:FF:000889', NULL, NULL, 'Os05g0586600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(201417, NULL, 'G3DSA:3.30.750.200:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201418, NULL, 'G3DSA:3.30.160.60:FF:006199', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201419, NULL, 'G3DSA:3.40.50.1440:FF:000099', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(201420, NULL, 'G3DSA:2.20.70.10:FF:000177', NULL, NULL, 'PQBP1 (Polyglutamine tract-binding neurodegeneration protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(201421, NULL, 'G3DSA:3.40.50.720:FF:000732', NULL, NULL, 'Unplaced genomic scaffold supercont1.13, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(201422, NULL, 'G3DSA:1.25.40.10:FF:000459', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(201423, NULL, 'G3DSA:1.10.150.20:FF:000252', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(201424, NULL, 'G3DSA:3.30.710.10:FF:000038', NULL, NULL, 'BTB/POZ domain-containing protein KCTD3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(201425, NULL, 'G3DSA:1.25.40.180:FF:000005', NULL, NULL, 'Ccr4-not transcription complex subunit 1 isoform', NULL, NULL, NULL, NULL, NULL, 4),
(201426, NULL, 'G3DSA:1.10.1040.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201427, NULL, 'G3DSA:3.40.50.1370:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(201428, NULL, 'G3DSA:1.10.510.10:FF:002839', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201429, NULL, 'G3DSA:1.20.920.10:FF:000002', NULL, NULL, 'Bromodomain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(201430, NULL, 'G3DSA:3.40.30.10:FF:000053', NULL, NULL, 'Thiol:disulfide interchange protein', NULL, NULL, NULL, NULL, NULL, 4),
(201431, NULL, 'G3DSA:1.10.418.10:FF:000197', NULL, NULL, 'Protein Hook homolog 3', NULL, NULL, NULL, NULL, NULL, 4),
(201432, NULL, 'G3DSA:3.40.50.12780:FF:000228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201433, NULL, 'G3DSA:2.130.10.10:FF:000775', NULL, NULL, 'BnaA09g28200D protein', NULL, NULL, NULL, NULL, NULL, 4),
(201434, NULL, 'G3DSA:1.20.58.1380:FF:000007', NULL, NULL, 'Nucleoporin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(201435, NULL, 'G3DSA:2.130.10.30:FF:000101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201436, NULL, 'G3DSA:2.30.26.10:FF:000001', NULL, NULL, 'Dihydroorotate dehydrogenase (fumarate)', NULL, NULL, NULL, NULL, NULL, 4),
(201437, NULL, 'G3DSA:3.80.10.10:FF:001938', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(201438, NULL, 'G3DSA:1.10.630.10:FF:000280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201439, NULL, 'G3DSA:3.30.559.70:FF:000029', NULL, NULL, 'Choline O-acetyltransferase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(201440, NULL, 'G3DSA:1.25.40.570:FF:000032', NULL, NULL, 'GD12156', NULL, NULL, NULL, NULL, NULL, 4),
(201441, NULL, 'G3DSA:3.40.50.2000:FF:000952', NULL, NULL, 'Glycosyl transferase group 1', NULL, NULL, NULL, NULL, NULL, 4),
(201442, NULL, 'G3DSA:1.20.1250.20:FF:001936', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201443, NULL, 'G3DSA:3.40.630.30:FF:000041', NULL, NULL, 'Histone acetyltransferase MCC1 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(201444, NULL, 'G3DSA:3.30.413.10:FF:000033', NULL, NULL, '4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase (flavodoxin)', NULL, NULL, NULL, NULL, NULL, 4),
(201445, NULL, 'G3DSA:2.60.40.10:FF:001314', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', NULL, NULL, NULL, NULL, NULL, 4),
(201446, NULL, 'G3DSA:3.10.110.10:FF:000076', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 W', NULL, NULL, NULL, NULL, NULL, 4),
(201447, NULL, 'G3DSA:3.40.850.10:FF:000271', NULL, NULL, 'Chitin synthase-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(201448, NULL, 'G3DSA:3.20.20.190:FF:000009', NULL, NULL, 'Glycerophosphodiester phosphodiesterase, periplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(201449, NULL, 'G3DSA:3.90.640.10:FF:000103', NULL, NULL, 'Actin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(201450, NULL, 'G3DSA:2.130.10.10:FF:001281', NULL, NULL, 'DDB1- and CUL4-associated factor 11 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(201451, NULL, 'G3DSA:2.130.10.10:FF:003181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201452, NULL, 'G3DSA:1.20.58.60:FF:000805', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201453, NULL, 'G3DSA:3.40.1440.60:FF:000001', NULL, NULL, 'Primosomal protein N', NULL, NULL, NULL, NULL, NULL, 4),
(201454, NULL, 'G3DSA:3.90.1010.10:FF:000004', NULL, NULL, 'Cysteine desulfuration protein SufE', NULL, NULL, NULL, NULL, NULL, 4),
(201455, NULL, 'G3DSA:3.20.20.80:FF:000400', NULL, NULL, 'Glucan endo-1,3-beta-glucosidase 8', NULL, NULL, NULL, NULL, NULL, 4),
(201456, NULL, 'G3DSA:3.10.20.90:FF:000010', NULL, NULL, 'Autophagy-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(201457, NULL, 'G3DSA:1.25.40.420:FF:000015', NULL, NULL, 'Kelch-like family member 31', NULL, NULL, NULL, NULL, NULL, 4),
(201458, NULL, 'G3DSA:3.40.50.300:FF:006469', NULL, NULL, 'Os04g0680700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(201459, NULL, 'G3DSA:1.20.1410.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201460, NULL, 'G3DSA:3.50.50.60:FF:000642', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(201461, NULL, 'G3DSA:3.30.750.24:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201462, NULL, 'G3DSA:3.30.60.220:FF:000002', NULL, NULL, 'DEAD-box ATP-dependent RNA helicase 41', NULL, NULL, NULL, NULL, NULL, 4),
(201463, NULL, 'G3DSA:1.10.10.60:FF:001270', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201464, NULL, 'G3DSA:1.25.40.10:FF:000689', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(201465, NULL, 'G3DSA:3.80.10.10:FF:000062', NULL, NULL, 'protein STRUBBELIG-RECEPTOR FAMILY 3', NULL, NULL, NULL, NULL, NULL, 4),
(201466, NULL, 'G3DSA:1.10.10.10:FF:001171', NULL, NULL, 'ETS translocation variant 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(201467, NULL, 'G3DSA:2.30.29.30:FF:000126', NULL, NULL, '3-phosphoinositide dependent protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(201468, NULL, 'G3DSA:1.20.58.1370:FF:000004', NULL, NULL, 'Lysine (K)-specific demethylase 6A', NULL, NULL, NULL, NULL, NULL, 4),
(201469, NULL, 'G3DSA:2.10.25.10:FF:000180', NULL, NULL, 'Netrin G2', NULL, NULL, NULL, NULL, NULL, 4),
(201470, NULL, 'G3DSA:1.20.58.60:FF:000570', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(201471, NULL, 'G3DSA:2.170.300.10:FF:000034', NULL, NULL, 'Multiple epidermal growth factor-like domains protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(201472, NULL, 'G3DSA:1.25.40.430:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201473, NULL, 'G3DSA:1.20.120.1240:FF:000041', NULL, NULL, 'Dynamin-related protein 1D', NULL, NULL, NULL, NULL, NULL, 4),
(201474, NULL, 'G3DSA:1.25.40.10:FF:004388', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201475, NULL, 'G3DSA:3.30.70.60:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201476, NULL, 'G3DSA:1.25.40.20:FF:000788', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(201477, NULL, 'G3DSA:1.20.58.1360:FF:000001', NULL, NULL, 'Histone lysine demethylase PHF8', NULL, NULL, NULL, NULL, NULL, 4),
(201478, NULL, 'G3DSA:2.60.20.10:FF:000003', NULL, NULL, 'Crystallin gamma S', NULL, NULL, NULL, NULL, NULL, 4),
(201479, NULL, 'G3DSA:1.10.510.10:FF:001316', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(201480, NULL, 'G3DSA:3.30.559.10:FF:000247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201481, NULL, 'G3DSA:3.90.20.20:FF:000031', NULL, NULL, 'Protein GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(201482, NULL, 'G3DSA:1.10.238.10:FF:000778', NULL, NULL, 'CALUmenin (Calcium-binding protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(201483, NULL, 'G3DSA:3.40.718.10:FF:000008', NULL, NULL, 'Phosphate acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(201484, NULL, 'G3DSA:1.25.40.10:FF:000785', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(201485, NULL, 'G3DSA:2.40.330.10:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201486, NULL, 'G3DSA:3.30.470.20:FF:000117', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(201487, NULL, 'G3DSA:3.30.160.60:FF:003326', NULL, NULL, 'tRNA dimethylallyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(201488, NULL, 'G3DSA:3.30.1010.10:FF:000029', NULL, NULL, 'Serine/threonine-protein kinase SMG1', NULL, NULL, NULL, NULL, NULL, 4),
(201489, NULL, 'G3DSA:3.80.10.10:FF:002091', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(201490, NULL, 'G3DSA:3.30.160.20:FF:000133', NULL, NULL, '40S ribosomal protein S2', NULL, NULL, NULL, NULL, NULL, 4),
(201491, NULL, 'G3DSA:3.30.450.20:FF:000234', NULL, NULL, 'PAS domain S-box protein', NULL, NULL, NULL, NULL, NULL, 4),
(201492, NULL, 'G3DSA:3.90.1530.10:FF:000015', NULL, NULL, 'Sulfiredoxin chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(201493, NULL, 'G3DSA:1.10.510.10:FF:003087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201494, NULL, 'G3DSA:1.20.1250.20:FF:001110', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(201495, NULL, 'G3DSA:3.90.1150.10:FF:000391', NULL, NULL, 'Uncharacterized aminotransferase C27F1.05c', NULL, NULL, NULL, NULL, NULL, 4),
(201496, NULL, 'G3DSA:1.10.720.30:FF:000034', NULL, NULL, 'Altered inheritance of mitochondria protein 34, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(201497, NULL, 'G3DSA:2.60.200.10:FF:000036', NULL, NULL, 'Smad protein', NULL, NULL, NULL, NULL, NULL, 4),
(201498, NULL, 'G3DSA:2.10.25.10:FF:001489', NULL, NULL, 'Eater', NULL, NULL, NULL, NULL, NULL, 4),
(201499, NULL, 'G3DSA:1.10.510.10:FF:001193', NULL, NULL, 'Si:dkey-192d15.1', NULL, NULL, NULL, NULL, NULL, 4),
(201500, NULL, 'G3DSA:3.30.1370.10:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201501, NULL, 'G3DSA:3.30.40.10:FF:002336', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201502, NULL, 'G3DSA:4.10.60.10:FF:000088', NULL, NULL, 'Cleavage and polyadenylation specificity factor subunit 4-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(201503, NULL, 'G3DSA:3.40.50.720:FF:002323', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(201504, NULL, 'G3DSA:1.10.10.60:FF:000668', NULL, NULL, 'Adenosinetriphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(201505, NULL, 'G3DSA:1.20.58.60:FF:000244', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(201506, NULL, 'G3DSA:1.25.40.1040:FF:000035', NULL, NULL, 'mRNA 3''-end-processing protein RNA14', NULL, NULL, NULL, NULL, NULL, 4),
(201507, NULL, 'G3DSA:3.30.70.870:FF:000019', NULL, NULL, 'Translation elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(201508, NULL, 'G3DSA:2.60.40.60:FF:000688', NULL, NULL, 'Cadherin-4', NULL, NULL, NULL, NULL, NULL, 4),
(201509, NULL, 'G3DSA:1.20.1250.20:FF:000834', NULL, NULL, 'EmrB/QacA family drug resistance transporter', NULL, NULL, NULL, NULL, NULL, 4),
(201510, NULL, 'G3DSA:1.10.238.10:FF:001037', NULL, NULL, 'Calmodulin 5', NULL, NULL, NULL, NULL, NULL, 4),
(201511, NULL, 'G3DSA:3.40.190.10:FF:000484', NULL, NULL, 'Sensory box sensor histidine kinase/response regulator VieS', NULL, NULL, NULL, NULL, NULL, 4),
(201512, NULL, 'G3DSA:3.40.50.12620:FF:000001', NULL, NULL, 'Glucokinase regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(201513, NULL, 'G3DSA:3.10.129.10:FF:000085', NULL, NULL, 'Acyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(201514, NULL, 'G3DSA:2.30.29.30:FF:000356', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(201515, NULL, 'G3DSA:3.40.50.300:FF:001135', NULL, NULL, 'ABC transporter F family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(201516, NULL, 'G3DSA:3.30.200.20:FF:002554', NULL, NULL, 'Protein kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(201517, NULL, 'G3DSA:3.30.200.20:FF:001014', NULL, NULL, 'Serine/threonine-protein kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(201518, NULL, 'G3DSA:2.60.40.420:FF:000252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201519, NULL, 'G3DSA:2.40.10.240:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201520, NULL, 'G3DSA:3.30.420.40:FF:001020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(201521, NULL, 'G3DSA:2.30.42.10:FF:000437', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201522, NULL, 'G3DSA:1.20.58.1610:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201523, NULL, 'G3DSA:1.10.150.120:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201524, NULL, 'G3DSA:1.10.3380.10:FF:000023', NULL, NULL, 'Putative DEAD/DEAH box helicase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(201525, NULL, 'G3DSA:3.40.50.300:FF:005058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201526, NULL, 'G3DSA:3.40.50.2300:FF:000609', NULL, NULL, 'Sensory box sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(201527, NULL, 'G3DSA:3.30.200.160:FF:000011', NULL, NULL, 'RNA polymerase III transcription factor subunit, putative (AFU_orthologue AFUA_5G02550)', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(201528, NULL, 'G3DSA:1.20.58.760:FF:000019', NULL, NULL, 'ATP-dependent zinc metalloprotease', NULL, NULL, NULL, NULL, NULL, 4),
(201529, NULL, 'G3DSA:1.10.640.10:FF:000005', NULL, NULL, 'Fatty acid oxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(201530, NULL, 'G3DSA:1.20.1070.10:FF:000519', NULL, NULL, 'CNMamide receptor', NULL, NULL, NULL, NULL, NULL, 4),
(201531, NULL, 'G3DSA:1.20.1560.10:FF:000506', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201532, NULL, 'G3DSA:3.90.1750.20:FF:000012', NULL, NULL, 'Site-specific recombinase / invertase', NULL, NULL, NULL, NULL, NULL, 4),
(201533, NULL, 'G3DSA:3.30.70.850:FF:000013', NULL, NULL, 'Neuroendocrine convertase 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(201534, NULL, 'G3DSA:3.30.160.60:FF:001191', NULL, NULL, 'POZ-, AT hook-, and zinc finger-containing protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(201535, NULL, 'G3DSA:2.130.10.10:FF:005007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201536, NULL, 'G3DSA:1.10.1370.10:FF:000051', NULL, NULL, 'Im:6903007 protein', NULL, NULL, NULL, NULL, NULL, 4),
(201537, NULL, 'G3DSA:3.40.140.100:FF:000021', NULL, NULL, 'Autophagy related 7', NULL, NULL, NULL, NULL, NULL, 4),
(201538, NULL, 'G3DSA:2.120.10.30:FF:000079', NULL, NULL, 'S9 family peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(201539, NULL, 'G3DSA:3.60.10.10:FF:000130', NULL, NULL, 'DNA-(apurinic or apyrimidinic site) lyase', NULL, NULL, NULL, NULL, NULL, 4),
(201540, NULL, 'G3DSA:3.90.190.10:FF:000124', NULL, NULL, 'Paladin', NULL, NULL, NULL, NULL, NULL, 4),
(201541, NULL, 'G3DSA:1.25.10.10:FF:001137', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(201542, NULL, 'G3DSA:1.20.1090.10:FF:000066', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(201543, NULL, 'G3DSA:2.60.40.60:FF:000784', NULL, NULL, 'Cadherin 15', NULL, NULL, NULL, NULL, NULL, 4),
(201544, NULL, 'G3DSA:2.40.50.140:FF:000399', NULL, NULL, 'Ribonuclease E', NULL, NULL, NULL, NULL, NULL, 4),
(201545, NULL, 'G3DSA:1.10.8.500:FF:000006', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(201546, NULL, 'G3DSA:1.20.900.10:FF:000102', NULL, NULL, 'MKIAA0380 protein', NULL, NULL, NULL, NULL, NULL, 4),
(201547, NULL, 'G3DSA:3.40.50.11210:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201548, NULL, 'G3DSA:3.40.50.300:FF:000033', NULL, NULL, '26S protease regulatory subunit 6B', NULL, NULL, NULL, NULL, NULL, 4),
(201549, NULL, 'G3DSA:3.40.50.300:FF:007525', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201550, NULL, 'G3DSA:1.10.3380.30:FF:000029', NULL, NULL, 'ATP-dependent DNA helicase Hel308', NULL, NULL, NULL, NULL, NULL, 4),
(201551, NULL, 'G3DSA:1.20.1070.10:FF:002083', NULL, NULL, 'Calcitonin gene-related peptide type 1 receptor-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(201552, NULL, 'G3DSA:3.40.50.720:FF:000069', NULL, NULL, 'Inositol-3-phosphate synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(201553, NULL, 'G3DSA:2.60.120.10:FF:000310', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(201554, NULL, 'G3DSA:3.40.50.880:FF:000089', NULL, NULL, 'Catalase', NULL, NULL, NULL, NULL, NULL, 4),
(201555, NULL, 'G3DSA:3.40.50.300:FF:005160', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(201556, NULL, 'G3DSA:3.30.70.660:FF:000046', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(201557, NULL, 'G3DSA:3.30.30.30:FF:000020', NULL, NULL, 'Ssz1p', NULL, NULL, NULL, NULL, NULL, 4),
(201558, NULL, 'G3DSA:2.130.10.10:FF:004827', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(201559, NULL, 'G3DSA:2.60.40.10:FF:001191', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(201560, NULL, 'G3DSA:1.25.10.10:FF:002548', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201561, NULL, 'G3DSA:1.10.287.130:FF:000017', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(201562, NULL, 'G3DSA:1.20.1070.10:FF:000312', NULL, NULL, 'protein trapped in endoderm-1', NULL, NULL, NULL, NULL, NULL, 4),
(201563, NULL, 'G3DSA:1.20.5.110:FF:000151', NULL, NULL, 'Ehsyntaxin B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(201564, NULL, 'G3DSA:3.40.50.300:FF:008498', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201565, NULL, 'G3DSA:3.40.50.1820:FF:000229', NULL, NULL, 'Lactonizing lipase', NULL, NULL, NULL, NULL, NULL, 4),
(201566, NULL, 'G3DSA:3.40.50.450:FF:000050', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(201567, NULL, 'G3DSA:3.30.420.40:FF:000738', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201568, NULL, 'G3DSA:3.30.565.10:FF:000099', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(201569, NULL, 'G3DSA:1.20.58.90:FF:000011', NULL, NULL, 'Tubulin-specific chaperone A', NULL, NULL, NULL, NULL, NULL, 4),
(201570, NULL, 'G3DSA:3.40.50.300:FF:007312', NULL, NULL, 'GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(201571, NULL, 'G3DSA:3.30.450.380:FF:000003', NULL, NULL, 'Pilus assembly protein CpaF', NULL, NULL, NULL, NULL, NULL, 4),
(201572, NULL, 'G3DSA:1.25.10.10:FF:003037', NULL, NULL, 'Plakophilin 1', NULL, NULL, NULL, NULL, NULL, 4),
(201573, NULL, 'G3DSA:1.20.120.80:FF:000018', NULL, NULL, 'Cytochrome c oxidase, coo3-type, subunit III', NULL, NULL, NULL, NULL, NULL, 4),
(201574, NULL, 'G3DSA:3.40.366.10:FF:000016', NULL, NULL, 'Fatty acid synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(201575, NULL, 'G3DSA:2.60.40.10:FF:003652', NULL, NULL, 'Protein CBR-UNC-40', NULL, NULL, NULL, NULL, NULL, 4),
(201576, NULL, 'G3DSA:3.90.220.20:FF:000001', NULL, NULL, 'Type I restriction-modification system restriction endonuclease DNA specificity subunit HsdS', NULL, NULL, NULL, NULL, NULL, 4),
(201577, NULL, 'G3DSA:3.40.50.2000:FF:000076', NULL, NULL, 'GDP-Man:Man(3)GlcNAc(2)-PP-Dol alpha-1,2-mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(201578, NULL, 'G3DSA:2.60.120.650:FF:000072', NULL, NULL, 'Lysine-specific demethylase 3', NULL, NULL, NULL, NULL, NULL, 4),
(201579, NULL, 'G3DSA:2.170.16.10:FF:000033', NULL, NULL, 'XK-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(201580, NULL, 'G3DSA:2.60.40.10:FF:002949', NULL, NULL, 'Hyaluronan proteoglycan link protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(201581, NULL, 'G3DSA:3.40.50.10130:FF:000001', NULL, NULL, 'DNA excision repair protein ERCC-1', NULL, NULL, NULL, NULL, NULL, 4),
(201582, NULL, 'G3DSA:1.20.1250.20:FF:000284', NULL, NULL, 'Siderophore iron transporter mirB', NULL, NULL, NULL, NULL, NULL, 4),
(201583, NULL, 'G3DSA:2.60.40.150:FF:000828', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201584, NULL, 'G3DSA:3.40.50.1820:FF:000117', NULL, NULL, 'Monoglyceride lipase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(201585, NULL, 'G3DSA:1.25.40.820:FF:000028', NULL, NULL, 'RNA polymerase II subunit B1 CTD phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(201586, NULL, 'G3DSA:3.40.50.10140:FF:000004', NULL, NULL, 'X-linked interleukin-1 receptor accessory protein-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(201587, NULL, 'G3DSA:3.40.50.1170:FF:000006', NULL, NULL, 'Asparaginase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(201588, NULL, 'G3DSA:1.20.1560.10:FF:000153', NULL, NULL, 'multidrug resistance protein homolog 65', NULL, NULL, NULL, NULL, NULL, 4),
(201589, NULL, 'G3DSA:1.10.630.10:FF:000403', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(201590, NULL, 'G3DSA:3.90.1800.10:FF:000019', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(201591, NULL, 'G3DSA:2.60.40.10:FF:005125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201592, NULL, 'G3DSA:3.30.300.30:FF:000013', NULL, NULL, 'Long-chain fatty acid--CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(201593, NULL, 'G3DSA:1.25.40.10:FF:000577', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(201594, NULL, 'G3DSA:3.40.50.200:FF:000020', NULL, NULL, 'Minor extracellular protease', NULL, NULL, NULL, NULL, NULL, 4),
(201595, NULL, 'G3DSA:3.40.50.300:FF:003361', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(201596, NULL, 'G3DSA:1.10.287.130:FF:000135', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(201597, NULL, 'G3DSA:1.20.5.170:FF:000045', NULL, NULL, 'nuclear pore glycoprotein p62', NULL, NULL, NULL, NULL, NULL, 4),
(201598, NULL, 'G3DSA:2.130.10.10:FF:005092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201599, NULL, 'G3DSA:1.10.10.60:FF:000876', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201600, NULL, 'G3DSA:3.30.420.580:FF:000012', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(201601, NULL, 'G3DSA:2.60.120.290:FF:000042', NULL, NULL, 'AGAP005526-PA', NULL, NULL, NULL, NULL, NULL, 4),
(201602, NULL, 'G3DSA:3.40.50.960:FF:000012', NULL, NULL, '6,7-dimethyl-8-ribityllumazine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(201603, NULL, 'G3DSA:2.60.120.260:FF:000623', NULL, NULL, 'Exo-beta-D-glucosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(201604, NULL, 'G3DSA:3.30.70.2850:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201605, NULL, 'G3DSA:3.30.1360.40:FF:000007', NULL, NULL, 'ribosome-recycling factor, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(201606, NULL, 'G3DSA:2.30.29.30:FF:000570', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(201607, NULL, 'G3DSA:3.90.190.10:FF:000551', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201608, NULL, 'G3DSA:3.30.300.20:FF:000010', NULL, NULL, 'OsmC family peroxiredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(201609, NULL, 'G3DSA:3.30.200.20:FF:000963', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 13', NULL, NULL, NULL, NULL, NULL, 4),
(201610, NULL, 'G3DSA:1.10.12.10:FF:000051', NULL, NULL, 'Methylthioacryloyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(201611, NULL, 'G3DSA:1.25.40.120:FF:000015', NULL, NULL, 'Protein prenyltransferase alpha subunit repeat-containing protein 1-B isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(201612, NULL, 'G3DSA:3.90.70.80:FF:000057', NULL, NULL, 'OTU-like cysteine protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(201613, NULL, 'G3DSA:3.30.70.330:FF:002235', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201614, NULL, 'G3DSA:3.40.50.360:FF:000135', NULL, NULL, 'Tryptophan repressor binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(201615, NULL, 'G3DSA:3.30.160.60:FF:003540', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201616, NULL, 'G3DSA:2.60.40.10:FF:001426', NULL, NULL, 'Intercellular adhesion molecule 4', NULL, NULL, NULL, NULL, NULL, 4),
(201617, NULL, 'G3DSA:1.25.40.10:FF:004949', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(201618, NULL, 'G3DSA:3.30.40.10:FF:000650', NULL, NULL, 'Homeobox protein HAT3.1', NULL, NULL, NULL, NULL, NULL, 4),
(201619, NULL, 'G3DSA:3.90.1150.10:FF:000278', NULL, NULL, 'Aminotransferase PigE', NULL, NULL, NULL, NULL, NULL, 4),
(201620, NULL, 'G3DSA:3.40.50.11900:FF:000004', NULL, NULL, 'R-phenyllactate dehydratase medium subunit', NULL, NULL, NULL, NULL, NULL, 4),
(201621, NULL, 'G3DSA:3.40.190.10:FF:000580', NULL, NULL, 'Oligopeptide transport system binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(201622, NULL, 'G3DSA:1.25.40.10:FF:002831', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201623, NULL, 'G3DSA:3.40.50.150:FF:001831', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201624, NULL, 'G3DSA:2.20.70.10:FF:000289', NULL, NULL, 'Pre-mRNA-processing protein 40A', NULL, NULL, NULL, NULL, NULL, 4),
(201625, NULL, 'G3DSA:3.20.20.80:FF:000271', NULL, NULL, 'Alkali-sensitive linkage protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(201626, NULL, 'G3DSA:1.25.10.10:FF:001800', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(201627, NULL, 'G3DSA:3.30.710.10:FF:000504', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201628, NULL, 'G3DSA:1.25.10.10:FF:002099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201629, NULL, 'G3DSA:3.30.50.10:FF:000038', NULL, NULL, 'GATA transcription factor 14', NULL, NULL, NULL, NULL, NULL, 4),
(201630, NULL, 'G3DSA:2.60.120.200:FF:000167', NULL, NULL, 'Laminin subunit alpha-3', NULL, NULL, NULL, NULL, NULL, 4),
(201631, NULL, 'G3DSA:3.40.50.2300:FF:000722', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(201632, NULL, 'G3DSA:3.30.420.40:FF:000497', NULL, NULL, 'Hydantoinase/oxoprolinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(201633, NULL, 'G3DSA:3.40.50.720:FF:002295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201634, NULL, 'G3DSA:1.20.1050.10:FF:000075', NULL, NULL, 'Methionyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(201635, NULL, 'G3DSA:2.30.42.10:FF:000224', NULL, NULL, 'Arc, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(201636, NULL, 'G3DSA:1.20.1540.10:FF:000045', NULL, NULL, 'Putative membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(201637, NULL, 'G3DSA:3.40.50.2000:FF:000626', NULL, NULL, 'Sucrose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(201638, NULL, 'G3DSA:3.40.50.150:FF:000887', NULL, NULL, 'Non-ribosomal peptide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(201639, NULL, 'G3DSA:2.130.10.10:FF:001505', NULL, NULL, 'Striatin', NULL, NULL, NULL, NULL, NULL, 4),
(201640, NULL, 'G3DSA:3.40.50.150:FF:001505', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201641, NULL, 'G3DSA:1.10.260.40:FF:000024', NULL, NULL, 'Transcriptional regulator SinR', NULL, NULL, NULL, NULL, NULL, 4),
(201642, NULL, 'G3DSA:1.10.630.10:FF:000504', NULL, NULL, 'Cytochrome P450 family 87 subfamily A polypeptide 6', NULL, NULL, NULL, NULL, NULL, 4),
(201643, NULL, 'G3DSA:2.60.40.150:FF:000727', NULL, NULL, 'C2 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(201644, NULL, 'G3DSA:3.40.50.720:FF:000850', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(201645, NULL, 'G3DSA:1.25.40.10:FF:000690', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(201646, NULL, 'G3DSA:3.30.200.20:FF:002088', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(201647, NULL, 'G3DSA:2.130.10.10:FF:000679', NULL, NULL, 'Elongator acetyltransferase complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(201648, NULL, 'G3DSA:2.40.160.10:FF:000076', NULL, NULL, 'Putative mitochondrial outer membrane protein porin 5', NULL, NULL, NULL, NULL, NULL, 4),
(201649, NULL, 'G3DSA:2.10.109.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201650, NULL, 'G3DSA:3.20.20.80:FF:000372', NULL, NULL, '1,3-beta-glucanosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(201651, NULL, 'G3DSA:3.40.50.300:FF:006587', NULL, NULL, 'P-loop nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(201652, NULL, 'G3DSA:2.40.30.170:FF:000073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201653, NULL, 'G3DSA:1.10.10.10:FF:001053', NULL, NULL, 'GM24041', NULL, NULL, NULL, NULL, NULL, 4),
(201654, NULL, 'G3DSA:3.30.420.140:FF:000021', NULL, NULL, 'Transcription elongation factor spt6, putative', NULL, NULL, NULL, NULL, NULL, 4),
(201655, NULL, 'G3DSA:3.40.50.620:FF:000691', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201656, NULL, 'G3DSA:3.30.160.60:FF:003113', NULL, NULL, 'GD17411', NULL, NULL, NULL, NULL, NULL, 4),
(201657, NULL, 'G3DSA:3.40.720.10:FF:000036', NULL, NULL, 'Membrane-associated phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(201658, NULL, 'G3DSA:3.40.50.300:FF:005390', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201659, NULL, 'G3DSA:1.10.460.10:FF:000025', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(201660, NULL, 'G3DSA:3.40.50.620:FF:000702', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201661, NULL, 'G3DSA:1.20.1420.30:FF:000093', NULL, NULL, 'Ca2+/Na+ antiporter', NULL, NULL, NULL, NULL, NULL, 4),
(201662, NULL, 'G3DSA:3.60.40.10:FF:000171', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(201663, NULL, 'G3DSA:3.60.110.10:FF:000042', NULL, NULL, 'Carbon-nitrogen hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(201664, NULL, 'G3DSA:3.40.50.720:FF:000171', NULL, NULL, 'inositol-3-phosphate synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(201665, NULL, 'G3DSA:2.130.10.10:FF:002933', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(201666, NULL, 'G3DSA:2.60.120.590:FF:000019', NULL, NULL, 'DNA N6-methyl adenine demethylase', NULL, NULL, NULL, NULL, NULL, 4),
(201667, NULL, 'G3DSA:1.20.1070.10:FF:000520', NULL, NULL, '5-hydroxytryptamine (Serotonin) receptor 2B, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(201668, NULL, 'G3DSA:3.80.10.10:FF:000275', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(201669, NULL, 'G3DSA:3.40.50.2300:FF:000497', NULL, NULL, 'Transcriptional regulator LacI family', NULL, NULL, NULL, NULL, NULL, 4),
(201670, NULL, 'G3DSA:3.40.50.670:FF:000026', NULL, NULL, 'DNA gyrase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(201671, NULL, 'G3DSA:3.90.190.10:FF:000219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201672, NULL, 'G3DSA:3.30.930.10:FF:000032', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(201673, NULL, 'G3DSA:3.10.310.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201674, NULL, 'G3DSA:3.90.190.10:FF:000450', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201675, NULL, 'G3DSA:3.30.160.60:FF:001185', NULL, NULL, 'myoneurin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(201676, NULL, 'G3DSA:2.20.110.10:FF:000004', NULL, NULL, 'Histone-lysine N-methyltransferase SETD7', NULL, NULL, NULL, NULL, NULL, 4),
(201677, NULL, 'G3DSA:3.30.70.270:FF:000266', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201678, NULL, 'G3DSA:3.40.190.80:FF:000010', NULL, NULL, 'Histidinol phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(201679, NULL, 'G3DSA:1.20.1280.290:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201680, NULL, 'G3DSA:3.90.640.10:FF:000075', NULL, NULL, 'Heat shock 70 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(201681, NULL, 'G3DSA:2.60.120.200:FF:000072', NULL, NULL, 'basement membrane-specific heparan sulfate proteoglycan core protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(201682, NULL, 'G3DSA:2.60.120.920:FF:000040', NULL, NULL, 'Ret finger protein-like 4A', NULL, NULL, NULL, NULL, NULL, 4),
(201683, NULL, 'G3DSA:1.20.1740.10:FF:000026', NULL, NULL, 'Amino-acid permease BAT1', NULL, NULL, NULL, NULL, NULL, 4),
(201684, NULL, 'G3DSA:3.30.160.60:FF:003208', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201685, NULL, 'G3DSA:3.10.360.10:FF:000004', NULL, NULL, 'OvoDB1', NULL, NULL, NULL, NULL, NULL, 4),
(201686, NULL, 'G3DSA:1.25.40.20:FF:001518', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201687, NULL, 'G3DSA:1.10.510.10:FF:001081', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(201688, NULL, 'G3DSA:3.30.1370.170:FF:000004', NULL, NULL, 'Erythronate-4-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(201689, NULL, 'G3DSA:1.25.40.10:FF:001403', NULL, NULL, 'Mitochondrial ribonuclease P protein 3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(201690, NULL, 'G3DSA:3.40.50.2000:FF:000525', NULL, NULL, 'Trehalose-6-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(201691, NULL, 'G3DSA:3.30.230.10:FF:000136', NULL, NULL, 'GD14641', NULL, NULL, NULL, NULL, NULL, 4),
(201692, NULL, 'G3DSA:3.30.519.10:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(201693, NULL, 'G3DSA:1.25.40.20:FF:001294', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201694, NULL, 'G3DSA:3.30.200.20:FF:000749', NULL, NULL, 'Putative L-type lectin-domain containing receptor kinase S.5', NULL, NULL, NULL, NULL, NULL, 4),
(201695, NULL, 'G3DSA:1.25.40.10:FF:000897', NULL, NULL, 'Pentatricopeptide repeat-containing protein PNM1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(201696, NULL, 'G3DSA:2.60.40.10:FF:004299', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201697, NULL, 'G3DSA:3.10.129.10:FF:000197', NULL, NULL, 'Probable 4-hydroxybenzoyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(201698, NULL, 'G3DSA:2.40.240.20:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201699, NULL, 'G3DSA:3.30.40.10:FF:000442', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(201700, NULL, 'G3DSA:3.50.50.60:FF:000187', NULL, NULL, 'Thioredoxin reductase GliT', NULL, NULL, NULL, NULL, NULL, 4),
(201701, NULL, 'G3DSA:1.25.40.10:FF:001515', NULL, NULL, 'Clustered mitochondria protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(201702, NULL, 'G3DSA:1.20.1720.10:FF:000031', NULL, NULL, 'Drug resistance transporter, EmrB/QacA subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(201703, NULL, 'G3DSA:3.30.70.260:FF:000145', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(201704, NULL, 'G3DSA:1.20.1070.10:FF:000284', NULL, NULL, 'C3a anaphylatoxin chemotactic receptor', NULL, NULL, NULL, NULL, NULL, 4),
(201705, NULL, 'G3DSA:2.40.50.140:FF:000854', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201706, NULL, 'G3DSA:2.40.10.10:FF:000588', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201707, NULL, 'G3DSA:1.10.1200.10:FF:000050', NULL, NULL, 'Vibriobactin-specific isochorismatase', NULL, NULL, NULL, NULL, NULL, 4),
(201708, NULL, 'G3DSA:2.40.30.20:FF:000002', NULL, NULL, 'V-type proton ATPase catalytic subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(201709, NULL, 'G3DSA:3.30.70.270:FF:000148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201710, NULL, 'G3DSA:1.10.150.20:FF:000038', NULL, NULL, 'DNA repair endonuclease UVH1', NULL, NULL, NULL, NULL, NULL, 4),
(201711, NULL, 'G3DSA:3.10.196.10:FF:000009', NULL, NULL, 'Methionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(201712, NULL, 'G3DSA:2.40.30.30:FF:000005', NULL, NULL, 'Haloacid dehalogenase-like hydrolase domain-containing protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(201713, NULL, 'G3DSA:3.40.50.720:FF:000518', NULL, NULL, 'hydroxysteroid dehydrogenase-like protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(201714, NULL, 'G3DSA:2.40.10.10:FF:000476', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201715, NULL, 'G3DSA:3.100.10.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201716, NULL, 'G3DSA:3.30.1370.160:FF:000001', NULL, NULL, 'At1g53120', NULL, NULL, NULL, NULL, NULL, 4),
(201717, NULL, 'G3DSA:1.20.5.170:FF:000253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201718, NULL, 'G3DSA:2.10.25.10:FF:000741', NULL, NULL, 'Low density lipoprotein receptor-related protein 1Bb', NULL, NULL, NULL, NULL, NULL, 4),
(201719, NULL, 'G3DSA:3.30.70.330:FF:003050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201720, NULL, 'G3DSA:1.20.120.420:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201721, NULL, 'G3DSA:3.40.50.20:FF:000052', NULL, NULL, 'Alpha-L-glutamate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(201722, NULL, 'G3DSA:1.10.10.60:FF:000556', NULL, NULL, 'SIX homeobox 9', NULL, NULL, NULL, NULL, NULL, 4),
(201723, NULL, 'G3DSA:1.10.287.70:FF:000600', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201724, NULL, 'G3DSA:1.20.120.1240:FF:000035', NULL, NULL, 'Dynamin GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(201725, NULL, 'G3DSA:2.130.10.10:FF:004378', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201726, NULL, 'G3DSA:3.30.300.160:FF:000011', NULL, NULL, 'Type IV-A pilus assembly ATPase PilB', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(201727, NULL, 'G3DSA:2.130.10.10:FF:004277', NULL, NULL, 'AGAP010685-PA', NULL, NULL, NULL, NULL, NULL, 4),
(201728, NULL, 'G3DSA:3.30.2230.10:FF:000023', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(201729, NULL, 'G3DSA:3.40.390.10:FF:000027', NULL, NULL, 'Matrix metallopeptidase 19', NULL, NULL, NULL, NULL, NULL, 4),
(201730, NULL, 'G3DSA:3.20.20.70:FF:000037', NULL, NULL, 'Tryptophan synthase alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(201731, NULL, 'G3DSA:3.40.1110.10:FF:000012', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(201732, NULL, 'G3DSA:3.80.10.10:FF:000180', NULL, NULL, 'Oligodendrocyte myelin glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(201733, NULL, 'G3DSA:3.80.10.10:FF:004327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201734, NULL, 'G3DSA:1.10.150.50:FF:000120', NULL, NULL, 'Adenylate cyclase, class 3', NULL, NULL, NULL, NULL, NULL, 4),
(201735, NULL, 'G3DSA:1.25.40.20:FF:001406', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201736, NULL, 'G3DSA:1.25.10.10:FF:000749', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(201737, NULL, 'G3DSA:3.30.160.60:FF:003197', NULL, NULL, 'zinc finger protein 248 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(201738, NULL, 'G3DSA:3.30.160.20:FF:000127', NULL, NULL, 'Putative trna-specific adenosine deaminase 1', NULL, NULL, NULL, NULL, NULL, 4),
(201739, NULL, 'G3DSA:1.25.40.10:FF:002488', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g21300', NULL, NULL, NULL, NULL, NULL, 4),
(201740, NULL, 'G3DSA:2.30.250.10:FF:000006', NULL, NULL, 'Probable M18 family aminopeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(201741, NULL, 'G3DSA:3.40.50.300:FF:003029', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(201742, NULL, 'G3DSA:3.30.70.330:FF:002662', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201743, NULL, 'G3DSA:3.30.559.10:FF:000152', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(201744, NULL, 'G3DSA:3.40.50.150:FF:001051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201745, NULL, 'G3DSA:3.10.450.50:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201746, NULL, 'G3DSA:3.30.40.10:FF:000537', NULL, NULL, 'RING finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(201747, NULL, 'G3DSA:2.40.50.140:FF:000427', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(201748, NULL, 'G3DSA:2.130.10.10:FF:000567', NULL, NULL, 'POC1 centriolar protein homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(201749, NULL, 'G3DSA:3.30.1490.190:FF:000008', NULL, NULL, 'Ferric uptake regulator, Fur family', NULL, NULL, NULL, NULL, NULL, 4),
(201750, NULL, 'G3DSA:3.40.50.2000:FF:001020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201751, NULL, 'G3DSA:1.20.1250.20:FF:000385', NULL, NULL, 'Major facilitator superfamily domain-containing protein 4A', NULL, NULL, NULL, NULL, NULL, 4),
(201752, NULL, 'G3DSA:1.20.80.10:FF:000073', NULL, NULL, 'FERM domain-containing 4Ba', NULL, NULL, NULL, NULL, NULL, 4),
(201753, NULL, 'G3DSA:3.40.850.10:FF:000383', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201754, NULL, 'G3DSA:1.10.340.30:FF:000067', NULL, NULL, '8-oxoguanine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(201755, NULL, 'G3DSA:3.40.710.10:FF:000002', NULL, NULL, 'glutaminase kidney isoform, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(201756, NULL, 'G3DSA:4.10.520.10:FF:000007', NULL, NULL, 'Integration host factor subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(201757, NULL, 'G3DSA:1.10.510.10:FF:001642', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(201758, NULL, 'G3DSA:3.30.160.60:FF:005237', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201759, NULL, 'G3DSA:3.30.1050.10:FF:000026', NULL, NULL, 'UNC-24', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(201760, NULL, 'G3DSA:3.10.129.10:FF:000208', NULL, NULL, '4-hydroxybenzoyl-CoA thioesterase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(201761, NULL, 'G3DSA:3.10.100.10:FF:000356', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201762, NULL, 'G3DSA:2.30.42.10:FF:000336', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201763, NULL, 'G3DSA:3.40.33.10:FF:000200', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(201764, NULL, 'G3DSA:2.30.30.140:FF:000015', NULL, NULL, 'MBT domain-containing protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(201765, NULL, 'G3DSA:3.30.260.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201766, NULL, 'G3DSA:3.40.50.300:FF:006795', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(201767, NULL, 'G3DSA:3.60.130.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201768, NULL, 'G3DSA:3.10.110.10:FF:000284', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(201769, NULL, 'G3DSA:3.30.1490.180:FF:000005', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(201770, NULL, 'G3DSA:1.25.10.10:FF:002992', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201771, NULL, 'G3DSA:2.60.40.10:FF:003214', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201772, NULL, 'G3DSA:3.40.50.11610:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201773, NULL, 'G3DSA:3.30.1340.30:FF:000003', NULL, NULL, 'Putative secreted lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(201774, NULL, 'G3DSA:3.20.190.10:FF:000005', NULL, NULL, 'Nei like DNA glycosylase 3', NULL, NULL, NULL, NULL, NULL, 4),
(201775, NULL, 'G3DSA:2.60.120.200:FF:000280', NULL, NULL, 'L-type lectin-domain containing receptor kinase IX.1', NULL, NULL, NULL, NULL, NULL, 4),
(201776, NULL, 'G3DSA:3.30.70.330:FF:000874', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(201777, NULL, 'G3DSA:3.40.50.360:FF:000040', NULL, NULL, 'NADPH-dependent FMN reductase', NULL, NULL, NULL, NULL, NULL, 4),
(201778, NULL, 'G3DSA:3.40.630.10:FF:000389', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201779, NULL, 'G3DSA:3.40.50.970:FF:000099', NULL, NULL, 'Probable acetohydroxyacid synthase ilvX', NULL, NULL, NULL, NULL, NULL, 4),
(201780, NULL, 'G3DSA:2.30.38.10:FF:000006', NULL, NULL, 'Long-chain-fatty-acid--[acyl-carrier-protein] ligase AEE15, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(201781, NULL, 'G3DSA:2.40.200.10:FF:000001', NULL, NULL, 'Telomere-binding protein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(201782, NULL, 'G3DSA:3.60.10.10:FF:000017', NULL, NULL, 'Type I inositol polyphosphate 5-phosphatase 5', NULL, NULL, NULL, NULL, NULL, 4),
(201783, NULL, 'G3DSA:1.25.40.10:FF:004742', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201784, NULL, 'G3DSA:3.50.30.30:FF:000070', NULL, NULL, 'Subtilisin-like protease SBT3.18', NULL, NULL, NULL, NULL, NULL, 4),
(201785, NULL, 'G3DSA:3.80.10.10:FF:004232', NULL, NULL, 'Relaxin family peptide receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(201786, NULL, 'G3DSA:1.25.40.10:FF:004276', NULL, NULL, 'Os06g0625800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(201787, NULL, 'G3DSA:1.20.1560.10:FF:000271', NULL, NULL, 'HAlF transporter (PGP related)', NULL, NULL, NULL, NULL, NULL, 4),
(201788, NULL, 'G3DSA:3.40.50.12370:FF:000004', NULL, NULL, 'Os11g0109400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(201789, NULL, 'G3DSA:3.20.20.150:FF:000032', NULL, NULL, 'Xylose isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(201790, NULL, 'G3DSA:3.30.160.60:FF:005451', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201791, NULL, 'G3DSA:3.40.50.12780:FF:000133', NULL, NULL, 'D-alanine--poly(Phosphoribitol) ligase', NULL, NULL, NULL, NULL, NULL, 4),
(201792, NULL, 'G3DSA:1.25.40.10:FF:000908', NULL, NULL, 'YER077C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(201793, NULL, 'G3DSA:4.10.91.10:FF:000002', NULL, NULL, 'Cytochrome c oxidase subunit 7A1, mitochondrial-like Protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(201794, NULL, 'G3DSA:1.20.1260.10:FF:000012', NULL, NULL, '1,2-phenylacetyl-CoA epoxidase, subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(201795, NULL, 'G3DSA:2.130.10.10:FF:001404', NULL, NULL, 'Binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(201796, NULL, 'G3DSA:3.40.50.720:FF:002531', NULL, NULL, 'Ubiquitin-activating enzyme E1 domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(201797, NULL, 'G3DSA:3.80.10.10:FF:000741', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(201798, NULL, 'G3DSA:3.30.40.10:FF:002128', NULL, NULL, 'General transcription factor IIH subunit', NULL, NULL, NULL, NULL, NULL, 4),
(201799, NULL, 'G3DSA:3.60.10.10:FF:000225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201800, NULL, 'G3DSA:3.30.460.10:FF:000046', NULL, NULL, 'PAP/OAS1 substrate-binding domain superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(201801, NULL, 'G3DSA:2.40.50.140:FF:000416', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201802, NULL, 'G3DSA:3.80.10.10:FF:000511', NULL, NULL, 'Putative inactive leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(201803, NULL, 'G3DSA:3.40.50.300:FF:001343', NULL, NULL, 'ADP-ribosylation factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(201804, NULL, 'G3DSA:1.20.120.450:FF:000004', NULL, NULL, 'ClbS/DfsB family four-helix bundle protein', NULL, NULL, NULL, NULL, NULL, 4),
(201805, NULL, 'G3DSA:1.20.120.160:FF:000030', NULL, NULL, 'Histidine phosphotransfer domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(201806, NULL, 'G3DSA:3.10.180.10:FF:000119', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(201807, NULL, 'G3DSA:1.10.245.10:FF:000002', NULL, NULL, 'E3 ubiquitin-protein ligase Mdm2', NULL, NULL, NULL, NULL, NULL, 4),
(201808, NULL, 'G3DSA:3.90.1030.20:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201809, NULL, 'G3DSA:1.10.1320.10:FF:000008', NULL, NULL, 'DNA-dependent RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(201810, NULL, 'G3DSA:3.40.190.290:FF:000077', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(201811, NULL, 'G3DSA:3.40.1280.10:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201812, NULL, 'G3DSA:3.40.190.10:FF:000692', NULL, NULL, 'Periplasmic substrate binding protein family 1', NULL, NULL, NULL, NULL, NULL, 4),
(201813, NULL, 'G3DSA:1.10.510.10:FF:003542', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201814, NULL, 'G3DSA:2.10.25.10:FF:000421', NULL, NULL, 'Teratocarcinoma-derived growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(201815, NULL, 'G3DSA:1.10.10.10:FF:001406', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(201816, NULL, 'G3DSA:3.40.50.300:FF:004996', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201817, NULL, 'G3DSA:3.90.1030.10:FF:000005', NULL, NULL, 'Probable 50S ribosomal protein L17', NULL, NULL, NULL, NULL, NULL, 4),
(201818, NULL, 'G3DSA:3.30.1120.30:FF:000009', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(201819, NULL, 'G3DSA:2.70.170.10:FF:000098', NULL, NULL, 'Neuronal acetylcholine receptor subunit alpha-9', NULL, NULL, NULL, NULL, NULL, 4),
(201820, NULL, 'G3DSA:3.80.10.10:FF:002641', NULL, NULL, 'Leucine-rich repeat receptor protein kinase EMS1', NULL, NULL, NULL, NULL, NULL, 4),
(201821, NULL, 'G3DSA:3.80.10.10:FF:002540', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201822, NULL, 'G3DSA:3.30.1490.100:FF:000038', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(201823, NULL, 'G3DSA:3.40.50.1110:FF:000112', NULL, NULL, 'Putative O-antigen related protein', NULL, NULL, NULL, NULL, NULL, 4),
(201824, NULL, 'G3DSA:3.100.10.10:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201825, NULL, 'G3DSA:3.20.20.140:FF:000135', NULL, NULL, 'Inactive deaminase YJL070C', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(201826, NULL, 'G3DSA:3.30.200.20:FF:002099', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201827, NULL, 'G3DSA:3.20.20.300:FF:000009', NULL, NULL, 'Exo-1,4-beta-xylosidase xlnD', NULL, NULL, NULL, NULL, NULL, 4),
(201828, NULL, 'G3DSA:3.10.350.10:FF:000054', NULL, NULL, 'LysM domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(201829, NULL, 'G3DSA:1.20.1250.20:FF:000407', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(201830, NULL, 'G3DSA:2.60.120.200:FF:000633', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201831, NULL, 'G3DSA:3.30.160.60:FF:003551', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201832, NULL, 'G3DSA:3.30.420.40:FF:000289', NULL, NULL, 'Actin-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(201833, NULL, 'G3DSA:1.25.40.10:FF:001414', NULL, NULL, 'Small glutamine-rich tetratricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(201834, NULL, 'G3DSA:1.20.1050.10:FF:000187', NULL, NULL, 'Glutathionyl-hydroquinone reductase YqjG', NULL, NULL, NULL, NULL, NULL, 4),
(201835, NULL, 'G3DSA:3.40.390.10:FF:000235', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201836, NULL, 'G3DSA:3.90.190.10:FF:000012', NULL, NULL, 'protein tyrosine phosphatase type IVA 1', NULL, NULL, NULL, NULL, NULL, 4),
(201837, NULL, 'G3DSA:3.90.850.10:FF:000012', NULL, NULL, 'Putative 2-hydroxyhepta-2,4-diene-1,7-dioate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(201838, NULL, 'G3DSA:3.90.70.10:FF:000885', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201839, NULL, 'G3DSA:3.40.50.1000:FF:000669', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201840, NULL, 'G3DSA:2.60.40.10:FF:003444', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201841, NULL, 'G3DSA:2.30.120.10:FF:000002', NULL, NULL, 'Putative penicillin acylase (Penicillin amidase) (Penicillin amidohydrolase)', NULL, NULL, NULL, NULL, NULL, 4),
(201842, NULL, 'G3DSA:2.30.30.140:FF:000133', NULL, NULL, 'Fmr1, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(201843, NULL, 'G3DSA:3.55.50.30:FF:000027', NULL, NULL, 'Putative anti-sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(201844, NULL, 'G3DSA:3.40.50.2300:FF:000391', NULL, NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase SSU72', NULL, NULL, NULL, NULL, NULL, 4),
(201845, NULL, 'G3DSA:3.30.1370.120:FF:000017', NULL, NULL, 'Competence protein E', NULL, NULL, NULL, NULL, NULL, 4),
(201846, NULL, 'G3DSA:2.60.120.200:FF:000178', NULL, NULL, 'Glycoside hydrolase family 16 protein', NULL, NULL, NULL, NULL, NULL, 4),
(201847, NULL, 'G3DSA:3.90.228.20:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201848, NULL, 'G3DSA:3.40.1480.10:FF:000005', NULL, NULL, 'Glycerate kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(201849, NULL, 'G3DSA:3.40.1110.10:FF:000130', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(201850, NULL, 'G3DSA:1.20.1070.10:FF:000407', NULL, NULL, 'Adhesion G protein-coupled receptor D1', NULL, NULL, NULL, NULL, NULL, 4),
(201851, NULL, 'G3DSA:3.40.50.720:FF:000277', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(201852, NULL, 'G3DSA:3.40.50.620:FF:000371', NULL, NULL, 'Tryptophanyl-tRNA synthetase, cytoplasmic, putative', NULL, NULL, NULL, NULL, NULL, 4),
(201853, NULL, 'G3DSA:3.40.50.300:FF:003714', NULL, NULL, 'Guanylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(201854, NULL, 'G3DSA:2.60.40.60:FF:000896', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201855, NULL, 'G3DSA:3.40.50.720:FF:002418', NULL, NULL, 'UDP-galactose-4-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(201856, NULL, 'G3DSA:3.40.50.300:FF:005272', NULL, NULL, 'Ras family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(201857, NULL, 'G3DSA:3.40.50.2300:FF:000059', NULL, NULL, 'Glutamate receptor, ionotropic, kainate 4', NULL, NULL, NULL, NULL, NULL, 4),
(201858, NULL, 'G3DSA:1.25.40.20:FF:001395', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(201859, NULL, 'G3DSA:1.20.1070.10:FF:002195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201860, NULL, 'G3DSA:3.40.50.300:FF:007413', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201861, NULL, 'G3DSA:3.30.300.180:FF:000017', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(201862, NULL, 'G3DSA:1.10.3500.10:FF:000011', NULL, NULL, 'Transcription elongation factor SPT6', NULL, NULL, NULL, NULL, NULL, 4),
(201863, NULL, 'G3DSA:3.80.10.10:FF:004440', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201864, NULL, 'G3DSA:3.20.20.450:FF:000026', NULL, NULL, 'Diguanylate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(201865, NULL, 'G3DSA:2.130.10.10:FF:004939', NULL, NULL, 'WD repeat-containing protein 48 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(201866, NULL, 'G3DSA:1.20.120.20:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201867, NULL, 'G3DSA:3.80.10.10:FF:000286', NULL, NULL, 'Scribbled planar cell polarity protein', NULL, NULL, NULL, NULL, NULL, 4),
(201868, NULL, 'G3DSA:3.30.70.360:FF:000063', NULL, NULL, 'Succinyl-diaminopimelate desuccinylase', NULL, NULL, NULL, NULL, NULL, 4),
(201869, NULL, 'G3DSA:3.30.420.10:FF:000280', NULL, NULL, 'Protein CBG19000', NULL, NULL, NULL, NULL, NULL, 4),
(201870, NULL, 'G3DSA:2.130.10.10:FF:004619', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201871, NULL, 'G3DSA:2.60.120.200:FF:000403', NULL, NULL, 'Cadherin 3', NULL, NULL, NULL, NULL, NULL, 4),
(201872, NULL, 'G3DSA:3.90.1640.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201873, NULL, 'G3DSA:3.40.50.720:FF:000619', NULL, NULL, 'Oxidoreductase, short chain dehydrogenase/reductase family', NULL, NULL, NULL, NULL, NULL, 4),
(201874, NULL, 'G3DSA:3.40.50.300:FF:002866', NULL, NULL, 'DsDNA exonuclease SbcC', NULL, NULL, NULL, NULL, NULL, 4),
(201875, NULL, 'G3DSA:3.40.190.10:FF:000933', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201876, NULL, 'G3DSA:3.30.160.60:FF:001409', NULL, NULL, 'zinc finger protein 596 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(201877, NULL, 'G3DSA:3.40.50.1820:FF:000128', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(201878, NULL, 'G3DSA:1.10.510.10:FF:001743', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(201879, NULL, 'G3DSA:3.30.450.20:FF:000122', NULL, NULL, 'PAS domain-containing sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(201880, NULL, 'G3DSA:3.90.330.10:FF:000001', NULL, NULL, 'Cobalt-containing nitrile hydratase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(201881, NULL, 'G3DSA:3.30.710.10:FF:000151', NULL, NULL, 'BTB/POZ domain-containing protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(201882, NULL, 'G3DSA:3.40.50.300:FF:007424', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201883, NULL, 'G3DSA:2.130.10.10:FF:005215', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(201884, NULL, 'G3DSA:1.20.1250.20:FF:002307', NULL, NULL, 'Multidrug resistance efflux pump, RND family, inner membrane protein EmrB', NULL, NULL, NULL, NULL, NULL, 4),
(201885, NULL, 'G3DSA:3.90.25.10:FF:000016', NULL, NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(201886, NULL, 'G3DSA:1.10.1270.20:FF:000001', NULL, NULL, 'tRNA (guanine-N(1)-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(201887, NULL, 'G3DSA:1.10.150.20:FF:000139', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(201888, NULL, 'G3DSA:2.60.120.650:FF:000184', NULL, NULL, 'Putative lysine-specific demethylase ELF6', NULL, NULL, NULL, NULL, NULL, 4),
(201889, NULL, 'G3DSA:2.30.30.190:FF:000002', NULL, NULL, 'CAP-Gly domain containing linker protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(201890, NULL, 'G3DSA:3.30.1370.110:FF:000014', NULL, NULL, 'DNA endonuclease SmrA', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(201891, NULL, 'G3DSA:3.40.50.1370:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201892, NULL, 'G3DSA:3.40.50.300:FF:005159', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(201893, NULL, 'G3DSA:2.30.42.10:FF:000325', NULL, NULL, 'Periplasmic serine peptidase DegS', NULL, NULL, NULL, NULL, NULL, 4),
(201894, NULL, 'G3DSA:2.130.10.10:FF:002478', NULL, NULL, 'Plexin-2', NULL, NULL, NULL, NULL, NULL, 4),
(201895, NULL, 'G3DSA:3.40.50.150:FF:001152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201896, NULL, 'G3DSA:2.60.40.770:FF:000008', NULL, NULL, 'GG16835', NULL, NULL, NULL, NULL, NULL, 4),
(201897, NULL, 'G3DSA:3.30.160.20:FF:000021', NULL, NULL, 'Microprocessor complex subunit DGCR8', NULL, NULL, NULL, NULL, NULL, 4),
(201898, NULL, 'G3DSA:3.40.50.300:FF:006918', NULL, NULL, 'Carbohydrate sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(201899, NULL, 'G3DSA:3.30.1490.100:FF:000027', NULL, NULL, 'DNA polymerase Tau', NULL, NULL, NULL, NULL, NULL, 4),
(201900, NULL, 'G3DSA:3.40.50.2300:FF:000514', NULL, NULL, 'Metabotropic glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(201901, NULL, 'G3DSA:2.130.10.10:FF:001382', NULL, NULL, 'TOPLESS-related 3', NULL, NULL, NULL, NULL, NULL, 4),
(201902, NULL, 'G3DSA:2.60.40.760:FF:000005', NULL, NULL, 'Extracellular cellulase CelA/allergen Asp F7-like, putative (AFU_orthologue AFUA_5G08030)', NULL, NULL, NULL, NULL, NULL, 4),
(201903, NULL, 'G3DSA:3.40.50.150:FF:000876', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201904, NULL, 'G3DSA:1.25.40.10:FF:004287', NULL, NULL, 'At5g53080', NULL, NULL, NULL, NULL, NULL, 4),
(201905, NULL, 'G3DSA:3.90.1200.10:FF:000030', NULL, NULL, 'Bifunctional tRNA (Adenosine(37)-N6)-threonylcarbamoyltransferase complex ATPase subunit type 1 TsaE/phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(201906, NULL, 'G3DSA:1.10.238.10:FF:001149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201907, NULL, 'G3DSA:1.10.10.10:FF:000890', NULL, NULL, 'Trehalose operon transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(201908, NULL, 'G3DSA:1.20.58.400:FF:000030', NULL, NULL, 'Vesicle transport v-SNARE protein', NULL, NULL, NULL, NULL, NULL, 4),
(201909, NULL, 'G3DSA:2.160.10.10:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201910, NULL, 'G3DSA:3.10.290.20:FF:000001', NULL, NULL, 'NEDD8-activating enzyme E1 catalytic subunit, variant', NULL, NULL, NULL, NULL, NULL, 4),
(201911, NULL, 'G3DSA:1.10.630.10:FF:000381', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201912, NULL, 'G3DSA:3.30.200.20:FF:000643', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(201913, NULL, 'G3DSA:3.30.70.330:FF:002673', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201914, NULL, 'G3DSA:2.30.29.70:FF:000014', NULL, NULL, 'Proteasome complex subunit Rpn13 ubiquitin receptor-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(201915, NULL, 'G3DSA:3.30.40.10:FF:000548', NULL, NULL, 'Putative Histone-lysine N-methyltransferase MLL3', NULL, NULL, NULL, NULL, NULL, 4),
(201916, NULL, 'G3DSA:3.30.70.330:FF:000644', NULL, NULL, 'Splicing factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(201917, NULL, 'G3DSA:2.60.34.10:FF:000081', NULL, NULL, 'Chaperone protein', NULL, NULL, NULL, NULL, NULL, 4),
(201918, NULL, 'G3DSA:3.80.10.10:FF:002309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201919, NULL, 'G3DSA:2.60.40.10:FF:001073', NULL, NULL, 'ADAMTS like 1', NULL, NULL, NULL, NULL, NULL, 4),
(201920, NULL, 'G3DSA:1.20.900.10:FF:000091', NULL, NULL, 'Phosphatidylinositol-3,4,5-trisphosphate dependent Rac exchange factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(201921, NULL, 'G3DSA:3.40.50.80:FF:000154', NULL, NULL, 'NADH-cytochrome b5 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(201922, NULL, 'G3DSA:3.40.190.10:FF:000372', NULL, NULL, 'Membrane-bound lytic murein transglycosylase F', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(201923, NULL, 'G3DSA:1.20.58.60:FF:000126', NULL, NULL, 'Spectrin repeat containing, nuclear envelope 1a', NULL, NULL, NULL, NULL, NULL, 4),
(201924, NULL, 'G3DSA:3.40.630.10:FF:000288', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(201925, NULL, 'G3DSA:3.30.420.10:FF:000611', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201926, NULL, 'G3DSA:2.60.40.60:FF:000576', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201927, NULL, 'G3DSA:3.90.1150.10:FF:000486', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201928, NULL, 'G3DSA:3.40.850.10:FF:000153', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(201929, NULL, 'G3DSA:3.40.50.720:FF:000412', NULL, NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(201930, NULL, 'G3DSA:3.80.10.10:FF:002186', NULL, NULL, 'Probable disease resistance protein At5g04720', NULL, NULL, NULL, NULL, NULL, 4),
(201931, NULL, 'G3DSA:2.60.40.10:FF:000797', NULL, NULL, 'Plexin C1', NULL, NULL, NULL, NULL, NULL, 4),
(201932, NULL, 'G3DSA:3.30.160.60:FF:005338', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201933, NULL, 'G3DSA:1.10.8.60:FF:000122', NULL, NULL, 'AAA ATPase forming ring-shaped complexes', NULL, NULL, NULL, NULL, NULL, 4),
(201934, NULL, 'G3DSA:2.60.40.2610:FF:000002', NULL, NULL, 'Fimbrial biogenesis outer membrane usher protein', NULL, NULL, NULL, NULL, NULL, 4),
(201935, NULL, 'G3DSA:3.40.50.410:FF:000066', NULL, NULL, 'von Willebrand factor, type A', NULL, NULL, NULL, NULL, NULL, 4),
(201936, NULL, 'G3DSA:1.10.510.10:FF:003104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201937, NULL, 'G3DSA:3.40.850.10:FF:000372', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(201938, NULL, 'G3DSA:3.60.15.10:FF:000091', NULL, NULL, 'tRNA processing endoribonuclease Trz1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(201939, NULL, 'G3DSA:3.60.40.10:FF:000053', NULL, NULL, 'Protein phosphatase 2C 29', NULL, NULL, NULL, NULL, NULL, 4),
(201940, NULL, 'G3DSA:1.10.510.10:FF:000586', NULL, NULL, 'Interleukin-1 receptor-associated kinase-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(201941, NULL, 'G3DSA:1.25.40.470:FF:000002', NULL, NULL, 'Coatomer subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(201942, NULL, 'G3DSA:1.25.40.10:FF:004629', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201943, NULL, 'G3DSA:1.10.150.50:FF:000131', NULL, NULL, 'EPS8 like 2', NULL, NULL, NULL, NULL, NULL, 4),
(201944, NULL, 'G3DSA:1.25.40.20:FF:001417', NULL, NULL, 'Ankyrin repeat and SOCS box-containing 5a', NULL, NULL, NULL, NULL, NULL, 4),
(201945, NULL, 'G3DSA:2.130.10.10:FF:000887', NULL, NULL, 'CPSF (Cleavage and polyadenylation specific factor)', NULL, NULL, NULL, NULL, NULL, 4),
(201946, NULL, 'G3DSA:1.20.1070.10:FF:000295', NULL, NULL, 'B1 bradykinin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(201947, NULL, 'G3DSA:3.40.525.10:FF:000049', NULL, NULL, 'CRAL-TRIO domain-containing protein C23B6.04c isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(201948, NULL, 'G3DSA:3.40.50.300:FF:003372', NULL, NULL, 'DEAD-box ATP-dependent RNA helicase 38', NULL, NULL, NULL, NULL, NULL, 4),
(201949, NULL, 'G3DSA:2.120.10.80:FF:000279', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(201950, NULL, 'G3DSA:3.40.190.10:FF:000579', NULL, NULL, 'ABC-type dipeptide transport system, periplasmic component', NULL, NULL, NULL, NULL, NULL, 4),
(201951, NULL, 'G3DSA:2.30.29.30:FF:000238', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(201952, NULL, 'G3DSA:2.60.40.10:FF:002388', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(201953, NULL, 'G3DSA:1.10.510.10:FF:000928', NULL, NULL, 'Si:dkeyp-67e1.6', NULL, NULL, NULL, NULL, NULL, 4),
(201954, NULL, 'G3DSA:3.30.70.141:FF:000009', NULL, NULL, 'Nucleoside diphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(201955, NULL, 'G3DSA:1.25.40.480:FF:000005', NULL, NULL, 'SnoRNA-binding rRNA-processing protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(201956, NULL, 'G3DSA:3.40.50.620:FF:000039', NULL, NULL, 'Probable nicotinate-nucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(201957, NULL, 'G3DSA:3.30.930.10:FF:000133', NULL, NULL, 'Phenylalanyl-tRNA synthetase alpha chain,putative', NULL, NULL, NULL, NULL, NULL, 4),
(201958, NULL, 'G3DSA:1.10.10.2830:FF:000006', NULL, NULL, 'ParB-like partition protein', NULL, NULL, NULL, NULL, NULL, 4),
(201959, NULL, 'G3DSA:3.40.50.12780:FF:000122', NULL, NULL, 'Hydroxamate-type ferrichrome siderophore peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(201960, NULL, 'G3DSA:1.10.150.240:FF:000057', NULL, NULL, 'Phosphoglycolate phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(201961, NULL, 'G3DSA:2.70.150.10:FF:000198', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(201962, NULL, 'G3DSA:2.60.120.260:FF:000382', NULL, NULL, 'Beta-galactosidase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(201963, NULL, 'G3DSA:3.30.40.10:FF:002241', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(201964, NULL, 'G3DSA:3.30.710.10:FF:000381', NULL, NULL, 'Kelch like family member 14', NULL, NULL, NULL, NULL, NULL, 4),
(201965, NULL, 'G3DSA:3.30.750.24:FF:000037', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(201966, NULL, 'G3DSA:3.30.160.60:FF:005131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201967, NULL, 'G3DSA:3.30.420.10:FF:000050', NULL, NULL, 'Transposon Ty2-DR3 Gag-Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(201968, NULL, 'G3DSA:3.40.20.10:FF:000013', NULL, NULL, 'supervillin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(201969, NULL, 'G3DSA:1.20.1510.10:FF:000094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201970, NULL, 'G3DSA:3.30.160.70:FF:000007', NULL, NULL, 'Methylated-DNA--protein-cysteine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(201971, NULL, 'G3DSA:3.50.50.60:FF:000541', NULL, NULL, 'Dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(201972, NULL, 'G3DSA:3.30.160.60:FF:001286', NULL, NULL, 'Zinc finger protein 485', NULL, NULL, NULL, NULL, NULL, 4),
(201973, NULL, 'G3DSA:3.30.40.10:FF:001965', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201974, NULL, 'G3DSA:2.60.40.10:FF:001415', NULL, NULL, 'Hemicentin 2', NULL, NULL, NULL, NULL, NULL, 4),
(201975, NULL, 'G3DSA:3.30.70.330:FF:000863', NULL, NULL, 'Nucleolar protein', NULL, NULL, NULL, NULL, NULL, 4),
(201976, NULL, 'G3DSA:2.60.40.420:FF:000134', NULL, NULL, 'Cupredoxin superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(201977, NULL, 'G3DSA:3.40.50.150:FF:001713', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(201978, NULL, 'G3DSA:3.40.309.10:FF:000047', NULL, NULL, 'NAD-dependent succinate-semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(201979, NULL, 'G3DSA:1.25.10.10:FF:000862', NULL, NULL, 'Cell differentiation protein rcd1', NULL, NULL, NULL, NULL, NULL, 4),
(201980, NULL, 'G3DSA:2.30.40.10:FF:000034', NULL, NULL, 'Guanine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(201981, NULL, 'G3DSA:3.30.559.10:FF:000039', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(201982, NULL, 'G3DSA:2.170.150.10:FF:000005', NULL, NULL, 'Guanine nucleotide exchange factor MSS4', NULL, NULL, NULL, NULL, NULL, 4),
(201983, NULL, 'G3DSA:3.90.810.10:FF:000015', NULL, NULL, 'CDC42 small effector protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(201984, NULL, 'G3DSA:1.25.40.10:FF:003314', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(201985, NULL, 'G3DSA:2.60.40.60:FF:001059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201986, NULL, 'G3DSA:1.10.510.10:FF:001204', NULL, NULL, 'Probable CMK1-Ca2+/calmodulin-dependent ser/thr protein kinase type', NULL, NULL, NULL, NULL, NULL, 4),
(201987, NULL, 'G3DSA:1.10.238.10:FF:000666', NULL, NULL, 'Efhand domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(201988, NULL, 'G3DSA:3.30.450.20:FF:000661', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201989, NULL, 'G3DSA:1.10.1420.10:FF:000179', NULL, NULL, 'DNA Mismatch Repair (MMR) protein MutS, putative', NULL, NULL, NULL, NULL, NULL, 4),
(201990, NULL, 'G3DSA:3.40.640.10:FF:000339', NULL, NULL, 'Cystathionine gamma-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(201991, NULL, 'G3DSA:2.130.10.10:FF:003192', NULL, NULL, 'Microtubule binding protein YTM1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(201992, NULL, 'G3DSA:2.40.37.10:FF:000048', NULL, NULL, 'Ornithine decarboxylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(201993, NULL, 'G3DSA:3.30.200.20:FF:002329', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(201994, NULL, 'G3DSA:2.60.40.420:FF:000027', NULL, NULL, 'ephrin-B1', NULL, NULL, NULL, NULL, NULL, 4),
(201995, NULL, 'G3DSA:1.25.40.10:FF:002477', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(201996, NULL, 'G3DSA:3.40.50.10190:FF:000204', NULL, NULL, 'DNA polymerase III subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(201997, NULL, 'G3DSA:3.30.160.60:FF:001634', NULL, NULL, 'Zinc finger protein 224, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(201998, NULL, 'G3DSA:2.120.10.80:FF:000178', NULL, NULL, 'Leucine carboxyl methyltransferase 2, variant', NULL, NULL, NULL, NULL, NULL, 4),
(201999, NULL, 'G3DSA:3.80.10.10:FF:000623', NULL, NULL, 'Leucine-rich repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(202000, NULL, 'G3DSA:3.40.50.300:FF:001455', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(202001, NULL, 'G3DSA:3.40.1000.30:FF:000009', NULL, NULL, 'F-box only protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(202002, NULL, 'G3DSA:1.50.10.10:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202003, NULL, 'G3DSA:3.90.810.10:FF:000021', NULL, NULL, 'AGAP001790-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(202004, NULL, 'G3DSA:1.20.1730.10:FF:000082', NULL, NULL, 'Putative transmembrane transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(202005, NULL, 'G3DSA:3.40.50.80:FF:000047', NULL, NULL, 'Naphthalene 1,2-dioxygenase reductase component', NULL, NULL, NULL, NULL, NULL, 4),
(202006, NULL, 'G3DSA:1.25.40.180:FF:000123', NULL, NULL, 'CaGCR3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(202007, NULL, 'G3DSA:1.25.40.10:FF:003101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202008, NULL, 'G3DSA:1.20.1250.20:FF:000626', NULL, NULL, 'Putative integral membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(202009, NULL, 'G3DSA:1.10.1270.20:FF:000006', NULL, NULL, 'tRNA (guanine-N(1)-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(202010, NULL, 'G3DSA:3.40.1000.30:FF:000021', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(202011, NULL, 'G3DSA:3.90.830.10:FF:000016', NULL, NULL, 'Vacuolar protein sorting 33B', NULL, NULL, NULL, NULL, NULL, 4),
(202012, NULL, 'G3DSA:1.10.10.10:FF:000676', NULL, NULL, 'Transcriptional regulator, MarR family', NULL, NULL, NULL, NULL, NULL, 4),
(202013, NULL, 'G3DSA:2.130.10.10:FF:005434', NULL, NULL, 'SnoRNA-binding rRNA-processing protein', NULL, NULL, NULL, NULL, NULL, 4),
(202014, NULL, 'G3DSA:3.40.850.10:FF:000046', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(202015, NULL, 'G3DSA:2.130.10.10:FF:003310', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202016, NULL, 'G3DSA:3.40.50.720:FF:001120', NULL, NULL, 'Calcium-gated potassium channel protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202017, NULL, 'G3DSA:2.130.10.10:FF:004833', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202018, NULL, 'G3DSA:3.20.20.80:FF:000613', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(202019, NULL, 'G3DSA:2.20.100.10:FF:000048', NULL, NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 8', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(202020, NULL, 'G3DSA:1.20.58.760:FF:000008', NULL, NULL, 'ATP-dependent zinc metalloprotease FTSH', NULL, NULL, NULL, NULL, NULL, 4),
(202021, NULL, 'G3DSA:1.20.920.10:FF:000215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202022, NULL, 'G3DSA:3.30.1490.430:FF:000002', NULL, NULL, 'mRNA-capping enzyme subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(202023, NULL, 'G3DSA:3.50.50.60:FF:000760', NULL, NULL, 'Phytoene desaturase', NULL, NULL, NULL, NULL, NULL, 4),
(202024, NULL, 'G3DSA:1.10.486.10:FF:000073', NULL, NULL, 'Blr8088 protein', NULL, NULL, NULL, NULL, NULL, 4),
(202025, NULL, 'G3DSA:2.130.10.10:FF:001056', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(202026, NULL, 'G3DSA:2.60.40.10:FF:004855', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202027, NULL, 'G3DSA:3.40.50.300:FF:003602', NULL, NULL, 'Cobinamide kinase / cobinamide phosphate guanyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(202028, NULL, 'G3DSA:2.60.120.260:FF:000275', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(202029, NULL, 'G3DSA:1.10.630.10:FF:000055', NULL, NULL, 'Cytochrome P450 71A26', NULL, NULL, NULL, NULL, NULL, 4),
(202030, NULL, 'G3DSA:2.130.10.10:FF:001163', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(202031, NULL, 'G3DSA:2.60.40.10:FF:004748', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202032, NULL, 'G3DSA:3.10.20.620:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202033, NULL, 'G3DSA:1.25.40.10:FF:005225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202034, NULL, 'G3DSA:1.25.10.10:FF:001345', NULL, NULL, 'Hym1p orthologue, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202035, NULL, 'G3DSA:1.10.510.10:FF:000001', NULL, NULL, 'Calcium/calmodulin-dependent protein kinase type II subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(202036, NULL, 'G3DSA:2.60.40.10:FF:001078', NULL, NULL, 'Programmed cell death 1 ligand 2', NULL, NULL, NULL, NULL, NULL, 4),
(202037, NULL, 'G3DSA:1.10.630.10:FF:000162', NULL, NULL, 'Os06g0641600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(202038, NULL, 'G3DSA:3.30.40.210:FF:000012', NULL, NULL, 'Transcription elongation factor SPT4', NULL, NULL, NULL, NULL, NULL, 4),
(202039, NULL, 'G3DSA:1.10.472.30:FF:000007', NULL, NULL, 'PHD finger domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202040, NULL, 'G3DSA:1.10.10.60:FF:001152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202041, NULL, 'G3DSA:3.40.50.300:FF:001562', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(202042, NULL, 'G3DSA:1.10.1300.10:FF:000018', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(202043, NULL, 'G3DSA:2.40.240.20:FF:000001', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4),
(202044, NULL, 'G3DSA:3.60.10.10:FF:000012', NULL, NULL, 'nocturnin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(202045, NULL, 'G3DSA:1.25.10.10:FF:001019', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(202046, NULL, 'G3DSA:1.10.418.10:FF:000079', NULL, NULL, 'Neuron navigator 3', NULL, NULL, NULL, NULL, NULL, 4),
(202047, NULL, 'G3DSA:3.30.559.10:FF:000034', NULL, NULL, 'Nonribosomal peptide synthase sidD', NULL, NULL, NULL, NULL, NULL, 4),
(202048, NULL, 'G3DSA:3.30.160.60:FF:003091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202049, NULL, 'G3DSA:3.50.50.60:FF:000748', NULL, NULL, 'Probable lysine-specific histone demethylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(202050, NULL, 'G3DSA:3.30.160.60:FF:001527', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(202051, NULL, 'G3DSA:3.30.450.20:FF:000009', NULL, NULL, 'Potassium voltage-gated channel subfamily H member 1', NULL, NULL, NULL, NULL, NULL, 4),
(202052, NULL, 'G3DSA:3.30.760.10:FF:000086', NULL, NULL, 'Eukaryotic translation initiation factor 4E family member 1B', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(202053, NULL, 'G3DSA:1.20.920.10:FF:000108', NULL, NULL, 'Transcription initiation factor TFIID subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(202054, NULL, 'G3DSA:3.30.200.20:FF:001132', NULL, NULL, 'Si:ch211-285c6.3', NULL, NULL, NULL, NULL, NULL, 4),
(202055, NULL, 'G3DSA:3.30.450.20:FF:000335', NULL, NULL, 'Transcriptional regulator, PpsR', NULL, NULL, NULL, NULL, NULL, 4),
(202056, NULL, 'G3DSA:1.10.10.1020:FF:000003', NULL, NULL, 'RecBCD enzyme subunit RecD', NULL, NULL, NULL, NULL, NULL, 4),
(202057, NULL, 'G3DSA:3.90.70.10:FF:000767', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202058, NULL, 'G3DSA:3.30.1370.10:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202059, NULL, 'G3DSA:2.60.40.10:FF:001185', NULL, NULL, 'Nectin cell adhesion molecule 3b', NULL, NULL, NULL, NULL, NULL, 4),
(202060, NULL, 'G3DSA:1.25.10.10:FF:002880', NULL, NULL, 'Exportin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202061, NULL, 'G3DSA:3.30.70.120:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202062, NULL, 'G3DSA:1.10.220.70:FF:000002', NULL, NULL, 'Ethanolamine ammonia-lyase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(202063, NULL, 'G3DSA:3.30.70.270:FF:000042', NULL, NULL, 'Sensor domain-containing diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(202064, NULL, 'G3DSA:3.30.420.10:FF:000504', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202065, NULL, 'G3DSA:1.20.1250.20:FF:002190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202066, NULL, 'G3DSA:2.40.70.10:FF:000575', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202067, NULL, 'G3DSA:3.40.190.10:FF:000815', NULL, NULL, 'Transferrin-a', NULL, NULL, NULL, NULL, NULL, 4),
(202068, NULL, 'G3DSA:1.10.510.10:FF:003660', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202069, NULL, 'G3DSA:2.60.40.3470:FF:000001', NULL, NULL, 'Fimbrial assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(202070, NULL, 'G3DSA:3.40.50.300:FF:001129', NULL, NULL, 'ras-related protein Rab-44 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(202071, NULL, 'G3DSA:1.10.8.50:FF:000001', NULL, NULL, '30S ribosomal protein S13', NULL, NULL, NULL, NULL, NULL, 4),
(202072, NULL, 'G3DSA:3.30.40.10:FF:002342', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(202073, NULL, 'G3DSA:3.20.20.80:FF:000720', NULL, NULL, 'Beta-glucosidase 47', NULL, NULL, NULL, NULL, NULL, 4),
(202074, NULL, 'G3DSA:2.130.10.10:FF:004726', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(202075, NULL, 'G3DSA:3.40.50.10540:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202076, NULL, 'G3DSA:2.40.50.90:FF:000114', NULL, NULL, 'Ring finger protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(202077, NULL, 'G3DSA:3.30.160.60:FF:001960', NULL, NULL, 'zinc finger protein 629 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(202078, NULL, 'G3DSA:3.30.450.20:FF:000442', NULL, NULL, 'Sensor box histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(202079, NULL, 'G3DSA:2.60.40.150:FF:000379', NULL, NULL, 'Protein CBR-SNT-7', NULL, NULL, NULL, NULL, NULL, 4),
(202080, NULL, 'G3DSA:3.30.200.20:FF:002436', NULL, NULL, 'AGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(202081, NULL, 'G3DSA:3.40.50.720:FF:002536', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(202082, NULL, 'G3DSA:2.60.210.10:FF:000082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202083, NULL, 'G3DSA:1.20.1250.20:FF:002083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202084, NULL, 'G3DSA:1.10.8.60:FF:000004', NULL, NULL, 'Cell division control 48', NULL, NULL, NULL, NULL, NULL, 4),
(202085, NULL, 'G3DSA:2.60.120.330:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202086, NULL, 'G3DSA:1.20.120.850:FF:000023', NULL, NULL, 'DNA repair and recombination protein RAD54, putative', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(202087, NULL, 'G3DSA:1.20.1070.10:FF:000851', NULL, NULL, 'Octopamine receptor beta-3R', NULL, NULL, NULL, NULL, NULL, 4),
(202088, NULL, 'G3DSA:3.40.50.2000:FF:000284', NULL, NULL, 'Glycosyltransferase WbpY', NULL, NULL, NULL, NULL, NULL, 4),
(202089, NULL, 'G3DSA:3.40.1190.20:FF:000008', NULL, NULL, 'Pyridoxal kinase PdxY', NULL, NULL, NULL, NULL, NULL, 4),
(202090, NULL, 'G3DSA:2.40.70.10:FF:000468', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202091, NULL, 'G3DSA:3.30.1370.10:FF:000073', NULL, NULL, 'Transcription or splicing factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(202092, NULL, 'G3DSA:3.90.1310.10:FF:000038', NULL, NULL, 'Penicillin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(202093, NULL, 'G3DSA:3.30.230.10:FF:000018', NULL, NULL, 'Diphosphomevalonate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(202094, NULL, 'G3DSA:1.25.40.20:FF:001636', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202095, NULL, 'G3DSA:1.25.40.90:FF:000106', NULL, NULL, 'Clathrin interactor 1a', NULL, NULL, NULL, NULL, NULL, 4),
(202096, NULL, 'G3DSA:1.10.510.10:FF:001305', NULL, NULL, 'Serine/threonine-protein kinase RIO2', NULL, NULL, NULL, NULL, NULL, 4),
(202097, NULL, 'G3DSA:1.25.10.10:FF:001238', NULL, NULL, 'TOG array regulator of axonemal microtubules protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(202098, NULL, 'G3DSA:3.90.190.10:FF:000113', NULL, NULL, 'Putative mitogen-activated protein kinase phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(202099, NULL, 'G3DSA:3.50.50.60:FF:000529', NULL, NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(202100, NULL, 'G3DSA:2.130.10.10:FF:005108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202101, NULL, 'G3DSA:1.25.40.20:FF:001176', NULL, NULL, 'Transient receptor potential cation channel, subfamily A, member 1a', NULL, NULL, NULL, NULL, NULL, 4),
(202102, NULL, 'G3DSA:2.60.420.10:FF:000007', NULL, NULL, 'Trehalose-6-phosphate phosphatase OtsB1', NULL, NULL, NULL, NULL, NULL, 4),
(202103, NULL, 'G3DSA:2.160.10.10:FF:000077', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(202104, NULL, 'G3DSA:3.10.20.10:FF:000037', NULL, NULL, 'Cell death-inducing DFFA-like effector b', NULL, NULL, NULL, NULL, NULL, 4),
(202105, NULL, 'G3DSA:2.40.70.10:FF:000249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202106, NULL, 'G3DSA:3.40.50.12780:FF:000015', NULL, NULL, 'D-alanine--D-alanyl carrier protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(202107, NULL, 'G3DSA:3.40.1190.10:FF:000005', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(202108, NULL, 'G3DSA:3.30.160.60:FF:001308', NULL, NULL, 'Zinc finger protein 408', NULL, NULL, NULL, NULL, NULL, 4),
(202109, NULL, 'G3DSA:2.30.30.100:FF:000032', NULL, NULL, 'U7 snRNA-associated Sm-like protein LSm11', NULL, NULL, NULL, NULL, NULL, 4),
(202110, NULL, 'G3DSA:3.40.50.2000:FF:000065', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(202111, NULL, 'G3DSA:3.90.25.10:FF:000011', NULL, NULL, 'dTDP-glucose 4,6-dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(202112, NULL, 'G3DSA:2.60.40.10:FF:004962', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202113, NULL, 'G3DSA:3.40.190.10:FF:000478', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202114, NULL, 'G3DSA:3.30.70.330:FF:000756', NULL, NULL, 'Alternative splicing factor ASF-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202115, NULL, 'G3DSA:3.30.200.20:FF:002543', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202116, NULL, 'G3DSA:2.130.10.10:FF:004496', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202117, NULL, 'G3DSA:2.60.40.10:FF:003551', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202118, NULL, 'G3DSA:3.30.200.20:FF:000289', NULL, NULL, 'Cyclin-dependent kinase D-1', NULL, NULL, NULL, NULL, NULL, 4),
(202119, NULL, 'G3DSA:2.60.40.10:FF:004529', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(202120, NULL, 'G3DSA:2.10.70.10:FF:000031', NULL, NULL, 'gamma-aminobutyric acid type B receptor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(202121, NULL, 'G3DSA:1.25.10.10:FF:003262', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(202122, NULL, 'G3DSA:2.60.40.1390:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202123, NULL, 'G3DSA:1.10.287.70:FF:000038', NULL, NULL, 'Potassium voltage-gated channel subfamily KQT member', NULL, NULL, NULL, NULL, NULL, 4),
(202124, NULL, 'G3DSA:1.25.40.860:FF:000006', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(202125, NULL, 'G3DSA:3.30.200.20:FF:001025', NULL, NULL, 'Nucleotide exchange factor RasGEF P family protein', NULL, NULL, NULL, NULL, NULL, 4),
(202126, NULL, 'G3DSA:1.25.40.180:FF:000016', NULL, NULL, 'polyadenylate-binding protein-interacting protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(202127, NULL, 'G3DSA:1.10.10.60:FF:001045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202128, NULL, 'G3DSA:2.40.30.170:FF:000078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202129, NULL, 'G3DSA:2.120.10.30:FF:000528', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202130, NULL, 'G3DSA:2.60.120.650:FF:000178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202131, NULL, 'G3DSA:3.30.70.330:FF:000537', NULL, NULL, 'Ras GTPase-activating protein-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(202132, NULL, 'G3DSA:3.80.10.10:FF:000516', NULL, NULL, 'Leucine-rich repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(202133, NULL, 'G3DSA:2.60.110.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202134, NULL, 'G3DSA:2.40.30.10:FF:000359', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202135, NULL, 'G3DSA:4.10.60.10:FF:000094', NULL, NULL, 'Zinc finger CCHC-type containing 13', NULL, NULL, NULL, NULL, NULL, 4),
(202136, NULL, 'G3DSA:3.40.1170.10:FF:000010', NULL, NULL, 'DNA mismatch repair protein Msh1', NULL, NULL, NULL, NULL, NULL, 4),
(202137, NULL, 'G3DSA:1.25.10.10:FF:001126', NULL, NULL, 'Importin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(202138, NULL, 'G3DSA:1.20.120.20:FF:000034', NULL, NULL, 'Zgc:162608', NULL, NULL, NULL, NULL, NULL, 4),
(202139, NULL, 'G3DSA:3.80.10.10:FF:000404', NULL, NULL, 'Predicted gene 7682', NULL, NULL, NULL, NULL, NULL, 4),
(202140, NULL, 'G3DSA:3.40.50.150:FF:000769', NULL, NULL, 'Precorrin-6Y C(5,15)-methyltransferase [decarboxylating]', NULL, NULL, NULL, NULL, NULL, 4),
(202141, NULL, 'G3DSA:2.70.160.11:FF:000025', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(202142, NULL, 'G3DSA:2.60.40.10:FF:003332', NULL, NULL, 'Sensory AXon guidance', NULL, NULL, NULL, NULL, NULL, 4),
(202143, NULL, 'G3DSA:1.10.10.10:FF:000783', NULL, NULL, 'Unplaced genomic scaffold supercont1.201, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(202144, NULL, 'G3DSA:1.25.40.180:FF:000230', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202145, NULL, 'G3DSA:3.40.50.2000:FF:000744', NULL, NULL, 'GDP-Man:Man(3)GlcNAc(2)-PP-Dol alpha-1,2-mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(202146, NULL, 'G3DSA:3.30.40.10:FF:000655', NULL, NULL, 'E3 ubiquitin-protein ligase ATL41', NULL, NULL, NULL, NULL, NULL, 4),
(202147, NULL, 'G3DSA:3.40.1390.20:FF:000001', NULL, NULL, 'Phosphate acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(202148, NULL, 'G3DSA:3.30.70.330:FF:002780', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202149, NULL, 'G3DSA:2.30.30.190:FF:000007', NULL, NULL, 'Putative ubiquitin carboxyl-terminal hydrolase CYLD', NULL, NULL, NULL, NULL, NULL, 4),
(202150, NULL, 'G3DSA:2.20.100.10:FF:000155', NULL, NULL, 'Protein CBR-SPON-1', NULL, NULL, NULL, NULL, NULL, 4),
(202151, NULL, 'G3DSA:1.20.120.1130:FF:000002', NULL, NULL, 'Vacuolar protein sorting-associated protein 28 homolog', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(202152, NULL, 'G3DSA:3.40.50.1820:FF:000454', NULL, NULL, 'Ab-hydrolase associated lipase region', NULL, NULL, NULL, NULL, NULL, 4),
(202153, NULL, 'G3DSA:3.20.20.190:FF:000015', NULL, NULL, 'Glycerophosphocholine phosphodiesterase GPCPD1', NULL, NULL, NULL, NULL, NULL, 4),
(202154, NULL, 'G3DSA:3.80.10.10:FF:002080', NULL, NULL, 'LRR F-box protein MAX2a', NULL, NULL, NULL, NULL, NULL, 4),
(202155, NULL, 'G3DSA:2.30.29.30:FF:000811', NULL, NULL, 'Kinase, AGC MAST', NULL, NULL, NULL, NULL, NULL, 4),
(202156, NULL, 'G3DSA:3.30.160.60:FF:001741', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202157, NULL, 'G3DSA:3.30.450.20:FF:000223', NULL, NULL, 'neuronal PAS domain-containing protein 3 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(202158, NULL, 'G3DSA:1.10.287.110:FF:000478', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202159, NULL, 'G3DSA:3.40.50.620:FF:000707', NULL, NULL, 'Nicotinamide-nucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(202160, NULL, 'G3DSA:2.60.220.50:FF:000009', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(202161, NULL, 'G3DSA:3.40.50.300:FF:008487', NULL, NULL, 'Multidrug resistance protein fer6', NULL, NULL, NULL, NULL, NULL, 4),
(202162, NULL, 'G3DSA:3.30.710.10:FF:000156', NULL, NULL, 'Zinc finger protein chinmo', NULL, NULL, NULL, NULL, NULL, 4),
(202163, NULL, 'G3DSA:1.25.40.10:FF:004394', NULL, NULL, 'Pre-mRNA-splicing factor prp1', NULL, NULL, NULL, NULL, NULL, 4),
(202164, NULL, 'G3DSA:3.30.470.20:FF:000230', NULL, NULL, 'Carbamoyl phosphate synthase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(202165, NULL, 'G3DSA:1.25.40.820:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202166, NULL, 'G3DSA:3.30.300.30:FF:000119', NULL, NULL, 'D-alanine--poly(Phosphoribitol) ligase', NULL, NULL, NULL, NULL, NULL, 4),
(202167, NULL, 'G3DSA:1.20.1070.10:FF:000632', NULL, NULL, 'CG3856-like octopamine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(202168, NULL, 'G3DSA:2.60.40.10:FF:001308', NULL, NULL, 'Fc receptor like 4', NULL, NULL, NULL, NULL, NULL, 4),
(202169, NULL, 'G3DSA:3.10.450.350:FF:000010', NULL, NULL, 'Membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(202170, NULL, 'G3DSA:1.20.5.170:FF:000040', NULL, NULL, 'Nuclear pore glycoprotein p62', NULL, NULL, NULL, NULL, NULL, 4),
(202171, NULL, 'G3DSA:3.40.50.300:FF:004895', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202172, NULL, 'G3DSA:1.20.1250.20:FF:000733', NULL, NULL, 'Sugar efflux transporter B', NULL, NULL, NULL, NULL, NULL, 4),
(202173, NULL, 'G3DSA:2.40.50.140:FF:000079', NULL, NULL, 'Exoribonuclease 2', NULL, NULL, NULL, NULL, NULL, 4),
(202174, NULL, 'G3DSA:3.30.160.60:FF:002938', NULL, NULL, 'RAD18p E3 ubiquitin ligase', NULL, NULL, NULL, NULL, NULL, 4),
(202175, NULL, 'G3DSA:3.30.70.660:FF:000057', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(202176, NULL, 'G3DSA:3.30.160.60:FF:000111', NULL, NULL, 'GLI family zinc finger 4', NULL, NULL, NULL, NULL, NULL, 4),
(202177, NULL, 'G3DSA:1.20.1080.10:FF:000127', NULL, NULL, 'Aquaglyceroporin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202178, NULL, 'G3DSA:1.20.900.10:FF:000113', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(202179, NULL, 'G3DSA:3.40.50.410:FF:000302', NULL, NULL, 'ATP dependent DNA ligase 1', NULL, NULL, NULL, NULL, NULL, 4),
(202180, NULL, 'G3DSA:3.40.1390.30:FF:000004', NULL, NULL, 'NIF3-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(202181, NULL, 'G3DSA:1.10.238.10:FF:000986', NULL, NULL, 'Mitochondrial Rho GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(202182, NULL, 'G3DSA:2.120.10.80:FF:000392', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202183, NULL, 'G3DSA:3.40.220.10:FF:000015', NULL, NULL, 'Polyprotein P1234', NULL, NULL, NULL, NULL, NULL, 4),
(202184, NULL, 'G3DSA:1.20.58.740:FF:000002', NULL, NULL, 'Dedicator of cytokinesis protein 7', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(202185, NULL, 'G3DSA:2.40.50.650:FF:000001', NULL, NULL, 'Anti-adapter protein IraM', NULL, NULL, NULL, NULL, NULL, 4),
(202186, NULL, 'G3DSA:3.40.50.720:FF:002424', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202187, NULL, 'G3DSA:1.20.1070.10:FF:002094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202188, NULL, 'G3DSA:1.10.510.10:FF:001524', NULL, NULL, 'U-box domain-containing protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(202189, NULL, 'G3DSA:2.40.50.140:FF:000972', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202190, NULL, 'G3DSA:3.90.1150.10:FF:000380', NULL, NULL, 'Glycine dehydrogenase (decarboxylating)', NULL, NULL, NULL, NULL, NULL, 4),
(202191, NULL, 'G3DSA:2.60.120.200:FF:000408', NULL, NULL, 'Bb-cadherin', NULL, NULL, NULL, NULL, NULL, 4),
(202192, NULL, 'G3DSA:1.25.40.10:FF:001173', NULL, NULL, 'Vacuolar protein sorting-associated protein 41', NULL, NULL, NULL, NULL, NULL, 4),
(202193, NULL, 'G3DSA:1.20.1070.10:FF:001829', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202194, NULL, 'G3DSA:2.40.100.10:FF:000078', NULL, NULL, 'Allophanate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(202195, NULL, 'G3DSA:3.30.559.10:FF:000253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202196, NULL, 'G3DSA:1.50.10.10:FF:000101', NULL, NULL, 'Protein CBG10878', NULL, NULL, NULL, NULL, NULL, 4),
(202197, NULL, 'G3DSA:3.40.850.10:FF:000158', NULL, NULL, 'Kinesin family member 16B', NULL, NULL, NULL, NULL, NULL, 4),
(202198, NULL, 'G3DSA:3.50.7.10:FF:000091', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202199, NULL, 'G3DSA:1.20.1250.20:FF:000166', NULL, NULL, 'Inner membrane protein YhjX', NULL, NULL, NULL, NULL, NULL, 4),
(202200, NULL, 'G3DSA:1.10.600.10:FF:000008', NULL, NULL, 'Farnesyl pyrophosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(202201, NULL, 'G3DSA:2.130.10.10:FF:003080', NULL, NULL, 'Lethal(2) giant larvae protein-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(202202, NULL, 'G3DSA:2.60.40.420:FF:000139', NULL, NULL, 'Protein CBG16448', NULL, NULL, NULL, NULL, NULL, 4),
(202203, NULL, 'G3DSA:1.25.40.10:FF:002589', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(202204, NULL, 'G3DSA:1.10.150.170:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202205, NULL, 'G3DSA:3.40.390.10:FF:000134', NULL, NULL, 'Protein CBG01792', NULL, NULL, NULL, NULL, NULL, 4),
(202206, NULL, 'G3DSA:3.40.50.2300:FF:001110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202207, NULL, 'G3DSA:2.60.40.10:FF:003113', NULL, NULL, 'Fibronectin_type_III_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(202208, NULL, 'G3DSA:3.30.160.60:FF:001522', NULL, NULL, 'zinc finger protein 784', NULL, NULL, NULL, NULL, NULL, 4),
(202209, NULL, 'G3DSA:3.90.640.10:FF:000204', NULL, NULL, 'Putative heat shock 70 kDa protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(202210, NULL, 'G3DSA:2.130.10.10:FF:002798', NULL, NULL, 'YALI0B10890p', NULL, NULL, NULL, NULL, NULL, 4),
(202211, NULL, 'G3DSA:1.10.260.80:FF:000002', NULL, NULL, 'YOR131C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(202212, NULL, 'G3DSA:1.25.40.10:FF:003213', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g09650, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(202213, NULL, 'G3DSA:2.60.40.10:FF:005237', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202214, NULL, 'G3DSA:3.30.450.20:FF:000554', NULL, NULL, 'Phosphate regulon sensor histidine kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202215, NULL, 'G3DSA:3.10.28.10:FF:000049', NULL, NULL, 'Intron-encoded DNA endonuclease aI5 beta', NULL, NULL, NULL, NULL, NULL, 4),
(202216, NULL, 'G3DSA:2.60.40.2610:FF:000007', NULL, NULL, 'Protein CsuD', NULL, NULL, NULL, NULL, NULL, 4),
(202217, NULL, 'G3DSA:1.10.8.60:FF:000223', NULL, NULL, 'Recombination factor protein RarA', NULL, NULL, NULL, NULL, NULL, 4),
(202218, NULL, 'G3DSA:1.25.10.10:FF:000963', NULL, NULL, 'Protein VAC14-like protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(202219, NULL, 'G3DSA:2.130.10.10:FF:003422', NULL, NULL, 'intraflagellar transport protein 140 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(202220, NULL, 'G3DSA:1.20.1250.20:FF:000514', NULL, NULL, 'SLC (SoLute Carrier) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(202221, NULL, 'G3DSA:1.20.990.10:FF:000040', NULL, NULL, 'Nitric oxide synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202222, NULL, 'G3DSA:3.40.50.80:FF:000159', NULL, NULL, 'Iron import ATP-binding/permease protein IrtA', NULL, NULL, NULL, NULL, NULL, 4),
(202223, NULL, 'G3DSA:3.20.190.10:FF:000011', NULL, NULL, 'Putative formamidopyrimidine-DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(202224, NULL, 'G3DSA:1.10.287.130:FF:000023', NULL, NULL, 'Sensor histidine kinase/response regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202225, NULL, 'G3DSA:3.40.1110.10:FF:000017', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(202226, NULL, 'G3DSA:3.40.50.1000:FF:000776', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202227, NULL, 'G3DSA:3.30.70.270:FF:000261', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202228, NULL, 'G3DSA:3.40.50.1820:FF:000235', NULL, NULL, 'Cutinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(202229, NULL, 'G3DSA:1.25.40.180:FF:000235', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202230, NULL, 'G3DSA:1.10.510.10:FF:004397', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202231, NULL, 'G3DSA:2.160.20.10:FF:000139', NULL, NULL, 'Putative pectinesterase 52', NULL, NULL, NULL, NULL, NULL, 4),
(202232, NULL, 'G3DSA:3.90.1150.10:FF:000166', NULL, NULL, 'Kynurenine/alpha-aminoadipate aminotransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(202233, NULL, 'G3DSA:3.20.20.100:FF:000045', NULL, NULL, 'Aldo-keto reductase (AKR), putative', NULL, NULL, NULL, NULL, NULL, 4),
(202234, NULL, 'G3DSA:3.30.2090.10:FF:000028', NULL, NULL, 'Efflux pump membrane transporter', NULL, NULL, NULL, NULL, NULL, 4),
(202235, NULL, 'G3DSA:3.30.1410.10:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202236, NULL, 'G3DSA:1.10.10.60:FF:000988', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202237, NULL, 'G3DSA:2.60.120.260:FF:000387', NULL, NULL, 'Cellulose 1,4-beta-cellobiosidase', NULL, NULL, NULL, NULL, NULL, 4),
(202238, NULL, 'G3DSA:1.10.220.30:FF:000018', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(202239, NULL, 'G3DSA:1.25.40.10:FF:004736', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202240, NULL, 'G3DSA:3.40.50.2300:FF:000834', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202241, NULL, 'G3DSA:3.30.40.10:FF:000762', NULL, NULL, 'Zinc finger, C3HC4 type family protein', NULL, NULL, NULL, NULL, NULL, 4),
(202242, NULL, 'G3DSA:1.20.1070.10:FF:000306', NULL, NULL, 'Adrenocorticotropic hormone receptor', NULL, NULL, NULL, NULL, NULL, 4),
(202243, NULL, 'G3DSA:2.60.40.10:FF:004967', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202244, NULL, 'G3DSA:3.40.250.10:FF:000062', NULL, NULL, 'Thiosulfate sulfurtransferase 16, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(202245, NULL, 'G3DSA:1.10.3430.10:FF:000028', NULL, NULL, 'Ammonium Transporter Family protein', NULL, NULL, NULL, NULL, NULL, 4),
(202246, NULL, 'G3DSA:3.10.330.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202247, NULL, 'G3DSA:1.25.40.10:FF:005006', NULL, NULL, 'Tetratricopeptide repeat domain 21A', NULL, NULL, NULL, NULL, NULL, 4),
(202248, NULL, 'G3DSA:2.130.10.10:FF:001275', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(202249, NULL, 'G3DSA:1.25.40.420:FF:000009', NULL, NULL, 'Kelch-like protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(202250, NULL, 'G3DSA:3.40.228.10:FF:000027', NULL, NULL, 'NADH-quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(202251, NULL, 'G3DSA:3.30.465.10:FF:000035', NULL, NULL, 'L-gulonolactone oxidase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(202252, NULL, 'G3DSA:1.10.10.60:FF:001264', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202253, NULL, 'G3DSA:2.130.10.10:FF:001623', NULL, NULL, 'Protein NEDD1', NULL, NULL, NULL, NULL, NULL, 4),
(202254, NULL, 'G3DSA:3.40.50.10190:FF:000081', NULL, NULL, 'BRCA1 C Terminus domain containing protein expressed', NULL, NULL, NULL, NULL, NULL, 4),
(202255, NULL, 'G3DSA:3.90.870.10:FF:000013', NULL, NULL, 'Sua5/YciO/YrdC/YwlC family protein', NULL, NULL, NULL, NULL, NULL, 4),
(202256, NULL, 'G3DSA:3.30.200.110:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202257, NULL, 'G3DSA:3.10.580.10:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202258, NULL, 'G3DSA:2.40.50.140:FF:000309', NULL, NULL, 'Exosome complex exonuclease DIS3', NULL, NULL, NULL, NULL, NULL, 4),
(202259, NULL, 'G3DSA:3.40.50.1820:FF:000342', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(202260, NULL, 'G3DSA:2.60.40.10:FF:003220', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202261, NULL, 'G3DSA:3.40.850.10:FF:000265', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(202262, NULL, 'G3DSA:1.10.287.130:FF:000130', NULL, NULL, 'Signal transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(202263, NULL, 'G3DSA:2.40.50.140:FF:000753', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202264, NULL, 'G3DSA:1.25.40.10:FF:004843', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(202265, NULL, 'G3DSA:1.10.150.60:FF:000022', NULL, NULL, 'High mobility group B protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(202266, NULL, 'G3DSA:2.60.40.10:FF:000696', NULL, NULL, 'tyrosine-protein kinase receptor UFO isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(202267, NULL, 'G3DSA:1.10.238.10:FF:000767', NULL, NULL, 'Centrin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202268, NULL, 'G3DSA:3.80.10.10:FF:003496', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202269, NULL, 'G3DSA:1.10.510.10:FF:003222', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202270, NULL, 'G3DSA:3.40.50.12780:FF:000234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202271, NULL, 'G3DSA:1.20.58.400:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202272, NULL, 'G3DSA:2.130.10.10:FF:000999', NULL, NULL, 'SH3KBP1-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(202273, NULL, 'G3DSA:3.30.160.70:FF:000002', NULL, NULL, 'Bifunctional transcriptional activator/DNA repair enzyme Ada', NULL, NULL, NULL, NULL, NULL, 4),
(202274, NULL, 'G3DSA:3.10.20.230:FF:000007', NULL, NULL, 'Oxygen-regulated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(202275, NULL, 'G3DSA:2.120.10.80:FF:000397', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202276, NULL, 'G3DSA:2.60.120.180:FF:000003', NULL, NULL, 'Probable cellulase celA2b', NULL, NULL, NULL, NULL, NULL, 4),
(202277, NULL, 'G3DSA:3.30.70.660:FF:000052', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(202278, NULL, 'G3DSA:3.30.70.1230:FF:000111', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(202279, NULL, 'G3DSA:2.60.120.260:FF:000494', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202280, NULL, 'G3DSA:3.30.1330.40:FF:000051', NULL, NULL, 'YALI0F14553p', NULL, NULL, NULL, NULL, NULL, 4),
(202281, NULL, 'G3DSA:1.10.472.10:FF:000474', NULL, NULL, 'Cyclin-D1-1', NULL, NULL, NULL, NULL, NULL, 4),
(202282, NULL, 'G3DSA:1.20.1250.20:FF:000621', NULL, NULL, 'AmpG permease', NULL, NULL, NULL, NULL, NULL, 4),
(202283, NULL, 'G3DSA:1.10.1040.10:FF:000071', NULL, NULL, 'ApbA-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(202284, NULL, 'G3DSA:3.10.250.10:FF:000102', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202285, NULL, 'G3DSA:3.30.710.10:FF:000044', NULL, NULL, 'BTB/POZ domain-containing protein KCTD9 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(202286, NULL, 'G3DSA:1.10.238.10:FF:001043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(202287, NULL, 'G3DSA:3.40.50.300:FF:003821', NULL, NULL, 'Sugar ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(202288, NULL, 'G3DSA:1.25.40.20:FF:001850', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202289, NULL, 'G3DSA:6.20.50.160:FF:000001', NULL, NULL, 'Complement component 4', NULL, NULL, NULL, NULL, NULL, 4),
(202290, NULL, 'G3DSA:2.60.120.200:FF:000392', NULL, NULL, 'Glycoside hydrolase family 16 protein', NULL, NULL, NULL, NULL, NULL, 4),
(202291, NULL, 'G3DSA:3.80.10.10:FF:004120', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(202292, NULL, 'G3DSA:1.10.4160.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202293, NULL, 'G3DSA:2.20.70.10:FF:000076', NULL, NULL, 'Polyglutamine-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(202294, NULL, 'G3DSA:3.80.10.10:FF:003844', NULL, NULL, 'PH domain and leucine-rich repeat protein phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(202295, NULL, 'G3DSA:3.40.50.1820:FF:000903', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202296, NULL, 'G3DSA:3.40.50.1820:FF:001865', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202297, NULL, 'G3DSA:3.40.50.1000:FF:000883', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202298, NULL, 'G3DSA:1.10.510.10:FF:002598', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202299, NULL, 'G3DSA:3.80.10.10:FF:001927', NULL, NULL, 'Tubulin folding cofactor E', NULL, NULL, NULL, NULL, NULL, 4),
(202300, NULL, 'G3DSA:3.30.710.10:FF:000482', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(202301, NULL, 'G3DSA:1.10.225.10:FF:000001', NULL, NULL, 'Aspartic proteinase A1', NULL, NULL, NULL, NULL, NULL, 4),
(202302, NULL, 'G3DSA:2.60.40.10:FF:002489', NULL, NULL, 'Conserved repeat domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(202303, NULL, 'G3DSA:2.60.40.420:FF:000246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202304, NULL, 'G3DSA:3.30.200.20:FF:000750', NULL, NULL, 'Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(202305, NULL, 'G3DSA:1.10.10.10:FF:000895', NULL, NULL, 'O-methyltransferase 9', NULL, NULL, NULL, NULL, NULL, 4),
(202306, NULL, 'G3DSA:3.10.20.90:FF:000696', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(202307, NULL, 'G3DSA:2.20.70.10:FF:000183', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(202308, NULL, 'G3DSA:2.10.110.10:FF:000158', NULL, NULL, 'LIM/homeobox protein ttx-3', NULL, NULL, NULL, NULL, NULL, 4),
(202309, NULL, 'G3DSA:3.80.10.10:FF:003389', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(202310, NULL, 'G3DSA:1.10.565.10:FF:000032', NULL, NULL, 'Nuclear hormone receptor FTZ-F1', NULL, NULL, NULL, NULL, NULL, 4),
(202311, NULL, 'G3DSA:1.25.40.10:FF:002937', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202312, NULL, 'G3DSA:2.40.128.180:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202313, NULL, 'G3DSA:2.30.30.100:FF:000037', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm6', NULL, NULL, NULL, NULL, NULL, 4),
(202314, NULL, 'G3DSA:2.120.10.30:FF:000298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202315, NULL, 'G3DSA:3.30.420.40:FF:001014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202316, NULL, 'G3DSA:3.90.20.20:FF:000025', NULL, NULL, 'Protein GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(202317, NULL, 'G3DSA:3.40.50.300:FF:003035', NULL, NULL, 'ABC transporter AbcH.1', NULL, NULL, NULL, NULL, NULL, 4),
(202318, NULL, 'G3DSA:3.30.1490.20:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202319, NULL, 'G3DSA:3.30.40.10:FF:000436', NULL, NULL, 'Chromatin modification-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(202320, NULL, 'G3DSA:3.40.50.1110:FF:000005', NULL, NULL, 'Phospholipase B1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(202321, NULL, 'G3DSA:3.40.50.1100:FF:000002', NULL, NULL, 'Cysteine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(202322, NULL, 'G3DSA:3.30.70.330:FF:002903', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202323, NULL, 'G3DSA:3.30.450.20:FF:000228', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(202324, NULL, 'G3DSA:3.80.10.10:FF:002203', NULL, NULL, 'Toll-4', NULL, NULL, NULL, NULL, NULL, 4),
(202325, NULL, 'G3DSA:3.40.50.150:FF:001270', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202326, NULL, 'G3DSA:2.30.42.10:FF:000443', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202327, NULL, 'G3DSA:1.20.5.190:FF:000158', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202328, NULL, 'G3DSA:2.30.42.10:FF:000095', NULL, NULL, 'Zinc metalloprotease', NULL, NULL, NULL, NULL, NULL, 4),
(202329, NULL, 'G3DSA:3.80.10.10:FF:002085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202330, NULL, 'G3DSA:1.25.40.1040:FF:000041', NULL, NULL, 'mRNA 3''-end-processing protein rna14', NULL, NULL, NULL, NULL, NULL, 4),
(202331, NULL, 'G3DSA:1.25.40.10:FF:000791', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(202332, NULL, 'G3DSA:3.40.50.300:FF:002759', NULL, NULL, 'GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202333, NULL, 'G3DSA:1.20.1740.10:FF:000144', NULL, NULL, 'Solute carrier family 38 member 3', NULL, NULL, NULL, NULL, NULL, 4),
(202334, NULL, 'G3DSA:1.10.510.10:FF:003093', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202335, NULL, 'G3DSA:1.50.40.10:FF:000041', NULL, NULL, 'Mitochondrial substrate carrier family protein', NULL, NULL, NULL, NULL, NULL, 4),
(202336, NULL, 'G3DSA:2.60.120.200:FF:000734', NULL, NULL, 'L-type lectin-like domain-containing protein C4F6.05c', NULL, NULL, NULL, NULL, NULL, 4),
(202337, NULL, 'G3DSA:1.10.3450.40:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202338, NULL, 'G3DSA:2.60.120.650:FF:000066', NULL, NULL, 'lysine-specific demethylase 8-like', NULL, NULL, NULL, NULL, NULL, 4),
(202339, NULL, 'G3DSA:1.25.10.10:FF:003043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202340, NULL, 'G3DSA:2.40.240.10:FF:000003', NULL, NULL, 'Glutamine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(202341, NULL, 'G3DSA:3.40.50.11960:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202342, NULL, 'G3DSA:3.10.110.10:FF:000289', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(202343, NULL, 'G3DSA:3.40.50.1260:FF:000022', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(202344, NULL, 'G3DSA:1.10.472.10:FF:000693', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202345, NULL, 'G3DSA:3.40.30.10:FF:000401', NULL, NULL, 'Glutathione S-transferase theta 1', NULL, NULL, NULL, NULL, NULL, 4),
(202346, NULL, 'G3DSA:3.30.2450.30:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202347, NULL, 'G3DSA:3.30.40.10:FF:000088', NULL, NULL, 'E3 ubiquitin-protein ligase synoviolin', NULL, NULL, NULL, NULL, NULL, 4),
(202348, NULL, 'G3DSA:3.40.50.300:FF:007306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202349, NULL, 'G3DSA:2.60.40.4100:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202350, NULL, 'G3DSA:2.40.50.910:FF:000001', NULL, NULL, 'ESX-1 secretion system ATPase EccB1', NULL, NULL, NULL, NULL, NULL, 4),
(202351, NULL, 'G3DSA:3.40.50.300:FF:007183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202352, NULL, 'G3DSA:1.20.58.60:FF:000238', NULL, NULL, 'Muscle-specific protein 300 kDa, isoform I', NULL, NULL, NULL, NULL, NULL, 4),
(202353, NULL, 'G3DSA:3.40.50.11950:FF:000002', NULL, NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(202354, NULL, 'G3DSA:2.60.120.260:FF:000168', NULL, NULL, 'F-box only protein 6-like Protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(202355, NULL, 'G3DSA:1.10.287.70:FF:000712', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202356, NULL, 'G3DSA:3.40.50.1820:FF:000561', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(202357, NULL, 'G3DSA:2.40.240.20:FF:000006', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4),
(202358, NULL, 'G3DSA:3.40.50.300:FF:006694', NULL, NULL, 'Meiotic recombination protein DMC1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(202359, NULL, 'G3DSA:1.10.510.10:FF:001187', NULL, NULL, 'Tyrosine-protein kinase ITK/TSK', NULL, NULL, NULL, NULL, NULL, 4),
(202360, NULL, 'G3DSA:1.20.1560.10:FF:000158', NULL, NULL, 'Cysteine ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(202361, NULL, 'G3DSA:3.40.50.200:FF:000121', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(202362, NULL, 'G3DSA:3.30.70.330:FF:000649', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(202363, NULL, 'G3DSA:1.20.58.90:FF:000005', NULL, NULL, 'centrosomal protein CEP57L1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(202364, NULL, 'G3DSA:1.20.58.60:FF:000457', NULL, NULL, 'AGAP009554-PA', NULL, NULL, NULL, NULL, NULL, 4),
(202365, NULL, 'G3DSA:2.20.150.10:FF:000001', NULL, NULL, '5-dehydro-2-deoxygluconokinase', NULL, NULL, NULL, NULL, NULL, 4),
(202366, NULL, 'G3DSA:3.90.550.50:FF:000086', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(202367, NULL, 'G3DSA:1.25.40.10:FF:004517', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202368, NULL, 'G3DSA:3.90.45.10:FF:000006', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(202369, NULL, 'G3DSA:3.40.850.10:FF:000484', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(202370, NULL, 'G3DSA:2.130.10.10:FF:002579', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(202371, NULL, 'G3DSA:1.25.40.10:FF:003090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202372, NULL, 'G3DSA:3.30.160.60:FF:003107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202373, NULL, 'G3DSA:1.10.274.100:FF:000033', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(202374, NULL, 'G3DSA:3.30.200.20:FF:001020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(202375, NULL, 'G3DSA:1.20.1070.10:FF:000177', NULL, NULL, 'probable G-protein coupled receptor 52', NULL, NULL, NULL, NULL, NULL, 4),
(202376, NULL, 'G3DSA:1.20.1050.10:FF:000288', NULL, NULL, 'Safener induced1', NULL, NULL, NULL, NULL, NULL, 4),
(202377, NULL, 'G3DSA:3.30.2320.30:FF:000002', NULL, NULL, 'V-type proton ATPase subunit E3', NULL, NULL, NULL, NULL, NULL, 4),
(202378, NULL, 'G3DSA:3.30.200.20:FF:002548', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202379, NULL, 'G3DSA:1.20.1070.10:FF:001936', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(202380, NULL, 'G3DSA:3.40.50.1820:FF:000016', NULL, NULL, 'Dipeptidyl peptidase 8-like isoform', NULL, NULL, NULL, NULL, NULL, 4),
(202381, NULL, 'G3DSA:4.10.75.20:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202382, NULL, 'G3DSA:1.20.960.20:FF:000002', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(202383, NULL, 'G3DSA:2.130.10.10:FF:003203', NULL, NULL, 'Pre-mRNA-splicing factor RSE1', NULL, NULL, NULL, NULL, NULL, 4),
(202384, NULL, 'G3DSA:2.30.40.10:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202385, NULL, 'G3DSA:3.40.50.300:FF:002978', NULL, NULL, 'Putative multidrug resistance-associated protein lethal(2)03659-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(202386, NULL, 'G3DSA:1.25.40.570:FF:000026', NULL, NULL, 'COP9 signalosome complex subunit 2 isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(202387, NULL, 'G3DSA:1.25.40.20:FF:000001', NULL, NULL, 'Ankyrin-2 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(202388, NULL, 'G3DSA:3.90.190.10:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(202389, NULL, 'G3DSA:1.20.1070.10:FF:000525', NULL, NULL, 'AGAP002566-PA', NULL, NULL, NULL, NULL, NULL, 4),
(202390, NULL, 'G3DSA:3.40.50.1820:FF:000780', NULL, NULL, 'Putative serine hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(202391, NULL, 'G3DSA:1.10.1030.10:FF:000020', NULL, NULL, 'Carbamoyl-phosphate synthase large chain, C-terminal section', NULL, NULL, NULL, NULL, NULL, 4),
(202392, NULL, 'G3DSA:1.10.640.10:FF:000011', NULL, NULL, 'Alpha-dioxygenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(202393, NULL, 'G3DSA:1.25.40.10:FF:003432', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g04860', NULL, NULL, NULL, NULL, NULL, 4),
(202394, NULL, 'G3DSA:3.60.10.10:FF:000124', NULL, NULL, 'Endonuclease/exonuclease/phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(202395, NULL, 'G3DSA:3.40.50.300:FF:001348', NULL, NULL, 'Ras and EF-hand domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(202396, NULL, 'G3DSA:3.30.230.10:FF:000237', NULL, NULL, 'AaceriAEL124Wp', NULL, NULL, NULL, NULL, NULL, 4),
(202397, NULL, 'G3DSA:1.20.120.420:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202398, NULL, 'G3DSA:1.20.1270.60:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202399, NULL, 'G3DSA:2.170.300.10:FF:000040', NULL, NULL, 'Platelet endothelial aggregation receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(202400, NULL, 'G3DSA:3.80.10.10:FF:000842', NULL, NULL, 'Receptor protein kinase CLAVATA1', NULL, NULL, NULL, NULL, NULL, 4),
(202401, NULL, 'G3DSA:3.40.50.2000:FF:000289', NULL, NULL, 'UDP-N-acetylglucosamine transferase subunit ALG14', NULL, NULL, NULL, NULL, NULL, 4),
(202402, NULL, 'G3DSA:3.30.70.330:FF:002336', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202403, NULL, 'G3DSA:1.10.10.10:FF:001165', NULL, NULL, 'Carbohydrate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(202404, NULL, 'G3DSA:1.10.510.10:FF:003441', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202405, NULL, 'G3DSA:3.30.360.20:FF:000002', NULL, NULL, 'RNA terminal phosphate cyclase-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(202406, NULL, 'G3DSA:1.20.90.10:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202407, NULL, 'G3DSA:3.10.129.10:FF:000091', NULL, NULL, 'Esterase YdiI', NULL, NULL, NULL, NULL, NULL, 4),
(202408, NULL, 'G3DSA:3.30.413.10:FF:000027', NULL, NULL, 'Sulfite reductase (NADPH)', NULL, NULL, NULL, NULL, NULL, 4),
(202409, NULL, 'G3DSA:1.10.10.10:FF:001507', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(202410, NULL, 'G3DSA:3.40.50.720:FF:002317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202411, NULL, 'G3DSA:3.30.342.10:FF:000053', NULL, NULL, 'DNA polymerase epsilon catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(202412, NULL, 'G3DSA:3.30.710.10:FF:000263', NULL, NULL, 'Rho related BTB domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(202413, NULL, 'G3DSA:1.10.10.160:FF:000003', NULL, NULL, 'RecBCD enzyme subunit RecC', NULL, NULL, NULL, NULL, NULL, 4),
(202414, NULL, 'G3DSA:3.40.30.10:FF:001138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202415, NULL, 'G3DSA:2.60.120.200:FF:000515', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202416, NULL, 'G3DSA:1.10.720.30:FF:000040', NULL, NULL, 'DNA-(apurinic or apyrimidinic site) lyase', NULL, NULL, NULL, NULL, NULL, 4),
(202417, NULL, 'G3DSA:2.60.260.40:FF:000003', NULL, NULL, 'NADH dehydrogenase [ubiquinone] iron-sulfur protein 6, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(202418, NULL, 'G3DSA:3.30.70.1350:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202419, NULL, 'G3DSA:1.10.287.810:FF:000013', NULL, NULL, 'Mitochondrial GE17372', NULL, NULL, NULL, NULL, NULL, 4),
(202420, NULL, 'G3DSA:1.25.40.20:FF:001631', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202421, NULL, 'G3DSA:2.60.40.150:FF:000598', NULL, NULL, 'Ras GTPase-activating protein gap-2', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(202422, NULL, 'G3DSA:3.40.50.620:FF:000814', NULL, NULL, 'Tyrosyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(202423, NULL, 'G3DSA:3.30.9.10:FF:000021', NULL, NULL, 'L-2-hydroxyglutarate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(202424, NULL, 'G3DSA:1.20.1250.20:FF:000840', NULL, NULL, 'VBA4p protein', NULL, NULL, NULL, NULL, NULL, 4),
(202425, NULL, 'G3DSA:2.40.50.140:FF:000186', NULL, NULL, 'ATP-dependent DNA helicase RecG', NULL, NULL, NULL, NULL, NULL, 4),
(202426, NULL, 'G3DSA:1.10.472.10:FF:000249', NULL, NULL, 'Tumor suppressor p130, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202427, NULL, 'G3DSA:2.40.50.140:FF:000528', NULL, NULL, 'Putative asparaginyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(202428, NULL, 'G3DSA:3.30.70.920:FF:000057', NULL, NULL, '74aa long hypothetical transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(202429, NULL, 'G3DSA:3.60.10.10:FF:000343', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202430, NULL, 'G3DSA:3.40.50.2300:FF:001222', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202431, NULL, 'G3DSA:1.10.10.60:FF:000882', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202432, NULL, 'G3DSA:1.20.1050.10:FF:000069', NULL, NULL, 'Putative elongation factor 1-gamma', NULL, NULL, NULL, NULL, NULL, 4),
(202433, NULL, 'G3DSA:1.20.5.170:FF:000039', NULL, NULL, 'Autophagy-related protein 16-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(202434, NULL, 'G3DSA:3.40.190.80:FF:000004', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(202435, NULL, 'G3DSA:2.60.40.10:FF:005131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202436, NULL, 'G3DSA:3.30.1140.32:FF:000007', NULL, NULL, '30S ribosomal protein S3', NULL, NULL, NULL, NULL, NULL, 4),
(202437, NULL, 'G3DSA:1.10.1030.10:FF:000019', NULL, NULL, 'Carbamoyl-phosphate synthase large chain, N-terminal section', NULL, NULL, NULL, NULL, NULL, 4),
(202438, NULL, 'G3DSA:2.40.50.140:FF:000534', NULL, NULL, 'Aspartyl-tRNA synthetase, cytoplasmic, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202439, NULL, 'G3DSA:3.90.150.10:FF:000009', NULL, NULL, 'Expression site-associated gene (ESAG) protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202440, NULL, 'G3DSA:1.20.58.1030:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202441, NULL, 'G3DSA:3.30.160.60:FF:001292', NULL, NULL, 'zinc finger protein 181 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(202442, NULL, 'G3DSA:1.20.58.60:FF:000019', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(202443, NULL, 'G3DSA:3.80.10.10:FF:000281', NULL, NULL, 'Leucine-rich repeat protein soc-2', NULL, NULL, NULL, NULL, NULL, 4),
(202444, NULL, 'G3DSA:1.10.510.10:FF:002379', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202445, NULL, 'G3DSA:3.20.20.100:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202446, NULL, 'G3DSA:3.90.228.20:FF:000002', NULL, NULL, 'phosphoenolpyruvate carboxykinase, cytosolic [GTP]', NULL, NULL, NULL, NULL, NULL, 4),
(202447, NULL, 'G3DSA:1.20.1250.20:FF:000402', NULL, NULL, '3-(3-hydroxy-phenyl)propionate transporter MhpT', NULL, NULL, NULL, NULL, NULL, 4),
(202448, NULL, 'G3DSA:3.30.43.40:FF:000002', NULL, NULL, 'U5 snRNA-associated splicing factor', NULL, NULL, NULL, NULL, NULL, 4),
(202449, NULL, 'G3DSA:2.30.30.140:FF:000021', NULL, NULL, 'Tumor suppressor p53-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(202450, NULL, 'G3DSA:3.40.50.970:FF:000009', NULL, NULL, 'Pyruvate dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(202451, NULL, 'G3DSA:3.30.1300.30:FF:000001', NULL, NULL, 'Immunoglobulin-binding protein from prophage P-EibD', NULL, NULL, NULL, NULL, NULL, 4),
(202452, NULL, 'G3DSA:2.40.30.270:FF:000007', NULL, NULL, 'DNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202453, NULL, 'G3DSA:3.30.40.10:FF:000543', NULL, NULL, 'S-ribonuclease binding protein SBP1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(202454, NULL, 'G3DSA:2.60.120.290:FF:000036', NULL, NULL, 'Suppressor of tumorigenicity 14 protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(202455, NULL, 'G3DSA:3.40.50.960:FF:000006', NULL, NULL, '6,7-dimethyl-8-ribityllumazine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(202456, NULL, 'G3DSA:2.130.10.10:FF:002927', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202457, NULL, 'G3DSA:2.60.120.590:FF:000025', NULL, NULL, 'Alpha-ketoglutarate-dependent dioxygenase AlkB', NULL, NULL, NULL, NULL, NULL, 4),
(202458, NULL, 'G3DSA:3.30.420.140:FF:000015', NULL, NULL, 'Putative pre-16S rRNA nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(202459, NULL, 'G3DSA:3.30.300.30:FF:000120', NULL, NULL, 'Probable L-prolyl-AMP ligase PigI', NULL, NULL, NULL, NULL, NULL, 4),
(202460, NULL, 'G3DSA:3.30.230.10:FF:000349', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(202461, NULL, 'G3DSA:1.10.340.30:FF:000073', NULL, NULL, 'Endonuclease III', NULL, NULL, NULL, NULL, NULL, 4),
(202462, NULL, 'G3DSA:1.25.40.10:FF:001302', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g53360, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(202463, NULL, 'G3DSA:3.40.47.10:FF:000272', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202464, NULL, 'G3DSA:1.20.1560.10:FF:000046', NULL, NULL, 'ATP-binding cassette subfamily B member 11', NULL, NULL, NULL, NULL, NULL, 4),
(202465, NULL, 'G3DSA:3.30.70.850:FF:000007', NULL, NULL, 'Neuroendocrine convertase 2', NULL, NULL, NULL, NULL, NULL, 4),
(202466, NULL, 'G3DSA:3.20.20.80:FF:000158', NULL, NULL, 'Exported alpha-L-fucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(202467, NULL, 'G3DSA:1.10.1380.10:FF:000006', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(202468, NULL, 'G3DSA:1.10.150.120:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202469, NULL, 'G3DSA:3.40.50.300:FF:007531', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202470, NULL, 'G3DSA:3.30.200.20:FF:000856', NULL, NULL, 'Kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202471, NULL, 'G3DSA:1.25.40.20:FF:001305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202472, NULL, 'G3DSA:3.30.310.80:FF:000039', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(202473, NULL, 'G3DSA:1.10.260.30:FF:000015', NULL, NULL, 'Signal recognition particle 54 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(202474, NULL, 'G3DSA:3.30.160.60:FF:002489', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202475, NULL, 'G3DSA:2.30.42.10:FF:000218', NULL, NULL, 'PDZ domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(202476, NULL, 'G3DSA:3.40.50.11260:FF:000003', NULL, NULL, 'Heat shock protein 90', NULL, NULL, NULL, NULL, NULL, 4),
(202477, NULL, 'G3DSA:3.40.50.300:FF:003260', NULL, NULL, '3''-5'' exonuclease DinG', NULL, NULL, NULL, NULL, NULL, 4),
(202478, NULL, 'G3DSA:1.20.1050.10:FF:000182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202479, NULL, 'G3DSA:3.40.50.300:FF:004783', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(202480, NULL, 'G3DSA:3.10.450.50:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202481, NULL, 'G3DSA:1.20.1070.10:FF:000183', NULL, NULL, 'Urotensin-2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(202482, NULL, 'G3DSA:3.30.160.60:FF:003433', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202483, NULL, 'G3DSA:3.30.420.10:FF:000055', NULL, NULL, 'RNA exonuclease 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(202484, NULL, 'G3DSA:3.40.50.2000:FF:000632', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(202485, NULL, 'G3DSA:3.80.10.10:FF:004226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202486, NULL, 'G3DSA:4.10.270.10:FF:000010', NULL, NULL, 'Type II myosin heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(202487, NULL, 'G3DSA:1.10.150.710:FF:000001', NULL, NULL, 'Glutamate--cysteine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(202488, NULL, 'G3DSA:3.30.300.10:FF:000001', NULL, NULL, 'S-adenosylmethionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(202489, NULL, 'G3DSA:3.40.50.2300:FF:000621', NULL, NULL, 'Vomeronasal 2, receptor 83', NULL, NULL, NULL, NULL, NULL, 4),
(202490, NULL, 'G3DSA:3.40.50.360:FF:000034', NULL, NULL, 'NADPH-dependent diflavin oxidoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(202491, NULL, 'G3DSA:1.10.260.40:FF:000018', NULL, NULL, 'Multiprotein bridging factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(202492, NULL, 'G3DSA:3.90.1750.20:FF:000006', NULL, NULL, 'Site-specific recombinase', NULL, NULL, NULL, NULL, NULL, 4),
(202493, NULL, 'G3DSA:3.10.129.10:FF:000214', NULL, NULL, 'Thioesterase superfamily, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202494, NULL, 'G3DSA:3.30.300.20:FF:000004', NULL, NULL, 'GTPase Der', NULL, NULL, NULL, NULL, NULL, 4),
(202495, NULL, 'G3DSA:1.20.5.170:FF:000152', NULL, NULL, 'Yap3p', NULL, NULL, NULL, NULL, NULL, 4),
(202496, NULL, 'G3DSA:2.10.25.10:FF:001377', NULL, NULL, 'Growth arrest-specific 6', NULL, NULL, NULL, NULL, NULL, 4),
(202497, NULL, 'G3DSA:3.40.20.10:FF:000007', NULL, NULL, 'Twinfilin-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(202498, NULL, 'G3DSA:3.40.50.360:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202499, NULL, 'G3DSA:3.30.420.10:FF:000162', NULL, NULL, 'Mitochondrial DNA polymerase I protein D, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202500, NULL, 'G3DSA:2.60.40.10:FF:001527', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(202501, NULL, 'G3DSA:1.10.287.130:FF:000129', NULL, NULL, 'Two-component sensor, ParS', NULL, NULL, NULL, NULL, NULL, 4),
(202502, NULL, 'G3DSA:2.40.10.10:FF:000689', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202503, NULL, 'G3DSA:3.90.660.10:FF:000082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202504, NULL, 'G3DSA:1.25.40.20:FF:001288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202505, NULL, 'G3DSA:3.40.50.720:FF:000064', NULL, NULL, 'Pyrroline-5-carboxylate reductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(202506, NULL, 'G3DSA:2.30.29.170:FF:000016', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(202507, NULL, 'G3DSA:1.20.1510.10:FF:000099', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202508, NULL, 'G3DSA:3.30.300.30:FF:000007', NULL, NULL, '4-coumarate--CoA ligase 2', NULL, NULL, NULL, NULL, NULL, 4),
(202509, NULL, 'G3DSA:3.20.20.80:FF:000265', NULL, NULL, 'Chitinase putative', NULL, NULL, NULL, NULL, NULL, 4),
(202510, NULL, 'G3DSA:2.40.50.140:FF:000860', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202511, NULL, 'G3DSA:1.20.1070.10:FF:001020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202512, NULL, 'G3DSA:3.10.129.10:FF:000107', NULL, NULL, 'Acyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(202513, NULL, 'G3DSA:3.40.50.410:FF:000072', NULL, NULL, 'collagen alpha-1(VII) chain', NULL, NULL, NULL, NULL, NULL, 4),
(202514, NULL, 'G3DSA:3.40.50.1970:FF:000027', NULL, NULL, 'Iron-containing alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(202515, NULL, 'G3DSA:3.30.200.20:FF:000637', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(202516, NULL, 'G3DSA:3.40.50.2000:FF:000413', NULL, NULL, 'UDP-N-acetylglucosamine transferase subunit ALG14', NULL, NULL, NULL, NULL, NULL, 4),
(202517, NULL, 'G3DSA:3.30.2230.10:FF:000017', NULL, NULL, 'Putative ubiquitin-hydrolase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(202518, NULL, 'G3DSA:3.30.40.10:FF:000324', NULL, NULL, 'E3 ubiquitin-protein ligase RNF125 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(202519, NULL, 'G3DSA:3.90.190.10:FF:000225', NULL, NULL, 'Tyrosine phosphatase family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202520, NULL, 'G3DSA:1.25.40.10:FF:001521', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(202521, NULL, 'G3DSA:2.60.34.10:FF:000075', NULL, NULL, 'Heat shock protein 70E', NULL, NULL, NULL, NULL, NULL, 4),
(202522, NULL, 'G3DSA:3.30.70.330:FF:001032', NULL, NULL, 'Os05g0162600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(202523, NULL, 'G3DSA:3.40.50.300:FF:003147', NULL, NULL, '6-phosphofructo-2-kinase/fructose-2,6-biphosphata se-1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(202524, NULL, 'G3DSA:3.40.50.150:FF:000988', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202525, NULL, 'G3DSA:3.40.50.300:FF:005165', NULL, NULL, 'YALI0F10307p', NULL, NULL, NULL, NULL, NULL, 4),
(202526, NULL, 'G3DSA:3.40.50.12780:FF:000127', NULL, NULL, 'Nonribosomal peptide synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202527, NULL, 'G3DSA:3.40.50.150:FF:001606', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202528, NULL, 'G3DSA:3.30.930.10:FF:000026', NULL, NULL, 'Seryl-tRNA synthetase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(202529, NULL, 'G3DSA:3.30.519.10:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202530, NULL, 'G3DSA:3.30.70.330:FF:002561', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202531, NULL, 'G3DSA:1.20.1740.10:FF:000032', NULL, NULL, 'Tyrosine-specific transport system', NULL, NULL, NULL, NULL, NULL, 4),
(202532, NULL, 'G3DSA:3.30.1010.10:FF:000035', NULL, NULL, 'Phosphatidylinositol 4-kinase PIK1a', NULL, NULL, NULL, NULL, NULL, 4),
(202533, NULL, 'G3DSA:2.70.98.10:FF:000098', NULL, NULL, 'Galactose mutarotase-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(202534, NULL, 'G3DSA:3.90.1640.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202535, NULL, 'G3DSA:1.25.40.20:FF:001524', NULL, NULL, 'Protein 21.1', NULL, NULL, NULL, NULL, NULL, 4),
(202536, NULL, 'G3DSA:2.170.140.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202537, NULL, 'G3DSA:2.130.10.10:FF:005002', NULL, NULL, 'Zinc finger CCCH domain-containing protein 63', NULL, NULL, NULL, NULL, NULL, 4),
(202538, NULL, 'G3DSA:2.40.220.10:FF:000002', NULL, NULL, 'Sialidase B', NULL, NULL, NULL, NULL, NULL, 4),
(202539, NULL, 'G3DSA:3.40.50.2300:FF:000508', NULL, NULL, 'Accessory gene regulator A', NULL, NULL, NULL, NULL, NULL, 4),
(202540, NULL, 'G3DSA:1.10.3450.30:FF:000001', NULL, NULL, 'KICSTOR complex protein C12orf66 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(202541, NULL, 'G3DSA:2.60.40.4100:FF:000016', NULL, NULL, 'uncharacterized protein LOC100177824', NULL, NULL, NULL, NULL, NULL, 4),
(202542, NULL, 'G3DSA:2.60.120.10:FF:000411', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202543, NULL, 'G3DSA:3.30.160.60:FF:001179', NULL, NULL, 'zinc finger protein 621 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(202544, NULL, 'G3DSA:3.40.50.300:FF:007418', NULL, NULL, 'ATP binding cassette subfamily B member 4', NULL, NULL, NULL, NULL, NULL, 4),
(202545, NULL, 'G3DSA:1.20.1070.10:FF:000413', NULL, NULL, 'Relaxin family peptide receptor 3.2b', NULL, NULL, NULL, NULL, NULL, 4),
(202546, NULL, 'G3DSA:3.80.10.10:FF:003838', NULL, NULL, 'Si:ch211-191d15.2', NULL, NULL, NULL, NULL, NULL, 4),
(202547, NULL, 'G3DSA:2.30.30.30:FF:000096', NULL, NULL, '40S ribosomal protein S4', NULL, NULL, NULL, NULL, NULL, 4),
(202548, NULL, 'G3DSA:3.40.50.720:FF:002194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202549, NULL, 'G3DSA:1.10.10.2830:FF:000001', NULL, NULL, 'Chromosome partitioning protein ParB', NULL, NULL, NULL, NULL, NULL, 4),
(202550, NULL, 'G3DSA:3.40.50.300:FF:005401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202551, NULL, 'G3DSA:1.20.1280.290:FF:000055', NULL, NULL, 'PQ loop repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(202552, NULL, 'G3DSA:2.30.29.30:FF:000463', NULL, NULL, 'CCM2 like scaffold protein', NULL, NULL, NULL, NULL, NULL, 4),
(202553, NULL, 'G3DSA:1.10.3450.40:FF:000004', NULL, NULL, 'Signal recognition particle subunit SRP68', NULL, NULL, NULL, NULL, NULL, 4),
(202554, NULL, 'G3DSA:3.40.720.10:FF:000042', NULL, NULL, 'Alkaline-phosphatase-like family protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(202555, NULL, 'G3DSA:3.30.260.10:FF:000065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202556, NULL, 'G3DSA:3.80.10.10:FF:002079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202557, NULL, 'G3DSA:3.60.130.10:FF:000037', NULL, NULL, 'Putative gamma-butyrobetaine dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(202558, NULL, 'G3DSA:1.25.40.10:FF:000914', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(202559, NULL, 'G3DSA:1.20.1250.20:FF:000391', NULL, NULL, 'Large neutral amino acids transporter small subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(202560, NULL, 'G3DSA:1.25.10.10:FF:002986', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202561, NULL, 'G3DSA:3.30.160.60:FF:002596', NULL, NULL, 'Transcriptional repressor CTCF', NULL, NULL, NULL, NULL, NULL, 4),
(202562, NULL, 'G3DSA:1.10.510.10:FF:003216', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202563, NULL, 'G3DSA:1.25.10.10:FF:003150', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(202564, NULL, 'G3DSA:1.10.460.10:FF:000019', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(202565, NULL, 'G3DSA:1.20.1740.10:FF:000251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202566, NULL, 'G3DSA:3.90.1150.10:FF:000379', NULL, NULL, 'Ornithine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(202567, NULL, 'G3DSA:1.20.1070.10:FF:000290', NULL, NULL, 'GG11888', NULL, NULL, NULL, NULL, NULL, 4),
(202568, NULL, 'G3DSA:1.20.80.10:FF:000067', NULL, NULL, 'Fermitin 2', NULL, NULL, NULL, NULL, NULL, 4),
(202569, NULL, 'G3DSA:3.40.50.20:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202570, NULL, 'G3DSA:3.40.630.10:FF:000395', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202571, NULL, 'G3DSA:3.40.50.2000:FF:001014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202572, NULL, 'G3DSA:3.30.420.150:FF:000018', NULL, NULL, 'Probable apyrase 6', NULL, NULL, NULL, NULL, NULL, 4),
(202573, NULL, 'G3DSA:3.20.20.80:FF:000046', NULL, NULL, 'Glucosidase alpha, neutral C', NULL, NULL, NULL, NULL, NULL, 4),
(202574, NULL, 'G3DSA:1.25.40.10:FF:000684', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g41720', NULL, NULL, NULL, NULL, NULL, 4),
(202575, NULL, 'G3DSA:1.50.10.20:FF:000093', NULL, NULL, 'Terpene cyclase/mutase family member', NULL, NULL, NULL, NULL, NULL, 4),
(202576, NULL, 'G3DSA:1.25.40.20:FF:000687', NULL, NULL, 'BRCA1-associated RING domain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(202577, NULL, 'G3DSA:1.10.472.10:FF:000468', NULL, NULL, 'Cyclin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(202578, NULL, 'G3DSA:3.30.1520.10:FF:000006', NULL, NULL, 'Phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(202579, NULL, 'G3DSA:1.10.287.130:FF:000242', NULL, NULL, 'Sensor histidine kinase, PAS domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(202580, NULL, 'G3DSA:3.40.50.150:FF:001045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202581, NULL, 'G3DSA:1.20.1540.10:FF:000051', NULL, NULL, 'Membrane associated serine protease, rhomboid family', NULL, NULL, NULL, NULL, NULL, 4),
(202582, NULL, 'G3DSA:2.60.120.200:FF:000066', NULL, NULL, 'Laminin subunit alpha 4', NULL, NULL, NULL, NULL, NULL, 4),
(202583, NULL, 'G3DSA:3.40.20.10:FF:000120', NULL, NULL, 'Gelsolin-related protein of 125 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(202584, NULL, 'G3DSA:3.30.70.1730:FF:000042', NULL, NULL, '50S ribosomal protein L10', NULL, NULL, NULL, NULL, NULL, 4),
(202585, NULL, 'G3DSA:3.30.750.24:FF:000144', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(202586, NULL, 'G3DSA:3.30.559.10:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202587, NULL, 'G3DSA:3.90.70.80:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(202588, NULL, 'G3DSA:3.40.50.10580:FF:000001', NULL, NULL, 'V-type proton ATPase subunit F', NULL, NULL, NULL, NULL, NULL, 4),
(202589, NULL, 'G3DSA:3.40.50.720:FF:002082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202590, NULL, 'G3DSA:1.25.40.10:FF:004955', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202591, NULL, 'G3DSA:3.30.70.330:FF:000195', NULL, NULL, 'RNA binding motif protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(202592, NULL, 'G3DSA:1.20.120.1240:FF:000029', NULL, NULL, 'Dynamin GTPase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(202593, NULL, 'G3DSA:2.60.40.10:FF:005018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202594, NULL, 'G3DSA:3.20.20.70:FF:000043', NULL, NULL, 'D-tagatose-1,6-bisphosphate aldolase subunit GatY', NULL, NULL, NULL, NULL, NULL, 4),
(202595, NULL, 'G3DSA:3.30.1120.30:FF:000015', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(202596, NULL, 'G3DSA:3.60.110.10:FF:000036', NULL, NULL, 'Hydrolase, carbon-nitrogen family protein', NULL, NULL, NULL, NULL, NULL, 4),
(202597, NULL, 'G3DSA:1.10.760.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202598, NULL, 'G3DSA:3.30.1540.10:FF:000007', NULL, NULL, 'Probable CoA-transferase Rv1866', NULL, NULL, NULL, NULL, NULL, 4),
(202599, NULL, 'G3DSA:3.40.50.300:FF:005384', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202600, NULL, 'G3DSA:1.20.1070.10:FF:002105', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(202601, NULL, 'G3DSA:2.40.50.40:FF:000009', NULL, NULL, 'chromobox protein homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(202602, NULL, 'G3DSA:3.30.70.270:FF:000154', NULL, NULL, 'Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(202603, NULL, 'G3DSA:1.10.10.60:FF:000769', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202604, NULL, 'G3DSA:3.40.1440.10:FF:000003', NULL, NULL, 'Structure-specific endonuclease subunit SLX1', NULL, NULL, NULL, NULL, NULL, 4),
(202605, NULL, 'G3DSA:2.30.230.10:FF:000005', NULL, NULL, 'Putative Copper-zinc cu-zn superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(202606, NULL, 'G3DSA:1.10.4160.10:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202607, NULL, 'G3DSA:2.40.50.140:FF:000641', NULL, NULL, '''Cold-shock'' DNA-binding domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202608, NULL, 'G3DSA:1.20.1270.60:FF:000044', NULL, NULL, 'Sorting nexin 1', NULL, NULL, NULL, NULL, NULL, 4),
(202609, NULL, 'G3DSA:3.80.10.10:FF:000174', NULL, NULL, 'E3 ubiquitin-protein ligase LRSAM1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(202610, NULL, 'G3DSA:1.20.120.1820:FF:000001', NULL, NULL, 'Chaperone protein TorD', NULL, NULL, NULL, NULL, NULL, 4),
(202611, NULL, 'G3DSA:3.40.50.2300:FF:000840', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202612, NULL, 'G3DSA:1.20.58.60:FF:000351', NULL, NULL, 'Spectrin beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(202613, NULL, 'G3DSA:2.30.42.10:FF:000550', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202614, NULL, 'G3DSA:3.30.70.260:FF:000151', NULL, NULL, 'Probable phosphoserine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(202615, NULL, 'G3DSA:3.50.50.60:FF:000299', NULL, NULL, 'KsdD-like steroid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(202616, NULL, 'G3DSA:2.130.10.10:FF:003641', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202617, NULL, 'G3DSA:1.25.40.120:FF:000021', NULL, NULL, 'Protein farnesyltransferase alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202618, NULL, 'G3DSA:3.30.70.330:FF:002229', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202619, NULL, 'G3DSA:3.30.160.60:FF:003214', NULL, NULL, 'Zinc finger protein 1164', NULL, NULL, NULL, NULL, NULL, 4),
(202620, NULL, 'G3DSA:2.120.10.30:FF:000186', NULL, NULL, 'Acylaminoacyl peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(202621, NULL, 'G3DSA:2.60.120.260:FF:000617', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(202622, NULL, 'G3DSA:3.40.50.2000:FF:000396', NULL, NULL, 'Macrolide glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(202623, NULL, 'G3DSA:3.30.160.60:FF:004962', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202624, NULL, 'G3DSA:1.50.10.20:FF:000104', NULL, NULL, 'Geranylgeranyl transferase type-2 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(202625, NULL, 'G3DSA:1.20.1560.10:FF:000265', NULL, NULL, 'p-GlycoProtein related', NULL, NULL, NULL, NULL, NULL, 4),
(202626, NULL, 'G3DSA:3.30.200.20:FF:001351', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase RLK1', NULL, NULL, NULL, NULL, NULL, 4),
(202627, NULL, 'G3DSA:1.20.5.1200:FF:000009', NULL, NULL, 'GD18460', NULL, NULL, NULL, NULL, NULL, 4),
(202628, NULL, 'G3DSA:3.60.10.10:FF:000231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202629, NULL, 'G3DSA:1.20.120.160:FF:000024', NULL, NULL, 'Response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(202630, NULL, 'G3DSA:1.10.287.70:FF:000605', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(202631, NULL, 'G3DSA:1.10.10.10:FF:000906', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(202632, NULL, 'G3DSA:1.10.287.70:FF:000263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202633, NULL, 'G3DSA:1.20.1070.10:FF:002088', NULL, NULL, 'Gastric inhibitory polypeptide receptor', NULL, NULL, NULL, NULL, NULL, 4),
(202634, NULL, 'G3DSA:3.40.1310.20:FF:000002', NULL, NULL, 'Master replication protein', NULL, NULL, NULL, NULL, NULL, 4),
(202635, NULL, 'G3DSA:2.130.10.30:FF:000090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202636, NULL, 'G3DSA:3.10.350.10:FF:000048', NULL, NULL, 'Cell division suppressor protein YneA', NULL, NULL, NULL, NULL, NULL, 4),
(202637, NULL, 'G3DSA:1.20.1420.30:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202638, NULL, 'G3DSA:2.10.25.10:FF:000073', NULL, NULL, 'Pro-neuregulin-1, membrane-bound isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(202639, NULL, 'G3DSA:2.60.120.200:FF:000285', NULL, NULL, 'Sialidase A', NULL, NULL, NULL, NULL, NULL, 4),
(202640, NULL, 'G3DSA:1.20.1260.10:FF:000006', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(202641, NULL, 'G3DSA:3.40.50.2000:FF:000851', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202642, NULL, 'G3DSA:3.30.460.10:FF:000052', NULL, NULL, 'Ribosomal silencing factor RsfS', NULL, NULL, NULL, NULL, NULL, 4),
(202643, NULL, 'G3DSA:3.10.20.90:FF:000589', NULL, NULL, 'Autophagy-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(202644, NULL, 'G3DSA:3.80.10.10:FF:001011', NULL, NULL, 'Toll-like receptor 21', NULL, NULL, NULL, NULL, NULL, 4),
(202645, NULL, 'G3DSA:2.30.30.140:FF:000240', NULL, NULL, 'Putative serine/threonine-protein kinase pats1', NULL, NULL, NULL, NULL, NULL, 4),
(202646, NULL, 'G3DSA:3.30.70.330:FF:002448', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202647, NULL, 'G3DSA:1.20.1250.20:FF:001695', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202648, NULL, 'G3DSA:3.60.90.10:FF:000005', NULL, NULL, 'Arginine decarboxylase proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(202649, NULL, 'G3DSA:1.25.40.90:FF:000090', NULL, NULL, 'Os09g0472400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(202650, NULL, 'G3DSA:2.10.25.10:FF:000415', NULL, NULL, 'Laminin subunit gamma 1', NULL, NULL, NULL, NULL, NULL, 4),
(202651, NULL, 'G3DSA:2.130.10.10:FF:004945', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(202652, NULL, 'G3DSA:3.80.10.10:FF:000393', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RCH1', NULL, NULL, NULL, NULL, NULL, 4),
(202653, NULL, 'G3DSA:2.60.260.20:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202654, NULL, 'G3DSA:2.10.25.10:FF:001596', NULL, NULL, 'Netrin g2b', NULL, NULL, NULL, NULL, NULL, 4),
(202655, NULL, 'G3DSA:2.130.10.10:FF:005221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(202656, NULL, 'G3DSA:3.40.50.720:FF:000625', NULL, NULL, 'Glutamyl-tRNA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(202657, NULL, 'G3DSA:1.20.1250.20:FF:002313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202658, NULL, 'G3DSA:1.10.150.20:FF:000145', NULL, NULL, 'DNA repair endonuclease xp-f, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202659, NULL, 'G3DSA:3.30.1240.10:FF:000063', NULL, NULL, 'Sll1524 protein', NULL, NULL, NULL, NULL, NULL, 4),
(202660, NULL, 'G3DSA:1.10.8.10:FF:000017', NULL, NULL, 'OTU domain-containing protein 7A', NULL, NULL, NULL, NULL, NULL, 4),
(202661, NULL, 'G3DSA:3.40.1160.10:FF:000060', NULL, NULL, 'Uridylate kinase protein', NULL, NULL, NULL, NULL, NULL, 4),
(202662, NULL, 'G3DSA:1.10.10.10:FF:001058', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(202663, NULL, 'G3DSA:2.60.40.10:FF:003096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202664, NULL, 'G3DSA:1.20.1070.10:FF:001487', NULL, NULL, 'Teleost multiple tissue opsin 3b', NULL, NULL, NULL, NULL, NULL, 4),
(202665, NULL, 'G3DSA:3.40.50.300:FF:005620', NULL, NULL, 'Putative Unc104-like kinesin', NULL, NULL, NULL, NULL, NULL, 4),
(202666, NULL, 'G3DSA:2.40.50.40:FF:000122', NULL, NULL, 'Chromodomain helicase DNA-binding protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(202667, NULL, 'G3DSA:3.40.190.10:FF:000585', NULL, NULL, 'Peptide transport periplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(202668, NULL, 'G3DSA:3.30.70.330:FF:000318', NULL, NULL, 'Zinc finger CCCH domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(202669, NULL, 'G3DSA:2.160.20.10:FF:000246', NULL, NULL, 'ABC-type copper transport system substrate-binding component NosD', NULL, NULL, NULL, NULL, NULL, 4),
(202670, NULL, 'G3DSA:1.10.287.3440:FF:000005', NULL, NULL, 'Arginine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(202671, NULL, 'G3DSA:3.40.1190.20:FF:000233', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202672, NULL, 'G3DSA:3.40.50.11350:FF:000024', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(202673, NULL, 'G3DSA:3.40.50.620:FF:000365', NULL, NULL, 'Pantoate--beta-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(202674, NULL, 'G3DSA:3.90.190.20:FF:000009', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(202675, NULL, 'G3DSA:3.40.1110.10:FF:000124', NULL, NULL, 'Probable copper-importing P-type ATPase A', NULL, NULL, NULL, NULL, NULL, 4),
(202676, NULL, 'G3DSA:3.40.50.1010:FF:000200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202677, NULL, 'G3DSA:1.10.510.10:FF:001294', NULL, NULL, 'CDPK-related kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(202678, NULL, 'G3DSA:3.60.20.10:FF:000057', NULL, NULL, 'ATP-dependent protease subunit ClpQ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202679, NULL, 'G3DSA:1.25.40.180:FF:000342', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202680, NULL, 'G3DSA:3.40.390.10:FF:000241', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202681, NULL, 'G3DSA:2.60.40.10:FF:001640', NULL, NULL, 'Prostate-specific transglutaminase 4', NULL, NULL, NULL, NULL, NULL, 4),
(202682, NULL, 'G3DSA:3.80.10.10:FF:002192', NULL, NULL, 'Toll-like receptor 21', NULL, NULL, NULL, NULL, NULL, 4),
(202683, NULL, 'G3DSA:2.60.40.60:FF:001065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202684, NULL, 'G3DSA:3.90.79.10:FF:000186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202685, NULL, 'G3DSA:3.40.50.300:FF:001236', NULL, NULL, 'ATP-dependent helicase/nuclease subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(202686, NULL, 'G3DSA:3.90.180.10:FF:000056', NULL, NULL, 'NAD-dependent alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(202687, NULL, 'G3DSA:3.40.50.12710:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202688, NULL, 'G3DSA:3.30.160.60:FF:005125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202689, NULL, 'G3DSA:3.90.190.10:FF:000006', NULL, NULL, 'Dual specificity protein phosphatase CDC14B', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(202690, NULL, 'G3DSA:3.30.830.10:FF:000098', NULL, NULL, 'Zinc Metalloprotease (Insulinase family)', NULL, NULL, NULL, NULL, NULL, 4),
(202691, NULL, 'G3DSA:3.40.50.300:FF:008599', NULL, NULL, 'Peroxisome biogenesis factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202692, NULL, 'G3DSA:1.25.40.10:FF:003320', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g27610', NULL, NULL, NULL, NULL, NULL, 4),
(202693, NULL, 'G3DSA:1.20.1250.20:FF:000059', NULL, NULL, 'Solute carrier family 17 member 9', NULL, NULL, NULL, NULL, NULL, 4),
(202694, NULL, 'G3DSA:3.40.50.1820:FF:001758', NULL, NULL, 'Cathepsin A', NULL, NULL, NULL, NULL, NULL, 4),
(202695, NULL, 'G3DSA:3.30.40.10:FF:001959', NULL, NULL, 'CESA4 (CELLULOSE SYNTHASE A4)', NULL, NULL, NULL, NULL, NULL, 4),
(202696, NULL, 'G3DSA:1.20.1250.10:FF:000056', NULL, NULL, 'Colony-stimulating factor 1b (macrophage)', NULL, NULL, NULL, NULL, NULL, 4),
(202697, NULL, 'G3DSA:2.30.40.10:FF:000040', NULL, NULL, 'Guanine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(202698, NULL, 'G3DSA:3.40.50.970:FF:000228', NULL, NULL, 'Gll1094 protein', NULL, NULL, NULL, NULL, NULL, 4),
(202699, NULL, 'G3DSA:2.130.10.10:FF:003309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202700, NULL, 'G3DSA:3.80.10.10:FF:002534', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202701, NULL, 'G3DSA:3.40.50.300:FF:007076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202702, NULL, 'G3DSA:3.90.1150.210:FF:000028', NULL, NULL, 'F-actin-capping protein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(202703, NULL, 'G3DSA:1.20.1080.10:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202704, NULL, 'G3DSA:1.25.10.10:FF:001570', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202705, NULL, 'G3DSA:3.30.710.10:FF:000375', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202706, NULL, 'G3DSA:2.60.40.60:FF:000789', NULL, NULL, 'Cadherin related family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(202707, NULL, 'G3DSA:3.100.10.10:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202708, NULL, 'G3DSA:1.20.5.110:FF:000050', NULL, NULL, 'Vesicle-associated membrane protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(202709, NULL, 'G3DSA:3.20.20.140:FF:000141', NULL, NULL, 'Histidinol-phosphatase HisJ', NULL, NULL, NULL, NULL, NULL, 4),
(202710, NULL, 'G3DSA:2.30.30.100:FF:000144', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm6', NULL, NULL, NULL, NULL, NULL, 4),
(202711, NULL, 'G3DSA:3.40.50.2000:FF:000177', NULL, NULL, 'Glycogen [starch] synthase', NULL, NULL, NULL, NULL, NULL, 4),
(202712, NULL, 'G3DSA:2.60.40.10:FF:005350', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202713, NULL, 'G3DSA:1.20.900.10:FF:000001', NULL, NULL, 'Guanine nucleotide exchange factor DBS', NULL, NULL, NULL, NULL, NULL, 4),
(202714, NULL, 'G3DSA:2.60.120.200:FF:000627', NULL, NULL, 'Drosophila CRumBs homolog', NULL, NULL, NULL, NULL, NULL, 4),
(202715, NULL, 'G3DSA:3.30.70.141:FF:000015', NULL, NULL, 'Nucleoside diphosphate kinase B', NULL, NULL, NULL, NULL, NULL, 4),
(202716, NULL, 'G3DSA:2.80.10.70:FF:000003', NULL, NULL, 'spindlin-2B isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(202717, NULL, 'G3DSA:1.25.40.20:FF:001743', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202718, NULL, 'G3DSA:3.30.590.10:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202719, NULL, 'G3DSA:3.90.226.10:FF:000068', NULL, NULL, 'S49 family peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(202720, NULL, 'G3DSA:3.40.50.720:FF:002205', NULL, NULL, 'Dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202721, NULL, 'G3DSA:3.90.1150.10:FF:000492', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202722, NULL, 'G3DSA:2.40.50.140:FF:000298', NULL, NULL, 'aspartate--tRNA ligase, mitochondrial isoform X2', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(202723, NULL, 'G3DSA:3.30.40.10:FF:002235', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(202724, NULL, 'G3DSA:1.20.1560.10:FF:000607', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202725, NULL, 'G3DSA:2.120.10.80:FF:000408', NULL, NULL, 'F-box only protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(202726, NULL, 'G3DSA:3.40.50.300:FF:005507', NULL, NULL, 'DEAD box protein 21E2', NULL, NULL, NULL, NULL, NULL, 4),
(202727, NULL, 'G3DSA:3.40.50.300:FF:003366', NULL, NULL, 'Helicase required for RNAi-mediated heterochromatin assembly 1', NULL, NULL, NULL, NULL, NULL, 4),
(202728, NULL, 'G3DSA:2.60.220.50:FF:000122', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(202729, NULL, 'G3DSA:1.10.510.10:FF:000799', NULL, NULL, 'Cyclin-dependent kinase F-1', NULL, NULL, NULL, NULL, NULL, 4),
(202730, NULL, 'G3DSA:3.80.10.10:FF:002315', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202731, NULL, 'G3DSA:1.10.510.10:FF:001417', NULL, NULL, 'Casein kinase I isoform alpha', NULL, NULL, NULL, NULL, NULL, 4),
(202732, NULL, 'G3DSA:3.30.300.160:FF:000005', NULL, NULL, 'Type II secretion system protein E', NULL, NULL, NULL, NULL, NULL, 4),
(202733, NULL, 'G3DSA:3.50.50.60:FF:000193', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(202734, NULL, 'G3DSA:3.80.10.10:FF:001697', NULL, NULL, 'F-box and leucine-rich repeat protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(202735, NULL, 'G3DSA:3.30.450.20:FF:000116', NULL, NULL, 'period circadian protein homolog 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(202736, NULL, 'G3DSA:3.40.50.1370:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202737, NULL, 'G3DSA:3.30.470.10:FF:000002', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(202738, NULL, 'G3DSA:3.40.50.2300:FF:000166', NULL, NULL, 'Galactitol-specific phosphotransferase enzyme IIB component', NULL, NULL, NULL, NULL, NULL, 4),
(202739, NULL, 'G3DSA:3.40.50.2000:FF:000519', NULL, NULL, 'Lipid-A-disaccharide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(202740, NULL, 'G3DSA:3.50.50.60:FF:000535', NULL, NULL, 'FAD/NAD(P)-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(202741, NULL, 'G3DSA:3.90.1860.10:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202742, NULL, 'G3DSA:3.40.190.10:FF:000366', NULL, NULL, 'Ovotransferrin', NULL, NULL, NULL, NULL, NULL, 4),
(202743, NULL, 'G3DSA:3.10.196.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202744, NULL, 'G3DSA:1.25.10.10:FF:001132', NULL, NULL, 'Serum amyloid A-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(202745, NULL, 'G3DSA:3.40.47.10:FF:000159', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202746, NULL, 'G3DSA:2.130.10.10:FF:001730', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(202747, NULL, 'G3DSA:3.90.1150.10:FF:000273', NULL, NULL, 'Class III aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(202748, NULL, 'G3DSA:1.20.210.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202749, NULL, 'G3DSA:3.40.50.150:FF:000882', NULL, NULL, 'tRNA wybutosine-synthesizing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(202750, NULL, 'G3DSA:1.20.1440.210:FF:000001', NULL, NULL, 'Intraflagellar transport 57', NULL, NULL, NULL, NULL, NULL, 4),
(202751, NULL, 'G3DSA:2.60.210.10:FF:000076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202752, NULL, 'G3DSA:3.90.226.10:FF:000287', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(202753, NULL, 'G3DSA:3.40.50.150:FF:001500', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202754, NULL, 'G3DSA:3.30.470.20:FF:000005', NULL, NULL, 'Acetyl-CoA carboxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(202755, NULL, 'G3DSA:1.20.910.10:FF:000046', NULL, NULL, 'Heme oxygenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(202756, NULL, 'G3DSA:1.10.390.10:FF:000013', NULL, NULL, 'Aminopeptidase N', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(202757, NULL, 'G3DSA:3.40.50.1360:FF:000052', NULL, NULL, 'Ribose-5-phosphate isomerase A', NULL, NULL, NULL, NULL, NULL, 4),
(202758, NULL, 'G3DSA:3.30.1370.10:FF:000067', NULL, NULL, 'High density lipoprotein binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(202759, NULL, 'G3DSA:3.30.1180.20:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202760, NULL, 'G3DSA:3.10.400.20:FF:000033', NULL, NULL, 'Eukaryotic translation initiation factor 2D', NULL, NULL, NULL, NULL, NULL, 4),
(202761, NULL, 'G3DSA:1.10.3630.10:FF:000009', NULL, NULL, 'Golgi phosphoprotein 3-like', NULL, NULL, NULL, NULL, NULL, 4),
(202762, NULL, 'G3DSA:3.30.200.20:FF:001019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202763, NULL, 'G3DSA:3.30.70.330:FF:002667', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202764, NULL, 'G3DSA:1.10.472.10:FF:000581', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202765, NULL, 'G3DSA:2.60.40.420:FF:000140', NULL, NULL, 'Multicopper oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(202766, NULL, 'G3DSA:2.10.25.10:FF:001719', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202767, NULL, 'G3DSA:2.40.160.110:FF:000029', NULL, NULL, 'Lysosomal-associated membrane protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(202768, NULL, 'G3DSA:3.40.309.10:FF:000053', NULL, NULL, 'GM25448', NULL, NULL, NULL, NULL, NULL, 4),
(202769, NULL, 'G3DSA:1.20.1560.10:FF:000720', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(202770, NULL, 'G3DSA:3.10.110.10:FF:000177', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(202771, NULL, 'G3DSA:3.40.190.10:FF:000708', NULL, NULL, 'Sulfonate ABC transporter, periplasmic sulfonate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(202772, NULL, 'G3DSA:1.10.600.10:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202773, NULL, 'G3DSA:1.20.1270.290:FF:000002', NULL, NULL, 'ENL/AF9-related, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(202774, NULL, 'G3DSA:2.40.30.30:FF:000011', NULL, NULL, 'Putative riboflavin kinase', NULL, NULL, NULL, NULL, NULL, 4),
(202775, NULL, 'G3DSA:1.25.10.10:FF:000856', NULL, NULL, 'HEAT repeat domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(202776, NULL, 'G3DSA:2.30.140.20:FF:000001', NULL, NULL, 'Penicillin-binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(202777, NULL, 'G3DSA:3.30.1490.30:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202778, NULL, 'G3DSA:3.40.50.2300:FF:001003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202779, NULL, 'G3DSA:1.10.510.10:FF:001075', NULL, NULL, 'Protein kinase, putative (AFU_orthologue AFUA_2G16620)', NULL, NULL, NULL, NULL, NULL, 4),
(202780, NULL, 'G3DSA:2.30.29.70:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202781, NULL, 'G3DSA:3.10.20.10:FF:000043', NULL, NULL, '60S ribosomal protein L18a-2', NULL, NULL, NULL, NULL, NULL, 4),
(202782, NULL, 'G3DSA:2.10.109.10:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202783, NULL, 'G3DSA:2.60.40.10:FF:001421', NULL, NULL, 'Interleukin 9 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(202784, NULL, 'G3DSA:2.30.29.30:FF:000244', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(202785, NULL, 'G3DSA:3.30.160.20:FF:000015', NULL, NULL, 'endoribonuclease Dicer', NULL, NULL, NULL, NULL, NULL, 4),
(202786, NULL, 'G3DSA:3.30.160.60:FF:004849', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202787, NULL, 'G3DSA:3.30.160.60:FF:000797', NULL, NULL, 'zinc finger protein 592 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(202788, NULL, 'G3DSA:3.90.550.50:FF:000198', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(202789, NULL, 'G3DSA:1.10.8.10:FF:000130', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(202790, NULL, 'G3DSA:3.60.70.12:FF:000001', NULL, NULL, 'Arginine biosynthesis bifunctional protein ArgJ, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(202791, NULL, 'G3DSA:3.40.50.2000:FF:000290', NULL, NULL, 'Glycosyltransferase family 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(202792, NULL, 'G3DSA:3.30.1370.110:FF:000020', NULL, NULL, 'Endonuclease MutS2', NULL, NULL, NULL, NULL, NULL, 4),
(202793, NULL, 'G3DSA:3.30.160.60:FF:001415', NULL, NULL, 'zinc finger protein 282', NULL, NULL, NULL, NULL, NULL, 4),
(202794, NULL, 'G3DSA:3.80.10.10:FF:001478', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(202795, NULL, 'G3DSA:3.30.160.20:FF:000234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202796, NULL, 'G3DSA:2.130.10.10:FF:001511', NULL, NULL, 'WD repeat domain 11', NULL, NULL, NULL, NULL, NULL, 4),
(202797, NULL, 'G3DSA:3.50.50.60:FF:001030', NULL, NULL, 'Flavin containing amine oxidase, putative (AFU_orthologue AFUA_8G01470)', NULL, NULL, NULL, NULL, NULL, 4),
(202798, NULL, 'G3DSA:3.30.1360.40:FF:000002', NULL, NULL, 'DNA gyrase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(202799, NULL, 'G3DSA:2.130.10.10:FF:000893', NULL, NULL, 'Dynein intermediate chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(202800, NULL, 'G3DSA:3.40.50.2300:FF:000727', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202801, NULL, 'G3DSA:2.60.200.40:FF:000011', NULL, NULL, 'diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(202802, NULL, 'G3DSA:2.40.30.260:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202803, NULL, 'G3DSA:3.20.110.10:FF:000017', NULL, NULL, 'Alpha-mannosidase D', NULL, NULL, NULL, NULL, NULL, 4),
(202804, NULL, 'G3DSA:4.10.410.20:FF:000002', NULL, NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(202805, NULL, 'G3DSA:1.10.287.370:FF:000061', NULL, NULL, 'Prefoldin alpha-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(202806, NULL, 'G3DSA:1.20.120.1530:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202807, NULL, 'G3DSA:2.40.50.90:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202808, NULL, 'G3DSA:3.40.50.300:FF:001910', NULL, NULL, 'GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202809, NULL, 'G3DSA:3.90.70.10:FF:000879', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202810, NULL, 'G3DSA:3.40.50.1910:FF:000037', NULL, NULL, 'Vacuolar protein sorting-associated protein 33A', NULL, NULL, NULL, NULL, NULL, 4),
(202811, NULL, 'G3DSA:1.10.630.10:FF:000510', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(202812, NULL, 'G3DSA:2.120.10.80:FF:000285', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(202813, NULL, 'G3DSA:3.20.20.80:FF:000501', NULL, NULL, 'Mp65 cell surface mannoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(202814, NULL, 'G3DSA:1.25.40.10:FF:001066', NULL, NULL, 'Clathrin heavy chain like 1', NULL, NULL, NULL, NULL, NULL, 4),
(202815, NULL, 'G3DSA:3.60.20.10:FF:000170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202816, NULL, 'G3DSA:3.40.50.1220:FF:000038', NULL, NULL, 'NAD-dependent protein deacetylase sirtuin-6 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(202817, NULL, 'G3DSA:3.40.190.10:FF:000927', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202818, NULL, 'G3DSA:1.10.238.10:FF:000879', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202819, NULL, 'G3DSA:1.10.8.60:FF:000116', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(202820, NULL, 'G3DSA:3.40.50.720:FF:000283', NULL, NULL, 'Glyoxylate/hydroxypyruvate reductase HPR3', NULL, NULL, NULL, NULL, NULL, 4),
(202821, NULL, 'G3DSA:1.25.10.10:FF:001351', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(202822, NULL, 'G3DSA:3.30.160.60:FF:005344', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202823, NULL, 'G3DSA:3.30.70.330:FF:000650', NULL, NULL, 'Polyadenylate-binding protein RBP45', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(202824, NULL, 'G3DSA:3.40.850.10:FF:000501', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(202825, NULL, 'G3DSA:3.40.50.80:FF:000160', NULL, NULL, 'Ferredoxin:NADP oxidoreductase, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(202826, NULL, 'G3DSA:1.20.1050.10:FF:000305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202827, NULL, 'G3DSA:2.60.120.430:FF:000005', NULL, NULL, 'Putative receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(202828, NULL, 'G3DSA:3.30.160.60:FF:001073', NULL, NULL, 'zinc finger protein 182', NULL, NULL, NULL, NULL, NULL, 4),
(202829, NULL, 'G3DSA:3.50.50.60:FF:000754', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202830, NULL, 'G3DSA:1.25.40.20:FF:001069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202831, NULL, 'G3DSA:2.10.25.10:FF:000292', NULL, NULL, 'Matrilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(202832, NULL, 'G3DSA:1.20.1250.20:FF:000278', NULL, NULL, 'Putative MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(202833, NULL, 'G3DSA:1.10.238.10:FF:001155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202834, NULL, 'G3DSA:3.40.50.2300:FF:000385', NULL, NULL, 'Low molecular weight phosphotyrosine protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202835, NULL, 'G3DSA:1.25.40.420:FF:000010', NULL, NULL, 'Kelch-like family member 14', NULL, NULL, NULL, NULL, NULL, 4),
(202836, NULL, 'G3DSA:1.20.59.10:FF:000001', NULL, NULL, 'T-protein', NULL, NULL, NULL, NULL, NULL, 4),
(202837, NULL, 'G3DSA:1.25.40.10:FF:002825', NULL, NULL, 'Bardet-Biedl syndrome 4 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202838, NULL, 'G3DSA:3.40.50.720:FF:001615', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202839, NULL, 'G3DSA:3.40.47.10:FF:000087', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 3', NULL, NULL, NULL, NULL, NULL, 4),
(202840, NULL, 'G3DSA:1.10.8.10:FF:000097', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(202841, NULL, 'G3DSA:1.50.10.10:FF:000225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202842, NULL, 'G3DSA:3.90.70.10:FF:000296', NULL, NULL, 'Putative calpain-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(202843, NULL, 'G3DSA:1.20.1250.10:FF:000063', NULL, NULL, 'Chorionic somatomammotropin hormone', NULL, NULL, NULL, NULL, NULL, 4),
(202844, NULL, 'G3DSA:2.20.25.10:FF:000011', NULL, NULL, 'peptide-N(4)-(N-acetyl-beta- glucosaminyl)asparagine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(202845, NULL, 'G3DSA:1.20.1270.60:FF:000028', NULL, NULL, 'Bridging integrator 3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(202846, NULL, 'G3DSA:2.10.260.10:FF:000001', NULL, NULL, 'Stage V sporulation protein T', NULL, NULL, NULL, NULL, NULL, 4),
(202847, NULL, 'G3DSA:2.170.8.10:FF:000009', NULL, NULL, 'Phosphoenolpyruvate carboxykinase', NULL, NULL, NULL, NULL, NULL, 4),
(202848, NULL, 'G3DSA:1.20.58.60:FF:000172', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(202849, NULL, 'G3DSA:3.10.110.10:FF:000099', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 E3', NULL, NULL, NULL, NULL, NULL, 4),
(202850, NULL, 'G3DSA:2.60.40.2240:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202851, NULL, 'G3DSA:1.10.1300.10:FF:000075', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(202852, NULL, 'G3DSA:3.90.1640.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202853, NULL, 'G3DSA:3.40.50.2300:FF:000380', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202854, NULL, 'G3DSA:1.25.40.1030:FF:000022', NULL, NULL, 'Protein transport protein SEC31 B', NULL, NULL, NULL, NULL, NULL, 4),
(202855, NULL, 'G3DSA:3.80.10.10:FF:002726', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(202856, NULL, 'G3DSA:2.40.70.10:FF:000536', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(202857, NULL, 'G3DSA:2.30.29.30:FF:001009', NULL, NULL, 'Peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(202858, NULL, 'G3DSA:3.90.226.10:FF:000147', NULL, NULL, 'Carbamoyl-phosphate synthase/carboxyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(202859, NULL, 'G3DSA:3.30.70.330:FF:003039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202860, NULL, 'G3DSA:3.30.930.10:FF:000010', NULL, NULL, 'Glycyl-tRNA synthetase 1', NULL, NULL, NULL, NULL, NULL, 4),
(202861, NULL, 'G3DSA:6.10.250.3410:FF:000002', NULL, NULL, 'DBF4 zinc finger', NULL, NULL, NULL, NULL, NULL, 4),
(202862, NULL, 'G3DSA:3.30.160.60:FF:002591', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202863, NULL, 'G3DSA:1.20.90.10:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202864, NULL, 'G3DSA:1.25.40.10:FF:000937', NULL, NULL, 'Os08g0162200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(202865, NULL, 'G3DSA:3.40.50.300:FF:004126', NULL, NULL, 'DNA-dependent ATPase (MGS1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(202866, NULL, 'G3DSA:2.40.50.1070:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202867, NULL, 'G3DSA:3.80.20.20:FF:000083', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(202868, NULL, 'G3DSA:3.30.160.60:FF:005345', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202869, NULL, 'G3DSA:3.90.190.10:FF:000170', NULL, NULL, 'Protein tyrosine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(202870, NULL, 'G3DSA:3.40.50.80:FF:000115', NULL, NULL, 'Ferric reductase transmembrane component, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202871, NULL, 'G3DSA:3.40.50.10490:FF:000048', NULL, NULL, 'Glucose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(202872, NULL, 'G3DSA:2.70.150.10:FF:000041', NULL, NULL, 'Calcium-transporting ATPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(202873, NULL, 'G3DSA:2.60.40.10:FF:000578', NULL, NULL, 'Leukemia inhibitory factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(202874, NULL, 'G3DSA:3.30.710.10:FF:000319', NULL, NULL, 'AGAP001646-PA', NULL, NULL, NULL, NULL, NULL, 4),
(202875, NULL, 'G3DSA:2.40.50.40:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202876, NULL, 'G3DSA:1.25.10.10:FF:000317', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(202877, NULL, 'G3DSA:1.25.40.10:FF:001926', NULL, NULL, 'RNA polymerase-associated protein CTR9', NULL, NULL, NULL, NULL, NULL, 4),
(202878, NULL, 'G3DSA:3.90.550.10:FF:000153', NULL, NULL, 'Putative glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(202879, NULL, 'G3DSA:3.30.565.10:FF:000397', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(202880, NULL, 'G3DSA:3.60.10.10:FF:000119', NULL, NULL, 'Probable exported protein', NULL, NULL, NULL, NULL, NULL, 4),
(202881, NULL, 'G3DSA:2.40.37.10:FF:000009', NULL, NULL, 'antizyme inhibitor 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(202882, NULL, 'G3DSA:3.40.50.620:FF:000422', NULL, NULL, 'Putative tyrosyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(202883, NULL, 'G3DSA:1.10.287.130:FF:000012', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(202884, NULL, 'G3DSA:2.60.40.820:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202885, NULL, 'G3DSA:3.40.50.10190:FF:000109', NULL, NULL, 'Regulator of Ty1 transposition', NULL, NULL, NULL, NULL, NULL, 4),
(202886, NULL, 'G3DSA:3.30.160.60:FF:001163', NULL, NULL, 'zinc finger protein 182 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(202887, NULL, 'G3DSA:1.20.5.340:FF:000030', NULL, NULL, 'Putative transcriptional repressor TUP1', NULL, NULL, NULL, NULL, NULL, 4),
(202888, NULL, 'G3DSA:3.20.190.20:FF:000003', NULL, NULL, 'Protease Do-like 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(202889, NULL, 'G3DSA:1.25.40.10:FF:002062', NULL, NULL, 'Pentatricopeptide (PPR) repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(202890, NULL, 'G3DSA:1.10.225.10:FF:000030', NULL, NULL, 'Prosaposin (variant Gaucher disease and variant metachromatic leukodystrophy)', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(202891, NULL, 'G3DSA:3.30.200.20:FF:001346', NULL, NULL, 'Leucine-rich repeat receptor protein kinase MSP1', NULL, NULL, NULL, NULL, NULL, 4),
(202892, NULL, 'G3DSA:2.60.120.310:FF:000010', NULL, NULL, 'tyramine beta-hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(202893, NULL, 'G3DSA:1.10.560.10:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202894, NULL, 'G3DSA:3.30.70.330:FF:000285', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(202895, NULL, 'G3DSA:3.40.50.1820:FF:000803', NULL, NULL, 'Steryl ester hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202896, NULL, 'G3DSA:2.10.25.10:FF:000152', NULL, NULL, 'FAT atypical cadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(202897, NULL, 'G3DSA:1.20.1270.10:FF:000007', NULL, NULL, 'Heat shock protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(202898, NULL, 'G3DSA:3.40.50.1700:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202899, NULL, 'G3DSA:3.20.20.140:FF:000226', NULL, NULL, 'Amidohydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(202900, NULL, 'G3DSA:2.130.10.10:FF:003636', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202901, NULL, 'G3DSA:2.60.40.10:FF:000106', NULL, NULL, 'Neogenin isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(202902, NULL, 'G3DSA:1.25.10.10:FF:000789', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(202903, NULL, 'G3DSA:2.60.40.420:FF:000146', NULL, NULL, 'Quinol oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(202904, NULL, 'G3DSA:3.40.50.800:FF:000032', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(202905, NULL, 'G3DSA:3.30.50.10:FF:000016', NULL, NULL, 'Nuclear receptor subfamily 2 group F member 1', NULL, NULL, NULL, NULL, NULL, 4),
(202906, NULL, 'G3DSA:1.10.10.60:FF:000219', NULL, NULL, 'LIM/homeobox protein Lhx3', NULL, NULL, NULL, NULL, NULL, 4),
(202907, NULL, 'G3DSA:1.10.150.20:FF:000128', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(202908, NULL, 'G3DSA:3.40.50.300:FF:004598', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(202909, NULL, 'G3DSA:3.30.70.141:FF:000004', NULL, NULL, 'Nucleoside diphosphate kinase 7', NULL, NULL, NULL, NULL, NULL, 4),
(202910, NULL, 'G3DSA:3.30.450.20:FF:000549', NULL, NULL, 'Putative nitrogen regulation protein NtrY', NULL, NULL, NULL, NULL, NULL, 4),
(202911, NULL, 'G3DSA:3.30.420.40:FF:000907', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(202912, NULL, 'G3DSA:1.20.1420.30:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202913, NULL, 'G3DSA:3.20.20.100:FF:000034', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(202914, NULL, 'G3DSA:1.10.510.10:FF:000873', NULL, NULL, 'Serine/threonine-protein kinase VHS1', NULL, NULL, NULL, NULL, NULL, 4),
(202915, NULL, 'G3DSA:2.130.10.10:FF:001658', NULL, NULL, 'CPSF_A_subunit_region_containing_protein', NULL, NULL, NULL, NULL, NULL, 4),
(202916, NULL, 'G3DSA:2.20.25.30:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202917, NULL, 'G3DSA:3.40.50.150:FF:001658', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202918, NULL, 'G3DSA:3.40.50.410:FF:000005', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(202919, NULL, 'G3DSA:1.25.40.10:FF:003490', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(202920, NULL, 'G3DSA:3.60.21.10:FF:000408', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(202921, NULL, 'G3DSA:2.170.150.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202922, NULL, 'G3DSA:3.40.50.620:FF:000894', NULL, NULL, 'Isoleucine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(202923, NULL, 'G3DSA:2.60.40.10:FF:001534', NULL, NULL, 'Signal regulatory protein beta 2', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(202924, NULL, 'G3DSA:1.50.40.10:FF:000053', NULL, NULL, 'Mitochondrial DNA replication protein', NULL, NULL, NULL, NULL, NULL, 4),
(202925, NULL, 'G3DSA:1.20.58.1100:FF:000008', NULL, NULL, 'Unc-13 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(202926, NULL, 'G3DSA:3.40.50.720:FF:000626', NULL, NULL, 'D3-phosphoglycerate dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202927, NULL, 'G3DSA:3.90.70.80:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202928, NULL, 'G3DSA:3.40.50.2300:FF:000228', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(202929, NULL, 'G3DSA:1.20.120.80:FF:000013', NULL, NULL, 'Cytochrome c oxidase subunit I+III', NULL, NULL, NULL, NULL, NULL, 4),
(202930, NULL, 'G3DSA:1.25.10.10:FF:001745', NULL, NULL, 'AaceriAFR269Wp', NULL, NULL, NULL, NULL, NULL, 4),
(202931, NULL, 'G3DSA:1.10.10.10:FF:001626', NULL, NULL, 'Target Of ERK kinase MPK-1', NULL, NULL, NULL, NULL, NULL, 4),
(202932, NULL, 'G3DSA:2.10.25.10:FF:001580', NULL, NULL, 'Fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(202933, NULL, 'G3DSA:2.60.40.150:FF:000222', NULL, NULL, 'SyNapTotagmin', NULL, NULL, NULL, NULL, NULL, 4),
(202934, NULL, 'G3DSA:3.80.10.10:FF:000309', NULL, NULL, 'Leucine-rich repeat-containing protein 55', NULL, NULL, NULL, NULL, NULL, 4),
(202935, NULL, 'G3DSA:3.30.1490.80:FF:000035', NULL, NULL, 'Os12g0528400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(202936, NULL, 'G3DSA:1.25.40.10:FF:004832', NULL, NULL, 'Crooked neck protein-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(202937, NULL, 'G3DSA:1.20.58.530:FF:000030', NULL, NULL, 'Probable chitin synthase 8', NULL, NULL, NULL, NULL, NULL, 4),
(202938, NULL, 'G3DSA:1.10.3730.20:FF:000009', NULL, NULL, 'EamA family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(202939, NULL, 'G3DSA:2.130.10.10:FF:005553', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202940, NULL, 'G3DSA:1.20.1070.10:FF:001807', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202941, NULL, 'G3DSA:3.40.630.10:FF:000120', NULL, NULL, 'Peptidase M20 domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(202942, NULL, 'G3DSA:3.40.50.150:FF:000410', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(202943, NULL, 'G3DSA:2.10.110.10:FF:000226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202944, NULL, 'G3DSA:1.20.1250.20:FF:001381', NULL, NULL, 'Putative metabolite transport protein HI_1104', NULL, NULL, NULL, NULL, NULL, 4),
(202945, NULL, 'G3DSA:3.30.70.330:FF:000605', NULL, NULL, 'Splicing factor U2AF 65 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(202946, NULL, 'G3DSA:3.40.720.10:FF:000239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202947, NULL, 'G3DSA:2.40.50.140:FF:001136', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202948, NULL, 'G3DSA:3.30.460.10:FF:000165', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(202949, NULL, 'G3DSA:1.25.10.30:FF:000003', NULL, NULL, 'Protein CBR-ITR-1, isoform a', NULL, NULL, NULL, NULL, NULL, 4),
(202950, NULL, 'G3DSA:3.30.40.10:FF:002168', NULL, NULL, 'AT Hook plus PHD finger transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(202951, NULL, 'G3DSA:1.10.3120.10:FF:000005', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(202952, NULL, 'G3DSA:2.40.50.770:FF:000015', NULL, NULL, 'RecQ mediated genome instability protein Rmi1', NULL, NULL, NULL, NULL, NULL, 4),
(202953, NULL, 'G3DSA:3.40.50.300:FF:005115', NULL, NULL, 'Phosphonates import ATP-binding protein PhnC 2', NULL, NULL, NULL, NULL, NULL, 4),
(202954, NULL, 'G3DSA:1.10.506.10:FF:000003', NULL, NULL, 'Plexin A2', NULL, NULL, NULL, NULL, NULL, 4),
(202955, NULL, 'G3DSA:3.30.1370.210:FF:000017', NULL, NULL, 'Zinc finger C-x8-C-x5-C-x3-H type (And similar), putative', NULL, NULL, NULL, NULL, NULL, 4),
(202956, NULL, 'G3DSA:1.10.1000.11:FF:000008', NULL, NULL, 'F-box only protein 8', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(202957, NULL, 'G3DSA:2.30.30.490:FF:000065', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(202958, NULL, 'G3DSA:2.30.29.30:FF:000233', NULL, NULL, 'rhotekin isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(202959, NULL, 'G3DSA:3.90.650.10:FF:000037', NULL, NULL, 'Hydrogenase expression/formation protein hypE', NULL, NULL, NULL, NULL, NULL, 4),
(202960, NULL, 'G3DSA:3.30.420.150:FF:000013', NULL, NULL, 'Exopolyphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(202961, NULL, 'G3DSA:1.10.246.90:FF:000001', NULL, NULL, 'Nucleolar protein 56', NULL, NULL, NULL, NULL, NULL, 4),
(202962, NULL, 'G3DSA:3.30.40.10:FF:001679', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202963, NULL, 'G3DSA:2.40.30.10:FF:000270', NULL, NULL, 'Flavodoxin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(202964, NULL, 'G3DSA:2.120.10.30:FF:000557', NULL, NULL, 'Senescence marker protein-30, putative', NULL, NULL, NULL, NULL, NULL, 4),
(202965, NULL, 'G3DSA:1.25.10.10:FF:001306', NULL, NULL, '26S proteasome regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(202966, NULL, 'G3DSA:1.10.510.10:FF:000401', NULL, NULL, 'serine/threonine-protein kinase haspin', NULL, NULL, NULL, NULL, NULL, 4),
(202967, NULL, 'G3DSA:2.30.30.140:FF:000044', NULL, NULL, 'AT-rich interactive domain-containing protein 4B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(202968, NULL, 'G3DSA:3.40.50.300:FF:006104', NULL, NULL, 'Mismatch repair ATPase Msh2', NULL, NULL, NULL, NULL, NULL, 4),
(202969, NULL, 'G3DSA:2.60.40.10:FF:002995', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202970, NULL, 'G3DSA:2.30.30.40:FF:000627', NULL, NULL, 'MAGUK p55 subfamily member 7', NULL, NULL, NULL, NULL, NULL, 4),
(202971, NULL, 'G3DSA:3.80.10.10:FF:003715', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202972, NULL, 'G3DSA:4.10.1000.10:FF:000095', NULL, NULL, 'C3H-type transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(202973, NULL, 'G3DSA:4.10.410.10:FF:000045', NULL, NULL, 'Collagen type XXVIII alpha 1 a', NULL, NULL, NULL, NULL, NULL, 4),
(202974, NULL, 'G3DSA:1.10.150.50:FF:000143', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(202975, NULL, 'G3DSA:1.20.120.1750:FF:000104', NULL, NULL, 'Protein CBG09610', NULL, NULL, NULL, NULL, NULL, 4),
(202976, NULL, 'G3DSA:2.130.10.10:FF:000882', NULL, NULL, 'Syntaxin-binding protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(202977, NULL, 'G3DSA:3.30.160.60:FF:000174', NULL, NULL, 'Transcriptional repressor protein YY1', NULL, NULL, NULL, NULL, NULL, 4),
(202978, NULL, 'G3DSA:1.20.1070.10:FF:000818', NULL, NULL, 'AGAP011380-PA', NULL, NULL, NULL, NULL, NULL, 4),
(202979, NULL, 'G3DSA:3.90.550.20:FF:000010', NULL, NULL, 'Unplaced genomic scaffold supercont2.19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(202980, NULL, 'G3DSA:1.25.10.10:FF:002234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202981, NULL, 'G3DSA:1.10.10.60:FF:000871', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202982, NULL, 'G3DSA:3.40.50.720:FF:001262', NULL, NULL, 'UDP-glucose 4-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(202983, NULL, 'G3DSA:1.10.10.10:FF:000637', NULL, NULL, 'Histone H1.2', NULL, NULL, NULL, NULL, NULL, 4),
(202984, NULL, 'G3DSA:3.90.1010.20:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202985, NULL, 'G3DSA:3.40.50.2000:FF:000228', NULL, NULL, 'UDP-GlucuronosylTransferase', NULL, NULL, NULL, NULL, NULL, 4),
(202986, NULL, 'G3DSA:3.90.190.10:FF:000018', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type', NULL, NULL, NULL, NULL, NULL, 4),
(202987, NULL, 'G3DSA:3.30.420.40:FF:000115', NULL, NULL, 'Pantothenate kinase PanK', NULL, NULL, NULL, NULL, NULL, 4),
(202988, NULL, 'G3DSA:3.30.160.60:FF:003900', NULL, NULL, 'HKR1, GLI-Kruppel zinc finger family member', NULL, NULL, NULL, NULL, NULL, 4),
(202989, NULL, 'G3DSA:2.160.20.10:FF:000224', NULL, NULL, 'Os05g0578600 protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(202990, NULL, 'G3DSA:2.40.50.140:FF:000147', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(202991, NULL, 'G3DSA:1.20.120.350:FF:000003', NULL, NULL, 'Voltage-dependent sodium channel', NULL, NULL, NULL, NULL, NULL, 4),
(202992, NULL, 'G3DSA:3.90.70.10:FF:000649', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(202993, NULL, 'G3DSA:3.30.160.20:FF:000010', NULL, NULL, 'Peptide chain release factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(202994, NULL, 'G3DSA:1.10.287.1490:FF:000022', NULL, NULL, 'Phosphatidylinositol 3-kinase regulatory subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(202995, NULL, 'G3DSA:2.10.25.10:FF:000591', NULL, NULL, 'Protein eyes shut homolog', NULL, NULL, NULL, NULL, NULL, 4),
(202996, NULL, 'G3DSA:2.60.120.290:FF:000195', NULL, NULL, 'AGAP005526-PA', NULL, NULL, NULL, NULL, NULL, 4),
(202997, NULL, 'G3DSA:3.30.40.10:FF:001179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(202998, NULL, 'G3DSA:1.10.555.10:FF:000223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(202999, NULL, 'G3DSA:2.60.120.260:FF:000652', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203000, NULL, 'G3DSA:3.40.630.40:FF:000016', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(203001, NULL, 'G3DSA:3.40.50.1000:FF:000237', NULL, NULL, 'Putative nuclear LIM factor interactor-interacting protein hyphal form', NULL, NULL, NULL, NULL, NULL, 4),
(203002, NULL, 'G3DSA:1.20.1070.10:FF:000970', NULL, NULL, 'Serotonin receptor 5-HT1a', NULL, NULL, NULL, NULL, NULL, 4),
(203003, NULL, 'G3DSA:3.40.50.300:FF:001372', NULL, NULL, 'ATP-dependent DNA helicase chl1', NULL, NULL, NULL, NULL, NULL, 4),
(203004, NULL, 'G3DSA:2.10.70.10:FF:000015', NULL, NULL, 'CYR61 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(203005, NULL, 'G3DSA:2.60.40.10:FF:003951', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203006, NULL, 'G3DSA:3.90.1720.10:FF:000031', NULL, NULL, 'Gifsy-1 prophage VtaK', NULL, NULL, NULL, NULL, NULL, 4),
(203007, NULL, 'G3DSA:3.30.428.10:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203008, NULL, 'G3DSA:3.30.420.10:FF:000039', NULL, NULL, 'Target of EGR1 protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(203009, NULL, 'G3DSA:1.10.167.10:FF:000041', NULL, NULL, 'Regulator of G-protein signaling rgs-5', NULL, NULL, NULL, NULL, NULL, 4),
(203010, NULL, 'G3DSA:1.10.287.600:FF:000024', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(203011, NULL, 'G3DSA:2.60.40.690:FF:000002', NULL, NULL, 'Complement C4 isoform-A', NULL, NULL, NULL, NULL, NULL, 4),
(203012, NULL, 'G3DSA:2.60.40.10:FF:004440', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203013, NULL, 'G3DSA:3.90.228.20:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203014, NULL, 'G3DSA:1.25.40.10:FF:005288', NULL, NULL, 'SET and MYND domain containing 1b', NULL, NULL, NULL, NULL, NULL, 4),
(203015, NULL, 'G3DSA:3.20.20.80:FF:000569', NULL, NULL, 'Glucosylceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(203016, NULL, 'G3DSA:3.30.160.60:FF:001955', NULL, NULL, 'Jim, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(203017, NULL, 'G3DSA:2.80.10.50:FF:000020', NULL, NULL, 'Fibroblast growth factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(203018, NULL, 'G3DSA:3.20.20.70:FF:000420', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203019, NULL, 'G3DSA:3.40.718.10:FF:000003', NULL, NULL, 'Isocitrate dehydrogenase [NAD] subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(203020, NULL, 'G3DSA:1.10.10.60:FF:001208', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203021, NULL, 'G3DSA:3.10.100.10:FF:000334', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203022, NULL, 'G3DSA:3.30.160.40:FF:000016', NULL, NULL, 'Porphobilinogen deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(203023, NULL, 'G3DSA:3.30.160.60:FF:003580', NULL, NULL, 'Zinc finger protein 813', NULL, NULL, NULL, NULL, NULL, 4),
(203024, NULL, 'G3DSA:3.30.260.10:FF:000037', NULL, NULL, 'Chaperonin TCP20, putative', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(203025, NULL, 'G3DSA:3.40.366.10:FF:000062', NULL, NULL, 'Fatty acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(203026, NULL, 'G3DSA:1.10.10.10:FF:001126', NULL, NULL, 'Two-component system response regulator MprA', NULL, NULL, NULL, NULL, NULL, 4),
(203027, NULL, 'G3DSA:2.10.25.10:FF:001080', NULL, NULL, 'Neurogenic locus protein delta', NULL, NULL, NULL, NULL, NULL, 4),
(203028, NULL, 'G3DSA:2.60.40.340:FF:000009', NULL, NULL, 'Nuclear factor of activated T-cells, cytoplasmic 3', NULL, NULL, NULL, NULL, NULL, 4),
(203029, NULL, 'G3DSA:2.130.10.10:FF:004564', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203030, NULL, 'G3DSA:1.25.40.10:FF:003051', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g60960, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(203031, NULL, 'G3DSA:1.10.555.10:FF:000162', NULL, NULL, 'Mental retardation GTPase activating protein homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(203032, NULL, 'G3DSA:1.10.532.10:FF:000007', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(203033, NULL, 'G3DSA:2.40.50.150:FF:000004', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(203034, NULL, 'G3DSA:2.60.120.330:FF:000049', NULL, NULL, 'Probable iron/ascorbate oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(203035, NULL, 'G3DSA:1.25.40.10:FF:004799', NULL, NULL, 'Anaphase-promoting complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(203036, NULL, 'G3DSA:2.60.40.60:FF:001116', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203037, NULL, 'G3DSA:1.20.1250.20:FF:000392', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(203038, NULL, 'G3DSA:3.30.200.20:FF:000357', NULL, NULL, 'serine/threonine-protein kinase-like protein CCR1', NULL, NULL, NULL, NULL, NULL, 4),
(203039, NULL, 'G3DSA:3.10.50.30:FF:000012', NULL, NULL, 'Transcription elongation factor GreB', NULL, NULL, NULL, NULL, NULL, 4),
(203040, NULL, 'G3DSA:2.130.10.10:FF:001219', NULL, NULL, 'Sortilin-related VPS10 domain-containing receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(203041, NULL, 'G3DSA:1.10.510.10:FF:001862', NULL, NULL, 'Probable serine/threonine-protein kinase zyg-1', NULL, NULL, NULL, NULL, NULL, 4),
(203042, NULL, 'G3DSA:3.20.100.10:FF:000017', NULL, NULL, 'Putative RNA triphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(203043, NULL, 'G3DSA:2.130.10.30:FF:000096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203044, NULL, 'G3DSA:2.10.110.10:FF:000198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203045, NULL, 'G3DSA:3.30.160.60:FF:000202', NULL, NULL, 'Zinc finger protein 574', NULL, NULL, NULL, NULL, NULL, 4),
(203046, NULL, 'G3DSA:3.40.390.10:FF:000084', NULL, NULL, 'Zinc metalloproteinase', NULL, NULL, NULL, NULL, NULL, 4),
(203047, NULL, 'G3DSA:2.60.40.10:FF:004940', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203048, NULL, 'G3DSA:1.10.10.1760:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203049, NULL, 'G3DSA:3.30.420.10:FF:000539', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203050, NULL, 'G3DSA:1.25.40.20:FF:000002', NULL, NULL, 'Ankyrin-2 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(203051, NULL, 'G3DSA:2.30.30.40:FF:000599', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203052, NULL, 'G3DSA:2.30.42.10:FF:000191', NULL, NULL, 'Serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(203053, NULL, 'G3DSA:1.50.10.20:FF:000054', NULL, NULL, 'Os03g0193700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(203054, NULL, 'G3DSA:3.30.160.60:FF:003080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203055, NULL, 'G3DSA:1.25.40.20:FF:000474', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(203056, NULL, 'G3DSA:3.40.850.10:FF:000423', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203057, NULL, 'G3DSA:3.30.310.230:FF:000001', NULL, NULL, 'Sigma factor-binding protein Crl', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(203058, NULL, 'G3DSA:1.25.40.10:FF:005316', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g62370', NULL, NULL, NULL, NULL, NULL, 4),
(203059, NULL, 'G3DSA:3.40.50.300:FF:007532', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203060, NULL, 'G3DSA:1.25.40.10:FF:002854', NULL, NULL, 'Mitochondrial group I intron splicing factor CCM1', NULL, NULL, NULL, NULL, NULL, 4),
(203061, NULL, 'G3DSA:3.80.10.10:FF:003215', NULL, NULL, 'DNA repair protein rhp7', NULL, NULL, NULL, NULL, NULL, 4),
(203062, NULL, 'G3DSA:1.20.5.110:FF:000219', NULL, NULL, 'Syntaxin', NULL, NULL, NULL, NULL, NULL, 4),
(203063, NULL, 'G3DSA:3.30.460.20:FF:000022', NULL, NULL, 'YALI0D00319p', NULL, NULL, NULL, NULL, NULL, 4),
(203064, NULL, 'G3DSA:3.40.50.720:FF:002251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203065, NULL, 'G3DSA:1.25.40.20:FF:001755', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203066, NULL, 'G3DSA:3.90.105.10:FF:000029', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(203067, NULL, 'G3DSA:4.10.60.10:FF:000257', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(203068, NULL, 'G3DSA:1.20.1070.10:FF:001307', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203069, NULL, 'G3DSA:3.30.200.20:FF:001846', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203070, NULL, 'G3DSA:3.30.70.370:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203071, NULL, 'G3DSA:1.10.510.10:FF:003127', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203072, NULL, 'G3DSA:3.40.50.1820:FF:001000', NULL, NULL, 'Putative serine esterase', NULL, NULL, NULL, NULL, NULL, 4),
(203073, NULL, 'G3DSA:2.60.120.10:FF:000558', NULL, NULL, 'cAMP-dependent protein kinase type II-alpha regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(203074, NULL, 'G3DSA:3.40.50.11530:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203075, NULL, 'G3DSA:2.40.10.350:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203076, NULL, 'G3DSA:3.40.50.150:FF:001719', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203077, NULL, 'G3DSA:3.70.10.10:FF:000130', NULL, NULL, 'DNA repair protein rad9', NULL, NULL, NULL, NULL, NULL, 4),
(203078, NULL, 'G3DSA:3.80.10.10:FF:000461', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(203079, NULL, 'G3DSA:1.25.40.20:FF:001463', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203080, NULL, 'G3DSA:1.10.287.110:FF:000265', NULL, NULL, 'WGS project CABT00000000 data, contig 2.17', NULL, NULL, NULL, NULL, NULL, 4),
(203081, NULL, 'G3DSA:1.10.8.60:FF:000179', NULL, NULL, 'Ribosome biogenesis ATPase RIX7', NULL, NULL, NULL, NULL, NULL, 4),
(203082, NULL, 'G3DSA:3.30.70.330:FF:002522', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203083, NULL, 'G3DSA:3.40.50.140:FF:000020', NULL, NULL, 'DNA topoisomerase III', NULL, NULL, NULL, NULL, NULL, 4),
(203084, NULL, 'G3DSA:3.100.10.10:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203085, NULL, 'G3DSA:1.10.630.10:FF:000348', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203086, NULL, 'G3DSA:1.25.10.10:FF:002734', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203087, NULL, 'G3DSA:2.60.120.590:FF:000048', NULL, NULL, 'YALI0D07546p', NULL, NULL, NULL, NULL, NULL, 4),
(203088, NULL, 'G3DSA:1.20.1250.10:FF:000124', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203089, NULL, 'G3DSA:2.130.10.10:FF:002147', NULL, NULL, 'Plexin A4', NULL, NULL, NULL, NULL, NULL, 4),
(203090, NULL, 'G3DSA:2.20.110.10:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203091, NULL, 'G3DSA:3.40.250.10:FF:000074', NULL, NULL, 'Thiosulfate sulfurtransferase like domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(203092, NULL, 'G3DSA:2.60.120.260:FF:000360', NULL, NULL, 'Cellulose synthase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(203093, NULL, 'G3DSA:1.10.510.10:FF:001070', NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-like 1.5', NULL, NULL, NULL, NULL, NULL, 4),
(203094, NULL, 'G3DSA:3.40.50.300:FF:006043', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(203095, NULL, 'G3DSA:3.10.290.10:FF:000055', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(203096, NULL, 'G3DSA:1.10.238.10:FF:001257', NULL, NULL, 'Tubulin polymerization-promoting protein family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(203097, NULL, 'G3DSA:1.10.238.10:FF:000301', NULL, NULL, 'EF-hand calcium-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(203098, NULL, 'G3DSA:1.10.10.750:FF:000029', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(203099, NULL, 'G3DSA:3.40.50.1000:FF:000737', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203100, NULL, 'G3DSA:1.10.510.10:FF:001362', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(203101, NULL, 'G3DSA:1.10.472.10:FF:000328', NULL, NULL, 'Cdk activating kinase (CAK)/RNA polymerase II transcription initiation/nucleotide excision repair factor TFIIH/TFIIK, cyclin H subunit', NULL, NULL, NULL, NULL, NULL, 4),
(203102, NULL, 'G3DSA:2.60.40.10:FF:003512', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203103, NULL, 'G3DSA:3.90.1150.160:FF:000008', NULL, NULL, 'Glutamate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(203104, NULL, 'G3DSA:2.60.120.200:FF:000741', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203105, NULL, 'G3DSA:3.30.160.60:FF:005406', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203106, NULL, 'G3DSA:1.10.10.10:FF:000137', NULL, NULL, 'Zinc uptake transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(203107, NULL, 'G3DSA:3.40.50.2000:FF:000728', NULL, NULL, 'Lipid-A-disaccharide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(203108, NULL, 'G3DSA:1.10.10.10:FF:001565', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(203109, NULL, 'G3DSA:3.40.50.970:FF:000004', NULL, NULL, 'Transketolase', NULL, NULL, NULL, NULL, NULL, 4),
(203110, NULL, 'G3DSA:3.50.50.60:FF:001216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203111, NULL, 'G3DSA:3.40.50.1820:FF:000775', NULL, NULL, 'AGAP000687-PA', NULL, NULL, NULL, NULL, NULL, 4),
(203112, NULL, 'G3DSA:3.40.50.1980:FF:000126', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(203113, NULL, 'G3DSA:1.20.120.1750:FF:000076', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(203114, NULL, 'G3DSA:1.10.510.10:FF:003599', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203115, NULL, 'G3DSA:1.25.40.10:FF:001573', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(203116, NULL, 'G3DSA:3.40.50.300:FF:004659', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(203117, NULL, 'G3DSA:1.25.40.10:FF:004299', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(203118, NULL, 'G3DSA:1.10.1420.10:FF:000022', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(203119, NULL, 'G3DSA:2.40.50.140:FF:001075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203120, NULL, 'G3DSA:3.40.50.2020:FF:000094', NULL, NULL, 'Phosphoribosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(203121, NULL, 'G3DSA:3.40.50.720:FF:002543', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203122, NULL, 'G3DSA:3.60.10.10:FF:000271', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203123, NULL, 'G3DSA:4.10.1080.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203124, NULL, 'G3DSA:3.40.50.300:FF:000736', NULL, NULL, 'Interferon-induced helicase C domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(203125, NULL, 'G3DSA:2.10.25.10:FF:000091', NULL, NULL, 'Fibulin 5', NULL, NULL, NULL, NULL, NULL, 4),
(203126, NULL, 'G3DSA:3.20.20.140:FF:000198', NULL, NULL, 'Rudimentary, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(203127, NULL, 'G3DSA:3.40.50.740:FF:000020', NULL, NULL, 'DMSO reductase', NULL, NULL, NULL, NULL, NULL, 4),
(203128, NULL, 'G3DSA:2.60.40.10:FF:002023', NULL, NULL, 'KETtiN (Drosophila actin-binding) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(203129, NULL, 'G3DSA:3.40.47.10:FF:000148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203130, NULL, 'G3DSA:3.30.420.10:FF:000691', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203131, NULL, 'G3DSA:1.10.8.60:FF:000151', NULL, NULL, 'ATP dependent metalloprotease', NULL, NULL, NULL, NULL, NULL, 4),
(203132, NULL, 'G3DSA:1.10.1520.10:FF:000086', NULL, NULL, 'RNAse THREE-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(203133, NULL, 'G3DSA:2.30.29.30:FF:000672', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(203134, NULL, 'G3DSA:2.170.40.20:FF:000003', NULL, NULL, 'Envelope glycoprotein gp160', NULL, NULL, NULL, NULL, NULL, 4),
(203135, NULL, 'G3DSA:3.90.79.20:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203136, NULL, 'G3DSA:3.40.50.150:FF:001158', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203137, NULL, 'G3DSA:3.10.20.90:FF:000567', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203138, NULL, 'G3DSA:3.30.160.60:FF:005845', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203139, NULL, 'G3DSA:1.10.510.10:FF:002790', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203140, NULL, 'G3DSA:1.10.8.950:FF:000001', NULL, NULL, 'Polymerase cofactor VP35', NULL, NULL, NULL, NULL, NULL, 4),
(203141, NULL, 'G3DSA:1.10.8.270:FF:000011', NULL, NULL, 'TBC1 domain family member 5', NULL, NULL, NULL, NULL, NULL, 4),
(203142, NULL, 'G3DSA:1.20.1250.20:FF:001673', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203143, NULL, 'G3DSA:1.10.590.10:FF:000001', NULL, NULL, 'Chorismate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(203144, NULL, 'G3DSA:3.30.470.20:FF:000079', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(203145, NULL, 'G3DSA:2.40.30.170:FF:000034', NULL, NULL, 'Efflux transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(203146, NULL, 'G3DSA:2.30.40.10:FF:000057', NULL, NULL, 'Imidazolonepropionase-like amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(203147, NULL, 'G3DSA:1.25.10.10:FF:003223', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(203148, NULL, 'G3DSA:3.30.200.20:FF:001285', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(203149, NULL, 'G3DSA:2.60.40.60:FF:000599', NULL, NULL, 'Protocadherin 20', NULL, NULL, NULL, NULL, NULL, 4),
(203150, NULL, 'G3DSA:2.30.42.10:FF:000039', NULL, NULL, 'Lin-7 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(203151, NULL, 'G3DSA:2.60.40.60:FF:001088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203152, NULL, 'G3DSA:3.90.1200.10:FF:000036', NULL, NULL, 'N-acetylhexosamine 1-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(203153, NULL, 'G3DSA:3.40.950.10:FF:000015', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor nar1', NULL, NULL, NULL, NULL, NULL, 4),
(203154, NULL, 'G3DSA:3.10.350.10:FF:000026', NULL, NULL, 'Peptidoglycan endopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(203155, NULL, 'G3DSA:1.20.990.10:FF:000024', NULL, NULL, 'NADPH-cytochrome p450 reductase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(203156, NULL, 'G3DSA:1.20.1050.40:FF:000011', NULL, NULL, 'Thimet oligopeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(203157, NULL, 'G3DSA:3.40.50.1460:FF:000032', NULL, NULL, 'Caspase 1', NULL, NULL, NULL, NULL, NULL, 4),
(203158, NULL, 'G3DSA:4.10.1240.10:FF:000017', NULL, NULL, 'Glucagon like peptide 2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(203159, NULL, 'G3DSA:3.40.190.10:FF:000395', NULL, NULL, 'Oligopeptide ABC transporter, solute-binding protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(203160, NULL, 'G3DSA:3.30.70.330:FF:000313', NULL, NULL, 'Alkylated DNA repair protein alkB homolog 8', NULL, NULL, NULL, NULL, NULL, 4),
(203161, NULL, 'G3DSA:2.60.40.10:FF:005749', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203162, NULL, 'G3DSA:1.20.1250.20:FF:000745', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(203163, NULL, 'G3DSA:3.30.50.10:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203164, NULL, 'G3DSA:1.20.1110.10:FF:000053', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(203165, NULL, 'G3DSA:3.40.190.290:FF:000055', NULL, NULL, 'Putative transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(203166, NULL, 'G3DSA:2.130.10.10:FF:004917', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203167, NULL, 'G3DSA:3.40.50.2300:FF:001156', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203168, NULL, 'G3DSA:3.30.70.330:FF:001241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203169, NULL, 'G3DSA:2.40.30.20:FF:000008', NULL, NULL, 'Riboflavin synthase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(203170, NULL, 'G3DSA:2.30.29.30:FF:000525', NULL, NULL, 'Ran GTPase-activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(203171, NULL, 'G3DSA:3.30.160.60:FF:006334', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203172, NULL, 'G3DSA:3.30.450.20:FF:000196', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203173, NULL, 'G3DSA:3.90.1150.10:FF:000155', NULL, NULL, 'Serine palmitoyltransferase component', NULL, NULL, NULL, NULL, NULL, 4),
(203174, NULL, 'G3DSA:3.40.630.30:FF:000598', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(203175, NULL, 'G3DSA:1.10.3260.10:FF:000015', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(203176, NULL, 'G3DSA:2.40.50.1020:FF:000002', NULL, NULL, 'DNA-binding response regulator AlgR', NULL, NULL, NULL, NULL, NULL, 4),
(203177, NULL, 'G3DSA:3.40.50.12120:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203178, NULL, 'G3DSA:3.40.50.10470:FF:000042', NULL, NULL, 'Methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(203179, NULL, 'G3DSA:3.30.450.20:FF:000049', NULL, NULL, 'Sensor histidine kinase DpiB', NULL, NULL, NULL, NULL, NULL, 4),
(203180, NULL, 'G3DSA:3.40.20.10:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203181, NULL, 'G3DSA:3.40.50.12470:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203182, NULL, 'G3DSA:1.25.40.10:FF:001134', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(203183, NULL, 'G3DSA:3.40.50.10140:FF:000027', NULL, NULL, 'Toll-6', NULL, NULL, NULL, NULL, NULL, 4),
(203184, NULL, 'G3DSA:2.60.120.10:FF:000530', NULL, NULL, 'cGMP-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(203185, NULL, 'G3DSA:3.40.50.300:FF:008021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203186, NULL, 'G3DSA:3.60.60.10:FF:000010', NULL, NULL, 'Acyl-coenzyme A:6-aminopenicillanic-acid-acyltransferase 40 kDa form', NULL, NULL, NULL, NULL, NULL, 4),
(203187, NULL, 'G3DSA:1.10.10.10:FF:000929', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(203188, NULL, 'G3DSA:1.10.20.10:FF:000082', NULL, NULL, 'Transcriptional activator, variant', NULL, NULL, NULL, NULL, NULL, 4),
(203189, NULL, 'G3DSA:2.40.50.140:FF:000439', NULL, NULL, '23S rRNA (uracil(747)-C(5))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(203190, NULL, 'G3DSA:3.30.160.60:FF:004389', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203191, NULL, 'G3DSA:2.160.20.10:FF:000196', NULL, NULL, 'tRNA nuclease CdiA-2', NULL, NULL, NULL, NULL, NULL, 4),
(203192, NULL, 'G3DSA:1.20.58.2220:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203193, NULL, 'G3DSA:1.20.1070.10:FF:001015', NULL, NULL, 'Si:ch211-119o8.4', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(203194, NULL, 'G3DSA:3.20.20.100:FF:000181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203195, NULL, 'G3DSA:2.130.10.10:FF:004272', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203196, NULL, 'G3DSA:3.40.50.2000:FF:000880', NULL, NULL, 'Putative colanic acid biosynthesis glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(203197, NULL, 'G3DSA:2.30.29.30:FF:001189', NULL, NULL, 'Ran-binding protein 1 homolog a', NULL, NULL, NULL, NULL, NULL, 4),
(203198, NULL, 'G3DSA:1.25.40.60:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203199, NULL, 'G3DSA:1.10.287.70:FF:000371', NULL, NULL, 'TWiK family of potassium channels', NULL, NULL, NULL, NULL, NULL, 4),
(203200, NULL, 'G3DSA:2.60.120.620:FF:000131', NULL, NULL, 'Predicted gene, 28038', NULL, NULL, NULL, NULL, NULL, 4),
(203201, NULL, 'G3DSA:3.50.50.60:FF:001396', NULL, NULL, 'Gll1923 protein', NULL, NULL, NULL, NULL, NULL, 4),
(203202, NULL, 'G3DSA:3.30.40.10:FF:000370', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(203203, NULL, 'G3DSA:3.40.50.300:FF:001664', NULL, NULL, 'MSHA biogenesis protein MshM', NULL, NULL, NULL, NULL, NULL, 4),
(203204, NULL, 'G3DSA:3.90.1680.10:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203205, NULL, 'G3DSA:3.30.830.10:FF:000093', NULL, NULL, 'Zinc protease, insulinase family', NULL, NULL, NULL, NULL, NULL, 4),
(203206, NULL, 'G3DSA:1.20.58.1060:FF:000007', NULL, NULL, 'Wu:fi04e12', NULL, NULL, NULL, NULL, NULL, 4),
(203207, NULL, 'G3DSA:1.20.1560.10:FF:000726', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203208, NULL, 'G3DSA:2.30.29.30:FF:001161', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203209, NULL, 'G3DSA:3.30.160.60:FF:001663', NULL, NULL, 'ZFP57 zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(203210, NULL, 'G3DSA:1.10.486.10:FF:000006', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(203211, NULL, 'G3DSA:1.10.20.140:FF:000005', NULL, NULL, 'Putative tRNA delta(2)-isopentenylpyrophosphate transferase', NULL, NULL, NULL, NULL, NULL, 4),
(203212, NULL, 'G3DSA:3.20.20.60:FF:000030', NULL, NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(203213, NULL, 'G3DSA:3.30.160.60:FF:003872', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203214, NULL, 'G3DSA:3.40.50.300:FF:005587', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(203215, NULL, 'G3DSA:3.40.50.300:FF:003350', NULL, NULL, 'Structural maintenance of chromosomes protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(203216, NULL, 'G3DSA:2.60.40.1180:FF:000006', NULL, NULL, 'Putative family 31 glucosidase KIAA1161', NULL, NULL, NULL, NULL, NULL, 4),
(203217, NULL, 'G3DSA:1.20.58.2220:FF:000041', NULL, NULL, 'Diaphanous protein, homolog 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(203218, NULL, 'G3DSA:3.60.140.10:FF:000022', NULL, NULL, 'Polyphenol oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(203219, NULL, 'G3DSA:3.40.850.10:FF:000131', NULL, NULL, 'Kinesin family member 25', NULL, NULL, NULL, NULL, NULL, 4),
(203220, NULL, 'G3DSA:3.40.50.300:FF:002861', NULL, NULL, 'Cell division control protein 48 homolog E', NULL, NULL, NULL, NULL, NULL, 4),
(203221, NULL, 'G3DSA:2.60.40.150:FF:000694', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203222, NULL, 'G3DSA:2.20.100.10:FF:000116', NULL, NULL, 'Thrombospondin protein-1', NULL, NULL, NULL, NULL, NULL, 4),
(203223, NULL, 'G3DSA:3.40.50.720:FF:001795', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(203224, NULL, 'G3DSA:3.30.710.10:FF:000466', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203225, NULL, 'G3DSA:2.60.120.650:FF:000235', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203226, NULL, 'G3DSA:3.10.10.10:FF:000060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203227, NULL, 'G3DSA:1.20.58.60:FF:000464', NULL, NULL, 'Protein CBR-SMA-1', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(203228, NULL, 'G3DSA:3.90.70.10:FF:000116', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 20', NULL, NULL, NULL, NULL, NULL, 4),
(203229, NULL, 'G3DSA:4.10.410.10:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203230, NULL, 'G3DSA:1.10.238.10:FF:000240', NULL, NULL, 'EF-hand calcium-binding domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(203231, NULL, 'G3DSA:3.30.70.330:FF:001741', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203232, NULL, 'G3DSA:1.25.40.10:FF:000645', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(203233, NULL, 'G3DSA:1.20.1250.20:FF:001881', NULL, NULL, 'Major facilitator superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(203234, NULL, 'G3DSA:3.40.50.720:FF:001907', NULL, NULL, 'Short-chain dehydrogenase/reductase SDR', NULL, NULL, NULL, NULL, NULL, 4),
(203235, NULL, 'G3DSA:2.130.10.10:FF:001366', NULL, NULL, 'WD repeat-containing protein 37', NULL, NULL, NULL, NULL, NULL, 4),
(203236, NULL, 'G3DSA:3.40.50.300:FF:003850', NULL, NULL, 'Si:dkey-79f11.8', NULL, NULL, NULL, NULL, NULL, 4),
(203237, NULL, 'G3DSA:1.20.1080.10:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203238, NULL, 'G3DSA:1.25.40.90:FF:000034', NULL, NULL, 'Phosphatidylinositol-binding clathrin assembly protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(203239, NULL, 'G3DSA:3.20.20.80:FF:000277', NULL, NULL, '4-alpha-glucanotransferase, amylo-alpha-1,6-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(203240, NULL, 'G3DSA:3.90.79.10:FF:000169', NULL, NULL, 'Mutator MutT protein', NULL, NULL, NULL, NULL, NULL, 4),
(203241, NULL, 'G3DSA:3.30.60.20:FF:000082', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(203242, NULL, 'G3DSA:1.10.441.10:FF:000009', NULL, NULL, 'Mannose-6-phosphate isomerase, class I', NULL, NULL, NULL, NULL, NULL, 4),
(203243, NULL, 'G3DSA:3.40.630.30:FF:000570', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203244, NULL, 'G3DSA:2.60.120.290:FF:000048', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(203245, NULL, 'G3DSA:3.90.550.10:FF:000445', NULL, NULL, 'Exostosin-2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(203246, NULL, 'G3DSA:3.40.50.620:FF:000130', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(203247, NULL, 'G3DSA:2.60.200.20:FF:000096', NULL, NULL, 'Microspherule protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(203248, NULL, 'G3DSA:1.10.510.10:FF:002290', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203249, NULL, 'G3DSA:2.10.25.10:FF:000444', NULL, NULL, 'von Willebrand factor', NULL, NULL, NULL, NULL, NULL, 4),
(203250, NULL, 'G3DSA:4.10.1000.10:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203251, NULL, 'G3DSA:3.40.50.200:FF:000032', NULL, NULL, 'Cell wall-associated serine proteinase', NULL, NULL, NULL, NULL, NULL, 4),
(203252, NULL, 'G3DSA:1.10.10.440:FF:000060', NULL, NULL, 'GH18144p', NULL, NULL, NULL, NULL, NULL, 4),
(203253, NULL, 'G3DSA:3.30.780.10:FF:000032', NULL, NULL, 'Translation machinery-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(203254, NULL, 'G3DSA:3.40.50.2300:FF:000672', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203255, NULL, 'G3DSA:1.10.238.10:FF:001318', NULL, NULL, 'Solute carrier family 25 member 23b', NULL, NULL, NULL, NULL, NULL, 4),
(203256, NULL, 'G3DSA:1.20.1560.10:FF:000165', NULL, NULL, 'Unplaced genomic scaffold supercont1.71, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(203257, NULL, 'G3DSA:3.30.470.20:FF:000112', NULL, NULL, 'Phosphoribosylaminoimidazole carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(203258, NULL, 'G3DSA:1.10.630.10:FF:000320', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203259, NULL, 'G3DSA:1.20.1250.20:FF:000245', NULL, NULL, 'MFS allantoate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(203260, NULL, 'G3DSA:3.30.450.50:FF:000064', NULL, NULL, 'Putative vesicle-associated membrane protein family protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(203261, NULL, 'G3DSA:1.20.1050.130:FF:000029', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(203262, NULL, 'G3DSA:3.40.50.10810:FF:000127', NULL, NULL, 'Helicase SNF2', NULL, NULL, NULL, NULL, NULL, 4),
(203263, NULL, 'G3DSA:1.10.150.20:FF:000275', NULL, NULL, 'DNA repair protein rad16', NULL, NULL, NULL, NULL, NULL, 4),
(203264, NULL, 'G3DSA:2.60.120.260:FF:000152', NULL, NULL, 'Rhamnogalacturonate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(203265, NULL, 'G3DSA:3.40.50.150:FF:000910', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203266, NULL, 'G3DSA:2.130.10.10:FF:005109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203267, NULL, 'G3DSA:3.30.160.60:FF:002411', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203268, NULL, 'G3DSA:2.60.470.10:FF:000022', NULL, NULL, 'Pickpocket protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(203269, NULL, 'G3DSA:3.30.200.20:FF:000918', NULL, NULL, 'Myosin Light Chain Kinase related', NULL, NULL, NULL, NULL, NULL, 4),
(203270, NULL, 'G3DSA:1.10.630.10:FF:000409', NULL, NULL, 'Cytochrome P450 oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(203271, NULL, 'G3DSA:3.40.30.10:FF:000964', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203272, NULL, 'G3DSA:2.40.100.10:FF:000073', NULL, NULL, 'Putative cyclosporin 16', NULL, NULL, NULL, NULL, NULL, 4),
(203273, NULL, 'G3DSA:3.40.1280.10:FF:000070', NULL, NULL, 'AGAP005864-PA', NULL, NULL, NULL, NULL, NULL, 4),
(203274, NULL, 'G3DSA:3.30.200.20:FF:001054', NULL, NULL, 'Serine/threonine-protein kinase WNK1', NULL, NULL, NULL, NULL, NULL, 4),
(203275, NULL, 'G3DSA:2.20.25.630:FF:000003', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(203276, NULL, 'G3DSA:2.60.40.10:FF:001242', NULL, NULL, 'Sialic acid binding Ig like lectin 11', NULL, NULL, NULL, NULL, NULL, 4),
(203277, NULL, 'G3DSA:3.40.50.720:FF:002312', NULL, NULL, 'AGR227Wp', NULL, NULL, NULL, NULL, NULL, 4),
(203278, NULL, 'G3DSA:3.40.50.300:FF:001080', NULL, NULL, 'Dynein, axonemal, heavy chain 5', NULL, NULL, NULL, NULL, NULL, 4),
(203279, NULL, 'G3DSA:1.10.10.750:FF:000001', NULL, NULL, 'TBC1 domain family member 10A', NULL, NULL, NULL, NULL, NULL, 4),
(203280, NULL, 'G3DSA:3.40.50.1100:FF:000149', NULL, NULL, 'Cysteine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(203281, NULL, 'G3DSA:3.30.160.60:FF:001455', NULL, NULL, 'myoneurin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(203282, NULL, 'G3DSA:3.30.450.20:FF:000257', NULL, NULL, 'Similar to serine threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(203283, NULL, 'G3DSA:1.20.1420.30:FF:000110', NULL, NULL, 'Potassium-dependent sodium-calcium exchanger, putative', NULL, NULL, NULL, NULL, NULL, 4),
(203284, NULL, 'G3DSA:1.50.40.10:FF:000345', NULL, NULL, 'Solute carrier family 25 member 22b', NULL, NULL, NULL, NULL, NULL, 4),
(203285, NULL, 'G3DSA:3.90.1150.10:FF:000094', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(203286, NULL, 'G3DSA:3.30.60.30:FF:000028', NULL, NULL, 'Follistatin-related protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(203287, NULL, 'G3DSA:3.10.250.10:FF:000081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203288, NULL, 'G3DSA:3.30.559.10:FF:000012', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(203289, NULL, 'G3DSA:1.25.10.10:FF:000025', NULL, NULL, 'Calcium-binding protein 39', NULL, NULL, NULL, NULL, NULL, 4),
(203290, NULL, 'G3DSA:3.40.50.1010:FF:000274', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203291, NULL, 'G3DSA:2.10.90.10:FF:000078', NULL, NULL, 'Putative bursicon beta', NULL, NULL, NULL, NULL, NULL, 4),
(203292, NULL, 'G3DSA:1.20.140.10:FF:000067', NULL, NULL, 'Oxidoreductase, mmfh', NULL, NULL, NULL, NULL, NULL, 4),
(203293, NULL, 'G3DSA:1.10.1090.10:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203294, NULL, 'G3DSA:2.30.39.10:FF:000020', NULL, NULL, 'Serpin family B member 8', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(203295, NULL, 'G3DSA:3.30.559.10:FF:000276', NULL, NULL, 'Choline oacetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(203296, NULL, 'G3DSA:3.30.497.10:FF:000143', NULL, NULL, 'AT24862p', NULL, NULL, NULL, NULL, NULL, 4),
(203297, NULL, 'G3DSA:3.10.250.10:FF:000137', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203298, NULL, 'G3DSA:1.25.10.10:FF:003370', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203299, NULL, 'G3DSA:1.25.10.10:FF:000497', NULL, NULL, 'Reticulocyte binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(203300, NULL, 'G3DSA:3.40.50.300:FF:005407', NULL, NULL, 'PDR-like ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(203301, NULL, 'G3DSA:1.10.101.10:FF:000018', NULL, NULL, 'PDZ-containing carboxyl-terminal proteaseprocessing protease', NULL, NULL, NULL, NULL, NULL, 4),
(203302, NULL, 'G3DSA:1.25.40.10:FF:005108', NULL, NULL, 'Response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(203303, NULL, 'G3DSA:2.40.70.10:FF:000244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203304, NULL, 'G3DSA:2.10.220.10:FF:000116', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(203305, NULL, 'G3DSA:3.40.50.1100:FF:000060', NULL, NULL, 'N-(2-amino-2-carboxyethyl)-L-glutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(203306, NULL, 'G3DSA:2.60.40.2030:FF:000036', NULL, NULL, 'Adhesion G protein-coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(203307, NULL, 'G3DSA:3.60.21.10:FF:000116', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(203308, NULL, 'G3DSA:3.40.50.80:FF:000087', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(203309, NULL, 'G3DSA:3.30.70.330:FF:000577', NULL, NULL, 'Blast:RNA-binding protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(203310, NULL, 'G3DSA:3.40.1110.10:FF:000024', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(203311, NULL, 'G3DSA:2.130.10.10:FF:005261', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203312, NULL, 'G3DSA:2.60.40.10:FF:005457', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203313, NULL, 'G3DSA:3.30.930.10:FF:000302', NULL, NULL, 'Prolyl-tRNA synthetase (AFU_orthologue AFUA_1G10750)', NULL, NULL, NULL, NULL, NULL, 4),
(203314, NULL, 'G3DSA:3.30.360.10:FF:000129', NULL, NULL, 'Josephin domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(203315, NULL, 'G3DSA:2.30.180.10:FF:000102', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203316, NULL, 'G3DSA:3.40.50.1110:FF:000006', NULL, NULL, 'O-acetyltransferase OatA', NULL, NULL, NULL, NULL, NULL, 4),
(203317, NULL, 'G3DSA:1.10.40.30:FF:000004', NULL, NULL, 'Adenylosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(203318, NULL, 'G3DSA:3.40.250.10:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203319, NULL, 'G3DSA:3.40.50.150:FF:001366', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203320, NULL, 'G3DSA:3.30.160.60:FF:002883', NULL, NULL, 'Hunchback-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(203321, NULL, 'G3DSA:1.10.287.920:FF:000002', NULL, NULL, 'Mating-type alpha-pheromone receptor PreB', NULL, NULL, NULL, NULL, NULL, 4),
(203322, NULL, 'G3DSA:2.40.50.90:FF:000103', NULL, NULL, 'Mitochondrial succinoglycan biosynthesis protein-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(203323, NULL, 'G3DSA:3.40.50.2300:FF:000728', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203324, NULL, 'G3DSA:2.30.30.30:FF:000006', NULL, NULL, '60S ribosomal protein L8', NULL, NULL, NULL, NULL, NULL, 4),
(203325, NULL, 'G3DSA:3.90.15.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203326, NULL, 'G3DSA:3.80.10.10:FF:002434', NULL, NULL, 'MDIS1-interacting receptor like kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(203327, NULL, 'G3DSA:3.40.50.300:FF:004570', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(203328, NULL, 'G3DSA:1.20.140.150:FF:000043', NULL, NULL, 'Clarin 3', NULL, NULL, NULL, NULL, NULL, 4),
(203329, NULL, 'G3DSA:2.70.170.10:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203330, NULL, 'G3DSA:2.130.10.10:FF:001158', NULL, NULL, 'Semaphorin-4E', NULL, NULL, NULL, NULL, NULL, 4),
(203331, NULL, 'G3DSA:2.60.120.290:FF:000256', NULL, NULL, 'Cubilin-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(203332, NULL, 'G3DSA:3.10.20.310:FF:000032', NULL, NULL, 'Outer membrane protein assembly factor BamA', NULL, NULL, NULL, NULL, NULL, 4),
(203333, NULL, 'G3DSA:2.30.30.380:FF:000032', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(203334, NULL, 'G3DSA:3.40.630.10:FF:000412', NULL, NULL, 'Acetylornithine deacetylase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(203335, NULL, 'G3DSA:1.10.10.10:FF:001334', NULL, NULL, 'Cullin-5', NULL, NULL, NULL, NULL, NULL, 4),
(203336, NULL, 'G3DSA:3.30.70.330:FF:001533', NULL, NULL, 'Multiple RNA-binding domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(203337, NULL, 'G3DSA:3.20.20.80:FF:000069', NULL, NULL, 'Beta-glucosidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(203338, NULL, 'G3DSA:1.10.8.270:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203339, NULL, 'G3DSA:2.10.25.10:FF:001400', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203340, NULL, 'G3DSA:2.30.29.30:FF:000964', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203341, NULL, 'G3DSA:3.90.1150.10:FF:000447', NULL, NULL, '4-aminobutyrate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(203342, NULL, 'G3DSA:1.20.120.350:FF:000150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203343, NULL, 'G3DSA:3.10.20.90:FF:000275', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(203344, NULL, 'G3DSA:1.10.238.210:FF:000010', NULL, NULL, 'Glutaminase like', NULL, NULL, NULL, NULL, NULL, 4),
(203345, NULL, 'G3DSA:3.40.630.30:FF:000418', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203346, NULL, 'G3DSA:1.25.40.790:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203347, NULL, 'G3DSA:3.30.9.10:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203348, NULL, 'G3DSA:3.40.190.10:FF:000687', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203349, NULL, 'G3DSA:3.30.1520.10:FF:000057', NULL, NULL, 'Snx4p', NULL, NULL, NULL, NULL, NULL, 4),
(203350, NULL, 'G3DSA:2.60.120.330:FF:000021', NULL, NULL, 'Gibberellin 2-beta-dioxygenase 8', NULL, NULL, NULL, NULL, NULL, 4),
(203351, NULL, 'G3DSA:3.80.10.10:FF:000489', NULL, NULL, 'Centrosomal protein of 72 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(203352, NULL, 'G3DSA:2.70.130.10:FF:000006', NULL, NULL, 'Insulin-like growth factor 2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(203353, NULL, 'G3DSA:3.40.50.1820:FF:000275', NULL, NULL, 'Prolyl endopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(203354, NULL, 'G3DSA:2.70.150.10:FF:000069', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(203355, NULL, 'G3DSA:2.130.10.10:FF:000702', NULL, NULL, 'WD repeat-containing protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(203356, NULL, 'G3DSA:2.60.20.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203357, NULL, 'G3DSA:3.90.176.10:FF:000002', NULL, NULL, 'NAD(P)(+)--arginine ADP-ribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(203358, NULL, 'G3DSA:1.25.40.180:FF:000163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203359, NULL, 'G3DSA:1.10.8.60:FF:000207', NULL, NULL, 'Lon protease homolog 2, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(203360, NULL, 'G3DSA:3.40.50.620:FF:000394', NULL, NULL, 'Bifunctional protein HldE', NULL, NULL, NULL, NULL, NULL, 4),
(203361, NULL, 'G3DSA:3.40.50.300:FF:005295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(203362, NULL, 'G3DSA:3.90.1110.10:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203363, NULL, 'G3DSA:1.10.287.70:FF:000724', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203364, NULL, 'G3DSA:1.10.275.10:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203365, NULL, 'G3DSA:2.60.40.10:FF:003804', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203366, NULL, 'G3DSA:1.10.640.10:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203367, NULL, 'G3DSA:3.90.1030.10:FF:000028', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203368, NULL, 'G3DSA:3.40.1170.60:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203369, NULL, 'G3DSA:1.20.272.10:FF:000002', NULL, NULL, 'Replication factor C subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(203370, NULL, 'G3DSA:1.20.1250.20:FF:000453', NULL, NULL, 'MFS allantoate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(203371, NULL, 'G3DSA:1.20.120.1530:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203372, NULL, 'G3DSA:2.130.10.10:FF:003928', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(203373, NULL, 'G3DSA:3.90.1180.10:FF:000011', NULL, NULL, 'Probable MRPL23-mitochondrial ribosomal protein, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(203374, NULL, 'G3DSA:2.80.10.50:FF:000048', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(203375, NULL, 'G3DSA:3.30.160.60:FF:003400', NULL, NULL, 'Schnurri, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(203376, NULL, 'G3DSA:1.10.560.10:FF:000084', NULL, NULL, '60 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(203377, NULL, 'G3DSA:3.90.1260.10:FF:000012', NULL, NULL, 'Os11g0303050 protein', NULL, NULL, NULL, NULL, NULL, 4),
(203378, NULL, 'G3DSA:1.10.4160.10:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203379, NULL, 'G3DSA:3.40.1170.10:FF:000033', NULL, NULL, 'YALI0B10197p', NULL, NULL, NULL, NULL, NULL, 4),
(203380, NULL, 'G3DSA:1.10.150.20:FF:000067', NULL, NULL, 'DNA polymerase A', NULL, NULL, NULL, NULL, NULL, 4),
(203381, NULL, 'G3DSA:2.60.60.20:FF:000026', NULL, NULL, 'Embryo-specific protein ATS3A', NULL, NULL, NULL, NULL, NULL, 4),
(203382, NULL, 'G3DSA:3.80.10.10:FF:002698', NULL, NULL, 'MDIS1-interacting receptor like kinase 2 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(203383, NULL, 'G3DSA:2.110.10.10:FF:000012', NULL, NULL, 'Matrix metallopeptidase 21', NULL, NULL, NULL, NULL, NULL, 4),
(203384, NULL, 'G3DSA:2.20.140.10:FF:000001', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(203385, NULL, 'G3DSA:3.30.420.40:FF:000379', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(203386, NULL, 'G3DSA:3.90.850.10:FF:000018', NULL, NULL, 'Putative hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(203387, NULL, 'G3DSA:1.10.287.3490:FF:000004', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 11', NULL, NULL, NULL, NULL, NULL, 4),
(203388, NULL, 'G3DSA:1.10.3450.40:FF:000005', NULL, NULL, 'Signal recognition particle subunit SRP68', NULL, NULL, NULL, NULL, NULL, 4),
(203389, NULL, 'G3DSA:1.20.120.1630:FF:000006', NULL, NULL, 'Putative 7-dehydrocholesterol reductase', NULL, NULL, NULL, NULL, NULL, 4),
(203390, NULL, 'G3DSA:1.10.287.70:FF:000140', NULL, NULL, 'cation channel sperm-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(203391, NULL, 'G3DSA:3.40.50.300:FF:008313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203392, NULL, 'G3DSA:2.60.40.10:FF:003304', NULL, NULL, 'Leukemia inhibitory factor receptor alpha b', NULL, NULL, NULL, NULL, NULL, 4),
(203393, NULL, 'G3DSA:3.10.450.280:FF:000001', NULL, NULL, 'Beta-lactamase', NULL, NULL, NULL, NULL, NULL, 4),
(203394, NULL, 'G3DSA:2.60.40.10:FF:002170', NULL, NULL, 'Immunoglobulin superfamily, member 3', NULL, NULL, NULL, NULL, NULL, 4),
(203395, NULL, 'G3DSA:2.40.20.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(203396, NULL, 'G3DSA:2.10.70.10:FF:000279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203397, NULL, 'G3DSA:2.60.40.10:FF:001034', NULL, NULL, 'Uncharacterized protein, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(203398, NULL, 'G3DSA:1.20.1070.10:FF:000998', NULL, NULL, 'Olfactory receptor 1260', NULL, NULL, NULL, NULL, NULL, 4),
(203399, NULL, 'G3DSA:1.20.930.10:FF:000020', NULL, NULL, 'Transcription elongation factor A (SII), 3', NULL, NULL, NULL, NULL, NULL, 4),
(203400, NULL, 'G3DSA:1.10.287.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203401, NULL, 'G3DSA:1.10.150.60:FF:000028', NULL, NULL, 'Filamentous growth regulator', NULL, NULL, NULL, NULL, NULL, 4),
(203402, NULL, 'G3DSA:1.10.287.1060:FF:000011', NULL, NULL, 'Vacuolar protein sorting-associated protein 32', NULL, NULL, NULL, NULL, NULL, 4),
(203403, NULL, 'G3DSA:1.25.10.10:FF:000289', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(203404, NULL, 'G3DSA:2.120.10.30:FF:000349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203405, NULL, 'G3DSA:1.10.10.60:FF:001147', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203406, NULL, 'G3DSA:3.20.20.80:FF:000541', NULL, NULL, 'AGAP007182-PA', NULL, NULL, NULL, NULL, NULL, 4),
(203407, NULL, 'G3DSA:2.40.160.20:FF:000023', NULL, NULL, 'Outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(203408, NULL, 'G3DSA:1.10.132.110:FF:000004', NULL, NULL, 'Serum amyloid A protein', NULL, NULL, NULL, NULL, NULL, 4),
(203409, NULL, 'G3DSA:1.25.10.10:FF:000609', NULL, NULL, 'Armadillo repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(203410, NULL, 'G3DSA:1.10.472.10:FF:000536', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203411, NULL, 'G3DSA:3.40.30.10:FF:001245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203412, NULL, 'G3DSA:2.40.50.140:FF:001283', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203413, NULL, 'G3DSA:3.40.50.300:FF:003642', NULL, NULL, 'Cobalt ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(203414, NULL, 'G3DSA:2.130.10.10:FF:005053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203415, NULL, 'G3DSA:3.40.50.720:FF:000126', NULL, NULL, 'UDP-N-acetylmuramoylalanine--D-glutamate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(203416, NULL, 'G3DSA:2.10.109.10:FF:000009', NULL, NULL, 'Prophage repressor CI', NULL, NULL, NULL, NULL, NULL, 4),
(203417, NULL, 'G3DSA:2.60.120.380:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203418, NULL, 'G3DSA:3.30.1240.10:FF:000075', NULL, NULL, 'Cof-like hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(203419, NULL, 'G3DSA:1.10.150.50:FF:000082', NULL, NULL, 'Polarized growth protein boi2', NULL, NULL, NULL, NULL, NULL, 4),
(203420, NULL, 'G3DSA:3.90.730.10:FF:000010', NULL, NULL, 'Ribonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(203421, NULL, 'G3DSA:3.10.129.10:FF:000237', NULL, NULL, 'Acyl-[acyl-carrier-protein] hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(203422, NULL, 'G3DSA:3.40.50.1820:FF:000983', NULL, NULL, 'Sn1-specific diacylglycerol lipase alpha', NULL, NULL, NULL, NULL, NULL, 4),
(203423, NULL, 'G3DSA:1.10.540.10:FF:000021', NULL, NULL, 'Isovaleryl-CoA dehydrogenase IvdA', NULL, NULL, NULL, NULL, NULL, 4),
(203424, NULL, 'G3DSA:3.40.350.10:FF:000019', NULL, NULL, 'Aminopeptidase YpdF', NULL, NULL, NULL, NULL, NULL, 4),
(203425, NULL, 'G3DSA:2.60.40.640:FF:000009', NULL, NULL, 'Down syndrome critical region protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(203426, NULL, 'G3DSA:1.10.460.10:FF:000020', NULL, NULL, 'DNA topoisomerase 3-alpha', NULL, NULL, NULL, NULL, NULL, 4),
(203427, NULL, 'G3DSA:3.30.70.260:FF:000005', NULL, NULL, 'Glycine cleavage system transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(203428, NULL, 'G3DSA:1.20.5.170:FF:000282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203429, NULL, 'G3DSA:1.20.58.830:FF:000030', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(203430, NULL, 'G3DSA:2.130.10.30:FF:000124', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203431, NULL, 'G3DSA:1.25.40.10:FF:001365', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g25360', NULL, NULL, NULL, NULL, NULL, 4),
(203432, NULL, 'G3DSA:3.40.640.10:FF:000385', NULL, NULL, 'Aminotransferase (Class 5)', NULL, NULL, NULL, NULL, NULL, 4),
(203433, NULL, 'G3DSA:2.60.40.10:FF:004468', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203434, NULL, 'G3DSA:2.40.70.10:FF:000036', NULL, NULL, 'Vacuolar aspartic protease', NULL, NULL, NULL, NULL, NULL, 4),
(203435, NULL, 'G3DSA:3.30.420.10:FF:000011', NULL, NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', NULL, NULL, NULL, NULL, NULL, 4),
(203436, NULL, 'G3DSA:1.10.287.1080:FF:000017', NULL, NULL, 'Nucleoside triphosphate pyrophosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(203437, NULL, 'G3DSA:3.30.70.270:FF:000065', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(203438, NULL, 'G3DSA:1.10.287.70:FF:000663', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203439, NULL, 'G3DSA:3.40.50.300:FF:001433', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(203440, NULL, 'G3DSA:3.30.428.10:FF:000040', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(203441, NULL, 'G3DSA:2.130.10.10:FF:000438', NULL, NULL, 'TAF5-like RNA polymerase II p300/CBP-associated factor-associated factor 65 kDa subunit 5L', NULL, NULL, NULL, NULL, NULL, 4),
(203442, NULL, 'G3DSA:2.30.30.40:FF:000127', NULL, NULL, 'neutrophil cytosol factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(203443, NULL, 'G3DSA:1.10.510.10:FF:000081', NULL, NULL, 'STE20-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(203444, NULL, 'G3DSA:1.20.1310.10:FF:000034', NULL, NULL, 'Related to Cullin-3', NULL, NULL, NULL, NULL, NULL, 4),
(203445, NULL, 'G3DSA:2.60.40.10:FF:002787', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203446, NULL, 'G3DSA:3.40.50.1220:FF:000039', NULL, NULL, '2-succinyl-5-enolpyruvyl-6-hydroxy-3-cyclohexene-1-carboxylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(203447, NULL, 'G3DSA:2.40.50.90:FF:000042', NULL, NULL, 'Tudor domain containing 6', NULL, NULL, NULL, NULL, NULL, 4),
(203448, NULL, 'G3DSA:3.30.420.10:FF:000483', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203449, NULL, 'G3DSA:2.60.40.10:FF:005249', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203450, NULL, 'G3DSA:1.20.140.140:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203451, NULL, 'G3DSA:3.90.20.20:FF:000003', NULL, NULL, 'GrpE protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(203452, NULL, 'G3DSA:3.90.550.20:FF:000038', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203453, NULL, 'G3DSA:3.30.160.60:FF:000674', NULL, NULL, 'zinc finger transcription factor Trps1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(203454, NULL, 'G3DSA:3.40.50.1820:FF:000483', NULL, NULL, 'Clan SC, family S33, methylesterase-like serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(203455, NULL, 'G3DSA:3.30.70.1230:FF:000174', NULL, NULL, 'Gcy-36', NULL, NULL, NULL, NULL, NULL, 4),
(203456, NULL, 'G3DSA:3.40.630.30:FF:000098', NULL, NULL, 'N-terminal acetyltransferase A complex catalytic subunit Ard1', NULL, NULL, NULL, NULL, NULL, 4),
(203457, NULL, 'G3DSA:2.130.10.10:FF:003428', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203458, NULL, 'G3DSA:2.30.29.30:FF:000464', NULL, NULL, 'Cell 12A endoglucanase', NULL, NULL, NULL, NULL, NULL, 4),
(203459, NULL, 'G3DSA:3.30.160.60:FF:003136', NULL, NULL, 'Zinc finger protein 562', NULL, NULL, NULL, NULL, NULL, 4),
(203460, NULL, 'G3DSA:2.60.175.20:FF:000002', NULL, NULL, 'Major capsid protein L1', NULL, NULL, NULL, NULL, NULL, 4),
(203461, NULL, 'G3DSA:1.20.1110.10:FF:000114', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203462, NULL, 'G3DSA:3.40.190.10:FF:000895', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(203463, NULL, 'G3DSA:3.30.70.330:FF:000813', NULL, NULL, 'RNA binding motif protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(203464, NULL, 'G3DSA:2.20.70.10:FF:000138', NULL, NULL, 'WW domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(203465, NULL, 'G3DSA:1.25.40.10:FF:005260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203466, NULL, 'G3DSA:3.30.70.590:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203467, NULL, 'G3DSA:1.10.510.10:FF:004408', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203468, NULL, 'G3DSA:2.60.40.150:FF:000722', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203469, NULL, 'G3DSA:3.40.50.300:FF:005087', NULL, NULL, 'Os12g0503200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(203470, NULL, 'G3DSA:3.40.50.1820:FF:000011', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(203471, NULL, 'G3DSA:2.60.40.10:FF:005396', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203472, NULL, 'G3DSA:3.10.20.90:FF:000067', NULL, NULL, 'E3 ubiquitin-protein ligase RING2', NULL, NULL, NULL, NULL, NULL, 4),
(203473, NULL, 'G3DSA:3.30.70.330:FF:001033', NULL, NULL, 'splicing factor U2AF 26 kDa subunit isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(203474, NULL, 'G3DSA:1.20.1110.10:FF:000261', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203475, NULL, 'G3DSA:1.10.2010.10:FF:000002', NULL, NULL, 'Protein CBG14491', NULL, NULL, NULL, NULL, NULL, 4),
(203476, NULL, 'G3DSA:3.30.70.270:FF:000126', NULL, NULL, 'GGDEF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(203477, NULL, 'G3DSA:3.20.20.30:FF:000015', NULL, NULL, 'Phthiodiolone/phenolphthiodiolone dimycocerosates ketoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(203478, NULL, 'G3DSA:3.80.10.10:FF:003507', NULL, NULL, 'Nyctalopin', NULL, NULL, NULL, NULL, NULL, 4),
(203479, NULL, 'G3DSA:1.20.58.390:FF:000145', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203480, NULL, 'G3DSA:3.30.450.20:FF:000521', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203481, NULL, 'G3DSA:3.30.160.60:FF:004417', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203482, NULL, 'G3DSA:3.30.160.60:FF:006126', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203483, NULL, 'G3DSA:3.30.1460.20:FF:000004', NULL, NULL, 'Arp2/3 complex 34 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(203484, NULL, 'G3DSA:1.10.510.10:FF:001418', NULL, NULL, 'Serine/threonine protein kinase 15', NULL, NULL, NULL, NULL, NULL, 4),
(203485, NULL, 'G3DSA:3.40.630.10:FF:000148', NULL, NULL, 'Aminopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(203486, NULL, 'G3DSA:3.50.50.60:FF:000940', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203487, NULL, 'G3DSA:3.80.10.10:FF:000989', NULL, NULL, 'Leucine rich repeats and death domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(203488, NULL, 'G3DSA:3.30.40.10:FF:000431', NULL, NULL, 'E3 ubiquitin-protein ligase TRAIP', NULL, NULL, NULL, NULL, NULL, 4),
(203489, NULL, 'G3DSA:3.40.50.10420:FF:000016', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(203490, NULL, 'G3DSA:1.20.120.160:FF:000036', NULL, NULL, 'Aerobic respiration control sensor protein arcB', NULL, NULL, NULL, NULL, NULL, 4),
(203491, NULL, 'G3DSA:1.25.10.10:FF:002442', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203492, NULL, 'G3DSA:3.50.50.100:FF:000011', NULL, NULL, 'Membrane NADH dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(203493, NULL, 'G3DSA:1.20.1250.20:FF:000953', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203494, NULL, 'G3DSA:3.40.532.10:FF:000010', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(203495, NULL, 'G3DSA:1.20.1070.10:FF:000498', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(203496, NULL, 'G3DSA:1.20.920.10:FF:000194', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(203497, NULL, 'G3DSA:2.30.30.100:FF:000111', NULL, NULL, 'U6 snrnaassociated Sm family LSm3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(203498, NULL, 'G3DSA:1.10.730.20:FF:000010', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(203499, NULL, 'G3DSA:3.30.2410.10:FF:000049', NULL, NULL, 'Thyroid hormone receptor interactor 12', NULL, NULL, NULL, NULL, NULL, 4),
(203500, NULL, 'G3DSA:3.90.470.20:FF:000037', NULL, NULL, 'Protein CBG08117', NULL, NULL, NULL, NULL, NULL, 4),
(203501, NULL, 'G3DSA:3.30.420.40:FF:000587', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203502, NULL, 'G3DSA:3.40.50.300:FF:000152', NULL, NULL, 'ATP-binding cassette, sub-family E, member 1', NULL, NULL, NULL, NULL, NULL, 4),
(203503, NULL, 'G3DSA:3.30.390.60:FF:000011', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(203504, NULL, 'G3DSA:3.40.50.2300:FF:001509', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203505, NULL, 'G3DSA:1.10.287.4070:FF:000021', NULL, NULL, 'SnoRNA binding domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(203506, NULL, 'G3DSA:1.10.12.10:FF:000035', NULL, NULL, 'Enoyl-CoA hydratase/isomerase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(203507, NULL, 'G3DSA:2.60.40.790:FF:000094', NULL, NULL, 'Heat shock protein Hsp-16.2', NULL, NULL, NULL, NULL, NULL, 4),
(203508, NULL, 'G3DSA:2.130.10.10:FF:001719', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203509, NULL, 'G3DSA:3.40.50.300:FF:008521', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203510, NULL, 'G3DSA:3.40.50.2000:FF:000672', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203511, NULL, 'G3DSA:1.10.520.10:FF:000019', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(203512, NULL, 'G3DSA:2.10.25.10:FF:000383', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(203513, NULL, 'G3DSA:1.25.40.10:FF:003551', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203514, NULL, 'G3DSA:3.40.570.10:FF:000002', NULL, NULL, 'Endonuclease G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(203515, NULL, 'G3DSA:1.25.40.570:FF:000010', NULL, NULL, '26S proteasome regulatory subunit RPN6', NULL, NULL, NULL, NULL, NULL, 4),
(203516, NULL, 'G3DSA:1.10.1040.10:FF:000004', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(203517, NULL, 'G3DSA:3.40.190.10:FF:000748', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203518, NULL, 'G3DSA:3.50.50.60:FF:000699', NULL, NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(203519, NULL, 'G3DSA:2.30.180.10:FF:000041', NULL, NULL, 'Heme detoxification protein', NULL, NULL, NULL, NULL, NULL, 4),
(203520, NULL, 'G3DSA:3.30.200.20:FF:000857', NULL, NULL, 'Pk17E, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(203521, NULL, 'G3DSA:1.10.3720.10:FF:000034', NULL, NULL, 'Sugar ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(203522, NULL, 'G3DSA:2.130.10.10:FF:003575', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203523, NULL, 'G3DSA:1.20.1560.10:FF:000518', NULL, NULL, 'YALI0A19580p', NULL, NULL, NULL, NULL, NULL, 4),
(203524, NULL, 'G3DSA:3.80.10.10:FF:003979', NULL, NULL, 'AER145Wp', NULL, NULL, NULL, NULL, NULL, 4),
(203525, NULL, 'G3DSA:3.30.479.30:FF:000017', NULL, NULL, 'SPFH domain/band 7 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(203526, NULL, 'G3DSA:1.10.10.10:FF:000429', NULL, NULL, 'Two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(203527, NULL, 'G3DSA:3.40.50.300:FF:006576', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203528, NULL, 'G3DSA:3.30.479.10:FF:000011', NULL, NULL, '6-carboxy-5,6,7,8-tetrahydropterin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(203529, NULL, 'G3DSA:3.40.50.360:FF:000063', NULL, NULL, 'Probable NAD(P)H dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(203530, NULL, 'G3DSA:3.20.20.150:FF:000055', NULL, NULL, 'AP endonuclease, family 2', NULL, NULL, NULL, NULL, NULL, 4),
(203531, NULL, 'G3DSA:1.20.1730.10:FF:000026', NULL, NULL, 'Transporter, SSS family', NULL, NULL, NULL, NULL, NULL, 4),
(203532, NULL, 'G3DSA:1.20.1070.10:FF:000026', NULL, NULL, 'C-C chemokine receptor type 5', NULL, NULL, NULL, NULL, NULL, 4),
(203533, NULL, 'G3DSA:3.90.930.1:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203534, NULL, 'G3DSA:1.20.140.10:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203535, NULL, 'G3DSA:1.10.630.10:FF:000056', NULL, NULL, 'Red aleurone1', NULL, NULL, NULL, NULL, NULL, 4),
(203536, NULL, 'G3DSA:3.40.640.10:FF:000177', NULL, NULL, 'Unplaced genomic scaffold supercont1.16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(203537, NULL, 'G3DSA:1.10.472.10:FF:000036', NULL, NULL, 'cyclin-J isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(203538, NULL, 'G3DSA:1.20.120.350:FF:000211', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203539, NULL, 'G3DSA:3.40.220.10:FF:000038', NULL, NULL, 'DNA ligase 3', NULL, NULL, NULL, NULL, NULL, 4),
(203540, NULL, 'G3DSA:2.60.120.260:FF:000505', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203541, NULL, 'G3DSA:3.30.300.30:FF:000103', NULL, NULL, '2-succinylbenzoate--CoA ligase, chloroplastic/peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(203542, NULL, 'G3DSA:3.30.70.270:FF:000273', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203543, NULL, 'G3DSA:3.40.710.10:FF:000093', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase/D-alanyl-D-alanine-endopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(203544, NULL, 'G3DSA:3.30.160.60:FF:004889', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203545, NULL, 'G3DSA:3.40.50.300:FF:003142', NULL, NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(203546, NULL, 'G3DSA:2.60.40.10:FF:003451', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203547, NULL, 'G3DSA:2.60.120.200:FF:000802', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203548, NULL, 'G3DSA:1.25.40.10:FF:000437', NULL, NULL, 'Transmembrane and tetratricopeptide repeat containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(203549, NULL, 'G3DSA:3.90.550.10:FF:000653', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203550, NULL, 'G3DSA:2.60.40.10:FF:005660', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203551, NULL, 'G3DSA:1.25.40.800:FF:000006', NULL, NULL, 'Domain_of_uncharacterized_function_(DUF3819)/CCR4 -Not_complex_component_-_Not1_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(203552, NULL, 'G3DSA:1.20.58.60:FF:000672', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203553, NULL, 'G3DSA:3.20.20.60:FF:000119', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(203554, NULL, 'G3DSA:1.10.418.10:FF:000158', NULL, NULL, 'Parvin, beta', NULL, NULL, NULL, NULL, NULL, 4),
(203555, NULL, 'G3DSA:2.20.70.10:FF:000290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203556, NULL, 'G3DSA:1.10.10.10:FF:001918', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203557, NULL, 'G3DSA:3.80.10.10:FF:000017', NULL, NULL, 'leucine-rich repeat LGI family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(203558, NULL, 'G3DSA:2.60.40.10:FF:002523', NULL, NULL, 'Exo-beta-D-glucosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(203559, NULL, 'G3DSA:3.80.10.10:FF:002934', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203560, NULL, 'G3DSA:3.40.50.300:FF:002361', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203561, NULL, 'G3DSA:3.40.50.720:FF:001407', NULL, NULL, 'CipA protein', NULL, NULL, NULL, NULL, NULL, 4),
(203562, NULL, 'G3DSA:2.10.25.10:FF:000944', NULL, NULL, 'protein eyes shut-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(203563, NULL, 'G3DSA:2.60.120.10:FF:000058', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(203564, NULL, 'G3DSA:2.30.110.10:FF:000036', NULL, NULL, 'F420-dependent enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(203565, NULL, 'G3DSA:3.40.50.1240:FF:000197', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203566, NULL, 'G3DSA:3.10.28.10:FF:000027', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(203567, NULL, 'G3DSA:2.60.40.1480:FF:000006', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(203568, NULL, 'G3DSA:2.80.10.50:FF:000251', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(203569, NULL, 'G3DSA:3.30.1540.20:FF:000005', NULL, NULL, 'MutL homolog 3', NULL, NULL, NULL, NULL, NULL, 4),
(203570, NULL, 'G3DSA:3.10.450.70:FF:000001', NULL, NULL, 'Thiol:disulfide interchange protein', NULL, NULL, NULL, NULL, NULL, 4),
(203571, NULL, 'G3DSA:3.40.50.10190:FF:000020', NULL, NULL, 'DNA topoisomerase II binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(203572, NULL, 'G3DSA:2.60.40.1970:FF:000001', NULL, NULL, 'YEATS domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(203573, NULL, 'G3DSA:3.40.50.150:FF:001630', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203574, NULL, 'G3DSA:1.10.630.10:FF:000820', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203575, NULL, 'G3DSA:3.40.50.1820:FF:001500', NULL, NULL, 'Putative serine carboxypeptidase-like 54', NULL, NULL, NULL, NULL, NULL, 4),
(203576, NULL, 'G3DSA:3.30.200.20:FF:001638', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203577, NULL, 'G3DSA:3.40.50.2300:FF:000880', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203578, NULL, 'G3DSA:1.20.1280.290:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203579, NULL, 'G3DSA:2.60.40.10:FF:004732', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203580, NULL, 'G3DSA:1.20.58.1360:FF:000007', NULL, NULL, 'Lysine-specific demethylase 7 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(203581, NULL, 'G3DSA:3.30.930.10:FF:000038', NULL, NULL, 'Aspartate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(203582, NULL, 'G3DSA:1.20.1070.10:FF:001515', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203583, NULL, 'G3DSA:3.30.300.70:FF:000003', NULL, NULL, 'Ribosome maturation factor RimP', NULL, NULL, NULL, NULL, NULL, 4),
(203584, NULL, 'G3DSA:1.25.40.10:FF:001718', NULL, NULL, 'Molecular chaperone DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(203585, NULL, 'G3DSA:3.40.50.620:FF:000630', NULL, NULL, 'Electron transfer flavoprotein alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(203586, NULL, 'G3DSA:3.30.750.200:FF:000001', NULL, NULL, 'Coproporphyrinogen-III oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(203587, NULL, 'G3DSA:1.20.1560.10:FF:000665', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203588, NULL, 'G3DSA:3.60.15.10:FF:000203', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203589, NULL, 'G3DSA:1.10.510.10:FF:003627', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203590, NULL, 'G3DSA:1.25.40.20:FF:001255', NULL, NULL, 'Calcium transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(203591, NULL, 'G3DSA:2.40.50.140:FF:000939', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203592, NULL, 'G3DSA:3.40.50.300:FF:007032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203593, NULL, 'G3DSA:3.30.450.380:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203594, NULL, 'G3DSA:3.40.50.150:FF:000702', NULL, NULL, 'Cell division protein ftsj', NULL, NULL, NULL, NULL, NULL, 4),
(203595, NULL, 'G3DSA:3.30.420.40:FF:001043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203596, NULL, 'G3DSA:3.30.160.60:FF:005906', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203597, NULL, 'G3DSA:3.30.30.40:FF:000001', NULL, NULL, 'CoA-transferase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(203598, NULL, 'G3DSA:3.40.50.300:FF:005907', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(203599, NULL, 'G3DSA:3.40.120.10:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203600, NULL, 'G3DSA:2.120.10.80:FF:000139', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(203601, NULL, 'G3DSA:1.25.10.10:FF:003162', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(203602, NULL, 'G3DSA:1.10.340.70:FF:000012', NULL, NULL, 'Protein CBR-NOL-10', NULL, NULL, NULL, NULL, NULL, 4),
(203603, NULL, 'G3DSA:1.10.10.160:FF:000066', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(203604, NULL, 'G3DSA:1.10.238.10:FF:000801', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(203605, NULL, 'G3DSA:3.40.50.1000:FF:000529', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203606, NULL, 'G3DSA:3.40.50.1010:FF:000066', NULL, NULL, 'Flap endonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(203607, NULL, 'G3DSA:2.60.40.10:FF:005957', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203608, NULL, 'G3DSA:3.30.70.330:FF:000105', NULL, NULL, 'HIV Tat-specific factor 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(203609, NULL, 'G3DSA:1.20.58.60:FF:000525', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203610, NULL, 'G3DSA:2.70.98.20:FF:000034', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(203611, NULL, 'G3DSA:3.40.1160.10:FF:000004', NULL, NULL, 'Acetylglutamate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(203612, NULL, 'G3DSA:3.40.140.10:FF:000184', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203613, NULL, 'G3DSA:2.130.10.10:FF:004856', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203614, NULL, 'G3DSA:1.20.1740.10:FF:000263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203615, NULL, 'G3DSA:3.90.640.10:FF:000183', NULL, NULL, 'Actin family', NULL, NULL, NULL, NULL, NULL, 4),
(203616, NULL, 'G3DSA:3.40.50.1440:FF:000077', NULL, NULL, 'Tubulin alpha-1B chain', NULL, NULL, NULL, NULL, NULL, 4),
(203617, NULL, 'G3DSA:3.40.50.150:FF:001219', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203618, NULL, 'G3DSA:1.25.70.10:FF:000001', NULL, NULL, 'Mitochondrial transcription termination factor-like', NULL, NULL, NULL, NULL, NULL, 4),
(203619, NULL, 'G3DSA:3.30.1330.30:FF:000060', NULL, NULL, '40S ribosomal protein S12', NULL, NULL, NULL, NULL, NULL, 4),
(203620, NULL, 'G3DSA:1.10.510.10:FF:001570', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(203621, NULL, 'G3DSA:1.10.10.580:FF:000017', NULL, NULL, 'Meiotic recombination protein rec8', NULL, NULL, NULL, NULL, NULL, 4),
(203622, NULL, 'G3DSA:1.20.1250.20:FF:001173', NULL, NULL, 'Solute carrier family 49 member 4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(203623, NULL, 'G3DSA:1.10.10.350:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203624, NULL, 'G3DSA:3.40.30.10:FF:000464', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(203625, NULL, 'G3DSA:3.30.2350.10:FF:000050', NULL, NULL, 'tRNA pseudouridine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(203626, NULL, 'G3DSA:3.90.245.10:FF:000039', NULL, NULL, 'Putative uridine nucleosidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(203627, NULL, 'G3DSA:1.25.40.10:FF:002270', NULL, NULL, 'Transcription factor Tcc1p', NULL, NULL, NULL, NULL, NULL, 4),
(203628, NULL, 'G3DSA:1.20.1070.10:FF:001779', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203629, NULL, 'G3DSA:1.10.1200.10:FF:000011', NULL, NULL, 'Sterigmatocystin biosynthesis polyketide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(203630, NULL, 'G3DSA:1.10.10.60:FF:000427', NULL, NULL, 'Transcription factor MYB59', NULL, NULL, NULL, NULL, NULL, 4),
(203631, NULL, 'G3DSA:3.30.40.10:FF:001207', NULL, NULL, 'GG11833', NULL, NULL, NULL, NULL, NULL, 4),
(203632, NULL, 'G3DSA:2.60.120.200:FF:000241', NULL, NULL, 'L-type lectin-domain containing receptor kinase S.6-like', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(203633, NULL, 'G3DSA:3.30.70.100:FF:000121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203634, NULL, 'G3DSA:2.30.42.10:FF:000539', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203635, NULL, 'G3DSA:3.80.10.10:FF:002226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203636, NULL, 'G3DSA:3.40.50.980:FF:000041', NULL, NULL, 'Acyl-CoA synthetase, AMP-forming', NULL, NULL, NULL, NULL, NULL, 4),
(203637, NULL, 'G3DSA:3.30.750.44:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203638, NULL, 'G3DSA:3.40.50.11340:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203639, NULL, 'G3DSA:3.30.1360.120:FF:000078', NULL, NULL, 'tRNA modification GTPase MnmE', NULL, NULL, NULL, NULL, NULL, 4),
(203640, NULL, 'G3DSA:2.60.40.10:FF:000314', NULL, NULL, 'Calmodulin-binding transcription activator 2', NULL, NULL, NULL, NULL, NULL, 4),
(203641, NULL, 'G3DSA:4.10.800.20:FF:000010', NULL, NULL, 'AMP deaminase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(203642, NULL, 'G3DSA:3.30.1330.40:FF:000006', NULL, NULL, 'Reactive Intermediate Deaminase A, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(203643, NULL, 'G3DSA:2.130.10.10:FF:002647', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203644, NULL, 'G3DSA:3.60.10.10:FF:000063', NULL, NULL, 'Sphingomyelinase C', NULL, NULL, NULL, NULL, NULL, 4),
(203645, NULL, 'G3DSA:3.10.20.90:FF:000303', NULL, NULL, 'E3 ubiquitin-protein ligase UPL5 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(203646, NULL, 'G3DSA:2.60.40.150:FF:000486', NULL, NULL, 'Copine family member IX', NULL, NULL, NULL, NULL, NULL, 4),
(203647, NULL, 'G3DSA:1.20.58.60:FF:000756', NULL, NULL, 'Envoplakin b', NULL, NULL, NULL, NULL, NULL, 4),
(203648, NULL, 'G3DSA:1.20.1600.10:FF:000017', NULL, NULL, 'Agglutination protein', NULL, NULL, NULL, NULL, NULL, 4),
(203649, NULL, 'G3DSA:2.60.40.10:FF:003187', NULL, NULL, 'Polycystic kidney disease 1-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(203650, NULL, 'G3DSA:3.10.20.90:FF:000775', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203651, NULL, 'G3DSA:3.40.50.150:FF:001074', NULL, NULL, 'U6 small nuclear RNA (adenine-(43)-N(6))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(203652, NULL, 'G3DSA:1.10.238.270:FF:000005', NULL, NULL, 'Odorant-binding protein 46a', NULL, NULL, NULL, NULL, NULL, 4),
(203653, NULL, 'G3DSA:1.10.730.10:FF:000176', NULL, NULL, 'DALR anticodon binding domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(203654, NULL, 'G3DSA:1.20.1640.10:FF:000019', NULL, NULL, 'Patched 2', NULL, NULL, NULL, NULL, NULL, 4),
(203655, NULL, 'G3DSA:3.40.50.150:FF:001130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203656, NULL, 'G3DSA:1.10.630.10:FF:000117', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(203657, NULL, 'G3DSA:1.10.287.70:FF:000163', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(203658, NULL, 'G3DSA:2.40.160.110:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203659, NULL, 'G3DSA:1.20.5.340:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203660, NULL, 'G3DSA:2.30.30.220:FF:000001', NULL, NULL, 'ClpXP protease specificity-enhancing factor', NULL, NULL, NULL, NULL, NULL, 4),
(203661, NULL, 'G3DSA:3.40.50.300:FF:003081', NULL, NULL, 'Ras family protein', NULL, NULL, NULL, NULL, NULL, 4),
(203662, NULL, 'G3DSA:1.10.10.60:FF:000130', NULL, NULL, 'Homeobox protein Hox-D12', NULL, NULL, NULL, NULL, NULL, 4),
(203663, NULL, 'G3DSA:3.30.750.24:FF:000127', NULL, NULL, 'Low affinity sulfate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(203664, NULL, 'G3DSA:3.30.70.330:FF:000869', NULL, NULL, 'Putative RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(203665, NULL, 'G3DSA:1.10.238.10:FF:000037', NULL, NULL, 'calcium-binding protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(203666, NULL, 'G3DSA:3.40.50.300:FF:001517', NULL, NULL, 'Putative ATP-dependent RNA helicase TDRD12', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(203667, NULL, 'G3DSA:2.60.40.10:FF:003720', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203668, NULL, 'G3DSA:1.25.10.10:FF:002026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203669, NULL, 'G3DSA:3.80.10.10:FF:002670', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(203670, NULL, 'G3DSA:1.25.10.10:FF:003015', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203671, NULL, 'G3DSA:1.20.1250.20:FF:000537', NULL, NULL, 'Peptide transporter family 2', NULL, NULL, NULL, NULL, NULL, 4),
(203672, NULL, 'G3DSA:2.60.200.30:FF:000014', NULL, NULL, 'Mitochondrial NADH kinase', NULL, NULL, NULL, NULL, NULL, 4),
(203673, NULL, 'G3DSA:2.30.31.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203674, NULL, 'G3DSA:3.30.565.10:FF:000509', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(203675, NULL, 'G3DSA:1.25.40.10:FF:003107', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(203676, NULL, 'G3DSA:2.30.30.140:FF:000275', NULL, NULL, 'SMN (Human Survival Motor Neuron gene) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(203677, NULL, 'G3DSA:3.60.110.10:FF:000082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203678, NULL, 'G3DSA:3.40.50.880:FF:000157', NULL, NULL, 'Anthranilate synthase component II', NULL, NULL, NULL, NULL, NULL, 4),
(203679, NULL, 'G3DSA:3.30.70.260:FF:000152', NULL, NULL, 'GTP pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(203680, NULL, 'G3DSA:3.30.9.10:FF:000134', NULL, NULL, 'D-amino acid oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(203681, NULL, 'G3DSA:2.60.40.60:FF:001060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203682, NULL, 'G3DSA:1.25.40.10:FF:003635', NULL, NULL, 'Tetratricopeptide repeat protein 21B', NULL, NULL, NULL, NULL, NULL, 4),
(203683, NULL, 'G3DSA:3.30.1490.100:FF:000022', NULL, NULL, 'DNA polymerase eta', NULL, NULL, NULL, NULL, NULL, 4),
(203684, NULL, 'G3DSA:1.25.10.10:FF:001953', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203685, NULL, 'G3DSA:3.30.70.3020:FF:000003', NULL, NULL, 'U3 small nucleolar RNA-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(203686, NULL, 'G3DSA:3.40.1410.10:FF:000041', NULL, NULL, 'Histidine utilization repressor', NULL, NULL, NULL, NULL, NULL, 4),
(203687, NULL, 'G3DSA:1.20.5.650:FF:000004', NULL, NULL, 'Transcription factor TFIIIB subunit', NULL, NULL, NULL, NULL, NULL, 4),
(203688, NULL, 'G3DSA:3.90.1150.10:FF:000386', NULL, NULL, '3,4-dihydroxyphenylacetaldehyde synthase', NULL, NULL, NULL, NULL, NULL, 4),
(203689, NULL, 'G3DSA:3.80.10.10:FF:003923', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(203690, NULL, 'G3DSA:3.60.40.10:FF:000211', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203691, NULL, 'G3DSA:2.60.120.260:FF:000444', NULL, NULL, 'Laminin subunit alpha 5', NULL, NULL, NULL, NULL, NULL, 4),
(203692, NULL, 'G3DSA:3.40.50.300:FF:008549', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203693, NULL, 'G3DSA:1.20.120.220:FF:000015', NULL, NULL, 'ATP synthase subunit a', NULL, NULL, NULL, NULL, NULL, 4),
(203694, NULL, 'G3DSA:1.10.10.10:FF:000845', NULL, NULL, 'DeoR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(203695, NULL, 'G3DSA:2.10.70.10:FF:000223', NULL, NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(203696, NULL, 'G3DSA:2.120.10.80:FF:000347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203697, NULL, 'G3DSA:3.80.10.10:FF:002142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203698, NULL, 'G3DSA:3.50.70.10:FF:000005', NULL, NULL, 'Chalcone-flavonone isomerase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(203699, NULL, 'G3DSA:2.60.120.260:FF:000388', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(203700, NULL, 'G3DSA:2.60.40.10:FF:004232', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203701, NULL, 'G3DSA:3.30.450.190:FF:000014', NULL, NULL, 'GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(203702, NULL, 'G3DSA:3.20.20.140:FF:000170', NULL, NULL, 'Histidinol phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(203703, NULL, 'G3DSA:3.30.200.20:FF:000626', NULL, NULL, 'Related to MKK1-MAP kinase kinase', NULL, NULL, NULL, NULL, NULL, 4),
(203704, NULL, 'G3DSA:2.40.50.690:FF:000025', NULL, NULL, 'DIS3-like exonuclease 2', NULL, NULL, NULL, NULL, NULL, 4),
(203705, NULL, 'G3DSA:1.20.1250.20:FF:000009', NULL, NULL, 'Synaptic vesicle glycoprotein 2A', NULL, NULL, NULL, NULL, NULL, 4),
(203706, NULL, 'G3DSA:3.90.550.50:FF:000114', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(203707, NULL, 'G3DSA:1.10.510.10:FF:001593', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(203708, NULL, 'G3DSA:3.30.2080.10:FF:000006', NULL, NULL, 'Putative conserved exported protein', NULL, NULL, NULL, NULL, NULL, 4),
(203709, NULL, 'G3DSA:3.50.50.60:FF:000671', NULL, NULL, 'Thioredoxin reductase 2, tandem duplicate 1', NULL, NULL, NULL, NULL, NULL, 4),
(203710, NULL, 'G3DSA:2.130.10.10:FF:000141', NULL, NULL, 'Pleckstrin homology domain interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(203711, NULL, 'G3DSA:3.30.230.10:FF:000125', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(203712, NULL, 'G3DSA:1.10.20.10:FF:000290', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203713, NULL, 'G3DSA:1.25.40.20:FF:001547', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(203714, NULL, 'G3DSA:3.80.10.10:FF:004379', NULL, NULL, 'Disease resistance RPP13-like protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(203715, NULL, 'G3DSA:3.30.1360.200:FF:000012', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(203716, NULL, 'G3DSA:2.130.10.10:FF:004356', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203717, NULL, 'G3DSA:1.20.58.1210:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203718, NULL, 'G3DSA:1.20.58.60:FF:000317', NULL, NULL, 'Muscle-specific protein 300 kDa, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(203719, NULL, 'G3DSA:1.10.287.370:FF:000028', NULL, NULL, 'Prefoldin alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(203720, NULL, 'G3DSA:3.10.129.10:FF:000153', NULL, NULL, 'Acyl-CoA thioesterase 7', NULL, NULL, NULL, NULL, NULL, 4),
(203721, NULL, 'G3DSA:3.30.830.10:FF:000177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203722, NULL, 'G3DSA:2.170.270.10:FF:000239', NULL, NULL, 'SET and MYND domain containing 1b', NULL, NULL, NULL, NULL, NULL, 4),
(203723, NULL, 'G3DSA:2.60.40.10:FF:004968', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203724, NULL, 'G3DSA:1.20.1000.10:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203725, NULL, 'G3DSA:3.90.180.10:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203726, NULL, 'G3DSA:3.10.20.90:FF:000831', NULL, NULL, 'Small ubiquitin-related modifier', NULL, NULL, NULL, NULL, NULL, 4),
(203727, NULL, 'G3DSA:1.20.920.10:FF:000019', NULL, NULL, 'Transcription initiation factor TFIID subunit', NULL, NULL, NULL, NULL, NULL, 4),
(203728, NULL, 'G3DSA:3.30.160.60:FF:001747', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203729, NULL, 'G3DSA:3.40.50.300:FF:007296', NULL, NULL, 'Ras-related protein RABD1', NULL, NULL, NULL, NULL, NULL, 4),
(203730, NULL, 'G3DSA:1.10.510.10:FF:003571', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203731, NULL, 'G3DSA:1.10.405.20:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203732, NULL, 'G3DSA:2.40.50.140:FF:000355', NULL, NULL, 'Single-stranded DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(203733, NULL, 'G3DSA:3.30.60.30:FF:000231', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(203734, NULL, 'G3DSA:4.10.1110.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203735, NULL, 'G3DSA:2.40.100.10:FF:000101', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(203736, NULL, 'G3DSA:3.80.10.10:FF:000197', NULL, NULL, 'F-box and leucine-rich repeat protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(203737, NULL, 'G3DSA:3.30.1370.110:FF:000021', NULL, NULL, 'YALI0D27280p', NULL, NULL, NULL, NULL, NULL, 4),
(203738, NULL, 'G3DSA:3.20.20.80:FF:000041', NULL, NULL, 'Beta-glucosidase 7', NULL, NULL, NULL, NULL, NULL, 4),
(203739, NULL, 'G3DSA:1.10.287.130:FF:000243', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(203740, NULL, 'G3DSA:3.30.420.110:FF:000052', NULL, NULL, 'DNA mismatch repair protein Msh3', NULL, NULL, NULL, NULL, NULL, 4),
(203741, NULL, 'G3DSA:1.10.1750.10:FF:000007', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(203742, NULL, 'G3DSA:1.25.40.10:FF:003579', NULL, NULL, 'Cyclin-F', NULL, NULL, NULL, NULL, NULL, 4),
(203743, NULL, 'G3DSA:3.30.565.10:FF:000133', NULL, NULL, 'Accessory gene regulator C', NULL, NULL, NULL, NULL, NULL, 4),
(203744, NULL, 'G3DSA:1.25.40.10:FF:001342', NULL, NULL, 'Tonsoku like, DNA repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(203745, NULL, 'G3DSA:3.30.200.20:FF:000149', NULL, NULL, 'serine/threonine-protein kinase unc-51 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(203746, NULL, 'G3DSA:3.40.50.150:FF:000141', NULL, NULL, 'ATP synthase c subunit lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(203747, NULL, 'G3DSA:1.20.120.1080:FF:000151', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203748, NULL, 'G3DSA:3.30.420.10:FF:000308', NULL, NULL, 'Uncharacterized protein C29A10.09c', NULL, NULL, NULL, NULL, NULL, 4),
(203749, NULL, 'G3DSA:3.40.630.30:FF:000070', NULL, NULL, 'Acetylglutamate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(203750, NULL, 'G3DSA:3.30.160.60:FF:005553', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203751, NULL, 'G3DSA:3.40.50.1820:FF:000039', NULL, NULL, 'Esterase ybfF', NULL, NULL, NULL, NULL, NULL, 4),
(203752, NULL, 'G3DSA:2.30.30.180:FF:000005', NULL, NULL, 'Ribosome maturation factor RimP', NULL, NULL, NULL, NULL, NULL, 4),
(203753, NULL, 'G3DSA:1.20.58.60:FF:000380', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203754, NULL, 'G3DSA:1.10.274.30:FF:000020', NULL, NULL, 'Mortality factor 4-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(203755, NULL, 'G3DSA:1.20.5.440:FF:000003', NULL, NULL, 'ATP synthase subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(203756, NULL, 'G3DSA:3.40.630.20:FF:000005', NULL, NULL, 'Pyrrolidone-carboxylate peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(203757, NULL, 'G3DSA:3.30.70.20:FF:000144', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203758, NULL, 'G3DSA:3.40.47.10:FF:000295', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203759, NULL, 'G3DSA:2.60.110.10:FF:000029', NULL, NULL, 'Os08g0388150 protein', NULL, NULL, NULL, NULL, NULL, 4),
(203760, NULL, 'G3DSA:1.20.1440.170:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203761, NULL, 'G3DSA:1.10.1050.10:FF:000010', NULL, NULL, '30S ribosomal protein S4', NULL, NULL, NULL, NULL, NULL, 4),
(203762, NULL, 'G3DSA:3.40.50.11610:FF:000002', NULL, NULL, '2-oxoglutarate dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(203763, NULL, 'G3DSA:3.90.70.10:FF:000560', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203764, NULL, 'G3DSA:1.20.5.170:FF:000102', NULL, NULL, 'bZIP transcription factor hapX', NULL, NULL, NULL, NULL, NULL, 4),
(203765, NULL, 'G3DSA:2.130.10.10:FF:003052', NULL, NULL, 'Polyadenylation factor subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(203766, NULL, 'G3DSA:3.30.200.160:FF:000006', NULL, NULL, 'general transcription factor 3C polypeptide 5-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(203767, NULL, 'G3DSA:1.10.10.1330:FF:000001', NULL, NULL, 'RNA polymerase sigma-54 factor', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(203768, NULL, 'G3DSA:1.10.287.110:FF:000181', NULL, NULL, 'Chaperone protein DNAj, putative', NULL, NULL, NULL, NULL, NULL, 4),
(203769, NULL, 'G3DSA:2.70.170.10:FF:000188', NULL, NULL, 'AGAP009493-PA', NULL, NULL, NULL, NULL, NULL, 4),
(203770, NULL, 'G3DSA:3.40.50.150:FF:000938', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203771, NULL, 'G3DSA:3.40.850.10:FF:000215', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(203772, NULL, 'G3DSA:1.10.472.10:FF:000300', NULL, NULL, 'Cyclin-L1-1', NULL, NULL, NULL, NULL, NULL, 4),
(203773, NULL, 'G3DSA:2.60.40.60:FF:000071', NULL, NULL, 'FAT atypical cadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(203774, NULL, 'G3DSA:3.40.710.10:FF:000149', NULL, NULL, 'Cell division protein FtsI', NULL, NULL, NULL, NULL, NULL, 4),
(203775, NULL, 'G3DSA:3.30.160.60:FF:000882', NULL, NULL, 'Predicted gene, 21060', NULL, NULL, NULL, NULL, NULL, 4),
(203776, NULL, 'G3DSA:3.20.20.80:FF:000305', NULL, NULL, 'Alpha-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(203777, NULL, 'G3DSA:3.30.870.10:FF:000067', NULL, NULL, 'Cardiolipin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(203778, NULL, 'G3DSA:1.20.1160.11:FF:000006', NULL, NULL, 'GON-4-like protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(203779, NULL, 'G3DSA:3.30.70.860:FF:000005', NULL, NULL, 'UPF0234 protein LEP1GSC123_2924', NULL, NULL, NULL, NULL, NULL, 4),
(203780, NULL, 'G3DSA:1.20.5.170:FF:000046', NULL, NULL, 'cGMP-dependent protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(203781, NULL, 'G3DSA:3.30.70.330:FF:002258', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203782, NULL, 'G3DSA:3.30.70.330:FF:000021', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(203783, NULL, 'G3DSA:1.20.5.460:FF:000009', NULL, NULL, 'Proline utilization trans-activator', NULL, NULL, NULL, NULL, NULL, 4),
(203784, NULL, 'G3DSA:2.70.70.10:FF:000057', NULL, NULL, 'PTS glucose transporter subunit IIA', NULL, NULL, NULL, NULL, NULL, 4),
(203785, NULL, 'G3DSA:3.60.10.10:FF:000327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203786, NULL, 'G3DSA:3.30.160.60:FF:004625', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203787, NULL, 'G3DSA:1.20.1070.10:FF:001695', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203788, NULL, 'G3DSA:2.60.40.60:FF:000868', NULL, NULL, 'Cadherin domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(203789, NULL, 'G3DSA:2.60.260.20:FF:000133', NULL, NULL, 'Chaperone protein DnaJ 1', NULL, NULL, NULL, NULL, NULL, 4),
(203790, NULL, 'G3DSA:3.40.50.10890:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203791, NULL, 'G3DSA:3.90.25.10:FF:000017', NULL, NULL, 'GDP-L-fucose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(203792, NULL, 'G3DSA:1.10.510.10:FF:002935', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203793, NULL, 'G3DSA:3.10.50.10:FF:000034', NULL, NULL, 'Chitinase, acidic.4', NULL, NULL, NULL, NULL, NULL, 4),
(203794, NULL, 'G3DSA:3.10.280.10:FF:000026', NULL, NULL, 'Mitochondrial p32 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(203795, NULL, 'G3DSA:1.10.1130.10:FF:000011', NULL, NULL, 'Dissimilatory sulfite reductase MccA', NULL, NULL, NULL, NULL, NULL, 4),
(203796, NULL, 'G3DSA:1.10.287.130:FF:000187', NULL, NULL, 'PAS domain-containing sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(203797, NULL, 'G3DSA:1.10.287.110:FF:000057', NULL, NULL, 'dnaJ homolog subfamily C member 14', NULL, NULL, NULL, NULL, NULL, 4),
(203798, NULL, 'G3DSA:3.30.160.60:FF:005114', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203799, NULL, 'G3DSA:3.10.50.40:FF:000110', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(203800, NULL, 'G3DSA:3.40.50.300:FF:003406', NULL, NULL, 'DNA replication ATP-dependent helicase/nuclease DNA2', NULL, NULL, NULL, NULL, NULL, 4),
(203801, NULL, 'G3DSA:3.40.50.10190:FF:000317', NULL, NULL, 'DNA repair protein crb2', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(203802, NULL, 'G3DSA:2.30.30.1160:FF:000001', NULL, NULL, 'Antiviral helicase SKI2', NULL, NULL, NULL, NULL, NULL, 4),
(203803, NULL, 'G3DSA:3.30.70.330:FF:002758', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203804, NULL, 'G3DSA:3.30.2130.30:FF:000022', NULL, NULL, 'Putative uncharacterized protein DDB_G0293380', NULL, NULL, NULL, NULL, NULL, 4),
(203805, NULL, 'G3DSA:3.30.160.60:FF:001219', NULL, NULL, 'zinc finger protein 436 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(203806, NULL, 'G3DSA:3.40.50.880:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203807, NULL, 'G3DSA:3.30.160.60:FF:001371', NULL, NULL, 'Zinc finger protein, FOG family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(203808, NULL, 'G3DSA:2.130.10.10:FF:003900', NULL, NULL, 'Quinoprotein amine dehydrogenase, beta chain-like RIC1-like guanyl-nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(203809, NULL, 'G3DSA:2.60.40.790:FF:000150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203810, NULL, 'G3DSA:2.60.120.590:FF:000020', NULL, NULL, 'Alpha-ketoglutarate-dependent dioxygenase alkB', NULL, NULL, NULL, NULL, NULL, 4),
(203811, NULL, 'G3DSA:3.30.830.10:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203812, NULL, 'G3DSA:1.10.510.10:FF:001154', NULL, NULL, 'eIF-2alpha kinase', NULL, NULL, NULL, NULL, NULL, 4),
(203813, NULL, 'G3DSA:3.30.70.330:FF:000077', NULL, NULL, 'RNA-binding motif protein 24', NULL, NULL, NULL, NULL, NULL, 4),
(203814, NULL, 'G3DSA:3.30.40.10:FF:001151', NULL, NULL, 'RING-H2 finger protein ATL3C', NULL, NULL, NULL, NULL, NULL, 4),
(203815, NULL, 'G3DSA:1.10.3370.10:FF:000052', NULL, NULL, 'Protein translocase subunit SecY', NULL, NULL, NULL, NULL, NULL, 4),
(203816, NULL, 'G3DSA:3.40.109.10:FF:000055', NULL, NULL, 'Nitroreductase', NULL, NULL, NULL, NULL, NULL, 4),
(203817, NULL, 'G3DSA:1.20.1560.10:FF:000581', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203818, NULL, 'G3DSA:3.30.40.10:FF:000515', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203819, NULL, 'G3DSA:3.80.10.10:FF:001506', NULL, NULL, 'toll-like receptor 8', NULL, NULL, NULL, NULL, NULL, 4),
(203820, NULL, 'G3DSA:2.60.40.10:FF:001298', NULL, NULL, 'Vesicle-associated membrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(203821, NULL, 'G3DSA:3.20.20.140:FF:000434', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203822, NULL, 'G3DSA:3.80.10.10:FF:002518', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203823, NULL, 'G3DSA:3.40.30.10:FF:001184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203824, NULL, 'G3DSA:2.60.120.1540:FF:000002', NULL, NULL, 'PZP, alpha-2-macroglobulin like', NULL, NULL, NULL, NULL, NULL, 4),
(203825, NULL, 'G3DSA:3.40.640.10:FF:000446', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203826, NULL, 'G3DSA:3.40.50.300:FF:007301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203827, NULL, 'G3DSA:3.40.50.2000:FF:000200', NULL, NULL, 'Phosphatidylinositol N-acetylglucosaminyltransferase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(203828, NULL, 'G3DSA:1.10.390.10:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203829, NULL, 'G3DSA:1.10.472.80:FF:000040', NULL, NULL, 'TBC1 domain family member 2A', NULL, NULL, NULL, NULL, NULL, 4),
(203830, NULL, 'G3DSA:2.40.50.140:FF:000883', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203831, NULL, 'G3DSA:3.40.50.300:FF:004070', NULL, NULL, 'MutS protein homolog 4', NULL, NULL, NULL, NULL, NULL, 4),
(203832, NULL, 'G3DSA:3.90.228.10:FF:000045', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(203833, NULL, 'G3DSA:1.10.510.10:FF:000665', NULL, NULL, 'Microtubule associated serine/threonine kinase-like', NULL, NULL, NULL, NULL, NULL, 4),
(203834, NULL, 'G3DSA:3.30.200.20:FF:001554', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(203835, NULL, 'G3DSA:3.90.120.10:FF:000008', NULL, NULL, 'Methyltransferase 2, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(203836, NULL, 'G3DSA:3.40.190.10:FF:000664', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(203837, NULL, 'G3DSA:2.130.10.10:FF:003367', NULL, NULL, 'Probable serine/threonine-protein kinase vps15', NULL, NULL, NULL, NULL, NULL, 4),
(203838, NULL, 'G3DSA:2.120.10.80:FF:000403', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203839, NULL, 'G3DSA:3.40.50.2300:FF:001425', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203840, NULL, 'G3DSA:3.30.420.280:FF:000001', NULL, NULL, 'Terminase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(203841, NULL, 'G3DSA:3.30.70.1230:FF:000258', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203842, NULL, 'G3DSA:3.30.160.20:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203843, NULL, 'G3DSA:2.60.120.200:FF:000038', NULL, NULL, 'thrombospondin-3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(203844, NULL, 'G3DSA:3.40.1810.10:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203845, NULL, 'G3DSA:2.60.40.10:FF:003243', NULL, NULL, 'Class II cytokine receptor crfb8', NULL, NULL, NULL, NULL, NULL, 4),
(203846, NULL, 'G3DSA:3.40.50.720:FF:000834', NULL, NULL, 'Saccharopine dehydrogenase [NAD(+), L-lysine-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(203847, NULL, 'G3DSA:1.10.8.10:FF:000333', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203848, NULL, 'G3DSA:3.10.105.10:FF:000002', NULL, NULL, 'Dipeptide ABC transporter, substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(203849, NULL, 'G3DSA:3.30.70.890:FF:000020', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(203850, NULL, 'G3DSA:1.25.10.10:FF:002498', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203851, NULL, 'G3DSA:2.10.110.10:FF:000018', NULL, NULL, 'Paxillin isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(203852, NULL, 'G3DSA:2.60.40.10:FF:002315', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203853, NULL, 'G3DSA:1.10.8.870:FF:000011', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(203854, NULL, 'G3DSA:2.30.29.30:FF:000756', NULL, NULL, 'Nuclear pore complex protein NUP50A', NULL, NULL, NULL, NULL, NULL, 4),
(203855, NULL, 'G3DSA:2.30.42.10:FF:000011', NULL, NULL, 'partitioning defective 3 homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(203856, NULL, 'G3DSA:3.90.640.10:FF:000160', NULL, NULL, 'Heat shock protein70 mitochondrial putative', NULL, NULL, NULL, NULL, NULL, 4),
(203857, NULL, 'G3DSA:3.40.50.2000:FF:001133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203858, NULL, 'G3DSA:1.20.940.10:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203859, NULL, 'G3DSA:3.40.50.150:FF:000202', NULL, NULL, 'Electron transfer flavoprotein subunit beta lysine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(203860, NULL, 'G3DSA:2.70.160.11:FF:000048', NULL, NULL, 'Protein arginine methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(203861, NULL, 'G3DSA:3.40.50.150:FF:000146', NULL, NULL, 'Acetylserotonin O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(203862, NULL, 'G3DSA:3.20.20.70:FF:000156', NULL, NULL, 'Glutamate synthase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(203863, NULL, 'G3DSA:3.40.50.300:FF:002153', NULL, NULL, 'Regulator of nonsense transcripts 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(203864, NULL, 'G3DSA:3.30.70.330:FF:001797', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203865, NULL, 'G3DSA:3.40.50.300:FF:002097', NULL, NULL, 'ATP-binding cassette sub-family A member', NULL, NULL, NULL, NULL, NULL, 4),
(203866, NULL, 'G3DSA:1.25.40.120:FF:000044', NULL, NULL, 'Protein prenyltransferase alpha subunit repeat, putative', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(203867, NULL, 'G3DSA:3.40.1160.10:FF:000027', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(203868, NULL, 'G3DSA:3.20.20.70:FF:000212', NULL, NULL, 'Indole-3-glycerol phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(203869, NULL, 'G3DSA:2.30.42.10:FF:000303', NULL, NULL, 'Protein CBG01035', NULL, NULL, NULL, NULL, NULL, 4),
(203870, NULL, 'G3DSA:2.30.42.10:FF:000483', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203871, NULL, 'G3DSA:1.10.418.10:FF:000074', NULL, NULL, 'protein sickie isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(203872, NULL, 'G3DSA:2.10.25.10:FF:001372', NULL, NULL, 'Fibropellin-1', NULL, NULL, NULL, NULL, NULL, 4),
(203873, NULL, 'G3DSA:1.25.40.10:FF:002707', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203874, NULL, 'G3DSA:3.90.180.10:FF:000080', NULL, NULL, 'Alcohol dehydrogenase, zinc-binding', NULL, NULL, NULL, NULL, NULL, 4),
(203875, NULL, 'G3DSA:3.20.20.70:FF:000651', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203876, NULL, 'G3DSA:3.30.70.330:FF:001325', NULL, NULL, 'Putative U1A small nuclear ribonucleoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(203877, NULL, 'G3DSA:1.25.40.10:FF:000229', NULL, NULL, 'Eukaryotic elongation factor 2 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(203878, NULL, 'G3DSA:3.90.1410.10:FF:000013', NULL, NULL, 'N-lysine methyltransferase SETD6', NULL, NULL, NULL, NULL, NULL, 4),
(203879, NULL, 'G3DSA:3.30.230.10:FF:000120', NULL, NULL, 'Mismatch repair endonuclease PMS2', NULL, NULL, NULL, NULL, NULL, 4),
(203880, NULL, 'G3DSA:3.80.10.10:FF:003070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203881, NULL, 'G3DSA:2.60.40.4100:FF:000011', NULL, NULL, 'Zona pellucida glycoprotein 3', NULL, NULL, NULL, NULL, NULL, 4),
(203882, NULL, 'G3DSA:1.20.1280.290:FF:000044', NULL, NULL, 'PQ loop repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(203883, NULL, 'G3DSA:3.10.100.10:FF:000250', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203884, NULL, 'G3DSA:2.40.30.10:FF:000354', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203885, NULL, 'G3DSA:3.30.1130.10:FF:000005', NULL, NULL, 'D-erythro-7,8-dihydroneopterin triphosphate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(203886, NULL, 'G3DSA:3.80.10.10:FF:001978', NULL, NULL, 'Inactive disease susceptibility protein LOV1', NULL, NULL, NULL, NULL, NULL, 4),
(203887, NULL, 'G3DSA:1.10.510.10:FF:003419', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203888, NULL, 'G3DSA:1.10.8.60:FF:000382', NULL, NULL, 'Katanin p60 ATPase-containing subunit A-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(203889, NULL, 'G3DSA:1.25.10.10:FF:001537', NULL, NULL, 'V-type proton ATPase subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(203890, NULL, 'G3DSA:2.60.40.150:FF:000430', NULL, NULL, 'Synaptotagmin XIII', NULL, NULL, NULL, NULL, NULL, 4),
(203891, NULL, 'G3DSA:3.40.30.10:FF:001189', NULL, NULL, 'Sulfhydryl oxidase 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(203892, NULL, 'G3DSA:3.30.56.70:FF:000002', NULL, NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(203893, NULL, 'G3DSA:3.20.20.120:FF:000012', NULL, NULL, 'Dipeptide epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(203894, NULL, 'G3DSA:3.40.50.12780:FF:000061', NULL, NULL, 'Acyl-CoA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(203895, NULL, 'G3DSA:2.40.30.10:FF:000062', NULL, NULL, 'methionine synthase reductase', NULL, NULL, NULL, NULL, NULL, 4),
(203896, NULL, 'G3DSA:1.20.1560.10:FF:000873', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203897, NULL, 'G3DSA:2.70.98.10:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203898, NULL, 'G3DSA:3.30.160.380:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203899, NULL, 'G3DSA:2.130.10.10:FF:001427', NULL, NULL, 'Breast carcinoma-amplified sequence 3', NULL, NULL, NULL, NULL, NULL, 4),
(203900, NULL, 'G3DSA:3.40.395.10:FF:000016', NULL, NULL, 'Deubiquitinase and deneddylase Dub1', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(203901, NULL, 'G3DSA:3.30.920.10:FF:000004', NULL, NULL, 'Mitochondrial chaperone Frataxin', NULL, NULL, NULL, NULL, NULL, 4),
(203902, NULL, 'G3DSA:2.160.20.10:FF:000308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203903, NULL, 'G3DSA:1.10.555.10:FF:000015', NULL, NULL, 'rho GTPase-activating protein 25 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(203904, NULL, 'G3DSA:1.10.3630.10:FF:000004', NULL, NULL, 'Probable VPS74-protein involved in protein-vacuolar targeting', NULL, NULL, NULL, NULL, NULL, 4),
(203905, NULL, 'G3DSA:3.30.70.330:FF:001802', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203906, NULL, 'G3DSA:1.10.533.10:FF:000206', NULL, NULL, 'Death-associated inhibitor of apoptosis 2', NULL, NULL, NULL, NULL, NULL, 4),
(203907, NULL, 'G3DSA:2.30.29.30:FF:000941', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203908, NULL, 'G3DSA:3.30.1370.10:FF:000056', NULL, NULL, 'Tudor and KH domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(203909, NULL, 'G3DSA:3.60.15.10:FF:000259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203910, NULL, 'G3DSA:3.30.160.20:FF:000038', NULL, NULL, 'Dicer-like 104', NULL, NULL, NULL, NULL, NULL, 4),
(203911, NULL, 'G3DSA:1.25.40.10:FF:001218', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(203912, NULL, 'G3DSA:3.30.1360.30:FF:000005', NULL, NULL, 'Aspartate--tRNA(Asp/Asn) ligase', NULL, NULL, NULL, NULL, NULL, 4),
(203913, NULL, 'G3DSA:3.90.930.12:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203914, NULL, 'G3DSA:2.160.20.10:FF:000016', NULL, NULL, 'Polygalacturonase 7', NULL, NULL, NULL, NULL, NULL, 4),
(203915, NULL, 'G3DSA:3.80.10.10:FF:001686', NULL, NULL, 'Insulin-like growth factor-binding protein acid labile subunit', NULL, NULL, NULL, NULL, NULL, 4),
(203916, NULL, 'G3DSA:2.60.40.10:FF:003248', NULL, NULL, 'Kinase insert domain receptor like', NULL, NULL, NULL, NULL, NULL, 4),
(203917, NULL, 'G3DSA:3.40.50.720:FF:001054', NULL, NULL, 'UDP-glucose dehydrogenase Ugd1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(203918, NULL, 'G3DSA:2.30.30.100:FF:000083', NULL, NULL, 'Small nuclear ribonucleoprotein E', NULL, NULL, NULL, NULL, NULL, 4),
(203919, NULL, 'G3DSA:3.30.160.60:FF:006418', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203920, NULL, 'G3DSA:1.20.900.10:FF:000136', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203921, NULL, 'G3DSA:1.10.510.10:FF:002082', NULL, NULL, 'Kinase', NULL, NULL, NULL, NULL, NULL, 4),
(203922, NULL, 'G3DSA:3.30.70.330:FF:001510', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203923, NULL, 'G3DSA:1.20.1740.10:FF:000055', NULL, NULL, 'Amino acid permease 6', NULL, NULL, NULL, NULL, NULL, 4),
(203924, NULL, 'G3DSA:2.60.40.1180:FF:000186', NULL, NULL, 'Alpha,alpha-phosphotrehalase', NULL, NULL, NULL, NULL, NULL, 4),
(203925, NULL, 'G3DSA:2.130.10.10:FF:001135', NULL, NULL, 'Bromodomain and WD repeat domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(203926, NULL, 'G3DSA:3.10.580.10:FF:000066', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(203927, NULL, 'G3DSA:3.90.190.10:FF:000254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203928, NULL, 'G3DSA:3.40.50.1440:FF:000021', NULL, NULL, 'Tubulin delta chain', NULL, NULL, NULL, NULL, NULL, 4),
(203929, NULL, 'G3DSA:1.20.1300.10:FF:000005', NULL, NULL, 'Succinate dehydrogenase cytochrome b556 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(203930, NULL, 'G3DSA:3.90.190.20:FF:000055', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(203931, NULL, 'G3DSA:1.10.260.100:FF:000006', NULL, NULL, 'Ubiquitin-associated domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(203932, NULL, 'G3DSA:3.30.70.330:FF:002786', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203933, NULL, 'G3DSA:2.40.340.10:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203934, NULL, 'G3DSA:3.90.870.10:FF:000020', NULL, NULL, '3,4-dihydroxy-2-butanone 4-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(203935, NULL, 'G3DSA:3.40.309.10:FF:000059', NULL, NULL, 'Aldehyde dehydrogenase 3 family, member B1', NULL, NULL, NULL, NULL, NULL, 4),
(203936, NULL, 'G3DSA:2.30.30.140:FF:000336', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203937, NULL, 'G3DSA:3.40.50.300:FF:001933', NULL, NULL, 'Heparan-sulfate 6-O-sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(203938, NULL, 'G3DSA:3.20.20.70:FF:000504', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203939, NULL, 'G3DSA:3.30.470.20:FF:000051', NULL, NULL, 'Carbamoyl phosphate synthetase II', NULL, NULL, NULL, NULL, NULL, 4),
(203940, NULL, 'G3DSA:2.130.10.10:FF:001630', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(203941, NULL, 'G3DSA:1.25.40.10:FF:004271', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203942, NULL, 'G3DSA:1.25.10.10:FF:001161', NULL, NULL, 'Hsp70-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(203943, NULL, 'G3DSA:1.10.287.1250:FF:000001', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(203944, NULL, 'G3DSA:3.90.105.10:FF:000001', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(203945, NULL, 'G3DSA:3.40.30.10:FF:000256', NULL, NULL, 'Glutathione S-transferase U11', NULL, NULL, NULL, NULL, NULL, 4),
(203946, NULL, 'G3DSA:3.90.1480.20:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203947, NULL, 'G3DSA:3.40.50.1460:FF:000116', NULL, NULL, 'GPI-anchor transamidase', NULL, NULL, NULL, NULL, NULL, 4),
(203948, NULL, 'G3DSA:3.30.870.10:FF:000123', NULL, NULL, 'Cardiolipin synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(203949, NULL, 'G3DSA:2.130.10.10:FF:002439', NULL, NULL, 'Protein CBG02611', NULL, NULL, NULL, NULL, NULL, 4),
(203950, NULL, 'G3DSA:3.30.230.10:FF:000064', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(203951, NULL, 'G3DSA:2.10.60.10:FF:000014', NULL, NULL, 'Serine/threonine-protein kinase receptor R3', NULL, NULL, NULL, NULL, NULL, 4),
(203952, NULL, 'G3DSA:1.10.20.10:FF:000166', NULL, NULL, 'TAF (TBP-associated transcription factor) family', NULL, NULL, NULL, NULL, NULL, 4),
(203953, NULL, 'G3DSA:2.60.120.370:FF:000005', NULL, NULL, 'Beta-galactosidase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(203954, NULL, 'G3DSA:3.30.70.330:FF:002814', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203955, NULL, 'G3DSA:1.10.8.480:FF:000017', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(203956, NULL, 'G3DSA:2.60.40.150:FF:000806', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203957, NULL, 'G3DSA:1.20.58.80:FF:000003', NULL, NULL, 'Katanin p60 ATPase-containing subunit A1', NULL, NULL, NULL, NULL, NULL, 4),
(203958, NULL, 'G3DSA:3.80.10.10:FF:000517', NULL, NULL, 'Leucine rich repeat containing 15', NULL, NULL, NULL, NULL, NULL, 4),
(203959, NULL, 'G3DSA:1.10.150.910:FF:000005', NULL, NULL, 'Cleavage and polyadenylation specific factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(203960, NULL, 'G3DSA:3.20.20.80:FF:000777', NULL, NULL, 'Chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(203961, NULL, 'G3DSA:1.20.5.2210:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203962, NULL, 'G3DSA:3.30.200.20:FF:002066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203963, NULL, 'G3DSA:3.10.110.10:FF:000368', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(203964, NULL, 'G3DSA:1.10.3710.10:FF:000005', NULL, NULL, 'AAA family ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(203965, NULL, 'G3DSA:2.130.10.10:FF:005845', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203966, NULL, 'G3DSA:3.30.70.3370:FF:000001', NULL, NULL, '40S ribosomal protein S24', NULL, NULL, NULL, NULL, NULL, 4),
(203967, NULL, 'G3DSA:1.25.40.180:FF:000219', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203968, NULL, 'G3DSA:2.60.40.150:FF:000458', NULL, NULL, 'RPGR-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(203969, NULL, 'G3DSA:1.20.1070.10:FF:001987', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203970, NULL, 'G3DSA:3.90.70.10:FF:000032', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 14', NULL, NULL, NULL, NULL, NULL, 4),
(203971, NULL, 'G3DSA:3.90.640.10:FF:000008', NULL, NULL, 'alpha-centractin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(203972, NULL, 'G3DSA:3.50.50.60:FF:000199', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(203973, NULL, 'G3DSA:2.40.30.30:FF:000040', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(203974, NULL, 'G3DSA:1.10.730.20:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203975, NULL, 'G3DSA:2.60.40.10:FF:001303', NULL, NULL, 'Cell surface glycoprotein MUC18', NULL, NULL, NULL, NULL, NULL, 4),
(203976, NULL, 'G3DSA:1.10.1450.10:FF:000142', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(203977, NULL, 'G3DSA:1.10.1450.10:FF:000086', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(203978, NULL, 'G3DSA:2.60.40.150:FF:000514', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203979, NULL, 'G3DSA:1.10.10.790:FF:000018', NULL, NULL, 'Splicing factor 3A subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(203980, NULL, 'G3DSA:3.30.505.10:FF:000124', NULL, NULL, 'tensin', NULL, NULL, NULL, NULL, NULL, 4),
(203981, NULL, 'G3DSA:3.30.230.130:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203982, NULL, 'G3DSA:1.10.10.60:FF:001124', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203983, NULL, 'G3DSA:3.80.10.10:FF:004412', NULL, NULL, 'Receptor like protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(203984, NULL, 'G3DSA:3.60.10.10:FF:000035', NULL, NULL, 'Deoxyribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(203985, NULL, 'G3DSA:2.60.40.2840:FF:000009', NULL, NULL, 'inositol polyphosphate 5-phosphatase K', NULL, NULL, NULL, NULL, NULL, 4),
(203986, NULL, 'G3DSA:2.40.50.700:FF:000006', NULL, NULL, 'Exosome complex exonuclease RRP44', NULL, NULL, NULL, NULL, NULL, 4),
(203987, NULL, 'G3DSA:3.40.50.10490:FF:000020', NULL, NULL, 'Glucose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(203988, NULL, 'G3DSA:3.30.450.40:FF:000027', NULL, NULL, 'Sensor histidine kinase YpdA', NULL, NULL, NULL, NULL, NULL, 4),
(203989, NULL, 'G3DSA:3.30.160.60:FF:002708', NULL, NULL, 'Zinc finger, C2H2 type', NULL, NULL, NULL, NULL, NULL, 4),
(203990, NULL, 'G3DSA:3.20.20.210:FF:000011', NULL, NULL, 'Uroporphyrinogen decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(203991, NULL, 'G3DSA:3.40.50.1820:FF:000511', NULL, NULL, 'Epoxide hydrolase EphF', NULL, NULL, NULL, NULL, NULL, 4),
(203992, NULL, 'G3DSA:3.30.40.10:FF:000931', NULL, NULL, 'GM11875', NULL, NULL, NULL, NULL, NULL, 4),
(203993, NULL, 'G3DSA:1.50.40.10:FF:000109', NULL, NULL, 'Ornithine carrier protein AmcA/Ort1', NULL, NULL, NULL, NULL, NULL, 4),
(203994, NULL, 'G3DSA:2.130.10.10:FF:001574', NULL, NULL, 'Similar to pre-mRNA splicing factor 3b', NULL, NULL, NULL, NULL, NULL, 4),
(203995, NULL, 'G3DSA:1.10.10.10:FF:000901', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(203996, NULL, 'G3DSA:1.20.1250.20:FF:002162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203997, NULL, 'G3DSA:3.30.160.60:FF:003636', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(203998, NULL, 'G3DSA:1.25.10.10:FF:001014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(203999, NULL, 'G3DSA:1.25.70.10:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204000, NULL, 'G3DSA:1.10.10.10:FF:001481', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC3', NULL, NULL, NULL, NULL, NULL, 4),
(204001, NULL, 'G3DSA:2.130.10.10:FF:005317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204002, NULL, 'G3DSA:1.10.238.10:FF:000032', NULL, NULL, 'Spectrin alpha chain, non-erythrocytic 1', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(204003, NULL, 'G3DSA:2.120.10.30:FF:000265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204004, NULL, 'G3DSA:3.20.20.80:FF:000833', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204005, NULL, 'G3DSA:3.30.565.10:FF:000189', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(204006, NULL, 'G3DSA:1.20.920.20:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204007, NULL, 'G3DSA:2.60.60.20:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204008, NULL, 'G3DSA:2.40.50.140:FF:000411', NULL, NULL, '23S rRNA (Uracil-5-)-methyltransferase RumA', NULL, NULL, NULL, NULL, NULL, 4),
(204009, NULL, 'G3DSA:3.40.1800.20:FF:000006', NULL, NULL, 'GD21383', NULL, NULL, NULL, NULL, NULL, 4),
(204010, NULL, 'G3DSA:1.10.510.10:FF:002407', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204011, NULL, 'G3DSA:1.10.340.30:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204012, NULL, 'G3DSA:1.20.1560.10:FF:000018', NULL, NULL, 'ATP-binding cassette subfamily B member 11', NULL, NULL, NULL, NULL, NULL, 4),
(204013, NULL, 'G3DSA:3.40.50.12550:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204014, NULL, 'G3DSA:2.60.220.50:FF:000055', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(204015, NULL, 'G3DSA:2.130.10.10:FF:002063', NULL, NULL, 'WD repeat domain 43', NULL, NULL, NULL, NULL, NULL, 4),
(204016, NULL, 'G3DSA:2.40.100.10:FF:000157', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(204017, NULL, 'G3DSA:3.30.200.20:FF:001138', NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-like 1.2 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(204018, NULL, 'G3DSA:3.40.800.20:FF:000041', NULL, NULL, 'Histone deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(204019, NULL, 'G3DSA:3.40.50.970:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204020, NULL, 'G3DSA:1.25.40.10:FF:002146', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(204021, NULL, 'G3DSA:1.10.287.470:FF:000092', NULL, NULL, 'Efflux pump, RND family, membrane fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(204022, NULL, 'G3DSA:1.10.510.10:FF:001098', NULL, NULL, 'Unplaced genomic scaffold supercont1.188, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(204023, NULL, 'G3DSA:3.40.50.410:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204024, NULL, 'G3DSA:2.130.10.10:FF:005284', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(204025, NULL, 'G3DSA:3.60.40.10:FF:000155', NULL, NULL, 'Protein phosphatase 2C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204026, NULL, 'G3DSA:3.40.50.1010:FF:000010', NULL, NULL, 'Exosome complex exonuclease DIS3', NULL, NULL, NULL, NULL, NULL, 4),
(204027, NULL, 'G3DSA:1.10.390.10:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204028, NULL, 'G3DSA:3.40.50.880:FF:000185', NULL, NULL, 'Carbamoyl-phosphate synthase small chain, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(204029, NULL, 'G3DSA:2.60.40.10:FF:005188', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204030, NULL, 'G3DSA:1.10.10.60:FF:001091', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204031, NULL, 'G3DSA:2.60.40.10:FF:001450', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204032, NULL, 'G3DSA:2.60.40.10:FF:004176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204033, NULL, 'G3DSA:2.170.150.80:FF:000004', NULL, NULL, 'NAC transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(204034, NULL, 'G3DSA:3.40.850.10:FF:000159', NULL, NULL, 'Microtubule motor protein', NULL, NULL, NULL, NULL, NULL, 4),
(204035, NULL, 'G3DSA:3.30.1920.40:FF:000001', NULL, NULL, 'Phage baseplate hub subunit', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(204036, NULL, 'G3DSA:3.40.50.2020:FF:000178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204037, NULL, 'G3DSA:1.20.1070.10:FF:000526', NULL, NULL, 'Olfactory receptor family 52 subfamily D member 1', NULL, NULL, NULL, NULL, NULL, 4),
(204038, NULL, 'G3DSA:2.60.40.10:FF:005160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204039, NULL, 'G3DSA:3.30.160.60:FF:002675', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204040, NULL, 'G3DSA:1.10.12.70:FF:000007', NULL, NULL, 'STE/STE20/YSK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(204041, NULL, 'G3DSA:1.20.1280.50:FF:000144', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(204042, NULL, 'G3DSA:3.20.20.140:FF:000018', NULL, NULL, '3''-5'' ssDNA/RNA exonuclease TatD', NULL, NULL, NULL, NULL, NULL, 4),
(204043, NULL, 'G3DSA:3.60.20.10:FF:000209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204044, NULL, 'G3DSA:3.30.70.330:FF:000493', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase E', NULL, NULL, NULL, NULL, NULL, 4),
(204045, NULL, 'G3DSA:3.40.50.150:FF:001866', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204046, NULL, 'G3DSA:1.10.510.10:FF:003043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204047, NULL, 'G3DSA:1.20.120.1240:FF:000075', NULL, NULL, 'Dynamin-related protein 3A', NULL, NULL, NULL, NULL, NULL, 4),
(204048, NULL, 'G3DSA:1.10.8.350:FF:000001', NULL, NULL, 'Lytic murein transglycosylase B', NULL, NULL, NULL, NULL, NULL, 4),
(204049, NULL, 'G3DSA:3.40.630.30:FF:000334', NULL, NULL, 'N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(204050, NULL, 'G3DSA:3.80.10.10:FF:002962', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204051, NULL, 'G3DSA:3.40.190.10:FF:000956', NULL, NULL, 'Oligopeptide transport periplasmic protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204052, NULL, 'G3DSA:3.30.70.2280:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204053, NULL, 'G3DSA:1.10.472.10:FF:000244', NULL, NULL, 'Cyclin L1a', NULL, NULL, NULL, NULL, NULL, 4),
(204054, NULL, 'G3DSA:3.40.190.10:FF:000248', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(204055, NULL, 'G3DSA:3.40.50.2300:FF:001009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204056, NULL, 'G3DSA:3.30.530.20:FF:000022', NULL, NULL, 'StAR-related lipid transfer (START) domain-containing 9', NULL, NULL, NULL, NULL, NULL, 4),
(204057, NULL, 'G3DSA:1.10.565.10:FF:000016', NULL, NULL, 'Nuclear receptor subfamily 1 group D member 2', NULL, NULL, NULL, NULL, NULL, 4),
(204058, NULL, 'G3DSA:3.30.40.10:FF:002084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204059, NULL, 'G3DSA:1.50.40.10:FF:000261', NULL, NULL, 'Solute carrier family 25 member 5', NULL, NULL, NULL, NULL, NULL, 4),
(204060, NULL, 'G3DSA:3.40.50.2000:FF:000172', NULL, NULL, 'DNA alpha-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(204061, NULL, 'G3DSA:3.40.50.300:FF:006604', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204062, NULL, 'G3DSA:1.10.10.1930:FF:000001', NULL, NULL, 'Transcriptional Regulator BldD', NULL, NULL, NULL, NULL, NULL, 4),
(204063, NULL, 'G3DSA:3.40.50.300:FF:007588', NULL, NULL, 'ATP-dependent RNA helicase drs1', NULL, NULL, NULL, NULL, NULL, 4),
(204064, NULL, 'G3DSA:3.40.720.10:FF:000211', NULL, NULL, 'Iduronate 2-sulfatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204065, NULL, 'G3DSA:2.130.10.110:FF:000007', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(204066, NULL, 'G3DSA:3.40.50.720:FF:001323', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204067, NULL, 'G3DSA:3.30.160.60:FF:005637', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204068, NULL, 'G3DSA:3.40.1260.20:FF:000009', NULL, NULL, 'Ribonuclease E', NULL, NULL, NULL, NULL, NULL, 4),
(204069, NULL, 'G3DSA:1.10.1520.10:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(204070, NULL, 'G3DSA:3.30.1330.40:FF:000001', NULL, NULL, 'L-PSP family endoribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(204071, NULL, 'G3DSA:3.30.465.10:FF:000064', NULL, NULL, 'Putative cation efflux protein', NULL, NULL, NULL, NULL, NULL, 4),
(204072, NULL, 'G3DSA:2.60.40.10:FF:003479', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204073, NULL, 'G3DSA:3.30.9.10:FF:000281', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(204074, NULL, 'G3DSA:1.20.1270.280:FF:000062', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(204075, NULL, 'G3DSA:1.20.58.1610:FF:000009', NULL, NULL, 'NADH-ubiquinone oxidoreductase chain 3', NULL, NULL, NULL, NULL, NULL, 4),
(204076, NULL, 'G3DSA:2.60.200.20:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204077, NULL, 'G3DSA:3.30.160.60:FF:000258', NULL, NULL, 'zinc finger and SCAN domain-containing protein 29 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(204078, NULL, 'G3DSA:3.30.365.10:FF:000005', NULL, NULL, 'Carbon monoxide dehydrogenase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(204079, NULL, 'G3DSA:1.10.555.10:FF:000246', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204080, NULL, 'G3DSA:1.25.40.10:FF:003343', NULL, NULL, 'Pre-mRNA-splicing factor CLF1', NULL, NULL, NULL, NULL, NULL, 4),
(204081, NULL, 'G3DSA:2.60.40.10:FF:003535', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204082, NULL, 'G3DSA:3.40.390.10:FF:000320', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204083, NULL, 'G3DSA:2.130.10.10:FF:004064', NULL, NULL, 'Histone-binding protein RBBP4', NULL, NULL, NULL, NULL, NULL, 4),
(204084, NULL, 'G3DSA:3.30.1780.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204085, NULL, 'G3DSA:2.40.128.50:FF:000002', NULL, NULL, 'D-aminopeptidase domain C', NULL, NULL, NULL, NULL, NULL, 4),
(204086, NULL, 'G3DSA:2.60.40.1930:FF:000012', NULL, NULL, 'Complement C5', NULL, NULL, NULL, NULL, NULL, 4),
(204087, NULL, 'G3DSA:3.90.1150.10:FF:000239', NULL, NULL, 'DegT/DnrJ/EryC1/StrS aminotransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(204088, NULL, 'G3DSA:3.40.50.300:FF:007116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204089, NULL, 'G3DSA:2.80.10.50:FF:000256', NULL, NULL, 'Fascin', NULL, NULL, NULL, NULL, NULL, 4),
(204090, NULL, 'G3DSA:1.10.230.10:FF:000003', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(204091, NULL, 'G3DSA:1.10.390.10:FF:000020', NULL, NULL, 'aminopeptidase O isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(204092, NULL, 'G3DSA:3.40.50.2020:FF:000122', NULL, NULL, 'Uridine cytidine kinase I, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204093, NULL, 'G3DSA:6.10.140.2220:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204094, NULL, 'G3DSA:3.50.30.30:FF:000037', NULL, NULL, 'Peptidase M20', NULL, NULL, NULL, NULL, NULL, 4),
(204095, NULL, 'G3DSA:2.130.10.10:FF:002883', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204096, NULL, 'G3DSA:3.40.33.10:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204097, NULL, 'G3DSA:1.10.3720.10:FF:000118', NULL, NULL, 'Peptide ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(204098, NULL, 'G3DSA:1.25.40.20:FF:001694', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204099, NULL, 'G3DSA:3.30.70.940:FF:000018', NULL, NULL, 'AT3g09210/F3L24_8', NULL, NULL, NULL, NULL, NULL, 4),
(204100, NULL, 'G3DSA:1.10.220.160:FF:000016', NULL, NULL, 'GD10841', NULL, NULL, NULL, NULL, NULL, 4),
(204101, NULL, 'G3DSA:2.30.30.40:FF:000543', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(204102, NULL, 'G3DSA:3.40.1280.10:FF:000007', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4),
(204103, NULL, 'G3DSA:3.50.50.60:FF:000524', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(204104, NULL, 'G3DSA:3.30.40.10:FF:000662', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase (Cyclophilin)', NULL, NULL, NULL, NULL, NULL, 4),
(204105, NULL, 'G3DSA:1.20.120.1080:FF:000004', NULL, NULL, 'ATP-dependent RNA helicase DHX30 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(204106, NULL, 'G3DSA:2.60.40.10:FF:005721', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204107, NULL, 'G3DSA:1.10.10.10:FF:001065', NULL, NULL, 'Manganese ABC transporter membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(204108, NULL, 'G3DSA:3.20.20.190:FF:000044', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(204109, NULL, 'G3DSA:1.25.40.20:FF:000058', NULL, NULL, 'regulatory protein NPR5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(204110, NULL, 'G3DSA:2.30.30.100:FF:000116', NULL, NULL, 'Small nuclear ribonucleoprotein Sm D1', NULL, NULL, NULL, NULL, NULL, 4),
(204111, NULL, 'G3DSA:1.20.1070.10:FF:001190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204112, NULL, 'G3DSA:3.60.40.10:FF:000391', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204113, NULL, 'G3DSA:3.80.10.10:FF:004087', NULL, NULL, 'Leucine rich repeat neuronal 3', NULL, NULL, NULL, NULL, NULL, 4),
(204114, NULL, 'G3DSA:1.10.150.240:FF:000052', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(204115, NULL, 'G3DSA:2.60.40.1390:FF:000007', NULL, NULL, 'p53-like transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(204116, NULL, 'G3DSA:3.30.200.20:FF:002010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204117, NULL, 'G3DSA:1.10.10.10:FF:000553', NULL, NULL, 'Transcriptional regulator, LuxR family', NULL, NULL, NULL, NULL, NULL, 4),
(204118, NULL, 'G3DSA:1.25.10.10:FF:000992', NULL, NULL, 'Rotatin', NULL, NULL, NULL, NULL, NULL, 4),
(204119, NULL, 'G3DSA:3.40.50.1580:FF:000006', NULL, NULL, 'Purine nucleoside phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(204120, NULL, 'G3DSA:1.25.10.10:FF:002650', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204121, NULL, 'G3DSA:3.90.230.10:FF:000022', NULL, NULL, 'DNA-binding protein, 42 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(204122, NULL, 'G3DSA:1.20.5.1160:FF:000037', NULL, NULL, 'Keratin, type I cytoskeletal 13', NULL, NULL, NULL, NULL, NULL, 4),
(204123, NULL, 'G3DSA:6.10.250.3370:FF:000001', NULL, NULL, 'Aerobactin siderophore biosynthesis protein iucC', NULL, NULL, NULL, NULL, NULL, 4),
(204124, NULL, 'G3DSA:2.60.220.50:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204125, NULL, 'G3DSA:3.10.20.90:FF:001000', NULL, NULL, 'Tubulin-specific chaperone E-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(204126, NULL, 'G3DSA:2.10.50.10:FF:000132', NULL, NULL, 'signal peptide, CUB and EGF-like domain-containing protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(204127, NULL, 'G3DSA:1.10.287.1490:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204128, NULL, 'G3DSA:3.50.50.60:FF:000468', NULL, NULL, 'Salicylate hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(204129, NULL, 'G3DSA:1.25.40.420:FF:000016', NULL, NULL, 'BTB/POZ domain-containing protein 7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(204130, NULL, 'G3DSA:3.40.50.1000:FF:000001', NULL, NULL, 'Phospholipid-transporting ATPase IC', NULL, NULL, NULL, NULL, NULL, 4),
(204131, NULL, 'G3DSA:3.30.70.1450:FF:000032', NULL, NULL, 'Trk system potassium uptake protein TrkA', NULL, NULL, NULL, NULL, NULL, 4),
(204132, NULL, 'G3DSA:2.60.410.10:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204133, NULL, 'G3DSA:1.10.8.1220:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204134, NULL, 'G3DSA:2.170.300.10:FF:000006', NULL, NULL, 'Multiple epidermal growth factor-like domains protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(204135, NULL, 'G3DSA:3.30.160.60:FF:006042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204136, NULL, 'G3DSA:1.10.579.10:FF:000014', NULL, NULL, 'Cry4 protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(204137, NULL, 'G3DSA:3.90.1280.20:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204138, NULL, 'G3DSA:3.60.40.10:FF:000008', NULL, NULL, 'Phosphatase 2C family protein', NULL, NULL, NULL, NULL, NULL, 4),
(204139, NULL, 'G3DSA:1.25.10.10:FF:002318', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(204140, NULL, 'G3DSA:3.90.920.10:FF:000018', NULL, NULL, 'DNA primase small subunit PriS', NULL, NULL, NULL, NULL, NULL, 4),
(204141, NULL, 'G3DSA:3.40.50.720:FF:000918', NULL, NULL, 'Ornithine cyclodeaminase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204142, NULL, 'G3DSA:3.20.80.10:FF:000013', NULL, NULL, 'Soul heme-binding family protein', NULL, NULL, NULL, NULL, NULL, 4),
(204143, NULL, 'G3DSA:3.90.190.10:FF:000518', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204144, NULL, 'G3DSA:3.40.50.720:FF:000598', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(204145, NULL, 'G3DSA:1.10.510.10:FF:003863', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204146, NULL, 'G3DSA:2.40.50.140:FF:000647', NULL, NULL, 'Protection of telomeres protein 1b', NULL, NULL, NULL, NULL, NULL, 4),
(204147, NULL, 'G3DSA:1.25.40.10:FF:001634', NULL, NULL, 'Calcineurin-binding protein cabin-1', NULL, NULL, NULL, NULL, NULL, 4),
(204148, NULL, 'G3DSA:2.130.10.10:FF:002411', NULL, NULL, 'Striatin', NULL, NULL, NULL, NULL, NULL, 4),
(204149, NULL, 'G3DSA:2.60.40.10:FF:001826', NULL, NULL, 'Immunoglobulin kappa chain variable 4-91', NULL, NULL, NULL, NULL, NULL, 4),
(204150, NULL, 'G3DSA:3.30.450.20:FF:000488', NULL, NULL, 'Sensor histidine kinase TodS', NULL, NULL, NULL, NULL, NULL, 4),
(204151, NULL, 'G3DSA:3.40.50.1820:FF:001495', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204152, NULL, 'G3DSA:3.40.50.300:FF:003373', NULL, NULL, 'RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(204153, NULL, 'G3DSA:3.30.1330.30:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204154, NULL, 'G3DSA:1.10.472.80:FF:000276', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204155, NULL, 'G3DSA:3.40.220.10:FF:000010', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(204156, NULL, 'G3DSA:1.10.1370.40:FF:000004', NULL, NULL, 'DnaJ protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204157, NULL, 'G3DSA:1.10.630.10:FF:000792', NULL, NULL, 'Retinoic acid catabolizing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(204158, NULL, 'G3DSA:3.30.1490.20:FF:000063', NULL, NULL, 'Zgc:123047', NULL, NULL, NULL, NULL, NULL, 4),
(204159, NULL, 'G3DSA:3.30.200.20:FF:002482', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204160, NULL, 'G3DSA:2.70.160.11:FF:000020', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(204161, NULL, 'G3DSA:3.60.40.10:FF:000239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204162, NULL, 'G3DSA:3.30.420.40:FF:000615', NULL, NULL, 'Actin-related protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(204163, NULL, 'G3DSA:2.10.10.10:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204164, NULL, 'G3DSA:1.20.58.60:FF:000609', NULL, NULL, 'Spectrin repeat-containing, nuclear envelope family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(204165, NULL, 'G3DSA:2.70.170.10:FF:000008', NULL, NULL, 'Cholinergic receptor nicotinic alpha 6 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(204166, NULL, 'G3DSA:3.80.10.10:FF:003631', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(204167, NULL, 'G3DSA:1.25.40.800:FF:000001', NULL, NULL, 'CCR4-NOT transcription complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(204168, NULL, 'G3DSA:1.25.40.20:FF:000710', NULL, NULL, 'Ankyrin repeat domain 27 (VPS9 domain)', NULL, NULL, NULL, NULL, NULL, 4),
(204169, NULL, 'G3DSA:4.10.910.10:FF:000010', NULL, NULL, 'Ribosomal protein S13', NULL, NULL, NULL, NULL, NULL, 4),
(204170, NULL, 'G3DSA:1.25.40.20:FF:000390', NULL, NULL, 'Ankyrin repeat-containing protein NPR4', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(204171, NULL, 'G3DSA:3.40.50.300:FF:001225', NULL, NULL, 'ATP-binding cassette sub-family G member', NULL, NULL, NULL, NULL, NULL, 4),
(204172, NULL, 'G3DSA:2.60.120.380:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204173, NULL, 'G3DSA:3.30.360.10:FF:000040', NULL, NULL, 'Inositol 1-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(204174, NULL, 'G3DSA:2.60.40.10:FF:002231', NULL, NULL, 'Titin, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(204175, NULL, 'G3DSA:1.20.20.10:FF:000025', NULL, NULL, 'Os01g0899350 protein', NULL, NULL, NULL, NULL, NULL, 4),
(204176, NULL, 'G3DSA:1.20.120.1200:FF:000018', NULL, NULL, 'NADH-ubiquinone oxidoreductase chain 6', NULL, NULL, NULL, NULL, NULL, 4),
(204177, NULL, 'G3DSA:3.30.1490.10:FF:000003', NULL, NULL, '40S ribosomal protein S15a-5', NULL, NULL, NULL, NULL, NULL, 4),
(204178, NULL, 'G3DSA:2.60.40.10:FF:005952', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204179, NULL, 'G3DSA:4.10.280.10:FF:000219', NULL, NULL, 'Hairy-related 9', NULL, NULL, NULL, NULL, NULL, 4),
(204180, NULL, 'G3DSA:1.20.120.850:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204181, NULL, 'G3DSA:3.30.70.1230:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204182, NULL, 'G3DSA:3.30.230.70:FF:000059', NULL, NULL, 'FI01414p', NULL, NULL, NULL, NULL, NULL, 4),
(204183, NULL, 'G3DSA:2.130.10.10:FF:005789', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204184, NULL, 'G3DSA:1.20.120.140:FF:000002', NULL, NULL, 'Signal recognition particle receptor FtsY', NULL, NULL, NULL, NULL, NULL, 4),
(204185, NULL, 'G3DSA:3.30.420.10:FF:000511', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204186, NULL, 'G3DSA:2.170.270.10:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204187, NULL, 'G3DSA:1.10.510.10:FF:002115', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase pek-1', NULL, NULL, NULL, NULL, NULL, 4),
(204188, NULL, 'G3DSA:2.60.120.200:FF:000510', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(204189, NULL, 'G3DSA:3.30.200.20:FF:000593', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(204190, NULL, 'G3DSA:3.30.70.330:FF:001038', NULL, NULL, 'BnaA10g11870D protein', NULL, NULL, NULL, NULL, NULL, 4),
(204191, NULL, 'G3DSA:2.40.160.40:FF:000001', NULL, NULL, 'Porin OmpL', NULL, NULL, NULL, NULL, NULL, 4),
(204192, NULL, 'G3DSA:3.30.390.120:FF:000001', NULL, NULL, 'Nitric oxide reductase FlRd-NAD(+) reductase', NULL, NULL, NULL, NULL, NULL, 4),
(204193, NULL, 'G3DSA:3.90.550.10:FF:000237', NULL, NULL, 'WGS project CABT00000000 data, contig 2.1', NULL, NULL, NULL, NULL, NULL, 4),
(204194, NULL, 'G3DSA:2.60.40.10:FF:000045', NULL, NULL, 'Ephrin type-A receptor 5', NULL, NULL, NULL, NULL, NULL, 4),
(204195, NULL, 'G3DSA:3.40.50.2300:FF:001392', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204196, NULL, 'G3DSA:1.10.3090.10:FF:000007', NULL, NULL, 'tRNA nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(204197, NULL, 'G3DSA:3.90.199.10:FF:000010', NULL, NULL, 'DNA gyrase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(204198, NULL, 'G3DSA:2.40.50.140:FF:000703', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204199, NULL, 'G3DSA:3.30.200.20:FF:000121', NULL, NULL, 'Ribosomal protein S6 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(204200, NULL, 'G3DSA:1.20.920.10:FF:000222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204201, NULL, 'G3DSA:3.30.1520.10:FF:000001', NULL, NULL, 'Sorting nexin', NULL, NULL, NULL, NULL, NULL, 4),
(204202, NULL, 'G3DSA:3.30.40.10:FF:001948', NULL, NULL, 'E3 ubiquitin-protein ligase RHA2A', NULL, NULL, NULL, NULL, NULL, 4),
(204203, NULL, 'G3DSA:3.40.1360.10:FF:000008', NULL, NULL, 'Mitochondrial helicase twinkle', NULL, NULL, NULL, NULL, NULL, 4),
(204204, NULL, 'G3DSA:3.40.50.2000:FF:000964', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(204205, NULL, 'G3DSA:3.90.320.10:FF:000052', NULL, NULL, 'Gustatory receptor 125', NULL, NULL, NULL, NULL, NULL, 4),
(204206, NULL, 'G3DSA:1.10.20.10:FF:000110', NULL, NULL, 'Nuclear factor Y, subunit B1', NULL, NULL, NULL, NULL, NULL, 4),
(204207, NULL, 'G3DSA:1.10.10.10:FF:001773', NULL, NULL, 'Signal transduction response regulator, antiterminator', NULL, NULL, NULL, NULL, NULL, 4),
(204208, NULL, 'G3DSA:1.25.40.10:FF:002938', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g39620, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(204209, NULL, 'G3DSA:1.20.58.400:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204210, NULL, 'G3DSA:1.10.510.10:FF:003335', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204211, NULL, 'G3DSA:3.40.50.1820:FF:001023', NULL, NULL, 'KAT8 regulatory NSL complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(204212, NULL, 'G3DSA:3.10.310.10:FF:000024', NULL, NULL, 'Yhi9p', NULL, NULL, NULL, NULL, NULL, 4),
(204213, NULL, 'G3DSA:3.30.1600.10:FF:000002', NULL, NULL, 'NAD-dependent protein deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(204214, NULL, 'G3DSA:3.30.70.330:FF:002022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204215, NULL, 'G3DSA:3.40.30.10:FF:000172', NULL, NULL, 'Glutathione S-transferase GstA', NULL, NULL, NULL, NULL, NULL, 4),
(204216, NULL, 'G3DSA:3.20.10.10:FF:000008', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(204217, NULL, 'G3DSA:1.20.1560.10:FF:000434', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204218, NULL, 'G3DSA:1.20.90.10:FF:000012', NULL, NULL, 'Phospholipase A2 group III', NULL, NULL, NULL, NULL, NULL, 4),
(204219, NULL, 'G3DSA:1.10.238.10:FF:001049', NULL, NULL, 'Guanylate cyclase activator 1e', NULL, NULL, NULL, NULL, NULL, 4),
(204220, NULL, 'G3DSA:1.20.1440.200:FF:000004', NULL, NULL, 'Vacuolar protein sorting-associated protein 28', NULL, NULL, NULL, NULL, NULL, 4),
(204221, NULL, 'G3DSA:1.20.140.150:FF:000099', NULL, NULL, 'Voltage-dependent calcium channel gamma-2 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(204222, NULL, 'G3DSA:2.60.210.10:FF:000065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204223, NULL, 'G3DSA:1.20.1110.10:FF:000030', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(204224, NULL, 'G3DSA:3.60.20.10:FF:000064', NULL, NULL, 'Proteasome subunit beta type-6', NULL, NULL, NULL, NULL, NULL, 4),
(204225, NULL, 'G3DSA:3.40.50.2300:FF:000464', NULL, NULL, 'LuxR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(204226, NULL, 'G3DSA:1.10.1070.11:FF:000018', NULL, NULL, 'DNA-dependent protein kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(204227, NULL, 'G3DSA:3.30.160.60:FF:002203', NULL, NULL, 'Zinc finger protein 142-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(204228, NULL, 'G3DSA:1.20.58.60:FF:000233', NULL, NULL, 'nesprin-1 isoform X9', NULL, NULL, NULL, NULL, NULL, 4),
(204229, NULL, 'G3DSA:3.40.50.2000:FF:000436', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(204230, NULL, 'G3DSA:1.50.40.10:FF:000553', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204231, NULL, 'G3DSA:3.80.10.10:FF:002198', NULL, NULL, 'NACHT, LRR and PYD domains-containing protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(204232, NULL, 'G3DSA:3.10.490.20:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204233, NULL, 'G3DSA:3.60.15.10:FF:000175', NULL, NULL, 'Slr2005 protein', NULL, NULL, NULL, NULL, NULL, 4),
(204234, NULL, 'G3DSA:2.60.40.1730:FF:000008', NULL, NULL, 'aminopeptidase O isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(204235, NULL, 'G3DSA:3.40.50.10330:FF:000017', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(204236, NULL, 'G3DSA:1.10.10.60:FF:000719', NULL, NULL, 'Homeobox protein orthopedia-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(204237, NULL, 'G3DSA:2.120.10.80:FF:000055', NULL, NULL, 'kelch domain-containing protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(204238, NULL, 'G3DSA:3.40.50.300:FF:005879', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204239, NULL, 'G3DSA:3.30.160.60:FF:003928', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204240, NULL, 'G3DSA:3.40.50.300:FF:004098', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(204241, NULL, 'G3DSA:2.60.40.10:FF:000994', NULL, NULL, 'Sialic acid binding Ig like lectin 10', NULL, NULL, NULL, NULL, NULL, 4),
(204242, NULL, 'G3DSA:1.25.10.10:FF:001806', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204243, NULL, 'G3DSA:2.60.120.10:FF:000474', NULL, NULL, 'Cysteine dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(204244, NULL, 'G3DSA:2.130.10.10:FF:002355', NULL, NULL, 'Transducin', NULL, NULL, NULL, NULL, NULL, 4),
(204245, NULL, 'G3DSA:3.40.50.150:FF:001635', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204246, NULL, 'G3DSA:3.30.1390.20:FF:000004', NULL, NULL, '60S ribosomal protein L7', NULL, NULL, NULL, NULL, NULL, 4),
(204247, NULL, 'G3DSA:1.10.3170.10:FF:000008', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(204248, NULL, 'G3DSA:2.60.40.10:FF:000606', NULL, NULL, 'Vascular endothelial growth factor receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(204249, NULL, 'G3DSA:3.30.160.60:FF:001894', NULL, NULL, 'Zinc finger protein 768', NULL, NULL, NULL, NULL, NULL, 4),
(204250, NULL, 'G3DSA:3.40.50.620:FF:000714', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204251, NULL, 'G3DSA:3.40.50.10810:FF:000251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204252, NULL, 'G3DSA:3.30.70.330:FF:002730', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204253, NULL, 'G3DSA:3.80.10.10:FF:004143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204254, NULL, 'G3DSA:1.25.40.10:FF:002562', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(204255, NULL, 'G3DSA:2.30.29.30:FF:000469', NULL, NULL, 'unconventional myosin-XV', NULL, NULL, NULL, NULL, NULL, 4),
(204256, NULL, 'G3DSA:2.40.10.10:FF:000499', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204257, NULL, 'G3DSA:3.30.499.10:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204258, NULL, 'G3DSA:2.120.10.30:FF:000321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204259, NULL, 'G3DSA:3.40.50.410:FF:000241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204260, NULL, 'G3DSA:3.40.50.300:FF:007824', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204261, NULL, 'G3DSA:1.10.10.2670:FF:000009', NULL, NULL, 'Putative com1 regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(204262, NULL, 'G3DSA:1.20.120.160:FF:000008', NULL, NULL, 'Chemotaxis sensor histidine kinase CheA', NULL, NULL, NULL, NULL, NULL, 4),
(204263, NULL, 'G3DSA:3.40.190.10:FF:000479', NULL, NULL, 'Phosphate ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(204264, NULL, 'G3DSA:1.10.10.60:FF:000399', NULL, NULL, 'Homeobox protein B-H1', NULL, NULL, NULL, NULL, NULL, 4),
(204265, NULL, 'G3DSA:3.10.180.10:FF:000081', NULL, NULL, 'Uncharacterized 4-hydroxyphenylpyruvate dioxygenase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(204266, NULL, 'G3DSA:1.25.40.470:FF:000042', NULL, NULL, 'CRE-CHE-11 protein', NULL, NULL, NULL, NULL, NULL, 4),
(204267, NULL, 'G3DSA:3.40.50.300:FF:002445', NULL, NULL, 'ATP-dependent RNA helicase prh1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204268, NULL, 'G3DSA:1.10.168.20:FF:000006', NULL, NULL, '40S ribosomal protein S8', NULL, NULL, NULL, NULL, NULL, 4),
(204269, NULL, 'G3DSA:2.30.29.30:FF:000380', NULL, NULL, 'Interferon-induced guanylate-binding protein 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(204270, NULL, 'G3DSA:3.40.50.300:FF:005790', NULL, NULL, 'Si:dkey-11m19.5', NULL, NULL, NULL, NULL, NULL, 4),
(204271, NULL, 'G3DSA:1.20.120.1760:FF:000017', NULL, NULL, 'Phosphatidyl synthase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(204272, NULL, 'G3DSA:1.20.5.340:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204273, NULL, 'G3DSA:1.10.287.110:FF:000001', NULL, NULL, 'Import inner membrane translocase subunit tim14', NULL, NULL, NULL, NULL, NULL, 4),
(204274, NULL, 'G3DSA:3.30.70.330:FF:000785', NULL, NULL, 'NONO (Conserved nuclear protein, aka PSF) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(204275, NULL, 'G3DSA:1.10.3520.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204276, NULL, 'G3DSA:2.60.40.10:FF:005665', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204277, NULL, 'G3DSA:1.10.510.40:FF:000005', NULL, NULL, 'IucA/IucC family siderophore biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(204278, NULL, 'G3DSA:2.30.42.10:FF:000247', NULL, NULL, 'DegP protease 7', NULL, NULL, NULL, NULL, NULL, 4),
(204279, NULL, 'G3DSA:2.10.25.10:FF:000860', NULL, NULL, 'Attractin', NULL, NULL, NULL, NULL, NULL, 4),
(204280, NULL, 'G3DSA:3.40.50.10800:FF:000006', NULL, NULL, 'Quinolinate synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(204281, NULL, 'G3DSA:3.40.50.620:FF:000006', NULL, NULL, 'bifunctional 3''-phosphoadenosine 5''-phosphosulfate synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(204282, NULL, 'G3DSA:3.40.50.300:FF:002389', NULL, NULL, 'Related to ATP-binding cassette, sub-family G, member 2', NULL, NULL, NULL, NULL, NULL, 4),
(204283, NULL, 'G3DSA:3.40.50.1780:FF:000010', NULL, NULL, 'Nuclear prelamin A recognition factor', NULL, NULL, NULL, NULL, NULL, 4),
(204284, NULL, 'G3DSA:1.25.10.10:FF:003431', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204285, NULL, 'G3DSA:3.40.50.10190:FF:000048', NULL, NULL, 'DNA repair protein Rtt107', NULL, NULL, NULL, NULL, NULL, 4),
(204286, NULL, 'G3DSA:3.30.160.60:FF:004709', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204287, NULL, 'G3DSA:1.20.140.40:FF:000087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204288, NULL, 'G3DSA:1.10.510.10:FF:000373', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(204289, NULL, 'G3DSA:3.40.630.10:FF:000384', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(204290, NULL, 'G3DSA:1.10.132.70:FF:000017', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(204291, NULL, 'G3DSA:3.80.10.10:FF:003159', NULL, NULL, 'Os11g0685600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(204292, NULL, 'G3DSA:1.20.1070.10:FF:000262', NULL, NULL, 'Frizzled 2', NULL, NULL, NULL, NULL, NULL, 4),
(204293, NULL, 'G3DSA:3.80.10.10:FF:000809', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204294, NULL, 'G3DSA:2.60.40.2030:FF:000008', NULL, NULL, 'FRAS1-related extracellular matrix protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(204295, NULL, 'G3DSA:1.10.510.10:FF:004116', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204296, NULL, 'G3DSA:3.80.10.10:FF:002703', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(204297, NULL, 'G3DSA:1.20.200.10:FF:000038', NULL, NULL, 'Adenylosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(204298, NULL, 'G3DSA:2.130.10.10:FF:002916', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(204299, NULL, 'G3DSA:2.130.10.10:FF:003283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204300, NULL, 'G3DSA:3.30.160.20:FF:000241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204301, NULL, 'G3DSA:1.25.40.20:FF:000766', NULL, NULL, 'KN motif and ankyrin repeat domains 2', NULL, NULL, NULL, NULL, NULL, 4),
(204302, NULL, 'G3DSA:3.30.200.20:FF:001610', NULL, NULL, 'Putative WAK-related receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(204303, NULL, 'G3DSA:3.40.50.10310:FF:000011', NULL, NULL, 'Creatinine amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(204304, NULL, 'G3DSA:1.20.5.110:FF:000163', NULL, NULL, 'Vesicle transport v-SNARE protein, putative', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(204305, NULL, 'G3DSA:1.10.418.10:FF:000130', NULL, NULL, 'Actinin alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(204306, NULL, 'G3DSA:1.25.10.10:FF:001245', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(204307, NULL, 'G3DSA:3.80.10.10:FF:003687', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204308, NULL, 'G3DSA:1.10.150.50:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204309, NULL, 'G3DSA:3.40.50.1820:FF:001528', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204310, NULL, 'G3DSA:3.30.1120.120:FF:000002', NULL, NULL, 'Probable serine/threonine-protein kinase zyg-1', NULL, NULL, NULL, NULL, NULL, 4),
(204311, NULL, 'G3DSA:1.20.58.760:FF:000037', NULL, NULL, 'Os01g0590700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(204312, NULL, 'G3DSA:2.10.25.10:FF:000675', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(204313, NULL, 'G3DSA:2.60.40.10:FF:002607', NULL, NULL, 'Chitodextrinase', NULL, NULL, NULL, NULL, NULL, 4),
(204314, NULL, 'G3DSA:3.20.20.70:FF:000448', NULL, NULL, 'Thiamine-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(204315, NULL, 'G3DSA:4.10.400.10:FF:000196', NULL, NULL, 'RT10567p', NULL, NULL, NULL, NULL, NULL, 4),
(204316, NULL, 'G3DSA:1.20.1250.20:FF:001465', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(204317, NULL, 'G3DSA:3.40.50.1820:FF:000191', NULL, NULL, 'LIPaSe related', NULL, NULL, NULL, NULL, NULL, 4),
(204318, NULL, 'G3DSA:1.10.150.530:FF:000015', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase N', NULL, NULL, NULL, NULL, NULL, 4),
(204319, NULL, 'G3DSA:3.40.1380.20:FF:000052', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(204320, NULL, 'G3DSA:3.40.50.720:FF:002487', NULL, NULL, 'ThiF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(204321, NULL, 'G3DSA:3.10.20.90:FF:000359', NULL, NULL, 'Replication stress response regulator SDE2', NULL, NULL, NULL, NULL, NULL, 4),
(204322, NULL, 'G3DSA:3.40.140.10:FF:000004', NULL, NULL, '26S proteasome regulatory subunit rpn-8', NULL, NULL, NULL, NULL, NULL, 4),
(204323, NULL, 'G3DSA:2.30.39.10:FF:000048', NULL, NULL, 'Serine protease inhibitor (serpin) 12', NULL, NULL, NULL, NULL, NULL, 4),
(204324, NULL, 'G3DSA:2.130.10.10:FF:004300', NULL, NULL, 'Pre-mRNA-processing factor 19 homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(204325, NULL, 'G3DSA:3.30.70.80:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204326, NULL, 'G3DSA:1.10.287.10:FF:000021', NULL, NULL, 'Mrps28p', NULL, NULL, NULL, NULL, NULL, 4),
(204327, NULL, 'G3DSA:3.40.250.10:FF:000158', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 4', NULL, NULL, NULL, NULL, NULL, 4),
(204328, NULL, 'G3DSA:3.40.50.300:FF:000444', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(204329, NULL, 'G3DSA:4.10.1000.40:FF:000014', NULL, NULL, 'YALI0E13794p', NULL, NULL, NULL, NULL, NULL, 4),
(204330, NULL, 'G3DSA:2.105.10.10:FF:000002', NULL, NULL, 'Adsorption protein P2', NULL, NULL, NULL, NULL, NULL, 4),
(204331, NULL, 'G3DSA:2.130.10.10:FF:004772', NULL, NULL, 'WD repeat protein iqw1', NULL, NULL, NULL, NULL, NULL, 4),
(204332, NULL, 'G3DSA:3.30.780.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204333, NULL, 'G3DSA:1.20.120.350:FF:000239', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204334, NULL, 'G3DSA:1.20.190.50:FF:000003', NULL, NULL, 'Nuclear pore complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(204335, NULL, 'G3DSA:1.20.5.500:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204336, NULL, 'G3DSA:3.40.50.300:FF:005823', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(204337, NULL, 'G3DSA:2.60.260.50:FF:000001', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(204338, NULL, 'G3DSA:2.40.40.20:FF:000037', NULL, NULL, 'Peroxisomal biogenesis factor 1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(204339, NULL, 'G3DSA:1.10.238.10:FF:000981', NULL, NULL, 'Calcium-binding mitochondrial carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(204340, NULL, 'G3DSA:1.10.8.60:FF:000090', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(204341, NULL, 'G3DSA:1.50.10.10:FF:000164', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(204342, NULL, 'G3DSA:1.10.630.10:FF:000404', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204343, NULL, 'G3DSA:3.10.120.10:FF:000009', NULL, NULL, 'Cytochrome b2, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204344, NULL, 'G3DSA:1.25.40.10:FF:004563', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204345, NULL, 'G3DSA:3.40.532.10:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204346, NULL, 'G3DSA:2.60.120.260:FF:000157', NULL, NULL, 'Cytosolic endo-beta-N-acetylglucosaminidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(204347, NULL, 'G3DSA:2.40.30.10:FF:000298', NULL, NULL, 'Putative translation initiation factor EIF-2B gamma subunit', NULL, NULL, NULL, NULL, NULL, 4),
(204348, NULL, 'G3DSA:3.40.1440.10:FF:000009', NULL, NULL, 'Excinuclease ABC subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(204349, NULL, 'G3DSA:3.90.190.10:FF:000198', NULL, NULL, 'Dual specificity protein phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204350, NULL, 'G3DSA:1.25.50.20:FF:000031', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(204351, NULL, 'G3DSA:1.25.40.20:FF:001171', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(204352, NULL, 'G3DSA:3.30.230.10:FF:000356', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204353, NULL, 'G3DSA:4.10.60.10:FF:000173', NULL, NULL, 'Zinc finger CCHC-type containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(204354, NULL, 'G3DSA:3.90.180.10:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204355, NULL, 'G3DSA:2.10.25.10:FF:000528', NULL, NULL, 'Growth arrest-specific protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(204356, NULL, 'G3DSA:3.40.50.300:FF:003878', NULL, NULL, 'ADP ribosylation factor like GTPase 5B', NULL, NULL, NULL, NULL, NULL, 4),
(204357, NULL, 'G3DSA:1.10.510.10:FF:002879', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204358, NULL, 'G3DSA:1.25.40.10:FF:000853', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g13600', NULL, NULL, NULL, NULL, NULL, 4),
(204359, NULL, 'G3DSA:3.30.160.60:FF:000966', NULL, NULL, 'ZFP90 zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(204360, NULL, 'G3DSA:3.30.420.10:FF:000191', NULL, NULL, 'Transposase', NULL, NULL, NULL, NULL, NULL, 4),
(204361, NULL, 'G3DSA:3.90.70.10:FF:000088', NULL, NULL, 'Ubl carboxyl-terminal hydrolase 18', NULL, NULL, NULL, NULL, NULL, 4),
(204362, NULL, 'G3DSA:3.40.50.2300:FF:000700', NULL, NULL, 'Sporulation initiation phosphotransferase F', NULL, NULL, NULL, NULL, NULL, 4),
(204363, NULL, 'G3DSA:3.40.50.1100:FF:000121', NULL, NULL, 'PLP-dependent cysteine synthase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(204364, NULL, 'G3DSA:1.20.1070.10:FF:001223', NULL, NULL, 'Beta-2 adrenergic receptor', NULL, NULL, NULL, NULL, NULL, 4),
(204365, NULL, 'G3DSA:2.30.29.30:FF:001397', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204366, NULL, 'G3DSA:3.40.30.10:FF:000548', NULL, NULL, 'Glutathione S-transferase theta-1', NULL, NULL, NULL, NULL, NULL, 4),
(204367, NULL, 'G3DSA:3.30.160.60:FF:003372', NULL, NULL, 'LD46263p', NULL, NULL, NULL, NULL, NULL, 4),
(204368, NULL, 'G3DSA:1.20.1540.10:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204369, NULL, 'G3DSA:3.40.50.620:FF:000478', NULL, NULL, 'Leucyl Amino-acyl tRNA Synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(204370, NULL, 'G3DSA:3.30.70.330:FF:002494', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204371, NULL, 'G3DSA:3.90.70.10:FF:000796', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(204372, NULL, 'G3DSA:3.40.50.12780:FF:000206', NULL, NULL, 'Fatty acid transporter protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(204373, NULL, 'G3DSA:1.25.40.10:FF:000145', NULL, NULL, 'G-protein-signaling modulator 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(204374, NULL, 'G3DSA:3.30.40.10:FF:001387', NULL, NULL, 'Putative histone-lysine n-methyltransferase 2c-like isoform x5', NULL, NULL, NULL, NULL, NULL, 4),
(204375, NULL, 'G3DSA:2.10.90.10:FF:000106', NULL, NULL, 'VEGF183 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204376, NULL, 'G3DSA:3.40.50.300:FF:006992', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204377, NULL, 'G3DSA:3.30.710.10:FF:000382', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204378, NULL, 'G3DSA:3.20.20.10:FF:000037', NULL, NULL, 'Alanine racemase', NULL, NULL, NULL, NULL, NULL, 4),
(204379, NULL, 'G3DSA:1.10.238.10:FF:000796', NULL, NULL, 'EF-hand superfamily Ca2+-modulated protein (AFU_orthologue AFUA_5G13630)', NULL, NULL, NULL, NULL, NULL, 4),
(204380, NULL, 'G3DSA:3.40.50.1220:FF:000011', NULL, NULL, 'NAD-dependent deacetylase sirtuin-7', NULL, NULL, NULL, NULL, NULL, 4),
(204381, NULL, 'G3DSA:1.50.10.10:FF:000017', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(204382, NULL, 'G3DSA:1.10.287.110:FF:000473', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(204383, NULL, 'G3DSA:1.25.40.10:FF:000673', NULL, NULL, 'TPR-repeat-containing chaperone protein DNAJ', NULL, NULL, NULL, NULL, NULL, 4),
(204384, NULL, 'G3DSA:1.20.1310.10:FF:000118', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204385, NULL, 'G3DSA:3.80.10.10:FF:001181', NULL, NULL, 'Leucine-rich repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(204386, NULL, 'G3DSA:3.30.1120.10:FF:000072', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(204387, NULL, 'G3DSA:2.60.40.1500:FF:000001', NULL, NULL, 'Alpha-L-iduronidase', NULL, NULL, NULL, NULL, NULL, 4),
(204388, NULL, 'G3DSA:3.40.1110.10:FF:000440', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204389, NULL, 'G3DSA:1.50.10.160:FF:000006', NULL, NULL, 'Bifunctional diterpene synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(204390, NULL, 'G3DSA:1.10.510.10:FF:003099', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204391, NULL, 'G3DSA:3.30.160.60:FF:005261', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204392, NULL, 'G3DSA:2.30.30.140:FF:000191', NULL, NULL, 'T17B22.17 protein', NULL, NULL, NULL, NULL, NULL, 4),
(204393, NULL, 'G3DSA:2.70.98.40:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204394, NULL, 'G3DSA:1.20.1090.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204395, NULL, 'G3DSA:3.30.200.20:FF:000065', NULL, NULL, 'SRSF protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(204396, NULL, 'G3DSA:3.40.50.10490:FF:000109', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204397, NULL, 'G3DSA:2.40.33.10:FF:000012', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(204398, NULL, 'G3DSA:3.40.20.10:FF:000143', NULL, NULL, 'Protein app1', NULL, NULL, NULL, NULL, NULL, 4),
(204399, NULL, 'G3DSA:3.40.50.300:FF:004862', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204400, NULL, 'G3DSA:1.10.8.50:FF:000030', NULL, NULL, 'Ribosomal protein S13', NULL, NULL, NULL, NULL, NULL, 4),
(204401, NULL, 'G3DSA:3.30.565.10:FF:000425', NULL, NULL, 'Phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(204402, NULL, 'G3DSA:1.25.40.10:FF:001073', NULL, NULL, 'Transcription factor EMB1444', NULL, NULL, NULL, NULL, NULL, 4),
(204403, NULL, 'G3DSA:3.40.50.1370:FF:000005', NULL, NULL, 'CAD protein-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(204404, NULL, 'G3DSA:2.40.30.70:FF:000001', NULL, NULL, 'tRNA (N6-threonylcarbamoyladenosine(37)-N6)-methyltransferase TrmO', NULL, NULL, NULL, NULL, NULL, 4),
(204405, NULL, 'G3DSA:1.20.58.390:FF:000061', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(204406, NULL, 'G3DSA:1.10.400.10:FF:000016', NULL, NULL, 'Guanine nucleotide-binding protein alpha-7 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(204407, NULL, 'G3DSA:1.25.40.610:FF:000011', NULL, NULL, 'Adhesion G protein-coupled receptor B2', NULL, NULL, NULL, NULL, NULL, 4),
(204408, NULL, 'G3DSA:2.40.70.10:FF:000328', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204409, NULL, 'G3DSA:3.80.10.10:FF:000961', NULL, NULL, 'Protein phosphatase PP1 regulatory subunit sds22', NULL, NULL, NULL, NULL, NULL, 4),
(204410, NULL, 'G3DSA:3.40.1190.20:FF:000037', NULL, NULL, 'Fructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(204411, NULL, 'G3DSA:3.30.160.60:FF:004333', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204412, NULL, 'G3DSA:3.30.40.10:FF:001443', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(204413, NULL, 'G3DSA:2.20.100.10:FF:000055', NULL, NULL, 'ADAMTS-like protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(204414, NULL, 'G3DSA:3.40.50.2300:FF:000644', NULL, NULL, 'Acid phosphatase 1, soluble, isoform CRA_d', NULL, NULL, NULL, NULL, NULL, 4),
(204415, NULL, 'G3DSA:1.10.472.30:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204416, NULL, 'G3DSA:3.40.50.1110:FF:000034', NULL, NULL, 'GDSL-motif lipase/hydrolase protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(204417, NULL, 'G3DSA:3.30.1010.10:FF:000058', NULL, NULL, 'Serine/threonine-protein kinase ATR', NULL, NULL, NULL, NULL, NULL, 4),
(204418, NULL, 'G3DSA:3.90.280.10:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204419, NULL, 'G3DSA:3.90.550.50:FF:000081', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(204420, NULL, 'G3DSA:3.30.40.10:FF:002371', NULL, NULL, 'Chromatin modification-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(204421, NULL, 'G3DSA:3.30.160.60:FF:000590', NULL, NULL, 'Zinc finger protein 319', NULL, NULL, NULL, NULL, NULL, 4),
(204422, NULL, 'G3DSA:3.40.50.1980:FF:000098', NULL, NULL, 'ABC-type cobalamin/Fe3+-siderophores transport systems, periplasmic components', NULL, NULL, NULL, NULL, NULL, 4),
(204423, NULL, 'G3DSA:3.40.1190.20:FF:000217', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204424, NULL, 'G3DSA:3.40.50.300:FF:003934', NULL, NULL, 'ARL2', NULL, NULL, NULL, NULL, NULL, 4),
(204425, NULL, 'G3DSA:2.60.40.60:FF:000363', NULL, NULL, 'Dachsous cadherin-related 1a', NULL, NULL, NULL, NULL, NULL, 4),
(204426, NULL, 'G3DSA:3.40.1280.10:FF:000098', NULL, NULL, 'tRNA (cytidine(56)-2''-O)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(204427, NULL, 'G3DSA:3.30.230.10:FF:000209', NULL, NULL, 'Ribonuclease P protein component', NULL, NULL, NULL, NULL, NULL, 4),
(204428, NULL, 'G3DSA:3.90.70.10:FF:000852', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(204429, NULL, 'G3DSA:3.80.10.10:FF:000253', NULL, NULL, 'Leucine-rich repeat-containing protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(204430, NULL, 'G3DSA:1.10.287.280:FF:000006', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(204431, NULL, 'G3DSA:1.20.1270.60:FF:000180', NULL, NULL, 'Vacuolar protein sorting-associated protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(204432, NULL, 'G3DSA:1.10.220.150:FF:000070', NULL, NULL, 'ADP-ribosylation factor GTPase-activating protein AGD10', NULL, NULL, NULL, NULL, NULL, 4),
(204433, NULL, 'G3DSA:3.80.10.10:FF:001214', NULL, NULL, 'Leucine rich repeat containing 26', NULL, NULL, NULL, NULL, NULL, 4),
(204434, NULL, 'G3DSA:1.25.40.20:FF:001019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204435, NULL, 'G3DSA:3.40.50.720:FF:000542', NULL, NULL, 'Inositol-3-phosphate synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(204436, NULL, 'G3DSA:3.90.660.10:FF:000066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204437, NULL, 'G3DSA:3.30.70.1170:FF:000015', NULL, NULL, 'Putative methyltransferase NSUN7', NULL, NULL, NULL, NULL, NULL, 4),
(204438, NULL, 'G3DSA:1.10.357.10:FF:000049', NULL, NULL, 'Probable transcriptional regulatory protein (Probably tetR/acrR-family)', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(204439, NULL, 'G3DSA:3.40.50.1100:FF:000065', NULL, NULL, 'Putative D-cysteine desulfhydrase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(204440, NULL, 'G3DSA:1.20.1250.20:FF:000684', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(204441, NULL, 'G3DSA:1.10.1200.10:FF:000039', NULL, NULL, 'Phenolpthiocerol synthesis type-I polyketide synthase PPSE', NULL, NULL, NULL, NULL, NULL, 4),
(204442, NULL, 'G3DSA:2.60.40.3210:FF:000020', NULL, NULL, 'Matrix metallopeptidase 15a', NULL, NULL, NULL, NULL, NULL, 4),
(204443, NULL, 'G3DSA:2.60.40.1120:FF:000067', NULL, NULL, 'Putative carboxypeptidase d', NULL, NULL, NULL, NULL, NULL, 4),
(204444, NULL, 'G3DSA:1.20.1540.10:FF:000107', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(204445, NULL, 'G3DSA:3.40.50.360:FF:000147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204446, NULL, 'G3DSA:3.30.1330.30:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204447, NULL, 'G3DSA:3.30.710.10:FF:000235', NULL, NULL, 'OSJNBa0093O08.6-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(204448, NULL, 'G3DSA:3.40.50.300:FF:000500', NULL, NULL, 'ATP-dependent RNA helicase DHX29', NULL, NULL, NULL, NULL, NULL, 4),
(204449, NULL, 'G3DSA:1.10.238.10:FF:000829', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204450, NULL, 'G3DSA:3.40.50.460:FF:000031', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(204451, NULL, 'G3DSA:3.10.580.10:FF:000010', NULL, NULL, 'Chloride voltage-gated channel 6', NULL, NULL, NULL, NULL, NULL, 4),
(204452, NULL, 'G3DSA:1.20.58.2190:FF:000009', NULL, NULL, 'Tamo, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(204453, NULL, 'G3DSA:3.30.40.10:FF:000459', NULL, NULL, 'TFA1p TFIIE large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(204454, NULL, 'G3DSA:3.40.50.620:FF:000658', NULL, NULL, 'DALR anticodon binding domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(204455, NULL, 'G3DSA:3.30.200.20:FF:000773', NULL, NULL, 'L-type lectin-domain containing receptor kinase S.6-like', NULL, NULL, NULL, NULL, NULL, 4),
(204456, NULL, 'G3DSA:3.40.50.1260:FF:000028', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(204457, NULL, 'G3DSA:2.60.120.200:FF:000269', NULL, NULL, 'Laminin subunit alpha-3', NULL, NULL, NULL, NULL, NULL, 4),
(204458, NULL, 'G3DSA:3.30.1360.120:FF:000050', NULL, NULL, 'Putative transferase caf17 homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(204459, NULL, 'G3DSA:1.25.40.10:FF:001781', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(204460, NULL, 'G3DSA:3.50.50.60:FF:000704', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(204461, NULL, 'G3DSA:1.10.8.720:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204462, NULL, 'G3DSA:2.130.10.10:FF:003844', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204463, NULL, 'G3DSA:1.10.287.70:FF:000432', NULL, NULL, 'TOK potassium channel', NULL, NULL, NULL, NULL, NULL, 4),
(204464, NULL, 'G3DSA:1.20.1250.20:FF:000161', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(204465, NULL, 'G3DSA:3.30.2350.10:FF:000078', NULL, NULL, 'TruB pseudouridine (psi) synthase family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(204466, NULL, 'G3DSA:3.40.50.1820:FF:000567', NULL, NULL, 'Acyl-protein thioesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(204467, NULL, 'G3DSA:3.40.50.300:FF:008605', NULL, NULL, 'ATPase, AAA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(204468, NULL, 'G3DSA:2.120.10.80:FF:000111', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(204469, NULL, 'G3DSA:3.60.120.10:FF:000015', NULL, NULL, 'Probable isochorismate synthase entC', NULL, NULL, NULL, NULL, NULL, 4),
(204470, NULL, 'G3DSA:2.10.25.10:FF:000708', NULL, NULL, 'Stabilin 2', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(204471, NULL, 'G3DSA:3.30.450.70:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204472, NULL, 'G3DSA:3.60.20.10:FF:000120', NULL, NULL, 'Proteasome subunit beta type 7-B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204473, NULL, 'G3DSA:4.10.400.10:FF:000252', NULL, NULL, 'Suppressor of tumorigenicity 14 protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(204474, NULL, 'G3DSA:3.40.1190.20:FF:000184', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204475, NULL, 'G3DSA:2.40.50.140:FF:001052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204476, NULL, 'G3DSA:2.130.10.10:FF:000410', NULL, NULL, 'U3 small nucleolar RNA-associated protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(204477, NULL, 'G3DSA:2.130.10.10:FF:003136', NULL, NULL, 'Tricorn protease homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(204478, NULL, 'G3DSA:1.10.8.60:FF:000123', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(204479, NULL, 'G3DSA:2.30.39.10:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204480, NULL, 'G3DSA:1.20.1070.10:FF:002151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204481, NULL, 'G3DSA:1.20.58.2170:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204482, NULL, 'G3DSA:3.30.559.10:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204483, NULL, 'G3DSA:1.20.120.230:FF:000057', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(204484, NULL, 'G3DSA:3.30.1370.100:FF:000012', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(204485, NULL, 'G3DSA:3.90.70.10:FF:000352', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204486, NULL, 'G3DSA:2.30.30.380:FF:000060', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(204487, NULL, 'G3DSA:3.40.350.10:FF:000014', NULL, NULL, 'Aminopeptidase P2', NULL, NULL, NULL, NULL, NULL, 4),
(204488, NULL, 'G3DSA:3.40.50.300:FF:007408', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204489, NULL, 'G3DSA:1.10.10.10:FF:001250', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(204490, NULL, 'G3DSA:3.20.20.60:FF:000035', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(204491, NULL, 'G3DSA:3.90.800.10:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204492, NULL, 'G3DSA:3.40.47.10:FF:000143', NULL, NULL, 'Fatty acid synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(204493, NULL, 'G3DSA:1.10.1740.10:FF:000041', NULL, NULL, 'Putative sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(204494, NULL, 'G3DSA:3.40.50.720:FF:001559', NULL, NULL, 'Probable oxidoreductase (Short-chain dehydrogenase family)', NULL, NULL, NULL, NULL, NULL, 4),
(204495, NULL, 'G3DSA:3.30.160.60:FF:005401', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204496, NULL, 'G3DSA:2.30.30.40:FF:000251', NULL, NULL, 'Chemotaxis protein CheW', NULL, NULL, NULL, NULL, NULL, 4),
(204497, NULL, 'G3DSA:1.20.5.110:FF:000343', NULL, NULL, 'SNAP-25 (Synaptosome-associated protein) component of SNARE complex, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204498, NULL, 'G3DSA:2.60.120.1000:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204499, NULL, 'G3DSA:3.40.50.300:FF:004654', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(204500, NULL, 'G3DSA:1.20.5.170:FF:000254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204501, NULL, 'G3DSA:3.30.1370.120:FF:000018', NULL, NULL, 'Type II secretion system lipoprotein GspD, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204502, NULL, 'G3DSA:3.10.110.10:FF:000155', NULL, NULL, 'Ubiquitin-conjugating enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(204503, NULL, 'G3DSA:3.40.1010.20:FF:000002', NULL, NULL, '4-hydroxy-3-methylbut-2-enyl diphosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(204504, NULL, 'G3DSA:2.40.30.20:FF:000003', NULL, NULL, 'Riboflavin synthase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(204505, NULL, 'G3DSA:3.30.70.100:FF:000126', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204506, NULL, 'G3DSA:2.10.220.10:FF:000032', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(204507, NULL, 'G3DSA:1.20.1250.20:FF:002246', NULL, NULL, 'Proton-dependent oligopeptide transport (POT) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(204508, NULL, 'G3DSA:3.30.1360.210:FF:000009', NULL, NULL, '60S ribosomal protein L22, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204509, NULL, 'G3DSA:1.10.3060.10:FF:000011', NULL, NULL, 'Protein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(204510, NULL, 'G3DSA:3.60.20.10:FF:000092', NULL, NULL, 'Class II glutamine amidotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(204511, NULL, 'G3DSA:3.30.70.270:FF:000149', NULL, NULL, 'Putative signal protein with GGDEF domain', NULL, NULL, NULL, NULL, NULL, 4),
(204512, NULL, 'G3DSA:2.60.120.290:FF:000251', NULL, NULL, 'Cubilin-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(204513, NULL, 'G3DSA:3.40.190.10:FF:000400', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(204514, NULL, 'G3DSA:3.40.50.150:FF:001714', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204515, NULL, 'G3DSA:1.20.1560.10:FF:000350', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204516, NULL, 'G3DSA:3.40.1500.10:FF:000020', NULL, NULL, 'Coproporphyrinogen III oxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204517, NULL, 'G3DSA:1.20.1070.10:FF:001010', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(204518, NULL, 'G3DSA:3.60.20.10:FF:000041', NULL, NULL, 'Asparagine synthase (Glutamine-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4),
(204519, NULL, 'G3DSA:3.20.80.10:FF:000041', NULL, NULL, 'SOUL heme-binding family protein', NULL, NULL, NULL, NULL, NULL, 4),
(204520, NULL, 'G3DSA:1.10.357.140:FF:000026', NULL, NULL, 'Phosphoribose diphosphate:decaprenyl-phosphate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(204521, NULL, 'G3DSA:1.25.10.10:FF:000845', NULL, NULL, 'Protein folding regulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204522, NULL, 'G3DSA:3.80.10.10:FF:000045', NULL, NULL, 'Leucine-rich repeat and fibronectin type III domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(204523, NULL, 'G3DSA:1.50.40.10:FF:000317', NULL, NULL, 'Dicarboxylate carrier 4, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(204524, NULL, 'G3DSA:3.30.160.60:FF:004833', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204525, NULL, 'G3DSA:3.30.70.330:FF:001538', NULL, NULL, 'RNA binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204526, NULL, 'G3DSA:1.20.272.10:FF:000007', NULL, NULL, 'Replication factor C subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(204527, NULL, 'G3DSA:2.60.40.10:FF:003827', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204528, NULL, 'G3DSA:1.10.287.3440:FF:000006', NULL, NULL, 'Biosynthetic arginine decarboxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(204529, NULL, 'G3DSA:3.30.40.10:FF:000307', NULL, NULL, 'LON peptidase N-terminal domain and RING finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(204530, NULL, 'G3DSA:3.30.70.100:FF:000177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204531, NULL, 'G3DSA:3.90.70.10:FF:000301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204532, NULL, 'G3DSA:1.10.10.60:FF:001271', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204533, NULL, 'G3DSA:1.10.8.60:FF:000174', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(204534, NULL, 'G3DSA:2.160.20.10:FF:000168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204535, NULL, 'G3DSA:2.60.120.780:FF:000010', NULL, NULL, 'AaceriAAR121Wp', NULL, NULL, NULL, NULL, NULL, 4),
(204536, NULL, 'G3DSA:1.25.40.200:FF:000001', NULL, NULL, 'Ran GTPase-activating protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(204537, NULL, 'G3DSA:3.30.572.10:FF:000032', NULL, NULL, 'Probable thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(204538, NULL, 'G3DSA:2.60.40.60:FF:000604', NULL, NULL, 'CaDHerin family', NULL, NULL, NULL, NULL, NULL, 4),
(204539, NULL, 'G3DSA:3.30.70.340:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204540, NULL, 'G3DSA:1.50.10.20:FF:000077', NULL, NULL, 'Protein geranylgeranyltransferase type I subunit', NULL, NULL, NULL, NULL, NULL, 4),
(204541, NULL, 'G3DSA:1.20.120.1910:FF:000023', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(204542, NULL, 'G3DSA:2.60.120.200:FF:000325', NULL, NULL, 'Vesicular mannose-binding lectin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204543, NULL, 'G3DSA:2.60.40.10:FF:005805', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204544, NULL, 'G3DSA:3.10.450.580:FF:000006', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(204545, NULL, 'G3DSA:1.10.132.30:FF:000028', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(204546, NULL, 'G3DSA:2.60.120.200:FF:000797', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204547, NULL, 'G3DSA:2.30.29.30:FF:000969', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204548, NULL, 'G3DSA:1.20.5.4280:FF:000001', NULL, NULL, '60S ribosomal protein L16-A', NULL, NULL, NULL, NULL, NULL, 4),
(204549, NULL, 'G3DSA:3.80.10.10:FF:003659', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204550, NULL, 'G3DSA:3.40.50.300:FF:006099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204551, NULL, 'G3DSA:2.30.36.70:FF:000014', NULL, NULL, 'Actin, alpha 2, smooth muscle, aorta', NULL, NULL, NULL, NULL, NULL, 4),
(204552, NULL, 'G3DSA:3.40.850.10:FF:000428', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(204553, NULL, 'G3DSA:3.30.70.1730:FF:000026', NULL, NULL, '60S acidic ribosomal protein P0', NULL, NULL, NULL, NULL, NULL, 4),
(204554, NULL, 'G3DSA:1.25.40.10:FF:002859', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(204555, NULL, 'G3DSA:3.30.300.160:FF:000012', NULL, NULL, 'Type IV-A pilus assembly ATPase PilB', NULL, NULL, NULL, NULL, NULL, 4),
(204556, NULL, 'G3DSA:3.30.70.330:FF:001589', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204557, NULL, 'G3DSA:3.30.160.60:FF:005289', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204558, NULL, 'G3DSA:1.25.40.10:FF:004776', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204559, NULL, 'G3DSA:3.30.70.330:FF:002106', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204560, NULL, 'G3DSA:1.10.472.10:FF:000452', NULL, NULL, 'Cyclin domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(204561, NULL, 'G3DSA:1.10.540.10:FF:000105', NULL, NULL, 'ActVA 5 protein', NULL, NULL, NULL, NULL, NULL, 4),
(204562, NULL, 'G3DSA:1.20.1070.10:FF:000442', NULL, NULL, 'Melatonin receptor type 1A', NULL, NULL, NULL, NULL, NULL, 4),
(204563, NULL, 'G3DSA:3.40.50.720:FF:002127', NULL, NULL, 'Os07g0229800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(204564, NULL, 'G3DSA:3.40.605.10:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204565, NULL, 'G3DSA:3.90.1200.10:FF:000031', NULL, NULL, 'Spore coat protein YutH', NULL, NULL, NULL, NULL, NULL, 4),
(204566, NULL, 'G3DSA:1.25.40.370:FF:000006', NULL, NULL, 'Apoptotic protease-activating factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(204567, NULL, 'G3DSA:1.10.510.10:FF:003251', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204568, NULL, 'G3DSA:3.90.199.10:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204569, NULL, 'G3DSA:2.10.25.10:FF:001405', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(204570, NULL, 'G3DSA:3.40.430.10:FF:000015', NULL, NULL, 'Dihydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(204571, NULL, 'G3DSA:1.25.10.10:FF:001801', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(204572, NULL, 'G3DSA:3.40.50.300:FF:005059', NULL, NULL, 'Muscle RAS oncogene homolog', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(204573, NULL, 'G3DSA:3.40.50.880:FF:000005', NULL, NULL, 'CTP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(204574, NULL, 'G3DSA:2.40.50.140:FF:000675', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204575, NULL, 'G3DSA:3.90.226.10:FF:000203', NULL, NULL, '3-hydroxy-3-methylglutaryl-coenzyme A lyase/3-methylglutaconyl-coenzyme A hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(204576, NULL, 'G3DSA:3.40.50.1820:FF:001787', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204577, NULL, 'G3DSA:2.60.40.10:FF:003035', NULL, NULL, 'Highly immunogenic outer capsid protein', NULL, NULL, NULL, NULL, NULL, 4),
(204578, NULL, 'G3DSA:3.30.720.50:FF:000012', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(204579, NULL, 'G3DSA:1.25.40.10:FF:000201', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(204580, NULL, 'G3DSA:3.90.105.20:FF:000010', NULL, NULL, 'Ribosome assembly factor mrt4', NULL, NULL, NULL, NULL, NULL, 4),
(204581, NULL, 'G3DSA:2.60.120.650:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204582, NULL, 'G3DSA:3.10.20.90:FF:000623', NULL, NULL, 'XPC-binding domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(204583, NULL, 'G3DSA:3.10.450.320:FF:000007', NULL, NULL, 'Mitochondrial import inner membrane translocase subunit Tim21', NULL, NULL, NULL, NULL, NULL, 4),
(204584, NULL, 'G3DSA:1.10.418.60:FF:000004', NULL, NULL, 'Nuf2p', NULL, NULL, NULL, NULL, NULL, 4),
(204585, NULL, 'G3DSA:2.60.40.10:FF:002467', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(204586, NULL, 'G3DSA:1.10.150.20:FF:000191', NULL, NULL, 'Flap structure-specific endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(204587, NULL, 'G3DSA:2.130.10.10:FF:001282', NULL, NULL, 'ER membrane protein complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(204588, NULL, 'G3DSA:3.40.50.300:FF:002237', NULL, NULL, 'Shikimate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(204589, NULL, 'G3DSA:3.30.160.60:FF:002416', NULL, NULL, 'Zinc finger protein 891', NULL, NULL, NULL, NULL, NULL, 4),
(204590, NULL, 'G3DSA:1.10.10.160:FF:000043', NULL, NULL, 'RecBCD enzyme subunit RecC', NULL, NULL, NULL, NULL, NULL, 4),
(204591, NULL, 'G3DSA:1.25.40.10:FF:000561', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204592, NULL, 'G3DSA:1.20.120.330:FF:000020', NULL, NULL, 'Related to SPA2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(204593, NULL, 'G3DSA:2.60.40.60:FF:000655', NULL, NULL, 'AGAP003579-PA', NULL, NULL, NULL, NULL, NULL, 4),
(204594, NULL, 'G3DSA:3.30.260.10:FF:000009', NULL, NULL, 'T-complex protein 1 subunit zeta', NULL, NULL, NULL, NULL, NULL, 4),
(204595, NULL, 'G3DSA:1.10.260.40:FF:000019', NULL, NULL, 'Maltose regulon transcriptional regulator MalI', NULL, NULL, NULL, NULL, NULL, 4),
(204596, NULL, 'G3DSA:3.30.160.60:FF:002967', NULL, NULL, 'Zinc finger protein 417', NULL, NULL, NULL, NULL, NULL, 4),
(204597, NULL, 'G3DSA:3.80.10.10:FF:000433', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(204598, NULL, 'G3DSA:1.10.840.10:FF:000038', NULL, NULL, 'Ras guanine nucleotide exchange factor N', NULL, NULL, NULL, NULL, NULL, 4),
(204599, NULL, 'G3DSA:3.40.5.60:FF:000005', NULL, NULL, 'DNA replication complex GINS protein SLD5', NULL, NULL, NULL, NULL, NULL, 4),
(204600, NULL, 'G3DSA:3.40.50.300:FF:001669', NULL, NULL, 'Dicer-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(204601, NULL, 'G3DSA:1.20.1440.160:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204602, NULL, 'G3DSA:3.30.40.10:FF:002224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204603, NULL, 'G3DSA:3.30.160.60:FF:004092', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204604, NULL, 'G3DSA:2.10.220.10:FF:000083', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5a', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(204605, NULL, 'G3DSA:2.40.70.10:FF:000160', NULL, NULL, 'ASpartyl Protease', NULL, NULL, NULL, NULL, NULL, 4),
(204606, NULL, 'G3DSA:2.130.10.10:FF:000758', NULL, NULL, 'UTP4, small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4),
(204607, NULL, 'G3DSA:2.60.120.10:FF:000114', NULL, NULL, 'Patatin like phospholipase domain containing 6', NULL, NULL, NULL, NULL, NULL, 4),
(204608, NULL, 'G3DSA:1.10.1900.10:FF:000008', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(204609, NULL, 'G3DSA:3.30.450.20:FF:000201', NULL, NULL, 'Cyclic-di-AMP phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(204610, NULL, 'G3DSA:1.10.510.10:FF:001738', NULL, NULL, 'TRAF2 and NCK interacting kinase', NULL, NULL, NULL, NULL, NULL, 4),
(204611, NULL, 'G3DSA:3.80.10.10:FF:001894', NULL, NULL, 'Toll-like receptor 13', NULL, NULL, NULL, NULL, NULL, 4),
(204612, NULL, 'G3DSA:1.20.1250.20:FF:000268', NULL, NULL, 'MFS multidrug efflux transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(204613, NULL, 'G3DSA:2.60.120.290:FF:000200', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(204614, NULL, 'G3DSA:3.40.50.200:FF:000116', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 4', NULL, NULL, NULL, NULL, NULL, 4),
(204615, NULL, 'G3DSA:3.30.200.20:FF:001402', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(204616, NULL, 'G3DSA:3.30.160.60:FF:001927', NULL, NULL, 'Zinc finger protein 1184', NULL, NULL, NULL, NULL, NULL, 4),
(204617, NULL, 'G3DSA:1.20.58.340:FF:000035', NULL, NULL, 'Putative CorA-like Mg2+ transporter protein', NULL, NULL, NULL, NULL, NULL, 4),
(204618, NULL, 'G3DSA:3.30.50.10:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204619, NULL, 'G3DSA:2.30.29.30:FF:000109', NULL, NULL, 'Arf-GAP with GTPase, ANK repeat and PH domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(204620, NULL, 'G3DSA:3.40.50.300:FF:003294', NULL, NULL, 'ARL1 isoform 5', NULL, NULL, NULL, NULL, NULL, 4),
(204621, NULL, 'G3DSA:3.40.50.300:FF:004603', NULL, NULL, 'Dynein_heavy_chain_-_N-terminal_region_2_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(204622, NULL, 'G3DSA:3.30.420.10:FF:000163', NULL, NULL, 'Exosome complex exonuclease RRP6', NULL, NULL, NULL, NULL, NULL, 4),
(204623, NULL, 'G3DSA:2.130.10.30:FF:000091', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204624, NULL, 'G3DSA:3.30.559.10:FF:000248', NULL, NULL, 'Nonribosomal peptide synthetase asqK', NULL, NULL, NULL, NULL, NULL, 4),
(204625, NULL, 'G3DSA:1.10.533.10:FF:000122', NULL, NULL, 'Caspase 8a', NULL, NULL, NULL, NULL, NULL, 4),
(204626, NULL, 'G3DSA:3.20.20.80:FF:000193', NULL, NULL, '4-alpha-glucanotransferase, chloroplastic/amyloplastic', NULL, NULL, NULL, NULL, NULL, 4),
(204627, NULL, 'G3DSA:3.10.110.10:FF:000104', NULL, NULL, 'RWD domain-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204628, NULL, 'G3DSA:3.30.160.60:FF:003405', NULL, NULL, 'Zinc finger domain-containing protein/ double-stranded RNA-bindingprotein', NULL, NULL, NULL, NULL, NULL, 4),
(204629, NULL, 'G3DSA:1.25.40.10:FF:003427', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(204630, NULL, 'G3DSA:2.10.25.10:FF:000467', NULL, NULL, 'Laminin subunit alpha 5', NULL, NULL, NULL, NULL, NULL, 4),
(204631, NULL, 'G3DSA:1.20.140.50:FF:000005', NULL, NULL, 'Bro1p', NULL, NULL, NULL, NULL, NULL, 4),
(204632, NULL, 'G3DSA:3.90.190.10:FF:000046', NULL, NULL, 'Cyclin-dependent kinase inhibitor 3', NULL, NULL, NULL, NULL, NULL, 4),
(204633, NULL, 'G3DSA:2.60.120.200:FF:000685', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(204634, NULL, 'G3DSA:1.25.40.20:FF:001339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204635, NULL, 'G3DSA:1.10.238.10:FF:000745', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204636, NULL, 'G3DSA:2.10.90.10:FF:000022', NULL, NULL, 'Norrin', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(204637, NULL, 'G3DSA:3.30.1360.40:FF:000042', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(204638, NULL, 'G3DSA:3.40.50.300:FF:000208', NULL, NULL, 'Urease accessory protein UreG', NULL, NULL, NULL, NULL, NULL, 4),
(204639, NULL, 'G3DSA:1.25.10.10:FF:003246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204640, NULL, 'G3DSA:1.10.10.10:FF:000261', NULL, NULL, 'Transcriptional regulator SlyA', NULL, NULL, NULL, NULL, NULL, 4),
(204641, NULL, 'G3DSA:1.10.760.10:FF:000037', NULL, NULL, 'Cytochrome bc1 complex cytochrome c subunit', NULL, NULL, NULL, NULL, NULL, 4),
(204642, NULL, 'G3DSA:3.20.20.80:FF:000693', NULL, NULL, 'Putative beta-glucosidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(204643, NULL, 'G3DSA:2.60.40.10:FF:004496', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204644, NULL, 'G3DSA:1.20.1250.20:FF:000217', NULL, NULL, 'MFS lactose permease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204645, NULL, 'G3DSA:1.10.10.60:FF:000747', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204646, NULL, 'G3DSA:3.60.21.10:FF:000083', NULL, NULL, 'Sphingomyelin phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(204647, NULL, 'G3DSA:1.10.10.10:FF:001621', NULL, NULL, 'Putative ArsR-family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(204648, NULL, 'G3DSA:2.20.20.110:FF:000013', NULL, NULL, 'DNA repair protein rhp42', NULL, NULL, NULL, NULL, NULL, 4),
(204649, NULL, 'G3DSA:3.40.850.10:FF:000479', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204650, NULL, 'G3DSA:3.30.457.50:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204651, NULL, 'G3DSA:1.20.1250.20:FF:001678', NULL, NULL, 'Sugar transporter ERD6-like 6', NULL, NULL, NULL, NULL, NULL, 4),
(204652, NULL, 'G3DSA:3.40.30.10:FF:000880', NULL, NULL, 'DNaJ domain (Prokaryotic heat shock protein)', NULL, NULL, NULL, NULL, NULL, 4),
(204653, NULL, 'G3DSA:1.10.40.30:FF:000027', NULL, NULL, 'Aspartate ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(204654, NULL, 'G3DSA:2.40.50.120:FF:000017', NULL, NULL, 'UPF0450 protein C17orf58 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(204655, NULL, 'G3DSA:2.10.25.10:FF:000416', NULL, NULL, 'Heparan sulfate proteoglycan 2', NULL, NULL, NULL, NULL, NULL, 4),
(204656, NULL, 'G3DSA:3.90.550.10:FF:000029', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(204657, NULL, 'G3DSA:1.10.510.10:FF:003363', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204658, NULL, 'G3DSA:3.30.70.330:FF:001185', NULL, NULL, 'POU domain, class 4, transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(204659, NULL, 'G3DSA:1.10.150.870:FF:000004', NULL, NULL, 'Error-prone DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(204660, NULL, 'G3DSA:3.30.160.60:FF:004041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204661, NULL, 'G3DSA:3.40.50.2300:FF:001212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204662, NULL, 'G3DSA:3.30.360.10:FF:000045', NULL, NULL, 'NAD-binding Rossmann fold oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(204663, NULL, 'G3DSA:1.20.58.60:FF:000109', NULL, NULL, 'Periplakin', NULL, NULL, NULL, NULL, NULL, 4),
(204664, NULL, 'G3DSA:2.40.50.40:FF:000105', NULL, NULL, 'Interleukin-8', NULL, NULL, NULL, NULL, NULL, 4),
(204665, NULL, 'G3DSA:1.20.1440.180:FF:000009', NULL, NULL, 'Key regulator in ER unfolded protein response', NULL, NULL, NULL, NULL, NULL, 4),
(204666, NULL, 'G3DSA:3.30.70.270:FF:000250', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204667, NULL, 'G3DSA:1.20.120.790:FF:000023', NULL, NULL, 'Chaperone protein HtpG', NULL, NULL, NULL, NULL, NULL, 4),
(204668, NULL, 'G3DSA:3.30.160.60:FF:006278', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204669, NULL, 'G3DSA:3.30.43.40:FF:000003', NULL, NULL, 'Spliceosomal protein PrP8, U6-snRNA interacting domain', NULL, NULL, NULL, NULL, NULL, 4),
(204670, NULL, 'G3DSA:3.40.190.10:FF:000451', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(204671, NULL, 'G3DSA:1.10.3680.10:FF:000002', NULL, NULL, 'Inner membrane protein YebE', NULL, NULL, NULL, NULL, NULL, 4),
(204672, NULL, 'G3DSA:3.40.50.620:FF:000366', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(204673, NULL, 'G3DSA:3.40.630.30:FF:000654', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(204674, NULL, 'G3DSA:3.30.565.10:FF:000341', NULL, NULL, 'Sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(204675, NULL, 'G3DSA:3.90.70.80:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204676, NULL, 'G3DSA:1.25.40.10:FF:001550', NULL, NULL, 'Empty pericarp7', NULL, NULL, NULL, NULL, NULL, 4),
(204677, NULL, 'G3DSA:3.40.50.12780:FF:000229', NULL, NULL, 'Mutant e4 ebony', NULL, NULL, NULL, NULL, NULL, 4),
(204678, NULL, 'G3DSA:1.25.40.10:FF:002359', NULL, NULL, 'Os01g0914600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(204679, NULL, 'G3DSA:1.20.120.1630:FF:000029', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(204680, NULL, 'G3DSA:3.30.420.40:FF:001048', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(204681, NULL, 'G3DSA:3.40.630.30:FF:000154', NULL, NULL, 'Probable acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(204682, NULL, 'G3DSA:3.40.50.300:FF:007476', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(204683, NULL, 'G3DSA:2.60.210.10:FF:000060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204684, NULL, 'G3DSA:1.20.210.10:FF:000016', NULL, NULL, 'Probable intron-encoded endonuclease aI7', NULL, NULL, NULL, NULL, NULL, 4),
(204685, NULL, 'G3DSA:1.10.532.10:FF:000002', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(204686, NULL, 'G3DSA:3.30.160.60:FF:001186', NULL, NULL, 'Zinc finger and BTB domain containing 11', NULL, NULL, NULL, NULL, NULL, 4),
(204687, NULL, 'G3DSA:3.40.140.100:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204688, NULL, 'G3DSA:2.60.40.10:FF:004884', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204689, NULL, 'G3DSA:3.30.200.20:FF:001902', NULL, NULL, 'Phosphoribosylamidoimidazole-succinocarboxamide synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204690, NULL, 'G3DSA:3.80.30.30:FF:000002', NULL, NULL, 'Spore photoproduct lyase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(204691, NULL, 'G3DSA:1.20.1270.60:FF:000152', NULL, NULL, 'Formin 2,3 and collagen domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(204692, NULL, 'G3DSA:2.60.40.10:FF:002990', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(204693, NULL, 'G3DSA:3.30.160.60:FF:000730', NULL, NULL, 'zinc finger protein 34 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(204694, NULL, 'G3DSA:1.25.40.10:FF:002910', NULL, NULL, 'Clustered mitochondria protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(204695, NULL, 'G3DSA:1.25.10.10:FF:000441', NULL, NULL, 'NOP9 nucleolar protein', NULL, NULL, NULL, NULL, NULL, 4),
(204696, NULL, 'G3DSA:3.40.50.300:FF:005143', NULL, NULL, 'ABC transporter G family member 22', NULL, NULL, NULL, NULL, NULL, 4),
(204697, NULL, 'G3DSA:1.10.3380.10:FF:000018', NULL, NULL, 'Translocation protein sec63', NULL, NULL, NULL, NULL, NULL, 4),
(204698, NULL, 'G3DSA:2.60.40.10:FF:005452', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204699, NULL, 'G3DSA:3.10.20.90:FF:000123', NULL, NULL, 'plexin-B1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(204700, NULL, 'G3DSA:2.40.10.10:FF:000212', NULL, NULL, 'Serine protease P53', NULL, NULL, NULL, NULL, NULL, 4),
(204701, NULL, 'G3DSA:2.60.120.330:FF:000173', NULL, NULL, 'Protein DOWNY MILDEW RESISTANCE 6', NULL, NULL, NULL, NULL, NULL, 4),
(204702, NULL, 'G3DSA:3.40.50.720:FF:002195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204703, NULL, 'G3DSA:3.30.530.20:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204704, NULL, 'G3DSA:1.10.472.80:FF:000192', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(204705, NULL, 'G3DSA:3.50.50.60:FF:000463', NULL, NULL, 'Amine oxidase, variant 1', NULL, NULL, NULL, NULL, NULL, 4),
(204706, NULL, 'G3DSA:3.50.30.30:FF:000014', NULL, NULL, 'E3 ubiquitin-protein ligase ZNRF3', NULL, NULL, NULL, NULL, NULL, 4),
(204707, NULL, 'G3DSA:3.30.930.10:FF:000033', NULL, NULL, 'Phenylalanine--tRNA ligase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(204708, NULL, 'G3DSA:4.10.60.10:FF:000021', NULL, NULL, 'zinc finger CCHC domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(204709, NULL, 'G3DSA:3.30.2230.10:FF:000007', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(204710, NULL, 'G3DSA:1.10.275.10:FF:000005', NULL, NULL, 'Histidine ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(204711, NULL, 'G3DSA:1.10.1080.10:FF:000006', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(204712, NULL, 'G3DSA:3.30.200.20:FF:000913', NULL, NULL, 'Serine/threonine kinase like domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(204713, NULL, 'G3DSA:1.10.510.10:FF:003604', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204714, NULL, 'G3DSA:1.10.1820.10:FF:000007', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(204715, NULL, 'G3DSA:2.120.10.80:FF:000263', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(204716, NULL, 'G3DSA:2.30.30.490:FF:000093', NULL, NULL, '(Cytosine-5)-methyltransferase 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204717, NULL, 'G3DSA:1.10.510.10:FF:003312', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204718, NULL, 'G3DSA:1.10.287.950:FF:000022', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(204719, NULL, 'G3DSA:3.80.10.10:FF:004199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204720, NULL, 'G3DSA:1.25.40.550:FF:000004', NULL, NULL, 'AAR2 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204721, NULL, 'G3DSA:1.10.760.10:FF:000088', NULL, NULL, 'Cytochrome C peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(204722, NULL, 'G3DSA:1.25.40.20:FF:001278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204723, NULL, 'G3DSA:1.10.630.10:FF:000825', NULL, NULL, 'Premnaspirodiene oxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(204724, NULL, 'G3DSA:1.20.1270.10:FF:000002', NULL, NULL, 'Heat shock 70 kDa protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(204725, NULL, 'G3DSA:3.30.160.60:FF:005322', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204726, NULL, 'G3DSA:3.40.850.10:FF:000075', NULL, NULL, 'Myosin XVI', NULL, NULL, NULL, NULL, NULL, 4),
(204727, NULL, 'G3DSA:2.60.40.10:FF:001270', NULL, NULL, 'MPL proto-oncogene, thrombopoietin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(204728, NULL, 'G3DSA:3.20.20.140:FF:000254', NULL, NULL, 'Dihydropyrimidinase like 2', NULL, NULL, NULL, NULL, NULL, 4),
(204729, NULL, 'G3DSA:3.30.760.10:FF:000093', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(204730, NULL, 'G3DSA:2.40.40.20:FF:000009', NULL, NULL, 'Biotin sulfoxide reductase 2', NULL, NULL, NULL, NULL, NULL, 4),
(204731, NULL, 'G3DSA:3.40.50.720:FF:001290', NULL, NULL, 'Os02g0811600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(204732, NULL, 'G3DSA:1.10.238.10:FF:001313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204733, NULL, 'G3DSA:1.10.10.60:FF:000635', NULL, NULL, '3-methyladenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(204734, NULL, 'G3DSA:3.40.50.300:FF:008465', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204735, NULL, 'G3DSA:1.10.3460.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204736, NULL, 'G3DSA:1.25.10.10:FF:001722', NULL, NULL, 'AGAP002970-PA', NULL, NULL, NULL, NULL, NULL, 4),
(204737, NULL, 'G3DSA:3.90.1560.10:FF:000001', NULL, NULL, 'Probable 2-phosphosulfolactate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(204738, NULL, 'G3DSA:3.40.50.300:FF:000388', NULL, NULL, 'Guanine nucleotide-binding protein G(s) subunit alpha', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(204739, NULL, 'G3DSA:3.40.50.300:FF:008369', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204740, NULL, 'G3DSA:1.10.286.10:FF:000002', NULL, NULL, 'GTP cyclohydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(204741, NULL, 'G3DSA:3.90.226.10:FF:000271', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204742, NULL, 'G3DSA:1.25.40.10:FF:001921', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(204743, NULL, 'G3DSA:3.40.50.620:FF:000866', NULL, NULL, 'Guanine monophosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(204744, NULL, 'G3DSA:3.40.33.10:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204745, NULL, 'G3DSA:3.80.10.10:FF:004148', NULL, NULL, 'Os06g0167500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(204746, NULL, 'G3DSA:3.40.50.670:FF:000009', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(204747, NULL, 'G3DSA:1.20.1250.20:FF:000329', NULL, NULL, 'monocarboxylate transporter 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(204748, NULL, 'G3DSA:3.10.290.70:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204749, NULL, 'G3DSA:3.90.76.10:FF:000039', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(204750, NULL, 'G3DSA:3.40.630.30:FF:000603', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204751, NULL, 'G3DSA:1.25.40.20:FF:001227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204752, NULL, 'G3DSA:1.10.630.10:FF:000084', NULL, NULL, 'CYtochrome P450 family', NULL, NULL, NULL, NULL, NULL, 4),
(204753, NULL, 'G3DSA:3.20.20.60:FF:000114', NULL, NULL, 'Homolog to citrate lyase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(204754, NULL, 'G3DSA:3.40.50.1000:FF:000361', NULL, NULL, 'NLI interacting factor-like phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(204755, NULL, 'G3DSA:3.10.620.30:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204756, NULL, 'G3DSA:2.130.10.10:FF:005137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204757, NULL, 'G3DSA:1.10.1060.10:FF:000011', NULL, NULL, 'NAD(P)H-dependent glutamate synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204758, NULL, 'G3DSA:1.10.10.60:FF:001203', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204759, NULL, 'G3DSA:1.10.238.10:FF:000245', NULL, NULL, 'WD repeat domain 66', NULL, NULL, NULL, NULL, NULL, 4),
(204760, NULL, 'G3DSA:3.50.50.60:FF:001401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204761, NULL, 'G3DSA:1.25.40.10:FF:002798', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(204762, NULL, 'G3DSA:3.50.30.30:FF:000065', NULL, NULL, 'Zinc and ring finger 3', NULL, NULL, NULL, NULL, NULL, 4),
(204763, NULL, 'G3DSA:2.30.30.140:FF:000016', NULL, NULL, 'polycomb protein SCMH1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(204764, NULL, 'G3DSA:3.30.2020.30:FF:000008', NULL, NULL, 'Trimethyllysine hydroxylase, epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(204765, NULL, 'G3DSA:2.80.10.50:FF:000043', NULL, NULL, 'Interleukin-18', NULL, NULL, NULL, NULL, NULL, 4),
(204766, NULL, 'G3DSA:2.70.98.40:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204767, NULL, 'G3DSA:4.10.410.10:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204768, NULL, 'G3DSA:3.30.200.20:FF:000885', NULL, NULL, 'Receptor-like cytosolic serine/threonine-protein kinase RBK2', NULL, NULL, NULL, NULL, NULL, 4),
(204769, NULL, 'G3DSA:3.30.470.30:FF:000093', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(204770, NULL, 'G3DSA:3.40.50.300:FF:001748', NULL, NULL, 'RAD3-like DNA-binding helicase protein', NULL, NULL, NULL, NULL, NULL, 4),
(204771, NULL, 'G3DSA:2.60.40.10:FF:001118', NULL, NULL, 'Down syndrome cell adhesion molecule-like protein Dscam2', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(204772, NULL, 'G3DSA:3.30.230.10:FF:000384', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(204773, NULL, 'G3DSA:1.25.10.10:FF:001189', NULL, NULL, 'DnaJ-like subfamily C member 13', NULL, NULL, NULL, NULL, NULL, 4),
(204774, NULL, 'G3DSA:2.60.40.690:FF:000007', NULL, NULL, 'Complement C5', NULL, NULL, NULL, NULL, NULL, 4),
(204775, NULL, 'G3DSA:3.30.160.60:FF:005901', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204776, NULL, 'G3DSA:1.20.1050.10:FF:000019', NULL, NULL, 'Glutathione S-transferase, omega', NULL, NULL, NULL, NULL, NULL, 4),
(204777, NULL, 'G3DSA:3.30.2350.10:FF:000055', NULL, NULL, 'tRNA pseudouridine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(204778, NULL, 'G3DSA:2.10.110.10:FF:000254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204779, NULL, 'G3DSA:1.20.58.390:FF:000201', NULL, NULL, 'Gamma-aminobutyric acid type A receptor pi subunit', NULL, NULL, NULL, NULL, NULL, 4),
(204780, NULL, 'G3DSA:3.20.20.80:FF:000272', NULL, NULL, 'CHiTinase', NULL, NULL, NULL, NULL, NULL, 4),
(204781, NULL, 'G3DSA:2.40.10.10:FF:000504', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204782, NULL, 'G3DSA:1.10.8.710:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204783, NULL, 'G3DSA:3.80.10.10:FF:000837', NULL, NULL, 'Tubulin folding cofactor E-like a', NULL, NULL, NULL, NULL, NULL, 4),
(204784, NULL, 'G3DSA:2.10.25.10:FF:000916', NULL, NULL, 'Adhesion G protein-coupled receptor E5b, duplicate 3', NULL, NULL, NULL, NULL, NULL, 4),
(204785, NULL, 'G3DSA:3.90.550.10:FF:000529', NULL, NULL, 'Probable glycosyltransferase, type 2', NULL, NULL, NULL, NULL, NULL, 4),
(204786, NULL, 'G3DSA:1.25.40.10:FF:003074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204787, NULL, 'G3DSA:2.60.40.10:FF:002579', NULL, NULL, 'Filamin 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204788, NULL, 'G3DSA:3.30.420.10:FF:000455', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204789, NULL, 'G3DSA:2.40.50.90:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204790, NULL, 'G3DSA:2.130.10.10:FF:001214', NULL, NULL, 'Sortilin-related VPS10 domain-containing receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(204791, NULL, 'G3DSA:1.20.1250.10:FF:000091', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204792, NULL, 'G3DSA:3.90.70.120:FF:000001', NULL, NULL, 'Large tegument protein', NULL, NULL, NULL, NULL, NULL, 4),
(204793, NULL, 'G3DSA:1.10.20.10:FF:000379', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204794, NULL, 'G3DSA:3.10.20.90:FF:000915', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204795, NULL, 'G3DSA:2.120.10.30:FF:000613', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204796, NULL, 'G3DSA:3.90.1750.20:FF:000013', NULL, NULL, 'Probable PhiRv1 integrase', NULL, NULL, NULL, NULL, NULL, 4),
(204797, NULL, 'G3DSA:1.20.1070.10:FF:000054', NULL, NULL, 'Adhesion G protein-coupled receptor E3', NULL, NULL, NULL, NULL, NULL, 4),
(204798, NULL, 'G3DSA:1.10.472.80:FF:000220', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204799, NULL, 'G3DSA:1.20.58.2050:FF:000001', NULL, NULL, 'DNA replication complex GINS protein PSF3', NULL, NULL, NULL, NULL, NULL, 4),
(204800, NULL, 'G3DSA:3.40.50.2300:FF:000756', NULL, NULL, 'Vomeronasal 2 receptor, h32', NULL, NULL, NULL, NULL, NULL, 4),
(204801, NULL, 'G3DSA:2.40.50.140:FF:000624', NULL, NULL, 'Programmed cell death 11', NULL, NULL, NULL, NULL, NULL, 4),
(204802, NULL, 'G3DSA:2.30.29.30:FF:000177', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(204803, NULL, 'G3DSA:3.30.70.1560:FF:000014', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(204804, NULL, 'G3DSA:3.30.450.50:FF:000036', NULL, NULL, 'Phytolongin Phyl1.1', NULL, NULL, NULL, NULL, NULL, 4),
(204805, NULL, 'G3DSA:2.60.40.10:FF:003327', NULL, NULL, 'Interleukin-1 receptor type I', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(204806, NULL, 'G3DSA:2.60.40.2310:FF:000002', NULL, NULL, 'p69E protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(204807, NULL, 'G3DSA:3.40.50.1220:FF:000067', NULL, NULL, 'NAD-dependent histone deacetylase Sir2', NULL, NULL, NULL, NULL, NULL, 4),
(204808, NULL, 'G3DSA:2.130.10.10:FF:000646', NULL, NULL, 'WD repeat containing antisense to TP53', NULL, NULL, NULL, NULL, NULL, 4),
(204809, NULL, 'G3DSA:3.40.366.10:FF:000067', NULL, NULL, 'Putative sterigmatocystin biosynthesis fatty acid synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(204810, NULL, 'G3DSA:1.20.920.10:FF:000166', NULL, NULL, 'Pbrm-1', NULL, NULL, NULL, NULL, NULL, 4),
(204811, NULL, 'G3DSA:1.20.58.1480:FF:000021', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(204812, NULL, 'G3DSA:2.10.25.10:FF:000175', NULL, NULL, 'Integrin subunit beta-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(204813, NULL, 'G3DSA:1.10.287.110:FF:000349', NULL, NULL, 'DnaJ-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(204814, NULL, 'G3DSA:3.30.450.30:FF:000030', NULL, NULL, 'Profilin', NULL, NULL, NULL, NULL, NULL, 4),
(204815, NULL, 'G3DSA:2.30.30.140:FF:000067', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(204816, NULL, 'G3DSA:3.80.10.10:FF:004227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204817, NULL, 'G3DSA:3.30.420.40:FF:000531', NULL, NULL, 'Actin', NULL, NULL, NULL, NULL, NULL, 4),
(204818, NULL, 'G3DSA:3.40.33.10:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204819, NULL, 'G3DSA:3.30.40.10:FF:001331', NULL, NULL, 'Putative RING-H2 finger protein ATL53', NULL, NULL, NULL, NULL, NULL, 4),
(204820, NULL, 'G3DSA:3.40.50.2020:FF:000150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204821, NULL, 'G3DSA:2.130.10.10:FF:005497', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204822, NULL, 'G3DSA:2.10.25.10:FF:000124', NULL, NULL, 'Signal peptide, CUB domain and EGF-like domain-containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(204823, NULL, 'G3DSA:3.40.50.1820:FF:001736', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204824, NULL, 'G3DSA:2.40.10.10:FF:000555', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204825, NULL, 'G3DSA:3.10.100.10:FF:000278', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204826, NULL, 'G3DSA:3.30.2070.10:FF:000005', NULL, NULL, 'Molybdopterin oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(204827, NULL, 'G3DSA:2.60.120.260:FF:000657', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204828, NULL, 'G3DSA:3.40.50.1000:FF:000653', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204829, NULL, 'G3DSA:3.40.50.1010:FF:000190', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204830, NULL, 'G3DSA:1.10.1300.10:FF:000047', NULL, NULL, 'cAMP-specific cyclic nucleotide phosphodiesterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204831, NULL, 'G3DSA:3.10.250.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204832, NULL, 'G3DSA:2.20.25.420:FF:000002', NULL, NULL, 'Zinc finger protein ZPR1', NULL, NULL, NULL, NULL, NULL, 4),
(204833, NULL, 'G3DSA:3.30.1360.120:FF:000022', NULL, NULL, 'Aminomethyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204834, NULL, 'G3DSA:1.20.1050.10:FF:000171', NULL, NULL, 'Glutathione S-transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204835, NULL, 'G3DSA:1.10.287.10:FF:000044', NULL, NULL, 'AGAP005226-PA', NULL, NULL, NULL, NULL, NULL, 4),
(204836, NULL, 'G3DSA:2.60.120.920:FF:000007', NULL, NULL, 'SPRY domain-containing SOCS box protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(204837, NULL, 'G3DSA:2.60.120.200:FF:000393', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(204838, NULL, 'G3DSA:3.30.70.330:FF:000841', NULL, NULL, 'Polyadenylate-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204839, NULL, 'G3DSA:1.20.1410.10:FF:000042', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(204840, NULL, 'G3DSA:3.40.50.1010:FF:000038', NULL, NULL, 'Exosome complex exonuclease RRP44', NULL, NULL, NULL, NULL, NULL, 4),
(204841, NULL, 'G3DSA:1.20.1050.130:FF:000024', NULL, NULL, 'Methionine-tRNA ligase, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(204842, NULL, 'G3DSA:3.40.50.300:FF:005935', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204843, NULL, 'G3DSA:3.30.420.40:FF:001099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204844, NULL, 'G3DSA:3.30.160.60:FF:004884', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204845, NULL, 'G3DSA:3.40.1370.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204846, NULL, 'G3DSA:1.20.1250.10:FF:000040', NULL, NULL, 'Interleukin 26', NULL, NULL, NULL, NULL, NULL, 4),
(204847, NULL, 'G3DSA:2.60.40.10:FF:001478', NULL, NULL, 'Terribly reduced optic lobes, isoform AF', NULL, NULL, NULL, NULL, NULL, 4),
(204848, NULL, 'G3DSA:3.20.20.140:FF:000350', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204849, NULL, 'G3DSA:1.10.287.70:FF:000308', NULL, NULL, 'Ionotropic receptor 68b', NULL, NULL, NULL, NULL, NULL, 4),
(204850, NULL, 'G3DSA:1.20.1230.10:FF:000005', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(204851, NULL, 'G3DSA:2.130.10.10:FF:004980', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204852, NULL, 'G3DSA:3.30.200.20:FF:001110', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(204853, NULL, 'G3DSA:3.30.460.10:FF:000160', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(204854, NULL, 'G3DSA:1.10.630.10:FF:000264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204855, NULL, 'G3DSA:1.10.8.10:FF:000102', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(204856, NULL, 'G3DSA:4.10.240.10:FF:000222', NULL, NULL, 'Uga3p', NULL, NULL, NULL, NULL, NULL, 4),
(204857, NULL, 'G3DSA:3.40.50.1220:FF:000016', NULL, NULL, 'SIR2 family histone deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(204858, NULL, 'G3DSA:3.30.160.60:FF:002063', NULL, NULL, 'RB associated KRAB zinc finger', NULL, NULL, NULL, NULL, NULL, 4),
(204859, NULL, 'G3DSA:1.10.510.10:FF:003655', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204860, NULL, 'G3DSA:3.50.50.60:FF:000384', NULL, NULL, 'FAD-containing monooxygenase MymA', NULL, NULL, NULL, NULL, NULL, 4),
(204861, NULL, 'G3DSA:3.90.550.20:FF:000015', NULL, NULL, 'Glycoside transferase family 32', NULL, NULL, NULL, NULL, NULL, 4),
(204862, NULL, 'G3DSA:3.30.230.10:FF:000333', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(204863, NULL, 'G3DSA:4.10.400.10:FF:000224', NULL, NULL, 'Perlecan', NULL, NULL, NULL, NULL, NULL, 4),
(204864, NULL, 'G3DSA:2.40.160.50:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204865, NULL, 'G3DSA:3.40.50.10140:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204866, NULL, 'G3DSA:3.30.200.20:FF:000834', NULL, NULL, 'Serine/threonine-protein kinase D6PKL2', NULL, NULL, NULL, NULL, NULL, 4),
(204867, NULL, 'G3DSA:2.130.10.10:FF:002675', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204868, NULL, 'G3DSA:1.25.40.10:FF:003815', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204869, NULL, 'G3DSA:3.80.10.10:FF:002350', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(204870, NULL, 'G3DSA:3.40.50.300:FF:006571', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204871, NULL, 'G3DSA:3.30.450.20:FF:000544', NULL, NULL, 'Hybrid signal transduction histidine kinase H', NULL, NULL, NULL, NULL, NULL, 4),
(204872, NULL, 'G3DSA:3.30.450.30:FF:000081', NULL, NULL, 'Ragulator complex protein LAMTOR4', NULL, NULL, NULL, NULL, NULL, 4),
(204873, NULL, 'G3DSA:3.30.420.100:FF:000015', NULL, NULL, '60S ribosomal protein L5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(204874, NULL, 'G3DSA:1.25.40.20:FF:000890', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204875, NULL, 'G3DSA:1.25.40.10:FF:003719', NULL, NULL, 'Zinc finger, C3H1-type-containing', NULL, NULL, NULL, NULL, NULL, 4),
(204876, NULL, 'G3DSA:3.30.40.10:FF:001595', NULL, NULL, 'PINEAPPLE EYE', NULL, NULL, NULL, NULL, NULL, 4),
(204877, NULL, 'G3DSA:3.90.190.10:FF:000434', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204878, NULL, 'G3DSA:1.10.238.10:FF:000296', NULL, NULL, 'Protein S100', NULL, NULL, NULL, NULL, NULL, 4),
(204879, NULL, 'G3DSA:3.20.20.220:FF:000008', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(204880, NULL, 'G3DSA:1.25.10.10:FF:000492', NULL, NULL, 'HEAT repeat containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(204881, NULL, 'G3DSA:2.10.25.10:FF:001585', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204882, NULL, 'G3DSA:1.25.40.410:FF:000007', NULL, NULL, 'YLR422W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(204883, NULL, 'G3DSA:2.60.120.10:FF:000182', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(204884, NULL, 'G3DSA:3.30.160.60:FF:005373', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204885, NULL, 'G3DSA:3.50.50.80:FF:000002', NULL, NULL, 'SUMO-activating enzyme subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(204886, NULL, 'G3DSA:2.40.50.90:FF:000098', NULL, NULL, 'Tudor domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(204887, NULL, 'G3DSA:2.60.40.10:FF:004788', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204888, NULL, 'G3DSA:1.10.472.80:FF:000271', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204889, NULL, 'G3DSA:3.30.420.510:FF:000020', NULL, NULL, 'Pantothenate kinase PanK, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204890, NULL, 'G3DSA:1.10.510.10:FF:001446', NULL, NULL, 'Probable serine/threonine-protein kinase YabT', NULL, NULL, NULL, NULL, NULL, 4),
(204891, NULL, 'G3DSA:2.10.25.10:FF:000388', NULL, NULL, 'Laminin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(204892, NULL, 'G3DSA:3.40.50.720:FF:000603', NULL, NULL, '40S ribosomal protein S30', NULL, NULL, NULL, NULL, NULL, 4),
(204893, NULL, 'G3DSA:3.40.50.460:FF:000003', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(204894, NULL, 'G3DSA:1.25.40.820:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204895, NULL, 'G3DSA:1.10.390.30:FF:000003', NULL, NULL, 'Immunomodulating metalloprotease', NULL, NULL, NULL, NULL, NULL, 4),
(204896, NULL, 'G3DSA:1.10.150.20:FF:000123', NULL, NULL, 'DNA polymerase eta', NULL, NULL, NULL, NULL, NULL, 4),
(204897, NULL, 'G3DSA:3.40.50.150:FF:000758', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(204898, NULL, 'G3DSA:2.20.25.80:FF:000015', NULL, NULL, 'Protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(204899, NULL, 'G3DSA:3.40.50.1370:FF:000033', NULL, NULL, 'CAD protein', NULL, NULL, NULL, NULL, NULL, 4),
(204900, NULL, 'G3DSA:3.40.50.150:FF:000854', NULL, NULL, 'Nicotianamine synthase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(204901, NULL, 'G3DSA:2.120.10.30:FF:000001', NULL, NULL, 'Low-density lipoprotein receptor-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(204902, NULL, 'G3DSA:3.30.70.330:FF:000280', NULL, NULL, 'RNA-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(204903, NULL, 'G3DSA:3.40.50.2300:FF:000705', NULL, NULL, 'Response regulator receiver', NULL, NULL, NULL, NULL, NULL, 4),
(204904, NULL, 'G3DSA:2.40.50.150:FF:000009', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(204905, NULL, 'G3DSA:3.40.50.12470:FF:000001', NULL, NULL, '2-oxoglutarate dehydrogenase, mitochondrial isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(204906, NULL, 'G3DSA:3.40.630.30:FF:000042', NULL, NULL, 'Glycylpeptide N-tetradecanoyltransferase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(204907, NULL, 'G3DSA:3.40.720.10:FF:000155', NULL, NULL, 'Iduronate-2-sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(204908, NULL, 'G3DSA:3.10.290.10:FF:000050', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(204909, NULL, 'G3DSA:1.20.1270.60:FF:000264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204910, NULL, 'G3DSA:3.30.420.40:FF:000082', NULL, NULL, 'ROK family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(204911, NULL, 'G3DSA:2.30.40.10:FF:000029', NULL, NULL, 'Dihydropyrimidinase-related protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(204912, NULL, 'G3DSA:1.10.510.10:FF:002874', NULL, NULL, 'Probable serine/threonine-protein kinase ifkA', NULL, NULL, NULL, NULL, NULL, 4),
(204913, NULL, 'G3DSA:3.30.420.10:FF:000663', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204914, NULL, 'G3DSA:1.20.190.50:FF:000008', NULL, NULL, 'Nuclear pore complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(204915, NULL, 'G3DSA:3.30.70.20:FF:000060', NULL, NULL, 'Ferredoxin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(204916, NULL, 'G3DSA:3.30.70.330:FF:002819', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204917, NULL, 'G3DSA:3.90.70.10:FF:000060', NULL, NULL, 'Cathepsin Z', NULL, NULL, NULL, NULL, NULL, 4),
(204918, NULL, 'G3DSA:1.20.58.1070:FF:000016', NULL, NULL, 'Gem-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(204919, NULL, 'G3DSA:3.15.20.10:FF:000022', NULL, NULL, 'BPI fold-containing family C,-like', NULL, NULL, NULL, NULL, NULL, 4),
(204920, NULL, 'G3DSA:3.40.50.300:FF:007060', NULL, NULL, 'AEL095Cp', NULL, NULL, NULL, NULL, NULL, 4),
(204921, NULL, 'G3DSA:3.10.50.10:FF:000062', NULL, NULL, 'Calcium-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204922, NULL, 'G3DSA:2.60.120.650:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204923, NULL, 'G3DSA:3.30.760.10:FF:000025', NULL, NULL, 'Translation Initiation factor eIF-4e-like, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204924, NULL, 'G3DSA:1.20.5.110:FF:000051', NULL, NULL, 'synaptosomal-associated protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(204925, NULL, 'G3DSA:1.20.58.200:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204926, NULL, 'G3DSA:3.80.10.10:FF:000337', NULL, NULL, 'Adhesion molecule with Ig-like domain 3', NULL, NULL, NULL, NULL, NULL, 4),
(204927, NULL, 'G3DSA:1.25.40.850:FF:000004', NULL, NULL, 'Carnation, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(204928, NULL, 'G3DSA:1.20.5.420:FF:000025', NULL, NULL, 'Ribonuclease P protein component 4', NULL, NULL, NULL, NULL, NULL, 4),
(204929, NULL, 'G3DSA:1.10.390.10:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204930, NULL, 'G3DSA:3.90.1410.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204931, NULL, 'G3DSA:1.10.10.10:FF:001542', NULL, NULL, 'Panl-2', NULL, NULL, NULL, NULL, NULL, 4),
(204932, NULL, 'G3DSA:1.10.290.10:FF:000012', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(204933, NULL, 'G3DSA:1.10.1200.120:FF:000009', NULL, NULL, 'Large conductance mechanosensitive channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(204934, NULL, 'G3DSA:3.10.20.90:FF:000011', NULL, NULL, 'Polyubiquitin Ubiquitin', NULL, NULL, NULL, NULL, NULL, 4),
(204935, NULL, 'G3DSA:3.40.140.10:FF:000009', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(204936, NULL, 'G3DSA:2.40.128.20:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204937, NULL, 'G3DSA:3.30.930.10:FF:000246', NULL, NULL, 'Phenylalanyl-tRNA synthetase beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(204938, NULL, 'G3DSA:2.130.10.10:FF:001894', NULL, NULL, 'Pre-mRNA splicing factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204939, NULL, 'G3DSA:3.30.70.330:FF:000633', NULL, NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(204940, NULL, 'G3DSA:2.60.120.920:FF:000215', NULL, NULL, 'Ryanodine receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(204941, NULL, 'G3DSA:1.20.1560.10:FF:000642', NULL, NULL, 'Protein CBG25498', NULL, NULL, NULL, NULL, NULL, 4),
(204942, NULL, 'G3DSA:1.10.472.10:FF:000160', NULL, NULL, 'Cyclin-T2', NULL, NULL, NULL, NULL, NULL, 4),
(204943, NULL, 'G3DSA:3.40.50.300:FF:003794', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(204944, NULL, 'G3DSA:3.40.1110.10:FF:000288', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204945, NULL, 'G3DSA:3.40.1350.10:FF:000042', NULL, NULL, 'Probable tRNA-splicing endonuclease subunit sen15', NULL, NULL, NULL, NULL, NULL, 4),
(204946, NULL, 'G3DSA:3.40.50.300:FF:001720', NULL, NULL, 'NACHT and WD repeat domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(204947, NULL, 'G3DSA:3.40.50.150:FF:001422', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204948, NULL, 'G3DSA:2.30.29.30:FF:001245', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(204949, NULL, 'G3DSA:3.30.420.40:FF:000559', NULL, NULL, 'Actin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204950, NULL, 'G3DSA:1.25.10.10:FF:002739', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204951, NULL, 'G3DSA:3.20.20.140:FF:000142', NULL, NULL, 'TatD family Hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(204952, NULL, 'G3DSA:3.40.50.300:FF:001169', NULL, NULL, 'Type VII secretion AAA-ATPase EccA', NULL, NULL, NULL, NULL, NULL, 4),
(204953, NULL, 'G3DSA:1.10.238.10:FF:000857', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(204954, NULL, 'G3DSA:2.60.40.10:FF:000781', NULL, NULL, 'Mannosidase beta', NULL, NULL, NULL, NULL, NULL, 4),
(204955, NULL, 'G3DSA:3.90.650.10:FF:000065', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204956, NULL, 'G3DSA:3.30.460.10:FF:000081', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(204957, NULL, 'G3DSA:3.40.50.300:FF:004946', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204958, NULL, 'G3DSA:3.40.50.1000:FF:000861', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204959, NULL, 'G3DSA:3.40.850.10:FF:000187', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(204960, NULL, 'G3DSA:3.20.20.80:FF:000721', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204961, NULL, 'G3DSA:2.60.110.10:FF:000024', NULL, NULL, 'Os10g0524900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(204962, NULL, 'G3DSA:3.10.20.10:FF:000026', NULL, NULL, '60S ribosomal protein L18a', NULL, NULL, NULL, NULL, NULL, 4),
(204963, NULL, 'G3DSA:3.40.50.2300:FF:000195', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(204964, NULL, 'G3DSA:2.40.50.140:FF:000063', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(204965, NULL, 'G3DSA:3.30.160.60:FF:001399', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(204966, NULL, 'G3DSA:2.60.40.2300:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204967, NULL, 'G3DSA:2.60.200.40:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204968, NULL, 'G3DSA:1.20.990.10:FF:000029', NULL, NULL, 'Sulfite reductase [NADPH] flavoprotein alpha-component', NULL, NULL, NULL, NULL, NULL, 4),
(204969, NULL, 'G3DSA:3.90.1150.10:FF:000150', NULL, NULL, 'Similar to cystathionine gamma-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(204970, NULL, 'G3DSA:1.10.220.20:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204971, NULL, 'G3DSA:1.20.1250.20:FF:002342', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204972, NULL, 'G3DSA:1.10.510.10:FF:001238', NULL, NULL, 'Nucleotide exchange factor RasGEF P family protein', NULL, NULL, NULL, NULL, NULL, 4),
(204973, NULL, 'G3DSA:2.60.40.10:FF:001186', NULL, NULL, 'Interleukin 13 receptor subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(204974, NULL, 'G3DSA:1.25.40.10:FF:003927', NULL, NULL, 'Anaphase-promoting complex subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(204975, NULL, 'G3DSA:2.10.90.10:FF:000134', NULL, NULL, 'Vascular endothelial growth factor Bb', NULL, NULL, NULL, NULL, NULL, 4),
(204976, NULL, 'G3DSA:3.30.1360.170:FF:000008', NULL, NULL, 'Flavin-dependent thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(204977, NULL, 'G3DSA:3.80.10.10:FF:001973', NULL, NULL, 'F-box/LRR-repeat protein 16-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(204978, NULL, 'G3DSA:3.30.40.10:FF:002320', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(204979, NULL, 'G3DSA:1.20.1070.10:FF:000734', NULL, NULL, 'Methuselah-like 8, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(204980, NULL, 'G3DSA:2.60.120.10:FF:000002', NULL, NULL, 'Cyclic nucleotide gated channel alpha 1a', NULL, NULL, NULL, NULL, NULL, 4),
(204981, NULL, 'G3DSA:3.40.50.720:FF:000654', NULL, NULL, 'Voltage-gated Ion Channel (VIC) Superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(204982, NULL, 'G3DSA:3.80.10.10:FF:002911', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204983, NULL, 'G3DSA:2.130.10.10:FF:004648', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204984, NULL, 'G3DSA:3.40.50.300:FF:005031', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(204985, NULL, 'G3DSA:2.40.50.140:FF:000383', NULL, NULL, 'Transcription elongation factor Spt6', NULL, NULL, NULL, NULL, NULL, 4),
(204986, NULL, 'G3DSA:2.60.120.260:FF:000096', NULL, NULL, 'SUN domain protein1', NULL, NULL, NULL, NULL, NULL, 4),
(204987, NULL, 'G3DSA:2.60.40.10:FF:004676', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204988, NULL, 'G3DSA:3.40.462.20:FF:000007', NULL, NULL, 'Hexose oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(204989, NULL, 'G3DSA:2.60.120.560:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204990, NULL, 'G3DSA:3.10.105.10:FF:000025', NULL, NULL, 'ABC transporter, substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(204991, NULL, 'G3DSA:3.40.50.300:FF:000028', NULL, NULL, 'UvrABC system protein A', NULL, NULL, NULL, NULL, NULL, 4),
(204992, NULL, 'G3DSA:3.30.70.330:FF:001297', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204993, NULL, 'G3DSA:1.10.418.10:FF:000282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204994, NULL, 'G3DSA:3.30.170.10:FF:000002', NULL, NULL, 'Cyclin-dependent kinases regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(204995, NULL, 'G3DSA:1.10.1200.270:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(204996, NULL, 'G3DSA:2.60.40.60:FF:000312', NULL, NULL, 'FAT atypical cadherin 3a', NULL, NULL, NULL, NULL, NULL, 4),
(204997, NULL, 'G3DSA:3.30.1330.220:FF:000001', NULL, NULL, 'ORF1a polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(204998, NULL, 'G3DSA:2.60.40.10:FF:004996', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(204999, NULL, 'G3DSA:1.10.287.2720:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205000, NULL, 'G3DSA:1.20.120.610:FF:000014', NULL, NULL, 'ATP synthase subunit c', NULL, NULL, NULL, NULL, NULL, 4),
(205001, NULL, 'G3DSA:2.80.10.50:FF:000104', NULL, NULL, 'Pyramus', NULL, NULL, NULL, NULL, NULL, 4),
(205002, NULL, 'G3DSA:3.30.70.330:FF:002078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205003, NULL, 'G3DSA:2.130.10.10:FF:003131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205004, NULL, 'G3DSA:3.40.50.150:FF:000646', NULL, NULL, '6-hydroxytryprostatin B O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(205005, NULL, 'G3DSA:2.160.20.10:FF:000229', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(205006, NULL, 'G3DSA:1.25.40.10:FF:002567', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(205007, NULL, 'G3DSA:3.40.50.300:FF:007801', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(205008, NULL, 'G3DSA:3.40.50.1820:FF:000455', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(205009, NULL, 'G3DSA:3.30.160.60:FF:004384', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205010, NULL, 'G3DSA:1.25.40.20:FF:001839', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205011, NULL, 'G3DSA:1.10.220.10:FF:000070', NULL, NULL, 'Annexin A13,-like', NULL, NULL, NULL, NULL, NULL, 4),
(205012, NULL, 'G3DSA:2.30.29.70:FF:000009', NULL, NULL, 'WGS project CABT00000000 data, contig 2.6', NULL, NULL, NULL, NULL, NULL, 4),
(205013, NULL, 'G3DSA:2.10.25.10:FF:000500', NULL, NULL, 'Growth arrest specific 6', NULL, NULL, NULL, NULL, NULL, 4),
(205014, NULL, 'G3DSA:1.25.10.10:FF:000941', NULL, NULL, 'HEAT repeat domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(205015, NULL, 'G3DSA:2.70.150.10:FF:000013', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(205016, NULL, 'G3DSA:2.40.50.40:FF:000044', NULL, NULL, 'C.Elegans Chromodomain protein', NULL, NULL, NULL, NULL, NULL, 4),
(205017, NULL, 'G3DSA:3.40.50.150:FF:000062', NULL, NULL, 'U6 small nuclear RNA (adenine-(43)-N(6))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(205018, NULL, 'G3DSA:2.60.40.3190:FF:000002', NULL, NULL, 'Envelope glycoprotein H', NULL, NULL, NULL, NULL, NULL, 4),
(205019, NULL, 'G3DSA:3.30.710.10:FF:000090', NULL, NULL, 'GDNF inducible zinc finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(205020, NULL, 'G3DSA:2.60.120.310:FF:000015', NULL, NULL, 'peptidyl-glycine alpha-amidating monooxygenase A', NULL, NULL, NULL, NULL, NULL, 4),
(205021, NULL, 'G3DSA:3.30.230.10:FF:000092', NULL, NULL, 'Lon protease homolog', NULL, NULL, NULL, NULL, NULL, 4),
(205022, NULL, 'G3DSA:1.10.10.10:FF:001278', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205023, NULL, 'G3DSA:3.30.160.60:FF:000994', NULL, NULL, 'zinc finger protein 142', NULL, NULL, NULL, NULL, NULL, 4),
(205024, NULL, 'G3DSA:1.25.40.10:FF:003023', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(205025, NULL, 'G3DSA:3.40.1010.10:FF:000016', NULL, NULL, 'Uroporphyrin-III C-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(205026, NULL, 'G3DSA:1.10.510.10:FF:002587', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205027, NULL, 'G3DSA:2.70.150.10:FF:000125', NULL, NULL, 'Probable phospholipid-transporting ATPase IF', NULL, NULL, NULL, NULL, NULL, 4),
(205028, NULL, 'G3DSA:1.10.8.60:FF:000095', NULL, NULL, 'Lon protease homolog 2, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(205029, NULL, 'G3DSA:3.20.20.70:FF:000443', NULL, NULL, 'tRNA-dihydrouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(205030, NULL, 'G3DSA:2.70.170.10:FF:000076', NULL, NULL, 'Gamma-aminobutyric acid receptor subunit gamma-3', NULL, NULL, NULL, NULL, NULL, 4),
(205031, NULL, 'G3DSA:3.30.40.10:FF:002112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205032, NULL, 'G3DSA:1.10.150.60:FF:000005', NULL, NULL, 'Jumonji, AT-rich interactive domain 2a', NULL, NULL, NULL, NULL, NULL, 4),
(205033, NULL, 'G3DSA:3.30.70.260:FF:000180', NULL, NULL, 'Ribose-5-phosphate isomerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205034, NULL, 'G3DSA:3.80.10.10:FF:000545', NULL, NULL, 'Nodulation receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(205035, NULL, 'G3DSA:1.20.1440.340:FF:000001', NULL, NULL, 'N-acetylgalactosamine kinase isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(205036, NULL, 'G3DSA:2.70.210.12:FF:000003', NULL, NULL, 'Obg family GTPase CgtA', NULL, NULL, NULL, NULL, NULL, 4),
(205037, NULL, 'G3DSA:3.30.190.20:FF:000006', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(205038, NULL, 'G3DSA:3.40.1190.10:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205039, NULL, 'G3DSA:1.25.40.10:FF:005052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205040, NULL, 'G3DSA:2.40.50.140:FF:000916', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(205041, NULL, 'G3DSA:3.30.1050.10:FF:000004', NULL, NULL, 'Hydroxysteroid 17-beta dehydrogenase 4', NULL, NULL, NULL, NULL, NULL, 4),
(205042, NULL, 'G3DSA:3.30.200.20:FF:001341', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205043, NULL, 'G3DSA:3.20.10.10:FF:000059', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(205044, NULL, 'G3DSA:1.25.40.1030:FF:000027', NULL, NULL, 'SEC16 homolog B, endoplasmic reticulum export factor', NULL, NULL, NULL, NULL, NULL, 4),
(205045, NULL, 'G3DSA:2.130.10.10:FF:005429', NULL, NULL, 'Uncharacterized WD repeat-containing protein C1306.02', NULL, NULL, NULL, NULL, NULL, 4),
(205046, NULL, 'G3DSA:2.60.40.10:FF:005513', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205047, NULL, 'G3DSA:3.30.460.20:FF:000027', NULL, NULL, 'Mg2 transporter protein CorA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(205048, NULL, 'G3DSA:1.10.510.10:FF:001626', NULL, NULL, 'Death-associated protein kinase 2a', NULL, NULL, NULL, NULL, NULL, 4),
(205049, NULL, 'G3DSA:3.30.450.20:FF:000313', NULL, NULL, 'Probable two-component sensor', NULL, NULL, NULL, NULL, NULL, 4),
(205050, NULL, 'G3DSA:3.30.565.10:FF:000009', NULL, NULL, 'Molecular chaperone HtpG', NULL, NULL, NULL, NULL, NULL, 4),
(205051, NULL, 'G3DSA:3.30.420.10:FF:000275', NULL, NULL, 'Ribonuclease H', NULL, NULL, NULL, NULL, NULL, 4),
(205052, NULL, 'G3DSA:3.30.70.1170:FF:000010', NULL, NULL, 'YNL022C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(205053, NULL, 'G3DSA:3.80.10.10:FF:002693', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(205054, NULL, 'G3DSA:3.30.540.10:FF:000082', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(205055, NULL, 'G3DSA:1.25.40.10:FF:005232', NULL, NULL, 'UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(205056, NULL, 'G3DSA:2.40.50.1020:FF:000025', NULL, NULL, 'CO-responsive transcriptional regulator RcoM', NULL, NULL, NULL, NULL, NULL, 4),
(205057, NULL, 'G3DSA:1.20.5.340:FF:000035', NULL, NULL, 'Paramyosin, long form', NULL, NULL, NULL, NULL, NULL, 4),
(205058, NULL, 'G3DSA:1.10.238.10:FF:000537', NULL, NULL, 'Zinc_finger_-_C3HC4_type_(RING_finger)/Ring_finger_domain/zinc-RING_finger_domain/EF-hand_domain_pair/EF-hand_domain/EF_hand/Secreted_protein_acidic_and_rich_in_cys teine_Ca_binding_region_containing_...', NULL, NULL, NULL, NULL, NULL, 4),
(205059, NULL, 'G3DSA:3.20.20.140:FF:000462', NULL, NULL, 'RE32242p', NULL, NULL, NULL, NULL, NULL, 4),
(205060, NULL, 'G3DSA:3.30.200.20:FF:002419', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(205061, NULL, 'G3DSA:1.10.132.70:FF:000012', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(205062, NULL, 'G3DSA:2.60.40.10:FF:004092', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205063, NULL, 'G3DSA:2.60.40.10:FF:001062', NULL, NULL, 'OX-2 membrane glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(205064, NULL, 'G3DSA:1.20.1280.50:FF:000200', NULL, NULL, 'Rho GTPase-activating protein gacFF', NULL, NULL, NULL, NULL, NULL, 4),
(205065, NULL, 'G3DSA:3.30.1450.10:FF:000001', NULL, NULL, 'Outer membrane protein assembly factor BamE', NULL, NULL, NULL, NULL, NULL, 4),
(205066, NULL, 'G3DSA:2.40.50.360:FF:000005', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(205067, NULL, 'G3DSA:1.20.950.20:FF:000024', NULL, NULL, 'Respiratory nitrate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(205068, NULL, 'G3DSA:1.10.630.10:FF:000617', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205069, NULL, 'G3DSA:3.50.50.60:FF:000963', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205070, NULL, 'G3DSA:3.40.50.300:FF:003518', NULL, NULL, 'ATP-dependent helicase fft1', NULL, NULL, NULL, NULL, NULL, 4),
(205071, NULL, 'G3DSA:3.80.10.10:FF:002170', NULL, NULL, 'Outer membrane protein YopM', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(205072, NULL, 'G3DSA:3.40.50.11500:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205073, NULL, 'G3DSA:2.40.50.140:FF:000175', NULL, NULL, 'Programmed cell death 11', NULL, NULL, NULL, NULL, NULL, 4),
(205074, NULL, 'G3DSA:2.40.50.730:FF:000026', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(205075, NULL, 'G3DSA:3.40.50.300:FF:000360', NULL, NULL, 'RAB9B, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(205076, NULL, 'G3DSA:3.40.50.300:FF:008577', NULL, NULL, 'Thymidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(205077, NULL, 'G3DSA:3.30.70.100:FF:000065', NULL, NULL, 'Antibiotic biosynthesis monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(205078, NULL, 'G3DSA:3.40.190.290:FF:000111', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(205079, NULL, 'G3DSA:3.30.65.10:FF:000005', NULL, NULL, 'Predicted DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(205080, NULL, 'G3DSA:3.40.50.720:FF:001110', NULL, NULL, 'Formate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(205081, NULL, 'G3DSA:3.30.160.60:FF:000207', NULL, NULL, 'zinc finger protein SNAI2', NULL, NULL, NULL, NULL, NULL, 4),
(205082, NULL, 'G3DSA:2.20.25.10:FF:000034', NULL, NULL, 'tRNA m2G10 methyltransferase subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205083, NULL, 'G3DSA:1.10.246.130:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205084, NULL, 'G3DSA:1.10.1420.10:FF:000106', NULL, NULL, 'YALI0B10197p', NULL, NULL, NULL, NULL, NULL, 4),
(205085, NULL, 'G3DSA:3.30.497.10:FF:000087', NULL, NULL, 'Serpin 77Bb', NULL, NULL, NULL, NULL, NULL, 4),
(205086, NULL, 'G3DSA:1.10.510.10:FF:004111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205087, NULL, 'G3DSA:3.40.50.920:FF:000006', NULL, NULL, 'Pyruvate dehydrogenase E1 component subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(205088, NULL, 'G3DSA:1.10.287.70:FF:000016', NULL, NULL, 'Putative potassium voltage-gated channel subfamily KQT member 2', NULL, NULL, NULL, NULL, NULL, 4),
(205089, NULL, 'G3DSA:3.40.50.80:FF:000143', NULL, NULL, 'Cytochrome p450 oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(205090, NULL, 'G3DSA:3.50.4.10:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205091, NULL, 'G3DSA:3.30.70.890:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205092, NULL, 'G3DSA:3.30.2290.10:FF:000016', NULL, NULL, 'Peptidase U62 modulator of DNA gyrase', NULL, NULL, NULL, NULL, NULL, 4),
(205093, NULL, 'G3DSA:1.25.10.10:FF:001273', NULL, NULL, 'Protein CBG21459', NULL, NULL, NULL, NULL, NULL, 4),
(205094, NULL, 'G3DSA:3.30.1370.30:FF:000006', NULL, NULL, '40S ribosomal protein S8', NULL, NULL, NULL, NULL, NULL, 4),
(205095, NULL, 'G3DSA:3.30.450.190:FF:000019', NULL, NULL, 'RAS-related GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205096, NULL, 'G3DSA:3.40.50.300:FF:004042', NULL, NULL, 'ATP-dependent DEAH-box RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205097, NULL, 'G3DSA:3.30.40.10:FF:000875', NULL, NULL, 'Os05g0163400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(205098, NULL, 'G3DSA:3.40.50.1820:FF:001444', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205099, NULL, 'G3DSA:1.10.1670.10:FF:000029', NULL, NULL, 'Endonuclease III homolog', NULL, NULL, NULL, NULL, NULL, 4),
(205100, NULL, 'G3DSA:2.60.40.200:FF:000024', NULL, NULL, 'Vitellogenin fused with superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(205101, NULL, 'G3DSA:2.60.40.60:FF:000104', NULL, NULL, 'cadherin-23 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(205102, NULL, 'G3DSA:3.30.420.40:FF:000823', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(205103, NULL, 'G3DSA:2.60.40.420:FF:000123', NULL, NULL, 'Cytochrome c oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(205104, NULL, 'G3DSA:3.50.50.60:FF:000676', NULL, NULL, 'Succinate dehydrogenase subunit A (SdhA)', NULL, NULL, NULL, NULL, NULL, 4),
(205105, NULL, 'G3DSA:1.25.10.10:FF:001397', NULL, NULL, 'INTegrator complex Subunit homolog', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(205106, NULL, 'G3DSA:1.25.50.20:FF:000036', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(205107, NULL, 'G3DSA:3.40.50.2300:FF:000936', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205108, NULL, 'G3DSA:1.20.1070.10:FF:001459', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205109, NULL, 'G3DSA:1.20.1250.20:FF:000829', NULL, NULL, 'Protein CBG21733', NULL, NULL, NULL, NULL, NULL, 4),
(205110, NULL, 'G3DSA:1.10.287.580:FF:000001', NULL, NULL, 'Serine proteinase inhibitor 2', NULL, NULL, NULL, NULL, NULL, 4),
(205111, NULL, 'G3DSA:1.20.200.10:FF:000010', NULL, NULL, 'Adenylosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(205112, NULL, 'G3DSA:1.10.472.10:FF:000564', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205113, NULL, 'G3DSA:3.10.490.10:FF:000031', NULL, NULL, 'Os09g0573150 protein', NULL, NULL, NULL, NULL, NULL, 4),
(205114, NULL, 'G3DSA:1.20.58.530:FF:000002', NULL, NULL, 'Class V myosin', NULL, NULL, NULL, NULL, NULL, 4),
(205115, NULL, 'G3DSA:3.40.50.80:FF:000082', NULL, NULL, 'Metalloreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205116, NULL, 'G3DSA:3.30.70.330:FF:001089', NULL, NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(205117, NULL, 'G3DSA:1.20.1070.10:FF:001982', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205118, NULL, 'G3DSA:3.30.160.60:FF:004592', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205119, NULL, 'G3DSA:3.30.920.10:FF:000009', NULL, NULL, 'Iron-sulfur cluster assembly protein CyaY', NULL, NULL, NULL, NULL, NULL, 4),
(205120, NULL, 'G3DSA:3.90.190.10:FF:000203', NULL, NULL, 'Dual specificity protein phosphatase CDC14A', NULL, NULL, NULL, NULL, NULL, 4),
(205121, NULL, 'G3DSA:2.60.40.1940:FF:000009', NULL, NULL, 'Sb:cb37', NULL, NULL, NULL, NULL, NULL, 4),
(205122, NULL, 'G3DSA:3.40.50.720:FF:002520', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205123, NULL, 'G3DSA:2.30.30.40:FF:000594', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205124, NULL, 'G3DSA:3.40.50.10810:FF:000279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205125, NULL, 'G3DSA:2.10.70.10:FF:000190', NULL, NULL, 'Furrowed, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(205126, NULL, 'G3DSA:1.10.560.10:FF:000117', NULL, NULL, 'Mitochondrial chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(205127, NULL, 'G3DSA:1.10.630.10:FF:000033', NULL, NULL, '14-alpha sterol demethylase', NULL, NULL, NULL, NULL, NULL, 4),
(205128, NULL, 'G3DSA:3.40.50.150:FF:001186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205129, NULL, 'G3DSA:1.20.1110.10:FF:000058', NULL, NULL, 'Probable ENA2-Plasma membrane P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(205130, NULL, 'G3DSA:3.40.50.620:FF:000186', NULL, NULL, 'Putative Cysteinyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(205131, NULL, 'G3DSA:2.30.29.30:FF:000520', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(205132, NULL, 'G3DSA:2.10.70.10:FF:000200', NULL, NULL, 'Kielin/chordin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(205133, NULL, 'G3DSA:1.25.40.10:FF:004984', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(205134, NULL, 'G3DSA:1.20.120.430:FF:000016', NULL, NULL, 'tRNA modification GTPase gtpbp3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(205135, NULL, 'G3DSA:3.90.70.10:FF:000240', NULL, NULL, 'General secretion pathway protein A', NULL, NULL, NULL, NULL, NULL, 4),
(205136, NULL, 'G3DSA:3.30.200.20:FF:001077', NULL, NULL, 'Kinase, AGC NDR', NULL, NULL, NULL, NULL, NULL, 4),
(205137, NULL, 'G3DSA:2.10.25.10:FF:000624', NULL, NULL, 'protein delta homolog 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(205138, NULL, 'G3DSA:1.20.144.10:FF:000036', NULL, NULL, 'Putative phosphatidate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(205139, NULL, 'G3DSA:2.20.28.10:FF:000012', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(205140, NULL, 'G3DSA:3.40.50.11260:FF:000032', NULL, NULL, 'Chaperone protein HtpG', NULL, NULL, NULL, NULL, NULL, 4),
(205141, NULL, 'G3DSA:2.40.50.770:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205142, NULL, 'G3DSA:3.30.70.330:FF:000757', NULL, NULL, 'RNA and export factor binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205143, NULL, 'G3DSA:3.30.860.10:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205144, NULL, 'G3DSA:1.10.1000.11:FF:000003', NULL, NULL, 'Brefeldin A-inhibited guanine nucleotide-exchange protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(205145, NULL, 'G3DSA:2.130.10.10:FF:003631', NULL, NULL, 'Semaphorin 7A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205146, NULL, 'G3DSA:2.60.40.10:FF:001803', NULL, NULL, 'filamin-A isoform X10', NULL, NULL, NULL, NULL, NULL, 4),
(205147, NULL, 'G3DSA:2.60.40.840:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205148, NULL, 'G3DSA:3.40.50.2300:FF:000548', NULL, NULL, 'C4-dicarboxylate transport transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(205149, NULL, 'G3DSA:2.60.40.10:FF:002259', NULL, NULL, 'Sidekick, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(205150, NULL, 'G3DSA:3.40.850.10:FF:000367', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205151, NULL, 'G3DSA:3.30.40.10:FF:001999', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205152, NULL, 'G3DSA:3.40.50.300:FF:002737', NULL, NULL, 'NADH-ubiquinone oxidoreductase complex I subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205153, NULL, 'G3DSA:4.10.1000.10:FF:000090', NULL, NULL, 'Zinc finger C-x8-C-x5-C-x3-H type family protein', NULL, NULL, NULL, NULL, NULL, 4),
(205154, NULL, 'G3DSA:1.50.40.10:FF:000137', NULL, NULL, 'Mitochondrial carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205155, NULL, 'G3DSA:2.130.10.10:FF:004709', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205156, NULL, 'G3DSA:1.10.730.10:FF:000097', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(205157, NULL, 'G3DSA:2.60.40.420:FF:000062', NULL, NULL, 'Laccase', NULL, NULL, NULL, NULL, NULL, 4),
(205158, NULL, 'G3DSA:1.20.1250.20:FF:002134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205159, NULL, 'G3DSA:1.10.490.20:FF:000002', NULL, NULL, 'C-phycocyanin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(205160, NULL, 'G3DSA:1.10.510.10:FF:002795', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205161, NULL, 'G3DSA:3.30.160.60:FF:001899', NULL, NULL, 'Zinc finger protein 317', NULL, NULL, NULL, NULL, NULL, 4),
(205162, NULL, 'G3DSA:3.50.50.60:FF:000412', NULL, NULL, 'Methylenetetrahydrofolate--tRNA-(uracil-5-)-methyltransferase TrmFO', NULL, NULL, NULL, NULL, NULL, 4),
(205163, NULL, 'G3DSA:2.30.31.10:FF:000014', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205164, NULL, 'G3DSA:3.40.190.10:FF:000804', NULL, NULL, 'Oligopeptide ABC transporter, solute-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(205165, NULL, 'G3DSA:1.10.510.10:FF:000721', NULL, NULL, 'Checkpoint serine/threonine-protein kinase BUB1', NULL, NULL, NULL, NULL, NULL, 4),
(205166, NULL, 'G3DSA:1.25.10.10:FF:000733', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(205167, NULL, 'G3DSA:3.20.20.100:FF:000186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205168, NULL, 'G3DSA:2.60.40.2840:FF:000004', NULL, NULL, 'Calcium-binding and coiled-coil domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(205169, NULL, 'G3DSA:2.40.30.170:FF:000062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205170, NULL, 'G3DSA:1.10.730.10:FF:000209', NULL, NULL, 'Valine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(205171, NULL, 'G3DSA:1.10.238.10:FF:001021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(205172, NULL, 'G3DSA:1.10.10.10:FF:000761', NULL, NULL, 'RpiR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(205173, NULL, 'G3DSA:3.30.450.90:FF:000020', NULL, NULL, 'Pilus assembly protein PilB', NULL, NULL, NULL, NULL, NULL, 4),
(205174, NULL, 'G3DSA:2.70.98.110:FF:000009', NULL, NULL, 'Mannosyl_oligosaccharide_glucosidase_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(205175, NULL, 'G3DSA:2.170.270.10:FF:000071', NULL, NULL, 'Down and out, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(205176, NULL, 'G3DSA:3.30.160.60:FF:002916', NULL, NULL, 'zinc finger protein 772 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(205177, NULL, 'G3DSA:3.30.40.10:FF:000246', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM33 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(205178, NULL, 'G3DSA:3.30.160.60:FF:004945', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205179, NULL, 'G3DSA:3.30.300.20:FF:000005', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(205180, NULL, 'G3DSA:3.30.360.10:FF:000096', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(205181, NULL, 'G3DSA:3.50.50.60:FF:000755', NULL, NULL, 'Lysine (K)-specific demethylase 1A', NULL, NULL, NULL, NULL, NULL, 4),
(205182, NULL, 'G3DSA:1.10.630.10:FF:000376', NULL, NULL, 'Cytochrome P450 NovI', NULL, NULL, NULL, NULL, NULL, 4),
(205183, NULL, 'G3DSA:2.20.110.10:FF:000033', NULL, NULL, 'MORN repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205184, NULL, 'G3DSA:3.30.70.1390:FF:000002', NULL, NULL, 'Leucine-rich repeat serine/threonine-protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(205185, NULL, 'G3DSA:3.40.140.10:FF:000240', NULL, NULL, 'Cytidine and deoxycytidylate deaminase zinc-binding region family protein', NULL, NULL, NULL, NULL, NULL, 4),
(205186, NULL, 'G3DSA:3.90.70.80:FF:000041', NULL, NULL, 'Extracellular OTU-like cysteine protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205187, NULL, 'G3DSA:3.40.50.1010:FF:000122', NULL, NULL, 'DNA repair enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(205188, NULL, 'G3DSA:3.30.40.10:FF:001095', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(205189, NULL, 'G3DSA:3.30.70.240:FF:000022', NULL, NULL, 'U5 snRNP-specific protein', NULL, NULL, NULL, NULL, NULL, 4),
(205190, NULL, 'G3DSA:3.20.70.20:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205191, NULL, 'G3DSA:3.30.365.10:FF:000028', NULL, NULL, 'Xanthine dehydrogenase, molybdenum binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(205192, NULL, 'G3DSA:1.10.300.10:FF:000003', NULL, NULL, 'Adenylosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(205193, NULL, 'G3DSA:2.130.10.10:FF:004480', NULL, NULL, 'Regulatory-associated protein of mTOR-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(205194, NULL, 'G3DSA:3.40.50.1820:FF:001236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205195, NULL, 'G3DSA:3.10.50.40:FF:000138', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(205196, NULL, 'G3DSA:3.60.21.10:FF:000291', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(205197, NULL, 'G3DSA:4.10.400.10:FF:000336', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205198, NULL, 'G3DSA:1.10.150.50:FF:000115', NULL, NULL, 'Serine/threonine-protein kinase STE11', NULL, NULL, NULL, NULL, NULL, 4),
(205199, NULL, 'G3DSA:3.40.50.300:FF:003586', NULL, NULL, 'Deoxyguanosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(205200, NULL, 'G3DSA:1.25.40.10:FF:003607', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205201, NULL, 'G3DSA:3.30.160.60:FF:002175', NULL, NULL, 'Zinc finger protein 234', NULL, NULL, NULL, NULL, NULL, 4),
(205202, NULL, 'G3DSA:3.30.200.20:FF:002358', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205203, NULL, 'G3DSA:2.60.40.10:FF:001562', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(205204, NULL, 'G3DSA:3.80.10.10:FF:002754', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205205, NULL, 'G3DSA:2.120.10.30:FF:000405', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205206, NULL, 'G3DSA:1.25.40.10:FF:003366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205207, NULL, 'G3DSA:4.10.110.10:FF:000005', NULL, NULL, 'Trefoil factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(205208, NULL, 'G3DSA:3.60.40.10:FF:000267', NULL, NULL, 'Protein phosphatase type 2C', NULL, NULL, NULL, NULL, NULL, 4),
(205209, NULL, 'G3DSA:3.30.70.260:FF:000028', NULL, NULL, 'Arogenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(205210, NULL, 'G3DSA:1.25.40.10:FF:004708', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205211, NULL, 'G3DSA:3.40.50.300:FF:000096', NULL, NULL, 'KRAS proto-oncogene, GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(205212, NULL, 'G3DSA:3.40.50.300:FF:004250', NULL, NULL, 'Excision repair cross-complementation group 2', NULL, NULL, NULL, NULL, NULL, 4),
(205213, NULL, 'G3DSA:3.10.20.90:FF:000511', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205214, NULL, 'G3DSA:3.40.50.300:FF:001456', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(205215, NULL, 'G3DSA:1.10.1520.10:FF:000030', NULL, NULL, 'Dicer-like 105', NULL, NULL, NULL, NULL, NULL, 4),
(205216, NULL, 'G3DSA:1.10.510.10:FF:000457', NULL, NULL, 'cyclin-dependent kinase 2 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(205217, NULL, 'G3DSA:2.30.30.140:FF:000308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205218, NULL, 'G3DSA:1.20.1560.10:FF:000721', NULL, NULL, 'HlyB/MsbA family ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(205219, NULL, 'G3DSA:3.30.70.600:FF:000006', NULL, NULL, '39S ribosomal protein L48, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(205220, NULL, 'G3DSA:3.90.190.10:FF:000546', NULL, NULL, 'Protein tyrosine phosphatase, receptor type C', NULL, NULL, NULL, NULL, NULL, 4),
(205221, NULL, 'G3DSA:3.30.930.10:FF:000185', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(205222, NULL, 'G3DSA:2.40.70.10:FF:000564', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205223, NULL, 'G3DSA:3.40.50.150:FF:000966', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205224, NULL, 'G3DSA:3.40.50.620:FF:000574', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205225, NULL, 'G3DSA:3.40.630.30:FF:000542', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205226, NULL, 'G3DSA:1.25.40.20:FF:000030', NULL, NULL, 'Kinase D-interacting substrate of 220 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(205227, NULL, 'G3DSA:3.90.660.10:FF:000015', NULL, NULL, 'Lysine-specific histone demethylase', NULL, NULL, NULL, NULL, NULL, 4),
(205228, NULL, 'G3DSA:1.20.120.350:FF:000026', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(205229, NULL, 'G3DSA:2.40.160.120:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205230, NULL, 'G3DSA:2.30.40.10:FF:000181', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205231, NULL, 'G3DSA:1.10.510.10:FF:003812', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205232, NULL, 'G3DSA:3.90.550.10:FF:000597', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205233, NULL, 'G3DSA:3.10.20.90:FF:000331', NULL, NULL, 'NPL4-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(205234, NULL, 'G3DSA:3.40.720.10:FF:000363', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205235, NULL, 'G3DSA:3.40.50.300:FF:007560', NULL, NULL, 'DEAD_2 protein domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(205236, NULL, 'G3DSA:1.10.1070.11:FF:000069', NULL, NULL, 'Phosphoinositide-3-kinase, class 3', NULL, NULL, NULL, NULL, NULL, 4),
(205237, NULL, 'G3DSA:3.80.10.10:FF:001001', NULL, NULL, 'Probable inactive leucine-rich repeat receptor-like protein kinase At3g03770', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(205238, NULL, 'G3DSA:2.60.40.10:FF:000281', NULL, NULL, 'Cytokine receptor like factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(205239, NULL, 'G3DSA:1.50.10.20:FF:000026', NULL, NULL, 'Squalene--hopene cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(205240, NULL, 'G3DSA:3.30.50.10:FF:000140', NULL, NULL, 'COUP-TF', NULL, NULL, NULL, NULL, NULL, 4),
(205241, NULL, 'G3DSA:2.40.10.10:FF:000004', NULL, NULL, 'Tryptase gamma 1', NULL, NULL, NULL, NULL, NULL, 4),
(205242, NULL, 'G3DSA:1.20.58.60:FF:000492', NULL, NULL, 'Microtubule actin crosslinking factor 1a', NULL, NULL, NULL, NULL, NULL, 4),
(205243, NULL, 'G3DSA:3.20.20.70:FF:000364', NULL, NULL, 'Inosine-5''-monophosphate dehydrogenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(205244, NULL, 'G3DSA:3.20.20.190:FF:000128', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205245, NULL, 'G3DSA:3.30.9.10:FF:000050', NULL, NULL, 'Glycine oxidase ThiO', NULL, NULL, NULL, NULL, NULL, 4),
(205246, NULL, 'G3DSA:1.10.8.20:FF:000010', NULL, NULL, 'alpha-tocopherol transfer protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(205247, NULL, 'G3DSA:3.30.2130.10:FF:000011', NULL, NULL, 'Aspartate/glutamate/uridylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(205248, NULL, 'G3DSA:1.10.220.10:FF:000002', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(205249, NULL, 'G3DSA:3.40.50.620:FF:000450', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(205250, NULL, 'G3DSA:1.10.437.10:FF:000022', NULL, NULL, 'Apoptosis regulator ced-9', NULL, NULL, NULL, NULL, NULL, 4),
(205251, NULL, 'G3DSA:3.40.1110.10:FF:000001', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(205252, NULL, 'G3DSA:3.40.630.30:FF:000362', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205253, NULL, 'G3DSA:1.10.510.10:FF:004032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205254, NULL, 'G3DSA:2.60.120.620:FF:000007', NULL, NULL, 'Procollagen-lysine,2-oxoglutarate 5-dioxygenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(205255, NULL, 'G3DSA:1.10.238.20:FF:000006', NULL, NULL, 'Odorant binding protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(205256, NULL, 'G3DSA:3.40.640.10:FF:000441', NULL, NULL, 'Protein CBR-GOT-1.3', NULL, NULL, NULL, NULL, NULL, 4),
(205257, NULL, 'G3DSA:3.10.450.10:FF:000034', NULL, NULL, 'Cathelicidin-related peptide Oh-Cath', NULL, NULL, NULL, NULL, NULL, 4),
(205258, NULL, 'G3DSA:3.40.50.2300:FF:001280', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205259, NULL, 'G3DSA:1.25.40.10:FF:002646', NULL, NULL, 'Soluble NSF attachment protein gamma isoform', NULL, NULL, NULL, NULL, NULL, 4),
(205260, NULL, 'G3DSA:1.10.3260.10:FF:000010', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(205261, NULL, 'G3DSA:3.40.50.2000:FF:000852', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205262, NULL, 'G3DSA:3.30.565.10:FF:000077', NULL, NULL, 'BlpH histidine kinase TCS13', NULL, NULL, NULL, NULL, NULL, 4),
(205263, NULL, 'G3DSA:3.40.50.200:FF:000004', NULL, NULL, 'Proprotein convertase type 2', NULL, NULL, NULL, NULL, NULL, 4),
(205264, NULL, 'G3DSA:3.40.1090.10:FF:000055', NULL, NULL, 'Patatin', NULL, NULL, NULL, NULL, NULL, 4),
(205265, NULL, 'G3DSA:3.10.350.10:FF:000049', NULL, NULL, 'Cell wall protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205266, NULL, 'G3DSA:3.30.505.10:FF:000236', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205267, NULL, 'G3DSA:1.20.1050.20:FF:000005', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(205268, NULL, 'G3DSA:3.80.10.10:FF:003210', NULL, NULL, 'Protein AMN1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(205269, NULL, 'G3DSA:2.10.110.10:FF:000193', NULL, NULL, 'LIM homeobox 4', NULL, NULL, NULL, NULL, NULL, 4),
(205270, NULL, 'G3DSA:3.60.40.10:FF:000003', NULL, NULL, 'PH domain and leucine-rich repeat protein phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(205271, NULL, 'G3DSA:3.40.50.300:FF:007740', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(205272, NULL, 'G3DSA:3.30.160.60:FF:001511', NULL, NULL, 'Zinc finger protein 496', NULL, NULL, NULL, NULL, NULL, 4),
(205273, NULL, 'G3DSA:3.30.710.10:FF:000022', NULL, NULL, 'SKP1-like protein 21 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(205274, NULL, 'G3DSA:1.20.1560.10:FF:000142', NULL, NULL, 'ATP-binding Cassette (ABC) Superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(205275, NULL, 'G3DSA:1.10.30.10:FF:000195', NULL, NULL, 'FACT complex subunit SSRP1', NULL, NULL, NULL, NULL, NULL, 4),
(205276, NULL, 'G3DSA:2.10.25.10:FF:000236', NULL, NULL, 'BMP-binding endothelial regulator protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(205277, NULL, 'G3DSA:2.60.120.200:FF:000617', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205278, NULL, 'G3DSA:1.10.340.30:FF:000056', NULL, NULL, 'DNA-3-methyladenine glycosylase 2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(205279, NULL, 'G3DSA:2.40.30.130:FF:000022', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(205280, NULL, 'G3DSA:3.40.50.10130:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205281, NULL, 'G3DSA:1.25.40.180:FF:000343', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205282, NULL, 'G3DSA:3.40.50.10470:FF:000014', NULL, NULL, 'Translation initiation factor eIF-2B alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205283, NULL, 'G3DSA:1.10.8.720:FF:000022', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(205284, NULL, 'G3DSA:3.40.50.300:FF:001377', NULL, NULL, 'Nucleolar protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(205285, NULL, 'G3DSA:3.30.300.30:FF:000047', NULL, NULL, 'Acetyl-coenzyme A synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(205286, NULL, 'G3DSA:3.10.580.10:FF:000038', NULL, NULL, 'CBS domain-containing protein CBSX2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(205287, NULL, 'G3DSA:2.130.10.10:FF:002271', NULL, NULL, 'Nuclear pore complex protein Nup160', NULL, NULL, NULL, NULL, NULL, 4),
(205288, NULL, 'G3DSA:2.60.40.10:FF:001686', NULL, NULL, 'Terribly reduced optic lobes, isoform BA', NULL, NULL, NULL, NULL, NULL, 4),
(205289, NULL, 'G3DSA:1.10.287.70:FF:000084', NULL, NULL, 'Potassium voltage-gated channel protein eag', NULL, NULL, NULL, NULL, NULL, 4),
(205290, NULL, 'G3DSA:3.20.20.60:FF:000086', NULL, NULL, 'Malyl-CoA/beta-methylmalyl-CoA/citramalyl-CoA lyase', NULL, NULL, NULL, NULL, NULL, 4),
(205291, NULL, 'G3DSA:1.10.630.10:FF:000112', NULL, NULL, 'Cytochrome P450 71B10', NULL, NULL, NULL, NULL, NULL, 4),
(205292, NULL, 'G3DSA:1.25.40.120:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205293, NULL, 'G3DSA:2.60.120.260:FF:000596', NULL, NULL, 'Alpha-N-arabinofuranosidase', NULL, NULL, NULL, NULL, NULL, 4),
(205294, NULL, 'G3DSA:3.30.497.10:FF:000019', NULL, NULL, 'Plasminogen activator inhibitor 2, macrophage', NULL, NULL, NULL, NULL, NULL, 4),
(205295, NULL, 'G3DSA:3.40.50.300:FF:008257', NULL, NULL, 'Dynein heavy chain 3', NULL, NULL, NULL, NULL, NULL, 4),
(205296, NULL, 'G3DSA:3.40.190.10:FF:000928', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205297, NULL, 'G3DSA:1.10.565.10:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205298, NULL, 'G3DSA:3.30.70.330:FF:002314', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205299, NULL, 'G3DSA:3.80.20.20:FF:000088', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205300, NULL, 'G3DSA:3.60.90.10:FF:000006', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(205301, NULL, 'G3DSA:2.60.40.1180:FF:000130', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(205302, NULL, 'G3DSA:1.10.287.370:FF:000005', NULL, NULL, 'Prefoldin subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(205303, NULL, 'G3DSA:3.80.10.10:FF:004435', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205304, NULL, 'G3DSA:3.30.60.30:FF:000236', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(205305, NULL, 'G3DSA:3.30.1140.32:FF:000008', NULL, NULL, 'Ribosomal protein S3', NULL, NULL, NULL, NULL, NULL, 4),
(205306, NULL, 'G3DSA:1.25.10.10:FF:002178', NULL, NULL, 'WAPL (Wings apart-like protein regulation of heterochromatin) protein', NULL, NULL, NULL, NULL, NULL, 4),
(205307, NULL, 'G3DSA:3.40.50.1820:FF:001579', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205308, NULL, 'G3DSA:3.40.50.300:FF:006048', NULL, NULL, 'DNA helicase INO80', NULL, NULL, NULL, NULL, NULL, 4),
(205309, NULL, 'G3DSA:1.25.40.540:FF:000018', NULL, NULL, 'ABR072Wp', NULL, NULL, NULL, NULL, NULL, 4),
(205310, NULL, 'G3DSA:3.30.160.60:FF:001635', NULL, NULL, 'Zinc finger protein 317', NULL, NULL, NULL, NULL, NULL, 4),
(205311, NULL, 'G3DSA:1.10.510.10:FF:003071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205312, NULL, 'G3DSA:3.20.20.70:FF:000100', NULL, NULL, 'tRNA-dihydrouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(205313, NULL, 'G3DSA:3.40.50.11660:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205314, NULL, 'G3DSA:2.30.30.140:FF:000128', NULL, NULL, 'NAD(P)H-quinone oxidoreductase subunit S, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(205315, NULL, 'G3DSA:3.90.70.10:FF:000801', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205316, NULL, 'G3DSA:3.40.630.10:FF:000204', NULL, NULL, 'Peptide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(205317, NULL, 'G3DSA:3.30.465.10:FF:000013', NULL, NULL, 'Aldehyde oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(205318, NULL, 'G3DSA:3.30.70.2060:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205319, NULL, 'G3DSA:3.30.230.10:FF:000272', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(205320, NULL, 'G3DSA:1.10.400.10:FF:000067', NULL, NULL, 'Guanine nucleotide binding protein, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(205321, NULL, 'G3DSA:2.40.170.20:FF:000052', NULL, NULL, 'Outer membrane receptor for ferrienterochelin and colicins', NULL, NULL, NULL, NULL, NULL, 4),
(205322, NULL, 'G3DSA:2.60.270.50:FF:000002', NULL, NULL, 'Asp-hemolysin', NULL, NULL, NULL, NULL, NULL, 4),
(205323, NULL, 'G3DSA:3.30.450.40:FF:000151', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(205324, NULL, 'G3DSA:3.80.10.10:FF:002411', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205325, NULL, 'G3DSA:4.10.240.10:FF:000161', NULL, NULL, 'YALI0E18656p', NULL, NULL, NULL, NULL, NULL, 4),
(205326, NULL, 'G3DSA:1.50.10.10:FF:000080', NULL, NULL, 'Protein-glucosylgalactosylhydroxylysine glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(205327, NULL, 'G3DSA:2.130.10.10:FF:004148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205328, NULL, 'G3DSA:1.20.58.390:FF:000089', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(205329, NULL, 'G3DSA:1.20.1250.20:FF:000897', NULL, NULL, 'Siderochrome-iron transporter (Sit1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(205330, NULL, 'G3DSA:3.40.50.1700:FF:000065', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205331, NULL, 'G3DSA:3.30.40.10:FF:000807', NULL, NULL, 'General transcription and DNA repair factor IIH', NULL, NULL, NULL, NULL, NULL, 4),
(205332, NULL, 'G3DSA:1.10.510.10:FF:003594', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205333, NULL, 'G3DSA:1.20.1070.10:FF:000554', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(205334, NULL, 'G3DSA:2.40.50.140:FF:000563', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(205335, NULL, 'G3DSA:3.80.10.10:FF:000725', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase GSO1', NULL, NULL, NULL, NULL, NULL, 4),
(205336, NULL, 'G3DSA:3.30.200.20:FF:001970', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205337, NULL, 'G3DSA:1.20.1720.10:FF:000121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205338, NULL, 'G3DSA:1.20.140.150:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(205339, NULL, 'G3DSA:1.20.1740.10:FF:000078', NULL, NULL, 'Cationic amino acid transporter 9', NULL, NULL, NULL, NULL, NULL, 4),
(205340, NULL, 'G3DSA:3.40.50.300:FF:006784', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205341, NULL, 'G3DSA:3.90.1180.10:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205342, NULL, 'G3DSA:2.40.240.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205343, NULL, 'G3DSA:3.30.230.70:FF:000087', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase 1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(205344, NULL, 'G3DSA:2.60.40.150:FF:000014', NULL, NULL, 'protein unc-13 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(205345, NULL, 'G3DSA:3.30.160.20:FF:000117', NULL, NULL, 'Related to Ribonuclease III', NULL, NULL, NULL, NULL, NULL, 4),
(205346, NULL, 'G3DSA:3.40.50.1970:FF:000005', NULL, NULL, 'Glycerol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(205347, NULL, 'G3DSA:4.10.1240.50:FF:000006', NULL, NULL, 'Egg-laying defective protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(205348, NULL, 'G3DSA:3.40.50.2300:FF:000436', NULL, NULL, 'Gamma-aminobutyric acid type B receptor', NULL, NULL, NULL, NULL, NULL, 4),
(205349, NULL, 'G3DSA:1.20.1260.10:FF:000041', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(205350, NULL, 'G3DSA:3.30.70.1130:FF:000003', NULL, NULL, 'Eukaryotic translation initiation factor 2 alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205351, NULL, 'G3DSA:3.90.190.10:FF:000277', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205352, NULL, 'G3DSA:3.30.160.60:FF:003248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205353, NULL, 'G3DSA:3.30.420.40:FF:000374', NULL, NULL, 'Heat shock 70 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(205354, NULL, 'G3DSA:1.20.1560.10:FF:000934', NULL, NULL, 'ABC transporter B family member 26 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(205355, NULL, 'G3DSA:1.25.40.10:FF:001393', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(205356, NULL, 'G3DSA:2.60.40.10:FF:002203', NULL, NULL, 'Titin, tandem duplicate 1', NULL, NULL, NULL, NULL, NULL, 4),
(205357, NULL, 'G3DSA:1.25.40.10:FF:000881', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(205358, NULL, 'G3DSA:1.20.1250.20:FF:001061', NULL, NULL, 'Bypass of stop codon protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205359, NULL, 'G3DSA:3.40.50.2000:FF:001009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205360, NULL, 'G3DSA:3.30.40.10:FF:001943', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205361, NULL, 'G3DSA:1.20.80.10:FF:000006', NULL, NULL, 'FERM domain-containing protein 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(205362, NULL, 'G3DSA:3.30.1050.10:FF:000009', NULL, NULL, 'Sterol carrier protein-2', NULL, NULL, NULL, NULL, NULL, 4),
(205363, NULL, 'G3DSA:2.10.25.10:FF:000736', NULL, NULL, 'C-type lectin domain family 14 member A', NULL, NULL, NULL, NULL, NULL, 4),
(205364, NULL, 'G3DSA:3.30.40.10:FF:001887', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205365, NULL, 'G3DSA:3.30.500.10:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205366, NULL, 'G3DSA:2.130.10.10:FF:004305', NULL, NULL, 'Wd-40 repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(205367, NULL, 'G3DSA:3.80.10.10:FF:001681', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205368, NULL, 'G3DSA:2.10.25.10:FF:001248', NULL, NULL, 'Netrin g2a', NULL, NULL, NULL, NULL, NULL, 4),
(205369, NULL, 'G3DSA:3.40.50.720:FF:000042', NULL, NULL, 'Trk system potassium transporter TrkA', NULL, NULL, NULL, NULL, NULL, 4),
(205370, NULL, 'G3DSA:1.10.238.10:FF:001026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205371, NULL, 'G3DSA:3.30.200.20:FF:002190', NULL, NULL, 'Serine/threonine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(205372, NULL, 'G3DSA:1.20.1070.10:FF:000285', NULL, NULL, 'Succinate receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(205373, NULL, 'G3DSA:1.10.8.270:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205374, NULL, 'G3DSA:3.40.309.10:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205375, NULL, 'G3DSA:1.25.10.10:FF:001514', NULL, NULL, 'SNF2 superfamily chromatin remodeling protein', NULL, NULL, NULL, NULL, NULL, 4),
(205376, NULL, 'G3DSA:1.20.1560.10:FF:000878', NULL, NULL, 'TAP1', NULL, NULL, NULL, NULL, NULL, 4),
(205377, NULL, 'G3DSA:2.40.50.100:FF:000186', NULL, NULL, 'ABC-type transport system ATP-binding protein (Probable substrate thiamine)', NULL, NULL, NULL, NULL, NULL, 4),
(205378, NULL, 'G3DSA:1.10.287.70:FF:000584', NULL, NULL, 'Os07g0522600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(205379, NULL, 'G3DSA:2.30.42.10:FF:000371', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205380, NULL, 'G3DSA:3.30.1120.30:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205381, NULL, 'G3DSA:1.10.630.10:FF:000612', NULL, NULL, 'Ent-kaurene oxidase-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(205382, NULL, 'G3DSA:3.30.300.150:FF:000003', NULL, NULL, 'DNA polymerase III subunit gamma/tau', NULL, NULL, NULL, NULL, NULL, 4),
(205383, NULL, 'G3DSA:3.40.190.10:FF:000187', NULL, NULL, '4-amino-5-hydroxymethyl-2-methylpyrimidine phosphate synthase THI5', NULL, NULL, NULL, NULL, NULL, 4),
(205384, NULL, 'G3DSA:3.30.1600.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205385, NULL, 'G3DSA:2.40.20.10:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205386, NULL, 'G3DSA:3.30.160.60:FF:006014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205387, NULL, 'G3DSA:2.60.40.3440:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205388, NULL, 'G3DSA:3.40.50.300:FF:005323', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205389, NULL, 'G3DSA:3.40.1170.60:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205390, NULL, 'G3DSA:3.80.10.10:FF:002193', NULL, NULL, 'Toll-like receptor 5b', NULL, NULL, NULL, NULL, NULL, 4),
(205391, NULL, 'G3DSA:3.30.70.330:FF:001010', NULL, NULL, 'CUGBP Elav-like family member 5', NULL, NULL, NULL, NULL, NULL, 4),
(205392, NULL, 'G3DSA:1.10.10.10:FF:001778', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(205393, NULL, 'G3DSA:1.10.4160.10:FF:000013', NULL, NULL, 'Related to purine-cytosine permease', NULL, NULL, NULL, NULL, NULL, 4),
(205394, NULL, 'G3DSA:3.30.559.70:FF:000007', NULL, NULL, 'Carnitine O-acetyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(205395, NULL, 'G3DSA:2.40.160.10:FF:000054', NULL, NULL, 'Outer membrane porin, OprD family', NULL, NULL, NULL, NULL, NULL, 4),
(205396, NULL, 'G3DSA:1.20.5.1160:FF:000009', NULL, NULL, 'filensin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(205397, NULL, 'G3DSA:3.50.50.60:FF:000176', NULL, NULL, 'Pyridine nucleotide-disulfide oxidoreductase domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(205398, NULL, 'G3DSA:2.60.40.1730:FF:000036', NULL, NULL, 'Leucyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(205399, NULL, 'G3DSA:1.20.120.1240:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205400, NULL, 'G3DSA:3.20.20.380:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205401, NULL, 'G3DSA:3.40.50.300:FF:003018', NULL, NULL, 'GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205402, NULL, 'G3DSA:3.40.50.720:FF:000946', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(205403, NULL, 'G3DSA:1.25.40.420:FF:000044', NULL, NULL, 'Ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(205404, NULL, 'G3DSA:3.30.420.40:FF:000267', NULL, NULL, 'Glycerol kinase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(205405, NULL, 'G3DSA:3.10.580.10:FF:000190', NULL, NULL, 'Cysteine synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205406, NULL, 'G3DSA:2.60.120.10:FF:000390', NULL, NULL, 'Putative transcriptional regulator, Crp/Fnr family', NULL, NULL, NULL, NULL, NULL, 4),
(205407, NULL, 'G3DSA:2.60.120.970:FF:000033', NULL, NULL, 'Transforming growth factor beta', NULL, NULL, NULL, NULL, NULL, 4),
(205408, NULL, 'G3DSA:3.30.870.10:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205409, NULL, 'G3DSA:3.90.780.10:FF:000018', NULL, NULL, 'SA0881 protein', NULL, NULL, NULL, NULL, NULL, 4),
(205410, NULL, 'G3DSA:3.40.630.150:FF:000007', NULL, NULL, 'Malonyl-CoA decarboxylase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(205411, NULL, 'G3DSA:3.30.160.20:FF:000162', NULL, NULL, 'Double-stranded RNA-binding protein Staufen homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(205412, NULL, 'G3DSA:2.130.10.10:FF:001551', NULL, NULL, 'Elongator acetyltransferase complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(205413, NULL, 'G3DSA:3.30.420.40:FF:000323', NULL, NULL, 'Actin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205414, NULL, 'G3DSA:1.10.10.10:FF:001093', NULL, NULL, 'Heat shock transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205415, NULL, 'G3DSA:3.30.70.1230:FF:000207', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205416, NULL, 'G3DSA:3.10.180.10:FF:000086', NULL, NULL, '4-hydroxyphenylpyruvate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(205417, NULL, 'G3DSA:3.20.10.10:FF:000003', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(205418, NULL, 'G3DSA:3.40.30.10:FF:000672', NULL, NULL, 'Insulin-degrading enzyme-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(205419, NULL, 'G3DSA:3.40.50.1000:FF:000029', NULL, NULL, '3-deoxy-D-manno-octulosonate 8-phosphate phosphatase KdsC', NULL, NULL, NULL, NULL, NULL, 4),
(205420, NULL, 'G3DSA:1.10.437.10:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205421, NULL, 'G3DSA:1.20.1280.50:FF:000149', NULL, NULL, 'GM17963', NULL, NULL, NULL, NULL, NULL, 4),
(205422, NULL, 'G3DSA:1.20.58.70:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205423, NULL, 'G3DSA:1.10.510.10:FF:002531', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205424, NULL, 'G3DSA:1.10.3380.20:FF:000004', NULL, NULL, 'DNA polymerase theta (Helicase domain only), putative', NULL, NULL, NULL, NULL, NULL, 4),
(205425, NULL, 'G3DSA:2.30.29.30:FF:000385', NULL, NULL, 'insulin receptor substrate 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(205426, NULL, 'G3DSA:1.10.287.70:FF:000640', NULL, NULL, 'Potassium two pore domain channel subfamily K member 6', NULL, NULL, NULL, NULL, NULL, 4),
(205427, NULL, 'G3DSA:1.10.510.10:FF:003094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205428, NULL, 'G3DSA:3.40.1110.10:FF:000052', NULL, NULL, 'Copper-translocating P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(205429, NULL, 'G3DSA:1.10.287.110:FF:000006', NULL, NULL, 'Import inner membrane translocase subunit TIM16', NULL, NULL, NULL, NULL, NULL, 4),
(205430, NULL, 'G3DSA:3.40.50.20:FF:000092', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(205431, NULL, 'G3DSA:2.70.98.90:FF:000010', NULL, NULL, 'Membrane protein insertase YidC', NULL, NULL, NULL, NULL, NULL, 4),
(205432, NULL, 'G3DSA:3.40.50.1820:FF:000270', NULL, NULL, 'Alpha/beta-Hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(205433, NULL, 'G3DSA:3.90.190.10:FF:000226', NULL, NULL, 'Riok-3', NULL, NULL, NULL, NULL, NULL, 4),
(205434, NULL, 'G3DSA:3.20.20.70:FF:000095', NULL, NULL, 'Lysine 2,3-aminomutase', NULL, NULL, NULL, NULL, NULL, 4),
(205435, NULL, 'G3DSA:3.40.50.1010:FF:000246', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205436, NULL, 'G3DSA:3.40.50.2000:FF:001072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(205437, NULL, 'G3DSA:3.40.190.10:FF:000979', NULL, NULL, 'ADL180Cp', NULL, NULL, NULL, NULL, NULL, 4),
(205438, NULL, 'G3DSA:1.10.220.30:FF:000008', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(205439, NULL, 'G3DSA:2.130.10.10:FF:002855', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205440, NULL, 'G3DSA:2.130.10.10:FF:000938', NULL, NULL, 'Probable periodic tryptophan protein PWP2', NULL, NULL, NULL, NULL, NULL, 4),
(205441, NULL, 'G3DSA:3.40.50.360:FF:000142', NULL, NULL, 'Oxygen-independent protoporphyrinogen oxidase HemG', NULL, NULL, NULL, NULL, NULL, 4),
(205442, NULL, 'G3DSA:1.10.510.10:FF:000165', NULL, NULL, 'Tyrosine-protein kinase RYK', NULL, NULL, NULL, NULL, NULL, 4),
(205443, NULL, 'G3DSA:2.60.120.290:FF:000020', NULL, NULL, 'Neuropilin and tolloid-like protein 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(205444, NULL, 'G3DSA:3.40.390.10:FF:000224', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205445, NULL, 'G3DSA:3.90.1750.10:FF:000004', NULL, NULL, 'E3 ubiquitin-protein ligase HECW2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(205446, NULL, 'G3DSA:3.30.200.20:FF:002015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205447, NULL, 'G3DSA:1.10.1030.10:FF:000003', NULL, NULL, 'Carbamoyl-phosphate synthase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(205448, NULL, 'G3DSA:3.30.160.60:FF:005665', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205449, NULL, 'G3DSA:2.130.10.10:FF:005609', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205450, NULL, 'G3DSA:2.170.300.10:FF:000029', NULL, NULL, 'Platelet endothelial aggregation receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(205451, NULL, 'G3DSA:3.40.1280.10:FF:000103', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205452, NULL, 'G3DSA:1.25.40.10:FF:000729', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g25270, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(205453, NULL, 'G3DSA:1.20.1250.20:FF:001965', NULL, NULL, 'Uncharacterized transporter C460.05', NULL, NULL, NULL, NULL, NULL, 4),
(205454, NULL, 'G3DSA:3.30.420.110:FF:000001', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(205455, NULL, 'G3DSA:2.10.60.10:FF:000082', NULL, NULL, 'Serine/threonine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(205456, NULL, 'G3DSA:2.60.40.10:FF:005165', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205457, NULL, 'G3DSA:3.40.50.10190:FF:000368', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205458, NULL, 'G3DSA:3.10.430.100:FF:000016', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(205459, NULL, 'G3DSA:1.10.260.100:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205460, NULL, 'G3DSA:3.20.20.190:FF:000016', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(205461, NULL, 'G3DSA:3.40.50.10810:FF:000043', NULL, NULL, 'Transcription termination factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(205462, NULL, 'G3DSA:2.60.120.820:FF:000016', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205463, NULL, 'G3DSA:3.60.15.10:FF:000198', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205464, NULL, 'G3DSA:1.10.132.20:FF:000019', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205465, NULL, 'G3DSA:3.30.70.330:FF:002319', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205466, NULL, 'G3DSA:3.30.450.40:FF:000095', NULL, NULL, 'Transcriptional regulator, IclR family', NULL, NULL, NULL, NULL, NULL, 4),
(205467, NULL, 'G3DSA:1.25.40.20:FF:001671', NULL, NULL, 'Inhibitor of Bruton tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(205468, NULL, 'G3DSA:3.40.50.300:FF:001905', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205469, NULL, 'G3DSA:3.30.70.980:FF:000070', NULL, NULL, 'Probable transcriptional regulatory protein C8D2.12c', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(205470, NULL, 'G3DSA:2.70.50.40:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205471, NULL, 'G3DSA:3.30.200.20:FF:001526', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205472, NULL, 'G3DSA:2.130.10.10:FF:001506', NULL, NULL, 'Vacuolar assembly protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205473, NULL, 'G3DSA:3.30.1490.20:FF:000091', NULL, NULL, 'Ribosomal protein S6 modification protein', NULL, NULL, NULL, NULL, NULL, 4),
(205474, NULL, 'G3DSA:1.20.142.10:FF:000026', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(205475, NULL, 'G3DSA:3.30.160.60:FF:001394', NULL, NULL, 'Zinc finger protein 189', NULL, NULL, NULL, NULL, NULL, 4),
(205476, NULL, 'G3DSA:3.10.660.10:FF:000016', NULL, NULL, 'DPH3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(205477, NULL, 'G3DSA:2.130.10.10:FF:002911', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205478, NULL, 'G3DSA:3.10.20.30:FF:000072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205479, NULL, 'G3DSA:3.90.550.10:FF:000361', NULL, NULL, 'Glycosyltransferases', NULL, NULL, NULL, NULL, NULL, 4),
(205480, NULL, 'G3DSA:2.60.120.10:FF:000238', NULL, NULL, 'Cysteine dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(205481, NULL, 'G3DSA:3.40.50.620:FF:000742', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205482, NULL, 'G3DSA:1.10.274.100:FF:000016', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(205483, NULL, 'G3DSA:2.60.40.10:FF:001798', NULL, NULL, 'Hibris, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(205484, NULL, 'G3DSA:3.30.930.10:FF:000241', NULL, NULL, 'Bifunctional ligase/repressor BirA', NULL, NULL, NULL, NULL, NULL, 4),
(205485, NULL, 'G3DSA:1.10.510.10:FF:003835', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205486, NULL, 'G3DSA:1.25.10.10:FF:002818', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205487, NULL, 'G3DSA:1.20.1540.10:FF:000079', NULL, NULL, 'Rhomboid family intramembrane serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(205488, NULL, 'G3DSA:1.20.1560.10:FF:000086', NULL, NULL, 'ABC multidrug transporter Mdr1', NULL, NULL, NULL, NULL, NULL, 4),
(205489, NULL, 'G3DSA:3.40.50.300:FF:000596', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(205490, NULL, 'G3DSA:1.20.5.740:FF:000003', NULL, NULL, 'Colicin', NULL, NULL, NULL, NULL, NULL, 4),
(205491, NULL, 'G3DSA:3.40.50.1820:FF:000955', NULL, NULL, 'Hydrolase, alpha/beta fold family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205492, NULL, 'G3DSA:1.10.630.10:FF:000556', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205493, NULL, 'G3DSA:1.10.287.470:FF:000024', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(205494, NULL, 'G3DSA:3.30.70.330:FF:000572', NULL, NULL, 'U1 small nuclear ribonucleoprotein A', NULL, NULL, NULL, NULL, NULL, 4),
(205495, NULL, 'G3DSA:3.30.160.60:FF:005614', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205496, NULL, 'G3DSA:1.10.150.120:FF:000010', NULL, NULL, 'Oxidoreductase, iron-sulfur binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(205497, NULL, 'G3DSA:3.40.50.300:FF:001220', NULL, NULL, 'ABC transporter ATP-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(205498, NULL, 'G3DSA:3.40.50.970:FF:000212', NULL, NULL, 'Pyruvate dehydrogenase E1 alpha 1 subunit b', NULL, NULL, NULL, NULL, NULL, 4),
(205499, NULL, 'G3DSA:3.30.565.10:FF:000184', NULL, NULL, 'Heat shock protein 90, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205500, NULL, 'G3DSA:3.50.50.100:FF:000039', NULL, NULL, 'Sulfide:quinone oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(205501, NULL, 'G3DSA:3.40.50.1440:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205502, NULL, 'G3DSA:3.55.50.30:FF:000005', NULL, NULL, 'Fec operon regulator FecR', NULL, NULL, NULL, NULL, NULL, 4),
(205503, NULL, 'G3DSA:1.10.287.410:FF:000001', NULL, NULL, 'Carboxypeptidase Y', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(205504, NULL, 'G3DSA:2.30.29.30:FF:000441', NULL, NULL, 'Insulin receptor substrate 1', NULL, NULL, NULL, NULL, NULL, 4),
(205505, NULL, 'G3DSA:3.30.210.10:FF:000006', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(205506, NULL, 'G3DSA:1.10.230.10:FF:000008', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(205507, NULL, 'G3DSA:2.130.10.10:FF:000197', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(205508, NULL, 'G3DSA:3.30.1490.180:FF:000040', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(205509, NULL, 'G3DSA:1.20.1070.10:FF:000234', NULL, NULL, 'adhesion G-protein coupled receptor G4', NULL, NULL, NULL, NULL, NULL, 4),
(205510, NULL, 'G3DSA:3.30.40.10:FF:000690', NULL, NULL, 'Mind bomb', NULL, NULL, NULL, NULL, NULL, 4),
(205511, NULL, 'G3DSA:1.10.1200.120:FF:000004', NULL, NULL, 'Ion channel, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205512, NULL, 'G3DSA:1.25.10.10:FF:001458', NULL, NULL, 'Receptor Mediated Endocytosis', NULL, NULL, NULL, NULL, NULL, 4),
(205513, NULL, 'G3DSA:3.30.720.90:FF:000001', NULL, NULL, '60S ribosomal protein L38', NULL, NULL, NULL, NULL, NULL, 4),
(205514, NULL, 'G3DSA:3.40.50.150:FF:000989', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205515, NULL, 'G3DSA:3.40.50.2000:FF:000560', NULL, NULL, 'Trehalose-6-phosphate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(205516, NULL, 'G3DSA:1.20.120.980:FF:000046', NULL, NULL, 'Protein CBG23655', NULL, NULL, NULL, NULL, NULL, 4),
(205517, NULL, 'G3DSA:2.60.200.20:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205518, NULL, 'G3DSA:3.40.309.10:FF:000036', NULL, NULL, 'Methylmalonate-semialdehyde dehydrogenase (Acylating)', NULL, NULL, NULL, NULL, NULL, 4),
(205519, NULL, 'G3DSA:1.20.120.1240:FF:000007', NULL, NULL, 'Interferon-induced GTP-binding protein Mx1', NULL, NULL, NULL, NULL, NULL, 4),
(205520, NULL, 'G3DSA:3.30.420.580:FF:000001', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(205521, NULL, 'G3DSA:1.10.238.10:FF:001077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205522, NULL, 'G3DSA:3.30.70.560:FF:000005', NULL, NULL, 'Folic acid synthesis protein fol1', NULL, NULL, NULL, NULL, NULL, 4),
(205523, NULL, 'G3DSA:3.40.50.300:FF:001956', NULL, NULL, 'Dynein cytoplasmic 1 heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(205524, NULL, 'G3DSA:1.25.40.20:FF:000210', NULL, NULL, 'Ankyrin repeat and FYVE domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(205525, NULL, 'G3DSA:3.30.1490.20:FF:000040', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(205526, NULL, 'G3DSA:3.15.10.30:FF:000004', NULL, NULL, 'AGAP013061-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(205527, NULL, 'G3DSA:3.30.160.60:FF:001343', NULL, NULL, 'Zinc finger protein 568', NULL, NULL, NULL, NULL, NULL, 4),
(205528, NULL, 'G3DSA:3.20.20.80:FF:000480', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205529, NULL, 'G3DSA:3.80.10.10:FF:003131', NULL, NULL, 'Si:dkey-230i18.2', NULL, NULL, NULL, NULL, NULL, 4),
(205530, NULL, 'G3DSA:1.25.10.10:FF:000997', NULL, NULL, 'Cell fusion protein fus1', NULL, NULL, NULL, NULL, NULL, 4),
(205531, NULL, 'G3DSA:1.10.8.60:FF:000443', NULL, NULL, 'Replication factor C, subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(205532, NULL, 'G3DSA:3.60.15.10:FF:000147', NULL, NULL, 'Metallo-beta-lactamase type 2', NULL, NULL, NULL, NULL, NULL, 4),
(205533, NULL, 'G3DSA:3.40.50.300:FF:004867', NULL, NULL, 'NLR family member X1', NULL, NULL, NULL, NULL, NULL, 4),
(205534, NULL, 'G3DSA:3.40.50.10810:FF:000094', NULL, NULL, 'DNA excision repair protein ERCC-6', NULL, NULL, NULL, NULL, NULL, 4),
(205535, NULL, 'G3DSA:1.20.1050.10:FF:000227', NULL, NULL, 'Glutathione S-transferase Gst', NULL, NULL, NULL, NULL, NULL, 4),
(205536, NULL, 'G3DSA:3.40.50.1460:FF:000139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205537, NULL, 'G3DSA:1.10.287.130:FF:000220', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(205538, NULL, 'G3DSA:2.60.40.10:FF:001742', NULL, NULL, 'filamin-A isoform X7', NULL, NULL, NULL, NULL, NULL, 4),
(205539, NULL, 'G3DSA:2.30.42.10:FF:000308', NULL, NULL, 'Rap guanine nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(205540, NULL, 'G3DSA:3.40.50.300:FF:005267', NULL, NULL, 'Cytidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(205541, NULL, 'G3DSA:3.50.50.60:FF:001076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205542, NULL, 'G3DSA:3.30.40.10:FF:001090', NULL, NULL, 'Histone-lysine N-methyltransferase ATXR6', NULL, NULL, NULL, NULL, NULL, 4),
(205543, NULL, 'G3DSA:1.10.10.10:FF:001834', NULL, NULL, 'Cyclic GMP-binding protein C', NULL, NULL, NULL, NULL, NULL, 4),
(205544, NULL, 'G3DSA:2.130.10.10:FF:005761', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205545, NULL, 'G3DSA:2.60.40.10:FF:001747', NULL, NULL, 'Interference hedgehog', NULL, NULL, NULL, NULL, NULL, 4),
(205546, NULL, 'G3DSA:1.20.1640.10:FF:000087', NULL, NULL, 'Bifunctional preprotein translocase subunit SecD/SecF', NULL, NULL, NULL, NULL, NULL, 4),
(205547, NULL, 'G3DSA:1.10.287.70:FF:000039', NULL, NULL, 'ATP-sensitive inward rectifier potassium channel 12', NULL, NULL, NULL, NULL, NULL, 4),
(205548, NULL, 'G3DSA:3.90.79.10:FF:000113', NULL, NULL, 'NUDIX hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(205549, NULL, 'G3DSA:3.80.10.10:FF:000225', NULL, NULL, 'volume-regulated anion channel subunit LRRC8B', NULL, NULL, NULL, NULL, NULL, 4),
(205550, NULL, 'G3DSA:2.130.10.10:FF:000202', NULL, NULL, 'TAF5-like RNA polymerase II p300/CBP-associated factor-associated factor 65 kDa subunit 5L', NULL, NULL, NULL, NULL, NULL, 4),
(205551, NULL, 'G3DSA:3.40.50.300:FF:007240', NULL, NULL, 'RE04047p', NULL, NULL, NULL, NULL, NULL, 4),
(205552, NULL, 'G3DSA:3.30.559.10:FF:000017', NULL, NULL, 'Nonribosomal peptide synthase Pes1', NULL, NULL, NULL, NULL, NULL, 4),
(205553, NULL, 'G3DSA:2.30.30.40:FF:000419', NULL, NULL, 'Chemotaxis protein CheV', NULL, NULL, NULL, NULL, NULL, 4),
(205554, NULL, 'G3DSA:3.40.50.150:FF:001478', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205555, NULL, 'G3DSA:3.80.10.10:FF:000169', NULL, NULL, 'TLR4 interactor with leucine rich repeats', NULL, NULL, NULL, NULL, NULL, 4),
(205556, NULL, 'G3DSA:1.25.40.10:FF:001281', NULL, NULL, 'G-protein-signaling modulator 2', NULL, NULL, NULL, NULL, NULL, 4),
(205557, NULL, 'G3DSA:1.10.238.10:FF:000588', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205558, NULL, 'G3DSA:1.10.720.30:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205559, NULL, 'G3DSA:3.30.750.24:FF:000015', NULL, NULL, 'Sulfate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(205560, NULL, 'G3DSA:1.10.1410.10:FF:000044', NULL, NULL, 'RNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(205561, NULL, 'G3DSA:3.40.630.150:FF:000002', NULL, NULL, 'malonyl-CoA decarboxylase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(205562, NULL, 'G3DSA:1.10.510.10:FF:001177', NULL, NULL, 'eukaryotic translation initiation factor 2-alpha kinase 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(205563, NULL, 'G3DSA:1.20.1250.20:FF:000661', NULL, NULL, 'Synaptic vesicle glycoprotein 2C', NULL, NULL, NULL, NULL, NULL, 4),
(205564, NULL, 'G3DSA:3.90.79.10:FF:000057', NULL, NULL, 'MutT/NUDIX family protein phosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(205565, NULL, 'G3DSA:2.10.50.10:FF:000137', NULL, NULL, 'CD40 molecule, TNF receptor superfamily member 5', NULL, NULL, NULL, NULL, NULL, 4),
(205566, NULL, 'G3DSA:3.30.160.60:FF:000090', NULL, NULL, 'Odd-skipped-related transciption factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(205567, NULL, 'G3DSA:3.30.70.120:FF:000008', NULL, NULL, 'Protein CutA 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(205568, NULL, 'G3DSA:3.30.40.10:FF:002376', NULL, NULL, 'Tnf receptor associated factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205569, NULL, 'G3DSA:3.30.200.20:FF:000273', NULL, NULL, 'Casein kinase II alpha subunit', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(205570, NULL, 'G3DSA:1.20.1080.10:FF:000004', NULL, NULL, 'Glycerol facilitator', NULL, NULL, NULL, NULL, NULL, 4),
(205571, NULL, 'G3DSA:1.10.3210.10:FF:000063', NULL, NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(205572, NULL, 'G3DSA:3.20.20.10:FF:000009', NULL, NULL, 'Diaminopimelate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(205573, NULL, 'G3DSA:2.40.100.10:FF:000106', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(205574, NULL, 'G3DSA:3.40.1190.20:FF:000009', NULL, NULL, 'Pyridoxine/pyridoxal/pyridoxamine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(205575, NULL, 'G3DSA:2.60.120.200:FF:000117', NULL, NULL, 'Terribly reduced optic lobes, isoform AL', NULL, NULL, NULL, NULL, NULL, 4),
(205576, NULL, 'G3DSA:1.10.510.10:FF:000906', NULL, NULL, 'Spectrin, beta, non-erythrocytic 1', NULL, NULL, NULL, NULL, NULL, 4),
(205577, NULL, 'G3DSA:3.30.200.20:FF:000621', NULL, NULL, 'Putative L-type lectin-domain containing receptor kinase VII.2', NULL, NULL, NULL, NULL, NULL, 4),
(205578, NULL, 'G3DSA:3.10.129.10:FF:000181', NULL, NULL, 'Acyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(205579, NULL, 'G3DSA:1.10.10.60:FF:000186', NULL, NULL, 'Transcriptional regulator, TetR family', NULL, NULL, NULL, NULL, NULL, 4),
(205580, NULL, 'G3DSA:2.130.10.10:FF:001490', NULL, NULL, 'Protein HIRA', NULL, NULL, NULL, NULL, NULL, 4),
(205581, NULL, 'G3DSA:3.30.1330.30:FF:000116', NULL, NULL, 'Protein CBG18354', NULL, NULL, NULL, NULL, NULL, 4),
(205582, NULL, 'G3DSA:1.10.260.50:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205583, NULL, 'G3DSA:1.10.220.150:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205584, NULL, 'G3DSA:3.30.56.10:FF:000035', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(205585, NULL, 'G3DSA:2.20.100.10:FF:000083', NULL, NULL, 'ADAMTS like 3', NULL, NULL, NULL, NULL, NULL, 4),
(205586, NULL, 'G3DSA:3.40.30.10:FF:001009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205587, NULL, 'G3DSA:3.60.130.10:FF:000021', NULL, NULL, 'Pyoverdine biosynthesis protein PvcB', NULL, NULL, NULL, NULL, NULL, 4),
(205588, NULL, 'G3DSA:1.10.1670.10:FF:000074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205589, NULL, 'G3DSA:2.60.40.60:FF:000043', NULL, NULL, 'Protocadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(205590, NULL, 'G3DSA:3.20.20.190:FF:000067', NULL, NULL, 'Glycerophosphoryl diester phosphodiesterase family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205591, NULL, 'G3DSA:3.30.342.10:FF:000048', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(205592, NULL, 'G3DSA:3.30.2140.20:FF:000014', NULL, NULL, 'Arylamine N-acetyltransferase 3', NULL, NULL, NULL, NULL, NULL, 4),
(205593, NULL, 'G3DSA:3.50.50.60:FF:000120', NULL, NULL, 'Putative oxidoreductase FixC', NULL, NULL, NULL, NULL, NULL, 4),
(205594, NULL, 'G3DSA:2.60.120.620:FF:000052', NULL, NULL, 'Prolyl 4-hydroxylase alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205595, NULL, 'G3DSA:3.40.50.10130:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205596, NULL, 'G3DSA:3.20.20.105:FF:000012', NULL, NULL, 'Queuine tRNA-ribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(205597, NULL, 'G3DSA:3.10.580.10:FF:000015', NULL, NULL, 'DUF21 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(205598, NULL, 'G3DSA:1.20.120.720:FF:000047', NULL, NULL, 'Chitin synthase-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(205599, NULL, 'G3DSA:3.30.750.24:FF:000066', NULL, NULL, 'Solute carrier family 26, member 10', NULL, NULL, NULL, NULL, NULL, 4),
(205600, NULL, 'G3DSA:1.10.8.50:FF:000002', NULL, NULL, '40S ribosomal protein S18', NULL, NULL, NULL, NULL, NULL, 4),
(205601, NULL, 'G3DSA:1.10.533.10:FF:000257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205602, NULL, 'G3DSA:3.30.160.60:FF:000382', NULL, NULL, 'zinc finger protein 35 isoform X4', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(205603, NULL, 'G3DSA:1.10.287.130:FF:000164', NULL, NULL, 'Signal transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(205604, NULL, 'G3DSA:3.80.10.10:FF:002018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205605, NULL, 'G3DSA:1.20.58.60:FF:000733', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205606, NULL, 'G3DSA:3.80.10.10:FF:000276', NULL, NULL, 'F-box/LRR-repeat protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(205607, NULL, 'G3DSA:3.30.420.10:FF:000724', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205608, NULL, 'G3DSA:1.10.10.60:FF:000927', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205609, NULL, 'G3DSA:1.25.10.10:FF:000109', NULL, NULL, 'Diaphanous homolog 1 (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(205610, NULL, 'G3DSA:1.20.1080.10:FF:000055', NULL, NULL, 'Related to channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(205611, NULL, 'G3DSA:2.60.40.10:FF:000786', NULL, NULL, 'hepatocyte cell adhesion molecule isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(205612, NULL, 'G3DSA:1.20.58.740:FF:000003', NULL, NULL, 'dedicator of cytokinesis protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(205613, NULL, 'G3DSA:3.30.300.30:FF:000042', NULL, NULL, 'Fatty-acid-CoA ligase FadD22', NULL, NULL, NULL, NULL, NULL, 4),
(205614, NULL, 'G3DSA:3.10.100.10:FF:000098', NULL, NULL, 'protein bark beetle', NULL, NULL, NULL, NULL, NULL, 4),
(205615, NULL, 'G3DSA:3.90.70.10:FF:000857', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205616, NULL, 'G3DSA:3.40.50.300:FF:008201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205617, NULL, 'G3DSA:1.25.10.10:FF:002970', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205618, NULL, 'G3DSA:1.20.5.190:FF:000029', NULL, NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(205619, NULL, 'G3DSA:2.60.40.1200:FF:000001', NULL, NULL, 'RTX toxin', NULL, NULL, NULL, NULL, NULL, 4),
(205620, NULL, 'G3DSA:1.20.1080.10:FF:000111', NULL, NULL, 'Zgc:92747', NULL, NULL, NULL, NULL, NULL, 4),
(205621, NULL, 'G3DSA:1.10.340.30:FF:000051', NULL, NULL, 'Methyl-CpG-binding domain protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(205622, NULL, 'G3DSA:3.40.50.150:FF:001427', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205623, NULL, 'G3DSA:1.20.120.550:FF:000030', NULL, NULL, 'Microsomal glutathione S-transferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(205624, NULL, 'G3DSA:1.10.510.10:FF:000614', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205625, NULL, 'G3DSA:2.40.50.140:FF:000799', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205626, NULL, 'G3DSA:1.20.58.60:FF:000677', NULL, NULL, 'Nesprin-1', NULL, NULL, NULL, NULL, NULL, 4),
(205627, NULL, 'G3DSA:3.20.20.80:FF:000485', NULL, NULL, 'Alpha-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(205628, NULL, 'G3DSA:3.30.9.10:FF:000073', NULL, NULL, 'FAD-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(205629, NULL, 'G3DSA:3.30.160.60:FF:002759', NULL, NULL, 'Zinc finger protein 568', NULL, NULL, NULL, NULL, NULL, 4),
(205630, NULL, 'G3DSA:1.20.5.170:FF:000074', NULL, NULL, 'Spindle assembly checkpoint component', NULL, NULL, NULL, NULL, NULL, 4),
(205631, NULL, 'G3DSA:2.170.16.10:FF:000040', NULL, NULL, 'DNA polymerase III subunit', NULL, NULL, NULL, NULL, NULL, 4),
(205632, NULL, 'G3DSA:3.30.230.70:FF:000031', NULL, NULL, 'Exosome complex exonuclease RRP41, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205633, NULL, 'G3DSA:1.20.1560.10:FF:000081', NULL, NULL, 'Protein CBG24505', NULL, NULL, NULL, NULL, NULL, 4),
(205634, NULL, 'G3DSA:3.10.129.10:FF:000029', NULL, NULL, 'Acyl-CoA thioesterase 12', NULL, NULL, NULL, NULL, NULL, 4),
(205635, NULL, 'G3DSA:1.25.40.20:FF:000614', NULL, NULL, 'Ankyrin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(205636, NULL, 'G3DSA:3.30.465.10:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(205637, NULL, 'G3DSA:3.40.50.12280:FF:000006', NULL, NULL, 'NADH-ubiquinone oxidoreductase 20 kDa subunit,mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(205638, NULL, 'G3DSA:3.20.20.70:FF:000600', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205639, NULL, 'G3DSA:3.30.70.890:FF:000043', NULL, NULL, 'GHMP kinase', NULL, NULL, NULL, NULL, NULL, 4),
(205640, NULL, 'G3DSA:1.50.10.10:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205641, NULL, 'G3DSA:3.90.1580.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205642, NULL, 'G3DSA:3.10.20.870:FF:000003', NULL, NULL, 'Polyubiquitin binding (Doa1 Ufd3) protein', NULL, NULL, NULL, NULL, NULL, 4),
(205643, NULL, 'G3DSA:1.10.8.60:FF:000331', NULL, NULL, 'Spermatogenesis associated 5-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(205644, NULL, 'G3DSA:3.40.309.10:FF:000031', NULL, NULL, 'Phenylacetic acid degradation protein MaoC', NULL, NULL, NULL, NULL, NULL, 4),
(205645, NULL, 'G3DSA:3.30.200.20:FF:000565', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RCH1', NULL, NULL, NULL, NULL, NULL, 4),
(205646, NULL, 'G3DSA:1.20.58.60:FF:000385', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(205647, NULL, 'G3DSA:3.30.420.340:FF:000008', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4),
(205648, NULL, 'G3DSA:4.10.400.10:FF:000044', NULL, NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein', NULL, NULL, NULL, NULL, NULL, 4),
(205649, NULL, 'G3DSA:1.25.40.20:FF:001519', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205650, NULL, 'G3DSA:1.10.530.10:FF:000048', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(205651, NULL, 'G3DSA:3.40.1190.20:FF:000161', NULL, NULL, 'ADP-dependent (S)-NAD(P)H-hydrate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(205652, NULL, 'G3DSA:3.90.1530.10:FF:000016', NULL, NULL, 'Sulfiredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(205653, NULL, 'G3DSA:2.60.40.60:FF:000947', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205654, NULL, 'G3DSA:2.20.25.10:FF:000039', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(205655, NULL, 'G3DSA:3.90.640.10:FF:000244', NULL, NULL, 'Actin-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(205656, NULL, 'G3DSA:3.90.660.10:FF:000127', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205657, NULL, 'G3DSA:3.40.390.10:FF:000168', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(205658, NULL, 'G3DSA:1.10.600.10:FF:000048', NULL, NULL, 'Probable polyprenyl-diphosphate synthase GrcC1 (Polyprenyl pyrophosphate synthetase)', NULL, NULL, NULL, NULL, NULL, 4),
(205659, NULL, 'G3DSA:1.25.40.20:FF:000558', NULL, NULL, 'Ankyrin repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(205660, NULL, 'G3DSA:1.50.10.10:FF:000141', NULL, NULL, 'Non-lysosomal glucosylceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(205661, NULL, 'G3DSA:3.40.50.300:FF:007796', NULL, NULL, 'Ras like without CAAX 2', NULL, NULL, NULL, NULL, NULL, 4),
(205662, NULL, 'G3DSA:4.10.280.10:FF:000051', NULL, NULL, 'Basic helix-loop-helix domain-containing protein KIAA2018', NULL, NULL, NULL, NULL, NULL, 4),
(205663, NULL, 'G3DSA:3.80.10.10:FF:003479', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205664, NULL, 'G3DSA:3.50.50.60:FF:000912', NULL, NULL, 'FAD-dependent oxidoreductase (Homolog to geranylgeranyl reductase)', NULL, NULL, NULL, NULL, NULL, 4),
(205665, NULL, 'G3DSA:3.40.190.10:FF:000743', NULL, NULL, 'Glutamate receptor 3.3', NULL, NULL, NULL, NULL, NULL, 4),
(205666, NULL, 'G3DSA:3.30.70.920:FF:000035', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(205667, NULL, 'G3DSA:1.25.10.10:FF:001453', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205668, NULL, 'G3DSA:1.10.510.10:FF:000221', NULL, NULL, 'ribosomal protein S6 kinase delta-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(205669, NULL, 'G3DSA:1.10.357.10:FF:000044', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(205670, NULL, 'G3DSA:1.10.565.10:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205671, NULL, 'G3DSA:3.40.50.10810:FF:000099', NULL, NULL, 'Rad5p', NULL, NULL, NULL, NULL, NULL, 4),
(205672, NULL, 'G3DSA:3.40.50.1820:FF:000163', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(205673, NULL, 'G3DSA:3.30.160.60:FF:006121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205674, NULL, 'G3DSA:1.20.5.170:FF:000023', NULL, NULL, 'ADP-ribosylation factor-binding protein GGA3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(205675, NULL, 'G3DSA:2.60.40.1670:FF:000001', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(205676, NULL, 'G3DSA:3.50.50.60:FF:001132', NULL, NULL, 'FAD-dependent oxidoreductase domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(205677, NULL, 'G3DSA:1.10.287.380:FF:000042', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205678, NULL, 'G3DSA:3.40.50.2300:FF:001504', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205679, NULL, 'G3DSA:1.20.1070.10:FF:002027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205680, NULL, 'G3DSA:3.40.50.620:FF:000635', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(205681, NULL, 'G3DSA:3.50.50.60:FF:000732', NULL, NULL, 'FAD-dependent pyridine nucleotide-disulphide oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(205682, NULL, 'G3DSA:2.20.70.10:FF:000166', NULL, NULL, 'WW domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205683, NULL, 'G3DSA:3.40.50.1100:FF:000273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205684, NULL, 'G3DSA:1.25.10.10:FF:003038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205685, NULL, 'G3DSA:3.30.160.60:FF:004209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205686, NULL, 'G3DSA:3.30.465.10:FF:000069', NULL, NULL, 'FAD binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(205687, NULL, 'G3DSA:1.10.10.440:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205688, NULL, 'G3DSA:3.40.50.300:FF:004311', NULL, NULL, 'RAB30 isoform 8', NULL, NULL, NULL, NULL, NULL, 4),
(205689, NULL, 'G3DSA:4.10.400.10:FF:000100', NULL, NULL, 'LDL receptor related protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(205690, NULL, 'G3DSA:3.40.50.2300:FF:000487', NULL, NULL, 'Phosphotyrosine protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(205691, NULL, 'G3DSA:1.10.10.10:FF:001042', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(205692, NULL, 'G3DSA:1.20.1740.10:FF:000139', NULL, NULL, 'Amino acid transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205693, NULL, 'G3DSA:1.10.510.10:FF:001918', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase SD2-5', NULL, NULL, NULL, NULL, NULL, 4),
(205694, NULL, 'G3DSA:1.10.3210.10:FF:000012', NULL, NULL, 'HD domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(205695, NULL, 'G3DSA:2.130.10.10:FF:003288', NULL, NULL, 'Kinesin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(205696, NULL, 'G3DSA:3.30.200.20:FF:001633', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205697, NULL, 'G3DSA:3.40.50.300:FF:007745', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205698, NULL, 'G3DSA:1.20.1070.10:FF:000178', NULL, NULL, 'Adhesion G-protein coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(205699, NULL, 'G3DSA:2.130.10.10:FF:002799', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(205700, NULL, 'G3DSA:1.10.10.10:FF:001385', NULL, NULL, 'Transcriptional regulator, ArsR family', NULL, NULL, NULL, NULL, NULL, 4),
(205701, NULL, 'G3DSA:3.30.1120.30:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(205702, NULL, 'G3DSA:3.90.79.10:FF:000164', NULL, NULL, 'YALI0C13310p', NULL, NULL, NULL, NULL, NULL, 4),
(205703, NULL, 'G3DSA:1.20.1250.20:FF:000037', NULL, NULL, 'Protein NRT1/ PTR FAMILY 5.2', NULL, NULL, NULL, NULL, NULL, 4),
(205704, NULL, 'G3DSA:3.30.559.10:FF:000068', NULL, NULL, 'Putrescine hydroxycinnamoyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(205705, NULL, 'G3DSA:1.25.40.20:FF:001047', NULL, NULL, 'NePHronoPhthisis (Human kidney disease) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(205706, NULL, 'G3DSA:3.40.50.300:FF:003873', NULL, NULL, 'Cell cycle checkpoint protein RAD17-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(205707, NULL, 'G3DSA:3.40.50.720:FF:001402', NULL, NULL, 'Glucose 1-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(205708, NULL, 'G3DSA:1.20.120.900:FF:000005', NULL, NULL, 'Blast:Peroxisomal biogenesis factor 19', NULL, NULL, NULL, NULL, NULL, 4),
(205709, NULL, 'G3DSA:2.30.180.10:FF:000097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205710, NULL, 'G3DSA:3.30.70.600:FF:000001', NULL, NULL, '30S ribosomal protein S10', NULL, NULL, NULL, NULL, NULL, 4),
(205711, NULL, 'G3DSA:1.10.340.70:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205712, NULL, 'G3DSA:2.130.10.10:FF:003816', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205713, NULL, 'G3DSA:2.130.10.10:FF:003075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205714, NULL, 'G3DSA:3.40.50.300:FF:000652', NULL, NULL, 'ATP-dependent RNA helicase DDX1', NULL, NULL, NULL, NULL, NULL, 4),
(205715, NULL, 'G3DSA:3.40.50.1480:FF:000010', NULL, NULL, 'Adenosylhomocysteinase', NULL, NULL, NULL, NULL, NULL, 4),
(205716, NULL, 'G3DSA:3.30.40.10:FF:000982', NULL, NULL, 'RING-H2 finger protein ATL2K', NULL, NULL, NULL, NULL, NULL, 4),
(205717, NULL, 'G3DSA:1.10.150.50:FF:000227', NULL, NULL, 'EPH receptor A5', NULL, NULL, NULL, NULL, NULL, 4),
(205718, NULL, 'G3DSA:2.10.230.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205719, NULL, 'G3DSA:3.80.10.10:FF:000568', NULL, NULL, 'Disease resistance protein RPS4', NULL, NULL, NULL, NULL, NULL, 4),
(205720, NULL, 'G3DSA:3.90.20.20:FF:000026', NULL, NULL, 'GrpE-like 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(205721, NULL, 'G3DSA:3.40.50.1760:FF:000004', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(205722, NULL, 'G3DSA:1.20.1070.10:FF:001690', NULL, NULL, 'Parathyroid hormone receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(205723, NULL, 'G3DSA:3.30.70.3190:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205724, NULL, 'G3DSA:3.30.1370.130:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205725, NULL, 'G3DSA:1.25.40.10:FF:001842', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(205726, NULL, 'G3DSA:1.20.1250.20:FF:000509', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(205727, NULL, 'G3DSA:1.10.1040.10:FF:000009', NULL, NULL, 'Mannitol-1-phosphate 5-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(205728, NULL, 'G3DSA:3.40.50.620:FF:000686', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205729, NULL, 'G3DSA:3.40.50.300:FF:004362', NULL, NULL, '50S ribosome-binding GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205730, NULL, 'G3DSA:3.30.160.60:FF:001450', NULL, NULL, 'zinc finger protein 774', NULL, NULL, NULL, NULL, NULL, 4),
(205731, NULL, 'G3DSA:3.75.10.10:FF:000007', NULL, NULL, 'N(G),N(G)-dimethylarginine dimethylaminohydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(205732, NULL, 'G3DSA:1.20.1280.290:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205733, NULL, 'G3DSA:1.10.510.10:FF:000957', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205734, NULL, 'G3DSA:3.90.180.10:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(205735, NULL, 'G3DSA:3.40.50.720:FF:001003', NULL, NULL, 'Oxidoreductase, short-chain dehydrogenase/reductase family', NULL, NULL, NULL, NULL, NULL, 4),
(205736, NULL, 'G3DSA:2.30.30.390:FF:000001', NULL, NULL, 'F-box only protein 21 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(205737, NULL, 'G3DSA:3.30.70.80:FF:000055', NULL, NULL, 'Subtilisin-like protease SBT3.2', NULL, NULL, NULL, NULL, NULL, 4),
(205738, NULL, 'G3DSA:3.30.1010.10:FF:000119', NULL, NULL, 'ATM protein', NULL, NULL, NULL, NULL, NULL, 4),
(205739, NULL, 'G3DSA:1.25.10.10:FF:003190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205740, NULL, 'G3DSA:3.50.50.60:FF:000171', NULL, NULL, 'zeta-carotene-forming phytoene desaturase', NULL, NULL, NULL, NULL, NULL, 4),
(205741, NULL, 'G3DSA:3.30.910.20:FF:000012', NULL, NULL, 'Outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(205742, NULL, 'G3DSA:3.30.40.10:FF:000583', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM69', NULL, NULL, NULL, NULL, NULL, 4),
(205743, NULL, 'G3DSA:3.40.50.10190:FF:000076', NULL, NULL, 'DNA helicase, phage-associated', NULL, NULL, NULL, NULL, NULL, 4),
(205744, NULL, 'G3DSA:2.60.120.820:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205745, NULL, 'G3DSA:3.40.50.300:FF:007184', NULL, NULL, 'Energy-coupling factor transporter ATP-binding protein EcfA2', NULL, NULL, NULL, NULL, NULL, 4),
(205746, NULL, 'G3DSA:3.30.70.1450:FF:000037', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205747, NULL, 'G3DSA:2.40.70.10:FF:000452', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205748, NULL, 'G3DSA:3.40.50.360:FF:000086', NULL, NULL, 'FMN reductase', NULL, NULL, NULL, NULL, NULL, 4),
(205749, NULL, 'G3DSA:1.10.510.10:FF:004268', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205750, NULL, 'G3DSA:3.90.70.10:FF:000588', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205751, NULL, 'G3DSA:3.20.20.80:FF:000772', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205752, NULL, 'G3DSA:3.30.200.20:FF:000385', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(205753, NULL, 'G3DSA:2.60.40.150:FF:000306', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(205754, NULL, 'G3DSA:3.40.50.720:FF:002419', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205755, NULL, 'G3DSA:1.20.58.1360:FF:000002', NULL, NULL, 'Lysine (K)-specific demethylase 2B', NULL, NULL, NULL, NULL, NULL, 4),
(205756, NULL, 'G3DSA:2.60.40.10:FF:001293', NULL, NULL, 'Protein tyrosine phosphatase, receptor type B', NULL, NULL, NULL, NULL, NULL, 4),
(205757, NULL, 'G3DSA:3.90.1480.20:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205758, NULL, 'G3DSA:3.40.50.300:FF:000091', NULL, NULL, 'Probable GTP-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(205759, NULL, 'G3DSA:1.20.1530.20:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205760, NULL, 'G3DSA:1.10.10.10:FF:002110', NULL, NULL, 'Forkhead box P3a', NULL, NULL, NULL, NULL, NULL, 4),
(205761, NULL, 'G3DSA:1.20.5.490:FF:000001', NULL, NULL, 'Envelope glycoprotein gp160', NULL, NULL, NULL, NULL, NULL, 4),
(205762, NULL, 'G3DSA:1.10.10.10:FF:002054', NULL, NULL, 'Helicase conserved C-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(205763, NULL, 'G3DSA:3.90.25.10:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205764, NULL, 'G3DSA:3.30.310.10:FF:000042', NULL, NULL, 'AP 2 complex subunit beta 1 putative', NULL, NULL, NULL, NULL, NULL, 4),
(205765, NULL, 'G3DSA:1.10.555.10:FF:000190', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205766, NULL, 'G3DSA:3.30.1370.10:FF:000051', NULL, NULL, 'Putative kh domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(205767, NULL, 'G3DSA:3.30.200.110:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205768, NULL, 'G3DSA:2.10.50.30:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(205769, NULL, 'G3DSA:3.40.50.620:FF:000074', NULL, NULL, 'Nicotinamide-nucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(205770, NULL, 'G3DSA:2.30.180.10:FF:000046', NULL, NULL, 'Fasciclin-like arabinogalactan family protein', NULL, NULL, NULL, NULL, NULL, 4),
(205771, NULL, 'G3DSA:2.60.120.200:FF:000662', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205772, NULL, 'G3DSA:3.30.70.360:FF:000064', NULL, NULL, 'Peptidase M20 domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(205773, NULL, 'G3DSA:2.70.70.10:FF:000029', NULL, NULL, 'Murein DD-endopeptidase MepM and murein hydrolase activator NlpD, contain LysM domain', NULL, NULL, NULL, NULL, NULL, 4),
(205774, NULL, 'G3DSA:3.30.710.10:FF:000027', NULL, NULL, 'Kelch-like protein 4 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(205775, NULL, 'G3DSA:3.30.160.60:FF:004541', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205776, NULL, 'G3DSA:3.30.70.330:FF:001246', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(205777, NULL, 'G3DSA:2.160.10.10:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205778, NULL, 'G3DSA:1.10.1200.10:FF:000163', NULL, NULL, 'Tryptophan N-acetyltransferase ivoA', NULL, NULL, NULL, NULL, NULL, 4),
(205779, NULL, 'G3DSA:3.10.20.80:FF:000002', NULL, NULL, 'Mitochondrial translational initiation factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(205780, NULL, 'G3DSA:1.25.10.10:FF:001222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205781, NULL, 'G3DSA:1.10.300.10:FF:000008', NULL, NULL, 'Adenylosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(205782, NULL, 'G3DSA:3.30.40.10:FF:002163', NULL, NULL, 'Structure-specific endonuclease subunit SLX1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(205783, NULL, 'G3DSA:2.100.10.30:FF:000007', NULL, NULL, 'YIL108W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(205784, NULL, 'G3DSA:3.40.50.1110:FF:000057', NULL, NULL, 'Acetylxylan esterase / glucomannan deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(205785, NULL, 'G3DSA:1.25.40.530:FF:000021', NULL, NULL, 'Protein CBG15100', NULL, NULL, NULL, NULL, NULL, 4),
(205786, NULL, 'G3DSA:3.40.50.1820:FF:001231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205787, NULL, 'G3DSA:2.60.40.420:FF:000174', NULL, NULL, 'Multicopper oxidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(205788, NULL, 'G3DSA:3.10.50.40:FF:000133', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(205789, NULL, 'G3DSA:2.60.40.650:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205790, NULL, 'G3DSA:3.30.470.20:FF:000219', NULL, NULL, 'Inositol-tetrakisphosphate 1-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(205791, NULL, 'G3DSA:2.60.40.630:FF:000012', NULL, NULL, 'Signal transducer and activator of transcription 3', NULL, NULL, NULL, NULL, NULL, 4),
(205792, NULL, 'G3DSA:3.30.160.380:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205793, NULL, 'G3DSA:2.60.40.60:FF:000155', NULL, NULL, 'cadherin-23 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(205794, NULL, 'G3DSA:1.25.40.10:FF:004439', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205795, NULL, 'G3DSA:3.30.60.30:FF:000079', NULL, NULL, 'Enhancer of split M1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(205796, NULL, 'G3DSA:3.10.20.90:FF:000062', NULL, NULL, 'talin-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(205797, NULL, 'G3DSA:3.90.70.10:FF:000644', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 17', NULL, NULL, NULL, NULL, NULL, 4),
(205798, NULL, 'G3DSA:3.40.30.10:FF:000380', NULL, NULL, 'UBX domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(205799, NULL, 'G3DSA:3.55.10.10:FF:000002', NULL, NULL, 'Archease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205800, NULL, 'G3DSA:2.30.29.30:FF:000733', NULL, NULL, 'Myosin XVB', NULL, NULL, NULL, NULL, NULL, 4),
(205801, NULL, 'G3DSA:2.10.110.10:FF:000086', NULL, NULL, 'Filamin binding LIM protein 1', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(205802, NULL, 'G3DSA:2.30.30.190:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205803, NULL, 'G3DSA:3.40.50.2300:FF:000144', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(205804, NULL, 'G3DSA:3.10.250.10:FF:000030', NULL, NULL, 'T-cell surface glycoprotein CD5', NULL, NULL, NULL, NULL, NULL, 4),
(205805, NULL, 'G3DSA:3.30.40.10:FF:001651', NULL, NULL, 'Development protein DG1106', NULL, NULL, NULL, NULL, NULL, 4),
(205806, NULL, 'G3DSA:2.70.170.10:FF:000183', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205807, NULL, 'G3DSA:2.60.120.10:FF:000682', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205808, NULL, 'G3DSA:1.20.1250.20:FF:000892', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(205809, NULL, 'G3DSA:2.130.10.10:FF:005492', NULL, NULL, 'SnoRNA-binding rRNA-processing protein', NULL, NULL, NULL, NULL, NULL, 4),
(205810, NULL, 'G3DSA:1.25.40.10:FF:001050', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g33760', NULL, NULL, NULL, NULL, NULL, 4),
(205811, NULL, 'G3DSA:3.30.70.60:FF:000009', NULL, NULL, '30S ribosomal protein S6', NULL, NULL, NULL, NULL, NULL, 4),
(205812, NULL, 'G3DSA:1.10.10.10:FF:000873', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(205813, NULL, 'G3DSA:3.90.1410.10:FF:000018', NULL, NULL, 'N-lysine methyltransferase SETD6 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(205814, NULL, 'G3DSA:3.40.1120.10:FF:000002', NULL, NULL, '50S ribosomal protein L15e', NULL, NULL, NULL, NULL, NULL, 4),
(205815, NULL, 'G3DSA:3.30.40.10:FF:001319', NULL, NULL, 'TFIIE alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(205816, NULL, 'G3DSA:3.30.2090.10:FF:000012', NULL, NULL, 'Probable RND efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(205817, NULL, 'G3DSA:1.20.58.390:FF:000140', NULL, NULL, 'Neuronal acetylcholine receptor subunit eat-2', NULL, NULL, NULL, NULL, NULL, 4),
(205818, NULL, 'G3DSA:3.40.50.720:FF:000334', NULL, NULL, 'Inositol-3-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(205819, NULL, 'G3DSA:3.30.70.330:FF:002882', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205820, NULL, 'G3DSA:3.40.50.11660:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205821, NULL, 'G3DSA:3.30.720.50:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205822, NULL, 'G3DSA:1.25.40.10:FF:005283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205823, NULL, 'G3DSA:2.60.40.1170:FF:000065', NULL, NULL, 'Mu-adaptin 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205824, NULL, 'G3DSA:3.40.50.10190:FF:000025', NULL, NULL, 'Breast cancer type 1 susceptibility protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(205825, NULL, 'G3DSA:3.90.650.10:FF:000014', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(205826, NULL, 'G3DSA:1.10.150.170:FF:000008', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase H', NULL, NULL, NULL, NULL, NULL, 4),
(205827, NULL, 'G3DSA:2.130.10.10:FF:004704', NULL, NULL, 'AFR634Wp', NULL, NULL, NULL, NULL, NULL, 4),
(205828, NULL, 'G3DSA:3.40.50.720:FF:000278', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(205829, NULL, 'G3DSA:1.10.510.10:FF:003543', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205830, NULL, 'G3DSA:2.130.10.10:FF:002563', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205831, NULL, 'G3DSA:1.25.40.10:FF:004484', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g01510, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(205832, NULL, 'G3DSA:2.40.50.140:FF:000967', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205833, NULL, 'G3DSA:3.40.30.10:FF:000228', NULL, NULL, 'Protein disulfide-isomerase like 2-2', NULL, NULL, NULL, NULL, NULL, 4),
(205834, NULL, 'G3DSA:3.40.50.10190:FF:000256', NULL, NULL, 'PIS (Pax-2, IA-1/6, Smad-2 interacting protein) homolog', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(205835, NULL, 'G3DSA:3.30.70.2510:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205836, NULL, 'G3DSA:3.30.1490.80:FF:000030', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(205837, NULL, 'G3DSA:3.30.160.60:FF:001686', NULL, NULL, 'Zinc finger protein 571', NULL, NULL, NULL, NULL, NULL, 4),
(205838, NULL, 'G3DSA:1.10.418.20:FF:000015', NULL, NULL, 'Ubiquitin-like protease 2', NULL, NULL, NULL, NULL, NULL, 4),
(205839, NULL, 'G3DSA:1.25.40.10:FF:002354', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(205840, NULL, 'G3DSA:2.60.40.60:FF:000099', NULL, NULL, 'protocadherin-19 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(205841, NULL, 'G3DSA:2.130.10.10:FF:003344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205842, NULL, 'G3DSA:2.60.40.10:FF:002759', NULL, NULL, 'Protein-tyrosine-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(205843, NULL, 'G3DSA:2.30.39.10:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205844, NULL, 'G3DSA:1.20.140.40:FF:000019', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(205845, NULL, 'G3DSA:2.30.29.30:FF:000677', NULL, NULL, 'p21-activated kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205846, NULL, 'G3DSA:3.50.50.60:FF:001188', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(205847, NULL, 'G3DSA:3.80.10.10:FF:001006', NULL, NULL, 'F-box protein', NULL, NULL, NULL, NULL, NULL, 4),
(205848, NULL, 'G3DSA:2.120.10.30:FF:000618', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205849, NULL, 'G3DSA:2.60.40.150:FF:000582', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205850, NULL, 'G3DSA:1.10.167.10:FF:000046', NULL, NULL, 'FI03282p', NULL, NULL, NULL, NULL, NULL, 4),
(205851, NULL, 'G3DSA:1.25.40.10:FF:003079', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(205852, NULL, 'G3DSA:1.20.58.60:FF:000784', NULL, NULL, 'Dystonin', NULL, NULL, NULL, NULL, NULL, 4),
(205853, NULL, 'G3DSA:1.50.10.10:FF:000085', NULL, NULL, 'Glycosyl transferase, family 65', NULL, NULL, NULL, NULL, NULL, 4),
(205854, NULL, 'G3DSA:3.40.390.10:FF:000056', NULL, NULL, 'Thrombospondin type 1 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(205855, NULL, 'G3DSA:3.10.20.90:FF:000859', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205856, NULL, 'G3DSA:3.30.1960.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205857, NULL, 'G3DSA:1.50.10.20:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205858, NULL, 'G3DSA:3.90.640.10:FF:000188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205859, NULL, 'G3DSA:3.10.450.580:FF:000001', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(205860, NULL, 'G3DSA:2.70.130.10:FF:000130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205861, NULL, 'G3DSA:1.10.730.10:FF:000092', NULL, NULL, 'GD12953', NULL, NULL, NULL, NULL, NULL, 4),
(205862, NULL, 'G3DSA:1.10.555.10:FF:000038', NULL, NULL, 'DEP domain-containing protein 1A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(205863, NULL, 'G3DSA:1.20.1070.10:FF:001919', NULL, NULL, 'Urotensin-2 receptor-like', NULL, NULL, NULL, NULL, NULL, 4),
(205864, NULL, 'G3DSA:1.25.40.20:FF:000322', NULL, NULL, 'GA-binding protein subunit beta-1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(205865, NULL, 'G3DSA:3.30.710.10:FF:000314', NULL, NULL, 'Potassium channel', NULL, NULL, NULL, NULL, NULL, 4),
(205866, NULL, 'G3DSA:4.10.280.10:FF:000163', NULL, NULL, 'Transcriptional regulator CBF1', NULL, NULL, NULL, NULL, NULL, 4),
(205867, NULL, 'G3DSA:1.10.246.130:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205868, NULL, 'G3DSA:1.25.40.20:FF:000266', NULL, NULL, 'Mindbomb E3 ubiquitin protein ligase 1', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(205869, NULL, 'G3DSA:3.30.710.10:FF:000258', NULL, NULL, 'Protein CBR-KVS-3', NULL, NULL, NULL, NULL, NULL, 4),
(205870, NULL, 'G3DSA:3.40.850.10:FF:000136', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(205871, NULL, 'G3DSA:3.30.1120.10:FF:000004', NULL, NULL, 'Galactosamine (N-acetyl)-6-sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(205872, NULL, 'G3DSA:1.25.10.10:FF:002021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205873, NULL, 'G3DSA:3.40.50.720:FF:002571', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205874, NULL, 'G3DSA:1.20.120.1510:FF:000004', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(205875, NULL, 'G3DSA:3.50.50.60:FF:001424', NULL, NULL, 'Lysine-specific histone demethylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(205876, NULL, 'G3DSA:1.10.510.10:FF:000053', NULL, NULL, 'Epithelial discoidin domain-containing receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(205877, NULL, 'G3DSA:2.20.100.10:FF:000032', NULL, NULL, 'ADAMTS-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(205878, NULL, 'G3DSA:2.60.120.260:FF:000365', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205879, NULL, 'G3DSA:1.10.287.110:FF:000405', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205880, NULL, 'G3DSA:1.25.40.180:FF:000051', NULL, NULL, 'MIF4G domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(205881, NULL, 'G3DSA:1.10.10.60:FF:000135', NULL, NULL, 'Myb/SANT-like DNA-binding domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(205882, NULL, 'G3DSA:3.40.50.261:FF:000040', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205883, NULL, 'G3DSA:2.130.10.10:FF:003400', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205884, NULL, 'G3DSA:3.20.20.70:FF:000656', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205885, NULL, 'G3DSA:1.10.1240.10:FF:000008', NULL, NULL, 'Dimethylamine corrinoid protein', NULL, NULL, NULL, NULL, NULL, 4),
(205886, NULL, 'G3DSA:2.60.260.20:FF:000009', NULL, NULL, 'Putative Mitochondrial DnaJ chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(205887, NULL, 'G3DSA:1.25.40.10:FF:002410', NULL, NULL, 'Os03g0435200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(205888, NULL, 'G3DSA:3.30.160.60:FF:001742', NULL, NULL, 'Zinc finger protein 620', NULL, NULL, NULL, NULL, NULL, 4),
(205889, NULL, 'G3DSA:1.20.1560.10:FF:000373', NULL, NULL, 'ATP binding cassette subfamily B member 10', NULL, NULL, NULL, NULL, NULL, 4),
(205890, NULL, 'G3DSA:3.40.50.1820:FF:001848', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205891, NULL, 'G3DSA:1.10.8.140:FF:000005', NULL, NULL, 'Unplaced genomic scaffold supercont2.21, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(205892, NULL, 'G3DSA:3.30.420.40:FF:000879', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205893, NULL, 'G3DSA:2.60.40.10:FF:002815', NULL, NULL, 'AGAP003610-PA', NULL, NULL, NULL, NULL, NULL, 4),
(205894, NULL, 'G3DSA:3.40.50.10190:FF:000312', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205895, NULL, 'G3DSA:3.80.10.10:FF:003367', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205896, NULL, 'G3DSA:3.40.367.20:FF:000027', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(205897, NULL, 'G3DSA:3.40.50.300:FF:007852', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205898, NULL, 'G3DSA:3.40.50.2300:FF:000779', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205899, NULL, 'G3DSA:3.30.760.10:FF:000070', NULL, NULL, 'YALI0D24299p', NULL, NULL, NULL, NULL, NULL, 4),
(205900, NULL, 'G3DSA:1.10.510.10:FF:004324', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205901, NULL, 'G3DSA:3.10.330.10:FF:000031', NULL, NULL, 'Putative AAA family ATPase SEC18', NULL, NULL, NULL, NULL, NULL, 4),
(205902, NULL, 'G3DSA:3.10.20.90:FF:000679', NULL, NULL, 'Ubiquitin family protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(205903, NULL, 'G3DSA:2.60.40.10:FF:005401', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205904, NULL, 'G3DSA:1.10.287.70:FF:000191', NULL, NULL, 'Glutamate receptor ionotropic, NMDA 3A', NULL, NULL, NULL, NULL, NULL, 4),
(205905, NULL, 'G3DSA:2.20.70.10:FF:000054', NULL, NULL, 'E3 ubiquitin-protein ligase SMURF1', NULL, NULL, NULL, NULL, NULL, 4),
(205906, NULL, 'G3DSA:3.40.50.10330:FF:000045', NULL, NULL, 'Diacylglycerol kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(205907, NULL, 'G3DSA:3.40.630.30:FF:000093', NULL, NULL, 'Acetyltransferase, GNAT family', NULL, NULL, NULL, NULL, NULL, 4),
(205908, NULL, 'G3DSA:2.40.70.10:FF:000396', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205909, NULL, 'G3DSA:3.40.50.150:FF:001079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205910, NULL, 'G3DSA:1.25.40.10:FF:004771', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205911, NULL, 'G3DSA:3.30.750.24:FF:000122', NULL, NULL, 'Proton/sulfate symporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(205912, NULL, 'G3DSA:3.30.559.10:FF:000124', NULL, NULL, 'Plipastatin synthase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(205913, NULL, 'G3DSA:3.30.70.330:FF:002606', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205914, NULL, 'G3DSA:3.40.50.300:FF:005615', NULL, NULL, 'Tudor domain-containing 9', NULL, NULL, NULL, NULL, NULL, 4),
(205915, NULL, 'G3DSA:1.10.510.10:FF:001126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205916, NULL, 'G3DSA:2.60.40.10:FF:000730', NULL, NULL, 'Fibroblast growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(205917, NULL, 'G3DSA:2.40.20.10:FF:000005', NULL, NULL, 'Plasminogen', NULL, NULL, NULL, NULL, NULL, 4),
(205918, NULL, 'G3DSA:2.10.70.10:FF:000251', NULL, NULL, 'Mannan-binding lectin serine peptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(205919, NULL, 'G3DSA:3.40.50.300:FF:007291', NULL, NULL, 'Small GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205920, NULL, 'G3DSA:1.25.10.10:FF:000784', NULL, NULL, 'Bm5671, isoform c', NULL, NULL, NULL, NULL, NULL, 4),
(205921, NULL, 'G3DSA:3.10.20.620:FF:000001', NULL, NULL, 'Autophagy related 5', NULL, NULL, NULL, NULL, NULL, 4),
(205922, NULL, 'G3DSA:1.10.287.80:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205923, NULL, 'G3DSA:2.80.10.50:FF:000099', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(205924, NULL, 'G3DSA:1.10.510.10:FF:003487', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205925, NULL, 'G3DSA:1.20.1070.10:FF:000846', NULL, NULL, 'Oxoeicosanoid receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(205926, NULL, 'G3DSA:2.30.29.30:FF:000913', NULL, NULL, 'Protein VASP homolog', NULL, NULL, NULL, NULL, NULL, 4),
(205927, NULL, 'G3DSA:3.30.40.10:FF:000291', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(205928, NULL, 'G3DSA:2.40.10.240:FF:000006', NULL, NULL, 'S-adenosylmethionine:tRNA ribosyltransferase-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(205929, NULL, 'G3DSA:3.30.70.330:FF:002994', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205930, NULL, 'G3DSA:2.10.25.10:FF:000231', NULL, NULL, 'hedgehog-interacting protein-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(205931, NULL, 'G3DSA:3.30.2300.10:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205932, NULL, 'G3DSA:1.10.1040.10:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205933, NULL, 'G3DSA:3.90.470.10:FF:000028', NULL, NULL, 'Ribosomal protein L17', NULL, NULL, NULL, NULL, NULL, 4),
(205934, NULL, 'G3DSA:1.10.1200.10:FF:000118', NULL, NULL, 'Hydroxamate-type ferrichrome siderophore peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(205935, NULL, 'G3DSA:3.30.930.10:FF:000297', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(205936, NULL, 'G3DSA:3.30.110.20:FF:000007', NULL, NULL, 'DNA/RNA-binding protein Alba 3', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(205937, NULL, 'G3DSA:3.80.10.10:FF:003928', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205938, NULL, 'G3DSA:1.10.150.20:FF:000016', NULL, NULL, 'DNA integrity scanning protein DisA', NULL, NULL, NULL, NULL, NULL, 4),
(205939, NULL, 'G3DSA:2.60.120.780:FF:000015', NULL, NULL, 'Protein inhibitor of-activated STAT, 4b', NULL, NULL, NULL, NULL, NULL, 4),
(205940, NULL, 'G3DSA:3.40.190.10:FF:000636', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(205941, NULL, 'G3DSA:3.40.1110.10:FF:000232', NULL, NULL, 'Calcium-translocating P-type ATPase, PMCA-type', NULL, NULL, NULL, NULL, NULL, 4),
(205942, NULL, 'G3DSA:1.20.1730.10:FF:000021', NULL, NULL, 'Sodium/glucose cotransporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(205943, NULL, 'G3DSA:3.30.160.60:FF:005053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205944, NULL, 'G3DSA:3.40.50.300:FF:003581', NULL, NULL, 'Probable ATP-binding component of ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(205945, NULL, 'G3DSA:1.25.10.10:FF:003307', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205946, NULL, 'G3DSA:1.20.120.230:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205947, NULL, 'G3DSA:3.40.30.10:FF:000048', NULL, NULL, 'Arsenate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(205948, NULL, 'G3DSA:3.40.50.620:FF:000181', NULL, NULL, 'Nicotinamide/nicotinic acid mononucleotide adenylyltransferase 3', NULL, NULL, NULL, NULL, NULL, 4),
(205949, NULL, 'G3DSA:3.80.10.10:FF:002642', NULL, NULL, 'Nephrocan', NULL, NULL, NULL, NULL, NULL, 4),
(205950, NULL, 'G3DSA:1.10.20.10:FF:000374', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205951, NULL, 'G3DSA:3.40.50.300:FF:000944', NULL, NULL, 'Macrolide ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(205952, NULL, 'G3DSA:3.40.50.2300:FF:000200', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(205953, NULL, 'G3DSA:3.40.605.10:FF:000135', NULL, NULL, 'ALdehyde deHydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(205954, NULL, 'G3DSA:2.60.40.10:FF:001511', NULL, NULL, 'Beta-mannosidase A', NULL, NULL, NULL, NULL, NULL, 4),
(205955, NULL, 'G3DSA:1.20.5.190:FF:000136', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205956, NULL, 'G3DSA:2.60.110.10:FF:000001', NULL, NULL, 'THAUMATIN-LIKE PROTEIN 1', NULL, NULL, NULL, NULL, NULL, 4),
(205957, NULL, 'G3DSA:2.130.10.10:FF:003923', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205958, NULL, 'G3DSA:2.30.30.30:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205959, NULL, 'G3DSA:2.170.140.10:FF:000027', NULL, NULL, 'mucin-2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(205960, NULL, 'G3DSA:3.40.50.1010:FF:000015', NULL, NULL, 'Flap endonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(205961, NULL, 'G3DSA:2.130.10.10:FF:005997', NULL, NULL, 'Beta transducin Trp-Asp domain-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205962, NULL, 'G3DSA:2.60.40.10:FF:001455', NULL, NULL, 'Bent, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(205963, NULL, 'G3DSA:1.20.58.1780:FF:000009', NULL, NULL, 'Nuclear pore complex protein nup155, putative', NULL, NULL, NULL, NULL, NULL, 4),
(205964, NULL, 'G3DSA:3.30.40.10:FF:000538', NULL, NULL, 'E3 ubiquitin-protein ligase MBR2 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(205965, NULL, 'G3DSA:2.40.50.140:FF:000911', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205966, NULL, 'G3DSA:3.40.50.1820:FF:001287', NULL, NULL, 'Clan SC, family S33, methylesterase-like serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(205967, NULL, 'G3DSA:2.40.50.140:FF:000855', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205968, NULL, 'G3DSA:3.30.1490.120:FF:000005', NULL, NULL, 'DNA-directed RNA polymerase III subunit', NULL, NULL, NULL, NULL, NULL, 4),
(205969, NULL, 'G3DSA:2.60.220.50:FF:000050', NULL, NULL, 'Latrophilin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(205970, NULL, 'G3DSA:3.30.1150.10:FF:000012', NULL, NULL, 'Energy transducer TonB', NULL, NULL, NULL, NULL, NULL, 4),
(205971, NULL, 'G3DSA:3.40.50.720:FF:000154', NULL, NULL, 'Bifunctional acetylglutamate kinase/N-acetyl-gamma-glutamyl-phosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(205972, NULL, 'G3DSA:3.40.1110.10:FF:000176', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(205973, NULL, 'G3DSA:2.130.10.10:FF:001782', NULL, NULL, 'WD_domain_-_G-beta_repeat_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(205974, NULL, 'G3DSA:3.30.160.60:FF:003428', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205975, NULL, 'G3DSA:1.20.1070.10:FF:000503', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205976, NULL, 'G3DSA:1.10.287.2480:FF:000004', NULL, NULL, 'Fusion glycoprotein F0', NULL, NULL, NULL, NULL, NULL, 4),
(205977, NULL, 'G3DSA:3.40.50.11610:FF:000007', NULL, NULL, '2-oxoglutarate dehydrogenase, E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(205978, NULL, 'G3DSA:3.40.50.1820:FF:000831', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205979, NULL, 'G3DSA:3.80.10.10:FF:004204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205980, NULL, 'G3DSA:3.40.33.10:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205981, NULL, 'G3DSA:2.40.50.140:FF:001131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205982, NULL, 'G3DSA:3.30.830.10:FF:000025', NULL, NULL, 'Stromal processing peptidase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(205983, NULL, 'G3DSA:2.30.29.30:FF:001133', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205984, NULL, 'G3DSA:2.130.10.10:FF:000146', NULL, NULL, 'protein RAE1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(205985, NULL, 'G3DSA:2.40.10.10:FF:000055', NULL, NULL, 'Hepatocyte growth factor-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(205986, NULL, 'G3DSA:1.50.40.10:FF:000429', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(205987, NULL, 'G3DSA:1.20.5.170:FF:000130', NULL, NULL, 'Transcription factor VIP1 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(205988, NULL, 'G3DSA:1.10.10.60:FF:000478', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(205989, NULL, 'G3DSA:3.30.70.330:FF:000521', NULL, NULL, 'serine/arginine-rich splicing factor RSZ22-like', NULL, NULL, NULL, NULL, NULL, 4),
(205990, NULL, 'G3DSA:3.90.1150.10:FF:000363', NULL, NULL, 'Pleiotropic regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(205991, NULL, 'G3DSA:3.30.70.330:FF:000864', NULL, NULL, 'Putative RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(205992, NULL, 'G3DSA:3.40.1800.20:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205993, NULL, 'G3DSA:3.40.50.300:FF:005435', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205994, NULL, 'G3DSA:2.60.40.10:FF:005744', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(205995, NULL, 'G3DSA:3.30.505.10:FF:000129', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(205996, NULL, 'G3DSA:2.130.10.10:FF:000489', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(205997, NULL, 'G3DSA:3.40.50.410:FF:000180', NULL, NULL, 'Epithelial chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(205998, NULL, 'G3DSA:3.40.50.2300:FF:000256', NULL, NULL, 'Response regulator receiver domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(205999, NULL, 'G3DSA:2.120.10.30:FF:000057', NULL, NULL, 'Low-density lipoprotein receptor-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(206000, NULL, 'G3DSA:3.60.21.10:FF:000240', NULL, NULL, 'AGAP005458-PA', NULL, NULL, NULL, NULL, NULL, 4),
(206001, NULL, 'G3DSA:1.20.58.60:FF:000441', NULL, NULL, 'Muscle-specific protein 300 kDa, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(206002, NULL, 'G3DSA:2.60.40.10:FF:004108', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(206003, NULL, 'G3DSA:1.10.10.10:FF:001273', NULL, NULL, 'Des-methyl DIF-1 methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(206004, NULL, 'G3DSA:3.40.50.300:FF:001164', NULL, NULL, 'ATP-dependent helicase/nuclease subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(206005, NULL, 'G3DSA:2.60.40.60:FF:000992', NULL, NULL, 'Protein CBR-CDH-12', NULL, NULL, NULL, NULL, NULL, 4),
(206006, NULL, 'G3DSA:3.30.980.10:FF:000013', NULL, NULL, 'alanine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(206007, NULL, 'G3DSA:1.20.5.420:FF:000020', NULL, NULL, 'Ribonuclease P protein component 4', NULL, NULL, NULL, NULL, NULL, 4),
(206008, NULL, 'G3DSA:2.160.20.10:FF:000336', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(206009, NULL, 'G3DSA:3.40.50.620:FF:000922', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(206010, NULL, 'G3DSA:3.30.160.60:FF:003760', NULL, NULL, 'AGAP012741-PA', NULL, NULL, NULL, NULL, NULL, 4),
(206011, NULL, 'G3DSA:3.40.630.30:FF:000311', NULL, NULL, 'Protein CBG09255', NULL, NULL, NULL, NULL, NULL, 4),
(206012, NULL, 'G3DSA:4.10.140.10:FF:000001', NULL, NULL, 'Prothrombin', NULL, NULL, NULL, NULL, NULL, 4),
(206013, NULL, 'G3DSA:3.40.50.2300:FF:001217', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206014, NULL, 'G3DSA:1.10.575.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206015, NULL, 'G3DSA:3.90.810.10:FF:000016', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(206016, NULL, 'G3DSA:2.10.70.10:FF:000195', NULL, NULL, 'Receptor tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(206017, NULL, 'G3DSA:1.10.630.10:FF:000668', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206018, NULL, 'G3DSA:2.70.20.10:FF:000026', NULL, NULL, 'DNA topoisomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(206019, NULL, 'G3DSA:3.40.50.80:FF:000031', NULL, NULL, 'Bifunctional cytochrome P450/NADPH--P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(206020, NULL, 'G3DSA:3.30.360.10:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206021, NULL, 'G3DSA:1.20.920.10:FF:000143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206022, NULL, 'G3DSA:3.30.420.10:FF:000432', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206023, NULL, 'G3DSA:3.30.40.10:FF:000870', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(206024, NULL, 'G3DSA:1.50.10.130:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206025, NULL, 'G3DSA:3.80.10.10:FF:002462', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206026, NULL, 'G3DSA:1.10.30.10:FF:000144', NULL, NULL, 'High mobility group protein B1', NULL, NULL, NULL, NULL, NULL, 4),
(206027, NULL, 'G3DSA:3.30.160.60:FF:004597', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206028, NULL, 'G3DSA:3.30.428.10:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206029, NULL, 'G3DSA:3.40.1170.10:FF:000005', NULL, NULL, 'DNA mismatch repair protein MSH1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(206030, NULL, 'G3DSA:3.30.420.40:FF:000935', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206031, NULL, 'G3DSA:2.40.50.100:FF:000130', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(206032, NULL, 'G3DSA:1.20.50.20:FF:000007', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(206033, NULL, 'G3DSA:3.90.850.10:FF:000013', NULL, NULL, '4-hydroxyphenylacetate degradation bifunctional isomerase/decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(206034, NULL, 'G3DSA:2.140.10.10:FF:000005', NULL, NULL, 'Glucose dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(206035, NULL, 'G3DSA:1.10.287.370:FF:000056', NULL, NULL, 'Protein UXT homolog', NULL, NULL, NULL, NULL, NULL, 4),
(206036, NULL, 'G3DSA:3.40.190.10:FF:000456', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(206037, NULL, 'G3DSA:3.55.40.20:FF:000007', NULL, NULL, 'Superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(206038, NULL, 'G3DSA:1.20.58.1040:FF:000024', NULL, NULL, '1,3-beta-glucanosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(206039, NULL, 'G3DSA:3.40.1090.10:FF:000004', NULL, NULL, 'Phospholipase A2', NULL, NULL, NULL, NULL, NULL, 4),
(206040, NULL, 'G3DSA:3.90.1170.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206041, NULL, 'G3DSA:3.30.450.30:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206042, NULL, 'G3DSA:3.40.720.10:FF:000150', NULL, NULL, 'N-sulfoglucosamine sulfohydrolase (sulfamidase)', NULL, NULL, NULL, NULL, NULL, 4),
(206043, NULL, 'G3DSA:1.20.1310.20:FF:000043', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(206044, NULL, 'G3DSA:3.30.450.20:FF:000044', NULL, NULL, 'Phosphate regulon sensor histidine kinase PhoR', NULL, NULL, NULL, NULL, NULL, 4),
(206045, NULL, 'G3DSA:1.10.8.10:FF:000125', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(206046, NULL, 'G3DSA:1.25.40.10:FF:003259', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At3g15200', NULL, NULL, NULL, NULL, NULL, 4),
(206047, NULL, 'G3DSA:2.10.80.10:FF:000021', NULL, NULL, 'Dickkopf', NULL, NULL, NULL, NULL, NULL, 4),
(206048, NULL, 'G3DSA:1.20.58.1150:FF:000001', NULL, NULL, 'Exocyst complex component EXO70', NULL, NULL, NULL, NULL, NULL, 4),
(206049, NULL, 'G3DSA:3.40.50.2000:FF:000380', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(206050, NULL, 'G3DSA:3.40.50.720:FF:001115', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(206051, NULL, 'G3DSA:2.30.29.30:FF:000172', NULL, NULL, 'differentially expressed in FDCP 6 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(206052, NULL, 'G3DSA:2.30.230.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206053, NULL, 'G3DSA:1.10.510.10:FF:001469', NULL, NULL, 'TKL family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(206054, NULL, 'G3DSA:1.10.1900.10:FF:000020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206055, NULL, 'G3DSA:2.120.10.30:FF:000113', NULL, NULL, 'Low-density lipoprotein receptor-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(206056, NULL, 'G3DSA:2.60.40.10:FF:001854', NULL, NULL, 'Uncharacterized protein, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(206057, NULL, 'G3DSA:3.40.50.300:FF:005379', NULL, NULL, 'ABC transporter NFT1', NULL, NULL, NULL, NULL, NULL, 4),
(206058, NULL, 'G3DSA:3.40.50.150:FF:001135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206059, NULL, 'G3DSA:1.10.10.1630:FF:000001', NULL, NULL, 'SYmmetrical Sister cell hermaphrodite gonad defect', NULL, NULL, NULL, NULL, NULL, 4),
(206060, NULL, 'G3DSA:3.30.160.60:FF:002467', NULL, NULL, 'Zinc finger protein 51', NULL, NULL, NULL, NULL, NULL, 4),
(206061, NULL, 'G3DSA:2.130.10.10:FF:001107', NULL, NULL, 'Chromosome segregation protein (SepB)', NULL, NULL, NULL, NULL, NULL, 4),
(206062, NULL, 'G3DSA:3.70.10.10:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206063, NULL, 'G3DSA:3.40.50.670:FF:000004', NULL, NULL, 'DNA gyrase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(206064, NULL, 'G3DSA:1.10.8.10:FF:000069', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(206065, NULL, 'G3DSA:3.40.50.150:FF:000354', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4),
(206066, NULL, 'G3DSA:3.40.50.10090:FF:000052', NULL, NULL, 'Uroporphyrinogen-III synthase/uroporphyrin-III C-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(206067, NULL, 'G3DSA:3.30.160.60:FF:005957', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206068, NULL, 'G3DSA:2.60.120.260:FF:000601', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206069, NULL, 'G3DSA:1.10.8.60:FF:000387', NULL, NULL, 'Orc1-type DNA replication protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(206070, NULL, 'G3DSA:3.90.640.10:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206071, NULL, 'G3DSA:3.40.50.1440:FF:000026', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(206072, NULL, 'G3DSA:1.25.40.120:FF:000016', NULL, NULL, 'Geranylgeranyltransferase type II alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(206073, NULL, 'G3DSA:3.40.1160.10:FF:000055', NULL, NULL, 'Acetylglutamate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(206074, NULL, 'G3DSA:3.30.160.60:FF:002124', NULL, NULL, 'ras-responsive element-binding protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(206075, NULL, 'G3DSA:3.30.70.1230:FF:000090', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(206076, NULL, 'G3DSA:3.40.50.300:FF:002001', NULL, NULL, 'Peptide ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(206077, NULL, 'G3DSA:3.40.50.300:FF:002125', NULL, NULL, 'ATP-dependent helicase HrpB', NULL, NULL, NULL, NULL, NULL, 4),
(206078, NULL, 'G3DSA:3.20.20.140:FF:000193', NULL, NULL, 'Histidinol phosphatase and related hydrolases of the PHP family', NULL, NULL, NULL, NULL, NULL, 4),
(206079, NULL, 'G3DSA:3.40.50.300:FF:001725', NULL, NULL, 'Peptide chain release factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(206080, NULL, 'G3DSA:3.40.50.720:FF:000839', NULL, NULL, 'FAD dependent oxidoreductase superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(206081, NULL, 'G3DSA:3.30.300.110:FF:000014', NULL, NULL, 'Class I SAM-dependent methyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(206082, NULL, 'G3DSA:1.25.40.10:FF:003135', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(206083, NULL, 'G3DSA:1.25.10.10:FF:001565', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206084, NULL, 'G3DSA:3.90.730.10:FF:000015', NULL, NULL, 'Ribonuclease 2', NULL, NULL, NULL, NULL, NULL, 4),
(206085, NULL, 'G3DSA:1.20.1250.20:FF:002185', NULL, NULL, 'Facilitated glucose transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(206086, NULL, 'G3DSA:3.40.640.10:FF:000093', NULL, NULL, 'L-tryptophan--pyruvate aminotransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(206087, NULL, 'G3DSA:3.40.390.10:FF:000112', NULL, NULL, 'Zinc MetalloProtease', NULL, NULL, NULL, NULL, NULL, 4),
(206088, NULL, 'G3DSA:1.10.565.10:FF:000140', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206089, NULL, 'G3DSA:3.60.15.10:FF:000254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206090, NULL, 'G3DSA:1.20.1510.10:FF:000038', NULL, NULL, 'Zinc transporter 4-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(206091, NULL, 'G3DSA:3.40.50.11350:FF:000019', NULL, NULL, 'Putative N-acetyl-beta-D-glucosaminide alpha-1,6-fucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(206092, NULL, 'G3DSA:1.10.630.10:FF:000325', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206093, NULL, 'G3DSA:3.20.20.140:FF:000411', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206094, NULL, 'G3DSA:1.10.220.20:FF:000011', NULL, NULL, 'IQ motif and SEC7 domain-containing protein 2 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(206095, NULL, 'G3DSA:3.10.450.10:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206096, NULL, 'G3DSA:1.20.1610.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206097, NULL, 'G3DSA:3.80.10.10:FF:002586', NULL, NULL, 'Hypothetical leucine-rich repeat protein 1 (LRRP1)', NULL, NULL, NULL, NULL, NULL, 4),
(206098, NULL, 'G3DSA:3.40.50.720:FF:001059', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(206099, NULL, 'G3DSA:1.25.40.10:FF:003315', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(206100, NULL, 'G3DSA:3.50.50.60:FF:000968', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206101, NULL, 'G3DSA:2.60.120.1540:FF:000007', NULL, NULL, 'Alpha-2-macroglobulin like 1', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(206102, NULL, 'G3DSA:3.30.450.20:FF:000605', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206103, NULL, 'G3DSA:2.60.40.10:FF:005221', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206104, NULL, 'G3DSA:3.40.30.10:FF:000104', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(206105, NULL, 'G3DSA:3.10.100.10:FF:000042', NULL, NULL, 'secretory phospholipase A2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(206106, NULL, 'G3DSA:2.60.40.10:FF:004384', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206107, NULL, 'G3DSA:3.30.479.20:FF:000020', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(206108, NULL, 'G3DSA:1.25.40.10:FF:002915', NULL, NULL, 'Tetratricopeptide repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(206109, NULL, 'G3DSA:2.60.40.10:FF:002310', NULL, NULL, 'Beta-mannosidase A', NULL, NULL, NULL, NULL, NULL, 4),
(206110, NULL, 'G3DSA:3.30.2170.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206111, NULL, 'G3DSA:3.40.50.300:FF:000888', NULL, NULL, 'GPN-loop GTPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(206112, NULL, 'G3DSA:2.60.120.10:FF:000007', NULL, NULL, 'Putative potassium/sodium hyperpolarization-activated cyclic nucleotide-gated channel 2', NULL, NULL, NULL, NULL, NULL, 4),
(206113, NULL, 'G3DSA:3.30.200.20:FF:002307', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206114, NULL, 'G3DSA:1.10.238.220:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206115, NULL, 'G3DSA:3.30.160.60:FF:000887', NULL, NULL, 'Transcription factor E4F1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(206116, NULL, 'G3DSA:3.50.50.60:FF:001244', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(206117, NULL, 'G3DSA:3.30.450.270:FF:000004', NULL, NULL, 'Bacteriophytochrome', NULL, NULL, NULL, NULL, NULL, 4),
(206118, NULL, 'G3DSA:3.10.400.20:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206119, NULL, 'G3DSA:3.40.50.720:FF:001790', NULL, NULL, 'Bifunctional protein FolD', NULL, NULL, NULL, NULL, NULL, 4),
(206120, NULL, 'G3DSA:3.20.20.70:FF:000151', NULL, NULL, 'Tryptophan synthase', NULL, NULL, NULL, NULL, NULL, 4),
(206121, NULL, 'G3DSA:3.40.228.10:FF:000011', NULL, NULL, 'Formate dehydrogenase-N subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(206122, NULL, 'G3DSA:4.10.270.10:FF:000005', NULL, NULL, 'myosin heavy chain, muscle isoform X44', NULL, NULL, NULL, NULL, NULL, 4),
(206123, NULL, 'G3DSA:1.20.1740.10:FF:000027', NULL, NULL, 'cystine/glutamate transporter isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(206124, NULL, 'G3DSA:1.20.58.2220:FF:000013', NULL, NULL, 'Cappuccino, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(206125, NULL, 'G3DSA:3.30.420.10:FF:000270', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(206126, NULL, 'G3DSA:1.25.40.10:FF:002298', NULL, NULL, 'Putative pentatricopeptide repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(206127, NULL, 'G3DSA:1.20.1070.10:FF:001302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206128, NULL, 'G3DSA:3.30.420.40:FF:000031', NULL, NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(206129, NULL, 'G3DSA:3.40.720.10:FF:000094', NULL, NULL, 'Iduronate 2-sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(206130, NULL, 'G3DSA:2.120.10.80:FF:000375', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206131, NULL, 'G3DSA:1.20.1110.10:FF:000165', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(206132, NULL, 'G3DSA:2.30.30.100:FF:000139', NULL, NULL, 'Sm snRNP core protein Smb1', NULL, NULL, NULL, NULL, NULL, 4),
(206133, NULL, 'G3DSA:3.40.50.300:FF:005559', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(206134, NULL, 'G3DSA:3.30.540.10:FF:000087', NULL, NULL, 'Os12g0183300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(206135, NULL, 'G3DSA:2.10.25.10:FF:001809', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(206136, NULL, 'G3DSA:3.30.300.30:FF:000098', NULL, NULL, 'Nonribosomal peptide synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(206137, NULL, 'G3DSA:3.40.50.2000:FF:000048', NULL, NULL, 'Starch synthase, chloroplastic/amyloplastic', NULL, NULL, NULL, NULL, NULL, 4),
(206138, NULL, 'G3DSA:3.30.160.60:FF:005558', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206139, NULL, 'G3DSA:3.40.50.150:FF:000697', NULL, NULL, '23S rRNA (Uracil-5-)-methyltransferase RumA', NULL, NULL, NULL, NULL, NULL, 4),
(206140, NULL, 'G3DSA:3.40.50.970:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206141, NULL, 'G3DSA:1.10.30.10:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206142, NULL, 'G3DSA:1.20.58.90:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206143, NULL, 'G3DSA:1.20.1280.50:FF:000205', NULL, NULL, 'F-box DNA helicase 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(206144, NULL, 'G3DSA:1.25.10.10:FF:002526', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206145, NULL, 'G3DSA:3.30.70.330:FF:001302', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(206146, NULL, 'G3DSA:3.80.10.10:FF:003423', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206147, NULL, 'G3DSA:1.25.40.20:FF:000502', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206148, NULL, 'G3DSA:3.10.105.10:FF:000070', NULL, NULL, 'Extracellular solute-binding protein family 5', NULL, NULL, NULL, NULL, NULL, 4),
(206149, NULL, 'G3DSA:2.60.40.10:FF:004945', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206150, NULL, 'G3DSA:3.60.40.10:FF:000216', NULL, NULL, 'Protein phosphatase, Mg2+/Mn2+ dependent 1G', NULL, NULL, NULL, NULL, NULL, 4),
(206151, NULL, 'G3DSA:3.30.70.330:FF:000465', NULL, NULL, 'Polyadenylate-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(206152, NULL, 'G3DSA:3.30.60.30:FF:000023', NULL, NULL, 'tomoregulin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(206153, NULL, 'G3DSA:1.10.10.750:FF:000006', NULL, NULL, 'TBC1 domain family member 7', NULL, NULL, NULL, NULL, NULL, 4),
(206154, NULL, 'G3DSA:1.10.10.60:FF:000079', NULL, NULL, 'MYB transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(206155, NULL, 'G3DSA:1.10.10.440:FF:000032', NULL, NULL, 'Formin binding protein (FNB3)', NULL, NULL, NULL, NULL, NULL, 4),
(206156, NULL, 'G3DSA:1.10.510.10:FF:002582', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206157, NULL, 'G3DSA:3.90.245.10:FF:000011', NULL, NULL, 'Probable nucleoside hydrolase iunH', NULL, NULL, NULL, NULL, NULL, 4),
(206158, NULL, 'G3DSA:2.10.110.10:FF:000142', NULL, NULL, 'Lrg1p', NULL, NULL, NULL, NULL, NULL, 4),
(206159, NULL, 'G3DSA:1.20.1560.10:FF:000193', NULL, NULL, 'ABC transporter B family member 7', NULL, NULL, NULL, NULL, NULL, 4),
(206160, NULL, 'G3DSA:3.40.50.300:FF:005036', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206161, NULL, 'G3DSA:2.20.70.10:FF:000110', NULL, NULL, 'CUGBP Elav-like family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(206162, NULL, 'G3DSA:2.60.120.10:FF:000406', NULL, NULL, 'Cyclic nucleotide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(206163, NULL, 'G3DSA:3.40.50.720:FF:000098', NULL, NULL, 'calcium-activated potassium channel subunit alpha-1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(206164, NULL, 'G3DSA:1.25.10.10:FF:001166', NULL, NULL, 'Cofactor D', NULL, NULL, NULL, NULL, NULL, 4),
(206165, NULL, 'G3DSA:1.10.533.10:FF:000201', NULL, NULL, 'Caspase', NULL, NULL, NULL, NULL, NULL, 4),
(206166, NULL, 'G3DSA:2.10.60.10:FF:000037', NULL, NULL, 'Si:ch73-28h20.1', NULL, NULL, NULL, NULL, NULL, 4),
(206167, NULL, 'G3DSA:3.20.20.70:FF:000712', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206168, NULL, 'G3DSA:3.40.640.10:FF:000289', NULL, NULL, 'Aromatic amino acid aminotransferase DDB_G0272014', NULL, NULL, NULL, NULL, NULL, 4),
(206169, NULL, 'G3DSA:3.40.50.1360:FF:000036', NULL, NULL, 'Glucosamine-6-phosphate deaminase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(206170, NULL, 'G3DSA:2.130.10.30:FF:000028', NULL, NULL, 'PH, RCC1 and FYVE domains-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(206171, NULL, 'G3DSA:3.30.70.1230:FF:000062', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206172, NULL, 'G3DSA:3.40.50.170:FF:000028', NULL, NULL, 'Phosphoribosylglycinamide formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(206173, NULL, 'G3DSA:3.40.50.11180:FF:000002', NULL, NULL, 'Transcription-repair-coupling factor', NULL, NULL, NULL, NULL, NULL, 4),
(206174, NULL, 'G3DSA:3.40.50.460:FF:000008', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(206175, NULL, 'G3DSA:3.30.160.20:FF:000061', NULL, NULL, 'Mitochondrial ribosomal protein S5,putative', NULL, NULL, NULL, NULL, NULL, 4),
(206176, NULL, 'G3DSA:3.40.50.300:FF:003119', NULL, NULL, 'ABC ATPase, putative (AFU_orthologue AFUA_1G16440)', NULL, NULL, NULL, NULL, NULL, 4),
(206177, NULL, 'G3DSA:1.10.472.170:FF:000008', NULL, NULL, 'Transcription initiation factor IIB protein', NULL, NULL, NULL, NULL, NULL, 4),
(206178, NULL, 'G3DSA:1.25.40.20:FF:000406', NULL, NULL, 'protein TANC1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(206179, NULL, 'G3DSA:3.40.50.10940:FF:000003', NULL, NULL, 'L-arabinose isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(206180, NULL, 'G3DSA:3.40.50.1820:FF:000854', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206181, NULL, 'G3DSA:3.30.70.270:FF:000205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206182, NULL, 'G3DSA:3.40.50.1010:FF:000145', NULL, NULL, 'Crossover junction endodeoxyribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(206183, NULL, 'G3DSA:3.40.50.410:FF:000056', NULL, NULL, 'Complement factor B', NULL, NULL, NULL, NULL, NULL, 4),
(206184, NULL, 'G3DSA:1.10.600.10:FF:000088', NULL, NULL, 'FDPS isoform 20', NULL, NULL, NULL, NULL, NULL, 4),
(206185, NULL, 'G3DSA:2.60.40.10:FF:002091', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(206186, NULL, 'G3DSA:2.60.40.10:FF:001585', NULL, NULL, 'Hemicentin-2', NULL, NULL, NULL, NULL, NULL, 4),
(206187, NULL, 'G3DSA:3.60.15.10:FF:000046', NULL, NULL, 'Cleavage and polyadenylation specificity factor subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(206188, NULL, 'G3DSA:3.30.160.60:FF:006385', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206189, NULL, 'G3DSA:1.25.10.10:FF:000368', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(206190, NULL, 'G3DSA:1.25.40.10:FF:001505', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(206191, NULL, 'G3DSA:3.30.559.30:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206192, NULL, 'G3DSA:3.40.50.300:FF:004710', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206193, NULL, 'G3DSA:2.60.120.380:FF:000019', NULL, NULL, 'Clan SB, family S8, subtilisin-like serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(206194, NULL, 'G3DSA:3.20.20.70:FF:000471', NULL, NULL, 'N-acetylneuraminic acid condensing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(206195, NULL, 'G3DSA:2.40.50.140:FF:000731', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206196, NULL, 'G3DSA:1.10.510.10:FF:003195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206197, NULL, 'G3DSA:2.10.25.10:FF:001349', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206198, NULL, 'G3DSA:3.80.10.10:FF:004272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206199, NULL, 'G3DSA:2.60.40.10:FF:005328', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206200, NULL, 'G3DSA:3.30.70.270:FF:000194', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206201, NULL, 'G3DSA:2.60.40.60:FF:000548', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206202, NULL, 'G3DSA:1.10.472.150:FF:000002', NULL, NULL, 'Mlc titration factor A', NULL, NULL, NULL, NULL, NULL, 4),
(206203, NULL, 'G3DSA:1.20.120.530:FF:000001', NULL, NULL, 'Pyruvate dehydrogenase complex transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(206204, NULL, 'G3DSA:2.40.290.10:FF:000035', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(206205, NULL, 'G3DSA:3.90.1520.10:FF:000015', NULL, NULL, 'guanylate cyclase soluble subunit beta-1-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(206206, NULL, 'G3DSA:2.60.200.10:FF:000008', NULL, NULL, 'Interferon regulatory factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(206207, NULL, 'G3DSA:3.40.50.1820:FF:000415', NULL, NULL, 'Putative class 3 lipase', NULL, NULL, NULL, NULL, NULL, 4),
(206208, NULL, 'G3DSA:3.40.930.10:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206209, NULL, 'G3DSA:2.60.120.200:FF:000370', NULL, NULL, 'Apical endosomal glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(206210, NULL, 'G3DSA:2.30.42.10:FF:000270', NULL, NULL, 'disks large homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(206211, NULL, 'G3DSA:1.25.40.20:FF:000878', NULL, NULL, 'Ankyrin 2, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(206212, NULL, 'G3DSA:2.130.10.10:FF:005502', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206213, NULL, 'G3DSA:1.20.1250.20:FF:002139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206214, NULL, 'G3DSA:2.40.160.50:FF:000015', NULL, NULL, 'SAM complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(206215, NULL, 'G3DSA:1.25.40.20:FF:001351', NULL, NULL, 'Protein vms-1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(206216, NULL, 'G3DSA:2.60.40.1450:FF:000014', NULL, NULL, 'Transcription factor cbf11', NULL, NULL, NULL, NULL, NULL, 4),
(206217, NULL, 'G3DSA:1.20.1070.10:FF:000386', NULL, NULL, 'Methuselah-like 10, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(206218, NULL, 'G3DSA:1.10.8.60:FF:000067', NULL, NULL, 'Peroxisomal biogenesis factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(206219, NULL, 'G3DSA:1.25.40.10:FF:001022', NULL, NULL, 'Skt5p', NULL, NULL, NULL, NULL, NULL, 4),
(206220, NULL, 'G3DSA:3.90.290.10:FF:000003', NULL, NULL, 'Fibrillin 3', NULL, NULL, NULL, NULL, NULL, 4),
(206221, NULL, 'G3DSA:2.60.40.10:FF:002102', NULL, NULL, 'V-set and immunoglobulin domain containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(206222, NULL, 'G3DSA:3.40.50.720:FF:001666', NULL, NULL, 'NEDD8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(206223, NULL, 'G3DSA:2.60.40.10:FF:000966', NULL, NULL, 'Sallimus, isoform P', NULL, NULL, NULL, NULL, NULL, 4),
(206224, NULL, 'G3DSA:3.30.160.60:FF:005766', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206225, NULL, 'G3DSA:3.40.50.40:FF:000002', NULL, NULL, 'L-asparaginase 2', NULL, NULL, NULL, NULL, NULL, 4),
(206226, NULL, 'G3DSA:3.40.250.10:FF:000006', NULL, NULL, 'M-phase inducer phosphatase 2', NULL, NULL, NULL, NULL, NULL, 4),
(206227, NULL, 'G3DSA:2.10.110.20:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206228, NULL, 'G3DSA:1.10.287.70:FF:000803', NULL, NULL, 'Calcium voltage-gated channel subunit alpha1 I', NULL, NULL, NULL, NULL, NULL, 4),
(206229, NULL, 'G3DSA:3.30.230.10:FF:000277', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206230, NULL, 'G3DSA:2.60.40.10:FF:002574', NULL, NULL, 'Plexin B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(206231, NULL, 'G3DSA:2.30.30.910:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206232, NULL, 'G3DSA:3.30.160.20:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206233, NULL, 'G3DSA:3.90.70.10:FF:000245', NULL, NULL, 'Ubiquitin hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(206234, NULL, 'G3DSA:3.30.420.40:FF:000003', NULL, NULL, 'heat shock 70 kDa protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(206235, NULL, 'G3DSA:3.30.70.2010:FF:000003', NULL, NULL, '2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-succinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(206236, NULL, 'G3DSA:3.20.20.80:FF:000148', NULL, NULL, 'Isoamylase 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(206237, NULL, 'G3DSA:3.40.50.790:FF:000006', NULL, NULL, 'Electron transfer flavoprotein alpha-subunit', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(206238, NULL, 'G3DSA:3.90.700.10:FF:000002', NULL, NULL, 'L-aspartate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(206239, NULL, 'G3DSA:1.20.120.1750:FF:000155', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(206240, NULL, 'G3DSA:1.10.10.60:FF:001259', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206241, NULL, 'G3DSA:3.20.140.10:FF:000014', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(206242, NULL, 'G3DSA:3.10.310.10:FF:000029', NULL, NULL, 'Trans-3-hydroxy-L-proline dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(206243, NULL, 'G3DSA:3.40.50.2020:FF:000026', NULL, NULL, 'Uracil phosphoribosyltransferase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(206244, NULL, 'G3DSA:1.10.150.220:FF:000006', NULL, NULL, 'Protein CBG23184', NULL, NULL, NULL, NULL, NULL, 4),
(206245, NULL, 'G3DSA:3.40.50.1820:FF:001360', NULL, NULL, 'Esterase EstC, putative', NULL, NULL, NULL, NULL, NULL, 4),
(206246, NULL, 'G3DSA:3.40.30.10:FF:000043', NULL, NULL, 'Alkyl hydroperoxide reductase C', NULL, NULL, NULL, NULL, NULL, 4),
(206247, NULL, 'G3DSA:2.40.30.10:FF:000202', NULL, NULL, 'Fre7p', NULL, NULL, NULL, NULL, NULL, 4),
(206248, NULL, 'G3DSA:3.40.50.300:FF:003558', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206249, NULL, 'G3DSA:1.10.287.660:FF:000014', NULL, NULL, 'rRNA biogenesis protein Nop5/Nop56', NULL, NULL, NULL, NULL, NULL, 4),
(206250, NULL, 'G3DSA:3.10.590.10:FF:000016', NULL, NULL, 'YTH domain-containing protein mmi1', NULL, NULL, NULL, NULL, NULL, 4),
(206251, NULL, 'G3DSA:3.90.80.10:FF:000010', NULL, NULL, 'Probable inorganic pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(206252, NULL, 'G3DSA:1.10.30.50:FF:000021', NULL, NULL, 'Vng6364h', NULL, NULL, NULL, NULL, NULL, 4),
(206253, NULL, 'G3DSA:2.60.40.10:FF:001146', NULL, NULL, 'Matrix remodeling associated 5', NULL, NULL, NULL, NULL, NULL, 4),
(206254, NULL, 'G3DSA:1.20.5.110:FF:000011', NULL, NULL, 'B-cell receptor-associated protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(206255, NULL, 'G3DSA:2.60.40.2100:FF:000001', NULL, NULL, 'Minor fimbrium anchoring subunit Mfa2', NULL, NULL, NULL, NULL, NULL, 4),
(206256, NULL, 'G3DSA:1.10.287.70:FF:000320', NULL, NULL, 'Voltage-dependent calcium channel subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(206257, NULL, 'G3DSA:3.40.50.300:FF:007936', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206258, NULL, 'G3DSA:3.30.200.20:FF:002386', NULL, NULL, 'Protein CBG24789', NULL, NULL, NULL, NULL, NULL, 4),
(206259, NULL, 'G3DSA:1.25.40.180:FF:000079', NULL, NULL, 'Related to cap binding protein 80 (Cbp80)', NULL, NULL, NULL, NULL, NULL, 4),
(206260, NULL, 'G3DSA:3.40.33.10:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206261, NULL, 'G3DSA:3.30.160.60:FF:005396', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206262, NULL, 'G3DSA:1.10.260.40:FF:000064', NULL, NULL, 'Transcriptional repressor RstR', NULL, NULL, NULL, NULL, NULL, 4),
(206263, NULL, 'G3DSA:1.20.58.1480:FF:000009', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(206264, NULL, 'G3DSA:2.130.10.10:FF:004676', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(206265, NULL, 'G3DSA:1.20.1250.20:FF:001313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206266, NULL, 'G3DSA:3.20.20.60:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206267, NULL, 'G3DSA:3.40.50.300:FF:001321', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(206268, NULL, 'G3DSA:1.10.10.2230:FF:000001', NULL, NULL, 'DNA (cytosine-5)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(206269, NULL, 'G3DSA:1.25.40.10:FF:000988', NULL, NULL, 'Os01g0818200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(206270, NULL, 'G3DSA:3.40.50.720:FF:000677', NULL, NULL, 'NAD-dependent glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(206271, NULL, 'G3DSA:3.40.50.1220:FF:000123', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(206272, NULL, 'G3DSA:3.40.50.1000:FF:000288', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(206273, NULL, 'G3DSA:3.30.40.10:FF:001128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206274, NULL, 'G3DSA:3.40.1350.10:FF:000047', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206275, NULL, 'G3DSA:1.10.287.130:FF:000063', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(206276, NULL, 'G3DSA:2.120.10.30:FF:000006', NULL, NULL, 'Teneurin transmembrane protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(206277, NULL, 'G3DSA:2.40.50.140:FF:000568', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206278, NULL, 'G3DSA:2.60.450.10:FF:000010', NULL, NULL, 'Lipopolysaccharide export system protein LptC', NULL, NULL, NULL, NULL, NULL, 4),
(206279, NULL, 'G3DSA:3.40.50.970:FF:000055', NULL, NULL, '2-oxoisovalerate dehydrogenase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(206280, NULL, 'G3DSA:3.30.1330.60:FF:000035', NULL, NULL, 'Outer membrane insertion signal domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(206281, NULL, 'G3DSA:1.20.58.1310:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206282, NULL, 'G3DSA:3.40.50.2300:FF:000588', NULL, NULL, 'Catabolite repressor-activator, DNA-binding transcriptional dual regulator', NULL, NULL, NULL, NULL, NULL, 4),
(206283, NULL, 'G3DSA:2.60.40.10:FF:001955', NULL, NULL, 'SLAM family member 8', NULL, NULL, NULL, NULL, NULL, 4),
(206284, NULL, 'G3DSA:3.20.20.150:FF:000004', NULL, NULL, 'Mannonate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(206285, NULL, 'G3DSA:3.50.50.60:FF:000709', NULL, NULL, 'Reductase/halogenase', NULL, NULL, NULL, NULL, NULL, 4),
(206286, NULL, 'G3DSA:3.30.420.40:FF:001094', NULL, NULL, 'Predicted gene 28778', NULL, NULL, NULL, NULL, NULL, 4),
(206287, NULL, 'G3DSA:2.70.40.10:FF:000016', NULL, NULL, 'Deoxyuridine 5-triphosphate nucleotidohydrolase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(206288, NULL, 'G3DSA:2.130.10.10:FF:004985', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206289, NULL, 'G3DSA:3.90.190.10:FF:000069', NULL, NULL, 'Phosphoglucan phosphatase DSP4, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(206290, NULL, 'G3DSA:3.40.1690.20:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206291, NULL, 'G3DSA:3.30.300.20:FF:000050', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(206292, NULL, 'G3DSA:1.10.630.10:FF:000269', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(206293, NULL, 'G3DSA:2.80.10.50:FF:000071', NULL, NULL, 'Doublecortin domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(206294, NULL, 'G3DSA:2.130.10.10:FF:004204', NULL, NULL, 'Protein CBG07523', NULL, NULL, NULL, NULL, NULL, 4),
(206295, NULL, 'G3DSA:3.30.160.60:FF:001904', NULL, NULL, 'Zinc finger protein 677', NULL, NULL, NULL, NULL, NULL, 4),
(206296, NULL, 'G3DSA:3.10.250.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206297, NULL, 'G3DSA:2.60.120.260:FF:000129', NULL, NULL, 'Laminin subunit gamma 1', NULL, NULL, NULL, NULL, NULL, 4),
(206298, NULL, 'G3DSA:2.60.40.150:FF:000773', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206299, NULL, 'G3DSA:1.10.1440.10:FF:000001', NULL, NULL, 'Apolipoprotein C-II', NULL, NULL, NULL, NULL, NULL, 4),
(206300, NULL, 'G3DSA:2.60.40.10:FF:003400', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206301, NULL, 'G3DSA:2.60.120.10:FF:000137', NULL, NULL, '(S)-ureidoglycine aminohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(206302, NULL, 'G3DSA:1.20.1250.20:FF:000341', NULL, NULL, 'Sialic acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(206303, NULL, 'G3DSA:1.50.40.10:FF:000002', NULL, NULL, 'Putative ADP/ATP translocase 2-like', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(206304, NULL, 'G3DSA:1.25.50.20:FF:000008', NULL, NULL, 'aminopeptidase N isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(206305, NULL, 'G3DSA:3.30.200.20:FF:000941', NULL, NULL, 'Ribosomal protein S6 kinase alpha-3', NULL, NULL, NULL, NULL, NULL, 4),
(206306, NULL, 'G3DSA:3.30.930.10:FF:000218', NULL, NULL, 'ATP phosphoribosyltransferase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(206307, NULL, 'G3DSA:2.30.42.10:FF:000640', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206308, NULL, 'G3DSA:3.40.50.300:FF:007144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206309, NULL, 'G3DSA:2.20.25.10:FF:000062', NULL, NULL, 'Alkylphosphonate utilization protein', NULL, NULL, NULL, NULL, NULL, 4),
(206310, NULL, 'G3DSA:3.40.50.1820:FF:001843', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206311, NULL, 'G3DSA:3.30.40.10:FF:000639', NULL, NULL, 'E3 ubiquitin-protein ligase PEP5', NULL, NULL, NULL, NULL, NULL, 4),
(206312, NULL, 'G3DSA:3.30.160.60:FF:003951', NULL, NULL, 'Maternal gene required for meiosis, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(206313, NULL, 'G3DSA:3.40.50.11260:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206314, NULL, 'G3DSA:3.90.70.80:FF:000013', NULL, NULL, 'OTU domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(206315, NULL, 'G3DSA:3.20.20.100:FF:000113', NULL, NULL, 'Aldo/keto reductase', NULL, NULL, NULL, NULL, NULL, 4),
(206316, NULL, 'G3DSA:3.40.605.10:FF:000039', NULL, NULL, 'Succinate-semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(206317, NULL, 'G3DSA:3.30.450.60:FF:000050', NULL, NULL, 'Coatomer zeta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(206318, NULL, 'G3DSA:3.30.60.20:FF:000059', NULL, NULL, 'Tensin 2', NULL, NULL, NULL, NULL, NULL, 4),
(206319, NULL, 'G3DSA:1.20.120.610:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206320, NULL, 'G3DSA:2.40.50.140:FF:001187', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206321, NULL, 'G3DSA:1.25.40.20:FF:000053', NULL, NULL, 'caskin-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(206322, NULL, 'G3DSA:1.10.20.10:FF:000014', NULL, NULL, 'Histone H2B', NULL, NULL, NULL, NULL, NULL, 4),
(206323, NULL, 'G3DSA:1.10.1600.10:FF:000019', NULL, NULL, 'DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(206324, NULL, 'G3DSA:3.90.1150.10:FF:000234', NULL, NULL, 'Cystathionine gamma-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(206325, NULL, 'G3DSA:3.40.50.300:FF:000332', NULL, NULL, 'DNA repair and recombination protein RAD54-like', NULL, NULL, NULL, NULL, NULL, 4),
(206326, NULL, 'G3DSA:1.25.40.10:FF:000196', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g14850', NULL, NULL, NULL, NULL, NULL, 4),
(206327, NULL, 'G3DSA:3.90.79.10:FF:000248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206328, NULL, 'G3DSA:1.10.510.10:FF:001278', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase', NULL, NULL, NULL, NULL, NULL, 4),
(206329, NULL, 'G3DSA:3.10.450.40:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206330, NULL, 'G3DSA:3.30.160.60:FF:004940', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206331, NULL, 'G3DSA:3.30.70.3290:FF:000016', NULL, NULL, 'Lovastatin nonaketide synthase, polyketide synthase component', NULL, NULL, NULL, NULL, NULL, 4),
(206332, NULL, 'G3DSA:1.25.40.20:FF:001834', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206333, NULL, 'G3DSA:3.60.21.10:FF:000459', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(206334, NULL, 'G3DSA:3.20.20.70:FF:000780', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206335, NULL, 'G3DSA:1.10.10.10:FF:000997', NULL, NULL, 'Transcriptional regulator, ArsR family', NULL, NULL, NULL, NULL, NULL, 4),
(206336, NULL, 'G3DSA:3.30.1370.10:FF:000236', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206337, NULL, 'G3DSA:3.40.50.720:FF:002172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(206338, NULL, 'G3DSA:2.60.40.10:FF:005637', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206339, NULL, 'G3DSA:1.10.287.110:FF:000214', NULL, NULL, 'DnaJ domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(206340, NULL, 'G3DSA:1.25.40.10:FF:004248', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g16470', NULL, NULL, NULL, NULL, NULL, 4),
(206341, NULL, 'G3DSA:3.90.1410.10:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206342, NULL, 'G3DSA:3.30.70.330:FF:002634', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206343, NULL, 'G3DSA:1.10.10.10:FF:001677', NULL, NULL, 'ETS translocation variant 3', NULL, NULL, NULL, NULL, NULL, 4),
(206344, NULL, 'G3DSA:3.30.160.60:FF:004468', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206345, NULL, 'G3DSA:3.50.50.60:FF:001328', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206346, NULL, 'G3DSA:2.20.70.10:FF:000267', NULL, NULL, 'E3 ubiquitin-protein ligase HECW2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(206347, NULL, 'G3DSA:3.80.10.10:FF:002294', NULL, NULL, 'Mhp1p', NULL, NULL, NULL, NULL, NULL, 4),
(206348, NULL, 'G3DSA:1.10.238.20:FF:000046', NULL, NULL, 'general odorant-binding protein 99a-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(206349, NULL, 'G3DSA:1.20.58.400:FF:000019', NULL, NULL, 'Vesicle transport through interaction with t-SNAREs 1B', NULL, NULL, NULL, NULL, NULL, 4),
(206350, NULL, 'G3DSA:3.30.160.60:FF:002540', NULL, NULL, 'Zinc finger protein Nv-ZicE', NULL, NULL, NULL, NULL, NULL, 4),
(206351, NULL, 'G3DSA:2.30.29.30:FF:000284', NULL, NULL, 'pleckstrin homology domain-containing family H member 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(206352, NULL, 'G3DSA:3.40.50.2300:FF:000812', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206353, NULL, 'G3DSA:3.30.70.3270:FF:000010', NULL, NULL, 'NADH-quinone oxidoreductase subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(206354, NULL, 'G3DSA:2.170.130.10:FF:000066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206355, NULL, 'G3DSA:3.10.20.30:FF:000105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206356, NULL, 'G3DSA:3.30.2130.10:FF:000016', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(206357, NULL, 'G3DSA:1.10.472.80:FF:000164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206358, NULL, 'G3DSA:3.40.50.2000:FF:000812', NULL, NULL, 'UDP-glycosyltransferase 73D1', NULL, NULL, NULL, NULL, NULL, 4),
(206359, NULL, 'G3DSA:3.10.350.10:FF:000094', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206360, NULL, 'G3DSA:3.30.460.10:FF:000114', NULL, NULL, 'ATPase synthesis protein 25, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(206361, NULL, 'G3DSA:3.30.70.340:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206362, NULL, 'G3DSA:1.20.120.550:FF:000007', NULL, NULL, 'Leukotriene C4 synthase', NULL, NULL, NULL, NULL, NULL, 4),
(206363, NULL, 'G3DSA:3.30.470.30:FF:000048', NULL, NULL, 'RNA guanylyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(206364, NULL, 'G3DSA:3.30.50.10:FF:000128', NULL, NULL, 'Peroxisome proliferator activated receptor delta', NULL, NULL, NULL, NULL, NULL, 4),
(206365, NULL, 'G3DSA:2.130.10.10:FF:003524', NULL, NULL, 'Small nucleolar ribonucleoprotein complex subunit Dip2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(206366, NULL, 'G3DSA:3.40.50.150:FF:001450', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206367, NULL, 'G3DSA:3.30.160.60:FF:002995', NULL, NULL, 'Zinc-finger protein at 72d', NULL, NULL, NULL, NULL, NULL, 4),
(206368, NULL, 'G3DSA:3.30.70.330:FF:000173', NULL, NULL, 'polypyrimidine tract-binding protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(206369, NULL, 'G3DSA:3.30.420.40:FF:000475', NULL, NULL, 'EryA, erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(206370, NULL, 'G3DSA:3.90.190.10:FF:000541', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206371, NULL, 'G3DSA:3.40.50.1240:FF:000129', NULL, NULL, '6-phosphofructo-2-kinase/fructose-2, 6-biphosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(206372, NULL, 'G3DSA:3.40.50.1820:FF:000062', NULL, NULL, 'Platelet-activating factor acetylhydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(206373, NULL, 'G3DSA:3.40.50.300:FF:008100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206374, NULL, 'G3DSA:1.10.1040.10:FF:000055', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(206375, NULL, 'G3DSA:3.30.160.60:FF:004777', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206376, NULL, 'G3DSA:3.40.140.100:FF:000011', NULL, NULL, 'Ubiquitin-like modifier-activating enzyme ATG7', NULL, NULL, NULL, NULL, NULL, 4),
(206377, NULL, 'G3DSA:3.50.50.60:FF:000491', NULL, NULL, 'Pyruvate Dehydrogenase Phosphatase Regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(206378, NULL, 'G3DSA:2.120.10.30:FF:000506', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206379, NULL, 'G3DSA:3.40.250.10:FF:000023', NULL, NULL, 'Dual specificity protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(206380, NULL, 'G3DSA:1.20.1270.60:FF:000096', NULL, NULL, 'Unplaced genomic scaffold supercont2.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(206381, NULL, 'G3DSA:3.40.50.2000:FF:000279', NULL, NULL, 'Lipopolysaccharide core biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(206382, NULL, 'G3DSA:3.30.46.10:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206383, NULL, 'G3DSA:3.40.50.300:FF:000023', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit beta-2', NULL, NULL, NULL, NULL, NULL, 4),
(206384, NULL, 'G3DSA:3.40.47.10:FF:000199', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206385, NULL, 'G3DSA:3.30.470.10:FF:000042', NULL, NULL, '4-amino-4-deoxychorismate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(206386, NULL, 'G3DSA:3.30.160.60:FF:005749', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206387, NULL, 'G3DSA:2.60.120.200:FF:000792', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(206388, NULL, 'G3DSA:3.40.50.300:FF:006964', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206389, NULL, 'G3DSA:3.20.140.10:FF:000031', NULL, NULL, 'Nicotinate phosphoribosyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(206390, NULL, 'G3DSA:3.40.50.300:FF:003249', NULL, NULL, 'Putative U5 small nuclear ribonucleoprotein 200 kDa helicase', NULL, NULL, NULL, NULL, NULL, 4),
(206391, NULL, 'G3DSA:1.10.150.20:FF:000207', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4),
(206392, NULL, 'G3DSA:3.90.1750.10:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206393, NULL, 'G3DSA:1.10.238.10:FF:001206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206394, NULL, 'G3DSA:1.25.10.10:FF:002285', NULL, NULL, 'Pkp2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(206395, NULL, 'G3DSA:3.60.21.10:FF:000004', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(206396, NULL, 'G3DSA:1.25.40.10:FF:003422', NULL, NULL, 'Putative suppressor of g2 allele of skp1', NULL, NULL, NULL, NULL, NULL, 4),
(206397, NULL, 'G3DSA:1.20.1300.20:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206398, NULL, 'G3DSA:1.10.238.110:FF:000014', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(206399, NULL, 'G3DSA:3.40.630.30:FF:000210', NULL, NULL, 'Beta-N-acetylglucosaminidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(206400, NULL, 'G3DSA:1.20.58.60:FF:000284', NULL, NULL, 'VAB-10A protein', NULL, NULL, NULL, NULL, NULL, 4),
(206401, NULL, 'G3DSA:1.10.275.20:FF:000002', NULL, NULL, 'Peroxisomal carnitine O-octanoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(206402, NULL, 'G3DSA:2.60.120.10:FF:000507', NULL, NULL, 'cGMP-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(206403, NULL, 'G3DSA:3.40.50.300:FF:000787', NULL, NULL, 'Protein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(206404, NULL, 'G3DSA:1.20.120.350:FF:000054', NULL, NULL, 'voltage-gated hydrogen channel 1', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(206405, NULL, 'G3DSA:2.170.120.12:FF:000006', NULL, NULL, 'DNA-directed RNA polymerase alpha chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(206406, NULL, 'G3DSA:3.40.50.10810:FF:000195', NULL, NULL, 'E3 ubiquitin-protein ligase SHPRH-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(206407, NULL, 'G3DSA:3.30.1680.10:FF:000029', NULL, NULL, 'Semaphorin 3B', NULL, NULL, NULL, NULL, NULL, 4),
(206408, NULL, 'G3DSA:3.30.200.20:FF:002414', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206409, NULL, 'G3DSA:2.120.10.80:FF:000370', NULL, NULL, 'Tip elongation aberrant protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(206410, NULL, 'G3DSA:2.60.40.4370:FF:000002', NULL, NULL, 'Transcription factor TFIIIC, tau55-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(206411, NULL, 'G3DSA:3.40.50.1820:FF:001343', NULL, NULL, 'Probable thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(206412, NULL, 'G3DSA:2.10.25.10:FF:000040', NULL, NULL, 'Stabilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(206413, NULL, 'G3DSA:3.40.50.410:FF:000365', NULL, NULL, 'Type IV pili system adhesin PilY', NULL, NULL, NULL, NULL, NULL, 4),
(206414, NULL, 'G3DSA:2.30.30.940:FF:000003', NULL, NULL, 'DNA helicase B', NULL, NULL, NULL, NULL, NULL, 4),
(206415, NULL, 'G3DSA:1.10.510.10:FF:001811', NULL, NULL, 'Cyclin-dependent kinase B1-1', NULL, NULL, NULL, NULL, NULL, 4),
(206416, NULL, 'G3DSA:3.40.50.10320:FF:000008', NULL, NULL, 'N-acetylglucosaminyl-phosphatidylinositol de-N-acetylase', NULL, NULL, NULL, NULL, NULL, 4),
(206417, NULL, 'G3DSA:3.30.470.20:FF:000180', NULL, NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(206418, NULL, 'G3DSA:2.40.110.10:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206419, NULL, 'G3DSA:1.20.120.230:FF:000001', NULL, NULL, 'Breast cancer anti-estrogen resistance 1', NULL, NULL, NULL, NULL, NULL, 4),
(206420, NULL, 'G3DSA:2.170.130.10:FF:000049', NULL, NULL, 'SusC/RagA family TonB-linked outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(206421, NULL, 'G3DSA:3.40.50.720:FF:001975', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206422, NULL, 'G3DSA:1.25.40.660:FF:000009', NULL, NULL, 'Vacuolar protein sorting-associated protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(206423, NULL, 'G3DSA:3.20.20.80:FF:000209', NULL, NULL, 'Glycoside hydrolase family 25', NULL, NULL, NULL, NULL, NULL, 4),
(206424, NULL, 'G3DSA:3.30.710.10:FF:000207', NULL, NULL, 'BTB/POZ domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(206425, NULL, 'G3DSA:1.20.1280.50:FF:000065', NULL, NULL, 'F-box protein SKIP23', NULL, NULL, NULL, NULL, NULL, 4),
(206426, NULL, 'G3DSA:3.30.450.20:FF:000628', NULL, NULL, 'Putative regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(206427, NULL, 'G3DSA:3.40.50.300:FF:001304', NULL, NULL, 'DNA helicase INO80', NULL, NULL, NULL, NULL, NULL, 4),
(206428, NULL, 'G3DSA:1.20.58.100:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206429, NULL, 'G3DSA:3.30.565.10:FF:000285', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(206430, NULL, 'G3DSA:3.90.226.10:FF:000259', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206431, NULL, 'G3DSA:3.100.10.10:FF:000003', NULL, NULL, '50S ribosomal protein L15', NULL, NULL, NULL, NULL, NULL, 4),
(206432, NULL, 'G3DSA:3.30.1600.10:FF:000007', NULL, NULL, 'NAD-dependent protein lipoamidase sirtuin-4, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(206433, NULL, 'G3DSA:3.30.310.80:FF:000029', NULL, NULL, 'MAP/microtubule affinity-regulating kinase 2a', NULL, NULL, NULL, NULL, NULL, 4),
(206434, NULL, 'G3DSA:1.20.1250.20:FF:001330', NULL, NULL, 'Oligopeptide transporter, kidney isoform', NULL, NULL, NULL, NULL, NULL, 4),
(206435, NULL, 'G3DSA:1.10.275.40:FF:000008', NULL, NULL, 'DNA repair helicase rad3/xp-D, putative', NULL, NULL, NULL, NULL, NULL, 4),
(206436, NULL, 'G3DSA:3.40.50.150:FF:001107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(206437, NULL, 'G3DSA:3.40.50.720:FF:000694', NULL, NULL, 'Zinc-dependent alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(206438, NULL, 'G3DSA:2.40.50.140:FF:000259', NULL, NULL, 'RNA polymerase Rpb7 N-terminal domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(206439, NULL, 'G3DSA:1.10.10.10:FF:000749', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(206440, NULL, 'G3DSA:1.10.150.240:FF:000029', NULL, NULL, 'Haloacid dehalogenase-like hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(206441, NULL, 'G3DSA:3.40.50.1820:FF:000871', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206442, NULL, 'G3DSA:1.20.140.150:FF:000094', NULL, NULL, 'germ cell-specific gene 1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(206443, NULL, 'G3DSA:3.20.20.220:FF:000020', NULL, NULL, 'Probable proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(206444, NULL, 'G3DSA:3.40.30.10:FF:000352', NULL, NULL, 'Magnesium transporter protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(206445, NULL, 'G3DSA:3.40.430.10:FF:000043', NULL, NULL, 'Bifunctional dihydrofolate reductase-thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(206446, NULL, 'G3DSA:3.60.15.10:FF:000063', NULL, NULL, 'tRNA processing endoribonuclease Trz1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(206447, NULL, 'G3DSA:1.20.1600.10:FF:000040', NULL, NULL, 'Outer membrane efflux protein', NULL, NULL, NULL, NULL, NULL, 4),
(206448, NULL, 'G3DSA:1.25.40.10:FF:004883', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206449, NULL, 'G3DSA:1.20.5.110:FF:000348', NULL, NULL, 'Synaptosome-associated protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(206450, NULL, 'G3DSA:1.50.40.10:FF:000441', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206451, NULL, 'G3DSA:2.60.40.10:FF:000174', NULL, NULL, 'Nuclear factor of activated T-cells 5, tonicity-responsive', NULL, NULL, NULL, NULL, NULL, 4),
(206452, NULL, 'G3DSA:1.10.287.130:FF:000080', NULL, NULL, 'Sensor histidine kinase/response regulator EvgS', NULL, NULL, NULL, NULL, NULL, 4),
(206453, NULL, 'G3DSA:1.20.1250.20:FF:001622', NULL, NULL, 'Transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(206454, NULL, 'G3DSA:1.10.3160.10:FF:000002', NULL, NULL, 'P35 antigen', NULL, NULL, NULL, NULL, NULL, 4),
(206455, NULL, 'G3DSA:3.30.70.940:FF:000013', NULL, NULL, 'Transcription elongation regulator-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(206456, NULL, 'G3DSA:3.10.129.110:FF:000005', NULL, NULL, 'Phenolpthiocerol synthesis type-I polyketide synthase ppsD', NULL, NULL, NULL, NULL, NULL, 4),
(206457, NULL, 'G3DSA:1.10.30.10:FF:000088', NULL, NULL, 'Sex-determining region Y protein', NULL, NULL, NULL, NULL, NULL, 4),
(206458, NULL, 'G3DSA:1.20.1250.20:FF:000796', NULL, NULL, 'Related to siderophore iron transporter mirc', NULL, NULL, NULL, NULL, NULL, 4),
(206459, NULL, 'G3DSA:2.60.120.650:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206460, NULL, 'G3DSA:2.60.40.2400:FF:000001', NULL, NULL, 'Structural polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(206461, NULL, 'G3DSA:3.40.718.10:FF:000054', NULL, NULL, 'Isocitrate dehydrogenase 3 (NAD+) beta', NULL, NULL, NULL, NULL, NULL, 4),
(206462, NULL, 'G3DSA:1.10.520.20:FF:000005', NULL, NULL, 'ATP synthase subunit delta, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(206463, NULL, 'G3DSA:1.25.40.20:FF:001704', NULL, NULL, 'LOC100005699 protein', NULL, NULL, NULL, NULL, NULL, 4),
(206464, NULL, 'G3DSA:3.30.160.60:FF:003849', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206465, NULL, 'G3DSA:3.40.50.720:FF:000238', NULL, NULL, 'UDP-glucose 4-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(206466, NULL, 'G3DSA:3.40.5.10:FF:000007', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(206467, NULL, 'G3DSA:2.60.40.10:FF:004491', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206468, NULL, 'G3DSA:3.40.50.200:FF:000111', NULL, NULL, 'Neuroendocrine convertase 1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(206469, NULL, 'G3DSA:1.25.40.10:FF:002983', NULL, NULL, 'AGAP010587-PA', NULL, NULL, NULL, NULL, NULL, 4),
(206470, NULL, 'G3DSA:1.20.58.2220:FF:000018', NULL, NULL, 'Formin 2', NULL, NULL, NULL, NULL, NULL, 4),
(206471, NULL, 'G3DSA:2.30.42.10:FF:000623', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206472, NULL, 'G3DSA:2.40.10.10:FF:000639', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206473, NULL, 'G3DSA:3.30.428.10:FF:000017', NULL, NULL, 'Aprataxin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(206474, NULL, 'G3DSA:1.25.10.10:FF:001666', NULL, NULL, 'YALI0D01199p', NULL, NULL, NULL, NULL, NULL, 4),
(206475, NULL, 'G3DSA:1.10.10.60:FF:000287', NULL, NULL, 'TSL-kinase interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(206476, NULL, 'G3DSA:1.10.8.770:FF:000003', NULL, NULL, 'Methylenetetrahydrofolate dehydrogenase (NADP+-dependent) 1a, methenyltetrahydrofolate cyclohydrolase, formyltetrahydrofolate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(206477, NULL, 'G3DSA:3.40.850.10:FF:000474', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(206478, NULL, 'G3DSA:3.40.50.620:FF:000343', NULL, NULL, 'Glutamate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(206479, NULL, 'G3DSA:3.40.50.10140:FF:000078', NULL, NULL, 'Interleukin 1 receptor accessory protein-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(206480, NULL, 'G3DSA:1.10.150.50:FF:000194', NULL, NULL, 'AFR092Wp', NULL, NULL, NULL, NULL, NULL, 4),
(206481, NULL, 'G3DSA:3.30.70.330:FF:003118', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206482, NULL, 'G3DSA:3.10.200.10:FF:000010', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(206483, NULL, 'G3DSA:1.25.40.10:FF:004591', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206484, NULL, 'G3DSA:2.60.120.340:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206485, NULL, 'G3DSA:1.20.5.110:FF:000320', NULL, NULL, 'Protein CBG26242', NULL, NULL, NULL, NULL, NULL, 4),
(206486, NULL, 'G3DSA:2.130.10.10:FF:000298', NULL, NULL, 'Intraflagellar transport 80 homolog (Chlamydomonas)', NULL, NULL, NULL, NULL, NULL, 4),
(206487, NULL, 'G3DSA:3.40.50.300:FF:004047', NULL, NULL, 'Nuclear VCP-like', NULL, NULL, NULL, NULL, NULL, 4),
(206488, NULL, 'G3DSA:3.40.50.1820:FF:001051', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(206489, NULL, 'G3DSA:1.20.58.60:FF:000104', NULL, NULL, 'Nesprin-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(206490, NULL, 'G3DSA:1.20.1250.20:FF:000824', NULL, NULL, 'Transporter, major facilitator family protein', NULL, NULL, NULL, NULL, NULL, 4),
(206491, NULL, 'G3DSA:2.60.34.10:FF:000053', NULL, NULL, 'Hypoxia up-regulated 1', NULL, NULL, NULL, NULL, NULL, 4),
(206492, NULL, 'G3DSA:3.75.10.10:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206493, NULL, 'G3DSA:3.30.200.20:FF:000469', NULL, NULL, 'Spore coat protein YsxE', NULL, NULL, NULL, NULL, NULL, 4),
(206494, NULL, 'G3DSA:3.30.200.20:FF:001897', NULL, NULL, 'CMGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(206495, NULL, 'G3DSA:2.130.10.10:FF:002759', NULL, NULL, 'WD repeat-containing protein 93', NULL, NULL, NULL, NULL, NULL, 4),
(206496, NULL, 'G3DSA:2.30.30.140:FF:000123', NULL, NULL, 'Chromatin modification-related protein EAF3', NULL, NULL, NULL, NULL, NULL, 4),
(206497, NULL, 'G3DSA:2.60.120.200:FF:000353', NULL, NULL, 'Vesicular integral membrane protein VIP36, putative', NULL, NULL, NULL, NULL, NULL, 4),
(206498, NULL, 'G3DSA:2.10.25.10:FF:000832', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(206499, NULL, 'G3DSA:3.20.20.60:FF:000007', NULL, NULL, 'Phosphoenolpyruvate-protein phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(206500, NULL, 'G3DSA:2.40.50.40:FF:000100', NULL, NULL, 'Chromodomain-helicase-DNA-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(206501, NULL, 'G3DSA:1.20.1160.20:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206502, NULL, 'G3DSA:1.25.40.280:FF:000007', NULL, NULL, 'Unplaced genomic scaffold supercont1.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(206503, NULL, 'G3DSA:2.60.120.40:FF:000022', NULL, NULL, 'Tumor necrosis factor ligand superfamily member 12', NULL, NULL, NULL, NULL, NULL, 4),
(206504, NULL, 'G3DSA:3.40.630.30:FF:000238', NULL, NULL, 'Ribosomal-protein-alanine N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(206505, NULL, 'G3DSA:3.90.70.10:FF:000728', NULL, NULL, 'Cysteine endopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(206506, NULL, 'G3DSA:1.25.40.10:FF:000549', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(206507, NULL, 'G3DSA:3.10.450.40:FF:000037', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(206508, NULL, 'G3DSA:1.10.287.70:FF:000011', NULL, NULL, 'Potassium channel, voltage-gated Shaw-related subfamily C, member 4', NULL, NULL, NULL, NULL, NULL, 4),
(206509, NULL, 'G3DSA:1.10.486.10:FF:000057', NULL, NULL, 'ATP-dependent 3''-5'' DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(206510, NULL, 'G3DSA:2.130.10.10:FF:001450', NULL, NULL, 'RE05579p', NULL, NULL, NULL, NULL, NULL, 4),
(206511, NULL, 'G3DSA:3.40.50.720:FF:002155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206512, NULL, 'G3DSA:2.30.29.30:FF:000312', NULL, NULL, 'Ran binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(206513, NULL, 'G3DSA:3.40.640.10:FF:000317', NULL, NULL, 'Kynureninase', NULL, NULL, NULL, NULL, NULL, 4),
(206514, NULL, 'G3DSA:3.40.50.720:FF:001183', NULL, NULL, 'Ornithine cyclodeaminase', NULL, NULL, NULL, NULL, NULL, 4),
(206515, NULL, 'G3DSA:3.30.160.60:FF:003288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206516, NULL, 'G3DSA:2.30.30.550:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206517, NULL, 'G3DSA:3.30.160.60:FF:001612', NULL, NULL, 'MEP-1, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(206518, NULL, 'G3DSA:3.50.50.60:FF:001345', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206519, NULL, 'G3DSA:1.20.85.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206520, NULL, 'G3DSA:1.10.238.20:FF:000029', NULL, NULL, 'AGAP008278-PA', NULL, NULL, NULL, NULL, NULL, 4),
(206521, NULL, 'G3DSA:2.60.120.650:FF:000139', NULL, NULL, 'Protein Jumonji', NULL, NULL, NULL, NULL, NULL, 4),
(206522, NULL, 'G3DSA:3.30.70.1730:FF:000003', NULL, NULL, '50S ribosomal protein L10', NULL, NULL, NULL, NULL, NULL, 4),
(206523, NULL, 'G3DSA:1.20.920.30:FF:000048', NULL, NULL, 'Dynein heavy chain domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(206524, NULL, 'G3DSA:2.120.10.30:FF:000478', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206525, NULL, 'G3DSA:2.60.40.10:FF:003872', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206526, NULL, 'G3DSA:3.30.70.330:FF:000965', NULL, NULL, 'Peroxisome proliferator-activated receptor gamma, coactivator 1 beta', NULL, NULL, NULL, NULL, NULL, 4),
(206527, NULL, 'G3DSA:1.10.10.10:FF:001694', NULL, NULL, 'Vacuolar membrane-associated protein IML1', NULL, NULL, NULL, NULL, NULL, 4),
(206528, NULL, 'G3DSA:2.60.40.420:FF:000197', NULL, NULL, 'Early nodulin-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(206529, NULL, 'G3DSA:2.170.120.30:FF:000015', NULL, NULL, 'YbbR family protein', NULL, NULL, NULL, NULL, NULL, 4),
(206530, NULL, 'G3DSA:3.40.50.720:FF:000255', NULL, NULL, 'Methylenetetrahydrofolate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(206531, NULL, 'G3DSA:3.30.60.30:FF:000051', NULL, NULL, 'LOW QUALITY PROTEIN: tomoregulin-1', NULL, NULL, NULL, NULL, NULL, 4),
(206532, NULL, 'G3DSA:1.10.510.10:FF:002430', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206533, NULL, 'G3DSA:3.60.40.10:FF:000368', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206534, NULL, 'G3DSA:1.10.10.10:FF:000188', NULL, NULL, 'HTH-type transcriptional regulator LeuO', NULL, NULL, NULL, NULL, NULL, 4),
(206535, NULL, 'G3DSA:1.10.472.80:FF:000208', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206536, NULL, 'G3DSA:2.60.40.60:FF:001037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(206537, NULL, 'G3DSA:2.60.40.180:FF:000006', NULL, NULL, 'Probable 5-hydroxyisourate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(206538, NULL, 'G3DSA:1.10.3080.10:FF:000029', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(206539, NULL, 'G3DSA:3.40.718.10:FF:000071', NULL, NULL, 'Isocitrate dehydrogenase [NADP]', NULL, NULL, NULL, NULL, NULL, 4),
(206540, NULL, 'G3DSA:3.30.160.60:FF:003512', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206541, NULL, 'G3DSA:1.25.40.10:FF:002803', NULL, NULL, 'Tetratricopeptide repeat (TPR)-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(206542, NULL, 'G3DSA:3.30.160.60:FF:003821', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206543, NULL, 'G3DSA:2.60.40.420:FF:000067', NULL, NULL, 'Cupredoxin superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(206544, NULL, 'G3DSA:1.10.357.20:FF:000002', NULL, NULL, 'Solute carrier family 41, member 2', NULL, NULL, NULL, NULL, NULL, 4),
(206545, NULL, 'G3DSA:3.40.50.720:FF:000385', NULL, NULL, 'Aspartate kinase /homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(206546, NULL, 'G3DSA:2.160.10.10:FF:000038', NULL, NULL, 'mRNA, clone: RTFL01-10-C12', NULL, NULL, NULL, NULL, NULL, 4),
(206547, NULL, 'G3DSA:3.90.1200.10:FF:000087', NULL, NULL, 'Phosphotransferase, PolIIIAc domain-containing, putative', NULL, NULL, NULL, NULL, NULL, 4),
(206548, NULL, 'G3DSA:2.170.140.10:FF:000022', NULL, NULL, 'Chondroitin proteoglycan-2', NULL, NULL, NULL, NULL, NULL, 4),
(206549, NULL, 'G3DSA:1.20.1560.10:FF:000777', NULL, NULL, 'Putative multidrug resistance-associated protein lethal(2)03659-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(206550, NULL, 'G3DSA:1.10.287.1490:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206551, NULL, 'G3DSA:3.30.70.1050:FF:000013', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(206552, NULL, 'G3DSA:3.40.50.300:FF:005227', NULL, NULL, 'Guanylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(206553, NULL, 'G3DSA:3.30.465.10:FF:000092', NULL, NULL, 'D-lactate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(206554, NULL, 'G3DSA:1.25.40.10:FF:001494', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(206555, NULL, 'G3DSA:1.10.238.200:FF:000024', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(206556, NULL, 'G3DSA:1.10.1520.10:FF:000035', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(206557, NULL, 'G3DSA:1.20.120.350:FF:000071', NULL, NULL, 'Potassium voltage-gated channel protein shk-1', NULL, NULL, NULL, NULL, NULL, 4),
(206558, NULL, 'G3DSA:2.130.10.30:FF:000045', NULL, NULL, 'Ultraviolet-B receptor UVR8', NULL, NULL, NULL, NULL, NULL, 4),
(206559, NULL, 'G3DSA:1.10.630.10:FF:000140', NULL, NULL, 'Putative cytochrome P450 126', NULL, NULL, NULL, NULL, NULL, 4),
(206560, NULL, 'G3DSA:2.130.10.10:FF:005632', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206561, NULL, 'G3DSA:1.10.510.10:FF:001941', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206562, NULL, 'G3DSA:3.30.160.60:FF:001051', NULL, NULL, 'zinc finger protein 768', NULL, NULL, NULL, NULL, NULL, 4),
(206563, NULL, 'G3DSA:3.90.1150.80:FF:000002', NULL, NULL, 'Monopolin complex subunit CSM1', NULL, NULL, NULL, NULL, NULL, 4),
(206564, NULL, 'G3DSA:3.40.1690.10:FF:000005', NULL, NULL, 'Flagellar biosynthesis protein FlhB', NULL, NULL, NULL, NULL, NULL, 4),
(206565, NULL, 'G3DSA:3.40.630.30:FF:000547', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206566, NULL, 'G3DSA:1.25.40.10:FF:000858', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g33990', NULL, NULL, NULL, NULL, NULL, 4),
(206567, NULL, 'G3DSA:3.30.2020.30:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206568, NULL, 'G3DSA:2.30.40.10:FF:000006', NULL, NULL, 'D-phenylhydantoinase', NULL, NULL, NULL, NULL, NULL, 4),
(206569, NULL, 'G3DSA:3.30.200.20:FF:001234', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(206570, NULL, 'G3DSA:3.40.50.300:FF:007583', NULL, NULL, 'LD21880p', NULL, NULL, NULL, NULL, NULL, 4),
(206571, NULL, 'G3DSA:2.30.30.30:FF:000057', NULL, NULL, 'Transcription elongation factor SPT5', NULL, NULL, NULL, NULL, NULL, 4),
(206572, NULL, 'G3DSA:3.20.20.100:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206573, NULL, 'G3DSA:1.20.1560.10:FF:000114', NULL, NULL, 'ABC multidrug transporter Mdr1', NULL, NULL, NULL, NULL, NULL, 4),
(206574, NULL, 'G3DSA:2.130.10.10:FF:001607', NULL, NULL, 'Cilia- and flagella-associated protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(206575, NULL, 'G3DSA:3.90.190.10:FF:000086', NULL, NULL, 'Protein tyrosine phosphatase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(206576, NULL, 'G3DSA:3.90.640.10:FF:000031', NULL, NULL, 'Actin-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(206577, NULL, 'G3DSA:3.10.20.90:FF:000516', NULL, NULL, 'Inactive tyrosine-protein kinase kin-32', NULL, NULL, NULL, NULL, NULL, 4),
(206578, NULL, 'G3DSA:2.160.20.10:FF:000292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206579, NULL, 'G3DSA:3.90.1290.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206580, NULL, 'G3DSA:3.30.505.10:FF:000028', NULL, NULL, 'Suppressor of cytokine signaling 5', NULL, NULL, NULL, NULL, NULL, 4),
(206581, NULL, 'G3DSA:3.40.50.1820:FF:000724', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(206582, NULL, 'G3DSA:3.30.1640.10:FF:000100', NULL, NULL, 'DNA replication licensing factor', NULL, NULL, NULL, NULL, NULL, 4),
(206583, NULL, 'G3DSA:2.60.40.150:FF:000790', NULL, NULL, 'Protein CBG04254', NULL, NULL, NULL, NULL, NULL, 4),
(206584, NULL, 'G3DSA:1.50.10.20:FF:000150', NULL, NULL, 'Murinoglobulin-2', NULL, NULL, NULL, NULL, NULL, 4),
(206585, NULL, 'G3DSA:2.10.25.10:FF:001012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206586, NULL, 'G3DSA:3.40.190.10:FF:000344', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(206587, NULL, 'G3DSA:1.10.510.10:FF:003256', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206588, NULL, 'G3DSA:3.60.40.10:FF:000031', NULL, NULL, 'PAS sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(206589, NULL, 'G3DSA:1.20.58.190:FF:000006', NULL, NULL, 'Unplaced genomic scaffold supercont1.3, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(206590, NULL, 'G3DSA:3.40.50.300:FF:006172', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206591, NULL, 'G3DSA:2.130.10.10:FF:000961', NULL, NULL, 'WD repeat domain phosphoinositide-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(206592, NULL, 'G3DSA:2.40.128.680:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206593, NULL, 'G3DSA:1.20.920.10:FF:000042', NULL, NULL, 'RSC complex member', NULL, NULL, NULL, NULL, NULL, 4),
(206594, NULL, 'G3DSA:3.30.420.10:FF:000331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206595, NULL, 'G3DSA:3.40.50.2300:FF:001105', NULL, NULL, 'Metabotropic glutamate receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(206596, NULL, 'G3DSA:1.10.10.60:FF:000950', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206597, NULL, 'G3DSA:3.40.50.620:FF:000782', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206598, NULL, 'G3DSA:3.40.930.10:FF:000036', NULL, NULL, 'Anion exchange protein', NULL, NULL, NULL, NULL, NULL, 4),
(206599, NULL, 'G3DSA:1.20.1280.50:FF:000048', NULL, NULL, 'F-box family protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(206600, NULL, 'G3DSA:3.10.20.90:FF:000207', NULL, NULL, 'Rhea, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(206601, NULL, 'G3DSA:2.130.10.10:FF:000270', NULL, NULL, 'plexin-B3 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(206602, NULL, 'G3DSA:1.10.340.30:FF:000028', NULL, NULL, 'Mitochondrial glycosylase/lyase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(206603, NULL, 'G3DSA:1.10.10.10:FF:001486', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit K', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(206604, NULL, 'G3DSA:2.60.40.3510:FF:000008', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(206605, NULL, 'G3DSA:2.60.120.200:FF:000718', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206606, NULL, 'G3DSA:3.90.1150.10:FF:000251', NULL, NULL, 'Aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(206607, NULL, 'G3DSA:2.70.50.30:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206608, NULL, 'G3DSA:1.10.287.470:FF:000047', NULL, NULL, 'Putative periplasmic linker protein', NULL, NULL, NULL, NULL, NULL, 4),
(206609, NULL, 'G3DSA:1.10.10.10:FF:000396', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(206610, NULL, 'G3DSA:3.30.310.50:FF:000003', NULL, NULL, 'Phosphoacetylglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(206611, NULL, 'G3DSA:3.50.50.60:FF:000047', NULL, NULL, 'Nitric oxide reductase FlRd-NAD(+) reductase', NULL, NULL, NULL, NULL, NULL, 4),
(206612, NULL, 'G3DSA:4.10.60.10:FF:000178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206613, NULL, 'G3DSA:1.10.10.10:FF:001014', NULL, NULL, 'Iron (Metal) dependent repressor, DtxR family', NULL, NULL, NULL, NULL, NULL, 4),
(206614, NULL, 'G3DSA:1.20.1270.60:FF:000320', NULL, NULL, 'AGAP001369-PA', NULL, NULL, NULL, NULL, NULL, 4),
(206615, NULL, 'G3DSA:1.10.10.1940:FF:000010', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(206616, NULL, 'G3DSA:2.60.120.260:FF:000573', NULL, NULL, 'EPH receptor B6', NULL, NULL, NULL, NULL, NULL, 4),
(206617, NULL, 'G3DSA:2.40.128.20:FF:000038', NULL, NULL, 'AGAP002594-PA', NULL, NULL, NULL, NULL, NULL, 4),
(206618, NULL, 'G3DSA:3.30.160.60:FF:004485', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206619, NULL, 'G3DSA:3.30.1390.30:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206620, NULL, 'G3DSA:1.20.1050.90:FF:000009', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(206621, NULL, 'G3DSA:3.90.640.90:FF:000009', NULL, NULL, 'B-cell translocation gene 4', NULL, NULL, NULL, NULL, NULL, 4),
(206622, NULL, 'G3DSA:1.10.390.10:FF:000071', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206623, NULL, 'G3DSA:3.30.70.3500:FF:000001', NULL, NULL, 'Chromosome partition protein MukB', NULL, NULL, NULL, NULL, NULL, 4),
(206624, NULL, 'G3DSA:2.130.10.130:FF:000013', NULL, NULL, 'Glycosylphosphatidylinositol specific phospholipase D1', NULL, NULL, NULL, NULL, NULL, 4),
(206625, NULL, 'G3DSA:1.10.287.40:FF:000013', NULL, NULL, 'Seryl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(206626, NULL, 'G3DSA:2.160.10.10:FF:000010', NULL, NULL, 'Glucose-1-phosphate adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(206627, NULL, 'G3DSA:3.30.420.40:FF:000666', NULL, NULL, 'Actin-related protein ARP9', NULL, NULL, NULL, NULL, NULL, 4),
(206628, NULL, 'G3DSA:1.20.1070.10:FF:001083', NULL, NULL, 'Neuropeptide FF receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(206629, NULL, 'G3DSA:1.20.58.390:FF:000033', NULL, NULL, 'Gamma-aminobutyric acid receptor subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(206630, NULL, 'G3DSA:3.30.40.10:FF:000611', NULL, NULL, 'Zinc finger family protein', NULL, NULL, NULL, NULL, NULL, 4),
(206631, NULL, 'G3DSA:3.80.10.10:FF:003002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206632, NULL, 'G3DSA:1.25.10.10:FF:001649', NULL, NULL, 'Proteasome activator complex subunit 4A', NULL, NULL, NULL, NULL, NULL, 4),
(206633, NULL, 'G3DSA:2.130.10.10:FF:003496', NULL, NULL, 'SH3KBP1-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(206634, NULL, 'G3DSA:2.130.10.10:FF:003395', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206635, NULL, 'G3DSA:3.30.70.330:FF:000734', NULL, NULL, 'U2 snRNP auxiliary factor large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(206636, NULL, 'G3DSA:3.40.50.12160:FF:000015', NULL, NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(206637, NULL, 'G3DSA:2.130.10.10:FF:003507', NULL, NULL, 'Plexin-A2', NULL, NULL, NULL, NULL, NULL, 4),
(206638, NULL, 'G3DSA:3.80.10.10:FF:003575', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206639, NULL, 'G3DSA:2.130.10.10:FF:001787', NULL, NULL, 'Dynein, cytoplasmic 1, intermediate chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(206640, NULL, 'G3DSA:3.40.720.10:FF:000099', NULL, NULL, 'Arylsulphatase A', NULL, NULL, NULL, NULL, NULL, 4),
(206641, NULL, 'G3DSA:1.25.40.10:FF:002303', NULL, NULL, 'Pentatricopeptide repeat (PPR) superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(206642, NULL, 'G3DSA:4.10.900.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206643, NULL, 'G3DSA:3.90.180.10:FF:000113', NULL, NULL, 'Geraniol dehydrogenase GeoA', NULL, NULL, NULL, NULL, NULL, 4),
(206644, NULL, 'G3DSA:3.90.180.10:FF:000012', NULL, NULL, 'Quinone oxidoreductase yhdH', NULL, NULL, NULL, NULL, NULL, 4),
(206645, NULL, 'G3DSA:3.40.50.300:FF:005019', NULL, NULL, 'Arsenical pump-driving ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(206646, NULL, 'G3DSA:2.60.40.10:FF:003372', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206647, NULL, 'G3DSA:1.10.1820.10:FF:000002', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(206648, NULL, 'G3DSA:3.40.50.150:FF:000270', NULL, NULL, 'RNA methylase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(206649, NULL, 'G3DSA:1.10.510.10:FF:004004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206650, NULL, 'G3DSA:1.10.10.790:FF:000013', NULL, NULL, 'Splicing factor 3A subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(206651, NULL, 'G3DSA:1.25.40.180:FF:000320', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206652, NULL, 'G3DSA:2.60.40.3210:FF:000025', NULL, NULL, 'Si:ch211-14a17.7', NULL, NULL, NULL, NULL, NULL, 4),
(206653, NULL, 'G3DSA:3.30.200.20:FF:000486', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(206654, NULL, 'G3DSA:3.40.50.720:FF:002464', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206655, NULL, 'G3DSA:3.50.50.60:FF:000148', NULL, NULL, 'NAD-dependent dihydropyrimidine dehydrogenase subunit PreT', NULL, NULL, NULL, NULL, NULL, 4),
(206656, NULL, 'G3DSA:3.40.1380.20:FF:000024', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(206657, NULL, 'G3DSA:3.80.10.10:FF:002046', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206658, NULL, 'G3DSA:4.10.400.10:FF:000140', NULL, NULL, 'Terribly reduced optic lobes, isoform AF', NULL, NULL, NULL, NULL, NULL, 4),
(206659, NULL, 'G3DSA:1.10.150.240:FF:000001', NULL, NULL, 'Haloacid dehalogenase-like hydrolase domain', NULL, NULL, NULL, NULL, NULL, 4),
(206660, NULL, 'G3DSA:3.30.200.20:FF:000014', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(206661, NULL, 'G3DSA:1.10.10.10:FF:000497', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(206662, NULL, 'G3DSA:2.60.98.40:FF:000001', NULL, NULL, 'Major S-layer protein', NULL, NULL, NULL, NULL, NULL, 4),
(206663, NULL, 'G3DSA:1.10.8.10:FF:000338', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206664, NULL, 'G3DSA:3.30.1010.10:FF:000086', NULL, NULL, 'Atr1', NULL, NULL, NULL, NULL, NULL, 4),
(206665, NULL, 'G3DSA:3.40.50.2300:FF:000251', NULL, NULL, 'Autoinducer 2 ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(206666, NULL, 'G3DSA:2.170.270.10:FF:000104', NULL, NULL, 'PR/SET domain 16', NULL, NULL, NULL, NULL, NULL, 4),
(206667, NULL, 'G3DSA:2.40.50.140:FF:001007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206668, NULL, 'G3DSA:3.40.50.10480:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206669, NULL, 'G3DSA:3.10.110.10:FF:000020', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 N', NULL, NULL, NULL, NULL, NULL, 4),
(206670, NULL, 'G3DSA:1.10.418.40:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(206671, NULL, 'G3DSA:3.20.20.80:FF:000709', NULL, NULL, 'Amylo-alpha-1,6-glucosidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(206672, NULL, 'G3DSA:1.20.1530.20:FF:000031', NULL, NULL, 'Glutathione-regulated potassium-efflux system protein KefB', NULL, NULL, NULL, NULL, NULL, 4),
(206673, NULL, 'G3DSA:3.30.40.10:FF:001230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206674, NULL, 'G3DSA:2.40.110.10:FF:000051', NULL, NULL, 'Isovaleryl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(206675, NULL, 'G3DSA:3.30.40.10:FF:000510', NULL, NULL, 'Phosphatidylinositol 3,5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(206676, NULL, 'G3DSA:1.10.287.610:FF:000010', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(206677, NULL, 'G3DSA:3.30.200.20:FF:001442', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206678, NULL, 'G3DSA:2.30.29.30:FF:001138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206679, NULL, 'G3DSA:3.40.50.2000:FF:000796', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206680, NULL, 'G3DSA:1.25.40.10:FF:003394', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(206681, NULL, 'G3DSA:2.60.40.2150:FF:000005', NULL, NULL, 'Interleukin 17 receptor A2', NULL, NULL, NULL, NULL, NULL, 4),
(206682, NULL, 'G3DSA:3.80.10.10:FF:003474', NULL, NULL, 'Leucine-rich repeat transmembrane protein FLRT2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(206683, NULL, 'G3DSA:1.20.120.150:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206684, NULL, 'G3DSA:3.40.50.80:FF:000244', NULL, NULL, 'Os08g0453700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(206685, NULL, 'G3DSA:3.30.160.60:FF:001843', NULL, NULL, 'Zinc finger 30C', NULL, NULL, NULL, NULL, NULL, 4),
(206686, NULL, 'G3DSA:3.30.830.10:FF:000042', NULL, NULL, 'Zinc metalloprotease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(206687, NULL, 'G3DSA:1.20.1560.10:FF:000586', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206688, NULL, 'G3DSA:3.30.365.10:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206689, NULL, 'G3DSA:3.10.129.10:FF:000057', NULL, NULL, 'ATP-binding Cassette (ABC) superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(206690, NULL, 'G3DSA:2.10.25.10:FF:001220', NULL, NULL, 'Usher syndrome 2A (autosomal recessive, mild)', NULL, NULL, NULL, NULL, NULL, 4),
(206691, NULL, 'G3DSA:1.20.1560.10:FF:000013', NULL, NULL, 'ABC transporter C family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(206692, NULL, 'G3DSA:3.30.1330.30:FF:000037', NULL, NULL, '40S ribosomal protein S12', NULL, NULL, NULL, NULL, NULL, 4),
(206693, NULL, 'G3DSA:1.10.510.10:FF:000777', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(206694, NULL, 'G3DSA:1.10.510.10:FF:004476', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206695, NULL, 'G3DSA:2.130.10.10:FF:003024', NULL, NULL, 'PWP2, small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4),
(206696, NULL, 'G3DSA:3.90.70.10:FF:000700', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206697, NULL, 'G3DSA:1.20.1070.10:FF:000577', NULL, NULL, 'Frizzled homolog', NULL, NULL, NULL, NULL, NULL, 4),
(206698, NULL, 'G3DSA:2.120.10.60:FF:000004', NULL, NULL, 'Putative Tricorn-like protease C-terminal subunit', NULL, NULL, NULL, NULL, NULL, 4),
(206699, NULL, 'G3DSA:3.30.450.20:FF:000645', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(206700, NULL, 'G3DSA:3.90.470.10:FF:000023', NULL, NULL, 'Putative 50S ribosomal protein L22, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(206701, NULL, 'G3DSA:3.40.50.970:FF:000072', NULL, NULL, '3D-(3,5/4)-trihydroxycyclohexane-1,2-dione hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(206702, NULL, 'G3DSA:1.10.510.10:FF:003048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206703, NULL, 'G3DSA:1.20.5.110:FF:000039', NULL, NULL, 'Syntaxin-81 like', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(206704, NULL, 'G3DSA:3.90.190.10:FF:000411', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206705, NULL, 'G3DSA:3.30.565.10:FF:000268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206706, NULL, 'G3DSA:3.40.190.80:FF:000067', NULL, NULL, 'Probable inositol-1(Or 4)-monophosphatase / fructose-1,6-bisphosphatase, archaeal-type', NULL, NULL, NULL, NULL, NULL, 4),
(206707, NULL, 'G3DSA:1.25.40.10:FF:001477', NULL, NULL, 'RNA polymerase II transcription elongation factor (Ctr9), putative', NULL, NULL, NULL, NULL, NULL, 4),
(206708, NULL, 'G3DSA:3.40.850.10:FF:000243', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(206709, NULL, 'G3DSA:1.10.510.10:FF:003386', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206710, NULL, 'G3DSA:3.40.50.300:FF:007161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206711, NULL, 'G3DSA:2.10.25.10:FF:001804', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206712, NULL, 'G3DSA:1.10.10.10:FF:001222', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(206713, NULL, 'G3DSA:1.10.510.10:FF:003650', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206714, NULL, 'G3DSA:2.30.29.30:FF:000784', NULL, NULL, 'Rho guanine nucleotide exchange factor 10-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(206715, NULL, 'G3DSA:1.20.1270.10:FF:000030', NULL, NULL, 'Heat shock cognate 70 kDa protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(206716, NULL, 'G3DSA:1.20.1560.10:FF:000906', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206717, NULL, 'G3DSA:1.10.2000.10:FF:000064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206718, NULL, 'G3DSA:2.30.29.30:FF:001402', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206719, NULL, 'G3DSA:2.130.10.10:FF:002304', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206720, NULL, 'G3DSA:4.10.240.10:FF:000149', NULL, NULL, 'Zcf19p', NULL, NULL, NULL, NULL, NULL, 4),
(206721, NULL, 'G3DSA:3.80.10.10:FF:002147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206722, NULL, 'G3DSA:3.40.50.10970:FF:000001', NULL, NULL, 'Sensor histidine kinase RcsC', NULL, NULL, NULL, NULL, NULL, 4),
(206723, NULL, 'G3DSA:3.30.160.20:FF:000089', NULL, NULL, 'Dicer-2', NULL, NULL, NULL, NULL, NULL, 4),
(206724, NULL, 'G3DSA:3.40.50.11780:FF:000002', NULL, NULL, 'Tail sheath monomer', NULL, NULL, NULL, NULL, NULL, 4),
(206725, NULL, 'G3DSA:1.10.150.900:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206726, NULL, 'G3DSA:3.30.1370.210:FF:000040', NULL, NULL, 'LD47649p', NULL, NULL, NULL, NULL, NULL, 4),
(206727, NULL, 'G3DSA:3.30.70.1180:FF:000001', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(206728, NULL, 'G3DSA:3.80.10.10:FF:004300', NULL, NULL, 'Protein NLRC5', NULL, NULL, NULL, NULL, NULL, 4),
(206729, NULL, 'G3DSA:3.40.50.300:FF:003530', NULL, NULL, 'Phosphate acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(206730, NULL, 'G3DSA:2.60.40.10:FF:003271', NULL, NULL, 'Xyloglucan-specific endo-beta-1,4-glucanase BoGH5A', NULL, NULL, NULL, NULL, NULL, 4),
(206731, NULL, 'G3DSA:3.30.505.10:FF:000045', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(206732, NULL, 'G3DSA:2.10.109.10:FF:000032', NULL, NULL, 'Mitochondrial inner membrane protease subunit', NULL, NULL, NULL, NULL, NULL, 4),
(206733, NULL, 'G3DSA:3.10.20.770:FF:000018', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206734, NULL, 'G3DSA:1.10.530.10:FF:000060', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206735, NULL, 'G3DSA:1.20.5.1430:FF:000017', NULL, NULL, 'Microtubule-associated protein, RP/EB family, member 1b', NULL, NULL, NULL, NULL, NULL, 4),
(206736, NULL, 'G3DSA:3.40.50.300:FF:003221', NULL, NULL, 'Nucleosome remodeling complex ATPase subunit (Snf2h)', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(206737, NULL, 'G3DSA:3.80.10.10:FF:004194', NULL, NULL, 'Protein zer-1 homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(206738, NULL, 'G3DSA:3.30.590.50:FF:000006', NULL, NULL, 'Glutamate--cysteine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(206739, NULL, 'G3DSA:1.10.510.10:FF:001502', NULL, NULL, 'Serine/threonine-protein kinase HRK1', NULL, NULL, NULL, NULL, NULL, 4),
(206740, NULL, 'G3DSA:4.10.1240.10:FF:000040', NULL, NULL, 'Hector, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(206741, NULL, 'G3DSA:4.10.860.120:FF:000011', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(206742, NULL, 'G3DSA:1.10.20.10:FF:000323', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206743, NULL, 'G3DSA:3.40.1090.10:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206744, NULL, 'G3DSA:3.40.50.300:FF:002602', NULL, NULL, 'GPN-loop GTPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(206745, NULL, 'G3DSA:1.10.10.2660:FF:000012', NULL, NULL, 'SUMO-activating enzyme subunit', NULL, NULL, NULL, NULL, NULL, 4),
(206746, NULL, 'G3DSA:3.30.160.60:FF:004440', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206747, NULL, 'G3DSA:2.30.30.30:FF:000158', NULL, NULL, 'Mitochondrial elongation factor P', NULL, NULL, NULL, NULL, NULL, 4),
(206748, NULL, 'G3DSA:3.40.30.10:FF:000705', NULL, NULL, 'GLutaRedoXin', NULL, NULL, NULL, NULL, NULL, 4),
(206749, NULL, 'G3DSA:3.30.342.10:FF:000020', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(206750, NULL, 'G3DSA:3.40.33.10:FF:000049', NULL, NULL, 'Gamete and mating-type specific protein A', NULL, NULL, NULL, NULL, NULL, 4),
(206751, NULL, 'G3DSA:3.90.1170.30:FF:000011', NULL, NULL, 'Thymidine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(206752, NULL, 'G3DSA:3.40.50.620:FF:000765', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206753, NULL, 'G3DSA:3.40.50.1820:FF:000399', NULL, NULL, 'YDR444W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(206754, NULL, 'G3DSA:1.10.20.10:FF:000222', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206755, NULL, 'G3DSA:1.10.510.10:FF:000513', NULL, NULL, 'Protein NSP-INTERACTING KINASE 2', NULL, NULL, NULL, NULL, NULL, 4),
(206756, NULL, 'G3DSA:3.40.250.10:FF:000254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206757, NULL, 'G3DSA:3.30.230.130:FF:000003', NULL, NULL, 'Cullin 2', NULL, NULL, NULL, NULL, NULL, 4),
(206758, NULL, 'G3DSA:2.40.10.10:FF:000656', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206759, NULL, 'G3DSA:1.25.40.10:FF:003731', NULL, NULL, 'Peptidylprolyl isomerase D', NULL, NULL, NULL, NULL, NULL, 4),
(206760, NULL, 'G3DSA:2.130.10.10:FF:002776', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206761, NULL, 'G3DSA:1.25.10.10:FF:001857', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206762, NULL, 'G3DSA:3.40.50.300:FF:005828', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206763, NULL, 'G3DSA:4.10.110.20:FF:000002', NULL, NULL, 'Variant surface glycoprotein (VSG), putative', NULL, NULL, NULL, NULL, NULL, 4),
(206764, NULL, 'G3DSA:3.40.50.300:FF:006655', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206765, NULL, 'G3DSA:3.40.50.720:FF:000710', NULL, NULL, 'Serine 3-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(206766, NULL, 'G3DSA:3.30.160.60:FF:003057', NULL, NULL, 'Zinc finger protein 473', NULL, NULL, NULL, NULL, NULL, 4),
(206767, NULL, 'G3DSA:2.40.40.10:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206768, NULL, 'G3DSA:3.40.50.2300:FF:001077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206769, NULL, 'G3DSA:3.30.420.10:FF:000562', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206770, NULL, 'G3DSA:2.10.25.10:FF:000815', NULL, NULL, 'Laminin subunit alpha-3', NULL, NULL, NULL, NULL, NULL, 4),
(206771, NULL, 'G3DSA:2.30.42.10:FF:000298', NULL, NULL, 'Protein lin-7 homolog A', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(206772, NULL, 'G3DSA:2.60.40.10:FF:003428', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206773, NULL, 'G3DSA:3.90.70.10:FF:000745', NULL, NULL, 'Clan CA, family C1, cathepsin B-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(206774, NULL, 'G3DSA:1.25.40.10:FF:002202', NULL, NULL, 'Contig, possible fusion of chromosomes 20 and 34', NULL, NULL, NULL, NULL, NULL, 4),
(206775, NULL, 'G3DSA:1.10.510.10:FF:004375', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206776, NULL, 'G3DSA:2.30.110.10:FF:000115', NULL, NULL, 'Pyridoxamine 5''-phosphate oxidase C1952.08c homolog', NULL, NULL, NULL, NULL, NULL, 4),
(206777, NULL, 'G3DSA:3.40.50.1000:FF:000849', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206778, NULL, 'G3DSA:2.10.25.10:FF:000601', NULL, NULL, 'Neural-cadherin', NULL, NULL, NULL, NULL, NULL, 4),
(206779, NULL, 'G3DSA:3.40.50.300:FF:001276', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(206780, NULL, 'G3DSA:1.10.510.10:FF:003711', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206781, NULL, 'G3DSA:1.25.40.10:FF:004809', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206782, NULL, 'G3DSA:2.20.70.10:FF:000003', NULL, NULL, 'amyloid beta A4 precursor protein-binding family B member 2', NULL, NULL, NULL, NULL, NULL, 4),
(206783, NULL, 'G3DSA:2.30.30.570:FF:000004', NULL, NULL, 'Major vault protein', NULL, NULL, NULL, NULL, NULL, 4),
(206784, NULL, 'G3DSA:3.90.1150.50:FF:000004', NULL, NULL, 'Transcription-repair-coupling factor', NULL, NULL, NULL, NULL, NULL, 4),
(206785, NULL, 'G3DSA:3.30.70.330:FF:000948', NULL, NULL, 'RNA-binding region (RNP1, RRM) containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(206786, NULL, 'G3DSA:1.20.920.30:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206787, NULL, 'G3DSA:1.25.40.10:FF:005075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206788, NULL, 'G3DSA:3.20.20.140:FF:000338', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206789, NULL, 'G3DSA:3.40.50.1360:FF:000019', NULL, NULL, 'Sugar-binding transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(206790, NULL, 'G3DSA:1.20.1720.10:FF:000088', NULL, NULL, 'Bcr/CflA family efflux transporter', NULL, NULL, NULL, NULL, NULL, 4),
(206791, NULL, 'G3DSA:3.80.10.10:FF:002855', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206792, NULL, 'G3DSA:3.30.160.60:FF:002231', NULL, NULL, 'Hangover, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(206793, NULL, 'G3DSA:2.30.40.10:FF:000080', NULL, NULL, 'dihydropyrimidinase-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(206794, NULL, 'G3DSA:2.60.120.330:FF:000145', NULL, NULL, 'Gibberellin 2-beta-dioxygenase 8', NULL, NULL, NULL, NULL, NULL, 4),
(206795, NULL, 'G3DSA:3.40.50.300:FF:001984', NULL, NULL, 'Branched-chain amino acid ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(206796, NULL, 'G3DSA:3.30.450.20:FF:000437', NULL, NULL, 'Photoactive yellow protein', NULL, NULL, NULL, NULL, NULL, 4),
(206797, NULL, 'G3DSA:3.40.50.620:FF:000551', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206798, NULL, 'G3DSA:2.40.50.140:FF:000698', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(206799, NULL, 'G3DSA:3.40.309.10:FF:000008', NULL, NULL, 'Cytosolic 10-formyltetrahydrofolate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(206800, NULL, 'G3DSA:3.30.1370.250:FF:000001', NULL, NULL, '5''-3'' exoribonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(206801, NULL, 'G3DSA:3.30.9.10:FF:000106', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(206802, NULL, 'G3DSA:3.90.1290.10:FF:000036', NULL, NULL, 'AGAP011396-PA', NULL, NULL, NULL, NULL, NULL, 4),
(206803, NULL, 'G3DSA:3.40.1110.10:FF:000445', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206804, NULL, 'G3DSA:1.10.510.10:FF:001250', NULL, NULL, 'Protein kinase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(206805, NULL, 'G3DSA:3.40.50.11350:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206806, NULL, 'G3DSA:3.60.20.10:FF:000013', NULL, NULL, 'Proteasome subunit beta type-5', NULL, NULL, NULL, NULL, NULL, 4),
(206807, NULL, 'G3DSA:1.25.10.10:FF:003083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206808, NULL, 'G3DSA:2.130.10.10:FF:004013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206809, NULL, 'G3DSA:1.50.10.130:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206810, NULL, 'G3DSA:6.10.140.2220:FF:000016', NULL, NULL, 'zinc finger MYND domain-containing protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(206811, NULL, 'G3DSA:1.25.40.10:FF:002775', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(206812, NULL, 'G3DSA:3.30.479.30:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206813, NULL, 'G3DSA:1.20.1110.10:FF:000182', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206814, NULL, 'G3DSA:3.30.450.40:FF:000286', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(206815, NULL, 'G3DSA:2.60.40.10:FF:000449', NULL, NULL, 'cell adhesion molecule 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(206816, NULL, 'G3DSA:3.40.50.10240:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206817, NULL, 'G3DSA:1.20.1250.40:FF:000010', NULL, NULL, 'RNA Polymerase II (B) subunit', NULL, NULL, NULL, NULL, NULL, 4),
(206818, NULL, 'G3DSA:3.30.40.10:FF:000302', NULL, NULL, 'E3 ubiquitin-protein ligase NRDP1', NULL, NULL, NULL, NULL, NULL, 4),
(206819, NULL, 'G3DSA:1.10.730.10:FF:000041', NULL, NULL, 'Methionine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(206820, NULL, 'G3DSA:3.40.50.1000:FF:000597', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206821, NULL, 'G3DSA:1.20.1560.10:FF:000794', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(206822, NULL, 'G3DSA:1.10.287.370:FF:000051', NULL, NULL, 'Prefoldin subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(206823, NULL, 'G3DSA:2.60.120.200:FF:000561', NULL, NULL, 'Os08g0123900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(206824, NULL, 'G3DSA:3.40.50.2000:FF:000588', NULL, NULL, 'Glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(206825, NULL, 'G3DSA:3.50.50.60:FF:000811', NULL, NULL, 'Methylenetetrahydrofolate--tRNA-(uracil-5-)-methyltransferase TrmFO', NULL, NULL, NULL, NULL, NULL, 4),
(206826, NULL, 'G3DSA:3.20.20.140:FF:000086', NULL, NULL, 'Adenosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(206827, NULL, 'G3DSA:3.20.20.80:FF:000665', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206828, NULL, 'G3DSA:2.60.40.10:FF:005980', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206829, NULL, 'G3DSA:1.10.630.10:FF:000241', NULL, NULL, 'cytochrome P450 3A31-like', NULL, NULL, NULL, NULL, NULL, 4),
(206830, NULL, 'G3DSA:1.20.1700.10:FF:000002', NULL, NULL, 'Pantothenate kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(206831, NULL, 'G3DSA:1.20.58.60:FF:000868', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206832, NULL, 'G3DSA:3.30.70.330:FF:002943', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206833, NULL, 'G3DSA:3.40.50.720:FF:001211', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(206834, NULL, 'G3DSA:2.60.40.10:FF:003063', NULL, NULL, 'Myotactin form B', NULL, NULL, NULL, NULL, NULL, 4),
(206835, NULL, 'G3DSA:3.40.50.150:FF:001242', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206836, NULL, 'G3DSA:1.25.40.10:FF:000757', NULL, NULL, 'Os10g0501300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(206837, NULL, 'G3DSA:2.130.10.10:FF:001242', NULL, NULL, 'WD repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(206838, NULL, 'G3DSA:2.60.40.10:FF:000657', NULL, NULL, 'Leukemia inhibitory factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(206839, NULL, 'G3DSA:2.40.320.10:FF:000033', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 18', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(206840, NULL, 'G3DSA:1.10.565.10:FF:000100', NULL, NULL, 'Steroid hormone receptor family member cnr14', NULL, NULL, NULL, NULL, NULL, 4),
(206841, NULL, 'G3DSA:1.20.58.860:FF:000005', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase BAP1', NULL, NULL, NULL, NULL, NULL, 4),
(206842, NULL, 'G3DSA:3.40.50.300:FF:005930', NULL, NULL, 'Putative helicase 2', NULL, NULL, NULL, NULL, NULL, 4),
(206843, NULL, 'G3DSA:3.40.1120.10:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206844, NULL, 'G3DSA:3.60.10.10:FF:000187', NULL, NULL, 'Inositol-1,4,5-trisphosphate 5-phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(206845, NULL, 'G3DSA:3.40.50.1100:FF:000172', NULL, NULL, 'Cysteine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(206846, NULL, 'G3DSA:3.20.20.80:FF:000356', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206847, NULL, 'G3DSA:3.30.530.20:FF:000090', NULL, NULL, 'Phosphatidylinositol transfer protein, beta,-like', NULL, NULL, NULL, NULL, NULL, 4),
(206848, NULL, 'G3DSA:3.30.450.20:FF:000280', NULL, NULL, 'Sensor histidine kinase KinD', NULL, NULL, NULL, NULL, NULL, 4),
(206849, NULL, 'G3DSA:1.25.10.20:FF:000017', NULL, NULL, 'Apolipoprotein Bb, tandem duplicate 1', NULL, NULL, NULL, NULL, NULL, 4),
(206850, NULL, 'G3DSA:3.40.50.1000:FF:000496', NULL, NULL, 'Alpha,alpha-trehalose-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(206851, NULL, 'G3DSA:3.40.50.2300:FF:000560', NULL, NULL, 'Clumsy, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(206852, NULL, 'G3DSA:3.30.230.10:FF:000305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206853, NULL, 'G3DSA:3.30.70.60:FF:000004', NULL, NULL, 'Elongation factor 1-beta, putative', NULL, NULL, NULL, NULL, NULL, 4),
(206854, NULL, 'G3DSA:3.40.50.300:FF:005328', NULL, NULL, 'Muscle-specific beta 1 integrin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(206855, NULL, 'G3DSA:1.10.510.10:FF:002222', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206856, NULL, 'G3DSA:2.130.10.10:FF:005177', NULL, NULL, 'WD40-repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(206857, NULL, 'G3DSA:1.20.1250.20:FF:002269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206858, NULL, 'G3DSA:3.60.110.10:FF:000014', NULL, NULL, 'Aliphatic amidase', NULL, NULL, NULL, NULL, NULL, 4),
(206859, NULL, 'G3DSA:3.40.920.10:FF:000007', NULL, NULL, 'Related to MET10-sulfite reductase flavin-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(206860, NULL, 'G3DSA:2.30.180.10:FF:000170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206861, NULL, 'G3DSA:1.20.910.10:FF:000036', NULL, NULL, 'Conserved protein (TenA homolog)', NULL, NULL, NULL, NULL, NULL, 4),
(206862, NULL, 'G3DSA:2.60.40.10:FF:001163', NULL, NULL, 'Sallimus, isoform Q', NULL, NULL, NULL, NULL, NULL, 4),
(206863, NULL, 'G3DSA:1.20.1070.10:FF:000610', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(206864, NULL, 'G3DSA:3.40.640.10:FF:000418', NULL, NULL, 'Serine--pyruvate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(206865, NULL, 'G3DSA:3.30.160.60:FF:003720', NULL, NULL, 'Zinc finger protein 562', NULL, NULL, NULL, NULL, NULL, 4),
(206866, NULL, 'G3DSA:3.30.930.10:FF:000426', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206867, NULL, 'G3DSA:3.30.40.10:FF:001336', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(206868, NULL, 'G3DSA:1.20.1070.10:FF:000155', NULL, NULL, 'diuretic hormone receptor isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(206869, NULL, 'G3DSA:3.80.10.10:FF:002355', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206870, NULL, 'G3DSA:1.25.10.10:FF:003139', NULL, NULL, 'SNF2 superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(206871, NULL, 'G3DSA:3.30.300.20:FF:000078', NULL, NULL, '40S ribosomal protein S3-1', NULL, NULL, NULL, NULL, NULL, 4),
(206872, NULL, 'G3DSA:3.30.190.20:FF:000029', NULL, NULL, '60S ribosomal protein L10a', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(206873, NULL, 'G3DSA:3.20.20.140:FF:000439', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206874, NULL, 'G3DSA:3.40.1360.10:FF:000003', NULL, NULL, 'DNA topoisomerase 6 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(206875, NULL, 'G3DSA:2.40.10.10:FF:000448', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206876, NULL, 'G3DSA:1.10.132.60:FF:000020', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(206877, NULL, 'G3DSA:4.10.280.10:FF:000112', NULL, NULL, 'Hes family bHLH transcription factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(206878, NULL, 'G3DSA:3.40.50.10090:FF:000001', NULL, NULL, 'Bifunctional uroporphyrinogen-III C-methyltransferase/uroporphyrinogen-III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(206879, NULL, 'G3DSA:1.10.287.110:FF:000422', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206880, NULL, 'G3DSA:2.70.170.10:FF:000267', NULL, NULL, 'Gamma-aminobutyric acid (GABA) A receptor, rho 1', NULL, NULL, NULL, NULL, NULL, 4),
(206881, NULL, 'G3DSA:1.20.1050.130:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206882, NULL, 'G3DSA:3.30.559.10:FF:000208', NULL, NULL, 'N-(5-amino-5-carboxypentanoyl)-L-cysteinyl-D-valine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(206883, NULL, 'G3DSA:2.60.40.60:FF:000756', NULL, NULL, 'SET domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(206884, NULL, 'G3DSA:2.10.25.10:FF:001793', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206885, NULL, 'G3DSA:3.30.420.270:FF:000015', NULL, NULL, 'Biopolymer transporter ExbD', NULL, NULL, NULL, NULL, NULL, 4),
(206886, NULL, 'G3DSA:3.40.630.30:FF:000339', NULL, NULL, 'Acetyltransferase, GNAT family family', NULL, NULL, NULL, NULL, NULL, 4),
(206887, NULL, 'G3DSA:3.10.620.30:FF:000008', NULL, NULL, 'Blast:Peptide-N(4)-(N-acetyl-beta-glucosaminyl)asparagine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(206888, NULL, 'G3DSA:1.20.1080.10:FF:000083', NULL, NULL, 'lens fiber major intrinsic protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(206889, NULL, 'G3DSA:3.40.50.300:FF:007375', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206890, NULL, 'G3DSA:2.40.50.90:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206891, NULL, 'G3DSA:3.30.160.60:FF:001579', NULL, NULL, 'Crooked legs, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(206892, NULL, 'G3DSA:4.10.1000.10:FF:000044', NULL, NULL, 'Probable E3 ubiquitin-protein ligase makorin-2', NULL, NULL, NULL, NULL, NULL, 4),
(206893, NULL, 'G3DSA:1.20.5.990:FF:000016', NULL, NULL, 'IKK gamma', NULL, NULL, NULL, NULL, NULL, 4),
(206894, NULL, 'G3DSA:3.10.20.90:FF:000308', NULL, NULL, 'bolA-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(206895, NULL, 'G3DSA:2.60.490.10:FF:000001', NULL, NULL, 'P2X purinoceptor', NULL, NULL, NULL, NULL, NULL, 4),
(206896, NULL, 'G3DSA:1.20.120.1760:FF:000012', NULL, NULL, 'sn-1,2-diacylglycerol cholinephosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(206897, NULL, 'G3DSA:2.70.98.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206898, NULL, 'G3DSA:3.80.10.10:FF:000040', NULL, NULL, 'Leucine rich repeats and immunoglobulin like domains 2', NULL, NULL, NULL, NULL, NULL, 4),
(206899, NULL, 'G3DSA:2.30.30.140:FF:000095', NULL, NULL, 'tudor domain-containing protein 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(206900, NULL, 'G3DSA:3.30.70.330:FF:002842', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206901, NULL, 'G3DSA:3.40.850.10:FF:000552', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206902, NULL, 'G3DSA:2.60.40.640:FF:000032', NULL, NULL, 'Arrestin domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(206903, NULL, 'G3DSA:2.60.120.20:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206904, NULL, 'G3DSA:3.40.50.1110:FF:000074', NULL, NULL, 'GPI inositol deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(206905, NULL, 'G3DSA:3.30.160.60:FF:005165', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(206906, NULL, 'G3DSA:1.20.58.60:FF:000093', NULL, NULL, 'dystonin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(206907, NULL, 'G3DSA:1.10.238.10:FF:000060', NULL, NULL, 'Parvalbumin, thymic', NULL, NULL, NULL, NULL, NULL, 4),
(206908, NULL, 'G3DSA:3.30.70.330:FF:000381', NULL, NULL, 'RNA-binding proteins (RRM domain)', NULL, NULL, NULL, NULL, NULL, 4),
(206909, NULL, 'G3DSA:1.10.560.10:FF:000016', NULL, NULL, '60 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(206910, NULL, 'G3DSA:3.40.30.10:FF:000121', NULL, NULL, 'protein disulfide-isomerase TMX3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(206911, NULL, 'G3DSA:2.130.10.10:FF:002670', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206912, NULL, 'G3DSA:1.20.1250.20:FF:000369', NULL, NULL, 'MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(206913, NULL, 'G3DSA:1.25.40.10:FF:004456', NULL, NULL, 'OSM-5', NULL, NULL, NULL, NULL, NULL, 4),
(206914, NULL, 'G3DSA:2.40.50.100:FF:000034', NULL, NULL, 'Spermidine/putrescine import ATP-binding protein PotA', NULL, NULL, NULL, NULL, NULL, 4),
(206915, NULL, 'G3DSA:3.30.200.20:FF:000380', NULL, NULL, 'Eukaryotic translation initiation factor 2 alpha kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(206916, NULL, 'G3DSA:3.40.190.10:FF:000552', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(206917, NULL, 'G3DSA:3.40.50.2300:FF:001313', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206918, NULL, 'G3DSA:3.40.50.300:FF:001776', NULL, NULL, 'MgsA AAA+ ATPase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(206919, NULL, 'G3DSA:4.10.860.10:FF:000005', NULL, NULL, 'UvrABC system protein B', NULL, NULL, NULL, NULL, NULL, 4),
(206920, NULL, 'G3DSA:1.10.510.10:FF:003756', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206921, NULL, 'G3DSA:1.10.1740.10:FF:000046', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206922, NULL, 'G3DSA:1.10.10.60:FF:001231', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206923, NULL, 'G3DSA:3.40.50.300:FF:005475', NULL, NULL, 'ABC-type multidrug transport system, ATPase component', NULL, NULL, NULL, NULL, NULL, 4),
(206924, NULL, 'G3DSA:2.40.100.10:FF:000005', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase G', NULL, NULL, NULL, NULL, NULL, 4),
(206925, NULL, 'G3DSA:1.10.10.10:FF:001722', NULL, NULL, 'Iron (Metal) dependent repressor, DtxR family', NULL, NULL, NULL, NULL, NULL, 4),
(206926, NULL, 'G3DSA:1.25.40.10:FF:004911', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206927, NULL, 'G3DSA:1.25.40.10:FF:005176', NULL, NULL, 'U6 snRNP complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(206928, NULL, 'G3DSA:1.25.10.10:FF:001296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206929, NULL, 'G3DSA:3.20.20.80:FF:000457', NULL, NULL, 'Putative beta-glucosidase 41', NULL, NULL, NULL, NULL, NULL, 4),
(206930, NULL, 'G3DSA:2.40.30.10:FF:000511', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206931, NULL, 'G3DSA:1.10.150.20:FF:000196', NULL, NULL, 'DNA polymerase nu', NULL, NULL, NULL, NULL, NULL, 4),
(206932, NULL, 'G3DSA:2.30.29.30:FF:000076', NULL, NULL, 'TBC1 domain family member 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(206933, NULL, 'G3DSA:1.10.510.10:FF:000322', NULL, NULL, 'Serine/threonine-protein kinase Kist isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(206934, NULL, 'G3DSA:3.90.320.10:FF:000001', NULL, NULL, 'DNA replication helicase Dna2', NULL, NULL, NULL, NULL, NULL, 4),
(206935, NULL, 'G3DSA:2.20.100.10:FF:000004', NULL, NULL, 'Adhesion G protein-coupled receptor B2', NULL, NULL, NULL, NULL, NULL, 4),
(206936, NULL, 'G3DSA:3.90.215.10:FF:000015', NULL, NULL, 'Intelectin 2', NULL, NULL, NULL, NULL, NULL, 4),
(206937, NULL, 'G3DSA:3.40.50.1820:FF:000207', NULL, NULL, 'Alpha/beta-Hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(206938, NULL, 'G3DSA:3.40.630.10:FF:000480', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206939, NULL, 'G3DSA:3.90.1750.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(206940, NULL, 'G3DSA:3.40.50.300:FF:006756', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206941, NULL, 'G3DSA:3.10.580.10:FF:000061', NULL, NULL, 'Hemolysin-like protein containing CBS domains', NULL, NULL, NULL, NULL, NULL, 4),
(206942, NULL, 'G3DSA:1.25.40.10:FF:003630', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(206943, NULL, 'G3DSA:3.20.180.10:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206944, NULL, 'G3DSA:3.30.40.10:FF:002056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206945, NULL, 'G3DSA:3.40.1410.10:FF:000018', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(206946, NULL, 'G3DSA:3.40.50.2000:FF:000487', NULL, NULL, 'N-acylglucosamine 2-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(206947, NULL, 'G3DSA:1.20.5.170:FF:000214', NULL, NULL, 'Voltage-gated hydrogen channel 1', NULL, NULL, NULL, NULL, NULL, 4),
(206948, NULL, 'G3DSA:3.40.50.2000:FF:001105', NULL, NULL, 'UDP-glycosyltransferase 73D1', NULL, NULL, NULL, NULL, NULL, 4),
(206949, NULL, 'G3DSA:3.10.100.10:FF:000093', NULL, NULL, 'GM12442', NULL, NULL, NULL, NULL, NULL, 4),
(206950, NULL, 'G3DSA:3.30.2350.10:FF:000027', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(206951, NULL, 'G3DSA:1.25.10.10:FF:000929', NULL, NULL, 'Importin alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(206952, NULL, 'G3DSA:1.20.1050.10:FF:000047', NULL, NULL, 'Glutathione S-transferase P', NULL, NULL, NULL, NULL, NULL, 4),
(206953, NULL, 'G3DSA:2.40.180.10:FF:000044', NULL, NULL, 'Catalase', NULL, NULL, NULL, NULL, NULL, 4),
(206954, NULL, 'G3DSA:3.80.10.10:FF:000601', NULL, NULL, 'DNA repair protein Rad7, protein', NULL, NULL, NULL, NULL, NULL, 4),
(206955, NULL, 'G3DSA:3.30.70.330:FF:002281', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206956, NULL, 'G3DSA:1.10.287.130:FF:000119', NULL, NULL, 'Unplaced genomic scaffold supercont1.240, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(206957, NULL, 'G3DSA:2.60.40.10:FF:001377', NULL, NULL, 'Matrix remodeling associated 5', NULL, NULL, NULL, NULL, NULL, 4),
(206958, NULL, 'G3DSA:1.20.1560.10:FF:000322', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(206959, NULL, 'G3DSA:1.20.58.1120:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206960, NULL, 'G3DSA:3.40.1110.10:FF:000092', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(206961, NULL, 'G3DSA:1.10.287.70:FF:000792', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206962, NULL, 'G3DSA:1.10.287.3990:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206963, NULL, 'G3DSA:1.10.540.10:FF:000150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206964, NULL, 'G3DSA:2.40.50.140:FF:001215', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206965, NULL, 'G3DSA:1.10.8.470:FF:000003', NULL, NULL, 'GTP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(206966, NULL, 'G3DSA:2.30.39.10:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206967, NULL, 'G3DSA:1.10.506.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206968, NULL, 'G3DSA:3.30.70.330:FF:001353', NULL, NULL, 'Tar DNA-binding protein homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(206969, NULL, 'G3DSA:3.40.50.300:FF:001512', NULL, NULL, 'Fused isobutyryl-CoA mutase', NULL, NULL, NULL, NULL, NULL, 4),
(206970, NULL, 'G3DSA:1.10.1200.10:FF:000135', NULL, NULL, 'MFS transporter/NRPS-like enzyme, putative (JCVI)', NULL, NULL, NULL, NULL, NULL, 4),
(206971, NULL, 'G3DSA:3.30.50.10:FF:000084', NULL, NULL, 'PPARA', NULL, NULL, NULL, NULL, NULL, 4),
(206972, NULL, 'G3DSA:1.25.40.620:FF:000008', NULL, NULL, 'Glr3962 protein', NULL, NULL, NULL, NULL, NULL, 4),
(206973, NULL, 'G3DSA:1.10.510.10:FF:001603', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(206974, NULL, 'G3DSA:3.30.60.90:FF:000018', NULL, NULL, 'Histone acetyltransferase HAC1', NULL, NULL, NULL, NULL, NULL, 4),
(206975, NULL, 'G3DSA:3.80.10.10:FF:003783', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206976, NULL, 'G3DSA:3.30.420.40:FF:000458', NULL, NULL, '105/110 kDa heat shock protein/ nucleotide-binding domain', NULL, NULL, NULL, NULL, NULL, 4),
(206977, NULL, 'G3DSA:2.60.40.60:FF:000048', NULL, NULL, 'protocadherin-15 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(206978, NULL, 'G3DSA:1.10.490.10:FF:000033', NULL, NULL, 'Globin 2, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(206979, NULL, 'G3DSA:3.30.10.20:FF:000011', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(206980, NULL, 'G3DSA:1.10.3660.10:FF:000012', NULL, NULL, 'Prephenate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(206981, NULL, 'G3DSA:3.40.710.10:FF:000172', NULL, NULL, 'Peptidoglycan D,D-transpeptidase MrdA', NULL, NULL, NULL, NULL, NULL, 4),
(206982, NULL, 'G3DSA:3.80.10.10:FF:002810', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(206983, NULL, 'G3DSA:3.40.50.300:FF:006447', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206984, NULL, 'G3DSA:3.30.450.60:FF:000033', NULL, NULL, 'Coatomer zeta subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(206985, NULL, 'G3DSA:3.30.420.10:FF:000140', NULL, NULL, 'Protein CBG03114', NULL, NULL, NULL, NULL, NULL, 4),
(206986, NULL, 'G3DSA:2.60.40.10:FF:004709', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206987, NULL, 'G3DSA:3.30.300.30:FF:000070', NULL, NULL, 'O-succinylbenzoic acid--CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(206988, NULL, 'G3DSA:1.10.287.1490:FF:000090', NULL, NULL, 'YALI0F02387p', NULL, NULL, NULL, NULL, NULL, 4),
(206989, NULL, 'G3DSA:2.60.120.290:FF:000127', NULL, NULL, 'C-type LECtin', NULL, NULL, NULL, NULL, NULL, 4),
(206990, NULL, 'G3DSA:2.40.50.140:FF:000962', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206991, NULL, 'G3DSA:2.60.120.260:FF:000472', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206992, NULL, 'G3DSA:2.60.120.920:FF:000035', NULL, NULL, 'SplA/ryanodine receptor domain and SOCS box containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(206993, NULL, 'G3DSA:3.40.470.10:FF:000017', NULL, NULL, 'Single-strand-selective monofunctional uracil-DNA glycosylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(206994, NULL, 'G3DSA:1.10.274.100:FF:000011', NULL, NULL, 'DNA-directed RNA polymerase subunit beta''''', NULL, NULL, NULL, NULL, NULL, 4),
(206995, NULL, 'G3DSA:1.25.40.20:FF:001379', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206996, NULL, 'G3DSA:3.30.750.24:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(206997, NULL, 'G3DSA:3.30.70.330:FF:001662', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(206998, NULL, 'G3DSA:2.30.30.40:FF:000150', NULL, NULL, 'Proline-serine-threonine phosphatase interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(206999, NULL, 'G3DSA:3.40.50.720:FF:000446', NULL, NULL, 'Short chain dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(207000, NULL, 'G3DSA:2.70.130.10:FF:000135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207001, NULL, 'G3DSA:2.10.110.10:FF:000355', NULL, NULL, 'Four and a half LIM domains 5', NULL, NULL, NULL, NULL, NULL, 4),
(207002, NULL, 'G3DSA:2.60.40.10:FF:001938', NULL, NULL, 'Transmembrane and immunoglobulin domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(207003, NULL, 'G3DSA:2.150.10.10:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207004, NULL, 'G3DSA:1.20.1070.10:FF:000369', NULL, NULL, 'octopamine receptor Oamb isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(207005, NULL, 'G3DSA:1.20.1070.10:FF:002055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207006, NULL, 'G3DSA:1.10.510.10:FF:000985', NULL, NULL, 'Serine/threonine-protein kinase MARK2', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(207007, NULL, 'G3DSA:3.30.1240.10:FF:000007', NULL, NULL, 'Cof-like hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(207008, NULL, 'G3DSA:3.30.479.20:FF:000048', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(207009, NULL, 'G3DSA:3.40.50.1820:FF:000663', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207010, NULL, 'G3DSA:3.40.50.20:FF:000047', NULL, NULL, 'Probable alpha-L-glutamate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(207011, NULL, 'G3DSA:3.50.50.60:FF:000356', NULL, NULL, 'GDP dissociation inhibitor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207012, NULL, 'G3DSA:3.40.190.10:FF:000771', NULL, NULL, 'Ionotropic receptor 7f', NULL, NULL, NULL, NULL, NULL, 4),
(207013, NULL, 'G3DSA:1.10.150.20:FF:000308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207014, NULL, 'G3DSA:2.30.130.10:FF:000015', NULL, NULL, 'Glutamate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(207015, NULL, 'G3DSA:1.20.5.510:FF:000007', NULL, NULL, 'Ubiquitin-like protein MDY2', NULL, NULL, NULL, NULL, NULL, 4),
(207016, NULL, 'G3DSA:3.30.70.330:FF:002179', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207017, NULL, 'G3DSA:3.30.565.10:FF:000476', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207018, NULL, 'G3DSA:1.25.40.10:FF:001685', NULL, NULL, 'Suppressor of RPS4-RLD 1', NULL, NULL, NULL, NULL, NULL, 4),
(207019, NULL, 'G3DSA:3.30.200.20:FF:000677', NULL, NULL, 'Fibrillarin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207020, NULL, 'G3DSA:1.20.1250.10:FF:000012', NULL, NULL, 'Growth hormone 1', NULL, NULL, NULL, NULL, NULL, 4),
(207021, NULL, 'G3DSA:3.90.930.12:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207022, NULL, 'G3DSA:1.25.10.10:FF:000677', NULL, NULL, 'DnaJ subfamily C member', NULL, NULL, NULL, NULL, NULL, 4),
(207023, NULL, 'G3DSA:3.40.50.10860:FF:000069', NULL, NULL, 'C1-tetrahydrofolate synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207024, NULL, 'G3DSA:3.30.200.20:FF:002178', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207025, NULL, 'G3DSA:3.80.10.10:FF:000910', NULL, NULL, 'MDIS1-interacting receptor like kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(207026, NULL, 'G3DSA:3.60.20.40:FF:000011', NULL, NULL, 'Gamma-glutamyltransferase 5a', NULL, NULL, NULL, NULL, NULL, 4),
(207027, NULL, 'G3DSA:3.30.40.10:FF:002308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207028, NULL, 'G3DSA:3.30.40.10:FF:000408', NULL, NULL, 'E3 ubiquitin-protein ligase RNF114', NULL, NULL, NULL, NULL, NULL, 4),
(207029, NULL, 'G3DSA:2.60.120.10:FF:000401', NULL, NULL, 'Sulfate permease', NULL, NULL, NULL, NULL, NULL, 4),
(207030, NULL, 'G3DSA:3.40.50.450:FF:000017', NULL, NULL, 'Raw, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(207031, NULL, 'G3DSA:3.40.50.150:FF:000034', NULL, NULL, 'Protein arginine N-methyltransferase 3', NULL, NULL, NULL, NULL, NULL, 4),
(207032, NULL, 'G3DSA:3.30.200.20:FF:001189', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207033, NULL, 'G3DSA:3.40.50.300:FF:007352', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207034, NULL, 'G3DSA:4.10.240.10:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207035, NULL, 'G3DSA:3.10.20.320:FF:000001', NULL, NULL, 'Muramidase-released protein', NULL, NULL, NULL, NULL, NULL, 4),
(207036, NULL, 'G3DSA:2.30.29.30:FF:000868', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207037, NULL, 'G3DSA:1.10.10.10:FF:000160', NULL, NULL, 'HTH-type transcriptional regulator UlaR', NULL, NULL, NULL, NULL, NULL, 4),
(207038, NULL, 'G3DSA:1.10.1070.11:FF:000097', NULL, NULL, 'Ataxia telangiectasia mutated, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207039, NULL, 'G3DSA:3.30.420.10:FF:000371', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207040, NULL, 'G3DSA:3.30.70.330:FF:000925', NULL, NULL, 'Nucleolar protein 12', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(207041, NULL, 'G3DSA:3.10.400.20:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207042, NULL, 'G3DSA:3.40.50.720:FF:000469', NULL, NULL, 'SDR family oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(207043, NULL, 'G3DSA:2.60.40.60:FF:000503', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207044, NULL, 'G3DSA:1.25.40.10:FF:002539', NULL, NULL, 'Embryo specific2', NULL, NULL, NULL, NULL, NULL, 4),
(207045, NULL, 'G3DSA:1.50.40.10:FF:000210', NULL, NULL, 'Mitochondrial succinate-fumarate transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(207046, NULL, 'G3DSA:1.25.40.10:FF:005092', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g15510, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(207047, NULL, 'G3DSA:1.10.510.10:FF:001047', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(207048, NULL, 'G3DSA:3.40.1190.20:FF:000077', NULL, NULL, 'Adenosine kinase b', NULL, NULL, NULL, NULL, NULL, 4),
(207049, NULL, 'G3DSA:2.70.98.30:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207050, NULL, 'G3DSA:3.30.70.270:FF:000093', NULL, NULL, 'Sensor domain-containing diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(207051, NULL, 'G3DSA:2.40.50.140:FF:000832', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207052, NULL, 'G3DSA:1.10.10.1100:FF:000005', NULL, NULL, 'Bacterioferritin', NULL, NULL, NULL, NULL, NULL, 4),
(207053, NULL, 'G3DSA:4.10.640.10:FF:000011', NULL, NULL, '28S ribosomal protein S18a, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(207054, NULL, 'G3DSA:1.20.1250.20:FF:000588', NULL, NULL, 'Major Facilitator Superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(207055, NULL, 'G3DSA:3.40.30.10:FF:001077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207056, NULL, 'G3DSA:3.30.70.330:FF:001437', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207057, NULL, 'G3DSA:3.30.420.610:FF:000016', NULL, NULL, 'Tudor domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(207058, NULL, 'G3DSA:1.20.1050.10:FF:000278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207059, NULL, 'G3DSA:3.10.20.340:FF:000007', NULL, NULL, 'Arginine biosynthesis bifunctional protein ArgJ', NULL, NULL, NULL, NULL, NULL, 4),
(207060, NULL, 'G3DSA:3.40.50.1100:FF:000301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207061, NULL, 'G3DSA:1.25.40.10:FF:004147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207062, NULL, 'G3DSA:2.130.10.10:FF:000989', NULL, NULL, 'Ribosome biogenesis protein WDR12 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(207063, NULL, 'G3DSA:3.80.10.10:FF:000146', NULL, NULL, 'podocan isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(207064, NULL, 'G3DSA:3.40.50.12780:FF:000173', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207065, NULL, 'G3DSA:3.90.1580.10:FF:000036', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207066, NULL, 'G3DSA:3.50.50.60:FF:001429', NULL, NULL, 'Probable lysine-specific histone demethylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(207067, NULL, 'G3DSA:2.20.50.20:FF:000016', NULL, NULL, 'Apolipophorins-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(207068, NULL, 'G3DSA:1.10.510.10:FF:000058', NULL, NULL, 'Receptor-like protein kinase FERONIA', NULL, NULL, NULL, NULL, NULL, 4),
(207069, NULL, 'G3DSA:2.60.40.10:FF:004917', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207070, NULL, 'G3DSA:2.10.25.10:FF:000259', NULL, NULL, 'Coagulation factor VII', NULL, NULL, NULL, NULL, NULL, 4),
(207071, NULL, 'G3DSA:3.10.100.10:FF:000177', NULL, NULL, 'GD23470', NULL, NULL, NULL, NULL, NULL, 4),
(207072, NULL, 'G3DSA:3.20.20.20:FF:000023', NULL, NULL, 'Dihydropteroate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(207073, NULL, 'G3DSA:1.20.920.10:FF:000082', NULL, NULL, 'Similar to Bromodomain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(207074, NULL, 'G3DSA:2.130.10.10:FF:005840', NULL, NULL, 'Plexin D1', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(207075, NULL, 'G3DSA:2.60.120.260:FF:000337', NULL, NULL, 'Netrin G1', NULL, NULL, NULL, NULL, NULL, 4),
(207076, NULL, 'G3DSA:3.30.40.10:FF:001027', NULL, NULL, 'E3 ubiquitin-protein ligase PRT1', NULL, NULL, NULL, NULL, NULL, 4),
(207077, NULL, 'G3DSA:3.40.720.10:FF:000026', NULL, NULL, 'N-sulphoglucosamine sulphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(207078, NULL, 'G3DSA:3.40.50.300:FF:007509', NULL, NULL, 'ABC transporter related', NULL, NULL, NULL, NULL, NULL, 4),
(207079, NULL, 'G3DSA:1.10.630.10:FF:000224', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(207080, NULL, 'G3DSA:1.10.150.670:FF:000012', NULL, NULL, 'Probable crossover junction endonuclease mus81', NULL, NULL, NULL, NULL, NULL, 4),
(207081, NULL, 'G3DSA:3.90.76.10:FF:000011', NULL, NULL, 'Extracellular solute-binding protein, family protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(207082, NULL, 'G3DSA:1.20.80.10:FF:000057', NULL, NULL, 'Band 4.1-like protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(207083, NULL, 'G3DSA:1.50.10.10:FF:000068', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(207084, NULL, 'G3DSA:3.90.1150.10:FF:000442', NULL, NULL, 'Aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(207085, NULL, 'G3DSA:3.40.50.1000:FF:000041', NULL, NULL, 'Phosphoserine phosphatase SerB', NULL, NULL, NULL, NULL, NULL, 4),
(207086, NULL, 'G3DSA:2.30.280.10:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207087, NULL, 'G3DSA:3.30.710.10:FF:000123', NULL, NULL, 'Intracisternal A particle-promoted polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(207088, NULL, 'G3DSA:3.40.50.1820:FF:000516', NULL, NULL, 'Probable oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(207089, NULL, 'G3DSA:3.40.50.10330:FF:000129', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(207090, NULL, 'G3DSA:1.20.1070.10:FF:001330', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(207091, NULL, 'G3DSA:3.30.160.60:FF:004676', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207092, NULL, 'G3DSA:1.10.565.10:FF:000128', NULL, NULL, 'Nuclear receptor', NULL, NULL, NULL, NULL, NULL, 4),
(207093, NULL, 'G3DSA:3.30.1010.10:FF:000114', NULL, NULL, 'Phosphatidylinositol 3-kinase-related protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(207094, NULL, 'G3DSA:3.40.50.2300:FF:000913', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207095, NULL, 'G3DSA:2.40.37.20:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207096, NULL, 'G3DSA:3.20.20.190:FF:000084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207097, NULL, 'G3DSA:3.30.70.260:FF:000096', NULL, NULL, 'Mg2+ transport P-type ATPase MgtC', NULL, NULL, NULL, NULL, NULL, 4),
(207098, NULL, 'G3DSA:2.60.260.20:FF:000077', NULL, NULL, 'DnaJ-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(207099, NULL, 'G3DSA:3.30.1520.10:FF:000080', NULL, NULL, 'Conserved fungal protein', NULL, NULL, NULL, NULL, NULL, 4),
(207100, NULL, 'G3DSA:2.40.50.1060:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207101, NULL, 'G3DSA:1.20.58.1120:FF:000014', NULL, NULL, 'Putative dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(207102, NULL, 'G3DSA:3.40.50.10190:FF:000071', NULL, NULL, 'Pescadillo homolog', NULL, NULL, NULL, NULL, NULL, 4),
(207103, NULL, 'G3DSA:3.40.850.10:FF:000108', NULL, NULL, 'Myosin XIX', NULL, NULL, NULL, NULL, NULL, 4),
(207104, NULL, 'G3DSA:1.20.1250.20:FF:000116', NULL, NULL, 'synaptic vesicular amine transporter isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(207105, NULL, 'G3DSA:3.40.50.300:FF:003985', NULL, NULL, 'DNA repair protein rad-50', NULL, NULL, NULL, NULL, NULL, 4),
(207106, NULL, 'G3DSA:3.40.50.300:FF:004755', NULL, NULL, 'DNA helicase bloom''s syndrome protein C', NULL, NULL, NULL, NULL, NULL, 4),
(207107, NULL, 'G3DSA:3.40.50.2000:FF:000604', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207108, NULL, 'G3DSA:1.25.70.10:FF:000006', NULL, NULL, 'Transcription termination factor MTERF9, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(207109, NULL, 'G3DSA:3.30.900.10:FF:000025', NULL, NULL, 'Autophagy-related protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(207110, NULL, 'G3DSA:3.30.1010.10:FF:000007', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(207111, NULL, 'G3DSA:1.25.40.20:FF:000507', NULL, NULL, 'Anion exchange protein', NULL, NULL, NULL, NULL, NULL, 4),
(207112, NULL, 'G3DSA:1.10.8.870:FF:000016', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(207113, NULL, 'G3DSA:1.10.10.350:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207114, NULL, 'G3DSA:3.30.160.60:FF:002787', NULL, NULL, 'AGAP000058-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(207115, NULL, 'G3DSA:3.80.10.10:FF:001102', NULL, NULL, 'Protein phosphatase 2C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207116, NULL, 'G3DSA:3.40.47.10:FF:000244', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207117, NULL, 'G3DSA:3.10.129.10:FF:000260', NULL, NULL, 'Os04g0553300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(207118, NULL, 'G3DSA:1.10.287.110:FF:000113', NULL, NULL, 'DnaJ (Hsp40) homolog, subfamily C, member 28', NULL, NULL, NULL, NULL, NULL, 4),
(207119, NULL, 'G3DSA:2.60.120.200:FF:000584', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207120, NULL, 'G3DSA:3.40.50.300:FF:007728', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207121, NULL, 'G3DSA:3.40.462.40:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207122, NULL, 'G3DSA:2.60.120.590:FF:000071', NULL, NULL, 'AlkB homolog 3, alpha-ketoglutarate-dependent dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(207123, NULL, 'G3DSA:4.10.400.10:FF:000123', NULL, NULL, 'low-density lipoprotein receptor-related protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(207124, NULL, 'G3DSA:1.10.238.180:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207125, NULL, 'G3DSA:2.130.10.10:FF:005733', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207126, NULL, 'G3DSA:3.40.250.10:FF:000231', NULL, NULL, 'Probable 3-mercaptopyruvate sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(207127, NULL, 'G3DSA:3.40.50.360:FF:000018', NULL, NULL, 'Sulfite reductase [NADPH] flavoprotein alpha-component', NULL, NULL, NULL, NULL, NULL, 4),
(207128, NULL, 'G3DSA:1.10.472.10:FF:000660', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207129, NULL, 'G3DSA:3.40.50.300:FF:001085', NULL, NULL, 'RNA cytidine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(207130, NULL, 'G3DSA:3.40.50.1820:FF:001135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207131, NULL, 'G3DSA:1.10.510.10:FF:003520', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207132, NULL, 'G3DSA:3.30.310.10:FF:000014', NULL, NULL, 'Beta-adaptin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(207133, NULL, 'G3DSA:2.40.50.100:FF:000135', NULL, NULL, 'TOBE domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(207134, NULL, 'G3DSA:3.40.50.300:FF:004502', NULL, NULL, 'YALI0E16775p', NULL, NULL, NULL, NULL, NULL, 4),
(207135, NULL, 'G3DSA:3.40.190.170:FF:000013', NULL, NULL, 'TRAP dicarboxylate transporter, DctP subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207136, NULL, 'G3DSA:1.25.10.10:FF:000593', NULL, NULL, 'U-box domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(207137, NULL, 'G3DSA:3.60.21.10:FF:000212', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(207138, NULL, 'G3DSA:3.40.50.10140:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207139, NULL, 'G3DSA:1.10.8.60:FF:000319', NULL, NULL, 'ORC1-type DNA replication protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(207140, NULL, 'G3DSA:3.40.120.10:FF:000042', NULL, NULL, 'Phosphoglucomutase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207141, NULL, 'G3DSA:3.50.7.10:FF:000063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(207142, NULL, 'G3DSA:2.130.10.10:FF:003951', NULL, NULL, 'Tomosyn-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(207143, NULL, 'G3DSA:1.10.3430.10:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207144, NULL, 'G3DSA:1.25.10.10:FF:000121', NULL, NULL, 'Protein MOR1', NULL, NULL, NULL, NULL, NULL, 4),
(207145, NULL, 'G3DSA:1.10.238.150:FF:000003', NULL, NULL, 'Cytokinesis protein SepA', NULL, NULL, NULL, NULL, NULL, 4),
(207146, NULL, 'G3DSA:3.30.70.330:FF:001218', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(207147, NULL, 'G3DSA:1.10.1040.50:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207148, NULL, 'G3DSA:3.30.870.10:FF:000179', NULL, NULL, 'Phospholipase D/Transphosphatidylase', NULL, NULL, NULL, NULL, NULL, 4),
(207149, NULL, 'G3DSA:3.40.50.1820:FF:000623', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(207150, NULL, 'G3DSA:2.60.300.12:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207151, NULL, 'G3DSA:2.60.40.10:FF:001247', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(207152, NULL, 'G3DSA:1.10.220.150:FF:000047', NULL, NULL, 'arf-GAP domain and FG repeat-containing protein 1 isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(207153, NULL, 'G3DSA:3.30.160.60:FF:001803', NULL, NULL, 'Zinc finger protein 667', NULL, NULL, NULL, NULL, NULL, 4),
(207154, NULL, 'G3DSA:3.30.70.330:FF:000818', NULL, NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(207155, NULL, 'G3DSA:1.20.1250.20:FF:002050', NULL, NULL, 'Monocarboxylate transporter 12-B-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(207156, NULL, 'G3DSA:3.40.390.10:FF:000180', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207157, NULL, 'G3DSA:1.20.1540.10:FF:000023', NULL, NULL, 'Peptidase, S54 family', NULL, NULL, NULL, NULL, NULL, 4),
(207158, NULL, 'G3DSA:1.10.1510.10:FF:000001', NULL, NULL, 'Glutamyl-tRNA amidotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(207159, NULL, 'G3DSA:1.20.140.10:FF:000095', NULL, NULL, 'Acyl-CoA dehydrogenase FadE32', NULL, NULL, NULL, NULL, NULL, 4),
(207160, NULL, 'G3DSA:2.60.40.1180:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207161, NULL, 'G3DSA:1.10.1040.30:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207162, NULL, 'G3DSA:3.50.50.60:FF:000620', NULL, NULL, 'Dimethylaniline monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(207163, NULL, 'G3DSA:1.10.472.10:FF:000188', NULL, NULL, 'PCL5p Cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(207164, NULL, 'G3DSA:2.120.10.30:FF:000377', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207165, NULL, 'G3DSA:3.30.342.10:FF:000043', NULL, NULL, 'DNA polymerase zeta catalytic subunit-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(207166, NULL, 'G3DSA:2.60.40.10:FF:003619', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207167, NULL, 'G3DSA:3.10.50.40:FF:000037', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(207168, NULL, 'G3DSA:1.20.1280.50:FF:000273', NULL, NULL, 'ELM2 domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(207169, NULL, 'G3DSA:2.170.16.10:FF:000028', NULL, NULL, 'NAD(P)(+)--arginine ADP-ribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(207170, NULL, 'G3DSA:3.30.230.10:FF:000069', NULL, NULL, 'Probable phosphomevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(207171, NULL, 'G3DSA:3.40.50.12780:FF:000066', NULL, NULL, 'Probable fatty-acid-CoA ligase fadD6', NULL, NULL, NULL, NULL, NULL, 4),
(207172, NULL, 'G3DSA:1.25.10.10:FF:001902', NULL, NULL, 'YALI0E28371p', NULL, NULL, NULL, NULL, NULL, 4),
(207173, NULL, 'G3DSA:2.10.50.30:FF:000014', NULL, NULL, 'Vomeronasal 2, receptor 8', NULL, NULL, NULL, NULL, NULL, 4),
(207174, NULL, 'G3DSA:3.30.420.390:FF:000006', NULL, NULL, 'DNA polymerase gamma, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(207175, NULL, 'G3DSA:1.20.1310.20:FF:000048', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(207176, NULL, 'G3DSA:3.10.20.90:FF:000090', NULL, NULL, 'Kinesin-like calmodulin-binding protein (ZWICHEL)', NULL, NULL, NULL, NULL, NULL, 4),
(207177, NULL, 'G3DSA:1.10.3210.10:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207178, NULL, 'G3DSA:3.90.25.10:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207179, NULL, 'G3DSA:2.60.120.260:FF:000556', NULL, NULL, 'von Willebrand factor D and EGF domains', NULL, NULL, NULL, NULL, NULL, 4),
(207180, NULL, 'G3DSA:1.25.40.10:FF:004675', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207181, NULL, 'G3DSA:3.30.9.10:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207182, NULL, 'G3DSA:1.20.1250.20:FF:001414', NULL, NULL, 'Slr0616 protein', NULL, NULL, NULL, NULL, NULL, 4),
(207183, NULL, 'G3DSA:3.90.70.10:FF:000037', NULL, NULL, 'Tubulointerstitial nephritis antigen-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(207184, NULL, 'G3DSA:1.10.287.70:FF:000691', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207185, NULL, 'G3DSA:3.40.850.10:FF:000327', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(207186, NULL, 'G3DSA:3.50.30.30:FF:000166', NULL, NULL, 'Glr3087 protein', NULL, NULL, NULL, NULL, NULL, 4),
(207187, NULL, 'G3DSA:2.130.10.10:FF:002967', NULL, NULL, 'WD-40 repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(207188, NULL, 'G3DSA:3.80.10.10:FF:003558', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207189, NULL, 'G3DSA:3.10.50.40:FF:000161', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(207190, NULL, 'G3DSA:3.40.50.300:FF:003457', NULL, NULL, 'ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(207191, NULL, 'G3DSA:2.60.40.640:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207192, NULL, 'G3DSA:3.30.40.10:FF:002191', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(207193, NULL, 'G3DSA:3.90.550.50:FF:000165', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(207194, NULL, 'G3DSA:3.30.70.260:FF:000101', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(207195, NULL, 'G3DSA:3.80.10.10:FF:001630', NULL, NULL, 'Si:ch73-286h23.4', NULL, NULL, NULL, NULL, NULL, 4),
(207196, NULL, 'G3DSA:3.80.10.10:FF:001321', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(207197, NULL, 'G3DSA:3.80.10.10:FF:004047', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(207198, NULL, 'G3DSA:3.40.50.300:FF:003766', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207199, NULL, 'G3DSA:1.25.40.10:FF:001269', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g56310', NULL, NULL, NULL, NULL, NULL, 4),
(207200, NULL, 'G3DSA:1.10.720.30:FF:000029', NULL, NULL, 'Neurofilament medium polypeptide, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207201, NULL, 'G3DSA:2.30.30.140:FF:000331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207202, NULL, 'G3DSA:1.20.1250.20:FF:001105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207203, NULL, 'G3DSA:1.20.5.110:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207204, NULL, 'G3DSA:3.30.70.330:FF:002382', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207205, NULL, 'G3DSA:1.10.238.10:FF:000161', NULL, NULL, 'EF-hand calcium-binding domain-containing protein 7 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(207206, NULL, 'G3DSA:2.40.128.20:FF:000010', NULL, NULL, 'Prostaglandin-H2 D-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(207207, NULL, 'G3DSA:3.40.50.150:FF:000253', NULL, NULL, 'Cephalosporin hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(207208, NULL, 'G3DSA:3.60.40.10:FF:000262', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(207209, NULL, 'G3DSA:1.25.40.20:FF:001126', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(207210, NULL, 'G3DSA:1.20.80.60:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207211, NULL, 'G3DSA:3.10.110.10:FF:000256', NULL, NULL, 'Ubiquitin carrier protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(207212, NULL, 'G3DSA:1.20.5.170:FF:000097', NULL, NULL, 'Beaded filament structural protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(207213, NULL, 'G3DSA:1.20.140.10:FF:000090', NULL, NULL, 'Short/branched chain specific acyl-CoA dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(207214, NULL, 'G3DSA:4.10.280.10:FF:000011', NULL, NULL, 'Aryl hydrocarbon receptor nuclear translocator 2', NULL, NULL, NULL, NULL, NULL, 4),
(207215, NULL, 'G3DSA:1.10.630.10:FF:000477', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207216, NULL, 'G3DSA:1.25.40.120:FF:000100', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207217, NULL, 'G3DSA:2.60.40.10:FF:003299', NULL, NULL, 'DLEC1, cilia and flagella associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(207218, NULL, 'G3DSA:2.60.40.150:FF:000082', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(207219, NULL, 'G3DSA:3.30.300.30:FF:000093', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(207220, NULL, 'G3DSA:3.30.710.10:FF:000342', NULL, NULL, 'BTB/POZ domain/Regulator of chromosome condensation (RCC1) repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207221, NULL, 'G3DSA:1.20.1740.10:FF:000004', NULL, NULL, 'Sodium:alanine symporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(207222, NULL, 'G3DSA:1.20.1250.20:FF:001993', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(207223, NULL, 'G3DSA:2.130.10.10:FF:001478', NULL, NULL, 'Cytoplasmic dynein 1 intermediate chain', NULL, NULL, NULL, NULL, NULL, 4),
(207224, NULL, 'G3DSA:3.90.1260.10:FF:000017', NULL, NULL, 'Argininosuccinate synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207225, NULL, 'G3DSA:2.60.40.10:FF:003647', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207226, NULL, 'G3DSA:3.30.420.60:FF:000014', NULL, NULL, 'YALI0B20658p', NULL, NULL, NULL, NULL, NULL, 4),
(207227, NULL, 'G3DSA:3.40.720.10:FF:000335', NULL, NULL, 'Iduronate-2-sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(207228, NULL, 'G3DSA:2.40.30.10:FF:000410', NULL, NULL, 'NADPH-dependent diflavin oxidoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(207229, NULL, 'G3DSA:3.40.50.300:FF:001877', NULL, NULL, 'GTP:AMP phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(207230, NULL, 'G3DSA:1.10.10.440:FF:000037', NULL, NULL, 'Pre-mRNA-processing factor 40', NULL, NULL, NULL, NULL, NULL, 4),
(207231, NULL, 'G3DSA:3.40.1380.20:FF:000007', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(207232, NULL, 'G3DSA:3.30.70.330:FF:002073', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207233, NULL, 'G3DSA:1.25.40.10:FF:000960', NULL, NULL, 'Protein adenylyltransferase fic-1', NULL, NULL, NULL, NULL, NULL, 4),
(207234, NULL, 'G3DSA:3.40.50.2000:FF:000913', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207235, NULL, 'G3DSA:2.130.10.10:FF:001681', NULL, NULL, 'Elongator acetyltransferase complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(207236, NULL, 'G3DSA:2.60.120.260:FF:000028', NULL, NULL, 'Reelin', NULL, NULL, NULL, NULL, NULL, 4),
(207237, NULL, 'G3DSA:3.80.10.10:FF:002069', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(207238, NULL, 'G3DSA:3.30.200.20:FF:002515', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207239, NULL, 'G3DSA:1.10.238.10:FF:001094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207240, NULL, 'G3DSA:3.30.70.2190:FF:000012', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(207241, NULL, 'G3DSA:3.50.30.30:FF:000149', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(207242, NULL, 'G3DSA:1.25.40.10:FF:004220', NULL, NULL, 'Putative cargo-transport protein ypp1', NULL, NULL, NULL, NULL, NULL, 4),
(207243, NULL, 'G3DSA:3.30.1520.10:FF:000052', NULL, NULL, 'Putative SNARE complex subunit (Vam7)', NULL, NULL, NULL, NULL, NULL, 4),
(207244, NULL, 'G3DSA:3.30.160.60:FF:006019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207245, NULL, 'G3DSA:3.40.50.300:FF:002501', NULL, NULL, 'Rab-like protein 2A', NULL, NULL, NULL, NULL, NULL, 4),
(207246, NULL, 'G3DSA:1.10.10.10:FF:001913', NULL, NULL, 'Heat shock factor protein-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(207247, NULL, 'G3DSA:3.30.710.10:FF:000095', NULL, NULL, 'Kelch-like 11 (Drosophila) (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(207248, NULL, 'G3DSA:1.20.58.1120:FF:000031', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(207249, NULL, 'G3DSA:3.40.50.1700:FF:000037', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207250, NULL, 'G3DSA:3.40.50.720:FF:000339', NULL, NULL, 'Prephenate dehydrogenase [NADP(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(207251, NULL, 'G3DSA:2.60.40.10:FF:004592', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207252, NULL, 'G3DSA:3.10.50.10:FF:000039', NULL, NULL, 'AGAP008562-PA', NULL, NULL, NULL, NULL, NULL, 4),
(207253, NULL, 'G3DSA:2.30.29.30:FF:001032', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207254, NULL, 'G3DSA:3.30.870.10:FF:000174', NULL, NULL, 'Mitochondrial cardiolipin hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(207255, NULL, 'G3DSA:3.40.30.10:FF:000604', NULL, NULL, 'Ubiquitin fusion degradation protein 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207256, NULL, 'G3DSA:3.40.50.300:FF:006863', NULL, NULL, 'Arsenical pump-driving ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(207257, NULL, 'G3DSA:1.10.150.110:FF:000013', NULL, NULL, 'Crossover junction endonuclease MUS81', NULL, NULL, NULL, NULL, NULL, 4),
(207258, NULL, 'G3DSA:3.40.190.10:FF:000119', NULL, NULL, 'glutamate receptor ionotropic, NMDA 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(207259, NULL, 'G3DSA:3.40.50.1000:FF:000260', NULL, NULL, 'Hydrolase, haloacid dehalogenase-like family', NULL, NULL, NULL, NULL, NULL, 4),
(207260, NULL, 'G3DSA:1.25.40.10:FF:003523', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207261, NULL, 'G3DSA:1.10.510.10:FF:003947', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207262, NULL, 'G3DSA:3.40.50.720:FF:002380', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207263, NULL, 'G3DSA:3.50.7.10:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207264, NULL, 'G3DSA:3.20.20.70:FF:000105', NULL, NULL, 'Glycerol uptake operon antiterminator regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(207265, NULL, 'G3DSA:2.130.10.10:FF:000859', NULL, NULL, 'Cytoplasmic dynein intermediate chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207266, NULL, 'G3DSA:1.20.120.1770:FF:000003', NULL, NULL, 'Ferric chelate reductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(207267, NULL, 'G3DSA:3.40.50.300:FF:002024', NULL, NULL, 'ESX-1 secretion system protein EccCb1', NULL, NULL, NULL, NULL, NULL, 4),
(207268, NULL, 'G3DSA:2.60.120.10:FF:000362', NULL, NULL, 'cAMP-dependent protein kinase regulatory chain', NULL, NULL, NULL, NULL, NULL, 4),
(207269, NULL, 'G3DSA:3.40.50.2000:FF:001004', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(207270, NULL, 'G3DSA:1.25.10.10:FF:003010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207271, NULL, 'G3DSA:2.130.10.10:FF:003732', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207272, NULL, 'G3DSA:2.30.29.210:FF:000001', NULL, NULL, 'FACT complex subunit spt16', NULL, NULL, NULL, NULL, NULL, 4),
(207273, NULL, 'G3DSA:3.40.190.10:FF:000299', NULL, NULL, 'Molybdate ABC transporter periplasmic substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(207274, NULL, 'G3DSA:2.30.29.30:FF:000649', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(207275, NULL, 'G3DSA:1.20.1250.20:FF:001886', NULL, NULL, 'Major facilitator superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(207276, NULL, 'G3DSA:3.30.70.360:FF:000041', NULL, NULL, 'Putative Peptidase M20/M25/M40 family', NULL, NULL, NULL, NULL, NULL, 4),
(207277, NULL, 'G3DSA:2.60.120.10:FF:000710', NULL, NULL, 'Cyclic nucleotide-binding', NULL, NULL, NULL, NULL, NULL, 4),
(207278, NULL, 'G3DSA:1.10.418.10:FF:000023', NULL, NULL, 'EH domain-binding protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(207279, NULL, 'G3DSA:3.20.20.70:FF:000027', NULL, NULL, 'Dihydropyrimidine dehydrogenase [NADP(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(207280, NULL, 'G3DSA:2.60.40.200:FF:000029', NULL, NULL, 'Copper/zinc superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(207281, NULL, 'G3DSA:3.80.10.10:FF:001074', NULL, NULL, 'Ubiquitin ligase complex F-box protein GRR1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207282, NULL, 'G3DSA:3.30.70.330:FF:001454', NULL, NULL, 'RNA exonuclease 5', NULL, NULL, NULL, NULL, NULL, 4),
(207283, NULL, 'G3DSA:3.30.720.210:FF:000026', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(207284, NULL, 'G3DSA:3.30.40.10:FF:000403', NULL, NULL, 'RING finger protein 208', NULL, NULL, NULL, NULL, NULL, 4),
(207285, NULL, 'G3DSA:3.40.50.150:FF:000489', NULL, NULL, 'Methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207286, NULL, 'G3DSA:2.60.40.10:FF:005901', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207287, NULL, 'G3DSA:3.40.50.300:FF:002496', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(207288, NULL, 'G3DSA:1.20.1740.10:FF:000111', NULL, NULL, 'Probable general amino acid permease', NULL, NULL, NULL, NULL, NULL, 4),
(207289, NULL, 'G3DSA:3.30.450.40:FF:000078', NULL, NULL, 'Stage II sporulation protein E', NULL, NULL, NULL, NULL, NULL, 4),
(207290, NULL, 'G3DSA:1.20.58.390:FF:000297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207291, NULL, 'G3DSA:3.80.10.10:FF:002939', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', NULL, NULL, NULL, NULL, NULL, 4),
(207292, NULL, 'G3DSA:3.40.50.1820:FF:000640', NULL, NULL, 'Putative carboxypeptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(207293, NULL, 'G3DSA:1.10.600.10:FF:000060', NULL, NULL, 'Terpenoid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(207294, NULL, 'G3DSA:3.40.50.20:FF:000024', NULL, NULL, 'Phosphoribosylaminoimidazole carboxylase family protein / AIR carboxylase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(207295, NULL, 'G3DSA:3.40.50.300:FF:005244', NULL, NULL, 'DNA polymerase III delta prime subunit', NULL, NULL, NULL, NULL, NULL, 4),
(207296, NULL, 'G3DSA:3.30.160.60:FF:004569', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207297, NULL, 'G3DSA:3.10.100.10:FF:000194', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207298, NULL, 'G3DSA:3.30.450.20:FF:000414', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(207299, NULL, 'G3DSA:1.20.1250.20:FF:002033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207300, NULL, 'G3DSA:2.30.29.230:FF:000007', NULL, NULL, 'GTPase activating protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(207301, NULL, 'G3DSA:1.25.10.10:FF:000576', NULL, NULL, 'Binding', NULL, NULL, NULL, NULL, NULL, 4),
(207302, NULL, 'G3DSA:3.30.70.330:FF:000509', NULL, NULL, 'Polyadenylate-binding protein RBP47C isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(207303, NULL, 'G3DSA:3.40.50.300:FF:002838', NULL, NULL, 'Uncharacterized ATPase YjoB', NULL, NULL, NULL, NULL, NULL, 4),
(207304, NULL, 'G3DSA:1.10.510.10:FF:001839', NULL, NULL, 'Cell division control protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207305, NULL, 'G3DSA:3.90.830.10:FF:000006', NULL, NULL, 'Vacuolar protein sorting-associated protein 33A', NULL, NULL, NULL, NULL, NULL, 4),
(207306, NULL, 'G3DSA:3.30.559.10:FF:000080', NULL, NULL, 'Carnitine acyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(207307, NULL, 'G3DSA:3.40.50.1010:FF:000061', NULL, NULL, 'Single-stranded DNA endonuclease (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(207308, NULL, 'G3DSA:1.10.510.10:FF:002986', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207309, NULL, 'G3DSA:3.80.10.10:FF:000702', NULL, NULL, 'Leucine-rich repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(207310, NULL, 'G3DSA:3.40.640.10:FF:000497', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207311, NULL, 'G3DSA:2.60.40.10:FF:005553', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207312, NULL, 'G3DSA:3.30.160.60:FF:002332', NULL, NULL, 'Zinc finger 30C', NULL, NULL, NULL, NULL, NULL, 4),
(207313, NULL, 'G3DSA:3.10.10.10:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207314, NULL, 'G3DSA:1.20.1070.10:FF:000346', NULL, NULL, 'Adrenergic, alpha-2D-, receptor a', NULL, NULL, NULL, NULL, NULL, 4),
(207315, NULL, 'G3DSA:3.90.1150.10:FF:000026', NULL, NULL, 'Pyridoxal phosphate-dependent aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(207316, NULL, 'G3DSA:1.10.10.10:FF:000952', NULL, NULL, '26S proteasome non-ATPase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(207317, NULL, 'G3DSA:3.40.50.2000:FF:000565', NULL, NULL, '1,2-diacylglycerol 3-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(207318, NULL, 'G3DSA:3.20.10.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207319, NULL, 'G3DSA:3.30.160.60:FF:005058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207320, NULL, 'G3DSA:2.60.40.1490:FF:000003', NULL, NULL, 'Anti-silencing function 1B histone chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(207321, NULL, 'G3DSA:1.20.58.150:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207322, NULL, 'G3DSA:3.20.20.100:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207323, NULL, 'G3DSA:3.80.10.10:FF:000141', NULL, NULL, 'Leucine-rich repeat-containing protein 59', NULL, NULL, NULL, NULL, NULL, 4),
(207324, NULL, 'G3DSA:1.20.80.60:FF:000004', NULL, NULL, 'Sorting nexin-17 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(207325, NULL, 'G3DSA:2.40.160.10:FF:000037', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(207326, NULL, 'G3DSA:1.25.40.420:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207327, NULL, 'G3DSA:2.60.40.10:FF:000865', NULL, NULL, 'AXL receptor tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(207328, NULL, 'G3DSA:1.20.1070.10:FF:000841', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(207329, NULL, 'G3DSA:3.10.20.360:FF:000002', NULL, NULL, 'Patronin, isoform M', NULL, NULL, NULL, NULL, NULL, 4),
(207330, NULL, 'G3DSA:1.10.10.60:FF:000848', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207331, NULL, 'G3DSA:3.40.50.300:FF:005374', NULL, NULL, 'mRNA cleavage and polyadenylation factor CLP1', NULL, NULL, NULL, NULL, NULL, 4),
(207332, NULL, 'G3DSA:1.10.8.10:FF:000193', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(207333, NULL, 'G3DSA:2.40.50.90:FF:000070', NULL, NULL, 'Tudor domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(207334, NULL, 'G3DSA:3.30.450.20:FF:000072', NULL, NULL, 'Period circadian protein', NULL, NULL, NULL, NULL, NULL, 4),
(207335, NULL, 'G3DSA:3.40.50.410:FF:000134', NULL, NULL, 'Efk-1', NULL, NULL, NULL, NULL, NULL, 4),
(207336, NULL, 'G3DSA:3.30.40.10:FF:001022', NULL, NULL, 'Structure-specific endonuclease subunit SLX1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(207337, NULL, 'G3DSA:1.20.1070.10:FF:001111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207338, NULL, 'G3DSA:3.40.50.720:FF:001891', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207339, NULL, 'G3DSA:3.30.160.60:FF:004221', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207340, NULL, 'G3DSA:2.60.40.10:FF:005772', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207341, NULL, 'G3DSA:3.30.70.980:FF:000002', NULL, NULL, 'Probable transcriptional regulatory protein YebC', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(207342, NULL, 'G3DSA:3.40.50.1440:FF:000150', NULL, NULL, 'At4g37190', NULL, NULL, NULL, NULL, NULL, 4),
(207343, NULL, 'G3DSA:3.90.1150.10:FF:000335', NULL, NULL, 'Kynureninase', NULL, NULL, NULL, NULL, NULL, 4),
(207344, NULL, 'G3DSA:3.40.50.300:FF:004974', NULL, NULL, 'AIG1 family protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(207345, NULL, 'G3DSA:1.10.10.60:FF:000978', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207346, NULL, 'G3DSA:1.10.490.160:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207347, NULL, 'G3DSA:1.20.1070.10:FF:000711', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207348, NULL, 'G3DSA:1.10.443.10:FF:000019', NULL, NULL, 'Site-specific recombinase, phage integrase family', NULL, NULL, NULL, NULL, NULL, 4),
(207349, NULL, 'G3DSA:3.20.20.70:FF:000555', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207350, NULL, 'G3DSA:1.10.357.70:FF:000011', NULL, NULL, 'TNF alpha induced protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(207351, NULL, 'G3DSA:3.30.450.20:FF:000381', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(207352, NULL, 'G3DSA:3.40.50.410:FF:000281', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(207353, NULL, 'G3DSA:2.60.40.10:FF:004608', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207354, NULL, 'G3DSA:3.40.309.10:FF:000115', NULL, NULL, 'Long-chain acyl-protein thioester reductase', NULL, NULL, NULL, NULL, NULL, 4),
(207355, NULL, 'G3DSA:3.40.50.150:FF:001815', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207356, NULL, 'G3DSA:1.25.40.10:FF:002758', NULL, NULL, 'N-ethylmaleimide-sensitive factor attachment protei', NULL, NULL, NULL, NULL, NULL, 4),
(207357, NULL, 'G3DSA:2.60.40.10:FF:005406', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207358, NULL, 'G3DSA:1.10.472.10:FF:000295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207359, NULL, 'G3DSA:3.40.30.10:FF:000127', NULL, NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(207360, NULL, 'G3DSA:3.40.50.1820:FF:001388', NULL, NULL, 'GPI inositol-deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(207361, NULL, 'G3DSA:3.40.630.70:FF:000008', NULL, NULL, 'Leucyl/phenylalanyl-tRNA--protein transferase', NULL, NULL, NULL, NULL, NULL, 4),
(207362, NULL, 'G3DSA:3.30.160.60:FF:002315', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207363, NULL, 'G3DSA:1.25.40.90:FF:000062', NULL, NULL, 'I/LWEQ domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(207364, NULL, 'G3DSA:2.60.40.10:FF:006025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207365, NULL, 'G3DSA:3.10.110.10:FF:000239', NULL, NULL, 'NEDD8-conjugating enzyme Ubc12', NULL, NULL, NULL, NULL, NULL, 4),
(207366, NULL, 'G3DSA:3.30.230.70:FF:000082', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207367, NULL, 'G3DSA:3.30.40.10:FF:000038', NULL, NULL, 'E3 ubiquitin-protein ligase listerin', NULL, NULL, NULL, NULL, NULL, 4),
(207368, NULL, 'G3DSA:2.60.40.10:FF:005536', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207369, NULL, 'G3DSA:3.30.70.270:FF:000121', NULL, NULL, 'AGAP001404-PA', NULL, NULL, NULL, NULL, NULL, 4),
(207370, NULL, 'G3DSA:2.60.120.230:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207371, NULL, 'G3DSA:3.40.50.300:FF:005683', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(207372, NULL, 'G3DSA:2.60.15.10:FF:000014', NULL, NULL, 'ATP synthase, epsilon chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207373, NULL, 'G3DSA:3.40.50.2300:FF:000357', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(207374, NULL, 'G3DSA:1.20.140.10:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207375, NULL, 'G3DSA:3.40.50.300:FF:001192', NULL, NULL, 'Phosphonate C-P lyase system protein PhnL', NULL, NULL, NULL, NULL, NULL, 4),
(207376, NULL, 'G3DSA:1.25.40.10:FF:004703', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(207377, NULL, 'G3DSA:2.30.29.30:FF:000885', NULL, NULL, 'Rab_C103 protein', NULL, NULL, NULL, NULL, NULL, 4),
(207378, NULL, 'G3DSA:3.90.550.10:FF:000496', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(207379, NULL, 'G3DSA:1.20.1050.10:FF:000148', NULL, NULL, 'hematopoietic prostaglandin D synthase', NULL, NULL, NULL, NULL, NULL, 4),
(207380, NULL, 'G3DSA:1.20.120.810:FF:000006', NULL, NULL, 'Protein CBR-DEB-1, isoform b', NULL, NULL, NULL, NULL, NULL, 4),
(207381, NULL, 'G3DSA:2.60.40.10:FF:001354', NULL, NULL, 'Sallimus, isoform Q', NULL, NULL, NULL, NULL, NULL, 4),
(207382, NULL, 'G3DSA:3.30.1150.10:FF:000017', NULL, NULL, 'Energy transducer TonB', NULL, NULL, NULL, NULL, NULL, 4),
(207383, NULL, 'G3DSA:1.10.472.10:FF:000643', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207384, NULL, 'G3DSA:3.80.10.10:FF:002254', NULL, NULL, 'Leucine-rich repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(207385, NULL, 'G3DSA:3.90.190.10:FF:000310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207386, NULL, 'G3DSA:3.20.20.80:FF:000092', NULL, NULL, 'Probable alpha-L-arabinofuranosidase A', NULL, NULL, NULL, NULL, NULL, 4),
(207387, NULL, 'G3DSA:2.10.60.10:FF:000065', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(207388, NULL, 'G3DSA:1.10.238.180:FF:000001', NULL, NULL, 'Stromal interaction molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(207389, NULL, 'G3DSA:1.25.40.10:FF:003158', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g48250, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(207390, NULL, 'G3DSA:3.20.20.80:FF:000434', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(207391, NULL, 'G3DSA:2.40.30.10:FF:000438', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207392, NULL, 'G3DSA:1.10.8.270:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207393, NULL, 'G3DSA:3.40.850.10:FF:000344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207394, NULL, 'G3DSA:1.10.510.10:FF:002458', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207395, NULL, 'G3DSA:2.10.10.20:FF:000008', NULL, NULL, 'Chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(207396, NULL, 'G3DSA:3.20.20.80:FF:000249', NULL, NULL, 'Counting factor 50', NULL, NULL, NULL, NULL, NULL, 4),
(207397, NULL, 'G3DSA:3.30.70.20:FF:000088', NULL, NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(207398, NULL, 'G3DSA:3.30.160.60:FF:005188', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207399, NULL, 'G3DSA:3.30.230.130:FF:000020', NULL, NULL, 'CULLIN 8', NULL, NULL, NULL, NULL, NULL, 4),
(207400, NULL, 'G3DSA:1.10.400.10:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207401, NULL, 'G3DSA:2.60.200.20:FF:000101', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207402, NULL, 'G3DSA:3.40.50.2000:FF:000695', NULL, NULL, 'Glycosyl transferase family 9', NULL, NULL, NULL, NULL, NULL, 4),
(207403, NULL, 'G3DSA:3.30.160.60:FF:003260', NULL, NULL, 'Transcriptional repressor CTCF', NULL, NULL, NULL, NULL, NULL, 4),
(207404, NULL, 'G3DSA:3.40.1340.10:FF:000013', NULL, NULL, 'RNA polymerase Rpb5, N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(207405, NULL, 'G3DSA:3.40.350.10:FF:000087', NULL, NULL, 'Protein CBG01440', NULL, NULL, NULL, NULL, NULL, 4),
(207406, NULL, 'G3DSA:1.10.565.10:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207407, NULL, 'G3DSA:3.40.1180.10:FF:000039', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207408, NULL, 'G3DSA:2.130.10.10:FF:004884', NULL, NULL, 'WD40 repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(207409, NULL, 'G3DSA:1.10.30.10:FF:000043', NULL, NULL, 'Transcription factor A, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(207410, NULL, 'G3DSA:1.10.510.10:FF:002767', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207411, NULL, 'G3DSA:2.30.110.10:FF:000008', NULL, NULL, 'Flagellar brake protein YcgR', NULL, NULL, NULL, NULL, NULL, 4),
(207412, NULL, 'G3DSA:3.30.420.40:FF:000930', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207413, NULL, 'G3DSA:2.70.170.10:FF:000284', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207414, NULL, 'G3DSA:1.10.10.10:FF:000502', NULL, NULL, 'ORC1-type DNA replication protein', NULL, NULL, NULL, NULL, NULL, 4),
(207415, NULL, 'G3DSA:3.30.160.60:FF:000314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207416, NULL, 'G3DSA:2.60.120.10:FF:000581', NULL, NULL, 'DNR protein', NULL, NULL, NULL, NULL, NULL, 4),
(207417, NULL, 'G3DSA:3.40.30.10:FF:000913', NULL, NULL, 'Uba3-binding protein but1', NULL, NULL, NULL, NULL, NULL, 4),
(207418, NULL, 'G3DSA:1.20.58.60:FF:000520', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207419, NULL, 'G3DSA:2.70.20.40:FF:000001', NULL, NULL, 'Matrix protein', NULL, NULL, NULL, NULL, NULL, 4),
(207420, NULL, 'G3DSA:3.20.20.100:FF:000130', NULL, NULL, 'NADP(+) coupled glycerol dehydrogenase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(207421, NULL, 'G3DSA:1.10.10.10:FF:000974', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(207422, NULL, 'G3DSA:1.25.40.10:FF:002197', NULL, NULL, 'Membrane protein involved in organellar division, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207423, NULL, 'G3DSA:3.60.40.10:FF:000340', NULL, NULL, 'Auxin-responsive protein', NULL, NULL, NULL, NULL, NULL, 4),
(207424, NULL, 'G3DSA:3.30.390.50:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207425, NULL, 'G3DSA:2.30.30.40:FF:000487', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207426, NULL, 'G3DSA:1.10.287.770:FF:000024', NULL, NULL, 'Pickpocket protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(207427, NULL, 'G3DSA:1.25.40.20:FF:001148', NULL, NULL, 'Caskin-1', NULL, NULL, NULL, NULL, NULL, 4),
(207428, NULL, 'G3DSA:2.40.50.140:FF:000012', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(207429, NULL, 'G3DSA:3.40.50.300:FF:007700', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207430, NULL, 'G3DSA:1.20.120.20:FF:000006', NULL, NULL, 'Apolipoprotein A-V', NULL, NULL, NULL, NULL, NULL, 4),
(207431, NULL, 'G3DSA:1.10.287.470:FF:000041', NULL, NULL, 'Multidrug resistance protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207432, NULL, 'G3DSA:3.40.50.300:FF:002810', NULL, NULL, 'Blast:Dynein heavy chain 6, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(207433, NULL, 'G3DSA:3.40.50.10860:FF:000041', NULL, NULL, 'Pentafunctional AROM polypeptide, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207434, NULL, 'G3DSA:2.60.120.260:FF:000101', NULL, NULL, 'uncharacterized protein LOC108094628 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(207435, NULL, 'G3DSA:3.40.50.300:FF:008206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207436, NULL, 'G3DSA:3.30.465.10:FF:000120', NULL, NULL, 'FAD linked oxidase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(207437, NULL, 'G3DSA:2.10.25.10:FF:000023', NULL, NULL, 'Fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(207438, NULL, 'G3DSA:1.10.1520.10:FF:000058', NULL, NULL, 'Endoribonuclease Dicer-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(207439, NULL, 'G3DSA:3.40.50.720:FF:002363', NULL, NULL, 'S-adenosylhomocysteine hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207440, NULL, 'G3DSA:1.10.10.750:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207441, NULL, 'G3DSA:3.30.160.60:FF:001348', NULL, NULL, 'Zinc finger protein 646', NULL, NULL, NULL, NULL, NULL, 4),
(207442, NULL, 'G3DSA:2.30.29.30:FF:000104', NULL, NULL, 'collagen type IV alpha-3-binding protein-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(207443, NULL, 'G3DSA:1.20.1510.10:FF:000066', NULL, NULL, 'Cation efflux protein/ zinc transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207444, NULL, 'G3DSA:2.130.10.10:FF:004120', NULL, NULL, 'Os02g0307200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(207445, NULL, 'G3DSA:1.20.1340.10:FF:000002', NULL, NULL, 'Tryptophan decarboxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(207446, NULL, 'G3DSA:2.10.25.10:FF:001113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207447, NULL, 'G3DSA:3.80.10.10:FF:002485', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207448, NULL, 'G3DSA:2.60.40.2700:FF:000001', NULL, NULL, 'Transmembrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(207449, NULL, 'G3DSA:2.40.70.10:FF:000295', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207450, NULL, 'G3DSA:1.10.150.810:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207451, NULL, 'G3DSA:3.20.20.70:FF:000336', NULL, NULL, 'Triosephosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(207452, NULL, 'G3DSA:2.60.40.1080:FF:000015', NULL, NULL, 'Bacterial Ig-like domain (Group 2)', NULL, NULL, NULL, NULL, NULL, 4),
(207453, NULL, 'G3DSA:2.40.50.100:FF:000051', NULL, NULL, '50S ribosomal protein L27', NULL, NULL, NULL, NULL, NULL, 4),
(207454, NULL, 'G3DSA:3.40.190.10:FF:000535', NULL, NULL, 'ABC transporter, periplasmic substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(207455, NULL, 'G3DSA:1.10.12.10:FF:000012', NULL, NULL, 'Phenylacetate degradation enoyl-CoA hydratase PaaB', NULL, NULL, NULL, NULL, NULL, 4),
(207456, NULL, 'G3DSA:3.30.70.270:FF:000014', NULL, NULL, 'DNA polymerase kappa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(207457, NULL, 'G3DSA:3.30.60.90:FF:000046', NULL, NULL, 'Transcriptional adapter', NULL, NULL, NULL, NULL, NULL, 4),
(207458, NULL, 'G3DSA:3.80.10.10:FF:001866', NULL, NULL, 'Os06g0587900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(207459, NULL, 'G3DSA:3.30.450.30:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207460, NULL, 'G3DSA:3.30.160.60:FF:003496', NULL, NULL, 'Zinc finger protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(207461, NULL, 'G3DSA:2.60.120.10:FF:000053', NULL, NULL, 'Homogentisate 1,2-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(207462, NULL, 'G3DSA:2.40.50.120:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207463, NULL, 'G3DSA:3.80.10.10:FF:002378', NULL, NULL, 'Protein CBR-EGG-6', NULL, NULL, NULL, NULL, NULL, 4),
(207464, NULL, 'G3DSA:3.30.430.20:FF:000054', NULL, NULL, 'Putative cysteine-rich receptor-like protein kinase 43', NULL, NULL, NULL, NULL, NULL, 4),
(207465, NULL, 'G3DSA:3.40.50.300:FF:005458', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207466, NULL, 'G3DSA:2.40.50.90:FF:000154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207467, NULL, 'G3DSA:2.30.42.10:FF:000067', NULL, NULL, 'Golgi-associated PDZ and coiled-coil motif-containing protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(207468, NULL, 'G3DSA:2.120.10.30:FF:000580', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207469, NULL, 'G3DSA:3.30.2010.30:FF:000002', NULL, NULL, 'Putative aminopeptidase N', NULL, NULL, NULL, NULL, NULL, 4),
(207470, NULL, 'G3DSA:2.30.29.30:FF:000093', NULL, NULL, 'SET binding factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(207471, NULL, 'G3DSA:1.10.472.80:FF:000080', NULL, NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(207472, NULL, 'G3DSA:1.10.287.1150:FF:000010', NULL, NULL, 'Oxoglutarate dehydrogenase (Succinyl-transferring), E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(207473, NULL, 'G3DSA:3.60.150.10:FF:000005', NULL, NULL, 'Chorismate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(207474, NULL, 'G3DSA:1.20.1270.60:FF:000213', NULL, NULL, 'Chromosome 13 SCAF14555, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(207475, NULL, 'G3DSA:1.10.10.10:FF:001121', NULL, NULL, 'DNA-binding transcriptional activator', NULL, NULL, NULL, NULL, NULL, 4),
(207476, NULL, 'G3DSA:2.30.40.10:FF:000136', NULL, NULL, 'Guanine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(207477, NULL, 'G3DSA:3.30.460.90:FF:000003', NULL, NULL, 'MB21D2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(207478, NULL, 'G3DSA:3.30.800.10:FF:000006', NULL, NULL, '1-phosphatidylinositol-3-phosphate 5-kinase FAB1B', NULL, NULL, NULL, NULL, NULL, 4),
(207479, NULL, 'G3DSA:2.70.150.10:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207480, NULL, 'G3DSA:1.25.40.530:FF:000009', NULL, NULL, 'Myosin XVA', NULL, NULL, NULL, NULL, NULL, 4),
(207481, NULL, 'G3DSA:1.20.1070.10:FF:000239', NULL, NULL, 'G-protein-coupled receptor 65', NULL, NULL, NULL, NULL, NULL, 4),
(207482, NULL, 'G3DSA:2.60.40.10:FF:000882', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(207483, NULL, 'G3DSA:3.40.50.2300:FF:001285', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207484, NULL, 'G3DSA:3.40.50.10130:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207485, NULL, 'G3DSA:2.10.70.10:FF:000127', NULL, NULL, 'Hig-anchoring scaffold protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(207486, NULL, 'G3DSA:3.70.10.10:FF:000006', NULL, NULL, 'Checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(207487, NULL, 'G3DSA:1.50.40.10:FF:000025', NULL, NULL, 'mitochondrial folate transporter/carrier', NULL, NULL, NULL, NULL, NULL, 4),
(207488, NULL, 'G3DSA:3.20.20.150:FF:000083', NULL, NULL, 'Protein arginine N-methyltransferase 1.5', NULL, NULL, NULL, NULL, NULL, 4),
(207489, NULL, 'G3DSA:3.40.50.2000:FF:000256', NULL, NULL, 'GDP-Man:Man(3)GlcNAc(2)-PP-Dol alpha-1,2-mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(207490, NULL, 'G3DSA:1.10.3730.20:FF:000004', NULL, NULL, 'QacE family quaternary ammonium compound efflux SMR transporter', NULL, NULL, NULL, NULL, NULL, 4),
(207491, NULL, 'G3DSA:1.20.58.60:FF:000413', NULL, NULL, 'AGAP009554-PA', NULL, NULL, NULL, NULL, NULL, 4),
(207492, NULL, 'G3DSA:3.40.50.10810:FF:000178', NULL, NULL, 'Helicase superfamily, c-terminal domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(207493, NULL, 'G3DSA:3.30.160.60:FF:001950', NULL, NULL, 'Zinc finger protein 518B', NULL, NULL, NULL, NULL, NULL, 4),
(207494, NULL, 'G3DSA:1.20.1070.10:FF:000150', NULL, NULL, 'probable G-protein coupled receptor 34', NULL, NULL, NULL, NULL, NULL, 4),
(207495, NULL, 'G3DSA:1.10.150.20:FF:000224', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(207496, NULL, 'G3DSA:3.40.720.10:FF:000104', NULL, NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase-like', NULL, NULL, NULL, NULL, NULL, 4),
(207497, NULL, 'G3DSA:1.20.1560.10:FF:000693', NULL, NULL, 'ATP-binding cassette transporter, subfamily C, member 10, group MRP protein PpABCC10', NULL, NULL, NULL, NULL, NULL, 4),
(207498, NULL, 'G3DSA:2.130.10.10:FF:003501', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207499, NULL, 'G3DSA:1.10.287.70:FF:000775', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207500, NULL, 'G3DSA:1.10.10.60:FF:000034', NULL, NULL, 'HTH-type transcriptional repressor FabR', NULL, NULL, NULL, NULL, NULL, 4),
(207501, NULL, 'G3DSA:1.10.510.10:FF:003279', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207502, NULL, 'G3DSA:3.40.50.150:FF:001473', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207503, NULL, 'G3DSA:4.10.400.10:FF:000229', NULL, NULL, 'Low-density lipoprotein receptor-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(207504, NULL, 'G3DSA:1.25.40.10:FF:002674', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207505, NULL, 'G3DSA:3.90.245.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207506, NULL, 'G3DSA:3.30.2350.20:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207507, NULL, 'G3DSA:3.30.70.330:FF:000257', NULL, NULL, 'CCR4-NOT core complex subunit Not4', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(207508, NULL, 'G3DSA:3.40.50.2000:FF:000149', NULL, NULL, 'Glycogen phosphorylase, muscle form', NULL, NULL, NULL, NULL, NULL, 4),
(207509, NULL, 'G3DSA:1.20.1250.20:FF:002286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207510, NULL, 'G3DSA:1.25.10.10:FF:001065', NULL, NULL, 'Pumilio homolog 23', NULL, NULL, NULL, NULL, NULL, 4),
(207511, NULL, 'G3DSA:2.130.10.10:FF:000753', NULL, NULL, 'Coatomer alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207512, NULL, 'G3DSA:3.20.20.40:FF:000001', NULL, NULL, 'Glucanase', NULL, NULL, NULL, NULL, NULL, 4),
(207513, NULL, 'G3DSA:3.30.930.10:FF:000089', NULL, NULL, 'Phenylalanine--tRNA ligase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(207514, NULL, 'G3DSA:2.60.40.60:FF:000739', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207515, NULL, 'G3DSA:3.30.9.10:FF:000005', NULL, NULL, 'Sarcosine oxidase, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(207516, NULL, 'G3DSA:1.10.10.60:FF:000742', NULL, NULL, 'Transcription termination factor, RNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(207517, NULL, 'G3DSA:3.30.450.60:FF:000073', NULL, NULL, 'AP complex subunit sigma', NULL, NULL, NULL, NULL, NULL, 4),
(207518, NULL, 'G3DSA:3.10.180.10:FF:000058', NULL, NULL, 'tRNA (guanine-N(1)-)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(207519, NULL, 'G3DSA:2.102.10.10:FF:000013', NULL, NULL, 'Nitrite reductase [NAD(P)H], small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(207520, NULL, 'G3DSA:3.30.530.20:FF:000106', NULL, NULL, 'START domain containing 7 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(207521, NULL, 'G3DSA:1.25.40.120:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207522, NULL, 'G3DSA:1.10.490.10:FF:000016', NULL, NULL, 'cytoglobin', NULL, NULL, NULL, NULL, NULL, 4),
(207523, NULL, 'G3DSA:3.40.20.10:FF:000087', NULL, NULL, 'Actin-binding protein, cofilin/tropomyosin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(207524, NULL, 'G3DSA:3.80.10.10:FF:002271', NULL, NULL, 'Leucine-rich repeat-containing protein 43', NULL, NULL, NULL, NULL, NULL, 4),
(207525, NULL, 'G3DSA:3.40.470.10:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207526, NULL, 'G3DSA:4.10.280.10:FF:000039', NULL, NULL, 'DNA-binding protein inhibitor ID-3', NULL, NULL, NULL, NULL, NULL, 4),
(207527, NULL, 'G3DSA:2.60.40.10:FF:005300', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207528, NULL, 'G3DSA:3.60.10.10:FF:000203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207529, NULL, 'G3DSA:3.30.565.10:FF:000369', NULL, NULL, 'Sensor histidine kinase, HAMP and PAS domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(207530, NULL, 'G3DSA:1.10.10.10:FF:001806', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207531, NULL, 'G3DSA:1.10.238.10:FF:000958', NULL, NULL, 'EG:114D9.1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(207532, NULL, 'G3DSA:2.70.98.10:FF:000048', NULL, NULL, 'Aldose 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(207533, NULL, 'G3DSA:3.40.630.30:FF:000250', NULL, NULL, '[Citrate [pro-3S]-lyase] ligase', NULL, NULL, NULL, NULL, NULL, 4),
(207534, NULL, 'G3DSA:3.30.70.330:FF:000364', NULL, NULL, 'heterogeneous nuclear ribonucleoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(207535, NULL, 'G3DSA:3.90.380.10:FF:000010', NULL, NULL, 'Vanillate O-demethylase, oxygenase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(207536, NULL, 'G3DSA:3.40.50.10490:FF:000132', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207537, NULL, 'G3DSA:3.40.50.80:FF:000019', NULL, NULL, 'NADH-cytochrome b5 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(207538, NULL, 'G3DSA:1.20.1250.20:FF:000032', NULL, NULL, 'Protein TsgA', NULL, NULL, NULL, NULL, NULL, 4),
(207539, NULL, 'G3DSA:3.30.160.60:FF:001618', NULL, NULL, 'Zinc finger protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(207540, NULL, 'G3DSA:3.60.40.10:FF:000115', NULL, NULL, 'Protein phosphatase 2C 38', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(207541, NULL, 'G3DSA:1.25.10.10:FF:001430', NULL, NULL, 'Serine/threonine-protein phosphatase 4 regulatory subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(207542, NULL, 'G3DSA:1.20.930.20:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207543, NULL, 'G3DSA:2.130.10.10:FF:003715', NULL, NULL, 'Semaphorin-4D', NULL, NULL, NULL, NULL, NULL, 4),
(207544, NULL, 'G3DSA:1.25.40.10:FF:003978', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207545, NULL, 'G3DSA:2.30.29.30:FF:000413', NULL, NULL, 'vacuolar protein-sorting-associated protein 36 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(207546, NULL, 'G3DSA:3.40.50.150:FF:001214', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207547, NULL, 'G3DSA:2.60.40.1730:FF:000031', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(207548, NULL, 'G3DSA:1.50.10.10:FF:000040', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(207549, NULL, 'G3DSA:1.50.40.10:FF:000132', NULL, NULL, 'Solute carrier family 25, member 33/36', NULL, NULL, NULL, NULL, NULL, 4),
(207550, NULL, 'G3DSA:3.30.980.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207551, NULL, 'G3DSA:2.60.120.290:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207552, NULL, 'G3DSA:3.80.10.10:FF:004519', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207553, NULL, 'G3DSA:3.90.176.10:FF:000007', NULL, NULL, 'Lethal factor', NULL, NULL, NULL, NULL, NULL, 4),
(207554, NULL, 'G3DSA:2.60.40.10:FF:001394', NULL, NULL, 'Immunoglobulin alpha Fc receptor', NULL, NULL, NULL, NULL, NULL, 4),
(207555, NULL, 'G3DSA:3.60.21.10:FF:000431', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(207556, NULL, 'G3DSA:3.20.20.80:FF:000018', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(207557, NULL, 'G3DSA:1.25.10.10:FF:002846', NULL, NULL, 'Protein penguin-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(207558, NULL, 'G3DSA:1.10.268.10:FF:000005', NULL, NULL, 'DNA topoisomerase medium subunit', NULL, NULL, NULL, NULL, NULL, 4),
(207559, NULL, 'G3DSA:1.25.10.10:FF:002594', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207560, NULL, 'G3DSA:2.60.120.290:FF:000099', NULL, NULL, 'Scavenger receptor cysteine-rich protein type 5', NULL, NULL, NULL, NULL, NULL, 4),
(207561, NULL, 'G3DSA:2.30.30.100:FF:000223', NULL, NULL, 'Small nuclear ribonucleoprotein E', NULL, NULL, NULL, NULL, NULL, 4),
(207562, NULL, 'G3DSA:3.40.50.170:FF:000045', NULL, NULL, 'Aldehyde dehydrogenase 1 family, member L2', NULL, NULL, NULL, NULL, NULL, 4),
(207563, NULL, 'G3DSA:3.40.50.300:FF:003805', NULL, NULL, 'DEAD/DEAH box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(207564, NULL, 'G3DSA:3.40.50.300:FF:004839', NULL, NULL, 'V-type ATP synthase alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(207565, NULL, 'G3DSA:2.60.120.620:FF:000024', NULL, NULL, 'Prolyl 4-hydroxylase subunit alpha, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207566, NULL, 'G3DSA:1.25.40.20:FF:000423', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(207567, NULL, 'G3DSA:1.10.510.10:FF:000878', NULL, NULL, 'Insulin receptor a', NULL, NULL, NULL, NULL, NULL, 4),
(207568, NULL, 'G3DSA:3.40.50.300:FF:002046', NULL, NULL, 'DnaA regulatory inactivator Hda', NULL, NULL, NULL, NULL, NULL, 4),
(207569, NULL, 'G3DSA:1.25.40.10:FF:001578', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207570, NULL, 'G3DSA:3.30.505.10:FF:000253', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207571, NULL, 'G3DSA:2.60.120.340:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207572, NULL, 'G3DSA:3.30.420.10:FF:000224', NULL, NULL, 'RE72821p1', NULL, NULL, NULL, NULL, NULL, 4),
(207573, NULL, 'G3DSA:3.40.50.720:FF:000486', NULL, NULL, 'UDP-glucose 6-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(207574, NULL, 'G3DSA:2.60.40.60:FF:001144', NULL, NULL, 'Cadherin 2', NULL, NULL, NULL, NULL, NULL, 4),
(207575, NULL, 'G3DSA:2.40.50.140:FF:000271', NULL, NULL, 'Similar to ssDNA binding protein Ssb3', NULL, NULL, NULL, NULL, NULL, 4),
(207576, NULL, 'G3DSA:1.20.1740.10:FF:000095', NULL, NULL, 'B(0,+)-type amino acid transporter 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(207577, NULL, 'G3DSA:2.10.25.10:FF:000495', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(207578, NULL, 'G3DSA:3.80.10.10:FF:000832', NULL, NULL, 'Toll-like receptor 11', NULL, NULL, NULL, NULL, NULL, 4),
(207579, NULL, 'G3DSA:1.20.1260.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207580, NULL, 'G3DSA:1.10.630.10:FF:000680', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207581, NULL, 'G3DSA:3.30.830.10:FF:000289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207582, NULL, 'G3DSA:3.80.10.10:FF:003103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207583, NULL, 'G3DSA:1.20.120.830:FF:000001', NULL, NULL, 'BCAR1 scaffold protein, Cas family member', NULL, NULL, NULL, NULL, NULL, 4),
(207584, NULL, 'G3DSA:1.10.520.10:FF:000014', NULL, NULL, 'Catalase/peroxidase HPI', NULL, NULL, NULL, NULL, NULL, 4),
(207585, NULL, 'G3DSA:3.40.1110.10:FF:000075', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(207586, NULL, 'G3DSA:2.40.40.50:FF:000001', NULL, NULL, 'Ubiquitin fusion degradation protein 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(207587, NULL, 'G3DSA:3.40.309.10:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207588, NULL, 'G3DSA:3.40.50.150:FF:000961', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207589, NULL, 'G3DSA:1.20.5.1300:FF:000006', NULL, NULL, 'Histidinol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(207590, NULL, 'G3DSA:3.30.60.20:FF:000031', NULL, NULL, 'Protein kinase C alpha', NULL, NULL, NULL, NULL, NULL, 4),
(207591, NULL, 'G3DSA:1.20.140.10:FF:000016', NULL, NULL, 'Acyl-CoA dehydrogenase FadE5', NULL, NULL, NULL, NULL, NULL, 4),
(207592, NULL, 'G3DSA:1.20.120.850:FF:000007', NULL, NULL, 'Protein CHROMATIN REMODELING 25', NULL, NULL, NULL, NULL, NULL, 4),
(207593, NULL, 'G3DSA:3.30.470.20:FF:000163', NULL, NULL, 'RimK-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(207594, NULL, 'G3DSA:3.40.50.1820:FF:000770', NULL, NULL, 'Medium-chain fatty acid ethyl ester synthase/esterase', NULL, NULL, NULL, NULL, NULL, 4),
(207595, NULL, 'G3DSA:1.10.630.10:FF:000371', NULL, NULL, 'Putative cytochrome P450 120', NULL, NULL, NULL, NULL, NULL, 4),
(207596, NULL, 'G3DSA:3.20.20.140:FF:000310', NULL, NULL, 'AAA-4 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(207597, NULL, 'G3DSA:1.25.40.180:FF:000326', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207598, NULL, 'G3DSA:1.20.1250.20:FF:001066', NULL, NULL, 'Monocarboxylate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(207599, NULL, 'G3DSA:3.80.10.10:FF:000124', NULL, NULL, 'Coronatine-insensitive protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(207600, NULL, 'G3DSA:3.10.20.90:FF:000887', NULL, NULL, 'FERM, RhoGEF and pleckstrin domain protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(207601, NULL, 'G3DSA:1.10.555.10:FF:000066', NULL, NULL, 'Rho GTPase activator (Bem3), putative', NULL, NULL, NULL, NULL, NULL, 4),
(207602, NULL, 'G3DSA:2.10.25.10:FF:000129', NULL, NULL, 'Low-density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(207603, NULL, 'G3DSA:3.40.250.10:FF:000029', NULL, NULL, 'Dual specificity phosphatase 9', NULL, NULL, NULL, NULL, NULL, 4),
(207604, NULL, 'G3DSA:3.40.50.2000:FF:001077', NULL, NULL, 'Starch synthase, chloroplastic/amyloplastic', NULL, NULL, NULL, NULL, NULL, 4),
(207605, NULL, 'G3DSA:3.80.10.10:FF:002850', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207606, NULL, 'G3DSA:3.50.80.20:FF:000003', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase/D-alanyl-D-alanine-endopeptidase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(207607, NULL, 'G3DSA:1.10.2000.10:FF:000024', NULL, NULL, 'Transmembrane receptor LIN-17', NULL, NULL, NULL, NULL, NULL, 4),
(207608, NULL, 'G3DSA:3.30.160.60:FF:001242', NULL, NULL, 'zinc finger protein 746 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(207609, NULL, 'G3DSA:3.30.160.60:FF:005513', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207610, NULL, 'G3DSA:3.40.50.620:FF:000681', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207611, NULL, 'G3DSA:3.30.40.10:FF:001100', NULL, NULL, 'TRIM28 isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(207612, NULL, 'G3DSA:1.25.10.10:FF:001301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207613, NULL, 'G3DSA:1.25.40.10:FF:004692', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207614, NULL, 'G3DSA:3.80.10.10:FF:001557', NULL, NULL, 'Leucine-rich repeat kinase', NULL, NULL, NULL, NULL, NULL, 4),
(207615, NULL, 'G3DSA:3.30.710.10:FF:000106', NULL, NULL, 'BTB/POZ domain-containing protein POB1', NULL, NULL, NULL, NULL, NULL, 4),
(207616, NULL, 'G3DSA:3.40.50.300:FF:003193', NULL, NULL, 'Flagella-related protein FlaI', NULL, NULL, NULL, NULL, NULL, 4),
(207617, NULL, 'G3DSA:3.30.310.180:FF:000003', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 20', NULL, NULL, NULL, NULL, NULL, 4),
(207618, NULL, 'G3DSA:3.30.160.60:FF:002568', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207619, NULL, 'G3DSA:3.30.1360.120:FF:000027', NULL, NULL, 'tRNA modification GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(207620, NULL, 'G3DSA:2.130.10.10:FF:001006', NULL, NULL, 'Dynein intermediate chain 1, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(207621, NULL, 'G3DSA:3.40.50.300:FF:001405', NULL, NULL, 'Multidrug resistance protein associated1', NULL, NULL, NULL, NULL, NULL, 4),
(207622, NULL, 'G3DSA:1.10.287.380:FF:000014', NULL, NULL, 'Mitochondrial valyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(207623, NULL, 'G3DSA:1.10.630.10:FF:000005', NULL, NULL, 'cytochrome P450 4F22 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(207624, NULL, 'G3DSA:1.25.40.20:FF:001042', NULL, NULL, 'NePHronoPhthisis (Human kidney disease) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(207625, NULL, 'G3DSA:3.30.70.1450:FF:000009', NULL, NULL, 'SLC13 family permease', NULL, NULL, NULL, NULL, NULL, 4),
(207626, NULL, 'G3DSA:1.10.246.90:FF:000006', NULL, NULL, 'Pre-RNA processing ribonucleoprotein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207627, NULL, 'G3DSA:6.20.240.60:FF:000002', NULL, NULL, 'Cell wall hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(207628, NULL, 'G3DSA:1.25.40.20:FF:001570', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207629, NULL, 'G3DSA:1.10.565.10:FF:000095', NULL, NULL, 'COUP transcription factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(207630, NULL, 'G3DSA:2.20.100.10:FF:000240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207631, NULL, 'G3DSA:3.30.200.20:FF:001425', NULL, NULL, 'Insulin receptor b', NULL, NULL, NULL, NULL, NULL, 4),
(207632, NULL, 'G3DSA:3.40.190.80:FF:000084', NULL, NULL, 'Inositol monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(207633, NULL, 'G3DSA:3.40.1810.10:FF:000010', NULL, NULL, 'Agamous-like MADS-box protein AGL30', NULL, NULL, NULL, NULL, NULL, 4),
(207634, NULL, 'G3DSA:1.10.1520.10:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207635, NULL, 'G3DSA:1.20.272.10:FF:000030', NULL, NULL, 'Replication factor C subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(207636, NULL, 'G3DSA:1.10.10.650:FF:000010', NULL, NULL, 'Transcription accessory protein (S1 RNA-binding domain)', NULL, NULL, NULL, NULL, NULL, 4),
(207637, NULL, 'G3DSA:1.10.506.10:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207638, NULL, 'G3DSA:3.30.70.660:FF:000024', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(207639, NULL, 'G3DSA:3.40.50.300:FF:007953', NULL, NULL, 'MutS domain III family protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(207640, NULL, 'G3DSA:1.10.510.10:FF:004459', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207641, NULL, 'G3DSA:3.40.50.1820:FF:000438', NULL, NULL, 'Possible hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(207642, NULL, 'G3DSA:3.90.1100.10:FF:000040', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(207643, NULL, 'G3DSA:2.30.30.100:FF:000004', NULL, NULL, 'Small nuclear ribonucleoprotein-associated proteins', NULL, NULL, NULL, NULL, NULL, 4),
(207644, NULL, 'G3DSA:1.10.357.140:FF:000049', NULL, NULL, 'Lmo2635 protein', NULL, NULL, NULL, NULL, NULL, 4),
(207645, NULL, 'G3DSA:1.20.5.1430:FF:000012', NULL, NULL, 'FI16628p1', NULL, NULL, NULL, NULL, NULL, 4),
(207646, NULL, 'G3DSA:3.40.47.10:FF:000019', NULL, NULL, 'Polyketide synthase type I', NULL, NULL, NULL, NULL, NULL, 4),
(207647, NULL, 'G3DSA:3.40.50.300:FF:008572', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207648, NULL, 'G3DSA:3.30.1010.10:FF:000081', NULL, NULL, 'Smg-1', NULL, NULL, NULL, NULL, NULL, 4),
(207649, NULL, 'G3DSA:1.25.40.10:FF:001814', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g77170, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(207650, NULL, 'G3DSA:3.90.550.10:FF:000041', NULL, NULL, 'UDP-glucose ceramide glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(207651, NULL, 'G3DSA:3.40.50.620:FF:000534', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207652, NULL, 'G3DSA:3.30.160.60:FF:005660', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207653, NULL, 'G3DSA:3.30.200.20:FF:000806', NULL, NULL, 'Putative DUF26-domain protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(207654, NULL, 'G3DSA:1.20.5.2700:FF:000005', NULL, NULL, 'NADH-quinone oxidoreductase subunit L', NULL, NULL, NULL, NULL, NULL, 4),
(207655, NULL, 'G3DSA:3.40.190.10:FF:000900', NULL, NULL, 'Probable sensor/response regulator hybrid', NULL, NULL, NULL, NULL, NULL, 4),
(207656, NULL, 'G3DSA:2.60.40.3510:FF:000025', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(207657, NULL, 'G3DSA:1.20.58.530:FF:000007', NULL, NULL, 'Myosin IE', NULL, NULL, NULL, NULL, NULL, 4),
(207658, NULL, 'G3DSA:2.10.25.10:FF:000731', NULL, NULL, 'Wall-associated receptor kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(207659, NULL, 'G3DSA:3.80.10.10:FF:000596', NULL, NULL, 'peroxidasin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(207660, NULL, 'G3DSA:1.25.40.10:FF:004939', NULL, NULL, 'Developmental protein DG1091', NULL, NULL, NULL, NULL, NULL, 4),
(207661, NULL, 'G3DSA:1.20.120.1240:FF:000002', NULL, NULL, 'Dynamin-1-like protein isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(207662, NULL, 'G3DSA:3.40.50.620:FF:000079', NULL, NULL, 'Probable nicotinate-nucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(207663, NULL, 'G3DSA:2.130.10.10:FF:005424', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207664, NULL, 'G3DSA:3.30.565.10:FF:000392', NULL, NULL, 'Sensor histidine kinase RegB', NULL, NULL, NULL, NULL, NULL, 4),
(207665, NULL, 'G3DSA:1.20.1160.20:FF:000002', NULL, NULL, 'Whirlin a', NULL, NULL, NULL, NULL, NULL, 4),
(207666, NULL, 'G3DSA:3.90.79.10:FF:000012', NULL, NULL, 'Isopentenyl-diphosphate Delta-isomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(207667, NULL, 'G3DSA:1.20.1250.20:FF:000902', NULL, NULL, 'Solute carrier organic anion transporter family member 5A1', NULL, NULL, NULL, NULL, NULL, 4),
(207668, NULL, 'G3DSA:3.30.70.250:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207669, NULL, 'G3DSA:2.130.10.10:FF:000045', NULL, NULL, 'DDB1- and CUL4-associated factor 6 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(207670, NULL, 'G3DSA:3.40.630.10:FF:000255', NULL, NULL, 'Nicastrin', NULL, NULL, NULL, NULL, NULL, 4),
(207671, NULL, 'G3DSA:1.20.5.170:FF:000231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207672, NULL, 'G3DSA:3.90.320.10:FF:000029', NULL, NULL, 'Mitochondrial genome maintenance exonuclease 1', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(207673, NULL, 'G3DSA:2.10.220.10:FF:000212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207674, NULL, 'G3DSA:3.40.50.150:FF:001579', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207675, NULL, 'G3DSA:1.10.8.430:FF:000014', NULL, NULL, 'Disease resistance protein RGA4', NULL, NULL, NULL, NULL, NULL, 4),
(207676, NULL, 'G3DSA:3.90.1170.40:FF:000002', NULL, NULL, 'Molybdopterin synthase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(207677, NULL, 'G3DSA:4.10.800.30:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207678, NULL, 'G3DSA:2.30.170.20:FF:000009', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207679, NULL, 'G3DSA:1.10.238.10:FF:000397', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(207680, NULL, 'G3DSA:3.40.30.10:FF:000149', NULL, NULL, 'Thioredoxin-like protein CITRX, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(207681, NULL, 'G3DSA:3.40.50.10190:FF:000177', NULL, NULL, 'DNA polymerase III subunit epsilon DnaQ', NULL, NULL, NULL, NULL, NULL, 4),
(207682, NULL, 'G3DSA:3.40.1090.10:FF:000139', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207683, NULL, 'G3DSA:1.10.150.50:FF:000222', NULL, NULL, 'transcription factor protein', NULL, NULL, NULL, NULL, NULL, 4),
(207684, NULL, 'G3DSA:3.40.50.1240:FF:000202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207685, NULL, 'G3DSA:2.40.50.140:FF:001232', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207686, NULL, 'G3DSA:2.10.25.10:FF:000276', NULL, NULL, 'Wnt inhibitory factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(207687, NULL, 'G3DSA:1.10.238.20:FF:000023', NULL, NULL, 'Odorant-binding protein 57d', NULL, NULL, NULL, NULL, NULL, 4),
(207688, NULL, 'G3DSA:1.10.287.2250:FF:000020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207689, NULL, 'G3DSA:1.20.120.1750:FF:000048', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(207690, NULL, 'G3DSA:3.40.50.300:FF:004154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207691, NULL, 'G3DSA:3.30.420.40:FF:000110', NULL, NULL, 'heat shock 70 kDa protein 13 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(207692, NULL, 'G3DSA:1.10.45.10:FF:000004', NULL, NULL, 'L-gulonolactone oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(207693, NULL, 'G3DSA:2.20.100.10:FF:000111', NULL, NULL, 'ADAMTS-like protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(207694, NULL, 'G3DSA:1.10.510.10:FF:003155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207695, NULL, 'G3DSA:3.50.50.60:FF:000272', NULL, NULL, 'Dihydrolipoyl dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(207696, NULL, 'G3DSA:1.20.1250.20:FF:000717', NULL, NULL, 'Uncharacterized transporter C460.03', NULL, NULL, NULL, NULL, NULL, 4),
(207697, NULL, 'G3DSA:2.130.10.10:FF:003479', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(207698, NULL, 'G3DSA:3.30.160.60:FF:003187', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207699, NULL, 'G3DSA:3.30.40.10:FF:000482', NULL, NULL, 'SNF2 helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207700, NULL, 'G3DSA:2.70.160.11:FF:000088', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(207701, NULL, 'G3DSA:2.80.10.50:FF:000200', NULL, NULL, 'Inositol 1,4,5-trisphosphate receptor-like protein A', NULL, NULL, NULL, NULL, NULL, 4),
(207702, NULL, 'G3DSA:3.10.350.10:FF:000021', NULL, NULL, 'Probable cell wall hydrolase LytN', NULL, NULL, NULL, NULL, NULL, 4),
(207703, NULL, 'G3DSA:2.60.260.20:FF:000184', NULL, NULL, 'Chaperone protein dnaJ 3', NULL, NULL, NULL, NULL, NULL, 4),
(207704, NULL, 'G3DSA:3.40.140.10:FF:000133', NULL, NULL, 'Riboflavin biosynthesis protein RibD', NULL, NULL, NULL, NULL, NULL, 4),
(207705, NULL, 'G3DSA:3.40.109.10:FF:000004', NULL, NULL, 'Iodotyrosine deiodinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(207706, NULL, 'G3DSA:2.60.40.10:FF:002208', NULL, NULL, 'CD96 isoform 3', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(207707, NULL, 'G3DSA:3.20.20.20:FF:000006', NULL, NULL, 'Dihydropteroate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(207708, NULL, 'G3DSA:3.90.640.10:FF:000267', NULL, NULL, 'HSP70 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(207709, NULL, 'G3DSA:3.40.50.1910:FF:000010', NULL, NULL, 'Vacuolar protein sorting-associated protein 45', NULL, NULL, NULL, NULL, NULL, 4),
(207710, NULL, 'G3DSA:3.40.630.30:FF:000446', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207711, NULL, 'G3DSA:3.10.20.90:FF:000415', NULL, NULL, 'Ubiquitin regulatory X', NULL, NULL, NULL, NULL, NULL, 4),
(207712, NULL, 'G3DSA:3.90.120.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207713, NULL, 'G3DSA:1.20.1070.10:FF:000947', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207714, NULL, 'G3DSA:1.10.110.10:FF:000005', NULL, NULL, 'Non-specific lipid-transfer protein C6', NULL, NULL, NULL, NULL, NULL, 4),
(207715, NULL, 'G3DSA:1.20.1070.10:FF:001875', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(207716, NULL, 'G3DSA:3.40.605.10:FF:000056', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(207717, NULL, 'G3DSA:2.170.300.10:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207718, NULL, 'G3DSA:3.90.79.10:FF:000265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207719, NULL, 'G3DSA:3.80.10.10:FF:000377', NULL, NULL, 'Tonsoku like, DNA repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(207720, NULL, 'G3DSA:3.30.160.60:FF:000062', NULL, NULL, 'RB-associated KRAB zinc finger protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(207721, NULL, 'G3DSA:1.20.5.1000:FF:000001', NULL, NULL, 'C-Jun-amino-terminal kinase-interacting protein 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(207722, NULL, 'G3DSA:1.10.510.10:FF:001025', NULL, NULL, 'Novel gene similar to TRAF2 and NCK-interacting kinase', NULL, NULL, NULL, NULL, NULL, 4),
(207723, NULL, 'G3DSA:1.10.238.10:FF:000852', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207724, NULL, 'G3DSA:3.40.50.300:FF:007392', NULL, NULL, 'Primosomal protein N''', NULL, NULL, NULL, NULL, NULL, 4),
(207725, NULL, 'G3DSA:3.30.559.10:FF:000225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207726, NULL, 'G3DSA:1.10.287.70:FF:000247', NULL, NULL, 'Inward Rectifying K (Potassium) channel family', NULL, NULL, NULL, NULL, NULL, 4),
(207727, NULL, 'G3DSA:3.90.70.10:FF:000144', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(207728, NULL, 'G3DSA:3.30.420.10:FF:000567', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207729, NULL, 'G3DSA:3.40.50.740:FF:000025', NULL, NULL, 'NADH-quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(207730, NULL, 'G3DSA:3.30.160.460:FF:000001', NULL, NULL, 'Methylated-DNA--protein-cysteine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(207731, NULL, 'G3DSA:1.10.132.60:FF:000048', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(207732, NULL, 'G3DSA:2.30.180.10:FF:000198', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207733, NULL, 'G3DSA:1.10.510.10:FF:000749', NULL, NULL, 'Leucine-rich repeat kinase, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(207734, NULL, 'G3DSA:1.10.1620.20:FF:000012', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207735, NULL, 'G3DSA:2.60.40.10:FF:000101', NULL, NULL, 'Neogenin isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(207736, NULL, 'G3DSA:2.60.120.200:FF:000454', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207737, NULL, 'G3DSA:3.30.200.20:FF:001211', NULL, NULL, 'OSJNBa0027H06.10-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(207738, NULL, 'G3DSA:1.20.120.350:FF:000262', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207739, NULL, 'G3DSA:3.10.330.10:FF:000019', NULL, NULL, 'Peroxisome biogenesis factor 1', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(207740, NULL, 'G3DSA:3.10.110.10:FF:000003', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 E3', NULL, NULL, NULL, NULL, NULL, 4),
(207741, NULL, 'G3DSA:1.20.1250.20:FF:000138', NULL, NULL, 'Amino acid/peptide transporter', NULL, NULL, NULL, NULL, NULL, 4),
(207742, NULL, 'G3DSA:1.10.287.660:FF:000031', NULL, NULL, 'Vacuolar protein sorting-associated protein 37A-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(207743, NULL, 'G3DSA:1.10.1670.10:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207744, NULL, 'G3DSA:1.10.560.10:FF:000033', NULL, NULL, '60 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(207745, NULL, 'G3DSA:1.20.1110.10:FF:000210', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207746, NULL, 'G3DSA:1.25.10.10:FF:000340', NULL, NULL, 'Vacuolar protein 8, variant', NULL, NULL, NULL, NULL, NULL, 4),
(207747, NULL, 'G3DSA:1.10.238.10:FF:000144', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(207748, NULL, 'G3DSA:3.40.710.10:FF:000042', NULL, NULL, 'Penicillin-binding protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(207749, NULL, 'G3DSA:3.40.1380.20:FF:000029', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(207750, NULL, 'G3DSA:4.10.1060.10:FF:000048', NULL, NULL, 'AGAP000025-PA', NULL, NULL, NULL, NULL, NULL, 4),
(207751, NULL, 'G3DSA:1.25.40.10:FF:000982', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(207752, NULL, 'G3DSA:1.10.8.60:FF:000522', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207753, NULL, 'G3DSA:2.60.40.10:FF:002883', NULL, NULL, 'Neurolin-like cell adhesion molecule', NULL, NULL, NULL, NULL, NULL, 4),
(207754, NULL, 'G3DSA:2.170.270.10:FF:000099', NULL, NULL, 'Histone-lysine N-methyltransferase Su(var)3-9', NULL, NULL, NULL, NULL, NULL, 4),
(207755, NULL, 'G3DSA:3.10.20.30:FF:000004', NULL, NULL, 'Succinate dehydrogenase iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4),
(207756, NULL, 'G3DSA:3.10.129.10:FF:000282', NULL, NULL, 'Thioesterase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(207757, NULL, 'G3DSA:3.30.160.60:FF:003748', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207758, NULL, 'G3DSA:3.30.40.10:FF:000858', NULL, NULL, 'Zinc_finger_-_C3HC4_type_(RING_finger)/Ring_finger_domain/zinc-RING_finger_domain/EF-hand_domain_pair/EF-hand_domain/EF_hand/Secreted_protein_acidic_and_rich_in_cys teine_Ca_binding_region_containing_...', NULL, NULL, NULL, NULL, NULL, 4),
(207759, NULL, 'G3DSA:1.20.58.390:FF:000038', NULL, NULL, 'Acetylcholine receptor subunit beta-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(207760, NULL, 'G3DSA:3.90.1720.10:FF:000019', NULL, NULL, 'CBN-EGL-26 protein', NULL, NULL, NULL, NULL, NULL, 4),
(207761, NULL, 'G3DSA:2.10.50.10:FF:000109', NULL, NULL, 'Si:ch211-261n11.7', NULL, NULL, NULL, NULL, NULL, 4),
(207762, NULL, 'G3DSA:1.10.510.10:FF:001733', NULL, NULL, 'Casein kinase 1 gamma 1', NULL, NULL, NULL, NULL, NULL, 4),
(207763, NULL, 'G3DSA:1.20.930.40:FF:000012', NULL, NULL, 'Membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(207764, NULL, 'G3DSA:1.25.40.10:FF:000089', NULL, NULL, 'CTR9 homolog, Paf1/RNA polymerase II complex component', NULL, NULL, NULL, NULL, NULL, 4),
(207765, NULL, 'G3DSA:3.30.40.10:FF:001786', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207766, NULL, 'G3DSA:1.10.10.10:FF:001593', NULL, NULL, 'Helix-turn-helix SAM-dependent methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(207767, NULL, 'G3DSA:2.130.10.10:FF:004805', NULL, NULL, 'Shk1 kinase-binding protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(207768, NULL, 'G3DSA:1.20.5.1190:FF:000001', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(207769, NULL, 'G3DSA:1.20.1250.20:FF:000560', NULL, NULL, 'MFS hexose transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207770, NULL, 'G3DSA:1.20.58.60:FF:000885', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207771, NULL, 'G3DSA:2.130.10.10:FF:002299', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit TRM82', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(207772, NULL, 'G3DSA:2.60.40.10:FF:000410', NULL, NULL, 'Down syndrome cell adhesion molecule, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(207773, NULL, 'G3DSA:2.30.42.10:FF:000376', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207774, NULL, 'G3DSA:3.40.50.1820:FF:000168', NULL, NULL, 'Alpha/beta-Hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(207775, NULL, 'G3DSA:3.90.70.10:FF:000829', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207776, NULL, 'G3DSA:3.90.15.10:FF:000011', NULL, NULL, 'DNA topoisomerase I, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(207777, NULL, 'G3DSA:1.20.1090.10:FF:000038', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(207778, NULL, 'G3DSA:2.30.30.40:FF:000178', NULL, NULL, 'SH3 and multiple ankyrin repeat domains protein', NULL, NULL, NULL, NULL, NULL, 4),
(207779, NULL, 'G3DSA:3.40.50.300:FF:007245', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207780, NULL, 'G3DSA:3.80.10.10:FF:000938', NULL, NULL, 'Blast:Chaoptin', NULL, NULL, NULL, NULL, NULL, 4),
(207781, NULL, 'G3DSA:2.30.230.10:FF:000051', NULL, NULL, 'Apolipophorins-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(207782, NULL, 'G3DSA:2.30.30.140:FF:000224', NULL, NULL, 'Tudor, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(207783, NULL, 'G3DSA:3.50.30.30:FF:000060', NULL, NULL, 'Double-zinc aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(207784, NULL, 'G3DSA:4.10.280.10:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207785, NULL, 'G3DSA:3.40.50.300:FF:003226', NULL, NULL, 'Large subunit GTPase 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(207786, NULL, 'G3DSA:1.10.510.10:FF:000406', NULL, NULL, 'cyclin-dependent kinase 20 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(207787, NULL, 'G3DSA:3.40.120.10:FF:000025', NULL, NULL, 'Phosphomannomutase', NULL, NULL, NULL, NULL, NULL, 4),
(207788, NULL, 'G3DSA:3.30.460.10:FF:000036', NULL, NULL, 'Ribosomal silencing factor RsfS', NULL, NULL, NULL, NULL, NULL, 4),
(207789, NULL, 'G3DSA:1.25.40.20:FF:001603', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207790, NULL, 'G3DSA:3.90.550.50:FF:000058', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(207791, NULL, 'G3DSA:1.20.1310.10:FF:000085', NULL, NULL, 'Cullin homolog 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(207792, NULL, 'G3DSA:2.40.10.10:FF:000100', NULL, NULL, 'Kallikrein-4', NULL, NULL, NULL, NULL, NULL, 4),
(207793, NULL, 'G3DSA:1.20.1050.80:FF:000023', NULL, NULL, 'UPF0507 protein C2_02840C_A', NULL, NULL, NULL, NULL, NULL, 4),
(207794, NULL, 'G3DSA:3.20.20.190:FF:000100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207795, NULL, 'G3DSA:2.30.30.140:FF:000100', NULL, NULL, 'E3 ubiquitin-protein ligase UHRF2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(207796, NULL, 'G3DSA:3.30.40.10:FF:001819', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207797, NULL, 'G3DSA:2.60.120.200:FF:000145', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(207798, NULL, 'G3DSA:1.20.58.60:FF:000177', NULL, NULL, 'nesprin-1 isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(207799, NULL, 'G3DSA:1.10.1220.10:FF:000018', NULL, NULL, 'Possible antitoxin vapb19', NULL, NULL, NULL, NULL, NULL, 4),
(207800, NULL, 'G3DSA:2.60.40.10:FF:004120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207801, NULL, 'G3DSA:3.30.1640.30:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207802, NULL, 'G3DSA:1.10.3720.10:FF:000085', NULL, NULL, 'Carbohydrate ABC transporter membrane protein 2, CUT1 family', NULL, NULL, NULL, NULL, NULL, 4),
(207803, NULL, 'G3DSA:3.40.50.720:FF:000941', NULL, NULL, 'Prephenate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(207804, NULL, 'G3DSA:3.30.720.150:FF:000002', NULL, NULL, 'probable UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase SEC', NULL, NULL, NULL, NULL, NULL, 4),
(207805, NULL, 'G3DSA:1.10.1060.10:FF:000016', NULL, NULL, 'Dihydropyrimidine dehydrogenase [NADP(+)]', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(207806, NULL, 'G3DSA:1.20.5.110:FF:000034', NULL, NULL, 'syntaxin-61 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(207807, NULL, 'G3DSA:1.10.238.10:FF:001105', NULL, NULL, 'Aspartate/glutamate carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207808, NULL, 'G3DSA:3.40.50.200:FF:000184', NULL, NULL, 'Gll1055 protein', NULL, NULL, NULL, NULL, NULL, 4),
(207809, NULL, 'G3DSA:3.40.50.1820:FF:001152', NULL, NULL, 'Endothelial lipase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207810, NULL, 'G3DSA:1.10.287.70:FF:000556', NULL, NULL, 'Glutamate receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(207811, NULL, 'G3DSA:2.60.120.1030:FF:000006', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(207812, NULL, 'G3DSA:3.10.50.40:FF:000054', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(207813, NULL, 'G3DSA:3.30.230.10:FF:000176', NULL, NULL, 'Galactokinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207814, NULL, 'G3DSA:3.40.50.2300:FF:000335', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207815, NULL, 'G3DSA:3.30.160.60:FF:000623', NULL, NULL, 'Zinc finger protein 234', NULL, NULL, NULL, NULL, NULL, 4),
(207816, NULL, 'G3DSA:1.20.1250.20:FF:001521', NULL, NULL, 'AGAP008720-PA', NULL, NULL, NULL, NULL, NULL, 4),
(207817, NULL, 'G3DSA:3.30.9.10:FF:000078', NULL, NULL, 'Possible oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(207818, NULL, 'G3DSA:3.30.780.10:FF:000060', NULL, NULL, 'Eukaryotic Initiation Factor', NULL, NULL, NULL, NULL, NULL, 4),
(207819, NULL, 'G3DSA:1.20.1070.10:FF:001566', NULL, NULL, 'C-X-C chemokine receptor type 4', NULL, NULL, NULL, NULL, NULL, 4),
(207820, NULL, 'G3DSA:3.40.50.300:FF:000101', NULL, NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(207821, NULL, 'G3DSA:3.30.190.20:FF:000046', NULL, NULL, 'Ribosomal protein L1p/L10e family', NULL, NULL, NULL, NULL, NULL, 4),
(207822, NULL, 'G3DSA:3.30.70.1430:FF:000003', NULL, NULL, 'Cation efflux system protein CusA', NULL, NULL, NULL, NULL, NULL, 4),
(207823, NULL, 'G3DSA:2.40.50.140:FF:000467', NULL, NULL, 'Unplaced genomic scaffold supercont1.15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(207824, NULL, 'G3DSA:3.40.50.300:FF:003535', NULL, NULL, 'Digestive organ expansion factor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(207825, NULL, 'G3DSA:2.60.300.12:FF:000013', NULL, NULL, 'Iron-sulfur assembly protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(207826, NULL, 'G3DSA:2.60.120.1440:FF:000011', NULL, NULL, 'Amino acid ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(207827, NULL, 'G3DSA:2.10.10.70:FF:000001', NULL, NULL, 'Polymerase cofactor VP35', NULL, NULL, NULL, NULL, NULL, 4),
(207828, NULL, 'G3DSA:1.25.40.20:FF:001727', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207829, NULL, 'G3DSA:2.60.40.790:FF:000043', NULL, NULL, 'Hsp90 binding co-chaperone (Sba1)', NULL, NULL, NULL, NULL, NULL, 4),
(207830, NULL, 'G3DSA:1.25.40.20:FF:001912', NULL, NULL, 'Ankyrin repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207831, NULL, 'G3DSA:3.90.550.10:FF:000602', NULL, NULL, 'Probable N-acylneuraminate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(207832, NULL, 'G3DSA:1.10.510.10:FF:003734', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207833, NULL, 'G3DSA:1.50.10.10:FF:000169', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(207834, NULL, 'G3DSA:3.40.50.300:FF:008448', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207835, NULL, 'G3DSA:3.30.160.60:FF:005873', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207836, NULL, 'G3DSA:3.30.200.20:FF:002279', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(207837, NULL, 'G3DSA:3.30.1550.10:FF:000020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207838, NULL, 'G3DSA:3.20.20.140:FF:000333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(207839, NULL, 'G3DSA:3.40.50.300:FF:005694', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207840, NULL, 'G3DSA:4.10.280.10:FF:000135', NULL, NULL, 'Transcription factor MYC1', NULL, NULL, NULL, NULL, NULL, 4),
(207841, NULL, 'G3DSA:1.20.1070.10:FF:001431', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(207842, NULL, 'G3DSA:1.10.510.10:FF:004240', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207843, NULL, 'G3DSA:2.120.10.80:FF:000246', NULL, NULL, 'tRNA wybutosine-synthesizing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(207844, NULL, 'G3DSA:2.40.50.140:FF:000254', NULL, NULL, 'Ribosomal protein L2 mitochondrion', NULL, NULL, NULL, NULL, NULL, 4),
(207845, NULL, 'G3DSA:1.10.10.2210:FF:000001', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(207846, NULL, 'G3DSA:1.10.10.2670:FF:000004', NULL, NULL, 'Ubiquitin-protein ligase E3 component (UBR1)', NULL, NULL, NULL, NULL, NULL, 4),
(207847, NULL, 'G3DSA:3.90.320.10:FF:000012', NULL, NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(207848, NULL, 'G3DSA:3.30.559.10:FF:000091', NULL, NULL, 'Choline O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(207849, NULL, 'G3DSA:3.40.50.10090:FF:000012', NULL, NULL, 'Uroporphyrinogen-III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(207850, NULL, 'G3DSA:3.30.450.150:FF:000002', NULL, NULL, 'UPF0303 protein BCAH820_3413', NULL, NULL, NULL, NULL, NULL, 4),
(207851, NULL, 'G3DSA:1.10.10.60:FF:001220', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207852, NULL, 'G3DSA:2.130.10.30:FF:000040', NULL, NULL, 'Guanidine nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(207853, NULL, 'G3DSA:1.20.1280.50:FF:000060', NULL, NULL, 'F-box only protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(207854, NULL, 'G3DSA:2.40.30.170:FF:000039', NULL, NULL, 'RND family efflux transporter, MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(207855, NULL, 'G3DSA:2.130.10.10:FF:001714', NULL, NULL, 'Periodic tryptophan protein 2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(207856, NULL, 'G3DSA:3.40.50.10490:FF:000155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207857, NULL, 'G3DSA:3.40.50.80:FF:000008', NULL, NULL, 'Ferredoxin--NADP reductase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(207858, NULL, 'G3DSA:1.10.630.10:FF:000713', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207859, NULL, 'G3DSA:2.60.40.10:FF:001039', NULL, NULL, 'laforin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(207860, NULL, 'G3DSA:3.30.559.30:FF:000097', NULL, NULL, 'Nonribosomal peptide synthase inpB', NULL, NULL, NULL, NULL, NULL, 4),
(207861, NULL, 'G3DSA:2.60.40.10:FF:004816', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207862, NULL, 'G3DSA:2.130.10.10:FF:003260', NULL, NULL, 'Wdr1p', NULL, NULL, NULL, NULL, NULL, 4),
(207863, NULL, 'G3DSA:2.130.10.10:FF:006014', NULL, NULL, 'WD repeat domain 90', NULL, NULL, NULL, NULL, NULL, 4),
(207864, NULL, 'G3DSA:3.40.50.620:FF:000315', NULL, NULL, 'Universal stress protein Rv2028c', NULL, NULL, NULL, NULL, NULL, 4),
(207865, NULL, 'G3DSA:2.10.109.10:FF:000037', NULL, NULL, 'Putative repressor LexA', NULL, NULL, NULL, NULL, NULL, 4),
(207866, NULL, 'G3DSA:2.10.110.10:FF:000333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207867, NULL, 'G3DSA:3.40.50.300:FF:004171', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207868, NULL, 'G3DSA:3.30.70.330:FF:002527', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207869, NULL, 'G3DSA:3.30.160.60:FF:000067', NULL, NULL, 'Vascular endothelial zinc finger 1', NULL, NULL, NULL, NULL, NULL, 4),
(207870, NULL, 'G3DSA:3.30.160.60:FF:001495', NULL, NULL, 'Datilografo, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(207871, NULL, 'G3DSA:1.25.40.10:FF:002438', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g49710', NULL, NULL, NULL, NULL, NULL, 4),
(207872, NULL, 'G3DSA:1.20.120.560:FF:000004', NULL, NULL, 'Blast:Programmed cell death 6-interacting protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(207873, NULL, 'G3DSA:2.60.40.150:FF:000115', NULL, NULL, 'Uncharacterized protein, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(207874, NULL, 'G3DSA:3.90.640.10:FF:000284', NULL, NULL, 'Actin-related protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(207875, NULL, 'G3DSA:2.10.25.10:FF:000837', NULL, NULL, 'Notch 3', NULL, NULL, NULL, NULL, NULL, 4),
(207876, NULL, 'G3DSA:3.80.10.10:FF:000484', NULL, NULL, 'Leucine-rich repeat kinase, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(207877, NULL, 'G3DSA:3.50.50.60:FF:001340', NULL, NULL, 'Mercuric reductase', NULL, NULL, NULL, NULL, NULL, 4),
(207878, NULL, 'G3DSA:2.70.130.10:FF:000034', NULL, NULL, 'Glucosidase II beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(207879, NULL, 'G3DSA:3.40.1110.10:FF:000108', NULL, NULL, 'Cation transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(207880, NULL, 'G3DSA:4.10.1240.10:FF:000045', NULL, NULL, 'Calcitonin gene-related peptide type 1 receptor-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(207881, NULL, 'G3DSA:3.30.70.330:FF:002966', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207882, NULL, 'G3DSA:1.25.10.10:FF:003116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207883, NULL, 'G3DSA:1.20.1290.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207884, NULL, 'G3DSA:2.40.50.40:FF:000061', NULL, NULL, 'CBX7 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(207885, NULL, 'G3DSA:3.10.20.90:FF:000202', NULL, NULL, 'Small ubiquitin-related modifier I', NULL, NULL, NULL, NULL, NULL, 4),
(207886, NULL, 'G3DSA:1.10.150.50:FF:000087', NULL, NULL, 'Sterile alpha motif domain containing 9', NULL, NULL, NULL, NULL, NULL, 4),
(207887, NULL, 'G3DSA:3.30.160.60:FF:002107', NULL, NULL, 'Zinc finger protein 484', NULL, NULL, NULL, NULL, NULL, 4),
(207888, NULL, 'G3DSA:1.25.40.180:FF:000186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207889, NULL, 'G3DSA:3.30.530.20:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207890, NULL, 'G3DSA:1.20.272.10:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207891, NULL, 'G3DSA:3.40.720.10:FF:000346', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207892, NULL, 'G3DSA:3.80.10.10:FF:002833', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207893, NULL, 'G3DSA:3.40.190.10:FF:000872', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207894, NULL, 'G3DSA:2.60.120.620:FF:000136', NULL, NULL, 'Prolyl 4-hydroxylase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(207895, NULL, 'G3DSA:3.40.630.30:FF:000233', NULL, NULL, 'Uncharacterized protein 9G6.260', NULL, NULL, NULL, NULL, NULL, 4),
(207896, NULL, 'G3DSA:1.20.1070.10:FF:002050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207897, NULL, 'G3DSA:3.30.930.10:FF:000342', NULL, NULL, 'Class II aaRS and biotin synthetases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(207898, NULL, 'G3DSA:2.130.10.10:FF:001231', NULL, NULL, 'PWP2, small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4),
(207899, NULL, 'G3DSA:3.30.70.330:FF:003146', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207900, NULL, 'G3DSA:1.10.10.10:FF:001149', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(207901, NULL, 'G3DSA:1.25.40.690:FF:000001', NULL, NULL, 'Nuclear pore complex protein Nup98-Nup96', NULL, NULL, NULL, NULL, NULL, 4),
(207902, NULL, 'G3DSA:1.10.1000.11:FF:000020', NULL, NULL, 'Guanyl nucleotide exchange factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207903, NULL, 'G3DSA:1.20.1270.60:FF:000135', NULL, NULL, 'GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207904, NULL, 'G3DSA:3.20.20.80:FF:000581', NULL, NULL, 'Heparanase-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(207905, NULL, 'G3DSA:3.40.50.300:FF:007829', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207906, NULL, 'G3DSA:3.40.50.2000:FF:000352', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(207907, NULL, 'G3DSA:1.10.510.10:FF:002211', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207908, NULL, 'G3DSA:1.25.40.10:FF:003383', NULL, NULL, 'Pentatricopeptide repeat-containing protein DOT4, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(207909, NULL, 'G3DSA:1.20.1250.40:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207910, NULL, 'G3DSA:3.40.50.2300:FF:001633', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207911, NULL, 'G3DSA:3.50.50.60:FF:000816', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(207912, NULL, 'G3DSA:3.40.50.620:FF:000787', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207913, NULL, 'G3DSA:2.40.70.10:FF:000429', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207914, NULL, 'G3DSA:3.30.479.30:FF:000045', NULL, NULL, 'Stomatin (EPB72)-like 3b', NULL, NULL, NULL, NULL, NULL, 4),
(207915, NULL, 'G3DSA:1.20.1250.20:FF:000689', NULL, NULL, '3-phenylpropionic acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(207916, NULL, 'G3DSA:3.40.50.1820:FF:000747', NULL, NULL, 'Triacylglycerol lipase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207917, NULL, 'G3DSA:1.10.1200.10:FF:000034', NULL, NULL, 'Peptide synthetase mbtE', NULL, NULL, NULL, NULL, NULL, 4),
(207918, NULL, 'G3DSA:1.10.472.140:FF:000005', NULL, NULL, 'Retinoblastoma family protein', NULL, NULL, NULL, NULL, NULL, 4),
(207919, NULL, 'G3DSA:3.30.40.10:FF:002292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207920, NULL, 'G3DSA:1.20.1250.20:FF:001206', NULL, NULL, 'Nucleoside permease NupG', NULL, NULL, NULL, NULL, NULL, 4),
(207921, NULL, 'G3DSA:3.80.10.10:FF:002619', NULL, NULL, 'PH domain leucine-rich repeat protein phosphatase, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(207922, NULL, 'G3DSA:1.25.10.10:FF:001413', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207923, NULL, 'G3DSA:3.30.30.10:FF:000009', NULL, NULL, 'Potassium channel toxin alpha-KTx 4.3', NULL, NULL, NULL, NULL, NULL, 4),
(207924, NULL, 'G3DSA:3.20.20.10:FF:000032', NULL, NULL, 'Pyridoxal phosphate homeostasis protein', NULL, NULL, NULL, NULL, NULL, 4),
(207925, NULL, 'G3DSA:3.40.50.300:FF:003665', NULL, NULL, 'ABC transporter, multidrug resistance associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(207926, NULL, 'G3DSA:1.10.3370.10:FF:000029', NULL, NULL, 'Protein translocase subunit SecY', NULL, NULL, NULL, NULL, NULL, 4),
(207927, NULL, 'G3DSA:3.40.50.2000:FF:000835', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207928, NULL, 'G3DSA:3.40.50.150:FF:001231', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207929, NULL, 'G3DSA:3.90.1280.10:FF:000002', NULL, NULL, 'Hsp33_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(207930, NULL, 'G3DSA:2.130.10.10:FF:003159', NULL, NULL, 'DDB1 and CUL4-associated factor 11', NULL, NULL, NULL, NULL, NULL, 4),
(207931, NULL, 'G3DSA:3.80.10.10:FF:004536', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207932, NULL, 'G3DSA:3.30.160.60:FF:003052', NULL, NULL, 'histone H4 transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(207933, NULL, 'G3DSA:2.30.42.10:FF:000516', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207934, NULL, 'G3DSA:3.10.20.90:FF:000191', NULL, NULL, 'FERM domain-containing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(207935, NULL, 'G3DSA:3.40.50.170:FF:000040', NULL, NULL, 'Formyltransferase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(207936, NULL, 'G3DSA:4.10.1000.10:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207937, NULL, 'G3DSA:1.10.510.10:FF:000980', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207938, NULL, 'G3DSA:3.30.70.370:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207939, NULL, 'G3DSA:3.30.365.10:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207940, NULL, 'G3DSA:1.20.1560.10:FF:000119', NULL, NULL, 'ATP binding cassette subfamily C member 5', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(207941, NULL, 'G3DSA:3.30.430.20:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207942, NULL, 'G3DSA:3.30.70.660:FF:000013', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(207943, NULL, 'G3DSA:3.40.50.150:FF:001326', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207944, NULL, 'G3DSA:2.30.40.10:FF:000113', NULL, NULL, 'Urease', NULL, NULL, NULL, NULL, NULL, 4),
(207945, NULL, 'G3DSA:2.30.40.10:FF:000001', NULL, NULL, 'Dihydropyrimidinase like 2', NULL, NULL, NULL, NULL, NULL, 4),
(207946, NULL, 'G3DSA:2.70.20.10:FF:000009', NULL, NULL, 'DNA topoisomerase 3', NULL, NULL, NULL, NULL, NULL, 4),
(207947, NULL, 'G3DSA:3.30.70.3250:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207948, NULL, 'G3DSA:1.25.10.10:FF:002841', NULL, NULL, 'Protein phosphatase 2A regulatory subunit A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207949, NULL, 'G3DSA:3.40.140.70:FF:000016', NULL, NULL, 'Autophagy related 7', NULL, NULL, NULL, NULL, NULL, 4),
(207950, NULL, 'G3DSA:3.40.630.40:FF:000011', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(207951, NULL, 'G3DSA:3.90.226.10:FF:000254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207952, NULL, 'G3DSA:3.40.50.300:FF:001309', NULL, NULL, 'RAB7A, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(207953, NULL, 'G3DSA:3.30.200.20:FF:000481', NULL, NULL, 'Wall-associated receptor kinase-like 14', NULL, NULL, NULL, NULL, NULL, 4),
(207954, NULL, 'G3DSA:3.30.70.2850:FF:000019', NULL, NULL, 'RNA polymerase I largest subunit', NULL, NULL, NULL, NULL, NULL, 4),
(207955, NULL, 'G3DSA:4.10.400.20:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207956, NULL, 'G3DSA:3.40.50.1110:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207957, NULL, 'G3DSA:1.50.40.10:FF:000008', NULL, NULL, 'Mitochondrial uncoupling protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(207958, NULL, 'G3DSA:1.25.40.10:FF:001241', NULL, NULL, 'Tetratricopeptide repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207959, NULL, 'G3DSA:1.10.720.30:FF:000001', NULL, NULL, 'E3 SUMO-protein ligase PIAS2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(207960, NULL, 'G3DSA:3.30.1490.20:FF:000068', NULL, NULL, 'D-alanyl-alanine synthetase A', NULL, NULL, NULL, NULL, NULL, 4),
(207961, NULL, 'G3DSA:3.30.1330.30:FF:000015', NULL, NULL, 'H/ACA ribonucleoprotein complex subunit NHP2', NULL, NULL, NULL, NULL, NULL, 4),
(207962, NULL, 'G3DSA:1.20.5.100:FF:000014', NULL, NULL, 'Cytochrome c1, heme protein', NULL, NULL, NULL, NULL, NULL, 4),
(207963, NULL, 'G3DSA:3.20.20.140:FF:000119', NULL, NULL, 'Deoxyribonuclease Tat-D', NULL, NULL, NULL, NULL, NULL, 4),
(207964, NULL, 'G3DSA:1.25.40.10:FF:004467', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g10690', NULL, NULL, NULL, NULL, NULL, 4),
(207965, NULL, 'G3DSA:1.10.400.10:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207966, NULL, 'G3DSA:1.25.40.10:FF:003736', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207967, NULL, 'G3DSA:3.40.30.10:FF:000357', NULL, NULL, 'Thioredoxin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(207968, NULL, 'G3DSA:3.40.50.150:FF:000837', NULL, NULL, 'Protein-L-isoaspartate O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(207969, NULL, 'G3DSA:3.30.70.3270:FF:000016', NULL, NULL, 'F(420)H(2) dehydrogenase, subunit FpoI', NULL, NULL, NULL, NULL, NULL, 4),
(207970, NULL, 'G3DSA:3.30.70.1470:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207971, NULL, 'G3DSA:1.10.238.10:FF:001234', NULL, NULL, 'Putative calcium-binding protein CML15', NULL, NULL, NULL, NULL, NULL, 4),
(207972, NULL, 'G3DSA:3.60.20.10:FF:000249', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207973, NULL, 'G3DSA:2.20.28.200:FF:000011', NULL, NULL, 'Sir2-type regulatory transcription factor silent information regulator protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(207974, NULL, 'G3DSA:2.40.30.10:FF:000197', NULL, NULL, 'Nitrate reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(207975, NULL, 'G3DSA:3.10.20.90:FF:000983', NULL, NULL, 'Sorting nexin-17-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(207976, NULL, 'G3DSA:1.25.40.250:FF:000004', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit K', NULL, NULL, NULL, NULL, NULL, 4),
(207977, NULL, 'G3DSA:1.20.58.60:FF:000418', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(207978, NULL, 'G3DSA:1.10.510.10:FF:004009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207979, NULL, 'G3DSA:2.10.25.10:FF:001456', NULL, NULL, 'signal peptide, CUB and EGF-like domain-containing protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(207980, NULL, 'G3DSA:1.20.1560.10:FF:000249', NULL, NULL, 'HAlF transporter (PGP related)', NULL, NULL, NULL, NULL, NULL, 4),
(207981, NULL, 'G3DSA:2.60.40.10:FF:003395', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(207982, NULL, 'G3DSA:2.30.39.10:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207983, NULL, 'G3DSA:4.10.1060.10:FF:000059', NULL, NULL, 'Zinc finger Ran-binding domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(207984, NULL, 'G3DSA:3.40.50.1700:FF:000048', NULL, NULL, 'Glycoside hydrolase family 3 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(207985, NULL, 'G3DSA:3.50.50.60:FF:001109', NULL, NULL, 'Kynurenine 3-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(207986, NULL, 'G3DSA:2.60.120.920:FF:000119', NULL, NULL, 'Si:dkey-261j11.3', NULL, NULL, NULL, NULL, NULL, 4),
(207987, NULL, 'G3DSA:2.40.50.90:FF:000177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207988, NULL, 'G3DSA:3.30.1240.10:FF:000047', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(207989, NULL, 'G3DSA:2.170.120.30:FF:000010', NULL, NULL, 'Putative secreted protein associated with spyDAC', NULL, NULL, NULL, NULL, NULL, 4),
(207990, NULL, 'G3DSA:2.170.210.10:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(207991, NULL, 'G3DSA:2.120.10.30:FF:000130', NULL, NULL, 'Type II transmembrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(207992, NULL, 'G3DSA:3.40.50.720:FF:000362', NULL, NULL, 'L-lactate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(207993, NULL, 'G3DSA:3.40.50.720:FF:000250', NULL, NULL, 'YciK family oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(207994, NULL, 'G3DSA:3.40.50.12160:FF:000010', NULL, NULL, 'Ribosomal protein S12 methylthiotransferase RimO', NULL, NULL, NULL, NULL, NULL, 4),
(207995, NULL, 'G3DSA:3.40.50.300:FF:004963', NULL, NULL, 'Nucleolar GTP-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(207996, NULL, 'G3DSA:2.130.10.10:FF:001343', NULL, NULL, 'Pre-mRNA splicing factor, putative (AFU_orthologue AFUA_8G04590)', NULL, NULL, NULL, NULL, NULL, 4),
(207997, NULL, 'G3DSA:2.130.10.10:FF:003029', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(207998, NULL, 'G3DSA:3.40.50.1820:FF:000308', NULL, NULL, 'Lipase 2', NULL, NULL, NULL, NULL, NULL, 4),
(207999, NULL, 'G3DSA:2.20.100.10:FF:000009', NULL, NULL, 'ADAMTS-like protein 3 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(208000, NULL, 'G3DSA:1.10.287.110:FF:000080', NULL, NULL, 'NAD(P)H-quinone oxidoreductase subunit U chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(208001, NULL, 'G3DSA:3.40.720.10:FF:000234', NULL, NULL, 'FI08016p', NULL, NULL, NULL, NULL, NULL, 4),
(208002, NULL, 'G3DSA:1.20.1260.100:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208003, NULL, 'G3DSA:3.40.630.30:FF:000103', NULL, NULL, 'RNA cytidine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(208004, NULL, 'G3DSA:2.40.50.150:FF:000032', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(208005, NULL, 'G3DSA:2.10.50.10:FF:000008', NULL, NULL, 'Signal peptide, CUB domain and EGF-like domain-containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(208006, NULL, 'G3DSA:1.25.40.10:FF:000510', NULL, NULL, 'Vacuolar assembly protein, putative', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(208007, NULL, 'G3DSA:3.30.420.10:FF:000584', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208008, NULL, 'G3DSA:1.20.1510.10:FF:000055', NULL, NULL, 'Protein CBG10923', NULL, NULL, NULL, NULL, NULL, 4),
(208009, NULL, 'G3DSA:2.30.30.490:FF:000042', NULL, NULL, 'Protein CBR-LIN-40', NULL, NULL, NULL, NULL, NULL, 4),
(208010, NULL, 'G3DSA:2.30.130.10:FF:000026', NULL, NULL, 'tRNA pseudouridine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(208011, NULL, 'G3DSA:3.30.565.10:FF:000032', NULL, NULL, 'Phosphate regulon sensor histidine kinase PhoR', NULL, NULL, NULL, NULL, NULL, 4),
(208012, NULL, 'G3DSA:2.10.25.10:FF:001001', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(208013, NULL, 'G3DSA:1.25.40.20:FF:001699', NULL, NULL, 'Death-associated protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(208014, NULL, 'G3DSA:3.90.180.10:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208015, NULL, 'G3DSA:3.30.160.60:FF:005081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208016, NULL, 'G3DSA:1.10.287.920:FF:000007', NULL, NULL, 'Fungal pheromone mating factor STE2 GPCR-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(208017, NULL, 'G3DSA:1.10.8.720:FF:000005', NULL, NULL, 'Dynein axonemal heavy chain 10', NULL, NULL, NULL, NULL, NULL, 4),
(208018, NULL, 'G3DSA:2.20.100.10:FF:000223', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs adt-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(208019, NULL, 'G3DSA:1.10.1200.10:FF:000146', NULL, NULL, 'Polyketide synthase RzxE', NULL, NULL, NULL, NULL, NULL, 4),
(208020, NULL, 'G3DSA:2.130.10.10:FF:002754', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208021, NULL, 'G3DSA:2.160.20.10:FF:000089', NULL, NULL, 'Right_handed_beta_helix_region /Periplasmic_copper-binding_protein_(NosD)_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(208022, NULL, 'G3DSA:3.30.450.20:FF:000622', NULL, NULL, 'Hypoxia-inducible factor 1 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(208023, NULL, 'G3DSA:3.60.10.10:FF:000294', NULL, NULL, 'AGAP011401-PA', NULL, NULL, NULL, NULL, NULL, 4),
(208024, NULL, 'G3DSA:3.30.760.10:FF:000042', NULL, NULL, 'Eukaryotic translation initiation factor 4E, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208025, NULL, 'G3DSA:1.10.510.10:FF:002778', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208026, NULL, 'G3DSA:1.20.1730.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208027, NULL, 'G3DSA:1.10.630.10:FF:000808', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208028, NULL, 'G3DSA:2.60.120.200:FF:000376', NULL, NULL, 'Extracellular agarase', NULL, NULL, NULL, NULL, NULL, 4),
(208029, NULL, 'G3DSA:4.10.800.30:FF:000002', NULL, NULL, 'Essential meiotic structure-specific endonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(208030, NULL, 'G3DSA:1.20.1250.20:FF:000801', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(208031, NULL, 'G3DSA:3.30.1520.10:FF:000181', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(208032, NULL, 'G3DSA:2.60.120.920:FF:000024', NULL, NULL, 'Ryanodine receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(208033, NULL, 'G3DSA:3.10.129.10:FF:000052', NULL, NULL, 'PaaI family thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(208034, NULL, 'G3DSA:1.10.287.70:FF:000325', NULL, NULL, 'GM10959', NULL, NULL, NULL, NULL, NULL, 4),
(208035, NULL, 'G3DSA:3.30.40.10:FF:000263', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(208036, NULL, 'G3DSA:3.40.30.10:FF:000571', NULL, NULL, 'Glutathione S-transferase kappa 1', NULL, NULL, NULL, NULL, NULL, 4),
(208037, NULL, 'G3DSA:2.60.40.10:FF:005761', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208038, NULL, 'G3DSA:3.90.1150.10:FF:000099', NULL, NULL, 'phosphoserine aminotransferase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(208039, NULL, 'G3DSA:4.10.280.10:FF:000247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(208040, NULL, 'G3DSA:3.40.50.300:FF:001299', NULL, NULL, 'Guanylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(208041, NULL, 'G3DSA:1.10.287.110:FF:000321', NULL, NULL, 'LOC100124938 protein', NULL, NULL, NULL, NULL, NULL, 4),
(208042, NULL, 'G3DSA:3.20.20.80:FF:000704', NULL, NULL, 'Glucosylceramidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208043, NULL, 'G3DSA:3.30.70.100:FF:000194', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208044, NULL, 'G3DSA:3.20.140.10:FF:000019', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(208045, NULL, 'G3DSA:3.90.950.10:FF:000026', NULL, NULL, 'Septum formation protein MAF homologue, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208046, NULL, 'G3DSA:3.10.310.40:FF:000016', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(208047, NULL, 'G3DSA:1.20.120.1920:FF:000009', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(208048, NULL, 'G3DSA:1.10.357.140:FF:000043', NULL, NULL, 'Protoheme IX farnesyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(208049, NULL, 'G3DSA:3.30.310.130:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208050, NULL, 'G3DSA:3.30.160.60:FF:001478', NULL, NULL, 'Zinc finger protein 134', NULL, NULL, NULL, NULL, NULL, 4),
(208051, NULL, 'G3DSA:2.130.10.10:FF:004671', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208052, NULL, 'G3DSA:3.30.70.330:FF:002415', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208053, NULL, 'G3DSA:3.30.930.10:FF:000325', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208054, NULL, 'G3DSA:1.10.1370.40:FF:000009', NULL, NULL, 'Zincin-like metalloproteases family protein', NULL, NULL, NULL, NULL, NULL, 4),
(208055, NULL, 'G3DSA:2.60.40.10:FF:001169', NULL, NULL, 'Macrophage colony-stimulating factor 1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(208056, NULL, 'G3DSA:1.20.1250.20:FF:001757', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(208057, NULL, 'G3DSA:3.30.160.60:FF:005761', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208058, NULL, 'G3DSA:3.30.200.20:FF:002167', NULL, NULL, 'AGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(208059, NULL, 'G3DSA:1.10.8.60:FF:000191', NULL, NULL, 'C4-dicarboxylate transport transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(208060, NULL, 'G3DSA:2.130.10.10:FF:002771', NULL, NULL, 'MAG2-interacting protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(208061, NULL, 'G3DSA:1.25.40.20:FF:001811', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208062, NULL, 'G3DSA:1.10.8.60:FF:000527', NULL, NULL, 'Katanin p60 ATPase-containing subunit A-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(208063, NULL, 'G3DSA:1.25.10.10:FF:001773', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208064, NULL, 'G3DSA:3.80.10.10:FF:003890', NULL, NULL, 'Flyers-cup, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(208065, NULL, 'G3DSA:1.10.510.10:FF:002323', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208066, NULL, 'G3DSA:2.130.10.30:FF:000152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208067, NULL, 'G3DSA:3.40.50.850:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208068, NULL, 'G3DSA:3.40.710.10:FF:000065', NULL, NULL, 'Peptidoglycan D,D-transpeptidase FtsI', NULL, NULL, NULL, NULL, NULL, 4),
(208069, NULL, 'G3DSA:1.10.150.510:FF:000009', NULL, NULL, 'Receptor activity modifying protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(208070, NULL, 'G3DSA:2.40.37.10:FF:000004', NULL, NULL, 'Ornithine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(208071, NULL, 'G3DSA:3.50.50.60:FF:001452', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(208072, NULL, 'G3DSA:3.40.630.10:FF:000013', NULL, NULL, 'carboxypeptidase N catalytic chain', NULL, NULL, NULL, NULL, NULL, 4),
(208073, NULL, 'G3DSA:3.10.105.10:FF:000042', NULL, NULL, 'Oligopeptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(208074, NULL, 'G3DSA:3.40.50.300:FF:007037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208075, NULL, 'G3DSA:1.25.10.30:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208076, NULL, 'G3DSA:1.25.10.10:FF:001290', NULL, NULL, 'Ctnnb2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(208077, NULL, 'G3DSA:3.40.50.720:FF:002048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208078, NULL, 'G3DSA:3.30.230.10:FF:000412', NULL, NULL, 'Mismatch repair endonuclease PMS2', NULL, NULL, NULL, NULL, NULL, 4),
(208079, NULL, 'G3DSA:2.40.230.10:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208080, NULL, 'G3DSA:3.30.40.10:FF:001235', NULL, NULL, 'Lysine-specific demethylase rbr-2 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(208081, NULL, 'G3DSA:3.30.200.20:FF:001318', NULL, NULL, 'Citron rho-interacting serine/threonine kinase a', NULL, NULL, NULL, NULL, NULL, 4),
(208082, NULL, 'G3DSA:3.30.505.10:FF:000040', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(208083, NULL, 'G3DSA:1.20.1640.10:FF:000042', NULL, NULL, 'Export membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(208084, NULL, 'G3DSA:1.25.40.990:FF:000001', NULL, NULL, '26S proteasome non-ATPase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(208085, NULL, 'G3DSA:3.40.1380.10:FF:000010', NULL, NULL, 'ATP synthase gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(208086, NULL, 'G3DSA:3.30.540.10:FF:000059', NULL, NULL, 'Bisphosphate nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(208087, NULL, 'G3DSA:2.60.40.10:FF:001702', NULL, NULL, 'Lymphocyte function-associated antigen 3', NULL, NULL, NULL, NULL, NULL, 4),
(208088, NULL, 'G3DSA:1.25.40.70:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208089, NULL, 'G3DSA:3.30.160.60:FF:001135', NULL, NULL, 'Zinc finger protein 57', NULL, NULL, NULL, NULL, NULL, 4),
(208090, NULL, 'G3DSA:1.20.5.190:FF:000001', NULL, NULL, 'unconventional myosin-Va', NULL, NULL, NULL, NULL, NULL, 4),
(208091, NULL, 'G3DSA:3.30.70.1230:FF:000281', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(208092, NULL, 'G3DSA:3.30.450.60:FF:000056', NULL, NULL, 'AP complex subunit sigma', NULL, NULL, NULL, NULL, NULL, 4),
(208093, NULL, 'G3DSA:2.60.40.10:FF:000522', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(208094, NULL, 'G3DSA:2.60.120.10:FF:000614', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208095, NULL, 'G3DSA:2.170.130.10:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208096, NULL, 'G3DSA:3.80.10.10:FF:000354', NULL, NULL, 'Melanoma antigen preferentially expressed in tumors', NULL, NULL, NULL, NULL, NULL, 4),
(208097, NULL, 'G3DSA:2.30.110.10:FF:000031', NULL, NULL, 'YPR172W', NULL, NULL, NULL, NULL, NULL, 4),
(208098, NULL, 'G3DSA:3.40.50.720:FF:002144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208099, NULL, 'G3DSA:3.30.710.10:FF:000443', NULL, NULL, 'Protein bric-a-brac 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(208100, NULL, 'G3DSA:3.20.20.60:FF:000018', NULL, NULL, 'Methylisocitrate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(208101, NULL, 'G3DSA:3.10.170.10:FF:000001', NULL, NULL, 'Peptidase M4', NULL, NULL, NULL, NULL, NULL, 4),
(208102, NULL, 'G3DSA:1.25.10.10:FF:000924', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208103, NULL, 'G3DSA:1.25.40.90:FF:000039', NULL, NULL, 'Vacuolar protein sorting-associated protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(208104, NULL, 'G3DSA:3.30.160.60:FF:003956', NULL, NULL, 'Zinc finger protein 592', NULL, NULL, NULL, NULL, NULL, 4),
(208105, NULL, 'G3DSA:2.40.50.140:FF:000607', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(208106, NULL, 'G3DSA:3.40.50.300:FF:003114', NULL, NULL, 'mRNA cleavage and polyadenylation factor CLP1', NULL, NULL, NULL, NULL, NULL, 4),
(208107, NULL, 'G3DSA:3.30.160.20:FF:000084', NULL, NULL, 'Ribonuclease 3', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(208108, NULL, 'G3DSA:3.30.450.40:FF:000050', NULL, NULL, 'Transcriptional regulator, IclR family', NULL, NULL, NULL, NULL, NULL, 4),
(208109, NULL, 'G3DSA:3.30.160.60:FF:000859', NULL, NULL, 'myc-associated zinc finger protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(208110, NULL, 'G3DSA:3.40.850.10:FF:000119', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(208111, NULL, 'G3DSA:3.40.50.150:FF:001782', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208112, NULL, 'G3DSA:4.10.410.10:FF:000073', NULL, NULL, 'Kunitz-type protein bli-5', NULL, NULL, NULL, NULL, NULL, 4),
(208113, NULL, 'G3DSA:1.10.3080.10:FF:000041', NULL, NULL, 'Os03g0695700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(208114, NULL, 'G3DSA:1.10.540.10:FF:000026', NULL, NULL, 'Acyl-CoA dehydrogenase medium chain', NULL, NULL, NULL, NULL, NULL, 4),
(208115, NULL, 'G3DSA:3.40.390.10:FF:000191', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208116, NULL, 'G3DSA:3.30.70.330:FF:001229', NULL, NULL, 'Os05g0376000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(208117, NULL, 'G3DSA:3.40.605.10:FF:000051', NULL, NULL, 'Carnitine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(208118, NULL, 'G3DSA:2.130.10.10:FF:003390', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208119, NULL, 'G3DSA:1.20.5.170:FF:000237', NULL, NULL, 'Transcription factor MafB', NULL, NULL, NULL, NULL, NULL, 4),
(208120, NULL, 'G3DSA:3.40.33.10:FF:000173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208121, NULL, 'G3DSA:1.20.1070.10:FF:000133', NULL, NULL, 'Glucagon receptor a', NULL, NULL, NULL, NULL, NULL, 4),
(208122, NULL, 'G3DSA:2.10.110.10:FF:000350', NULL, NULL, 'AGAP008979-PA', NULL, NULL, NULL, NULL, NULL, 4),
(208123, NULL, 'G3DSA:3.40.50.1820:FF:001719', NULL, NULL, 'Alanine aminotransferase 2 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(208124, NULL, 'G3DSA:3.30.40.10:FF:002303', NULL, NULL, 'AGAP007095-PA', NULL, NULL, NULL, NULL, NULL, 4),
(208125, NULL, 'G3DSA:3.30.200.20:FF:001762', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208126, NULL, 'G3DSA:1.20.120.1900:FF:000003', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(208127, NULL, 'G3DSA:2.130.10.10:FF:004569', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208128, NULL, 'G3DSA:1.20.1090.10:FF:000033', NULL, NULL, 'NADH-dependent butanol dehydrogenase A', NULL, NULL, NULL, NULL, NULL, 4),
(208129, NULL, 'G3DSA:2.40.290.10:FF:000030', NULL, NULL, 'ATP-dependent DNA helicase II subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(208130, NULL, 'G3DSA:3.30.60.190:FF:000016', NULL, NULL, 'HIT zinc finger, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208131, NULL, 'G3DSA:1.20.1560.10:FF:000333', NULL, NULL, 'ATP-binding cassette transporter', NULL, NULL, NULL, NULL, NULL, 4),
(208132, NULL, 'G3DSA:3.30.70.330:FF:002174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208133, NULL, 'G3DSA:1.10.4030.10:FF:000004', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(208134, NULL, 'G3DSA:2.60.120.200:FF:000246', NULL, NULL, 'L-type lectin-domain containing receptor kinase V.9', NULL, NULL, NULL, NULL, NULL, 4),
(208135, NULL, 'G3DSA:1.50.40.10:FF:000238', NULL, NULL, 'Mitochondrial ornithine transporter 1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(208136, NULL, 'G3DSA:3.40.640.10:FF:000284', NULL, NULL, 'Low specificity L-threonine aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(208137, NULL, 'G3DSA:1.10.287.70:FF:000668', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208138, NULL, 'G3DSA:3.40.50.1000:FF:000602', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208139, NULL, 'G3DSA:3.30.190.20:FF:000023', NULL, NULL, 'Ribosomal protein L1p/L10e family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208140, NULL, 'G3DSA:2.60.490.10:FF:000012', NULL, NULL, 'P2X purinoceptor', NULL, NULL, NULL, NULL, NULL, 4),
(208141, NULL, 'G3DSA:3.80.10.10:FF:001422', NULL, NULL, 'GD22564', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(208142, NULL, 'G3DSA:3.40.630.30:FF:000019', NULL, NULL, 'RNA cytidine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(208143, NULL, 'G3DSA:3.30.70.330:FF:001898', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208144, NULL, 'G3DSA:3.40.1490.10:FF:000001', NULL, NULL, 'Peptidyl-tRNA hydrolase 2', NULL, NULL, NULL, NULL, NULL, 4),
(208145, NULL, 'G3DSA:3.10.310.20:FF:000010', NULL, NULL, 'Manganese-dependent inorganic pyrophosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208146, NULL, 'G3DSA:3.20.20.220:FF:000031', NULL, NULL, 'Bifunctional protein PutA', NULL, NULL, NULL, NULL, NULL, 4),
(208147, NULL, 'G3DSA:3.30.70.330:FF:000712', NULL, NULL, 'NONO (Conserved nuclear protein, aka PSF) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(208148, NULL, 'G3DSA:1.10.287.470:FF:000069', NULL, NULL, 'RND multidrug efflux membrane fusion protein MexE', NULL, NULL, NULL, NULL, NULL, 4),
(208149, NULL, 'G3DSA:1.10.1040.10:FF:000032', NULL, NULL, '6-phosphogluconate dehydrogenase, decarboxylating', NULL, NULL, NULL, NULL, NULL, 4),
(208150, NULL, 'G3DSA:3.30.160.60:FF:001039', NULL, NULL, 'zinc finger and BTB domain-containing protein 17 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(208151, NULL, 'G3DSA:2.60.120.920:FF:000136', NULL, NULL, 'E3 ubiquitin-protein ligase Midline-1', NULL, NULL, NULL, NULL, NULL, 4),
(208152, NULL, 'G3DSA:2.10.70.10:FF:000122', NULL, NULL, 'Beta-2-glycoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(208153, NULL, 'G3DSA:2.30.30.100:FF:000212', NULL, NULL, 'U7 snRNA-associated Sm-like protein LSm11', NULL, NULL, NULL, NULL, NULL, 4),
(208154, NULL, 'G3DSA:2.170.270.10:FF:000211', NULL, NULL, 'SET domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(208155, NULL, 'G3DSA:3.40.50.300:FF:006520', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(208156, NULL, 'G3DSA:1.25.40.20:FF:001356', NULL, NULL, 'Spatzle 5', NULL, NULL, NULL, NULL, NULL, 4),
(208157, NULL, 'G3DSA:1.10.238.10:FF:000728', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208158, NULL, 'G3DSA:2.10.90.10:FF:000005', NULL, NULL, 'Inhibin beta A chain', NULL, NULL, NULL, NULL, NULL, 4),
(208159, NULL, 'G3DSA:3.20.20.80:FF:000125', NULL, NULL, 'CTS1p Endochitinase', NULL, NULL, NULL, NULL, NULL, 4),
(208160, NULL, 'G3DSA:1.25.40.10:FF:001819', NULL, NULL, 'Spliceosome associated factor 3, U4/U6 recycling protein', NULL, NULL, NULL, NULL, NULL, 4),
(208161, NULL, 'G3DSA:3.30.420.40:FF:000222', NULL, NULL, 'Putative glycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(208162, NULL, 'G3DSA:1.20.1070.10:FF:000493', NULL, NULL, 'Adhesion G protein-coupled receptor G1', NULL, NULL, NULL, NULL, NULL, 4),
(208163, NULL, 'G3DSA:1.20.58.70:FF:000085', NULL, NULL, 'Putative snare protein pep12/vam3/syntaxin 7/syntaxin 17', NULL, NULL, NULL, NULL, NULL, 4),
(208164, NULL, 'G3DSA:2.170.16.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208165, NULL, 'G3DSA:3.20.20.80:FF:000564', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208166, NULL, 'G3DSA:3.40.50.300:FF:000337', NULL, NULL, 'ABC transporter G family member 22', NULL, NULL, NULL, NULL, NULL, 4),
(208167, NULL, 'G3DSA:2.60.40.420:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208168, NULL, 'G3DSA:2.40.50.1070:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208169, NULL, 'G3DSA:1.25.10.10:FF:002599', NULL, NULL, 'Protein CBG03609', NULL, NULL, NULL, NULL, NULL, 4),
(208170, NULL, 'G3DSA:1.20.58.60:FF:000548', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(208171, NULL, 'G3DSA:3.40.50.80:FF:000222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208172, NULL, 'G3DSA:3.30.420.10:FF:000016', NULL, NULL, 'Ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(208173, NULL, 'G3DSA:2.60.120.10:FF:000131', NULL, NULL, '3-hydroxyanthranilate 3,4-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(208174, NULL, 'G3DSA:1.10.340.70:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(208175, NULL, 'G3DSA:3.30.110.110:FF:000010', NULL, NULL, 'Double-strand break repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(208176, NULL, 'G3DSA:3.30.160.60:FF:002888', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208177, NULL, 'G3DSA:1.10.510.10:FF:001497', NULL, NULL, 'Myosin light chain kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208178, NULL, 'G3DSA:2.40.50.90:FF:000047', NULL, NULL, 'Probable staphylococcal-like nuclease CAN3', NULL, NULL, NULL, NULL, NULL, 4),
(208179, NULL, 'G3DSA:1.10.1300.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208180, NULL, 'G3DSA:3.30.420.40:FF:000582', NULL, NULL, 'Actin-like protein ARP6', NULL, NULL, NULL, NULL, NULL, 4),
(208181, NULL, 'G3DSA:3.90.550.10:FF:000046', NULL, NULL, 'Mannose-1-phosphate guanylyltransferase (GDP)', NULL, NULL, NULL, NULL, NULL, 4),
(208182, NULL, 'G3DSA:1.10.10.10:FF:001019', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(208183, NULL, 'G3DSA:1.20.1070.10:FF:000363', NULL, NULL, 'Glucagon receptor', NULL, NULL, NULL, NULL, NULL, 4),
(208184, NULL, 'G3DSA:2.40.50.120:FF:000034', NULL, NULL, 'Netrin 4', NULL, NULL, NULL, NULL, NULL, 4),
(208185, NULL, 'G3DSA:2.60.120.260:FF:000348', NULL, NULL, 'Putative glucuronoxylan glucuronosyltransferase F8H', NULL, NULL, NULL, NULL, NULL, 4),
(208186, NULL, 'G3DSA:3.40.50.720:FF:000019', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(P)+]', NULL, NULL, NULL, NULL, NULL, 4),
(208187, NULL, 'G3DSA:3.30.1400.10:FF:000003', NULL, NULL, 'Cell division protein ZipA', NULL, NULL, NULL, NULL, NULL, 4),
(208188, NULL, 'G3DSA:3.40.50.300:FF:005008', NULL, NULL, 'Septin 9', NULL, NULL, NULL, NULL, NULL, 4),
(208189, NULL, 'G3DSA:1.25.40.10:FF:004355', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(208190, NULL, 'G3DSA:1.20.930.20:FF:000012', NULL, NULL, 'Mixed lineage kinase domain like pseudokinase', NULL, NULL, NULL, NULL, NULL, 4),
(208191, NULL, 'G3DSA:3.30.40.10:FF:000746', NULL, NULL, 'E3 ubiquitin-protein ligase RHF2A', NULL, NULL, NULL, NULL, NULL, 4),
(208192, NULL, 'G3DSA:3.40.50.360:FF:000119', NULL, NULL, 'Flavo-diiron protein FprA1', NULL, NULL, NULL, NULL, NULL, 4),
(208193, NULL, 'G3DSA:3.40.630.10:FF:000356', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208194, NULL, 'G3DSA:3.30.40.10:FF:000616', NULL, NULL, 'Asi3p', NULL, NULL, NULL, NULL, NULL, 4),
(208195, NULL, 'G3DSA:1.10.533.10:FF:000010', NULL, NULL, 'Ankyrin 1', NULL, NULL, NULL, NULL, NULL, 4),
(208196, NULL, 'G3DSA:3.65.10.10:FF:000013', NULL, NULL, 'UDP-N-acetylglucosamine 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(208197, NULL, 'G3DSA:2.60.40.10:FF:002888', NULL, NULL, 'Leptin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(208198, NULL, 'G3DSA:3.10.170.20:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208199, NULL, 'G3DSA:3.30.420.270:FF:000010', NULL, NULL, 'Transport energizing protein, ExbD/TolR family', NULL, NULL, NULL, NULL, NULL, 4),
(208200, NULL, 'G3DSA:3.30.70.2000:FF:000006', NULL, NULL, 'BTB/POZ domain-containing protein KCTD5', NULL, NULL, NULL, NULL, NULL, 4),
(208201, NULL, 'G3DSA:1.20.1740.10:FF:000235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208202, NULL, 'G3DSA:2.120.10.10:FF:000023', NULL, NULL, 'Trans-sialidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208203, NULL, 'G3DSA:1.10.530.10:FF:000071', NULL, NULL, 'Basic endochitinase B', NULL, NULL, NULL, NULL, NULL, 4),
(208204, NULL, 'G3DSA:2.70.170.10:FF:000031', NULL, NULL, 'AcetylCholine Receptor', NULL, NULL, NULL, NULL, NULL, 4),
(208205, NULL, 'G3DSA:3.30.300.20:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208206, NULL, 'G3DSA:3.40.1180.10:FF:000011', NULL, NULL, 'NUS1p putative prenyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(208207, NULL, 'G3DSA:1.10.555.10:FF:000055', NULL, NULL, 'Similar to GTPase-activating protein testicular GAP1', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(208208, NULL, 'G3DSA:3.30.1330.80:FF:000018', NULL, NULL, 'AT-hook motif nuclear-localized protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(208209, NULL, 'G3DSA:1.10.418.60:FF:000021', NULL, NULL, 'Kinetochore protein nuf2', NULL, NULL, NULL, NULL, NULL, 4),
(208210, NULL, 'G3DSA:3.30.310.10:FF:000025', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(208211, NULL, 'G3DSA:2.10.25.10:FF:000028', NULL, NULL, 'Signal peptide, CUB domain and EGF-like domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(208212, NULL, 'G3DSA:2.70.170.10:FF:000059', NULL, NULL, 'Uncharacterized protein, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(208213, NULL, 'G3DSA:2.40.270.10:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208214, NULL, 'G3DSA:1.20.1270.60:FF:000005', NULL, NULL, 'Sphingolipid long chain base-responsive pil1', NULL, NULL, NULL, NULL, NULL, 4),
(208215, NULL, 'G3DSA:2.40.430.10:FF:000002', NULL, NULL, 'Maltose/maltodextrin transport system permease protein MalF', NULL, NULL, NULL, NULL, NULL, 4),
(208216, NULL, 'G3DSA:2.60.40.1090:FF:000007', NULL, NULL, 'Fimbrial-like protein FimF', NULL, NULL, NULL, NULL, NULL, 4),
(208217, NULL, 'G3DSA:2.60.120.330:FF:000156', NULL, NULL, 'Os05g0514600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(208218, NULL, 'G3DSA:3.20.20.80:FF:000221', NULL, NULL, 'PLASMODESMATA CALLOSE-BINDING PROTEIN 5', NULL, NULL, NULL, NULL, NULL, 4),
(208219, NULL, 'G3DSA:3.30.420.40:FF:001071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208220, NULL, 'G3DSA:1.10.510.10:FF:003751', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208221, NULL, 'G3DSA:3.30.40.10:FF:002180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208222, NULL, 'G3DSA:2.60.40.10:FF:004575', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208223, NULL, 'G3DSA:2.60.40.60:FF:000172', NULL, NULL, 'cadherin-23 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(208224, NULL, 'G3DSA:3.40.50.10190:FF:000172', NULL, NULL, 'DNA topoisomerase II binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(208225, NULL, 'G3DSA:3.20.20.140:FF:000203', NULL, NULL, 'Pyrimidine deaminase archaeal predicted', NULL, NULL, NULL, NULL, NULL, 4),
(208226, NULL, 'G3DSA:3.30.70.260:FF:000112', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(208227, NULL, 'G3DSA:3.30.1330.30:FF:000032', NULL, NULL, 'Eukaryotic peptide chain release factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(208228, NULL, 'G3DSA:3.80.10.10:FF:001765', NULL, NULL, 'Toll-9, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(208229, NULL, 'G3DSA:1.25.40.20:FF:000530', NULL, NULL, 'SH3 and multiple ankyrin repeat domains protein', NULL, NULL, NULL, NULL, NULL, 4),
(208230, NULL, 'G3DSA:3.40.50.300:FF:003777', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208231, NULL, 'G3DSA:2.130.10.10:FF:005188', NULL, NULL, 'POC1 centriolar protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(208232, NULL, 'G3DSA:3.30.420.10:FF:000146', NULL, NULL, 'Endogenous retrovirus group K member 6 Pol protein', NULL, NULL, NULL, NULL, NULL, 4),
(208233, NULL, 'G3DSA:3.80.10.10:FF:002041', NULL, NULL, 'Protein artichoke', NULL, NULL, NULL, NULL, NULL, 4),
(208234, NULL, 'G3DSA:3.30.160.60:FF:003164', NULL, NULL, 'Zinc finger and BTB domain-containing 17', NULL, NULL, NULL, NULL, NULL, 4),
(208235, NULL, 'G3DSA:3.40.50.150:FF:001343', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208236, NULL, 'G3DSA:3.60.15.10:FF:000282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208237, NULL, 'G3DSA:2.10.25.10:FF:000484', NULL, NULL, 'Crumbs 1, cell polarity complex component', NULL, NULL, NULL, NULL, NULL, 4),
(208238, NULL, 'G3DSA:1.10.260.40:FF:000087', NULL, NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', NULL, NULL, NULL, NULL, NULL, 4),
(208239, NULL, 'G3DSA:1.25.40.10:FF:003506', NULL, NULL, 'DnaJ homolog subfamily C member 7 homolog', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(208240, NULL, 'G3DSA:1.20.120.1780:FF:000012', NULL, NULL, '4-hydroxybenzoate solanesyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(208241, NULL, 'G3DSA:2.60.40.10:FF:001141', NULL, NULL, 'Down syndrome cell adhesion molecule 4, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(208242, NULL, 'G3DSA:2.10.220.10:FF:000111', NULL, NULL, 'Furin2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208243, NULL, 'G3DSA:3.40.50.300:FF:006880', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208244, NULL, 'G3DSA:2.60.120.290:FF:000104', NULL, NULL, 'Multiple EGF like domains 8', NULL, NULL, NULL, NULL, NULL, 4),
(208245, NULL, 'G3DSA:1.25.40.10:FF:001157', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(208246, NULL, 'G3DSA:1.25.10.10:FF:001661', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208247, NULL, 'G3DSA:1.10.150.20:FF:000331', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(208248, NULL, 'G3DSA:1.10.510.10:FF:003964', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208249, NULL, 'G3DSA:2.90.10.30:FF:000008', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase SD3-1', NULL, NULL, NULL, NULL, NULL, 4),
(208250, NULL, 'G3DSA:2.70.150.10:FF:000277', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(208251, NULL, 'G3DSA:3.30.1330.10:FF:000037', NULL, NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase (AIRS) (PurM)', NULL, NULL, NULL, NULL, NULL, 4),
(208252, NULL, 'G3DSA:3.30.420.10:FF:000707', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208253, NULL, 'G3DSA:3.10.20.30:FF:000100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208254, NULL, 'G3DSA:3.10.450.490:FF:000002', NULL, NULL, 'Neutral protease B', NULL, NULL, NULL, NULL, NULL, 4),
(208255, NULL, 'G3DSA:2.20.70.10:FF:000262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208256, NULL, 'G3DSA:2.20.28.230:FF:000003', NULL, NULL, 'Interleukin-2 receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(208257, NULL, 'G3DSA:1.25.40.10:FF:000061', NULL, NULL, 'Tetratricopeptide repeat domain 17', NULL, NULL, NULL, NULL, NULL, 4),
(208258, NULL, 'G3DSA:3.90.640.10:FF:000036', NULL, NULL, 'Actin-like protein ARP6', NULL, NULL, NULL, NULL, NULL, 4),
(208259, NULL, 'G3DSA:3.40.50.300:FF:006548', NULL, NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 10, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(208260, NULL, 'G3DSA:1.20.1050.130:FF:000041', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(208261, NULL, 'G3DSA:1.10.8.60:FF:000415', NULL, NULL, 'Differentiation specific element binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208262, NULL, 'G3DSA:1.10.472.80:FF:000169', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208263, NULL, 'G3DSA:3.10.620.30:FF:000003', NULL, NULL, 'Centrosomal protein of 76 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(208264, NULL, 'G3DSA:1.25.40.10:FF:003287', NULL, NULL, 'TPR repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208265, NULL, 'G3DSA:3.30.2020.30:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208266, NULL, 'G3DSA:1.20.1250.20:FF:001869', NULL, NULL, 'LacY', NULL, NULL, NULL, NULL, NULL, 4),
(208267, NULL, 'G3DSA:2.40.128.80:FF:000005', NULL, NULL, 'Dipeptidyl aminopeptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(208268, NULL, 'G3DSA:4.10.1000.10:FF:000067', NULL, NULL, 'Zinc finger C-x8-C-x5-C-x3-H type family protein', NULL, NULL, NULL, NULL, NULL, 4),
(208269, NULL, 'G3DSA:3.40.50.300:FF:003906', NULL, NULL, 'Macrolide export ATP-binding/permease protein MacB', NULL, NULL, NULL, NULL, NULL, 4),
(208270, NULL, 'G3DSA:3.30.200.20:FF:000930', NULL, NULL, 'Protein CBG20555', NULL, NULL, NULL, NULL, NULL, 4),
(208271, NULL, 'G3DSA:1.20.1070.10:FF:002179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208272, NULL, 'G3DSA:1.20.120.1750:FF:000020', NULL, NULL, 'ATP-dependent RNA helicase DEAH12 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(208273, NULL, 'G3DSA:3.40.50.300:FF:000129', NULL, NULL, 'Replication factor C subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(208274, NULL, 'G3DSA:3.90.550.10:FF:000389', NULL, NULL, 'UDP-glucose ceramide glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(208275, NULL, 'G3DSA:2.120.10.80:FF:000004', NULL, NULL, 'Ectoderm-neural cortex protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(208276, NULL, 'G3DSA:4.10.375.10:FF:000001', NULL, NULL, 'Lipoxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(208277, NULL, 'G3DSA:3.20.20.80:FF:000333', NULL, NULL, 'Glycogen debranching enzyme Gdb1, putative (AFU_orthologue AFUA_1G02140)', NULL, NULL, NULL, NULL, NULL, 4),
(208278, NULL, 'G3DSA:3.10.280.10:FF:000021', NULL, NULL, 'Os01g0143700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(208279, NULL, 'G3DSA:3.30.428.10:FF:000028', NULL, NULL, 'Galactose-1-phosphate uridylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(208280, NULL, 'G3DSA:2.130.10.10:FF:003608', NULL, NULL, 'Sema domain, immunoglobulin domain (Ig), transmembrane domain (TM) and short cytoplasmic domain, (semaphorin) 4Aa', NULL, NULL, NULL, NULL, NULL, 4),
(208281, NULL, 'G3DSA:3.30.50.10:FF:000095', NULL, NULL, 'Glucocorticoid receptor isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(208282, NULL, 'G3DSA:3.40.50.1980:FF:000093', NULL, NULL, 'Nitrogenase molybdenum-iron protein beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(208283, NULL, 'G3DSA:3.40.50.300:FF:001765', NULL, NULL, 'ABC transporter B family member 6', NULL, NULL, NULL, NULL, NULL, 4),
(208284, NULL, 'G3DSA:1.10.510.10:FF:003380', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208285, NULL, 'G3DSA:3.30.450.20:FF:000061', NULL, NULL, 'Histidine kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(208286, NULL, 'G3DSA:2.120.10.30:FF:000473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208287, NULL, 'G3DSA:1.10.3200.20:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208288, NULL, 'G3DSA:2.170.270.10:FF:000003', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(208289, NULL, 'G3DSA:3.20.20.100:FF:000118', NULL, NULL, 'AKR1E2 isoform 12', NULL, NULL, NULL, NULL, NULL, 4),
(208290, NULL, 'G3DSA:2.130.10.10:FF:005637', NULL, NULL, 'Coatomer subunit beta''-3', NULL, NULL, NULL, NULL, NULL, 4),
(208291, NULL, 'G3DSA:2.60.40.10:FF:005081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208292, NULL, 'G3DSA:1.10.20.10:FF:000003', NULL, NULL, 'Histone H2B', NULL, NULL, NULL, NULL, NULL, 4),
(208293, NULL, 'G3DSA:1.20.1050.10:FF:000036', NULL, NULL, 'Putative glutamyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(208294, NULL, 'G3DSA:2.40.70.10:FF:000188', NULL, NULL, 'Sap99p', NULL, NULL, NULL, NULL, NULL, 4),
(208295, NULL, 'G3DSA:2.10.60.10:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208296, NULL, 'G3DSA:1.10.443.10:FF:000014', NULL, NULL, 'Site-specific recombinase, phage integrase family', NULL, NULL, NULL, NULL, NULL, 4),
(208297, NULL, 'G3DSA:3.40.50.300:FF:007167', NULL, NULL, 'ADP-ribosylation factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208298, NULL, 'G3DSA:2.40.50.140:FF:000484', NULL, NULL, 'Putative activity regulator of membrane protease YbbK', NULL, NULL, NULL, NULL, NULL, 4),
(208299, NULL, 'G3DSA:3.90.70.80:FF:000018', NULL, NULL, 'OTU domain-containing protein 5-B', NULL, NULL, NULL, NULL, NULL, 4),
(208300, NULL, 'G3DSA:3.40.630.30:FF:000463', NULL, NULL, 'Sll1647 protein', NULL, NULL, NULL, NULL, NULL, 4),
(208301, NULL, 'G3DSA:3.30.310.80:FF:000006', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(208302, NULL, 'G3DSA:3.30.160.60:FF:003501', NULL, NULL, 'Zinc finger imprinted 2', NULL, NULL, NULL, NULL, NULL, 4),
(208303, NULL, 'G3DSA:3.40.50.300:FF:006975', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208304, NULL, 'G3DSA:3.30.70.250:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208305, NULL, 'G3DSA:3.30.60.30:FF:000040', NULL, NULL, 'Agrin, putative', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(208306, NULL, 'G3DSA:3.30.160.60:FF:004120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208307, NULL, 'G3DSA:2.40.70.10:FF:000300', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208308, NULL, 'G3DSA:3.60.10.10:FF:000304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208309, NULL, 'G3DSA:3.40.50.620:FF:000219', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(208310, NULL, 'G3DSA:3.40.50.10420:FF:000044', NULL, NULL, 'Protein CBG12218', NULL, NULL, NULL, NULL, NULL, 4),
(208311, NULL, 'G3DSA:3.30.260.10:FF:000032', NULL, NULL, 'T-complex protein 1 subunit theta', NULL, NULL, NULL, NULL, NULL, 4),
(208312, NULL, 'G3DSA:2.60.40.10:FF:003052', NULL, NULL, 'Interleukin 18 receptor accessory protein', NULL, NULL, NULL, NULL, NULL, 4),
(208313, NULL, 'G3DSA:2.60.120.650:FF:000134', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(208314, NULL, 'G3DSA:3.30.30.30:FF:000004', NULL, NULL, 'hypoxia up-regulated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(208315, NULL, 'G3DSA:1.20.58.1030:FF:000004', NULL, NULL, 'DNA replication complex GINS protein PSF1', NULL, NULL, NULL, NULL, NULL, 4),
(208316, NULL, 'G3DSA:3.20.20.100:FF:000219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208317, NULL, 'G3DSA:2.130.10.10:FF:005738', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208318, NULL, 'G3DSA:3.40.50.300:FF:005351', NULL, NULL, 'RecBCD enzyme subunit RecC', NULL, NULL, NULL, NULL, NULL, 4),
(208319, NULL, 'G3DSA:1.25.40.20:FF:001587', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208320, NULL, 'G3DSA:3.40.50.300:FF:001068', NULL, NULL, 'RecBCD enzyme subunit RecC', NULL, NULL, NULL, NULL, NULL, 4),
(208321, NULL, 'G3DSA:2.60.40.10:FF:003956', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208322, NULL, 'G3DSA:1.20.5.170:FF:000006', NULL, NULL, 'fos-related antigen 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(208323, NULL, 'G3DSA:2.30.30.140:FF:000084', NULL, NULL, 'Tudor and KH domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(208324, NULL, 'G3DSA:2.60.120.200:FF:000033', NULL, NULL, 'pikachurin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(208325, NULL, 'G3DSA:3.40.190.10:FF:000428', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(208326, NULL, 'G3DSA:3.80.10.10:FF:000933', NULL, NULL, 'RNI-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(208327, NULL, 'G3DSA:1.20.1050.10:FF:000250', NULL, NULL, 'Glutathione S-transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(208328, NULL, 'G3DSA:1.10.10.350:FF:000010', NULL, NULL, 'Glutamate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(208329, NULL, 'G3DSA:3.40.50.10140:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208330, NULL, 'G3DSA:3.40.50.150:FF:001686', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208331, NULL, 'G3DSA:3.20.20.190:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208332, NULL, 'G3DSA:3.30.1330.90:FF:000004', NULL, NULL, 'L-serine dehydratase, iron-sulfur-dependent subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(208333, NULL, 'G3DSA:1.10.8.270:FF:000067', NULL, NULL, 'TBC1 domain family member 25', NULL, NULL, NULL, NULL, NULL, 4),
(208334, NULL, 'G3DSA:1.10.238.10:FF:001217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208335, NULL, 'G3DSA:1.10.560.10:FF:000140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208336, NULL, 'G3DSA:1.20.1420.30:FF:000054', NULL, NULL, 'Sodium/calcium exchanger membrane region', NULL, NULL, NULL, NULL, NULL, 4),
(208337, NULL, 'G3DSA:2.60.40.10:FF:004367', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208338, NULL, 'G3DSA:3.30.70.330:FF:002387', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208339, NULL, 'G3DSA:2.40.50.40:FF:000089', NULL, NULL, 'Chemokine', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(208340, NULL, 'G3DSA:3.60.21.10:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208341, NULL, 'G3DSA:6.20.10.30:FF:000002', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(208342, NULL, 'G3DSA:1.20.1110.10:FF:000081', NULL, NULL, 'ATPase 7', NULL, NULL, NULL, NULL, NULL, 4),
(208343, NULL, 'G3DSA:3.60.20.10:FF:000232', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208344, NULL, 'G3DSA:3.90.1720.10:FF:000036', NULL, NULL, 'Palmitoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(208345, NULL, 'G3DSA:3.40.50.300:FF:006071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208346, NULL, 'G3DSA:1.10.287.70:FF:000117', NULL, NULL, 'Voltage-gated Ca2+ channel, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(208347, NULL, 'G3DSA:2.90.10.10:FF:000002', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(208348, NULL, 'G3DSA:2.30.130.40:FF:000018', NULL, NULL, 'Cereblon', NULL, NULL, NULL, NULL, NULL, 4),
(208349, NULL, 'G3DSA:3.40.50.720:FF:000811', NULL, NULL, 'AflH/ adhA/ short chain alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(208350, NULL, 'G3DSA:1.20.1250.10:FF:000023', NULL, NULL, 'Cardiotrophin-2', NULL, NULL, NULL, NULL, NULL, 4),
(208351, NULL, 'G3DSA:1.20.1600.10:FF:000045', NULL, NULL, 'Outer membrane efflux protein', NULL, NULL, NULL, NULL, NULL, 4),
(208352, NULL, 'G3DSA:3.40.50.1010:FF:000167', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208353, NULL, 'G3DSA:3.40.50.1000:FF:000052', NULL, NULL, 'Alpha,alpha-trehalose-phosphate synthase [UDP-forming] 6', NULL, NULL, NULL, NULL, NULL, 4),
(208354, NULL, 'G3DSA:1.10.3460.10:FF:000036', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(208355, NULL, 'G3DSA:2.60.120.10:FF:000261', NULL, NULL, 'At4g10300', NULL, NULL, NULL, NULL, NULL, 4),
(208356, NULL, 'G3DSA:2.60.40.10:FF:001719', NULL, NULL, 'FiLamiN (Actin binding protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(208357, NULL, 'G3DSA:3.40.50.720:FF:001531', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208358, NULL, 'G3DSA:3.40.50.790:FF:000001', NULL, NULL, '50S ribosomal protein L1', NULL, NULL, NULL, NULL, NULL, 4),
(208359, NULL, 'G3DSA:3.50.50.60:FF:000255', NULL, NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme GidA', NULL, NULL, NULL, NULL, NULL, 4),
(208360, NULL, 'G3DSA:3.80.10.10:FF:003682', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208361, NULL, 'G3DSA:3.20.20.60:FF:000131', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(208362, NULL, 'G3DSA:3.50.50.60:FF:000367', NULL, NULL, 'Rab proteins geranylgeranyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(208363, NULL, 'G3DSA:3.80.10.10:FF:003794', NULL, NULL, 'AGAP007463-PA', NULL, NULL, NULL, NULL, NULL, 4),
(208364, NULL, 'G3DSA:3.40.30.10:FF:000599', NULL, NULL, 'Peroxiredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(208365, NULL, 'G3DSA:1.25.40.20:FF:000873', NULL, NULL, 'Glutaminase kidney isoform, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(208366, NULL, 'G3DSA:2.60.34.10:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208367, NULL, 'G3DSA:1.25.10.10:FF:001981', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(208368, NULL, 'G3DSA:3.40.50.800:FF:000055', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(208369, NULL, 'G3DSA:2.40.10.350:FF:000011', NULL, NULL, 'Rod shape-determining protein MreC', NULL, NULL, NULL, NULL, NULL, 4),
(208370, NULL, 'G3DSA:1.20.1280.140:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208371, NULL, 'G3DSA:1.20.1270.90:FF:000003', NULL, NULL, 'Zinc metalloprotease ZmpB', NULL, NULL, NULL, NULL, NULL, 4),
(208372, NULL, 'G3DSA:3.30.230.10:FF:000204', NULL, NULL, 'mismatch repair endonuclease PMS2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(208373, NULL, 'G3DSA:3.40.30.10:FF:001217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(208374, NULL, 'G3DSA:3.90.190.10:FF:000417', NULL, NULL, 'Protein tyrosine phosphatase SH-PTP2', NULL, NULL, NULL, NULL, NULL, 4),
(208375, NULL, 'G3DSA:3.90.190.10:FF:000193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208376, NULL, 'G3DSA:3.30.230.10:FF:000316', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208377, NULL, 'G3DSA:2.120.10.30:FF:000372', NULL, NULL, 'Acylaminoacyl-peptide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(208378, NULL, 'G3DSA:2.30.29.30:FF:000418', NULL, NULL, 'PH domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(208379, NULL, 'G3DSA:3.40.50.1100:FF:000205', NULL, NULL, 'Pyridoxal-phosphate dependent protein', NULL, NULL, NULL, NULL, NULL, 4),
(208380, NULL, 'G3DSA:1.25.40.10:FF:005209', NULL, NULL, 'Clustered mitochondria protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(208381, NULL, 'G3DSA:3.40.50.1820:FF:000410', NULL, NULL, 'Lipase', NULL, NULL, NULL, NULL, NULL, 4),
(208382, NULL, 'G3DSA:1.10.510.10:FF:003172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208383, NULL, 'G3DSA:1.10.287.280:FF:000001', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(208384, NULL, 'G3DSA:3.40.50.2300:FF:000352', NULL, NULL, 'LacI family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(208385, NULL, 'G3DSA:1.25.10.10:FF:003459', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(208386, NULL, 'G3DSA:3.30.2350.10:FF:000038', NULL, NULL, 'Ribosomal pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(208387, NULL, 'G3DSA:1.10.238.10:FF:001122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208388, NULL, 'G3DSA:1.10.1280.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208389, NULL, 'G3DSA:3.40.50.2020:FF:000015', NULL, NULL, 'Uridine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(208390, NULL, 'G3DSA:2.40.50.140:FF:000692', NULL, NULL, 'Asparagine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(208391, NULL, 'G3DSA:1.25.40.10:FF:004012', NULL, NULL, 'TPR repeat-containing protein P27G11.02', NULL, NULL, NULL, NULL, NULL, 4),
(208392, NULL, 'G3DSA:2.160.20.10:FF:000191', NULL, NULL, 'F-box protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(208393, NULL, 'G3DSA:3.10.20.90:FF:000432', NULL, NULL, 'Protein CBR-GCK-3', NULL, NULL, NULL, NULL, NULL, 4),
(208394, NULL, 'G3DSA:3.40.50.880:FF:000022', NULL, NULL, 'protein deglycase DJ-1', NULL, NULL, NULL, NULL, NULL, 4),
(208395, NULL, 'G3DSA:3.40.50.300:FF:003086', NULL, NULL, 'GTP-binding protein, Ras family protein', NULL, NULL, NULL, NULL, NULL, 4),
(208396, NULL, 'G3DSA:3.60.10.10:FF:000198', NULL, NULL, 'Probable deoxyribonuclease I (DNase I)', NULL, NULL, NULL, NULL, NULL, 4),
(208397, NULL, 'G3DSA:1.25.40.10:FF:000538', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(208398, NULL, 'G3DSA:2.60.40.10:FF:001618', NULL, NULL, 'Chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(208399, NULL, 'G3DSA:1.20.120.350:FF:000155', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208400, NULL, 'G3DSA:2.130.10.10:FF:004912', NULL, NULL, 'Plexin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208401, NULL, 'G3DSA:2.60.40.60:FF:000964', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(208402, NULL, 'G3DSA:3.40.50.720:FF:002150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208403, NULL, 'G3DSA:3.30.160.60:FF:004816', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208404, NULL, 'G3DSA:3.40.190.10:FF:000760', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(208405, NULL, 'G3DSA:3.30.70.330:FF:000049', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(208406, NULL, 'G3DSA:3.40.250.10:FF:000046', NULL, NULL, 'Serine/threonine/tyrosine interacting like 1', NULL, NULL, NULL, NULL, NULL, 4),
(208407, NULL, 'G3DSA:1.20.1070.10:FF:000942', NULL, NULL, 'G protein-coupled receptor, putative', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(208408, NULL, 'G3DSA:3.90.70.10:FF:000161', NULL, NULL, 'Related to deubiquitinating enzyme ubh1', NULL, NULL, NULL, NULL, NULL, 4),
(208409, NULL, 'G3DSA:2.40.340.10:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208410, NULL, 'G3DSA:1.10.630.10:FF:000584', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208411, NULL, 'G3DSA:3.30.70.1230:FF:000073', NULL, NULL, 'Soluble guanylate cyclase gcy-37', NULL, NULL, NULL, NULL, NULL, 4),
(208412, NULL, 'G3DSA:3.30.70.330:FF:003034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208413, NULL, 'G3DSA:3.30.479.20:FF:000059', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(208414, NULL, 'G3DSA:2.30.30.380:FF:000037', NULL, NULL, 'Protein transport protein Sec24C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208415, NULL, 'G3DSA:3.40.50.620:FF:000427', NULL, NULL, 'Probable nicotinate-nucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(208416, NULL, 'G3DSA:3.40.50.740:FF:000008', NULL, NULL, 'Dimethyl sulfoxide reductase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(208417, NULL, 'G3DSA:1.20.910.10:FF:000013', NULL, NULL, 'Heme oxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(208418, NULL, 'G3DSA:2.130.10.10:FF:002203', NULL, NULL, 'Probable elongator complex protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(208419, NULL, 'G3DSA:1.10.565.10:FF:000123', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(208420, NULL, 'G3DSA:3.30.70.330:FF:000942', NULL, NULL, 'Multiple RNA-binding domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(208421, NULL, 'G3DSA:1.20.58.60:FF:000205', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(208422, NULL, 'G3DSA:3.30.160.60:FF:006250', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208423, NULL, 'G3DSA:3.30.559.10:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208424, NULL, 'G3DSA:1.25.10.10:FF:000233', NULL, NULL, 'Ecm29 proteasome adaptor and scaffold', NULL, NULL, NULL, NULL, NULL, 4),
(208425, NULL, 'G3DSA:3.20.20.70:FF:000235', NULL, NULL, 'Orotidine 5''-phosphate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(208426, NULL, 'G3DSA:3.40.50.2000:FF:000464', NULL, NULL, 'UDP-Glycosyltransferase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(208427, NULL, 'G3DSA:3.30.390.30:FF:000019', NULL, NULL, 'Trypanothione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(208428, NULL, 'G3DSA:3.10.129.10:FF:000265', NULL, NULL, 'Uncharacterized protein C3A12.08', NULL, NULL, NULL, NULL, NULL, 4),
(208429, NULL, 'G3DSA:1.20.58.60:FF:000099', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(208430, NULL, 'G3DSA:3.40.50.12780:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208431, NULL, 'G3DSA:1.20.1560.10:FF:000221', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(208432, NULL, 'G3DSA:3.40.50.150:FF:001574', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208433, NULL, 'G3DSA:1.20.1610.10:FF:000006', NULL, NULL, 'Alpha-1,2-mannosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208434, NULL, 'G3DSA:2.30.30.140:FF:000196', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(208435, NULL, 'G3DSA:1.20.1250.20:FF:002263', NULL, NULL, 'Os10g0404500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(208436, NULL, 'G3DSA:3.40.50.1820:FF:000859', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(208437, NULL, 'G3DSA:3.90.640.90:FF:000021', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(208438, NULL, 'G3DSA:1.10.150.20:FF:000095', NULL, NULL, 'Exonuclease I, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208439, NULL, 'G3DSA:3.40.30.10:FF:000020', NULL, NULL, 'Peroxiredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(208440, NULL, 'G3DSA:3.40.50.2300:FF:001521', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208441, NULL, 'G3DSA:3.30.200.20:FF:002381', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(208442, NULL, 'G3DSA:1.20.1250.20:FF:000577', NULL, NULL, 'Mch4p', NULL, NULL, NULL, NULL, NULL, 4),
(208443, NULL, 'G3DSA:2.30.42.10:FF:000404', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208444, NULL, 'G3DSA:3.30.390.10:FF:000013', NULL, NULL, 'L-rhamnonate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(208445, NULL, 'G3DSA:3.40.50.720:FF:000699', NULL, NULL, 'Arg5,6p', NULL, NULL, NULL, NULL, NULL, 4),
(208446, NULL, 'G3DSA:1.10.418.10:FF:000259', NULL, NULL, 'Spectrin beta, non-erythrocytic 4', NULL, NULL, NULL, NULL, NULL, 4),
(208447, NULL, 'G3DSA:3.30.200.20:FF:001650', NULL, NULL, 'Putative pseudokinase domain of ste20-related kinase adapter protein', NULL, NULL, NULL, NULL, NULL, 4),
(208448, NULL, 'G3DSA:1.25.40.10:FF:000965', NULL, NULL, 'Ethylene-overproduction protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(208449, NULL, 'G3DSA:3.40.850.10:FF:000451', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208450, NULL, 'G3DSA:2.60.40.2170:FF:000005', NULL, NULL, 'tyrosine-protein kinase Drl', NULL, NULL, NULL, NULL, NULL, 4),
(208451, NULL, 'G3DSA:2.30.29.30:FF:000099', NULL, NULL, 'Arf-GAP with dual PH domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(208452, NULL, 'G3DSA:3.30.160.60:FF:001247', NULL, NULL, 'zinc finger protein 341 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(208453, NULL, 'G3DSA:3.30.40.10:FF:000167', NULL, NULL, 'PHD finger protein 6 X-linked', NULL, NULL, NULL, NULL, NULL, 4),
(208454, NULL, 'G3DSA:2.40.33.40:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208455, NULL, 'G3DSA:1.20.1410.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208456, NULL, 'G3DSA:3.10.580.10:FF:000167', NULL, NULL, 'Chloride channel protein C', NULL, NULL, NULL, NULL, NULL, 4),
(208457, NULL, 'G3DSA:1.10.8.270:FF:000168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208458, NULL, 'G3DSA:1.10.10.10:FF:001930', NULL, NULL, 'Regulatory protein MarR', NULL, NULL, NULL, NULL, NULL, 4),
(208459, NULL, 'G3DSA:3.40.50.12780:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208460, NULL, 'G3DSA:2.40.10.10:FF:000072', NULL, NULL, 'CLIP-domain serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(208461, NULL, 'G3DSA:3.40.50.300:FF:005452', NULL, NULL, 'ATP-binding cassette transporter, subfamily G, member 23, group PDR protein PpABCG23', NULL, NULL, NULL, NULL, NULL, 4),
(208462, NULL, 'G3DSA:3.20.80.10:FF:000018', NULL, NULL, 'Heme-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(208463, NULL, 'G3DSA:3.40.50.720:FF:000593', NULL, NULL, 'Dihydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(208464, NULL, 'G3DSA:1.25.40.10:FF:003950', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(208465, NULL, 'G3DSA:2.60.40.10:FF:003405', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208466, NULL, 'G3DSA:1.50.10.10:FF:000057', NULL, NULL, 'N-acylglucosamine 2-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(208467, NULL, 'G3DSA:1.10.1370.10:FF:000012', NULL, NULL, 'Oligoendopeptidase F', NULL, NULL, NULL, NULL, NULL, 4),
(208468, NULL, 'G3DSA:1.25.40.500:FF:000001', NULL, NULL, 'Transcription initiation factor TFIID subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(208469, NULL, 'G3DSA:2.170.300.10:FF:000001', NULL, NULL, 'Laminin subunit beta-1', NULL, NULL, NULL, NULL, NULL, 4),
(208470, NULL, 'G3DSA:1.10.287.1490:FF:000123', NULL, NULL, 'Putative DNA repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(208471, NULL, 'G3DSA:2.30.29.30:FF:000992', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(208472, NULL, 'G3DSA:3.40.1380.20:FF:000001', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(208473, NULL, 'G3DSA:3.30.900.10:FF:000048', NULL, NULL, 'MAD (Yeast Mitosis arrest DeFicient) related', NULL, NULL, NULL, NULL, NULL, 4),
(208474, NULL, 'G3DSA:2.60.40.10:FF:003850', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208475, NULL, 'G3DSA:3.30.420.40:FF:000014', NULL, NULL, 'Rod shape-determining protein MreB', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(208476, NULL, 'G3DSA:2.60.40.150:FF:000666', NULL, NULL, 'Copine, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208477, NULL, 'G3DSA:2.130.10.10:FF:000966', NULL, NULL, 'Hsv2p', NULL, NULL, NULL, NULL, NULL, 4),
(208478, NULL, 'G3DSA:1.20.120.1080:FF:000027', NULL, NULL, 'ATP-dependent RNA helicase dhx8', NULL, NULL, NULL, NULL, NULL, 4),
(208479, NULL, 'G3DSA:2.30.30.140:FF:000207', NULL, NULL, 'Tudor/PWWP/MBT superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(208480, NULL, 'G3DSA:1.25.40.10:FF:001033', NULL, NULL, 'PPR repeat family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208481, NULL, 'G3DSA:1.10.510.10:FF:001946', NULL, NULL, 'Microtubule-associated serine/threonine kinase 1a', NULL, NULL, NULL, NULL, NULL, 4),
(208482, NULL, 'G3DSA:3.90.1150.10:FF:000127', NULL, NULL, 'Acetylornithine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(208483, NULL, 'G3DSA:1.10.287.3240:FF:000002', NULL, NULL, 'Vacuolar atp synthase subunit d', NULL, NULL, NULL, NULL, NULL, 4),
(208484, NULL, 'G3DSA:1.10.472.10:FF:000435', NULL, NULL, 'B type cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(208485, NULL, 'G3DSA:2.30.29.30:FF:000317', NULL, NULL, 'Amyloid beta A4 protein-binding family B member', NULL, NULL, NULL, NULL, NULL, 4),
(208486, NULL, 'G3DSA:3.30.70.260:FF:000129', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(208487, NULL, 'G3DSA:3.20.20.300:FF:000066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208488, NULL, 'G3DSA:2.60.40.10:FF:005305', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208489, NULL, 'G3DSA:3.40.50.2300:FF:000695', NULL, NULL, 'AGAP012447-PA', NULL, NULL, NULL, NULL, NULL, 4),
(208490, NULL, 'G3DSA:1.10.10.60:FF:000051', NULL, NULL, 'POU domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(208491, NULL, 'G3DSA:2.60.40.10:FF:004928', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208492, NULL, 'G3DSA:3.30.230.10:FF:000193', NULL, NULL, 'Eukaryotic translation elongation factor 2a, tandem duplicate 1', NULL, NULL, NULL, NULL, NULL, 4),
(208493, NULL, 'G3DSA:2.30.29.110:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208494, NULL, 'G3DSA:1.20.900.10:FF:000052', NULL, NULL, 'Cell division control protein 24', NULL, NULL, NULL, NULL, NULL, 4),
(208495, NULL, 'G3DSA:2.30.30.550:FF:000004', NULL, NULL, 'Major vault protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(208496, NULL, 'G3DSA:3.30.70.1440:FF:000012', NULL, NULL, 'Putative multidrug resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(208497, NULL, 'G3DSA:3.40.50.10490:FF:000025', NULL, NULL, 'Glucosamine--fructose-6-phosphate aminotransferase [isomerizing]', NULL, NULL, NULL, NULL, NULL, 4),
(208498, NULL, 'G3DSA:2.60.120.260:FF:000449', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208499, NULL, 'G3DSA:1.10.10.60:FF:000955', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208500, NULL, 'G3DSA:3.40.1690.20:FF:000002', NULL, NULL, 'paraplegin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(208501, NULL, 'G3DSA:4.10.240.10:FF:000138', NULL, NULL, 'Oleate-activated transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208502, NULL, 'G3DSA:1.20.58.1060:FF:000002', NULL, NULL, 'plectin isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(208503, NULL, 'G3DSA:1.20.58.190:FF:000001', NULL, NULL, 'Translin', NULL, NULL, NULL, NULL, NULL, 4),
(208504, NULL, 'G3DSA:3.30.70.100:FF:000109', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208505, NULL, 'G3DSA:2.170.300.10:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208506, NULL, 'G3DSA:1.10.287.130:FF:000086', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(208507, NULL, 'G3DSA:3.30.420.10:FF:000354', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208508, NULL, 'G3DSA:3.90.25.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208509, NULL, 'G3DSA:1.10.510.10:FF:001042', NULL, NULL, 'Ptk2p', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(208510, NULL, 'G3DSA:2.60.40.150:FF:000323', NULL, NULL, 'C2 calcium/lipid-binding plant phosphoribosyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(208511, NULL, 'G3DSA:3.30.160.60:FF:003265', NULL, NULL, 'Zinc finger protein 1012', NULL, NULL, NULL, NULL, NULL, 4),
(208512, NULL, 'G3DSA:3.30.420.40:FF:000790', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208513, NULL, 'G3DSA:3.40.50.1820:FF:000298', NULL, NULL, 'Bem46-like serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(208514, NULL, 'G3DSA:3.40.250.10:FF:000130', NULL, NULL, 'Putative thiosulfate sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(208515, NULL, 'G3DSA:1.10.510.10:FF:003503', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208516, NULL, 'G3DSA:1.10.12.70:FF:000002', NULL, NULL, 'Serine/threonine kinase 24', NULL, NULL, NULL, NULL, NULL, 4),
(208517, NULL, 'G3DSA:1.10.510.10:FF:002907', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208518, NULL, 'G3DSA:3.70.10.10:FF:000102', NULL, NULL, 'Checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(208519, NULL, 'G3DSA:2.60.40.60:FF:001032', NULL, NULL, 'AGAP006732-PA', NULL, NULL, NULL, NULL, NULL, 4),
(208520, NULL, 'G3DSA:1.10.510.10:FF:000766', NULL, NULL, 'CAMK/CDPK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(208521, NULL, 'G3DSA:3.90.190.10:FF:000294', NULL, NULL, 'Tyrosine-protein phosphatase 2', NULL, NULL, NULL, NULL, NULL, 4),
(208522, NULL, 'G3DSA:3.30.1370.50:FF:000017', NULL, NULL, 'YALI0D10285p', NULL, NULL, NULL, NULL, NULL, 4),
(208523, NULL, 'G3DSA:4.10.400.10:FF:000016', NULL, NULL, 'Low-density lipoprotein receptor-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(208524, NULL, 'G3DSA:3.30.70.270:FF:000227', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208525, NULL, 'G3DSA:2.60.120.330:FF:000044', NULL, NULL, '2-oxoglutarate (2OG) and Fe(II)-dependent oxygenase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(208526, NULL, 'G3DSA:2.30.310.10:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208527, NULL, 'G3DSA:2.60.40.10:FF:001950', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(208528, NULL, 'G3DSA:3.40.367.20:FF:000044', NULL, NULL, 'Hexokinase', NULL, NULL, NULL, NULL, NULL, 4),
(208529, NULL, 'G3DSA:1.10.510.10:FF:002666', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208530, NULL, 'G3DSA:3.40.1500.10:FF:000003', NULL, NULL, 'oxygen-dependent coproporphyrinogen-III oxidase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(208531, NULL, 'G3DSA:3.60.40.10:FF:000132', NULL, NULL, 'Stage II sporulation protein E', NULL, NULL, NULL, NULL, NULL, 4),
(208532, NULL, 'G3DSA:3.30.40.10:FF:000830', NULL, NULL, 'RING-H2 finger protein ATL28', NULL, NULL, NULL, NULL, NULL, 4),
(208533, NULL, 'G3DSA:3.40.50.10190:FF:000284', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(208534, NULL, 'G3DSA:1.10.20.140:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208535, NULL, 'G3DSA:3.10.310.10:FF:000007', NULL, NULL, 'Trans-L-3-hydroxyproline dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(208536, NULL, 'G3DSA:2.130.10.10:FF:005076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208537, NULL, 'G3DSA:3.40.50.11060:FF:000005', NULL, NULL, 'Protein CBG19372', NULL, NULL, NULL, NULL, NULL, 4),
(208538, NULL, 'G3DSA:3.40.50.300:FF:001641', NULL, NULL, 'Mitochondrial Rho GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(208539, NULL, 'G3DSA:2.20.100.10:FF:000139', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs gon-1', NULL, NULL, NULL, NULL, NULL, 4),
(208540, NULL, 'G3DSA:3.60.15.10:FF:000170', NULL, NULL, 'Metallo-beta-lactamase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(208541, NULL, 'G3DSA:1.20.920.10:FF:000065', NULL, NULL, 'Transcription regulatory protein SNF2', NULL, NULL, NULL, NULL, NULL, 4),
(208542, NULL, 'G3DSA:3.80.10.10:FF:003108', NULL, NULL, 'Viral A-type inclusion protein, putative', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(208543, NULL, 'G3DSA:3.40.800.10:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208544, NULL, 'G3DSA:3.30.40.10:FF:000375', NULL, NULL, 'tripartite motif-containing protein 47 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(208545, NULL, 'G3DSA:1.10.472.80:FF:000063', NULL, NULL, 'GTPase-activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208546, NULL, 'G3DSA:2.60.40.10:FF:000977', NULL, NULL, 'Myosin binding protein H like', NULL, NULL, NULL, NULL, NULL, 4),
(208547, NULL, 'G3DSA:1.20.80.10:FF:000034', NULL, NULL, 'Blast:E3 ubiquitin-protein ligase MYLIP-A', NULL, NULL, NULL, NULL, NULL, 4),
(208548, NULL, 'G3DSA:3.30.70.330:FF:002623', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208549, NULL, 'G3DSA:3.40.50.300:FF:000231', NULL, NULL, 'Activating signal cointegrator 1 complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(208550, NULL, 'G3DSA:2.130.10.30:FF:000068', NULL, NULL, 'Hect domain and RLD 3', NULL, NULL, NULL, NULL, NULL, 4),
(208551, NULL, 'G3DSA:2.60.220.50:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208552, NULL, 'G3DSA:2.30.42.10:FF:000163', NULL, NULL, 'rho GTPase-activating protein 100F isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(208553, NULL, 'G3DSA:1.10.287.500:FF:000005', NULL, NULL, 'Chemotaxis protein CheZ', NULL, NULL, NULL, NULL, NULL, 4),
(208554, NULL, 'G3DSA:3.10.110.10:FF:000363', NULL, NULL, 'Protein IMPACT homolog', NULL, NULL, NULL, NULL, NULL, 4),
(208555, NULL, 'G3DSA:2.160.20.10:FF:000297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208556, NULL, 'G3DSA:3.60.21.10:FF:000324', NULL, NULL, 'Lmo2403 protein', NULL, NULL, NULL, NULL, NULL, 4),
(208557, NULL, 'G3DSA:1.10.10.60:FF:000394', NULL, NULL, 'MYB transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(208558, NULL, 'G3DSA:3.40.50.2000:FF:000705', NULL, NULL, 'ADP-heptose--lipopolysaccharide heptosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208559, NULL, 'G3DSA:1.10.630.10:FF:000685', NULL, NULL, 'Cytochrome P450 78A7', NULL, NULL, NULL, NULL, NULL, 4),
(208560, NULL, 'G3DSA:1.10.10.60:FF:001012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208561, NULL, 'G3DSA:3.20.20.80:FF:000676', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208562, NULL, 'G3DSA:2.130.10.10:FF:000062', NULL, NULL, 'Putative WD repeat-containing protein 48', NULL, NULL, NULL, NULL, NULL, 4),
(208563, NULL, 'G3DSA:1.10.510.10:FF:001385', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(208564, NULL, 'G3DSA:1.20.1250.20:FF:001549', NULL, NULL, 'Solute carrier family 15 member 4', NULL, NULL, NULL, NULL, NULL, 4),
(208565, NULL, 'G3DSA:1.10.510.10:FF:002003', NULL, NULL, 'SNF1 family protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208566, NULL, 'G3DSA:3.30.160.60:FF:004693', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208567, NULL, 'G3DSA:1.25.40.10:FF:003495', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(208568, NULL, 'G3DSA:3.30.160.60:FF:000410', NULL, NULL, 'Zinc finger protein 777', NULL, NULL, NULL, NULL, NULL, 4),
(208569, NULL, 'G3DSA:3.30.200.20:FF:002487', NULL, NULL, 'Citron rho-interacting serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(208570, NULL, 'G3DSA:3.30.70.1730:FF:000009', NULL, NULL, '50S ribosomal protein L10', NULL, NULL, NULL, NULL, NULL, 4),
(208571, NULL, 'G3DSA:2.40.50.140:FF:000815', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208572, NULL, 'G3DSA:2.30.29.30:FF:001037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208573, NULL, 'G3DSA:3.80.10.10:FF:002625', NULL, NULL, 'leucine-rich repeat neuronal protein 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(208574, NULL, 'G3DSA:1.10.3730.20:FF:000021', NULL, NULL, 'Probable 4-amino-4-deoxy-L-arabinose-phosphoundecaprenol flippase subunit ArnF', NULL, NULL, NULL, NULL, NULL, 4),
(208575, NULL, 'G3DSA:3.40.630.10:FF:000468', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(208576, NULL, 'G3DSA:3.80.10.10:FF:000692', NULL, NULL, 'Leucine rich repeat containing 15', NULL, NULL, NULL, NULL, NULL, 4),
(208577, NULL, 'G3DSA:1.10.520.10:FF:000031', NULL, NULL, 'Os01g0327000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(208578, NULL, 'G3DSA:3.20.20.80:FF:000013', NULL, NULL, 'lactase-phlorizin hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(208579, NULL, 'G3DSA:1.25.40.20:FF:000979', NULL, NULL, 'SH3 and multiple ankyrin repeat domains 2a', NULL, NULL, NULL, NULL, NULL, 4),
(208580, NULL, 'G3DSA:1.25.10.10:FF:001329', NULL, NULL, 'Kinesin associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(208581, NULL, 'G3DSA:3.40.50.720:FF:002256', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(208582, NULL, 'G3DSA:1.25.10.10:FF:003324', NULL, NULL, 'PIKK family atypical protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(208583, NULL, 'G3DSA:2.130.10.10:FF:001686', NULL, NULL, 'Inositol polyphosphate phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208584, NULL, 'G3DSA:2.40.128.20:FF:000027', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(208585, NULL, 'G3DSA:3.30.70.1710:FF:000003', NULL, NULL, 'Ethanolamine utilization protein EutL', NULL, NULL, NULL, NULL, NULL, 4),
(208586, NULL, 'G3DSA:4.10.240.10:FF:000014', NULL, NULL, 'HAP1p Zinc finger transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(208587, NULL, 'G3DSA:1.25.40.20:FF:001598', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208588, NULL, 'G3DSA:3.90.550.10:FF:000288', NULL, NULL, 'Lipopolysaccharide 1,2-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(208589, NULL, 'G3DSA:1.10.439.10:FF:000004', NULL, NULL, 'Penicillin acylase II', NULL, NULL, NULL, NULL, NULL, 4),
(208590, NULL, 'G3DSA:3.40.630.30:FF:000671', NULL, NULL, 'Glr3626 protein', NULL, NULL, NULL, NULL, NULL, 4),
(208591, NULL, 'G3DSA:3.40.390.10:FF:000292', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208592, NULL, 'G3DSA:3.10.20.90:FF:000640', NULL, NULL, 'Autophagy-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(208593, NULL, 'G3DSA:1.20.58.60:FF:000649', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208594, NULL, 'G3DSA:3.40.430.10:FF:000032', NULL, NULL, 'Riboflavin biosynthesis protein RibD', NULL, NULL, NULL, NULL, NULL, 4),
(208595, NULL, 'G3DSA:2.60.40.10:FF:005648', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208596, NULL, 'G3DSA:1.10.2000.10:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208597, NULL, 'G3DSA:2.60.120.10:FF:000502', NULL, NULL, 'cGMP-dependent 3'',5''-cGMP phosphodiesterase A', NULL, NULL, NULL, NULL, NULL, 4),
(208598, NULL, 'G3DSA:1.10.10.10:FF:001357', NULL, NULL, 'Pleckstrin 2', NULL, NULL, NULL, NULL, NULL, 4),
(208599, NULL, 'G3DSA:3.40.50.2000:FF:000144', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(208600, NULL, 'G3DSA:3.30.710.10:FF:000331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208601, NULL, 'G3DSA:1.25.40.180:FF:000298', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208602, NULL, 'G3DSA:3.40.50.720:FF:001430', NULL, NULL, 'PKS-NRPS hybrid synthetase psoA', NULL, NULL, NULL, NULL, NULL, 4),
(208603, NULL, 'G3DSA:2.130.10.10:FF:003940', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208604, NULL, 'G3DSA:3.30.160.60:FF:003844', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208605, NULL, 'G3DSA:3.30.160.60:FF:005530', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208606, NULL, 'G3DSA:2.60.40.2860:FF:000015', NULL, NULL, 'Transmission-blocking target antigen s230', NULL, NULL, NULL, NULL, NULL, 4),
(208607, NULL, 'G3DSA:3.30.470.20:FF:000056', NULL, NULL, 'Inositol-tetrakisphosphate 1-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(208608, NULL, 'G3DSA:3.30.70.330:FF:000369', NULL, NULL, 'heterogeneous nuclear ribonucleoprotein D0 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(208609, NULL, 'G3DSA:1.10.10.10:FF:000957', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(208610, NULL, 'G3DSA:3.40.50.1000:FF:000153', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(208611, NULL, 'G3DSA:1.20.120.20:FF:000001', NULL, NULL, 'Apolipoprotein A-I', NULL, NULL, NULL, NULL, NULL, 4),
(208612, NULL, 'G3DSA:3.90.79.20:FF:000021', NULL, NULL, 'NADH pyrophosphatase, MutT family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(208613, NULL, 'G3DSA:3.50.50.60:FF:001008', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(208614, NULL, 'G3DSA:3.10.20.310:FF:000009', NULL, NULL, 'Outer membrane protein, OMP85 family', NULL, NULL, NULL, NULL, NULL, 4),
(208615, NULL, 'G3DSA:3.90.1300.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208616, NULL, 'G3DSA:2.60.40.10:FF:004024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208617, NULL, 'G3DSA:2.40.128.270:FF:000001', NULL, NULL, 'Heat shock protein HslJ', NULL, NULL, NULL, NULL, NULL, 4),
(208618, NULL, 'G3DSA:3.40.50.300:FF:003322', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(208619, NULL, 'G3DSA:2.130.10.10:FF:001023', NULL, NULL, 'Actin-related protein 2/3 complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(208620, NULL, 'G3DSA:3.40.50.300:FF:007717', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208621, NULL, 'G3DSA:1.20.1270.60:FF:000343', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208622, NULL, 'G3DSA:3.30.200.20:FF:001661', NULL, NULL, 'Os12g0500400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(208623, NULL, 'G3DSA:1.10.486.10:FF:000034', NULL, NULL, 'DNA helicase II/ATP-dependent DNA helicase PcrA', NULL, NULL, NULL, NULL, NULL, 4),
(208624, NULL, 'G3DSA:3.30.70.360:FF:000047', NULL, NULL, 'Peptidase M20 domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(208625, NULL, 'G3DSA:2.60.40.2170:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208626, NULL, 'G3DSA:3.60.20.10:FF:000024', NULL, NULL, 'Asparagine synthetase [glutamine-hydrolyzing]', NULL, NULL, NULL, NULL, NULL, 4),
(208627, NULL, 'G3DSA:3.40.50.2300:FF:001532', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208628, NULL, 'G3DSA:3.30.160.60:FF:001820', NULL, NULL, 'Zinc finger protein 473', NULL, NULL, NULL, NULL, NULL, 4),
(208629, NULL, 'G3DSA:3.30.50.10:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208630, NULL, 'G3DSA:3.40.1190.20:FF:000088', NULL, NULL, '2-dehydro-3-deoxygluconokinase', NULL, NULL, NULL, NULL, NULL, 4),
(208631, NULL, 'G3DSA:2.60.40.420:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208632, NULL, 'G3DSA:3.75.10.10:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208633, NULL, 'G3DSA:3.30.160.60:FF:002220', NULL, NULL, 'Zinc finger protein 382', NULL, NULL, NULL, NULL, NULL, 4),
(208634, NULL, 'G3DSA:2.130.10.10:FF:004457', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208635, NULL, 'G3DSA:3.90.1310.10:FF:000005', NULL, NULL, 'Stage V sporulation protein D', NULL, NULL, NULL, NULL, NULL, 4),
(208636, NULL, 'G3DSA:3.60.20.10:FF:000148', NULL, NULL, 'Putative glutamine--fructose-6-phosphate aminotransferase [isomerizing]', NULL, NULL, NULL, NULL, NULL, 4),
(208637, NULL, 'G3DSA:3.40.33.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208638, NULL, 'G3DSA:1.20.5.110:FF:000247', NULL, NULL, 'Syntaxin-18', NULL, NULL, NULL, NULL, NULL, 4),
(208639, NULL, 'G3DSA:3.80.10.10:FF:001310', NULL, NULL, 'leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(208640, NULL, 'G3DSA:2.60.40.1400:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208641, NULL, 'G3DSA:3.50.50.60:FF:000608', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(208642, NULL, 'G3DSA:1.25.10.10:FF:001205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(208643, NULL, 'G3DSA:3.40.950.10:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208644, NULL, 'G3DSA:3.10.390.10:FF:000012', NULL, NULL, 'Nuclear autoantigen Sp-100', NULL, NULL, NULL, NULL, NULL, 4),
(208645, NULL, 'G3DSA:3.30.70.680:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208646, NULL, 'G3DSA:2.60.40.10:FF:003748', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208647, NULL, 'G3DSA:1.50.40.10:FF:000446', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208648, NULL, 'G3DSA:3.90.550.50:FF:000030', NULL, NULL, 'Fringe-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(208649, NULL, 'G3DSA:1.10.10.10:FF:001233', NULL, NULL, 'Two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(208650, NULL, 'G3DSA:1.10.533.10:FF:000105', NULL, NULL, 'Fas-associated death domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(208651, NULL, 'G3DSA:2.170.150.80:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208652, NULL, 'G3DSA:3.40.50.300:FF:005800', NULL, NULL, 'Replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(208653, NULL, 'G3DSA:3.10.20.310:FF:000004', NULL, NULL, 'Outer membrane protein assembly factor BamA', NULL, NULL, NULL, NULL, NULL, 4),
(208654, NULL, 'G3DSA:1.10.10.10:FF:000738', NULL, NULL, 'Transcriptional regulator, ArsR family', NULL, NULL, NULL, NULL, NULL, 4),
(208655, NULL, 'G3DSA:3.30.710.10:FF:000230', NULL, NULL, 'SKP1-like protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(208656, NULL, 'G3DSA:3.90.550.10:FF:000737', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(208657, NULL, 'G3DSA:2.130.10.10:FF:001130', NULL, NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(208658, NULL, 'G3DSA:3.30.70.890:FF:000071', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(208659, NULL, 'G3DSA:1.10.8.10:FF:000209', NULL, NULL, 'UBA/TS-N domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(208660, NULL, 'G3DSA:1.25.40.10:FF:000297', NULL, NULL, 'tonsoku-like protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(208661, NULL, 'G3DSA:3.90.320.10:FF:000006', NULL, NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(208662, NULL, 'G3DSA:3.40.50.300:FF:002029', NULL, NULL, 'Replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(208663, NULL, 'G3DSA:2.30.29.30:FF:000880', NULL, NULL, 'uncharacterized protein LOC100181754', NULL, NULL, NULL, NULL, NULL, 4),
(208664, NULL, 'G3DSA:3.40.50.300:FF:002041', NULL, NULL, 'ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(208665, NULL, 'G3DSA:3.40.50.300:FF:006312', NULL, NULL, 'CTP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(208666, NULL, 'G3DSA:3.30.160.60:FF:002208', NULL, NULL, 'Zinc finger protein 787', NULL, NULL, NULL, NULL, NULL, 4),
(208667, NULL, 'G3DSA:2.130.10.10:FF:005401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208668, NULL, 'G3DSA:3.10.400.10:FF:000008', NULL, NULL, 'Probable bifunctional SAT/APS kinase', NULL, NULL, NULL, NULL, NULL, 4),
(208669, NULL, 'G3DSA:2.60.40.10:FF:002675', NULL, NULL, 'Leukemia inhibitory factor receptor alpha a', NULL, NULL, NULL, NULL, NULL, 4),
(208670, NULL, 'G3DSA:3.40.50.720:FF:000463', NULL, NULL, 'Probable NADPH quinone oxidoreductase fadB4', NULL, NULL, NULL, NULL, NULL, 4),
(208671, NULL, 'G3DSA:1.20.120.1080:FF:000139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208672, NULL, 'G3DSA:3.90.1110.10:FF:000001', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(208673, NULL, 'G3DSA:3.30.499.10:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208674, NULL, 'G3DSA:3.40.50.80:FF:000014', NULL, NULL, 'Na(+)-translocating NADH-quinone reductase subunit F', NULL, NULL, NULL, NULL, NULL, 4),
(208675, NULL, 'G3DSA:3.40.1110.10:FF:000209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(208676, NULL, 'G3DSA:2.130.10.10:FF:004777', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208677, NULL, 'G3DSA:3.30.1550.10:FF:000014', NULL, NULL, 'Probable MRPL19-mitochondrial ribosomal protein, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(208678, NULL, 'G3DSA:3.30.590.50:FF:000001', NULL, NULL, 'Glutamate-cysteine ligase Gcs1', NULL, NULL, NULL, NULL, NULL, 4),
(208679, NULL, 'G3DSA:3.80.10.10:FF:000585', NULL, NULL, 'Leucine-rich repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(208680, NULL, 'G3DSA:3.40.50.300:FF:005688', NULL, NULL, 'Adenylate/guanylate cyclase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(208681, NULL, 'G3DSA:3.40.50.10390:FF:000001', NULL, NULL, 'Lys-gingipain 381', NULL, NULL, NULL, NULL, NULL, 4),
(208682, NULL, 'G3DSA:2.60.40.60:FF:000975', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208683, NULL, 'G3DSA:3.30.830.10:FF:000284', NULL, NULL, 'Clan ME, family M16, insulinase-like metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(208684, NULL, 'G3DSA:3.40.50.620:FF:000321', NULL, NULL, 'Os05g0113300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(208685, NULL, 'G3DSA:1.20.1560.10:FF:000457', NULL, NULL, 'HlyB/MsbA family ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(208686, NULL, 'G3DSA:2.40.50.140:FF:000838', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208687, NULL, 'G3DSA:2.130.10.10:FF:005289', NULL, NULL, 'At4g01860', NULL, NULL, NULL, NULL, NULL, 4),
(208688, NULL, 'G3DSA:3.30.420.10:FF:000359', NULL, NULL, 'Transposon Ty3-I Gag-Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(208689, NULL, 'G3DSA:3.40.50.2000:FF:000936', NULL, NULL, 'At4g15260', NULL, NULL, NULL, NULL, NULL, 4),
(208690, NULL, 'G3DSA:3.30.40.10:FF:000847', NULL, NULL, 'Unplaced genomic scaffold supercont1.9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(208691, NULL, 'G3DSA:1.10.510.10:FF:002110', NULL, NULL, 'Kinase, CMGC CMGC-GL1', NULL, NULL, NULL, NULL, NULL, 4),
(208692, NULL, 'G3DSA:1.10.510.10:FF:001486', NULL, NULL, 'AGC protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(208693, NULL, 'G3DSA:3.40.30.70:FF:000004', NULL, NULL, 'tRNA synthetases class I, catalytic domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(208694, NULL, 'G3DSA:3.30.450.20:FF:000297', NULL, NULL, 'Diguanylate cyclase (GGDEF) domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(208695, NULL, 'G3DSA:2.60.40.10:FF:005429', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208696, NULL, 'G3DSA:3.40.50.720:FF:001082', NULL, NULL, 'Cis-1,2-dihydroxycyclohexa-3,4-diene carboxylate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(208697, NULL, 'G3DSA:3.40.50.2300:FF:000919', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208698, NULL, 'G3DSA:3.10.105.10:FF:000053', NULL, NULL, 'Oligopeptide ABC transporter, oligopeptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(208699, NULL, 'G3DSA:3.30.40.10:FF:000954', NULL, NULL, 'Histone demethylase JHD2', NULL, NULL, NULL, NULL, NULL, 4),
(208700, NULL, 'G3DSA:1.10.3090.10:FF:000002', NULL, NULL, 'CCA tRNA nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(208701, NULL, 'G3DSA:2.10.25.10:FF:001776', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(208702, NULL, 'G3DSA:3.40.50.150:FF:001118', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208703, NULL, 'G3DSA:3.40.50.720:FF:000570', NULL, NULL, 'Oxidoreductase HTATIP2', NULL, NULL, NULL, NULL, NULL, 4),
(208704, NULL, 'G3DSA:3.30.160.60:FF:003743', NULL, NULL, 'Zinc finger protein 668', NULL, NULL, NULL, NULL, NULL, 4),
(208705, NULL, 'G3DSA:1.25.40.1040:FF:000019', NULL, NULL, 'NMDA receptor-regulated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208706, NULL, 'G3DSA:1.20.900.10:FF:000075', NULL, NULL, 'Rho guanine nucleotide exchange factor 38', NULL, NULL, NULL, NULL, NULL, 4),
(208707, NULL, 'G3DSA:1.10.287.4070:FF:000026', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(208708, NULL, 'G3DSA:3.65.10.20:FF:000005', NULL, NULL, 'RNA re-capping enzyme, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(208709, NULL, 'G3DSA:2.30.29.30:FF:000773', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208710, NULL, 'G3DSA:1.25.40.10:FF:000302', NULL, NULL, 'Rolling pebbles, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(208711, NULL, 'G3DSA:1.25.10.10:FF:003454', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208712, NULL, 'G3DSA:3.30.200.20:FF:000256', NULL, NULL, 'cyclin-dependent kinase 10 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(208713, NULL, 'G3DSA:1.20.5.110:FF:000242', NULL, NULL, 'Synaptosomal-associated protein 47', NULL, NULL, NULL, NULL, NULL, 4),
(208714, NULL, 'G3DSA:2.130.10.10:FF:000511', NULL, NULL, 'WD repeat domain 37', NULL, NULL, NULL, NULL, NULL, 4),
(208715, NULL, 'G3DSA:1.10.238.10:FF:000953', NULL, NULL, 'HLH domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(208716, NULL, 'G3DSA:3.30.200.20:FF:001094', NULL, NULL, 'cAMP-dependent protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208717, NULL, 'G3DSA:3.40.50.300:FF:005795', NULL, NULL, 'Tudor domain containing 9', NULL, NULL, NULL, NULL, NULL, 4),
(208718, NULL, 'G3DSA:4.10.280.10:FF:000034', NULL, NULL, 'MAX network transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(208719, NULL, 'G3DSA:1.10.150.20:FF:000090', NULL, NULL, 'U5 small nuclear ribonucleoprotein helicase', NULL, NULL, NULL, NULL, NULL, 4),
(208720, NULL, 'G3DSA:3.10.310.30:FF:000002', NULL, NULL, 'Cyclic-di-AMP phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(208721, NULL, 'G3DSA:2.60.120.230:FF:000002', NULL, NULL, 'Peptidyl-glycine alpha-amidating monooxygenase B', NULL, NULL, NULL, NULL, NULL, 4),
(208722, NULL, 'G3DSA:1.10.287.3240:FF:000019', NULL, NULL, 'Probable vacuolar ATP synthase subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(208723, NULL, 'G3DSA:3.40.1350.100:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208724, NULL, 'G3DSA:3.40.91.20:FF:000001', NULL, NULL, 'BstYI', NULL, NULL, NULL, NULL, NULL, 4),
(208725, NULL, 'G3DSA:1.10.1410.10:FF:000061', NULL, NULL, 'U3 small nucleolar RNA-associated protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(208726, NULL, 'G3DSA:2.60.120.200:FF:000477', NULL, NULL, 'MAM and LDL-receptor class A domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(208727, NULL, 'G3DSA:1.10.455.10:FF:000002', NULL, NULL, '40S ribosomal protein S5', NULL, NULL, NULL, NULL, NULL, 4),
(208728, NULL, 'G3DSA:2.60.40.10:FF:003294', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208729, NULL, 'G3DSA:4.10.60.10:FF:000049', NULL, NULL, 'Zinc finger protein GIS2', NULL, NULL, NULL, NULL, NULL, 4),
(208730, NULL, 'G3DSA:1.25.40.10:FF:003152', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g03540', NULL, NULL, NULL, NULL, NULL, 4),
(208731, NULL, 'G3DSA:3.90.550.10:FF:000052', NULL, NULL, 'Colanic acid biosynthesis glycosyltransferase WcaA', NULL, NULL, NULL, NULL, NULL, 4),
(208732, NULL, 'G3DSA:3.40.50.300:FF:002945', NULL, NULL, 'ATP-dependent RNA helicase MRH4, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(208733, NULL, 'G3DSA:3.40.50.720:FF:001986', NULL, NULL, '3-oxoacyl-(Acyl-carrier-protein) reductase', NULL, NULL, NULL, NULL, NULL, 4),
(208734, NULL, 'G3DSA:3.30.1680.30:FF:000001', NULL, NULL, 'Variant surface glycoprotein (VSG, atypical), putative', NULL, NULL, NULL, NULL, NULL, 4),
(208735, NULL, 'G3DSA:3.30.160.60:FF:000073', NULL, NULL, 'IKAROS family zinc finger 1', NULL, NULL, NULL, NULL, NULL, 4),
(208736, NULL, 'G3DSA:1.10.10.1540:FF:000002', NULL, NULL, 'costars family protein ABRACL', NULL, NULL, NULL, NULL, NULL, 4),
(208737, NULL, 'G3DSA:1.20.58.80:FF:000071', NULL, NULL, 'Serine/threonine-protein kinase ULK3', NULL, NULL, NULL, NULL, NULL, 4),
(208738, NULL, 'G3DSA:1.10.555.10:FF:000061', NULL, NULL, 'Rho GTPase activating protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(208739, NULL, 'G3DSA:3.20.20.70:FF:000572', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208740, NULL, 'G3DSA:2.130.10.10:FF:001815', NULL, NULL, 'WD repeat protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(208741, NULL, 'G3DSA:1.25.40.10:FF:005187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208742, NULL, 'G3DSA:3.30.930.10:FF:000117', NULL, NULL, 'Aspartate--tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208743, NULL, 'G3DSA:1.10.472.10:FF:000648', NULL, NULL, 'AGAP008191-PA', NULL, NULL, NULL, NULL, NULL, 4),
(208744, NULL, 'G3DSA:2.130.10.10:FF:005396', NULL, NULL, 'DmX-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(208745, NULL, 'G3DSA:3.40.50.150:FF:001551', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208746, NULL, 'G3DSA:1.10.1660.30:FF:000001', NULL, NULL, 'Plasmid partition protein A', NULL, NULL, NULL, NULL, NULL, 4),
(208747, NULL, 'G3DSA:1.20.58.60:FF:000424', NULL, NULL, 'Quattro', NULL, NULL, NULL, NULL, NULL, 4),
(208748, NULL, 'G3DSA:1.10.1370.10:FF:000017', NULL, NULL, 'Oligopeptidase A', NULL, NULL, NULL, NULL, NULL, 4),
(208749, NULL, 'G3DSA:1.20.120.1630:FF:000001', NULL, NULL, 'delta(14)-sterol reductase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(208750, NULL, 'G3DSA:1.10.8.10:FF:000310', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(208751, NULL, 'G3DSA:3.30.160.60:FF:006486', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208752, NULL, 'G3DSA:1.25.10.10:FF:000469', NULL, NULL, 'Crm1p', NULL, NULL, NULL, NULL, NULL, 4),
(208753, NULL, 'G3DSA:1.25.40.470:FF:000065', NULL, NULL, 'WD repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208754, NULL, 'G3DSA:2.60.40.10:FF:004125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208755, NULL, 'G3DSA:2.60.40.10:FF:006042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208756, NULL, 'G3DSA:2.40.420.20:FF:000061', NULL, NULL, 'Thiophosphate efflux pump MFP component', NULL, NULL, NULL, NULL, NULL, 4),
(208757, NULL, 'G3DSA:2.30.30.40:FF:000043', NULL, NULL, 'Chemotaxis protein CheW', NULL, NULL, NULL, NULL, NULL, 4),
(208758, NULL, 'G3DSA:1.20.1250.20:FF:000925', NULL, NULL, 'Similar to MFS sugar transporter', NULL, NULL, NULL, NULL, NULL, 4),
(208759, NULL, 'G3DSA:1.20.58.830:FF:000007', NULL, NULL, 'VAR2CSA', NULL, NULL, NULL, NULL, NULL, 4),
(208760, NULL, 'G3DSA:2.60.40.10:FF:001371', NULL, NULL, 'Protein O-linked mannose N-acetylglucosaminyltransferase 2 (beta 1,4-)', NULL, NULL, NULL, NULL, NULL, 4),
(208761, NULL, 'G3DSA:1.20.1270.60:FF:000236', NULL, NULL, 'Rho GTPase-activating protein gacP', NULL, NULL, NULL, NULL, NULL, 4),
(208762, NULL, 'G3DSA:3.30.70.3250:FF:000004', NULL, NULL, 'Ribonuclease P/MRP protein subunit POP5', NULL, NULL, NULL, NULL, NULL, 4),
(208763, NULL, 'G3DSA:3.40.50.300:FF:003890', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(208764, NULL, 'G3DSA:1.10.10.60:FF:000500', NULL, NULL, 'Telomeric repeat-binding factor a', NULL, NULL, NULL, NULL, NULL, 4),
(208765, NULL, 'G3DSA:3.30.420.270:FF:000004', NULL, NULL, 'Putative biopolymer transport protein exbD-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(208766, NULL, 'G3DSA:2.130.10.10:FF:002546', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One component system)', NULL, NULL, NULL, NULL, NULL, 4),
(208767, NULL, 'G3DSA:3.80.10.10:FF:003007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208768, NULL, 'G3DSA:3.80.10.10:FF:004171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208769, NULL, 'G3DSA:6.20.10.30:FF:000007', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(208770, NULL, 'G3DSA:1.10.510.10:FF:003526', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208771, NULL, 'G3DSA:1.10.510.10:FF:004015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208772, NULL, 'G3DSA:2.60.40.420:FF:000090', NULL, NULL, 'NtEPc-like', NULL, NULL, NULL, NULL, NULL, 4),
(208773, NULL, 'G3DSA:2.10.25.10:FF:001669', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208774, NULL, 'G3DSA:1.25.40.10:FF:001825', NULL, NULL, 'pentatricopeptide repeat-containing protein At4g02750', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(208775, NULL, 'G3DSA:1.25.40.10:FF:001713', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(208776, NULL, 'G3DSA:1.25.40.20:FF:001250', NULL, NULL, 'Os09g0341200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(208777, NULL, 'G3DSA:3.90.226.10:FF:000248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208778, NULL, 'G3DSA:2.80.10.50:FF:000172', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(208779, NULL, 'G3DSA:1.25.10.10:FF:001082', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(208780, NULL, 'G3DSA:1.10.1450.10:FF:000069', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(208781, NULL, 'G3DSA:1.25.40.20:FF:000631', NULL, NULL, 'Wide awake, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(208782, NULL, 'G3DSA:3.40.50.1820:FF:000646', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(208783, NULL, 'G3DSA:1.20.1070.10:FF:000594', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(208784, NULL, 'G3DSA:3.40.1630.10:FF:000001', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase J', NULL, NULL, NULL, NULL, NULL, 4),
(208785, NULL, 'G3DSA:1.20.5.1700:FF:000014', NULL, NULL, 'huntingtin-interacting protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(208786, NULL, 'G3DSA:1.10.30.10:FF:000060', NULL, NULL, 'Transcription factor protein', NULL, NULL, NULL, NULL, NULL, 4),
(208787, NULL, 'G3DSA:2.10.110.10:FF:000125', NULL, NULL, 'Four and a half LIM domains 2', NULL, NULL, NULL, NULL, NULL, 4),
(208788, NULL, 'G3DSA:3.40.50.410:FF:000269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208789, NULL, 'G3DSA:3.40.50.620:FF:000214', NULL, NULL, 'Choline-phosphate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(208790, NULL, 'G3DSA:3.40.50.2000:FF:000251', NULL, NULL, 'Glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(208791, NULL, 'G3DSA:2.130.10.10:FF:003491', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208792, NULL, 'G3DSA:3.30.40.10:FF:002067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208793, NULL, 'G3DSA:1.10.10.10:FF:000053', NULL, NULL, 'Serine/threonine-protein kinase RIO2', NULL, NULL, NULL, NULL, NULL, 4),
(208794, NULL, 'G3DSA:3.20.180.20:FF:000025', NULL, NULL, 'Si:dkey-11m19.5', NULL, NULL, NULL, NULL, NULL, 4),
(208795, NULL, 'G3DSA:3.30.1680.10:FF:000001', NULL, NULL, 'Semaphorin 3F like', NULL, NULL, NULL, NULL, NULL, 4),
(208796, NULL, 'G3DSA:3.30.2460.20:FF:000010', NULL, NULL, 'Protein Wnt', NULL, NULL, NULL, NULL, NULL, 4),
(208797, NULL, 'G3DSA:1.10.10.1940:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208798, NULL, 'G3DSA:2.60.40.10:FF:000758', NULL, NULL, 'tyrosine-protein kinase receptor Tie-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(208799, NULL, 'G3DSA:2.30.30.40:FF:000498', NULL, NULL, 'JNK-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(208800, NULL, 'G3DSA:2.30.39.10:FF:000150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208801, NULL, 'G3DSA:3.90.520.10:FF:000005', NULL, NULL, 'Mothers against decapentaplegic homolog', NULL, NULL, NULL, NULL, NULL, 4),
(208802, NULL, 'G3DSA:2.60.120.10:FF:000822', NULL, NULL, 'Homogentisate 12-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(208803, NULL, 'G3DSA:2.30.42.10:FF:000062', NULL, NULL, 'harmonin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(208804, NULL, 'G3DSA:3.40.640.10:FF:000076', NULL, NULL, 'N-succinyldiaminopimelate aminotransferase DapC', NULL, NULL, NULL, NULL, NULL, 4),
(208805, NULL, 'G3DSA:3.30.160.60:FF:000303', NULL, NULL, 'Zinc finger protein 41', NULL, NULL, NULL, NULL, NULL, 4),
(208806, NULL, 'G3DSA:3.30.160.60:FF:005974', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208807, NULL, 'G3DSA:1.10.8.10:FF:000198', NULL, NULL, 'Myosin XXI', NULL, NULL, NULL, NULL, NULL, 4),
(208808, NULL, 'G3DSA:1.20.1510.10:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(208809, NULL, 'G3DSA:3.80.30.20:FF:000010', NULL, NULL, 'tRNA (N(6)-L-threonylcarbamoyladenosine(37)-C(2))-methylthiotransferase MtaB', NULL, NULL, NULL, NULL, NULL, 4),
(208810, NULL, 'G3DSA:2.170.120.40:FF:000007', NULL, NULL, 'YbbR-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(208811, NULL, 'G3DSA:3.40.50.720:FF:001874', NULL, NULL, 'NADPH:adrenodoxin oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208812, NULL, 'G3DSA:1.25.10.10:FF:002942', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(208813, NULL, 'G3DSA:3.30.70.330:FF:001342', NULL, NULL, 'Poly(A)-specific ribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(208814, NULL, 'G3DSA:1.10.287.70:FF:000112', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(208815, NULL, 'G3DSA:2.60.210.10:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208816, NULL, 'G3DSA:2.40.10.10:FF:000420', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208817, NULL, 'G3DSA:1.10.730.10:FF:000069', NULL, NULL, 'Isoleucyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208818, NULL, 'G3DSA:1.10.357.20:FF:000013', NULL, NULL, 'Protein CBG20346', NULL, NULL, NULL, NULL, NULL, 4),
(208819, NULL, 'G3DSA:1.10.1040.50:FF:000010', NULL, NULL, 'Enoyl-CoA, hydratase/3-hydroxyacyl CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(208820, NULL, 'G3DSA:2.60.120.200:FF:000589', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208821, NULL, 'G3DSA:3.60.15.10:FF:000271', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208822, NULL, 'G3DSA:1.10.287.380:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208823, NULL, 'G3DSA:3.40.30.10:FF:000144', NULL, NULL, 'Thioredoxin domain', NULL, NULL, NULL, NULL, NULL, 4),
(208824, NULL, 'G3DSA:2.40.30.10:FF:000303', NULL, NULL, 'Eukaryotic translation initiation factor 2 subunit gamma B', NULL, NULL, NULL, NULL, NULL, 4),
(208825, NULL, 'G3DSA:2.170.120.20:FF:000001', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(208826, NULL, 'G3DSA:1.25.10.10:FF:000688', NULL, NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(208827, NULL, 'G3DSA:2.60.260.20:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208828, NULL, 'G3DSA:2.60.40.10:FF:002782', NULL, NULL, '(Glucose-repressible genes) transcriptional activator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208829, NULL, 'G3DSA:3.50.50.60:FF:001115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208830, NULL, 'G3DSA:2.130.10.10:FF:001927', NULL, NULL, 'Bcrad28', NULL, NULL, NULL, NULL, NULL, 4),
(208831, NULL, 'G3DSA:1.25.10.10:FF:001088', NULL, NULL, 'Importin subunit alpha-5', NULL, NULL, NULL, NULL, NULL, 4),
(208832, NULL, 'G3DSA:1.10.1670.10:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208833, NULL, 'G3DSA:2.10.25.10:FF:000253', NULL, NULL, 'Neurogenic locus notch protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(208834, NULL, 'G3DSA:1.10.10.60:FF:000495', NULL, NULL, 'Transcription factor MYB14', NULL, NULL, NULL, NULL, NULL, 4),
(208835, NULL, 'G3DSA:3.20.20.20:FF:000029', NULL, NULL, 'Dihydropteroate synthase DHPS', NULL, NULL, NULL, NULL, NULL, 4),
(208836, NULL, 'G3DSA:3.30.800.10:FF:000001', NULL, NULL, 'phosphatidylinositol 4-phosphate 5-kinase type-1 gamma', NULL, NULL, NULL, NULL, NULL, 4),
(208837, NULL, 'G3DSA:3.40.50.1110:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208838, NULL, 'G3DSA:3.30.160.60:FF:000758', NULL, NULL, 'C2H2 transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208839, NULL, 'G3DSA:3.60.20.10:FF:000255', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208840, NULL, 'G3DSA:3.40.50.300:FF:002260', NULL, NULL, 'Dynein beta chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208841, NULL, 'G3DSA:3.30.2130.30:FF:000045', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(208842, NULL, 'G3DSA:1.50.40.10:FF:000340', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208843, NULL, 'G3DSA:2.10.25.10:FF:001664', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208844, NULL, 'G3DSA:1.10.20.10:FF:000115', NULL, NULL, 'Histone H4', NULL, NULL, NULL, NULL, NULL, 4),
(208845, NULL, 'G3DSA:1.10.1170.10:FF:000036', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(208846, NULL, 'G3DSA:2.40.50.40:FF:000072', NULL, NULL, 'Chemokine (C-C motif) ligand 34b, duplicate 3', NULL, NULL, NULL, NULL, NULL, 4),
(208847, NULL, 'G3DSA:3.50.30.30:FF:000161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208848, NULL, 'G3DSA:1.25.40.20:FF:000182', NULL, NULL, 'Ankyrin repeat and MYND domain containing 2a', NULL, NULL, NULL, NULL, NULL, 4),
(208849, NULL, 'G3DSA:3.30.70.330:FF:001561', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208850, NULL, 'G3DSA:1.10.630.10:FF:000247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208851, NULL, 'G3DSA:2.60.40.10:FF:000421', NULL, NULL, 'LOW QUALITY PROTEIN: obscurin', NULL, NULL, NULL, NULL, NULL, 4),
(208852, NULL, 'G3DSA:3.40.50.2300:FF:001072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208853, NULL, 'G3DSA:2.60.40.820:FF:000007', NULL, NULL, 'T-box transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(208854, NULL, 'G3DSA:1.25.40.10:FF:003175', NULL, NULL, 'Os03g0775400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(208855, NULL, 'G3DSA:3.80.10.10:FF:001990', NULL, NULL, 'Nephrocan', NULL, NULL, NULL, NULL, NULL, 4),
(208856, NULL, 'G3DSA:1.10.287.70:FF:000331', NULL, NULL, '2P domain K+ channel TWIK-2', NULL, NULL, NULL, NULL, NULL, 4),
(208857, NULL, 'G3DSA:3.40.50.1820:FF:000539', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(208858, NULL, 'G3DSA:2.60.40.1170:FF:000048', NULL, NULL, 'AP-3 complex subunit mu', NULL, NULL, NULL, NULL, NULL, 4),
(208859, NULL, 'G3DSA:3.80.10.10:FF:000697', NULL, NULL, 'Leucine-rich repeat-containing 8 VRAC subunit Aa', NULL, NULL, NULL, NULL, NULL, 4),
(208860, NULL, 'G3DSA:1.10.3430.10:FF:000079', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(208861, NULL, 'G3DSA:1.20.1050.10:FF:000255', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(208862, NULL, 'G3DSA:1.10.238.100:FF:000005', NULL, NULL, 'BZIP transcription factor (Fcr3), putative', NULL, NULL, NULL, NULL, NULL, 4),
(208863, NULL, 'G3DSA:2.60.40.60:FF:000863', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208864, NULL, 'G3DSA:1.25.40.10:FF:004698', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208865, NULL, 'G3DSA:3.30.460.10:FF:000013', NULL, NULL, 'terminal uridylyltransferase 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(208866, NULL, 'G3DSA:2.130.10.10:FF:003384', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208867, NULL, 'G3DSA:3.80.10.10:FF:002602', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208868, NULL, 'G3DSA:2.60.40.10:FF:000073', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(208869, NULL, 'G3DSA:3.30.40.10:FF:000959', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(208870, NULL, 'G3DSA:1.20.1250.20:FF:000476', NULL, NULL, 'Cysteine transporter', NULL, NULL, NULL, NULL, NULL, 4),
(208871, NULL, 'G3DSA:3.30.160.60:FF:001826', NULL, NULL, 'Lethal (3) neo38, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(208872, NULL, 'G3DSA:3.40.50.12780:FF:000196', NULL, NULL, 'AMP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(208873, NULL, 'G3DSA:1.10.3720.10:FF:000186', NULL, NULL, 'ABC transporter permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(208874, NULL, 'G3DSA:3.90.180.10:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208875, NULL, 'G3DSA:3.30.160.60:FF:004125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208876, NULL, 'G3DSA:1.20.1250.20:FF:000133', NULL, NULL, 'Inner membrane protein YbjJ', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(208877, NULL, 'G3DSA:1.20.58.830:FF:000002', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(208878, NULL, 'G3DSA:1.20.58.60:FF:000880', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208879, NULL, 'G3DSA:1.10.3820.10:FF:000002', NULL, NULL, 'Cytochrome c nitrate reductase small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(208880, NULL, 'G3DSA:3.40.1280.10:FF:000075', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4),
(208881, NULL, 'G3DSA:2.40.50.140:FF:000708', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208882, NULL, 'G3DSA:2.60.120.970:FF:000005', NULL, NULL, 'Bone morphogenetic protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(208883, NULL, 'G3DSA:2.60.40.150:FF:000565', NULL, NULL, 'Ca2+dependent plant phosphoribosyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(208884, NULL, 'G3DSA:1.25.40.120:FF:000095', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(208885, NULL, 'G3DSA:2.60.40.2860:FF:000010', NULL, NULL, 'Transmission-blocking target antigen S230', NULL, NULL, NULL, NULL, NULL, 4),
(208886, NULL, 'G3DSA:2.60.120.290:FF:000228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208887, NULL, 'G3DSA:3.30.900.10:FF:000042', NULL, NULL, 'Histone H4 transcription factor-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(208888, NULL, 'G3DSA:1.10.510.10:FF:001710', NULL, NULL, 'Os07g0555700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(208889, NULL, 'G3DSA:1.20.1260.110:FF:000003', NULL, NULL, 'DNA integrity scanning protein DisA', NULL, NULL, NULL, NULL, NULL, 4),
(208890, NULL, 'G3DSA:2.60.40.1080:FF:000010', NULL, NULL, 'S-layer protein', NULL, NULL, NULL, NULL, NULL, 4),
(208891, NULL, 'G3DSA:3.30.160.60:FF:004232', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208892, NULL, 'G3DSA:3.30.40.10:FF:001578', NULL, NULL, 'DUF602 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(208893, NULL, 'G3DSA:3.40.20.10:FF:000082', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(208894, NULL, 'G3DSA:2.60.120.200:FF:000701', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208895, NULL, 'G3DSA:3.40.50.2300:FF:000127', NULL, NULL, 'Response regulator (OmpR)', NULL, NULL, NULL, NULL, NULL, 4),
(208896, NULL, 'G3DSA:3.30.40.10:FF:000055', NULL, NULL, 'Ubiquitin conjugation factor e4 a', NULL, NULL, NULL, NULL, NULL, 4),
(208897, NULL, 'G3DSA:1.20.5.1300:FF:000001', NULL, NULL, 'Histidine biosynthesis trifunctional protein', NULL, NULL, NULL, NULL, NULL, 4),
(208898, NULL, 'G3DSA:3.40.30.10:FF:000700', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208899, NULL, 'G3DSA:3.40.1410.10:FF:000013', NULL, NULL, 'Mannosyl-D-glycerate transport/metabolism system repressor mngR', NULL, NULL, NULL, NULL, NULL, 4),
(208900, NULL, 'G3DSA:3.10.440.10:FF:000005', NULL, NULL, '50S ribosomal protein L31e', NULL, NULL, NULL, NULL, NULL, 4),
(208901, NULL, 'G3DSA:3.40.50.450:FF:000034', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(208902, NULL, 'G3DSA:3.40.50.300:FF:000124', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(208903, NULL, 'G3DSA:3.60.10.10:FF:000086', NULL, NULL, 'Carbon catabolite repressor protein 4 homolog 6', NULL, NULL, NULL, NULL, NULL, 4),
(208904, NULL, 'G3DSA:2.130.10.10:FF:003035', NULL, NULL, 'Uncharacterized WD repeat-containing protein slr1409', NULL, NULL, NULL, NULL, NULL, 4),
(208905, NULL, 'G3DSA:1.10.287.70:FF:000224', NULL, NULL, 'Potassium voltage-gated channel subfamily C member 2', NULL, NULL, NULL, NULL, NULL, 4),
(208906, NULL, 'G3DSA:3.40.50.1000:FF:000389', NULL, NULL, 'CTDNEP1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(208907, NULL, 'G3DSA:3.30.590.10:FF:000017', NULL, NULL, 'Probable glutamine synthetase glnA3', NULL, NULL, NULL, NULL, NULL, 4),
(208908, NULL, 'G3DSA:3.40.390.10:FF:000185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208909, NULL, 'G3DSA:2.60.300.12:FF:000018', NULL, NULL, 'Iron-sulfur cluster assembly accessory protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(208910, NULL, 'G3DSA:1.10.4140.10:FF:000001', NULL, NULL, 'SPI-1 type III secretion system effector HECT-type E3 ubiquitin transferase SopA', NULL, NULL, NULL, NULL, NULL, 4),
(208911, NULL, 'G3DSA:3.30.1330.20:FF:000023', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(208912, NULL, 'G3DSA:2.130.10.10:FF:001922', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208913, NULL, 'G3DSA:2.60.40.10:FF:002894', NULL, NULL, 'SNF1-related protein kinase regulatory subunit beta, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208914, NULL, 'G3DSA:3.10.580.10:FF:000162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208915, NULL, 'G3DSA:2.70.160.11:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208916, NULL, 'G3DSA:1.10.10.10:FF:001469', NULL, NULL, 'Putative U5 small nuclear ribonucleoprotein 200 kDa helicase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(208917, NULL, 'G3DSA:1.10.600.10:FF:000071', NULL, NULL, 'Phytoene synthase', NULL, NULL, NULL, NULL, NULL, 4),
(208918, NULL, 'G3DSA:3.40.50.300:FF:003434', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208919, NULL, 'G3DSA:2.60.40.10:FF:003743', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208920, NULL, 'G3DSA:2.130.10.10:FF:000629', NULL, NULL, 'UV-damaged DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(208921, NULL, 'G3DSA:3.40.50.410:FF:000264', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(208922, NULL, 'G3DSA:3.60.20.10:FF:000125', NULL, NULL, 'Proteasome subunit alpha type', NULL, NULL, NULL, NULL, NULL, 4),
(208923, NULL, 'G3DSA:1.20.1070.10:FF:002156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208924, NULL, 'G3DSA:3.40.1190.20:FF:000189', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208925, NULL, 'G3DSA:3.40.50.2300:FF:000796', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208926, NULL, 'G3DSA:1.10.10.650:FF:000016', NULL, NULL, 'Transcription elongation factor Spt6', NULL, NULL, NULL, NULL, NULL, 4),
(208927, NULL, 'G3DSA:3.30.1330.100:FF:000004', NULL, NULL, 'GTP protein', NULL, NULL, NULL, NULL, NULL, 4),
(208928, NULL, 'G3DSA:2.60.120.10:FF:000266', NULL, NULL, 'Phosphomannose isomerase type I, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208929, NULL, 'G3DSA:1.10.580.10:FF:000023', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(208930, NULL, 'G3DSA:3.30.1330.40:FF:000029', NULL, NULL, 'Unplaced genomic scaffold supercont2.28, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(208931, NULL, 'G3DSA:3.80.10.10:FF:000129', NULL, NULL, 'Leucine-rich repeat receptor-like kinase', NULL, NULL, NULL, NULL, NULL, 4),
(208932, NULL, 'G3DSA:2.30.30.140:FF:000201', NULL, NULL, 'Putative ATP-dependent RNA helicase SoYb', NULL, NULL, NULL, NULL, NULL, 4),
(208933, NULL, 'G3DSA:3.30.230.10:FF:000199', NULL, NULL, 'Protein CBR-TAG-96', NULL, NULL, NULL, NULL, NULL, 4),
(208934, NULL, 'G3DSA:3.10.330.10:FF:000014', NULL, NULL, 'Blast:Peroxisome biogenesis factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(208935, NULL, 'G3DSA:1.10.1370.30:FF:000012', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(208936, NULL, 'G3DSA:1.20.1410.10:FF:000002', NULL, NULL, 'Huntingtin interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(208937, NULL, 'G3DSA:2.60.40.60:FF:000970', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208938, NULL, 'G3DSA:1.25.40.10:FF:002770', NULL, NULL, 'Probable inactive receptor-like kinase BSK12', NULL, NULL, NULL, NULL, NULL, 4),
(208939, NULL, 'G3DSA:1.20.5.110:FF:000135', NULL, NULL, 'Sporulation-specific protein 20', NULL, NULL, NULL, NULL, NULL, 4),
(208940, NULL, 'G3DSA:1.10.1060.10:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208941, NULL, 'G3DSA:3.40.50.300:FF:007616', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208942, NULL, 'G3DSA:3.40.50.300:FF:003327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(208943, NULL, 'G3DSA:3.30.420.230:FF:000003', NULL, NULL, 'Pre-mRNA-processing-splicing factor 8', NULL, NULL, NULL, NULL, NULL, 4),
(208944, NULL, 'G3DSA:3.40.50.2300:FF:001420', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208945, NULL, 'G3DSA:3.50.50.60:FF:000603', NULL, NULL, 'Flavin-containing monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208946, NULL, 'G3DSA:3.40.30.10:FF:000363', NULL, NULL, 'Glutaredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(208947, NULL, 'G3DSA:1.25.10.10:FF:002386', NULL, NULL, 'LD19058p', NULL, NULL, NULL, NULL, NULL, 4),
(208948, NULL, 'G3DSA:1.10.10.790:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208949, NULL, 'G3DSA:3.30.310.10:FF:000019', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(208950, NULL, 'G3DSA:3.40.50.720:FF:000025', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(208951, NULL, 'G3DSA:3.40.50.300:FF:000343', NULL, NULL, 'Ras family gtpase', NULL, NULL, NULL, NULL, NULL, 4),
(208952, NULL, 'G3DSA:3.40.47.10:FF:000227', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208953, NULL, 'G3DSA:3.30.40.10:FF:000274', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(208954, NULL, 'G3DSA:1.20.1310.10:FF:000186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208955, NULL, 'G3DSA:2.10.70.20:FF:000001', NULL, NULL, 'General secretion pathway protein J', NULL, NULL, NULL, NULL, NULL, 4),
(208956, NULL, 'G3DSA:1.10.287.80:FF:000008', NULL, NULL, 'ATP synthase F1 subunit gamma protein', NULL, NULL, NULL, NULL, NULL, 4),
(208957, NULL, 'G3DSA:3.30.70.330:FF:002735', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208958, NULL, 'G3DSA:1.25.10.10:FF:003347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208959, NULL, 'G3DSA:2.10.25.10:FF:000490', NULL, NULL, 'von Willebrand factor D and EGF domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(208960, NULL, 'G3DSA:3.40.50.720:FF:001879', NULL, NULL, 'GH01674p', NULL, NULL, NULL, NULL, NULL, 4),
(208961, NULL, 'G3DSA:1.20.58.900:FF:000034', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(208962, NULL, 'G3DSA:4.10.240.10:FF:000037', NULL, NULL, 'Glucose starvation modulator protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(208963, NULL, 'G3DSA:1.20.1540.10:FF:000006', NULL, NULL, 'rhomboid-related protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(208964, NULL, 'G3DSA:2.30.39.10:FF:000043', NULL, NULL, 'Serpin 7 precursor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208965, NULL, 'G3DSA:3.30.70.360:FF:000024', NULL, NULL, 'Beta-Ala-His dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(208966, NULL, 'G3DSA:3.90.25.10:FF:000085', NULL, NULL, 'Uncharacterized protein PB2B2.11', NULL, NULL, NULL, NULL, NULL, 4),
(208967, NULL, 'G3DSA:3.30.70.330:FF:002865', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208968, NULL, 'G3DSA:1.20.930.20:FF:000006', NULL, NULL, 'Armadillo repeat only 4', NULL, NULL, NULL, NULL, NULL, 4),
(208969, NULL, 'G3DSA:1.10.10.60:FF:000618', NULL, NULL, 'FRIGIDA interacting protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(208970, NULL, 'G3DSA:3.10.130.10:FF:000010', NULL, NULL, 'RNase 3', NULL, NULL, NULL, NULL, NULL, 4),
(208971, NULL, 'G3DSA:3.20.20.300:FF:000061', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208972, NULL, 'G3DSA:3.40.50.12780:FF:000089', NULL, NULL, 'AMP dependent ligase/synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208973, NULL, 'G3DSA:3.30.160.60:FF:004917', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208974, NULL, 'G3DSA:3.30.70.330:FF:003011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208975, NULL, 'G3DSA:2.10.25.10:FF:000360', NULL, NULL, 'Sushi, nidogen and EGF like domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(208976, NULL, 'G3DSA:3.40.50.300:FF:005014', NULL, NULL, 'Ribosome biogenesis protein BMS1 homolog-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(208977, NULL, 'G3DSA:3.30.310.80:FF:000001', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(208978, NULL, 'G3DSA:3.80.10.10:FF:003788', NULL, NULL, 'RNI-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(208979, NULL, 'G3DSA:3.40.1110.10:FF:000316', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(208980, NULL, 'G3DSA:3.40.50.1390:FF:000011', NULL, NULL, 'Resolvase protein', NULL, NULL, NULL, NULL, NULL, 4),
(208981, NULL, 'G3DSA:3.90.180.10:FF:000017', NULL, NULL, 'NADP-dependent alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(208982, NULL, 'G3DSA:2.60.120.340:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208983, NULL, 'G3DSA:1.10.640.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208984, NULL, 'G3DSA:1.25.40.20:FF:000867', NULL, NULL, 'Ankyrin_repeats_(Many_copies)/Ankyrin_repeats_(3_ copies)/Ankyrin_repeat_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(208985, NULL, 'G3DSA:3.80.10.10:FF:004064', NULL, NULL, 'F-box/leucine rich repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208986, NULL, 'G3DSA:1.10.1000.11:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208987, NULL, 'G3DSA:3.90.226.10:FF:000355', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(208988, NULL, 'G3DSA:1.25.40.20:FF:001143', NULL, NULL, 'UPF0507 protein YALI0E18612g', NULL, NULL, NULL, NULL, NULL, 4),
(208989, NULL, 'G3DSA:1.10.10.10:FF:001817', NULL, NULL, 'Vacuolar protein-sorting protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208990, NULL, 'G3DSA:3.40.50.300:FF:004738', NULL, NULL, 'Multidrug resistance protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(208991, NULL, 'G3DSA:3.40.50.620:FF:000326', NULL, NULL, 'Leucine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(208992, NULL, 'G3DSA:3.10.20.90:FF:000882', NULL, NULL, 'GA-binding protein transcription factor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(208993, NULL, 'G3DSA:3.40.50.2020:FF:000127', NULL, NULL, 'Orotate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(208994, NULL, 'G3DSA:3.30.730.10:FF:000006', NULL, NULL, 'ethylene-responsive transcription factor ERF014-like', NULL, NULL, NULL, NULL, NULL, 4),
(208995, NULL, 'G3DSA:3.40.50.720:FF:002279', NULL, NULL, 'Os11g0229100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(208996, NULL, 'G3DSA:1.25.40.10:FF:001606', NULL, NULL, 'Anaphase-promoting complex subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(208997, NULL, 'G3DSA:2.60.34.10:FF:000036', NULL, NULL, 'Heat shock 70 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(208998, NULL, 'G3DSA:2.10.70.10:FF:000116', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(208999, NULL, 'G3DSA:3.30.1370.10:FF:000135', NULL, NULL, 'RE73736p', NULL, NULL, NULL, NULL, NULL, 4),
(209000, NULL, 'G3DSA:1.25.10.10:FF:002947', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(209001, NULL, 'G3DSA:1.10.275.60:FF:000003', NULL, NULL, 'Adenylosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(209002, NULL, 'G3DSA:3.30.70.330:FF:003135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209003, NULL, 'G3DSA:1.25.40.10:FF:001258', NULL, NULL, 'Soluble NSF attachment protein gamma isoform, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209004, NULL, 'G3DSA:1.20.1440.170:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209005, NULL, 'G3DSA:1.10.2000.10:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209006, NULL, 'G3DSA:3.90.640.10:FF:000059', NULL, NULL, 'Actin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(209007, NULL, 'G3DSA:1.20.1270.60:FF:000129', NULL, NULL, 'Islet cell autoantigen', NULL, NULL, NULL, NULL, NULL, 4),
(209008, NULL, 'G3DSA:3.40.50.1820:FF:001028', NULL, NULL, 'Lipid particle protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209009, NULL, 'G3DSA:3.30.160.60:FF:005536', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209010, NULL, 'G3DSA:3.40.50.620:FF:000107', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(209011, NULL, 'G3DSA:2.30.170.40:FF:000009', NULL, NULL, '50S ribosomal protein L28', NULL, NULL, NULL, NULL, NULL, 4),
(209012, NULL, 'G3DSA:2.60.40.60:FF:000520', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209013, NULL, 'G3DSA:2.30.170.20:FF:000003', NULL, NULL, '60S ribosomal protein L24', NULL, NULL, NULL, NULL, NULL, 4),
(209014, NULL, 'G3DSA:1.10.287.950:FF:000005', NULL, NULL, 'Laminin subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(209015, NULL, 'G3DSA:2.60.40.10:FF:003164', NULL, NULL, 'Chitinase A', NULL, NULL, NULL, NULL, NULL, 4),
(209016, NULL, 'G3DSA:3.40.50.1220:FF:000112', NULL, NULL, 'NAD-dependent protein deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(209017, NULL, 'G3DSA:3.40.140.10:FF:000032', NULL, NULL, 'DNA repair protein RadC', NULL, NULL, NULL, NULL, NULL, 4),
(209018, NULL, 'G3DSA:1.25.40.500:FF:000006', NULL, NULL, 'GD12864', NULL, NULL, NULL, NULL, NULL, 4),
(209019, NULL, 'G3DSA:3.10.129.10:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209020, NULL, 'G3DSA:2.10.25.10:FF:001321', NULL, NULL, 'Crumbs cell polarity complex component 1', NULL, NULL, NULL, NULL, NULL, 4),
(209021, NULL, 'G3DSA:2.40.50.140:FF:000591', NULL, NULL, 'DNA replication, chromatin-associated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209022, NULL, 'G3DSA:1.10.150.250:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209023, NULL, 'G3DSA:4.10.400.10:FF:000128', NULL, NULL, 'Vermiform, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(209024, NULL, 'G3DSA:1.10.510.10:FF:000182', NULL, NULL, 'MAP kinase kinase kinase mkh1', NULL, NULL, NULL, NULL, NULL, 4),
(209025, NULL, 'G3DSA:1.10.720.30:FF:000018', NULL, NULL, 'Uncharacterized protein, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(209026, NULL, 'G3DSA:1.25.40.10:FF:004568', NULL, NULL, 'Pre-mRNA-splicing factor CLF1', NULL, NULL, NULL, NULL, NULL, 4),
(209027, NULL, 'G3DSA:3.30.540.10:FF:000065', NULL, NULL, 'Ammonium transporter', NULL, NULL, NULL, NULL, NULL, 4),
(209028, NULL, 'G3DSA:1.10.510.10:FF:001609', NULL, NULL, 'Fused serine/threonine kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(209029, NULL, 'G3DSA:1.20.5.120:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209030, NULL, 'G3DSA:3.30.420.40:FF:000795', NULL, NULL, 'Heat shock protein 70 putative', NULL, NULL, NULL, NULL, NULL, 4),
(209031, NULL, 'G3DSA:3.50.50.60:FF:000480', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(209032, NULL, 'G3DSA:1.25.10.20:FF:000011', NULL, NULL, 'AGAP008369-PA', NULL, NULL, NULL, NULL, NULL, 4),
(209033, NULL, 'G3DSA:3.30.160.60:FF:000865', NULL, NULL, 'zinc finger protein 140 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(209034, NULL, 'G3DSA:1.10.4100.10:FF:000004', NULL, NULL, '2-methylcitrate dehydratase PrpD', NULL, NULL, NULL, NULL, NULL, 4),
(209035, NULL, 'G3DSA:1.10.1080.10:FF:000023', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(209036, NULL, 'G3DSA:2.60.40.3510:FF:000020', NULL, NULL, 'Jagged canonical Notch ligand 2', NULL, NULL, NULL, NULL, NULL, 4),
(209037, NULL, 'G3DSA:1.20.1160.11:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209038, NULL, 'G3DSA:3.30.40.10:FF:000398', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM71', NULL, NULL, NULL, NULL, NULL, 4),
(209039, NULL, 'G3DSA:3.30.760.10:FF:000053', NULL, NULL, 'Eukaryotic translation initiation factor 4E family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(209040, NULL, 'G3DSA:3.10.450.50:FF:000046', NULL, NULL, 'Nuclear RNA export factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(209041, NULL, 'G3DSA:3.30.70.3490:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209042, NULL, 'G3DSA:2.40.40.20:FF:000032', NULL, NULL, 'vesicle-fusing ATPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(209043, NULL, 'G3DSA:3.70.10.10:FF:000001', NULL, NULL, 'Proliferating cell nuclear antigen', NULL, NULL, NULL, NULL, NULL, 4),
(209044, NULL, 'G3DSA:1.10.510.10:FF:000530', NULL, NULL, 'probable receptor-like protein kinase At5g59700', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(209045, NULL, 'G3DSA:3.90.260.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209046, NULL, 'G3DSA:1.20.1420.30:FF:000059', NULL, NULL, 'Ca(2+)/H(+) antiporter', NULL, NULL, NULL, NULL, NULL, 4),
(209047, NULL, 'G3DSA:3.40.50.2300:FF:000801', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209048, NULL, 'G3DSA:2.60.120.620:FF:000035', NULL, NULL, 'prolyl 3-hydroxylase sudestada1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(209049, NULL, 'G3DSA:3.30.1640.10:FF:000004', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(209050, NULL, 'G3DSA:3.10.400.10:FF:000003', NULL, NULL, 'Sulfate adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(209051, NULL, 'G3DSA:1.10.472.80:FF:000175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209052, NULL, 'G3DSA:3.90.550.10:FF:000501', NULL, NULL, 'Exostosin-1', NULL, NULL, NULL, NULL, NULL, 4),
(209053, NULL, 'G3DSA:3.60.10.10:FF:000299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209054, NULL, 'G3DSA:3.40.390.10:FF:000308', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209055, NULL, 'G3DSA:2.60.40.3500:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209056, NULL, 'G3DSA:1.50.40.10:FF:000452', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209057, NULL, 'G3DSA:3.40.50.720:FF:000817', NULL, NULL, 'Short chain dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(209058, NULL, 'G3DSA:3.30.1370.50:FF:000012', NULL, NULL, 'Transcription factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(209059, NULL, 'G3DSA:2.60.120.260:FF:000579', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209060, NULL, 'G3DSA:3.70.10.10:FF:000107', NULL, NULL, 'Rad9', NULL, NULL, NULL, NULL, NULL, 4),
(209061, NULL, 'G3DSA:2.60.40.2170:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209062, NULL, 'G3DSA:1.25.40.10:FF:004916', NULL, NULL, 'Genomes uncoupled1', NULL, NULL, NULL, NULL, NULL, 4),
(209063, NULL, 'G3DSA:1.25.10.10:FF:000126', NULL, NULL, 'TOG array regulator of axonemal microtubules 1', NULL, NULL, NULL, NULL, NULL, 4),
(209064, NULL, 'G3DSA:3.90.660.10:FF:000043', NULL, NULL, 'Lysine-specific histone demethylase 1A', NULL, NULL, NULL, NULL, NULL, 4),
(209065, NULL, 'G3DSA:1.20.1070.10:FF:001667', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(209066, NULL, 'G3DSA:1.25.40.20:FF:000070', NULL, NULL, 'ankyrin repeat domain-containing protein 17 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(209067, NULL, 'G3DSA:1.20.1250.20:FF:000346', NULL, NULL, 'Transporter, major facilitator family', NULL, NULL, NULL, NULL, NULL, 4),
(209068, NULL, 'G3DSA:1.10.510.10:FF:001834', NULL, NULL, 'Si:ch211-22d5.2', NULL, NULL, NULL, NULL, NULL, 4),
(209069, NULL, 'G3DSA:3.30.70.330:FF:000156', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein d0 isoform', NULL, NULL, NULL, NULL, NULL, 4),
(209070, NULL, 'G3DSA:3.30.70.250:FF:000008', NULL, NULL, 'Unplaced genomic scaffold supercont1.17, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(209071, NULL, 'G3DSA:3.40.50.2300:FF:001184', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209072, NULL, 'G3DSA:3.40.710.10:FF:000177', NULL, NULL, 'Glutaminase a', NULL, NULL, NULL, NULL, NULL, 4),
(209073, NULL, 'G3DSA:2.60.40.150:FF:000778', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209074, NULL, 'G3DSA:3.40.50.1820:FF:000067', NULL, NULL, 'Bifunctional epoxide hydrolase 2', NULL, NULL, NULL, NULL, NULL, 4),
(209075, NULL, 'G3DSA:3.90.70.80:FF:000024', NULL, NULL, 'OTU-like cysteine protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209076, NULL, 'G3DSA:2.60.40.2700:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209077, NULL, 'G3DSA:1.10.60.10:FF:000005', NULL, NULL, 'Transcriptional regulator MntR protein', NULL, NULL, NULL, NULL, NULL, 4),
(209078, NULL, 'G3DSA:2.130.10.10:FF:000854', NULL, NULL, 'Eukaryotic translation initiation factor 2A', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(209079, NULL, 'G3DSA:1.20.1050.10:FF:000143', NULL, NULL, 'Glutathione S-transferase, C-terminal domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(209080, NULL, 'G3DSA:3.40.250.10:FF:000153', NULL, NULL, 'Putative thiosulfate sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(209081, NULL, 'G3DSA:3.10.10.10:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209082, NULL, 'G3DSA:1.10.12.10:FF:000018', NULL, NULL, 'Probable enoyl-CoA hydratase echA10', NULL, NULL, NULL, NULL, NULL, 4),
(209083, NULL, 'G3DSA:3.40.50.620:FF:000557', NULL, NULL, '7-cyano-7-deazaguanine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(209084, NULL, 'G3DSA:3.40.50.1820:FF:001596', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209085, NULL, 'G3DSA:3.30.70.20:FF:000099', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209086, NULL, 'G3DSA:1.20.5.170:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209087, NULL, 'G3DSA:3.30.160.60:FF:004013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209088, NULL, 'G3DSA:3.30.505.10:FF:000152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209089, NULL, 'G3DSA:1.10.287.1040:FF:000005', NULL, NULL, 'Exodeoxyribonuclease 7 small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(209090, NULL, 'G3DSA:1.20.1250.20:FF:000352', NULL, NULL, 'Major Facilitator Superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(209091, NULL, 'G3DSA:3.30.1330.80:FF:000013', NULL, NULL, 'AT-hook motif nuclear-localized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209092, NULL, 'G3DSA:2.30.29.30:FF:000205', NULL, NULL, 'Rho guanine nucleotide exchange factor (GEF) 19', NULL, NULL, NULL, NULL, NULL, 4),
(209093, NULL, 'G3DSA:3.40.50.150:FF:001787', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209094, NULL, 'G3DSA:1.25.40.20:FF:001593', NULL, NULL, 'Protein CBG05582', NULL, NULL, NULL, NULL, NULL, 4),
(209095, NULL, 'G3DSA:3.60.10.10:FF:000411', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209096, NULL, 'G3DSA:3.30.40.10:FF:001123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209097, NULL, 'G3DSA:1.20.58.340:FF:000063', NULL, NULL, 'Metal ion transporter', NULL, NULL, NULL, NULL, NULL, 4),
(209098, NULL, 'G3DSA:3.60.21.10:FF:000217', NULL, NULL, 'Serine/threonine protein phosphatase BSU1', NULL, NULL, NULL, NULL, NULL, 4),
(209099, NULL, 'G3DSA:1.20.1410.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209100, NULL, 'G3DSA:3.30.470.30:FF:000065', NULL, NULL, 'RNA guanylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(209101, NULL, 'G3DSA:2.120.10.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209102, NULL, 'G3DSA:1.10.3660.10:FF:000017', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(209103, NULL, 'G3DSA:2.30.30.140:FF:000090', NULL, NULL, 'Tudor domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(209104, NULL, 'G3DSA:1.10.8.60:FF:000314', NULL, NULL, 'Chromosome 12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(209105, NULL, 'G3DSA:3.40.630.70:FF:000003', NULL, NULL, 'Leucyl/phenylalanyl-tRNA--protein transferase', NULL, NULL, NULL, NULL, NULL, 4),
(209106, NULL, 'G3DSA:1.20.1260.140:FF:000001', NULL, NULL, 'Ubiquinol oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(209107, NULL, 'G3DSA:1.10.287.1480:FF:000002', NULL, NULL, 'Probable 40S ribosomal protein S14, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(209108, NULL, 'G3DSA:1.25.40.280:FF:000002', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type 23', NULL, NULL, NULL, NULL, NULL, 4),
(209109, NULL, 'G3DSA:1.25.10.10:FF:000132', NULL, NULL, 'TATA-binding protein-associated factor 172 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(209110, NULL, 'G3DSA:1.10.510.10:FF:000305', NULL, NULL, 'phosphoinositide 3-kinase regulatory subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(209111, NULL, 'G3DSA:3.30.230.10:FF:000417', NULL, NULL, 'ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(209112, NULL, 'G3DSA:2.60.450.10:FF:000015', NULL, NULL, 'LPS ABC transporter substrate-binding protein LptA', NULL, NULL, NULL, NULL, NULL, 4),
(209113, NULL, 'G3DSA:2.130.10.10:FF:002984', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit TRM82', NULL, NULL, NULL, NULL, NULL, 4),
(209114, NULL, 'G3DSA:2.40.50.140:FF:001108', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209115, NULL, 'G3DSA:2.30.130.30:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209116, NULL, 'G3DSA:1.20.1070.10:FF:001774', NULL, NULL, 'Olfactory receptor 332', NULL, NULL, NULL, NULL, NULL, 4),
(209117, NULL, 'G3DSA:3.30.160.60:FF:000415', NULL, NULL, 'Zinc finger protein 827', NULL, NULL, NULL, NULL, NULL, 4),
(209118, NULL, 'G3DSA:1.10.10.10:FF:000401', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(209119, NULL, 'G3DSA:2.130.10.10:FF:005744', NULL, NULL, 'DNA damage-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(209120, NULL, 'G3DSA:2.160.20.10:FF:000084', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(209121, NULL, 'G3DSA:3.40.50.300:FF:008105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209122, NULL, 'G3DSA:3.90.132.10:FF:000013', NULL, NULL, 'Protein CBG03424', NULL, NULL, NULL, NULL, NULL, 4),
(209123, NULL, 'G3DSA:2.130.10.30:FF:000175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209124, NULL, 'G3DSA:1.20.970.50:FF:000001', NULL, NULL, 'AMP phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(209125, NULL, 'G3DSA:2.10.25.10:FF:000607', NULL, NULL, 'Protein delta 2', NULL, NULL, NULL, NULL, NULL, 4),
(209126, NULL, 'G3DSA:1.10.220.150:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209127, NULL, 'G3DSA:1.25.40.10:FF:001264', NULL, NULL, 'High chlorophyll fluorescent 107', NULL, NULL, NULL, NULL, NULL, 4),
(209128, NULL, 'G3DSA:3.30.70.270:FF:000334', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209129, NULL, 'G3DSA:3.30.70.260:FF:000106', NULL, NULL, 'Acetolactate synthase small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(209130, NULL, 'G3DSA:3.40.920.10:FF:000002', NULL, NULL, '2-oxoglutarate oxidoreductase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(209131, NULL, 'G3DSA:1.20.1070.10:FF:000470', NULL, NULL, 'ETHR, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(209132, NULL, 'G3DSA:3.40.50.720:FF:001424', NULL, NULL, 'PKS-NRPS hybrid synthetase psoA', NULL, NULL, NULL, NULL, NULL, 4),
(209133, NULL, 'G3DSA:2.130.10.10:FF:001473', NULL, NULL, 'Protein HIRA', NULL, NULL, NULL, NULL, NULL, 4),
(209134, NULL, 'G3DSA:2.30.42.10:FF:000168', NULL, NULL, 'FERM and PDZ domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(209135, NULL, 'G3DSA:3.30.200.210:FF:000004', NULL, NULL, 'NADH-quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(209136, NULL, 'G3DSA:3.40.50.2300:FF:000565', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209137, NULL, 'G3DSA:1.20.58.60:FF:000076', NULL, NULL, 'Plectin a', NULL, NULL, NULL, NULL, NULL, 4),
(209138, NULL, 'G3DSA:2.130.10.10:FF:004221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209139, NULL, 'G3DSA:3.30.160.60:FF:002776', NULL, NULL, 'Zinc finger protein 639', NULL, NULL, NULL, NULL, NULL, 4),
(209140, NULL, 'G3DSA:2.10.60.10:FF:000060', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(209141, NULL, 'G3DSA:3.10.100.10:FF:000418', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209142, NULL, 'G3DSA:3.60.60.10:FF:000015', NULL, NULL, 'Bile salt hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(209143, NULL, 'G3DSA:3.30.420.10:FF:000123', NULL, NULL, 'Poly(A)-specific ribonuclease PARN', NULL, NULL, NULL, NULL, NULL, 4),
(209144, NULL, 'G3DSA:3.40.50.200:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209145, NULL, 'G3DSA:3.40.50.2000:FF:000700', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(209146, NULL, 'G3DSA:1.10.287.70:FF:000455', NULL, NULL, 'ATP-sensitive inward rectifier potassium channel 12-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(209147, NULL, 'G3DSA:2.60.40.10:FF:003636', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209148, NULL, 'G3DSA:1.10.565.10:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209149, NULL, 'G3DSA:3.40.50.300:FF:001872', NULL, NULL, 'PAXNEB protein superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(209150, NULL, 'G3DSA:1.10.540.10:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209151, NULL, 'G3DSA:1.10.630.10:FF:000472', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209152, NULL, 'G3DSA:3.20.20.80:FF:000226', NULL, NULL, 'Unplaced genomic scaffold supercont1.19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(209153, NULL, 'G3DSA:2.120.10.80:FF:000010', NULL, NULL, 'kelch domain-containing protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(209154, NULL, 'G3DSA:2.170.230.10:FF:000001', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4),
(209155, NULL, 'G3DSA:1.10.287.70:FF:000348', NULL, NULL, 'Voltage-dependent T-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(209156, NULL, 'G3DSA:2.30.30.40:FF:000386', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(209157, NULL, 'G3DSA:3.10.260.20:FF:000005', NULL, NULL, 'Dachshund family transcription factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(209158, NULL, 'G3DSA:3.30.460.10:FF:000137', NULL, NULL, 'Uncharacterized protein L5213T.03', NULL, NULL, NULL, NULL, NULL, 4),
(209159, NULL, 'G3DSA:2.60.40.10:FF:000202', NULL, NULL, 'Sidekick cell adhesion molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(209160, NULL, 'G3DSA:2.10.220.10:FF:000223', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5a', NULL, NULL, NULL, NULL, NULL, 4),
(209161, NULL, 'G3DSA:2.10.25.10:FF:000596', NULL, NULL, 'Nimrod C2, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(209162, NULL, 'G3DSA:2.30.42.10:FF:000275', NULL, NULL, 'Inactivation-no-after-potential D protein', NULL, NULL, NULL, NULL, NULL, 4),
(209163, NULL, 'G3DSA:1.20.1270.60:FF:000112', NULL, NULL, 'YKR078W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(209164, NULL, 'G3DSA:3.60.20.40:FF:000016', NULL, NULL, 'Uncharacterized protein, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(209165, NULL, 'G3DSA:3.30.160.60:FF:001034', NULL, NULL, 'zinc finger protein with KRAB and SCAN domains 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(209166, NULL, 'G3DSA:2.30.30.40:FF:000279', NULL, NULL, 'Spectrin beta chain, non-erythrocytic', NULL, NULL, NULL, NULL, NULL, 4),
(209167, NULL, 'G3DSA:3.40.50.300:FF:006868', NULL, NULL, 'Sll5052 protein', NULL, NULL, NULL, NULL, NULL, 4),
(209168, NULL, 'G3DSA:3.10.129.110:FF:000016', NULL, NULL, 'Lovastatin nonaketide synthase, polyketide synthase component', NULL, NULL, NULL, NULL, NULL, 4),
(209169, NULL, 'G3DSA:2.60.40.150:FF:000110', NULL, NULL, 'Coiled-coil and C2 domain-containing protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(209170, NULL, 'G3DSA:2.30.42.10:FF:000399', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209171, NULL, 'G3DSA:1.20.120.230:FF:000029', NULL, NULL, 'Cas scaffold protein family member 4', NULL, NULL, NULL, NULL, NULL, 4),
(209172, NULL, 'G3DSA:3.30.200.20:FF:001217', NULL, NULL, 'Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(209173, NULL, 'G3DSA:3.30.590.20:FF:000003', NULL, NULL, 'Glutamate--cysteine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(209174, NULL, 'G3DSA:2.60.40.10:FF:002107', NULL, NULL, 'Si:ch211-193k19.1', NULL, NULL, NULL, NULL, NULL, 4),
(209175, NULL, 'G3DSA:3.40.50.1000:FF:000046', NULL, NULL, 'Phosphomannomutase', NULL, NULL, NULL, NULL, NULL, 4),
(209176, NULL, 'G3DSA:1.25.10.10:FF:000817', NULL, NULL, 'Importin_1', NULL, NULL, NULL, NULL, NULL, 4),
(209177, NULL, 'G3DSA:3.30.160.60:FF:005429', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209178, NULL, 'G3DSA:1.25.40.20:FF:001362', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209179, NULL, 'G3DSA:3.30.200.20:FF:000817', NULL, NULL, 'STE/STE20/YSK protein kinase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(209180, NULL, 'G3DSA:2.10.110.10:FF:000338', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209181, NULL, 'G3DSA:3.10.129.10:FF:000288', NULL, NULL, 'Methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(209182, NULL, 'G3DSA:3.40.50.300:FF:007268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209183, NULL, 'G3DSA:1.20.1250.10:FF:000017', NULL, NULL, 'Interleukin 11', NULL, NULL, NULL, NULL, NULL, 4),
(209184, NULL, 'G3DSA:2.60.120.650:FF:000027', NULL, NULL, 'Jumonji/arid domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(209185, NULL, 'G3DSA:4.10.400.10:FF:000353', NULL, NULL, 'Low density lipoprotein receptor', NULL, NULL, NULL, NULL, NULL, 4),
(209186, NULL, 'G3DSA:2.40.70.10:FF:000087', NULL, NULL, 'Gag-Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(209187, NULL, 'G3DSA:3.40.30.10:FF:001088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209188, NULL, 'G3DSA:3.30.160.60:FF:000522', NULL, NULL, 'zinc finger protein 285', NULL, NULL, NULL, NULL, NULL, 4),
(209189, NULL, 'G3DSA:1.10.8.1180:FF:000001', NULL, NULL, 'Primosomal protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(209190, NULL, 'G3DSA:1.25.40.20:FF:001486', NULL, NULL, 'Ankyrin repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(209191, NULL, 'G3DSA:3.90.226.10:FF:000012', NULL, NULL, 'Chromodomain Y-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(209192, NULL, 'G3DSA:3.30.200.20:FF:000705', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(209193, NULL, 'G3DSA:3.40.1380.10:FF:000015', NULL, NULL, 'F0F1 ATP synthase subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(209194, NULL, 'G3DSA:3.20.20.220:FF:000025', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(209195, NULL, 'G3DSA:3.40.190.10:FF:000327', NULL, NULL, 'ABC transporter, periplasmic substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(209196, NULL, 'G3DSA:1.20.1250.20:FF:000583', NULL, NULL, 'Tartrate transporter, variant', NULL, NULL, NULL, NULL, NULL, 4),
(209197, NULL, 'G3DSA:2.10.70.10:FF:000228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209198, NULL, 'G3DSA:1.10.510.10:FF:003739', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209199, NULL, 'G3DSA:3.40.50.300:FF:002597', NULL, NULL, 'GTPase Der', NULL, NULL, NULL, NULL, NULL, 4),
(209200, NULL, 'G3DSA:3.40.50.1380:FF:000019', NULL, NULL, 'Carbamyl phosphate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(209201, NULL, 'G3DSA:3.80.10.10:FF:003895', NULL, NULL, 'AGAP011649-PA', NULL, NULL, NULL, NULL, NULL, 4),
(209202, NULL, 'G3DSA:3.30.565.10:FF:000493', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209203, NULL, 'G3DSA:1.25.40.20:FF:000974', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209204, NULL, 'G3DSA:3.30.70.1230:FF:000067', NULL, NULL, 'Adenylate/guanylate cyclase catalytic domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(209205, NULL, 'G3DSA:3.90.1240.10:FF:000005', NULL, NULL, 'Botulinum neurotoxin type D', NULL, NULL, NULL, NULL, NULL, 4),
(209206, NULL, 'G3DSA:2.40.100.10:FF:000022', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase CYP95', NULL, NULL, NULL, NULL, NULL, 4),
(209207, NULL, 'G3DSA:3.40.367.20:FF:000050', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(209208, NULL, 'G3DSA:3.80.10.10:FF:004295', NULL, NULL, 'Rab family protein', NULL, NULL, NULL, NULL, NULL, 4),
(209209, NULL, 'G3DSA:2.130.10.10:FF:002198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209210, NULL, 'G3DSA:3.40.50.11310:FF:000002', NULL, NULL, 'Alkylphosphonate utilization protein PhnH', NULL, NULL, NULL, NULL, NULL, 4),
(209211, NULL, 'G3DSA:2.170.8.10:FF:000004', NULL, NULL, 'Phosphoenolpyruvate carboxykinase homolog2', NULL, NULL, NULL, NULL, NULL, 4),
(209212, NULL, 'G3DSA:2.130.10.10:FF:001579', NULL, NULL, 'Anaphase-promoting complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(209213, NULL, 'G3DSA:3.90.1170.20:FF:000002', NULL, NULL, 'Nicotinate-nucleotide pyrophosphorylase [carboxylating]', NULL, NULL, NULL, NULL, NULL, 4),
(209214, NULL, 'G3DSA:3.40.50.1360:FF:000013', NULL, NULL, 'Ribose 5-phosphate isomerase A', NULL, NULL, NULL, NULL, NULL, 4),
(209215, NULL, 'G3DSA:3.90.640.10:FF:000261', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(209216, NULL, 'G3DSA:1.10.600.10:FF:000065', NULL, NULL, 'Putative polyprenyl synthetase IdsB', NULL, NULL, NULL, NULL, NULL, 4),
(209217, NULL, 'G3DSA:3.40.50.300:FF:000236', NULL, NULL, 'Cell division control protein 42', NULL, NULL, NULL, NULL, NULL, 4),
(209218, NULL, 'G3DSA:3.30.70.100:FF:000093', NULL, NULL, 'Acylphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(209219, NULL, 'G3DSA:3.90.360.10:FF:000003', NULL, NULL, 'Histone acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209220, NULL, 'G3DSA:3.80.10.10:FF:001658', NULL, NULL, 'LOC523504 protein', NULL, NULL, NULL, NULL, NULL, 4),
(209221, NULL, 'G3DSA:1.10.472.80:FF:000068', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(209222, NULL, 'G3DSA:1.25.10.10:FF:001436', NULL, NULL, 'Ubiquitin fusion degradation protein 3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(209223, NULL, 'G3DSA:3.90.1170.40:FF:000008', NULL, NULL, 'Molybdopterin-converting factor chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(209224, NULL, 'G3DSA:3.30.70.270:FF:000222', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209225, NULL, 'G3DSA:1.20.920.20:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209226, NULL, 'G3DSA:1.25.40.10:FF:000752', NULL, NULL, 'Outer membrane protein assembly factor BamD', NULL, NULL, NULL, NULL, NULL, 4),
(209227, NULL, 'G3DSA:1.10.10.10:FF:000289', NULL, NULL, 'HTH-type transcriptional regulator YidZ', NULL, NULL, NULL, NULL, NULL, 4),
(209228, NULL, 'G3DSA:3.50.50.60:FF:000839', NULL, NULL, 'Squalene monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(209229, NULL, 'G3DSA:1.10.10.60:FF:000843', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209230, NULL, 'G3DSA:1.20.1560.10:FF:000805', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209231, NULL, 'G3DSA:1.10.1750.10:FF:000002', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(209232, NULL, 'G3DSA:1.20.58.1480:FF:000004', NULL, NULL, 'Cereblon, isoform CRA_c', NULL, NULL, NULL, NULL, NULL, 4),
(209233, NULL, 'G3DSA:3.40.630.10:FF:000463', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209234, NULL, 'G3DSA:2.40.10.340:FF:000002', NULL, NULL, 'Rod shape-determining protein MreC', NULL, NULL, NULL, NULL, NULL, 4),
(209235, NULL, 'G3DSA:3.90.380.10:FF:000016', NULL, NULL, 'Dibenzofuran dioxygenase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(209236, NULL, 'G3DSA:1.20.1250.20:FF:001190', NULL, NULL, 'Major facilitator superfamily MFS_1', NULL, NULL, NULL, NULL, NULL, 4),
(209237, NULL, 'G3DSA:3.30.160.60:FF:003395', NULL, NULL, 'RH47711p', NULL, NULL, NULL, NULL, NULL, 4),
(209238, NULL, 'G3DSA:3.30.70.330:FF:002286', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209239, NULL, 'G3DSA:2.60.40.10:FF:003855', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209240, NULL, 'G3DSA:3.40.50.2020:FF:000021', NULL, NULL, 'Adenine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(209241, NULL, 'G3DSA:1.10.510.10:FF:003178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209242, NULL, 'G3DSA:3.90.228.10:FF:000073', NULL, NULL, 'Poly [ADP-ribose] polymerase tankyrase', NULL, NULL, NULL, NULL, NULL, 4),
(209243, NULL, 'G3DSA:3.40.50.10140:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209244, NULL, 'G3DSA:3.30.160.60:FF:003271', NULL, NULL, 'PR domain-containing 2, with ZNF domain a', NULL, NULL, NULL, NULL, NULL, 4),
(209245, NULL, 'G3DSA:1.10.443.10:FF:000008', NULL, NULL, 'Site-specific recombinase, phage integrase family', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(209246, NULL, 'G3DSA:1.10.3080.10:FF:000046', NULL, NULL, 'Chloride channel protein ClC family', NULL, NULL, NULL, NULL, NULL, 4),
(209247, NULL, 'G3DSA:3.80.10.10:FF:004513', NULL, NULL, 'Os10g0155800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(209248, NULL, 'G3DSA:3.30.160.60:FF:005305', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209249, NULL, 'G3DSA:3.30.70.2190:FF:000001', NULL, NULL, 'D-2-hydroxyglutarate dehydrogenase mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(209250, NULL, 'G3DSA:2.10.220.10:FF:000004', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(209251, NULL, 'G3DSA:2.40.320.10:FF:000016', NULL, NULL, 'Adenylate cyclase CyaB', NULL, NULL, NULL, NULL, NULL, 4),
(209252, NULL, 'G3DSA:1.20.58.1120:FF:000037', NULL, NULL, 'GM10109', NULL, NULL, NULL, NULL, NULL, 4),
(209253, NULL, 'G3DSA:2.60.120.200:FF:000134', NULL, NULL, 'Slit 2', NULL, NULL, NULL, NULL, NULL, 4),
(209254, NULL, 'G3DSA:2.60.200.20:FF:000197', NULL, NULL, 'YALI0C09185p', NULL, NULL, NULL, NULL, NULL, 4),
(209255, NULL, 'G3DSA:2.40.290.10:FF:000018', NULL, NULL, 'Putative KU80 protein', NULL, NULL, NULL, NULL, NULL, 4),
(209256, NULL, 'G3DSA:3.60.40.10:FF:000020', NULL, NULL, 'Probable protein phosphatase 2C 42', NULL, NULL, NULL, NULL, NULL, 4),
(209257, NULL, 'G3DSA:1.25.40.10:FF:001027', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g44230', NULL, NULL, NULL, NULL, NULL, 4),
(209258, NULL, 'G3DSA:1.20.1070.10:FF:000138', NULL, NULL, 'histamine H3 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(209259, NULL, 'G3DSA:2.60.40.790:FF:000178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209260, NULL, 'G3DSA:1.10.287.70:FF:000567', NULL, NULL, 'Protein CBR-KVS-4', NULL, NULL, NULL, NULL, NULL, 4),
(209261, NULL, 'G3DSA:1.10.287.660:FF:000019', NULL, NULL, 'Vacuolar protein sorting-associated protein 37', NULL, NULL, NULL, NULL, NULL, 4),
(209262, NULL, 'G3DSA:1.20.1070.10:FF:001886', NULL, NULL, 'G-protein coupled receptor daf-37', NULL, NULL, NULL, NULL, NULL, 4),
(209263, NULL, 'G3DSA:1.20.1050.80:FF:000012', NULL, NULL, 'Ras and Rab interactor like', NULL, NULL, NULL, NULL, NULL, 4),
(209264, NULL, 'G3DSA:3.40.50.2060:FF:000004', NULL, NULL, 'vacuolar protein sorting-associated protein 33A isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(209265, NULL, 'G3DSA:1.20.1250.20:FF:001201', NULL, NULL, 'Transmembrane transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(209266, NULL, 'G3DSA:1.25.40.1050:FF:000005', NULL, NULL, 'Putative exoribonuclease 2', NULL, NULL, NULL, NULL, NULL, 4),
(209267, NULL, 'G3DSA:3.40.1180.10:FF:000034', NULL, NULL, 'Alkyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(209268, NULL, 'G3DSA:3.40.250.10:FF:000259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209269, NULL, 'G3DSA:3.40.50.150:FF:001006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209270, NULL, 'G3DSA:3.40.50.300:FF:005582', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209271, NULL, 'G3DSA:2.60.40.290:FF:000011', NULL, NULL, 'Putative secreted sugar hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(209272, NULL, 'G3DSA:3.90.1200.10:FF:000008', NULL, NULL, 'Methylthioribose kinase', NULL, NULL, NULL, NULL, NULL, 4),
(209273, NULL, 'G3DSA:1.10.472.10:FF:000087', NULL, NULL, 'Putative Cyclin dependent kinase binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(209274, NULL, 'G3DSA:3.30.200.90:FF:000001', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(209275, NULL, 'G3DSA:2.130.10.10:FF:005525', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209276, NULL, 'G3DSA:3.40.50.300:FF:006200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209277, NULL, 'G3DSA:1.25.40.10:FF:004804', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(209278, NULL, 'G3DSA:3.20.20.100:FF:000006', NULL, NULL, 'Aldo-keto reductase family 1 member A1', NULL, NULL, NULL, NULL, NULL, 4),
(209279, NULL, 'G3DSA:1.20.5.1160:FF:000032', NULL, NULL, 'KRT17 isoform 5', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(209280, NULL, 'G3DSA:1.25.40.970:FF:000001', NULL, NULL, 'Histone-lysine N-methyltransferase SMYD1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(209281, NULL, 'G3DSA:3.30.70.340:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209282, NULL, 'G3DSA:1.20.5.100:FF:000019', NULL, NULL, 'Tail spike protein', NULL, NULL, NULL, NULL, NULL, 4),
(209283, NULL, 'G3DSA:3.10.180.10:FF:000069', NULL, NULL, 'Glyoxalase', NULL, NULL, NULL, NULL, NULL, 4),
(209284, NULL, 'G3DSA:3.30.420.10:FF:000247', NULL, NULL, 'Si:ch1073-296i8.2', NULL, NULL, NULL, NULL, NULL, 4),
(209285, NULL, 'G3DSA:1.10.1420.10:FF:000123', NULL, NULL, 'Putative MSH5 protein', NULL, NULL, NULL, NULL, NULL, 4),
(209286, NULL, 'G3DSA:1.10.437.10:FF:000062', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(209287, NULL, 'G3DSA:3.40.50.300:FF:001293', NULL, NULL, 'helicase POLQ-like isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(209288, NULL, 'G3DSA:3.60.20.10:FF:000018', NULL, NULL, 'Proteasome subunit alpha type', NULL, NULL, NULL, NULL, NULL, 4),
(209289, NULL, 'G3DSA:1.10.275.30:FF:000011', NULL, NULL, 'Rad3-related DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(209290, NULL, 'G3DSA:2.60.40.3110:FF:000001', NULL, NULL, 'Putative fimbrial outer membrane usher', NULL, NULL, NULL, NULL, NULL, 4),
(209291, NULL, 'G3DSA:3.40.350.10:FF:000082', NULL, NULL, 'Prolidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(209292, NULL, 'G3DSA:3.40.50.1240:FF:000101', NULL, NULL, '6-phosphofructo-2-kinase/fructose-2, 6-biphosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209293, NULL, 'G3DSA:2.120.10.30:FF:000585', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209294, NULL, 'G3DSA:1.25.10.10:FF:000020', NULL, NULL, 'AP-2 complex subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(209295, NULL, 'G3DSA:3.30.60.30:FF:000152', NULL, NULL, 'Kazal type serine protease inhibitor 4', NULL, NULL, NULL, NULL, NULL, 4),
(209296, NULL, 'G3DSA:3.40.640.10:FF:000525', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209297, NULL, 'G3DSA:3.30.160.60:FF:003613', NULL, NULL, 'DNA-binding protein creA, variant', NULL, NULL, NULL, NULL, NULL, 4),
(209298, NULL, 'G3DSA:2.60.120.10:FF:000030', NULL, NULL, 'Mannose-6-phosphate isomerase ManA', NULL, NULL, NULL, NULL, NULL, 4),
(209299, NULL, 'G3DSA:3.40.50.80:FF:000227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209300, NULL, 'G3DSA:3.30.40.10:FF:000723', NULL, NULL, 'RING-H2 finger protein ATL46', NULL, NULL, NULL, NULL, NULL, 4),
(209301, NULL, 'G3DSA:1.20.1250.20:FF:000240', NULL, NULL, 'Transporter, major facilitator family', NULL, NULL, NULL, NULL, NULL, 4),
(209302, NULL, 'G3DSA:1.20.1280.50:FF:000172', NULL, NULL, 'Fbox domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(209303, NULL, 'G3DSA:1.10.3860.10:FF:000016', NULL, NULL, 'Proton glutamate symport protein', NULL, NULL, NULL, NULL, NULL, 4),
(209304, NULL, 'G3DSA:1.20.1560.10:FF:000569', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(209305, NULL, 'G3DSA:1.10.357.20:FF:000007', NULL, NULL, 'Magnesium transporter MgtE', NULL, NULL, NULL, NULL, NULL, 4),
(209306, NULL, 'G3DSA:3.30.160.60:FF:001719', NULL, NULL, 'C2H2 type zinc finger domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(209307, NULL, 'G3DSA:3.80.10.10:FF:003114', NULL, NULL, 'Dynein axonemal light chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(209308, NULL, 'G3DSA:3.80.10.10:FF:000708', NULL, NULL, 'Internalin A', NULL, NULL, NULL, NULL, NULL, 4),
(209309, NULL, 'G3DSA:1.50.10.10:FF:000063', NULL, NULL, 'Endoglucanase', NULL, NULL, NULL, NULL, NULL, 4),
(209310, NULL, 'G3DSA:3.30.450.20:FF:000173', NULL, NULL, 'Putative LOV domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(209311, NULL, 'G3DSA:1.20.120.1380:FF:000004', NULL, NULL, 'Flagellar biosynthesis regulator FlhF', NULL, NULL, NULL, NULL, NULL, 4),
(209312, NULL, 'G3DSA:1.20.1250.50:FF:000001', NULL, NULL, 'Interleukin-7', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(209313, NULL, 'G3DSA:3.30.200.20:FF:000694', NULL, NULL, 'Eukaryotic initiation factor 2alpha kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(209314, NULL, 'G3DSA:1.25.50.20:FF:000019', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(209315, NULL, 'G3DSA:1.10.510.10:FF:001598', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(209316, NULL, 'G3DSA:3.30.160.60:FF:001472', NULL, NULL, 'Zinc finger protein 324', NULL, NULL, NULL, NULL, NULL, 4),
(209317, NULL, 'G3DSA:4.10.240.10:FF:000144', NULL, NULL, 'Arg83p', NULL, NULL, NULL, NULL, NULL, 4),
(209318, NULL, 'G3DSA:3.30.420.40:FF:000008', NULL, NULL, 'Glycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(209319, NULL, 'G3DSA:3.30.1240.10:FF:000024', NULL, NULL, 'Haloacid dehalogenase-like hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(209320, NULL, 'G3DSA:3.40.50.1820:FF:000303', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(209321, NULL, 'G3DSA:1.20.1270.340:FF:000001', NULL, NULL, 'Primosomal replication protein N', NULL, NULL, NULL, NULL, NULL, 4),
(209322, NULL, 'G3DSA:3.20.20.80:FF:000120', NULL, NULL, 'Alpha-amylase A', NULL, NULL, NULL, NULL, NULL, 4),
(209323, NULL, 'G3DSA:3.30.1370.10:FF:000028', NULL, NULL, 'protein quaking isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(209324, NULL, 'G3DSA:1.10.940.10:FF:000006', NULL, NULL, '16S rRNA (Cytosine(967)-C(5))-methyltransferase RsmB', NULL, NULL, NULL, NULL, NULL, 4),
(209325, NULL, 'G3DSA:2.10.10.20:FF:000003', NULL, NULL, 'Chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209326, NULL, 'G3DSA:3.40.50.1580:FF:000074', NULL, NULL, 'Inosine guanosine and xanthosine phosphorylase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(209327, NULL, 'G3DSA:1.25.10.10:FF:003330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209328, NULL, 'G3DSA:3.60.40.10:FF:000363', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209329, NULL, 'G3DSA:3.40.50.720:FF:002386', NULL, NULL, 'Enoyl-[acyl-carrier-protein] reductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(209330, NULL, 'G3DSA:2.10.110.10:FF:000119', NULL, NULL, 'LIM domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(209331, NULL, 'G3DSA:3.10.20.90:FF:000988', NULL, NULL, 'Autophagy protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(209332, NULL, 'G3DSA:1.20.1270.50:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209333, NULL, 'G3DSA:3.40.50.300:FF:002254', NULL, NULL, 'Quinate pathway repressor protein QutR', NULL, NULL, NULL, NULL, NULL, 4),
(209334, NULL, 'G3DSA:3.40.50.410:FF:000033', NULL, NULL, '60 kDa SS-A/Ro ribonucleoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(209335, NULL, 'G3DSA:3.40.50.150:FF:001349', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209336, NULL, 'G3DSA:1.10.555.10:FF:000167', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209337, NULL, 'G3DSA:1.25.40.90:FF:000051', NULL, NULL, 'Ent4p', NULL, NULL, NULL, NULL, NULL, 4),
(209338, NULL, 'G3DSA:3.20.20.70:FF:000347', NULL, NULL, 'GTP 3'',8-cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(209339, NULL, 'G3DSA:3.90.640.90:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209340, NULL, 'G3DSA:1.20.1560.10:FF:000226', NULL, NULL, 'Probable ATP-binding/permease fusion ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(209341, NULL, 'G3DSA:1.10.1070.11:FF:000086', NULL, NULL, 'Smilar to phosphatidylinositol 3-or 4-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(209342, NULL, 'G3DSA:3.40.50.10090:FF:000029', NULL, NULL, 'Uroporphyrinogen-III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(209343, NULL, 'G3DSA:1.10.8.60:FF:000078', NULL, NULL, '26S protease regulatory subunit 6B homolog', NULL, NULL, NULL, NULL, NULL, 4),
(209344, NULL, 'G3DSA:1.10.8.270:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209345, NULL, 'G3DSA:1.10.418.10:FF:000265', NULL, NULL, 'Transgelin', NULL, NULL, NULL, NULL, NULL, 4),
(209346, NULL, 'G3DSA:3.40.1050.10:FF:000030', NULL, NULL, 'Putative integral membrane transport protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(209347, NULL, 'G3DSA:1.20.990.10:FF:000001', NULL, NULL, 'NADPH--cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(209348, NULL, 'G3DSA:3.40.50.10380:FF:000015', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(209349, NULL, 'G3DSA:3.20.20.80:FF:000805', NULL, NULL, 'Alpha-L-iduronidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209350, NULL, 'G3DSA:1.20.1720.10:FF:000104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209351, NULL, 'G3DSA:3.30.420.40:FF:000683', NULL, NULL, 'Os07g0409200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(209352, NULL, 'G3DSA:3.40.50.1000:FF:000844', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209353, NULL, 'G3DSA:3.30.60.90:FF:000035', NULL, NULL, 'Putative N6-adenosine-methyltransferase with ZZ-type zinc-binding domains', NULL, NULL, NULL, NULL, NULL, 4),
(209354, NULL, 'G3DSA:2.40.128.20:FF:000033', NULL, NULL, 'PAEP isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(209355, NULL, 'G3DSA:3.50.50.60:FF:000592', NULL, NULL, '2,4-dienoyl-coa reductase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(209356, NULL, 'G3DSA:2.40.270.10:FF:000023', NULL, NULL, 'DNA-directed RNA polymerase III subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(209357, NULL, 'G3DSA:3.30.200.20:FF:001655', NULL, NULL, 'Dual specificity protein kinase splB', NULL, NULL, NULL, NULL, NULL, 4),
(209358, NULL, 'G3DSA:3.40.50.300:FF:007723', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209359, NULL, 'G3DSA:2.60.40.420:FF:000207', NULL, NULL, 'Cytochrome c oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(209360, NULL, 'G3DSA:3.30.310.40:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209361, NULL, 'G3DSA:1.25.40.10:FF:002663', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209362, NULL, 'G3DSA:3.40.140.10:FF:000268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209363, NULL, 'G3DSA:2.30.29.30:FF:001262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209364, NULL, 'G3DSA:1.20.1530.20:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209365, NULL, 'G3DSA:3.40.50.300:FF:004289', NULL, NULL, 'RAS like estrogen regulated growth inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(209366, NULL, 'G3DSA:3.40.50.150:FF:000045', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase F', NULL, NULL, NULL, NULL, NULL, 4),
(209367, NULL, 'G3DSA:1.10.510.10:FF:002559', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(209368, NULL, 'G3DSA:3.20.20.140:FF:000102', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(209369, NULL, 'G3DSA:2.60.40.10:FF:005873', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209370, NULL, 'G3DSA:1.25.40.180:FF:000303', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209371, NULL, 'G3DSA:1.20.120.810:FF:000001', NULL, NULL, 'Vinculin a', NULL, NULL, NULL, NULL, NULL, 4),
(209372, NULL, 'G3DSA:3.30.470.20:FF:000186', NULL, NULL, 'Carbamoyl phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(209373, NULL, 'G3DSA:3.40.720.10:FF:000127', NULL, NULL, 'N-acetylgalactosamine-6-sulfatase (GALNS)', NULL, NULL, NULL, NULL, NULL, 4),
(209374, NULL, 'G3DSA:3.40.50.300:FF:000579', NULL, NULL, 'GPN-loop GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(209375, NULL, 'G3DSA:1.20.1740.10:FF:000212', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(209376, NULL, 'G3DSA:3.90.190.10:FF:000063', NULL, NULL, 'Dual specificity phosphatase 23', NULL, NULL, NULL, NULL, NULL, 4),
(209377, NULL, 'G3DSA:2.60.120.10:FF:000715', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(209378, NULL, 'G3DSA:3.40.630.30:FF:000002', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(209379, NULL, 'G3DSA:3.40.630.30:FF:000126', NULL, NULL, 'Histone acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209380, NULL, 'G3DSA:3.40.50.2000:FF:000357', NULL, NULL, 'Lipopolysaccharide biosynthesis protein RfbV', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(209381, NULL, 'G3DSA:1.20.120.520:FF:000015', NULL, NULL, 'Uncharacterized hemerythrin-like protein C869.06c', NULL, NULL, NULL, NULL, NULL, 4),
(209382, NULL, 'G3DSA:1.10.3730.10:FF:000012', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(209383, NULL, 'G3DSA:1.25.10.10:FF:003111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209384, NULL, 'G3DSA:1.10.510.10:FF:001255', NULL, NULL, 'Glycogen synthase kinase-3 homolog YGK3', NULL, NULL, NULL, NULL, NULL, 4),
(209385, NULL, 'G3DSA:3.20.20.70:FF:000004', NULL, NULL, 'Ribulose-phosphate 3-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(209386, NULL, 'G3DSA:3.40.50.720:FF:001767', NULL, NULL, 'Agroclavine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(209387, NULL, 'G3DSA:3.20.20.70:FF:000128', NULL, NULL, 'Phospho-2-dehydro-3-deoxyheptonate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(209388, NULL, 'G3DSA:1.25.10.10:FF:002493', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209389, NULL, 'G3DSA:2.60.120.10:FF:000373', NULL, NULL, 'MerR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(209390, NULL, 'G3DSA:3.80.10.10:FF:002277', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(209391, NULL, 'G3DSA:1.25.40.70:FF:000056', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', NULL, NULL, NULL, NULL, NULL, 4),
(209392, NULL, 'G3DSA:1.10.472.100:FF:000004', NULL, NULL, 'Presenilin spe-4', NULL, NULL, NULL, NULL, NULL, 4),
(209393, NULL, 'G3DSA:1.20.1070.10:FF:000717', NULL, NULL, 'Dopamine receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(209394, NULL, 'G3DSA:3.80.10.10:FF:001877', NULL, NULL, 'TOLl (Drosophila) family', NULL, NULL, NULL, NULL, NULL, 4),
(209395, NULL, 'G3DSA:3.30.40.10:FF:000162', NULL, NULL, 'E3 ubiquitin-protein ligase SHPRH isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(209396, NULL, 'G3DSA:1.20.1250.20:FF:002038', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(209397, NULL, 'G3DSA:1.20.1280.290:FF:000016', NULL, NULL, 'Cystinosin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(209398, NULL, 'G3DSA:2.30.29.30:FF:000424', NULL, NULL, 'Phospholipase DDHD1', NULL, NULL, NULL, NULL, NULL, 4),
(209399, NULL, 'G3DSA:3.30.430.20:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209400, NULL, 'G3DSA:3.40.50.720:FF:002043', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(209401, NULL, 'G3DSA:1.20.140.10:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209402, NULL, 'G3DSA:1.20.970.10:FF:000017', NULL, NULL, 'Anthranilate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(209403, NULL, 'G3DSA:3.40.50.410:FF:000376', NULL, NULL, 'Voltage-dependent calcium channel subunit alpha-2/delta-4-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(209404, NULL, 'G3DSA:2.120.10.30:FF:000366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209405, NULL, 'G3DSA:1.20.81.30:FF:000003', NULL, NULL, 'Toxin co-regulated pilus biosynthesis protein E', NULL, NULL, NULL, NULL, NULL, 4),
(209406, NULL, 'G3DSA:3.40.1110.10:FF:000428', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209407, NULL, 'G3DSA:1.25.40.10:FF:003500', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209408, NULL, 'G3DSA:3.40.50.1460:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209409, NULL, 'G3DSA:3.30.160.60:FF:005182', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209410, NULL, 'G3DSA:3.40.50.410:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209411, NULL, 'G3DSA:1.25.40.10:FF:003843', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209412, NULL, 'G3DSA:2.60.40.10:FF:001725', NULL, NULL, 'Exo-beta-D-glucosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(209413, NULL, 'G3DSA:2.30.29.30:FF:000548', NULL, NULL, 'GD13075', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(209414, NULL, 'G3DSA:1.10.8.10:FF:000092', NULL, NULL, 'Putative E3 ubiquitin-protein ligase UPL1-like', NULL, NULL, NULL, NULL, NULL, 4),
(209415, NULL, 'G3DSA:1.10.630.10:FF:000016', NULL, NULL, 'Cytochrome P450 78A5', NULL, NULL, NULL, NULL, NULL, 4),
(209416, NULL, 'G3DSA:3.30.420.10:FF:000702', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209417, NULL, 'G3DSA:2.10.25.10:FF:001557', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(209418, NULL, 'G3DSA:3.40.720.10:FF:000003', NULL, NULL, 'Extracellular sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(209419, NULL, 'G3DSA:1.20.58.1880:FF:000017', NULL, NULL, 'RCOR (REST CO-Repressor) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(209420, NULL, 'G3DSA:2.40.50.730:FF:000009', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(209421, NULL, 'G3DSA:3.40.50.1100:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209422, NULL, 'G3DSA:3.30.1370.10:FF:000247', NULL, NULL, 'EG:EG0003.2 protein (Fbgn0014870;psi protein)', NULL, NULL, NULL, NULL, NULL, 4),
(209423, NULL, 'G3DSA:3.90.1410.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209424, NULL, 'G3DSA:1.10.10.10:FF:001705', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(209425, NULL, 'G3DSA:1.25.10.10:FF:002835', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209426, NULL, 'G3DSA:1.10.357.50:FF:000005', NULL, NULL, 'protein unc-13 homolog D', NULL, NULL, NULL, NULL, NULL, 4),
(209427, NULL, 'G3DSA:3.30.160.60:FF:002091', NULL, NULL, 'Zinc finger protein, FOG family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(209428, NULL, 'G3DSA:3.40.50.300:FF:001416', NULL, NULL, 'Tudor domain containing 12', NULL, NULL, NULL, NULL, NULL, 4),
(209429, NULL, 'G3DSA:1.25.40.180:FF:000180', NULL, NULL, 'YALI0E24629p', NULL, NULL, NULL, NULL, NULL, 4),
(209430, NULL, 'G3DSA:3.40.30.10:FF:000812', NULL, NULL, 'Slr0236 protein', NULL, NULL, NULL, NULL, NULL, 4),
(209431, NULL, 'G3DSA:1.25.10.10:FF:001874', NULL, NULL, 'Cullin-associated NEDD8-dissociated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(209432, NULL, 'G3DSA:2.60.120.970:FF:000117', NULL, NULL, 'Myostatin', NULL, NULL, NULL, NULL, NULL, 4),
(209433, NULL, 'G3DSA:2.70.70.10:FF:000052', NULL, NULL, 'Peptidase M23B', NULL, NULL, NULL, NULL, NULL, 4),
(209434, NULL, 'G3DSA:1.10.510.10:FF:002891', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209435, NULL, 'G3DSA:1.10.287.470:FF:000064', NULL, NULL, 'Sodium:proton antiporter', NULL, NULL, NULL, NULL, NULL, 4),
(209436, NULL, 'G3DSA:3.40.50.1010:FF:000162', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209437, NULL, 'G3DSA:1.20.1250.20:FF:002370', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209438, NULL, 'G3DSA:3.40.850.10:FF:000007', NULL, NULL, 'Myosin VIIA', NULL, NULL, NULL, NULL, NULL, 4),
(209439, NULL, 'G3DSA:2.60.120.10:FF:000154', NULL, NULL, 'cGMP-dependent protein kinase 1-4', NULL, NULL, NULL, NULL, NULL, 4),
(209440, NULL, 'G3DSA:2.60.120.260:FF:000236', NULL, NULL, 'Glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(209441, NULL, 'G3DSA:3.20.20.70:FF:000460', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209442, NULL, 'G3DSA:1.50.40.10:FF:000233', NULL, NULL, 'Mitochondrial carrier', NULL, NULL, NULL, NULL, NULL, 4),
(209443, NULL, 'G3DSA:2.30.30.940:FF:000008', NULL, NULL, 'Exodeoxyribonuclease V, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(209444, NULL, 'G3DSA:3.30.420.40:FF:000806', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209445, NULL, 'G3DSA:3.30.70.330:FF:001117', NULL, NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(209446, NULL, 'G3DSA:1.25.10.10:FF:002150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209447, NULL, 'G3DSA:2.60.40.1180:FF:000034', NULL, NULL, 'Alpha-xylosidase', NULL, NULL, NULL, NULL, NULL, 4),
(209448, NULL, 'G3DSA:3.20.20.190:FF:000089', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(209449, NULL, 'G3DSA:3.20.10.10:FF:000076', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(209450, NULL, 'G3DSA:3.80.10.10:FF:002838', NULL, NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At1g29720', NULL, NULL, NULL, NULL, NULL, 4),
(209451, NULL, 'G3DSA:2.60.120.920:FF:000131', NULL, NULL, 'Neuralized-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(209452, NULL, 'G3DSA:3.30.200.20:FF:001998', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209453, NULL, 'G3DSA:3.30.70.330:FF:000717', NULL, NULL, 'regulator of nonsense transcripts 3B', NULL, NULL, NULL, NULL, NULL, 4),
(209454, NULL, 'G3DSA:3.30.450.40:FF:000179', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(209455, NULL, 'G3DSA:1.25.40.10:FF:003282', NULL, NULL, 'Pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(209456, NULL, 'G3DSA:2.60.40.10:FF:005530', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209457, NULL, 'G3DSA:3.30.830.10:FF:000278', NULL, NULL, 'Metalloprotease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209458, NULL, 'G3DSA:2.30.42.10:FF:000511', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209459, NULL, 'G3DSA:3.30.160.60:FF:006143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209460, NULL, 'G3DSA:1.10.8.480:FF:000012', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(209461, NULL, 'G3DSA:1.10.275.20:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209462, NULL, 'G3DSA:1.20.5.170:FF:000001', NULL, NULL, 'Tropomyosin alpha-1 chain isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(209463, NULL, 'G3DSA:1.10.150.670:FF:000017', NULL, NULL, 'Crossover junction endonuclease MUS81', NULL, NULL, NULL, NULL, NULL, 4),
(209464, NULL, 'G3DSA:3.40.30.10:FF:000251', NULL, NULL, 'TXNL4A isoform 6', NULL, NULL, NULL, NULL, NULL, 4),
(209465, NULL, 'G3DSA:1.10.10.10:FF:000744', NULL, NULL, 'HTH-type transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(209466, NULL, 'G3DSA:3.40.50.1000:FF:000501', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209467, NULL, 'G3DSA:1.10.630.10:FF:000691', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209468, NULL, 'G3DSA:3.30.200.20:FF:002274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209469, NULL, 'G3DSA:3.40.1360.10:FF:000020', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(209470, NULL, 'G3DSA:1.25.40.10:FF:002882', NULL, NULL, 'Chs6p', NULL, NULL, NULL, NULL, NULL, 4),
(209471, NULL, 'G3DSA:3.60.21.10:FF:000111', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(209472, NULL, 'G3DSA:3.30.9.10:FF:000213', NULL, NULL, '3-hydroxybenzoate 4-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(209473, NULL, 'G3DSA:1.20.58.60:FF:000312', NULL, NULL, 'Microtubule-actin crosslinking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(209474, NULL, 'G3DSA:1.20.1630.10:FF:000002', NULL, NULL, 'Tetrathionate reductase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(209475, NULL, 'G3DSA:1.10.472.10:FF:000429', NULL, NULL, 'Cyclin domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(209476, NULL, 'G3DSA:3.40.50.150:FF:001681', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209477, NULL, 'G3DSA:3.40.50.1010:FF:000083', NULL, NULL, 'Ribonuclease VapC', NULL, NULL, NULL, NULL, NULL, 4),
(209478, NULL, 'G3DSA:1.20.1720.10:FF:000071', NULL, NULL, 'Membrane transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(209479, NULL, 'G3DSA:1.20.1250.10:FF:000107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209480, NULL, 'G3DSA:1.10.10.10:FF:001256', NULL, NULL, 'la-related protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(209481, NULL, 'G3DSA:2.60.120.200:FF:000432', NULL, NULL, 'Glycosidase', NULL, NULL, NULL, NULL, NULL, 4),
(209482, NULL, 'G3DSA:2.60.40.10:FF:005912', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(209483, NULL, 'G3DSA:3.40.50.300:FF:005750', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209484, NULL, 'G3DSA:3.30.160.880:FF:000003', NULL, NULL, 'Cell division protein ZapA', NULL, NULL, NULL, NULL, NULL, 4),
(209485, NULL, 'G3DSA:1.25.40.10:FF:001443', NULL, NULL, 'Sel1 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(209486, NULL, 'G3DSA:3.40.50.620:FF:000905', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(209487, NULL, 'G3DSA:2.60.120.260:FF:000343', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(209488, NULL, 'G3DSA:1.20.1740.10:FF:000128', NULL, NULL, 'Proline-specific permease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209489, NULL, 'G3DSA:3.40.33.10:FF:000015', NULL, NULL, 'Golgi-associated plant pathogenesis-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(209490, NULL, 'G3DSA:3.30.160.60:FF:001646', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209491, NULL, 'G3DSA:1.10.10.60:FF:001164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209492, NULL, 'G3DSA:3.30.40.10:FF:000853', NULL, NULL, 'PHD finger family protein', NULL, NULL, NULL, NULL, NULL, 4),
(209493, NULL, 'G3DSA:3.40.50.2300:FF:001526', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209494, NULL, 'G3DSA:3.90.190.10:FF:000327', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase R', NULL, NULL, NULL, NULL, NULL, 4),
(209495, NULL, 'G3DSA:3.20.20.70:FF:000050', NULL, NULL, 'Pyruvate formate-lyase-activating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(209496, NULL, 'G3DSA:3.40.1490.10:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209497, NULL, 'G3DSA:4.10.240.10:FF:000115', NULL, NULL, 'C6 transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209498, NULL, 'G3DSA:3.40.50.300:FF:000899', NULL, NULL, 'Bifunctional coenzyme A synthase', NULL, NULL, NULL, NULL, NULL, 4),
(209499, NULL, 'G3DSA:1.10.520.10:FF:000036', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(209500, NULL, 'G3DSA:3.40.850.10:FF:000114', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(209501, NULL, 'G3DSA:1.25.40.10:FF:002545', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(209502, NULL, 'G3DSA:3.40.50.300:FF:007841', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209503, NULL, 'G3DSA:1.25.40.10:FF:003534', NULL, NULL, 'Uncharacterized RNA-binding protein C1861.04c', NULL, NULL, NULL, NULL, NULL, 4),
(209504, NULL, 'G3DSA:3.40.50.1820:FF:000792', NULL, NULL, 'Protein EDS1', NULL, NULL, NULL, NULL, NULL, 4),
(209505, NULL, 'G3DSA:3.30.900.10:FF:000019', NULL, NULL, 'Predicted HORMA domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(209506, NULL, 'G3DSA:3.10.129.10:FF:000254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209507, NULL, 'G3DSA:3.80.10.10:FF:000591', NULL, NULL, 'Leucine-rich repeat receptor protein kinase MSP1', NULL, NULL, NULL, NULL, NULL, 4),
(209508, NULL, 'G3DSA:2.10.25.10:FF:000309', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(209509, NULL, 'G3DSA:3.40.1110.10:FF:000215', NULL, NULL, 'Copper-exporting P-type ATPase A', NULL, NULL, NULL, NULL, NULL, 4),
(209510, NULL, 'G3DSA:3.30.70.270:FF:000256', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209511, NULL, 'G3DSA:3.80.10.10:FF:002243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209512, NULL, 'G3DSA:1.10.3500.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209513, NULL, 'G3DSA:3.80.10.10:FF:004334', NULL, NULL, 'Roco6, ROCO family protein', NULL, NULL, NULL, NULL, NULL, 4),
(209514, NULL, 'G3DSA:3.90.850.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209515, NULL, 'G3DSA:3.60.40.10:FF:000110', NULL, NULL, 'Integrin-linked kinase-associated serine/threonine phosphatase 2C', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(209516, NULL, 'G3DSA:1.10.8.10:FF:000108', NULL, NULL, 'Ubiquitin domain-containing protein DSK2', NULL, NULL, NULL, NULL, NULL, 4),
(209517, NULL, 'G3DSA:2.20.110.10:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209518, NULL, 'G3DSA:3.40.50.720:FF:001132', NULL, NULL, 'NADH oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(209519, NULL, 'G3DSA:3.40.50.720:FF:002560', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209520, NULL, 'G3DSA:3.90.70.10:FF:000779', NULL, NULL, 'Ubiquitin-specific peptidase 20', NULL, NULL, NULL, NULL, NULL, 4),
(209521, NULL, 'G3DSA:2.60.120.290:FF:000239', NULL, NULL, 'Platelet-derived growth factor C', NULL, NULL, NULL, NULL, NULL, 4),
(209522, NULL, 'G3DSA:3.40.50.720:FF:002234', NULL, NULL, 'Glyoxylate/hydroxypyruvate reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209523, NULL, 'G3DSA:2.130.10.10:FF:001175', NULL, NULL, 'Protein HIRA', NULL, NULL, NULL, NULL, NULL, 4),
(209524, NULL, 'G3DSA:1.20.900.10:FF:000030', NULL, NULL, 'rho guanine nucleotide exchange factor 39', NULL, NULL, NULL, NULL, NULL, 4),
(209525, NULL, 'G3DSA:3.60.90.10:FF:000028', NULL, NULL, '[Pyruvate dehydrogenase (Acetyl-transferring)] kinase mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(209526, NULL, 'G3DSA:4.10.280.10:FF:000180', NULL, NULL, 'Transcription factor BPE', NULL, NULL, NULL, NULL, NULL, 4),
(209527, NULL, 'G3DSA:2.20.25.100:FF:000002', NULL, NULL, '30S ribosomal protein S27e', NULL, NULL, NULL, NULL, NULL, 4),
(209528, NULL, 'G3DSA:3.40.50.1820:FF:000466', NULL, NULL, 'Tributyrin esterase', NULL, NULL, NULL, NULL, NULL, 4),
(209529, NULL, 'G3DSA:3.50.30.30:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209530, NULL, 'G3DSA:3.30.710.10:FF:000275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209531, NULL, 'G3DSA:1.25.40.20:FF:000311', NULL, NULL, 'Calmodulin-binding transcription activator 2', NULL, NULL, NULL, NULL, NULL, 4),
(209532, NULL, 'G3DSA:1.10.10.10:FF:001935', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209533, NULL, 'G3DSA:3.30.460.20:FF:000005', NULL, NULL, 'CorA Metal Ion Transporter (MIT) Family', NULL, NULL, NULL, NULL, NULL, 4),
(209534, NULL, 'G3DSA:3.80.10.10:FF:003232', NULL, NULL, 'CD180 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(209535, NULL, 'G3DSA:2.130.10.30:FF:000079', NULL, NULL, 'Guanidine nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(209536, NULL, 'G3DSA:2.60.40.10:FF:003142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209537, NULL, 'G3DSA:3.30.30.170:FF:000004', NULL, NULL, 'Eukaryotic translation initiation factor eif-5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209538, NULL, 'G3DSA:1.25.40.20:FF:001772', NULL, NULL, 'C2 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(209539, NULL, 'G3DSA:3.40.50.1110:FF:000141', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(209540, NULL, 'G3DSA:1.20.1070.10:FF:000335', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(209541, NULL, 'G3DSA:1.20.58.390:FF:000162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209542, NULL, 'G3DSA:3.40.50.2300:FF:000863', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209543, NULL, 'G3DSA:2.60.40.10:FF:003821', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209544, NULL, 'G3DSA:3.90.1600.10:FF:000067', NULL, NULL, 'DNA-directed DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(209545, NULL, 'G3DSA:1.25.40.10:FF:004669', NULL, NULL, 'Os06g0597500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(209546, NULL, 'G3DSA:2.20.100.10:FF:000072', NULL, NULL, 'SCO-spondin', NULL, NULL, NULL, NULL, NULL, 4),
(209547, NULL, 'G3DSA:3.90.25.10:FF:000091', NULL, NULL, 'GDP-L-fucose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(209548, NULL, 'G3DSA:1.10.510.10:FF:003144', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209549, NULL, 'G3DSA:3.10.20.90:FF:000084', NULL, NULL, 'nuclear protein localization protein 4 homolog', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(209550, NULL, 'G3DSA:1.10.630.10:FF:000511', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209551, NULL, 'G3DSA:1.20.58.1420:FF:000003', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(209552, NULL, 'G3DSA:1.20.1250.20:FF:000436', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209553, NULL, 'G3DSA:3.30.460.10:FF:000002', NULL, NULL, 'Poly(A) polymerase alpha, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209554, NULL, 'G3DSA:3.30.50.10:FF:000179', NULL, NULL, 'Os05g0155400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(209555, NULL, 'G3DSA:3.40.30.10:FF:001083', NULL, NULL, 'NAD-reducing hydrogenase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(209556, NULL, 'G3DSA:1.50.10.10:FF:000181', NULL, NULL, 'LanC lantibiotic synthetase component C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(209557, NULL, 'G3DSA:3.30.420.40:FF:000896', NULL, NULL, 'Putative Hsp70 family ATPase KAR2', NULL, NULL, NULL, NULL, NULL, 4),
(209558, NULL, 'G3DSA:2.40.50.140:FF:000782', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209559, NULL, 'G3DSA:1.20.5.2950:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209560, NULL, 'G3DSA:2.130.10.10:FF:003945', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209561, NULL, 'G3DSA:3.30.40.10:FF:001988', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(209562, NULL, 'G3DSA:1.10.8.10:FF:000260', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 13', NULL, NULL, NULL, NULL, NULL, 4),
(209563, NULL, 'G3DSA:3.90.640.10:FF:000082', NULL, NULL, 'Actin 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(209564, NULL, 'G3DSA:2.10.25.10:FF:000635', NULL, NULL, 'Terribly reduced optic lobes, isoform AN', NULL, NULL, NULL, NULL, NULL, 4),
(209565, NULL, 'G3DSA:3.30.70.1230:FF:000011', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(209566, NULL, 'G3DSA:3.40.390.10:FF:000067', NULL, NULL, 'Probable zinc metalloprotease', NULL, NULL, NULL, NULL, NULL, 4),
(209567, NULL, 'G3DSA:3.60.20.10:FF:000047', NULL, NULL, 'Amidophosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(209568, NULL, 'G3DSA:2.60.120.10:FF:000721', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209569, NULL, 'G3DSA:3.50.50.60:FF:000923', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209570, NULL, 'G3DSA:2.60.60.20:FF:000009', NULL, NULL, 'Lipoxygenase homology domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(209571, NULL, 'G3DSA:3.20.20.100:FF:000164', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(209572, NULL, 'G3DSA:2.60.120.590:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209573, NULL, 'G3DSA:3.40.50.10240:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209574, NULL, 'G3DSA:2.40.128.20:FF:000004', NULL, NULL, 'Retinol-binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(209575, NULL, 'G3DSA:3.20.20.330:FF:000002', NULL, NULL, 'Homocysteine S-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(209576, NULL, 'G3DSA:3.90.1150.10:FF:000285', NULL, NULL, 'Kynureninase', NULL, NULL, NULL, NULL, NULL, 4),
(209577, NULL, 'G3DSA:1.10.800.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209578, NULL, 'G3DSA:3.20.20.80:FF:000732', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209579, NULL, 'G3DSA:3.30.160.310:FF:000001', NULL, NULL, 'RING finger protein Z', NULL, NULL, NULL, NULL, NULL, 4),
(209580, NULL, 'G3DSA:2.60.40.2300:FF:000005', NULL, NULL, 'Hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(209581, NULL, 'G3DSA:3.30.200.20:FF:001037', NULL, NULL, 'Putative G-type lectin S-receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(209582, NULL, 'G3DSA:1.20.1070.10:FF:000661', NULL, NULL, 'KISS1 receptor b', NULL, NULL, NULL, NULL, NULL, 4),
(209583, NULL, 'G3DSA:3.40.50.1000:FF:000400', NULL, NULL, 'GM14093', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(209584, NULL, 'G3DSA:2.40.50.140:FF:000456', NULL, NULL, 'Aspartyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(209585, NULL, 'G3DSA:3.40.50.300:FF:005424', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(209586, NULL, 'G3DSA:3.60.40.10:FF:000256', NULL, NULL, 'Integrin-linked kinase-associated serine/threonine phosphatase 2C', NULL, NULL, NULL, NULL, NULL, 4),
(209587, NULL, 'G3DSA:3.30.380.10:FF:000001', NULL, NULL, 'Capsid protein', NULL, NULL, NULL, NULL, NULL, 4),
(209588, NULL, 'G3DSA:1.20.1250.20:FF:002353', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209589, NULL, 'G3DSA:1.10.10.10:FF:000946', NULL, NULL, 'ForKHead transcription factor family', NULL, NULL, NULL, NULL, NULL, 4),
(209590, NULL, 'G3DSA:1.50.40.10:FF:000362', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(209591, NULL, 'G3DSA:3.40.30.10:FF:000301', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(209592, NULL, 'G3DSA:3.30.160.60:FF:004991', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209593, NULL, 'G3DSA:3.10.290.10:FF:000072', NULL, NULL, '30S ribosomal protein S4', NULL, NULL, NULL, NULL, NULL, 4),
(209594, NULL, 'G3DSA:1.10.357.70:FF:000005', NULL, NULL, 'Exocyst complex component Sec6', NULL, NULL, NULL, NULL, NULL, 4),
(209595, NULL, 'G3DSA:1.10.20.60:FF:000001', NULL, NULL, 'Aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(209596, NULL, 'G3DSA:1.25.40.10:FF:004962', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209597, NULL, 'G3DSA:3.80.10.10:FF:002389', NULL, NULL, 'F-box and leucine rich repeat protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(209598, NULL, 'G3DSA:3.40.710.10:FF:000104', NULL, NULL, 'Penicillin-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(209599, NULL, 'G3DSA:2.60.40.2310:FF:000008', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(209600, NULL, 'G3DSA:3.40.50.720:FF:000317', NULL, NULL, 'Very-long-chain 3-oxoacyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(209601, NULL, 'G3DSA:3.40.50.150:FF:001821', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209602, NULL, 'G3DSA:1.10.8.1220:FF:000013', NULL, NULL, 'Dynein axonemal heavy chain 14', NULL, NULL, NULL, NULL, NULL, 4),
(209603, NULL, 'G3DSA:2.20.28.20:FF:000004', NULL, NULL, 'Putative tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(209604, NULL, 'G3DSA:3.50.50.60:FF:001233', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(209605, NULL, 'G3DSA:3.30.70.330:FF:000594', NULL, NULL, 'RNA binding protein Rnp24', NULL, NULL, NULL, NULL, NULL, 4),
(209606, NULL, 'G3DSA:3.40.50.300:FF:001681', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(209607, NULL, 'G3DSA:2.30.39.10:FF:000149', NULL, NULL, 'Serine protease inhibitor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209608, NULL, 'G3DSA:2.60.120.330:FF:000212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209609, NULL, 'G3DSA:1.20.1560.10:FF:000709', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209610, NULL, 'G3DSA:2.30.29.150:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209611, NULL, 'G3DSA:2.130.10.10:FF:005244', NULL, NULL, 'Damage-specific DNA binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209612, NULL, 'G3DSA:2.30.29.170:FF:000017', NULL, NULL, 'Protofilament ribbon protein of flagellar microtubules', NULL, NULL, NULL, NULL, NULL, 4),
(209613, NULL, 'G3DSA:2.60.40.10:FF:004131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209614, NULL, 'G3DSA:3.30.160.60:FF:005980', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209615, NULL, 'G3DSA:3.30.470.20:FF:000096', NULL, NULL, 'Tubulin tyrosine ligase protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209616, NULL, 'G3DSA:1.25.40.10:FF:003208', NULL, NULL, 'Os07g0172600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(209617, NULL, 'G3DSA:1.10.287.70:FF:000415', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(209618, NULL, 'G3DSA:1.25.40.20:FF:001093', NULL, NULL, 'Ankyrin repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(209619, NULL, 'G3DSA:3.40.50.2300:FF:000537', NULL, NULL, 'Transcriptional regulator, LacI family', NULL, NULL, NULL, NULL, NULL, 4),
(209620, NULL, 'G3DSA:3.40.50.1760:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209621, NULL, 'G3DSA:1.10.20.70:FF:000004', NULL, NULL, 'Rna15p', NULL, NULL, NULL, NULL, NULL, 4),
(209622, NULL, 'G3DSA:1.25.10.10:FF:001615', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209623, NULL, 'G3DSA:3.30.70.330:FF:002685', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209624, NULL, 'G3DSA:2.60.40.10:FF:002040', NULL, NULL, 'Mesocentin', NULL, NULL, NULL, NULL, NULL, 4),
(209625, NULL, 'G3DSA:3.40.50.11290:FF:000001', NULL, NULL, 'Hypothetical alanine and leucine rich protein', NULL, NULL, NULL, NULL, NULL, 4),
(209626, NULL, 'G3DSA:3.40.50.150:FF:001175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209627, NULL, 'G3DSA:1.25.40.10:FF:001117', NULL, NULL, 'Est1-like bcy1 suppressor', NULL, NULL, NULL, NULL, NULL, 4),
(209628, NULL, 'G3DSA:1.10.287.380:FF:000019', NULL, NULL, 'Valyl tRNA Synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(209629, NULL, 'G3DSA:3.30.470.30:FF:000099', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(209630, NULL, 'G3DSA:3.30.1180.20:FF:000005', NULL, NULL, 'Dihydroxyacetone kinase 1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(209631, NULL, 'G3DSA:1.25.40.180:FF:000354', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209632, NULL, 'G3DSA:3.90.640.10:FF:000109', NULL, NULL, 'Actin-Related Proteins', NULL, NULL, NULL, NULL, NULL, 4),
(209633, NULL, 'G3DSA:1.10.8.60:FF:000016', NULL, NULL, 'ATPase family AAA domain-containing protein 2B', NULL, NULL, NULL, NULL, NULL, 4),
(209634, NULL, 'G3DSA:3.90.660.10:FF:000026', NULL, NULL, 'Flavin-containing monoamine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(209635, NULL, 'G3DSA:3.20.20.70:FF:000257', NULL, NULL, 'Phosphatidylinositol 4-kinase type 2 alpha', NULL, NULL, NULL, NULL, NULL, 4),
(209636, NULL, 'G3DSA:2.60.120.650:FF:000218', NULL, NULL, 'HSPB1 associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(209637, NULL, 'G3DSA:3.40.50.1450:FF:000012', NULL, NULL, 'Slr1876 protein', NULL, NULL, NULL, NULL, NULL, 4),
(209638, NULL, 'G3DSA:3.10.10.10:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209639, NULL, 'G3DSA:2.60.40.2550:FF:000001', NULL, NULL, 'GlcNAc-binding protein A', NULL, NULL, NULL, NULL, NULL, 4),
(209640, NULL, 'G3DSA:3.40.50.300:FF:007515', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(209641, NULL, 'G3DSA:3.40.50.300:FF:007195', NULL, NULL, 'DNA polymerase III subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209642, NULL, 'G3DSA:3.40.50.1460:FF:000015', NULL, NULL, 'Caspase 14', NULL, NULL, NULL, NULL, NULL, 4),
(209643, NULL, 'G3DSA:1.10.8.50:FF:000013', NULL, NULL, '40S ribosomal protein S18', NULL, NULL, NULL, NULL, NULL, 4),
(209644, NULL, 'G3DSA:1.10.600.10:FF:000037', NULL, NULL, 'Phytoene synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209645, NULL, 'G3DSA:1.25.40.10:FF:002871', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(209646, NULL, 'G3DSA:2.60.40.10:FF:005266', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209647, NULL, 'G3DSA:3.80.10.10:FF:000298', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(209648, NULL, 'G3DSA:1.20.58.1070:FF:000027', NULL, NULL, 'Gem-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(209649, NULL, 'G3DSA:3.10.129.30:FF:000001', NULL, NULL, 'Fatty acyl CoA thioesterase FcoT', NULL, NULL, NULL, NULL, NULL, 4),
(209650, NULL, 'G3DSA:3.30.300.30:FF:000148', NULL, NULL, 'Putative acetyl-CoA synethetase', NULL, NULL, NULL, NULL, NULL, 4),
(209651, NULL, 'G3DSA:3.40.1620.10:FF:000006', NULL, NULL, 'Antitoxin VapB35', NULL, NULL, NULL, NULL, NULL, 4),
(209652, NULL, 'G3DSA:3.90.1200.10:FF:000019', NULL, NULL, 'Choline kinase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(209653, NULL, 'G3DSA:4.10.1000.10:FF:000106', NULL, NULL, 'CCCH zinc finger protein (AFU_orthologue AFUA_8G04360)', NULL, NULL, NULL, NULL, NULL, 4),
(209654, NULL, 'G3DSA:2.30.42.10:FF:000056', NULL, NULL, 'Golgi reassembly-stacking protein 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(209655, NULL, 'G3DSA:2.10.25.10:FF:000961', NULL, NULL, 'GD23942', NULL, NULL, NULL, NULL, NULL, 4),
(209656, NULL, 'G3DSA:3.40.50.300:FF:001742', NULL, NULL, 'Pre-mRNA-splicing helicase BRR2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209657, NULL, 'G3DSA:2.60.120.10:FF:000075', NULL, NULL, 'metal transporter CNNM2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(209658, NULL, 'G3DSA:3.40.50.10190:FF:000065', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(209659, NULL, 'G3DSA:2.60.200.20:FF:000079', NULL, NULL, 'Checkpoint kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(209660, NULL, 'G3DSA:1.10.510.10:FF:001492', NULL, NULL, 'Related to Serine/threonine-protein kinase mph1', NULL, NULL, NULL, NULL, NULL, 4),
(209661, NULL, 'G3DSA:1.25.40.10:FF:003360', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(209662, NULL, 'G3DSA:1.10.510.10:FF:004133', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209663, NULL, 'G3DSA:3.30.420.10:FF:000409', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209664, NULL, 'G3DSA:1.20.1560.10:FF:000182', NULL, NULL, 'Beta-(1-->2)glucan export ATP-binding/permease protein NdvA', NULL, NULL, NULL, NULL, NULL, 4),
(209665, NULL, 'G3DSA:2.20.28.10:FF:000001', NULL, NULL, 'Rubredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(209666, NULL, 'G3DSA:3.90.55.10:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209667, NULL, 'G3DSA:1.20.1250.20:FF:000762', NULL, NULL, 'organic cation transporter protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(209668, NULL, 'G3DSA:1.10.150.20:FF:000258', NULL, NULL, 'Flap endonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(209669, NULL, 'G3DSA:3.40.50.10140:FF:000044', NULL, NULL, 'Toll-like receptor adaptor molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(209670, NULL, 'G3DSA:1.10.630.10:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209671, NULL, 'G3DSA:1.10.565.10:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209672, NULL, 'G3DSA:1.20.1280.290:FF:000084', NULL, NULL, 'Sugar transporter SWEET1', NULL, NULL, NULL, NULL, NULL, 4),
(209673, NULL, 'G3DSA:2.30.30.100:FF:000156', NULL, NULL, 'Small nuclear ribonucleoprotein Sm D2', NULL, NULL, NULL, NULL, NULL, 4),
(209674, NULL, 'G3DSA:3.30.420.40:FF:001060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209675, NULL, 'G3DSA:2.40.50.90:FF:000087', NULL, NULL, 'Protein CBG02810', NULL, NULL, NULL, NULL, NULL, 4),
(209676, NULL, 'G3DSA:3.30.30.30:FF:000009', NULL, NULL, 'Heat shock protein Hsp70', NULL, NULL, NULL, NULL, NULL, 4),
(209677, NULL, 'G3DSA:2.60.120.260:FF:000489', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209678, NULL, 'G3DSA:3.40.50.620:FF:000085', NULL, NULL, 'Tyrosine--tRNA ligase 1 cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(209679, NULL, 'G3DSA:3.30.300.30:FF:000087', NULL, NULL, 'Nonribosomal peptide synthase GliP', NULL, NULL, NULL, NULL, NULL, 4),
(209680, NULL, 'G3DSA:3.40.80.10:FF:000012', NULL, NULL, 'N-acetyl-anhydromuranmyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(209681, NULL, 'G3DSA:1.10.630.10:FF:000191', NULL, NULL, 'GD17061', NULL, NULL, NULL, NULL, NULL, 4),
(209682, NULL, 'G3DSA:3.40.50.300:FF:001063', NULL, NULL, 'Guanylate-binding family protein', NULL, NULL, NULL, NULL, NULL, 4),
(209683, NULL, 'G3DSA:3.40.50.720:FF:000643', NULL, NULL, 'Short chain dehydrogenase/reductase family oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209684, NULL, 'G3DSA:3.30.70.330:FF:001903', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209685, NULL, 'G3DSA:2.60.220.50:FF:000038', NULL, NULL, 'RE14222p', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(209686, NULL, 'G3DSA:1.10.3810.10:FF:000024', NULL, NULL, 'Penicillin-binding protein, 1A family', NULL, NULL, NULL, NULL, NULL, 4),
(209687, NULL, 'G3DSA:3.40.50.300:FF:008330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209688, NULL, 'G3DSA:1.10.10.10:FF:001082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209689, NULL, 'G3DSA:3.40.50.2060:FF:000010', NULL, NULL, 'Vacuolar protein sorting-associated protein 45', NULL, NULL, NULL, NULL, NULL, 4),
(209690, NULL, 'G3DSA:3.40.50.300:FF:001355', NULL, NULL, 'tRNA dimethylallyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(209691, NULL, 'G3DSA:1.10.630.10:FF:000011', NULL, NULL, 'Cytochrome P450 83B1', NULL, NULL, NULL, NULL, NULL, 4),
(209692, NULL, 'G3DSA:4.10.950.10:FF:000001', NULL, NULL, '50S ribosomal protein L2', NULL, NULL, NULL, NULL, NULL, 4),
(209693, NULL, 'G3DSA:2.10.25.10:FF:000135', NULL, NULL, 'Laminin subunit beta 4', NULL, NULL, NULL, NULL, NULL, 4),
(209694, NULL, 'G3DSA:3.40.50.620:FF:000731', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209695, NULL, 'G3DSA:1.25.40.10:FF:001617', NULL, NULL, 'Stress-induced-phosphoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(209696, NULL, 'G3DSA:1.10.8.100:FF:000022', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(209697, NULL, 'G3DSA:3.30.200.20:FF:001363', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209698, NULL, 'G3DSA:1.10.510.10:FF:001519', NULL, NULL, 'Serine/threonine-protein kinase NEK', NULL, NULL, NULL, NULL, NULL, 4),
(209699, NULL, 'G3DSA:3.40.50.410:FF:000168', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(209700, NULL, 'G3DSA:1.20.80.10:FF:000080', NULL, NULL, 'Protein tyrosine kinase 2 beta', NULL, NULL, NULL, NULL, NULL, 4),
(209701, NULL, 'G3DSA:2.130.10.10:FF:003092', NULL, NULL, 'WD repeat-containing protein 20 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(209702, NULL, 'G3DSA:2.60.40.10:FF:001225', NULL, NULL, 'Cell surface glycoprotein MUC18', NULL, NULL, NULL, NULL, NULL, 4),
(209703, NULL, 'G3DSA:1.20.1070.10:FF:000509', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209704, NULL, 'G3DSA:3.80.10.10:FF:001315', NULL, NULL, 'Leucine-rich receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(209705, NULL, 'G3DSA:2.130.10.10:FF:001528', NULL, NULL, 'U3 small nucleolar RNA-associated protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(209706, NULL, 'G3DSA:3.30.420.10:FF:000056', NULL, NULL, 'CCR4-NOT core complex subunit Caf1', NULL, NULL, NULL, NULL, NULL, 4),
(209707, NULL, 'G3DSA:3.10.330.10:FF:000008', NULL, NULL, 'AAA family ATPase, CDC48 subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(209708, NULL, 'G3DSA:3.40.50.720:FF:000289', NULL, NULL, 'Hydroxysteroid 17-beta dehydrogenase 7', NULL, NULL, NULL, NULL, NULL, 4),
(209709, NULL, 'G3DSA:3.80.10.10:FF:004160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209710, NULL, 'G3DSA:3.30.160.60:FF:003563', NULL, NULL, 'Zinc finger protein 460', NULL, NULL, NULL, NULL, NULL, 4),
(209711, NULL, 'G3DSA:3.40.50.800:FF:000015', NULL, NULL, 'Histidyl-tRNA synthetase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(209712, NULL, 'G3DSA:2.60.40.10:FF:000123', NULL, NULL, 'Plexin A1', NULL, NULL, NULL, NULL, NULL, 4),
(209713, NULL, 'G3DSA:3.40.50.1470:FF:000018', NULL, NULL, 'Peptidyl-tRNA hydrolase 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(209714, NULL, 'G3DSA:3.40.50.2000:FF:000863', NULL, NULL, 'Putative colanic acid biosynthesis glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(209715, NULL, 'G3DSA:3.10.250.10:FF:000007', NULL, NULL, 'Soluble scavenger receptor cysteine-rich domain-containing protein SSC5D', NULL, NULL, NULL, NULL, NULL, 4),
(209716, NULL, 'G3DSA:2.60.40.420:FF:000163', NULL, NULL, 'AGAP008732-PA', NULL, NULL, NULL, NULL, NULL, 4),
(209717, NULL, 'G3DSA:3.40.50.2000:FF:000571', NULL, NULL, 'D-inositol-3-phosphate glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(209718, NULL, 'G3DSA:3.30.200.20:FF:002465', NULL, NULL, 'Serine/threonine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(209719, NULL, 'G3DSA:2.130.10.10:FF:003327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209720, NULL, 'G3DSA:3.40.640.10:FF:000368', NULL, NULL, 'PLP-dependent transferase', NULL, NULL, NULL, NULL, NULL, 4),
(209721, NULL, 'G3DSA:3.30.1640.10:FF:000021', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(209722, NULL, 'G3DSA:2.40.10.10:FF:000105', NULL, NULL, 'Inactive serine protease 45', NULL, NULL, NULL, NULL, NULL, 4),
(209723, NULL, 'G3DSA:2.60.120.330:FF:000066', NULL, NULL, 'Os06g0176500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(209724, NULL, 'G3DSA:3.40.50.300:FF:003833', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(209725, NULL, 'G3DSA:3.40.50.450:FF:000040', NULL, NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(209726, NULL, 'G3DSA:3.40.50.300:FF:000253', NULL, NULL, 'Peptide chain release factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(209727, NULL, 'G3DSA:3.40.190.10:FF:000939', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(209728, NULL, 'G3DSA:3.60.140.10:FF:000005', NULL, NULL, 'Laccase domain protein YfiH', NULL, NULL, NULL, NULL, NULL, 4),
(209729, NULL, 'G3DSA:3.30.70.270:FF:000082', NULL, NULL, 'DNA polymerase eta', NULL, NULL, NULL, NULL, NULL, 4),
(209730, NULL, 'G3DSA:2.60.40.60:FF:001133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209731, NULL, 'G3DSA:3.80.10.10:FF:002417', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209732, NULL, 'G3DSA:1.10.287.70:FF:000269', NULL, NULL, 'TWiK family of potassium channels', NULL, NULL, NULL, NULL, NULL, 4),
(209733, NULL, 'G3DSA:1.20.1250.20:FF:002027', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(209734, NULL, 'G3DSA:2.60.40.10:FF:001517', NULL, NULL, 'Cytokine receptor common subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(209735, NULL, 'G3DSA:1.50.40.10:FF:000036', NULL, NULL, 'Mitochondrial glycine transporter B', NULL, NULL, NULL, NULL, NULL, 4),
(209736, NULL, 'G3DSA:3.20.20.190:FF:000117', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209737, NULL, 'G3DSA:1.10.10.2420:FF:000002', NULL, NULL, 'Glutaminyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209738, NULL, 'G3DSA:3.40.50.150:FF:000101', NULL, NULL, 'Thiopurine S-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(209739, NULL, 'G3DSA:3.90.70.80:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209740, NULL, 'G3DSA:1.20.1270.60:FF:000045', NULL, NULL, 'Cell division control protein', NULL, NULL, NULL, NULL, NULL, 4),
(209741, NULL, 'G3DSA:1.10.1520.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209742, NULL, 'G3DSA:1.25.40.10:FF:000628', NULL, NULL, 'protein CTR9 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(209743, NULL, 'G3DSA:3.90.640.10:FF:000289', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(209744, NULL, 'G3DSA:3.10.20.90:FF:000230', NULL, NULL, 'Sorting nexin 31', NULL, NULL, NULL, NULL, NULL, 4),
(209745, NULL, 'G3DSA:3.30.70.330:FF:000914', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit G', NULL, NULL, NULL, NULL, NULL, 4),
(209746, NULL, 'G3DSA:1.10.3730.20:FF:000026', NULL, NULL, 'Solute carrier family 35, member G1', NULL, NULL, NULL, NULL, NULL, 4),
(209747, NULL, 'G3DSA:3.30.420.10:FF:000202', NULL, NULL, 'Ribonuclease H1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209748, NULL, 'G3DSA:2.130.10.10:FF:005862', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209749, NULL, 'G3DSA:3.60.10.10:FF:000428', NULL, NULL, 'Putative inositol polyphosphate phosphatase (Synaptogenin-like) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(209750, NULL, 'G3DSA:1.20.920.10:FF:000093', NULL, NULL, 'Transcription factor GTE6', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(209751, NULL, 'G3DSA:3.80.10.10:FF:002743', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(209752, NULL, 'G3DSA:3.30.70.80:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209753, NULL, 'G3DSA:3.90.1140.10:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209754, NULL, 'G3DSA:2.170.300.10:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209755, NULL, 'G3DSA:2.60.120.290:FF:000065', NULL, NULL, 'Uncharacterized protein, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(209756, NULL, 'G3DSA:1.10.10.2430:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209757, NULL, 'G3DSA:3.30.160.20:FF:000140', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(209758, NULL, 'G3DSA:3.30.460.10:FF:000148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209759, NULL, 'G3DSA:1.25.40.10:FF:003181', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(209760, NULL, 'G3DSA:3.40.50.410:FF:000314', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(209761, NULL, 'G3DSA:1.20.90.10:FF:000018', NULL, NULL, 'Phospholipase A(2)', NULL, NULL, NULL, NULL, NULL, 4),
(209762, NULL, 'G3DSA:2.30.39.10:FF:000003', NULL, NULL, 'alpha-1-antitrypsin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(209763, NULL, 'G3DSA:3.90.1290.10:FF:000002', NULL, NULL, 'Plectin a', NULL, NULL, NULL, NULL, NULL, 4),
(209764, NULL, 'G3DSA:1.20.58.340:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209765, NULL, 'G3DSA:2.30.30.60:FF:000004', NULL, NULL, 'Transporter, small conductance mechanosensitive ion channel family', NULL, NULL, NULL, NULL, NULL, 4),
(209766, NULL, 'G3DSA:2.20.100.10:FF:000246', NULL, NULL, 'plasminogen-like', NULL, NULL, NULL, NULL, NULL, 4),
(209767, NULL, 'G3DSA:3.40.20.10:FF:000036', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(209768, NULL, 'G3DSA:3.50.50.60:FF:000777', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(209769, NULL, 'G3DSA:2.40.50.140:FF:000810', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209770, NULL, 'G3DSA:2.30.30.50:FF:000001', NULL, NULL, 'Photosystem I reaction center subunit IV, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(209771, NULL, 'G3DSA:2.120.10.30:FF:000248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209772, NULL, 'G3DSA:3.40.190.120:FF:000009', NULL, NULL, 'Proline/glycine betaine ABC superfamily ATP binding cassette transporter, membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(209773, NULL, 'G3DSA:1.10.630.10:FF:000483', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209774, NULL, 'G3DSA:1.10.510.10:FF:001227', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(209775, NULL, 'G3DSA:3.40.630.30:FF:000261', NULL, NULL, 'N-alpha-acetyltransferase 10-like isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(209776, NULL, 'G3DSA:3.40.50.2000:FF:000419', NULL, NULL, 'Putative glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(209777, NULL, 'G3DSA:3.60.40.10:FF:000317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209778, NULL, 'G3DSA:1.20.58.60:FF:000481', NULL, NULL, 'Spectrin repeat containing, nuclear envelope 1a', NULL, NULL, NULL, NULL, NULL, 4),
(209779, NULL, 'G3DSA:3.30.160.60:FF:003237', NULL, NULL, 'Si:ch211-269m15.3', NULL, NULL, NULL, NULL, NULL, 4),
(209780, NULL, 'G3DSA:3.40.50.2000:FF:000245', NULL, NULL, 'Lipid-A-disaccharide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(209781, NULL, 'G3DSA:3.30.760.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209782, NULL, 'G3DSA:1.25.10.10:FF:000891', NULL, NULL, 'VAC14p Enzyme regulator', NULL, NULL, NULL, NULL, NULL, 4),
(209783, NULL, 'G3DSA:1.25.10.10:FF:002717', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(209784, NULL, 'G3DSA:3.40.250.10:FF:000057', NULL, NULL, 'Cysteine synthase B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209785, NULL, 'G3DSA:3.30.70.330:FF:003141', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209786, NULL, 'G3DSA:1.10.150.50:FF:000008', NULL, NULL, 'Neurabin-1 isoform 1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(209787, NULL, 'G3DSA:1.10.150.40:FF:000005', NULL, NULL, 'Barrier-to-autointegration factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(209788, NULL, 'G3DSA:3.90.190.10:FF:000299', NULL, NULL, 'Triacylglycerol lipase', NULL, NULL, NULL, NULL, NULL, 4),
(209789, NULL, 'G3DSA:1.20.58.60:FF:000716', NULL, NULL, 'Dystonin', NULL, NULL, NULL, NULL, NULL, 4),
(209790, NULL, 'G3DSA:3.30.40.10:FF:000268', NULL, NULL, 'E3 ubiquitin-protein ligase NRDP1', NULL, NULL, NULL, NULL, NULL, 4),
(209791, NULL, 'G3DSA:3.40.50.10730:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209792, NULL, 'G3DSA:1.20.120.350:FF:000020', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(209793, NULL, 'G3DSA:1.20.1280.50:FF:000014', NULL, NULL, 'F-box only protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(209794, NULL, 'G3DSA:3.40.850.10:FF:000086', NULL, NULL, 'kinesin-like protein KIN-14F', NULL, NULL, NULL, NULL, NULL, 4),
(209795, NULL, 'G3DSA:3.40.50.1820:FF:000820', NULL, NULL, 'Triacylglycerol lipase', NULL, NULL, NULL, NULL, NULL, 4),
(209796, NULL, 'G3DSA:3.40.190.10:FF:000086', NULL, NULL, 'Probable porphobilinogen deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(209797, NULL, 'G3DSA:3.30.70.330:FF:002393', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209798, NULL, 'G3DSA:2.60.40.10:FF:001843', NULL, NULL, 'KETtiN (Drosophila actin-binding) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(209799, NULL, 'G3DSA:1.20.58.150:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209800, NULL, 'G3DSA:3.40.930.10:FF:000002', NULL, NULL, 'Anion exchange protein', NULL, NULL, NULL, NULL, NULL, 4),
(209801, NULL, 'G3DSA:3.30.342.10:FF:000037', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(209802, NULL, 'G3DSA:3.40.50.11500:FF:000014', NULL, NULL, 'DENN (AEX-3) domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(209803, NULL, 'G3DSA:3.60.40.10:FF:000082', NULL, NULL, 'Protein phosphatase, Mg2+/Mn2+ dependent 1J', NULL, NULL, NULL, NULL, NULL, 4),
(209804, NULL, 'G3DSA:2.60.40.350:FF:000001', NULL, NULL, 'Envelope glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(209805, NULL, 'G3DSA:3.30.920.10:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209806, NULL, 'G3DSA:1.25.10.10:FF:003353', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209807, NULL, 'G3DSA:2.60.40.10:FF:005412', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209808, NULL, 'G3DSA:3.40.309.10:FF:000076', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(209809, NULL, 'G3DSA:2.60.98.20:FF:000012', NULL, NULL, 'Flagellar hook protein FlgE', NULL, NULL, NULL, NULL, NULL, 4),
(209810, NULL, 'G3DSA:3.10.180.10:FF:000064', NULL, NULL, 'Lactoylglutathione lyase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(209811, NULL, 'G3DSA:3.40.630.60:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209812, NULL, 'G3DSA:3.40.50.300:FF:003507', NULL, NULL, 'dCMP deaminase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209813, NULL, 'G3DSA:2.130.10.10:FF:003653', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(209814, NULL, 'G3DSA:2.80.10.50:FF:000003', NULL, NULL, 'recombining binding protein suppressor of hairless', NULL, NULL, NULL, NULL, NULL, 4),
(209815, NULL, 'G3DSA:3.30.1490.20:FF:000080', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(209816, NULL, 'G3DSA:1.20.59.10:FF:000007', NULL, NULL, 'Secreted chorismate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(209817, NULL, 'G3DSA:3.80.10.10:FF:004188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(209818, NULL, 'G3DSA:3.30.9.10:FF:000235', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(209819, NULL, 'G3DSA:3.30.505.10:FF:000051', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(209820, NULL, 'G3DSA:3.30.160.60:FF:001972', NULL, NULL, 'Zinc finger protein 574', NULL, NULL, NULL, NULL, NULL, 4),
(209821, NULL, 'G3DSA:1.10.472.80:FF:000085', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(209822, NULL, 'G3DSA:3.40.50.300:FF:001916', NULL, NULL, 'Mitochondrial GTPase (Mss1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(209823, NULL, 'G3DSA:2.30.29.30:FF:000363', NULL, NULL, 'Putative E3 ubiquitin-protein ligase HERC1', NULL, NULL, NULL, NULL, NULL, 4),
(209824, NULL, 'G3DSA:1.20.58.900:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209825, NULL, 'G3DSA:2.130.10.10:FF:005536', NULL, NULL, 'Uncharacterized WD repeat-containing protein C1306.02', NULL, NULL, NULL, NULL, NULL, 4),
(209826, NULL, 'G3DSA:3.40.50.300:FF:006998', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209827, NULL, 'G3DSA:1.25.40.470:FF:000025', NULL, NULL, 'GL24573', NULL, NULL, NULL, NULL, NULL, 4),
(209828, NULL, 'G3DSA:1.20.58.830:FF:000013', NULL, NULL, 'Erythrocyte binding antigen-140', NULL, NULL, NULL, NULL, NULL, 4),
(209829, NULL, 'G3DSA:3.20.20.80:FF:000440', NULL, NULL, 'Acidic endochitinase', NULL, NULL, NULL, NULL, NULL, 4),
(209830, NULL, 'G3DSA:3.50.50.60:FF:000570', NULL, NULL, 'Dimethylglycine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(209831, NULL, 'G3DSA:3.30.420.10:FF:000382', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209832, NULL, 'G3DSA:1.10.287.70:FF:000680', NULL, NULL, 'Potassium voltage-gated channel subfamily H member 2', NULL, NULL, NULL, NULL, NULL, 4),
(209833, NULL, 'G3DSA:3.30.40.10:FF:001016', NULL, NULL, 'SNF2 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(209834, NULL, 'G3DSA:1.10.510.10:FF:001845', NULL, NULL, 'Serine/threonine protein kinase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(209835, NULL, 'G3DSA:2.30.42.10:FF:000348', NULL, NULL, 'Rubredoxin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(209836, NULL, 'G3DSA:3.30.160.60:FF:005715', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209837, NULL, 'G3DSA:1.20.1260.10:FF:000052', NULL, NULL, 'Putative ferritin heavy polypeptide-like 19', NULL, NULL, NULL, NULL, NULL, 4),
(209838, NULL, 'G3DSA:1.10.238.10:FF:000610', NULL, NULL, 'EF-hand domain pair/EF-hand domain/EF hand, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209839, NULL, 'G3DSA:1.25.40.10:FF:003034', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g42630', NULL, NULL, NULL, NULL, NULL, 4),
(209840, NULL, 'G3DSA:3.40.50.300:FF:007223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209841, NULL, 'G3DSA:3.30.2260.10:FF:000003', NULL, NULL, 'Enhancer of rudimentary homolog', NULL, NULL, NULL, NULL, NULL, 4),
(209842, NULL, 'G3DSA:1.10.287.770:FF:000013', NULL, NULL, 'GL19333', NULL, NULL, NULL, NULL, NULL, 4),
(209843, NULL, 'G3DSA:1.10.246.140:FF:000012', NULL, NULL, 'Transcription and mRNA export factor ENY2', NULL, NULL, NULL, NULL, NULL, 4),
(209844, NULL, 'G3DSA:1.50.10.10:FF:000208', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(209845, NULL, 'G3DSA:3.30.1490.80:FF:000018', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(209846, NULL, 'G3DSA:1.25.40.1040:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209847, NULL, 'G3DSA:3.20.20.80:FF:000086', NULL, NULL, '1,3-beta-glucanosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(209848, NULL, 'G3DSA:2.10.60.10:FF:000059', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(209849, NULL, 'G3DSA:2.60.40.10:FF:004923', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209850, NULL, 'G3DSA:1.10.10.2380:FF:000001', NULL, NULL, 'Cell division control protein 13', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(209851, NULL, 'G3DSA:2.70.160.11:FF:000065', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(209852, NULL, 'G3DSA:1.20.58.60:FF:000155', NULL, NULL, 'nesprin-1 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(209853, NULL, 'G3DSA:3.10.20.90:FF:000876', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(209854, NULL, 'G3DSA:1.10.287.3240:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209855, NULL, 'G3DSA:2.120.10.30:FF:000574', NULL, NULL, 'tripartite motif-containing protein 3-like', NULL, NULL, NULL, NULL, NULL, 4),
(209856, NULL, 'G3DSA:2.40.70.10:FF:000519', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209857, NULL, 'G3DSA:3.40.850.10:FF:000440', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209858, NULL, 'G3DSA:3.30.70.360:FF:000018', NULL, NULL, 'N-acyl-L-amino acid amidohydrolase AmiA1', NULL, NULL, NULL, NULL, NULL, 4),
(209859, NULL, 'G3DSA:1.25.40.10:FF:005007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209860, NULL, 'G3DSA:3.80.20.20:FF:000066', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(209861, NULL, 'G3DSA:3.40.50.300:FF:005278', NULL, NULL, 'Septin-7', NULL, NULL, NULL, NULL, NULL, 4),
(209862, NULL, 'G3DSA:1.10.3370.10:FF:000006', NULL, NULL, 'Sec61 translocon alpha 2 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(209863, NULL, 'G3DSA:3.40.1810.10:FF:000015', NULL, NULL, 'MADS-box transcription factor 32', NULL, NULL, NULL, NULL, NULL, 4),
(209864, NULL, 'G3DSA:2.60.120.200:FF:000639', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209865, NULL, 'G3DSA:1.20.5.170:FF:000147', NULL, NULL, 'fos-related antigen 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(209866, NULL, 'G3DSA:1.20.5.110:FF:000062', NULL, NULL, 'Cell division coordinator CpoB', NULL, NULL, NULL, NULL, NULL, 4),
(209867, NULL, 'G3DSA:1.20.1560.10:FF:000417', NULL, NULL, 'SPbeta prophage-derived sublancin-168-processing and transport ATP-binding protein SunT', NULL, NULL, NULL, NULL, NULL, 4),
(209868, NULL, 'G3DSA:2.60.120.10:FF:000221', NULL, NULL, 'Mannose-6-phosphate isomerase, class I', NULL, NULL, NULL, NULL, NULL, 4),
(209869, NULL, 'G3DSA:3.40.50.10190:FF:000211', NULL, NULL, 'AGAP002760-PA', NULL, NULL, NULL, NULL, NULL, 4),
(209870, NULL, 'G3DSA:2.160.10.10:FF:000089', NULL, NULL, 'Putative lipopolysaccharide biosynthesis O-acetyl transferase WbbJ', NULL, NULL, NULL, NULL, NULL, 4),
(209871, NULL, 'G3DSA:1.25.40.10:FF:000954', NULL, NULL, 'LOW protein: PPR containing-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(209872, NULL, 'G3DSA:2.102.10.10:FF:000018', NULL, NULL, 'Putative biphenyl dioxygenase system ferredoxin component', NULL, NULL, NULL, NULL, NULL, 4),
(209873, NULL, 'G3DSA:1.25.40.20:FF:001446', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209874, NULL, 'G3DSA:1.10.150.50:FF:000160', NULL, NULL, 'stromal interaction molecule homolog isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(209875, NULL, 'G3DSA:1.10.555.10:FF:000240', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209876, NULL, 'G3DSA:1.20.120.1880:FF:000014', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(209877, NULL, 'G3DSA:1.10.287.70:FF:000062', NULL, NULL, 'Two pore calcium channel protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(209878, NULL, 'G3DSA:3.30.110.170:FF:000005', NULL, NULL, 'interleukin-1 receptor-associated kinase 1-binding protein 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(209879, NULL, 'G3DSA:3.60.15.10:FF:000097', NULL, NULL, 'MBL fold metallo-hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(209880, NULL, 'G3DSA:3.30.420.390:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209881, NULL, 'G3DSA:2.60.40.10:FF:002978', NULL, NULL, 'Thioester-containing protein 2, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(209882, NULL, 'G3DSA:2.40.30.10:FF:000399', NULL, NULL, 'Pyruvate dehydrogenase [NADP(+)], mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(209883, NULL, 'G3DSA:1.20.1070.10:FF:001324', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(209884, NULL, 'G3DSA:3.80.10.10:FF:003878', NULL, NULL, 'NLR family, CARD domain-containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(209885, NULL, 'G3DSA:1.25.40.20:FF:000957', NULL, NULL, 'Transient receptor potential cation channel subfamily V member 1', NULL, NULL, NULL, NULL, NULL, 4),
(209886, NULL, 'G3DSA:3.30.1490.70:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209887, NULL, 'G3DSA:1.10.150.20:FF:000084', NULL, NULL, 'ERCC1 nucleotide excision repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209888, NULL, 'G3DSA:1.10.569.10:FF:000002', NULL, NULL, 'Aldehyde ferredoxin oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(209889, NULL, 'G3DSA:1.20.1070.10:FF:000835', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(209890, NULL, 'G3DSA:3.70.10.10:FF:000113', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(209891, NULL, 'G3DSA:3.40.50.12470:FF:000007', NULL, NULL, '2-oxoglutarate dehydrogenase e1 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(209892, NULL, 'G3DSA:3.40.50.10130:FF:000007', NULL, NULL, 'Probable crossover junction endonuclease EME2', NULL, NULL, NULL, NULL, NULL, 4),
(209893, NULL, 'G3DSA:1.20.1080.10:FF:000072', NULL, NULL, 'Aquaporin TIP4-1', NULL, NULL, NULL, NULL, NULL, 4),
(209894, NULL, 'G3DSA:3.10.290.10:FF:000100', NULL, NULL, '37S ribosomal protein S4-like, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(209895, NULL, 'G3DSA:1.20.1560.10:FF:000209', NULL, NULL, 'ATP-binding cassette sub-family B member 9 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(209896, NULL, 'G3DSA:1.10.510.10:FF:003970', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209897, NULL, 'G3DSA:3.30.160.60:FF:001354', NULL, NULL, 'RB-associated KRAB zinc finger protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(209898, NULL, 'G3DSA:2.60.40.10:FF:001343', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(209899, NULL, 'G3DSA:2.10.90.10:FF:000033', NULL, NULL, 'Muellerian-inhibiting factor', NULL, NULL, NULL, NULL, NULL, 4),
(209900, NULL, 'G3DSA:1.10.238.10:FF:001274', NULL, NULL, 'Uncharacterized calcium-binding protein C800.10c', NULL, NULL, NULL, NULL, NULL, 4),
(209901, NULL, 'G3DSA:3.30.70.1070:FF:000002', NULL, NULL, 'Cell division protein FtsN', NULL, NULL, NULL, NULL, NULL, 4),
(209902, NULL, 'G3DSA:1.10.150.20:FF:000319', NULL, NULL, 'DNA-directed RNA polymerase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(209903, NULL, 'G3DSA:3.30.470.20:FF:000157', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(209904, NULL, 'G3DSA:1.10.630.10:FF:000365', NULL, NULL, 'Probable lanosterol 14-alpha demethylase', NULL, NULL, NULL, NULL, NULL, 4),
(209905, NULL, 'G3DSA:3.60.40.10:FF:000290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209906, NULL, 'G3DSA:2.40.420.20:FF:000021', NULL, NULL, 'AcrA/AcrE family protein', NULL, NULL, NULL, NULL, NULL, 4),
(209907, NULL, 'G3DSA:3.40.50.300:FF:001181', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(209908, NULL, 'G3DSA:2.40.50.90:FF:000148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209909, NULL, 'G3DSA:2.130.10.10:FF:005098', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(209910, NULL, 'G3DSA:3.40.50.300:FF:005396', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209911, NULL, 'G3DSA:1.10.3730.30:FF:000001', NULL, NULL, 'Toxin A', NULL, NULL, NULL, NULL, NULL, 4),
(209912, NULL, 'G3DSA:3.40.30.10:FF:000273', NULL, NULL, 'Glutaredoxin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(209913, NULL, 'G3DSA:2.30.29.30:FF:000155', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase gamma', NULL, NULL, NULL, NULL, NULL, 4),
(209914, NULL, 'G3DSA:3.40.50.1110:FF:000107', NULL, NULL, 'O-antigen acetylase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(209915, NULL, 'G3DSA:3.30.230.10:FF:000373', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209916, NULL, 'G3DSA:3.40.50.150:FF:001321', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209917, NULL, 'G3DSA:3.40.366.10:FF:000045', NULL, NULL, 'Malonyl CoA-acyl carrier protein transacylase', NULL, NULL, NULL, NULL, NULL, 4),
(209918, NULL, 'G3DSA:1.10.10.10:FF:001109', NULL, NULL, 'Transcriptional regulator, BadM/Rrf2 family', NULL, NULL, NULL, NULL, NULL, 4),
(209919, NULL, 'G3DSA:3.30.420.10:FF:000117', NULL, NULL, 'DNA polymerase III polC-type', NULL, NULL, NULL, NULL, NULL, 4),
(209920, NULL, 'G3DSA:3.30.420.10:FF:000174', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(209921, NULL, 'G3DSA:1.10.10.750:FF:000046', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(209922, NULL, 'G3DSA:1.10.1060.10:FF:000022', NULL, NULL, 'CoB--CoM heterodisulfide reductase iron-sulfur subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(209923, NULL, 'G3DSA:2.60.40.10:FF:002006', NULL, NULL, 'Probable fimbrial chaperone YadV', NULL, NULL, NULL, NULL, NULL, 4),
(209924, NULL, 'G3DSA:2.10.80.10:FF:000004', NULL, NULL, 'Prokineticin 1', NULL, NULL, NULL, NULL, NULL, 4),
(209925, NULL, 'G3DSA:1.20.960.10:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209926, NULL, 'G3DSA:2.10.25.10:FF:000017', NULL, NULL, 'latent-transforming growth factor beta-binding protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(209927, NULL, 'G3DSA:3.30.70.330:FF:002831', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209928, NULL, 'G3DSA:3.10.20.90:FF:000112', NULL, NULL, 'TANK binding kinase TBK1', NULL, NULL, NULL, NULL, NULL, 4),
(209929, NULL, 'G3DSA:2.130.10.10:FF:004547', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209930, NULL, 'G3DSA:3.40.50.1100:FF:000104', NULL, NULL, 'Cysteate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(209931, NULL, 'G3DSA:2.10.25.10:FF:001006', NULL, NULL, 'Nimrod C2, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(209932, NULL, 'G3DSA:3.40.50.2300:FF:001234', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209933, NULL, 'G3DSA:2.60.120.10:FF:000103', NULL, NULL, 'Cyclic nucleotide-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(209934, NULL, 'G3DSA:2.30.39.10:FF:000121', NULL, NULL, 'SERPINB5 protein', NULL, NULL, NULL, NULL, NULL, 4),
(209935, NULL, 'G3DSA:1.25.40.10:FF:003242', NULL, NULL, 'Transcription factor TFIIIC subunit', NULL, NULL, NULL, NULL, NULL, 4),
(209936, NULL, 'G3DSA:2.60.120.10:FF:000160', NULL, NULL, 'Cysteine dioxygenase type I', NULL, NULL, NULL, NULL, NULL, 4),
(209937, NULL, 'G3DSA:3.90.105.20:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209938, NULL, 'G3DSA:3.60.70.12:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209939, NULL, 'G3DSA:3.40.190.170:FF:000002', NULL, NULL, 'TRAP transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(209940, NULL, 'G3DSA:3.40.50.1820:FF:000174', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(209941, NULL, 'G3DSA:1.20.1250.20:FF:001982', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209942, NULL, 'G3DSA:3.90.1480.20:FF:000014', NULL, NULL, 'Alpha-N-acetylneuraminide alpha-2,8-sialyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(209943, NULL, 'G3DSA:1.10.287.110:FF:000102', NULL, NULL, 'Molecular chaperone DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(209944, NULL, 'G3DSA:3.40.50.300:FF:002170', NULL, NULL, 'Adenylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(209945, NULL, 'G3DSA:1.20.58.60:FF:000363', NULL, NULL, 'Nesprin-2', NULL, NULL, NULL, NULL, NULL, 4),
(209946, NULL, 'G3DSA:1.10.10.10:FF:001643', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209947, NULL, 'G3DSA:3.40.720.10:FF:000110', NULL, NULL, 'Phosphatidylinositol glycan, class O', NULL, NULL, NULL, NULL, NULL, 4),
(209948, NULL, 'G3DSA:3.40.630.30:FF:000143', NULL, NULL, '[Ribosomal protein S18]-alanine N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(209949, NULL, 'G3DSA:1.25.40.90:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209950, NULL, 'G3DSA:3.60.10.10:FF:000254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209951, NULL, 'G3DSA:1.25.40.70:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209952, NULL, 'G3DSA:2.40.30.330:FF:000003', NULL, NULL, 'mRNA cleavage and polyadenylation factor CLP1', NULL, NULL, NULL, NULL, NULL, 4),
(209953, NULL, 'G3DSA:2.60.120.290:FF:000211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209954, NULL, 'G3DSA:1.20.1070.10:FF:000189', NULL, NULL, 'Histamine H1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(209955, NULL, 'G3DSA:3.80.10.10:FF:000826', NULL, NULL, 'Receptor-like protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(209956, NULL, 'G3DSA:1.10.720.30:FF:000024', NULL, NULL, 'E3 ubiquitin-protein ligase RAD18 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(209957, NULL, 'G3DSA:3.40.50.300:FF:001708', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(209958, NULL, 'G3DSA:2.130.10.10:FF:001321', NULL, NULL, '6-phosphogluconolactonase (Cycloisomerase 2 family)', NULL, NULL, NULL, NULL, NULL, 4),
(209959, NULL, 'G3DSA:3.30.930.10:FF:000139', NULL, NULL, 'O-phosphoserine--tRNA(Cys) ligase', NULL, NULL, NULL, NULL, NULL, 4),
(209960, NULL, 'G3DSA:1.25.40.10:FF:002837', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(209961, NULL, 'G3DSA:3.30.710.10:FF:000421', NULL, NULL, 'Protein CBG06295', NULL, NULL, NULL, NULL, NULL, 4),
(209962, NULL, 'G3DSA:2.60.40.420:FF:000281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209963, NULL, 'G3DSA:3.40.640.10:FF:000486', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(209964, NULL, 'G3DSA:1.20.80.10:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209965, NULL, 'G3DSA:1.20.140.160:FF:000001', NULL, NULL, 'RNA polymerase sigma factor FliA', NULL, NULL, NULL, NULL, NULL, 4),
(209966, NULL, 'G3DSA:2.60.40.10:FF:002332', NULL, NULL, 'Myotactin form A', NULL, NULL, NULL, NULL, NULL, 4),
(209967, NULL, 'G3DSA:1.25.10.10:FF:001228', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(209968, NULL, 'G3DSA:3.40.190.10:FF:000378', NULL, NULL, 'Phosphonate ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(209969, NULL, 'G3DSA:1.10.510.10:FF:003436', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209970, NULL, 'G3DSA:3.30.40.10:FF:000706', NULL, NULL, 'AGAP000533-PA', NULL, NULL, NULL, NULL, NULL, 4),
(209971, NULL, 'G3DSA:2.60.40.10:FF:005766', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209972, NULL, 'G3DSA:1.10.10.2740:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209973, NULL, 'G3DSA:2.10.25.10:FF:000489', NULL, NULL, 'CD248 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(209974, NULL, 'G3DSA:1.25.10.10:FF:003206', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(209975, NULL, 'G3DSA:1.25.40.10:FF:000746', NULL, NULL, 'Zgc:152670', NULL, NULL, NULL, NULL, NULL, 4),
(209976, NULL, 'G3DSA:3.40.50.300:FF:003480', NULL, NULL, 'ATPase, AAA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(209977, NULL, 'G3DSA:2.60.120.970:FF:000022', NULL, NULL, 'Inhibin subunit beta C', NULL, NULL, NULL, NULL, NULL, 4),
(209978, NULL, 'G3DSA:2.30.280.10:FF:000003', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-9 specific SUVH5', NULL, NULL, NULL, NULL, NULL, 4),
(209979, NULL, 'G3DSA:2.60.40.2610:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209980, NULL, 'G3DSA:2.30.30.140:FF:000027', NULL, NULL, 'putative oxidoreductase GLYR1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(209981, NULL, 'G3DSA:3.30.160.60:FF:005154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209982, NULL, 'G3DSA:1.25.40.20:FF:000749', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(209983, NULL, 'G3DSA:3.40.50.150:FF:001736', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209984, NULL, 'G3DSA:3.40.1160.10:FF:000105', NULL, NULL, 'Isopentenyl phosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(209985, NULL, 'G3DSA:3.40.50.2000:FF:000099', NULL, NULL, 'Alpha,alpha-trehalose phosphate synthase subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(209986, NULL, 'G3DSA:1.10.287.10:FF:000004', NULL, NULL, 'bifunctional glutamate/proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(209987, NULL, 'G3DSA:1.10.1670.10:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209988, NULL, 'G3DSA:3.40.50.150:FF:001793', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209989, NULL, 'G3DSA:1.20.1280.170:FF:000014', NULL, NULL, 'Exocyst subunit Exo70 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(209990, NULL, 'G3DSA:1.25.40.20:FF:001800', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(209991, NULL, 'G3DSA:1.20.1270.60:FF:000163', NULL, NULL, 'AGAP009727-PA', NULL, NULL, NULL, NULL, NULL, 4),
(209992, NULL, 'G3DSA:3.40.50.410:FF:000140', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(209993, NULL, 'G3DSA:3.30.980.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209994, NULL, 'G3DSA:4.10.1220.10:FF:000004', NULL, NULL, 'Low density lipoprotein receptor-related protein 1Bb', NULL, NULL, NULL, NULL, NULL, 4),
(209995, NULL, 'G3DSA:3.40.470.10:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209996, NULL, 'G3DSA:3.30.519.10:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(209997, NULL, 'G3DSA:3.30.750.24:FF:000173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(209998, NULL, 'G3DSA:1.25.10.10:FF:002897', NULL, NULL, 'Ipo7 protein', NULL, NULL, NULL, NULL, NULL, 4),
(209999, NULL, 'G3DSA:1.20.1740.10:FF:000162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210000, NULL, 'G3DSA:2.60.40.3710:FF:000001', NULL, NULL, 'L,D-transpeptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(210001, NULL, 'G3DSA:3.100.10.10:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210002, NULL, 'G3DSA:3.40.50.10190:FF:000126', NULL, NULL, 'Epithelial cell-transforming 2', NULL, NULL, NULL, NULL, NULL, 4),
(210003, NULL, 'G3DSA:1.10.10.10:FF:000828', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(210004, NULL, 'G3DSA:2.130.10.10:FF:004755', NULL, NULL, 'Protein HIRA homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(210005, NULL, 'G3DSA:3.40.50.300:FF:008004', NULL, NULL, 'MutS homolog1', NULL, NULL, NULL, NULL, NULL, 4),
(210006, NULL, 'G3DSA:3.40.50.10050:FF:000017', NULL, NULL, 'Translation initiation factor IF-2, mitochondrial-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(210007, NULL, 'G3DSA:3.30.70.330:FF:002567', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210008, NULL, 'G3DSA:3.20.20.140:FF:000361', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(210009, NULL, 'G3DSA:1.10.10.60:FF:001310', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210010, NULL, 'G3DSA:1.10.10.41:FF:000001', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(210011, NULL, 'G3DSA:2.160.20.10:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210012, NULL, 'G3DSA:3.20.20.140:FF:000243', NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(210013, NULL, 'G3DSA:3.80.10.10:FF:003906', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210014, NULL, 'G3DSA:3.80.10.10:FF:001107', NULL, NULL, 'Leucine rich repeats and immunoglobulin like domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(210015, NULL, 'G3DSA:3.30.160.60:FF:001028', NULL, NULL, 'hypermethylated in cancer 2 protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(210016, NULL, 'G3DSA:1.10.1200.10:FF:000056', NULL, NULL, 'Membrane bound polyketide synthase Pks6', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(210017, NULL, 'G3DSA:2.60.40.10:FF:003760', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210018, NULL, 'G3DSA:3.40.50.10380:FF:000032', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(210019, NULL, 'G3DSA:1.10.630.10:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210020, NULL, 'G3DSA:3.30.1050.10:FF:000049', NULL, NULL, 'Alkyl sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(210021, NULL, 'G3DSA:3.40.50.450:FF:000101', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(210022, NULL, 'G3DSA:1.10.510.10:FF:001671', NULL, NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', NULL, NULL, NULL, NULL, NULL, 4),
(210023, NULL, 'G3DSA:2.60.40.10:FF:003642', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210024, NULL, 'G3DSA:2.60.40.420:FF:000129', NULL, NULL, 'GD21245', NULL, NULL, NULL, NULL, NULL, 4),
(210025, NULL, 'G3DSA:2.60.40.10:FF:004777', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210026, NULL, 'G3DSA:2.10.25.10:FF:000074', NULL, NULL, 'Laminin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(210027, NULL, 'G3DSA:3.40.50.1820:FF:001601', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210028, NULL, 'G3DSA:2.60.120.200:FF:000286', NULL, NULL, 'Basement membrane proteoglycan', NULL, NULL, NULL, NULL, NULL, 4),
(210029, NULL, 'G3DSA:3.30.160.60:FF:000949', NULL, NULL, 'zinc finger homeobox protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(210030, NULL, 'G3DSA:1.25.40.10:FF:005097', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(210031, NULL, 'G3DSA:3.20.20.80:FF:000378', NULL, NULL, 'Alpha-amylase', NULL, NULL, NULL, NULL, NULL, 4),
(210032, NULL, 'G3DSA:3.50.50.60:FF:001351', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(210033, NULL, 'G3DSA:3.40.50.720:FF:000435', NULL, NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(210034, NULL, 'G3DSA:3.40.630.10:FF:000457', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210035, NULL, 'G3DSA:1.20.1070.10:FF:002134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210036, NULL, 'G3DSA:1.25.10.10:FF:000918', NULL, NULL, 'Testis-expressed protein 10 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(210037, NULL, 'G3DSA:1.10.8.10:FF:000142', NULL, NULL, 'Tyrosyl-DNA phosphodiesterase 2', NULL, NULL, NULL, NULL, NULL, 4),
(210038, NULL, 'G3DSA:3.30.200.20:FF:000548', NULL, NULL, 'Z-DNA binding protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(210039, NULL, 'G3DSA:3.30.200.20:FF:002257', NULL, NULL, 'Protein kinase byr1', NULL, NULL, NULL, NULL, NULL, 4),
(210040, NULL, 'G3DSA:3.40.50.720:FF:002526', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(210041, NULL, 'G3DSA:2.60.40.10:FF:001551', NULL, NULL, 'Jitterbug, isoform M', NULL, NULL, NULL, NULL, NULL, 4),
(210042, NULL, 'G3DSA:1.20.1740.10:FF:000100', NULL, NULL, 'Cationic amino acid transport integral membrane protein RocE', NULL, NULL, NULL, NULL, NULL, 4),
(210043, NULL, 'G3DSA:3.40.1190.20:FF:000144', NULL, NULL, 'Ribokinase', NULL, NULL, NULL, NULL, NULL, 4),
(210044, NULL, 'G3DSA:1.20.1250.20:FF:002235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210045, NULL, 'G3DSA:1.25.10.10:FF:003061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210046, NULL, 'G3DSA:1.20.1250.20:FF:002292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210047, NULL, 'G3DSA:3.30.559.10:FF:000175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210048, NULL, 'G3DSA:1.10.3080.10:FF:000052', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(210049, NULL, 'G3DSA:3.20.20.10:FF:000054', NULL, NULL, 'Probable diaminopimelate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(210050, NULL, 'G3DSA:3.40.190.10:FF:000850', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(210051, NULL, 'G3DSA:1.10.1270.10:FF:000004', NULL, NULL, 'Trp operon repressor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(210052, NULL, 'G3DSA:1.25.40.10:FF:001056', NULL, NULL, 'Anaphase-promoting complex subunit CDC27', NULL, NULL, NULL, NULL, NULL, 4),
(210053, NULL, 'G3DSA:3.40.50.10090:FF:000035', NULL, NULL, 'Uroporphyrinogen III synthase HEM4', NULL, NULL, NULL, NULL, NULL, 4),
(210054, NULL, 'G3DSA:1.50.10.10:FF:000034', NULL, NULL, 'Trehalase', NULL, NULL, NULL, NULL, NULL, 4),
(210055, NULL, 'G3DSA:2.70.98.10:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210056, NULL, 'G3DSA:2.130.10.10:FF:003119', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210057, NULL, 'G3DSA:1.20.920.10:FF:000121', NULL, NULL, 'Bromodomain factor 2 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210058, NULL, 'G3DSA:3.30.420.10:FF:000410', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210059, NULL, 'G3DSA:1.50.10.20:FF:000037', NULL, NULL, 'Terpene synthase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(210060, NULL, 'G3DSA:1.10.3890.10:FF:000001', NULL, NULL, 'High frequency lysogenization protein HflD homolog', NULL, NULL, NULL, NULL, NULL, 4),
(210061, NULL, 'G3DSA:3.30.710.10:FF:000157', NULL, NULL, 'Potassium channel', NULL, NULL, NULL, NULL, NULL, 4),
(210062, NULL, 'G3DSA:1.20.1250.10:FF:000080', NULL, NULL, 'Interferon gamma', NULL, NULL, NULL, NULL, NULL, 4),
(210063, NULL, 'G3DSA:3.40.50.10490:FF:000126', NULL, NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing] 1', NULL, NULL, NULL, NULL, NULL, 4),
(210064, NULL, 'G3DSA:2.130.10.10:FF:005362', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210065, NULL, 'G3DSA:3.30.1490.20:FF:000107', NULL, NULL, 'ATP-grasp enzyme-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(210066, NULL, 'G3DSA:1.10.287.70:FF:000354', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(210067, NULL, 'G3DSA:1.20.1250.20:FF:000083', NULL, NULL, 'synaptic vesicular amine transporter isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(210068, NULL, 'G3DSA:3.30.160.60:FF:005800', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210069, NULL, 'G3DSA:3.30.200.20:FF:000666', NULL, NULL, 'Kinase family with leucine-rich repeat domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(210070, NULL, 'G3DSA:2.60.40.4100:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210071, NULL, 'G3DSA:1.25.10.10:FF:002043', NULL, NULL, 'Cytoskeleton-associated protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(210072, NULL, 'G3DSA:1.20.990.10:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210073, NULL, 'G3DSA:2.40.30.30:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210074, NULL, 'G3DSA:3.20.20.80:FF:000114', NULL, NULL, 'Cell wall alpha-1,3-glucan synthase ags1', NULL, NULL, NULL, NULL, NULL, 4),
(210075, NULL, 'G3DSA:2.20.100.10:FF:000038', NULL, NULL, 'CYR61 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(210076, NULL, 'G3DSA:1.10.220.30:FF:000031', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(210077, NULL, 'G3DSA:3.40.50.10190:FF:000183', NULL, NULL, 'Cleavage and polyadenylation factor 6-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(210078, NULL, 'G3DSA:2.40.30.20:FF:000025', NULL, NULL, 'Riboflavin synthase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(210079, NULL, 'G3DSA:3.20.20.70:FF:000111', NULL, NULL, 'Fructose-1,6-bisphosphate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(210080, NULL, 'G3DSA:3.40.50.300:FF:003951', NULL, NULL, 'Succinoglycan biosynthesis transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(210081, NULL, 'G3DSA:3.30.160.60:FF:002017', NULL, NULL, 'Zinc finger protein 599', NULL, NULL, NULL, NULL, NULL, 4),
(210082, NULL, 'G3DSA:3.60.40.10:FF:000109', NULL, NULL, 'Protein phosphatase PPM9', NULL, NULL, NULL, NULL, NULL, 4),
(210083, NULL, 'G3DSA:1.10.238.10:FF:001212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(210084, NULL, 'G3DSA:3.80.10.10:FF:001872', NULL, NULL, 'NLR family CARD domain-containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(210085, NULL, 'G3DSA:2.60.40.10:FF:004895', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210086, NULL, 'G3DSA:1.50.10.150:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210087, NULL, 'G3DSA:2.30.29.30:FF:000508', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(210088, NULL, 'G3DSA:3.40.50.12370:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210089, NULL, 'G3DSA:1.10.10.160:FF:000021', NULL, NULL, 'PROBABLE ATP-DEPENDENT DNA HELICASE', NULL, NULL, NULL, NULL, NULL, 4),
(210090, NULL, 'G3DSA:2.60.120.200:FF:000550', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(210091, NULL, 'G3DSA:2.60.40.2860:FF:000004', NULL, NULL, 'Transmission-blocking target antigen S230', NULL, NULL, NULL, NULL, NULL, 4),
(210092, NULL, 'G3DSA:1.10.238.110:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210093, NULL, 'G3DSA:2.60.40.10:FF:003349', NULL, NULL, 'Beta-glucosidase (Gentiobiase)', NULL, NULL, NULL, NULL, NULL, 4),
(210094, NULL, 'G3DSA:3.40.50.300:FF:003187', NULL, NULL, 'DEAD box helicase involved in nonsense mediated decay, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210095, NULL, 'G3DSA:1.25.10.10:FF:001823', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210096, NULL, 'G3DSA:1.10.533.10:FF:000015', NULL, NULL, 'Caspase recruitment domain-containing protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(210097, NULL, 'G3DSA:3.40.50.1820:FF:001101', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(210098, NULL, 'G3DSA:3.40.50.360:FF:000164', NULL, NULL, 'Methionine synthase reductase, mitochondrial-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(210099, NULL, 'G3DSA:3.10.50.40:FF:000003', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(210100, NULL, 'G3DSA:3.30.160.60:FF:001764', NULL, NULL, 'zinc finger protein 454 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(210101, NULL, 'G3DSA:3.30.70.2490:FF:000001', NULL, NULL, 'Fatty acid synthase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(210102, NULL, 'G3DSA:3.20.80.10:FF:000030', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(210103, NULL, 'G3DSA:3.30.70.270:FF:000317', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210104, NULL, 'G3DSA:3.30.70.330:FF:002713', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210105, NULL, 'G3DSA:1.25.40.20:FF:001564', NULL, NULL, 'Sex-determining protein fem-1', NULL, NULL, NULL, NULL, NULL, 4),
(210106, NULL, 'G3DSA:2.60.40.10:FF:003703', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210107, NULL, 'G3DSA:3.60.15.10:FF:000158', NULL, NULL, 'MBL fold metallo-hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(210108, NULL, 'G3DSA:3.40.50.720:FF:000935', NULL, NULL, 'HesA/MoeB/ThiF family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210109, NULL, 'G3DSA:3.40.50.1260:FF:000045', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(210110, NULL, 'G3DSA:3.30.70.2740:FF:000008', NULL, NULL, 'Probable dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(210111, NULL, 'G3DSA:1.20.1260.10:FF:000018', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(210112, NULL, 'G3DSA:3.10.129.10:FF:000136', NULL, NULL, 'Thioesterase superfamily, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210113, NULL, 'G3DSA:3.60.130.10:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210114, NULL, 'G3DSA:3.30.160.60:FF:002989', NULL, NULL, 'GH20378p', NULL, NULL, NULL, NULL, NULL, 4),
(210115, NULL, 'G3DSA:3.20.20.80:FF:000586', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210116, NULL, 'G3DSA:3.40.570.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210117, NULL, 'G3DSA:1.10.510.10:FF:000856', NULL, NULL, 'eIF-2-alpha kinase GCN2', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(210118, NULL, 'G3DSA:1.20.5.100:FF:000025', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(210119, NULL, 'G3DSA:2.10.25.10:FF:000282', NULL, NULL, 'Crumbs cell polarity complex component 2', NULL, NULL, NULL, NULL, NULL, 4),
(210120, NULL, 'G3DSA:3.20.20.140:FF:000304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210121, NULL, 'G3DSA:2.130.10.10:FF:003619', NULL, NULL, 'Uncharacterized WD repeat-containing protein C3D6.12', NULL, NULL, NULL, NULL, NULL, 4),
(210122, NULL, 'G3DSA:3.40.50.1000:FF:000838', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210123, NULL, 'G3DSA:3.30.450.20:FF:000566', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(210124, NULL, 'G3DSA:1.10.3210.10:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210125, NULL, 'G3DSA:3.40.50.300:FF:003541', NULL, NULL, 'RAB39A, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(210126, NULL, 'G3DSA:3.40.50.10220:FF:000001', NULL, NULL, 'DNA polymerase III subunit psi', NULL, NULL, NULL, NULL, NULL, 4),
(210127, NULL, 'G3DSA:3.30.160.60:FF:005036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210128, NULL, 'G3DSA:3.30.40.10:FF:001050', NULL, NULL, 'Receptor homology region, transmembrane domain- and RING domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(210129, NULL, 'G3DSA:3.10.100.10:FF:000289', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210130, NULL, 'G3DSA:2.30.42.10:FF:000382', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210131, NULL, 'G3DSA:3.30.160.60:FF:005507', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210132, NULL, 'G3DSA:1.10.260.30:FF:000005', NULL, NULL, 'Signal recognition particle 54 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(210133, NULL, 'G3DSA:1.10.8.60:FF:000050', NULL, NULL, 'Psp operon transcriptional activator', NULL, NULL, NULL, NULL, NULL, 4),
(210134, NULL, 'G3DSA:3.40.605.10:FF:000005', NULL, NULL, 'Succinate-semialdehyde dehydrogenase I', NULL, NULL, NULL, NULL, NULL, 4),
(210135, NULL, 'G3DSA:1.25.10.10:FF:001880', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210136, NULL, 'G3DSA:3.40.50.300:FF:002052', NULL, NULL, 'DNA repair protein RAD51 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(210137, NULL, 'G3DSA:1.20.1250.10:FF:000046', NULL, NULL, 'Interferon alpha', NULL, NULL, NULL, NULL, NULL, 4),
(210138, NULL, 'G3DSA:2.130.10.10:FF:005570', NULL, NULL, 'Myosin heavy chain kinase D', NULL, NULL, NULL, NULL, NULL, 4),
(210139, NULL, 'G3DSA:1.20.5.210:FF:000002', NULL, NULL, 'BnaA01g31400D protein', NULL, NULL, NULL, NULL, NULL, 4),
(210140, NULL, 'G3DSA:2.60.40.10:FF:001904', NULL, NULL, 'Uncharacterized protein YeeJ', NULL, NULL, NULL, NULL, NULL, 4),
(210141, NULL, 'G3DSA:1.25.40.860:FF:000018', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(210142, NULL, 'G3DSA:2.130.10.10:FF:001057', NULL, NULL, 'Nuclear pore complex subunit Nup133, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210143, NULL, 'G3DSA:3.40.50.150:FF:001057', NULL, NULL, 'Methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(210144, NULL, 'G3DSA:2.10.220.10:FF:000010', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(210145, NULL, 'G3DSA:1.25.40.770:FF:000025', NULL, NULL, 'LD25013p', NULL, NULL, NULL, NULL, NULL, 4),
(210146, NULL, 'G3DSA:1.20.5.170:FF:000181', NULL, NULL, 'C-type lectin domain family 4 member F', NULL, NULL, NULL, NULL, NULL, 4),
(210147, NULL, 'G3DSA:1.20.1560.10:FF:000917', NULL, NULL, 'ABC transporter B family member 27', NULL, NULL, NULL, NULL, NULL, 4),
(210148, NULL, 'G3DSA:1.20.5.110:FF:000270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210149, NULL, 'G3DSA:1.50.10.10:FF:000242', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(210150, NULL, 'G3DSA:3.40.50.2300:FF:000419', NULL, NULL, 'Ethanolamine two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(210151, NULL, 'G3DSA:1.10.630.10:FF:000718', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210152, NULL, 'G3DSA:3.40.50.2000:FF:001026', NULL, NULL, 'UDP-GlucuronosylTransferase', NULL, NULL, NULL, NULL, NULL, 4),
(210153, NULL, 'G3DSA:1.20.1050.10:FF:000126', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(210154, NULL, 'G3DSA:3.40.50.300:FF:004204', NULL, NULL, 'Multidrug resistance protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210155, NULL, 'G3DSA:1.25.40.10:FF:001090', NULL, NULL, 'CTR9 homolog, Paf1/RNA polymerase II complex component', NULL, NULL, NULL, NULL, NULL, 4),
(210156, NULL, 'G3DSA:2.130.10.10:FF:005418', NULL, NULL, 'IRE protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(210157, NULL, 'G3DSA:3.30.40.10:FF:000645', NULL, NULL, 'Dual specificity phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(210158, NULL, 'G3DSA:1.20.5.110:FF:000028', NULL, NULL, '25.3 kDa vesicle transport protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(210159, NULL, 'G3DSA:3.90.190.10:FF:000535', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(210160, NULL, 'G3DSA:1.25.40.20:FF:001654', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(210161, NULL, 'G3DSA:1.20.1250.20:FF:000554', NULL, NULL, 'YALI0D20064p', NULL, NULL, NULL, NULL, NULL, 4),
(210162, NULL, 'G3DSA:3.40.50.620:FF:000585', NULL, NULL, 'Asparagine synthetase [glutamine-hydrolyzing] 1', NULL, NULL, NULL, NULL, NULL, 4),
(210163, NULL, 'G3DSA:1.10.510.10:FF:003318', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210164, NULL, 'G3DSA:3.30.1010.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210165, NULL, 'G3DSA:3.10.100.10:FF:000379', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210166, NULL, 'G3DSA:3.30.70.330:FF:002359', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210167, NULL, 'G3DSA:1.10.390.10:FF:000003', NULL, NULL, 'Leukotriene A(4) hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(210168, NULL, 'G3DSA:3.80.10.10:FF:000944', NULL, NULL, 'Leucine Rich Repeat family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(210169, NULL, 'G3DSA:1.10.287.380:FF:000020', NULL, NULL, 'ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(210170, NULL, 'G3DSA:1.10.10.60:FF:001046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210171, NULL, 'G3DSA:2.30.29.30:FF:000716', NULL, NULL, 'Integrin beta-1-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(210172, NULL, 'G3DSA:3.30.70.870:FF:000048', NULL, NULL, 'Elongation factor Tu GTP binding domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(210173, NULL, 'G3DSA:2.60.120.920:FF:000001', NULL, NULL, 'neuralized-like protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(210174, NULL, 'G3DSA:1.20.1070.10:FF:001116', NULL, NULL, 'Beta-2 adrenergic receptor', NULL, NULL, NULL, NULL, NULL, 4),
(210175, NULL, 'G3DSA:3.50.30.30:FF:000054', NULL, NULL, 'Peptide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(210176, NULL, 'G3DSA:1.25.40.10:FF:003860', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(210177, NULL, 'G3DSA:1.20.1270.60:FF:000106', NULL, NULL, 'Atg20p', NULL, NULL, NULL, NULL, NULL, 4),
(210178, NULL, 'G3DSA:1.10.8.280:FF:000002', NULL, NULL, 'UvrABC system protein A', NULL, NULL, NULL, NULL, NULL, 4),
(210179, NULL, 'G3DSA:1.25.40.10:FF:001409', NULL, NULL, 'Kinesin light chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(210180, NULL, 'G3DSA:1.25.40.570:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210181, NULL, 'G3DSA:1.20.58.60:FF:000834', NULL, NULL, 'Spectrin repeat containing nuclear envelope protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(210182, NULL, 'G3DSA:1.20.1070.10:FF:000953', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(210183, NULL, 'G3DSA:3.30.70.330:FF:002977', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210184, NULL, 'G3DSA:2.40.40.20:FF:000054', NULL, NULL, 'Molybdopterin oxidoreductase Fe4S4 region', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(210185, NULL, 'G3DSA:1.10.555.10:FF:000206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210186, NULL, 'G3DSA:2.60.120.200:FF:000640', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210187, NULL, 'G3DSA:2.60.40.1730:FF:000025', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(210188, NULL, 'G3DSA:1.25.10.10:FF:003471', NULL, NULL, 'Importin subunit alpha-6', NULL, NULL, NULL, NULL, NULL, 4),
(210189, NULL, 'G3DSA:3.30.200.20:FF:001329', NULL, NULL, 'Os11g0691100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(210190, NULL, 'G3DSA:3.40.250.10:FF:000175', NULL, NULL, 'Rhodanese-like domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210191, NULL, 'G3DSA:3.40.50.300:FF:000461', NULL, NULL, 'Deoxycytidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(210192, NULL, 'G3DSA:3.80.10.10:FF:000383', NULL, NULL, 'Leucine-rich repeat receptor protein kinase EMS1', NULL, NULL, NULL, NULL, NULL, 4),
(210193, NULL, 'G3DSA:1.25.40.420:FF:000061', NULL, NULL, 'GCL (Drosophila Germ Cell-Less) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(210194, NULL, 'G3DSA:1.10.150.50:FF:000126', NULL, NULL, 'Zmp:0000000735', NULL, NULL, NULL, NULL, NULL, 4),
(210195, NULL, 'G3DSA:3.30.70.660:FF:000075', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(210196, NULL, 'G3DSA:1.10.510.10:FF:003470', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210197, NULL, 'G3DSA:3.40.50.1010:FF:000111', NULL, NULL, 'Exonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(210198, NULL, 'G3DSA:1.20.1070.10:FF:001881', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210199, NULL, 'G3DSA:1.10.287.2620:FF:000024', NULL, NULL, 'Dynein heavy chain 9', NULL, NULL, NULL, NULL, NULL, 4),
(210200, NULL, 'G3DSA:3.30.2230.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210201, NULL, 'G3DSA:1.10.150.110:FF:000024', NULL, NULL, 'Mus-81', NULL, NULL, NULL, NULL, NULL, 4),
(210202, NULL, 'G3DSA:3.40.50.20:FF:000013', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(210203, NULL, 'G3DSA:1.25.40.10:FF:001651', NULL, NULL, 'Tetratricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(210204, NULL, 'G3DSA:3.40.50.300:FF:007902', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210205, NULL, 'G3DSA:2.60.120.260:FF:000197', NULL, NULL, 'Alpha-L-fucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(210206, NULL, 'G3DSA:3.90.650.10:FF:000054', NULL, NULL, 'NiFe hydrogenase accessory/formation protein HypE', NULL, NULL, NULL, NULL, NULL, 4),
(210207, NULL, 'G3DSA:3.20.20.190:FF:000151', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210208, NULL, 'G3DSA:1.20.900.10:FF:000029', NULL, NULL, 'Rho guanine nucleotide exchange factor 37', NULL, NULL, NULL, NULL, NULL, 4),
(210209, NULL, 'G3DSA:3.30.160.60:FF:001854', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(210210, NULL, 'G3DSA:3.80.10.10:FF:004126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210211, NULL, 'G3DSA:3.30.2290.10:FF:000005', NULL, NULL, 'Peptidase U62 modulator of DNA gyrase', NULL, NULL, NULL, NULL, NULL, 4),
(210212, NULL, 'G3DSA:1.20.1540.10:FF:000091', NULL, NULL, 'Rhomboid protease GluP', NULL, NULL, NULL, NULL, NULL, 4),
(210213, NULL, 'G3DSA:3.30.230.10:FF:000339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210214, NULL, 'G3DSA:1.10.418.80:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210215, NULL, 'G3DSA:3.30.70.100:FF:000019', NULL, NULL, 'Protein NipSnap homolog 3A', NULL, NULL, NULL, NULL, NULL, 4),
(210216, NULL, 'G3DSA:3.40.850.10:FF:000322', NULL, NULL, 'Kinesin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210217, NULL, 'G3DSA:2.60.40.10:FF:005351', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210218, NULL, 'G3DSA:1.50.40.10:FF:000070', NULL, NULL, 'Mitochondrial phosphate carrier protein 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(210219, NULL, 'G3DSA:2.60.40.10:FF:001197', NULL, NULL, 'tyrosine-protein phosphatase Lar isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(210220, NULL, 'G3DSA:3.40.50.720:FF:001340', NULL, NULL, '3-oxoacyl-[acyl-carrier protein] reductase', NULL, NULL, NULL, NULL, NULL, 4),
(210221, NULL, 'G3DSA:3.30.60.90:FF:000041', NULL, NULL, 'E3 ubiquitin-protein ligase Zswim2', NULL, NULL, NULL, NULL, NULL, 4),
(210222, NULL, 'G3DSA:3.10.590.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210223, NULL, 'G3DSA:1.10.287.470:FF:000013', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(210224, NULL, 'G3DSA:2.60.120.290:FF:000150', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(210225, NULL, 'G3DSA:3.40.50.2000:FF:000829', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210226, NULL, 'G3DSA:1.10.3500.10:FF:000006', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(210227, NULL, 'G3DSA:3.30.70.330:FF:000768', NULL, NULL, 'Polyadenylate-binding protein RBP47C isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(210228, NULL, 'G3DSA:1.20.910.10:FF:000002', NULL, NULL, 'Aminopyrimidine aminohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(210229, NULL, 'G3DSA:2.130.10.10:FF:001821', NULL, NULL, 'SEC31 homolog A, COPII coat complex component', NULL, NULL, NULL, NULL, NULL, 4),
(210230, NULL, 'G3DSA:4.10.60.10:FF:000156', NULL, NULL, 'Replication protein A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(210231, NULL, 'G3DSA:1.10.10.10:FF:001609', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210232, NULL, 'G3DSA:3.30.160.60:FF:005654', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210233, NULL, 'G3DSA:4.10.280.10:FF:000146', NULL, NULL, 'Transcription factor bHLH162', NULL, NULL, NULL, NULL, NULL, 4),
(210234, NULL, 'G3DSA:1.10.2000.10:FF:000075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210235, NULL, 'G3DSA:2.170.300.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210236, NULL, 'G3DSA:1.10.3090.10:FF:000024', NULL, NULL, 'tRNA nucleotidyltransferase, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210237, NULL, 'G3DSA:1.25.10.10:FF:003414', NULL, NULL, 'Ecm29p', NULL, NULL, NULL, NULL, NULL, 4),
(210238, NULL, 'G3DSA:1.10.10.60:FF:000793', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210239, NULL, 'G3DSA:3.80.10.10:FF:000326', NULL, NULL, 'Protein phosphatase 1 regulatory inhibitor subunit PPP1R7 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(210240, NULL, 'G3DSA:3.30.160.60:FF:000011', NULL, NULL, 'zinc finger protein 615 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(210241, NULL, 'G3DSA:3.30.930.10:FF:000140', NULL, NULL, 'Octanoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(210242, NULL, 'G3DSA:3.30.160.60:FF:001293', NULL, NULL, 'Zinc finger protein 292', NULL, NULL, NULL, NULL, NULL, 4),
(210243, NULL, 'G3DSA:1.20.5.110:FF:000180', NULL, NULL, 'Putative QA-SNARE protein', NULL, NULL, NULL, NULL, NULL, 4),
(210244, NULL, 'G3DSA:2.30.40.10:FF:000158', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(210245, NULL, 'G3DSA:2.130.10.10:FF:002956', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210246, NULL, 'G3DSA:3.30.460.10:FF:000182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210247, NULL, 'G3DSA:3.40.50.300:FF:007341', NULL, NULL, 'UvrD/REP helicase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(210248, NULL, 'G3DSA:3.30.160.60:FF:003445', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210249, NULL, 'G3DSA:3.30.56.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210250, NULL, 'G3DSA:1.20.1560.10:FF:000356', NULL, NULL, 'HAlF transporter (PGP related)', NULL, NULL, NULL, NULL, NULL, 4),
(210251, NULL, 'G3DSA:3.30.930.10:FF:000347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(210252, NULL, 'G3DSA:2.40.50.110:FF:000003', NULL, NULL, 'Subtilase SubB', NULL, NULL, NULL, NULL, NULL, 4),
(210253, NULL, 'G3DSA:2.30.30.140:FF:000061', NULL, NULL, 'SAGA-associated factor 29 isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(210254, NULL, 'G3DSA:1.20.58.120:FF:000008', NULL, NULL, 'BAG family molecular chaperone regulator 5', NULL, NULL, NULL, NULL, NULL, 4),
(210255, NULL, 'G3DSA:1.10.238.10:FF:001066', NULL, NULL, 'Myosin, essential light chain', NULL, NULL, NULL, NULL, NULL, 4),
(210256, NULL, 'G3DSA:1.20.5.170:FF:000029', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(210257, NULL, 'G3DSA:3.80.10.10:FF:002535', NULL, NULL, 'Geranylgeranyl transferase type-2 subunit alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(210258, NULL, 'G3DSA:1.10.472.10:FF:000699', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210259, NULL, 'G3DSA:2.30.30.490:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210260, NULL, 'G3DSA:4.10.81.10:FF:000002', NULL, NULL, 'cytochrome c oxidase subunit 8C, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(210261, NULL, 'G3DSA:3.90.320.10:FF:000035', NULL, NULL, 'YALI0A09680p', NULL, NULL, NULL, NULL, NULL, 4),
(210262, NULL, 'G3DSA:3.40.30.10:FF:000155', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(210263, NULL, 'G3DSA:3.40.190.80:FF:000033', NULL, NULL, 'Si:ch211-160o17.2', NULL, NULL, NULL, NULL, NULL, 4),
(210264, NULL, 'G3DSA:1.25.10.10:FF:001262', NULL, NULL, 'HEAT repeat-containing protein 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(210265, NULL, 'G3DSA:3.30.200.20:FF:000812', NULL, NULL, 'Scy1p', NULL, NULL, NULL, NULL, NULL, 4),
(210266, NULL, 'G3DSA:3.60.20.10:FF:000081', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(210267, NULL, 'G3DSA:1.20.90.10:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210268, NULL, 'G3DSA:1.20.120.1650:FF:000001', NULL, NULL, 'Rif2p', NULL, NULL, NULL, NULL, NULL, 4),
(210269, NULL, 'G3DSA:1.10.510.10:FF:001727', NULL, NULL, 'Tyrosine-protein kinase receptor svh-2', NULL, NULL, NULL, NULL, NULL, 4),
(210270, NULL, 'G3DSA:1.10.287.130:FF:000142', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(210271, NULL, 'G3DSA:2.60.40.10:FF:005558', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210272, NULL, 'G3DSA:1.10.10.10:FF:001048', NULL, NULL, 'Glycerol-3-phosphate regulon repressor', NULL, NULL, NULL, NULL, NULL, 4),
(210273, NULL, 'G3DSA:3.40.960.10:FF:000004', NULL, NULL, 'Cullin, a subunit of E3 ubiquitin ligase', NULL, NULL, NULL, NULL, NULL, 4),
(210274, NULL, 'G3DSA:3.40.50.2000:FF:000453', NULL, NULL, 'Lipopolysaccharide heptosyltransferase I', NULL, NULL, NULL, NULL, NULL, 4),
(210275, NULL, 'G3DSA:1.20.58.110:FF:000005', NULL, NULL, '30S ribosomal protein S20', NULL, NULL, NULL, NULL, NULL, 4),
(210276, NULL, 'G3DSA:1.20.58.100:FF:000002', NULL, NULL, 'L-aspartate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(210277, NULL, 'G3DSA:3.40.190.10:FF:000586', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(210278, NULL, 'G3DSA:3.40.50.150:FF:001528', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210279, NULL, 'G3DSA:2.40.50.120:FF:000006', NULL, NULL, 'Secreted frizzled-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(210280, NULL, 'G3DSA:1.10.10.10:FF:001290', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(210281, NULL, 'G3DSA:2.40.50.120:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210282, NULL, 'G3DSA:4.10.1000.10:FF:000078', NULL, NULL, 'Zinc finger protein family member, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210283, NULL, 'G3DSA:1.10.510.10:FF:001019', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase B120', NULL, NULL, NULL, NULL, NULL, 4),
(210284, NULL, 'G3DSA:2.60.40.650:FF:000001', NULL, NULL, 'Nitrate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(210285, NULL, 'G3DSA:3.30.9.10:FF:000117', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(210286, NULL, 'G3DSA:1.20.1420.10:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210287, NULL, 'G3DSA:2.30.29.30:FF:000924', NULL, NULL, 'RAB GTPase-activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210288, NULL, 'G3DSA:3.90.70.10:FF:000402', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 5', NULL, NULL, NULL, NULL, NULL, 4),
(210289, NULL, 'G3DSA:3.40.50.10330:FF:000034', NULL, NULL, 'Mitochondrial NADH kinase', NULL, NULL, NULL, NULL, NULL, 4),
(210290, NULL, 'G3DSA:2.60.40.3770:FF:000002', NULL, NULL, 'Envelopment polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(210291, NULL, 'G3DSA:3.30.160.60:FF:004783', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210292, NULL, 'G3DSA:3.90.810.10:FF:000027', NULL, NULL, 'Serine/threonine-protein kinase PAK 1', NULL, NULL, NULL, NULL, NULL, 4),
(210293, NULL, 'G3DSA:3.40.50.720:FF:000525', NULL, NULL, '3-keto-steroid reductase', NULL, NULL, NULL, NULL, NULL, 4),
(210294, NULL, 'G3DSA:1.20.1270.10:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210295, NULL, 'G3DSA:1.20.1720.10:FF:000127', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210296, NULL, 'G3DSA:3.30.200.20:FF:001245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210297, NULL, 'G3DSA:2.160.20.10:FF:000269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210298, NULL, 'G3DSA:3.40.20.10:FF:000121', NULL, NULL, 'Gelsolin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(210299, NULL, 'G3DSA:2.130.10.10:FF:004839', NULL, NULL, 'THO complex 3 G protein beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(210300, NULL, 'G3DSA:1.10.510.10:FF:001109', NULL, NULL, 'Protein CBG07147', NULL, NULL, NULL, NULL, NULL, 4),
(210301, NULL, 'G3DSA:3.30.559.10:FF:000085', NULL, NULL, 'Transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(210302, NULL, 'G3DSA:1.10.150.50:FF:000042', NULL, NULL, 'GRB2-associated and regulator of MAPK protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(210303, NULL, 'G3DSA:2.30.30.240:FF:000001', NULL, NULL, 'Ribosome maturation factor RimM', NULL, NULL, NULL, NULL, NULL, 4),
(210304, NULL, 'G3DSA:3.40.50.450:FF:000011', NULL, NULL, 'TIGR00730 family Rossman fold protein', NULL, NULL, NULL, NULL, NULL, 4),
(210305, NULL, 'G3DSA:2.40.50.140:FF:000248', NULL, NULL, 'Meiosis specific with OB domains', NULL, NULL, NULL, NULL, NULL, 4),
(210306, NULL, 'G3DSA:3.40.50.1360:FF:000042', NULL, NULL, 'Putative lactose phosphotransferase system transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(210307, NULL, 'G3DSA:1.10.287.70:FF:000207', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(210308, NULL, 'G3DSA:3.40.50.1950:FF:000005', NULL, NULL, 'Phosphopantothenoylcysteine decarboxylase subunit VHS3', NULL, NULL, NULL, NULL, NULL, 4),
(210309, NULL, 'G3DSA:3.30.2230.10:FF:000030', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(210310, NULL, 'G3DSA:3.90.190.10:FF:000271', NULL, NULL, 'Protein tyrosine phosphatase, receptor-type, Z polypeptide 1a', NULL, NULL, NULL, NULL, NULL, 4),
(210311, NULL, 'G3DSA:3.30.200.20:FF:001301', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 40', NULL, NULL, NULL, NULL, NULL, 4),
(210312, NULL, 'G3DSA:2.130.10.10:FF:001118', NULL, NULL, 'WD repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(210313, NULL, 'G3DSA:3.10.580.10:FF:000083', NULL, NULL, 'HlyC/CorC family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(210314, NULL, 'G3DSA:3.20.20.80:FF:000524', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210315, NULL, 'G3DSA:3.30.450.20:FF:000448', NULL, NULL, 'Cyclic-di-AMP phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(210316, NULL, 'G3DSA:2.60.40.60:FF:001015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210317, NULL, 'G3DSA:3.30.2160.10:FF:000001', NULL, NULL, 'E3 ubiquitin-protein ligase NEDD4-like', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(210318, NULL, 'G3DSA:3.30.559.10:FF:000203', NULL, NULL, 'Carnitine O-palmitoyltransferase 2, mitochondrial-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(210319, NULL, 'G3DSA:1.10.150.60:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210320, NULL, 'G3DSA:3.40.50.460:FF:000014', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(210321, NULL, 'G3DSA:1.10.287.550:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210322, NULL, 'G3DSA:3.20.20.70:FF:000521', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210323, NULL, 'G3DSA:1.10.260.40:FF:000070', NULL, NULL, 'Addiction module antidote protein, HigA family', NULL, NULL, NULL, NULL, NULL, 4),
(210324, NULL, 'G3DSA:3.90.870.10:FF:000003', NULL, NULL, 'Sua5/YciO/YrdC/YwlC family protein', NULL, NULL, NULL, NULL, NULL, 4),
(210325, NULL, 'G3DSA:3.30.160.60:FF:003681', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210326, NULL, 'G3DSA:1.20.120.1240:FF:000058', NULL, NULL, 'Dynamin-A', NULL, NULL, NULL, NULL, NULL, 4),
(210327, NULL, 'G3DSA:3.30.710.10:FF:000218', NULL, NULL, 'Lolal-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(210328, NULL, 'G3DSA:3.40.50.300:FF:004699', NULL, NULL, 'Minichromosome maintenance complex component 5', NULL, NULL, NULL, NULL, NULL, 4),
(210329, NULL, 'G3DSA:1.10.510.10:FF:000974', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(210330, NULL, 'G3DSA:2.60.120.920:FF:000030', NULL, NULL, 'probable E3 ubiquitin-protein ligase HECTD4 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(210331, NULL, 'G3DSA:3.30.1370.10:FF:000242', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(210332, NULL, 'G3DSA:3.40.367.20:FF:000016', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(210333, NULL, 'G3DSA:2.150.10.10:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210334, NULL, 'G3DSA:1.25.40.10:FF:000836', NULL, NULL, 'Unplaced genomic scaffold supercont1.19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(210335, NULL, 'G3DSA:1.25.10.10:FF:001407', NULL, NULL, 'U3 small nucleolar RNA-associated protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(210336, NULL, 'G3DSA:3.30.160.60:FF:005772', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210337, NULL, 'G3DSA:3.30.70.330:FF:002477', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210338, NULL, 'G3DSA:3.40.50.2300:FF:000329', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(210339, NULL, 'G3DSA:1.25.40.180:FF:000236', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210340, NULL, 'G3DSA:3.20.140.10:FF:000008', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(210341, NULL, 'G3DSA:3.90.640.10:FF:000227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210342, NULL, 'G3DSA:3.30.1410.10:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210343, NULL, 'G3DSA:3.40.1160.10:FF:000044', NULL, NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210344, NULL, 'G3DSA:3.40.47.10:FF:000188', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210345, NULL, 'G3DSA:3.30.160.60:FF:005300', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210346, NULL, 'G3DSA:3.60.10.10:FF:000018', NULL, NULL, '2'',5''-phosphodiesterase 12', NULL, NULL, NULL, NULL, NULL, 4),
(210347, NULL, 'G3DSA:3.30.9.10:FF:000027', NULL, NULL, 'FAD-dependent oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(210348, NULL, 'G3DSA:1.20.5.190:FF:000097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210349, NULL, 'G3DSA:1.50.10.10:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210350, NULL, 'G3DSA:4.10.75.10:FF:000004', NULL, NULL, 'WAP four-disulfide core domain 6A', NULL, NULL, NULL, NULL, NULL, 4),
(210351, NULL, 'G3DSA:1.20.120.1080:FF:000044', NULL, NULL, 'Protein CBG08977', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(210352, NULL, 'G3DSA:1.25.10.10:FF:001470', NULL, NULL, 'AGAP006626-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(210353, NULL, 'G3DSA:1.25.40.10:FF:003096', NULL, NULL, 'YALI0A10296p', NULL, NULL, NULL, NULL, NULL, 4),
(210354, NULL, 'G3DSA:2.60.120.320:FF:000001', NULL, NULL, 'Thiamine pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(210355, NULL, 'G3DSA:2.20.100.10:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210356, NULL, 'G3DSA:2.30.42.10:FF:000466', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210357, NULL, 'G3DSA:3.40.50.12780:FF:000128', NULL, NULL, 'Fatty acid transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210358, NULL, 'G3DSA:3.40.50.300:FF:003715', NULL, NULL, 'GG12352', NULL, NULL, NULL, NULL, NULL, 4),
(210359, NULL, 'G3DSA:2.30.42.10:FF:000264', NULL, NULL, 'Multiple PDZ domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(210360, NULL, 'G3DSA:3.80.10.10:FF:000208', NULL, NULL, 'F-box/LRR-repeat protein 12 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(210361, NULL, 'G3DSA:3.10.20.360:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210362, NULL, 'G3DSA:2.60.120.330:FF:000004', NULL, NULL, 'aspartyl/asparaginyl beta-hydroxylase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(210363, NULL, 'G3DSA:1.10.10.60:FF:001107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210364, NULL, 'G3DSA:2.30.230.10:FF:000028', NULL, NULL, 'Putative vitellogenin 2', NULL, NULL, NULL, NULL, NULL, 4),
(210365, NULL, 'G3DSA:3.20.20.80:FF:000468', NULL, NULL, 'Alpha-amylase', NULL, NULL, NULL, NULL, NULL, 4),
(210366, NULL, 'G3DSA:3.40.850.10:FF:000378', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210367, NULL, 'G3DSA:3.30.70.330:FF:001016', NULL, NULL, 'U11/U12 small nuclear ribonucleoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(210368, NULL, 'G3DSA:2.130.10.10:FF:002748', NULL, NULL, 'Autophagy-related protein 18e', NULL, NULL, NULL, NULL, NULL, 4),
(210369, NULL, 'G3DSA:3.30.10.20:FF:000005', NULL, NULL, 'Bifunctional membrane-associatedpenicillin-binding protein 1A/1B', NULL, NULL, NULL, NULL, NULL, 4),
(210370, NULL, 'G3DSA:1.25.40.10:FF:005041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210371, NULL, 'G3DSA:3.30.70.3490:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210372, NULL, 'G3DSA:2.60.120.340:FF:000007', NULL, NULL, 'Nucleophosmin 1a', NULL, NULL, NULL, NULL, NULL, 4),
(210373, NULL, 'G3DSA:3.20.20.70:FF:000465', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210374, NULL, 'G3DSA:3.40.1360.10:FF:000025', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(210375, NULL, 'G3DSA:3.40.1380.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210376, NULL, 'G3DSA:3.40.50.10490:FF:000003', NULL, NULL, 'Glucose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(210377, NULL, 'G3DSA:3.40.50.1820:FF:001040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210378, NULL, 'G3DSA:1.10.4160.10:FF:000019', NULL, NULL, 'Transmembrane transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(210379, NULL, 'G3DSA:2.40.50.90:FF:000025', NULL, NULL, 'Thermonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(210380, NULL, 'G3DSA:3.40.50.150:FF:000511', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase G', NULL, NULL, NULL, NULL, NULL, 4),
(210381, NULL, 'G3DSA:1.50.10.20:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210382, NULL, 'G3DSA:2.130.10.10:FF:003209', NULL, NULL, 'WD repeat-containing protein 38', NULL, NULL, NULL, NULL, NULL, 4),
(210383, NULL, 'G3DSA:3.40.605.10:FF:000062', NULL, NULL, 'Delta-1-pyrroline-5-carboxylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(210384, NULL, 'G3DSA:3.30.70.1590:FF:000006', NULL, NULL, 'Myosin XI D', NULL, NULL, NULL, NULL, NULL, 4),
(210385, NULL, 'G3DSA:1.10.40.60:FF:000002', NULL, NULL, 'Type II secretion system protein K', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(210386, NULL, 'G3DSA:3.30.1430.10:FF:000011', NULL, NULL, 'LRRGT00043', NULL, NULL, NULL, NULL, NULL, 4),
(210387, NULL, 'G3DSA:3.40.1170.10:FF:000016', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(210388, NULL, 'G3DSA:3.40.1380.20:FF:000035', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(210389, NULL, 'G3DSA:1.25.40.20:FF:001238', NULL, NULL, 'Os11g0182900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(210390, NULL, 'G3DSA:1.10.287.70:FF:000270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210391, NULL, 'G3DSA:3.50.50.60:FF:000980', NULL, NULL, 'Pyridine nucleotide-disulphide oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210392, NULL, 'G3DSA:2.130.10.10:FF:004991', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210393, NULL, 'G3DSA:1.10.510.10:FF:003880', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210394, NULL, 'G3DSA:3.40.50.300:FF:008122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210395, NULL, 'G3DSA:3.80.10.10:FF:004542', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(210396, NULL, 'G3DSA:3.30.420.40:FF:001088', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(210397, NULL, 'G3DSA:2.60.450.20:FF:000007', NULL, NULL, 'Centromere protein J', NULL, NULL, NULL, NULL, NULL, 4),
(210398, NULL, 'G3DSA:3.90.660.10:FF:000083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210399, NULL, 'G3DSA:2.130.10.10:FF:003058', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210400, NULL, 'G3DSA:3.40.50.10180:FF:000005', NULL, NULL, 'Glycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(210401, NULL, 'G3DSA:3.30.160.60:FF:001438', NULL, NULL, 'Zinc finger and BTB domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(210402, NULL, 'G3DSA:1.25.40.10:FF:001235', NULL, NULL, 'Empty pericarp7', NULL, NULL, NULL, NULL, NULL, 4),
(210403, NULL, 'G3DSA:3.40.1690.20:FF:000019', NULL, NULL, 'Membrane AAA-metalloprotease', NULL, NULL, NULL, NULL, NULL, 4),
(210404, NULL, 'G3DSA:3.40.190.10:FF:000973', NULL, NULL, 'ABC-type dipeptide transport system, periplasmic component', NULL, NULL, NULL, NULL, NULL, 4),
(210405, NULL, 'G3DSA:3.40.1690.10:FF:000016', NULL, NULL, 'Type III secretion protein HrcU', NULL, NULL, NULL, NULL, NULL, 4),
(210406, NULL, 'G3DSA:1.10.12.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210407, NULL, 'G3DSA:1.10.390.10:FF:000093', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(210408, NULL, 'G3DSA:3.30.420.10:FF:000617', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210409, NULL, 'G3DSA:3.40.50.2000:FF:000655', NULL, NULL, 'Zeaxanthin glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(210410, NULL, 'G3DSA:3.40.50.300:FF:003395', NULL, NULL, 'Regulator of nonsense transcripts, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210411, NULL, 'G3DSA:3.30.50.10:FF:000090', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(210412, NULL, 'G3DSA:3.30.200.40:FF:000003', NULL, NULL, 'm7GpppX diphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(210413, NULL, 'G3DSA:1.10.150.50:FF:000244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210414, NULL, 'G3DSA:2.60.450.10:FF:000004', NULL, NULL, 'Lipopolysaccharide export system protein LptA', NULL, NULL, NULL, NULL, NULL, 4),
(210415, NULL, 'G3DSA:2.40.50.140:FF:000574', NULL, NULL, 'Multiple sugar ABC transporter ATP-bindingprotein', NULL, NULL, NULL, NULL, NULL, 4),
(210416, NULL, 'G3DSA:3.30.160.60:FF:004018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210417, NULL, 'G3DSA:1.10.287.470:FF:000075', NULL, NULL, 'HAE1 family effllux pump MFP component', NULL, NULL, NULL, NULL, NULL, 4),
(210418, NULL, 'G3DSA:1.20.1560.10:FF:000620', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210419, NULL, 'G3DSA:1.20.1300.10:FF:000022', NULL, NULL, 'YOR228C-like protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(210420, NULL, 'G3DSA:3.40.50.10190:FF:000008', NULL, NULL, 'X-ray repair cross complementing 1', NULL, NULL, NULL, NULL, NULL, 4),
(210421, NULL, 'G3DSA:3.40.50.2000:FF:000127', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(210422, NULL, 'G3DSA:2.30.30.140:FF:000117', NULL, NULL, 'Glyoxylate reductase 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(210423, NULL, 'G3DSA:3.50.30.30:FF:000115', NULL, NULL, 'Carboxypeptidase Q', NULL, NULL, NULL, NULL, NULL, 4),
(210424, NULL, 'G3DSA:3.80.10.10:FF:002451', NULL, NULL, 'Leucine-rich repeat protein (LRRP)', NULL, NULL, NULL, NULL, NULL, 4),
(210425, NULL, 'G3DSA:3.60.10.10:FF:000400', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210426, NULL, 'G3DSA:1.20.1070.10:FF:000599', NULL, NULL, 'SERotonin/octopamine receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(210427, NULL, 'G3DSA:3.40.50.2300:FF:000594', NULL, NULL, 'Penicillin-binding protein activator', NULL, NULL, NULL, NULL, NULL, 4),
(210428, NULL, 'G3DSA:3.10.129.10:FF:000046', NULL, NULL, 'Acyl-coenzyme A thioesterase THEM4', NULL, NULL, NULL, NULL, NULL, 4),
(210429, NULL, 'G3DSA:1.20.1250.20:FF:001010', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(210430, NULL, 'G3DSA:2.30.30.490:FF:000020', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(210431, NULL, 'G3DSA:1.10.1040.10:FF:000049', NULL, NULL, 'Related to 2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(210432, NULL, 'G3DSA:1.20.5.170:FF:000091', NULL, NULL, 'CD207 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(210433, NULL, 'G3DSA:2.60.40.10:FF:004659', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210434, NULL, 'G3DSA:3.40.50.80:FF:000216', NULL, NULL, 'NADH-cytochrome b5 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(210435, NULL, 'G3DSA:3.75.10.10:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210436, NULL, 'G3DSA:3.30.70.330:FF:000706', NULL, NULL, 'Multiple RNA-binding domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(210437, NULL, 'G3DSA:2.30.30.100:FF:000038', NULL, NULL, 'Gem-associated protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(210438, NULL, 'G3DSA:3.10.20.30:FF:000111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210439, NULL, 'G3DSA:1.25.40.10:FF:001179', NULL, NULL, 'Pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(210440, NULL, 'G3DSA:3.30.160.60:FF:005244', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210441, NULL, 'G3DSA:3.40.50.300:FF:001624', NULL, NULL, 'Dynein heavy chain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(210442, NULL, 'G3DSA:3.90.180.10:FF:000147', NULL, NULL, '2-haloacrylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(210443, NULL, 'G3DSA:1.20.58.60:FF:000071', NULL, NULL, 'Spectrin alpha chain, non-erythrocytic 1', NULL, NULL, NULL, NULL, NULL, 4),
(210444, NULL, 'G3DSA:3.40.50.1240:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210445, NULL, 'G3DSA:3.50.30.30:FF:000110', NULL, NULL, 'Inactive zinc metalloprotease C354.09c', NULL, NULL, NULL, NULL, NULL, 4),
(210446, NULL, 'G3DSA:2.130.10.10:FF:003361', NULL, NULL, 'CMGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(210447, NULL, 'G3DSA:3.40.50.1400:FF:000020', NULL, NULL, 'Ferrochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(210448, NULL, 'G3DSA:3.40.50.300:FF:000045', NULL, NULL, 'dynamin-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(210449, NULL, 'G3DSA:3.40.50.1820:FF:000584', NULL, NULL, '1-alkyl-2-acetylglycerophosphocholine esterase', NULL, NULL, NULL, NULL, NULL, 4),
(210450, NULL, 'G3DSA:1.10.720.60:FF:000010', NULL, NULL, 'Enolase-phosphatase E1', NULL, NULL, NULL, NULL, NULL, 4),
(210451, NULL, 'G3DSA:1.25.40.80:FF:000014', NULL, NULL, 'Deoxyribodipyrimidine photolyase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210452, NULL, 'G3DSA:3.30.420.10:FF:000590', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(210453, NULL, 'G3DSA:3.40.50.300:FF:005481', NULL, NULL, 'ATP-dependent RNA helicase RhlE', NULL, NULL, NULL, NULL, NULL, 4),
(210454, NULL, 'G3DSA:1.25.40.10:FF:004905', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(210455, NULL, 'G3DSA:3.20.20.70:FF:000139', NULL, NULL, 'Phospho-2-dehydro-3-deoxyheptonate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(210456, NULL, 'G3DSA:3.20.20.60:FF:000136', NULL, NULL, 'Isocitrate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(210457, NULL, 'G3DSA:2.60.220.50:FF:000095', NULL, NULL, 'Sperm receptor for egg jelly', NULL, NULL, NULL, NULL, NULL, 4),
(210458, NULL, 'G3DSA:3.40.720.10:FF:000138', NULL, NULL, 'Acid phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(210459, NULL, 'G3DSA:2.10.25.10:FF:000843', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(210460, NULL, 'G3DSA:2.40.50.140:FF:001035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210461, NULL, 'G3DSA:1.20.58.60:FF:000447', NULL, NULL, 'Spectrin repeat containing nuclear envelope family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(210462, NULL, 'G3DSA:1.10.8.530:FF:000010', NULL, NULL, 'DNA polymerase alpha subunit B-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(210463, NULL, 'G3DSA:3.60.10.10:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210464, NULL, 'G3DSA:3.30.160.60:FF:003299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210465, NULL, 'G3DSA:1.20.1070.10:FF:000099', NULL, NULL, 'D(2) dopamine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(210466, NULL, 'G3DSA:2.20.70.10:FF:000245', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(210467, NULL, 'G3DSA:2.30.29.30:FF:000447', NULL, NULL, 'RanBP-type and C3HC4-type zinc finger-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(210468, NULL, 'G3DSA:1.25.40.820:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210469, NULL, 'G3DSA:3.80.10.10:FF:000736', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(210470, NULL, 'G3DSA:3.40.50.300:FF:007077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210471, NULL, 'G3DSA:2.60.40.3980:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210472, NULL, 'G3DSA:3.40.50.150:FF:001293', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210473, NULL, 'G3DSA:3.20.20.100:FF:000107', NULL, NULL, 'Putative oxidoreductase-possibly Aldo/keto reductase', NULL, NULL, NULL, NULL, NULL, 4),
(210474, NULL, 'G3DSA:3.30.465.10:FF:000081', NULL, NULL, 'Magnesium and cobalt efflux protein CorC', NULL, NULL, NULL, NULL, NULL, 4),
(210475, NULL, 'G3DSA:1.20.1250.20:FF:000644', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(210476, NULL, 'G3DSA:3.30.710.10:FF:000067', NULL, NULL, 'Potassium voltage-gated channel subfamily V member 1', NULL, NULL, NULL, NULL, NULL, 4),
(210477, NULL, 'G3DSA:3.30.160.60:FF:003153', NULL, NULL, 'Zinc finger and SCAN domain containing 20', NULL, NULL, NULL, NULL, NULL, 4),
(210478, NULL, 'G3DSA:4.10.240.10:FF:000172', NULL, NULL, 'Fungal-specific transcription factor domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(210479, NULL, 'G3DSA:1.25.40.90:FF:000017', NULL, NULL, 'Phosphatidylinositol-binding clathrin assembly protein LAP', NULL, NULL, NULL, NULL, NULL, 4),
(210480, NULL, 'G3DSA:3.30.450.20:FF:000504', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(210481, NULL, 'G3DSA:2.130.10.10:FF:003737', NULL, NULL, 'WD-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210482, NULL, 'G3DSA:2.60.40.10:FF:000207', NULL, NULL, 'Tenascin C', NULL, NULL, NULL, NULL, NULL, 4),
(210483, NULL, 'G3DSA:3.30.200.60:FF:000009', NULL, NULL, 'Ubiquitin thioesterase otubain-like', NULL, NULL, NULL, NULL, NULL, 4),
(210484, NULL, 'G3DSA:3.30.40.10:FF:001460', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(210485, NULL, 'G3DSA:3.40.50.1820:FF:000674', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(210486, NULL, 'G3DSA:1.10.600.10:FF:000094', NULL, NULL, 'Selina-4(15),7(11)-diene synthase ((2E,6E)-farnesyl diphosphate cyclizing)', NULL, NULL, NULL, NULL, NULL, 4),
(210487, NULL, 'G3DSA:3.40.50.150:FF:001613', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210488, NULL, 'G3DSA:2.60.40.10:FF:003552', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210489, NULL, 'G3DSA:3.30.230.10:FF:000283', NULL, NULL, 'Elongation factor G 1', NULL, NULL, NULL, NULL, NULL, 4),
(210490, NULL, 'G3DSA:1.20.58.1120:FF:000065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210491, NULL, 'G3DSA:3.90.640.10:FF:000290', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(210492, NULL, 'G3DSA:1.20.1070.10:FF:002044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210493, NULL, 'G3DSA:1.50.40.10:FF:000154', NULL, NULL, 'Unplaced genomic scaffold supercont2.19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(210494, NULL, 'G3DSA:1.10.10.790:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210495, NULL, 'G3DSA:2.30.29.30:FF:000071', NULL, NULL, 'Enah/Vasp-like, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(210496, NULL, 'G3DSA:3.30.300.20:FF:000027', NULL, NULL, 'Small GTP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(210497, NULL, 'G3DSA:3.40.50.10090:FF:000006', NULL, NULL, 'uroporphyrinogen-III synthase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(210498, NULL, 'G3DSA:2.60.40.10:FF:003613', NULL, NULL, 'Vascular endothelial growth factor receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(210499, NULL, 'G3DSA:2.10.110.20:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210500, NULL, 'G3DSA:3.40.50.300:FF:007138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210501, NULL, 'G3DSA:3.40.50.620:FF:000793', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210502, NULL, 'G3DSA:2.60.40.1390:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210503, NULL, 'G3DSA:3.80.10.10:FF:002361', NULL, NULL, 'Cytoplasmic membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(210504, NULL, 'G3DSA:1.10.238.10:FF:000200', NULL, NULL, 'Phosphatidylserine decarboxylase proenzyme 2', NULL, NULL, NULL, NULL, NULL, 4),
(210505, NULL, 'G3DSA:3.30.930.10:FF:000055', NULL, NULL, 'Serine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(210506, NULL, 'G3DSA:3.20.20.140:FF:000125', NULL, NULL, 'Male-specific IDGF', NULL, NULL, NULL, NULL, NULL, 4),
(210507, NULL, 'G3DSA:2.60.40.3510:FF:000031', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(210508, NULL, 'G3DSA:1.25.40.70:FF:000011', NULL, NULL, 'Phosphatidylinositol 4-kinase alpha', NULL, NULL, NULL, NULL, NULL, 4),
(210509, NULL, 'G3DSA:1.25.40.20:FF:000075', NULL, NULL, 'E3 ubiquitin-protein ligase MIB2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(210510, NULL, 'G3DSA:3.30.160.20:FF:000224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210511, NULL, 'G3DSA:1.25.10.10:FF:003268', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(210512, NULL, 'G3DSA:3.30.750.24:FF:000083', NULL, NULL, 'Sulfate transporter-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(210513, NULL, 'G3DSA:2.60.40.10:FF:000972', NULL, NULL, 'Phosphoglucan phosphatase LSF1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(210514, NULL, 'G3DSA:3.40.50.300:FF:004497', NULL, NULL, 'IcmO', NULL, NULL, NULL, NULL, NULL, 4),
(210515, NULL, 'G3DSA:2.20.28.200:FF:000005', NULL, NULL, 'Mono-ADP-ribosyltransferase sirtuin-6 protein', NULL, NULL, NULL, NULL, NULL, 4),
(210516, NULL, 'G3DSA:3.40.50.2000:FF:000329', NULL, NULL, 'Lipopolysaccharide biosynthesis protein RfbV', NULL, NULL, NULL, NULL, NULL, 4),
(210517, NULL, 'G3DSA:3.40.1800.20:FF:000023', NULL, NULL, 'GG16747', NULL, NULL, NULL, NULL, NULL, 4),
(210518, NULL, 'G3DSA:3.30.70.890:FF:000003', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(210519, NULL, 'G3DSA:3.30.200.20:FF:001071', NULL, NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(210520, NULL, 'G3DSA:1.20.120.1910:FF:000012', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(210521, NULL, 'G3DSA:3.30.420.40:FF:000981', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(210522, NULL, 'G3DSA:3.90.1150.10:FF:000369', NULL, NULL, 'Threonine aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(210523, NULL, 'G3DSA:3.60.21.10:FF:000010', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(210524, NULL, 'G3DSA:3.30.40.10:FF:000971', NULL, NULL, 'Putative RING zinc finger domain superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(210525, NULL, 'G3DSA:3.60.40.10:FF:000172', NULL, NULL, 'Unplaced genomic scaffold supercont2.16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(210526, NULL, 'G3DSA:3.40.50.11540:FF:000003', NULL, NULL, 'NAD-dependent formate dehydrogenase flavoprotein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(210527, NULL, 'G3DSA:2.130.10.10:FF:004665', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210528, NULL, 'G3DSA:2.60.200.30:FF:000031', NULL, NULL, 'Blr5515 protein', NULL, NULL, NULL, NULL, NULL, 4),
(210529, NULL, 'G3DSA:1.10.8.1310:FF:000006', NULL, NULL, 'Rab GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210530, NULL, 'G3DSA:3.50.50.60:FF:000654', NULL, NULL, 'D-amino acid dehydrogenase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(210531, NULL, 'G3DSA:2.10.90.10:FF:000151', NULL, NULL, 'Invected', NULL, NULL, NULL, NULL, NULL, 4),
(210532, NULL, 'G3DSA:1.20.1250.20:FF:002319', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210533, NULL, 'G3DSA:2.60.200.40:FF:000034', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(210534, NULL, 'G3DSA:3.40.50.1820:FF:001045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210535, NULL, 'G3DSA:3.40.50.300:FF:002928', NULL, NULL, 'DEAD/DEAH box helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210536, NULL, 'G3DSA:3.80.10.10:FF:002125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210537, NULL, 'G3DSA:1.10.510.10:FF:003262', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210538, NULL, 'G3DSA:1.50.40.10:FF:000570', NULL, NULL, 'ADP/ATP carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(210539, NULL, 'G3DSA:3.40.190.10:FF:000647', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(210540, NULL, 'G3DSA:2.60.120.200:FF:000347', NULL, NULL, 'OSJNBa0027H06.9 protein', NULL, NULL, NULL, NULL, NULL, 4),
(210541, NULL, 'G3DSA:1.25.40.10:FF:003416', NULL, NULL, 'Os03g0861900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(210542, NULL, 'G3DSA:3.40.50.200:FF:000105', NULL, NULL, 'Subtilisin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(210543, NULL, 'G3DSA:3.40.850.10:FF:000468', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(210544, NULL, 'G3DSA:2.20.100.10:FF:000190', NULL, NULL, 'A disintegrin-like and metallopeptidase (reprolysin type) with thrombospondin type 1 motif, 17', NULL, NULL, NULL, NULL, NULL, 4),
(210545, NULL, 'G3DSA:3.40.50.300:FF:003390', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210546, NULL, 'G3DSA:1.10.510.10:FF:003026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210547, NULL, 'G3DSA:3.40.430.10:FF:000037', NULL, NULL, 'Dihydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(210548, NULL, 'G3DSA:3.40.50.800:FF:000072', NULL, NULL, 'Prolyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(210549, NULL, 'G3DSA:3.40.50.1820:FF:000730', NULL, NULL, 'GPI inositol-deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(210550, NULL, 'G3DSA:2.60.120.430:FF:000034', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(210551, NULL, 'G3DSA:2.40.128.20:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(210552, NULL, 'G3DSA:3.30.160.60:FF:003327', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210553, NULL, 'G3DSA:2.60.40.10:FF:005502', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210554, NULL, 'G3DSA:3.40.50.300:FF:006970', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210555, NULL, 'G3DSA:1.10.510.10:FF:001463', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210556, NULL, 'G3DSA:3.90.1150.10:FF:000077', NULL, NULL, 'Glycine cleavage system P protein', NULL, NULL, NULL, NULL, NULL, 4),
(210557, NULL, 'G3DSA:3.30.450.20:FF:000274', NULL, NULL, 'Cyclic di-GMP phosphodiesterase Gmr', NULL, NULL, NULL, NULL, NULL, 4),
(210558, NULL, 'G3DSA:1.20.1070.10:FF:000745', NULL, NULL, 'Olfactory receptor 1508', NULL, NULL, NULL, NULL, NULL, 4),
(210559, NULL, 'G3DSA:3.30.160.60:FF:003855', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210560, NULL, 'G3DSA:3.20.90.10:FF:000002', NULL, NULL, 'Tubby like protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(210561, NULL, 'G3DSA:3.90.190.10:FF:000209', NULL, NULL, 'Protein tyrosine phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(210562, NULL, 'G3DSA:1.20.1560.10:FF:000327', NULL, NULL, 'ABC transporter, ATP binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(210563, NULL, 'G3DSA:3.40.50.150:FF:001383', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210564, NULL, 'G3DSA:1.10.486.10:FF:000023', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(210565, NULL, 'G3DSA:1.20.58.60:FF:000626', NULL, NULL, 'Spectrin repeat-containing, nuclear envelope 1b', NULL, NULL, NULL, NULL, NULL, 4),
(210566, NULL, 'G3DSA:1.20.1250.20:FF:002084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210567, NULL, 'G3DSA:3.30.420.40:FF:000778', NULL, NULL, 'Actin-related protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(210568, NULL, 'G3DSA:3.40.718.10:FF:000048', NULL, NULL, 'Isocitrate dehydrogenase [NAD] regulatory subunit 3 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(210569, NULL, 'G3DSA:1.20.1070.10:FF:000217', NULL, NULL, 'neurotensin receptor type 1', NULL, NULL, NULL, NULL, NULL, 4),
(210570, NULL, 'G3DSA:2.130.10.10:FF:002102', NULL, NULL, 'GD25262', NULL, NULL, NULL, NULL, NULL, 4),
(210571, NULL, 'G3DSA:1.10.1390.10:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210572, NULL, 'G3DSA:1.50.10.20:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210573, NULL, 'G3DSA:3.40.50.1220:FF:000090', NULL, NULL, 'Thiamine diphosphate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(210574, NULL, 'G3DSA:3.40.50.1820:FF:000056', NULL, NULL, 'GPI inositol-deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(210575, NULL, 'G3DSA:1.10.630.10:FF:000426', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210576, NULL, 'G3DSA:1.10.10.540:FF:000011', NULL, NULL, 'UV excision repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210577, NULL, 'G3DSA:3.40.50.300:FF:001478', NULL, NULL, 'Similar to late competence protein comGA', NULL, NULL, NULL, NULL, NULL, 4),
(210578, NULL, 'G3DSA:3.30.70.1320:FF:000004', NULL, NULL, 'Efflux pump membrane transporter', NULL, NULL, NULL, NULL, NULL, 4),
(210579, NULL, 'G3DSA:1.25.40.180:FF:000062', NULL, NULL, 'CCR4-not transcription complex, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210580, NULL, 'G3DSA:2.60.40.60:FF:000998', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210581, NULL, 'G3DSA:1.20.1110.10:FF:000013', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(210582, NULL, 'G3DSA:2.60.40.150:FF:000031', NULL, NULL, 'Protein unc-13 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(210583, NULL, 'G3DSA:1.20.120.850:FF:000013', NULL, NULL, 'Rad54p', NULL, NULL, NULL, NULL, NULL, 4),
(210584, NULL, 'G3DSA:2.30.130.30:FF:000004', NULL, NULL, 'Activating signal cointegrator 1', NULL, NULL, NULL, NULL, NULL, 4),
(210585, NULL, 'G3DSA:3.30.160.60:FF:002225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(210586, NULL, 'G3DSA:1.10.1520.10:FF:000041', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(210587, NULL, 'G3DSA:3.90.370.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210588, NULL, 'G3DSA:3.90.25.10:FF:000034', NULL, NULL, 'Unplaced genomic scaffold supercont1.17, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(210589, NULL, 'G3DSA:3.40.50.2300:FF:000099', NULL, NULL, 'Eg435916, gene 1', NULL, NULL, NULL, NULL, NULL, 4),
(210590, NULL, 'G3DSA:3.80.10.10:FF:000118', NULL, NULL, 'Leucine rich repeat containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(210591, NULL, 'G3DSA:2.10.25.10:FF:000753', NULL, NULL, 'Laminin subunit alpha-3', NULL, NULL, NULL, NULL, NULL, 4),
(210592, NULL, 'G3DSA:1.20.1250.20:FF:001100', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210593, NULL, 'G3DSA:3.30.780.10:FF:000015', NULL, NULL, 'Translation initiation factor SUI1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210594, NULL, 'G3DSA:2.10.220.10:FF:000009', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(210595, NULL, 'G3DSA:3.30.230.70:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210596, NULL, 'G3DSA:1.20.58.60:FF:000773', NULL, NULL, 'Si:ch211-207i1.2', NULL, NULL, NULL, NULL, NULL, 4),
(210597, NULL, 'G3DSA:1.25.40.180:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210598, NULL, 'G3DSA:3.40.50.300:FF:007133', NULL, NULL, 'Small GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210599, NULL, 'G3DSA:2.10.25.10:FF:001771', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210600, NULL, 'G3DSA:1.25.40.10:FF:003326', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(210601, NULL, 'G3DSA:3.30.465.10:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210602, NULL, 'G3DSA:2.40.50.140:FF:000664', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210603, NULL, 'G3DSA:2.60.40.10:FF:001079', NULL, NULL, 'Interleukin 12 receptor subunit beta 2', NULL, NULL, NULL, NULL, NULL, 4),
(210604, NULL, 'G3DSA:3.30.9.10:FF:000151', NULL, NULL, 'AGAP001098-PA', NULL, NULL, NULL, NULL, NULL, 4),
(210605, NULL, 'G3DSA:1.20.1280.50:FF:000071', NULL, NULL, 'Secretion pathway protein Sls2/Rcy1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210606, NULL, 'G3DSA:3.40.50.200:FF:000015', NULL, NULL, 'Tripeptidyl peptidase A', NULL, NULL, NULL, NULL, NULL, 4),
(210607, NULL, 'G3DSA:1.25.40.10:FF:003124', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g21170', NULL, NULL, NULL, NULL, NULL, 4),
(210608, NULL, 'G3DSA:3.40.50.10580:FF:000002', NULL, NULL, 'V-type proton ATPase subunit F', NULL, NULL, NULL, NULL, NULL, 4),
(210609, NULL, 'G3DSA:1.10.472.130:FF:000013', NULL, NULL, 'Dynein heavy chain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(210610, NULL, 'G3DSA:2.60.40.150:FF:000767', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210611, NULL, 'G3DSA:3.40.50.300:FF:001826', NULL, NULL, 'Nickel import system ATP-binding protein NikD', NULL, NULL, NULL, NULL, NULL, 4),
(210612, NULL, 'G3DSA:3.40.850.10:FF:000524', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(210613, NULL, 'G3DSA:3.40.1110.10:FF:000333', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210614, NULL, 'G3DSA:1.10.510.10:FF:001284', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(210615, NULL, 'G3DSA:2.60.120.10:FF:000159', NULL, NULL, 'Cyclic nucleotide-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(210616, NULL, 'G3DSA:3.40.190.10:FF:000794', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(210617, NULL, 'G3DSA:2.30.30.100:FF:000190', NULL, NULL, 'Small nuclear ribonucleoprotein E', NULL, NULL, NULL, NULL, NULL, 4),
(210618, NULL, 'G3DSA:3.60.40.10:FF:000374', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(210619, NULL, 'G3DSA:3.40.50.300:FF:005340', NULL, NULL, 'Putative moxR protein', NULL, NULL, NULL, NULL, NULL, 4),
(210620, NULL, 'G3DSA:1.10.510.10:FF:001137', NULL, NULL, 'Isr1p', NULL, NULL, NULL, NULL, NULL, 4),
(210621, NULL, 'G3DSA:1.10.10.10:FF:001172', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(210622, NULL, 'G3DSA:1.25.40.10:FF:004670', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210623, NULL, 'G3DSA:3.40.50.2000:FF:000599', NULL, NULL, 'Chitobiosyldiphosphodolichol beta-mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(210624, NULL, 'G3DSA:1.50.40.10:FF:000300', NULL, NULL, 'Probable mitochondrial 2-oxoglutarate/malate carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(210625, NULL, 'G3DSA:3.40.50.620:FF:000821', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210626, NULL, 'G3DSA:4.10.10.10:FF:000001', NULL, NULL, 'Metallothionein', NULL, NULL, NULL, NULL, NULL, 4),
(210627, NULL, 'G3DSA:2.60.40.10:FF:003557', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210628, NULL, 'G3DSA:3.90.190.10:FF:000119', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type', NULL, NULL, NULL, NULL, NULL, 4),
(210629, NULL, 'G3DSA:3.30.360.20:FF:000003', NULL, NULL, 'RNA 3''-terminal phosphate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(210630, NULL, 'G3DSA:3.80.10.10:FF:002035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210631, NULL, 'G3DSA:2.60.120.260:FF:000427', NULL, NULL, 'Putative secreted ATP/GTP binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(210632, NULL, 'G3DSA:1.25.40.10:FF:003742', NULL, NULL, 'Embryo specific2', NULL, NULL, NULL, NULL, NULL, 4),
(210633, NULL, 'G3DSA:2.60.40.10:FF:001135', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(210634, NULL, 'G3DSA:3.30.450.20:FF:000358', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(210635, NULL, 'G3DSA:3.80.10.10:FF:004250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210636, NULL, 'G3DSA:3.90.1520.10:FF:000004', NULL, NULL, 'soluble guanylate cyclase 89Da', NULL, NULL, NULL, NULL, NULL, 4),
(210637, NULL, 'G3DSA:2.30.29.30:FF:000834', NULL, NULL, 'amyloid beta A4 precursor protein-binding family B member 1-interacting protein-like isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(210638, NULL, 'G3DSA:3.40.50.2300:FF:001318', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210639, NULL, 'G3DSA:3.30.60.90:FF:000012', NULL, NULL, 'Sequestosome 1', NULL, NULL, NULL, NULL, NULL, 4),
(210640, NULL, 'G3DSA:3.30.200.20:FF:001099', NULL, NULL, 'Fructosamine kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(210641, NULL, 'G3DSA:3.40.30.10:FF:000711', NULL, NULL, 'Elongation factor 1-gamma', NULL, NULL, NULL, NULL, NULL, 4),
(210642, NULL, 'G3DSA:1.10.1670.40:FF:000004', NULL, NULL, 'Putative DNA-3-methyladenine glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(210643, NULL, 'G3DSA:3.30.70.330:FF:002505', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210644, NULL, 'G3DSA:2.60.40.420:FF:000073', NULL, NULL, 'Laccase 2, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(210645, NULL, 'G3DSA:1.10.238.10:FF:001184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210646, NULL, 'G3DSA:3.30.310.80:FF:000052', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(210647, NULL, 'G3DSA:3.30.200.20:FF:002549', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210648, NULL, 'G3DSA:2.170.16.10:FF:000023', NULL, NULL, 'Replication factor C small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(210649, NULL, 'G3DSA:2.60.120.260:FF:000079', NULL, NULL, 'Anaphase-promoting complex subunit 10', NULL, NULL, NULL, NULL, NULL, 4),
(210650, NULL, 'G3DSA:1.20.1050.10:FF:000244', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210651, NULL, 'G3DSA:2.130.10.10:FF:002838', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(210652, NULL, 'G3DSA:2.40.50.140:FF:001030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210653, NULL, 'G3DSA:1.10.10.10:FF:001520', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210654, NULL, 'G3DSA:3.90.190.10:FF:000092', NULL, NULL, 'Tyrosine-protein phosphatase 69D', NULL, NULL, NULL, NULL, NULL, 4),
(210655, NULL, 'G3DSA:2.60.490.10:FF:000006', NULL, NULL, 'P2X receptor B', NULL, NULL, NULL, NULL, NULL, 4),
(210656, NULL, 'G3DSA:2.30.29.30:FF:000306', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(210657, NULL, 'G3DSA:2.70.180.20:FF:000001', NULL, NULL, 'Endonuclease NucS', NULL, NULL, NULL, NULL, NULL, 4),
(210658, NULL, 'G3DSA:2.10.60.10:FF:000031', NULL, NULL, 'Lymphocyte antigen 6 family member K', NULL, NULL, NULL, NULL, NULL, 4),
(210659, NULL, 'G3DSA:3.30.470.10:FF:000031', NULL, NULL, 'Branched-chain-amino-acid aminotransferase atnH', NULL, NULL, NULL, NULL, NULL, 4),
(210660, NULL, 'G3DSA:1.10.10.60:FF:001248', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210661, NULL, 'G3DSA:3.30.70.141:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210662, NULL, 'G3DSA:3.30.1490.20:FF:000023', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(210663, NULL, 'G3DSA:3.40.50.300:FF:005188', NULL, NULL, 'Zgc:136870', NULL, NULL, NULL, NULL, NULL, 4),
(210664, NULL, 'G3DSA:2.10.25.10:FF:001799', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210665, NULL, 'G3DSA:3.40.50.300:FF:006205', NULL, NULL, 'Peroxisomal biogenesis factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(210666, NULL, 'G3DSA:1.25.40.10:FF:003091', NULL, NULL, 'Activator of C kinase protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(210667, NULL, 'G3DSA:2.130.10.10:FF:000955', NULL, NULL, 'Putative CPSF (Cleavage and polyadenylation specific factor), subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(210668, NULL, 'G3DSA:3.30.470.20:FF:000034', NULL, NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(210669, NULL, 'G3DSA:2.60.120.10:FF:000311', NULL, NULL, 'AGAP002094-PA', NULL, NULL, NULL, NULL, NULL, 4),
(210670, NULL, 'G3DSA:3.30.1370.10:FF:000096', NULL, NULL, 'KH domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(210671, NULL, 'G3DSA:2.130.10.10:FF:001259', NULL, NULL, 'LD41558p', NULL, NULL, NULL, NULL, NULL, 4),
(210672, NULL, 'G3DSA:2.130.10.10:FF:001444', NULL, NULL, 'Radiation sensitive protein', NULL, NULL, NULL, NULL, NULL, 4),
(210673, NULL, 'G3DSA:1.10.3520.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210674, NULL, 'G3DSA:1.25.40.470:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210675, NULL, 'G3DSA:3.40.50.300:FF:005716', NULL, NULL, 'Disease resistance RPP13-like protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(210676, NULL, 'G3DSA:2.60.40.150:FF:000121', NULL, NULL, 'Synaptotagmin-like 4, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(210677, NULL, 'G3DSA:3.40.630.30:FF:000025', NULL, NULL, 'Aminoglycoside acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(210678, NULL, 'G3DSA:1.20.920.10:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210679, NULL, 'G3DSA:3.40.50.720:FF:002318', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210680, NULL, 'G3DSA:1.20.5.350:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210681, NULL, 'G3DSA:2.30.40.10:FF:000102', NULL, NULL, 'LAF3/LAF3 ISF1/LAF3 ISF2', NULL, NULL, NULL, NULL, NULL, 4),
(210682, NULL, 'G3DSA:3.30.710.10:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210683, NULL, 'G3DSA:3.40.1380.20:FF:000030', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(210684, NULL, 'G3DSA:3.40.630.20:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210685, NULL, 'G3DSA:1.20.120.1760:FF:000034', NULL, NULL, 'Phosphatidylcholine synthase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(210686, NULL, 'G3DSA:3.40.47.10:FF:000278', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210687, NULL, 'G3DSA:3.30.800.10:FF:000012', NULL, NULL, 'Phosphatidylinositol 5-phosphate 4-kinase, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(210688, NULL, 'G3DSA:3.30.110.10:FF:000015', NULL, NULL, 'Translation initiation factor IF-3, C-terminal domain', NULL, NULL, NULL, NULL, NULL, 4),
(210689, NULL, 'G3DSA:1.10.8.10:FF:000226', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(210690, NULL, 'G3DSA:2.40.240.20:FF:000007', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4),
(210691, NULL, 'G3DSA:3.90.1440.10:FF:000003', NULL, NULL, 'Preprotein translocase SecA subunit', NULL, NULL, NULL, NULL, NULL, 4),
(210692, NULL, 'G3DSA:3.40.50.300:FF:004789', NULL, NULL, 'Cell division control protein 48 homolog C', NULL, NULL, NULL, NULL, NULL, 4),
(210693, NULL, 'G3DSA:3.30.1370.10:FF:000186', NULL, NULL, 'KH homology domain-containing protein 4-like', NULL, NULL, NULL, NULL, NULL, 4),
(210694, NULL, 'G3DSA:1.10.840.10:FF:000021', NULL, NULL, 'Cell division cycle-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(210695, NULL, 'G3DSA:2.40.50.430:FF:000009', NULL, NULL, 'Probable DNA polymerase delta small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(210696, NULL, 'G3DSA:3.30.160.60:FF:004788', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210697, NULL, 'G3DSA:3.40.50.150:FF:001467', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210698, NULL, 'G3DSA:3.40.50.150:FF:001091', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210699, NULL, 'G3DSA:3.40.50.720:FF:001216', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] reductase', NULL, NULL, NULL, NULL, NULL, 4),
(210700, NULL, 'G3DSA:2.30.29.30:FF:000273', NULL, NULL, 'alsin isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(210701, NULL, 'G3DSA:3.40.640.10:FF:000278', NULL, NULL, 'Glutamate decarboxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(210702, NULL, 'G3DSA:3.30.390.30:FF:000036', NULL, NULL, 'Mercuric reductase', NULL, NULL, NULL, NULL, NULL, 4),
(210703, NULL, 'G3DSA:1.25.10.10:FF:001380', NULL, NULL, 'AP-3 adaptor complex subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210704, NULL, 'G3DSA:3.40.30.10:FF:000037', NULL, NULL, 'Co-chaperone YbbN', NULL, NULL, NULL, NULL, NULL, 4),
(210705, NULL, 'G3DSA:3.40.390.10:FF:000303', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210706, NULL, 'G3DSA:3.30.40.10:FF:002393', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(210707, NULL, 'G3DSA:1.10.167.10:FF:000001', NULL, NULL, 'Putative regulator of g-protein signaling 12', NULL, NULL, NULL, NULL, NULL, 4),
(210708, NULL, 'G3DSA:3.80.10.10:FF:002653', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210709, NULL, 'G3DSA:1.20.120.550:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210710, NULL, 'G3DSA:3.40.50.800:FF:000105', NULL, NULL, 'Threonine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(210711, NULL, 'G3DSA:3.40.50.720:FF:001981', NULL, NULL, '3-hydroxybutyrate dehydrogenase type 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(210712, NULL, 'G3DSA:3.30.930.10:FF:000229', NULL, NULL, 'phenylalanine--tRNA ligase beta subunit isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(210713, NULL, 'G3DSA:2.130.10.10:FF:005160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210714, NULL, 'G3DSA:3.40.50.720:FF:000379', NULL, NULL, 'Oxidoreductase, zinc-binding dehydrogenase family', NULL, NULL, NULL, NULL, NULL, 4),
(210715, NULL, 'G3DSA:3.10.129.110:FF:000011', NULL, NULL, 'Polyketide synthase RzxE', NULL, NULL, NULL, NULL, NULL, 4),
(210716, NULL, 'G3DSA:1.20.1560.10:FF:000474', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(210717, NULL, 'G3DSA:1.20.1070.10:FF:000127', NULL, NULL, 'Parathyroid hormone 2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(210718, NULL, 'G3DSA:1.10.510.10:FF:003352', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(210719, NULL, 'G3DSA:2.60.120.680:FF:000002', NULL, NULL, 'Putative Golgi resident protein GCP60', NULL, NULL, NULL, NULL, NULL, 4),
(210720, NULL, 'G3DSA:2.10.110.10:FF:000327', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(210721, NULL, 'G3DSA:2.60.260.40:FF:000010', NULL, NULL, 'NADH:ubiquinone oxidoreductase subunit S6', NULL, NULL, NULL, NULL, NULL, 4),
(210722, NULL, 'G3DSA:3.30.200.20:FF:001447', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(210723, NULL, 'G3DSA:1.10.1040.10:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210724, NULL, 'G3DSA:3.40.710.10:FF:000020', NULL, NULL, 'Penicillin-binding protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(210725, NULL, 'G3DSA:3.30.930.10:FF:000201', NULL, NULL, 'Related to lipoate--protein ligase B', NULL, NULL, NULL, NULL, NULL, 4),
(210726, NULL, 'G3DSA:1.25.40.10:FF:003652', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210727, NULL, 'G3DSA:3.30.110.20:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210728, NULL, 'G3DSA:3.65.10.20:FF:000022', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(210729, NULL, 'G3DSA:1.10.287.850:FF:000003', NULL, NULL, 'PE family protein PE25', NULL, NULL, NULL, NULL, NULL, 4),
(210730, NULL, 'G3DSA:2.60.98.60:FF:000001', NULL, NULL, 'Protein CBR-EFF-1, isoform a', NULL, NULL, NULL, NULL, NULL, 4),
(210731, NULL, 'G3DSA:2.40.37.10:FF:000049', NULL, NULL, 'Antizyme inhibitor 2', NULL, NULL, NULL, NULL, NULL, 4),
(210732, NULL, 'G3DSA:3.60.10.10:FF:000344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210733, NULL, 'G3DSA:2.40.240.10:FF:000004', NULL, NULL, 'Glutamyl-tRNA synthetase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(210734, NULL, 'G3DSA:1.20.1540.10:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210735, NULL, 'G3DSA:1.25.40.10:FF:004872', NULL, NULL, 'Developmental protein DG1091', NULL, NULL, NULL, NULL, NULL, 4),
(210736, NULL, 'G3DSA:3.30.1360.40:FF:000025', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(210737, NULL, 'G3DSA:2.30.30.490:FF:000019', NULL, NULL, 'Chromatin remodeling protein EBS', NULL, NULL, NULL, NULL, NULL, 4),
(210738, NULL, 'G3DSA:3.40.50.300:FF:005514', NULL, NULL, 'DEAD-box helicase 3 X-linked b', NULL, NULL, NULL, NULL, NULL, 4),
(210739, NULL, 'G3DSA:3.30.450.20:FF:000651', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(210740, NULL, 'G3DSA:3.90.190.10:FF:000035', NULL, NULL, 'Tyrosine phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210741, NULL, 'G3DSA:3.20.20.100:FF:000074', NULL, NULL, 'Oxidoreductase, aldo/keto reductase family', NULL, NULL, NULL, NULL, NULL, 4),
(210742, NULL, 'G3DSA:2.60.120.200:FF:000724', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210743, NULL, 'G3DSA:2.30.29.30:FF:000632', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(210744, NULL, 'G3DSA:3.40.250.10:FF:000091', NULL, NULL, 'Rhodanese-like domain-containing protein 11, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(210745, NULL, 'G3DSA:3.40.50.720:FF:000761', NULL, NULL, 'SDR family oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(210746, NULL, 'G3DSA:3.90.190.20:FF:000038', NULL, NULL, 'Bifunctional tetrahydrofolate synthase/dihydrofolate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(210747, NULL, 'G3DSA:3.30.50.10:FF:000089', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(210748, NULL, 'G3DSA:4.10.400.10:FF:000033', NULL, NULL, 'Sortilin-related receptor isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(210749, NULL, 'G3DSA:1.10.1040.10:FF:000021', NULL, NULL, '2-hydroxy-3-oxopropionate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(210750, NULL, 'G3DSA:3.20.20.70:FF:000813', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210751, NULL, 'G3DSA:3.40.50.2000:FF:000745', NULL, NULL, 'Chitobiosyldiphosphodolichol beta-mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(210752, NULL, 'G3DSA:3.30.420.40:FF:000132', NULL, NULL, 'Sedoheptulokinase', NULL, NULL, NULL, NULL, NULL, 4),
(210753, NULL, 'G3DSA:3.40.50.300:FF:006498', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210754, NULL, 'G3DSA:2.130.10.10:FF:005154', NULL, NULL, 'DmX-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(210755, NULL, 'G3DSA:2.60.40.10:FF:004569', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210756, NULL, 'G3DSA:1.10.10.60:FF:000938', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210757, NULL, 'G3DSA:3.90.70.10:FF:000110', NULL, NULL, 'ubiquitin carboxyl-terminal hydrolase 32 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(210758, NULL, 'G3DSA:3.90.180.10:FF:000006', NULL, NULL, 'Alcohol dehydrogenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(210759, NULL, 'G3DSA:1.20.120.720:FF:000058', NULL, NULL, 'Myosin IHb', NULL, NULL, NULL, NULL, NULL, 4),
(210760, NULL, 'G3DSA:3.40.850.10:FF:000294', NULL, NULL, 'Kinesin-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(210761, NULL, 'G3DSA:1.20.190.20:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210762, NULL, 'G3DSA:2.130.10.10:FF:003030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210763, NULL, 'G3DSA:3.20.20.140:FF:000035', NULL, NULL, 'Probable amp deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(210764, NULL, 'G3DSA:1.20.1560.10:FF:000743', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(210765, NULL, 'G3DSA:3.30.1520.10:FF:000164', NULL, NULL, 'Sorting nexin-12', NULL, NULL, NULL, NULL, NULL, 4),
(210766, NULL, 'G3DSA:3.50.50.60:FF:001143', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(210767, NULL, 'G3DSA:2.30.180.10:FF:000001', NULL, NULL, 'periostin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(210768, NULL, 'G3DSA:3.40.50.300:FF:002698', NULL, NULL, 'Rab2b/ Small GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(210769, NULL, 'G3DSA:3.40.50.11660:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210770, NULL, 'G3DSA:1.20.190.10:FF:000002', NULL, NULL, 'Pesticidal crystal protein Cry5Ba', NULL, NULL, NULL, NULL, NULL, 4),
(210771, NULL, 'G3DSA:3.80.10.10:FF:003996', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(210772, NULL, 'G3DSA:3.40.50.11350:FF:000008', NULL, NULL, 'Alpha-(1,6)-fucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(210773, NULL, 'G3DSA:2.30.42.10:FF:000556', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210774, NULL, 'G3DSA:3.20.20.150:FF:000038', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(210775, NULL, 'G3DSA:3.40.50.2300:FF:001083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210776, NULL, 'G3DSA:3.40.710.10:FF:000076', NULL, NULL, 'Penicillin-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(210777, NULL, 'G3DSA:3.30.30.30:FF:000010', NULL, NULL, 'Heat shock 70 kDa protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(210778, NULL, 'G3DSA:3.10.290.70:FF:000011', NULL, NULL, '40S ribosomal protein S8', NULL, NULL, NULL, NULL, NULL, 4),
(210779, NULL, 'G3DSA:3.30.160.60:FF:005098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210780, NULL, 'G3DSA:2.100.10.50:FF:000007', NULL, NULL, 'Multivesicular body subunit 12A', NULL, NULL, NULL, NULL, NULL, 4),
(210781, NULL, 'G3DSA:3.90.190.10:FF:000563', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210782, NULL, 'G3DSA:1.20.1070.10:FF:000571', NULL, NULL, 'Proctolin receptor, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(210783, NULL, 'G3DSA:1.10.8.60:FF:000252', NULL, NULL, 'AAA family ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210784, NULL, 'G3DSA:3.90.640.10:FF:000143', NULL, NULL, 'Heat shock protein 70', NULL, NULL, NULL, NULL, NULL, 4),
(210785, NULL, 'G3DSA:3.90.70.10:FF:000487', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210786, NULL, 'G3DSA:2.10.109.10:FF:000083', NULL, NULL, 'Signal peptidase I', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(210787, NULL, 'G3DSA:3.30.160.60:FF:002990', NULL, NULL, 'Zinc finger protein 578', NULL, NULL, NULL, NULL, NULL, 4),
(210788, NULL, 'G3DSA:1.20.5.120:FF:000003', NULL, NULL, 'Proteasome activator subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(210789, NULL, 'G3DSA:4.10.410.10:FF:000005', NULL, NULL, 'Pancreatic trypsin inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(210790, NULL, 'G3DSA:2.60.120.290:FF:000155', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(210791, NULL, 'G3DSA:3.40.50.150:FF:000163', NULL, NULL, '23S rRNA methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(210792, NULL, 'G3DSA:3.10.110.10:FF:000346', NULL, NULL, 'Protein CBR-UEV-3', NULL, NULL, NULL, NULL, NULL, 4),
(210793, NULL, 'G3DSA:1.10.510.10:FF:002008', NULL, NULL, 'Calmodulin-binding receptor-like cytoplasmic kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(210794, NULL, 'G3DSA:1.10.1580.10:FF:000016', NULL, NULL, 'Related to NUG1-Nuclear GTPase (Involved in Ribosome biogenesis)', NULL, NULL, NULL, NULL, NULL, 4),
(210795, NULL, 'G3DSA:3.90.180.10:FF:000063', NULL, NULL, 'Probable alcohol dehydrogenase adhA', NULL, NULL, NULL, NULL, NULL, 4),
(210796, NULL, 'G3DSA:1.25.40.120:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210797, NULL, 'G3DSA:4.10.410.20:FF:000008', NULL, NULL, 'SR-CI', NULL, NULL, NULL, NULL, NULL, 4),
(210798, NULL, 'G3DSA:2.130.10.10:FF:000949', NULL, NULL, 'Polyubiquitin binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210799, NULL, 'G3DSA:3.40.50.300:FF:006121', NULL, NULL, 'Putative ABC transporter ATP-binding protein MG187', NULL, NULL, NULL, NULL, NULL, 4),
(210800, NULL, 'G3DSA:1.20.940.10:FF:000004', NULL, NULL, 'Pre-mRNA-splicing factor 18', NULL, NULL, NULL, NULL, NULL, 4),
(210801, NULL, 'G3DSA:1.10.150.20:FF:000168', NULL, NULL, 'Mating-type switching protein swi10', NULL, NULL, NULL, NULL, NULL, 4),
(210802, NULL, 'G3DSA:2.30.110.10:FF:000053', NULL, NULL, 'Protein CBG16488', NULL, NULL, NULL, NULL, NULL, 4),
(210803, NULL, 'G3DSA:1.10.565.10:FF:000061', NULL, NULL, 'Protein CBR-NHR-14', NULL, NULL, NULL, NULL, NULL, 4),
(210804, NULL, 'G3DSA:1.10.510.10:FF:002773', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210805, NULL, 'G3DSA:3.40.1620.60:FF:000004', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 12', NULL, NULL, NULL, NULL, NULL, 4),
(210806, NULL, 'G3DSA:3.40.980.10:FF:000005', NULL, NULL, 'Molybdopterin biosynthesis mog protein', NULL, NULL, NULL, NULL, NULL, 4),
(210807, NULL, 'G3DSA:3.10.20.870:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210808, NULL, 'G3DSA:3.40.50.620:FF:000169', NULL, NULL, 'Two-component system sensor histidine kinase KdbD', NULL, NULL, NULL, NULL, NULL, 4),
(210809, NULL, 'G3DSA:1.10.472.10:FF:000637', NULL, NULL, 'Cyclin, N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(210810, NULL, 'G3DSA:2.30.42.10:FF:000612', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210811, NULL, 'G3DSA:1.10.238.110:FF:000019', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(210812, NULL, 'G3DSA:3.30.70.330:FF:001201', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(210813, NULL, 'G3DSA:3.30.70.330:FF:001347', NULL, NULL, 'Zinc finger CCCH domain-containing protein 41', NULL, NULL, NULL, NULL, NULL, 4),
(210814, NULL, 'G3DSA:3.30.1360.10:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210815, NULL, 'G3DSA:3.90.190.10:FF:000361', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210816, NULL, 'G3DSA:1.10.3520.10:FF:000007', NULL, NULL, 'Glycolipid transfer protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210817, NULL, 'G3DSA:3.40.390.10:FF:000270', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210818, NULL, 'G3DSA:1.10.10.160:FF:000026', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(210819, NULL, 'G3DSA:1.10.287.160:FF:000010', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(210820, NULL, 'G3DSA:2.60.120.10:FF:000305', NULL, NULL, 'Clavaminate synthase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(210821, NULL, 'G3DSA:4.10.1000.10:FF:000016', NULL, NULL, 'Zinc finger CCCH domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(210822, NULL, 'G3DSA:1.10.3860.10:FF:000027', NULL, NULL, 'Transporter, dicarboxylate/amino acid:cation Na+/H+ symporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(210823, NULL, 'G3DSA:3.30.230.30:FF:000002', NULL, NULL, 'Protein IMPACT homolog', NULL, NULL, NULL, NULL, NULL, 4),
(210824, NULL, 'G3DSA:3.40.50.300:FF:000135', NULL, NULL, 'DNA repair helicase RAD3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210825, NULL, 'G3DSA:3.40.50.150:FF:000596', NULL, NULL, 'Caffeic acid O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(210826, NULL, 'G3DSA:1.10.472.10:FF:000694', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210827, NULL, 'G3DSA:3.40.50.2000:FF:001111', NULL, NULL, 'UDP-glycosyltransferase 90A1', NULL, NULL, NULL, NULL, NULL, 4),
(210828, NULL, 'G3DSA:3.20.20.300:FF:000049', NULL, NULL, 'Glycoside hydrolase superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(210829, NULL, 'G3DSA:3.20.20.80:FF:000816', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210830, NULL, 'G3DSA:1.10.8.60:FF:000196', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(210831, NULL, 'G3DSA:3.30.1370.210:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210832, NULL, 'G3DSA:1.10.10.10:FF:000070', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 12', NULL, NULL, NULL, NULL, NULL, 4),
(210833, NULL, 'G3DSA:3.30.230.40:FF:000005', NULL, NULL, 'Imidazoleglycerol-phosphate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(210834, NULL, 'G3DSA:3.30.760.10:FF:000076', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(210835, NULL, 'G3DSA:3.40.50.1000:FF:000170', NULL, NULL, '4-nitrophenylphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(210836, NULL, 'G3DSA:3.40.50.970:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210837, NULL, 'G3DSA:3.30.200.20:FF:001155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210838, NULL, 'G3DSA:3.80.10.10:FF:000091', NULL, NULL, 'leucine-rich repeat serine/threonine-protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(210839, NULL, 'G3DSA:2.60.40.10:FF:003265', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(210840, NULL, 'G3DSA:3.40.50.410:FF:000078', NULL, NULL, 'UPF0353 protein RN09_1826', NULL, NULL, NULL, NULL, NULL, 4),
(210841, NULL, 'G3DSA:1.10.555.10:FF:000032', NULL, NULL, 'Uncharacterized protein, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(210842, NULL, 'G3DSA:1.20.1720.10:FF:000037', NULL, NULL, 'WGS project CABT00000000 data, contig 2.4', NULL, NULL, NULL, NULL, NULL, 4),
(210843, NULL, 'G3DSA:3.40.50.300:FF:001439', NULL, NULL, 'Cell division control protein 48 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(210844, NULL, 'G3DSA:1.10.510.10:FF:003644', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210845, NULL, 'G3DSA:1.10.10.10:FF:000300', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(210846, NULL, 'G3DSA:1.10.357.140:FF:000015', NULL, NULL, 'Chlorophyll synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(210847, NULL, 'G3DSA:3.10.580.10:FF:000173', NULL, NULL, 'Putative chloride channel', NULL, NULL, NULL, NULL, NULL, 4),
(210848, NULL, 'G3DSA:3.40.630.30:FF:000412', NULL, NULL, 'Putative N-acetyltransferase YjaB', NULL, NULL, NULL, NULL, NULL, 4),
(210849, NULL, 'G3DSA:2.130.10.10:FF:001736', NULL, NULL, 'Pre-rRNA-processing protein IPI3', NULL, NULL, NULL, NULL, NULL, 4),
(210850, NULL, 'G3DSA:2.30.29.30:FF:000778', NULL, NULL, 'Chromosome undetermined SCAF14530, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(210851, NULL, 'G3DSA:3.40.50.410:FF:000022', NULL, NULL, 'Collagen type VI alpha 3 chain', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(210852, NULL, 'G3DSA:3.40.800.10:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210853, NULL, 'G3DSA:3.20.20.80:FF:000614', NULL, NULL, 'Beta-galactosidase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(210854, NULL, 'G3DSA:3.30.200.20:FF:002375', NULL, NULL, 'Serine/threonine-protein kinase phg2', NULL, NULL, NULL, NULL, NULL, 4),
(210855, NULL, 'G3DSA:3.20.20.70:FF:000611', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210856, NULL, 'G3DSA:3.20.70.20:FF:000032', NULL, NULL, 'Ribonucleoside-diphosphate reductase NrdEB subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(210857, NULL, 'G3DSA:2.60.40.3170:FF:000002', NULL, NULL, 'Tripeptidyl-peptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(210858, NULL, 'G3DSA:1.20.1740.10:FF:000038', NULL, NULL, 'Putative sodium-coupled neutral amino acid transporter 7', NULL, NULL, NULL, NULL, NULL, 4),
(210859, NULL, 'G3DSA:1.10.510.10:FF:001553', NULL, NULL, 'Serine/threonine-protein kinase zyg-8', NULL, NULL, NULL, NULL, NULL, 4),
(210860, NULL, 'G3DSA:3.30.160.60:FF:003771', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210861, NULL, 'G3DSA:3.30.70.330:FF:000476', NULL, NULL, 'Zinc finger CCCH domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(210862, NULL, 'G3DSA:3.40.1390.20:FF:000002', NULL, NULL, 'HPr kinase/phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(210863, NULL, 'G3DSA:1.10.287.370:FF:000045', NULL, NULL, 'Tubulin-binding prefolding complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(210864, NULL, 'G3DSA:3.30.70.330:FF:001403', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(210865, NULL, 'G3DSA:3.30.160.60:FF:002658', NULL, NULL, 'C2H2 transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210866, NULL, 'G3DSA:3.30.479.20:FF:000031', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(210867, NULL, 'G3DSA:3.60.20.10:FF:000226', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210868, NULL, 'G3DSA:2.30.30.140:FF:000353', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210869, NULL, 'G3DSA:3.40.1390.30:FF:000005', NULL, NULL, 'Nif3-like dinuclear metal center hexameric protein', NULL, NULL, NULL, NULL, NULL, 4),
(210870, NULL, 'G3DSA:3.30.160.60:FF:001680', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210871, NULL, 'G3DSA:1.10.10.60:FF:001074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210872, NULL, 'G3DSA:3.30.40.10:FF:000353', NULL, NULL, 'E3 ubiquitin-protein ligase KEG', NULL, NULL, NULL, NULL, NULL, 4),
(210873, NULL, 'G3DSA:3.30.479.30:FF:000034', NULL, NULL, 'Stomatin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(210874, NULL, 'G3DSA:3.40.190.10:FF:000788', NULL, NULL, 'ABC-type transport system periplasmic substrate-binding protein (Probable substrate dipeptide/oligopeptide)', NULL, NULL, NULL, NULL, NULL, 4),
(210875, NULL, 'G3DSA:3.40.30.10:FF:000481', NULL, NULL, 'Thiol:disulfide interchange protein DsbD', NULL, NULL, NULL, NULL, NULL, 4),
(210876, NULL, 'G3DSA:3.30.230.10:FF:000047', NULL, NULL, 'DNA topoisomerase 4 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(210877, NULL, 'G3DSA:1.20.272.40:FF:000005', NULL, NULL, 'ATP-dependent RNA helicase SUPV3L1', NULL, NULL, NULL, NULL, NULL, 4),
(210878, NULL, 'G3DSA:1.50.40.10:FF:000244', NULL, NULL, 'Mitochondrial carrier protein (Rim2), putative', NULL, NULL, NULL, NULL, NULL, 4),
(210879, NULL, 'G3DSA:2.60.120.650:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210880, NULL, 'G3DSA:1.10.1670.40:FF:000010', NULL, NULL, 'AFR011Wp', NULL, NULL, NULL, NULL, NULL, 4),
(210881, NULL, 'G3DSA:1.10.630.10:FF:000039', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(210882, NULL, 'G3DSA:3.30.70.330:FF:001460', NULL, NULL, 'RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(210883, NULL, 'G3DSA:1.25.40.10:FF:002399', NULL, NULL, 'PPR repeat/Pentatricopeptide repeat domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210884, NULL, 'G3DSA:2.40.50.140:FF:000338', NULL, NULL, 'Replication protein A large subunit', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(210885, NULL, 'G3DSA:3.40.50.2300:FF:001026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210886, NULL, 'G3DSA:1.10.357.150:FF:000018', NULL, NULL, 'Centromere/kinetochore protein zw10-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(210887, NULL, 'G3DSA:1.20.1560.10:FF:000272', NULL, NULL, 'Lipid A export ATP-binding/permease protein MsbA', NULL, NULL, NULL, NULL, NULL, 4),
(210888, NULL, 'G3DSA:3.80.10.10:FF:002209', NULL, NULL, 'Protein CBG00897', NULL, NULL, NULL, NULL, NULL, 4),
(210889, NULL, 'G3DSA:3.40.50.300:FF:007425', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210890, NULL, 'G3DSA:3.40.390.10:FF:000157', NULL, NULL, 'Disintegrin and metalloproteinase domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(210891, NULL, 'G3DSA:1.20.1110.10:FF:000007', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(210892, NULL, 'G3DSA:3.40.50.11340:FF:000005', NULL, NULL, 'Galactoside 2-alpha-L-fucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(210893, NULL, 'G3DSA:1.20.80.10:FF:000017', NULL, NULL, 'Golgi resident protein GCP60', NULL, NULL, NULL, NULL, NULL, 4),
(210894, NULL, 'G3DSA:1.20.900.10:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210895, NULL, 'G3DSA:2.60.40.1130:FF:000002', NULL, NULL, 'Pullulanase 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(210896, NULL, 'G3DSA:2.40.50.40:FF:000095', NULL, NULL, 'Chromo (CHRromatin Organisation MOdifier) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(210897, NULL, 'G3DSA:1.10.3380.10:FF:000041', NULL, NULL, 'YALI0B13904p', NULL, NULL, NULL, NULL, NULL, 4),
(210898, NULL, 'G3DSA:1.25.10.10:FF:001554', NULL, NULL, 'Protein MOR1', NULL, NULL, NULL, NULL, NULL, 4),
(210899, NULL, 'G3DSA:1.10.260.40:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210900, NULL, 'G3DSA:3.40.720.10:FF:000048', NULL, NULL, 'ectonucleotide pyrophosphatase/phosphodiesterase family member 7', NULL, NULL, NULL, NULL, NULL, 4),
(210901, NULL, 'G3DSA:3.40.50.12670:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210902, NULL, 'G3DSA:3.30.160.60:FF:005480', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210903, NULL, 'G3DSA:2.60.40.10:FF:005356', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210904, NULL, 'G3DSA:3.40.50.2300:FF:000773', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210905, NULL, 'G3DSA:3.30.70.1230:FF:000191', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(210906, NULL, 'G3DSA:3.40.50.1820:FF:000404', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(210907, NULL, 'G3DSA:2.130.10.10:FF:003389', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210908, NULL, 'G3DSA:1.10.8.10:FF:000024', NULL, NULL, 'Ubiquitin domain-containing protein DSK2', NULL, NULL, NULL, NULL, NULL, 4),
(210909, NULL, 'G3DSA:1.10.1300.10:FF:000058', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(210910, NULL, 'G3DSA:3.30.70.330:FF:003056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210911, NULL, 'G3DSA:3.40.440.10:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210912, NULL, 'G3DSA:1.20.1070.10:FF:000419', NULL, NULL, 'Neuropeptide FF receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(210913, NULL, 'G3DSA:3.40.50.620:FF:000405', NULL, NULL, 'Putative icotinic acid mononucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(210914, NULL, 'G3DSA:3.40.50.300:FF:001771', NULL, NULL, 'RAB8B, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(210915, NULL, 'G3DSA:1.25.40.10:FF:002629', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g18110, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(210916, NULL, 'G3DSA:3.40.50.720:FF:001014', NULL, NULL, 'Erythronate-4-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(210917, NULL, 'G3DSA:2.30.30.870:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(210918, NULL, 'G3DSA:3.30.40.10:FF:000914', NULL, NULL, 'RWD domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(210919, NULL, 'G3DSA:1.20.1250.20:FF:002117', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(210920, NULL, 'G3DSA:2.130.10.10:FF:005334', NULL, NULL, 'WD-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210921, NULL, 'G3DSA:3.40.50.450:FF:000039', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(210922, NULL, 'G3DSA:3.40.50.11890:FF:000001', NULL, NULL, 'Putative 2-hydroxyglutaryl-CoA dehydratase, D-component', NULL, NULL, NULL, NULL, NULL, 4),
(210923, NULL, 'G3DSA:3.40.50.12780:FF:000044', NULL, NULL, 'Short-chain-fatty-acid--CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(210924, NULL, 'G3DSA:2.60.40.1150:FF:000008', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(210925, NULL, 'G3DSA:1.20.1050.10:FF:000188', NULL, NULL, 'Hematopoietic prostaglandin D synthase', NULL, NULL, NULL, NULL, NULL, 4),
(210926, NULL, 'G3DSA:3.40.50.1010:FF:000173', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210927, NULL, 'G3DSA:3.60.110.10:FF:000065', NULL, NULL, 'Nitrilase/amidohydrolase superfamily protein, class 8', NULL, NULL, NULL, NULL, NULL, 4),
(210928, NULL, 'G3DSA:3.30.160.60:FF:001528', NULL, NULL, 'Zinc finger and SCAN domain containing 9', NULL, NULL, NULL, NULL, NULL, 4),
(210929, NULL, 'G3DSA:1.20.58.1180:FF:000004', NULL, NULL, 'Phosphatidylethanolamine-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(210930, NULL, 'G3DSA:1.10.510.10:FF:000210', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(210931, NULL, 'G3DSA:1.10.150.170:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210932, NULL, 'G3DSA:3.90.79.10:FF:000299', NULL, NULL, 'Transcriptional repressor of nicotinamide riboside utilization NrtR', NULL, NULL, NULL, NULL, NULL, 4),
(210933, NULL, 'G3DSA:1.20.58.60:FF:000632', NULL, NULL, 'Spectrin repeat-containing, nuclear envelope 1b', NULL, NULL, NULL, NULL, NULL, 4),
(210934, NULL, 'G3DSA:2.10.70.10:FF:000150', NULL, NULL, 'Complement factor H related 5', NULL, NULL, NULL, NULL, NULL, 4),
(210935, NULL, 'G3DSA:1.10.287.130:FF:000265', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(210936, NULL, 'G3DSA:1.10.10.10:FF:001374', NULL, NULL, 'Ferric uptake regulator family protein', NULL, NULL, NULL, NULL, NULL, 4),
(210937, NULL, 'G3DSA:3.40.50.10420:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210938, NULL, 'G3DSA:1.10.1370.10:FF:000006', NULL, NULL, 'mitochondrial intermediate peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(210939, NULL, 'G3DSA:3.30.70.330:FF:002893', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210940, NULL, 'G3DSA:3.40.50.2300:FF:001116', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210941, NULL, 'G3DSA:1.25.40.20:FF:001328', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(210942, NULL, 'G3DSA:1.20.1250.20:FF:000228', NULL, NULL, 'Battenin', NULL, NULL, NULL, NULL, NULL, 4),
(210943, NULL, 'G3DSA:3.80.10.10:FF:004452', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210944, NULL, 'G3DSA:3.80.10.10:FF:004249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210945, NULL, 'G3DSA:3.40.50.300:FF:003682', NULL, NULL, 'Caspase recruitment domain family, member 11', NULL, NULL, NULL, NULL, NULL, 4),
(210946, NULL, 'G3DSA:1.25.10.10:FF:000683', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(210947, NULL, 'G3DSA:3.30.559.10:FF:000259', NULL, NULL, 'Acyltransferase easC', NULL, NULL, NULL, NULL, NULL, 4),
(210948, NULL, 'G3DSA:1.25.40.20:FF:001856', NULL, NULL, 'Mitogen activated protein kinase kinase kinase 3, MAPKKK3, MEKK3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210949, NULL, 'G3DSA:2.60.120.200:FF:000016', NULL, NULL, 'Collagen XI alpha 1 chain', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(210950, NULL, 'G3DSA:3.40.1110.10:FF:000041', NULL, NULL, 'Magnesium-translocating P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(210951, NULL, 'G3DSA:3.50.50.60:FF:000362', NULL, NULL, 'All-trans-retinol 13,14-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(210952, NULL, 'G3DSA:1.10.238.10:FF:000110', NULL, NULL, 'calumenin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(210953, NULL, 'G3DSA:3.20.20.80:FF:000294', NULL, NULL, 'Beta-glucosidase 11', NULL, NULL, NULL, NULL, NULL, 4),
(210954, NULL, 'G3DSA:4.10.1250.10:FF:000006', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(210955, NULL, 'G3DSA:1.25.40.10:FF:005125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210956, NULL, 'G3DSA:1.10.287.70:FF:000180', NULL, NULL, 'Ionotropic receptor 75a', NULL, NULL, NULL, NULL, NULL, 4),
(210957, NULL, 'G3DSA:1.10.287.130:FF:000226', NULL, NULL, 'Two component system histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(210958, NULL, 'G3DSA:3.10.290.20:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210959, NULL, 'G3DSA:3.40.50.300:FF:007279', NULL, NULL, 'Origin recognition complex subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(210960, NULL, 'G3DSA:1.10.510.10:FF:003554', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210961, NULL, 'G3DSA:3.40.50.300:FF:003479', NULL, NULL, 'Benign gonial cell neoplasm', NULL, NULL, NULL, NULL, NULL, 4),
(210962, NULL, 'G3DSA:4.10.280.10:FF:000005', NULL, NULL, 'Myogenic factor', NULL, NULL, NULL, NULL, NULL, 4),
(210963, NULL, 'G3DSA:1.10.555.10:FF:000122', NULL, NULL, 'Rho GTPase Activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(210964, NULL, 'G3DSA:1.20.1050.10:FF:000098', NULL, NULL, 'Protein Translation Elongation Factor 1B subunitbeta (EF-1Bb)/1-gamma', NULL, NULL, NULL, NULL, NULL, 4),
(210965, NULL, 'G3DSA:1.25.40.10:FF:002961', NULL, NULL, 'Os04g0676200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(210966, NULL, 'G3DSA:2.60.40.3710:FF:000006', NULL, NULL, 'L,D-transpeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(210967, NULL, 'G3DSA:3.30.40.10:FF:000824', NULL, NULL, 'E3 ubiquitin-protein ligase RNF13', NULL, NULL, NULL, NULL, NULL, 4),
(210968, NULL, 'G3DSA:2.130.10.30:FF:000107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210969, NULL, 'G3DSA:1.25.40.10:FF:001325', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(210970, NULL, 'G3DSA:1.20.1250.20:FF:000375', NULL, NULL, 'Glycoside-Pentoside-Hexuronide (GPH):Cation Symporter Family', NULL, NULL, NULL, NULL, NULL, 4),
(210971, NULL, 'G3DSA:2.60.110.10:FF:000007', NULL, NULL, 'Osmotin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(210972, NULL, 'G3DSA:3.30.70.3400:FF:000010', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(210973, NULL, 'G3DSA:1.20.1250.20:FF:001864', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210974, NULL, 'G3DSA:2.10.110.10:FF:000097', NULL, NULL, 'Filamin-binding LIM protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(210975, NULL, 'G3DSA:1.10.287.110:FF:000220', NULL, NULL, 'DnaJ (Hsp40) homolog, subfamily A, member 4', NULL, NULL, NULL, NULL, NULL, 4),
(210976, NULL, 'G3DSA:1.25.40.20:FF:000081', NULL, NULL, 'Kinase D-interacting substrate of 220 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(210977, NULL, 'G3DSA:2.40.50.140:FF:001029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210978, NULL, 'G3DSA:3.20.20.70:FF:000049', NULL, NULL, 'Thiazole synthase', NULL, NULL, NULL, NULL, NULL, 4),
(210979, NULL, 'G3DSA:3.30.160.60:FF:000191', NULL, NULL, 'zinc finger protein 366', NULL, NULL, NULL, NULL, NULL, 4),
(210980, NULL, 'G3DSA:4.10.280.10:FF:000062', NULL, NULL, 'Neuronal PAS domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(210981, NULL, 'G3DSA:3.30.70.330:FF:002836', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210982, NULL, 'G3DSA:2.60.120.920:FF:000029', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM36', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(210983, NULL, 'G3DSA:1.10.150.20:FF:000314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(210984, NULL, 'G3DSA:3.30.40.10:FF:000297', NULL, NULL, 'tripartite motif-containing protein 59', NULL, NULL, NULL, NULL, NULL, 4),
(210985, NULL, 'G3DSA:1.10.8.60:FF:000342', NULL, NULL, 'Peroxisome assembly protein Pex1p', NULL, NULL, NULL, NULL, NULL, 4),
(210986, NULL, 'G3DSA:3.30.160.60:FF:005570', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210987, NULL, 'G3DSA:3.40.50.300:FF:003064', NULL, NULL, 'ATP-dependent dethiobiotin synthetase BioD', NULL, NULL, NULL, NULL, NULL, 4),
(210988, NULL, 'G3DSA:3.40.50.11210:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210989, NULL, 'G3DSA:1.10.238.10:FF:000487', NULL, NULL, 'Myosin, essential light chain', NULL, NULL, NULL, NULL, NULL, 4),
(210990, NULL, 'G3DSA:2.60.120.1000:FF:000031', NULL, NULL, 'Collagen, type I, alpha 1a', NULL, NULL, NULL, NULL, NULL, 4),
(210991, NULL, 'G3DSA:1.20.1150.12:FF:000001', NULL, NULL, 'Endoplasmic reticulum resident protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(210992, NULL, 'G3DSA:1.10.10.10:FF:001227', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(210993, NULL, 'G3DSA:3.60.21.10:FF:000341', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(210994, NULL, 'G3DSA:3.40.50.1820:FF:000348', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(210995, NULL, 'G3DSA:1.20.1270.10:FF:000081', NULL, NULL, 'Heat shock cognate protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210996, NULL, 'G3DSA:3.30.1370.100:FF:000001', NULL, NULL, 'Mismatch repair endonuclease pms1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(210997, NULL, 'G3DSA:1.10.10.10:FF:001317', NULL, NULL, 'Related to RPC82-RNA polymerase III subunit C82', NULL, NULL, NULL, NULL, NULL, 4),
(210998, NULL, 'G3DSA:3.30.160.60:FF:003714', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(210999, NULL, 'G3DSA:1.25.40.10:FF:001943', NULL, NULL, 'Os08g0538800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(211000, NULL, 'G3DSA:3.55.40.20:FF:000018', NULL, NULL, 'Superoxide dismutase [Mn], mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(211001, NULL, 'G3DSA:3.30.160.60:FF:003529', NULL, NULL, 'Misexpression suppressor of ras 4, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(211002, NULL, 'G3DSA:3.30.200.20:FF:000992', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(211003, NULL, 'G3DSA:2.10.25.10:FF:000461', NULL, NULL, 'laminin subunit alpha-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(211004, NULL, 'G3DSA:3.40.50.300:FF:003569', NULL, NULL, 'Probable ATP-binding component of ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(211005, NULL, 'G3DSA:3.40.50.720:FF:002088', NULL, NULL, 'Glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(211006, NULL, 'G3DSA:3.30.160.60:FF:005328', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211007, NULL, 'G3DSA:4.10.970.10:FF:000002', NULL, NULL, 'Atp-dependent dna helicase 2', NULL, NULL, NULL, NULL, NULL, 4),
(211008, NULL, 'G3DSA:1.10.472.80:FF:000113', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(211009, NULL, 'G3DSA:3.90.550.10:FF:000170', NULL, NULL, 'Dolichol-phosphate mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(211010, NULL, 'G3DSA:3.80.10.10:FF:000652', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RPK2', NULL, NULL, NULL, NULL, NULL, 4),
(211011, NULL, 'G3DSA:2.10.25.10:FF:000219', NULL, NULL, 'Pro-epidermal growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(211012, NULL, 'G3DSA:1.25.40.10:FF:005215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211013, NULL, 'G3DSA:3.40.1120.10:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211014, NULL, 'G3DSA:2.10.70.10:FF:000060', NULL, NULL, 'Complement inhibitory factor H', NULL, NULL, NULL, NULL, NULL, 4),
(211015, NULL, 'G3DSA:2.60.120.200:FF:000488', NULL, NULL, 'Laminin, alpha 3', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(211016, NULL, 'G3DSA:2.40.50.140:FF:000956', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211017, NULL, 'G3DSA:2.60.470.10:FF:000005', NULL, NULL, 'Amiloride-sensitive sodium channel subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(211018, NULL, 'G3DSA:2.70.130.10:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211019, NULL, 'G3DSA:3.30.70.260:FF:000135', NULL, NULL, 'Ribose 5-phosphate isomerase (RpiA)', NULL, NULL, NULL, NULL, NULL, 4),
(211020, NULL, 'G3DSA:1.10.1240.10:FF:000002', NULL, NULL, 'Methionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(211021, NULL, 'G3DSA:1.10.10.1210:FF:000004', NULL, NULL, 'Unplaced genomic scaffold supercont1.8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(211022, NULL, 'G3DSA:1.10.10.2120:FF:000002', NULL, NULL, 'Acyl-coenzyme A:6-aminopenicillanic-acid-acyltransferase 40 kDa form', NULL, NULL, NULL, NULL, NULL, 4),
(211023, NULL, 'G3DSA:2.10.70.10:FF:000240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211024, NULL, 'G3DSA:1.10.101.10:FF:000035', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(211025, NULL, 'G3DSA:3.30.40.10:FF:001134', NULL, NULL, 'E3 ubiquitin-protein ligase Zswim2', NULL, NULL, NULL, NULL, NULL, 4),
(211026, NULL, 'G3DSA:1.10.287.370:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211027, NULL, 'G3DSA:3.80.10.10:FF:001956', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(211028, NULL, 'G3DSA:1.25.40.10:FF:005035', NULL, NULL, 'LP07472p', NULL, NULL, NULL, NULL, NULL, 4),
(211029, NULL, 'G3DSA:3.40.50.300:FF:003625', NULL, NULL, 'Helicase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(211030, NULL, 'G3DSA:2.40.50.140:FF:000866', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211031, NULL, 'G3DSA:3.40.50.1820:FF:000876', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211032, NULL, 'G3DSA:1.20.5.170:FF:000208', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(211033, NULL, 'G3DSA:2.130.10.10:FF:003535', NULL, NULL, 'F-box and WD repeat domain-containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(211034, NULL, 'G3DSA:1.20.1730.10:FF:000066', NULL, NULL, 'Sodium/glucose cotransporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(211035, NULL, 'G3DSA:3.40.50.1820:FF:000909', NULL, NULL, 'Alpha/beta-Hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(211036, NULL, 'G3DSA:1.20.1250.20:FF:000846', NULL, NULL, 'Multidrug resistance protein VceB', NULL, NULL, NULL, NULL, NULL, 4),
(211037, NULL, 'G3DSA:1.25.40.10:FF:004759', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211038, NULL, 'G3DSA:3.60.21.10:FF:000009', NULL, NULL, 'Vacuolar protein sorting-associated protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(211039, NULL, 'G3DSA:3.40.1110.10:FF:000131', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(211040, NULL, 'G3DSA:1.10.287.110:FF:000107', NULL, NULL, 'Related to DJP1-DnaJ-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(211041, NULL, 'G3DSA:3.30.40.10:FF:002062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211042, NULL, 'G3DSA:3.30.70.260:FF:000045', NULL, NULL, 'Homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(211043, NULL, 'G3DSA:2.40.50.140:FF:000809', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211044, NULL, 'G3DSA:1.25.40.20:FF:001385', NULL, NULL, 'Calmodulin-binding transcription activator 2', NULL, NULL, NULL, NULL, NULL, 4),
(211045, NULL, 'G3DSA:3.30.1370.110:FF:000004', NULL, NULL, 'Endonuclease MutS2', NULL, NULL, NULL, NULL, NULL, 4),
(211046, NULL, 'G3DSA:1.25.40.10:FF:001382', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(211047, NULL, 'G3DSA:2.40.340.10:FF:000006', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(211048, NULL, 'G3DSA:1.20.1730.10:FF:000009', NULL, NULL, 'Cation acetate symporter', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(211049, NULL, 'G3DSA:2.60.260.40:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211050, NULL, 'G3DSA:2.10.109.10:FF:000026', NULL, NULL, 'HTH-type transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(211051, NULL, 'G3DSA:1.20.140.10:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211052, NULL, 'G3DSA:3.30.70.330:FF:003112', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211053, NULL, 'G3DSA:3.40.710.10:FF:000019', NULL, NULL, 'Beta-lactamase', NULL, NULL, NULL, NULL, NULL, 4),
(211054, NULL, 'G3DSA:3.40.50.360:FF:000080', NULL, NULL, 'NADPH-dependent fmn reductase', NULL, NULL, NULL, NULL, NULL, 4),
(211055, NULL, 'G3DSA:3.40.190.120:FF:000010', NULL, NULL, 'Glycine betaine transport system permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(211056, NULL, 'G3DSA:3.40.50.2300:FF:000953', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211057, NULL, 'G3DSA:1.10.472.80:FF:000023', NULL, NULL, 'TBC1 domain family member 8B', NULL, NULL, NULL, NULL, NULL, 4),
(211058, NULL, 'G3DSA:3.30.70.270:FF:000290', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211059, NULL, 'G3DSA:3.40.50.720:FF:000609', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(211060, NULL, 'G3DSA:3.30.160.60:FF:004024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211061, NULL, 'G3DSA:1.20.5.170:FF:000265', NULL, NULL, 'Viral A-type inclusion protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211062, NULL, 'G3DSA:1.20.1250.20:FF:000318', NULL, NULL, 'MFS multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211063, NULL, 'G3DSA:3.40.50.720:FF:000851', NULL, NULL, 'Probable 2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(211064, NULL, 'G3DSA:3.40.50.620:FF:000349', NULL, NULL, 'Electron transfer flavoprotein beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(211065, NULL, 'G3DSA:3.30.70.270:FF:000048', NULL, NULL, 'Gag-Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(211066, NULL, 'G3DSA:3.40.1000.70:FF:000005', NULL, NULL, 'Serine/threonine-protein kinase PknH', NULL, NULL, NULL, NULL, NULL, 4),
(211067, NULL, 'G3DSA:2.60.40.10:FF:003226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211068, NULL, 'G3DSA:3.40.50.12710:FF:000006', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7', NULL, NULL, NULL, NULL, NULL, 4),
(211069, NULL, 'G3DSA:1.20.1270.60:FF:000247', NULL, NULL, 'Rho GTPase-activating protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(211070, NULL, 'G3DSA:2.40.50.140:FF:001119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211071, NULL, 'G3DSA:3.40.50.1820:FF:000258', NULL, NULL, 'WGS project CABT00000000 data, contig 2.27', NULL, NULL, NULL, NULL, NULL, 4),
(211072, NULL, 'G3DSA:1.20.1600.10:FF:000062', NULL, NULL, 'Putative outer membrane protein TolC', NULL, NULL, NULL, NULL, NULL, 4),
(211073, NULL, 'G3DSA:3.10.20.310:FF:000015', NULL, NULL, 'Outer membrane protein assembly factor BamA', NULL, NULL, NULL, NULL, NULL, 4),
(211074, NULL, 'G3DSA:3.20.20.105:FF:000001', NULL, NULL, 'Queuine tRNA-ribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(211075, NULL, 'G3DSA:3.90.1420.10:FF:000002', NULL, NULL, 'N-lysine methyltransferase SETD6', NULL, NULL, NULL, NULL, NULL, 4),
(211076, NULL, 'G3DSA:3.40.50.300:FF:006969', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211077, NULL, 'G3DSA:3.10.20.90:FF:000758', NULL, NULL, 'Wall-associated receptor kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(211078, NULL, 'G3DSA:2.130.10.30:FF:000017', NULL, NULL, 'Serine/threonine-protein kinase Nek8', NULL, NULL, NULL, NULL, NULL, 4),
(211079, NULL, 'G3DSA:3.40.50.620:FF:000259', NULL, NULL, 'Methionine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(211080, NULL, 'G3DSA:2.130.10.10:FF:000011', NULL, NULL, 'Echinoderm microtubule-associated protein-like 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(211081, NULL, 'G3DSA:3.30.200.20:FF:000464', NULL, NULL, 'Cdc2-related protein kinase 5', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(211082, NULL, 'G3DSA:3.90.45.10:FF:000035', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(211083, NULL, 'G3DSA:2.10.25.10:FF:000551', NULL, NULL, 'Protein delta homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(211084, NULL, 'G3DSA:3.40.1190.20:FF:000060', NULL, NULL, 'Phosphomethylpyrimidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(211085, NULL, 'G3DSA:1.25.10.10:FF:001700', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211086, NULL, 'G3DSA:2.130.10.10:FF:003445', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211087, NULL, 'G3DSA:3.80.10.10:FF:000562', NULL, NULL, 'Protein NSP-INTERACTING KINASE 2', NULL, NULL, NULL, NULL, NULL, 4),
(211088, NULL, 'G3DSA:1.10.8.60:FF:000432', NULL, NULL, 'AAA family ATPase peroxin 1', NULL, NULL, NULL, NULL, NULL, 4),
(211089, NULL, 'G3DSA:3.40.50.2000:FF:000801', NULL, NULL, 'Os03g0824600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(211090, NULL, 'G3DSA:2.130.10.10:FF:000101', NULL, NULL, 'WD repeat-containing protein 20 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(211091, NULL, 'G3DSA:1.10.196.10:FF:000006', NULL, NULL, 'regulator of G-protein signaling 10 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(211092, NULL, 'G3DSA:2.20.70.10:FF:000099', NULL, NULL, 'E3 ubiquitin-protein ligase NEDD4', NULL, NULL, NULL, NULL, NULL, 4),
(211093, NULL, 'G3DSA:3.40.30.10:FF:001167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211094, NULL, 'G3DSA:1.25.10.10:FF:000250', NULL, NULL, 'Phospholipase A-2-activating protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(211095, NULL, 'G3DSA:1.10.238.20:FF:000057', NULL, NULL, 'Odorant binding protein C19', NULL, NULL, NULL, NULL, NULL, 4),
(211096, NULL, 'G3DSA:3.30.70.330:FF:002275', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211097, NULL, 'G3DSA:1.25.40.10:FF:004198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211098, NULL, 'G3DSA:1.10.238.10:FF:000054', NULL, NULL, 'Calbindin 2', NULL, NULL, NULL, NULL, NULL, 4),
(211099, NULL, 'G3DSA:1.20.1250.20:FF:000285', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(211100, NULL, 'G3DSA:1.10.287.70:FF:000741', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211101, NULL, 'G3DSA:3.30.1300.30:FF:000007', NULL, NULL, 'Type II secretion system protein K', NULL, NULL, NULL, NULL, NULL, 4),
(211102, NULL, 'G3DSA:1.10.510.10:FF:000007', NULL, NULL, 'Fibroblast growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(211103, NULL, 'G3DSA:3.40.50.720:FF:000233', NULL, NULL, 'Glucose-fructose oxidoreductase domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(211104, NULL, 'G3DSA:3.40.33.10:FF:000100', NULL, NULL, 'Predicted extracellular protein', NULL, NULL, NULL, NULL, NULL, 4),
(211105, NULL, 'G3DSA:1.10.418.40:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211106, NULL, 'G3DSA:3.40.50.10820:FF:000001', NULL, NULL, 'Inositol-tetrakisphosphate 1-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(211107, NULL, 'G3DSA:3.30.710.10:FF:000359', NULL, NULL, 'Potassium voltage-gated channel, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211108, NULL, 'G3DSA:3.30.420.270:FF:000009', NULL, NULL, 'Transport energizing protein, ExbD/TolR family', NULL, NULL, NULL, NULL, NULL, 4),
(211109, NULL, 'G3DSA:3.30.540.30:FF:000014', NULL, NULL, 'Dipeptidyl peptidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(211110, NULL, 'G3DSA:1.20.1250.20:FF:000936', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211111, NULL, 'G3DSA:3.30.40.10:FF:000768', NULL, NULL, 'PHD finger transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(211112, NULL, 'G3DSA:3.10.50.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211113, NULL, 'G3DSA:1.10.268.10:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211114, NULL, 'G3DSA:1.25.40.10:FF:001387', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g39620', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(211115, NULL, 'G3DSA:3.30.160.60:FF:001118', NULL, NULL, 'zinc finger protein 197 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(211116, NULL, 'G3DSA:1.20.58.60:FF:000806', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211117, NULL, 'G3DSA:3.20.20.240:FF:000003', NULL, NULL, 'Fused isobutyryl-CoA mutase', NULL, NULL, NULL, NULL, NULL, 4),
(211118, NULL, 'G3DSA:3.90.1150.10:FF:000487', NULL, NULL, 'Ornithine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(211119, NULL, 'G3DSA:3.40.50.1820:FF:000910', NULL, NULL, 'Alpha/beta hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211120, NULL, 'G3DSA:3.40.50.2000:FF:000447', NULL, NULL, 'Phosphatidylinositol glycan, class A', NULL, NULL, NULL, NULL, NULL, 4),
(211121, NULL, 'G3DSA:3.30.40.10:FF:000358', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(211122, NULL, 'G3DSA:3.30.70.330:FF:002483', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211123, NULL, 'G3DSA:3.80.10.10:FF:002187', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211124, NULL, 'G3DSA:3.40.50.12780:FF:000167', NULL, NULL, 'Meiotically up-regulated gene 62 protein', NULL, NULL, NULL, NULL, NULL, 4),
(211125, NULL, 'G3DSA:1.20.1270.10:FF:000114', NULL, NULL, 'AGAP004581-PA', NULL, NULL, NULL, NULL, NULL, 4),
(211126, NULL, 'G3DSA:2.130.10.10:FF:002220', NULL, NULL, 'EMAP-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(211127, NULL, 'G3DSA:3.40.50.720:FF:000519', NULL, NULL, 'NAD(P)(+) transhydrogenase (AB-specific), alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(211128, NULL, 'G3DSA:3.40.50.300:FF:005222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211129, NULL, 'G3DSA:2.130.10.10:FF:003743', NULL, NULL, 'Uncharacterized protein C3H8.05c', NULL, NULL, NULL, NULL, NULL, 4),
(211130, NULL, 'G3DSA:2.60.40.10:FF:001641', NULL, NULL, 'Myoblast growth factor receptor egl-15', NULL, NULL, NULL, NULL, NULL, 4),
(211131, NULL, 'G3DSA:1.20.1690.10:FF:000011', NULL, NULL, 'V-type proton ATPase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(211132, NULL, 'G3DSA:1.20.58.1120:FF:000008', NULL, NULL, 'Dynein heavy chain 10, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(211133, NULL, 'G3DSA:3.40.50.10330:FF:000040', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(211134, NULL, 'G3DSA:2.60.120.340:FF:000013', NULL, NULL, '39 kDa FK506-binding nuclear protein', NULL, NULL, NULL, NULL, NULL, 4),
(211135, NULL, 'G3DSA:3.40.50.150:FF:001652', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211136, NULL, 'G3DSA:3.40.50.1010:FF:000201', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211137, NULL, 'G3DSA:3.30.70.330:FF:003051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211138, NULL, 'G3DSA:3.40.1110.10:FF:000097', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(211139, NULL, 'G3DSA:1.10.540.10:FF:000043', NULL, NULL, 'Acyl-CoA dehydrogenase FadE6', NULL, NULL, NULL, NULL, NULL, 4),
(211140, NULL, 'G3DSA:1.10.10.10:FF:000210', NULL, NULL, 'Winged-helix transcriptional response regulator KdpE', NULL, NULL, NULL, NULL, NULL, 4),
(211141, NULL, 'G3DSA:4.10.240.10:FF:000059', NULL, NULL, 'C6 transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211142, NULL, 'G3DSA:1.10.620.20:FF:000047', NULL, NULL, 'Acyl-[acyl-carrier-protein] desaturase', NULL, NULL, NULL, NULL, NULL, 4),
(211143, NULL, 'G3DSA:2.30.29.30:FF:001003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211144, NULL, 'G3DSA:3.30.70.330:FF:000919', NULL, NULL, 'Nrp1p', NULL, NULL, NULL, NULL, NULL, 4),
(211145, NULL, 'G3DSA:2.60.20.10:FF:000004', NULL, NULL, 'Crystallin beta A4', NULL, NULL, NULL, NULL, NULL, 4),
(211146, NULL, 'G3DSA:1.20.120.1220:FF:000013', NULL, NULL, 'Peptidase A24A prepilin type IV', NULL, NULL, NULL, NULL, NULL, 4),
(211147, NULL, 'G3DSA:2.130.10.10:FF:004878', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211148, NULL, 'G3DSA:3.30.70.270:FF:000087', NULL, NULL, 'YALI0E34980p', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(211149, NULL, 'G3DSA:1.20.1070.10:FF:000279', NULL, NULL, 'Trace amine-associated receptor 16f', NULL, NULL, NULL, NULL, NULL, 4),
(211150, NULL, 'G3DSA:2.60.40.10:FF:003765', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211151, NULL, 'G3DSA:2.40.50.140:FF:001243', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211152, NULL, 'G3DSA:3.60.20.10:FF:000103', NULL, NULL, 'ASparagiNe Synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(211153, NULL, 'G3DSA:3.30.920.10:FF:000026', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(211154, NULL, 'G3DSA:3.40.50.2300:FF:000386', NULL, NULL, 'Glutamate receptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(211155, NULL, 'G3DSA:3.40.50.1820:FF:000264', NULL, NULL, 'Retinoid-inducible serine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(211156, NULL, 'G3DSA:2.30.29.30:FF:000918', NULL, NULL, 'Decapping mRNA 1A', NULL, NULL, NULL, NULL, NULL, 4),
(211157, NULL, 'G3DSA:3.30.1510.10:FF:000006', NULL, NULL, 'Formate--tetrahydrofolate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(211158, NULL, 'G3DSA:1.10.510.10:FF:003088', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211159, NULL, 'G3DSA:3.40.50.970:FF:000162', NULL, NULL, 'Benzaldehyde lyase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211160, NULL, 'G3DSA:3.40.190.10:FF:000288', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(211161, NULL, 'G3DSA:3.40.1110.10:FF:000046', NULL, NULL, 'Copper-transporting ATPase PAA2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(211162, NULL, 'G3DSA:1.20.1070.10:FF:001965', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211163, NULL, 'G3DSA:2.130.10.10:FF:001652', NULL, NULL, 'WD repeat and SOF domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(211164, NULL, 'G3DSA:3.40.50.11850:FF:000012', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(211165, NULL, 'G3DSA:1.10.640.10:FF:000039', NULL, NULL, 'Peroxinectin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211166, NULL, 'G3DSA:1.20.1280.50:FF:000104', NULL, NULL, 'GD11494', NULL, NULL, NULL, NULL, NULL, 4),
(211167, NULL, 'G3DSA:3.40.50.12230:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211168, NULL, 'G3DSA:3.50.50.60:FF:000867', NULL, NULL, 'Slr1998 protein', NULL, NULL, NULL, NULL, NULL, 4),
(211169, NULL, 'G3DSA:1.25.10.10:FF:001464', NULL, NULL, 'E3 ubiquitin-protein ligase UPL1', NULL, NULL, NULL, NULL, NULL, 4),
(211170, NULL, 'G3DSA:3.30.420.140:FF:000049', NULL, NULL, 'Si:ch211-117n7.8', NULL, NULL, NULL, NULL, NULL, 4),
(211171, NULL, 'G3DSA:3.30.160.60:FF:005452', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211172, NULL, 'G3DSA:1.25.10.10:FF:001790', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211173, NULL, 'G3DSA:3.30.70.270:FF:000312', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211174, NULL, 'G3DSA:3.40.20.10:FF:000160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211175, NULL, 'G3DSA:1.10.8.60:FF:000218', NULL, NULL, 'PEX1p AAA-peroxin', NULL, NULL, NULL, NULL, NULL, 4),
(211176, NULL, 'G3DSA:1.10.246.190:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211177, NULL, 'G3DSA:1.10.8.100:FF:000027', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(211178, NULL, 'G3DSA:3.80.10.10:FF:003873', NULL, NULL, 'Adenylate cyclase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211179, NULL, 'G3DSA:3.40.1180.10:FF:000045', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(211180, NULL, 'G3DSA:3.40.47.10:FF:000194', NULL, NULL, 'Polyketide synthase RzxE', NULL, NULL, NULL, NULL, NULL, 4),
(211181, NULL, 'G3DSA:1.25.40.10:FF:001292', NULL, NULL, 'Tetratricopeptide repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(211182, NULL, 'G3DSA:2.30.30.140:FF:000230', NULL, NULL, 'Ubiquitin like with PHD and ring finger domains 2', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(211183, NULL, 'G3DSA:1.10.10.2330:FF:000003', NULL, NULL, 'Phenylalanine--tRNA ligase alpha subunit cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(211184, NULL, 'G3DSA:3.30.70.1230:FF:000213', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(211185, NULL, 'G3DSA:1.10.10.10:FF:001733', NULL, NULL, 'Two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(211186, NULL, 'G3DSA:3.40.50.300:FF:005273', NULL, NULL, 'Hpr(Ser) kinase', NULL, NULL, NULL, NULL, NULL, 4),
(211187, NULL, 'G3DSA:3.40.50.300:FF:001911', NULL, NULL, 'ATP-dependent Clp protease ATP-binding subunit ClpX', NULL, NULL, NULL, NULL, NULL, 4),
(211188, NULL, 'G3DSA:1.20.58.70:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211189, NULL, 'G3DSA:1.25.40.10:FF:000398', NULL, NULL, 'pentatricopeptide repeat-containing protein PNM1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(211190, NULL, 'G3DSA:2.130.10.10:FF:004199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211191, NULL, 'G3DSA:1.10.8.60:FF:000544', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211192, NULL, 'G3DSA:2.60.40.150:FF:000649', NULL, NULL, 'Plant synaptotagmin: integral membrane double C2 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(211193, NULL, 'G3DSA:2.60.120.330:FF:000061', NULL, NULL, '2-oxoglutarate-dependent dioxygenase AOP3', NULL, NULL, NULL, NULL, NULL, 4),
(211194, NULL, 'G3DSA:3.60.10.10:FF:000164', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 5-phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211195, NULL, 'G3DSA:1.25.10.10:FF:001559', NULL, NULL, 'AGAP007299-PA', NULL, NULL, NULL, NULL, NULL, 4),
(211196, NULL, 'G3DSA:3.30.2140.20:FF:000003', NULL, NULL, 'Arylamine N-acetyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(211197, NULL, 'G3DSA:1.20.58.60:FF:000065', NULL, NULL, 'plectin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(211198, NULL, 'G3DSA:1.10.287.70:FF:000590', NULL, NULL, 'Glutamate receptor ionotropic, delta-1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(211199, NULL, 'G3DSA:1.20.120.890:FF:000002', NULL, NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', NULL, NULL, NULL, NULL, NULL, 4),
(211200, NULL, 'G3DSA:1.10.510.10:FF:001643', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(211201, NULL, 'G3DSA:2.130.10.10:FF:000888', NULL, NULL, 'CPSF (Cleavage and polyadenylation specific factor)', NULL, NULL, NULL, NULL, NULL, 4),
(211202, NULL, 'G3DSA:1.10.196.10:FF:000012', NULL, NULL, 'Regulator of G-protein signaling egl-10', NULL, NULL, NULL, NULL, NULL, 4),
(211203, NULL, 'G3DSA:1.25.10.10:FF:000896', NULL, NULL, 'Adaptin N terminal region family protein', NULL, NULL, NULL, NULL, NULL, 4),
(211204, NULL, 'G3DSA:3.30.420.10:FF:000258', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(211205, NULL, 'G3DSA:3.30.40.10:FF:001252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211206, NULL, 'G3DSA:1.25.40.20:FF:001295', NULL, NULL, 'Kank, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(211207, NULL, 'G3DSA:3.40.50.300:FF:007346', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211208, NULL, 'G3DSA:3.60.40.10:FF:000054', NULL, NULL, 'Protein phosphatase type 2C', NULL, NULL, NULL, NULL, NULL, 4),
(211209, NULL, 'G3DSA:3.40.50.2300:FF:001324', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211210, NULL, 'G3DSA:3.30.710.10:FF:000073', NULL, NULL, 'Zinc finger and BTB domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(211211, NULL, 'G3DSA:3.30.160.20:FF:000016', NULL, NULL, 'ATP-dependent RNA helicase DHX30 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(211212, NULL, 'G3DSA:3.60.130.10:FF:000038', NULL, NULL, 'Taurine catabolism dioxygenase TauD, TfdA family-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(211213, NULL, 'G3DSA:1.25.10.10:FF:002987', NULL, NULL, 'Beta-tubulin cofactor D, putative', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(211214, NULL, 'G3DSA:3.30.70.850:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211215, NULL, 'G3DSA:3.30.200.20:FF:001239', NULL, NULL, 'Ribosomal protein S6 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(211216, NULL, 'G3DSA:3.90.180.10:FF:000091', NULL, NULL, 'Aspergillus niger contig An11c0010, genomic contig', NULL, NULL, NULL, NULL, NULL, 4),
(211217, NULL, 'G3DSA:3.60.40.10:FF:000380', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211218, NULL, 'G3DSA:3.40.50.300:FF:005952', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(211219, NULL, 'G3DSA:3.90.1300.10:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211220, NULL, 'G3DSA:1.10.287.70:FF:000359', NULL, NULL, 'TWiK family of potassium channels', NULL, NULL, NULL, NULL, NULL, 4),
(211221, NULL, 'G3DSA:2.60.120.20:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211222, NULL, 'G3DSA:3.40.50.360:FF:000136', NULL, NULL, 'Flavodoxin-like fold family protein', NULL, NULL, NULL, NULL, NULL, 4),
(211223, NULL, 'G3DSA:3.40.1360.10:FF:000031', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(211224, NULL, 'G3DSA:3.30.450.20:FF:000561', NULL, NULL, 'Nitrogen regulation protein NtrB', NULL, NULL, NULL, NULL, NULL, 4),
(211225, NULL, 'G3DSA:4.10.410.10:FF:000090', NULL, NULL, 'Colostrum trypsin inhibitor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211226, NULL, 'G3DSA:2.60.40.10:FF:000213', NULL, NULL, 'Hepatocyte growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(211227, NULL, 'G3DSA:3.40.50.2300:FF:001150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211228, NULL, 'G3DSA:3.40.250.10:FF:000113', NULL, NULL, 'WGS project CABT00000000 data, contig 2.33', NULL, NULL, NULL, NULL, NULL, 4),
(211229, NULL, 'G3DSA:1.10.10.350:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211230, NULL, 'G3DSA:3.30.40.10:FF:000684', NULL, NULL, 'Putative E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(211231, NULL, 'G3DSA:3.90.660.10:FF:000021', NULL, NULL, 'Lysine-specific histone demethylase 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211232, NULL, 'G3DSA:1.10.472.10:FF:000289', NULL, NULL, 'G2/mitotic-specific cyclin-A1', NULL, NULL, NULL, NULL, NULL, 4),
(211233, NULL, 'G3DSA:3.20.20.80:FF:000204', NULL, NULL, 'Probable 4-alpha-glucanotransferase / amylo-1,6-glucosidase (Glycogen-debranching enzyme)', NULL, NULL, NULL, NULL, NULL, 4),
(211234, NULL, 'G3DSA:3.40.50.720:FF:000671', NULL, NULL, 'Voltage-gated Ion Channel (VIC) Superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(211235, NULL, 'G3DSA:3.40.718.10:FF:000009', NULL, NULL, 'Isocitrate dehydrogenase [NAD] regulatory subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(211236, NULL, 'G3DSA:3.75.10.10:FF:000018', NULL, NULL, 'Eukaryotic translation initiation factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(211237, NULL, 'G3DSA:1.20.1250.20:FF:002297', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(211238, NULL, 'G3DSA:3.30.160.60:FF:003361', NULL, NULL, 'GD23866', NULL, NULL, NULL, NULL, NULL, 4),
(211239, NULL, 'G3DSA:3.30.200.20:FF:000790', NULL, NULL, 'CAMK/CAMKL protein kinase, variant 1', NULL, NULL, NULL, NULL, NULL, 4),
(211240, NULL, 'G3DSA:3.20.20.70:FF:000201', NULL, NULL, 'Hydroxymethylglutaryl-CoA lyase', NULL, NULL, NULL, NULL, NULL, 4),
(211241, NULL, 'G3DSA:1.20.1510.10:FF:000089', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211242, NULL, 'G3DSA:3.40.50.620:FF:000641', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211243, NULL, 'G3DSA:1.10.150.20:FF:000286', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4),
(211244, NULL, 'G3DSA:3.40.33.10:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211245, NULL, 'G3DSA:2.130.10.10:FF:001405', NULL, NULL, 'Serine/threonine-protein kinase VPS15', NULL, NULL, NULL, NULL, NULL, 4),
(211246, NULL, 'G3DSA:3.40.20.10:FF:000008', NULL, NULL, 'gelsolin isoform X2', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(211247, NULL, 'G3DSA:3.60.15.10:FF:000153', NULL, NULL, 'Cleavage and polyadenylation specificity factor subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(211248, NULL, 'G3DSA:3.30.70.330:FF:003000', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211249, NULL, 'G3DSA:1.10.630.10:FF:000281', NULL, NULL, 'Os08g0152300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(211250, NULL, 'G3DSA:2.60.120.380:FF:000064', NULL, NULL, 'Flagellar associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(211251, NULL, 'G3DSA:3.40.50.12760:FF:000009', NULL, NULL, 'GD11317', NULL, NULL, NULL, NULL, NULL, 4),
(211252, NULL, 'G3DSA:3.40.50.300:FF:003182', NULL, NULL, 'GTPase Era', NULL, NULL, NULL, NULL, NULL, 4),
(211253, NULL, 'G3DSA:1.25.40.80:FF:000020', NULL, NULL, 'CPD photolyase type II', NULL, NULL, NULL, NULL, NULL, 4),
(211254, NULL, 'G3DSA:1.20.58.1120:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211255, NULL, 'G3DSA:1.10.10.60:FF:000798', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(211256, NULL, 'G3DSA:2.60.40.1510:FF:000049', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(211257, NULL, 'G3DSA:3.40.50.300:FF:001618', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(211258, NULL, 'G3DSA:1.20.120.1080:FF:000050', NULL, NULL, 'ATP dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(211259, NULL, 'G3DSA:1.20.1270.60:FF:000073', NULL, NULL, 'RhoGAP and Fes/CIP4 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(211260, NULL, 'G3DSA:3.40.50.1220:FF:000084', NULL, NULL, 'Related to NAD-dependent histone deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(211261, NULL, 'G3DSA:2.130.10.10:FF:000303', NULL, NULL, 'Sortilin related receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(211262, NULL, 'G3DSA:1.20.5.170:FF:000203', NULL, NULL, 'Basic leucine zipper transcriptional factor ATF-like', NULL, NULL, NULL, NULL, NULL, 4),
(211263, NULL, 'G3DSA:3.90.640.10:FF:000233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211264, NULL, 'G3DSA:3.30.160.60:FF:003147', NULL, NULL, 'Transcription factor IIIA', NULL, NULL, NULL, NULL, NULL, 4),
(211265, NULL, 'G3DSA:3.30.450.20:FF:000089', NULL, NULL, 'Trachealess, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(211266, NULL, 'G3DSA:3.40.50.620:FF:000580', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211267, NULL, 'G3DSA:3.30.160.60:FF:005390', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211268, NULL, 'G3DSA:1.10.287.70:FF:000264', NULL, NULL, 'Potassium channel', NULL, NULL, NULL, NULL, NULL, 4),
(211269, NULL, 'G3DSA:1.20.144.10:FF:000087', NULL, NULL, 'AFR693Cp', NULL, NULL, NULL, NULL, NULL, 4),
(211270, NULL, 'G3DSA:3.40.50.300:FF:003923', NULL, NULL, 'GTP binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(211271, NULL, 'G3DSA:3.40.50.720:FF:002178', NULL, NULL, '(+)-neomenthol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(211272, NULL, 'G3DSA:1.25.10.10:FF:001060', NULL, NULL, 'Anaphase-promoting complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(211273, NULL, 'G3DSA:1.10.10.60:FF:000377', NULL, NULL, 'DNA-binding E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(211274, NULL, 'G3DSA:3.30.160.60:FF:005238', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211275, NULL, 'G3DSA:3.30.70.3490:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211276, NULL, 'G3DSA:1.10.472.80:FF:000203', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211277, NULL, 'G3DSA:2.60.40.10:FF:003086', NULL, NULL, 'Polycystic kidney and hepatic disease 1 (autosomal recessive)-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(211278, NULL, 'G3DSA:2.30.29.30:FF:001054', NULL, NULL, 'UNC-112-Interacting Guanine nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(211279, NULL, 'G3DSA:1.10.565.10:FF:000027', NULL, NULL, 'nuclear receptor subfamily 0 group B member 1', NULL, NULL, NULL, NULL, NULL, 4),
(211280, NULL, 'G3DSA:1.25.40.10:FF:002747', NULL, NULL, 'AaceriAFR112Wp', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(211281, NULL, 'G3DSA:3.10.129.10:FF:000198', NULL, NULL, '4-hydroxybenzoyl-CoA thioesterase family active site', NULL, NULL, NULL, NULL, NULL, 4),
(211282, NULL, 'G3DSA:3.40.50.300:FF:003709', NULL, NULL, 'AAA_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(211283, NULL, 'G3DSA:2.60.120.260:FF:000219', NULL, NULL, 'Laminin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(211284, NULL, 'G3DSA:2.30.42.10:FF:000646', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211285, NULL, 'G3DSA:1.10.10.10:FF:001087', NULL, NULL, 'Heat shock transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(211286, NULL, 'G3DSA:1.20.1110.10:FF:000221', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211287, NULL, 'G3DSA:3.40.50.620:FF:000736', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211288, NULL, 'G3DSA:3.40.50.1820:FF:000617', NULL, NULL, 'GM24588', NULL, NULL, NULL, NULL, NULL, 4),
(211289, NULL, 'G3DSA:1.25.40.10:FF:001180', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g03380, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(211290, NULL, 'G3DSA:1.10.357.10:FF:000089', NULL, NULL, 'Transcriptional repressor of RND efflux transporter TetR family', NULL, NULL, NULL, NULL, NULL, 4),
(211291, NULL, 'G3DSA:2.60.40.60:FF:000200', NULL, NULL, 'Cadherin 24, type 2b', NULL, NULL, NULL, NULL, NULL, 4),
(211292, NULL, 'G3DSA:1.20.1740.10:FF:000252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211293, NULL, 'G3DSA:1.10.3430.10:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211294, NULL, 'G3DSA:3.40.1190.20:FF:000234', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211295, NULL, 'G3DSA:1.10.510.10:FF:001901', NULL, NULL, 'Proto-oncogene tyrosine-protein kinase ROS', NULL, NULL, NULL, NULL, NULL, 4),
(211296, NULL, 'G3DSA:3.40.1160.10:FF:000050', NULL, NULL, 'Glutamate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(211297, NULL, 'G3DSA:3.30.2230.10:FF:000024', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 33', NULL, NULL, NULL, NULL, NULL, 4),
(211298, NULL, 'G3DSA:1.20.1250.20:FF:000431', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(211299, NULL, 'G3DSA:3.40.50.2000:FF:000773', NULL, NULL, 'UDP-N-acetylglucosamine transferase subunit ALG14', NULL, NULL, NULL, NULL, NULL, 4),
(211300, NULL, 'G3DSA:2.30.29.30:FF:000565', NULL, NULL, 'Related to OSH3-Member of oxysterol-binding protein family', NULL, NULL, NULL, NULL, NULL, 4),
(211301, NULL, 'G3DSA:2.120.10.10:FF:000006', NULL, NULL, 'Sialidase 4', NULL, NULL, NULL, NULL, NULL, 4),
(211302, NULL, 'G3DSA:3.40.225.10:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211303, NULL, 'G3DSA:1.25.40.10:FF:004838', NULL, NULL, 'Tetratricopeptide repeat domain 21A', NULL, NULL, NULL, NULL, NULL, 4),
(211304, NULL, 'G3DSA:1.20.1560.10:FF:000833', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211305, NULL, 'G3DSA:1.10.8.1070:FF:000002', NULL, NULL, 'BnaC06g43890D protein', NULL, NULL, NULL, NULL, NULL, 4),
(211306, NULL, 'G3DSA:1.20.140.160:FF:000006', NULL, NULL, 'RNA polymerase sigma factor RpoH', NULL, NULL, NULL, NULL, NULL, 4),
(211307, NULL, 'G3DSA:1.20.140.10:FF:000140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211308, NULL, 'G3DSA:3.80.10.10:FF:002299', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(211309, NULL, 'G3DSA:1.25.40.10:FF:004990', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211310, NULL, 'G3DSA:3.80.10.10:FF:000175', NULL, NULL, 'Si:dkey-16p6.1', NULL, NULL, NULL, NULL, NULL, 4),
(211311, NULL, 'G3DSA:2.130.10.10:FF:000388', NULL, NULL, 'VPS10 domain-containing receptor SorCS3', NULL, NULL, NULL, NULL, NULL, 4),
(211312, NULL, 'G3DSA:3.20.20.100:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211313, NULL, 'G3DSA:3.40.50.300:FF:007190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(211314, NULL, 'G3DSA:3.40.50.1000:FF:000310', NULL, NULL, 'Trehalose-6-phosphate phosphatase OtsB', NULL, NULL, NULL, NULL, NULL, 4),
(211315, NULL, 'G3DSA:3.30.70.330:FF:000763', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211316, NULL, 'G3DSA:2.30.30.100:FF:000184', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm6p', NULL, NULL, NULL, NULL, NULL, 4),
(211317, NULL, 'G3DSA:2.60.40.10:FF:001753', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211318, NULL, 'G3DSA:2.60.120.430:FF:000040', NULL, NULL, 'Beta-agarase A', NULL, NULL, NULL, NULL, NULL, 4),
(211319, NULL, 'G3DSA:1.20.120.850:FF:000052', NULL, NULL, 'SWI/SNF chromatin remodeling complex component', NULL, NULL, NULL, NULL, NULL, 4),
(211320, NULL, 'G3DSA:3.40.50.2000:FF:000335', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(211321, NULL, 'G3DSA:4.10.400.10:FF:000145', NULL, NULL, 'Low-density lipoprotein RecePtor related', NULL, NULL, NULL, NULL, NULL, 4),
(211322, NULL, 'G3DSA:3.40.50.410:FF:000224', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(211323, NULL, 'G3DSA:3.40.50.12280:FF:000012', NULL, NULL, 'Hydrogenase, HycG subunit', NULL, NULL, NULL, NULL, NULL, 4),
(211324, NULL, 'G3DSA:3.30.70.100:FF:000014', NULL, NULL, 'Copper chaperone copZ', NULL, NULL, NULL, NULL, NULL, 4),
(211325, NULL, 'G3DSA:1.20.1280.290:FF:000089', NULL, NULL, 'Sugar transporter SWEET', NULL, NULL, NULL, NULL, NULL, 4),
(211326, NULL, 'G3DSA:3.30.1520.10:FF:000097', NULL, NULL, 'PX domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211327, NULL, 'G3DSA:3.20.20.105:FF:000006', NULL, NULL, 'Queuine tRNA-ribosyltransferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(211328, NULL, 'G3DSA:3.40.50.150:FF:001826', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211329, NULL, 'G3DSA:2.60.40.10:FF:005390', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211330, NULL, 'G3DSA:1.10.287.470:FF:000018', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(211331, NULL, 'G3DSA:3.40.50.10810:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211332, NULL, 'G3DSA:2.130.10.10:FF:001826', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(211333, NULL, 'G3DSA:3.40.50.1760:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211334, NULL, 'G3DSA:3.40.50.300:FF:005334', NULL, NULL, 'Regulator of nonsense transcripts 1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(211335, NULL, 'G3DSA:1.20.1250.20:FF:001223', NULL, NULL, 'Solute carrier family 22 member 22', NULL, NULL, NULL, NULL, NULL, 4),
(211336, NULL, 'G3DSA:3.40.50.300:FF:001832', NULL, NULL, 'IstB-like ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(211337, NULL, 'G3DSA:3.40.50.2300:FF:001650', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211338, NULL, 'G3DSA:3.40.50.80:FF:000076', NULL, NULL, 'Flavohemoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(211339, NULL, 'G3DSA:2.60.120.10:FF:000165', NULL, NULL, 'dTDP-4-dehydrorhamnose 3,5-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(211340, NULL, 'G3DSA:3.90.640.10:FF:000019', NULL, NULL, 'ARP5 actin-related protein 5 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(211341, NULL, 'G3DSA:3.30.160.60:FF:003035', NULL, NULL, 'zinc finger protein ZFP69 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(211342, NULL, 'G3DSA:1.25.40.10:FF:000898', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(211343, NULL, 'G3DSA:1.20.1560.10:FF:000480', NULL, NULL, 'ABC superfamily ATP binding cassette transporter ABC/membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(211344, NULL, 'G3DSA:2.10.50.10:FF:000143', NULL, NULL, 'Ectodysplasin A2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(211345, NULL, 'G3DSA:3.30.60.20:FF:000149', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(211346, NULL, 'G3DSA:2.60.40.10:FF:005682', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(211347, NULL, 'G3DSA:1.10.10.2520:FF:000004', NULL, NULL, 'Ion channel', NULL, NULL, NULL, NULL, NULL, 4),
(211348, NULL, 'G3DSA:3.10.450.50:FF:000029', NULL, NULL, 'Probable sucrose-phosphatase 2', NULL, NULL, NULL, NULL, NULL, 4),
(211349, NULL, 'G3DSA:2.20.70.10:FF:000239', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(211350, NULL, 'G3DSA:3.40.50.1820:FF:000376', NULL, NULL, 'Probable carboxylesterase 12', NULL, NULL, NULL, NULL, NULL, 4),
(211351, NULL, 'G3DSA:2.10.70.10:FF:000301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211352, NULL, 'G3DSA:3.40.630.10:FF:000098', NULL, NULL, 'Gly-Xaa carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(211353, NULL, 'G3DSA:3.90.190.10:FF:000451', NULL, NULL, 'Protein-tyrosine phosphatase beta', NULL, NULL, NULL, NULL, NULL, 4),
(211354, NULL, 'G3DSA:2.60.260.40:FF:000004', NULL, NULL, 'Lactobacillus shifted protein', NULL, NULL, NULL, NULL, NULL, 4),
(211355, NULL, 'G3DSA:1.20.58.60:FF:000683', NULL, NULL, 'Spectrin beta chain, non-erythrocytic 5-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(211356, NULL, 'G3DSA:1.10.150.240:FF:000119', NULL, NULL, 'CG5565 protein', NULL, NULL, NULL, NULL, NULL, 4),
(211357, NULL, 'G3DSA:3.40.50.150:FF:001085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211358, NULL, 'G3DSA:2.30.29.30:FF:000891', NULL, NULL, 'YALI0B12452p', NULL, NULL, NULL, NULL, NULL, 4),
(211359, NULL, 'G3DSA:1.10.287.810:FF:000008', NULL, NULL, 'Mitochondrial import inner membrane translocase subunit TIM9', NULL, NULL, NULL, NULL, NULL, 4),
(211360, NULL, 'G3DSA:1.20.120.1760:FF:000040', NULL, NULL, 'CDP-diacylglycerol--inositol 3-phosphatidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(211361, NULL, 'G3DSA:3.40.50.150:FF:001377', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211362, NULL, 'G3DSA:3.60.10.10:FF:000338', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(211363, NULL, 'G3DSA:2.130.10.10:FF:001085', NULL, NULL, 'Chromatin assembly factor-I p60 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(211364, NULL, 'G3DSA:2.40.50.90:FF:000143', NULL, NULL, 'YALI0B03960p', NULL, NULL, NULL, NULL, NULL, 4),
(211365, NULL, 'G3DSA:3.40.50.300:FF:006857', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211366, NULL, 'G3DSA:2.10.25.10:FF:001765', NULL, NULL, 'Adhesion G protein-coupled receptor L4', NULL, NULL, NULL, NULL, NULL, 4),
(211367, NULL, 'G3DSA:3.30.479.20:FF:000025', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(211368, NULL, 'G3DSA:1.20.1560.10:FF:000092', NULL, NULL, 'ABC bile acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(211369, NULL, 'G3DSA:2.30.42.10:FF:000584', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211370, NULL, 'G3DSA:3.40.570.10:FF:000008', NULL, NULL, 'Probable NUC1-dna/rna non-specific nuclease, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(211371, NULL, 'G3DSA:3.40.720.10:FF:000200', NULL, NULL, 'Choline sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(211372, NULL, 'G3DSA:1.25.10.10:FF:003184', NULL, NULL, 'PIKK family atypical protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(211373, NULL, 'G3DSA:1.10.8.10:FF:000232', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase A', NULL, NULL, NULL, NULL, NULL, 4),
(211374, NULL, 'G3DSA:3.30.70.1320:FF:000010', NULL, NULL, 'Multidrug efflux pump', NULL, NULL, NULL, NULL, NULL, 4),
(211375, NULL, 'G3DSA:3.30.70.1730:FF:000043', NULL, NULL, 'Ribosome assembly factor mrt4', NULL, NULL, NULL, NULL, NULL, 4),
(211376, NULL, 'G3DSA:2.10.10.90:FF:000001', NULL, NULL, 'Chitin oligosaccharide deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(211377, NULL, 'G3DSA:3.30.420.10:FF:000112', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(211378, NULL, 'G3DSA:2.60.40.10:FF:003198', NULL, NULL, 'B-cell antigen receptor complex-associated protein alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(211379, NULL, 'G3DSA:3.40.50.1820:FF:000668', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(211380, NULL, 'G3DSA:3.40.50.300:FF:005194', NULL, NULL, 'ATP-binding cassette sub-family G member 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(211381, NULL, 'G3DSA:3.40.50.300:FF:001883', NULL, NULL, 'Pre-mRNA-processing ATP-dependent RNA helicase PRP5', NULL, NULL, NULL, NULL, NULL, 4),
(211382, NULL, 'G3DSA:1.20.1250.20:FF:002229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211383, NULL, 'G3DSA:1.10.10.790:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211384, NULL, 'G3DSA:2.40.50.120:FF:000068', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(211385, NULL, 'G3DSA:2.130.10.10:FF:006031', NULL, NULL, 'Probable elongator complex protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(211386, NULL, 'G3DSA:2.60.120.330:FF:000122', NULL, NULL, 'Protein SRG1 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(211387, NULL, 'G3DSA:1.10.472.80:FF:000141', NULL, NULL, 'Related to MDR1-Mac1p interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(211388, NULL, 'G3DSA:3.40.50.720:FF:000199', NULL, NULL, 'Cinnamoyl-CoA reductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(211389, NULL, 'G3DSA:3.30.950.10:FF:000028', NULL, NULL, 'Precorrin-6A synthase [deacetylating]', NULL, NULL, NULL, NULL, NULL, 4),
(211390, NULL, 'G3DSA:3.30.2410.10:FF:000010', NULL, NULL, 'E3 ubiquitin-protein ligase UPL1', NULL, NULL, NULL, NULL, NULL, 4),
(211391, NULL, 'G3DSA:2.60.40.10:FF:001399', NULL, NULL, 'Titin a', NULL, NULL, NULL, NULL, NULL, 4),
(211392, NULL, 'G3DSA:3.30.70.330:FF:000566', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211393, NULL, 'G3DSA:1.10.3200.20:FF:000003', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(211394, NULL, 'G3DSA:2.40.30.70:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211395, NULL, 'G3DSA:3.30.390.30:FF:000042', NULL, NULL, 'IP11909p', NULL, NULL, NULL, NULL, NULL, 4),
(211396, NULL, 'G3DSA:1.20.1270.10:FF:000053', NULL, NULL, 'Heat shock 70 kDa protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(211397, NULL, 'G3DSA:3.40.50.10380:FF:000026', NULL, NULL, 'NADP-dependent malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(211398, NULL, 'G3DSA:4.10.430.10:FF:000001', NULL, NULL, 'DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(211399, NULL, 'G3DSA:1.25.10.10:FF:003476', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211400, NULL, 'G3DSA:3.30.200.20:FF:001161', NULL, NULL, 'Membrane-associated tyrosine- and threonine-specific cdc2-inhibitory kinase wee-1.1', NULL, NULL, NULL, NULL, NULL, 4),
(211401, NULL, 'G3DSA:1.20.58.60:FF:000239', NULL, NULL, 'dystrophin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(211402, NULL, 'G3DSA:2.60.40.2500:FF:000003', NULL, NULL, 'Type IV secretion system protein PtlF', NULL, NULL, NULL, NULL, NULL, 4),
(211403, NULL, 'G3DSA:1.10.287.370:FF:000106', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(211404, NULL, 'G3DSA:3.40.309.10:FF:000109', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(211405, NULL, 'G3DSA:2.60.40.420:FF:000253', NULL, NULL, 'Ephrin', NULL, NULL, NULL, NULL, NULL, 4),
(211406, NULL, 'G3DSA:3.30.160.60:FF:005659', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211407, NULL, 'G3DSA:3.40.50.2000:FF:000661', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(211408, NULL, 'G3DSA:3.30.56.10:FF:000041', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(211409, NULL, 'G3DSA:3.30.450.20:FF:000364', NULL, NULL, 'Neuronal PAS domain-containing protein 4-like', NULL, NULL, NULL, NULL, NULL, 4),
(211410, NULL, 'G3DSA:3.40.50.300:FF:001265', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211411, NULL, 'G3DSA:1.10.510.10:FF:003700', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211412, NULL, 'G3DSA:1.10.287.70:FF:000185', NULL, NULL, 'TWiK family of potassium channels', NULL, NULL, NULL, NULL, NULL, 4),
(211413, NULL, 'G3DSA:1.10.510.10:FF:000215', NULL, NULL, 'serine/threonine-protein kinase/endoribonuclease IRE1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(211414, NULL, 'G3DSA:1.10.1040.10:FF:000111', NULL, NULL, '3-hydroxyisobutyrate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(211415, NULL, 'G3DSA:3.40.50.720:FF:000441', NULL, NULL, 'Oxidoreductase, short-chain dehydrogenase/reductase', NULL, NULL, NULL, NULL, NULL, 4),
(211416, NULL, 'G3DSA:1.10.10.60:FF:001254', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211417, NULL, 'G3DSA:3.40.50.720:FF:000733', NULL, NULL, 'Alcohol dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211418, NULL, 'G3DSA:3.40.50.300:FF:005722', NULL, NULL, 'Si:dkey-11m19.5', NULL, NULL, NULL, NULL, NULL, 4),
(211419, NULL, 'G3DSA:1.10.10.10:FF:001166', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(211420, NULL, 'G3DSA:1.10.238.10:FF:001190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211421, NULL, 'G3DSA:3.30.160.60:FF:002012', NULL, NULL, 'Zinc finger protein 989', NULL, NULL, NULL, NULL, NULL, 4),
(211422, NULL, 'G3DSA:3.30.710.10:FF:000426', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211423, NULL, 'G3DSA:1.25.40.10:FF:004664', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g46610', NULL, NULL, NULL, NULL, NULL, 4),
(211424, NULL, 'G3DSA:3.30.160.60:FF:001444', NULL, NULL, 'zinc finger protein 131 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(211425, NULL, 'G3DSA:3.40.50.300:FF:000989', NULL, NULL, 'von Willebrand factor A domain containing 8', NULL, NULL, NULL, NULL, NULL, 4),
(211426, NULL, 'G3DSA:3.60.21.70:FF:000005', NULL, NULL, 'Probable secreted alkaline phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(211427, NULL, 'G3DSA:1.10.2000.10:FF:000070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211428, NULL, 'G3DSA:1.10.580.10:FF:000040', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(211429, NULL, 'G3DSA:3.30.200.20:FF:001453', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211430, NULL, 'G3DSA:3.60.21.60:FF:000002', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(211431, NULL, 'G3DSA:1.10.630.10:FF:000213', NULL, NULL, 'Putative cytochrome P450 superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(211432, NULL, 'G3DSA:3.30.70.330:FF:002157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211433, NULL, 'G3DSA:3.20.20.80:FF:000255', NULL, NULL, 'Alpha-glucosidase/alpha-amylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211434, NULL, 'G3DSA:3.30.160.60:FF:003473', NULL, NULL, 'Zgc:162936', NULL, NULL, NULL, NULL, NULL, 4),
(211435, NULL, 'G3DSA:3.20.20.70:FF:000252', NULL, NULL, 'Glycoside hydrolase family 27', NULL, NULL, NULL, NULL, NULL, 4),
(211436, NULL, 'G3DSA:3.30.479.30:FF:000028', NULL, NULL, 'Vacuolin-A', NULL, NULL, NULL, NULL, NULL, 4),
(211437, NULL, 'G3DSA:3.30.200.20:FF:000964', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(211438, NULL, 'G3DSA:3.15.10.10:FF:000015', NULL, NULL, 'lipopolysaccharide-binding protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(211439, NULL, 'G3DSA:2.40.50.140:FF:000754', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211440, NULL, 'G3DSA:2.10.25.10:FF:000337', NULL, NULL, 'stabilin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(211441, NULL, 'G3DSA:3.30.40.10:FF:001201', NULL, NULL, 'RING finger protein 219', NULL, NULL, NULL, NULL, NULL, 4),
(211442, NULL, 'G3DSA:3.40.50.620:FF:000815', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211443, NULL, 'G3DSA:1.25.10.10:FF:002369', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211444, NULL, 'G3DSA:2.60.40.10:FF:001348', NULL, NULL, 'Hemicentin 2', NULL, NULL, NULL, NULL, NULL, 4),
(211445, NULL, 'G3DSA:3.90.1520.10:FF:000010', NULL, NULL, 'GH18909', NULL, NULL, NULL, NULL, NULL, 4),
(211446, NULL, 'G3DSA:1.20.1090.10:FF:000016', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(211447, NULL, 'G3DSA:1.10.12.10:FF:000046', NULL, NULL, 'Short chain enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(211448, NULL, 'G3DSA:2.60.40.10:FF:000859', NULL, NULL, 'Titin b', NULL, NULL, NULL, NULL, NULL, 4),
(211449, NULL, 'G3DSA:2.60.120.200:FF:000729', NULL, NULL, 'L-type lectin-like domain-containing protein C126.08c', NULL, NULL, NULL, NULL, NULL, 4),
(211450, NULL, 'G3DSA:3.30.70.1230:FF:000101', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(211451, NULL, 'G3DSA:3.30.160.60:FF:001169', NULL, NULL, 'zinc finger protein 574', NULL, NULL, NULL, NULL, NULL, 4),
(211452, NULL, 'G3DSA:3.80.10.10:FF:002248', NULL, NULL, 'Centrosomal protein of 78 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(211453, NULL, 'G3DSA:1.10.10.2480:FF:000003', NULL, NULL, 'Translation initiation factor IF-2', NULL, NULL, NULL, NULL, NULL, 4),
(211454, NULL, 'G3DSA:1.25.40.180:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211455, NULL, 'G3DSA:1.10.287.130:FF:000018', NULL, NULL, 'Sensor histidine kinase RstB', NULL, NULL, NULL, NULL, NULL, 4),
(211456, NULL, 'G3DSA:2.130.10.10:FF:001265', NULL, NULL, 'Small nucleolar ribonucleoprotein complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(211457, NULL, 'G3DSA:1.20.1270.60:FF:000101', NULL, NULL, 'F-BAR and double SH3 domains protein 2 isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(211458, NULL, 'G3DSA:3.40.980.10:FF:000011', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(211459, NULL, 'G3DSA:3.40.50.620:FF:000287', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(211460, NULL, 'G3DSA:2.30.42.10:FF:000258', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(211461, NULL, 'G3DSA:1.20.58.60:FF:000391', NULL, NULL, 'SMAll', NULL, NULL, NULL, NULL, NULL, 4),
(211462, NULL, 'G3DSA:3.40.850.10:FF:000530', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(211463, NULL, 'G3DSA:3.40.50.2000:FF:000386', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(211464, NULL, 'G3DSA:3.30.70.2740:FF:000003', NULL, NULL, 'Oxidoreductase, FAD-binding, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211465, NULL, 'G3DSA:3.40.50.720:FF:002470', NULL, NULL, 'Polyketide synthase RzxE', NULL, NULL, NULL, NULL, NULL, 4),
(211466, NULL, 'G3DSA:2.60.120.590:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211467, NULL, 'G3DSA:1.10.287.110:FF:000012', NULL, NULL, 'dnaJ protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(211468, NULL, 'G3DSA:1.10.10.10:FF:001379', NULL, NULL, 'Toxin biosynthesis regulatory protein AflJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211469, NULL, 'G3DSA:3.30.160.60:FF:002984', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211470, NULL, 'G3DSA:1.10.287.130:FF:000170', NULL, NULL, 'Volvoxopsin-5, sensory rhodopsin with histidine kinase domain', NULL, NULL, NULL, NULL, NULL, 4),
(211471, NULL, 'G3DSA:2.40.30.110:FF:000016', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(211472, NULL, 'G3DSA:1.10.10.10:FF:001115', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(211473, NULL, 'G3DSA:3.40.50.300:FF:006211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211474, NULL, 'G3DSA:3.30.160.60:FF:005160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211475, NULL, 'G3DSA:3.30.420.10:FF:000730', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211476, NULL, 'G3DSA:2.130.10.30:FF:000135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211477, NULL, 'G3DSA:2.60.40.790:FF:000200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211478, NULL, 'G3DSA:3.30.710.10:FF:000477', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211479, NULL, 'G3DSA:3.80.10.10:FF:000096', NULL, NULL, 'F-box/LRR-repeat protein 19 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(211480, NULL, 'G3DSA:3.40.50.300:FF:007397', NULL, NULL, 'Obg-like ATPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(211481, NULL, 'G3DSA:1.20.1070.10:FF:000184', NULL, NULL, 'C-C chemokine receptor type 10', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(211482, NULL, 'G3DSA:3.30.930.10:FF:000016', NULL, NULL, 'Asparagine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(211483, NULL, 'G3DSA:2.10.220.10:FF:000015', NULL, NULL, 'proprotein convertase subtilisin/kexin type 6', NULL, NULL, NULL, NULL, NULL, 4),
(211484, NULL, 'G3DSA:3.40.190.80:FF:000005', NULL, NULL, '3''(2''),5''-bisphosphate nucleotidase CysQ', NULL, NULL, NULL, NULL, NULL, 4),
(211485, NULL, 'G3DSA:6.10.140.2220:FF:000027', NULL, NULL, 'Eto/mtg8/nervy, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211486, NULL, 'G3DSA:1.10.287.70:FF:000713', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211487, NULL, 'G3DSA:2.10.70.10:FF:000026', NULL, NULL, 'Complement inhibitory factor H', NULL, NULL, NULL, NULL, NULL, 4),
(211488, NULL, 'G3DSA:3.30.40.10:FF:000437', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(211489, NULL, 'G3DSA:3.40.50.2000:FF:000947', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(211490, NULL, 'G3DSA:3.30.1520.10:FF:000046', NULL, NULL, 'sorting nexin-17 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(211491, NULL, 'G3DSA:3.40.720.10:FF:000251', NULL, NULL, 'Sulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(211492, NULL, 'G3DSA:3.30.420.40:FF:000891', NULL, NULL, 'Glycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(211493, NULL, 'G3DSA:1.25.40.180:FF:000056', NULL, NULL, 'Sto1p', NULL, NULL, NULL, NULL, NULL, 4),
(211494, NULL, 'G3DSA:2.130.10.10:FF:004699', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(211495, NULL, 'G3DSA:2.60.40.10:FF:005064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211496, NULL, 'G3DSA:3.20.20.80:FF:000530', NULL, NULL, 'O-Glycosyl hydrolase family 17 protein', NULL, NULL, NULL, NULL, NULL, 4),
(211497, NULL, 'G3DSA:2.20.100.10:FF:000077', NULL, NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 12', NULL, NULL, NULL, NULL, NULL, 4),
(211498, NULL, 'G3DSA:1.25.40.20:FF:000221', NULL, NULL, 'Transient receptor potential-gamma protein', NULL, NULL, NULL, NULL, NULL, 4),
(211499, NULL, 'G3DSA:2.60.120.290:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211500, NULL, 'G3DSA:2.60.40.10:FF:000090', NULL, NULL, 'Protein-glutamine gamma-glutamyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(211501, NULL, 'G3DSA:3.30.2090.10:FF:000018', NULL, NULL, 'Transporter, AcrB/D/F family', NULL, NULL, NULL, NULL, NULL, 4),
(211502, NULL, 'G3DSA:3.30.70.1820:FF:000002', NULL, NULL, 'LINE-1 retrotransposable element ORF1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(211503, NULL, 'G3DSA:2.130.10.10:FF:003417', NULL, NULL, 'VPS15 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(211504, NULL, 'G3DSA:3.40.5.90:FF:000003', NULL, NULL, 'CDGSH iron sulfur domain 3', NULL, NULL, NULL, NULL, NULL, 4),
(211505, NULL, 'G3DSA:3.40.50.1580:FF:000057', NULL, NULL, 'Probable S-methyl-5''-thioinosine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(211506, NULL, 'G3DSA:3.30.200.20:FF:001009', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', NULL, NULL, NULL, NULL, NULL, 4),
(211507, NULL, 'G3DSA:3.20.20.80:FF:000822', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211508, NULL, 'G3DSA:3.30.413.10:FF:000028', NULL, NULL, 'Nitrite and sulphite reductase 4Fe-4S region', NULL, NULL, NULL, NULL, NULL, 4),
(211509, NULL, 'G3DSA:2.30.30.60:FF:000009', NULL, NULL, 'Mechanosensitive ion channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(211510, NULL, 'G3DSA:1.10.555.10:FF:000184', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211511, NULL, 'G3DSA:2.60.120.10:FF:000631', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211512, NULL, 'G3DSA:3.40.50.300:FF:007638', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(211513, NULL, 'G3DSA:3.20.20.100:FF:000080', NULL, NULL, 'Aldo-keto reductase family 4 member C8', NULL, NULL, NULL, NULL, NULL, 4),
(211514, NULL, 'G3DSA:1.10.10.10:FF:002104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(211515, NULL, 'G3DSA:1.20.58.60:FF:000514', NULL, NULL, 'Spectrin repeat containing, nuclear envelope 1a', NULL, NULL, NULL, NULL, NULL, 4),
(211516, NULL, 'G3DSA:1.20.1070.10:FF:000633', NULL, NULL, 'Histamine receptor H1', NULL, NULL, NULL, NULL, NULL, 4),
(211517, NULL, 'G3DSA:2.60.300.12:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211518, NULL, 'G3DSA:3.30.160.60:FF:003973', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211519, NULL, 'G3DSA:1.20.140.10:FF:000022', NULL, NULL, 'Acyl-CoA dehydrogenase FadE8', NULL, NULL, NULL, NULL, NULL, 4),
(211520, NULL, 'G3DSA:2.60.40.10:FF:003473', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211521, NULL, 'G3DSA:1.25.40.10:FF:001095', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g34400', NULL, NULL, NULL, NULL, NULL, 4),
(211522, NULL, 'G3DSA:1.10.1900.40:FF:000006', NULL, NULL, 'Erythrocyte membrane protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(211523, NULL, 'G3DSA:2.60.40.10:FF:001287', NULL, NULL, 'MAM domain-containing glycosylphosphatidylinositol anchor protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(211524, NULL, 'G3DSA:3.40.50.720:FF:002357', NULL, NULL, 'D-aspartate oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(211525, NULL, 'G3DSA:1.25.10.10:FF:003263', NULL, NULL, 'E3 ubiquitin-protein ligase listerin', NULL, NULL, NULL, NULL, NULL, 4),
(211526, NULL, 'G3DSA:2.10.50.10:FF:000025', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 1A', NULL, NULL, NULL, NULL, NULL, 4),
(211527, NULL, 'G3DSA:2.60.40.1090:FF:000024', NULL, NULL, 'Fimbrial subunit', NULL, NULL, NULL, NULL, NULL, 4),
(211528, NULL, 'G3DSA:2.30.30.490:FF:000025', NULL, NULL, 'E3 ubiquitin-protein ligase SNT2', NULL, NULL, NULL, NULL, NULL, 4),
(211529, NULL, 'G3DSA:2.30.30.100:FF:000066', NULL, NULL, 'Bifunctional ligase/repressor BirA', NULL, NULL, NULL, NULL, NULL, 4),
(211530, NULL, 'G3DSA:2.30.29.30:FF:000626', NULL, NULL, 'Protein CBG14242', NULL, NULL, NULL, NULL, NULL, 4),
(211531, NULL, 'G3DSA:2.10.110.10:FF:000092', NULL, NULL, 'LIM domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(211532, NULL, 'G3DSA:3.50.50.60:FF:000575', NULL, NULL, 'Putative polyamine oxidase 5 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(211533, NULL, 'G3DSA:3.30.70.330:FF:002769', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211534, NULL, 'G3DSA:3.40.50.1700:FF:000020', NULL, NULL, 'Beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(211535, NULL, 'G3DSA:4.10.830.40:FF:000006', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM47', NULL, NULL, NULL, NULL, NULL, 4),
(211536, NULL, 'G3DSA:1.25.40.20:FF:001098', NULL, NULL, 'Ankyrin repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(211537, NULL, 'G3DSA:1.25.10.10:FF:002695', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211538, NULL, 'G3DSA:2.60.220.50:FF:000162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211539, NULL, 'G3DSA:3.30.413.10:FF:000034', NULL, NULL, 'Nitrite/sulfite reductase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(211540, NULL, 'G3DSA:1.10.418.40:FF:000009', NULL, NULL, 'Protein CBR-BEC-1', NULL, NULL, NULL, NULL, NULL, 4),
(211541, NULL, 'G3DSA:1.25.10.10:FF:001172', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(211542, NULL, 'G3DSA:1.25.40.10:FF:001741', NULL, NULL, 'Tetratricopeptide repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(211543, NULL, 'G3DSA:3.20.20.150:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211544, NULL, 'G3DSA:4.10.1000.10:FF:000022', NULL, NULL, 'Zinc finger CCCH domain-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(211545, NULL, 'G3DSA:1.10.8.10:FF:000350', NULL, NULL, 'Putative peptidyl-tRNA hydrolase 2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(211546, NULL, 'G3DSA:2.60.40.1080:FF:000021', NULL, NULL, 'SbsB protein', NULL, NULL, NULL, NULL, NULL, 4),
(211547, NULL, 'G3DSA:2.60.120.200:FF:000229', NULL, NULL, 'MAM domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(211548, NULL, 'G3DSA:3.30.40.10:FF:001701', NULL, NULL, 'BRCA1-associated RING domain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(211549, NULL, 'G3DSA:2.40.70.10:FF:000289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211550, NULL, 'G3DSA:3.30.70.330:FF:001252', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(211551, NULL, 'G3DSA:2.60.40.10:FF:005614', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211552, NULL, 'G3DSA:3.40.50.80:FF:000188', NULL, NULL, 'NADPH--cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(211553, NULL, 'G3DSA:3.40.50.720:FF:000227', NULL, NULL, 'Dipicolinic acid synthetase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(211554, NULL, 'G3DSA:3.40.1110.10:FF:000400', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211555, NULL, 'G3DSA:1.10.510.10:FF:001351', NULL, NULL, 'Casein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211556, NULL, 'G3DSA:3.30.1490.80:FF:000024', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(211557, NULL, 'G3DSA:1.25.10.10:FF:003358', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211558, NULL, 'G3DSA:2.60.120.920:FF:000153', NULL, NULL, 'Si:ch211-238e22.8', NULL, NULL, NULL, NULL, NULL, 4),
(211559, NULL, 'G3DSA:3.40.50.300:FF:005508', NULL, NULL, 'ATP-dependent DEAD/H RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211560, NULL, 'G3DSA:1.20.58.60:FF:000891', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211561, NULL, 'G3DSA:1.25.40.20:FF:000108', NULL, NULL, 'Ankyrin repeat domain-containing protein 54', NULL, NULL, NULL, NULL, NULL, 4),
(211562, NULL, 'G3DSA:3.30.450.70:FF:000025', NULL, NULL, 'TRAPPC2 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(211563, NULL, 'G3DSA:1.10.1040.10:FF:000015', NULL, NULL, 'Ketol-acid reductoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(211564, NULL, 'G3DSA:1.25.40.20:FF:001744', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211565, NULL, 'G3DSA:1.10.287.770:FF:000018', NULL, NULL, 'Pickpocket 6', NULL, NULL, NULL, NULL, NULL, 4),
(211566, NULL, 'G3DSA:1.10.418.30:FF:000006', NULL, NULL, 'Probable kinetochore protein NDC80', NULL, NULL, NULL, NULL, NULL, 4),
(211567, NULL, 'G3DSA:2.70.160.11:FF:000071', NULL, NULL, 'protein arginine N-methyltransferase 9', NULL, NULL, NULL, NULL, NULL, 4),
(211568, NULL, 'G3DSA:3.40.50.410:FF:000292', NULL, NULL, 'Collagen type VI alpha 3 chain', NULL, NULL, NULL, NULL, NULL, 4),
(211569, NULL, 'G3DSA:3.40.190.10:FF:000642', NULL, NULL, 'LD22449p', NULL, NULL, NULL, NULL, NULL, 4),
(211570, NULL, 'G3DSA:1.10.287.130:FF:000052', NULL, NULL, 'PAS domain-containing sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(211571, NULL, 'G3DSA:3.90.70.10:FF:000689', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211572, NULL, 'G3DSA:2.60.40.60:FF:000846', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211573, NULL, 'G3DSA:1.25.10.10:FF:001560', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211574, NULL, 'G3DSA:1.10.8.10:FF:000018', NULL, NULL, 'Nuclear RNA export factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(211575, NULL, 'G3DSA:3.30.710.10:FF:000365', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211576, NULL, 'G3DSA:1.25.40.180:FF:000264', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211577, NULL, 'G3DSA:2.130.10.10:FF:005542', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(211578, NULL, 'G3DSA:1.10.860.10:FF:000022', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(211579, NULL, 'G3DSA:1.10.510.10:FF:002975', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211580, NULL, 'G3DSA:1.50.40.10:FF:000031', NULL, NULL, 'mitoferrin-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(211581, NULL, 'G3DSA:3.40.50.620:FF:000175', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(211582, NULL, 'G3DSA:3.40.50.720:FF:001222', NULL, NULL, 'Glucose-fructose oxidoreductase domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(211583, NULL, 'G3DSA:3.30.70.360:FF:000013', NULL, NULL, 'Allantoate amidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(211584, NULL, 'G3DSA:1.10.150.20:FF:000174', NULL, NULL, 'ATP-dependent DNA helicase Hel308', NULL, NULL, NULL, NULL, NULL, 4),
(211585, NULL, 'G3DSA:3.50.50.60:FF:001238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211586, NULL, 'G3DSA:3.40.50.850:FF:000007', NULL, NULL, 'isochorismatase domain-containing protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(211587, NULL, 'G3DSA:3.40.50.720:FF:000284', NULL, NULL, 'Lysine-ketoglutarate reductase/saccharopine dehydrogenase1', NULL, NULL, NULL, NULL, NULL, 4),
(211588, NULL, 'G3DSA:2.60.40.420:FF:000168', NULL, NULL, 'L-ascorbate oxidase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(211589, NULL, 'G3DSA:1.20.140.10:FF:000061', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(211590, NULL, 'G3DSA:1.10.2020.20:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211591, NULL, 'G3DSA:3.80.10.10:FF:000450', NULL, NULL, 'Leucine-rich repeat protein soc-2', NULL, NULL, NULL, NULL, NULL, 4),
(211592, NULL, 'G3DSA:3.40.440.10:FF:000004', NULL, NULL, 'Adenylosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(211593, NULL, 'G3DSA:3.40.50.300:FF:007751', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211594, NULL, 'G3DSA:1.10.8.590:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211595, NULL, 'G3DSA:1.20.1070.10:FF:001240', NULL, NULL, 'Putative transmembrane receptor', NULL, NULL, NULL, NULL, NULL, 4),
(211596, NULL, 'G3DSA:3.30.70.141:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211597, NULL, 'G3DSA:1.10.3370.10:FF:000012', NULL, NULL, 'Ssh1p', NULL, NULL, NULL, NULL, NULL, 4),
(211598, NULL, 'G3DSA:1.10.1580.10:FF:000022', NULL, NULL, 'G protein nucleolar 3', NULL, NULL, NULL, NULL, NULL, 4),
(211599, NULL, 'G3DSA:3.30.70.370:FF:000016', NULL, NULL, 'DNA polymerase 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211600, NULL, 'G3DSA:1.20.1730.10:FF:000015', NULL, NULL, 'Na+/galactose cotransporter', NULL, NULL, NULL, NULL, NULL, 4),
(211601, NULL, 'G3DSA:2.130.10.10:FF:003451', NULL, NULL, 'Transcription initiation factor TFIID subunit 9', NULL, NULL, NULL, NULL, NULL, 4),
(211602, NULL, 'G3DSA:1.25.40.10:FF:004338', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(211603, NULL, 'G3DSA:3.40.50.300:FF:003423', NULL, NULL, 'Developmentally-regulated GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211604, NULL, 'G3DSA:4.10.950.10:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211605, NULL, 'G3DSA:3.30.40.10:FF:000763', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(211606, NULL, 'G3DSA:2.10.25.10:FF:000130', NULL, NULL, 'Laminin subunit beta 1', NULL, NULL, NULL, NULL, NULL, 4),
(211607, NULL, 'G3DSA:3.40.710.10:FF:000082', NULL, NULL, 'Penicillin-binding protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(211608, NULL, 'G3DSA:3.30.160.60:FF:001736', NULL, NULL, 'Fibronectin type III and SPRY domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(211609, NULL, 'G3DSA:3.40.50.620:FF:000080', NULL, NULL, 'Nicotinamide/nicotinic acid mononucleotide adenylyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(211610, NULL, 'G3DSA:1.20.1560.10:FF:000266', NULL, NULL, 'Putative multidrug resistance-associated protein lethal(2)03659-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(211611, NULL, 'G3DSA:2.170.150.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211612, NULL, 'G3DSA:1.20.5.110:FF:000146', NULL, NULL, 'Ehsyntaxin K, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211613, NULL, 'G3DSA:1.10.3720.10:FF:000169', NULL, NULL, 'ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(211614, NULL, 'G3DSA:2.120.10.30:FF:000568', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211615, NULL, 'G3DSA:2.40.128.620:FF:000005', NULL, NULL, 'SCO-spondin', NULL, NULL, NULL, NULL, NULL, 4),
(211616, NULL, 'G3DSA:3.30.160.60:FF:003653', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211617, NULL, 'G3DSA:1.25.40.80:FF:000019', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(211618, NULL, 'G3DSA:3.40.50.2000:FF:000739', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211619, NULL, 'G3DSA:1.20.58.2240:FF:000002', NULL, NULL, 'FGGY carbohydrate kinase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(211620, NULL, 'G3DSA:3.30.1520.10:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211621, NULL, 'G3DSA:3.30.40.10:FF:002157', NULL, NULL, 'Structure-specific endonuclease subunit SLX1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(211622, NULL, 'G3DSA:3.40.190.10:FF:000737', NULL, NULL, 'Nodulation protein D 1', NULL, NULL, NULL, NULL, NULL, 4),
(211623, NULL, 'G3DSA:3.30.160.380:FF:000005', NULL, NULL, 'Dicer-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(211624, NULL, 'G3DSA:3.40.50.300:FF:005660', NULL, NULL, 'Adenylate/guanylate cyclase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(211625, NULL, 'G3DSA:2.40.128.630:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211626, NULL, 'G3DSA:1.20.1070.10:FF:002078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211627, NULL, 'G3DSA:1.10.10.10:FF:001441', NULL, NULL, 'Paired box protein Pax-3', NULL, NULL, NULL, NULL, NULL, 4),
(211628, NULL, 'G3DSA:3.30.70.1620:FF:000010', NULL, NULL, 'Structural maintenance of chromosomes protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(211629, NULL, 'G3DSA:1.10.10.250:FF:000014', NULL, NULL, '60S ribosomal protein L12, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211630, NULL, 'G3DSA:3.40.50.150:FF:001208', NULL, NULL, 'Protein-lysine N-methyltransferase rrg1', NULL, NULL, NULL, NULL, NULL, 4),
(211631, NULL, 'G3DSA:3.40.20.10:FF:000093', NULL, NULL, 'Villin-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(211632, NULL, 'G3DSA:3.30.70.330:FF:000971', NULL, NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(211633, NULL, 'G3DSA:1.20.1250.20:FF:000088', NULL, NULL, 'MFS multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211634, NULL, 'G3DSA:1.10.601.10:FF:000005', NULL, NULL, 'RNA polymerase sigma factor RpoH', NULL, NULL, NULL, NULL, NULL, 4),
(211635, NULL, 'G3DSA:2.30.29.30:FF:000840', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(211636, NULL, 'G3DSA:2.130.10.10:FF:001618', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(211637, NULL, 'G3DSA:2.130.10.10:FF:000596', NULL, NULL, 'Eukaryotic translation initiation factor 2A', NULL, NULL, NULL, NULL, NULL, 4),
(211638, NULL, 'G3DSA:3.40.50.10490:FF:000059', NULL, NULL, 'Glucose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(211639, NULL, 'G3DSA:3.30.70.330:FF:002449', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211640, NULL, 'G3DSA:2.170.130.10:FF:000044', NULL, NULL, 'Hemin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(211641, NULL, 'G3DSA:1.10.8.140:FF:000011', NULL, NULL, 'Double-stranded DNA-binding domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(211642, NULL, 'G3DSA:3.40.390.10:FF:000062', NULL, NULL, 'Zinc metalloproteinase', NULL, NULL, NULL, NULL, NULL, 4),
(211643, NULL, 'G3DSA:2.60.120.200:FF:000342', NULL, NULL, 'Apical endosomal glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(211644, NULL, 'G3DSA:3.40.50.300:FF:007846', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211645, NULL, 'G3DSA:3.40.50.10190:FF:000250', NULL, NULL, 'YALI0B15576p', NULL, NULL, NULL, NULL, NULL, 4),
(211646, NULL, 'G3DSA:1.50.10.10:FF:000203', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(211647, NULL, 'G3DSA:3.30.160.60:FF:001556', NULL, NULL, 'Zinc finger protein 154', NULL, NULL, NULL, NULL, NULL, 4),
(211648, NULL, 'G3DSA:3.40.50.300:FF:001557', NULL, NULL, 'Septin homolog spn3', NULL, NULL, NULL, NULL, NULL, 4),
(211649, NULL, 'G3DSA:1.50.10.10:FF:000091', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(211650, NULL, 'G3DSA:1.10.510.10:FF:003149', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211651, NULL, 'G3DSA:2.20.25.100:FF:000007', NULL, NULL, '40S ribosomal protein S27', NULL, NULL, NULL, NULL, NULL, 4),
(211652, NULL, 'G3DSA:1.20.120.1880:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211653, NULL, 'G3DSA:3.40.50.450:FF:000045', NULL, NULL, 'Lysine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(211654, NULL, 'G3DSA:1.10.1220.10:FF:000001', NULL, NULL, 'Nickel-responsive regulator', NULL, NULL, NULL, NULL, NULL, 4),
(211655, NULL, 'G3DSA:3.20.20.80:FF:000081', NULL, NULL, 'Chitinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(211656, NULL, 'G3DSA:1.10.1200.10:FF:000112', NULL, NULL, 'Acyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(211657, NULL, 'G3DSA:2.40.70.10:FF:000497', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211658, NULL, 'G3DSA:2.30.30.140:FF:000229', NULL, NULL, 'Bromodomain and PHD finger-containing, 3', NULL, NULL, NULL, NULL, NULL, 4),
(211659, NULL, 'G3DSA:1.50.10.20:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211660, NULL, 'G3DSA:1.10.3330.10:FF:000004', NULL, NULL, 'Uric acid degradation bifunctional protein', NULL, NULL, NULL, NULL, NULL, 4),
(211661, NULL, 'G3DSA:3.30.559.30:FF:000012', NULL, NULL, 'Nonribosomal peptide synthase SidE', NULL, NULL, NULL, NULL, NULL, 4),
(211662, NULL, 'G3DSA:2.10.25.10:FF:000225', NULL, NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(211663, NULL, 'G3DSA:3.30.930.10:FF:000403', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(211664, NULL, 'G3DSA:2.130.10.10:FF:003176', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(211665, NULL, 'G3DSA:1.20.1250.20:FF:000734', NULL, NULL, 'Sugar (Glycoside-Pentoside-Hexuronide) transporter', NULL, NULL, NULL, NULL, NULL, 4),
(211666, NULL, 'G3DSA:1.10.510.10:FF:002014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211667, NULL, 'G3DSA:3.90.1580.10:FF:000013', NULL, NULL, 'GM14301', NULL, NULL, NULL, NULL, NULL, 4),
(211668, NULL, 'G3DSA:1.20.120.1080:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211669, NULL, 'G3DSA:1.20.1310.10:FF:000169', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211670, NULL, 'G3DSA:2.40.50.140:FF:000804', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211671, NULL, 'G3DSA:3.30.160.60:FF:006469', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211672, NULL, 'G3DSA:3.40.50.170:FF:000023', NULL, NULL, 'Pyoverdine synthetase F', NULL, NULL, NULL, NULL, NULL, 4),
(211673, NULL, 'G3DSA:3.80.10.10:FF:001231', NULL, NULL, 'Os02g0281150 protein', NULL, NULL, NULL, NULL, NULL, 4),
(211674, NULL, 'G3DSA:3.40.1160.10:FF:000049', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(211675, NULL, 'G3DSA:3.30.9.10:FF:000230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211676, NULL, 'G3DSA:3.30.450.60:FF:000022', NULL, NULL, 'AP complex subunit sigma', NULL, NULL, NULL, NULL, NULL, 4),
(211677, NULL, 'G3DSA:1.50.10.10:FF:000186', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(211678, NULL, 'G3DSA:2.10.110.10:FF:000299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211679, NULL, 'G3DSA:1.10.530.10:FF:000003', NULL, NULL, 'Membrane-bound lytic murein transglycosylase F', NULL, NULL, NULL, NULL, NULL, 4),
(211680, NULL, 'G3DSA:3.40.50.720:FF:000492', NULL, NULL, 'D3-phosphoglycerate dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211681, NULL, 'G3DSA:1.20.58.900:FF:000023', NULL, NULL, 'Protein CBR-UNC-14', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(211682, NULL, 'G3DSA:2.130.10.10:FF:001091', NULL, NULL, 'G protein beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(211683, NULL, 'G3DSA:1.10.8.60:FF:000106', NULL, NULL, 'Cell division control protein 48 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(211684, NULL, 'G3DSA:2.30.29.30:FF:000683', NULL, NULL, 'Homer scaffold protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(211685, NULL, 'G3DSA:1.20.58.60:FF:000571', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(211686, NULL, 'G3DSA:3.90.640.10:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211687, NULL, 'G3DSA:2.60.40.10:FF:002658', NULL, NULL, 'Myotactin form A', NULL, NULL, NULL, NULL, NULL, 4),
(211688, NULL, 'G3DSA:3.30.1330.40:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211689, NULL, 'G3DSA:3.40.50.10330:FF:000039', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(211690, NULL, 'G3DSA:1.10.8.10:FF:000170', NULL, NULL, 'Release factor glutamine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(211691, NULL, 'G3DSA:1.20.970.10:FF:000034', NULL, NULL, 'Anthranilate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(211692, NULL, 'G3DSA:3.60.10.10:FF:000052', NULL, NULL, 'Retrovirus-related Pol polyprotein LINE-1', NULL, NULL, NULL, NULL, NULL, 4),
(211693, NULL, 'G3DSA:2.60.120.200:FF:000437', NULL, NULL, 'EC1118_1J11_0133p', NULL, NULL, NULL, NULL, NULL, 4),
(211694, NULL, 'G3DSA:1.25.10.10:FF:001059', NULL, NULL, 'Pumillio protein 8, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211695, NULL, 'G3DSA:3.90.840.10:FF:000001', NULL, NULL, 'Thiol-activated cytolysin', NULL, NULL, NULL, NULL, NULL, 4),
(211696, NULL, 'G3DSA:1.10.3860.10:FF:000033', NULL, NULL, 'Amino acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(211697, NULL, 'G3DSA:1.10.10.1010:FF:000001', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(211698, NULL, 'G3DSA:3.10.450.40:FF:000032', NULL, NULL, 'Required to maintain repression6', NULL, NULL, NULL, NULL, NULL, 4),
(211699, NULL, 'G3DSA:3.30.750.44:FF:000010', NULL, NULL, 'Carboxyl-terminal-processing peptidase 1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(211700, NULL, 'G3DSA:3.40.50.11660:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211701, NULL, 'G3DSA:3.40.50.1460:FF:000072', NULL, NULL, 'caspase-6-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(211702, NULL, 'G3DSA:2.80.10.50:FF:000205', NULL, NULL, 'Ricin B-like lectin EULS3', NULL, NULL, NULL, NULL, NULL, 4),
(211703, NULL, 'G3DSA:3.90.180.10:FF:000057', NULL, NULL, 'Putative alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(211704, NULL, 'G3DSA:4.10.1060.10:FF:000031', NULL, NULL, 'FUS/TLS RNA binding protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(211705, NULL, 'G3DSA:3.40.50.300:FF:004412', NULL, NULL, 'RabA', NULL, NULL, NULL, NULL, NULL, 4),
(211706, NULL, 'G3DSA:2.20.100.10:FF:000105', NULL, NULL, 'Circumsporozoite-and TRAP-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(211707, NULL, 'G3DSA:3.40.190.10:FF:000849', NULL, NULL, 'Sugar ABC transporter, periplasmic sugar-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(211708, NULL, 'G3DSA:3.40.50.1110:FF:000051', NULL, NULL, 'GDSL Lipase/Acylhydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(211709, NULL, 'G3DSA:2.20.100.10:FF:000162', NULL, NULL, 'Semaphorin 5C', NULL, NULL, NULL, NULL, NULL, 4),
(211710, NULL, 'G3DSA:3.40.1280.10:FF:000058', NULL, NULL, 'rRNA methylase, SpoU family protein', NULL, NULL, NULL, NULL, NULL, 4),
(211711, NULL, 'G3DSA:3.30.160.60:FF:003765', NULL, NULL, 'AGAP001555-PA', NULL, NULL, NULL, NULL, NULL, 4),
(211712, NULL, 'G3DSA:2.60.220.30:FF:000004', NULL, NULL, 'tight junction protein ZO-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(211713, NULL, 'G3DSA:3.20.20.70:FF:000605', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211714, NULL, 'G3DSA:3.20.20.20:FF:000001', NULL, NULL, '4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase (flavodoxin)', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(211715, NULL, 'G3DSA:3.40.850.10:FF:000081', NULL, NULL, 'Kinesin-13, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211716, NULL, 'G3DSA:2.130.10.10:FF:003243', NULL, NULL, 'Cilia- and flagella-associated protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(211717, NULL, 'G3DSA:3.40.50.150:FF:001265', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211718, NULL, 'G3DSA:3.90.1150.10:FF:000195', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(211719, NULL, 'G3DSA:1.10.400.20:FF:000002', NULL, NULL, 'Tagatose-bisphosphate aldolase noncatalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(211720, NULL, 'G3DSA:3.30.70.330:FF:000358', NULL, NULL, 'RNA exonuclease 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(211721, NULL, 'G3DSA:3.40.630.10:FF:000339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211722, NULL, 'G3DSA:1.20.58.60:FF:000778', NULL, NULL, 'Wu:fi04e12', NULL, NULL, NULL, NULL, NULL, 4),
(211723, NULL, 'G3DSA:3.30.450.20:FF:000156', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(211724, NULL, 'G3DSA:2.60.40.10:FF:005238', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211725, NULL, 'G3DSA:3.30.710.10:FF:000185', NULL, NULL, 'Btb/poz domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(211726, NULL, 'G3DSA:4.10.1240.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211727, NULL, 'G3DSA:1.10.287.4070:FF:000009', NULL, NULL, 'Pre-mRNA processing ribonucleoprotein, binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(211728, NULL, 'G3DSA:1.25.40.10:FF:005327', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g52620', NULL, NULL, NULL, NULL, NULL, 4),
(211729, NULL, 'G3DSA:3.20.20.80:FF:000608', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211730, NULL, 'G3DSA:3.60.40.10:FF:000166', NULL, NULL, 'Protein phosphatase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(211731, NULL, 'G3DSA:2.60.220.20:FF:000001', NULL, NULL, 'Beta-galactosidase, putative (AFU_orthologue AFUA_5G00670)', NULL, NULL, NULL, NULL, NULL, 4),
(211732, NULL, 'G3DSA:3.90.25.10:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211733, NULL, 'G3DSA:3.90.550.10:FF:000698', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211734, NULL, 'G3DSA:1.10.10.60:FF:001080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211735, NULL, 'G3DSA:3.30.160.60:FF:001236', NULL, NULL, 'E3 ubiquitin-protein ligase ZNRF2', NULL, NULL, NULL, NULL, NULL, 4),
(211736, NULL, 'G3DSA:1.25.10.10:FF:002919', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211737, NULL, 'G3DSA:3.20.20.330:FF:000030', NULL, NULL, 'Uncharacterized protein C57A7.07c', NULL, NULL, NULL, NULL, NULL, 4),
(211738, NULL, 'G3DSA:3.20.70.20:FF:000004', NULL, NULL, 'Ribonucleoside-diphosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(211739, NULL, 'G3DSA:2.30.29.30:FF:000806', NULL, NULL, 'Putative phosphatidylinositol-3-phosphate binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(211740, NULL, 'G3DSA:3.40.720.10:FF:000043', NULL, NULL, 'Acid phosphatase PHOa', NULL, NULL, NULL, NULL, NULL, 4),
(211741, NULL, 'G3DSA:3.30.70.330:FF:002887', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211742, NULL, 'G3DSA:4.10.260.10:FF:000004', NULL, NULL, 'guanine nucleotide-binding protein G(I)/G(S)/G(O) subunit gamma-13', NULL, NULL, NULL, NULL, NULL, 4),
(211743, NULL, 'G3DSA:1.10.10.60:FF:001102', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211744, NULL, 'G3DSA:1.10.238.10:FF:000936', NULL, NULL, 'EF-hand domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211745, NULL, 'G3DSA:2.130.10.10:FF:003861', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211746, NULL, 'G3DSA:3.40.50.620:FF:000528', NULL, NULL, 'Os02g0183900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(211747, NULL, 'G3DSA:1.10.10.2030:FF:000003', NULL, NULL, 'Rts2p', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(211748, NULL, 'G3DSA:1.10.10.10:FF:001380', NULL, NULL, 'Caffeic acid 3-O-methyltransferase isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(211749, NULL, 'G3DSA:2.60.120.200:FF:000494', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(211750, NULL, 'G3DSA:1.20.1250.20:FF:000723', NULL, NULL, 'Putative multidrug resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(211751, NULL, 'G3DSA:3.30.450.20:FF:000038', NULL, NULL, 'Sensor domain-containing diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(211752, NULL, 'G3DSA:1.20.5.110:FF:000213', NULL, NULL, 'Synaptobrevin 1-2', NULL, NULL, NULL, NULL, NULL, 4),
(211753, NULL, 'G3DSA:2.60.40.1180:FF:000051', NULL, NULL, 'Alpha-L-fucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(211754, NULL, 'G3DSA:3.30.40.10:FF:000476', NULL, NULL, 'E3 SUMO-protein ligase SIZ1', NULL, NULL, NULL, NULL, NULL, 4),
(211755, NULL, 'G3DSA:3.60.20.10:FF:000171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211756, NULL, 'G3DSA:1.10.472.80:FF:000107', NULL, NULL, 'Rab GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211757, NULL, 'G3DSA:3.30.70.330:FF:002657', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211758, NULL, 'G3DSA:3.90.80.10:FF:000021', NULL, NULL, 'Inorganic pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(211759, NULL, 'G3DSA:3.40.50.300:FF:007228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211760, NULL, 'G3DSA:1.10.10.60:FF:000826', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211761, NULL, 'G3DSA:2.10.25.10:FF:001130', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(211762, NULL, 'G3DSA:3.90.190.10:FF:000501', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211763, NULL, 'G3DSA:3.30.70.330:FF:001134', NULL, NULL, 'Poly(A) binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(211764, NULL, 'G3DSA:2.70.160.11:FF:000060', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(211765, NULL, 'G3DSA:1.20.58.390:FF:000010', NULL, NULL, 'Nicotinic acetylcholine receptor subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(211766, NULL, 'G3DSA:3.50.50.60:FF:001031', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(211767, NULL, 'G3DSA:3.40.30.10:FF:000211', NULL, NULL, 'TPR repeat-containing thioredoxin TTL4', NULL, NULL, NULL, NULL, NULL, 4),
(211768, NULL, 'G3DSA:3.40.50.10730:FF:000002', NULL, NULL, 'Urocanate hydratase 1', NULL, NULL, NULL, NULL, NULL, 4),
(211769, NULL, 'G3DSA:3.30.40.10:FF:002275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211770, NULL, 'G3DSA:2.40.30.10:FF:000112', NULL, NULL, 'TetQ GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(211771, NULL, 'G3DSA:1.10.287.70:FF:000472', NULL, NULL, 'Potassium channel, subfamily K, member 12-like', NULL, NULL, NULL, NULL, NULL, 4),
(211772, NULL, 'G3DSA:3.30.160.190:FF:000004', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(211773, NULL, 'G3DSA:2.130.10.10:FF:005328', NULL, NULL, 'Wd-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211774, NULL, 'G3DSA:1.25.10.10:FF:001352', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211775, NULL, 'G3DSA:1.10.238.10:FF:000402', NULL, NULL, 'Calcium-binding protein SPEC 2D', NULL, NULL, NULL, NULL, NULL, 4),
(211776, NULL, 'G3DSA:1.10.238.10:FF:001156', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(211777, NULL, 'G3DSA:3.30.70.330:FF:000471', NULL, NULL, 'Polyadenylate-binding RBP45B-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(211778, NULL, 'G3DSA:3.40.50.300:FF:001057', NULL, NULL, 'LPS export ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(211779, NULL, 'G3DSA:2.60.40.1230:FF:000004', NULL, NULL, 'AP-1 complex subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(211780, NULL, 'G3DSA:2.60.40.1220:FF:000001', NULL, NULL, 'CopC domain-containing protein YobA', NULL, NULL, NULL, NULL, NULL, 4),
(211781, NULL, 'G3DSA:4.10.1000.10:FF:000134', NULL, NULL, 'AGL116Cp', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(211782, NULL, 'G3DSA:3.30.450.60:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211783, NULL, 'G3DSA:2.30.42.10:FF:000197', NULL, NULL, 'Periplasmic serine endoprotease DegP-like', NULL, NULL, NULL, NULL, NULL, 4),
(211784, NULL, 'G3DSA:3.40.50.1010:FF:000021', NULL, NULL, 'DIS3-like exonuclease 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(211785, NULL, 'G3DSA:3.30.160.60:FF:005564', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211786, NULL, 'G3DSA:1.20.1250.20:FF:001858', NULL, NULL, 'MFS multidrug transporter, putative (AFU_orthologue AFUA_3G14560)', NULL, NULL, NULL, NULL, NULL, 4),
(211787, NULL, 'G3DSA:3.30.160.60:FF:000101', NULL, NULL, 'zinc finger protein 436 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(211788, NULL, 'G3DSA:1.10.2000.10:FF:000018', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(211789, NULL, 'G3DSA:2.130.10.10:FF:005660', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211790, NULL, 'G3DSA:2.60.120.290:FF:000037', NULL, NULL, 'Kremen protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(211791, NULL, 'G3DSA:1.20.20.10:FF:000008', NULL, NULL, 'ATPase subunit 9 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(211792, NULL, 'G3DSA:3.30.200.20:FF:000458', NULL, NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 196', NULL, NULL, NULL, NULL, NULL, 4),
(211793, NULL, 'G3DSA:2.130.10.10:FF:001377', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(211794, NULL, 'G3DSA:3.40.390.10:FF:000269', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211795, NULL, 'G3DSA:3.30.540.30:FF:000020', NULL, NULL, 'Dipeptidyl peptidase III', NULL, NULL, NULL, NULL, NULL, 4),
(211796, NULL, 'G3DSA:1.20.120.1530:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211797, NULL, 'G3DSA:2.130.10.30:FF:000023', NULL, NULL, 'serine/threonine-protein kinase Nek9 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(211798, NULL, 'G3DSA:3.90.15.10:FF:000005', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(211799, NULL, 'G3DSA:1.20.900.10:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211800, NULL, 'G3DSA:3.30.460.10:FF:000204', NULL, NULL, '2''-5'' oligoadenylate synthetase 1E', NULL, NULL, NULL, NULL, NULL, 4),
(211801, NULL, 'G3DSA:1.10.510.10:FF:002132', NULL, NULL, 'TBC Kinase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(211802, NULL, 'G3DSA:3.40.50.300:FF:007285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211803, NULL, 'G3DSA:3.30.160.60:FF:001910', NULL, NULL, 'zinc finger protein 420 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(211804, NULL, 'G3DSA:1.20.1730.10:FF:000072', NULL, NULL, 'Two-component sensor CbrA', NULL, NULL, NULL, NULL, NULL, 4),
(211805, NULL, 'G3DSA:2.10.10.10:FF:000028', NULL, NULL, 'HGF activator', NULL, NULL, NULL, NULL, NULL, 4),
(211806, NULL, 'G3DSA:3.30.1490.20:FF:000085', NULL, NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(211807, NULL, 'G3DSA:4.10.280.10:FF:000056', NULL, NULL, 'mesogenin-1', NULL, NULL, NULL, NULL, NULL, 4),
(211808, NULL, 'G3DSA:3.30.450.20:FF:000656', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(211809, NULL, 'G3DSA:3.30.110.10:FF:000010', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(211810, NULL, 'G3DSA:3.40.1190.20:FF:000054', NULL, NULL, 'ATP-dependent (S)-NAD(P)H-hydrate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(211811, NULL, 'G3DSA:3.40.50.2300:FF:000661', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(211812, NULL, 'G3DSA:3.30.420.140:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211813, NULL, 'G3DSA:1.20.1250.20:FF:002179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211814, NULL, 'G3DSA:3.40.50.1820:FF:000825', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(211815, NULL, 'G3DSA:3.20.20.140:FF:000063', NULL, NULL, 'Phosphotriesterase homology protein', NULL, NULL, NULL, NULL, NULL, 4),
(211816, NULL, 'G3DSA:3.40.50.720:FF:001008', NULL, NULL, 'Putative capsular polysaccharide biosynthesis glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(211817, NULL, 'G3DSA:2.30.29.30:FF:000065', NULL, NULL, 'T cell lymphoma invasion and metastasis 1', NULL, NULL, NULL, NULL, NULL, 4),
(211818, NULL, 'G3DSA:3.10.20.30:FF:000021', NULL, NULL, 'Ubiquitin-related modifier 1', NULL, NULL, NULL, NULL, NULL, 4),
(211819, NULL, 'G3DSA:3.20.20.80:FF:000322', NULL, NULL, 'Probable alpha-L-arabinofuranosidase A', NULL, NULL, NULL, NULL, NULL, 4),
(211820, NULL, 'G3DSA:3.20.20.150:FF:000066', NULL, NULL, 'Putative hydroxypyruvate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(211821, NULL, 'G3DSA:3.40.50.300:FF:006003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211822, NULL, 'G3DSA:3.80.10.10:FF:003030', NULL, NULL, 'F-box and leucine-rich repeat protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(211823, NULL, 'G3DSA:3.40.50.300:FF:005429', NULL, NULL, 'RAB34, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(211824, NULL, 'G3DSA:3.40.50.300:FF:003917', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211825, NULL, 'G3DSA:2.40.50.170:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211826, NULL, 'G3DSA:3.40.50.300:FF:005486', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(211827, NULL, 'G3DSA:3.30.110.20:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211828, NULL, 'G3DSA:2.40.50.140:FF:001125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211829, NULL, 'G3DSA:1.10.3370.10:FF:000001', NULL, NULL, 'Preprotein translocase subunit SecY', NULL, NULL, NULL, NULL, NULL, 4),
(211830, NULL, 'G3DSA:1.20.120.610:FF:000025', NULL, NULL, 'ATPase, F0/V0 complex, subunit C protein', NULL, NULL, NULL, NULL, NULL, 4),
(211831, NULL, 'G3DSA:3.30.70.330:FF:000858', NULL, NULL, 'Flowering time control protein FCA isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(211832, NULL, 'G3DSA:2.60.120.10:FF:000070', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(211833, NULL, 'G3DSA:3.20.20.80:FF:000642', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211834, NULL, 'G3DSA:3.40.50.12710:FF:000012', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7', NULL, NULL, NULL, NULL, NULL, 4),
(211835, NULL, 'G3DSA:3.40.50.1820:FF:000882', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(211836, NULL, 'G3DSA:1.10.3130.10:FF:000017', NULL, NULL, 'Serine acetyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(211837, NULL, 'G3DSA:2.60.120.590:FF:000026', NULL, NULL, '2OG-Fe(II) oxygenase superfamily, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211838, NULL, 'G3DSA:3.30.420.10:FF:000084', NULL, NULL, 'Tn7 transposase B', NULL, NULL, NULL, NULL, NULL, 4),
(211839, NULL, 'G3DSA:2.130.10.10:FF:003529', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211840, NULL, 'G3DSA:2.40.50.180:FF:000007', NULL, NULL, 'Purine-binding chemotaxis protein CheW', NULL, NULL, NULL, NULL, NULL, 4),
(211841, NULL, 'G3DSA:3.30.40.210:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211842, NULL, 'G3DSA:3.40.50.720:FF:000845', NULL, NULL, 'Zinc-binding dehydrogenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(211843, NULL, 'G3DSA:1.25.40.20:FF:000316', NULL, NULL, 'BRCA1-associated RING domain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(211844, NULL, 'G3DSA:1.25.10.10:FF:001913', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211845, NULL, 'G3DSA:3.40.50.720:FF:002565', NULL, NULL, 'Glucose-6-phosphate 1-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(211846, NULL, 'G3DSA:3.40.50.740:FF:000031', NULL, NULL, 'Probable oxidoreductase YyaE', NULL, NULL, NULL, NULL, NULL, 4),
(211847, NULL, 'G3DSA:2.60.40.10:FF:003439', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(211848, NULL, 'G3DSA:1.10.101.10:FF:000041', NULL, NULL, 'Peptidoglycan-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(211849, NULL, 'G3DSA:3.70.10.10:FF:000023', NULL, NULL, 'Proliferating cell nuclear antigen', NULL, NULL, NULL, NULL, NULL, 4),
(211850, NULL, 'G3DSA:3.40.50.1760:FF:000009', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(211851, NULL, 'G3DSA:1.10.10.1350:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211852, NULL, 'G3DSA:3.60.15.10:FF:000248', NULL, NULL, 'Putative hydrolase C777.06c', NULL, NULL, NULL, NULL, NULL, 4),
(211853, NULL, 'G3DSA:3.40.250.10:FF:000001', NULL, NULL, 'Sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(211854, NULL, 'G3DSA:3.30.710.10:FF:000308', NULL, NULL, 'Putative structure-specific endonuclease subunit slx4', NULL, NULL, NULL, NULL, NULL, 4),
(211855, NULL, 'G3DSA:1.25.40.20:FF:001733', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211856, NULL, 'G3DSA:1.25.40.10:FF:004546', NULL, NULL, 'Transcription factor IIIC-gamma subunit', NULL, NULL, NULL, NULL, NULL, 4),
(211857, NULL, 'G3DSA:1.20.1250.20:FF:000498', NULL, NULL, 'Putative monocarboxylate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(211858, NULL, 'G3DSA:3.40.50.300:FF:005840', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(211859, NULL, 'G3DSA:3.40.50.410:FF:000016', NULL, NULL, 'Collagen type VI alpha 3 chain', NULL, NULL, NULL, NULL, NULL, 4),
(211860, NULL, 'G3DSA:3.90.55.10:FF:000002', NULL, NULL, 'Trimethylamine-N-oxide reductase TorA', NULL, NULL, NULL, NULL, NULL, 4),
(211861, NULL, 'G3DSA:1.25.40.10:FF:001730', NULL, NULL, 'Pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(211862, NULL, 'G3DSA:1.20.1560.10:FF:000187', NULL, NULL, 'ATP binding cassette subfamily B member 1', NULL, NULL, NULL, NULL, NULL, 4),
(211863, NULL, 'G3DSA:3.90.850.10:FF:000007', NULL, NULL, 'Fumarylacetoacetate hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(211864, NULL, 'G3DSA:3.30.900.10:FF:000014', NULL, NULL, 'Autophagy-related protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(211865, NULL, 'G3DSA:2.130.10.10:FF:005603', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211866, NULL, 'G3DSA:3.30.70.330:FF:002269', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211867, NULL, 'G3DSA:3.30.160.60:FF:003535', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211868, NULL, 'G3DSA:3.30.160.60:FF:003355', NULL, NULL, 'Zinc finger protein 28 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(211869, NULL, 'G3DSA:3.40.50.2300:FF:001442', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211870, NULL, 'G3DSA:3.40.50.150:FF:001860', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211871, NULL, 'G3DSA:3.10.50.40:FF:000060', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(211872, NULL, 'G3DSA:2.60.120.430:FF:000006', NULL, NULL, 'Malectin', NULL, NULL, NULL, NULL, NULL, 4),
(211873, NULL, 'G3DSA:3.40.50.300:FF:003356', NULL, NULL, 'Putative ATP dependent DEAD-box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(211874, NULL, 'G3DSA:3.30.200.20:FF:001571', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211875, NULL, 'G3DSA:1.20.120.160:FF:000025', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(211876, NULL, 'G3DSA:3.30.160.60:FF:002130', NULL, NULL, 'Zinc finger protein 136', NULL, NULL, NULL, NULL, NULL, 4),
(211877, NULL, 'G3DSA:1.20.1250.10:FF:000102', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211878, NULL, 'G3DSA:3.90.1150.10:FF:000436', NULL, NULL, 'Hercynylcysteine sulfoxide lyase', NULL, NULL, NULL, NULL, NULL, 4),
(211879, NULL, 'G3DSA:2.60.40.10:FF:005890', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211880, NULL, 'G3DSA:3.30.420.40:FF:000986', NULL, NULL, 'Stress-70 protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(211881, NULL, 'G3DSA:2.30.30.40:FF:000060', NULL, NULL, 'FCH and double SH3 domains protein 2', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(211882, NULL, 'G3DSA:3.40.350.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211883, NULL, 'G3DSA:1.10.8.60:FF:000336', NULL, NULL, 'Vacuolar transport protein 4A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211884, NULL, 'G3DSA:3.40.1000.10:FF:000010', NULL, NULL, 'PsbP domain-containing protein 6, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(211885, NULL, 'G3DSA:3.40.190.120:FF:000004', NULL, NULL, 'ABC transporter amino acid permease', NULL, NULL, NULL, NULL, NULL, 4),
(211886, NULL, 'G3DSA:2.130.10.10:FF:001113', NULL, NULL, 'OSIGBa0103M18.5 protein', NULL, NULL, NULL, NULL, NULL, 4),
(211887, NULL, 'G3DSA:1.20.1270.60:FF:000253', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(211888, NULL, 'G3DSA:3.40.50.150:FF:000303', NULL, NULL, 'Type III restriction-modification system StyLTI enzyme mod', NULL, NULL, NULL, NULL, NULL, 4),
(211889, NULL, 'G3DSA:2.60.40.10:FF:001848', NULL, NULL, 'Complement component C5', NULL, NULL, NULL, NULL, NULL, 4),
(211890, NULL, 'G3DSA:3.60.10.10:FF:000372', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211891, NULL, 'G3DSA:2.40.50.90:FF:000109', NULL, NULL, 'Transcription factor (Snd1/p100), putative', NULL, NULL, NULL, NULL, NULL, 4),
(211892, NULL, 'G3DSA:3.30.420.10:FF:000264', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(211893, NULL, 'G3DSA:2.60.40.10:FF:002124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211894, NULL, 'G3DSA:2.130.10.10:FF:000837', NULL, NULL, 'Blast:Mitogen-activated protein kinase-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(211895, NULL, 'G3DSA:1.25.40.10:FF:001112', NULL, NULL, 'wolframin', NULL, NULL, NULL, NULL, NULL, 4),
(211896, NULL, 'G3DSA:1.20.1420.30:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211897, NULL, 'G3DSA:1.20.1560.10:FF:000541', NULL, NULL, 'ATP binding cassette subfamily B19', NULL, NULL, NULL, NULL, NULL, 4),
(211898, NULL, 'G3DSA:2.60.260.20:FF:000178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211899, NULL, 'G3DSA:2.130.10.10:FF:005042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211900, NULL, 'G3DSA:3.30.420.10:FF:000207', NULL, NULL, 'Putative transposase', NULL, NULL, NULL, NULL, NULL, 4),
(211901, NULL, 'G3DSA:3.10.20.870:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211902, NULL, 'G3DSA:2.60.120.330:FF:000010', NULL, NULL, '1-aminocyclopropane-1-carboxylate oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(211903, NULL, 'G3DSA:2.60.40.10:FF:000005', NULL, NULL, 'Neuronal cell adhesion molecule', NULL, NULL, NULL, NULL, NULL, 4),
(211904, NULL, 'G3DSA:1.25.40.10:FF:005338', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211905, NULL, 'G3DSA:2.30.39.10:FF:000065', NULL, NULL, 'Serpin family A member 5', NULL, NULL, NULL, NULL, NULL, 4),
(211906, NULL, 'G3DSA:3.40.50.2300:FF:000947', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211907, NULL, 'G3DSA:1.10.10.10:FF:001941', NULL, NULL, 'MarR family transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(211908, NULL, 'G3DSA:1.10.287.90:FF:000011', NULL, NULL, 'Probable quinol oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(211909, NULL, 'G3DSA:1.10.506.10:FF:000104', NULL, NULL, 'Plexin A1', NULL, NULL, NULL, NULL, NULL, 4),
(211910, NULL, 'G3DSA:3.30.40.10:FF:001140', NULL, NULL, 'RING-H2 finger protein ATL52', NULL, NULL, NULL, NULL, NULL, 4),
(211911, NULL, 'G3DSA:3.40.50.300:FF:000894', NULL, NULL, 'Discs large MAGUK scaffold protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(211912, NULL, 'G3DSA:1.20.58.760:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211913, NULL, 'G3DSA:2.30.42.10:FF:000472', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211914, NULL, 'G3DSA:3.40.190.80:FF:000090', NULL, NULL, 'Os12g0183200 protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(211915, NULL, 'G3DSA:3.80.10.10:FF:004036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211916, NULL, 'G3DSA:3.40.850.10:FF:000529', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211917, NULL, 'G3DSA:2.60.40.3170:FF:000007', NULL, NULL, 'Tpp-2', NULL, NULL, NULL, NULL, NULL, 4),
(211918, NULL, 'G3DSA:3.30.70.330:FF:000678', NULL, NULL, 'zinc finger CCCH domain-containing protein 53-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(211919, NULL, 'G3DSA:2.130.10.10:FF:001731', NULL, NULL, 'CHromatin Assembly Factor', NULL, NULL, NULL, NULL, NULL, 4),
(211920, NULL, 'G3DSA:2.60.40.60:FF:001009', NULL, NULL, 'Protein CBR-CDH-7', NULL, NULL, NULL, NULL, NULL, 4),
(211921, NULL, 'G3DSA:3.40.1280.10:FF:000047', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4),
(211922, NULL, 'G3DSA:3.30.1240.10:FF:000064', NULL, NULL, 'Putative sugar phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(211923, NULL, 'G3DSA:1.20.58.60:FF:000273', NULL, NULL, 'Zormin, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(211924, NULL, 'G3DSA:3.40.1000.30:FF:000016', NULL, NULL, 'Proteasome inhibitor PI31 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(211925, NULL, 'G3DSA:3.20.20.190:FF:000061', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(211926, NULL, 'G3DSA:3.40.50.150:FF:001585', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211927, NULL, 'G3DSA:1.10.640.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211928, NULL, 'G3DSA:1.25.40.10:FF:003186', NULL, NULL, 'Uncharacterized protein CaJ7.0066', NULL, NULL, NULL, NULL, NULL, 4),
(211929, NULL, 'G3DSA:1.10.150.220:FF:000001', NULL, NULL, 'Phosphatase 1, regulatory (Inhibitor) subunit 14C', NULL, NULL, NULL, NULL, NULL, 4),
(211930, NULL, 'G3DSA:3.40.50.300:FF:003631', NULL, NULL, 'DEAH (Asp-Glu-Ala-His) box polypeptide 37', NULL, NULL, NULL, NULL, NULL, 4),
(211931, NULL, 'G3DSA:3.40.190.10:FF:000529', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(211932, NULL, 'G3DSA:3.40.1110.10:FF:000125', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(211933, NULL, 'G3DSA:3.90.1750.10:FF:000105', NULL, NULL, 'Ubiquitin-protein ligase E3 C', NULL, NULL, NULL, NULL, NULL, 4),
(211934, NULL, 'G3DSA:3.60.21.10:FF:000015', NULL, NULL, 'Vacuolar protein sorting-associated protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(211935, NULL, 'G3DSA:1.10.510.10:FF:001076', NULL, NULL, 'Altered disjunction', NULL, NULL, NULL, NULL, NULL, 4),
(211936, NULL, 'G3DSA:1.20.5.170:FF:000260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211937, NULL, 'G3DSA:3.30.1370.110:FF:000009', NULL, NULL, 'Polyadenylate-binding protein-interacting protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(211938, NULL, 'G3DSA:3.30.559.70:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211939, NULL, 'G3DSA:3.40.50.2000:FF:000397', NULL, NULL, 'D-inositol 3-phosphate glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(211940, NULL, 'G3DSA:3.30.720.210:FF:000009', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(211941, NULL, 'G3DSA:1.20.1740.10:FF:000072', NULL, NULL, 'Cationic amino acid transport integral membraneprotein', NULL, NULL, NULL, NULL, NULL, 4),
(211942, NULL, 'G3DSA:3.30.720.200:FF:000006', NULL, NULL, 'Glycyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211943, NULL, 'G3DSA:1.20.5.510:FF:000002', NULL, NULL, 'Cytochrome b6-f complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(211944, NULL, 'G3DSA:2.60.40.10:FF:001635', NULL, NULL, 'SLAM family member 8', NULL, NULL, NULL, NULL, NULL, 4),
(211945, NULL, 'G3DSA:3.30.70.3160:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211946, NULL, 'G3DSA:3.30.1370.100:FF:000006', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(211947, NULL, 'G3DSA:3.10.580.10:FF:000201', NULL, NULL, 'UPF0053 protein MG146', NULL, NULL, NULL, NULL, NULL, 4),
(211948, NULL, 'G3DSA:2.60.40.1450:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211949, NULL, 'G3DSA:3.20.20.70:FF:000044', NULL, NULL, 'Deoxyribose-phosphate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(211950, NULL, 'G3DSA:1.20.1070.10:FF:000341', NULL, NULL, 'Methuselah-like 5, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(211951, NULL, 'G3DSA:3.60.40.10:FF:000104', NULL, NULL, 'Protein phosphatase 2C 32', NULL, NULL, NULL, NULL, NULL, 4),
(211952, NULL, 'G3DSA:1.20.1720.10:FF:000065', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(211953, NULL, 'G3DSA:2.20.110.10:FF:000038', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(211954, NULL, 'G3DSA:2.30.30.380:FF:000054', NULL, NULL, 'EAP30/Vps36 family-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(211955, NULL, 'G3DSA:3.90.1150.210:FF:000029', NULL, NULL, 'F-actin-capping protein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(211956, NULL, 'G3DSA:1.20.1740.10:FF:000134', NULL, NULL, 'Uncharacterized amino-acid permease B0303.11', NULL, NULL, NULL, NULL, NULL, 4),
(211957, NULL, 'G3DSA:2.60.120.10:FF:000283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211958, NULL, 'G3DSA:3.80.10.10:FF:002237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211959, NULL, 'G3DSA:3.20.20.60:FF:000041', NULL, NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(211960, NULL, 'G3DSA:3.40.50.150:FF:001708', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211961, NULL, 'G3DSA:1.20.58.190:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211962, NULL, 'G3DSA:1.10.510.10:FF:003150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211963, NULL, 'G3DSA:1.10.287.860:FF:000001', NULL, NULL, 'GTP pyrophosphokinase YjbM', NULL, NULL, NULL, NULL, NULL, 4),
(211964, NULL, 'G3DSA:3.40.50.300:FF:001950', NULL, NULL, 'Early gene transcription factor VETF small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(211965, NULL, 'G3DSA:1.10.520.10:FF:000042', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(211966, NULL, 'G3DSA:3.40.50.800:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211967, NULL, 'G3DSA:2.10.25.10:FF:001299', NULL, NULL, 'Protein eyes shut homolog', NULL, NULL, NULL, NULL, NULL, 4),
(211968, NULL, 'G3DSA:3.80.10.10:FF:004373', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211969, NULL, 'G3DSA:2.130.10.10:FF:001613', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211970, NULL, 'G3DSA:3.10.129.10:FF:000248', NULL, NULL, 'Acyl-CoA thioester hydrolase, YbgC/YbaW family', NULL, NULL, NULL, NULL, NULL, 4),
(211971, NULL, 'G3DSA:1.25.40.20:FF:001452', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211972, NULL, 'G3DSA:3.30.950.10:FF:000017', NULL, NULL, 'Uroporphyrinogen-III C-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(211973, NULL, 'G3DSA:3.40.50.300:FF:005216', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(211974, NULL, 'G3DSA:3.60.40.10:FF:000048', NULL, NULL, 'probable protein phosphatase 1N isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(211975, NULL, 'G3DSA:1.25.40.10:FF:003528', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211976, NULL, 'G3DSA:2.30.29.30:FF:000278', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(211977, NULL, 'G3DSA:3.40.33.10:FF:000021', NULL, NULL, 'Scl-5', NULL, NULL, NULL, NULL, NULL, 4),
(211978, NULL, 'G3DSA:3.50.50.60:FF:000917', NULL, NULL, '5-(hydroxymethyl)furfural oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(211979, NULL, 'G3DSA:2.60.40.10:FF:005906', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211980, NULL, 'G3DSA:3.40.50.1820:FF:000904', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(211981, NULL, 'G3DSA:3.40.50.1460:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211982, NULL, 'G3DSA:1.10.565.10:FF:000033', NULL, NULL, 'Nuclear receptor subfamily 4 group A member 2', NULL, NULL, NULL, NULL, NULL, 4),
(211983, NULL, 'G3DSA:3.30.750.24:FF:000178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211984, NULL, 'G3DSA:3.30.70.330:FF:000976', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein A2/B1', NULL, NULL, NULL, NULL, NULL, 4),
(211985, NULL, 'G3DSA:2.60.40.60:FF:000498', NULL, NULL, 'Protocadherin19 isoform1', NULL, NULL, NULL, NULL, NULL, 4),
(211986, NULL, 'G3DSA:3.20.20.80:FF:000047', NULL, NULL, 'Chitinase-3-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(211987, NULL, 'G3DSA:3.90.1150.10:FF:000493', NULL, NULL, 'Aminotransferase, conjectural', NULL, NULL, NULL, NULL, NULL, 4),
(211988, NULL, 'G3DSA:2.40.30.110:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211989, NULL, 'G3DSA:1.10.640.10:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(211990, NULL, 'G3DSA:1.10.600.10:FF:000043', NULL, NULL, 'Polyprenyl synthetase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(211991, NULL, 'G3DSA:1.10.510.10:FF:001637', NULL, NULL, 'Kinase, CMGC CMGC-GL1', NULL, NULL, NULL, NULL, NULL, 4),
(211992, NULL, 'G3DSA:1.10.8.1310:FF:000001', NULL, NULL, 'TBC1 domain family, member 20', NULL, NULL, NULL, NULL, NULL, 4),
(211993, NULL, 'G3DSA:3.30.2280.10:FF:000004', NULL, NULL, 'Protein CBG05668', NULL, NULL, NULL, NULL, NULL, 4),
(211994, NULL, 'G3DSA:3.40.50.300:FF:006739', NULL, NULL, 'Thymidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(211995, NULL, 'G3DSA:3.40.50.300:FF:007307', NULL, NULL, 'Ras-like protein Rac2', NULL, NULL, NULL, NULL, NULL, 4),
(211996, NULL, 'G3DSA:1.10.3380.10:FF:000007', NULL, NULL, 'DnaJ protein ERDJ2A', NULL, NULL, NULL, NULL, NULL, 4),
(211997, NULL, 'G3DSA:3.30.160.60:FF:005502', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(211998, NULL, 'G3DSA:3.30.1160.10:FF:000001', NULL, NULL, 'Cyanate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(211999, NULL, 'G3DSA:3.30.30.170:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212000, NULL, 'G3DSA:2.130.10.10:FF:001495', NULL, NULL, 'Hypothetical_protein', NULL, NULL, NULL, NULL, NULL, 4),
(212001, NULL, 'G3DSA:3.90.1750.10:FF:000111', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212002, NULL, 'G3DSA:3.40.50.11850:FF:000006', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(212003, NULL, 'G3DSA:1.20.1070.10:FF:000392', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212004, NULL, 'G3DSA:1.10.630.10:FF:000550', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212005, NULL, 'G3DSA:1.10.510.10:FF:001963', NULL, NULL, 'Serine/threonine protein kinase 21', NULL, NULL, NULL, NULL, NULL, 4),
(212006, NULL, 'G3DSA:2.60.98.20:FF:000006', NULL, NULL, 'Flagellar hook protein FlgE', NULL, NULL, NULL, NULL, NULL, 4),
(212007, NULL, 'G3DSA:1.10.640.10:FF:000045', NULL, NULL, 'Protein CBG06977', NULL, NULL, NULL, NULL, NULL, 4),
(212008, NULL, 'G3DSA:3.30.160.60:FF:005446', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212009, NULL, 'G3DSA:3.40.50.2300:FF:001111', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212010, NULL, 'G3DSA:3.40.1190.20:FF:000228', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212011, NULL, 'G3DSA:1.10.8.60:FF:000224', NULL, NULL, '26S protease regulatory subunit S10B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(212012, NULL, 'G3DSA:3.40.50.300:FF:001894', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(212013, NULL, 'G3DSA:3.40.50.11860:FF:000009', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(212014, NULL, 'G3DSA:3.30.190.20:FF:000001', NULL, NULL, '50S ribosomal protein L1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(212015, NULL, 'G3DSA:2.40.290.10:FF:000041', NULL, NULL, 'ATP dependent DNA ligase 1', NULL, NULL, NULL, NULL, NULL, 4),
(212016, NULL, 'G3DSA:2.60.120.10:FF:000013', NULL, NULL, 'cAMP-dependent protein kinase type I regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(212017, NULL, 'G3DSA:1.20.1250.20:FF:000223', NULL, NULL, 'Major facilitator superfamily domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(212018, NULL, 'G3DSA:3.90.190.10:FF:000333', NULL, NULL, 'Kinetoplastid-specific dual specificity phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(212019, NULL, 'G3DSA:3.40.50.12670:FF:000016', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(212020, NULL, 'G3DSA:3.40.50.12660:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212021, NULL, 'G3DSA:3.30.40.10:FF:000471', NULL, NULL, 'Histone-lysine N-methyltransferase trithorax', NULL, NULL, NULL, NULL, NULL, 4),
(212022, NULL, 'G3DSA:3.40.920.10:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212023, NULL, 'G3DSA:3.40.640.10:FF:000508', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212024, NULL, 'G3DSA:3.40.50.620:FF:000467', NULL, NULL, 'Nicotinamide-nucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(212025, NULL, 'G3DSA:3.30.559.10:FF:000254', NULL, NULL, 'Choline O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(212026, NULL, 'G3DSA:1.20.1250.20:FF:000493', NULL, NULL, 'proton-associated sugar transporter A', NULL, NULL, NULL, NULL, NULL, 4),
(212027, NULL, 'G3DSA:1.20.58.400:FF:000025', NULL, NULL, 'Vesicle transport V-snare protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(212028, NULL, 'G3DSA:1.10.10.60:FF:001309', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212029, NULL, 'G3DSA:3.30.160.60:FF:004142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212030, NULL, 'G3DSA:3.40.50.2300:FF:000543', NULL, NULL, 'Penicillin-binding protein activator LpoA', NULL, NULL, NULL, NULL, NULL, 4),
(212031, NULL, 'G3DSA:2.60.40.10:FF:001961', NULL, NULL, 'CD101 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(212032, NULL, 'G3DSA:1.25.40.10:FF:003540', NULL, NULL, 'Flagellar_Member_7', NULL, NULL, NULL, NULL, NULL, 4),
(212033, NULL, 'G3DSA:1.10.287.70:FF:000533', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212034, NULL, 'G3DSA:3.40.50.300:FF:006846', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212035, NULL, 'G3DSA:2.60.98.10:FF:000003', NULL, NULL, 'Structural polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(212036, NULL, 'G3DSA:3.40.50.1460:FF:000077', NULL, NULL, 'Caspase 10', NULL, NULL, NULL, NULL, NULL, 4),
(212037, NULL, 'G3DSA:2.60.120.20:FF:000016', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(212038, NULL, 'G3DSA:3.90.1520.10:FF:000009', NULL, NULL, 'Guanylate cyclase soluble subunit beta-2', NULL, NULL, NULL, NULL, NULL, 4),
(212039, NULL, 'G3DSA:3.30.160.20:FF:000055', NULL, NULL, 'Ribosomal protein S24/S35', NULL, NULL, NULL, NULL, NULL, 4),
(212040, NULL, 'G3DSA:3.40.50.11840:FF:000003', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(212041, NULL, 'G3DSA:2.60.40.10:FF:005272', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212042, NULL, 'G3DSA:3.90.640.10:FF:000076', NULL, NULL, 'Cytosolic heat shock protein 70, putative', NULL, NULL, NULL, NULL, NULL, 4),
(212043, NULL, 'G3DSA:1.10.630.10:FF:000275', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(212044, NULL, 'G3DSA:3.40.50.970:FF:000049', NULL, NULL, '2-oxoglutarate ferredoxin oxidoreductase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(212045, NULL, 'G3DSA:2.60.120.260:FF:000551', NULL, NULL, 'Neuropilin 1b', NULL, NULL, NULL, NULL, NULL, 4),
(212046, NULL, 'G3DSA:2.60.120.260:FF:000495', NULL, NULL, 'Protein CBG04402', NULL, NULL, NULL, NULL, NULL, 4),
(212047, NULL, 'G3DSA:1.10.287.130:FF:000057', NULL, NULL, 'Type IV pilus sensor protein PilS', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(212048, NULL, 'G3DSA:3.30.1240.10:FF:000002', NULL, NULL, 'HMP-PP phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(212049, NULL, 'G3DSA:3.40.50.300:FF:001271', NULL, NULL, 'Mitochondrial Rho GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(212050, NULL, 'G3DSA:3.40.50.300:FF:005542', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212051, NULL, 'G3DSA:1.25.10.10:FF:000042', NULL, NULL, 'exportin-7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(212052, NULL, 'G3DSA:3.30.2090.10:FF:000029', NULL, NULL, 'Heavy metal efflux pump permease component CzcA family', NULL, NULL, NULL, NULL, NULL, 4),
(212053, NULL, 'G3DSA:3.40.50.1010:FF:000291', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212054, NULL, 'G3DSA:3.30.450.60:FF:000027', NULL, NULL, 'AP complex subunit sigma', NULL, NULL, NULL, NULL, NULL, 4),
(212055, NULL, 'G3DSA:2.30.29.30:FF:001060', NULL, NULL, 'IQ motif and Sec7 domain 2', NULL, NULL, NULL, NULL, NULL, 4),
(212056, NULL, 'G3DSA:3.30.40.10:FF:000701', NULL, NULL, 'Zinc finger FYVE-type containing 19', NULL, NULL, NULL, NULL, NULL, 4),
(212057, NULL, 'G3DSA:3.40.50.1820:FF:001686', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212058, NULL, 'G3DSA:3.30.30.30:FF:000015', NULL, NULL, 'Putative heat shock protein 110', NULL, NULL, NULL, NULL, NULL, 4),
(212059, NULL, 'G3DSA:1.10.260.100:FF:000023', NULL, NULL, 'ST13, Hsp70 interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(212060, NULL, 'G3DSA:2.160.20.10:FF:000067', NULL, NULL, 'Possible serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(212061, NULL, 'G3DSA:1.25.10.10:FF:001621', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212062, NULL, 'G3DSA:1.20.1280.290:FF:000090', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212063, NULL, 'G3DSA:2.60.40.420:FF:000247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212064, NULL, 'G3DSA:3.40.33.10:FF:000072', NULL, NULL, 'GLI pathogenesis-related 1b', NULL, NULL, NULL, NULL, NULL, 4),
(212065, NULL, 'G3DSA:1.10.472.80:FF:000091', NULL, NULL, 'EVI5 protein', NULL, NULL, NULL, NULL, NULL, 4),
(212066, NULL, 'G3DSA:2.10.25.10:FF:000629', NULL, NULL, 'Laminin subunit alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(212067, NULL, 'G3DSA:1.20.1070.10:FF:002139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212068, NULL, 'G3DSA:3.40.50.620:FF:000523', NULL, NULL, 'Isoleucyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(212069, NULL, 'G3DSA:3.10.290.70:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212070, NULL, 'G3DSA:3.15.10.20:FF:000007', NULL, NULL, 'Aha1 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(212071, NULL, 'G3DSA:3.30.420.10:FF:000090', NULL, NULL, 'Ribonuclease H', NULL, NULL, NULL, NULL, NULL, 4),
(212072, NULL, 'G3DSA:1.20.1560.10:FF:000827', NULL, NULL, 'Multidrug resistance protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(212073, NULL, 'G3DSA:3.20.20.80:FF:000266', NULL, NULL, 'Lactase-like a', NULL, NULL, NULL, NULL, NULL, 4),
(212074, NULL, 'G3DSA:3.30.70.850:FF:000008', NULL, NULL, 'Furin-like protease 1, isoform 1-CRR', NULL, NULL, NULL, NULL, NULL, 4),
(212075, NULL, 'G3DSA:2.60.40.10:FF:000331', NULL, NULL, '1,4-alpha-glucan branching enzyme GlgB', NULL, NULL, NULL, NULL, NULL, 4),
(212076, NULL, 'G3DSA:3.30.2410.10:FF:000004', NULL, NULL, 'E3 ubiquitin-protein ligase HUWE1, variant', NULL, NULL, NULL, NULL, NULL, 4),
(212077, NULL, 'G3DSA:3.40.50.300:FF:007633', NULL, NULL, 'ATPase family AAA domaincontaining protein 5-like, putative', NULL, NULL, NULL, NULL, NULL, 4),
(212078, NULL, 'G3DSA:1.10.630.10:FF:000505', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(212079, NULL, 'G3DSA:1.10.287.70:FF:000477', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212080, NULL, 'G3DSA:3.30.420.580:FF:000007', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(212081, NULL, 'G3DSA:1.25.10.10:FF:001672', NULL, NULL, 'Apr-1', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(212082, NULL, 'G3DSA:2.60.40.10:FF:001309', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', NULL, NULL, NULL, NULL, NULL, 4),
(212083, NULL, 'G3DSA:2.60.120.200:FF:000224', NULL, NULL, 'SP2353, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(212084, NULL, 'G3DSA:1.25.40.10:FF:002865', NULL, NULL, 'tetratricopeptide repeat protein 7A isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(212085, NULL, 'G3DSA:1.10.10.10:FF:001104', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(212086, NULL, 'G3DSA:1.10.3730.20:FF:000032', NULL, NULL, 'Transporter, EamA family', NULL, NULL, NULL, NULL, NULL, 4),
(212087, NULL, 'G3DSA:3.20.20.70:FF:000263', NULL, NULL, 'Putative FMN-dependent dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(212088, NULL, 'G3DSA:3.80.10.10:FF:004480', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(212089, NULL, 'G3DSA:1.25.40.10:FF:002753', NULL, NULL, 'YALI0B19184p', NULL, NULL, NULL, NULL, NULL, 4),
(212090, NULL, 'G3DSA:2.130.10.10:FF:003530', NULL, NULL, 'WD repeat-containing protein 90', NULL, NULL, NULL, NULL, NULL, 4),
(212091, NULL, 'G3DSA:1.20.1110.10:FF:000215', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212092, NULL, 'G3DSA:3.40.50.2000:FF:001116', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(212093, NULL, 'G3DSA:1.10.3500.10:FF:000001', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(212094, NULL, 'G3DSA:3.90.1200.10:FF:000025', NULL, NULL, 'Ethanolamine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(212095, NULL, 'G3DSA:3.30.300.30:FF:000154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212096, NULL, 'G3DSA:3.80.10.10:FF:003991', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212097, NULL, 'G3DSA:3.30.160.60:FF:003029', NULL, NULL, 'Zinc finger protein 766', NULL, NULL, NULL, NULL, NULL, 4),
(212098, NULL, 'G3DSA:2.60.40.10:FF:000848', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(212099, NULL, 'G3DSA:1.25.40.550:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212100, NULL, 'G3DSA:3.40.50.720:FF:002296', NULL, NULL, 'Phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(212101, NULL, 'G3DSA:1.20.920.20:FF:000034', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212102, NULL, 'G3DSA:1.20.920.10:FF:000031', NULL, NULL, 'Bromodomain adjacent to zinc finger domain, 1B', NULL, NULL, NULL, NULL, NULL, 4),
(212103, NULL, 'G3DSA:2.130.10.30:FF:000085', NULL, NULL, 'BTB/POZ domain/Regulator of chromosome condensation (RCC1) repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(212104, NULL, 'G3DSA:3.30.40.10:FF:000145', NULL, NULL, 'RING finger protein 145', NULL, NULL, NULL, NULL, NULL, 4),
(212105, NULL, 'G3DSA:3.30.1740.10:FF:000023', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(212106, NULL, 'G3DSA:2.60.120.290:FF:000071', NULL, NULL, 'Zinc metalloproteinase', NULL, NULL, NULL, NULL, NULL, 4),
(212107, NULL, 'G3DSA:3.55.40.20:FF:000013', NULL, NULL, 'Superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(212108, NULL, 'G3DSA:3.40.50.620:FF:000579', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212109, NULL, 'G3DSA:3.30.450.60:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212110, NULL, 'G3DSA:3.30.365.10:FF:000022', NULL, NULL, 'Carbon monoxide dehydrogenase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(212111, NULL, 'G3DSA:1.20.58.1030:FF:000038', NULL, NULL, 'DNA replication complex GINS protein SLD5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(212112, NULL, 'G3DSA:1.25.40.570:FF:000016', NULL, NULL, '26S proteasome regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(212113, NULL, 'G3DSA:1.20.1560.10:FF:000715', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212114, NULL, 'G3DSA:3.60.110.10:FF:000037', NULL, NULL, 'Hydrolase, carbon-nitrogen family protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(212115, NULL, 'G3DSA:3.60.40.10:FF:000323', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212116, NULL, 'G3DSA:3.30.420.10:FF:000320', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212117, NULL, 'G3DSA:3.20.20.300:FF:000044', NULL, NULL, 'Periplasmic beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(212118, NULL, 'G3DSA:1.25.40.720:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212119, NULL, 'G3DSA:3.30.450.20:FF:000095', NULL, NULL, 'Sigma-54-dependent transcriptional regulator ygeV', NULL, NULL, NULL, NULL, NULL, 4),
(212120, NULL, 'G3DSA:3.40.50.720:FF:002026', NULL, NULL, 'Dihydroflavonol-4-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(212121, NULL, 'G3DSA:3.40.605.10:FF:000011', NULL, NULL, 'ALD5p Mitochondrial aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(212122, NULL, 'G3DSA:3.30.70.141:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212123, NULL, 'G3DSA:3.80.10.10:FF:004328', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212124, NULL, 'G3DSA:3.40.190.10:FF:000294', NULL, NULL, 'Probable sugar-binding lipoprotein lpqY', NULL, NULL, NULL, NULL, NULL, 4),
(212125, NULL, 'G3DSA:3.30.50.10:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212126, NULL, 'G3DSA:3.40.850.10:FF:000266', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(212127, NULL, 'G3DSA:1.10.287.70:FF:000421', NULL, NULL, 'Voltage-gated Ca2+ channel, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(212128, NULL, 'G3DSA:3.40.50.12230:FF:000019', NULL, NULL, 'Putative methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(212129, NULL, 'G3DSA:3.40.1170.10:FF:000011', NULL, NULL, 'Msh1p', NULL, NULL, NULL, NULL, NULL, 4),
(212130, NULL, 'G3DSA:3.40.50.410:FF:000174', NULL, NULL, 'Matrilin 1', NULL, NULL, NULL, NULL, NULL, 4),
(212131, NULL, 'G3DSA:3.30.200.20:FF:000784', NULL, NULL, 'Serine/threonine-protein kinase STE7', NULL, NULL, NULL, NULL, NULL, 4),
(212132, NULL, 'G3DSA:3.90.190.10:FF:000445', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212133, NULL, 'G3DSA:3.40.50.800:FF:000077', NULL, NULL, 'Threonine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(212134, NULL, 'G3DSA:2.60.40.10:FF:005053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212135, NULL, 'G3DSA:3.40.50.2300:FF:000655', NULL, NULL, 'CsgBAC operon transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(212136, NULL, 'G3DSA:3.40.50.300:FF:001675', NULL, NULL, 'Bifunctional dethiobiotin synthetase/7,8-diamino-pelargonic acid aminotransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(212137, NULL, 'G3DSA:3.40.50.12160:FF:000032', NULL, NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(212138, NULL, 'G3DSA:1.25.40.10:FF:001404', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(212139, NULL, 'G3DSA:3.40.50.2000:FF:000627', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(212140, NULL, 'G3DSA:3.30.1370.10:FF:000118', NULL, NULL, 'Heterogeneous nuclear rnp K-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(212141, NULL, 'G3DSA:2.60.40.2300:FF:000011', NULL, NULL, 'Neutral ceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(212142, NULL, 'G3DSA:3.40.50.12760:FF:000010', NULL, NULL, 'CMTR1 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(212143, NULL, 'G3DSA:3.30.460.10:FF:000210', NULL, NULL, 'MUTator', NULL, NULL, NULL, NULL, NULL, 4),
(212144, NULL, 'G3DSA:1.10.8.10:FF:000052', NULL, NULL, 'Huntingtin-interacting protein K (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(212145, NULL, 'G3DSA:3.40.390.10:FF:000275', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212146, NULL, 'G3DSA:2.60.40.10:FF:001461', NULL, NULL, 'tyrosine-protein phosphatase 10D isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(212147, NULL, 'G3DSA:3.40.50.12780:FF:000049', NULL, NULL, 'Putative acyl-activating enzyme 19', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(212148, NULL, 'G3DSA:3.40.630.30:FF:000204', NULL, NULL, 'N-acetyltransferase, putative, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(212149, NULL, 'G3DSA:2.60.40.10:FF:004890', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212150, NULL, 'G3DSA:1.20.1560.10:FF:000822', NULL, NULL, 'ABC transporter B family member 14', NULL, NULL, NULL, NULL, NULL, 4),
(212151, NULL, 'G3DSA:1.10.1410.10:FF:000100', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212152, NULL, 'G3DSA:2.60.120.10:FF:000513', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212153, NULL, 'G3DSA:1.20.970.10:FF:000039', NULL, NULL, 'Pyrimidine-nucleoside phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(212154, NULL, 'G3DSA:3.60.20.10:FF:000221', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212155, NULL, 'G3DSA:4.10.400.10:FF:000151', NULL, NULL, 'LDL receptor related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(212156, NULL, 'G3DSA:3.40.50.300:FF:000601', NULL, NULL, 'Mg-protoporphyrin IX chelatase', NULL, NULL, NULL, NULL, NULL, 4),
(212157, NULL, 'G3DSA:1.10.8.100:FF:000016', NULL, NULL, 'rRNA adenine N-6-methyltransferase (Erm/ksgA)', NULL, NULL, NULL, NULL, NULL, 4),
(212158, NULL, 'G3DSA:3.30.1370.210:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212159, NULL, 'G3DSA:2.40.170.20:FF:000102', NULL, NULL, 'Outer membrane receptor for Fe3+-dicitrate/TonB-dependent receptor', NULL, NULL, NULL, NULL, NULL, 4),
(212160, NULL, 'G3DSA:1.20.930.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212161, NULL, 'G3DSA:1.10.132.30:FF:000011', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(212162, NULL, 'G3DSA:1.10.510.10:FF:001233', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(212163, NULL, 'G3DSA:1.10.3810.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212164, NULL, 'G3DSA:3.10.20.90:FF:000117', NULL, NULL, 'Ubiquitin-like protein ATG12', NULL, NULL, NULL, NULL, NULL, 4),
(212165, NULL, 'G3DSA:1.10.510.10:FF:001525', NULL, NULL, 'MAPKK kinase', NULL, NULL, NULL, NULL, NULL, 4),
(212166, NULL, 'G3DSA:3.40.50.720:FF:000109', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(212167, NULL, 'G3DSA:2.70.98.30:FF:000020', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(212168, NULL, 'G3DSA:2.60.40.10:FF:002984', NULL, NULL, 'DNase I-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(212169, NULL, 'G3DSA:3.30.200.20:FF:000907', NULL, NULL, 'Probable serine/threonine-protein kinase gdt2', NULL, NULL, NULL, NULL, NULL, 4),
(212170, NULL, 'G3DSA:1.20.1070.10:FF:000397', NULL, NULL, 'GG11470', NULL, NULL, NULL, NULL, NULL, 4),
(212171, NULL, 'G3DSA:3.50.50.60:FF:000805', NULL, NULL, '2-octaprenyl-6-methoxyphenyl hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(212172, NULL, 'G3DSA:3.40.50.800:FF:000021', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(212173, NULL, 'G3DSA:1.10.420.10:FF:000057', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(212174, NULL, 'G3DSA:3.30.70.80:FF:000004', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 9', NULL, NULL, NULL, NULL, NULL, 4),
(212175, NULL, 'G3DSA:3.40.50.410:FF:000230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212176, NULL, 'G3DSA:3.30.70.1730:FF:000037', NULL, NULL, '50S ribosomal protein L10', NULL, NULL, NULL, NULL, NULL, 4),
(212177, NULL, 'G3DSA:2.60.40.10:FF:003260', NULL, NULL, 'Interleukin 13 receptor, alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(212178, NULL, 'G3DSA:1.25.40.10:FF:000948', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(212179, NULL, 'G3DSA:1.10.287.660:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212180, NULL, 'G3DSA:3.10.20.90:FF:000224', NULL, NULL, 'ras association domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(212181, NULL, 'G3DSA:3.40.630.30:FF:000148', NULL, NULL, 'Lysine N-acyltransferase MbtK', NULL, NULL, NULL, NULL, NULL, 4),
(212182, NULL, 'G3DSA:3.40.20.10:FF:000042', NULL, NULL, 'Actin depolymerizing protein', NULL, NULL, NULL, NULL, NULL, 4),
(212183, NULL, 'G3DSA:2.102.10.10:FF:000024', NULL, NULL, 'Ubiquinol-cytochrome c reductase, iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4),
(212184, NULL, 'G3DSA:2.60.40.10:FF:005058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212185, NULL, 'G3DSA:1.25.40.10:FF:003028', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(212186, NULL, 'G3DSA:2.60.120.1560:FF:000002', NULL, NULL, 'Flocculation protein FLO10', NULL, NULL, NULL, NULL, NULL, 4),
(212187, NULL, 'G3DSA:3.90.640.10:FF:000025', NULL, NULL, 'Chromatin remodeling complex subunit (Arp5)', NULL, NULL, NULL, NULL, NULL, 4),
(212188, NULL, 'G3DSA:1.10.510.10:FF:000002', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(212189, NULL, 'G3DSA:1.25.40.10:FF:001174', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g49740', NULL, NULL, NULL, NULL, NULL, 4),
(212190, NULL, 'G3DSA:1.10.10.60:FF:000585', NULL, NULL, 'Chromodomain-helicase-DNA-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(212191, NULL, 'G3DSA:2.170.300.10:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212192, NULL, 'G3DSA:3.30.70.1390:FF:000008', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212193, NULL, 'G3DSA:3.30.710.10:FF:000191', NULL, NULL, 'YIL001W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(212194, NULL, 'G3DSA:1.20.1070.10:FF:001976', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212195, NULL, 'G3DSA:2.40.30.170:FF:000017', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(212196, NULL, 'G3DSA:1.25.10.10:FF:001402', NULL, NULL, 'Arm repeat-containing protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(212197, NULL, 'G3DSA:3.80.10.10:FF:004098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212198, NULL, 'G3DSA:1.20.1270.10:FF:000103', NULL, NULL, 'Retrovirus-related Pol polyprotein LINE-1', NULL, NULL, NULL, NULL, NULL, 4),
(212199, NULL, 'G3DSA:1.25.40.20:FF:001177', NULL, NULL, 'Transient receptor potential cation channel subfamily A member 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(212200, NULL, 'G3DSA:3.90.1150.10:FF:000318', NULL, NULL, 'Pyridoxal phosphate-dependent aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(212201, NULL, 'G3DSA:3.80.10.10:FF:000624', NULL, NULL, 'Leucine rich repeats and death domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(212202, NULL, 'G3DSA:1.10.287.70:FF:000146', NULL, NULL, 'Potassium channel, putative', NULL, NULL, NULL, NULL, NULL, 4),
(212203, NULL, 'G3DSA:1.20.1560.10:FF:000148', NULL, NULL, 'ATP-binding cassette protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(212204, NULL, 'G3DSA:1.20.1270.60:FF:000039', NULL, NULL, 'FCH and double SH3 domains protein', NULL, NULL, NULL, NULL, NULL, 4),
(212205, NULL, 'G3DSA:2.30.39.10:FF:000060', NULL, NULL, 'Serpin peptidase inhibitor 31', NULL, NULL, NULL, NULL, NULL, 4),
(212206, NULL, 'G3DSA:3.40.140.20:FF:000001', NULL, NULL, 'Bifunctional purine biosynthesis protein PurH', NULL, NULL, NULL, NULL, NULL, 4),
(212207, NULL, 'G3DSA:2.130.10.10:FF:003237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212208, NULL, 'G3DSA:1.25.10.10:FF:000778', NULL, NULL, 'Armadillo/beta-catenin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(212209, NULL, 'G3DSA:3.30.420.10:FF:000376', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212210, NULL, 'G3DSA:3.40.250.10:FF:000170', NULL, NULL, 'Ubiquitin-specific protease', NULL, NULL, NULL, NULL, NULL, 4),
(212211, NULL, 'G3DSA:3.40.50.2000:FF:000953', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212212, NULL, 'G3DSA:3.80.10.10:FF:004547', NULL, NULL, 'F-box protein At1g10780', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(212213, NULL, 'G3DSA:4.10.240.10:FF:000060', NULL, NULL, 'YNR063W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(212214, NULL, 'G3DSA:3.30.230.10:FF:000171', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(212215, NULL, 'G3DSA:1.10.630.10:FF:000831', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212216, NULL, 'G3DSA:3.30.450.20:FF:000151', NULL, NULL, 'Sensor histidine kinase LuxQ', NULL, NULL, NULL, NULL, NULL, 4),
(212217, NULL, 'G3DSA:3.30.200.20:FF:000672', NULL, NULL, 'Spectrin, beta, non-erythrocytic 1', NULL, NULL, NULL, NULL, NULL, 4),
(212218, NULL, 'G3DSA:3.40.50.2300:FF:000981', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212219, NULL, 'G3DSA:1.10.1300.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212220, NULL, 'G3DSA:2.40.50.140:FF:000462', NULL, NULL, '30S ribosomal protein S17', NULL, NULL, NULL, NULL, NULL, 4),
(212221, NULL, 'G3DSA:1.25.40.20:FF:001626', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212222, NULL, 'G3DSA:1.10.510.10:FF:003649', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212223, NULL, 'G3DSA:1.25.10.10:FF:001054', NULL, NULL, 'WAPL cohesin release factor a', NULL, NULL, NULL, NULL, NULL, 4),
(212224, NULL, 'G3DSA:1.10.287.70:FF:000707', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212225, NULL, 'G3DSA:1.25.40.10:FF:001623', NULL, NULL, 'Protein CBG09345', NULL, NULL, NULL, NULL, NULL, 4),
(212226, NULL, 'G3DSA:2.60.120.330:FF:000072', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(212227, NULL, 'G3DSA:1.20.5.4980:FF:000003', NULL, NULL, 'Centromere protein X', NULL, NULL, NULL, NULL, NULL, 4),
(212228, NULL, 'G3DSA:1.20.1070.10:FF:000453', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(212229, NULL, 'G3DSA:3.20.20.190:FF:000123', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212230, NULL, 'G3DSA:3.30.1490.20:FF:000102', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(212231, NULL, 'G3DSA:1.20.58.60:FF:000278', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(212232, NULL, 'G3DSA:3.20.20.140:FF:000248', NULL, NULL, 'Dihydropyrimidinase', NULL, NULL, NULL, NULL, NULL, 4),
(212233, NULL, 'G3DSA:3.40.710.10:FF:000143', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(212234, NULL, 'G3DSA:1.20.1260.10:FF:000046', NULL, NULL, 'Ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(212235, NULL, 'G3DSA:3.30.70.100:FF:000020', NULL, NULL, 'Transporter, small conductance mechanosensitive ion channel family', NULL, NULL, NULL, NULL, NULL, 4),
(212236, NULL, 'G3DSA:1.25.40.1030:FF:000033', NULL, NULL, 'Protein transport protein Sec31A', NULL, NULL, NULL, NULL, NULL, 4),
(212237, NULL, 'G3DSA:2.30.42.10:FF:000438', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212238, NULL, 'G3DSA:2.30.30.490:FF:000087', NULL, NULL, 'Cytosine-specific methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(212239, NULL, 'G3DSA:2.30.30.790:FF:000019', NULL, NULL, 'Ribosomal protein L19', NULL, NULL, NULL, NULL, NULL, 4),
(212240, NULL, 'G3DSA:3.50.50.60:FF:000457', NULL, NULL, 'Long-chain-alcohol oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(212241, NULL, 'G3DSA:3.40.50.620:FF:000293', NULL, NULL, 'Integral membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(212242, NULL, 'G3DSA:1.25.40.1040:FF:000036', NULL, NULL, 'Cleavage stimulation factor subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(212243, NULL, 'G3DSA:1.20.120.1900:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212244, NULL, 'G3DSA:2.60.40.4060:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212245, NULL, 'G3DSA:3.30.200.20:FF:001801', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212246, NULL, 'G3DSA:2.60.120.200:FF:000168', NULL, NULL, 'Sr-CI', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(212247, NULL, 'G3DSA:1.10.600.10:FF:000099', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212248, NULL, 'G3DSA:3.30.300.30:FF:000109', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(212249, NULL, 'G3DSA:3.40.50.720:FF:000727', NULL, NULL, 'UDP-N-acetyl-D-glucosamine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(212250, NULL, 'G3DSA:3.30.420.510:FF:000014', NULL, NULL, 'Pantothenate kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(212251, NULL, 'G3DSA:3.30.2130.30:FF:000005', NULL, NULL, 'THUMP domain containing 2, isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(212252, NULL, 'G3DSA:3.30.160.60:FF:005721', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212253, NULL, 'G3DSA:1.25.40.470:FF:000031', NULL, NULL, 'Uncharacterized protein TCIL3000_10_12370', NULL, NULL, NULL, NULL, NULL, 4),
(212254, NULL, 'G3DSA:1.20.140.100:FF:000011', NULL, NULL, 'Dynein heavy chain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(212255, NULL, 'G3DSA:3.90.870.10:FF:000008', NULL, NULL, 'Threonylcarbamoyl-AMP synthase', NULL, NULL, NULL, NULL, NULL, 4),
(212256, NULL, 'G3DSA:2.40.20.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212257, NULL, 'G3DSA:3.40.50.1000:FF:000698', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212258, NULL, 'G3DSA:3.40.250.10:FF:000063', NULL, NULL, 'Unplaced genomic scaffold supercont1.113, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(212259, NULL, 'G3DSA:2.60.120.620:FF:000001', NULL, NULL, 'Prolyl 4-hydroxylase subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(212260, NULL, 'G3DSA:1.20.920.20:FF:000039', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(212261, NULL, 'G3DSA:1.20.120.350:FF:000200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212262, NULL, 'G3DSA:1.10.510.10:FF:001632', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212263, NULL, 'G3DSA:3.50.50.60:FF:000856', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(212264, NULL, 'G3DSA:3.90.190.10:FF:000440', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212265, NULL, 'G3DSA:2.60.120.200:FF:000516', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212266, NULL, 'G3DSA:2.60.40.10:FF:002765', NULL, NULL, 'filamin-C isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(212267, NULL, 'G3DSA:1.20.120.1960:FF:000004', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(212268, NULL, 'G3DSA:3.40.50.300:FF:003474', NULL, NULL, 'Uncharacterized ATP-dependent helicase C05C10.2', NULL, NULL, NULL, NULL, NULL, 4),
(212269, NULL, 'G3DSA:1.10.150.850:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212270, NULL, 'G3DSA:3.40.1810.10:FF:000021', NULL, NULL, 'AGAMOUS-like 21', NULL, NULL, NULL, NULL, NULL, 4),
(212271, NULL, 'G3DSA:3.30.420.10:FF:000325', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212272, NULL, 'G3DSA:1.20.1560.10:FF:000204', NULL, NULL, 'Drugs-transport transmembrane ATP-binding protein ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(212273, NULL, 'G3DSA:3.20.20.100:FF:000079', NULL, NULL, 'glutamate--cysteine ligase regulatory subunit-like', NULL, NULL, NULL, NULL, NULL, 4),
(212274, NULL, 'G3DSA:1.10.287.1390:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212275, NULL, 'G3DSA:1.20.1560.10:FF:000423', NULL, NULL, 'ATP-binding cassette transporter, subfamily B, member 6, group TAP protein PpABCB6', NULL, NULL, NULL, NULL, NULL, 4),
(212276, NULL, 'G3DSA:3.60.21.10:FF:000133', NULL, NULL, 'Protein CBR-PPH-1', NULL, NULL, NULL, NULL, NULL, 4),
(212277, NULL, 'G3DSA:3.40.1110.10:FF:000007', NULL, NULL, 'Potassium-transporting ATPase ATP-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(212278, NULL, 'G3DSA:1.20.920.10:FF:000036', NULL, NULL, 'Tripartite motif-containing protein 66', NULL, NULL, NULL, NULL, NULL, 4),
(212279, NULL, 'G3DSA:2.10.25.10:FF:000517', NULL, NULL, 'Crumbs 1, cell polarity complex component', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(212280, NULL, 'G3DSA:3.30.70.270:FF:000295', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212281, NULL, 'G3DSA:3.10.590.10:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212282, NULL, 'G3DSA:1.10.287.810:FF:000014', NULL, NULL, 'Tim10/DDP family zinc finger, putative', NULL, NULL, NULL, NULL, NULL, 4),
(212283, NULL, 'G3DSA:1.20.1250.20:FF:000167', NULL, NULL, 'Transporter, major facilitator family', NULL, NULL, NULL, NULL, NULL, 4),
(212284, NULL, 'G3DSA:3.30.460.10:FF:000154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212285, NULL, 'G3DSA:2.130.10.30:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212286, NULL, 'G3DSA:1.20.1070.10:FF:001757', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212287, NULL, 'G3DSA:3.30.200.20:FF:001240', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(212288, NULL, 'G3DSA:2.30.42.10:FF:000590', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212289, NULL, 'G3DSA:3.40.50.300:FF:003687', NULL, NULL, 'Disease resistance protein Pik-1', NULL, NULL, NULL, NULL, NULL, 4),
(212290, NULL, 'G3DSA:3.40.50.10190:FF:000205', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(212291, NULL, 'G3DSA:4.10.280.10:FF:000213', NULL, NULL, 'MAX-like-1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(212292, NULL, 'G3DSA:3.80.10.10:FF:000444', NULL, NULL, 'Leucine rich repeat containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(212293, NULL, 'G3DSA:3.40.1410.10:FF:000047', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(212294, NULL, 'G3DSA:3.30.40.10:FF:000089', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(212295, NULL, 'G3DSA:1.10.238.10:FF:000695', NULL, NULL, 'Calmodulin-like 4b', NULL, NULL, NULL, NULL, NULL, 4),
(212296, NULL, 'G3DSA:3.90.950.10:FF:000009', NULL, NULL, 'Inosine triphosphate pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(212297, NULL, 'G3DSA:2.40.30.110:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212298, NULL, 'G3DSA:3.30.40.10:FF:001994', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212299, NULL, 'G3DSA:1.25.40.120:FF:000061', NULL, NULL, 'Protein prenyltransferase alpha subunit repeat containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(212300, NULL, 'G3DSA:3.30.70.330:FF:001139', NULL, NULL, 'EG:BACR42I17.12 protein', NULL, NULL, NULL, NULL, NULL, 4),
(212301, NULL, 'G3DSA:1.10.10.10:FF:001727', NULL, NULL, 'Response regulator receiver', NULL, NULL, NULL, NULL, NULL, 4),
(212302, NULL, 'G3DSA:3.60.20.40:FF:000033', NULL, NULL, 'Gamma-glutamyltransferase 5', NULL, NULL, NULL, NULL, NULL, 4),
(212303, NULL, 'G3DSA:3.40.50.300:FF:000040', NULL, NULL, 'GTPase Der', NULL, NULL, NULL, NULL, NULL, 4),
(212304, NULL, 'G3DSA:3.30.710.10:FF:000483', NULL, NULL, 'Mynn protein', NULL, NULL, NULL, NULL, NULL, 4),
(212305, NULL, 'G3DSA:3.30.160.20:FF:000050', NULL, NULL, 'Peptidyl-tRNA hydrolase ICT1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(212306, NULL, 'G3DSA:3.50.50.60:FF:000238', NULL, NULL, 'Putative flavin dependent monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(212307, NULL, 'G3DSA:3.90.550.20:FF:000021', NULL, NULL, 'Toxin Afp18', NULL, NULL, NULL, NULL, NULL, 4),
(212308, NULL, 'G3DSA:1.10.510.10:FF:001851', NULL, NULL, 'Kinase, STE STE20', NULL, NULL, NULL, NULL, NULL, 4),
(212309, NULL, 'G3DSA:3.80.10.10:FF:004154', NULL, NULL, 'NLR family, pyrin domain containing 4G', NULL, NULL, NULL, NULL, NULL, 4),
(212310, NULL, 'G3DSA:1.20.140.10:FF:000027', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(212311, NULL, 'G3DSA:3.90.70.10:FF:000695', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212312, NULL, 'G3DSA:1.20.1730.10:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212313, NULL, 'G3DSA:1.20.1270.10:FF:000047', NULL, NULL, 'Heat Shock Protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(212314, NULL, 'G3DSA:3.40.50.2300:FF:000829', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(212315, NULL, 'G3DSA:1.25.40.10:FF:005153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212316, NULL, 'G3DSA:3.30.70.270:FF:000076', NULL, NULL, 'Diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(212317, NULL, 'G3DSA:1.20.120.1950:FF:000001', NULL, NULL, 'Cerebral cavernous malformation 3', NULL, NULL, NULL, NULL, NULL, 4),
(212318, NULL, 'G3DSA:3.30.200.20:FF:000958', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(212319, NULL, 'G3DSA:1.20.1250.20:FF:000442', NULL, NULL, 'Hexose transporter', NULL, NULL, NULL, NULL, NULL, 4),
(212320, NULL, 'G3DSA:3.40.710.10:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212321, NULL, 'G3DSA:2.40.50.140:FF:000748', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212322, NULL, 'G3DSA:3.40.225.10:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212323, NULL, 'G3DSA:1.10.8.60:FF:000550', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(212324, NULL, 'G3DSA:1.25.40.20:FF:001233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212325, NULL, 'G3DSA:3.40.50.1100:FF:000222', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212326, NULL, 'G3DSA:3.30.70.260:FF:000073', NULL, NULL, 'Ribose-5-phosphate isomerase A', NULL, NULL, NULL, NULL, NULL, 4),
(212327, NULL, 'G3DSA:3.40.50.1820:FF:000382', NULL, NULL, 'Proline iminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(212328, NULL, 'G3DSA:3.90.45.10:FF:000007', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(212329, NULL, 'G3DSA:1.10.150.50:FF:000014', NULL, NULL, 'Protein c-ets-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(212330, NULL, 'G3DSA:1.25.40.10:FF:001230', NULL, NULL, 'Os01g0880900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(212331, NULL, 'G3DSA:1.25.40.10:FF:004877', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212332, NULL, 'G3DSA:2.40.50.140:FF:001237', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212333, NULL, 'G3DSA:2.20.100.10:FF:000212', NULL, NULL, 'Thrombospondin type-1 domain-containing protein 7B', NULL, NULL, NULL, NULL, NULL, 4),
(212334, NULL, 'G3DSA:3.40.50.300:FF:003069', NULL, NULL, 'Small GTPase EhRabX19, putative', NULL, NULL, NULL, NULL, NULL, 4),
(212335, NULL, 'G3DSA:3.10.20.620:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212336, NULL, 'G3DSA:3.30.70.330:FF:002825', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212337, NULL, 'G3DSA:2.60.220.50:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212338, NULL, 'G3DSA:3.30.70.1620:FF:000004', NULL, NULL, 'Structural maintenance of chromosomes flexible hinge domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(212339, NULL, 'G3DSA:2.10.50.10:FF:000031', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 1B', NULL, NULL, NULL, NULL, NULL, 4),
(212340, NULL, 'G3DSA:1.10.510.10:FF:001289', NULL, NULL, 'Serine/threonine-protein kinase dkf-1', NULL, NULL, NULL, NULL, NULL, 4),
(212341, NULL, 'G3DSA:1.20.1270.60:FF:000314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212342, NULL, 'G3DSA:3.30.70.330:FF:002775', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212343, NULL, 'G3DSA:3.40.50.12710:FF:000017', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7 homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(212344, NULL, 'G3DSA:2.60.40.1090:FF:000030', NULL, NULL, 'Hypothetical fimbrial subunit', NULL, NULL, NULL, NULL, NULL, 4),
(212345, NULL, 'G3DSA:2.30.30.100:FF:000072', NULL, NULL, 'RNA-binding protein Hfq', NULL, NULL, NULL, NULL, NULL, 4),
(212346, NULL, 'G3DSA:1.10.10.10:FF:001492', NULL, NULL, 'Transcriptional regulator, IclR family', NULL, NULL, NULL, NULL, NULL, 4),
(212347, NULL, 'G3DSA:3.30.497.10:FF:000188', NULL, NULL, 'Serpin, putative', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(212348, NULL, 'G3DSA:3.40.50.2300:FF:000094', NULL, NULL, 'PTS system fructose-like IIB component 2', NULL, NULL, NULL, NULL, NULL, 4),
(212349, NULL, 'G3DSA:3.40.50.410:FF:000286', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(212350, NULL, 'G3DSA:2.60.40.10:FF:005620', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212351, NULL, 'G3DSA:3.30.70.940:FF:000030', NULL, NULL, 'Transcription antitermination protein RfaH', NULL, NULL, NULL, NULL, NULL, 4),
(212352, NULL, 'G3DSA:6.10.140.2220:FF:000022', NULL, NULL, 'Leucine-rich repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(212353, NULL, 'G3DSA:1.10.510.10:FF:001345', NULL, NULL, 'HET-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(212354, NULL, 'G3DSA:3.40.225.10:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212355, NULL, 'G3DSA:2.40.50.120:FF:000012', NULL, NULL, 'Metalloproteinase inhibitor 4', NULL, NULL, NULL, NULL, NULL, 4),
(212356, NULL, 'G3DSA:3.40.50.300:FF:003417', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(212357, NULL, 'G3DSA:2.80.10.50:FF:000211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212358, NULL, 'G3DSA:2.60.40.10:FF:004041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212359, NULL, 'G3DSA:2.10.70.10:FF:000032', NULL, NULL, 'sushi repeat-containing protein SRPX isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(212360, NULL, 'G3DSA:2.60.40.10:FF:005564', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212361, NULL, 'G3DSA:1.20.58.60:FF:000508', NULL, NULL, 'Muscle-specific protein', NULL, NULL, NULL, NULL, NULL, 4),
(212362, NULL, 'G3DSA:3.40.50.720:FF:001857', NULL, NULL, 'Alcohol dehydrogenase class 4 mu/sigma chain', NULL, NULL, NULL, NULL, NULL, 4),
(212363, NULL, 'G3DSA:3.40.50.1820:FF:000612', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212364, NULL, 'G3DSA:3.30.1330.20:FF:000040', NULL, NULL, 'Cell division protein FtsZ', NULL, NULL, NULL, NULL, NULL, 4),
(212365, NULL, 'G3DSA:1.10.510.10:FF:002868', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212366, NULL, 'G3DSA:3.80.10.10:FF:001967', NULL, NULL, 'F-box/LRR-repeat protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(212367, NULL, 'G3DSA:2.130.10.10:FF:001944', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212368, NULL, 'G3DSA:2.60.120.180:FF:000004', NULL, NULL, 'Endoglucanase A eglA', NULL, NULL, NULL, NULL, NULL, 4),
(212369, NULL, 'G3DSA:1.25.50.20:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212370, NULL, 'G3DSA:3.40.718.10:FF:000043', NULL, NULL, '3-isopropylmalate dehydrogenase (LeuB)', NULL, NULL, NULL, NULL, NULL, 4),
(212371, NULL, 'G3DSA:3.30.1330.30:FF:000043', NULL, NULL, '23S rRNA methyltransferase TsnR', NULL, NULL, NULL, NULL, NULL, 4),
(212372, NULL, 'G3DSA:3.40.50.410:FF:000342', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212373, NULL, 'G3DSA:2.130.10.10:FF:005216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212374, NULL, 'G3DSA:4.10.1060.10:FF:000025', NULL, NULL, 'Zinc finger, RanBP2-type', NULL, NULL, NULL, NULL, NULL, 4),
(212375, NULL, 'G3DSA:1.20.5.110:FF:000152', NULL, NULL, 'EhSyntaxin C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(212376, NULL, 'G3DSA:3.80.10.10:FF:002529', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212377, NULL, 'G3DSA:3.40.50.1700:FF:000014', NULL, NULL, 'Glycoside hydrolase family 3', NULL, NULL, NULL, NULL, NULL, 4),
(212378, NULL, 'G3DSA:1.25.10.10:FF:002689', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212379, NULL, 'G3DSA:2.30.30.790:FF:000020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212380, NULL, 'G3DSA:3.30.40.10:FF:002270', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212381, NULL, 'G3DSA:1.20.1560.10:FF:000592', NULL, NULL, 'MRP-like ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(212382, NULL, 'G3DSA:2.10.90.10:FF:000027', NULL, NULL, 'Glycoprotein hormone alpha 2', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(212383, NULL, 'G3DSA:1.20.1270.60:FF:000258', NULL, NULL, 'ArfGAP with SH3 domain, ankyrin repeat and PH domain 3', NULL, NULL, NULL, NULL, NULL, 4),
(212384, NULL, 'G3DSA:2.60.40.10:FF:003434', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212385, NULL, 'G3DSA:3.80.10.10:FF:000388', NULL, NULL, 'Blast:Lutropin-choriogonadotropic hormone receptor', NULL, NULL, NULL, NULL, NULL, 4),
(212386, NULL, 'G3DSA:3.30.70.660:FF:000047', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(212387, NULL, 'G3DSA:3.30.1330.40:FF:000046', NULL, NULL, 'ATP binding L-PSP endoribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(212388, NULL, 'G3DSA:3.40.50.920:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212389, NULL, 'G3DSA:2.60.220.50:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212390, NULL, 'G3DSA:2.30.40.10:FF:000035', NULL, NULL, 'Imidazolonepropionase', NULL, NULL, NULL, NULL, NULL, 4),
(212391, NULL, 'G3DSA:3.30.1360.140:FF:000011', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(212392, NULL, 'G3DSA:1.10.8.590:FF:000005', NULL, NULL, 'Uncharacterized tRNA/rRNA methyltransferase HI_0380', NULL, NULL, NULL, NULL, NULL, 4),
(212393, NULL, 'G3DSA:1.25.10.10:FF:003420', NULL, NULL, 'U3 small nucleolar RNA-associated protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(212394, NULL, 'G3DSA:1.10.2000.10:FF:000013', NULL, NULL, 'atrial natriuretic peptide-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(212395, NULL, 'G3DSA:3.40.50.300:FF:004997', NULL, NULL, 'RAB5A, member RAS oncogene family, b', NULL, NULL, NULL, NULL, NULL, 4),
(212396, NULL, 'G3DSA:1.20.1070.10:FF:000740', NULL, NULL, 'muscarinic acetylcholine receptor M3-like', NULL, NULL, NULL, NULL, NULL, 4),
(212397, NULL, 'G3DSA:1.10.150.240:FF:000097', NULL, NULL, 'Haloacid dehalogenase-like hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(212398, NULL, 'G3DSA:3.80.10.10:FF:000438', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase At4g26540 family', NULL, NULL, NULL, NULL, NULL, 4),
(212399, NULL, 'G3DSA:3.40.1110.10:FF:000451', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212400, NULL, 'G3DSA:2.30.30.40:FF:000588', NULL, NULL, 'CIN85 and CD2AP related, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(212401, NULL, 'G3DSA:1.50.10.160:FF:000017', NULL, NULL, 'Ent-copalyl diphosphate synthase chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(212402, NULL, 'G3DSA:3.90.105.20:FF:000015', NULL, NULL, 'Ribosome assembly factor mrt4', NULL, NULL, NULL, NULL, NULL, 4),
(212403, NULL, 'G3DSA:1.50.10.150:FF:000014', NULL, NULL, 'C4-dicarboxylate transporter/malic acid transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(212404, NULL, 'G3DSA:1.25.40.10:FF:005333', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g23020', NULL, NULL, NULL, NULL, NULL, 4),
(212405, NULL, 'G3DSA:3.10.20.90:FF:000966', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212406, NULL, 'G3DSA:3.30.70.330:FF:000684', NULL, NULL, 'Putative glycine-rich RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(212407, NULL, 'G3DSA:3.40.720.10:FF:000256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212408, NULL, 'G3DSA:3.40.50.150:FF:001259', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212409, NULL, 'G3DSA:2.60.40.60:FF:000205', NULL, NULL, 'Proto-oncogene tyrosine-protein kinase receptor Ret', NULL, NULL, NULL, NULL, NULL, 4),
(212410, NULL, 'G3DSA:3.80.10.10:FF:000770', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212411, NULL, 'G3DSA:2.60.120.200:FF:000499', NULL, NULL, 'slit homolog 2 protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(212412, NULL, 'G3DSA:3.80.10.10:FF:004042', NULL, NULL, 'Leucine-rich repeat family protein /protein kinase family protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(212413, NULL, 'G3DSA:3.30.40.10:FF:000976', NULL, NULL, 'Transcriptional repressor NOT4Hp, putative', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(212414, NULL, 'G3DSA:3.40.50.1100:FF:000110', NULL, NULL, 'Cysteine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(212415, NULL, 'G3DSA:1.20.1250.20:FF:000728', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212416, NULL, 'G3DSA:2.40.50.90:FF:000199', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(212417, NULL, 'G3DSA:3.30.420.10:FF:000269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212418, NULL, 'G3DSA:2.60.120.170:FF:000001', NULL, NULL, 'Intermediate capsid protein VP6', NULL, NULL, NULL, NULL, NULL, 4),
(212419, NULL, 'G3DSA:3.40.50.300:FF:001563', NULL, NULL, 'Probable conserved membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(212420, NULL, 'G3DSA:3.90.550.50:FF:000249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212421, NULL, 'G3DSA:3.40.50.300:FF:003693', NULL, NULL, 'Dicer-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(212422, NULL, 'G3DSA:3.40.50.2300:FF:000835', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212423, NULL, 'G3DSA:1.20.970.10:FF:000040', NULL, NULL, 'Thymidine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(212424, NULL, 'G3DSA:6.10.140.2220:FF:000061', NULL, NULL, 'MYND finger, putative', NULL, NULL, NULL, NULL, NULL, 4),
(212425, NULL, 'G3DSA:1.20.1560.10:FF:000479', NULL, NULL, 'ABC transporter, ATP-binding/permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(212426, NULL, 'G3DSA:3.40.190.10:FF:000001', NULL, NULL, 'Glutamate receptor ionotropic, kainate 2', NULL, NULL, NULL, NULL, NULL, 4),
(212427, NULL, 'G3DSA:3.80.10.10:FF:002861', NULL, NULL, 'Toll, putative', NULL, NULL, NULL, NULL, NULL, 4),
(212428, NULL, 'G3DSA:2.10.25.10:FF:001647', NULL, NULL, 'Adhesion G protein-coupled receptor L4', NULL, NULL, NULL, NULL, NULL, 4),
(212429, NULL, 'G3DSA:3.30.160.60:FF:003703', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212430, NULL, 'G3DSA:3.30.70.330:FF:002718', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212431, NULL, 'G3DSA:1.20.1070.10:FF:000627', NULL, NULL, 'Family A G protein-coupled receptor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(212432, NULL, 'G3DSA:3.30.2290.10:FF:000011', NULL, NULL, 'Peptidase U62, modulator of DNA gyrase', NULL, NULL, NULL, NULL, NULL, 4),
(212433, NULL, 'G3DSA:3.90.226.10:FF:000338', NULL, NULL, 'Carboxyl-terminal-processing peptidase 3 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(212434, NULL, 'G3DSA:3.40.50.300:FF:007015', NULL, NULL, 'Chromosome 15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(212435, NULL, 'G3DSA:1.20.90.10:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212436, NULL, 'G3DSA:3.40.50.80:FF:000194', NULL, NULL, 'YALI0F01386p', NULL, NULL, NULL, NULL, NULL, 4),
(212437, NULL, 'G3DSA:1.20.58.1070:FF:000022', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212438, NULL, 'G3DSA:3.40.50.1110:FF:000113', NULL, NULL, 'Isoamyl acetate-hydrolyzing esterase', NULL, NULL, NULL, NULL, NULL, 4),
(212439, NULL, 'G3DSA:3.40.50.300:FF:003743', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212440, NULL, 'G3DSA:1.20.58.1120:FF:000060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212441, NULL, 'G3DSA:3.80.10.10:FF:001113', NULL, NULL, 'Protein phosphatase 2C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(212442, NULL, 'G3DSA:1.25.40.10:FF:000387', NULL, NULL, 'Golgi to ER traffic protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(212443, NULL, 'G3DSA:1.25.40.10:FF:001005', NULL, NULL, 'Magnetosome protein MamA', NULL, NULL, NULL, NULL, NULL, 4),
(212444, NULL, 'G3DSA:1.10.510.10:FF:003762', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212445, NULL, 'G3DSA:2.60.200.40:FF:000006', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(212446, NULL, 'G3DSA:2.60.40.10:FF:003147', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212447, NULL, 'G3DSA:3.30.920.10:FF:000015', NULL, NULL, 'Frataxin, putative', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(212448, NULL, 'G3DSA:4.10.1240.10:FF:000011', NULL, NULL, 'Calcitonin gene-related peptide type 1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(212449, NULL, 'G3DSA:3.50.50.60:FF:000862', NULL, NULL, 'Gll1135 protein', NULL, NULL, NULL, NULL, NULL, 4),
(212450, NULL, 'G3DSA:3.40.50.720:FF:000553', NULL, NULL, 'SUMO-activating enzyme subunit', NULL, NULL, NULL, NULL, NULL, 4),
(212451, NULL, 'G3DSA:1.25.40.770:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212452, NULL, 'G3DSA:1.10.630.10:FF:000163', NULL, NULL, 'Geraniol 8-hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(212453, NULL, 'G3DSA:1.10.470.10:FF:000009', NULL, NULL, 'Variant surface glycoprotein (VSG, atypical), putative', NULL, NULL, NULL, NULL, NULL, 4),
(212454, NULL, 'G3DSA:3.65.10.20:FF:000027', NULL, NULL, 'RNA 3'' terminal cyclase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(212455, NULL, 'G3DSA:1.20.58.60:FF:000840', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212456, NULL, 'G3DSA:3.40.190.10:FF:000855', NULL, NULL, 'NMDA class glutamate Receptor', NULL, NULL, NULL, NULL, NULL, 4),
(212457, NULL, 'G3DSA:1.20.1250.20:FF:002241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212458, NULL, 'G3DSA:3.30.559.10:FF:000181', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212459, NULL, 'G3DSA:2.130.10.10:FF:003294', NULL, NULL, 'AGAP004176-PA', NULL, NULL, NULL, NULL, NULL, 4),
(212460, NULL, 'G3DSA:2.130.10.10:FF:004873', NULL, NULL, 'Chromosome 15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(212461, NULL, 'G3DSA:2.10.25.10:FF:000287', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(212462, NULL, 'G3DSA:2.60.40.1400:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212463, NULL, 'G3DSA:2.10.25.10:FF:000343', NULL, NULL, 'latent-transforming growth factor beta-binding protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(212464, NULL, 'G3DSA:1.20.1250.40:FF:000032', NULL, NULL, 'DNA-directed RNA polymerase II subunit', NULL, NULL, NULL, NULL, NULL, 4),
(212465, NULL, 'G3DSA:3.50.50.60:FF:000682', NULL, NULL, '2-polyprenyl-6-methoxyphenol hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(212466, NULL, 'G3DSA:2.60.40.10:FF:004889', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212467, NULL, 'G3DSA:1.20.120.1080:FF:000049', NULL, NULL, 'ATP-dependent RNA helicase A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(212468, NULL, 'G3DSA:3.30.160.60:FF:003647', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212469, NULL, 'G3DSA:4.10.1240.30:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212470, NULL, 'G3DSA:1.20.920.10:FF:000087', NULL, NULL, 'ATPase family AAA domain-containing protein 2B', NULL, NULL, NULL, NULL, NULL, 4),
(212471, NULL, 'G3DSA:3.40.220.10:FF:000016', NULL, NULL, 'Putative helicase CHR10', NULL, NULL, NULL, NULL, NULL, 4),
(212472, NULL, 'G3DSA:3.60.20.10:FF:000108', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(212473, NULL, 'G3DSA:1.20.1730.10:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212474, NULL, 'G3DSA:2.60.120.200:FF:000555', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212475, NULL, 'G3DSA:3.40.50.1240:FF:000011', NULL, NULL, '2-phosphoxylose phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(212476, NULL, 'G3DSA:1.25.40.620:FF:000003', NULL, NULL, 'Tetrapyrrole-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(212477, NULL, 'G3DSA:1.20.990.10:FF:000035', NULL, NULL, 'Methionine synthase reductase, mitochondrial-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(212478, NULL, 'G3DSA:3.40.50.10190:FF:000132', NULL, NULL, 'DNA repair protein REV1', NULL, NULL, NULL, NULL, NULL, 4),
(212479, NULL, 'G3DSA:3.30.450.20:FF:000443', NULL, NULL, 'Erg potassium channel', NULL, NULL, NULL, NULL, NULL, 4),
(212480, NULL, 'G3DSA:2.60.200.30:FF:000003', NULL, NULL, 'NAD kinase b', NULL, NULL, NULL, NULL, NULL, 4),
(212481, NULL, 'G3DSA:2.170.130.10:FF:000038', NULL, NULL, 'TonB-dependent heme receptor HasR', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(212482, NULL, 'G3DSA:1.10.2020.20:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212483, NULL, 'G3DSA:1.10.238.10:FF:000987', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212484, NULL, 'G3DSA:3.40.50.1360:FF:000047', NULL, NULL, '6-phosphogluconolactonase', NULL, NULL, NULL, NULL, NULL, 4),
(212485, NULL, 'G3DSA:3.30.160.60:FF:000213', NULL, NULL, 'Zinc finger protein 624', NULL, NULL, NULL, NULL, NULL, 4),
(212486, NULL, 'G3DSA:2.20.100.10:FF:000156', NULL, NULL, 'GD10853', NULL, NULL, NULL, NULL, NULL, 4),
(212487, NULL, 'G3DSA:3.30.1060.10:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212488, NULL, 'G3DSA:3.10.450.40:FF:000026', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(212489, NULL, 'G3DSA:4.10.240.10:FF:000054', NULL, NULL, 'C6 transcription factor GliZ-like, putative', NULL, NULL, NULL, NULL, NULL, 4),
(212490, NULL, 'G3DSA:3.40.50.10480:FF:000005', NULL, NULL, 'Similar to RNA processing factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(212491, NULL, 'G3DSA:3.40.630.30:FF:000255', NULL, NULL, 'N-acetyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(212492, NULL, 'G3DSA:3.30.70.330:FF:001988', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212493, NULL, 'G3DSA:3.60.10.10:FF:000046', NULL, NULL, 'DNA-(apurinic or apyrimidinic site) lyase', NULL, NULL, NULL, NULL, NULL, 4),
(212494, NULL, 'G3DSA:3.30.70.330:FF:000920', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(212495, NULL, 'G3DSA:3.80.10.10:FF:000618', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3', NULL, NULL, NULL, NULL, NULL, 4),
(212496, NULL, 'G3DSA:3.40.50.150:FF:000011', NULL, NULL, 'DNA methyltransferase 3 alpha', NULL, NULL, NULL, NULL, NULL, 4),
(212497, NULL, 'G3DSA:2.60.60.20:FF:000004', NULL, NULL, 'Lipoxygenase homology domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(212498, NULL, 'G3DSA:3.30.750.44:FF:000004', NULL, NULL, 'Tail-specific protease', NULL, NULL, NULL, NULL, NULL, 4),
(212499, NULL, 'G3DSA:2.30.40.10:FF:000074', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(212500, NULL, 'G3DSA:1.10.10.10:FF:001435', NULL, NULL, 'Transcriptional regulatory protein CusR', NULL, NULL, NULL, NULL, NULL, 4),
(212501, NULL, 'G3DSA:3.40.50.170:FF:000017', NULL, NULL, 'dTDP-4-amino-4,6-dideoxyglucose formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(212502, NULL, 'G3DSA:1.10.730.10:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212503, NULL, 'G3DSA:2.130.10.10:FF:003125', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(212504, NULL, 'G3DSA:3.40.1190.20:FF:000116', NULL, NULL, 'ADP-dependent (S)-NAD(P)H-hydrate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(212505, NULL, 'G3DSA:3.30.1370.160:FF:000002', NULL, NULL, 'Sll1252 protein', NULL, NULL, NULL, NULL, NULL, 4),
(212506, NULL, 'G3DSA:3.30.160.60:FF:003922', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212507, NULL, 'G3DSA:3.40.50.12780:FF:000162', NULL, NULL, 'HC-toxin synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(212508, NULL, 'G3DSA:3.40.50.1820:FF:000556', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212509, NULL, 'G3DSA:1.20.5.2440:FF:000011', NULL, NULL, 'LOC100135220 protein', NULL, NULL, NULL, NULL, NULL, 4),
(212510, NULL, 'G3DSA:3.80.10.10:FF:001748', NULL, NULL, 'AGAP000471-PA', NULL, NULL, NULL, NULL, NULL, 4),
(212511, NULL, 'G3DSA:3.40.50.850:FF:000013', NULL, NULL, 'Pyrazinamidase and NiCotinamidase', NULL, NULL, NULL, NULL, NULL, 4),
(212512, NULL, 'G3DSA:3.40.50.1000:FF:000479', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212513, NULL, 'G3DSA:3.40.570.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212514, NULL, 'G3DSA:3.30.230.10:FF:000165', NULL, NULL, 'DNA gyrase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(212515, NULL, 'G3DSA:1.20.58.60:FF:000565', NULL, NULL, 'Plectin', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(212516, NULL, 'G3DSA:3.50.50.60:FF:001300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212517, NULL, 'G3DSA:1.10.150.50:FF:000121', NULL, NULL, 'stromal interaction molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(212518, NULL, 'G3DSA:2.130.10.10:FF:003182', NULL, NULL, 'Pre-mRNA-splicing factor RSE1', NULL, NULL, NULL, NULL, NULL, 4),
(212519, NULL, 'G3DSA:1.25.40.20:FF:001738', NULL, NULL, 'Protein CBG15247', NULL, NULL, NULL, NULL, NULL, 4),
(212520, NULL, 'G3DSA:2.40.10.10:FF:000111', NULL, NULL, 'Blast:Serine protease nudel', NULL, NULL, NULL, NULL, NULL, 4),
(212521, NULL, 'G3DSA:1.20.1070.10:FF:000447', NULL, NULL, 'NeuroPeptide Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(212522, NULL, 'G3DSA:1.20.120.610:FF:000020', NULL, NULL, 'V-type proton ATPase subunit c4', NULL, NULL, NULL, NULL, NULL, 4),
(212523, NULL, 'G3DSA:1.20.58.390:FF:000302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212524, NULL, 'G3DSA:3.40.50.1260:FF:000017', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(212525, NULL, 'G3DSA:3.60.130.10:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212526, NULL, 'G3DSA:1.10.10.250:FF:000020', NULL, NULL, '50S ribosomal protein L11-like', NULL, NULL, NULL, NULL, NULL, 4),
(212527, NULL, 'G3DSA:2.10.25.10:FF:000068', NULL, NULL, 'Latent transforming growth factor beta binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(212528, NULL, 'G3DSA:3.40.50.720:FF:002239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212529, NULL, 'G3DSA:1.25.40.10:FF:005046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212530, NULL, 'G3DSA:1.20.1250.20:FF:000616', NULL, NULL, 'Transporter major facilitator superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(212531, NULL, 'G3DSA:1.25.40.10:FF:001735', NULL, NULL, 'Os04g0218100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(212532, NULL, 'G3DSA:3.30.160.60:FF:003086', NULL, NULL, 'Zinc finger protein 772', NULL, NULL, NULL, NULL, NULL, 4),
(212533, NULL, 'G3DSA:1.10.390.10:FF:000008', NULL, NULL, 'Thyrotropin-releasing hormone-degrading ectoenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(212534, NULL, 'G3DSA:3.40.50.10490:FF:000008', NULL, NULL, '30S ribosomal protein S2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(212535, NULL, 'G3DSA:1.10.10.10:FF:000598', NULL, NULL, 'forkhead box protein I1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(212536, NULL, 'G3DSA:3.40.50.10490:FF:000065', NULL, NULL, 'Transcriptional regulator, RpiR family', NULL, NULL, NULL, NULL, NULL, 4),
(212537, NULL, 'G3DSA:2.30.30.140:FF:000235', NULL, NULL, 'E3 ubiquitin-protein ligase UHRF2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(212538, NULL, 'G3DSA:3.30.200.20:FF:001127', NULL, NULL, 'AGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(212539, NULL, 'G3DSA:1.10.555.10:FF:000201', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212540, NULL, 'G3DSA:3.90.190.10:FF:000097', NULL, NULL, 'Tyrosine-protein phosphatase 99A', NULL, NULL, NULL, NULL, NULL, 4),
(212541, NULL, 'G3DSA:1.10.8.370:FF:000001', NULL, NULL, 'Orf1a polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(212542, NULL, 'G3DSA:1.25.10.10:FF:003201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212543, NULL, 'G3DSA:3.10.580.10:FF:000021', NULL, NULL, 'DUF21 domain-containing protein At4g14240-like', NULL, NULL, NULL, NULL, NULL, 4),
(212544, NULL, 'G3DSA:1.10.10.980:FF:000002', NULL, NULL, 'CST complex subunit STN1', NULL, NULL, NULL, NULL, NULL, 4),
(212545, NULL, 'G3DSA:2.60.40.10:FF:005800', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212546, NULL, 'G3DSA:1.20.1740.10:FF:000246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212547, NULL, 'G3DSA:3.90.80.10:FF:000015', NULL, NULL, 'Sulfate adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(212548, NULL, 'G3DSA:2.10.25.10:FF:000630', NULL, NULL, 'Fibulin 2', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(212549, NULL, 'G3DSA:1.25.10.10:FF:002925', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(212550, NULL, 'G3DSA:3.30.160.20:FF:000229', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212551, NULL, 'G3DSA:3.30.470.20:FF:000039', NULL, NULL, 'Pyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(212552, NULL, 'G3DSA:1.25.10.10:FF:002869', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212553, NULL, 'G3DSA:2.30.29.30:FF:000514', NULL, NULL, 'FACT complex subunit POB3', NULL, NULL, NULL, NULL, NULL, 4),
(212554, NULL, 'G3DSA:3.50.50.60:FF:001025', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(212555, NULL, 'G3DSA:3.30.70.330:FF:002595', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212556, NULL, 'G3DSA:3.40.30.10:FF:000503', NULL, NULL, 'Protein CBG12683', NULL, NULL, NULL, NULL, NULL, 4),
(212557, NULL, 'G3DSA:3.30.1010.10:FF:000069', NULL, NULL, 'Phosphoinositide-3-kinase, class 3', NULL, NULL, NULL, NULL, NULL, 4),
(212558, NULL, 'G3DSA:1.25.10.10:FF:003145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212559, NULL, 'G3DSA:3.90.190.10:FF:000439', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212560, NULL, 'G3DSA:1.20.1280.290:FF:000106', NULL, NULL, 'SD10385p', NULL, NULL, NULL, NULL, NULL, 4),
(212561, NULL, 'G3DSA:1.10.533.10:FF:000021', NULL, NULL, 'caspase-8 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(212562, NULL, 'G3DSA:3.40.50.790:FF:000023', NULL, NULL, 'Ribosomal protein L10a', NULL, NULL, NULL, NULL, NULL, 4),
(212563, NULL, 'G3DSA:3.30.470.10:FF:000036', NULL, NULL, '4-amino-4-deoxychorismate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(212564, NULL, 'G3DSA:3.40.30.10:FF:000161', NULL, NULL, 'Thioredoxin reductase 3', NULL, NULL, NULL, NULL, NULL, 4),
(212565, NULL, 'G3DSA:3.40.50.1460:FF:000021', NULL, NULL, 'GPI-anchor transamidase', NULL, NULL, NULL, NULL, NULL, 4),
(212566, NULL, 'G3DSA:3.40.50.300:FF:003305', NULL, NULL, 'ATP-dependent dethiobiotin synthetase BioD', NULL, NULL, NULL, NULL, NULL, 4),
(212567, NULL, 'G3DSA:4.10.1000.10:FF:000084', NULL, NULL, 'RING finger protein unkempt homolog', NULL, NULL, NULL, NULL, NULL, 4),
(212568, NULL, 'G3DSA:2.130.10.10:FF:005036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212569, NULL, 'G3DSA:1.10.1200.10:FF:000051', NULL, NULL, 'Nonribosomal peptide synthetase 7', NULL, NULL, NULL, NULL, NULL, 4),
(212570, NULL, 'G3DSA:1.25.40.770:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212571, NULL, 'G3DSA:3.30.930.10:FF:000134', NULL, NULL, 'Glycine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(212572, NULL, 'G3DSA:2.40.10.10:FF:000398', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212573, NULL, 'G3DSA:1.20.1070.10:FF:001122', NULL, NULL, 'Relaxin receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(212574, NULL, 'G3DSA:3.40.50.150:FF:001534', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212575, NULL, 'G3DSA:3.30.70.330:FF:001140', NULL, NULL, 'RNA-binding protein BRN2', NULL, NULL, NULL, NULL, NULL, 4),
(212576, NULL, 'G3DSA:1.10.630.10:FF:000724', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212577, NULL, 'G3DSA:1.20.5.300:FF:000001', NULL, NULL, 'striatin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(212578, NULL, 'G3DSA:3.60.20.10:FF:000165', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212579, NULL, 'G3DSA:3.30.160.60:FF:002866', NULL, NULL, 'Zinc finger protein 260', NULL, NULL, NULL, NULL, NULL, 4),
(212580, NULL, 'G3DSA:3.60.21.60:FF:000007', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(212581, NULL, 'G3DSA:3.30.365.10:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212582, NULL, 'G3DSA:3.10.450.350:FF:000005', NULL, NULL, 'Peptidase M23', NULL, NULL, NULL, NULL, NULL, 4),
(212583, NULL, 'G3DSA:1.10.10.250:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(212584, NULL, 'G3DSA:1.10.510.10:FF:003705', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212585, NULL, 'G3DSA:1.10.8.60:FF:000044', NULL, NULL, 'ATPase family AAA domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(212586, NULL, 'G3DSA:1.20.5.110:FF:000264', NULL, NULL, 'Culmination specific protein 37D', NULL, NULL, NULL, NULL, NULL, 4),
(212587, NULL, 'G3DSA:1.10.10.990:FF:000005', NULL, NULL, 'RecBCD enzyme subunit RecC', NULL, NULL, NULL, NULL, NULL, 4),
(212588, NULL, 'G3DSA:3.40.1000.10:FF:000004', NULL, NULL, 'Probable ran guanine nucleotide release factor', NULL, NULL, NULL, NULL, NULL, 4),
(212589, NULL, 'G3DSA:3.80.10.10:FF:000950', NULL, NULL, 'Nyctalopin', NULL, NULL, NULL, NULL, NULL, 4),
(212590, NULL, 'G3DSA:2.60.40.3470:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212591, NULL, 'G3DSA:3.40.50.10330:FF:000101', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(212592, NULL, 'G3DSA:2.60.40.10:FF:002130', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(212593, NULL, 'G3DSA:2.130.10.10:FF:005710', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212594, NULL, 'G3DSA:2.30.29.30:FF:000571', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212595, NULL, 'G3DSA:2.60.40.1190:FF:000003', NULL, NULL, 'Endo-1,4-beta-xylanase A', NULL, NULL, NULL, NULL, NULL, 4),
(212596, NULL, 'G3DSA:1.10.10.60:FF:000877', NULL, NULL, 'CENP-B homolog protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(212597, NULL, 'G3DSA:3.30.450.60:FF:000084', NULL, NULL, 'AP-3 complex subunit mu', NULL, NULL, NULL, NULL, NULL, 4),
(212598, NULL, 'G3DSA:3.30.160.60:FF:005890', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212599, NULL, 'G3DSA:3.30.160.60:FF:004996', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212600, NULL, 'G3DSA:1.10.630.10:FF:000106', NULL, NULL, 'Cytochrome P450-DIT2', NULL, NULL, NULL, NULL, NULL, 4),
(212601, NULL, 'G3DSA:2.130.10.10:FF:002962', NULL, NULL, 'WD repeat domain 34', NULL, NULL, NULL, NULL, NULL, 4),
(212602, NULL, 'G3DSA:2.30.42.10:FF:000146', NULL, NULL, 'Carboxyl-terminal-processing peptidase 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(212603, NULL, 'G3DSA:1.10.10.10:FF:001615', NULL, NULL, 'Histone H1', NULL, NULL, NULL, NULL, NULL, 4),
(212604, NULL, 'G3DSA:3.40.50.12760:FF:000004', NULL, NULL, 'FtsJ-like methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(212605, NULL, 'G3DSA:4.10.240.10:FF:000110', NULL, NULL, 'C6 transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(212606, NULL, 'G3DSA:3.30.70.2850:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212607, NULL, 'G3DSA:1.10.10.1410:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212608, NULL, 'G3DSA:2.20.25.20:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212609, NULL, 'G3DSA:3.30.160.60:FF:005272', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212610, NULL, 'G3DSA:1.10.10.10:FF:000379', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(212611, NULL, 'G3DSA:1.20.1540.10:FF:000085', NULL, NULL, 'Rhomboid-like protease', NULL, NULL, NULL, NULL, NULL, 4),
(212612, NULL, 'G3DSA:2.40.50.90:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212613, NULL, 'G3DSA:1.10.287.70:FF:000202', NULL, NULL, 'TWiK family of potassium channels', NULL, NULL, NULL, NULL, NULL, 4),
(212614, NULL, 'G3DSA:3.40.50.300:FF:002400', NULL, NULL, 'ABC transporter 2', NULL, NULL, NULL, NULL, NULL, 4),
(212615, NULL, 'G3DSA:1.20.140.50:FF:000011', NULL, NULL, 'Rim20p', NULL, NULL, NULL, NULL, NULL, 4),
(212616, NULL, 'G3DSA:3.80.10.10:FF:002804', NULL, NULL, 'Leucine-rich repeat-containing G-protein coupled receptor 5-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(212617, NULL, 'G3DSA:3.50.50.60:FF:000749', NULL, NULL, 'Amine oxidase family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(212618, NULL, 'G3DSA:1.20.58.1120:FF:000003', NULL, NULL, 'Cytoplasmic dynein heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(212619, NULL, 'G3DSA:2.40.37.10:FF:000083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212620, NULL, 'G3DSA:4.10.1000.10:FF:000140', NULL, NULL, 'Cleavage and polyadenylation specificity factor subunit 4-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(212621, NULL, 'G3DSA:1.25.10.10:FF:001346', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212622, NULL, 'G3DSA:3.20.20.80:FF:000592', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212623, NULL, 'G3DSA:2.60.40.10:FF:004783', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212624, NULL, 'G3DSA:3.30.160.60:FF:001562', NULL, NULL, 'Zinc finger protein 449', NULL, NULL, NULL, NULL, NULL, 4),
(212625, NULL, 'G3DSA:3.40.50.300:FF:001506', NULL, NULL, 'Ras-related protein Rab-40C', NULL, NULL, NULL, NULL, NULL, 4),
(212626, NULL, 'G3DSA:3.80.10.10:FF:000332', NULL, NULL, 'extracellular matrix protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(212627, NULL, 'G3DSA:1.10.150.20:FF:000292', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(212628, NULL, 'G3DSA:1.25.40.180:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212629, NULL, 'G3DSA:1.10.10.60:FF:001192', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212630, NULL, 'G3DSA:2.20.28.10:FF:000006', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(212631, NULL, 'G3DSA:3.40.50.2300:FF:001094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212632, NULL, 'G3DSA:2.130.10.10:FF:001326', NULL, NULL, 'Similar to nuclear pore protein Seh1', NULL, NULL, NULL, NULL, NULL, 4),
(212633, NULL, 'G3DSA:3.40.50.300:FF:005834', NULL, NULL, 'ABC transporter D family member 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(212634, NULL, 'G3DSA:1.10.150.110:FF:000018', NULL, NULL, 'Probable crossover junction endonuclease mus81', NULL, NULL, NULL, NULL, NULL, 4),
(212635, NULL, 'G3DSA:3.30.900.10:FF:000020', NULL, NULL, 'Mitotic spindle checkpoint component MAD2', NULL, NULL, NULL, NULL, NULL, 4),
(212636, NULL, 'G3DSA:3.40.50.300:FF:001383', NULL, NULL, 'Peptide ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(212637, NULL, 'G3DSA:3.30.40.210:FF:000007', NULL, NULL, 'Transcription elongation factor SPT4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(212638, NULL, 'G3DSA:3.90.215.10:FF:000021', NULL, NULL, 'Fibrinogen alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(212639, NULL, 'G3DSA:3.40.80.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212640, NULL, 'G3DSA:3.30.70.330:FF:001701', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212641, NULL, 'G3DSA:1.10.287.4070:FF:000004', NULL, NULL, 'Nucleolar protein 56', NULL, NULL, NULL, NULL, NULL, 4),
(212642, NULL, 'G3DSA:1.20.120.1220:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212643, NULL, 'G3DSA:1.25.10.10:FF:001907', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212644, NULL, 'G3DSA:1.20.120.1080:FF:000105', NULL, NULL, 'AGAP010872-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(212645, NULL, 'G3DSA:2.60.40.10:FF:001017', NULL, NULL, 'Matrix remodeling associated 5', NULL, NULL, NULL, NULL, NULL, 4),
(212646, NULL, 'G3DSA:4.10.1000.10:FF:000027', NULL, NULL, 'Zinc finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(212647, NULL, 'G3DSA:3.30.420.40:FF:000773', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(212648, NULL, 'G3DSA:3.20.20.140:FF:000355', NULL, NULL, 'Putative deoxyribonuclease TATDN1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(212649, NULL, 'G3DSA:2.60.40.10:FF:005507', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212650, NULL, 'G3DSA:3.30.67.10:FF:000004', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(212651, NULL, 'G3DSA:1.20.120.850:FF:000018', NULL, NULL, 'DNA repair and recombination protein RAD54', NULL, NULL, NULL, NULL, NULL, 4),
(212652, NULL, 'G3DSA:3.40.1280.10:FF:000053', NULL, NULL, 'SpoU rRNA Methylase family, putative', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(212653, NULL, 'G3DSA:2.30.29.30:FF:000239', NULL, NULL, 'arf-GAP with GTPase, ANK repeat and PH domain-containing protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(212654, NULL, 'G3DSA:1.10.150.20:FF:000179', NULL, NULL, 'DNA-directed DNA polymerase eta', NULL, NULL, NULL, NULL, NULL, 4),
(212655, NULL, 'G3DSA:3.20.20.70:FF:000370', NULL, NULL, 'Dihydroorotate dehydrogenase (quinone), mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(212656, NULL, 'G3DSA:3.80.10.10:FF:000731', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(212657, NULL, 'G3DSA:3.40.50.10490:FF:000121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212658, NULL, 'G3DSA:3.30.450.20:FF:000482', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(212659, NULL, 'G3DSA:3.30.9.10:FF:000123', NULL, NULL, 'D-amino acid dehydrogenase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(212660, NULL, 'G3DSA:2.130.10.10:FF:005093', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212661, NULL, 'G3DSA:1.10.287.310:FF:000010', NULL, NULL, '60S ribosomal protein L35, putative', NULL, NULL, NULL, NULL, NULL, 4),
(212662, NULL, 'G3DSA:1.20.1560.10:FF:000535', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212663, NULL, 'G3DSA:1.20.1250.20:FF:002347', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(212664, NULL, 'G3DSA:2.60.40.1090:FF:000029', NULL, NULL, 'Fimbrial family protein', NULL, NULL, NULL, NULL, NULL, 4),
(212665, NULL, 'G3DSA:1.20.1420.30:FF:000037', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212666, NULL, 'G3DSA:3.80.10.10:FF:002748', NULL, NULL, 'Fbox domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(212667, NULL, 'G3DSA:1.10.510.10:FF:002649', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212668, NULL, 'G3DSA:1.20.1420.10:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212669, NULL, 'G3DSA:3.30.1240.10:FF:000058', NULL, NULL, 'Putative phosphatase HI_0003', NULL, NULL, NULL, NULL, NULL, 4),
(212670, NULL, 'G3DSA:1.10.472.10:FF:000519', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212671, NULL, 'G3DSA:2.10.220.10:FF:000133', NULL, NULL, 'receptor tyrosine-protein kinase erbB-4-like', NULL, NULL, NULL, NULL, NULL, 4),
(212672, NULL, 'G3DSA:3.20.20.70:FF:000313', NULL, NULL, 'Dihydroorotate reductase PyrE, putative', NULL, NULL, NULL, NULL, NULL, 4),
(212673, NULL, 'G3DSA:3.40.50.150:FF:001591', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212674, NULL, 'G3DSA:1.25.40.90:FF:000085', NULL, NULL, 'ENTH domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(212675, NULL, 'G3DSA:1.20.1070.10:FF:000009', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(212676, NULL, 'G3DSA:1.25.40.570:FF:000061', NULL, NULL, '26S proteasome regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(212677, NULL, 'G3DSA:3.40.50.720:FF:000497', NULL, NULL, 'Trk system potassium transporter TrkA', NULL, NULL, NULL, NULL, NULL, 4),
(212678, NULL, 'G3DSA:3.15.10.10:FF:000010', NULL, NULL, 'BPI fold containing family A member 2', NULL, NULL, NULL, NULL, NULL, 4),
(212679, NULL, 'G3DSA:2.60.40.10:FF:001910', NULL, NULL, 'CD83 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(212680, NULL, 'G3DSA:2.60.120.260:FF:000545', NULL, NULL, 'Probable beta-glucosidase O', NULL, NULL, NULL, NULL, NULL, 4),
(212681, NULL, 'G3DSA:1.20.120.1910:FF:000017', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(212682, NULL, 'G3DSA:3.30.930.10:FF:000353', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212683, NULL, 'G3DSA:1.50.10.20:FF:000032', NULL, NULL, 'Putative geranylgeranyl transferase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(212684, NULL, 'G3DSA:3.20.20.150:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212685, NULL, 'G3DSA:2.60.120.970:FF:000027', NULL, NULL, 'Growth differentiation factor 7', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(212686, NULL, 'G3DSA:3.30.70.590:FF:000003', NULL, NULL, 'Poly(A) polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(212687, NULL, 'G3DSA:1.25.40.10:FF:000100', NULL, NULL, 'Type III secretion system translocator chaperone SicA', NULL, NULL, NULL, NULL, NULL, 4),
(212688, NULL, 'G3DSA:3.40.50.720:FF:002352', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212689, NULL, 'G3DSA:1.20.1070.10:FF:000902', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212690, NULL, 'G3DSA:3.30.420.10:FF:000612', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212691, NULL, 'G3DSA:3.30.160.60:FF:001287', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM56', NULL, NULL, NULL, NULL, NULL, 4),
(212692, NULL, 'G3DSA:2.160.20.10:FF:000174', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(212693, NULL, 'G3DSA:3.40.50.2300:FF:000599', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(212694, NULL, 'G3DSA:1.25.40.180:FF:000270', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212695, NULL, 'G3DSA:3.40.350.10:FF:000059', NULL, NULL, 'Prolidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(212696, NULL, 'G3DSA:1.10.8.10:FF:000344', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212697, NULL, 'G3DSA:3.60.10.10:FF:000226', NULL, NULL, 'DNA-(apurinic or apyrimidinic site) lyase', NULL, NULL, NULL, NULL, NULL, 4),
(212698, NULL, 'G3DSA:1.20.5.5160:FF:000001', NULL, NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', NULL, NULL, NULL, NULL, NULL, 4),
(212699, NULL, 'G3DSA:2.60.120.380:FF:000002', NULL, NULL, 'calpain-3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(212700, NULL, 'G3DSA:3.40.50.150:FF:001315', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212701, NULL, 'G3DSA:2.130.10.10:FF:001383', NULL, NULL, 'Protein JINGUBANG', NULL, NULL, NULL, NULL, NULL, 4),
(212702, NULL, 'G3DSA:3.40.1110.10:FF:000338', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212703, NULL, 'G3DSA:1.20.120.20:FF:000029', NULL, NULL, 'Apolipoprotein A-I', NULL, NULL, NULL, NULL, NULL, 4),
(212704, NULL, 'G3DSA:1.10.2000.10:FF:000069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212705, NULL, 'G3DSA:2.10.110.10:FF:000209', NULL, NULL, 'LIM homeobox 2b', NULL, NULL, NULL, NULL, NULL, 4),
(212706, NULL, 'G3DSA:3.30.160.60:FF:005159', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212707, NULL, 'G3DSA:3.20.20.80:FF:000373', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(212708, NULL, 'G3DSA:3.80.10.10:FF:003024', NULL, NULL, 'Os11g0641200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(212709, NULL, 'G3DSA:3.40.720.10:FF:000312', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212710, NULL, 'G3DSA:1.25.40.20:FF:000103', NULL, NULL, 'Nuclear factor NF-kappa-B p105 subunit isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(212711, NULL, 'G3DSA:1.20.58.60:FF:000621', NULL, NULL, 'Spectrin repeat-containing, nuclear envelope 2, gene 2', NULL, NULL, NULL, NULL, NULL, 4),
(212712, NULL, 'G3DSA:3.20.20.80:FF:000316', NULL, NULL, 'Xylanase', NULL, NULL, NULL, NULL, NULL, 4),
(212713, NULL, 'G3DSA:1.10.510.10:FF:002981', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212714, NULL, 'G3DSA:3.40.640.10:FF:000492', NULL, NULL, 'Aromatic amino acid aminotransferase DDB_G0287711-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(212715, NULL, 'G3DSA:1.25.40.10:FF:002697', NULL, NULL, 'LD43276p', NULL, NULL, NULL, NULL, NULL, 4),
(212716, NULL, 'G3DSA:2.60.40.10:FF:005345', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212717, NULL, 'G3DSA:3.40.190.10:FF:000799', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212718, NULL, 'G3DSA:3.40.850.10:FF:000316', NULL, NULL, 'Myosin', NULL, NULL, NULL, NULL, NULL, 4),
(212719, NULL, 'G3DSA:2.40.128.30:FF:000002', NULL, NULL, 'Hoefavidin', NULL, NULL, NULL, NULL, NULL, 4),
(212720, NULL, 'G3DSA:2.30.29.30:FF:000391', NULL, NULL, 'Sterol 3-beta-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(212721, NULL, 'G3DSA:2.130.10.130:FF:000030', NULL, NULL, 'Phosphatidylinositol-glycan-specific phospholipase D', NULL, NULL, NULL, NULL, NULL, 4),
(212722, NULL, 'G3DSA:3.30.470.20:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212723, NULL, 'G3DSA:2.120.10.30:FF:000456', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212724, NULL, 'G3DSA:1.20.1050.10:FF:000177', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212725, NULL, 'G3DSA:2.170.270.10:FF:000020', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(212726, NULL, 'G3DSA:3.40.850.10:FF:000373', NULL, NULL, 'p-loop nucleoside triphosphate hydrolase superfamily protein with CH (Calponin Homology) domain', NULL, NULL, NULL, NULL, NULL, 4),
(212727, NULL, 'G3DSA:4.10.830.40:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212728, NULL, 'G3DSA:1.20.120.160:FF:000019', NULL, NULL, 'Sensory box sensor histidine kinase/response regulator VieS', NULL, NULL, NULL, NULL, NULL, 4),
(212729, NULL, 'G3DSA:2.130.10.10:FF:005654', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212730, NULL, 'G3DSA:3.50.50.60:FF:000569', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(212731, NULL, 'G3DSA:3.90.190.10:FF:000153', NULL, NULL, 'TEP1p protein', NULL, NULL, NULL, NULL, NULL, 4),
(212732, NULL, 'G3DSA:3.30.160.60:FF:001848', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(212733, NULL, 'G3DSA:3.30.40.10:FF:002269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212734, NULL, 'G3DSA:2.60.60.20:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212735, NULL, 'G3DSA:3.40.50.200:FF:000010', NULL, NULL, 'Putative neuroendocrine convertase 1', NULL, NULL, NULL, NULL, NULL, 4),
(212736, NULL, 'G3DSA:3.30.950.10:FF:000023', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212737, NULL, 'G3DSA:1.20.900.10:FF:000092', NULL, NULL, 'Son of sevenless homolog', NULL, NULL, NULL, NULL, NULL, 4),
(212738, NULL, 'G3DSA:1.20.900.10:FF:000035', NULL, NULL, 'Rho guanyl nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(212739, NULL, 'G3DSA:1.10.10.10:FF:000688', NULL, NULL, 'Transcriptional regulator MvfR', NULL, NULL, NULL, NULL, NULL, 4),
(212740, NULL, 'G3DSA:1.10.238.10:FF:000998', NULL, NULL, 'Centrin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(212741, NULL, 'G3DSA:3.30.710.10:FF:000180', NULL, NULL, 'Kelch repeat and BTB domain containing 13', NULL, NULL, NULL, NULL, NULL, 4),
(212742, NULL, 'G3DSA:1.20.1560.10:FF:000940', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212743, NULL, 'G3DSA:3.40.20.10:FF:000115', NULL, NULL, 'Twinfilin', NULL, NULL, NULL, NULL, NULL, 4),
(212744, NULL, 'G3DSA:1.20.1270.10:FF:000058', NULL, NULL, 'Chaperone protein HscA homolog', NULL, NULL, NULL, NULL, NULL, 4),
(212745, NULL, 'G3DSA:3.90.550.10:FF:000687', NULL, NULL, 'Os08g0434632 protein', NULL, NULL, NULL, NULL, NULL, 4),
(212746, NULL, 'G3DSA:3.90.370.10:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212747, NULL, 'G3DSA:2.60.40.10:FF:003237', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212748, NULL, 'G3DSA:3.30.200.20:FF:000099', NULL, NULL, 'Serine/threonine-protein kinase BLUS1', NULL, NULL, NULL, NULL, NULL, 4),
(212749, NULL, 'G3DSA:3.40.50.300:FF:001467', NULL, NULL, 'Nuclease SbcCD subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(212750, NULL, 'G3DSA:1.20.900.10:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212751, NULL, 'G3DSA:1.20.1110.10:FF:000002', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(212752, NULL, 'G3DSA:3.40.50.150:FF:001596', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212753, NULL, 'G3DSA:1.10.575.10:FF:000011', NULL, NULL, 'Phospholipase C/P1 nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(212754, NULL, 'G3DSA:3.30.200.20:FF:001251', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(212755, NULL, 'G3DSA:3.40.50.620:FF:000843', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212756, NULL, 'G3DSA:3.40.367.20:FF:000022', NULL, NULL, 'Hexokinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(212757, NULL, 'G3DSA:3.40.850.10:FF:000535', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(212758, NULL, 'G3DSA:3.40.1110.10:FF:000153', NULL, NULL, 'Phospholipid-transporting ATPase IC', NULL, NULL, NULL, NULL, NULL, 4),
(212759, NULL, 'G3DSA:3.40.50.2300:FF:000958', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212760, NULL, 'G3DSA:1.25.40.10:FF:002011', NULL, NULL, 'Predicted tetratricopeptide repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(212761, NULL, 'G3DSA:3.20.200.10:FF:000002', NULL, NULL, 'Eukaryotic elongation factor 2 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(212762, NULL, 'G3DSA:2.30.29.30:FF:000930', NULL, NULL, 'Guanine exchange factor for Rac 30', NULL, NULL, NULL, NULL, NULL, 4),
(212763, NULL, 'G3DSA:1.10.510.10:FF:000013', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(212764, NULL, 'G3DSA:2.160.20.10:FF:000275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212765, NULL, 'G3DSA:2.40.50.140:FF:000198', NULL, NULL, 'Exosome complex component CSL4', NULL, NULL, NULL, NULL, NULL, 4),
(212766, NULL, 'G3DSA:2.130.10.10:FF:001080', NULL, NULL, 'NACHT and WD domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(212767, NULL, 'G3DSA:3.40.50.800:FF:000083', NULL, NULL, 'NAB3-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(212768, NULL, 'G3DSA:3.30.70.2350:FF:000004', NULL, NULL, 'Intramembrane protease rhomboid family GlpG', NULL, NULL, NULL, NULL, NULL, 4),
(212769, NULL, 'G3DSA:1.20.1250.20:FF:002095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212770, NULL, 'G3DSA:3.30.1540.20:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212771, NULL, 'G3DSA:1.25.40.10:FF:005237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212772, NULL, 'G3DSA:1.25.10.10:FF:001357', NULL, NULL, 'Protein maestro', NULL, NULL, NULL, NULL, NULL, 4),
(212773, NULL, 'G3DSA:1.25.40.10:FF:002966', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g50390, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(212774, NULL, 'G3DSA:2.130.10.10:FF:002698', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212775, NULL, 'G3DSA:1.20.58.60:FF:000267', NULL, NULL, 'Spectrin repeat containing, nuclear envelope 1a', NULL, NULL, NULL, NULL, NULL, 4),
(212776, NULL, 'G3DSA:1.50.10.20:FF:000133', NULL, NULL, 'Protein farnesyltransferase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(212777, NULL, 'G3DSA:3.40.50.1820:FF:000371', NULL, NULL, 'Similar to platelet-activating factor acetylhydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(212778, NULL, 'G3DSA:3.40.50.150:FF:001607', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212779, NULL, 'G3DSA:2.130.10.10:FF:003215', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(212780, NULL, 'G3DSA:3.80.10.10:FF:002664', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RCH1', NULL, NULL, NULL, NULL, NULL, 4),
(212781, NULL, 'G3DSA:1.10.472.10:FF:000396', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212782, NULL, 'G3DSA:3.40.50.1460:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212783, NULL, 'G3DSA:3.20.20.80:FF:000518', NULL, NULL, 'Glycoside hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(212784, NULL, 'G3DSA:1.10.10.10:FF:001840', NULL, NULL, 'MCM family protein', NULL, NULL, NULL, NULL, NULL, 4),
(212785, NULL, 'G3DSA:3.90.190.10:FF:000232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212786, NULL, 'G3DSA:1.20.1730.10:FF:000105', NULL, NULL, 'High-affinity choline transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(212787, NULL, 'G3DSA:1.10.510.10:FF:003239', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(212788, NULL, 'G3DSA:3.30.450.20:FF:000454', NULL, NULL, 'Voltage-dependent calcium channel subunit alpha-2/delta-4', NULL, NULL, NULL, NULL, NULL, 4),
(212789, NULL, 'G3DSA:3.30.565.10:FF:000459', NULL, NULL, 'Globin-coupled histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(212790, NULL, 'G3DSA:3.50.50.60:FF:000339', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(212791, NULL, 'G3DSA:3.30.70.1230:FF:000106', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(212792, NULL, 'G3DSA:3.40.850.10:FF:000491', NULL, NULL, 'Kinesin-like protein KIN-7N', NULL, NULL, NULL, NULL, NULL, 4),
(212793, NULL, 'G3DSA:3.40.50.10140:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212794, NULL, 'G3DSA:2.60.40.10:FF:000011', NULL, NULL, 'Titin b', NULL, NULL, NULL, NULL, NULL, 4),
(212795, NULL, 'G3DSA:3.40.190.10:FF:000827', NULL, NULL, 'Putative nitrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(212796, NULL, 'G3DSA:2.60.120.260:FF:000394', NULL, NULL, 'Endo-1,4-beta-xylanase Y', NULL, NULL, NULL, NULL, NULL, 4),
(212797, NULL, 'G3DSA:3.40.630.150:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212798, NULL, 'G3DSA:1.10.287.70:FF:000157', NULL, NULL, 'Calcium channel subunit Cch1', NULL, NULL, NULL, NULL, NULL, 4),
(212799, NULL, 'G3DSA:2.60.200.40:FF:000023', NULL, NULL, 'Long-chain base (LCB) kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(212800, NULL, 'G3DSA:3.30.70.330:FF:000982', NULL, NULL, 'Unplaced genomic scaffold supercont2.16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(212801, NULL, 'G3DSA:1.10.1670.40:FF:000015', NULL, NULL, 'Slr0231 protein', NULL, NULL, NULL, NULL, NULL, 4),
(212802, NULL, 'G3DSA:4.10.240.10:FF:000166', NULL, NULL, 'YALI0D02783p', NULL, NULL, NULL, NULL, NULL, 4),
(212803, NULL, 'G3DSA:1.20.1740.10:FF:000033', NULL, NULL, 'Lysine histidine transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(212804, NULL, 'G3DSA:1.20.920.20:FF:000028', NULL, NULL, 'Ciliary dynein heavy chain 11', NULL, NULL, NULL, NULL, NULL, 4),
(212805, NULL, 'G3DSA:3.40.1800.20:FF:000012', NULL, NULL, 'FI04829p', NULL, NULL, NULL, NULL, NULL, 4),
(212806, NULL, 'G3DSA:3.40.50.300:FF:003721', NULL, NULL, 'Thiol reductant ABC exporter subunit CydD', NULL, NULL, NULL, NULL, NULL, 4),
(212807, NULL, 'G3DSA:3.30.160.60:FF:000123', NULL, NULL, 'transcriptional repressor CTCF isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(212808, NULL, 'G3DSA:1.20.1250.20:FF:000650', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(212809, NULL, 'G3DSA:1.10.8.10:FF:000046', NULL, NULL, 'ubiquitin carboxyl-terminal hydrolase 28 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(212810, NULL, 'G3DSA:2.30.30.40:FF:000678', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212811, NULL, 'G3DSA:4.10.280.110:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212812, NULL, 'G3DSA:2.20.100.10:FF:000167', NULL, NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif A, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(212813, NULL, 'G3DSA:1.25.40.180:FF:000242', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212814, NULL, 'G3DSA:3.90.550.10:FF:000102', NULL, NULL, 'Alpha-1,2-mannosyltransferase (Kre5)', NULL, NULL, NULL, NULL, NULL, 4),
(212815, NULL, 'G3DSA:3.40.50.300:FF:007453', NULL, NULL, 'Photoreactivation-associated protein PhrA', NULL, NULL, NULL, NULL, NULL, 4),
(212816, NULL, 'G3DSA:3.40.50.2000:FF:001122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212817, NULL, 'G3DSA:3.30.200.20:FF:000778', NULL, NULL, 'Os07g0493200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(212818, NULL, 'G3DSA:1.10.510.10:FF:001441', NULL, NULL, 'Protein CBG00447', NULL, NULL, NULL, NULL, NULL, 4),
(212819, NULL, 'G3DSA:3.30.9.10:FF:000140', NULL, NULL, 'Gamma-glutamylputrescine oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(212820, NULL, 'G3DSA:3.30.40.10:FF:000791', NULL, NULL, 'Putative RNA binding protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(212821, NULL, 'G3DSA:1.10.150.60:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212822, NULL, 'G3DSA:3.40.1390.30:FF:000016', NULL, NULL, 'Nif3-like dinuclear metal center hexameric protein', NULL, NULL, NULL, NULL, NULL, 4),
(212823, NULL, 'G3DSA:1.25.40.10:FF:002596', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(212824, NULL, 'G3DSA:3.40.50.10190:FF:000323', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212825, NULL, 'G3DSA:1.10.238.10:FF:001178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212826, NULL, 'G3DSA:1.20.1560.10:FF:000305', NULL, NULL, 'Unplaced genomic scaffold supercont1.219, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(212827, NULL, 'G3DSA:3.40.50.300:FF:005166', NULL, NULL, 'DNA mismatch repair protein MutS domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(212828, NULL, 'G3DSA:1.25.40.10:FF:003113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212829, NULL, 'G3DSA:2.130.10.10:FF:005339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212830, NULL, 'G3DSA:3.20.70.20:FF:000009', NULL, NULL, 'Ribonucleoside-diphosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(212831, NULL, 'G3DSA:1.20.1730.10:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212832, NULL, 'G3DSA:3.20.20.300:FF:000038', NULL, NULL, 'Beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(212833, NULL, 'G3DSA:3.30.40.10:FF:000802', NULL, NULL, 'Histone-lysine N-methyltransferase ATXR5', NULL, NULL, NULL, NULL, NULL, 4),
(212834, NULL, 'G3DSA:1.20.1560.10:FF:000614', NULL, NULL, 'ABC transporter, multidrug resistance associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(212835, NULL, 'G3DSA:3.30.160.60:FF:001551', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212836, NULL, 'G3DSA:3.40.850.10:FF:000165', NULL, NULL, 'Kinesin family member 3A (KIF3A)', NULL, NULL, NULL, NULL, NULL, 4),
(212837, NULL, 'G3DSA:3.40.50.300:FF:002895', NULL, NULL, 'Si:dkeyp-52c3.7', NULL, NULL, NULL, NULL, NULL, 4),
(212838, NULL, 'G3DSA:1.20.1560.10:FF:000294', NULL, NULL, 'Multidrug resistance protein 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(212839, NULL, 'G3DSA:2.60.120.200:FF:000527', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(212840, NULL, 'G3DSA:3.40.50.10190:FF:000014', NULL, NULL, 'RNA polymerase II C-terminal domain phosphatase-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(212841, NULL, 'G3DSA:3.30.70.260:FF:000039', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(212842, NULL, 'G3DSA:2.170.270.10:FF:000189', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(212843, NULL, 'G3DSA:3.80.10.10:FF:003766', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212844, NULL, 'G3DSA:2.40.70.10:FF:000002', NULL, NULL, 'Vacuolar aspartic proteinase', NULL, NULL, NULL, NULL, NULL, 4),
(212845, NULL, 'G3DSA:2.60.120.650:FF:000095', NULL, NULL, 'RIOX2 isoform 6', NULL, NULL, NULL, NULL, NULL, 4),
(212846, NULL, 'G3DSA:3.40.50.300:FF:005845', NULL, NULL, 'ABC transporter, putative (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(212847, NULL, 'G3DSA:3.40.50.620:FF:000517', NULL, NULL, 'GMP synthase [glutamine-hydrolyzing]', NULL, NULL, NULL, NULL, NULL, 4),
(212848, NULL, 'G3DSA:3.40.50.10180:FF:000011', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212849, NULL, 'G3DSA:3.80.10.10:FF:002338', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212850, NULL, 'G3DSA:3.30.310.80:FF:000046', NULL, NULL, 'Protein kinase domain-containing protein ppk9', NULL, NULL, NULL, NULL, NULL, 4),
(212851, NULL, 'G3DSA:2.60.200.30:FF:000020', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(212852, NULL, 'G3DSA:3.30.70.330:FF:002590', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212853, NULL, 'G3DSA:1.10.510.10:FF:001750', NULL, NULL, 'OSJNBa0016N04.12-like protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(212854, NULL, 'G3DSA:2.60.120.820:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212855, NULL, 'G3DSA:3.30.800.10:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212856, NULL, 'G3DSA:3.40.50.2000:FF:000649', NULL, NULL, 'Os06g0216100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(212857, NULL, 'G3DSA:1.10.10.10:FF:002020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212858, NULL, 'G3DSA:2.30.29.30:FF:000604', NULL, NULL, 'Serine/threonine protein kinase ppk21, putative', NULL, NULL, NULL, NULL, NULL, 4),
(212859, NULL, 'G3DSA:1.25.40.410:FF:000002', NULL, NULL, 'Dedicator of cytokinesis protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(212860, NULL, 'G3DSA:1.20.58.60:FF:000604', NULL, NULL, 'Microtubule actin crosslinking factor 1a', NULL, NULL, NULL, NULL, NULL, 4),
(212861, NULL, 'G3DSA:1.10.8.10:FF:000355', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212862, NULL, 'G3DSA:1.20.140.10:FF:000050', NULL, NULL, 'Acyl-CoA dehydrogenase FadE28', NULL, NULL, NULL, NULL, NULL, 4),
(212863, NULL, 'G3DSA:3.40.50.720:FF:002329', NULL, NULL, 'C-terminal-binding protein-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(212864, NULL, 'G3DSA:1.25.10.10:FF:003291', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(212865, NULL, 'G3DSA:1.25.10.10:FF:002785', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212866, NULL, 'G3DSA:3.30.420.10:FF:000623', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212867, NULL, 'G3DSA:3.30.450.20:FF:000128', NULL, NULL, 'PAS domain S-box protein', NULL, NULL, NULL, NULL, NULL, 4),
(212868, NULL, 'G3DSA:2.30.30.180:FF:000011', NULL, NULL, 'Ribosome maturation factor RimP', NULL, NULL, NULL, NULL, NULL, 4),
(212869, NULL, 'G3DSA:3.30.700.40:FF:000002', NULL, NULL, 'Methylcrotonyl-CoA carboxylase, alpha-subunit (Biotin-containing)', NULL, NULL, NULL, NULL, NULL, 4),
(212870, NULL, 'G3DSA:3.30.450.40:FF:000201', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(212871, NULL, 'G3DSA:3.40.630.30:FF:000064', NULL, NULL, 'GNAT family acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(212872, NULL, 'G3DSA:2.60.120.290:FF:000144', NULL, NULL, 'GD12774', NULL, NULL, NULL, NULL, NULL, 4),
(212873, NULL, 'G3DSA:2.30.30.190:FF:000014', NULL, NULL, 'Uncharacterized protein, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(212874, NULL, 'G3DSA:1.20.1250.20:FF:001959', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212875, NULL, 'G3DSA:3.90.640.10:FF:000014', NULL, NULL, 'Putative actin-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(212876, NULL, 'G3DSA:1.10.418.40:FF:000004', NULL, NULL, 'Beclin 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(212877, NULL, 'G3DSA:1.10.1520.10:FF:000018', NULL, NULL, 'RNase III domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(212878, NULL, 'G3DSA:3.30.460.10:FF:000053', NULL, NULL, 'ILF3 isoform 21', NULL, NULL, NULL, NULL, NULL, 4),
(212879, NULL, 'G3DSA:3.90.660.10:FF:000077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212880, NULL, 'G3DSA:3.40.50.300:FF:001804', NULL, NULL, 'ATP-dependent RNA helicase DDX47', NULL, NULL, NULL, NULL, NULL, 4),
(212881, NULL, 'G3DSA:3.30.930.10:FF:000061', NULL, NULL, 'Histidine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(212882, NULL, 'G3DSA:1.20.58.390:FF:000111', NULL, NULL, 'AcetylCholine Receptor', NULL, NULL, NULL, NULL, NULL, 4),
(212883, NULL, 'G3DSA:2.60.40.1390:FF:000018', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212884, NULL, 'G3DSA:3.90.570.10:FF:000002', NULL, NULL, 'beta-amyloid-like protein isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(212885, NULL, 'G3DSA:3.90.190.10:FF:000602', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212886, NULL, 'G3DSA:1.20.58.1210:FF:000007', NULL, NULL, 'Exocyst complex component EXO84, variant', NULL, NULL, NULL, NULL, NULL, 4),
(212887, NULL, 'G3DSA:2.10.50.10:FF:000036', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 1B', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(212888, NULL, 'G3DSA:1.20.1070.10:FF:000756', NULL, NULL, 'Follicle stimulating hormone receptor, fshr, putative', NULL, NULL, NULL, NULL, NULL, 4),
(212889, NULL, 'G3DSA:2.40.50.140:FF:000877', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212890, NULL, 'G3DSA:1.20.1410.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212891, NULL, 'G3DSA:3.30.420.10:FF:000314', NULL, NULL, 'Protein CBG03113', NULL, NULL, NULL, NULL, NULL, 4),
(212892, NULL, 'G3DSA:1.10.418.30:FF:000001', NULL, NULL, 'Probable kinetochore protein ndc80', NULL, NULL, NULL, NULL, NULL, 4),
(212893, NULL, 'G3DSA:1.10.555.10:FF:000111', NULL, NULL, 'RhoGAP domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(212894, NULL, 'G3DSA:3.30.160.60:FF:001860', NULL, NULL, 'Zinc finger protein 770', NULL, NULL, NULL, NULL, NULL, 4),
(212895, NULL, 'G3DSA:1.10.10.2480:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212896, NULL, 'G3DSA:3.90.20.20:FF:000037', NULL, NULL, 'GrpE protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(212897, NULL, 'G3DSA:1.10.10.10:FF:001531', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(212898, NULL, 'G3DSA:1.20.920.10:FF:000025', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(212899, NULL, 'G3DSA:3.40.50.300:FF:001793', NULL, NULL, 'TATA-binding protein-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(212900, NULL, 'G3DSA:1.10.30.20:FF:000006', NULL, NULL, 'ERCC2/XPD/Rad3-related DNA repair helicase', NULL, NULL, NULL, NULL, NULL, 4),
(212901, NULL, 'G3DSA:3.40.50.2300:FF:000649', NULL, NULL, 'AGAP010272-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(212902, NULL, 'G3DSA:3.90.25.10:FF:000040', NULL, NULL, 'Tar1', NULL, NULL, NULL, NULL, NULL, 4),
(212903, NULL, 'G3DSA:2.10.25.10:FF:000540', NULL, NULL, 'Sushi, nidogen and EGF-like domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(212904, NULL, 'G3DSA:3.10.100.10:FF:000385', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212905, NULL, 'G3DSA:1.25.40.120:FF:000022', NULL, NULL, 'Farnesyl transferase alpha, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(212906, NULL, 'G3DSA:1.10.1410.20:FF:000002', NULL, NULL, '2''-5''-oligoadenylate synthetase 3', NULL, NULL, NULL, NULL, NULL, 4),
(212907, NULL, 'G3DSA:2.30.30.100:FF:000061', NULL, NULL, 'Small nuclear ribonucleoprotein G', NULL, NULL, NULL, NULL, NULL, 4),
(212908, NULL, 'G3DSA:3.40.50.150:FF:001287', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212909, NULL, 'G3DSA:2.60.120.10:FF:000300', NULL, NULL, 'Potassium channel, voltage-gated eag-related subfamily H, member 7', NULL, NULL, NULL, NULL, NULL, 4),
(212910, NULL, 'G3DSA:3.40.30.10:FF:000998', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212911, NULL, 'G3DSA:1.20.1070.10:FF:001858', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212912, NULL, 'G3DSA:3.30.40.10:FF:000139', NULL, NULL, 'E3 ubiquitin-protein ligase RBBP6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(212913, NULL, 'G3DSA:1.10.3520.10:FF:000002', NULL, NULL, 'Ceramide-1-phosphate transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(212914, NULL, 'G3DSA:2.130.10.10:FF:002113', NULL, NULL, 'WD repeat-containing protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(212915, NULL, 'G3DSA:3.40.50.2300:FF:000279', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(212916, NULL, 'G3DSA:3.30.160.60:FF:001225', NULL, NULL, 'zinc finger protein 341 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(212917, NULL, 'G3DSA:1.10.630.10:FF:000432', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(212918, NULL, 'G3DSA:3.30.70.330:FF:002264', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212919, NULL, 'G3DSA:3.10.290.10:FF:000021', NULL, NULL, '40S ribosomal protein S9', NULL, NULL, NULL, NULL, NULL, 4),
(212920, NULL, 'G3DSA:2.30.29.30:FF:000593', NULL, NULL, 'Adaptin ear-binding coat-associated protein 2 family protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(212921, NULL, 'G3DSA:1.10.2080.10:FF:000001', NULL, NULL, 'ejaculatory bulb-specific protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(212922, NULL, 'G3DSA:2.130.10.10:FF:001433', NULL, NULL, 'Lethal(2) giant larvae protein', NULL, NULL, NULL, NULL, NULL, 4),
(212923, NULL, 'G3DSA:1.50.10.10:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212924, NULL, 'G3DSA:1.20.5.170:FF:000068', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(212925, NULL, 'G3DSA:1.10.8.60:FF:000600', NULL, NULL, 'Lon protease homolog 2, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(212926, NULL, 'G3DSA:3.40.50.620:FF:000490', NULL, NULL, 'U-box domain-containing protein 54', NULL, NULL, NULL, NULL, NULL, 4),
(212927, NULL, 'G3DSA:3.40.50.300:FF:005519', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212928, NULL, 'G3DSA:1.20.1070.10:FF:000077', NULL, NULL, 'Melanocortin receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(212929, NULL, 'G3DSA:1.10.560.10:FF:000050', NULL, NULL, 'Bardet-Biedl syndrome 10 protein', NULL, NULL, NULL, NULL, NULL, 4),
(212930, NULL, 'G3DSA:3.10.290.20:FF:000024', NULL, NULL, 'SUMO-activating enzyme subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(212931, NULL, 'G3DSA:4.10.75.10:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212932, NULL, 'G3DSA:1.20.1270.60:FF:000303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212933, NULL, 'G3DSA:2.40.50.140:FF:001041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212934, NULL, 'G3DSA:1.20.1260.60:FF:000005', NULL, NULL, 'Regulator of Vps4 activity in the MVB pathway protein', NULL, NULL, NULL, NULL, NULL, 4),
(212935, NULL, 'G3DSA:4.10.1060.10:FF:000003', NULL, NULL, 'E3 SUMO-protein ligase RanBP2', NULL, NULL, NULL, NULL, NULL, 4),
(212936, NULL, 'G3DSA:3.30.50.10:FF:000067', NULL, NULL, 'GATA transcription factor (Ams2), putative', NULL, NULL, NULL, NULL, NULL, 4),
(212937, NULL, 'G3DSA:1.20.120.310:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212938, NULL, 'G3DSA:2.40.70.10:FF:000278', NULL, NULL, 'Aspartic peptidase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(212939, NULL, 'G3DSA:3.30.1520.10:FF:000153', NULL, NULL, 'Sorting nexin-41', NULL, NULL, NULL, NULL, NULL, 4),
(212940, NULL, 'G3DSA:3.30.390.30:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212941, NULL, 'G3DSA:3.20.20.190:FF:000022', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(212942, NULL, 'G3DSA:3.40.190.10:FF:000518', NULL, NULL, 'Transferrin-a', NULL, NULL, NULL, NULL, NULL, 4),
(212943, NULL, 'G3DSA:3.40.50.10880:FF:000007', NULL, NULL, 'DUF89 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(212944, NULL, 'G3DSA:3.40.50.2300:FF:000751', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212945, NULL, 'G3DSA:4.10.830.40:FF:000001', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM9 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(212946, NULL, 'G3DSA:3.10.20.90:FF:000033', NULL, NULL, 'afadin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(212947, NULL, 'G3DSA:1.10.510.10:FF:003548', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212948, NULL, 'G3DSA:1.10.8.60:FF:000230', NULL, NULL, 'DNA polymerase epsilon subunit', NULL, NULL, NULL, NULL, NULL, 4),
(212949, NULL, 'G3DSA:2.30.230.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212950, NULL, 'G3DSA:3.40.50.150:FF:001080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212951, NULL, 'G3DSA:2.10.110.10:FF:000277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212952, NULL, 'G3DSA:1.10.3380.10:FF:000013', NULL, NULL, 'DEAD/DEAH box helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(212953, NULL, 'G3DSA:1.20.120.1240:FF:000064', NULL, NULL, 'Dynamin-2A', NULL, NULL, NULL, NULL, NULL, 4),
(212954, NULL, 'G3DSA:2.60.40.10:FF:005480', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(212955, NULL, 'G3DSA:1.20.58.60:FF:000593', NULL, NULL, 'Dystrophin', NULL, NULL, NULL, NULL, NULL, 4),
(212956, NULL, 'G3DSA:3.60.40.10:FF:000205', NULL, NULL, 'AGAP002147-PA', NULL, NULL, NULL, NULL, NULL, 4),
(212957, NULL, 'G3DSA:2.30.30.490:FF:000014', NULL, NULL, 'trinucleotide repeat-containing gene 18 protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(212958, NULL, 'G3DSA:3.40.50.720:FF:000738', NULL, NULL, 'Galactose/lactose metabolism regulatory protein GAL80', NULL, NULL, NULL, NULL, NULL, 4),
(212959, NULL, 'G3DSA:2.60.40.10:FF:004991', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212960, NULL, 'G3DSA:3.30.70.3030:FF:000017', NULL, NULL, 'Nucleolar protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(212961, NULL, 'G3DSA:2.130.10.10:FF:005811', NULL, NULL, 'Plexin B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(212962, NULL, 'G3DSA:1.10.880.10:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212963, NULL, 'G3DSA:4.10.240.10:FF:000183', NULL, NULL, 'Zcf10p', NULL, NULL, NULL, NULL, NULL, 4),
(212964, NULL, 'G3DSA:2.60.40.10:FF:000949', NULL, NULL, 'vascular endothelial growth factor receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(212965, NULL, 'G3DSA:3.80.10.10:FF:000747', NULL, NULL, 'volume-regulated anion channel subunit LRRC8E', NULL, NULL, NULL, NULL, NULL, 4),
(212966, NULL, 'G3DSA:2.60.200.40:FF:000040', NULL, NULL, 'Ceramide kinase-like isoform 29', NULL, NULL, NULL, NULL, NULL, 4),
(212967, NULL, 'G3DSA:3.40.50.2020:FF:000043', NULL, NULL, 'Ribose-phosphate pyrophosphokinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(212968, NULL, 'G3DSA:3.80.10.10:FF:002647', NULL, NULL, 'Transforming growth factor beta activator LRRC33', NULL, NULL, NULL, NULL, NULL, 4),
(212969, NULL, 'G3DSA:3.30.420.40:FF:000975', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(212970, NULL, 'G3DSA:3.30.70.2740:FF:000014', NULL, NULL, 'D-2-hydroxyglutarate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(212971, NULL, 'G3DSA:3.20.20.70:FF:000162', NULL, NULL, 'tRNA-dihydrouridine(16/17) synthase [NAD(P)(+)]-like', NULL, NULL, NULL, NULL, NULL, 4),
(212972, NULL, 'G3DSA:1.20.1250.20:FF:000178', NULL, NULL, 'Protein NRT1/ PTR FAMILY 4.4', NULL, NULL, NULL, NULL, NULL, 4),
(212973, NULL, 'G3DSA:3.30.1370.10:FF:000219', NULL, NULL, 'RNA-binding protein rnc1', NULL, NULL, NULL, NULL, NULL, 4),
(212974, NULL, 'G3DSA:1.10.3390.10:FF:000002', NULL, NULL, 'Tegument protein BLRF2', NULL, NULL, NULL, NULL, NULL, 4),
(212975, NULL, 'G3DSA:1.25.40.10:FF:003130', NULL, NULL, 'Os03g0283500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(212976, NULL, 'G3DSA:2.30.29.30:FF:000267', NULL, NULL, 'PH and SEC7 domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(212977, NULL, 'G3DSA:3.80.10.10:FF:004446', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(212978, NULL, 'G3DSA:3.40.850.10:FF:000518', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(212979, NULL, 'G3DSA:3.20.20.140:FF:000147', NULL, NULL, 'AMP deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(212980, NULL, 'G3DSA:3.30.260.10:FF:000088', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212981, NULL, 'G3DSA:2.20.70.10:FF:000088', NULL, NULL, 'WW domain-binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(212982, NULL, 'G3DSA:3.30.160.60:FF:001534', NULL, NULL, 'zinc finger protein 227 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(212983, NULL, 'G3DSA:2.120.10.30:FF:000299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212984, NULL, 'G3DSA:2.60.40.10:FF:005154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212985, NULL, 'G3DSA:3.40.850.10:FF:000182', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(212986, NULL, 'G3DSA:1.25.10.10:FF:002200', NULL, NULL, 'AGAP002597-PA', NULL, NULL, NULL, NULL, NULL, 4),
(212987, NULL, 'G3DSA:3.80.10.10:FF:000523', NULL, NULL, 'F-box/LRR-repeat protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(212988, NULL, 'G3DSA:1.25.40.20:FF:001525', NULL, NULL, 'Kinase, NEK-frag', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(212989, NULL, 'G3DSA:3.40.50.10190:FF:000340', NULL, NULL, 'Pescadillo homolog', NULL, NULL, NULL, NULL, NULL, 4),
(212990, NULL, 'G3DSA:3.30.160.60:FF:005457', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212991, NULL, 'G3DSA:1.25.40.10:FF:004748', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(212992, NULL, 'G3DSA:2.60.40.10:FF:003546', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212993, NULL, 'G3DSA:3.40.50.2300:FF:001122', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212994, NULL, 'G3DSA:1.25.10.10:FF:001048', NULL, NULL, 'WGS project CABT00000000 data, contig 2.10', NULL, NULL, NULL, NULL, NULL, 4),
(212995, NULL, 'G3DSA:1.10.260.40:FF:000047', NULL, NULL, 'One cut domain family member', NULL, NULL, NULL, NULL, NULL, 4),
(212996, NULL, 'G3DSA:1.10.1580.10:FF:000011', NULL, NULL, 'Nucleolar GTP-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(212997, NULL, 'G3DSA:1.10.3380.10:FF:000030', NULL, NULL, 'Pre-mRNA-splicing helicase BRR2', NULL, NULL, NULL, NULL, NULL, 4),
(212998, NULL, 'G3DSA:2.40.50.140:FF:000861', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(212999, NULL, 'G3DSA:1.10.10.540:FF:000005', NULL, NULL, 'Related to RAD23-nucleotide excision repair protein (Ubiquitin-like protein)', NULL, NULL, NULL, NULL, NULL, 4),
(213000, NULL, 'G3DSA:1.25.40.120:FF:000038', NULL, NULL, 'WGS project CABT00000000 data, contig 2.3', NULL, NULL, NULL, NULL, NULL, 4),
(213001, NULL, 'G3DSA:3.40.33.10:FF:000083', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(213002, NULL, 'G3DSA:3.40.1110.10:FF:000462', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213003, NULL, 'G3DSA:3.40.50.1000:FF:000788', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213004, NULL, 'G3DSA:3.40.50.720:FF:001020', NULL, NULL, 'Putative D-isomer specific 2-hydroxyacid dehydrogenase family', NULL, NULL, NULL, NULL, NULL, 4),
(213005, NULL, 'G3DSA:3.80.10.10:FF:003749', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213006, NULL, 'G3DSA:3.90.190.10:FF:000248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213007, NULL, 'G3DSA:1.25.10.10:FF:003302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213008, NULL, 'G3DSA:3.40.20.10:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213009, NULL, 'G3DSA:2.30.29.30:FF:000621', NULL, NULL, 'NECAP endocytosis-associated 1', NULL, NULL, NULL, NULL, NULL, 4),
(213010, NULL, 'G3DSA:3.30.160.20:FF:000044', NULL, NULL, 'Uncharacterized protein, isoform I', NULL, NULL, NULL, NULL, NULL, 4),
(213011, NULL, 'G3DSA:3.40.50.12710:FF:000034', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7', NULL, NULL, NULL, NULL, NULL, 4),
(213012, NULL, 'G3DSA:3.30.1300.30:FF:000002', NULL, NULL, 'Type II secretion system protein GspI', NULL, NULL, NULL, NULL, NULL, 4),
(213013, NULL, 'G3DSA:3.30.300.30:FF:000036', NULL, NULL, 'Acetyl-CoA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(213014, NULL, 'G3DSA:1.20.58.1610:FF:000004', NULL, NULL, 'NADH-quinone oxidoreductase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(213015, NULL, 'G3DSA:3.40.50.300:FF:001484', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(213016, NULL, 'G3DSA:3.40.50.1010:FF:000206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213017, NULL, 'G3DSA:3.30.1360.40:FF:000014', NULL, NULL, 'DNA gyrase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(213018, NULL, 'G3DSA:3.30.300.20:FF:000033', NULL, NULL, 'GTPase Era, putative', NULL, NULL, NULL, NULL, NULL, 4),
(213019, NULL, 'G3DSA:3.40.50.80:FF:000183', NULL, NULL, 'Ferric-chelate reductase, putative (AFU_orthologue AFUA_6G13750)', NULL, NULL, NULL, NULL, NULL, 4),
(213020, NULL, 'G3DSA:3.30.460.10:FF:000070', NULL, NULL, 'Related to TRF4-topoisomerase I-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(213021, NULL, 'G3DSA:1.10.10.60:FF:000579', NULL, NULL, 'Homeodomain-like transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(213022, NULL, 'G3DSA:2.40.128.20:FF:000055', NULL, NULL, 'Nitrophorin-7', NULL, NULL, NULL, NULL, NULL, 4),
(213023, NULL, 'G3DSA:1.10.8.60:FF:000128', NULL, NULL, 'Cell division control protein 48 homolog C', NULL, NULL, NULL, NULL, NULL, 4),
(213024, NULL, 'G3DSA:1.25.10.10:FF:003274', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(213025, NULL, 'G3DSA:3.30.1740.10:FF:000017', NULL, NULL, 'DNA repair protein rhp16, putative', NULL, NULL, NULL, NULL, NULL, 4),
(213026, NULL, 'G3DSA:1.25.10.10:FF:001374', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213027, NULL, 'G3DSA:1.10.3080.10:FF:000001', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(213028, NULL, 'G3DSA:3.40.1190.20:FF:000239', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213029, NULL, 'G3DSA:3.40.1190.10:FF:000012', NULL, NULL, 'Dihydrofolate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(213030, NULL, 'G3DSA:3.20.20.80:FF:000165', NULL, NULL, 'Cell wall glucanase (Scw11)', NULL, NULL, NULL, NULL, NULL, 4),
(213031, NULL, 'G3DSA:3.80.10.10:FF:001849', NULL, NULL, 'Receptor-like protein kinase 2 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(213032, NULL, 'G3DSA:3.30.300.10:FF:000030', NULL, NULL, 'Methionine S-adenosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(213033, NULL, 'G3DSA:3.40.50.300:FF:003384', NULL, NULL, 'DNA ligase-associated DEXH box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(213034, NULL, 'G3DSA:3.50.30.30:FF:000104', NULL, NULL, 'Peptide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(213035, NULL, 'G3DSA:3.30.450.20:FF:000471', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(213036, NULL, 'G3DSA:1.20.900.10:FF:000097', NULL, NULL, 'MKIAA1209 protein', NULL, NULL, NULL, NULL, NULL, 4),
(213037, NULL, 'G3DSA:3.20.20.80:FF:000827', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(213038, NULL, 'G3DSA:1.10.238.10:FF:000689', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(213039, NULL, 'G3DSA:3.30.70.330:FF:000673', NULL, NULL, 'Os07g0663300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(213040, NULL, 'G3DSA:1.25.40.10:FF:005030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213041, NULL, 'G3DSA:3.20.20.80:FF:000311', NULL, NULL, 'Chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(213042, NULL, 'G3DSA:3.40.1190.20:FF:000015', NULL, NULL, 'Hydroxyethylthiazole kinase', NULL, NULL, NULL, NULL, NULL, 4),
(213043, NULL, 'G3DSA:2.10.50.10:FF:000053', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(213044, NULL, 'G3DSA:3.40.50.20:FF:000081', NULL, NULL, 'Biotin carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(213045, NULL, 'G3DSA:2.40.50.40:FF:000128', NULL, NULL, 'Histone-lysine N-methyltransferase SUV39H1-A', NULL, NULL, NULL, NULL, NULL, 4),
(213046, NULL, 'G3DSA:2.60.40.200:FF:000001', NULL, NULL, 'Superoxide dismutase [Cu-Zn]', NULL, NULL, NULL, NULL, NULL, 4),
(213047, NULL, 'G3DSA:3.30.40.10:FF:001145', NULL, NULL, 'E3 ubiquitin-protein ligase PEP5', NULL, NULL, NULL, NULL, NULL, 4),
(213048, NULL, 'G3DSA:3.90.810.10:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213049, NULL, 'G3DSA:3.30.70.330:FF:001162', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(213050, NULL, 'G3DSA:3.40.440.10:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213051, NULL, 'G3DSA:3.40.50.300:FF:007762', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213052, NULL, 'G3DSA:2.10.60.10:FF:000008', NULL, NULL, 'Serine/threonine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(213053, NULL, 'G3DSA:3.20.20.80:FF:000620', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213054, NULL, 'G3DSA:3.10.580.10:FF:000105', NULL, NULL, 'Inorganic pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(213055, NULL, 'G3DSA:1.10.287.130:FF:000237', NULL, NULL, 'Phytochrome-like protein cph1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(213056, NULL, 'G3DSA:1.10.287.110:FF:000231', NULL, NULL, 'Molecular chaperone, putative', NULL, NULL, NULL, NULL, NULL, 4),
(213057, NULL, 'G3DSA:1.25.40.20:FF:001188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213058, NULL, 'G3DSA:2.60.420.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213059, NULL, 'G3DSA:1.10.20.10:FF:000031', NULL, NULL, 'transcription initiation factor TFIID subunit 8 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(213060, NULL, 'G3DSA:3.30.160.60:FF:000106', NULL, NULL, 'B-cell lymphoma/leukemia 11A isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(213061, NULL, 'G3DSA:3.40.50.800:FF:000111', NULL, NULL, 'Threonyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(213062, NULL, 'G3DSA:1.25.10.10:FF:001683', NULL, NULL, 'Pumilio/PUF RNA binding protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(213063, NULL, 'G3DSA:3.30.60.270:FF:000012', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(213064, NULL, 'G3DSA:2.40.50.140:FF:001024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213065, NULL, 'G3DSA:1.20.58.400:FF:000036', NULL, NULL, 'vesicle transport through interaction with t-SNAREs homolog 1B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(213066, NULL, 'G3DSA:1.25.40.20:FF:001851', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(213067, NULL, 'G3DSA:3.40.50.300:FF:007436', NULL, NULL, 'Putative RNA helicase armi-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(213068, NULL, 'G3DSA:3.40.50.300:FF:005536', NULL, NULL, 'Elongation factor G, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(213069, NULL, 'G3DSA:3.40.50.11660:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213070, NULL, 'G3DSA:1.20.1250.20:FF:001004', NULL, NULL, 'Drug resistance transporter, EmrB/QacA subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(213071, NULL, 'G3DSA:3.90.640.10:FF:000238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213072, NULL, 'G3DSA:3.40.50.300:FF:001613', NULL, NULL, 'DNA primase/helicase, helicase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(213073, NULL, 'G3DSA:3.10.290.20:FF:000007', NULL, NULL, 'SUMO-activating enzyme subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(213074, NULL, 'G3DSA:3.40.50.80:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213075, NULL, 'G3DSA:3.30.70.2640:FF:000001', NULL, NULL, 'RNA-directed RNA polymerase L', NULL, NULL, NULL, NULL, NULL, 4),
(213076, NULL, 'G3DSA:1.25.40.10:FF:001185', NULL, NULL, 'H0315A08.2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(213077, NULL, 'G3DSA:3.90.870.10:FF:000014', NULL, NULL, 'Sua5 YciO YrdC YwlC family protein', NULL, NULL, NULL, NULL, NULL, 4),
(213078, NULL, 'G3DSA:1.25.40.10:FF:000679', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g03800', NULL, NULL, NULL, NULL, NULL, 4),
(213079, NULL, 'G3DSA:3.30.70.330:FF:001471', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213080, NULL, 'G3DSA:1.20.1250.20:FF:000515', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(213081, NULL, 'G3DSA:4.10.280.110:FF:000005', NULL, NULL, 'Pre-mRNA-splicing factor 18', NULL, NULL, NULL, NULL, NULL, 4),
(213082, NULL, 'G3DSA:3.60.10.10:FF:000350', NULL, NULL, 'Protein CBG05397', NULL, NULL, NULL, NULL, NULL, 4),
(213083, NULL, 'G3DSA:2.30.30.190:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213084, NULL, 'G3DSA:2.60.40.10:FF:005463', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213085, NULL, 'G3DSA:3.30.40.10:FF:002247', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(213086, NULL, 'G3DSA:3.30.1520.10:FF:000136', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(213087, NULL, 'G3DSA:3.40.50.150:FF:001742', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213088, NULL, 'G3DSA:1.10.10.10:FF:000103', NULL, NULL, 'Two-component system response regulator NarL', NULL, NULL, NULL, NULL, NULL, 4),
(213089, NULL, 'G3DSA:2.30.230.10:FF:000017', NULL, NULL, 'Uncharacterized protein VTG4', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(213090, NULL, 'G3DSA:1.10.510.10:FF:003565', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213091, NULL, 'G3DSA:3.90.830.10:FF:000023', NULL, NULL, 'Syntaxin-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(213092, NULL, 'G3DSA:3.40.30.10:FF:000060', NULL, NULL, 'Glutaredoxin-like protein nrdH', NULL, NULL, NULL, NULL, NULL, 4),
(213093, NULL, 'G3DSA:3.50.30.30:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213094, NULL, 'G3DSA:3.30.70.360:FF:000069', NULL, NULL, 'Os07g0249900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(213095, NULL, 'G3DSA:1.10.150.170:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213096, NULL, 'G3DSA:3.60.10.10:FF:000041', NULL, NULL, 'DNA-(apurinic or apyrimidinic site) lyase', NULL, NULL, NULL, NULL, NULL, 4),
(213097, NULL, 'G3DSA:1.25.10.10:FF:000868', NULL, NULL, 'HEAT repeat-containing protein 5A', NULL, NULL, NULL, NULL, NULL, 4),
(213098, NULL, 'G3DSA:3.40.1190.20:FF:000032', NULL, NULL, 'Pseudouridine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(213099, NULL, 'G3DSA:3.40.50.620:FF:000164', NULL, NULL, 'Envelope biogenesis factor ElyC', NULL, NULL, NULL, NULL, NULL, 4),
(213100, NULL, 'G3DSA:2.10.110.10:FF:000294', NULL, NULL, 'Probable Rho-type GTPase-activating protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(213101, NULL, 'G3DSA:1.20.140.10:FF:000033', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(213102, NULL, 'G3DSA:2.30.29.30:FF:001110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213103, NULL, 'G3DSA:3.40.50.200:FF:000009', NULL, NULL, 'tripeptidyl-peptidase 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(213104, NULL, 'G3DSA:3.30.780.10:FF:000009', NULL, NULL, '39S ribosomal protein L49, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(213105, NULL, 'G3DSA:2.60.40.10:FF:004974', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213106, NULL, 'G3DSA:3.30.160.60:FF:001079', NULL, NULL, 'zinc finger protein ZFPM1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(213107, NULL, 'G3DSA:3.30.70.330:FF:000656', NULL, NULL, 'Nuclear transport factor 2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(213108, NULL, 'G3DSA:1.25.10.10:FF:002768', NULL, NULL, 'Exportin 6', NULL, NULL, NULL, NULL, NULL, 4),
(213109, NULL, 'G3DSA:2.100.10.50:FF:000002', NULL, NULL, 'Multivesicular body subunit 12B', NULL, NULL, NULL, NULL, NULL, 4),
(213110, NULL, 'G3DSA:3.30.420.10:FF:000640', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213111, NULL, 'G3DSA:3.30.230.40:FF:000011', NULL, NULL, 'Imidazoleglycerol-phosphate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(213112, NULL, 'G3DSA:3.90.660.10:FF:000094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213113, NULL, 'G3DSA:3.30.70.330:FF:002808', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213114, NULL, 'G3DSA:1.10.10.10:FF:001205', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(213115, NULL, 'G3DSA:3.30.470.10:FF:000025', NULL, NULL, '4-amino-4-deoxychorismate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(213116, NULL, 'G3DSA:2.60.110.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213117, NULL, 'G3DSA:3.30.160.60:FF:006300', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213118, NULL, 'G3DSA:1.20.1070.10:FF:000532', NULL, NULL, 'Odorant receptor S3', NULL, NULL, NULL, NULL, NULL, 4),
(213119, NULL, 'G3DSA:3.40.50.970:FF:000038', NULL, NULL, '2-hydroxyacyl-CoA lyase 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(213120, NULL, 'G3DSA:3.30.710.10:FF:000387', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213121, NULL, 'G3DSA:3.30.470.20:FF:000028', NULL, NULL, 'Methylcrotonoyl-CoA carboxylase subunit alpha, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(213122, NULL, 'G3DSA:4.10.1260.10:FF:000001', NULL, NULL, 'Internal scaffolding protein', NULL, NULL, NULL, NULL, NULL, 4),
(213123, NULL, 'G3DSA:3.30.420.40:FF:000958', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(213124, NULL, 'G3DSA:2.60.40.10:FF:003254', NULL, NULL, 'Nectin-1', NULL, NULL, NULL, NULL, NULL, 4),
(213125, NULL, 'G3DSA:3.30.70.330:FF:000347', NULL, NULL, 'Zinc finger CCCH domain-containing protein 40', NULL, NULL, NULL, NULL, NULL, 4),
(213126, NULL, 'G3DSA:3.40.50.300:FF:006947', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(213127, NULL, 'G3DSA:3.40.50.2000:FF:000296', NULL, NULL, 'Glucosyltransferase 3', NULL, NULL, NULL, NULL, NULL, 4),
(213128, NULL, 'G3DSA:3.30.710.10:FF:000078', NULL, NULL, 'BTB/POZ domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(213129, NULL, 'G3DSA:3.20.20.140:FF:000164', NULL, NULL, 'Amidohydrolase 2', NULL, NULL, NULL, NULL, NULL, 4),
(213130, NULL, 'G3DSA:2.60.40.10:FF:005715', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213131, NULL, 'G3DSA:1.20.1070.10:FF:000739', NULL, NULL, 'Growth hormone-releasing hormone receptor short isoform', NULL, NULL, NULL, NULL, NULL, 4),
(213132, NULL, 'G3DSA:3.40.50.620:FF:000473', NULL, NULL, 'Cytidylyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(213133, NULL, 'G3DSA:2.10.25.10:FF:000214', NULL, NULL, 'Multiple epidermal growth factor-like domains 8', NULL, NULL, NULL, NULL, NULL, 4),
(213134, NULL, 'G3DSA:3.30.70.141:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213135, NULL, 'G3DSA:3.40.1640.10:FF:000002', NULL, NULL, 'DUF1445 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(213136, NULL, 'G3DSA:1.25.40.320:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213137, NULL, 'G3DSA:2.60.40.60:FF:000211', NULL, NULL, 'Dachsous cadherin-related 2', NULL, NULL, NULL, NULL, NULL, 4),
(213138, NULL, 'G3DSA:3.80.10.10:FF:000540', NULL, NULL, 'Insulin-like growth factor-binding protein complex acid labile subunit', NULL, NULL, NULL, NULL, NULL, 4),
(213139, NULL, 'G3DSA:3.20.20.80:FF:000491', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(213140, NULL, 'G3DSA:1.10.132.30:FF:000005', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(213141, NULL, 'G3DSA:3.30.450.20:FF:000145', NULL, NULL, 'AGAP009664-PA', NULL, NULL, NULL, NULL, NULL, 4),
(213142, NULL, 'G3DSA:2.40.30.160:FF:000008', NULL, NULL, 'Aminomethyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(213143, NULL, 'G3DSA:1.10.287.810:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213144, NULL, 'G3DSA:3.60.40.10:FF:000059', NULL, NULL, 'Protein phosphatase 2C 32', NULL, NULL, NULL, NULL, NULL, 4),
(213145, NULL, 'G3DSA:2.10.25.10:FF:000523', NULL, NULL, 'Delta/notch like EGF repeat containing', NULL, NULL, NULL, NULL, NULL, 4),
(213146, NULL, 'G3DSA:3.10.290.10:FF:000004', NULL, NULL, '40s ribosomal protein s9', NULL, NULL, NULL, NULL, NULL, 4),
(213147, NULL, 'G3DSA:1.20.1740.10:FF:000049', NULL, NULL, 'Solute carrier family 12 (potassium/chloride transporter), member 4', NULL, NULL, NULL, NULL, NULL, 4),
(213148, NULL, 'G3DSA:1.20.1080.10:FF:000049', NULL, NULL, 'Aquaporin-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(213149, NULL, 'G3DSA:1.10.10.10:FF:001514', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(213150, NULL, 'G3DSA:1.10.10.10:FF:002003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213151, NULL, 'G3DSA:2.60.40.10:FF:003563', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213152, NULL, 'G3DSA:3.30.420.40:FF:000649', NULL, NULL, 'Chromatin remodeling complex subunit (Arp5), putative (AFU_orthologue AFUA_4G03020)', NULL, NULL, NULL, NULL, NULL, 4),
(213153, NULL, 'G3DSA:3.30.70.360:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213154, NULL, 'G3DSA:3.60.10.10:FF:000349', NULL, NULL, 'Os01g0814200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(213155, NULL, 'G3DSA:3.90.25.10:FF:000039', NULL, NULL, 'UDP-glucose 4-epimerase GalE', NULL, NULL, NULL, NULL, NULL, 4),
(213156, NULL, 'G3DSA:1.20.1250.20:FF:000841', NULL, NULL, 'Major facilitator superfamily domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(213157, NULL, 'G3DSA:1.50.40.10:FF:000502', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213158, NULL, 'G3DSA:1.10.510.10:FF:001339', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(213159, NULL, 'G3DSA:3.20.20.190:FF:000038', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(213160, NULL, 'G3DSA:3.40.50.360:FF:000052', NULL, NULL, 'NAD(P)H-dependent FMN reductase LOT6', NULL, NULL, NULL, NULL, NULL, 4),
(213161, NULL, 'G3DSA:2.170.300.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213162, NULL, 'G3DSA:3.30.1780.10:FF:000008', NULL, NULL, 'Ornithine cyclodeaminase', NULL, NULL, NULL, NULL, NULL, 4),
(213163, NULL, 'G3DSA:1.10.510.10:FF:001295', NULL, NULL, 'Serine/threonine-protein kinase kin-29', NULL, NULL, NULL, NULL, NULL, 4),
(213164, NULL, 'G3DSA:3.30.1360.40:FF:000031', NULL, NULL, 'Ribosome recycling factor', NULL, NULL, NULL, NULL, NULL, 4),
(213165, NULL, 'G3DSA:3.30.160.60:FF:005575', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213166, NULL, 'G3DSA:3.30.300.20:FF:000016', NULL, NULL, 'GTPase Era, mitochondrial isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(213167, NULL, 'G3DSA:3.40.390.10:FF:000264', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213168, NULL, 'G3DSA:3.50.50.60:FF:001137', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(213169, NULL, 'G3DSA:3.40.50.1820:FF:000707', NULL, NULL, 'AGAP002090-PA-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(213170, NULL, 'G3DSA:1.20.1440.100:FF:000002', NULL, NULL, 'HAD hydrolase, family IF', NULL, NULL, NULL, NULL, NULL, 4),
(213171, NULL, 'G3DSA:1.20.1070.10:FF:000094', NULL, NULL, 'Vasopressin V1a receptor', NULL, NULL, NULL, NULL, NULL, 4),
(213172, NULL, 'G3DSA:3.40.50.960:FF:000018', NULL, NULL, '6,7-dimethyl-8-ribityllumazine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(213173, NULL, 'G3DSA:3.30.300.30:FF:000019', NULL, NULL, 'Phenylacetate-coenzyme A ligase', NULL, NULL, NULL, NULL, NULL, 4),
(213174, NULL, 'G3DSA:1.25.40.20:FF:001643', NULL, NULL, 'E3 ubiquitin-protein ligase HOS1', NULL, NULL, NULL, NULL, NULL, 4),
(213175, NULL, 'G3DSA:3.30.710.10:FF:000516', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213176, NULL, 'G3DSA:1.25.40.10:FF:004866', NULL, NULL, 'Diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(213177, NULL, 'G3DSA:2.60.120.260:FF:000629', NULL, NULL, 'Endo-1,4-beta-xylanase', NULL, NULL, NULL, NULL, NULL, 4),
(213178, NULL, 'G3DSA:3.20.20.100:FF:000068', NULL, NULL, 'Aldo-keto reductase family 1 member B10', NULL, NULL, NULL, NULL, NULL, 4),
(213179, NULL, 'G3DSA:3.40.50.620:FF:000708', NULL, NULL, 'ExsB family protein', NULL, NULL, NULL, NULL, NULL, 4),
(213180, NULL, 'G3DSA:3.10.350.10:FF:000077', NULL, NULL, 'LysM peptidoglycan-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(213181, NULL, 'G3DSA:1.25.40.10:FF:001640', NULL, NULL, 'Pentatricopeptide repeat protein PPR986-12', NULL, NULL, NULL, NULL, NULL, 4),
(213182, NULL, 'G3DSA:3.90.530.10:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213183, NULL, 'G3DSA:3.40.718.10:FF:000037', NULL, NULL, 'CG3483 protein', NULL, NULL, NULL, NULL, NULL, 4),
(213184, NULL, 'G3DSA:3.30.300.10:FF:000013', NULL, NULL, 'GMP synthase (Glutamine-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4),
(213185, NULL, 'G3DSA:1.10.1520.10:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213186, NULL, 'G3DSA:3.30.465.10:FF:000058', NULL, NULL, 'Alkyldihydroxyacetonephosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(213187, NULL, 'G3DSA:4.10.410.20:FF:000014', NULL, NULL, 'Endoribonuclease-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(213188, NULL, 'G3DSA:3.30.70.660:FF:000086', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(213189, NULL, 'G3DSA:3.80.10.10:FF:004137', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(213190, NULL, 'G3DSA:3.40.50.2000:FF:000751', NULL, NULL, 'Protein CBR-UGT-2', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(213191, NULL, 'G3DSA:1.10.472.10:FF:000688', NULL, NULL, 'Os07g0504500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(213192, NULL, 'G3DSA:3.40.570.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213193, NULL, 'G3DSA:1.25.10.10:FF:000559', NULL, NULL, 'Msn5p', NULL, NULL, NULL, NULL, NULL, 4),
(213194, NULL, 'G3DSA:4.10.410.10:FF:000011', NULL, NULL, 'Tissue factor pathway inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(213195, NULL, 'G3DSA:1.20.5.110:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213196, NULL, 'G3DSA:2.30.30.140:FF:000140', NULL, NULL, 'MRG (Mortality factor-Related Gene) related', NULL, NULL, NULL, NULL, NULL, 4),
(213197, NULL, 'G3DSA:3.30.70.330:FF:002781', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213198, NULL, 'G3DSA:2.60.260.20:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213199, NULL, 'G3DSA:3.10.50.40:FF:000071', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(213200, NULL, 'G3DSA:3.40.50.300:FF:003367', NULL, NULL, 'ATP-dependent DNA helicase PIF1', NULL, NULL, NULL, NULL, NULL, 4),
(213201, NULL, 'G3DSA:3.30.70.1730:FF:000048', NULL, NULL, '50S ribosomal protein L10', NULL, NULL, NULL, NULL, NULL, 4),
(213202, NULL, 'G3DSA:3.30.70.330:FF:001145', NULL, NULL, 'AGAP009570-PA', NULL, NULL, NULL, NULL, NULL, 4),
(213203, NULL, 'G3DSA:3.40.50.720:FF:000755', NULL, NULL, 'F420-dependent NADP reductase', NULL, NULL, NULL, NULL, NULL, 4),
(213204, NULL, 'G3DSA:1.10.1040.10:FF:000072', NULL, NULL, '2-hydroxy-3-oxopropionate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(213205, NULL, 'G3DSA:3.40.50.1220:FF:000062', NULL, NULL, 'NAD-dependent deacetylase sir2E', NULL, NULL, NULL, NULL, NULL, 4),
(213206, NULL, 'G3DSA:3.90.1750.20:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213207, NULL, 'G3DSA:1.25.40.10:FF:001213', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(213208, NULL, 'G3DSA:1.25.40.20:FF:000215', NULL, NULL, 'ankyrin repeat domain-containing protein 49', NULL, NULL, NULL, NULL, NULL, 4),
(213209, NULL, 'G3DSA:1.25.10.10:FF:001812', NULL, NULL, 'DnaJ-like protein subfamily C member 13', NULL, NULL, NULL, NULL, NULL, 4),
(213210, NULL, 'G3DSA:1.25.40.710:FF:000002', NULL, NULL, 'Tripeptidyl-peptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(213211, NULL, 'G3DSA:3.40.50.300:FF:005621', NULL, NULL, 'YALI0A04279p', NULL, NULL, NULL, NULL, NULL, 4),
(213212, NULL, 'G3DSA:3.30.160.60:FF:004968', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213213, NULL, 'G3DSA:3.40.190.10:FF:000962', NULL, NULL, 'Glutamate receptor, ionotropic, delta 1a', NULL, NULL, NULL, NULL, NULL, 4),
(213214, NULL, 'G3DSA:1.10.2000.10:FF:000007', NULL, NULL, 'Frizzled class receptor 10', NULL, NULL, NULL, NULL, NULL, 4),
(213215, NULL, 'G3DSA:2.30.29.30:FF:001301', NULL, NULL, 'ESCRT-II subunit protein', NULL, NULL, NULL, NULL, NULL, 4),
(213216, NULL, 'G3DSA:3.40.605.10:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213217, NULL, 'G3DSA:1.20.58.90:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213218, NULL, 'G3DSA:1.10.287.70:FF:000292', NULL, NULL, 'Calcium transporter 2', NULL, NULL, NULL, NULL, NULL, 4),
(213219, NULL, 'G3DSA:3.40.50.1260:FF:000023', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(213220, NULL, 'G3DSA:2.60.120.290:FF:000161', NULL, NULL, 'Cubilin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(213221, NULL, 'G3DSA:3.60.40.10:FF:000385', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213222, NULL, 'G3DSA:3.40.50.150:FF:000899', NULL, NULL, 'tRNA (guanine(37)-N1)/4-demethylwyosine(37)-methyltransferase Taw22', NULL, NULL, NULL, NULL, NULL, 4),
(213223, NULL, 'G3DSA:3.60.15.10:FF:000237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213224, NULL, 'G3DSA:2.60.40.10:FF:001972', NULL, NULL, 'Fibronectin type III domain containing 3Ba', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(213225, NULL, 'G3DSA:3.40.30.10:FF:000430', NULL, NULL, 'Disulfide oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(213226, NULL, 'G3DSA:1.25.40.420:FF:000022', NULL, NULL, 'Calicin', NULL, NULL, NULL, NULL, NULL, 4),
(213227, NULL, 'G3DSA:2.70.98.30:FF:000003', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(213228, NULL, 'G3DSA:3.40.50.300:FF:003266', NULL, NULL, 'Guanylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(213229, NULL, 'G3DSA:3.40.1110.10:FF:000344', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213230, NULL, 'G3DSA:3.10.100.10:FF:000368', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213231, NULL, 'G3DSA:1.10.720.30:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213232, NULL, 'G3DSA:2.30.42.10:FF:000562', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213233, NULL, 'G3DSA:3.30.40.10:FF:002264', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(213234, NULL, 'G3DSA:1.20.5.900:FF:000001', NULL, NULL, 'T-cell surface glycoprotein CD4', NULL, NULL, NULL, NULL, NULL, 4),
(213235, NULL, 'G3DSA:2.60.40.10:FF:002866', NULL, NULL, 'Si:dkey-102c8.2', NULL, NULL, NULL, NULL, NULL, 4),
(213236, NULL, 'G3DSA:3.30.40.10:FF:001600', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213237, NULL, 'G3DSA:1.10.640.10:FF:000017', NULL, NULL, 'Double peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(213238, NULL, 'G3DSA:3.30.1520.10:FF:000119', NULL, NULL, 'Probable serine/threonine-protein kinase DDB_G0272282', NULL, NULL, NULL, NULL, NULL, 4),
(213239, NULL, 'G3DSA:3.40.50.1820:FF:000562', NULL, NULL, 'Surfactin synthase thioesterase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(213240, NULL, 'G3DSA:2.70.98.40:FF:000006', NULL, NULL, 'Cellobionic acid phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(213241, NULL, 'G3DSA:3.90.199.10:FF:000004', NULL, NULL, 'DNA topoisomerase II medium subunit', NULL, NULL, NULL, NULL, NULL, 4),
(213242, NULL, 'G3DSA:1.20.120.1080:FF:000055', NULL, NULL, 'ATP-dependent helicase HrpB', NULL, NULL, NULL, NULL, NULL, 4),
(213243, NULL, 'G3DSA:3.30.160.60:FF:005474', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213244, NULL, 'G3DSA:1.25.40.10:FF:003337', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(213245, NULL, 'G3DSA:1.10.196.10:FF:000001', NULL, NULL, 'Regulator of G-protein signaling 8', NULL, NULL, NULL, NULL, NULL, 4),
(213246, NULL, 'G3DSA:1.25.40.10:FF:004765', NULL, NULL, 'Os12g0557800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(213247, NULL, 'G3DSA:3.90.190.10:FF:000041', NULL, NULL, 'phosphatidylinositol phosphatase PTPRQ isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(213248, NULL, 'G3DSA:2.60.40.10:FF:001438', NULL, NULL, 'Immunoglobulin-like and fibronectin type III domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(213249, NULL, 'G3DSA:3.30.40.10:FF:000656', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213250, NULL, 'G3DSA:1.20.91.20:FF:000012', NULL, NULL, 'Complement component 4A (Rodgers blood group)', NULL, NULL, NULL, NULL, NULL, 4),
(213251, NULL, 'G3DSA:2.130.10.10:FF:001950', NULL, NULL, 'Os01g0605400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(213252, NULL, 'G3DSA:3.40.50.2300:FF:000088', NULL, NULL, 'Ribose operon repressor', NULL, NULL, NULL, NULL, NULL, 4),
(213253, NULL, 'G3DSA:1.20.5.170:FF:000170', NULL, NULL, 'GM14169p', NULL, NULL, NULL, NULL, NULL, 4),
(213254, NULL, 'G3DSA:3.20.10.10:FF:000014', NULL, NULL, 'Branched-chain-amino-acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(213255, NULL, 'G3DSA:3.40.50.300:FF:001922', NULL, NULL, 'DEAH (Asp-Glu-Ala-His) box polypeptide 29', NULL, NULL, NULL, NULL, NULL, 4),
(213256, NULL, 'G3DSA:3.40.390.10:FF:000163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213257, NULL, 'G3DSA:1.20.1270.280:FF:000011', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(213258, NULL, 'G3DSA:3.30.70.100:FF:000042', NULL, NULL, 'Copper chaperone for superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(213259, NULL, 'G3DSA:1.10.8.10:FF:000237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213260, NULL, 'G3DSA:3.30.160.60:FF:005783', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213261, NULL, 'G3DSA:3.90.640.10:FF:000194', NULL, NULL, 'Actin-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(213262, NULL, 'G3DSA:1.10.510.10:FF:001087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213263, NULL, 'G3DSA:1.20.920.10:FF:000216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213264, NULL, 'G3DSA:3.30.70.330:FF:000791', NULL, NULL, 'Peroxisome proliferator-activated receptor gamma coactivator 1-beta isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(213265, NULL, 'G3DSA:2.30.30.140:FF:000241', NULL, NULL, 'AGAP001019-PA', NULL, NULL, NULL, NULL, NULL, 4),
(213266, NULL, 'G3DSA:1.10.472.80:FF:000017', NULL, NULL, 'TBC1 domain family member 23', NULL, NULL, NULL, NULL, NULL, 4),
(213267, NULL, 'G3DSA:3.40.50.300:FF:003619', NULL, NULL, 'OLA1 isoform 9', NULL, NULL, NULL, NULL, NULL, 4),
(213268, NULL, 'G3DSA:1.25.40.10:FF:003085', NULL, NULL, 'Tetratricopeptide repeat domain 21A', NULL, NULL, NULL, NULL, NULL, 4),
(213269, NULL, 'G3DSA:3.30.70.120:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213270, NULL, 'G3DSA:2.70.160.11:FF:000026', NULL, NULL, 'Unplaced genomic scaffold supercont1.163, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(213271, NULL, 'G3DSA:3.30.420.10:FF:000505', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213272, NULL, 'G3DSA:3.40.710.10:FF:000025', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase DacA', NULL, NULL, NULL, NULL, NULL, 4),
(213273, NULL, 'G3DSA:3.30.1490.20:FF:000012', NULL, NULL, 'Biotin carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(213274, NULL, 'G3DSA:1.20.59.10:FF:000013', NULL, NULL, 'Chorismate mutase I', NULL, NULL, NULL, NULL, NULL, 4),
(213275, NULL, 'G3DSA:1.20.1420.30:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213276, NULL, 'G3DSA:3.40.50.150:FF:001641', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213277, NULL, 'G3DSA:3.40.50.10490:FF:000071', NULL, NULL, 'Glucose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(213278, NULL, 'G3DSA:1.20.1050.10:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213279, NULL, 'G3DSA:3.60.40.10:FF:000076', NULL, NULL, 'Phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(213280, NULL, 'G3DSA:1.20.1560.10:FF:000485', NULL, NULL, 'Lipid A export ATP-binding/permease protein MsbA', NULL, NULL, NULL, NULL, NULL, 4),
(213281, NULL, 'G3DSA:3.40.50.300:FF:000995', NULL, NULL, 'RAB5B, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(213282, NULL, 'G3DSA:1.20.120.1810:FF:000004', NULL, NULL, 'RNA polymerase sigma-H factor SigH', NULL, NULL, NULL, NULL, NULL, 4),
(213283, NULL, 'G3DSA:3.30.70.260:FF:000157', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(213284, NULL, 'G3DSA:2.60.40.10:FF:005362', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213285, NULL, 'G3DSA:2.30.29.30:FF:000475', NULL, NULL, 'AGC/RSK/RSKP90 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(213286, NULL, 'G3DSA:2.130.10.10:FF:004867', NULL, NULL, 'WD40-repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(213287, NULL, 'G3DSA:1.25.10.10:FF:001503', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(213288, NULL, 'G3DSA:3.30.40.10:FF:000920', NULL, NULL, 'Putative RING-H2 finger protein ATL12', NULL, NULL, NULL, NULL, NULL, 4),
(213289, NULL, 'G3DSA:1.20.5.110:FF:000303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213290, NULL, 'G3DSA:3.20.70.20:FF:000026', NULL, NULL, 'Vitamin B12-dependent ribonucleotide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(213291, NULL, 'G3DSA:3.30.70.330:FF:003062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213292, NULL, 'G3DSA:3.30.70.1230:FF:000140', NULL, NULL, 'Ca(2+)/calmodulin-responsive adenylate cyclase-like Protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(213293, NULL, 'G3DSA:3.40.50.720:FF:000547', NULL, NULL, 'Ast1p', NULL, NULL, NULL, NULL, NULL, 4),
(213294, NULL, 'G3DSA:1.25.40.770:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213295, NULL, 'G3DSA:2.60.40.10:FF:003580', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213296, NULL, 'G3DSA:1.10.287.1260:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213297, NULL, 'G3DSA:2.30.30.870:FF:000004', NULL, NULL, 'Protein DOM34 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(213298, NULL, 'G3DSA:3.80.10.10:FF:001012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213299, NULL, 'G3DSA:1.25.10.10:FF:003482', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(213300, NULL, 'G3DSA:3.40.50.300:FF:003058', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(213301, NULL, 'G3DSA:3.80.10.10:FF:000394', NULL, NULL, 'Dynein assembly factor 1, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(213302, NULL, 'G3DSA:3.40.1160.10:FF:000072', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(213303, NULL, 'G3DSA:3.40.50.720:FF:000856', NULL, NULL, 'Phthiocerol synthesis polyketide synthase type I PpsD', NULL, NULL, NULL, NULL, NULL, 4),
(213304, NULL, 'G3DSA:3.40.720.10:FF:000262', NULL, NULL, 'Phosphonate monoester hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(213305, NULL, 'G3DSA:3.40.50.300:FF:007419', NULL, NULL, 'QUInine non-avoider', NULL, NULL, NULL, NULL, NULL, 4),
(213306, NULL, 'G3DSA:3.40.50.410:FF:000117', NULL, NULL, 'Protein CBR-TAG-180', NULL, NULL, NULL, NULL, NULL, 4),
(213307, NULL, 'G3DSA:3.30.230.10:FF:000159', NULL, NULL, 'Elongation factor 2-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(213308, NULL, 'G3DSA:1.10.510.10:FF:003341', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213309, NULL, 'G3DSA:3.40.1110.10:FF:000136', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(213310, NULL, 'G3DSA:1.10.510.10:FF:001648', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(213311, NULL, 'G3DSA:3.90.180.10:FF:000175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213312, NULL, 'G3DSA:1.25.40.10:FF:001522', NULL, NULL, 'Penicillin-binding protein activator', NULL, NULL, NULL, NULL, NULL, 4),
(213313, NULL, 'G3DSA:1.10.10.10:FF:001059', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(213314, NULL, 'G3DSA:3.30.930.10:FF:000027', NULL, NULL, 'Serine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(213315, NULL, 'G3DSA:3.40.50.10580:FF:000007', NULL, NULL, 'VATPase', NULL, NULL, NULL, NULL, NULL, 4),
(213316, NULL, 'G3DSA:3.30.450.20:FF:000600', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(213317, NULL, 'G3DSA:3.60.15.10:FF:000029', NULL, NULL, 'Cyclic nucleotide-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(213318, NULL, 'G3DSA:2.40.50.140:FF:000759', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213319, NULL, 'G3DSA:2.30.30.790:FF:000014', NULL, NULL, 'Unplaced genomic scaffold supercont2.18, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(213320, NULL, 'G3DSA:3.30.160.60:FF:005266', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213321, NULL, 'G3DSA:2.30.42.10:FF:000461', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213322, NULL, 'G3DSA:1.20.1250.20:FF:002078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213323, NULL, 'G3DSA:2.130.10.10:FF:001742', NULL, NULL, 'SeMaPhorin related', NULL, NULL, NULL, NULL, NULL, 4),
(213324, NULL, 'G3DSA:1.10.630.10:FF:000741', NULL, NULL, 'Cytochrome P450 monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(213325, NULL, 'G3DSA:3.40.50.2000:FF:000442', NULL, NULL, 'Dorothy, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(213326, NULL, 'G3DSA:1.10.472.10:FF:000379', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(213327, NULL, 'G3DSA:1.10.472.80:FF:000225', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213328, NULL, 'G3DSA:3.60.20.10:FF:000070', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(213329, NULL, 'G3DSA:3.80.10.10:FF:000085', NULL, NULL, 'protein zer-1 homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(213330, NULL, 'G3DSA:3.30.300.160:FF:000017', NULL, NULL, 'Type II secretory pathway, ATPase PulE', NULL, NULL, NULL, NULL, NULL, 4),
(213331, NULL, 'G3DSA:3.30.200.20:FF:000880', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(213332, NULL, 'G3DSA:3.40.50.2000:FF:000958', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213333, NULL, 'G3DSA:3.40.50.300:FF:007970', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(213334, NULL, 'G3DSA:3.20.20.140:FF:000029', NULL, NULL, '2-amino-3-carboxymuconate-6-semialdehyde decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(213335, NULL, 'G3DSA:3.90.190.10:FF:000147', NULL, NULL, 'Protein-tyrosine-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(213336, NULL, 'G3DSA:1.10.510.10:FF:003902', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213337, NULL, 'G3DSA:3.30.160.60:FF:002040', NULL, NULL, 'zinc finger protein 70', NULL, NULL, NULL, NULL, NULL, 4),
(213338, NULL, 'G3DSA:3.30.160.60:FF:000140', NULL, NULL, 'Tripartite motif containing 55', NULL, NULL, NULL, NULL, NULL, 4),
(213339, NULL, 'G3DSA:1.25.10.10:FF:002577', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213340, NULL, 'G3DSA:1.10.8.10:FF:000029', NULL, NULL, 'Serine/threonine-protein kinase LATS1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(213341, NULL, 'G3DSA:2.60.220.50:FF:000044', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(213342, NULL, 'G3DSA:2.60.40.10:FF:003119', NULL, NULL, 'AGAP003610-PA', NULL, NULL, NULL, NULL, NULL, 4),
(213343, NULL, 'G3DSA:1.10.287.130:FF:000029', NULL, NULL, 'Phytochrome', NULL, NULL, NULL, NULL, NULL, 4),
(213344, NULL, 'G3DSA:2.10.70.10:FF:000144', NULL, NULL, 'Blast:Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(213345, NULL, 'G3DSA:3.30.200.20:FF:001133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213346, NULL, 'G3DSA:3.30.160.20:FF:000235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213347, NULL, 'G3DSA:1.25.40.10:FF:001331', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(213348, NULL, 'G3DSA:1.50.10.10:FF:000113', NULL, NULL, 'Endoglucanase', NULL, NULL, NULL, NULL, NULL, 4),
(213349, NULL, 'G3DSA:1.10.287.130:FF:000271', NULL, NULL, 'Sensor histidine kinase, PAS domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(213350, NULL, 'G3DSA:1.20.1560.10:FF:000277', NULL, NULL, 'WGS project CABT00000000 data, contig 2.12', NULL, NULL, NULL, NULL, NULL, 4),
(213351, NULL, 'G3DSA:2.60.40.10:FF:005019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213352, NULL, 'G3DSA:3.60.21.50:FF:000010', NULL, NULL, 'DNA polymerase epsilon subunit', NULL, NULL, NULL, NULL, NULL, 4),
(213353, NULL, 'G3DSA:1.10.10.60:FF:001276', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213354, NULL, 'G3DSA:1.50.10.20:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213355, NULL, 'G3DSA:1.10.510.10:FF:003357', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213356, NULL, 'G3DSA:3.90.245.10:FF:000005', NULL, NULL, 'Inosine-uridine preferring nucleoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(213357, NULL, 'G3DSA:4.10.470.10:FF:000003', NULL, NULL, 'Ribosome-inactivating protein PMRIPt', NULL, NULL, NULL, NULL, NULL, 4),
(213358, NULL, 'G3DSA:3.40.1170.60:FF:000020', NULL, NULL, 'DNA repair protein REV1', NULL, NULL, NULL, NULL, NULL, 4),
(213359, NULL, 'G3DSA:4.10.400.10:FF:000201', NULL, NULL, 'Serine protease nudel', NULL, NULL, NULL, NULL, NULL, 4),
(213360, NULL, 'G3DSA:1.25.40.10:FF:003231', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g21065', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(213361, NULL, 'G3DSA:3.30.450.20:FF:000336', NULL, NULL, 'Protein_kinase_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(213362, NULL, 'G3DSA:1.20.5.110:FF:000157', NULL, NULL, 't-SNARE protein aex-4', NULL, NULL, NULL, NULL, NULL, 4),
(213363, NULL, 'G3DSA:1.10.287.110:FF:000023', NULL, NULL, 'Sacsin molecular chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(213364, NULL, 'G3DSA:3.40.50.410:FF:000073', NULL, NULL, 'ATP-dependent DNA helicase II subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(213365, NULL, 'G3DSA:2.40.50.140:FF:000905', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213366, NULL, 'G3DSA:3.30.40.10:FF:000774', NULL, NULL, 'E3 ubiquitin-protein ligase SINAT3', NULL, NULL, NULL, NULL, NULL, 4),
(213367, NULL, 'G3DSA:4.10.470.20:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213368, NULL, 'G3DSA:4.10.1060.10:FF:000020', NULL, NULL, 'ranBP2-type zinc finger protein At1g67325-like', NULL, NULL, NULL, NULL, NULL, 4),
(213369, NULL, 'G3DSA:2.30.29.30:FF:000166', NULL, NULL, 'GRB2-associated-binding protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(213370, NULL, 'G3DSA:3.40.1110.10:FF:000035', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(213371, NULL, 'G3DSA:3.60.10.10:FF:000142', NULL, NULL, 'DNA-(apurinic or apyrimidinic site) lyase', NULL, NULL, NULL, NULL, NULL, 4),
(213372, NULL, 'G3DSA:1.20.1560.10:FF:000631', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213373, NULL, 'G3DSA:1.10.225.10:FF:000007', NULL, NULL, 'Canopy 2 homolog (Zebrafish)', NULL, NULL, NULL, NULL, NULL, 4),
(213374, NULL, 'G3DSA:1.20.1560.10:FF:000176', NULL, NULL, 'ATP-binding cassette bilirubin transporter', NULL, NULL, NULL, NULL, NULL, 4),
(213375, NULL, 'G3DSA:1.10.10.10:FF:001177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213376, NULL, 'G3DSA:3.30.360.20:FF:000008', NULL, NULL, 'RNA 3''-terminal phosphate cyclase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(213377, NULL, 'G3DSA:3.30.230.10:FF:000362', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213378, NULL, 'G3DSA:1.10.10.10:FF:001323', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(213379, NULL, 'G3DSA:2.160.20.10:FF:000258', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(213380, NULL, 'G3DSA:1.20.1270.10:FF:000075', NULL, NULL, 'Luminal binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(213381, NULL, 'G3DSA:3.40.50.2000:FF:000178', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(213382, NULL, 'G3DSA:3.40.50.1360:FF:000053', NULL, NULL, 'Glucosamine-6-phosphate isomerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(213383, NULL, 'G3DSA:2.130.10.10:FF:003187', NULL, NULL, 'WD repeat-containing protein 38', NULL, NULL, NULL, NULL, NULL, 4),
(213384, NULL, 'G3DSA:3.30.413.10:FF:000039', NULL, NULL, 'Sulfite reductase [NADPH] subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(213385, NULL, 'G3DSA:3.30.30.30:FF:000032', NULL, NULL, 'Actin-like ATPase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(213386, NULL, 'G3DSA:3.40.50.300:FF:001158', NULL, NULL, 'Phage terminase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(213387, NULL, 'G3DSA:3.60.110.10:FF:000071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213388, NULL, 'G3DSA:1.10.10.250:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213389, NULL, 'G3DSA:3.80.10.10:FF:002456', NULL, NULL, 'Paraflagellar rod component, putative', NULL, NULL, NULL, NULL, NULL, 4),
(213390, NULL, 'G3DSA:4.10.780.10:FF:000004', NULL, NULL, 'Pyruvate-flavoredoxin oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(213391, NULL, 'G3DSA:3.40.50.2000:FF:000088', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(213392, NULL, 'G3DSA:1.25.40.70:FF:000005', NULL, NULL, 'Phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(213393, NULL, 'G3DSA:3.40.50.300:FF:005727', NULL, NULL, 'Similar to type IV pilus assembly protein TapB', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(213394, NULL, 'G3DSA:3.30.980.10:FF:000007', NULL, NULL, 'alanyl-tRNA editing protein Aarsd1', NULL, NULL, NULL, NULL, NULL, 4),
(213395, NULL, 'G3DSA:2.30.30.1020:FF:000004', NULL, NULL, 'probable NOT transcription complex subunit VIP2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(213396, NULL, 'G3DSA:3.40.50.620:FF:000826', NULL, NULL, 'Tryptophan--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(213397, NULL, 'G3DSA:3.40.367.20:FF:000005', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(213398, NULL, 'G3DSA:1.25.40.80:FF:000008', NULL, NULL, 'Cryptochrome-1', NULL, NULL, NULL, NULL, NULL, 4),
(213399, NULL, 'G3DSA:2.10.25.10:FF:000006', NULL, NULL, 'Versican core protein-like isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(213400, NULL, 'G3DSA:3.40.50.1110:FF:000028', NULL, NULL, 'GDSL family lipase', NULL, NULL, NULL, NULL, NULL, 4),
(213401, NULL, 'G3DSA:2.130.10.10:FF:001641', NULL, NULL, 'Ribosome biogenesis protein WDR12 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(213402, NULL, 'G3DSA:3.60.21.60:FF:000013', NULL, NULL, 'DNA polymerase alpha/epsilon subunit B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(213403, NULL, 'G3DSA:3.40.50.300:FF:003928', NULL, NULL, 'Telomere length regulation protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(213404, NULL, 'G3DSA:2.60.40.150:FF:000756', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213405, NULL, 'G3DSA:3.30.470.20:FF:000236', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(213406, NULL, 'G3DSA:3.40.50.300:FF:003412', NULL, NULL, 'Bifunctional helicase and thymine dioxygenase JBP2', NULL, NULL, NULL, NULL, NULL, 4),
(213407, NULL, 'G3DSA:2.60.120.10:FF:000081', NULL, NULL, 'Pirin', NULL, NULL, NULL, NULL, NULL, 4),
(213408, NULL, 'G3DSA:3.30.1490.120:FF:000011', NULL, NULL, 'DNA-directed RNA polymerase III subunit 22.9 kDa polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(213409, NULL, 'G3DSA:2.60.120.200:FF:000218', NULL, NULL, 'Protein eyes shut homolog', NULL, NULL, NULL, NULL, NULL, 4),
(213410, NULL, 'G3DSA:1.20.5.170:FF:000259', NULL, NULL, 'Mitotic spindle assembly checkpoint protein MAD1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(213411, NULL, 'G3DSA:2.30.42.10:FF:000253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213412, NULL, 'G3DSA:1.20.900.10:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213413, NULL, 'G3DSA:3.30.930.10:FF:000370', NULL, NULL, 'Glycine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(213414, NULL, 'G3DSA:3.40.50.12780:FF:000156', NULL, NULL, 'Nonribosomal peptide synthase nlsA', NULL, NULL, NULL, NULL, NULL, 4),
(213415, NULL, 'G3DSA:2.40.160.180:FF:000005', NULL, NULL, 'Porin', NULL, NULL, NULL, NULL, NULL, 4),
(213416, NULL, 'G3DSA:3.40.50.1370:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213417, NULL, 'G3DSA:1.20.920.10:FF:000008', NULL, NULL, 'Bromodomain and WD repeat domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(213418, NULL, 'G3DSA:3.90.25.10:FF:000023', NULL, NULL, 'UDP-glucose 4-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(213419, NULL, 'G3DSA:1.25.40.10:FF:005119', NULL, NULL, 'Chaperone protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(213420, NULL, 'G3DSA:1.25.10.10:FF:001239', NULL, NULL, 'CLIP-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(213421, NULL, 'G3DSA:1.25.40.20:FF:001334', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213422, NULL, 'G3DSA:3.40.50.2300:FF:000650', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(213423, NULL, 'G3DSA:1.10.287.70:FF:000174', NULL, NULL, 'KCNN (Potassium K ChaNNel, calcium activated)-Like', NULL, NULL, NULL, NULL, NULL, 4),
(213424, NULL, 'G3DSA:3.80.10.10:FF:004255', NULL, NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase At2g25790', NULL, NULL, NULL, NULL, NULL, 4),
(213425, NULL, 'G3DSA:1.25.40.820:FF:000035', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(213426, NULL, 'G3DSA:3.10.580.10:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213427, NULL, 'G3DSA:1.25.40.10:FF:003129', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(213428, NULL, 'G3DSA:1.20.1310.20:FF:000003', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(213429, NULL, 'G3DSA:3.40.50.10330:FF:000062', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(213430, NULL, 'G3DSA:3.40.50.1820:FF:000045', NULL, NULL, 'Pimeloyl-[acyl-carrier protein] methyl ester esterase', NULL, NULL, NULL, NULL, NULL, 4),
(213431, NULL, 'G3DSA:1.25.40.10:FF:001067', NULL, NULL, 'Programmed cell death protein pre-rrna processing protein rrp5', NULL, NULL, NULL, NULL, NULL, 4),
(213432, NULL, 'G3DSA:3.40.50.300:FF:007318', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(213433, NULL, 'G3DSA:1.10.1740.10:FF:000001', NULL, NULL, 'RNA polymerase sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(213434, NULL, 'G3DSA:3.40.50.300:FF:001719', NULL, NULL, 'Torsin', NULL, NULL, NULL, NULL, NULL, 4),
(213435, NULL, 'G3DSA:3.60.120.10:FF:000009', NULL, NULL, 'Para-aminobenzoate synthase PabaA', NULL, NULL, NULL, NULL, NULL, 4),
(213436, NULL, 'G3DSA:1.20.58.2070:FF:000001', NULL, NULL, 'Spindle checkpoint complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(213437, NULL, 'G3DSA:1.10.4080.10:FF:000001', NULL, NULL, 'ADP-ribose glycohydrolase ARH3', NULL, NULL, NULL, NULL, NULL, 4),
(213438, NULL, 'G3DSA:2.130.10.10:FF:005441', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213439, NULL, 'G3DSA:2.160.20.20:FF:000002', NULL, NULL, 'Tail spike protein', NULL, NULL, NULL, NULL, NULL, 4),
(213440, NULL, 'G3DSA:1.10.3450.40:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213441, NULL, 'G3DSA:3.40.50.1970:FF:000039', NULL, NULL, 'Phosphoribosylaminoimidazole carboxylase family protein / AIR carboxylase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(213442, NULL, 'G3DSA:3.50.50.60:FF:000974', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(213443, NULL, 'G3DSA:2.30.30.140:FF:000038', NULL, NULL, 'Survival of motor neuron-related-splicing factor 30', NULL, NULL, NULL, NULL, NULL, 4),
(213444, NULL, 'G3DSA:3.40.50.10190:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213445, NULL, 'G3DSA:1.10.287.70:FF:000483', NULL, NULL, 'Two pore potassium channel protein sup-9', NULL, NULL, NULL, NULL, NULL, 4),
(213446, NULL, 'G3DSA:1.20.5.170:FF:000052', NULL, NULL, 'GDP-mannose 6-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(213447, NULL, 'G3DSA:2.130.10.10:FF:003541', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213448, NULL, 'G3DSA:2.60.120.330:FF:000100', NULL, NULL, 'Os09g0353400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(213449, NULL, 'G3DSA:3.30.200.20:FF:001043', NULL, NULL, 'Alpha-protein kinase vwkA', NULL, NULL, NULL, NULL, NULL, 4),
(213450, NULL, 'G3DSA:1.25.40.370:FF:000001', NULL, NULL, 'Apoptotic protease-activating factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(213451, NULL, 'G3DSA:1.10.357.140:FF:000021', NULL, NULL, '1,4-dihydroxy-2-naphthoate octaprenyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(213452, NULL, 'G3DSA:1.20.1540.10:FF:000068', NULL, NULL, 'Peptidase, S54 (Rhomboid) family', NULL, NULL, NULL, NULL, NULL, 4),
(213453, NULL, 'G3DSA:1.10.1080.10:FF:000001', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(213454, NULL, 'G3DSA:1.20.1280.50:FF:000211', NULL, NULL, 'Cyclin-F', NULL, NULL, NULL, NULL, NULL, 4),
(213455, NULL, 'G3DSA:1.10.510.10:FF:003447', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213456, NULL, 'G3DSA:3.40.50.12600:FF:000001', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(213457, NULL, 'G3DSA:3.30.420.40:FF:000767', NULL, NULL, 'Heat shock protein 70 (HSP70)-4, putative', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(213458, NULL, 'G3DSA:1.20.58.340:FF:000012', NULL, NULL, 'Magnesium transport protein CorA', NULL, NULL, NULL, NULL, NULL, 4),
(213459, NULL, 'G3DSA:2.60.40.1530:FF:000021', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(213460, NULL, 'G3DSA:2.60.40.10:FF:003681', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213461, NULL, 'G3DSA:3.30.70.330:FF:001044', NULL, NULL, 'RNA binding protein Rnp24, putative', NULL, NULL, NULL, NULL, NULL, 4),
(213462, NULL, 'G3DSA:3.40.50.1820:FF:000915', NULL, NULL, 'Prolylcarboxypeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(213463, NULL, 'G3DSA:1.10.8.10:FF:000131', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(213464, NULL, 'G3DSA:1.10.630.10:FF:000640', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213465, NULL, 'G3DSA:3.40.50.300:FF:007009', NULL, NULL, 'Elongator complex protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(213466, NULL, 'G3DSA:2.40.50.140:FF:000653', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213467, NULL, 'G3DSA:1.10.4160.10:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213468, NULL, 'G3DSA:3.40.190.10:FF:000619', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213469, NULL, 'G3DSA:2.130.10.10:FF:005132', NULL, NULL, 'WD repeat-containing protein 19-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(213470, NULL, 'G3DSA:3.20.20.380:FF:000005', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(213471, NULL, 'G3DSA:3.40.1620.60:FF:000010', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(213472, NULL, 'G3DSA:1.25.40.10:FF:005029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213473, NULL, 'G3DSA:3.30.450.20:FF:000027', NULL, NULL, 'Nuclear receptor coactivator 3', NULL, NULL, NULL, NULL, NULL, 4),
(213474, NULL, 'G3DSA:3.30.470.20:FF:000146', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(213475, NULL, 'G3DSA:1.10.10.10:FF:001632', NULL, NULL, 'Transcriptional regulator, ArsR family', NULL, NULL, NULL, NULL, NULL, 4),
(213476, NULL, 'G3DSA:2.60.120.650:FF:000078', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(213477, NULL, 'G3DSA:1.20.120.850:FF:000024', NULL, NULL, 'Helicase ssl-1', NULL, NULL, NULL, NULL, NULL, 4),
(213478, NULL, 'G3DSA:1.20.1250.20:FF:000633', NULL, NULL, 'Staphyloferrin B transporter', NULL, NULL, NULL, NULL, NULL, 4),
(213479, NULL, 'G3DSA:3.30.40.10:FF:000465', NULL, NULL, 'Increased DNA methylation 1', NULL, NULL, NULL, NULL, NULL, 4),
(213480, NULL, 'G3DSA:1.20.1250.20:FF:000279', NULL, NULL, 'Major facilitator superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(213481, NULL, 'G3DSA:3.10.270.10:FF:000003', NULL, NULL, 'Uricase', NULL, NULL, NULL, NULL, NULL, 4),
(213482, NULL, 'G3DSA:3.40.50.720:FF:002094', NULL, NULL, 'Estradiol 17-beta-dehydrogenase 8', NULL, NULL, NULL, NULL, NULL, 4),
(213483, NULL, 'G3DSA:3.30.300.110:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213484, NULL, 'G3DSA:1.10.10.160:FF:000032', NULL, NULL, 'ATP-dependent DNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(213485, NULL, 'G3DSA:2.60.40.1280:FF:000002', NULL, NULL, 'Clumping factor A', NULL, NULL, NULL, NULL, NULL, 4),
(213486, NULL, 'G3DSA:3.90.1150.10:FF:000526', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213487, NULL, 'G3DSA:1.25.40.180:FF:000034', NULL, NULL, 'Eukaryotic translation initiation factor 4G', NULL, NULL, NULL, NULL, NULL, 4),
(213488, NULL, 'G3DSA:1.20.5.1230:FF:000002', NULL, NULL, 'Apolipoprotein E', NULL, NULL, NULL, NULL, NULL, 4),
(213489, NULL, 'G3DSA:1.25.40.10:FF:001286', NULL, NULL, 'Tetratricopeptide repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(213490, NULL, 'G3DSA:3.40.50.720:FF:002346', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213491, NULL, 'G3DSA:1.10.472.10:FF:000002', NULL, NULL, 'Transcription factor IIIB 90 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(213492, NULL, 'G3DSA:1.20.140.10:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213493, NULL, 'G3DSA:1.25.40.20:FF:001289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213494, NULL, 'G3DSA:1.25.10.10:FF:002886', NULL, NULL, 'HEAT repeat-containing protein 2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(213495, NULL, 'G3DSA:1.10.555.10:FF:000083', NULL, NULL, 'Rho GTPase Activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(213496, NULL, 'G3DSA:3.40.50.2300:FF:001223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213497, NULL, 'G3DSA:1.20.1250.20:FF:002224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213498, NULL, 'G3DSA:2.20.100.10:FF:000049', NULL, NULL, 'Thrombospondin type 1 domain containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(213499, NULL, 'G3DSA:3.30.420.140:FF:000027', NULL, NULL, 'Putative pre-16S rRNA nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(213500, NULL, 'G3DSA:2.40.37.10:FF:000077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213501, NULL, 'G3DSA:3.90.190.10:FF:000456', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(213502, NULL, 'G3DSA:3.40.50.790:FF:000040', NULL, NULL, '60S ribosomal protein L10a-1', NULL, NULL, NULL, NULL, NULL, 4),
(213503, NULL, 'G3DSA:3.40.50.10050:FF:000006', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(213504, NULL, 'G3DSA:3.40.50.12610:FF:000004', NULL, NULL, 'Oligosaccharyl transferase STT3 subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(213505, NULL, 'G3DSA:3.30.70.850:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213506, NULL, 'G3DSA:3.30.200.20:FF:000986', NULL, NULL, 'Related to serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(213507, NULL, 'G3DSA:2.130.10.10:FF:001287', NULL, NULL, 'syntaxin-binding protein 5-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(213508, NULL, 'G3DSA:3.30.2410.10:FF:000015', NULL, NULL, 'probable E3 ubiquitin-protein ligase HECTD4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(213509, NULL, 'G3DSA:3.30.200.20:FF:001604', NULL, NULL, 'Traf2 and NCK-interacting protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(213510, NULL, 'G3DSA:2.40.240.10:FF:000032', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(213511, NULL, 'G3DSA:2.40.50.90:FF:000019', NULL, NULL, 'Transcription factor (Snd1/p100), putative', NULL, NULL, NULL, NULL, NULL, 4),
(213512, NULL, 'G3DSA:1.10.630.10:FF:000286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213513, NULL, 'G3DSA:1.25.10.10:FF:000986', NULL, NULL, 'Armadillo repeat containing 8', NULL, NULL, NULL, NULL, NULL, 4),
(213514, NULL, 'G3DSA:1.25.40.420:FF:000038', NULL, NULL, 'BTB and MATH domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(213515, NULL, 'G3DSA:3.30.1360.140:FF:000005', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(213516, NULL, 'G3DSA:3.50.50.60:FF:000665', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(213517, NULL, 'G3DSA:1.20.1250.20:FF:000324', NULL, NULL, 'Transporter, MFS superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(213518, NULL, 'G3DSA:3.30.40.10:FF:002365', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213519, NULL, 'G3DSA:3.60.40.10:FF:000177', NULL, NULL, 'WGS project CABT00000000 data, contig 2.1', NULL, NULL, NULL, NULL, NULL, 4),
(213520, NULL, 'G3DSA:3.40.50.300:FF:001821', NULL, NULL, 'Putative gtp-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(213521, NULL, 'G3DSA:2.130.10.10:FF:003232', NULL, NULL, 'WD-40 repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(213522, NULL, 'G3DSA:3.90.226.10:FF:000198', NULL, NULL, 'Enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(213523, NULL, 'G3DSA:1.10.472.30:FF:000008', NULL, NULL, 'transcription elongation factor S-II', NULL, NULL, NULL, NULL, NULL, 4),
(213524, NULL, 'G3DSA:1.10.8.840:FF:000002', NULL, NULL, 'Zuo1p', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(213525, NULL, 'G3DSA:1.25.40.10:FF:003321', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g49740', NULL, NULL, NULL, NULL, NULL, 4),
(213526, NULL, 'G3DSA:2.60.40.420:FF:000258', NULL, NULL, 'Os02g0653200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(213527, NULL, 'G3DSA:3.40.50.1820:FF:000606', NULL, NULL, 'GD19073', NULL, NULL, NULL, NULL, NULL, 4),
(213528, NULL, 'G3DSA:2.60.40.60:FF:001066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213529, NULL, 'G3DSA:3.40.50.1820:FF:000354', NULL, NULL, '(R)-3-hydroxydecanoyl-ACP:CoA transacylase PhaG', NULL, NULL, NULL, NULL, NULL, 4),
(213530, NULL, 'G3DSA:1.10.3430.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213531, NULL, 'G3DSA:3.40.50.10490:FF:000115', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213532, NULL, 'G3DSA:3.30.70.60:FF:000049', NULL, NULL, 'Plastid ribosomal protein S6', NULL, NULL, NULL, NULL, NULL, 4),
(213533, NULL, 'G3DSA:2.10.109.10:FF:000077', NULL, NULL, 'Signal peptidase I, fused to C-terminal uncharacterized domain', NULL, NULL, NULL, NULL, NULL, 4),
(213534, NULL, 'G3DSA:1.20.1170.10:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213535, NULL, 'G3DSA:3.30.559.10:FF:000046', NULL, NULL, 'Phenolic glucoside malonyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(213536, NULL, 'G3DSA:3.90.660.10:FF:000105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213537, NULL, 'G3DSA:3.90.810.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213538, NULL, 'G3DSA:2.60.40.4100:FF:000028', NULL, NULL, 'Betaglycan', NULL, NULL, NULL, NULL, NULL, 4),
(213539, NULL, 'G3DSA:3.40.50.720:FF:000194', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] reductase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(213540, NULL, 'G3DSA:3.40.50.2300:FF:000296', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(213541, NULL, 'G3DSA:2.60.40.1090:FF:000035', NULL, NULL, 'Fimbrial-like adhesin protein', NULL, NULL, NULL, NULL, NULL, 4),
(213542, NULL, 'G3DSA:1.20.1600.10:FF:000011', NULL, NULL, 'Outer membrane efflux protein', NULL, NULL, NULL, NULL, NULL, 4),
(213543, NULL, 'G3DSA:3.80.10.10:FF:000629', NULL, NULL, 'U2 snRNP component', NULL, NULL, NULL, NULL, NULL, 4),
(213544, NULL, 'G3DSA:1.20.1250.10:FF:000057', NULL, NULL, 'Interferon B', NULL, NULL, NULL, NULL, NULL, 4),
(213545, NULL, 'G3DSA:1.20.1070.10:FF:001959', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213546, NULL, 'G3DSA:2.30.42.10:FF:000359', NULL, NULL, 'Putative Golgi reassembly stacking protein (GRASP homologue)', NULL, NULL, NULL, NULL, NULL, 4),
(213547, NULL, 'G3DSA:3.30.1120.30:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213548, NULL, 'G3DSA:1.50.10.10:FF:000219', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(213549, NULL, 'G3DSA:3.30.70.100:FF:000132', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213550, NULL, 'G3DSA:4.10.240.10:FF:000065', NULL, NULL, 'Unplaced genomic scaffold supercont1.82, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(213551, NULL, 'G3DSA:3.100.10.10:FF:000065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213552, NULL, 'G3DSA:3.40.50.2300:FF:001004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213553, NULL, 'G3DSA:1.10.287.810:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213554, NULL, 'G3DSA:3.40.30.10:FF:000621', NULL, NULL, 'Protein disulfide isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(213555, NULL, 'G3DSA:3.40.630.30:FF:000272', NULL, NULL, 'Acetyltransferase, GNAT family protein', NULL, NULL, NULL, NULL, NULL, 4),
(213556, NULL, 'G3DSA:3.40.1190.20:FF:000133', NULL, NULL, 'Phosphomethylpyrimidine kinase (ThiD-1)', NULL, NULL, NULL, NULL, NULL, 4),
(213557, NULL, 'G3DSA:1.20.58.60:FF:000812', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213558, NULL, 'G3DSA:2.60.60.20:FF:000015', NULL, NULL, 'Lipoxygenase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(213559, NULL, 'G3DSA:3.60.10.10:FF:000125', NULL, NULL, 'Inositol 5-phosphatase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(213560, NULL, 'G3DSA:3.90.180.10:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213561, NULL, 'G3DSA:3.90.800.10:FF:000004', NULL, NULL, 'Glutamate--tRNA ligase 2', NULL, NULL, NULL, NULL, NULL, 4),
(213562, NULL, 'G3DSA:3.40.50.1910:FF:000038', NULL, NULL, 'Vacuolar protein sorting-associated protein 33', NULL, NULL, NULL, NULL, NULL, 4),
(213563, NULL, 'G3DSA:3.90.850.10:FF:000041', NULL, NULL, '2-hydroxypenta-2,4-dienoate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(213564, NULL, 'G3DSA:3.30.960.10:FF:000001', NULL, NULL, 'Eukaryotic peptide chain release factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(213565, NULL, 'G3DSA:1.25.10.10:FF:002993', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213566, NULL, 'G3DSA:2.130.10.10:FF:003316', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213567, NULL, 'G3DSA:3.90.870.50:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213568, NULL, 'G3DSA:1.10.472.10:FF:000497', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213569, NULL, 'G3DSA:2.40.50.140:FF:000776', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213570, NULL, 'G3DSA:3.30.2350.10:FF:000084', NULL, NULL, 'tRNA pseudouridine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(213571, NULL, 'G3DSA:1.20.90.10:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213572, NULL, 'G3DSA:3.30.160.60:FF:005351', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213573, NULL, 'G3DSA:2.10.230.10:FF:000010', NULL, NULL, 'Heat shock protein DnaJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(213574, NULL, 'G3DSA:3.30.559.10:FF:000147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213575, NULL, 'G3DSA:4.10.1240.30:FF:000006', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(213576, NULL, 'G3DSA:2.20.25.20:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213577, NULL, 'G3DSA:1.10.238.220:FF:000002', NULL, NULL, 'Serine/threonine-protein phosphatase 2A regulatory subunit B'''' subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(213578, NULL, 'G3DSA:2.60.40.60:FF:000020', NULL, NULL, 'Dachsous cadherin-related 1b', NULL, NULL, NULL, NULL, NULL, 4),
(213579, NULL, 'G3DSA:1.25.40.10:FF:000943', NULL, NULL, 'Transcription factor tau 131 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(213580, NULL, 'G3DSA:2.40.155.10:FF:000002', NULL, NULL, 'Hemicentin 1', NULL, NULL, NULL, NULL, NULL, 4),
(213581, NULL, 'G3DSA:3.30.710.10:FF:000269', NULL, NULL, 'SKP1-like protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(213582, NULL, 'G3DSA:1.20.1260.10:FF:000029', NULL, NULL, 'DNA polymerase III subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(213583, NULL, 'G3DSA:1.25.10.10:FF:003066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213584, NULL, 'G3DSA:3.90.550.10:FF:000203', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase 9', NULL, NULL, NULL, NULL, NULL, 4),
(213585, NULL, 'G3DSA:3.40.50.620:FF:000372', NULL, NULL, 'Probable CDC60-leucine--tRNA ligase, cytosolic', NULL, NULL, NULL, NULL, NULL, 4),
(213586, NULL, 'G3DSA:2.60.40.10:FF:001540', NULL, NULL, 'Immunoglobulin heavy constant gamma 1', NULL, NULL, NULL, NULL, NULL, 4),
(213587, NULL, 'G3DSA:3.90.226.10:FF:000097', NULL, NULL, 'Probable enoyl-CoA hydratase echa16', NULL, NULL, NULL, NULL, NULL, 4),
(213588, NULL, 'G3DSA:1.10.246.140:FF:000001', NULL, NULL, 'Transcription and mRNA export factor ENY2', NULL, NULL, NULL, NULL, NULL, 4),
(213589, NULL, 'G3DSA:3.30.70.270:FF:000306', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213590, NULL, 'G3DSA:3.40.50.10090:FF:000057', NULL, NULL, 'Uroporphyrinogen-III synthase', NULL, NULL, NULL, NULL, NULL, 4),
(213591, NULL, 'G3DSA:3.40.50.150:FF:001495', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213592, NULL, 'G3DSA:3.40.50.2000:FF:001021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(213593, NULL, 'G3DSA:1.10.238.20:FF:000001', NULL, NULL, 'General odorant-binding protein lush', NULL, NULL, NULL, NULL, NULL, 4),
(213594, NULL, 'G3DSA:1.10.510.10:FF:003138', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213595, NULL, 'G3DSA:1.10.555.10:FF:000010', NULL, NULL, 'SLIT-ROBO Rho GTPase-activating protein 1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(213596, NULL, 'G3DSA:1.20.1070.10:FF:000964', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213597, NULL, 'G3DSA:1.20.1070.10:FF:000329', NULL, NULL, 'Tyramine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(213598, NULL, 'G3DSA:1.20.1250.20:FF:002196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213599, NULL, 'G3DSA:3.40.1190.20:FF:000240', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213600, NULL, 'G3DSA:3.80.10.10:FF:002086', NULL, NULL, 'F-box domain containing protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(213601, NULL, 'G3DSA:3.40.50.450:FF:000062', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(213602, NULL, 'G3DSA:3.30.70.330:FF:001600', NULL, NULL, 'Pre-rRNA-processing protein esf2', NULL, NULL, NULL, NULL, NULL, 4),
(213603, NULL, 'G3DSA:2.30.29.30:FF:000503', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(213604, NULL, 'G3DSA:3.30.420.40:FF:001037', NULL, NULL, 'Heat shock 70 kDa protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(213605, NULL, 'G3DSA:3.40.50.740:FF:000042', NULL, NULL, 'NADH:ubiquinone oxidoreductase 78 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(213606, NULL, 'G3DSA:2.130.10.30:FF:000129', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213607, NULL, 'G3DSA:1.10.510.10:FF:003773', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213608, NULL, 'G3DSA:3.30.428.10:FF:000074', NULL, NULL, 'Uncharacterized HIT-like protein MG132', NULL, NULL, NULL, NULL, NULL, 4),
(213609, NULL, 'G3DSA:1.10.10.10:FF:000789', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit K', NULL, NULL, NULL, NULL, NULL, 4),
(213610, NULL, 'G3DSA:2.130.10.10:FF:005250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213611, NULL, 'G3DSA:3.50.50.60:FF:000873', NULL, NULL, 'Lycopene beta/epsilon cyclase protein', NULL, NULL, NULL, NULL, NULL, 4),
(213612, NULL, 'G3DSA:3.40.50.2000:FF:000874', NULL, NULL, 'Lipopolysaccharide core biosynthesis mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(213613, NULL, 'G3DSA:2.60.40.10:FF:003664', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213614, NULL, 'G3DSA:3.30.160.60:FF:004878', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213615, NULL, 'G3DSA:3.40.50.150:FF:001181', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213616, NULL, 'G3DSA:3.60.20.10:FF:000204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213617, NULL, 'G3DSA:3.40.50.620:FF:000265', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(213618, NULL, 'G3DSA:1.20.1250.20:FF:000739', NULL, NULL, 'Vesicular NUcleotide Transporte', NULL, NULL, NULL, NULL, NULL, 4),
(213619, NULL, 'G3DSA:1.25.40.1040:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213620, NULL, 'G3DSA:3.40.190.10:FF:000389', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(213621, NULL, 'G3DSA:3.40.20.10:FF:000014', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(213622, NULL, 'G3DSA:2.60.40.10:FF:003771', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213623, NULL, 'G3DSA:3.60.15.30:FF:000001', NULL, NULL, 'Alkyl/aryl-sulfatase BDS1', NULL, NULL, NULL, NULL, NULL, 4),
(213624, NULL, 'G3DSA:1.20.1280.50:FF:000110', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(213625, NULL, 'G3DSA:2.40.70.10:FF:000379', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213626, NULL, 'G3DSA:3.40.50.300:FF:007189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(213627, NULL, 'G3DSA:3.60.20.10:FF:000086', NULL, NULL, 'Proteasome subunit beta type-1', NULL, NULL, NULL, NULL, NULL, 4),
(213628, NULL, 'G3DSA:1.20.940.10:FF:000026', NULL, NULL, 'Splicing factor Prp18 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(213629, NULL, 'G3DSA:1.20.5.600:FF:000001', NULL, NULL, 'Potassium voltage-gated channel subfamily A member 4', NULL, NULL, NULL, NULL, NULL, 4),
(213630, NULL, 'G3DSA:3.60.20.10:FF:000193', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213631, NULL, 'G3DSA:1.10.150.110:FF:000030', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(213632, NULL, 'G3DSA:3.10.20.90:FF:000241', NULL, NULL, 'Phosphatidylinositol 3-kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(213633, NULL, 'G3DSA:2.60.20.10:FF:000010', NULL, NULL, 'very large A-kinase anchor protein', NULL, NULL, NULL, NULL, NULL, 4),
(213634, NULL, 'G3DSA:2.30.29.30:FF:000492', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(213635, NULL, 'G3DSA:1.10.287.2210:FF:000002', NULL, NULL, 'Proteasome activator subunit 4, putative (AFU_orthologue AFUA_4G11290)', NULL, NULL, NULL, NULL, NULL, 4),
(213636, NULL, 'G3DSA:3.40.50.300:FF:002411', NULL, NULL, 'Adenylyl-sulfate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(213637, NULL, 'G3DSA:3.40.50.1010:FF:000100', NULL, NULL, 'Protein CBR-EXO-1', NULL, NULL, NULL, NULL, NULL, 4),
(213638, NULL, 'G3DSA:2.10.25.10:FF:000315', NULL, NULL, 'Laminin subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(213639, NULL, 'G3DSA:3.30.160.100:FF:000017', NULL, NULL, 'Ribosome-associated factor Y', NULL, NULL, NULL, NULL, NULL, 4),
(213640, NULL, 'G3DSA:3.30.160.60:FF:004985', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213641, NULL, 'G3DSA:2.30.29.30:FF:000722', NULL, NULL, 'Integrin beta-1-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(213642, NULL, 'G3DSA:3.40.720.10:FF:000071', NULL, NULL, 'Metalloenzyme domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(213643, NULL, 'G3DSA:3.30.70.330:FF:002909', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213644, NULL, 'G3DSA:1.25.40.10:FF:004956', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213645, NULL, 'G3DSA:3.40.250.10:FF:000107', NULL, NULL, 'Rodhanase family domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(213646, NULL, 'G3DSA:4.10.1000.10:FF:000089', NULL, NULL, 'Zinc finger CCCH domain-containing protein 37', NULL, NULL, NULL, NULL, NULL, 4),
(213647, NULL, 'G3DSA:3.30.70.330:FF:002691', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213648, NULL, 'G3DSA:1.20.1270.60:FF:000174', NULL, NULL, 'Meiotically up-regulated gene 137 protein', NULL, NULL, NULL, NULL, NULL, 4),
(213649, NULL, 'G3DSA:3.90.70.10:FF:000200', NULL, NULL, 'Protein CBG05143', NULL, NULL, NULL, NULL, NULL, 4),
(213650, NULL, 'G3DSA:3.90.70.80:FF:000070', NULL, NULL, 'OTU-like cysteine protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(213651, NULL, 'G3DSA:3.20.20.100:FF:000158', NULL, NULL, 'Aldo-keto reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(213652, NULL, 'G3DSA:3.40.50.300:FF:005430', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213653, NULL, 'G3DSA:2.130.10.10:FF:002012', NULL, NULL, 'Transcriptional corepressor LEUNIG_HOMOLOG', NULL, NULL, NULL, NULL, NULL, 4),
(213654, NULL, 'G3DSA:3.90.550.20:FF:000004', NULL, NULL, 'Glycosyltransferase family 32 protein', NULL, NULL, NULL, NULL, NULL, 4),
(213655, NULL, 'G3DSA:2.60.120.200:FF:000628', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213656, NULL, 'G3DSA:2.10.25.10:FF:000422', NULL, NULL, 'Adhesion G protein-coupled receptor E2', NULL, NULL, NULL, NULL, NULL, 4),
(213657, NULL, 'G3DSA:3.40.50.11500:FF:000020', NULL, NULL, 'DENN/MADD domain containing 1A', NULL, NULL, NULL, NULL, NULL, 4),
(213658, NULL, 'G3DSA:2.120.10.80:FF:000398', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213659, NULL, 'G3DSA:3.20.20.80:FF:000726', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(213660, NULL, 'G3DSA:3.80.10.10:FF:000955', NULL, NULL, 'Volume-regulated anion channel subunit LRRC8B', NULL, NULL, NULL, NULL, NULL, 4),
(213661, NULL, 'G3DSA:3.40.50.620:FF:000618', NULL, NULL, 'DUF218 domain protein (AFU_orthologue AFUA_7G01750)', NULL, NULL, NULL, NULL, NULL, 4),
(213662, NULL, 'G3DSA:1.20.1070.10:FF:000655', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213663, NULL, 'G3DSA:3.40.50.720:FF:000093', NULL, NULL, 'Erythronate-4-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(213664, NULL, 'G3DSA:1.25.40.20:FF:000024', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(213665, NULL, 'G3DSA:1.20.120.160:FF:000031', NULL, NULL, 'Two-component system sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(213666, NULL, 'G3DSA:2.60.40.10:FF:003029', NULL, NULL, '2 (Zwei) IG domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(213667, NULL, 'G3DSA:3.15.10.10:FF:000021', NULL, NULL, 'Cholesteryl ester transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(213668, NULL, 'G3DSA:3.90.180.10:FF:000085', NULL, NULL, 'Alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(213669, NULL, 'G3DSA:1.10.8.1220:FF:000007', NULL, NULL, 'Cytoplasmic dynein heavy chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(213670, NULL, 'G3DSA:3.20.20.80:FF:000417', NULL, NULL, 'Alpha-L-fucosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(213671, NULL, 'G3DSA:3.30.470.20:FF:000253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213672, NULL, 'G3DSA:1.20.1280.290:FF:000078', NULL, NULL, 'PQ loop repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(213673, NULL, 'G3DSA:1.10.510.10:FF:001340', NULL, NULL, 'STE family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(213674, NULL, 'G3DSA:3.20.20.190:FF:000140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213675, NULL, 'G3DSA:2.60.120.330:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213676, NULL, 'G3DSA:2.60.120.10:FF:000108', NULL, NULL, 'cAMP-dependent protein kinase type II regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(213677, NULL, 'G3DSA:3.90.650.10:FF:000060', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(213678, NULL, 'G3DSA:1.10.8.50:FF:000007', NULL, NULL, 'endonuclease 8-like 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(213679, NULL, 'G3DSA:2.60.40.1930:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213680, NULL, 'G3DSA:3.40.50.1970:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213681, NULL, 'G3DSA:3.90.1860.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213682, NULL, 'G3DSA:1.25.10.10:FF:003173', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(213683, NULL, 'G3DSA:3.30.230.10:FF:000378', NULL, NULL, 'LIn-8 Domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(213684, NULL, 'G3DSA:3.30.40.10:FF:000566', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(213685, NULL, 'G3DSA:3.30.710.10:FF:000488', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213686, NULL, 'G3DSA:2.30.140.10:FF:000021', NULL, NULL, 'Polyamine aminopropyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(213687, NULL, 'G3DSA:3.30.200.20:FF:001503', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213688, NULL, 'G3DSA:3.40.50.410:FF:000308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213689, NULL, 'G3DSA:3.30.497.10:FF:000177', NULL, NULL, 'Serpin family C member 1', NULL, NULL, NULL, NULL, NULL, 4),
(213690, NULL, 'G3DSA:3.30.200.20:FF:000879', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(213691, NULL, 'G3DSA:2.130.10.10:FF:005031', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(213692, NULL, 'G3DSA:3.20.20.70:FF:000414', NULL, NULL, 'D-arabino 3-hexulose 6-phosphate aldehyde lyase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(213693, NULL, 'G3DSA:2.130.10.10:FF:003007', NULL, NULL, 'WD40-repeat-containing domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(213694, NULL, 'G3DSA:2.60.120.200:FF:000089', NULL, NULL, 'growth arrest-specific protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(213695, NULL, 'G3DSA:3.30.160.60:FF:003574', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213696, NULL, 'G3DSA:3.30.40.10:FF:002348', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213697, NULL, 'G3DSA:2.130.10.10:FF:003642', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213698, NULL, 'G3DSA:1.10.287.770:FF:000002', NULL, NULL, 'Amiloride-sensitive sodium channel subunit beta 1', NULL, NULL, NULL, NULL, NULL, 4),
(213699, NULL, 'G3DSA:2.60.40.10:FF:003338', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213700, NULL, 'G3DSA:1.20.1070.10:FF:002095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213701, NULL, 'G3DSA:1.10.510.10:FF:000114', NULL, NULL, 'Tyrosine-protein kinase JAK2', NULL, NULL, NULL, NULL, NULL, 4),
(213702, NULL, 'G3DSA:2.40.50.140:FF:000299', NULL, NULL, 'Glycerol-3-phosphate ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(213703, NULL, 'G3DSA:2.120.10.80:FF:000089', NULL, NULL, 'Acyl-CoA-binding domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(213704, NULL, 'G3DSA:3.20.20.150:FF:000061', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(213705, NULL, 'G3DSA:3.30.160.60:FF:000331', NULL, NULL, 'E3 ubiquitin-protein ligase RAD18', NULL, NULL, NULL, NULL, NULL, 4),
(213706, NULL, 'G3DSA:1.25.40.180:FF:000348', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213707, NULL, 'G3DSA:3.40.50.10420:FF:000010', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(213708, NULL, 'G3DSA:3.30.1340.30:FF:000010', NULL, NULL, 'Type III export protein PscD', NULL, NULL, NULL, NULL, NULL, 4),
(213709, NULL, 'G3DSA:3.30.70.1620:FF:000015', NULL, NULL, 'Structural maintenance of chromosomes protein', NULL, NULL, NULL, NULL, NULL, 4),
(213710, NULL, 'G3DSA:1.25.10.10:FF:003392', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213711, NULL, 'G3DSA:4.10.1000.10:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213712, NULL, 'G3DSA:2.60.120.290:FF:000043', NULL, NULL, 'Enteropeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(213713, NULL, 'G3DSA:2.40.50.140:FF:000669', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213714, NULL, 'G3DSA:3.40.50.300:FF:003176', NULL, NULL, 'Dda DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(213715, NULL, 'G3DSA:3.80.10.10:FF:003867', NULL, NULL, 'Endonuclease/Exonuclease/phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(213716, NULL, 'G3DSA:3.40.50.300:FF:005391', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213717, NULL, 'G3DSA:3.60.130.10:FF:000044', NULL, NULL, 'TauD/TfdA family dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(213718, NULL, 'G3DSA:3.90.1030.10:FF:000006', NULL, NULL, '50S ribosomal protein L17', NULL, NULL, NULL, NULL, NULL, 4),
(213719, NULL, 'G3DSA:2.30.30.140:FF:000022', NULL, NULL, 'Hydrogenase assembly chaperone HybG', NULL, NULL, NULL, NULL, NULL, 4),
(213720, NULL, 'G3DSA:3.40.50.300:FF:007661', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(213721, NULL, 'G3DSA:1.20.900.10:FF:000024', NULL, NULL, 'FYVE, RhoGEF and PH domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(213722, NULL, 'G3DSA:3.40.390.10:FF:000247', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213723, NULL, 'G3DSA:2.60.120.260:FF:000646', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213724, NULL, 'G3DSA:3.90.550.10:FF:000310', NULL, NULL, '2-phospho-L-lactate guanylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(213725, NULL, 'G3DSA:2.10.50.10:FF:000154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(213726, NULL, 'G3DSA:1.25.40.10:FF:003214', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At1g09680', NULL, NULL, NULL, NULL, NULL, 4),
(213727, NULL, 'G3DSA:3.40.50.300:FF:003827', NULL, NULL, 'Replication factor C, subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(213728, NULL, 'G3DSA:3.40.50.1100:FF:000115', NULL, NULL, 'Cysteine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(213729, NULL, 'G3DSA:1.20.5.110:FF:000073', NULL, NULL, 't-SNARE domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(213730, NULL, 'G3DSA:3.30.420.10:FF:000185', NULL, NULL, 'Unplaced genomic scaffold supercont2.5, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(213731, NULL, 'G3DSA:2.10.70.10:FF:000037', NULL, NULL, 'BMP-binding endothelial regulator protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(213732, NULL, 'G3DSA:3.30.70.330:FF:001061', NULL, NULL, 'Mip6p', NULL, NULL, NULL, NULL, NULL, 4),
(213733, NULL, 'G3DSA:2.60.120.200:FF:000319', NULL, NULL, 'Laminin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(213734, NULL, 'G3DSA:3.30.1520.10:FF:000035', NULL, NULL, 'Sorting nexin-4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(213735, NULL, 'G3DSA:2.30.30.140:FF:000050', NULL, NULL, 'AT-rich interactive domain 4A (RBP1-like)', NULL, NULL, NULL, NULL, NULL, 4),
(213736, NULL, 'G3DSA:2.60.120.380:FF:000070', NULL, NULL, 'Calpain 14', NULL, NULL, NULL, NULL, NULL, 4),
(213737, NULL, 'G3DSA:3.40.50.1110:FF:000118', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(213738, NULL, 'G3DSA:1.10.1540.10:FF:000003', NULL, NULL, 'WD repeat-containing protein 81 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(213739, NULL, 'G3DSA:3.30.460.10:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213740, NULL, 'G3DSA:3.30.160.60:FF:000022', NULL, NULL, 'zinc finger protein 383 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(213741, NULL, 'G3DSA:6.20.40.20:FF:000001', NULL, NULL, 'Hemolysin', NULL, NULL, NULL, NULL, NULL, 4),
(213742, NULL, 'G3DSA:3.90.550.10:FF:000001', NULL, NULL, 'Cellulose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(213743, NULL, 'G3DSA:3.40.250.10:FF:000068', NULL, NULL, 'Metallo-beta-lactamase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(213744, NULL, 'G3DSA:3.40.30.10:FF:000514', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(213745, NULL, 'G3DSA:1.10.287.70:FF:000382', NULL, NULL, 'Cyclic Nucleotide Gated channel', NULL, NULL, NULL, NULL, NULL, 4),
(213746, NULL, 'G3DSA:1.10.225.10:FF:000024', NULL, NULL, 'GG11904', NULL, NULL, NULL, NULL, NULL, 4),
(213747, NULL, 'G3DSA:3.90.1150.10:FF:000425', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213748, NULL, 'G3DSA:1.20.5.50:FF:000012', NULL, NULL, 'Cell division protein ZapA', NULL, NULL, NULL, NULL, NULL, 4),
(213749, NULL, 'G3DSA:3.40.50.300:FF:001349', NULL, NULL, 'NLR family pyrin domain containing 6', NULL, NULL, NULL, NULL, NULL, 4),
(213750, NULL, 'G3DSA:4.10.900.10:FF:000003', NULL, NULL, 'Desmoglein 1', NULL, NULL, NULL, NULL, NULL, 4),
(213751, NULL, 'G3DSA:2.60.40.1730:FF:000053', NULL, NULL, 'Peptidase M1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(213752, NULL, 'G3DSA:4.10.1080.10:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213753, NULL, 'G3DSA:2.130.10.10:FF:003086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213754, NULL, 'G3DSA:2.30.40.10:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213755, NULL, 'G3DSA:2.130.10.10:FF:001534', NULL, NULL, 'WD domain, G-beta repeat/PFU (PLAA family ubiquitin binding), putative', NULL, NULL, NULL, NULL, NULL, 4),
(213756, NULL, 'G3DSA:3.90.70.20:FF:000001', NULL, NULL, 'Protein adenylyltransferase and cysteine protease IbpA', NULL, NULL, NULL, NULL, NULL, 4),
(213757, NULL, 'G3DSA:3.40.50.720:FF:002537', NULL, NULL, 'Dihydrodipicolinate reductase, C-terminus family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(213758, NULL, 'G3DSA:1.10.8.60:FF:000229', NULL, NULL, 'Replication factor C subunit 3/5', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(213759, NULL, 'G3DSA:3.90.70.80:FF:000086', NULL, NULL, 'OTU deubiquitinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(213760, NULL, 'G3DSA:1.25.10.10:FF:001251', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(213761, NULL, 'G3DSA:3.40.50.11850:FF:000001', NULL, NULL, '2-(3-amino-3-carboxypropyl)histidine synthase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(213762, NULL, 'G3DSA:1.20.900.10:FF:000007', NULL, NULL, 'rho guanine nucleotide exchange factor 19', NULL, NULL, NULL, NULL, NULL, 4),
(213763, NULL, 'G3DSA:3.30.160.60:FF:004659', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213764, NULL, 'G3DSA:1.50.40.10:FF:000042', NULL, NULL, 'Envelope ADP,ATP carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(213765, NULL, 'G3DSA:1.10.10.10:FF:001430', NULL, NULL, 'Metallopeptidase_family_M24_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(213766, NULL, 'G3DSA:3.30.2320.80:FF:000001', NULL, NULL, 'Hydrogenase maturation factor HypA', NULL, NULL, NULL, NULL, NULL, 4),
(213767, NULL, 'G3DSA:3.30.70.1230:FF:000224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213768, NULL, 'G3DSA:1.10.630.10:FF:000533', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213769, NULL, 'G3DSA:3.90.1030.10:FF:000023', NULL, NULL, 'Mitochondrial ribosomal protein L17', NULL, NULL, NULL, NULL, NULL, 4),
(213770, NULL, 'G3DSA:3.40.50.2000:FF:000857', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(213771, NULL, 'G3DSA:3.40.50.150:FF:001490', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213772, NULL, 'G3DSA:3.30.9.10:FF:000022', NULL, NULL, 'Pipecolic acid and sarcosine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(213773, NULL, 'G3DSA:1.10.565.10:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213774, NULL, 'G3DSA:1.20.1070.10:FF:001021', NULL, NULL, 'Odor receptor 1I', NULL, NULL, NULL, NULL, NULL, 4),
(213775, NULL, 'G3DSA:3.40.30.10:FF:000312', NULL, NULL, 'redox-regulatory protein FAM213A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(213776, NULL, 'G3DSA:3.30.420.10:FF:000062', NULL, NULL, 'ERI1 exoribonuclease 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(213777, NULL, 'G3DSA:1.25.40.20:FF:001749', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213778, NULL, 'G3DSA:1.20.1250.20:FF:000425', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(213779, NULL, 'G3DSA:1.20.1560.10:FF:000530', NULL, NULL, 'YALI0A11473p', NULL, NULL, NULL, NULL, NULL, 4),
(213780, NULL, 'G3DSA:1.10.3810.10:FF:000018', NULL, NULL, 'Putative membrane carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(213781, NULL, 'G3DSA:3.40.50.300:FF:003148', NULL, NULL, 'Protein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(213782, NULL, 'G3DSA:3.30.160.20:FF:000134', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(213783, NULL, 'G3DSA:1.10.238.10:FF:001307', NULL, NULL, 'CDPK-related kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(213784, NULL, 'G3DSA:2.60.120.200:FF:000409', NULL, NULL, 'Apical endosomal glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(213785, NULL, 'G3DSA:2.40.128.700:FF:000001', NULL, NULL, 'Fatty acid synthase subunit beta, fungi type', NULL, NULL, NULL, NULL, NULL, 4),
(213786, NULL, 'G3DSA:3.30.160.60:FF:001657', NULL, NULL, 'Zinc finger protein 142', NULL, NULL, NULL, NULL, NULL, 4),
(213787, NULL, 'G3DSA:3.40.190.290:FF:000089', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(213788, NULL, 'G3DSA:3.40.50.300:FF:005284', NULL, NULL, 'Ferrous iron transport protein B', NULL, NULL, NULL, NULL, NULL, 4),
(213789, NULL, 'G3DSA:3.40.80.10:FF:000006', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(213790, NULL, 'G3DSA:2.40.280.10:FF:000001', NULL, NULL, 'SsrA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(213791, NULL, 'G3DSA:3.40.630.30:FF:000502', NULL, NULL, 'Spore associated protein, SapD', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(213792, NULL, 'G3DSA:2.60.120.10:FF:000215', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(213793, NULL, 'G3DSA:1.20.58.60:FF:000503', NULL, NULL, 'Dystrophin-1', NULL, NULL, NULL, NULL, NULL, 4),
(213794, NULL, 'G3DSA:3.10.580.10:FF:000122', NULL, NULL, 'Cystathionine beta-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(213795, NULL, 'G3DSA:3.30.70.330:FF:002472', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213796, NULL, 'G3DSA:3.40.50.300:FF:002102', NULL, NULL, 'Putative DEAD box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(213797, NULL, 'G3DSA:1.25.10.10:FF:002684', NULL, NULL, 'Importin 11', NULL, NULL, NULL, NULL, NULL, 4),
(213798, NULL, 'G3DSA:2.30.40.10:FF:000046', NULL, NULL, 'Guanine aminohydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(213799, NULL, 'G3DSA:1.25.40.20:FF:000131', NULL, NULL, 'ankyrin repeat domain-containing protein 17 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(213800, NULL, 'G3DSA:2.130.10.10:FF:005340', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(213801, NULL, 'G3DSA:2.170.240.10:FF:000001', NULL, NULL, 'Collagen IV alpha 1 chain', NULL, NULL, NULL, NULL, NULL, 4),
(213802, NULL, 'G3DSA:3.40.50.1460:FF:000009', NULL, NULL, 'Caspase 2', NULL, NULL, NULL, NULL, NULL, 4),
(213803, NULL, 'G3DSA:3.30.70.330:FF:002696', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213804, NULL, 'G3DSA:3.40.50.1000:FF:000687', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213805, NULL, 'G3DSA:3.40.50.360:FF:000035', NULL, NULL, 'NADPH-dependent FMN reductase', NULL, NULL, NULL, NULL, NULL, 4),
(213806, NULL, 'G3DSA:3.40.50.1820:FF:000146', NULL, NULL, 'Acylamino-acid-releasing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(213807, NULL, 'G3DSA:1.20.5.790:FF:000001', NULL, NULL, 'Spike glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(213808, NULL, 'G3DSA:1.10.510.10:FF:003133', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213809, NULL, 'G3DSA:2.60.120.590:FF:000054', NULL, NULL, 'Alkylated DNA repair protein alkB-like protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(213810, NULL, 'G3DSA:2.130.10.10:FF:003333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213811, NULL, 'G3DSA:3.30.70.330:FF:000908', NULL, NULL, 'probable RNA-binding protein ARP1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(213812, NULL, 'G3DSA:1.20.1740.10:FF:000151', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(213813, NULL, 'G3DSA:2.130.10.10:FF:001079', NULL, NULL, 'Cell division control protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(213814, NULL, 'G3DSA:2.30.29.30:FF:000705', NULL, NULL, 'PH domain leucine-rich repeat-containing protein phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(213815, NULL, 'G3DSA:3.30.40.10:FF:000347', NULL, NULL, 'rab effector Noc2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(213816, NULL, 'G3DSA:3.30.160.60:FF:005367', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213817, NULL, 'G3DSA:1.25.40.10:FF:002848', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(213818, NULL, 'G3DSA:3.50.50.60:FF:000564', NULL, NULL, 'Putative transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(213819, NULL, 'G3DSA:3.40.50.150:FF:001725', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213820, NULL, 'G3DSA:1.20.1420.10:FF:000020', NULL, NULL, 'Putative cyclin-d1-binding protein 1 log isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(213821, NULL, 'G3DSA:3.30.1240.10:FF:000069', NULL, NULL, 'Uncharacterized hydrolase C25B8.12c', NULL, NULL, NULL, NULL, NULL, 4),
(213822, NULL, 'G3DSA:3.30.200.20:FF:001812', NULL, NULL, 'Kinase, NEK', NULL, NULL, NULL, NULL, NULL, 4),
(213823, NULL, 'G3DSA:3.50.50.60:FF:001362', NULL, NULL, 'Monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(213824, NULL, 'G3DSA:3.90.650.10:FF:000043', NULL, NULL, 'Phosphoribosylformylglycinamide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(213825, NULL, 'G3DSA:3.40.850.10:FF:000417', NULL, NULL, 'Kinesin motor domain containing protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(213826, NULL, 'G3DSA:3.30.450.20:FF:000229', NULL, NULL, 'Methyl-accepting chemotaxis sensory transducer', NULL, NULL, NULL, NULL, NULL, 4),
(213827, NULL, 'G3DSA:3.40.630.30:FF:000300', NULL, NULL, 'GNAT family N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(213828, NULL, 'G3DSA:1.10.390.10:FF:000042', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(213829, NULL, 'G3DSA:3.50.50.60:FF:001053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213830, NULL, 'G3DSA:3.30.430.20:FF:000037', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 29', NULL, NULL, NULL, NULL, NULL, 4),
(213831, NULL, 'G3DSA:1.25.10.10:FF:000885', NULL, NULL, 'GPI inositol-deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(213832, NULL, 'G3DSA:3.40.50.410:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213833, NULL, 'G3DSA:3.30.70.2610:FF:000009', NULL, NULL, 'General transcription factor IIH subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(213834, NULL, 'G3DSA:1.10.472.10:FF:000278', NULL, NULL, 'Putative cyclin-D7-1', NULL, NULL, NULL, NULL, NULL, 4),
(213835, NULL, 'G3DSA:3.40.50.150:FF:001832', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213836, NULL, 'G3DSA:6.10.140.2220:FF:000050', NULL, NULL, 'SET domain-containing protein SmydA-8, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(213837, NULL, 'G3DSA:3.30.300.110:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213838, NULL, 'G3DSA:3.30.160.60:FF:001096', NULL, NULL, 'zinc finger protein 32 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(213839, NULL, 'G3DSA:1.10.510.10:FF:000699', NULL, NULL, 'Probable serine/threonine-protein kinase iksA', NULL, NULL, NULL, NULL, NULL, 4),
(213840, NULL, 'G3DSA:2.30.29.30:FF:000357', NULL, NULL, 'Kinesin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(213841, NULL, 'G3DSA:1.20.1250.10:FF:000085', NULL, NULL, 'Colony stimulating factor 2 (Granulocyte-macrophage)', NULL, NULL, NULL, NULL, NULL, 4),
(213842, NULL, 'G3DSA:3.40.50.720:FF:002447', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213843, NULL, 'G3DSA:3.40.190.10:FF:000698', NULL, NULL, 'Opine/polyamine ABC transporter, periplasmic substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(213844, NULL, 'G3DSA:2.130.10.10:FF:001388', NULL, NULL, 'PWP2 small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4),
(213845, NULL, 'G3DSA:1.20.1560.10:FF:000069', NULL, NULL, 'Multidrug ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(213846, NULL, 'G3DSA:1.20.5.300:FF:000006', NULL, NULL, 'Spike glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(213847, NULL, 'G3DSA:2.30.40.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213848, NULL, 'G3DSA:2.130.10.10:FF:001208', NULL, NULL, 'Cft1p', NULL, NULL, NULL, NULL, NULL, 4),
(213849, NULL, 'G3DSA:2.60.40.10:FF:001663', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(213850, NULL, 'G3DSA:2.130.10.10:FF:005901', NULL, NULL, 'DENN domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(213851, NULL, 'G3DSA:3.40.50.1010:FF:000223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213852, NULL, 'G3DSA:1.10.630.10:FF:000207', NULL, NULL, 'Putative cytochrome P450 superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(213853, NULL, 'G3DSA:3.60.130.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213854, NULL, 'G3DSA:3.40.50.2300:FF:001032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213855, NULL, 'G3DSA:2.10.25.10:FF:001748', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213856, NULL, 'G3DSA:3.40.50.300:FF:003822', NULL, NULL, 'Chromatin-remodeling ATPase INO80', NULL, NULL, NULL, NULL, NULL, 4),
(213857, NULL, 'G3DSA:3.40.50.300:FF:001259', NULL, NULL, 'Anion-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(213858, NULL, 'G3DSA:1.10.8.60:FF:000145', NULL, NULL, 'ATP-dependent protease La', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(213859, NULL, 'G3DSA:1.10.150.240:FF:000086', NULL, NULL, 'Phosphoglycolate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(213860, NULL, 'G3DSA:3.40.50.1860:FF:000006', NULL, NULL, 'Glutamate racemase', NULL, NULL, NULL, NULL, NULL, 4),
(213861, NULL, 'G3DSA:3.90.1200.10:FF:000042', NULL, NULL, 'Aminoglycoside phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(213862, NULL, 'G3DSA:3.60.140.10:FF:000016', NULL, NULL, 'Polyphenol oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(213863, NULL, 'G3DSA:2.30.140.10:FF:000004', NULL, NULL, 'Polyamine aminopropyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(213864, NULL, 'G3DSA:1.25.40.20:FF:000440', NULL, NULL, 'Receptor interacting serine/threonine kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(213865, NULL, 'G3DSA:3.40.50.150:FF:001164', NULL, NULL, 'tRNA wybutosine-synthesizing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(213866, NULL, 'G3DSA:2.40.30.10:FF:000011', NULL, NULL, 'Eukaryotic translation initiation factor 2 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(213867, NULL, 'G3DSA:3.40.50.12230:FF:000014', NULL, NULL, 'Methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(213868, NULL, 'G3DSA:1.20.1280.50:FF:000020', NULL, NULL, 'F-box only protein 4 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(213869, NULL, 'G3DSA:3.80.10.10:FF:002872', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213870, NULL, 'G3DSA:3.90.1150.10:FF:000279', NULL, NULL, 'Bifunctional dethiobiotin synthetase/7,8-diamino-pelargonic acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(213871, NULL, 'G3DSA:3.40.309.10:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213872, NULL, 'G3DSA:1.10.1760.20:FF:000011', NULL, NULL, 'Riboflavin transporter', NULL, NULL, NULL, NULL, NULL, 4),
(213873, NULL, 'G3DSA:2.60.120.770:FF:000001', NULL, NULL, 'Spike protein P1', NULL, NULL, NULL, NULL, NULL, 4),
(213874, NULL, 'G3DSA:3.30.70.1220:FF:000002', NULL, NULL, 'RNA polymerase II transcription factor B subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(213875, NULL, 'G3DSA:1.10.10.60:FF:001068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213876, NULL, 'G3DSA:3.60.20.10:FF:000176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213877, NULL, 'G3DSA:3.30.9.10:FF:000241', NULL, NULL, 'FAD-dependent oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(213878, NULL, 'G3DSA:3.40.50.150:FF:001506', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213879, NULL, 'G3DSA:1.10.630.10:FF:000078', NULL, NULL, 'Probable cytochrome P450 515A1', NULL, NULL, NULL, NULL, NULL, 4),
(213880, NULL, 'G3DSA:2.130.10.10:FF:003114', NULL, NULL, 'Echinoderm microtubule-associated protein-like elp-1', NULL, NULL, NULL, NULL, NULL, 4),
(213881, NULL, 'G3DSA:3.40.50.300:FF:003513', NULL, NULL, '6-phosphofructo-2-kinase/fructose-2, 6-bisphosphatase 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(213882, NULL, 'G3DSA:6.10.140.2220:FF:000033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(213883, NULL, 'G3DSA:2.130.10.10:FF:003423', NULL, NULL, 'Vacuolar protein sorting/targeting protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(213884, NULL, 'G3DSA:2.60.40.60:FF:001094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213885, NULL, 'G3DSA:3.40.50.300:FF:005065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213886, NULL, 'G3DSA:3.40.50.10240:FF:000035', NULL, NULL, 'Thiamine pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(213887, NULL, 'G3DSA:1.50.10.10:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213888, NULL, 'G3DSA:1.10.10.10:FF:000896', NULL, NULL, 'ETS domain-containing protein Elk-3', NULL, NULL, NULL, NULL, NULL, 4),
(213889, NULL, 'G3DSA:2.60.220.50:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213890, NULL, 'G3DSA:3.40.190.80:FF:000011', NULL, NULL, 'Fructose-1,6-bisphosphatase class 1', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(213891, NULL, 'G3DSA:3.80.10.10:FF:002563', NULL, NULL, 'SUMO-specific peptidase 7a', NULL, NULL, NULL, NULL, NULL, 4),
(213892, NULL, 'G3DSA:3.30.960.10:FF:000006', NULL, NULL, 'Eukaryotic peptide chain release factor subunit 1-3', NULL, NULL, NULL, NULL, NULL, 4),
(213893, NULL, 'G3DSA:3.40.50.720:FF:000963', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(213894, NULL, 'G3DSA:1.20.5.170:FF:000153', NULL, NULL, 'Trans-activator protein BZLF1', NULL, NULL, NULL, NULL, NULL, 4),
(213895, NULL, 'G3DSA:1.20.5.110:FF:000056', NULL, NULL, 'Bet1-like protein At4g14600', NULL, NULL, NULL, NULL, NULL, 4),
(213896, NULL, 'G3DSA:3.40.50.2000:FF:000548', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(213897, NULL, 'G3DSA:3.30.160.60:FF:003350', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213898, NULL, 'G3DSA:2.60.120.330:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213899, NULL, 'G3DSA:3.30.1370.110:FF:000026', NULL, NULL, 'Smr domain-containing protein C11H11.03c', NULL, NULL, NULL, NULL, NULL, 4),
(213900, NULL, 'G3DSA:1.20.120.1080:FF:000100', NULL, NULL, 'Protein CBG12480', NULL, NULL, NULL, NULL, NULL, 4),
(213901, NULL, 'G3DSA:1.10.10.10:FF:000587', NULL, NULL, 'Forkhead box P1', NULL, NULL, NULL, NULL, NULL, 4),
(213902, NULL, 'G3DSA:1.50.40.10:FF:000603', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213903, NULL, 'G3DSA:3.40.50.300:FF:001568', NULL, NULL, 'ATP-dependent Clp protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(213904, NULL, 'G3DSA:3.30.60.220:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213905, NULL, 'G3DSA:3.90.1480.20:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213906, NULL, 'G3DSA:3.40.50.720:FF:002228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213907, NULL, 'G3DSA:2.130.10.10:FF:001169', NULL, NULL, 'Bardet-Biedl syndrome 7 protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(213908, NULL, 'G3DSA:3.30.160.60:FF:005682', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213909, NULL, 'G3DSA:2.60.120.10:FF:000524', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213910, NULL, 'G3DSA:1.20.1560.10:FF:000378', NULL, NULL, 'ABC transporter HlyB/MsbA family', NULL, NULL, NULL, NULL, NULL, 4),
(213911, NULL, 'G3DSA:1.10.287.770:FF:000007', NULL, NULL, 'Diadenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(213912, NULL, 'G3DSA:3.20.20.80:FF:000743', NULL, NULL, 'Putative glucan endo-13-beta-glucosidase BG1', NULL, NULL, NULL, NULL, NULL, 4),
(213913, NULL, 'G3DSA:3.30.1450.10:FF:000006', NULL, NULL, 'Outer membrane protein assembly factor BamE', NULL, NULL, NULL, NULL, NULL, 4),
(213914, NULL, 'G3DSA:3.30.70.1230:FF:000005', NULL, NULL, 'Guanylate cyclase soluble subunit beta-1', NULL, NULL, NULL, NULL, NULL, 4),
(213915, NULL, 'G3DSA:2.30.42.10:FF:000354', NULL, NULL, 'protein inturned isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(213916, NULL, 'G3DSA:1.20.1050.130:FF:000018', NULL, NULL, 'tRNA-binding region domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(213917, NULL, 'G3DSA:3.40.5.120:FF:000008', NULL, NULL, 'Protein partner of snf, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(213918, NULL, 'G3DSA:3.50.50.60:FF:000783', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase (FAD-dependent), putative', NULL, NULL, NULL, NULL, NULL, 4),
(213919, NULL, 'G3DSA:1.20.920.10:FF:000109', NULL, NULL, 'GM15561', NULL, NULL, NULL, NULL, NULL, 4),
(213920, NULL, 'G3DSA:2.60.120.780:FF:000004', NULL, NULL, 'Sumo ligase', NULL, NULL, NULL, NULL, NULL, 4),
(213921, NULL, 'G3DSA:3.90.10.10:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213922, NULL, 'G3DSA:3.30.930.10:FF:000162', NULL, NULL, 'Lysyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(213923, NULL, 'G3DSA:1.10.287.160:FF:000004', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(213924, NULL, 'G3DSA:1.20.1050.10:FF:000295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(213925, NULL, 'G3DSA:2.40.30.20:FF:000014', NULL, NULL, 'Riboflavin synthase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(213926, NULL, 'G3DSA:1.10.10.60:FF:001158', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213927, NULL, 'G3DSA:2.30.30.100:FF:000167', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(213928, NULL, 'G3DSA:1.10.510.10:FF:002031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213929, NULL, 'G3DSA:1.10.630.10:FF:000168', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(213930, NULL, 'G3DSA:3.40.50.800:FF:000009', NULL, NULL, 'Eukaryotic translation initiation factor 2-alpha kinase', NULL, NULL, NULL, NULL, NULL, 4),
(213931, NULL, 'G3DSA:2.40.50.90:FF:000137', NULL, NULL, 'Putative ATP-dependent RNA helicase SoYb', NULL, NULL, NULL, NULL, NULL, 4),
(213932, NULL, 'G3DSA:1.10.10.60:FF:000669', NULL, NULL, 'Helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(213933, NULL, 'G3DSA:2.40.30.30:FF:000017', NULL, NULL, 'Uncharacterized protein B2G14.030', NULL, NULL, NULL, NULL, NULL, 4),
(213934, NULL, 'G3DSA:3.60.90.10:FF:000034', NULL, NULL, 'Putative S-adenosylmethionine decarboxylase proenzyme-like', NULL, NULL, NULL, NULL, NULL, 4),
(213935, NULL, 'G3DSA:3.30.200.20:FF:002459', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213936, NULL, 'G3DSA:2.140.10.30:FF:000005', NULL, NULL, 'Dipeptidyl peptidase 9', NULL, NULL, NULL, NULL, NULL, 4),
(213937, NULL, 'G3DSA:3.80.10.10:FF:003974', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213938, NULL, 'G3DSA:3.90.190.10:FF:000338', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213939, NULL, 'G3DSA:3.30.160.60:FF:003911', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213940, NULL, 'G3DSA:1.10.150.20:FF:000281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213941, NULL, 'G3DSA:1.20.120.310:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213942, NULL, 'G3DSA:1.25.40.20:FF:000114', NULL, NULL, 'ankyrin repeat and KH domain-containing protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(213943, NULL, 'G3DSA:1.20.58.60:FF:000470', NULL, NULL, 'AGAP011396-PA', NULL, NULL, NULL, NULL, NULL, 4),
(213944, NULL, 'G3DSA:2.60.120.650:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213945, NULL, 'G3DSA:3.30.740.10:FF:000018', NULL, NULL, 'Dynein light chain', NULL, NULL, NULL, NULL, NULL, 4),
(213946, NULL, 'G3DSA:3.30.420.270:FF:000032', NULL, NULL, 'Glr1388 protein', NULL, NULL, NULL, NULL, NULL, 4),
(213947, NULL, 'G3DSA:3.40.50.300:FF:007644', NULL, NULL, 'GTP-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(213948, NULL, 'G3DSA:3.40.50.1820:FF:000129', NULL, NULL, 'Autophagy related lipase Atg15, putative', NULL, NULL, NULL, NULL, NULL, 4),
(213949, NULL, 'G3DSA:3.80.10.10:FF:000287', NULL, NULL, 'adhesion G protein-coupled receptor A3', NULL, NULL, NULL, NULL, NULL, 4),
(213950, NULL, 'G3DSA:1.25.40.570:FF:000027', NULL, NULL, 'COP9 signalosome complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(213951, NULL, 'G3DSA:1.20.120.1030:FF:000001', NULL, NULL, 'Motility gene repressor MogR', NULL, NULL, NULL, NULL, NULL, 4),
(213952, NULL, 'G3DSA:1.10.10.60:FF:000888', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213953, NULL, 'G3DSA:3.40.50.300:FF:004896', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(213954, NULL, 'G3DSA:3.30.160.60:FF:001298', NULL, NULL, 'zinc finger protein 23 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(213955, NULL, 'G3DSA:1.25.40.550:FF:000021', NULL, NULL, 'AAR2-splicing factor', NULL, NULL, NULL, NULL, NULL, 4),
(213956, NULL, 'G3DSA:2.60.40.10:FF:001337', NULL, NULL, 'T-cell surface glycoprotein CD3 gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(213957, NULL, 'G3DSA:1.25.40.570:FF:000033', NULL, NULL, 'PCI domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(213958, NULL, 'G3DSA:2.30.29.30:FF:000576', NULL, NULL, 'Vacuolar sorting protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(213959, NULL, 'G3DSA:1.25.40.860:FF:000013', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(213960, NULL, 'G3DSA:3.40.720.10:FF:000161', NULL, NULL, 'Putative arylsulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(213961, NULL, 'G3DSA:3.40.50.300:FF:003844', NULL, NULL, 'WHiTe (Drosophila) related ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(213962, NULL, 'G3DSA:3.40.50.1110:FF:000012', NULL, NULL, 'SPI-2 type III secretion system effector SseJ', NULL, NULL, NULL, NULL, NULL, 4),
(213963, NULL, 'G3DSA:1.25.40.10:FF:000111', NULL, NULL, 'tetratricopeptide repeat protein 17 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(213964, NULL, 'G3DSA:3.90.190.10:FF:000029', NULL, NULL, 'Phosphatidylinositol 3,4,5-trisphosphate 3-phosphatase and dual-specificity protein phosphatase PTEN', NULL, NULL, NULL, NULL, NULL, 4),
(213965, NULL, 'G3DSA:4.10.410.10:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213966, NULL, 'G3DSA:3.30.420.10:FF:000168', NULL, NULL, 'Exonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(213967, NULL, 'G3DSA:3.90.228.10:FF:000005', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(213968, NULL, 'G3DSA:3.20.20.80:FF:000182', NULL, NULL, 'Beta-glucosidase 1A', NULL, NULL, NULL, NULL, NULL, 4),
(213969, NULL, 'G3DSA:2.60.120.330:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213970, NULL, 'G3DSA:3.30.930.10:FF:000145', NULL, NULL, 'Holocarboxylase synthetase, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(213971, NULL, 'G3DSA:3.40.50.2300:FF:000734', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(213972, NULL, 'G3DSA:3.40.50.410:FF:000191', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(213973, NULL, 'G3DSA:3.30.160.60:FF:003439', NULL, NULL, 'zinc finger and BTB domain-containing protein 47 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(213974, NULL, 'G3DSA:2.60.40.420:FF:000275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213975, NULL, 'G3DSA:3.90.1150.10:FF:000189', NULL, NULL, 'S phingosine-1-phosphate lyase 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(213976, NULL, 'G3DSA:3.40.50.1460:FF:000010', NULL, NULL, 'putative GPI-anchor transamidase', NULL, NULL, NULL, NULL, NULL, 4),
(213977, NULL, 'G3DSA:3.30.160.60:FF:005148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213978, NULL, 'G3DSA:3.60.40.10:FF:000284', NULL, NULL, 'protein phosphatase 1G', NULL, NULL, NULL, NULL, NULL, 4),
(213979, NULL, 'G3DSA:3.30.559.10:FF:000282', NULL, NULL, 'Choline O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(213980, NULL, 'G3DSA:2.40.420.20:FF:000015', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(213981, NULL, 'G3DSA:2.30.39.10:FF:000071', NULL, NULL, 'Serpin B3', NULL, NULL, NULL, NULL, NULL, 4),
(213982, NULL, 'G3DSA:1.20.1420.10:FF:000003', NULL, NULL, 'Talin 2', NULL, NULL, NULL, NULL, NULL, 4),
(213983, NULL, 'G3DSA:1.10.510.10:FF:002969', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213984, NULL, 'G3DSA:3.30.200.20:FF:001048', NULL, NULL, 'Px serine/threonine kinase (Pxk)', NULL, NULL, NULL, NULL, NULL, 4),
(213985, NULL, 'G3DSA:2.130.10.10:FF:000697', NULL, NULL, 'WD repeat protein, variant', NULL, NULL, NULL, NULL, NULL, 4),
(213986, NULL, 'G3DSA:3.30.450.210:FF:000003', NULL, NULL, 'Periplasmic stress-responsive two component signal transduction system histidine kinase CpxA', NULL, NULL, NULL, NULL, NULL, 4),
(213987, NULL, 'G3DSA:3.50.50.60:FF:001036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213988, NULL, 'G3DSA:1.25.40.20:FF:001109', NULL, NULL, 'Ankyrin repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(213989, NULL, 'G3DSA:1.10.238.10:FF:001268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(213990, NULL, 'G3DSA:3.30.365.10:FF:000011', NULL, NULL, 'Carbon monoxide dehydrogenase, large subunit', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(213991, NULL, 'G3DSA:1.10.10.10:FF:000935', NULL, NULL, 'Osomolarity two-component system, response regulator SKN7', NULL, NULL, NULL, NULL, NULL, 4),
(213992, NULL, 'G3DSA:3.40.50.720:FF:000177', NULL, NULL, 'Retinol dehydrogenase 10', NULL, NULL, NULL, NULL, NULL, 4),
(213993, NULL, 'G3DSA:3.30.420.410:FF:000001', NULL, NULL, 'Nucleoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(213994, NULL, 'G3DSA:1.10.510.10:FF:003442', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213995, NULL, 'G3DSA:3.40.50.150:FF:000798', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(213996, NULL, 'G3DSA:1.10.840.10:FF:000015', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(213997, NULL, 'G3DSA:3.30.450.70:FF:000019', NULL, NULL, 'Sybindin-like family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(213998, NULL, 'G3DSA:2.60.40.10:FF:001192', NULL, NULL, 'Aggrecan core protein', NULL, NULL, NULL, NULL, NULL, 4),
(213999, NULL, 'G3DSA:3.30.160.60:FF:002023', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM68', NULL, NULL, NULL, NULL, NULL, 4),
(214000, NULL, 'G3DSA:3.30.710.10:FF:000415', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214001, NULL, 'G3DSA:3.30.160.60:FF:001309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214002, NULL, 'G3DSA:3.30.40.10:FF:000549', NULL, NULL, 'RING/FYVE/PHD-type zinc finger family protein', NULL, NULL, NULL, NULL, NULL, 4),
(214003, NULL, 'G3DSA:1.25.40.20:FF:001750', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214004, NULL, 'G3DSA:3.60.70.12:FF:000007', NULL, NULL, 'Arginine biosynthesis bifunctional protein ArgJ', NULL, NULL, NULL, NULL, NULL, 4),
(214005, NULL, 'G3DSA:1.20.1740.10:FF:000257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214006, NULL, 'G3DSA:1.20.1250.20:FF:000195', NULL, NULL, 'monocarboxylate transporter 9 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(214007, NULL, 'G3DSA:3.90.1150.10:FF:000296', NULL, NULL, 'Transcriptional regulator, GntR family', NULL, NULL, NULL, NULL, NULL, 4),
(214008, NULL, 'G3DSA:1.25.10.10:FF:003408', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214009, NULL, 'G3DSA:1.20.58.60:FF:000357', NULL, NULL, 'SMAll', NULL, NULL, NULL, NULL, NULL, 4),
(214010, NULL, 'G3DSA:3.30.470.20:FF:000118', NULL, NULL, 'Formate-dependent phosphoribosylglycinamide formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(214011, NULL, 'G3DSA:3.10.250.10:FF:000131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214012, NULL, 'G3DSA:2.130.10.10:FF:004968', NULL, NULL, 'F-box and WD domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214013, NULL, 'G3DSA:3.30.930.10:FF:000252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214014, NULL, 'G3DSA:2.10.110.10:FF:000187', NULL, NULL, 'LIM and Rho-GAP domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(214015, NULL, 'G3DSA:2.30.29.30:FF:000048', NULL, NULL, 'Ras association (RalGDS/AF-6) and pleckstrin homology domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(214016, NULL, 'G3DSA:3.60.10.10:FF:000260', NULL, NULL, 'Endonuclease/exonuclease/phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(214017, NULL, 'G3DSA:2.60.40.10:FF:002973', NULL, NULL, 'Tyrosine-protein phosphatase 4', NULL, NULL, NULL, NULL, NULL, 4),
(214018, NULL, 'G3DSA:2.60.40.60:FF:000110', NULL, NULL, 'FAT atypical cadherin 4', NULL, NULL, NULL, NULL, NULL, 4),
(214019, NULL, 'G3DSA:1.25.10.10:FF:001267', NULL, NULL, 'Putative transformation/transcription domain-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(214020, NULL, 'G3DSA:1.10.10.60:FF:000995', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214021, NULL, 'G3DSA:1.20.1250.20:FF:000408', NULL, NULL, 'Major facilitator superfamily domain containing 4B', NULL, NULL, NULL, NULL, NULL, 4),
(214022, NULL, 'G3DSA:3.40.50.150:FF:001523', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214023, NULL, 'G3DSA:3.40.710.10:FF:000132', NULL, NULL, 'Penicillin-binding protein 1B', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(214024, NULL, 'G3DSA:1.10.472.10:FF:000587', NULL, NULL, 'Os02g0627800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(214025, NULL, 'G3DSA:2.130.10.10:FF:005115', NULL, NULL, 'Striatin, calmodulin-binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(214026, NULL, 'G3DSA:3.80.10.10:FF:002541', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214027, NULL, 'G3DSA:1.20.1070.10:FF:002128', NULL, NULL, 'RpkA', NULL, NULL, NULL, NULL, NULL, 4),
(214028, NULL, 'G3DSA:1.10.10.2830:FF:000007', NULL, NULL, 'Partitioning protein', NULL, NULL, NULL, NULL, NULL, 4),
(214029, NULL, 'G3DSA:3.30.450.50:FF:000013', NULL, NULL, 'Synaptobrevin homolog YKT6', NULL, NULL, NULL, NULL, NULL, 4),
(214030, NULL, 'G3DSA:2.130.10.10:FF:001843', NULL, NULL, 'Putative serine threonine kinase irei protein', NULL, NULL, NULL, NULL, NULL, 4),
(214031, NULL, 'G3DSA:2.60.40.10:FF:005137', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214032, NULL, 'G3DSA:2.10.80.10:FF:000010', NULL, NULL, 'AmphiDkk3', NULL, NULL, NULL, NULL, NULL, 4),
(214033, NULL, 'G3DSA:1.25.40.470:FF:000019', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(214034, NULL, 'G3DSA:3.40.50.150:FF:001416', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214035, NULL, 'G3DSA:3.90.70.80:FF:000069', NULL, NULL, 'Ubiquitin thioesterase otu2', NULL, NULL, NULL, NULL, NULL, 4),
(214036, NULL, 'G3DSA:3.40.50.720:FF:001958', NULL, NULL, 'ABR076Cp', NULL, NULL, NULL, NULL, NULL, 4),
(214037, NULL, 'G3DSA:1.25.20.10:FF:000003', NULL, NULL, 'Putative soluble lytic murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(214038, NULL, 'G3DSA:2.130.10.10:FF:000899', NULL, NULL, 'Chromosome 15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(214039, NULL, 'G3DSA:3.30.160.20:FF:000151', NULL, NULL, 'Endoribonuclease Dicer homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(214040, NULL, 'G3DSA:1.10.630.10:FF:000842', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214041, NULL, 'G3DSA:3.30.450.60:FF:000016', NULL, NULL, 'Signal recognition particle receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(214042, NULL, 'G3DSA:1.25.10.10:FF:003156', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(214043, NULL, 'G3DSA:3.30.760.10:FF:000019', NULL, NULL, 'Eukaryotic translation initiation factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214044, NULL, 'G3DSA:3.40.1110.10:FF:000237', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214045, NULL, 'G3DSA:1.10.510.10:FF:001188', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(214046, NULL, 'G3DSA:1.20.1560.10:FF:000159', NULL, NULL, 'multidrug resistance-associated protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(214047, NULL, 'G3DSA:4.10.80.40:FF:000003', NULL, NULL, 'Fumarate reductase flavoprotein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(214048, NULL, 'G3DSA:3.30.470.10:FF:000008', NULL, NULL, 'D-amino-acid transaminase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(214049, NULL, 'G3DSA:3.60.10.10:FF:000147', NULL, NULL, 'Suppressor of actin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214050, NULL, 'G3DSA:3.90.1150.10:FF:000509', NULL, NULL, 'Cysteine desulfurase', NULL, NULL, NULL, NULL, NULL, 4),
(214051, NULL, 'G3DSA:3.30.479.10:FF:000005', NULL, NULL, '6-pyruvoyl tetrahydropterin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(214052, NULL, 'G3DSA:3.20.20.70:FF:000072', NULL, NULL, '4-hydroxy-2-oxovalerate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(214053, NULL, 'G3DSA:3.40.50.620:FF:000388', NULL, NULL, 'Adenine nucleotide alpha hydrolases-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(214054, NULL, 'G3DSA:3.30.70.270:FF:000071', NULL, NULL, 'Sensor domain-containing diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(214055, NULL, 'G3DSA:1.10.287.70:FF:000067', NULL, NULL, 'glutamate receptor 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(214056, NULL, 'G3DSA:3.30.70.1230:FF:000022', NULL, NULL, 'Receptor-type adenylate cyclase GRESAG 4, putative', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(214057, NULL, 'G3DSA:2.40.50.40:FF:000038', NULL, NULL, 'Chromo domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(214058, NULL, 'G3DSA:2.30.42.10:FF:000337', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214059, NULL, 'G3DSA:3.30.479.20:FF:000008', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(214060, NULL, 'G3DSA:1.10.630.10:FF:000623', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214061, NULL, 'G3DSA:4.10.240.10:FF:000211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214062, NULL, 'G3DSA:3.20.20.80:FF:000075', NULL, NULL, 'Sporulation-specific chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(214063, NULL, 'G3DSA:3.40.50.1820:FF:000932', NULL, NULL, 'Alpha/Beta hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(214064, NULL, 'G3DSA:2.130.10.10:FF:001624', NULL, NULL, 'WD domain, G-beta repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(214065, NULL, 'G3DSA:3.90.70.200:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214066, NULL, 'G3DSA:3.40.50.720:FF:000429', NULL, NULL, 'NAD-specific glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(214067, NULL, 'G3DSA:2.60.120.920:FF:000052', NULL, NULL, 'CBN-UNC-68 protein', NULL, NULL, NULL, NULL, NULL, 4),
(214068, NULL, 'G3DSA:2.40.30.20:FF:000031', NULL, NULL, 'Yellow fluorescent protein', NULL, NULL, NULL, NULL, NULL, 4),
(214069, NULL, 'G3DSA:3.40.50.12360:FF:000002', NULL, NULL, 'HDA1 complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(214070, NULL, 'G3DSA:2.60.120.200:FF:000398', NULL, NULL, 'Putative L-type lectin-domain containing receptor kinase S.7', NULL, NULL, NULL, NULL, NULL, 4),
(214071, NULL, 'G3DSA:3.30.710.10:FF:000179', NULL, NULL, 'Rho-related BTB domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(214072, NULL, 'G3DSA:3.30.1490.330:FF:000001', NULL, NULL, 'Bifunctional glutathionylspermidine synthetase/amidase', NULL, NULL, NULL, NULL, NULL, 4),
(214073, NULL, 'G3DSA:2.60.40.10:FF:005244', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214074, NULL, 'G3DSA:3.30.160.60:FF:003243', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214075, NULL, 'G3DSA:3.40.50.1820:FF:000461', NULL, NULL, 'Alpha/beta fold hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(214076, NULL, 'G3DSA:3.40.50.20:FF:000064', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(214077, NULL, 'G3DSA:1.20.1250.20:FF:001499', NULL, NULL, 'Synaptic vesicle glycoprotein 2', NULL, NULL, NULL, NULL, NULL, 4),
(214078, NULL, 'G3DSA:1.10.287.70:FF:000303', NULL, NULL, 'TWiK family of potassium channels', NULL, NULL, NULL, NULL, NULL, 4),
(214079, NULL, 'G3DSA:1.10.287.70:FF:000612', NULL, NULL, 'Potassium channel, subfamily K, member 7', NULL, NULL, NULL, NULL, NULL, 4),
(214080, NULL, 'G3DSA:3.40.50.720:FF:000648', NULL, NULL, 'YOR246C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(214081, NULL, 'G3DSA:2.130.10.30:FF:000130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214082, NULL, 'G3DSA:3.40.50.12370:FF:000005', NULL, NULL, 'Cation/H(+) antiporter 20', NULL, NULL, NULL, NULL, NULL, 4),
(214083, NULL, 'G3DSA:3.30.900.10:FF:000008', NULL, NULL, 'Autophagy-related protein 13b', NULL, NULL, NULL, NULL, NULL, 4),
(214084, NULL, 'G3DSA:2.60.40.10:FF:001085', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(214085, NULL, 'G3DSA:2.60.20.10:FF:000009', NULL, NULL, 'very large A-kinase anchor protein', NULL, NULL, NULL, NULL, NULL, 4),
(214086, NULL, 'G3DSA:1.20.141.10:FF:000001', NULL, NULL, 'Chitosanase', NULL, NULL, NULL, NULL, NULL, 4),
(214087, NULL, 'G3DSA:3.40.720.10:FF:000380', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214088, NULL, 'G3DSA:1.10.220.30:FF:000025', NULL, NULL, 'Flagellar switch complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(214089, NULL, 'G3DSA:1.25.40.180:FF:000039', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(214090, NULL, 'G3DSA:2.10.25.10:FF:000186', NULL, NULL, 'Slit homolog 2 (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(214091, NULL, 'G3DSA:2.40.30.30:FF:000034', NULL, NULL, 'Riboflavin kinase/FAD synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(214092, NULL, 'G3DSA:1.20.58.190:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214093, NULL, 'G3DSA:2.60.220.30:FF:000010', NULL, NULL, 'p53-induced death domain-containing protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(214094, NULL, 'G3DSA:1.10.287.2620:FF:000018', NULL, NULL, 'Dynein heavy chain 5', NULL, NULL, NULL, NULL, NULL, 4),
(214095, NULL, 'G3DSA:3.80.10.10:FF:003957', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214096, NULL, 'G3DSA:1.20.58.60:FF:000722', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214097, NULL, 'G3DSA:3.30.559.10:FF:000063', NULL, NULL, 'Transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(214098, NULL, 'G3DSA:3.40.50.1000:FF:000203', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(214099, NULL, 'G3DSA:3.30.420.40:FF:000874', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214100, NULL, 'G3DSA:1.10.10.60:FF:000686', NULL, NULL, 'Os01g0127450 protein', NULL, NULL, NULL, NULL, NULL, 4),
(214101, NULL, 'G3DSA:3.30.40.10:FF:000881', NULL, NULL, 'Os08g0162400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(214102, NULL, 'G3DSA:1.20.58.790:FF:000001', NULL, NULL, 'Surface layer (S-layer) glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(214103, NULL, 'G3DSA:2.60.40.10:FF:001646', NULL, NULL, 'Collagen, type VII, alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(214104, NULL, 'G3DSA:2.60.34.10:FF:000098', NULL, NULL, 'EG:25E8.1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(214105, NULL, 'G3DSA:1.10.287.10:FF:000055', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(214106, NULL, 'G3DSA:3.10.580.10:FF:000206', NULL, NULL, 'DUF21 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(214107, NULL, 'G3DSA:1.10.630.10:FF:000314', NULL, NULL, 'Os06g0671300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(214108, NULL, 'G3DSA:1.10.630.10:FF:000062', NULL, NULL, 'Ent-kaurene oxidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(214109, NULL, 'G3DSA:3.30.160.20:FF:000128', NULL, NULL, 'RNA HelicAse', NULL, NULL, NULL, NULL, NULL, 4),
(214110, NULL, 'G3DSA:3.40.50.2300:FF:000189', NULL, NULL, 'SSU72p Phosphatase and transcription/RNA-processing factor', NULL, NULL, NULL, NULL, NULL, 4),
(214111, NULL, 'G3DSA:1.20.1310.20:FF:000020', NULL, NULL, 'Merozoite surface protein duffy binding ligand 2', NULL, NULL, NULL, NULL, NULL, 4),
(214112, NULL, 'G3DSA:3.40.50.11500:FF:000019', NULL, NULL, 'DENN_(AEX-3)_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(214113, NULL, 'G3DSA:1.25.40.10:FF:003236', NULL, NULL, 'AGR398Wp', NULL, NULL, NULL, NULL, NULL, 4),
(214114, NULL, 'G3DSA:2.10.270.10:FF:000001', NULL, NULL, 'Toxin B', NULL, NULL, NULL, NULL, NULL, 4),
(214115, NULL, 'G3DSA:2.60.60.20:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214116, NULL, 'G3DSA:3.90.1150.10:FF:000498', NULL, NULL, 'Kynurenine aminotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214117, NULL, 'G3DSA:1.10.225.10:FF:000002', NULL, NULL, 'prosaposin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(214118, NULL, 'G3DSA:3.80.10.10:FF:002428', NULL, NULL, 'cDNA, clone cssl:d0334', NULL, NULL, NULL, NULL, NULL, 4),
(214119, NULL, 'G3DSA:3.40.1110.10:FF:000018', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(214120, NULL, 'G3DSA:3.30.160.60:FF:003804', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214121, NULL, 'G3DSA:1.10.10.60:FF:001293', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214122, NULL, 'G3DSA:2.10.25.10:FF:000438', NULL, NULL, 'Hepatocyte growth factor activator', NULL, NULL, NULL, NULL, NULL, 4),
(214123, NULL, 'G3DSA:1.10.4160.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214124, NULL, 'G3DSA:3.40.30.10:FF:000205', NULL, NULL, 'Probable dolichyl-diphosphooligosaccharide--protein glycosyltransferase subunit 3', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(214125, NULL, 'G3DSA:3.40.1170.60:FF:000003', NULL, NULL, 'DNA polymerase eta', NULL, NULL, NULL, NULL, NULL, 4),
(214126, NULL, 'G3DSA:1.10.486.10:FF:000074', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(214127, NULL, 'G3DSA:3.90.190.10:FF:000142', NULL, NULL, 'Protein tyrosine phosphatase (Pyp1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(214128, NULL, 'G3DSA:1.20.1250.20:FF:000740', NULL, NULL, '3-phenylpropionic acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(214129, NULL, 'G3DSA:3.20.20.80:FF:000384', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214130, NULL, 'G3DSA:2.40.30.10:FF:000388', NULL, NULL, 'Probable translation initiation factor IF-2', NULL, NULL, NULL, NULL, NULL, 4),
(214131, NULL, 'G3DSA:2.40.50.140:FF:000670', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214132, NULL, 'G3DSA:3.20.20.70:FF:000381', NULL, NULL, 'Alpha-1,6-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(214133, NULL, 'G3DSA:3.40.50.300:FF:005082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214134, NULL, 'G3DSA:3.30.200.20:FF:000969', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214135, NULL, 'G3DSA:3.30.160.60:FF:003552', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214136, NULL, 'G3DSA:1.25.40.10:FF:003545', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214137, NULL, 'G3DSA:2.60.40.1820:FF:000001', NULL, NULL, 'Desiccation protectant protein Lea14-like', NULL, NULL, NULL, NULL, NULL, 4),
(214138, NULL, 'G3DSA:3.90.650.10:FF:000059', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(214139, NULL, 'G3DSA:2.130.10.10:FF:004749', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(214140, NULL, 'G3DSA:1.10.555.10:FF:000009', NULL, NULL, 'unconventional myosin-IXa isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(214141, NULL, 'G3DSA:3.30.70.330:FF:001370', NULL, NULL, 'GM11803', NULL, NULL, NULL, NULL, NULL, 4),
(214142, NULL, 'G3DSA:1.20.1270.60:FF:000051', NULL, NULL, 'ARF GTPase activator (Csx2)', NULL, NULL, NULL, NULL, NULL, 4),
(214143, NULL, 'G3DSA:3.40.50.720:FF:000980', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(214144, NULL, 'G3DSA:1.10.10.60:FF:001304', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214145, NULL, 'G3DSA:2.130.10.10:FF:001315', NULL, NULL, 'WD repeat domain 27', NULL, NULL, NULL, NULL, NULL, 4),
(214146, NULL, 'G3DSA:3.40.50.300:FF:001714', NULL, NULL, 'ATP-dependent DEAD/H RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214147, NULL, 'G3DSA:1.20.1720.10:FF:000060', NULL, NULL, 'Tetracycline resistance MFS efflux pump', NULL, NULL, NULL, NULL, NULL, 4),
(214148, NULL, 'G3DSA:2.60.40.2950:FF:000003', NULL, NULL, 'Thioester-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(214149, NULL, 'G3DSA:3.40.50.1010:FF:000116', NULL, NULL, 'Forkhead-associated (FHA) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(214150, NULL, 'G3DSA:1.20.58.900:FF:000006', NULL, NULL, 'RUN and SH3 domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(214151, NULL, 'G3DSA:3.30.750.44:FF:000015', NULL, NULL, 'Carboxy-terminal processing protease', NULL, NULL, NULL, NULL, NULL, 4),
(214152, NULL, 'G3DSA:2.30.29.30:FF:000470', NULL, NULL, 'Phosphatidylinositol 3-kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(214153, NULL, 'G3DSA:3.30.40.10:FF:001044', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(214154, NULL, 'G3DSA:3.40.50.360:FF:000170', NULL, NULL, 'Putative bifunctional protein', NULL, NULL, NULL, NULL, NULL, 4),
(214155, NULL, 'G3DSA:1.25.40.180:FF:000017', NULL, NULL, 'Eukaryotic translation initiation factor 4 gamma 2', NULL, NULL, NULL, NULL, NULL, 4),
(214156, NULL, 'G3DSA:3.40.50.1220:FF:000045', NULL, NULL, 'Electron transfer flavoprotein subunit alpha, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(214157, NULL, 'G3DSA:3.40.50.1820:FF:000477', NULL, NULL, 'Prolyl Carboxy Peptidase like', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(214158, NULL, 'G3DSA:2.30.29.30:FF:000812', NULL, NULL, 'Vacuolar protein sorting protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214159, NULL, 'G3DSA:1.20.990.10:FF:000046', NULL, NULL, 'Putative nadp-dependent flavoprotein reductase', NULL, NULL, NULL, NULL, NULL, 4),
(214160, NULL, 'G3DSA:3.30.70.330:FF:002707', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214161, NULL, 'G3DSA:1.25.10.10:FF:003375', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214162, NULL, 'G3DSA:3.50.50.60:FF:000890', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214163, NULL, 'G3DSA:3.20.190.10:FF:000017', NULL, NULL, 'Formamidopyrimidine-DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(214164, NULL, 'G3DSA:3.30.420.140:FF:000044', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(214165, NULL, 'G3DSA:1.25.10.10:FF:000969', NULL, NULL, 'GM12221', NULL, NULL, NULL, NULL, NULL, 4),
(214166, NULL, 'G3DSA:3.40.50.10190:FF:000104', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(214167, NULL, 'G3DSA:2.20.100.10:FF:000184', NULL, NULL, 'AGAP002424-PA', NULL, NULL, NULL, NULL, NULL, 4),
(214168, NULL, 'G3DSA:1.20.1560.10:FF:000524', NULL, NULL, 'ABC transporter C family member 9', NULL, NULL, NULL, NULL, NULL, 4),
(214169, NULL, 'G3DSA:3.30.160.60:FF:003658', NULL, NULL, 'GG12460', NULL, NULL, NULL, NULL, NULL, 4),
(214170, NULL, 'G3DSA:6.20.50.160:FF:000007', NULL, NULL, 'Complement 4B (Chido blood group)', NULL, NULL, NULL, NULL, NULL, 4),
(214171, NULL, 'G3DSA:1.10.510.10:FF:001424', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(214172, NULL, 'G3DSA:1.20.58.60:FF:000048', NULL, NULL, 'microtubule-actin cross-linking factor 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(214173, NULL, 'G3DSA:1.10.472.80:FF:000242', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214174, NULL, 'G3DSA:3.30.1330.40:FF:000057', NULL, NULL, 'Translation initiation inhibitor UK114/IBM1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214175, NULL, 'G3DSA:3.40.630.10:FF:000199', NULL, NULL, 'Clan MH, family M20, peptidase T-like metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(214176, NULL, 'G3DSA:3.10.310.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214177, NULL, 'G3DSA:3.40.220.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214178, NULL, 'G3DSA:3.30.70.270:FF:000267', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214179, NULL, 'G3DSA:2.20.70.10:FF:000189', NULL, NULL, 'MIP25048p', NULL, NULL, NULL, NULL, NULL, 4),
(214180, NULL, 'G3DSA:1.10.565.10:FF:000038', NULL, NULL, 'Dissatisfaction, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(214181, NULL, 'G3DSA:3.50.50.60:FF:000648', NULL, NULL, 'NAD(FAD)-dependent dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214182, NULL, 'G3DSA:3.30.450.40:FF:000100', NULL, NULL, 'GAF modulated transcriptional regulator, LuxR family', NULL, NULL, NULL, NULL, NULL, 4),
(214183, NULL, 'G3DSA:1.20.1070.10:FF:000548', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214184, NULL, 'G3DSA:1.10.640.10:FF:000034', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(214185, NULL, 'G3DSA:2.60.40.10:FF:003900', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214186, NULL, 'G3DSA:3.10.129.10:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214187, NULL, 'G3DSA:3.30.160.60:FF:000005', NULL, NULL, 'Zinc finger protein 14 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(214188, NULL, 'G3DSA:1.10.287.110:FF:000130', NULL, NULL, 'DnaJ chaperone (Caj1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(214189, NULL, 'G3DSA:3.90.660.10:FF:000122', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214190, NULL, 'G3DSA:3.30.1330.30:FF:000054', NULL, NULL, 'Uncharacterized protein MT2704', NULL, NULL, NULL, NULL, NULL, 4),
(214191, NULL, 'G3DSA:2.60.120.200:FF:000544', NULL, NULL, 'Os07g0133100 protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(214192, NULL, 'G3DSA:1.20.58.60:FF:000576', NULL, NULL, 'AGAP009554-PA', NULL, NULL, NULL, NULL, NULL, 4),
(214193, NULL, 'G3DSA:3.20.10.10:FF:000031', NULL, NULL, 'Putative secreted protein', NULL, NULL, NULL, NULL, NULL, 4),
(214194, NULL, 'G3DSA:3.40.50.1820:FF:000680', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(214195, NULL, 'G3DSA:1.20.80.10:FF:000074', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(214196, NULL, 'G3DSA:1.10.8.1310:FF:000012', NULL, NULL, 'Chromosome 16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(214197, NULL, 'G3DSA:3.30.200.20:FF:000863', NULL, NULL, 'Serine/threonine-protein kinase ELM1', NULL, NULL, NULL, NULL, NULL, 4),
(214198, NULL, 'G3DSA:3.30.300.30:FF:000143', NULL, NULL, 'Nonribosomal peptide synthase inpB', NULL, NULL, NULL, NULL, NULL, 4),
(214199, NULL, 'G3DSA:2.10.25.10:FF:000332', NULL, NULL, 'Tenascin N', NULL, NULL, NULL, NULL, NULL, 4),
(214200, NULL, 'G3DSA:3.30.1340.30:FF:000004', NULL, NULL, 'Predicted periplasmic or secreted lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(214201, NULL, 'G3DSA:3.30.420.10:FF:000533', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214202, NULL, 'G3DSA:3.30.70.330:FF:002365', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214203, NULL, 'G3DSA:1.10.510.10:FF:000030', NULL, NULL, 'Serine/threonine-protein kinase TAO2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214204, NULL, 'G3DSA:3.30.200.20:FF:001026', NULL, NULL, 'Aurora kinase', NULL, NULL, NULL, NULL, NULL, 4),
(214205, NULL, 'G3DSA:3.20.20.140:FF:000400', NULL, NULL, '2-amino-3-carboxylmuconate-6-semialdehyde decarboxylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214206, NULL, 'G3DSA:3.30.160.70:FF:000008', NULL, NULL, 'Methylated-DNA--protein-cysteine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(214207, NULL, 'G3DSA:1.10.287.70:FF:000376', NULL, NULL, 'Calcium channel, voltage-dependent, L type, alpha 1D subunit, b', NULL, NULL, NULL, NULL, NULL, 4),
(214208, NULL, 'G3DSA:3.40.50.300:FF:007335', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214209, NULL, 'G3DSA:3.30.1360.220:FF:000001', NULL, NULL, 'Zinc finger, FYVE domain-containing 9a', NULL, NULL, NULL, NULL, NULL, 4),
(214210, NULL, 'G3DSA:3.40.50.300:FF:007083', NULL, NULL, 'Probable GTP-binding protein EngB', NULL, NULL, NULL, NULL, NULL, 4),
(214211, NULL, 'G3DSA:2.60.40.10:FF:001556', NULL, NULL, 'Plexin A, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(214212, NULL, 'G3DSA:3.40.190.10:FF:000844', NULL, NULL, 'Gll3456 protein', NULL, NULL, NULL, NULL, NULL, 4),
(214213, NULL, 'G3DSA:1.10.3090.10:FF:000030', NULL, NULL, 'AGR118Wp', NULL, NULL, NULL, NULL, NULL, 4),
(214214, NULL, 'G3DSA:2.40.160.120:FF:000010', NULL, NULL, 'Oxysterol-binding protein homolog 4', NULL, NULL, NULL, NULL, NULL, 4),
(214215, NULL, 'G3DSA:1.10.2000.10:FF:000081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214216, NULL, 'G3DSA:3.40.630.30:FF:000047', NULL, NULL, 'Acetyltransferase, GNAT family', NULL, NULL, NULL, NULL, NULL, 4),
(214217, NULL, 'G3DSA:2.60.40.10:FF:000230', NULL, NULL, 'Down syndrome cell adhesion molecule, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(214218, NULL, 'G3DSA:3.90.850.10:FF:000024', NULL, NULL, '2-keto-4-pentenoate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(214219, NULL, 'G3DSA:3.20.20.10:FF:000060', NULL, NULL, 'Antizyme inhibitor 2', NULL, NULL, NULL, NULL, NULL, 4),
(214220, NULL, 'G3DSA:3.40.1190.20:FF:000150', NULL, NULL, '2-dehydro-3-deoxygluconokinase', NULL, NULL, NULL, NULL, NULL, 4),
(214221, NULL, 'G3DSA:1.10.287.130:FF:000136', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(214222, NULL, 'G3DSA:3.30.40.10:FF:002039', NULL, NULL, 'Suppressor of PAr-Two defect', NULL, NULL, NULL, NULL, NULL, 4),
(214223, NULL, 'G3DSA:1.10.150.50:FF:000019', NULL, NULL, 'Connector enhancer of kinase suppressor of Ras 2', NULL, NULL, NULL, NULL, NULL, 4),
(214224, NULL, 'G3DSA:1.20.1070.10:FF:000638', NULL, NULL, 'GH12381p', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(214225, NULL, 'G3DSA:3.30.160.60:FF:005912', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214226, NULL, 'G3DSA:1.25.40.10:FF:005254', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(214227, NULL, 'G3DSA:3.40.50.1820:FF:000590', NULL, NULL, 'Inactive pancreatic lipase-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(214228, NULL, 'G3DSA:3.30.70.270:FF:000177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214229, NULL, 'G3DSA:1.20.90.10:FF:000046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214230, NULL, 'G3DSA:2.70.50.40:FF:000003', NULL, NULL, 'UNC119 homologue, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214231, NULL, 'G3DSA:3.40.50.300:FF:002788', NULL, NULL, 'RecBCD enzyme subunit RecD', NULL, NULL, NULL, NULL, NULL, 4),
(214232, NULL, 'G3DSA:2.60.40.1230:FF:000010', NULL, NULL, 'VHS domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(214233, NULL, 'G3DSA:1.20.1270.190:FF:000001', NULL, NULL, 'ExsD', NULL, NULL, NULL, NULL, NULL, 4),
(214234, NULL, 'G3DSA:3.30.1490.190:FF:000009', NULL, NULL, 'Fur family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(214235, NULL, 'G3DSA:3.30.1490.180:FF:000006', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(214236, NULL, 'G3DSA:2.40.10.10:FF:000010', NULL, NULL, 'Kallikrein related peptidase 11', NULL, NULL, NULL, NULL, NULL, 4),
(214237, NULL, 'G3DSA:1.10.287.410:FF:000006', NULL, NULL, 'Serine carboxypeptidase-like 33', NULL, NULL, NULL, NULL, NULL, 4),
(214238, NULL, 'G3DSA:2.60.40.10:FF:003810', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214239, NULL, 'G3DSA:1.25.40.1030:FF:000044', NULL, NULL, 'Protein transport protein sec16', NULL, NULL, NULL, NULL, NULL, 4),
(214240, NULL, 'G3DSA:1.20.1730.10:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214241, NULL, 'G3DSA:3.30.70.260:FF:000174', NULL, NULL, 'Uncharacterized protein MJ0241', NULL, NULL, NULL, NULL, NULL, 4),
(214242, NULL, 'G3DSA:3.80.10.10:FF:004362', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214243, NULL, 'G3DSA:1.10.510.10:FF:001334', NULL, NULL, 'Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(214244, NULL, 'G3DSA:1.25.40.20:FF:001441', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214245, NULL, 'G3DSA:1.10.510.10:FF:003464', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214246, NULL, 'G3DSA:3.40.50.620:FF:000624', NULL, NULL, 'Glutamyl-Q tRNA(Asp) synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(214247, NULL, 'G3DSA:3.40.50.2000:FF:000526', NULL, NULL, 'UDP-glycosyltransferase 83A1', NULL, NULL, NULL, NULL, NULL, 4),
(214248, NULL, 'G3DSA:1.20.1070.10:FF:000296', NULL, NULL, 'C5a anaphylatoxin chemotactic receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(214249, NULL, 'G3DSA:3.40.50.11500:FF:000003', NULL, NULL, 'DENN domain containing 4C', NULL, NULL, NULL, NULL, NULL, 4),
(214250, NULL, 'G3DSA:3.10.290.10:FF:000105', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(214251, NULL, 'G3DSA:2.130.10.10:FF:002389', NULL, NULL, 'Flagellar inner dynein arm I1 intermediate chain IC140', NULL, NULL, NULL, NULL, NULL, 4),
(214252, NULL, 'G3DSA:1.20.1110.10:FF:000120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214253, NULL, 'G3DSA:2.60.40.3620:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214254, NULL, 'G3DSA:3.40.50.1260:FF:000051', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(214255, NULL, 'G3DSA:1.25.40.720:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214256, NULL, 'G3DSA:3.40.50.300:FF:004929', NULL, NULL, 'Zgc:63587', NULL, NULL, NULL, NULL, NULL, 4),
(214257, NULL, 'G3DSA:2.60.40.10:FF:003355', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214258, NULL, 'G3DSA:2.30.29.170:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214259, NULL, 'G3DSA:1.10.3470.10:FF:000048', NULL, NULL, 'FecCD transport family protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(214260, NULL, 'G3DSA:1.10.287.70:FF:000718', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(214261, NULL, 'G3DSA:3.10.620.30:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214262, NULL, 'G3DSA:3.40.50.300:FF:007554', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214263, NULL, 'G3DSA:3.30.70.660:FF:000081', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(214264, NULL, 'G3DSA:3.30.1240.10:FF:000070', NULL, NULL, 'Putative hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(214265, NULL, 'G3DSA:1.10.10.10:FF:001284', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(214266, NULL, 'G3DSA:1.10.3500.10:FF:000012', NULL, NULL, 'Transcription elongation factor spt6, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214267, NULL, 'G3DSA:3.80.10.10:FF:000539', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase EFR', NULL, NULL, NULL, NULL, NULL, 4),
(214268, NULL, 'G3DSA:1.25.40.10:FF:001415', NULL, NULL, 'Mitochondrial group I intron splicing factor CCM1', NULL, NULL, NULL, NULL, NULL, 4),
(214269, NULL, 'G3DSA:3.30.720.50:FF:000006', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(214270, NULL, 'G3DSA:3.30.559.10:FF:000169', NULL, NULL, 'Nonribosomal peptide synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(214271, NULL, 'G3DSA:1.10.437.10:FF:000016', NULL, NULL, 'bcl-2-like protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(214272, NULL, 'G3DSA:1.25.40.1040:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214273, NULL, 'G3DSA:1.10.238.10:FF:001072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214274, NULL, 'G3DSA:2.60.40.10:FF:003445', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214275, NULL, 'G3DSA:2.30.120.10:FF:000003', NULL, NULL, 'Acyl-homoserine lactone acylase PvdQ', NULL, NULL, NULL, NULL, NULL, 4),
(214276, NULL, 'G3DSA:3.30.160.60:FF:000224', NULL, NULL, 'Zinc finger protein 329', NULL, NULL, NULL, NULL, NULL, 4),
(214277, NULL, 'G3DSA:1.10.555.10:FF:000212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214278, NULL, 'G3DSA:3.40.50.12760:FF:000015', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(214279, NULL, 'G3DSA:2.60.120.200:FF:000292', NULL, NULL, 'NeuReXin related', NULL, NULL, NULL, NULL, NULL, 4),
(214280, NULL, 'G3DSA:1.20.58.60:FF:000486', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214281, NULL, 'G3DSA:3.80.10.10:FF:004339', NULL, NULL, 'Si:dkey-28k24.2', NULL, NULL, NULL, NULL, NULL, 4),
(214282, NULL, 'G3DSA:3.40.50.300:FF:003283', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(214283, NULL, 'G3DSA:3.50.30.30:FF:000003', NULL, NULL, 'E3 ubiquitin-protein ligase RNF128', NULL, NULL, NULL, NULL, NULL, 4),
(214284, NULL, 'G3DSA:2.40.40.20:FF:000060', NULL, NULL, 'DNA-directed RNA polymerase II subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(214285, NULL, 'G3DSA:1.25.40.20:FF:001418', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214286, NULL, 'G3DSA:1.10.150.50:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214287, NULL, 'G3DSA:1.10.287.70:FF:000409', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(214288, NULL, 'G3DSA:3.30.750.24:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214289, NULL, 'G3DSA:3.40.50.620:FF:000282', NULL, NULL, 'Bifunctional protein HldE', NULL, NULL, NULL, NULL, NULL, 4),
(214290, NULL, 'G3DSA:3.10.20.90:FF:000016', NULL, NULL, 'Polyubiquitin 3', NULL, NULL, NULL, NULL, NULL, 4),
(214291, NULL, 'G3DSA:1.10.1200.10:FF:000062', NULL, NULL, 'Acyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(214292, NULL, 'G3DSA:1.10.720.30:FF:000046', NULL, NULL, 'AaceriAAR121Wp', NULL, NULL, NULL, NULL, NULL, 4),
(214293, NULL, 'G3DSA:3.40.33.10:FF:000010', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(214294, NULL, 'G3DSA:1.20.1250.20:FF:001122', NULL, NULL, 'Multidrug transporter DTR1', NULL, NULL, NULL, NULL, NULL, 4),
(214295, NULL, 'G3DSA:3.40.50.11350:FF:000031', NULL, NULL, 'Putative alpha 1-6-fucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(214296, NULL, 'G3DSA:3.40.50.360:FF:000057', NULL, NULL, 'N-ribosyldihydronicotinamide:quinone reductase 2', NULL, NULL, NULL, NULL, NULL, 4),
(214297, NULL, 'G3DSA:3.40.50.300:FF:004210', NULL, NULL, 'Small GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214298, NULL, 'G3DSA:3.80.10.10:FF:002232', NULL, NULL, 'Protein CBG08830', NULL, NULL, NULL, NULL, NULL, 4),
(214299, NULL, 'G3DSA:2.130.10.10:FF:004030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214300, NULL, 'G3DSA:2.70.50.50:FF:000006', NULL, NULL, 'Putative secreted cellulose-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(214301, NULL, 'G3DSA:2.40.50.200:FF:000002', NULL, NULL, 'TIGR00156 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(214302, NULL, 'G3DSA:3.10.129.10:FF:000097', NULL, NULL, 'DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(214303, NULL, 'G3DSA:1.10.8.240:FF:000002', NULL, NULL, '2-phospho-L-lactate transferase', NULL, NULL, NULL, NULL, NULL, 4),
(214304, NULL, 'G3DSA:3.80.10.10:FF:000068', NULL, NULL, 'F-box/LRR-repeat protein 7 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(214305, NULL, 'G3DSA:1.25.40.10:FF:000797', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(214306, NULL, 'G3DSA:3.30.1140.32:FF:000014', NULL, NULL, '30S ribosomal protein S3', NULL, NULL, NULL, NULL, NULL, 4),
(214307, NULL, 'G3DSA:2.40.170.20:FF:000001', NULL, NULL, 'Vitamin B12 transporter BtuB', NULL, NULL, NULL, NULL, NULL, 4),
(214308, NULL, 'G3DSA:3.40.250.10:FF:000181', NULL, NULL, 'Rhodanese-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(214309, NULL, 'G3DSA:2.40.50.140:FF:001142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214310, NULL, 'G3DSA:3.40.50.620:FF:000591', NULL, NULL, 'Os08g0191800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(214311, NULL, 'G3DSA:3.30.160.60:FF:005603', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214312, NULL, 'G3DSA:2.30.30.40:FF:000577', NULL, NULL, 'Protein ste6', NULL, NULL, NULL, NULL, NULL, 4),
(214313, NULL, 'G3DSA:3.30.160.60:FF:001641', NULL, NULL, 'Zinc finger and BTB domain containing 4', NULL, NULL, NULL, NULL, NULL, 4),
(214314, NULL, 'G3DSA:1.25.40.10:FF:005344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214315, NULL, 'G3DSA:3.20.20.330:FF:000013', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(214316, NULL, 'G3DSA:3.30.1360.230:FF:000004', NULL, NULL, 'Suppressor of fused homolog', NULL, NULL, NULL, NULL, NULL, 4),
(214317, NULL, 'G3DSA:1.25.40.10:FF:000488', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(214318, NULL, 'G3DSA:2.60.40.10:FF:003136', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214319, NULL, 'G3DSA:3.40.50.300:FF:000410', NULL, NULL, 'ATPase RavA', NULL, NULL, NULL, NULL, NULL, 4),
(214320, NULL, 'G3DSA:3.30.70.330:FF:002674', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214321, NULL, 'G3DSA:3.40.190.10:FF:000934', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(214322, NULL, 'G3DSA:1.25.40.10:FF:001106', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(214323, NULL, 'G3DSA:1.10.287.130:FF:000046', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(214324, NULL, 'G3DSA:1.25.10.10:FF:001610', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214325, NULL, 'G3DSA:2.130.10.10:FF:004862', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214326, NULL, 'G3DSA:3.30.70.100:FF:000025', NULL, NULL, 'N-terminal EF-hand calcium-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(214327, NULL, 'G3DSA:1.20.120.350:FF:000205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(214328, NULL, 'G3DSA:1.10.238.10:FF:000919', NULL, NULL, 'EF-hand calcium-binding domain-containing protein 6-like', NULL, NULL, NULL, NULL, NULL, 4),
(214329, NULL, 'G3DSA:2.60.120.200:FF:000763', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214330, NULL, 'G3DSA:3.40.1160.10:FF:000100', NULL, NULL, 'Amino acid kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(214331, NULL, 'G3DSA:3.40.50.720:FF:000632', NULL, NULL, 'Fatty acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(214332, NULL, 'G3DSA:1.20.1270.60:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214333, NULL, 'G3DSA:3.40.1350.10:FF:000002', NULL, NULL, 'tRNA-splicing endonuclease subunit Sen34', NULL, NULL, NULL, NULL, NULL, 4),
(214334, NULL, 'G3DSA:3.30.1430.10:FF:000005', NULL, NULL, '50S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(214335, NULL, 'G3DSA:3.10.580.10:FF:000100', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(214336, NULL, 'G3DSA:3.40.50.10490:FF:000076', NULL, NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing]', NULL, NULL, NULL, NULL, NULL, 4),
(214337, NULL, 'G3DSA:2.10.25.10:FF:000641', NULL, NULL, 'epigen isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(214338, NULL, 'G3DSA:1.25.40.10:FF:004849', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214339, NULL, 'G3DSA:2.160.20.80:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214340, NULL, 'G3DSA:3.90.228.20:FF:000008', NULL, NULL, 'Phosphoenolpyruvate carboxykinase [GTP]', NULL, NULL, NULL, NULL, NULL, 4),
(214341, NULL, 'G3DSA:3.90.640.10:FF:000087', NULL, NULL, 'Actin-like ATPase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(214342, NULL, 'G3DSA:3.40.1480.10:FF:000006', NULL, NULL, 'Glycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(214343, NULL, 'G3DSA:3.40.50.10190:FF:000233', NULL, NULL, 'FHA domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214344, NULL, 'G3DSA:3.30.160.60:FF:003097', NULL, NULL, 'Zinc finger and BTB domain-containing 40', NULL, NULL, NULL, NULL, NULL, 4),
(214345, NULL, 'G3DSA:1.25.40.20:FF:001660', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(214346, NULL, 'G3DSA:3.40.50.850:FF:000002', NULL, NULL, 'Vibriobactin-specific isochorismatase', NULL, NULL, NULL, NULL, NULL, 4),
(214347, NULL, 'G3DSA:3.40.50.300:FF:003592', NULL, NULL, 'Thymidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(214348, NULL, 'G3DSA:1.20.58.200:FF:000004', NULL, NULL, 'Translin-associated factor TraX, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214349, NULL, 'G3DSA:2.40.10.230:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214350, NULL, 'G3DSA:3.40.50.10130:FF:000002', NULL, NULL, 'DNA repair endonuclease XPF', NULL, NULL, NULL, NULL, NULL, 4),
(214351, NULL, 'G3DSA:1.20.5.170:FF:000175', NULL, NULL, 'Basic-leucine zipper transcription factor B', NULL, NULL, NULL, NULL, NULL, 4),
(214352, NULL, 'G3DSA:2.60.120.330:FF:000223', NULL, NULL, 'Putative 2-oxoglutarate-dependent dioxygenase DIN11', NULL, NULL, NULL, NULL, NULL, 4),
(214353, NULL, 'G3DSA:1.10.10.10:FF:001194', NULL, NULL, 'Transcriptional regulator, Rrf2', NULL, NULL, NULL, NULL, NULL, 4),
(214354, NULL, 'G3DSA:2.170.16.10:FF:000045', NULL, NULL, 'Gll3966 protein', NULL, NULL, NULL, NULL, NULL, 4),
(214355, NULL, 'G3DSA:3.40.710.10:FF:000109', NULL, NULL, 'Glutaminase', NULL, NULL, NULL, NULL, NULL, 4),
(214356, NULL, 'G3DSA:3.40.250.10:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214357, NULL, 'G3DSA:3.40.50.300:FF:004120', NULL, NULL, 'tRNA modification GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(214358, NULL, 'G3DSA:1.20.58.1380:FF:000019', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(214359, NULL, 'G3DSA:2.60.120.430:FF:000012', NULL, NULL, 'Putative receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(214360, NULL, 'G3DSA:3.40.50.10140:FF:000005', NULL, NULL, 'Myeloid differentiation primary response protein MyD88', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(214361, NULL, 'G3DSA:2.60.40.760:FF:000006', NULL, NULL, 'Expansin-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(214362, NULL, 'G3DSA:3.30.160.60:FF:003349', NULL, NULL, 'RB associated KRAB zinc finger', NULL, NULL, NULL, NULL, NULL, 4),
(214363, NULL, 'G3DSA:3.30.70.330:FF:002926', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214364, NULL, 'G3DSA:1.10.150.50:FF:000036', NULL, NULL, 'upstream-binding protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(214365, NULL, 'G3DSA:1.25.40.180:FF:000135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214366, NULL, 'G3DSA:2.60.60.20:FF:000021', NULL, NULL, 'Lipoxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(214367, NULL, 'G3DSA:3.40.50.150:FF:001068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214368, NULL, 'G3DSA:3.30.980.10:FF:000002', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(214369, NULL, 'G3DSA:3.10.450.40:FF:000009', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(214370, NULL, 'G3DSA:3.30.300.130:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214371, NULL, 'G3DSA:1.20.920.10:FF:000132', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(214372, NULL, 'G3DSA:1.10.150.60:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214373, NULL, 'G3DSA:3.30.70.330:FF:000875', NULL, NULL, 'Glucose-repressible RNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(214374, NULL, 'G3DSA:3.90.810.10:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214375, NULL, 'G3DSA:3.40.50.10490:FF:000093', NULL, NULL, 'Glucose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(214376, NULL, 'G3DSA:1.10.630.10:FF:000067', NULL, NULL, 'Cytochrome P450 - like protein', NULL, NULL, NULL, NULL, NULL, 4),
(214377, NULL, 'G3DSA:1.25.40.320:FF:000003', NULL, NULL, 'Aminopeptidase O isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(214378, NULL, 'G3DSA:3.30.540.30:FF:000003', NULL, NULL, 'Dipeptidyl peptidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(214379, NULL, 'G3DSA:2.60.40.420:FF:000039', NULL, NULL, 'Blue copper oxidase CueO', NULL, NULL, NULL, NULL, NULL, 4),
(214380, NULL, 'G3DSA:1.50.40.10:FF:000160', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(214381, NULL, 'G3DSA:1.10.510.10:FF:003672', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214382, NULL, 'G3DSA:3.40.50.10190:FF:000216', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(214383, NULL, 'G3DSA:3.30.160.60:FF:000016', NULL, NULL, 'zinc finger protein 37 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(214384, NULL, 'G3DSA:1.10.2000.10:FF:000086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214385, NULL, 'G3DSA:1.10.287.810:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214386, NULL, 'G3DSA:1.10.8.10:FF:000153', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(214387, NULL, 'G3DSA:1.10.555.10:FF:000004', NULL, NULL, 'active breakpoint cluster region-related protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(214388, NULL, 'G3DSA:3.30.1140.60:FF:000003', NULL, NULL, 'F-actin-capping protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(214389, NULL, 'G3DSA:1.20.1070.10:FF:000863', NULL, NULL, '5-hydroxytryptamine receptor 1A-beta', NULL, NULL, NULL, NULL, NULL, 4),
(214390, NULL, 'G3DSA:1.10.530.10:FF:000020', NULL, NULL, 'Endochitinase CHI', NULL, NULL, NULL, NULL, NULL, 4),
(214391, NULL, 'G3DSA:1.20.1560.10:FF:000412', NULL, NULL, 'Putative ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(214392, NULL, 'G3DSA:4.10.280.10:FF:000073', NULL, NULL, 'MAX dimerization protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(214393, NULL, 'G3DSA:3.90.180.10:FF:000186', NULL, NULL, 'Putative cinnamyl alcohol dehydrogenase 6', NULL, NULL, NULL, NULL, NULL, 4),
(214394, NULL, 'G3DSA:3.20.20.70:FF:000622', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214395, NULL, 'G3DSA:1.20.1560.10:FF:000507', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(214396, NULL, 'G3DSA:3.40.50.720:FF:001025', NULL, NULL, 'Oxidoreductase, Gfo/Idh/MocA family', NULL, NULL, NULL, NULL, NULL, 4),
(214397, NULL, 'G3DSA:3.40.50.410:FF:000112', NULL, NULL, 'TFIIH basal transcription factor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(214398, NULL, 'G3DSA:2.130.10.10:FF:003322', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(214399, NULL, 'G3DSA:1.10.600.10:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214400, NULL, 'G3DSA:1.20.1250.20:FF:000638', NULL, NULL, 'Monocarboxylate permease', NULL, NULL, NULL, NULL, NULL, 4),
(214401, NULL, 'G3DSA:3.30.499.10:FF:000001', NULL, NULL, 'Aconitate hydratase B', NULL, NULL, NULL, NULL, NULL, 4),
(214402, NULL, 'G3DSA:2.60.120.260:FF:000287', NULL, NULL, 'Glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(214403, NULL, 'G3DSA:1.20.1270.10:FF:000070', NULL, NULL, 'Chaperone protein HscA', NULL, NULL, NULL, NULL, NULL, 4),
(214404, NULL, 'G3DSA:1.25.10.10:FF:002892', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214405, NULL, 'G3DSA:1.10.150.310:FF:000005', NULL, NULL, 'Si:ch211-117n7.8', NULL, NULL, NULL, NULL, NULL, 4),
(214406, NULL, 'G3DSA:3.30.1520.10:FF:000029', NULL, NULL, 'sorting nexin-15 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(214407, NULL, 'G3DSA:2.60.120.330:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214408, NULL, 'G3DSA:3.30.160.60:FF:003782', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214409, NULL, 'G3DSA:1.10.10.10:FF:001312', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(214410, NULL, 'G3DSA:2.30.30.40:FF:000200', NULL, NULL, 'SH3 domain containing 19', NULL, NULL, NULL, NULL, NULL, 4),
(214411, NULL, 'G3DSA:3.40.50.300:FF:003614', NULL, NULL, 'RecBCD enzyme subunit RecC', NULL, NULL, NULL, NULL, NULL, 4),
(214412, NULL, 'G3DSA:3.30.710.10:FF:000168', NULL, NULL, 'BTB/POZ domain-containing protein At1g03010', NULL, NULL, NULL, NULL, NULL, 4),
(214413, NULL, 'G3DSA:3.30.200.20:FF:001144', NULL, NULL, 'Calcium and calcium/calmodulin-dependent serine/threonine-protein kinase DMI-3', NULL, NULL, NULL, NULL, NULL, 4),
(214414, NULL, 'G3DSA:3.30.450.20:FF:000347', NULL, NULL, 'PAS sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(214415, NULL, 'G3DSA:1.10.150.300:FF:000002', NULL, NULL, 'Ribosome-binding ATPase YchF', NULL, NULL, NULL, NULL, NULL, 4),
(214416, NULL, 'G3DSA:2.40.30.70:FF:000006', NULL, NULL, 'BnaA08g13900D protein', NULL, NULL, NULL, NULL, NULL, 4),
(214417, NULL, 'G3DSA:3.80.10.10:FF:002771', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214418, NULL, 'G3DSA:3.30.2320.80:FF:000012', NULL, NULL, 'Hydrogenase maturation factor HypA', NULL, NULL, NULL, NULL, NULL, 4),
(214419, NULL, 'G3DSA:2.130.10.10:FF:005351', NULL, NULL, 'Transducin/WD-40 repeat protein family', NULL, NULL, NULL, NULL, NULL, 4),
(214420, NULL, 'G3DSA:3.20.20.80:FF:000625', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(214421, NULL, 'G3DSA:3.30.420.10:FF:000421', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214422, NULL, 'G3DSA:3.30.1490.20:FF:000017', NULL, NULL, 'Pyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(214423, NULL, 'G3DSA:2.30.29.30:FF:000823', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214424, NULL, 'G3DSA:1.10.10.60:FF:000809', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214425, NULL, 'G3DSA:2.30.40.10:FF:000164', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(214426, NULL, 'G3DSA:3.80.10.10:FF:000528', NULL, NULL, 'F-box/LRR-repeat protein 17 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(214427, NULL, 'G3DSA:3.30.70.330:FF:000780', NULL, NULL, 'U2 small nuclear ribonucleoprotein B''''', NULL, NULL, NULL, NULL, NULL, 4),
(214428, NULL, 'G3DSA:3.40.50.720:FF:000424', NULL, NULL, 'Meiotically up-regulated gene 72 protein', NULL, NULL, NULL, NULL, NULL, 4),
(214429, NULL, 'G3DSA:1.20.58.1520:FF:000005', NULL, NULL, 'GM11282', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(214430, NULL, 'G3DSA:2.10.50.10:FF:000160', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(214431, NULL, 'G3DSA:1.10.510.10:FF:000120', NULL, NULL, 'Casein kinase I isoform alpha', NULL, NULL, NULL, NULL, NULL, 4),
(214432, NULL, 'G3DSA:2.40.240.10:FF:000010', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(214433, NULL, 'G3DSA:3.30.70.890:FF:000014', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(214434, NULL, 'G3DSA:3.30.160.60:FF:005822', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214435, NULL, 'G3DSA:3.80.10.10:FF:002092', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(214436, NULL, 'G3DSA:3.40.50.300:FF:001574', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(214437, NULL, 'G3DSA:3.30.70.330:FF:001055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214438, NULL, 'G3DSA:1.25.40.10:FF:003006', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g13770, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(214439, NULL, 'G3DSA:2.60.220.50:FF:000033', NULL, NULL, 'Polycystic kidney disease 1 like 2a', NULL, NULL, NULL, NULL, NULL, 4),
(214440, NULL, 'G3DSA:2.60.40.10:FF:003344', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214441, NULL, 'G3DSA:3.40.80.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214442, NULL, 'G3DSA:3.40.30.10:FF:000520', NULL, NULL, 'Thioredoxin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214443, NULL, 'G3DSA:3.10.105.10:FF:000103', NULL, NULL, 'Oligopeptide transport system binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(214444, NULL, 'G3DSA:3.30.70.100:FF:000031', NULL, NULL, 'copper-transporting ATPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(214445, NULL, 'G3DSA:3.20.90.10:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214446, NULL, 'G3DSA:1.10.10.10:FF:000795', NULL, NULL, 'La protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(214447, NULL, 'G3DSA:3.90.1150.10:FF:000392', NULL, NULL, 'Serine--pyruvate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(214448, NULL, 'G3DSA:3.30.9.10:FF:000033', NULL, NULL, 'Putative oxidoreductase C1F5.03c', NULL, NULL, NULL, NULL, NULL, 4),
(214449, NULL, 'G3DSA:3.40.50.10190:FF:000121', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(214450, NULL, 'G3DSA:3.40.50.410:FF:000207', NULL, NULL, 'Cku-70', NULL, NULL, NULL, NULL, NULL, 4),
(214451, NULL, 'G3DSA:3.50.50.60:FF:000446', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214452, NULL, 'G3DSA:3.90.1210.10:FF:000003', NULL, NULL, 'Flagella basal body P-ring formation protein FlgA', NULL, NULL, NULL, NULL, NULL, 4),
(214453, NULL, 'G3DSA:2.60.40.1530:FF:000010', NULL, NULL, 'Integrin subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(214454, NULL, 'G3DSA:3.40.50.80:FF:000059', NULL, NULL, 'Ferric reduction oxidase 4', NULL, NULL, NULL, NULL, NULL, 4),
(214455, NULL, 'G3DSA:3.40.220.10:FF:000027', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(214456, NULL, 'G3DSA:1.25.10.10:FF:003167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214457, NULL, 'G3DSA:1.10.720.30:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214458, NULL, 'G3DSA:3.40.50.150:FF:000888', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(214459, NULL, 'G3DSA:1.10.880.10:FF:000001', NULL, NULL, 'Nuclear factor erythroid 2-related factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(214460, NULL, 'G3DSA:1.10.10.60:FF:001057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214461, NULL, 'G3DSA:2.40.37.10:FF:000072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214462, NULL, 'G3DSA:2.130.10.10:FF:001068', NULL, NULL, 'Regulatory-associated protein of TOR 1', NULL, NULL, NULL, NULL, NULL, 4),
(214463, NULL, 'G3DSA:1.25.40.90:FF:000118', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(214464, NULL, 'G3DSA:1.25.40.10:FF:002489', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g58590', NULL, NULL, NULL, NULL, NULL, 4),
(214465, NULL, 'G3DSA:2.130.10.10:FF:005446', NULL, NULL, 'WD repeat-containing protein 3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(214466, NULL, 'G3DSA:3.40.850.10:FF:000058', NULL, NULL, 'kinesin-like protein KIN-14B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(214467, NULL, 'G3DSA:3.40.50.2300:FF:000970', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214468, NULL, 'G3DSA:1.20.5.110:FF:000281', NULL, NULL, 'R-SNARE protein, tomsyn-like family', NULL, NULL, NULL, NULL, NULL, 4),
(214469, NULL, 'G3DSA:3.40.50.1820:FF:000359', NULL, NULL, 'Alpha/beta fold hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(214470, NULL, 'G3DSA:1.10.472.10:FF:000598', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214471, NULL, 'G3DSA:3.40.47.10:FF:000289', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214472, NULL, 'G3DSA:3.30.43.10:FF:000039', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(214473, NULL, 'G3DSA:1.20.1050.130:FF:000007', NULL, NULL, 'Bifunctional glutamate/proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(214474, NULL, 'G3DSA:2.60.120.200:FF:000634', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214475, NULL, 'G3DSA:2.60.220.50:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214476, NULL, 'G3DSA:1.10.630.10:FF:000393', NULL, NULL, 'Tafazzin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(214477, NULL, 'G3DSA:3.30.710.10:FF:000494', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214478, NULL, 'G3DSA:2.60.40.10:FF:005710', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214479, NULL, 'G3DSA:3.40.50.2000:FF:000189', NULL, NULL, 'UDP-glucuronosyltransferase 2B14-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(214480, NULL, 'G3DSA:2.130.10.10:FF:001394', NULL, NULL, 'Damaged DNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(214481, NULL, 'G3DSA:3.40.50.720:FF:002341', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214482, NULL, 'G3DSA:2.60.40.10:FF:001427', NULL, NULL, 'Immunoglobulin superfamily member 10', NULL, NULL, NULL, NULL, NULL, 4),
(214483, NULL, 'G3DSA:2.40.50.90:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214484, NULL, 'G3DSA:1.20.58.60:FF:000374', NULL, NULL, 'Blast:Spectrin beta chain, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(214485, NULL, 'G3DSA:3.40.1190.10:FF:000017', NULL, NULL, 'Folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(214486, NULL, 'G3DSA:3.30.160.60:FF:005143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214487, NULL, 'G3DSA:3.30.1370.10:FF:000085', NULL, NULL, 'KH domain-containing, RNA-binding, signal transduction-associated protein 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(214488, NULL, 'G3DSA:1.20.1050.110:FF:000001', NULL, NULL, 'Methionine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(214489, NULL, 'G3DSA:3.40.50.300:FF:000051', NULL, NULL, 'Guanine nucleotide-binding protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(214490, NULL, 'G3DSA:3.30.70.330:FF:002915', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214491, NULL, 'G3DSA:1.20.1420.10:FF:000014', NULL, NULL, 'Os05g0554500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(214492, NULL, 'G3DSA:1.20.120.20:FF:000046', NULL, NULL, 'Apolipoprotein A-I', NULL, NULL, NULL, NULL, NULL, 4),
(214493, NULL, 'G3DSA:3.30.450.20:FF:000673', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214494, NULL, 'G3DSA:1.10.8.970:FF:000001', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(214495, NULL, 'G3DSA:3.10.250.10:FF:000002', NULL, NULL, 'Scavenger receptor cysteine-rich type 1 protein M130', NULL, NULL, NULL, NULL, NULL, 4),
(214496, NULL, 'G3DSA:3.30.450.220:FF:000001', NULL, NULL, 'Sensor histidine kinase LuxQ', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(214497, NULL, 'G3DSA:1.20.140.10:FF:000038', NULL, NULL, 'Nitroalkane oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(214498, NULL, 'G3DSA:3.30.70.330:FF:000549', NULL, NULL, 'Plastid-specific 30S ribosomal protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(214499, NULL, 'G3DSA:6.10.140.2220:FF:000044', NULL, NULL, 'GH11294p', NULL, NULL, NULL, NULL, NULL, 4),
(214500, NULL, 'G3DSA:1.20.1070.10:FF:000537', NULL, NULL, '5-hydroxytryptamine (Serotonin) receptor 2A, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(214501, NULL, 'G3DSA:3.30.470.20:FF:000135', NULL, NULL, 'Tubulin Tyrosine Ligase Like', NULL, NULL, NULL, NULL, NULL, 4),
(214502, NULL, 'G3DSA:1.10.405.20:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214503, NULL, 'G3DSA:3.80.10.10:FF:000854', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(214504, NULL, 'G3DSA:2.10.70.10:FF:000043', NULL, NULL, 'Plasminogen activator', NULL, NULL, NULL, NULL, NULL, 4),
(214505, NULL, 'G3DSA:2.60.40.420:FF:000270', NULL, NULL, 'Cytochrome c oxidase, subunit II', NULL, NULL, NULL, NULL, NULL, 4),
(214506, NULL, 'G3DSA:3.40.50.300:FF:005643', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214507, NULL, 'G3DSA:1.10.510.10:FF:001429', NULL, NULL, 'Cyclin-dependent kinase 14', NULL, NULL, NULL, NULL, NULL, 4),
(214508, NULL, 'G3DSA:1.25.40.20:FF:001648', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(214509, NULL, 'G3DSA:1.10.510.10:FF:001317', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(214510, NULL, 'G3DSA:3.80.10.10:FF:000742', NULL, NULL, 'Pollen-specific leucine-rich repeat extensin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(214511, NULL, 'G3DSA:1.20.900.10:FF:000018', NULL, NULL, 'Phosphatidylinositol-3,4, 5-trisphosphate-dependent Rac exchange factor 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214512, NULL, 'G3DSA:3.30.160.60:FF:001865', NULL, NULL, 'Zinc finger protein 404', NULL, NULL, NULL, NULL, NULL, 4),
(214513, NULL, 'G3DSA:3.60.21.10:FF:000032', NULL, NULL, 'Tartrate-resistant acid phosphatase type 5', NULL, NULL, NULL, NULL, NULL, 4),
(214514, NULL, 'G3DSA:1.10.2000.10:FF:000002', NULL, NULL, 'Inactive tyrosine-protein kinase transmembrane receptor ROR1', NULL, NULL, NULL, NULL, NULL, 4),
(214515, NULL, 'G3DSA:2.120.10.80:FF:000297', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(214516, NULL, 'G3DSA:3.90.660.10:FF:000116', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214517, NULL, 'G3DSA:1.25.40.470:FF:000020', NULL, NULL, 'Intraflagellar transport protein 172', NULL, NULL, NULL, NULL, NULL, 4),
(214518, NULL, 'G3DSA:3.40.50.2000:FF:000094', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(214519, NULL, 'G3DSA:1.10.10.10:FF:001407', NULL, NULL, 'Transcriptional regulator MarR family', NULL, NULL, NULL, NULL, NULL, 4),
(214520, NULL, 'G3DSA:3.40.50.300:FF:001248', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(214521, NULL, 'G3DSA:3.30.710.10:FF:000505', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214522, NULL, 'G3DSA:3.40.50.720:FF:002548', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214523, NULL, 'G3DSA:1.10.8.530:FF:000004', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(214524, NULL, 'G3DSA:3.30.1120.100:FF:000002', NULL, NULL, 'Fatty acid synthase beta subunit aflB', NULL, NULL, NULL, NULL, NULL, 4),
(214525, NULL, 'G3DSA:1.10.238.10:FF:000779', NULL, NULL, 'Calretinin', NULL, NULL, NULL, NULL, NULL, 4),
(214526, NULL, 'G3DSA:2.60.40.10:FF:003456', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214527, NULL, 'G3DSA:3.70.10.10:FF:000040', NULL, NULL, 'DNA polymerase sliding clamp', NULL, NULL, NULL, NULL, NULL, 4),
(214528, NULL, 'G3DSA:3.40.50.10090:FF:000063', NULL, NULL, 'Uroporphyrin-III C-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(214529, NULL, 'G3DSA:3.30.160.60:FF:005710', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(214530, NULL, 'G3DSA:3.10.50.40:FF:000104', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(214531, NULL, 'G3DSA:2.60.40.10:FF:004867', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214532, NULL, 'G3DSA:2.10.25.10:FF:000096', NULL, NULL, 'Putative fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(214533, NULL, 'G3DSA:3.40.50.620:FF:000057', NULL, NULL, 'tRNA-specific 2-thiouridylase MnmA', NULL, NULL, NULL, NULL, NULL, 4),
(214534, NULL, 'G3DSA:3.90.70.80:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214535, NULL, 'G3DSA:3.40.50.11350:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214536, NULL, 'G3DSA:1.25.40.10:FF:005018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214537, NULL, 'G3DSA:3.40.850.10:FF:000384', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(214538, NULL, 'G3DSA:3.10.350.10:FF:000066', NULL, NULL, 'Lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(214539, NULL, 'G3DSA:1.20.120.850:FF:000035', NULL, NULL, 'DNA repair and recombination protein RAD54B', NULL, NULL, NULL, NULL, NULL, 4),
(214540, NULL, 'G3DSA:1.20.58.60:FF:000469', NULL, NULL, 'Protein CBG15811', NULL, NULL, NULL, NULL, NULL, 4),
(214541, NULL, 'G3DSA:3.50.50.60:FF:000558', NULL, NULL, 'Rab proteins geranylgeranyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(214542, NULL, 'G3DSA:1.25.10.10:FF:001155', NULL, NULL, 'Condensin-2 complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(214543, NULL, 'G3DSA:1.20.120.1750:FF:000099', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(214544, NULL, 'G3DSA:3.40.190.10:FF:000597', NULL, NULL, 'Ionotropic glutamate receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214545, NULL, 'G3DSA:3.30.160.60:FF:001770', NULL, NULL, 'Zinc finger protein 526', NULL, NULL, NULL, NULL, NULL, 4),
(214546, NULL, 'G3DSA:3.30.450.20:FF:000252', NULL, NULL, 'PAS sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(214547, NULL, 'G3DSA:1.25.40.10:FF:003332', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(214548, NULL, 'G3DSA:2.60.40.10:FF:003670', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214549, NULL, 'G3DSA:3.40.50.200:FF:000021', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5a', NULL, NULL, NULL, NULL, NULL, 4),
(214550, NULL, 'G3DSA:2.130.10.10:FF:005025', NULL, NULL, 'Protein HIR', NULL, NULL, NULL, NULL, NULL, 4),
(214551, NULL, 'G3DSA:3.40.50.10490:FF:000104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214552, NULL, 'G3DSA:3.30.160.60:FF:003456', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214553, NULL, 'G3DSA:4.10.1080.10:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214554, NULL, 'G3DSA:3.30.40.10:FF:002354', NULL, NULL, 'Nucleic acid binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214555, NULL, 'G3DSA:3.40.50.720:FF:000087', NULL, NULL, 'alpha-aminoadipic semialdehyde synthase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(214556, NULL, 'G3DSA:3.40.1110.10:FF:000260', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214557, NULL, 'G3DSA:2.60.40.2660:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214558, NULL, 'G3DSA:2.10.25.10:FF:000107', NULL, NULL, 'Fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(214559, NULL, 'G3DSA:3.50.50.60:FF:000772', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(214560, NULL, 'G3DSA:1.20.1050.120:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214561, NULL, 'G3DSA:3.30.1490.80:FF:000007', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(214562, NULL, 'G3DSA:1.20.120.740:FF:000002', NULL, NULL, 'UPF0149 protein XC_0904', NULL, NULL, NULL, NULL, NULL, 4),
(214563, NULL, 'G3DSA:3.30.70.660:FF:000064', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(214564, NULL, 'G3DSA:3.100.10.10:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214565, NULL, 'G3DSA:4.10.320.30:FF:000004', NULL, NULL, 'Myelin transcription factor 1a', NULL, NULL, NULL, NULL, NULL, 4),
(214566, NULL, 'G3DSA:2.30.40.10:FF:000052', NULL, NULL, 'Dihydroorotase', NULL, NULL, NULL, NULL, NULL, 4),
(214567, NULL, 'G3DSA:1.10.287.130:FF:000035', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(214568, NULL, 'G3DSA:2.60.120.200:FF:000746', NULL, NULL, 'AGAP011278-PA', NULL, NULL, NULL, NULL, NULL, 4),
(214569, NULL, 'G3DSA:3.90.1150.10:FF:000419', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214570, NULL, 'G3DSA:3.40.50.300:FF:002203', NULL, NULL, 'ATP-dependent RNA helicase (Hrh1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(214571, NULL, 'G3DSA:3.20.20.140:FF:000271', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214572, NULL, 'G3DSA:3.40.50.1820:FF:001202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214573, NULL, 'G3DSA:3.80.10.10:FF:002119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214574, NULL, 'G3DSA:3.30.160.60:FF:005805', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214575, NULL, 'G3DSA:1.25.40.420:FF:000033', NULL, NULL, 'BTB/POZ domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(214576, NULL, 'G3DSA:1.10.8.60:FF:000235', NULL, NULL, 'ATPase, AAA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(214577, NULL, 'G3DSA:3.30.70.1230:FF:000230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214578, NULL, 'G3DSA:3.30.450.60:FF:000005', NULL, NULL, 'AP complex subunit sigma', NULL, NULL, NULL, NULL, NULL, 4),
(214579, NULL, 'G3DSA:1.25.10.10:FF:000975', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(214580, NULL, 'G3DSA:1.10.10.10:FF:001424', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(214581, NULL, 'G3DSA:1.10.840.10:FF:000004', NULL, NULL, 'ras-specific guanine nucleotide-releasing factor 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(214582, NULL, 'G3DSA:3.30.70.590:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214583, NULL, 'G3DSA:2.60.120.290:FF:000172', NULL, NULL, 'Multiple epidermal growth factor-like domains protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(214584, NULL, 'G3DSA:3.40.50.300:FF:005290', NULL, NULL, 'Gluconokinase', NULL, NULL, NULL, NULL, NULL, 4),
(214585, NULL, 'G3DSA:3.40.50.300:FF:005626', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(214586, NULL, 'G3DSA:1.10.1040.10:FF:000083', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(214587, NULL, 'G3DSA:3.30.160.60:FF:003905', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214588, NULL, 'G3DSA:3.30.450.50:FF:000002', NULL, NULL, 'Vesicle-associated membrane protein 722', NULL, NULL, NULL, NULL, NULL, 4),
(214589, NULL, 'G3DSA:3.40.50.300:FF:001591', NULL, NULL, 'Primosomal protein N''', NULL, NULL, NULL, NULL, NULL, 4),
(214590, NULL, 'G3DSA:1.10.287.70:FF:000281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214591, NULL, 'G3DSA:3.40.50.300:FF:001927', NULL, NULL, 'Nucleolar GTP-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(214592, NULL, 'G3DSA:1.10.287.70:FF:000617', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214593, NULL, 'G3DSA:2.10.25.10:FF:000079', NULL, NULL, 'Attractin like 1', NULL, NULL, NULL, NULL, NULL, 4),
(214594, NULL, 'G3DSA:1.20.120.350:FF:000110', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(214595, NULL, 'G3DSA:1.20.1070.10:FF:000751', NULL, NULL, 'Adhesion G protein-coupled receptor L3', NULL, NULL, NULL, NULL, NULL, 4),
(214596, NULL, 'G3DSA:3.40.50.300:FF:003726', NULL, NULL, 'WGS project CABT00000000 data, contig 2.2', NULL, NULL, NULL, NULL, NULL, 4),
(214597, NULL, 'G3DSA:1.20.59.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(214598, NULL, 'G3DSA:2.60.120.200:FF:000297', NULL, NULL, 'MAM and LDL-receptor class A domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(214599, NULL, 'G3DSA:3.40.710.10:FF:000014', NULL, NULL, 'Glutaminase', NULL, NULL, NULL, NULL, NULL, 4),
(214600, NULL, 'G3DSA:2.130.10.10:FF:003434', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214601, NULL, 'G3DSA:3.60.110.10:FF:000059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214602, NULL, 'G3DSA:3.30.1050.10:FF:000038', NULL, NULL, 'Alkyl/aryl-sulfatase BDS1', NULL, NULL, NULL, NULL, NULL, 4),
(214603, NULL, 'G3DSA:1.20.1250.20:FF:000190', NULL, NULL, 'Sugar transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(214604, NULL, 'G3DSA:3.40.50.620:FF:000383', NULL, NULL, 'LD26737p', NULL, NULL, NULL, NULL, NULL, 4),
(214605, NULL, 'G3DSA:1.20.1250.20:FF:000526', NULL, NULL, 'Tetracycline resistance protein TetL', NULL, NULL, NULL, NULL, NULL, 4),
(214606, NULL, 'G3DSA:3.40.50.620:FF:000719', NULL, NULL, '7-cyano-7-deazaguanine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(214607, NULL, 'G3DSA:1.20.5.2210:FF:000004', NULL, NULL, 'ATP Synthase B homolog', NULL, NULL, NULL, NULL, NULL, 4),
(214608, NULL, 'G3DSA:3.20.20.70:FF:000510', NULL, NULL, 'Dihydroorotate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(214609, NULL, 'G3DSA:3.30.460.10:FF:000058', NULL, NULL, 'Interleukin enhancer-binding factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(214610, NULL, 'G3DSA:2.10.25.10:FF:000433', NULL, NULL, 'Laminin subunit gamma 3', NULL, NULL, NULL, NULL, NULL, 4),
(214611, NULL, 'G3DSA:2.60.120.260:FF:000399', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(214612, NULL, 'G3DSA:3.90.1030.10:FF:000017', NULL, NULL, '50S ribosomal protein L17', NULL, NULL, NULL, NULL, NULL, 4),
(214613, NULL, 'G3DSA:3.30.200.20:FF:001711', NULL, NULL, 'Serine/threonine-protein kinase RIO2', NULL, NULL, NULL, NULL, NULL, 4),
(214614, NULL, 'G3DSA:3.30.559.10:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214615, NULL, 'G3DSA:3.20.20.80:FF:000513', NULL, NULL, 'Di-N-acetylchitobiase', NULL, NULL, NULL, NULL, NULL, 4),
(214616, NULL, 'G3DSA:1.25.40.10:FF:001078', NULL, NULL, 'Pre-mRNA-splicing factor SYF1', NULL, NULL, NULL, NULL, NULL, 4),
(214617, NULL, 'G3DSA:1.10.510.10:FF:002857', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214618, NULL, 'G3DSA:2.40.50.140:FF:000658', NULL, NULL, 'Transcription elongation factor SPT6-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(214619, NULL, 'G3DSA:3.90.180.10:FF:000074', NULL, NULL, 'Glucose 1-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(214620, NULL, 'G3DSA:3.40.50.800:FF:000122', NULL, NULL, 'Histidine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(214621, NULL, 'G3DSA:3.30.450.20:FF:000235', NULL, NULL, 'Signal transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(214622, NULL, 'G3DSA:1.20.58.90:FF:000012', NULL, NULL, 'SNARE domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(214623, NULL, 'G3DSA:2.130.10.10:FF:005463', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214624, NULL, 'G3DSA:1.10.10.60:FF:000101', NULL, NULL, 'NK2 homeobox 8', NULL, NULL, NULL, NULL, NULL, 4),
(214625, NULL, 'G3DSA:4.10.760.10:FF:000003', NULL, NULL, 'Agouti-related peptide 2', NULL, NULL, NULL, NULL, NULL, 4),
(214626, NULL, 'G3DSA:2.140.10.30:FF:000011', NULL, NULL, 'Acylaminoacyl-peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(214627, NULL, 'G3DSA:2.60.120.200:FF:000651', NULL, NULL, 'Fat1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(214628, NULL, 'G3DSA:3.40.720.10:FF:000172', NULL, NULL, 'Alkaline-phosphatase-like family protein', NULL, NULL, NULL, NULL, NULL, 4),
(214629, NULL, 'G3DSA:3.40.50.360:FF:000041', NULL, NULL, 'NAD(P)H-dependent FMN reductase', NULL, NULL, NULL, NULL, NULL, 4),
(214630, NULL, 'G3DSA:1.10.30.20:FF:000001', NULL, NULL, 'DNA repair helicase rad15', NULL, NULL, NULL, NULL, NULL, 4),
(214631, NULL, 'G3DSA:3.40.390.10:FF:000039', NULL, NULL, 'Peptidase M3', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(214632, NULL, 'G3DSA:3.40.50.2300:FF:001015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214633, NULL, 'G3DSA:3.10.580.10:FF:000212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214634, NULL, 'G3DSA:3.40.1280.30:FF:000002', NULL, NULL, 'tRNA methyltransferase 10 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(214635, NULL, 'G3DSA:1.20.58.60:FF:000823', NULL, NULL, 'Spectrin repeat containing nuclear envelope protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(214636, NULL, 'G3DSA:1.20.920.10:FF:000115', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(214637, NULL, 'G3DSA:2.30.30.190:FF:000019', NULL, NULL, 'Associated kinase of Tb14-3-3', NULL, NULL, NULL, NULL, NULL, 4),
(214638, NULL, 'G3DSA:3.30.70.330:FF:002792', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214639, NULL, 'G3DSA:3.30.1370.110:FF:000032', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(214640, NULL, 'G3DSA:3.10.580.10:FF:000116', NULL, NULL, 'Domain_of_uncharacterized_function_DUF21_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(214641, NULL, 'G3DSA:2.40.30.30:FF:000023', NULL, NULL, 'Riboflavin kinase, FMN adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(214642, NULL, 'G3DSA:3.40.50.2300:FF:000739', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(214643, NULL, 'G3DSA:3.30.40.10:FF:000667', NULL, NULL, 'Phosphatidylinositol kinase (PIK-D)', NULL, NULL, NULL, NULL, NULL, 4),
(214644, NULL, 'G3DSA:3.40.50.1400:FF:000014', NULL, NULL, 'Ferrochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(214645, NULL, 'G3DSA:3.40.50.720:FF:000750', NULL, NULL, 'YGL159W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(214646, NULL, 'G3DSA:3.30.160.60:FF:001427', NULL, NULL, 'Zinc finger 45-like', NULL, NULL, NULL, NULL, NULL, 4),
(214647, NULL, 'G3DSA:3.30.70.330:FF:002466', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214648, NULL, 'G3DSA:2.40.30.20:FF:000020', NULL, NULL, 'Vacuolar ATP synthase catalytic subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(214649, NULL, 'G3DSA:1.10.600.10:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214650, NULL, 'G3DSA:1.25.10.10:FF:002678', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214651, NULL, 'G3DSA:1.20.120.310:FF:000008', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(214652, NULL, 'G3DSA:2.30.29.30:FF:000609', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(214653, NULL, 'G3DSA:3.30.300.70:FF:000008', NULL, NULL, 'Ribosome maturation factor RimP', NULL, NULL, NULL, NULL, NULL, 4),
(214654, NULL, 'G3DSA:2.40.50.140:FF:000984', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214655, NULL, 'G3DSA:1.25.40.570:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214656, NULL, 'G3DSA:3.40.50.300:FF:003491', NULL, NULL, 'RAB39A, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(214657, NULL, 'G3DSA:1.10.8.10:FF:000136', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(214658, NULL, 'G3DSA:3.90.45.10:FF:000030', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(214659, NULL, 'G3DSA:3.30.420.40:FF:000868', NULL, NULL, 'O-sialoglycoprotein endopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214660, NULL, 'G3DSA:1.50.10.10:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214661, NULL, 'G3DSA:2.20.25.230:FF:000001', NULL, NULL, 'protein zwilch homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(214662, NULL, 'G3DSA:3.30.200.20:FF:001470', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(214663, NULL, 'G3DSA:2.102.20.10:FF:000002', NULL, NULL, 'Putative secreted beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(214664, NULL, 'G3DSA:3.30.70.270:FF:000166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214665, NULL, 'G3DSA:2.40.50.140:FF:001260', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(214666, NULL, 'G3DSA:1.10.390.10:FF:000031', NULL, NULL, 'Cytosol alanyl aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(214667, NULL, 'G3DSA:2.60.20.10:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214668, NULL, 'G3DSA:1.20.810.10:FF:000011', NULL, NULL, 'Cytochrome b/b6 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(214669, NULL, 'G3DSA:1.20.940.10:FF:000015', NULL, NULL, 'Yeast SEC homolog', NULL, NULL, NULL, NULL, NULL, 4),
(214670, NULL, 'G3DSA:3.20.20.190:FF:000027', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(214671, NULL, 'G3DSA:3.40.50.1820:FF:000601', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(214672, NULL, 'G3DSA:2.20.25.240:FF:000004', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(214673, NULL, 'G3DSA:1.20.1250.20:FF:002325', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214674, NULL, 'G3DSA:3.40.30.10:FF:000306', NULL, NULL, 'Peroxiredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(214675, NULL, 'G3DSA:3.30.420.10:FF:000404', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214676, NULL, 'G3DSA:1.10.1410.20:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214677, NULL, 'G3DSA:3.40.50.1360:FF:000064', NULL, NULL, '6-phosphogluconolactonase', NULL, NULL, NULL, NULL, NULL, 4),
(214678, NULL, 'G3DSA:2.130.10.10:FF:004957', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214679, NULL, 'G3DSA:1.10.1760.20:FF:000005', NULL, NULL, 'Biotin transporter', NULL, NULL, NULL, NULL, NULL, 4),
(214680, NULL, 'G3DSA:1.20.1720.10:FF:000043', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(214681, NULL, 'G3DSA:3.90.70.200:FF:000019', NULL, NULL, 'RNA polymerase-associated protein RTF1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(214682, NULL, 'G3DSA:4.10.410.10:FF:000022', NULL, NULL, 'WAP, Kazal, immunoglobulin, Kunitz and NTR domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(214683, NULL, 'G3DSA:1.20.1270.60:FF:000056', NULL, NULL, 'brain-specific angiogenesis inhibitor 1-associated protein 2-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(214684, NULL, 'G3DSA:3.40.50.150:FF:001394', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214685, NULL, 'G3DSA:2.30.42.10:FF:000567', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214686, NULL, 'G3DSA:3.40.50.1370:FF:000067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214687, NULL, 'G3DSA:3.60.10.10:FF:000029', NULL, NULL, 'Inositol polyphosphate 5-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(214688, NULL, 'G3DSA:3.30.470.20:FF:000247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214689, NULL, 'G3DSA:3.90.190.10:FF:000125', NULL, NULL, 'Dual specificity protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(214690, NULL, 'G3DSA:3.80.10.10:FF:003968', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214691, NULL, 'G3DSA:3.40.570.10:FF:000025', NULL, NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(214692, NULL, 'G3DSA:1.25.10.10:FF:001138', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(214693, NULL, 'G3DSA:1.10.1760.10:FF:000002', NULL, NULL, 'Actin-related protein 2/3 complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(214694, NULL, 'G3DSA:3.40.50.1820:FF:000685', NULL, NULL, '3-oxoadipate enol-lactone hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(214695, NULL, 'G3DSA:1.10.10.10:FF:001750', NULL, NULL, 'Endodeoxyribonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214696, NULL, 'G3DSA:2.130.10.10:FF:003108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214697, NULL, 'G3DSA:3.40.50.2000:FF:000970', NULL, NULL, 'Mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(214698, NULL, 'G3DSA:2.80.10.50:FF:000222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(214699, NULL, 'G3DSA:1.10.510.10:FF:003346', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214700, NULL, 'G3DSA:3.40.1110.10:FF:000243', NULL, NULL, 'Sarco/endoplasmic reticulum Ca2+ -ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(214701, NULL, 'G3DSA:2.40.37.10:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214702, NULL, 'G3DSA:3.30.70.260:FF:000163', NULL, NULL, 'Amino acid-binding ACT domain regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(214703, NULL, 'G3DSA:2.60.40.60:FF:000121', NULL, NULL, 'Protocadherin 17', NULL, NULL, NULL, NULL, NULL, 4),
(214704, NULL, 'G3DSA:3.30.230.10:FF:000154', NULL, NULL, 'MeValonate Kinase', NULL, NULL, NULL, NULL, NULL, 4),
(214705, NULL, 'G3DSA:3.40.50.720:FF:002099', NULL, NULL, 'Hydroxysteroid 11-beta-dehydrogenase 1-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(214706, NULL, 'G3DSA:2.130.10.10:FF:005008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214707, NULL, 'G3DSA:3.30.200.20:FF:000655', NULL, NULL, 'AGC/AKT protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(214708, NULL, 'G3DSA:2.30.29.30:FF:000486', NULL, NULL, 'Numb-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(214709, NULL, 'G3DSA:1.25.40.20:FF:001536', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214710, NULL, 'G3DSA:1.25.40.10:FF:001320', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g39350', NULL, NULL, NULL, NULL, NULL, 4),
(214711, NULL, 'G3DSA:1.10.260.40:FF:000036', NULL, NULL, 'LacI family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(214712, NULL, 'G3DSA:3.40.50.2300:FF:001341', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214713, NULL, 'G3DSA:3.80.10.10:FF:004457', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214714, NULL, 'G3DSA:1.25.50.20:FF:000053', NULL, NULL, 'Protein CBG09901', NULL, NULL, NULL, NULL, NULL, 4),
(214715, NULL, 'G3DSA:1.25.40.10:FF:001533', NULL, NULL, 'Cartilage associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(214716, NULL, 'G3DSA:2.30.180.10:FF:000012', NULL, NULL, 'Fasciclin-like arabinogalactan protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(214717, NULL, 'G3DSA:3.90.220.20:FF:000002', NULL, NULL, 'Type I restriction-modification system restriction endonuclease DNA specificity subunit HsdS', NULL, NULL, NULL, NULL, NULL, 4),
(214718, NULL, 'G3DSA:3.30.200.160:FF:000012', NULL, NULL, 'RNA polymerase III transcription factor subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214719, NULL, 'G3DSA:2.60.40.1930:FF:000023', NULL, NULL, 'MHC-linked complement C4', NULL, NULL, NULL, NULL, NULL, 4),
(214720, NULL, 'G3DSA:2.130.10.10:FF:001517', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214721, NULL, 'G3DSA:1.20.1250.10:FF:000068', NULL, NULL, 'Ciliary neurotrophic factor', NULL, NULL, NULL, NULL, NULL, 4),
(214722, NULL, 'G3DSA:3.40.50.300:FF:008499', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214723, NULL, 'G3DSA:3.40.1370.10:FF:000003', NULL, NULL, '50S ribosomal protein L4', NULL, NULL, NULL, NULL, NULL, 4),
(214724, NULL, 'G3DSA:3.40.1110.10:FF:000030', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(214725, NULL, 'G3DSA:3.30.160.60:FF:001753', NULL, NULL, 'Si:ch211-119o8.6', NULL, NULL, NULL, NULL, NULL, 4),
(214726, NULL, 'G3DSA:3.40.850.10:FF:000507', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214727, NULL, 'G3DSA:3.60.130.10:FF:000055', NULL, NULL, 'Butyrobetaine (gamma), 2-oxoglutarate dioxygenase (gamma-butyrobetaine hydroxylase) 1', NULL, NULL, NULL, NULL, NULL, 4),
(214728, NULL, 'G3DSA:1.50.10.10:FF:000118', NULL, NULL, 'AGL (Amylo-1,6-GLucosidase, 4-alpha-glucanotransferase) glycogen debranching enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(214729, NULL, 'G3DSA:1.20.1560.10:FF:000384', NULL, NULL, 'Putative ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(214730, NULL, 'G3DSA:3.40.630.30:FF:000171', NULL, NULL, 'Acetyltransferase, GNAT family', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(214731, NULL, 'G3DSA:3.30.70.100:FF:000143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214732, NULL, 'G3DSA:3.10.560.10:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214733, NULL, 'G3DSA:2.60.40.10:FF:001444', NULL, NULL, 'PKHD1, fibrocystin/polyductin', NULL, NULL, NULL, NULL, NULL, 4),
(214734, NULL, 'G3DSA:2.60.40.10:FF:003018', NULL, NULL, 'T cell receptor alpha constant', NULL, NULL, NULL, NULL, NULL, 4),
(214735, NULL, 'G3DSA:1.10.1520.10:FF:000125', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(214736, NULL, 'G3DSA:2.60.40.1730:FF:000070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214737, NULL, 'G3DSA:2.30.29.30:FF:000711', NULL, NULL, 'PH and Rap-GAP domain-containing protein DDB_G0271806', NULL, NULL, NULL, NULL, NULL, 4),
(214738, NULL, 'G3DSA:1.10.630.10:FF:000516', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(214739, NULL, 'G3DSA:3.10.20.90:FF:000140', NULL, NULL, 'RanBP-type and C3HC4-type zinc finger-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(214740, NULL, 'G3DSA:1.10.510.10:FF:001194', NULL, NULL, 'Calcium/calmodulin-dependent protein kinase type 1D, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214741, NULL, 'G3DSA:3.30.70.330:FF:000892', NULL, NULL, 'AGAP002655-PA', NULL, NULL, NULL, NULL, NULL, 4),
(214742, NULL, 'G3DSA:3.30.450.20:FF:000690', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(214743, NULL, 'G3DSA:1.10.340.30:FF:000085', NULL, NULL, '8-oxoguanine DNA glycosylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214744, NULL, 'G3DSA:2.60.40.10:FF:003911', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214745, NULL, 'G3DSA:2.60.220.50:FF:000145', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(214746, NULL, 'G3DSA:3.90.370.10:FF:000009', NULL, NULL, 'metalloproteinase inhibitor 3-like', NULL, NULL, NULL, NULL, NULL, 4),
(214747, NULL, 'G3DSA:3.90.25.10:FF:000028', NULL, NULL, 'UDP-glucose 4-epimerase GalE', NULL, NULL, NULL, NULL, NULL, 4),
(214748, NULL, 'G3DSA:3.40.50.20:FF:000069', NULL, NULL, 'Bifunctional purine synthesis protein purC/E', NULL, NULL, NULL, NULL, NULL, 4),
(214749, NULL, 'G3DSA:3.40.50.12780:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214750, NULL, 'G3DSA:3.40.50.12230:FF:000008', NULL, NULL, 'Formyl transferase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(214751, NULL, 'G3DSA:1.10.510.10:FF:001755', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(214752, NULL, 'G3DSA:3.40.50.1170:FF:000007', NULL, NULL, 'Asparaginase homolog (S. cerevisiae)', NULL, NULL, NULL, NULL, NULL, 4),
(214753, NULL, 'G3DSA:2.30.30.140:FF:000246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214754, NULL, 'G3DSA:2.60.40.10:FF:005373', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214755, NULL, 'G3DSA:1.10.565.10:FF:000162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214756, NULL, 'G3DSA:1.10.238.10:FF:000211', NULL, NULL, 'Mitochondrial calcium uptake family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(214757, NULL, 'G3DSA:3.90.320.10:FF:000063', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(214758, NULL, 'G3DSA:3.30.56.10:FF:000018', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(214759, NULL, 'G3DSA:3.40.50.620:FF:000512', NULL, NULL, 'Isoleucyl-tRNA synthetase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(214760, NULL, 'G3DSA:1.10.220.30:FF:000042', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(214761, NULL, 'G3DSA:2.30.29.30:FF:001200', NULL, NULL, 'Mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(214762, NULL, 'G3DSA:3.40.50.300:FF:003165', NULL, NULL, 'E3 ubiquitin-protein ligase SHPRH, variant', NULL, NULL, NULL, NULL, NULL, 4),
(214763, NULL, 'G3DSA:1.25.40.80:FF:000003', NULL, NULL, 'cryptochrome-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(214764, NULL, 'G3DSA:1.20.5.4130:FF:000001', NULL, NULL, 'NB-ARC domain containing protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(214765, NULL, 'G3DSA:3.40.50.300:FF:006599', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214766, NULL, 'G3DSA:3.40.50.300:FF:007088', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(214767, NULL, 'G3DSA:3.80.10.10:FF:000293', NULL, NULL, 'Protein phosphatase 1 regulatory subunit 42', NULL, NULL, NULL, NULL, NULL, 4),
(214768, NULL, 'G3DSA:2.30.42.10:FF:000129', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type 13', NULL, NULL, NULL, NULL, NULL, 4),
(214769, NULL, 'G3DSA:1.20.58.1610:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214770, NULL, 'G3DSA:2.40.50.140:FF:001046', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214771, NULL, 'G3DSA:3.30.1140.32:FF:000019', NULL, NULL, 'Putative ribosomal protein S3', NULL, NULL, NULL, NULL, NULL, 4),
(214772, NULL, 'G3DSA:2.160.20.80:FF:000003', NULL, NULL, 'thylakoid lumenal 15 kDa protein 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(214773, NULL, 'G3DSA:3.30.160.60:FF:003018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214774, NULL, 'G3DSA:3.30.1300.30:FF:000013', NULL, NULL, 'T2aSS secretion system pseudopilus protein GspI', NULL, NULL, NULL, NULL, NULL, 4),
(214775, NULL, 'G3DSA:3.10.290.70:FF:000005', NULL, NULL, '40S ribosomal protein S8', NULL, NULL, NULL, NULL, NULL, 4),
(214776, NULL, 'G3DSA:1.10.630.10:FF:000421', NULL, NULL, 'Kaurene oxidase2', NULL, NULL, NULL, NULL, NULL, 4),
(214777, NULL, 'G3DSA:3.40.50.11610:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214778, NULL, 'G3DSA:3.20.20.140:FF:000041', NULL, NULL, 'Dihydroorotase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(214779, NULL, 'G3DSA:1.10.287.70:FF:000393', NULL, NULL, 'Calcium channel, voltage-dependent, T type, alpha 1I subunit', NULL, NULL, NULL, NULL, NULL, 4),
(214780, NULL, 'G3DSA:3.40.850.10:FF:000288', NULL, NULL, 'Kinesin motor domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(214781, NULL, 'G3DSA:1.10.287.130:FF:000153', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(214782, NULL, 'G3DSA:1.10.287.70:FF:000505', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214783, NULL, 'G3DSA:3.40.190.10:FF:000485', NULL, NULL, 'Sensory box sensor histidine kinase/response regulator VieS', NULL, NULL, NULL, NULL, NULL, 4),
(214784, NULL, 'G3DSA:1.10.287.70:FF:000410', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214785, NULL, 'G3DSA:2.60.120.590:FF:000037', NULL, NULL, 'DNA oxidative demethylase ALKBH2', NULL, NULL, NULL, NULL, NULL, 4),
(214786, NULL, 'G3DSA:3.30.70.1730:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214787, NULL, 'G3DSA:1.20.1560.10:FF:000171', NULL, NULL, 'ATP-binding cassette (ABC) transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214788, NULL, 'G3DSA:3.40.50.10140:FF:000022', NULL, NULL, 'Myd88', NULL, NULL, NULL, NULL, NULL, 4),
(214789, NULL, 'G3DSA:2.10.25.10:FF:000545', NULL, NULL, 'von Willebrand factor C and EGF domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(214790, NULL, 'G3DSA:3.40.50.620:FF:000607', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(214791, NULL, 'G3DSA:3.40.190.80:FF:000022', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(214792, NULL, 'G3DSA:2.60.40.10:FF:005143', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214793, NULL, 'G3DSA:3.40.1620.10:FF:000001', NULL, NULL, 'Antitoxin', NULL, NULL, NULL, NULL, NULL, 4),
(214794, NULL, 'G3DSA:3.30.505.10:FF:000202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214795, NULL, 'G3DSA:1.20.1460.10:FF:000011', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(214796, NULL, 'G3DSA:3.50.30.30:FF:000082', NULL, NULL, 'Probable M28 family peptidase (Homolog to aminopeptidase YwaD)', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(214797, NULL, 'G3DSA:3.30.1360.120:FF:000100', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(214798, NULL, 'G3DSA:2.40.50.140:FF:000445', NULL, NULL, 'RNA Polymerase, Class III (C)', NULL, NULL, NULL, NULL, NULL, 4),
(214799, NULL, 'G3DSA:1.10.287.70:FF:000404', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214800, NULL, 'G3DSA:3.40.710.10:FF:000126', NULL, NULL, 'Penicillin-binding protein 1A (PBP-1A)', NULL, NULL, NULL, NULL, NULL, 4),
(214801, NULL, 'G3DSA:3.40.50.620:FF:000596', NULL, NULL, 'tRNA-specific 2-thiouridylase MnmA protein', NULL, NULL, NULL, NULL, NULL, 4),
(214802, NULL, 'G3DSA:3.30.200.20:FF:000868', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214803, NULL, 'G3DSA:1.20.1050.10:FF:000093', NULL, NULL, 'Glutathione-S-transferase/glutaredoxin,putative', NULL, NULL, NULL, NULL, NULL, 4),
(214804, NULL, 'G3DSA:2.170.16.10:FF:000051', NULL, NULL, 'DNA gyrase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(214805, NULL, 'G3DSA:2.130.10.10:FF:002945', NULL, NULL, 'Cytoplasmic dynein 1 intermediate chain', NULL, NULL, NULL, NULL, NULL, 4),
(214806, NULL, 'G3DSA:2.60.40.10:FF:001871', NULL, NULL, 'protein sidekick isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(214807, NULL, 'G3DSA:3.40.50.800:FF:000010', NULL, NULL, 'Putative nuclear receptor coactivator 5', NULL, NULL, NULL, NULL, NULL, 4),
(214808, NULL, 'G3DSA:1.20.1540.10:FF:000057', NULL, NULL, 'Peptidase, S54 family', NULL, NULL, NULL, NULL, NULL, 4),
(214809, NULL, 'G3DSA:3.40.50.300:FF:007217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214810, NULL, 'G3DSA:3.40.50.620:FF:000495', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214811, NULL, 'G3DSA:3.90.660.10:FF:000088', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214812, NULL, 'G3DSA:3.90.70.80:FF:000075', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(214813, NULL, 'G3DSA:1.10.10.60:FF:000894', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214814, NULL, 'G3DSA:3.40.50.2000:FF:000644', NULL, NULL, 'Os11g0461200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(214815, NULL, 'G3DSA:3.30.1360.40:FF:000019', NULL, NULL, 'Multifunctional urea amidolyase', NULL, NULL, NULL, NULL, NULL, 4),
(214816, NULL, 'G3DSA:3.60.10.10:FF:000361', NULL, NULL, 'DNA-(apurinic or apyrimidinic site) lyase', NULL, NULL, NULL, NULL, NULL, 4),
(214817, NULL, 'G3DSA:2.60.120.200:FF:000185', NULL, NULL, 'EGF like domain multiple 6', NULL, NULL, NULL, NULL, NULL, 4),
(214818, NULL, 'G3DSA:3.40.50.300:FF:001809', NULL, NULL, 'Si:ch1073-365p7.2', NULL, NULL, NULL, NULL, NULL, 4),
(214819, NULL, 'G3DSA:1.10.10.10:FF:001071', NULL, NULL, 'Selenocysteine-specific elongation factor', NULL, NULL, NULL, NULL, NULL, 4),
(214820, NULL, 'G3DSA:1.10.287.470:FF:000002', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(214821, NULL, 'G3DSA:3.40.50.11260:FF:000009', NULL, NULL, 'Chaperone protein HtpG', NULL, NULL, NULL, NULL, NULL, 4),
(214822, NULL, 'G3DSA:1.25.40.20:FF:001199', NULL, NULL, 'Poly [ADP-ribose] polymerase tankyrase', NULL, NULL, NULL, NULL, NULL, 4),
(214823, NULL, 'G3DSA:1.25.40.120:FF:000033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(214824, NULL, 'G3DSA:1.20.5.4880:FF:000001', NULL, NULL, 'Guanine nucleotide exchange factor for Rab-3A', NULL, NULL, NULL, NULL, NULL, 4),
(214825, NULL, 'G3DSA:3.40.50.12780:FF:000038', NULL, NULL, 'Ebony protein', NULL, NULL, NULL, NULL, NULL, 4),
(214826, NULL, 'G3DSA:3.40.50.620:FF:000720', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214827, NULL, 'G3DSA:3.20.20.330:FF:000007', NULL, NULL, 'Homocysteine S-methyltransferase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(214828, NULL, 'G3DSA:2.130.10.10:FF:001309', NULL, NULL, 'Probable cytosolic iron-sulfur protein assembly protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(214829, NULL, 'G3DSA:1.10.510.10:FF:003913', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(214830, NULL, 'G3DSA:3.40.720.10:FF:000054', NULL, NULL, 'non-specific phospholipase C6', NULL, NULL, NULL, NULL, NULL, 4),
(214831, NULL, 'G3DSA:3.90.640.10:FF:000093', NULL, NULL, 'Hsp70 protein/TPR repeat/Tetratricopeptide repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214832, NULL, 'G3DSA:3.20.20.70:FF:000173', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(214833, NULL, 'G3DSA:3.10.450.50:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214834, NULL, 'G3DSA:3.30.40.100:FF:000002', NULL, NULL, 'Lysine-specific histone demethylase 1B', NULL, NULL, NULL, NULL, NULL, 4),
(214835, NULL, 'G3DSA:3.30.70.270:FF:000284', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214836, NULL, 'G3DSA:3.40.50.200:FF:000133', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(214837, NULL, 'G3DSA:1.10.630.10:FF:000308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214838, NULL, 'G3DSA:1.10.238.10:FF:001167', NULL, NULL, 'Voltage-dependent N-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(214839, NULL, 'G3DSA:1.20.5.320:FF:000029', NULL, NULL, 'Collagen alpha-1(XVII) chain', NULL, NULL, NULL, NULL, NULL, 4),
(214840, NULL, 'G3DSA:1.50.40.10:FF:000401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214841, NULL, 'G3DSA:3.30.505.10:FF:000101', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(214842, NULL, 'G3DSA:2.10.25.10:FF:000646', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(214843, NULL, 'G3DSA:3.40.50.620:FF:000506', NULL, NULL, 'DNA photolyase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(214844, NULL, 'G3DSA:3.30.160.60:FF:003344', NULL, NULL, 'Zinc finger protein 343', NULL, NULL, NULL, NULL, NULL, 4),
(214845, NULL, 'G3DSA:3.40.50.300:FF:006014', NULL, NULL, 'MutS domain V domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(214846, NULL, 'G3DSA:2.60.120.430:FF:000017', NULL, NULL, 'PA-I galactophilic lectin', NULL, NULL, NULL, NULL, NULL, 4),
(214847, NULL, 'G3DSA:3.80.10.10:FF:004244', NULL, NULL, 'Leucine rich repeat containing G protein-coupled receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(214848, NULL, 'G3DSA:3.40.50.1460:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214849, NULL, 'G3DSA:3.30.930.10:FF:000050', NULL, NULL, 'Bifunctional ligase/repressor BirA', NULL, NULL, NULL, NULL, NULL, 4),
(214850, NULL, 'G3DSA:2.40.240.10:FF:000009', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(214851, NULL, 'G3DSA:3.40.50.1820:FF:000814', NULL, NULL, 'GPI inositol-deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(214852, NULL, 'G3DSA:1.20.5.170:FF:000063', NULL, NULL, 'G-box binding factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(214853, NULL, 'G3DSA:1.20.1250.20:FF:000397', NULL, NULL, 'Aminotriazole resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(214854, NULL, 'G3DSA:3.40.33.10:FF:000105', NULL, NULL, 'Pathogenesis-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(214855, NULL, 'G3DSA:3.30.70.330:FF:002348', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214856, NULL, 'G3DSA:2.130.10.10:FF:001523', NULL, NULL, 'Splicing factor 3b subunit 3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214857, NULL, 'G3DSA:1.25.40.10:FF:002944', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g09220, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(214858, NULL, 'G3DSA:2.60.40.60:FF:000689', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(214859, NULL, 'G3DSA:3.90.228.20:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214860, NULL, 'G3DSA:1.25.10.10:FF:001705', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214861, NULL, 'G3DSA:3.90.228.10:FF:000011', NULL, NULL, 'Poly(ADP-ribose) polymerase family member 9', NULL, NULL, NULL, NULL, NULL, 4),
(214862, NULL, 'G3DSA:3.10.290.60:FF:000002', NULL, NULL, 'Ubiquitin-like modifier-activating enzyme 1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(214863, NULL, 'G3DSA:3.20.20.80:FF:000176', NULL, NULL, 'Glycoside hydrolase family 128 protein', NULL, NULL, NULL, NULL, NULL, 4),
(214864, NULL, 'G3DSA:1.10.287.10:FF:000061', NULL, NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(214865, NULL, 'G3DSA:1.10.630.10:FF:000522', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214866, NULL, 'G3DSA:1.20.1740.10:FF:000044', NULL, NULL, 'Amino acid permease', NULL, NULL, NULL, NULL, NULL, 4),
(214867, NULL, 'G3DSA:4.10.240.10:FF:000205', NULL, NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(214868, NULL, 'G3DSA:3.40.20.10:FF:000031', NULL, NULL, 'protein flightless-1 homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(214869, NULL, 'G3DSA:1.25.40.1040:FF:000053', NULL, NULL, 'RNA processing protein', NULL, NULL, NULL, NULL, NULL, 4),
(214870, NULL, 'G3DSA:3.40.850.10:FF:000513', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214871, NULL, 'G3DSA:1.20.58.60:FF:000262', NULL, NULL, 'Uncharacterized protein, isoform J', NULL, NULL, NULL, NULL, NULL, 4),
(214872, NULL, 'G3DSA:3.30.1370.10:FF:000197', NULL, NULL, 'KH domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(214873, NULL, 'G3DSA:3.10.110.10:FF:000189', NULL, NULL, 'UBE2M isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(214874, NULL, 'G3DSA:1.25.40.10:FF:001527', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(214875, NULL, 'G3DSA:4.10.280.110:FF:000011', NULL, NULL, 'Pre-mRNA splicing factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214876, NULL, 'G3DSA:3.30.470.10:FF:000014', NULL, NULL, 'Branched-chain amino acid aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(214877, NULL, 'G3DSA:3.30.559.10:FF:000057', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(214878, NULL, 'G3DSA:3.80.10.10:FF:002327', NULL, NULL, 'Antagonist of mitotic exit network protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(214879, NULL, 'G3DSA:3.20.20.80:FF:000390', NULL, NULL, 'Malto-oligosyltrehalose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(214880, NULL, 'G3DSA:2.60.40.10:FF:005822', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214881, NULL, 'G3DSA:3.90.190.10:FF:000237', NULL, NULL, 'Protein-tyrosine phosphatase SHP-1', NULL, NULL, NULL, NULL, NULL, 4),
(214882, NULL, 'G3DSA:2.30.29.30:FF:000256', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(214883, NULL, 'G3DSA:3.30.420.10:FF:000393', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214884, NULL, 'G3DSA:3.30.40.10:FF:000908', NULL, NULL, 'Neuralized E3 ubiquitin protein ligase 1Ab', NULL, NULL, NULL, NULL, NULL, 4),
(214885, NULL, 'G3DSA:1.20.5.170:FF:000158', NULL, NULL, 'BZIP transcription factor family', NULL, NULL, NULL, NULL, NULL, 4),
(214886, NULL, 'G3DSA:1.25.40.10:FF:003450', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At1g13800', NULL, NULL, NULL, NULL, NULL, 4),
(214887, NULL, 'G3DSA:3.30.70.330:FF:000779', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(214888, NULL, 'G3DSA:1.20.1730.10:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214889, NULL, 'G3DSA:3.30.60.270:FF:000006', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(214890, NULL, 'G3DSA:1.10.260.40:FF:000042', NULL, NULL, 'LacI family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(214891, NULL, 'G3DSA:3.40.50.300:FF:005076', NULL, NULL, 'BMS1, ribosome biogenesis factor', NULL, NULL, NULL, NULL, NULL, 4),
(214892, NULL, 'G3DSA:2.30.29.30:FF:000374', NULL, NULL, 'insulin receptor substrate 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(214893, NULL, 'G3DSA:3.30.1490.480:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214894, NULL, 'G3DSA:2.60.40.770:FF:000026', NULL, NULL, 'Secreted protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214895, NULL, 'G3DSA:3.30.160.60:FF:005356', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(214896, NULL, 'G3DSA:2.60.40.10:FF:000016', NULL, NULL, 'Fibroblast growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(214897, NULL, 'G3DSA:3.30.40.10:FF:000454', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(214898, NULL, 'G3DSA:3.60.20.10:FF:000069', NULL, NULL, 'Proteasome subunit beta 12', NULL, NULL, NULL, NULL, NULL, 4),
(214899, NULL, 'G3DSA:3.30.70.330:FF:001504', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214900, NULL, 'G3DSA:3.40.50.300:FF:005177', NULL, NULL, 'Cytidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(214901, NULL, 'G3DSA:3.60.40.10:FF:000071', NULL, NULL, 'Stage II sporulation protein E', NULL, NULL, NULL, NULL, NULL, 4),
(214902, NULL, 'G3DSA:1.25.40.10:FF:004647', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(214903, NULL, 'G3DSA:1.20.1250.20:FF:001015', NULL, NULL, 'Os01g0386600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(214904, NULL, 'G3DSA:2.60.120.10:FF:000423', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214905, NULL, 'G3DSA:3.40.50.410:FF:000084', NULL, NULL, 'Transcription factor TFIIH subunit Tfb4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(214906, NULL, 'G3DSA:3.90.190.10:FF:000355', NULL, NULL, 'Protein-tyrosine phosphatase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(214907, NULL, 'G3DSA:1.25.40.1030:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214908, NULL, 'G3DSA:1.20.1070.10:FF:000425', NULL, NULL, 'Trissin receptor, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(214909, NULL, 'G3DSA:1.10.10.60:FF:001175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214910, NULL, 'G3DSA:3.100.10.10:FF:000060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214911, NULL, 'G3DSA:3.40.50.10190:FF:000093', NULL, NULL, 'DNA-binding protein RAP1', NULL, NULL, NULL, NULL, NULL, 4),
(214912, NULL, 'G3DSA:3.40.50.300:FF:007537', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214913, NULL, 'G3DSA:1.10.287.130:FF:000248', NULL, NULL, 'Hybrid sensory kinase', NULL, NULL, NULL, NULL, NULL, 4),
(214914, NULL, 'G3DSA:1.10.3380.10:FF:000035', NULL, NULL, 'YALI0F20724p', NULL, NULL, NULL, NULL, NULL, 4),
(214915, NULL, 'G3DSA:1.10.150.110:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214916, NULL, 'G3DSA:3.80.10.10:FF:000646', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine-protein kinase BAM3', NULL, NULL, NULL, NULL, NULL, 4),
(214917, NULL, 'G3DSA:3.30.300.30:FF:000126', NULL, NULL, '8-demethylnovobiocic acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(214918, NULL, 'G3DSA:3.30.160.60:FF:002141', NULL, NULL, 'Zinc finger and SCAN domain-containing protein 22', NULL, NULL, NULL, NULL, NULL, 4),
(214919, NULL, 'G3DSA:2.30.29.30:FF:000935', NULL, NULL, 'Rho GTPase-activating protein gacJJ', NULL, NULL, NULL, NULL, NULL, 4),
(214920, NULL, 'G3DSA:3.30.160.20:FF:000246', NULL, NULL, 'RNA interference promoting factor', NULL, NULL, NULL, NULL, NULL, 4),
(214921, NULL, 'G3DSA:1.20.1560.10:FF:000951', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214922, NULL, 'G3DSA:4.10.240.10:FF:000082', NULL, NULL, 'Zn(II)2Cys6 transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(214923, NULL, 'G3DSA:1.10.510.10:FF:003801', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214924, NULL, 'G3DSA:3.40.50.150:FF:001517', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214925, NULL, 'G3DSA:1.25.40.10:FF:001432', NULL, NULL, 'Si:ch211-166a6.5', NULL, NULL, NULL, NULL, NULL, 4),
(214926, NULL, 'G3DSA:2.60.40.10:FF:001770', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(214927, NULL, 'G3DSA:3.30.1490.190:FF:000015', NULL, NULL, 'Transcriptional regulator PerR', NULL, NULL, NULL, NULL, NULL, 4),
(214928, NULL, 'G3DSA:3.40.309.10:FF:000065', NULL, NULL, 'Aldehyde dehydrogenase3', NULL, NULL, NULL, NULL, NULL, 4),
(214929, NULL, 'G3DSA:1.25.40.20:FF:001435', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(214930, NULL, 'G3DSA:1.20.1560.10:FF:000058', NULL, NULL, 'ABC transporter B family member 25', NULL, NULL, NULL, NULL, NULL, 4),
(214931, NULL, 'G3DSA:3.30.40.10:FF:001061', NULL, NULL, 'E3 ubiquitin-protein ligase CCNP1IP1', NULL, NULL, NULL, NULL, NULL, 4),
(214932, NULL, 'G3DSA:1.25.40.10:FF:003118', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(214933, NULL, 'G3DSA:1.10.238.10:FF:001055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214934, NULL, 'G3DSA:3.40.20.10:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214935, NULL, 'G3DSA:2.60.40.60:FF:001077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214936, NULL, 'G3DSA:2.10.25.10:FF:000192', NULL, NULL, 'FAT atypical cadherin 3', NULL, NULL, NULL, NULL, NULL, 4),
(214937, NULL, 'G3DSA:1.20.1440.200:FF:000010', NULL, NULL, 'Vacuolar protein sorting-associated protein 28', NULL, NULL, NULL, NULL, NULL, 4),
(214938, NULL, 'G3DSA:3.80.10.10:FF:004356', NULL, NULL, 'Si:ch73-286h23.4', NULL, NULL, NULL, NULL, NULL, 4),
(214939, NULL, 'G3DSA:3.30.450.20:FF:000465', NULL, NULL, 'Neuronal PAS domain protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(214940, NULL, 'G3DSA:3.30.930.10:FF:000151', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(214941, NULL, 'G3DSA:3.40.50.300:FF:003485', NULL, NULL, 'DNA helicase MCM9 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(214942, NULL, 'G3DSA:3.40.50.2300:FF:000627', NULL, NULL, 'GLutamate Receptor family (AMPA)', NULL, NULL, NULL, NULL, NULL, 4),
(214943, NULL, 'G3DSA:3.30.1490.180:FF:000012', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(214944, NULL, 'G3DSA:3.40.50.800:FF:000116', NULL, NULL, 'Prolyl Amino-acyl tRNA Synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(214945, NULL, 'G3DSA:3.30.70.1230:FF:000016', NULL, NULL, 'Adenylate/guanylate cyclase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(214946, NULL, 'G3DSA:1.25.40.20:FF:001862', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(214947, NULL, 'G3DSA:2.130.10.10:FF:003552', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214948, NULL, 'G3DSA:2.60.40.10:FF:002967', NULL, NULL, 'Protein tyrosine phosphatase receptor type Ja', NULL, NULL, NULL, NULL, NULL, 4),
(214949, NULL, 'G3DSA:3.40.50.150:FF:001731', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214950, NULL, 'G3DSA:3.30.70.141:FF:000027', NULL, NULL, 'GG17026', NULL, NULL, NULL, NULL, NULL, 4),
(214951, NULL, 'G3DSA:3.30.710.10:FF:000409', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214952, NULL, 'G3DSA:1.10.357.140:FF:000009', NULL, NULL, 'homogentisate solanesyltransferase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(214953, NULL, 'G3DSA:1.25.40.10:FF:000595', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(214954, NULL, 'G3DSA:2.60.40.10:FF:001219', NULL, NULL, 'tyrosine-protein phosphatase Lar isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(214955, NULL, 'G3DSA:2.60.120.260:FF:000528', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214956, NULL, 'G3DSA:3.40.50.300:FF:007330', NULL, NULL, 'Protein CBR-WHT-1', NULL, NULL, NULL, NULL, NULL, 4),
(214957, NULL, 'G3DSA:3.90.870.10:FF:000025', NULL, NULL, '3,4-dihydroxy-2-butanone 4-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(214958, NULL, 'G3DSA:4.10.400.10:FF:000302', NULL, NULL, 'Megalin, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(214959, NULL, 'G3DSA:2.60.200.40:FF:000028', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(214960, NULL, 'G3DSA:2.170.150.40:FF:000003', NULL, NULL, 'DUF427 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(214961, NULL, 'G3DSA:3.50.50.60:FF:001261', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(214962, NULL, 'G3DSA:1.20.920.10:FF:000020', NULL, NULL, 'Transcription initiation factor TFIID subunit', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(214963, NULL, 'G3DSA:1.10.555.10:FF:000116', NULL, NULL, 'EG:86E4.5 protein', NULL, NULL, NULL, NULL, NULL, 4),
(214964, NULL, 'G3DSA:1.25.40.720:FF:000016', NULL, NULL, 'YALI0D22979p', NULL, NULL, NULL, NULL, NULL, 4),
(214965, NULL, 'G3DSA:1.25.10.10:FF:003381', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214966, NULL, 'G3DSA:1.20.58.60:FF:000582', NULL, NULL, 'SEC14 domain and spectrin repeat-containing protein 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(214967, NULL, 'G3DSA:3.40.50.970:FF:000139', NULL, NULL, 'Pyruvate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(214968, NULL, 'G3DSA:3.40.1170.60:FF:000008', NULL, NULL, 'DNA polymerase eta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(214969, NULL, 'G3DSA:1.10.510.10:FF:003560', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214970, NULL, 'G3DSA:1.25.40.10:FF:003219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214971, NULL, 'G3DSA:1.25.40.10:FF:001319', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(214972, NULL, 'G3DSA:3.90.640.10:FF:000216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214973, NULL, 'G3DSA:1.20.58.1220:FF:000005', NULL, NULL, 'Os07g0568000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(214974, NULL, 'G3DSA:1.25.40.180:FF:000253', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(214975, NULL, 'G3DSA:3.30.300.30:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214976, NULL, 'G3DSA:3.20.20.80:FF:000412', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214977, NULL, 'G3DSA:3.30.1490.70:FF:000010', NULL, NULL, 'Ligase III, DNA, ATP-dependent', NULL, NULL, NULL, NULL, NULL, 4),
(214978, NULL, 'G3DSA:1.10.8.10:FF:000041', NULL, NULL, 'ubiquitin-like protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(214979, NULL, 'G3DSA:3.60.10.10:FF:000243', NULL, NULL, 'Endonuclease/exonuclease/phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(214980, NULL, 'G3DSA:1.20.1560.10:FF:000619', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214981, NULL, 'G3DSA:3.30.1490.80:FF:000013', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(214982, NULL, 'G3DSA:2.30.30.140:FF:000151', NULL, NULL, 'Tapas, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(214983, NULL, 'G3DSA:1.20.58.1210:FF:000002', NULL, NULL, 'Exocyst complex component EXO84B', NULL, NULL, NULL, NULL, NULL, 4),
(214984, NULL, 'G3DSA:1.10.565.10:FF:000044', NULL, NULL, 'Ecdysone-induced protein 78C, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(214985, NULL, 'G3DSA:2.60.120.200:FF:000308', NULL, NULL, 'protein eyes shut', NULL, NULL, NULL, NULL, NULL, 4),
(214986, NULL, 'G3DSA:3.40.190.10:FF:000951', NULL, NULL, 'Bifunctional periplasmic substrate binding protein/cytoplasmic diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(214987, NULL, 'G3DSA:3.40.710.10:FF:000115', NULL, NULL, 'Penicillin-binding protein 2B', NULL, NULL, NULL, NULL, NULL, 4),
(214988, NULL, 'G3DSA:2.60.120.200:FF:000196', NULL, NULL, 'SP2353, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(214989, NULL, 'G3DSA:3.40.640.10:FF:000475', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214990, NULL, 'G3DSA:3.30.56.50:FF:000002', NULL, NULL, 'Translation initiation factor IF-2', NULL, NULL, NULL, NULL, NULL, 4),
(214991, NULL, 'G3DSA:2.60.120.470:FF:000001', NULL, NULL, 'Thioredoxin-like 1, isoform CRA_c', NULL, NULL, NULL, NULL, NULL, 4),
(214992, NULL, 'G3DSA:1.20.5.1930:FF:000004', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(214993, NULL, 'G3DSA:1.10.1040.10:FF:000077', NULL, NULL, 'AGAP012912-PA', NULL, NULL, NULL, NULL, NULL, 4),
(214994, NULL, 'G3DSA:3.50.50.60:FF:001502', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214995, NULL, 'G3DSA:3.40.1090.10:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(214996, NULL, 'G3DSA:1.20.1070.10:FF:000324', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(214997, NULL, 'G3DSA:1.10.10.160:FF:000009', NULL, NULL, 'ATP-dependent DNA helicase UvrD', NULL, NULL, NULL, NULL, NULL, 4),
(214998, NULL, 'G3DSA:1.10.510.10:FF:001660', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(214999, NULL, 'G3DSA:3.20.20.140:FF:000153', NULL, NULL, 'Uncharacterized protein MJ1295', NULL, NULL, NULL, NULL, NULL, 4),
(215000, NULL, 'G3DSA:3.30.60.30:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215001, NULL, 'G3DSA:3.40.50.620:FF:000484', NULL, NULL, 'Os03g0335600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(215002, NULL, 'G3DSA:3.30.200.20:FF:000756', NULL, NULL, 'Serine/threonine/tyrosine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(215003, NULL, 'G3DSA:1.10.287.2620:FF:000013', NULL, NULL, 'Putative dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(215004, NULL, 'G3DSA:3.30.70.330:FF:000987', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215005, NULL, 'G3DSA:1.10.287.70:FF:000516', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(215006, NULL, 'G3DSA:2.30.29.30:FF:000694', NULL, NULL, 'Vacuolar protein sorting-associated protein 13C', NULL, NULL, NULL, NULL, NULL, 4),
(215007, NULL, 'G3DSA:3.30.710.10:FF:000056', NULL, NULL, 'BTB/POZ domain-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(215008, NULL, 'G3DSA:3.30.200.20:FF:001032', NULL, NULL, 'Sks1p', NULL, NULL, NULL, NULL, NULL, 4),
(215009, NULL, 'G3DSA:3.40.50.300:FF:004103', NULL, NULL, 'Zinc finger NFX1-type containing homolog', NULL, NULL, NULL, NULL, NULL, 4),
(215010, NULL, 'G3DSA:1.10.10.10:FF:001851', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215011, NULL, 'G3DSA:3.40.50.300:FF:007329', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215012, NULL, 'G3DSA:1.10.287.410:FF:000012', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(215013, NULL, 'G3DSA:3.10.350.10:FF:000072', NULL, NULL, 'Peptidoglycan-binding LysM domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(215014, NULL, 'G3DSA:3.40.50.1110:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215015, NULL, 'G3DSA:1.10.8.60:FF:000140', NULL, NULL, 'AAA family ATPase, CDC48 subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(215016, NULL, 'G3DSA:1.10.1870.10:FF:000005', NULL, NULL, 'Chimeric spermidine synthase/saccharopine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(215017, NULL, 'G3DSA:2.60.120.480:FF:000004', NULL, NULL, 'Allantoicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215018, NULL, 'G3DSA:3.20.20.70:FF:000055', NULL, NULL, 'Ethanolamine ammonia-lyase heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(215019, NULL, 'G3DSA:1.25.40.710:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215020, NULL, 'G3DSA:1.20.58.340:FF:000001', NULL, NULL, 'Magnesium transport protein CorA', NULL, NULL, NULL, NULL, NULL, 4),
(215021, NULL, 'G3DSA:3.40.250.10:FF:000208', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(215022, NULL, 'G3DSA:2.160.20.80:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215023, NULL, 'G3DSA:2.60.40.10:FF:001332', NULL, NULL, 'PKHD1 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(215024, NULL, 'G3DSA:3.80.10.10:FF:001130', NULL, NULL, 'Os04g0132500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(215025, NULL, 'G3DSA:2.130.10.10:FF:001629', NULL, NULL, 'WD-40 repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(215026, NULL, 'G3DSA:3.40.50.720:FF:002436', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215027, NULL, 'G3DSA:1.10.10.10:FF:001519', NULL, NULL, 'Probable serine/threonine-protein kinase roco4', NULL, NULL, NULL, NULL, NULL, 4),
(215028, NULL, 'G3DSA:3.40.50.300:FF:007431', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215029, NULL, 'G3DSA:2.30.30.100:FF:000055', NULL, NULL, 'Probable small nuclear ribonucleoprotein F', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(215030, NULL, 'G3DSA:2.60.40.10:FF:005923', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215031, NULL, 'G3DSA:2.130.10.10:FF:003760', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215032, NULL, 'G3DSA:2.60.40.10:FF:004985', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215033, NULL, 'G3DSA:3.20.20.80:FF:000058', NULL, NULL, 'Alpha-amylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(215034, NULL, 'G3DSA:2.60.120.10:FF:000322', NULL, NULL, 'Cyclic nucleotide-binding domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215035, NULL, 'G3DSA:1.10.3520.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215036, NULL, 'G3DSA:2.60.40.10:FF:003462', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215037, NULL, 'G3DSA:4.10.280.10:FF:000202', NULL, NULL, 'Transcription factor hes-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215038, NULL, 'G3DSA:3.50.50.60:FF:001160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215039, NULL, 'G3DSA:2.60.40.10:FF:005581', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215040, NULL, 'G3DSA:1.20.58.1610:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215041, NULL, 'G3DSA:1.20.1250.20:FF:000852', NULL, NULL, 'Predicted arabinose efflux permease, MFS family', NULL, NULL, NULL, NULL, NULL, 4),
(215042, NULL, 'G3DSA:3.40.50.12660:FF:000002', NULL, NULL, 'Metacaspase 1', NULL, NULL, NULL, NULL, NULL, 4),
(215043, NULL, 'G3DSA:3.40.50.20:FF:000070', NULL, NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(215044, NULL, 'G3DSA:3.30.465.10:FF:000047', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(215045, NULL, 'G3DSA:1.25.10.10:FF:003049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215046, NULL, 'G3DSA:1.10.10.1320:FF:000009', NULL, NULL, 'Putative transmembrane anti-sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(215047, NULL, 'G3DSA:3.20.10.10:FF:000025', NULL, NULL, 'Branched-chain amino acid aminotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215048, NULL, 'G3DSA:1.20.5.1940:FF:000007', NULL, NULL, 'Vacuolar protein sorting-associated protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(215049, NULL, 'G3DSA:3.30.160.60:FF:003226', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(215050, NULL, 'G3DSA:2.60.40.10:FF:005261', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215051, NULL, 'G3DSA:2.60.40.60:FF:000003', NULL, NULL, 'Protocadherin alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(215052, NULL, 'G3DSA:2.60.120.200:FF:000538', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(215053, NULL, 'G3DSA:3.40.50.410:FF:000325', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(215054, NULL, 'G3DSA:3.30.160.60:FF:003664', NULL, NULL, 'Broad complex isoform Z4', NULL, NULL, NULL, NULL, NULL, 4),
(215055, NULL, 'G3DSA:3.40.50.12670:FF:000005', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(215056, NULL, 'G3DSA:2.30.30.190:FF:000020', NULL, NULL, 'Cylindromatosis, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(215057, NULL, 'G3DSA:3.40.718.10:FF:000026', NULL, NULL, '3-isopropylmalate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(215058, NULL, 'G3DSA:1.25.40.10:FF:002955', NULL, NULL, 'Os09g0573000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(215059, NULL, 'G3DSA:3.30.710.10:FF:000286', NULL, NULL, 'CG12236', NULL, NULL, NULL, NULL, NULL, 4),
(215060, NULL, 'G3DSA:3.90.228.10:FF:000022', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(215061, NULL, 'G3DSA:3.30.40.10:FF:002146', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(215062, NULL, 'G3DSA:1.10.510.10:FF:001547', NULL, NULL, 'NIMA-related kinase 10', NULL, NULL, NULL, NULL, NULL, 4),
(215063, NULL, 'G3DSA:3.30.559.10:FF:000265', NULL, NULL, 'Pelargonidin 3-O-(6-caffeoylglucoside) 5-O-(6-O-malonylglucoside) 4''''''-malonyltransferase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(215064, NULL, 'G3DSA:3.30.1920.20:FF:000001', NULL, NULL, 'ExeM/NucH family extracellular endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(215065, NULL, 'G3DSA:1.25.40.10:FF:005361', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215066, NULL, 'G3DSA:1.25.10.10:FF:001481', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(215067, NULL, 'G3DSA:4.10.1060.10:FF:000008', NULL, NULL, 'TATA-binding protein-associated factor 2N isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(215068, NULL, 'G3DSA:3.80.10.10:FF:002900', NULL, NULL, 'Protein CBG18939', NULL, NULL, NULL, NULL, NULL, 4),
(215069, NULL, 'G3DSA:3.40.50.300:FF:003277', NULL, NULL, 'Molybdopterin guanine dinucleotide synthesis protein B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215070, NULL, 'G3DSA:1.10.238.10:FF:001285', NULL, NULL, 'Nuclear receptor coactivator 5', NULL, NULL, NULL, NULL, NULL, 4),
(215071, NULL, 'G3DSA:3.40.50.1110:FF:000017', NULL, NULL, 'Protein CBG05119', NULL, NULL, NULL, NULL, NULL, 4),
(215072, NULL, 'G3DSA:3.40.50.1100:FF:000014', NULL, NULL, 'Threonine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(215073, NULL, 'G3DSA:1.20.1280.50:FF:000121', NULL, NULL, 'Putative scf ubiquitin ligase skp2 component', NULL, NULL, NULL, NULL, NULL, 4),
(215074, NULL, 'G3DSA:2.20.100.10:FF:000061', NULL, NULL, 'adhesion G protein-coupled receptor B1', NULL, NULL, NULL, NULL, NULL, 4),
(215075, NULL, 'G3DSA:3.50.50.60:FF:000884', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215076, NULL, 'G3DSA:1.10.472.80:FF:000006', NULL, NULL, 'TBC1 domain family member 14', NULL, NULL, NULL, NULL, NULL, 4),
(215077, NULL, 'G3DSA:3.40.50.11950:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215078, NULL, 'G3DSA:3.30.230.10:FF:000249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215079, NULL, 'G3DSA:3.30.160.60:FF:000230', NULL, NULL, 'Zinc finger protein 148', NULL, NULL, NULL, NULL, NULL, 4),
(215080, NULL, 'G3DSA:3.30.70.330:FF:000903', NULL, NULL, 'La protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(215081, NULL, 'G3DSA:1.20.1110.10:FF:000024', NULL, NULL, 'Plasma membrane ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(215082, NULL, 'G3DSA:3.40.50.300:FF:001147', NULL, NULL, 'multidrug resistance-associated protein 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(215083, NULL, 'G3DSA:3.60.110.10:FF:000060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215084, NULL, 'G3DSA:3.30.160.20:FF:000145', NULL, NULL, 'Class I peptide chain release factor', NULL, NULL, NULL, NULL, NULL, 4),
(215085, NULL, 'G3DSA:3.30.160.60:FF:004979', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215086, NULL, 'G3DSA:2.60.40.10:FF:001539', NULL, NULL, 'Immunoglobulin superfamily member 22', NULL, NULL, NULL, NULL, NULL, 4),
(215087, NULL, 'G3DSA:3.30.160.60:FF:001326', NULL, NULL, 'Zinc finger protein 432', NULL, NULL, NULL, NULL, NULL, 4),
(215088, NULL, 'G3DSA:3.60.40.10:FF:000312', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215089, NULL, 'G3DSA:3.40.910.10:FF:000001', NULL, NULL, 'Probable deoxyhypusine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(215090, NULL, 'G3DSA:3.40.50.2300:FF:000638', NULL, NULL, 'Clumsy, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(215091, NULL, 'G3DSA:3.10.250.10:FF:000114', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215092, NULL, 'G3DSA:1.20.5.5270:FF:000006', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(215093, NULL, 'G3DSA:3.40.1800.20:FF:000001', NULL, NULL, 'zinc finger protein 836', NULL, NULL, NULL, NULL, NULL, 4),
(215094, NULL, 'G3DSA:3.80.10.10:FF:002445', NULL, NULL, 'Paraflagellar rod component, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215095, NULL, 'G3DSA:3.40.50.150:FF:001276', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215096, NULL, 'G3DSA:3.30.160.60:FF:005255', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215097, NULL, 'G3DSA:2.30.42.10:FF:000449', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(215098, NULL, 'G3DSA:1.20.1250.20:FF:000291', NULL, NULL, 'Solute carrier family 16 member 5', NULL, NULL, NULL, NULL, NULL, 4),
(215099, NULL, 'G3DSA:1.20.120.1240:FF:000053', NULL, NULL, 'Dynamin GTPase, putative (AFU_orthologue AFUA_7G08580)', NULL, NULL, NULL, NULL, NULL, 4),
(215100, NULL, 'G3DSA:1.25.10.10:FF:001043', NULL, NULL, 'Protein phosphatase 2A regulatory subunit,putative', NULL, NULL, NULL, NULL, NULL, 4),
(215101, NULL, 'G3DSA:3.40.50.300:FF:003940', NULL, NULL, 'Ras family gtpase', NULL, NULL, NULL, NULL, NULL, 4),
(215102, NULL, 'G3DSA:3.40.850.10:FF:000496', NULL, NULL, 'Kinesin-like protein KIN-7N', NULL, NULL, NULL, NULL, NULL, 4),
(215103, NULL, 'G3DSA:3.40.1170.10:FF:000022', NULL, NULL, 'Mismatch repair ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(215104, NULL, 'G3DSA:3.40.190.10:FF:000496', NULL, NULL, 'NMDA class glutamate Receptor', NULL, NULL, NULL, NULL, NULL, 4),
(215105, NULL, 'G3DSA:3.30.1490.180:FF:000023', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(215106, NULL, 'G3DSA:3.40.50.1820:FF:000573', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(215107, NULL, 'G3DSA:1.50.40.10:FF:000047', NULL, NULL, 'peroxisomal membrane protein PMP34 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(215108, NULL, 'G3DSA:1.20.1260.60:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215109, NULL, 'G3DSA:3.40.50.1260:FF:000034', NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(215110, NULL, 'G3DSA:1.10.1380.10:FF:000018', NULL, NULL, 'GD18423', NULL, NULL, NULL, NULL, NULL, 4),
(215111, NULL, 'G3DSA:3.40.1440.10:FF:000015', NULL, NULL, 'Structure-specific endonuclease subunit SLX1', NULL, NULL, NULL, NULL, NULL, 4),
(215112, NULL, 'G3DSA:3.40.50.2000:FF:000543', NULL, NULL, 'Alpha,alpha-trehalose-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(215113, NULL, 'G3DSA:1.25.40.90:FF:000124', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(215114, NULL, 'G3DSA:3.90.850.10:FF:000030', NULL, NULL, '2-dehydro-3-deoxy-D-arabinonate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(215115, NULL, 'G3DSA:3.80.10.10:FF:004345', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215116, NULL, 'G3DSA:3.40.50.150:FF:001618', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215117, NULL, 'G3DSA:3.30.260.10:FF:000077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215118, NULL, 'G3DSA:2.70.160.11:FF:000037', NULL, NULL, 'Protein arginine N-methyltransferase 7', NULL, NULL, NULL, NULL, NULL, 4),
(215119, NULL, 'G3DSA:3.40.30.10:FF:000065', NULL, NULL, 'SH3 domain-binding glutamic acid-rich-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(215120, NULL, 'G3DSA:1.25.10.10:FF:000767', NULL, NULL, 'Mitotic spindle protein STU1', NULL, NULL, NULL, NULL, NULL, 4),
(215121, NULL, 'G3DSA:1.20.1560.10:FF:000850', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(215122, NULL, 'G3DSA:3.30.200.20:FF:000767', NULL, NULL, 'Serine/threonine-protein kinase CBK1', NULL, NULL, NULL, NULL, NULL, 4),
(215123, NULL, 'G3DSA:1.10.8.1220:FF:000002', NULL, NULL, 'cytoplasmic dynein 1 heavy chain 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(215124, NULL, 'G3DSA:1.25.40.10:FF:001421', NULL, NULL, 'LRP2-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(215125, NULL, 'G3DSA:3.30.1490.190:FF:000026', NULL, NULL, 'Probable transcription regulator FurR family', NULL, NULL, NULL, NULL, NULL, 4),
(215126, NULL, 'G3DSA:3.30.1120.30:FF:000027', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(215127, NULL, 'G3DSA:1.20.5.2650:FF:000001', NULL, NULL, '40S ribosomal protein S6', NULL, NULL, NULL, NULL, NULL, 4),
(215128, NULL, 'G3DSA:3.10.580.20:FF:000007', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(215129, NULL, 'G3DSA:3.90.45.10:FF:000029', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(215130, NULL, 'G3DSA:2.20.25.690:FF:000004', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(215131, NULL, 'G3DSA:2.130.10.10:FF:003097', NULL, NULL, 'WD repeat-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(215132, NULL, 'G3DSA:1.20.1250.20:FF:001948', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215133, NULL, 'G3DSA:1.25.40.10:FF:004855', NULL, NULL, 'Splicing factor, component of the U4/U6-U5 snRNP complex', NULL, NULL, NULL, NULL, NULL, 4),
(215134, NULL, 'G3DSA:1.20.1250.20:FF:000189', NULL, NULL, 'thiamine transporter 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(215135, NULL, 'G3DSA:3.20.20.60:FF:000052', NULL, NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(215136, NULL, 'G3DSA:3.40.50.300:FF:005531', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(215137, NULL, 'G3DSA:1.10.1520.10:FF:000007', NULL, NULL, 'Endoribonuclease dicer-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(215138, NULL, 'G3DSA:1.20.5.170:FF:000271', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215139, NULL, 'G3DSA:3.40.50.2300:FF:001133', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215140, NULL, 'G3DSA:2.20.25.680:FF:000001', NULL, NULL, 'Terminal oxygenase component of carbazole', NULL, NULL, NULL, NULL, NULL, 4),
(215141, NULL, 'G3DSA:3.40.50.360:FF:000153', NULL, NULL, '8-demethyl-8-aminoriboflavin-5''-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(215142, NULL, 'G3DSA:3.30.70.330:FF:002680', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215143, NULL, 'G3DSA:3.30.200.20:FF:001262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215144, NULL, 'G3DSA:3.10.580.10:FF:000004', NULL, NULL, 'Protein kinase AMP-activated non-catalytic subunit gamma 2', NULL, NULL, NULL, NULL, NULL, 4),
(215145, NULL, 'G3DSA:3.40.50.720:FF:000536', NULL, NULL, 'Sorbitol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(215146, NULL, 'G3DSA:1.25.40.10:FF:005131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215147, NULL, 'G3DSA:3.30.70.330:FF:002578', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215148, NULL, 'G3DSA:1.25.40.860:FF:000030', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(215149, NULL, 'G3DSA:3.40.50.300:FF:001686', NULL, NULL, 'KRAS proto-oncogene, GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(215150, NULL, 'G3DSA:3.30.40.10:FF:000555', NULL, NULL, 'Zinc finger (Ubiquitin-hydrolase) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(215151, NULL, 'G3DSA:3.90.1150.10:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215152, NULL, 'G3DSA:1.20.58.390:FF:000100', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(215153, NULL, 'G3DSA:3.30.70.260:FF:000051', NULL, NULL, 'Methionine import ATP-binding protein MetN', NULL, NULL, NULL, NULL, NULL, 4),
(215154, NULL, 'G3DSA:3.80.10.10:FF:000416', NULL, NULL, 'Probable leucine-rich repeat receptor-like protein kinase At5g63930', NULL, NULL, NULL, NULL, NULL, 4),
(215155, NULL, 'G3DSA:3.30.1120.10:FF:000021', NULL, NULL, 'Iduronate-sulfatase or arylsulfatase A', NULL, NULL, NULL, NULL, NULL, 4),
(215156, NULL, 'G3DSA:1.20.920.50:FF:000003', NULL, NULL, 'Allergen dI chain C2D', NULL, NULL, NULL, NULL, NULL, 4),
(215157, NULL, 'G3DSA:2.40.50.140:FF:000872', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215158, NULL, 'G3DSA:3.40.190.10:FF:000838', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(215159, NULL, 'G3DSA:1.25.40.20:FF:000007', NULL, NULL, 'Phosphatase 1 regulatory subunit 12A', NULL, NULL, NULL, NULL, NULL, 4),
(215160, NULL, 'G3DSA:1.25.10.10:FF:001604', NULL, NULL, 'Putative countin receptor Cnr17', NULL, NULL, NULL, NULL, NULL, 4),
(215161, NULL, 'G3DSA:3.40.50.1470:FF:000007', NULL, NULL, 'Peptidyl-tRNA hydrolase 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(215162, NULL, 'G3DSA:3.20.20.80:FF:000619', NULL, NULL, 'Arabinogalactan endo-beta-1,4-galactanase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(215163, NULL, 'G3DSA:3.90.1230.10:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215164, NULL, 'G3DSA:3.30.70.330:FF:001263', NULL, NULL, 'Nucleic acid binding', NULL, NULL, NULL, NULL, NULL, 4),
(215165, NULL, 'G3DSA:1.10.510.10:FF:003228', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215166, NULL, 'G3DSA:3.40.33.10:FF:000004', NULL, NULL, 'CAP, cysteine-rich secretory protein, antigen 5', NULL, NULL, NULL, NULL, NULL, 4),
(215167, NULL, 'G3DSA:4.10.520.10:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215168, NULL, 'G3DSA:1.10.8.50:FF:000024', NULL, NULL, 'Formamidopyrimidine-DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(215169, NULL, 'G3DSA:1.20.920.60:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215170, NULL, 'G3DSA:2.130.10.10:FF:001422', NULL, NULL, 'Putative rna polymerase ii elongator complex subunit elp2 wd repeat superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(215171, NULL, 'G3DSA:3.40.1390.30:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215172, NULL, 'G3DSA:1.10.8.60:FF:000027', NULL, NULL, 'ATP-dependent protease ATPase subunit HslU', NULL, NULL, NULL, NULL, NULL, 4),
(215173, NULL, 'G3DSA:1.20.920.10:FF:000227', NULL, NULL, 'AT Hook plus PHD finger transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(215174, NULL, 'G3DSA:3.40.50.1450:FF:000001', NULL, NULL, 'Hydrogenase 2 maturation endopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(215175, NULL, 'G3DSA:3.30.420.10:FF:000516', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215176, NULL, 'G3DSA:3.30.1740.10:FF:000012', NULL, NULL, 'Poly(ADP-ribose) polymerase and DNA-Ligase Zn-finger region/Zinc-finger (CX5CX6HX5H) motif containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215177, NULL, 'G3DSA:2.60.120.290:FF:000060', NULL, NULL, 'Cubilin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(215178, NULL, 'G3DSA:3.40.20.10:FF:000137', NULL, NULL, 'Protein tyrosine kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215179, NULL, 'G3DSA:3.20.20.100:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215180, NULL, 'G3DSA:3.10.20.90:FF:000022', NULL, NULL, 'Small ubiquitin-related modifier', NULL, NULL, NULL, NULL, NULL, 4),
(215181, NULL, 'G3DSA:3.40.50.410:FF:000106', NULL, NULL, 'Nitric oxide reductase D protein', NULL, NULL, NULL, NULL, NULL, 4),
(215182, NULL, 'G3DSA:3.40.50.1460:FF:000004', NULL, NULL, 'Mucosa-associated lymphoid tissue lymphoma translocation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(215183, NULL, 'G3DSA:1.20.990.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215184, NULL, 'G3DSA:3.30.50.10:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215185, NULL, 'G3DSA:3.40.630.30:FF:000053', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(215186, NULL, 'G3DSA:3.10.20.230:FF:000019', NULL, NULL, 'Doublecortin domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(215187, NULL, 'G3DSA:2.60.40.2030:FF:000059', NULL, NULL, 'Na+/Ca2+ exchanger NCX1 isoform', NULL, NULL, NULL, NULL, NULL, 4),
(215188, NULL, 'G3DSA:2.20.25.10:FF:000005', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(215189, NULL, 'G3DSA:2.130.10.10:FF:001074', NULL, NULL, 'Probable SOF1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(215190, NULL, 'G3DSA:1.20.900.10:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215191, NULL, 'G3DSA:1.10.10.10:FF:001306', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(215192, NULL, 'G3DSA:3.30.160.60:FF:005923', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215193, NULL, 'G3DSA:1.10.8.10:FF:000147', NULL, NULL, 'Nuclear RNA export factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(215194, NULL, 'G3DSA:2.20.25.20:FF:000008', NULL, NULL, 'E3 ubiquitin-protein ligase parkin', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(215195, NULL, 'G3DSA:1.10.530.10:FF:000014', NULL, NULL, 'Alpha-lactalbumin', NULL, NULL, NULL, NULL, NULL, 4),
(215196, NULL, 'G3DSA:1.10.10.60:FF:001170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215197, NULL, 'G3DSA:3.30.710.10:FF:000174', NULL, NULL, 'BTB/POZ and TAZ domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(215198, NULL, 'G3DSA:1.25.40.180:FF:000141', NULL, NULL, 'AGAP002502-PA', NULL, NULL, NULL, NULL, NULL, 4),
(215199, NULL, 'G3DSA:2.10.25.10:FF:000197', NULL, NULL, 'latent-transforming growth factor beta-binding protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(215200, NULL, 'G3DSA:1.10.575.10:FF:000005', NULL, NULL, 'Putative p1/s1 nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(215201, NULL, 'G3DSA:1.20.920.10:FF:000126', NULL, NULL, 'YALI0D20702p', NULL, NULL, NULL, NULL, NULL, 4),
(215202, NULL, 'G3DSA:3.30.420.10:FF:000415', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215203, NULL, 'G3DSA:3.40.50.300:FF:003620', NULL, NULL, 'Regulator of nonsense transcripts putative', NULL, NULL, NULL, NULL, NULL, 4),
(215204, NULL, 'G3DSA:1.20.1560.10:FF:000395', NULL, NULL, 'Multidrug resistance protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215205, NULL, 'G3DSA:3.40.50.720:FF:001031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215206, NULL, 'G3DSA:1.25.10.10:FF:001363', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215207, NULL, 'G3DSA:1.20.900.10:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215208, NULL, 'G3DSA:1.20.58.60:FF:000694', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215209, NULL, 'G3DSA:3.80.10.10:FF:000641', NULL, NULL, 'NLR family CARD domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(215210, NULL, 'G3DSA:3.40.50.300:FF:005744', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215211, NULL, 'G3DSA:3.90.370.10:FF:000010', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(215212, NULL, 'G3DSA:3.30.70.330:FF:000448', NULL, NULL, 'Negative elongation factor E', NULL, NULL, NULL, NULL, NULL, 4),
(215213, NULL, 'G3DSA:1.25.40.10:FF:005136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215214, NULL, 'G3DSA:3.30.160.60:FF:001652', NULL, NULL, 'Zinc finger protein 772', NULL, NULL, NULL, NULL, NULL, 4),
(215215, NULL, 'G3DSA:3.30.1490.120:FF:000022', NULL, NULL, 'RNA polymerase I subunit A43', NULL, NULL, NULL, NULL, NULL, 4),
(215216, NULL, 'G3DSA:1.10.287.370:FF:000073', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(215217, NULL, 'G3DSA:3.30.40.10:FF:000892', NULL, NULL, 'Probable E3 ubiquitin-protein ligase ARI15', NULL, NULL, NULL, NULL, NULL, 4),
(215218, NULL, 'G3DSA:3.50.50.60:FF:000766', NULL, NULL, 'RIKEN cDNA 4930438A08 gene', NULL, NULL, NULL, NULL, NULL, 4),
(215219, NULL, 'G3DSA:1.20.1250.20:FF:002089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215220, NULL, 'G3DSA:3.40.30.10:FF:000200', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(215221, NULL, 'G3DSA:3.40.50.2300:FF:000964', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215222, NULL, 'G3DSA:2.60.40.10:FF:005367', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215223, NULL, 'G3DSA:3.30.160.60:FF:001545', NULL, NULL, 'Zinc finger protein 575', NULL, NULL, NULL, NULL, NULL, 4),
(215224, NULL, 'G3DSA:3.40.50.300:FF:001473', NULL, NULL, 'ATP-binding cassette transporter', NULL, NULL, NULL, NULL, NULL, 4),
(215225, NULL, 'G3DSA:3.40.50.80:FF:000065', NULL, NULL, 'Nitric oxide dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(215226, NULL, 'G3DSA:3.80.10.10:FF:000534', NULL, NULL, 'Probably inactive leucine-rich repeat receptor-like protein kinase At5g06940', NULL, NULL, NULL, NULL, NULL, 4),
(215227, NULL, 'G3DSA:2.40.37.10:FF:000066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215228, NULL, 'G3DSA:3.40.50.2300:FF:000857', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(215229, NULL, 'G3DSA:1.10.630.10:FF:000073', NULL, NULL, 'Cytochrome P450 family 27 subfamily C member 1', NULL, NULL, NULL, NULL, NULL, 4),
(215230, NULL, 'G3DSA:2.80.10.50:FF:000014', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(215231, NULL, 'G3DSA:2.60.40.10:FF:004766', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215232, NULL, 'G3DSA:1.10.8.60:FF:000022', NULL, NULL, 'Fidgetin like 1', NULL, NULL, NULL, NULL, NULL, 4),
(215233, NULL, 'G3DSA:1.20.920.10:FF:000233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215234, NULL, 'G3DSA:3.30.420.10:FF:000522', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215235, NULL, 'G3DSA:1.10.287.70:FF:000056', NULL, NULL, 'Potassium voltage-gated channel subfamily KQT member 1', NULL, NULL, NULL, NULL, NULL, 4),
(215236, NULL, 'G3DSA:1.10.150.50:FF:000137', NULL, NULL, 'Sphingomyelin synthase-related 1', NULL, NULL, NULL, NULL, NULL, 4),
(215237, NULL, 'G3DSA:1.20.1250.20:FF:000970', NULL, NULL, 'Sugar transporter', NULL, NULL, NULL, NULL, NULL, 4),
(215238, NULL, 'G3DSA:1.10.630.10:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215239, NULL, 'G3DSA:3.40.50.720:FF:002554', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215240, NULL, 'G3DSA:3.30.60.270:FF:000001', NULL, NULL, 'Sortilin related VPS10 domain containing receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(215241, NULL, 'G3DSA:3.20.20.80:FF:000631', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215242, NULL, 'G3DSA:1.20.120.850:FF:000041', NULL, NULL, 'Helicase swr1', NULL, NULL, NULL, NULL, NULL, 4),
(215243, NULL, 'G3DSA:1.10.10.10:FF:001295', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(215244, NULL, 'G3DSA:3.40.190.10:FF:000726', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(215245, NULL, 'G3DSA:3.20.20.140:FF:000372', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215246, NULL, 'G3DSA:1.20.1280.50:FF:000003', NULL, NULL, 'F-box only protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(215247, NULL, 'G3DSA:3.40.1390.20:FF:000007', NULL, NULL, 'Phosphate acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(215248, NULL, 'G3DSA:1.25.40.10:FF:005243', NULL, NULL, 'SH3 domain and tetratricopeptide repeat-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(215249, NULL, 'G3DSA:2.60.40.10:FF:001096', NULL, NULL, 'Interleukin 1 receptor like 2', NULL, NULL, NULL, NULL, NULL, 4),
(215250, NULL, 'G3DSA:3.30.1610.10:FF:000002', NULL, NULL, 'nuclear pore complex protein NUP98A', NULL, NULL, NULL, NULL, NULL, 4),
(215251, NULL, 'G3DSA:3.30.160.60:FF:005816', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215252, NULL, 'G3DSA:3.30.470.10:FF:000019', NULL, NULL, 'Aminodeoxychorismate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(215253, NULL, 'G3DSA:4.10.1080.10:FF:000004', NULL, NULL, 'Cartilage oligomeric matrix protein', NULL, NULL, NULL, NULL, NULL, 4),
(215254, NULL, 'G3DSA:1.10.510.10:FF:001216', NULL, NULL, 'Leucine-rich repeat kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(215255, NULL, 'G3DSA:1.10.3810.10:FF:000013', NULL, NULL, 'Transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(215256, NULL, 'G3DSA:1.10.10.10:FF:001413', NULL, NULL, 'Transcriptional regulator, ArsR family', NULL, NULL, NULL, NULL, NULL, 4),
(215257, NULL, 'G3DSA:3.30.479.20:FF:000003', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(215258, NULL, 'G3DSA:3.40.50.300:FF:005418', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215259, NULL, 'G3DSA:3.20.110.10:FF:000029', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(215260, NULL, 'G3DSA:3.40.50.2000:FF:000981', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215261, NULL, 'G3DSA:3.30.450.20:FF:000353', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215262, NULL, 'G3DSA:2.40.30.70:FF:000012', NULL, NULL, 'Putative UPF0066 family protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(215263, NULL, 'G3DSA:2.10.25.10:FF:000208', NULL, NULL, 'Crumbs 2, cell polarity complex component', NULL, NULL, NULL, NULL, NULL, 4),
(215264, NULL, 'G3DSA:2.60.40.1230:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215265, NULL, 'G3DSA:3.30.70.330:FF:002679', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215266, NULL, 'G3DSA:3.40.1190.20:FF:000026', NULL, NULL, 'Inositol 3-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(215267, NULL, 'G3DSA:2.130.10.10:FF:005019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215268, NULL, 'G3DSA:2.40.70.10:FF:000486', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215269, NULL, 'G3DSA:3.30.200.20:FF:001150', NULL, NULL, 'Pregnancy up-regulated nonubiquitous CaM kinase', NULL, NULL, NULL, NULL, NULL, 4),
(215270, NULL, 'G3DSA:1.10.600.10:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215271, NULL, 'G3DSA:2.10.110.10:FF:000176', NULL, NULL, 'LIM domain-containing protein pin-2', NULL, NULL, NULL, NULL, NULL, 4),
(215272, NULL, 'G3DSA:2.40.50.960:FF:000005', NULL, NULL, 'Telomere replication protein EST3', NULL, NULL, NULL, NULL, NULL, 4),
(215273, NULL, 'G3DSA:3.30.450.20:FF:000460', NULL, NULL, 'Neuronal PAS domain-containing protein 4-like', NULL, NULL, NULL, NULL, NULL, 4),
(215274, NULL, 'G3DSA:1.20.1070.10:FF:000762', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(215275, NULL, 'G3DSA:3.40.50.620:FF:000158', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(215276, NULL, 'G3DSA:3.30.420.40:FF:000857', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215277, NULL, 'G3DSA:3.40.1190.10:FF:000023', NULL, NULL, 'UDP-N-acetylmuramoylalanine--D-glutamate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(215278, NULL, 'G3DSA:1.50.10.10:FF:000231', NULL, NULL, 'Glycogen debranching enzyme-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(215279, NULL, 'G3DSA:1.20.58.60:FF:000705', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215280, NULL, 'G3DSA:2.102.10.10:FF:000041', NULL, NULL, 'Benzene 12-dioxygenase system ferredoxin subunit protein', NULL, NULL, NULL, NULL, NULL, 4),
(215281, NULL, 'G3DSA:2.60.120.200:FF:000752', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215282, NULL, 'G3DSA:2.30.30.100:FF:000162', NULL, NULL, 'Small nuclear ribonucleoprotein-associated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215283, NULL, 'G3DSA:3.40.50.150:FF:001388', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215284, NULL, 'G3DSA:3.30.420.10:FF:000741', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215285, NULL, 'G3DSA:4.10.410.10:FF:000016', NULL, NULL, 'Collagen type XXVIII alpha 1 chain', NULL, NULL, NULL, NULL, NULL, 4),
(215286, NULL, 'G3DSA:3.80.10.10:FF:000315', NULL, NULL, 'Si:dkey-16p6.1', NULL, NULL, NULL, NULL, NULL, 4),
(215287, NULL, 'G3DSA:1.20.58.90:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215288, NULL, 'G3DSA:1.20.58.80:FF:000020', NULL, NULL, 'AMSH-like ubiquitin thioesterase 3', NULL, NULL, NULL, NULL, NULL, 4),
(215289, NULL, 'G3DSA:4.10.410.20:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215290, NULL, 'G3DSA:1.20.1080.10:FF:000038', NULL, NULL, 'Glycerol uptake facilitator protein', NULL, NULL, NULL, NULL, NULL, 4),
(215291, NULL, 'G3DSA:1.25.10.10:FF:003403', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215292, NULL, 'G3DSA:1.20.1070.10:FF:000543', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215293, NULL, 'G3DSA:2.60.40.1530:FF:000004', NULL, NULL, 'Integrin subunit alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(215294, NULL, 'G3DSA:3.30.70.330:FF:002921', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215295, NULL, 'G3DSA:3.30.450.20:FF:000246', NULL, NULL, 'Two-component sensor kinase citS', NULL, NULL, NULL, NULL, NULL, 4),
(215296, NULL, 'G3DSA:3.40.50.1100:FF:000020', NULL, NULL, 'Cysteine synthase 2', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(215297, NULL, 'G3DSA:2.60.40.1520:FF:000001', NULL, NULL, 'Hemocyanin subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(215298, NULL, 'G3DSA:2.60.40.420:FF:000152', NULL, NULL, 'fibrocystin-L-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(215299, NULL, 'G3DSA:3.90.70.10:FF:000678', NULL, NULL, 'Bleomycin hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215300, NULL, 'G3DSA:2.60.40.10:FF:001433', NULL, NULL, 'Matrix remodeling associated 5', NULL, NULL, NULL, NULL, NULL, 4),
(215301, NULL, 'G3DSA:1.10.8.10:FF:000361', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(215302, NULL, 'G3DSA:3.40.50.1260:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215303, NULL, 'G3DSA:1.20.140.10:FF:000044', NULL, NULL, '4-hydroxyphenylacetate 3-monooxygenase oxygenase component', NULL, NULL, NULL, NULL, NULL, 4),
(215304, NULL, 'G3DSA:3.90.20.20:FF:000043', NULL, NULL, 'Protein GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(215305, NULL, 'G3DSA:2.130.10.10:FF:001860', NULL, NULL, 'Type I inositol-1,4,5-trisphosphate 5-phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(215306, NULL, 'G3DSA:2.120.10.30:FF:000439', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(215307, NULL, 'G3DSA:3.40.50.1110:FF:000023', NULL, NULL, 'Poly C5 epimerase 3', NULL, NULL, NULL, NULL, NULL, 4),
(215308, NULL, 'G3DSA:3.30.70.330:FF:000667', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215309, NULL, 'G3DSA:1.10.287.160:FF:000021', NULL, NULL, 'Serine/threonine-protein kinase N2', NULL, NULL, NULL, NULL, NULL, 4),
(215310, NULL, 'G3DSA:1.25.10.10:FF:001037', NULL, NULL, 'DNA double-strand break repair Rad50 ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215311, NULL, 'G3DSA:3.90.45.10:FF:000024', NULL, NULL, 'Peptide deformylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(215312, NULL, 'G3DSA:2.60.40.10:FF:005474', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215313, NULL, 'G3DSA:3.40.50.11350:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215314, NULL, 'G3DSA:3.40.50.300:FF:001580', NULL, NULL, 'E1A binding protein p400', NULL, NULL, NULL, NULL, NULL, 4),
(215315, NULL, 'G3DSA:1.20.120.310:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215316, NULL, 'G3DSA:2.60.120.480:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215317, NULL, 'G3DSA:1.25.10.10:FF:001149', NULL, NULL, 'Protein serine/threonine phosphatase 4 regulatory subunit 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215318, NULL, 'G3DSA:3.90.190.10:FF:000024', NULL, NULL, 'probable tyrosine-protein phosphatase At1g05000', NULL, NULL, NULL, NULL, NULL, 4),
(215319, NULL, 'G3DSA:2.130.10.10:FF:001181', NULL, NULL, 'Unplaced genomic scaffold supercont1.10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(215320, NULL, 'G3DSA:2.60.120.260:FF:000186', NULL, NULL, 'Putative serine esterase Rv1835c', NULL, NULL, NULL, NULL, NULL, 4),
(215321, NULL, 'G3DSA:2.130.10.10:FF:005671', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215322, NULL, 'G3DSA:3.40.1110.10:FF:000254', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215323, NULL, 'G3DSA:1.20.1420.10:FF:000008', NULL, NULL, 'Cyclin-D1-binding protein 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(215324, NULL, 'G3DSA:4.10.410.60:FF:000003', NULL, NULL, 'Large subunit ribosomal protein L35', NULL, NULL, NULL, NULL, NULL, 4),
(215325, NULL, 'G3DSA:3.30.710.10:FF:000281', NULL, NULL, 'Elongin C paralog b', NULL, NULL, NULL, NULL, NULL, 4),
(215326, NULL, 'G3DSA:3.30.360.20:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215327, NULL, 'G3DSA:1.10.238.10:FF:000897', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215328, NULL, 'G3DSA:3.30.160.60:FF:005704', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215329, NULL, 'G3DSA:3.40.50.11990:FF:000003', NULL, NULL, 'Pol II transcription elongation factor subunit Cdc73', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(215330, NULL, 'G3DSA:1.25.40.20:FF:001087', NULL, NULL, 'SPRY domain/Ankyrin repeats (3 copies), putative', NULL, NULL, NULL, NULL, NULL, 4),
(215331, NULL, 'G3DSA:1.25.40.10:FF:001084', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(215332, NULL, 'G3DSA:3.40.50.300:FF:001366', NULL, NULL, 'ATP binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215333, NULL, 'G3DSA:3.40.80.10:FF:000023', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(215334, NULL, 'G3DSA:1.25.40.570:FF:000044', NULL, NULL, 'Csn-1', NULL, NULL, NULL, NULL, NULL, 4),
(215335, NULL, 'G3DSA:3.40.850.10:FF:000390', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215336, NULL, 'G3DSA:3.40.50.150:FF:001169', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215337, NULL, 'G3DSA:2.30.40.10:FF:000170', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(215338, NULL, 'G3DSA:3.40.50.300:FF:005851', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215339, NULL, 'G3DSA:1.20.58.60:FF:000475', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(215340, NULL, 'G3DSA:1.25.10.10:FF:001582', NULL, NULL, 'Probable importin-5 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(215341, NULL, 'G3DSA:1.50.10.10:FF:000012', NULL, NULL, 'LanC-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(215342, NULL, 'G3DSA:2.130.10.10:FF:005452', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215343, NULL, 'G3DSA:1.25.40.470:FF:000014', NULL, NULL, 'Coatomer subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(215344, NULL, 'G3DSA:2.40.440.10:FF:000002', NULL, NULL, 'L,D-transpeptidase ErfK/SrfK', NULL, NULL, NULL, NULL, NULL, 4),
(215345, NULL, 'G3DSA:2.30.29.30:FF:000817', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(215346, NULL, 'G3DSA:2.10.70.10:FF:000161', NULL, NULL, 'Membrane cofactor protein', NULL, NULL, NULL, NULL, NULL, 4),
(215347, NULL, 'G3DSA:2.60.120.200:FF:000533', NULL, NULL, 'LOC495391 protein', NULL, NULL, NULL, NULL, NULL, 4),
(215348, NULL, 'G3DSA:2.30.29.30:FF:001211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215349, NULL, 'G3DSA:6.10.140.2220:FF:000038', NULL, NULL, 'GM14901', NULL, NULL, NULL, NULL, NULL, 4),
(215350, NULL, 'G3DSA:1.10.10.10:FF:001525', NULL, NULL, 'Manganese ABC transporter, inner membrane permease protein SitC', NULL, NULL, NULL, NULL, NULL, 4),
(215351, NULL, 'G3DSA:3.40.50.410:FF:000213', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(215352, NULL, 'G3DSA:1.20.1560.10:FF:000406', NULL, NULL, 'ABC multidrug transporter', NULL, NULL, NULL, NULL, NULL, 4),
(215353, NULL, 'G3DSA:4.10.740.10:FF:000002', NULL, NULL, 'Proline rich and Gla domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(215354, NULL, 'G3DSA:3.40.50.10190:FF:000222', NULL, NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(215355, NULL, 'G3DSA:3.30.60.30:FF:000101', NULL, NULL, 'Follistatin', NULL, NULL, NULL, NULL, NULL, 4),
(215356, NULL, 'G3DSA:3.30.200.20:FF:002566', NULL, NULL, 'Pim proto-oncogene, serine/threonine kinase,-related 156', NULL, NULL, NULL, NULL, NULL, 4),
(215357, NULL, 'G3DSA:1.20.1280.50:FF:000222', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(215358, NULL, 'G3DSA:1.10.510.10:FF:001435', NULL, NULL, 'Probable myosin light chain kinase DDB_G0275057', NULL, NULL, NULL, NULL, NULL, 4),
(215359, NULL, 'G3DSA:2.60.40.1170:FF:000099', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215360, NULL, 'G3DSA:3.50.50.60:FF:000985', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215361, NULL, 'G3DSA:3.20.20.80:FF:000171', NULL, NULL, 'Malto-oligosyltrehalose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(215362, NULL, 'G3DSA:1.10.441.10:FF:000004', NULL, NULL, 'Mannose-6-phosphate isomerase, class I', NULL, NULL, NULL, NULL, NULL, 4),
(215363, NULL, 'G3DSA:3.80.10.10:FF:000860', NULL, NULL, 'F-box/LRR-repeat protein 12 isoform X2', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(215364, NULL, 'G3DSA:2.20.100.10:FF:000066', NULL, NULL, 'A disintegrin and metalloproteinase with thrombospondin motifs 18', NULL, NULL, NULL, NULL, NULL, 4),
(215365, NULL, 'G3DSA:2.130.10.10:FF:002597', NULL, NULL, 'DNA damage-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(215366, NULL, 'G3DSA:2.60.220.50:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215367, NULL, 'G3DSA:1.20.90.10:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215368, NULL, 'G3DSA:2.10.90.10:FF:000044', NULL, NULL, 'Interleukin 17D', NULL, NULL, NULL, NULL, NULL, 4),
(215369, NULL, 'G3DSA:3.40.50.300:FF:002996', NULL, NULL, 'Dynamin family GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215370, NULL, 'G3DSA:3.40.50.300:FF:005637', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215371, NULL, 'G3DSA:1.25.10.10:FF:002779', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(215372, NULL, 'G3DSA:1.10.10.1310:FF:000001', NULL, NULL, 'TCP pilus virulence regulatory protein ToxT', NULL, NULL, NULL, NULL, NULL, 4),
(215373, NULL, 'G3DSA:3.30.1360.40:FF:000020', NULL, NULL, 'Similar to ribosome recycling factor', NULL, NULL, NULL, NULL, NULL, 4),
(215374, NULL, 'G3DSA:2.60.40.10:FF:005704', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215375, NULL, 'G3DSA:3.30.70.330:FF:000881', NULL, NULL, 'Polypyrimidine tract-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(215376, NULL, 'G3DSA:1.10.840.10:FF:000010', NULL, NULL, 'ras-specific guanine nucleotide-releasing factor RalGPS1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(215377, NULL, 'G3DSA:3.80.10.10:FF:002546', NULL, NULL, 'Cyclic nucleotide-binding domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215378, NULL, 'G3DSA:3.20.20.80:FF:000850', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215379, NULL, 'G3DSA:3.40.1000.10:FF:000021', NULL, NULL, 'PsbP domain-containing protein 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(215380, NULL, 'G3DSA:3.30.1370.10:FF:000079', NULL, NULL, 'developmental pluripotency-associated 5 protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(215381, NULL, 'G3DSA:2.130.10.10:FF:005238', NULL, NULL, 'WD-40 repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(215382, NULL, 'G3DSA:3.40.50.720:FF:002335', NULL, NULL, 'Bll6448 protein', NULL, NULL, NULL, NULL, NULL, 4),
(215383, NULL, 'G3DSA:1.10.510.10:FF:000131', NULL, NULL, 'cyclin-dependent kinase 14 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(215384, NULL, 'G3DSA:3.30.70.3320:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215385, NULL, 'G3DSA:2.60.120.290:FF:000166', NULL, NULL, 'Cubilin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(215386, NULL, 'G3DSA:3.30.572.10:FF:000003', NULL, NULL, 'Thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(215387, NULL, 'G3DSA:1.10.167.10:FF:000012', NULL, NULL, 'Rho guanine nucleotide exchange factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(215388, NULL, 'G3DSA:3.30.450.60:FF:000011', NULL, NULL, 'AP complex subunit sigma', NULL, NULL, NULL, NULL, NULL, 4),
(215389, NULL, 'G3DSA:2.130.10.10:FF:001186', NULL, NULL, 'UTP15p Nucleolar protein', NULL, NULL, NULL, NULL, NULL, 4),
(215390, NULL, 'G3DSA:1.10.287.70:FF:000275', NULL, NULL, 'Potassium voltage-gated channel subfamily H member 8', NULL, NULL, NULL, NULL, NULL, 4),
(215391, NULL, 'G3DSA:3.10.180.90:FF:000003', NULL, NULL, 'ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(215392, NULL, 'G3DSA:1.10.10.10:FF:001418', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(215393, NULL, 'G3DSA:1.10.1200.240:FF:000006', NULL, NULL, 'Probable ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(215394, NULL, 'G3DSA:2.130.10.10:FF:004963', NULL, NULL, 'Ribosomal RNA processing 9, U3 small nucleolar RNA binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(215395, NULL, 'G3DSA:1.10.630.10:FF:000303', NULL, NULL, 'Probable cytochrome P450 519D1', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(215396, NULL, 'G3DSA:1.20.5.350:FF:000004', NULL, NULL, 'WupA, isoform I', NULL, NULL, NULL, NULL, NULL, 4),
(215397, NULL, 'G3DSA:1.20.120.350:FF:000104', NULL, NULL, 'Unplaced genomic scaffold supercont1.219, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(215398, NULL, 'G3DSA:3.80.10.10:FF:000753', NULL, NULL, 'Leucine rich repeat kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(215399, NULL, 'G3DSA:3.10.20.90:FF:000949', NULL, NULL, 'UBA/TS-N domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(215400, NULL, 'G3DSA:2.130.10.10:FF:005233', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(215401, NULL, 'G3DSA:3.40.50.720:FF:000637', NULL, NULL, 'Uncharacterized oxidoreductase C736.13', NULL, NULL, NULL, NULL, NULL, 4),
(215402, NULL, 'G3DSA:1.10.10.1760:FF:000006', NULL, NULL, 'LSU ribosomal protein L36E', NULL, NULL, NULL, NULL, NULL, 4),
(215403, NULL, 'G3DSA:1.10.8.60:FF:000241', NULL, NULL, 'GH08677p', NULL, NULL, NULL, NULL, NULL, 4),
(215404, NULL, 'G3DSA:1.10.1580.10:FF:000005', NULL, NULL, 'Nucleolar GTP-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(215405, NULL, 'G3DSA:1.10.287.130:FF:000041', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(215406, NULL, 'G3DSA:3.40.50.300:FF:005632', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215407, NULL, 'G3DSA:1.10.10.10:FF:001076', NULL, NULL, '3-aminomethylindole N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(215408, NULL, 'G3DSA:1.25.40.10:FF:004754', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215409, NULL, 'G3DSA:1.10.220.30:FF:000036', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(215410, NULL, 'G3DSA:1.20.1050.10:FF:000199', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(215411, NULL, 'G3DSA:1.20.5.340:FF:000001', NULL, NULL, 'Tropomyosin alpha-1 chain isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(215412, NULL, 'G3DSA:3.90.190.10:FF:000350', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase R', NULL, NULL, NULL, NULL, NULL, 4),
(215413, NULL, 'G3DSA:1.20.58.60:FF:000149', NULL, NULL, 'Spectrin beta chain, non-erythrocytic', NULL, NULL, NULL, NULL, NULL, 4),
(215414, NULL, 'G3DSA:1.10.287.70:FF:000623', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215415, NULL, 'G3DSA:1.10.3500.10:FF:000017', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(215416, NULL, 'G3DSA:3.40.50.80:FF:000177', NULL, NULL, 'FAD-binding domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(215417, NULL, 'G3DSA:3.30.40.10:FF:000673', NULL, NULL, 'RING finger domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215418, NULL, 'G3DSA:1.25.40.10:FF:005024', NULL, NULL, 'Diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(215419, NULL, 'G3DSA:3.40.850.10:FF:000176', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(215420, NULL, 'G3DSA:1.20.120.1880:FF:000008', NULL, NULL, 'WGS project CABT00000000 data, contig 2.2', NULL, NULL, NULL, NULL, NULL, 4),
(215421, NULL, 'G3DSA:3.40.50.2300:FF:000852', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215422, NULL, 'G3DSA:3.40.50.1820:FF:000253', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(215423, NULL, 'G3DSA:1.20.940.10:FF:000009', NULL, NULL, 'Protein transport protein Sec31A', NULL, NULL, NULL, NULL, NULL, 4),
(215424, NULL, 'G3DSA:3.40.50.300:FF:004002', NULL, NULL, 'Thiamine ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(215425, NULL, 'G3DSA:1.20.1050.10:FF:000317', NULL, NULL, 'Methionyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(215426, NULL, 'G3DSA:2.10.25.10:FF:000085', NULL, NULL, 'Netrin G1', NULL, NULL, NULL, NULL, NULL, 4),
(215427, NULL, 'G3DSA:1.10.437.10:FF:000011', NULL, NULL, 'BCL2 like 13', NULL, NULL, NULL, NULL, NULL, 4),
(215428, NULL, 'G3DSA:1.25.40.420:FF:000027', NULL, NULL, 'galectin-3-binding protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(215429, NULL, 'G3DSA:3.30.160.60:FF:005811', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215430, NULL, 'G3DSA:2.30.30.140:FF:000252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215431, NULL, 'G3DSA:3.40.50.300:FF:001585', NULL, NULL, 'DNA replication helicase', NULL, NULL, NULL, NULL, NULL, 4),
(215432, NULL, 'G3DSA:3.80.10.10:FF:001023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215433, NULL, 'G3DSA:3.30.160.60:FF:001433', NULL, NULL, 'Zinc finger protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(215434, NULL, 'G3DSA:2.60.40.10:FF:002849', NULL, NULL, 'AGAP003656-PC', NULL, NULL, NULL, NULL, NULL, 4),
(215435, NULL, 'G3DSA:3.90.640.10:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215436, NULL, 'G3DSA:1.10.245.10:FF:000014', NULL, NULL, 'E3 ubiquitin-protein ligase Mdm2', NULL, NULL, NULL, NULL, NULL, 4),
(215437, NULL, 'G3DSA:1.10.630.10:FF:000185', NULL, NULL, 'Fatty-acid peroxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(215438, NULL, 'G3DSA:3.40.50.2300:FF:000745', NULL, NULL, 'Vomeronasal 2, receptor 8', NULL, NULL, NULL, NULL, NULL, 4),
(215439, NULL, 'G3DSA:3.60.90.10:FF:000017', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(215440, NULL, 'G3DSA:2.30.33.40:FF:000010', NULL, NULL, '10 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(215441, NULL, 'G3DSA:3.30.160.60:FF:001085', NULL, NULL, 'Zinc finger protein 184', NULL, NULL, NULL, NULL, NULL, 4),
(215442, NULL, 'G3DSA:1.10.555.10:FF:000217', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215443, NULL, 'G3DSA:1.25.10.10:FF:002998', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215444, NULL, 'G3DSA:2.40.420.20:FF:000010', NULL, NULL, 'Efflux transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(215445, NULL, 'G3DSA:1.25.10.10:FF:003280', NULL, NULL, 'Si:ch1073-82l19.1', NULL, NULL, NULL, NULL, NULL, 4),
(215446, NULL, 'G3DSA:1.10.1520.10:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215447, NULL, 'G3DSA:2.10.110.10:FF:000069', NULL, NULL, 'Uncharacterized protein, isoform Z', NULL, NULL, NULL, NULL, NULL, 4),
(215448, NULL, 'G3DSA:1.20.1250.10:FF:000074', NULL, NULL, 'Interleukin-3', NULL, NULL, NULL, NULL, NULL, 4),
(215449, NULL, 'G3DSA:3.90.1200.10:FF:000053', NULL, NULL, 'Spore coat protein, CotS family', NULL, NULL, NULL, NULL, NULL, 4),
(215450, NULL, 'G3DSA:1.20.1270.60:FF:000281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215451, NULL, 'G3DSA:3.30.70.660:FF:000070', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(215452, NULL, 'G3DSA:2.60.220.50:FF:000139', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(215453, NULL, 'G3DSA:3.30.70.1290:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215454, NULL, 'G3DSA:3.40.50.2300:FF:001021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215455, NULL, 'G3DSA:1.20.1250.20:FF:000532', NULL, NULL, 'SLC (SoLute Carrier) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(215456, NULL, 'G3DSA:3.40.250.10:FF:000080', NULL, NULL, 'Ubiquitin-specific protease', NULL, NULL, NULL, NULL, NULL, 4),
(215457, NULL, 'G3DSA:1.10.10.60:FF:000899', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215458, NULL, 'G3DSA:2.60.40.10:FF:005148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215459, NULL, 'G3DSA:1.10.510.10:FF:001761', NULL, NULL, 'Pk34A', NULL, NULL, NULL, NULL, NULL, 4),
(215460, NULL, 'G3DSA:3.40.50.12710:FF:000040', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7', NULL, NULL, NULL, NULL, NULL, 4),
(215461, NULL, 'G3DSA:3.90.870.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215462, NULL, 'G3DSA:3.40.50.2300:FF:000397', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(215463, NULL, 'G3DSA:2.60.120.200:FF:000645', NULL, NULL, 'Heparan sulfate proteoglycan 2 domain V/endorepellin', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(215464, NULL, 'G3DSA:1.20.5.1500:FF:000016', NULL, NULL, 'Breast cancer metastasis-suppressor 1-like protein-A', NULL, NULL, NULL, NULL, NULL, 4),
(215465, NULL, 'G3DSA:3.40.710.10:FF:000008', NULL, NULL, 'Glutaminase, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(215466, NULL, 'G3DSA:1.20.120.1810:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215467, NULL, 'G3DSA:3.30.1490.480:FF:000006', NULL, NULL, 'Endolytic murein transglycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(215468, NULL, 'G3DSA:2.20.25.20:FF:000003', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(215469, NULL, 'G3DSA:4.10.1000.10:FF:000005', NULL, NULL, 'cleavage and polyadenylation specificity factor subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(215470, NULL, 'G3DSA:3.40.50.12370:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215471, NULL, 'G3DSA:2.130.10.10:FF:003440', NULL, NULL, 'Pek-1', NULL, NULL, NULL, NULL, NULL, 4),
(215472, NULL, 'G3DSA:3.40.50.720:FF:000295', NULL, NULL, '6-phospho-alpha-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(215473, NULL, 'G3DSA:3.30.70.330:FF:000886', NULL, NULL, 'Oligouridylate-binding protein 1C', NULL, NULL, NULL, NULL, NULL, 4),
(215474, NULL, 'G3DSA:1.20.1250.20:FF:000184', NULL, NULL, 'Feline leukemia virus subgroup C receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(215475, NULL, 'G3DSA:3.40.570.10:FF:000019', NULL, NULL, 'Putative endonuclease G', NULL, NULL, NULL, NULL, NULL, 4),
(215476, NULL, 'G3DSA:1.20.1560.10:FF:000390', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(215477, NULL, 'G3DSA:1.10.150.20:FF:000157', NULL, NULL, 'DNA-directed DNA polymerase, family X', NULL, NULL, NULL, NULL, NULL, 4),
(215478, NULL, 'G3DSA:3.10.250.10:FF:000013', NULL, NULL, 'CD163 molecule like 1', NULL, NULL, NULL, NULL, NULL, 4),
(215479, NULL, 'G3DSA:1.20.1250.20:FF:000077', NULL, NULL, 'Proton-coupled monocarboxylate transporter 3', NULL, NULL, NULL, NULL, NULL, 4),
(215480, NULL, 'G3DSA:1.25.40.20:FF:001761', NULL, NULL, 'Kinase, NEK-frag', NULL, NULL, NULL, NULL, NULL, 4),
(215481, NULL, 'G3DSA:2.40.150.20:FF:000011', NULL, NULL, '60S ribosomal protein L23', NULL, NULL, NULL, NULL, NULL, 4),
(215482, NULL, 'G3DSA:2.40.50.140:FF:000771', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215483, NULL, 'G3DSA:3.30.160.60:FF:003557', NULL, NULL, 'Zinc finger protein 846', NULL, NULL, NULL, NULL, NULL, 4),
(215484, NULL, 'G3DSA:3.30.710.10:FF:000393', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215485, NULL, 'G3DSA:2.60.40.420:FF:000157', NULL, NULL, 'Laccase', NULL, NULL, NULL, NULL, NULL, 4),
(215486, NULL, 'G3DSA:3.40.50.10190:FF:000334', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(215487, NULL, 'G3DSA:3.90.226.10:FF:000299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215488, NULL, 'G3DSA:3.40.50.2300:FF:000178', NULL, NULL, 'Transcriptional regulator FleQ', NULL, NULL, NULL, NULL, NULL, 4),
(215489, NULL, 'G3DSA:1.20.1270.60:FF:000062', NULL, NULL, 'Arf-GAP with coiled-coil, ANK repeat and PH domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(215490, NULL, 'G3DSA:3.40.50.11500:FF:000008', NULL, NULL, 'DENN domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(215491, NULL, 'G3DSA:3.10.290.20:FF:000013', NULL, NULL, 'SUMO-activating enzyme subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(215492, NULL, 'G3DSA:2.10.110.10:FF:000288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215493, NULL, 'G3DSA:1.10.1410.20:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215494, NULL, 'G3DSA:2.60.34.10:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215495, NULL, 'G3DSA:1.25.40.10:FF:001191', NULL, NULL, 'ESX-2 secretion system protein EccA2', NULL, NULL, NULL, NULL, NULL, 4),
(215496, NULL, 'G3DSA:3.40.50.300:FF:003159', NULL, NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(215497, NULL, 'G3DSA:3.20.10.10:FF:000020', NULL, NULL, 'Aminodeoxychorismate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(215498, NULL, 'G3DSA:1.20.1560.10:FF:000732', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215499, NULL, 'G3DSA:1.25.40.20:FF:001194', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(215500, NULL, 'G3DSA:1.10.1410.10:FF:000010', NULL, NULL, 'poly(A) RNA polymerase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(215501, NULL, 'G3DSA:3.40.50.300:FF:007094', NULL, NULL, 'Small GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215502, NULL, 'G3DSA:3.30.200.20:FF:000649', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215503, NULL, 'G3DSA:3.30.230.10:FF:000148', NULL, NULL, '30S ribosomal protein S5', NULL, NULL, NULL, NULL, NULL, 4),
(215504, NULL, 'G3DSA:2.20.25.240:FF:000010', NULL, NULL, 'AGAP004541-PA', NULL, NULL, NULL, NULL, NULL, 4),
(215505, NULL, 'G3DSA:3.40.50.12780:FF:000145', NULL, NULL, 'NRPS-like enzyme, putative (AFU_orthologue AFUA_8G01222)', NULL, NULL, NULL, NULL, NULL, 4),
(215506, NULL, 'G3DSA:3.30.160.20:FF:000027', NULL, NULL, 'Peptide chain release factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(215507, NULL, 'G3DSA:2.40.30.10:FF:000489', NULL, NULL, 'NADH-cytochrome b5 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(215508, NULL, 'G3DSA:3.40.50.1820:FF:000691', NULL, NULL, 'Putative esterase', NULL, NULL, NULL, NULL, NULL, 4),
(215509, NULL, 'G3DSA:3.40.850.10:FF:000395', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(215510, NULL, 'G3DSA:3.40.50.20:FF:000075', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(215511, NULL, 'G3DSA:2.60.40.10:FF:003905', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215512, NULL, 'G3DSA:3.40.50.11660:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215513, NULL, 'G3DSA:3.50.50.60:FF:000547', NULL, NULL, 'UDP-galactopyranose mutase', NULL, NULL, NULL, NULL, NULL, 4),
(215514, NULL, 'G3DSA:3.40.50.720:FF:000076', NULL, NULL, 'CoA-binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(215515, NULL, 'G3DSA:1.25.10.10:FF:001144', NULL, NULL, 'Importin beta-like SAD2-like isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(215516, NULL, 'G3DSA:3.30.160.60:FF:005137', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215517, NULL, 'G3DSA:1.20.1730.10:FF:000004', NULL, NULL, 'sodium/glucose cotransporter 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(215518, NULL, 'G3DSA:2.40.15.10:FF:000004', NULL, NULL, 'Protein TCL1B4', NULL, NULL, NULL, NULL, NULL, 4),
(215519, NULL, 'G3DSA:3.40.20.10:FF:000019', NULL, NULL, 'protein flightless-1 homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(215520, NULL, 'G3DSA:3.40.50.1110:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215521, NULL, 'G3DSA:3.40.50.2300:FF:000526', NULL, NULL, 'Glutamate receptor 2.5', NULL, NULL, NULL, NULL, NULL, 4),
(215522, NULL, 'G3DSA:1.10.8.60:FF:000460', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215523, NULL, 'G3DSA:1.10.1410.40:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215524, NULL, 'G3DSA:3.10.290.10:FF:000010', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(215525, NULL, 'G3DSA:3.90.320.10:FF:000057', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(215526, NULL, 'G3DSA:1.10.287.130:FF:000260', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(215527, NULL, 'G3DSA:3.90.79.10:FF:000198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215528, NULL, 'G3DSA:1.20.58.60:FF:000368', NULL, NULL, 'Spectrin beta, non-erythrocytic 5', NULL, NULL, NULL, NULL, NULL, 4),
(215529, NULL, 'G3DSA:3.40.50.1820:FF:000472', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(215530, NULL, 'G3DSA:1.10.390.10:FF:000025', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(215531, NULL, 'G3DSA:4.10.400.10:FF:000061', NULL, NULL, 'Low-density lipoprotein receptor-related protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(215532, NULL, 'G3DSA:3.80.10.10:FF:000192', NULL, NULL, 'Serine/threonine-protein kinase 11-interacting protein-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(215533, NULL, 'G3DSA:3.60.10.10:FF:000248', NULL, NULL, 'Putative sphingomyelinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(215534, NULL, 'G3DSA:1.10.800.10:FF:000007', NULL, NULL, 'Phenylalanine-4-hydroxylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215535, NULL, 'G3DSA:2.40.50.140:FF:000097', NULL, NULL, '23S rRNA (uracil(1939)-C(5))-methyltransferase RlmD', NULL, NULL, NULL, NULL, NULL, 4),
(215536, NULL, 'G3DSA:2.40.50.510:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215537, NULL, 'G3DSA:3.20.20.100:FF:000175', NULL, NULL, 'Oxidoreductase, aldo/keto reductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(215538, NULL, 'G3DSA:3.40.50.300:FF:005413', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215539, NULL, 'G3DSA:1.10.285.10:FF:000005', NULL, NULL, 'Glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(215540, NULL, 'G3DSA:1.25.40.10:FF:004973', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At1g56570', NULL, NULL, NULL, NULL, NULL, 4),
(215541, NULL, 'G3DSA:3.100.10.10:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215542, NULL, 'G3DSA:3.40.50.2020:FF:000060', NULL, NULL, 'Ribose-phosphate pyrophosphokinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215543, NULL, 'G3DSA:3.40.50.620:FF:000377', NULL, NULL, 'Deoxyribodipyrimidine photolyase', NULL, NULL, NULL, NULL, NULL, 4),
(215544, NULL, 'G3DSA:3.30.559.10:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215545, NULL, 'G3DSA:1.10.4020.10:FF:000003', NULL, NULL, 'SCAN domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(215546, NULL, 'G3DSA:3.30.70.270:FF:000172', NULL, NULL, 'Cyclic di-GMP phosphodiesterase Gmr', NULL, NULL, NULL, NULL, NULL, 4),
(215547, NULL, 'G3DSA:1.20.1370.20:FF:000001', NULL, NULL, 'Catalase HPII', NULL, NULL, NULL, NULL, NULL, 4),
(215548, NULL, 'G3DSA:3.10.310.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215549, NULL, 'G3DSA:3.20.20.190:FF:000033', NULL, NULL, 'Glycerophosphodiester phosphodiesterase domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(215550, NULL, 'G3DSA:2.60.120.650:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215551, NULL, 'G3DSA:3.40.50.300:FF:003378', NULL, NULL, 'Java no jive', NULL, NULL, NULL, NULL, NULL, 4),
(215552, NULL, 'G3DSA:3.40.50.410:FF:000320', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(215553, NULL, 'G3DSA:2.60.9.10:FF:000002', NULL, NULL, 'Vasopressin-neurophysin protein', NULL, NULL, NULL, NULL, NULL, 4),
(215554, NULL, 'G3DSA:3.40.50.10440:FF:000005', NULL, NULL, 'YALI0F09273p', NULL, NULL, NULL, NULL, NULL, 4),
(215555, NULL, 'G3DSA:2.20.100.10:FF:000173', NULL, NULL, 'Complement C7', NULL, NULL, NULL, NULL, NULL, 4),
(215556, NULL, 'G3DSA:3.40.50.300:FF:001703', NULL, NULL, 'DExH-box helicase 30', NULL, NULL, NULL, NULL, NULL, 4),
(215557, NULL, 'G3DSA:3.40.50.300:FF:002889', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(215558, NULL, 'G3DSA:3.40.50.620:FF:000725', NULL, NULL, 'Probable nicotinate-nucleotide adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(215559, NULL, 'G3DSA:1.10.510.10:FF:001542', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(215560, NULL, 'G3DSA:3.30.460.10:FF:000064', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(215561, NULL, 'G3DSA:2.30.29.170:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215562, NULL, 'G3DSA:2.60.40.10:FF:003350', NULL, NULL, 'Immunoglobulin light 3 variable 3', NULL, NULL, NULL, NULL, NULL, 4),
(215563, NULL, 'G3DSA:2.60.40.1930:FF:000017', NULL, NULL, 'Thioester-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(215564, NULL, 'G3DSA:1.25.40.20:FF:001542', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215565, NULL, 'G3DSA:3.90.180.10:FF:000068', NULL, NULL, 'Phthioceranic/hydroxyphthioceranic acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(215566, NULL, 'G3DSA:3.40.220.10:FF:000033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(215567, NULL, 'G3DSA:2.30.30.190:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215568, NULL, 'G3DSA:3.40.50.10190:FF:000115', NULL, NULL, 'DNA polymerase POL4', NULL, NULL, NULL, NULL, NULL, 4),
(215569, NULL, 'G3DSA:2.40.50.140:FF:000990', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215570, NULL, 'G3DSA:2.60.120.200:FF:000426', NULL, NULL, 'Laminin subunit alpha 5', NULL, NULL, NULL, NULL, NULL, 4),
(215571, NULL, 'G3DSA:1.10.472.80:FF:000118', NULL, NULL, 'Rab GTPase activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215572, NULL, 'G3DSA:3.40.50.720:FF:000418', NULL, NULL, 'UDP-glucose 4-epimerase 5', NULL, NULL, NULL, NULL, NULL, 4),
(215573, NULL, 'G3DSA:3.30.230.90:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215574, NULL, 'G3DSA:1.20.142.10:FF:000009', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(215575, NULL, 'G3DSA:1.20.1070.10:FF:000088', NULL, NULL, 'Angiotensin II receptor type 1', NULL, NULL, NULL, NULL, NULL, 4),
(215576, NULL, 'G3DSA:1.20.1250.20:FF:000751', NULL, NULL, 'Monocarboxylate transporter 12-B', NULL, NULL, NULL, NULL, NULL, 4),
(215577, NULL, 'G3DSA:1.20.1560.10:FF:000513', NULL, NULL, 'YALI0D24189p', NULL, NULL, NULL, NULL, NULL, 4),
(215578, NULL, 'G3DSA:3.40.50.10090:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215579, NULL, 'G3DSA:3.30.420.10:FF:000292', NULL, NULL, 'Ribonuclease H', NULL, NULL, NULL, NULL, NULL, 4),
(215580, NULL, 'G3DSA:3.80.10.10:FF:004463', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(215581, NULL, 'G3DSA:2.10.25.10:FF:000427', NULL, NULL, 'epigen isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(215582, NULL, 'G3DSA:2.60.120.260:FF:000635', NULL, NULL, 'Protein CBR-DDR-2', NULL, NULL, NULL, NULL, NULL, 4),
(215583, NULL, 'G3DSA:1.25.40.10:FF:001207', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g18970', NULL, NULL, NULL, NULL, NULL, 4),
(215584, NULL, 'G3DSA:1.10.287.130:FF:000147', NULL, NULL, 'Protein-histidine kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215585, NULL, 'G3DSA:1.25.10.10:FF:001711', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215586, NULL, 'G3DSA:1.10.238.10:FF:001280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215587, NULL, 'G3DSA:2.30.30.1020:FF:000021', NULL, NULL, 'Probable NOT transcription complex subunit VIP2', NULL, NULL, NULL, NULL, NULL, 4),
(215588, NULL, 'G3DSA:3.30.1740.10:FF:000006', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(215589, NULL, 'G3DSA:1.10.8.60:FF:000353', NULL, NULL, 'ORC1-type DNA replication protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(215590, NULL, 'G3DSA:2.60.120.290:FF:000054', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(215591, NULL, 'G3DSA:3.30.160.60:FF:005581', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215592, NULL, 'G3DSA:3.40.50.150:FF:000320', NULL, NULL, 'Ribosomal RNA-processing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(215593, NULL, 'G3DSA:1.10.630.10:FF:000415', NULL, NULL, 'Cytochrome P450 family 87 subfamily A polypeptide 2', NULL, NULL, NULL, NULL, NULL, 4),
(215594, NULL, 'G3DSA:1.20.58.1610:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215595, NULL, 'G3DSA:3.30.300.30:FF:000025', NULL, NULL, 'Acetyl-coenzyme A synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(215596, NULL, 'G3DSA:1.25.40.10:FF:000589', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(215597, NULL, 'G3DSA:1.20.1050.10:FF:000087', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(215598, NULL, 'G3DSA:3.40.50.10140:FF:000016', NULL, NULL, 'Disease resistance protein (TIR-NBS class)', NULL, NULL, NULL, NULL, NULL, 4),
(215599, NULL, 'G3DSA:1.20.91.20:FF:000006', NULL, NULL, 'Complement C4', NULL, NULL, NULL, NULL, NULL, 4),
(215600, NULL, 'G3DSA:3.40.50.2300:FF:001240', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215601, NULL, 'G3DSA:3.30.1740.20:FF:000009', NULL, NULL, '40S ribosomal protein S26', NULL, NULL, NULL, NULL, NULL, 4),
(215602, NULL, 'G3DSA:3.60.10.10:FF:000355', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215603, NULL, 'G3DSA:3.30.160.60:FF:003451', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215604, NULL, 'G3DSA:2.130.10.10:FF:001416', NULL, NULL, 'Transducin (beta)-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(215605, NULL, 'G3DSA:3.30.1140.32:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215606, NULL, 'G3DSA:2.130.10.10:FF:002939', NULL, NULL, 'WD repeat-containing protein 78', NULL, NULL, NULL, NULL, NULL, 4),
(215607, NULL, 'G3DSA:2.60.120.200:FF:000084', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(215608, NULL, 'G3DSA:2.130.10.10:FF:000798', NULL, NULL, 'Probable cytosolic iron-sulfur protein assembly protein CIAO1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(215609, NULL, 'G3DSA:3.60.21.60:FF:000030', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(215610, NULL, 'G3DSA:3.30.200.20:FF:000874', NULL, NULL, 'AGC protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(215611, NULL, 'G3DSA:1.20.5.170:FF:000057', NULL, NULL, 'Basic leucine zipper 61', NULL, NULL, NULL, NULL, NULL, 4),
(215612, NULL, 'G3DSA:1.10.12.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215613, NULL, 'G3DSA:1.20.1250.20:FF:000307', NULL, NULL, 'Solute carrier family 15 member 3', NULL, NULL, NULL, NULL, NULL, 4),
(215614, NULL, 'G3DSA:1.10.287.70:FF:000511', NULL, NULL, 'Protein CBR-TWK-44', NULL, NULL, NULL, NULL, NULL, 4),
(215615, NULL, 'G3DSA:3.30.40.10:FF:000561', NULL, NULL, 'Bromo-adjacent homology (BAH) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(215616, NULL, 'G3DSA:3.90.190.10:FF:000462', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215617, NULL, 'G3DSA:1.10.472.80:FF:000124', NULL, NULL, 'TBC/Rab GTPase activating domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(215618, NULL, 'G3DSA:3.40.50.300:FF:006020', NULL, NULL, 'AGAP009980-PA', NULL, NULL, NULL, NULL, NULL, 4),
(215619, NULL, 'G3DSA:3.30.230.10:FF:000367', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215620, NULL, 'G3DSA:1.10.8.540:FF:000002', NULL, NULL, 'Putative type III secretion system protein', NULL, NULL, NULL, NULL, NULL, 4),
(215621, NULL, 'G3DSA:1.10.260.100:FF:000001', NULL, NULL, 'Ubiquilin 1', NULL, NULL, NULL, NULL, NULL, 4),
(215622, NULL, 'G3DSA:3.80.10.10:FF:002440', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215623, NULL, 'G3DSA:3.40.190.80:FF:000016', NULL, NULL, 'Inositol monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(215624, NULL, 'G3DSA:2.30.30.140:FF:000033', NULL, NULL, 'Binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(215625, NULL, 'G3DSA:2.60.120.200:FF:000078', NULL, NULL, 'Galectin', NULL, NULL, NULL, NULL, NULL, 4),
(215626, NULL, 'G3DSA:1.10.1520.10:FF:000013', NULL, NULL, 'Endoribonuclease Dicer homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(215627, NULL, 'G3DSA:2.60.120.590:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215628, NULL, 'G3DSA:1.20.1560.10:FF:000064', NULL, NULL, 'ATP-binding cassette sub-family D member 4', NULL, NULL, NULL, NULL, NULL, 4),
(215629, NULL, 'G3DSA:2.40.50.140:FF:000546', NULL, NULL, '26S protease regulatory subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(215630, NULL, 'G3DSA:3.30.420.10:FF:000067', NULL, NULL, 'Putative CCR4-associated factor 1 11', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(215631, NULL, 'G3DSA:2.130.10.10:FF:003546', NULL, NULL, 'QUInine non-avoider', NULL, NULL, NULL, NULL, NULL, 4),
(215632, NULL, 'G3DSA:3.40.720.10:FF:000060', NULL, NULL, 'Phosphatidylglycerol specific phospholipase C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215633, NULL, 'G3DSA:1.25.40.10:FF:004967', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215634, NULL, 'G3DSA:1.10.472.80:FF:000231', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215635, NULL, 'G3DSA:3.40.50.360:FF:000046', NULL, NULL, 'NrdI protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215636, NULL, 'G3DSA:1.10.800.10:FF:000013', NULL, NULL, 'Aromatic amino acid hydroxlase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215637, NULL, 'G3DSA:3.30.200.160:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215638, NULL, 'G3DSA:1.10.285.10:FF:000011', NULL, NULL, 'Glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(215639, NULL, 'G3DSA:1.25.40.20:FF:000013', NULL, NULL, 'ARF GTPase-activating protein GIT1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(215640, NULL, 'G3DSA:3.30.70.1970:FF:000002', NULL, NULL, 'RNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(215641, NULL, 'G3DSA:1.10.405.20:FF:000002', NULL, NULL, 'Amine oxidase, flavin-containing superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(215642, NULL, 'G3DSA:1.20.5.50:FF:000001', NULL, NULL, 'Cell division protein ZapA', NULL, NULL, NULL, NULL, NULL, 4),
(215643, NULL, 'G3DSA:3.30.40.10:FF:000229', NULL, NULL, 'Cellulose synthase-like protein D3', NULL, NULL, NULL, NULL, NULL, 4),
(215644, NULL, 'G3DSA:3.80.10.10:FF:000186', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase ERECTA', NULL, NULL, NULL, NULL, NULL, 4),
(215645, NULL, 'G3DSA:1.10.287.130:FF:000254', NULL, NULL, 'Histidine kinase A domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(215646, NULL, 'G3DSA:1.10.10.1050:FF:000001', NULL, NULL, 'M7GpppN-mRNA hydrolase isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(215647, NULL, 'G3DSA:3.30.300.30:FF:000132', NULL, NULL, 'Enniatin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(215648, NULL, 'G3DSA:1.25.40.10:FF:000696', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(215649, NULL, 'G3DSA:3.30.160.60:FF:003119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215650, NULL, 'G3DSA:3.30.310.80:FF:000057', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(215651, NULL, 'G3DSA:3.30.70.850:FF:000025', NULL, NULL, 'Prohormone convertase 2', NULL, NULL, NULL, NULL, NULL, 4),
(215652, NULL, 'G3DSA:3.40.1170.10:FF:000027', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(215653, NULL, 'G3DSA:3.30.40.10:FF:002359', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215654, NULL, 'G3DSA:1.25.40.10:FF:001314', NULL, NULL, 'Os11g0213500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(215655, NULL, 'G3DSA:3.40.850.10:FF:000406', NULL, NULL, 'Kinesin-like protein KIN-6', NULL, NULL, NULL, NULL, NULL, 4),
(215656, NULL, 'G3DSA:2.30.29.30:FF:000481', NULL, NULL, 'FACT complex subunit POB3', NULL, NULL, NULL, NULL, NULL, 4),
(215657, NULL, 'G3DSA:3.90.1750.10:FF:000021', NULL, NULL, 'E3 ubiquitin-protein ligase HECTD1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(215658, NULL, 'G3DSA:3.20.20.190:FF:000145', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215659, NULL, 'G3DSA:1.20.1110.10:FF:000131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215660, NULL, 'G3DSA:1.20.1250.20:FF:001021', NULL, NULL, 'MFS sugar transporter, putative (AFU_orthologue AFUA_5G06720)', NULL, NULL, NULL, NULL, NULL, 4),
(215661, NULL, 'G3DSA:2.40.50.140:FF:001153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215662, NULL, 'G3DSA:3.60.130.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215663, NULL, 'G3DSA:3.20.20.80:FF:000283', NULL, NULL, 'Glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(215664, NULL, 'G3DSA:3.30.70.1730:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215665, NULL, 'G3DSA:3.40.50.2000:FF:000650', NULL, NULL, 'Glycosyl transferase, group 1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(215666, NULL, 'G3DSA:1.25.40.10:FF:003444', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(215667, NULL, 'G3DSA:3.40.50.300:FF:001815', NULL, NULL, 'ATP-dependent DNA helicase SRS2', NULL, NULL, NULL, NULL, NULL, 4),
(215668, NULL, 'G3DSA:3.40.630.30:FF:000620', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(215669, NULL, 'G3DSA:3.40.50.10880:FF:000002', NULL, NULL, 'Acidic residue methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(215670, NULL, 'G3DSA:3.30.200.20:FF:000981', NULL, NULL, 'Unplaced genomic scaffold supercont1.6, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(215671, NULL, 'G3DSA:3.40.850.10:FF:000389', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215672, NULL, 'G3DSA:3.40.50.800:FF:000004', NULL, NULL, 'Glycine--tRNA ligase 2', NULL, NULL, NULL, NULL, NULL, 4),
(215673, NULL, 'G3DSA:2.10.60.10:FF:000003', NULL, NULL, 'lymphocyte antigen 6E isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(215674, NULL, 'G3DSA:3.40.50.410:FF:000090', NULL, NULL, 'Secretory 24AB, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(215675, NULL, 'G3DSA:3.40.50.150:FF:001843', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215676, NULL, 'G3DSA:3.30.420.10:FF:000180', NULL, NULL, 'CCR4-NOT transcription complex, subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(215677, NULL, 'G3DSA:1.20.1460.10:FF:000005', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(215678, NULL, 'G3DSA:3.30.70.1990:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215679, NULL, 'G3DSA:3.30.70.80:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215680, NULL, 'G3DSA:3.30.750.24:FF:000049', NULL, NULL, 'Sulfate ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(215681, NULL, 'G3DSA:3.30.420.40:FF:001026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215682, NULL, 'G3DSA:3.20.20.100:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215683, NULL, 'G3DSA:3.40.50.200:FF:000026', NULL, NULL, 'Subtilisin-like protease SBT4.12', NULL, NULL, NULL, NULL, NULL, 4),
(215684, NULL, 'G3DSA:3.40.50.620:FF:000613', NULL, NULL, 'Tryptophanyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215685, NULL, 'G3DSA:3.40.20.10:FF:000025', NULL, NULL, 'Actin-depolymerizing factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(215686, NULL, 'G3DSA:3.30.300.20:FF:000022', NULL, NULL, 'Ribosome-binding factor A', NULL, NULL, NULL, NULL, NULL, 4),
(215687, NULL, 'G3DSA:2.60.120.740:FF:000009', NULL, NULL, 'DEAD (Asp-Glu-Ala-Asp) box polypeptide 41', NULL, NULL, NULL, NULL, NULL, 4),
(215688, NULL, 'G3DSA:3.20.20.70:FF:000280', NULL, NULL, 'tRNA-dihydrouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(215689, NULL, 'G3DSA:3.40.30.10:FF:001268', NULL, NULL, 'Calsequestrin', NULL, NULL, NULL, NULL, NULL, 4),
(215690, NULL, 'G3DSA:3.50.50.60:FF:000098', NULL, NULL, 'Dihydrolipoyl dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(215691, NULL, 'G3DSA:3.40.366.10:FF:000039', NULL, NULL, 'Acyl transferase/acyl hydrolase/lysophospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(215692, NULL, 'G3DSA:1.25.40.10:FF:000010', NULL, NULL, 'Stress-induced phosphoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(215693, NULL, 'G3DSA:1.10.1380.10:FF:000024', NULL, NULL, 'Cell surface zinc endopeptidase PepO', NULL, NULL, NULL, NULL, NULL, 4),
(215694, NULL, 'G3DSA:3.40.50.300:FF:007324', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215695, NULL, 'G3DSA:3.30.70.330:FF:002573', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215696, NULL, 'G3DSA:3.40.630.150:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(215697, NULL, 'G3DSA:2.70.9.10:FF:000002', NULL, NULL, 'Hexon protein', NULL, NULL, NULL, NULL, NULL, 4),
(215698, NULL, 'G3DSA:2.130.10.30:FF:000118', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215699, NULL, 'G3DSA:2.40.240.20:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215700, NULL, 'G3DSA:1.20.1740.10:FF:000156', NULL, NULL, 'Amino acid transporter (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(215701, NULL, 'G3DSA:1.10.10.10:FF:001744', NULL, NULL, 'Iron dependent repressor', NULL, NULL, NULL, NULL, NULL, 4),
(215702, NULL, 'G3DSA:3.30.160.20:FF:000033', NULL, NULL, 'Adenosine deaminase domain-containing 1 (testis-specific)', NULL, NULL, NULL, NULL, NULL, 4),
(215703, NULL, 'G3DSA:2.40.30.110:FF:000005', NULL, NULL, 'dimethylglycine dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(215704, NULL, 'G3DSA:3.30.160.60:FF:004867', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215705, NULL, 'G3DSA:3.30.40.10:FF:001977', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(215706, NULL, 'G3DSA:3.40.50.12780:FF:000139', NULL, NULL, 'AMP dependent CoA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215707, NULL, 'G3DSA:1.25.10.10:FF:003055', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(215708, NULL, 'G3DSA:1.20.5.170:FF:000164', NULL, NULL, 'Protein Mabiki', NULL, NULL, NULL, NULL, NULL, 4),
(215709, NULL, 'G3DSA:3.30.160.60:FF:003338', NULL, NULL, 'Si:ch73-221f6.3', NULL, NULL, NULL, NULL, NULL, 4),
(215710, NULL, 'G3DSA:3.40.50.2000:FF:000537', NULL, NULL, 'UDP-glycosyltransferase 83A1', NULL, NULL, NULL, NULL, NULL, 4),
(215711, NULL, 'G3DSA:2.130.10.30:FF:000006', NULL, NULL, 'E3 ubiquitin-protein ligase HERC2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(215712, NULL, 'G3DSA:2.40.240.10:FF:000015', NULL, NULL, 'Glutaminyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(215713, NULL, 'G3DSA:1.10.287.70:FF:000730', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215714, NULL, 'G3DSA:3.80.10.10:FF:000079', NULL, NULL, 'PRAME family member 18', NULL, NULL, NULL, NULL, NULL, 4),
(215715, NULL, 'G3DSA:3.40.47.10:FF:000177', NULL, NULL, '3-ketoacyl-CoA thiolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215716, NULL, 'G3DSA:3.30.470.10:FF:000020', NULL, NULL, '4-amino-4-deoxychorismate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(215717, NULL, 'G3DSA:1.20.1070.10:FF:001032', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(215718, NULL, 'G3DSA:3.30.300.160:FF:000023', NULL, NULL, 'Type IV pilus assembly protein PilB', NULL, NULL, NULL, NULL, NULL, 4),
(215719, NULL, 'G3DSA:2.40.50.140:FF:000765', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215720, NULL, 'G3DSA:3.40.1110.10:FF:000142', NULL, NULL, 'Cation-transporting P-type ATPase B', NULL, NULL, NULL, NULL, NULL, 4),
(215721, NULL, 'G3DSA:1.20.5.170:FF:000276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215722, NULL, 'G3DSA:1.10.150.60:FF:000034', NULL, NULL, 'ARID (AT-rich Interactive Domain-containing protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(215723, NULL, 'G3DSA:3.30.70.270:FF:000059', NULL, NULL, 'Diguanylate cyclase (GGDEF) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(215724, NULL, 'G3DSA:3.40.5.120:FF:000003', NULL, NULL, 'chromodomain-helicase-DNA-binding protein 9 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(215725, NULL, 'G3DSA:3.40.50.300:FF:005289', NULL, NULL, 'ADP-ribosylation factor-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(215726, NULL, 'G3DSA:2.30.42.10:FF:000455', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215727, NULL, 'G3DSA:2.30.29.30:FF:000262', NULL, NULL, 'Disabled, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(215728, NULL, 'G3DSA:3.40.50.300:FF:004688', NULL, NULL, 'Cell division control protein 48 homolog D', NULL, NULL, NULL, NULL, NULL, 4),
(215729, NULL, 'G3DSA:1.25.40.20:FF:001429', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215730, NULL, 'G3DSA:1.10.510.10:FF:001093', NULL, NULL, 'NIMA related kinase 10', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(215731, NULL, 'G3DSA:1.25.40.20:FF:001317', NULL, NULL, 'Charon', NULL, NULL, NULL, NULL, NULL, 4),
(215732, NULL, 'G3DSA:1.10.150.50:FF:000031', NULL, NULL, 'Kinase suppressor of Ras 2', NULL, NULL, NULL, NULL, NULL, 4),
(215733, NULL, 'G3DSA:3.30.70.260:FF:000056', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(215734, NULL, 'G3DSA:2.130.10.10:FF:000112', NULL, NULL, 'jouberin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(215735, NULL, 'G3DSA:3.10.580.10:FF:000111', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(215736, NULL, 'G3DSA:3.80.10.10:FF:004238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215737, NULL, 'G3DSA:2.10.25.10:FF:000652', NULL, NULL, 'Blast:Protein eyes shut', NULL, NULL, NULL, NULL, NULL, 4),
(215738, NULL, 'G3DSA:1.20.58.60:FF:000256', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(215739, NULL, 'G3DSA:3.40.50.1820:FF:000808', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(215740, NULL, 'G3DSA:3.90.228.20:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215741, NULL, 'G3DSA:1.10.8.60:FF:000134', NULL, NULL, 'AAA family ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215742, NULL, 'G3DSA:1.25.40.10:FF:001426', NULL, NULL, 'Beta-lactamase HcpA', NULL, NULL, NULL, NULL, NULL, 4),
(215743, NULL, 'G3DSA:3.40.50.720:FF:000862', NULL, NULL, 'Formate dehydrogenase chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(215744, NULL, 'G3DSA:1.25.10.10:FF:001930', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215745, NULL, 'G3DSA:1.10.287.70:FF:000168', NULL, NULL, 'Potassium sodium-activated channel subfamily T member 2', NULL, NULL, NULL, NULL, NULL, 4),
(215746, NULL, 'G3DSA:1.10.10.10:FF:001183', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(215747, NULL, 'G3DSA:3.40.250.10:FF:000192', NULL, NULL, 'Adenylyltransferase and sulfurtransferase MOCS3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(215748, NULL, 'G3DSA:3.40.50.300:FF:007543', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215749, NULL, 'G3DSA:3.40.50.2000:FF:000318', NULL, NULL, 'Glycogen phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(215750, NULL, 'G3DSA:3.90.180.10:FF:000181', NULL, NULL, 'Zinc-type alcohol dehydrogenase-like protein C337.11', NULL, NULL, NULL, NULL, NULL, 4),
(215751, NULL, 'G3DSA:2.60.40.10:FF:001764', NULL, NULL, 'Sallimus, isoform Q', NULL, NULL, NULL, NULL, NULL, 4),
(215752, NULL, 'G3DSA:2.60.120.200:FF:000191', NULL, NULL, 'MAM and LDL receptor class A domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(215753, NULL, 'G3DSA:3.40.50.1220:FF:000056', NULL, NULL, 'Pyruvate decarboxylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215754, NULL, 'G3DSA:3.40.50.11260:FF:000015', NULL, NULL, 'Heat shock protein 92', NULL, NULL, NULL, NULL, NULL, 4),
(215755, NULL, 'G3DSA:2.60.40.820:FF:000058', NULL, NULL, 'Protein CBG21788', NULL, NULL, NULL, NULL, NULL, 4),
(215756, NULL, 'G3DSA:2.60.120.430:FF:000023', NULL, NULL, 'Complex I intermediate-associated protein 30, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(215757, NULL, 'G3DSA:3.90.70.10:FF:000897', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215758, NULL, 'G3DSA:2.60.120.10:FF:000210', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(215759, NULL, 'G3DSA:1.10.437.10:FF:000005', NULL, NULL, 'bcl-2-related ovarian killer protein', NULL, NULL, NULL, NULL, NULL, 4),
(215760, NULL, 'G3DSA:3.40.33.10:FF:000111', NULL, NULL, 'uncharacterized protein LOC100180010 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(215761, NULL, 'G3DSA:3.30.160.20:FF:000252', NULL, NULL, 'Adenosine deaminase, RNA specific B2 (inactive)', NULL, NULL, NULL, NULL, NULL, 4),
(215762, NULL, 'G3DSA:2.60.40.10:FF:000022', NULL, NULL, 'Cardiac titin', NULL, NULL, NULL, NULL, NULL, 4),
(215763, NULL, 'G3DSA:3.30.70.270:FF:000278', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(215764, NULL, 'G3DSA:3.30.410.40:FF:000002', NULL, NULL, 'BnaC06g23880D protein', NULL, NULL, NULL, NULL, NULL, 4),
(215765, NULL, 'G3DSA:3.30.420.40:FF:000969', NULL, NULL, 'HSP70 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(215766, NULL, 'G3DSA:3.10.129.10:FF:000119', NULL, NULL, 'Fatty acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(215767, NULL, 'G3DSA:3.40.50.300:FF:003272', NULL, NULL, 'G Protein, Alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(215768, NULL, 'G3DSA:3.40.1190.20:FF:000138', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215769, NULL, 'G3DSA:3.40.50.1460:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215770, NULL, 'G3DSA:3.80.10.10:FF:002333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215771, NULL, 'G3DSA:1.20.1070.10:FF:000195', NULL, NULL, 'probable G-protein coupled receptor 61', NULL, NULL, NULL, NULL, NULL, 4),
(215772, NULL, 'G3DSA:1.10.10.60:FF:001169', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215773, NULL, 'G3DSA:1.10.287.1260:FF:000009', NULL, NULL, 'Possible conserved transmembrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(215774, NULL, 'G3DSA:3.40.250.10:FF:000203', NULL, NULL, 'Dual specificity phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(215775, NULL, 'G3DSA:3.40.50.620:FF:000832', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(215776, NULL, 'G3DSA:1.10.3500.10:FF:000023', NULL, NULL, 'Transcription accessory protein', NULL, NULL, NULL, NULL, NULL, 4),
(215777, NULL, 'G3DSA:3.40.50.10130:FF:000013', NULL, NULL, 'Crossover junction endonuclease EME1', NULL, NULL, NULL, NULL, NULL, 4),
(215778, NULL, 'G3DSA:3.30.160.60:FF:005362', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215779, NULL, 'G3DSA:3.40.50.300:FF:005306', NULL, NULL, 'Small GTP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(215780, NULL, 'G3DSA:3.30.40.10:FF:000448', NULL, NULL, 'Histone-lysine N-methyltransferase MLL3', NULL, NULL, NULL, NULL, NULL, 4),
(215781, NULL, 'G3DSA:3.30.2350.10:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215782, NULL, 'G3DSA:1.20.1250.20:FF:000296', NULL, NULL, 'MFS sugar transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215783, NULL, 'G3DSA:1.10.238.10:FF:001173', NULL, NULL, 'EFHC2', NULL, NULL, NULL, NULL, NULL, 4),
(215784, NULL, 'G3DSA:2.130.10.10:FF:005800', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215785, NULL, 'G3DSA:1.20.5.370:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215786, NULL, 'G3DSA:1.20.58.60:FF:000817', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215787, NULL, 'G3DSA:1.25.40.10:FF:000819', NULL, NULL, 'Coatomer subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(215788, NULL, 'G3DSA:3.40.50.1820:FF:000247', NULL, NULL, 'Phosphatidylcholine-sterol acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(215789, NULL, 'G3DSA:1.10.860.10:FF:000005', NULL, NULL, 'Replicative DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(215790, NULL, 'G3DSA:3.30.1490.70:FF:000004', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(215791, NULL, 'G3DSA:1.10.8.10:FF:000035', NULL, NULL, 'baculoviral IAP repeat-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(215792, NULL, 'G3DSA:1.10.225.10:FF:000013', NULL, NULL, 'Aspartic proteinase A1', NULL, NULL, NULL, NULL, NULL, 4),
(215793, NULL, 'G3DSA:3.40.190.10:FF:000945', NULL, NULL, 'Gll0431 protein', NULL, NULL, NULL, NULL, NULL, 4),
(215794, NULL, 'G3DSA:1.10.10.60:FF:001282', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215795, NULL, 'G3DSA:2.60.120.480:FF:000010', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(215796, NULL, 'G3DSA:3.80.10.10:FF:004019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215797, NULL, 'G3DSA:3.90.1010.10:FF:000016', NULL, NULL, 'Iron-sulfur cluster assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(215798, NULL, 'G3DSA:2.60.120.970:FF:000050', NULL, NULL, 'Transforming growth factor beta-1', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(215799, NULL, 'G3DSA:3.60.90.10:FF:000023', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme', NULL, NULL, NULL, NULL, NULL, 4),
(215800, NULL, 'G3DSA:3.30.420.10:FF:000303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215801, NULL, 'G3DSA:3.90.640.10:FF:000222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215802, NULL, 'G3DSA:3.40.640.10:FF:000469', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215803, NULL, 'G3DSA:1.20.5.350:FF:000010', NULL, NULL, 'Troponin T type 3b (skeletal, fast)', NULL, NULL, NULL, NULL, NULL, 4),
(215804, NULL, 'G3DSA:1.20.920.10:FF:000014', NULL, NULL, 'Histone acetyltransferase KAT2B', NULL, NULL, NULL, NULL, NULL, 4),
(215805, NULL, 'G3DSA:3.30.70.141:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215806, NULL, 'G3DSA:1.25.40.20:FF:000232', NULL, NULL, 'DExH-box ATP-dependent RNA helicase DExH6', NULL, NULL, NULL, NULL, NULL, 4),
(215807, NULL, 'G3DSA:3.30.50.10:FF:000168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215808, NULL, 'G3DSA:1.10.472.80:FF:000012', NULL, NULL, 'Small G protein signaling modulator 3', NULL, NULL, NULL, NULL, NULL, 4),
(215809, NULL, 'G3DSA:3.80.10.10:FF:002552', NULL, NULL, 'AGAP002004-PA', NULL, NULL, NULL, NULL, NULL, 4),
(215810, NULL, 'G3DSA:3.30.230.10:FF:000255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215811, NULL, 'G3DSA:1.20.1070.10:FF:000318', NULL, NULL, 'Trace amine associated receptor 15', NULL, NULL, NULL, NULL, NULL, 4),
(215812, NULL, 'G3DSA:2.60.40.10:FF:004979', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215813, NULL, 'G3DSA:2.60.120.10:FF:000316', NULL, NULL, 'S-adenosyl-L-homocysteine hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(215814, NULL, 'G3DSA:3.30.559.10:FF:000271', NULL, NULL, 'ACL138Cp', NULL, NULL, NULL, NULL, NULL, 4),
(215815, NULL, 'G3DSA:3.50.50.60:FF:000878', NULL, NULL, 'Squalene monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(215816, NULL, 'G3DSA:1.25.10.10:FF:001475', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215817, NULL, 'G3DSA:1.20.1560.10:FF:000283', NULL, NULL, 'Related to YBT1-Vacuolar, full-size ABC protein transporting bile acids', NULL, NULL, NULL, NULL, NULL, 4),
(215818, NULL, 'G3DSA:3.20.20.80:FF:000406', NULL, NULL, 'Chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(215819, NULL, 'G3DSA:2.30.30.140:FF:000145', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(215820, NULL, 'G3DSA:3.30.160.60:FF:003670', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215821, NULL, 'G3DSA:3.40.50.2000:FF:000756', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215822, NULL, 'G3DSA:3.30.450.20:FF:000459', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(215823, NULL, 'G3DSA:3.90.1150.10:FF:000178', NULL, NULL, 'Probable aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(215824, NULL, 'G3DSA:2.60.40.60:FF:001083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215825, NULL, 'G3DSA:4.10.410.10:FF:000123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215826, NULL, 'G3DSA:1.20.120.1080:FF:000072', NULL, NULL, 'ATP-dependent RNA helicase DHX36', NULL, NULL, NULL, NULL, NULL, 4),
(215827, NULL, 'G3DSA:1.25.40.180:FF:000247', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215828, NULL, 'G3DSA:3.40.390.10:FF:000146', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(215829, NULL, 'G3DSA:2.60.40.10:FF:005255', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215830, NULL, 'G3DSA:4.10.520.10:FF:000019', NULL, NULL, 'DNA-binding protein HU', NULL, NULL, NULL, NULL, NULL, 4),
(215831, NULL, 'G3DSA:3.30.470.20:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215832, NULL, 'G3DSA:3.30.70.330:FF:001611', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215833, NULL, 'G3DSA:1.50.10.10:FF:000006', NULL, NULL, 'Non-lysosomal glucosylceramidase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(215834, NULL, 'G3DSA:3.30.200.20:FF:001256', NULL, NULL, 'AGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(215835, NULL, 'G3DSA:3.20.20.100:FF:000063', NULL, NULL, 'Aldo/keto reductase', NULL, NULL, NULL, NULL, NULL, 4),
(215836, NULL, 'G3DSA:3.10.20.230:FF:000025', NULL, NULL, 'Rp1-like 1b', NULL, NULL, NULL, NULL, NULL, 4),
(215837, NULL, 'G3DSA:1.25.40.570:FF:000038', NULL, NULL, 'GM15765', NULL, NULL, NULL, NULL, NULL, 4),
(215838, NULL, 'G3DSA:1.10.357.140:FF:000004', NULL, NULL, 'Protoheme IX farnesyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(215839, NULL, 'G3DSA:3.40.50.300:FF:001254', NULL, NULL, 'Cell division protein ZapE', NULL, NULL, NULL, NULL, NULL, 4),
(215840, NULL, 'G3DSA:1.25.40.10:FF:004861', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215841, NULL, 'G3DSA:2.10.90.10:FF:000050', NULL, NULL, 'Nerve growth factor beta polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(215842, NULL, 'G3DSA:1.10.287.2610:FF:000004', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(215843, NULL, 'G3DSA:3.40.50.2000:FF:001032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215844, NULL, 'G3DSA:1.50.10.20:FF:000009', NULL, NULL, 'Geranylgeranyl transferase type-2 subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(215845, NULL, 'G3DSA:2.40.10.10:FF:000021', NULL, NULL, 'Kallikrein 1', NULL, NULL, NULL, NULL, NULL, 4),
(215846, NULL, 'G3DSA:2.30.30.490:FF:000008', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(215847, NULL, 'G3DSA:1.20.1720.10:FF:000048', NULL, NULL, 'Uncharacterized MFS-type transporter YfiU', NULL, NULL, NULL, NULL, NULL, 4),
(215848, NULL, 'G3DSA:1.10.287.2620:FF:000007', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215849, NULL, 'G3DSA:3.30.760.10:FF:000008', NULL, NULL, 'Eukaryotic translation initiation factor NCBP', NULL, NULL, NULL, NULL, NULL, 4),
(215850, NULL, 'G3DSA:1.10.510.10:FF:003453', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215851, NULL, 'G3DSA:3.30.360.20:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215852, NULL, 'G3DSA:2.40.128.330:FF:000008', NULL, NULL, 'CorA Metal Ion Transporter (MIT) Family', NULL, NULL, NULL, NULL, NULL, 4),
(215853, NULL, 'G3DSA:3.30.360.10:FF:000011', NULL, NULL, 'Glucose-6-phosphate 1-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(215854, NULL, 'G3DSA:3.50.50.60:FF:000991', NULL, NULL, 'Tryptophan 2-halogenase', NULL, NULL, NULL, NULL, NULL, 4),
(215855, NULL, 'G3DSA:3.30.40.10:FF:000780', NULL, NULL, 'Rab-3-interacting molecule unc-10', NULL, NULL, NULL, NULL, NULL, 4),
(215856, NULL, 'G3DSA:3.40.50.300:FF:005183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215857, NULL, 'G3DSA:3.40.710.10:FF:000121', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(215858, NULL, 'G3DSA:1.20.1260.10:FF:000024', NULL, NULL, 'Ferritin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(215859, NULL, 'G3DSA:2.130.10.10:FF:005126', NULL, NULL, 'Tomosyn-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(215860, NULL, 'G3DSA:2.30.29.30:FF:000368', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(215861, NULL, 'G3DSA:3.40.30.10:FF:000413', NULL, NULL, 'N-oligosaccharyltransferase complex 37kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(215862, NULL, 'G3DSA:1.20.120.160:FF:000042', NULL, NULL, 'Two-component phosphorelay mediator', NULL, NULL, NULL, NULL, NULL, 4),
(215863, NULL, 'G3DSA:1.10.510.10:FF:001654', NULL, NULL, 'SRSF protein kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(215864, NULL, 'G3DSA:1.10.506.10:FF:000020', NULL, NULL, 'Ras GTPase-activating protein 4 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(215865, NULL, 'G3DSA:1.20.1560.10:FF:000625', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215866, NULL, 'G3DSA:2.60.40.420:FF:000264', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(215867, NULL, 'G3DSA:3.40.30.10:FF:000071', NULL, NULL, 'Glutathione S-transferase P', NULL, NULL, NULL, NULL, NULL, 4),
(215868, NULL, 'G3DSA:3.30.160.60:FF:001871', NULL, NULL, 'Zinc finger protein 473', NULL, NULL, NULL, NULL, NULL, 4),
(215869, NULL, 'G3DSA:3.40.50.150:FF:001405', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215870, NULL, 'G3DSA:3.40.50.10190:FF:000003', NULL, NULL, 'Tumor suppressor p53-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(215871, NULL, 'G3DSA:3.40.50.300:FF:000978', NULL, NULL, 'YLP motif-containing protein 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(215872, NULL, 'G3DSA:3.30.70.660:FF:000069', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(215873, NULL, 'G3DSA:1.20.1250.20:FF:002218', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215874, NULL, 'G3DSA:3.40.605.10:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215875, NULL, 'G3DSA:3.30.930.10:FF:000263', NULL, NULL, 'Lysyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(215876, NULL, 'G3DSA:3.40.50.300:FF:005525', NULL, NULL, 'DEAD-box ATP-dependent RNA helicase 55', NULL, NULL, NULL, NULL, NULL, 4),
(215877, NULL, 'G3DSA:3.80.10.10:FF:004351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215878, NULL, 'G3DSA:1.10.565.10:FF:000050', NULL, NULL, 'Nuclear hormone receptor family member daf-12', NULL, NULL, NULL, NULL, NULL, 4),
(215879, NULL, 'G3DSA:3.30.1780.10:FF:000003', NULL, NULL, 'Protein SAR DEFICIENT 4', NULL, NULL, NULL, NULL, NULL, 4),
(215880, NULL, 'G3DSA:1.10.10.160:FF:000015', NULL, NULL, 'Possible ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(215881, NULL, 'G3DSA:3.30.2410.10:FF:000021', NULL, NULL, 'Putative ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(215882, NULL, 'G3DSA:2.170.300.10:FF:000052', NULL, NULL, 'Cell death abnormality protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(215883, NULL, 'G3DSA:3.60.10.10:FF:000136', NULL, NULL, 'Endonuclease/exonuclease/phosphatase family metal-dependent hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(215884, NULL, 'G3DSA:3.30.70.330:FF:000993', NULL, NULL, 'NOP4p Nucleolar protein', NULL, NULL, NULL, NULL, NULL, 4),
(215885, NULL, 'G3DSA:3.30.470.20:FF:000129', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(215886, NULL, 'G3DSA:3.40.50.1820:FF:000921', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(215887, NULL, 'G3DSA:3.30.1490.180:FF:000017', NULL, NULL, 'DNA-directed RNA polymerase IV subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(215888, NULL, 'G3DSA:3.40.50.2000:FF:000195', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(215889, NULL, 'G3DSA:2.60.40.10:FF:001545', NULL, NULL, 'Echinoid, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(215890, NULL, 'G3DSA:3.40.50.1010:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215891, NULL, 'G3DSA:1.10.510.10:FF:001199', NULL, NULL, 'Cyclin-dependent kinase-activating kinase', NULL, NULL, NULL, NULL, NULL, 4),
(215892, NULL, 'G3DSA:2.20.110.10:FF:000016', NULL, NULL, 'Radial spoke head 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(215893, NULL, 'G3DSA:3.40.50.1000:FF:000102', NULL, NULL, 'Enolase-phosphatase E1', NULL, NULL, NULL, NULL, NULL, 4),
(215894, NULL, 'G3DSA:1.20.58.90:FF:000017', NULL, NULL, 'SPI-1 type III secretion system effector E3 ubiquitin transferase SlrP', NULL, NULL, NULL, NULL, NULL, 4),
(215895, NULL, 'G3DSA:3.80.10.10:FF:002439', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215896, NULL, 'G3DSA:1.20.120.1910:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215897, NULL, 'G3DSA:1.10.510.10:FF:002958', NULL, NULL, 'TKL family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(215898, NULL, 'G3DSA:3.10.250.10:FF:000120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215899, NULL, 'G3DSA:3.60.110.10:FF:000054', NULL, NULL, 'Biotinidase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(215900, NULL, 'G3DSA:3.60.40.10:FF:000306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215901, NULL, 'G3DSA:3.30.70.330:FF:000555', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(215902, NULL, 'G3DSA:1.20.1560.10:FF:000844', NULL, NULL, 'AGL346Wp', NULL, NULL, NULL, NULL, NULL, 4),
(215903, NULL, 'G3DSA:1.10.10.10:FF:000002', NULL, NULL, 'RNA polymerase sigma factor SigA', NULL, NULL, NULL, NULL, NULL, 4),
(215904, NULL, 'G3DSA:3.30.260.10:FF:000083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215905, NULL, 'G3DSA:3.30.930.10:FF:000044', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(215906, NULL, 'G3DSA:3.30.160.20:FF:000139', NULL, NULL, 'Interferon-induced, double-stranded RNA-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(215907, NULL, 'G3DSA:3.60.20.10:FF:000075', NULL, NULL, 'Asparagine synthase (Glutamine-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4),
(215908, NULL, 'G3DSA:2.80.10.50:FF:000121', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(215909, NULL, 'G3DSA:1.10.238.10:FF:001279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215910, NULL, 'G3DSA:3.40.50.720:FF:000188', NULL, NULL, 'NAD(P) transhydrogenase alpha subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(215911, NULL, 'G3DSA:1.25.10.10:FF:001256', NULL, NULL, 'Armadillo repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(215912, NULL, 'G3DSA:3.40.1110.10:FF:000361', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215913, NULL, 'G3DSA:3.30.160.60:FF:005249', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215914, NULL, 'G3DSA:3.40.1390.20:FF:000013', NULL, NULL, 'HPr kinase/phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(215915, NULL, 'G3DSA:3.40.50.300:FF:001692', NULL, NULL, 'Unplaced genomic scaffold supercont2.18, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(215916, NULL, 'G3DSA:3.40.50.150:FF:001282', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215917, NULL, 'G3DSA:3.20.20.150:FF:000049', NULL, NULL, 'Sugar phosphate isomerase/epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(215918, NULL, 'G3DSA:3.90.1150.10:FF:000397', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215919, NULL, 'G3DSA:1.20.120.1240:FF:000047', NULL, NULL, 'Dynamin', NULL, NULL, NULL, NULL, NULL, 4),
(215920, NULL, 'G3DSA:1.10.10.60:FF:001063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215921, NULL, 'G3DSA:1.10.30.10:FF:000110', NULL, NULL, 'Polybromo 1', NULL, NULL, NULL, NULL, NULL, 4),
(215922, NULL, 'G3DSA:3.40.1390.10:FF:000010', NULL, NULL, 'UDP-3-O-acylglucosamine N-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(215923, NULL, 'G3DSA:3.50.50.60:FF:000659', NULL, NULL, 'Rab proteins geranylgeranyltransferase component A', NULL, NULL, NULL, NULL, NULL, 4),
(215924, NULL, 'G3DSA:3.90.190.10:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215925, NULL, 'G3DSA:1.20.1740.10:FF:000050', NULL, NULL, 'MGC157082 protein', NULL, NULL, NULL, NULL, NULL, 4),
(215926, NULL, 'G3DSA:1.10.730.20:FF:000004', NULL, NULL, 'Isoleucyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215927, NULL, 'G3DSA:3.60.40.10:FF:000183', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(215928, NULL, 'G3DSA:1.10.510.10:FF:003234', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215929, NULL, 'G3DSA:3.40.850.10:FF:000283', NULL, NULL, 'Putative inactive kinesin-like protein KIN-7B', NULL, NULL, NULL, NULL, NULL, 4),
(215930, NULL, 'G3DSA:1.10.3450.40:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215931, NULL, 'G3DSA:3.80.10.10:FF:002097', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(215932, NULL, 'G3DSA:3.20.20.140:FF:000046', NULL, NULL, 'Glutamate-ammonia ligase', NULL, NULL, NULL, NULL, NULL, 4),
(215933, NULL, 'G3DSA:1.10.630.10:FF:000292', NULL, NULL, 'Cytochrome P450 family 2 subfamily U member 1', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(215934, NULL, 'G3DSA:3.20.70.20:FF:000021', NULL, NULL, 'Ribonucleoside-diphosphate reductase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(215935, NULL, 'G3DSA:1.25.40.860:FF:000024', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(215936, NULL, 'G3DSA:3.90.70.80:FF:000081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215937, NULL, 'G3DSA:3.40.50.2300:FF:001127', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215938, NULL, 'G3DSA:2.130.10.10:FF:001293', NULL, NULL, 'UTP4, small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4),
(215939, NULL, 'G3DSA:3.30.160.60:FF:001539', NULL, NULL, 'Zinc finger protein 521', NULL, NULL, NULL, NULL, NULL, 4),
(215940, NULL, 'G3DSA:1.10.10.60:FF:000787', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215941, NULL, 'G3DSA:1.20.1070.10:FF:000650', NULL, NULL, 'uncharacterized protein LOC104265789', NULL, NULL, NULL, NULL, NULL, 4),
(215942, NULL, 'G3DSA:3.30.160.60:FF:001197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215943, NULL, 'G3DSA:2.60.40.10:FF:001326', NULL, NULL, 'Interleukin 1 receptor type 2', NULL, NULL, NULL, NULL, NULL, 4),
(215944, NULL, 'G3DSA:1.10.8.10:FF:000254', NULL, NULL, 'baculoviral IAP repeat-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(215945, NULL, 'G3DSA:2.40.50.40:FF:000027', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(215946, NULL, 'G3DSA:1.25.40.180:FF:000028', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(215947, NULL, 'G3DSA:2.60.220.50:FF:000027', NULL, NULL, 'Adhesion G protein-coupled receptor B3', NULL, NULL, NULL, NULL, NULL, 4),
(215948, NULL, 'G3DSA:2.60.40.10:FF:005036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215949, NULL, 'G3DSA:3.40.50.300:FF:002310', NULL, NULL, 'Origin of replication complex subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(215950, NULL, 'G3DSA:3.30.1120.30:FF:000033', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(215951, NULL, 'G3DSA:2.60.220.30:FF:000021', NULL, NULL, 'Netrin receptor unc-5', NULL, NULL, NULL, NULL, NULL, 4),
(215952, NULL, 'G3DSA:3.30.70.330:FF:000774', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(215953, NULL, 'G3DSA:3.40.50.720:FF:002442', NULL, NULL, 'Putative 2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(215954, NULL, 'G3DSA:1.20.58.60:FF:000711', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215955, NULL, 'G3DSA:3.50.50.60:FF:001154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215956, NULL, 'G3DSA:1.20.1280.50:FF:000115', NULL, NULL, 'F-box protein At4g02760-like', NULL, NULL, NULL, NULL, NULL, 4),
(215957, NULL, 'G3DSA:2.20.25.10:FF:000112', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(215958, NULL, 'G3DSA:3.40.630.30:FF:000401', NULL, NULL, 'Histone acetyltransferase, type b catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(215959, NULL, 'G3DSA:2.30.30.100:FF:000049', NULL, NULL, 'Small nuclear ribonucleoprotein-associated protein B', NULL, NULL, NULL, NULL, NULL, 4),
(215960, NULL, 'G3DSA:1.20.1280.290:FF:000073', NULL, NULL, 'Bidirectional sugar transporter SWEET', NULL, NULL, NULL, NULL, NULL, 4),
(215961, NULL, 'G3DSA:3.40.50.410:FF:000319', NULL, NULL, 'Collagen, type XIV, alpha 1a', NULL, NULL, NULL, NULL, NULL, 4),
(215962, NULL, 'G3DSA:3.20.20.70:FF:000403', NULL, NULL, 'Glycolate oxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215963, NULL, 'G3DSA:1.25.40.10:FF:002388', NULL, NULL, 'Os01g0959600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(215964, NULL, 'G3DSA:1.25.40.700:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215965, NULL, 'G3DSA:1.25.40.10:FF:002949', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215966, NULL, 'G3DSA:1.10.472.10:FF:000486', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(215967, NULL, 'G3DSA:3.30.428.10:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215968, NULL, 'G3DSA:2.60.40.420:FF:000045', NULL, NULL, 'Laccase 2', NULL, NULL, NULL, NULL, NULL, 4),
(215969, NULL, 'G3DSA:2.70.160.11:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215970, NULL, 'G3DSA:1.10.150.20:FF:000269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215971, NULL, 'G3DSA:2.30.29.30:FF:000149', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type', NULL, NULL, NULL, NULL, NULL, 4),
(215972, NULL, 'G3DSA:2.130.10.10:FF:005345', NULL, NULL, 'U3 small nucleolar RNA-associated protein 4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(215973, NULL, 'G3DSA:3.40.1440.60:FF:000007', NULL, NULL, 'Primosomal protein N''', NULL, NULL, NULL, NULL, NULL, 4),
(215974, NULL, 'G3DSA:3.90.650.10:FF:000048', NULL, NULL, 'Os01g0888500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(215975, NULL, 'G3DSA:3.40.50.1820:FF:000702', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(215976, NULL, 'G3DSA:1.10.287.470:FF:000007', NULL, NULL, 'HlyD family efflux transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(215977, NULL, 'G3DSA:1.25.40.710:FF:000007', NULL, NULL, 'Tripeptidyl-peptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(215978, NULL, 'G3DSA:3.20.20.70:FF:000061', NULL, NULL, 'Glutamate synthase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(215979, NULL, 'G3DSA:3.30.70.1230:FF:000123', NULL, NULL, 'Adenylate cyclase (ATP pyrophosphate-lyase) (Adenylyl cyclase)', NULL, NULL, NULL, NULL, NULL, 4),
(215980, NULL, 'G3DSA:3.40.1170.60:FF:000014', NULL, NULL, 'Related to DNA polymerase kappa', NULL, NULL, NULL, NULL, NULL, 4),
(215981, NULL, 'G3DSA:2.130.10.10:FF:001635', NULL, NULL, 'Activating molecule in BECN1-regulated autophagy protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(215982, NULL, 'G3DSA:3.30.40.10:FF:000903', NULL, NULL, 'E3 ubiquitin-protein ligase SNT2', NULL, NULL, NULL, NULL, NULL, 4),
(215983, NULL, 'G3DSA:3.40.50.11550:FF:000001', NULL, NULL, 'Protein RETICULATA-RELATED 6, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(215984, NULL, 'G3DSA:1.25.40.10:FF:003225', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(215985, NULL, 'G3DSA:4.10.1000.10:FF:000117', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(215986, NULL, 'G3DSA:1.10.600.10:FF:000026', NULL, NULL, 'NADH dehydrogenase (Ubiquinone) complex I, assembly factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(215987, NULL, 'G3DSA:1.20.5.1930:FF:000010', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(215988, NULL, 'G3DSA:3.30.450.20:FF:000572', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215989, NULL, 'G3DSA:3.40.1110.10:FF:000029', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(215990, NULL, 'G3DSA:3.40.50.150:FF:001624', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(215991, NULL, 'G3DSA:3.30.70.330:FF:001050', NULL, NULL, 'Putative RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(215992, NULL, 'G3DSA:1.10.287.460:FF:000004', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(215993, NULL, 'G3DSA:1.10.630.10:FF:000634', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(215994, NULL, 'G3DSA:4.10.240.10:FF:000200', NULL, NULL, 'Putative Zn(II)2Cys6 transcription factor (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(215995, NULL, 'G3DSA:3.20.20.80:FF:000064', NULL, NULL, 'Oligo-1,6-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(215996, NULL, 'G3DSA:3.40.50.300:FF:002035', NULL, NULL, 'DEAD/DEAH box ATP-dependent RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(215997, NULL, 'G3DSA:2.130.10.10:FF:000556', NULL, NULL, 'Syntaxin binding protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(215998, NULL, 'G3DSA:1.20.1310.10:FF:000208', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(215999, NULL, 'G3DSA:2.60.40.10:FF:002669', NULL, NULL, 'Sensory AXon guidance', NULL, NULL, NULL, NULL, NULL, 4),
(216000, NULL, 'G3DSA:4.10.240.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216001, NULL, 'G3DSA:3.40.50.150:FF:000556', NULL, NULL, 'Probable protein-L-isoaspartate O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(216002, NULL, 'G3DSA:3.30.200.20:FF:000211', NULL, NULL, 'Putative cyclin-dependent kinase 20', NULL, NULL, NULL, NULL, NULL, 4),
(216003, NULL, 'G3DSA:3.30.70.330:FF:000931', NULL, NULL, 'Serine/arginine-rich-splicing factor SR34', NULL, NULL, NULL, NULL, NULL, 4),
(216004, NULL, 'G3DSA:3.80.10.10:FF:000635', NULL, NULL, 'F-box/LRR-repeat protein 17 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(216005, NULL, 'G3DSA:1.10.287.110:FF:000439', NULL, NULL, 'Chaperone DnaJ-domain superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(216006, NULL, 'G3DSA:2.40.240.10:FF:000049', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(216007, NULL, 'G3DSA:3.30.230.130:FF:000037', NULL, NULL, 'Protein CBR-CUL-4', NULL, NULL, NULL, NULL, NULL, 4),
(216008, NULL, 'G3DSA:1.20.920.10:FF:000076', NULL, NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(216009, NULL, 'G3DSA:1.10.8.270:FF:000157', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(216010, NULL, 'G3DSA:2.102.10.10:FF:000035', NULL, NULL, 'Chlorophyllide a oxygenase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(216011, NULL, 'G3DSA:1.20.120.1080:FF:000089', NULL, NULL, 'Pre-mRNA-splicing factor ATP-dependent RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216012, NULL, 'G3DSA:3.30.230.70:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216013, NULL, 'G3DSA:2.60.40.60:FF:000453', NULL, NULL, 'Protocadherin 7', NULL, NULL, NULL, NULL, NULL, 4),
(216014, NULL, 'G3DSA:1.10.418.10:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216015, NULL, 'G3DSA:3.30.230.10:FF:000182', NULL, NULL, 'DNA mismatch repair protein MLH3', NULL, NULL, NULL, NULL, NULL, 4),
(216016, NULL, 'G3DSA:3.30.200.20:FF:000683', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216017, NULL, 'G3DSA:1.20.120.1240:FF:000013', NULL, NULL, 'Dynamin-related protein 3A', NULL, NULL, NULL, NULL, NULL, 4),
(216018, NULL, 'G3DSA:2.40.50.1060:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216019, NULL, 'G3DSA:3.30.420.40:FF:000380', NULL, NULL, 'Putative chromatin remodeling complex subunit (Arp5)', NULL, NULL, NULL, NULL, NULL, 4),
(216020, NULL, 'G3DSA:2.60.220.30:FF:000015', NULL, NULL, 'Unc-5, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(216021, NULL, 'G3DSA:3.30.70.330:FF:001387', NULL, NULL, 'Multiple RNA-binding domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(216022, NULL, 'G3DSA:1.20.58.390:FF:000319', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216023, NULL, 'G3DSA:3.30.160.60:FF:004243', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216024, NULL, 'G3DSA:3.30.200.20:FF:001672', NULL, NULL, 'AGAP007598-PA', NULL, NULL, NULL, NULL, NULL, 4),
(216025, NULL, 'G3DSA:3.40.30.10:FF:001127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216026, NULL, 'G3DSA:3.80.10.10:FF:001624', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216027, NULL, 'G3DSA:3.40.30.10:FF:000138', NULL, NULL, 'Thioredoxin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(216028, NULL, 'G3DSA:3.10.450.220:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216029, NULL, 'G3DSA:1.10.510.10:FF:000547', NULL, NULL, 'serine/threonine-protein kinase Nek3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(216030, NULL, 'G3DSA:3.40.50.450:FF:000056', NULL, NULL, '6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(216031, NULL, 'G3DSA:2.60.40.10:FF:003658', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(216032, NULL, 'G3DSA:1.10.238.10:FF:001083', NULL, NULL, 'Defective in cullin neddylation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(216033, NULL, 'G3DSA:2.60.120.10:FF:000384', NULL, NULL, 'Lysophospholipase NTE1', NULL, NULL, NULL, NULL, NULL, 4),
(216034, NULL, 'G3DSA:3.30.160.60:FF:003254', NULL, NULL, 'Zinc finger protein 561', NULL, NULL, NULL, NULL, NULL, 4),
(216035, NULL, 'G3DSA:1.10.1650.10:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216036, NULL, 'G3DSA:1.20.58.1120:FF:000020', NULL, NULL, 'Putative dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(216037, NULL, 'G3DSA:3.30.70.330:FF:001920', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216038, NULL, 'G3DSA:1.10.287.70:FF:000106', NULL, NULL, 'Potassium channel subfamily K member 4', NULL, NULL, NULL, NULL, NULL, 4),
(216039, NULL, 'G3DSA:2.130.10.10:FF:004890', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216040, NULL, 'G3DSA:3.60.20.10:FF:000210', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216041, NULL, 'G3DSA:3.30.160.60:FF:004682', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216042, NULL, 'G3DSA:1.10.630.10:FF:000174', NULL, NULL, 'Similar to cytochrome P450 monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(216043, NULL, 'G3DSA:1.25.10.10:FF:002560', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216044, NULL, 'G3DSA:1.20.1540.10:FF:000017', NULL, NULL, 'RHOMBOID-like protein 9, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(216045, NULL, 'G3DSA:3.40.50.300:FF:003024', NULL, NULL, 'Activator 1 40 kDa subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216046, NULL, 'G3DSA:1.10.3810.10:FF:000007', NULL, NULL, 'Penicillin-binding protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(216047, NULL, 'G3DSA:2.40.160.10:FF:000048', NULL, NULL, 'Zinc-regulated TonB-dependent zinc receptor', NULL, NULL, NULL, NULL, NULL, 4),
(216048, NULL, 'G3DSA:1.10.1370.30:FF:000029', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(216049, NULL, 'G3DSA:2.60.40.1730:FF:000042', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(216050, NULL, 'G3DSA:3.40.50.300:FF:004805', NULL, NULL, '6-phosphofructo-2-kinase/fructose-2, 6-bisphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(216051, NULL, 'G3DSA:3.40.50.2000:FF:000554', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(216052, NULL, 'G3DSA:3.40.50.10330:FF:000079', NULL, NULL, 'Ceramide kinase-like isoform 5', NULL, NULL, NULL, NULL, NULL, 4),
(216053, NULL, 'G3DSA:1.20.1070.10:FF:001280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216054, NULL, 'G3DSA:3.30.70.330:FF:002376', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216055, NULL, 'G3DSA:1.10.510.10:FF:000108', NULL, NULL, 'L-type lectin-domain containing receptor kinase S.4', NULL, NULL, NULL, NULL, NULL, 4),
(216056, NULL, 'G3DSA:1.10.510.10:FF:001536', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216057, NULL, 'G3DSA:3.90.550.50:FF:000171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216058, NULL, 'G3DSA:1.25.40.10:FF:004153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216059, NULL, 'G3DSA:3.30.450.20:FF:000403', NULL, NULL, 'Diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(216060, NULL, 'G3DSA:1.20.1250.20:FF:002044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216061, NULL, 'G3DSA:1.20.1070.10:FF:002089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216062, NULL, 'G3DSA:1.50.40.10:FF:000199', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(216063, NULL, 'G3DSA:2.120.10.30:FF:000383', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216064, NULL, 'G3DSA:3.20.20.190:FF:000134', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216065, NULL, 'G3DSA:3.40.50.1820:FF:000949', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(216066, NULL, 'G3DSA:3.10.180.10:FF:000047', NULL, NULL, 'Glyoxalase/bleomycin resistance protein/dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(216067, NULL, 'G3DSA:1.20.1260.10:FF:000035', NULL, NULL, 'Reverse rubrerythrin-2', NULL, NULL, NULL, NULL, NULL, 4),
(216068, NULL, 'G3DSA:3.30.1370.10:FF:000141', NULL, NULL, 'KRR1 small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4),
(216069, NULL, 'G3DSA:3.20.180.20:FF:000031', NULL, NULL, 'Dynein heavy chain domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(216070, NULL, 'G3DSA:3.30.40.10:FF:002022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216071, NULL, 'G3DSA:1.10.1410.10:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216072, NULL, 'G3DSA:3.30.420.10:FF:000365', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216073, NULL, 'G3DSA:3.40.50.1000:FF:000563', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216074, NULL, 'G3DSA:1.10.3720.10:FF:000208', NULL, NULL, 'Sugar ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(216075, NULL, 'G3DSA:1.25.40.470:FF:000008', NULL, NULL, 'Intraflagellar transport protein 172 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(216076, NULL, 'G3DSA:3.40.50.300:FF:000270', NULL, NULL, 'Eukaryotic peptide chain release factor GTP-binding subunit ERF3A', NULL, NULL, NULL, NULL, NULL, 4),
(216077, NULL, 'G3DSA:3.40.630.10:FF:000266', NULL, NULL, 'Peptide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(216078, NULL, 'G3DSA:3.30.200.20:FF:002009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216079, NULL, 'G3DSA:2.20.25.20:FF:000014', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(216080, NULL, 'G3DSA:3.30.200.20:FF:001200', NULL, NULL, 'Bifunctional tRNA (Adenosine(37)-N6)-threonylcarbamoyltransferase complex ATPase subunit type 1 TsaE/phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(216081, NULL, 'G3DSA:2.180.10.10:FF:000003', NULL, NULL, 'Teneurin-1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(216082, NULL, 'G3DSA:1.10.510.10:FF:002964', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(216083, NULL, 'G3DSA:3.90.1480.20:FF:000031', NULL, NULL, 'GalNAc alpha 2,6-sialyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(216084, NULL, 'G3DSA:3.80.10.10:FF:003069', NULL, NULL, 'F-box and leucine-rich repeat protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(216085, NULL, 'G3DSA:2.10.60.10:FF:000076', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(216086, NULL, 'G3DSA:1.25.40.20:FF:000148', NULL, NULL, 'cyclin-dependent kinase 4 inhibitor C', NULL, NULL, NULL, NULL, NULL, 4),
(216087, NULL, 'G3DSA:1.25.40.10:FF:003197', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g74900, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(216088, NULL, 'G3DSA:1.20.1250.20:FF:001847', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216089, NULL, 'G3DSA:3.30.160.60:FF:005671', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216090, NULL, 'G3DSA:1.10.8.60:FF:000325', NULL, NULL, 'ATP-dependent zinc metallopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216091, NULL, 'G3DSA:3.30.40.10:FF:000044', NULL, NULL, 'Regulating synaptic membrane exocytosis protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(216092, NULL, 'G3DSA:6.20.10.30:FF:000013', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(216093, NULL, 'G3DSA:3.90.132.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216094, NULL, 'G3DSA:3.40.50.1820:FF:000157', NULL, NULL, 'Triacylglycerol lipase', NULL, NULL, NULL, NULL, NULL, 4),
(216095, NULL, 'G3DSA:3.10.20.30:FF:000010', NULL, NULL, 'Molybdopterin synthase sulfur carrier subunit', NULL, NULL, NULL, NULL, NULL, 4),
(216096, NULL, 'G3DSA:1.10.1870.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216097, NULL, 'G3DSA:2.20.70.10:FF:000172', NULL, NULL, 'HECT, C2 and WW domain containing E3 ubiquitin protein ligase 2', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(216098, NULL, 'G3DSA:1.20.1050.10:FF:000109', NULL, NULL, 'Glutathione S-transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216099, NULL, 'G3DSA:2.130.10.10:FF:002973', NULL, NULL, 'Chromatin assembly factor 1 subunit FAS2', NULL, NULL, NULL, NULL, NULL, 4),
(216100, NULL, 'G3DSA:1.20.5.300:FF:000012', NULL, NULL, 'Spike glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(216101, NULL, 'G3DSA:1.10.510.10:FF:004442', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216102, NULL, 'G3DSA:2.40.50.100:FF:000129', NULL, NULL, 'ABC transporter related protein', NULL, NULL, NULL, NULL, NULL, 4),
(216103, NULL, 'G3DSA:3.90.45.10:FF:000018', NULL, NULL, 'Peptide deformylase', NULL, NULL, NULL, NULL, NULL, 4),
(216104, NULL, 'G3DSA:1.25.40.450:FF:000002', NULL, NULL, 'Putative non-repetitive nucleoporin', NULL, NULL, NULL, NULL, NULL, 4),
(216105, NULL, 'G3DSA:1.10.441.10:FF:000010', NULL, NULL, 'Mannose-6-phosphate isomerase, class I', NULL, NULL, NULL, NULL, NULL, 4),
(216106, NULL, 'G3DSA:1.20.144.10:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216107, NULL, 'G3DSA:3.40.120.10:FF:000036', NULL, NULL, 'Phosphoacetylglucosamine mutase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216108, NULL, 'G3DSA:3.40.1110.10:FF:000378', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216109, NULL, 'G3DSA:2.130.10.130:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216110, NULL, 'G3DSA:2.60.40.10:FF:005575', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216111, NULL, 'G3DSA:3.40.50.410:FF:000331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216112, NULL, 'G3DSA:4.10.860.10:FF:000011', NULL, NULL, 'Chaperone protein ClpC1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(216113, NULL, 'G3DSA:1.20.1250.20:FF:001408', NULL, NULL, 'Transporter, MFS superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(216114, NULL, 'G3DSA:3.30.9.10:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216115, NULL, 'G3DSA:1.10.238.10:FF:000094', NULL, NULL, 'ninein isoform X7', NULL, NULL, NULL, NULL, NULL, 4),
(216116, NULL, 'G3DSA:3.30.2060.10:FF:000005', NULL, NULL, 'Transcription-repair-coupling factor', NULL, NULL, NULL, NULL, NULL, 4),
(216117, NULL, 'G3DSA:2.60.40.10:FF:001860', NULL, NULL, 'Sucrose nonfermenting 4-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(216118, NULL, 'G3DSA:1.10.720.10:FF:000001', NULL, NULL, 'Transcription termination factor Rho', NULL, NULL, NULL, NULL, NULL, 4),
(216119, NULL, 'G3DSA:2.40.10.10:FF:000414', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216120, NULL, 'G3DSA:3.30.565.10:FF:000251', NULL, NULL, 'Sensor histide kinase', NULL, NULL, NULL, NULL, NULL, 4),
(216121, NULL, 'G3DSA:3.90.1150.10:FF:000329', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(216122, NULL, 'G3DSA:3.40.50.10810:FF:000161', NULL, NULL, 'SNF2 family N-terminal domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(216123, NULL, 'G3DSA:3.90.550.10:FF:000299', NULL, NULL, 'Translation initiation factor eIF-2B epsilon subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216124, NULL, 'G3DSA:2.60.220.50:FF:000140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216125, NULL, 'G3DSA:3.30.420.10:FF:000718', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216126, NULL, 'G3DSA:2.70.150.10:FF:000187', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(216127, NULL, 'G3DSA:3.30.160.60:FF:002265', NULL, NULL, 'Specific RNA polymerase II transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(216128, NULL, 'G3DSA:1.20.1250.20:FF:000919', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(216129, NULL, 'G3DSA:2.60.200.20:FF:000242', NULL, NULL, 'FHA domain-containing protein DDL', NULL, NULL, NULL, NULL, NULL, 4),
(216130, NULL, 'G3DSA:3.30.420.140:FF:000010', NULL, NULL, 'Putative pre-16S rRNA nuclease', NULL, NULL, NULL, NULL, NULL, 4),
(216131, NULL, 'G3DSA:3.10.20.90:FF:000393', NULL, NULL, 'Autophagy protein 5', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(216132, NULL, 'G3DSA:2.10.25.10:FF:001607', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216133, NULL, 'G3DSA:3.40.50.720:FF:001941', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216134, NULL, 'G3DSA:1.10.472.10:FF:000654', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216135, NULL, 'G3DSA:1.10.3730.10:FF:000006', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(216136, NULL, 'G3DSA:3.90.70.10:FF:000503', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216137, NULL, 'G3DSA:1.10.150.670:FF:000006', NULL, NULL, 'Crossover junction endonuclease mus81', NULL, NULL, NULL, NULL, NULL, 4),
(216138, NULL, 'G3DSA:1.10.510.10:FF:003953', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216139, NULL, 'G3DSA:1.10.10.60:FF:001001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216140, NULL, 'G3DSA:1.20.1250.20:FF:001908', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216141, NULL, 'G3DSA:3.30.70.980:FF:000013', NULL, NULL, 'Probable transcriptional regulatory protein SAMN02910431_03073', NULL, NULL, NULL, NULL, NULL, 4),
(216142, NULL, 'G3DSA:3.30.160.60:FF:006160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216143, NULL, 'G3DSA:1.25.10.10:FF:000143', NULL, NULL, 'ADP-ribosylation factor guanine nucleotide-exchange factor 2 (brefeldin A-inhibited)', NULL, NULL, NULL, NULL, NULL, 4),
(216144, NULL, 'G3DSA:2.60.300.12:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216145, NULL, 'G3DSA:3.40.50.720:FF:000952', NULL, NULL, 'Oxidoreductase/ transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(216146, NULL, 'G3DSA:1.10.10.2360:FF:000006', NULL, NULL, 'F2K11.11', NULL, NULL, NULL, NULL, NULL, 4),
(216147, NULL, 'G3DSA:2.60.40.10:FF:004586', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216148, NULL, 'G3DSA:3.40.1280.10:FF:000036', NULL, NULL, 'MRM1p Ribose methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(216149, NULL, 'G3DSA:3.30.870.10:FF:000185', NULL, NULL, 'Tyrosyl-DNA phosphodiesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(216150, NULL, 'G3DSA:3.40.1810.10:FF:000032', NULL, NULL, 'MADS transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(216151, NULL, 'G3DSA:1.20.5.1700:FF:000008', NULL, NULL, 'transforming acidic coiled-coil-containing protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(216152, NULL, 'G3DSA:3.30.160.60:FF:006008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216153, NULL, 'G3DSA:1.10.150.110:FF:000007', NULL, NULL, 'CCAAT-box DNA binding protein subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(216154, NULL, 'G3DSA:3.40.30.10:FF:000290', NULL, NULL, 'Redoxin', NULL, NULL, NULL, NULL, NULL, 4),
(216155, NULL, 'G3DSA:3.40.50.2300:FF:001482', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216156, NULL, 'G3DSA:1.10.10.10:FF:001891', NULL, NULL, 'Transcriptional regulator (FurR family)', NULL, NULL, NULL, NULL, NULL, 4),
(216157, NULL, 'G3DSA:2.60.120.200:FF:000095', NULL, NULL, 'Lectin family integral membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(216158, NULL, 'G3DSA:4.10.60.10:FF:000111', NULL, NULL, 'AAEL017419-PA', NULL, NULL, NULL, NULL, NULL, 4),
(216159, NULL, 'G3DSA:3.40.309.10:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216160, NULL, 'G3DSA:1.25.40.10:FF:005142', NULL, NULL, 'ABC transporter, membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(216161, NULL, 'G3DSA:3.20.20.80:FF:000423', NULL, NULL, 'Glycoprotein endo-alpha-1,2-mannosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216162, NULL, 'G3DSA:2.130.10.10:FF:001984', NULL, NULL, '3-carboxy-cis,cis-mucoante lactonizing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(216163, NULL, 'G3DSA:2.60.120.260:FF:000034', NULL, NULL, 'furin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(216164, NULL, 'G3DSA:3.20.20.70:FF:000566', NULL, NULL, 'Delta-aminolevulinic acid dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(216165, NULL, 'G3DSA:3.30.200.20:FF:002509', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(216166, NULL, 'G3DSA:1.10.30.10:FF:000054', NULL, NULL, 'Swi snf-related matrix-associated actin-dependent regulator of', NULL, NULL, NULL, NULL, NULL, 4),
(216167, NULL, 'G3DSA:2.130.10.10:FF:002473', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(216168, NULL, 'G3DSA:3.30.9.10:FF:000252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216169, NULL, 'G3DSA:2.40.50.140:FF:000001', NULL, NULL, '30S ribosomal protein S12', NULL, NULL, NULL, NULL, NULL, 4),
(216170, NULL, 'G3DSA:2.80.10.50:FF:000166', NULL, NULL, 'Protein O-mannosyl-transferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(216171, NULL, 'G3DSA:2.40.10.10:FF:000353', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216172, NULL, 'G3DSA:3.30.40.10:FF:001033', NULL, NULL, 'MBD9', NULL, NULL, NULL, NULL, NULL, 4),
(216173, NULL, 'G3DSA:2.30.29.30:FF:001335', NULL, NULL, 'BcDNA.GH04637', NULL, NULL, NULL, NULL, NULL, 4),
(216174, NULL, 'G3DSA:2.40.50.100:FF:000068', NULL, NULL, 'V-type ATP synthase alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(216175, NULL, 'G3DSA:3.30.2160.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216176, NULL, 'G3DSA:2.30.42.10:FF:000365', NULL, NULL, 'Discs large 5, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(216177, NULL, 'G3DSA:2.70.150.10:FF:000215', NULL, NULL, 'Putative cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(216178, NULL, 'G3DSA:1.10.20.10:FF:000109', NULL, NULL, 'Nuclear factor Y subunit C10', NULL, NULL, NULL, NULL, NULL, 4),
(216179, NULL, 'G3DSA:2.130.10.10:FF:001012', NULL, NULL, 'Actin cross-linking, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216180, NULL, 'G3DSA:1.10.1410.10:FF:000050', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(216181, NULL, 'G3DSA:1.10.510.10:FF:002025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216182, NULL, 'G3DSA:3.90.550.10:FF:000619', NULL, NULL, 'UDP-N-acetyl-alpha-D-galactosamine: polypeptide N-acetylgalactosaminyltransferase 7', NULL, NULL, NULL, NULL, NULL, 4),
(216183, NULL, 'G3DSA:1.10.1170.10:FF:000042', NULL, NULL, 'Protein bir1', NULL, NULL, NULL, NULL, NULL, 4),
(216184, NULL, 'G3DSA:1.10.533.10:FF:000263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216185, NULL, 'G3DSA:2.60.40.150:FF:000368', NULL, NULL, 'SEC63 homolog, protein translocation regulator', NULL, NULL, NULL, NULL, NULL, 4),
(216186, NULL, 'G3DSA:3.50.30.30:FF:000155', NULL, NULL, 'Os01g0740650 protein', NULL, NULL, NULL, NULL, NULL, 4),
(216187, NULL, 'G3DSA:3.30.160.60:FF:002326', NULL, NULL, 'B-cell CLL/lymphoma 6 member B protein', NULL, NULL, NULL, NULL, NULL, 4),
(216188, NULL, 'G3DSA:1.25.40.10:FF:000471', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(216189, NULL, 'G3DSA:3.40.50.150:FF:001484', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216190, NULL, 'G3DSA:3.10.20.90:FF:000893', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216191, NULL, 'G3DSA:2.130.10.10:FF:001192', NULL, NULL, 'Protein SLOW WALKER 1', NULL, NULL, NULL, NULL, NULL, 4),
(216192, NULL, 'G3DSA:3.40.50.720:FF:001441', NULL, NULL, 'Pyrrolysine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(216193, NULL, 'G3DSA:2.30.29.230:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216194, NULL, 'G3DSA:1.25.40.10:FF:003697', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g02330, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(216195, NULL, 'G3DSA:3.40.50.2300:FF:000846', NULL, NULL, 'Probable metabotropic glutamate receptor mgl-1', NULL, NULL, NULL, NULL, NULL, 4),
(216196, NULL, 'G3DSA:3.80.10.10:FF:004025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216197, NULL, 'G3DSA:3.30.750.24:FF:000009', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(216198, NULL, 'G3DSA:1.10.510.10:FF:002172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(216199, NULL, 'G3DSA:3.90.550.50:FF:000232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216200, NULL, 'G3DSA:3.30.160.60:FF:002765', NULL, NULL, 'Si:dkey-77f5.8', NULL, NULL, NULL, NULL, NULL, 4),
(216201, NULL, 'G3DSA:1.25.40.10:FF:003989', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216202, NULL, 'G3DSA:1.25.40.10:FF:001752', NULL, NULL, 'WGS project CABT00000000 data, contig 2.24', NULL, NULL, NULL, NULL, NULL, 4),
(216203, NULL, 'G3DSA:1.10.10.10:FF:001952', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(216204, NULL, 'G3DSA:3.90.190.10:FF:000344', NULL, NULL, 'Kinetoplastid-specific dual specificity phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216205, NULL, 'G3DSA:2.60.40.10:FF:006059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216206, NULL, 'G3DSA:3.40.50.300:FF:007178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216207, NULL, 'G3DSA:3.30.160.60:FF:004182', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216208, NULL, 'G3DSA:2.40.70.10:FF:000362', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216209, NULL, 'G3DSA:3.40.30.10:FF:001066', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(216210, NULL, 'G3DSA:1.10.238.10:FF:000155', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(216211, NULL, 'G3DSA:3.10.100.10:FF:000008', NULL, NULL, 'collagen alpha-1(XVIII) chain isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(216212, NULL, 'G3DSA:1.10.730.10:FF:000058', NULL, NULL, 'Leucine-tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216213, NULL, 'G3DSA:2.60.40.150:FF:000076', NULL, NULL, 'multiple C2 and transmembrane domain-containing protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(216214, NULL, 'G3DSA:3.40.50.300:FF:000118', NULL, NULL, 'Rho-related GTP-binding protein RhoG', NULL, NULL, NULL, NULL, NULL, 4),
(216215, NULL, 'G3DSA:3.30.70.120:FF:000014', NULL, NULL, 'DUF190 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(216216, NULL, 'G3DSA:2.130.10.10:FF:003962', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216217, NULL, 'G3DSA:1.10.1670.10:FF:000035', NULL, NULL, 'Endonuclease III homolog', NULL, NULL, NULL, NULL, NULL, 4),
(216218, NULL, 'G3DSA:1.10.510.10:FF:002464', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216219, NULL, 'G3DSA:2.60.40.640:FF:000127', NULL, NULL, 'Arrestin-C', NULL, NULL, NULL, NULL, NULL, 4),
(216220, NULL, 'G3DSA:1.20.1250.20:FF:000599', NULL, NULL, 'Sugar transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216221, NULL, 'G3DSA:2.60.120.10:FF:000704', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(216222, NULL, 'G3DSA:2.60.40.10:FF:001360', NULL, NULL, 'neurofascin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(216223, NULL, 'G3DSA:2.10.230.10:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216224, NULL, 'G3DSA:3.30.559.10:FF:000158', NULL, NULL, 'HC-toxin synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(216225, NULL, 'G3DSA:3.30.160.60:FF:001337', NULL, NULL, 'Zinc finger protein 286A', NULL, NULL, NULL, NULL, NULL, 4),
(216226, NULL, 'G3DSA:3.30.559.70:FF:000069', NULL, NULL, 'Carnitine palmitoyltransferase I, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216227, NULL, 'G3DSA:3.40.50.960:FF:000001', NULL, NULL, '6,7-dimethyl-8-ribityllumazine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(216228, NULL, 'G3DSA:3.30.559.10:FF:000130', NULL, NULL, 'Nonribosomal peptide synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216229, NULL, 'G3DSA:1.25.40.10:FF:002236', NULL, NULL, 'Chaperone protein dnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(216230, NULL, 'G3DSA:3.30.342.10:FF:000054', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(216231, NULL, 'G3DSA:3.40.50.980:FF:000007', NULL, NULL, 'Acyl-CoA synthetase family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(216232, NULL, 'G3DSA:3.40.190.10:FF:000069', NULL, NULL, 'HTH-type transcriptional regulator lrhA', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(216233, NULL, 'G3DSA:3.10.129.10:FF:000271', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216234, NULL, 'G3DSA:1.10.10.60:FF:001181', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216235, NULL, 'G3DSA:3.30.40.10:FF:000869', NULL, NULL, 'Cellulose synthase-like protein D3', NULL, NULL, NULL, NULL, NULL, 4),
(216236, NULL, 'G3DSA:3.40.1210.10:FF:000003', NULL, NULL, 'Survival protein SurE-like phosphatase/nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(216237, NULL, 'G3DSA:2.40.420.20:FF:000004', NULL, NULL, 'Macrolide transporter subunit MacA', NULL, NULL, NULL, NULL, NULL, 4),
(216238, NULL, 'G3DSA:1.20.1250.20:FF:000419', NULL, NULL, 'Monosaccharide transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216239, NULL, 'G3DSA:3.40.50.1100:FF:000267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216240, NULL, 'G3DSA:2.60.40.60:FF:000806', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(216241, NULL, 'G3DSA:1.20.1050.10:FF:000261', NULL, NULL, 'Ganglioside-induced differentiation-associated protein 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(216242, NULL, 'G3DSA:3.40.190.10:FF:000310', NULL, NULL, 'Iron(III) ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(216243, NULL, 'G3DSA:2.40.128.250:FF:000001', NULL, NULL, 'Transferrin binding protein B', NULL, NULL, NULL, NULL, NULL, 4),
(216244, NULL, 'G3DSA:3.30.200.20:FF:000711', NULL, NULL, 'Receptor-like protein kinase HSL1', NULL, NULL, NULL, NULL, NULL, 4),
(216245, NULL, 'G3DSA:3.30.160.60:FF:000820', NULL, NULL, 'Zinc finger protein 512B', NULL, NULL, NULL, NULL, NULL, 4),
(216246, NULL, 'G3DSA:1.25.40.10:FF:004214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216247, NULL, 'G3DSA:2.40.70.10:FF:000070', NULL, NULL, 'Aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(216248, NULL, 'G3DSA:3.50.50.60:FF:000553', NULL, NULL, 'Glutamate synthase beta subunit putative', NULL, NULL, NULL, NULL, NULL, 4),
(216249, NULL, 'G3DSA:3.80.10.10:FF:004497', NULL, NULL, 'Os01g0821900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(216250, NULL, 'G3DSA:3.80.10.10:FF:002260', NULL, NULL, 'CD14 antigen', NULL, NULL, NULL, NULL, NULL, 4),
(216251, NULL, 'G3DSA:1.20.1050.10:FF:000289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216252, NULL, 'G3DSA:2.60.40.10:FF:003597', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216253, NULL, 'G3DSA:3.40.50.10750:FF:000002', NULL, NULL, 'NADP-dependent malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(216254, NULL, 'G3DSA:2.130.10.10:FF:001484', NULL, NULL, 'Os03g0145600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(216255, NULL, 'G3DSA:1.20.120.1760:FF:000079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216256, NULL, 'G3DSA:3.90.79.10:FF:000023', NULL, NULL, 'Peroxisomal NADH pyrophosphatase NUDT12', NULL, NULL, NULL, NULL, NULL, 4),
(216257, NULL, 'G3DSA:1.20.1250.20:FF:000127', NULL, NULL, 'Monocarboxylate transporter 9 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(216258, NULL, 'G3DSA:3.40.50.300:FF:006430', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216259, NULL, 'G3DSA:3.30.230.10:FF:000210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216260, NULL, 'G3DSA:3.30.420.40:FF:000441', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(216261, NULL, 'G3DSA:3.20.20.100:FF:000208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216262, NULL, 'G3DSA:3.40.190.10:FF:000602', NULL, NULL, 'Chorismate mutase/prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(216263, NULL, 'G3DSA:1.25.40.10:FF:002528', NULL, NULL, 'SGS domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(216264, NULL, 'G3DSA:1.10.8.960:FF:000004', NULL, NULL, 'Glutamate--cysteine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(216265, NULL, 'G3DSA:1.10.390.10:FF:000019', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(216266, NULL, 'G3DSA:3.30.70.2460:FF:000003', NULL, NULL, 'DNA-repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216267, NULL, 'G3DSA:3.30.200.20:FF:000183', NULL, NULL, 'Probable multifunctional protein ADE2', NULL, NULL, NULL, NULL, NULL, 4),
(216268, NULL, 'G3DSA:3.30.470.160:FF:000009', NULL, NULL, 'Kinase', NULL, NULL, NULL, NULL, NULL, 4),
(216269, NULL, 'G3DSA:2.70.170.10:FF:000250', NULL, NULL, 'Nicotinic acetylcholine receptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(216270, NULL, 'G3DSA:2.10.25.10:FF:001754', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(216271, NULL, 'G3DSA:3.10.110.10:FF:000245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216272, NULL, 'G3DSA:3.90.1100.10:FF:000057', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(216273, NULL, 'G3DSA:3.30.565.10:FF:000543', NULL, NULL, 'Two-component response regulator, sigma factor PP2C-like phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(216274, NULL, 'G3DSA:3.80.10.10:FF:003980', NULL, NULL, 'Protein phosphatase 2C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216275, NULL, 'G3DSA:3.30.60.60:FF:000009', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(216276, NULL, 'G3DSA:1.20.1530.20:FF:000048', NULL, NULL, 'Solute carrier family 10, member 4', NULL, NULL, NULL, NULL, NULL, 4),
(216277, NULL, 'G3DSA:3.40.50.1820:FF:000449', NULL, NULL, 'GPI inositol-deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(216278, NULL, 'G3DSA:2.60.40.60:FF:000953', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(216279, NULL, 'G3DSA:2.60.120.1190:FF:000003', NULL, NULL, 'Discoidin domain-containing receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(216280, NULL, 'G3DSA:3.40.50.2300:FF:000054', NULL, NULL, 'RbsB (Ribose ABC transporter)', NULL, NULL, NULL, NULL, NULL, 4),
(216281, NULL, 'G3DSA:3.40.50.1820:FF:001085', NULL, NULL, 'Serine peptidase, family S28, putative (AFU_orthologue AFUA_4G03790)', NULL, NULL, NULL, NULL, NULL, 4),
(216282, NULL, 'G3DSA:3.40.640.10:FF:000031', NULL, NULL, 'Kynureninase', NULL, NULL, NULL, NULL, NULL, 4),
(216283, NULL, 'G3DSA:3.40.390.10:FF:000230', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216284, NULL, 'G3DSA:3.40.50.150:FF:000056', NULL, NULL, 'Polyamine aminopropyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(216285, NULL, 'G3DSA:3.40.50.300:FF:004452', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216286, NULL, 'G3DSA:3.40.50.10190:FF:000082', NULL, NULL, 'Os11g0191300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(216287, NULL, 'G3DSA:1.10.600.10:FF:000054', NULL, NULL, 'NADH dehydrogenase (ubiquinone) complex I, assembly factor 6 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(216288, NULL, 'G3DSA:2.60.40.10:FF:000871', NULL, NULL, 'PKHD1, fibrocystin/polyductin', NULL, NULL, NULL, NULL, NULL, 4),
(216289, NULL, 'G3DSA:2.40.30.10:FF:000444', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(216290, NULL, 'G3DSA:3.80.10.10:FF:000135', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(216291, NULL, 'G3DSA:3.40.50.300:FF:003996', NULL, NULL, 'Secretion-associated RAS super family 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(216292, NULL, 'G3DSA:2.30.140.10:FF:000010', NULL, NULL, 'Spermine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(216293, NULL, 'G3DSA:1.20.1070.10:FF:001633', NULL, NULL, 'Thromboxane A2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(216294, NULL, 'G3DSA:1.20.58.60:FF:000790', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216295, NULL, 'G3DSA:2.60.40.1230:FF:000015', NULL, NULL, 'AP-2 complex subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(216296, NULL, 'G3DSA:2.10.25.10:FF:001315', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216297, NULL, 'G3DSA:3.40.1340.10:FF:000007', NULL, NULL, 'RNA polymerase II subunit Rpb5a', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(216298, NULL, 'G3DSA:3.50.50.60:FF:000261', NULL, NULL, 'N-methyl-L-tryptophan oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(216299, NULL, 'G3DSA:3.30.230.70:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216300, NULL, 'G3DSA:1.25.40.20:FF:000620', NULL, NULL, 'Receptor-interacting serine/threonine-protein kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(216301, NULL, 'G3DSA:3.30.70.920:FF:000041', NULL, NULL, 'Transcriptional regulator, AsnC family', NULL, NULL, NULL, NULL, NULL, 4),
(216302, NULL, 'G3DSA:1.10.510.10:FF:004150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216303, NULL, 'G3DSA:3.30.200.20:FF:002156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216304, NULL, 'G3DSA:1.10.3210.10:FF:000097', NULL, NULL, 'Metal dependent phosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(216305, NULL, 'G3DSA:3.90.226.10:FF:000001', NULL, NULL, 'ATP-dependent Clp protease proteolytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(216306, NULL, 'G3DSA:1.25.10.10:FF:000582', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(216307, NULL, 'G3DSA:1.25.10.10:FF:002408', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216308, NULL, 'G3DSA:2.30.29.30:FF:000879', NULL, NULL, 'YALI0D12540p', NULL, NULL, NULL, NULL, NULL, 4),
(216309, NULL, 'G3DSA:1.50.10.10:FF:000079', NULL, NULL, 'Putative glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(216310, NULL, 'G3DSA:2.10.25.10:FF:000298', NULL, NULL, 'basement membrane-specific heparan sulfate proteoglycan core protein', NULL, NULL, NULL, NULL, NULL, 4),
(216311, NULL, 'G3DSA:3.30.559.70:FF:000041', NULL, NULL, 'Carnitine O-palmitoyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216312, NULL, 'G3DSA:2.40.30.10:FF:000005', NULL, NULL, 'Elongation factor 1-alpha', NULL, NULL, NULL, NULL, NULL, 4),
(216313, NULL, 'G3DSA:3.80.10.10:FF:003541', NULL, NULL, 'Os10g0148800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(216314, NULL, 'G3DSA:2.60.40.60:FF:000514', NULL, NULL, 'GD20623', NULL, NULL, NULL, NULL, NULL, 4),
(216315, NULL, 'G3DSA:1.20.1740.10:FF:000145', NULL, NULL, 'Solute carrier family 7 member 5', NULL, NULL, NULL, NULL, NULL, 4),
(216316, NULL, 'G3DSA:3.10.580.10:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216317, NULL, 'G3DSA:1.10.238.10:FF:000947', NULL, NULL, 'Ninein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216318, NULL, 'G3DSA:1.25.40.20:FF:001137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216319, NULL, 'G3DSA:3.40.50.300:FF:007739', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216320, NULL, 'G3DSA:3.40.50.300:FF:001046', NULL, NULL, 'Probable ATP-dependent RNA helicase ddx56', NULL, NULL, NULL, NULL, NULL, 4),
(216321, NULL, 'G3DSA:1.20.1070.10:FF:001780', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216322, NULL, 'G3DSA:3.40.50.280:FF:000011', NULL, NULL, 'Possible methyltransferase (Methylase)', NULL, NULL, NULL, NULL, NULL, 4),
(216323, NULL, 'G3DSA:3.30.1330.10:FF:000048', NULL, NULL, 'Trifunctional purine biosynthetic protein adenosine-3', NULL, NULL, NULL, NULL, NULL, 4),
(216324, NULL, 'G3DSA:1.25.10.10:FF:001099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216325, NULL, 'G3DSA:1.10.10.60:FF:000545', NULL, NULL, 'Unplaced genomic scaffold supercont1.28, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(216326, NULL, 'G3DSA:3.10.100.10:FF:000188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216327, NULL, 'G3DSA:3.40.50.360:FF:000001', NULL, NULL, 'NAD(P)H dehydrogenase (Quinone) FQR1-like', NULL, NULL, NULL, NULL, NULL, 4),
(216328, NULL, 'G3DSA:2.60.120.200:FF:000123', NULL, NULL, 'Thrombospondin 4', NULL, NULL, NULL, NULL, NULL, 4),
(216329, NULL, 'G3DSA:3.40.309.10:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216330, NULL, 'G3DSA:3.90.79.10:FF:000170', NULL, NULL, 'Bifunctional NMN adenylyltransferase/Nudix hydrolase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(216331, NULL, 'G3DSA:2.60.40.10:FF:000432', NULL, NULL, 'Protein tyrosine kinase 7 (inactive)', NULL, NULL, NULL, NULL, NULL, 4),
(216332, NULL, 'G3DSA:1.10.520.10:FF:000053', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(216333, NULL, 'G3DSA:3.30.420.610:FF:000022', NULL, NULL, 'Emb|CAB71880.1', NULL, NULL, NULL, NULL, NULL, 4),
(216334, NULL, 'G3DSA:3.30.160.60:FF:000409', NULL, NULL, 'zinc finger protein 644 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(216335, NULL, 'G3DSA:1.10.287.70:FF:000578', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216336, NULL, 'G3DSA:3.90.180.10:FF:000107', NULL, NULL, 'Alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(216337, NULL, 'G3DSA:3.10.100.10:FF:000160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216338, NULL, 'G3DSA:2.130.10.10:FF:005227', NULL, NULL, 'Ribosome biogenesis protein WDR12 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(216339, NULL, 'G3DSA:1.10.357.10:FF:000078', NULL, NULL, 'TetR/AcrR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(216340, NULL, 'G3DSA:3.40.50.1240:FF:000051', NULL, NULL, 'Phosphoglycerate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(216341, NULL, 'G3DSA:1.10.357.10:FF:000050', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(216342, NULL, 'G3DSA:3.30.70.330:FF:001448', NULL, NULL, 'RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(216343, NULL, 'G3DSA:2.130.10.10:FF:002501', NULL, NULL, 'Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(216344, NULL, 'G3DSA:1.20.1250.20:FF:001055', NULL, NULL, 'Nitrate transporter 2.2', NULL, NULL, NULL, NULL, NULL, 4),
(216345, NULL, 'G3DSA:2.60.40.1170:FF:000003', NULL, NULL, 'Putative AP-2 complex subunit mu', NULL, NULL, NULL, NULL, NULL, 4),
(216346, NULL, 'G3DSA:2.50.20.10:FF:000010', NULL, NULL, 'Outer-membrane lipoprotein carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(216347, NULL, 'G3DSA:1.10.1740.140:FF:000002', NULL, NULL, 'ATP-dependent RNA helicase SUV3 homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(216348, NULL, 'G3DSA:3.30.160.60:FF:002618', NULL, NULL, 'Bmp-induced factor', NULL, NULL, NULL, NULL, NULL, 4),
(216349, NULL, 'G3DSA:3.40.50.300:FF:003816', NULL, NULL, 'Si:dkey-96f10.1', NULL, NULL, NULL, NULL, NULL, 4),
(216350, NULL, 'G3DSA:1.10.10.10:FF:000463', NULL, NULL, 'Rrf2 family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(216351, NULL, 'G3DSA:3.40.50.360:FF:000029', NULL, NULL, 'NAD(P)H dehydrogenase [quinone] 1', NULL, NULL, NULL, NULL, NULL, 4),
(216352, NULL, 'G3DSA:3.40.50.300:FF:004305', NULL, NULL, 'Small GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216353, NULL, 'G3DSA:2.60.40.10:FF:004614', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216354, NULL, 'G3DSA:3.50.50.60:FF:000114', NULL, NULL, 'spermine oxidase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(216355, NULL, 'G3DSA:1.10.1200.10:FF:000157', NULL, NULL, 'Polyketide synthase RzxE', NULL, NULL, NULL, NULL, NULL, 4),
(216356, NULL, 'G3DSA:2.60.40.10:FF:005103', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216357, NULL, 'G3DSA:1.20.144.10:FF:000098', NULL, NULL, 'Diacylglycerol pyrophosphate (DGPP) phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216358, NULL, 'G3DSA:3.40.390.10:FF:000258', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216359, NULL, 'G3DSA:1.10.287.130:FF:000097', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(216360, NULL, 'G3DSA:2.10.50.30:FF:000025', NULL, NULL, 'Vomeronasal 2, receptor 73', NULL, NULL, NULL, NULL, NULL, 4),
(216361, NULL, 'G3DSA:2.30.42.10:FF:000073', NULL, NULL, 'Interacting with PRKCA', NULL, NULL, NULL, NULL, NULL, 4),
(216362, NULL, 'G3DSA:1.10.287.770:FF:000030', NULL, NULL, 'Cyclic di-AMP synthase CdaS', NULL, NULL, NULL, NULL, NULL, 4),
(216363, NULL, 'G3DSA:2.60.40.60:FF:000745', NULL, NULL, 'Fat-like cadherin-related tumor suppressor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(216364, NULL, 'G3DSA:3.30.310.10:FF:000036', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(216365, NULL, 'G3DSA:2.170.16.10:FF:000039', NULL, NULL, 'Transcription initiation factor IIB', NULL, NULL, NULL, NULL, NULL, 4),
(216366, NULL, 'G3DSA:2.60.40.10:FF:002377', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(216367, NULL, 'G3DSA:3.90.1150.10:FF:000301', NULL, NULL, 'Putative acetylornithine/succinylornithine aminotransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(216368, NULL, 'G3DSA:3.30.450.60:FF:000067', NULL, NULL, 'Signal sequence receptor alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(216369, NULL, 'G3DSA:2.30.30.40:FF:000009', NULL, NULL, 'Breast cancer anti-estrogen resistance 1', NULL, NULL, NULL, NULL, NULL, 4),
(216370, NULL, 'G3DSA:3.40.50.10860:FF:000035', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(216371, NULL, 'G3DSA:2.70.170.10:FF:000278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216372, NULL, 'G3DSA:2.130.10.10:FF:000848', NULL, NULL, 'SNARE-dependent exocytosis protein (Sro7), putative', NULL, NULL, NULL, NULL, NULL, 4),
(216373, NULL, 'G3DSA:3.90.1480.20:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216374, NULL, 'G3DSA:3.30.160.60:FF:000320', NULL, NULL, 'Zinc finger protein 777', NULL, NULL, NULL, NULL, NULL, 4),
(216375, NULL, 'G3DSA:1.10.287.110:FF:000147', NULL, NULL, 'JJJ2p protein', NULL, NULL, NULL, NULL, NULL, 4),
(216376, NULL, 'G3DSA:1.10.189.10:FF:000001', NULL, NULL, 'Pyruvate, phosphate dikinase', NULL, NULL, NULL, NULL, NULL, 4),
(216377, NULL, 'G3DSA:3.80.10.10:FF:003041', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(216378, NULL, 'G3DSA:1.25.40.20:FF:000592', NULL, NULL, 'Water witch, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(216379, NULL, 'G3DSA:3.20.20.70:FF:000274', NULL, NULL, 'Triosephosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(216380, NULL, 'G3DSA:1.20.140.40:FF:000025', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(216381, NULL, 'G3DSA:3.40.190.10:FF:000541', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(216382, NULL, 'G3DSA:3.80.10.10:FF:003569', NULL, NULL, 'Proteophosphoglycan ppg1', NULL, NULL, NULL, NULL, NULL, 4),
(216383, NULL, 'G3DSA:3.30.40.140:FF:000008', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(216384, NULL, 'G3DSA:1.25.40.20:FF:000648', NULL, NULL, 'Calcium-independent phospholipase A2 VIA, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(216385, NULL, 'G3DSA:3.30.50.10:FF:000050', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(216386, NULL, 'G3DSA:2.30.42.10:FF:000657', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216387, NULL, 'G3DSA:3.40.50.300:FF:002327', NULL, NULL, 'DEAD-box ATP-dependent RNA helicase 26', NULL, NULL, NULL, NULL, NULL, 4),
(216388, NULL, 'G3DSA:1.25.40.20:FF:000120', NULL, NULL, 'krev interaction trapped protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(216389, NULL, 'G3DSA:3.30.200.20:FF:000975', NULL, NULL, 'Protein CBG00445', NULL, NULL, NULL, NULL, NULL, 4),
(216390, NULL, 'G3DSA:1.20.58.70:FF:000028', NULL, NULL, 'Syntaxin, Qa-SNARE family', NULL, NULL, NULL, NULL, NULL, 4),
(216391, NULL, 'G3DSA:3.40.50.1820:FF:001646', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216392, NULL, 'G3DSA:3.30.930.10:FF:000095', NULL, NULL, 'Phenylalanine--tRNA ligase alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(216393, NULL, 'G3DSA:1.25.10.10:FF:001071', NULL, NULL, 'U3 small nucleolar RNA-associated protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(216394, NULL, 'G3DSA:3.20.20.300:FF:000004', NULL, NULL, 'probable beta-D-xylosidase 7', NULL, NULL, NULL, NULL, NULL, 4),
(216395, NULL, 'G3DSA:1.25.40.10:FF:002680', NULL, NULL, 'protein HGV2-like', NULL, NULL, NULL, NULL, NULL, 4),
(216396, NULL, 'G3DSA:1.10.472.80:FF:000130', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(216397, NULL, 'G3DSA:2.60.40.10:FF:005042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(216398, NULL, 'G3DSA:3.90.260.10:FF:000052', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(216399, NULL, 'G3DSA:1.25.10.10:FF:000082', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(216400, NULL, 'G3DSA:1.20.1070.10:FF:000144', NULL, NULL, 'G protein-coupled receptor 143', NULL, NULL, NULL, NULL, NULL, 4),
(216401, NULL, 'G3DSA:2.30.30.40:FF:000392', NULL, NULL, 'SMAll', NULL, NULL, NULL, NULL, NULL, 4),
(216402, NULL, 'G3DSA:3.40.50.2300:FF:001190', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216403, NULL, 'G3DSA:3.30.450.40:FF:000061', NULL, NULL, 'Adenylate/guanylate cyclase catalytic domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(216404, NULL, 'G3DSA:2.40.30.10:FF:000236', NULL, NULL, 'Translation initiation factor IF-2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216405, NULL, 'G3DSA:3.40.140.10:FF:000066', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(216406, NULL, 'G3DSA:2.30.29.30:FF:000054', NULL, NULL, 'PH and SEC7 domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(216407, NULL, 'G3DSA:2.10.25.10:FF:001107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216408, NULL, 'G3DSA:1.10.10.790:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216409, NULL, 'G3DSA:1.10.10.10:FF:000019', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(216410, NULL, 'G3DSA:2.130.10.10:FF:001837', NULL, NULL, 'THO complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(216411, NULL, 'G3DSA:2.30.30.1020:FF:000015', NULL, NULL, 'Unplaced genomic scaffold supercont1.35, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(216412, NULL, 'G3DSA:1.10.287.110:FF:000091', NULL, NULL, 'Chaperone protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216413, NULL, 'G3DSA:2.40.50.140:FF:000973', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216414, NULL, 'G3DSA:1.25.10.20:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216415, NULL, 'G3DSA:2.40.370.10:FF:000002', NULL, NULL, 'Kievitone hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(216416, NULL, 'G3DSA:3.30.70.330:FF:002404', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216417, NULL, 'G3DSA:2.40.320.10:FF:000022', NULL, NULL, 'Putative mediator of RNA polymerase II transcription subunit 18', NULL, NULL, NULL, NULL, NULL, 4),
(216418, NULL, 'G3DSA:2.130.10.10:FF:002029', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(216419, NULL, 'G3DSA:1.20.5.1300:FF:000012', NULL, NULL, 'Histidinol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(216420, NULL, 'G3DSA:3.40.50.1000:FF:000271', NULL, NULL, 'Haloacid dehalogenase-like hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(216421, NULL, 'G3DSA:3.30.2300.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216422, NULL, 'G3DSA:3.30.70.660:FF:000002', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(216423, NULL, 'G3DSA:1.20.1070.10:FF:001572', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(216424, NULL, 'G3DSA:3.30.60.20:FF:000025', NULL, NULL, 'Chimaerin', NULL, NULL, NULL, NULL, NULL, 4),
(216425, NULL, 'G3DSA:2.60.40.10:FF:000724', NULL, NULL, 'ephrin type-A receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(216426, NULL, 'G3DSA:3.40.50.300:FF:000562', NULL, NULL, 'Structural maintenance of chromosomes protein', NULL, NULL, NULL, NULL, NULL, 4),
(216427, NULL, 'G3DSA:1.25.10.10:FF:002908', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216428, NULL, 'G3DSA:1.10.10.10:FF:001391', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216429, NULL, 'G3DSA:1.20.58.60:FF:000879', NULL, NULL, 'Spectrin repeat-containing, nuclear envelope family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(216430, NULL, 'G3DSA:3.40.47.10:FF:000002', NULL, NULL, 'Acetyl-CoA acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(216431, NULL, 'G3DSA:3.40.50.2000:FF:000262', NULL, NULL, 'Trehalose-6-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(216432, NULL, 'G3DSA:3.30.2010.10:FF:000002', NULL, NULL, 'CAAX prenyl protease', NULL, NULL, NULL, NULL, NULL, 4),
(216433, NULL, 'G3DSA:3.40.50.1100:FF:000003', NULL, NULL, 'Cystathionine beta-synthase', NULL, NULL, NULL, NULL, NULL, 4),
(216434, NULL, 'G3DSA:3.60.21.10:FF:000173', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(216435, NULL, 'G3DSA:2.20.25.10:FF:000096', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(216436, NULL, 'G3DSA:1.10.8.100:FF:000005', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(216437, NULL, 'G3DSA:1.10.20.10:FF:000048', NULL, NULL, 'Chromatin accessibility complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(216438, NULL, 'G3DSA:1.10.540.10:FF:000083', NULL, NULL, 'Acyl-CoA dehydrogenase, short-chain specific', NULL, NULL, NULL, NULL, NULL, 4),
(216439, NULL, 'G3DSA:3.40.50.300:FF:000618', NULL, NULL, 'ATP-binding cassette (ABC) transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216440, NULL, 'G3DSA:3.30.450.20:FF:000111', NULL, NULL, 'Potassium voltage-gated channel subfamily H member 5', NULL, NULL, NULL, NULL, NULL, 4),
(216441, NULL, 'G3DSA:3.30.70.60:FF:000015', NULL, NULL, 'Pilus assembly protein PilO', NULL, NULL, NULL, NULL, NULL, 4),
(216442, NULL, 'G3DSA:3.30.430.20:FF:000048', NULL, NULL, 'Os01g0366300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(216443, NULL, 'G3DSA:3.80.10.10:FF:001916', NULL, NULL, 'Brassinosteroid-insensitive 1', NULL, NULL, NULL, NULL, NULL, 4),
(216444, NULL, 'G3DSA:3.30.160.60:FF:003546', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216445, NULL, 'G3DSA:3.30.160.60:FF:002826', NULL, NULL, 'Zinc finger protein 473', NULL, NULL, NULL, NULL, NULL, 4),
(216446, NULL, 'G3DSA:3.30.420.10:FF:000073', NULL, NULL, 'DNA polymerase epsilon catalytic subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(216447, NULL, 'G3DSA:3.30.60.30:FF:000085', NULL, NULL, 'Serine protease inhibitor Kazal-type 13', NULL, NULL, NULL, NULL, NULL, 4),
(216448, NULL, 'G3DSA:1.10.510.10:FF:001828', NULL, NULL, 'BRSK2 isoform 14', NULL, NULL, NULL, NULL, NULL, 4),
(216449, NULL, 'G3DSA:2.40.50.180:FF:000018', NULL, NULL, 'Purine-binding chemotaxis protein CheW', NULL, NULL, NULL, NULL, NULL, 4),
(216450, NULL, 'G3DSA:3.10.330.10:FF:000025', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(216451, NULL, 'G3DSA:3.90.70.10:FF:000650', NULL, NULL, 'HlyB/MsbA family ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(216452, NULL, 'G3DSA:3.60.21.60:FF:000024', NULL, NULL, 'DNA polymerase alpha subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(216453, NULL, 'G3DSA:3.50.50.60:FF:001042', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(216454, NULL, 'G3DSA:2.160.10.10:FF:000105', NULL, NULL, 'Translation initiation factor eIF-2B subunit epsilon-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(216455, NULL, 'G3DSA:2.10.220.10:FF:000173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216456, NULL, 'G3DSA:3.10.180.10:FF:000108', NULL, NULL, '4-hydroxyphenylpyruvate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(216457, NULL, 'G3DSA:2.60.120.330:FF:000083', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(216458, NULL, 'G3DSA:3.40.1370.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216459, NULL, 'G3DSA:3.60.20.10:FF:000182', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216460, NULL, 'G3DSA:1.25.40.10:FF:004445', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216461, NULL, 'G3DSA:3.30.70.330:FF:002668', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216462, NULL, 'G3DSA:2.60.40.10:FF:001388', NULL, NULL, 'ephrin type-A receptor 3-like', NULL, NULL, NULL, NULL, NULL, 4),
(216463, NULL, 'G3DSA:3.30.160.60:FF:000792', NULL, NULL, 'Zinc finger and BTB domain-containing protein 16', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(216464, NULL, 'G3DSA:3.30.200.20:FF:000391', NULL, NULL, 'Large tumor suppressor kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(216465, NULL, 'G3DSA:3.90.550.10:FF:000771', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(216466, NULL, 'G3DSA:2.100.10.30:FF:000013', NULL, NULL, 'Agglutinin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(216467, NULL, 'G3DSA:3.30.450.40:FF:000117', NULL, NULL, 'Diguanylate cyclase-related enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(216468, NULL, 'G3DSA:1.25.10.10:FF:002852', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216469, NULL, 'G3DSA:2.60.40.1080:FF:000009', NULL, NULL, 'Putative invasin', NULL, NULL, NULL, NULL, NULL, 4),
(216470, NULL, 'G3DSA:3.40.50.300:FF:004513', NULL, NULL, 'DNA repair helicase TFIIH P90', NULL, NULL, NULL, NULL, NULL, 4),
(216471, NULL, 'G3DSA:3.40.50.300:FF:005941', NULL, NULL, 'RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216472, NULL, 'G3DSA:2.30.30.30:FF:000063', NULL, NULL, 'Transcription elongation factor SPT5', NULL, NULL, NULL, NULL, NULL, 4),
(216473, NULL, 'G3DSA:1.20.1640.10:FF:000053', NULL, NULL, 'PaTched Related family', NULL, NULL, NULL, NULL, NULL, 4),
(216474, NULL, 'G3DSA:1.20.1070.10:FF:001925', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216475, NULL, 'G3DSA:1.10.1620.20:FF:000006', NULL, NULL, 'Mitochondrial ATP synthase F1, epsilon subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216476, NULL, 'G3DSA:3.30.200.20:FF:000239', NULL, NULL, 'Calcium/calmodulin-dependent protein kinase type II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(216477, NULL, 'G3DSA:2.110.10.10:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216478, NULL, 'G3DSA:4.10.280.10:FF:000045', NULL, NULL, 'upstream stimulatory factor 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(216479, NULL, 'G3DSA:2.40.240.10:FF:000021', NULL, NULL, 'Glutamate--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(216480, NULL, 'G3DSA:3.30.1120.10:FF:000010', NULL, NULL, 'Arylsulfatase atsA', NULL, NULL, NULL, NULL, NULL, 4),
(216481, NULL, 'G3DSA:2.70.130.10:FF:000124', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216482, NULL, 'G3DSA:1.25.40.10:FF:000319', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(216483, NULL, 'G3DSA:3.40.50.300:FF:007386', NULL, NULL, 'Atl2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(216484, NULL, 'G3DSA:2.60.120.920:FF:000046', NULL, NULL, 'tripartite motif-containing protein 16', NULL, NULL, NULL, NULL, NULL, 4),
(216485, NULL, 'G3DSA:3.10.390.10:FF:000001', NULL, NULL, 'SKI family transcriptional corepressor 1', NULL, NULL, NULL, NULL, NULL, 4),
(216486, NULL, 'G3DSA:1.25.40.180:FF:000045', NULL, NULL, 'snRNA cap binding complex subunit (Gcr3), putative', NULL, NULL, NULL, NULL, NULL, 4),
(216487, NULL, 'G3DSA:1.10.510.10:FF:000047', NULL, NULL, 'Rho-associated protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(216488, NULL, 'G3DSA:3.40.50.300:FF:006930', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216489, NULL, 'G3DSA:1.10.510.10:FF:001980', NULL, NULL, 'Receptor-like protein kinase THESEUS 1', NULL, NULL, NULL, NULL, NULL, 4),
(216490, NULL, 'G3DSA:3.30.420.40:FF:000941', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216491, NULL, 'G3DSA:3.40.50.1910:FF:000004', NULL, NULL, 'Vacuolar protein sorting-associated protein 45', NULL, NULL, NULL, NULL, NULL, 4),
(216492, NULL, 'G3DSA:3.30.160.60:FF:000056', NULL, NULL, 'Zinc finger and SCAN domain-containing 20', NULL, NULL, NULL, NULL, NULL, 4),
(216493, NULL, 'G3DSA:4.10.170.10:FF:000008', NULL, NULL, 'Cellular tumor antigen p53', NULL, NULL, NULL, NULL, NULL, 4),
(216494, NULL, 'G3DSA:1.10.238.220:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216495, NULL, 'G3DSA:1.10.490.10:FF:000022', NULL, NULL, 'Heme-based aerotactic transducer HemAT', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(216496, NULL, 'G3DSA:2.60.40.150:FF:000104', NULL, NULL, 'coiled-coil and C2 domain-containing protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(216497, NULL, 'G3DSA:3.30.70.330:FF:001887', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216498, NULL, 'G3DSA:3.40.50.700:FF:000002', NULL, NULL, 'Hydrogenase-1 small chain', NULL, NULL, NULL, NULL, NULL, 4),
(216499, NULL, 'G3DSA:2.60.120.340:FF:000024', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase FKBP53', NULL, NULL, NULL, NULL, NULL, 4),
(216500, NULL, 'G3DSA:2.60.220.10:FF:000004', NULL, NULL, 'Xanthan lyase', NULL, NULL, NULL, NULL, NULL, 4),
(216501, NULL, 'G3DSA:3.40.50.720:FF:000008', NULL, NULL, 'calcium-activated potassium channel subunit alpha-1 isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(216502, NULL, 'G3DSA:3.30.160.60:FF:005199', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216503, NULL, 'G3DSA:3.80.20.20:FF:000049', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(216504, NULL, 'G3DSA:2.60.120.260:FF:000298', NULL, NULL, 'CUB domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(216505, NULL, 'G3DSA:3.40.50.300:FF:004160', NULL, NULL, 'ABC transporter (Glutamine transport ATP-binding protein)', NULL, NULL, NULL, NULL, NULL, 4),
(216506, NULL, 'G3DSA:3.30.870.10:FF:000005', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(216507, NULL, 'G3DSA:1.10.530.40:FF:000006', NULL, NULL, 'Internal virion protein', NULL, NULL, NULL, NULL, NULL, 4),
(216508, NULL, 'G3DSA:1.10.560.10:FF:000027', NULL, NULL, 'T-complex protein 1 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(216509, NULL, 'G3DSA:1.10.510.10:FF:002233', NULL, NULL, 'CMGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(216510, NULL, 'G3DSA:2.130.10.10:FF:004446', NULL, NULL, 'Os07g0203700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(216511, NULL, 'G3DSA:1.25.10.10:FF:002588', NULL, NULL, 'Importin-beta N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(216512, NULL, 'G3DSA:3.40.50.620:FF:000276', NULL, NULL, 'Electron transfer flavoprotein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(216513, NULL, 'G3DSA:2.40.50.140:FF:001254', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216514, NULL, 'G3DSA:2.10.110.10:FF:000344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216515, NULL, 'G3DSA:3.50.50.60:FF:000906', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(216516, NULL, 'G3DSA:3.30.590.10:FF:000023', NULL, NULL, 'Probable glutamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(216517, NULL, 'G3DSA:3.30.540.10:FF:000020', NULL, NULL, 'PAP-specific phosphatase HAL2-like', NULL, NULL, NULL, NULL, NULL, 4),
(216518, NULL, 'G3DSA:1.10.630.10:FF:000466', NULL, NULL, 'Os07g0291750 protein', NULL, NULL, NULL, NULL, NULL, 4),
(216519, NULL, 'G3DSA:3.10.100.10:FF:000216', NULL, NULL, 'Mannose receptor, C type 2', NULL, NULL, NULL, NULL, NULL, 4),
(216520, NULL, 'G3DSA:3.10.20.740:FF:000009', NULL, NULL, '64kDa iron hydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216521, NULL, 'G3DSA:2.30.30.40:FF:000161', NULL, NULL, 'Actin polymerization protein Bzz1', NULL, NULL, NULL, NULL, NULL, 4),
(216522, NULL, 'G3DSA:3.70.10.10:FF:000012', NULL, NULL, 'cell cycle checkpoint control protein RAD9A', NULL, NULL, NULL, NULL, NULL, 4),
(216523, NULL, 'G3DSA:1.25.40.10:FF:001308', NULL, NULL, 'pentatricopeptide repeat-containing protein At5g46460, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(216524, NULL, 'G3DSA:2.60.120.620:FF:000046', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(216525, NULL, 'G3DSA:1.20.1070.10:FF:000852', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(216526, NULL, 'G3DSA:1.10.10.60:FF:000837', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216527, NULL, 'G3DSA:3.40.30.10:FF:000610', NULL, NULL, 'Glutathione Stransferase EC 25118', NULL, NULL, NULL, NULL, NULL, 4),
(216528, NULL, 'G3DSA:3.30.70.380:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(216529, NULL, 'G3DSA:1.10.3450.30:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216530, NULL, 'G3DSA:1.10.150.50:FF:000025', NULL, NULL, 'Ankyrin repeat and sterile alpha motif domain-containing 6', NULL, NULL, NULL, NULL, NULL, 4),
(216531, NULL, 'G3DSA:3.90.190.10:FF:000136', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type 61F', NULL, NULL, NULL, NULL, NULL, 4),
(216532, NULL, 'G3DSA:1.10.472.130:FF:000058', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216533, NULL, 'G3DSA:3.30.420.40:FF:000880', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(216534, NULL, 'G3DSA:2.160.20.10:FF:000342', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216535, NULL, 'G3DSA:2.40.50.140:FF:000265', NULL, NULL, '30S ribosomal protein S17, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(216536, NULL, 'G3DSA:1.10.1040.10:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216537, NULL, 'G3DSA:2.30.29.30:FF:000907', NULL, NULL, 'FACT complex subunit SSRP1', NULL, NULL, NULL, NULL, NULL, 4),
(216538, NULL, 'G3DSA:2.40.160.10:FF:000020', NULL, NULL, 'Voltage-dependent anion-selective channel protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216539, NULL, 'G3DSA:3.30.70.330:FF:002876', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216540, NULL, 'G3DSA:1.10.510.10:FF:000608', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216541, NULL, 'G3DSA:3.40.30.10:FF:001274', NULL, NULL, 'Calsequestrin', NULL, NULL, NULL, NULL, NULL, 4),
(216542, NULL, 'G3DSA:3.30.110.30:FF:000010', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(216543, NULL, 'G3DSA:1.10.10.10:FF:000171', NULL, NULL, 'DEP domain-containing protein 5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(216544, NULL, 'G3DSA:1.10.20.10:FF:000256', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216545, NULL, 'G3DSA:1.10.238.10:FF:000655', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216546, NULL, 'G3DSA:2.60.120.10:FF:000204', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(216547, NULL, 'G3DSA:1.10.269.10:FF:000002', NULL, NULL, 'DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(216548, NULL, 'G3DSA:1.25.10.10:FF:001924', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(216549, NULL, 'G3DSA:3.40.50.2300:FF:001543', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216550, NULL, 'G3DSA:1.10.268.10:FF:000011', NULL, NULL, 'DNA topoisomerase (ATP-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4),
(216551, NULL, 'G3DSA:1.25.10.10:FF:000290', NULL, NULL, 'importin-11 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(216552, NULL, 'G3DSA:2.60.120.970:FF:000067', NULL, NULL, 'Nodal homolog 6', NULL, NULL, NULL, NULL, NULL, 4),
(216553, NULL, 'G3DSA:2.60.40.640:FF:000066', NULL, NULL, 'Vacuolar sorting protein 26, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216554, NULL, 'G3DSA:1.25.40.10:FF:003517', NULL, NULL, 'SART-3/p110 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(216555, NULL, 'G3DSA:3.30.70.260:FF:000062', NULL, NULL, 'Homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(216556, NULL, 'G3DSA:2.60.260.20:FF:000043', NULL, NULL, 'Related to DnaJ homolog subfamily A member 2', NULL, NULL, NULL, NULL, NULL, 4),
(216557, NULL, 'G3DSA:1.20.930.20:FF:000023', NULL, NULL, 'Os11g0669200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(216558, NULL, 'G3DSA:3.40.50.20:FF:000058', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(216559, NULL, 'G3DSA:2.60.40.10:FF:004322', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216560, NULL, 'G3DSA:3.80.10.10:FF:001563', NULL, NULL, 'Protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(216561, NULL, 'G3DSA:1.10.510.10:FF:002817', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216562, NULL, 'G3DSA:3.80.10.10:FF:004289', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(216563, NULL, 'G3DSA:3.40.1190.20:FF:000099', NULL, NULL, 'Pyridoxal kinase putative', NULL, NULL, NULL, NULL, NULL, 4),
(216564, NULL, 'G3DSA:3.30.160.60:FF:004535', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216565, NULL, 'G3DSA:2.60.40.420:FF:000180', NULL, NULL, 'Laccase-15', NULL, NULL, NULL, NULL, NULL, 4),
(216566, NULL, 'G3DSA:1.25.50.20:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216567, NULL, 'G3DSA:1.10.760.10:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216568, NULL, 'G3DSA:3.40.50.1010:FF:000212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216569, NULL, 'G3DSA:3.90.1140.10:FF:000003', NULL, NULL, 'RNA 2'',3''-cyclic phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(216570, NULL, 'G3DSA:3.40.50.150:FF:000495', NULL, NULL, 'Nucleolar RNA methyltransferase (Nop2), putative', NULL, NULL, NULL, NULL, NULL, 4),
(216571, NULL, 'G3DSA:1.20.930.40:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216572, NULL, 'G3DSA:3.30.70.1950:FF:000002', NULL, NULL, 'Adapter protein MecA', NULL, NULL, NULL, NULL, NULL, 4),
(216573, NULL, 'G3DSA:2.130.10.10:FF:005519', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216574, NULL, 'G3DSA:2.60.40.630:FF:000006', NULL, NULL, 'Signal transducer and activator of transcription b', NULL, NULL, NULL, NULL, NULL, 4),
(216575, NULL, 'G3DSA:2.10.70.10:FF:000133', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(216576, NULL, 'G3DSA:2.60.40.60:FF:000161', NULL, NULL, 'FAT atypical cadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(216577, NULL, 'G3DSA:3.30.420.40:FF:000233', NULL, NULL, 'Probable butyrate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(216578, NULL, 'G3DSA:3.30.710.10:FF:000320', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216579, NULL, 'G3DSA:3.40.50.300:FF:006222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216580, NULL, 'G3DSA:3.40.50.300:FF:001490', NULL, NULL, 'DNA replication helicase', NULL, NULL, NULL, NULL, NULL, 4),
(216581, NULL, 'G3DSA:3.30.70.270:FF:000008', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(216582, NULL, 'G3DSA:1.10.287.70:FF:000606', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216583, NULL, 'G3DSA:3.40.720.10:FF:000273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216584, NULL, 'G3DSA:3.40.50.300:FF:006722', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(216585, NULL, 'G3DSA:3.30.70.360:FF:000002', NULL, NULL, 'Peptidase T', NULL, NULL, NULL, NULL, NULL, 4),
(216586, NULL, 'G3DSA:3.10.20.90:FF:000421', NULL, NULL, 'Plexin A', NULL, NULL, NULL, NULL, NULL, 4),
(216587, NULL, 'G3DSA:1.20.1310.20:FF:000037', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(216588, NULL, 'G3DSA:1.10.10.60:FF:000484', NULL, NULL, 'Chromatin modification-related protein EAF1', NULL, NULL, NULL, NULL, NULL, 4),
(216589, NULL, 'G3DSA:3.40.350.10:FF:000076', NULL, NULL, 'Putative aminopeptidase P, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(216590, NULL, 'G3DSA:3.40.50.2300:FF:000262', NULL, NULL, 'Asc operon transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(216591, NULL, 'G3DSA:1.20.5.190:FF:000142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216592, NULL, 'G3DSA:1.20.140.150:FF:000009', NULL, NULL, 'Claudin domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(216593, NULL, 'G3DSA:1.10.860.10:FF:000011', NULL, NULL, 'DnaB-like helicase N terminal domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(216594, NULL, 'G3DSA:1.10.1820.10:FF:000013', NULL, NULL, 'Casein kinase II subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(216595, NULL, 'G3DSA:3.40.980.10:FF:000022', NULL, NULL, 'Molybdenum cofactor biosynthesis protein B', NULL, NULL, NULL, NULL, NULL, 4),
(216596, NULL, 'G3DSA:1.10.640.10:FF:000028', NULL, NULL, 'Dual oxidase 2 variant', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(216597, NULL, 'G3DSA:3.40.190.80:FF:000078', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(216598, NULL, 'G3DSA:3.20.20.20:FF:000012', NULL, NULL, 'Dihydropteroate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(216599, NULL, 'G3DSA:3.40.1090.10:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216600, NULL, 'G3DSA:3.40.50.150:FF:001012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216601, NULL, 'G3DSA:2.30.30.30:FF:000124', NULL, NULL, 'YALI0A20526p', NULL, NULL, NULL, NULL, NULL, 4),
(216602, NULL, 'G3DSA:2.130.10.10:FF:001776', NULL, NULL, 'Ddb1 and cul4-associated factor 11', NULL, NULL, NULL, NULL, NULL, 4),
(216603, NULL, 'G3DSA:2.30.22.10:FF:000010', NULL, NULL, 'Protein GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(216604, NULL, 'G3DSA:1.10.2000.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216605, NULL, 'G3DSA:1.25.10.10:FF:003369', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216606, NULL, 'G3DSA:1.25.40.170:FF:000008', NULL, NULL, 'protein Smaug homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(216607, NULL, 'G3DSA:1.10.510.10:FF:002756', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216608, NULL, 'G3DSA:1.20.58.1780:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216609, NULL, 'G3DSA:3.30.450.20:FF:000050', NULL, NULL, 'PAS domain-containing sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(216610, NULL, 'G3DSA:3.30.565.10:FF:000043', NULL, NULL, 'DNA mismatch repair protein MLH1', NULL, NULL, NULL, NULL, NULL, 4),
(216611, NULL, 'G3DSA:3.30.160.60:FF:002473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216612, NULL, 'G3DSA:2.130.10.10:FF:004238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216613, NULL, 'G3DSA:3.40.140.10:FF:000127', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit F-2', NULL, NULL, NULL, NULL, NULL, 4),
(216614, NULL, 'G3DSA:1.10.1320.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216615, NULL, 'G3DSA:1.10.3470.10:FF:000054', NULL, NULL, 'Iron (III) dicitrate transport system, permease protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216616, NULL, 'G3DSA:1.25.10.10:FF:002088', NULL, NULL, 'Radial spoke head 14 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(216617, NULL, 'G3DSA:3.20.20.370:FF:000036', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(216618, NULL, 'G3DSA:3.20.20.80:FF:000070', NULL, NULL, 'GDB1p Glycogen debranching enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(216619, NULL, 'G3DSA:2.60.40.10:FF:000224', NULL, NULL, 'Leucine rich repeats and immunoglobulin like domains 3', NULL, NULL, NULL, NULL, NULL, 4),
(216620, NULL, 'G3DSA:2.10.25.10:FF:000798', NULL, NULL, 'Crumbs, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(216621, NULL, 'G3DSA:3.40.630.30:FF:000452', NULL, NULL, 'Acyl-homoserine-lactone synthase', NULL, NULL, NULL, NULL, NULL, 4),
(216622, NULL, 'G3DSA:3.40.225.10:FF:000027', NULL, NULL, 'Adducin 3 (gamma) b', NULL, NULL, NULL, NULL, NULL, 4),
(216623, NULL, 'G3DSA:3.30.40.10:FF:001825', NULL, NULL, 'AAL030Cp', NULL, NULL, NULL, NULL, NULL, 4),
(216624, NULL, 'G3DSA:3.30.160.60:FF:004474', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216625, NULL, 'G3DSA:3.40.250.10:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216626, NULL, 'G3DSA:1.10.940.10:FF:000012', NULL, NULL, 'Transcription antitermination protein NusB', NULL, NULL, NULL, NULL, NULL, 4),
(216627, NULL, 'G3DSA:3.80.10.10:FF:002844', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(216628, NULL, 'G3DSA:2.10.25.10:FF:001815', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216629, NULL, 'G3DSA:3.30.160.60:FF:005699', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216630, NULL, 'G3DSA:1.10.630.10:FF:000674', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(216631, NULL, 'G3DSA:1.25.40.150:FF:000002', NULL, NULL, 'V-type proton ATPase subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(216632, NULL, 'G3DSA:1.20.58.900:FF:000012', NULL, NULL, 'RUN domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(216633, NULL, 'G3DSA:1.10.238.10:FF:000594', NULL, NULL, 'Suppressor of LIneage defect', NULL, NULL, NULL, NULL, NULL, 4),
(216634, NULL, 'G3DSA:1.25.10.10:FF:000790', NULL, NULL, 'SNF2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(216635, NULL, 'G3DSA:3.10.50.40:FF:000048', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(216636, NULL, 'G3DSA:3.30.900.10:FF:000003', NULL, NULL, 'Mitotic spindle assembly checkpoint protein MAD2B', NULL, NULL, NULL, NULL, NULL, 4),
(216637, NULL, 'G3DSA:3.30.1640.10:FF:000066', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(216638, NULL, 'G3DSA:3.30.1590.10:FF:000005', NULL, NULL, 'Probable glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(216639, NULL, 'G3DSA:2.60.120.200:FF:000595', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216640, NULL, 'G3DSA:3.40.50.1440:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216641, NULL, 'G3DSA:1.20.1720.10:FF:000054', NULL, NULL, 'Multidrug resistance efflux pump', NULL, NULL, NULL, NULL, NULL, 4),
(216642, NULL, 'G3DSA:2.60.40.3510:FF:000019', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(216643, NULL, 'G3DSA:2.60.40.10:FF:001652', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216644, NULL, 'G3DSA:2.60.40.10:FF:004114', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216645, NULL, 'G3DSA:3.30.740.10:FF:000001', NULL, NULL, 'Dynein light chain', NULL, NULL, NULL, NULL, NULL, 4),
(216646, NULL, 'G3DSA:1.10.287.470:FF:000058', NULL, NULL, 'Efflux transporter, RND family, MFP subunit', NULL, NULL, NULL, NULL, NULL, 4),
(216647, NULL, 'G3DSA:1.20.1530.20:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216648, NULL, 'G3DSA:2.60.40.10:FF:005603', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216649, NULL, 'G3DSA:3.30.160.60:FF:006216', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216650, NULL, 'G3DSA:2.30.30.100:FF:000201', NULL, NULL, 'Sm protein', NULL, NULL, NULL, NULL, NULL, 4),
(216651, NULL, 'G3DSA:1.10.238.10:FF:001111', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(216652, NULL, 'G3DSA:2.60.120.10:FF:000412', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216653, NULL, 'G3DSA:3.30.70.330:FF:000459', NULL, NULL, 'Multiple RNA-binding domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(216654, NULL, 'G3DSA:3.90.70.10:FF:000711', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216655, NULL, 'G3DSA:1.25.40.10:FF:002180', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(216656, NULL, 'G3DSA:3.90.470.10:FF:000034', NULL, NULL, '39S ribosomal protein L22, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(216657, NULL, 'G3DSA:1.10.10.60:FF:000337', NULL, NULL, 'Chitin synthase 8', NULL, NULL, NULL, NULL, NULL, 4),
(216658, NULL, 'G3DSA:3.40.30.10:FF:000110', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(216659, NULL, 'G3DSA:3.90.1150.10:FF:000240', NULL, NULL, 'Putative cystathionine beta-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(216660, NULL, 'G3DSA:3.90.1150.10:FF:000037', NULL, NULL, 'Putative Kynurenine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(216661, NULL, 'G3DSA:3.30.420.40:FF:000733', NULL, NULL, 'Actin7-1 (Actin-related protein)', NULL, NULL, NULL, NULL, NULL, 4),
(216662, NULL, 'G3DSA:3.40.50.1820:FF:001293', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216663, NULL, 'G3DSA:2.30.29.30:FF:000407', NULL, NULL, 'C2 domain-containing protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(216664, NULL, 'G3DSA:3.40.50.300:FF:002827', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(216665, NULL, 'G3DSA:2.130.10.10:FF:003518', NULL, NULL, 'Elongator complex protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(216666, NULL, 'G3DSA:2.10.25.10:FF:000326', NULL, NULL, 'Multiple EGF like domains 6', NULL, NULL, NULL, NULL, NULL, 4),
(216667, NULL, 'G3DSA:1.25.40.10:FF:001808', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(216668, NULL, 'G3DSA:1.25.10.10:FF:000643', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(216669, NULL, 'G3DSA:1.10.287.40:FF:000002', NULL, NULL, 'Serine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(216670, NULL, 'G3DSA:3.60.21.10:FF:000234', NULL, NULL, 'Metallophosphoesterase', NULL, NULL, NULL, NULL, NULL, 4),
(216671, NULL, 'G3DSA:3.90.550.10:FF:000035', NULL, NULL, 'Putative Exostosin-2', NULL, NULL, NULL, NULL, NULL, 4),
(216672, NULL, 'G3DSA:1.10.357.70:FF:000022', NULL, NULL, 'Tumor necrosis factor, alpha-induced protein 2a', NULL, NULL, NULL, NULL, NULL, 4),
(216673, NULL, 'G3DSA:3.20.20.140:FF:000052', NULL, NULL, 'Catalytic/ hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(216674, NULL, 'G3DSA:1.10.238.10:FF:000447', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216675, NULL, 'G3DSA:2.60.40.10:FF:002169', NULL, NULL, 'KETtiN (Drosophila actin-binding) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(216676, NULL, 'G3DSA:3.30.60.30:FF:000146', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216677, NULL, 'G3DSA:1.20.58.60:FF:000054', NULL, NULL, 'Short stop, isoform K', NULL, NULL, NULL, NULL, NULL, 4),
(216678, NULL, 'G3DSA:3.40.50.720:FF:000160', NULL, NULL, '2,3-dihydro-2,3-dihydroxybenzoate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(216679, NULL, 'G3DSA:3.40.50.920:FF:000040', NULL, NULL, '1-deoxy-D-xylulose 5-phosphate synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(216680, NULL, 'G3DSA:3.40.50.80:FF:000233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216681, NULL, 'G3DSA:3.30.830.10:FF:000031', NULL, NULL, 'Putative zinc metalloprotease', NULL, NULL, NULL, NULL, NULL, 4),
(216682, NULL, 'G3DSA:3.30.565.10:FF:000190', NULL, NULL, 'Two-component sensor, ParS', NULL, NULL, NULL, NULL, NULL, 4),
(216683, NULL, 'G3DSA:1.50.40.10:FF:000227', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(216684, NULL, 'G3DSA:3.30.70.330:FF:001948', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216685, NULL, 'G3DSA:1.10.630.10:FF:000202', NULL, NULL, 'Cytochrome P450 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(216686, NULL, 'G3DSA:3.60.15.10:FF:000113', NULL, NULL, 'Hydroxyacylglutathione hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(216687, NULL, 'G3DSA:2.60.40.290:FF:000005', NULL, NULL, 'Beta-N-acetylhexosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(216688, NULL, 'G3DSA:3.30.710.10:FF:000112', NULL, NULL, 'Zinc finger and BTB domain-containing protein 8B', NULL, NULL, NULL, NULL, NULL, 4),
(216689, NULL, 'G3DSA:3.30.479.20:FF:000014', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(216690, NULL, 'G3DSA:2.30.29.30:FF:001127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216691, NULL, 'G3DSA:1.10.10.10:FF:000671', NULL, NULL, 'Bifunctional ligase/repressor BirA', NULL, NULL, NULL, NULL, NULL, 4),
(216692, NULL, 'G3DSA:3.40.50.1400:FF:000003', NULL, NULL, 'Ferrochelatase', NULL, NULL, NULL, NULL, NULL, 4),
(216693, NULL, 'G3DSA:1.10.472.10:FF:000093', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(216694, NULL, 'G3DSA:3.50.50.60:FF:000322', NULL, NULL, 'Protein CBG01975', NULL, NULL, NULL, NULL, NULL, 4),
(216695, NULL, 'G3DSA:2.130.10.10:FF:005727', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216696, NULL, 'G3DSA:3.40.1160.10:FF:000061', NULL, NULL, 'Molybdenum storage protein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(216697, NULL, 'G3DSA:3.40.50.12760:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(216698, NULL, 'G3DSA:3.10.20.90:FF:000685', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216699, NULL, 'G3DSA:3.90.70.10:FF:000150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216700, NULL, 'G3DSA:3.90.640.10:FF:000126', NULL, NULL, 'Heat shock protein 70, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216701, NULL, 'G3DSA:2.60.40.10:FF:003097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216702, NULL, 'G3DSA:3.30.160.60:FF:003046', NULL, NULL, 'Zinc finger protein 715', NULL, NULL, NULL, NULL, NULL, 4),
(216703, NULL, 'G3DSA:3.50.7.10:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216704, NULL, 'G3DSA:3.80.10.10:FF:000899', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(216705, NULL, 'G3DSA:2.60.40.150:FF:000576', NULL, NULL, 'Regulating synaptic membrane exocytosis protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(216706, NULL, 'G3DSA:1.25.10.10:FF:001571', NULL, NULL, 'Protein VAC14-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(216707, NULL, 'G3DSA:3.10.10.10:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216708, NULL, 'G3DSA:2.20.28.290:FF:000004', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(216709, NULL, 'G3DSA:2.60.40.1470:FF:000003', NULL, NULL, 'F-box protein SKIP16', NULL, NULL, NULL, NULL, NULL, 4),
(216710, NULL, 'G3DSA:1.20.1250.20:FF:001116', NULL, NULL, 'Related to Polyamine transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(216711, NULL, 'G3DSA:2.20.70.10:FF:000228', NULL, NULL, 'Pre-mRNA-processing protein 40A', NULL, NULL, NULL, NULL, NULL, 4),
(216712, NULL, 'G3DSA:3.30.2350.20:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216713, NULL, 'G3DSA:1.10.357.50:FF:000011', NULL, NULL, 'YOR296Wp-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(216714, NULL, 'G3DSA:3.30.70.330:FF:000723', NULL, NULL, 'Chromosome 16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(216715, NULL, 'G3DSA:2.170.8.10:FF:000010', NULL, NULL, 'Phosphoenolypyruvate CarboxyKinase', NULL, NULL, NULL, NULL, NULL, 4),
(216716, NULL, 'G3DSA:3.10.450.80:FF:000004', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(216717, NULL, 'G3DSA:1.10.1450.10:FF:000024', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(216718, NULL, 'G3DSA:3.40.50.12430:FF:000006', NULL, NULL, 'folliculin-like', NULL, NULL, NULL, NULL, NULL, 4),
(216719, NULL, 'G3DSA:1.25.10.10:FF:003105', NULL, NULL, 'Os07g0693400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(216720, NULL, 'G3DSA:2.130.10.10:FF:000348', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1', NULL, NULL, NULL, NULL, NULL, 4),
(216721, NULL, 'G3DSA:3.20.20.70:FF:000797', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216722, NULL, 'G3DSA:3.10.105.10:FF:000064', NULL, NULL, 'Oligopeptide ABC transporter, periplasmic oligopeptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(216723, NULL, 'G3DSA:2.40.290.30:FF:000007', NULL, NULL, 'Putative transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(216724, NULL, 'G3DSA:1.10.3430.10:FF:000080', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(216725, NULL, 'G3DSA:3.30.160.60:FF:002118', NULL, NULL, 'Zinc finger protein 382', NULL, NULL, NULL, NULL, NULL, 4),
(216726, NULL, 'G3DSA:3.80.10.10:FF:001299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216727, NULL, 'G3DSA:1.10.10.440:FF:000026', NULL, NULL, 'Pre-mRNA-processing protein 40A', NULL, NULL, NULL, NULL, NULL, 4),
(216728, NULL, 'G3DSA:2.30.30.140:FF:000218', NULL, NULL, 'Enhanced RNAI (RNA interference)', NULL, NULL, NULL, NULL, NULL, 4),
(216729, NULL, 'G3DSA:1.20.1560.10:FF:000608', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216730, NULL, 'G3DSA:1.10.4200.10:FF:000006', NULL, NULL, 'Probable 2-(5''''-triphosphoribosyl)-3''-dephosphocoenzyme-A synthase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(216731, NULL, 'G3DSA:3.40.50.1970:FF:000062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216732, NULL, 'G3DSA:1.25.40.10:FF:001960', NULL, NULL, 'Tetratricopeptide repeat domain 21A', NULL, NULL, NULL, NULL, NULL, 4),
(216733, NULL, 'G3DSA:3.30.70.3490:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216734, NULL, 'G3DSA:3.60.15.10:FF:000260', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(216735, NULL, 'G3DSA:1.10.510.10:FF:003161', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216736, NULL, 'G3DSA:3.30.200.20:FF:001880', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(216737, NULL, 'G3DSA:2.60.40.10:FF:005867', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216738, NULL, 'G3DSA:3.30.1540.10:FF:000002', NULL, NULL, 'Formyl-CoA:oxalate CoA-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(216739, NULL, 'G3DSA:3.40.50.300:FF:003232', NULL, NULL, 'Structural maintenance of chromosomes 6, gene 1', NULL, NULL, NULL, NULL, NULL, 4),
(216740, NULL, 'G3DSA:1.10.565.10:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216741, NULL, 'G3DSA:2.40.50.140:FF:000473', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(216742, NULL, 'G3DSA:3.40.50.200:FF:000178', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(216743, NULL, 'G3DSA:1.20.1070.10:FF:000644', NULL, NULL, 'Olfactory receptor 716', NULL, NULL, NULL, NULL, NULL, 4),
(216744, NULL, 'G3DSA:3.30.1010.10:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216745, NULL, 'G3DSA:3.60.10.10:FF:000153', NULL, NULL, 'Type II inositol-1,4,5-trisphosphate 5-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(216746, NULL, 'G3DSA:3.40.50.10490:FF:000082', NULL, NULL, 'Glucose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(216747, NULL, 'G3DSA:3.40.50.1820:FF:001146', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(216748, NULL, 'G3DSA:3.40.50.740:FF:000019', NULL, NULL, 'Formate dehydrogenase subunit alpha FdhF', NULL, NULL, NULL, NULL, NULL, 4),
(216749, NULL, 'G3DSA:3.60.110.10:FF:000048', NULL, NULL, 'Glutamine-dependent NAD(+) synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(216750, NULL, 'G3DSA:2.20.28.10:FF:000046', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(216751, NULL, 'G3DSA:2.40.10.230:FF:000008', NULL, NULL, 'H/ACA ribonucleoprotein complex non-core subunit NAF1', NULL, NULL, NULL, NULL, NULL, 4),
(216752, NULL, 'G3DSA:2.60.40.10:FF:000932', NULL, NULL, 'Immunoglobulin superfamily member 3', NULL, NULL, NULL, NULL, NULL, 4),
(216753, NULL, 'G3DSA:1.25.40.10:FF:002028', NULL, NULL, 'Kinetoplast polyadenylation/uridylation factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(216754, NULL, 'G3DSA:3.60.21.10:FF:000381', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216755, NULL, 'G3DSA:3.30.70.2760:FF:000003', NULL, NULL, 'HD superfamily phosphohydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(216756, NULL, 'G3DSA:2.130.10.10:FF:002181', NULL, NULL, 'WD repeat-containing protein JIP5', NULL, NULL, NULL, NULL, NULL, 4),
(216757, NULL, 'G3DSA:2.130.10.10:FF:000495', NULL, NULL, 'Transcriptional corepressor LEUNIG', NULL, NULL, NULL, NULL, NULL, 4),
(216758, NULL, 'G3DSA:3.40.50.1580:FF:000068', NULL, NULL, 'Purine nucleoside phosphorylase 6', NULL, NULL, NULL, NULL, NULL, 4),
(216759, NULL, 'G3DSA:3.30.519.10:FF:000004', NULL, NULL, 'Rab proteins geranylgeranyltransferase component A', NULL, NULL, NULL, NULL, NULL, 4),
(216760, NULL, 'G3DSA:3.10.110.10:FF:000306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216761, NULL, 'G3DSA:2.40.100.10:FF:000039', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(216762, NULL, 'G3DSA:2.70.98.10:FF:000031', NULL, NULL, 'Putative sugar hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(216763, NULL, 'G3DSA:3.40.50.2000:FF:000054', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(216764, NULL, 'G3DSA:1.10.1370.10:FF:000023', NULL, NULL, 'Mitochondrial intermediate peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(216765, NULL, 'G3DSA:3.40.50.300:FF:000770', NULL, NULL, 'Caspase recruitment domain family, member 11', NULL, NULL, NULL, NULL, NULL, 4),
(216766, NULL, 'G3DSA:3.40.50.880:FF:000067', NULL, NULL, '4-methyl-5(B-hydroxyethyl)-thiazol monophosphate biosynthesis enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(216767, NULL, 'G3DSA:3.30.160.60:FF:003754', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216768, NULL, 'G3DSA:3.10.450.10:FF:000091', NULL, NULL, 'Alpha-2-HS-glycoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(216769, NULL, 'G3DSA:3.40.50.300:FF:005441', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216770, NULL, 'G3DSA:3.40.50.150:FF:001837', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216771, NULL, 'G3DSA:1.20.1110.10:FF:000171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216772, NULL, 'G3DSA:1.10.287.4290:FF:000002', NULL, NULL, 'Peroxisomal multifunctional enzyme type 2', NULL, NULL, NULL, NULL, NULL, 4),
(216773, NULL, 'G3DSA:1.10.10.570:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216774, NULL, 'G3DSA:3.20.70.20:FF:000015', NULL, NULL, 'Vitamin B12-dependent ribonucleotide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(216775, NULL, 'G3DSA:3.40.50.1000:FF:000063', NULL, NULL, 'Nuclear elongation and deformation protein', NULL, NULL, NULL, NULL, NULL, 4),
(216776, NULL, 'G3DSA:3.30.300.160:FF:000006', NULL, NULL, 'General secretion pathway protein E', NULL, NULL, NULL, NULL, NULL, 4),
(216777, NULL, 'G3DSA:2.60.120.10:FF:000676', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216778, NULL, 'G3DSA:1.10.510.10:FF:001328', NULL, NULL, 'NEK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(216779, NULL, 'G3DSA:3.40.190.10:FF:000277', NULL, NULL, 'glutamate receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(216780, NULL, 'G3DSA:3.40.50.300:FF:008167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216781, NULL, 'G3DSA:2.30.110.10:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216782, NULL, 'G3DSA:3.40.50.2000:FF:000762', NULL, NULL, 'UDP-N-acetylglucosamine transferase subunit ALG14', NULL, NULL, NULL, NULL, NULL, 4),
(216783, NULL, 'G3DSA:2.40.10.10:FF:000061', NULL, NULL, 'Hepatocyte growth factor activator', NULL, NULL, NULL, NULL, NULL, 4),
(216784, NULL, 'G3DSA:3.50.50.60:FF:001250', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(216785, NULL, 'G3DSA:2.60.40.10:FF:002580', NULL, NULL, 'Gamete expressed 2', NULL, NULL, NULL, NULL, NULL, 4),
(216786, NULL, 'G3DSA:2.70.98.30:FF:000037', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(216787, NULL, 'G3DSA:2.130.10.10:FF:004390', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216788, NULL, 'G3DSA:3.30.200.20:FF:000503', NULL, NULL, 'Putative prolin-rich extensin-like receptor protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(216789, NULL, 'G3DSA:3.40.50.620:FF:000540', NULL, NULL, 'Glutamyl-Q tRNA(Asp) synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(216790, NULL, 'G3DSA:1.10.730.10:FF:000119', NULL, NULL, 'Valyl tRNA synthetase putative', NULL, NULL, NULL, NULL, NULL, 4),
(216791, NULL, 'G3DSA:3.30.1330.50:FF:000009', NULL, NULL, '2-C-methyl-D-erythritol 2,4-cyclodiphosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(216792, NULL, 'G3DSA:3.40.850.10:FF:000277', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216793, NULL, 'G3DSA:3.90.1410.10:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216794, NULL, 'G3DSA:3.40.50.1000:FF:000771', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216795, NULL, 'G3DSA:1.20.58.80:FF:000065', NULL, NULL, 'serine/threonine-protein kinase ULK3', NULL, NULL, NULL, NULL, NULL, 4),
(216796, NULL, 'G3DSA:1.20.1510.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(216797, NULL, 'G3DSA:3.40.50.11350:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216798, NULL, 'G3DSA:2.160.20.10:FF:000078', NULL, NULL, 'Coagulation factor 5/8 type domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(216799, NULL, 'G3DSA:3.30.450.20:FF:000611', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216800, NULL, 'G3DSA:3.30.160.60:FF:005963', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216801, NULL, 'G3DSA:1.10.220.10:FF:000036', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(216802, NULL, 'G3DSA:1.50.10.130:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216803, NULL, 'G3DSA:2.10.25.10:FF:001254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216804, NULL, 'G3DSA:3.30.1330.40:FF:000063', NULL, NULL, 'Chromosome 15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(216805, NULL, 'G3DSA:2.30.30.790:FF:000003', NULL, NULL, '50S ribosomal protein L19, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(216806, NULL, 'G3DSA:3.40.640.10:FF:000531', NULL, NULL, 'Serine--pyruvate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(216807, NULL, 'G3DSA:1.25.40.10:FF:002736', NULL, NULL, 'U5 snRNP-associated 102 kDa protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216808, NULL, 'G3DSA:3.30.420.10:FF:000573', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216809, NULL, 'G3DSA:2.60.40.10:FF:000371', NULL, NULL, 'Kirre like nephrin family adhesion molecule 3', NULL, NULL, NULL, NULL, NULL, 4),
(216810, NULL, 'G3DSA:3.40.50.12350:FF:000016', NULL, NULL, 'Eyes absent homolog', NULL, NULL, NULL, NULL, NULL, 4),
(216811, NULL, 'G3DSA:3.40.50.300:FF:007650', NULL, NULL, 'Helicase', NULL, NULL, NULL, NULL, NULL, 4),
(216812, NULL, 'G3DSA:3.30.160.60:FF:006391', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216813, NULL, 'G3DSA:4.10.280.10:FF:000129', NULL, NULL, 'HLH DNA binding protein (Penr2), putative', NULL, NULL, NULL, NULL, NULL, 4),
(216814, NULL, 'G3DSA:1.20.1170.10:FF:000005', NULL, NULL, 'Nematocidal crystal protein 6A', NULL, NULL, NULL, NULL, NULL, 4),
(216815, NULL, 'G3DSA:3.30.70.1230:FF:000112', NULL, NULL, 'Putative adenylate cyclase 3', NULL, NULL, NULL, NULL, NULL, 4),
(216816, NULL, 'G3DSA:1.10.287.110:FF:000383', NULL, NULL, 'Putative chaperone protein DNAj', NULL, NULL, NULL, NULL, NULL, 4),
(216817, NULL, 'G3DSA:2.60.40.10:FF:002141', NULL, NULL, 'Beta-mannosidase A', NULL, NULL, NULL, NULL, NULL, 4),
(216818, NULL, 'G3DSA:2.130.10.30:FF:000034', NULL, NULL, 'HECT and RLD domain containing E3 ubiquitin protein ligase 4', NULL, NULL, NULL, NULL, NULL, 4),
(216819, NULL, 'G3DSA:3.90.1170.40:FF:000019', NULL, NULL, 'Uncharacterized protein MJ0717', NULL, NULL, NULL, NULL, NULL, 4),
(216820, NULL, 'G3DSA:3.40.50.300:FF:004660', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(216821, NULL, 'G3DSA:3.30.70.270:FF:000211', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216822, NULL, 'G3DSA:3.90.1170.20:FF:000013', NULL, NULL, 'Quinolinate phosphoribosyltransferase [decarboxylating]', NULL, NULL, NULL, NULL, NULL, 4),
(216823, NULL, 'G3DSA:1.10.8.60:FF:000117', NULL, NULL, 'Sigma-54-dependent phenylalanine hydroxylase transcriptional regulator PhhR', NULL, NULL, NULL, NULL, NULL, 4),
(216824, NULL, 'G3DSA:3.40.350.10:FF:000020', NULL, NULL, 'Probable aminopeptidase P, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(216825, NULL, 'G3DSA:1.20.120.560:FF:000010', NULL, NULL, 'Rim20p', NULL, NULL, NULL, NULL, NULL, 4),
(216826, NULL, 'G3DSA:1.20.1250.20:FF:001639', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216827, NULL, 'G3DSA:3.40.50.1820:FF:000365', NULL, NULL, 'Prolyl oligopeptidase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(216828, NULL, 'G3DSA:3.30.70.1230:FF:000056', NULL, NULL, 'Putative adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(216829, NULL, 'G3DSA:2.60.40.10:FF:002085', NULL, NULL, 'Iduronidase, alpha-L-', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(216830, NULL, 'G3DSA:3.30.1640.10:FF:000089', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(216831, NULL, 'G3DSA:1.20.1730.10:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216832, NULL, 'G3DSA:1.25.40.180:FF:000129', NULL, NULL, 'Putative eukaryotic initiation factor 4a', NULL, NULL, NULL, NULL, NULL, 4),
(216833, NULL, 'G3DSA:2.30.29.30:FF:000290', NULL, NULL, 'SH2 domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(216834, NULL, 'G3DSA:3.40.50.10490:FF:000110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216835, NULL, 'G3DSA:1.20.1070.10:FF:001425', NULL, NULL, '5-hydroxytryptamine receptor 1D', NULL, NULL, NULL, NULL, NULL, 4),
(216836, NULL, 'G3DSA:3.10.450.40:FF:000015', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(216837, NULL, 'G3DSA:1.20.1270.10:FF:000064', NULL, NULL, 'CBN-HSP-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(216838, NULL, 'G3DSA:3.30.230.70:FF:000149', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216839, NULL, 'G3DSA:1.25.10.10:FF:000851', NULL, NULL, 'Exportin 1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(216840, NULL, 'G3DSA:1.10.472.170:FF:000014', NULL, NULL, 'Transcription initiation factor IIB 1', NULL, NULL, NULL, NULL, NULL, 4),
(216841, NULL, 'G3DSA:1.20.1250.40:FF:000021', NULL, NULL, 'DNA-directed RNA polymerase III subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216842, NULL, 'G3DSA:1.10.510.10:FF:003189', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216843, NULL, 'G3DSA:2.60.200.20:FF:000011', NULL, NULL, 'Serine/threonine-protein kinase Chk2', NULL, NULL, NULL, NULL, NULL, 4),
(216844, NULL, 'G3DSA:1.10.510.10:FF:003245', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216845, NULL, 'G3DSA:1.20.1070.10:FF:001369', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(216846, NULL, 'G3DSA:1.25.10.10:FF:000374', NULL, NULL, 'Protein wings apart-like', NULL, NULL, NULL, NULL, NULL, 4),
(216847, NULL, 'G3DSA:1.20.120.850:FF:000029', NULL, NULL, 'RAD54B DNA helicase splice variant', NULL, NULL, NULL, NULL, NULL, 4),
(216848, NULL, 'G3DSA:1.10.3020.10:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216849, NULL, 'G3DSA:2.40.30.10:FF:000528', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216850, NULL, 'G3DSA:3.10.20.90:FF:000185', NULL, NULL, 'UBX domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(216851, NULL, 'G3DSA:2.60.40.150:FF:000604', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(216852, NULL, 'G3DSA:1.20.1280.50:FF:000054', NULL, NULL, 'Coronatine-insensitive protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(216853, NULL, 'G3DSA:3.80.20.20:FF:000026', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(216854, NULL, 'G3DSA:1.25.40.20:FF:001401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216855, NULL, 'G3DSA:1.20.1070.10:FF:000436', NULL, NULL, 'Olfactory receptor OR6-8', NULL, NULL, NULL, NULL, NULL, 4),
(216856, NULL, 'G3DSA:3.90.1600.10:FF:000022', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(216857, NULL, 'G3DSA:1.20.5.110:FF:000337', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(216858, NULL, 'G3DSA:3.40.50.300:FF:008403', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(216859, NULL, 'G3DSA:3.20.20.60:FF:000029', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(216860, NULL, 'G3DSA:3.40.50.790:FF:000012', NULL, NULL, 'Ribosomal protein L1p/L10e family', NULL, NULL, NULL, NULL, NULL, 4),
(216861, NULL, 'G3DSA:3.30.70.330:FF:003096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216862, NULL, 'G3DSA:3.40.190.10:FF:000338', NULL, NULL, 'Iron(III) ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(216863, NULL, 'G3DSA:2.120.10.80:FF:000201', NULL, NULL, 'F-box only protein 13', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(216864, NULL, 'G3DSA:3.40.50.261:FF:000006', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(216865, NULL, 'G3DSA:3.30.160.60:FF:000117', NULL, NULL, 'Zinc finger E-box-binding homeobox 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(216866, NULL, 'G3DSA:3.30.40.10:FF:001297', NULL, NULL, 'RING/U-box superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(216867, NULL, 'G3DSA:3.40.50.1820:FF:001354', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216868, NULL, 'G3DSA:1.25.40.10:FF:001983', NULL, NULL, 'TPR domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(216869, NULL, 'G3DSA:1.20.120.1750:FF:000161', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(216870, NULL, 'G3DSA:1.25.40.10:FF:001488', NULL, NULL, 'pentatricopeptide repeat-containing protein At2g13600-like', NULL, NULL, NULL, NULL, NULL, 4),
(216871, NULL, 'G3DSA:1.10.357.140:FF:000032', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(216872, NULL, 'G3DSA:1.20.1250.10:FF:000006', NULL, NULL, 'Interleukin-6', NULL, NULL, NULL, NULL, NULL, 4),
(216873, NULL, 'G3DSA:3.60.21.10:FF:000465', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216874, NULL, 'G3DSA:3.80.10.10:FF:002288', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(216875, NULL, 'G3DSA:1.20.120.1110:FF:000002', NULL, NULL, 'Transcription initiation factor TFIID subunit 4B', NULL, NULL, NULL, NULL, NULL, 4),
(216876, NULL, 'G3DSA:2.130.10.10:FF:002265', NULL, NULL, 'Lethal giant larvae like, C-terminal-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(216877, NULL, 'G3DSA:1.10.486.10:FF:000040', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(216878, NULL, 'G3DSA:2.40.50.40:FF:000111', NULL, NULL, 'Interleukin-8', NULL, NULL, NULL, NULL, NULL, 4),
(216879, NULL, 'G3DSA:3.30.70.330:FF:002640', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216880, NULL, 'G3DSA:3.40.1500.10:FF:000014', NULL, NULL, 'Coproporphyrinogen III oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(216881, NULL, 'G3DSA:1.25.40.20:FF:001345', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216882, NULL, 'G3DSA:2.60.120.920:FF:000069', NULL, NULL, 'Ryanodine receptor 44F', NULL, NULL, NULL, NULL, NULL, 4),
(216883, NULL, 'G3DSA:1.10.510.10:FF:002733', NULL, NULL, 'Probable inactive serine/threonine-protein kinase DDB_G0274613', NULL, NULL, NULL, NULL, NULL, 4),
(216884, NULL, 'G3DSA:2.60.120.1440:FF:000005', NULL, NULL, 'Sigma factor regulatory protein, FecR/PupR family', NULL, NULL, NULL, NULL, NULL, 4),
(216885, NULL, 'G3DSA:1.20.910.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216886, NULL, 'G3DSA:1.10.275.40:FF:000019', NULL, NULL, 'DNA helicase RepD', NULL, NULL, NULL, NULL, NULL, 4),
(216887, NULL, 'G3DSA:3.30.2350.20:FF:000030', NULL, NULL, 'tRNA pseudouridine synthase D', NULL, NULL, NULL, NULL, NULL, 4),
(216888, NULL, 'G3DSA:3.30.420.40:FF:000469', NULL, NULL, 'Putative nodulation protein nolNO', NULL, NULL, NULL, NULL, NULL, 4),
(216889, NULL, 'G3DSA:3.40.1090.10:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216890, NULL, 'G3DSA:2.40.50.140:FF:001193', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216891, NULL, 'G3DSA:3.40.50.1820:FF:000893', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216892, NULL, 'G3DSA:2.60.120.330:FF:000111', NULL, NULL, 'Steroid 16alpha-hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(216893, NULL, 'G3DSA:2.40.30.10:FF:000152', NULL, NULL, 'Probable translation initiation factor IF-2', NULL, NULL, NULL, NULL, NULL, 4),
(216894, NULL, 'G3DSA:3.20.20.220:FF:000042', NULL, NULL, 'Methylenetetrahydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(216895, NULL, 'G3DSA:3.40.50.1820:FF:001410', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(216896, NULL, 'G3DSA:1.10.540.10:FF:000144', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(216897, NULL, 'G3DSA:1.10.10.520:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216898, NULL, 'G3DSA:2.130.10.10:FF:004210', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(216899, NULL, 'G3DSA:1.20.930.40:FF:000006', NULL, NULL, 'Glutamate carboxypeptidase Tre2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216900, NULL, 'G3DSA:3.40.50.300:FF:006953', NULL, NULL, 'DNA mismatch repair MutS protein', NULL, NULL, NULL, NULL, NULL, 4),
(216901, NULL, 'G3DSA:1.20.1250.20:FF:001263', NULL, NULL, 'Putative integral membrane transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(216902, NULL, 'G3DSA:3.40.430.10:FF:000054', NULL, NULL, 'Uncharacterized hydrolase C22A12.06c', NULL, NULL, NULL, NULL, NULL, 4),
(216903, NULL, 'G3DSA:3.40.50.300:FF:003608', NULL, NULL, 'Cell division protein ZapE', NULL, NULL, NULL, NULL, NULL, 4),
(216904, NULL, 'G3DSA:1.20.5.100:FF:000008', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(216905, NULL, 'G3DSA:3.30.1360.210:FF:000015', NULL, NULL, 'Ribosomal protein L22-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(216906, NULL, 'G3DSA:1.25.40.10:FF:003433', NULL, NULL, 'Os01g0357800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(216907, NULL, 'G3DSA:2.10.109.10:FF:000043', NULL, NULL, 'Mitochondrial inner membrane protease subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(216908, NULL, 'G3DSA:1.20.120.230:FF:000018', NULL, NULL, 'Mesoderm development candidate 1', NULL, NULL, NULL, NULL, NULL, 4),
(216909, NULL, 'G3DSA:1.20.58.1220:FF:000016', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(216910, NULL, 'G3DSA:3.80.10.10:FF:000051', NULL, NULL, 'F-box and leucine-rich repeat protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(216911, NULL, 'G3DSA:2.40.70.10:FF:000098', NULL, NULL, 'Chloroplast nucleoid DNA-binding protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(216912, NULL, 'G3DSA:1.20.120.350:FF:000065', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(216913, NULL, 'G3DSA:2.60.120.650:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216914, NULL, 'G3DSA:3.40.50.300:FF:001787', NULL, NULL, 'Putative DEAD/DEAH box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(216915, NULL, 'G3DSA:1.20.5.170:FF:000248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216916, NULL, 'G3DSA:1.10.620.20:FF:000002', NULL, NULL, 'Stearoyl-[acyl-carrier-protein] 9-desaturase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(216917, NULL, 'G3DSA:1.10.10.10:FF:001683', NULL, NULL, 'Heat shock factor (HSF)-type DNA-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(216918, NULL, 'G3DSA:3.20.20.70:FF:000358', NULL, NULL, 'Enoyl-(Acyl-carrier-protein) reductase II', NULL, NULL, NULL, NULL, NULL, 4),
(216919, NULL, 'G3DSA:2.40.160.120:FF:000027', NULL, NULL, 'Oxysterol-binding protein/PH domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(216920, NULL, 'G3DSA:2.10.25.10:FF:001462', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(216921, NULL, 'G3DSA:2.60.40.1510:FF:000004', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(216922, NULL, 'G3DSA:2.60.40.10:FF:004822', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216923, NULL, 'G3DSA:3.30.160.60:FF:003838', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216924, NULL, 'G3DSA:3.30.160.60:FF:001601', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(216925, NULL, 'G3DSA:1.10.10.1340:FF:000004', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 31', NULL, NULL, NULL, NULL, NULL, 4),
(216926, NULL, 'G3DSA:2.60.11.10:FF:000011', NULL, NULL, 'Cytochrome c oxidase subunit 5B, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(216927, NULL, 'G3DSA:3.40.50.300:FF:001315', NULL, NULL, 'SNF2 family helicase/ATPase PasG', NULL, NULL, NULL, NULL, NULL, 4),
(216928, NULL, 'G3DSA:3.10.20.90:FF:000505', NULL, NULL, 'SEP domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(216929, NULL, 'G3DSA:2.40.50.90:FF:000132', NULL, NULL, 'Ring finger protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(216930, NULL, 'G3DSA:3.80.10.10:FF:000427', NULL, NULL, 'Osteomodulin', NULL, NULL, NULL, NULL, NULL, 4),
(216931, NULL, 'G3DSA:2.60.40.10:FF:003389', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216932, NULL, 'G3DSA:2.30.42.10:FF:000157', NULL, NULL, 'General receptor for phosphoinositides 1-associated scaffold protein', NULL, NULL, NULL, NULL, NULL, 4),
(216933, NULL, 'G3DSA:2.60.40.150:FF:000284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216934, NULL, 'G3DSA:2.30.30.170:FF:000002', NULL, NULL, 'Bifunctional autolysin', NULL, NULL, NULL, NULL, NULL, 4),
(216935, NULL, 'G3DSA:1.20.1510.10:FF:000100', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216936, NULL, 'G3DSA:2.60.40.10:FF:001949', NULL, NULL, 'Hemicentin 2', NULL, NULL, NULL, NULL, NULL, 4),
(216937, NULL, 'G3DSA:3.40.50.1000:FF:000294', NULL, NULL, 'CRE-FCP-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(216938, NULL, 'G3DSA:1.10.1520.10:FF:000024', NULL, NULL, 'Dicer-2', NULL, NULL, NULL, NULL, NULL, 4),
(216939, NULL, 'G3DSA:2.60.40.150:FF:000340', NULL, NULL, 'Extended SYnapTotagmin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(216940, NULL, 'G3DSA:1.25.40.10:FF:005350', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g64320, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(216941, NULL, 'G3DSA:2.60.40.10:FF:002877', NULL, NULL, 'GM25453', NULL, NULL, NULL, NULL, NULL, 4),
(216942, NULL, 'G3DSA:3.40.630.30:FF:000536', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(216943, NULL, 'G3DSA:3.90.1800.10:FF:000003', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(216944, NULL, 'G3DSA:1.25.40.280:FF:000013', NULL, NULL, 'Endosomal targeting BRO1-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(216945, NULL, 'G3DSA:3.30.160.60:FF:002534', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(216946, NULL, 'G3DSA:3.40.50.720:FF:001233', NULL, NULL, 'SUMO1 activating enzyme subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(216947, NULL, 'G3DSA:1.20.58.670:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216948, NULL, 'G3DSA:3.30.470.20:FF:000197', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(216949, NULL, 'G3DSA:1.20.140.80:FF:000014', NULL, NULL, 'Transcription factor, E2F and DP-related', NULL, NULL, NULL, NULL, NULL, 4),
(216950, NULL, 'G3DSA:2.30.29.30:FF:000610', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216951, NULL, 'G3DSA:3.80.10.10:FF:001355', NULL, NULL, 'Tubulin folding COfactor E-Like protein', NULL, NULL, NULL, NULL, NULL, 4),
(216952, NULL, 'G3DSA:2.60.40.10:FF:002933', NULL, NULL, 'Deleted in lung and esophageal cancer protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(216953, NULL, 'G3DSA:3.40.50.300:FF:006458', NULL, NULL, 'Protein CBR-RAB-35', NULL, NULL, NULL, NULL, NULL, 4),
(216954, NULL, 'G3DSA:3.40.525.10:FF:000016', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(216955, NULL, 'G3DSA:3.30.70.870:FF:000008', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(216956, NULL, 'G3DSA:1.10.510.10:FF:000755', NULL, NULL, 'Homoserine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(216957, NULL, 'G3DSA:2.60.40.60:FF:000222', NULL, NULL, 'neural-cadherin isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(216958, NULL, 'G3DSA:1.20.58.340:FF:000029', NULL, NULL, 'Magnesium transport protein CorA', NULL, NULL, NULL, NULL, NULL, 4),
(216959, NULL, 'G3DSA:3.30.360.10:FF:000039', NULL, NULL, 'Glucose-6-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(216960, NULL, 'G3DSA:3.40.50.10880:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216961, NULL, 'G3DSA:2.40.110.10:FF:000068', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(216962, NULL, 'G3DSA:3.30.470.20:FF:000141', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(216963, NULL, 'G3DSA:3.30.40.10:FF:001617', NULL, NULL, 'Probable E3 ubiquitin-protein ligase ARI12', NULL, NULL, NULL, NULL, NULL, 4),
(216964, NULL, 'G3DSA:3.20.20.70:FF:000302', NULL, NULL, 'Imidazole glycerol phosphate synthase hisHF', NULL, NULL, NULL, NULL, NULL, 4),
(216965, NULL, 'G3DSA:1.20.1440.180:FF:000015', NULL, NULL, 'Protein CBG25496', NULL, NULL, NULL, NULL, NULL, 4),
(216966, NULL, 'G3DSA:3.10.450.350:FF:000016', NULL, NULL, 'Peptidoglycan-specific endopeptidase, M23 family', NULL, NULL, NULL, NULL, NULL, 4),
(216967, NULL, 'G3DSA:2.60.120.650:FF:000089', NULL, NULL, 'Lysine-specific demethylase 4', NULL, NULL, NULL, NULL, NULL, 4),
(216968, NULL, 'G3DSA:3.30.70.330:FF:001179', NULL, NULL, 'RNA_recognition_motif._(A.k.a._RRM_-_RBD_-_or_RNP_domain)/RNA_recognition_motif_(A.k.a._RRM_-_RBD_-_or_RNP_domain)_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(216969, NULL, 'G3DSA:2.40.70.10:FF:000154', NULL, NULL, 'Aspartic proteinase nepenthesin-2', NULL, NULL, NULL, NULL, NULL, 4),
(216970, NULL, 'G3DSA:3.40.718.10:FF:000032', NULL, NULL, 'GM20069', NULL, NULL, NULL, NULL, NULL, 4),
(216971, NULL, 'G3DSA:3.30.200.20:FF:001464', NULL, NULL, 'U-box domain-containing protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(216972, NULL, 'G3DSA:2.30.42.10:FF:000101', NULL, NULL, 'LIM domain kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(216973, NULL, 'G3DSA:2.30.30.190:FF:000008', NULL, NULL, 'Tubulin-specific chaperone E', NULL, NULL, NULL, NULL, NULL, 4),
(216974, NULL, 'G3DSA:1.20.58.60:FF:000610', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(216975, NULL, 'G3DSA:4.10.910.10:FF:000009', NULL, NULL, 'Mitochondrial ribosomal protein S13', NULL, NULL, NULL, NULL, NULL, 4),
(216976, NULL, 'G3DSA:1.20.1560.10:FF:000311', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(216977, NULL, 'G3DSA:3.40.250.10:FF:000012', NULL, NULL, 'Centrosomal protein of 41 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(216978, NULL, 'G3DSA:3.30.70.1350:FF:000002', NULL, NULL, 'Ferrous-iron efflux pump FieF', NULL, NULL, NULL, NULL, NULL, 4),
(216979, NULL, 'G3DSA:3.30.710.10:FF:000376', NULL, NULL, 'SCF ubiquitin ligase complex protein SKP1b', NULL, NULL, NULL, NULL, NULL, 4),
(216980, NULL, 'G3DSA:3.30.70.340:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216981, NULL, 'G3DSA:3.30.160.60:FF:003462', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216982, NULL, 'G3DSA:2.40.50.120:FF:000023', NULL, NULL, 'Complement C5', NULL, NULL, NULL, NULL, NULL, 4),
(216983, NULL, 'G3DSA:3.40.630.10:FF:000002', NULL, NULL, 'Peptidase T', NULL, NULL, NULL, NULL, NULL, 4),
(216984, NULL, 'G3DSA:1.10.1600.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216985, NULL, 'G3DSA:3.40.50.2000:FF:000346', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(216986, NULL, 'G3DSA:1.10.533.10:FF:000116', NULL, NULL, 'Caspase-15', NULL, NULL, NULL, NULL, NULL, 4),
(216987, NULL, 'G3DSA:3.80.10.10:FF:001416', NULL, NULL, 'Leucine-rich repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(216988, NULL, 'G3DSA:3.40.30.10:FF:000874', NULL, NULL, 'Phospholipid hydroperoxide glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(216989, NULL, 'G3DSA:1.10.238.10:FF:001291', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(216990, NULL, 'G3DSA:1.50.40.10:FF:000463', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216991, NULL, 'G3DSA:3.90.80.10:FF:000004', NULL, NULL, 'Inorganic pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(216992, NULL, 'G3DSA:2.10.90.10:FF:000016', NULL, NULL, 'Neuroblastoma suppressor of tumorigenicity 1', NULL, NULL, NULL, NULL, NULL, 4),
(216993, NULL, 'G3DSA:3.90.1520.10:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216994, NULL, 'G3DSA:3.30.70.330:FF:002112', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216995, NULL, 'G3DSA:3.30.70.330:FF:001712', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(216996, NULL, 'G3DSA:1.10.472.80:FF:000186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(216997, NULL, 'G3DSA:1.10.274.10:FF:000008', NULL, NULL, 'GAF domain phosphoenolpyruvate--protein phosphotransferase PtsP', NULL, NULL, NULL, NULL, NULL, 4),
(216998, NULL, 'G3DSA:2.130.10.10:FF:004682', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(216999, NULL, 'G3DSA:2.60.40.4070:FF:000013', NULL, NULL, 'Glr0823 protein', NULL, NULL, NULL, NULL, NULL, 4),
(217000, NULL, 'G3DSA:1.10.287.890:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217001, NULL, 'G3DSA:2.160.20.10:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217002, NULL, 'G3DSA:2.40.50.140:FF:000029', NULL, NULL, '50S ribosomal protein L2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(217003, NULL, 'G3DSA:3.30.40.10:FF:002230', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217004, NULL, 'G3DSA:3.10.20.120:FF:000003', NULL, NULL, 'Toxic shock syndrome toxin-1', NULL, NULL, NULL, NULL, NULL, 4),
(217005, NULL, 'G3DSA:3.60.21.10:FF:000026', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(217006, NULL, 'G3DSA:3.50.50.60:FF:000345', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(217007, NULL, 'G3DSA:2.10.25.10:FF:000534', NULL, NULL, 'Neurogenic locus notch homolog protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(217008, NULL, 'G3DSA:3.90.1720.30:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217009, NULL, 'G3DSA:2.10.25.10:FF:001023', NULL, NULL, 'Os09g0373800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(217010, NULL, 'G3DSA:3.40.640.10:FF:000300', NULL, NULL, 'Pyridoxal phosphate-dependent transferase', NULL, NULL, NULL, NULL, NULL, 4),
(217011, NULL, 'G3DSA:1.20.58.390:FF:000263', NULL, NULL, 'Glycine receptor alpha 1 variant, putative', NULL, NULL, NULL, NULL, NULL, 4),
(217012, NULL, 'G3DSA:3.40.720.10:FF:000301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217013, NULL, 'G3DSA:1.10.418.60:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217014, NULL, 'G3DSA:3.40.710.10:FF:000059', NULL, NULL, 'Penicillin-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(217015, NULL, 'G3DSA:1.10.1080.10:FF:000012', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(217016, NULL, 'G3DSA:3.40.50.300:FF:004536', NULL, NULL, 'ATP-binding cassette sub-family F member 2', NULL, NULL, NULL, NULL, NULL, 4),
(217017, NULL, 'G3DSA:3.10.20.70:FF:000027', NULL, NULL, 'Glutamate-ammonia ligase', NULL, NULL, NULL, NULL, NULL, 4),
(217018, NULL, 'G3DSA:1.20.1250.20:FF:000335', NULL, NULL, 'Siderochrome iron transporter 2', NULL, NULL, NULL, NULL, NULL, 4),
(217019, NULL, 'G3DSA:1.10.555.10:FF:000105', NULL, NULL, 'Mental retardation GTPase activating protein homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(217020, NULL, 'G3DSA:3.40.50.150:FF:001304', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217021, NULL, 'G3DSA:2.130.10.10:FF:006008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217022, NULL, 'G3DSA:3.40.630.10:FF:000058', NULL, NULL, 'Aminopeptidase ypdE', NULL, NULL, NULL, NULL, NULL, 4),
(217023, NULL, 'G3DSA:2.40.20.10:FF:000090', NULL, NULL, 'Hepatocyte growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(217024, NULL, 'G3DSA:2.60.40.840:FF:000007', NULL, NULL, 'Phosrestin ii arrestin a arrestin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(217025, NULL, 'G3DSA:3.20.20.60:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217026, NULL, 'G3DSA:2.60.34.10:FF:000047', NULL, NULL, '97 kDa heat shock protein', NULL, NULL, NULL, NULL, NULL, 4),
(217027, NULL, 'G3DSA:3.40.50.10260:FF:000007', NULL, NULL, 'YjeF N-terminal domain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(217028, NULL, 'G3DSA:2.60.40.3130:FF:000001', NULL, NULL, 'Spike glycoprotein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(217029, NULL, 'G3DSA:3.40.47.10:FF:000025', NULL, NULL, 'Chalcone synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(217030, NULL, 'G3DSA:1.20.1530.20:FF:000020', NULL, NULL, 'Arsenical-resistance membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(217031, NULL, 'G3DSA:3.30.200.70:FF:000001', NULL, NULL, 'Stress response kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(217032, NULL, 'G3DSA:3.40.630.30:FF:000160', NULL, NULL, 'Gcn5-related N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(217033, NULL, 'G3DSA:1.10.3380.10:FF:000024', NULL, NULL, 'U5 snRNP-specific protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(217034, NULL, 'G3DSA:3.30.420.140:FF:000038', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(217035, NULL, 'G3DSA:1.25.40.90:FF:000096', NULL, NULL, 'Target of Myb protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(217036, NULL, 'G3DSA:3.30.70.2740:FF:000020', NULL, NULL, 'D-lactate dehydrogenase (Cytochrome)', NULL, NULL, NULL, NULL, NULL, 4),
(217037, NULL, 'G3DSA:1.20.120.350:FF:000060', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(217038, NULL, 'G3DSA:1.25.40.70:FF:000090', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', NULL, NULL, NULL, NULL, NULL, 4),
(217039, NULL, 'G3DSA:2.40.10.10:FF:000645', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217040, NULL, 'G3DSA:3.40.50.720:FF:002009', NULL, NULL, 'Short-chain dehydrogenase/reductase SDR', NULL, NULL, NULL, NULL, NULL, 4),
(217041, NULL, 'G3DSA:3.80.10.10:FF:000399', NULL, NULL, 'F-box/LRR-repeat protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(217042, NULL, 'G3DSA:3.40.50.300:FF:003732', NULL, NULL, 'ATP-dependent RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(217043, NULL, 'G3DSA:3.90.480.20:FF:000009', NULL, NULL, 'Sulfite reductase (NADPH) hemoprotein beta-component', NULL, NULL, NULL, NULL, NULL, 4),
(217044, NULL, 'G3DSA:1.25.40.10:FF:000999', NULL, NULL, 'Anaphase-promoting complex subunit Apc5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(217045, NULL, 'G3DSA:1.10.472.10:FF:000570', NULL, NULL, 'Cyclin-D2-1', NULL, NULL, NULL, NULL, NULL, 4),
(217046, NULL, 'G3DSA:2.10.110.10:FF:000260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217047, NULL, 'G3DSA:3.40.930.10:FF:000042', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217048, NULL, 'G3DSA:3.30.160.60:FF:005463', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217049, NULL, 'G3DSA:3.30.70.330:FF:002168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217050, NULL, 'G3DSA:3.40.50.150:FF:001776', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217051, NULL, 'G3DSA:3.30.9.10:FF:000308', NULL, NULL, 'Amino acid deaminase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(217052, NULL, 'G3DSA:2.40.70.10:FF:000126', NULL, NULL, 'Gamma conglutin 1', NULL, NULL, NULL, NULL, NULL, 4),
(217053, NULL, 'G3DSA:3.10.28.10:FF:000061', NULL, NULL, 'Large helicase-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(217054, NULL, 'G3DSA:1.20.1050.10:FF:000025', NULL, NULL, 'Glutathione S-transferase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(217055, NULL, 'G3DSA:2.130.10.10:FF:002529', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217056, NULL, 'G3DSA:2.60.40.1180:FF:000096', NULL, NULL, 'Probable glucan 1,3-alpha-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(217057, NULL, 'G3DSA:1.20.1300.20:FF:000008', NULL, NULL, 'Cysteine proteinase', NULL, NULL, NULL, NULL, NULL, 4),
(217058, NULL, 'G3DSA:3.20.20.80:FF:000687', NULL, NULL, 'Hexosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(217059, NULL, 'G3DSA:3.40.50.10140:FF:000084', NULL, NULL, 'Protein CBG03616', NULL, NULL, NULL, NULL, NULL, 4),
(217060, NULL, 'G3DSA:1.25.40.10:FF:003809', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(217061, NULL, 'G3DSA:2.60.40.10:FF:000955', NULL, NULL, 'Terribly reduced optic lobes, isoform AF', NULL, NULL, NULL, NULL, NULL, 4),
(217062, NULL, 'G3DSA:1.20.1070.10:FF:001364', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(217063, NULL, 'G3DSA:2.40.10.10:FF:000206', NULL, NULL, 'Serine protease Rv3671c', NULL, NULL, NULL, NULL, NULL, 4),
(217064, NULL, 'G3DSA:3.20.20.80:FF:000159', NULL, NULL, 'Class V chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(217065, NULL, 'G3DSA:2.60.40.10:FF:000516', NULL, NULL, 'Myosin light chain kinase, smooth muscle', NULL, NULL, NULL, NULL, NULL, 4),
(217066, NULL, 'G3DSA:1.10.10.60:FF:000629', NULL, NULL, 'L-rhamnose operon transcriptional activator RhaR', NULL, NULL, NULL, NULL, NULL, 4),
(217067, NULL, 'G3DSA:3.40.50.10240:FF:000001', NULL, NULL, 'Thiamine pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(217068, NULL, 'G3DSA:3.90.76.10:FF:000045', NULL, NULL, 'Dipeptide ABC superfamily ATP binding cassette transporter, binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(217069, NULL, 'G3DSA:3.30.70.330:FF:000167', NULL, NULL, 'protein boule-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(217070, NULL, 'G3DSA:2.60.40.10:FF:004878', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217071, NULL, 'G3DSA:1.20.120.790:FF:000017', NULL, NULL, 'Lipophosphoglycan biosynthetic protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(217072, NULL, 'G3DSA:1.20.58.90:FF:000006', NULL, NULL, 'Type III secretion system needle complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(217073, NULL, 'G3DSA:3.40.50.300:FF:008375', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217074, NULL, 'G3DSA:3.40.50.720:FF:000744', NULL, NULL, 'Smt3 activating enzyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(217075, NULL, 'G3DSA:3.30.1360.40:FF:000008', NULL, NULL, 'DNA topoisomerase (ATP-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4),
(217076, NULL, 'G3DSA:3.40.50.300:FF:005969', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217077, NULL, 'G3DSA:3.30.200.20:FF:001228', NULL, NULL, 'Probable serine/threonine-protein kinase DDB_G0290859', NULL, NULL, NULL, NULL, NULL, 4),
(217078, NULL, 'G3DSA:3.30.920.20:FF:000007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217079, NULL, 'G3DSA:1.10.1020.10:FF:000003', NULL, NULL, 'Site-specific DNA-methyltransferase (adenine-specific)', NULL, NULL, NULL, NULL, NULL, 4),
(217080, NULL, 'G3DSA:3.90.190.10:FF:000052', NULL, NULL, 'Dual specificity phosphatase 15', NULL, NULL, NULL, NULL, NULL, 4),
(217081, NULL, 'G3DSA:3.20.20.100:FF:000091', NULL, NULL, 'NADPH-dependent aldo-keto reductase, chloroplastic isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(217082, NULL, 'G3DSA:3.40.50.150:FF:000287', NULL, NULL, 'Protein-lysine N-methyltransferase EFM4', NULL, NULL, NULL, NULL, NULL, 4),
(217083, NULL, 'G3DSA:2.60.120.260:FF:000270', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(217084, NULL, 'G3DSA:3.80.10.10:FF:003833', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217085, NULL, 'G3DSA:1.10.10.10:FF:000227', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(217086, NULL, 'G3DSA:3.40.850.10:FF:000069', NULL, NULL, 'Kinesin-like motor protein', NULL, NULL, NULL, NULL, NULL, 4),
(217087, NULL, 'G3DSA:1.25.40.20:FF:000912', NULL, NULL, 'Ankyrin repeat and KH domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(217088, NULL, 'G3DSA:3.30.50.10:FF:000073', NULL, NULL, 'Nuclear hormone receptor family member nhr-121', NULL, NULL, NULL, NULL, NULL, 4),
(217089, NULL, 'G3DSA:3.40.50.1700:FF:000003', NULL, NULL, 'Probable beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(217090, NULL, 'G3DSA:3.60.40.10:FF:000065', NULL, NULL, 'Protein phosphatase 2C 37', NULL, NULL, NULL, NULL, NULL, 4),
(217091, NULL, 'G3DSA:3.30.10.20:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217092, NULL, 'G3DSA:3.40.50.300:FF:000298', NULL, NULL, 'ATP-binding cassette sub-family A member 12', NULL, NULL, NULL, NULL, NULL, 4),
(217093, NULL, 'G3DSA:2.30.30.230:FF:000009', NULL, NULL, 'Fumarylacetoacetase', NULL, NULL, NULL, NULL, NULL, 4),
(217094, NULL, 'G3DSA:2.130.10.10:FF:002681', NULL, NULL, 'Seven WD repeats, AN11 family', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(217095, NULL, 'G3DSA:1.10.1280.10:FF:000016', NULL, NULL, 'Tyrosinase', NULL, NULL, NULL, NULL, NULL, 4),
(217096, NULL, 'G3DSA:3.30.505.10:FF:000034', NULL, NULL, 'SH2 domain-containing protein 4A', NULL, NULL, NULL, NULL, NULL, 4),
(217097, NULL, 'G3DSA:3.80.10.10:FF:003272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217098, NULL, 'G3DSA:1.10.472.10:FF:000385', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217099, NULL, 'G3DSA:2.60.120.920:FF:000193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217100, NULL, 'G3DSA:3.30.565.10:FF:000279', NULL, NULL, 'Two-component system sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(217101, NULL, 'G3DSA:3.40.50.150:FF:000820', NULL, NULL, 'Nicotinamide N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(217102, NULL, 'G3DSA:1.20.1250.20:FF:001324', NULL, NULL, 'Sodium/phosphate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(217103, NULL, 'G3DSA:2.160.10.10:FF:000044', NULL, NULL, 'Transferase hexapeptide domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(217104, NULL, 'G3DSA:3.20.20.80:FF:000507', NULL, NULL, 'Glucosylceramidase beta 3 (gene/pseudogene)', NULL, NULL, NULL, NULL, NULL, 4),
(217105, NULL, 'G3DSA:3.30.470.30:FF:000054', NULL, NULL, 'Putative methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(217106, NULL, 'G3DSA:3.20.20.80:FF:000215', NULL, NULL, '1,3-beta-galactosyl-N-acetylhexosamine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(217107, NULL, 'G3DSA:3.30.40.10:FF:001241', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(217108, NULL, 'G3DSA:3.40.50.300:FF:000793', NULL, NULL, 'Structural maintenance of chromosomes protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(217109, NULL, 'G3DSA:1.20.1250.20:FF:001139', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(217110, NULL, 'G3DSA:3.20.20.70:FF:000774', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217111, NULL, 'G3DSA:1.10.8.60:FF:000089', NULL, NULL, 'Peroxisomal biogenesis factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(217112, NULL, 'G3DSA:1.10.510.10:FF:002317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217113, NULL, 'G3DSA:3.20.20.140:FF:000344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217114, NULL, 'G3DSA:2.30.30.210:FF:000003', NULL, NULL, 'Ribonuclease P protein subunit p29, putative', NULL, NULL, NULL, NULL, NULL, 4),
(217115, NULL, 'G3DSA:3.30.1360.20:FF:000002', NULL, NULL, 'Putative pterin-4-alpha-carbinolamine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(217116, NULL, 'G3DSA:1.20.59.10:FF:000024', NULL, NULL, 'Chorismate mutase/prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(217117, NULL, 'G3DSA:3.90.1410.10:FF:000136', NULL, NULL, 'Uncharacterized protein C16C6.01c', NULL, NULL, NULL, NULL, NULL, 4),
(217118, NULL, 'G3DSA:2.30.42.10:FF:000573', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217119, NULL, 'G3DSA:1.25.40.10:FF:003017', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g46580, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(217120, NULL, 'G3DSA:3.40.30.10:FF:000402', NULL, NULL, 'Protein disulfide isomerase PDI2', NULL, NULL, NULL, NULL, NULL, 4),
(217121, NULL, 'G3DSA:3.40.390.30:FF:000005', NULL, NULL, 'Probable rRNA maturation factor YbeY, putative', NULL, NULL, NULL, NULL, NULL, 4),
(217122, NULL, 'G3DSA:3.90.105.20:FF:000004', NULL, NULL, 'Ribosome assembly factor mrt4', NULL, NULL, NULL, NULL, NULL, 4),
(217123, NULL, 'G3DSA:2.40.50.140:FF:001198', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217124, NULL, 'G3DSA:3.40.570.10:FF:000031', NULL, NULL, 'Endonuclease G', NULL, NULL, NULL, NULL, NULL, 4),
(217125, NULL, 'G3DSA:3.40.50.300:FF:007442', NULL, NULL, 'ABC transporter protein family', NULL, NULL, NULL, NULL, NULL, 4),
(217126, NULL, 'G3DSA:1.20.58.70:FF:000091', NULL, NULL, 'AaceriACR092Cp', NULL, NULL, NULL, NULL, NULL, 4),
(217127, NULL, 'G3DSA:3.30.70.1560:FF:000008', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(217128, NULL, 'G3DSA:2.60.120.40:FF:000016', NULL, NULL, 'Tumor necrosis factor', NULL, NULL, NULL, NULL, NULL, 4),
(217129, NULL, 'G3DSA:2.60.40.10:FF:002405', NULL, NULL, 'Colony stimulating factor 1 receptor, a', NULL, NULL, NULL, NULL, NULL, 4),
(217130, NULL, 'G3DSA:1.10.10.60:FF:000692', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(217131, NULL, 'G3DSA:3.40.630.30:FF:000244', NULL, NULL, 'GNAT family N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(217132, NULL, 'G3DSA:3.10.20.90:FF:000213', NULL, NULL, 'Plexin A4, B', NULL, NULL, NULL, NULL, NULL, 4),
(217133, NULL, 'G3DSA:3.40.50.300:FF:001607', NULL, NULL, 'Gluconokinase', NULL, NULL, NULL, NULL, NULL, 4),
(217134, NULL, 'G3DSA:3.40.50.720:FF:002161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217135, NULL, 'G3DSA:2.10.110.10:FF:000108', NULL, NULL, 'LIM domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(217136, NULL, 'G3DSA:1.20.120.1080:FF:000061', NULL, NULL, 'ATP-dependent RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(217137, NULL, 'G3DSA:3.30.530.20:FF:000112', NULL, NULL, 'Coenzyme Q-binding protein COQ10, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(217138, NULL, 'G3DSA:1.25.10.10:FF:002791', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217139, NULL, 'G3DSA:2.60.40.10:FF:004850', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217140, NULL, 'G3DSA:3.40.50.1360:FF:000058', NULL, NULL, '6-phosphogluconolactonase', NULL, NULL, NULL, NULL, NULL, 4),
(217141, NULL, 'G3DSA:2.20.25.80:FF:000009', NULL, NULL, 'WRKY transcription factor 53', NULL, NULL, NULL, NULL, NULL, 4),
(217142, NULL, 'G3DSA:3.40.50.150:FF:001220', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217143, NULL, 'G3DSA:3.30.160.60:FF:003170', NULL, NULL, 'Crooked legs, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(217144, NULL, 'G3DSA:3.40.50.300:FF:006514', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217145, NULL, 'G3DSA:2.60.40.10:FF:004794', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217146, NULL, 'G3DSA:2.40.50.90:FF:000188', NULL, NULL, 'Serine/threonine kinase 31', NULL, NULL, NULL, NULL, NULL, 4),
(217147, NULL, 'G3DSA:1.10.730.10:FF:000030', NULL, NULL, 'Methionine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(217148, NULL, 'G3DSA:1.20.1640.10:FF:000109', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217149, NULL, 'G3DSA:3.40.50.970:FF:000061', NULL, NULL, '2-oxoglutarate dehydrogenase E1 component', NULL, NULL, NULL, NULL, NULL, 4),
(217150, NULL, 'G3DSA:3.40.50.300:FF:003171', NULL, NULL, 'ATP-dependent RNA helicase YTHDC2', NULL, NULL, NULL, NULL, NULL, 4),
(217151, NULL, 'G3DSA:1.20.58.1480:FF:000015', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(217152, NULL, 'G3DSA:3.20.20.80:FF:000131', NULL, NULL, 'Glycoside hydrolase superfamily', NULL, NULL, NULL, NULL, NULL, 4),
(217153, NULL, 'G3DSA:3.30.450.20:FF:000667', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(217154, NULL, 'G3DSA:3.30.200.20:FF:002392', NULL, NULL, 'Protein kinase domaincontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(217155, NULL, 'G3DSA:3.20.20.220:FF:000014', NULL, NULL, 'Methylenetetrahydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(217156, NULL, 'G3DSA:2.60.40.10:FF:003866', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217157, NULL, 'G3DSA:3.20.20.140:FF:000288', NULL, NULL, 'Histidinol-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(217158, NULL, 'G3DSA:2.60.120.260:FF:000118', NULL, NULL, 'Beta-mannosidase B', NULL, NULL, NULL, NULL, NULL, 4),
(217159, NULL, 'G3DSA:3.40.50.150:FF:000764', NULL, NULL, 'RE45246p', NULL, NULL, NULL, NULL, NULL, 4),
(217160, NULL, 'G3DSA:3.30.70.330:FF:000370', NULL, NULL, 'Dead end protein homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(217161, NULL, 'G3DSA:2.60.120.260:FF:000303', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(217162, NULL, 'G3DSA:3.90.190.10:FF:000428', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217163, NULL, 'G3DSA:3.40.850.10:FF:000041', NULL, NULL, 'Kinesin-like calmodulin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(217164, NULL, 'G3DSA:3.40.50.300:FF:002771', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(217165, NULL, 'G3DSA:3.80.10.10:FF:002344', NULL, NULL, 'F-box/LRR-repeat protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(217166, NULL, 'G3DSA:1.10.418.10:FF:000276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217167, NULL, 'G3DSA:3.40.50.300:FF:002243', NULL, NULL, 'Regulator of telomere elongation helicase 1', NULL, NULL, NULL, NULL, NULL, 4),
(217168, NULL, 'G3DSA:1.20.920.30:FF:000054', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(217169, NULL, 'G3DSA:1.20.58.60:FF:000407', NULL, NULL, 'Spectrin beta chain, non-erythrocytic', NULL, NULL, NULL, NULL, NULL, 4),
(217170, NULL, 'G3DSA:3.30.450.20:FF:000139', NULL, NULL, 'Cyclic-di-AMP phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(217171, NULL, 'G3DSA:3.40.50.2300:FF:001627', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217172, NULL, 'G3DSA:3.10.20.90:FF:000921', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217173, NULL, 'G3DSA:3.40.30.10:FF:000346', NULL, NULL, 'Calsequestrin', NULL, NULL, NULL, NULL, NULL, 4),
(217174, NULL, 'G3DSA:1.10.238.200:FF:000030', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(217175, NULL, 'G3DSA:3.40.50.2300:FF:001279', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217176, NULL, 'G3DSA:2.170.150.70:FF:000001', NULL, NULL, 'Centromere protein V', NULL, NULL, NULL, NULL, NULL, 4),
(217177, NULL, 'G3DSA:3.30.160.60:FF:002057', NULL, NULL, 'IKAROS family zinc finger 3', NULL, NULL, NULL, NULL, NULL, 4),
(217178, NULL, 'G3DSA:1.25.10.10:FF:002644', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217179, NULL, 'G3DSA:1.20.1560.10:FF:000108', NULL, NULL, 'Multidrug resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(217180, NULL, 'G3DSA:1.10.10.10:FF:001211', NULL, NULL, 'RecQ family helicase', NULL, NULL, NULL, NULL, NULL, 4),
(217181, NULL, 'G3DSA:3.30.160.60:FF:001045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217182, NULL, 'G3DSA:3.40.50.720:FF:000688', NULL, NULL, 'Dehydrogenase, putative (AFU_orthologue AFUA_8G05760)', NULL, NULL, NULL, NULL, NULL, 4),
(217183, NULL, 'G3DSA:3.40.50.2000:FF:000638', NULL, NULL, 'AGAP007588-PA', NULL, NULL, NULL, NULL, NULL, 4),
(217184, NULL, 'G3DSA:3.30.40.10:FF:000313', NULL, NULL, 'Tripartite motif-containing protein 66', NULL, NULL, NULL, NULL, NULL, 4),
(217185, NULL, 'G3DSA:1.20.1560.10:FF:000783', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(217186, NULL, 'G3DSA:2.30.29.30:FF:000615', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217187, NULL, 'G3DSA:1.10.510.10:FF:003661', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217188, NULL, 'G3DSA:2.60.40.10:FF:005811', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217189, NULL, 'G3DSA:6.10.300.40:FF:000004', NULL, NULL, '26S proteasome regulatory subunit N10', NULL, NULL, NULL, NULL, NULL, 4),
(217190, NULL, 'G3DSA:1.25.40.10:FF:004361', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(217191, NULL, 'G3DSA:2.120.10.30:FF:000175', NULL, NULL, 'Calcium-dependent phosphotriesterase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(217192, NULL, 'G3DSA:3.30.300.20:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217193, NULL, 'G3DSA:1.10.8.1330:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217194, NULL, 'G3DSA:3.20.20.70:FF:000830', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217195, NULL, 'G3DSA:3.40.50.720:FF:001672', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(217196, NULL, 'G3DSA:3.20.20.140:FF:000260', NULL, NULL, 'Alpha-D-ribose 1-methylphosphonate 5-triphosphate diphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(217197, NULL, 'G3DSA:2.120.10.10:FF:000017', NULL, NULL, 'Exo-alpha-sialidase', NULL, NULL, NULL, NULL, NULL, 4),
(217198, NULL, 'G3DSA:3.30.300.10:FF:000007', NULL, NULL, 'S-adenosylmethionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(217199, NULL, 'G3DSA:3.30.200.20:FF:001756', NULL, NULL, 'Aurora kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(217200, NULL, 'G3DSA:3.30.365.10:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217201, NULL, 'G3DSA:3.40.50.12650:FF:000016', NULL, NULL, 'DNA repair metallo-beta-lactamase-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(217202, NULL, 'G3DSA:3.90.110.10:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217203, NULL, 'G3DSA:3.30.450.30:FF:000024', NULL, NULL, 'Dynein light chain roadblock', NULL, NULL, NULL, NULL, NULL, 4),
(217204, NULL, 'G3DSA:1.25.40.10:FF:003961', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217205, NULL, 'G3DSA:2.60.120.10:FF:000620', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217206, NULL, 'G3DSA:2.60.200.40:FF:000017', NULL, NULL, 'Sphingoid long chain base kinase', NULL, NULL, NULL, NULL, NULL, 4),
(217207, NULL, 'G3DSA:3.30.420.40:FF:000525', NULL, NULL, 'Alpha-centractin', NULL, NULL, NULL, NULL, NULL, 4),
(217208, NULL, 'G3DSA:1.10.3080.10:FF:000035', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(217209, NULL, 'G3DSA:1.50.40.10:FF:000019', NULL, NULL, 'Mitochondrial uncoupling protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(217210, NULL, 'G3DSA:3.80.10.10:FF:003305', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217211, NULL, 'G3DSA:2.90.10.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217212, NULL, 'G3DSA:3.40.50.720:FF:001177', NULL, NULL, 'epidermal retinol dehydrogenase 2', NULL, NULL, NULL, NULL, NULL, 4),
(217213, NULL, 'G3DSA:3.40.50.1820:FF:000421', NULL, NULL, 'Possible epoxide hydrolase ephE', NULL, NULL, NULL, NULL, NULL, 4),
(217214, NULL, 'G3DSA:2.170.120.12:FF:000012', NULL, NULL, 'DNA-directed RNA polymerases I and III subunit RPAC1', NULL, NULL, NULL, NULL, NULL, 4),
(217215, NULL, 'G3DSA:3.30.450.40:FF:000297', NULL, NULL, 'Sensor histidine kinase, PAS and GAF domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(217216, NULL, 'G3DSA:3.30.559.30:FF:000052', NULL, NULL, 'Nonribosomal peptide synthase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(217217, NULL, 'G3DSA:1.10.420.10:FF:000017', NULL, NULL, 'Catalase/peroxidase HPI', NULL, NULL, NULL, NULL, NULL, 4),
(217218, NULL, 'G3DSA:2.40.10.10:FF:000122', NULL, NULL, 'Chymotrypsin-like elastase family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(217219, NULL, 'G3DSA:1.20.1070.10:FF:000060', NULL, NULL, 'Somatostatin receptor type 1', NULL, NULL, NULL, NULL, NULL, 4),
(217220, NULL, 'G3DSA:3.40.50.12710:FF:000028', NULL, NULL, 'Protein arginine methyltransferase NDUFAF7', NULL, NULL, NULL, NULL, NULL, 4),
(217221, NULL, 'G3DSA:3.30.70.330:FF:000959', NULL, NULL, 'Mitochondrial escape protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(217222, NULL, 'G3DSA:1.20.1110.10:FF:000232', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(217223, NULL, 'G3DSA:3.50.50.60:FF:001339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217224, NULL, 'G3DSA:1.10.630.10:FF:000819', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217225, NULL, 'G3DSA:2.130.10.10:FF:005935', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase, cyclophilin-type family protein', NULL, NULL, NULL, NULL, NULL, 4),
(217226, NULL, 'G3DSA:2.120.10.80:FF:000257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217227, NULL, 'G3DSA:3.40.50.300:FF:002619', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(217228, NULL, 'G3DSA:3.30.1360.170:FF:000014', NULL, NULL, 'Thymidylate synthase complementing protein ThyX', NULL, NULL, NULL, NULL, NULL, 4),
(217229, NULL, 'G3DSA:3.30.70.330:FF:000223', NULL, NULL, 'Polypyrimidine tract binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(217230, NULL, 'G3DSA:3.30.1520.10:FF:000142', NULL, NULL, 'PX domain-containing protein C1450.12', NULL, NULL, NULL, NULL, NULL, 4),
(217231, NULL, 'G3DSA:1.20.1250.20:FF:002252', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(217232, NULL, 'G3DSA:1.10.3460.10:FF:000025', NULL, NULL, 'Fucoxanthin chlorophyll a/c light-harvesting protein', NULL, NULL, NULL, NULL, NULL, 4),
(217233, NULL, 'G3DSA:2.170.300.10:FF:000063', NULL, NULL, 'netrin-4', NULL, NULL, NULL, NULL, NULL, 4),
(217234, NULL, 'G3DSA:3.90.79.10:FF:000231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217235, NULL, 'G3DSA:3.80.10.10:FF:000343', NULL, NULL, 'CCR4-NOT transcription complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(217236, NULL, 'G3DSA:2.130.10.10:FF:000320', NULL, NULL, 'echinoderm microtubule-associated protein-like 6', NULL, NULL, NULL, NULL, NULL, 4),
(217237, NULL, 'G3DSA:1.20.1110.10:FF:000176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217238, NULL, 'G3DSA:1.10.510.10:FF:002880', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217239, NULL, 'G3DSA:1.10.10.1940:FF:000004', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(217240, NULL, 'G3DSA:3.40.190.10:FF:000046', NULL, NULL, 'Glycerol-3-phosphate transporter periplasmic binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(217241, NULL, 'G3DSA:3.40.50.300:FF:004952', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217242, NULL, 'G3DSA:3.40.640.10:FF:000115', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(217243, NULL, 'G3DSA:1.10.8.60:FF:000409', NULL, NULL, 'AGAP011652-PA', NULL, NULL, NULL, NULL, NULL, 4),
(217244, NULL, 'G3DSA:3.30.40.10:FF:000128', NULL, NULL, 'lysine-specific demethylase 5C isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(217245, NULL, 'G3DSA:2.40.10.170:FF:000024', NULL, NULL, 'ATP synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(217246, NULL, 'G3DSA:3.40.640.10:FF:000059', NULL, NULL, 'Serine palmitoyl CoA transferase subunit LcbA', NULL, NULL, NULL, NULL, NULL, 4),
(217247, NULL, 'G3DSA:3.40.190.10:FF:000102', NULL, NULL, 'Osmoprotectant ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(217248, NULL, 'G3DSA:2.60.40.3210:FF:000019', NULL, NULL, 'Zona pellucida glycoprotein 3 (sperm receptor), gene 2', NULL, NULL, NULL, NULL, NULL, 4),
(217249, NULL, 'G3DSA:3.50.50.60:FF:000053', NULL, NULL, 'Geranylgeranyl reductase family', NULL, NULL, NULL, NULL, NULL, 4),
(217250, NULL, 'G3DSA:1.10.472.80:FF:000219', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217251, NULL, 'G3DSA:1.20.1270.60:FF:000270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217252, NULL, 'G3DSA:3.30.740.10:FF:000024', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217253, NULL, 'G3DSA:1.20.1510.10:FF:000072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217254, NULL, 'G3DSA:1.10.3730.20:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217255, NULL, 'G3DSA:2.30.130.40:FF:000024', NULL, NULL, 'Lon protease homolog 2, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(217256, NULL, 'G3DSA:1.25.40.10:FF:000055', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(217257, NULL, 'G3DSA:2.60.120.560:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217258, NULL, 'G3DSA:3.30.1320.10:FF:000014', NULL, NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(217259, NULL, 'G3DSA:3.40.50.12160:FF:000021', NULL, NULL, 'Ribosomal protein S12 methylthiotransferase RimO', NULL, NULL, NULL, NULL, NULL, 4),
(217260, NULL, 'G3DSA:3.30.1330.50:FF:000004', NULL, NULL, '2-C-methyl-D-erythritol 2,4-cyclodiphosphate synthase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(217261, NULL, 'G3DSA:2.130.10.10:FF:005643', NULL, NULL, 'Plexin C1', NULL, NULL, NULL, NULL, NULL, 4),
(217262, NULL, 'G3DSA:2.10.25.10:FF:001546', NULL, NULL, 'Carbohydrate sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(217263, NULL, 'G3DSA:3.40.1260.10:FF:000006', NULL, NULL, 'Sulfur relay protein TusB/DsrH', NULL, NULL, NULL, NULL, NULL, 4),
(217264, NULL, 'G3DSA:3.30.420.10:FF:000657', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217265, NULL, 'G3DSA:1.10.238.10:FF:000178', NULL, NULL, 'Calmodulin-2 A', NULL, NULL, NULL, NULL, NULL, 4),
(217266, NULL, 'G3DSA:1.25.40.10:FF:001691', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g20300, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(217267, NULL, 'G3DSA:1.10.220.150:FF:000013', NULL, NULL, 'Putative Arf GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(217268, NULL, 'G3DSA:1.20.1070.10:FF:001133', NULL, NULL, 'Substance-K receptor', NULL, NULL, NULL, NULL, NULL, 4),
(217269, NULL, 'G3DSA:2.60.40.60:FF:000306', NULL, NULL, 'Cadherin 23', NULL, NULL, NULL, NULL, NULL, 4),
(217270, NULL, 'G3DSA:2.30.130.10:FF:000009', NULL, NULL, 'H/ACA ribonucleoprotein complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(217271, NULL, 'G3DSA:3.40.50.300:FF:003788', NULL, NULL, 'INO80 complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(217272, NULL, 'G3DSA:3.30.1390.30:FF:000007', NULL, NULL, 'Penicillin-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(217273, NULL, 'G3DSA:3.30.160.60:FF:006188', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217274, NULL, 'G3DSA:3.40.50.1820:FF:000657', NULL, NULL, 'Proline iminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(217275, NULL, 'G3DSA:3.30.70.330:FF:001095', NULL, NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(217276, NULL, 'G3DSA:3.90.640.90:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217277, NULL, 'G3DSA:3.30.40.10:FF:000605', NULL, NULL, 'E3 ubiquitin-protein ligase PRT1', NULL, NULL, NULL, NULL, NULL, 4),
(217278, NULL, 'G3DSA:3.40.1110.10:FF:000439', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217279, NULL, 'G3DSA:3.40.120.10:FF:000059', NULL, NULL, 'GlcNAc phosphomutase', NULL, NULL, NULL, NULL, NULL, 4),
(217280, NULL, 'G3DSA:4.10.60.10:FF:000083', NULL, NULL, 'Protein CBG13587', NULL, NULL, NULL, NULL, NULL, 4),
(217281, NULL, 'G3DSA:3.30.40.10:FF:002314', NULL, NULL, 'Lid2 complex component lid2', NULL, NULL, NULL, NULL, NULL, 4),
(217282, NULL, 'G3DSA:1.25.40.20:FF:001637', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(217283, NULL, 'G3DSA:1.20.120.1480:FF:000001', NULL, NULL, 'DNA-binding protein RAP1', NULL, NULL, NULL, NULL, NULL, 4),
(217284, NULL, 'G3DSA:3.40.50.150:FF:000848', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217285, NULL, 'G3DSA:1.10.565.10:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217286, NULL, 'G3DSA:1.10.510.10:FF:001244', NULL, NULL, 'Putative casein kinase I', NULL, NULL, NULL, NULL, NULL, 4),
(217287, NULL, 'G3DSA:1.10.1200.270:FF:000032', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(217288, NULL, 'G3DSA:3.40.50.1240:FF:000112', NULL, NULL, '6-phosphofructo-2-kinase/fructose-2, 6-biphosphatase 1 splice variant', NULL, NULL, NULL, NULL, NULL, 4),
(217289, NULL, 'G3DSA:2.30.30.100:FF:000173', NULL, NULL, 'Small nuclear ribonucleoprotein (LSM1), putative (AFU_orthologue AFUA_2G11800)', NULL, NULL, NULL, NULL, NULL, 4),
(217290, NULL, 'G3DSA:1.10.10.10:FF:001008', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(217291, NULL, 'G3DSA:2.30.29.30:FF:000582', NULL, NULL, 'Vacuolar sorting protein', NULL, NULL, NULL, NULL, NULL, 4),
(217292, NULL, 'G3DSA:3.10.20.230:FF:000036', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(217293, NULL, 'G3DSA:1.10.400.10:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(217294, NULL, 'G3DSA:3.40.1110.10:FF:000350', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217295, NULL, 'G3DSA:1.20.120.610:FF:000008', NULL, NULL, 'Vacuolar ATP synthase 16 kDa proteolipid subunit', NULL, NULL, NULL, NULL, NULL, 4),
(217296, NULL, 'G3DSA:3.10.20.30:FF:000038', NULL, NULL, 'Molybdopterin synthase sulfur carrier subunit', NULL, NULL, NULL, NULL, NULL, 4),
(217297, NULL, 'G3DSA:3.90.70.10:FF:000739', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217298, NULL, 'G3DSA:2.60.120.260:FF:000534', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(217299, NULL, 'G3DSA:2.60.40.10:FF:004086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217300, NULL, 'G3DSA:1.10.533.10:FF:000032', NULL, NULL, 'Nucleotide-binding oligomerization domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(217301, NULL, 'G3DSA:3.40.50.300:FF:001282', NULL, NULL, 'RAB17, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(217302, NULL, 'G3DSA:1.10.630.10:FF:000258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217303, NULL, 'G3DSA:3.40.50.10470:FF:000008', NULL, NULL, 'Translation initiation factor 2B, beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(217304, NULL, 'G3DSA:3.30.70.3250:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217305, NULL, 'G3DSA:1.25.40.990:FF:000018', NULL, NULL, '26S proteasome regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(217306, NULL, 'G3DSA:3.90.550.50:FF:000024', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(217307, NULL, 'G3DSA:3.40.50.300:FF:006661', NULL, NULL, 'RAB20, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(217308, NULL, 'G3DSA:3.30.1370.10:FF:000202', NULL, NULL, 'Vigilin 1', NULL, NULL, NULL, NULL, NULL, 4),
(217309, NULL, 'G3DSA:3.30.65.10:FF:000011', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(217310, NULL, 'G3DSA:3.30.1680.10:FF:000012', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(217311, NULL, 'G3DSA:3.75.10.10:FF:000041', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217312, NULL, 'G3DSA:3.30.160.60:FF:002349', NULL, NULL, 'Zinc finger and BTB domain-containing 40', NULL, NULL, NULL, NULL, NULL, 4),
(217313, NULL, 'G3DSA:3.30.1240.10:FF:000013', NULL, NULL, 'Cof-type HAD-IIB family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(217314, NULL, 'G3DSA:1.10.472.10:FF:000154', NULL, NULL, 'Cyclin-B1-4', NULL, NULL, NULL, NULL, NULL, 4),
(217315, NULL, 'G3DSA:2.130.10.10:FF:004007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217316, NULL, 'G3DSA:3.40.250.10:FF:000248', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217317, NULL, 'G3DSA:3.40.50.1700:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217318, NULL, 'G3DSA:2.30.29.30:FF:001251', NULL, NULL, 'BEACH domain-containing protein lvsB', NULL, NULL, NULL, NULL, NULL, 4),
(217319, NULL, 'G3DSA:2.60.40.10:FF:003102', NULL, NULL, 'Ciliary neurotrophic factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(217320, NULL, 'G3DSA:3.40.50.2300:FF:001335', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217321, NULL, 'G3DSA:3.30.40.10:FF:000460', NULL, NULL, 'Anaphase promoting complex subunit 11', NULL, NULL, NULL, NULL, NULL, 4),
(217322, NULL, 'G3DSA:1.25.40.410:FF:000013', NULL, NULL, 'CED-5', NULL, NULL, NULL, NULL, NULL, 4),
(217323, NULL, 'G3DSA:1.20.1250.20:FF:002336', NULL, NULL, 'Protein CBG12921', NULL, NULL, NULL, NULL, NULL, 4),
(217324, NULL, 'G3DSA:3.40.50.1820:FF:001062', NULL, NULL, 'NonRibosomal Peptide Synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(217325, NULL, 'G3DSA:3.30.465.10:FF:000007', NULL, NULL, 'TerC family inner membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(217326, NULL, 'G3DSA:1.10.510.10:FF:002548', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217327, NULL, 'G3DSA:3.30.70.330:FF:001151', NULL, NULL, 'RNA-binding protein PIN4', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(217328, NULL, 'G3DSA:2.30.30.140:FF:000134', NULL, NULL, 'C.Elegans Chromodomain protein', NULL, NULL, NULL, NULL, NULL, 4),
(217329, NULL, 'G3DSA:2.60.120.200:FF:000179', NULL, NULL, 'Unplaced genomic scaffold supercont1.19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(217330, NULL, 'G3DSA:2.60.40.10:FF:006031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217331, NULL, 'G3DSA:3.30.420.40:FF:000672', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(217332, NULL, 'G3DSA:1.10.510.10:FF:004206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217333, NULL, 'G3DSA:1.10.1370.30:FF:000001', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(217334, NULL, 'G3DSA:3.30.200.20:FF:002425', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217335, NULL, 'G3DSA:3.40.50.1000:FF:000855', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217336, NULL, 'G3DSA:3.40.50.920:FF:000012', NULL, NULL, 'Transketolase, variant 1', NULL, NULL, NULL, NULL, NULL, 4),
(217337, NULL, 'G3DSA:1.25.10.10:FF:002116', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(217338, NULL, 'G3DSA:2.30.30.790:FF:000008', NULL, NULL, 'Mitochondrial ribosomal protein L19', NULL, NULL, NULL, NULL, NULL, 4),
(217339, NULL, 'G3DSA:1.25.40.10:FF:003725', NULL, NULL, 'Transcription factor tau subunit sfc4', NULL, NULL, NULL, NULL, NULL, 4),
(217340, NULL, 'G3DSA:2.40.128.20:FF:000044', NULL, NULL, 'LiPocalin-Related protein', NULL, NULL, NULL, NULL, NULL, 4),
(217341, NULL, 'G3DSA:2.40.50.140:FF:000501', NULL, NULL, 'Cold shock protein', NULL, NULL, NULL, NULL, NULL, 4),
(217342, NULL, 'G3DSA:3.40.50.300:FF:003316', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217343, NULL, 'G3DSA:3.30.160.60:FF:006244', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217344, NULL, 'G3DSA:1.25.10.10:FF:000227', NULL, NULL, 'AP-4 complex subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(217345, NULL, 'G3DSA:2.170.120.30:FF:000009', NULL, NULL, 'Putative exported protein', NULL, NULL, NULL, NULL, NULL, 4),
(217346, NULL, 'G3DSA:3.30.190.20:FF:000012', NULL, NULL, '50S ribosomal protein L1', NULL, NULL, NULL, NULL, NULL, 4),
(217347, NULL, 'G3DSA:1.20.1070.10:FF:001077', NULL, NULL, 'Octopressin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(217348, NULL, 'G3DSA:1.20.1250.20:FF:001555', NULL, NULL, 'YALI0C00847p', NULL, NULL, NULL, NULL, NULL, 4),
(217349, NULL, 'G3DSA:3.50.20.20:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217350, NULL, 'G3DSA:3.40.50.11580:FF:000004', NULL, NULL, 'Polyprotein 1ab', NULL, NULL, NULL, NULL, NULL, 4),
(217351, NULL, 'G3DSA:3.40.50.1010:FF:000004', NULL, NULL, 'rRNA-processing protein FCF1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(217352, NULL, 'G3DSA:3.40.1350.10:FF:000036', NULL, NULL, 'tRNA-splicing endonuclease subunit Sen2', NULL, NULL, NULL, NULL, NULL, 4),
(217353, NULL, 'G3DSA:3.40.1110.10:FF:000294', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217354, NULL, 'G3DSA:3.30.70.20:FF:000054', NULL, NULL, 'NADP-reducing hydrogenase subunit HndC', NULL, NULL, NULL, NULL, NULL, 4),
(217355, NULL, 'G3DSA:3.40.50.300:FF:006806', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217356, NULL, 'G3DSA:3.40.720.10:FF:000357', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(217357, NULL, 'G3DSA:3.40.350.10:FF:000048', NULL, NULL, 'Putative aminopeptidase P1', NULL, NULL, NULL, NULL, NULL, 4),
(217358, NULL, 'G3DSA:3.40.50.150:FF:000472', NULL, NULL, '25S rRNA adenine-N(1) methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(217359, NULL, 'G3DSA:3.30.1490.20:FF:000006', NULL, NULL, 'phosphoribosylamine--glycine ligase, chloroplastic-like', NULL, NULL, NULL, NULL, NULL, 4),
(217360, NULL, 'G3DSA:1.10.168.10:FF:000003', NULL, NULL, 'Phosducin', NULL, NULL, NULL, NULL, NULL, 4),
(217361, NULL, 'G3DSA:3.30.1470.10:FF:000002', NULL, NULL, 'Photosystem I reaction center subunit II', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(217362, NULL, 'G3DSA:2.70.150.10:FF:000007', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(217363, NULL, 'G3DSA:1.25.10.10:FF:001863', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217364, NULL, 'G3DSA:1.10.8.60:FF:000561', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217365, NULL, 'G3DSA:3.80.10.10:FF:002760', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217366, NULL, 'G3DSA:1.10.630.10:FF:000735', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217367, NULL, 'G3DSA:2.40.160.50:FF:000004', NULL, NULL, 'Protein TOC75-3 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(217368, NULL, 'G3DSA:3.40.50.300:FF:001990', NULL, NULL, 'Ras family, other', NULL, NULL, NULL, NULL, NULL, 4),
(217369, NULL, 'G3DSA:1.10.150.80:FF:000040', NULL, NULL, 'RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(217370, NULL, 'G3DSA:1.20.120.150:FF:000005', NULL, NULL, 'GTOR', NULL, NULL, NULL, NULL, NULL, 4),
(217371, NULL, 'G3DSA:2.10.25.10:FF:001170', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(217372, NULL, 'G3DSA:1.10.10.10:FF:000194', NULL, NULL, 'HTH-type transcriptional regulator Hpr', NULL, NULL, NULL, NULL, NULL, 4),
(217373, NULL, 'G3DSA:2.60.120.310:FF:000009', NULL, NULL, 'Monooxygenase, DBH-like 1, like', NULL, NULL, NULL, NULL, NULL, 4),
(217374, NULL, 'G3DSA:3.30.420.10:FF:000281', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217375, NULL, 'G3DSA:3.40.50.1100:FF:000211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217376, NULL, 'G3DSA:3.30.420.40:FF:000817', NULL, NULL, 'Putative nodulation protein nolNO', NULL, NULL, NULL, NULL, NULL, 4),
(217377, NULL, 'G3DSA:3.60.20.10:FF:000007', NULL, NULL, 'Proteasome subunit alpha type', NULL, NULL, NULL, NULL, NULL, 4),
(217378, NULL, 'G3DSA:3.40.50.300:FF:002535', NULL, NULL, 'SMC5 protein', NULL, NULL, NULL, NULL, NULL, 4),
(217379, NULL, 'G3DSA:1.25.10.10:FF:000879', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(217380, NULL, 'G3DSA:3.20.10.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217381, NULL, 'G3DSA:1.20.1560.10:FF:000491', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217382, NULL, 'G3DSA:3.80.10.10:FF:002849', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(217383, NULL, 'G3DSA:1.20.1070.10:FF:000352', NULL, NULL, 'Latrophilin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(217384, NULL, 'G3DSA:1.10.1420.10:FF:000112', NULL, NULL, 'Muts domain V-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(217385, NULL, 'G3DSA:1.10.8.270:FF:000073', NULL, NULL, 'TBC1 domain family, member 22B', NULL, NULL, NULL, NULL, NULL, 4),
(217386, NULL, 'G3DSA:3.30.890.10:FF:000012', NULL, NULL, 'Methyl-CpG-binding domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(217387, NULL, 'G3DSA:1.10.8.10:FF:000243', NULL, NULL, 'YALI0E14927p', NULL, NULL, NULL, NULL, NULL, 4),
(217388, NULL, 'G3DSA:3.10.310.20:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217389, NULL, 'G3DSA:3.90.1290.10:FF:000042', NULL, NULL, 'Dystonin', NULL, NULL, NULL, NULL, NULL, 4),
(217390, NULL, 'G3DSA:3.30.70.580:FF:000045', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(217391, NULL, 'G3DSA:2.60.40.150:FF:000099', NULL, NULL, 'Copine 3', NULL, NULL, NULL, NULL, NULL, 4),
(217392, NULL, 'G3DSA:1.10.472.130:FF:000030', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(217393, NULL, 'G3DSA:2.120.10.30:FF:000091', NULL, NULL, 'Aminopeptidase C', NULL, NULL, NULL, NULL, NULL, 4),
(217394, NULL, 'G3DSA:2.80.10.50:FF:000110', NULL, NULL, 'Mannose receptor, C type 1a', NULL, NULL, NULL, NULL, NULL, 4),
(217395, NULL, 'G3DSA:1.25.40.10:FF:002472', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g13650', NULL, NULL, NULL, NULL, NULL, 4),
(217396, NULL, 'G3DSA:3.30.160.20:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(217397, NULL, 'G3DSA:3.10.196.10:FF:000004', NULL, NULL, 'Methionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(217398, NULL, 'G3DSA:3.30.40.230:FF:000007', NULL, NULL, 'Glycine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(217399, NULL, 'G3DSA:1.10.1070.11:FF:000075', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(217400, NULL, 'G3DSA:2.20.25.10:FF:000101', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(217401, NULL, 'G3DSA:3.50.40.10:FF:000003', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(217402, NULL, 'G3DSA:1.20.1280.290:FF:000005', NULL, NULL, 'PQ-loop repeat-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(217403, NULL, 'G3DSA:1.10.472.10:FF:000098', NULL, NULL, 'Cyclin N-terminal domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(217404, NULL, 'G3DSA:3.30.1550.10:FF:000003', NULL, NULL, '39S ribosomal protein L11, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(217405, NULL, 'G3DSA:3.40.50.300:FF:005733', NULL, NULL, 'tRNA 2-selenouridine/geranyl-2-thiouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(217406, NULL, 'G3DSA:1.10.245.10:FF:000003', NULL, NULL, 'Zinc finger CCCH domain-containing protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(217407, NULL, 'G3DSA:3.40.50.720:FF:001380', NULL, NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(217408, NULL, 'G3DSA:1.25.40.10:FF:004653', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217409, NULL, 'G3DSA:1.10.268.10:FF:000039', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217410, NULL, 'G3DSA:1.10.287.130:FF:000102', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(217411, NULL, 'G3DSA:3.80.10.10:FF:002052', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(217412, NULL, 'G3DSA:3.30.160.60:FF:001129', NULL, NULL, 'zinc finger protein 181 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(217413, NULL, 'G3DSA:3.10.20.10:FF:000032', NULL, NULL, '60S ribosomal protein L18a', NULL, NULL, NULL, NULL, NULL, 4),
(217414, NULL, 'G3DSA:1.20.120.350:FF:000149', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217415, NULL, 'G3DSA:3.30.830.10:FF:000267', NULL, NULL, 'Clan ME, family M16, insulinase-like metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(217416, NULL, 'G3DSA:3.80.10.10:FF:001068', NULL, NULL, 'Leucine-rich repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(217417, NULL, 'G3DSA:3.40.30.10:FF:000638', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217418, NULL, 'G3DSA:3.40.50.20:FF:000030', NULL, NULL, 'Phosphoribosylaminoimidazole carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(217419, NULL, 'G3DSA:3.30.1390.10:FF:000001', NULL, NULL, '50S ribosomal protein L7/L12', NULL, NULL, NULL, NULL, NULL, 4),
(217420, NULL, 'G3DSA:2.60.40.420:FF:000056', NULL, NULL, 'Coagulation factor V', NULL, NULL, NULL, NULL, NULL, 4),
(217421, NULL, 'G3DSA:3.40.50.300:FF:000354', NULL, NULL, 'ATP-dependent RNA helicase SKI2', NULL, NULL, NULL, NULL, NULL, 4),
(217422, NULL, 'G3DSA:3.40.50.300:FF:004188', NULL, NULL, 'Adenosinetriphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(217423, NULL, 'G3DSA:3.40.50.1000:FF:000327', NULL, NULL, 'Probable sucrose-phosphate synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(217424, NULL, 'G3DSA:1.10.10.10:FF:000755', NULL, NULL, 'Carbohydrate kinase, PfkB family', NULL, NULL, NULL, NULL, NULL, 4),
(217425, NULL, 'G3DSA:3.30.160.60:FF:001837', NULL, NULL, 'Zgc:110821', NULL, NULL, NULL, NULL, NULL, 4),
(217426, NULL, 'G3DSA:1.20.1420.30:FF:000048', NULL, NULL, 'Cation/calcium exchanger 5', NULL, NULL, NULL, NULL, NULL, 4),
(217427, NULL, 'G3DSA:3.40.50.1820:FF:000713', NULL, NULL, 'YALI0E05907p', NULL, NULL, NULL, NULL, NULL, 4),
(217428, NULL, 'G3DSA:1.20.5.340:FF:000029', NULL, NULL, 'Coiled-coil domain-containing protein 90-like', NULL, NULL, NULL, NULL, NULL, 4),
(217429, NULL, 'G3DSA:1.25.40.10:FF:004130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(217430, NULL, 'G3DSA:1.10.472.10:FF:000418', NULL, NULL, 'Cyclin domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(217431, NULL, 'G3DSA:2.130.10.10:FF:000972', NULL, NULL, 'Tumor suppressing subtransferable candidate 1', NULL, NULL, NULL, NULL, NULL, 4),
(217432, NULL, 'G3DSA:2.120.10.30:FF:000467', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217433, NULL, 'G3DSA:3.40.50.150:FF:001692', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217434, NULL, 'G3DSA:3.40.50.300:FF:005025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217435, NULL, 'G3DSA:3.90.1010.10:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217436, NULL, 'G3DSA:2.30.29.30:FF:000323', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(217437, NULL, 'G3DSA:3.30.310.80:FF:000012', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(217438, NULL, 'G3DSA:1.20.1070.10:FF:000728', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217439, NULL, 'G3DSA:3.30.40.10:FF:002258', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(217440, NULL, 'G3DSA:3.40.850.10:FF:000305', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(217441, NULL, 'G3DSA:3.10.20.810:FF:000002', NULL, NULL, 'Histidine biosynthesis trifunctional protein', NULL, NULL, NULL, NULL, NULL, 4),
(217442, NULL, 'G3DSA:1.10.10.2660:FF:000006', NULL, NULL, 'Ubiquitin modifier-activating enzyme 1', NULL, NULL, NULL, NULL, NULL, 4),
(217443, NULL, 'G3DSA:3.30.590.50:FF:000012', NULL, NULL, 'Gamma-glutamylcysteine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(217444, NULL, 'G3DSA:3.40.50.720:FF:001469', NULL, NULL, 'Hypothetical pyrroline-5-carboxylate reductase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(217445, NULL, 'G3DSA:2.130.10.10:FF:000264', NULL, NULL, 'WD repeat and SOCS box containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(217446, NULL, 'G3DSA:3.30.260.10:FF:000094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217447, NULL, 'G3DSA:3.30.160.60:FF:002821', NULL, NULL, 'Transcriptional regulator MET32', NULL, NULL, NULL, NULL, NULL, 4),
(217448, NULL, 'G3DSA:1.25.40.10:FF:002505', NULL, NULL, 'Clustered mitochondria protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(217449, NULL, 'G3DSA:1.20.120.1750:FF:000014', NULL, NULL, 'Cullin 9', NULL, NULL, NULL, NULL, NULL, 4),
(217450, NULL, 'G3DSA:3.30.540.10:FF:000076', NULL, NULL, '3''(2''),5''-bisphosphate nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(217451, NULL, 'G3DSA:3.40.50.300:FF:008459', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217452, NULL, 'G3DSA:1.10.10.60:FF:000253', NULL, NULL, 'Transcriptional regulator, AraC family', NULL, NULL, NULL, NULL, NULL, 4),
(217453, NULL, 'G3DSA:1.10.2000.10:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217454, NULL, 'G3DSA:2.20.110.10:FF:000027', NULL, NULL, 'Phosphatidylinositol 4-phosphate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(217455, NULL, 'G3DSA:2.130.10.10:FF:003698', NULL, NULL, 'NACHT domain- and WD repeat-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(217456, NULL, 'G3DSA:3.30.860.10:FF:000004', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(217457, NULL, 'G3DSA:1.25.40.10:FF:000235', NULL, NULL, 'MAU2 sister chromatid cohesion factor', NULL, NULL, NULL, NULL, NULL, 4),
(217458, NULL, 'G3DSA:1.20.120.430:FF:000022', NULL, NULL, 'tRNA modification GTPase MnmE', NULL, NULL, NULL, NULL, NULL, 4),
(217459, NULL, 'G3DSA:1.50.10.10:FF:000107', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(217460, NULL, 'G3DSA:1.25.40.210:FF:000009', NULL, NULL, 'Telomeric repeat-binding factor', NULL, NULL, NULL, NULL, NULL, 4),
(217461, NULL, 'G3DSA:1.20.1070.10:FF:001841', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(217462, NULL, 'G3DSA:3.40.50.11260:FF:000026', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(217463, NULL, 'G3DSA:3.30.160.60:FF:004951', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217464, NULL, 'G3DSA:1.20.58.860:FF:000011', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(217465, NULL, 'G3DSA:1.10.455.10:FF:000013', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(217466, NULL, 'G3DSA:3.60.10.10:FF:000237', NULL, NULL, '2'',5''-phosphodiesterase 12', NULL, NULL, NULL, NULL, NULL, 4),
(217467, NULL, 'G3DSA:1.10.530.10:FF:000082', NULL, NULL, 'Chitinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(217468, NULL, 'G3DSA:3.10.110.10:FF:000037', NULL, NULL, 'ubiquitin-conjugating enzyme E2 27', NULL, NULL, NULL, NULL, NULL, 4),
(217469, NULL, 'G3DSA:1.10.510.10:FF:001952', NULL, NULL, 'Protein kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(217470, NULL, 'G3DSA:3.90.550.10:FF:000327', NULL, NULL, 'Minor teichoic acid biosynthesis protein GgaB', NULL, NULL, NULL, NULL, NULL, 4),
(217471, NULL, 'G3DSA:2.130.10.10:FF:000500', NULL, NULL, 'Neutral sphingomyelinase activation associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(217472, NULL, 'G3DSA:3.40.50.620:FF:000192', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(217473, NULL, 'G3DSA:3.40.50.10810:FF:000009', NULL, NULL, 'B-TFIID TATA-box-binding protein-associated factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(217474, NULL, 'G3DSA:1.10.132.60:FF:000014', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(217475, NULL, 'G3DSA:2.20.100.10:FF:000201', NULL, NULL, 'Thrombospondin type-1 domain-containing protein 7B', NULL, NULL, NULL, NULL, NULL, 4),
(217476, NULL, 'G3DSA:1.10.10.10:FF:001716', NULL, NULL, 'Regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(217477, NULL, 'G3DSA:2.60.120.650:FF:000061', NULL, NULL, 'Glucosamine 6-phosphate N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(217478, NULL, 'G3DSA:4.10.1060.10:FF:000014', NULL, NULL, 'Putative zinc finger, RanBP2-type', NULL, NULL, NULL, NULL, NULL, 4),
(217479, NULL, 'G3DSA:3.30.710.10:FF:000292', NULL, NULL, 'Similar to TD and POZ domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(217480, NULL, 'G3DSA:2.170.270.10:FF:000065', NULL, NULL, 'Histone-lysine N-methyltransferase ATXR3', NULL, NULL, NULL, NULL, NULL, 4),
(217481, NULL, 'G3DSA:2.60.40.10:FF:000663', NULL, NULL, 'myelin-associated glycoprotein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(217482, NULL, 'G3DSA:2.130.10.10:FF:005699', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217483, NULL, 'G3DSA:1.20.1260.140:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217484, NULL, 'G3DSA:3.40.50.200:FF:000094', NULL, NULL, 'Serine protease (Putative secreted protein)', NULL, NULL, NULL, NULL, NULL, 4),
(217485, NULL, 'G3DSA:3.40.50.300:FF:004244', NULL, NULL, 'RAD51 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(217486, NULL, 'G3DSA:1.20.1200.10:FF:000003', NULL, NULL, 'ATP:cob(I)alamin adenosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(217487, NULL, 'G3DSA:2.40.320.10:FF:000027', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 18', NULL, NULL, NULL, NULL, NULL, 4),
(217488, NULL, 'G3DSA:1.10.1200.10:FF:000096', NULL, NULL, 'Anthracycline acyl carrier protein DauA', NULL, NULL, NULL, NULL, NULL, 4),
(217489, NULL, 'G3DSA:3.40.50.2300:FF:000610', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(217490, NULL, 'G3DSA:1.25.40.10:FF:004506', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217491, NULL, 'G3DSA:3.30.930.10:FF:000364', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217492, NULL, 'G3DSA:3.40.50.1820:FF:001585', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217493, NULL, 'G3DSA:2.10.25.10:FF:000618', NULL, NULL, 'Fibrillin 3', NULL, NULL, NULL, NULL, NULL, 4),
(217494, NULL, 'G3DSA:1.20.1070.10:FF:002061', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(217495, NULL, 'G3DSA:3.30.565.10:FF:000335', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(217496, NULL, 'G3DSA:1.25.40.10:FF:000763', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(217497, NULL, 'G3DSA:3.90.70.10:FF:000178', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase cyk-3', NULL, NULL, NULL, NULL, NULL, 4),
(217498, NULL, 'G3DSA:2.60.120.330:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217499, NULL, 'G3DSA:3.40.50.11370:FF:000003', NULL, NULL, 'Inositol-tetrakisphosphate 1-kinase isoform a', NULL, NULL, NULL, NULL, NULL, 4),
(217500, NULL, 'G3DSA:1.10.510.10:FF:004173', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217501, NULL, 'G3DSA:1.25.40.20:FF:000709', NULL, NULL, 'Calcium transporter 2', NULL, NULL, NULL, NULL, NULL, 4),
(217502, NULL, 'G3DSA:1.10.287.110:FF:000416', NULL, NULL, 'Heat shock protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(217503, NULL, 'G3DSA:2.120.10.30:FF:000411', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217504, NULL, 'G3DSA:3.40.50.1220:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217505, NULL, 'G3DSA:1.20.58.60:FF:000290', NULL, NULL, 'Spectrin repeat containing nuclear envelope protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(217506, NULL, 'G3DSA:3.40.50.300:FF:006189', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(217507, NULL, 'G3DSA:3.40.50.300:FF:008083', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(217508, NULL, 'G3DSA:1.20.144.10:FF:000042', NULL, NULL, 'PAP2 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(217509, NULL, 'G3DSA:3.30.160.60:FF:005171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217510, NULL, 'G3DSA:3.30.1120.130:FF:000005', NULL, NULL, 'AGAP012499-PA', NULL, NULL, NULL, NULL, NULL, 4),
(217511, NULL, 'G3DSA:3.30.30.30:FF:000026', NULL, NULL, 'Protein CBG00051', NULL, NULL, NULL, NULL, NULL, 4),
(217512, NULL, 'G3DSA:3.30.565.10:FF:000482', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217513, NULL, 'G3DSA:3.90.870.10:FF:000019', NULL, NULL, 'Translation factor Sua5', NULL, NULL, NULL, NULL, NULL, 4),
(217514, NULL, 'G3DSA:4.10.400.10:FF:000342', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217515, NULL, 'G3DSA:1.20.1070.10:FF:001656', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217516, NULL, 'G3DSA:3.30.70.100:FF:000059', NULL, NULL, 'protein NipSnap homolog 3A isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(217517, NULL, 'G3DSA:1.10.246.130:FF:000015', NULL, NULL, 'Gamma-glutamyltransferase 5', NULL, NULL, NULL, NULL, NULL, 4),
(217518, NULL, 'G3DSA:3.40.30.10:FF:000790', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(217519, NULL, 'G3DSA:2.40.50.140:FF:000181', NULL, NULL, 'CST complex subunit STN1', NULL, NULL, NULL, NULL, NULL, 4),
(217520, NULL, 'G3DSA:3.80.10.10:FF:001124', NULL, NULL, 'Os06g0692100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(217521, NULL, 'G3DSA:1.10.1420.10:FF:000168', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(217522, NULL, 'G3DSA:1.10.150.50:FF:000109', NULL, NULL, 'Ste50p', NULL, NULL, NULL, NULL, NULL, 4),
(217523, NULL, 'G3DSA:2.60.60.30:FF:000001', NULL, NULL, 'Tellurium resistance protein TerD', NULL, NULL, NULL, NULL, NULL, 4),
(217524, NULL, 'G3DSA:3.40.50.720:FF:000452', NULL, NULL, 'Malate dehydrogenase (NAD)', NULL, NULL, NULL, NULL, NULL, 4),
(217525, NULL, 'G3DSA:2.30.30.1020:FF:000010', NULL, NULL, 'CCR4-NOT transcription complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(217526, NULL, 'G3DSA:3.40.50.1820:FF:001641', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217527, NULL, 'G3DSA:3.10.110.10:FF:000222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217528, NULL, 'G3DSA:2.40.50.140:FF:000557', NULL, NULL, '30S ribosomal protein S17', NULL, NULL, NULL, NULL, NULL, 4),
(217529, NULL, 'G3DSA:2.60.40.1090:FF:000041', NULL, NULL, 'Fimbrial subunit CupA4', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(217530, NULL, 'G3DSA:3.30.70.660:FF:000058', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(217531, NULL, 'G3DSA:1.10.287.550:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217532, NULL, 'G3DSA:1.10.510.10:FF:000991', NULL, NULL, 'CAMK/CDPK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(217533, NULL, 'G3DSA:2.60.40.1400:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217534, NULL, 'G3DSA:3.30.830.10:FF:000323', NULL, NULL, 'Presequence protease', NULL, NULL, NULL, NULL, NULL, 4),
(217535, NULL, 'G3DSA:1.10.10.10:FF:000699', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(217536, NULL, 'G3DSA:3.40.50.10490:FF:000166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217537, NULL, 'G3DSA:3.80.10.10:FF:003777', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217538, NULL, 'G3DSA:2.10.50.10:FF:000042', NULL, NULL, 'Signal peptide, CUB domain and EGF like domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(217539, NULL, 'G3DSA:1.10.287.70:FF:000522', NULL, NULL, 'Receptor for egg jelly 6', NULL, NULL, NULL, NULL, NULL, 4),
(217540, NULL, 'G3DSA:3.40.50.1820:FF:001438', NULL, NULL, 'Lipase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(217541, NULL, 'G3DSA:3.10.490.20:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217542, NULL, 'G3DSA:3.40.50.1110:FF:000124', NULL, NULL, 'Probable cytochrome c', NULL, NULL, NULL, NULL, NULL, 4),
(217543, NULL, 'G3DSA:3.50.50.60:FF:000614', NULL, NULL, 'Salicylate hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(217544, NULL, 'G3DSA:3.30.40.10:FF:001533', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217545, NULL, 'G3DSA:3.30.160.60:FF:004619', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217546, NULL, 'G3DSA:3.90.1310.10:FF:000011', NULL, NULL, 'Penicillin-binding protein 2B', NULL, NULL, NULL, NULL, NULL, 4),
(217547, NULL, 'G3DSA:1.25.40.20:FF:000856', NULL, NULL, 'Leucine-rich repeat serine/threonine-protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(217548, NULL, 'G3DSA:4.10.640.10:FF:000028', NULL, NULL, 'ADL117Wp', NULL, NULL, NULL, NULL, NULL, 4),
(217549, NULL, 'G3DSA:2.60.40.10:FF:004406', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217550, NULL, 'G3DSA:3.30.70.330:FF:001656', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217551, NULL, 'G3DSA:3.90.226.10:FF:000057', NULL, NULL, 'Protease 4', NULL, NULL, NULL, NULL, NULL, 4),
(217552, NULL, 'G3DSA:2.40.70.10:FF:000418', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217553, NULL, 'G3DSA:3.30.2290.10:FF:000022', NULL, NULL, 'Zinc protease PmbA, putative', NULL, NULL, NULL, NULL, NULL, 4),
(217554, NULL, 'G3DSA:3.10.450.50:FF:000080', NULL, NULL, 'ECF RNA polymerase sigma factor SigJ', NULL, NULL, NULL, NULL, NULL, 4),
(217555, NULL, 'G3DSA:3.40.50.300:FF:005205', NULL, NULL, 'Ras2p', NULL, NULL, NULL, NULL, NULL, 4),
(217556, NULL, 'G3DSA:2.10.70.40:FF:000001', NULL, NULL, 'Flagellar assembly peptidoglycan hydrolase FlgJ', NULL, NULL, NULL, NULL, NULL, 4),
(217557, NULL, 'G3DSA:3.40.920.10:FF:000013', NULL, NULL, 'Indolepyruvate oxidoreductase, IorB subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(217558, NULL, 'G3DSA:3.40.50.1000:FF:000147', NULL, NULL, 'H/K ATPase alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(217559, NULL, 'G3DSA:1.10.238.10:FF:000739', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(217560, NULL, 'G3DSA:3.30.1360.70:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217561, NULL, 'G3DSA:2.130.10.10:FF:004715', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217562, NULL, 'G3DSA:3.30.160.60:FF:000909', NULL, NULL, 'zinc finger and BTB domain-containing protein 40', NULL, NULL, NULL, NULL, NULL, 4),
(217563, NULL, 'G3DSA:1.25.10.10:FF:000935', NULL, NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(217564, NULL, 'G3DSA:1.10.20.10:FF:000020', NULL, NULL, 'Histone H2A', NULL, NULL, NULL, NULL, NULL, 4),
(217565, NULL, 'G3DSA:3.40.50.2300:FF:000554', NULL, NULL, 'Two-component response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(217566, NULL, 'G3DSA:3.90.70.10:FF:000234', NULL, NULL, 'Ubiquitin specific peptidase 26', NULL, NULL, NULL, NULL, NULL, 4),
(217567, NULL, 'G3DSA:1.10.30.50:FF:000010', NULL, NULL, 'HNH endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(217568, NULL, 'G3DSA:3.10.20.90:FF:000977', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217569, NULL, 'G3DSA:3.40.50.1360:FF:000002', NULL, NULL, 'Glucosamine-6-phosphate deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(217570, NULL, 'G3DSA:2.60.40.380:FF:000004', NULL, NULL, 'Purple acid phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(217571, NULL, 'G3DSA:4.10.240.10:FF:000155', NULL, NULL, 'SfgA', NULL, NULL, NULL, NULL, NULL, 4),
(217572, NULL, 'G3DSA:3.40.50.300:FF:007678', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217573, NULL, 'G3DSA:3.30.160.60:FF:000348', NULL, NULL, 'zinc finger protein 260', NULL, NULL, NULL, NULL, NULL, 4),
(217574, NULL, 'G3DSA:1.20.1250.20:FF:001611', NULL, NULL, 'Uncharacterized protein P0668F02.8', NULL, NULL, NULL, NULL, NULL, 4),
(217575, NULL, 'G3DSA:1.10.510.10:FF:000283', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(217576, NULL, 'G3DSA:2.60.40.60:FF:000829', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217577, NULL, 'G3DSA:3.80.10.10:FF:000719', NULL, NULL, 'MDIS1-interacting receptor like kinase 2 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(217578, NULL, 'G3DSA:3.40.350.10:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217579, NULL, 'G3DSA:3.30.160.60:FF:000404', NULL, NULL, 'POZ-, AT hook-, and zinc finger-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(217580, NULL, 'G3DSA:3.90.215.10:FF:000009', NULL, NULL, 'Fibrinogen alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(217581, NULL, 'G3DSA:3.10.20.90:FF:000449', NULL, NULL, 'Fra2p', NULL, NULL, NULL, NULL, NULL, 4),
(217582, NULL, 'G3DSA:1.10.8.60:FF:000033', NULL, NULL, 'paraplegin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(217583, NULL, 'G3DSA:3.40.50.720:FF:002397', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217584, NULL, 'G3DSA:3.40.50.10330:FF:000056', NULL, NULL, 'Yef1p', NULL, NULL, NULL, NULL, NULL, 4),
(217585, NULL, 'G3DSA:3.30.40.10:FF:001909', NULL, NULL, 'VPS8, CORVET complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(217586, NULL, 'G3DSA:1.25.40.770:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217587, NULL, 'G3DSA:1.20.58.1120:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217588, NULL, 'G3DSA:3.30.200.20:FF:001700', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217589, NULL, 'G3DSA:1.20.80.10:FF:000040', NULL, NULL, 'Acyl-CoA-binding domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(217590, NULL, 'G3DSA:2.40.70.10:FF:000570', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217591, NULL, 'G3DSA:1.10.3660.10:FF:000006', NULL, NULL, 'Prephenate dehydrogenase [NADP(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(217592, NULL, 'G3DSA:4.10.280.50:FF:000006', NULL, NULL, 'Glutamate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(217593, NULL, 'G3DSA:4.10.240.10:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217594, NULL, 'G3DSA:1.10.510.10:FF:000463', NULL, NULL, 'Serine/threonine-protein kinase/endoribonuclease IRE1a', NULL, NULL, NULL, NULL, NULL, 4),
(217595, NULL, 'G3DSA:2.30.30.40:FF:000453', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(217596, NULL, 'G3DSA:1.20.1250.20:FF:000627', NULL, NULL, 'GEX1p Proton:glutathione antiporter', NULL, NULL, NULL, NULL, NULL, 4),
(217597, NULL, 'G3DSA:1.10.506.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(217598, NULL, 'G3DSA:2.30.30.40:FF:000397', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(217599, NULL, 'G3DSA:1.20.5.110:FF:000253', NULL, NULL, 'Syntaxin 2a', NULL, NULL, NULL, NULL, NULL, 4),
(217600, NULL, 'G3DSA:1.10.2020.20:FF:000006', NULL, NULL, 'Proteasomal ubiquitin receptor ADRM1', NULL, NULL, NULL, NULL, NULL, 4),
(217601, NULL, 'G3DSA:2.130.10.10:FF:004154', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217602, NULL, 'G3DSA:3.80.10.10:FF:001832', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217603, NULL, 'G3DSA:3.60.21.10:FF:000318', NULL, NULL, 'Metallo-dependent phosphatase-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(217604, NULL, 'G3DSA:3.40.30.10:FF:001043', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(217605, NULL, 'G3DSA:3.10.250.10:FF:000108', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217606, NULL, 'G3DSA:3.10.100.10:FF:000396', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217607, NULL, 'G3DSA:3.40.50.620:FF:000568', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217608, NULL, 'G3DSA:1.10.238.10:FF:000363', NULL, NULL, 'Endoplasmic reticulum-resident calcium binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(217609, NULL, 'G3DSA:1.10.150.20:FF:000005', NULL, NULL, 'UvrABC system protein C', NULL, NULL, NULL, NULL, NULL, 4),
(217610, NULL, 'G3DSA:3.40.1010.10:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217611, NULL, 'G3DSA:3.40.50.1380:FF:000008', NULL, NULL, 'Methylglyoxal synthase', NULL, NULL, NULL, NULL, NULL, 4),
(217612, NULL, 'G3DSA:3.30.430.20:FF:000020', NULL, NULL, 'Cysteine-rich repeat secretory protein 60', NULL, NULL, NULL, NULL, NULL, 4),
(217613, NULL, 'G3DSA:2.60.40.10:FF:004030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217614, NULL, 'G3DSA:2.130.10.10:FF:003226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217615, NULL, 'G3DSA:1.25.40.10:FF:003489', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217616, NULL, 'G3DSA:1.20.1330.10:FF:000007', NULL, NULL, 'Flagellar hook-associated protein FlgL', NULL, NULL, NULL, NULL, NULL, 4),
(217617, NULL, 'G3DSA:3.40.50.300:FF:000534', NULL, NULL, 'Heparan sulfate 2-O-sulfotransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(217618, NULL, 'G3DSA:3.80.10.10:FF:001647', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217619, NULL, 'G3DSA:3.30.230.10:FF:000266', NULL, NULL, 'Probable 40S ribosomal protein S9, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(217620, NULL, 'G3DSA:3.90.1150.10:FF:000532', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217621, NULL, 'G3DSA:2.130.10.10:FF:003754', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217622, NULL, 'G3DSA:3.30.30.10:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217623, NULL, 'G3DSA:1.50.10.150:FF:000003', NULL, NULL, 'S-type anion channel SLAH1', NULL, NULL, NULL, NULL, NULL, 4),
(217624, NULL, 'G3DSA:1.20.272.10:FF:000064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217625, NULL, 'G3DSA:1.10.510.10:FF:000316', NULL, NULL, 'serine/threonine-protein kinase HT1', NULL, NULL, NULL, NULL, NULL, 4),
(217626, NULL, 'G3DSA:2.40.100.10:FF:000011', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase A', NULL, NULL, NULL, NULL, NULL, 4),
(217627, NULL, 'G3DSA:3.40.50.300:FF:003991', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(217628, NULL, 'G3DSA:3.30.160.60:FF:004766', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217629, NULL, 'G3DSA:1.20.58.60:FF:000795', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217630, NULL, 'G3DSA:3.30.160.60:FF:003990', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217631, NULL, 'G3DSA:3.30.70.330:FF:002584', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217632, NULL, 'G3DSA:4.10.800.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(217633, NULL, 'G3DSA:1.10.3580.10:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217634, NULL, 'G3DSA:3.10.450.50:FF:000113', NULL, NULL, 'Diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(217635, NULL, 'G3DSA:3.90.1300.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217636, NULL, 'G3DSA:3.40.50.1000:FF:000799', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217637, NULL, 'G3DSA:2.40.70.10:FF:000385', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217638, NULL, 'G3DSA:3.30.70.1180:FF:000018', NULL, NULL, 'V-type proton ATPase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(217639, NULL, 'G3DSA:2.40.290.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217640, NULL, 'G3DSA:3.30.160.60:FF:004390', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217641, NULL, 'G3DSA:1.10.1200.10:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217642, NULL, 'G3DSA:1.25.40.10:FF:001016', NULL, NULL, 'Selenium-binding protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(217643, NULL, 'G3DSA:3.40.50.1110:FF:000068', NULL, NULL, 'PAFAH1B2 isoform 6', NULL, NULL, NULL, NULL, NULL, 4),
(217644, NULL, 'G3DSA:3.30.200.20:FF:000008', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(217645, NULL, 'G3DSA:3.40.50.10190:FF:000290', NULL, NULL, 'DNA ligase 4', NULL, NULL, NULL, NULL, NULL, 4),
(217646, NULL, 'G3DSA:2.60.40.2860:FF:000021', NULL, NULL, 'Transmission-blocking target antigen S230', NULL, NULL, NULL, NULL, NULL, 4),
(217647, NULL, 'G3DSA:2.170.130.10:FF:000027', NULL, NULL, 'Heme receptor HutR', NULL, NULL, NULL, NULL, NULL, 4),
(217648, NULL, 'G3DSA:1.25.10.10:FF:000407', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217649, NULL, 'G3DSA:1.10.1070.11:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217650, NULL, 'G3DSA:3.10.129.10:FF:000063', NULL, NULL, 'Acyl-CoA thioester hydrolase, YbgC/YbaW family', NULL, NULL, NULL, NULL, NULL, 4),
(217651, NULL, 'G3DSA:1.10.510.10:FF:000839', NULL, NULL, 'Spire type actin nucleation factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(217652, NULL, 'G3DSA:2.10.25.10:FF:000242', NULL, NULL, 'Laminin subunit alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(217653, NULL, 'G3DSA:1.10.418.10:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217654, NULL, 'G3DSA:1.10.8.720:FF:000016', NULL, NULL, 'Putative dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(217655, NULL, 'G3DSA:1.10.510.10:FF:004026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217656, NULL, 'G3DSA:3.40.1190.20:FF:000127', NULL, NULL, 'Sugar kinase', NULL, NULL, NULL, NULL, NULL, 4),
(217657, NULL, 'G3DSA:3.40.50.2020:FF:000032', NULL, NULL, 'ribose-phosphate pyrophosphokinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(217658, NULL, 'G3DSA:3.30.2130.10:FF:000005', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(217659, NULL, 'G3DSA:3.90.226.10:FF:000237', NULL, NULL, 'Amino acid adenylation domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(217660, NULL, 'G3DSA:1.25.40.20:FF:000676', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217661, NULL, 'G3DSA:3.40.190.10:FF:000625', NULL, NULL, 'Glutamate receptor 2.8', NULL, NULL, NULL, NULL, NULL, 4),
(217662, NULL, 'G3DSA:2.30.180.10:FF:000164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217663, NULL, 'G3DSA:1.10.3210.10:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217664, NULL, 'G3DSA:3.80.10.10:FF:001271', NULL, NULL, 'Chitin binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(217665, NULL, 'G3DSA:1.25.40.10:FF:002000', NULL, NULL, 'Suppressor of RPS4-RLD 1', NULL, NULL, NULL, NULL, NULL, 4),
(217666, NULL, 'G3DSA:3.90.660.10:FF:000009', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(217667, NULL, 'G3DSA:3.40.630.10:FF:000474', NULL, NULL, 'Glutaminyl-peptide cyclotransferase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(217668, NULL, 'G3DSA:3.30.2300.10:FF:000018', NULL, NULL, 'tRNA(cytosine(8)) deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(217669, NULL, 'G3DSA:3.90.1750.10:FF:000066', NULL, NULL, 'E3 ubiquitin-protein ligase UBR5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(217670, NULL, 'G3DSA:3.40.50.170:FF:000006', NULL, NULL, 'Trifunctional purine biosynthetic protein adenosine-3', NULL, NULL, NULL, NULL, NULL, 4),
(217671, NULL, 'G3DSA:1.10.510.10:FF:001300', NULL, NULL, 'Serine/threonine-protein kinase csk1', NULL, NULL, NULL, NULL, NULL, 4),
(217672, NULL, 'G3DSA:3.40.190.10:FF:000810', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(217673, NULL, 'G3DSA:2.40.30.180:FF:000014', NULL, NULL, 'Ube1l', NULL, NULL, NULL, NULL, NULL, 4),
(217674, NULL, 'G3DSA:3.40.50.300:FF:002299', NULL, NULL, 'Rab family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(217675, NULL, 'G3DSA:2.130.10.10:FF:003193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217676, NULL, 'G3DSA:4.10.320.10:FF:000009', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(217677, NULL, 'G3DSA:2.30.39.10:FF:000161', NULL, NULL, 'Serine protease inhibitor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(217678, NULL, 'G3DSA:3.40.50.2000:FF:001015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217679, NULL, 'G3DSA:2.60.40.150:FF:000020', NULL, NULL, 'C2 calcium dependent domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(217680, NULL, 'G3DSA:3.40.630.30:FF:000328', NULL, NULL, 'Phosphinothricin acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(217681, NULL, 'G3DSA:4.10.1240.50:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217682, NULL, 'G3DSA:2.40.30.130:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217683, NULL, 'G3DSA:3.40.50.1000:FF:000086', NULL, NULL, 'LD24878p', NULL, NULL, NULL, NULL, NULL, 4),
(217684, NULL, 'G3DSA:3.30.1370.110:FF:000015', NULL, NULL, 'CUE2p protein', NULL, NULL, NULL, NULL, NULL, 4),
(217685, NULL, 'G3DSA:2.30.29.30:FF:000402', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(217686, NULL, 'G3DSA:1.25.10.10:FF:000907', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(217687, NULL, 'G3DSA:1.10.10.10:FF:001828', NULL, NULL, 'Helicase', NULL, NULL, NULL, NULL, NULL, 4),
(217688, NULL, 'G3DSA:2.10.25.10:FF:000742', NULL, NULL, 'Crumbs cell polarity complex component 1', NULL, NULL, NULL, NULL, NULL, 4),
(217689, NULL, 'G3DSA:3.30.200.20:FF:000155', NULL, NULL, 'CaM kinase-like vesicle-associated, like', NULL, NULL, NULL, NULL, NULL, 4),
(217690, NULL, 'G3DSA:3.30.590.10:FF:000028', NULL, NULL, 'Putative glutamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(217691, NULL, 'G3DSA:1.10.10.1100:FF:000011', NULL, NULL, 'Sarcosine oxidase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(217692, NULL, 'G3DSA:3.30.9.10:FF:000128', NULL, NULL, 'D-amino-acid oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(217693, NULL, 'G3DSA:2.60.40.60:FF:000397', NULL, NULL, 'Fat-like cadherin-related tumor suppressor homolog', NULL, NULL, NULL, NULL, NULL, 4),
(217694, NULL, 'G3DSA:1.25.40.10:FF:004097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217695, NULL, 'G3DSA:3.30.70.330:FF:000403', NULL, NULL, 'Bruno-3, isoform O', NULL, NULL, NULL, NULL, NULL, 4),
(217696, NULL, 'G3DSA:3.40.30.10:FF:000615', NULL, NULL, 'AT3g27570/MMJ24_12', NULL, NULL, NULL, NULL, NULL, 4),
(217697, NULL, 'G3DSA:2.130.10.10:FF:000028', NULL, NULL, 'semaphorin-6A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(217698, NULL, 'G3DSA:3.30.910.20:FF:000006', NULL, NULL, 'OmpH family outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(217699, NULL, 'G3DSA:2.10.25.10:FF:001198', NULL, NULL, 'Fibulin 2', NULL, NULL, NULL, NULL, NULL, 4),
(217700, NULL, 'G3DSA:2.60.200.30:FF:000008', NULL, NULL, 'Putative NAD+ kinase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(217701, NULL, 'G3DSA:1.10.1750.10:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217702, NULL, 'G3DSA:2.40.50.100:FF:000192', NULL, NULL, 'Probable membrane-fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(217703, NULL, 'G3DSA:1.50.40.10:FF:000255', NULL, NULL, 'Putative inner membrane solute transporter MRS4', NULL, NULL, NULL, NULL, NULL, 4),
(217704, NULL, 'G3DSA:3.30.1360.200:FF:000006', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(217705, NULL, 'G3DSA:2.130.10.10:FF:004362', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217706, NULL, 'G3DSA:1.20.1250.20:FF:001111', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4),
(217707, NULL, 'G3DSA:3.90.1530.30:FF:000005', NULL, NULL, 'Plasmid partitioning protein, parb2', NULL, NULL, NULL, NULL, NULL, 4),
(217708, NULL, 'G3DSA:3.30.160.60:FF:002742', NULL, NULL, 'Zinc finger protein Pegasus', NULL, NULL, NULL, NULL, NULL, 4),
(217709, NULL, 'G3DSA:3.30.559.70:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217710, NULL, 'G3DSA:3.30.720.210:FF:000015', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH', NULL, NULL, NULL, NULL, NULL, 4),
(217711, NULL, 'G3DSA:1.10.1070.11:FF:000052', NULL, NULL, 'Serine/threonine-protein kinase Tel1', NULL, NULL, NULL, NULL, NULL, 4),
(217712, NULL, 'G3DSA:3.40.1080.20:FF:000001', NULL, NULL, 'Acetyl-CoA hydrolase Ach1', NULL, NULL, NULL, NULL, NULL, 4),
(217713, NULL, 'G3DSA:3.40.50.300:FF:002563', NULL, NULL, 'Unplaced genomic scaffold supercont1.20, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(217714, NULL, 'G3DSA:1.10.238.10:FF:000571', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(217715, NULL, 'G3DSA:3.90.550.10:FF:000304', NULL, NULL, 'PGL/p-HBAD biosynthesis glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(217716, NULL, 'G3DSA:1.20.140.150:FF:000133', NULL, NULL, 'Voltage-dependent calcium channel gamma-2 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(217717, NULL, 'G3DSA:3.40.630.10:FF:000322', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217718, NULL, 'G3DSA:3.40.30.10:FF:000666', NULL, NULL, 'AhpC/TSA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(217719, NULL, 'G3DSA:3.80.10.10:FF:000107', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase ERL1', NULL, NULL, NULL, NULL, NULL, 4),
(217720, NULL, 'G3DSA:1.20.1560.10:FF:000928', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217721, NULL, 'G3DSA:1.20.930.80:FF:000018', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(217722, NULL, 'G3DSA:2.30.42.10:FF:000421', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217723, NULL, 'G3DSA:2.10.25.10:FF:001310', NULL, NULL, 'Hemolectin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(217724, NULL, 'G3DSA:2.40.160.110:FF:000018', NULL, NULL, 'Si:ch211-212k18.7', NULL, NULL, NULL, NULL, NULL, 4),
(217725, NULL, 'G3DSA:3.40.50.150:FF:000028', NULL, NULL, 'Ubiquinone biosynthesis O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(217726, NULL, 'G3DSA:1.10.1670.10:FF:000012', NULL, NULL, '8-oxoguanine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(217727, NULL, 'G3DSA:3.30.1110.10:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217728, NULL, 'G3DSA:3.40.50.1100:FF:000239', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(217729, NULL, 'G3DSA:3.40.50.720:FF:001464', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(217730, NULL, 'G3DSA:3.30.1460.30:FF:000002', NULL, NULL, 'Putative DNA transformation protein TfoX', NULL, NULL, NULL, NULL, NULL, 4),
(217731, NULL, 'G3DSA:1.10.1130.10:FF:000005', NULL, NULL, 'Cytochrome c-554', NULL, NULL, NULL, NULL, NULL, 4),
(217732, NULL, 'G3DSA:3.30.450.190:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217733, NULL, 'G3DSA:3.30.420.40:FF:000317', NULL, NULL, 'Luminal-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(217734, NULL, 'G3DSA:3.80.10.10:FF:002136', NULL, NULL, 'Nuclear export factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(217735, NULL, 'G3DSA:3.40.50.720:FF:000896', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(P)+]', NULL, NULL, NULL, NULL, NULL, 4),
(217736, NULL, 'G3DSA:3.40.50.300:FF:008291', NULL, NULL, 'tRNA modification GTPase trmE', NULL, NULL, NULL, NULL, NULL, 4),
(217737, NULL, 'G3DSA:2.60.40.10:FF:001736', NULL, NULL, 'T-cell surface antigen CD2', NULL, NULL, NULL, NULL, NULL, 4),
(217738, NULL, 'G3DSA:3.40.50.150:FF:001017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217739, NULL, 'G3DSA:3.40.50.2000:FF:000498', NULL, NULL, 'Glycosyl transferase family 1', NULL, NULL, NULL, NULL, NULL, 4),
(217740, NULL, 'G3DSA:1.10.510.10:FF:001160', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(217741, NULL, 'G3DSA:3.30.200.20:FF:002184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217742, NULL, 'G3DSA:4.10.400.10:FF:000162', NULL, NULL, 'LDL receptor related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(217743, NULL, 'G3DSA:2.60.40.2580:FF:000004', NULL, NULL, 'Major fimbrium subunit FimC', NULL, NULL, NULL, NULL, NULL, 4),
(217744, NULL, 'G3DSA:1.10.132.20:FF:000025', NULL, NULL, 'Sugar transporter ERD6-like 6', NULL, NULL, NULL, NULL, NULL, 4),
(217745, NULL, 'G3DSA:1.50.10.10:FF:000074', NULL, NULL, 'Glucanase', NULL, NULL, NULL, NULL, NULL, 4),
(217746, NULL, 'G3DSA:1.20.120.1900:FF:000020', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(217747, NULL, 'G3DSA:3.90.1750.10:FF:000061', NULL, NULL, 'E3 ubiquitin-protein ligase hecw-1', NULL, NULL, NULL, NULL, NULL, 4),
(217748, NULL, 'G3DSA:2.10.70.10:FF:000217', NULL, NULL, 'Protein lev-9', NULL, NULL, NULL, NULL, NULL, 4),
(217749, NULL, 'G3DSA:2.40.20.10:FF:000123', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(217750, NULL, 'G3DSA:3.30.1010.10:FF:000064', NULL, NULL, 'Serine/threonine-protein kinase ATR', NULL, NULL, NULL, NULL, NULL, 4),
(217751, NULL, 'G3DSA:3.40.50.300:FF:004328', NULL, NULL, 'DNA translocase coupling ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(217752, NULL, 'G3DSA:3.30.70.260:FF:000146', NULL, NULL, 'Aspartokinase', NULL, NULL, NULL, NULL, NULL, 4),
(217753, NULL, 'G3DSA:2.60.260.20:FF:000127', NULL, NULL, 'dnaJ homolog subfamily A member 2', NULL, NULL, NULL, NULL, NULL, 4),
(217754, NULL, 'G3DSA:3.40.50.720:FF:000036', NULL, NULL, 'Glutathione-regulated potassium-efflux system protein KefB', NULL, NULL, NULL, NULL, NULL, 4),
(217755, NULL, 'G3DSA:3.30.40.10:FF:000521', NULL, NULL, 'RING/U-box superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(217756, NULL, 'G3DSA:2.70.130.10:FF:000129', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217757, NULL, 'G3DSA:3.80.10.10:FF:002928', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217758, NULL, 'G3DSA:2.60.40.10:FF:000376', NULL, NULL, 'CLUMA_CG000981, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(217759, NULL, 'G3DSA:1.10.238.10:FF:000419', NULL, NULL, 'Calmodulin-like protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(217760, NULL, 'G3DSA:1.10.565.10:FF:000078', NULL, NULL, 'Peroxisome proliferator-activated receptor gamma', NULL, NULL, NULL, NULL, NULL, 4),
(217761, NULL, 'G3DSA:2.40.30.160:FF:000003', NULL, NULL, 'Ccr4 associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(217762, NULL, 'G3DSA:3.90.550.10:FF:000355', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(217763, NULL, 'G3DSA:1.25.10.10:FF:003021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217764, NULL, 'G3DSA:3.30.160.60:FF:003198', NULL, NULL, 'Zinc finger protein 891', NULL, NULL, NULL, NULL, NULL, 4),
(217765, NULL, 'G3DSA:1.20.1560.10:FF:000024', NULL, NULL, 'ABC transporter C family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(217766, NULL, 'G3DSA:3.30.70.330:FF:000015', NULL, NULL, 'CUGBP Elav-like family member 1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(217767, NULL, 'G3DSA:3.80.10.10:FF:001568', NULL, NULL, 'Adhesion G protein-coupled receptor A2', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(217768, NULL, 'G3DSA:1.20.1250.20:FF:000543', NULL, NULL, 'Vacuolar basic amino acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(217769, NULL, 'G3DSA:1.20.1640.10:FF:000025', NULL, NULL, 'Protein-export membrane protein SecF', NULL, NULL, NULL, NULL, NULL, 4),
(217770, NULL, 'G3DSA:3.40.190.10:FF:000193', NULL, NULL, 'Two-component system sensor histidine kinase EvgS', NULL, NULL, NULL, NULL, NULL, 4),
(217771, NULL, 'G3DSA:1.20.1250.20:FF:001971', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217772, NULL, 'G3DSA:2.20.28.30:FF:000001', NULL, NULL, 'DNA-directed RNA polymerases I, II, and III subunit RPABC4', NULL, NULL, NULL, NULL, NULL, 4),
(217773, NULL, 'G3DSA:3.50.50.60:FF:000137', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(217774, NULL, 'G3DSA:3.20.20.70:FF:000038', NULL, NULL, 'Hydroxymethylglutaryl-CoA lyase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(217775, NULL, 'G3DSA:3.30.300.30:FF:000160', NULL, NULL, 'Chondramide synthase cmdD', NULL, NULL, NULL, NULL, NULL, 4),
(217776, NULL, 'G3DSA:1.20.1530.20:FF:000104', NULL, NULL, 'Os09g0474501 protein', NULL, NULL, NULL, NULL, NULL, 4),
(217777, NULL, 'G3DSA:3.40.50.720:FF:001413', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217778, NULL, 'G3DSA:3.40.50.150:FF:000180', NULL, NULL, 'Cytosine-specific methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(217779, NULL, 'G3DSA:3.30.70.1230:FF:000264', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(217780, NULL, 'G3DSA:2.70.70.10:FF:000063', NULL, NULL, 'SPbeta prophage-derived uncharacterized transglycosylase YomI', NULL, NULL, NULL, NULL, NULL, 4),
(217781, NULL, 'G3DSA:3.30.310.10:FF:000008', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(217782, NULL, 'G3DSA:1.10.418.50:FF:000001', NULL, NULL, 'TRAF3-interacting protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(217783, NULL, 'G3DSA:1.10.274.100:FF:000022', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(217784, NULL, 'G3DSA:3.40.50.720:FF:002453', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217785, NULL, 'G3DSA:3.30.160.60:FF:006183', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217786, NULL, 'G3DSA:1.20.1440.170:FF:000006', NULL, NULL, 'WGS project CABT00000000 data, contig 2.35', NULL, NULL, NULL, NULL, NULL, 4),
(217787, NULL, 'G3DSA:3.40.50.1820:FF:000213', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(217788, NULL, 'G3DSA:2.160.20.10:FF:000073', NULL, NULL, 'F-box domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(217789, NULL, 'G3DSA:3.40.50.300:FF:007734', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(217790, NULL, 'G3DSA:3.40.50.10700:FF:000004', NULL, NULL, 'D-aminoacyl-tRNA deacylase', NULL, NULL, NULL, NULL, NULL, 4),
(217791, NULL, 'G3DSA:3.30.70.20:FF:000026', NULL, NULL, 'Nitrate reductase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(217792, NULL, 'G3DSA:3.30.200.20:FF:002133', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(217793, NULL, 'G3DSA:1.20.1070.10:FF:000228', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(217794, NULL, 'G3DSA:1.10.10.2010:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217795, NULL, 'G3DSA:1.10.418.70:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217796, NULL, 'G3DSA:3.30.160.60:FF:004507', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217797, NULL, 'G3DSA:3.40.50.10130:FF:000047', NULL, NULL, 'Essential meiotic structure-specific endonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(217798, NULL, 'G3DSA:1.10.260.30:FF:000016', NULL, NULL, 'Signal recognition particle 54 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(217799, NULL, 'G3DSA:3.60.10.10:FF:000389', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217800, NULL, 'G3DSA:3.10.50.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(217801, NULL, 'G3DSA:1.25.40.10:FF:002652', NULL, NULL, 'CCR4-NOT transcription complex subunit 10', NULL, NULL, NULL, NULL, NULL, 4),
(217802, NULL, 'G3DSA:2.10.220.10:FF:000178', NULL, NULL, 'Extracellular matrix protein FRAS1', NULL, NULL, NULL, NULL, NULL, 4),
(217803, NULL, 'G3DSA:1.20.1250.20:FF:001903', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217804, NULL, 'G3DSA:3.90.180.10:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217805, NULL, 'G3DSA:3.30.70.20:FF:000138', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217806, NULL, 'G3DSA:2.60.120.200:FF:000100', NULL, NULL, 'Axotactin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(217807, NULL, 'G3DSA:2.60.200.20:FF:000118', NULL, NULL, 'SMAD/FHA domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(217808, NULL, 'G3DSA:3.30.40.10:FF:000572', NULL, NULL, 'CDK-activating kinase assembly factor MAT1', NULL, NULL, NULL, NULL, NULL, 4),
(217809, NULL, 'G3DSA:1.20.1070.10:FF:001577', NULL, NULL, 'Olfactory receptor 753, pseudogene 1', NULL, NULL, NULL, NULL, NULL, 4),
(217810, NULL, 'G3DSA:2.30.180.10:FF:000080', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(217811, NULL, 'G3DSA:3.30.2080.10:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217812, NULL, 'G3DSA:3.55.50.30:FF:000011', NULL, NULL, 'Putative anti-sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(217813, NULL, 'G3DSA:3.40.50.12160:FF:000026', NULL, NULL, 'MiaB-like tRNA modifying enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(217814, NULL, 'G3DSA:1.20.1540.10:FF:000080', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217815, NULL, 'G3DSA:1.10.3210.10:FF:000074', NULL, NULL, 'Metal dependent phosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(217816, NULL, 'G3DSA:2.60.40.10:FF:004558', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217817, NULL, 'G3DSA:3.30.565.10:FF:000127', NULL, NULL, 'Hybrid sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(217818, NULL, 'G3DSA:1.10.10.60:FF:000017', NULL, NULL, 'Homeobox protein antennapedia', NULL, NULL, NULL, NULL, NULL, 4),
(217819, NULL, 'G3DSA:3.40.50.1000:FF:000827', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217820, NULL, 'G3DSA:3.30.505.10:FF:000186', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217821, NULL, 'G3DSA:3.30.930.10:FF:000179', NULL, NULL, 'Glycine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(217822, NULL, 'G3DSA:1.20.1070.10:FF:000116', NULL, NULL, 'probable G-protein coupled receptor 22', NULL, NULL, NULL, NULL, NULL, 4),
(217823, NULL, 'G3DSA:3.40.50.1820:FF:001562', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217824, NULL, 'G3DSA:2.60.40.790:FF:000088', NULL, NULL, '18.8 kDa class V heat shock protein', NULL, NULL, NULL, NULL, NULL, 4),
(217825, NULL, 'G3DSA:2.130.10.10:FF:002445', NULL, NULL, 'POC1 centriolar protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(217826, NULL, 'G3DSA:2.10.60.10:FF:000020', NULL, NULL, 'LY6/PLAUR domain containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(217827, NULL, 'G3DSA:1.25.10.10:FF:000166', NULL, NULL, 'Coatomer subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(217828, NULL, 'G3DSA:3.30.200.20:FF:001987', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217829, NULL, 'G3DSA:1.20.1050.10:FF:000233', NULL, NULL, 'Glutathione transferase', NULL, NULL, NULL, NULL, NULL, 4),
(217830, NULL, 'G3DSA:2.130.10.10:FF:002849', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217831, NULL, 'G3DSA:3.30.70.330:FF:002820', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217832, NULL, 'G3DSA:1.10.510.10:FF:002469', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217833, NULL, 'G3DSA:2.60.40.150:FF:000812', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217834, NULL, 'G3DSA:1.25.40.10:FF:003692', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(217835, NULL, 'G3DSA:3.40.50.20:FF:000002', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(217836, NULL, 'G3DSA:1.20.5.470:FF:000012', NULL, NULL, 'Argininosuccinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(217837, NULL, 'G3DSA:1.10.287.3610:FF:000001', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(217838, NULL, 'G3DSA:3.20.20.190:FF:000078', NULL, NULL, 'GM14906', NULL, NULL, NULL, NULL, NULL, 4),
(217839, NULL, 'G3DSA:3.80.10.10:FF:003125', NULL, NULL, 'Fbxl7, putative', NULL, NULL, NULL, NULL, NULL, 4),
(217840, NULL, 'G3DSA:2.60.40.10:FF:005047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217841, NULL, 'G3DSA:1.25.40.20:FF:000204', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(217842, NULL, 'G3DSA:3.30.160.60:FF:000325', NULL, NULL, 'ZFP90 zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(217843, NULL, 'G3DSA:1.20.58.860:FF:000016', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(217844, NULL, 'G3DSA:3.30.70.920:FF:000046', NULL, NULL, 'DNA-binding transcriptional regulator, Lrp family', NULL, NULL, NULL, NULL, NULL, 4),
(217845, NULL, 'G3DSA:3.10.129.10:FF:000147', NULL, NULL, 'Acyl-CoA thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(217846, NULL, 'G3DSA:1.10.510.10:FF:003981', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217847, NULL, 'G3DSA:1.10.418.10:FF:000017', NULL, NULL, 'Microtubule-actin cross-linking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(217848, NULL, 'G3DSA:3.30.457.60:FF:000009', NULL, NULL, 'GM14169p', NULL, NULL, NULL, NULL, NULL, 4),
(217849, NULL, 'G3DSA:2.60.40.60:FF:000930', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217850, NULL, 'G3DSA:2.40.290.30:FF:000002', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit', NULL, NULL, NULL, NULL, NULL, 4),
(217851, NULL, 'G3DSA:1.10.510.10:FF:001008', NULL, NULL, 'NAK/MPSK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(217852, NULL, 'G3DSA:3.40.50.720:FF:002402', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217853, NULL, 'G3DSA:2.130.10.10:FF:001489', NULL, NULL, 'U3 small nucleolar RNA-associated protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(217854, NULL, 'G3DSA:1.25.40.420:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217855, NULL, 'G3DSA:3.90.190.20:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217856, NULL, 'G3DSA:3.20.20.100:FF:000203', NULL, NULL, 'Galactose dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(217857, NULL, 'G3DSA:3.40.50.970:FF:000206', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(217858, NULL, 'G3DSA:3.40.50.300:FF:001102', NULL, NULL, 'Nuclear GTPase, germinal center-associated', NULL, NULL, NULL, NULL, NULL, 4),
(217859, NULL, 'G3DSA:1.10.340.30:FF:000017', NULL, NULL, 'N-glycosylase/DNA lyase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(217860, NULL, 'G3DSA:1.10.150.530:FF:000021', NULL, NULL, 'Probable dual-specificity RNA methyltransferase RlmN', NULL, NULL, NULL, NULL, NULL, 4),
(217861, NULL, 'G3DSA:3.40.50.300:FF:006745', NULL, NULL, 'Abcg4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(217862, NULL, 'G3DSA:2.60.40.150:FF:000071', NULL, NULL, 'Copine 8', NULL, NULL, NULL, NULL, NULL, 4),
(217863, NULL, 'G3DSA:1.25.40.10:FF:003641', NULL, NULL, 'Tetratricopeptide repeat protein 21B', NULL, NULL, NULL, NULL, NULL, 4),
(217864, NULL, 'G3DSA:3.30.160.60:FF:000825', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM39', NULL, NULL, NULL, NULL, NULL, 4),
(217865, NULL, 'G3DSA:1.20.58.60:FF:000323', NULL, NULL, 'SMAll', NULL, NULL, NULL, NULL, NULL, 4),
(217866, NULL, 'G3DSA:3.90.1410.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217867, NULL, 'G3DSA:3.20.20.140:FF:000428', NULL, NULL, 'Carbamoyl-phosphate synthetase 2, aspartate transcarbamylase, and dihydroorotase', NULL, NULL, NULL, NULL, NULL, 4),
(217868, NULL, 'G3DSA:1.10.510.10:FF:003829', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(217869, NULL, 'G3DSA:3.30.420.40:FF:000205', NULL, NULL, 'Actin, alpha skeletal muscle', NULL, NULL, NULL, NULL, NULL, 4),
(217870, NULL, 'G3DSA:2.30.30.40:FF:000476', NULL, NULL, 'Chemotaxis signal transduction system adaptor protein CheW', NULL, NULL, NULL, NULL, NULL, 4),
(217871, NULL, 'G3DSA:3.80.10.10:FF:003985', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(217872, NULL, 'G3DSA:4.10.400.10:FF:000050', NULL, NULL, 'low-density lipoprotein receptor-related protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(217873, NULL, 'G3DSA:3.30.70.330:FF:001864', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217874, NULL, 'G3DSA:3.40.30.10:FF:000262', NULL, NULL, 'Thioredoxin domain containing 8', NULL, NULL, NULL, NULL, NULL, 4),
(217875, NULL, 'G3DSA:3.40.50.300:FF:002512', NULL, NULL, 'Thymidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(217876, NULL, 'G3DSA:3.30.160.60:FF:003310', NULL, NULL, 'Zinc finger protein 607', NULL, NULL, NULL, NULL, NULL, 4),
(217877, NULL, 'G3DSA:2.30.30.70:FF:000001', NULL, NULL, '60S ribosomal protein L21', NULL, NULL, NULL, NULL, NULL, 4),
(217878, NULL, 'G3DSA:3.10.20.30:FF:000066', NULL, NULL, 'Adrenodoxin-like protein 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(217879, NULL, 'G3DSA:1.25.40.20:FF:001553', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217880, NULL, 'G3DSA:1.10.12.10:FF:000029', NULL, NULL, '3-hydroxybutyryl-CoA dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(217881, NULL, 'G3DSA:3.30.70.60:FF:000010', NULL, NULL, '30S ribosomal protein S6', NULL, NULL, NULL, NULL, NULL, 4),
(217882, NULL, 'G3DSA:2.30.30.30:FF:000068', NULL, NULL, 'Putative ribosomal protein L2', NULL, NULL, NULL, NULL, NULL, 4),
(217883, NULL, 'G3DSA:3.40.50.150:FF:000680', NULL, NULL, 'Ubiquinone/menaquinone biosynthesis methyltransferase ubiE', NULL, NULL, NULL, NULL, NULL, 4),
(217884, NULL, 'G3DSA:2.170.16.10:FF:000034', NULL, NULL, 'Hedgehog protein', NULL, NULL, NULL, NULL, NULL, 4),
(217885, NULL, 'G3DSA:3.30.40.10:FF:001769', NULL, NULL, 'Conserved zinc-finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(217886, NULL, 'G3DSA:1.10.287.110:FF:000175', NULL, NULL, 'GM22099', NULL, NULL, NULL, NULL, NULL, 4),
(217887, NULL, 'G3DSA:3.40.50.1820:FF:000101', NULL, NULL, 'Hepatic triacylglycerol lipase', NULL, NULL, NULL, NULL, NULL, 4),
(217888, NULL, 'G3DSA:2.30.30.90:FF:000007', NULL, NULL, 'Iron-dependent transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(217889, NULL, 'G3DSA:1.20.120.450:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217890, NULL, 'G3DSA:3.30.70.20:FF:000077', NULL, NULL, 'Indolepyruvate oxidoreductase subunit IorA', NULL, NULL, NULL, NULL, NULL, 4),
(217891, NULL, 'G3DSA:1.20.140.40:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217892, NULL, 'G3DSA:3.30.160.60:FF:006132', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217893, NULL, 'G3DSA:1.25.10.10:FF:000115', NULL, NULL, 'Splicing factor 3B subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(217894, NULL, 'G3DSA:3.40.50.10810:FF:000037', NULL, NULL, 'chromodomain-helicase-DNA-binding protein 1-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(217895, NULL, 'G3DSA:3.40.250.10:FF:000164', NULL, NULL, 'Tbck-1', NULL, NULL, NULL, NULL, NULL, 4),
(217896, NULL, 'G3DSA:1.10.510.10:FF:000171', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(217897, NULL, 'G3DSA:1.20.5.650:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217898, NULL, 'G3DSA:3.30.1120.30:FF:000044', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(217899, NULL, 'G3DSA:2.70.160.11:FF:000054', NULL, NULL, 'Arginine methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(217900, NULL, 'G3DSA:3.30.497.10:FF:000002', NULL, NULL, 'Serpin family B member 6', NULL, NULL, NULL, NULL, NULL, 4),
(217901, NULL, 'G3DSA:1.20.5.190:FF:000086', NULL, NULL, 'IQ-domain 14', NULL, NULL, NULL, NULL, NULL, 4),
(217902, NULL, 'G3DSA:3.10.110.10:FF:000329', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(217903, NULL, 'G3DSA:1.25.40.120:FF:000050', NULL, NULL, 'YALI0A02431p', NULL, NULL, NULL, NULL, NULL, 4),
(217904, NULL, 'G3DSA:1.20.58.80:FF:000060', NULL, NULL, 'STAM-binding protein-like A', NULL, NULL, NULL, NULL, NULL, 4),
(217905, NULL, 'G3DSA:2.60.40.150:FF:000424', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(217906, NULL, 'G3DSA:3.30.870.10:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217907, NULL, 'G3DSA:3.40.720.10:FF:000329', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(217908, NULL, 'G3DSA:2.60.120.10:FF:000699', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217909, NULL, 'G3DSA:3.40.50.2000:FF:001127', NULL, NULL, 'Glycogen [starch] synthase', NULL, NULL, NULL, NULL, NULL, 4),
(217910, NULL, 'G3DSA:3.30.230.10:FF:000058', NULL, NULL, 'Elongation factor Tu family protein, putative, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(217911, NULL, 'G3DSA:3.30.160.60:FF:000376', NULL, NULL, 'Zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(217912, NULL, 'G3DSA:3.40.50.2300:FF:000498', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(217913, NULL, 'G3DSA:3.60.10.10:FF:000001', NULL, NULL, 'Exodeoxyribonuclease III', NULL, NULL, NULL, NULL, NULL, 4),
(217914, NULL, 'G3DSA:3.40.50.300:FF:004828', NULL, NULL, 'DNA helicase INO80', NULL, NULL, NULL, NULL, NULL, 4),
(217915, NULL, 'G3DSA:3.30.200.20:FF:000559', NULL, NULL, 'Ribosomal protein S6 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(217916, NULL, 'G3DSA:2.10.110.10:FF:000024', NULL, NULL, 'actin-binding LIM protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(217917, NULL, 'G3DSA:3.40.50.12780:FF:000055', NULL, NULL, 'Fatty-acid-CoA ligase FadD22', NULL, NULL, NULL, NULL, NULL, 4),
(217918, NULL, 'G3DSA:1.25.40.10:FF:001275', NULL, NULL, 'HemY protein', NULL, NULL, NULL, NULL, NULL, 4),
(217919, NULL, 'G3DSA:3.90.1480.20:FF:000003', NULL, NULL, 'CMP-N-acetylneuraminate-beta-1,4-galactoside alpha-2,3-sialyltransferase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(217920, NULL, 'G3DSA:3.30.200.20:FF:000267', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(217921, NULL, 'G3DSA:3.90.79.10:FF:000107', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(217922, NULL, 'G3DSA:3.30.9.10:FF:000016', NULL, NULL, 'Fructosyl amine:oxygen oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(217923, NULL, 'G3DSA:2.170.140.10:FF:000033', NULL, NULL, 'GD12214', NULL, NULL, NULL, NULL, NULL, 4),
(217924, NULL, 'G3DSA:3.20.180.20:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217925, NULL, 'G3DSA:3.90.132.10:FF:000002', NULL, NULL, 'Leishmanolysin like peptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(217926, NULL, 'G3DSA:1.20.1250.20:FF:000947', NULL, NULL, 'Probable major facilitator superfamily (MFS) transporter', NULL, NULL, NULL, NULL, NULL, 4),
(217927, NULL, 'G3DSA:1.10.472.10:FF:000626', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217928, NULL, 'G3DSA:1.10.565.10:FF:000139', NULL, NULL, 'Nr1h3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(217929, NULL, 'G3DSA:3.30.1010.10:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217930, NULL, 'G3DSA:2.130.10.10:FF:005755', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217931, NULL, 'G3DSA:2.40.30.270:FF:000036', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(217932, NULL, 'G3DSA:1.10.8.870:FF:000005', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(217933, NULL, 'G3DSA:3.30.70.330:FF:001364', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217934, NULL, 'G3DSA:3.30.2140.20:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217935, NULL, 'G3DSA:3.60.21.10:FF:000178', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(217936, NULL, 'G3DSA:1.10.220.150:FF:000036', NULL, NULL, 'CRE-GIT-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(217937, NULL, 'G3DSA:3.40.50.720:FF:001093', NULL, NULL, 'Putative nucleoside-diphosphate sugar epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(217938, NULL, 'G3DSA:2.40.10.10:FF:000297', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217939, NULL, 'G3DSA:2.40.110.10:FF:000040', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(217940, NULL, 'G3DSA:1.20.120.660:FF:000001', NULL, NULL, 'Cag pathogenicity island protein', NULL, NULL, NULL, NULL, NULL, 4),
(217941, NULL, 'G3DSA:3.30.430.20:FF:000043', NULL, NULL, 'Os12g0606000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(217942, NULL, 'G3DSA:3.30.200.20:FF:002072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217943, NULL, 'G3DSA:3.40.109.10:FF:000049', NULL, NULL, 'Nitroreductase', NULL, NULL, NULL, NULL, NULL, 4),
(217944, NULL, 'G3DSA:2.60.40.10:FF:003653', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217945, NULL, 'G3DSA:3.40.50.1460:FF:000122', NULL, NULL, 'Caspase Dronc', NULL, NULL, NULL, NULL, NULL, 4),
(217946, NULL, 'G3DSA:1.10.720.30:FF:000035', NULL, NULL, 'Nfi1p', NULL, NULL, NULL, NULL, NULL, 4),
(217947, NULL, 'G3DSA:3.40.50.720:FF:000396', NULL, NULL, '(+)-neomenthol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(217948, NULL, 'G3DSA:1.10.274.60:FF:000001', NULL, NULL, 'Eggcase silk protein', NULL, NULL, NULL, NULL, NULL, 4),
(217949, NULL, 'G3DSA:3.90.70.10:FF:000818', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217950, NULL, 'G3DSA:3.80.10.10:FF:000219', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase ERL1', NULL, NULL, NULL, NULL, NULL, 4),
(217951, NULL, 'G3DSA:1.20.5.170:FF:000080', NULL, NULL, 'Basic leucine zipper transcriptional factor ATF-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(217952, NULL, 'G3DSA:1.10.260.100:FF:000012', NULL, NULL, 'Hsc70-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(217953, NULL, 'G3DSA:1.20.1560.10:FF:000816', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217954, NULL, 'G3DSA:1.10.510.10:FF:000963', NULL, NULL, 'Serine/threonine-protein kinase BUR1', NULL, NULL, NULL, NULL, NULL, 4),
(217955, NULL, 'G3DSA:3.40.50.1820:FF:000152', NULL, NULL, 'Protein phosphatase methylesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(217956, NULL, 'G3DSA:1.10.555.10:FF:000072', NULL, NULL, 'Protein RGD1', NULL, NULL, NULL, NULL, NULL, 4),
(217957, NULL, 'G3DSA:3.40.50.300:FF:005677', NULL, NULL, 'ATP-dependent nuclease subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(217958, NULL, 'G3DSA:3.80.10.10:FF:002024', NULL, NULL, 'Protein CBG18939', NULL, NULL, NULL, NULL, NULL, 4),
(217959, NULL, 'G3DSA:3.30.920.10:FF:000010', NULL, NULL, 'Frataxin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(217960, NULL, 'G3DSA:3.40.50.12780:FF:000004', NULL, NULL, 'Disco interacting protein 2 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(217961, NULL, 'G3DSA:2.130.10.10:FF:001540', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(217962, NULL, 'G3DSA:2.60.40.1730:FF:000047', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(217963, NULL, 'G3DSA:1.25.40.540:FF:000001', NULL, NULL, 'immunoglobulin-binding protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(217964, NULL, 'G3DSA:1.10.400.10:FF:000050', NULL, NULL, 'guanine nucleotide-binding protein G(S) subunit alpha-like', NULL, NULL, NULL, NULL, NULL, 4),
(217965, NULL, 'G3DSA:1.20.1270.20:FF:000005', NULL, NULL, 'Hydroxylamine reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(217966, NULL, 'G3DSA:3.30.310.10:FF:000059', NULL, NULL, 'AP complex subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(217967, NULL, 'G3DSA:2.30.40.10:FF:000147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217968, NULL, 'G3DSA:2.30.29.30:FF:001071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217969, NULL, 'G3DSA:2.60.40.60:FF:000329', NULL, NULL, 'Cadherin-related tumor suppressor', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(217970, NULL, 'G3DSA:3.60.20.10:FF:000215', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217971, NULL, 'G3DSA:3.10.580.10:FF:000072', NULL, NULL, 'Putative zinc metalloprotease Rip3', NULL, NULL, NULL, NULL, NULL, 4),
(217972, NULL, 'G3DSA:3.90.1150.10:FF:000324', NULL, NULL, 'Kynureninase', NULL, NULL, NULL, NULL, NULL, 4),
(217973, NULL, 'G3DSA:1.25.10.10:FF:003100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217974, NULL, 'G3DSA:1.10.268.20:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217975, NULL, 'G3DSA:3.30.200.20:FF:000508', NULL, NULL, 'Protein kinase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(217976, NULL, 'G3DSA:3.50.50.60:FF:000058', NULL, NULL, 'apoptosis-inducing factor 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(217977, NULL, 'G3DSA:1.25.40.10:FF:001224', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(217978, NULL, 'G3DSA:2.102.10.10:FF:000030', NULL, NULL, 'Possible dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(217979, NULL, 'G3DSA:1.10.472.10:FF:000238', NULL, NULL, 'Putative cyclin', NULL, NULL, NULL, NULL, NULL, 4),
(217980, NULL, 'G3DSA:3.30.230.10:FF:000007', NULL, NULL, '40S ribosomal protein S16', NULL, NULL, NULL, NULL, NULL, 4),
(217981, NULL, 'G3DSA:3.40.50.150:FF:000579', NULL, NULL, 'RNA methylase family UPF0020 protein', NULL, NULL, NULL, NULL, NULL, 4),
(217982, NULL, 'G3DSA:1.20.1740.10:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217983, NULL, 'G3DSA:1.20.1740.10:FF:000061', NULL, NULL, 'K+/Cl-Cotransporter', NULL, NULL, NULL, NULL, NULL, 4),
(217984, NULL, 'G3DSA:3.15.10.30:FF:000010', NULL, NULL, 'AGAP009387-PA', NULL, NULL, NULL, NULL, NULL, 4),
(217985, NULL, 'G3DSA:2.30.29.30:FF:000795', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(217986, NULL, 'G3DSA:1.20.1280.50:FF:000267', NULL, NULL, 'F-box protein pof9', NULL, NULL, NULL, NULL, NULL, 4),
(217987, NULL, 'G3DSA:3.40.50.300:FF:000938', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(217988, NULL, 'G3DSA:3.40.1000.50:FF:000005', NULL, NULL, 'Repressor of RNA polymerase III transcription MAF1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(217989, NULL, 'G3DSA:1.25.10.10:FF:002824', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(217990, NULL, 'G3DSA:3.30.200.20:FF:000216', NULL, NULL, 'Putative serine/threonine-protein kinase dyrk2', NULL, NULL, NULL, NULL, NULL, 4),
(217991, NULL, 'G3DSA:3.40.190.10:FF:000125', NULL, NULL, 'ATP phosphoribosyltransferase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(217992, NULL, 'G3DSA:2.60.40.10:FF:002372', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(217993, NULL, 'G3DSA:2.60.40.60:FF:000430', NULL, NULL, 'Cadherin 3', NULL, NULL, NULL, NULL, NULL, 4),
(217994, NULL, 'G3DSA:1.10.510.10:FF:000671', NULL, NULL, 'Casein kinase I isoform alpha', NULL, NULL, NULL, NULL, NULL, 4),
(217995, NULL, 'G3DSA:1.20.1080.10:FF:000061', NULL, NULL, 'Formate/nitrite transporter family protein', NULL, NULL, NULL, NULL, NULL, 4),
(217996, NULL, 'G3DSA:1.10.555.10:FF:000021', NULL, NULL, 'rho GTPase-activating protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(217997, NULL, 'G3DSA:1.10.8.720:FF:000039', NULL, NULL, 'AT15593p', NULL, NULL, NULL, NULL, NULL, 4),
(217998, NULL, 'G3DSA:1.10.600.10:FF:000110', NULL, NULL, 'Geranylfarnesyl diphosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(217999, NULL, 'G3DSA:2.30.42.10:FF:000360', NULL, NULL, 'Protein lap1', NULL, NULL, NULL, NULL, NULL, 4),
(218000, NULL, 'G3DSA:3.30.2350.20:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218001, NULL, 'G3DSA:2.10.25.10:FF:001231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218002, NULL, 'G3DSA:2.40.10.190:FF:000002', NULL, NULL, '60S ribosomal protein L35ae, putative', NULL, NULL, NULL, NULL, NULL, 4),
(218003, NULL, 'G3DSA:2.120.10.30:FF:000355', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(218004, NULL, 'G3DSA:1.25.10.10:FF:001104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218005, NULL, 'G3DSA:2.10.60.10:FF:000071', NULL, NULL, 'Activin A receptor type 2Ba', NULL, NULL, NULL, NULL, NULL, 4),
(218006, NULL, 'G3DSA:1.10.8.270:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218007, NULL, 'G3DSA:3.30.160.60:FF:004558', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218008, NULL, 'G3DSA:2.30.30.40:FF:000425', NULL, NULL, 'Fus1p', NULL, NULL, NULL, NULL, NULL, 4),
(218009, NULL, 'G3DSA:3.30.420.40:FF:000256', NULL, NULL, 'Carbohydrate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(218010, NULL, 'G3DSA:3.30.160.60:FF:000084', NULL, NULL, 'Zinc finger E-box binding homeobox 2', NULL, NULL, NULL, NULL, NULL, 4),
(218011, NULL, 'G3DSA:2.40.40.10:FF:000006', NULL, NULL, 'Expansin-like A2', NULL, NULL, NULL, NULL, NULL, 4),
(218012, NULL, 'G3DSA:1.10.730.10:FF:000114', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(218013, NULL, 'G3DSA:1.25.40.20:FF:000564', NULL, NULL, 'Potassium channel SKOR', NULL, NULL, NULL, NULL, NULL, 4),
(218014, NULL, 'G3DSA:1.10.238.10:FF:000650', NULL, NULL, 'Centrin-B', NULL, NULL, NULL, NULL, NULL, 4),
(218015, NULL, 'G3DSA:3.30.519.10:FF:000009', NULL, NULL, 'Rab GDP dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(218016, NULL, 'G3DSA:1.10.286.20:FF:000005', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(218017, NULL, 'G3DSA:3.80.10.10:FF:003485', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218018, NULL, 'G3DSA:1.10.510.10:FF:002520', NULL, NULL, 'Protein mes-1', NULL, NULL, NULL, NULL, NULL, 4),
(218019, NULL, 'G3DSA:3.30.160.60:FF:006475', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218020, NULL, 'G3DSA:1.25.40.180:FF:000101', NULL, NULL, 'Pre-mRNA-splicing factor CWC22', NULL, NULL, NULL, NULL, NULL, 4),
(218021, NULL, 'G3DSA:3.40.50.1440:FF:000144', NULL, NULL, 'Chromosome 15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(218022, NULL, 'G3DSA:3.90.1750.10:FF:000010', NULL, NULL, 'probable E3 ubiquitin-protein ligase HERC4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(218023, NULL, 'G3DSA:3.30.30.30:FF:000021', NULL, NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(218024, NULL, 'G3DSA:1.10.8.10:FF:000187', NULL, NULL, 'E3 ubiquitin-protein ligase HUWE1', NULL, NULL, NULL, NULL, NULL, 4),
(218025, NULL, 'G3DSA:3.40.390.10:FF:000174', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218026, NULL, 'G3DSA:2.60.40.10:FF:002293', NULL, NULL, 'Twitchin', NULL, NULL, NULL, NULL, NULL, 4),
(218027, NULL, 'G3DSA:3.40.50.300:FF:004980', NULL, NULL, 'Ras homolog gene family, member Gd', NULL, NULL, NULL, NULL, NULL, 4),
(218028, NULL, 'G3DSA:2.130.10.10:FF:000180', NULL, NULL, 'WD repeat-containing protein 76', NULL, NULL, NULL, NULL, NULL, 4),
(218029, NULL, 'G3DSA:3.40.50.450:FF:000051', NULL, NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(218030, NULL, 'G3DSA:1.10.8.60:FF:000269', NULL, NULL, 'ATP-dependent Clp protease ATP-binding subunit ClpX', NULL, NULL, NULL, NULL, NULL, 4),
(218031, NULL, 'G3DSA:1.10.287.110:FF:000063', NULL, NULL, 'Translocation protein SEC63', NULL, NULL, NULL, NULL, NULL, 4),
(218032, NULL, 'G3DSA:1.10.220.10:FF:000064', NULL, NULL, 'Annexin D8', NULL, NULL, NULL, NULL, NULL, 4),
(218033, NULL, 'G3DSA:1.20.1070.10:FF:002033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218034, NULL, 'G3DSA:3.80.10.10:FF:003193', NULL, NULL, 'Leucine-Rich Repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(218035, NULL, 'G3DSA:2.40.30.10:FF:000500', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218036, NULL, 'G3DSA:2.10.25.10:FF:001810', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218037, NULL, 'G3DSA:3.30.160.60:FF:002681', NULL, NULL, 'Zinc finger protein 568-like Protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(218038, NULL, 'G3DSA:3.30.450.40:FF:000033', NULL, NULL, 'Transcriptional regulator, IclR family', NULL, NULL, NULL, NULL, NULL, 4),
(218039, NULL, 'G3DSA:2.60.40.1180:FF:000129', NULL, NULL, 'Alpha-L-fucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(218040, NULL, 'G3DSA:3.30.70.330:FF:001943', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218041, NULL, 'G3DSA:1.25.40.10:FF:000735', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(218042, NULL, 'G3DSA:1.25.40.20:FF:000272', NULL, NULL, 'Transient receptor potential cation channel subfamily A member 1', NULL, NULL, NULL, NULL, NULL, 4),
(218043, NULL, 'G3DSA:2.10.25.10:FF:001282', NULL, NULL, 'Adhesion G protein-coupled receptor E1', NULL, NULL, NULL, NULL, NULL, 4),
(218044, NULL, 'G3DSA:3.90.660.10:FF:000133', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218045, NULL, 'G3DSA:3.40.50.300:FF:002063', NULL, NULL, 'DNA helicase related protein', NULL, NULL, NULL, NULL, NULL, 4),
(218046, NULL, 'G3DSA:3.40.50.10240:FF:000029', NULL, NULL, 'Thiamine pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(218047, NULL, 'G3DSA:1.20.1560.10:FF:000075', NULL, NULL, 'Multidrug resistance protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(218048, NULL, 'G3DSA:2.130.10.10:FF:001568', NULL, NULL, 'WD repeat domain 63', NULL, NULL, NULL, NULL, NULL, 4),
(218049, NULL, 'G3DSA:3.30.1050.10:FF:000010', NULL, NULL, 'SDS hydrolase SdsA1', NULL, NULL, NULL, NULL, NULL, 4),
(218050, NULL, 'G3DSA:1.10.510.10:FF:003037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218051, NULL, 'G3DSA:3.30.565.10:FF:000015', NULL, NULL, 'Two-component osmosensing histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(218052, NULL, 'G3DSA:3.50.50.60:FF:001486', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218053, NULL, 'G3DSA:3.30.70.80:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218054, NULL, 'G3DSA:3.40.50.620:FF:000692', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218055, NULL, 'G3DSA:3.40.50.2000:FF:000610', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(218056, NULL, 'G3DSA:3.40.50.300:FF:003468', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(218057, NULL, 'G3DSA:3.30.450.40:FF:000084', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(218058, NULL, 'G3DSA:2.20.100.10:FF:000206', NULL, NULL, 'Golgi apparatus membrane protein TVP23 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(218059, NULL, 'G3DSA:3.30.160.60:FF:004266', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218060, NULL, 'G3DSA:2.40.70.10:FF:000446', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218061, NULL, 'G3DSA:3.30.465.10:FF:000131', NULL, NULL, 'Glycolate oxidase, GlcE subunit', NULL, NULL, NULL, NULL, NULL, 4),
(218062, NULL, 'G3DSA:2.70.130.10:FF:000068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218063, NULL, 'G3DSA:3.30.830.10:FF:000183', NULL, NULL, 'Peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(218064, NULL, 'G3DSA:1.20.1250.20:FF:000094', NULL, NULL, 'protein NRT1/ PTR FAMILY 7.3', NULL, NULL, NULL, NULL, NULL, 4),
(218065, NULL, 'G3DSA:1.10.10.2100:FF:000002', NULL, NULL, 'cell growth-regulating nucleolar protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(218066, NULL, 'G3DSA:3.90.640.10:FF:000250', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(218067, NULL, 'G3DSA:3.60.21.10:FF:000206', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(218068, NULL, 'G3DSA:3.30.160.60:FF:002242', NULL, NULL, 'Zinc finger protein 473', NULL, NULL, NULL, NULL, NULL, 4),
(218069, NULL, 'G3DSA:1.25.10.10:FF:002083', NULL, NULL, 'HEAT repeat-containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(218070, NULL, 'G3DSA:2.20.28.120:FF:000004', NULL, NULL, '50S ribosomal protein L33, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(218071, NULL, 'G3DSA:1.10.10.60:FF:000309', NULL, NULL, 'HTH-type transcriptional activator RhaR', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(218072, NULL, 'G3DSA:2.130.10.10:FF:002006', NULL, NULL, 'Protein HIRA', NULL, NULL, NULL, NULL, NULL, 4),
(218073, NULL, 'G3DSA:3.10.129.10:FF:000035', NULL, NULL, 'Thioesterase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(218074, NULL, 'G3DSA:1.10.8.270:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218075, NULL, 'G3DSA:3.40.50.300:FF:000646', NULL, NULL, 'U5 small nuclear ribonucleoprotein component', NULL, NULL, NULL, NULL, NULL, 4),
(218076, NULL, 'G3DSA:1.10.10.10:FF:000839', NULL, NULL, 'IclR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(218077, NULL, 'G3DSA:2.60.40.1260:FF:000002', NULL, NULL, 'Lamin B1', NULL, NULL, NULL, NULL, NULL, 4),
(218078, NULL, 'G3DSA:3.30.750.24:FF:000072', NULL, NULL, 'Probable Sulfate permease', NULL, NULL, NULL, NULL, NULL, 4),
(218079, NULL, 'G3DSA:3.30.559.10:FF:000074', NULL, NULL, 'BAHD acyltransferase DCR-like', NULL, NULL, NULL, NULL, NULL, 4),
(218080, NULL, 'G3DSA:1.25.10.10:FF:000087', NULL, NULL, 'Unc-45 myosin chaperone A', NULL, NULL, NULL, NULL, NULL, 4),
(218081, NULL, 'G3DSA:2.40.50.140:FF:000349', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(218082, NULL, 'G3DSA:1.20.5.1160:FF:000043', NULL, NULL, 'Keratin, type II cytoskeletal 8', NULL, NULL, NULL, NULL, NULL, 4),
(218083, NULL, 'G3DSA:1.20.1640.10:FF:000076', NULL, NULL, 'NPC intracellular cholesterol transporter 1 homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(218084, NULL, 'G3DSA:2.60.40.1730:FF:000098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218085, NULL, 'G3DSA:2.30.30.140:FF:000342', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218086, NULL, 'G3DSA:3.40.50.300:FF:000034', NULL, NULL, '26S protease regulatory subunit 10B', NULL, NULL, NULL, NULL, NULL, 4),
(218087, NULL, 'G3DSA:1.20.1250.20:FF:000043', NULL, NULL, 'sugar transporter ERD6-like 6', NULL, NULL, NULL, NULL, NULL, 4),
(218088, NULL, 'G3DSA:3.30.70.330:FF:002432', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218089, NULL, 'G3DSA:3.90.1150.10:FF:000032', NULL, NULL, 'Ornithine decarboxylase SpeF', NULL, NULL, NULL, NULL, NULL, 4),
(218090, NULL, 'G3DSA:3.60.20.10:FF:000266', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218091, NULL, 'G3DSA:3.90.780.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218092, NULL, 'G3DSA:2.130.10.10:FF:002057', NULL, NULL, 'CDT (S. pombe CDC10 Dependent Transcript) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(218093, NULL, 'G3DSA:2.30.30.30:FF:000147', NULL, NULL, '60S ribosomal protein L26-1', NULL, NULL, NULL, NULL, NULL, 4),
(218094, NULL, 'G3DSA:2.40.100.10:FF:000163', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(218095, NULL, 'G3DSA:2.10.25.10:FF:000793', NULL, NULL, 'Adhesion G protein-coupled receptor L4', NULL, NULL, NULL, NULL, NULL, 4),
(218096, NULL, 'G3DSA:3.40.50.1820:FF:001270', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(218097, NULL, 'G3DSA:3.10.180.10:FF:000103', NULL, NULL, 'Glr0001 protein', NULL, NULL, NULL, NULL, NULL, 4),
(218098, NULL, 'G3DSA:2.20.25.90:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218099, NULL, 'G3DSA:3.30.160.60:FF:004215', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218100, NULL, 'G3DSA:3.30.160.60:FF:000904', NULL, NULL, 'Zinc finger protein 770', NULL, NULL, NULL, NULL, NULL, 4),
(218101, NULL, 'G3DSA:1.20.1070.10:FF:001285', NULL, NULL, 'melatonin receptor type 1A-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(218102, NULL, 'G3DSA:1.10.3210.10:FF:000006', NULL, NULL, 'Exopolyphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(218103, NULL, 'G3DSA:3.40.50.300:FF:002804', NULL, NULL, 'DNA helicase 2', NULL, NULL, NULL, NULL, NULL, 4),
(218104, NULL, 'G3DSA:3.40.920.10:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218105, NULL, 'G3DSA:2.160.10.10:FF:000128', NULL, NULL, 'UTP--glucose-1-phosphate uridylyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(218106, NULL, 'G3DSA:2.60.40.10:FF:003602', NULL, NULL, 'Novel immune-type receptor 9', NULL, NULL, NULL, NULL, NULL, 4),
(218107, NULL, 'G3DSA:2.60.40.150:FF:000520', NULL, NULL, 'Formin-A', NULL, NULL, NULL, NULL, NULL, 4),
(218108, NULL, 'G3DSA:3.30.420.110:FF:000018', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(218109, NULL, 'G3DSA:3.40.50.300:FF:005317', NULL, NULL, 'Gluconokinase', NULL, NULL, NULL, NULL, NULL, 4),
(218110, NULL, 'G3DSA:3.50.50.60:FF:001126', NULL, NULL, 'Senecionine N-oxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(218111, NULL, 'G3DSA:3.60.15.10:FF:000136', NULL, NULL, 'N-Acyl Phosphatidyl Ethanolamine specific phospholipase D (NAPE-PLD) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(218112, NULL, 'G3DSA:3.90.550.50:FF:000176', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(218113, NULL, 'G3DSA:3.20.20.210:FF:000005', NULL, NULL, 'Uroporphyrinogen decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(218114, NULL, 'G3DSA:3.40.630.30:FF:000480', NULL, NULL, 'Putative N-acetyltransferase san', NULL, NULL, NULL, NULL, NULL, 4),
(218115, NULL, 'G3DSA:3.80.10.10:FF:004502', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(218116, NULL, 'G3DSA:2.60.40.60:FF:000481', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218117, NULL, 'G3DSA:3.90.1150.10:FF:000245', NULL, NULL, 'Pleiotropic regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(218118, NULL, 'G3DSA:3.60.21.10:FF:000257', NULL, NULL, 'Tyrosine-protein phosphatase RLPH2', NULL, NULL, NULL, NULL, NULL, 4),
(218119, NULL, 'G3DSA:3.40.50.1380:FF:000036', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(218120, NULL, 'G3DSA:3.90.70.10:FF:000026', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 15', NULL, NULL, NULL, NULL, NULL, 4),
(218121, NULL, 'G3DSA:3.30.450.90:FF:000019', NULL, NULL, 'General secretion pathway protein E', NULL, NULL, NULL, NULL, NULL, 4),
(218122, NULL, 'G3DSA:2.60.200.20:FF:000186', NULL, NULL, 'FHA domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(218123, NULL, 'G3DSA:3.40.50.1000:FF:000035', NULL, NULL, 'RNA polymerase II C-terminal domain phosphatase-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(218124, NULL, 'G3DSA:2.60.120.10:FF:000648', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218125, NULL, 'G3DSA:3.40.50.300:FF:008139', NULL, NULL, 'Tight junction protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(218126, NULL, 'G3DSA:1.25.10.10:FF:001447', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(218127, NULL, 'G3DSA:1.10.10.10:FF:002060', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(218128, NULL, 'G3DSA:1.10.287.70:FF:000101', NULL, NULL, 'Voltage-gated potassium channel Kch', NULL, NULL, NULL, NULL, NULL, 4),
(218129, NULL, 'G3DSA:3.30.160.60:FF:000264', NULL, NULL, 'Zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(218130, NULL, 'G3DSA:3.40.50.300:FF:007122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218131, NULL, 'G3DSA:3.40.50.1000:FF:000378', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(218132, NULL, 'G3DSA:3.30.420.270:FF:000026', NULL, NULL, 'Biopolymer transport protein ExbD/TolR', NULL, NULL, NULL, NULL, NULL, 4),
(218133, NULL, 'G3DSA:3.50.7.10:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218134, NULL, 'G3DSA:1.25.40.860:FF:000007', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(218135, NULL, 'G3DSA:1.10.10.1390:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218136, NULL, 'G3DSA:1.20.120.20:FF:000012', NULL, NULL, 'Skeleton-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(218137, NULL, 'G3DSA:2.130.10.10:FF:003985', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218138, NULL, 'G3DSA:3.40.50.2300:FF:000138', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(218139, NULL, 'G3DSA:2.10.110.10:FF:000136', NULL, NULL, 'LIM domain family', NULL, NULL, NULL, NULL, NULL, 4),
(218140, NULL, 'G3DSA:3.30.200.20:FF:000447', NULL, NULL, 'Calcium/calmodulin dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(218141, NULL, 'G3DSA:1.10.1520.10:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218142, NULL, 'G3DSA:3.30.465.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218143, NULL, 'G3DSA:1.10.533.10:FF:000139', NULL, NULL, 'Ankyrin-2', NULL, NULL, NULL, NULL, NULL, 4),
(218144, NULL, 'G3DSA:2.160.10.10:FF:000049', NULL, NULL, 'Glucose-1-phosphate adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(218145, NULL, 'G3DSA:3.30.70.980:FF:000036', NULL, NULL, 'Probable transcriptional regulatory protein BbuZS7_0025', NULL, NULL, NULL, NULL, NULL, 4),
(218146, NULL, 'G3DSA:2.60.120.650:FF:000229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218147, NULL, 'G3DSA:3.90.25.10:FF:000051', NULL, NULL, 'UDP-glucose 4-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(218148, NULL, 'G3DSA:1.20.190.40:FF:000005', NULL, NULL, 'Major DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(218149, NULL, 'G3DSA:2.60.40.150:FF:000312', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(218150, NULL, 'G3DSA:3.40.50.300:FF:002271', NULL, NULL, 'Protein ROOT HAIR DEFECTIVE 3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(218151, NULL, 'G3DSA:1.25.40.840:FF:000001', NULL, NULL, 'Ccr4-not transcription complex subunit 1 isoform', NULL, NULL, NULL, NULL, NULL, 4),
(218152, NULL, 'G3DSA:1.25.10.10:FF:003313', NULL, NULL, 'Protein CELLULOSE SYNTHASE INTERACTIVE 3', NULL, NULL, NULL, NULL, NULL, 4),
(218153, NULL, 'G3DSA:3.30.390.50:FF:000031', NULL, NULL, 'Lipoate-protein ligase A subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(218154, NULL, 'G3DSA:2.40.50.140:FF:000006', NULL, NULL, 'Cold shock protein CspC', NULL, NULL, NULL, NULL, NULL, 4),
(218155, NULL, 'G3DSA:3.40.50.12710:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218156, NULL, 'G3DSA:3.10.350.10:FF:000083', NULL, NULL, 'Peptidase M23', NULL, NULL, NULL, NULL, NULL, 4),
(218157, NULL, 'G3DSA:3.30.60.90:FF:000052', NULL, NULL, 'Transcriptional adapter', NULL, NULL, NULL, NULL, NULL, 4),
(218158, NULL, 'G3DSA:3.40.50.300:FF:002855', NULL, NULL, 'Interferon-induced guanylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(218159, NULL, 'G3DSA:1.50.10.150:FF:000008', NULL, NULL, 'Exfoliative toxin A', NULL, NULL, NULL, NULL, NULL, 4),
(218160, NULL, 'G3DSA:2.20.100.10:FF:000257', NULL, NULL, 'Semaphorin-5c', NULL, NULL, NULL, NULL, NULL, 4),
(218161, NULL, 'G3DSA:3.40.50.720:FF:000328', NULL, NULL, 'UDP-glucose 6-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(218162, NULL, 'G3DSA:3.40.120.10:FF:000008', NULL, NULL, 'Alpha-D-glucose phosphate-specific phosphoglucomutase', NULL, NULL, NULL, NULL, NULL, 4),
(218163, NULL, 'G3DSA:3.30.160.60:FF:004479', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218164, NULL, 'G3DSA:1.20.1250.20:FF:002016', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(218165, NULL, 'G3DSA:1.10.405.10:FF:000038', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(218166, NULL, 'G3DSA:3.30.200.20:FF:002476', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218167, NULL, 'G3DSA:1.10.510.10:FF:000732', NULL, NULL, 'Protein serine-threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(218168, NULL, 'G3DSA:3.40.50.300:FF:005497', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(218169, NULL, 'G3DSA:3.10.25.10:FF:000015', NULL, NULL, 'Methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(218170, NULL, 'G3DSA:3.30.160.60:FF:002450', NULL, NULL, 'Zinc finger protein 470', NULL, NULL, NULL, NULL, NULL, 4),
(218171, NULL, 'G3DSA:2.40.10.10:FF:000229', NULL, NULL, 'Si:dkey-33m11.7', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(218172, NULL, 'G3DSA:3.40.50.11370:FF:000008', NULL, NULL, 'Inositol-tetrakisphosphate 1-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(218173, NULL, 'G3DSA:1.10.20.10:FF:000380', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218174, NULL, 'G3DSA:3.40.50.2020:FF:000116', NULL, NULL, 'Phosphoribosyl pyrophosphate synthetase-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(218175, NULL, 'G3DSA:2.60.40.640:FF:000122', NULL, NULL, 'Chromosome 16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(218176, NULL, 'G3DSA:3.30.1780.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218177, NULL, 'G3DSA:1.20.1530.20:FF:000076', NULL, NULL, 'Na+/H+ exchanger', NULL, NULL, NULL, NULL, NULL, 4),
(218178, NULL, 'G3DSA:2.60.40.10:FF:005570', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218179, NULL, 'G3DSA:3.40.720.10:FF:000149', NULL, NULL, 'PhosphatidylInositol Glycan anchor biosynthesis class G', NULL, NULL, NULL, NULL, NULL, 4),
(218180, NULL, 'G3DSA:3.30.420.40:FF:000609', NULL, NULL, 'hexokinase-2 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(218181, NULL, 'G3DSA:2.10.70.10:FF:000077', NULL, NULL, 'Complement component C7', NULL, NULL, NULL, NULL, NULL, 4),
(218182, NULL, 'G3DSA:3.40.50.1820:FF:001169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218183, NULL, 'G3DSA:3.90.70.10:FF:000594', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218184, NULL, 'G3DSA:3.30.70.360:FF:000058', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(218185, NULL, 'G3DSA:1.25.40.10:FF:004501', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218186, NULL, 'G3DSA:1.10.287.470:FF:000086', NULL, NULL, 'Gll0875 protein', NULL, NULL, NULL, NULL, NULL, 4),
(218187, NULL, 'G3DSA:3.40.50.2000:FF:000110', NULL, NULL, 'UDP-N-acetylglucosaminyltransferase protein', NULL, NULL, NULL, NULL, NULL, 4),
(218188, NULL, 'G3DSA:1.10.220.30:FF:000019', NULL, NULL, 'Flagellar motor switch protein FliG', NULL, NULL, NULL, NULL, NULL, 4),
(218189, NULL, 'G3DSA:1.10.1170.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218190, NULL, 'G3DSA:2.10.25.160:FF:000005', NULL, NULL, 'Granulin a', NULL, NULL, NULL, NULL, NULL, 4),
(218191, NULL, 'G3DSA:2.130.10.10:FF:004974', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218192, NULL, 'G3DSA:2.60.120.10:FF:000732', NULL, NULL, 'cGMP-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(218193, NULL, 'G3DSA:3.80.10.10:FF:001276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218194, NULL, 'G3DSA:2.170.120.12:FF:000017', NULL, NULL, 'DNA-directed RNA polymerase II subunit putative', NULL, NULL, NULL, NULL, NULL, 4),
(218195, NULL, 'G3DSA:2.120.10.80:FF:000049', NULL, NULL, 'Cell polarity protein (Tea1)', NULL, NULL, NULL, NULL, NULL, 4),
(218196, NULL, 'G3DSA:3.30.420.40:FF:000025', NULL, NULL, 'pantothenate kinase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(218197, NULL, 'G3DSA:3.20.80.10:FF:000007', NULL, NULL, 'Heme-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(218198, NULL, 'G3DSA:2.60.40.10:FF:000404', NULL, NULL, 'Sortilin related receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(218199, NULL, 'G3DSA:3.40.605.10:FF:000129', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218200, NULL, 'G3DSA:3.30.70.330:FF:002932', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218201, NULL, 'G3DSA:3.30.160.60:FF:002293', NULL, NULL, 'Zinc finger protein 836', NULL, NULL, NULL, NULL, NULL, 4),
(218202, NULL, 'G3DSA:3.40.50.150:FF:001309', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218203, NULL, 'G3DSA:1.50.40.10:FF:000547', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218204, NULL, 'G3DSA:2.60.120.20:FF:000005', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(218205, NULL, 'G3DSA:3.40.50.10540:FF:000001', NULL, NULL, 'L-carnitine CoA-transferase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(218206, NULL, 'G3DSA:1.25.40.10:FF:000494', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(218207, NULL, 'G3DSA:3.30.40.10:FF:001589', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(218208, NULL, 'G3DSA:1.10.390.10:FF:000014', NULL, NULL, 'aminopeptidase O isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(218209, NULL, 'G3DSA:3.40.50.80:FF:000205', NULL, NULL, 'Ferric reductase-like transmembrane component', NULL, NULL, NULL, NULL, NULL, 4),
(218210, NULL, 'G3DSA:1.10.472.10:FF:000210', NULL, NULL, 'Cyclin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(218211, NULL, 'G3DSA:2.60.120.10:FF:000468', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(218212, NULL, 'G3DSA:1.10.10.10:FF:000547', NULL, NULL, 'Peroxisomal membrane protein PEX14', NULL, NULL, NULL, NULL, NULL, 4),
(218213, NULL, 'G3DSA:2.70.150.10:FF:000182', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(218214, NULL, 'G3DSA:3.30.300.110:FF:000008', NULL, NULL, 'tRNA(Phe) (4-demethylwyosine(37)-C(7)) aminocarboxypropyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(218215, NULL, 'G3DSA:1.25.10.10:FF:000458', NULL, NULL, 'Juxtamembrane domain-associated catenin', NULL, NULL, NULL, NULL, NULL, 4),
(218216, NULL, 'G3DSA:3.60.40.10:FF:000278', NULL, NULL, 'Stage II sporulation E family protein', NULL, NULL, NULL, NULL, NULL, 4),
(218217, NULL, 'G3DSA:3.30.250.20:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218218, NULL, 'G3DSA:1.10.238.10:FF:000127', NULL, NULL, 'Mitochondrial Rho GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(218219, NULL, 'G3DSA:3.40.30.10:FF:000374', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(218220, NULL, 'G3DSA:3.40.50.2300:FF:001566', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218221, NULL, 'G3DSA:3.30.70.940:FF:000024', NULL, NULL, 'Transcription elongation factor SPT5', NULL, NULL, NULL, NULL, NULL, 4),
(218222, NULL, 'G3DSA:3.30.160.60:FF:005047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218223, NULL, 'G3DSA:4.10.800.10:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218224, NULL, 'G3DSA:1.10.300.10:FF:000014', NULL, NULL, 'Adenylosuccinate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(218225, NULL, 'G3DSA:3.40.50.1820:FF:000505', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218226, NULL, 'G3DSA:1.25.40.10:FF:001836', NULL, NULL, 'Os03g0852700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(218227, NULL, 'G3DSA:2.60.40.10:FF:004619', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218228, NULL, 'G3DSA:3.90.550.10:FF:000063', NULL, NULL, 'Beta-1,4-N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(218229, NULL, 'G3DSA:3.30.505.10:FF:000247', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218230, NULL, 'G3DSA:1.20.1510.10:FF:000021', NULL, NULL, 'Solute carrier family 30 (Zinc transporter), member 1', NULL, NULL, NULL, NULL, NULL, 4),
(218231, NULL, 'G3DSA:2.80.10.50:FF:000161', NULL, NULL, 'Lectin', NULL, NULL, NULL, NULL, NULL, 4),
(218232, NULL, 'G3DSA:3.30.420.100:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218233, NULL, 'G3DSA:1.10.220.10:FF:000013', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(218234, NULL, 'G3DSA:2.60.120.260:FF:000039', NULL, NULL, 'Reelin', NULL, NULL, NULL, NULL, NULL, 4),
(218235, NULL, 'G3DSA:1.10.220.160:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218236, NULL, 'G3DSA:1.10.10.60:FF:000461', NULL, NULL, 'Sigma-54-dependent Fis family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(218237, NULL, 'G3DSA:2.60.40.10:FF:000668', NULL, NULL, 'transmembrane protein 130 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(218238, NULL, 'G3DSA:3.40.50.300:FF:000085', NULL, NULL, 'Putative ras-related protein rab-11a', NULL, NULL, NULL, NULL, NULL, 4),
(218239, NULL, 'G3DSA:3.40.50.410:FF:000179', NULL, NULL, 'von Willebrand factor type A domain protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(218240, NULL, 'G3DSA:1.10.510.10:FF:003329', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218241, NULL, 'G3DSA:2.40.20.10:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218242, NULL, 'G3DSA:2.60.120.40:FF:000011', NULL, NULL, 'Elastin microfibril interfacer 2', NULL, NULL, NULL, NULL, NULL, 4),
(218243, NULL, 'G3DSA:3.40.30.10:FF:000907', NULL, NULL, 'Antioxidant protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(218244, NULL, 'G3DSA:1.10.8.10:FF:000119', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(218245, NULL, 'G3DSA:2.60.40.10:FF:003153', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(218246, NULL, 'G3DSA:3.30.160.60:FF:000112', NULL, NULL, 'Mds1 and evi1 complex locus protein', NULL, NULL, NULL, NULL, NULL, 4),
(218247, NULL, 'G3DSA:2.70.170.10:FF:000014', NULL, NULL, 'Glycine receptor subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(218248, NULL, 'G3DSA:3.90.730.10:FF:000009', NULL, NULL, 'Ribonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(218249, NULL, 'G3DSA:3.65.10.10:FF:000030', NULL, NULL, '3-phosphoshikimate 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(218250, NULL, 'G3DSA:3.90.550.10:FF:000243', NULL, NULL, 'Glycosyl transferase, group 2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(218251, NULL, 'G3DSA:1.20.5.1150:FF:000001', NULL, NULL, '30S ribosomal protein S21', NULL, NULL, NULL, NULL, NULL, 4),
(218252, NULL, 'G3DSA:2.130.10.10:FF:000472', NULL, NULL, 'Embryonic ectoderm development', NULL, NULL, NULL, NULL, NULL, 4),
(218253, NULL, 'G3DSA:1.10.3090.10:FF:000013', NULL, NULL, 'PolyA polymerase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(218254, NULL, 'G3DSA:2.60.40.150:FF:000632', NULL, NULL, 'Synaptotagmin 2', NULL, NULL, NULL, NULL, NULL, 4),
(218255, NULL, 'G3DSA:3.90.320.10:FF:000046', NULL, NULL, 'YALI0E33377p', NULL, NULL, NULL, NULL, NULL, 4),
(218256, NULL, 'G3DSA:3.40.30.10:FF:000166', NULL, NULL, 'Thioredoxin-like protein AAED1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(218257, NULL, 'G3DSA:2.40.30.130:FF:000011', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(218258, NULL, 'G3DSA:1.25.40.10:FF:000847', NULL, NULL, 'Signal recognition particle subunit SRP72', NULL, NULL, NULL, NULL, NULL, 4),
(218259, NULL, 'G3DSA:3.40.50.10900:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218260, NULL, 'G3DSA:1.10.10.60:FF:000129', NULL, NULL, 'Telomeric repeat-binding factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(218261, NULL, 'G3DSA:3.40.50.2300:FF:000470', NULL, NULL, 'Olfactory receptor family 2 subfamily G member 3', NULL, NULL, NULL, NULL, NULL, 4),
(218262, NULL, 'G3DSA:1.20.120.1200:FF:000024', NULL, NULL, 'NADH-ubiquinone oxidoreductase chain 6', NULL, NULL, NULL, NULL, NULL, 4),
(218263, NULL, 'G3DSA:3.40.50.150:FF:000528', NULL, NULL, 'DNA methyltransferase Dim-2', NULL, NULL, NULL, NULL, NULL, 4),
(218264, NULL, 'G3DSA:3.10.20.90:FF:000741', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(218265, NULL, 'G3DSA:3.90.70.10:FF:000318', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(218266, NULL, 'G3DSA:3.40.30.10:FF:000054', NULL, NULL, 'Disulfide-isomerase A3', NULL, NULL, NULL, NULL, NULL, 4),
(218267, NULL, 'G3DSA:3.30.1960.10:FF:000017', NULL, NULL, 'Reverse transcriptase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(218268, NULL, 'G3DSA:1.10.3550.20:FF:000001', NULL, NULL, 'T4 RNA ligase 1', NULL, NULL, NULL, NULL, NULL, 4),
(218269, NULL, 'G3DSA:1.25.40.20:FF:000384', NULL, NULL, 'Os07g0515700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(218270, NULL, 'G3DSA:1.10.287.70:FF:000073', NULL, NULL, 'Potassium voltage-gated channel subfamily D member 2', NULL, NULL, NULL, NULL, NULL, 4),
(218271, NULL, 'G3DSA:2.40.10.10:FF:000381', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218272, NULL, 'G3DSA:1.10.1420.10:FF:000163', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(218273, NULL, 'G3DSA:1.20.140.180:FF:000001', NULL, NULL, 'RTX toxin RtxA', NULL, NULL, NULL, NULL, NULL, 4),
(218274, NULL, 'G3DSA:3.40.50.720:FF:001964', NULL, NULL, 'Oxidoreductase, short chain dehydrogenase/reductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(218275, NULL, 'G3DSA:3.40.1190.20:FF:000043', NULL, NULL, 'ATP-dependent (S)-NAD(P)H-hydrate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(218276, NULL, 'G3DSA:3.50.50.60:FF:001194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218277, NULL, 'G3DSA:2.60.98.20:FF:000001', NULL, NULL, 'Flagellar hook protein FlgE', NULL, NULL, NULL, NULL, NULL, 4),
(218278, NULL, 'G3DSA:1.25.40.10:FF:003141', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(218279, NULL, 'G3DSA:3.30.450.20:FF:000370', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(218280, NULL, 'G3DSA:3.30.565.10:FF:000066', NULL, NULL, 'Two-component sensor kinase MprB', NULL, NULL, NULL, NULL, NULL, 4),
(218281, NULL, 'G3DSA:3.50.50.60:FF:001418', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218282, NULL, 'G3DSA:3.80.10.10:FF:002636', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218283, NULL, 'G3DSA:1.10.238.10:FF:000071', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(218284, NULL, 'G3DSA:3.40.50.1390:FF:000022', NULL, NULL, 'Probable PhiRv1 integrase', NULL, NULL, NULL, NULL, NULL, 4),
(218285, NULL, 'G3DSA:3.30.540.10:FF:000025', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(218286, NULL, 'G3DSA:3.30.70.270:FF:000183', NULL, NULL, 'PAS/PAC sensor-containing diguanylate cyclase/phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(218287, NULL, 'G3DSA:1.10.580.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218288, NULL, 'G3DSA:3.40.640.10:FF:000267', NULL, NULL, 'L-seryl-tRNA(Sec) selenium transferase', NULL, NULL, NULL, NULL, NULL, 4),
(218289, NULL, 'G3DSA:1.10.287.3240:FF:000036', NULL, NULL, 'Vacuolar H+-ATPase V1 sector, subunit D, putative', NULL, NULL, NULL, NULL, NULL, 4),
(218290, NULL, 'G3DSA:1.10.533.10:FF:000291', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218291, NULL, 'G3DSA:3.40.50.300:FF:004249', NULL, NULL, 'GTPase Der', NULL, NULL, NULL, NULL, NULL, 4),
(218292, NULL, 'G3DSA:2.60.40.420:FF:000005', NULL, NULL, 'Ephrin A5', NULL, NULL, NULL, NULL, NULL, 4),
(218293, NULL, 'G3DSA:3.30.1120.10:FF:000066', NULL, NULL, 'Arylsulphatase A', NULL, NULL, NULL, NULL, NULL, 4),
(218294, NULL, 'G3DSA:2.60.120.620:FF:000018', NULL, NULL, '2-oxoglutarate (2OG) and Fe(II)-dependent oxygenase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(218295, NULL, 'G3DSA:3.30.830.10:FF:000295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218296, NULL, 'G3DSA:4.10.280.10:FF:000101', NULL, NULL, 'Transcription factor PRE4', NULL, NULL, NULL, NULL, NULL, 4),
(218297, NULL, 'G3DSA:1.10.10.10:FF:000727', NULL, NULL, 'Vacuolar sorting protein', NULL, NULL, NULL, NULL, NULL, 4),
(218298, NULL, 'G3DSA:2.60.40.10:FF:001124', NULL, NULL, 'leukemia inhibitory factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(218299, NULL, 'G3DSA:2.170.270.10:FF:000149', NULL, NULL, 'Myeloid/lymphoid or mixed-lineage leukemia', NULL, NULL, NULL, NULL, NULL, 4),
(218300, NULL, 'G3DSA:3.30.499.10:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218301, NULL, 'G3DSA:3.40.50.300:FF:005885', NULL, NULL, 'AAA domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(218302, NULL, 'G3DSA:1.10.287.80:FF:000019', NULL, NULL, 'ATP synthase gamma chain', NULL, NULL, NULL, NULL, NULL, 4),
(218303, NULL, 'G3DSA:3.30.40.10:FF:000021', NULL, NULL, 'Inhibitor of growth 2b', NULL, NULL, NULL, NULL, NULL, 4),
(218304, NULL, 'G3DSA:3.30.70.330:FF:002724', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218305, NULL, 'G3DSA:1.25.40.10:FF:000286', NULL, NULL, 'Tetratricopeptide repeat domain 28', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(218306, NULL, 'G3DSA:1.10.630.10:FF:000090', NULL, NULL, 'Cytochrome P450 monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(218307, NULL, 'G3DSA:1.10.10.60:FF:000989', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218308, NULL, 'G3DSA:2.130.10.10:FF:002349', NULL, NULL, 'WD repeat domain 18', NULL, NULL, NULL, NULL, NULL, 4),
(218309, NULL, 'G3DSA:3.30.160.60:FF:001101', NULL, NULL, 'Zinc finger protein 408', NULL, NULL, NULL, NULL, NULL, 4),
(218310, NULL, 'G3DSA:3.40.640.10:FF:000328', NULL, NULL, 'Dethiobiotin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(218311, NULL, 'G3DSA:1.20.1740.10:FF:000089', NULL, NULL, 'Protein CBG13067', NULL, NULL, NULL, NULL, NULL, 4),
(218312, NULL, 'G3DSA:1.20.1250.20:FF:000886', NULL, NULL, '3-phenylpropionic acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(218313, NULL, 'G3DSA:3.30.1020.10:FF:000002', NULL, NULL, 'Peroxiredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(218314, NULL, 'G3DSA:1.10.20.10:FF:000104', NULL, NULL, 'Transcription initiation factor TFIID subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(218315, NULL, 'G3DSA:3.30.160.20:FF:000100', NULL, NULL, 'Probable peptide chain release factor 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(218316, NULL, 'G3DSA:1.25.10.10:FF:000666', NULL, NULL, 'Exportin 6, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(218317, NULL, 'G3DSA:3.40.50.300:FF:005609', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(218318, NULL, 'G3DSA:2.60.120.10:FF:000356', NULL, NULL, 'Cyclic nucleotide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(218319, NULL, 'G3DSA:3.40.50.300:FF:000826', NULL, NULL, 'Replicative DNA helicase Mcm', NULL, NULL, NULL, NULL, NULL, 4),
(218320, NULL, 'G3DSA:3.10.105.10:FF:000087', NULL, NULL, 'Bacterial extracellular solute-binding protein, family 5', NULL, NULL, NULL, NULL, NULL, 4),
(218321, NULL, 'G3DSA:2.60.40.60:FF:000037', NULL, NULL, 'FAT atypical cadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(218322, NULL, 'G3DSA:3.30.160.60:FF:003698', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218323, NULL, 'G3DSA:2.60.40.10:FF:002821', NULL, NULL, 'Leucine-rich repeats and immunoglobulin-like domains protein sma-10', NULL, NULL, NULL, NULL, NULL, 4),
(218324, NULL, 'G3DSA:3.40.630.30:FF:000249', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(218325, NULL, 'G3DSA:3.10.490.20:FF:000034', NULL, NULL, 'Motor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(218326, NULL, 'G3DSA:2.40.40.20:FF:000043', NULL, NULL, 'NADH-quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(218327, NULL, 'G3DSA:2.130.10.10:FF:004070', NULL, NULL, 'DENN/MADD domain-containing 3b', NULL, NULL, NULL, NULL, NULL, 4),
(218328, NULL, 'G3DSA:3.40.50.80:FF:000025', NULL, NULL, 'Nitrate reductase [NADH]', NULL, NULL, NULL, NULL, NULL, 4),
(218329, NULL, 'G3DSA:3.30.70.330:FF:000515', NULL, NULL, 'RNA-binding motif protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(218330, NULL, 'G3DSA:3.20.20.190:FF:000050', NULL, NULL, 'Glycerophosphoryl diester phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(218331, NULL, 'G3DSA:1.20.58.760:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218332, NULL, 'G3DSA:3.90.105.20:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218333, NULL, 'G3DSA:1.20.5.110:FF:000258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218334, NULL, 'G3DSA:1.10.10.2750:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218335, NULL, 'G3DSA:3.30.1070.10:FF:000005', NULL, NULL, 'Cell division topological specificity factor', NULL, NULL, NULL, NULL, NULL, 4),
(218336, NULL, 'G3DSA:3.10.20.90:FF:000218', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 32', NULL, NULL, NULL, NULL, NULL, 4),
(218337, NULL, 'G3DSA:3.30.40.10:FF:002045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218338, NULL, 'G3DSA:3.90.190.10:FF:000260', NULL, NULL, 'Dual specificity phosphatase 19a', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(218339, NULL, 'G3DSA:2.10.110.10:FF:000316', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218340, NULL, 'G3DSA:2.30.29.30:FF:000110', NULL, NULL, 'Docking protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(218341, NULL, 'G3DSA:3.40.50.300:FF:008370', NULL, NULL, 'Adenylate kinase 9', NULL, NULL, NULL, NULL, NULL, 4),
(218342, NULL, 'G3DSA:1.10.510.10:FF:004318', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218343, NULL, 'G3DSA:3.10.20.90:FF:000865', NULL, NULL, 'Uncharacterized protein C17C9.11c', NULL, NULL, NULL, NULL, NULL, 4),
(218344, NULL, 'G3DSA:2.60.40.1930:FF:000006', NULL, NULL, 'Complement C3', NULL, NULL, NULL, NULL, NULL, 4),
(218345, NULL, 'G3DSA:3.90.1310.10:FF:000016', NULL, NULL, 'PASTA domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(218346, NULL, 'G3DSA:2.10.25.10:FF:001759', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218347, NULL, 'G3DSA:2.60.40.1400:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218348, NULL, 'G3DSA:2.60.260.20:FF:000015', NULL, NULL, 'Heat shock protein 40', NULL, NULL, NULL, NULL, NULL, 4),
(218349, NULL, 'G3DSA:1.10.10.10:FF:000143', NULL, NULL, 'DDRGK domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(218350, NULL, 'G3DSA:2.60.40.150:FF:000132', NULL, NULL, 'Copine 7', NULL, NULL, NULL, NULL, NULL, 4),
(218351, NULL, 'G3DSA:1.20.1560.10:FF:000367', NULL, NULL, 'Probable non-intrinsic ABC protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(218352, NULL, 'G3DSA:3.30.1150.10:FF:000006', NULL, NULL, 'Protein TonB', NULL, NULL, NULL, NULL, NULL, 4),
(218353, NULL, 'G3DSA:2.30.30.40:FF:000537', NULL, NULL, 'Formin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(218354, NULL, 'G3DSA:1.25.40.120:FF:000078', NULL, NULL, 'Protein farnesyltransferase alpha subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(218355, NULL, 'G3DSA:3.30.70.330:FF:002371', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218356, NULL, 'G3DSA:1.20.80.10:FF:000068', NULL, NULL, 'Enoyl-CoA delta isomerase 3, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(218357, NULL, 'G3DSA:3.10.110.10:FF:000273', NULL, NULL, 'Ubiquitin-conjugating enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(218358, NULL, 'G3DSA:1.10.287.950:FF:000016', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(218359, NULL, 'G3DSA:3.90.70.10:FF:000470', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218360, NULL, 'G3DSA:3.40.50.2300:FF:000318', NULL, NULL, 'Sugar ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(218361, NULL, 'G3DSA:3.30.40.10:FF:001038', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(218362, NULL, 'G3DSA:3.30.160.60:FF:004715', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218363, NULL, 'G3DSA:3.30.70.100:FF:000008', NULL, NULL, 'Copper transport protein ATOX1', NULL, NULL, NULL, NULL, NULL, 4),
(218364, NULL, 'G3DSA:2.60.34.10:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218365, NULL, 'G3DSA:3.30.70.870:FF:000003', NULL, NULL, 'GTP-binding protein TypA', NULL, NULL, NULL, NULL, NULL, 4),
(218366, NULL, 'G3DSA:1.10.10.10:FF:001896', NULL, NULL, 'DNA-directed RNA polymerase III subunit rpc3', NULL, NULL, NULL, NULL, NULL, 4),
(218367, NULL, 'G3DSA:1.10.10.60:FF:000540', NULL, NULL, 'HOP homeobox', NULL, NULL, NULL, NULL, NULL, 4),
(218368, NULL, 'G3DSA:1.20.120.420:FF:000013', NULL, NULL, 'Methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(218369, NULL, 'G3DSA:2.60.200.20:FF:000270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218370, NULL, 'G3DSA:3.40.50.720:FF:001385', NULL, NULL, 'Phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(218371, NULL, 'G3DSA:1.10.420.10:FF:000012', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(218372, NULL, 'G3DSA:1.10.3720.10:FF:000091', NULL, NULL, 'Phosphate transport system permease protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(218373, NULL, 'G3DSA:3.40.50.300:FF:006666', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218374, NULL, 'G3DSA:3.30.420.40:FF:000548', NULL, NULL, 'Chaperone protein DnaK HSP70', NULL, NULL, NULL, NULL, NULL, 4),
(218375, NULL, 'G3DSA:2.80.10.50:FF:000082', NULL, NULL, 'Beta/gamma crystallin domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(218376, NULL, 'G3DSA:2.60.40.2830:FF:000001', NULL, NULL, 'Autophagy-related protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(218377, NULL, 'G3DSA:3.90.70.10:FF:000526', NULL, NULL, 'AGAP000884-PA', NULL, NULL, NULL, NULL, NULL, 4),
(218378, NULL, 'G3DSA:2.20.25.10:FF:000073', NULL, NULL, 'Trm112p-like_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(218379, NULL, 'G3DSA:3.30.160.20:FF:000179', NULL, NULL, 'Ribonuclease III', NULL, NULL, NULL, NULL, NULL, 4),
(218380, NULL, 'G3DSA:3.30.260.10:FF:000043', NULL, NULL, 'Chaperonin 1 60 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(218381, NULL, 'G3DSA:3.40.50.150:FF:001540', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218382, NULL, 'G3DSA:3.40.50.790:FF:000017', NULL, NULL, 'Protein CBG11519', NULL, NULL, NULL, NULL, NULL, 4),
(218383, NULL, 'G3DSA:1.10.287.380:FF:000008', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(218384, NULL, 'G3DSA:1.10.620.20:FF:000030', NULL, NULL, 'Os06g0503800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(218385, NULL, 'G3DSA:3.40.50.300:FF:002451', NULL, NULL, 'Midasin', NULL, NULL, NULL, NULL, NULL, 4),
(218386, NULL, 'G3DSA:2.130.10.10:FF:004423', NULL, NULL, 'Protein phosphatase PP2A regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(218387, NULL, 'G3DSA:2.30.230.10:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218388, NULL, 'G3DSA:3.40.50.300:FF:004480', NULL, NULL, 'Protein CBR-RAB-21', NULL, NULL, NULL, NULL, NULL, 4),
(218389, NULL, 'G3DSA:3.40.50.300:FF:005385', NULL, NULL, 'AGAP005926-PA', NULL, NULL, NULL, NULL, NULL, 4),
(218390, NULL, 'G3DSA:2.40.30.10:FF:000213', NULL, NULL, 'Elongation factor 1-alpha, putative', NULL, NULL, NULL, NULL, NULL, 4),
(218391, NULL, 'G3DSA:3.30.1680.10:FF:000035', NULL, NULL, 'Uncharacterized integrin beta-like protein C05D9.3', NULL, NULL, NULL, NULL, NULL, 4),
(218392, NULL, 'G3DSA:3.30.300.10:FF:000002', NULL, NULL, 'GMP synthase [glutamine-hydrolyzing]', NULL, NULL, NULL, NULL, NULL, 4),
(218393, NULL, 'G3DSA:2.60.40.10:FF:003361', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218394, NULL, 'G3DSA:1.10.30.10:FF:000138', NULL, NULL, 'Isw-1', NULL, NULL, NULL, NULL, NULL, 4),
(218395, NULL, 'G3DSA:2.130.10.10:FF:004766', NULL, NULL, 'UDP-galactose:fucoside alpha-3-galactosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(218396, NULL, 'G3DSA:3.40.30.10:FF:000554', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218397, NULL, 'G3DSA:1.25.40.10:FF:004158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218398, NULL, 'G3DSA:3.40.50.720:FF:000216', NULL, NULL, 'Glycerate dehydrogenase HPR, peroxisomal', NULL, NULL, NULL, NULL, NULL, 4),
(218399, NULL, 'G3DSA:2.10.220.10:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218400, NULL, 'G3DSA:1.25.10.10:FF:002291', NULL, NULL, 'Os05g0555100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(218401, NULL, 'G3DSA:2.60.40.60:FF:000722', NULL, NULL, 'Cadherin-4', NULL, NULL, NULL, NULL, NULL, 4),
(218402, NULL, 'G3DSA:2.10.70.10:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218403, NULL, 'G3DSA:1.10.1200.10:FF:000101', NULL, NULL, '6-deoxyerythronolide-B synthase EryA1, modules 1 and 2', NULL, NULL, NULL, NULL, NULL, 4),
(218404, NULL, 'G3DSA:2.40.50.100:FF:000124', NULL, NULL, 'Bll2173 protein', NULL, NULL, NULL, NULL, NULL, 4),
(218405, NULL, 'G3DSA:1.20.1560.10:FF:000103', NULL, NULL, 'Lipid A export ATP-binding/permease protein MsbA', NULL, NULL, NULL, NULL, NULL, 4),
(218406, NULL, 'G3DSA:1.10.418.10:FF:000068', NULL, NULL, 'Putative Filamin-A', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(218407, NULL, 'G3DSA:3.30.40.10:FF:000600', NULL, NULL, 'Phd zn-finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(218408, NULL, 'G3DSA:3.30.160.60:FF:000617', NULL, NULL, 'Zinc finger protein 777', NULL, NULL, NULL, NULL, NULL, 4),
(218409, NULL, 'G3DSA:3.90.1100.10:FF:000034', NULL, NULL, 'DNA-directed RNA polymerase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(218410, NULL, 'G3DSA:3.30.70.890:FF:000082', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(218411, NULL, 'G3DSA:1.25.10.10:FF:002532', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218412, NULL, 'G3DSA:1.20.5.490:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218413, NULL, 'G3DSA:1.20.144.10:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218414, NULL, 'G3DSA:1.20.5.340:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218415, NULL, 'G3DSA:3.90.1300.10:FF:000010', NULL, NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit A, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(218416, NULL, 'G3DSA:3.40.50.880:FF:000123', NULL, NULL, 'Serine O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(218417, NULL, 'G3DSA:1.10.10.10:FF:001003', NULL, NULL, 'Hms2p', NULL, NULL, NULL, NULL, NULL, 4),
(218418, NULL, 'G3DSA:3.40.50.2000:FF:000234', NULL, NULL, 'Glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(218419, NULL, 'G3DSA:1.10.10.10:FF:001267', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(218420, NULL, 'G3DSA:1.20.140.40:FF:000002', NULL, NULL, 'Putative invertase inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(218421, NULL, 'G3DSA:2.60.40.10:FF:004058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218422, NULL, 'G3DSA:3.30.70.660:FF:000030', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(218423, NULL, 'G3DSA:3.90.1580.10:FF:000002', NULL, NULL, 'sulfatase-modifying factor 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(218424, NULL, 'G3DSA:2.30.39.10:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218425, NULL, 'G3DSA:3.40.50.620:FF:000916', NULL, NULL, 'Probable electron transfer flavoprotein subunit alpha, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(218426, NULL, 'G3DSA:3.30.70.250:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218427, NULL, 'G3DSA:3.40.1380.20:FF:000046', NULL, NULL, 'Pyruvate kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(218428, NULL, 'G3DSA:2.130.10.10:FF:000551', NULL, NULL, 'UTP15p Nucleolar protein', NULL, NULL, NULL, NULL, NULL, 4),
(218429, NULL, 'G3DSA:2.10.50.30:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218430, NULL, 'G3DSA:1.10.287.110:FF:000124', NULL, NULL, 'SCJ1p protein', NULL, NULL, NULL, NULL, NULL, 4),
(218431, NULL, 'G3DSA:3.30.160.60:FF:003810', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218432, NULL, 'G3DSA:2.130.10.130:FF:000024', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(218433, NULL, 'G3DSA:4.10.860.10:FF:000016', NULL, NULL, 'ClpC ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(218434, NULL, 'G3DSA:2.130.10.10:FF:003013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218435, NULL, 'G3DSA:3.40.50.2300:FF:001487', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218436, NULL, 'G3DSA:1.20.1730.10:FF:000083', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(218437, NULL, 'G3DSA:3.60.20.10:FF:000058', NULL, NULL, 'Proteasome subunit alpha type', NULL, NULL, NULL, NULL, NULL, 4),
(218438, NULL, 'G3DSA:1.10.20.10:FF:000312', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218439, NULL, 'G3DSA:2.20.70.10:FF:000048', NULL, NULL, 'HECT, C2 and WW domain-containing E3 ubiquitin protein ligase 1', NULL, NULL, NULL, NULL, NULL, 4),
(218440, NULL, 'G3DSA:3.30.365.10:FF:000067', NULL, NULL, 'Aerobic-type carbon monoxide dehydrogenase, large subunit-like protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(218441, NULL, 'G3DSA:1.10.486.10:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218442, NULL, 'G3DSA:2.120.10.30:FF:000063', NULL, NULL, 'NHL repeat containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(218443, NULL, 'G3DSA:2.40.50.140:FF:000849', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218444, NULL, 'G3DSA:3.30.1520.10:FF:000147', NULL, NULL, 'Sorting nexin mvp1', NULL, NULL, NULL, NULL, NULL, 4),
(218445, NULL, 'G3DSA:1.20.1420.30:FF:000043', NULL, NULL, 'Ecm27p', NULL, NULL, NULL, NULL, NULL, 4),
(218446, NULL, 'G3DSA:3.40.50.620:FF:000012', NULL, NULL, 'Phosphopantetheine adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(218447, NULL, 'G3DSA:3.30.160.60:FF:004327', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218448, NULL, 'G3DSA:3.30.930.10:FF:000128', NULL, NULL, 'Phenylalanine-tRNA ligase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(218449, NULL, 'G3DSA:2.115.10.20:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218450, NULL, 'G3DSA:3.60.10.10:FF:000097', NULL, NULL, 'Sphingomyelin phosphodiesterase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(218451, NULL, 'G3DSA:1.10.220.20:FF:000005', NULL, NULL, 'ARF guanine-nucleotide exchange factor GNOM', NULL, NULL, NULL, NULL, NULL, 4),
(218452, NULL, 'G3DSA:3.40.50.300:FF:002119', NULL, NULL, 'DNA repair protein rhp16', NULL, NULL, NULL, NULL, NULL, 4),
(218453, NULL, 'G3DSA:1.10.10.10:FF:000486', NULL, NULL, 'Transcriptional activator protein TraR', NULL, NULL, NULL, NULL, NULL, 4),
(218454, NULL, 'G3DSA:3.40.640.10:FF:000087', NULL, NULL, 'L-threonine aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(218455, NULL, 'G3DSA:3.40.390.10:FF:000106', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(218456, NULL, 'G3DSA:2.70.220.10:FF:000007', NULL, NULL, 'Phosphatidylglycerol/phosphatidylinositol transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(218457, NULL, 'G3DSA:2.70.150.10:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218458, NULL, 'G3DSA:1.10.510.10:FF:002177', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase CES101 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(218459, NULL, 'G3DSA:3.40.50.10090:FF:000046', NULL, NULL, 'Uroporphyrinogen-III C-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(218460, NULL, 'G3DSA:1.10.287.110:FF:000467', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218461, NULL, 'G3DSA:1.20.900.10:FF:000041', NULL, NULL, 'Rho guanyl nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(218462, NULL, 'G3DSA:3.40.30.10:FF:000897', NULL, NULL, 'Protein disulfide isomerase 3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(218463, NULL, 'G3DSA:1.10.510.10:FF:000103', NULL, NULL, 'PTI1-like tyrosine-protein kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(218464, NULL, 'G3DSA:3.40.50.670:FF:000010', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(218465, NULL, 'G3DSA:1.50.40.10:FF:000194', NULL, NULL, 'Mitochondrial substrate carrier family protein Y', NULL, NULL, NULL, NULL, NULL, 4),
(218466, NULL, 'G3DSA:3.40.50.1820:FF:001854', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218467, NULL, 'G3DSA:3.80.10.10:FF:003417', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218468, NULL, 'G3DSA:3.40.50.720:FF:001121', NULL, NULL, 'Calcium-gated potassium channel protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(218469, NULL, 'G3DSA:3.10.620.30:FF:000019', NULL, NULL, 'Peptide-N(4)-(N-acetyl-beta-glucosaminyl)asparagine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(218470, NULL, 'G3DSA:3.40.50.300:FF:006402', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218471, NULL, 'G3DSA:2.60.40.10:FF:005339', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218472, NULL, 'G3DSA:3.90.1660.10:FF:000003', NULL, NULL, 'Coenzyme F420:L-glutamate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(218473, NULL, 'G3DSA:1.25.40.10:FF:003984', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(218474, NULL, 'G3DSA:1.20.1250.20:FF:001791', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(218475, NULL, 'G3DSA:1.10.730.10:FF:000086', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(218476, NULL, 'G3DSA:2.60.40.790:FF:000037', NULL, NULL, 'NudC domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(218477, NULL, 'G3DSA:2.10.25.10:FF:000293', NULL, NULL, 'FAT atypical cadherin 4', NULL, NULL, NULL, NULL, NULL, 4),
(218478, NULL, 'G3DSA:1.25.40.10:FF:002360', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(218479, NULL, 'G3DSA:2.60.40.1170:FF:000059', NULL, NULL, 'F-BAR domain only protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(218480, NULL, 'G3DSA:3.20.20.80:FF:000367', NULL, NULL, 'Putative secreted protein', NULL, NULL, NULL, NULL, NULL, 4),
(218481, NULL, 'G3DSA:3.30.160.60:FF:002793', NULL, NULL, 'Zinc finger protein 574', NULL, NULL, NULL, NULL, NULL, 4),
(218482, NULL, 'G3DSA:2.170.270.10:FF:000014', NULL, NULL, 'PR domain-containing protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(218483, NULL, 'G3DSA:3.40.50.300:FF:001731', NULL, NULL, 'Nitric oxide reductase NorQ protein', NULL, NULL, NULL, NULL, NULL, 4),
(218484, NULL, 'G3DSA:3.30.559.30:FF:000113', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218485, NULL, 'G3DSA:3.60.120.10:FF:000021', NULL, NULL, 'Isochorismate synthase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(218486, NULL, 'G3DSA:3.40.50.300:FF:002794', NULL, NULL, 'ABC Transporter family', NULL, NULL, NULL, NULL, NULL, 4),
(218487, NULL, 'G3DSA:2.40.70.10:FF:000334', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218488, NULL, 'G3DSA:3.30.460.10:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218489, NULL, 'G3DSA:1.20.1070.10:FF:002145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218490, NULL, 'G3DSA:3.40.50.12780:FF:000212', NULL, NULL, 'Putative long-chain-fatty-acid-CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(218491, NULL, 'G3DSA:2.60.120.200:FF:000151', NULL, NULL, 'Laminin subunit alpha 5', NULL, NULL, NULL, NULL, NULL, 4),
(218492, NULL, 'G3DSA:1.10.510.10:FF:004386', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218493, NULL, 'G3DSA:1.20.1610.10:FF:000017', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(218494, NULL, 'G3DSA:2.70.40.10:FF:000022', NULL, NULL, 'Deoxyuridine 5''-triphosphate nucleotidohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(218495, NULL, 'G3DSA:1.10.3380.30:FF:000007', NULL, NULL, 'DExH-box ATP-dependent RNA helicase DExH15 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(218496, NULL, 'G3DSA:2.130.10.10:FF:002737', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(218497, NULL, 'G3DSA:3.30.70.1350:FF:000007', NULL, NULL, 'Cation efflux system', NULL, NULL, NULL, NULL, NULL, 4),
(218498, NULL, 'G3DSA:3.30.200.20:FF:001695', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218499, NULL, 'G3DSA:2.130.10.10:FF:002557', NULL, NULL, 'Syntaxin binding protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(218500, NULL, 'G3DSA:3.90.76.10:FF:000022', NULL, NULL, 'Peptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(218501, NULL, 'G3DSA:1.20.1050.10:FF:000002', NULL, NULL, 'Stringent starvation protein A', NULL, NULL, NULL, NULL, NULL, 4),
(218502, NULL, 'G3DSA:1.10.472.10:FF:000126', NULL, NULL, 'Cyclin domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(218503, NULL, 'G3DSA:3.30.200.20:FF:000059', NULL, NULL, 'S-receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(218504, NULL, 'G3DSA:3.30.70.330:FF:001572', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218505, NULL, 'G3DSA:3.90.660.20:FF:000018', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(218506, NULL, 'G3DSA:3.30.1330.30:FF:000150', NULL, NULL, 'Protein pelota homolog', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(218507, NULL, 'G3DSA:2.30.30.40:FF:000184', NULL, NULL, 'Protein kinase activator Bem1', NULL, NULL, NULL, NULL, NULL, 4),
(218508, NULL, 'G3DSA:1.20.1070.10:FF:001869', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218509, NULL, 'G3DSA:3.30.200.20:FF:001352', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218510, NULL, 'G3DSA:3.40.50.300:FF:000438', NULL, NULL, 'Rho-related GTP-binding protein RhoJ', NULL, NULL, NULL, NULL, NULL, 4),
(218511, NULL, 'G3DSA:2.60.40.10:FF:000747', NULL, NULL, 'obscurin isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(218512, NULL, 'G3DSA:3.40.50.1100:FF:000059', NULL, NULL, 'N-(2-amino-2-carboxyethyl)-L-glutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(218513, NULL, 'G3DSA:4.10.240.10:FF:000104', NULL, NULL, 'PrnA protein', NULL, NULL, NULL, NULL, NULL, 4),
(218514, NULL, 'G3DSA:3.40.50.11460:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218515, NULL, 'G3DSA:1.25.10.10:FF:002796', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218516, NULL, 'G3DSA:3.20.20.70:FF:000089', NULL, NULL, 'Sulfofructosephosphate aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(218517, NULL, 'G3DSA:2.60.40.3210:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218518, NULL, 'G3DSA:3.40.50.2060:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218519, NULL, 'G3DSA:3.10.400.20:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218520, NULL, 'G3DSA:1.25.40.10:FF:001628', NULL, NULL, 'Tetratricopeptide repeat protein 7B-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(218521, NULL, 'G3DSA:1.20.1310.10:FF:000091', NULL, NULL, 'Cullin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(218522, NULL, 'G3DSA:2.160.20.70:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218523, NULL, 'G3DSA:3.40.630.10:FF:000261', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218524, NULL, 'G3DSA:1.10.1420.10:FF:000084', NULL, NULL, 'MutS protein homolog 4', NULL, NULL, NULL, NULL, NULL, 4),
(218525, NULL, 'G3DSA:1.20.58.60:FF:000615', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218526, NULL, 'G3DSA:2.60.40.3850:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218527, NULL, 'G3DSA:1.25.10.10:FF:003072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218528, NULL, 'G3DSA:3.30.559.70:FF:000013', NULL, NULL, 'Carnitine Palmitoyl Transferase', NULL, NULL, NULL, NULL, NULL, 4),
(218529, NULL, 'G3DSA:2.120.10.80:FF:000229', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(218530, NULL, 'G3DSA:3.30.70.1070:FF:000013', NULL, NULL, 'General secretion pathway protein D', NULL, NULL, NULL, NULL, NULL, 4),
(218531, NULL, 'G3DSA:3.40.720.10:FF:000088', NULL, NULL, 'Phosphatidylinositol glycan anchor biosynthesis, class N', NULL, NULL, NULL, NULL, NULL, 4),
(218532, NULL, 'G3DSA:2.120.10.80:FF:000381', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218533, NULL, 'G3DSA:3.10.100.10:FF:000036', NULL, NULL, 'Lymphocyte antigen 75', NULL, NULL, NULL, NULL, NULL, 4),
(218534, NULL, 'G3DSA:1.10.287.370:FF:000062', NULL, NULL, 'AGAP007637-PA', NULL, NULL, NULL, NULL, NULL, 4),
(218535, NULL, 'G3DSA:3.20.20.80:FF:000103', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(218536, NULL, 'G3DSA:3.40.50.1110:FF:000040', NULL, NULL, 'Putative platelet activating factor', NULL, NULL, NULL, NULL, NULL, 4),
(218537, NULL, 'G3DSA:1.10.630.10:FF:000730', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218538, NULL, 'G3DSA:2.70.98.90:FF:000004', NULL, NULL, 'Membrane protein insertase YidC', NULL, NULL, NULL, NULL, NULL, 4),
(218539, NULL, 'G3DSA:1.20.5.960:FF:000002', NULL, NULL, 'Baseplate wedge protein gp10', NULL, NULL, NULL, NULL, NULL, 4),
(218540, NULL, 'G3DSA:3.20.20.140:FF:000349', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(218541, NULL, 'G3DSA:1.20.120.960:FF:000001', NULL, NULL, 'Sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(218542, NULL, 'G3DSA:1.10.357.20:FF:000024', NULL, NULL, 'Solute carrier, putative', NULL, NULL, NULL, NULL, NULL, 4),
(218543, NULL, 'G3DSA:3.30.565.10:FF:000419', NULL, NULL, 'Heat shock protein 75 kDa, mitochondrial-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(218544, NULL, 'G3DSA:2.90.10.10:FF:000036', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(218545, NULL, 'G3DSA:3.40.228.10:FF:000005', NULL, NULL, 'Anaerobic dimethyl sulfoxide reductase, subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(218546, NULL, 'G3DSA:1.25.40.20:FF:000772', NULL, NULL, 'Ankyrin repeats (3 copies), putative', NULL, NULL, NULL, NULL, NULL, 4),
(218547, NULL, 'G3DSA:2.30.30.140:FF:000185', NULL, NULL, 'RING finger protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(218548, NULL, 'G3DSA:3.30.230.10:FF:000215', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(218549, NULL, 'G3DSA:2.60.120.260:FF:000539', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218550, NULL, 'G3DSA:3.40.50.1000:FF:000586', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218551, NULL, 'G3DSA:2.40.160.120:FF:000004', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(218552, NULL, 'G3DSA:2.40.50.140:FF:000506', NULL, NULL, '26S proteasome ATPase subunit S4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(218553, NULL, 'G3DSA:2.10.25.10:FF:000854', NULL, NULL, 'C-type lectin domain family 18 member B', NULL, NULL, NULL, NULL, NULL, 4),
(218554, NULL, 'G3DSA:3.40.190.290:FF:000122', NULL, NULL, 'Transcriptional regulator lysR family', NULL, NULL, NULL, NULL, NULL, 4),
(218555, NULL, 'G3DSA:3.40.50.300:FF:001170', NULL, NULL, 'DNA replication helicase Dna2', NULL, NULL, NULL, NULL, NULL, 4),
(218556, NULL, 'G3DSA:3.30.70.1230:FF:000084', NULL, NULL, 'Adenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(218557, NULL, 'G3DSA:1.10.510.10:FF:003537', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218558, NULL, 'G3DSA:1.25.40.530:FF:000015', NULL, NULL, 'Myosin 28B1, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(218559, NULL, 'G3DSA:3.40.47.10:FF:000093', NULL, NULL, '3-hydroxy-3-methylglutaryl coenzyme A synthase', NULL, NULL, NULL, NULL, NULL, 4),
(218560, NULL, 'G3DSA:3.80.10.10:FF:003693', NULL, NULL, 'Receptor-like protein 52', NULL, NULL, NULL, NULL, NULL, 4),
(218561, NULL, 'G3DSA:3.40.50.300:FF:001995', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(218562, NULL, 'G3DSA:1.25.40.10:FF:004422', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218563, NULL, 'G3DSA:3.30.40.10:FF:000864', NULL, NULL, 'PHD transcription factor Rum1', NULL, NULL, NULL, NULL, NULL, 4),
(218564, NULL, 'G3DSA:1.50.10.10:FF:000023', NULL, NULL, 'Protein-glucosylgalactosylhydroxylysine glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(218565, NULL, 'G3DSA:2.30.30.100:FF:000021', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm1', NULL, NULL, NULL, NULL, NULL, 4),
(218566, NULL, 'G3DSA:3.40.50.720:FF:002133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218567, NULL, 'G3DSA:2.30.30.40:FF:000245', NULL, NULL, 'N-acetylmuramoyl-l-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(218568, NULL, 'G3DSA:1.20.1310.10:FF:000152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218569, NULL, 'G3DSA:3.40.50.300:FF:000377', NULL, NULL, 'transcriptional regulator ATRX isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(218570, NULL, 'G3DSA:1.10.3460.10:FF:000002', NULL, NULL, 'Chlorophyll a-b binding protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(218571, NULL, 'G3DSA:3.10.110.10:FF:000161', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(218572, NULL, 'G3DSA:3.80.10.10:FF:003772', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(218573, NULL, 'G3DSA:2.60.40.10:FF:004327', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218574, NULL, 'G3DSA:1.20.58.1100:FF:000014', NULL, NULL, 'Uncharacterized protein C11E3.02c', NULL, NULL, NULL, NULL, NULL, 4),
(218575, NULL, 'G3DSA:1.25.10.10:FF:001891', NULL, NULL, 'U3 small nucleolar RNA-associated protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(218576, NULL, 'G3DSA:3.30.70.330:FF:003101', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218577, NULL, 'G3DSA:1.10.268.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218578, NULL, 'G3DSA:1.25.40.10:FF:002005', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g27610', NULL, NULL, NULL, NULL, NULL, 4),
(218579, NULL, 'G3DSA:3.30.160.60:FF:000556', NULL, NULL, 'sal-like protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(218580, NULL, 'G3DSA:3.60.21.10:FF:000414', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218581, NULL, 'G3DSA:3.30.160.60:FF:004827', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218582, NULL, 'G3DSA:3.40.20.10:FF:000109', NULL, NULL, 'Scinderin like a', NULL, NULL, NULL, NULL, NULL, 4),
(218583, NULL, 'G3DSA:1.25.40.10:FF:002972', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(218584, NULL, 'G3DSA:3.30.40.10:FF:000364', NULL, NULL, 'Protease-associated PA domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(218585, NULL, 'G3DSA:2.130.10.10:FF:003693', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218586, NULL, 'G3DSA:2.30.30.40:FF:000189', NULL, NULL, 'BAR adaptor protein RVS167', NULL, NULL, NULL, NULL, NULL, 4),
(218587, NULL, 'G3DSA:3.90.1140.10:FF:000031', NULL, NULL, 'U6 snRNA phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(218588, NULL, 'G3DSA:1.25.40.20:FF:001396', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218589, NULL, 'G3DSA:3.30.160.60:FF:001124', NULL, NULL, 'Zinc finger protein 445', NULL, NULL, NULL, NULL, NULL, 4),
(218590, NULL, 'G3DSA:2.10.220.10:FF:000026', NULL, NULL, 'Fraser extracellular matrix complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(218591, NULL, 'G3DSA:2.40.70.10:FF:000103', NULL, NULL, 'Aspartyl protease family', NULL, NULL, NULL, NULL, NULL, 4),
(218592, NULL, 'G3DSA:1.10.418.10:FF:000248', NULL, NULL, 'Coiled-coil domain-containing 88Aa', NULL, NULL, NULL, NULL, NULL, 4),
(218593, NULL, 'G3DSA:1.10.287.100:FF:000003', NULL, NULL, 'Hypothetical alanine and leucine rich protein', NULL, NULL, NULL, NULL, NULL, 4),
(218594, NULL, 'G3DSA:1.10.1740.10:FF:000035', NULL, NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(218595, NULL, 'G3DSA:2.30.30.40:FF:000301', NULL, NULL, 'SH3 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(218596, NULL, 'G3DSA:2.40.50.140:FF:000681', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218597, NULL, 'G3DSA:1.10.10.10:FF:000199', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC3', NULL, NULL, NULL, NULL, NULL, 4),
(218598, NULL, 'G3DSA:1.20.58.2200:FF:000001', NULL, NULL, 'Motility protein FimV', NULL, NULL, NULL, NULL, NULL, 4),
(218599, NULL, 'G3DSA:1.10.150.80:FF:000045', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(218600, NULL, 'G3DSA:1.25.40.10:FF:003484', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(218601, NULL, 'G3DSA:3.40.50.200:FF:000173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218602, NULL, 'G3DSA:3.30.540.10:FF:000048', NULL, NULL, 'WGS project CABT00000000 data, contig 2.15', NULL, NULL, NULL, NULL, NULL, 4),
(218603, NULL, 'G3DSA:1.25.40.20:FF:000940', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218604, NULL, 'G3DSA:1.10.10.10:FF:000204', NULL, NULL, 'Apoptotic protease-activating factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(218605, NULL, 'G3DSA:3.40.50.300:FF:006902', NULL, NULL, 'ABC transporter related', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(218606, NULL, 'G3DSA:3.30.70.1820:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218607, NULL, 'G3DSA:1.10.1420.10:FF:000140', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(218608, NULL, 'G3DSA:2.60.40.10:FF:000112', NULL, NULL, 'Titin a', NULL, NULL, NULL, NULL, NULL, 4),
(218609, NULL, 'G3DSA:3.30.2230.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218610, NULL, 'G3DSA:4.10.860.120:FF:000022', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(218611, NULL, 'G3DSA:2.160.20.10:FF:000230', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(218612, NULL, 'G3DSA:1.10.10.10:FF:000311', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(218613, NULL, 'G3DSA:3.40.850.10:FF:000541', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218614, NULL, 'G3DSA:1.20.1310.10:FF:000096', NULL, NULL, 'Cullin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(218615, NULL, 'G3DSA:1.10.472.10:FF:000446', NULL, NULL, 'AaceriADR384Wp', NULL, NULL, NULL, NULL, NULL, 4),
(218616, NULL, 'G3DSA:2.60.120.1000:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218617, NULL, 'G3DSA:3.40.50.410:FF:000011', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(218618, NULL, 'G3DSA:2.130.10.10:FF:002214', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(218619, NULL, 'G3DSA:3.40.50.720:FF:001621', NULL, NULL, 'NAD-dependent malic enzyme 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(218620, NULL, 'G3DSA:1.10.10.60:FF:000753', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218621, NULL, 'G3DSA:1.20.920.30:FF:000031', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(218622, NULL, 'G3DSA:3.20.20.60:FF:000092', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(218623, NULL, 'G3DSA:3.30.1640.10:FF:000038', NULL, NULL, 'Cell division control protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(218624, NULL, 'G3DSA:2.60.120.200:FF:000331', NULL, NULL, 'FAT atypical cadherin 2', NULL, NULL, NULL, NULL, NULL, 4),
(218625, NULL, 'G3DSA:3.30.160.60:FF:006340', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218626, NULL, 'G3DSA:1.10.510.10:FF:000440', NULL, NULL, 'Serine/threonine-protein kinase bur1', NULL, NULL, NULL, NULL, NULL, 4),
(218627, NULL, 'G3DSA:3.30.70.1440:FF:000001', NULL, NULL, 'Multidrug efflux pump subunit AcrB', NULL, NULL, NULL, NULL, NULL, 4),
(218628, NULL, 'G3DSA:2.60.40.10:FF:004434', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218629, NULL, 'G3DSA:2.60.40.820:FF:000024', NULL, NULL, 'T BoX family', NULL, NULL, NULL, NULL, NULL, 4),
(218630, NULL, 'G3DSA:2.40.10.10:FF:000622', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218631, NULL, 'G3DSA:2.60.40.10:FF:004378', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218632, NULL, 'G3DSA:1.20.272.40:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218633, NULL, 'G3DSA:3.40.50.10140:FF:000089', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(218634, NULL, 'G3DSA:1.10.760.10:FF:000099', NULL, NULL, 'Cytochrome c2', NULL, NULL, NULL, NULL, NULL, 4),
(218635, NULL, 'G3DSA:2.60.40.3430:FF:000001', NULL, NULL, 'protocadherin-15 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(218636, NULL, 'G3DSA:1.10.630.10:FF:000494', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218637, NULL, 'G3DSA:3.30.70.100:FF:000183', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218638, NULL, 'G3DSA:3.40.50.200:FF:000122', NULL, NULL, 'Glr3087 protein', NULL, NULL, NULL, NULL, NULL, 4),
(218639, NULL, 'G3DSA:1.20.58.60:FF:000115', NULL, NULL, 'nesprin-2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(218640, NULL, 'G3DSA:1.10.472.10:FF:000502', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218641, NULL, 'G3DSA:3.80.10.10:FF:003709', NULL, NULL, 'Os08g0446400 protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(218642, NULL, 'G3DSA:1.25.40.20:FF:000884', NULL, NULL, 'Zgc:77223 protein', NULL, NULL, NULL, NULL, NULL, 4),
(218643, NULL, 'G3DSA:3.40.50.10810:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218644, NULL, 'G3DSA:3.30.160.60:FF:005339', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218645, NULL, 'G3DSA:3.30.70.330:FF:000246', NULL, NULL, 'TATA-binding protein-associated factor 2N isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(218646, NULL, 'G3DSA:3.30.505.10:FF:000062', NULL, NULL, 'SH2 domain-containing protein 1A', NULL, NULL, NULL, NULL, NULL, 4),
(218647, NULL, 'G3DSA:1.10.560.10:FF:000151', NULL, NULL, 'T-complex protein 1 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(218648, NULL, 'G3DSA:3.40.50.1980:FF:000008', NULL, NULL, 'Ferrichrome ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(218649, NULL, 'G3DSA:3.40.850.10:FF:000485', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218650, NULL, 'G3DSA:3.40.50.300:FF:005109', NULL, NULL, 'Energy-coupling factor transporter ATP-binding protein EcfA1', NULL, NULL, NULL, NULL, NULL, 4),
(218651, NULL, 'G3DSA:4.10.400.10:FF:000218', NULL, NULL, 'low-density lipoprotein receptor-related protein 2 isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(218652, NULL, 'G3DSA:3.30.1360.120:FF:000016', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(218653, NULL, 'G3DSA:1.20.1070.10:FF:001920', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218654, NULL, 'G3DSA:3.30.60.190:FF:000005', NULL, NULL, 'Putative HIT finger domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(218655, NULL, 'G3DSA:1.20.58.2220:FF:000007', NULL, NULL, 'formin-2', NULL, NULL, NULL, NULL, NULL, 4),
(218656, NULL, 'G3DSA:1.10.287.1490:FF:000084', NULL, NULL, 'Putative adaptor for phosphoinositide 3-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(218657, NULL, 'G3DSA:3.40.50.150:FF:001697', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218658, NULL, 'G3DSA:2.60.40.10:FF:000163', NULL, NULL, 'peroxidasin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(218659, NULL, 'G3DSA:3.40.50.2300:FF:001274', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218660, NULL, 'G3DSA:1.20.58.940:FF:000001', NULL, NULL, 'COPII coat assembly protein SEC16', NULL, NULL, NULL, NULL, NULL, 4),
(218661, NULL, 'G3DSA:1.10.10.10:FF:000255', NULL, NULL, '40S ribosomal protein S19', NULL, NULL, NULL, NULL, NULL, 4),
(218662, NULL, 'G3DSA:1.20.1070.10:FF:001813', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(218663, NULL, 'G3DSA:3.40.50.1000:FF:000243', NULL, NULL, 'Glycerol-3-phosphate 2-O-acyltransferase 6', NULL, NULL, NULL, NULL, NULL, 4),
(218664, NULL, 'G3DSA:3.70.10.10:FF:000017', NULL, NULL, 'DNA damage checkpoint control protein RAD17', NULL, NULL, NULL, NULL, NULL, 4),
(218665, NULL, 'G3DSA:3.40.50.880:FF:000062', NULL, NULL, 'ES1 protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(218666, NULL, 'G3DSA:1.10.287.950:FF:000039', NULL, NULL, 'Sensory rhodopsin II transducer', NULL, NULL, NULL, NULL, NULL, 4),
(218667, NULL, 'G3DSA:3.90.1300.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218668, NULL, 'G3DSA:2.130.10.10:FF:001276', NULL, NULL, 'U3 small nucleolar RNA-associated protein 13,putative', NULL, NULL, NULL, NULL, NULL, 4),
(218669, NULL, 'G3DSA:2.40.10.120:FF:000026', NULL, NULL, 'Cfb protein', NULL, NULL, NULL, NULL, NULL, 4),
(218670, NULL, 'G3DSA:3.30.420.40:FF:000048', NULL, NULL, 'ARP5 actin-related protein 5 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(218671, NULL, 'G3DSA:2.60.40.60:FF:000661', NULL, NULL, 'Cadherin 16', NULL, NULL, NULL, NULL, NULL, 4),
(218672, NULL, 'G3DSA:2.60.120.290:FF:000138', NULL, NULL, 'GD12774', NULL, NULL, NULL, NULL, NULL, 4),
(218673, NULL, 'G3DSA:1.20.120.1750:FF:000110', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(218674, NULL, 'G3DSA:1.50.40.10:FF:000486', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(218675, NULL, 'G3DSA:3.40.50.150:FF:000404', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase H', NULL, NULL, NULL, NULL, NULL, 4),
(218676, NULL, 'G3DSA:3.90.1750.20:FF:000007', NULL, NULL, 'Site-specific recombinase', NULL, NULL, NULL, NULL, NULL, 4),
(218677, NULL, 'G3DSA:1.10.287.630:FF:000005', NULL, NULL, 'cyclic nucleotide-gated cation channel alpha-4', NULL, NULL, NULL, NULL, NULL, 4),
(218678, NULL, 'G3DSA:2.60.40.60:FF:000773', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218679, NULL, 'G3DSA:3.40.50.300:FF:005946', NULL, NULL, 'Putative deah-box rna helicase', NULL, NULL, NULL, NULL, NULL, 4),
(218680, NULL, 'G3DSA:2.120.10.10:FF:000012', NULL, NULL, 'Sialidase [Precursor]', NULL, NULL, NULL, NULL, NULL, 4),
(218681, NULL, 'G3DSA:3.90.70.80:FF:000058', NULL, NULL, 'YALI0F01540p', NULL, NULL, NULL, NULL, NULL, 4),
(218682, NULL, 'G3DSA:2.130.10.10:FF:000764', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(218683, NULL, 'G3DSA:3.90.550.10:FF:000479', NULL, NULL, 'Molybdenum cofactor guanylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(218684, NULL, 'G3DSA:3.40.1370.10:FF:000048', NULL, NULL, '60S ribosomal protein L4', NULL, NULL, NULL, NULL, NULL, 4),
(218685, NULL, 'G3DSA:1.20.120.1760:FF:000051', NULL, NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(218686, NULL, 'G3DSA:3.40.710.10:FF:000087', NULL, NULL, 'Penicillin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(218687, NULL, 'G3DSA:1.10.30.50:FF:000015', NULL, NULL, 'HNH endonuclease domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(218688, NULL, 'G3DSA:3.80.10.10:FF:000787', NULL, NULL, 'Extracellular matrix protein 2, female organ and adipocyte-specific', NULL, NULL, NULL, NULL, NULL, 4),
(218689, NULL, 'G3DSA:3.90.1420.10:FF:000013', NULL, NULL, 'Ribosomal lysine N-methyltransferase 4', NULL, NULL, NULL, NULL, NULL, 4),
(218690, NULL, 'G3DSA:1.20.58.1780:FF:000010', NULL, NULL, 'Nuclear pore complex protein Nup155', NULL, NULL, NULL, NULL, NULL, 4),
(218691, NULL, 'G3DSA:1.10.150.20:FF:000185', NULL, NULL, 'DNA repair endonuclease XPF', NULL, NULL, NULL, NULL, NULL, 4),
(218692, NULL, 'G3DSA:1.25.40.10:FF:003309', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218693, NULL, 'G3DSA:1.25.10.10:FF:001739', NULL, NULL, 'Tbcd-1', NULL, NULL, NULL, NULL, NULL, 4),
(218694, NULL, 'G3DSA:2.130.10.10:FF:005547', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218695, NULL, 'G3DSA:1.20.1110.10:FF:000092', NULL, NULL, 'Calcium-transporting ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(218696, NULL, 'G3DSA:1.10.132.10:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218697, NULL, 'G3DSA:1.20.120.80:FF:000007', NULL, NULL, 'Cytochrome c oxidase subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(218698, NULL, 'G3DSA:3.40.630.30:FF:000660', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(218699, NULL, 'G3DSA:3.30.460.10:FF:000047', NULL, NULL, 'Ribosomal silencing factor RsfS', NULL, NULL, NULL, NULL, NULL, 4),
(218700, NULL, 'G3DSA:3.10.28.10:FF:000033', NULL, NULL, 'Probable intron-encoded endonuclease aI2', NULL, NULL, NULL, NULL, NULL, 4),
(218701, NULL, 'G3DSA:1.10.510.10:FF:001856', NULL, NULL, 'Outer arm dynein light chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(218702, NULL, 'G3DSA:3.40.50.2300:FF:001330', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218703, NULL, 'G3DSA:2.130.10.10:FF:005143', NULL, NULL, 'Vacuolar protein sorting-associated protein 41', NULL, NULL, NULL, NULL, NULL, 4),
(218704, NULL, 'G3DSA:3.30.450.20:FF:000555', NULL, NULL, 'Alkaline phosphatase synthesis sensor protein PhoR', NULL, NULL, NULL, NULL, NULL, 4),
(218705, NULL, 'G3DSA:3.30.450.30:FF:000092', NULL, NULL, 'Profilin', NULL, NULL, NULL, NULL, NULL, 4),
(218706, NULL, 'G3DSA:1.20.1250.20:FF:000386', NULL, NULL, 'MFS general substrate transporter', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(218707, NULL, 'G3DSA:1.10.510.10:FF:002256', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218708, NULL, 'G3DSA:1.10.510.10:FF:001795', NULL, NULL, 'Serine/threonine-protein kinase Nek1', NULL, NULL, NULL, NULL, NULL, 4),
(218709, NULL, 'G3DSA:2.130.10.10:FF:000820', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218710, NULL, 'G3DSA:4.10.1000.10:FF:000033', NULL, NULL, 'zinc finger CCCH domain-containing protein 37', NULL, NULL, NULL, NULL, NULL, 4),
(218711, NULL, 'G3DSA:1.10.510.10:FF:001744', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218712, NULL, 'G3DSA:1.10.1900.10:FF:000014', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(218713, NULL, 'G3DSA:3.40.50.1240:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218714, NULL, 'G3DSA:1.10.3720.10:FF:000040', NULL, NULL, 'Putrescine ABC transporter, permease protein PotI', NULL, NULL, NULL, NULL, NULL, 4),
(218715, NULL, 'G3DSA:3.30.420.10:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218716, NULL, 'G3DSA:3.40.50.150:FF:000348', NULL, NULL, 'S-adenosyl-methionine-sterol-C-methyltransferas (AFU_orthologue AFUA_4G09190)', NULL, NULL, NULL, NULL, NULL, 4),
(218717, NULL, 'G3DSA:3.30.420.40:FF:000593', NULL, NULL, 'DnaK protein', NULL, NULL, NULL, NULL, NULL, 4),
(218718, NULL, 'G3DSA:1.10.472.80:FF:000158', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218719, NULL, 'G3DSA:3.30.160.60:FF:002973', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218720, NULL, 'G3DSA:3.10.100.10:FF:000328', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218721, NULL, 'G3DSA:2.30.230.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218722, NULL, 'G3DSA:3.50.30.30:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218723, NULL, 'G3DSA:2.170.270.10:FF:000037', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(218724, NULL, 'G3DSA:3.40.50.300:FF:000326', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(218725, NULL, 'G3DSA:3.30.50.10:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218726, NULL, 'G3DSA:3.40.50.300:FF:005997', NULL, NULL, 'ATP-dependent Clp protease ATP-binding subunit clpX', NULL, NULL, NULL, NULL, NULL, 4),
(218727, NULL, 'G3DSA:3.40.50.1000:FF:000355', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(218728, NULL, 'G3DSA:3.40.1260.10:FF:000001', NULL, NULL, 'Sulfurtransferase TusD', NULL, NULL, NULL, NULL, NULL, 4),
(218729, NULL, 'G3DSA:1.10.287.70:FF:000258', NULL, NULL, 'TWiK family of potassium channels', NULL, NULL, NULL, NULL, NULL, 4),
(218730, NULL, 'G3DSA:2.60.40.10:FF:001528', NULL, NULL, 'Tyrosine-protein phosphatase 99A', NULL, NULL, NULL, NULL, NULL, 4),
(218731, NULL, 'G3DSA:1.10.287.1490:FF:000140', NULL, NULL, 'Structural maintenance of chromosomes protein 6A', NULL, NULL, NULL, NULL, NULL, 4),
(218732, NULL, 'G3DSA:1.20.1070.10:FF:001864', NULL, NULL, 'Gonadotropin-releasing hormone receptor 2; Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218733, NULL, 'G3DSA:3.10.250.10:FF:000103', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218734, NULL, 'G3DSA:2.60.120.200:FF:000679', NULL, NULL, 'Calnexin homolog-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(218735, NULL, 'G3DSA:1.50.40.10:FF:000435', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(218736, NULL, 'G3DSA:2.30.42.10:FF:000152', NULL, NULL, 'disks large homolog 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(218737, NULL, 'G3DSA:3.30.63.10:FF:000001', NULL, NULL, 'Disks large homolog 1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(218738, NULL, 'G3DSA:3.10.100.10:FF:000391', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218739, NULL, 'G3DSA:3.70.10.10:FF:000068', NULL, NULL, 'Checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(218740, NULL, 'G3DSA:1.25.10.10:FF:002352', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218741, NULL, 'G3DSA:1.10.405.10:FF:000033', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(218742, NULL, 'G3DSA:2.170.270.10:FF:000088', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(218743, NULL, 'G3DSA:3.40.50.300:FF:006161', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(218744, NULL, 'G3DSA:3.30.2410.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218745, NULL, 'G3DSA:1.20.58.390:FF:000139', NULL, NULL, 'AcetylCholine Receptor', NULL, NULL, NULL, NULL, NULL, 4),
(218746, NULL, 'G3DSA:3.40.50.410:FF:000359', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(218747, NULL, 'G3DSA:3.90.70.80:FF:000007', NULL, NULL, 'OTU domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(218748, NULL, 'G3DSA:2.40.10.10:FF:000566', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218749, NULL, 'G3DSA:1.10.150.780:FF:000011', NULL, NULL, 'Probable vacuolar protein sorting-associated protein 16 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(218750, NULL, 'G3DSA:3.40.366.10:FF:000005', NULL, NULL, 'Fatty acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(218751, NULL, 'G3DSA:1.10.3720.10:FF:000096', NULL, NULL, 'Peptide ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(218752, NULL, 'G3DSA:1.20.120.1780:FF:000001', NULL, NULL, '4-hydroxybenzoate octaprenyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(218753, NULL, 'G3DSA:3.40.50.300:FF:003311', NULL, NULL, 'Glycolipid sulfotransferase BCG_1434', NULL, NULL, NULL, NULL, NULL, 4),
(218754, NULL, 'G3DSA:3.40.50.300:FF:002687', NULL, NULL, 'Helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(218755, NULL, 'G3DSA:3.90.950.20:FF:000001', NULL, NULL, 'Competence/damage-inducible domain protein CinA', NULL, NULL, NULL, NULL, NULL, 4),
(218756, NULL, 'G3DSA:3.30.70.330:FF:000291', NULL, NULL, 'CC1-like family splicing factor', NULL, NULL, NULL, NULL, NULL, 4),
(218757, NULL, 'G3DSA:3.30.420.10:FF:000157', NULL, NULL, 'Cell death-related nuclease 4', NULL, NULL, NULL, NULL, NULL, 4),
(218758, NULL, 'G3DSA:2.60.40.150:FF:000655', NULL, NULL, 'Copine Va', NULL, NULL, NULL, NULL, NULL, 4),
(218759, NULL, 'G3DSA:3.40.5.10:FF:000013', NULL, NULL, 'Mitochondrial Ribosomal Protein, Large', NULL, NULL, NULL, NULL, NULL, 4),
(218760, NULL, 'G3DSA:1.25.10.10:FF:000727', NULL, NULL, 'Putative HEAT repeat-containing protein 5A', NULL, NULL, NULL, NULL, NULL, 4),
(218761, NULL, 'G3DSA:3.30.60.30:FF:000062', NULL, NULL, 'Serine protease inhibitor dipetalogastin', NULL, NULL, NULL, NULL, NULL, 4),
(218762, NULL, 'G3DSA:3.30.160.60:FF:000612', NULL, NULL, 'Zinc finger matrin-type protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(218763, NULL, 'G3DSA:1.20.58.60:FF:000166', NULL, NULL, 'Spectrin alpha chain non-erythrocytic 1', NULL, NULL, NULL, NULL, NULL, 4),
(218764, NULL, 'G3DSA:2.60.40.10:FF:000168', NULL, NULL, 'filamin-C isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(218765, NULL, 'G3DSA:1.10.10.60:FF:001265', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218766, NULL, 'G3DSA:2.10.25.10:FF:001574', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218767, NULL, 'G3DSA:2.160.20.10:FF:000281', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218768, NULL, 'G3DSA:2.120.10.30:FF:000563', NULL, NULL, 'Adipocyte plasma membrane-associated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(218769, NULL, 'G3DSA:3.80.10.10:FF:001911', NULL, NULL, 'TOLL-like receptor 9', NULL, NULL, NULL, NULL, NULL, 4),
(218770, NULL, 'G3DSA:3.20.20.80:FF:000210', NULL, NULL, 'Putative hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(218771, NULL, 'G3DSA:1.10.1060.10:FF:000005', NULL, NULL, 'Succinate dehydrogenase iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4),
(218772, NULL, 'G3DSA:3.10.20.90:FF:000680', NULL, NULL, 'Protein CBG08550', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(218773, NULL, 'G3DSA:1.25.40.10:FF:000499', NULL, NULL, 'sorting nexin-21 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(218774, NULL, 'G3DSA:3.40.33.10:FF:000139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218775, NULL, 'G3DSA:3.10.620.30:FF:000014', NULL, NULL, 'DNA repair protein Rad4 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(218776, NULL, 'G3DSA:3.30.70.330:FF:001651', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218777, NULL, 'G3DSA:1.20.1420.30:FF:000020', NULL, NULL, 'Vacuolar cation/proton exchanger', NULL, NULL, NULL, NULL, NULL, 4),
(218778, NULL, 'G3DSA:3.30.470.20:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218779, NULL, 'G3DSA:3.40.50.10860:FF:000030', NULL, NULL, 'Quinate 5-dehydrogenase QutB', NULL, NULL, NULL, NULL, NULL, 4),
(218780, NULL, 'G3DSA:2.30.30.1150:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218781, NULL, 'G3DSA:1.20.272.10:FF:000069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218782, NULL, 'G3DSA:1.20.1270.60:FF:000146', NULL, NULL, 'Glucosamine 6-phosphate N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(218783, NULL, 'G3DSA:3.40.50.1000:FF:000304', NULL, NULL, 'Phosphatase MT3486', NULL, NULL, NULL, NULL, NULL, 4),
(218784, NULL, 'G3DSA:3.40.50.300:FF:006958', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218785, NULL, 'G3DSA:3.40.630.10:FF:000502', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218786, NULL, 'G3DSA:3.40.50.300:FF:007526', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218787, NULL, 'G3DSA:2.60.40.1510:FF:000032', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(218788, NULL, 'G3DSA:3.40.50.2020:FF:000037', NULL, NULL, 'Phosphoribosylpyrophosphate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(218789, NULL, 'G3DSA:3.40.50.720:FF:002245', NULL, NULL, 'Dihydropteridine reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(218790, NULL, 'G3DSA:1.25.40.10:FF:002860', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(218791, NULL, 'G3DSA:1.20.58.60:FF:000110', NULL, NULL, 'Short stop, isoform AA', NULL, NULL, NULL, NULL, NULL, 4),
(218792, NULL, 'G3DSA:1.20.1250.10:FF:000001', NULL, NULL, 'Interferon alpha', NULL, NULL, NULL, NULL, NULL, 4),
(218793, NULL, 'G3DSA:3.30.200.20:FF:001852', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218794, NULL, 'G3DSA:3.30.760.10:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218795, NULL, 'G3DSA:3.40.630.10:FF:000446', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218796, NULL, 'G3DSA:3.40.50.720:FF:001969', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(218797, NULL, 'G3DSA:1.10.510.10:FF:002812', NULL, NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3', NULL, NULL, NULL, NULL, NULL, 4),
(218798, NULL, 'G3DSA:3.80.10.10:FF:001804', NULL, NULL, 'Leucine-rich repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(218799, NULL, 'G3DSA:3.40.366.10:FF:000056', NULL, NULL, 'Malonyl CoA-acyl carrier protein transacylase', NULL, NULL, NULL, NULL, NULL, 4),
(218800, NULL, 'G3DSA:3.30.420.10:FF:000106', NULL, NULL, 'Fusilli, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(218801, NULL, 'G3DSA:1.10.150.130:FF:000013', NULL, NULL, 'Putative integrase KpLE2 phage-like element', NULL, NULL, NULL, NULL, NULL, 4),
(218802, NULL, 'G3DSA:3.80.10.10:FF:001855', NULL, NULL, 'Lap1, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(218803, NULL, 'G3DSA:2.130.10.10:FF:001832', NULL, NULL, 'Putative WD-repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(218804, NULL, 'G3DSA:3.80.10.10:FF:004210', NULL, NULL, 'Probable inactive serine/threonine-protein kinase DDB_G0278909', NULL, NULL, NULL, NULL, NULL, 4),
(218805, NULL, 'G3DSA:1.10.540.10:FF:000116', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(218806, NULL, 'G3DSA:1.20.1250.20:FF:001616', NULL, NULL, 'MFS multidrug transporter, putative (AFU_orthologue AFUA_1G05010)', NULL, NULL, NULL, NULL, NULL, 4),
(218807, NULL, 'G3DSA:2.60.40.10:FF:002017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218808, NULL, 'G3DSA:3.30.40.230:FF:000002', NULL, NULL, 'Glycyl-tRNA synthetase 1', NULL, NULL, NULL, NULL, NULL, 4),
(218809, NULL, 'G3DSA:3.40.1360.10:FF:000042', NULL, NULL, 'Type IIB DNA topoisomerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(218810, NULL, 'G3DSA:2.40.70.10:FF:000177', NULL, NULL, 'Protein CBG08575', NULL, NULL, NULL, NULL, NULL, 4),
(218811, NULL, 'G3DSA:1.25.10.10:FF:000379', NULL, NULL, 'MMS19 nucleotide excision repair protein homolog isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(218812, NULL, 'G3DSA:1.25.40.10:FF:001567', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(218813, NULL, 'G3DSA:1.50.40.10:FF:000379', NULL, NULL, 'Mitochondrial carrier', NULL, NULL, NULL, NULL, NULL, 4),
(218814, NULL, 'G3DSA:1.10.506.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218815, NULL, 'G3DSA:3.90.700.10:FF:000013', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] flavoprotein subunit 1 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(218816, NULL, 'G3DSA:2.130.10.10:FF:002237', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit wuho', NULL, NULL, NULL, NULL, NULL, 4),
(218817, NULL, 'G3DSA:1.10.260.60:FF:000008', NULL, NULL, 'Histone-lysine N-methyltransferase, H3 lysine-79 specific', NULL, NULL, NULL, NULL, NULL, 4),
(218818, NULL, 'G3DSA:2.130.10.10:FF:004131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218819, NULL, 'G3DSA:3.40.1190.10:FF:000006', NULL, NULL, 'UDP-N-acetylmuramoyl-L-alanyl-D-glutamate--2,6-diaminopimelate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(218820, NULL, 'G3DSA:3.40.50.1000:FF:000299', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(218821, NULL, 'G3DSA:1.20.58.2010:FF:000006', NULL, NULL, 'Rop guanine nucleotide exchange factor 9', NULL, NULL, NULL, NULL, NULL, 4),
(218822, NULL, 'G3DSA:2.60.40.10:FF:002080', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(218823, NULL, 'G3DSA:2.160.20.10:FF:000286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218824, NULL, 'G3DSA:3.70.10.10:FF:000124', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218825, NULL, 'G3DSA:3.30.70.330:FF:002612', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218826, NULL, 'G3DSA:1.10.3660.10:FF:000001', NULL, NULL, 'T-protein', NULL, NULL, NULL, NULL, NULL, 4),
(218827, NULL, 'G3DSA:1.20.1070.10:FF:001009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218828, NULL, 'G3DSA:3.30.70.330:FF:002988', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218829, NULL, 'G3DSA:3.40.50.10330:FF:000051', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(218830, NULL, 'G3DSA:1.10.10.10:FF:001559', NULL, NULL, 'Pre-mRNA splicing helicase', NULL, NULL, NULL, NULL, NULL, 4),
(218831, NULL, 'G3DSA:3.40.50.300:FF:002294', NULL, NULL, 'Elongation factor G (EF-G)', NULL, NULL, NULL, NULL, NULL, 4),
(218832, NULL, 'G3DSA:3.90.226.10:FF:000321', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(218833, NULL, 'G3DSA:3.30.160.60:FF:004035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218834, NULL, 'G3DSA:1.10.418.10:FF:000225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218835, NULL, 'G3DSA:2.60.210.10:FF:000003', NULL, NULL, 'Speckle-type POZ protein-like a', NULL, NULL, NULL, NULL, NULL, 4),
(218836, NULL, 'G3DSA:3.40.50.261:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218837, NULL, 'G3DSA:3.40.50.12470:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(218838, NULL, 'G3DSA:3.90.830.10:FF:000017', NULL, NULL, 'Putative syntaxin binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(218839, NULL, 'G3DSA:2.10.109.10:FF:000015', NULL, NULL, 'Mitochondrial inner membrane protease subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(218840, NULL, 'G3DSA:2.60.40.1210:FF:000004', NULL, NULL, 'Cellobiose dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(218841, NULL, 'G3DSA:2.90.10.10:FF:000013', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase LECRK1', NULL, NULL, NULL, NULL, NULL, 4),
(218842, NULL, 'G3DSA:3.30.2350.10:FF:000016', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(218843, NULL, 'G3DSA:3.30.720.220:FF:000001', NULL, NULL, 'Jumping translocation breakpoint', NULL, NULL, NULL, NULL, NULL, 4),
(218844, NULL, 'G3DSA:3.40.1110.10:FF:000226', NULL, NULL, 'Cation transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(218845, NULL, 'G3DSA:3.90.226.10:FF:000214', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(218846, NULL, 'G3DSA:1.10.287.40:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218847, NULL, 'G3DSA:3.40.640.10:FF:000323', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(218848, NULL, 'G3DSA:3.30.230.80:FF:000034', NULL, NULL, 'LD43460p', NULL, NULL, NULL, NULL, NULL, 4),
(218849, NULL, 'G3DSA:3.30.460.10:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218850, NULL, 'G3DSA:2.60.40.10:FF:003945', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218851, NULL, 'G3DSA:1.25.40.10:FF:005226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218852, NULL, 'G3DSA:1.10.260.40:FF:000053', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(218853, NULL, 'G3DSA:2.130.10.10:FF:004182', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218854, NULL, 'G3DSA:3.40.367.20:FF:000033', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(218855, NULL, 'G3DSA:1.25.50.20:FF:000098', NULL, NULL, 'Aminopeptidase A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(218856, NULL, 'G3DSA:3.30.565.10:FF:000307', NULL, NULL, 'Signal-transducing histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(218857, NULL, 'G3DSA:1.25.40.10:FF:000611', NULL, NULL, 'TPR repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(218858, NULL, 'G3DSA:1.25.40.10:FF:001516', NULL, NULL, 'Tetratricopeptide repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(218859, NULL, 'G3DSA:3.30.428.10:FF:000006', NULL, NULL, 'm7GpppX diphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(218860, NULL, 'G3DSA:3.40.50.2000:FF:000341', NULL, NULL, 'Glycogen phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(218861, NULL, 'G3DSA:1.20.1050.130:FF:000030', NULL, NULL, 'Glutathione S-transferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(218862, NULL, 'G3DSA:1.50.10.20:FF:000088', NULL, NULL, 'Terpene cyclase/mutase family member', NULL, NULL, NULL, NULL, NULL, 4),
(218863, NULL, 'G3DSA:3.30.810.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218864, NULL, 'G3DSA:2.60.40.10:FF:002585', NULL, NULL, 'FiLamiN (Actin binding protein) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(218865, NULL, 'G3DSA:1.10.10.2660:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218866, NULL, 'G3DSA:2.40.10.10:FF:000561', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218867, NULL, 'G3DSA:3.80.10.10:FF:000894', NULL, NULL, 'Os08g0322500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(218868, NULL, 'G3DSA:3.40.190.10:FF:000417', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(218869, NULL, 'G3DSA:3.80.10.10:FF:001063', NULL, NULL, 'AGAP012317-PA', NULL, NULL, NULL, NULL, NULL, 4),
(218870, NULL, 'G3DSA:2.30.30.550:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218871, NULL, 'G3DSA:3.90.550.10:FF:000535', NULL, NULL, 'Cellulose synthase catalytic subunit A [UDP-forming]', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(218872, NULL, 'G3DSA:1.10.20.10:FF:000025', NULL, NULL, 'Transcription initiation factor TFIID subunit 11', NULL, NULL, NULL, NULL, NULL, 4),
(218873, NULL, 'G3DSA:1.10.10.10:FF:001508', NULL, NULL, 'Catabolite gene activator', NULL, NULL, NULL, NULL, NULL, 4),
(218874, NULL, 'G3DSA:3.30.200.20:FF:000003', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(218875, NULL, 'G3DSA:1.10.287.110:FF:000355', NULL, NULL, 'Chaperone protein DnaJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(218876, NULL, 'G3DSA:3.40.50.1220:FF:000073', NULL, NULL, 'Nicotinamide nucleotide transhydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(218877, NULL, 'G3DSA:1.25.40.10:FF:001011', NULL, NULL, 'Mitochondrial splicing system-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(218878, NULL, 'G3DSA:1.25.40.790:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218879, NULL, 'G3DSA:1.10.287.110:FF:000411', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218880, NULL, 'G3DSA:3.90.70.80:FF:000002', NULL, NULL, 'OTU domain-containing protein 5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(218881, NULL, 'G3DSA:3.30.70.2970:FF:000004', NULL, NULL, 'Interleukin-1 receptor-associated kinase 1 binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(218882, NULL, 'G3DSA:2.120.10.80:FF:000206', NULL, NULL, 'Acyl-CoA-binding domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(218883, NULL, 'G3DSA:1.10.510.10:FF:000339', NULL, NULL, 'Serine/threonine-protein kinase SRPK-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(218884, NULL, 'G3DSA:3.40.1060.10:FF:000002', NULL, NULL, 'Aconitate hydratase B', NULL, NULL, NULL, NULL, NULL, 4),
(218885, NULL, 'G3DSA:1.20.120.350:FF:000144', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218886, NULL, 'G3DSA:2.130.10.10:FF:004923', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(218887, NULL, 'G3DSA:2.60.120.620:FF:000069', NULL, NULL, 'Phytanoyl-CoA dioxygenase family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(218888, NULL, 'G3DSA:3.80.10.10:FF:000495', NULL, NULL, 'Leucine-rich repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(218889, NULL, 'G3DSA:2.40.50.140:FF:001018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218890, NULL, 'G3DSA:1.10.510.10:FF:001800', NULL, NULL, 'Lectin-domain containing receptor kinase A4.1', NULL, NULL, NULL, NULL, NULL, 4),
(218891, NULL, 'G3DSA:3.30.420.10:FF:000449', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(218892, NULL, 'G3DSA:1.10.1520.10:FF:000092', NULL, NULL, 'Endoribonuclease Dicer-like', NULL, NULL, NULL, NULL, NULL, 4),
(218893, NULL, 'G3DSA:2.40.30.330:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218894, NULL, 'G3DSA:1.20.5.2950:FF:000001', NULL, NULL, 'V-type proton ATPase subunit G', NULL, NULL, NULL, NULL, NULL, 4),
(218895, NULL, 'G3DSA:1.10.10.1200:FF:000007', NULL, NULL, 'Melanoma-associated antigen C2', NULL, NULL, NULL, NULL, NULL, 4),
(218896, NULL, 'G3DSA:1.25.40.10:FF:004658', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(218897, NULL, 'G3DSA:1.20.144.10:FF:000070', NULL, NULL, 'Lipid phosphate phosphatase delta', NULL, NULL, NULL, NULL, NULL, 4),
(218898, NULL, 'G3DSA:1.20.58.60:FF:000059', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(218899, NULL, 'G3DSA:3.10.20.90:FF:000573', NULL, NULL, 'Ubiquitin-like protein atg-12', NULL, NULL, NULL, NULL, NULL, 4),
(218900, NULL, 'G3DSA:3.30.710.10:FF:000140', NULL, NULL, 'Zinc finger and BTB domain-containing protein 32', NULL, NULL, NULL, NULL, NULL, 4),
(218901, NULL, 'G3DSA:3.30.710.10:FF:000084', NULL, NULL, 'regulatory protein NPR5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(218902, NULL, 'G3DSA:3.40.50.300:FF:006166', NULL, NULL, 'Midasin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(218903, NULL, 'G3DSA:2.30.130.10:FF:000037', NULL, NULL, 'tRNA pseudouridine synthase B', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(218904, NULL, 'G3DSA:3.30.70.330:FF:002084', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218905, NULL, 'G3DSA:3.30.420.40:FF:000885', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(218906, NULL, 'G3DSA:1.10.510.10:FF:001452', NULL, NULL, 'Cell division protein kinase 2 putative', NULL, NULL, NULL, NULL, NULL, 4),
(218907, NULL, 'G3DSA:2.60.120.10:FF:000176', NULL, NULL, 'Calcium-binding mitochondrial carrier protein SCaMC-1', NULL, NULL, NULL, NULL, NULL, 4),
(218908, NULL, 'G3DSA:2.10.220.10:FF:000021', NULL, NULL, 'proprotein convertase subtilisin/kexin type 6', NULL, NULL, NULL, NULL, NULL, 4),
(218909, NULL, 'G3DSA:3.20.20.70:FF:000482', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218910, NULL, 'G3DSA:3.80.10.10:FF:000843', NULL, NULL, 'Leucine-rich repeat-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(218911, NULL, 'G3DSA:1.25.40.20:FF:001845', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(218912, NULL, 'G3DSA:2.60.120.620:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218913, NULL, 'G3DSA:1.25.10.10:FF:002296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218914, NULL, 'G3DSA:3.30.2320.30:FF:000003', NULL, NULL, 'V-type proton ATPase subunit E', NULL, NULL, NULL, NULL, NULL, 4),
(218915, NULL, 'G3DSA:2.60.40.10:FF:002641', NULL, NULL, 'Interleukin 4 receptor, tandem duplicate 1', NULL, NULL, NULL, NULL, NULL, 4),
(218916, NULL, 'G3DSA:1.10.287.70:FF:000365', NULL, NULL, 'TWiK family of potassium channels', NULL, NULL, NULL, NULL, NULL, 4),
(218917, NULL, 'G3DSA:2.70.40.10:FF:000027', NULL, NULL, 'Deoxyuridine 5''-triphosphate nucleotidohydrolase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(218918, NULL, 'G3DSA:3.30.565.10:FF:000358', NULL, NULL, 'Unplaced genomic scaffold supercont2.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(218919, NULL, 'G3DSA:3.40.50.1110:FF:000096', NULL, NULL, 'Putative isoamyl acetate hydrolytic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(218920, NULL, 'G3DSA:2.60.40.10:FF:003041', NULL, NULL, 'Fms-related tyrosine kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(218921, NULL, 'G3DSA:1.10.3720.10:FF:000152', NULL, NULL, 'Amino acid ABC transporter membrane protein 1 (PAAT family)', NULL, NULL, NULL, NULL, NULL, 4),
(218922, NULL, 'G3DSA:1.10.1900.10:FF:000019', NULL, NULL, 'Polyadenylate-binding protein 1-B', NULL, NULL, NULL, NULL, NULL, 4),
(218923, NULL, 'G3DSA:1.10.3380.30:FF:000002', NULL, NULL, 'superkiller viralicidic activity 2-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(218924, NULL, 'G3DSA:3.40.50.200:FF:000066', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(218925, NULL, 'G3DSA:2.60.120.200:FF:000336', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218926, NULL, 'G3DSA:1.25.40.10:FF:000555', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(218927, NULL, 'G3DSA:1.50.10.20:FF:000144', NULL, NULL, 'Terpene cyclase/mutase family member', NULL, NULL, NULL, NULL, NULL, 4),
(218928, NULL, 'G3DSA:1.25.40.20:FF:000092', NULL, NULL, 'inversin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(218929, NULL, 'G3DSA:3.30.160.60:FF:004890', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218930, NULL, 'G3DSA:3.30.70.330:FF:001595', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218931, NULL, 'G3DSA:3.30.50.10:FF:000022', NULL, NULL, 'glucocorticoid receptor isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(218932, NULL, 'G3DSA:3.40.50.1010:FF:000184', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218933, NULL, 'G3DSA:1.10.533.10:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218934, NULL, 'G3DSA:2.40.128.20:FF:000049', NULL, NULL, 'Lipocalin 8', NULL, NULL, NULL, NULL, NULL, 4),
(218935, NULL, 'G3DSA:1.10.3260.10:FF:000009', NULL, NULL, 'Probable DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(218936, NULL, 'G3DSA:1.10.150.20:FF:000180', NULL, NULL, 'DNA repair enzyme', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(218937, NULL, 'G3DSA:2.60.120.200:FF:000735', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218938, NULL, 'G3DSA:3.90.470.20:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218939, NULL, 'G3DSA:3.40.50.720:FF:000660', NULL, NULL, 'Unplaced genomic scaffold supercont1.113, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(218940, NULL, 'G3DSA:2.130.10.10:FF:004710', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(218941, NULL, 'G3DSA:3.40.50.880:FF:000011', NULL, NULL, 'Carbamoyl-phosphate synthase small chain', NULL, NULL, NULL, NULL, NULL, 4),
(218942, NULL, 'G3DSA:3.90.740.10:FF:000010', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(218943, NULL, 'G3DSA:3.40.50.1820:FF:001793', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(218944, NULL, 'G3DSA:3.60.20.10:FF:000002', NULL, NULL, 'ATP-dependent protease subunit HslV', NULL, NULL, NULL, NULL, NULL, 4),
(218945, NULL, 'G3DSA:3.40.50.300:FF:008015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218946, NULL, 'G3DSA:1.20.1410.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218947, NULL, 'G3DSA:2.60.40.10:FF:000904', NULL, NULL, 'RIM-binding protein, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(218948, NULL, 'G3DSA:1.20.120.910:FF:000008', NULL, NULL, 'Zinc finger transcriptional regulator, TraR/DksA family', NULL, NULL, NULL, NULL, NULL, 4),
(218949, NULL, 'G3DSA:1.10.287.70:FF:000314', NULL, NULL, 'Voltage-gated Ca2+ channel, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(218950, NULL, 'G3DSA:3.30.1330.20:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218951, NULL, 'G3DSA:3.40.30.10:FF:000958', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218952, NULL, 'G3DSA:3.40.50.1000:FF:000647', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218953, NULL, 'G3DSA:2.170.150.10:FF:000034', NULL, NULL, 'Putative translationally-controlled tumor protein-like protein TPT1P8', NULL, NULL, NULL, NULL, NULL, 4),
(218954, NULL, 'G3DSA:3.40.50.10140:FF:000033', NULL, NULL, 'Toll-4', NULL, NULL, NULL, NULL, NULL, 4),
(218955, NULL, 'G3DSA:4.10.400.10:FF:000370', NULL, NULL, 'Serine protease nudel', NULL, NULL, NULL, NULL, NULL, 4),
(218956, NULL, 'G3DSA:1.10.260.40:FF:000002', NULL, NULL, 'HTH-type transcriptional repressor PurR', NULL, NULL, NULL, NULL, NULL, 4),
(218957, NULL, 'G3DSA:3.30.40.10:FF:001325', NULL, NULL, 'AER016Cp', NULL, NULL, NULL, NULL, NULL, 4),
(218958, NULL, 'G3DSA:3.30.230.10:FF:000390', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(218959, NULL, 'G3DSA:3.80.20.20:FF:000105', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(218960, NULL, 'G3DSA:3.80.10.10:FF:001332', NULL, NULL, 'Toll-like receptor 11', NULL, NULL, NULL, NULL, NULL, 4),
(218961, NULL, 'G3DSA:1.20.1070.10:FF:001072', NULL, NULL, 'lysophosphatidic acid receptor 1-B-like', NULL, NULL, NULL, NULL, NULL, 4),
(218962, NULL, 'G3DSA:2.10.25.10:FF:000118', NULL, NULL, 'protein delta homolog 2', NULL, NULL, NULL, NULL, NULL, 4),
(218963, NULL, 'G3DSA:3.40.190.290:FF:000061', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(218964, NULL, 'G3DSA:1.25.40.20:FF:000833', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(218965, NULL, 'G3DSA:3.30.200.20:FF:000891', NULL, NULL, 'Probable peptidoglycan biosynthesis protein MviN', NULL, NULL, NULL, NULL, NULL, 4),
(218966, NULL, 'G3DSA:3.40.50.1820:FF:000781', NULL, NULL, 'Fungal cellulose binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(218967, NULL, 'G3DSA:3.10.120.10:FF:000043', NULL, NULL, 'Potential delta(6)-or delta(8)-desaturase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(218968, NULL, 'G3DSA:3.30.2020.30:FF:000014', NULL, NULL, 'Gamma Butyrobetaine Hydroxylase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(218969, NULL, 'G3DSA:3.40.50.2300:FF:000762', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218970, NULL, 'G3DSA:3.30.540.10:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218971, NULL, 'G3DSA:3.10.20.90:FF:000972', NULL, NULL, 'Myosin-G heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(218972, NULL, 'G3DSA:3.40.30.10:FF:000397', NULL, NULL, 'Protein disulfide-isomerase EUG1', NULL, NULL, NULL, NULL, NULL, 4),
(218973, NULL, 'G3DSA:1.10.472.80:FF:000214', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218974, NULL, 'G3DSA:3.30.70.330:FF:003045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(218975, NULL, 'G3DSA:2.60.120.200:FF:000387', NULL, NULL, 'Galactan endo-beta-1,3-galactanase', NULL, NULL, NULL, NULL, NULL, 4),
(218976, NULL, 'G3DSA:3.90.70.10:FF:000239', NULL, NULL, 'Calpain family cysteine protease', NULL, NULL, NULL, NULL, NULL, 4),
(218977, NULL, 'G3DSA:1.10.238.10:FF:000239', NULL, NULL, 'N-terminal EF-hand calcium-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(218978, NULL, 'G3DSA:3.30.1370.120:FF:000001', NULL, NULL, 'General secretion pathway protein D', NULL, NULL, NULL, NULL, NULL, 4),
(218979, NULL, 'G3DSA:3.40.50.620:FF:000416', NULL, NULL, 'Arginine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(218980, NULL, 'G3DSA:3.30.1370.10:FF:000225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218981, NULL, 'G3DSA:3.90.226.10:FF:000265', NULL, NULL, 'Nodulation protein NfeD', NULL, NULL, NULL, NULL, NULL, 4),
(218982, NULL, 'G3DSA:3.20.20.220:FF:000065', NULL, NULL, 'Methylenetetrahydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(218983, NULL, 'G3DSA:3.10.250.10:FF:000047', NULL, NULL, 'Protein bark beetle', NULL, NULL, NULL, NULL, NULL, 4),
(218984, NULL, 'G3DSA:1.10.1040.10:FF:000066', NULL, NULL, '3-hydroxyisobutyrate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(218985, NULL, 'G3DSA:1.10.340.40:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218986, NULL, 'G3DSA:1.25.10.10:FF:000435', NULL, NULL, 'Ubiquitin ligase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(218987, NULL, 'G3DSA:3.30.460.10:FF:000103', NULL, NULL, 'Ribosomal silencing factor RsfS', NULL, NULL, NULL, NULL, NULL, 4),
(218988, NULL, 'G3DSA:1.10.510.10:FF:000491', NULL, NULL, 'SRSF protein kinase 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(218989, NULL, 'G3DSA:3.40.50.1240:FF:000079', NULL, NULL, 'Phosphoglycerate mutase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(218990, NULL, 'G3DSA:2.60.34.10:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218991, NULL, 'G3DSA:3.40.50.720:FF:002189', NULL, NULL, 'Hydroxysteroid (17-beta) dehydrogenase 8', NULL, NULL, NULL, NULL, NULL, 4),
(218992, NULL, 'G3DSA:1.20.58.60:FF:000458', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218993, NULL, 'G3DSA:4.10.170.10:FF:000003', NULL, NULL, 'Cellular tumor antigen p53', NULL, NULL, NULL, NULL, NULL, 4),
(218994, NULL, 'G3DSA:3.30.497.10:FF:000137', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(218995, NULL, 'G3DSA:1.20.1070.10:FF:000796', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(218996, NULL, 'G3DSA:3.30.2450.10:FF:000001', NULL, NULL, 'SPI-2 type III secretion system effector PipB', NULL, NULL, NULL, NULL, NULL, 4),
(218997, NULL, 'G3DSA:3.30.40.10:FF:001538', NULL, NULL, 'CDK-activating kinase assembly factor MAT1', NULL, NULL, NULL, NULL, NULL, 4),
(218998, NULL, 'G3DSA:3.40.50.620:FF:000068', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(218999, NULL, 'G3DSA:3.30.40.10:FF:000072', NULL, NULL, 'lysine-specific demethylase 5C isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(219000, NULL, 'G3DSA:1.25.40.90:FF:000028', NULL, NULL, 'TOM1-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(219001, NULL, 'G3DSA:3.40.50.300:FF:000669', NULL, NULL, 'Ras-related protein Rab-23', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(219002, NULL, 'G3DSA:3.30.60.20:FF:000076', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(219003, NULL, 'G3DSA:2.10.55.10:FF:000002', NULL, NULL, 'leishmanolysin-like peptidase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(219004, NULL, 'G3DSA:3.30.200.100:FF:000005', NULL, NULL, 'Sigma E factor regulatory protein RseB', NULL, NULL, NULL, NULL, NULL, 4),
(219005, NULL, 'G3DSA:1.25.10.10:FF:002801', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219006, NULL, 'G3DSA:3.30.70.1320:FF:000015', NULL, NULL, 'AcrB/AcrD/AcrF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(219007, NULL, 'G3DSA:2.130.10.10:FF:003018', NULL, NULL, 'SAGA complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(219008, NULL, 'G3DSA:1.20.1250.20:FF:000835', NULL, NULL, 'Organic anion transporting polypeptide 33Eb', NULL, NULL, NULL, NULL, NULL, 4),
(219009, NULL, 'G3DSA:2.130.10.10:FF:002506', NULL, NULL, 'Beta-alanine-activating enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(219010, NULL, 'G3DSA:1.20.5.110:FF:000101', NULL, NULL, 'Serine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(219011, NULL, 'G3DSA:1.25.10.10:FF:003257', NULL, NULL, 'phosphoinositide 3-kinase regulatory subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(219012, NULL, 'G3DSA:3.80.10.10:FF:003480', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219013, NULL, 'G3DSA:3.40.50.720:FF:001913', NULL, NULL, 'Os07g0602050 protein', NULL, NULL, NULL, NULL, NULL, 4),
(219014, NULL, 'G3DSA:3.40.630.10:FF:000030', NULL, NULL, 'nicastrin', NULL, NULL, NULL, NULL, NULL, 4),
(219015, NULL, 'G3DSA:1.10.510.10:FF:000783', NULL, NULL, 'Proline-rich receptor-like protein kinase PERK4', NULL, NULL, NULL, NULL, NULL, 4),
(219016, NULL, 'G3DSA:2.30.30.490:FF:000031', NULL, NULL, 'Unplaced genomic scaffold supercont2.14, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(219017, NULL, 'G3DSA:2.60.40.640:FF:000015', NULL, NULL, 'Vacuolar protein sorting-associated protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(219018, NULL, 'G3DSA:2.60.40.10:FF:002872', NULL, NULL, 'MPL proto-oncogene, thrombopoietin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(219019, NULL, 'G3DSA:1.20.5.110:FF:000045', NULL, NULL, 'Syntaxin 4', NULL, NULL, NULL, NULL, NULL, 4),
(219020, NULL, 'G3DSA:3.30.760.10:FF:000031', NULL, NULL, 'Eukaryotic translation initiation factor 4E, putative', NULL, NULL, NULL, NULL, NULL, 4),
(219021, NULL, 'G3DSA:1.25.40.10:FF:003192', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(219022, NULL, 'G3DSA:1.10.730.10:FF:000035', NULL, NULL, 'Methionine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(219023, NULL, 'G3DSA:3.10.20.90:FF:000005', NULL, NULL, 'Polyubiquitin 11', NULL, NULL, NULL, NULL, NULL, 4),
(219024, NULL, 'G3DSA:3.30.200.20:FF:001964', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219025, NULL, 'G3DSA:1.25.70.10:FF:000091', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219026, NULL, 'G3DSA:2.40.10.10:FF:000274', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219027, NULL, 'G3DSA:3.30.160.60:FF:000848', NULL, NULL, 'Zinc finger protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(219028, NULL, 'G3DSA:3.90.1410.10:FF:000075', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(219029, NULL, 'G3DSA:2.60.40.200:FF:000018', NULL, NULL, 'Copper chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(219030, NULL, 'G3DSA:1.10.287.380:FF:000003', NULL, NULL, 'ABC transporter ATP-binding protein uup', NULL, NULL, NULL, NULL, NULL, 4),
(219031, NULL, 'G3DSA:1.25.40.10:FF:003877', NULL, NULL, 'Tetratricopeptide repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(219032, NULL, 'G3DSA:1.20.1250.20:FF:001403', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219033, NULL, 'G3DSA:3.30.2350.20:FF:000002', NULL, NULL, 'Pseudouridylate synthase 7 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(219034, NULL, 'G3DSA:2.10.90.10:FF:000084', NULL, NULL, 'Gonadal soma derived factor variant 2', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(219035, NULL, 'G3DSA:1.25.40.540:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219036, NULL, 'G3DSA:1.10.150.50:FF:000177', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(219037, NULL, 'G3DSA:3.40.50.1100:FF:000054', NULL, NULL, 'Phenylserine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(219038, NULL, 'G3DSA:2.40.50.140:FF:000057', NULL, NULL, 'Single-stranded DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(219039, NULL, 'G3DSA:3.40.630.30:FF:000036', NULL, NULL, 'Acetyltransferase, GNAT', NULL, NULL, NULL, NULL, NULL, 4),
(219040, NULL, 'G3DSA:3.40.50.300:FF:008307', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219041, NULL, 'G3DSA:3.10.170.20:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219042, NULL, 'G3DSA:1.10.238.10:FF:000863', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219043, NULL, 'G3DSA:1.25.40.20:FF:001053', NULL, NULL, 'CARD- and ANK-containing Inflammasome Adaptor Protein', NULL, NULL, NULL, NULL, NULL, 4),
(219044, NULL, 'G3DSA:2.40.50.140:FF:000113', NULL, NULL, 'polyribonucleotide nucleotidyltransferase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(219045, NULL, 'G3DSA:3.90.1720.30:FF:000003', NULL, NULL, 'BnaCnng47550D protein', NULL, NULL, NULL, NULL, NULL, 4),
(219046, NULL, 'G3DSA:3.50.4.10:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219047, NULL, 'G3DSA:3.40.140.10:FF:000122', NULL, NULL, 'Putative inactive tRNA-specific adenosine deaminase-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(219048, NULL, 'G3DSA:2.130.10.10:FF:004654', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219049, NULL, 'G3DSA:3.40.50.11500:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219050, NULL, 'G3DSA:1.25.40.20:FF:000209', NULL, NULL, 'protein fem-1 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(219051, NULL, 'G3DSA:1.10.486.10:FF:000012', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(219052, NULL, 'G3DSA:2.60.40.1180:FF:000068', NULL, NULL, 'Glucuronoxylanase XynC', NULL, NULL, NULL, NULL, NULL, 4),
(219053, NULL, 'G3DSA:3.40.50.1000:FF:000535', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219054, NULL, 'G3DSA:3.30.420.40:FF:000992', NULL, NULL, 'Pantothenate kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(219055, NULL, 'G3DSA:3.90.70.40:FF:000018', NULL, NULL, 'AGAP005226-PA', NULL, NULL, NULL, NULL, NULL, 4),
(219056, NULL, 'G3DSA:3.60.21.10:FF:000021', NULL, NULL, 'Serine/threonine-protein phosphatase 5', NULL, NULL, NULL, NULL, NULL, 4),
(219057, NULL, 'G3DSA:3.40.50.1820:FF:001118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219058, NULL, 'G3DSA:1.20.58.390:FF:000027', NULL, NULL, 'Histamine-gated chloride channel subunit', NULL, NULL, NULL, NULL, NULL, 4),
(219059, NULL, 'G3DSA:3.30.160.60:FF:003866', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219060, NULL, 'G3DSA:1.50.10.130:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219061, NULL, 'G3DSA:1.20.1560.10:FF:000316', NULL, NULL, 'ABC transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(219062, NULL, 'G3DSA:3.30.40.10:FF:001269', NULL, NULL, 'Os12g0527800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(219063, NULL, 'G3DSA:1.20.58.830:FF:000024', NULL, NULL, 'Duffy receptor', NULL, NULL, NULL, NULL, NULL, 4),
(219064, NULL, 'G3DSA:2.60.260.20:FF:000066', NULL, NULL, 'Xdj1p', NULL, NULL, NULL, NULL, NULL, 4),
(219065, NULL, 'G3DSA:3.40.50.300:FF:004036', NULL, NULL, 'Replication protein E1', NULL, NULL, NULL, NULL, NULL, 4),
(219066, NULL, 'G3DSA:3.50.30.80:FF:000001', NULL, NULL, 'Dihydroxy-acid dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(219067, NULL, 'G3DSA:3.40.50.2300:FF:000998', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219068, NULL, 'G3DSA:2.60.120.260:FF:000146', NULL, NULL, 'Glycosyl hydrolase family 10 protein', NULL, NULL, NULL, NULL, NULL, 4),
(219069, NULL, 'G3DSA:2.60.40.10:FF:004726', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(219070, NULL, 'G3DSA:2.40.10.10:FF:000330', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219071, NULL, 'G3DSA:3.40.850.10:FF:000193', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(219072, NULL, 'G3DSA:1.10.510.10:FF:004049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219073, NULL, 'G3DSA:3.90.650.10:FF:000071', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(219074, NULL, 'G3DSA:4.10.970.10:FF:000013', NULL, NULL, 'Putative dna-binding subunit of a dna-dependent protein kinase ku70 autoantigen', NULL, NULL, NULL, NULL, NULL, 4),
(219075, NULL, 'G3DSA:3.40.50.620:FF:000809', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219076, NULL, 'G3DSA:3.40.50.2000:FF:000846', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219077, NULL, 'G3DSA:3.30.1300.10:FF:000007', NULL, NULL, 'Pantothenate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(219078, NULL, 'G3DSA:3.10.350.10:FF:000032', NULL, NULL, 'Putative lipoprotein NlpD', NULL, NULL, NULL, NULL, NULL, 4),
(219079, NULL, 'G3DSA:3.40.50.300:FF:002799', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(219080, NULL, 'G3DSA:1.25.10.10:FF:000615', NULL, NULL, 'AP-2 complex subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(219081, NULL, 'G3DSA:2.10.25.10:FF:000450', NULL, NULL, 'Integrin subunit beta like 1', NULL, NULL, NULL, NULL, NULL, 4),
(219082, NULL, 'G3DSA:2.60.120.10:FF:000625', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219083, NULL, 'G3DSA:1.20.1280.50:FF:000082', NULL, NULL, 'F-box only protein 42', NULL, NULL, NULL, NULL, NULL, 4),
(219084, NULL, 'G3DSA:2.60.120.920:FF:000097', NULL, NULL, 'B-box and SPRY domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(219085, NULL, 'G3DSA:2.60.40.1900:FF:000003', NULL, NULL, 'Si:ch1073-70f20.1', NULL, NULL, NULL, NULL, NULL, 4),
(219086, NULL, 'G3DSA:1.10.150.50:FF:000233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219087, NULL, 'G3DSA:2.40.50.40:FF:000050', NULL, NULL, 'flap endonuclease GEN-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(219088, NULL, 'G3DSA:3.40.50.720:FF:001172', NULL, NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(219089, NULL, 'G3DSA:1.20.140.40:FF:000076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219090, NULL, 'G3DSA:1.10.418.10:FF:000012', NULL, NULL, 'Plastin-3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(219091, NULL, 'G3DSA:3.30.780.10:FF:000026', NULL, NULL, 'Translation initiation factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(219092, NULL, 'G3DSA:1.10.150.670:FF:000001', NULL, NULL, 'Crossover junction endonuclease MUS81', NULL, NULL, NULL, NULL, NULL, 4),
(219093, NULL, 'G3DSA:2.130.10.10:FF:001040', NULL, NULL, 'Protein phosphatase PP2A regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(219094, NULL, 'G3DSA:3.10.20.90:FF:000281', NULL, NULL, 'Ubiquitin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(219095, NULL, 'G3DSA:2.70.150.10:FF:000131', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(219096, NULL, 'G3DSA:3.40.640.10:FF:000379', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219097, NULL, 'G3DSA:1.20.120.1500:FF:000001', NULL, NULL, 'Pre-hexon-linking protein IIIa', NULL, NULL, NULL, NULL, NULL, 4),
(219098, NULL, 'G3DSA:3.90.550.10:FF:000647', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(219099, NULL, 'G3DSA:1.10.287.110:FF:000299', NULL, NULL, 'DnaJ heat shock protein family (Hsp40) member C18', NULL, NULL, NULL, NULL, NULL, 4),
(219100, NULL, 'G3DSA:1.20.120.350:FF:000088', NULL, NULL, 'Protein CBG09661', NULL, NULL, NULL, NULL, NULL, 4),
(219101, NULL, 'G3DSA:1.10.530.10:FF:000054', NULL, NULL, 'SPbeta prophage-derived uncharacterized transglycosylase YomI', NULL, NULL, NULL, NULL, NULL, 4),
(219102, NULL, 'G3DSA:3.10.20.310:FF:000026', NULL, NULL, 'Patatin-like protein, PlpD', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(219103, NULL, 'G3DSA:1.10.3470.10:FF:000059', NULL, NULL, 'Putative cation ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(219104, NULL, 'G3DSA:2.60.120.330:FF:000139', NULL, NULL, 'Protein DMR6-LIKE OXYGENASE 2', NULL, NULL, NULL, NULL, NULL, 4),
(219105, NULL, 'G3DSA:1.25.40.20:FF:001901', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219106, NULL, 'G3DSA:1.10.150.20:FF:000073', NULL, NULL, 'Translocation protein SEC63', NULL, NULL, NULL, NULL, NULL, 4),
(219107, NULL, 'G3DSA:3.90.1110.10:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219108, NULL, 'G3DSA:1.25.40.10:FF:000263', NULL, NULL, 'SEL1L, ERAD E3 ligase adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(219109, NULL, 'G3DSA:2.60.40.10:FF:000455', NULL, NULL, 'Protogenin A', NULL, NULL, NULL, NULL, NULL, 4),
(219110, NULL, 'G3DSA:1.20.1070.10:FF:001521', NULL, NULL, 'Atypical chemokine receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(219111, NULL, 'G3DSA:2.60.40.10:FF:000511', NULL, NULL, 'Nectin cell adhesion molecule 3', NULL, NULL, NULL, NULL, NULL, 4),
(219112, NULL, 'G3DSA:3.30.830.10:FF:000300', NULL, NULL, 'Clan ME, family M16, insulinase-like metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(219113, NULL, 'G3DSA:1.25.40.10:FF:004714', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219114, NULL, 'G3DSA:2.60.40.10:FF:004906', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219115, NULL, 'G3DSA:2.30.110.10:FF:000098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219116, NULL, 'G3DSA:3.40.50.2000:FF:000902', NULL, NULL, 'WbcM protein', NULL, NULL, NULL, NULL, NULL, 4),
(219117, NULL, 'G3DSA:1.10.287.70:FF:000657', NULL, NULL, 'Potassium channel, subfamily K, member 16', NULL, NULL, NULL, NULL, NULL, 4),
(219118, NULL, 'G3DSA:3.30.160.60:FF:003759', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219119, NULL, 'G3DSA:3.20.20.80:FF:000659', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219120, NULL, 'G3DSA:3.20.20.80:FF:000479', NULL, NULL, 'Oligo-1,6-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(219121, NULL, 'G3DSA:1.10.238.20:FF:000012', NULL, NULL, 'AGAP001189-PA', NULL, NULL, NULL, NULL, NULL, 4),
(219122, NULL, 'G3DSA:3.30.160.60:FF:006396', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219123, NULL, 'G3DSA:3.30.40.10:FF:002106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219124, NULL, 'G3DSA:1.20.120.1750:FF:000166', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(219125, NULL, 'G3DSA:3.40.50.300:FF:006397', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219126, NULL, 'G3DSA:1.10.10.1100:FF:000016', NULL, NULL, 'FAD-dependent pyridine nucleotide-disulfide oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(219127, NULL, 'G3DSA:2.40.110.10:FF:000045', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(219128, NULL, 'G3DSA:1.10.10.10:FF:001216', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(219129, NULL, 'G3DSA:1.10.510.10:FF:004381', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219130, NULL, 'G3DSA:1.25.40.10:FF:000443', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(219131, NULL, 'G3DSA:2.130.10.10:FF:001220', NULL, NULL, 'WD repeat-containing protein 65', NULL, NULL, NULL, NULL, NULL, 4),
(219132, NULL, 'G3DSA:1.20.1070.10:FF:001341', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219133, NULL, 'G3DSA:2.10.90.10:FF:000140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219134, NULL, 'G3DSA:1.10.287.70:FF:000022', NULL, NULL, 'Small conductance calcium-activated potassium channel, isoform O', NULL, NULL, NULL, NULL, NULL, 4),
(219135, NULL, 'G3DSA:1.25.10.10:FF:003364', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(219136, NULL, 'G3DSA:3.40.50.1950:FF:000016', NULL, NULL, 'Cypemycin cysteine dehydrogenase (decarboxylating)', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(219137, NULL, 'G3DSA:1.20.58.900:FF:000017', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(219138, NULL, 'G3DSA:3.60.120.10:FF:000026', NULL, NULL, 'Isochorismate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(219139, NULL, 'G3DSA:3.30.70.580:FF:000068', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(219140, NULL, 'G3DSA:1.20.140.150:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219141, NULL, 'G3DSA:1.10.533.10:FF:000240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219142, NULL, 'G3DSA:2.60.120.200:FF:000443', NULL, NULL, 'Os02g0299000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(219143, NULL, 'G3DSA:3.50.50.60:FF:000406', NULL, NULL, 'Possible oxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(219144, NULL, 'G3DSA:2.60.40.10:FF:003310', NULL, NULL, 'CAMTA (CAlModulin-binding Transcriptional activator)', NULL, NULL, NULL, NULL, NULL, 4),
(219145, NULL, 'G3DSA:3.90.1150.210:FF:000012', NULL, NULL, 'F-actin-capping protein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(219146, NULL, 'G3DSA:1.10.455.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219147, NULL, 'G3DSA:2.40.10.230:FF:000003', NULL, NULL, 'NAF1 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(219148, NULL, 'G3DSA:3.40.50.300:FF:008583', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(219149, NULL, 'G3DSA:2.60.40.790:FF:000032', NULL, NULL, 'NudC domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(219150, NULL, 'G3DSA:3.30.70.270:FF:000132', NULL, NULL, 'Diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(219151, NULL, 'G3DSA:3.30.70.360:FF:000007', NULL, NULL, 'Peptidase, M20/M25/M40 family', NULL, NULL, NULL, NULL, NULL, 4),
(219152, NULL, 'G3DSA:1.20.120.550:FF:000029', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(219153, NULL, 'G3DSA:1.10.287.90:FF:000028', NULL, NULL, 'Cytochrome c oxidase subunit II', NULL, NULL, NULL, NULL, NULL, 4),
(219154, NULL, 'G3DSA:3.30.200.20:FF:001060', NULL, NULL, 'CMGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(219155, NULL, 'G3DSA:2.60.40.60:FF:000374', NULL, NULL, 'Cadherin-related hmr-1', NULL, NULL, NULL, NULL, NULL, 4),
(219156, NULL, 'G3DSA:3.40.50.300:FF:003524', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(219157, NULL, 'G3DSA:3.30.60.90:FF:000001', NULL, NULL, 'Dystrophin isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(219158, NULL, 'G3DSA:1.50.40.10:FF:000087', NULL, NULL, 'SLC (SoLute Carrier) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(219159, NULL, 'G3DSA:1.25.40.10:FF:001859', NULL, NULL, 'Tetratricopeptide repeat domain 4', NULL, NULL, NULL, NULL, NULL, 4),
(219160, NULL, 'G3DSA:3.30.40.10:FF:000757', NULL, NULL, 'San1p', NULL, NULL, NULL, NULL, NULL, 4),
(219161, NULL, 'G3DSA:3.90.550.10:FF:000086', NULL, NULL, 'Putative ceramide glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(219162, NULL, 'G3DSA:1.10.510.10:FF:002020', NULL, NULL, 'Protein nipi-3', NULL, NULL, NULL, NULL, NULL, 4),
(219163, NULL, 'G3DSA:1.10.1140.10:FF:000006', NULL, NULL, 'ATP synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(219164, NULL, 'G3DSA:2.40.30.10:FF:000449', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219165, NULL, 'G3DSA:3.30.160.60:FF:004322', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219166, NULL, 'G3DSA:1.20.1250.20:FF:001347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219167, NULL, 'G3DSA:1.10.510.10:FF:004094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219168, NULL, 'G3DSA:2.40.70.10:FF:000502', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219169, NULL, 'G3DSA:3.30.9.10:FF:000067', NULL, NULL, 'Unplaced genomic scaffold supercont2.12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(219170, NULL, 'G3DSA:2.60.40.2070:FF:000003', NULL, NULL, 'Putative fimbrial outer membrane usher', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(219171, NULL, 'G3DSA:3.40.710.10:FF:000031', NULL, NULL, 'Penicillin-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(219172, NULL, 'G3DSA:1.10.10.520:FF:000011', NULL, NULL, 'Ubiquitin-activating enzyme E1-like', NULL, NULL, NULL, NULL, NULL, 4),
(219173, NULL, 'G3DSA:3.80.10.10:FF:000551', NULL, NULL, 'Si:dkey-286j17.4', NULL, NULL, NULL, NULL, NULL, 4),
(219174, NULL, 'G3DSA:3.30.200.20:FF:002420', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219175, NULL, 'G3DSA:3.40.50.620:FF:000124', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(219176, NULL, 'G3DSA:2.130.10.10:FF:005199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219177, NULL, 'G3DSA:1.10.472.170:FF:000019', NULL, NULL, 'Cyclin/Brf1-like TBP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(219178, NULL, 'G3DSA:3.30.70.330:FF:002140', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219179, NULL, 'G3DSA:4.10.60.10:FF:000139', NULL, NULL, 'Cold shock domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(219180, NULL, 'G3DSA:3.30.2140.20:FF:000008', NULL, NULL, 'Arylamine N-acetyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(219181, NULL, 'G3DSA:3.40.190.10:FF:000170', NULL, NULL, 'Glutamate receptor ionotropic, NMDA 2D', NULL, NULL, NULL, NULL, NULL, 4),
(219182, NULL, 'G3DSA:1.10.20.10:FF:000317', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219183, NULL, 'G3DSA:1.25.40.20:FF:000541', NULL, NULL, 'Arginine N-methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(219184, NULL, 'G3DSA:1.20.58.60:FF:000402', NULL, NULL, 'AGAP009554-PA', NULL, NULL, NULL, NULL, NULL, 4),
(219185, NULL, 'G3DSA:1.20.1110.10:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219186, NULL, 'G3DSA:1.20.1310.10:FF:000040', NULL, NULL, 'Putative cullin-1', NULL, NULL, NULL, NULL, NULL, 4),
(219187, NULL, 'G3DSA:3.40.720.10:FF:000037', NULL, NULL, 'Nucleotide pyrophosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(219188, NULL, 'G3DSA:3.40.50.300:FF:007234', NULL, NULL, 'Atlastin 3', NULL, NULL, NULL, NULL, NULL, 4),
(219189, NULL, 'G3DSA:2.60.120.650:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219190, NULL, 'G3DSA:2.130.10.10:FF:002288', NULL, NULL, 'WD_repeat_and_HMG-box_DNA-binding_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(219191, NULL, 'G3DSA:3.30.530.20:FF:000140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219192, NULL, 'G3DSA:1.20.140.10:FF:000134', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219193, NULL, 'G3DSA:3.30.160.60:FF:000668', NULL, NULL, 'zinc finger protein 346 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(219194, NULL, 'G3DSA:3.30.530.20:FF:000084', NULL, NULL, 'Polyketide cyclase / dehydrase and lipid transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(219195, NULL, 'G3DSA:1.10.10.60:FF:000192', NULL, NULL, 'Homeobox-leucine zipper protein HAT22', NULL, NULL, NULL, NULL, NULL, 4),
(219196, NULL, 'G3DSA:3.30.1490.110:FF:000002', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(219197, NULL, 'G3DSA:3.30.110.10:FF:000004', NULL, NULL, 'Translation initiation factor IF-3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(219198, NULL, 'G3DSA:3.30.40.10:FF:000252', NULL, NULL, 'E3 ubiquitin-protein ligase LRSAM1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(219199, NULL, 'G3DSA:3.40.50.300:FF:001107', NULL, NULL, 'Cell division control protein 48-B-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(219200, NULL, 'G3DSA:3.60.110.10:FF:000020', NULL, NULL, 'Glutamine-dependent NAD(+) synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(219201, NULL, 'G3DSA:2.40.50.90:FF:000036', NULL, NULL, 'Tudor domain-containing protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(219202, NULL, 'G3DSA:2.30.30.40:FF:000133', NULL, NULL, 'FYN-binding protein-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(219203, NULL, 'G3DSA:1.25.10.10:FF:002583', NULL, NULL, 'Os01g0816500 protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(219204, NULL, 'G3DSA:3.30.200.20:FF:002364', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(219205, NULL, 'G3DSA:3.30.160.60:FF:003142', NULL, NULL, 'Zinc finger protein 30', NULL, NULL, NULL, NULL, NULL, 4),
(219206, NULL, 'G3DSA:1.20.1250.20:FF:002128', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(219207, NULL, 'G3DSA:2.60.120.920:FF:000041', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM62', NULL, NULL, NULL, NULL, NULL, 4),
(219208, NULL, 'G3DSA:3.30.56.10:FF:000029', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(219209, NULL, 'G3DSA:3.10.20.30:FF:000015', NULL, NULL, 'Aldehyde oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(219210, NULL, 'G3DSA:1.25.40.20:FF:001340', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219211, NULL, 'G3DSA:3.30.40.10:FF:002382', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219212, NULL, 'G3DSA:3.40.50.150:FF:000972', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219213, NULL, 'G3DSA:3.40.50.300:FF:002743', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(219214, NULL, 'G3DSA:1.10.230.10:FF:000014', NULL, NULL, 'Citrate synthase 2', NULL, NULL, NULL, NULL, NULL, 4),
(219215, NULL, 'G3DSA:3.40.140.10:FF:000178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219216, NULL, 'G3DSA:3.80.10.10:FF:004261', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219217, NULL, 'G3DSA:2.130.10.10:FF:004474', NULL, NULL, 'Striatin 4', NULL, NULL, NULL, NULL, NULL, 4),
(219218, NULL, 'G3DSA:2.60.40.10:FF:003889', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219219, NULL, 'G3DSA:1.20.1280.220:FF:000001', NULL, NULL, 'AvrPtoB type III effector', NULL, NULL, NULL, NULL, NULL, 4),
(219220, NULL, 'G3DSA:2.60.120.560:FF:000011', NULL, NULL, 'Glycoside hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(219221, NULL, 'G3DSA:2.60.40.10:FF:005783', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219222, NULL, 'G3DSA:2.40.30.10:FF:000505', NULL, NULL, 'Oxidoreductase NAD-binding domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(219223, NULL, 'G3DSA:2.60.40.3170:FF:000013', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(219224, NULL, 'G3DSA:3.30.70.330:FF:000807', NULL, NULL, 'Putative RRM RNA binding protein NSAP1', NULL, NULL, NULL, NULL, NULL, 4),
(219225, NULL, 'G3DSA:3.30.160.60:FF:001961', NULL, NULL, 'Zinc finger protein 34', NULL, NULL, NULL, NULL, NULL, 4),
(219226, NULL, 'G3DSA:1.10.1450.10:FF:000108', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(219227, NULL, 'G3DSA:3.40.630.10:FF:000210', NULL, NULL, 'N-alpha-acetyl-L-2,4-diaminobutyric acid deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(219228, NULL, 'G3DSA:2.130.10.10:FF:001725', NULL, NULL, 'Receptor for activated C kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(219229, NULL, 'G3DSA:3.40.50.410:FF:000123', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(219230, NULL, 'G3DSA:3.40.50.720:FF:001733', NULL, NULL, 'Homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(219231, NULL, 'G3DSA:3.30.40.10:FF:001089', NULL, NULL, 'WGS project CABT00000000 data, contig 2.7', NULL, NULL, NULL, NULL, NULL, 4),
(219232, NULL, 'G3DSA:1.10.555.10:FF:000257', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219233, NULL, 'G3DSA:3.30.740.10:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219234, NULL, 'G3DSA:3.30.1120.10:FF:000061', NULL, NULL, 'Arylsulfatase A', NULL, NULL, NULL, NULL, NULL, 4),
(219235, NULL, 'G3DSA:3.30.70.330:FF:002320', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219236, NULL, 'G3DSA:3.40.30.10:FF:000846', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219237, NULL, 'G3DSA:3.40.50.980:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219238, NULL, 'G3DSA:1.25.10.10:FF:002240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(219239, NULL, 'G3DSA:1.10.1040.10:FF:000010', NULL, NULL, '3-hydroxybutyryl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(219240, NULL, 'G3DSA:2.40.30.130:FF:000016', NULL, NULL, 'YNL040W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(219241, NULL, 'G3DSA:3.30.420.270:FF:000021', NULL, NULL, 'Tol-Pal system protein TolR', NULL, NULL, NULL, NULL, NULL, 4),
(219242, NULL, 'G3DSA:3.40.30.10:FF:001122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219243, NULL, 'G3DSA:2.10.25.10:FF:001523', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219244, NULL, 'G3DSA:3.30.160.60:FF:001629', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219245, NULL, 'G3DSA:1.20.1250.20:FF:000330', NULL, NULL, 'monocarboxylate transporter 10', NULL, NULL, NULL, NULL, NULL, 4),
(219246, NULL, 'G3DSA:2.40.50.140:FF:000237', NULL, NULL, 'Ribonuclease, Rne/Rng family domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(219247, NULL, 'G3DSA:2.130.10.10:FF:002001', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1', NULL, NULL, NULL, NULL, NULL, 4),
(219248, NULL, 'G3DSA:1.20.1070.10:FF:000560', NULL, NULL, 'neuropeptides capa receptor isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(219249, NULL, 'G3DSA:3.40.50.300:FF:000146', NULL, NULL, 'MAGUK p55 subfamily member 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(219250, NULL, 'G3DSA:3.30.450.40:FF:000089', NULL, NULL, 'Sigma-54-dependent Fis family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(219251, NULL, 'G3DSA:3.40.50.1010:FF:000072', NULL, NULL, 'Ribonuclease VapC', NULL, NULL, NULL, NULL, NULL, 4),
(219252, NULL, 'G3DSA:3.40.33.10:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219253, NULL, 'G3DSA:2.30.42.10:FF:000601', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219254, NULL, 'G3DSA:2.60.40.1170:FF:000008', NULL, NULL, 'AP-2 complex subunit mu isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(219255, NULL, 'G3DSA:2.30.30.40:FF:000532', NULL, NULL, 'Protein kinase C and casein kinase substrate in neurons protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(219256, NULL, 'G3DSA:3.40.50.620:FF:000304', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(219257, NULL, 'G3DSA:3.55.40.10:FF:000004', NULL, NULL, 'Putative type IV pilin', NULL, NULL, NULL, NULL, NULL, 4),
(219258, NULL, 'G3DSA:3.30.450.30:FF:000047', NULL, NULL, 'Probable gliding protein (MglB)', NULL, NULL, NULL, NULL, NULL, 4),
(219259, NULL, 'G3DSA:2.30.29.30:FF:000115', NULL, NULL, 'General transcription factor IIH subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(219260, NULL, 'G3DSA:3.90.190.10:FF:000496', NULL, NULL, 'Probable dual specificity protein phosphatase DDB_G0283417', NULL, NULL, NULL, NULL, NULL, 4),
(219261, NULL, 'G3DSA:1.25.40.10:FF:003753', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219262, NULL, 'G3DSA:2.10.70.10:FF:000138', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(219263, NULL, 'G3DSA:3.30.70.330:FF:001027', NULL, NULL, 'RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(219264, NULL, 'G3DSA:1.20.1250.20:FF:001167', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(219265, NULL, 'G3DSA:3.30.70.330:FF:003157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219266, NULL, 'G3DSA:1.10.490.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219267, NULL, 'G3DSA:1.10.510.10:FF:002705', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219268, NULL, 'G3DSA:2.30.110.10:FF:000042', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(219269, NULL, 'G3DSA:3.40.1090.10:FF:000061', NULL, NULL, 'Patatin', NULL, NULL, NULL, NULL, NULL, 4),
(219270, NULL, 'G3DSA:3.40.1170.60:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219271, NULL, 'G3DSA:2.60.120.10:FF:000120', NULL, NULL, 'cAMP-dependent protein kinase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(219272, NULL, 'G3DSA:3.30.497.10:FF:000025', NULL, NULL, 'Serine protease inhibitor, serpin', NULL, NULL, NULL, NULL, NULL, 4),
(219273, NULL, 'G3DSA:1.20.1270.60:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219274, NULL, 'G3DSA:1.10.3480.20:FF:000001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219275, NULL, 'G3DSA:1.10.3110.10:FF:000010', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(219276, NULL, 'G3DSA:2.60.200.20:FF:000163', NULL, NULL, 'Serine/threonine-protein kinase RAD53', NULL, NULL, NULL, NULL, NULL, 4),
(219277, NULL, 'G3DSA:3.30.160.60:FF:000269', NULL, NULL, 'Zinc finger protein 287', NULL, NULL, NULL, NULL, NULL, 4),
(219278, NULL, 'G3DSA:2.120.10.30:FF:000170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219279, NULL, 'G3DSA:1.10.287.470:FF:000030', NULL, NULL, 'Efflux transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(219280, NULL, 'G3DSA:3.40.50.720:FF:001677', NULL, NULL, 'Phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(219281, NULL, 'G3DSA:3.40.50.300:FF:006110', NULL, NULL, 'Putative multidrug resistance-associated protein lethal(2)03659-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(219282, NULL, 'G3DSA:3.40.50.150:FF:001192', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219283, NULL, 'G3DSA:3.30.1360.10:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219284, NULL, 'G3DSA:2.70.150.10:FF:000075', NULL, NULL, 'Metal cation transporter P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(219285, NULL, 'G3DSA:2.70.170.10:FF:000306', NULL, NULL, 'Protein CBG26995', NULL, NULL, NULL, NULL, NULL, 4),
(219286, NULL, 'G3DSA:4.10.1240.10:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219287, NULL, 'G3DSA:3.40.50.11340:FF:000016', NULL, NULL, 'Probable fucosyltransferase 8', NULL, NULL, NULL, NULL, NULL, 4),
(219288, NULL, 'G3DSA:2.70.170.10:FF:000126', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(219289, NULL, 'G3DSA:1.25.40.180:FF:000337', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219290, NULL, 'G3DSA:3.40.1110.10:FF:000119', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(219291, NULL, 'G3DSA:2.130.10.10:FF:005435', NULL, NULL, 'WD-40 repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(219292, NULL, 'G3DSA:2.60.40.10:FF:000399', NULL, NULL, 'myopalladin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(219293, NULL, 'G3DSA:2.40.160.120:FF:000055', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(219294, NULL, 'G3DSA:3.30.830.10:FF:000244', NULL, NULL, 'Ubiquinol-cytochrome c reductase core protein 2b', NULL, NULL, NULL, NULL, NULL, 4),
(219295, NULL, 'G3DSA:1.25.40.800:FF:000012', NULL, NULL, 'Os03g0102366 protein', NULL, NULL, NULL, NULL, NULL, 4),
(219296, NULL, 'G3DSA:1.20.58.760:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219297, NULL, 'G3DSA:1.20.58.1030:FF:000021', NULL, NULL, 'DNA replication complex GINS protein SLD5', NULL, NULL, NULL, NULL, NULL, 4),
(219298, NULL, 'G3DSA:1.10.472.10:FF:000177', NULL, NULL, 'PHO85 cyclin-10', NULL, NULL, NULL, NULL, NULL, 4),
(219299, NULL, 'G3DSA:2.130.10.10:FF:005379', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(219300, NULL, 'G3DSA:3.30.40.10:FF:000813', NULL, NULL, 'E3 ubiquitin-protein ligase RNF213', NULL, NULL, NULL, NULL, NULL, 4),
(219301, NULL, 'G3DSA:3.90.190.10:FF:000552', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219302, NULL, 'G3DSA:3.30.450.40:FF:000145', NULL, NULL, 'Protein serine phosphatase with GAF(S) sensor(S)', NULL, NULL, NULL, NULL, NULL, 4),
(219303, NULL, 'G3DSA:1.20.1280.50:FF:000262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219304, NULL, 'G3DSA:2.60.120.10:FF:000064', NULL, NULL, 'cGMP-dependent protein kinase, isozyme', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(219305, NULL, 'G3DSA:3.50.50.60:FF:001463', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(219306, NULL, 'G3DSA:1.25.10.10:FF:002060', NULL, NULL, 'Nipped-B protein', NULL, NULL, NULL, NULL, NULL, 4),
(219307, NULL, 'G3DSA:1.25.10.10:FF:001784', NULL, NULL, 'Exportin-6, putative', NULL, NULL, NULL, NULL, NULL, 4),
(219308, NULL, 'G3DSA:2.60.40.10:FF:001236', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(219309, NULL, 'G3DSA:3.80.10.10:FF:003148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219310, NULL, 'G3DSA:3.30.450.20:FF:000662', NULL, NULL, 'Sensor histidine kinase, HAMP and PAS domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(219311, NULL, 'G3DSA:2.30.29.30:FF:000059', NULL, NULL, 'neurobeachin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(219312, NULL, 'G3DSA:3.30.479.30:FF:000023', NULL, NULL, 'Band 7 protein', NULL, NULL, NULL, NULL, NULL, 4),
(219313, NULL, 'G3DSA:3.30.420.10:FF:000213', NULL, NULL, 'DNA polymerase I', NULL, NULL, NULL, NULL, NULL, 4),
(219314, NULL, 'G3DSA:3.30.450.40:FF:000269', NULL, NULL, 'Histidine kinase dimerisation and phosphoacceptor region', NULL, NULL, NULL, NULL, NULL, 4),
(219315, NULL, 'G3DSA:1.20.90.10:FF:000001', NULL, NULL, 'Basic phospholipase A2 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(219316, NULL, 'G3DSA:3.40.50.1000:FF:000411', NULL, NULL, '5''-nucleotidase', NULL, NULL, NULL, NULL, NULL, 4),
(219317, NULL, 'G3DSA:3.30.1330.60:FF:000041', NULL, NULL, 'Peptidoglycan-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(219318, NULL, 'G3DSA:3.40.50.300:FF:005492', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(219319, NULL, 'G3DSA:2.30.29.30:FF:000790', NULL, NULL, 'Sorting nexin-31', NULL, NULL, NULL, NULL, NULL, 4),
(219320, NULL, 'G3DSA:3.40.800.10:FF:000038', NULL, NULL, 'Agmatinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(219321, NULL, 'G3DSA:3.40.50.300:FF:006453', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219322, NULL, 'G3DSA:2.70.98.20:FF:000028', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(219323, NULL, 'G3DSA:1.10.10.10:FF:000435', NULL, NULL, 'HTH-type transcriptional regulator MurR', NULL, NULL, NULL, NULL, NULL, 4),
(219324, NULL, 'G3DSA:2.130.10.10:FF:005778', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219325, NULL, 'G3DSA:3.40.640.10:FF:000036', NULL, NULL, 'pyridoxal-dependent decarboxylase domain-containing protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(219326, NULL, 'G3DSA:2.160.20.10:FF:000050', NULL, NULL, 'F-box domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(219327, NULL, 'G3DSA:3.10.580.10:FF:000184', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(219328, NULL, 'G3DSA:1.25.40.10:FF:003933', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219329, NULL, 'G3DSA:3.40.50.1440:FF:000083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219330, NULL, 'G3DSA:3.40.30.10:FF:000902', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(219331, NULL, 'G3DSA:2.60.40.150:FF:000363', NULL, NULL, 'Multiple C2 domains, transmembrane 2a', NULL, NULL, NULL, NULL, NULL, 4),
(219332, NULL, 'G3DSA:2.60.40.10:FF:005963', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219333, NULL, 'G3DSA:2.60.40.1180:FF:000124', NULL, NULL, 'neutral alpha-glucosidase AB', NULL, NULL, NULL, NULL, NULL, 4),
(219334, NULL, 'G3DSA:3.20.20.80:FF:000715', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219335, NULL, 'G3DSA:3.30.160.60:FF:006452', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219336, NULL, 'G3DSA:1.50.40.10:FF:000143', NULL, NULL, 'Mitochondrial carrier protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(219337, NULL, 'G3DSA:3.40.50.150:FF:000079', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase F', NULL, NULL, NULL, NULL, NULL, 4),
(219338, NULL, 'G3DSA:3.30.160.650:FF:000002', NULL, NULL, 'Alkylglycerone-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(219339, NULL, 'G3DSA:3.10.450.10:FF:000028', NULL, NULL, 'Cysteine proteinase inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(219340, NULL, 'G3DSA:1.10.10.60:FF:000697', NULL, NULL, 'Myb transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(219341, NULL, 'G3DSA:3.60.40.10:FF:000273', NULL, NULL, 'Protein phosphatase family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(219342, NULL, 'G3DSA:2.60.120.260:FF:000326', NULL, NULL, 'Beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(219343, NULL, 'G3DSA:3.30.450.20:FF:000263', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(219344, NULL, 'G3DSA:1.10.555.10:FF:000077', NULL, NULL, 'GTPase activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(219345, NULL, 'G3DSA:3.30.70.1660:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219346, NULL, 'G3DSA:3.40.50.1580:FF:000040', NULL, NULL, 'S-methyl-5''-thioadenosine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(219347, NULL, 'G3DSA:3.40.50.300:FF:001782', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(219348, NULL, 'G3DSA:3.30.470.30:FF:000031', NULL, NULL, 'Multifunctional non-homologous end joining protein LigD', NULL, NULL, NULL, NULL, NULL, 4),
(219349, NULL, 'G3DSA:3.40.50.2000:FF:001066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219350, NULL, 'G3DSA:1.10.630.10:FF:000382', NULL, NULL, 'Cytochrome P450 monooxygenase easK', NULL, NULL, NULL, NULL, NULL, 4),
(219351, NULL, 'G3DSA:3.90.1410.10:FF:000131', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(219352, NULL, 'G3DSA:3.40.50.140:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219353, NULL, 'G3DSA:1.10.510.10:FF:002525', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219354, NULL, 'G3DSA:3.40.50.300:FF:005093', NULL, NULL, 'Ras-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(219355, NULL, 'G3DSA:3.40.50.1970:FF:000011', NULL, NULL, 'NDMA-dependent methanol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(219356, NULL, 'G3DSA:1.10.510.10:FF:001688', NULL, NULL, 'Discoidin domain-containing receptor A', NULL, NULL, NULL, NULL, NULL, 4),
(219357, NULL, 'G3DSA:2.10.25.10:FF:001467', NULL, NULL, 'Neurogenic locus notch homolog protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(219358, NULL, 'G3DSA:3.90.1150.10:FF:000088', NULL, NULL, 'Aminotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(219359, NULL, 'G3DSA:3.30.230.10:FF:000002', NULL, NULL, '30S ribosomal protein S5', NULL, NULL, NULL, NULL, NULL, 4),
(219360, NULL, 'G3DSA:1.20.1560.10:FF:000659', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219361, NULL, 'G3DSA:3.30.60.20:FF:000020', NULL, NULL, 'Putative unconventional myosin-IXa', NULL, NULL, NULL, NULL, NULL, 4),
(219362, NULL, 'G3DSA:2.30.29.30:FF:000458', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(219363, NULL, 'G3DSA:2.120.10.30:FF:000332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219364, NULL, 'G3DSA:3.30.160.60:FF:002181', NULL, NULL, 'Zinc finger protein 215', NULL, NULL, NULL, NULL, NULL, 4),
(219365, NULL, 'G3DSA:3.20.20.140:FF:000136', NULL, NULL, 'Predicted metal-dependent hydrolase of the TIM-barrel fold', NULL, NULL, NULL, NULL, NULL, 4),
(219366, NULL, 'G3DSA:1.20.1050.10:FF:000053', NULL, NULL, 'Glutathione S-transferase P', NULL, NULL, NULL, NULL, NULL, 4),
(219367, NULL, 'G3DSA:1.20.1530.20:FF:000025', NULL, NULL, 'Cation/H(+) antiporter 28', NULL, NULL, NULL, NULL, NULL, 4),
(219368, NULL, 'G3DSA:1.20.5.2050:FF:000001', NULL, NULL, 'Transcription factor with AP2 domain(S)', NULL, NULL, NULL, NULL, NULL, 4),
(219369, NULL, 'G3DSA:3.30.505.10:FF:000242', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219370, NULL, 'G3DSA:2.60.120.10:FF:000463', NULL, NULL, 'Cupin-like_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(219371, NULL, 'G3DSA:3.30.50.10:FF:000078', NULL, NULL, 'Nuclear Hormone Receptor family', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(219372, NULL, 'G3DSA:1.10.442.10:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219373, NULL, 'G3DSA:2.40.10.10:FF:000673', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219374, NULL, 'G3DSA:3.40.50.410:FF:000067', NULL, NULL, 'Integrin alpha M', NULL, NULL, NULL, NULL, NULL, 4),
(219375, NULL, 'G3DSA:3.40.50.12240:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219376, NULL, 'G3DSA:1.25.40.10:FF:000403', NULL, NULL, 'General transcriptional repressor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(219377, NULL, 'G3DSA:1.20.58.1880:FF:000006', NULL, NULL, 'Protein ALWAYS EARLY 3 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(219378, NULL, 'G3DSA:1.20.140.150:FF:000077', NULL, NULL, 'Germ cell-specific gene 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(219379, NULL, 'G3DSA:2.130.10.10:FF:001124', NULL, NULL, 'Unplaced genomic scaffold supercont1.12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(219380, NULL, 'G3DSA:3.40.50.150:FF:001124', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219381, NULL, 'G3DSA:3.40.50.1000:FF:000142', NULL, NULL, 'Similar to FCP1-like phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(219382, NULL, 'G3DSA:3.30.530.20:FF:000016', NULL, NULL, 'StAR-related lipid transfer protein 7, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(219383, NULL, 'G3DSA:1.10.630.10:FF:000595', NULL, NULL, 'Os05g0200400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(219384, NULL, 'G3DSA:3.40.50.300:FF:003075', NULL, NULL, 'Toxin resistance protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(219385, NULL, 'G3DSA:3.30.40.10:FF:001893', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219386, NULL, 'G3DSA:3.30.830.10:FF:000290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219387, NULL, 'G3DSA:3.40.50.80:FF:000020', NULL, NULL, 'Dual oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(219388, NULL, 'G3DSA:1.10.510.10:FF:002093', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219389, NULL, 'G3DSA:3.40.1410.10:FF:000002', NULL, NULL, 'Chorismate pyruvate-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(219390, NULL, 'G3DSA:1.10.630.10:FF:000123', NULL, NULL, 'Cytochrome P450, family 702, subfamily A, polypeptide 2', NULL, NULL, NULL, NULL, NULL, 4),
(219391, NULL, 'G3DSA:1.10.10.60:FF:000596', NULL, NULL, 'Putative DNAj-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(219392, NULL, 'G3DSA:3.30.160.60:FF:002214', NULL, NULL, 'zinc finger protein 34 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(219393, NULL, 'G3DSA:2.30.29.30:FF:001386', NULL, NULL, 'BEACH domain-containing protein lvsE', NULL, NULL, NULL, NULL, NULL, 4),
(219394, NULL, 'G3DSA:3.80.10.10:FF:001675', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219395, NULL, 'G3DSA:3.80.10.10:FF:001203', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(219396, NULL, 'G3DSA:2.60.40.150:FF:000008', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(219397, NULL, 'G3DSA:3.90.1290.10:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219398, NULL, 'G3DSA:1.10.238.10:FF:000526', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219399, NULL, 'G3DSA:3.30.40.10:FF:001454', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219400, NULL, 'G3DSA:3.10.20.90:FF:000781', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(219401, NULL, 'G3DSA:3.40.50.10610:FF:000005', NULL, NULL, 'Penicillin-binding protein activator LpoB', NULL, NULL, NULL, NULL, NULL, 4),
(219402, NULL, 'G3DSA:1.10.238.10:FF:000043', NULL, NULL, 'Kv channel-interacting protein 1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(219403, NULL, 'G3DSA:1.10.510.10:FF:002576', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219404, NULL, 'G3DSA:1.20.120.540:FF:000004', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(219405, NULL, 'G3DSA:2.20.100.10:FF:000021', NULL, NULL, 'semaphorin-5B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(219406, NULL, 'G3DSA:3.40.30.10:FF:000559', NULL, NULL, 'DSBA oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(219407, NULL, 'G3DSA:1.10.510.10:FF:000968', NULL, NULL, 'Casein kinase I, putative', NULL, NULL, NULL, NULL, NULL, 4),
(219408, NULL, 'G3DSA:3.30.110.20:FF:000024', NULL, NULL, 'Ribonucleases P/MRP protein subunit POP7', NULL, NULL, NULL, NULL, NULL, 4),
(219409, NULL, 'G3DSA:3.30.40.10:FF:001937', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219410, NULL, 'G3DSA:3.40.1190.20:FF:000178', NULL, NULL, 'Ribosomal protein L15', NULL, NULL, NULL, NULL, NULL, 4),
(219411, NULL, 'G3DSA:3.40.30.10:FF:001178', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(219412, NULL, 'G3DSA:1.25.40.470:FF:000059', NULL, NULL, 'Intraflagellar transport protein 144', NULL, NULL, NULL, NULL, NULL, 4),
(219413, NULL, 'G3DSA:2.10.25.10:FF:000686', NULL, NULL, 'Dumpy, isoform Z', NULL, NULL, NULL, NULL, NULL, 4),
(219414, NULL, 'G3DSA:1.10.510.10:FF:001587', NULL, NULL, 'AGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(219415, NULL, 'G3DSA:3.30.750.24:FF:000077', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(219416, NULL, 'G3DSA:3.30.1130.10:FF:000016', NULL, NULL, '7,8-dihydroneopterin aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(219417, NULL, 'G3DSA:2.60.40.60:FF:001021', NULL, NULL, 'FAT atypical cadherin 2', NULL, NULL, NULL, NULL, NULL, 4),
(219418, NULL, 'G3DSA:1.10.418.10:FF:000141', NULL, NULL, 'DNA (cytosine-5-)-methyltransferase 3 beta, duplicate b.2', NULL, NULL, NULL, NULL, NULL, 4),
(219419, NULL, 'G3DSA:1.20.80.10:FF:000012', NULL, NULL, 'Myosin VIIA', NULL, NULL, NULL, NULL, NULL, 4),
(219420, NULL, 'G3DSA:3.40.50.300:FF:004064', NULL, NULL, '5-methylcytosine-specific restriction enzyme B (EcoKMcrBC)', NULL, NULL, NULL, NULL, NULL, 4),
(219421, NULL, 'G3DSA:1.25.40.10:FF:005193', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219422, NULL, 'G3DSA:3.20.20.80:FF:000474', NULL, NULL, 'Arabinogalactan endo-beta-1,4-galactanase', NULL, NULL, NULL, NULL, NULL, 4),
(219423, NULL, 'G3DSA:2.130.10.10:FF:003850', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219424, NULL, 'G3DSA:2.160.20.10:FF:000319', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219425, NULL, 'G3DSA:2.60.40.10:FF:001629', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(219426, NULL, 'G3DSA:1.20.1070.10:FF:002038', NULL, NULL, 'Novel 7 transmembrane receptor (Rhodopsin family)', NULL, NULL, NULL, NULL, NULL, 4),
(219427, NULL, 'G3DSA:1.20.1250.20:FF:000487', NULL, NULL, 'monocarboxylate transporter 3', NULL, NULL, NULL, NULL, NULL, 4),
(219428, NULL, 'G3DSA:1.25.40.10:FF:004574', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(219429, NULL, 'G3DSA:4.10.240.10:FF:000020', NULL, NULL, 'Maltose activator protein', NULL, NULL, NULL, NULL, NULL, 4),
(219430, NULL, 'G3DSA:2.130.10.10:FF:000505', NULL, NULL, 'Blast:Protein LST8 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(219431, NULL, 'G3DSA:2.60.40.60:FF:000874', NULL, NULL, 'FAT atypical cadherin 3a', NULL, NULL, NULL, NULL, NULL, 4),
(219432, NULL, 'G3DSA:1.20.20.10:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219433, NULL, 'G3DSA:2.10.110.10:FF:000001', NULL, NULL, 'Cysteine and glycine-rich protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(219434, NULL, 'G3DSA:1.50.40.10:FF:000587', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219435, NULL, 'G3DSA:3.30.70.330:FF:000510', NULL, NULL, 'protein elav isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(219436, NULL, 'G3DSA:2.60.40.150:FF:000447', NULL, NULL, 'Type III restriction enzyme, res subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(219437, NULL, 'G3DSA:1.10.1200.80:FF:000004', NULL, NULL, 'tRNA-dihydrouridine synthase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(219438, NULL, 'G3DSA:2.10.25.10:FF:001675', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219439, NULL, 'G3DSA:3.40.190.10:FF:000670', NULL, NULL, 'Glutamate receptor ionotropic, kainate 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(219440, NULL, 'G3DSA:3.20.20.70:FF:000145', NULL, NULL, 'tRNA-dihydrouridine(47) synthase [NAD(P)(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(219441, NULL, 'G3DSA:1.10.530.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219442, NULL, 'G3DSA:3.30.200.60:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219443, NULL, 'G3DSA:3.40.50.720:FF:001520', NULL, NULL, 'ThiF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(219444, NULL, 'G3DSA:2.60.120.260:FF:000438', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(219445, NULL, 'G3DSA:3.40.1160.10:FF:000038', NULL, NULL, 'Glutamate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(219446, NULL, 'G3DSA:1.25.40.20:FF:001025', NULL, NULL, 'Kinase/ NEK', NULL, NULL, NULL, NULL, NULL, 4),
(219447, NULL, 'G3DSA:1.25.10.10:FF:003448', NULL, NULL, 'Maestro heat-like repeat-containing protein family member 1', NULL, NULL, NULL, NULL, NULL, 4),
(219448, NULL, 'G3DSA:3.40.50.2300:FF:000003', NULL, NULL, 'Glutamate receptor, ionotropic, AMPA 4', NULL, NULL, NULL, NULL, NULL, 4),
(219449, NULL, 'G3DSA:3.10.100.10:FF:000076', NULL, NULL, 'C-type lectin domain family 19 member A', NULL, NULL, NULL, NULL, NULL, 4),
(219450, NULL, 'G3DSA:1.20.1280.290:FF:000033', NULL, NULL, 'Bidirectional sugar transporter SWEET', NULL, NULL, NULL, NULL, NULL, 4),
(219451, NULL, 'G3DSA:3.30.40.10:FF:000948', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(219452, NULL, 'G3DSA:2.60.120.200:FF:000044', NULL, NULL, 'neural-cadherin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(219453, NULL, 'G3DSA:3.40.190.290:FF:000021', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(219454, NULL, 'G3DSA:3.40.50.300:FF:001630', NULL, NULL, 'ATP synthase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(219455, NULL, 'G3DSA:3.90.550.10:FF:000248', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(219456, NULL, 'G3DSA:3.80.10.10:FF:004429', NULL, NULL, 'Leucine-rich repeat receptor-like protein kinase PEPR1', NULL, NULL, NULL, NULL, NULL, 4),
(219457, NULL, 'G3DSA:3.20.20.80:FF:000002', NULL, NULL, 'Glucan endo-1,3-beta-glucosidase 3', NULL, NULL, NULL, NULL, NULL, 4),
(219458, NULL, 'G3DSA:3.40.50.2300:FF:001431', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219459, NULL, 'G3DSA:3.40.50.1820:FF:001517', NULL, NULL, 'Abhydrolase domain-containing 15a', NULL, NULL, NULL, NULL, NULL, 4),
(219460, NULL, 'G3DSA:3.30.200.20:FF:002240', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219461, NULL, 'G3DSA:2.10.110.30:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219462, NULL, 'G3DSA:1.25.40.10:FF:003629', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g62370', NULL, NULL, NULL, NULL, NULL, 4),
(219463, NULL, 'G3DSA:2.130.10.10:FF:002905', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219464, NULL, 'G3DSA:1.10.510.10:FF:002104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219465, NULL, 'G3DSA:3.30.160.60:FF:006059', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219466, NULL, 'G3DSA:3.30.1550.10:FF:000008', NULL, NULL, 'Putative ribosomal protein L11', NULL, NULL, NULL, NULL, NULL, 4),
(219467, NULL, 'G3DSA:2.40.33.10:FF:000029', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(219468, NULL, 'G3DSA:3.30.70.330:FF:001336', NULL, NULL, 'Ribosomal RNA-processing 7 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(219469, NULL, 'G3DSA:1.10.20.10:FF:000340', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219470, NULL, 'G3DSA:3.40.50.300:FF:008116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(219471, NULL, 'G3DSA:2.70.150.10:FF:000136', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(219472, NULL, 'G3DSA:3.40.30.10:FF:000722', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219473, NULL, 'G3DSA:3.80.30.20:FF:000004', NULL, NULL, 'Radical SAM protein family', NULL, NULL, NULL, NULL, NULL, 4),
(219474, NULL, 'G3DSA:1.10.1450.10:FF:000075', NULL, NULL, 'GM20924', NULL, NULL, NULL, NULL, NULL, 4),
(219475, NULL, 'G3DSA:3.30.1600.10:FF:000024', NULL, NULL, 'DHS-like NAD/FAD-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(219476, NULL, 'G3DSA:1.25.10.10:FF:001520', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219477, NULL, 'G3DSA:3.40.50.12550:FF:000008', NULL, NULL, 'Ubiquitin-conjugating enzyme E1', NULL, NULL, NULL, NULL, NULL, 4),
(219478, NULL, 'G3DSA:3.30.160.60:FF:001697', NULL, NULL, 'zinc finger protein 623', NULL, NULL, NULL, NULL, NULL, 4),
(219479, NULL, 'G3DSA:3.30.230.70:FF:000042', NULL, NULL, 'Putative exoribonuclease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(219480, NULL, 'G3DSA:2.60.450.20:FF:000013', NULL, NULL, 'T-complex protein 10c', NULL, NULL, NULL, NULL, NULL, 4),
(219481, NULL, 'G3DSA:2.40.100.10:FF:000140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219482, NULL, 'G3DSA:1.10.8.60:FF:000437', NULL, NULL, 'ORC1-type DNA replication protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(219483, NULL, 'G3DSA:3.40.1380.20:FF:000041', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(219484, NULL, 'G3DSA:3.30.300.30:FF:000053', NULL, NULL, 'Putative siderophore biosysnthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(219485, NULL, 'G3DSA:1.10.287.470:FF:000081', NULL, NULL, 'RND efflux system, membrane fusion protein CmeA', NULL, NULL, NULL, NULL, NULL, 4),
(219486, NULL, 'G3DSA:3.40.50.300:FF:008246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219487, NULL, 'G3DSA:3.40.50.2000:FF:000133', NULL, NULL, 'UDP-glycosyltransferase 83A1', NULL, NULL, NULL, NULL, NULL, 4),
(219488, NULL, 'G3DSA:1.10.390.10:FF:000087', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(219489, NULL, 'G3DSA:2.40.50.140:FF:000052', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(219490, NULL, 'G3DSA:2.40.420.20:FF:000055', NULL, NULL, 'Uncharacterized protein HI_0894', NULL, NULL, NULL, NULL, NULL, 4),
(219491, NULL, 'G3DSA:3.40.50.720:FF:000901', NULL, NULL, '3-hydroxyacyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(219492, NULL, 'G3DSA:3.40.50.300:FF:003884', NULL, NULL, 'Heparan SulphoTransferase', NULL, NULL, NULL, NULL, NULL, 4),
(219493, NULL, 'G3DSA:1.10.150.550:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219494, NULL, 'G3DSA:2.60.40.2440:FF:000002', NULL, NULL, 'Protein phosphatase 1 regulatory subunit 3E', NULL, NULL, NULL, NULL, NULL, 4),
(219495, NULL, 'G3DSA:2.60.40.10:FF:005171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219496, NULL, 'G3DSA:3.80.10.10:FF:002029', NULL, NULL, 'Toll-like receptor 22', NULL, NULL, NULL, NULL, NULL, 4),
(219497, NULL, 'G3DSA:3.10.100.10:FF:000429', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219498, NULL, 'G3DSA:1.20.1560.10:FF:000131', NULL, NULL, 'Multidrug resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(219499, NULL, 'G3DSA:3.10.280.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219500, NULL, 'G3DSA:3.50.50.60:FF:000502', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(219501, NULL, 'G3DSA:3.40.50.300:FF:004373', NULL, NULL, 'Adenylyl-sulfate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(219502, NULL, 'G3DSA:3.40.50.1000:FF:000512', NULL, NULL, 'Calcium transporting rt-atpase', NULL, NULL, NULL, NULL, NULL, 4),
(219503, NULL, 'G3DSA:1.10.510.10:FF:001957', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(219504, NULL, 'G3DSA:2.130.10.10:FF:000944', NULL, NULL, 'Ribosome assembly protein 4', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(219505, NULL, 'G3DSA:3.40.1810.10:FF:000083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219506, NULL, 'G3DSA:3.40.630.10:FF:000215', NULL, NULL, 'Succinyl-diaminopimelate desuccinylase', NULL, NULL, NULL, NULL, NULL, 4),
(219507, NULL, 'G3DSA:1.25.40.20:FF:000732', NULL, NULL, 'GD22794', NULL, NULL, NULL, NULL, NULL, 4),
(219508, NULL, 'G3DSA:2.40.70.10:FF:000311', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219509, NULL, 'G3DSA:3.30.505.10:FF:000163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219510, NULL, 'G3DSA:2.40.10.10:FF:000302', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219511, NULL, 'G3DSA:1.25.40.20:FF:000069', NULL, NULL, 'Glutaminase, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(219512, NULL, 'G3DSA:1.20.1070.10:FF:000240', NULL, NULL, 'probable G-protein coupled receptor 88', NULL, NULL, NULL, NULL, NULL, 4),
(219513, NULL, 'G3DSA:1.10.150.850:FF:000004', NULL, NULL, 'Transcription elongation factor SPT6', NULL, NULL, NULL, NULL, NULL, 4),
(219514, NULL, 'G3DSA:2.40.50.140:FF:000361', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(219515, NULL, 'G3DSA:3.40.50.980:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219516, NULL, 'G3DSA:1.10.10.60:FF:000933', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219517, NULL, 'G3DSA:3.30.200.20:FF:000262', NULL, NULL, 'cyclin-dependent kinase F-4-like', NULL, NULL, NULL, NULL, NULL, 4),
(219518, NULL, 'G3DSA:1.10.10.60:FF:001113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219519, NULL, 'G3DSA:1.10.274.30:FF:000014', NULL, NULL, 'MORF4L2 isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(219520, NULL, 'G3DSA:2.130.10.10:FF:002422', NULL, NULL, 'Paralyzed flagella protein 20', NULL, NULL, NULL, NULL, NULL, 4),
(219521, NULL, 'G3DSA:1.10.240.10:FF:000003', NULL, NULL, 'Tryptophan--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(219522, NULL, 'G3DSA:1.10.10.10:FF:000542', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(219523, NULL, 'G3DSA:2.130.10.10:FF:001933', NULL, NULL, 'WD repeat-containing protein 70', NULL, NULL, NULL, NULL, NULL, 4),
(219524, NULL, 'G3DSA:1.10.10.900:FF:000001', NULL, NULL, 'SBDS, ribosome maturation factor', NULL, NULL, NULL, NULL, NULL, 4),
(219525, NULL, 'G3DSA:1.10.10.790:FF:000029', NULL, NULL, 'Probable splicing factor 3A subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(219526, NULL, 'G3DSA:2.60.120.10:FF:000816', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219527, NULL, 'G3DSA:1.20.58.1300:FF:000001', NULL, NULL, '(3,5-dihydroxyphenyl)acetyl-CoA 1,2-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(219528, NULL, 'G3DSA:1.25.10.10:FF:000694', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(219529, NULL, 'G3DSA:4.10.80.160:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219530, NULL, 'G3DSA:3.40.50.150:FF:000135', NULL, NULL, 'Arginine N-methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(219531, NULL, 'G3DSA:1.25.40.20:FF:000199', NULL, NULL, 'Espin like', NULL, NULL, NULL, NULL, NULL, 4),
(219532, NULL, 'G3DSA:3.10.110.10:FF:000374', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(219533, NULL, 'G3DSA:1.20.120.720:FF:000053', NULL, NULL, 'Myosin-K heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(219534, NULL, 'G3DSA:3.80.10.10:FF:001192', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(219535, NULL, 'G3DSA:3.40.50.300:FF:000478', NULL, NULL, '3''-5'' DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(219536, NULL, 'G3DSA:1.10.510.10:FF:002913', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219537, NULL, 'G3DSA:3.30.200.20:FF:001088', NULL, NULL, 'Kinase, CMGC CDK', NULL, NULL, NULL, NULL, NULL, 4),
(219538, NULL, 'G3DSA:3.60.21.10:FF:000313', NULL, NULL, 'Calcineurin-like phosphoesterase family protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(219539, NULL, 'G3DSA:3.20.20.80:FF:000783', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219540, NULL, 'G3DSA:2.60.40.10:FF:004226', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219541, NULL, 'G3DSA:1.10.10.10:FF:001031', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(219542, NULL, 'G3DSA:1.10.533.10:FF:000212', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(219543, NULL, 'G3DSA:2.40.70.10:FF:000441', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219544, NULL, 'G3DSA:1.10.10.1940:FF:000009', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(219545, NULL, 'G3DSA:3.30.40.10:FF:002073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219546, NULL, 'G3DSA:3.40.50.2300:FF:000133', NULL, NULL, 'Glutamate ionotropic receptor NMDA type subunit 3A', NULL, NULL, NULL, NULL, NULL, 4),
(219547, NULL, 'G3DSA:2.10.110.10:FF:000131', NULL, NULL, 'LIM domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(219548, NULL, 'G3DSA:1.10.10.600:FF:000001', NULL, NULL, 'Fe-S assembly protein IscX', NULL, NULL, NULL, NULL, NULL, 4),
(219549, NULL, 'G3DSA:1.10.10.10:FF:000851', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(219550, NULL, 'G3DSA:3.40.50.150:FF:000505', NULL, NULL, 'Thiopurine S-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(219551, NULL, 'G3DSA:3.40.720.10:FF:000144', NULL, NULL, 'Ectonucleotide pyrophosphatase/phosphodiesterase 2, short form', NULL, NULL, NULL, NULL, NULL, 4),
(219552, NULL, 'G3DSA:3.10.450.50:FF:000057', NULL, NULL, 'Protein F17L21.10', NULL, NULL, NULL, NULL, NULL, 4),
(219553, NULL, 'G3DSA:1.25.50.10:FF:000005', NULL, NULL, 'Aminopeptidase N', NULL, NULL, NULL, NULL, NULL, 4),
(219554, NULL, 'G3DSA:1.25.40.10:FF:004102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219555, NULL, 'G3DSA:1.10.640.10:FF:000051', NULL, NULL, 'Peroxinectin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(219556, NULL, 'G3DSA:3.40.50.300:FF:002939', NULL, NULL, 'DBP6p protein', NULL, NULL, NULL, NULL, NULL, 4),
(219557, NULL, 'G3DSA:2.30.31.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219558, NULL, 'G3DSA:3.20.20.140:FF:000001', NULL, NULL, 'Dihydropyrimidinase like 3', NULL, NULL, NULL, NULL, NULL, 4),
(219559, NULL, 'G3DSA:3.40.50.2300:FF:000442', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(219560, NULL, 'G3DSA:3.30.160.60:FF:002686', NULL, NULL, 'Zinc finger protein 555', NULL, NULL, NULL, NULL, NULL, 4),
(219561, NULL, 'G3DSA:1.20.950.20:FF:000002', NULL, NULL, 'Formate dehydrogenase cytochrome b556 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(219562, NULL, 'G3DSA:1.20.58.390:FF:000050', NULL, NULL, 'glycine receptor subunit alpha-4', NULL, NULL, NULL, NULL, NULL, 4),
(219563, NULL, 'G3DSA:3.30.40.10:FF:001584', NULL, NULL, 'RING-H2 zinc finger, putative', NULL, NULL, NULL, NULL, NULL, 4),
(219564, NULL, 'G3DSA:2.30.39.10:FF:000054', NULL, NULL, 'Serpin peptidase inhibitor, clade C (antithrombin), member 1', NULL, NULL, NULL, NULL, NULL, 4),
(219565, NULL, 'G3DSA:3.40.850.10:FF:000209', NULL, NULL, 'kinesin-4-like', NULL, NULL, NULL, NULL, NULL, 4),
(219566, NULL, 'G3DSA:2.10.25.10:FF:000377', NULL, NULL, 'Delta/notch like EGF repeat containing', NULL, NULL, NULL, NULL, NULL, 4),
(219567, NULL, 'G3DSA:3.40.50.720:FF:001992', NULL, NULL, 'UPF0659 protein C216.03', NULL, NULL, NULL, NULL, NULL, 4),
(219568, NULL, 'G3DSA:2.20.70.10:FF:000121', NULL, NULL, 'Transcription elongation regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(219569, NULL, 'G3DSA:3.40.532.10:FF:000004', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(219570, NULL, 'G3DSA:3.40.630.10:FF:000154', NULL, NULL, 'Peptidase M20A family', NULL, NULL, NULL, NULL, NULL, 4),
(219571, NULL, 'G3DSA:2.170.140.10:FF:000005', NULL, NULL, 'Acidic mammalian chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(219572, NULL, 'G3DSA:3.40.50.300:FF:000702', NULL, NULL, 'ABC transporter (Adp1)', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(219573, NULL, 'G3DSA:3.40.50.300:FF:008555', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(219574, NULL, 'G3DSA:1.25.40.10:FF:001831', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219575, NULL, 'G3DSA:2.130.10.10:FF:005295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219576, NULL, 'G3DSA:2.60.40.150:FF:000317', NULL, NULL, 'Protein CBG14248', NULL, NULL, NULL, NULL, NULL, 4),
(219577, NULL, 'G3DSA:3.40.1350.100:FF:000004', NULL, NULL, 'Apicoplast TIC22 protein', NULL, NULL, NULL, NULL, NULL, 4),
(219578, NULL, 'G3DSA:3.50.50.60:FF:001019', NULL, NULL, 'Rab proteins geranylgeranyltransferase component A', NULL, NULL, NULL, NULL, NULL, 4),
(219579, NULL, 'G3DSA:1.25.40.10:FF:002320', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219580, NULL, 'G3DSA:2.60.40.60:FF:000065', NULL, NULL, 'FAT atypical cadherin 1', NULL, NULL, NULL, NULL, NULL, 4),
(219581, NULL, 'G3DSA:1.10.510.10:FF:003402', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219582, NULL, 'G3DSA:3.30.710.10:FF:000224', NULL, NULL, 'Glycoprotein FP21, putative', NULL, NULL, NULL, NULL, NULL, 4),
(219583, NULL, 'G3DSA:3.20.20.120:FF:000006', NULL, NULL, 'o-succinylbenzoate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(219584, NULL, 'G3DSA:3.40.50.1440:FF:000060', NULL, NULL, 'Tubulin nucleotide-binding domain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(219585, NULL, 'G3DSA:3.90.290.10:FF:000020', NULL, NULL, 'Fibrillin-1', NULL, NULL, NULL, NULL, NULL, 4),
(219586, NULL, 'G3DSA:3.40.50.150:FF:000152', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(219587, NULL, 'G3DSA:1.20.1740.10:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219588, NULL, 'G3DSA:1.20.1720.10:FF:000003', NULL, NULL, 'Multidrug resistance protein MdtL', NULL, NULL, NULL, NULL, NULL, 4),
(219589, NULL, 'G3DSA:3.30.2130.30:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219590, NULL, 'G3DSA:3.80.10.10:FF:000231', NULL, NULL, 'Leucine-rich repeat-containing protein 73 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(219591, NULL, 'G3DSA:2.60.40.60:FF:000857', NULL, NULL, 'Cadherin-2', NULL, NULL, NULL, NULL, NULL, 4),
(219592, NULL, 'G3DSA:2.70.170.10:FF:000166', NULL, NULL, 'Protein CBR-DEG-3', NULL, NULL, NULL, NULL, NULL, 4),
(219593, NULL, 'G3DSA:2.60.40.10:FF:002309', NULL, NULL, 'tyrosine-protein phosphatase 69D isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(219594, NULL, 'G3DSA:3.30.160.60:FF:000432', NULL, NULL, 'zinc finger protein Gfi-1b isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(219595, NULL, 'G3DSA:1.20.58.70:FF:000107', NULL, NULL, 'Syntaxin', NULL, NULL, NULL, NULL, NULL, 4),
(219596, NULL, 'G3DSA:3.30.470.20:FF:000045', NULL, NULL, 'Biotin carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(219597, NULL, 'G3DSA:3.30.70.2040:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219598, NULL, 'G3DSA:3.40.190.10:FF:000653', NULL, NULL, 'Peptide ABC transporter, peptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(219599, NULL, 'G3DSA:3.30.540.10:FF:000071', NULL, NULL, 'Inositol polyphosphate 1-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(219600, NULL, 'G3DSA:3.10.100.10:FF:000059', NULL, NULL, 'Regenerating islet-derived 1', NULL, NULL, NULL, NULL, NULL, 4),
(219601, NULL, 'G3DSA:3.50.50.60:FF:000165', NULL, NULL, 'Pyridine nucleotide-disulfide oxidoreductase domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(219602, NULL, 'G3DSA:1.10.400.10:FF:000005', NULL, NULL, 'Extra-large guanine nucleotide-binding protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(219603, NULL, 'G3DSA:3.30.40.10:FF:000965', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(219604, NULL, 'G3DSA:2.10.25.10:FF:001658', NULL, NULL, 'AGAP000117-PA', NULL, NULL, NULL, NULL, NULL, 4),
(219605, NULL, 'G3DSA:4.10.240.10:FF:000003', NULL, NULL, 'C6 transcription factor (Leu3)', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(219606, NULL, 'G3DSA:3.90.230.10:FF:000011', NULL, NULL, 'Methionine aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(219607, NULL, 'G3DSA:1.20.1160.11:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219608, NULL, 'G3DSA:2.60.40.420:FF:000112', NULL, NULL, 'Laccase B', NULL, NULL, NULL, NULL, NULL, 4),
(219609, NULL, 'G3DSA:3.30.230.10:FF:000070', NULL, NULL, 'mismatch repair endonuclease PMS2', NULL, NULL, NULL, NULL, NULL, 4),
(219610, NULL, 'G3DSA:1.20.1300.10:FF:000011', NULL, NULL, 'Succinate dehydrogenase cytochrome b560 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(219611, NULL, 'G3DSA:3.90.190.20:FF:000061', NULL, NULL, 'Folylpolyglutamate synthase / 7,8-dihydropteroate reductase / dihydropteroate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(219612, NULL, 'G3DSA:3.40.309.10:FF:000025', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(219613, NULL, 'G3DSA:3.30.70.330:FF:001319', NULL, NULL, 'RNA recognition motif domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(219614, NULL, 'G3DSA:3.30.420.10:FF:000005', NULL, NULL, 'CCR4-NOT transcription complex subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(219615, NULL, 'G3DSA:3.30.200.20:FF:000571', NULL, NULL, 'Methylthioribose kinase', NULL, NULL, NULL, NULL, NULL, 4),
(219616, NULL, 'G3DSA:2.130.10.10:FF:004659', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(219617, NULL, 'G3DSA:3.40.50.2300:FF:001414', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219618, NULL, 'G3DSA:2.20.90.10:FF:000004', NULL, NULL, 'Vitellogenin A2', NULL, NULL, NULL, NULL, NULL, 4),
(219619, NULL, 'G3DSA:3.30.160.60:FF:004131', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219620, NULL, 'G3DSA:3.30.200.20:FF:001560', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219621, NULL, 'G3DSA:1.20.930.80:FF:000013', NULL, NULL, 'DNA primase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(219622, NULL, 'G3DSA:2.40.20.10:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219623, NULL, 'G3DSA:3.30.40.10:FF:002090', NULL, NULL, 'Uncharacterized RING finger protein P8B7.15c', NULL, NULL, NULL, NULL, NULL, 4),
(219624, NULL, 'G3DSA:3.40.1110.10:FF:000327', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219625, NULL, 'G3DSA:1.10.510.10:FF:004358', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219626, NULL, 'G3DSA:3.40.50.300:FF:002586', NULL, NULL, 'Putative abc transporter c family member', NULL, NULL, NULL, NULL, NULL, 4),
(219627, NULL, 'G3DSA:3.40.710.10:FF:000188', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(219628, NULL, 'G3DSA:2.130.10.10:FF:000635', NULL, NULL, 'Probable vacuolar protein sorting-associated protein 16 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(219629, NULL, 'G3DSA:2.60.40.1170:FF:000054', NULL, NULL, 'General transcription factor IIA, 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(219630, NULL, 'G3DSA:1.10.275.30:FF:000005', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(219631, NULL, 'G3DSA:3.40.30.10:FF:000689', NULL, NULL, 'Protein disulfide isomerase family A member 2', NULL, NULL, NULL, NULL, NULL, 4),
(219632, NULL, 'G3DSA:2.60.120.10:FF:000272', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(219633, NULL, 'G3DSA:4.10.240.30:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219634, NULL, 'G3DSA:1.20.1270.370:FF:000004', NULL, NULL, '(R)-phenyllactyl-CoA dehydratase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(219635, NULL, 'G3DSA:3.40.50.150:FF:001433', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219636, NULL, 'G3DSA:3.40.50.1100:FF:000216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219637, NULL, 'G3DSA:3.90.228.10:FF:000067', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(219638, NULL, 'G3DSA:1.20.120.1240:FF:000081', NULL, NULL, 'Dynamin-1-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(219639, NULL, 'G3DSA:2.60.40.60:FF:000082', NULL, NULL, 'Protocadherin 7b', NULL, NULL, NULL, NULL, NULL, 4),
(219640, NULL, 'G3DSA:2.30.30.40:FF:000369', NULL, NULL, 'Scaffold protein CheW associated with MCPs of classes 40H and 40+24H', NULL, NULL, NULL, NULL, NULL, 4),
(219641, NULL, 'G3DSA:3.30.160.60:FF:000871', NULL, NULL, 'myoneurin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(219642, NULL, 'G3DSA:2.130.10.10:FF:005278', NULL, NULL, 'WD-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(219643, NULL, 'G3DSA:3.40.50.300:FF:002147', NULL, NULL, 'Putative ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(219644, NULL, 'G3DSA:2.130.10.10:FF:003041', NULL, NULL, 'Putative wd40 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(219645, NULL, 'G3DSA:2.170.270.10:FF:000222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219646, NULL, 'G3DSA:3.40.640.10:FF:000082', NULL, NULL, 'Phosphoserine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(219647, NULL, 'G3DSA:1.10.340.30:FF:000045', NULL, NULL, 'DNA-3-methyladenine glycosylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(219648, NULL, 'G3DSA:1.25.40.10:FF:000050', NULL, NULL, 'Thioredoxin 2', NULL, NULL, NULL, NULL, NULL, 4),
(219649, NULL, 'G3DSA:1.20.1110.10:FF:000209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219650, NULL, 'G3DSA:3.30.200.20:FF:000132', NULL, NULL, 'Ribosomal protein S6 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(219651, NULL, 'G3DSA:3.30.70.20:FF:000133', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219652, NULL, 'G3DSA:3.90.70.10:FF:000419', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219653, NULL, 'G3DSA:1.10.3260.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219654, NULL, 'G3DSA:1.25.40.180:FF:000096', NULL, NULL, 'Pre-mRNA-splicing factor CWC22, putative', NULL, NULL, NULL, NULL, NULL, 4),
(219655, NULL, 'G3DSA:3.30.2160.10:FF:000018', NULL, NULL, 'Ubiquitin-protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(219656, NULL, 'G3DSA:1.10.510.10:FF:002076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219657, NULL, 'G3DSA:3.30.310.50:FF:000020', NULL, NULL, 'Putative phosphomannomutase', NULL, NULL, NULL, NULL, NULL, 4),
(219658, NULL, 'G3DSA:1.10.510.10:FF:000176', NULL, NULL, 'Muscle, skeletal receptor tyrosine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(219659, NULL, 'G3DSA:1.10.10.1180:FF:000001', NULL, NULL, 'inner nuclear membrane protein Man1', NULL, NULL, NULL, NULL, NULL, 4),
(219660, NULL, 'G3DSA:3.40.50.300:FF:003092', NULL, NULL, 'GTP-binding protein, Ras family protein', NULL, NULL, NULL, NULL, NULL, 4),
(219661, NULL, 'G3DSA:3.30.1330.20:FF:000017', NULL, NULL, 'Cell division protein FtsZ', NULL, NULL, NULL, NULL, NULL, 4),
(219662, NULL, 'G3DSA:2.40.30.10:FF:000056', NULL, NULL, 'NADPH oxidase 5', NULL, NULL, NULL, NULL, NULL, 4),
(219663, NULL, 'G3DSA:3.40.390.10:FF:000281', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219664, NULL, 'G3DSA:2.130.10.10:FF:004530', NULL, NULL, 'Cilia- and flagella-associated protein 44', NULL, NULL, NULL, NULL, NULL, 4),
(219665, NULL, 'G3DSA:1.25.40.470:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219666, NULL, 'G3DSA:3.40.50.970:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219667, NULL, 'G3DSA:3.30.160.60:FF:006368', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219668, NULL, 'G3DSA:2.60.40.790:FF:000144', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219669, NULL, 'G3DSA:3.30.2380.10:FF:000001', NULL, NULL, 'EKC/KEOPS complex subunit TPRKB', NULL, NULL, NULL, NULL, NULL, 4),
(219670, NULL, 'G3DSA:1.20.1560.10:FF:000468', NULL, NULL, 'ABC transporter D family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(219671, NULL, 'G3DSA:1.25.40.10:FF:001168', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(219672, NULL, 'G3DSA:3.30.70.100:FF:000087', NULL, NULL, 'CTP synthase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(219673, NULL, 'G3DSA:2.70.170.10:FF:000019', NULL, NULL, 'Putative acetylcholine receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(219674, NULL, 'G3DSA:2.60.220.50:FF:000089', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(219675, NULL, 'G3DSA:3.80.10.10:FF:001984', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(219676, NULL, 'G3DSA:2.40.50.140:FF:000714', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219677, NULL, 'G3DSA:1.10.287.1700:FF:000001', NULL, NULL, 'Translocation protein in type III secretion', NULL, NULL, NULL, NULL, NULL, 4),
(219678, NULL, 'G3DSA:2.30.110.50:FF:000003', NULL, NULL, 'Type VI secretion protein ImpA', NULL, NULL, NULL, NULL, NULL, 4),
(219679, NULL, 'G3DSA:3.40.50.150:FF:000635', NULL, NULL, 'probable methyltransferase PMT24', NULL, NULL, NULL, NULL, NULL, 4),
(219680, NULL, 'G3DSA:3.40.140.10:FF:000279', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219681, NULL, 'G3DSA:1.25.40.10:FF:003938', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(219682, NULL, 'G3DSA:3.30.930.10:FF:000235', NULL, NULL, 'Os02g0139600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(219683, NULL, 'G3DSA:3.30.870.10:FF:000134', NULL, NULL, 'Mitochondrial cardiolipin hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(219684, NULL, 'G3DSA:3.40.50.1460:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219685, NULL, 'G3DSA:3.30.200.20:FF:000615', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(219686, NULL, 'G3DSA:3.40.50.300:FF:005020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(219687, NULL, 'G3DSA:3.90.180.10:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219688, NULL, 'G3DSA:1.10.510.10:FF:004021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219689, NULL, 'G3DSA:3.40.50.1820:FF:001826', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219690, NULL, 'G3DSA:3.60.20.40:FF:000027', NULL, NULL, 'Gamma-glutamyltransferase 5', NULL, NULL, NULL, NULL, NULL, 4),
(219691, NULL, 'G3DSA:3.30.465.10:FF:000075', NULL, NULL, 'Magnesium and cobalt efflux protein', NULL, NULL, NULL, NULL, NULL, 4),
(219692, NULL, 'G3DSA:1.20.1560.10:FF:000440', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219693, NULL, 'G3DSA:2.10.70.10:FF:000245', NULL, NULL, 'Mannan-binding lectin serine peptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(219694, NULL, 'G3DSA:3.30.559.10:FF:000107', NULL, NULL, 'Chat-3-HEXEN-1-OL ACETYLTRANSFERASE', NULL, NULL, NULL, NULL, NULL, 4),
(219695, NULL, 'G3DSA:3.40.50.720:FF:001649', NULL, NULL, '3-beta hydroxysteroid dehydrogenase/isomerase family protein, putative (AFU_orthologue AFUA_1G06450)', NULL, NULL, NULL, NULL, NULL, 4),
(219696, NULL, 'G3DSA:2.60.120.10:FF:000833', NULL, NULL, 'Putative AraC-family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(219697, NULL, 'G3DSA:1.10.720.60:FF:000004', NULL, NULL, 'Enolase-phosphatase E1', NULL, NULL, NULL, NULL, NULL, 4),
(219698, NULL, 'G3DSA:3.40.50.300:FF:006638', NULL, NULL, 'Iron (II) transporter (FeoB-2) part 2, conjectural, authentic frameshift', NULL, NULL, NULL, NULL, NULL, 4),
(219699, NULL, 'G3DSA:1.20.142.10:FF:000032', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(219700, NULL, 'G3DSA:1.20.58.60:FF:000430', NULL, NULL, 'Desmoplakin a', NULL, NULL, NULL, NULL, NULL, 4),
(219701, NULL, 'G3DSA:1.10.510.10:FF:004330', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219702, NULL, 'G3DSA:2.110.10.10:FF:000006', NULL, NULL, 'Proteoglycan 4', NULL, NULL, NULL, NULL, NULL, 4),
(219703, NULL, 'G3DSA:3.30.750.24:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219704, NULL, 'G3DSA:3.90.550.10:FF:000411', NULL, NULL, 'Putative xyloglucan 6-xylosyltransferase 5', NULL, NULL, NULL, NULL, NULL, 4),
(219705, NULL, 'G3DSA:3.30.390.10:FF:000024', NULL, NULL, 'Chloromuconate cycloisomerase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(219706, NULL, 'G3DSA:3.30.160.60:FF:004923', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219707, NULL, 'G3DSA:1.10.10.10:FF:000412', NULL, NULL, 'Double-stranded RNA-specific adenosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(219708, NULL, 'G3DSA:1.20.1070.10:FF:001993', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219709, NULL, 'G3DSA:1.20.920.20:FF:000045', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(219710, NULL, 'G3DSA:1.10.10.60:FF:001130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219711, NULL, 'G3DSA:2.60.40.790:FF:000161', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219712, NULL, 'G3DSA:1.10.1070.11:FF:000007', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(219713, NULL, 'G3DSA:2.120.10.80:FF:000044', NULL, NULL, 'Kelch-like family member 21', NULL, NULL, NULL, NULL, NULL, 4),
(219714, NULL, 'G3DSA:1.10.3710.10:FF:000011', NULL, NULL, 'ATPase WRNIP1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(219715, NULL, 'G3DSA:2.130.10.10:FF:002861', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One-component system)', NULL, NULL, NULL, NULL, NULL, 4),
(219716, NULL, 'G3DSA:2.60.120.200:FF:000027', NULL, NULL, 'Transmembrane agrin', NULL, NULL, NULL, NULL, NULL, 4),
(219717, NULL, 'G3DSA:3.90.70.10:FF:000262', NULL, NULL, 'Putative calpain-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(219718, NULL, 'G3DSA:3.90.180.10:FF:000158', NULL, NULL, 'Dehydrogenase orsE', NULL, NULL, NULL, NULL, NULL, 4),
(219719, NULL, 'G3DSA:1.20.20.10:FF:000019', NULL, NULL, 'ATP synthase subunit c', NULL, NULL, NULL, NULL, NULL, 4),
(219720, NULL, 'G3DSA:3.30.160.60:FF:001388', NULL, NULL, 'Zinc finger and AT-hook domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(219721, NULL, 'G3DSA:2.130.10.10:FF:003350', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(219722, NULL, 'G3DSA:3.20.20.300:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219723, NULL, 'G3DSA:3.10.430.100:FF:000022', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(219724, NULL, 'G3DSA:2.130.10.10:FF:002552', NULL, NULL, 'Leucine-rich repeat serine/threonine-protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(219725, NULL, 'G3DSA:3.40.50.300:FF:001967', NULL, NULL, 'Protein translocase subunit SecA 2', NULL, NULL, NULL, NULL, NULL, 4),
(219726, NULL, 'G3DSA:2.30.39.10:FF:000037', NULL, NULL, 'Os11g0224800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(219727, NULL, 'G3DSA:3.30.70.2280:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219728, NULL, 'G3DSA:3.30.365.10:FF:000039', NULL, NULL, 'Aldehyde oxidase and xanthine dehydrogenase, molybdopterin binding', NULL, NULL, NULL, NULL, NULL, 4),
(219729, NULL, 'G3DSA:2.60.40.2840:FF:000015', NULL, NULL, 'E3 ubiquitin-protein ligase HECW1', NULL, NULL, NULL, NULL, NULL, 4),
(219730, NULL, 'G3DSA:3.30.70.20:FF:000003', NULL, NULL, 'Dimethyl sulfoxide reductase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(219731, NULL, 'G3DSA:3.40.50.150:FF:000944', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219732, NULL, 'G3DSA:3.30.160.60:FF:002669', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219733, NULL, 'G3DSA:1.20.120.550:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219734, NULL, 'G3DSA:4.10.400.10:FF:000038', NULL, NULL, 'Very low density lipoprotein receptor', NULL, NULL, NULL, NULL, NULL, 4),
(219735, NULL, 'G3DSA:1.25.40.20:FF:001497', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(219736, NULL, 'G3DSA:1.20.1300.10:FF:000039', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(219737, NULL, 'G3DSA:1.10.12.70:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219738, NULL, 'G3DSA:3.90.550.10:FF:000187', NULL, NULL, 'Glycosyltransferase YibD', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(219739, NULL, 'G3DSA:1.10.510.10:FF:002121', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219740, NULL, 'G3DSA:4.10.400.10:FF:000347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219741, NULL, 'G3DSA:3.40.50.1820:FF:001034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219742, NULL, 'G3DSA:3.30.200.20:FF:002369', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219743, NULL, 'G3DSA:3.75.10.10:FF:000013', NULL, NULL, 'N(G),N(G)-dimethylarginine dimethylaminohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(219744, NULL, 'G3DSA:1.20.120.220:FF:000009', NULL, NULL, 'ATP synthase subunit a', NULL, NULL, NULL, NULL, NULL, 4),
(219745, NULL, 'G3DSA:3.40.1360.10:FF:000019', NULL, NULL, 'Meiosis-specific protein SPO11', NULL, NULL, NULL, NULL, NULL, 4),
(219746, NULL, 'G3DSA:3.30.160.60:FF:004794', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219747, NULL, 'G3DSA:1.10.287.80:FF:000014', NULL, NULL, 'F0F1 ATP synthase subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(219748, NULL, 'G3DSA:1.20.120.1080:FF:000038', NULL, NULL, 'DEAH-box RNA helicase (Dhr1), putative', NULL, NULL, NULL, NULL, NULL, 4),
(219749, NULL, 'G3DSA:2.130.10.10:FF:001141', NULL, NULL, 'Related to UTP7-nucleolar protein, component of the small subunit processome', NULL, NULL, NULL, NULL, NULL, 4),
(219750, NULL, 'G3DSA:1.25.10.10:FF:001992', NULL, NULL, 'AEL006Wp', NULL, NULL, NULL, NULL, NULL, 4),
(219751, NULL, 'G3DSA:2.130.10.10:FF:003069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219752, NULL, 'G3DSA:3.40.50.300:FF:006301', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(219753, NULL, 'G3DSA:3.30.160.60:FF:000769', NULL, NULL, 'Early growth response 2b', NULL, NULL, NULL, NULL, NULL, 4),
(219754, NULL, 'G3DSA:1.20.1250.20:FF:001976', NULL, NULL, 'Antibiotic efflux protein', NULL, NULL, NULL, NULL, NULL, 4),
(219755, NULL, 'G3DSA:2.70.170.10:FF:000149', NULL, NULL, 'Nicotinic acetylcholine receptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(219756, NULL, 'G3DSA:1.20.1070.10:FF:001684', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219757, NULL, 'G3DSA:3.90.550.10:FF:000720', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219758, NULL, 'G3DSA:1.20.58.60:FF:000767', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219759, NULL, 'G3DSA:3.90.550.10:FF:000748', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219760, NULL, 'G3DSA:1.20.1050.10:FF:000238', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219761, NULL, 'G3DSA:1.10.630.10:FF:000606', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219762, NULL, 'G3DSA:3.40.50.300:FF:006329', NULL, NULL, 'Spermatogenesis-associated protein 5-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(219763, NULL, 'G3DSA:3.90.950.10:FF:000015', NULL, NULL, '7-methyl-GTP pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(219764, NULL, 'G3DSA:3.40.50.1220:FF:000106', NULL, NULL, 'Putative pyruvate decarboxylase C3G9.11c', NULL, NULL, NULL, NULL, NULL, 4),
(219765, NULL, 'G3DSA:3.40.50.300:FF:002456', NULL, NULL, 'Small GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(219766, NULL, 'G3DSA:3.40.800.20:FF:000035', NULL, NULL, 'Histone deacetylase 17', NULL, NULL, NULL, NULL, NULL, 4),
(219767, NULL, 'G3DSA:1.20.120.1760:FF:000028', NULL, NULL, 'Probable CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase pgsA2', NULL, NULL, NULL, NULL, NULL, 4),
(219768, NULL, 'G3DSA:1.20.120.980:FF:000035', NULL, NULL, 'Clan SC, family S28, unassigned serine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(219769, NULL, 'G3DSA:2.130.10.10:FF:001916', NULL, NULL, 'GG12447', NULL, NULL, NULL, NULL, NULL, 4),
(219770, NULL, 'G3DSA:1.25.10.10:FF:000222', NULL, NULL, 'Importin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(219771, NULL, 'G3DSA:3.40.30.10:FF:001195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(219772, NULL, 'G3DSA:3.40.50.800:FF:000066', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(219773, NULL, 'G3DSA:1.20.58.180:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219774, NULL, 'G3DSA:1.10.238.10:FF:000026', NULL, NULL, 'Epidermal growth factor receptor pathway substrate 15-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(219775, NULL, 'G3DSA:2.120.10.30:FF:000271', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(219776, NULL, 'G3DSA:1.20.200.10:FF:000021', NULL, NULL, 'Histidine--tRNA ligase cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(219777, NULL, 'G3DSA:1.10.10.10:FF:001823', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(219778, NULL, 'G3DSA:3.30.70.1230:FF:000269', NULL, NULL, 'Guanylyl cyclase 3', NULL, NULL, NULL, NULL, NULL, 4),
(219779, NULL, 'G3DSA:2.170.120.20:FF:000012', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(219780, NULL, 'G3DSA:3.40.50.1010:FF:000280', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219781, NULL, 'G3DSA:3.30.230.70:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219782, NULL, 'G3DSA:1.10.390.10:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219783, NULL, 'G3DSA:3.30.70.330:FF:000038', NULL, NULL, 'Nucleolysin tiar isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(219784, NULL, 'G3DSA:2.130.10.10:FF:002405', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1', NULL, NULL, NULL, NULL, NULL, 4),
(219785, NULL, 'G3DSA:3.30.342.10:FF:000003', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(219786, NULL, 'G3DSA:2.130.10.10:FF:003378', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219787, NULL, 'G3DSA:3.40.50.300:FF:007127', NULL, NULL, 'Guanylate-binding protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(219788, NULL, 'G3DSA:2.20.25.10:FF:000045', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(219789, NULL, 'G3DSA:3.90.190.10:FF:000395', NULL, NULL, 'MAP kinase phosphatase 5', NULL, NULL, NULL, NULL, NULL, 4),
(219790, NULL, 'G3DSA:3.30.2130.30:FF:000011', NULL, NULL, 'Probable tRNA sulfurtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(219791, NULL, 'G3DSA:2.30.30.40:FF:000032', NULL, NULL, 'Putative C-Jun-amino-terminal kinase-interacting protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(219792, NULL, 'G3DSA:2.120.10.80:FF:000353', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219793, NULL, 'G3DSA:3.40.50.300:FF:004401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219794, NULL, 'G3DSA:2.130.10.10:FF:005839', NULL, NULL, 'Villidin', NULL, NULL, NULL, NULL, NULL, 4),
(219795, NULL, 'G3DSA:3.40.50.10330:FF:000028', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(219796, NULL, 'G3DSA:2.70.150.10:FF:000266', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(219797, NULL, 'G3DSA:1.10.274.30:FF:000031', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(219798, NULL, 'G3DSA:2.70.70.10:FF:000035', NULL, NULL, 'Peptidase, M23 family', NULL, NULL, NULL, NULL, NULL, 4),
(219799, NULL, 'G3DSA:1.10.533.10:FF:000083', NULL, NULL, 'Leucine rich repeats and death domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(219800, NULL, 'G3DSA:2.60.40.1180:FF:000175', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(219801, NULL, 'G3DSA:2.60.40.10:FF:004035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219802, NULL, 'G3DSA:3.40.50.300:FF:000141', NULL, NULL, 'ATP-dependent RNA helicase DOB1', NULL, NULL, NULL, NULL, NULL, 4),
(219803, NULL, 'G3DSA:2.70.20.50:FF:000004', NULL, NULL, 'Matrix protein', NULL, NULL, NULL, NULL, NULL, 4),
(219804, NULL, 'G3DSA:3.30.1330.20:FF:000034', NULL, NULL, 'Cell division protein FtsZ', NULL, NULL, NULL, NULL, NULL, 4),
(219805, NULL, 'G3DSA:3.30.1370.10:FF:000045', NULL, NULL, 'KH domain-containing 4, pre-mRNA-splicing factor', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(219806, NULL, 'G3DSA:3.90.70.80:FF:000030', NULL, NULL, 'OTUBain deubiquitylating protease homolog', NULL, NULL, NULL, NULL, NULL, 4),
(219807, NULL, 'G3DSA:3.90.640.80:FF:000006', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(219808, NULL, 'G3DSA:1.10.287.70:FF:000449', NULL, NULL, 'Voltage-dependent calcium channel subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(219809, NULL, 'G3DSA:2.60.40.10:FF:000303', NULL, NULL, 'MAM domain containing glycosylphosphatidylinositol anchor 1', NULL, NULL, NULL, NULL, NULL, 4),
(219810, NULL, 'G3DSA:3.40.532.10:FF:000021', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(219811, NULL, 'G3DSA:1.10.760.10:FF:000026', NULL, NULL, 'Cytochrome C, membrane-bound', NULL, NULL, NULL, NULL, NULL, 4),
(219812, NULL, 'G3DSA:1.10.10.60:FF:000416', NULL, NULL, 'Myb family transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(219813, NULL, 'G3DSA:2.60.40.10:FF:000191', NULL, NULL, 'Immunoglobulin superfamily member 3', NULL, NULL, NULL, NULL, NULL, 4),
(219814, NULL, 'G3DSA:1.25.40.10:FF:001729', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(219815, NULL, 'G3DSA:2.30.30.100:FF:000122', NULL, NULL, 'U7 snRNA-associated Sm-like protein LSm11', NULL, NULL, NULL, NULL, NULL, 4),
(219816, NULL, 'G3DSA:3.90.226.10:FF:000344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219817, NULL, 'G3DSA:2.10.25.10:FF:000394', NULL, NULL, 'Epidermal growth factor-like protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(219818, NULL, 'G3DSA:3.20.20.70:FF:000807', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219819, NULL, 'G3DSA:3.30.1390.20:FF:000010', NULL, NULL, 'Large subunit ribosomal protein L30', NULL, NULL, NULL, NULL, NULL, 4),
(219820, NULL, 'G3DSA:1.10.3720.10:FF:000068', NULL, NULL, 'Oligopeptide transport system permease oppB', NULL, NULL, NULL, NULL, NULL, 4),
(219821, NULL, 'G3DSA:4.10.60.10:FF:000240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219822, NULL, 'G3DSA:1.25.10.10:FF:002268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219823, NULL, 'G3DSA:1.25.40.10:FF:000550', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(219824, NULL, 'G3DSA:1.10.472.10:FF:000311', NULL, NULL, 'Retinoblastoma-like protein homolog lin-35', NULL, NULL, NULL, NULL, NULL, 4),
(219825, NULL, 'G3DSA:1.20.1050.80:FF:000006', NULL, NULL, 'ALS2 C-terminal-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(219826, NULL, 'G3DSA:3.40.50.720:FF:001418', NULL, NULL, 'Aminotransferase PigE', NULL, NULL, NULL, NULL, NULL, 4),
(219827, NULL, 'G3DSA:3.30.160.60:FF:002978', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219828, NULL, 'G3DSA:3.40.50.1820:FF:001697', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(219829, NULL, 'G3DSA:3.30.160.60:FF:001360', NULL, NULL, 'zinc finger protein 624', NULL, NULL, NULL, NULL, NULL, 4),
(219830, NULL, 'G3DSA:3.30.1370.50:FF:000006', NULL, NULL, 'NF-X1 finger transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(219831, NULL, 'G3DSA:1.10.630.10:FF:000786', NULL, NULL, 'Cytochrome P450, family 2, subfamily j, polypeptide 13', NULL, NULL, NULL, NULL, NULL, 4),
(219832, NULL, 'G3DSA:2.30.42.10:FF:000606', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219833, NULL, 'G3DSA:3.40.630.10:FF:000137', NULL, NULL, 'Succinyl-diaminopimelate desuccinylase', NULL, NULL, NULL, NULL, NULL, 4),
(219834, NULL, 'G3DSA:3.30.70.330:FF:000690', NULL, NULL, 'Serine/arginine-rich splicing factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(219835, NULL, 'G3DSA:3.30.1490.20:FF:000057', NULL, NULL, 'D-alanine--D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(219836, NULL, 'G3DSA:2.60.40.10:FF:000292', NULL, NULL, 'Target of Nesh-SH3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(219837, NULL, 'G3DSA:3.30.70.330:FF:001780', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219838, NULL, 'G3DSA:1.25.40.10:FF:000651', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(219839, NULL, 'G3DSA:2.130.10.120:FF:000010', NULL, NULL, 'Prolyl endopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(219840, NULL, 'G3DSA:3.50.50.60:FF:000474', NULL, NULL, 'Possible thiamine biosynthesis oxidoreductase thiO', NULL, NULL, NULL, NULL, NULL, 4),
(219841, NULL, 'G3DSA:2.60.40.790:FF:000083', NULL, NULL, 'GM12013', NULL, NULL, NULL, NULL, NULL, 4),
(219842, NULL, 'G3DSA:1.10.10.10:FF:000603', NULL, NULL, 'DNA-binding transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(219843, NULL, 'G3DSA:2.170.300.10:FF:000012', NULL, NULL, 'Heparan sulfate proteoglycan 2', NULL, NULL, NULL, NULL, NULL, 4),
(219844, NULL, 'G3DSA:2.60.98.50:FF:000004', NULL, NULL, 'Envelopment polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(219845, NULL, 'G3DSA:2.60.120.820:FF:000005', NULL, NULL, 'Highwire, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(219846, NULL, 'G3DSA:2.40.100.10:FF:000123', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(219847, NULL, 'G3DSA:3.40.50.2000:FF:001094', NULL, NULL, 'Protein CBR-UGT-32', NULL, NULL, NULL, NULL, NULL, 4),
(219848, NULL, 'G3DSA:3.30.310.130:FF:000022', NULL, NULL, 'Sentrin-specific protease 2', NULL, NULL, NULL, NULL, NULL, 4),
(219849, NULL, 'G3DSA:1.20.1250.20:FF:000942', NULL, NULL, 'Synaptic vesicle glycoprotein 2', NULL, NULL, NULL, NULL, NULL, 4),
(219850, NULL, 'G3DSA:2.120.10.80:FF:000105', NULL, NULL, 'F-box/kelch-repeat protein At1g51550', NULL, NULL, NULL, NULL, NULL, 4),
(219851, NULL, 'G3DSA:3.30.420.10:FF:000606', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219852, NULL, 'G3DSA:3.30.720.50:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219853, NULL, 'G3DSA:3.10.20.870:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219854, NULL, 'G3DSA:1.10.510.10:FF:000204', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(219855, NULL, 'G3DSA:1.10.1390.10:FF:000002', NULL, NULL, 'Glucose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(219856, NULL, 'G3DSA:3.40.50.1440:FF:000043', NULL, NULL, 'Protein dml1', NULL, NULL, NULL, NULL, NULL, 4),
(219857, NULL, 'G3DSA:1.25.40.20:FF:000980', NULL, NULL, 'SH3 and multiple ankyrin repeat domains 2a', NULL, NULL, NULL, NULL, NULL, 4),
(219858, NULL, 'G3DSA:3.90.70.10:FF:000493', NULL, NULL, 'Putative ubiquitin carboxyl-terminal hydrolase FAF-X', NULL, NULL, NULL, NULL, NULL, 4),
(219859, NULL, 'G3DSA:2.60.40.10:FF:005671', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219860, NULL, 'G3DSA:3.60.15.10:FF:000181', NULL, NULL, 'Metal-dependent hydrolase, beta-lactamase superfamily III', NULL, NULL, NULL, NULL, NULL, 4),
(219861, NULL, 'G3DSA:1.20.5.100:FF:000036', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(219862, NULL, 'G3DSA:3.40.50.1460:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219863, NULL, 'G3DSA:3.10.450.700:FF:000003', NULL, NULL, 'transcription factor Pur-alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(219864, NULL, 'G3DSA:2.40.50.90:FF:000053', NULL, NULL, 'Nuclease domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(219865, NULL, 'G3DSA:1.10.20.10:FF:000368', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219866, NULL, 'G3DSA:1.20.58.2220:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219867, NULL, 'G3DSA:3.40.1380.10:FF:000021', NULL, NULL, 'Alternate ATPase, F1 complex, subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(219868, NULL, 'G3DSA:3.40.50.10490:FF:000014', NULL, NULL, 'N-acetylmuramic acid 6-phosphate etherase', NULL, NULL, NULL, NULL, NULL, 4),
(219869, NULL, 'G3DSA:1.25.10.10:FF:000722', NULL, NULL, 'UNC-45', NULL, NULL, NULL, NULL, NULL, 4),
(219870, NULL, 'G3DSA:1.10.287.950:FF:000011', NULL, NULL, 'Laminin subunit gamma 1', NULL, NULL, NULL, NULL, NULL, 4),
(219871, NULL, 'G3DSA:1.25.10.10:FF:001548', NULL, NULL, 'Transportin-1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(219872, NULL, 'G3DSA:1.20.120.350:FF:000037', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(219873, NULL, 'G3DSA:1.10.357.10:FF:000027', NULL, NULL, 'HTH-type transcriptional regulator EthR', NULL, NULL, NULL, NULL, NULL, 4),
(219874, NULL, 'G3DSA:1.20.5.190:FF:000119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219875, NULL, 'G3DSA:3.30.160.60:FF:006137', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219876, NULL, 'G3DSA:1.20.1070.10:FF:001184', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(219877, NULL, 'G3DSA:3.10.20.30:FF:000089', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219878, NULL, 'G3DSA:3.40.50.1820:FF:001798', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219879, NULL, 'G3DSA:3.30.1360.120:FF:000044', NULL, NULL, 'Aminomethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(219880, NULL, 'G3DSA:3.30.2020.30:FF:000019', NULL, NULL, 'uncharacterized protein LOC100185738', NULL, NULL, NULL, NULL, NULL, 4),
(219881, NULL, 'G3DSA:1.20.1250.20:FF:000678', NULL, NULL, 'Beta-lactamase induction signal transducer AmpG', NULL, NULL, NULL, NULL, NULL, 4),
(219882, NULL, 'G3DSA:1.20.1250.20:FF:001768', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(219883, NULL, 'G3DSA:3.30.420.110:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219884, NULL, 'G3DSA:2.60.40.2140:FF:000002', NULL, NULL, 'Gram-negative bacteria-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(219885, NULL, 'G3DSA:3.40.50.10190:FF:000295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219886, NULL, 'G3DSA:1.20.58.60:FF:000559', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(219887, NULL, 'G3DSA:2.60.40.10:FF:003529', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219888, NULL, 'G3DSA:1.10.150.250:FF:000004', NULL, NULL, 'Succinate dehydrogenase assembly factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(219889, NULL, 'G3DSA:2.60.40.10:FF:002809', NULL, NULL, 'Tyrosine-protein kinase-like otk', NULL, NULL, NULL, NULL, NULL, 4),
(219890, NULL, 'G3DSA:2.60.40.3500:FF:000005', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(219891, NULL, 'G3DSA:1.20.1540.10:FF:000113', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(219892, NULL, 'G3DSA:2.30.180.10:FF:000052', NULL, NULL, 'Vacuolar membrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(219893, NULL, 'G3DSA:1.20.120.330:FF:000031', NULL, NULL, 'Bifunctional uridylyltransferase/uridylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(219894, NULL, 'G3DSA:3.40.630.20:FF:000027', NULL, NULL, 'Pyroglutamyl-peptidase I like', NULL, NULL, NULL, NULL, NULL, 4),
(219895, NULL, 'G3DSA:1.20.5.170:FF:000113', NULL, NULL, 'Sth1p', NULL, NULL, NULL, NULL, NULL, 4),
(219896, NULL, 'G3DSA:3.40.50.880:FF:000146', NULL, NULL, 'Class I glutamine amidotransferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(219897, NULL, 'G3DSA:3.40.50.300:FF:005784', NULL, NULL, 'Uridine kinase, putative (AFU_orthologue AFUA_2G05430)', NULL, NULL, NULL, NULL, NULL, 4),
(219898, NULL, 'G3DSA:3.30.160.60:FF:002186', NULL, NULL, 'Zinc finger protein 507', NULL, NULL, NULL, NULL, NULL, 4),
(219899, NULL, 'G3DSA:3.40.630.10:FF:000362', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(219900, NULL, 'G3DSA:1.50.40.10:FF:000250', NULL, NULL, 'AT23463p', NULL, NULL, NULL, NULL, NULL, 4),
(219901, NULL, 'G3DSA:3.40.50.10470:FF:000059', NULL, NULL, 'Translation initiation factor eIF-2B alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(219902, NULL, 'G3DSA:1.25.10.10:FF:000823', NULL, NULL, 'AP-2 complex subunit beta-1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(219903, NULL, 'G3DSA:3.30.200.20:FF:000115', NULL, NULL, 'Wee1-like kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(219904, NULL, 'G3DSA:3.30.910.20:FF:000001', NULL, NULL, 'Molecular chaperone Skp', NULL, NULL, NULL, NULL, NULL, 4),
(219905, NULL, 'G3DSA:1.10.472.10:FF:000103', NULL, NULL, 'Cyclin B1', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(219906, NULL, 'G3DSA:3.10.129.110:FF:000022', NULL, NULL, 'Polyketide synthase RzxE', NULL, NULL, NULL, NULL, NULL, 4),
(219907, NULL, 'G3DSA:2.40.230.20:FF:000001', NULL, NULL, 'Nucleoside-specific channel-forming protein Tsx', NULL, NULL, NULL, NULL, NULL, 4),
(219908, NULL, 'G3DSA:1.10.287.690:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219909, NULL, 'G3DSA:2.60.120.780:FF:000021', NULL, NULL, 'E3 SUMO-protein ligase pli1', NULL, NULL, NULL, NULL, NULL, 4),
(219910, NULL, 'G3DSA:2.20.110.10:FF:000078', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219911, NULL, 'G3DSA:3.90.70.10:FF:000846', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219912, NULL, 'G3DSA:3.40.190.10:FF:000198', NULL, NULL, 'Sensor histidine kinase/response regulator EvgS', NULL, NULL, NULL, NULL, NULL, 4),
(219913, NULL, 'G3DSA:1.25.40.10:FF:004602', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(219914, NULL, 'G3DSA:1.10.510.10:FF:000631', NULL, NULL, 'Polo like kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(219915, NULL, 'G3DSA:1.20.1310.10:FF:000068', NULL, NULL, 'Cul3p', NULL, NULL, NULL, NULL, NULL, 4),
(219916, NULL, 'G3DSA:3.40.800.20:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219917, NULL, 'G3DSA:2.60.40.1120:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219918, NULL, 'G3DSA:3.40.50.970:FF:000173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219919, NULL, 'G3DSA:3.30.160.60:FF:005311', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219920, NULL, 'G3DSA:3.40.50.300:FF:003575', NULL, NULL, 'Homolog of X-ray repair cross complementing 2 (XRCC2)', NULL, NULL, NULL, NULL, NULL, 4),
(219921, NULL, 'G3DSA:2.120.10.30:FF:000254', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219922, NULL, 'G3DSA:3.40.640.10:FF:000290', NULL, NULL, 'Pyridoxal phosphate-dependent transferase', NULL, NULL, NULL, NULL, NULL, 4),
(219923, NULL, 'G3DSA:1.20.120.180:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219924, NULL, 'G3DSA:2.60.40.10:FF:001129', NULL, NULL, 'Immunoglobulin heavy constant gamma 1', NULL, NULL, NULL, NULL, NULL, 4),
(219925, NULL, 'G3DSA:3.60.40.10:FF:000014', NULL, NULL, 'TGF-beta-activated kinase 1 and MAP3K7-binding protein 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(219926, NULL, 'G3DSA:1.20.1250.20:FF:001184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219927, NULL, 'G3DSA:3.40.50.720:FF:000031', NULL, NULL, 'Glutamyl-tRNA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(219928, NULL, 'G3DSA:3.40.50.1000:FF:000642', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219929, NULL, 'G3DSA:3.30.70.330:FF:000482', NULL, NULL, 'SUPpressor', NULL, NULL, NULL, NULL, NULL, 4),
(219930, NULL, 'G3DSA:3.40.50.720:FF:001109', NULL, NULL, 'WGS project CABT00000000 data, contig 2.10', NULL, NULL, NULL, NULL, NULL, 4),
(219931, NULL, 'G3DSA:3.40.50.10190:FF:000031', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(219932, NULL, 'G3DSA:1.20.58.1480:FF:000010', NULL, NULL, 'ATP-dependent protease La', NULL, NULL, NULL, NULL, NULL, 4),
(219933, NULL, 'G3DSA:3.30.160.60:FF:000640', NULL, NULL, 'PR domain zinc finger protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(219934, NULL, 'G3DSA:2.40.30.170:FF:000028', NULL, NULL, 'Membrane fusion protein mtrC', NULL, NULL, NULL, NULL, NULL, 4),
(219935, NULL, 'G3DSA:3.90.132.10:FF:000007', NULL, NULL, 'GP63-like', NULL, NULL, NULL, NULL, NULL, 4),
(219936, NULL, 'G3DSA:3.40.50.1220:FF:000005', NULL, NULL, 'NAD-dependent deacetylase sirtuin-2', NULL, NULL, NULL, NULL, NULL, 4),
(219937, NULL, 'G3DSA:1.10.287.4070:FF:000010', NULL, NULL, 'U4/U6 small nuclear ribonucleoprotein Prp31, putative', NULL, NULL, NULL, NULL, NULL, 4),
(219938, NULL, 'G3DSA:2.60.120.10:FF:000480', NULL, NULL, 'cAMP protein kinase regulatory chain', NULL, NULL, NULL, NULL, NULL, 4),
(219939, NULL, 'G3DSA:3.30.160.60:FF:005884', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(219940, NULL, 'G3DSA:1.10.1450.10:FF:000092', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(219941, NULL, 'G3DSA:1.10.10.2670:FF:000015', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(219942, NULL, 'G3DSA:3.20.20.60:FF:000108', NULL, NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(219943, NULL, 'G3DSA:1.20.920.20:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219944, NULL, 'G3DSA:1.10.30.10:FF:000150', NULL, NULL, 'Mismatch-binding protein cmb1', NULL, NULL, NULL, NULL, NULL, 4),
(219945, NULL, 'G3DSA:1.20.245.10:FF:000001', NULL, NULL, 'Arachidonate 5-lipoxygenase a', NULL, NULL, NULL, NULL, NULL, 4),
(219946, NULL, 'G3DSA:1.25.10.10:FF:002476', NULL, NULL, 'Microtubule-associated protein TORTIFOLIA1', NULL, NULL, NULL, NULL, NULL, 4),
(219947, NULL, 'G3DSA:3.40.50.720:FF:000340', NULL, NULL, 'Succinyl-CoA synthetase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(219948, NULL, 'G3DSA:2.130.10.10:FF:000427', NULL, NULL, 'WD repeat domain 66', NULL, NULL, NULL, NULL, NULL, 4),
(219949, NULL, 'G3DSA:3.20.20.220:FF:000019', NULL, NULL, 'Methylenetetrahydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(219950, NULL, 'G3DSA:3.40.50.11340:FF:000011', NULL, NULL, 'Fucosyltransferase 3', NULL, NULL, NULL, NULL, NULL, 4),
(219951, NULL, 'G3DSA:3.30.420.40:FF:000357', NULL, NULL, 'L-fuculose kinase fucK', NULL, NULL, NULL, NULL, NULL, 4),
(219952, NULL, 'G3DSA:3.30.70.1450:FF:000026', NULL, NULL, 'Sulfur deprivation response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(219953, NULL, 'G3DSA:2.30.30.560:FF:000001', NULL, NULL, 'major vault protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(219954, NULL, 'G3DSA:3.40.50.360:FF:000097', NULL, NULL, 'NADPH--cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(219955, NULL, 'G3DSA:3.40.50.1000:FF:000703', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219956, NULL, 'G3DSA:3.40.50.300:FF:000450', NULL, NULL, 'ABC transporter C family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(219957, NULL, 'G3DSA:3.30.1330.30:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219958, NULL, 'G3DSA:2.40.170.20:FF:000063', NULL, NULL, 'Ferripyoverdine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(219959, NULL, 'G3DSA:1.25.40.10:FF:002348', NULL, NULL, 'Pre-mRNA processing factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(219960, NULL, 'G3DSA:1.20.58.1000:FF:000001', NULL, NULL, 'Transcriptional repressor RcnR', NULL, NULL, NULL, NULL, NULL, 4),
(219961, NULL, 'G3DSA:3.40.1090.10:FF:000010', NULL, NULL, 'Lysophospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(219962, NULL, 'G3DSA:3.10.310.10:FF:000030', NULL, NULL, 'Diaminopimelate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(219963, NULL, 'G3DSA:3.60.20.10:FF:000159', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219964, NULL, 'G3DSA:2.20.70.10:FF:000149', NULL, NULL, 'Rho GTPase-activating protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(219965, NULL, 'G3DSA:3.30.200.20:FF:000823', NULL, NULL, 'Probable IPL1-ser/thr protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(219966, NULL, 'G3DSA:3.40.50.10310:FF:000005', NULL, NULL, 'Creatininase', NULL, NULL, NULL, NULL, NULL, 4),
(219967, NULL, 'G3DSA:3.50.50.60:FF:001446', NULL, NULL, 'Gll3362 protein', NULL, NULL, NULL, NULL, NULL, 4),
(219968, NULL, 'G3DSA:1.10.472.80:FF:000282', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219969, NULL, 'G3DSA:1.25.10.10:FF:002167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219970, NULL, 'G3DSA:3.90.226.10:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219971, NULL, 'G3DSA:1.20.58.390:FF:000078', NULL, NULL, 'AcetylCholine Receptor', NULL, NULL, NULL, NULL, NULL, 4),
(219972, NULL, 'G3DSA:3.20.20.70:FF:000662', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219973, NULL, 'G3DSA:3.40.50.300:FF:002911', NULL, NULL, 'Dynein Light Intermediate chain', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(219974, NULL, 'G3DSA:2.130.10.10:FF:004322', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219975, NULL, 'G3DSA:2.60.40.10:FF:003737', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219976, NULL, 'G3DSA:1.10.510.10:FF:001396', NULL, NULL, 'Tyrosine-protein kinase receptor cam-1', NULL, NULL, NULL, NULL, NULL, 4),
(219977, NULL, 'G3DSA:1.10.510.10:FF:003857', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219978, NULL, 'G3DSA:2.120.10.30:FF:000040', NULL, NULL, 'Low-density lipoprotein receptor-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(219979, NULL, 'G3DSA:2.40.160.50:FF:000032', NULL, NULL, 'SAM complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(219980, NULL, 'G3DSA:3.30.200.210:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219981, NULL, 'G3DSA:3.40.190.10:FF:000209', NULL, NULL, 'Putative dipeptide/oligopeptide/nickel ABC-type transport system periplasmic component', NULL, NULL, NULL, NULL, NULL, 4),
(219982, NULL, 'G3DSA:3.40.50.2300:FF:001386', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219983, NULL, 'G3DSA:1.10.730.10:FF:000187', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(219984, NULL, 'G3DSA:1.10.10.10:FF:001795', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219985, NULL, 'G3DSA:3.90.1410.10:FF:000024', NULL, NULL, 'Rkm1p', NULL, NULL, NULL, NULL, NULL, 4),
(219986, NULL, 'G3DSA:1.10.8.10:FF:000294', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(219987, NULL, 'G3DSA:1.10.10.10:FF:001368', NULL, NULL, 'Predicted transcription regulator, ArsR family', NULL, NULL, NULL, NULL, NULL, 4),
(219988, NULL, 'G3DSA:4.10.280.10:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219989, NULL, 'G3DSA:1.25.40.10:FF:002096', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g62720', NULL, NULL, NULL, NULL, NULL, 4),
(219990, NULL, 'G3DSA:1.25.40.10:FF:004557', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219991, NULL, 'G3DSA:1.50.10.10:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219992, NULL, 'G3DSA:3.40.50.1820:FF:001017', NULL, NULL, 'Lipase containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(219993, NULL, 'G3DSA:1.20.58.340:FF:000057', NULL, NULL, 'Putative inactive magnesium transporter MRS2-8', NULL, NULL, NULL, NULL, NULL, 4),
(219994, NULL, 'G3DSA:1.10.287.940:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(219995, NULL, 'G3DSA:3.90.80.10:FF:000009', NULL, NULL, 'Inorganic pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(219996, NULL, 'G3DSA:2.130.10.10:FF:000152', NULL, NULL, 'WD repeat-containing protein 37', NULL, NULL, NULL, NULL, NULL, 4),
(219997, NULL, 'G3DSA:1.20.120.1380:FF:000010', NULL, NULL, 'Flagellar biosynthetic protein FlhF', NULL, NULL, NULL, NULL, NULL, 4),
(219998, NULL, 'G3DSA:3.30.70.340:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(219999, NULL, 'G3DSA:1.20.58.870:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220000, NULL, 'G3DSA:1.10.10.10:FF:000042', NULL, NULL, 'hepatocyte nuclear factor 3-beta', NULL, NULL, NULL, NULL, NULL, 4),
(220001, NULL, 'G3DSA:1.20.1280.50:FF:000166', NULL, NULL, 'Putative F-box only protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(220002, NULL, 'G3DSA:2.60.120.10:FF:000171', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(220003, NULL, 'G3DSA:3.30.450.40:FF:000185', NULL, NULL, 'GGDEF domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(220004, NULL, 'G3DSA:3.40.50.1820:FF:000972', NULL, NULL, 'Pancreatic triacylglycerol lipase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(220005, NULL, 'G3DSA:2.60.40.2030:FF:000014', NULL, NULL, 'Adhesion G-protein coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(220006, NULL, 'G3DSA:3.50.50.60:FF:000710', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(220007, NULL, 'G3DSA:2.60.40.10:FF:002557', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220008, NULL, 'G3DSA:2.60.40.10:FF:004457', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220009, NULL, 'G3DSA:3.20.20.60:FF:000097', NULL, NULL, 'Isocitrate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(220010, NULL, 'G3DSA:1.10.287.110:FF:000068', NULL, NULL, 'HSP40, subfamily A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(220011, NULL, 'G3DSA:1.10.8.270:FF:000078', NULL, NULL, 'GTPase-activating protein GYP6', NULL, NULL, NULL, NULL, NULL, 4),
(220012, NULL, 'G3DSA:2.60.40.10:FF:003838', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220013, NULL, 'G3DSA:2.10.220.10:FF:000094', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(220014, NULL, 'G3DSA:3.30.40.10:FF:002101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220015, NULL, 'G3DSA:3.10.100.10:FF:000300', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220016, NULL, 'G3DSA:2.30.29.30:FF:001256', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(220017, NULL, 'G3DSA:3.40.50.300:FF:003676', NULL, NULL, 'ATP-dependent helicase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(220018, NULL, 'G3DSA:3.40.50.150:FF:000736', NULL, NULL, 'RNA Methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(220019, NULL, 'G3DSA:4.10.400.10:FF:000246', NULL, NULL, 'Low-density lipoprotein receptor-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(220020, NULL, 'G3DSA:1.10.10.10:FF:000087', NULL, NULL, 'Transcriptional adapter 2', NULL, NULL, NULL, NULL, NULL, 4),
(220021, NULL, 'G3DSA:1.10.132.70:FF:000023', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(220022, NULL, 'G3DSA:1.10.418.10:FF:000271', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(220023, NULL, 'G3DSA:3.60.21.10:FF:000105', NULL, NULL, 'Metallo-dependent phosphatase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(220024, NULL, 'G3DSA:3.40.50.300:FF:004295', NULL, NULL, 'Branched-chain amino acid ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(220025, NULL, 'G3DSA:3.60.40.10:FF:000222', NULL, NULL, 'Sigma regulatory family protein-PP2C phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(220026, NULL, 'G3DSA:3.30.70.1020:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220027, NULL, 'G3DSA:3.30.780.10:FF:000043', NULL, NULL, 'Mitochondrial 54S ribosomal protein IMG2', NULL, NULL, NULL, NULL, NULL, 4),
(220028, NULL, 'G3DSA:1.20.1070.10:FF:001549', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(220029, NULL, 'G3DSA:3.30.9.10:FF:000095', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(220030, NULL, 'G3DSA:3.30.200.20:FF:001649', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220031, NULL, 'G3DSA:4.10.240.10:FF:000048', NULL, NULL, 'YLR278C', NULL, NULL, NULL, NULL, NULL, 4),
(220032, NULL, 'G3DSA:1.25.10.10:FF:002931', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220033, NULL, 'G3DSA:2.40.50.140:FF:000130', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC8', NULL, NULL, NULL, NULL, NULL, 4),
(220034, NULL, 'G3DSA:2.40.270.10:FF:000017', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(220035, NULL, 'G3DSA:3.30.450.40:FF:000038', NULL, NULL, 'Two-component sensor histidine kinase KdpD', NULL, NULL, NULL, NULL, NULL, 4),
(220036, NULL, 'G3DSA:1.25.40.10:FF:002657', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220037, NULL, 'G3DSA:1.10.1420.10:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220038, NULL, 'G3DSA:3.40.50.10420:FF:000055', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(220039, NULL, 'G3DSA:1.10.510.10:FF:001132', NULL, NULL, 'Casein kinase I-like protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(220040, NULL, 'G3DSA:3.30.200.20:FF:000470', NULL, NULL, 'Serine/threonine-protein kinase RAD53', NULL, NULL, NULL, NULL, NULL, 4),
(220041, NULL, 'G3DSA:3.10.100.10:FF:000401', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220042, NULL, 'G3DSA:3.30.830.10:FF:000160', NULL, NULL, 'Metalloenzyme, LuxS/M16 peptidase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(220043, NULL, 'G3DSA:1.20.5.420:FF:000014', NULL, NULL, 'SGT2p Glutamine-rich cytoplasmic cochaperone', NULL, NULL, NULL, NULL, NULL, 4),
(220044, NULL, 'G3DSA:2.60.40.420:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220045, NULL, 'G3DSA:3.30.160.60:FF:005620', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220046, NULL, 'G3DSA:2.30.130.40:FF:000029', NULL, NULL, 'Lon protease homolog, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(220047, NULL, 'G3DSA:3.10.20.90:FF:000550', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220048, NULL, 'G3DSA:2.20.70.10:FF:000251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220049, NULL, 'G3DSA:1.10.8.270:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220050, NULL, 'G3DSA:1.10.238.10:FF:000835', NULL, NULL, 'EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(220051, NULL, 'G3DSA:1.10.418.10:FF:000169', NULL, NULL, 'Kinesin-like protein KIN-14G', NULL, NULL, NULL, NULL, NULL, 4),
(220052, NULL, 'G3DSA:3.40.50.300:FF:002248', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(220053, NULL, 'G3DSA:3.30.420.40:FF:000149', NULL, NULL, 'Type IV pilus assembly protein PilM', NULL, NULL, NULL, NULL, NULL, 4),
(220054, NULL, 'G3DSA:3.40.50.720:FF:001784', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(220055, NULL, 'G3DSA:3.30.200.20:FF:002268', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(220056, NULL, 'G3DSA:1.20.1070.10:FF:001892', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220057, NULL, 'G3DSA:3.40.50.300:FF:007627', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220058, NULL, 'G3DSA:2.60.120.650:FF:000010', NULL, NULL, 'bifunctional arginine demethylase and lysyl-hydroxylase JMJD6 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(220059, NULL, 'G3DSA:3.30.40.10:FF:001437', NULL, NULL, 'TNF receptor-associated factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(220060, NULL, 'G3DSA:3.30.70.330:FF:000139', NULL, NULL, 'Serine/arginine-rich splicing factor 3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(220061, NULL, 'G3DSA:3.10.20.90:FF:000764', NULL, NULL, 'Pat-6', NULL, NULL, NULL, NULL, NULL, 4),
(220062, NULL, 'G3DSA:3.30.870.10:FF:000073', NULL, NULL, 'Phopholipase D-family protein', NULL, NULL, NULL, NULL, NULL, 4),
(220063, NULL, 'G3DSA:1.10.4160.10:FF:000002', NULL, NULL, 'Purine-cytosine permease fcyB', NULL, NULL, NULL, NULL, NULL, 4),
(220064, NULL, 'G3DSA:2.120.10.30:FF:000462', NULL, NULL, 'Low-density lipoprotein RecePtor related', NULL, NULL, NULL, NULL, NULL, 4),
(220065, NULL, 'G3DSA:1.10.150.530:FF:000009', NULL, NULL, 'Putative dual-specificity RNA methyltransferase RlmN', NULL, NULL, NULL, NULL, NULL, 4),
(220066, NULL, 'G3DSA:3.80.10.10:FF:001220', NULL, NULL, 'AGAP007471-PA', NULL, NULL, NULL, NULL, NULL, 4),
(220067, NULL, 'G3DSA:1.10.1450.10:FF:000153', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(220068, NULL, 'G3DSA:1.20.120.230:FF:000046', NULL, NULL, 'Talin-1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(220069, NULL, 'G3DSA:3.60.20.10:FF:000114', NULL, NULL, 'Asparagine synthetase, glutamine-hydrolyzing', NULL, NULL, NULL, NULL, NULL, 4),
(220070, NULL, 'G3DSA:2.10.25.10:FF:001074', NULL, NULL, 'Deleted in malignant brain tumors 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(220071, NULL, 'G3DSA:1.20.1270.280:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220072, NULL, 'G3DSA:3.30.465.10:FF:000103', NULL, NULL, 'Glycolate oxidase subunit GlcE', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(220073, NULL, 'G3DSA:1.10.8.480:FF:000006', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(220074, NULL, 'G3DSA:3.15.10.10:FF:000004', NULL, NULL, 'BPI fold-containing family B member 3', NULL, NULL, NULL, NULL, NULL, 4),
(220075, NULL, 'G3DSA:3.30.470.30:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220076, NULL, 'G3DSA:3.20.20.70:FF:000454', NULL, NULL, 'Dihydroorotate dehydrogenase (quinone)', NULL, NULL, NULL, NULL, NULL, 4),
(220077, NULL, 'G3DSA:1.20.5.4770:FF:000013', NULL, NULL, 'Zinc finger A20 and AN1 domain-containing stress-associated protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(220078, NULL, 'G3DSA:1.20.58.850:FF:000002', NULL, NULL, 'Chromosome partition protein MukB', NULL, NULL, NULL, NULL, NULL, 4),
(220079, NULL, 'G3DSA:2.60.40.1770:FF:000008', NULL, NULL, 'Eph receptor A2 b', NULL, NULL, NULL, NULL, NULL, 4),
(220080, NULL, 'G3DSA:2.130.10.10:FF:005087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220081, NULL, 'G3DSA:2.60.200.20:FF:000085', NULL, NULL, 'Factor arrest protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(220082, NULL, 'G3DSA:3.40.50.720:FF:001065', NULL, NULL, 'Os04g0630900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(220083, NULL, 'G3DSA:1.20.1250.40:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220084, NULL, 'G3DSA:2.60.120.970:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220085, NULL, 'G3DSA:3.40.50.300:FF:003103', NULL, NULL, 'cDNA FLJ50831, highly similar to Guanine nucleotide-binding protein G(q) subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(220086, NULL, 'G3DSA:1.20.58.70:FF:000096', NULL, NULL, 'Syntaxin 1A (brain)', NULL, NULL, NULL, NULL, NULL, 4),
(220087, NULL, 'G3DSA:3.30.200.20:FF:001751', NULL, NULL, 'Serine/threonine-protein kinase OSR1', NULL, NULL, NULL, NULL, NULL, 4),
(220088, NULL, 'G3DSA:1.20.1560.10:FF:000895', NULL, NULL, 'ATP-binding cassette permease', NULL, NULL, NULL, NULL, NULL, 4),
(220089, NULL, 'G3DSA:1.25.10.10:FF:000014', NULL, NULL, 'Cell differentiation protein RCD1', NULL, NULL, NULL, NULL, NULL, 4),
(220090, NULL, 'G3DSA:3.40.630.30:FF:000581', NULL, NULL, 'Acyl-CoA N-acyltransferases (NAT) superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(220091, NULL, 'G3DSA:3.80.10.10:FF:004401', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(220092, NULL, 'G3DSA:2.70.150.10:FF:000058', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(220093, NULL, 'G3DSA:3.40.50.1780:FF:000004', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor nar1', NULL, NULL, NULL, NULL, NULL, 4),
(220094, NULL, 'G3DSA:1.10.150.280:FF:000002', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(220095, NULL, 'G3DSA:3.40.50.1100:FF:000071', NULL, NULL, 'Diaminopropionate ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(220096, NULL, 'G3DSA:3.40.630.40:FF:000022', NULL, NULL, 'Putative N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(220097, NULL, 'G3DSA:3.40.30.10:FF:000498', NULL, NULL, 'glutathione S-transferase theta-1-like', NULL, NULL, NULL, NULL, NULL, 4),
(220098, NULL, 'G3DSA:3.10.20.310:FF:000021', NULL, NULL, 'Cell division protein FtsQ', NULL, NULL, NULL, NULL, NULL, 4),
(220099, NULL, 'G3DSA:1.10.10.60:FF:000141', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(220100, NULL, 'G3DSA:1.10.1200.10:FF:000045', NULL, NULL, 'Nonribosomal peptide synthase side', NULL, NULL, NULL, NULL, NULL, 4),
(220101, NULL, 'G3DSA:3.40.50.300:FF:008190', NULL, NULL, 'RAD3-like DNA-binding helicase protein', NULL, NULL, NULL, NULL, NULL, 4),
(220102, NULL, 'G3DSA:3.30.40.10:FF:000156', NULL, NULL, 'RING-box protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(220103, NULL, 'G3DSA:3.90.470.20:FF:000026', NULL, NULL, 'YALI0E09306p', NULL, NULL, NULL, NULL, NULL, 4),
(220104, NULL, 'G3DSA:2.40.160.20:FF:000034', NULL, NULL, '28kDa outer membrane protein gene 17', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(220105, NULL, 'G3DSA:3.30.70.1400:FF:000017', NULL, NULL, 'Aminomethyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(220106, NULL, 'G3DSA:3.40.190.10:FF:000861', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220107, NULL, 'G3DSA:1.25.10.10:FF:002829', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220108, NULL, 'G3DSA:1.10.630.10:FF:000331', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(220109, NULL, 'G3DSA:3.40.30.10:FF:000953', NULL, NULL, 'Iodothyronine deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(220110, NULL, 'G3DSA:3.40.50.300:FF:001203', NULL, NULL, 'Terminase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(220111, NULL, 'G3DSA:2.40.50.730:FF:000015', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(220112, NULL, 'G3DSA:2.60.40.10:FF:004243', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220113, NULL, 'G3DSA:3.90.1150.10:FF:000217', NULL, NULL, 'PLP-dependent aminotransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(220114, NULL, 'G3DSA:3.30.450.70:FF:000036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220115, NULL, 'G3DSA:3.40.50.300:FF:004856', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220116, NULL, 'G3DSA:3.30.160.60:FF:002905', NULL, NULL, 'Zinc finger protein 507 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(220117, NULL, 'G3DSA:2.60.120.380:FF:000053', NULL, NULL, 'Serine/threonine-protein kinase 4 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(220118, NULL, 'G3DSA:3.40.50.300:FF:006290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220119, NULL, 'G3DSA:1.20.1520.10:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220120, NULL, 'G3DSA:1.10.10.2270:FF:000002', NULL, NULL, 'ADL286Wp', NULL, NULL, NULL, NULL, NULL, 4),
(220121, NULL, 'G3DSA:3.40.1110.10:FF:000299', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220122, NULL, 'G3DSA:2.130.10.10:FF:006003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220123, NULL, 'G3DSA:1.10.8.60:FF:000393', NULL, NULL, 'cell cycle checkpoint protein RAD17', NULL, NULL, NULL, NULL, NULL, 4),
(220124, NULL, 'G3DSA:3.30.30.30:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220125, NULL, 'G3DSA:3.20.20.10:FF:000043', NULL, NULL, 'Alanine racemase', NULL, NULL, NULL, NULL, NULL, 4),
(220126, NULL, 'G3DSA:3.40.50.620:FF:000208', NULL, NULL, 'GMP synthase [glutamine-hydrolyzing] subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(220127, NULL, 'G3DSA:1.10.472.130:FF:000081', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(220128, NULL, 'G3DSA:3.40.50.300:FF:000803', NULL, NULL, 'Ras-related protein Rab-43', NULL, NULL, NULL, NULL, NULL, 4),
(220129, NULL, 'G3DSA:1.20.120.520:FF:000009', NULL, NULL, 'Zinc finger protein BRUTUS', NULL, NULL, NULL, NULL, NULL, 4),
(220130, NULL, 'G3DSA:3.30.420.240:FF:000001', NULL, NULL, 'Phage terminase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(220131, NULL, 'G3DSA:4.10.60.10:FF:000032', NULL, NULL, 'Glycine-rich RNA-binding protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(220132, NULL, 'G3DSA:1.10.10.750:FF:000012', NULL, NULL, 'Rab GTPase-activating protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(220133, NULL, 'G3DSA:2.30.42.10:FF:000505', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220134, NULL, 'G3DSA:3.40.50.300:FF:002956', NULL, NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(220135, NULL, 'G3DSA:3.20.20.70:FF:000706', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220136, NULL, 'G3DSA:3.80.10.10:FF:002501', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(220137, NULL, 'G3DSA:1.20.58.390:FF:000179', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(220138, NULL, 'G3DSA:3.40.50.10190:FF:000306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(220139, NULL, 'G3DSA:2.130.10.10:FF:005648', NULL, NULL, 'Tetraspanin 39D-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(220140, NULL, 'G3DSA:3.40.50.2300:FF:001622', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220141, NULL, 'G3DSA:1.25.40.10:FF:003276', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At1g09680', NULL, NULL, NULL, NULL, NULL, 4),
(220142, NULL, 'G3DSA:3.40.50.1370:FF:000011', NULL, NULL, 'Aspartate carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(220143, NULL, 'G3DSA:1.20.870.10:FF:000043', NULL, NULL, 'Ras guanine nucleotide exchange factor H', NULL, NULL, NULL, NULL, NULL, 4),
(220144, NULL, 'G3DSA:2.70.130.10:FF:000045', NULL, NULL, 'Mannose 6-phosphate receptor domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(220145, NULL, 'G3DSA:2.60.40.840:FF:000002', NULL, NULL, 'Arrestin 3', NULL, NULL, NULL, NULL, NULL, 4),
(220146, NULL, 'G3DSA:3.30.1370.70:FF:000001', NULL, NULL, 'NifU-like protein 4, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(220147, NULL, 'G3DSA:2.60.40.60:FF:000402', NULL, NULL, 'cadherin-89D', NULL, NULL, NULL, NULL, NULL, 4),
(220148, NULL, 'G3DSA:3.40.430.10:FF:000009', NULL, NULL, 'Dihydrofolate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(220149, NULL, 'G3DSA:3.40.50.1820:FF:001489', NULL, NULL, 'Lipase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(220150, NULL, 'G3DSA:2.130.10.10:FF:000713', NULL, NULL, 'WD repeat-containing protein 82 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(220151, NULL, 'G3DSA:3.40.140.10:FF:000150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220152, NULL, 'G3DSA:3.40.50.720:FF:002037', NULL, NULL, 'Predicted gene 4450', NULL, NULL, NULL, NULL, NULL, 4),
(220153, NULL, 'G3DSA:3.30.70.3490:FF:000060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220154, NULL, 'G3DSA:3.55.40.20:FF:000024', NULL, NULL, 'Superoxide dismutase', NULL, NULL, NULL, NULL, NULL, 4),
(220155, NULL, 'G3DSA:1.50.40.10:FF:000356', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220156, NULL, 'G3DSA:3.40.109.10:FF:000044', NULL, NULL, 'Nitroreductase Fd-NR2', NULL, NULL, NULL, NULL, NULL, 4),
(220157, NULL, 'G3DSA:3.30.70.330:FF:001819', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220158, NULL, 'G3DSA:3.30.710.10:FF:000241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220159, NULL, 'G3DSA:2.130.10.10:FF:001332', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(220160, NULL, 'G3DSA:4.10.410.10:FF:000084', NULL, NULL, 'Tissue factor pathway inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(220161, NULL, 'G3DSA:2.30.240.10:FF:000006', NULL, NULL, 'T19F6.7 protein', NULL, NULL, NULL, NULL, NULL, 4),
(220162, NULL, 'G3DSA:3.30.160.60:FF:000399', NULL, NULL, 'zinc finger protein 521', NULL, NULL, NULL, NULL, NULL, 4),
(220163, NULL, 'G3DSA:3.30.160.60:FF:002085', NULL, NULL, 'Zinc finger protein 136', NULL, NULL, NULL, NULL, NULL, 4),
(220164, NULL, 'G3DSA:1.10.8.60:FF:000084', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(220165, NULL, 'G3DSA:3.80.10.10:FF:003018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220166, NULL, 'G3DSA:2.60.40.10:FF:002248', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(220167, NULL, 'G3DSA:1.10.3930.10:FF:000005', NULL, NULL, 'Arginine deiminase', NULL, NULL, NULL, NULL, NULL, 4),
(220168, NULL, 'G3DSA:2.130.10.10:FF:005750', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(220169, NULL, 'G3DSA:3.70.10.10:FF:000080', NULL, NULL, 'DNA polymerase sliding clamp', NULL, NULL, NULL, NULL, NULL, 4),
(220170, NULL, 'G3DSA:1.25.40.10:FF:001376', NULL, NULL, 'Os05g0305300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(220171, NULL, 'G3DSA:1.20.58.1880:FF:000023', NULL, NULL, 'Protein CBG11880', NULL, NULL, NULL, NULL, NULL, 4),
(220172, NULL, 'G3DSA:3.30.420.40:FF:000812', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(220173, NULL, 'G3DSA:1.10.510.10:FF:002885', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(220174, NULL, 'G3DSA:1.10.150.50:FF:000093', NULL, NULL, 'Sterile alpha motif domain-containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(220175, NULL, 'G3DSA:3.40.50.300:FF:001422', NULL, NULL, 'Cobalt ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(220176, NULL, 'G3DSA:1.20.5.1160:FF:000015', NULL, NULL, 'phakinin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(220177, NULL, 'G3DSA:1.20.1600.10:FF:000056', NULL, NULL, 'Slr1270 protein', NULL, NULL, NULL, NULL, NULL, 4),
(220178, NULL, 'G3DSA:3.80.10.10:FF:003120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220179, NULL, 'G3DSA:2.40.70.10:FF:000210', NULL, NULL, 'Os09g0428200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(220180, NULL, 'G3DSA:3.30.1520.10:FF:000170', NULL, NULL, 'Vacuolar morphogenesis protein 7 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(220181, NULL, 'G3DSA:1.10.3140.10:FF:000001', NULL, NULL, '4-hydroxyphenylacetate 3-monooxygenase oxygenase component', NULL, NULL, NULL, NULL, NULL, 4),
(220182, NULL, 'G3DSA:1.10.220.150:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220183, NULL, 'G3DSA:3.80.10.10:FF:001883', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220184, NULL, 'G3DSA:1.25.50.20:FF:000025', NULL, NULL, 'Protein CBG08739', NULL, NULL, NULL, NULL, NULL, 4),
(220185, NULL, 'G3DSA:3.90.730.10:FF:000021', NULL, NULL, 'RiboNucleaSe T homolog', NULL, NULL, NULL, NULL, NULL, 4),
(220186, NULL, 'G3DSA:1.25.40.20:FF:001688', NULL, NULL, 'Glutaminase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(220187, NULL, 'G3DSA:1.10.510.10:FF:002312', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220188, NULL, 'G3DSA:3.30.505.10:FF:000146', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220189, NULL, 'G3DSA:3.30.450.190:FF:000008', NULL, NULL, 'GTP-binding protein GTR2', NULL, NULL, NULL, NULL, NULL, 4),
(220190, NULL, 'G3DSA:3.30.565.10:FF:000167', NULL, NULL, 'Probable two-component sensor', NULL, NULL, NULL, NULL, NULL, 4),
(220191, NULL, 'G3DSA:1.25.40.10:FF:003837', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220192, NULL, 'G3DSA:3.40.30.10:FF:001206', NULL, NULL, 'Iodothyronine deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(220193, NULL, 'G3DSA:3.30.430.20:FF:000071', NULL, NULL, 'Os01g0568800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(220194, NULL, 'G3DSA:3.30.160.60:FF:004030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220195, NULL, 'G3DSA:2.60.120.1540:FF:000013', NULL, NULL, 'Complement 4B (Chido blood group)', NULL, NULL, NULL, NULL, NULL, 4),
(220196, NULL, 'G3DSA:3.90.550.10:FF:000378', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220197, NULL, 'G3DSA:2.30.29.30:FF:000430', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(220198, NULL, 'G3DSA:2.30.30.40:FF:000402', NULL, NULL, 'Protein CBG22463', NULL, NULL, NULL, NULL, NULL, 4),
(220199, NULL, 'G3DSA:1.20.1250.20:FF:000015', NULL, NULL, 'Nucleoside permease NupG', NULL, NULL, NULL, NULL, NULL, 4),
(220200, NULL, 'G3DSA:3.40.50.300:FF:002395', NULL, NULL, 'GPN-loop GTPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(220201, NULL, 'G3DSA:1.10.472.10:FF:000525', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220202, NULL, 'G3DSA:2.130.10.10:FF:001596', NULL, NULL, 'WD domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(220203, NULL, 'G3DSA:2.40.50.150:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220204, NULL, 'G3DSA:1.10.418.10:FF:000124', NULL, NULL, 'Cortexillin-2', NULL, NULL, NULL, NULL, NULL, 4),
(220205, NULL, 'G3DSA:3.20.180.20:FF:000008', NULL, NULL, 'Dynein heavy chain-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(220206, NULL, 'G3DSA:3.40.50.720:FF:000137', NULL, NULL, 'Hydroxysteroid (17-beta) dehydrogenase 3', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(220207, NULL, 'G3DSA:3.80.10.10:FF:001175', NULL, NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', NULL, NULL, NULL, NULL, NULL, 4),
(220208, NULL, 'G3DSA:1.20.120.350:FF:000172', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220209, NULL, 'G3DSA:2.60.120.1000:FF:000008', NULL, NULL, 'collagen alpha-1(XXIV) chain isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(220210, NULL, 'G3DSA:2.60.40.10:FF:005862', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220211, NULL, 'G3DSA:2.40.20.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220212, NULL, 'G3DSA:2.20.110.10:FF:000050', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220213, NULL, 'G3DSA:1.20.1270.10:FF:000120', NULL, NULL, 'Stress-70 protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(220214, NULL, 'G3DSA:3.30.200.20:FF:002285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220215, NULL, 'G3DSA:1.25.10.10:FF:000795', NULL, NULL, 'Armadillo repeat containing 8', NULL, NULL, NULL, NULL, NULL, 4),
(220216, NULL, 'G3DSA:1.10.1450.10:FF:000176', NULL, NULL, 'TetraSPanin family', NULL, NULL, NULL, NULL, NULL, 4),
(220217, NULL, 'G3DSA:3.80.10.10:FF:001091', NULL, NULL, 'AGAP009688-PA', NULL, NULL, NULL, NULL, NULL, 4),
(220218, NULL, 'G3DSA:1.10.238.10:FF:000470', NULL, NULL, 'EF-hand calcium-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(220219, NULL, 'G3DSA:1.20.1250.10:FF:000113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220220, NULL, 'G3DSA:3.40.50.1820:FF:001461', NULL, NULL, 'Serine carboxypeptidase-like 19', NULL, NULL, NULL, NULL, NULL, 4),
(220221, NULL, 'G3DSA:1.10.510.10:FF:002677', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220222, NULL, 'G3DSA:1.10.580.10:FF:000006', NULL, NULL, 'ATP-citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(220223, NULL, 'G3DSA:1.10.150.20:FF:000078', NULL, NULL, 'DNA-directed RNA polymerase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(220224, NULL, 'G3DSA:2.40.30.10:FF:000101', NULL, NULL, 'Translation elongation factor G', NULL, NULL, NULL, NULL, NULL, 4),
(220225, NULL, 'G3DSA:3.50.50.60:FF:000401', NULL, NULL, 'Protein CBG06141', NULL, NULL, NULL, NULL, NULL, 4),
(220226, NULL, 'G3DSA:1.10.3080.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220227, NULL, 'G3DSA:2.120.10.30:FF:000231', NULL, NULL, 'Haloacid dehalogenase-like hydrolase family', NULL, NULL, NULL, NULL, NULL, 4),
(220228, NULL, 'G3DSA:2.170.8.10:FF:000015', NULL, NULL, 'Phosphoenolpyruvate carboxykinase [GTP], mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(220229, NULL, 'G3DSA:1.10.1300.10:FF:000081', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(220230, NULL, 'G3DSA:1.25.10.10:FF:000267', NULL, NULL, 'Proteasome activator complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(220231, NULL, 'G3DSA:2.60.120.330:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220232, NULL, 'G3DSA:3.20.20.30:FF:000026', NULL, NULL, 'Alkanesulfonate monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(220233, NULL, 'G3DSA:3.10.350.10:FF:000004', NULL, NULL, 'Membrane-bound lytic murein transglycosylase D', NULL, NULL, NULL, NULL, NULL, 4),
(220234, NULL, 'G3DSA:3.40.50.1000:FF:000726', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220235, NULL, 'G3DSA:4.10.400.10:FF:000269', NULL, NULL, 'Suppressor of tumorigenicity 14 protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(220236, NULL, 'G3DSA:1.10.10.60:FF:001214', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220237, NULL, 'G3DSA:2.20.20.110:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220238, NULL, 'G3DSA:3.90.1150.10:FF:000116', NULL, NULL, 'Probable glycine dehydrogenase (decarboxylating) subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(220239, NULL, 'G3DSA:2.130.10.10:FF:005879', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220240, NULL, 'G3DSA:3.90.550.10:FF:000642', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(220241, NULL, 'G3DSA:1.10.10.60:FF:000702', NULL, NULL, 'SWIB complex BAF60b domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(220242, NULL, 'G3DSA:3.40.50.1000:FF:000187', NULL, NULL, 'Ubiquitin-like domain containing CTD phosphatase 1', NULL, NULL, NULL, NULL, NULL, 4),
(220243, NULL, 'G3DSA:3.40.30.40:FF:000001', NULL, NULL, 'Thiol-activated cytolysin', NULL, NULL, NULL, NULL, NULL, 4),
(220244, NULL, 'G3DSA:3.30.40.10:FF:000257', NULL, NULL, 'zinc finger protein RFP', NULL, NULL, NULL, NULL, NULL, 4),
(220245, NULL, 'G3DSA:1.10.532.10:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220246, NULL, 'G3DSA:3.40.640.10:FF:000188', NULL, NULL, 'Unplaced genomic scaffold supercont1.10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(220247, NULL, 'G3DSA:1.20.120.140:FF:000019', NULL, NULL, 'Signal recognition particle receptor FtsY', NULL, NULL, NULL, NULL, NULL, 4),
(220248, NULL, 'G3DSA:2.130.10.10:FF:001225', NULL, NULL, 'WD repeat domain 59', NULL, NULL, NULL, NULL, NULL, 4),
(220249, NULL, 'G3DSA:2.170.150.20:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220250, NULL, 'G3DSA:1.10.555.10:FF:000049', NULL, NULL, 'Related to BEM3-GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(220251, NULL, 'G3DSA:1.10.1170.10:FF:000019', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(220252, NULL, 'G3DSA:2.30.29.30:FF:000975', NULL, NULL, 'Jnk interacting protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(220253, NULL, 'G3DSA:2.60.40.1120:FF:000073', NULL, NULL, 'A kinase (PRKA)-interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(220254, NULL, 'G3DSA:1.25.40.10:FF:000504', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(220255, NULL, 'G3DSA:1.20.1250.20:FF:001740', NULL, NULL, 'Os04g0452600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(220256, NULL, 'G3DSA:3.30.70.1170:FF:000009', NULL, NULL, 'Nucleolar protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(220257, NULL, 'G3DSA:1.20.120.1200:FF:000001', NULL, NULL, 'NADH-quinone oxidoreductase subunit J', NULL, NULL, NULL, NULL, NULL, 4),
(220258, NULL, 'G3DSA:3.20.80.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220259, NULL, 'G3DSA:3.30.160.60:FF:001017', NULL, NULL, 'Zinc finger protein 236 variant', NULL, NULL, NULL, NULL, NULL, 4),
(220260, NULL, 'G3DSA:2.130.10.10:FF:005986', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220261, NULL, 'G3DSA:2.60.40.60:FF:001122', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(220262, NULL, 'G3DSA:1.20.210.10:FF:000005', NULL, NULL, 'Cytochrome c oxidase, cbb3-type, subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(220263, NULL, 'G3DSA:1.10.8.60:FF:000538', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220264, NULL, 'G3DSA:2.130.10.10:FF:002321', NULL, NULL, 'WD40-repeat-containing domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(220265, NULL, 'G3DSA:2.60.40.10:FF:005755', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220266, NULL, 'G3DSA:1.20.1230.10:FF:000011', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(220267, NULL, 'G3DSA:3.30.40.10:FF:001792', NULL, NULL, 'Non-structural maintenance of chromosomes element 1 homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(220268, NULL, 'G3DSA:3.30.710.10:FF:000325', NULL, NULL, 'BTB and MATH domain-containing protein 41', NULL, NULL, NULL, NULL, NULL, 4),
(220269, NULL, 'G3DSA:2.10.25.10:FF:000585', NULL, NULL, 'Delta-like 3 (Drosophila), isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(220270, NULL, 'G3DSA:1.10.510.10:FF:003301', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220271, NULL, 'G3DSA:1.25.40.10:FF:004473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220272, NULL, 'G3DSA:2.130.10.10:FF:001697', NULL, NULL, 'WGS project CABT00000000 data, contig 2.1', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(220273, NULL, 'G3DSA:3.40.50.2300:FF:000341', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(220274, NULL, 'G3DSA:2.160.20.10:FF:000218', NULL, NULL, 'Os01g0637500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(220275, NULL, 'G3DSA:2.130.10.10:FF:005194', NULL, NULL, 'TOPLESS-related 3', NULL, NULL, NULL, NULL, NULL, 4),
(220276, NULL, 'G3DSA:3.40.50.300:FF:005593', NULL, NULL, 'Probable inactive serine/threonine-protein kinase roco10', NULL, NULL, NULL, NULL, NULL, 4),
(220277, NULL, 'G3DSA:3.30.70.330:FF:002056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220278, NULL, 'G3DSA:1.10.10.10:FF:000643', NULL, NULL, 'Two-component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(220279, NULL, 'G3DSA:1.10.510.10:FF:000070', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(220280, NULL, 'G3DSA:2.130.10.10:FF:003586', NULL, NULL, 'Aladin/adracalin/aaas, putative', NULL, NULL, NULL, NULL, NULL, 4),
(220281, NULL, 'G3DSA:2.40.50.1070:FF:000017', NULL, NULL, '23S rRNA (uracil(1939)-C(5))-methyltransferase RlmD', NULL, NULL, NULL, NULL, NULL, 4),
(220282, NULL, 'G3DSA:2.30.29.30:FF:000183', NULL, NULL, 'Oligophrenin 1', NULL, NULL, NULL, NULL, NULL, 4),
(220283, NULL, 'G3DSA:3.40.50.80:FF:000109', NULL, NULL, 'Ferredoxin reductase component of carbazole', NULL, NULL, NULL, NULL, NULL, 4),
(220284, NULL, 'G3DSA:2.60.120.650:FF:000038', NULL, NULL, 'Transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(220285, NULL, 'G3DSA:2.120.10.80:FF:000252', NULL, NULL, 'Galactose oxidase, central domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(220286, NULL, 'G3DSA:3.30.160.60:FF:002641', NULL, NULL, 'Fog: zn-finger', NULL, NULL, NULL, NULL, NULL, 4),
(220287, NULL, 'G3DSA:1.20.120.1220:FF:000007', NULL, NULL, 'Type 4 prepilin-like proteins leader peptide-processing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(220288, NULL, 'G3DSA:2.40.37.10:FF:000015', NULL, NULL, 'Alanine racemase', NULL, NULL, NULL, NULL, NULL, 4),
(220289, NULL, 'G3DSA:3.90.226.10:FF:000153', NULL, NULL, 'Polyketide biosynthesis enoyl-CoA hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(220290, NULL, 'G3DSA:3.90.1720.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220291, NULL, 'G3DSA:3.40.50.300:FF:007026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220292, NULL, 'G3DSA:1.20.1090.10:FF:000022', NULL, NULL, 'Iron-containing alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(220293, NULL, 'G3DSA:3.30.70.330:FF:002163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220294, NULL, 'G3DSA:1.10.1070.11:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220295, NULL, 'G3DSA:3.60.21.10:FF:000358', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220296, NULL, 'G3DSA:2.120.10.80:FF:000145', NULL, NULL, 'acyl-CoA-binding domain-containing protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(220297, NULL, 'G3DSA:3.30.450.40:FF:000302', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(220298, NULL, 'G3DSA:2.40.30.170:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220299, NULL, 'G3DSA:3.40.350.10:FF:000071', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(220300, NULL, 'G3DSA:1.10.287.540:FF:000006', NULL, NULL, 'Pyrrolysyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(220301, NULL, 'G3DSA:3.90.226.10:FF:000260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220302, NULL, 'G3DSA:3.90.230.10:FF:000039', NULL, NULL, 'Metallopeptidase_family_M24_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(220303, NULL, 'G3DSA:1.25.40.10:FF:002112', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g46460, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(220304, NULL, 'G3DSA:3.60.60.10:FF:000004', NULL, NULL, 'Bile salt hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(220305, NULL, 'G3DSA:3.40.50.1980:FF:000115', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(220306, NULL, 'G3DSA:3.30.70.330:FF:002533', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220307, NULL, 'G3DSA:3.40.50.300:FF:008347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220308, NULL, 'G3DSA:2.40.270.10:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220309, NULL, 'G3DSA:3.30.710.10:FF:000432', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220310, NULL, 'G3DSA:2.40.50.740:FF:000006', NULL, NULL, '30S ribosomal protein S4e', NULL, NULL, NULL, NULL, NULL, 4),
(220311, NULL, 'G3DSA:1.10.10.10:FF:001576', NULL, NULL, 'Ferric-uptake regulator', NULL, NULL, NULL, NULL, NULL, 4),
(220312, NULL, 'G3DSA:2.60.34.10:FF:000019', NULL, NULL, 'Heat shock 70 kDa protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(220313, NULL, 'G3DSA:2.40.50.180:FF:000013', NULL, NULL, 'Putative purine-binding chemotaxis protein Chew', NULL, NULL, NULL, NULL, NULL, 4),
(220314, NULL, 'G3DSA:2.60.40.10:FF:002349', NULL, NULL, 'CD4-2 molecule, tandem duplicate 2', NULL, NULL, NULL, NULL, NULL, 4),
(220315, NULL, 'G3DSA:1.10.1420.10:FF:000039', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(220316, NULL, 'G3DSA:3.30.1360.170:FF:000019', NULL, NULL, 'Flavin-dependent thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(220317, NULL, 'G3DSA:1.20.58.2220:FF:000058', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(220318, NULL, 'G3DSA:1.25.40.10:FF:001123', NULL, NULL, 'UTP6 small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4),
(220319, NULL, 'G3DSA:2.30.170.30:FF:000001', NULL, NULL, 'Ethanolamine ammonia-lyase heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(220320, NULL, 'G3DSA:1.10.418.10:FF:000040', NULL, NULL, 'Calponin', NULL, NULL, NULL, NULL, NULL, 4),
(220321, NULL, 'G3DSA:3.40.50.2300:FF:001206', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220322, NULL, 'G3DSA:1.25.40.10:FF:000095', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(220323, NULL, 'G3DSA:2.60.470.10:FF:000011', NULL, NULL, 'Pickpocket 23, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(220324, NULL, 'G3DSA:3.30.160.60:FF:000168', NULL, NULL, 'zinc finger protein Eos isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(220325, NULL, 'G3DSA:1.10.555.10:FF:000156', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220326, NULL, 'G3DSA:2.30.29.30:FF:001178', NULL, NULL, 'AGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(220327, NULL, 'G3DSA:3.80.10.10:FF:001411', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220328, NULL, 'G3DSA:3.30.40.10:FF:001246', NULL, NULL, 'Zinc finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(220329, NULL, 'G3DSA:3.40.30.10:FF:000823', NULL, NULL, 'Iodothyronine deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(220330, NULL, 'G3DSA:1.10.238.10:FF:001240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220331, NULL, 'G3DSA:1.10.510.10:FF:003296', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220332, NULL, 'G3DSA:3.40.50.300:FF:002720', NULL, NULL, 'GTP-binding family protein', NULL, NULL, NULL, NULL, NULL, 4),
(220333, NULL, 'G3DSA:3.40.190.10:FF:000445', NULL, NULL, 'Accessory colonization factor AcfC', NULL, NULL, NULL, NULL, NULL, 4),
(220334, NULL, 'G3DSA:1.25.40.10:FF:004366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220335, NULL, 'G3DSA:3.30.160.60:FF:002422', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220336, NULL, 'G3DSA:3.10.290.10:FF:000049', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(220337, NULL, 'G3DSA:1.20.1050.10:FF:000132', NULL, NULL, 'Related to ECM4-protein involved in cell wall biogenesis and architecture', NULL, NULL, NULL, NULL, NULL, 4),
(220338, NULL, 'G3DSA:2.60.40.10:FF:003973', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220339, NULL, 'G3DSA:1.25.40.10:FF:003854', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220340, NULL, 'G3DSA:3.40.225.10:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(220341, NULL, 'G3DSA:1.10.3120.10:FF:000011', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(220342, NULL, 'G3DSA:2.30.29.30:FF:001048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220343, NULL, 'G3DSA:1.10.3720.10:FF:000045', NULL, NULL, 'Peptide ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(220344, NULL, 'G3DSA:1.25.40.10:FF:005294', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220345, NULL, 'G3DSA:1.20.1110.10:FF:000103', NULL, NULL, 'Plasma membrane calcium-transporting ATPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(220346, NULL, 'G3DSA:3.30.1390.20:FF:000038', NULL, NULL, 'Ribosomal protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(220347, NULL, 'G3DSA:1.10.760.10:FF:000104', NULL, NULL, 'Os07g0567400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(220348, NULL, 'G3DSA:1.10.340.70:FF:000023', NULL, NULL, 'Polyprotein of viral origin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(220349, NULL, 'G3DSA:1.10.238.10:FF:000251', NULL, NULL, 'Calmodulin-related protein 97A', NULL, NULL, NULL, NULL, NULL, 4),
(220350, NULL, 'G3DSA:2.30.130.10:FF:000032', NULL, NULL, 'Probable tRNA pseudouridine synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(220351, NULL, 'G3DSA:3.40.50.300:FF:007498', NULL, NULL, 'ABC transporter protein', NULL, NULL, NULL, NULL, NULL, 4),
(220352, NULL, 'G3DSA:1.10.101.10:FF:000029', NULL, NULL, 'Bll5205 protein', NULL, NULL, NULL, NULL, NULL, 4),
(220353, NULL, 'G3DSA:2.60.40.60:FF:000649', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220354, NULL, 'G3DSA:3.60.10.10:FF:000288', NULL, NULL, 'Inositol polyphosphate-5-phosphatase, 40kDa, gene 2', NULL, NULL, NULL, NULL, NULL, 4),
(220355, NULL, 'G3DSA:3.40.50.300:FF:002355', NULL, NULL, 'Drugs ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(220356, NULL, 'G3DSA:3.30.260.10:FF:000015', NULL, NULL, 'T-complex protein 1 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(220357, NULL, 'G3DSA:1.10.10.10:FF:001929', NULL, NULL, 'MarR family transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(220358, NULL, 'G3DSA:3.30.160.60:FF:000663', NULL, NULL, 'Zinc finger protein 45', NULL, NULL, NULL, NULL, NULL, 4),
(220359, NULL, 'G3DSA:3.30.2010.10:FF:000007', NULL, NULL, 'Peptidase M48 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(220360, NULL, 'G3DSA:1.20.58.530:FF:000024', NULL, NULL, 'Myosin heavy chain subunit', NULL, NULL, NULL, NULL, NULL, 4),
(220361, NULL, 'G3DSA:3.30.420.10:FF:000680', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220362, NULL, 'G3DSA:2.60.40.1510:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220363, NULL, 'G3DSA:3.30.420.40:FF:000109', NULL, NULL, 'Heat shock 70 kDa protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(220364, NULL, 'G3DSA:1.10.238.10:FF:000627', NULL, NULL, 'Inorganic pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(220365, NULL, 'G3DSA:1.10.287.110:FF:000332', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220366, NULL, 'G3DSA:3.40.50.150:FF:000399', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(220367, NULL, 'G3DSA:2.30.30.40:FF:000138', NULL, NULL, 'dynamin-binding protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(220368, NULL, 'G3DSA:3.10.110.10:FF:000110', NULL, NULL, 'Ubiquitin-conjugating enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(220369, NULL, 'G3DSA:3.40.50.1820:FF:001725', NULL, NULL, 'Putative isoprenylcysteine alpha-carbonyl methylesterase ICMEL2', NULL, NULL, NULL, NULL, NULL, 4),
(220370, NULL, 'G3DSA:1.20.1310.10:FF:000045', NULL, NULL, 'Cullin-3', NULL, NULL, NULL, NULL, NULL, 4),
(220371, NULL, 'G3DSA:3.30.70.960:FF:000007', NULL, NULL, 'Enteropeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(220372, NULL, 'G3DSA:3.10.600.10:FF:000001', NULL, NULL, 'Pyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(220373, NULL, 'G3DSA:2.30.42.10:FF:000522', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(220374, NULL, 'G3DSA:3.40.50.1820:FF:000314', NULL, NULL, 'Protein CBG08019', NULL, NULL, NULL, NULL, NULL, 4),
(220375, NULL, 'G3DSA:1.20.1250.20:FF:001870', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220376, NULL, 'G3DSA:3.40.630.30:FF:000587', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220377, NULL, 'G3DSA:3.50.30.30:FF:000020', NULL, NULL, 'Receptor homology region transmembrane domain-and RING domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(220378, NULL, 'G3DSA:1.10.1520.10:FF:000075', NULL, NULL, 'RNAse III, putative (AFU_orthologue AFUA_3G03050)', NULL, NULL, NULL, NULL, NULL, 4),
(220379, NULL, 'G3DSA:3.90.470.20:FF:000003', NULL, NULL, 'L-aminoadipate-semialdehyde dehydrogenase-phosphopantetheinyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(220380, NULL, 'G3DSA:3.30.70.1470:FF:000004', NULL, NULL, 'Caspase, apoptotic cysteine protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(220381, NULL, 'G3DSA:1.20.1530.20:FF:000071', NULL, NULL, 'Cation/H(+) antiporter 15', NULL, NULL, NULL, NULL, NULL, 4),
(220382, NULL, 'G3DSA:3.10.20.90:FF:000556', NULL, NULL, 'Novel protein similar to KIAA1548', NULL, NULL, NULL, NULL, NULL, 4),
(220383, NULL, 'G3DSA:3.30.420.380:FF:000003', NULL, NULL, 'MSHA biogenesis protein MshI', NULL, NULL, NULL, NULL, NULL, 4),
(220384, NULL, 'G3DSA:1.20.5.540:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220385, NULL, 'G3DSA:3.90.550.10:FF:000147', NULL, NULL, 'Galactosylgalactosylxylosylprotein 3-beta-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(220386, NULL, 'G3DSA:1.20.1070.10:FF:001004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220387, NULL, 'G3DSA:3.40.50.1760:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220388, NULL, 'G3DSA:1.20.1690.10:FF:000005', NULL, NULL, 'V-type proton ATPase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(220389, NULL, 'G3DSA:2.30.30.40:FF:000633', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(220390, NULL, 'G3DSA:3.30.1360.120:FF:000067', NULL, NULL, 'Sarcosine dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(220391, NULL, 'G3DSA:1.10.510.10:FF:002205', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(220392, NULL, 'G3DSA:2.70.130.10:FF:000028', NULL, NULL, 'Mannose-6-phosphate/insulin-like growth factor II receptor', NULL, NULL, NULL, NULL, NULL, 4),
(220393, NULL, 'G3DSA:3.40.50.150:FF:000719', NULL, NULL, 'Cytosine-specific DNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(220394, NULL, 'G3DSA:3.40.50.300:FF:005121', NULL, NULL, 'Lipopolysaccharide export system ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(220395, NULL, 'G3DSA:3.80.10.10:FF:002400', NULL, NULL, 'F-box domain protein (AFU_orthologue AFUA_2G02860)', NULL, NULL, NULL, NULL, NULL, 4),
(220396, NULL, 'G3DSA:3.40.50.1100:FF:000290', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(220397, NULL, 'G3DSA:2.40.50.140:FF:000613', NULL, NULL, 'Protein Translation Initiation Factor 2 subunit alpha (IF-2a)', NULL, NULL, NULL, NULL, NULL, 4),
(220398, NULL, 'G3DSA:1.10.1000.11:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220399, NULL, 'G3DSA:3.40.50.1780:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220400, NULL, 'G3DSA:3.30.70.270:FF:000104', NULL, NULL, 'Heme-regulated cyclic AMP phosphodiesterase (Direct oxygen sensor protein)', NULL, NULL, NULL, NULL, NULL, 4),
(220401, NULL, 'G3DSA:3.30.160.60:FF:002113', NULL, NULL, 'Zinc finger protein 331', NULL, NULL, NULL, NULL, NULL, 4),
(220402, NULL, 'G3DSA:3.30.70.330:FF:001128', NULL, NULL, 'CUGBP Elav-like family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(220403, NULL, 'G3DSA:1.25.40.10:FF:000634', NULL, NULL, 'Prolyl 3-hydroxylase 2', NULL, NULL, NULL, NULL, NULL, 4),
(220404, NULL, 'G3DSA:2.130.10.10:FF:004098', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(220405, NULL, 'G3DSA:1.10.20.10:FF:000132', NULL, NULL, 'CBF/NF-Y family transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(220406, NULL, 'G3DSA:3.40.50.300:FF:006407', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220407, NULL, 'G3DSA:3.90.70.10:FF:000627', NULL, NULL, 'Dipeptidyl peptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(220408, NULL, 'G3DSA:3.30.70.330:FF:003152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220409, NULL, 'G3DSA:3.80.10.10:FF:001776', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220410, NULL, 'G3DSA:3.30.70.660:FF:000007', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(220411, NULL, 'G3DSA:2.60.40.10:FF:002192', NULL, NULL, 'AGAP005471-PA', NULL, NULL, NULL, NULL, NULL, 4),
(220412, NULL, 'G3DSA:3.40.50.620:FF:000309', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(220413, NULL, 'G3DSA:3.40.50.720:FF:000795', NULL, NULL, 'Short chain dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(220414, NULL, 'G3DSA:1.25.40.10:FF:002073', NULL, NULL, 'TTK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(220415, NULL, 'G3DSA:3.30.160.60:FF:005991', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220416, NULL, 'G3DSA:3.30.1460.50:FF:000013', NULL, NULL, 'Autophagy-related protein Atg10 (JCVI)', NULL, NULL, NULL, NULL, NULL, 4),
(220417, NULL, 'G3DSA:3.80.10.10:FF:003209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220418, NULL, 'G3DSA:3.30.70.100:FF:000188', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220419, NULL, 'G3DSA:1.20.1070.10:FF:000801', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(220420, NULL, 'G3DSA:2.40.50.140:FF:000136', NULL, NULL, 'cold shock domain-containing protein E1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(220421, NULL, 'G3DSA:3.80.10.10:FF:003884', NULL, NULL, 'Leucine-rich repeat (LRR) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(220422, NULL, 'G3DSA:3.10.20.10:FF:000009', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(220423, NULL, 'G3DSA:2.170.270.10:FF:000121', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(220424, NULL, 'G3DSA:3.40.1380.10:FF:000004', NULL, NULL, 'ATP synthase gamma chain, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(220425, NULL, 'G3DSA:1.25.40.20:FF:000963', NULL, NULL, 'calmodulin-binding transcription activator 2-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(220426, NULL, 'G3DSA:1.20.1420.30:FF:000071', NULL, NULL, 'Sodium-calcium exchanger', NULL, NULL, NULL, NULL, NULL, 4),
(220427, NULL, 'G3DSA:3.80.10.10:FF:003704', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(220428, NULL, 'G3DSA:3.30.420.40:FF:001054', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(220429, NULL, 'G3DSA:2.60.120.200:FF:000252', NULL, NULL, 'Crumbs 1, cell polarity complex component', NULL, NULL, NULL, NULL, NULL, 4),
(220430, NULL, 'G3DSA:1.10.10.10:FF:000626', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(220431, NULL, 'G3DSA:1.50.10.20:FF:000060', NULL, NULL, 'Terpentedienyl-diphosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(220432, NULL, 'G3DSA:1.25.40.10:FF:002421', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g09410, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(220433, NULL, 'G3DSA:3.40.50.300:FF:006082', NULL, NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 8', NULL, NULL, NULL, NULL, NULL, 4),
(220434, NULL, 'G3DSA:3.40.50.80:FF:000126', NULL, NULL, 'Probable oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(220435, NULL, 'G3DSA:2.130.10.10:FF:002630', NULL, NULL, 'Autophagy-related protein 18b', NULL, NULL, NULL, NULL, NULL, 4),
(220436, NULL, 'G3DSA:3.30.230.10:FF:000406', NULL, NULL, 'Ribosomal protein S5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(220437, NULL, 'G3DSA:2.130.10.120:FF:000033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(220438, NULL, 'G3DSA:3.80.10.10:FF:003356', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220439, NULL, 'G3DSA:1.10.472.10:FF:000334', NULL, NULL, 'AGAP001730-PA', NULL, NULL, NULL, NULL, NULL, 4),
(220440, NULL, 'G3DSA:3.30.870.10:FF:000033', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(220441, NULL, 'G3DSA:1.25.10.10:FF:000486', NULL, NULL, 'SCY1 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(220442, NULL, 'G3DSA:3.30.930.10:FF:000319', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220443, NULL, 'G3DSA:2.60.40.10:FF:000409', NULL, NULL, 'Muscle, skeletal receptor tyrosine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(220444, NULL, 'G3DSA:2.60.40.10:FF:004451', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220445, NULL, 'G3DSA:3.40.850.10:FF:000125', NULL, NULL, 'Kinesin class 4 (Chromokinesin group)', NULL, NULL, NULL, NULL, NULL, 4),
(220446, NULL, 'G3DSA:2.30.29.30:FF:000559', NULL, NULL, 'CDC-42 Guanine nucleotide Exchange Factor', NULL, NULL, NULL, NULL, NULL, 4),
(220447, NULL, 'G3DSA:3.30.70.330:FF:000274', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein A3 2', NULL, NULL, NULL, NULL, NULL, 4),
(220448, NULL, 'G3DSA:2.10.220.10:FF:000105', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(220449, NULL, 'G3DSA:3.30.390.30:FF:000002', NULL, NULL, 'Soluble pyridine nucleotide transhydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(220450, NULL, 'G3DSA:2.60.120.920:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220451, NULL, 'G3DSA:3.30.40.10:FF:002202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220452, NULL, 'G3DSA:3.40.50.1010:FF:000263', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220453, NULL, 'G3DSA:2.130.10.10:FF:000736', NULL, NULL, 'Cleavage stimulation factor subunit 50', NULL, NULL, NULL, NULL, NULL, 4),
(220454, NULL, 'G3DSA:3.90.1140.10:FF:000054', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(220455, NULL, 'G3DSA:1.25.70.10:FF:000023', NULL, NULL, 'Os05g0403600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(220456, NULL, 'G3DSA:3.40.50.300:FF:007818', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220457, NULL, 'G3DSA:3.40.50.1820:FF:000769', NULL, NULL, 'Protein phosphatase methylesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(220458, NULL, 'G3DSA:1.20.1110.10:FF:000064', NULL, NULL, 'Cation transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(220459, NULL, 'G3DSA:3.30.760.10:FF:000036', NULL, NULL, 'Protein Translation Initiation Factor 4E (IF-4E)', NULL, NULL, NULL, NULL, NULL, 4),
(220460, NULL, 'G3DSA:2.120.10.80:FF:000128', NULL, NULL, 'tRNA wybutosine-synthesizing protein 2/3/4', NULL, NULL, NULL, NULL, NULL, 4),
(220461, NULL, 'G3DSA:2.60.40.10:FF:001028', NULL, NULL, 'Roundabout guidance receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(220462, NULL, 'G3DSA:3.40.50.2300:FF:001195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220463, NULL, 'G3DSA:3.20.20.60:FF:000024', NULL, NULL, 'Isocitrate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(220464, NULL, 'G3DSA:3.40.720.10:FF:000228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220465, NULL, 'G3DSA:3.30.420.40:FF:000093', NULL, NULL, 'Fructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(220466, NULL, 'G3DSA:4.10.1240.10:FF:000056', NULL, NULL, 'Putative g protein-coupled receptor', NULL, NULL, NULL, NULL, NULL, 4),
(220467, NULL, 'G3DSA:2.70.170.10:FF:000065', NULL, NULL, 'Glutamate-gated chloride channel, putative', NULL, NULL, NULL, NULL, NULL, 4),
(220468, NULL, 'G3DSA:1.10.357.50:FF:000016', NULL, NULL, 'protein unc-13 homolog D isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(220469, NULL, 'G3DSA:2.130.10.10:FF:002097', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(220470, NULL, 'G3DSA:3.30.160.60:FF:004906', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220471, NULL, 'G3DSA:2.40.160.210:FF:000009', NULL, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(220472, NULL, 'G3DSA:1.10.10.60:FF:000725', NULL, NULL, 'C. Elegans Homeobox', NULL, NULL, NULL, NULL, NULL, 4),
(220473, NULL, 'G3DSA:3.30.390.50:FF:000008', NULL, NULL, 'Lipoate--protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(220474, NULL, 'G3DSA:1.25.40.70:FF:000045', NULL, NULL, 'Phosphatidylinositol 3-kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(220475, NULL, 'G3DSA:1.10.287.600:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220476, NULL, 'G3DSA:3.30.70.890:FF:000054', NULL, NULL, 'Mevalonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(220477, NULL, 'G3DSA:3.40.47.10:FF:000098', NULL, NULL, 'Uncharacterized protein B0303.3', NULL, NULL, NULL, NULL, NULL, 4),
(220478, NULL, 'G3DSA:3.60.40.10:FF:000121', NULL, NULL, 'Probable protein phosphatase 2C 51', NULL, NULL, NULL, NULL, NULL, 4),
(220479, NULL, 'G3DSA:3.20.20.80:FF:000108', NULL, NULL, 'glycogen debranching enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(220480, NULL, 'G3DSA:3.40.50.300:FF:007043', NULL, NULL, 'Putative RAD51C', NULL, NULL, NULL, NULL, NULL, 4),
(220481, NULL, 'G3DSA:1.10.418.20:FF:000026', NULL, NULL, 'Si:dkey-100n23.3', NULL, NULL, NULL, NULL, NULL, 4),
(220482, NULL, 'G3DSA:1.20.120.1780:FF:000006', NULL, NULL, 'Digeranylgeranylglyceryl phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(220483, NULL, 'G3DSA:3.40.50.720:FF:002138', NULL, NULL, 'Ubiquitin-like modifier-activating enzyme 7', NULL, NULL, NULL, NULL, NULL, 4),
(220484, NULL, 'G3DSA:3.30.160.60:FF:003041', NULL, NULL, 'GG12054', NULL, NULL, NULL, NULL, NULL, 4),
(220485, NULL, 'G3DSA:3.30.160.60:FF:001949', NULL, NULL, 'zinc finger protein 62 homolog isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(220486, NULL, 'G3DSA:1.10.3380.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220487, NULL, 'G3DSA:3.10.20.90:FF:000180', NULL, NULL, 'midnolin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(220488, NULL, 'G3DSA:2.60.40.10:FF:005446', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220489, NULL, 'G3DSA:3.40.50.1980:FF:000076', NULL, NULL, 'Iron-dicitrate ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(220490, NULL, 'G3DSA:1.20.1510.10:FF:000049', NULL, NULL, 'Cation transporter', NULL, NULL, NULL, NULL, NULL, 4),
(220491, NULL, 'G3DSA:2.120.10.30:FF:000607', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220492, NULL, 'G3DSA:3.30.450.30:FF:000075', NULL, NULL, 'Profilin', NULL, NULL, NULL, NULL, NULL, 4),
(220493, NULL, 'G3DSA:3.10.105.10:FF:000036', NULL, NULL, 'Peptide/nickel transport system substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(220494, NULL, 'G3DSA:1.10.3260.10:FF:000021', NULL, NULL, 'ATP-dependent DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(220495, NULL, 'G3DSA:3.30.160.60:FF:002894', NULL, NULL, 'AGAP010979-PA', NULL, NULL, NULL, NULL, NULL, 4),
(220496, NULL, 'G3DSA:1.10.1300.10:FF:000064', NULL, NULL, 'Phosphodiesterase 4B, cAMP-specific a', NULL, NULL, NULL, NULL, NULL, 4),
(220497, NULL, 'G3DSA:1.25.40.530:FF:000010', NULL, NULL, 'Myosin VIIA', NULL, NULL, NULL, NULL, NULL, 4),
(220498, NULL, 'G3DSA:2.10.25.10:FF:000169', NULL, NULL, 'teneurin-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(220499, NULL, 'G3DSA:3.40.50.2020:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220500, NULL, 'G3DSA:3.30.70.3220:FF:000001', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(220501, NULL, 'G3DSA:3.80.10.10:FF:002395', NULL, NULL, 'Protein phosphatase 1, regulatory subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(220502, NULL, 'G3DSA:1.20.5.340:FF:000052', NULL, NULL, 'Myosin heavy chain 6', NULL, NULL, NULL, NULL, NULL, 4),
(220503, NULL, 'G3DSA:2.40.70.10:FF:000525', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220504, NULL, 'G3DSA:1.10.510.10:FF:003610', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220505, NULL, 'G3DSA:3.30.70.330:FF:001763', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(220506, NULL, 'G3DSA:2.30.29.220:FF:000004', NULL, NULL, 'FACT complex subunit SSRP1', NULL, NULL, NULL, NULL, NULL, 4),
(220507, NULL, 'G3DSA:1.10.8.60:FF:000292', NULL, NULL, 'p60 katanin/ AAA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(220508, NULL, 'G3DSA:3.30.70.330:FF:000616', NULL, NULL, 'RNA binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(220509, NULL, 'G3DSA:3.30.160.60:FF:002006', NULL, NULL, 'Zinc finger protein 668', NULL, NULL, NULL, NULL, NULL, 4),
(220510, NULL, 'G3DSA:3.40.720.10:FF:000245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220511, NULL, 'G3DSA:2.60.120.260:FF:000663', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220512, NULL, 'G3DSA:2.30.42.10:FF:000045', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type', NULL, NULL, NULL, NULL, NULL, 4),
(220513, NULL, 'G3DSA:1.25.40.10:FF:002449', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220514, NULL, 'G3DSA:2.30.30.380:FF:000026', NULL, NULL, 'Nei-like DNA glycosylase 3', NULL, NULL, NULL, NULL, NULL, 4),
(220515, NULL, 'G3DSA:1.10.287.10:FF:000038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220516, NULL, 'G3DSA:3.40.1810.10:FF:000009', NULL, NULL, 'agamous-like MADS-box protein AGL11', NULL, NULL, NULL, NULL, NULL, 4),
(220517, NULL, 'G3DSA:2.120.10.30:FF:000124', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(220518, NULL, 'G3DSA:2.60.40.60:FF:000166', NULL, NULL, 'cadherin-23 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(220519, NULL, 'G3DSA:2.30.29.30:FF:000666', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(220520, NULL, 'G3DSA:3.20.20.370:FF:000031', NULL, NULL, 'Carbohydrate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(220521, NULL, 'G3DSA:2.40.160.210:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220522, NULL, 'G3DSA:3.40.50.2000:FF:000239', NULL, NULL, 'Trehalose-phosphatase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(220523, NULL, 'G3DSA:3.30.2310.20:FF:000016', NULL, NULL, 'Toxin RelE3', NULL, NULL, NULL, NULL, NULL, 4),
(220524, NULL, 'G3DSA:3.40.630.60:FF:000005', NULL, NULL, 'Ornithine decarboxylase antizyme, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(220525, NULL, 'G3DSA:1.25.40.10:FF:004001', NULL, NULL, 'RNA polymerase II protein ral transcription factor BTF3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(220526, NULL, 'G3DSA:2.10.25.10:FF:001097', NULL, NULL, 'Low-density lipoprotein receptor-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(220527, NULL, 'G3DSA:2.10.25.10:FF:000478', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(220528, NULL, 'G3DSA:1.20.58.340:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220529, NULL, 'G3DSA:2.40.10.10:FF:000549', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220530, NULL, 'G3DSA:2.40.30.10:FF:000320', NULL, NULL, 'tRNA-specific 2-thiouridylase MnmA', NULL, NULL, NULL, NULL, NULL, 4),
(220531, NULL, 'G3DSA:3.10.100.10:FF:000284', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220532, NULL, 'G3DSA:3.30.559.30:FF:000001', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(220533, NULL, 'G3DSA:1.25.10.10:FF:002245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220534, NULL, 'G3DSA:3.30.1370.210:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220535, NULL, 'G3DSA:2.60.40.10:FF:005070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220536, NULL, 'G3DSA:1.10.238.10:FF:000599', NULL, NULL, 'Reticulocalbin-3', NULL, NULL, NULL, NULL, NULL, 4),
(220537, NULL, 'G3DSA:1.25.40.10:FF:003377', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g04760, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(220538, NULL, 'G3DSA:3.40.850.10:FF:000434', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(220539, NULL, 'G3DSA:1.20.120.290:FF:000002', NULL, NULL, 'Photosynthetic NDH subunit of lumenal location 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(220540, NULL, 'G3DSA:1.10.150.20:FF:000117', NULL, NULL, 'Translocation protein SEC63', NULL, NULL, NULL, NULL, NULL, 4),
(220541, NULL, 'G3DSA:3.40.30.10:FF:000003', NULL, NULL, 'Peroxiredoxin 1', NULL, NULL, NULL, NULL, NULL, 4),
(220542, NULL, 'G3DSA:2.40.30.10:FF:000096', NULL, NULL, 'tRNA-specific 2-thiouridylase MnmA', NULL, NULL, NULL, NULL, NULL, 4),
(220543, NULL, 'G3DSA:3.30.40.10:FF:002174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220544, NULL, 'G3DSA:2.70.20.10:FF:000015', NULL, NULL, 'DNA topoisomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(220545, NULL, 'G3DSA:2.60.40.10:FF:000084', NULL, NULL, 'Myosin binding protein C, slow type', NULL, NULL, NULL, NULL, NULL, 4),
(220546, NULL, 'G3DSA:3.10.100.10:FF:000323', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220547, NULL, 'G3DSA:3.80.10.10:FF:001759', NULL, NULL, 'Toll-like receptor 19', NULL, NULL, NULL, NULL, NULL, 4),
(220548, NULL, 'G3DSA:2.60.40.10:FF:004142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220549, NULL, 'G3DSA:2.60.200.20:FF:000219', NULL, NULL, 'Bromo and FHA domain-containing protein DDB_G0267958', NULL, NULL, NULL, NULL, NULL, 4),
(220550, NULL, 'G3DSA:3.10.310.70:FF:000002', NULL, NULL, 'LAF3/LAF3 ISF1/LAF3 ISF2', NULL, NULL, NULL, NULL, NULL, 4),
(220551, NULL, 'G3DSA:3.40.30.10:FF:000930', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220552, NULL, 'G3DSA:3.40.390.10:FF:000207', NULL, NULL, 'Fra mauro, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(220553, NULL, 'G3DSA:1.20.1270.60:FF:000011', NULL, NULL, 'Brain-specific angiogenesis inhibitor 1-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(220554, NULL, 'G3DSA:1.10.730.10:FF:000081', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(220555, NULL, 'G3DSA:2.60.40.150:FF:000239', NULL, NULL, 'Calcium-dependent secretion activator', NULL, NULL, NULL, NULL, NULL, 4),
(220556, NULL, 'G3DSA:1.20.1070.10:FF:001420', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220557, NULL, 'G3DSA:2.60.40.10:FF:000556', NULL, NULL, 'Immunoglobulin heavy variable 7-81 (non-functional)', NULL, NULL, NULL, NULL, NULL, 4),
(220558, NULL, 'G3DSA:1.25.40.10:FF:003068', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(220559, NULL, 'G3DSA:2.60.40.1180:FF:000152', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(220560, NULL, 'G3DSA:1.20.1280.170:FF:000008', NULL, NULL, 'Exocyst complex component 7', NULL, NULL, NULL, NULL, NULL, 4),
(220561, NULL, 'G3DSA:1.10.8.100:FF:000033', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(220562, NULL, 'G3DSA:3.30.200.20:FF:002032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220563, NULL, 'G3DSA:2.40.50.40:FF:000055', NULL, NULL, 'Chromatin-associated protein swi6', NULL, NULL, NULL, NULL, NULL, 4),
(220564, NULL, 'G3DSA:2.60.40.150:FF:000211', NULL, NULL, 'synaptotagmin-5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(220565, NULL, 'G3DSA:2.20.70.10:FF:000043', NULL, NULL, 'Pleckstrin homology domain-containing, family A member 5', NULL, NULL, NULL, NULL, NULL, 4),
(220566, NULL, 'G3DSA:2.70.150.10:FF:000052', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(220567, NULL, 'G3DSA:2.60.40.10:FF:004266', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220568, NULL, 'G3DSA:3.30.310.10:FF:000031', NULL, NULL, 'AP-2 complex subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(220569, NULL, 'G3DSA:3.30.70.330:FF:001544', NULL, NULL, 'Serine/arginine-rich splicing factor SR45a', NULL, NULL, NULL, NULL, NULL, 4),
(220570, NULL, 'G3DSA:3.40.50.300:FF:005929', NULL, NULL, '26S protease regulatory subunit 10B A', NULL, NULL, NULL, NULL, NULL, 4),
(220571, NULL, 'G3DSA:3.50.30.30:FF:000059', NULL, NULL, 'Minor extracellular protease VPR', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(220572, NULL, 'G3DSA:3.90.70.10:FF:000599', NULL, NULL, 'Ubiquitin carboxylterminal hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(220573, NULL, 'G3DSA:1.20.120.1080:FF:000010', NULL, NULL, 'ATP-dependent RNA helicase DQX1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(220574, NULL, 'G3DSA:4.10.910.10:FF:000004', NULL, NULL, 'Small subunit ribosomal protein S13', NULL, NULL, NULL, NULL, NULL, 4),
(220575, NULL, 'G3DSA:3.30.60.30:FF:000141', NULL, NULL, 'Protein CBG17314', NULL, NULL, NULL, NULL, NULL, 4),
(220576, NULL, 'G3DSA:1.25.10.10:FF:001756', NULL, NULL, 'Pre-rRNA-processing protein IPI1-1', NULL, NULL, NULL, NULL, NULL, 4),
(220577, NULL, 'G3DSA:3.80.10.10:FF:003665', NULL, NULL, 'F-box/leucine rich repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(220578, NULL, 'G3DSA:3.30.160.60:FF:003602', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220579, NULL, 'G3DSA:2.10.50.10:FF:000098', NULL, NULL, 'C-type LECtin', NULL, NULL, NULL, NULL, NULL, 4),
(220580, NULL, 'G3DSA:2.60.40.10:FF:004827', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220581, NULL, 'G3DSA:1.10.510.10:FF:002340', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220582, NULL, 'G3DSA:2.60.40.60:FF:001127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220583, NULL, 'G3DSA:3.40.50.1000:FF:000743', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220584, NULL, 'G3DSA:3.40.850.10:FF:000092', NULL, NULL, 'Myosin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(220585, NULL, 'G3DSA:3.40.366.10:FF:000073', NULL, NULL, 'Acyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(220586, NULL, 'G3DSA:1.10.540.10:FF:000032', NULL, NULL, 'Acyl-CoA dehydrogenase fadE16', NULL, NULL, NULL, NULL, NULL, 4),
(220587, NULL, 'G3DSA:2.60.34.20:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220588, NULL, 'G3DSA:2.60.200.20:FF:000062', NULL, NULL, 'Serine/threonine-protein kinase RAD53', NULL, NULL, NULL, NULL, NULL, 4),
(220589, NULL, 'G3DSA:2.60.410.10:FF:000007', NULL, NULL, 'Putative D-alanyl-D-alanine carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(220590, NULL, 'G3DSA:3.30.70.330:FF:001235', NULL, NULL, 'RNA-binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(220591, NULL, 'G3DSA:3.40.50.300:FF:003204', NULL, NULL, 'RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(220592, NULL, 'G3DSA:3.20.20.80:FF:000558', NULL, NULL, 'Si:dkey-224e22.2', NULL, NULL, NULL, NULL, NULL, 4),
(220593, NULL, 'G3DSA:3.40.50.80:FF:000093', NULL, NULL, 'Putative cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(220594, NULL, 'G3DSA:2.130.10.10:FF:004575', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220595, NULL, 'G3DSA:1.25.40.10:FF:003040', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(220596, NULL, 'G3DSA:3.10.110.10:FF:000149', NULL, NULL, 'Ubiquitin-conjugating enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(220597, NULL, 'G3DSA:2.60.40.790:FF:000189', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220598, NULL, 'G3DSA:3.30.420.10:FF:000022', NULL, NULL, 'Exosome component 10', NULL, NULL, NULL, NULL, NULL, 4),
(220599, NULL, 'G3DSA:1.10.10.10:FF:000278', NULL, NULL, 'Forkhead box protein H1', NULL, NULL, NULL, NULL, NULL, 4),
(220600, NULL, 'G3DSA:3.20.20.70:FF:000246', NULL, NULL, 'Orotidine 5''-phosphate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(220601, NULL, 'G3DSA:2.170.270.10:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220602, NULL, 'G3DSA:3.10.290.10:FF:000089', NULL, NULL, '40S ribosomal protein S4', NULL, NULL, NULL, NULL, NULL, 4),
(220603, NULL, 'G3DSA:1.25.10.10:FF:002740', NULL, NULL, 'Importin 7', NULL, NULL, NULL, NULL, NULL, 4),
(220604, NULL, 'G3DSA:2.60.120.260:FF:000354', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(220605, NULL, 'G3DSA:2.30.30.100:FF:000206', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm3', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(220606, NULL, 'G3DSA:2.60.40.150:FF:000548', NULL, NULL, 'VPS34-like PI-3-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(220607, NULL, 'G3DSA:1.20.1250.20:FF:001667', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(220608, NULL, 'G3DSA:3.40.50.300:FF:000247', NULL, NULL, 'ADP-ribosylation factor-like GTPase 8A', NULL, NULL, NULL, NULL, NULL, 4),
(220609, NULL, 'G3DSA:1.10.472.80:FF:000079', NULL, NULL, 'TBC1 domain family member 25', NULL, NULL, NULL, NULL, NULL, 4),
(220610, NULL, 'G3DSA:2.60.40.10:FF:001045', NULL, NULL, 'Interleukin 6 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(220611, NULL, 'G3DSA:2.60.120.290:FF:000245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220612, NULL, 'G3DSA:3.40.50.300:FF:006554', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220613, NULL, 'G3DSA:2.60.40.10:FF:000775', NULL, NULL, 'Uncharacterized protein, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(220614, NULL, 'G3DSA:2.70.150.10:FF:000283', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(220615, NULL, 'G3DSA:2.60.300.12:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220616, NULL, 'G3DSA:1.20.5.190:FF:000018', NULL, NULL, 'Myosin XI D', NULL, NULL, NULL, NULL, NULL, 4),
(220617, NULL, 'G3DSA:3.40.50.300:FF:001175', NULL, NULL, 'Phosphoseryl-tRNA kinase', NULL, NULL, NULL, NULL, NULL, 4),
(220618, NULL, 'G3DSA:1.20.120.30:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220619, NULL, 'G3DSA:1.10.3210.10:FF:000001', NULL, NULL, 'GTP pyrophosphokinase RelA', NULL, NULL, NULL, NULL, NULL, 4),
(220620, NULL, 'G3DSA:3.50.50.100:FF:000028', NULL, NULL, 'Pyridine nucleotide-disulfide oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(220621, NULL, 'G3DSA:3.60.21.10:FF:000122', NULL, NULL, 'UshA related metallophosphatase, N-terminal domain', NULL, NULL, NULL, NULL, NULL, 4),
(220622, NULL, 'G3DSA:3.40.50.2000:FF:000689', NULL, NULL, 'Glycosyltransferase, group 1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(220623, NULL, 'G3DSA:2.120.10.30:FF:000046', NULL, NULL, 'Blast:Protein yellow', NULL, NULL, NULL, NULL, NULL, 4),
(220624, NULL, 'G3DSA:2.10.60.10:FF:000048', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(220625, NULL, 'G3DSA:3.90.70.10:FF:000054', NULL, NULL, 'Calpain 14', NULL, NULL, NULL, NULL, NULL, 4),
(220626, NULL, 'G3DSA:1.25.40.10:FF:003832', NULL, NULL, 'Translocation protein sec72', NULL, NULL, NULL, NULL, NULL, 4),
(220627, NULL, 'G3DSA:1.20.1050.130:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220628, NULL, 'G3DSA:1.20.5.170:FF:000012', NULL, NULL, 'Putative transcription factor AP-1', NULL, NULL, NULL, NULL, NULL, 4),
(220629, NULL, 'G3DSA:2.30.30.140:FF:000078', NULL, NULL, 'HypC/HybG/HupF family hydrogenase formation chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(220630, NULL, 'G3DSA:1.10.443.10:FF:000020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(220631, NULL, 'G3DSA:2.130.10.10:FF:004553', NULL, NULL, 'Chromosome 12, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(220632, NULL, 'G3DSA:3.30.420.10:FF:000713', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220633, NULL, 'G3DSA:3.40.50.1580:FF:000063', NULL, NULL, 'Futalosine hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(220634, NULL, 'G3DSA:3.30.70.260:FF:000011', NULL, NULL, 'Acetolactate synthase isozyme 1 small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(220635, NULL, 'G3DSA:2.40.50.150:FF:000015', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(220636, NULL, 'G3DSA:2.60.40.1090:FF:000018', NULL, NULL, 'Fimbrial family protein', NULL, NULL, NULL, NULL, NULL, 4),
(220637, NULL, 'G3DSA:3.30.1330.90:FF:000010', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(220638, NULL, 'G3DSA:1.20.1270.280:FF:000056', NULL, NULL, 'AGAP010790-PA', NULL, NULL, NULL, NULL, NULL, 4),
(220639, NULL, 'G3DSA:3.40.50.300:FF:006065', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(220640, NULL, 'G3DSA:2.60.120.200:FF:000235', NULL, NULL, 'Beta-1,3-glucan-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(220641, NULL, 'G3DSA:3.40.33.10:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220642, NULL, 'G3DSA:3.80.10.10:FF:002956', NULL, NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', NULL, NULL, NULL, NULL, NULL, 4),
(220643, NULL, 'G3DSA:3.30.160.60:FF:002877', NULL, NULL, 'Zgc:110821', NULL, NULL, NULL, NULL, NULL, 4),
(220644, NULL, 'G3DSA:2.10.90.10:FF:000128', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220645, NULL, 'G3DSA:3.30.160.60:FF:004586', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220646, NULL, 'G3DSA:3.30.428.10:FF:000034', NULL, NULL, 'Galactose-1-phosphate uridylyltransferase galTa', NULL, NULL, NULL, NULL, NULL, 4),
(220647, NULL, 'G3DSA:3.30.450.20:FF:000162', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(220648, NULL, 'G3DSA:1.25.10.10:FF:000031', NULL, NULL, 'CLIP-associating protein 1 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(220649, NULL, 'G3DSA:3.30.70.330:FF:000583', NULL, NULL, 'RNA-binding protein musashi, putative', NULL, NULL, NULL, NULL, NULL, 4),
(220650, NULL, 'G3DSA:3.50.50.60:FF:000581', NULL, NULL, 'Rab GDP dissociation inhibitor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(220651, NULL, 'G3DSA:3.30.450.40:FF:000168', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(220652, NULL, 'G3DSA:1.20.1080.10:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220653, NULL, 'G3DSA:3.40.50.300:FF:001658', NULL, NULL, 'Testicular tissue protein Li 168', NULL, NULL, NULL, NULL, NULL, 4),
(220654, NULL, 'G3DSA:3.30.1330.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220655, NULL, 'G3DSA:3.20.20.70:FF:000229', NULL, NULL, 'tRNA-dihydrouridine(20) synthase [NAD(P)+]-like', NULL, NULL, NULL, NULL, NULL, 4),
(220656, NULL, 'G3DSA:3.40.50.720:FF:001756', NULL, NULL, 'Mrf1p', NULL, NULL, NULL, NULL, NULL, 4),
(220657, NULL, 'G3DSA:3.40.1280.10:FF:000064', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase E', NULL, NULL, NULL, NULL, NULL, 4),
(220658, NULL, 'G3DSA:3.30.160.60:FF:003967', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220659, NULL, 'G3DSA:3.50.50.60:FF:001093', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(220660, NULL, 'G3DSA:1.25.40.70:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220661, NULL, 'G3DSA:3.90.105.10:FF:000018', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(220662, NULL, 'G3DSA:3.90.930.12:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220663, NULL, 'G3DSA:1.20.1560.10:FF:000215', NULL, NULL, 'ABC transporter B family member 4', NULL, NULL, NULL, NULL, NULL, 4),
(220664, NULL, 'G3DSA:3.30.70.20:FF:000110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220665, NULL, 'G3DSA:3.30.40.10:FF:000712', NULL, NULL, 'RING-H2 finger protein ATL60', NULL, NULL, NULL, NULL, NULL, 4),
(220666, NULL, 'G3DSA:3.30.70.330:FF:000055', NULL, NULL, 'Splicing factor U2AF 35 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(220667, NULL, 'G3DSA:3.30.559.10:FF:000006', NULL, NULL, 'Dihydrolipoyllysine-residue succinyltransferase component of 2-oxoglutarate dehydrogenase complex, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(220668, NULL, 'G3DSA:3.10.150.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220669, NULL, 'G3DSA:1.10.510.10:FF:000098', NULL, NULL, 'Mitogen-activated protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(220670, NULL, 'G3DSA:2.60.40.10:FF:002012', NULL, NULL, 'KETtiN (Drosophila actin-binding) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(220671, NULL, 'G3DSA:4.10.93.10:FF:000001', NULL, NULL, 'Cytochrome c oxidase subunit 6C', NULL, NULL, NULL, NULL, NULL, 4),
(220672, NULL, 'G3DSA:1.50.40.10:FF:000351', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(220673, NULL, 'G3DSA:3.40.640.10:FF:000160', NULL, NULL, 'Class III pyridoxal phosphate-dependent aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(220674, NULL, 'G3DSA:3.30.40.10:FF:000173', NULL, NULL, 'E3 ubiquitin-protein ligase RNF4', NULL, NULL, NULL, NULL, NULL, 4),
(220675, NULL, 'G3DSA:3.30.390.10:FF:000007', NULL, NULL, 'L-rhamnonate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(220676, NULL, 'G3DSA:1.10.3730.10:FF:000001', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(220677, NULL, 'G3DSA:2.40.10.10:FF:000173', NULL, NULL, 'GG16564', NULL, NULL, NULL, NULL, NULL, 4),
(220678, NULL, 'G3DSA:1.10.287.110:FF:000198', NULL, NULL, 'UDP-glycosyltransferase TURAN', NULL, NULL, NULL, NULL, NULL, 4),
(220679, NULL, 'G3DSA:3.10.20.90:FF:000106', NULL, NULL, 'Polycomb complex protein BMI-1', NULL, NULL, NULL, NULL, NULL, 4),
(220680, NULL, 'G3DSA:2.60.40.10:FF:003046', NULL, NULL, 'Poliovirus receptor', NULL, NULL, NULL, NULL, NULL, 4),
(220681, NULL, 'G3DSA:3.90.550.10:FF:000294', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(220682, NULL, 'G3DSA:2.130.10.10:FF:003934', NULL, NULL, 'AER249Cp', NULL, NULL, NULL, NULL, NULL, 4),
(220683, NULL, 'G3DSA:2.70.130.10:FF:000175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220684, NULL, 'G3DSA:3.30.420.40:FF:000565', NULL, NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(220685, NULL, 'G3DSA:3.40.50.620:FF:000225', NULL, NULL, 'Leucine--tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(220686, NULL, 'G3DSA:1.20.120.1630:FF:000012', NULL, NULL, 'Polyprenol reductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(220687, NULL, 'G3DSA:3.30.2350.10:FF:000044', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(220688, NULL, 'G3DSA:3.30.450.20:FF:000055', NULL, NULL, 'neuronal PAS domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(220689, NULL, 'G3DSA:1.20.1250.20:FF:000251', NULL, NULL, 'Inner membrane transporter YeaN', NULL, NULL, NULL, NULL, NULL, 4),
(220690, NULL, 'G3DSA:3.40.50.1100:FF:000099', NULL, NULL, 'Cystathionine Beta-Synthase', NULL, NULL, NULL, NULL, NULL, 4),
(220691, NULL, 'G3DSA:3.40.630.30:FF:000137', NULL, NULL, '[Citrate [pro-3S]-lyase] ligase', NULL, NULL, NULL, NULL, NULL, 4),
(220692, NULL, 'G3DSA:3.30.450.20:FF:000538', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220693, NULL, 'G3DSA:3.30.160.60:FF:004114', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220694, NULL, 'G3DSA:3.40.190.290:FF:000049', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(220695, NULL, 'G3DSA:3.20.20.140:FF:000237', NULL, NULL, 'Aminodeoxyfutalosine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(220696, NULL, 'G3DSA:2.40.240.130:FF:000009', NULL, NULL, 'Dishevelled segment polarity protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(220697, NULL, 'G3DSA:1.25.40.90:FF:000040', NULL, NULL, 'ADP-ribosylation factor-binding protein GGA3 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(220698, NULL, 'G3DSA:3.30.497.10:FF:000093', NULL, NULL, 'AGAP003194-PA', NULL, NULL, NULL, NULL, NULL, 4),
(220699, NULL, 'G3DSA:2.30.30.490:FF:000076', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(220700, NULL, 'G3DSA:3.30.160.60:FF:005204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220701, NULL, 'G3DSA:3.60.10.10:FF:000310', NULL, NULL, 'Putative inositol polyphosphate phosphatase (Synaptogenin-like) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(220702, NULL, 'G3DSA:3.40.640.10:FF:000536', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220703, NULL, 'G3DSA:3.30.300.10:FF:000058', NULL, NULL, 'S-adenosylmethionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(220704, NULL, 'G3DSA:4.10.1290.10:FF:000003', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 17', NULL, NULL, NULL, NULL, NULL, 4),
(220705, NULL, 'G3DSA:2.60.220.50:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(220706, NULL, 'G3DSA:3.30.200.20:FF:001335', NULL, NULL, 'Calmodulin-binding receptor-like cytoplasmic kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(220707, NULL, 'G3DSA:3.40.630.10:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220708, NULL, 'G3DSA:2.60.120.650:FF:000241', NULL, NULL, 'Lysine (K)-specific demethylase 5A', NULL, NULL, NULL, NULL, NULL, 4),
(220709, NULL, 'G3DSA:2.120.10.80:FF:000330', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(220710, NULL, 'G3DSA:2.80.10.50:FF:000054', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(220711, NULL, 'G3DSA:2.60.120.10:FF:000255', NULL, NULL, 'Cysteine dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(220712, NULL, 'G3DSA:1.10.238.10:FF:001324', NULL, NULL, 'Calpain 1', NULL, NULL, NULL, NULL, NULL, 4),
(220713, NULL, 'G3DSA:2.170.130.10:FF:000050', NULL, NULL, 'M56 family peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(220714, NULL, 'G3DSA:1.10.10.10:FF:001340', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(220715, NULL, 'G3DSA:1.20.58.60:FF:000666', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220716, NULL, 'G3DSA:3.40.50.300:FF:008010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220717, NULL, 'G3DSA:3.90.780.10:FF:000007', NULL, NULL, 'Trifunctional nucleotide phosphoesterase protein YfkN', NULL, NULL, NULL, NULL, NULL, 4),
(220718, NULL, 'G3DSA:1.10.630.10:FF:000679', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220719, NULL, 'G3DSA:2.40.160.10:FF:000043', NULL, NULL, 'Voltage-dependent anion-selective channel 1', NULL, NULL, NULL, NULL, NULL, 4),
(220720, NULL, 'G3DSA:2.60.120.970:FF:000016', NULL, NULL, 'Bone morphogenetic protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(220721, NULL, 'G3DSA:2.40.10.10:FF:000066', NULL, NULL, 'Complement factor I', NULL, NULL, NULL, NULL, NULL, 4),
(220722, NULL, 'G3DSA:1.10.940.10:FF:000017', NULL, NULL, 'Transcription antitermination factor NusB', NULL, NULL, NULL, NULL, NULL, 4),
(220723, NULL, 'G3DSA:3.30.70.330:FF:002511', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220724, NULL, 'G3DSA:1.10.472.130:FF:000007', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(220725, NULL, 'G3DSA:2.160.20.10:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220726, NULL, 'G3DSA:1.25.10.10:FF:001975', NULL, NULL, 'YALI0B05940p', NULL, NULL, NULL, NULL, NULL, 4),
(220727, NULL, 'G3DSA:1.25.40.10:FF:001359', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g57430, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(220728, NULL, 'G3DSA:3.80.10.10:FF:003249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220729, NULL, 'G3DSA:3.40.30.10:FF:001223', NULL, NULL, 'Protein disulfide-isomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(220730, NULL, 'G3DSA:3.40.50.300:FF:002479', NULL, NULL, 'DEAD/DEAH box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(220731, NULL, 'G3DSA:2.60.40.150:FF:000464', NULL, NULL, 'C2 domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(220732, NULL, 'G3DSA:1.25.10.10:FF:002375', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(220733, NULL, 'G3DSA:1.10.150.390:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220734, NULL, 'G3DSA:1.20.1600.10:FF:000039', NULL, NULL, 'Outer membrane efflux protein', NULL, NULL, NULL, NULL, NULL, 4),
(220735, NULL, 'G3DSA:3.30.160.60:FF:002080', NULL, NULL, 'Zinc finger RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(220736, NULL, 'G3DSA:2.60.40.10:FF:004682', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220737, NULL, 'G3DSA:1.10.150.50:FF:000076', NULL, NULL, 'Smg, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(220738, NULL, 'G3DSA:3.40.50.1380:FF:000031', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(220739, NULL, 'G3DSA:1.10.540.10:FF:000015', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(220740, NULL, 'G3DSA:3.40.640.10:FF:000391', NULL, NULL, 'RE16411p', NULL, NULL, NULL, NULL, NULL, 4),
(220741, NULL, 'G3DSA:3.30.200.20:FF:001644', NULL, NULL, 'Tribbles-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(220742, NULL, 'G3DSA:2.60.40.10:FF:004373', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220743, NULL, 'G3DSA:3.80.10.10:FF:002737', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(220744, NULL, 'G3DSA:3.40.50.800:FF:000049', NULL, NULL, 'Threonine--tRNA ligase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(220745, NULL, 'G3DSA:4.10.1240.50:FF:000017', NULL, NULL, 'Arginine-glutamic acid dipeptide repeats', NULL, NULL, NULL, NULL, NULL, 4),
(220746, NULL, 'G3DSA:3.40.50.300:FF:003120', NULL, NULL, 'ATP-binding cassette protein subfamily F, member 3', NULL, NULL, NULL, NULL, NULL, 4),
(220747, NULL, 'G3DSA:3.40.50.20:FF:000007', NULL, NULL, 'Formate-dependent phosphoribosylglycinamide formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(220748, NULL, 'G3DSA:3.50.4.10:FF:000039', NULL, NULL, 'NOmpA Homolog (Drosophila nompA: no mechanoreceptor potential A)', NULL, NULL, NULL, NULL, NULL, 4),
(220749, NULL, 'G3DSA:1.20.970.10:FF:000028', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(220750, NULL, 'G3DSA:1.20.1610.10:FF:000012', NULL, NULL, 'Alpha-1,2-mannosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(220751, NULL, 'G3DSA:1.25.10.10:FF:003212', NULL, NULL, 'Serine/threonine-protein kinase tor1', NULL, NULL, NULL, NULL, NULL, 4),
(220752, NULL, 'G3DSA:2.60.40.10:FF:002664', NULL, NULL, 'Immunoglobulin lambda variable 5-48 (non-functional)', NULL, NULL, NULL, NULL, NULL, 4),
(220753, NULL, 'G3DSA:1.10.418.10:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220754, NULL, 'G3DSA:3.40.50.2300:FF:001515', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220755, NULL, 'G3DSA:3.40.850.10:FF:000018', NULL, NULL, 'unconventional myosin-VI isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(220756, NULL, 'G3DSA:3.30.160.60:FF:001152', NULL, NULL, 'Zinc finger protein 691', NULL, NULL, NULL, NULL, NULL, 4),
(220757, NULL, 'G3DSA:3.30.160.60:FF:005856', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220758, NULL, 'G3DSA:3.30.1370.10:FF:000146', NULL, NULL, 'Heterogeneous nuclear rnp K-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(220759, NULL, 'G3DSA:1.25.40.10:FF:000420', NULL, NULL, 'Pentatricopeptide repeat domain-containing protein 3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(220760, NULL, 'G3DSA:1.25.10.10:FF:002700', NULL, NULL, 'Chromosome region maintenance protein 5/exportin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(220761, NULL, 'G3DSA:3.10.20.600:FF:000001', NULL, NULL, 'NADH dehydrogenase [ubiquinone] flavoprotein 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(220762, NULL, 'G3DSA:1.25.40.180:FF:000202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220763, NULL, 'G3DSA:3.40.50.10420:FF:000038', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(220764, NULL, 'G3DSA:2.60.40.10:FF:001500', NULL, NULL, 'Titin a', NULL, NULL, NULL, NULL, NULL, 4),
(220765, NULL, 'G3DSA:3.30.750.24:FF:000004', NULL, NULL, 'Phospholipid ABC transporter-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(220766, NULL, 'G3DSA:3.40.50.300:FF:006773', NULL, NULL, 'ATPase family, AAA domain-containing 5', NULL, NULL, NULL, NULL, NULL, 4),
(220767, NULL, 'G3DSA:3.90.190.10:FF:000288', NULL, NULL, 'Dual specificity protein phosphatase CDC14A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(220768, NULL, 'G3DSA:2.30.29.30:FF:001363', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220769, NULL, 'G3DSA:2.60.40.150:FF:000683', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(220770, NULL, 'G3DSA:1.50.10.20:FF:000043', NULL, NULL, 'Thioester-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(220771, NULL, 'G3DSA:2.10.220.10:FF:000122', NULL, NULL, 'Erb-b2 receptor tyrosine kinase 3a', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(220772, NULL, 'G3DSA:2.60.40.60:FF:000958', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(220773, NULL, 'G3DSA:3.90.1150.10:FF:000352', NULL, NULL, 'DegT/DnrJ/EryC1/StrS family aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(220774, NULL, 'G3DSA:3.30.160.60:FF:001461', NULL, NULL, 'Zinc finger protein 142', NULL, NULL, NULL, NULL, NULL, 4),
(220775, NULL, 'G3DSA:3.30.230.10:FF:000322', NULL, NULL, 'Diphosphomevalonate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(220776, NULL, 'G3DSA:2.60.120.260:FF:000247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220777, NULL, 'G3DSA:3.30.200.20:FF:002263', NULL, NULL, 'G protein-coupled receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(220778, NULL, 'G3DSA:3.40.50.2300:FF:000897', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220779, NULL, 'G3DSA:3.30.9.10:FF:000224', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase, truncation', NULL, NULL, NULL, NULL, NULL, 4),
(220780, NULL, 'G3DSA:2.30.42.10:FF:000500', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220781, NULL, 'G3DSA:3.20.20.300:FF:000072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220782, NULL, 'G3DSA:3.20.20.140:FF:000456', NULL, NULL, 'Guanine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(220783, NULL, 'G3DSA:3.50.50.60:FF:000957', NULL, NULL, 'Sll1025 protein', NULL, NULL, NULL, NULL, NULL, 4),
(220784, NULL, 'G3DSA:2.40.50.140:FF:000922', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220785, NULL, 'G3DSA:3.30.420.40:FF:000784', NULL, NULL, 'Ppx/GppA phosphatase family-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(220786, NULL, 'G3DSA:1.20.1280.50:FF:000183', NULL, NULL, 'Putative F-box/LRR-repeat protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(220787, NULL, 'G3DSA:3.40.390.10:FF:000101', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(220788, NULL, 'G3DSA:3.30.60.30:FF:000034', NULL, NULL, 'Serine peptidase inhibitor, Kazal type 5', NULL, NULL, NULL, NULL, NULL, 4),
(220789, NULL, 'G3DSA:1.25.40.10:FF:003293', NULL, NULL, 'Predicted ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(220790, NULL, 'G3DSA:3.40.50.720:FF:002054', NULL, NULL, 'NAD-dependent epimerase/dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(220791, NULL, 'G3DSA:3.80.10.10:FF:003092', NULL, NULL, 'Antagonist of mitotic exit network 1', NULL, NULL, NULL, NULL, NULL, 4),
(220792, NULL, 'G3DSA:3.30.870.10:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220793, NULL, 'G3DSA:4.10.240.30:FF:000003', NULL, NULL, 'Tumor necrosis factor alpha-induced protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(220794, NULL, 'G3DSA:1.25.40.20:FF:000171', NULL, NULL, 'Ankyrin repeat and SOCS box containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(220795, NULL, 'G3DSA:3.40.1030.10:FF:000017', NULL, NULL, 'Thymidine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(220796, NULL, 'G3DSA:2.60.40.1180:FF:000045', NULL, NULL, '1,4-alpha-glucan-branching enzyme 3, chloroplastic/amyloplastic', NULL, NULL, NULL, NULL, NULL, 4),
(220797, NULL, 'G3DSA:2.30.42.10:FF:000180', NULL, NULL, 'PDZ domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(220798, NULL, 'G3DSA:2.40.30.10:FF:000079', NULL, NULL, '60S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(220799, NULL, 'G3DSA:1.10.275.10:FF:000027', NULL, NULL, 'Adenylosuccinate lyase (PurB)', NULL, NULL, NULL, NULL, NULL, 4),
(220800, NULL, 'G3DSA:3.40.50.10470:FF:000031', NULL, NULL, 'Probable translation initiation factor eIF-2B subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(220801, NULL, 'G3DSA:3.30.830.10:FF:000143', NULL, NULL, 'Metalloprotease, insulinase family', NULL, NULL, NULL, NULL, NULL, 4),
(220802, NULL, 'G3DSA:3.50.50.60:FF:000249', NULL, NULL, 'Lysine-specific histone demethylase Aof2', NULL, NULL, NULL, NULL, NULL, 4),
(220803, NULL, 'G3DSA:2.60.40.10:FF:004934', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220804, NULL, 'G3DSA:1.10.20.10:FF:000093', NULL, NULL, 'Histone H2A', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(220805, NULL, 'G3DSA:1.10.101.10:FF:000001', NULL, NULL, 'Spore cortex-lytic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(220806, NULL, 'G3DSA:2.60.120.200:FF:000600', NULL, NULL, 'Si:ch211-241e1.3', NULL, NULL, NULL, NULL, NULL, 4),
(220807, NULL, 'G3DSA:3.40.50.2300:FF:000026', NULL, NULL, 'DNA-binding response OmpR family regulator', NULL, NULL, NULL, NULL, NULL, 4),
(220808, NULL, 'G3DSA:3.30.1640.10:FF:000015', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(220809, NULL, 'G3DSA:3.50.50.60:FF:001199', NULL, NULL, 'Zeta-carotene desaturase', NULL, NULL, NULL, NULL, NULL, 4),
(220810, NULL, 'G3DSA:2.30.30.110:FF:000007', NULL, NULL, 'mRNA interferase', NULL, NULL, NULL, NULL, NULL, 4),
(220811, NULL, 'G3DSA:3.30.2090.10:FF:000001', NULL, NULL, 'Efflux pump membrane transporter', NULL, NULL, NULL, NULL, NULL, 4),
(220812, NULL, 'G3DSA:1.20.1290.10:FF:000003', NULL, NULL, 'sestrin-2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(220813, NULL, 'G3DSA:3.30.160.60:FF:004895', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220814, NULL, 'G3DSA:3.40.390.10:FF:000090', NULL, NULL, 'neprilysin', NULL, NULL, NULL, NULL, NULL, 4),
(220815, NULL, 'G3DSA:3.40.950.10:FF:000037', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220816, NULL, 'G3DSA:3.90.1150.10:FF:000133', NULL, NULL, 'Cystathionine beta-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(220817, NULL, 'G3DSA:3.30.70.270:FF:000323', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220818, NULL, 'G3DSA:3.30.160.60:FF:003861', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220819, NULL, 'G3DSA:3.30.200.20:FF:000031', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(220820, NULL, 'G3DSA:1.10.238.10:FF:000942', NULL, NULL, 'Calcium-binding EF-hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(220821, NULL, 'G3DSA:3.10.100.10:FF:000053', NULL, NULL, 'Killer cell lectin-like receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(220822, NULL, 'G3DSA:1.20.1070.10:FF:001313', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(220823, NULL, 'G3DSA:3.30.420.40:FF:000020', NULL, NULL, 'Chaperone protein HscA homolog', NULL, NULL, NULL, NULL, NULL, 4),
(220824, NULL, 'G3DSA:1.10.510.10:FF:000862', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(220825, NULL, 'G3DSA:3.30.70.600:FF:000012', NULL, NULL, 'SSU ribosomal protein S10P', NULL, NULL, NULL, NULL, NULL, 4),
(220826, NULL, 'G3DSA:3.40.50.300:FF:004300', NULL, NULL, 'Sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(220827, NULL, 'G3DSA:1.20.120.1750:FF:000138', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(220828, NULL, 'G3DSA:2.60.120.620:FF:000153', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220829, NULL, 'G3DSA:1.20.1070.10:FF:001785', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220830, NULL, 'G3DSA:1.10.486.10:FF:000017', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(220831, NULL, 'G3DSA:4.10.260.10:FF:000010', NULL, NULL, 'Ste18p', NULL, NULL, NULL, NULL, NULL, 4),
(220832, NULL, 'G3DSA:3.30.40.10:FF:002281', NULL, NULL, 'E3 ubiquitin-protein ligase CHIP', NULL, NULL, NULL, NULL, NULL, 4),
(220833, NULL, 'G3DSA:1.20.1070.10:FF:000695', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(220834, NULL, 'G3DSA:1.10.287.370:FF:000011', NULL, NULL, 'prefoldin subunit 5 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(220835, NULL, 'G3DSA:3.90.650.10:FF:000003', NULL, NULL, 'Selenide, water dikinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(220836, NULL, 'G3DSA:1.20.1730.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220837, NULL, 'G3DSA:4.10.400.10:FF:000139', NULL, NULL, 'LDL receptor related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(220838, NULL, 'G3DSA:3.30.160.60:FF:004367', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220839, NULL, 'G3DSA:3.30.479.20:FF:000065', NULL, NULL, 'Elongation factor Ts, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(220840, NULL, 'G3DSA:3.30.40.10:FF:001477', NULL, NULL, 'RING/U-box superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(220841, NULL, 'G3DSA:3.30.1480.10:FF:000008', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(220842, NULL, 'G3DSA:2.40.50.770:FF:000004', NULL, NULL, 'RecQ-mediated instability protein (DUF1767)', NULL, NULL, NULL, NULL, NULL, 4),
(220843, NULL, 'G3DSA:3.40.190.10:FF:000226', NULL, NULL, 'Peptide ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(220844, NULL, 'G3DSA:3.10.28.10:FF:000010', NULL, NULL, 'LAGLIDADG homing endonuclease I-LtrII', NULL, NULL, NULL, NULL, NULL, 4),
(220845, NULL, 'G3DSA:1.10.560.10:FF:000123', NULL, NULL, '60 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(220846, NULL, 'G3DSA:4.10.60.10:FF:000263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220847, NULL, 'G3DSA:3.30.70.1230:FF:000168', NULL, NULL, 'Adenylate cyclase, terminal-differentiation specific', NULL, NULL, NULL, NULL, NULL, 4),
(220848, NULL, 'G3DSA:1.10.3180.10:FF:000003', NULL, NULL, 'Ethylene insensitive 3 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(220849, NULL, 'G3DSA:1.10.472.80:FF:000057', NULL, NULL, 'GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(220850, NULL, 'G3DSA:3.20.20.70:FF:000690', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220851, NULL, 'G3DSA:3.10.20.90:FF:000073', NULL, NULL, 'Polycomb group RING finger protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(220852, NULL, 'G3DSA:3.40.50.11060:FF:000011', NULL, NULL, 'HflX family GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(220853, NULL, 'G3DSA:3.40.50.1480:FF:000021', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220854, NULL, 'G3DSA:3.10.50.40:FF:000144', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(220855, NULL, 'G3DSA:3.10.330.20:FF:000011', NULL, NULL, 'tRNA methyltransferase complex GCD14 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(220856, NULL, 'G3DSA:1.10.10.60:FF:000832', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220857, NULL, 'G3DSA:1.10.510.10:FF:000659', NULL, NULL, 'Receptor protein serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(220858, NULL, 'G3DSA:3.60.20.10:FF:000030', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(220859, NULL, 'G3DSA:1.25.40.10:FF:002904', NULL, NULL, 'Tetratricopeptide repeat protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(220860, NULL, 'G3DSA:2.60.40.10:FF:002118', NULL, NULL, 'Neural cell adhesion molecule 3', NULL, NULL, NULL, NULL, NULL, 4),
(220861, NULL, 'G3DSA:2.60.260.20:FF:000094', NULL, NULL, 'Chaperone protein DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(220862, NULL, 'G3DSA:2.10.25.10:FF:001422', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220863, NULL, 'G3DSA:3.40.190.10:FF:000754', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(220864, NULL, 'G3DSA:3.40.50.1820:FF:001242', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(220865, NULL, 'G3DSA:4.10.530.10:FF:000003', NULL, NULL, 'Ficolin 3', NULL, NULL, NULL, NULL, NULL, 4),
(220866, NULL, 'G3DSA:3.40.50.970:FF:000201', NULL, NULL, 'Probable 2-ketoarginine decarboxylase AruI', NULL, NULL, NULL, NULL, NULL, 4),
(220867, NULL, 'G3DSA:2.70.150.10:FF:000030', NULL, NULL, 'Plasma membrane ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(220868, NULL, 'G3DSA:1.20.1260.100:FF:000006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220869, NULL, 'G3DSA:3.30.160.60:FF:004822', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220870, NULL, 'G3DSA:3.30.70.100:FF:000115', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220871, NULL, 'G3DSA:3.90.660.10:FF:000032', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(220872, NULL, 'G3DSA:3.30.160.60:FF:000533', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(220873, NULL, 'G3DSA:1.10.287.4070:FF:000015', NULL, NULL, 'Putative nucleolar protein 5-1', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(220874, NULL, 'G3DSA:3.90.550.10:FF:000512', NULL, NULL, 'UDP-glucose:glycoprotein glucosyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(220875, NULL, 'G3DSA:2.60.40.10:FF:000320', NULL, NULL, 'Plexin A1', NULL, NULL, NULL, NULL, NULL, 4),
(220876, NULL, 'G3DSA:3.40.630.10:FF:000345', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220877, NULL, 'G3DSA:2.170.150.80:FF:000026', NULL, NULL, 'NAC domain containing protein 49', NULL, NULL, NULL, NULL, NULL, 4),
(220878, NULL, 'G3DSA:3.40.50.720:FF:000828', NULL, NULL, 'Nedd8-activating enzyme E1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(220879, NULL, 'G3DSA:1.20.1310.10:FF:000175', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220880, NULL, 'G3DSA:1.20.1560.10:FF:000923', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220881, NULL, 'G3DSA:1.10.10.10:FF:002065', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(220882, NULL, 'G3DSA:3.40.50.720:FF:001104', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(220883, NULL, 'G3DSA:4.10.800.20:FF:000004', NULL, NULL, 'Probable amp deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(220884, NULL, 'G3DSA:2.60.40.1120:FF:000033', NULL, NULL, 'Rhamnogalacturonate lyase B', NULL, NULL, NULL, NULL, NULL, 4),
(220885, NULL, 'G3DSA:1.20.58.340:FF:000052', NULL, NULL, 'Mg2 transporter protein CorA family protein', NULL, NULL, NULL, NULL, NULL, 4),
(220886, NULL, 'G3DSA:3.40.50.150:FF:001669', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220887, NULL, 'G3DSA:1.20.58.1100:FF:000019', NULL, NULL, 'protein unc-13 homolog B-like', NULL, NULL, NULL, NULL, NULL, 4),
(220888, NULL, 'G3DSA:2.30.30.550:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220889, NULL, 'G3DSA:4.10.280.10:FF:000152', NULL, NULL, 'Nuclear pore complex protein NUP155', NULL, NULL, NULL, NULL, NULL, 4),
(220890, NULL, 'G3DSA:3.40.1190.20:FF:000094', NULL, NULL, 'ADP-dependent (S)-NAD(P)H-hydrate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(220891, NULL, 'G3DSA:1.10.472.10:FF:000441', NULL, NULL, 'Transcription initiation factor IIB', NULL, NULL, NULL, NULL, NULL, 4),
(220892, NULL, 'G3DSA:2.120.10.80:FF:000021', NULL, NULL, 'kelch-like protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(220893, NULL, 'G3DSA:2.30.30.40:FF:000268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220894, NULL, 'G3DSA:1.10.238.10:FF:001015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220895, NULL, 'G3DSA:1.10.287.1490:FF:000016', NULL, NULL, 'Coiled-coil domain containing 68', NULL, NULL, NULL, NULL, NULL, 4),
(220896, NULL, 'G3DSA:3.30.70.240:FF:000016', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(220897, NULL, 'G3DSA:1.10.287.70:FF:000466', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220898, NULL, 'G3DSA:2.60.40.60:FF:000273', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220899, NULL, 'G3DSA:1.10.3210.10:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220900, NULL, 'G3DSA:3.40.50.2030:FF:000001', NULL, NULL, 'Hydroxylamine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(220901, NULL, 'G3DSA:1.10.10.2360:FF:000001', NULL, NULL, 'Nuclear pore complex protein Nup98-Nup96', NULL, NULL, NULL, NULL, NULL, 4),
(220902, NULL, 'G3DSA:3.30.710.10:FF:000016', NULL, NULL, 'Transcription elongation factor', NULL, NULL, NULL, NULL, NULL, 4),
(220903, NULL, 'G3DSA:1.10.10.440:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220904, NULL, 'G3DSA:2.60.40.60:FF:000088', NULL, NULL, 'protocadherin-19 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(220905, NULL, 'G3DSA:1.20.58.390:FF:000151', NULL, NULL, 'AcetylCholine Receptor', NULL, NULL, NULL, NULL, NULL, 4),
(220906, NULL, 'G3DSA:1.10.1200.10:FF:000152', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220907, NULL, 'G3DSA:3.60.110.10:FF:000099', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(220908, NULL, 'G3DSA:3.20.20.210:FF:000028', NULL, NULL, 'Uroporphyrinogen decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(220909, NULL, 'G3DSA:2.30.39.10:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220910, NULL, 'G3DSA:3.90.1110.10:FF:000012', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(220911, NULL, 'G3DSA:3.90.1170.50:FF:000005', NULL, NULL, 'Xanthine dehydrogenase yagR molybdenum-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(220912, NULL, 'G3DSA:3.40.50.2000:FF:000711', NULL, NULL, 'Glycosyl transferase group 1', NULL, NULL, NULL, NULL, NULL, 4),
(220913, NULL, 'G3DSA:2.60.40.10:FF:003501', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220914, NULL, 'G3DSA:1.10.340.70:FF:000006', NULL, NULL, 'Retrovirus-related Pol polyprotein from transposon 297-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(220915, NULL, 'G3DSA:3.20.20.30:FF:000009', NULL, NULL, 'Luciferase-like monooxygenase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(220916, NULL, 'G3DSA:3.40.50.1820:FF:000281', NULL, NULL, 'LIPaSe related', NULL, NULL, NULL, NULL, NULL, 4),
(220917, NULL, 'G3DSA:2.130.10.10:FF:003625', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220918, NULL, 'G3DSA:3.90.79.20:FF:000015', NULL, NULL, 'NADH pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(220919, NULL, 'G3DSA:3.40.50.2000:FF:000003', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(220920, NULL, 'G3DSA:1.20.1250.20:FF:002140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220921, NULL, 'G3DSA:3.10.450.10:FF:000040', NULL, NULL, 'Protein CBR-TAG-196', NULL, NULL, NULL, NULL, NULL, 4),
(220922, NULL, 'G3DSA:3.10.50.10:FF:000040', NULL, NULL, 'AGAP007182-PA', NULL, NULL, NULL, NULL, NULL, 4),
(220923, NULL, 'G3DSA:3.40.47.10:FF:000109', NULL, NULL, '2-heptyl-4(1H)-quinolone synthase subunit PqsB', NULL, NULL, NULL, NULL, NULL, 4),
(220924, NULL, 'G3DSA:3.40.630.30:FF:000356', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(220925, NULL, 'G3DSA:1.10.8.10:FF:000299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220926, NULL, 'G3DSA:2.10.25.10:FF:000950', NULL, NULL, 'Protein Z, vitamin K-dependent plasma glycoprotein a', NULL, NULL, NULL, NULL, NULL, 4),
(220927, NULL, 'G3DSA:3.40.50.300:FF:000225', NULL, NULL, 'Thymidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(220928, NULL, 'G3DSA:3.30.1370.10:FF:000017', NULL, NULL, 'Fragile X mental retardation syndrome-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(220929, NULL, 'G3DSA:2.40.50.140:FF:001086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220930, NULL, 'G3DSA:1.10.10.250:FF:000008', NULL, NULL, '39S ribosomal protein L11, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(220931, NULL, 'G3DSA:2.60.210.10:FF:000026', NULL, NULL, 'Protein maternal effect lethal 26', NULL, NULL, NULL, NULL, NULL, 4),
(220932, NULL, 'G3DSA:1.10.287.90:FF:000005', NULL, NULL, 'Quinol oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(220933, NULL, 'G3DSA:3.40.50.880:FF:000016', NULL, NULL, 'Carbamoyl-phosphate synthase arginine-specific small chain', NULL, NULL, NULL, NULL, NULL, 4),
(220934, NULL, 'G3DSA:3.10.20.90:FF:000325', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(220935, NULL, 'G3DSA:1.20.1250.20:FF:001431', NULL, NULL, 'Peptide transporter family 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(220936, NULL, 'G3DSA:3.40.50.2020:FF:000009', NULL, NULL, 'Xanthine phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(220937, NULL, 'G3DSA:3.30.70.330:FF:001999', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220938, NULL, 'G3DSA:1.25.10.10:FF:001211', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(220939, NULL, 'G3DSA:1.10.287.3510:FF:000010', NULL, NULL, 'NADH:ubiquinone oxidoreductase subunit 4L', NULL, NULL, NULL, NULL, NULL, 4),
(220940, NULL, 'G3DSA:2.30.36.70:FF:000003', NULL, NULL, 'Actin-related protein 6', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(220941, NULL, 'G3DSA:1.25.10.10:FF:003465', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220942, NULL, 'G3DSA:3.30.70.330:FF:002617', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220943, NULL, 'G3DSA:2.60.40.790:FF:000167', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220944, NULL, 'G3DSA:2.40.50.140:FF:000158', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(220945, NULL, 'G3DSA:3.40.1380.10:FF:000026', NULL, NULL, 'ATP synthase gamma chain 1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(220946, NULL, 'G3DSA:1.25.40.20:FF:000985', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(220947, NULL, 'G3DSA:2.130.10.10:FF:000843', NULL, NULL, 'WD repeat-containing protein 3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(220948, NULL, 'G3DSA:2.60.40.10:FF:003754', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220949, NULL, 'G3DSA:2.40.70.10:FF:000547', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220950, NULL, 'G3DSA:3.30.40.10:FF:001662', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220951, NULL, 'G3DSA:1.20.5.1700:FF:000003', NULL, NULL, 'Homer homolog 1 (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(220952, NULL, 'G3DSA:2.10.25.10:FF:001203', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(220953, NULL, 'G3DSA:3.90.550.50:FF:000148', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(220954, NULL, 'G3DSA:3.40.50.10190:FF:000267', NULL, NULL, 'DNA topoisomerase II binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(220955, NULL, 'G3DSA:3.40.50.1110:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220956, NULL, 'G3DSA:3.90.226.10:FF:000113', NULL, NULL, 'Enoyl-CoA hydratase/isomerase family protein (AFU_orthologue AFUA_2G14850)', NULL, NULL, NULL, NULL, NULL, 4),
(220957, NULL, 'G3DSA:3.30.110.60:FF:000002', NULL, NULL, 'CRS2-associated factor 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(220958, NULL, 'G3DSA:1.10.3720.10:FF:000175', NULL, NULL, 'Opine/polyamine ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(220959, NULL, 'G3DSA:3.80.10.10:FF:001304', NULL, NULL, 'EIN3-binding F-box domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(220960, NULL, 'G3DSA:3.90.70.10:FF:000363', NULL, NULL, 'Apoptosis inhibitory protein', NULL, NULL, NULL, NULL, NULL, 4),
(220961, NULL, 'G3DSA:1.25.40.10:FF:004782', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220962, NULL, 'G3DSA:1.25.10.10:FF:000806', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220963, NULL, 'G3DSA:3.30.70.330:FF:002308', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220964, NULL, 'G3DSA:3.40.30.10:FF:000458', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(220965, NULL, 'G3DSA:2.60.120.310:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220966, NULL, 'G3DSA:3.90.640.10:FF:000177', NULL, NULL, 'actin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(220967, NULL, 'G3DSA:2.110.10.10:FF:000029', NULL, NULL, 'Matrix metallopeptidase 28', NULL, NULL, NULL, NULL, NULL, 4),
(220968, NULL, 'G3DSA:3.40.1160.10:FF:000010', NULL, NULL, 'Delta-1-pyrroline-5-carboxylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(220969, NULL, 'G3DSA:3.10.450.580:FF:000012', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(220970, NULL, 'G3DSA:3.40.50.2300:FF:000211', NULL, NULL, 'Glutamate receptor ionotropic, NMDA 2B', NULL, NULL, NULL, NULL, NULL, 4),
(220971, NULL, 'G3DSA:3.40.50.880:FF:000163', NULL, NULL, 'CPSase', NULL, NULL, NULL, NULL, NULL, 4),
(220972, NULL, 'G3DSA:1.25.40.20:FF:000277', NULL, NULL, 'Ankyrin repeat domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(220973, NULL, 'G3DSA:3.30.200.20:FF:000340', NULL, NULL, 'Calmodulin-binding receptor-like cytoplasmic kinase 3', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(220974, NULL, 'G3DSA:3.10.20.90:FF:000634', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220975, NULL, 'G3DSA:3.40.50.2000:FF:000150', NULL, NULL, 'Trehalose-6-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(220976, NULL, 'G3DSA:3.30.1370.50:FF:000023', NULL, NULL, 'NFKB-repressing factor', NULL, NULL, NULL, NULL, NULL, 4),
(220977, NULL, 'G3DSA:3.40.630.30:FF:000665', NULL, NULL, 'Putative acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(220978, NULL, 'G3DSA:1.10.287.70:FF:000090', NULL, NULL, 'two pore potassium channel protein sup-9', NULL, NULL, NULL, NULL, NULL, 4),
(220979, NULL, 'G3DSA:3.40.1090.10:FF:000049', NULL, NULL, 'Patatin-like phospholipase domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(220980, NULL, 'G3DSA:1.10.40.30:FF:000010', NULL, NULL, 'Adenylosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(220981, NULL, 'G3DSA:2.60.120.1020:FF:000003', NULL, NULL, 'PAW domain-containing protein Y50D4B.3', NULL, NULL, NULL, NULL, NULL, 4),
(220982, NULL, 'G3DSA:1.10.20.10:FF:000363', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220983, NULL, 'G3DSA:3.40.50.300:FF:000933', NULL, NULL, 'ABC transporter A family member 7', NULL, NULL, NULL, NULL, NULL, 4),
(220984, NULL, 'G3DSA:3.40.50.300:FF:003659', NULL, NULL, 'GM21754', NULL, NULL, NULL, NULL, NULL, 4),
(220985, NULL, 'G3DSA:1.20.1250.20:FF:001212', NULL, NULL, 'DUF895 domain membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(220986, NULL, 'G3DSA:1.10.30.10:FF:000189', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(220987, NULL, 'G3DSA:3.10.250.10:FF:000075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220988, NULL, 'G3DSA:1.20.920.10:FF:000188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(220989, NULL, 'G3DSA:2.10.50.10:FF:000019', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 11A', NULL, NULL, NULL, NULL, NULL, 4),
(220990, NULL, 'G3DSA:1.25.40.10:FF:001724', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(220991, NULL, 'G3DSA:2.60.120.330:FF:000038', NULL, NULL, 'Si:dkey-10o6.2', NULL, NULL, NULL, NULL, NULL, 4),
(220992, NULL, 'G3DSA:1.25.40.20:FF:001261', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(220993, NULL, 'G3DSA:3.30.70.1440:FF:000006', NULL, NULL, 'Transporter, AcrB/D/F family', NULL, NULL, NULL, NULL, NULL, 4),
(220994, NULL, 'G3DSA:3.30.200.20:FF:000716', NULL, NULL, 'Mitogen-activated protein kinase kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(220995, NULL, 'G3DSA:3.30.70.330:FF:002983', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(220996, NULL, 'G3DSA:1.10.533.10:FF:000009', NULL, NULL, 'tumor necrosis factor receptor superfamily member 21', NULL, NULL, NULL, NULL, NULL, 4),
(220997, NULL, 'G3DSA:3.80.10.10:FF:000686', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase GHR1', NULL, NULL, NULL, NULL, NULL, 4),
(220998, NULL, 'G3DSA:3.30.40.10:FF:001353', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(220999, NULL, 'G3DSA:1.25.40.10:FF:000179', NULL, NULL, 'Mitochondrial fission 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(221000, NULL, 'G3DSA:3.30.420.10:FF:000477', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221001, NULL, 'G3DSA:3.40.50.1820:FF:001618', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221002, NULL, 'G3DSA:2.60.40.10:FF:002793', NULL, NULL, 'Ig-like and fibronectin type-III domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(221003, NULL, 'G3DSA:2.60.120.1040:FF:000009', NULL, NULL, 'Zinc finger protein zpr1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221004, NULL, 'G3DSA:3.40.50.1820:FF:001803', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221005, NULL, 'G3DSA:1.20.5.100:FF:000031', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(221006, NULL, 'G3DSA:3.90.79.10:FF:000046', NULL, NULL, 'Nudix/MutT family protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(221007, NULL, 'G3DSA:3.80.10.10:FF:000579', NULL, NULL, 'Protein phosphatase 1 regulatory subunit 7', NULL, NULL, NULL, NULL, NULL, 4),
(221008, NULL, 'G3DSA:2.40.40.20:FF:000026', NULL, NULL, 'Transitional endoplasmic reticulum ATPase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(221009, NULL, 'G3DSA:1.10.730.10:FF:000182', NULL, NULL, 'Leucyl Amino-acyl tRNA Synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(221010, NULL, 'G3DSA:2.10.25.10:FF:001782', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221011, NULL, 'G3DSA:3.30.70.890:FF:000065', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221012, NULL, 'G3DSA:1.25.10.10:FF:002515', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221013, NULL, 'G3DSA:3.10.400.20:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221014, NULL, 'G3DSA:3.10.20.90:FF:000769', NULL, NULL, 'Inhibitor of nuclear factor kappa B kinase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(221015, NULL, 'G3DSA:3.40.1450.10:FF:000004', NULL, NULL, '23-bisphosphoglycerate-independent phosphoglycerate mutase 1', NULL, NULL, NULL, NULL, NULL, 4),
(221016, NULL, 'G3DSA:1.20.120.1080:FF:000145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221017, NULL, 'G3DSA:2.60.40.60:FF:000981', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221018, NULL, 'G3DSA:2.130.10.10:FF:004783', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221019, NULL, 'G3DSA:3.30.565.10:FF:000515', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221020, NULL, 'G3DSA:2.130.10.10:FF:000612', NULL, NULL, 'SEC12-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(221021, NULL, 'G3DSA:1.10.238.270:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221022, NULL, 'G3DSA:1.10.30.10:FF:000161', NULL, NULL, 'HMG box-containing protein C28F2.11', NULL, NULL, NULL, NULL, NULL, 4),
(221023, NULL, 'G3DSA:1.10.510.10:FF:002099', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221024, NULL, 'G3DSA:3.90.550.10:FF:000743', NULL, NULL, 'UTP--glucose-1-phosphate uridylyltransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(221025, NULL, 'G3DSA:1.20.1250.20:FF:002151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221026, NULL, 'G3DSA:3.30.200.20:FF:001195', NULL, NULL, 'Calcium-dependent protein kinase 13', NULL, NULL, NULL, NULL, NULL, 4),
(221027, NULL, 'G3DSA:3.40.50.300:FF:006306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221028, NULL, 'G3DSA:2.60.15.10:FF:000003', NULL, NULL, 'ATP synthase subunit delta, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(221029, NULL, 'G3DSA:1.10.20.10:FF:000233', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221030, NULL, 'G3DSA:2.40.180.10:FF:000004', NULL, NULL, 'Lipoxygenase homology domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(221031, NULL, 'G3DSA:2.30.29.30:FF:001380', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221032, NULL, 'G3DSA:2.30.29.30:FF:000874', NULL, NULL, 'Nuclear pore complex protein Nup50', NULL, NULL, NULL, NULL, NULL, 4),
(221033, NULL, 'G3DSA:1.10.287.3550:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221034, NULL, 'G3DSA:1.25.40.10:FF:005086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221035, NULL, 'G3DSA:3.40.1090.10:FF:000021', NULL, NULL, 'Patatin-like phospholipase domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(221036, NULL, 'G3DSA:2.60.120.620:FF:000041', NULL, NULL, 'prolyl 4-hydroxylase subunit alpha-2 isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(221037, NULL, 'G3DSA:3.40.640.10:FF:000407', NULL, NULL, 'Aminotransferase, class V', NULL, NULL, NULL, NULL, NULL, 4),
(221038, NULL, 'G3DSA:1.20.1250.20:FF:000594', NULL, NULL, 'MFS alpha-glucoside transporter', NULL, NULL, NULL, NULL, NULL, 4),
(221039, NULL, 'G3DSA:1.10.472.10:FF:000547', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(221040, NULL, 'G3DSA:1.10.287.70:FF:000685', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221041, NULL, 'G3DSA:3.30.9.10:FF:000084', NULL, NULL, 'FAD dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(221042, NULL, 'G3DSA:2.30.30.140:FF:000325', NULL, NULL, 'PHD finger protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(221043, NULL, 'G3DSA:1.20.144.10:FF:000019', NULL, NULL, 'Lipid A 1-diphosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(221044, NULL, 'G3DSA:2.60.40.1170:FF:000031', NULL, NULL, 'Coatomer subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(221045, NULL, 'G3DSA:3.40.50.460:FF:000020', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(221046, NULL, 'G3DSA:1.20.5.340:FF:000069', NULL, NULL, 'Rho-associated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(221047, NULL, 'G3DSA:3.40.50.300:FF:001523', NULL, NULL, 'Helicase (DNA) B', NULL, NULL, NULL, NULL, NULL, 4),
(221048, NULL, 'G3DSA:3.90.550.50:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221049, NULL, 'G3DSA:3.40.50.300:FF:005789', NULL, NULL, 'Dynein heavy chain 5, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(221050, NULL, 'G3DSA:3.30.559.10:FF:000102', NULL, NULL, 'Nonribosomal peptide synthetase 8', NULL, NULL, NULL, NULL, NULL, 4),
(221051, NULL, 'G3DSA:2.40.160.20:FF:000012', NULL, NULL, 'Outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(221052, NULL, 'G3DSA:3.30.1150.10:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221053, NULL, 'G3DSA:3.40.50.2300:FF:001419', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221054, NULL, 'G3DSA:3.40.1850.10:FF:000001', NULL, NULL, 'SPI-1 type III secretion system effector HECT-type E3 ubiquitin transferase SopA', NULL, NULL, NULL, NULL, NULL, 4),
(221055, NULL, 'G3DSA:3.60.40.10:FF:000149', NULL, NULL, 'Protein phosphatase 2C 29', NULL, NULL, NULL, NULL, NULL, 4),
(221056, NULL, 'G3DSA:2.40.10.10:FF:000521', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221057, NULL, 'G3DSA:3.80.10.10:FF:001198', NULL, NULL, 'Leucine Rich Repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(221058, NULL, 'G3DSA:2.60.210.10:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221059, NULL, 'G3DSA:3.30.420.390:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221060, NULL, 'G3DSA:3.50.4.10:FF:000011', NULL, NULL, 'Plasminogen', NULL, NULL, NULL, NULL, NULL, 4),
(221061, NULL, 'G3DSA:1.20.920.10:FF:000183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221062, NULL, 'G3DSA:3.30.160.60:FF:000393', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(221063, NULL, 'G3DSA:3.30.420.10:FF:000472', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221064, NULL, 'G3DSA:2.70.170.10:FF:000143', NULL, NULL, 'Gamma-aminobutyric-acid receptor subunit beta-1', NULL, NULL, NULL, NULL, NULL, 4),
(221065, NULL, 'G3DSA:3.40.50.300:FF:002951', NULL, NULL, 'Putative ras-like small GTPases', NULL, NULL, NULL, NULL, NULL, 4),
(221066, NULL, 'G3DSA:3.30.230.10:FF:000075', NULL, NULL, 'DNA topoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(221067, NULL, 'G3DSA:3.30.70.1400:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221068, NULL, 'G3DSA:3.40.50.2300:FF:000009', NULL, NULL, 'Glutamate receptor, metabotropic 4', NULL, NULL, NULL, NULL, NULL, 4),
(221069, NULL, 'G3DSA:3.90.950.10:FF:000043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221070, NULL, 'G3DSA:3.30.200.20:FF:000576', NULL, NULL, 'CBN-SEK-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(221071, NULL, 'G3DSA:2.130.10.10:FF:005300', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221072, NULL, 'G3DSA:1.10.630.10:FF:000230', NULL, NULL, 'Cytochrome P450', NULL, NULL, NULL, NULL, NULL, 4),
(221073, NULL, 'G3DSA:1.10.10.60:FF:000489', NULL, NULL, 'Fis family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(221074, NULL, 'G3DSA:1.10.287.380:FF:000031', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(221075, NULL, 'G3DSA:3.30.160.60:FF:005968', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221076, NULL, 'G3DSA:2.130.10.10:FF:003838', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit TRM82', NULL, NULL, NULL, NULL, NULL, 4),
(221077, NULL, 'G3DSA:3.40.50.720:FF:001076', NULL, NULL, 'Paratose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(221078, NULL, 'G3DSA:1.20.1070.10:FF:001105', NULL, NULL, 'Novel protein similar to vertebrate prostaglandin E receptor 2 (Subtype EP2), 53kDa (PTGER2)', NULL, NULL, NULL, NULL, NULL, 4),
(221079, NULL, 'G3DSA:2.40.50.100:FF:000141', NULL, NULL, 'Sugar ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(221080, NULL, 'G3DSA:3.30.40.10:FF:001561', NULL, NULL, 'Ubiquitin-protein ligase peroxin 2', NULL, NULL, NULL, NULL, NULL, 4),
(221081, NULL, 'G3DSA:2.60.120.260:FF:000011', NULL, NULL, 'E3 ubiquitin-protein ligase MYCBP2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(221082, NULL, 'G3DSA:3.40.50.300:FF:005368', NULL, NULL, 'Atlastin-1', NULL, NULL, NULL, NULL, NULL, 4),
(221083, NULL, 'G3DSA:1.10.1670.10:FF:000063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221084, NULL, 'G3DSA:1.25.40.10:FF:002343', NULL, NULL, 'GM12896', NULL, NULL, NULL, NULL, NULL, 4),
(221085, NULL, 'G3DSA:3.10.450.10:FF:000051', NULL, NULL, 'Cystatin cpi-1', NULL, NULL, NULL, NULL, NULL, 4),
(221086, NULL, 'G3DSA:1.10.10.2660:FF:000001', NULL, NULL, 'Ubiquitin-activating enzyme E1 1', NULL, NULL, NULL, NULL, NULL, 4),
(221087, NULL, 'G3DSA:1.10.472.130:FF:000002', NULL, NULL, 'Cytoplasmic dynein heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(221088, NULL, 'G3DSA:1.20.900.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221089, NULL, 'G3DSA:3.30.450.20:FF:000510', NULL, NULL, 'Probable response regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(221090, NULL, 'G3DSA:1.10.275.10:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221091, NULL, 'G3DSA:1.20.58.1000:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221092, NULL, 'G3DSA:3.30.160.60:FF:002321', NULL, NULL, 'Putative transcriptional repressor ctcf', NULL, NULL, NULL, NULL, NULL, 4),
(221093, NULL, 'G3DSA:3.10.100.10:FF:000183', NULL, NULL, 'C type lectin receptor A', NULL, NULL, NULL, NULL, NULL, 4),
(221094, NULL, 'G3DSA:3.30.70.330:FF:001443', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221095, NULL, 'G3DSA:1.20.58.160:FF:000003', NULL, NULL, 'VHS domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(221096, NULL, 'G3DSA:1.10.287.70:FF:000213', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha-1S', NULL, NULL, NULL, NULL, NULL, 4),
(221097, NULL, 'G3DSA:1.20.950.20:FF:000007', NULL, NULL, 'Formate dehydrogenase, gamma subunit', NULL, NULL, NULL, NULL, NULL, 4),
(221098, NULL, 'G3DSA:3.40.30.10:FF:001190', NULL, NULL, 'Thioredoxin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(221099, NULL, 'G3DSA:1.10.418.10:FF:000147', NULL, NULL, 'EB1', NULL, NULL, NULL, NULL, NULL, 4),
(221100, NULL, 'G3DSA:3.30.160.60:FF:004928', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221101, NULL, 'G3DSA:3.90.70.10:FF:000835', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221102, NULL, 'G3DSA:2.60.40.10:FF:001253', NULL, NULL, 'T-cell surface glycoprotein CD4', NULL, NULL, NULL, NULL, NULL, 4),
(221103, NULL, 'G3DSA:2.60.40.10:FF:002681', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221104, NULL, 'G3DSA:3.70.10.10:FF:000091', NULL, NULL, 'DNA repair protein rad9', NULL, NULL, NULL, NULL, NULL, 4),
(221105, NULL, 'G3DSA:3.30.70.1020:FF:000010', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(221106, NULL, 'G3DSA:3.30.70.360:FF:000030', NULL, NULL, 'Probable hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(221107, NULL, 'G3DSA:2.30.30.100:FF:000100', NULL, NULL, 'Small nuclear ribonucleoprotein D1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(221108, NULL, 'G3DSA:3.40.50.980:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221109, NULL, 'G3DSA:3.40.50.2300:FF:000110', NULL, NULL, 'Argonaute 10', NULL, NULL, NULL, NULL, NULL, 4),
(221110, NULL, 'G3DSA:3.40.50.300:FF:000697', NULL, NULL, 'DnaJ homolog subfamily C member 27', NULL, NULL, NULL, NULL, NULL, 4),
(221111, NULL, 'G3DSA:2.10.90.10:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221112, NULL, 'G3DSA:3.30.160.60:FF:000876', NULL, NULL, 'Zinc finger protein 335', NULL, NULL, NULL, NULL, NULL, 4),
(221113, NULL, 'G3DSA:1.25.40.20:FF:001244', NULL, NULL, 'Ankyrin repeat-containing protein BDA1', NULL, NULL, NULL, NULL, NULL, 4),
(221114, NULL, 'G3DSA:1.10.720.40:FF:000004', NULL, NULL, 'Ankyrin repeat and LEM domain-containing protein 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(221115, NULL, 'G3DSA:3.40.50.1100:FF:000082', NULL, NULL, 'Cysteine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(221116, NULL, 'G3DSA:3.30.60.300:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221117, NULL, 'G3DSA:3.40.50.1000:FF:000518', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221118, NULL, 'G3DSA:3.40.50.1820:FF:001253', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(221119, NULL, 'G3DSA:1.25.10.70:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221120, NULL, 'G3DSA:2.30.30.40:FF:000037', NULL, NULL, 'Rho guanine nucleotide exchange factor 9', NULL, NULL, NULL, NULL, NULL, 4),
(221121, NULL, 'G3DSA:3.10.50.40:FF:000155', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(221122, NULL, 'G3DSA:1.10.10.10:FF:000418', NULL, NULL, 'BlaI/MecI/CopY family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(221123, NULL, 'G3DSA:1.20.1160.11:FF:000012', NULL, NULL, 'Paired amphipathic helix protein Sin3-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(221124, NULL, 'G3DSA:2.40.100.10:FF:000146', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(221125, NULL, 'G3DSA:3.30.420.80:FF:000009', NULL, NULL, '50S ribosomal protein L18', NULL, NULL, NULL, NULL, NULL, 4),
(221126, NULL, 'G3DSA:1.25.40.240:FF:000001', NULL, NULL, 'X-ray repair cross-complementing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(221127, NULL, 'G3DSA:2.40.50.140:FF:000580', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(221128, NULL, 'G3DSA:3.40.190.10:FF:000546', NULL, NULL, 'Osmoprotection protein (ProWX)', NULL, NULL, NULL, NULL, NULL, 4),
(221129, NULL, 'G3DSA:3.40.50.1820:FF:001141', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(221130, NULL, 'G3DSA:3.80.10.10:FF:004053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221131, NULL, 'G3DSA:3.80.10.10:FF:003434', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221132, NULL, 'G3DSA:3.30.160.60:FF:000764', NULL, NULL, 'Zinc finger protein 335', NULL, NULL, NULL, NULL, NULL, 4),
(221133, NULL, 'G3DSA:1.25.40.10:FF:001707', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g11290, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(221134, NULL, 'G3DSA:3.90.1330.10:FF:000001', NULL, NULL, 'Xylan alpha-1,2-glucuronidase', NULL, NULL, NULL, NULL, NULL, 4),
(221135, NULL, 'G3DSA:3.40.140.10:FF:000043', NULL, NULL, 'ComE operon protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(221136, NULL, 'G3DSA:1.25.40.20:FF:001132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221137, NULL, 'G3DSA:3.40.850.10:FF:000333', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(221138, NULL, 'G3DSA:3.50.30.30:FF:000048', NULL, NULL, 'Tre2p', NULL, NULL, NULL, NULL, NULL, 4),
(221139, NULL, 'G3DSA:1.25.10.10:FF:000475', NULL, NULL, 'Unplaced genomic scaffold supercont1.2, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(221140, NULL, 'G3DSA:2.40.30.10:FF:000421', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(221141, NULL, 'G3DSA:3.20.20.120:FF:000001', NULL, NULL, 'Enolase', NULL, NULL, NULL, NULL, NULL, 4),
(221142, NULL, 'G3DSA:3.50.50.60:FF:000721', NULL, NULL, 'Mercuric reductase', NULL, NULL, NULL, NULL, NULL, 4),
(221143, NULL, 'G3DSA:3.40.50.1820:FF:000522', NULL, NULL, 'Alpha/beta fold hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(221144, NULL, 'G3DSA:3.80.10.10:FF:003013', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221145, NULL, 'G3DSA:3.30.70.2820:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221146, NULL, 'G3DSA:2.60.40.10:FF:002776', NULL, NULL, 'Protein tyrosine phosphatase, receptor type, s, a', NULL, NULL, NULL, NULL, NULL, 4),
(221147, NULL, 'G3DSA:3.60.15.10:FF:000265', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(221148, NULL, 'G3DSA:3.80.10.10:FF:003564', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221149, NULL, 'G3DSA:3.30.420.60:FF:000003', NULL, NULL, 'Peptide chain release factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(221150, NULL, 'G3DSA:3.90.120.10:FF:000014', NULL, NULL, 'tRNA (cytosine(38)-C(5))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(221151, NULL, 'G3DSA:3.30.1330.20:FF:000012', NULL, NULL, 'Cell division protein FtsZ 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(221152, NULL, 'G3DSA:3.90.70.10:FF:000498', NULL, NULL, 'AEL242Wp', NULL, NULL, NULL, NULL, NULL, 4),
(221153, NULL, 'G3DSA:1.10.1410.10:FF:000055', NULL, NULL, 'PAP associated domain containing 5 (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(221154, NULL, 'G3DSA:3.30.420.40:FF:000705', NULL, NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(221155, NULL, 'G3DSA:1.10.287.3990:FF:000002', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(221156, NULL, 'G3DSA:1.20.120.350:FF:000273', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221157, NULL, 'G3DSA:3.30.900.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221158, NULL, 'G3DSA:3.40.50.720:FF:001868', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(221159, NULL, 'G3DSA:1.25.10.10:FF:002936', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221160, NULL, 'G3DSA:1.10.10.60:FF:000601', NULL, NULL, 'Repressor activator protein', NULL, NULL, NULL, NULL, NULL, 4),
(221161, NULL, 'G3DSA:1.20.1070.10:FF:000700', NULL, NULL, 'GPCR class b orphan receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(221162, NULL, 'G3DSA:2.10.110.10:FF:000007', NULL, NULL, 'actin-binding LIM protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(221163, NULL, 'G3DSA:3.30.460.30:FF:000002', NULL, NULL, 'Glutamyl-tRNA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(221164, NULL, 'G3DSA:1.25.40.10:FF:004681', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221165, NULL, 'G3DSA:3.40.47.10:FF:000238', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221166, NULL, 'G3DSA:3.30.160.60:FF:006492', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221167, NULL, 'G3DSA:1.25.40.10:FF:001696', NULL, NULL, 'Flagellar associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(221168, NULL, 'G3DSA:3.50.50.60:FF:001098', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(221169, NULL, 'G3DSA:1.10.10.60:FF:000961', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221170, NULL, 'G3DSA:2.60.120.650:FF:000246', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221171, NULL, 'G3DSA:3.40.50.12780:FF:000072', NULL, NULL, 'Long-chain-fatty-acid-CoA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221172, NULL, 'G3DSA:1.20.120.220:FF:000021', NULL, NULL, 'ATP synthase subunit a', NULL, NULL, NULL, NULL, NULL, 4),
(221173, NULL, 'G3DSA:2.60.40.10:FF:006036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221174, NULL, 'G3DSA:3.40.50.300:FF:002142', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(221175, NULL, 'G3DSA:2.130.10.10:FF:001809', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221176, NULL, 'G3DSA:3.40.50.10860:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221177, NULL, 'G3DSA:3.10.620.10:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221178, NULL, 'G3DSA:1.20.1070.10:FF:002162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221179, NULL, 'G3DSA:3.20.180.20:FF:000019', NULL, NULL, 'Glutathione S-transferase class-mu 26 kDa isozyme', NULL, NULL, NULL, NULL, NULL, 4),
(221180, NULL, 'G3DSA:3.30.40.10:FF:000049', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(221181, NULL, 'G3DSA:4.10.60.10:FF:000167', NULL, NULL, 'WGS project CABT00000000 data, contig 2.31', NULL, NULL, NULL, NULL, NULL, 4),
(221182, NULL, 'G3DSA:3.30.60.90:FF:000029', NULL, NULL, 'Putative N6-adenosine-methyltransferase with ZZ-type zinc-binding domains', NULL, NULL, NULL, NULL, NULL, 4),
(221183, NULL, 'G3DSA:1.25.70.10:FF:000012', NULL, NULL, 'transcription termination factor MTERF6, chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(221184, NULL, 'G3DSA:2.60.40.150:FF:000441', NULL, NULL, 'Calcium-dependent protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(221185, NULL, 'G3DSA:3.40.275.10:FF:000002', NULL, NULL, 'L-fucose isomerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221186, NULL, 'G3DSA:1.25.40.20:FF:000513', NULL, NULL, 'ADP-ribosylation factor GTPase-activating protein AGD1', NULL, NULL, NULL, NULL, NULL, 4),
(221187, NULL, 'G3DSA:1.10.8.870:FF:000022', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(221188, NULL, 'G3DSA:3.90.730.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221189, NULL, 'G3DSA:1.10.472.10:FF:000194', NULL, NULL, 'Putative cyclin-D2-3', NULL, NULL, NULL, NULL, NULL, 4),
(221190, NULL, 'G3DSA:3.40.50.300:FF:004749', NULL, NULL, 'Inner dynein arm I1 heavy chain 1-ALPHA', NULL, NULL, NULL, NULL, NULL, 4),
(221191, NULL, 'G3DSA:3.30.1010.10:FF:000108', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221192, NULL, 'G3DSA:2.60.40.1460:FF:000011', NULL, NULL, 'integrin alpha-PS2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(221193, NULL, 'G3DSA:2.60.40.10:FF:005210', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221194, NULL, 'G3DSA:2.130.10.10:FF:003485', NULL, NULL, 'Protein CBG02750', NULL, NULL, NULL, NULL, NULL, 4),
(221195, NULL, 'G3DSA:3.40.50.620:FF:000220', NULL, NULL, 'Glutamine-dependent NAD(+) synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(221196, NULL, 'G3DSA:1.20.1250.20:FF:000122', NULL, NULL, 'D-xylose transporter XylE', NULL, NULL, NULL, NULL, NULL, 4),
(221197, NULL, 'G3DSA:1.10.10.60:FF:000068', NULL, NULL, 'Orthodenticle homeobox 1', NULL, NULL, NULL, NULL, NULL, 4),
(221198, NULL, 'G3DSA:1.20.1070.10:FF:001217', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221199, NULL, 'G3DSA:3.10.50.40:FF:000043', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(221200, NULL, 'G3DSA:3.30.160.60:FF:004350', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221201, NULL, 'G3DSA:3.30.450.20:FF:000398', NULL, NULL, 'Aryl hydrocarbon receptor nuclear translocator-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(221202, NULL, 'G3DSA:1.10.8.710:FF:000002', NULL, NULL, 'dynein heavy chain 17, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(221203, NULL, 'G3DSA:2.40.70.10:FF:000317', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221204, NULL, 'G3DSA:1.10.10.10:FF:000047', NULL, NULL, 'Transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(221205, NULL, 'G3DSA:1.20.1270.280:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221206, NULL, 'G3DSA:1.20.1250.20:FF:001532', NULL, NULL, 'AaceriABR223Cp', NULL, NULL, NULL, NULL, NULL, 4),
(221207, NULL, 'G3DSA:3.10.100.10:FF:000295', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(221208, NULL, 'G3DSA:3.30.70.330:FF:000824', NULL, NULL, 'U2 small nuclear ribonucleoprotein B', NULL, NULL, NULL, NULL, NULL, 4),
(221209, NULL, 'G3DSA:2.130.10.10:FF:000079', NULL, NULL, 'striatin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(221210, NULL, 'G3DSA:3.90.76.10:FF:000005', NULL, NULL, 'Peptide ABC transporter substrate-binding protein SapA', NULL, NULL, NULL, NULL, NULL, 4),
(221211, NULL, 'G3DSA:1.20.58.60:FF:000874', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(221212, NULL, 'G3DSA:1.10.220.150:FF:000053', NULL, NULL, 'Alpha-protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(221213, NULL, 'G3DSA:2.60.120.970:FF:000095', NULL, NULL, 'Bone morphogenetic protein 8B-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(221214, NULL, 'G3DSA:3.30.160.60:FF:005547', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221215, NULL, 'G3DSA:1.10.10.1800:FF:000007', NULL, NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', NULL, NULL, NULL, NULL, NULL, 4),
(221216, NULL, 'G3DSA:1.10.10.10:FF:000856', NULL, NULL, 'PROBABLE TRANSCRIPTIONAL REPRESSOR PROTEIN', NULL, NULL, NULL, NULL, NULL, 4),
(221217, NULL, 'G3DSA:3.10.20.90:FF:000657', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221218, NULL, 'G3DSA:1.10.510.10:FF:002992', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221219, NULL, 'G3DSA:1.50.40.10:FF:000334', NULL, NULL, 'Solute carrier family 25 member 36-A', NULL, NULL, NULL, NULL, NULL, 4),
(221220, NULL, 'G3DSA:1.50.40.10:FF:000564', NULL, NULL, 'Mitochondrial substrate carrier family protein W', NULL, NULL, NULL, NULL, NULL, 4),
(221221, NULL, 'G3DSA:1.10.1370.30:FF:000006', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(221222, NULL, 'G3DSA:1.20.120.1910:FF:000006', NULL, NULL, 'Cysteine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(221223, NULL, 'G3DSA:3.20.20.70:FF:000701', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221224, NULL, 'G3DSA:3.40.190.290:FF:000044', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(221225, NULL, 'G3DSA:1.25.40.20:FF:000176', NULL, NULL, 'ankyrin repeat domain-containing protein 17 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(221226, NULL, 'G3DSA:2.40.50.140:FF:000366', NULL, NULL, 'Replication protein A1, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(221227, NULL, 'G3DSA:3.10.330.10:FF:000020', NULL, NULL, 'PeRoXisome assembly factor', NULL, NULL, NULL, NULL, NULL, 4),
(221228, NULL, 'G3DSA:1.10.20.10:FF:000121', NULL, NULL, 'DNA polymerase II third subunit', NULL, NULL, NULL, NULL, NULL, 4),
(221229, NULL, 'G3DSA:3.30.505.10:FF:000270', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221230, NULL, 'G3DSA:3.30.70.3490:FF:000065', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221231, NULL, 'G3DSA:2.60.40.10:FF:005547', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221232, NULL, 'G3DSA:3.40.50.300:FF:003440', NULL, NULL, 'Deletions Of G-rich DNA', NULL, NULL, NULL, NULL, NULL, 4),
(221233, NULL, 'G3DSA:1.25.40.10:FF:005198', NULL, NULL, 'SH3 domain and tetratricopeptide repeat-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(221234, NULL, 'G3DSA:1.20.1580.10:FF:000003', NULL, NULL, 'UvrABC system protein A', NULL, NULL, NULL, NULL, NULL, 4),
(221235, NULL, 'G3DSA:1.10.3370.10:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221236, NULL, 'G3DSA:3.40.50.300:FF:001411', NULL, NULL, 'Dynein heavy chain domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(221237, NULL, 'G3DSA:3.80.10.10:FF:002945', NULL, NULL, 'CLL4A clavata1-like receptor S/T protein kinase protein', NULL, NULL, NULL, NULL, NULL, 4),
(221238, NULL, 'G3DSA:3.90.70.10:FF:000043', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 40', NULL, NULL, NULL, NULL, NULL, 4),
(221239, NULL, 'G3DSA:1.10.287.70:FF:000230', NULL, NULL, 'Inward Rectifying K (Potassium) channel family', NULL, NULL, NULL, NULL, NULL, 4),
(221240, NULL, 'G3DSA:3.30.9.10:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(221241, NULL, 'G3DSA:3.90.550.50:FF:000047', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(221242, NULL, 'G3DSA:3.50.7.10:FF:000052', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221243, NULL, 'G3DSA:2.60.40.10:FF:002321', NULL, NULL, 'GG12177', NULL, NULL, NULL, NULL, NULL, 4),
(221244, NULL, 'G3DSA:1.10.390.10:FF:000082', NULL, NULL, 'Os09g0410125 protein', NULL, NULL, NULL, NULL, NULL, 4),
(221245, NULL, 'G3DSA:3.40.50.1000:FF:000395', NULL, NULL, 'HAD family hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(221246, NULL, 'G3DSA:1.25.10.10:FF:003004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221247, NULL, 'G3DSA:3.65.10.20:FF:000016', NULL, NULL, 'WGS project CABT00000000 data, contig 2.4', NULL, NULL, NULL, NULL, NULL, 4),
(221248, NULL, 'G3DSA:1.20.120.350:FF:000161', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221249, NULL, 'G3DSA:1.10.10.620:FF:000001', NULL, NULL, 'Ribosome modulation factor', NULL, NULL, NULL, NULL, NULL, 4),
(221250, NULL, 'G3DSA:3.30.450.50:FF:000053', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221251, NULL, 'G3DSA:3.10.440.10:FF:000011', NULL, NULL, '50S ribosomal protein L31e', NULL, NULL, NULL, NULL, NULL, 4),
(221252, NULL, 'G3DSA:3.40.50.2300:FF:000447', NULL, NULL, 'Receptor-type guanylate cyclase gcy-19', NULL, NULL, NULL, NULL, NULL, 4),
(221253, NULL, 'G3DSA:1.20.58.60:FF:000211', NULL, NULL, 'Spectrin repeat containing nuclear envelope protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(221254, NULL, 'G3DSA:2.120.10.30:FF:000259', NULL, NULL, 'NHL repeat-containing protein 2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(221255, NULL, 'G3DSA:1.10.510.10:FF:000524', NULL, NULL, 'Cell division protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(221256, NULL, 'G3DSA:2.30.30.380:FF:000043', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(221257, NULL, 'G3DSA:1.20.1250.20:FF:001420', NULL, NULL, 'MFS tranporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221258, NULL, 'G3DSA:3.90.550.10:FF:000372', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221259, NULL, 'G3DSA:2.30.180.10:FF:000063', NULL, NULL, 'Os06g0285100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(221260, NULL, 'G3DSA:1.10.760.10:FF:000003', NULL, NULL, 'Cbb3-type cytochrome c oxidase subunit II', NULL, NULL, NULL, NULL, NULL, 4),
(221261, NULL, 'G3DSA:3.40.630.20:FF:000016', NULL, NULL, 'Pyroglutamyl-peptidase I-like', NULL, NULL, NULL, NULL, NULL, 4),
(221262, NULL, 'G3DSA:2.60.40.10:FF:005098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221263, NULL, 'G3DSA:2.40.110.10:FF:000091', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221264, NULL, 'G3DSA:2.160.20.10:FF:000314', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221265, NULL, 'G3DSA:2.20.70.70:FF:000004', NULL, NULL, 'Penicillin-binding protein 2B', NULL, NULL, NULL, NULL, NULL, 4),
(221266, NULL, 'G3DSA:3.40.30.10:FF:001200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221267, NULL, 'G3DSA:1.10.630.10:FF:000590', NULL, NULL, 'Protein CBG01396', NULL, NULL, NULL, NULL, NULL, 4),
(221268, NULL, 'G3DSA:2.40.37.20:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221269, NULL, 'G3DSA:3.90.180.10:FF:000023', NULL, NULL, 'Prostaglandin reductase 3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(221270, NULL, 'G3DSA:3.40.50.1820:FF:001478', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221271, NULL, 'G3DSA:3.30.230.130:FF:000014', NULL, NULL, 'CDC53p Cullin', NULL, NULL, NULL, NULL, NULL, 4),
(221272, NULL, 'G3DSA:3.90.190.10:FF:000400', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221273, NULL, 'G3DSA:3.30.505.10:FF:000169', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221274, NULL, 'G3DSA:3.30.565.10:FF:000144', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(221275, NULL, 'G3DSA:3.20.20.80:FF:000788', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221276, NULL, 'G3DSA:1.10.10.60:FF:000152', NULL, NULL, 'Trihelix transcription factor ASIL2', NULL, NULL, NULL, NULL, NULL, 4),
(221277, NULL, 'G3DSA:3.80.10.10:FF:004070', NULL, NULL, 'Putative mitogen-activated protein kinase kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(221278, NULL, 'G3DSA:3.40.50.300:FF:004396', NULL, NULL, 'Protein CBG00332', NULL, NULL, NULL, NULL, NULL, 4),
(221279, NULL, 'G3DSA:2.60.40.150:FF:000571', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221280, NULL, 'G3DSA:1.10.510.10:FF:003397', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221281, NULL, 'G3DSA:2.130.10.10:FF:004345', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221282, NULL, 'G3DSA:2.60.40.10:FF:000067', NULL, NULL, 'basement membrane-specific heparan sulfate proteoglycan core protein', NULL, NULL, NULL, NULL, NULL, 4),
(221283, NULL, 'G3DSA:3.40.50.1390:FF:000005', NULL, NULL, 'TnpR recombinase', NULL, NULL, NULL, NULL, NULL, 4),
(221284, NULL, 'G3DSA:3.40.50.620:FF:000332', NULL, NULL, 'Phosphoadenosine phosphosulfate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(221285, NULL, 'G3DSA:3.40.50.150:FF:000500', NULL, NULL, 'mRNA capping methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221286, NULL, 'G3DSA:3.30.70.330:FF:003129', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221287, NULL, 'G3DSA:3.40.50.2020:FF:000133', NULL, NULL, 'Adenine phosphoribosyltransferase 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(221288, NULL, 'G3DSA:3.20.20.70:FF:000589', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221289, NULL, 'G3DSA:3.40.630.30:FF:000688', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221290, NULL, 'G3DSA:3.90.226.10:FF:000349', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(221291, NULL, 'G3DSA:3.40.140.10:FF:000026', NULL, NULL, '26S proteasome non-ATPase regulatory subunit 14', NULL, NULL, NULL, NULL, NULL, 4),
(221292, NULL, 'G3DSA:2.130.10.10:FF:001591', NULL, NULL, 'Nucleolar protein 10 putative', NULL, NULL, NULL, NULL, NULL, 4),
(221293, NULL, 'G3DSA:3.40.50.300:FF:002934', NULL, NULL, 'DBP6p protein', NULL, NULL, NULL, NULL, NULL, 4),
(221294, NULL, 'G3DSA:2.40.50.1060:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221295, NULL, 'G3DSA:2.60.40.2880:FF:000004', NULL, NULL, 'Probable conserved membrane protein mmpS1', NULL, NULL, NULL, NULL, NULL, 4),
(221296, NULL, 'G3DSA:3.30.830.10:FF:000166', NULL, NULL, 'Putative mitochondrial-processing peptidase subunit beta mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(221297, NULL, 'G3DSA:3.40.1190.20:FF:000200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221298, NULL, 'G3DSA:3.30.70.2190:FF:000006', NULL, NULL, 'Predicted D-lactate dehydrogenase Fe-S protein FAD/FMN-containing', NULL, NULL, NULL, NULL, NULL, 4),
(221299, NULL, 'G3DSA:1.25.40.10:FF:004029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221300, NULL, 'G3DSA:3.20.20.70:FF:000561', NULL, NULL, 'Dihydroorotate dehydrogenase (quinone)', NULL, NULL, NULL, NULL, NULL, 4),
(221301, NULL, 'G3DSA:3.40.50.410:FF:000275', NULL, NULL, 'ATP-dependent DNA helicase II subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(221302, NULL, 'G3DSA:3.40.50.720:FF:000345', NULL, NULL, 'Homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(221303, NULL, 'G3DSA:2.60.40.10:FF:003170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221304, NULL, 'G3DSA:1.25.40.10:FF:000426', NULL, NULL, 'LON peptidase N-terminal domain and RING finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(221305, NULL, 'G3DSA:3.40.1280.10:FF:000081', NULL, NULL, 'rRNA methyltransferase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(221306, NULL, 'G3DSA:3.30.60.30:FF:000039', NULL, NULL, 'Agrin isoform B', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(221307, NULL, 'G3DSA:3.10.170.20:FF:000004', NULL, NULL, 'Leishmanolysin-like peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(221308, NULL, 'G3DSA:1.10.533.10:FF:000217', NULL, NULL, 'Fas cell surface death receptor', NULL, NULL, NULL, NULL, NULL, 4),
(221309, NULL, 'G3DSA:3.10.250.10:FF:000070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221310, NULL, 'G3DSA:3.90.70.160:FF:000001', NULL, NULL, 'ORF1a polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(221311, NULL, 'G3DSA:3.30.450.190:FF:000003', NULL, NULL, 'Small monomeric GTPase (Gtr1)', NULL, NULL, NULL, NULL, NULL, 4),
(221312, NULL, 'G3DSA:1.10.150.530:FF:000004', NULL, NULL, 'Probable dual-specificity RNA methyltransferase RlmN', NULL, NULL, NULL, NULL, NULL, 4),
(221313, NULL, 'G3DSA:3.90.70.10:FF:000386', NULL, NULL, 'Os09g0564200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(221314, NULL, 'G3DSA:3.80.30.20:FF:000027', NULL, NULL, 'MiaB-like tRNA modifying enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(221315, NULL, 'G3DSA:3.30.70.330:FF:002741', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221316, NULL, 'G3DSA:2.60.40.10:FF:004119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221317, NULL, 'G3DSA:3.90.1150.10:FF:000341', NULL, NULL, 'Probable 8-amino-7-oxononanoate synthase (Eurofung)', NULL, NULL, NULL, NULL, NULL, 4),
(221318, NULL, 'G3DSA:3.10.110.10:FF:000121', NULL, NULL, 'Protein crossbronx', NULL, NULL, NULL, NULL, NULL, 4),
(221319, NULL, 'G3DSA:1.25.10.10:FF:002953', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221320, NULL, 'G3DSA:1.20.58.80:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221321, NULL, 'G3DSA:2.60.40.10:FF:004479', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221322, NULL, 'G3DSA:3.30.1370.10:FF:000129', NULL, NULL, 'Pre-rRNA-processing protein PNO1', NULL, NULL, NULL, NULL, NULL, 4),
(221323, NULL, 'G3DSA:2.40.100.10:FF:000016', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(221324, NULL, 'G3DSA:3.40.50.300:FF:004620', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221325, NULL, 'G3DSA:2.60.260.20:FF:000083', NULL, NULL, 'Heat shock protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221326, NULL, 'G3DSA:2.60.120.10:FF:000491', NULL, NULL, 'Centromere protein C', NULL, NULL, NULL, NULL, NULL, 4),
(221327, NULL, 'G3DSA:1.10.510.10:FF:001143', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(221328, NULL, 'G3DSA:3.20.20.100:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221329, NULL, 'G3DSA:1.20.1540.10:FF:000012', NULL, NULL, 'Rhomboid family protein', NULL, NULL, NULL, NULL, NULL, 4),
(221330, NULL, 'G3DSA:1.10.238.10:FF:000262', NULL, NULL, 'calbindin-32 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(221331, NULL, 'G3DSA:1.10.288.10:FF:000001', NULL, NULL, 'Methionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(221332, NULL, 'G3DSA:1.10.1530.10:FF:000002', NULL, NULL, 'Malate/L-lactate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(221333, NULL, 'G3DSA:1.10.10.10:FF:000064', NULL, NULL, 'Lysine-specific histone demethylase 1A', NULL, NULL, NULL, NULL, NULL, 4),
(221334, NULL, 'G3DSA:1.10.510.10:FF:000654', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221335, NULL, 'G3DSA:1.10.10.790:FF:000024', NULL, NULL, 'Protein SWAP', NULL, NULL, NULL, NULL, NULL, 4),
(221336, NULL, 'G3DSA:3.30.160.60:FF:005064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221337, NULL, 'G3DSA:4.10.60.10:FF:000055', NULL, NULL, 'RNA-binding protein lark', NULL, NULL, NULL, NULL, NULL, 4),
(221338, NULL, 'G3DSA:1.25.40.10:FF:002764', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221339, NULL, 'G3DSA:3.30.40.10:FF:001898', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221340, NULL, 'G3DSA:1.20.5.110:FF:000129', NULL, NULL, 'Hemagglutinin-neuraminidase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(221341, NULL, 'G3DSA:3.30.200.20:FF:002504', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221342, NULL, 'G3DSA:3.30.1640.10:FF:000010', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(221343, NULL, 'G3DSA:3.10.450.50:FF:000052', NULL, NULL, 'Nuclear transport factor 2 (NTF2) domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221344, NULL, 'G3DSA:3.40.50.410:FF:000258', NULL, NULL, 'Voltage-dependent calcium channel subunit alpha-2/delta-4', NULL, NULL, NULL, NULL, NULL, 4),
(221345, NULL, 'G3DSA:1.20.58.60:FF:000082', NULL, NULL, 'Short stop, isoform K', NULL, NULL, NULL, NULL, NULL, 4),
(221346, NULL, 'G3DSA:3.40.850.10:FF:000221', NULL, NULL, 'Kinesin motor protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(221347, NULL, 'G3DSA:3.10.130.10:FF:000004', NULL, NULL, 'Epididymal secretory protein E3-alpha', NULL, NULL, NULL, NULL, NULL, 4),
(221348, NULL, 'G3DSA:3.30.160.60:FF:004575', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221349, NULL, 'G3DSA:3.30.40.10:FF:000280', NULL, NULL, 'E3 ubiquitin-protein ligase Hakai', NULL, NULL, NULL, NULL, NULL, 4),
(221350, NULL, 'G3DSA:3.40.50.10810:FF:000054', NULL, NULL, 'Helicase, Snf2 family', NULL, NULL, NULL, NULL, NULL, 4),
(221351, NULL, 'G3DSA:2.70.98.10:FF:000054', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(221352, NULL, 'G3DSA:2.30.30.40:FF:000408', NULL, NULL, 'Peroxin 13', NULL, NULL, NULL, NULL, NULL, 4),
(221353, NULL, 'G3DSA:3.90.70.10:FF:000610', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221354, NULL, 'G3DSA:2.30.29.30:FF:001279', NULL, NULL, 'PH domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(221355, NULL, 'G3DSA:3.90.25.10:FF:000079', NULL, NULL, 'dTDP-4-dehydrorhamnose reductase', NULL, NULL, NULL, NULL, NULL, 4),
(221356, NULL, 'G3DSA:3.40.50.720:FF:001525', NULL, NULL, 'UDP-N-acetylenolpyruvoylglucosamine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(221357, NULL, 'G3DSA:3.40.190.10:FF:000434', NULL, NULL, 'Peptide/nickel transport system substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(221358, NULL, 'G3DSA:3.30.70.20:FF:000094', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221359, NULL, 'G3DSA:1.10.287.130:FF:000198', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(221360, NULL, 'G3DSA:3.30.160.60:FF:002219', NULL, NULL, 'Kruppel like factor 17', NULL, NULL, NULL, NULL, NULL, 4),
(221361, NULL, 'G3DSA:3.40.50.2000:FF:000026', NULL, NULL, 'Phosphatidylinositol N-acetylglucosaminyltransferase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(221362, NULL, 'G3DSA:1.25.10.10:FF:002392', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221363, NULL, 'G3DSA:3.40.50.11040:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221364, NULL, 'G3DSA:3.40.20.10:FF:000076', NULL, NULL, 'Villin-1', NULL, NULL, NULL, NULL, NULL, 4),
(221365, NULL, 'G3DSA:3.40.50.880:FF:000039', NULL, NULL, 'Imidazole glycerol phosphate synthase hisHF', NULL, NULL, NULL, NULL, NULL, 4),
(221366, NULL, 'G3DSA:1.10.10.10:FF:001475', NULL, NULL, 'SPO11 meiotic protein covalently-bound to DSB', NULL, NULL, NULL, NULL, NULL, 4),
(221367, NULL, 'G3DSA:2.60.40.60:FF:000638', NULL, NULL, 'AGAP002828-PA', NULL, NULL, NULL, NULL, NULL, 4),
(221368, NULL, 'G3DSA:2.10.22.10:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221369, NULL, 'G3DSA:1.10.3210.10:FF:000102', NULL, NULL, 'Fusion HD-GYP domain and HD-hydrolase domain', NULL, NULL, NULL, NULL, NULL, 4),
(221370, NULL, 'G3DSA:3.60.130.10:FF:000004', NULL, NULL, 'Glutarate 2-hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(221371, NULL, 'G3DSA:2.130.10.10:FF:003726', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(221372, NULL, 'G3DSA:3.90.1110.10:FF:000018', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(221373, NULL, 'G3DSA:3.40.50.450:FF:000028', NULL, NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(221374, NULL, 'G3DSA:3.10.50.10:FF:000045', NULL, NULL, 'Chitinase Chia_Spl', NULL, NULL, NULL, NULL, NULL, 4),
(221375, NULL, 'G3DSA:1.10.10.440:FF:000054', NULL, NULL, 'Transcription elongation regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(221376, NULL, 'G3DSA:3.10.260.10:FF:000008', NULL, NULL, 'Transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(221377, NULL, 'G3DSA:3.40.50.300:FF:008111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221378, NULL, 'G3DSA:3.20.20.70:FF:000459', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221379, NULL, 'G3DSA:3.10.20.30:FF:000083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221380, NULL, 'G3DSA:3.50.50.60:FF:001435', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221381, NULL, 'G3DSA:2.60.40.1080:FF:000004', NULL, NULL, 'Putative adhesin', NULL, NULL, NULL, NULL, NULL, 4),
(221382, NULL, 'G3DSA:2.60.40.10:FF:002804', NULL, NULL, 'lymphocyte activation gene 3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(221383, NULL, 'G3DSA:1.20.1560.10:FF:000687', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221384, NULL, 'G3DSA:2.130.10.10:FF:004002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221385, NULL, 'G3DSA:3.40.50.150:FF:001809', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221386, NULL, 'G3DSA:3.30.160.60:FF:001702', NULL, NULL, 'Zinc finger protein 224', NULL, NULL, NULL, NULL, NULL, 4),
(221387, NULL, 'G3DSA:3.30.830.10:FF:000036', NULL, NULL, 'Putative zinc metalloprotease', NULL, NULL, NULL, NULL, NULL, 4),
(221388, NULL, 'G3DSA:3.30.60.30:FF:000169', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(221389, NULL, 'G3DSA:3.30.870.10:FF:000050', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(221390, NULL, 'G3DSA:1.25.10.10:FF:002032', NULL, NULL, 'Cytoskeleton-associated protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(221391, NULL, 'G3DSA:2.10.25.10:FF:001439', NULL, NULL, 'Multiple epidermal growth factor-like domains protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(221392, NULL, 'G3DSA:1.10.580.10:FF:000017', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(221393, NULL, 'G3DSA:3.30.70.270:FF:000115', NULL, NULL, 'Polyprotein of retroviral origin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221394, NULL, 'G3DSA:3.30.710.10:FF:000117', NULL, NULL, 'zinc finger and BTB domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(221395, NULL, 'G3DSA:1.20.120.230:FF:000041', NULL, NULL, 'Vinculin', NULL, NULL, NULL, NULL, NULL, 4),
(221396, NULL, 'G3DSA:4.10.640.10:FF:000005', NULL, NULL, '30S ribosomal protein S18', NULL, NULL, NULL, NULL, NULL, 4),
(221397, NULL, 'G3DSA:1.10.1450.10:FF:000052', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(221398, NULL, 'G3DSA:4.10.1100.10:FF:000001', NULL, NULL, 'Squamosa promoter-binding-like protein 14', NULL, NULL, NULL, NULL, NULL, 4),
(221399, NULL, 'G3DSA:4.10.800.10:FF:000007', NULL, NULL, 'Nidogen 2', NULL, NULL, NULL, NULL, NULL, 4),
(221400, NULL, 'G3DSA:3.40.50.720:FF:001885', NULL, NULL, 'Dihydroflavonol-4-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(221401, NULL, 'G3DSA:1.10.287.1770:FF:000005', NULL, NULL, 'Ferrous iron transport protein B', NULL, NULL, NULL, NULL, NULL, 4),
(221402, NULL, 'G3DSA:3.40.50.2300:FF:001066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221403, NULL, 'G3DSA:1.10.287.690:FF:000017', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(221404, NULL, 'G3DSA:3.80.10.10:FF:003917', NULL, NULL, 'Leucine-rich repeat protein (LRRP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(221405, NULL, 'G3DSA:3.30.160.60:FF:004119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221406, NULL, 'G3DSA:2.60.120.260:FF:000450', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221407, NULL, 'G3DSA:1.25.40.20:FF:000064', NULL, NULL, 'SH3 and multiple ankyrin repeat domains protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(221408, NULL, 'G3DSA:1.25.40.10:FF:004922', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g15630, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(221409, NULL, 'G3DSA:1.20.1070.10:FF:001673', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221410, NULL, 'G3DSA:1.20.120.1760:FF:000023', NULL, NULL, 'Putative CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(221411, NULL, 'G3DSA:3.40.50.2300:FF:001178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221412, NULL, 'G3DSA:2.60.40.10:FF:002433', NULL, NULL, 'Secreted alpha-amylase', NULL, NULL, NULL, NULL, NULL, 4),
(221413, NULL, 'G3DSA:1.10.3260.10:FF:000026', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(221414, NULL, 'G3DSA:3.30.70.330:FF:002303', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221415, NULL, 'G3DSA:1.10.10.60:FF:000944', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221416, NULL, 'G3DSA:1.20.120.720:FF:000064', NULL, NULL, 'Myosin XVB', NULL, NULL, NULL, NULL, NULL, 4),
(221417, NULL, 'G3DSA:1.10.287.1010:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221418, NULL, 'G3DSA:2.120.10.90:FF:000007', NULL, NULL, 'DNA gyrase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(221419, NULL, 'G3DSA:3.40.50.1820:FF:000073', NULL, NULL, 'esterase OVCA2 isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(221420, NULL, 'G3DSA:3.30.420.40:FF:000126', NULL, NULL, 'Xylulose kinase', NULL, NULL, NULL, NULL, NULL, 4),
(221421, NULL, 'G3DSA:2.120.10.70:FF:000001', NULL, NULL, 'Fucose-specific lectin', NULL, NULL, NULL, NULL, NULL, 4),
(221422, NULL, 'G3DSA:1.10.287.110:FF:000203', NULL, NULL, 'Diphthamide biosynthesis protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(221423, NULL, 'G3DSA:2.130.10.110:FF:000013', NULL, NULL, 'Clathrin heavy chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(221424, NULL, 'G3DSA:3.90.580.10:FF:000003', NULL, NULL, 'Zinc finger CHC2-family protein', NULL, NULL, NULL, NULL, NULL, 4),
(221425, NULL, 'G3DSA:1.10.510.10:FF:000311', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(221426, NULL, 'G3DSA:3.30.50.10:FF:000106', NULL, NULL, 'GATA transcription factor 15', NULL, NULL, NULL, NULL, NULL, 4),
(221427, NULL, 'G3DSA:2.30.30.40:FF:000493', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221428, NULL, 'G3DSA:3.10.660.10:FF:000005', NULL, NULL, 'DnaJ protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221429, NULL, 'G3DSA:3.20.20.100:FF:000124', NULL, NULL, 'Aldo-keto reductase family 1, member C20', NULL, NULL, NULL, NULL, NULL, 4),
(221430, NULL, 'G3DSA:1.10.510.10:FF:002441', NULL, NULL, 'Calcium-dependent protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(221431, NULL, 'G3DSA:3.30.450.30:FF:000064', NULL, NULL, 'Late endosomal/lysosomal adaptor, MAPK and MTOR activator 2', NULL, NULL, NULL, NULL, NULL, 4),
(221432, NULL, 'G3DSA:3.30.70.330:FF:000162', NULL, NULL, 'polypyrimidine tract-binding protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(221433, NULL, 'G3DSA:3.30.70.1050:FF:000002', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(221434, NULL, 'G3DSA:4.10.400.10:FF:000027', NULL, NULL, 'Sortilin related receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(221435, NULL, 'G3DSA:2.60.40.10:FF:005659', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221436, NULL, 'G3DSA:1.20.1250.20:FF:001291', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221437, NULL, 'G3DSA:1.20.58.1040:FF:000007', NULL, NULL, 'PLASMODESMATA CALLOSE-BINDING PROTEIN 2', NULL, NULL, NULL, NULL, NULL, 4),
(221438, NULL, 'G3DSA:6.10.250.3390:FF:000001', NULL, NULL, 'DNA-directed RNA polymerase I subunit RPA14', NULL, NULL, NULL, NULL, NULL, 4),
(221439, NULL, 'G3DSA:3.40.50.1240:FF:000219', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221440, NULL, 'G3DSA:3.40.710.10:FF:000183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221441, NULL, 'G3DSA:2.60.40.150:FF:000784', NULL, NULL, 'Synaptotagmin-15, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221442, NULL, 'G3DSA:1.20.1050.10:FF:000137', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(221443, NULL, 'G3DSA:1.10.287.110:FF:000192', NULL, NULL, 'Chaperone protein dnaJ 8 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(221444, NULL, 'G3DSA:3.10.10.10:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221445, NULL, 'G3DSA:3.30.70.240:FF:000011', NULL, NULL, 'Elongation factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(221446, NULL, 'G3DSA:3.30.70.330:FF:002292', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221447, NULL, 'G3DSA:2.60.40.10:FF:004581', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221448, NULL, 'G3DSA:3.10.100.10:FF:000424', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221449, NULL, 'G3DSA:3.40.50.720:FF:001317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221450, NULL, 'G3DSA:3.30.40.10:FF:001802', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221451, NULL, 'G3DSA:2.60.120.200:FF:000128', NULL, NULL, 'enteropeptidase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(221452, NULL, 'G3DSA:3.40.50.300:FF:007594', NULL, NULL, 'GTP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(221453, NULL, 'G3DSA:3.40.50.300:FF:003895', NULL, NULL, 'Lipoprotein-releasing system ATP-binding protein LolD', NULL, NULL, NULL, NULL, NULL, 4),
(221454, NULL, 'G3DSA:3.30.200.20:FF:002049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221455, NULL, 'G3DSA:3.30.160.60:FF:003389', NULL, NULL, 'LOC100006898 protein', NULL, NULL, NULL, NULL, NULL, 4),
(221456, NULL, 'G3DSA:1.10.10.60:FF:000517', NULL, NULL, 'MYB-related transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(221457, NULL, 'G3DSA:1.10.340.30:FF:000040', NULL, NULL, '8-oxoguanine glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(221458, NULL, 'G3DSA:2.10.25.10:FF:000933', NULL, NULL, 'LDL receptor protein 1, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(221459, NULL, 'G3DSA:1.10.287.1490:FF:000112', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221460, NULL, 'G3DSA:2.160.20.10:FF:000090', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(221461, NULL, 'G3DSA:1.10.238.10:FF:000711', NULL, NULL, 'Solute carrier family 25 member 24,-like', NULL, NULL, NULL, NULL, NULL, 4),
(221462, NULL, 'G3DSA:2.60.40.10:FF:005991', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221463, NULL, 'G3DSA:2.10.110.10:FF:000237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221464, NULL, 'G3DSA:1.20.58.1020:FF:000001', NULL, NULL, 'DNA replication complex GINS protein PSF2', NULL, NULL, NULL, NULL, NULL, 4),
(221465, NULL, 'G3DSA:2.130.10.30:FF:000169', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221466, NULL, 'G3DSA:1.10.10.10:FF:001587', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221467, NULL, 'G3DSA:2.30.29.30:FF:000531', NULL, NULL, 'FERM domain containing 4A', NULL, NULL, NULL, NULL, NULL, 4),
(221468, NULL, 'G3DSA:2.130.10.10:FF:000163', NULL, NULL, 'ER membrane protein complex subunit 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(221469, NULL, 'G3DSA:2.60.34.10:FF:000042', NULL, NULL, 'Putative heat shock protein', NULL, NULL, NULL, NULL, NULL, 4),
(221470, NULL, 'G3DSA:1.20.140.10:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221471, NULL, 'G3DSA:3.40.50.10130:FF:000064', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221472, NULL, 'G3DSA:1.20.1280.50:FF:000189', NULL, NULL, 'WD40-repeat-containing domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(221473, NULL, 'G3DSA:3.40.1360.10:FF:000014', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(221474, NULL, 'G3DSA:2.130.10.10:FF:003597', NULL, NULL, 'WD repeat-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(221475, NULL, 'G3DSA:1.10.1000.11:FF:000019', NULL, NULL, 'Guanine_nucleotide_exchange_factor_in_Golgi_transport_N-terminal/Sec7_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(221476, NULL, 'G3DSA:2.60.40.790:FF:000184', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(221477, NULL, 'G3DSA:1.10.287.660:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221478, NULL, 'G3DSA:3.40.50.300:FF:000242', NULL, NULL, 'Pantothenate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(221479, NULL, 'G3DSA:3.80.10.10:FF:001540', NULL, NULL, 'AGAP007237-PA', NULL, NULL, NULL, NULL, NULL, 4),
(221480, NULL, 'G3DSA:1.20.1070.10:FF:000037', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(221481, NULL, 'G3DSA:3.30.40.10:FF:001117', NULL, NULL, 'Non-SMC element 1, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(221482, NULL, 'G3DSA:2.60.120.10:FF:000148', NULL, NULL, 'Protein kinase A regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(221483, NULL, 'G3DSA:3.40.50.150:FF:000955', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221484, NULL, 'G3DSA:3.40.50.300:FF:002703', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221485, NULL, 'G3DSA:1.20.120.980:FF:000012', NULL, NULL, 'Serine carboxypeptidase (S28) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(221486, NULL, 'G3DSA:2.40.30.10:FF:000180', NULL, NULL, 'Mitochondrial ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(221487, NULL, 'G3DSA:3.10.310.10:FF:000018', NULL, NULL, '2-methylaconitate cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(221488, NULL, 'G3DSA:1.10.472.80:FF:000074', NULL, NULL, 'TBC (Tre-2/Bub2/Cdc16) domain family', NULL, NULL, NULL, NULL, NULL, 4),
(221489, NULL, 'G3DSA:2.130.10.10:FF:000860', NULL, NULL, 'Vacuolar protein sorting-associated protein 11 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(221490, NULL, 'G3DSA:3.30.200.20:FF:000604', NULL, NULL, 'Proline-rich receptor-like protein kinase PERK8', NULL, NULL, NULL, NULL, NULL, 4),
(221491, NULL, 'G3DSA:1.10.287.1040:FF:000011', NULL, NULL, 'Exodeoxyribonuclease 7 small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(221492, NULL, 'G3DSA:1.10.1420.10:FF:000011', NULL, NULL, 'DNA mismatch repair protein MSH4', NULL, NULL, NULL, NULL, NULL, 4),
(221493, NULL, 'G3DSA:2.60.40.60:FF:000060', NULL, NULL, 'Putative cadherin-23', NULL, NULL, NULL, NULL, NULL, 4),
(221494, NULL, 'G3DSA:3.30.70.1230:FF:000185', NULL, NULL, 'Adenylate/guanylate cyclase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(221495, NULL, 'G3DSA:1.25.40.10:FF:001584', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g18940, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(221496, NULL, 'G3DSA:2.70.20.20:FF:000001', NULL, NULL, 'Matrix protein VP40', NULL, NULL, NULL, NULL, NULL, 4),
(221497, NULL, 'G3DSA:1.10.510.10:FF:001935', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221498, NULL, 'G3DSA:3.30.420.10:FF:000230', NULL, NULL, 'Ribonuclease HIII', NULL, NULL, NULL, NULL, NULL, 4),
(221499, NULL, 'G3DSA:2.30.29.30:FF:000211', NULL, NULL, 'Arf-GAP with GTPase, ANK repeat and PH domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(221500, NULL, 'G3DSA:3.30.465.10:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221501, NULL, 'G3DSA:2.130.10.10:FF:004114', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221502, NULL, 'G3DSA:2.40.50.100:FF:000045', NULL, NULL, 'Glycine cleavage system H protein', NULL, NULL, NULL, NULL, NULL, 4),
(221503, NULL, 'G3DSA:2.60.200.20:FF:000202', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221504, NULL, 'G3DSA:3.30.160.60:FF:000308', NULL, NULL, 'zinc finger protein 236 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(221505, NULL, 'G3DSA:1.10.30.10:FF:000077', NULL, NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily E member 1-related', NULL, NULL, NULL, NULL, NULL, 4),
(221506, NULL, 'G3DSA:2.40.50.90:FF:000160', NULL, NULL, 'Staphylococcal-like nuclease CAN1', NULL, NULL, NULL, NULL, NULL, 4),
(221507, NULL, 'G3DSA:3.40.190.10:FF:000097', NULL, NULL, 'Putative glutamate receptor ionotropic NMDA 3A', NULL, NULL, NULL, NULL, NULL, 4),
(221508, NULL, 'G3DSA:3.80.10.10:FF:000236', NULL, NULL, 'NLR family CARD domain containing 3', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(221509, NULL, 'G3DSA:3.40.50.300:FF:002372', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(221510, NULL, 'G3DSA:3.30.160.60:FF:004007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221511, NULL, 'G3DSA:1.10.472.10:FF:000317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221512, NULL, 'G3DSA:3.30.160.60:FF:000516', NULL, NULL, 'zinc finger protein 771', NULL, NULL, NULL, NULL, NULL, 4),
(221513, NULL, 'G3DSA:2.60.40.10:FF:001495', NULL, NULL, 'Si:dkey-234i14.13', NULL, NULL, NULL, NULL, NULL, 4),
(221514, NULL, 'G3DSA:3.40.800.20:FF:000058', NULL, NULL, 'Histone deacetylase 19', NULL, NULL, NULL, NULL, NULL, 4),
(221515, NULL, 'G3DSA:3.40.50.1010:FF:000055', NULL, NULL, 'Exodeoxyribonuclease IX', NULL, NULL, NULL, NULL, NULL, 4),
(221516, NULL, 'G3DSA:1.10.510.10:FF:002109', NULL, NULL, 'Tyrosine-protein kinase hopscotch', NULL, NULL, NULL, NULL, NULL, 4),
(221517, NULL, 'G3DSA:2.60.120.650:FF:000033', NULL, NULL, 'Transcription factor jumonji (JmjC) domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(221518, NULL, 'G3DSA:2.130.10.10:FF:002080', NULL, NULL, 'U3 small nucleolar RNA-associated protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(221519, NULL, 'G3DSA:1.20.1310.10:FF:000192', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221520, NULL, 'G3DSA:2.60.40.10:FF:002225', NULL, NULL, 'Gamete expressed 2', NULL, NULL, NULL, NULL, NULL, 4),
(221521, NULL, 'G3DSA:2.60.40.10:FF:002113', NULL, NULL, 'KETtiN (Drosophila actin-binding) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(221522, NULL, 'G3DSA:3.30.565.10:FF:000375', NULL, NULL, 'Hybrid sensory kinase', NULL, NULL, NULL, NULL, NULL, 4),
(221523, NULL, 'G3DSA:1.10.150.910:FF:000011', NULL, NULL, 'WGS project CABT00000000 data, contig 2.21', NULL, NULL, NULL, NULL, NULL, 4),
(221524, NULL, 'G3DSA:2.60.40.10:FF:004249', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221525, NULL, 'G3DSA:1.10.510.10:FF:001031', NULL, NULL, 'Serine/threonine-protein kinase Nek7', NULL, NULL, NULL, NULL, NULL, 4),
(221526, NULL, 'G3DSA:3.60.20.40:FF:000022', NULL, NULL, 'Gamma-glutamyltranspeptidase 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221527, NULL, 'G3DSA:1.10.10.60:FF:000040', NULL, NULL, 'T-cell leukemia homeobox protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(221528, NULL, 'G3DSA:2.130.10.10:FF:005851', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221529, NULL, 'G3DSA:2.130.10.10:FF:002658', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221530, NULL, 'G3DSA:3.10.580.10:FF:000049', NULL, NULL, 'Nuclear protein SNF4', NULL, NULL, NULL, NULL, NULL, 4),
(221531, NULL, 'G3DSA:2.30.30.40:FF:000285', NULL, NULL, 'Peptidase M24', NULL, NULL, NULL, NULL, NULL, 4),
(221532, NULL, 'G3DSA:3.30.1130.10:FF:000027', NULL, NULL, 'Folic acid synthesis protein fol1', NULL, NULL, NULL, NULL, NULL, 4),
(221533, NULL, 'G3DSA:2.60.40.60:FF:000413', NULL, NULL, 'Desmocollin 2 like', NULL, NULL, NULL, NULL, NULL, 4),
(221534, NULL, 'G3DSA:3.40.50.1820:FF:000764', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(221535, NULL, 'G3DSA:3.40.50.300:FF:003209', NULL, NULL, 'Zinc finger NFX1-type-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(221536, NULL, 'G3DSA:3.40.190.10:FF:000333', NULL, NULL, 'Nickel ABC transporter, periplasmic nickel-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(221537, NULL, 'G3DSA:3.40.50.620:FF:000883', NULL, NULL, 'Isoleucyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(221538, NULL, 'G3DSA:1.10.510.10:FF:003638', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221539, NULL, 'G3DSA:1.20.1250.20:FF:000026', NULL, NULL, 'MFS quinate transporter QutD', NULL, NULL, NULL, NULL, NULL, 4),
(221540, NULL, 'G3DSA:1.10.510.10:FF:003060', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221541, NULL, 'G3DSA:3.40.309.10:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221542, NULL, 'G3DSA:3.30.70.330:FF:000263', NULL, NULL, 'Splicing factor CC1-like', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(221543, NULL, 'G3DSA:3.30.420.40:FF:000918', NULL, NULL, 'Actin, actin related protein', NULL, NULL, NULL, NULL, NULL, 4),
(221544, NULL, 'G3DSA:1.25.40.10:FF:000870', NULL, NULL, 'U1 snRNP protein', NULL, NULL, NULL, NULL, NULL, 4),
(221545, NULL, 'G3DSA:3.40.50.10810:FF:000184', NULL, NULL, 'SWI/SNF family DNA-dependent ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221546, NULL, 'G3DSA:1.20.1280.130:FF:000002', NULL, NULL, 'Vacuolar protein sorting-associated protein 54', NULL, NULL, NULL, NULL, NULL, 4),
(221547, NULL, 'G3DSA:1.10.287.70:FF:000781', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221548, NULL, 'G3DSA:3.10.129.10:FF:000170', NULL, NULL, 'Thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(221549, NULL, 'G3DSA:3.40.50.10380:FF:000009', NULL, NULL, 'NAD-dependent malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(221550, NULL, 'G3DSA:2.60.40.60:FF:000537', NULL, NULL, 'Protein CBR-CDH-12', NULL, NULL, NULL, NULL, NULL, 4),
(221551, NULL, 'G3DSA:3.40.50.40:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221552, NULL, 'G3DSA:3.40.50.1000:FF:000164', NULL, NULL, 'Heavy metal translocating P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(221553, NULL, 'G3DSA:1.10.10.10:FF:000295', NULL, NULL, 'E2F transcription factor-like E2FE', NULL, NULL, NULL, NULL, NULL, 4),
(221554, NULL, 'G3DSA:3.30.160.60:FF:000421', NULL, NULL, 'Sp2 transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(221555, NULL, 'G3DSA:2.60.40.10:FF:003861', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221556, NULL, 'G3DSA:3.60.60.10:FF:000021', NULL, NULL, 'Bile salt hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(221557, NULL, 'G3DSA:3.40.109.10:FF:000021', NULL, NULL, 'Nitroreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(221558, NULL, 'G3DSA:1.10.20.120:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221559, NULL, 'G3DSA:3.90.79.20:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221560, NULL, 'G3DSA:3.40.470.10:FF:000028', NULL, NULL, 'Single-strand selective monofunctional uracil DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(221561, NULL, 'G3DSA:3.30.530.20:FF:000005', NULL, NULL, 'Type II toxin-antitoxin system toxin RatA', NULL, NULL, NULL, NULL, NULL, 4),
(221562, NULL, 'G3DSA:3.40.50.300:FF:001866', NULL, NULL, 'Phosphoribulokinase / Uridine kinase family', NULL, NULL, NULL, NULL, NULL, 4),
(221563, NULL, 'G3DSA:3.30.160.60:FF:001040', NULL, NULL, 'GDNF-inducible zinc finger protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(221564, NULL, 'G3DSA:3.90.550.10:FF:000400', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221565, NULL, 'G3DSA:2.60.40.10:FF:000876', NULL, NULL, 'Uncharacterized protein, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(221566, NULL, 'G3DSA:4.10.640.40:FF:000003', NULL, NULL, 'Cytoplasmic polyadenylation element-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(221567, NULL, 'G3DSA:3.90.70.10:FF:000285', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 14', NULL, NULL, NULL, NULL, NULL, 4),
(221568, NULL, 'G3DSA:3.40.50.300:FF:004845', NULL, NULL, 'DNA repair and recombination protein RadA', NULL, NULL, NULL, NULL, NULL, 4),
(221569, NULL, 'G3DSA:1.25.40.20:FF:000417', NULL, NULL, 'Diego, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(221570, NULL, 'G3DSA:3.40.50.150:FF:000371', NULL, NULL, 'Methyltransferase OMS1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(221571, NULL, 'G3DSA:3.90.79.10:FF:000124', NULL, NULL, 'mRNA decapping protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221572, NULL, 'G3DSA:3.30.420.510:FF:000003', NULL, NULL, 'Pantothenate kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(221573, NULL, 'G3DSA:2.130.10.10:FF:000051', NULL, NULL, '6-phosphogluconolactonase', NULL, NULL, NULL, NULL, NULL, 4),
(221574, NULL, 'G3DSA:3.30.40.10:FF:001926', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221575, NULL, 'G3DSA:1.10.238.10:FF:000503', NULL, NULL, 'Calmodulin-like protein 5', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(221576, NULL, 'G3DSA:2.130.10.10:FF:001585', NULL, NULL, 'Protein CBG00600', NULL, NULL, NULL, NULL, NULL, 4),
(221577, NULL, 'G3DSA:1.20.1070.10:FF:001768', NULL, NULL, '5-hydroxytryptamine receptor 2B', NULL, NULL, NULL, NULL, NULL, 4),
(221578, NULL, 'G3DSA:2.10.25.10:FF:001208', NULL, NULL, 'Fibropellin-1', NULL, NULL, NULL, NULL, NULL, 4),
(221579, NULL, 'G3DSA:1.10.510.10:FF:004257', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221580, NULL, 'G3DSA:3.40.50.300:FF:008431', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221581, NULL, 'G3DSA:3.40.47.10:FF:000210', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221582, NULL, 'G3DSA:3.30.160.60:FF:002664', NULL, NULL, 'Si:ch73-138e16.6', NULL, NULL, NULL, NULL, NULL, 4),
(221583, NULL, 'G3DSA:1.20.80.10:FF:000023', NULL, NULL, 'FERM domain containing 8', NULL, NULL, NULL, NULL, NULL, 4),
(221584, NULL, 'G3DSA:3.30.450.40:FF:000162', NULL, NULL, 'Diguanylate cyclase/phosphodiesterase (GGDEF & EAL domains) with PAS/PAC sensor(S)', NULL, NULL, NULL, NULL, NULL, 4),
(221585, NULL, 'G3DSA:3.90.226.10:FF:000006', NULL, NULL, 'ATP-dependent Clp protease proteolytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(221586, NULL, 'G3DSA:3.40.1110.10:FF:000193', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(221587, NULL, 'G3DSA:2.60.40.2160:FF:000002', NULL, NULL, 'Interleukin 17 receptor B', NULL, NULL, NULL, NULL, NULL, 4),
(221588, NULL, 'G3DSA:2.20.160.10:FF:000002', NULL, NULL, 'Titin-cap (telethonin)', NULL, NULL, NULL, NULL, NULL, 4),
(221589, NULL, 'G3DSA:2.40.70.10:FF:000093', NULL, NULL, 'Plasmepsin 5', NULL, NULL, NULL, NULL, NULL, 4),
(221590, NULL, 'G3DSA:3.30.160.60:FF:006036', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221591, NULL, 'G3DSA:3.40.30.10:FF:000475', NULL, NULL, 'Cell wall organization protein/glutathione transferase (Gto3), putative', NULL, NULL, NULL, NULL, NULL, 4),
(221592, NULL, 'G3DSA:3.40.50.10900:FF:000008', NULL, NULL, 'Proteasome assembly chaperone 2', NULL, NULL, NULL, NULL, NULL, 4),
(221593, NULL, 'G3DSA:2.60.120.10:FF:000047', NULL, NULL, 'Auxin-binding protein ABP19a', NULL, NULL, NULL, NULL, NULL, 4),
(221594, NULL, 'G3DSA:1.25.40.20:FF:000968', NULL, NULL, 'SBF complex DNA-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(221595, NULL, 'G3DSA:3.30.430.20:FF:000060', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 21', NULL, NULL, NULL, NULL, NULL, 4),
(221596, NULL, 'G3DSA:3.40.1050.10:FF:000024', NULL, NULL, 'Carbonic anhydrase, beta-family, clade B', NULL, NULL, NULL, NULL, NULL, 4),
(221597, NULL, 'G3DSA:6.20.200.30:FF:000002', NULL, NULL, 'GM24381', NULL, NULL, NULL, NULL, NULL, 4),
(221598, NULL, 'G3DSA:2.60.120.1540:FF:000024', NULL, NULL, 'Murinoglobulin-2', NULL, NULL, NULL, NULL, NULL, 4),
(221599, NULL, 'G3DSA:2.40.10.10:FF:000538', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221600, NULL, 'G3DSA:3.30.565.10:FF:000487', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221601, NULL, 'G3DSA:3.50.50.60:FF:000160', NULL, NULL, 'Glutamate synthase (NADPH)', NULL, NULL, NULL, NULL, NULL, 4),
(221602, NULL, 'G3DSA:1.50.40.10:FF:000126', NULL, NULL, 'Transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221603, NULL, 'G3DSA:3.30.70.330:FF:001100', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221604, NULL, 'G3DSA:3.60.110.10:FF:000104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221605, NULL, 'G3DSA:3.40.50.150:FF:000157', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(221606, NULL, 'G3DSA:3.10.110.10:FF:000352', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221607, NULL, 'G3DSA:2.30.29.30:FF:001150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221608, NULL, 'G3DSA:3.30.465.10:FF:000002', NULL, NULL, 'HlyC/CorC family transporter', NULL, NULL, NULL, NULL, NULL, 4),
(221609, NULL, 'G3DSA:3.40.390.10:FF:000314', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(221610, NULL, 'G3DSA:2.102.10.10:FF:000007', NULL, NULL, 'Cytochrome b6-f complex iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4),
(221611, NULL, 'G3DSA:3.30.900.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221612, NULL, 'G3DSA:3.40.50.300:FF:004721', NULL, NULL, 'Signal recognition particle 54 kDa protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(221613, NULL, 'G3DSA:3.60.21.10:FF:000335', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(221614, NULL, 'G3DSA:3.30.230.70:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221615, NULL, 'G3DSA:3.40.1410.10:FF:000007', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(221616, NULL, 'G3DSA:3.80.10.10:FF:000028', NULL, NULL, 'leucine-rich repeat-containing G-protein coupled receptor 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(221617, NULL, 'G3DSA:1.20.20.10:FF:000031', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221618, NULL, 'G3DSA:3.40.1380.10:FF:000009', NULL, NULL, 'ATP synthase F1 subunit gamma protein', NULL, NULL, NULL, NULL, NULL, 4),
(221619, NULL, 'G3DSA:1.10.3720.10:FF:000192', NULL, NULL, 'ABC transporter permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(221620, NULL, 'G3DSA:1.20.144.10:FF:000002', NULL, NULL, 'phospholipid phosphatase-related protein type 5', NULL, NULL, NULL, NULL, NULL, 4),
(221621, NULL, 'G3DSA:2.10.50.10:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221622, NULL, 'G3DSA:3.40.1810.10:FF:000004', NULL, NULL, 'MADS-box transcription factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(221623, NULL, 'G3DSA:1.20.58.2220:FF:000030', NULL, NULL, 'Formin 1', NULL, NULL, NULL, NULL, NULL, 4),
(221624, NULL, 'G3DSA:3.40.50.1440:FF:000066', NULL, NULL, 'Tubulin A', NULL, NULL, NULL, NULL, NULL, 4),
(221625, NULL, 'G3DSA:2.120.10.80:FF:000358', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221626, NULL, 'G3DSA:3.30.420.210:FF:000003', NULL, NULL, 'UBX domain protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(221627, NULL, 'G3DSA:2.60.40.60:FF:000621', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221628, NULL, 'G3DSA:3.30.70.1450:FF:000015', NULL, NULL, 'Trk system potassium uptake protein TrkA', NULL, NULL, NULL, NULL, NULL, 4),
(221629, NULL, 'G3DSA:2.70.150.10:FF:000159', NULL, NULL, 'Phospholipid-transporting ATPase IA, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221630, NULL, 'G3DSA:1.10.437.10:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221631, NULL, 'G3DSA:2.160.20.10:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221632, NULL, 'G3DSA:3.40.50.300:FF:008566', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221633, NULL, 'G3DSA:1.25.40.20:FF:001036', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(221634, NULL, 'G3DSA:3.40.640.10:FF:000519', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221635, NULL, 'G3DSA:3.30.1240.10:FF:000030', NULL, NULL, 'Cof family protein', NULL, NULL, NULL, NULL, NULL, 4),
(221636, NULL, 'G3DSA:2.40.50.140:FF:001226', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221637, NULL, 'G3DSA:1.10.8.10:FF:000327', NULL, NULL, 'Ubiquitin specific protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221638, NULL, 'G3DSA:2.40.50.100:FF:000169', NULL, NULL, 'YALI0E33121p', NULL, NULL, NULL, NULL, NULL, 4),
(221639, NULL, 'G3DSA:1.10.510.10:FF:000423', NULL, NULL, 'Putative receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(221640, NULL, 'G3DSA:2.130.10.10:FF:003142', NULL, NULL, 'Coatomer subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(221641, NULL, 'G3DSA:1.10.510.10:FF:003846', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221642, NULL, 'G3DSA:1.25.40.10:FF:000527', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g04780, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(221643, NULL, 'G3DSA:1.20.1250.20:FF:000234', NULL, NULL, 'Solute carrier family 2 member 10', NULL, NULL, NULL, NULL, NULL, 4),
(221644, NULL, 'G3DSA:1.25.40.10:FF:004810', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221645, NULL, 'G3DSA:3.40.50.620:FF:000675', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221646, NULL, 'G3DSA:3.40.50.2000:FF:001083', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221647, NULL, 'G3DSA:3.40.1180.10:FF:000028', NULL, NULL, 'Undecaprenyl pyrophosphate synthetase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(221648, NULL, 'G3DSA:3.20.20.100:FF:000012', NULL, NULL, 'Glutamate--cysteine ligase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(221649, NULL, 'G3DSA:3.20.20.140:FF:000451', NULL, NULL, 'AMP deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(221650, NULL, 'G3DSA:3.40.50.300:FF:005576', NULL, NULL, 'Regulator of telomere elongation helicase 1', NULL, NULL, NULL, NULL, NULL, 4),
(221651, NULL, 'G3DSA:1.10.287.70:FF:000573', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221652, NULL, 'G3DSA:3.30.160.60:FF:000972', NULL, NULL, 'Zinc finger protein 768', NULL, NULL, NULL, NULL, NULL, 4),
(221653, NULL, 'G3DSA:3.10.350.10:FF:000015', NULL, NULL, 'LysM peptidoglycan-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(221654, NULL, 'G3DSA:2.30.30.40:FF:000616', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221655, NULL, 'G3DSA:1.10.510.10:FF:002565', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221656, NULL, 'G3DSA:1.10.246.90:FF:000012', NULL, NULL, 'Nucleolar protein NOP5', NULL, NULL, NULL, NULL, NULL, 4),
(221657, NULL, 'G3DSA:3.30.9.10:FF:000207', NULL, NULL, 'D-amino acid oxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221658, NULL, 'G3DSA:1.25.10.10:FF:000244', NULL, NULL, 'Nonsense-mediated mRNA decay protein', NULL, NULL, NULL, NULL, NULL, 4),
(221659, NULL, 'G3DSA:2.60.40.790:FF:000060', NULL, NULL, 'Nuclear movement protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221660, NULL, 'G3DSA:1.10.238.10:FF:000048', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(221661, NULL, 'G3DSA:1.10.274.30:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221662, NULL, 'G3DSA:2.10.25.10:FF:000725', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(221663, NULL, 'G3DSA:3.30.70.1740:FF:000001', NULL, NULL, 'BofC domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(221664, NULL, 'G3DSA:3.10.180.10:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221665, NULL, 'G3DSA:3.40.50.1010:FF:000156', NULL, NULL, 'RNA-binding protein NOB1', NULL, NULL, NULL, NULL, NULL, 4),
(221666, NULL, 'G3DSA:1.10.150.50:FF:000216', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221667, NULL, 'G3DSA:3.30.160.60:FF:004900', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221668, NULL, 'G3DSA:3.30.1310.10:FF:000013', NULL, NULL, 'Nucleoid-associated protein CO678_37690', NULL, NULL, NULL, NULL, NULL, 4),
(221669, NULL, 'G3DSA:3.30.200.20:FF:000138', NULL, NULL, 'Phosphorylase b kinase gamma catalytic chain, liver/testis', NULL, NULL, NULL, NULL, NULL, 4),
(221670, NULL, 'G3DSA:1.20.1250.20:FF:001662', NULL, NULL, 'MFS multidrug transporter, putative (AFU_orthologue AFUA_6G07320)', NULL, NULL, NULL, NULL, NULL, 4),
(221671, NULL, 'G3DSA:3.40.50.300:FF:006537', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221672, NULL, 'G3DSA:2.60.40.150:FF:000003', NULL, NULL, 'Regulating synaptic membrane exocytosis protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(221673, NULL, 'G3DSA:3.40.50.300:FF:005817', NULL, NULL, 'Pyridoxal phosphate-dependent transferase', NULL, NULL, NULL, NULL, NULL, 4),
(221674, NULL, 'G3DSA:1.10.238.10:FF:000493', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(221675, NULL, 'G3DSA:2.130.10.10:FF:004570', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221676, NULL, 'G3DSA:3.80.10.10:FF:000130', NULL, NULL, 'extracellular matrix protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(221677, NULL, 'G3DSA:3.80.10.10:FF:001208', NULL, NULL, 'U2 small nuclear ribonucleoprotein A', NULL, NULL, NULL, NULL, NULL, 4),
(221678, NULL, 'G3DSA:1.10.167.10:FF:000063', NULL, NULL, 'Regulator of G-protein signaling 1', NULL, NULL, NULL, NULL, NULL, 4),
(221679, NULL, 'G3DSA:1.10.8.10:FF:000086', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(221680, NULL, 'G3DSA:3.40.47.10:FF:000126', NULL, NULL, 'Protein CBG20965', NULL, NULL, NULL, NULL, NULL, 4),
(221681, NULL, 'G3DSA:3.40.1230.10:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221682, NULL, 'G3DSA:1.25.40.20:FF:000625', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221683, NULL, 'G3DSA:1.25.10.10:FF:001868', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(221684, NULL, 'G3DSA:2.60.40.10:FF:005204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221685, NULL, 'G3DSA:3.30.1370.10:FF:000034', NULL, NULL, 'synaptic functional regulator FMR1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(221686, NULL, 'G3DSA:3.30.565.10:FF:000386', NULL, NULL, 'DNA mismatch repair protein domain', NULL, NULL, NULL, NULL, NULL, 4),
(221687, NULL, 'G3DSA:3.40.50.720:FF:000800', NULL, NULL, 'NmrA like redox sensor 1', NULL, NULL, NULL, NULL, NULL, 4),
(221688, NULL, 'G3DSA:2.60.40.640:FF:000043', NULL, NULL, 'pH-response regulator protein palF/RIM8', NULL, NULL, NULL, NULL, NULL, 4),
(221689, NULL, 'G3DSA:1.10.510.10:FF:004465', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221690, NULL, 'G3DSA:3.40.50.2300:FF:000902', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221691, NULL, 'G3DSA:1.10.150.20:FF:000320', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(221692, NULL, 'G3DSA:3.40.50.200:FF:000190', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221693, NULL, 'G3DSA:1.25.40.10:FF:002556', NULL, NULL, 'Kinetoplast_polyadenylation/uridylation_factor_1', NULL, NULL, NULL, NULL, NULL, 4),
(221694, NULL, 'G3DSA:2.130.10.10:FF:004103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221695, NULL, 'G3DSA:3.40.50.300:FF:008223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221696, NULL, 'G3DSA:3.40.50.300:FF:004637', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(221697, NULL, 'G3DSA:3.30.200.20:FF:001548', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221698, NULL, 'G3DSA:2.130.10.10:FF:003277', NULL, NULL, 'DIGIT', NULL, NULL, NULL, NULL, NULL, 4),
(221699, NULL, 'G3DSA:1.25.10.10:FF:002144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221700, NULL, 'G3DSA:1.25.40.10:FF:003618', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g74600, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(221701, NULL, 'G3DSA:2.130.10.10:FF:002866', NULL, NULL, 'Two-component system sensor histidine kinase/response regulator, hybrid (One component system)', NULL, NULL, NULL, NULL, NULL, 4),
(221702, NULL, 'G3DSA:3.40.30.10:FF:001094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221703, NULL, 'G3DSA:3.10.450.10:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221704, NULL, 'G3DSA:1.20.1560.10:FF:000575', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(221705, NULL, 'G3DSA:4.10.1060.10:FF:000065', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221706, NULL, 'G3DSA:2.60.40.10:FF:004687', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221707, NULL, 'G3DSA:1.20.1070.10:FF:000588', NULL, NULL, 'Go opsin', NULL, NULL, NULL, NULL, NULL, 4),
(221708, NULL, 'G3DSA:2.130.10.10:FF:002428', NULL, NULL, 'AGAP010693-PA', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(221709, NULL, 'G3DSA:2.60.120.200:FF:000022', NULL, NULL, 'receptor-type tyrosine-protein phosphatase U isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(221710, NULL, 'G3DSA:3.40.50.720:FF:001773', NULL, NULL, '2-dehydropantoate 2-reductase family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221711, NULL, 'G3DSA:1.20.1280.290:FF:000022', NULL, NULL, 'Cystinosin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(221712, NULL, 'G3DSA:2.170.270.10:FF:000228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221713, NULL, 'G3DSA:1.20.58.390:FF:000055', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(221714, NULL, 'G3DSA:3.90.176.10:FF:000013', NULL, NULL, 'NAD(P)(+)--arginine ADP-ribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(221715, NULL, 'G3DSA:3.40.1350.150:FF:000002', NULL, NULL, 'tRNA-splicing endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(221716, NULL, 'G3DSA:3.40.50.300:FF:007947', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221717, NULL, 'G3DSA:1.10.3710.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221718, NULL, 'G3DSA:3.10.290.10:FF:000066', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(221719, NULL, 'G3DSA:3.30.70.270:FF:000216', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221720, NULL, 'G3DSA:3.40.30.10:FF:000683', NULL, NULL, 'Glutathione S-transferase zeta 1', NULL, NULL, NULL, NULL, NULL, 4),
(221721, NULL, 'G3DSA:3.80.10.10:FF:003805', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221722, NULL, 'G3DSA:2.60.120.260:FF:000562', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221723, NULL, 'G3DSA:3.80.10.10:FF:001664', NULL, NULL, 'Secreted protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221724, NULL, 'G3DSA:2.130.10.10:FF:000404', NULL, NULL, 'Mitochondrial division protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(221725, NULL, 'G3DSA:2.130.10.10:FF:000528', NULL, NULL, 'POC1 centriolar protein homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(221726, NULL, 'G3DSA:2.40.340.10:FF:000012', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(221727, NULL, 'G3DSA:2.10.70.10:FF:000234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221728, NULL, 'G3DSA:3.30.420.40:FF:000334', NULL, NULL, 'Unplaced genomic scaffold supercont1.162, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(221729, NULL, 'G3DSA:1.25.40.10:FF:002213', NULL, NULL, 'AGAP011462-PA', NULL, NULL, NULL, NULL, NULL, 4),
(221730, NULL, 'G3DSA:2.60.120.200:FF:000460', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221731, NULL, 'G3DSA:3.30.60.20:FF:000048', NULL, NULL, 'Thymidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(221732, NULL, 'G3DSA:3.40.309.10:FF:000020', NULL, NULL, 'Ethanolamine utilization aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(221733, NULL, 'G3DSA:3.90.1410.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221734, NULL, 'G3DSA:3.40.50.300:FF:000585', NULL, NULL, 'Structural maintenance of chromosomes 4', NULL, NULL, NULL, NULL, NULL, 4),
(221735, NULL, 'G3DSA:3.20.20.70:FF:000010', NULL, NULL, '2-isopropylmalate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(221736, NULL, 'G3DSA:2.60.120.10:FF:000709', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(221737, NULL, 'G3DSA:2.40.170.20:FF:000086', NULL, NULL, 'Transporter, outer membrane receptor (OMR) family', NULL, NULL, NULL, NULL, NULL, 4),
(221738, NULL, 'G3DSA:1.25.10.10:FF:002487', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221739, NULL, 'G3DSA:1.10.238.10:FF:000150', NULL, NULL, 'Sodium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(221740, NULL, 'G3DSA:1.25.40.10:FF:001937', NULL, NULL, 'TPR-containing protein DDB_G0280363', NULL, NULL, NULL, NULL, NULL, 4),
(221741, NULL, 'G3DSA:1.20.1050.80:FF:000017', NULL, NULL, 'Vacuolar sorting protein 9 (VPS9) domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(221742, NULL, 'G3DSA:3.90.79.10:FF:000259', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221743, NULL, 'G3DSA:2.30.30.490:FF:000059', NULL, NULL, 'AGAP001099-PA', NULL, NULL, NULL, NULL, NULL, 4),
(221744, NULL, 'G3DSA:1.25.40.10:FF:001595', NULL, NULL, 'Pentatricopeptide repeat-containing protein 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(221745, NULL, 'G3DSA:1.20.1110.10:FF:000204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221746, NULL, 'G3DSA:1.25.40.10:FF:004113', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221747, NULL, 'G3DSA:3.30.70.1020:FF:000004', NULL, NULL, 'Trehalose 6-phosphate phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(221748, NULL, 'G3DSA:3.40.630.10:FF:000238', NULL, NULL, 'Cytosolic carboxypeptidase-like protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(221749, NULL, 'G3DSA:3.40.1110.10:FF:000434', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221750, NULL, 'G3DSA:1.20.950.20:FF:000013', NULL, NULL, 'Thioredoxin reductase', NULL, NULL, NULL, NULL, NULL, 4),
(221751, NULL, 'G3DSA:1.25.10.10:FF:000587', NULL, NULL, 'Kap120p', NULL, NULL, NULL, NULL, NULL, 4),
(221752, NULL, 'G3DSA:2.40.10.10:FF:000313', NULL, NULL, 'Serine protease easter-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(221753, NULL, 'G3DSA:3.30.1490.200:FF:000001', NULL, NULL, 'Lipoprotein antigen Tp47', NULL, NULL, NULL, NULL, NULL, 4),
(221754, NULL, 'G3DSA:2.40.10.10:FF:000437', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221755, NULL, 'G3DSA:3.90.550.10:FF:000164', NULL, NULL, 'Beta-(1-3)-glucosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(221756, NULL, 'G3DSA:3.30.200.20:FF:002280', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(221757, NULL, 'G3DSA:3.10.530.10:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221758, NULL, 'G3DSA:2.170.120.20:FF:000018', NULL, NULL, '50S ribosomal protein L25', NULL, NULL, NULL, NULL, NULL, 4),
(221759, NULL, 'G3DSA:3.40.30.10:FF:000245', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(221760, NULL, 'G3DSA:3.10.490.10:FF:000042', NULL, NULL, 'Gamma-L-glutamyl-butirosin B gamma-glutamyl cyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(221761, NULL, 'G3DSA:1.10.150.20:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221762, NULL, 'G3DSA:1.20.58.60:FF:000183', NULL, NULL, 'dystrophin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(221763, NULL, 'G3DSA:1.20.1250.20:FF:001083', NULL, NULL, 'Protein CBG14518', NULL, NULL, NULL, NULL, NULL, 4),
(221764, NULL, 'G3DSA:3.30.360.10:FF:000062', NULL, NULL, 'Uncharacterized oxidoreductase yrbe-like', NULL, NULL, NULL, NULL, NULL, 4),
(221765, NULL, 'G3DSA:1.10.510.10:FF:000412', NULL, NULL, 'Probable receptor-like serine/threonine-protein kinase At5g57670', NULL, NULL, NULL, NULL, NULL, 4),
(221766, NULL, 'G3DSA:1.20.58.60:FF:000306', NULL, NULL, 'Uncharacterized protein, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(221767, NULL, 'G3DSA:1.10.287.370:FF:000039', NULL, NULL, 'Probable prefoldin subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(221768, NULL, 'G3DSA:2.60.40.10:FF:000770', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(221769, NULL, 'G3DSA:3.30.1330.30:FF:000127', NULL, NULL, 'Ribosomal protein L7Ae, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221770, NULL, 'G3DSA:3.30.230.120:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221771, NULL, 'G3DSA:3.30.70.1170:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221772, NULL, 'G3DSA:1.20.1300.10:FF:000016', NULL, NULL, 'Succinate dehydrogenase membrane anchor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(221773, NULL, 'G3DSA:3.40.120.10:FF:000031', NULL, NULL, 'Phosphoglucomutase-like 5', NULL, NULL, NULL, NULL, NULL, 4),
(221774, NULL, 'G3DSA:3.50.50.60:FF:000266', NULL, NULL, 'Baeyer-Villiger monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(221775, NULL, 'G3DSA:2.60.40.60:FF:000290', NULL, NULL, 'Dachsous, isoform B', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(221776, NULL, 'G3DSA:2.10.90.10:FF:000123', NULL, NULL, 'Interleukin 17 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(221777, NULL, 'G3DSA:3.40.630.10:FF:000114', NULL, NULL, 'Nicalin', NULL, NULL, NULL, NULL, NULL, 4),
(221778, NULL, 'G3DSA:2.60.40.2440:FF:000007', NULL, NULL, 'Glc7p regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(221779, NULL, 'G3DSA:2.60.40.10:FF:001596', NULL, NULL, 'vesicle-associated protein 4-1-like', NULL, NULL, NULL, NULL, NULL, 4),
(221780, NULL, 'G3DSA:3.30.420.210:FF:000014', NULL, NULL, 'Ubxn-2', NULL, NULL, NULL, NULL, NULL, 4),
(221781, NULL, 'G3DSA:2.60.120.290:FF:000003', NULL, NULL, 'Neuropilin', NULL, NULL, NULL, NULL, NULL, 4),
(221782, NULL, 'G3DSA:2.120.10.90:FF:000018', NULL, NULL, 'DNA topoisomerase IV subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(221783, NULL, 'G3DSA:3.30.70.330:FF:001786', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221784, NULL, 'G3DSA:3.30.200.20:FF:000368', NULL, NULL, 'Interleukin-1 receptor-associated kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(221785, NULL, 'G3DSA:3.30.160.740:FF:000001', NULL, NULL, 'Isopropylmalate/homocitrate/citramalate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(221786, NULL, 'G3DSA:3.40.140.10:FF:000274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221787, NULL, 'G3DSA:1.10.630.10:FF:000022', NULL, NULL, 'Taxadiene 5-alpha hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(221788, NULL, 'G3DSA:1.10.8.60:FF:000426', NULL, NULL, 'Replication factor C small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(221789, NULL, 'G3DSA:2.40.160.50:FF:000021', NULL, NULL, 'Outer membrane protein assembly factor BamA', NULL, NULL, NULL, NULL, NULL, 4),
(221790, NULL, 'G3DSA:1.20.1720.10:FF:000110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221791, NULL, 'G3DSA:2.40.30.130:FF:000056', NULL, NULL, 'Alanine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(221792, NULL, 'G3DSA:3.40.640.10:FF:000396', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221793, NULL, 'G3DSA:3.40.390.10:FF:000073', NULL, NULL, 'Zinc metalloproteinase', NULL, NULL, NULL, NULL, NULL, 4),
(221794, NULL, 'G3DSA:3.40.50.300:FF:007251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221795, NULL, 'G3DSA:3.40.50.150:FF:000051', NULL, NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(221796, NULL, 'G3DSA:3.30.450.40:FF:000308', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(221797, NULL, 'G3DSA:3.40.30.10:FF:000806', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221798, NULL, 'G3DSA:3.30.497.10:FF:000109', NULL, NULL, 'Serpin peptidase inhibitor, clade B (ovalbumin), member 1', NULL, NULL, NULL, NULL, NULL, 4),
(221799, NULL, 'G3DSA:3.30.160.60:FF:000185', NULL, NULL, 'zinc finger protein 319', NULL, NULL, NULL, NULL, NULL, 4),
(221800, NULL, 'G3DSA:3.30.1490.220:FF:000007', NULL, NULL, 'Inositol-tetrakisphosphate 1-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(221801, NULL, 'G3DSA:2.110.10.10:FF:000001', NULL, NULL, 'Matrix metallopeptidase 24', NULL, NULL, NULL, NULL, NULL, 4),
(221802, NULL, 'G3DSA:3.10.310.50:FF:000002', NULL, NULL, 'TLP18.3, Psb32 and MOLO-1 founding proteins of phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221803, NULL, 'G3DSA:2.80.10.50:FF:000059', NULL, NULL, 'Probable alpha-L-arabinofuranosidase B', NULL, NULL, NULL, NULL, NULL, 4),
(221804, NULL, 'G3DSA:3.30.500.10:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221805, NULL, 'G3DSA:2.70.70.10:FF:000046', NULL, NULL, 'Peptidase, M23 family', NULL, NULL, NULL, NULL, NULL, 4),
(221806, NULL, 'G3DSA:1.20.1070.10:FF:000245', NULL, NULL, 'Alpha-2C adrenergic receptor', NULL, NULL, NULL, NULL, NULL, 4),
(221807, NULL, 'G3DSA:3.30.420.40:FF:000677', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221808, NULL, 'G3DSA:1.10.555.10:FF:000173', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221809, NULL, 'G3DSA:3.30.70.20:FF:000009', NULL, NULL, 'Formate dehydrogenase iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(221810, NULL, 'G3DSA:1.25.40.10:FF:004237', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221811, NULL, 'G3DSA:3.30.450.20:FF:000302', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(221812, NULL, 'G3DSA:3.30.559.30:FF:000080', NULL, NULL, 'Nonribosomal peptide synthase inpB', NULL, NULL, NULL, NULL, NULL, 4),
(221813, NULL, 'G3DSA:3.20.20.70:FF:000673', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221814, NULL, 'G3DSA:3.20.140.10:FF:000020', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(221815, NULL, 'G3DSA:3.30.160.60:FF:001944', NULL, NULL, 'Zinc finger protein 571', NULL, NULL, NULL, NULL, NULL, 4),
(221816, NULL, 'G3DSA:3.30.1390.20:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221817, NULL, 'G3DSA:1.10.510.10:FF:004122', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221818, NULL, 'G3DSA:3.90.230.10:FF:000016', NULL, NULL, 'Putative curved dna-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(221819, NULL, 'G3DSA:3.40.50.150:FF:000612', NULL, NULL, 'Protein-lysine methyltransferase METTL21B', NULL, NULL, NULL, NULL, NULL, 4),
(221820, NULL, 'G3DSA:3.30.470.30:FF:000059', NULL, NULL, 'mRNA-capping enzyme subunit alpha, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221821, NULL, 'G3DSA:3.30.1330.120:FF:000004', NULL, NULL, '2-methylcitrate dehydratase 2', NULL, NULL, NULL, NULL, NULL, 4),
(221822, NULL, 'G3DSA:2.40.33.10:FF:000006', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(221823, NULL, 'G3DSA:3.40.50.12650:FF:000044', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(221824, NULL, 'G3DSA:3.40.50.300:FF:002580', NULL, NULL, 'AGAP002836-PB', NULL, NULL, NULL, NULL, NULL, 4),
(221825, NULL, 'G3DSA:3.40.50.2300:FF:000239', NULL, NULL, 'Trehalose operon repressor', NULL, NULL, NULL, NULL, NULL, 4),
(221826, NULL, 'G3DSA:1.20.1560.10:FF:000232', NULL, NULL, 'Multidrug ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(221827, NULL, 'G3DSA:1.20.120.30:FF:000004', NULL, NULL, 'Diguanylate cyclase YdeH', NULL, NULL, NULL, NULL, NULL, 4),
(221828, NULL, 'G3DSA:3.90.640.10:FF:000278', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221829, NULL, 'G3DSA:2.70.130.10:FF:000040', NULL, NULL, 'Endoplasmic reticulum lectin 1-like isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(221830, NULL, 'G3DSA:2.40.180.10:FF:000010', NULL, NULL, 'lipoxygenase homology domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(221831, NULL, 'G3DSA:2.40.70.10:FF:000542', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221832, NULL, 'G3DSA:2.70.170.10:FF:000042', NULL, NULL, 'Blast:Glycine receptor subunit alpha-3', NULL, NULL, NULL, NULL, NULL, 4),
(221833, NULL, 'G3DSA:3.40.140.10:FF:000251', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221834, NULL, 'G3DSA:2.60.40.10:FF:000533', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(221835, NULL, 'G3DSA:4.10.1240.10:FF:000039', NULL, NULL, 'Corticotropin-releasing hormone receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(221836, NULL, 'G3DSA:1.20.5.340:FF:000075', NULL, NULL, 'Chromosome undetermined SCAF14470, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(221837, NULL, 'G3DSA:3.65.10.10:FF:000002', NULL, NULL, 'UDP-N-acetylglucosamine 1-carboxyvinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(221838, NULL, 'G3DSA:4.10.1240.10:FF:000051', NULL, NULL, 'Glucagon receptor a', NULL, NULL, NULL, NULL, NULL, 4),
(221839, NULL, 'G3DSA:3.40.50.300:FF:008454', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221840, NULL, 'G3DSA:3.40.50.300:FF:004165', NULL, NULL, 'Rho-related BTB domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(221841, NULL, 'G3DSA:2.60.120.920:FF:000018', NULL, NULL, 'SPRY domain-containing SOCS box protein 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(221842, NULL, 'G3DSA:3.40.50.170:FF:000034', NULL, NULL, 'Phosphoribosylglycinamide transformylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221843, NULL, 'G3DSA:3.40.50.11720:FF:000001', NULL, NULL, '3-deoxy-D-manno-octulosonic acid transferase', NULL, NULL, NULL, NULL, NULL, 4),
(221844, NULL, 'G3DSA:3.50.50.60:FF:000822', NULL, NULL, 'FAD-dependent pyridine nucleotide-disulfide oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(221845, NULL, 'G3DSA:1.10.8.720:FF:000011', NULL, NULL, 'Dynein beta chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221846, NULL, 'G3DSA:3.40.640.10:FF:000295', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(221847, NULL, 'G3DSA:2.20.70.10:FF:000020', NULL, NULL, 'WW domain-containing adapter protein with coiled-coil isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(221848, NULL, 'G3DSA:3.30.160.60:FF:001596', NULL, NULL, 'Zinc finger protein 1048', NULL, NULL, NULL, NULL, NULL, 4),
(221849, NULL, 'G3DSA:1.25.10.10:FF:002509', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221850, NULL, 'G3DSA:3.40.50.1000:FF:000720', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221851, NULL, 'G3DSA:3.40.50.300:FF:007942', NULL, NULL, 'Putative SNF2/RAD54 related DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(221852, NULL, 'G3DSA:2.30.30.140:FF:000319', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221853, NULL, 'G3DSA:3.90.70.10:FF:000841', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(221854, NULL, 'G3DSA:3.40.50.620:FF:000888', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221855, NULL, 'G3DSA:3.30.200.20:FF:001779', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(221856, NULL, 'G3DSA:3.40.850.10:FF:000013', NULL, NULL, 'unconventional myosin-IXa isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(221857, NULL, 'G3DSA:2.20.100.10:FF:000122', NULL, NULL, 'SCO-spondin', NULL, NULL, NULL, NULL, NULL, 4),
(221858, NULL, 'G3DSA:3.90.1150.10:FF:000009', NULL, NULL, 'Succinylornithine transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(221859, NULL, 'G3DSA:3.10.390.10:FF:000006', NULL, NULL, 'Autoimmune regulator', NULL, NULL, NULL, NULL, NULL, 4),
(221860, NULL, 'G3DSA:2.40.50.140:FF:000260', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(221861, NULL, 'G3DSA:3.40.830.10:FF:000006', NULL, NULL, '3,4-dihydroxyphenylacetate 2,3-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(221862, NULL, 'G3DSA:2.60.40.1180:FF:000028', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(221863, NULL, 'G3DSA:1.10.10.10:FF:000750', NULL, NULL, 'Protein CBG08819', NULL, NULL, NULL, NULL, NULL, 4),
(221864, NULL, 'G3DSA:2.130.10.10:FF:002653', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221865, NULL, 'G3DSA:3.60.15.10:FF:000052', NULL, NULL, 'tRNAse Z TRZ4, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(221866, NULL, 'G3DSA:1.25.40.1030:FF:000016', NULL, NULL, 'WD domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(221867, NULL, 'G3DSA:3.20.20.80:FF:000575', NULL, NULL, 'Beta-galactosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221868, NULL, 'G3DSA:2.30.30.940:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221869, NULL, 'G3DSA:1.20.1310.20:FF:000060', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(221870, NULL, 'G3DSA:3.40.30.60:FF:000001', NULL, NULL, 'Flagellar biosynthesis protein FlhA', NULL, NULL, NULL, NULL, NULL, 4),
(221871, NULL, 'G3DSA:3.40.50.1000:FF:000619', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221872, NULL, 'G3DSA:2.40.50.140:FF:000153', NULL, NULL, 'Elongation factor P', NULL, NULL, NULL, NULL, NULL, 4),
(221873, NULL, 'G3DSA:3.90.1170.10:FF:000016', NULL, NULL, '50S ribosomal protein L16', NULL, NULL, NULL, NULL, NULL, 4),
(221874, NULL, 'G3DSA:3.40.50.10190:FF:000166', NULL, NULL, 'PAX transcription activation domain interacting protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(221875, NULL, 'G3DSA:3.30.420.40:FF:000913', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221876, NULL, 'G3DSA:1.50.10.10:FF:000175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221877, NULL, 'G3DSA:2.60.40.420:FF:000101', NULL, NULL, 'Multicopper oxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221878, NULL, 'G3DSA:3.30.230.10:FF:000081', NULL, NULL, 'Ribosome biogenesis protein Ria1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(221879, NULL, 'G3DSA:1.10.1200.10:FF:000028', NULL, NULL, 'Nonribosomal peptide synthetase 13', NULL, NULL, NULL, NULL, NULL, 4),
(221880, NULL, 'G3DSA:3.80.10.10:FF:003333', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221881, NULL, 'G3DSA:2.60.40.10:FF:000539', NULL, NULL, 'striated muscle preferentially expressed protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(221882, NULL, 'G3DSA:1.20.1250.40:FF:000009', NULL, NULL, 'Dna-directed rna polymerase ii subunit rpb4-like', NULL, NULL, NULL, NULL, NULL, 4),
(221883, NULL, 'G3DSA:3.30.200.20:FF:000582', NULL, NULL, 'Os04g0370900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(221884, NULL, 'G3DSA:3.30.530.20:FF:000117', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221885, NULL, 'G3DSA:1.25.40.20:FF:000412', NULL, NULL, 'Ankyrin repeat-containing protein ITN1 isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(221886, NULL, 'G3DSA:3.30.160.60:FF:004344', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221887, NULL, 'G3DSA:2.130.10.10:FF:002760', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221888, NULL, 'G3DSA:3.80.10.10:FF:000478', NULL, NULL, 'Leucine-rich repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(221889, NULL, 'G3DSA:2.60.40.10:FF:000640', NULL, NULL, 'semaphorin-7A isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(221890, NULL, 'G3DSA:2.60.40.1180:FF:000040', NULL, NULL, 'Maltodextrin glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(221891, NULL, 'G3DSA:1.20.1740.10:FF:000229', NULL, NULL, 'Gll1652 protein', NULL, NULL, NULL, NULL, NULL, 4),
(221892, NULL, 'G3DSA:3.30.460.20:FF:000011', NULL, NULL, 'Manganese resistance', NULL, NULL, NULL, NULL, NULL, 4),
(221893, NULL, 'G3DSA:3.30.70.330:FF:000830', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(221894, NULL, 'G3DSA:1.10.533.10:FF:000004', NULL, NULL, 'Death effector domain-containing protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(221895, NULL, 'G3DSA:1.25.40.20:FF:000305', NULL, NULL, 'Death associated protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(221896, NULL, 'G3DSA:1.20.1270.10:FF:000013', NULL, NULL, 'Hypoxia up-regulated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(221897, NULL, 'G3DSA:3.40.50.10470:FF:000036', NULL, NULL, 'Translation initiation factor eIF-2B alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(221898, NULL, 'G3DSA:1.25.10.10:FF:000800', NULL, NULL, 'Disheveled-associated activator of morphogenesis', NULL, NULL, NULL, NULL, NULL, 4),
(221899, NULL, 'G3DSA:3.80.10.10:FF:003226', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221900, NULL, 'G3DSA:3.40.720.10:FF:000352', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221901, NULL, 'G3DSA:2.130.10.10:FF:006020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221902, NULL, 'G3DSA:2.80.10.50:FF:000065', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(221903, NULL, 'G3DSA:3.40.30.10:FF:000470', NULL, NULL, 'NADH-quinone oxidoreductase subunit F', NULL, NULL, NULL, NULL, NULL, 4),
(221904, NULL, 'G3DSA:3.40.50.150:FF:000713', NULL, NULL, 'Bactin polyketide/non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(221905, NULL, 'G3DSA:1.10.287.70:FF:000786', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221906, NULL, 'G3DSA:1.10.630.10:FF:000814', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221907, NULL, 'G3DSA:3.50.50.60:FF:001441', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(221908, NULL, 'G3DSA:3.30.9.10:FF:000090', NULL, NULL, 'Pyruvate Dehydrogenase Phosphatase Regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(221909, NULL, 'G3DSA:2.40.160.50:FF:000009', NULL, NULL, 'Putative hemolysin activator protein', NULL, NULL, NULL, NULL, NULL, 4),
(221910, NULL, 'G3DSA:3.50.50.60:FF:001334', NULL, NULL, 'Protein CBG18666', NULL, NULL, NULL, NULL, NULL, 4),
(221911, NULL, 'G3DSA:1.10.10.60:FF:000169', NULL, NULL, 'DNA-binding protein SATB1', NULL, NULL, NULL, NULL, NULL, 4),
(221912, NULL, 'G3DSA:1.25.40.20:FF:001828', NULL, NULL, 'Poly [ADP-ribose] polymerase tankyrase', NULL, NULL, NULL, NULL, NULL, 4),
(221913, NULL, 'G3DSA:3.10.20.770:FF:000001', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit gamma isoform', NULL, NULL, NULL, NULL, NULL, 4),
(221914, NULL, 'G3DSA:2.60.120.920:FF:000125', NULL, NULL, 'Zn-finger in Ran binding protein and others/SPRY domain/HECT-domain (Ubiquitin-transferase), putative', NULL, NULL, NULL, NULL, NULL, 4),
(221915, NULL, 'G3DSA:3.40.50.300:FF:000910', NULL, NULL, 'probable ATP-dependent DNA helicase DDX11', NULL, NULL, NULL, NULL, NULL, 4),
(221916, NULL, 'G3DSA:1.25.40.10:FF:001932', NULL, NULL, 'Tetratricopeptide repeat domain 17', NULL, NULL, NULL, NULL, NULL, 4),
(221917, NULL, 'G3DSA:1.10.132.60:FF:000037', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(221918, NULL, 'G3DSA:3.30.160.60:FF:006379', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221919, NULL, 'G3DSA:1.10.510.10:FF:004234', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221920, NULL, 'G3DSA:1.25.40.1010:FF:000010', NULL, NULL, 'Peptide alpha-N-acetyltransferase complex A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(221921, NULL, 'G3DSA:3.30.160.60:FF:000977', NULL, NULL, 'Zinc finger protein 641', NULL, NULL, NULL, NULL, NULL, 4),
(221922, NULL, 'G3DSA:1.20.990.10:FF:000018', NULL, NULL, 'Sulfite reductase [NADPH] flavoprotein alpha-component', NULL, NULL, NULL, NULL, NULL, 4),
(221923, NULL, 'G3DSA:1.10.630.10:FF:000707', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221924, NULL, 'G3DSA:3.40.1110.10:FF:000198', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(221925, NULL, 'G3DSA:2.60.120.260:FF:000242', NULL, NULL, 'Alpha-L-arabinofuranosidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(221926, NULL, 'G3DSA:1.10.287.70:FF:000679', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221927, NULL, 'G3DSA:1.10.10.60:FF:000276', NULL, NULL, 'Transcriptional regulator, AraC family', NULL, NULL, NULL, NULL, NULL, 4),
(221928, NULL, 'G3DSA:3.50.50.60:FF:001227', NULL, NULL, 'Flavin-containing monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(221929, NULL, 'G3DSA:2.60.40.150:FF:000109', NULL, NULL, 'BAI1-associated protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(221930, NULL, 'G3DSA:2.30.180.10:FF:000187', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221931, NULL, 'G3DSA:3.30.1330.30:FF:000133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221932, NULL, 'G3DSA:2.130.10.10:FF:001708', NULL, NULL, 'WD repeat-containing protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(221933, NULL, 'G3DSA:2.60.120.10:FF:000603', NULL, NULL, 'Pirin', NULL, NULL, NULL, NULL, NULL, 4),
(221934, NULL, 'G3DSA:3.90.70.10:FF:000604', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221935, NULL, 'G3DSA:1.10.150.240:FF:000018', NULL, NULL, 'Hydrolase, haloacid dehalogenase-like family', NULL, NULL, NULL, NULL, NULL, 4),
(221936, NULL, 'G3DSA:3.10.170.20:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221937, NULL, 'G3DSA:3.90.79.10:FF:000147', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(221938, NULL, 'G3DSA:3.40.50.1100:FF:000076', NULL, NULL, 'Threonine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(221939, NULL, 'G3DSA:1.25.40.70:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221940, NULL, 'G3DSA:1.20.5.420:FF:000003', NULL, NULL, 'Immunoglobulin G-binding protein A', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(221941, NULL, 'G3DSA:3.30.200.20:FF:000475', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(221942, NULL, 'G3DSA:3.40.30.10:FF:000829', NULL, NULL, '2-hydroxychromene-2-carboxylate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(221943, NULL, 'G3DSA:1.20.1540.10:FF:000118', NULL, NULL, 'Peptidase, S54 (rhomboid) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(221944, NULL, 'G3DSA:3.40.50.2300:FF:000234', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(221945, NULL, 'G3DSA:3.30.160.60:FF:000292', NULL, NULL, 'zinc finger protein 619', NULL, NULL, NULL, NULL, NULL, 4),
(221946, NULL, 'G3DSA:3.10.250.10:FF:000064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221947, NULL, 'G3DSA:3.30.200.20:FF:000363', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(221948, NULL, 'G3DSA:2.30.30.40:FF:000509', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(221949, NULL, 'G3DSA:3.30.70.330:FF:000611', NULL, NULL, 'serine/arginine-rich splicing factor RSZ22A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(221950, NULL, 'G3DSA:1.10.150.220:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221951, NULL, 'G3DSA:1.10.510.10:FF:004127', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221952, NULL, 'G3DSA:1.25.40.250:FF:000010', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit K', NULL, NULL, NULL, NULL, NULL, 4),
(221953, NULL, 'G3DSA:3.90.190.20:FF:000072', NULL, NULL, 'Folylpolyglutamate synthase, mitochondrial-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(221954, NULL, 'G3DSA:1.20.1560.10:FF:000676', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221955, NULL, 'G3DSA:3.40.33.10:FF:000167', NULL, NULL, 'Predicted extracellular protein', NULL, NULL, NULL, NULL, NULL, 4),
(221956, NULL, 'G3DSA:2.40.10.10:FF:000196', NULL, NULL, 'Putative low-density lipoprotein receptor', NULL, NULL, NULL, NULL, NULL, 4),
(221957, NULL, 'G3DSA:3.40.1670.10:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221958, NULL, 'G3DSA:3.40.50.150:FF:001332', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221959, NULL, 'G3DSA:3.80.10.10:FF:003440', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221960, NULL, 'G3DSA:2.40.10.10:FF:000201', NULL, NULL, 'RT07795p', NULL, NULL, NULL, NULL, NULL, 4),
(221961, NULL, 'G3DSA:3.30.2350.10:FF:000033', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(221962, NULL, 'G3DSA:1.10.400.10:FF:000078', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221963, NULL, 'G3DSA:2.40.10.10:FF:000190', NULL, NULL, 'Coagulation factor II (Thrombin)', NULL, NULL, NULL, NULL, NULL, 4),
(221964, NULL, 'G3DSA:3.40.140.100:FF:000005', NULL, NULL, 'GM19894', NULL, NULL, NULL, NULL, NULL, 4),
(221965, NULL, 'G3DSA:2.10.25.10:FF:000938', NULL, NULL, 'NIDogen (Basement membrane protein)', NULL, NULL, NULL, NULL, NULL, 4),
(221966, NULL, 'G3DSA:3.30.559.10:FF:000001', NULL, NULL, 'Carnitine O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(221967, NULL, 'G3DSA:2.130.10.10:FF:004558', NULL, NULL, 'Eukaryotic translation initiation factor 2A', NULL, NULL, NULL, NULL, NULL, 4),
(221968, NULL, 'G3DSA:3.90.470.10:FF:000006', NULL, NULL, '50S ribosomal protein L22, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(221969, NULL, 'G3DSA:3.60.40.10:FF:000357', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221970, NULL, 'G3DSA:3.40.50.1780:FF:000021', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NAR1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(221971, NULL, 'G3DSA:1.10.510.10:FF:002784', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221972, NULL, 'G3DSA:3.10.20.10:FF:000004', NULL, NULL, 'cell death activator CIDE-3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(221973, NULL, 'G3DSA:2.30.110.10:FF:000025', NULL, NULL, 'Puatative oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(221974, NULL, 'G3DSA:1.10.8.270:FF:000050', NULL, NULL, 'TBC1 domain family protein 5', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(221975, NULL, 'G3DSA:2.60.40.10:FF:001837', NULL, NULL, 'Roughest, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(221976, NULL, 'G3DSA:1.20.1250.20:FF:000695', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(221977, NULL, 'G3DSA:1.10.287.110:FF:000208', NULL, NULL, 'DNAJ family-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(221978, NULL, 'G3DSA:2.60.120.10:FF:000592', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221979, NULL, 'G3DSA:1.25.10.10:FF:002723', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221980, NULL, 'G3DSA:2.20.25.10:FF:000056', NULL, NULL, 'Multifunctional methyltransferase subunit TRM112-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(221981, NULL, 'G3DSA:4.10.410.10:FF:000067', NULL, NULL, 'GM18125', NULL, NULL, NULL, NULL, NULL, 4),
(221982, NULL, 'G3DSA:3.30.390.60:FF:000005', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(221983, NULL, 'G3DSA:3.30.160.60:FF:001489', NULL, NULL, 'Zinc finger protein interacting with ribonucleoprotein K', NULL, NULL, NULL, NULL, NULL, 4),
(221984, NULL, 'G3DSA:1.10.1420.10:FF:000016', NULL, NULL, 'mutS protein homolog 4', NULL, NULL, NULL, NULL, NULL, 4),
(221985, NULL, 'G3DSA:2.40.50.150:FF:000026', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(221986, NULL, 'G3DSA:1.10.10.10:FF:000519', NULL, NULL, 'RNA polymerase sigma factor sigA', NULL, NULL, NULL, NULL, NULL, 4),
(221987, NULL, 'G3DSA:3.40.50.10190:FF:000059', NULL, NULL, 'ATBRCA1', NULL, NULL, NULL, NULL, NULL, 4),
(221988, NULL, 'G3DSA:3.40.50.80:FF:000121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221989, NULL, 'G3DSA:3.40.930.10:FF:000047', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221990, NULL, 'G3DSA:3.30.420.10:FF:000466', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221991, NULL, 'G3DSA:3.10.170.20:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(221992, NULL, 'G3DSA:1.10.12.10:FF:000001', NULL, NULL, 'Probable enoyl-CoA hydratase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(221993, NULL, 'G3DSA:3.90.1150.10:FF:000110', NULL, NULL, 'Acetylornithine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(221994, NULL, 'G3DSA:3.40.850.10:FF:000120', NULL, NULL, 'Kinesin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(221995, NULL, 'G3DSA:2.60.40.10:FF:001152', NULL, NULL, 'Sallimus, isoform P', NULL, NULL, NULL, NULL, NULL, 4),
(221996, NULL, 'G3DSA:3.40.50.1000:FF:000850', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(221997, NULL, 'G3DSA:3.30.710.10:FF:000011', NULL, NULL, 'Kelch-like family member 13', NULL, NULL, NULL, NULL, NULL, 4),
(221998, NULL, 'G3DSA:3.20.20.10:FF:000026', NULL, NULL, 'D-threonine aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(221999, NULL, 'G3DSA:3.80.10.10:FF:002951', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222000, NULL, 'G3DSA:1.25.40.10:FF:002444', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g65570', NULL, NULL, NULL, NULL, NULL, 4),
(222001, NULL, 'G3DSA:1.10.20.10:FF:000008', NULL, NULL, 'Histone H2A', NULL, NULL, NULL, NULL, NULL, 4),
(222002, NULL, 'G3DSA:2.60.40.60:FF:000189', NULL, NULL, 'FAT atypical cadherin 4', NULL, NULL, NULL, NULL, NULL, 4),
(222003, NULL, 'G3DSA:3.40.50.300:FF:006531', NULL, NULL, 'GTP-binding nuclear protein Ran', NULL, NULL, NULL, NULL, NULL, 4),
(222004, NULL, 'G3DSA:1.20.1250.20:FF:002145', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222005, NULL, 'G3DSA:2.40.50.100:FF:000040', NULL, NULL, 'Efflux transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(222006, NULL, 'G3DSA:3.50.50.60:FF:000715', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222007, NULL, 'G3DSA:3.40.50.150:FF:000843', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222008, NULL, 'G3DSA:2.30.30.280:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(222009, NULL, 'G3DSA:2.170.120.30:FF:000004', NULL, NULL, 'YbbR-like lipoprotein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222010, NULL, 'G3DSA:3.40.50.720:FF:000244', NULL, NULL, 'quinone oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(222011, NULL, 'G3DSA:3.10.450.10:FF:000045', NULL, NULL, 'Cysteine proteinase inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(222012, NULL, 'G3DSA:2.160.10.10:FF:000021', NULL, NULL, 'dynactin subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(222013, NULL, 'G3DSA:2.60.40.4370:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222014, NULL, 'G3DSA:3.20.20.70:FF:000353', NULL, NULL, 'tRNA-dihydrouridine(20) synthase [NAD(P)+]-like', NULL, NULL, NULL, NULL, NULL, 4),
(222015, NULL, 'G3DSA:1.10.357.30:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222016, NULL, 'G3DSA:3.40.50.300:FF:002726', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NUBP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(222017, NULL, 'G3DSA:3.40.50.1700:FF:000054', NULL, NULL, 'Thermostable beta-glucosidase B', NULL, NULL, NULL, NULL, NULL, 4),
(222018, NULL, 'G3DSA:2.60.120.620:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222019, NULL, 'G3DSA:1.20.920.10:FF:000177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222020, NULL, 'G3DSA:1.10.472.10:FF:000070', NULL, NULL, 'CYCLIN D32', NULL, NULL, NULL, NULL, NULL, 4),
(222021, NULL, 'G3DSA:2.70.150.10:FF:000035', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(222022, NULL, 'G3DSA:1.25.10.10:FF:001767', NULL, NULL, 'Importin-9', NULL, NULL, NULL, NULL, NULL, 4),
(222023, NULL, 'G3DSA:2.30.30.30:FF:000040', NULL, NULL, 'Organellar elongation factor P', NULL, NULL, NULL, NULL, NULL, 4),
(222024, NULL, 'G3DSA:1.10.287.980:FF:000003', NULL, NULL, 'ATP synthase subunit c, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(222025, NULL, 'G3DSA:3.80.20.20:FF:000077', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222026, NULL, 'G3DSA:3.30.930.10:FF:000336', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222027, NULL, 'G3DSA:1.25.10.10:FF:001312', NULL, NULL, 'HEAT_repeat_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(222028, NULL, 'G3DSA:2.120.10.30:FF:000602', NULL, NULL, 'Subfamily S9C unassigned peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(222029, NULL, 'G3DSA:1.25.40.90:FF:000045', NULL, NULL, 'Ent5p', NULL, NULL, NULL, NULL, NULL, 4),
(222030, NULL, 'G3DSA:3.30.160.60:FF:005755', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222031, NULL, 'G3DSA:1.20.1250.20:FF:001763', NULL, NULL, 'Resistance protein, conjectural', NULL, NULL, NULL, NULL, NULL, 4),
(222032, NULL, 'G3DSA:1.10.8.60:FF:000185', NULL, NULL, 'CBN-MAC-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(222033, NULL, 'G3DSA:3.40.50.300:FF:008324', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222034, NULL, 'G3DSA:3.20.140.10:FF:000025', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(222035, NULL, 'G3DSA:1.10.150.20:FF:000213', NULL, NULL, 'DNA repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(222036, NULL, 'G3DSA:3.30.70.1470:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222037, NULL, 'G3DSA:3.30.70.3290:FF:000005', NULL, NULL, 'Phenolpthiocerol synthesis type-I polyketide synthase PPSE', NULL, NULL, NULL, NULL, NULL, 4),
(222038, NULL, 'G3DSA:2.120.10.80:FF:000122', NULL, NULL, 'tRNA wybutosine-synthesizing protein 2/3/4', NULL, NULL, NULL, NULL, NULL, 4),
(222039, NULL, 'G3DSA:3.80.10.10:FF:001309', NULL, NULL, 'Leucine-rich repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(222040, NULL, 'G3DSA:1.10.510.10:FF:000075', NULL, NULL, 'Serine/threonine-protein kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(222041, NULL, 'G3DSA:3.40.50.300:FF:005918', NULL, NULL, 'YALI0A19580p', NULL, NULL, NULL, NULL, NULL, 4),
(222042, NULL, 'G3DSA:1.20.5.1160:FF:000026', NULL, NULL, 'Protein CBR-IFB-2, isoform a', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(222043, NULL, 'G3DSA:1.10.287.110:FF:000315', NULL, NULL, 'Chaperone protein DNAj, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222044, NULL, 'G3DSA:3.30.160.60:FF:006031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222045, NULL, 'G3DSA:3.30.70.1170:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222046, NULL, 'G3DSA:1.25.40.180:FF:000197', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222047, NULL, 'G3DSA:3.30.70.920:FF:000001', NULL, NULL, 'Transcriptional regulator, AsnC family', NULL, NULL, NULL, NULL, NULL, 4),
(222048, NULL, 'G3DSA:1.20.1090.10:FF:000027', NULL, NULL, 'Iron-containing alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(222049, NULL, 'G3DSA:3.30.1600.10:FF:000013', NULL, NULL, 'NAD-dependent protein deacetylase sirtuin-1', NULL, NULL, NULL, NULL, NULL, 4),
(222050, NULL, 'G3DSA:3.40.718.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222051, NULL, 'G3DSA:3.40.50.720:FF:000351', NULL, NULL, 'Short chain dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(222052, NULL, 'G3DSA:3.90.950.10:FF:000032', NULL, NULL, 'Maf-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(222053, NULL, 'G3DSA:1.20.58.1190:FF:000001', NULL, NULL, 'Toxin B', NULL, NULL, NULL, NULL, NULL, 4),
(222054, NULL, 'G3DSA:1.10.10.10:FF:001132', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(222055, NULL, 'G3DSA:3.40.50.300:FF:004053', NULL, NULL, 'Dicer-like 3', NULL, NULL, NULL, NULL, NULL, 4),
(222056, NULL, 'G3DSA:3.30.70.330:FF:002409', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222057, NULL, 'G3DSA:3.40.50.300:FF:000017', NULL, NULL, 'Disks large homolog 3 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(222058, NULL, 'G3DSA:2.120.10.30:FF:000591', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222059, NULL, 'G3DSA:3.30.310.130:FF:000027', NULL, NULL, 'DDE superfamily endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(222060, NULL, 'G3DSA:2.60.40.200:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222061, NULL, 'G3DSA:3.30.70.940:FF:000007', NULL, NULL, 'Transcription elongation factor SPT5', NULL, NULL, NULL, NULL, NULL, 4),
(222062, NULL, 'G3DSA:2.130.10.10:FF:002765', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222063, NULL, 'G3DSA:3.80.10.10:FF:003221', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222064, NULL, 'G3DSA:2.40.290.10:FF:000024', NULL, NULL, 'ATP-dependent DNA helicase II subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(222065, NULL, 'G3DSA:3.40.50.620:FF:000669', NULL, NULL, 'Valine--tRNA ligase mitochondrial 1', NULL, NULL, NULL, NULL, NULL, 4),
(222066, NULL, 'G3DSA:3.40.50.620:FF:000433', NULL, NULL, 'Electron transfer flavoprotein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(222067, NULL, 'G3DSA:2.10.70.10:FF:000009', NULL, NULL, 'Seizure related 6 homolog like', NULL, NULL, NULL, NULL, NULL, 4),
(222068, NULL, 'G3DSA:3.10.310.20:FF:000004', NULL, NULL, 'PPX1p Exopolyphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(222069, NULL, 'G3DSA:3.40.50.1820:FF:001484', NULL, NULL, 'Abhydrolase domain-containing 5b', NULL, NULL, NULL, NULL, NULL, 4),
(222070, NULL, 'G3DSA:3.40.630.10:FF:000007', NULL, NULL, 'Carboxypeptidase X (M14 family), member 1', NULL, NULL, NULL, NULL, NULL, 4),
(222071, NULL, 'G3DSA:3.40.50.620:FF:000776', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222072, NULL, 'G3DSA:3.30.70.330:FF:003028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222073, NULL, 'G3DSA:3.30.460.20:FF:000016', NULL, NULL, 'Magnesium transport protein CorA', NULL, NULL, NULL, NULL, NULL, 4),
(222074, NULL, 'G3DSA:1.25.40.10:FF:002899', NULL, NULL, 'Signal recognition particle subunit SRP72', NULL, NULL, NULL, NULL, NULL, 4),
(222075, NULL, 'G3DSA:1.10.357.10:FF:000010', NULL, NULL, 'HTH-type transcriptional regulator RutR', NULL, NULL, NULL, NULL, NULL, 4),
(222076, NULL, 'G3DSA:3.90.1290.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(222077, NULL, 'G3DSA:2.40.50.740:FF:000001', NULL, NULL, '40S ribosomal protein S4', NULL, NULL, NULL, NULL, NULL, 4),
(222078, NULL, 'G3DSA:1.20.120.350:FF:000048', NULL, NULL, 'Potassium voltage-gated channel modifier subfamily G member 3', NULL, NULL, NULL, NULL, NULL, 4),
(222079, NULL, 'G3DSA:3.40.50.300:FF:003783', NULL, NULL, 'Transitional endoplasmic reticulum ATPase TER94-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(222080, NULL, 'G3DSA:3.40.50.10810:FF:000189', NULL, NULL, 'SNF2 superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(222081, NULL, 'G3DSA:1.25.40.20:FF:000524', NULL, NULL, 'Ankyrin repeat domain 6b', NULL, NULL, NULL, NULL, NULL, 4),
(222082, NULL, 'G3DSA:2.60.120.10:FF:000608', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(222083, NULL, 'G3DSA:3.30.460.10:FF:000120', NULL, NULL, 'DNA nucleotidylexotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(222084, NULL, 'G3DSA:1.10.8.60:FF:000533', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222085, NULL, 'G3DSA:3.30.70.330:FF:002180', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222086, NULL, 'G3DSA:3.30.565.10:FF:000150', NULL, NULL, 'Putative heat shock protein HSP 90-beta 2', NULL, NULL, NULL, NULL, NULL, 4),
(222087, NULL, 'G3DSA:2.40.50.140:FF:000372', NULL, NULL, 'Replication factor A protein 3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222088, NULL, 'G3DSA:3.90.1150.10:FF:000228', NULL, NULL, 'Aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(222089, NULL, 'G3DSA:3.40.630.30:FF:000351', NULL, NULL, 'RNA cytidine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(222090, NULL, 'G3DSA:3.30.70.330:FF:002516', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222091, NULL, 'G3DSA:2.130.10.10:FF:005856', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222092, NULL, 'G3DSA:3.30.60.190:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222093, NULL, 'G3DSA:2.60.40.10:FF:002456', NULL, NULL, 'Sensory AXon guidance', NULL, NULL, NULL, NULL, NULL, 4),
(222094, NULL, 'G3DSA:3.10.20.90:FF:000320', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222095, NULL, 'G3DSA:3.60.15.10:FF:000057', NULL, NULL, 'Ribonuclease Z', NULL, NULL, NULL, NULL, NULL, 4),
(222096, NULL, 'G3DSA:2.130.10.110:FF:000018', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(222097, NULL, 'G3DSA:1.25.40.10:FF:001140', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(222098, NULL, 'G3DSA:3.90.550.10:FF:000518', NULL, NULL, 'Probable UDP-glucose:glycoprotein glucosyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(222099, NULL, 'G3DSA:3.30.160.60:FF:003962', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(222100, NULL, 'G3DSA:2.30.30.40:FF:000262', NULL, NULL, 'RUN and SH3 domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(222101, NULL, 'G3DSA:3.40.605.10:FF:000045', NULL, NULL, '1-pyrroline-5-carboxylate dehydrogenase 1', NULL, NULL, NULL, NULL, NULL, 4),
(222102, NULL, 'G3DSA:3.10.50.10:FF:000051', NULL, NULL, 'Chitinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222103, NULL, 'G3DSA:1.10.510.10:FF:003745', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222104, NULL, 'G3DSA:1.25.10.10:FF:002728', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222105, NULL, 'G3DSA:3.30.160.60:FF:000539', NULL, NULL, 'Putative zinc finger protein 131', NULL, NULL, NULL, NULL, NULL, 4),
(222106, NULL, 'G3DSA:3.30.1330.10:FF:000020', NULL, NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(222107, NULL, 'G3DSA:3.40.50.150:FF:001113', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222108, NULL, 'G3DSA:1.10.1660.10:FF:000006', NULL, NULL, 'Chaperone modulatory protein CbpM', NULL, NULL, NULL, NULL, NULL, 4),
(222109, NULL, 'G3DSA:2.130.10.10:FF:000287', NULL, NULL, 'WD repeat-containing protein 74', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(222110, NULL, 'G3DSA:3.40.50.620:FF:000091', NULL, NULL, 'Trifunctional nicotinamide-nucleotide adenylyltransferase/ribosylnicotinamide kinase/transcriptional regulator NadR', NULL, NULL, NULL, NULL, NULL, 4),
(222111, NULL, 'G3DSA:3.40.50.300:FF:001310', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222112, NULL, 'G3DSA:1.10.220.10:FF:000081', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(222113, NULL, 'G3DSA:3.40.50.300:FF:004957', NULL, NULL, 'Os10g0163290 protein', NULL, NULL, NULL, NULL, NULL, 4),
(222114, NULL, 'G3DSA:3.50.50.60:FF:000030', NULL, NULL, 'Glutathione reductase', NULL, NULL, NULL, NULL, NULL, 4),
(222115, NULL, 'G3DSA:1.20.140.150:FF:000088', NULL, NULL, 'Claudin-13', NULL, NULL, NULL, NULL, NULL, 4),
(222116, NULL, 'G3DSA:2.60.120.960:FF:000002', NULL, NULL, 'Spike glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(222117, NULL, 'G3DSA:2.40.20.10:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222118, NULL, 'G3DSA:2.170.210.10:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222119, NULL, 'G3DSA:3.65.10.10:FF:000007', NULL, NULL, 'Pentafunctional AROM polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(222120, NULL, 'G3DSA:1.25.40.10:FF:000864', NULL, NULL, 'Formin 1', NULL, NULL, NULL, NULL, NULL, 4),
(222121, NULL, 'G3DSA:1.25.40.10:FF:000078', NULL, NULL, 'Transcriptional corepressor Cyc8', NULL, NULL, NULL, NULL, NULL, 4),
(222122, NULL, 'G3DSA:2.30.29.30:FF:001155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222123, NULL, 'G3DSA:2.40.33.10:FF:000001', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(222124, NULL, 'G3DSA:3.90.226.10:FF:000029', NULL, NULL, 'Peptidase, S41 family', NULL, NULL, NULL, NULL, NULL, 4),
(222125, NULL, 'G3DSA:3.10.28.10:FF:000016', NULL, NULL, 'Pre-mRNA splicing factor (Prp8)', NULL, NULL, NULL, NULL, NULL, 4),
(222126, NULL, 'G3DSA:3.40.50.10810:FF:000060', NULL, NULL, 'DNA repair protein RAD5', NULL, NULL, NULL, NULL, NULL, 4),
(222127, NULL, 'G3DSA:3.30.420.10:FF:000578', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222128, NULL, 'G3DSA:3.30.1330.30:FF:000026', NULL, NULL, 'H/ACA ribonucleoprotein complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(222129, NULL, 'G3DSA:1.20.58.390:FF:000286', NULL, NULL, 'GABA-A receptor epsilon subunit', NULL, NULL, NULL, NULL, NULL, 4),
(222130, NULL, 'G3DSA:3.40.190.290:FF:000038', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(222131, NULL, 'G3DSA:3.40.50.300:FF:005233', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(222132, NULL, 'G3DSA:1.10.238.110:FF:000008', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(222133, NULL, 'G3DSA:2.10.25.10:FF:000141', NULL, NULL, 'Fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(222134, NULL, 'G3DSA:3.10.450.580:FF:000017', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(222135, NULL, 'G3DSA:2.10.25.10:FF:000034', NULL, NULL, 'Laminin subunit alpha 3', NULL, NULL, NULL, NULL, NULL, 4),
(222136, NULL, 'G3DSA:3.30.1490.20:FF:000074', NULL, NULL, 'Trifunctional purine biosynthetic protein adenosine-3', NULL, NULL, NULL, NULL, NULL, 4),
(222137, NULL, 'G3DSA:1.25.10.10:FF:001200', NULL, NULL, 'Uncharacterized conserved protein UCP005250', NULL, NULL, NULL, NULL, NULL, 4),
(222138, NULL, 'G3DSA:3.30.420.40:FF:000576', NULL, NULL, 'Heat shock protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222139, NULL, 'G3DSA:3.40.50.300:FF:000686', NULL, NULL, 'Multidrug ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(222140, NULL, 'G3DSA:2.60.120.1000:FF:000003', NULL, NULL, 'Collagen alpha-1(XXVII) chain B', NULL, NULL, NULL, NULL, NULL, 4),
(222141, NULL, 'G3DSA:2.130.10.30:FF:000051', NULL, NULL, 'Highwire, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(222142, NULL, 'G3DSA:1.25.40.10:FF:004349', NULL, NULL, 'PPIC-type PPIASE domain containing protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(222143, NULL, 'G3DSA:2.30.30.40:FF:000610', NULL, NULL, 'Chemotaxis protein CheZ', NULL, NULL, NULL, NULL, NULL, 4),
(222144, NULL, 'G3DSA:3.90.79.10:FF:000254', NULL, NULL, 'Zgc:103759', NULL, NULL, NULL, NULL, NULL, 4),
(222145, NULL, 'G3DSA:3.30.420.10:FF:000685', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222146, NULL, 'G3DSA:3.10.330.20:FF:000017', NULL, NULL, 'Putative trna methyltransferase complex gcd14 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(222147, NULL, 'G3DSA:3.90.1750.10:FF:000089', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222148, NULL, 'G3DSA:2.40.160.60:FF:000001', NULL, NULL, 'Long-chain fatty acid transporter FadL', NULL, NULL, NULL, NULL, NULL, 4),
(222149, NULL, 'G3DSA:2.60.40.2130:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222150, NULL, 'G3DSA:1.10.287.70:FF:000005', NULL, NULL, 'potassium voltage-gated channel subfamily G member 1', NULL, NULL, NULL, NULL, NULL, 4),
(222151, NULL, 'G3DSA:2.40.30.170:FF:000040', NULL, NULL, 'Efflux transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(222152, NULL, 'G3DSA:1.10.10.10:FF:001688', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(222153, NULL, 'G3DSA:3.40.47.10:FF:000103', NULL, NULL, '3,5-dihydroxyphenylacetyl-CoA synthase', NULL, NULL, NULL, NULL, NULL, 4),
(222154, NULL, 'G3DSA:1.20.1310.20:FF:000065', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(222155, NULL, 'G3DSA:1.10.1510.30:FF:000001', NULL, NULL, 'Pseudouridine synthase 7 like', NULL, NULL, NULL, NULL, NULL, 4),
(222156, NULL, 'G3DSA:1.10.1600.10:FF:000002', NULL, NULL, 'X-ray repair cross-complementing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(222157, NULL, 'G3DSA:3.10.450.40:FF:000043', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222158, NULL, 'G3DSA:3.40.50.300:FF:007150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222159, NULL, 'G3DSA:1.10.10.10:FF:002088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222160, NULL, 'G3DSA:3.40.50.1820:FF:001247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222161, NULL, 'G3DSA:1.10.287.3510:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222162, NULL, 'G3DSA:1.10.533.10:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222163, NULL, 'G3DSA:2.60.120.200:FF:000696', NULL, NULL, 'Protein S', NULL, NULL, NULL, NULL, NULL, 4),
(222164, NULL, 'G3DSA:3.40.50.300:FF:006874', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222165, NULL, 'G3DSA:1.10.238.10:FF:001010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222166, NULL, 'G3DSA:3.60.21.10:FF:000442', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(222167, NULL, 'G3DSA:2.10.25.10:FF:000826', NULL, NULL, 'Hemolectin', NULL, NULL, NULL, NULL, NULL, 4),
(222168, NULL, 'G3DSA:3.30.160.60:FF:000180', NULL, NULL, 'Zinc finger protein 689', NULL, NULL, NULL, NULL, NULL, 4),
(222169, NULL, 'G3DSA:1.20.930.10:FF:000003', NULL, NULL, 'Putative Transcription factor IWS1', NULL, NULL, NULL, NULL, NULL, 4),
(222170, NULL, 'G3DSA:2.60.40.60:FF:000301', NULL, NULL, 'protocadherin-7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(222171, NULL, 'G3DSA:3.40.50.300:FF:000809', NULL, NULL, 'ATP-dependent RNA helicase SUB2', NULL, NULL, NULL, NULL, NULL, 4),
(222172, NULL, 'G3DSA:3.30.70.1050:FF:000007', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(222173, NULL, 'G3DSA:1.20.1070.10:FF:000829', NULL, NULL, 'Melatonin receptor type 1A', NULL, NULL, NULL, NULL, NULL, 4),
(222174, NULL, 'G3DSA:3.90.70.10:FF:000734', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222175, NULL, 'G3DSA:3.80.20.20:FF:000072', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(222176, NULL, 'G3DSA:3.10.180.10:FF:000070', NULL, NULL, 'Methylmalonyl-CoA epimerase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(222177, NULL, 'G3DSA:3.30.60.30:FF:000045', NULL, NULL, 'Serine protease inhibitor dipetalogastin', NULL, NULL, NULL, NULL, NULL, 4),
(222178, NULL, 'G3DSA:1.10.20.140:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222179, NULL, 'G3DSA:3.40.50.300:FF:004614', NULL, NULL, 'Fanconi anemia group J protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(222180, NULL, 'G3DSA:1.20.58.390:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222181, NULL, 'G3DSA:2.30.42.10:FF:000281', NULL, NULL, 'Usher syndrome 1C', NULL, NULL, NULL, NULL, NULL, 4),
(222182, NULL, 'G3DSA:3.30.160.60:FF:004581', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222183, NULL, 'G3DSA:1.10.238.10:FF:000734', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222184, NULL, 'G3DSA:1.10.1200.270:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222185, NULL, 'G3DSA:1.10.287.1080:FF:000006', NULL, NULL, 'Hypothetical Cytosolic Protein', NULL, NULL, NULL, NULL, NULL, 4),
(222186, NULL, 'G3DSA:1.10.560.10:FF:000134', NULL, NULL, 'Chaperonin Cpn60', NULL, NULL, NULL, NULL, NULL, 4),
(222187, NULL, 'G3DSA:3.60.21.10:FF:000094', NULL, NULL, 'Acid phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(222188, NULL, 'G3DSA:1.20.1070.10:FF:000487', NULL, NULL, 'EG:22E5.10 protein', NULL, NULL, NULL, NULL, NULL, 4),
(222189, NULL, 'G3DSA:3.40.50.300:FF:004272', NULL, NULL, 'Rab_C99 protein', NULL, NULL, NULL, NULL, NULL, 4),
(222190, NULL, 'G3DSA:2.130.10.10:FF:003939', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222191, NULL, 'G3DSA:2.60.120.330:FF:000162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222192, NULL, 'G3DSA:2.30.330.10:FF:000002', NULL, NULL, 'Flagellar motor switch protein FliN', NULL, NULL, NULL, NULL, NULL, 4),
(222193, NULL, 'G3DSA:3.10.20.90:FF:000078', NULL, NULL, 'Auxin-responsive protein', NULL, NULL, NULL, NULL, NULL, 4),
(222194, NULL, 'G3DSA:2.60.120.10:FF:000485', NULL, NULL, 'Cyclic nucleotide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(222195, NULL, 'G3DSA:3.30.160.60:FF:004451', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222196, NULL, 'G3DSA:3.30.40.10:FF:001685', NULL, NULL, 'RING zinc finger-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(222197, NULL, 'G3DSA:1.10.510.10:FF:000648', NULL, NULL, 'Mitotic checkpoint serine/threonine-protein kinase BUB1', NULL, NULL, NULL, NULL, NULL, 4),
(222198, NULL, 'G3DSA:3.40.50.1820:FF:000758', NULL, NULL, 'Alpha/beta hydrolase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(222199, NULL, 'G3DSA:1.20.1070.10:FF:001318', NULL, NULL, 'C3a anaphylatoxin chemotactic receptor', NULL, NULL, NULL, NULL, NULL, 4),
(222200, NULL, 'G3DSA:1.20.1250.20:FF:001307', NULL, NULL, 'Major facilitator superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(222201, NULL, 'G3DSA:1.20.120.230:FF:000035', NULL, NULL, 'Alpha-catenin-like protein hmp-1', NULL, NULL, NULL, NULL, NULL, 4),
(222202, NULL, 'G3DSA:3.30.428.10:FF:000023', NULL, NULL, 'Adenylylsulfatase HINT3', NULL, NULL, NULL, NULL, NULL, 4),
(222203, NULL, 'G3DSA:3.20.20.80:FF:000794', NULL, NULL, 'Secreted alpha-amylase', NULL, NULL, NULL, NULL, NULL, 4),
(222204, NULL, 'G3DSA:1.10.238.10:FF:000386', NULL, NULL, 'Calmodulin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(222205, NULL, 'G3DSA:3.30.70.370:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222206, NULL, 'G3DSA:1.20.272.10:FF:000041', NULL, NULL, 'DNA polymerase III subunit gamma/tau', NULL, NULL, NULL, NULL, NULL, 4),
(222207, NULL, 'G3DSA:2.10.25.10:FF:001445', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222208, NULL, 'G3DSA:1.10.8.710:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222209, NULL, 'G3DSA:2.20.230.10:FF:000002', NULL, NULL, 'Beta-galactosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222210, NULL, 'G3DSA:2.10.25.10:FF:001102', NULL, NULL, 'Transmembrane cell adhesion receptor mua-3', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(222211, NULL, 'G3DSA:3.10.50.40:FF:000149', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(222212, NULL, 'G3DSA:2.130.10.10:FF:004339', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222213, NULL, 'G3DSA:4.10.60.10:FF:000268', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222214, NULL, 'G3DSA:1.10.510.10:FF:000867', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222215, NULL, 'G3DSA:1.25.40.510:FF:000009', NULL, NULL, 'Polyadenylated-RNA export factor', NULL, NULL, NULL, NULL, NULL, 4),
(222216, NULL, 'G3DSA:3.40.50.720:FF:001312', NULL, NULL, 'UDP-glucose 4-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(222217, NULL, 'G3DSA:3.40.50.720:FF:002498', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(222218, NULL, 'G3DSA:3.40.50.300:FF:003108', NULL, NULL, 'RecBCD enzyme subunit RecC', NULL, NULL, NULL, NULL, NULL, 4),
(222219, NULL, 'G3DSA:2.60.40.1770:FF:000003', NULL, NULL, 'ephrin type-B receptor 4', NULL, NULL, NULL, NULL, NULL, 4),
(222220, NULL, 'G3DSA:2.60.40.60:FF:000644', NULL, NULL, 'AGAP004166-PA', NULL, NULL, NULL, NULL, NULL, 4),
(222221, NULL, 'G3DSA:3.10.290.10:FF:000061', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(222222, NULL, 'G3DSA:1.20.1320.30:FF:000001', NULL, NULL, 'Interferon-induced with helicase C domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(222223, NULL, 'G3DSA:3.40.190.10:FF:000440', NULL, NULL, 'Uncharacterized solute-binding protein MA_0280', NULL, NULL, NULL, NULL, NULL, 4),
(222224, NULL, 'G3DSA:3.40.50.2300:FF:000453', NULL, NULL, 'Pilus assembly protein', NULL, NULL, NULL, NULL, NULL, 4),
(222225, NULL, 'G3DSA:1.10.238.10:FF:001223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222226, NULL, 'G3DSA:2.60.450.10:FF:000021', NULL, NULL, 'Lipopolysaccharide ABC transporter, periplasmic protein LptC', NULL, NULL, NULL, NULL, NULL, 4),
(222227, NULL, 'G3DSA:1.20.1070.10:FF:001448', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222228, NULL, 'G3DSA:1.20.1250.20:FF:000818', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222229, NULL, 'G3DSA:1.20.1250.10:FF:000130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222230, NULL, 'G3DSA:3.40.30.10:FF:000582', NULL, NULL, '2-hydroxychromene-2-carboxylate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(222231, NULL, 'G3DSA:3.30.160.60:FF:001141', NULL, NULL, 'Zinc finger protein 473', NULL, NULL, NULL, NULL, NULL, 4),
(222232, NULL, 'G3DSA:3.30.160.60:FF:005070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222233, NULL, 'G3DSA:3.40.50.300:FF:007493', NULL, NULL, 'ATP-dependent RNA helicase mss116, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(222234, NULL, 'G3DSA:1.25.10.10:FF:000930', NULL, NULL, 'Heat repeat domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(222235, NULL, 'G3DSA:2.130.10.10:FF:004215', NULL, NULL, 'LD21275p', NULL, NULL, NULL, NULL, NULL, 4),
(222236, NULL, 'G3DSA:1.10.287.940:FF:000002', NULL, NULL, 'P2X purinoceptor', NULL, NULL, NULL, NULL, NULL, 4),
(222237, NULL, 'G3DSA:3.30.40.10:FF:001229', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(222238, NULL, 'G3DSA:2.40.110.10:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222239, NULL, 'G3DSA:3.30.200.20:FF:001543', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222240, NULL, 'G3DSA:1.10.287.70:FF:000674', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222241, NULL, 'G3DSA:3.40.190.10:FF:000092', NULL, NULL, 'HTH-type transcriptional regulator YidZ', NULL, NULL, NULL, NULL, NULL, 4),
(222242, NULL, 'G3DSA:1.25.40.10:FF:002551', NULL, NULL, 'Pentatricopeptide (PPR) repeat-containing protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(222243, NULL, 'G3DSA:2.60.40.60:FF:000296', NULL, NULL, 'Cadherin 74A, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(222244, NULL, 'G3DSA:1.25.40.660:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(222245, NULL, 'G3DSA:1.20.120.1750:FF:000149', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(222246, NULL, 'G3DSA:3.40.50.300:FF:007835', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222247, NULL, 'G3DSA:3.40.50.1100:FF:000183', NULL, NULL, 'Related to L-serine dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(222248, NULL, 'G3DSA:2.20.70.10:FF:000256', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222249, NULL, 'G3DSA:3.30.160.60:FF:005412', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222250, NULL, 'G3DSA:2.170.130.10:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222251, NULL, 'G3DSA:3.30.497.10:FF:000098', NULL, NULL, 'Serpin family B member 13', NULL, NULL, NULL, NULL, NULL, 4),
(222252, NULL, 'G3DSA:1.20.5.1030:FF:000004', NULL, NULL, 'Protein translocase subunit SecE', NULL, NULL, NULL, NULL, NULL, 4),
(222253, NULL, 'G3DSA:1.25.40.10:FF:000639', NULL, NULL, 'Pre-mRNA-splicing factor CLF1', NULL, NULL, NULL, NULL, NULL, 4),
(222254, NULL, 'G3DSA:3.90.640.10:FF:000042', NULL, NULL, 'Heat shock 70 kDa protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(222255, NULL, 'G3DSA:1.10.287.1490:FF:000011', NULL, NULL, 'citron Rho-interacting kinase isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(222256, NULL, 'G3DSA:1.10.10.10:FF:001020', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(222257, NULL, 'G3DSA:3.30.1370.70:FF:000006', NULL, NULL, 'HIRA-interacting protein 5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222258, NULL, 'G3DSA:1.10.510.10:FF:000199', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(222259, NULL, 'G3DSA:3.40.50.150:FF:000264', NULL, NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(222260, NULL, 'G3DSA:3.10.20.90:FF:000533', NULL, NULL, 'Ubiquitin family', NULL, NULL, NULL, NULL, NULL, 4),
(222261, NULL, 'G3DSA:3.30.70.240:FF:000005', NULL, NULL, 'Elongation factor 4', NULL, NULL, NULL, NULL, NULL, 4),
(222262, NULL, 'G3DSA:2.130.10.10:FF:004108', NULL, NULL, 'Bardet-Biedl syndrome 2 protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(222263, NULL, 'G3DSA:1.10.340.30:FF:000034', NULL, NULL, 'Endonuclease III homolog', NULL, NULL, NULL, NULL, NULL, 4),
(222264, NULL, 'G3DSA:1.10.8.60:FF:000297', NULL, NULL, 'AAA family ATPase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(222265, NULL, 'G3DSA:1.50.10.100:FF:000005', NULL, NULL, 'Heparin/heparan-sulfate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(222266, NULL, 'G3DSA:1.10.287.10:FF:000010', NULL, NULL, 'RNA polymerase II subunit A C-terminal domain phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(222267, NULL, 'G3DSA:3.90.550.10:FF:000395', NULL, NULL, 'Glycosyl transferase group 2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(222268, NULL, 'G3DSA:3.40.250.10:FF:000147', NULL, NULL, 'Sulfurtransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(222269, NULL, 'G3DSA:2.60.40.3210:FF:000031', NULL, NULL, 'Uromodulin-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(222270, NULL, 'G3DSA:3.40.630.30:FF:000564', NULL, NULL, 'Elongator complex protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(222271, NULL, 'G3DSA:1.10.630.10:FF:000359', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222272, NULL, 'G3DSA:3.30.70.330:FF:001679', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222273, NULL, 'G3DSA:3.40.50.300:FF:001759', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NUBP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(222274, NULL, 'G3DSA:3.30.200.20:FF:002055', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222275, NULL, 'G3DSA:3.40.50.1820:FF:001702', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222276, NULL, 'G3DSA:1.10.510.10:FF:003958', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222277, NULL, 'G3DSA:2.120.10.90:FF:000013', NULL, NULL, 'DNA gyrase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(222278, NULL, 'G3DSA:2.130.10.130:FF:000007', NULL, NULL, 'Integrin subunit alpha 3', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(222279, NULL, 'G3DSA:3.40.50.1240:FF:000213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222280, NULL, 'G3DSA:3.30.870.10:FF:000056', NULL, NULL, 'Tyrosine-DNA phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(222281, NULL, 'G3DSA:3.30.450.20:FF:000639', NULL, NULL, 'PAS sensor protein', NULL, NULL, NULL, NULL, NULL, 4),
(222282, NULL, 'G3DSA:3.40.50.12430:FF:000001', NULL, NULL, 'Folliculin', NULL, NULL, NULL, NULL, NULL, 4),
(222283, NULL, 'G3DSA:2.60.40.10:FF:004474', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222284, NULL, 'G3DSA:1.25.40.10:FF:001590', NULL, NULL, 'Rapsynoid, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222285, NULL, 'G3DSA:3.30.1010.10:FF:000092', NULL, NULL, 'Phosphatidylinositol 3-kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222286, NULL, 'G3DSA:3.30.160.60:FF:001938', NULL, NULL, 'Zinc finger protein 300', NULL, NULL, NULL, NULL, NULL, 4),
(222287, NULL, 'G3DSA:3.30.465.10:FF:000108', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(222288, NULL, 'G3DSA:1.10.472.80:FF:000181', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222289, NULL, 'G3DSA:3.80.10.10:FF:000927', NULL, NULL, 'Nucleotide excision NEF4 component', NULL, NULL, NULL, NULL, NULL, 4),
(222290, NULL, 'G3DSA:3.40.50.10810:FF:000077', NULL, NULL, 'Putative DNA repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(222291, NULL, 'G3DSA:2.60.40.10:FF:003962', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222292, NULL, 'G3DSA:1.10.238.10:FF:000279', NULL, NULL, 'Rhomboid, veinlet-like 3 (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(222293, NULL, 'G3DSA:3.30.160.60:FF:000741', NULL, NULL, 'Zinc finger matrin-type protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(222294, NULL, 'G3DSA:4.10.400.10:FF:000134', NULL, NULL, 'Low-density lipoprotein RecePtor related', NULL, NULL, NULL, NULL, NULL, 4),
(222295, NULL, 'G3DSA:2.60.450.20:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222296, NULL, 'G3DSA:3.30.428.70:FF:000001', NULL, NULL, 'APA1p AP4A phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(222297, NULL, 'G3DSA:1.10.150.20:FF:000325', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222298, NULL, 'G3DSA:1.10.287.1490:FF:000005', NULL, NULL, 'nucleoprotein TPR isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(222299, NULL, 'G3DSA:3.90.70.10:FF:000155', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(222300, NULL, 'G3DSA:2.170.270.10:FF:000110', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(222301, NULL, 'G3DSA:2.60.40.3510:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222302, NULL, 'G3DSA:1.20.1420.30:FF:000060', NULL, NULL, 'Na+/Ca+ antiporter, CaCA family', NULL, NULL, NULL, NULL, NULL, 4),
(222303, NULL, 'G3DSA:3.80.10.10:FF:001439', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222304, NULL, 'G3DSA:2.40.50.140:FF:001097', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222305, NULL, 'G3DSA:3.90.79.10:FF:000130', NULL, NULL, 'Mitochondrial ribosomal protein L46', NULL, NULL, NULL, NULL, NULL, 4),
(222306, NULL, 'G3DSA:3.40.630.30:FF:000457', NULL, NULL, 'N-alpha-acetyltransferase 60', NULL, NULL, NULL, NULL, NULL, 4),
(222307, NULL, 'G3DSA:3.40.50.1010:FF:000268', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222308, NULL, 'G3DSA:3.40.50.300:FF:004851', NULL, NULL, 'Translation elongation factor G-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(222309, NULL, 'G3DSA:3.30.160.60:FF:001253', NULL, NULL, 'Zinc finger protein 408', NULL, NULL, NULL, NULL, NULL, 4),
(222310, NULL, 'G3DSA:3.40.50.720:FF:002262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222311, NULL, 'G3DSA:4.10.1030.10:FF:000001', NULL, NULL, 'Putative Cullin-1', NULL, NULL, NULL, NULL, NULL, 4),
(222312, NULL, 'G3DSA:3.90.1260.10:FF:000006', NULL, NULL, 'Argininosuccinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(222313, NULL, 'G3DSA:3.30.1660.10:FF:000005', NULL, NULL, 'Conserved protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(222314, NULL, 'G3DSA:2.60.40.10:FF:002326', NULL, NULL, 'GH03113p', NULL, NULL, NULL, NULL, NULL, 4),
(222315, NULL, 'G3DSA:1.10.246.60:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222316, NULL, 'G3DSA:2.60.120.200:FF:000819', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222317, NULL, 'G3DSA:3.40.50.10420:FF:000050', NULL, NULL, 'Probable 5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(222318, NULL, 'G3DSA:3.40.1740.10:FF:000004', NULL, NULL, 'Putative ACR, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222319, NULL, 'G3DSA:3.10.20.90:FF:000426', NULL, NULL, 'Ubiquitin and WLM domain-containing metalloprotease SPCC1442.07c', NULL, NULL, NULL, NULL, NULL, 4),
(222320, NULL, 'G3DSA:3.40.50.720:FF:000132', NULL, NULL, 'NAD-binding Rossmann fold oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(222321, NULL, 'G3DSA:3.40.50.300:FF:006981', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222322, NULL, 'G3DSA:1.20.144.10:FF:000103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222323, NULL, 'G3DSA:3.40.50.300:FF:005126', NULL, NULL, 'Cobalt ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(222324, NULL, 'G3DSA:3.30.70.920:FF:000018', NULL, NULL, 'Transcriptional regulator, AsnC family', NULL, NULL, NULL, NULL, NULL, 4),
(222325, NULL, 'G3DSA:2.40.50.100:FF:000152', NULL, NULL, 'Sugar ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(222326, NULL, 'G3DSA:2.40.340.10:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222327, NULL, 'G3DSA:3.40.50.1980:FF:000087', NULL, NULL, 'Iron (III) ABC transporter, periplasmic iron-bindin gprotein', NULL, NULL, NULL, NULL, NULL, 4),
(222328, NULL, 'G3DSA:3.30.930.10:FF:000100', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(222329, NULL, 'G3DSA:1.10.418.60:FF:000015', NULL, NULL, 'Probable kinetochore protein NUF2', NULL, NULL, NULL, NULL, NULL, 4),
(222330, NULL, 'G3DSA:3.30.470.20:FF:000062', NULL, NULL, 'Carbamoyl-phosphate synthetase 2, aspartate transcarbamylase, and dihydroorotase', NULL, NULL, NULL, NULL, NULL, 4),
(222331, NULL, 'G3DSA:3.40.50.12160:FF:000009', NULL, NULL, 'threonylcarbamoyladenosine tRNA methylthiotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(222332, NULL, 'G3DSA:2.40.70.10:FF:000194', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222333, NULL, 'G3DSA:3.10.129.10:FF:000164', NULL, NULL, 'Thioesterase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(222334, NULL, 'G3DSA:3.30.200.20:FF:000924', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222335, NULL, 'G3DSA:4.10.880.10:FF:000001', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(222336, NULL, 'G3DSA:1.20.1560.10:FF:000120', NULL, NULL, 'ABC transporter B family member 6', NULL, NULL, NULL, NULL, NULL, 4),
(222337, NULL, 'G3DSA:3.30.70.270:FF:000109', NULL, NULL, 'GGDEF family protein', NULL, NULL, NULL, NULL, NULL, 4),
(222338, NULL, 'G3DSA:1.10.506.10:FF:000088', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222339, NULL, 'G3DSA:3.80.10.10:FF:001771', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(222340, NULL, 'G3DSA:3.40.50.300:FF:003889', NULL, NULL, 'GPN-loop GTPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(222341, NULL, 'G3DSA:3.40.1580.10:FF:000002', NULL, NULL, 'F-box only protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(222342, NULL, 'G3DSA:3.30.230.70:FF:000177', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222343, NULL, 'G3DSA:3.40.532.10:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222344, NULL, 'G3DSA:1.10.3260.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222345, NULL, 'G3DSA:1.25.10.10:FF:001655', NULL, NULL, '19S/PA700 proteasome regulatory particle subunit Rpn1p/S1', NULL, NULL, NULL, NULL, NULL, 4),
(222346, NULL, 'G3DSA:1.10.238.10:FF:001004', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(222347, NULL, 'G3DSA:1.20.1250.20:FF:001875', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222348, NULL, 'G3DSA:3.30.360.10:FF:000079', NULL, NULL, 'Gfo/Idh/MocA family oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(222349, NULL, 'G3DSA:3.30.50.10:FF:000005', NULL, NULL, 'Retinoic acid receptor RXR-alpha', NULL, NULL, NULL, NULL, NULL, 4),
(222350, NULL, 'G3DSA:3.40.50.360:FF:000102', NULL, NULL, 'Methionine synthase reductase', NULL, NULL, NULL, NULL, NULL, 4),
(222351, NULL, 'G3DSA:3.30.420.210:FF:000008', NULL, NULL, 'Ubiquitin regulatory protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222352, NULL, 'G3DSA:1.10.10.60:FF:000624', NULL, NULL, 'Myb-related protein Myb4', NULL, NULL, NULL, NULL, NULL, 4),
(222353, NULL, 'G3DSA:3.80.10.10:FF:003912', NULL, NULL, 'Receptor-like protein EIX2', NULL, NULL, NULL, NULL, NULL, 4),
(222354, NULL, 'G3DSA:3.90.1140.10:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222355, NULL, 'G3DSA:3.40.50.880:FF:000140', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222356, NULL, 'G3DSA:3.10.580.10:FF:000055', NULL, NULL, 'Arabinose 5-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(222357, NULL, 'G3DSA:2.30.30.30:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222358, NULL, 'G3DSA:3.90.1150.10:FF:000453', NULL, NULL, 'Aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(222359, NULL, 'G3DSA:3.40.50.1010:FF:000049', NULL, NULL, 'DNA repair endonuclease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222360, NULL, 'G3DSA:3.40.50.300:FF:004744', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222361, NULL, 'G3DSA:2.60.40.1120:FF:000056', NULL, NULL, 'Rhamnogalacturonate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(222362, NULL, 'G3DSA:3.40.50.2300:FF:000346', NULL, NULL, 'Diguanylate cyclase response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(222363, NULL, 'G3DSA:1.20.1230.10:FF:000016', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(222364, NULL, 'G3DSA:1.20.1600.10:FF:000051', NULL, NULL, 'Protein CyaE', NULL, NULL, NULL, NULL, NULL, 4),
(222365, NULL, 'G3DSA:3.40.430.10:FF:000026', NULL, NULL, 'Riboflavin biosynthesis protein RibD', NULL, NULL, NULL, NULL, NULL, 4),
(222366, NULL, 'G3DSA:1.10.238.10:FF:000604', NULL, NULL, 'EF-hand domain pair/EF-hand domain/EF hand, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222367, NULL, 'G3DSA:3.40.47.10:FF:000233', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222368, NULL, 'G3DSA:1.25.40.10:FF:002101', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g53700, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(222369, NULL, 'G3DSA:2.40.30.10:FF:000073', NULL, NULL, 'NADPH--cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(222370, NULL, 'G3DSA:1.25.40.10:FF:001483', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222371, NULL, 'G3DSA:2.10.25.10:FF:001338', NULL, NULL, 'Fibulin 2', NULL, NULL, NULL, NULL, NULL, 4),
(222372, NULL, 'G3DSA:3.60.20.30:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222373, NULL, 'G3DSA:2.130.10.10:FF:002074', NULL, NULL, 'Os12g0178633 protein', NULL, NULL, NULL, NULL, NULL, 4),
(222374, NULL, 'G3DSA:2.60.40.10:FF:001489', NULL, NULL, 'SPEG neighbor', NULL, NULL, NULL, NULL, NULL, 4),
(222375, NULL, 'G3DSA:3.60.20.10:FF:000131', NULL, NULL, 'Proteasome subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(222376, NULL, 'G3DSA:4.10.400.10:FF:000241', NULL, NULL, 'LDL receptor protein 1, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(222377, NULL, 'G3DSA:3.30.40.10:FF:001797', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222378, NULL, 'G3DSA:3.40.50.1820:FF:000977', NULL, NULL, 'Alpha/beta hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(222379, NULL, 'G3DSA:2.10.25.10:FF:001214', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222380, NULL, 'G3DSA:1.20.1560.10:FF:000788', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(222381, NULL, 'G3DSA:1.25.40.10:FF:000971', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(222382, NULL, 'G3DSA:2.60.40.60:FF:001026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222383, NULL, 'G3DSA:3.80.10.10:FF:003676', NULL, NULL, 'Probable disease resistance protein At5g45510', NULL, NULL, NULL, NULL, NULL, 4),
(222384, NULL, 'G3DSA:3.40.50.1820:FF:001377', NULL, NULL, 'Chromosome 9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(222385, NULL, 'G3DSA:3.90.226.10:FF:000136', NULL, NULL, 'Carbamoyl-phosphate synthase/carboxyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(222386, NULL, 'G3DSA:3.90.340.10:FF:000002', NULL, NULL, 'Nitric oxide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(222387, NULL, 'G3DSA:3.50.50.60:FF:000373', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(222388, NULL, 'G3DSA:2.60.40.60:FF:000407', NULL, NULL, 'Calsyntenin 3', NULL, NULL, NULL, NULL, NULL, 4),
(222389, NULL, 'G3DSA:1.25.10.10:FF:000351', NULL, NULL, 'armadillo repeat-containing protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(222390, NULL, 'G3DSA:2.40.10.350:FF:000005', NULL, NULL, 'Rod shape-determining protein MreC', NULL, NULL, NULL, NULL, NULL, 4),
(222391, NULL, 'G3DSA:3.30.1520.10:FF:000063', NULL, NULL, 'Unplaced genomic scaffold supercont1.141, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(222392, NULL, 'G3DSA:1.20.1250.90:FF:000002', NULL, NULL, 'Thymic stromal lymphopoietin', NULL, NULL, NULL, NULL, NULL, 4),
(222393, NULL, 'G3DSA:1.20.58.70:FF:000079', NULL, NULL, 'Qa-SNARE, SYP2/Pep12p/Syntaxin 7-type', NULL, NULL, NULL, NULL, NULL, 4),
(222394, NULL, 'G3DSA:1.10.10.10:FF:001924', NULL, NULL, 'Transcriptional regulator, ArsR family', NULL, NULL, NULL, NULL, NULL, 4),
(222395, NULL, 'G3DSA:3.40.190.10:FF:000203', NULL, NULL, 'Dipeptide-binding ABC transporter, periplasmic substrate-binding component', NULL, NULL, NULL, NULL, NULL, 4),
(222396, NULL, 'G3DSA:3.40.190.80:FF:000073', NULL, NULL, 'Inositol polyphosphate 1-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(222397, NULL, 'G3DSA:1.25.40.20:FF:000755', NULL, NULL, 'Protein accellerated cell death 6', NULL, NULL, NULL, NULL, NULL, 4),
(222398, NULL, 'G3DSA:3.30.160.60:FF:004687', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222399, NULL, 'G3DSA:3.40.1380.20:FF:000018', NULL, NULL, 'Pyruvate kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(222400, NULL, 'G3DSA:2.40.10.10:FF:000544', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222401, NULL, 'G3DSA:3.50.50.60:FF:000154', NULL, NULL, 'Fumarate reductase flavoprotein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(222402, NULL, 'G3DSA:1.25.40.10:FF:003388', NULL, NULL, 'Prp-6', NULL, NULL, NULL, NULL, NULL, 4),
(222403, NULL, 'G3DSA:3.40.50.300:FF:002378', NULL, NULL, 'ATP-dependent helicase FUN30', NULL, NULL, NULL, NULL, NULL, 4),
(222404, NULL, 'G3DSA:1.10.150.20:FF:000106', NULL, NULL, '5''-3'' exonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(222405, NULL, 'G3DSA:3.40.50.1820:FF:000865', NULL, NULL, 'Lipid droplet-associated hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(222406, NULL, 'G3DSA:1.10.560.10:FF:000022', NULL, NULL, 'T-complex protein 1 subunit zeta', NULL, NULL, NULL, NULL, NULL, 4),
(222407, NULL, 'G3DSA:3.40.309.10:FF:000014', NULL, NULL, 'NAD/NADP-dependent betaine aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(222408, NULL, 'G3DSA:1.20.1560.10:FF:000007', NULL, NULL, 'ATP-binding cassette subfamily C member 1', NULL, NULL, NULL, NULL, NULL, 4),
(222409, NULL, 'G3DSA:1.10.238.10:FF:000498', NULL, NULL, 'Polcalcin Jun o 2', NULL, NULL, NULL, NULL, NULL, 4),
(222410, NULL, 'G3DSA:1.10.1410.10:FF:000078', NULL, NULL, 'Poly A polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(222411, NULL, 'G3DSA:3.40.50.300:FF:001978', NULL, NULL, 'EC1118_1F29_0056p', NULL, NULL, NULL, NULL, NULL, 4),
(222412, NULL, 'G3DSA:1.10.472.10:FF:000542', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(222413, NULL, 'G3DSA:3.20.20.210:FF:000022', NULL, NULL, 'Uroporphyrinogen decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(222414, NULL, 'G3DSA:3.40.50.150:FF:001568', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222415, NULL, 'G3DSA:2.40.180.10:FF:000027', NULL, NULL, 'Catalase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222416, NULL, 'G3DSA:2.40.160.20:FF:000017', NULL, NULL, 'Outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(222417, NULL, 'G3DSA:1.10.510.10:FF:001036', NULL, NULL, 'Calcium-dependent protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222418, NULL, 'G3DSA:1.25.10.10:FF:000019', NULL, NULL, 'Cytoskeleton-associated protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(222419, NULL, 'G3DSA:3.80.10.10:FF:000242', NULL, NULL, 'Adhesion G protein-coupled receptor A2', NULL, NULL, NULL, NULL, NULL, 4),
(222420, NULL, 'G3DSA:3.90.1170.30:FF:000005', NULL, NULL, 'Thymidine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(222421, NULL, 'G3DSA:1.20.920.30:FF:000059', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222422, NULL, 'G3DSA:3.30.200.20:FF:000020', NULL, NULL, 'Protein kinase C, alpha', NULL, NULL, NULL, NULL, NULL, 4),
(222423, NULL, 'G3DSA:1.20.1280.50:FF:000059', NULL, NULL, 'Partner of Paired', NULL, NULL, NULL, NULL, NULL, 4),
(222424, NULL, 'G3DSA:3.40.50.1370:FF:000016', NULL, NULL, 'Ornithine carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(222425, NULL, 'G3DSA:3.40.50.740:FF:000014', NULL, NULL, 'Tetrathionate reductase subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(222426, NULL, 'G3DSA:2.130.10.10:FF:004906', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222427, NULL, 'G3DSA:3.10.20.90:FF:000314', NULL, NULL, 'Ste50p', NULL, NULL, NULL, NULL, NULL, 4),
(222428, NULL, 'G3DSA:3.40.50.300:FF:006649', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(222429, NULL, 'G3DSA:3.40.50.11320:FF:000005', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(222430, NULL, 'G3DSA:1.25.40.10:FF:004006', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222431, NULL, 'G3DSA:2.60.40.150:FF:000559', NULL, NULL, 'Putative ca2+-dependent phospholipid-binding protein synaptotagmin required for synaptic vesicle', NULL, NULL, NULL, NULL, NULL, 4),
(222432, NULL, 'G3DSA:1.20.1250.20:FF:001656', NULL, NULL, 'MFS multidrug transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222433, NULL, 'G3DSA:1.25.40.1040:FF:000002', NULL, NULL, 'Cleavage stimulation factor subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(222434, NULL, 'G3DSA:3.30.40.10:FF:000381', NULL, NULL, 'TNF receptor-associated factor', NULL, NULL, NULL, NULL, NULL, 4),
(222435, NULL, 'G3DSA:3.40.50.1820:FF:000180', NULL, NULL, 'Putative lipase ROG1', NULL, NULL, NULL, NULL, NULL, 4),
(222436, NULL, 'G3DSA:1.20.5.1430:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222437, NULL, 'G3DSA:3.30.530.20:FF:000011', NULL, NULL, 'cytoplasmic phosphatidylinositol transfer protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(222438, NULL, 'G3DSA:3.10.110.10:FF:000138', NULL, NULL, 'Putative ubiquitin-conjugating enzyme e2', NULL, NULL, NULL, NULL, NULL, 4),
(222439, NULL, 'G3DSA:1.10.510.10:FF:003054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222440, NULL, 'G3DSA:3.30.565.10:FF:000274', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(222441, NULL, 'G3DSA:3.90.70.10:FF:000279', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(222442, NULL, 'G3DSA:3.40.630.30:FF:000345', NULL, NULL, 'GM13211', NULL, NULL, NULL, NULL, NULL, 4),
(222443, NULL, 'G3DSA:2.10.25.10:FF:000719', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(222444, NULL, 'G3DSA:3.30.1510.10:FF:000017', NULL, NULL, 'Formate-tetrahydrofolate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(222445, NULL, 'G3DSA:2.30.310.10:FF:000006', NULL, NULL, 'Nuclear export mediator factor', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(222446, NULL, 'G3DSA:3.30.200.20:FF:001436', NULL, NULL, 'Probable ethanolamine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(222447, NULL, 'G3DSA:3.40.1090.10:FF:000038', NULL, NULL, 'Patatin-like phospholipase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(222448, NULL, 'G3DSA:1.10.238.10:FF:001116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222449, NULL, 'G3DSA:3.40.50.10130:FF:000070', NULL, NULL, 'DNA excision repair protein ERCC-1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(222450, NULL, 'G3DSA:3.10.350.10:FF:000009', NULL, NULL, 'Uncharacterized protein, isoform W', NULL, NULL, NULL, NULL, NULL, 4),
(222451, NULL, 'G3DSA:2.60.40.1760:FF:000017', NULL, NULL, 'Acid Alpha Glucosidase Relate', NULL, NULL, NULL, NULL, NULL, 4),
(222452, NULL, 'G3DSA:1.50.40.10:FF:000339', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222453, NULL, 'G3DSA:1.20.58.1470:FF:000001', NULL, NULL, 'FTO, alpha-ketoglutarate dependent dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(222454, NULL, 'G3DSA:1.10.150.280:FF:000007', NULL, NULL, 'Kinesin-like protein Nod', NULL, NULL, NULL, NULL, NULL, 4),
(222455, NULL, 'G3DSA:1.10.30.10:FF:000178', NULL, NULL, 'High mobility group protein', NULL, NULL, NULL, NULL, NULL, 4),
(222456, NULL, 'G3DSA:3.40.1190.20:FF:000195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222457, NULL, 'G3DSA:1.10.640.10:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222458, NULL, 'G3DSA:3.40.50.300:FF:003215', NULL, NULL, 'Si:dkey-187j14.8', NULL, NULL, NULL, NULL, NULL, 4),
(222459, NULL, 'G3DSA:3.10.110.10:FF:000014', NULL, NULL, 'Baculoviral IAP repeat-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(222460, NULL, 'G3DSA:2.130.10.10:FF:003833', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222461, NULL, 'G3DSA:3.30.505.10:FF:000039', NULL, NULL, 'src-like-adapter isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(222462, NULL, 'G3DSA:2.60.120.290:FF:000110', NULL, NULL, 'GD12774', NULL, NULL, NULL, NULL, NULL, 4),
(222463, NULL, 'G3DSA:1.10.287.40:FF:000007', NULL, NULL, 'Seryl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222464, NULL, 'G3DSA:3.40.50.200:FF:000195', NULL, NULL, 'p-domain proprotein convertase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222465, NULL, 'G3DSA:3.30.450.30:FF:000070', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222466, NULL, 'G3DSA:4.10.860.120:FF:000005', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(222467, NULL, 'G3DSA:1.20.5.110:FF:000354', NULL, NULL, 'Calpain-3', NULL, NULL, NULL, NULL, NULL, 4),
(222468, NULL, 'G3DSA:2.40.37.10:FF:000010', NULL, NULL, 'Ornithine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(222469, NULL, 'G3DSA:3.30.70.330:FF:001555', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222470, NULL, 'G3DSA:2.60.40.10:FF:005199', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222471, NULL, 'G3DSA:3.30.70.1230:FF:000180', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222472, NULL, 'G3DSA:2.160.20.10:FF:000207', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222473, NULL, 'G3DSA:3.40.50.720:FF:000929', NULL, NULL, 'Oxidoreductase, short-chain dehydrogenase/reductase family', NULL, NULL, NULL, NULL, NULL, 4),
(222474, NULL, 'G3DSA:3.30.1370.240:FF:000003', NULL, NULL, 'Phenylalanyl-tRNA synthetase beta chain cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(222475, NULL, 'G3DSA:2.10.25.10:FF:001670', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222476, NULL, 'G3DSA:1.10.510.10:FF:003852', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222477, NULL, 'G3DSA:1.10.10.10:FF:000620', NULL, NULL, 'Homeodomain-like/winged-helix DNA-binding family protein', NULL, NULL, NULL, NULL, NULL, 4),
(222478, NULL, 'G3DSA:3.40.50.150:FF:000388', NULL, NULL, 'U6 small nuclear RNA (adenine-(43)-N(6))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(222479, NULL, 'G3DSA:3.30.70.1450:FF:000021', NULL, NULL, 'Probable sodium/sulfate cotransporter 3', NULL, NULL, NULL, NULL, NULL, 4),
(222480, NULL, 'G3DSA:3.60.15.10:FF:000164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222481, NULL, 'G3DSA:1.10.275.40:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222482, NULL, 'G3DSA:3.30.160.60:FF:006267', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222483, NULL, 'G3DSA:1.25.40.690:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222484, NULL, 'G3DSA:3.90.550.10:FF:000271', NULL, NULL, 'Hyaluronan synthase', NULL, NULL, NULL, NULL, NULL, 4),
(222485, NULL, 'G3DSA:1.10.357.10:FF:000004', NULL, NULL, 'Ubiquinone biosynthesis protein COQ9, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(222486, NULL, 'G3DSA:2.60.120.260:FF:000455', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222487, NULL, 'G3DSA:3.10.310.10:FF:000013', NULL, NULL, 'Phenazine biosynthesis-like domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(222488, NULL, 'G3DSA:3.40.640.10:FF:000183', NULL, NULL, '2-aminoethylphosphonate--pyruvate transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(222489, NULL, 'G3DSA:3.50.4.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222490, NULL, 'G3DSA:1.25.40.10:FF:005299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222491, NULL, 'G3DSA:2.70.130.10:FF:000152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222492, NULL, 'G3DSA:1.20.930.40:FF:000001', NULL, NULL, 'N-acetylated-alpha-linked acidic dipeptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(222493, NULL, 'G3DSA:2.30.29.30:FF:000986', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(222494, NULL, 'G3DSA:3.80.10.10:FF:003457', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222495, NULL, 'G3DSA:1.20.1070.10:FF:000032', NULL, NULL, 'Vasoactive intestinal polypeptide receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(222496, NULL, 'G3DSA:1.10.1200.80:FF:000009', NULL, NULL, 'tRNA-dihydrouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(222497, NULL, 'G3DSA:2.60.40.10:FF:004693', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222498, NULL, 'G3DSA:2.60.40.10:FF:001944', NULL, NULL, 'Hemicentin 2', NULL, NULL, NULL, NULL, NULL, 4),
(222499, NULL, 'G3DSA:3.40.50.300:FF:006088', NULL, NULL, 'ADP-ribosylation factor-like 3, like 2', NULL, NULL, NULL, NULL, NULL, 4),
(222500, NULL, 'G3DSA:2.20.100.10:FF:000010', NULL, NULL, 'ADAM metallopeptidase with thrombospondin type 1 motif 9', NULL, NULL, NULL, NULL, NULL, 4),
(222501, NULL, 'G3DSA:2.60.40.150:FF:000672', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222502, NULL, 'G3DSA:3.40.50.2000:FF:000470', NULL, NULL, 'Alpha,alpha-trehalose-phosphate synthase [UDP-forming] B', NULL, NULL, NULL, NULL, NULL, 4),
(222503, NULL, 'G3DSA:3.40.50.720:FF:001205', NULL, NULL, 'Probable short-chain type dehydrogenase/reductase VdlC', NULL, NULL, NULL, NULL, NULL, 4),
(222504, NULL, 'G3DSA:3.30.379.10:FF:000009', NULL, NULL, 'Beta-N-acetylhexosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(222505, NULL, 'G3DSA:1.25.40.10:FF:004462', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222506, NULL, 'G3DSA:3.40.50.2300:FF:001307', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222507, NULL, 'G3DSA:3.30.559.10:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222508, NULL, 'G3DSA:3.40.190.10:FF:000889', NULL, NULL, 'Transcriptional regulator LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(222509, NULL, 'G3DSA:3.40.50.11040:FF:000011', NULL, NULL, 'tRNA(Met) cytidine acetyltransferase TmcA', NULL, NULL, NULL, NULL, NULL, 4),
(222510, NULL, 'G3DSA:3.40.50.10190:FF:000278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222511, NULL, 'G3DSA:3.30.70.330:FF:000032', NULL, NULL, 'Polypyrimidine tract-binding protein 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(222512, NULL, 'G3DSA:1.10.287.1490:FF:000117', NULL, NULL, 'Coiled-coil domain-containing protein 102A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222513, NULL, 'G3DSA:1.25.40.10:FF:003169', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(222514, NULL, 'G3DSA:3.40.850.10:FF:000226', NULL, NULL, 'Kinesin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(222515, NULL, 'G3DSA:3.40.50.300:FF:005924', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222516, NULL, 'G3DSA:1.20.1250.60:FF:000004', NULL, NULL, 'Interferon lambda-3', NULL, NULL, NULL, NULL, NULL, 4),
(222517, NULL, 'G3DSA:2.60.120.230:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222518, NULL, 'G3DSA:2.60.40.10:FF:004350', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222519, NULL, 'G3DSA:1.10.1620.20:FF:000001', NULL, NULL, 'ATP synthase subunit epsilon, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(222520, NULL, 'G3DSA:2.130.10.10:FF:002872', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222521, NULL, 'G3DSA:1.20.1110.10:FF:000199', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222522, NULL, 'G3DSA:1.10.630.10:FF:000578', NULL, NULL, 'Cytochrome P450, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222523, NULL, 'G3DSA:2.70.150.10:FF:000260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222524, NULL, 'G3DSA:2.60.120.40:FF:000039', NULL, NULL, 'Tumor necrosis factor (Ligand) superfamily member 4', NULL, NULL, NULL, NULL, NULL, 4),
(222525, NULL, 'G3DSA:1.20.1070.10:FF:000936', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222526, NULL, 'G3DSA:2.70.98.10:FF:000059', NULL, NULL, 'Putative alpha-1,2-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(222527, NULL, 'G3DSA:2.60.40.10:FF:001040', NULL, NULL, 'Microfibrillar-associated protein 3-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(222528, NULL, 'G3DSA:3.30.450.40:FF:000292', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(222529, NULL, 'G3DSA:2.30.130.40:FF:000001', NULL, NULL, 'Lon protease', NULL, NULL, NULL, NULL, NULL, 4),
(222530, NULL, 'G3DSA:3.40.50.300:FF:007599', NULL, NULL, 'Protein-tyrosine sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(222531, NULL, 'G3DSA:1.20.58.60:FF:000531', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222532, NULL, 'G3DSA:3.20.20.70:FF:000802', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222533, NULL, 'G3DSA:2.60.40.10:FF:004018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222534, NULL, 'G3DSA:1.10.10.10:FF:000963', NULL, NULL, 'Two-component response transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(222535, NULL, 'G3DSA:2.60.120.380:FF:000036', NULL, NULL, 'Calpain 3b', NULL, NULL, NULL, NULL, NULL, 4),
(222536, NULL, 'G3DSA:3.30.160.60:FF:005648', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222537, NULL, 'G3DSA:3.50.50.100:FF:000005', NULL, NULL, 'NADH-ubiquinone oxidoreductase 64 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(222538, NULL, 'G3DSA:1.10.20.120:FF:000016', NULL, NULL, 'AAL125Wp', NULL, NULL, NULL, NULL, NULL, 4),
(222539, NULL, 'G3DSA:1.25.10.10:FF:002037', NULL, NULL, 'Armadillo/beta-catenin-like repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222540, NULL, 'G3DSA:2.30.30.100:FF:000105', NULL, NULL, 'Lsm10', NULL, NULL, NULL, NULL, NULL, 4),
(222541, NULL, 'G3DSA:1.20.120.290:FF:000007', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase TLP38, chloroplast', NULL, NULL, NULL, NULL, NULL, 4),
(222542, NULL, 'G3DSA:1.10.10.350:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222543, NULL, 'G3DSA:2.60.40.10:FF:005311', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222544, NULL, 'G3DSA:3.30.830.10:FF:000059', NULL, NULL, 'Mitochondrial-processing peptidase subunit alpha-1', NULL, NULL, NULL, NULL, NULL, 4),
(222545, NULL, 'G3DSA:2.60.40.10:FF:002905', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(222546, NULL, 'G3DSA:3.30.200.20:FF:002493', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222547, NULL, 'G3DSA:2.80.10.50:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222548, NULL, 'G3DSA:3.40.1780.10:FF:000001', NULL, NULL, 'S-adenosylmethionine:tRNA ribosyltransferase-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(222549, NULL, 'G3DSA:2.40.50.140:FF:000821', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222550, NULL, 'G3DSA:2.30.29.240:FF:000010', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(222551, NULL, 'G3DSA:4.10.60.10:FF:000162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222552, NULL, 'G3DSA:1.10.8.1190:FF:000004', NULL, NULL, 'Replicase polyprotein 1a', NULL, NULL, NULL, NULL, NULL, 4),
(222553, NULL, 'G3DSA:3.40.50.10490:FF:000031', NULL, NULL, 'Glucose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(222554, NULL, 'G3DSA:3.30.710.10:FF:000005', NULL, NULL, 'Potassium channel tetramerization domain-containing 17', NULL, NULL, NULL, NULL, NULL, 4),
(222555, NULL, 'G3DSA:3.40.50.720:FF:001880', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(222556, NULL, 'G3DSA:1.20.120.1750:FF:000037', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(222557, NULL, 'G3DSA:1.10.3730.20:FF:000015', NULL, NULL, 'UDP-galactose transporter 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(222558, NULL, 'G3DSA:3.30.1460.20:FF:000010', NULL, NULL, 'Arp2/3 complex 34 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(222559, NULL, 'G3DSA:3.30.420.40:FF:000121', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(222560, NULL, 'G3DSA:1.20.1070.10:FF:001212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222561, NULL, 'G3DSA:3.20.80.10:FF:000024', NULL, NULL, 'Heme-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(222562, NULL, 'G3DSA:3.40.50.720:FF:000587', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(222563, NULL, 'G3DSA:3.40.50.2000:FF:000138', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(222564, NULL, 'G3DSA:3.40.390.10:FF:000202', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222565, NULL, 'G3DSA:2.20.70.10:FF:000144', NULL, NULL, 'Pre-mRNA-processing factor 40 homolog A', NULL, NULL, NULL, NULL, NULL, 4),
(222566, NULL, 'G3DSA:3.90.190.10:FF:000187', NULL, NULL, 'Tyrosine phosphatase family, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222567, NULL, 'G3DSA:1.20.1560.10:FF:000682', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222568, NULL, 'G3DSA:3.80.10.10:FF:002153', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222569, NULL, 'G3DSA:1.10.10.60:FF:000045', NULL, NULL, 'RNA polymerase sigma-54 factor', NULL, NULL, NULL, NULL, NULL, 4),
(222570, NULL, 'G3DSA:2.130.10.10:FF:000056', NULL, NULL, 'Polycomb protein eed', NULL, NULL, NULL, NULL, NULL, 4),
(222571, NULL, 'G3DSA:3.40.50.300:FF:000455', NULL, NULL, 'Phosphate starvation-inducible ATPase PhoH', NULL, NULL, NULL, NULL, NULL, 4),
(222572, NULL, 'G3DSA:2.60.40.10:FF:000764', NULL, NULL, 'CXADR like membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(222573, NULL, 'G3DSA:1.10.472.80:FF:000287', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222574, NULL, 'G3DSA:3.40.50.2300:FF:000689', NULL, NULL, 'Glutamate receptor', NULL, NULL, NULL, NULL, NULL, 4),
(222575, NULL, 'G3DSA:1.20.5.190:FF:000102', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222576, NULL, 'G3DSA:1.25.40.10:FF:001589', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(222577, NULL, 'G3DSA:3.90.930.12:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222578, NULL, 'G3DSA:2.130.10.10:FF:005963', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222579, NULL, 'G3DSA:3.40.630.40:FF:000005', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase (AmiA)', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(222580, NULL, 'G3DSA:3.10.110.10:FF:000357', NULL, NULL, 'Si:ch1073-205c8.3', NULL, NULL, NULL, NULL, NULL, 4),
(222581, NULL, 'G3DSA:3.80.10.10:FF:000023', NULL, NULL, 'Leucine rich repeats and immunoglobulin like domains 3', NULL, NULL, NULL, NULL, NULL, 4),
(222582, NULL, 'G3DSA:3.10.150.10:FF:000011', NULL, NULL, 'Proliferating cell nuclear antigen', NULL, NULL, NULL, NULL, NULL, 4),
(222583, NULL, 'G3DSA:1.20.5.170:FF:000220', NULL, NULL, 'Mitotic checkpoint protein MAD1', NULL, NULL, NULL, NULL, NULL, 4),
(222584, NULL, 'G3DSA:3.60.21.10:FF:000330', NULL, NULL, 'Acid sphingomyelinase-like phosphodiesterase 3a', NULL, NULL, NULL, NULL, NULL, 4),
(222585, NULL, 'G3DSA:3.30.70.960:FF:000002', NULL, NULL, 'Interphotoreceptor matrix proteoglycan 2', NULL, NULL, NULL, NULL, NULL, 4),
(222586, NULL, 'G3DSA:1.10.357.40:FF:000002', NULL, NULL, 'FHA domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(222587, NULL, 'G3DSA:3.10.460.10:FF:000001', NULL, NULL, 'Matrix protein', NULL, NULL, NULL, NULL, NULL, 4),
(222588, NULL, 'G3DSA:1.20.120.530:FF:000018', NULL, NULL, 'Transcriptional regulator, GntR family', NULL, NULL, NULL, NULL, NULL, 4),
(222589, NULL, 'G3DSA:1.10.533.10:FF:000111', NULL, NULL, 'astrocytic phosphoprotein PEA-15 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(222590, NULL, 'G3DSA:2.60.40.10:FF:005654', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222591, NULL, 'G3DSA:2.30.29.230:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222592, NULL, 'G3DSA:3.40.50.300:FF:006762', NULL, NULL, 'Uncharacterized protein, isoform I', NULL, NULL, NULL, NULL, NULL, 4),
(222593, NULL, 'G3DSA:3.30.70.270:FF:000003', NULL, NULL, 'Transposon Ty3-G Gag-Pol polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(222594, NULL, 'G3DSA:2.60.40.10:FF:000983', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(222595, NULL, 'G3DSA:3.30.420.40:FF:000340', NULL, NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(222596, NULL, 'G3DSA:1.25.40.10:FF:003624', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(222597, NULL, 'G3DSA:2.60.40.10:FF:001601', NULL, NULL, 'Roundabout guidance receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(222598, NULL, 'G3DSA:1.10.150.250:FF:000009', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222599, NULL, 'G3DSA:2.60.40.150:FF:000216', NULL, NULL, 'Perforin-1 precursor', NULL, NULL, NULL, NULL, NULL, 4),
(222600, NULL, 'G3DSA:2.60.40.1730:FF:000019', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(222601, NULL, 'G3DSA:3.40.33.10:FF:000055', NULL, NULL, 'MIP16674p', NULL, NULL, NULL, NULL, NULL, 4),
(222602, NULL, 'G3DSA:1.20.1500.20:FF:000001', NULL, NULL, 'DEAD/DEAH box RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(222603, NULL, 'G3DSA:1.10.275.10:FF:000016', NULL, NULL, 'Histidine ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(222604, NULL, 'G3DSA:2.30.29.30:FF:000082', NULL, NULL, 'Docking protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(222605, NULL, 'G3DSA:1.20.1070.10:FF:000251', NULL, NULL, 'Sphingosine 1-phosphate receptor 5', NULL, NULL, NULL, NULL, NULL, 4),
(222606, NULL, 'G3DSA:2.10.25.10:FF:001091', NULL, NULL, 'Si:ch211-241f5.3', NULL, NULL, NULL, NULL, NULL, 4),
(222607, NULL, 'G3DSA:2.10.110.10:FF:000232', NULL, NULL, 'LIM and PET domains protein', NULL, NULL, NULL, NULL, NULL, 4),
(222608, NULL, 'G3DSA:1.10.10.60:FF:001006', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222609, NULL, 'G3DSA:3.30.1330.40:FF:000012', NULL, NULL, 'diphthine--ammonia ligase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(222610, NULL, 'G3DSA:3.40.50.300:FF:005469', NULL, NULL, 'ABC Transporter family', NULL, NULL, NULL, NULL, NULL, 4),
(222611, NULL, 'G3DSA:3.30.160.60:FF:002557', NULL, NULL, 'GH24059', NULL, NULL, NULL, NULL, NULL, 4),
(222612, NULL, 'G3DSA:2.60.40.10:FF:000308', NULL, NULL, 'Down syndrome cell adhesion molecule, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(222613, NULL, 'G3DSA:2.130.10.10:FF:001017', NULL, NULL, 'Dynein axonemal intermediate chain 2', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(222614, NULL, 'G3DSA:2.40.10.10:FF:000089', NULL, NULL, 'Mannan-binding lectin serine protease 2', NULL, NULL, NULL, NULL, NULL, 4),
(222615, NULL, 'G3DSA:1.10.510.10:FF:001379', NULL, NULL, 'Myosin light chain kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222616, NULL, 'G3DSA:3.90.190.10:FF:000529', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222617, NULL, 'G3DSA:3.90.190.20:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222618, NULL, 'G3DSA:3.40.50.150:FF:000949', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222619, NULL, 'G3DSA:2.130.10.10:FF:002310', NULL, NULL, 'Pre-mRNA-processing factor 19', NULL, NULL, NULL, NULL, NULL, 4),
(222620, NULL, 'G3DSA:3.30.70.330:FF:000375', NULL, NULL, 'RNA binding fox-1 homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(222621, NULL, 'G3DSA:1.20.58.120:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222622, NULL, 'G3DSA:3.20.20.80:FF:000682', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222623, NULL, 'G3DSA:3.30.40.10:FF:000504', NULL, NULL, 'E3 ubiquitin-protein ligase arkadia', NULL, NULL, NULL, NULL, NULL, 4),
(222624, NULL, 'G3DSA:1.10.510.10:FF:002672', NULL, NULL, 'Cdc7 kinase, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(222625, NULL, 'G3DSA:3.20.20.60:FF:000125', NULL, NULL, 'Isocitrate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(222626, NULL, 'G3DSA:3.30.1390.20:FF:000015', NULL, NULL, '60S ribosomal protein L7-1 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(222627, NULL, 'G3DSA:1.25.10.10:FF:001998', NULL, NULL, 'Armadillo-type protein', NULL, NULL, NULL, NULL, NULL, 4),
(222628, NULL, 'G3DSA:2.40.160.210:FF:000003', NULL, NULL, 'Acyl-CoA thioesterase II', NULL, NULL, NULL, NULL, NULL, 4),
(222629, NULL, 'G3DSA:3.40.50.970:FF:000066', NULL, NULL, '2-succinyl-5-enolpyruvyl-6-hydroxy-3-cyclohexene-1-carboxylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(222630, NULL, 'G3DSA:3.40.50.720:FF:001548', NULL, NULL, 'Short-chain dehydrogenase/reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222631, NULL, 'G3DSA:1.25.10.10:FF:002616', NULL, NULL, 'Importin subunit beta-5', NULL, NULL, NULL, NULL, NULL, 4),
(222632, NULL, 'G3DSA:3.40.50.300:FF:000798', NULL, NULL, 'Probable helicase senataxin', NULL, NULL, NULL, NULL, NULL, 4),
(222633, NULL, 'G3DSA:3.30.980.10:FF:000047', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222634, NULL, 'G3DSA:3.30.230.120:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222635, NULL, 'G3DSA:1.10.490.10:FF:000027', NULL, NULL, 'Flavohemoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(222636, NULL, 'G3DSA:3.30.1330.60:FF:000018', NULL, NULL, 'Major outer membrane protein OmpA', NULL, NULL, NULL, NULL, NULL, 4),
(222637, NULL, 'G3DSA:3.40.50.300:FF:001074', NULL, NULL, 'Nucleotide binding oligomerization domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(222638, NULL, 'G3DSA:3.40.50.150:FF:001225', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222639, NULL, 'G3DSA:2.30.29.30:FF:000767', NULL, NULL, 'sprouty-related, EVH1 domain-containing protein 2-like', NULL, NULL, NULL, NULL, NULL, 4),
(222640, NULL, 'G3DSA:2.120.10.30:FF:000023', NULL, NULL, 'Serum paraoxonase/arylesterase 2', NULL, NULL, NULL, NULL, NULL, 4),
(222641, NULL, 'G3DSA:2.130.10.10:FF:000399', NULL, NULL, 'Ribosome biogenesis protein WDR12 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(222642, NULL, 'G3DSA:3.40.470.10:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222643, NULL, 'G3DSA:2.40.10.10:FF:000307', NULL, NULL, 'Zgc:165423 protein', NULL, NULL, NULL, NULL, NULL, 4),
(222644, NULL, 'G3DSA:3.30.70.2850:FF:000002', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(222645, NULL, 'G3DSA:1.20.58.570:FF:000002', NULL, NULL, 'F-actin-capping protein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(222646, NULL, 'G3DSA:3.30.260.10:FF:000026', NULL, NULL, 'T-complex protein 1, zeta subunit', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(222647, NULL, 'G3DSA:3.90.120.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222648, NULL, 'G3DSA:3.40.50.11030:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222649, NULL, 'G3DSA:2.60.40.10:FF:002220', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(222650, NULL, 'G3DSA:3.20.20.30:FF:000021', NULL, NULL, 'Alkanesulfonate monooxygenase SsuD/methylene tetrahydromethanopterin reductase-like flavin-dependent oxidoreductase (Luciferase family)', NULL, NULL, NULL, NULL, NULL, 4),
(222651, NULL, 'G3DSA:1.20.120.1200:FF:000007', NULL, NULL, 'NADH-quinone oxidoreductase subunit J', NULL, NULL, NULL, NULL, NULL, 4),
(222652, NULL, 'G3DSA:2.30.29.30:FF:001043', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222653, NULL, 'G3DSA:3.30.160.20:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222654, NULL, 'G3DSA:3.40.395.10:FF:000050', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222655, NULL, 'G3DSA:3.30.460.80:FF:000006', NULL, NULL, 'NADH-quinone oxidoreductase subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(222656, NULL, 'G3DSA:2.60.120.650:FF:000140', NULL, NULL, 'tRNA wybutosine-synthesizing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(222657, NULL, 'G3DSA:3.10.280.10:FF:000015', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(222658, NULL, 'G3DSA:1.20.1110.10:FF:000075', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(222659, NULL, 'G3DSA:1.10.520.10:FF:000025', NULL, NULL, 'Ascorbate peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(222660, NULL, 'G3DSA:1.10.10.60:FF:000388', NULL, NULL, 'Transcription factor RAX2', NULL, NULL, NULL, NULL, NULL, 4),
(222661, NULL, 'G3DSA:2.130.10.10:FF:001692', NULL, NULL, 'Vps15p', NULL, NULL, NULL, NULL, NULL, 4),
(222662, NULL, 'G3DSA:2.40.50.140:FF:000602', NULL, NULL, 'Unplaced genomic scaffold supercont2.11, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(222663, NULL, 'G3DSA:3.30.420.40:FF:000464', NULL, NULL, 'Actin-related protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(222664, NULL, 'G3DSA:3.30.450.50:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222665, NULL, 'G3DSA:4.10.1000.10:FF:000050', NULL, NULL, 'AGAP008634-PA', NULL, NULL, NULL, NULL, NULL, 4),
(222666, NULL, 'G3DSA:3.30.230.10:FF:000311', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222667, NULL, 'G3DSA:2.170.180.11:FF:000003', NULL, NULL, 'GD11003', NULL, NULL, NULL, NULL, NULL, 4),
(222668, NULL, 'G3DSA:1.10.1040.50:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222669, NULL, 'G3DSA:3.80.10.10:FF:002496', NULL, NULL, 'Ras guanine nucleotide exchange factor V', NULL, NULL, NULL, NULL, NULL, 4),
(222670, NULL, 'G3DSA:2.120.10.30:FF:000147', NULL, NULL, 'Unplaced genomic scaffold supercont1.9, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(222671, NULL, 'G3DSA:3.30.160.60:FF:002433', NULL, NULL, 'Zinc finger protein 1168', NULL, NULL, NULL, NULL, NULL, 4),
(222672, NULL, 'G3DSA:3.20.20.140:FF:000445', NULL, NULL, 'Non-ATP-dependent L-selective hydantoinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222673, NULL, 'G3DSA:2.30.30.140:FF:000089', NULL, NULL, 'Male-specific lethal 3', NULL, NULL, NULL, NULL, NULL, 4),
(222674, NULL, 'G3DSA:1.10.510.10:FF:002216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222675, NULL, 'G3DSA:3.40.1110.10:FF:000086', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(222676, NULL, 'G3DSA:1.10.8.750:FF:000003', NULL, NULL, 'Probable phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(222677, NULL, 'G3DSA:3.30.160.60:FF:005867', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222678, NULL, 'G3DSA:2.70.170.10:FF:000273', NULL, NULL, 'SD10415p', NULL, NULL, NULL, NULL, NULL, 4),
(222679, NULL, 'G3DSA:3.20.20.80:FF:000007', NULL, NULL, 'Acidic mammalian chitinase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(222680, NULL, 'G3DSA:2.40.30.130:FF:000033', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(222681, NULL, 'G3DSA:3.40.50.300:FF:000427', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NUBP1', NULL, NULL, NULL, NULL, NULL, 4),
(222682, NULL, 'G3DSA:1.10.510.10:FF:001053', NULL, NULL, 'Related to VPS15-ser/thr protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(222683, NULL, 'G3DSA:1.10.472.10:FF:000019', NULL, NULL, 'transcription initiation factor IIB', NULL, NULL, NULL, NULL, NULL, 4),
(222684, NULL, 'G3DSA:3.10.580.10:FF:000139', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222685, NULL, 'G3DSA:3.10.450.50:FF:000006', NULL, NULL, 'NTF2-related export protein 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(222686, NULL, 'G3DSA:2.130.10.10:FF:002164', NULL, NULL, 'Telomerase protein component 1', NULL, NULL, NULL, NULL, NULL, 4),
(222687, NULL, 'G3DSA:3.40.50.720:FF:001571', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222688, NULL, 'G3DSA:3.40.50.880:FF:000112', NULL, NULL, 'Class I glutamine amidotransferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(222689, NULL, 'G3DSA:2.60.120.620:FF:000029', NULL, NULL, 'Probable prolyl 4-hydroxylase 12', NULL, NULL, NULL, NULL, NULL, 4),
(222690, NULL, 'G3DSA:2.60.40.10:FF:001051', NULL, NULL, 'HERV-H LTR-associating 2', NULL, NULL, NULL, NULL, NULL, 4),
(222691, NULL, 'G3DSA:3.40.50.1100:FF:000284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222692, NULL, 'G3DSA:3.40.50.300:FF:008504', NULL, NULL, 'UvrD/REP helicase domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222693, NULL, 'G3DSA:1.10.1420.10:FF:000185', NULL, NULL, 'MutS domain III family protein', NULL, NULL, NULL, NULL, NULL, 4),
(222694, NULL, 'G3DSA:3.30.160.60:FF:003737', NULL, NULL, 'zinc finger protein 429-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(222695, NULL, 'G3DSA:1.25.40.10:FF:001882', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222696, NULL, 'G3DSA:2.40.50.140:FF:000310', NULL, NULL, 'Probable asparagine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(222697, NULL, 'G3DSA:1.10.510.10:FF:002155', NULL, NULL, 'Tyrosine kinase-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222698, NULL, 'G3DSA:2.40.10.10:FF:000044', NULL, NULL, 'polyserase-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(222699, NULL, 'G3DSA:3.90.1170.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222700, NULL, 'G3DSA:3.40.50.1820:FF:001455', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222701, NULL, 'G3DSA:3.40.50.12500:FF:000005', NULL, NULL, 'Hydantoin racemase', NULL, NULL, NULL, NULL, NULL, 4),
(222702, NULL, 'G3DSA:3.60.21.10:FF:000364', NULL, NULL, 'Protein CBG18709', NULL, NULL, NULL, NULL, NULL, 4),
(222703, NULL, 'G3DSA:1.25.10.10:FF:000273', NULL, NULL, 'Huntingtin', NULL, NULL, NULL, NULL, NULL, 4),
(222704, NULL, 'G3DSA:1.10.10.10:FF:000154', NULL, NULL, 'DNA-binding transcriptional regulator ModE', NULL, NULL, NULL, NULL, NULL, 4),
(222705, NULL, 'G3DSA:1.10.418.10:FF:000203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222706, NULL, 'G3DSA:2.120.10.80:FF:000302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222707, NULL, 'G3DSA:1.10.238.10:FF:000464', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase cyk-3', NULL, NULL, NULL, NULL, NULL, 4),
(222708, NULL, 'G3DSA:3.50.50.60:FF:001379', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222709, NULL, 'G3DSA:2.40.70.10:FF:000053', NULL, NULL, 'Eukaryotic aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(222710, NULL, 'G3DSA:1.10.533.10:FF:000280', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222711, NULL, 'G3DSA:3.30.40.10:FF:001516', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222712, NULL, 'G3DSA:2.40.20.10:FF:000016', NULL, NULL, 'Coagulation factor XII', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(222713, NULL, 'G3DSA:3.30.497.10:FF:000008', NULL, NULL, 'antithrombin-III isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(222714, NULL, 'G3DSA:3.40.50.300:FF:006413', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222715, NULL, 'G3DSA:2.70.170.10:FF:000087', NULL, NULL, 'Gamma-aminobutyric acid type A receptor alpha6 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(222716, NULL, 'G3DSA:3.30.420.40:FF:000424', NULL, NULL, 'Chaperone protein dnaK, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222717, NULL, 'G3DSA:2.60.40.10:FF:004277', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222718, NULL, 'G3DSA:3.30.160.60:FF:002635', NULL, NULL, 'Zinc finger protein 678', NULL, NULL, NULL, NULL, NULL, 4),
(222719, NULL, 'G3DSA:1.10.10.10:FF:000800', NULL, NULL, 'Ubiquitin-protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222720, NULL, 'G3DSA:3.30.160.60:FF:000983', NULL, NULL, 'zinc finger protein 385B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(222721, NULL, 'G3DSA:3.30.200.20:FF:002291', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(222722, NULL, 'G3DSA:3.40.640.10:FF:000194', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222723, NULL, 'G3DSA:3.90.550.10:FF:000636', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222724, NULL, 'G3DSA:3.10.20.90:FF:000404', NULL, NULL, 'Ubiquitin-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(222725, NULL, 'G3DSA:2.30.30.40:FF:000144', NULL, NULL, 'Disks large 1 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(222726, NULL, 'G3DSA:3.30.530.20:FF:000067', NULL, NULL, 'Aha1 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(222727, NULL, 'G3DSA:3.30.70.330:FF:001550', NULL, NULL, 'Putative splicing factor C222.18', NULL, NULL, NULL, NULL, NULL, 4),
(222728, NULL, 'G3DSA:1.25.40.10:FF:000454', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g47530', NULL, NULL, NULL, NULL, NULL, 4),
(222729, NULL, 'G3DSA:1.20.1250.20:FF:001690', NULL, NULL, 'Monocarboxylate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222730, NULL, 'G3DSA:3.40.50.1000:FF:000193', NULL, NULL, 'Plasma membrane calcium-transporting ATPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(222731, NULL, 'G3DSA:1.25.10.10:FF:000952', NULL, NULL, 'U-box domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(222732, NULL, 'G3DSA:2.30.30.30:FF:000141', NULL, NULL, '60S ribosomal protein L14', NULL, NULL, NULL, NULL, NULL, 4),
(222733, NULL, 'G3DSA:3.10.110.10:FF:000262', NULL, NULL, 'Ubiquitin protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222734, NULL, 'G3DSA:1.20.1310.10:FF:000051', NULL, NULL, 'cullin homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(222735, NULL, 'G3DSA:2.60.40.10:FF:003288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222736, NULL, 'G3DSA:3.30.565.10:FF:000560', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222737, NULL, 'G3DSA:1.20.120.430:FF:000005', NULL, NULL, 'tRNA modification GTPase MnmE', NULL, NULL, NULL, NULL, NULL, 4),
(222738, NULL, 'G3DSA:3.30.160.60:FF:004726', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222739, NULL, 'G3DSA:3.40.630.30:FF:000435', NULL, NULL, 'Sll1552 protein', NULL, NULL, NULL, NULL, NULL, 4),
(222740, NULL, 'G3DSA:1.25.40.790:FF:000003', NULL, NULL, 'CCR4-NOT transcription complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(222741, NULL, 'G3DSA:1.10.510.10:FF:000390', NULL, NULL, 'Mitotic checkpoint serine/threonine-protein kinase BUB1', NULL, NULL, NULL, NULL, NULL, 4),
(222742, NULL, 'G3DSA:3.30.70.1230:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222743, NULL, 'G3DSA:3.30.450.40:FF:000252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222744, NULL, 'G3DSA:2.60.40.10:FF:002186', NULL, NULL, 'Sallimus, isoform P', NULL, NULL, NULL, NULL, NULL, 4),
(222745, NULL, 'G3DSA:3.10.105.10:FF:000047', NULL, NULL, 'ABC transporter, substrate-binding protein, family 5', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(222746, NULL, 'G3DSA:3.80.10.10:FF:003378', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222747, NULL, 'G3DSA:1.20.1280.50:FF:000099', NULL, NULL, 'F-box/kelch-repeat protein At1g51550', NULL, NULL, NULL, NULL, NULL, 4),
(222748, NULL, 'G3DSA:1.25.40.20:FF:000457', NULL, NULL, 'Protein CBR-VAB-19', NULL, NULL, NULL, NULL, NULL, 4),
(222749, NULL, 'G3DSA:3.30.160.60:FF:000657', NULL, NULL, 'GDNF inducible zinc finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(222750, NULL, 'G3DSA:1.10.110.10:FF:000016', NULL, NULL, 'Bifunctional inhibitor/lipid-transfer protein/seed storage 2S albumin superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(222751, NULL, 'G3DSA:1.20.1310.20:FF:000054', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(222752, NULL, 'G3DSA:3.30.420.40:FF:000750', NULL, NULL, 'Patothenate kinase, fumble family protein', NULL, NULL, NULL, NULL, NULL, 4),
(222753, NULL, 'G3DSA:1.20.1310.10:FF:000197', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222754, NULL, 'G3DSA:3.30.160.60:FF:006290', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222755, NULL, 'G3DSA:1.10.8.60:FF:000488', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222756, NULL, 'G3DSA:3.40.1010.10:FF:000005', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase I', NULL, NULL, NULL, NULL, NULL, 4),
(222757, NULL, 'G3DSA:1.10.3720.10:FF:000197', NULL, NULL, 'ABC transporter permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(222758, NULL, 'G3DSA:3.30.200.20:FF:001829', NULL, NULL, 'Serine/threonine-protein kinase NEK', NULL, NULL, NULL, NULL, NULL, 4),
(222759, NULL, 'G3DSA:1.25.10.10:FF:002397', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222760, NULL, 'G3DSA:3.90.1450.10:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222761, NULL, 'G3DSA:1.25.40.10:FF:004523', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222762, NULL, 'G3DSA:1.10.238.10:FF:000138', NULL, NULL, 'Calcium-binding mitochondrial carrier protein SCaMC-1', NULL, NULL, NULL, NULL, NULL, 4),
(222763, NULL, 'G3DSA:3.40.50.300:FF:002518', NULL, NULL, 'Rhb1p', NULL, NULL, NULL, NULL, NULL, 4),
(222764, NULL, 'G3DSA:3.30.9.90:FF:000006', NULL, NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(222765, NULL, 'G3DSA:1.10.760.10:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222766, NULL, 'G3DSA:3.30.70.330:FF:002213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222767, NULL, 'G3DSA:1.10.10.720:FF:000003', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(222768, NULL, 'G3DSA:2.120.10.30:FF:000074', NULL, NULL, 'Blast:Protein wech', NULL, NULL, NULL, NULL, NULL, 4),
(222769, NULL, 'G3DSA:3.30.40.10:FF:000414', NULL, NULL, 'E3 ubiquitin protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(222770, NULL, 'G3DSA:3.30.160.60:FF:000511', NULL, NULL, 'zinc finger protein 692 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(222771, NULL, 'G3DSA:3.30.40.10:FF:001842', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222772, NULL, 'G3DSA:2.60.40.150:FF:000059', NULL, NULL, 'Axin interactor, dorsalization-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(222773, NULL, 'G3DSA:1.10.510.10:FF:002481', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222774, NULL, 'G3DSA:1.10.730.10:FF:000075', NULL, NULL, 'Putative leucyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(222775, NULL, 'G3DSA:1.10.630.10:FF:000657', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222776, NULL, 'G3DSA:3.40.50.1820:FF:000320', NULL, NULL, 'Abhydrolase domain-containing protein abhd-5.2', NULL, NULL, NULL, NULL, NULL, 4),
(222777, NULL, 'G3DSA:1.20.120.420:FF:000002', NULL, NULL, 'Methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(222778, NULL, 'G3DSA:3.90.770.10:FF:000001', NULL, NULL, '3-hydroxy-3-methylglutaryl coenzyme A reductase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(222779, NULL, 'G3DSA:3.30.540.10:FF:000003', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(222780, NULL, 'G3DSA:1.10.580.10:FF:000012', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(222781, NULL, 'G3DSA:3.40.50.150:FF:000186', NULL, NULL, 'Fatty acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(222782, NULL, 'G3DSA:2.60.40.1180:FF:000141', NULL, NULL, 'Alpha-glucosidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(222783, NULL, 'G3DSA:1.10.10.10:FF:000480', NULL, NULL, 'Transcriptional regulator, AsnC family', NULL, NULL, NULL, NULL, NULL, 4),
(222784, NULL, 'G3DSA:3.30.310.270:FF:000002', NULL, NULL, 'BicC family RNA binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(222785, NULL, 'G3DSA:3.40.50.2000:FF:000071', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(222786, NULL, 'G3DSA:3.30.1310.10:FF:000002', NULL, NULL, 'Nucleoid-associated protein IKC_06587', NULL, NULL, NULL, NULL, NULL, 4),
(222787, NULL, 'G3DSA:3.90.79.10:FF:000153', NULL, NULL, 'Nudix hydrolase 7', NULL, NULL, NULL, NULL, NULL, 4),
(222788, NULL, 'G3DSA:3.40.50.720:FF:000789', NULL, NULL, 'Sugar epimerase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(222789, NULL, 'G3DSA:3.40.720.10:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222790, NULL, 'G3DSA:3.40.50.300:FF:006060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222791, NULL, 'G3DSA:3.10.170.20:FF:000009', NULL, NULL, 'Cell surface protease gp63, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222792, NULL, 'G3DSA:3.20.20.70:FF:000196', NULL, NULL, 'S-adenosyl-L-methionine-dependent tRNA 4-demethylwyosine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(222793, NULL, 'G3DSA:1.10.10.10:FF:001582', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(222794, NULL, 'G3DSA:2.30.180.10:FF:000086', NULL, NULL, 'FAS1 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(222795, NULL, 'G3DSA:3.30.70.330:FF:000122', NULL, NULL, 'Splicing factor U2AF small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(222796, NULL, 'G3DSA:1.20.58.1980:FF:000002', NULL, NULL, 'Kinesin-like_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(222797, NULL, 'G3DSA:1.10.510.10:FF:000710', NULL, NULL, 'Serine/threonine-protein kinase WAG1-like', NULL, NULL, NULL, NULL, NULL, 4),
(222798, NULL, 'G3DSA:3.40.140.10:FF:000049', NULL, NULL, 'C->U-editing enzyme APOBEC-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(222799, NULL, 'G3DSA:1.20.1080.10:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222800, NULL, 'G3DSA:3.30.160.60:FF:001500', NULL, NULL, 'Zinc finger protein 292', NULL, NULL, NULL, NULL, NULL, 4),
(222801, NULL, 'G3DSA:1.10.472.80:FF:000259', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222802, NULL, 'G3DSA:3.40.50.300:FF:008184', NULL, NULL, 'GTP-binding protein-related', NULL, NULL, NULL, NULL, NULL, 4),
(222803, NULL, 'G3DSA:1.10.472.10:FF:000345', NULL, NULL, 'Cyclin-D2-1', NULL, NULL, NULL, NULL, NULL, 4),
(222804, NULL, 'G3DSA:3.40.1700.10:FF:000007', NULL, NULL, 'Diadenylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(222805, NULL, 'G3DSA:3.80.10.10:FF:001933', NULL, NULL, 'Receptor-like protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(222806, NULL, 'G3DSA:3.30.465.10:FF:000024', NULL, NULL, 'Oxidoreductase, FAD-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(222807, NULL, 'G3DSA:3.30.830.10:FF:000076', NULL, NULL, 'Mitochondrial processing peptide beta subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222808, NULL, 'G3DSA:3.40.50.1000:FF:000872', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222809, NULL, 'G3DSA:3.90.940.10:FF:000008', NULL, NULL, 'DNA-directed RNA polymerase I, II, AND III, subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(222810, NULL, 'G3DSA:3.40.50.1240:FF:000034', NULL, NULL, 'Transcription factor TFIIIC subunit', NULL, NULL, NULL, NULL, NULL, 4),
(222811, NULL, 'G3DSA:1.10.510.10:FF:000917', NULL, NULL, 'Serine/threonine-protein kinase KIN3', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(222812, NULL, 'G3DSA:3.40.50.720:FF:001278', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(+)]', NULL, NULL, NULL, NULL, NULL, 4),
(222813, NULL, 'G3DSA:3.90.70.10:FF:000633', NULL, NULL, 'General secretion pathway protein A', NULL, NULL, NULL, NULL, NULL, 4),
(222814, NULL, 'G3DSA:3.90.1750.10:FF:000049', NULL, NULL, 'G2/M phase-specific E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(222815, NULL, 'G3DSA:3.40.1650.10:FF:000008', NULL, NULL, 'Fucose-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(222816, NULL, 'G3DSA:3.40.50.300:FF:000753', NULL, NULL, 'Polymerase (DNA directed), theta', NULL, NULL, NULL, NULL, NULL, 4),
(222817, NULL, 'G3DSA:3.40.50.300:FF:003333', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(222818, NULL, 'G3DSA:3.30.70.20:FF:000071', NULL, NULL, 'Ferredoxin-type protein NapF', NULL, NULL, NULL, NULL, NULL, 4),
(222819, NULL, 'G3DSA:3.40.50.300:FF:006559', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222820, NULL, 'G3DSA:3.30.450.30:FF:000069', NULL, NULL, 'Profilin', NULL, NULL, NULL, NULL, NULL, 4),
(222821, NULL, 'G3DSA:2.40.50.140:FF:001092', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222822, NULL, 'G3DSA:3.40.50.2020:FF:000077', NULL, NULL, 'Phosphoribosyl pyrophosphate synthetase 2', NULL, NULL, NULL, NULL, NULL, 4),
(222823, NULL, 'G3DSA:3.80.10.10:FF:001254', NULL, NULL, 'GD14431', NULL, NULL, NULL, NULL, NULL, 4),
(222824, NULL, 'G3DSA:3.50.50.60:FF:000131', NULL, NULL, '3-hydroxybenzoate 6-monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(222825, NULL, 'G3DSA:3.40.50.300:FF:002844', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(222826, NULL, 'G3DSA:2.60.40.10:FF:005120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222827, NULL, 'G3DSA:3.40.30.10:FF:000947', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222828, NULL, 'G3DSA:3.30.505.10:FF:000225', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222829, NULL, 'G3DSA:3.90.79.10:FF:000214', NULL, NULL, 'Nudix hydrolase 16 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(222830, NULL, 'G3DSA:1.10.10.10:FF:002071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222831, NULL, 'G3DSA:3.40.50.670:FF:000021', NULL, NULL, 'DNA gyrase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(222832, NULL, 'G3DSA:1.10.510.10:FF:000238', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(222833, NULL, 'G3DSA:3.40.50.720:FF:001778', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(222834, NULL, 'G3DSA:3.30.300.30:FF:000002', NULL, NULL, 'Long-chain fatty acid transport protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(222835, NULL, 'G3DSA:1.10.340.30:FF:000011', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(222836, NULL, 'G3DSA:3.90.70.10:FF:000133', NULL, NULL, 'Ubiquitin specific peptidase 35', NULL, NULL, NULL, NULL, NULL, 4),
(222837, NULL, 'G3DSA:1.20.1530.20:FF:000065', NULL, NULL, 'Cation/H(+) antiporter 20', NULL, NULL, NULL, NULL, NULL, 4),
(222838, NULL, 'G3DSA:2.40.30.170:FF:000051', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222839, NULL, 'G3DSA:3.90.230.10:FF:000062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222840, NULL, 'G3DSA:2.30.30.40:FF:000470', NULL, NULL, 'F-BAR and double SH3 domains protein 2 isoform X6', NULL, NULL, NULL, NULL, NULL, 4),
(222841, NULL, 'G3DSA:3.30.1460.50:FF:000002', NULL, NULL, 'Autophagy related 10', NULL, NULL, NULL, NULL, NULL, 4),
(222842, NULL, 'G3DSA:3.30.565.10:FF:000408', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222843, NULL, 'G3DSA:1.20.5.110:FF:000236', NULL, NULL, 'Qc-SNARE protein, Bet1/mBET1 family', NULL, NULL, NULL, NULL, NULL, 4),
(222844, NULL, 'G3DSA:3.40.50.150:FF:000865', NULL, NULL, 'Putative methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(222845, NULL, 'G3DSA:3.30.1340.10:FF:000004', NULL, NULL, 'HPr family phosphocarrier', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(222846, NULL, 'G3DSA:1.25.40.70:FF:000039', NULL, NULL, 'Protein CBG03566', NULL, NULL, NULL, NULL, NULL, 4),
(222847, NULL, 'G3DSA:3.30.200.20:FF:001981', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222848, NULL, 'G3DSA:3.40.50.300:FF:000692', NULL, NULL, 'Guanine nucleotide-binding protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(222849, NULL, 'G3DSA:3.80.10.10:FF:000152', NULL, NULL, 'F-box/LRR-repeat protein 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(222850, NULL, 'G3DSA:3.30.200.20:FF:000048', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(222851, NULL, 'G3DSA:3.40.50.300:FF:003979', NULL, NULL, 'mRNA cleavage and polyadenylation factor CLP1', NULL, NULL, NULL, NULL, NULL, 4),
(222852, NULL, 'G3DSA:3.10.300.10:FF:000006', NULL, NULL, 'DNA-3-methyladenine glycosylase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(222853, NULL, 'G3DSA:3.20.20.30:FF:000032', NULL, NULL, 'LLM class flavin-dependent oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(222854, NULL, 'G3DSA:2.30.110.10:FF:000019', NULL, NULL, 'PNPO isoform 11', NULL, NULL, NULL, NULL, NULL, 4),
(222855, NULL, 'G3DSA:1.25.40.530:FF:000004', NULL, NULL, 'Myosin VIIA', NULL, NULL, NULL, NULL, NULL, 4),
(222856, NULL, 'G3DSA:2.130.10.10:FF:004255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222857, NULL, 'G3DSA:3.30.230.70:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222858, NULL, 'G3DSA:3.40.50.12100:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222859, NULL, 'G3DSA:1.25.40.20:FF:000783', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222860, NULL, 'G3DSA:1.10.10.440:FF:000043', NULL, NULL, 'Unplaced genomic scaffold supercont1.18, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(222861, NULL, 'G3DSA:3.40.50.1820:FF:001629', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222862, NULL, 'G3DSA:3.30.450.200:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222863, NULL, 'G3DSA:1.10.510.10:FF:004279', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222864, NULL, 'G3DSA:1.20.1270.280:FF:000045', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222865, NULL, 'G3DSA:3.30.40.10:FF:000999', NULL, NULL, 'RING-H2_zinc_finger/Ring_finger_domain/Anaphase-promoting_complex_subunit_11_RING-H2_finger/Zinc_finger', NULL, NULL, NULL, NULL, NULL, 4),
(222866, NULL, 'G3DSA:3.40.50.2300:FF:001173', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222867, NULL, 'G3DSA:1.25.40.540:FF:000007', NULL, NULL, 'TAP42p protein', NULL, NULL, NULL, NULL, NULL, 4),
(222868, NULL, 'G3DSA:3.40.190.290:FF:000072', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(222869, NULL, 'G3DSA:4.10.400.10:FF:000117', NULL, NULL, 'Suppressor of tumorigenicity 14 protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(222870, NULL, 'G3DSA:3.10.100.10:FF:000025', NULL, NULL, 'Mannose receptor C-type 1', NULL, NULL, NULL, NULL, NULL, 4),
(222871, NULL, 'G3DSA:2.10.50.10:FF:000087', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 23', NULL, NULL, NULL, NULL, NULL, 4),
(222872, NULL, 'G3DSA:3.30.750.24:FF:000026', NULL, NULL, 'Sulfate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222873, NULL, 'G3DSA:2.60.40.2030:FF:000020', NULL, NULL, 'Adhesion G protein-coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(222874, NULL, 'G3DSA:2.60.40.10:FF:000915', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(222875, NULL, 'G3DSA:1.25.40.10:FF:000780', NULL, NULL, 'Pentatricopeptide repeat-containing protein isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(222876, NULL, 'G3DSA:3.30.160.60:FF:006317', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222877, NULL, 'G3DSA:3.30.160.60:FF:001000', NULL, NULL, 'Zinc finger and BTB domain-containing 40', NULL, NULL, NULL, NULL, NULL, 4),
(222878, NULL, 'G3DSA:3.40.50.11040:FF:000005', NULL, NULL, 'RNA cytidine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(222879, NULL, 'G3DSA:2.30.30.30:FF:000080', NULL, NULL, 'Eukaryotic translation initiation factor 5A', NULL, NULL, NULL, NULL, NULL, 4),
(222880, NULL, 'G3DSA:2.30.30.100:FF:000010', NULL, NULL, 'U6 snRNA-associated Sm-like protein LSm6', NULL, NULL, NULL, NULL, NULL, 4),
(222881, NULL, 'G3DSA:3.40.50.1000:FF:000254', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(222882, NULL, 'G3DSA:3.40.50.10470:FF:000025', NULL, NULL, '71 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(222883, NULL, 'G3DSA:3.40.190.290:FF:000100', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(222884, NULL, 'G3DSA:1.20.58.360:FF:000001', NULL, NULL, 'Probable E3 ubiquitin-protein ligase ipaH7.8', NULL, NULL, NULL, NULL, NULL, 4),
(222885, NULL, 'G3DSA:2.60.40.10:FF:001697', NULL, NULL, 'Titin a', NULL, NULL, NULL, NULL, NULL, 4),
(222886, NULL, 'G3DSA:3.30.830.10:FF:000222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222887, NULL, 'G3DSA:2.30.30.40:FF:000083', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(222888, NULL, 'G3DSA:3.40.50.11030:FF:000002', NULL, NULL, 'Sua5/YciO/YrdC/YwlC family protein', NULL, NULL, NULL, NULL, NULL, 4),
(222889, NULL, 'G3DSA:1.10.533.10:FF:000307', NULL, NULL, 'Interleukin 1 receptor associated kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(222890, NULL, 'G3DSA:3.40.30.10:FF:000801', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222891, NULL, 'G3DSA:3.60.21.10:FF:000190', NULL, NULL, 'Ser/Thr protein phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(222892, NULL, 'G3DSA:1.25.40.20:FF:000518', NULL, NULL, 'Ankyrin repeat domain-containing protein 20A1', NULL, NULL, NULL, NULL, NULL, 4),
(222893, NULL, 'G3DSA:3.50.30.10:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222894, NULL, 'G3DSA:1.10.238.10:FF:000638', NULL, NULL, 'Putative cytosolic ca2+-dependent cysteine protease calpain', NULL, NULL, NULL, NULL, NULL, 4),
(222895, NULL, 'G3DSA:2.60.40.10:FF:000415', NULL, NULL, 'receptor-type tyrosine-protein phosphatase O isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(222896, NULL, 'G3DSA:1.10.10.60:FF:000528', NULL, NULL, 'DNA-binding protein RAP1', NULL, NULL, NULL, NULL, NULL, 4),
(222897, NULL, 'G3DSA:3.30.70.330:FF:000268', NULL, NULL, '31 kDa ribonucleoprotein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(222898, NULL, 'G3DSA:1.10.246.60:FF:000003', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit J', NULL, NULL, NULL, NULL, NULL, 4),
(222899, NULL, 'G3DSA:1.20.5.4570:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222900, NULL, 'G3DSA:1.10.287.110:FF:000309', NULL, NULL, 'uncharacterized protein LOC100175116 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(222901, NULL, 'G3DSA:3.30.160.60:FF:006025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222902, NULL, 'G3DSA:3.40.50.1010:FF:000257', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222903, NULL, 'G3DSA:3.10.20.10:FF:000015', NULL, NULL, 'DNAation factor-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(222904, NULL, 'G3DSA:1.20.140.10:FF:000084', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(222905, NULL, 'G3DSA:1.10.510.10:FF:004072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222906, NULL, 'G3DSA:3.30.870.10:FF:000168', NULL, NULL, 'Phospholipase D superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(222907, NULL, 'G3DSA:3.30.40.10:FF:001342', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(222908, NULL, 'G3DSA:1.10.20.10:FF:000065', NULL, NULL, 'Histone H3-like centromeric protein A', NULL, NULL, NULL, NULL, NULL, 4),
(222909, NULL, 'G3DSA:2.20.28.120:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222910, NULL, 'G3DSA:1.10.418.20:FF:000032', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(222911, NULL, 'G3DSA:1.10.30.10:FF:000037', NULL, NULL, 'High mobility group protein B2', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(222912, NULL, 'G3DSA:4.10.400.10:FF:000089', NULL, NULL, 'Low-density lipoprotein receptor-related protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(222913, NULL, 'G3DSA:3.30.1520.10:FF:000102', NULL, NULL, 'SNX6 isoform 6', NULL, NULL, NULL, NULL, NULL, 4),
(222914, NULL, 'G3DSA:1.20.1420.30:FF:000065', NULL, NULL, 'Ca2+:Cation Antiporter (CaCA) protein', NULL, NULL, NULL, NULL, NULL, 4),
(222915, NULL, 'G3DSA:1.10.10.60:FF:000236', NULL, NULL, 'Fis family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(222916, NULL, 'G3DSA:1.20.5.340:FF:000046', NULL, NULL, 'Myosin-11 isoform x2', NULL, NULL, NULL, NULL, NULL, 4),
(222917, NULL, 'G3DSA:3.30.505.10:FF:000079', NULL, NULL, 'Suppressor of cytokine signaling 7', NULL, NULL, NULL, NULL, NULL, 4),
(222918, NULL, 'G3DSA:1.25.40.10:FF:002371', NULL, NULL, 'Os01g0197450 protein', NULL, NULL, NULL, NULL, NULL, 4),
(222919, NULL, 'G3DSA:1.20.1250.20:FF:001038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222920, NULL, 'G3DSA:3.30.70.330:FF:000622', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(222921, NULL, 'G3DSA:1.10.510.10:FF:001699', NULL, NULL, 'Inactive tyrosine-protein kinase kin-32', NULL, NULL, NULL, NULL, NULL, 4),
(222922, NULL, 'G3DSA:2.130.10.10:FF:001967', NULL, NULL, 'WD domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(222923, NULL, 'G3DSA:2.130.10.10:FF:000247', NULL, NULL, 'WD repeat-containing protein 72', NULL, NULL, NULL, NULL, NULL, 4),
(222924, NULL, 'G3DSA:2.60.34.20:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222925, NULL, 'G3DSA:2.30.29.30:FF:001318', NULL, NULL, 'Chromosome 7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(222926, NULL, 'G3DSA:2.60.40.790:FF:000195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222927, NULL, 'G3DSA:3.40.50.300:FF:006913', NULL, NULL, 'ATP-binding cassette sub-family E member 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(222928, NULL, 'G3DSA:3.40.140.10:FF:000228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222929, NULL, 'G3DSA:2.40.70.10:FF:000227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222930, NULL, 'G3DSA:2.10.50.30:FF:000008', NULL, NULL, 'Metabotropic GLutamate receptor family', NULL, NULL, NULL, NULL, NULL, 4),
(222931, NULL, 'G3DSA:3.30.160.60:FF:000718', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222932, NULL, 'G3DSA:3.30.200.20:FF:002026', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222933, NULL, 'G3DSA:1.10.10.1420:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222934, NULL, 'G3DSA:3.30.420.10:FF:000674', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222935, NULL, 'G3DSA:1.20.140.20:FF:000002', NULL, NULL, '[3-methyl-2-oxobutanoate dehydrogenase [lipoamide]] kinase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(222936, NULL, 'G3DSA:3.40.50.2300:FF:000071', NULL, NULL, 'Two-component DNA-binding response regulator ColR', NULL, NULL, NULL, NULL, NULL, 4),
(222937, NULL, 'G3DSA:1.20.144.10:FF:000143', NULL, NULL, 'Protein CBG02670', NULL, NULL, NULL, NULL, NULL, 4),
(222938, NULL, 'G3DSA:2.60.40.10:FF:000562', NULL, NULL, 'Snf1 kinase complex beta-subunit Gal83', NULL, NULL, NULL, NULL, NULL, 4),
(222939, NULL, 'G3DSA:3.80.10.10:FF:001080', NULL, NULL, 'Negative regulator of reactive oxygen species', NULL, NULL, NULL, NULL, NULL, 4),
(222940, NULL, 'G3DSA:3.30.160.60:FF:000483', NULL, NULL, 'Zinc finger protein 423', NULL, NULL, NULL, NULL, NULL, 4),
(222941, NULL, 'G3DSA:3.40.50.300:FF:002198', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(222942, NULL, 'G3DSA:2.70.170.10:FF:000115', NULL, NULL, 'Si:ch73-380n15.2', NULL, NULL, NULL, NULL, NULL, 4),
(222943, NULL, 'G3DSA:1.20.140.30:FF:000005', NULL, NULL, 'Putative cell cycle associated protein MOB1', NULL, NULL, NULL, NULL, NULL, 4),
(222944, NULL, 'G3DSA:2.30.30.40:FF:000318', NULL, NULL, 'Bud emergence protein 1', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(222945, NULL, 'G3DSA:2.130.10.10:FF:000539', NULL, NULL, 'Partner and localizer of BRCA2', NULL, NULL, NULL, NULL, NULL, 4),
(222946, NULL, 'G3DSA:3.30.730.10:FF:000012', NULL, NULL, 'Putative AP2/EREBP transcription factor superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(222947, NULL, 'G3DSA:3.40.50.150:FF:000539', NULL, NULL, 'juvenile hormone acid O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(222948, NULL, 'G3DSA:3.40.50.1910:FF:000021', NULL, NULL, 'Putative syntaxin binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(222949, NULL, 'G3DSA:2.10.25.10:FF:000809', NULL, NULL, 'Complement component C1q receptor', NULL, NULL, NULL, NULL, NULL, 4),
(222950, NULL, 'G3DSA:1.20.140.40:FF:000008', NULL, NULL, 'Invertase/pectin methylesterase inhibitor family protein', NULL, NULL, NULL, NULL, NULL, 4),
(222951, NULL, 'G3DSA:3.40.630.10:FF:000103', NULL, NULL, 'Aminoacyl-histidine dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(222952, NULL, 'G3DSA:3.10.20.90:FF:000258', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 24', NULL, NULL, NULL, NULL, NULL, 4),
(222953, NULL, 'G3DSA:3.90.1640.10:FF:000013', NULL, NULL, 'Prune', NULL, NULL, NULL, NULL, NULL, 4),
(222954, NULL, 'G3DSA:1.20.1070.10:FF:001650', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222955, NULL, 'G3DSA:2.40.170.10:FF:000004', NULL, NULL, 'Maltoporin', NULL, NULL, NULL, NULL, NULL, 4),
(222956, NULL, 'G3DSA:1.10.30.10:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222957, NULL, 'G3DSA:2.60.120.560:FF:000017', NULL, NULL, 'Levanase', NULL, NULL, NULL, NULL, NULL, 4),
(222958, NULL, 'G3DSA:1.20.120.1240:FF:000030', NULL, NULL, 'Dynamin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(222959, NULL, 'G3DSA:3.40.630.30:FF:000289', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222960, NULL, 'G3DSA:3.30.230.130:FF:000054', NULL, NULL, 'anaphase-promoting complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(222961, NULL, 'G3DSA:3.30.200.20:FF:002318', NULL, NULL, 'Receptor protein-tyrosine kinase CEPR2', NULL, NULL, NULL, NULL, NULL, 4),
(222962, NULL, 'G3DSA:3.90.550.10:FF:000462', NULL, NULL, 'Dolichol-phosphate mannosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(222963, NULL, 'G3DSA:2.130.10.10:FF:004608', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222964, NULL, 'G3DSA:3.40.50.300:FF:004143', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(222965, NULL, 'G3DSA:1.25.40.10:FF:004136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222966, NULL, 'G3DSA:3.40.30.10:FF:001144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222967, NULL, 'G3DSA:1.10.8.710:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222968, NULL, 'G3DSA:3.30.70.330:FF:002067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222969, NULL, 'G3DSA:1.10.540.10:FF:000066', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(222970, NULL, 'G3DSA:3.30.497.10:FF:000160', NULL, NULL, 'Serpin family B member 3', NULL, NULL, NULL, NULL, NULL, 4),
(222971, NULL, 'G3DSA:1.10.510.10:FF:000564', NULL, NULL, 'Phosphoenolpyruvate carboxylase kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(222972, NULL, 'G3DSA:2.20.70.10:FF:000037', NULL, NULL, 'E3 ubiquitin-protein ligase nedd-4', NULL, NULL, NULL, NULL, NULL, 4),
(222973, NULL, 'G3DSA:1.20.1110.10:FF:000070', NULL, NULL, 'Cation transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(222974, NULL, 'G3DSA:3.30.1490.40:FF:000001', NULL, NULL, 'GRB10-interacting GYF protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(222975, NULL, 'G3DSA:3.30.420.40:FF:000363', NULL, NULL, 'Heat shock protein 70 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(222976, NULL, 'G3DSA:2.120.10.30:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222977, NULL, 'G3DSA:3.40.50.300:FF:004435', NULL, NULL, 'TWiNKle mtDNA helicase homolog', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(222978, NULL, 'G3DSA:1.20.920.30:FF:000071', NULL, NULL, 'Dynein axonemal heavy chain 14', NULL, NULL, NULL, NULL, NULL, 4),
(222979, NULL, 'G3DSA:3.90.1410.10:FF:000058', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(222980, NULL, 'G3DSA:1.25.10.10:FF:002251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222981, NULL, 'G3DSA:1.25.40.490:FF:000003', NULL, NULL, 'FA complementation group F', NULL, NULL, NULL, NULL, NULL, 4),
(222982, NULL, 'G3DSA:3.30.160.60:FF:002282', NULL, NULL, 'Wu:fb97d07 protein', NULL, NULL, NULL, NULL, NULL, 4),
(222983, NULL, 'G3DSA:3.20.20.70:FF:000696', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222984, NULL, 'G3DSA:3.80.10.10:FF:000798', NULL, NULL, 'TropoMoDulin', NULL, NULL, NULL, NULL, NULL, 4),
(222985, NULL, 'G3DSA:4.10.110.10:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222986, NULL, 'G3DSA:2.30.39.10:FF:000088', NULL, NULL, 'AGAP009670-PA', NULL, NULL, NULL, NULL, NULL, 4),
(222987, NULL, 'G3DSA:3.30.1490.50:FF:000004', NULL, NULL, 'Glutathione synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(222988, NULL, 'G3DSA:2.60.40.820:FF:000013', NULL, NULL, 'T-box transcription factor tbx-9', NULL, NULL, NULL, NULL, NULL, 4),
(222989, NULL, 'G3DSA:1.20.1310.10:FF:000225', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222990, NULL, 'G3DSA:2.60.40.10:FF:000741', NULL, NULL, 'Interleukin 5 receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(222991, NULL, 'G3DSA:3.30.70.330:FF:002859', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222992, NULL, 'G3DSA:3.30.2340.10:FF:000004', NULL, NULL, 'tRNA pseudouridine synthase D', NULL, NULL, NULL, NULL, NULL, 4),
(222993, NULL, 'G3DSA:1.10.10.60:FF:000854', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222994, NULL, 'G3DSA:3.40.50.300:FF:008358', NULL, NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 8', NULL, NULL, NULL, NULL, NULL, 4),
(222995, NULL, 'G3DSA:2.60.40.10:FF:003203', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(222996, NULL, 'G3DSA:3.90.226.10:FF:000310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222997, NULL, 'G3DSA:3.30.40.10:FF:001196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(222998, NULL, 'G3DSA:2.160.20.10:FF:000241', NULL, NULL, 'Os02g0196700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(222999, NULL, 'G3DSA:3.60.15.10:FF:000012', NULL, NULL, 'Hydroxyacylglutathione hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(223000, NULL, 'G3DSA:1.10.472.10:FF:000171', NULL, NULL, 'Protein CBG05210', NULL, NULL, NULL, NULL, NULL, 4),
(223001, NULL, 'G3DSA:1.10.560.10:FF:000128', NULL, NULL, 'TCP-1/cpn60 chaperonin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(223002, NULL, 'G3DSA:3.50.50.60:FF:000423', NULL, NULL, 'FAD/NAD(P)-binding oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(223003, NULL, 'G3DSA:2.10.70.10:FF:000296', NULL, NULL, 'Sushi, von Willebrand factor type A, EGF and pentraxin domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(223004, NULL, 'G3DSA:2.130.10.10:FF:004401', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223005, NULL, 'G3DSA:3.40.50.300:FF:003041', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223006, NULL, 'G3DSA:3.40.50.300:FF:005896', NULL, NULL, 'General secretion pathway protein E', NULL, NULL, NULL, NULL, NULL, 4),
(223007, NULL, 'G3DSA:2.60.210.10:FF:000020', NULL, NULL, 'Traf3, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(223008, NULL, 'G3DSA:2.60.40.10:FF:004305', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223009, NULL, 'G3DSA:2.60.40.60:FF:000823', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223010, NULL, 'G3DSA:1.10.10.10:FF:000772', NULL, NULL, 'ECF RNA polymerase sigma factor SigM', NULL, NULL, NULL, NULL, NULL, 4),
(223011, NULL, 'G3DSA:3.30.1370.10:FF:000011', NULL, NULL, 'KRR1 small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(223012, NULL, 'G3DSA:3.80.10.10:FF:003850', NULL, NULL, 'Protein phosphatase 2C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223013, NULL, 'G3DSA:2.60.120.10:FF:000249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223014, NULL, 'G3DSA:3.40.640.10:FF:000340', NULL, NULL, '3-amino-5-hydroxybenzoic acid synthase', NULL, NULL, NULL, NULL, NULL, 4),
(223015, NULL, 'G3DSA:3.10.100.10:FF:000317', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223016, NULL, 'G3DSA:3.40.50.300:FF:005250', NULL, NULL, 'AAA domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223017, NULL, 'G3DSA:1.10.510.10:FF:000890', NULL, NULL, 'Blast:Serine/threonine-protein kinase 16', NULL, NULL, NULL, NULL, NULL, 4),
(223018, NULL, 'G3DSA:1.20.1250.20:FF:001364', NULL, NULL, 'Major facilitator superfamily MFS_1', NULL, NULL, NULL, NULL, NULL, 4),
(223019, NULL, 'G3DSA:3.40.50.2300:FF:001465', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223020, NULL, 'G3DSA:1.20.120.980:FF:000001', NULL, NULL, 'Dipeptidyl peptidase 7', NULL, NULL, NULL, NULL, NULL, 4),
(223021, NULL, 'G3DSA:3.20.20.70:FF:000549', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223022, NULL, 'G3DSA:3.40.50.1980:FF:000109', NULL, NULL, 'Vitamin B12 ABC transporter, B12-binding component BtuF', NULL, NULL, NULL, NULL, NULL, 4),
(223023, NULL, 'G3DSA:3.30.70.330:FF:001757', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223024, NULL, 'G3DSA:3.30.420.40:FF:000924', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223025, NULL, 'G3DSA:3.30.70.890:FF:000060', NULL, NULL, 'Diphosphomevalonate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(223026, NULL, 'G3DSA:3.40.50.1000:FF:000580', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223027, NULL, 'G3DSA:3.30.450.20:FF:000420', NULL, NULL, 'Sensor histidine kinase of FgrL, PAS domain-containing', NULL, NULL, NULL, NULL, NULL, 4),
(223028, NULL, 'G3DSA:1.20.1070.10:FF:001942', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223029, NULL, 'G3DSA:1.10.10.10:FF:001874', NULL, NULL, 'Nitrite reductase heme biosynthesis D/L protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223030, NULL, 'G3DSA:3.90.1140.10:FF:000020', NULL, NULL, 'RNA 2'',3''-cyclic phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(223031, NULL, 'G3DSA:3.40.630.10:FF:000283', NULL, NULL, 'Glutaminyl cyclase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223032, NULL, 'G3DSA:4.10.280.10:FF:000028', NULL, NULL, 'MLX interacting protein like', NULL, NULL, NULL, NULL, NULL, 4),
(223033, NULL, 'G3DSA:2.130.10.10:FF:004581', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223034, NULL, 'G3DSA:3.40.50.300:FF:004761', NULL, NULL, 'ABC transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223035, NULL, 'G3DSA:3.30.160.60:FF:002309', NULL, NULL, 'Transcriptional regulator nrg2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223036, NULL, 'G3DSA:1.10.8.60:FF:000308', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(223037, NULL, 'G3DSA:2.110.10.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223038, NULL, 'G3DSA:3.40.50.2300:FF:000363', NULL, NULL, 'Loc683510', NULL, NULL, NULL, NULL, NULL, 4),
(223039, NULL, 'G3DSA:1.20.120.1750:FF:000121', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(223040, NULL, 'G3DSA:2.60.34.10:FF:000002', NULL, NULL, 'Heat shock 70 kDa', NULL, NULL, NULL, NULL, NULL, 4),
(223041, NULL, 'G3DSA:2.40.50.100:FF:000146', NULL, NULL, 'sn-glycerol-3-phosphate import ATP-binding protein UgpC', NULL, NULL, NULL, NULL, NULL, 4),
(223042, NULL, 'G3DSA:3.40.50.300:FF:007487', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223043, NULL, 'G3DSA:3.30.40.10:FF:000061', NULL, NULL, 'FYVE, RhoGEF and PH domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(223044, NULL, 'G3DSA:3.40.50.720:FF:001306', NULL, NULL, 'Malic enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(223045, NULL, 'G3DSA:2.130.10.10:FF:002810', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(223046, NULL, 'G3DSA:3.30.230.70:FF:000076', NULL, NULL, 'Putative ribosomal RNA processing protein', NULL, NULL, NULL, NULL, NULL, 4),
(223047, NULL, 'G3DSA:3.40.47.10:FF:000250', NULL, NULL, '3-hydroxy-3-methylglutaryl coenzyme A synthase', NULL, NULL, NULL, NULL, NULL, 4),
(223048, NULL, 'G3DSA:3.30.360.10:FF:000085', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223049, NULL, 'G3DSA:1.10.418.10:FF:000057', NULL, NULL, 'Calmin', NULL, NULL, NULL, NULL, NULL, 4),
(223050, NULL, 'G3DSA:1.25.40.120:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223051, NULL, 'G3DSA:2.60.40.150:FF:000385', NULL, NULL, 'Phosphatidylinositol 3-and 4-kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(223052, NULL, 'G3DSA:3.40.50.620:FF:000113', NULL, NULL, 'FAD synthase', NULL, NULL, NULL, NULL, NULL, 4),
(223053, NULL, 'G3DSA:2.30.29.30:FF:000216', NULL, NULL, 'FERM domain-containing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(223054, NULL, 'G3DSA:4.10.60.10:FF:000274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223055, NULL, 'G3DSA:3.40.50.1820:FF:001394', NULL, NULL, 'Alpha/beta hydrolase domain-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223056, NULL, 'G3DSA:3.90.190.20:FF:000010', NULL, NULL, 'Dihydrofolate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(223057, NULL, 'G3DSA:1.10.1000.11:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223058, NULL, 'G3DSA:1.25.40.10:FF:001909', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223059, NULL, 'G3DSA:3.30.565.10:FF:000234', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(223060, NULL, 'G3DSA:3.40.50.10810:FF:000144', NULL, NULL, 'SNF2 family N-terminal domain-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(223061, NULL, 'G3DSA:3.30.930.10:FF:000286', NULL, NULL, 'Anticodon binding domain of tRNAs-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(223062, NULL, 'G3DSA:2.30.30.40:FF:000644', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223063, NULL, 'G3DSA:3.30.70.120:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223064, NULL, 'G3DSA:2.60.40.200:FF:000035', NULL, NULL, 'Bursicon', NULL, NULL, NULL, NULL, NULL, 4),
(223065, NULL, 'G3DSA:3.20.10.10:FF:000048', NULL, NULL, 'Aminotransferase class IV, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223066, NULL, 'G3DSA:2.60.200.20:FF:000225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223067, NULL, 'G3DSA:3.40.50.720:FF:001924', NULL, NULL, 'Ornithine cyclodeaminase', NULL, NULL, NULL, NULL, NULL, 4),
(223068, NULL, 'G3DSA:2.10.25.10:FF:001624', NULL, NULL, 'Putative wall-associated receptor protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(223069, NULL, 'G3DSA:2.130.10.10:FF:000865', NULL, NULL, 'WD repeat domain 90', NULL, NULL, NULL, NULL, NULL, 4),
(223070, NULL, 'G3DSA:2.30.29.30:FF:000981', NULL, NULL, 'Cyclin-B1-3', NULL, NULL, NULL, NULL, NULL, 4),
(223071, NULL, 'G3DSA:1.20.120.140:FF:000042', NULL, NULL, 'SRP54-type protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223072, NULL, 'G3DSA:3.40.50.80:FF:000132', NULL, NULL, 'Nitric oxide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(223073, NULL, 'G3DSA:3.80.10.10:FF:001641', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223074, NULL, 'G3DSA:2.130.10.120:FF:000027', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223075, NULL, 'G3DSA:2.40.110.10:FF:000028', NULL, NULL, 'Acyl-coenzyme A dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(223076, NULL, 'G3DSA:1.10.510.10:FF:004307', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223077, NULL, 'G3DSA:2.40.50.140:FF:000282', NULL, NULL, 'Protein BREAST CANCER SUSCEPTIBILITY 2 homolog B', NULL, NULL, NULL, NULL, NULL, 4),
(223078, NULL, 'G3DSA:3.10.490.10:FF:000020', NULL, NULL, 'Gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(223079, NULL, 'G3DSA:2.130.10.110:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223080, NULL, 'G3DSA:3.90.550.10:FF:000136', NULL, NULL, 'Exostosin glycosyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(223081, NULL, 'G3DSA:1.10.287.110:FF:000282', NULL, NULL, 'DPH4 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(223082, NULL, 'G3DSA:3.90.550.50:FF:000215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223083, NULL, 'G3DSA:1.20.58.220:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223084, NULL, 'G3DSA:2.60.210.10:FF:000048', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223085, NULL, 'G3DSA:3.30.590.10:FF:000040', NULL, NULL, 'Glutamate--isopropylamine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(223086, NULL, 'G3DSA:3.30.160.60:FF:000157', NULL, NULL, 'Immunodeficiency virus type I enhancer binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(223087, NULL, 'G3DSA:2.170.260.10:FF:000019', NULL, NULL, 'Endoribonuclease Dicer-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(223088, NULL, 'G3DSA:3.30.1330.60:FF:000001', NULL, NULL, 'Peptidoglycan-associated lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(223089, NULL, 'G3DSA:3.40.50.300:FF:008212', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223090, NULL, 'G3DSA:3.40.50.1000:FF:000428', NULL, NULL, 'Aminophospholipid transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223091, NULL, 'G3DSA:2.60.120.40:FF:000056', NULL, NULL, 'Si:ch1073-184j22.1', NULL, NULL, NULL, NULL, NULL, 4),
(223092, NULL, 'G3DSA:3.30.40.10:FF:000122', NULL, NULL, 'polycomb group RING finger protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(223093, NULL, 'G3DSA:2.60.40.1960:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223094, NULL, 'G3DSA:2.160.20.10:FF:000033', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(223095, NULL, 'G3DSA:1.20.1250.20:FF:001925', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223096, NULL, 'G3DSA:1.25.40.990:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223097, NULL, 'G3DSA:1.20.190.50:FF:000020', NULL, NULL, 'Nuclear pore complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(223098, NULL, 'G3DSA:1.20.120.790:FF:000034', NULL, NULL, 'TNF receptor associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(223099, NULL, 'G3DSA:1.10.238.10:FF:000756', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223100, NULL, 'G3DSA:2.60.40.10:FF:000769', NULL, NULL, 'Cell surface glycoprotein CD200 receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(223101, NULL, 'G3DSA:4.10.800.10:FF:000018', NULL, NULL, 'CRE-MLT-11 protein', NULL, NULL, NULL, NULL, NULL, 4),
(223102, NULL, 'G3DSA:1.10.472.10:FF:000199', NULL, NULL, 'Putative cyclin-A3-1', NULL, NULL, NULL, NULL, NULL, 4),
(223103, NULL, 'G3DSA:2.60.120.200:FF:000140', NULL, NULL, 'Beta-glucan synthesis-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(223104, NULL, 'G3DSA:3.30.1330.80:FF:000007', NULL, NULL, 'AT-hook motif nuclear-localized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223105, NULL, 'G3DSA:1.20.58.1380:FF:000002', NULL, NULL, 'Nup133', NULL, NULL, NULL, NULL, NULL, 4),
(223106, NULL, 'G3DSA:2.30.30.750:FF:000002', NULL, NULL, '5''-3'' exoribonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(223107, NULL, 'G3DSA:3.30.160.60:FF:004108', NULL, NULL, 'Zgc:173486', NULL, NULL, NULL, NULL, NULL, 4),
(223108, NULL, 'G3DSA:3.55.50.30:FF:000022', NULL, NULL, 'Ferripyoverdine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(223109, NULL, 'G3DSA:3.30.470.30:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223110, NULL, 'G3DSA:1.25.40.20:FF:001154', NULL, NULL, 'Putative leucine-rich repeat serine/threonine-protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(223111, NULL, 'G3DSA:1.25.10.10:FF:002751', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223112, NULL, 'G3DSA:2.120.10.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(223113, NULL, 'G3DSA:1.20.5.470:FF:000001', NULL, NULL, 'Argininosuccinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(223114, NULL, 'G3DSA:3.10.290.10:FF:000038', NULL, NULL, 'Chromosome 15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(223115, NULL, 'G3DSA:1.10.10.10:FF:000980', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(223116, NULL, 'G3DSA:3.30.160.60:FF:002927', NULL, NULL, 'Zinc finger transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(223117, NULL, 'G3DSA:2.160.10.10:FF:000061', NULL, NULL, 'Eukaryotic initiation factor eIF2B epsilon subunit', NULL, NULL, NULL, NULL, NULL, 4),
(223118, NULL, 'G3DSA:2.10.220.10:FF:000217', NULL, NULL, 'Extracellular matrix protein FRAS1', NULL, NULL, NULL, NULL, NULL, 4),
(223119, NULL, 'G3DSA:2.10.25.10:FF:001063', NULL, NULL, 'Cell death abnormality protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(223120, NULL, 'G3DSA:3.20.20.80:FF:000232', NULL, NULL, 'Beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(223121, NULL, 'G3DSA:3.90.226.10:FF:000282', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase IvdE', NULL, NULL, NULL, NULL, NULL, 4),
(223122, NULL, 'G3DSA:3.40.50.2300:FF:000571', NULL, NULL, 'Two-component response regulator ORR2', NULL, NULL, NULL, NULL, NULL, 4),
(223123, NULL, 'G3DSA:3.40.50.300:FF:006059', NULL, NULL, 'DNA replication licensing factor MCM5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223124, NULL, 'G3DSA:3.30.830.10:FF:000137', NULL, NULL, 'Mitochondrial-processing peptidase (MPP) alpha subunit, mitochondrial, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223125, NULL, 'G3DSA:2.130.10.10:FF:002456', NULL, NULL, 'Transducin beta-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(223126, NULL, 'G3DSA:3.30.200.20:FF:001537', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223127, NULL, 'G3DSA:2.80.10.50:FF:000149', NULL, NULL, 'Botulinum neurotoxin type D', NULL, NULL, NULL, NULL, NULL, 4),
(223128, NULL, 'G3DSA:3.40.50.720:FF:001806', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223129, NULL, 'G3DSA:2.60.40.10:FF:004631', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223130, NULL, 'G3DSA:3.40.1280.10:FF:000114', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223131, NULL, 'G3DSA:2.130.10.10:FF:000747', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(223132, NULL, 'G3DSA:3.30.530.20:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223133, NULL, 'G3DSA:1.10.287.130:FF:000203', NULL, NULL, 'Hybrid sensor kinase RscS', NULL, NULL, NULL, NULL, NULL, 4),
(223134, NULL, 'G3DSA:2.60.40.150:FF:000677', NULL, NULL, 'Protein kinase C-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(223135, NULL, 'G3DSA:1.25.40.10:FF:000162', NULL, NULL, 'CTR9 homolog, Paf1/RNA polymerase II complex component', NULL, NULL, NULL, NULL, NULL, 4),
(223136, NULL, 'G3DSA:3.40.50.300:FF:000719', NULL, NULL, 'Zinc finger FYVE domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(223137, NULL, 'G3DSA:3.30.450.20:FF:000212', NULL, NULL, 'Diguanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(223138, NULL, 'G3DSA:2.40.10.10:FF:000336', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223139, NULL, 'G3DSA:3.40.50.1000:FF:000372', NULL, NULL, 'Putative NipSnap protein K02D10.1', NULL, NULL, NULL, NULL, NULL, 4),
(223140, NULL, 'G3DSA:1.25.40.20:FF:000165', NULL, NULL, 'calmodulin-binding transcription activator 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(223141, NULL, 'G3DSA:1.25.10.10:FF:001762', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223142, NULL, 'G3DSA:3.30.160.60:FF:000365', NULL, NULL, 'zinc finger protein 197 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(223143, NULL, 'G3DSA:2.30.42.10:FF:000174', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type 13', NULL, NULL, NULL, NULL, NULL, 4),
(223144, NULL, 'G3DSA:1.20.1070.10:FF:001824', NULL, NULL, 'G protein-coupled receptor 25', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(223145, NULL, 'G3DSA:3.40.50.300:FF:007695', NULL, NULL, 'Heparan sulfate 2-O-sulfotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223146, NULL, 'G3DSA:3.10.280.10:FF:000009', NULL, NULL, 'Mitochondrial glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(223147, NULL, 'G3DSA:2.130.10.10:FF:003884', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223148, NULL, 'G3DSA:3.30.70.1660:FF:000022', NULL, NULL, 'Peptide chain release factor H', NULL, NULL, NULL, NULL, NULL, 4),
(223149, NULL, 'G3DSA:3.30.70.330:FF:001842', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223150, NULL, 'G3DSA:3.90.550.10:FF:000344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223151, NULL, 'G3DSA:2.70.150.10:FF:000232', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(223152, NULL, 'G3DSA:3.80.10.10:FF:003086', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223153, NULL, 'G3DSA:2.70.130.10:FF:000169', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223154, NULL, 'G3DSA:2.60.40.10:FF:002478', NULL, NULL, 'Unplaced genomic scaffold supercont1.8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(223155, NULL, 'G3DSA:2.130.10.10:FF:002990', NULL, NULL, 'WD repeat-containing protein 36-like', NULL, NULL, NULL, NULL, NULL, 4),
(223156, NULL, 'G3DSA:3.30.60.70:FF:000001', NULL, NULL, '2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-succinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(223157, NULL, 'G3DSA:3.60.110.10:FF:000003', NULL, NULL, 'Glutamine-dependent NAD(+) synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(223158, NULL, 'G3DSA:3.40.640.10:FF:000014', NULL, NULL, 'Adenosylmethionine-8-amino-7-oxononanoate aminotransferase, probable', NULL, NULL, NULL, NULL, NULL, 4),
(223159, NULL, 'G3DSA:1.20.120.1150:FF:000003', NULL, NULL, 'Serine/threonine-protein phosphatase 2A activator', NULL, NULL, NULL, NULL, NULL, 4),
(223160, NULL, 'G3DSA:2.30.30.40:FF:000436', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223161, NULL, 'G3DSA:1.25.40.190:FF:000003', NULL, NULL, 'Actin-related protein 2/3 complex subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(223162, NULL, 'G3DSA:2.40.10.120:FF:000015', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(223163, NULL, 'G3DSA:3.30.40.10:FF:001550', NULL, NULL, 'E3 ubiquitin-protein ligase At4g11680 family', NULL, NULL, NULL, NULL, NULL, 4),
(223164, NULL, 'G3DSA:3.30.200.20:FF:000402', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(223165, NULL, 'G3DSA:3.30.40.10:FF:000499', NULL, NULL, 'RING-box protein 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(223166, NULL, 'G3DSA:3.40.50.300:FF:004261', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223167, NULL, 'G3DSA:3.50.50.60:FF:000631', NULL, NULL, 'tRNA 5-methylaminomethyl-2-thiouridine biosynthesis bifunctional protein MnmC', NULL, NULL, NULL, NULL, NULL, 4),
(223168, NULL, 'G3DSA:1.20.1090.10:FF:000044', NULL, NULL, 'NADH-dependent butanol dehydrogenase A', NULL, NULL, NULL, NULL, NULL, 4),
(223169, NULL, 'G3DSA:1.20.1280.50:FF:000245', NULL, NULL, 'F-box/WD repeat-containing protein pof11', NULL, NULL, NULL, NULL, NULL, 4),
(223170, NULL, 'G3DSA:3.30.70.330:FF:000061', NULL, NULL, 'cleavage stimulation factor subunit 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(223171, NULL, 'G3DSA:3.40.33.10:FF:000162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223172, NULL, 'G3DSA:2.60.40.10:FF:003849', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223173, NULL, 'G3DSA:1.25.70.10:FF:000102', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223174, NULL, 'G3DSA:1.10.287.110:FF:000248', NULL, NULL, 'DNAJ heat shock N-terminal domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(223175, NULL, 'G3DSA:3.30.160.20:FF:000201', NULL, NULL, 'R3D1', NULL, NULL, NULL, NULL, NULL, 4),
(223176, NULL, 'G3DSA:3.30.390.50:FF:000019', NULL, NULL, 'Lipoate--protein ligase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(223177, NULL, 'G3DSA:3.10.20.90:FF:000376', NULL, NULL, 'myosin-VIIa isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(223178, NULL, 'G3DSA:3.90.1150.10:FF:000346', NULL, NULL, 'Glutamine--scyllo-inositol transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(223179, NULL, 'G3DSA:3.30.70.330:FF:001578', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223180, NULL, 'G3DSA:1.20.1080.10:FF:000015', NULL, NULL, 'Aquaporin 8', NULL, NULL, NULL, NULL, NULL, 4),
(223181, NULL, 'G3DSA:2.60.120.10:FF:000575', NULL, NULL, 'Catabolite gene activator protein', NULL, NULL, NULL, NULL, NULL, 4),
(223182, NULL, 'G3DSA:3.30.70.340:FF:000007', NULL, NULL, 'carboxypeptidase B-like', NULL, NULL, NULL, NULL, NULL, 4),
(223183, NULL, 'G3DSA:3.30.50.10:FF:000151', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223184, NULL, 'G3DSA:3.90.76.10:FF:000028', NULL, NULL, 'ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(223185, NULL, 'G3DSA:1.10.8.60:FF:000516', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223186, NULL, 'G3DSA:1.10.238.10:FF:000964', NULL, NULL, 'Calcium-binding EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(223187, NULL, 'G3DSA:2.60.40.1860:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223188, NULL, 'G3DSA:1.10.286.20:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223189, NULL, 'G3DSA:1.10.510.10:FF:004280', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223190, NULL, 'G3DSA:1.10.286.10:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223191, NULL, 'G3DSA:3.20.20.60:FF:000075', NULL, NULL, 'Putative citrate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(223192, NULL, 'G3DSA:3.30.300.130:FF:000008', NULL, NULL, 'Fe-S cluster assembly factor HCF101, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(223193, NULL, 'G3DSA:3.30.470.30:FF:000014', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(223194, NULL, 'G3DSA:1.25.10.10:FF:002543', NULL, NULL, 'AGAP011904-PA', NULL, NULL, NULL, NULL, NULL, 4),
(223195, NULL, 'G3DSA:2.60.220.50:FF:000010', NULL, NULL, 'adhesion G protein-coupled receptor L4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(223196, NULL, 'G3DSA:3.30.70.100:FF:000166', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223197, NULL, 'G3DSA:1.20.1270.250:FF:000002', NULL, NULL, 'Putative inhibitor of nuclear factor kappa-B kinase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(223198, NULL, 'G3DSA:1.25.10.10:FF:000452', NULL, NULL, 'Maestro heat-like repeat-containing protein family member 7', NULL, NULL, NULL, NULL, NULL, 4),
(223199, NULL, 'G3DSA:1.20.1250.20:FF:001072', NULL, NULL, 'Amino acid/peptide transporter', NULL, NULL, NULL, NULL, NULL, 4),
(223200, NULL, 'G3DSA:1.10.10.820:FF:000033', NULL, NULL, 'Chitin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(223201, NULL, 'G3DSA:3.30.830.10:FF:000194', NULL, NULL, 'Clan ME, family M16, insulinase-like metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(223202, NULL, 'G3DSA:3.40.1090.10:FF:000044', NULL, NULL, 'Patatin-like phospholipase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(223203, NULL, 'G3DSA:2.120.10.30:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223204, NULL, 'G3DSA:1.10.510.10:FF:002542', NULL, NULL, 'Casein kinase I, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223205, NULL, 'G3DSA:3.40.1110.10:FF:000069', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(223206, NULL, 'G3DSA:4.10.400.10:FF:000235', NULL, NULL, 'Low-density lipoprotein receptor-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(223207, NULL, 'G3DSA:3.90.79.10:FF:000006', NULL, NULL, 'ADP compounds hydrolase NudE', NULL, NULL, NULL, NULL, NULL, 4),
(223208, NULL, 'G3DSA:3.30.470.20:FF:000011', NULL, NULL, 'Synapsin I', NULL, NULL, NULL, NULL, NULL, 4),
(223209, NULL, 'G3DSA:3.50.80.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223210, NULL, 'G3DSA:1.20.1250.20:FF:000144', NULL, NULL, 'Picot, isoform B', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(223211, NULL, 'G3DSA:1.10.3720.10:FF:000225', NULL, NULL, 'Oligopeptide transport system permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(223212, NULL, 'G3DSA:2.130.10.10:FF:001467', NULL, NULL, 'Flagellar outer dynein arm intermediate chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(223213, NULL, 'G3DSA:2.130.10.10:FF:003827', NULL, NULL, 'Quinoprotein amine dehydrogenase, beta chain-like RIC1-like guanyl-nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(223214, NULL, 'G3DSA:3.60.21.10:FF:000425', NULL, NULL, 'DNA repair exonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(223215, NULL, 'G3DSA:2.40.50.1000:FF:000007', NULL, NULL, '30S ribosomal protein S17', NULL, NULL, NULL, NULL, NULL, 4),
(223216, NULL, 'G3DSA:3.40.50.2300:FF:001291', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223217, NULL, 'G3DSA:2.30.180.10:FF:000147', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223218, NULL, 'G3DSA:2.70.170.10:FF:000233', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223219, NULL, 'G3DSA:1.10.287.110:FF:000456', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223220, NULL, 'G3DSA:1.10.150.20:FF:000230', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(223221, NULL, 'G3DSA:3.40.50.300:FF:002018', NULL, NULL, 'Structural maintenance of chromosomes protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(223222, NULL, 'G3DSA:3.10.20.90:FF:000584', NULL, NULL, 'Autophagy-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(223223, NULL, 'G3DSA:2.10.110.10:FF:000035', NULL, NULL, 'prickle-like protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(223224, NULL, 'G3DSA:2.130.10.10:FF:005918', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223225, NULL, 'G3DSA:3.90.79.20:FF:000009', NULL, NULL, 'NADH pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(223226, NULL, 'G3DSA:1.10.510.10:FF:000356', NULL, NULL, 'Serine/threonine-protein kinase Nek2', NULL, NULL, NULL, NULL, NULL, 4),
(223227, NULL, 'G3DSA:2.60.40.10:FF:002686', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223228, NULL, 'G3DSA:2.30.29.90:FF:000009', NULL, NULL, 'Exocyst complex component', NULL, NULL, NULL, NULL, NULL, 4),
(223229, NULL, 'G3DSA:3.40.50.150:FF:000747', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223230, NULL, 'G3DSA:2.60.40.150:FF:000531', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223231, NULL, 'G3DSA:3.40.50.200:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223232, NULL, 'G3DSA:3.40.50.1370:FF:000022', NULL, NULL, 'Probable ornithine carbamoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(223233, NULL, 'G3DSA:3.30.160.60:FF:004844', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223234, NULL, 'G3DSA:2.60.120.260:FF:000404', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223235, NULL, 'G3DSA:3.40.50.150:FF:000039', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase K/L', NULL, NULL, NULL, NULL, NULL, 4),
(223236, NULL, 'G3DSA:2.60.40.10:FF:002068', NULL, NULL, 'fasciclin-2 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(223237, NULL, 'G3DSA:1.20.1070.10:FF:001616', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223238, NULL, 'G3DSA:3.40.950.10:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223239, NULL, 'G3DSA:3.40.50.150:FF:000601', NULL, NULL, 'Transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(223240, NULL, 'G3DSA:2.60.40.60:FF:000470', NULL, NULL, 'Cadherin 3', NULL, NULL, NULL, NULL, NULL, 4),
(223241, NULL, 'G3DSA:3.40.50.300:FF:001124', NULL, NULL, 'ABC transporter F family member 4', NULL, NULL, NULL, NULL, NULL, 4),
(223242, NULL, 'G3DSA:1.10.238.10:FF:000285', NULL, NULL, 'EF-hand calcium-binding domain-containing protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(223243, NULL, 'G3DSA:1.10.150.20:FF:000112', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(223244, NULL, 'G3DSA:3.30.160.60:FF:004165', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(223245, NULL, 'G3DSA:2.40.70.10:FF:000345', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223246, NULL, 'G3DSA:3.40.50.1390:FF:000028', NULL, NULL, 'Hypothetical immunity region protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(223247, NULL, 'G3DSA:2.30.29.240:FF:000004', NULL, NULL, '1-phosphatidylinositol 4,5-bisphosphate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(223248, NULL, 'G3DSA:3.80.10.10:FF:001815', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223249, NULL, 'G3DSA:3.90.1150.10:FF:000138', NULL, NULL, 'Putative ornithine aminotransferase RocD2', NULL, NULL, NULL, NULL, NULL, 4),
(223250, NULL, 'G3DSA:3.90.280.10:FF:000008', NULL, NULL, 'Probable lipoprotein lppC', NULL, NULL, NULL, NULL, NULL, 4),
(223251, NULL, 'G3DSA:3.30.160.60:FF:004226', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223252, NULL, 'G3DSA:1.10.1740.100:FF:000001', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(223253, NULL, 'G3DSA:3.40.50.1380:FF:000025', NULL, NULL, 'Carbamoyl-phosphate synthase large chain', NULL, NULL, NULL, NULL, NULL, 4),
(223254, NULL, 'G3DSA:1.25.40.840:FF:000007', NULL, NULL, 'Domain_of_uncharacterized_function_(DUF3819)/CCR4 -Not_complex_component_-_Not1_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(223255, NULL, 'G3DSA:3.30.160.60:FF:002782', NULL, NULL, 'B-box type zinc finger protein ncl-1', NULL, NULL, NULL, NULL, NULL, 4),
(223256, NULL, 'G3DSA:3.30.70.920:FF:000024', NULL, NULL, 'Transcriptional regulator, AsnC family', NULL, NULL, NULL, NULL, NULL, 4),
(223257, NULL, 'G3DSA:1.25.40.820:FF:000001', NULL, NULL, 'RNA polymerase II subunit B1 CTD phosphatase Rpap2', NULL, NULL, NULL, NULL, NULL, 4),
(223258, NULL, 'G3DSA:3.90.70.10:FF:000812', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223259, NULL, 'G3DSA:3.30.430.20:FF:000003', NULL, NULL, 'Cysteine-rich RLK (RECEPTOR-like protein kinase) 10', NULL, NULL, NULL, NULL, NULL, 4),
(223260, NULL, 'G3DSA:1.25.40.10:FF:003826', NULL, NULL, 'Probable assembly chaperone of rpl4', NULL, NULL, NULL, NULL, NULL, 4),
(223261, NULL, 'G3DSA:1.10.3210.10:FF:000052', NULL, NULL, 'Response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(223262, NULL, 'G3DSA:3.40.50.300:FF:006560', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223263, NULL, 'G3DSA:2.60.40.150:FF:000470', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223264, NULL, 'G3DSA:3.40.50.720:FF:001750', NULL, NULL, 'Reticulon-4-interacting protein 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(223265, NULL, 'G3DSA:3.40.50.720:FF:001099', NULL, NULL, 'Putative ketol-acid reductoisomerase 2', NULL, NULL, NULL, NULL, NULL, 4),
(223266, NULL, 'G3DSA:3.40.140.10:FF:000021', NULL, NULL, 'Deoxycytidylate deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(223267, NULL, 'G3DSA:3.30.160.60:FF:002074', NULL, NULL, 'Zinc finger protein 841', NULL, NULL, NULL, NULL, NULL, 4),
(223268, NULL, 'G3DSA:3.30.559.70:FF:000024', NULL, NULL, 'Carnitine acyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223269, NULL, 'G3DSA:2.30.30.770:FF:000008', NULL, NULL, 'LSU ribosomal protein L27E', NULL, NULL, NULL, NULL, NULL, 4),
(223270, NULL, 'G3DSA:2.60.40.150:FF:000413', NULL, NULL, 'Phosphatidylinositol 3 and 4-kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(223271, NULL, 'G3DSA:3.10.150.10:FF:000028', NULL, NULL, 'Beta sliding clamp', NULL, NULL, NULL, NULL, NULL, 4),
(223272, NULL, 'G3DSA:2.60.200.20:FF:000051', NULL, NULL, 'Nijmegen breakage syndrome 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(223273, NULL, 'G3DSA:3.50.4.10:FF:000034', NULL, NULL, 'uncharacterized protein LOC108091652', NULL, NULL, NULL, NULL, NULL, 4),
(223274, NULL, 'G3DSA:2.60.120.260:FF:000461', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223275, NULL, 'G3DSA:2.60.40.1180:FF:000107', NULL, NULL, 'Acid Alpha Glucosidase Relate', NULL, NULL, NULL, NULL, NULL, 4),
(223276, NULL, 'G3DSA:1.20.1540.10:FF:000034', NULL, NULL, 'Serine protease family S54, putative', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(223277, NULL, 'G3DSA:1.20.120.730:FF:000005', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(223278, NULL, 'G3DSA:3.30.450.80:FF:000005', NULL, NULL, 'Transcriptional activator protein LasR', NULL, NULL, NULL, NULL, NULL, 4),
(223279, NULL, 'G3DSA:3.90.960.10:FF:000010', NULL, NULL, 'Proline-tRNA ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223280, NULL, 'G3DSA:3.40.109.10:FF:000010', NULL, NULL, 'NAD(P)H nitroreductase', NULL, NULL, NULL, NULL, NULL, 4),
(223281, NULL, 'G3DSA:2.60.40.1120:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223282, NULL, 'G3DSA:1.10.150.670:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223283, NULL, 'G3DSA:3.90.700.10:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223284, NULL, 'G3DSA:1.10.10.10:FF:000328', NULL, NULL, 'Lactamase beta 2', NULL, NULL, NULL, NULL, NULL, 4),
(223285, NULL, 'G3DSA:2.60.40.1170:FF:000104', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223286, NULL, 'G3DSA:1.20.1070.10:FF:001263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223287, NULL, 'G3DSA:3.40.50.150:FF:000394', NULL, NULL, 'mRNA cap guanine-N7 methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(223288, NULL, 'G3DSA:3.30.160.60:FF:004373', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223289, NULL, 'G3DSA:3.40.50.720:FF:002003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223290, NULL, 'G3DSA:1.10.510.10:FF:000709', NULL, NULL, 'CAMK/CAMK1 protein kinase, variant 2', NULL, NULL, NULL, NULL, NULL, 4),
(223291, NULL, 'G3DSA:3.90.70.40:FF:000001', NULL, NULL, 'ataxin-3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(223292, NULL, 'G3DSA:3.40.50.10330:FF:000096', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(223293, NULL, 'G3DSA:1.10.472.10:FF:000137', NULL, NULL, 'Alpha-latroinsectotoxin-Lt1a', NULL, NULL, NULL, NULL, NULL, 4),
(223294, NULL, 'G3DSA:2.170.150.20:FF:000020', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223295, NULL, 'G3DSA:3.30.70.330:FF:001078', NULL, NULL, 'WGS project CABT00000000 data, contig 2.5', NULL, NULL, NULL, NULL, NULL, 4),
(223296, NULL, 'G3DSA:1.25.40.10:FF:004170', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223297, NULL, 'G3DSA:1.10.630.10:FF:000775', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223298, NULL, 'G3DSA:3.30.450.90:FF:000008', NULL, NULL, 'Similar to late competence protein comGA', NULL, NULL, NULL, NULL, NULL, 4),
(223299, NULL, 'G3DSA:3.30.565.10:FF:000088', NULL, NULL, 'DNA topoisomerase (ATP-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4),
(223300, NULL, 'G3DSA:2.30.29.30:FF:001026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223301, NULL, 'G3DSA:1.20.120.720:FF:000002', NULL, NULL, 'Myosin heavy chain 10', NULL, NULL, NULL, NULL, NULL, 4),
(223302, NULL, 'G3DSA:2.130.10.10:FF:002338', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(223303, NULL, 'G3DSA:3.40.50.300:FF:004822', NULL, NULL, 'SNF2 DNA repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223304, NULL, 'G3DSA:3.10.129.10:FF:000080', NULL, NULL, 'Thioesterase-like family protein', NULL, NULL, NULL, NULL, NULL, 4),
(223305, NULL, 'G3DSA:1.20.1050.20:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223306, NULL, 'G3DSA:3.40.50.150:FF:001675', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223307, NULL, 'G3DSA:3.30.1360.120:FF:000033', NULL, NULL, 'N,N-dimethylglycine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(223308, NULL, 'G3DSA:2.60.40.10:FF:006014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223309, NULL, 'G3DSA:3.60.21.10:FF:000279', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(223310, NULL, 'G3DSA:2.10.25.10:FF:000899', NULL, NULL, 'Thrombomodulin', NULL, NULL, NULL, NULL, NULL, 4),
(223311, NULL, 'G3DSA:3.30.70.330:FF:001549', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(223312, NULL, 'G3DSA:3.40.630.10:FF:000249', NULL, NULL, 'Peptidase M20 domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(223313, NULL, 'G3DSA:1.10.510.10:FF:002508', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223314, NULL, 'G3DSA:2.130.10.10:FF:004081', NULL, NULL, 'Nuclear pore complex protein 20', NULL, NULL, NULL, NULL, NULL, 4),
(223315, NULL, 'G3DSA:1.25.40.10:FF:003708', NULL, NULL, 'Patatin', NULL, NULL, NULL, NULL, NULL, 4),
(223316, NULL, 'G3DSA:2.130.10.10:FF:001675', NULL, NULL, 'AGAP010693-PA', NULL, NULL, NULL, NULL, NULL, 4),
(223317, NULL, 'G3DSA:3.30.1360.10:FF:000005', NULL, NULL, 'Dna-directed rna polymerases i and iii subunit', NULL, NULL, NULL, NULL, NULL, 4),
(223318, NULL, 'G3DSA:2.40.170.20:FF:000097', NULL, NULL, 'TonB-dependent receptor-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(223319, NULL, 'G3DSA:3.30.1230.20:FF:000004', NULL, NULL, '40S ribosomal protein S21', NULL, NULL, NULL, NULL, NULL, 4),
(223320, NULL, 'G3DSA:3.80.10.10:FF:003406', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223321, NULL, 'G3DSA:3.40.50.300:FF:008622', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223322, NULL, 'G3DSA:3.80.10.10:FF:003463', NULL, NULL, 'Fbxl16, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223323, NULL, 'G3DSA:2.60.120.380:FF:000087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223324, NULL, 'G3DSA:1.10.10.10:FF:000272', NULL, NULL, 'Transcriptional regulator, DeoR family', NULL, NULL, NULL, NULL, NULL, 4),
(223325, NULL, 'G3DSA:3.40.50.1440:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223326, NULL, 'G3DSA:1.20.1270.50:FF:000008', NULL, NULL, 'Alpha-mannosidase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(223327, NULL, 'G3DSA:1.10.287.1490:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223328, NULL, 'G3DSA:2.60.40.10:FF:002271', NULL, NULL, 'Myotactin form A', NULL, NULL, NULL, NULL, NULL, 4),
(223329, NULL, 'G3DSA:1.10.20.10:FF:000357', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223330, NULL, 'G3DSA:3.30.450.70:FF:000002', NULL, NULL, 'Trafficking protein particle complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(223331, NULL, 'G3DSA:3.90.740.10:FF:000027', NULL, NULL, 'Isoleucyl-tRNA synthetase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(223332, NULL, 'G3DSA:1.10.3720.10:FF:000079', NULL, NULL, 'Oligopeptide ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(223333, NULL, 'G3DSA:1.20.5.780:FF:000004', NULL, NULL, 'FXYD domain-containing ion transport regulator', NULL, NULL, NULL, NULL, NULL, 4),
(223334, NULL, 'G3DSA:3.10.110.10:FF:000144', NULL, NULL, 'Ubiquitin-conjugating enzyme family protein', NULL, NULL, NULL, NULL, NULL, 4),
(223335, NULL, 'G3DSA:1.25.40.20:FF:000283', NULL, NULL, 'Protein phosphatase 1 regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(223336, NULL, 'G3DSA:3.30.200.20:FF:000082', NULL, NULL, 'Epithelial discoidin domain-containing receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(223337, NULL, 'G3DSA:1.25.40.10:FF:000280', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(223338, NULL, 'G3DSA:3.40.50.720:FF:002060', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(223339, NULL, 'G3DSA:3.40.50.150:FF:000247', NULL, NULL, 'tRNA (adenine(58)-N(1))-methyltransferase catalytic subunit TRM61', NULL, NULL, NULL, NULL, NULL, 4),
(223340, NULL, 'G3DSA:1.10.533.10:FF:000072', NULL, NULL, 'Probable ATP-dependent RNA helicase DDX58', NULL, NULL, NULL, NULL, NULL, 4),
(223341, NULL, 'G3DSA:1.20.1250.20:FF:001572', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223342, NULL, 'G3DSA:1.10.730.10:FF:000221', NULL, NULL, 'Valyl-tRNA synthetase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(223343, NULL, 'G3DSA:4.10.60.10:FF:000009', NULL, NULL, 'Zinc finger CCHC-type and RNA-binding motif-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(223344, NULL, 'G3DSA:2.40.240.10:FF:000066', NULL, NULL, 'Glutamine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(223345, NULL, 'G3DSA:3.30.1010.10:FF:000018', NULL, NULL, 'phosphatidylinositol 4-kinase beta 1', NULL, NULL, NULL, NULL, NULL, 4),
(223346, NULL, 'G3DSA:1.10.274.80:FF:000001', NULL, NULL, 'Toxin A', NULL, NULL, NULL, NULL, NULL, 4),
(223347, NULL, 'G3DSA:2.60.40.150:FF:000177', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit type 3', NULL, NULL, NULL, NULL, NULL, 4),
(223348, NULL, 'G3DSA:2.60.40.60:FF:000436', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223349, NULL, 'G3DSA:1.20.1000.10:FF:000033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223350, NULL, 'G3DSA:2.40.70.10:FF:000553', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223351, NULL, 'G3DSA:3.30.70.330:FF:001696', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223352, NULL, 'G3DSA:1.10.506.10:FF:000048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223353, NULL, 'G3DSA:1.25.10.10:FF:002190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223354, NULL, 'G3DSA:3.30.565.10:FF:000442', NULL, NULL, 'Stage II sporulation E family protein', NULL, NULL, NULL, NULL, NULL, 4),
(223355, NULL, 'G3DSA:3.50.50.60:FF:000070', NULL, NULL, 'Thiamine thiazole synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(223356, NULL, 'G3DSA:2.10.25.10:FF:001416', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223357, NULL, 'G3DSA:3.80.10.10:FF:002889', NULL, NULL, 'Nyctalopin', NULL, NULL, NULL, NULL, NULL, 4),
(223358, NULL, 'G3DSA:3.30.40.10:FF:002331', NULL, NULL, 'Putative ras-like small GTPases', NULL, NULL, NULL, NULL, NULL, 4),
(223359, NULL, 'G3DSA:3.30.160.60:FF:002574', NULL, NULL, 'Zinc finger protein 546', NULL, NULL, NULL, NULL, NULL, 4),
(223360, NULL, 'G3DSA:3.40.50.1240:FF:000152', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223361, NULL, 'G3DSA:3.30.1480.10:FF:000014', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(223362, NULL, 'G3DSA:3.90.226.10:FF:000164', NULL, NULL, 'Trifunctional enzyme alpha subunit, mitochondrial-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(223363, NULL, 'G3DSA:3.40.850.10:FF:000232', NULL, NULL, 'Kinesin motor domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223364, NULL, 'G3DSA:3.40.190.10:FF:000232', NULL, NULL, 'Membrane-bound lytic murein transglycosylase F', NULL, NULL, NULL, NULL, NULL, 4),
(223365, NULL, 'G3DSA:1.25.10.10:FF:000334', NULL, NULL, 'Cell differentiation protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(223366, NULL, 'G3DSA:1.10.565.10:FF:000089', NULL, NULL, 'Nuclear hormone receptor family member nhr-111', NULL, NULL, NULL, NULL, NULL, 4),
(223367, NULL, 'G3DSA:1.25.10.10:FF:000391', NULL, NULL, 'ATP/GTP binding protein like 1', NULL, NULL, NULL, NULL, NULL, 4),
(223368, NULL, 'G3DSA:2.30.310.10:FF:000001', NULL, NULL, 'Nuclear export mediator factor Nemf', NULL, NULL, NULL, NULL, NULL, 4),
(223369, NULL, 'G3DSA:3.40.630.170:FF:000002', NULL, NULL, 'Glycylpeptide N-tetradecanoyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(223370, NULL, 'G3DSA:3.40.120.10:FF:000019', NULL, NULL, 'Phosphoacetylglucosamine mutase', NULL, NULL, NULL, NULL, NULL, 4),
(223371, NULL, 'G3DSA:2.60.260.20:FF:000088', NULL, NULL, 'GM14447', NULL, NULL, NULL, NULL, NULL, 4),
(223372, NULL, 'G3DSA:3.30.200.20:FF:001947', NULL, NULL, 'TKL family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(223373, NULL, 'G3DSA:4.10.60.10:FF:000066', NULL, NULL, 'CCHC-type zinc finger, nucleic acid-binding protein a', NULL, NULL, NULL, NULL, NULL, 4),
(223374, NULL, 'G3DSA:3.30.160.60:FF:002517', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223375, NULL, 'G3DSA:1.10.1200.270:FF:000015', NULL, NULL, 'Os11g0260100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(223376, NULL, 'G3DSA:1.10.400.10:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(223377, NULL, 'G3DSA:3.30.420.40:FF:000071', NULL, NULL, 'Molecular chaperone DnaK', NULL, NULL, NULL, NULL, NULL, 4),
(223378, NULL, 'G3DSA:1.20.1310.10:FF:000079', NULL, NULL, 'Cullin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(223379, NULL, 'G3DSA:3.40.1810.10:FF:000077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223380, NULL, 'G3DSA:2.40.160.10:FF:000065', NULL, NULL, 'Outer membrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223381, NULL, 'G3DSA:3.40.50.300:FF:000309', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(223382, NULL, 'G3DSA:1.25.10.10:FF:000188', NULL, NULL, 'protein inscuteable homolog isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(223383, NULL, 'G3DSA:3.80.10.10:FF:001607', NULL, NULL, 'Leucine-rich repeat receptor-like serine/threonine/tyrosine-protein kinase SOBIR1', NULL, NULL, NULL, NULL, NULL, 4),
(223384, NULL, 'G3DSA:3.40.50.261:FF:000023', NULL, NULL, 'ATP-citrate synthase subunit alpha chain protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(223385, NULL, 'G3DSA:1.10.220.150:FF:000030', NULL, NULL, 'GTPase activating protein for Arf, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223386, NULL, 'G3DSA:3.40.50.300:FF:008476', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223387, NULL, 'G3DSA:3.40.1060.10:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223388, NULL, 'G3DSA:3.30.420.40:FF:000278', NULL, NULL, 'Actin-related protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(223389, NULL, 'G3DSA:3.40.50.2000:FF:000363', NULL, NULL, 'Lipopolysaccharide 1,6-galactosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(223390, NULL, 'G3DSA:3.30.210.10:FF:000017', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(223391, NULL, 'G3DSA:1.50.40.10:FF:000536', NULL, NULL, 'ADP/ATP carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(223392, NULL, 'G3DSA:2.130.10.10:FF:000186', NULL, NULL, 'syntaxin-binding protein 5-like isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(223393, NULL, 'G3DSA:1.10.510.10:FF:003936', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223394, NULL, 'G3DSA:3.30.160.60:FF:001146', NULL, NULL, 'Zinc finger protein 555', NULL, NULL, NULL, NULL, NULL, 4),
(223395, NULL, 'G3DSA:3.40.30.10:FF:000773', NULL, NULL, 'Peroxiredoxin, 1-Cys subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(223396, NULL, 'G3DSA:2.40.50.140:FF:000164', NULL, NULL, 'Exosome complex component CSL4', NULL, NULL, NULL, NULL, NULL, 4),
(223397, NULL, 'G3DSA:1.10.10.60:FF:000736', NULL, NULL, 'Protein CBR-CEH-1', NULL, NULL, NULL, NULL, NULL, 4),
(223398, NULL, 'G3DSA:2.10.70.10:FF:000178', NULL, NULL, 'Hig-anchoring scaffold protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(223399, NULL, 'G3DSA:3.40.50.300:FF:000219', NULL, NULL, 'Dynein axonemal heavy chain 17', NULL, NULL, NULL, NULL, NULL, 4),
(223400, NULL, 'G3DSA:1.10.287.70:FF:000769', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223401, NULL, 'G3DSA:2.60.300.12:FF:000007', NULL, NULL, 'Iron-sulfur cluster assembly accessory protein', NULL, NULL, NULL, NULL, NULL, 4),
(223402, NULL, 'G3DSA:3.40.640.10:FF:000429', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223403, NULL, 'G3DSA:3.30.70.330:FF:001639', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223404, NULL, 'G3DSA:2.40.70.10:FF:000199', NULL, NULL, 'WGS project CABT00000000 data, contig 2.21', NULL, NULL, NULL, NULL, NULL, 4),
(223405, NULL, 'G3DSA:2.20.80.10:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223406, NULL, 'G3DSA:2.60.40.10:FF:000623', NULL, NULL, 'obscurin-like protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(223407, NULL, 'G3DSA:2.10.25.10:FF:001506', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223408, NULL, 'G3DSA:3.30.310.50:FF:000037', NULL, NULL, 'Transcription factor Pcc1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223409, NULL, 'G3DSA:3.90.120.10:FF:000025', NULL, NULL, 'tRNA (cytosine(38)-C(5))-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(223410, NULL, 'G3DSA:3.30.70.330:FF:000414', NULL, NULL, 'Eukaryotic translation initiation factor 4H', NULL, NULL, NULL, NULL, NULL, 4),
(223411, NULL, 'G3DSA:2.130.10.10:FF:000039', NULL, NULL, 'Guanine nucleotide-binding protein subunit beta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(223412, NULL, 'G3DSA:2.40.50.690:FF:000008', NULL, NULL, 'Exosome complex exonuclease RRP44', NULL, NULL, NULL, NULL, NULL, 4),
(223413, NULL, 'G3DSA:2.60.40.10:FF:000269', NULL, NULL, 'Growth hormone receptor', NULL, NULL, NULL, NULL, NULL, 4),
(223414, NULL, 'G3DSA:3.40.50.300:FF:006267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223415, NULL, 'G3DSA:3.40.50.300:FF:002670', NULL, NULL, 'Os03g0282700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(223416, NULL, 'G3DSA:2.130.10.10:FF:002490', NULL, NULL, 'Syntaxin-binding protein 5-like', NULL, NULL, NULL, NULL, NULL, 4),
(223417, NULL, 'G3DSA:2.60.40.10:FF:004423', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223418, NULL, 'G3DSA:3.40.190.10:FF:000439', NULL, NULL, 'GLutamate Receptor family (AMPA)', NULL, NULL, NULL, NULL, NULL, 4),
(223419, NULL, 'G3DSA:1.20.1070.10:FF:001206', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223420, NULL, 'G3DSA:1.25.40.10:FF:000128', NULL, NULL, 'General transcription factor IIIC, polypeptide 3, 102kDa', NULL, NULL, NULL, NULL, NULL, 4),
(223421, NULL, 'G3DSA:1.25.40.10:FF:002337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223422, NULL, 'G3DSA:3.10.20.90:FF:000994', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223423, NULL, 'G3DSA:3.10.490.10:FF:000019', NULL, NULL, 'Gamma-glutamylcyclotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(223424, NULL, 'G3DSA:2.40.10.10:FF:000370', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223425, NULL, 'G3DSA:3.30.160.60:FF:002427', NULL, NULL, 'Zinc finger protein 552', NULL, NULL, NULL, NULL, NULL, 4),
(223426, NULL, 'G3DSA:4.10.280.10:FF:000236', NULL, NULL, 'Os03g0279500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(223427, NULL, 'G3DSA:1.20.5.770:FF:000001', NULL, NULL, 'Period circadian protein', NULL, NULL, NULL, NULL, NULL, 4),
(223428, NULL, 'G3DSA:3.20.20.220:FF:000087', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(223429, NULL, 'G3DSA:3.40.50.970:FF:000105', NULL, NULL, '2-oxoglutarate dehydrogenase E1 component, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223430, NULL, 'G3DSA:3.30.497.10:FF:000042', NULL, NULL, 'GM21844', NULL, NULL, NULL, NULL, NULL, 4),
(223431, NULL, 'G3DSA:3.40.50.300:FF:000927', NULL, NULL, 'Septum-promoting GTP-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(223432, NULL, 'G3DSA:1.10.10.60:FF:000028', NULL, NULL, 'Paired box protein Pax-6', NULL, NULL, NULL, NULL, NULL, 4),
(223433, NULL, 'G3DSA:1.10.540.10:FF:000127', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(223434, NULL, 'G3DSA:3.90.950.10:FF:000037', NULL, NULL, 'dTTP/UTP pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(223435, NULL, 'G3DSA:2.60.40.10:FF:002214', NULL, NULL, 'Kinase insert domain receptor (a type III receptor tyrosine kinase)', NULL, NULL, NULL, NULL, NULL, 4),
(223436, NULL, 'G3DSA:3.90.290.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223437, NULL, 'G3DSA:2.60.40.150:FF:000267', NULL, NULL, 'C2 domain-containing protein / GRAM domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(223438, NULL, 'G3DSA:3.10.110.10:FF:000054', NULL, NULL, 'Ubiquitin-conjugating enzyme E2', NULL, NULL, NULL, NULL, NULL, 4),
(223439, NULL, 'G3DSA:1.20.58.670:FF:000004', NULL, NULL, 'Exocyst complex component SEC15', NULL, NULL, NULL, NULL, NULL, 4),
(223440, NULL, 'G3DSA:1.20.1110.10:FF:000069', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(223441, NULL, 'G3DSA:2.70.150.10:FF:000024', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(223442, NULL, 'G3DSA:3.90.110.10:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(223443, NULL, 'G3DSA:2.60.40.10:FF:003496', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(223444, NULL, 'G3DSA:2.60.120.650:FF:000044', NULL, NULL, 'Ubiquitously transcribed tetratricopeptide repeat protein Y-linked transcript variant 21', NULL, NULL, NULL, NULL, NULL, 4),
(223445, NULL, 'G3DSA:3.60.150.10:FF:000011', NULL, NULL, 'Chorismate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(223446, NULL, 'G3DSA:2.60.120.310:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223447, NULL, 'G3DSA:3.30.565.10:FF:000352', NULL, NULL, 'Sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(223448, NULL, 'G3DSA:1.10.3120.10:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223449, NULL, 'G3DSA:1.10.150.80:FF:000023', NULL, NULL, 'Unplaced genomic scaffold supercont1.38, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(223450, NULL, 'G3DSA:2.170.270.10:FF:000138', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223451, NULL, 'G3DSA:1.20.58.530:FF:000013', NULL, NULL, 'Unconventional myosin-XIX', NULL, NULL, NULL, NULL, NULL, 4),
(223452, NULL, 'G3DSA:2.60.40.10:FF:000680', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(223453, NULL, 'G3DSA:3.30.450.40:FF:000218', NULL, NULL, 'Slr1385 protein', NULL, NULL, NULL, NULL, NULL, 4),
(223454, NULL, 'G3DSA:2.10.25.10:FF:001563', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223455, NULL, 'G3DSA:1.25.40.10:FF:004731', NULL, NULL, 'Protein CBR-PRP-6', NULL, NULL, NULL, NULL, NULL, 4),
(223456, NULL, 'G3DSA:3.30.379.10:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223457, NULL, 'G3DSA:1.10.510.10:FF:000502', NULL, NULL, 'Aurora kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(223458, NULL, 'G3DSA:2.60.40.10:FF:000062', NULL, NULL, 'Myosin-binding protein C, slow type', NULL, NULL, NULL, NULL, NULL, 4),
(223459, NULL, 'G3DSA:3.40.50.10810:FF:000026', NULL, NULL, 'SWI/SNF related, matrix associated, actin dependent regulator of chromatin, subfamily a-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(223460, NULL, 'G3DSA:3.40.640.10:FF:000222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223461, NULL, 'G3DSA:3.40.50.10810:FF:000083', NULL, NULL, 'Helicase putative', NULL, NULL, NULL, NULL, NULL, 4),
(223462, NULL, 'G3DSA:3.30.9.10:FF:000174', NULL, NULL, 'Aerobic glycerol-3-phosphate dehydrogenase GlpD', NULL, NULL, NULL, NULL, NULL, 4),
(223463, NULL, 'G3DSA:1.20.120.1900:FF:000065', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(223464, NULL, 'G3DSA:3.40.50.300:FF:005132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223465, NULL, 'G3DSA:3.20.20.140:FF:000097', NULL, NULL, 'Dal1p', NULL, NULL, NULL, NULL, NULL, 4),
(223466, NULL, 'G3DSA:3.20.20.70:FF:000488', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223467, NULL, 'G3DSA:2.60.40.10:FF:002832', NULL, NULL, 'Interleukin-3 receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(223468, NULL, 'G3DSA:1.20.58.340:FF:000046', NULL, NULL, 'Magnesium transporter MRS2-2', NULL, NULL, NULL, NULL, NULL, 4),
(223469, NULL, 'G3DSA:3.30.70.330:FF:002005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223470, NULL, 'G3DSA:1.25.40.20:FF:001300', NULL, NULL, 'DNA replication inhibitor plutonium', NULL, NULL, NULL, NULL, NULL, 4),
(223471, NULL, 'G3DSA:3.90.1410.10:FF:000092', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223472, NULL, 'G3DSA:3.40.50.620:FF:000231', NULL, NULL, 'Multidrug MFS transporter', NULL, NULL, NULL, NULL, NULL, 4),
(223473, NULL, 'G3DSA:1.10.238.10:FF:001009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223474, NULL, 'G3DSA:3.40.50.10900:FF:000019', NULL, NULL, 'Proteasome assembly chaperone 2', NULL, NULL, NULL, NULL, NULL, 4),
(223475, NULL, 'G3DSA:1.20.120.330:FF:000008', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(223476, NULL, 'G3DSA:1.20.5.1430:FF:000006', NULL, NULL, 'Microtubule-associated protein RP/EB family member 1C', NULL, NULL, NULL, NULL, NULL, 4),
(223477, NULL, 'G3DSA:1.10.10.60:FF:000175', NULL, NULL, 'Melibiose operon regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(223478, NULL, 'G3DSA:3.10.20.90:FF:000730', NULL, NULL, 'Regulator of G-protein signalling 14', NULL, NULL, NULL, NULL, NULL, 4),
(223479, NULL, 'G3DSA:1.10.510.10:FF:001261', NULL, NULL, 'CAMK/CAMKL protein kinase, variant 1', NULL, NULL, NULL, NULL, NULL, 4),
(223480, NULL, 'G3DSA:1.10.533.10:FF:000162', NULL, NULL, 'Myeloid differentiation primary response protein MyD88', NULL, NULL, NULL, NULL, NULL, 4),
(223481, NULL, 'G3DSA:3.60.21.10:FF:000072', NULL, NULL, 'Ser/Thr protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(223482, NULL, 'G3DSA:2.130.10.10:FF:000129', NULL, NULL, 'Notchless homolog 1 (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(223483, NULL, 'G3DSA:1.20.1720.10:FF:000099', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223484, NULL, 'G3DSA:3.30.70.890:FF:000059', NULL, NULL, 'Galactokinase', NULL, NULL, NULL, NULL, NULL, 4),
(223485, NULL, 'G3DSA:3.30.70.330:FF:000504', NULL, NULL, 'Serine/arginine-rich splicing factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(223486, NULL, 'G3DSA:1.10.1070.11:FF:000092', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223487, NULL, 'G3DSA:1.20.1640.10:FF:000098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223488, NULL, 'G3DSA:3.10.20.30:FF:000055', NULL, NULL, 'Succinate dehydrogenase iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4),
(223489, NULL, 'G3DSA:3.10.50.40:FF:000150', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(223490, NULL, 'G3DSA:2.20.70.10:FF:000071', NULL, NULL, 'FERM domain (Protein4.1-ezrin-radixin-moesin) family', NULL, NULL, NULL, NULL, NULL, 4),
(223491, NULL, 'G3DSA:2.60.120.10:FF:000367', NULL, NULL, 'Crp/Fnr family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(223492, NULL, 'G3DSA:1.20.1250.20:FF:001482', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223493, NULL, 'G3DSA:1.20.58.60:FF:000216', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(223494, NULL, 'G3DSA:3.90.1200.10:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223495, NULL, 'G3DSA:2.40.160.10:FF:000003', NULL, NULL, 'Outer mitochondrial membrane protein porin', NULL, NULL, NULL, NULL, NULL, 4),
(223496, NULL, 'G3DSA:1.20.1560.10:FF:000890', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223497, NULL, 'G3DSA:3.30.70.100:FF:000076', NULL, NULL, 'Thiosulfate sulfurtransferase/rhodanese-like domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(223498, NULL, 'G3DSA:3.90.1100.10:FF:000017', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(223499, NULL, 'G3DSA:3.30.70.330:FF:001965', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223500, NULL, 'G3DSA:3.10.110.10:FF:000205', NULL, NULL, 'Ubiquitin-conjugating enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223501, NULL, 'G3DSA:3.80.10.10:FF:001669', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223502, NULL, 'G3DSA:1.25.40.10:FF:004580', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223503, NULL, 'G3DSA:1.10.510.10:FF:003728', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223504, NULL, 'G3DSA:3.40.50.720:FF:000997', NULL, NULL, 'Molybdopterin biosynthesis protein MoeB', NULL, NULL, NULL, NULL, NULL, 4),
(223505, NULL, 'G3DSA:2.160.20.10:FF:000325', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223506, NULL, 'G3DSA:3.30.160.60:FF:001062', NULL, NULL, 'Zinc finger protein 142', NULL, NULL, NULL, NULL, NULL, 4),
(223507, NULL, 'G3DSA:3.30.500.10:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223508, NULL, 'G3DSA:2.40.50.40:FF:000004', NULL, NULL, 'C-X-C motif chemokine', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(223509, NULL, 'G3DSA:2.120.10.80:FF:000190', NULL, NULL, 'Os09g0555300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(223510, NULL, 'G3DSA:3.80.10.10:FF:001725', NULL, NULL, 'Dynein assembly factor 1, axonemal homolog', NULL, NULL, NULL, NULL, NULL, 4),
(223511, NULL, 'G3DSA:2.40.160.20:FF:000006', NULL, NULL, 'p44/Msp2 family outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(223512, NULL, 'G3DSA:2.40.10.500:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223513, NULL, 'G3DSA:3.40.50.300:FF:008392', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(223514, NULL, 'G3DSA:3.40.50.10490:FF:000149', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223515, NULL, 'G3DSA:2.40.40.10:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223516, NULL, 'G3DSA:3.30.54.20:FF:000005', NULL, NULL, 'Alanine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(223517, NULL, 'G3DSA:1.10.135.10:FF:000006', NULL, NULL, 'GD11708', NULL, NULL, NULL, NULL, NULL, 4),
(223518, NULL, 'G3DSA:3.30.560.10:FF:000004', NULL, NULL, 'Dehydrogenase FAD flavoprotein GMC oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(223519, NULL, 'G3DSA:1.10.510.10:FF:002626', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223520, NULL, 'G3DSA:1.10.3080.10:FF:000018', NULL, NULL, 'Chloride transporter, ClC family', NULL, NULL, NULL, NULL, NULL, 4),
(223521, NULL, 'G3DSA:1.10.472.10:FF:000553', NULL, NULL, 'Cyclin, N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(223522, NULL, 'G3DSA:1.20.1250.20:FF:001156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223523, NULL, 'G3DSA:1.10.30.10:FF:000099', NULL, NULL, 'Axial regulator YABBY 4', NULL, NULL, NULL, NULL, NULL, 4),
(223524, NULL, 'G3DSA:3.40.30.10:FF:000565', NULL, NULL, 'Glutaredoxin/Glutathione_S-transferase_-_N-terminal_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(223525, NULL, 'G3DSA:3.30.70.330:FF:001488', NULL, NULL, 'RNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223526, NULL, 'G3DSA:1.50.40.10:FF:000098', NULL, NULL, 'Mitochondrial substrate carrier family protein', NULL, NULL, NULL, NULL, NULL, 4),
(223527, NULL, 'G3DSA:3.40.50.300:FF:002462', NULL, NULL, 'ATP-dependent helicase HrpB', NULL, NULL, NULL, NULL, NULL, 4),
(223528, NULL, 'G3DSA:4.10.60.10:FF:000010', NULL, NULL, 'Zinc knuckle domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(223529, NULL, 'G3DSA:2.170.130.10:FF:000072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223530, NULL, 'G3DSA:3.30.2130.10:FF:000022', NULL, NULL, 'Aspartate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(223531, NULL, 'G3DSA:1.10.20.10:FF:000183', NULL, NULL, 'YALI0F17072p', NULL, NULL, NULL, NULL, NULL, 4),
(223532, NULL, 'G3DSA:3.20.20.140:FF:000327', NULL, NULL, 'Error-prone DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(223533, NULL, 'G3DSA:3.30.300.180:FF:000006', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4),
(223534, NULL, 'G3DSA:1.20.120.230:FF:000012', NULL, NULL, 'Catenin alpha-2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(223535, NULL, 'G3DSA:3.20.20.10:FF:000077', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223536, NULL, 'G3DSA:3.30.200.20:FF:002403', NULL, NULL, 'Probable inactive serine/threonine-protein kinase DDB_G0278909', NULL, NULL, NULL, NULL, NULL, 4),
(223537, NULL, 'G3DSA:2.60.40.10:FF:002568', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223538, NULL, 'G3DSA:1.20.120.1110:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223539, NULL, 'G3DSA:1.10.287.690:FF:000023', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(223540, NULL, 'G3DSA:2.60.34.10:FF:000064', NULL, NULL, 'Heat shock protein 88', NULL, NULL, NULL, NULL, NULL, 4),
(223541, NULL, 'G3DSA:3.90.70.10:FF:000251', NULL, NULL, 'Cysteine protease 16', NULL, NULL, NULL, NULL, NULL, 4),
(223542, NULL, 'G3DSA:3.60.20.30:FF:000002', NULL, NULL, 'Taspase, threonine aspartase, 1', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(223543, NULL, 'G3DSA:3.80.10.10:FF:001046', NULL, NULL, 'Leucine Rich repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223544, NULL, 'G3DSA:1.10.530.10:FF:000065', NULL, NULL, 'Membrane-bound lytic murein transglycosylase B', NULL, NULL, NULL, NULL, NULL, 4),
(223545, NULL, 'G3DSA:3.90.780.10:FF:000030', NULL, NULL, 'UshA related metallophosphatase, N-terminal domain', NULL, NULL, NULL, NULL, NULL, 4),
(223546, NULL, 'G3DSA:3.40.50.300:FF:000484', NULL, NULL, 'Cytidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(223547, NULL, 'G3DSA:3.60.20.40:FF:000005', NULL, NULL, 'gamma-glutamyltransferase 5 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(223548, NULL, 'G3DSA:3.90.70.10:FF:000397', NULL, NULL, 'Putative ubiquitin carboxy-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(223549, NULL, 'G3DSA:3.40.47.10:FF:000042', NULL, NULL, 'Polyketide synthase Pks13', NULL, NULL, NULL, NULL, NULL, 4),
(223550, NULL, 'G3DSA:2.40.20.10:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223551, NULL, 'G3DSA:1.20.58.610:FF:000003', NULL, NULL, 'Cdc37p', NULL, NULL, NULL, NULL, NULL, 4),
(223552, NULL, 'G3DSA:3.90.730.10:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223553, NULL, 'G3DSA:2.70.150.10:FF:000086', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(223554, NULL, 'G3DSA:3.40.630.30:FF:000699', NULL, NULL, 'RNA cytidine acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(223555, NULL, 'G3DSA:2.60.34.10:FF:000120', NULL, NULL, 'Heat shock protein70, hsp70A2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223556, NULL, 'G3DSA:2.30.42.10:FF:000320', NULL, NULL, 'PDZ and LIM domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(223557, NULL, 'G3DSA:2.60.40.150:FF:000593', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223558, NULL, 'G3DSA:2.20.100.10:FF:000015', NULL, NULL, 'Thrombospondin, type I, domain containing 7A', NULL, NULL, NULL, NULL, NULL, 4),
(223559, NULL, 'G3DSA:2.10.25.10:FF:001153', NULL, NULL, 'SCO-spondin', NULL, NULL, NULL, NULL, NULL, 4),
(223560, NULL, 'G3DSA:3.20.20.70:FF:000667', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223561, NULL, 'G3DSA:3.10.20.90:FF:000668', NULL, NULL, 'Small ubiquitin-related modifier', NULL, NULL, NULL, NULL, NULL, 4),
(223562, NULL, 'G3DSA:3.50.4.10:FF:000005', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(223563, NULL, 'G3DSA:1.10.510.10:FF:000446', NULL, NULL, 'Microtubule associated serine/threonine kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(223564, NULL, 'G3DSA:2.170.270.10:FF:000082', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(223565, NULL, 'G3DSA:1.20.1250.20:FF:000700', NULL, NULL, 'Solute carrier family 45, member 1/2/4', NULL, NULL, NULL, NULL, NULL, 4),
(223566, NULL, 'G3DSA:2.60.40.1170:FF:000076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223567, NULL, 'G3DSA:3.10.100.10:FF:000233', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223568, NULL, 'G3DSA:2.40.10.10:FF:000515', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223569, NULL, 'G3DSA:1.10.10.10:FF:001790', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223570, NULL, 'G3DSA:3.30.160.60:FF:006109', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223571, NULL, 'G3DSA:1.10.30.10:FF:000155', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223572, NULL, 'G3DSA:3.40.1090.10:FF:000015', NULL, NULL, 'Patatin like phospholipase domain containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(223573, NULL, 'G3DSA:3.30.1050.10:FF:000021', NULL, NULL, 'Alkyl sulfatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223574, NULL, 'G3DSA:3.30.1680.10:FF:000052', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(223575, NULL, 'G3DSA:2.60.40.10:FF:004715', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223576, NULL, 'G3DSA:2.40.70.10:FF:000109', NULL, NULL, 'Eukaryotic aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(223577, NULL, 'G3DSA:3.30.1130.10:FF:000022', NULL, NULL, 'Related to multifunctional folic acid synthesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(223578, NULL, 'G3DSA:3.30.565.10:FF:000026', NULL, NULL, 'Serine-protein kinase RsbW', NULL, NULL, NULL, NULL, NULL, 4),
(223579, NULL, 'G3DSA:3.40.30.10:FF:001026', NULL, NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(223580, NULL, 'G3DSA:3.40.50.1820:FF:001837', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(223581, NULL, 'G3DSA:3.40.525.10:FF:000061', NULL, NULL, 'CRAL-TRIO domain-containing protein C365.01', NULL, NULL, NULL, NULL, NULL, 4),
(223582, NULL, 'G3DSA:3.40.50.300:FF:008066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223583, NULL, 'G3DSA:1.10.510.10:FF:004341', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223584, NULL, 'G3DSA:2.60.60.20:FF:000066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223585, NULL, 'G3DSA:3.30.70.1010:FF:000001', NULL, NULL, 'Elongation factor 1-gamma 1', NULL, NULL, NULL, NULL, NULL, 4),
(223586, NULL, 'G3DSA:1.20.1250.20:FF:001633', NULL, NULL, 'Protein NRT1/ PTR FAMILY 5.10', NULL, NULL, NULL, NULL, NULL, 4),
(223587, NULL, 'G3DSA:3.90.70.10:FF:000195', NULL, NULL, 'Cathepsin L-like protease', NULL, NULL, NULL, NULL, NULL, 4),
(223588, NULL, 'G3DSA:1.20.1070.10:FF:001532', NULL, NULL, 'Atypical chemokine receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(223589, NULL, 'G3DSA:2.40.30.10:FF:000045', NULL, NULL, 'Dihydroorotate dehydrogenase B (NAD(+)), electron transfer subunit', NULL, NULL, NULL, NULL, NULL, 4),
(223590, NULL, 'G3DSA:1.25.40.20:FF:000991', NULL, NULL, 'Protein phosphatase 1 regulatory inhibitor subunit 16B', NULL, NULL, NULL, NULL, NULL, 4),
(223591, NULL, 'G3DSA:2.60.40.1180:FF:000079', NULL, NULL, 'Glucosylceramidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223592, NULL, 'G3DSA:3.90.550.50:FF:000007', NULL, NULL, 'Glycoprotein-N-acetylgalactosamine 3-beta-galactosyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(223593, NULL, 'G3DSA:2.40.110.10:FF:000062', NULL, NULL, 'Acyl-CoA oxidase like', NULL, NULL, NULL, NULL, NULL, 4),
(223594, NULL, 'G3DSA:1.20.144.10:FF:000025', NULL, NULL, 'Lipid phosphate phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223595, NULL, 'G3DSA:2.10.25.10:FF:000692', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(223596, NULL, 'G3DSA:2.60.40.10:FF:002624', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223597, NULL, 'G3DSA:3.40.50.300:FF:006149', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(223598, NULL, 'G3DSA:4.10.400.10:FF:000325', NULL, NULL, 'sortilin-related receptor-like', NULL, NULL, NULL, NULL, NULL, 4),
(223599, NULL, 'G3DSA:4.10.860.120:FF:000028', NULL, NULL, 'RNA polymerase Rpb1, domain 1 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(223600, NULL, 'G3DSA:2.60.40.1360:FF:000009', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(223601, NULL, 'G3DSA:1.10.10.390:FF:000005', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(223602, NULL, 'G3DSA:3.30.40.10:FF:000206', NULL, NULL, 'BRCA1-associated protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(223603, NULL, 'G3DSA:2.160.20.70:FF:000034', NULL, NULL, 'Tubulin-specific chaperone C', NULL, NULL, NULL, NULL, NULL, 4),
(223604, NULL, 'G3DSA:2.60.11.10:FF:000017', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223605, NULL, 'G3DSA:2.60.40.1730:FF:000087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223606, NULL, 'G3DSA:3.20.20.150:FF:000010', NULL, NULL, 'Mannonate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(223607, NULL, 'G3DSA:3.30.70.330:FF:002331', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223608, NULL, 'G3DSA:1.20.1560.10:FF:000125', NULL, NULL, 'Hypothetical ABC transporter ATP-binding protein yddA', NULL, NULL, NULL, NULL, NULL, 4),
(223609, NULL, 'G3DSA:3.40.50.11980:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(223610, NULL, 'G3DSA:3.30.1330.60:FF:000029', NULL, NULL, 'Outer membrane protein OmpA', NULL, NULL, NULL, NULL, NULL, 4),
(223611, NULL, 'G3DSA:1.25.10.10:FF:000481', NULL, NULL, 'Transportin', NULL, NULL, NULL, NULL, NULL, 4),
(223612, NULL, 'G3DSA:3.10.120.10:FF:000026', NULL, NULL, 'Protein vem-1', NULL, NULL, NULL, NULL, NULL, 4),
(223613, NULL, 'G3DSA:3.60.21.10:FF:000156', NULL, NULL, 'Integral membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(223614, NULL, 'G3DSA:2.120.10.30:FF:000012', NULL, NULL, 'Low density lipoprotein receptor-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(223615, NULL, 'G3DSA:3.30.365.10:FF:000045', NULL, NULL, 'Aldehyde oxidase and xanthine dehydrogenase, a/b hammerhead domain', NULL, NULL, NULL, NULL, NULL, 4),
(223616, NULL, 'G3DSA:3.30.40.10:FF:001308', NULL, NULL, 'AGAP000928-PA', NULL, NULL, NULL, NULL, NULL, 4),
(223617, NULL, 'G3DSA:1.20.1110.10:FF:000154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223618, NULL, 'G3DSA:1.25.40.10:FF:002163', NULL, NULL, 'Embryo specific2', NULL, NULL, NULL, NULL, NULL, 4),
(223619, NULL, 'G3DSA:1.10.238.10:FF:000902', NULL, NULL, 'Calcium channel, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223620, NULL, 'G3DSA:3.50.50.60:FF:000013', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(223621, NULL, 'G3DSA:1.20.58.390:FF:000044', NULL, NULL, 'neuronal acetylcholine receptor subunit alpha-9', NULL, NULL, NULL, NULL, NULL, 4),
(223622, NULL, 'G3DSA:1.10.238.10:FF:000846', NULL, NULL, 'Calmodulin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223623, NULL, 'G3DSA:3.40.50.10190:FF:000273', NULL, NULL, 'Putative dna topoisomerase 2-binding protein 1 isoform x1', NULL, NULL, NULL, NULL, NULL, 4),
(223624, NULL, 'G3DSA:1.10.420.10:FF:000034', NULL, NULL, 'Cationic peroxidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(223625, NULL, 'G3DSA:1.25.50.10:FF:000011', NULL, NULL, 'Membrane alanine aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(223626, NULL, 'G3DSA:1.10.290.10:FF:000001', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(223627, NULL, 'G3DSA:3.30.160.60:FF:002843', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223628, NULL, 'G3DSA:1.25.40.10:FF:004254', NULL, NULL, 'Rap phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(223629, NULL, 'G3DSA:2.90.10.10:FF:000019', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(223630, NULL, 'G3DSA:1.10.238.10:FF:000256', NULL, NULL, 'probable calcium-binding protein CML20', NULL, NULL, NULL, NULL, NULL, 4),
(223631, NULL, 'G3DSA:1.10.565.10:FF:000179', NULL, NULL, 'Hepatocyte nuclear factor 4, alpha', NULL, NULL, NULL, NULL, NULL, 4),
(223632, NULL, 'G3DSA:1.20.1070.10:FF:001055', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(223633, NULL, 'G3DSA:2.60.40.60:FF:000228', NULL, NULL, 'Cadherin 23', NULL, NULL, NULL, NULL, NULL, 4),
(223634, NULL, 'G3DSA:1.25.40.20:FF:001710', NULL, NULL, 'CARD- and ANK-containing Inflammasome Adaptor Protein', NULL, NULL, NULL, NULL, NULL, 4),
(223635, NULL, 'G3DSA:3.40.30.10:FF:000239', NULL, NULL, 'Iodothyronine deiodinase', NULL, NULL, NULL, NULL, NULL, 4),
(223636, NULL, 'G3DSA:3.30.1360.70:FF:000006', NULL, NULL, 'Arginyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(223637, NULL, 'G3DSA:3.10.450.50:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223638, NULL, 'G3DSA:3.30.420.100:FF:000004', NULL, NULL, '50S ribosomal protein L18', NULL, NULL, NULL, NULL, NULL, 4),
(223639, NULL, 'G3DSA:2.40.70.10:FF:000435', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223640, NULL, 'G3DSA:3.30.70.330:FF:000240', NULL, NULL, 'RNA binding motif protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(223641, NULL, 'G3DSA:2.40.420.20:FF:000049', NULL, NULL, 'Multidrug resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(223642, NULL, 'G3DSA:1.10.220.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223643, NULL, 'G3DSA:1.10.8.270:FF:000112', NULL, NULL, 'Spindle protein, putative', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(223644, NULL, 'G3DSA:2.60.120.200:FF:000201', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(223645, NULL, 'G3DSA:1.20.1070.10:FF:001734', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223646, NULL, 'G3DSA:3.90.980.20:FF:000019', NULL, NULL, 'Cysteine-rich protein 2-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223647, NULL, 'G3DSA:3.40.640.10:FF:000137', NULL, NULL, 'Cystathionine beta-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(223648, NULL, 'G3DSA:3.10.180.10:FF:000002', NULL, NULL, 'Lactoylglutathione lyase', NULL, NULL, NULL, NULL, NULL, 4),
(223649, NULL, 'G3DSA:2.60.120.920:FF:000176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223650, NULL, 'G3DSA:3.90.79.10:FF:000271', NULL, NULL, 'Nudix hydrolase 15 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(223651, NULL, 'G3DSA:3.30.450.40:FF:000134', NULL, NULL, 'Transcriptional regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(223652, NULL, 'G3DSA:1.20.1280.50:FF:000161', NULL, NULL, 'F-box and WD repeat domain containing 9', NULL, NULL, NULL, NULL, NULL, 4),
(223653, NULL, 'G3DSA:3.50.7.10:FF:000012', NULL, NULL, 'Chaperonin CPN60, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(223654, NULL, 'G3DSA:3.90.150.10:FF:000004', NULL, NULL, 'Variant surface glycoprotein (VSG, atypical), putative', NULL, NULL, NULL, NULL, NULL, 4),
(223655, NULL, 'G3DSA:3.30.160.60:FF:004934', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223656, NULL, 'G3DSA:3.30.530.20:FF:000185', NULL, NULL, 'Polyketide cyclase/dehydrase and lipid transport superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(223657, NULL, 'G3DSA:3.40.50.300:FF:002136', NULL, NULL, 'Small rab-related GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(223658, NULL, 'G3DSA:1.10.287.110:FF:000338', NULL, NULL, 'DnaJ-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(223659, NULL, 'G3DSA:2.10.110.10:FF:000153', NULL, NULL, 'Rho GTPase activator (Lrg11), putative', NULL, NULL, NULL, NULL, NULL, 4),
(223660, NULL, 'G3DSA:3.10.20.90:FF:000466', NULL, NULL, 'Autophagy-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(223661, NULL, 'G3DSA:2.40.170.20:FF:000041', NULL, NULL, 'Hemin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(223662, NULL, 'G3DSA:2.30.180.10:FF:000029', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(223663, NULL, 'G3DSA:3.30.70.3290:FF:000022', NULL, NULL, 'Polyketide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(223664, NULL, 'G3DSA:1.20.82.10:FF:000005', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223665, NULL, 'G3DSA:2.30.180.10:FF:000057', NULL, NULL, 'Fasciclin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(223666, NULL, 'G3DSA:3.20.20.450:FF:000010', NULL, NULL, 'Cyclic diguanylate phosphodiesterase (EAL) domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(223667, NULL, 'G3DSA:3.40.630.30:FF:000227', NULL, NULL, 'Histone acetyltransferase type B catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(223668, NULL, 'G3DSA:1.20.58.1080:FF:000002', NULL, NULL, 'DExH-box ATP-dependent RNA helicase DExH18 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(223669, NULL, 'G3DSA:3.40.630.10:FF:000221', NULL, NULL, 'Clan MH, family M18, aspartyl aminopeptidase-like metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(223670, NULL, 'G3DSA:3.30.1380.10:FF:000012', NULL, NULL, 'Hedgehog2', NULL, NULL, NULL, NULL, NULL, 4),
(223671, NULL, 'G3DSA:1.25.10.10:FF:003122', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223672, NULL, 'G3DSA:3.40.50.12160:FF:000004', NULL, NULL, 'Threonylcarbamoyladenosine tRNA methylthiotransferase MtaB', NULL, NULL, NULL, NULL, NULL, 4),
(223673, NULL, 'G3DSA:3.40.630.30:FF:000497', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223674, NULL, 'G3DSA:3.40.630.10:FF:000367', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223675, NULL, 'G3DSA:1.25.10.10:FF:002189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(223676, NULL, 'G3DSA:3.40.225.10:FF:000021', NULL, NULL, 'Class II aldolase/adducin domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(223677, NULL, 'G3DSA:1.25.40.10:FF:001674', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(223678, NULL, 'G3DSA:1.20.58.1480:FF:000032', NULL, NULL, 'Protein cereblon homolog-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(223679, NULL, 'G3DSA:3.40.190.290:FF:000015', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(223680, NULL, 'G3DSA:3.40.50.300:FF:004227', NULL, NULL, 'Ribosome dissociation factor GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(223681, NULL, 'G3DSA:3.40.50.150:FF:001759', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223682, NULL, 'G3DSA:1.10.238.10:FF:000346', NULL, NULL, 'Sarcoplasmic Calcium-Binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(223683, NULL, 'G3DSA:1.25.40.10:FF:002814', NULL, NULL, 'Signal recognition particle subunit SRP72', NULL, NULL, NULL, NULL, NULL, 4),
(223684, NULL, 'G3DSA:1.20.1070.10:FF:000689', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223685, NULL, 'G3DSA:3.40.50.300:FF:004351', NULL, NULL, 'ATP (GTP)-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(223686, NULL, 'G3DSA:2.130.10.10:FF:004137', NULL, NULL, 'Angio-associated migratory cell protein', NULL, NULL, NULL, NULL, NULL, 4),
(223687, NULL, 'G3DSA:3.30.450.40:FF:000044', NULL, NULL, 'Putative sensor histidine kinase/response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(223688, NULL, 'G3DSA:1.20.1280.290:FF:000027', NULL, NULL, 'MtN3-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(223689, NULL, 'G3DSA:1.10.1200.10:FF:000079', NULL, NULL, 'Acyl carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(223690, NULL, 'G3DSA:1.10.510.10:FF:004190', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223691, NULL, 'G3DSA:1.25.40.20:FF:000726', NULL, NULL, 'Intracelllar PhosphoLipase A family', NULL, NULL, NULL, NULL, NULL, 4),
(223692, NULL, 'G3DSA:2.60.40.10:FF:004013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223693, NULL, 'G3DSA:3.40.50.12150:FF:000001', NULL, NULL, 'Proline reductase for pyrrolysine biosynthesis', NULL, NULL, NULL, NULL, NULL, 4),
(223694, NULL, 'G3DSA:1.25.10.10:FF:000542', NULL, NULL, 'Phosphoinositide 3-kinase regulatory subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(223695, NULL, 'G3DSA:3.80.10.10:FF:002827', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223696, NULL, 'G3DSA:3.40.190.10:FF:000024', NULL, NULL, 'Glutamate receptor, ionotropic, delta 1', NULL, NULL, NULL, NULL, NULL, 4),
(223697, NULL, 'G3DSA:1.10.1300.10:FF:000030', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(223698, NULL, 'G3DSA:1.20.272.10:FF:000081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223699, NULL, 'G3DSA:1.10.3720.10:FF:000135', NULL, NULL, 'Sugar-transport integral membrane protein ABC transporter SugA', NULL, NULL, NULL, NULL, NULL, 4),
(223700, NULL, 'G3DSA:1.10.340.30:FF:000039', NULL, NULL, 'Endonuclease III homolog', NULL, NULL, NULL, NULL, NULL, 4),
(223701, NULL, 'G3DSA:3.30.70.330:FF:002421', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223702, NULL, 'G3DSA:1.10.3260.10:FF:000055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223703, NULL, 'G3DSA:3.30.30.30:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223704, NULL, 'G3DSA:3.30.450.50:FF:000047', NULL, NULL, 'Vesicle-associated membrane protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(223705, NULL, 'G3DSA:2.130.10.10:FF:002046', NULL, NULL, 'Axonemal dynein intermediate chain', NULL, NULL, NULL, NULL, NULL, 4),
(223706, NULL, 'G3DSA:3.60.21.10:FF:000482', NULL, NULL, '5''-nucleotidase ecto', NULL, NULL, NULL, NULL, NULL, 4),
(223707, NULL, 'G3DSA:3.30.70.580:FF:000023', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(223708, NULL, 'G3DSA:3.40.720.10:FF:000279', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(223709, NULL, 'G3DSA:3.90.230.10:FF:000005', NULL, NULL, 'FACT complex subunit spt16', NULL, NULL, NULL, NULL, NULL, 4),
(223710, NULL, 'G3DSA:3.90.980.20:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223711, NULL, 'G3DSA:2.20.25.10:FF:000079', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(223712, NULL, 'G3DSA:1.10.10.470:FF:000001', NULL, NULL, 'Malto-oligosyltrehalose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(223713, NULL, 'G3DSA:3.30.420.40:FF:000306', NULL, NULL, 'Tetratricopeptide repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(223714, NULL, 'G3DSA:3.30.40.10:FF:000004', NULL, NULL, 'Jade family PHD finger 2', NULL, NULL, NULL, NULL, NULL, 4),
(223715, NULL, 'G3DSA:2.30.40.10:FF:000097', NULL, NULL, 'Enamidase', NULL, NULL, NULL, NULL, NULL, 4),
(223716, NULL, 'G3DSA:3.50.50.60:FF:000159', NULL, NULL, 'Dimethylaniline monooxygenase [N-oxide-forming]', NULL, NULL, NULL, NULL, NULL, 4),
(223717, NULL, 'G3DSA:1.20.920.30:FF:000014', NULL, NULL, 'Dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(223718, NULL, 'G3DSA:3.80.10.10:FF:003940', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', NULL, NULL, NULL, NULL, NULL, 4),
(223719, NULL, 'G3DSA:3.30.230.70:FF:000019', NULL, NULL, '3 exoribonuclease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(223720, NULL, 'G3DSA:3.40.50.2300:FF:001408', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223721, NULL, 'G3DSA:1.10.10.480:FF:000004', NULL, NULL, 'Probable ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(223722, NULL, 'G3DSA:1.20.58.400:FF:000002', NULL, NULL, 'Vesicle transport v-SNARE protein', NULL, NULL, NULL, NULL, NULL, 4),
(223723, NULL, 'G3DSA:2.60.40.10:FF:004395', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223724, NULL, 'G3DSA:1.50.40.10:FF:000328', NULL, NULL, 'ADP/ATP translocase 3-like', NULL, NULL, NULL, NULL, NULL, 4),
(223725, NULL, 'G3DSA:2.120.10.30:FF:000158', NULL, NULL, 'Pro-epidermal growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(223726, NULL, 'G3DSA:1.25.10.10:FF:002335', NULL, NULL, 'Importin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223727, NULL, 'G3DSA:3.40.190.10:FF:000703', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223728, NULL, 'G3DSA:2.130.10.10:FF:002282', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223729, NULL, 'G3DSA:3.80.20.20:FF:000009', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(223730, NULL, 'G3DSA:3.30.450.30:FF:000041', NULL, NULL, 'Roadblock/LC7 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(223731, NULL, 'G3DSA:2.70.170.10:FF:000172', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223732, NULL, 'G3DSA:3.40.640.10:FF:000430', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223733, NULL, 'G3DSA:2.10.90.10:FF:000095', NULL, NULL, 'Transforming growth factor beta-3', NULL, NULL, NULL, NULL, NULL, 4),
(223734, NULL, 'G3DSA:3.30.200.20:FF:000609', NULL, NULL, 'CMGC/DYRK/PRP4 protein kinase, variant', NULL, NULL, NULL, NULL, NULL, 4),
(223735, NULL, 'G3DSA:1.25.40.10:FF:003944', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223736, NULL, 'G3DSA:1.10.3430.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223737, NULL, 'G3DSA:3.20.20.300:FF:000021', NULL, NULL, 'Beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(223738, NULL, 'G3DSA:3.30.559.30:FF:000035', NULL, NULL, 'Hydroxamate-type ferrichrome siderophore peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(223739, NULL, 'G3DSA:1.20.58.420:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223740, NULL, 'G3DSA:1.20.1250.30:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223741, NULL, 'G3DSA:2.20.20.110:FF:000002', NULL, NULL, 'DNA repair protein Rad4 family', NULL, NULL, NULL, NULL, NULL, 4),
(223742, NULL, 'G3DSA:1.20.120.980:FF:000029', NULL, NULL, 'AGAP000994', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(223743, NULL, 'G3DSA:3.40.1110.10:FF:000277', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223744, NULL, 'G3DSA:6.10.140.2190:FF:000001', NULL, NULL, 'BPP', NULL, NULL, NULL, NULL, NULL, 4),
(223745, NULL, 'G3DSA:1.25.40.10:FF:003596', NULL, NULL, 'Adenylate/guanylate cyclase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(223746, NULL, 'G3DSA:1.20.930.80:FF:000007', NULL, NULL, 'DNA primase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(223747, NULL, 'G3DSA:2.40.160.50:FF:000026', NULL, NULL, 'Sorting and assembly machinery component 50 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(223748, NULL, 'G3DSA:2.60.40.10:FF:005497', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223749, NULL, 'G3DSA:2.10.220.10:FF:000156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223750, NULL, 'G3DSA:1.20.120.1350:FF:000001', NULL, NULL, 'Matrix M2-1', NULL, NULL, NULL, NULL, NULL, 4),
(223751, NULL, 'G3DSA:3.80.10.10:FF:002597', NULL, NULL, 'NLR family CARD domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(223752, NULL, 'G3DSA:2.60.40.420:FF:000106', NULL, NULL, 'Laccase-like multicopper oxidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(223753, NULL, 'G3DSA:3.40.50.1980:FF:000025', NULL, NULL, 'Iron ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(223754, NULL, 'G3DSA:3.30.200.20:FF:002408', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(223755, NULL, 'G3DSA:2.10.25.10:FF:001708', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223756, NULL, 'G3DSA:3.40.309.10:FF:000019', NULL, NULL, '4-trimethylaminobutyraldehyde dehydrogenase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(223757, NULL, 'G3DSA:6.10.140.2230:FF:000002', NULL, NULL, 'RNA polymerase-associated protein RapA', NULL, NULL, NULL, NULL, NULL, 4),
(223758, NULL, 'G3DSA:2.70.170.10:FF:000025', NULL, NULL, 'Gamma-aminobutyric acid type A receptor beta3 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(223759, NULL, 'G3DSA:2.60.40.10:FF:000180', NULL, NULL, 'Fibronectin type III domain containing 3A', NULL, NULL, NULL, NULL, NULL, 4),
(223760, NULL, 'G3DSA:3.40.50.720:FF:001486', NULL, NULL, 'Putative UDP-galactopyranose mutase', NULL, NULL, NULL, NULL, NULL, 4),
(223761, NULL, 'G3DSA:1.10.10.10:FF:000862', NULL, NULL, 'Putative transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(223762, NULL, 'G3DSA:1.10.10.60:FF:000293', NULL, NULL, 'Homeobox-leucine zipper protein ATHB-7', NULL, NULL, NULL, NULL, NULL, 4),
(223763, NULL, 'G3DSA:3.40.50.2300:FF:001588', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223764, NULL, 'G3DSA:3.30.1380.20:FF:000015', NULL, NULL, 'TRapp subunit', NULL, NULL, NULL, NULL, NULL, 4),
(223765, NULL, 'G3DSA:3.30.70.20:FF:000037', NULL, NULL, 'Epoxyqueuosine reductase', NULL, NULL, NULL, NULL, NULL, 4),
(223766, NULL, 'G3DSA:2.60.40.60:FF:000907', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223767, NULL, 'G3DSA:3.40.50.150:FF:000629', NULL, NULL, 'Ribosomal methyltransferase Rsm22', NULL, NULL, NULL, NULL, NULL, 4),
(223768, NULL, 'G3DSA:3.30.70.1230:FF:000275', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223769, NULL, 'G3DSA:3.40.50.300:FF:001208', NULL, NULL, 'DNA helicase B', NULL, NULL, NULL, NULL, NULL, 4),
(223770, NULL, 'G3DSA:1.20.58.2220:FF:000024', NULL, NULL, 'Formin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(223771, NULL, 'G3DSA:2.130.10.10:FF:005952', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223772, NULL, 'G3DSA:3.40.50.300:FF:006767', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223773, NULL, 'G3DSA:3.50.50.100:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223774, NULL, 'G3DSA:1.20.1640.10:FF:000036', NULL, NULL, 'PaTched Related family', NULL, NULL, NULL, NULL, NULL, 4),
(223775, NULL, 'G3DSA:3.80.10.10:FF:000360', NULL, NULL, 'NACHT, LRR and PYD domains-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(223776, NULL, 'G3DSA:3.40.190.10:FF:000029', NULL, NULL, 'Chorismate mutase/Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(223777, NULL, 'G3DSA:1.20.1070.10:FF:001706', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223778, NULL, 'G3DSA:2.60.40.10:FF:000270', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(223779, NULL, 'G3DSA:3.90.70.10:FF:000341', NULL, NULL, 'Ubiquitin-specific peptidase 47', NULL, NULL, NULL, NULL, NULL, 4),
(223780, NULL, 'G3DSA:3.30.160.60:FF:005862', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223781, NULL, 'G3DSA:3.10.20.90:FF:000494', NULL, NULL, 'AaceriAGL357Wp', NULL, NULL, NULL, NULL, NULL, 4),
(223782, NULL, 'G3DSA:3.10.20.90:FF:000522', NULL, NULL, 'Suppressor 2 of zeste h29', NULL, NULL, NULL, NULL, NULL, 4),
(223783, NULL, 'G3DSA:2.170.270.10:FF:000172', NULL, NULL, 'Si:dkeyp-41f9.4', NULL, NULL, NULL, NULL, NULL, 4),
(223784, NULL, 'G3DSA:2.60.120.260:FF:000612', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223785, NULL, 'G3DSA:2.70.50.30:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223786, NULL, 'G3DSA:2.40.30.10:FF:000461', NULL, NULL, 'Chromosome 13 SCAF14769, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(223787, NULL, 'G3DSA:3.40.630.30:FF:000553', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223788, NULL, 'G3DSA:3.40.50.1820:FF:000202', NULL, NULL, 'Lipase member H', NULL, NULL, NULL, NULL, NULL, 4),
(223789, NULL, 'G3DSA:3.30.70.1230:FF:000039', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(223790, NULL, 'G3DSA:1.20.5.190:FF:000041', NULL, NULL, 'IQ motif containing N', NULL, NULL, NULL, NULL, NULL, 4),
(223791, NULL, 'G3DSA:1.20.1250.40:FF:000004', NULL, NULL, 'Dna-directed rna polymerase ii subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(223792, NULL, 'G3DSA:1.10.1740.10:FF:000018', NULL, NULL, 'RNA polymerase sigma-70 factor, ECF subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(223793, NULL, 'G3DSA:1.10.287.110:FF:000366', NULL, NULL, 'DnaJ domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(223794, NULL, 'G3DSA:3.30.505.10:FF:000141', NULL, NULL, 'RIN (Ras/Rab INteractor) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(223795, NULL, 'G3DSA:3.40.50.1820:FF:001663', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223796, NULL, 'G3DSA:2.130.10.10:FF:004047', NULL, NULL, 'WD-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223797, NULL, 'G3DSA:1.10.460.10:FF:000008', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(223798, NULL, 'G3DSA:1.10.10.140:FF:000009', NULL, NULL, 'Cytochrome oxidase c subunit VIb-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(223799, NULL, 'G3DSA:2.60.40.10:FF:004541', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223800, NULL, 'G3DSA:1.25.10.10:FF:002279', NULL, NULL, 'Calcium binding protein 39 like', NULL, NULL, NULL, NULL, NULL, 4),
(223801, NULL, 'G3DSA:1.10.510.10:FF:004195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223802, NULL, 'G3DSA:1.10.510.10:FF:002424', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223803, NULL, 'G3DSA:1.20.870.10:FF:000032', NULL, NULL, 'GM22469', NULL, NULL, NULL, NULL, NULL, 4),
(223804, NULL, 'G3DSA:1.10.472.10:FF:000463', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223805, NULL, 'G3DSA:2.40.30.10:FF:000219', NULL, NULL, 'Ferric reduction oxidase 4', NULL, NULL, NULL, NULL, NULL, 4),
(223806, NULL, 'G3DSA:2.60.120.260:FF:000135', NULL, NULL, 'Allantoicase', NULL, NULL, NULL, NULL, NULL, 4),
(223807, NULL, 'G3DSA:3.40.50.150:FF:000781', NULL, NULL, 'Steroid monooxygenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223808, NULL, 'G3DSA:3.30.200.20:FF:002173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223809, NULL, 'G3DSA:1.20.1160.20:FF:000019', NULL, NULL, 'Regulator of telomere elongation helicase 1', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(223810, NULL, 'G3DSA:3.40.140.10:FF:000083', NULL, NULL, 'Cytidine and deoxycytidylate deaminase,putative', NULL, NULL, NULL, NULL, NULL, 4),
(223811, NULL, 'G3DSA:3.30.1490.110:FF:000008', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(223812, NULL, 'G3DSA:3.30.110.110:FF:000004', NULL, NULL, 'Double-strand break repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(223813, NULL, 'G3DSA:2.40.50.120:FF:000040', NULL, NULL, 'Netrin precursor', NULL, NULL, NULL, NULL, NULL, 4),
(223814, NULL, 'G3DSA:1.25.40.10:FF:001797', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g14050, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(223815, NULL, 'G3DSA:1.20.58.60:FF:000008', NULL, NULL, 'microtubule-actin cross-linking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(223816, NULL, 'G3DSA:1.20.1070.10:FF:001678', NULL, NULL, 'Extra-ocular rhodopsin', NULL, NULL, NULL, NULL, NULL, 4),
(223817, NULL, 'G3DSA:1.20.930.60:FF:000001', NULL, NULL, 'protein-glutamate O-methyltransferase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(223818, NULL, 'G3DSA:1.10.10.10:FF:001025', NULL, NULL, 'Lactamase-like protein nscB', NULL, NULL, NULL, NULL, NULL, 4),
(223819, NULL, 'G3DSA:1.25.10.10:FF:002009', NULL, NULL, 'Dynein assembly factor 5, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(223820, NULL, 'G3DSA:3.30.1490.100:FF:000005', NULL, NULL, 'DNA polymerase kappa', NULL, NULL, NULL, NULL, NULL, 4),
(223821, NULL, 'G3DSA:3.30.870.10:FF:000084', NULL, NULL, 'Cardiolipin synthase', NULL, NULL, NULL, NULL, NULL, 4),
(223822, NULL, 'G3DSA:2.160.20.10:FF:000151', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223823, NULL, 'G3DSA:1.20.920.20:FF:000011', NULL, NULL, 'Dynein heavy chain domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(223824, NULL, 'G3DSA:2.40.50.140:FF:000046', NULL, NULL, '26S protease regulatory subunit 6B', NULL, NULL, NULL, NULL, NULL, 4),
(223825, NULL, 'G3DSA:1.10.246.20:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223826, NULL, 'G3DSA:1.20.58.310:FF:000003', NULL, NULL, 'Polyphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(223827, NULL, 'G3DSA:3.40.50.720:FF:001363', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223828, NULL, 'G3DSA:1.10.10.10:FF:000536', NULL, NULL, 'Ferric uptake regulator family protein', NULL, NULL, NULL, NULL, NULL, 4),
(223829, NULL, 'G3DSA:1.10.760.10:FF:000048', NULL, NULL, 'Cytochrome c oxidase subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(223830, NULL, 'G3DSA:3.30.1330.10:FF:000003', NULL, NULL, 'Selenide, water dikinase', NULL, NULL, NULL, NULL, NULL, 4),
(223831, NULL, 'G3DSA:1.10.555.10:FF:000268', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223832, NULL, 'G3DSA:2.40.100.10:FF:000090', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(223833, NULL, 'G3DSA:3.30.160.60:FF:003945', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223834, NULL, 'G3DSA:1.10.246.10:FF:000005', NULL, NULL, 'Serum albumin', NULL, NULL, NULL, NULL, NULL, 4),
(223835, NULL, 'G3DSA:1.50.40.10:FF:000418', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223836, NULL, 'G3DSA:3.30.559.10:FF:000113', NULL, NULL, 'HXXXD-type acyl-transferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(223837, NULL, 'G3DSA:2.120.10.80:FF:000038', NULL, NULL, 'leucine-zipper-like transcriptional regulator 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(223838, NULL, 'G3DSA:3.40.30.10:FF:000655', NULL, NULL, 'GM26512', NULL, NULL, NULL, NULL, NULL, 4),
(223839, NULL, 'G3DSA:3.30.70.330:FF:000004', NULL, NULL, 'RNA binding fox-1 homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(223840, NULL, 'G3DSA:1.10.230.10:FF:000025', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223841, NULL, 'G3DSA:3.10.110.10:FF:000115', NULL, NULL, 'RWD domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(223842, NULL, 'G3DSA:3.30.1330.30:FF:000009', NULL, NULL, 'Eukaryotic peptide chain release factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(223843, NULL, 'G3DSA:1.10.540.10:FF:000009', NULL, NULL, 'Probable acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(223844, NULL, 'G3DSA:3.30.1330.20:FF:000006', NULL, NULL, 'Tubulin alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(223845, NULL, 'G3DSA:1.10.630.10:FF:000573', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223846, NULL, 'G3DSA:2.130.10.10:FF:002372', NULL, NULL, 'Splicing factor 3B subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(223847, NULL, 'G3DSA:2.30.29.30:FF:001234', NULL, NULL, 'Protein CARMIL', NULL, NULL, NULL, NULL, NULL, 4),
(223848, NULL, 'G3DSA:3.70.10.10:FF:000085', NULL, NULL, 'Cell cycle checkpoint protein RAD1-like, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223849, NULL, 'G3DSA:3.30.160.60:FF:002366', NULL, NULL, 'zinc finger protein 484 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(223850, NULL, 'G3DSA:1.20.1110.10:FF:000098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223851, NULL, 'G3DSA:1.10.510.10:FF:002716', NULL, NULL, 'Probable inactive serine/threonine-protein kinase bub1', NULL, NULL, NULL, NULL, NULL, 4),
(223852, NULL, 'G3DSA:3.30.750.24:FF:000111', NULL, NULL, 'Prestin', NULL, NULL, NULL, NULL, NULL, 4),
(223853, NULL, 'G3DSA:3.10.110.10:FF:000059', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 34', NULL, NULL, NULL, NULL, NULL, 4),
(223854, NULL, 'G3DSA:1.10.150.50:FF:000188', NULL, NULL, 'Kinase suppressor of Ras 2', NULL, NULL, NULL, NULL, NULL, 4),
(223855, NULL, 'G3DSA:2.40.50.140:FF:000102', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(223856, NULL, 'G3DSA:3.40.50.10810:FF:000234', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223857, NULL, 'G3DSA:3.30.200.20:FF:001594', NULL, NULL, 'Kinase-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(223858, NULL, 'G3DSA:2.120.10.30:FF:000484', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223859, NULL, 'G3DSA:2.40.30.10:FF:000135', NULL, NULL, '1,2-phenylacetyl-CoA epoxidase subunit E', NULL, NULL, NULL, NULL, NULL, 4),
(223860, NULL, 'G3DSA:2.60.40.150:FF:000823', NULL, NULL, 'Uncharacterized protein PYUK71.03c', NULL, NULL, NULL, NULL, NULL, 4),
(223861, NULL, 'G3DSA:1.20.120.1900:FF:000037', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(223862, NULL, 'G3DSA:2.80.10.50:FF:000060', NULL, NULL, 'Fibroblast growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(223863, NULL, 'G3DSA:2.130.10.130:FF:000002', NULL, NULL, 'integrin alpha-6 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(223864, NULL, 'G3DSA:3.40.50.300:FF:001973', NULL, NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(223865, NULL, 'G3DSA:2.60.40.10:FF:002714', NULL, NULL, 'CD45', NULL, NULL, NULL, NULL, NULL, 4),
(223866, NULL, 'G3DSA:2.130.10.10:FF:001883', NULL, NULL, 'WD40-repeat-containing domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(223867, NULL, 'G3DSA:2.20.25.10:FF:000051', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(223868, NULL, 'G3DSA:3.90.79.10:FF:000068', NULL, NULL, 'NUDIX family hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223869, NULL, 'G3DSA:3.30.870.10:FF:000140', NULL, NULL, 'Cardiolipin synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(223870, NULL, 'G3DSA:1.25.10.10:FF:001969', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(223871, NULL, 'G3DSA:3.30.200.20:FF:002083', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(223872, NULL, 'G3DSA:1.20.190.50:FF:000019', NULL, NULL, 'Nuclear pore complex protein', NULL, NULL, NULL, NULL, NULL, 4),
(223873, NULL, 'G3DSA:3.80.10.10:FF:003614', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223874, NULL, 'G3DSA:3.30.70.330:FF:001634', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223875, NULL, 'G3DSA:3.80.10.10:FF:004103', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(223876, NULL, 'G3DSA:2.60.40.10:FF:004485', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223877, NULL, 'G3DSA:3.40.50.720:FF:002503', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223878, NULL, 'G3DSA:3.40.50.80:FF:000042', NULL, NULL, 'Putative NADH-cytochrome b5 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(223879, NULL, 'G3DSA:3.30.420.40:FF:000216', NULL, NULL, 'Pantothenate kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(223880, NULL, 'G3DSA:1.20.58.70:FF:000130', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223881, NULL, 'G3DSA:1.10.840.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223882, NULL, 'G3DSA:1.25.10.10:FF:001846', NULL, NULL, 'Condensin complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(223883, NULL, 'G3DSA:2.30.40.10:FF:000012', NULL, NULL, 'N-acetylglucosamine-6-phosphate deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(223884, NULL, 'G3DSA:3.30.160.20:FF:000078', NULL, NULL, 'Staufen, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(223885, NULL, 'G3DSA:1.10.150.240:FF:000035', NULL, NULL, 'Protein tyrosine kinase transcriptional regulator PtkA', NULL, NULL, NULL, NULL, NULL, 4),
(223886, NULL, 'G3DSA:3.40.50.150:FF:000455', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(223887, NULL, 'G3DSA:2.170.140.10:FF:000016', NULL, NULL, 'Peritrophin-A', NULL, NULL, NULL, NULL, NULL, 4),
(223888, NULL, 'G3DSA:2.10.25.10:FF:001681', NULL, NULL, 'Uromodulin-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(223889, NULL, 'G3DSA:3.30.160.60:FF:006082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223890, NULL, 'G3DSA:2.40.10.10:FF:000459', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223891, NULL, 'G3DSA:2.130.10.10:FF:005626', NULL, NULL, 'Damage-specific DNA binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(223892, NULL, 'G3DSA:2.130.10.10:FF:000157', NULL, NULL, 'WD repeat domain 3', NULL, NULL, NULL, NULL, NULL, 4),
(223893, NULL, 'G3DSA:2.40.50.140:FF:000720', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223894, NULL, 'G3DSA:2.40.30.10:FF:000371', NULL, NULL, 'Siderophore-interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(223895, NULL, 'G3DSA:3.40.50.300:FF:002552', NULL, NULL, 'ATP-dependent DNA helicase pcrA', NULL, NULL, NULL, NULL, NULL, 4),
(223896, NULL, 'G3DSA:3.10.20.90:FF:000612', NULL, NULL, 'Protein PHOX4', NULL, NULL, NULL, NULL, NULL, 4),
(223897, NULL, 'G3DSA:3.30.70.330:FF:000532', NULL, NULL, '50S ribosomal protein L23', NULL, NULL, NULL, NULL, NULL, 4),
(223898, NULL, 'G3DSA:3.30.2130.10:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223899, NULL, 'G3DSA:2.70.150.10:FF:000142', NULL, NULL, 'Na/K ATPase alpha 2 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(223900, NULL, 'G3DSA:3.30.420.40:FF:000834', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223901, NULL, 'G3DSA:1.20.1440.80:FF:000002', NULL, NULL, 'Gap junction protein', NULL, NULL, NULL, NULL, NULL, 4),
(223902, NULL, 'G3DSA:3.30.559.30:FF:000119', NULL, NULL, 'Nonribosomal peptide synthetase asqK', NULL, NULL, NULL, NULL, NULL, 4),
(223903, NULL, 'G3DSA:3.40.630.30:FF:000643', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223904, NULL, 'G3DSA:2.10.25.10:FF:000697', NULL, NULL, 'von Willebrand factor C and EGF domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(223905, NULL, 'G3DSA:1.25.40.10:FF:004052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223906, NULL, 'G3DSA:1.10.10.60:FF:000146', NULL, NULL, 'WUSCHEL-related homeobox 4', NULL, NULL, NULL, NULL, NULL, 4),
(223907, NULL, 'G3DSA:2.30.30.1150:FF:000009', NULL, NULL, 'Little imaginal discs, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(223908, NULL, 'G3DSA:1.20.1440.90:FF:000005', NULL, NULL, 'Phosphoenolpyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(223909, NULL, 'G3DSA:3.90.1600.10:FF:000005', NULL, NULL, 'DNA polymerase epsilon catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(223910, NULL, 'G3DSA:2.80.10.50:FF:000088', NULL, NULL, 'Fibroblast growth factor', NULL, NULL, NULL, NULL, NULL, 4),
(223911, NULL, 'G3DSA:3.30.40.10:FF:000622', NULL, NULL, 'histone-lysine N-methyltransferase 2C isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(223912, NULL, 'G3DSA:3.30.70.20:FF:000127', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223913, NULL, 'G3DSA:3.30.70.330:FF:000184', NULL, NULL, 'Peroxisome proliferator-activated receptor gamma coactivator 1-alpha', NULL, NULL, NULL, NULL, NULL, 4),
(223914, NULL, 'G3DSA:3.40.30.10:FF:001021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223915, NULL, 'G3DSA:2.10.220.10:FF:000072', NULL, NULL, 'CXXC-rich protein', NULL, NULL, NULL, NULL, NULL, 4),
(223916, NULL, 'G3DSA:3.40.50.1820:FF:000112', NULL, NULL, 'Poly(R)-hydroxyalkanoic acid synthase, class III, PhaC subunit', NULL, NULL, NULL, NULL, NULL, 4),
(223917, NULL, 'G3DSA:1.10.150.20:FF:000027', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(223918, NULL, 'G3DSA:3.40.50.300:FF:006823', NULL, NULL, 'MCM homolog', NULL, NULL, NULL, NULL, NULL, 4),
(223919, NULL, 'G3DSA:3.30.70.870:FF:000025', NULL, NULL, 'Elongation factor 2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223920, NULL, 'G3DSA:2.10.90.10:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223921, NULL, 'G3DSA:2.40.100.10:FF:000174', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(223922, NULL, 'G3DSA:2.130.10.10:FF:005593', NULL, NULL, 'Leucine zipper transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223923, NULL, 'G3DSA:2.60.40.10:FF:000825', NULL, NULL, 'Polycystin 1, transient receptor potential channel interacting', NULL, NULL, NULL, NULL, NULL, 4),
(223924, NULL, 'G3DSA:2.60.40.1180:FF:000225', NULL, NULL, 'Glucosylceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(223925, NULL, 'G3DSA:1.10.510.10:FF:004482', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223926, NULL, 'G3DSA:3.40.50.300:FF:005986', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(223927, NULL, 'G3DSA:2.10.25.10:FF:000984', NULL, NULL, 'AGAP003656-PC', NULL, NULL, NULL, NULL, NULL, 4),
(223928, NULL, 'G3DSA:3.90.1340.10:FF:000001', NULL, NULL, 'Short tail fiber protein gp12', NULL, NULL, NULL, NULL, NULL, 4),
(223929, NULL, 'G3DSA:3.90.1410.10:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223930, NULL, 'G3DSA:1.25.40.10:FF:004400', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g01510, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(223931, NULL, 'G3DSA:3.40.50.1820:FF:001219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223932, NULL, 'G3DSA:2.60.40.790:FF:000133', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223933, NULL, 'G3DSA:3.80.10.10:FF:001377', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223934, NULL, 'G3DSA:3.40.30.10:FF:000857', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223935, NULL, 'G3DSA:3.30.43.10:FF:000011', NULL, NULL, 'D-lactate dehydrogenase (Cytochrome)', NULL, NULL, NULL, NULL, NULL, 4),
(223936, NULL, 'G3DSA:3.50.50.60:FF:001087', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223937, NULL, 'G3DSA:2.60.40.1180:FF:000169', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(223938, NULL, 'G3DSA:1.25.40.10:FF:002253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223939, NULL, 'G3DSA:1.10.1400.10:FF:000004', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223940, NULL, 'G3DSA:3.40.50.970:FF:000021', NULL, NULL, 'Pyruvate decarboxylase 1', NULL, NULL, NULL, NULL, NULL, 4),
(223941, NULL, 'G3DSA:2.10.70.80:FF:000002', NULL, NULL, 'Sortilin-related receptor isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(223942, NULL, 'G3DSA:3.30.505.10:FF:000197', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(223943, NULL, 'G3DSA:2.60.120.1540:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223944, NULL, 'G3DSA:3.40.50.1820:FF:001747', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223945, NULL, 'G3DSA:1.10.357.10:FF:000033', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(223946, NULL, 'G3DSA:3.20.20.70:FF:000757', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223947, NULL, 'G3DSA:3.30.70.330:FF:002185', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223948, NULL, 'G3DSA:3.30.160.60:FF:000803', NULL, NULL, 'zinc finger protein 142', NULL, NULL, NULL, NULL, NULL, 4),
(223949, NULL, 'G3DSA:3.90.1410.10:FF:000030', NULL, NULL, 'N-lysine methyltransferase SETD6 isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(223950, NULL, 'G3DSA:3.40.630.10:FF:000075', NULL, NULL, 'Nicastrin', NULL, NULL, NULL, NULL, NULL, 4),
(223951, NULL, 'G3DSA:3.30.160.60:FF:002512', NULL, NULL, 'Pebbled, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(223952, NULL, 'G3DSA:1.20.58.1040:FF:000013', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223953, NULL, 'G3DSA:1.20.58.1030:FF:000010', NULL, NULL, 'GD13488', NULL, NULL, NULL, NULL, NULL, 4),
(223954, NULL, 'G3DSA:1.10.510.10:FF:000682', NULL, NULL, 'WNK lysine deficient protein kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(223955, NULL, 'G3DSA:3.30.2020.30:FF:000025', NULL, NULL, 'Chromosome 16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(223956, NULL, 'G3DSA:1.10.510.10:FF:002391', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223957, NULL, 'G3DSA:2.30.29.30:FF:001144', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223958, NULL, 'G3DSA:2.40.50.150:FF:000021', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223959, NULL, 'G3DSA:3.30.40.10:FF:001224', NULL, NULL, 'Fcp-1', NULL, NULL, NULL, NULL, NULL, 4),
(223960, NULL, 'G3DSA:1.20.1070.10:FF:000043', NULL, NULL, 'adhesion G-protein coupled receptor G2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(223961, NULL, 'G3DSA:1.10.220.100:FF:000004', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(223962, NULL, 'G3DSA:3.90.550.10:FF:000018', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(223963, NULL, 'G3DSA:2.60.120.260:FF:000051', NULL, NULL, 'BTB/POZ domain-containing protein 9', NULL, NULL, NULL, NULL, NULL, 4),
(223964, NULL, 'G3DSA:3.40.50.980:FF:000024', NULL, NULL, 'Linear gramicidin synthase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(223965, NULL, 'G3DSA:1.50.10.130:FF:000008', NULL, NULL, 'Inactive delta-guaiene synthase', NULL, NULL, NULL, NULL, NULL, 4),
(223966, NULL, 'G3DSA:3.30.700.10:FF:000010', NULL, NULL, 'Type IV pilin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(223967, NULL, 'G3DSA:3.60.21.50:FF:000027', NULL, NULL, 'DNA polymerase delta small subunit-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(223968, NULL, 'G3DSA:1.25.40.20:FF:000547', NULL, NULL, 'Uveal autoantigen with coiled-coil domains and ankyrin repeats', NULL, NULL, NULL, NULL, NULL, 4),
(223969, NULL, 'G3DSA:3.30.310.130:FF:000016', NULL, NULL, 'SUMO specific peptidase 6', NULL, NULL, NULL, NULL, NULL, 4),
(223970, NULL, 'G3DSA:3.30.1370.10:FF:000039', NULL, NULL, 'vigilin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(223971, NULL, 'G3DSA:1.10.472.10:FF:000261', NULL, NULL, 'Cyclin, N-terminal domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(223972, NULL, 'G3DSA:3.90.550.10:FF:000546', NULL, NULL, 'Galactosylgalactosylxylosylprotein 3-beta-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(223973, NULL, 'G3DSA:2.60.40.10:FF:000354', NULL, NULL, 'Pro-neuregulin-2, membrane-bound isoform', NULL, NULL, NULL, NULL, NULL, 4),
(223974, NULL, 'G3DSA:1.10.510.10:FF:000154', NULL, NULL, 'Serine/threonine-protein kinase SIK2', NULL, NULL, NULL, NULL, NULL, 4),
(223975, NULL, 'G3DSA:3.80.10.10:FF:003468', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(223976, NULL, 'G3DSA:1.10.1420.10:FF:000005', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(223977, NULL, 'G3DSA:1.10.10.10:FF:000446', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(223978, NULL, 'G3DSA:3.30.565.10:FF:000173', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(223979, NULL, 'G3DSA:3.30.200.20:FF:000284', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(223980, NULL, 'G3DSA:2.60.40.150:FF:000205', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(223981, NULL, 'G3DSA:3.40.50.300:FF:000192', NULL, NULL, 'Phospholipid ABC transporter ATP-binding protein MlaF', NULL, NULL, NULL, NULL, NULL, 4),
(223982, NULL, 'G3DSA:3.40.350.10:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223983, NULL, 'G3DSA:3.40.50.2300:FF:000245', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(223984, NULL, 'G3DSA:1.20.120.350:FF:000043', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(223985, NULL, 'G3DSA:1.20.5.190:FF:000125', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223986, NULL, 'G3DSA:1.10.1410.10:FF:000033', NULL, NULL, 'Non-canonical poly(A) RNA polymerase PAPD7', NULL, NULL, NULL, NULL, NULL, 4),
(223987, NULL, 'G3DSA:2.40.170.20:FF:000125', NULL, NULL, 'TonB-dependent receptor', NULL, NULL, NULL, NULL, NULL, 4),
(223988, NULL, 'G3DSA:3.30.160.60:FF:003063', NULL, NULL, 'CBN-BLMP-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(223989, NULL, 'G3DSA:3.40.390.10:FF:000213', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(223990, NULL, 'G3DSA:1.10.8.60:FF:000398', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223991, NULL, 'G3DSA:1.10.533.10:FF:000246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223992, NULL, 'G3DSA:3.40.50.2300:FF:000301', NULL, NULL, 'Response regulator receiver', NULL, NULL, NULL, NULL, NULL, 4),
(223993, NULL, 'G3DSA:1.20.1250.20:FF:001302', NULL, NULL, 'Solute carrier family 2 member 1b', NULL, NULL, NULL, NULL, NULL, 4),
(223994, NULL, 'G3DSA:3.60.130.10:FF:000010', NULL, NULL, 'TauD/TfdA family dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(223995, NULL, 'G3DSA:2.10.25.10:FF:000927', NULL, NULL, 'Thrombomodulin', NULL, NULL, NULL, NULL, NULL, 4),
(223996, NULL, 'G3DSA:1.25.40.10:FF:000544', NULL, NULL, 'Prolyl 4-hydroxylase subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(223997, NULL, 'G3DSA:3.30.40.10:FF:001639', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(223998, NULL, 'G3DSA:2.60.40.10:FF:002916', NULL, NULL, 'Usherin', NULL, NULL, NULL, NULL, NULL, 4),
(223999, NULL, 'G3DSA:3.10.28.10:FF:000044', NULL, NULL, 'mRNA splicing protein PRP8', NULL, NULL, NULL, NULL, NULL, 4),
(224000, NULL, 'G3DSA:1.25.40.10:FF:000600', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(224001, NULL, 'G3DSA:1.25.40.10:FF:002781', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224002, NULL, 'G3DSA:2.130.10.10:FF:001793', NULL, NULL, 'THO complex subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(224003, NULL, 'G3DSA:2.20.70.10:FF:000155', NULL, NULL, 'WW domain-containing protein A', NULL, NULL, NULL, NULL, NULL, 4),
(224004, NULL, 'G3DSA:2.10.110.10:FF:000243', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224005, NULL, 'G3DSA:3.90.70.10:FF:000543', NULL, NULL, 'Os09g0565100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(224006, NULL, 'G3DSA:3.80.10.10:FF:003524', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224007, NULL, 'G3DSA:3.30.40.10:FF:001696', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224008, NULL, 'G3DSA:3.50.50.60:FF:001469', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224009, NULL, 'G3DSA:1.25.40.20:FF:000603', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(224010, NULL, 'G3DSA:2.30.29.30:FF:001088', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224011, NULL, 'G3DSA:2.120.10.30:FF:000102', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(224012, NULL, 'G3DSA:3.90.260.10:FF:000007', NULL, NULL, 'Rad4 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(224013, NULL, 'G3DSA:1.10.510.10:FF:004369', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224014, NULL, 'G3DSA:3.30.160.60:FF:002456', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(224015, NULL, 'G3DSA:3.40.850.10:FF:000350', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224016, NULL, 'G3DSA:2.40.50.140:FF:000490', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(224017, NULL, 'G3DSA:1.10.1320.10:FF:000003', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(224018, NULL, 'G3DSA:3.40.1110.10:FF:000187', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(224019, NULL, 'G3DSA:3.40.50.1820:FF:001332', NULL, NULL, 'Slr1827 protein', NULL, NULL, NULL, NULL, NULL, 4),
(224020, NULL, 'G3DSA:3.80.10.10:FF:001490', NULL, NULL, 'Blast:Leucine-rich repeat-containing protein 15', NULL, NULL, NULL, NULL, NULL, 4),
(224021, NULL, 'G3DSA:3.30.230.10:FF:000103', NULL, NULL, 'Tetracycline resistance protein, GTP-binding elongation family', NULL, NULL, NULL, NULL, NULL, 4),
(224022, NULL, 'G3DSA:4.10.410.10:FF:000062', NULL, NULL, 'GM18133', NULL, NULL, NULL, NULL, NULL, 4),
(224023, NULL, 'G3DSA:2.60.40.790:FF:000077', NULL, NULL, 'Heat shock protein', NULL, NULL, NULL, NULL, NULL, 4),
(224024, NULL, 'G3DSA:3.80.10.10:FF:003581', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224025, NULL, 'G3DSA:1.20.1070.10:FF:001347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224026, NULL, 'G3DSA:1.25.10.10:FF:002425', NULL, NULL, 'Protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(224027, NULL, 'G3DSA:2.60.40.150:FF:000262', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(224028, NULL, 'G3DSA:3.40.50.300:FF:002226', NULL, NULL, 'RAB3A, member RAS oncogene family', NULL, NULL, NULL, NULL, NULL, 4),
(224029, NULL, 'G3DSA:1.25.40.10:FF:004815', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224030, NULL, 'G3DSA:3.90.1860.10:FF:000001', NULL, NULL, 'tRNA-splicing ligase RtcB homolog', NULL, NULL, NULL, NULL, NULL, 4),
(224031, NULL, 'G3DSA:1.10.510.10:FF:002239', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224032, NULL, 'G3DSA:3.40.50.150:FF:000365', NULL, NULL, 'Unplaced genomic scaffold supercont1.14, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(224033, NULL, 'G3DSA:1.20.1440.130:FF:000011', NULL, NULL, 'Vitamin K epoxide reductase complex, subunit 1-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(224034, NULL, 'G3DSA:2.60.120.10:FF:000783', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224035, NULL, 'G3DSA:3.40.50.1440:FF:000094', NULL, NULL, 'Protein DML1', NULL, NULL, NULL, NULL, NULL, 4),
(224036, NULL, 'G3DSA:3.40.50.300:FF:006352', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224037, NULL, 'G3DSA:1.10.1660.10:FF:000017', NULL, NULL, 'Transcriptional regulator, MerR family', NULL, NULL, NULL, NULL, NULL, 4),
(224038, NULL, 'G3DSA:2.60.40.1180:FF:000023', NULL, NULL, 'neutral alpha-glucosidase AB isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(224039, NULL, 'G3DSA:3.30.1640.10:FF:000049', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(224040, NULL, 'G3DSA:1.20.840.10:FF:000002', NULL, NULL, 'Methyl-coenzyme M reductase I subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(224041, NULL, 'G3DSA:3.30.160.60:FF:006351', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224042, NULL, 'G3DSA:1.20.58.1880:FF:000028', NULL, NULL, 'Snt1p', NULL, NULL, NULL, NULL, NULL, 4),
(224043, NULL, 'G3DSA:3.30.420.40:FF:000508', NULL, NULL, 'Probable tRNA N6-adenosine threonylcarbamoyltransferase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(224044, NULL, 'G3DSA:2.60.40.10:FF:004900', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224045, NULL, 'G3DSA:3.40.140.10:FF:000167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224046, NULL, 'G3DSA:3.40.50.720:FF:001071', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(224047, NULL, 'G3DSA:3.30.160.60:FF:002192', NULL, NULL, 'Os08g0485600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(224048, NULL, 'G3DSA:1.20.1250.20:FF:001717', NULL, NULL, 'Protein NRT1/ PTR FAMILY 8.3', NULL, NULL, NULL, NULL, NULL, 4),
(224049, NULL, 'G3DSA:2.40.20.10:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224050, NULL, 'G3DSA:2.40.10.10:FF:000605', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224051, NULL, 'G3DSA:2.70.98.10:FF:000104', NULL, NULL, 'Aldose 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(224052, NULL, 'G3DSA:3.30.200.20:FF:000610', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 40', NULL, NULL, NULL, NULL, NULL, 4),
(224053, NULL, 'G3DSA:2.60.40.10:FF:004193', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224054, NULL, 'G3DSA:1.10.10.60:FF:000562', NULL, NULL, 'Myb-related protein 315', NULL, NULL, NULL, NULL, NULL, 4),
(224055, NULL, 'G3DSA:2.30.38.10:FF:000012', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(224056, NULL, 'G3DSA:1.20.1560.10:FF:000889', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224057, NULL, 'G3DSA:3.80.10.10:FF:003322', NULL, NULL, 'Si:ch211-191a16.5', NULL, NULL, NULL, NULL, NULL, 4),
(224058, NULL, 'G3DSA:2.130.10.10:FF:002664', NULL, NULL, 'Protein DSE1', NULL, NULL, NULL, NULL, NULL, 4),
(224059, NULL, 'G3DSA:2.30.42.10:FF:000410', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224060, NULL, 'G3DSA:3.40.1090.10:FF:000105', NULL, NULL, 'Uncharacterized protein C1A6.05c', NULL, NULL, NULL, NULL, NULL, 4),
(224061, NULL, 'G3DSA:1.10.730.10:FF:000136', NULL, NULL, 'Leucyl-tRNA synthetase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(224062, NULL, 'G3DSA:3.10.100.10:FF:000143', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224063, NULL, 'G3DSA:3.40.50.10810:FF:000228', NULL, NULL, 'SNF2 DNA repair protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(224064, NULL, 'G3DSA:2.30.30.40:FF:000291', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(224065, NULL, 'G3DSA:3.30.160.110:FF:000003', NULL, NULL, 'Siroheme synthase component enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(224066, NULL, 'G3DSA:2.130.10.10:FF:002607', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224067, NULL, 'G3DSA:2.120.10.80:FF:000274', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224068, NULL, 'G3DSA:2.60.40.1170:FF:000020', NULL, NULL, 'AP-4 complex subunit mu', NULL, NULL, NULL, NULL, NULL, 4),
(224069, NULL, 'G3DSA:3.20.20.100:FF:000017', NULL, NULL, 'Aflatoxin B1 aldehyde reductase member 2', NULL, NULL, NULL, NULL, NULL, 4),
(224070, NULL, 'G3DSA:3.40.390.10:FF:000011', NULL, NULL, 'Disintegrin and metalloproteinase domain-containing protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(224071, NULL, 'G3DSA:2.130.10.10:FF:004316', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224072, NULL, 'G3DSA:1.10.3460.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224073, NULL, 'G3DSA:2.40.160.120:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224074, NULL, 'G3DSA:1.20.210.10:FF:000027', NULL, NULL, 'Cytochrome c oxidase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(224075, NULL, 'G3DSA:3.30.40.10:FF:001932', NULL, NULL, 'E3 ubiquitin-protein ligase hel2', NULL, NULL, NULL, NULL, NULL, 4),
(224076, NULL, 'G3DSA:3.40.50.720:FF:001632', NULL, NULL, 'Aldehyde reductase II (AFU_orthologue AFUA_1G11360)', NULL, NULL, NULL, NULL, NULL, 4),
(224077, NULL, 'G3DSA:3.40.50.450:FF:000096', NULL, NULL, 'Putative 2''-deoxynucleoside 5''-phosphate N-hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(224078, NULL, 'G3DSA:2.130.10.10:FF:000573', NULL, NULL, 'Intraflagellar transport protein 122 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(224079, NULL, 'G3DSA:2.60.200.10:FF:000019', NULL, NULL, 'Interferon regulatory factor 9', NULL, NULL, NULL, NULL, NULL, 4),
(224080, NULL, 'G3DSA:2.30.30.40:FF:000234', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(224081, NULL, 'G3DSA:3.30.160.60:FF:005946', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224082, NULL, 'G3DSA:2.40.160.110:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224083, NULL, 'G3DSA:3.40.50.300:FF:001006', NULL, NULL, 'Molybdate ABC transporter ATP-binding protein ModF', NULL, NULL, NULL, NULL, NULL, 4),
(224084, NULL, 'G3DSA:2.70.98.10:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224085, NULL, 'G3DSA:3.40.50.1440:FF:000037', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(224086, NULL, 'G3DSA:2.60.40.10:FF:002540', NULL, NULL, 'Protein sidekick homolog', NULL, NULL, NULL, NULL, NULL, 4),
(224087, NULL, 'G3DSA:2.20.90.10:FF:000010', NULL, NULL, 'Vitellogenin-1', NULL, NULL, NULL, NULL, NULL, 4),
(224088, NULL, 'G3DSA:2.60.40.10:FF:005789', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224089, NULL, 'G3DSA:4.10.1240.10:FF:000034', NULL, NULL, 'Diuretic hormone 31 receptor, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(224090, NULL, 'G3DSA:2.40.10.10:FF:000662', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224091, NULL, 'G3DSA:1.10.510.10:FF:002571', NULL, NULL, 'STE/STE11 protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(224092, NULL, 'G3DSA:3.40.228.10:FF:000022', NULL, NULL, 'Twin-arginine translocation signal domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(224093, NULL, 'G3DSA:1.20.1250.20:FF:001774', NULL, NULL, 'Major facilitator superfamily MFS_1', NULL, NULL, NULL, NULL, NULL, 4),
(224094, NULL, 'G3DSA:3.40.50.10260:FF:000024', NULL, NULL, 'Enhancer of mRNA decapping 3', NULL, NULL, NULL, NULL, NULL, 4),
(224095, NULL, 'G3DSA:1.10.287.110:FF:000310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224096, NULL, 'G3DSA:1.20.1310.10:FF:000141', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224097, NULL, 'G3DSA:1.10.510.10:FF:001929', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224098, NULL, 'G3DSA:3.40.50.1970:FF:000022', NULL, NULL, 'Alcohol dehydrogenase lateral transfer candidate', NULL, NULL, NULL, NULL, NULL, 4),
(224099, NULL, 'G3DSA:3.30.2350.20:FF:000070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224100, NULL, 'G3DSA:3.40.630.10:FF:000311', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224101, NULL, 'G3DSA:2.60.40.60:FF:000559', NULL, NULL, 'Cadherin-related hmr-1', NULL, NULL, NULL, NULL, NULL, 4),
(224102, NULL, 'G3DSA:3.40.30.10:FF:000329', NULL, NULL, 'Merozoite capping protein-1', NULL, NULL, NULL, NULL, NULL, 4),
(224103, NULL, 'G3DSA:3.40.50.300:FF:002754', NULL, NULL, 'Signal recognition particle (SRP) subunit', NULL, NULL, NULL, NULL, NULL, 4),
(224104, NULL, 'G3DSA:1.20.1050.10:FF:000042', NULL, NULL, 'Glutathione S-transferase F9', NULL, NULL, NULL, NULL, NULL, 4),
(224105, NULL, 'G3DSA:3.10.450.10:FF:000074', NULL, NULL, 'Cystatin E/M', NULL, NULL, NULL, NULL, NULL, 4),
(224106, NULL, 'G3DSA:3.30.420.300:FF:000002', NULL, NULL, '2-dehydro-3-deoxygalactonate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(224107, NULL, 'G3DSA:3.30.70.1350:FF:000024', NULL, NULL, 'Cation-efflux pump FieF protein', NULL, NULL, NULL, NULL, NULL, 4),
(224108, NULL, 'G3DSA:3.40.50.140:FF:000008', NULL, NULL, 'DNA topoisomerase 1A', NULL, NULL, NULL, NULL, NULL, 4),
(224109, NULL, 'G3DSA:3.30.200.20:FF:001863', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224110, NULL, 'G3DSA:3.40.190.10:FF:000355', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(224111, NULL, 'G3DSA:3.20.110.10:FF:000006', NULL, NULL, 'Alpha-mannosidase MngB', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(224112, NULL, 'G3DSA:3.40.640.10:FF:000424', NULL, NULL, 'Glutamic--pyruvic transaminase', NULL, NULL, NULL, NULL, NULL, 4),
(224113, NULL, 'G3DSA:3.10.450.10:FF:000017', NULL, NULL, 'CST9 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(224114, NULL, 'G3DSA:1.20.890.10:FF:000005', NULL, NULL, 'calcium-binding tyrosine phosphorylation-regulated protein isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(224115, NULL, 'G3DSA:3.30.70.330:FF:000330', NULL, NULL, 'RNA-binding motif protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(224116, NULL, 'G3DSA:1.10.10.10:FF:002099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224117, NULL, 'G3DSA:3.90.660.20:FF:000001', NULL, NULL, 'Protoporphyrinogen oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(224118, NULL, 'G3DSA:1.10.472.10:FF:000109', NULL, NULL, 'Cyclin-J18-like', NULL, NULL, NULL, NULL, NULL, 4),
(224119, NULL, 'G3DSA:2.60.40.10:FF:003698', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224120, NULL, 'G3DSA:2.40.100.10:FF:000117', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase slr1251', NULL, NULL, NULL, NULL, NULL, 4),
(224121, NULL, 'G3DSA:2.20.28.10:FF:000029', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(224122, NULL, 'G3DSA:3.30.420.40:FF:001003', NULL, NULL, 'Protein CBG19481', NULL, NULL, NULL, NULL, NULL, 4),
(224123, NULL, 'G3DSA:3.10.20.90:FF:000904', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224124, NULL, 'G3DSA:3.40.50.300:FF:000663', NULL, NULL, 'von Willebrand factor A domain containing 8', NULL, NULL, NULL, NULL, NULL, 4),
(224125, NULL, 'G3DSA:3.90.1600.10:FF:000044', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224126, NULL, 'G3DSA:3.40.50.1000:FF:000636', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224127, NULL, 'G3DSA:3.40.50.1000:FF:000546', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224128, NULL, 'G3DSA:1.20.120.180:FF:000003', NULL, NULL, 'Proteasome activator complex subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(224129, NULL, 'G3DSA:3.50.50.60:FF:000215', NULL, NULL, 'FAD dependent oxidoreductase domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(224130, NULL, 'G3DSA:2.70.98.10:FF:000014', NULL, NULL, 'Aldose 1-epimerase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(224131, NULL, 'G3DSA:3.40.50.300:FF:003007', NULL, NULL, 'Deoxyuridine 5-triphosphate nucleotidohydrolase domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(224132, NULL, 'G3DSA:3.40.50.2000:FF:000037', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(224133, NULL, 'G3DSA:3.30.60.20:FF:000008', NULL, NULL, 'Protein kinase C theta', NULL, NULL, NULL, NULL, NULL, 4),
(224134, NULL, 'G3DSA:2.40.50.140:FF:001176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224135, NULL, 'G3DSA:3.30.160.60:FF:006497', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224136, NULL, 'G3DSA:1.10.3720.10:FF:000141', NULL, NULL, 'Amino acid ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(224137, NULL, 'G3DSA:2.60.120.970:FF:000106', NULL, NULL, 'Putative TGF-beta ligand Decapentaplegic protein', NULL, NULL, NULL, NULL, NULL, 4),
(224138, NULL, 'G3DSA:2.60.40.10:FF:005974', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224139, NULL, 'G3DSA:2.120.10.80:FF:000364', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224140, NULL, 'G3DSA:1.10.645.10:FF:000005', NULL, NULL, 'NADH-quinone oxidoreductase subunit D', NULL, NULL, NULL, NULL, NULL, 4),
(224141, NULL, 'G3DSA:1.20.1250.20:FF:001807', NULL, NULL, 'Slc17a3 protein', NULL, NULL, NULL, NULL, NULL, 4),
(224142, NULL, 'G3DSA:2.60.40.60:FF:000615', NULL, NULL, 'Cadherin-2', NULL, NULL, NULL, NULL, NULL, 4),
(224143, NULL, 'G3DSA:1.10.287.940:FF:000025', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224144, NULL, 'G3DSA:1.25.40.10:FF:003888', NULL, NULL, 'Testis-expressed 11', NULL, NULL, NULL, NULL, NULL, 4),
(224145, NULL, 'G3DSA:1.25.10.10:FF:000008', NULL, NULL, 'plakophilin-4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(224146, NULL, 'G3DSA:2.60.120.10:FF:000693', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224147, NULL, 'G3DSA:3.40.50.300:FF:000843', NULL, NULL, 'Chromatin structure-remodeling complex subunit snf21', NULL, NULL, NULL, NULL, NULL, 4),
(224148, NULL, 'G3DSA:3.30.2350.20:FF:000013', NULL, NULL, 'Putative tRNA pseudouridine synthase D', NULL, NULL, NULL, NULL, NULL, 4),
(224149, NULL, 'G3DSA:3.40.120.10:FF:000082', NULL, NULL, 'Phosphomannomutase', NULL, NULL, NULL, NULL, NULL, 4),
(224150, NULL, 'G3DSA:2.70.98.20:FF:000017', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(224151, NULL, 'G3DSA:3.30.497.10:FF:000126', NULL, NULL, 'Os05g0511800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(224152, NULL, 'G3DSA:3.40.190.10:FF:000411', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(224153, NULL, 'G3DSA:3.30.60.30:FF:000253', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224154, NULL, 'G3DSA:2.120.10.80:FF:000420', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224155, NULL, 'G3DSA:3.30.70.3000:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224156, NULL, 'G3DSA:3.80.10.10:FF:004396', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224157, NULL, 'G3DSA:3.30.9.10:FF:000258', NULL, NULL, 'L-2-hydroxyglutarate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(224158, NULL, 'G3DSA:2.130.10.10:FF:004373', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224159, NULL, 'G3DSA:2.60.40.10:FF:003788', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224160, NULL, 'G3DSA:2.60.40.60:FF:000144', NULL, NULL, 'FAT atypical cadherin 4', NULL, NULL, NULL, NULL, NULL, 4),
(224161, NULL, 'G3DSA:3.30.160.60:FF:004081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224162, NULL, 'G3DSA:1.25.10.10:FF:000536', NULL, NULL, 'GG11161', NULL, NULL, NULL, NULL, NULL, 4),
(224163, NULL, 'G3DSA:2.60.40.640:FF:000083', NULL, NULL, 'Down syndrome critical region protein', NULL, NULL, NULL, NULL, NULL, 4),
(224164, NULL, 'G3DSA:3.30.50.10:FF:000033', NULL, NULL, 'Nuclear receptor subfamily 1 group I member 2', NULL, NULL, NULL, NULL, NULL, 4),
(224165, NULL, 'G3DSA:3.30.390.110:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224166, NULL, 'G3DSA:3.40.50.1820:FF:000966', NULL, NULL, 'YALI0F16731p', NULL, NULL, NULL, NULL, NULL, 4),
(224167, NULL, 'G3DSA:2.160.10.10:FF:000122', NULL, NULL, 'Dynactin subunit 6', NULL, NULL, NULL, NULL, NULL, 4),
(224168, NULL, 'G3DSA:3.30.2350.10:FF:000010', NULL, NULL, 'RNA pseudouridine synthase domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(224169, NULL, 'G3DSA:1.20.920.10:FF:000059', NULL, NULL, 'Polybromo 1,-like', NULL, NULL, NULL, NULL, NULL, 4),
(224170, NULL, 'G3DSA:3.30.200.20:FF:000520', NULL, NULL, 'Calcium-dependent protein kinase 6', NULL, NULL, NULL, NULL, NULL, 4),
(224171, NULL, 'G3DSA:3.30.70.3340:FF:000003', NULL, NULL, 'Dissimilatory sulfite reductase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(224172, NULL, 'G3DSA:2.40.50.100:FF:000231', NULL, NULL, 'ATPase H+-transporting V1 subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(224173, NULL, 'G3DSA:1.20.5.4770:FF:000007', NULL, NULL, 'Zinc finger A20 and AN1 domain-containing stress-associated protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(224174, NULL, 'G3DSA:2.60.40.10:FF:003411', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224175, NULL, 'G3DSA:3.30.450.40:FF:000191', NULL, NULL, 'Bacteriophytochrome (Light-regulated signal transduction histidine kinase), PhyB2', NULL, NULL, NULL, NULL, NULL, 4),
(224176, NULL, 'G3DSA:2.10.25.10:FF:001237', NULL, NULL, 'Slit (Drosophila) homolog 3', NULL, NULL, NULL, NULL, NULL, 4),
(224177, NULL, 'G3DSA:3.30.70.2020:FF:000001', NULL, NULL, 'Phosphoserine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(224178, NULL, 'G3DSA:3.30.420.10:FF:000348', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(224179, NULL, 'G3DSA:3.30.200.20:FF:000317', NULL, NULL, 'Ephrin type-A receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(224180, NULL, 'G3DSA:2.160.20.10:FF:000095', NULL, NULL, 'Plasmin and fibronectin-binding protein A', NULL, NULL, NULL, NULL, NULL, 4),
(224181, NULL, 'G3DSA:1.10.10.10:FF:001789', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224182, NULL, 'G3DSA:3.40.50.2300:FF:000155', NULL, NULL, 'Vomeronasal 2, receptor 120', NULL, NULL, NULL, NULL, NULL, 4),
(224183, NULL, 'G3DSA:3.40.50.10860:FF:000018', NULL, NULL, 'Shikimate 5-dehydrogenase AroE', NULL, NULL, NULL, NULL, NULL, 4),
(224184, NULL, 'G3DSA:2.30.42.10:FF:000090', NULL, NULL, 'PDZ domain containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(224185, NULL, 'G3DSA:3.30.160.60:FF:000567', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM36 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(224186, NULL, 'G3DSA:1.20.1270.60:FF:000337', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224187, NULL, 'G3DSA:2.60.40.60:FF:000672', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224188, NULL, 'G3DSA:1.10.510.10:FF:004515', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224189, NULL, 'G3DSA:1.10.730.10:FF:000193', NULL, NULL, 'Arginyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(224190, NULL, 'G3DSA:3.80.10.10:FF:000034', NULL, NULL, 'Ras suppressor protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(224191, NULL, 'G3DSA:3.30.9.10:FF:000297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224192, NULL, 'G3DSA:3.30.60.20:FF:000065', NULL, NULL, 'Tensin 1', NULL, NULL, NULL, NULL, NULL, 4),
(224193, NULL, 'G3DSA:3.10.50.40:FF:000088', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(224194, NULL, 'G3DSA:3.10.20.90:FF:000814', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224195, NULL, 'G3DSA:2.160.10.10:FF:000066', NULL, NULL, 'Acetyltransferase (Isoleucine patch superfamily)', NULL, NULL, NULL, NULL, NULL, 4),
(224196, NULL, 'G3DSA:3.30.160.60:FF:002079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224197, NULL, 'G3DSA:3.30.50.10:FF:000123', NULL, NULL, 'Nuclear receptor subfamily 2 group F member 6', NULL, NULL, NULL, NULL, NULL, 4),
(224198, NULL, 'G3DSA:1.20.5.690:FF:000005', NULL, NULL, 'Importin subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(224199, NULL, 'G3DSA:1.10.20.10:FF:000216', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224200, NULL, 'G3DSA:1.10.167.10:FF:000057', NULL, NULL, 'GTPase-activating protein', NULL, NULL, NULL, NULL, NULL, 4),
(224201, NULL, 'G3DSA:3.30.60.30:FF:000068', NULL, NULL, 'CRE-AGR-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(224202, NULL, 'G3DSA:3.40.50.720:FF:000053', NULL, NULL, 'Quinone oxidoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(224203, NULL, 'G3DSA:1.10.1450.10:FF:000007', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(224204, NULL, 'G3DSA:1.20.1070.10:FF:001386', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224205, NULL, 'G3DSA:1.10.10.10:FF:001992', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224206, NULL, 'G3DSA:1.10.132.10:FF:000005', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(224207, NULL, 'G3DSA:3.30.1540.20:FF:000022', NULL, NULL, 'DNA mismatch repair protein (Mlh3), putative (AFU_orthologue AFUA_4G06490)', NULL, NULL, NULL, NULL, NULL, 4),
(224208, NULL, 'G3DSA:1.10.132.20:FF:000008', NULL, NULL, 'Ribosome_recycling_factor_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(224209, NULL, 'G3DSA:1.10.10.60:FF:000091', NULL, NULL, 'CDC5 cell division cycle 5-like', NULL, NULL, NULL, NULL, NULL, 4),
(224210, NULL, 'G3DSA:2.60.120.920:FF:000086', NULL, NULL, 'Butyrophilin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(224211, NULL, 'G3DSA:1.25.40.10:FF:005069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224212, NULL, 'G3DSA:3.40.50.1820:FF:001186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(224213, NULL, 'G3DSA:3.40.50.740:FF:000059', NULL, NULL, 'Extracellular oxidoreductase molybdopterin-binding lipoprotein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(224214, NULL, 'G3DSA:3.10.100.10:FF:000087', NULL, NULL, 'Snaclec rhodocetin subunit delta', NULL, NULL, NULL, NULL, NULL, 4),
(224215, NULL, 'G3DSA:1.25.40.10:FF:004107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224216, NULL, 'G3DSA:2.130.10.10:FF:002574', NULL, NULL, 'Protein will die slowly-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(224217, NULL, 'G3DSA:2.60.40.10:FF:001989', NULL, NULL, 'Unc-89 protein', NULL, NULL, NULL, NULL, NULL, 4),
(224218, NULL, 'G3DSA:3.40.50.300:FF:007897', NULL, NULL, 'Formate-tetrahydrofolate ligase', NULL, NULL, NULL, NULL, NULL, 4),
(224219, NULL, 'G3DSA:1.10.287.110:FF:000074', NULL, NULL, 'Heat shock protein DNAJ, putative', NULL, NULL, NULL, NULL, NULL, 4),
(224220, NULL, 'G3DSA:4.10.890.10:FF:000001', NULL, NULL, 'Protein Nef', NULL, NULL, NULL, NULL, NULL, 4),
(224221, NULL, 'G3DSA:3.30.60.10:FF:000005', NULL, NULL, 'Endochitinase At2g43610', NULL, NULL, NULL, NULL, NULL, 4),
(224222, NULL, 'G3DSA:2.60.420.10:FF:000002', NULL, NULL, 'Protein-glucosylgalactosylhydroxylysine glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(224223, NULL, 'G3DSA:1.20.140.150:FF:000116', NULL, NULL, 'Claudin-10e', NULL, NULL, NULL, NULL, NULL, 4),
(224224, NULL, 'G3DSA:3.40.50.150:FF:000742', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224225, NULL, 'G3DSA:3.40.50.1820:FF:001129', NULL, NULL, 'Acylamino acid-releasing enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(224226, NULL, 'G3DSA:3.30.200.20:FF:000430', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(224227, NULL, 'G3DSA:3.30.2160.10:FF:000029', NULL, NULL, 'Ubiquitin ligase (E3)', NULL, NULL, NULL, NULL, NULL, 4),
(224228, NULL, 'G3DSA:3.30.70.980:FF:000058', NULL, NULL, 'Probable transcriptional regulatory protein MG332', NULL, NULL, NULL, NULL, NULL, 4),
(224229, NULL, 'G3DSA:3.40.50.1000:FF:000456', NULL, NULL, 'UPF0655 protein C17G9.12c', NULL, NULL, NULL, NULL, NULL, 4),
(224230, NULL, 'G3DSA:1.20.1250.20:FF:000993', NULL, NULL, 'MFS transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(224231, NULL, 'G3DSA:3.90.1410.10:FF:000029', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224232, NULL, 'G3DSA:1.10.20.120:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224233, NULL, 'G3DSA:2.60.40.10:FF:001899', NULL, NULL, 'Immunoglobulin superfamily containing leucine rich repeat 2', NULL, NULL, NULL, NULL, NULL, 4),
(224234, NULL, 'G3DSA:3.30.40.10:FF:001078', NULL, NULL, 'GM14196', NULL, NULL, NULL, NULL, NULL, 4),
(224235, NULL, 'G3DSA:2.40.180.10:FF:000038', NULL, NULL, 'Catalase', NULL, NULL, NULL, NULL, NULL, 4),
(224236, NULL, 'G3DSA:1.10.238.10:FF:000672', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224237, NULL, 'G3DSA:1.10.287.70:FF:000123', NULL, NULL, 'Potassium channel KAT3', NULL, NULL, NULL, NULL, NULL, 4),
(224238, NULL, 'G3DSA:3.30.2410.10:FF:000066', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224239, NULL, 'G3DSA:3.40.50.10860:FF:000075', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224240, NULL, 'G3DSA:3.80.10.10:FF:001523', NULL, NULL, 'Leucine rich repeat protein GP150', NULL, NULL, NULL, NULL, NULL, 4),
(224241, NULL, 'G3DSA:2.130.10.10:FF:004463', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224242, NULL, 'G3DSA:3.40.109.10:FF:000038', NULL, NULL, 'Putative oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(224243, NULL, 'G3DSA:1.10.10.1050:FF:000024', NULL, NULL, 'GM04208p', NULL, NULL, NULL, NULL, NULL, 4),
(224244, NULL, 'G3DSA:4.10.1170.10:FF:000005', NULL, NULL, 'MAP kinase-activated protein kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(224245, NULL, 'G3DSA:2.60.40.1910:FF:000017', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(224246, NULL, 'G3DSA:3.90.470.10:FF:000017', NULL, NULL, '54S ribosomal protein L22, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(224247, NULL, 'G3DSA:3.40.190.10:FF:000501', NULL, NULL, 'Oligopeptide ABC transporter, periplasmic oligopeptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(224248, NULL, 'G3DSA:1.10.3720.10:FF:000051', NULL, NULL, 'Amino acid ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(224249, NULL, 'G3DSA:3.90.226.10:FF:000080', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(224250, NULL, 'G3DSA:1.10.20.10:FF:000273', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224251, NULL, 'G3DSA:1.10.287.660:FF:000008', NULL, NULL, 'Pre-mRNA processing ribonucleoprotein, binding domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(224252, NULL, 'G3DSA:1.25.10.10:FF:000626', NULL, NULL, 'Adaptor related protein complex 5 subunit zeta 1', NULL, NULL, NULL, NULL, NULL, 4),
(224253, NULL, 'G3DSA:1.20.1250.20:FF:001246', NULL, NULL, 'Peptide transporter PTR2-B', NULL, NULL, NULL, NULL, NULL, 4),
(224254, NULL, 'G3DSA:2.40.70.10:FF:000261', NULL, NULL, 'Renin', NULL, NULL, NULL, NULL, NULL, 4),
(224255, NULL, 'G3DSA:2.40.50.1000:FF:000002', NULL, NULL, '40S ribosomal protein S11', NULL, NULL, NULL, NULL, NULL, 4),
(224256, NULL, 'G3DSA:2.60.260.20:FF:000060', NULL, NULL, 'Scj1p', NULL, NULL, NULL, NULL, NULL, 4),
(224257, NULL, 'G3DSA:3.40.50.620:FF:000877', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224258, NULL, 'G3DSA:3.80.10.10:FF:001670', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(224259, NULL, 'G3DSA:3.40.50.720:FF:000143', NULL, NULL, 'Fatty acyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(224260, NULL, 'G3DSA:2.60.40.640:FF:000026', NULL, NULL, 'Aly1p', NULL, NULL, NULL, NULL, NULL, 4),
(224261, NULL, 'G3DSA:3.10.330.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224262, NULL, 'G3DSA:2.130.10.10:FF:003592', NULL, NULL, 'HEAT repeatcontaining protein', NULL, NULL, NULL, NULL, NULL, 4),
(224263, NULL, 'G3DSA:3.90.228.10:FF:000062', NULL, NULL, 'Zinc finger CCCH-type antiviral protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(224264, NULL, 'G3DSA:1.20.58.390:FF:000218', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224265, NULL, 'G3DSA:3.40.50.1820:FF:001276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224266, NULL, 'G3DSA:3.50.50.60:FF:000305', NULL, NULL, 'Rab proteins geranylgeranyltransferase component A', NULL, NULL, NULL, NULL, NULL, 4),
(224267, NULL, 'G3DSA:2.40.70.10:FF:000019', NULL, NULL, 'aspartyl protease family protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(224268, NULL, 'G3DSA:3.40.50.300:FF:004553', NULL, NULL, 'Uridine kinase, putative (AFU_orthologue AFUA_2G05430)', NULL, NULL, NULL, NULL, NULL, 4),
(224269, NULL, 'G3DSA:3.30.40.10:FF:002005', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224270, NULL, 'G3DSA:1.20.58.1620:FF:000001', NULL, NULL, 'Thylakoid lumenal 29 kDa protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(224271, NULL, 'G3DSA:1.10.510.10:FF:000625', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 6', NULL, NULL, NULL, NULL, NULL, 4),
(224272, NULL, 'G3DSA:3.40.50.300:FF:007987', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224273, NULL, 'G3DSA:2.60.120.200:FF:000578', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224274, NULL, 'G3DSA:3.30.160.60:FF:004552', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224275, NULL, 'G3DSA:3.30.830.10:FF:000014', NULL, NULL, 'Mitochondrial-processing peptidase alpha subunit, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(224276, NULL, 'G3DSA:2.40.50.100:FF:000028', NULL, NULL, 'Sugar ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(224277, NULL, 'G3DSA:3.30.200.20:FF:000374', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(224278, NULL, 'G3DSA:1.10.560.10:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224279, NULL, 'G3DSA:2.170.120.12:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224280, NULL, 'G3DSA:2.40.50.100:FF:000085', NULL, NULL, '50S ribosomal protein L27', NULL, NULL, NULL, NULL, NULL, 4),
(224281, NULL, 'G3DSA:3.30.565.10:FF:000116', NULL, NULL, 'Sensor histidine kinase FleS', NULL, NULL, NULL, NULL, NULL, 4),
(224282, NULL, 'G3DSA:3.40.1410.10:FF:000024', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(224283, NULL, 'G3DSA:3.30.70.270:FF:000233', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224284, NULL, 'G3DSA:2.60.40.60:FF:000762', NULL, NULL, 'Cadherin-4', NULL, NULL, NULL, NULL, NULL, 4),
(224285, NULL, 'G3DSA:2.70.130.10:FF:000141', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224286, NULL, 'G3DSA:1.10.510.10:FF:000064', NULL, NULL, 'BR serine/threonine-protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(224287, NULL, 'G3DSA:1.20.140.150:FF:000026', NULL, NULL, 'Epithelial membrane protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(224288, NULL, 'G3DSA:1.20.1070.10:FF:001908', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224289, NULL, 'G3DSA:1.10.274.100:FF:000005', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(224290, NULL, 'G3DSA:3.30.160.60:FF:000281', NULL, NULL, 'Zinc finger protein 558 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(224291, NULL, 'G3DSA:1.25.40.20:FF:000367', NULL, NULL, 'Transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(224292, NULL, 'G3DSA:1.25.40.10:FF:000364', NULL, NULL, 'Pentatricopeptide repeat (PPR-like) superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(224293, NULL, 'G3DSA:1.20.5.4820:FF:000006', NULL, NULL, 'Myosin XVI', NULL, NULL, NULL, NULL, NULL, 4),
(224294, NULL, 'G3DSA:3.90.550.10:FF:000260', NULL, NULL, 'N-acylneuraminate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(224295, NULL, 'G3DSA:3.40.50.300:FF:004643', NULL, NULL, 'AGAP001537-PA', NULL, NULL, NULL, NULL, NULL, 4),
(224296, NULL, 'G3DSA:2.130.10.10:FF:003968', NULL, NULL, 'Serine/threonine-protein phosphatase 2A 55 kDa regulatory subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(224297, NULL, 'G3DSA:2.60.40.10:FF:002394', NULL, NULL, 'Protein madd-4', NULL, NULL, NULL, NULL, NULL, 4),
(224298, NULL, 'G3DSA:1.20.1060.20:FF:000017', NULL, NULL, 'Chromosome partition protein Smc', NULL, NULL, NULL, NULL, NULL, 4),
(224299, NULL, 'G3DSA:3.40.50.300:FF:008353', NULL, NULL, 'ATP-binding cassette subfamily C member 9', NULL, NULL, NULL, NULL, NULL, 4),
(224300, NULL, 'G3DSA:1.10.510.10:FF:004425', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224301, NULL, 'G3DSA:3.30.160.60:FF:000039', NULL, NULL, 'Zinc finger protein ZIC 1', NULL, NULL, NULL, NULL, NULL, 4),
(224302, NULL, 'G3DSA:1.25.10.10:FF:000065', NULL, NULL, 'Regulatory-associated protein of MTOR, complex 1', NULL, NULL, NULL, NULL, NULL, 4),
(224303, NULL, 'G3DSA:2.40.50.140:FF:001209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224304, NULL, 'G3DSA:1.10.287.110:FF:000164', NULL, NULL, 'dnaJ homolog subfamily C member 22', NULL, NULL, NULL, NULL, NULL, 4),
(224305, NULL, 'G3DSA:1.20.1250.20:FF:001920', NULL, NULL, 'Glr0912 protein', NULL, NULL, NULL, NULL, NULL, 4),
(224306, NULL, 'G3DSA:3.30.40.10:FF:001752', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224307, NULL, 'G3DSA:3.90.420.10:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224308, NULL, 'G3DSA:3.80.10.10:FF:001338', NULL, NULL, 'F-box/leucine rich repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(224309, NULL, 'G3DSA:1.10.150.130:FF:000002', NULL, NULL, 'Tyrosine recombinase XerD', NULL, NULL, NULL, NULL, NULL, 4),
(224310, NULL, 'G3DSA:3.80.10.10:FF:001580', NULL, NULL, 'F-box family protein', NULL, NULL, NULL, NULL, NULL, 4),
(224311, NULL, 'G3DSA:3.10.20.90:FF:000292', NULL, NULL, 'Next to BRCA1 gene 1 protein', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(224312, NULL, 'G3DSA:1.20.1060.10:FF:000014', NULL, NULL, 'Polymerase (DNA directed) nu', NULL, NULL, NULL, NULL, NULL, 4),
(224313, NULL, 'G3DSA:3.40.710.10:FF:000166', NULL, NULL, 'Peptidoglycan transglycosylase and transpeptidase MrcA', NULL, NULL, NULL, NULL, NULL, 4),
(224314, NULL, 'G3DSA:3.30.360.10:FF:000056', NULL, NULL, 'Myo-inositol 2-dehydrogenase/D-chiro-inositol 1-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(224315, NULL, 'G3DSA:3.90.1150.220:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224316, NULL, 'G3DSA:2.40.50.100:FF:000175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224317, NULL, 'G3DSA:1.25.40.10:FF:003798', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224318, NULL, 'G3DSA:1.10.560.10:FF:000067', NULL, NULL, 'Chaperonin 60', NULL, NULL, NULL, NULL, NULL, 4),
(224319, NULL, 'G3DSA:1.10.3470.10:FF:000014', NULL, NULL, 'Iron ABC transporter permease', NULL, NULL, NULL, NULL, NULL, 4),
(224320, NULL, 'G3DSA:1.10.510.10:FF:000772', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224321, NULL, 'G3DSA:2.60.40.60:FF:000054', NULL, NULL, 'protocadherin-15 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(224322, NULL, 'G3DSA:2.40.70.10:FF:000171', NULL, NULL, 'Eukaryotic aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(224323, NULL, 'G3DSA:3.10.690.10:FF:000001', NULL, NULL, 'Bifunctional nuclease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(224324, NULL, 'G3DSA:1.20.5.420:FF:000008', NULL, NULL, 'Endo-1,3-beta-glucanase Engl1', NULL, NULL, NULL, NULL, NULL, 4),
(224325, NULL, 'G3DSA:3.40.630.10:FF:000165', NULL, NULL, 'Glucan 1,4-alpha-glucosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(224326, NULL, 'G3DSA:3.40.47.10:FF:000132', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224327, NULL, 'G3DSA:3.40.5.10:FF:000002', NULL, NULL, '50S ribosomal protein L9', NULL, NULL, NULL, NULL, NULL, 4),
(224328, NULL, 'G3DSA:1.25.10.10:FF:000716', NULL, NULL, 'Nucleotide exchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(224329, NULL, 'G3DSA:2.60.40.60:FF:000705', NULL, NULL, 'Cdh-4', NULL, NULL, NULL, NULL, NULL, 4),
(224330, NULL, 'G3DSA:3.30.160.60:FF:004642', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224331, NULL, 'G3DSA:2.60.260.20:FF:000150', NULL, NULL, 'Chaperone protein dnaJ 3', NULL, NULL, NULL, NULL, NULL, 4),
(224332, NULL, 'G3DSA:3.30.70.100:FF:000082', NULL, NULL, 'Putative NipSnap protein K02D10.1', NULL, NULL, NULL, NULL, NULL, 4),
(224333, NULL, 'G3DSA:3.30.1370.10:FF:000040', NULL, NULL, 'KH domain-containing protein At2g38610', NULL, NULL, NULL, NULL, NULL, 4),
(224334, NULL, 'G3DSA:1.20.58.390:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224335, NULL, 'G3DSA:3.90.1150.210:FF:000001', NULL, NULL, 'F-actin-capping protein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(224336, NULL, 'G3DSA:2.60.40.10:FF:003844', NULL, NULL, 'Exo-beta-D-glucosaminidase', NULL, NULL, NULL, NULL, NULL, 4),
(224337, NULL, 'G3DSA:3.40.50.300:FF:007369', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224338, NULL, 'G3DSA:3.30.1120.10:FF:000049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224339, NULL, 'G3DSA:3.40.50.10190:FF:000357', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224340, NULL, 'G3DSA:1.10.510.10:FF:003498', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224341, NULL, 'G3DSA:1.20.58.390:FF:000128', NULL, NULL, 'Neuronal acetylcholine receptor subunit eat-2', NULL, NULL, NULL, NULL, NULL, 4),
(224342, NULL, 'G3DSA:3.90.1140.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224343, NULL, 'G3DSA:1.20.920.30:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224344, NULL, 'G3DSA:2.130.10.10:FF:005885', NULL, NULL, 'Probable inositol polyphosphate 5-phosphatase C9G1.10c', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(224345, NULL, 'G3DSA:3.40.50.880:FF:000056', NULL, NULL, 'Imidazole glycerol phosphate synthase subunit HisH', NULL, NULL, NULL, NULL, NULL, 4),
(224346, NULL, 'G3DSA:1.10.10.60:FF:000652', NULL, NULL, 'Os01g0308000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(224347, NULL, 'G3DSA:3.40.800.20:FF:000030', NULL, NULL, 'Histone deacetylase 3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(224348, NULL, 'G3DSA:2.120.10.30:FF:000276', NULL, NULL, 'low-density lipoprotein receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(224349, NULL, 'G3DSA:1.25.10.10:FF:002453', NULL, NULL, 'ARM repeat superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(224350, NULL, 'G3DSA:2.160.20.10:FF:000331', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224351, NULL, 'G3DSA:3.10.100.10:FF:000227', NULL, NULL, 'Lymphocyte antigen 75', NULL, NULL, NULL, NULL, NULL, 4),
(224352, NULL, 'G3DSA:1.20.1560.10:FF:000884', NULL, NULL, 'MDR-like ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(224353, NULL, 'G3DSA:3.40.50.300:FF:003131', NULL, NULL, 'ATP-dependent RNA helicase RhlE', NULL, NULL, NULL, NULL, NULL, 4),
(224354, NULL, 'G3DSA:3.40.50.1820:FF:001399', NULL, NULL, 'Lipase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(224355, NULL, 'G3DSA:2.130.10.10:FF:004311', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224356, NULL, 'G3DSA:3.60.21.10:FF:000420', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224357, NULL, 'G3DSA:3.30.500.10:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224358, NULL, 'G3DSA:3.30.1010.10:FF:000013', NULL, NULL, 'Protein kinase, DNA-activated, catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(224359, NULL, 'G3DSA:2.40.30.10:FF:000051', NULL, NULL, 'NADPH-dependent diflavin oxidoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(224360, NULL, 'G3DSA:3.80.10.10:FF:001731', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(224361, NULL, 'G3DSA:1.25.40.20:FF:001502', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224362, NULL, 'G3DSA:1.10.1070.11:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224363, NULL, 'G3DSA:2.60.40.10:FF:002630', NULL, NULL, 'transmembrane protein 131 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(224364, NULL, 'G3DSA:1.20.1070.10:FF:001526', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224365, NULL, 'G3DSA:1.10.510.10:FF:003200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224366, NULL, 'G3DSA:3.40.50.200:FF:000167', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224367, NULL, 'G3DSA:3.40.1050.10:FF:000007', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(224368, NULL, 'G3DSA:3.10.20.90:FF:000286', NULL, NULL, 'Unplaced genomic scaffold supercont2.15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(224369, NULL, 'G3DSA:1.25.40.10:FF:004046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224370, NULL, 'G3DSA:1.10.510.10:FF:004335', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224371, NULL, 'G3DSA:3.90.1640.10:FF:000018', NULL, NULL, 'Inorganic diphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(224372, NULL, 'G3DSA:3.50.50.60:FF:000300', NULL, NULL, 'FAD-dependent oxidoreductase domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(224373, NULL, 'G3DSA:2.120.10.80:FF:000151', NULL, NULL, 'Kelch repeat-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(224374, NULL, 'G3DSA:3.60.130.10:FF:000089', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224375, NULL, 'G3DSA:1.20.120.1900:FF:000071', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(224376, NULL, 'G3DSA:2.20.80.10:FF:000004', NULL, NULL, 'Vitellogenin-3', NULL, NULL, NULL, NULL, NULL, 4),
(224377, NULL, 'G3DSA:2.60.40.10:FF:005856', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224378, NULL, 'G3DSA:3.30.160.60:FF:002804', NULL, NULL, 'RE1-silencing transcription factor', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(224379, NULL, 'G3DSA:2.40.50.1060:FF:000008', NULL, NULL, 'Related to dna-dependent rna polymerase I subunit a43 (Rpa43)', NULL, NULL, NULL, NULL, NULL, 4),
(224380, NULL, 'G3DSA:2.30.29.30:FF:000340', NULL, NULL, 'Arf-GAP with Rho-GAP domain, ANK repeat and PH domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(224381, NULL, 'G3DSA:3.80.10.10:FF:003822', NULL, NULL, 'Leucine-rich repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(224382, NULL, 'G3DSA:3.30.1640.10:FF:000044', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(224383, NULL, 'G3DSA:3.30.420.40:FF:000273', NULL, NULL, 'Pantothenate kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(224384, NULL, 'G3DSA:2.30.30.40:FF:000346', NULL, NULL, 'GTPase-activating protein rrc-1', NULL, NULL, NULL, NULL, NULL, 4),
(224385, NULL, 'G3DSA:3.30.70.330:FF:001926', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224386, NULL, 'G3DSA:1.10.238.10:FF:000633', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224387, NULL, 'G3DSA:1.10.437.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224388, NULL, 'G3DSA:2.130.10.10:FF:005834', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224389, NULL, 'G3DSA:3.10.20.90:FF:000674', NULL, NULL, 'Ubx domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(224390, NULL, 'G3DSA:3.40.630.30:FF:000379', NULL, NULL, 'Spermidine N(1)-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(224391, NULL, 'G3DSA:3.30.9.10:FF:000179', NULL, NULL, 'Sll1025 protein', NULL, NULL, NULL, NULL, NULL, 4),
(224392, NULL, 'G3DSA:3.40.630.10:FF:000373', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224393, NULL, 'G3DSA:3.10.20.90:FF:000348', NULL, NULL, 'DNA damage-inducible protein', NULL, NULL, NULL, NULL, NULL, 4),
(224394, NULL, 'G3DSA:1.10.510.10:FF:002683', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224395, NULL, 'G3DSA:2.40.10.10:FF:000572', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224396, NULL, 'G3DSA:1.10.510.10:FF:002306', NULL, NULL, 'Serine/threonine-protein kinase CDG1', NULL, NULL, NULL, NULL, NULL, 4),
(224397, NULL, 'G3DSA:3.60.21.10:FF:000195', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(224398, NULL, 'G3DSA:3.40.1810.10:FF:000038', NULL, NULL, 'MADS-box transcription factor 34', NULL, NULL, NULL, NULL, NULL, 4),
(224399, NULL, 'G3DSA:1.10.10.10:FF:000098', NULL, NULL, 'Two-component system response regulator PhoP', NULL, NULL, NULL, NULL, NULL, 4),
(224400, NULL, 'G3DSA:3.40.190.80:FF:000056', NULL, NULL, '3''(2''),5''-bisphosphate nucleotidase CysQ', NULL, NULL, NULL, NULL, NULL, 4),
(224401, NULL, 'G3DSA:1.10.540.10:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224402, NULL, 'G3DSA:1.25.40.20:FF:000934', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224403, NULL, 'G3DSA:1.20.1050.20:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224404, NULL, 'G3DSA:3.30.200.20:FF:001627', NULL, NULL, 'Serine/threonine-protein kinase TAO3', NULL, NULL, NULL, NULL, NULL, 4),
(224405, NULL, 'G3DSA:2.40.128.130:FF:000004', NULL, NULL, 'Autotransporter domain-containing esterase', NULL, NULL, NULL, NULL, NULL, 4),
(224406, NULL, 'G3DSA:3.40.630.10:FF:000159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224407, NULL, 'G3DSA:1.20.140.10:FF:000089', NULL, NULL, 'Pimeloyl-CoA dehydrogenase small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(224408, NULL, 'G3DSA:3.30.565.10:FF:000083', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(224409, NULL, 'G3DSA:2.60.200.20:FF:000056', NULL, NULL, 'Putative fork head domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(224410, NULL, 'G3DSA:3.90.550.50:FF:000064', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(224411, NULL, 'G3DSA:3.40.1030.10:FF:000012', NULL, NULL, 'Thymidine phosphorylase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(224412, NULL, 'G3DSA:1.10.10.820:FF:000005', NULL, NULL, 'unconventional myosin-VI isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(224413, NULL, 'G3DSA:2.60.40.2030:FF:000025', NULL, NULL, 'Adhesion G protein-coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(224414, NULL, 'G3DSA:3.40.50.200:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224415, NULL, 'G3DSA:3.40.50.970:FF:000111', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224416, NULL, 'G3DSA:3.20.20.140:FF:000479', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224417, NULL, 'G3DSA:1.10.10.830:FF:000008', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(224418, NULL, 'G3DSA:3.30.230.130:FF:000082', NULL, NULL, 'Anaphase-promoting complex subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(224419, NULL, 'G3DSA:1.25.40.10:FF:004260', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224420, NULL, 'G3DSA:1.10.150.20:FF:000235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224421, NULL, 'G3DSA:3.40.50.300:FF:001040', NULL, NULL, 'AFG1-like ATPase isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(224422, NULL, 'G3DSA:1.20.120.720:FF:000030', NULL, NULL, 'Myosin 1', NULL, NULL, NULL, NULL, NULL, 4),
(224423, NULL, 'G3DSA:1.10.150.650:FF:000006', NULL, NULL, 'PHP domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(224424, NULL, 'G3DSA:2.60.40.10:FF:002304', NULL, NULL, 'KALlmann syndrome homolog', NULL, NULL, NULL, NULL, NULL, 4),
(224425, NULL, 'G3DSA:3.30.70.330:FF:000392', NULL, NULL, 'SRA stem-loop-interacting RNA-binding protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(224426, NULL, 'G3DSA:1.10.560.10:FF:000005', NULL, NULL, 'T-complex protein 1 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(224427, NULL, 'G3DSA:1.10.10.10:FF:001458', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224428, NULL, 'G3DSA:3.40.50.1440:FF:000032', NULL, NULL, 'tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(224429, NULL, 'G3DSA:2.160.20.10:FF:000005', NULL, NULL, 'F-box only protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(224430, NULL, 'G3DSA:2.60.40.10:FF:004007', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224431, NULL, 'G3DSA:1.25.40.430:FF:000002', NULL, NULL, 'mitotic checkpoint serine/threonine-protein kinase BUB1 beta', NULL, NULL, NULL, NULL, NULL, 4),
(224432, NULL, 'G3DSA:3.30.160.60:FF:001270', NULL, NULL, 'zinc finger protein 583 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(224433, NULL, 'G3DSA:3.40.50.300:FF:002349', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(224434, NULL, 'G3DSA:3.40.50.300:FF:001091', NULL, NULL, 'Probable disease resistance protein At1g61300', NULL, NULL, NULL, NULL, NULL, 4),
(224435, NULL, 'G3DSA:1.25.40.10:FF:000605', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(224436, NULL, 'G3DSA:1.20.1250.20:FF:001841', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224437, NULL, 'G3DSA:3.50.50.60:FF:000007', NULL, NULL, 'Alkyl hydroperoxide reductase, F subunit', NULL, NULL, NULL, NULL, NULL, 4),
(224438, NULL, 'G3DSA:3.90.740.10:FF:000055', NULL, NULL, 'Valyl Amino-acyl tRNA Synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(224439, NULL, 'G3DSA:2.60.40.60:FF:000767', NULL, NULL, 'Cadherin', NULL, NULL, NULL, NULL, NULL, 4),
(224440, NULL, 'G3DSA:3.30.200.20:FF:002021', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224441, NULL, 'G3DSA:3.30.420.40:FF:000694', NULL, NULL, 'AGAP003464-PA', NULL, NULL, NULL, NULL, NULL, 4),
(224442, NULL, 'G3DSA:2.60.40.10:FF:002355', NULL, NULL, '1,4-alpha-glucan branching enzyme, putative', NULL, NULL, NULL, NULL, NULL, 4),
(224443, NULL, 'G3DSA:2.120.10.80:FF:000100', NULL, NULL, 'Kelch-like 11 (Drosophila), isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(224444, NULL, 'G3DSA:2.60.40.1360:FF:000015', NULL, NULL, 'Alpha-mannosidase E', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(224445, NULL, 'G3DSA:1.25.40.20:FF:000608', NULL, NULL, 'Os04g0574600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(224446, NULL, 'G3DSA:1.20.1050.10:FF:000103', NULL, NULL, 'Glutathione S-transferase F9', NULL, NULL, NULL, NULL, NULL, 4),
(224447, NULL, 'G3DSA:1.20.58.1770:FF:000001', NULL, NULL, 'C-Jun-amino-terminal kinase-interacting protein 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(224448, NULL, 'G3DSA:3.80.10.10:FF:001782', NULL, NULL, 'Protein CBG08830', NULL, NULL, NULL, NULL, NULL, 4),
(224449, NULL, 'G3DSA:1.10.3380.30:FF:000013', NULL, NULL, 'Putative ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(224450, NULL, 'G3DSA:3.30.565.10:FF:000178', NULL, NULL, 'Sigma factor regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(224451, NULL, 'G3DSA:1.10.3380.20:FF:000010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224452, NULL, 'G3DSA:3.30.450.40:FF:000196', NULL, NULL, 'Histidine kinase dimerisation and phosphoacceptor region', NULL, NULL, NULL, NULL, NULL, 4),
(224453, NULL, 'G3DSA:2.10.25.10:FF:001568', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224454, NULL, 'G3DSA:1.10.510.10:FF:002357', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224455, NULL, 'G3DSA:3.90.190.10:FF:000597', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224456, NULL, 'G3DSA:3.30.160.60:FF:006227', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224457, NULL, 'G3DSA:1.20.1560.10:FF:000558', NULL, NULL, 'Multidrug resistance protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(224458, NULL, 'G3DSA:3.10.10.10:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224459, NULL, 'G3DSA:3.90.550.50:FF:000013', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(224460, NULL, 'G3DSA:1.10.357.10:FF:000038', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(224461, NULL, 'G3DSA:3.30.470.30:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224462, NULL, 'G3DSA:1.10.10.60:FF:000910', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224463, NULL, 'G3DSA:1.20.58.1780:FF:000004', NULL, NULL, 'Nuclear pore complex protein Nup155', NULL, NULL, NULL, NULL, NULL, 4),
(224464, NULL, 'G3DSA:1.20.1110.10:FF:000272', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224465, NULL, 'G3DSA:3.30.2380.10:FF:000006', NULL, NULL, 'KEOPS complex subunit Cgi121', NULL, NULL, NULL, NULL, NULL, 4),
(224466, NULL, 'G3DSA:3.80.10.10:FF:002979', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224467, NULL, 'G3DSA:1.10.8.60:FF:000286', NULL, NULL, 'FI21292p1', NULL, NULL, NULL, NULL, NULL, 4),
(224468, NULL, 'G3DSA:1.10.1040.30:FF:000004', NULL, NULL, 'ISWI chromatin-remodeling complex ATPase ISW2', NULL, NULL, NULL, NULL, NULL, 4),
(224469, NULL, 'G3DSA:1.10.510.10:FF:000266', NULL, NULL, 'nuclear receptor-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(224470, NULL, 'G3DSA:2.60.40.10:FF:002416', NULL, NULL, 'Protogenin', NULL, NULL, NULL, NULL, NULL, 4),
(224471, NULL, 'G3DSA:2.60.40.60:FF:000560', NULL, NULL, 'Cadherin-related hmr-1', NULL, NULL, NULL, NULL, NULL, 4),
(224472, NULL, 'G3DSA:3.90.550.10:FF:000434', NULL, NULL, 'Uncharacterized alpha-1,2-galactosyltransferase C1289.13c', NULL, NULL, NULL, NULL, NULL, 4),
(224473, NULL, 'G3DSA:3.40.50.300:FF:002288', NULL, NULL, 'Probable thymidylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(224474, NULL, 'G3DSA:1.25.40.10:FF:000656', NULL, NULL, 'Unplaced genomic scaffold supercont1.51, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(224475, NULL, 'G3DSA:2.20.28.10:FF:000057', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(224476, NULL, 'G3DSA:2.70.170.10:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224477, NULL, 'G3DSA:3.30.70.960:FF:000013', NULL, NULL, 'Mucin glycoprotein MUC3', NULL, NULL, NULL, NULL, NULL, 4),
(224478, NULL, 'G3DSA:3.40.50.2300:FF:001049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(224479, NULL, 'G3DSA:3.30.160.60:FF:000455', NULL, NULL, 'Transcription factor Sp2', NULL, NULL, NULL, NULL, NULL, 4),
(224480, NULL, 'G3DSA:3.40.50.1820:FF:000090', NULL, NULL, 'Phosphatidylcholine-sterol acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(224481, NULL, 'G3DSA:2.60.120.10:FF:000570', NULL, NULL, 'Protein kinase, cAMP-dependent, regulatory, type I, beta', NULL, NULL, NULL, NULL, NULL, 4),
(224482, NULL, 'G3DSA:2.10.25.10:FF:001361', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(224483, NULL, 'G3DSA:2.70.130.10:FF:000085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224484, NULL, 'G3DSA:2.170.150.20:FF:000025', NULL, NULL, 'Peptide-methionine (R)-S-oxide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(224485, NULL, 'G3DSA:3.40.50.1440:FF:000127', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224486, NULL, 'G3DSA:3.90.1150.10:FF:000262', NULL, NULL, 'Kynurenine aminotransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(224487, NULL, 'G3DSA:1.20.1070.10:FF:001740', NULL, NULL, 'Zg11', NULL, NULL, NULL, NULL, NULL, 4),
(224488, NULL, 'G3DSA:3.40.190.10:FF:000237', NULL, NULL, 'Molybdate ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(224489, NULL, 'G3DSA:3.80.10.10:FF:000888', NULL, NULL, 'UBA/TS-N domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(224490, NULL, 'G3DSA:3.40.1280.10:FF:000030', NULL, NULL, 'RNA methyltransferase, TrmH family family', NULL, NULL, NULL, NULL, NULL, 4),
(224491, NULL, 'G3DSA:3.30.70.980:FF:000019', NULL, NULL, 'Probable transcriptional regulatory protein LIC_12886', NULL, NULL, NULL, NULL, NULL, 4),
(224492, NULL, 'G3DSA:2.130.10.10:FF:000663', NULL, NULL, 'Vacuolar import/degradation Vid27-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(224493, NULL, 'G3DSA:2.60.40.10:FF:004721', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224494, NULL, 'G3DSA:3.30.1360.10:FF:000011', NULL, NULL, 'Related to DNA-directed RNA polymerase 13.3K chain', NULL, NULL, NULL, NULL, NULL, 4),
(224495, NULL, 'G3DSA:1.10.510.10:FF:002418', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224496, NULL, 'G3DSA:3.90.70.10:FF:000189', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(224497, NULL, 'G3DSA:1.10.357.70:FF:000028', NULL, NULL, 'TNF alpha induced protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(224498, NULL, 'G3DSA:1.25.40.10:FF:003478', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(224499, NULL, 'G3DSA:3.40.1110.10:FF:000417', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224500, NULL, 'G3DSA:2.60.120.650:FF:000100', NULL, NULL, 'JuMonJi (Transcription factor) Domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(224501, NULL, 'G3DSA:3.30.160.60:FF:004496', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224502, NULL, 'G3DSA:4.10.60.10:FF:000072', NULL, NULL, 'Putative universal minicircle sequence binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(224503, NULL, 'G3DSA:3.10.120.10:FF:000032', NULL, NULL, 'Acyl-lipid (7-3)-desaturase', NULL, NULL, NULL, NULL, NULL, 4),
(224504, NULL, 'G3DSA:3.80.10.10:FF:000793', NULL, NULL, 'Leucine rich melanocyte differentiation associated', NULL, NULL, NULL, NULL, NULL, 4),
(224505, NULL, 'G3DSA:2.60.40.1670:FF:000018', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(224506, NULL, 'G3DSA:2.30.29.30:FF:000014', NULL, NULL, 'Homer homolog 1 (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(224507, NULL, 'G3DSA:1.25.40.10:FF:004372', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224508, NULL, 'G3DSA:1.25.40.150:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224509, NULL, 'G3DSA:2.30.130.40:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224510, NULL, 'G3DSA:1.20.1280.50:FF:000155', NULL, NULL, 'FBD-associated F-box protein At3g49020', NULL, NULL, NULL, NULL, NULL, 4),
(224511, NULL, 'G3DSA:2.60.200.10:FF:000020', NULL, NULL, 'Interferon regulatory factor 4b', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(224512, NULL, 'G3DSA:2.10.25.10:FF:001147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224513, NULL, 'G3DSA:1.10.10.10:FF:000356', NULL, NULL, 'Bifunctional ligase/repressor BirA', NULL, NULL, NULL, NULL, NULL, 4),
(224514, NULL, 'G3DSA:1.25.40.450:FF:000008', NULL, NULL, 'Nuclear pore complex protein Nup154', NULL, NULL, NULL, NULL, NULL, 4),
(224515, NULL, 'G3DSA:2.60.40.10:FF:004507', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224516, NULL, 'G3DSA:3.30.505.10:FF:000135', NULL, NULL, 'SHC-transforming protein homolog 1', NULL, NULL, NULL, NULL, NULL, 4),
(224517, NULL, 'G3DSA:2.60.40.1660:FF:000015', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(224518, NULL, 'G3DSA:3.90.1150.170:FF:000005', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(224519, NULL, 'G3DSA:2.120.10.30:FF:000225', NULL, NULL, 'Gluconolaconase', NULL, NULL, NULL, NULL, NULL, 4),
(224520, NULL, 'G3DSA:3.30.300.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224521, NULL, 'G3DSA:2.130.10.10:FF:003794', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224522, NULL, 'G3DSA:1.25.40.10:FF:002281', NULL, NULL, 'SPbeta prophage-derived glycosyltransferase SunS', NULL, NULL, NULL, NULL, NULL, 4),
(224523, NULL, 'G3DSA:3.40.50.300:FF:000197', NULL, NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 9', NULL, NULL, NULL, NULL, NULL, 4),
(224524, NULL, 'G3DSA:2.10.70.10:FF:000094', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(224525, NULL, 'G3DSA:3.40.20.10:FF:000059', NULL, NULL, 'Villin-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(224526, NULL, 'G3DSA:1.10.357.50:FF:000022', NULL, NULL, 'Exocyst complex component 3 like 4', NULL, NULL, NULL, NULL, NULL, 4),
(224527, NULL, 'G3DSA:1.20.1250.20:FF:001162', NULL, NULL, 'Protein NRT1/ PTR FAMILY 3.1', NULL, NULL, NULL, NULL, NULL, 4),
(224528, NULL, 'G3DSA:3.90.226.10:FF:000315', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224529, NULL, 'G3DSA:3.40.50.720:FF:001508', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224530, NULL, 'G3DSA:1.10.510.10:FF:002632', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224531, NULL, 'G3DSA:1.20.1080.10:FF:000010', NULL, NULL, 'Inner membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(224532, NULL, 'G3DSA:3.40.50.2000:FF:000043', NULL, NULL, 'UDP-N-acetylglucosamine 2-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(224533, NULL, 'G3DSA:3.90.70.10:FF:000464', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224534, NULL, 'G3DSA:3.30.2160.10:FF:000063', NULL, NULL, 'Protein CBR-HECD-1', NULL, NULL, NULL, NULL, NULL, 4),
(224535, NULL, 'G3DSA:1.25.10.10:FF:002341', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224536, NULL, 'G3DSA:2.40.100.10:FF:000112', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(224537, NULL, 'G3DSA:3.30.750.24:FF:000021', NULL, NULL, 'Sulfate Permease (SulP) Family', NULL, NULL, NULL, NULL, NULL, 4),
(224538, NULL, 'G3DSA:3.40.30.10:FF:000745', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224539, NULL, 'G3DSA:1.25.40.10:FF:002129', NULL, NULL, 'Putative pentatricopeptide repeat-containing protein At3g15130', NULL, NULL, NULL, NULL, NULL, 4),
(224540, NULL, 'G3DSA:3.40.50.880:FF:000168', NULL, NULL, 'Putative amidotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(224541, NULL, 'G3DSA:3.30.497.10:FF:000070', NULL, NULL, 'Serpin peptidase inhibitor, clade A (alpha-1 antiproteinase, antitrypsin), member 10a', NULL, NULL, NULL, NULL, NULL, 4),
(224542, NULL, 'G3DSA:3.20.110.10:FF:000001', NULL, NULL, 'Alpha-mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(224543, NULL, 'G3DSA:1.10.260.50:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224544, NULL, 'G3DSA:1.10.540.10:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(224545, NULL, 'G3DSA:1.10.510.10:FF:000912', NULL, NULL, 'obscurin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(224546, NULL, 'G3DSA:3.30.1490.100:FF:000011', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(224547, NULL, 'G3DSA:1.20.1640.10:FF:000093', NULL, NULL, 'Protein-export membrane protein SecF', NULL, NULL, NULL, NULL, NULL, 4),
(224548, NULL, 'G3DSA:1.20.272.10:FF:000075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224549, NULL, 'G3DSA:1.20.58.60:FF:000340', NULL, NULL, 'Spectrin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(224550, NULL, 'G3DSA:1.10.10.10:FF:001958', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224551, NULL, 'G3DSA:3.30.559.30:FF:000029', NULL, NULL, 'Nonribosomal peptide synthetase DhbF', NULL, NULL, NULL, NULL, NULL, 4),
(224552, NULL, 'G3DSA:3.30.70.380:FF:000002', NULL, NULL, 'phenylalanine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(224553, NULL, 'G3DSA:1.10.510.10:FF:000620', NULL, NULL, 'Putative serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(224554, NULL, 'G3DSA:2.40.50.690:FF:000036', NULL, NULL, 'DIS3 like exosome 3''-5'' exoribonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(224555, NULL, 'G3DSA:3.30.2410.10:FF:000061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224556, NULL, 'G3DSA:3.40.140.10:FF:000077', NULL, NULL, 'Proteasome regulatory non-ATPase subunit 8', NULL, NULL, NULL, NULL, NULL, 4),
(224557, NULL, 'G3DSA:1.10.1410.10:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224558, NULL, 'G3DSA:2.130.10.10:FF:000921', NULL, NULL, 'Protein HIR', NULL, NULL, NULL, NULL, NULL, 4),
(224559, NULL, 'G3DSA:3.30.210.10:FF:000012', NULL, NULL, 'DNA-directed DNA/RNA polymerase mu', NULL, NULL, NULL, NULL, NULL, 4),
(224560, NULL, 'G3DSA:3.30.810.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224561, NULL, 'G3DSA:3.30.2350.20:FF:000007', NULL, NULL, 'PUS7p Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(224562, NULL, 'G3DSA:2.10.90.10:FF:000089', NULL, NULL, 'PDGF/VEGF growth factor related', NULL, NULL, NULL, NULL, NULL, 4),
(224563, NULL, 'G3DSA:3.30.160.60:FF:002630', NULL, NULL, 'Zinc finger protein 1078', NULL, NULL, NULL, NULL, NULL, 4),
(224564, NULL, 'G3DSA:1.25.40.10:FF:004613', NULL, NULL, 'Intraflagellar transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(224565, NULL, 'G3DSA:3.80.10.10:FF:003934', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224566, NULL, 'G3DSA:1.20.1070.10:FF:001414', NULL, NULL, 'Adrenoceptor alpha 2A', NULL, NULL, NULL, NULL, NULL, 4),
(224567, NULL, 'G3DSA:3.90.226.10:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224568, NULL, 'G3DSA:3.10.20.90:FF:000174', NULL, NULL, 'Small ubiquitin-related modifier', NULL, NULL, NULL, NULL, NULL, 4),
(224569, NULL, 'G3DSA:3.40.50.10810:FF:000088', NULL, NULL, 'Irc20p', NULL, NULL, NULL, NULL, NULL, 4),
(224570, NULL, 'G3DSA:3.30.450.350:FF:000006', NULL, NULL, 'Sensory box sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(224571, NULL, 'G3DSA:2.30.30.1150:FF:000015', NULL, NULL, 'PHD and RING finger domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(224572, NULL, 'G3DSA:2.60.40.10:FF:005968', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224573, NULL, 'G3DSA:3.40.1280.30:FF:000036', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224574, NULL, 'G3DSA:1.25.10.10:FF:002627', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224575, NULL, 'G3DSA:1.20.1080.10:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224576, NULL, 'G3DSA:3.40.50.1000:FF:000018', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(224577, NULL, 'G3DSA:2.60.40.10:FF:003939', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224578, NULL, 'G3DSA:2.40.30.10:FF:000455', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(224579, NULL, 'G3DSA:3.40.50.300:FF:001214', NULL, NULL, 'DExH-box ATP-dependent RNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(224580, NULL, 'G3DSA:3.30.30.30:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224581, NULL, 'G3DSA:1.10.3380.10:FF:000069', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224582, NULL, 'G3DSA:1.20.1250.20:FF:001892', NULL, NULL, 'Solute carrier family 2, facilitated glucose transporter member 2', NULL, NULL, NULL, NULL, NULL, 4),
(224583, NULL, 'G3DSA:1.20.120.350:FF:000189', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224584, NULL, 'G3DSA:2.60.15.10:FF:000020', NULL, NULL, 'F-type H-ATPase delta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(224585, NULL, 'G3DSA:3.40.50.1970:FF:000016', NULL, NULL, 'Putative oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(224586, NULL, 'G3DSA:2.40.10.170:FF:000007', NULL, NULL, 'Transcription-repair-coupling factor', NULL, NULL, NULL, NULL, NULL, 4),
(224587, NULL, 'G3DSA:3.30.200.20:FF:001178', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(224588, NULL, 'G3DSA:2.60.220.50:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224589, NULL, 'G3DSA:2.60.40.150:FF:000475', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(224590, NULL, 'G3DSA:3.90.550.10:FF:000760', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224591, NULL, 'G3DSA:3.90.70.10:FF:000077', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(224592, NULL, 'G3DSA:3.30.40.10:FF:001870', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224593, NULL, 'G3DSA:3.30.420.80:FF:000026', NULL, NULL, '30S ribosomal protein S11', NULL, NULL, NULL, NULL, NULL, 4),
(224594, NULL, 'G3DSA:1.10.150.240:FF:000041', NULL, NULL, 'Haloacid dehalogenase-like hydrolase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(224595, NULL, 'G3DSA:1.10.510.10:FF:004223', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224596, NULL, 'G3DSA:2.60.40.10:FF:004833', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224597, NULL, 'G3DSA:3.90.1180.10:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224598, NULL, 'G3DSA:1.10.1670.10:FF:000080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224599, NULL, 'G3DSA:3.40.50.720:FF:001834', NULL, NULL, 'CD38 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(224600, NULL, 'G3DSA:1.25.40.10:FF:004321', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224601, NULL, 'G3DSA:6.10.140.2220:FF:000078', NULL, NULL, 'Hypoxia-inducible factor prolyl hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(224602, NULL, 'G3DSA:2.10.220.10:FF:000195', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5a', NULL, NULL, NULL, NULL, NULL, 4),
(224603, NULL, 'G3DSA:3.30.40.10:FF:001718', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(224604, NULL, 'G3DSA:4.10.640.10:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224605, NULL, 'G3DSA:3.20.20.220:FF:000059', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(224606, NULL, 'G3DSA:3.20.20.100:FF:000141', NULL, NULL, 'Uncharacterized oxidoreductase C215.11c', NULL, NULL, NULL, NULL, NULL, 4),
(224607, NULL, 'G3DSA:1.10.3210.10:FF:000057', NULL, NULL, 'Exopolyphosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(224608, NULL, 'G3DSA:2.40.30.10:FF:000404', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224609, NULL, 'G3DSA:1.20.1250.20:FF:001274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224610, NULL, 'G3DSA:1.10.472.130:FF:000070', NULL, NULL, 'Dynein-1-beta heavy chain, flagellar inner arm I1 complex', NULL, NULL, NULL, NULL, NULL, 4),
(224611, NULL, 'G3DSA:2.30.30.140:FF:000297', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(224612, NULL, 'G3DSA:2.30.30.30:FF:000017', NULL, NULL, 'Transcription elongation factor SPT5', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(224613, NULL, 'G3DSA:3.30.420.60:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224614, NULL, 'G3DSA:3.40.190.10:FF:000563', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(224615, NULL, 'G3DSA:1.10.287.70:FF:000764', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(224616, NULL, 'G3DSA:1.10.10.10:FF:001907', NULL, NULL, 'Phenazine-specific methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(224617, NULL, 'G3DSA:1.25.10.10:FF:000828', NULL, NULL, 'Importin subunit alpha-2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(224618, NULL, 'G3DSA:3.40.50.300:FF:002642', NULL, NULL, 'YDR061W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(224619, NULL, 'G3DSA:3.90.940.10:FF:000003', NULL, NULL, 'DNA-directed RNA polymerases I, II, and III subunit RPABC2', NULL, NULL, NULL, NULL, NULL, 4),
(224620, NULL, 'G3DSA:3.30.200.20:FF:002521', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224621, NULL, 'G3DSA:3.30.1380.20:FF:000009', NULL, NULL, 'Trafficking protein particle complex subunit 6A', NULL, NULL, NULL, NULL, NULL, 4),
(224622, NULL, 'G3DSA:1.20.1250.20:FF:000998', NULL, NULL, 'AGAP010043-PA', NULL, NULL, NULL, NULL, NULL, 4),
(224623, NULL, 'G3DSA:2.30.29.80:FF:000001', NULL, NULL, 'DUF1508 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(224624, NULL, 'G3DSA:3.90.1420.10:FF:000058', NULL, NULL, 'N-lysine methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(224625, NULL, 'G3DSA:3.30.160.60:FF:000781', NULL, NULL, 'zinc finger protein 205 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(224626, NULL, 'G3DSA:2.60.40.10:FF:000910', NULL, NULL, 'T-lymphocyte activation antigen CD80', NULL, NULL, NULL, NULL, NULL, 4),
(224627, NULL, 'G3DSA:3.30.70.580:FF:000062', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(224628, NULL, 'G3DSA:2.60.120.260:FF:000320', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224629, NULL, 'G3DSA:3.80.10.10:FF:001810', NULL, NULL, 'YALI0D21208p', NULL, NULL, NULL, NULL, NULL, 4),
(224630, NULL, 'G3DSA:1.25.40.390:FF:000001', NULL, NULL, 'Starch-binding outer membrane lipoprotein SusD', NULL, NULL, NULL, NULL, NULL, 4),
(224631, NULL, 'G3DSA:1.20.1050.10:FF:000154', NULL, NULL, 'Glutathione S-transferase U10', NULL, NULL, NULL, NULL, NULL, 4),
(224632, NULL, 'G3DSA:3.50.50.60:FF:000507', NULL, NULL, 'Lysine-specific histone demethylase 1 homolog 3', NULL, NULL, NULL, NULL, NULL, 4),
(224633, NULL, 'G3DSA:1.10.150.130:FF:000007', NULL, NULL, 'Tyrosine recombinase XerC', NULL, NULL, NULL, NULL, NULL, 4),
(224634, NULL, 'G3DSA:2.120.10.30:FF:000490', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224635, NULL, 'G3DSA:3.30.870.10:FF:000027', NULL, NULL, 'Phospholipase D', NULL, NULL, NULL, NULL, NULL, 4),
(224636, NULL, 'G3DSA:2.130.10.10:FF:002720', NULL, NULL, 'Target of rapamycin complex subunit lst8', NULL, NULL, NULL, NULL, NULL, 4),
(224637, NULL, 'G3DSA:1.10.510.10:FF:001789', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224638, NULL, 'G3DSA:2.30.29.90:FF:000004', NULL, NULL, 'Exocyst complex component 1 like', NULL, NULL, NULL, NULL, NULL, 4),
(224639, NULL, 'G3DSA:3.90.79.10:FF:000158', NULL, NULL, 'ADP-ribose pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(224640, NULL, 'G3DSA:3.30.1380.10:FF:000006', NULL, NULL, 'D-alanyl-D-alanine dipeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(224641, NULL, 'G3DSA:3.30.559.10:FF:000023', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(224642, NULL, 'G3DSA:2.60.40.10:FF:004221', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224643, NULL, 'G3DSA:3.40.50.1980:FF:000019', NULL, NULL, 'Histidinol dehydrogenase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(224644, NULL, 'G3DSA:3.30.70.920:FF:000029', NULL, NULL, 'ArsR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(224645, NULL, 'G3DSA:3.30.70.240:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(224646, NULL, 'G3DSA:2.70.170.10:FF:000082', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224647, NULL, 'G3DSA:3.40.1080.10:FF:000009', NULL, NULL, 'Succinate CoA transferase', NULL, NULL, NULL, NULL, NULL, 4),
(224648, NULL, 'G3DSA:3.40.50.150:FF:001034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224649, NULL, 'G3DSA:1.10.230.10:FF:000019', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(224650, NULL, 'G3DSA:2.30.42.10:FF:000207', NULL, NULL, 'Serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(224651, NULL, 'G3DSA:1.10.630.10:FF:000567', NULL, NULL, 'Cytochrome P450 2B4-like', NULL, NULL, NULL, NULL, NULL, 4),
(224652, NULL, 'G3DSA:3.40.50.300:FF:008414', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224653, NULL, 'G3DSA:3.40.50.10330:FF:000118', NULL, NULL, 'Putative diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(224654, NULL, 'G3DSA:1.10.246.20:FF:000014', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 15', NULL, NULL, NULL, NULL, NULL, 4),
(224655, NULL, 'G3DSA:2.60.40.10:FF:006019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224656, NULL, 'G3DSA:3.80.10.10:FF:001405', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224657, NULL, 'G3DSA:2.180.10.10:FF:000009', NULL, NULL, 'RHS element protein', NULL, NULL, NULL, NULL, NULL, 4),
(224658, NULL, 'G3DSA:1.25.40.990:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224659, NULL, 'G3DSA:2.40.30.10:FF:000129', NULL, NULL, 'U5 small nuclear ribonuclear protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(224660, NULL, 'G3DSA:3.10.20.70:FF:000016', NULL, NULL, 'Glutamine synthetase, type I', NULL, NULL, NULL, NULL, NULL, 4),
(224661, NULL, 'G3DSA:1.10.510.10:FF:002065', NULL, NULL, 'Protein_kinase_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(224662, NULL, 'G3DSA:3.30.830.10:FF:000132', NULL, NULL, 'Protease of the insulinase family', NULL, NULL, NULL, NULL, NULL, 4),
(224663, NULL, 'G3DSA:1.10.510.10:FF:004274', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224664, NULL, 'G3DSA:3.30.160.60:FF:003939', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224665, NULL, 'G3DSA:3.40.50.150:FF:000242', NULL, NULL, 'Protein-lysine N-methyltransferase EEF2KMT', NULL, NULL, NULL, NULL, NULL, 4),
(224666, NULL, 'G3DSA:3.30.950.30:FF:000006', NULL, NULL, 'PHP domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(224667, NULL, 'G3DSA:3.40.50.10990:FF:000001', NULL, NULL, 'Riboflavin biosynthesis protein RibBA', NULL, NULL, NULL, NULL, NULL, 4),
(224668, NULL, 'G3DSA:3.90.180.10:FF:000040', NULL, NULL, 'Nuclear receptor binding factor-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(224669, NULL, 'G3DSA:3.30.230.70:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224670, NULL, 'G3DSA:2.60.120.260:FF:000141', NULL, NULL, 'Beta-galactosidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(224671, NULL, 'G3DSA:1.10.246.10:FF:000011', NULL, NULL, 'Vitamin D-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(224672, NULL, 'G3DSA:3.30.160.60:FF:004428', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224673, NULL, 'G3DSA:3.40.50.10420:FF:000027', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase', NULL, NULL, NULL, NULL, NULL, 4),
(224674, NULL, 'G3DSA:3.30.540.10:FF:000031', NULL, NULL, 'Inositol-1-monophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(224675, NULL, 'G3DSA:3.40.50.12780:FF:000100', NULL, NULL, 'Nonribosomal peptide synthase Pes1', NULL, NULL, NULL, NULL, NULL, 4),
(224676, NULL, 'G3DSA:3.80.10.10:FF:002687', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase RCH1', NULL, NULL, NULL, NULL, NULL, 4),
(224677, NULL, 'G3DSA:2.60.40.10:FF:004272', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224678, NULL, 'G3DSA:2.130.10.10:FF:003468', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224679, NULL, 'G3DSA:1.20.58.480:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(224680, NULL, 'G3DSA:2.60.40.4310:FF:000001', NULL, NULL, 'Structural polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(224681, NULL, 'G3DSA:3.30.200.20:FF:001919', NULL, NULL, 'Os10g0112700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(224682, NULL, 'G3DSA:3.30.40.10:FF:001544', NULL, NULL, 'Putative BOI-related E3 ubiquitin-protein ligase 3 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(224683, NULL, 'G3DSA:3.30.870.10:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224684, NULL, 'G3DSA:2.60.40.10:FF:000393', NULL, NULL, 'Putative obscurin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(224685, NULL, 'G3DSA:3.30.160.60:FF:006115', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224686, NULL, 'G3DSA:3.30.160.60:FF:006295', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224687, NULL, 'G3DSA:3.90.550.50:FF:000125', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224688, NULL, 'G3DSA:3.20.20.370:FF:000025', NULL, NULL, 'ChbG/HpnK family deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(224689, NULL, 'G3DSA:3.40.50.300:FF:004087', NULL, NULL, 'GM12046', NULL, NULL, NULL, NULL, NULL, 4),
(224690, NULL, 'G3DSA:2.60.40.150:FF:000149', NULL, NULL, 'Piccolo presynaptic cytomatrix protein', NULL, NULL, NULL, NULL, NULL, 4),
(224691, NULL, 'G3DSA:3.10.105.10:FF:000019', NULL, NULL, 'Nickel ABC transporter, periplasmic nickel-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(224692, NULL, 'G3DSA:1.20.140.40:FF:000070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224693, NULL, 'G3DSA:2.60.40.10:FF:004428', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224694, NULL, 'G3DSA:3.30.519.10:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224695, NULL, 'G3DSA:1.10.20.10:FF:000149', NULL, NULL, 'CBF/NF-Y transcription factor domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(224696, NULL, 'G3DSA:1.20.58.60:FF:000857', NULL, NULL, 'Si:ch211-207i1.2', NULL, NULL, NULL, NULL, NULL, 4),
(224697, NULL, 'G3DSA:1.20.1440.90:FF:000011', NULL, NULL, 'Phosphoenolpyruvate carboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(224698, NULL, 'G3DSA:1.20.1600.10:FF:000028', NULL, NULL, 'Outer membrane efflux protein', NULL, NULL, NULL, NULL, NULL, 4),
(224699, NULL, 'G3DSA:1.20.140.80:FF:000003', NULL, NULL, 'Transcription factor dp-1', NULL, NULL, NULL, NULL, NULL, 4),
(224700, NULL, 'G3DSA:3.10.20.90:FF:000786', NULL, NULL, 'Polycomb group RING finger protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(224701, NULL, 'G3DSA:2.70.50.80:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224702, NULL, 'G3DSA:1.20.5.190:FF:000035', NULL, NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(224703, NULL, 'G3DSA:3.40.50.720:FF:001576', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224704, NULL, 'G3DSA:3.40.50.261:FF:000028', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit alpha, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(224705, NULL, 'G3DSA:1.20.140.150:FF:000054', NULL, NULL, 'Protein CBG14510', NULL, NULL, NULL, NULL, NULL, 4),
(224706, NULL, 'G3DSA:2.40.160.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224707, NULL, 'G3DSA:1.20.120.1080:FF:000128', NULL, NULL, 'Helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(224708, NULL, 'G3DSA:3.40.50.300:FF:001540', NULL, NULL, 'Dynein heavy chain domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(224709, NULL, 'G3DSA:3.90.1490.10:FF:000006', NULL, NULL, 'ATP binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(224710, NULL, 'G3DSA:3.10.50.40:FF:000026', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(224711, NULL, 'G3DSA:1.20.140.90:FF:000006', NULL, NULL, 'malonyl-CoA decarboxylase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(224712, NULL, 'G3DSA:1.20.58.390:FF:000252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224713, NULL, 'G3DSA:3.90.640.80:FF:000001', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(224714, NULL, 'G3DSA:3.90.260.10:FF:000041', NULL, NULL, 'YALI0D08756p', NULL, NULL, NULL, NULL, NULL, 4),
(224715, NULL, 'G3DSA:1.10.533.10:FF:000190', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224716, NULL, 'G3DSA:3.40.50.2300:FF:001375', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224717, NULL, 'G3DSA:1.50.40.10:FF:000385', NULL, NULL, 'Solute carrier family 25 member 24,-like', NULL, NULL, NULL, NULL, NULL, 4),
(224718, NULL, 'G3DSA:2.60.40.10:FF:002708', NULL, NULL, 'Hepatocyte growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(224719, NULL, 'G3DSA:2.130.10.10:FF:002900', NULL, NULL, 'Protein CBR-RBC-1', NULL, NULL, NULL, NULL, NULL, 4),
(224720, NULL, 'G3DSA:2.40.37.10:FF:000021', NULL, NULL, 'Ornithine decarboxylase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(224721, NULL, 'G3DSA:1.20.1070.10:FF:001139', NULL, NULL, 'Chemokine (C-C motif) receptor 1-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(224722, NULL, 'G3DSA:3.80.10.10:FF:003608', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224723, NULL, 'G3DSA:2.130.10.10:FF:002462', NULL, NULL, 'U3 small nucleolar RNA-associated protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(224724, NULL, 'G3DSA:1.10.1900.10:FF:000025', NULL, NULL, 'Chromosome 8, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(224725, NULL, 'G3DSA:2.40.290.10:FF:000007', NULL, NULL, 'RNA-binding protein 15B', NULL, NULL, NULL, NULL, NULL, 4),
(224726, NULL, 'G3DSA:2.120.10.30:FF:000517', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224727, NULL, 'G3DSA:3.40.630.10:FF:000047', NULL, NULL, 'Glycosylphosphatidylinositol anchor attachment 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(224728, NULL, 'G3DSA:1.10.472.10:FF:000340', NULL, NULL, 'RNA polymerase II holoenzyme cyclin-like subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(224729, NULL, 'G3DSA:3.40.30.10:FF:001234', NULL, NULL, 'Protein disulfide-isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(224730, NULL, 'G3DSA:3.40.50.1820:FF:001124', NULL, NULL, 'Acetylcholinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(224731, NULL, 'G3DSA:2.80.10.50:FF:000273', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224732, NULL, 'G3DSA:1.10.10.10:FF:001784', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224733, NULL, 'G3DSA:2.40.160.210:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224734, NULL, 'G3DSA:1.10.510.10:FF:002806', NULL, NULL, 'Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(224735, NULL, 'G3DSA:1.10.150.80:FF:000051', NULL, NULL, 'Ribonuclease D, putative', NULL, NULL, NULL, NULL, NULL, 4),
(224736, NULL, 'G3DSA:2.70.130.10:FF:000017', NULL, NULL, 'Insulin-like growth factor 2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(224737, NULL, 'G3DSA:3.80.10.10:FF:001456', NULL, NULL, 'Leucine-rich repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(224738, NULL, 'G3DSA:1.25.40.10:FF:002455', NULL, NULL, 'Intraflagellar transport protein 139', NULL, NULL, NULL, NULL, NULL, 4),
(224739, NULL, 'G3DSA:3.40.50.300:FF:002900', NULL, NULL, 'Capsular polysaccharide synthesis enzyme CpsD exopolysaccharide synthesis', NULL, NULL, NULL, NULL, NULL, 4),
(224740, NULL, 'G3DSA:3.40.525.10:FF:000027', NULL, NULL, 'Phosphatidylinositol transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(224741, NULL, 'G3DSA:3.10.310.10:FF:000041', NULL, NULL, 'Diaminopimelate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(224742, NULL, 'G3DSA:1.20.120.350:FF:000138', NULL, NULL, 'Putative calcium channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(224743, NULL, 'G3DSA:3.40.640.10:FF:000250', NULL, NULL, 'Aminotransferase, class V', NULL, NULL, NULL, NULL, NULL, 4),
(224744, NULL, 'G3DSA:1.25.40.790:FF:000008', NULL, NULL, 'CCR4-NOT transcription complex subunit 1,putative', NULL, NULL, NULL, NULL, NULL, 4),
(224745, NULL, 'G3DSA:3.30.160.60:FF:002579', NULL, NULL, 'Datilografo, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(224746, NULL, 'G3DSA:1.10.1410.10:FF:000038', NULL, NULL, 'PAP-associated domain containing protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(224747, NULL, 'G3DSA:3.30.43.10:FF:000005', NULL, NULL, 'Quinone-dependent D-lactate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(224748, NULL, 'G3DSA:3.40.50.620:FF:000118', NULL, NULL, 'Tryptophan--tRNA ligase, chloroplastic/mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(224749, NULL, 'G3DSA:1.10.238.10:FF:000812', NULL, NULL, 'EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(224750, NULL, 'G3DSA:3.90.1480.20:FF:000071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224751, NULL, 'G3DSA:3.40.50.1100:FF:000048', NULL, NULL, '1-aminocyclopropane-1-carboxylate deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(224752, NULL, 'G3DSA:1.10.150.240:FF:000102', NULL, NULL, 'HAD superfamily hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(224753, NULL, 'G3DSA:1.10.390.10:FF:000059', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(224754, NULL, 'G3DSA:1.10.10.60:FF:000360', NULL, NULL, 'Gastrulation brain homeobox', NULL, NULL, NULL, NULL, NULL, 4),
(224755, NULL, 'G3DSA:3.80.10.10:FF:002479', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224756, NULL, 'G3DSA:1.25.40.20:FF:001210', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224757, NULL, 'G3DSA:3.80.10.10:FF:003530', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224758, NULL, 'G3DSA:3.30.60.20:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224759, NULL, 'G3DSA:2.60.40.10:FF:000831', NULL, NULL, 'Uncharacterized protein, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(224760, NULL, 'G3DSA:4.10.410.10:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224761, NULL, 'G3DSA:3.30.40.10:FF:000066', NULL, NULL, 'E3 ubiquitin-protein ligase UHRF2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(224762, NULL, 'G3DSA:3.30.720.10:FF:000011', NULL, NULL, 'Signal recognition particle 14 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(224763, NULL, 'G3DSA:3.90.245.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224764, NULL, 'G3DSA:1.25.40.10:FF:002730', NULL, NULL, 'MAU2 sister chromatid cohesion factor', NULL, NULL, NULL, NULL, NULL, 4),
(224765, NULL, 'G3DSA:2.60.40.10:FF:002922', NULL, NULL, 'Protein sidekick homolog', NULL, NULL, NULL, NULL, NULL, 4),
(224766, NULL, 'G3DSA:3.40.50.150:FF:000803', NULL, NULL, 'RNA methylase, NOL1/NOP2/sun family', NULL, NULL, NULL, NULL, NULL, 4),
(224767, NULL, 'G3DSA:4.10.60.10:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224768, NULL, 'G3DSA:3.40.50.150:FF:000860', NULL, NULL, 'Multisite-specific tRNA m(5)C methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(224769, NULL, 'G3DSA:1.25.70.10:FF:000046', NULL, NULL, 'Mitochondrial transcription termination factor family protein', NULL, NULL, NULL, NULL, NULL, 4),
(224770, NULL, 'G3DSA:1.20.58.390:FF:000134', NULL, NULL, 'Ligand-Gated ion Channel', NULL, NULL, NULL, NULL, NULL, 4),
(224771, NULL, 'G3DSA:1.20.120.1750:FF:000065', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(224772, NULL, 'G3DSA:1.20.5.4770:FF:000002', NULL, NULL, 'rab5 GDP/GTP exchange factor isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(224773, NULL, 'G3DSA:2.40.30.10:FF:000281', NULL, NULL, 'NADPH-dependent diflavin oxidoreductase 1', NULL, NULL, NULL, NULL, NULL, 4),
(224774, NULL, 'G3DSA:3.30.70.330:FF:002191', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224775, NULL, 'G3DSA:1.20.1250.20:FF:001392', NULL, NULL, 'Monocarboxylate transporter 5 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(224776, NULL, 'G3DSA:3.30.160.60:FF:005210', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224777, NULL, 'G3DSA:1.20.1110.10:FF:000238', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224778, NULL, 'G3DSA:4.10.60.10:FF:000133', NULL, NULL, 'AFR646Wp', NULL, NULL, NULL, NULL, NULL, 4),
(224779, NULL, 'G3DSA:2.70.170.10:FF:000290', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(224780, NULL, 'G3DSA:2.60.40.1180:FF:000231', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(224781, NULL, 'G3DSA:2.40.10.10:FF:000167', NULL, NULL, 'Coagulation factor II (thrombin)', NULL, NULL, NULL, NULL, NULL, 4),
(224782, NULL, 'G3DSA:1.25.10.10:FF:000621', NULL, NULL, 'Exportin-T', NULL, NULL, NULL, NULL, NULL, 4),
(224783, NULL, 'G3DSA:3.40.1110.10:FF:000389', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224784, NULL, 'G3DSA:3.40.50.2000:FF:000155', NULL, NULL, 'UDP-glucuronosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(224785, NULL, 'G3DSA:1.10.1450.10:FF:000035', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(224786, NULL, 'G3DSA:2.60.40.150:FF:000357', NULL, NULL, 'Protein kinase C theta', NULL, NULL, NULL, NULL, NULL, 4),
(224787, NULL, 'G3DSA:3.40.50.300:FF:001332', NULL, NULL, 'Similar to ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(224788, NULL, 'G3DSA:3.20.20.120:FF:000029', NULL, NULL, 'Hydrophobic dipeptide epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(224789, NULL, 'G3DSA:2.130.10.10:FF:000219', NULL, NULL, 'Periodic tryptophan protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(224790, NULL, 'G3DSA:2.20.70.10:FF:000161', NULL, NULL, 'E3 ubiquitin-protein ligase hecw-1', NULL, NULL, NULL, NULL, NULL, 4),
(224791, NULL, 'G3DSA:3.40.50.10260:FF:000018', NULL, NULL, 'Multifunctional fusion protein', NULL, NULL, NULL, NULL, NULL, 4),
(224792, NULL, 'G3DSA:3.40.630.30:FF:000087', NULL, NULL, 'GNAT family N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(224793, NULL, 'G3DSA:3.40.50.620:FF:000023', NULL, NULL, 'Isoleucyl-tRNA synthetase,cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(224794, NULL, 'G3DSA:3.40.50.12100:FF:000003', NULL, NULL, 'Stimulator of interferon genes protein', NULL, NULL, NULL, NULL, NULL, 4),
(224795, NULL, 'G3DSA:2.60.40.60:FF:000149', NULL, NULL, 'cadherin-16 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(224796, NULL, 'G3DSA:3.30.70.270:FF:000020', NULL, NULL, 'Transposon Tf2-6 polyprotein-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(224797, NULL, 'G3DSA:3.30.40.10:FF:002207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224798, NULL, 'G3DSA:1.20.140.100:FF:000034', NULL, NULL, 'Dynein heavy chain, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(224799, NULL, 'G3DSA:1.10.287.1130:FF:000004', NULL, NULL, 'Cytochrome c oxidase copper chaperone', NULL, NULL, NULL, NULL, NULL, 4),
(224800, NULL, 'G3DSA:2.40.70.10:FF:000401', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224801, NULL, 'G3DSA:3.40.525.10:FF:000033', NULL, NULL, 'Retinol-binding protein pinta', NULL, NULL, NULL, NULL, NULL, 4),
(224802, NULL, 'G3DSA:1.20.120.1760:FF:000068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224803, NULL, 'G3DSA:1.20.120.1750:FF:000115', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(224804, NULL, 'G3DSA:1.25.40.10:FF:002404', NULL, NULL, 'Os01g0197450 protein', NULL, NULL, NULL, NULL, NULL, 4),
(224805, NULL, 'G3DSA:3.10.290.10:FF:000095', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(224806, NULL, 'G3DSA:2.40.10.10:FF:000280', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224807, NULL, 'G3DSA:3.30.930.10:FF:000196', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(224808, NULL, 'G3DSA:2.40.30.10:FF:000337', NULL, NULL, 'elongation factor Tu, mitochondrial isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(224809, NULL, 'G3DSA:3.30.40.10:FF:001494', NULL, NULL, 'Zinc finger family protein', NULL, NULL, NULL, NULL, NULL, 4),
(224810, NULL, 'G3DSA:1.10.510.10:FF:000884', NULL, NULL, 'Protein CBG08984', NULL, NULL, NULL, NULL, NULL, 4),
(224811, NULL, 'G3DSA:3.20.20.140:FF:000187', NULL, NULL, 'Ribonuclease P protein subunit p30-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(224812, NULL, 'G3DSA:3.30.60.30:FF:000135', NULL, NULL, 'flocculation protein FLO11', NULL, NULL, NULL, NULL, NULL, 4),
(224813, NULL, 'G3DSA:1.10.287.1120:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(224814, NULL, 'G3DSA:2.60.40.640:FF:000021', NULL, NULL, 'Vacuolar protein sorting-associated protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(224815, NULL, 'G3DSA:3.40.630.10:FF:000081', NULL, NULL, 'Peptide hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(224816, NULL, 'G3DSA:1.10.150.50:FF:000183', NULL, NULL, 'Epidermal growth factor receptor kinase substrate 8', NULL, NULL, NULL, NULL, NULL, 4),
(224817, NULL, 'G3DSA:1.20.1060.10:FF:000008', NULL, NULL, 'Mitochondrial DNA polymerase I protein A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(224818, NULL, 'G3DSA:1.20.1250.20:FF:001448', NULL, NULL, 'Solute carrier family 2, facilitated glucose transporter member 12', NULL, NULL, NULL, NULL, NULL, 4),
(224819, NULL, 'G3DSA:2.70.230.10:FF:000002', NULL, NULL, 'Envelope glycoprotein D', NULL, NULL, NULL, NULL, NULL, 4),
(224820, NULL, 'G3DSA:1.10.510.10:FF:002918', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224821, NULL, 'G3DSA:3.30.1370.10:FF:000152', NULL, NULL, 'Vigilin 1', NULL, NULL, NULL, NULL, NULL, 4),
(224822, NULL, 'G3DSA:3.20.20.100:FF:000023', NULL, NULL, 'aldose reductase', NULL, NULL, NULL, NULL, NULL, 4),
(224823, NULL, 'G3DSA:1.20.1000.10:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224824, NULL, 'G3DSA:3.30.2340.10:FF:000009', NULL, NULL, 'tRNA pseudouridine synthase D', NULL, NULL, NULL, NULL, NULL, 4),
(224825, NULL, 'G3DSA:3.10.20.90:FF:000056', NULL, NULL, 'growth factor receptor-bound protein 10 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(224826, NULL, 'G3DSA:3.30.60.30:FF:000192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224827, NULL, 'G3DSA:3.30.420.40:FF:000722', NULL, NULL, 'Actin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(224828, NULL, 'G3DSA:1.25.40.10:FF:002247', NULL, NULL, 'Daf-16-Dependent Longevity (WT but not daf-16 lifespan increased)', NULL, NULL, NULL, NULL, NULL, 4),
(224829, NULL, 'G3DSA:3.10.450.10:FF:000079', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224830, NULL, 'G3DSA:3.80.20.20:FF:000004', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(224831, NULL, 'G3DSA:2.60.40.1910:FF:000045', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224832, NULL, 'G3DSA:3.40.50.300:FF:008532', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(224833, NULL, 'G3DSA:3.40.50.1000:FF:000748', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224834, NULL, 'G3DSA:1.10.510.10:FF:004156', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224835, NULL, 'G3DSA:3.40.50.300:FF:006391', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224836, NULL, 'G3DSA:1.10.472.10:FF:000047', NULL, NULL, 'Cyclin J like', NULL, NULL, NULL, NULL, NULL, 4),
(224837, NULL, 'G3DSA:1.20.58.1880:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224838, NULL, 'G3DSA:1.10.150.390:FF:000006', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(224839, NULL, 'G3DSA:3.40.1410.10:FF:000030', NULL, NULL, 'Trehalose operon transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(224840, NULL, 'G3DSA:2.20.28.120:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224841, NULL, 'G3DSA:3.30.160.60:FF:006407', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224842, NULL, 'G3DSA:1.20.1070.10:FF:000897', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224843, NULL, 'G3DSA:2.130.10.10:FF:004811', NULL, NULL, 'WD repeat-containing protein 55 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(224844, NULL, 'G3DSA:2.60.40.10:FF:000567', NULL, NULL, 'Uncharacterized protein, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(224845, NULL, 'G3DSA:2.130.10.10:FF:005385', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224846, NULL, 'G3DSA:2.60.40.1180:FF:000017', NULL, NULL, 'Alpha-galactosidase A', NULL, NULL, NULL, NULL, NULL, 4),
(224847, NULL, 'G3DSA:3.30.160.60:FF:006345', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(224848, NULL, 'G3DSA:3.30.830.10:FF:000306', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224849, NULL, 'G3DSA:2.70.98.60:FF:000006', NULL, NULL, 'Alpha-galactosidase AgaA', NULL, NULL, NULL, NULL, NULL, 4),
(224850, NULL, 'G3DSA:2.170.150.80:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224851, NULL, 'G3DSA:1.10.1170.10:FF:000002', NULL, NULL, 'Baculoviral IAP repeat containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(224852, NULL, 'G3DSA:2.130.10.10:FF:003709', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224853, NULL, 'G3DSA:1.25.40.10:FF:004490', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224854, NULL, 'G3DSA:2.60.120.260:FF:000253', NULL, NULL, 'Beta-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(224855, NULL, 'G3DSA:3.40.395.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224856, NULL, 'G3DSA:1.25.40.20:FF:001002', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224857, NULL, 'G3DSA:3.90.550.50:FF:000131', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(224858, NULL, 'G3DSA:3.40.50.12650:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224859, NULL, 'G3DSA:1.10.3410.10:FF:000005', NULL, NULL, 'dGTP triphosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(224860, NULL, 'G3DSA:3.80.10.10:FF:003255', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224861, NULL, 'G3DSA:3.40.50.1000:FF:000541', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224862, NULL, 'G3DSA:2.40.50.140:FF:000400', NULL, NULL, 'Ribonuclease R', NULL, NULL, NULL, NULL, NULL, 4),
(224863, NULL, 'G3DSA:1.25.10.10:FF:002419', NULL, NULL, 'MO25-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(224864, NULL, 'G3DSA:1.25.10.10:FF:002015', NULL, NULL, 'Splicing factor 3B subunit 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(224865, NULL, 'G3DSA:2.60.40.1120:FF:000027', NULL, NULL, 'CarboxyPeptidase D family', NULL, NULL, NULL, NULL, NULL, 4),
(224866, NULL, 'G3DSA:3.90.1170.10:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224867, NULL, 'G3DSA:2.60.120.260:FF:000371', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224868, NULL, 'G3DSA:3.20.20.80:FF:000024', NULL, NULL, 'Heparanase 2', NULL, NULL, NULL, NULL, NULL, 4),
(224869, NULL, 'G3DSA:3.40.50.300:FF:006228', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224870, NULL, 'G3DSA:3.80.10.10:FF:000500', NULL, NULL, 'Protein TONSOKU', NULL, NULL, NULL, NULL, NULL, 4),
(224871, NULL, 'G3DSA:3.40.50.300:FF:004137', NULL, NULL, 'ATPase family associated with various cellular activities (AAA), putative', NULL, NULL, NULL, NULL, NULL, 4),
(224872, NULL, 'G3DSA:3.10.28.10:FF:000038', NULL, NULL, 'Intron-encoded DNA endonuclease aI5 beta', NULL, NULL, NULL, NULL, NULL, 4),
(224873, NULL, 'G3DSA:3.20.20.70:FF:000544', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224874, NULL, 'G3DSA:1.20.1250.20:FF:001723', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224875, NULL, 'G3DSA:1.10.510.10:FF:002071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224876, NULL, 'G3DSA:3.40.140.10:FF:000285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224877, NULL, 'G3DSA:3.30.200.20:FF:001857', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224878, NULL, 'G3DSA:3.40.140.10:FF:000173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224879, NULL, 'G3DSA:1.10.520.10:FF:000008', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(224880, NULL, 'G3DSA:2.130.10.10:FF:005946', NULL, NULL, 'AGAP006158-PA', NULL, NULL, NULL, NULL, NULL, 4),
(224881, NULL, 'G3DSA:3.40.50.300:FF:006503', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224882, NULL, 'G3DSA:3.30.300.180:FF:000001', NULL, NULL, 'Chromosomal replication initiator protein DnaA', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(224883, NULL, 'G3DSA:3.40.390.10:FF:000005', NULL, NULL, 'Matrix metallopeptidase 16', NULL, NULL, NULL, NULL, NULL, 4),
(224884, NULL, 'G3DSA:1.10.287.110:FF:000304', NULL, NULL, 'J domain-containing protein DDB_G0295729', NULL, NULL, NULL, NULL, NULL, 4),
(224885, NULL, 'G3DSA:1.25.40.10:FF:003883', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224886, NULL, 'G3DSA:1.20.1250.20:FF:001780', NULL, NULL, 'Major facilitator superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(224887, NULL, 'G3DSA:3.80.10.10:FF:001164', NULL, NULL, 'GH01279p', NULL, NULL, NULL, NULL, NULL, 4),
(224888, NULL, 'G3DSA:3.40.50.2300:FF:000043', NULL, NULL, 'Glutamate receptor, ionotropic, kainate 5', NULL, NULL, NULL, NULL, NULL, 4),
(224889, NULL, 'G3DSA:3.40.50.11420:FF:000001', NULL, NULL, 'Hydrogenase maturation GTPase HydF', NULL, NULL, NULL, NULL, NULL, 4),
(224890, NULL, 'G3DSA:3.40.50.720:FF:001626', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase 2, cytosolic', NULL, NULL, NULL, NULL, NULL, 4),
(224891, NULL, 'G3DSA:1.10.240.10:FF:000026', NULL, NULL, 'Tyrosyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(224892, NULL, 'G3DSA:3.30.200.20:FF:000172', NULL, NULL, 'cyclin-dependent kinase G-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(224893, NULL, 'G3DSA:2.60.40.10:FF:002534', NULL, NULL, 'Interleukin 1 receptor-like 1 (ST2L)', NULL, NULL, NULL, NULL, NULL, 4),
(224894, NULL, 'G3DSA:3.30.530.20:FF:000039', NULL, NULL, 'Bet v I allergen-like', NULL, NULL, NULL, NULL, NULL, 4),
(224895, NULL, 'G3DSA:1.10.8.270:FF:000022', NULL, NULL, 'Ypt/Rab-GAP domain of gyp1p superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(224896, NULL, 'G3DSA:1.10.418.10:FF:000113', NULL, NULL, 'Ras GTPase-activating-like protein IQG1', NULL, NULL, NULL, NULL, NULL, 4),
(224897, NULL, 'G3DSA:3.40.50.1240:FF:000062', NULL, NULL, 'Inositol hexakisphosphate and diphosphoinositol-pentakisphosphate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(224898, NULL, 'G3DSA:1.20.1280.50:FF:000037', NULL, NULL, 'F-box protein SKIP19', NULL, NULL, NULL, NULL, NULL, 4),
(224899, NULL, 'G3DSA:1.10.30.10:FF:000032', NULL, NULL, 'FACT complex subunit SSRP1', NULL, NULL, NULL, NULL, NULL, 4),
(224900, NULL, 'G3DSA:1.10.1300.10:FF:000002', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(224901, NULL, 'G3DSA:3.40.930.10:FF:000025', NULL, NULL, 'PTS 2-O-a-mannosyl-D-glycerate transporter subunit IIABC', NULL, NULL, NULL, NULL, NULL, 4),
(224902, NULL, 'G3DSA:3.80.10.10:FF:003373', NULL, NULL, 'Putative leucine-rich repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(224903, NULL, 'G3DSA:3.40.30.10:FF:001060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224904, NULL, 'G3DSA:3.40.50.2300:FF:001667', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224905, NULL, 'G3DSA:1.20.890.10:FF:000033', NULL, NULL, 'Set1 complex component sdc1', NULL, NULL, NULL, NULL, NULL, 4),
(224906, NULL, 'G3DSA:3.90.1170.50:FF:000011', NULL, NULL, 'Xanthine DeHydrogenase homolog', NULL, NULL, NULL, NULL, NULL, 4),
(224907, NULL, 'G3DSA:3.40.850.10:FF:000142', NULL, NULL, 'Unplaced genomic scaffold supercont1.7, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(224908, NULL, 'G3DSA:3.30.200.20:FF:001796', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(224909, NULL, 'G3DSA:2.130.10.10:FF:002512', NULL, NULL, 'Sensor histidine kinase TodS', NULL, NULL, NULL, NULL, NULL, 4),
(224910, NULL, 'G3DSA:1.10.418.10:FF:000170', NULL, NULL, 'Si:ch211-207i1.2', NULL, NULL, NULL, NULL, NULL, 4),
(224911, NULL, 'G3DSA:3.40.850.10:FF:000024', NULL, NULL, 'Myosin heavy chain, isoform J', NULL, NULL, NULL, NULL, NULL, 4),
(224912, NULL, 'G3DSA:2.60.40.1170:FF:000014', NULL, NULL, 'AP-5 complex subunit mu-1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(224913, NULL, 'G3DSA:1.10.8.430:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224914, NULL, 'G3DSA:3.30.200.20:FF:001739', NULL, NULL, 'Homoserine kinase', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(224915, NULL, 'G3DSA:3.30.70.2520:FF:000004', NULL, NULL, 'D-arabinono-1,4-lactone oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(224916, NULL, 'G3DSA:2.130.10.10:FF:004603', NULL, NULL, 'Putative katanin', NULL, NULL, NULL, NULL, NULL, 4),
(224917, NULL, 'G3DSA:2.130.10.10:FF:001034', NULL, NULL, 'WD repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(224918, NULL, 'G3DSA:3.30.60.30:FF:000247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224919, NULL, 'G3DSA:3.30.40.10:FF:001218', NULL, NULL, 'Tripartite motif containing 66', NULL, NULL, NULL, NULL, NULL, 4),
(224920, NULL, 'G3DSA:2.60.40.10:FF:001927', NULL, NULL, 'KETtiN (Drosophila actin-binding) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(224921, NULL, 'G3DSA:1.20.272.10:FF:000024', NULL, NULL, 'Replication factor C subunit 4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(224922, NULL, 'G3DSA:3.30.530.20:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224923, NULL, 'G3DSA:1.10.238.200:FF:000013', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(224924, NULL, 'G3DSA:1.10.10.60:FF:001023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224925, NULL, 'G3DSA:3.80.10.10:FF:003316', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224926, NULL, 'G3DSA:3.40.1360.10:FF:000059', NULL, NULL, 'DNA topoisomerase VI, A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(224927, NULL, 'G3DSA:1.20.5.930:FF:000004', NULL, NULL, 'Integrin subunit alpha M', NULL, NULL, NULL, NULL, NULL, 4),
(224928, NULL, 'G3DSA:1.20.1740.10:FF:000010', NULL, NULL, 'probable cationic amino acid transporter', NULL, NULL, NULL, NULL, NULL, 4),
(224929, NULL, 'G3DSA:3.40.47.10:FF:000255', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224930, NULL, 'G3DSA:3.90.79.10:FF:000063', NULL, NULL, 'mRNA cleavage factor-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(224931, NULL, 'G3DSA:3.30.2320.60:FF:000001', NULL, NULL, 'FHA domain-containing protein FhaA', NULL, NULL, NULL, NULL, NULL, 4),
(224932, NULL, 'G3DSA:3.90.70.10:FF:000756', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224933, NULL, 'G3DSA:1.20.1070.10:FF:001791', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224934, NULL, 'G3DSA:3.40.50.300:FF:006380', NULL, NULL, 'Stardust protein GUK1 isoform', NULL, NULL, NULL, NULL, NULL, 4),
(224935, NULL, 'G3DSA:3.40.50.300:FF:003974', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224936, NULL, 'G3DSA:3.40.470.10:FF:000006', NULL, NULL, 'Uracil-DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(224937, NULL, 'G3DSA:2.10.50.10:FF:000093', NULL, NULL, 'Nerve growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(224938, NULL, 'G3DSA:1.10.490.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224939, NULL, 'G3DSA:3.40.50.300:FF:000837', NULL, NULL, 'NADH dehydrogenase [ubiquinone] 1 alpha subcomplex subunit 10, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(224940, NULL, 'G3DSA:3.40.50.970:FF:000083', NULL, NULL, 'Sulfite reductase (NADPH) hemoprotein, beta-component', NULL, NULL, NULL, NULL, NULL, 4),
(224941, NULL, 'G3DSA:1.25.10.10:FF:002633', NULL, NULL, 'Adaptor-related protein complex 1 subunit beta 1', NULL, NULL, NULL, NULL, NULL, 4),
(224942, NULL, 'G3DSA:3.30.200.20:FF:001419', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224943, NULL, 'G3DSA:1.10.510.10:FF:002750', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224944, NULL, 'G3DSA:2.60.120.10:FF:000811', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224945, NULL, 'G3DSA:3.40.50.1000:FF:000198', NULL, NULL, 'Bifunctional polynucleotide phosphatase/kinase', NULL, NULL, NULL, NULL, NULL, 4),
(224946, NULL, 'G3DSA:2.130.10.10:FF:003917', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224947, NULL, 'G3DSA:3.50.50.60:FF:000221', NULL, NULL, 'Dihydrolipoyl dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(224948, NULL, 'G3DSA:3.40.980.10:FF:000028', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(224949, NULL, 'G3DSA:3.90.920.10:FF:000002', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(224950, NULL, 'G3DSA:3.30.470.20:FF:000101', NULL, NULL, 'Pyruvate, water dikinase', NULL, NULL, NULL, NULL, NULL, 4),
(224951, NULL, 'G3DSA:3.40.50.300:FF:004766', NULL, NULL, 'ATP synthase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(224952, NULL, 'G3DSA:3.30.1370.10:FF:000163', NULL, NULL, 'KH domain-containing, RNA-binding, signal transduction-associated protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(224953, NULL, 'G3DSA:3.30.390.10:FF:000002', NULL, NULL, 'D-galactonate dehydratase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(224954, NULL, 'G3DSA:2.10.70.10:FF:000088', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(224955, NULL, 'G3DSA:2.20.25.530:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224956, NULL, 'G3DSA:3.40.50.150:FF:000921', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224957, NULL, 'G3DSA:2.20.25.90:FF:000001', NULL, NULL, 'Formate dehydrogenase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(224958, NULL, 'G3DSA:3.30.390.110:FF:000015', NULL, NULL, 'Os07g0271600 protein', NULL, NULL, NULL, NULL, NULL, 4),
(224959, NULL, 'G3DSA:3.50.50.60:FF:001317', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224960, NULL, 'G3DSA:3.10.100.10:FF:000115', NULL, NULL, 'C-type lectin domain family 4 member K', NULL, NULL, NULL, NULL, NULL, 4),
(224961, NULL, 'G3DSA:3.80.10.10:FF:001905', NULL, NULL, 'leucine-rich repeats and immunoglobulin-like domains protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(224962, NULL, 'G3DSA:3.40.50.300:FF:005042', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(224963, NULL, 'G3DSA:3.30.160.60:FF:005221', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224964, NULL, 'G3DSA:1.20.1250.20:FF:001515', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224965, NULL, 'G3DSA:2.120.10.30:FF:000164', NULL, NULL, 'Peptidylglycine alpha-amidating monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(224966, NULL, 'G3DSA:3.30.50.10:FF:000027', NULL, NULL, 'Progesterone receptor', NULL, NULL, NULL, NULL, NULL, 4),
(224967, NULL, 'G3DSA:2.60.40.60:FF:000267', NULL, NULL, 'Dachsous cadherin-related 2', NULL, NULL, NULL, NULL, NULL, 4),
(224968, NULL, 'G3DSA:4.10.60.10:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224969, NULL, 'G3DSA:1.10.110.10:FF:000011', NULL, NULL, 'Lipid transfer-like protein VAS', NULL, NULL, NULL, NULL, NULL, 4),
(224970, NULL, 'G3DSA:3.10.20.90:FF:000409', NULL, NULL, 'YAL046C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(224971, NULL, 'G3DSA:3.40.50.300:FF:002350', NULL, NULL, 'ATP-dependent helicase/nuclease subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(224972, NULL, 'G3DSA:1.10.10.520:FF:000005', NULL, NULL, 'Ubiquitin-activating enzyme E1-like', NULL, NULL, NULL, NULL, NULL, 4),
(224973, NULL, 'G3DSA:2.130.10.10:FF:000096', NULL, NULL, 'E3 ubiquitin-protein ligase TRAF7 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(224974, NULL, 'G3DSA:3.30.750.24:FF:000116', NULL, NULL, 'Testis anion transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(224975, NULL, 'G3DSA:1.25.10.10:FF:001638', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224976, NULL, 'G3DSA:3.80.10.10:FF:003294', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224977, NULL, 'G3DSA:3.40.50.300:FF:003013', NULL, NULL, 'ATPase domain protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(224978, NULL, 'G3DSA:3.30.2310.20:FF:000011', NULL, NULL, 'Endoribonuclease HigB', NULL, NULL, NULL, NULL, NULL, 4),
(224979, NULL, 'G3DSA:3.40.30.10:FF:000099', NULL, NULL, 'thioredoxin domain-containing protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(224980, NULL, 'G3DSA:1.25.40.20:FF:000373', NULL, NULL, 'Protein CfxQ-like', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(224981, NULL, 'G3DSA:1.10.10.10:FF:001666', NULL, NULL, 'Putative flocculation suppression protein', NULL, NULL, NULL, NULL, NULL, 4),
(224982, NULL, 'G3DSA:2.60.120.10:FF:000457', NULL, NULL, 'Lysophospholipase NTE1', NULL, NULL, NULL, NULL, NULL, 4),
(224983, NULL, 'G3DSA:1.25.40.20:FF:000659', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224984, NULL, 'G3DSA:1.10.510.10:FF:004509', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224985, NULL, 'G3DSA:3.40.630.10:FF:000491', NULL, NULL, 'Probable M18 family aminopeptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(224986, NULL, 'G3DSA:3.80.10.10:FF:004311', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(224987, NULL, 'G3DSA:3.40.30.10:FF:001116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(224988, NULL, 'G3DSA:1.10.10.510:FF:000002', NULL, NULL, 'Large T antigen', NULL, NULL, NULL, NULL, NULL, 4),
(224989, NULL, 'G3DSA:3.40.50.2300:FF:000032', NULL, NULL, 'DNA-binding transcriptional regulator CpxR', NULL, NULL, NULL, NULL, NULL, 4),
(224990, NULL, 'G3DSA:1.20.1110.10:FF:000159', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(224991, NULL, 'G3DSA:3.30.565.10:FF:000532', NULL, NULL, 'Adenylate cyclase, terminal-differentiation specific', NULL, NULL, NULL, NULL, NULL, 4),
(224992, NULL, 'G3DSA:3.40.50.980:FF:000029', NULL, NULL, '4-chlorobenzoate--CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(224993, NULL, 'G3DSA:3.30.70.330:FF:001752', NULL, NULL, 'RBD (RNA binding domain) protein', NULL, NULL, NULL, NULL, NULL, 4),
(224994, NULL, 'G3DSA:1.25.40.10:FF:000370', NULL, NULL, 'E3 ubiquitin-protein ligase TTC3', NULL, NULL, NULL, NULL, NULL, 4),
(224995, NULL, 'G3DSA:3.30.1370.100:FF:000029', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(224996, NULL, 'G3DSA:1.20.58.1590:FF:000003', NULL, NULL, 'Tethering factor for nuclear proteasome STS1', NULL, NULL, NULL, NULL, NULL, 4),
(224997, NULL, 'G3DSA:4.10.1240.10:FF:000028', NULL, NULL, 'FlaMIngo (Cadherin plus 7TM domain) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(224998, NULL, 'G3DSA:1.20.120.80:FF:000002', NULL, NULL, 'Cytochrome c oxidase subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(224999, NULL, 'G3DSA:2.40.10.10:FF:000049', NULL, NULL, 'probable inactive serine protease 37', NULL, NULL, NULL, NULL, NULL, 4),
(225000, NULL, 'G3DSA:3.30.1120.10:FF:000055', NULL, NULL, 'Arylsulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(225001, NULL, 'G3DSA:2.70.70.10:FF:000012', NULL, NULL, 'Peptidase, M23/M37 family', NULL, NULL, NULL, NULL, NULL, 4),
(225002, NULL, 'G3DSA:2.70.160.11:FF:000003', NULL, NULL, 'Protein arginine N-methyltransferase 5', NULL, NULL, NULL, NULL, NULL, 4),
(225003, NULL, 'G3DSA:1.10.150.20:FF:000022', NULL, NULL, 'translocation protein SEC63 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(225004, NULL, 'G3DSA:2.10.25.10:FF:001473', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225005, NULL, 'G3DSA:1.25.40.10:FF:001466', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(225006, NULL, 'G3DSA:3.40.50.10860:FF:000024', NULL, NULL, 'Shikimate dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(225007, NULL, 'G3DSA:2.60.40.10:FF:002742', NULL, NULL, 'Putative Filamin-A', NULL, NULL, NULL, NULL, NULL, 4),
(225008, NULL, 'G3DSA:1.25.40.10:FF:000038', NULL, NULL, 'Putative pre-mRNA-splicing factor SYF1', NULL, NULL, NULL, NULL, NULL, 4),
(225009, NULL, 'G3DSA:3.40.33.10:FF:000038', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(225010, NULL, 'G3DSA:3.40.50.2300:FF:001167', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225011, NULL, 'G3DSA:2.60.40.10:FF:004513', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225012, NULL, 'G3DSA:3.30.200.20:FF:000722', NULL, NULL, 'eIF-2-alpha kinase GCN2', NULL, NULL, NULL, NULL, NULL, 4),
(225013, NULL, 'G3DSA:3.40.50.720:FF:000502', NULL, NULL, 'Diacylglycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(225014, NULL, 'G3DSA:3.30.160.60:FF:004316', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(225015, NULL, 'G3DSA:3.30.497.10:FF:000132', NULL, NULL, 'Protein CBG06349', NULL, NULL, NULL, NULL, NULL, 4),
(225016, NULL, 'G3DSA:1.10.230.10:FF:000020', NULL, NULL, 'Citrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(225017, NULL, 'G3DSA:3.80.20.20:FF:000043', NULL, NULL, 'GPI-anchored cell wall organization protein Ecm33 (AFU_orthologue AFUA_4G06820)', NULL, NULL, NULL, NULL, NULL, 4),
(225018, NULL, 'G3DSA:3.50.50.60:FF:001295', NULL, NULL, 'Rab GDP dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(225019, NULL, 'G3DSA:3.60.21.10:FF:000369', NULL, NULL, 'Similar to 2,3-bisphosphoglycerate-independent phosphoglycerate mutase', NULL, NULL, NULL, NULL, NULL, 4),
(225020, NULL, 'G3DSA:1.10.555.10:FF:000263', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225021, NULL, 'G3DSA:2.60.40.60:FF:000380', NULL, NULL, 'putative protocadherin beta-18', NULL, NULL, NULL, NULL, NULL, 4),
(225022, NULL, 'G3DSA:1.10.238.10:FF:000195', NULL, NULL, '45 kDa calcium-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(225023, NULL, 'G3DSA:2.60.40.10:FF:005738', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225024, NULL, 'G3DSA:1.10.1740.160:FF:000002', NULL, NULL, 'Portal protein', NULL, NULL, NULL, NULL, NULL, 4),
(225025, NULL, 'G3DSA:3.40.120.10:FF:000076', NULL, NULL, 'Phosphoglucomutase/phosphomannomutase alpha/beta/alpha domain I', NULL, NULL, NULL, NULL, NULL, 4),
(225026, NULL, 'G3DSA:2.40.50.140:FF:000220', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(225027, NULL, 'G3DSA:1.10.1420.10:FF:000207', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(225028, NULL, 'G3DSA:3.30.530.20:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225029, NULL, 'G3DSA:3.10.250.10:FF:000148', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225030, NULL, 'G3DSA:3.30.40.10:FF:001426', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(225031, NULL, 'G3DSA:3.40.640.10:FF:000042', NULL, NULL, 'Cysteine desulfurase', NULL, NULL, NULL, NULL, NULL, 4),
(225032, NULL, 'G3DSA:3.90.226.10:FF:000107', NULL, NULL, 'Unplaced genomic scaffold supercont2.5, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(225033, NULL, 'G3DSA:3.90.70.10:FF:000138', NULL, NULL, 'Cruzipain', NULL, NULL, NULL, NULL, NULL, 4),
(225034, NULL, 'G3DSA:1.20.1070.10:FF:001173', NULL, NULL, 'C3a anaphylatoxin chemotactic receptor', NULL, NULL, NULL, NULL, NULL, 4),
(225035, NULL, 'G3DSA:3.30.40.10:FF:001483', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225036, NULL, 'G3DSA:3.40.50.300:FF:000551', NULL, NULL, 'Obg-like ATPase 1', NULL, NULL, NULL, NULL, NULL, 4),
(225037, NULL, 'G3DSA:2.160.20.10:FF:000123', NULL, NULL, 'SPbeta prophage-derived uncharacterized protein YorA', NULL, NULL, NULL, NULL, NULL, 4),
(225038, NULL, 'G3DSA:2.60.120.1040:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225039, NULL, 'G3DSA:1.20.120.1760:FF:000057', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225040, NULL, 'G3DSA:2.70.150.10:FF:000081', NULL, NULL, 'Guanylyl cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(225041, NULL, 'G3DSA:3.30.2320.10:FF:000003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225042, NULL, 'G3DSA:2.60.40.10:FF:002181', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(225043, NULL, 'G3DSA:2.60.120.970:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225044, NULL, 'G3DSA:1.10.10.10:FF:000648', NULL, NULL, 'Transcriptional regulator, Crp/Fnr family', NULL, NULL, NULL, NULL, NULL, 4),
(225045, NULL, 'G3DSA:1.20.120.350:FF:000256', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225046, NULL, 'G3DSA:3.80.10.10:FF:001517', NULL, NULL, 'Transforming growth factor beta activator LRRC33', NULL, NULL, NULL, NULL, NULL, 4),
(225047, NULL, 'G3DSA:1.10.20.10:FF:000267', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225048, NULL, 'G3DSA:3.40.50.1000:FF:000462', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(225049, NULL, 'G3DSA:3.30.830.10:FF:000250', NULL, NULL, 'Clan ME, family M16, insulinase-like metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(225050, NULL, 'G3DSA:3.40.50.150:FF:000360', NULL, NULL, 'DNA (cytosine-5)-methyltransferase DRM2', NULL, NULL, NULL, NULL, NULL, 4),
(225051, NULL, 'G3DSA:3.40.50.1820:FF:001624', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225052, NULL, 'G3DSA:3.40.50.300:FF:008302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225053, NULL, 'G3DSA:2.30.29.30:FF:001346', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(225054, NULL, 'G3DSA:1.10.10.1180:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225055, NULL, 'G3DSA:2.40.50.100:FF:000079', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(225056, NULL, 'G3DSA:3.30.2010.10:FF:000013', NULL, NULL, 'Zn-dependent protease with chaperone function', NULL, NULL, NULL, NULL, NULL, 4),
(225057, NULL, 'G3DSA:3.80.10.10:FF:002799', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225058, NULL, 'G3DSA:1.10.10.60:FF:000208', NULL, NULL, 'Zinc fingers and homeoboxes protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(225059, NULL, 'G3DSA:2.60.120.1030:FF:000012', NULL, NULL, 'Acdh-6', NULL, NULL, NULL, NULL, NULL, 4),
(225060, NULL, 'G3DSA:1.10.940.10:FF:000023', NULL, NULL, 'Transcription antitermination protein NusB', NULL, NULL, NULL, NULL, NULL, 4),
(225061, NULL, 'G3DSA:2.40.10.10:FF:000667', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225062, NULL, 'G3DSA:3.90.228.10:FF:000056', NULL, NULL, 'UBA/TS-N domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(225063, NULL, 'G3DSA:3.40.50.1100:FF:000161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225064, NULL, 'G3DSA:2.130.10.10:FF:001995', NULL, NULL, 'Os03g0355200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(225065, NULL, 'G3DSA:2.10.25.10:FF:000579', NULL, NULL, 'Notch homolog 4, [Drosophila]', NULL, NULL, NULL, NULL, NULL, 4),
(225066, NULL, 'G3DSA:1.25.40.10:FF:004080', NULL, NULL, 'Putative Gamma-soluble NSF attachment protein (SNAP-gamma) (N-ethylmaleimide-sensitive factor attachment protein, gamma)', NULL, NULL, NULL, NULL, NULL, 4),
(225067, NULL, 'G3DSA:2.60.40.150:FF:000711', NULL, NULL, 'Regulator of G-protein signaling rgs-7', NULL, NULL, NULL, NULL, NULL, 4),
(225068, NULL, 'G3DSA:3.30.540.10:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225069, NULL, 'G3DSA:3.10.180.10:FF:000041', NULL, NULL, '4-hydroxymandelate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(225070, NULL, 'G3DSA:1.25.40.10:FF:002522', NULL, NULL, 'Chaperone protein dnaK', NULL, NULL, NULL, NULL, NULL, 4),
(225071, NULL, 'G3DSA:3.40.50.10810:FF:000116', NULL, NULL, 'SNF2 family helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(225072, NULL, 'G3DSA:3.30.70.120:FF:000003', NULL, NULL, 'ATP phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(225073, NULL, 'G3DSA:3.10.100.10:FF:000435', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225074, NULL, 'G3DSA:2.60.40.10:FF:004951', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225075, NULL, 'G3DSA:2.40.128.130:FF:000010', NULL, NULL, 'Adhesin/invasin TibA autotransporter', NULL, NULL, NULL, NULL, NULL, 4),
(225076, NULL, 'G3DSA:1.25.10.10:FF:000278', NULL, NULL, 'MAP3K epsilon protein kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(225077, NULL, 'G3DSA:2.40.10.10:FF:000128', NULL, NULL, 'S46 family peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(225078, NULL, 'G3DSA:2.60.120.330:FF:000089', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(225079, NULL, 'G3DSA:1.20.120.1750:FF:000054', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(225080, NULL, 'G3DSA:1.10.287.2250:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225081, NULL, 'G3DSA:1.10.510.10:FF:001694', NULL, NULL, 'Ribosomal protein S6 kinase delta-1 isoform a', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(225082, NULL, 'G3DSA:3.40.50.1240:FF:000073', NULL, NULL, 'Fructose-6-phosphate2-kinase/fructose-2,6-bisph os phatase-likeprotein', NULL, NULL, NULL, NULL, NULL, 4),
(225083, NULL, 'G3DSA:2.130.10.10:FF:006048', NULL, NULL, 'F-box/WD repeat-containing protein pof1', NULL, NULL, NULL, NULL, NULL, 4),
(225084, NULL, 'G3DSA:3.30.420.40:FF:000104', NULL, NULL, 'putative glycerol kinase 5', NULL, NULL, NULL, NULL, NULL, 4),
(225085, NULL, 'G3DSA:3.30.60.20:FF:000071', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(225086, NULL, 'G3DSA:1.10.3470.10:FF:000008', NULL, NULL, 'Zinc ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(225087, NULL, 'G3DSA:1.10.10.60:FF:000085', NULL, NULL, 'SIX homeobox 5', NULL, NULL, NULL, NULL, NULL, 4),
(225088, NULL, 'G3DSA:2.130.10.10:FF:000371', NULL, NULL, 'dynein intermediate chain 2, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(225089, NULL, 'G3DSA:2.10.90.10:FF:000090', NULL, NULL, 'transforming growth factor beta superfamily signaling ligand isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(225090, NULL, 'G3DSA:3.30.200.20:FF:000104', NULL, NULL, 'G protein-coupled receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(225091, NULL, 'G3DSA:1.25.40.10:FF:004821', NULL, NULL, 'Enhanced entry protein enhC, tetratricopeptide repeat family', NULL, NULL, NULL, NULL, NULL, 4),
(225092, NULL, 'G3DSA:1.10.510.10:FF:002711', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(225093, NULL, 'G3DSA:1.10.10.10:FF:000441', NULL, NULL, 'AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(225094, NULL, 'G3DSA:2.40.50.140:FF:000107', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(225095, NULL, 'G3DSA:3.30.160.60:FF:000275', NULL, NULL, 'zinc finger protein 90 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(225096, NULL, 'G3DSA:3.30.920.20:FF:000001', NULL, NULL, 'Microtubule-actin cross-linking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(225097, NULL, 'G3DSA:3.40.50.300:FF:000276', NULL, NULL, 'Ras-related GTP-binding protein A', NULL, NULL, NULL, NULL, NULL, 4),
(225098, NULL, 'G3DSA:3.40.190.10:FF:000063', NULL, NULL, 'Glutamine ABC transporter, periplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(225099, NULL, 'G3DSA:1.10.510.10:FF:004431', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225100, NULL, 'G3DSA:2.70.150.10:FF:000288', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(225101, NULL, 'G3DSA:3.90.770.10:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225102, NULL, 'G3DSA:3.90.550.10:FF:000254', NULL, NULL, 'N-acetylmuramate alpha-1-phosphate uridylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(225103, NULL, 'G3DSA:2.40.10.10:FF:000460', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225104, NULL, 'G3DSA:3.40.1360.10:FF:000048', NULL, NULL, 'Meiotic recombination protein W68', NULL, NULL, NULL, NULL, NULL, 4),
(225105, NULL, 'G3DSA:1.25.40.340:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225106, NULL, 'G3DSA:2.30.30.40:FF:000526', NULL, NULL, 'LysM peptidoglycan-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(225107, NULL, 'G3DSA:1.20.1070.10:FF:001914', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225108, NULL, 'G3DSA:1.10.274.30:FF:000003', NULL, NULL, 'Male-specific lethal 3 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(225109, NULL, 'G3DSA:3.40.50.300:FF:004148', NULL, NULL, 'Si:dkey-61p9.9', NULL, NULL, NULL, NULL, NULL, 4),
(225110, NULL, 'G3DSA:1.10.472.10:FF:000401', NULL, NULL, 'Cyclin domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(225111, NULL, 'G3DSA:3.30.200.20:FF:002313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225112, NULL, 'G3DSA:2.60.120.920:FF:000092', NULL, NULL, 'Ran-binding protein M homolog', NULL, NULL, NULL, NULL, NULL, 4),
(225113, NULL, 'G3DSA:2.40.10.10:FF:000403', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(225114, NULL, 'G3DSA:1.10.287.600:FF:000013', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(225115, NULL, 'G3DSA:1.20.1250.20:FF:000200', NULL, NULL, 'Major facilitator superfamily domain-containing protein 4A', NULL, NULL, NULL, NULL, NULL, 4),
(225116, NULL, 'G3DSA:2.60.40.820:FF:000018', NULL, NULL, 'Putative T-box protein 35', NULL, NULL, NULL, NULL, NULL, 4),
(225117, NULL, 'G3DSA:3.30.160.60:FF:000893', NULL, NULL, 'Zinc finger protein 641', NULL, NULL, NULL, NULL, NULL, 4),
(225118, NULL, 'G3DSA:3.30.559.10:FF:000231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225119, NULL, 'G3DSA:1.25.10.10:FF:001970', NULL, NULL, 'YALI0E33774p', NULL, NULL, NULL, NULL, NULL, 4),
(225120, NULL, 'G3DSA:1.10.8.270:FF:000090', NULL, NULL, 'TBC domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(225121, NULL, 'G3DSA:2.70.170.10:FF:000177', NULL, NULL, 'Protein CBR-DEG-3', NULL, NULL, NULL, NULL, NULL, 4),
(225122, NULL, 'G3DSA:3.20.130.10:FF:000002', NULL, NULL, 'L(+)-tartrate dehydratase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(225123, NULL, 'G3DSA:2.10.70.10:FF:000268', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(225124, NULL, 'G3DSA:3.30.420.40:FF:000368', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(225125, NULL, 'G3DSA:1.10.8.270:FF:000033', NULL, NULL, 'GTPase-activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(225126, NULL, 'G3DSA:1.10.287.1490:FF:000157', NULL, NULL, 'Coiled-coil domain-containing 88C', NULL, NULL, NULL, NULL, NULL, 4),
(225127, NULL, 'G3DSA:2.60.40.10:FF:004333', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225128, NULL, 'G3DSA:1.10.418.10:FF:000181', NULL, NULL, 'Girdin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(225129, NULL, 'G3DSA:3.90.1290.10:FF:000025', NULL, NULL, 'Epiplakin 1', NULL, NULL, NULL, NULL, NULL, 4),
(225130, NULL, 'G3DSA:1.25.40.10:FF:000218', NULL, NULL, 'Peroxisomal targeting signal receptor', NULL, NULL, NULL, NULL, NULL, 4),
(225131, NULL, 'G3DSA:3.40.800.20:FF:000024', NULL, NULL, 'Histone deacetylase 3', NULL, NULL, NULL, NULL, NULL, 4),
(225132, NULL, 'G3DSA:3.30.590.10:FF:000034', NULL, NULL, 'Glutamate-ammonia ligase', NULL, NULL, NULL, NULL, NULL, 4),
(225133, NULL, 'G3DSA:1.10.238.260:FF:000008', NULL, NULL, 'Homocitrate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(225134, NULL, 'G3DSA:2.70.98.10:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225135, NULL, 'G3DSA:3.40.50.300:FF:001001', NULL, NULL, 'Multidrug ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(225136, NULL, 'G3DSA:3.90.79.10:FF:000001', NULL, NULL, 'RNA pyrophosphohydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(225137, NULL, 'G3DSA:3.40.47.10:FF:000137', NULL, NULL, 'Protein CBG03789', NULL, NULL, NULL, NULL, NULL, 4),
(225138, NULL, 'G3DSA:3.40.50.1010:FF:000139', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225139, NULL, 'G3DSA:3.40.50.1000:FF:000136', NULL, NULL, 'Trehalose-6-phosphate phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(225140, NULL, 'G3DSA:2.30.42.10:FF:000415', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225141, NULL, 'G3DSA:2.130.10.10:FF:000034', NULL, NULL, 'Pre-mRNA-processing factor 17, putative', NULL, NULL, NULL, NULL, NULL, 4),
(225142, NULL, 'G3DSA:3.40.800.10:FF:000021', NULL, NULL, 'Arginase', NULL, NULL, NULL, NULL, NULL, 4),
(225143, NULL, 'G3DSA:3.40.50.300:FF:000433', NULL, NULL, 'Estrogen sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(225144, NULL, 'G3DSA:2.60.40.10:FF:001579', NULL, NULL, 'Titin a', NULL, NULL, NULL, NULL, NULL, 4),
(225145, NULL, 'G3DSA:3.30.1640.10:FF:000083', NULL, NULL, 'DNA replication licensing factor MCM7', NULL, NULL, NULL, NULL, NULL, 4),
(225146, NULL, 'G3DSA:1.20.1640.10:FF:000031', NULL, NULL, 'PaTChed family', NULL, NULL, NULL, NULL, NULL, 4),
(225147, NULL, 'G3DSA:2.130.10.10:FF:002170', NULL, NULL, 'AGAP008095-PA', NULL, NULL, NULL, NULL, NULL, 4),
(225148, NULL, 'G3DSA:1.20.58.60:FF:000222', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(225149, NULL, 'G3DSA:3.30.160.60:FF:003304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225150, NULL, 'G3DSA:3.80.10.10:FF:003816', NULL, NULL, 'Receptor-like protein 18', NULL, NULL, NULL, NULL, NULL, 4),
(225151, NULL, 'G3DSA:3.90.226.10:FF:000102', NULL, NULL, 'Crotonase/enoyl-CoA hydratase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(225152, NULL, 'G3DSA:3.40.350.10:FF:000008', NULL, NULL, 'xaa-Pro aminopeptidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(225153, NULL, 'G3DSA:3.30.230.70:FF:000143', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(225154, NULL, 'G3DSA:3.30.40.10:FF:000420', NULL, NULL, 'Putative Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(225155, NULL, 'G3DSA:1.20.1070.10:FF:000919', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(225156, NULL, 'G3DSA:2.60.40.10:FF:002147', NULL, NULL, 'Down syndrome cell adhesion molecule like 1', NULL, NULL, NULL, NULL, NULL, 4),
(225157, NULL, 'G3DSA:3.40.1050.10:FF:000013', NULL, NULL, 'Probable transmembrane carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(225158, NULL, 'G3DSA:2.40.70.10:FF:000047', NULL, NULL, 'Cathepsin D preproprotein', NULL, NULL, NULL, NULL, NULL, 4),
(225159, NULL, 'G3DSA:3.90.226.10:FF:000046', NULL, NULL, 'Geranyl-CoA carboxylase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(225160, NULL, 'G3DSA:3.30.505.10:FF:000017', NULL, NULL, 'Phosphatidylinositol 3-kinase regulatory subunit gamma b', NULL, NULL, NULL, NULL, NULL, 4),
(225161, NULL, 'G3DSA:1.10.640.10:FF:000101', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225162, NULL, 'G3DSA:3.40.50.10810:FF:000262', NULL, NULL, 'Meiotic recombination protein rdh54', NULL, NULL, NULL, NULL, NULL, 4),
(225163, NULL, 'G3DSA:3.90.550.50:FF:000070', NULL, NULL, 'Beta-1,3-glucosyltransferase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(225164, NULL, 'G3DSA:1.10.238.10:FF:001133', NULL, NULL, 'Dual oxidase 2', NULL, NULL, NULL, NULL, NULL, 4),
(225165, NULL, 'G3DSA:3.40.50.1820:FF:000899', NULL, NULL, 'Carboxylic ester hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(225166, NULL, 'G3DSA:3.40.50.300:FF:004704', NULL, NULL, 'Adenylate kinase 9', NULL, NULL, NULL, NULL, NULL, 4),
(225167, NULL, 'G3DSA:3.30.200.20:FF:002234', NULL, NULL, 'Putative MAP kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(225168, NULL, 'G3DSA:1.10.8.60:FF:000494', NULL, NULL, 'Spastin-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(225169, NULL, 'G3DSA:1.10.460.10:FF:000003', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(225170, NULL, 'G3DSA:2.60.40.180:FF:000017', NULL, NULL, 'Probable 5-hydroxyisourate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(225171, NULL, 'G3DSA:2.60.40.1120:FF:000022', NULL, NULL, 'Carbohydrate-binding-like fold', NULL, NULL, NULL, NULL, NULL, 4),
(225172, NULL, 'G3DSA:3.40.50.300:FF:003125', NULL, NULL, 'Cobalt ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(225173, NULL, 'G3DSA:3.40.30.10:FF:001228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225174, NULL, 'G3DSA:3.30.160.60:FF:002692', NULL, NULL, 'Kruppel-like factor 15', NULL, NULL, NULL, NULL, NULL, 4),
(225175, NULL, 'G3DSA:3.30.70.1230:FF:000163', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(225176, NULL, 'G3DSA:2.130.10.10:FF:000657', NULL, NULL, 'U3 small nucleolar RNA associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(225177, NULL, 'G3DSA:3.40.50.720:FF:001514', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225178, NULL, 'G3DSA:1.20.1310.10:FF:000107', NULL, NULL, 'Cullin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(225179, NULL, 'G3DSA:1.10.8.60:FF:000168', NULL, NULL, 'ESX-5 type VII secretion system protein EccA', NULL, NULL, NULL, NULL, NULL, 4),
(225180, NULL, 'G3DSA:3.30.300.130:FF:000003', NULL, NULL, 'NifU-like protein 3, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(225181, NULL, 'G3DSA:3.30.565.10:FF:000414', NULL, NULL, 'Two-component sensor kinase', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(225182, NULL, 'G3DSA:3.30.160.60:FF:006284', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225183, NULL, 'G3DSA:3.30.70.330:FF:001870', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225184, NULL, 'G3DSA:2.170.270.10:FF:000200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225185, NULL, 'G3DSA:1.20.58.860:FF:000022', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(225186, NULL, 'G3DSA:2.170.130.10:FF:000021', NULL, NULL, 'SusC/RagA family TonB-linked outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(225187, NULL, 'G3DSA:2.30.29.30:FF:000008', NULL, NULL, 'GRAM domain containing 1B', NULL, NULL, NULL, NULL, NULL, 4),
(225188, NULL, 'G3DSA:2.60.40.10:FF:005002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225189, NULL, 'G3DSA:2.10.25.10:FF:001355', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225190, NULL, 'G3DSA:3.100.10.10:FF:000014', NULL, NULL, 'Ribosomal protein', NULL, NULL, NULL, NULL, NULL, 4),
(225191, NULL, 'G3DSA:3.50.50.60:FF:000390', NULL, NULL, 'FAD/NAD(P)-binding oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(225192, NULL, 'G3DSA:1.10.150.190:FF:000003', NULL, NULL, 'Eukaryotic translation initiation factor 2 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(225193, NULL, 'G3DSA:2.70.130.10:FF:000079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225194, NULL, 'G3DSA:3.40.190.10:FF:000350', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(225195, NULL, 'G3DSA:1.50.40.10:FF:000593', NULL, NULL, 'Protein CBG24187', NULL, NULL, NULL, NULL, NULL, 4),
(225196, NULL, 'G3DSA:3.40.50.1240:FF:000028', NULL, NULL, 'Putative 2-carboxy-D-arabinitol-1-phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(225197, NULL, 'G3DSA:1.25.40.20:FF:000777', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(225198, NULL, 'G3DSA:3.30.870.10:FF:000016', NULL, NULL, 'Cardiolipin synthase B', NULL, NULL, NULL, NULL, NULL, 4),
(225199, NULL, 'G3DSA:2.60.40.10:FF:000056', NULL, NULL, 'twitchin isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(225200, NULL, 'G3DSA:3.40.50.2300:FF:001381', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225201, NULL, 'G3DSA:1.25.10.10:FF:002077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225202, NULL, 'G3DSA:3.90.920.10:FF:000007', NULL, NULL, 'Possible ATP dependant DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(225203, NULL, 'G3DSA:1.10.10.10:FF:000148', NULL, NULL, '6-O-methylguanine DNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(225204, NULL, 'G3DSA:3.30.420.40:FF:000430', NULL, NULL, 'GD23045', NULL, NULL, NULL, NULL, NULL, 4),
(225205, NULL, 'G3DSA:3.40.50.300:FF:004648', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225206, NULL, 'G3DSA:2.60.200.20:FF:000017', NULL, NULL, 'Nibrin', NULL, NULL, NULL, NULL, NULL, 4),
(225207, NULL, 'G3DSA:2.60.200.10:FF:000014', NULL, NULL, 'Interferon regulatory factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(225208, NULL, 'G3DSA:3.90.550.10:FF:000198', NULL, NULL, '2-C-methyl-D-erythritol 4-phosphate cytidylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(225209, NULL, 'G3DSA:3.30.160.60:FF:003411', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(225210, NULL, 'G3DSA:2.30.30.1190:FF:000004', NULL, NULL, 'Zinc finger CCCH domain-containing protein 37', NULL, NULL, NULL, NULL, NULL, 4),
(225211, NULL, 'G3DSA:3.30.70.330:FF:002426', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225212, NULL, 'G3DSA:2.10.220.10:FF:000077', NULL, NULL, 'High cysteine membrane protein TMK-like', NULL, NULL, NULL, NULL, NULL, 4),
(225213, NULL, 'G3DSA:3.40.630.10:FF:000316', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(225214, NULL, 'G3DSA:2.130.10.10:FF:004249', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225215, NULL, 'G3DSA:1.10.274.30:FF:000008', NULL, NULL, 'MRG (Mortality factor-Related Gene) related', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(225216, NULL, 'G3DSA:1.25.40.10:FF:004203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225217, NULL, 'G3DSA:1.10.10.60:FF:000646', NULL, NULL, 'Sensor histidine kinase TodS', NULL, NULL, NULL, NULL, NULL, 4),
(225218, NULL, 'G3DSA:3.10.20.90:FF:001011', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 21', NULL, NULL, NULL, NULL, NULL, 4),
(225219, NULL, 'G3DSA:3.10.450.50:FF:000012', NULL, NULL, 'Mitogen-activated protein kinase kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(225220, NULL, 'G3DSA:2.20.70.10:FF:000222', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(225221, NULL, 'G3DSA:3.50.50.60:FF:000283', NULL, NULL, 'Lipoamide dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(225222, NULL, 'G3DSA:3.30.200.20:FF:000110', NULL, NULL, 'Death-associated kinase 3, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(225223, NULL, 'G3DSA:3.30.450.20:FF:000499', NULL, NULL, 'Methyl-accepting chemotaxis protein', NULL, NULL, NULL, NULL, NULL, 4),
(225224, NULL, 'G3DSA:1.20.5.990:FF:000005', NULL, NULL, 'TNFAIP3 interacting protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(225225, NULL, 'G3DSA:2.60.40.60:FF:000554', NULL, NULL, 'cadherin EGF LAG seven-pass G-type receptor 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(225226, NULL, 'G3DSA:3.40.50.1220:FF:000022', NULL, NULL, 'Electron transfer flavoprotein, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(225227, NULL, 'G3DSA:3.30.200.20:FF:001296', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(225228, NULL, 'G3DSA:1.10.8.10:FF:000001', NULL, NULL, 'Elongation factor Ts', NULL, NULL, NULL, NULL, NULL, 4),
(225229, NULL, 'G3DSA:3.30.70.330:FF:000116', NULL, NULL, 'Putative ribonucleoprotein PTB-binding 1', NULL, NULL, NULL, NULL, NULL, 4),
(225230, NULL, 'G3DSA:1.20.58.1030:FF:000015', NULL, NULL, 'Probable DNA replication complex GINS protein PSF1', NULL, NULL, NULL, NULL, NULL, 4),
(225231, NULL, 'G3DSA:3.50.30.50:FF:000003', NULL, NULL, 'Metal-dependent hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(225232, NULL, 'G3DSA:2.30.30.90:FF:000013', NULL, NULL, 'SirR/DtxR family transcription regulator SirR', NULL, NULL, NULL, NULL, NULL, 4),
(225233, NULL, 'G3DSA:2.60.40.10:FF:000909', NULL, NULL, 'Interferon alpha/beta receptor 2', NULL, NULL, NULL, NULL, NULL, 4),
(225234, NULL, 'G3DSA:3.30.830.10:FF:000082', NULL, NULL, 'Axl1p', NULL, NULL, NULL, NULL, NULL, 4),
(225235, NULL, 'G3DSA:1.25.40.990:FF:000029', NULL, NULL, 'Related to leucine permease transcriptional regulator SAC3', NULL, NULL, NULL, NULL, NULL, 4),
(225236, NULL, 'G3DSA:3.40.50.300:FF:002850', NULL, NULL, 'Katanin p60 ATPase-containing subunit A-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(225237, NULL, 'G3DSA:3.30.160.60:FF:001798', NULL, NULL, 'Zinc finger protein 202', NULL, NULL, NULL, NULL, NULL, 4),
(225238, NULL, 'G3DSA:1.25.10.10:FF:002133', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(225239, NULL, 'G3DSA:1.10.10.10:FF:000362', NULL, NULL, 'DNA-directed RNA polymerase III subunit rpc3', NULL, NULL, NULL, NULL, NULL, 4),
(225240, NULL, 'G3DSA:1.10.565.10:FF:000084', NULL, NULL, 'Nuclear receptor subfamily 1, group H, member 5', NULL, NULL, NULL, NULL, NULL, 4),
(225241, NULL, 'G3DSA:2.130.10.10:FF:002451', NULL, NULL, 'Putative Serine/threonine-protein kinase/endoribonuclease IRE1', NULL, NULL, NULL, NULL, NULL, 4),
(225242, NULL, 'G3DSA:1.10.3720.10:FF:000107', NULL, NULL, 'Nickel ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(225243, NULL, 'G3DSA:1.10.287.110:FF:000169', NULL, NULL, 'DnaJ domain protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(225244, NULL, 'G3DSA:3.30.420.40:FF:000481', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(225245, NULL, 'G3DSA:1.10.510.10:FF:002475', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225246, NULL, 'G3DSA:3.30.70.330:FF:002207', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225247, NULL, 'G3DSA:3.30.300.10:FF:000047', NULL, NULL, 'S-adenosylmethionine synthase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(225248, NULL, 'G3DSA:3.30.565.10:FF:000296', NULL, NULL, 'Ethylene receptor', NULL, NULL, NULL, NULL, NULL, 4),
(225249, NULL, 'G3DSA:3.40.190.290:FF:000066', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(225250, NULL, 'G3DSA:3.30.450.40:FF:000139', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(225251, NULL, 'G3DSA:3.30.70.330:FF:000302', NULL, NULL, 'RNA-binding protein BRN1', NULL, NULL, NULL, NULL, NULL, 4),
(225252, NULL, 'G3DSA:1.20.1560.10:FF:000030', NULL, NULL, 'ABC transporter B family member 15', NULL, NULL, NULL, NULL, NULL, 4),
(225253, NULL, 'G3DSA:3.20.20.70:FF:000729', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225254, NULL, 'G3DSA:3.40.50.720:FF:001840', NULL, NULL, 'Dihydrodipicolinate reductase, C-terminus family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(225255, NULL, 'G3DSA:1.10.472.10:FF:000227', NULL, NULL, 'Cyclin protein', NULL, NULL, NULL, NULL, NULL, 4),
(225256, NULL, 'G3DSA:1.20.58.1040:FF:000018', NULL, NULL, '1,3-beta-glucanosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(225257, NULL, 'G3DSA:2.20.70.10:FF:000273', NULL, NULL, 'Rho GTPase activating protein 27, like', NULL, NULL, NULL, NULL, NULL, 4),
(225258, NULL, 'G3DSA:3.90.1420.10:FF:000064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225259, NULL, 'G3DSA:1.10.8.20:FF:000004', NULL, NULL, 'Retinaldehyde binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(225260, NULL, 'G3DSA:2.130.10.10:FF:005598', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225261, NULL, 'G3DSA:2.60.40.2030:FF:000019', NULL, NULL, 'Adhesion G protein-coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(225262, NULL, 'G3DSA:2.10.25.10:FF:001029', NULL, NULL, 'InTestinal NeureXin-like', NULL, NULL, NULL, NULL, NULL, 4),
(225263, NULL, 'G3DSA:3.30.200.20:FF:000054', NULL, NULL, 'Cyclin-dependent kinase 11B', NULL, NULL, NULL, NULL, NULL, 4),
(225264, NULL, 'G3DSA:3.90.550.10:FF:000580', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225265, NULL, 'G3DSA:3.30.160.60:FF:000449', NULL, NULL, 'Zinc finger protein MAGPIE', NULL, NULL, NULL, NULL, NULL, 4),
(225266, NULL, 'G3DSA:2.130.10.10:FF:005828', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225267, NULL, 'G3DSA:2.40.10.170:FF:000013', NULL, NULL, 'Transcriptional regulator, CarD family', NULL, NULL, NULL, NULL, NULL, 4),
(225268, NULL, 'G3DSA:3.90.79.10:FF:000220', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(225269, NULL, 'G3DSA:3.50.50.60:FF:000064', NULL, NULL, 'Thioredoxin reductase', NULL, NULL, NULL, NULL, NULL, 4),
(225270, NULL, 'G3DSA:1.20.5.730:FF:000006', NULL, NULL, 'Regulatory protein SIR4', NULL, NULL, NULL, NULL, NULL, 4),
(225271, NULL, 'G3DSA:1.10.510.10:FF:000384', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(225272, NULL, 'G3DSA:3.90.1750.10:FF:000055', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(225273, NULL, 'G3DSA:1.25.40.10:FF:000044', NULL, NULL, 'Tetratricopeptide repeat, ankyrin repeat and coiled-coil containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(225274, NULL, 'G3DSA:3.40.50.300:FF:006621', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225275, NULL, 'G3DSA:2.120.10.30:FF:000107', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225276, NULL, 'G3DSA:3.30.160.360:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225277, NULL, 'G3DSA:1.25.40.10:FF:000662', NULL, NULL, 'prolyl 4-hydroxylase subunit alpha-2', NULL, NULL, NULL, NULL, NULL, 4),
(225278, NULL, 'G3DSA:3.40.50.150:FF:000129', NULL, NULL, 'Mitochondrial rRNA methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(225279, NULL, 'G3DSA:3.90.550.10:FF:000428', NULL, NULL, 'Sll1528 protein', NULL, NULL, NULL, NULL, NULL, 4),
(225280, NULL, 'G3DSA:3.30.1380.20:FF:000043', NULL, NULL, 'Trafficking protein particle complex subunit', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(225281, NULL, 'G3DSA:2.60.40.10:FF:000382', NULL, NULL, 'fibronectin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(225282, NULL, 'G3DSA:3.40.50.300:FF:006891', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225283, NULL, 'G3DSA:3.10.110.10:FF:000380', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(225284, NULL, 'G3DSA:1.25.40.20:FF:000665', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225285, NULL, 'G3DSA:1.10.238.10:FF:000751', NULL, NULL, 'Two pore calcium channel protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(225286, NULL, 'G3DSA:3.30.70.330:FF:001718', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225287, NULL, 'G3DSA:3.60.21.10:FF:000307', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(225288, NULL, 'G3DSA:1.25.40.20:FF:000047', NULL, NULL, 'Kinase D-interacting substrate of 220 kDa B', NULL, NULL, NULL, NULL, NULL, 4),
(225289, NULL, 'G3DSA:2.70.20.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225290, NULL, 'G3DSA:1.10.220.160:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225291, NULL, 'G3DSA:3.80.10.10:FF:003586', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225292, NULL, 'G3DSA:2.30.30.360:FF:000003', NULL, NULL, 'Myosin heavy chain 95F', NULL, NULL, NULL, NULL, NULL, 4),
(225293, NULL, 'G3DSA:3.40.50.1980:FF:000053', NULL, NULL, 'Histidinol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(225294, NULL, 'G3DSA:2.10.25.10:FF:001304', NULL, NULL, 'Hyaluronan-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(225295, NULL, 'G3DSA:1.25.40.10:FF:004315', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225296, NULL, 'G3DSA:3.30.505.10:FF:000192', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225297, NULL, 'G3DSA:3.40.50.720:FF:001284', NULL, NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase 2, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(225298, NULL, 'G3DSA:1.25.40.10:FF:002135', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(225299, NULL, 'G3DSA:2.60.40.10:FF:002473', NULL, NULL, 'Jitterbug, isoform N', NULL, NULL, NULL, NULL, NULL, 4),
(225300, NULL, 'G3DSA:2.30.30.380:FF:000009', NULL, NULL, 'Calpain 15', NULL, NULL, NULL, NULL, NULL, 4),
(225301, NULL, 'G3DSA:2.30.30.40:FF:000352', NULL, NULL, 'Putative chemotaxis protein CheV', NULL, NULL, NULL, NULL, NULL, 4),
(225302, NULL, 'G3DSA:2.10.70.80:FF:000007', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(225303, NULL, 'G3DSA:1.10.10.60:FF:000534', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(225304, NULL, 'G3DSA:2.120.10.30:FF:000282', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM71', NULL, NULL, NULL, NULL, NULL, 4),
(225305, NULL, 'G3DSA:3.40.50.150:FF:001023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225306, NULL, 'G3DSA:1.25.40.180:FF:000287', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225307, NULL, 'G3DSA:2.130.10.10:FF:004468', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225308, NULL, 'G3DSA:3.40.50.720:FF:001565', NULL, NULL, 'Sumo-1-activating enzyme E1a, putative', NULL, NULL, NULL, NULL, NULL, 4),
(225309, NULL, 'G3DSA:3.30.519.10:FF:000015', NULL, NULL, 'Guanosine nucleotide diphosphate dissociation inhibitor', NULL, NULL, NULL, NULL, NULL, 4),
(225310, NULL, 'G3DSA:2.60.120.200:FF:000786', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225311, NULL, 'G3DSA:2.60.40.10:FF:004159', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225312, NULL, 'G3DSA:2.30.30.40:FF:000077', NULL, NULL, 'spermatogenesis-associated protein 13 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(225313, NULL, 'G3DSA:3.40.630.10:FF:000160', NULL, NULL, 'Predicted aminopeptidases', NULL, NULL, NULL, NULL, NULL, 4),
(225314, NULL, 'G3DSA:2.60.40.150:FF:000418', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(225315, NULL, 'G3DSA:2.60.210.10:FF:000054', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225316, NULL, 'G3DSA:3.30.565.10:FF:000291', NULL, NULL, 'PAS domain-containing sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(225317, NULL, 'G3DSA:1.10.238.10:FF:000700', NULL, NULL, 'Ef-hand protein 5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(225318, NULL, 'G3DSA:3.40.220.20:FF:000002', NULL, NULL, 'Polyprotein ORF1ab', NULL, NULL, NULL, NULL, NULL, 4),
(225319, NULL, 'G3DSA:1.10.238.10:FF:000644', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(225320, NULL, 'G3DSA:3.40.50.10470:FF:000019', NULL, NULL, 'Ribose 1,5-bisphosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(225321, NULL, 'G3DSA:2.60.40.10:FF:004215', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225322, NULL, 'G3DSA:2.170.11.10:FF:000006', NULL, NULL, 'DNA topoisomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(225323, NULL, 'G3DSA:3.40.30.10:FF:000453', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(225324, NULL, 'G3DSA:3.10.250.10:FF:000098', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225325, NULL, 'G3DSA:1.20.1560.10:FF:000766', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225326, NULL, 'G3DSA:3.30.160.60:FF:000724', NULL, NULL, 'PR domain zinc finger protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(225327, NULL, 'G3DSA:1.10.730.10:FF:000108', NULL, NULL, 'Leucyl Amino-acyl tRNA Synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(225328, NULL, 'G3DSA:1.20.210.10:FF:000022', NULL, NULL, 'Cytochrome c oxidase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(225329, NULL, 'G3DSA:1.10.10.60:FF:000242', NULL, NULL, 'Homeobox-leucine zipper protein HOX13', NULL, NULL, NULL, NULL, NULL, 4),
(225330, NULL, 'G3DSA:3.90.190.10:FF:000389', NULL, NULL, 'AaceriAFR601Cp', NULL, NULL, NULL, NULL, NULL, 4),
(225331, NULL, 'G3DSA:3.30.420.40:FF:000486', NULL, NULL, 'Actin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(225332, NULL, 'G3DSA:2.30.30.30:FF:000074', NULL, NULL, 'Transcription elongation regulator-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(225333, NULL, 'G3DSA:3.40.50.1000:FF:000248', NULL, NULL, 'HAD family phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(225334, NULL, 'G3DSA:1.20.58.80:FF:000054', NULL, NULL, 'Vacuolar protein sorting-associated protein', NULL, NULL, NULL, NULL, NULL, 4),
(225335, NULL, 'G3DSA:3.30.230.10:FF:000108', NULL, NULL, '4-diphosphocytidyl-2-C-methyl-D-erythritol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(225336, NULL, 'G3DSA:3.30.450.200:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225337, NULL, 'G3DSA:3.30.830.10:FF:000019', NULL, NULL, 'nardilysin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(225338, NULL, 'G3DSA:3.30.420.40:FF:000542', NULL, NULL, 'Heat shock cognate 71 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(225339, NULL, 'G3DSA:1.10.510.10:FF:004217', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225340, NULL, 'G3DSA:3.30.160.40:FF:000005', NULL, NULL, 'Porphobilinogen deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(225341, NULL, 'G3DSA:1.20.1050.10:FF:000160', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(225342, NULL, 'G3DSA:1.20.58.390:FF:000246', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225343, NULL, 'G3DSA:3.30.450.20:FF:000100', NULL, NULL, 'Protein TWIN LOV 1', NULL, NULL, NULL, NULL, NULL, 4),
(225344, NULL, 'G3DSA:3.50.50.60:FF:000513', NULL, NULL, 'Hydrogen cyanide synthase HcnC', NULL, NULL, NULL, NULL, NULL, 4),
(225345, NULL, 'G3DSA:3.90.1640.10:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225346, NULL, 'G3DSA:3.30.70.270:FF:000025', NULL, NULL, 'Retrovirus-related Pol polyprotein LINE-1', NULL, NULL, NULL, NULL, NULL, 4),
(225347, NULL, 'G3DSA:1.25.40.10:FF:001915', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225348, NULL, 'G3DSA:1.25.10.10:FF:001110', NULL, NULL, 'RING-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(225349, NULL, 'G3DSA:3.90.550.50:FF:000182', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(225350, NULL, 'G3DSA:3.40.50.10810:FF:000150', NULL, NULL, 'Helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(225351, NULL, 'G3DSA:3.30.420.40:FF:000604', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225352, NULL, 'G3DSA:3.80.10.10:FF:001462', NULL, NULL, 'Related to Leucine Rich Repeat domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(225353, NULL, 'G3DSA:3.40.50.1240:FF:000180', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225354, NULL, 'G3DSA:4.10.400.10:FF:000095', NULL, NULL, 'Low-density lipoprotein receptor-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(225355, NULL, 'G3DSA:3.90.1720.10:FF:000008', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, NULL, NULL, NULL, NULL, 4),
(225356, NULL, 'G3DSA:1.10.1450.10:FF:000097', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(225357, NULL, 'G3DSA:1.10.286.20:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225358, NULL, 'G3DSA:1.10.150.390:FF:000001', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(225359, NULL, 'G3DSA:2.40.10.10:FF:000162', NULL, NULL, 'Protease Do-like 7', NULL, NULL, NULL, NULL, NULL, 4),
(225360, NULL, 'G3DSA:1.20.1250.20:FF:001280', NULL, NULL, 'Sucrose transporter GRMZM2G106741', NULL, NULL, NULL, NULL, NULL, 4),
(225361, NULL, 'G3DSA:1.10.3080.10:FF:000086', NULL, NULL, 'Chloride channel protein', NULL, NULL, NULL, NULL, NULL, 4),
(225362, NULL, 'G3DSA:1.25.10.10:FF:000093', NULL, NULL, 'rap1 GTPase-GDP dissociation stimulator 1 isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(225363, NULL, 'G3DSA:1.20.120.350:FF:000251', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225364, NULL, 'G3DSA:1.25.40.10:FF:004259', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225365, NULL, 'G3DSA:1.20.58.70:FF:000051', NULL, NULL, 'Syntaxin PM family protein', NULL, NULL, NULL, NULL, NULL, 4),
(225366, NULL, 'G3DSA:1.50.40.10:FF:000093', NULL, NULL, 'mitochondrial uncoupling protein 4-like', NULL, NULL, NULL, NULL, NULL, 4),
(225367, NULL, 'G3DSA:3.40.30.10:FF:000739', NULL, NULL, 'Thioredoxin-1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(225368, NULL, 'G3DSA:1.10.30.10:FF:000094', NULL, NULL, 'High mobility group B protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(225369, NULL, 'G3DSA:3.40.50.1110:FF:000169', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225370, NULL, 'G3DSA:3.40.50.1100:FF:000166', NULL, NULL, 'Diaminopropionate ammonia-lyase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(225371, NULL, 'G3DSA:3.40.50.880:FF:000230', NULL, NULL, 'Carbamoyl-phosphate synthase small chain', NULL, NULL, NULL, NULL, NULL, 4),
(225372, NULL, 'G3DSA:3.90.550.10:FF:000754', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225373, NULL, 'G3DSA:2.130.10.10:FF:004524', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225374, NULL, 'G3DSA:2.10.109.10:FF:000060', NULL, NULL, 'Mitochondrial inner membrane protease subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(225375, NULL, 'G3DSA:3.40.50.300:FF:002636', NULL, NULL, 'ABC transporter A family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(225376, NULL, 'G3DSA:2.60.40.150:FF:000469', NULL, NULL, 'Phospholipase A2', NULL, NULL, NULL, NULL, NULL, 4),
(225377, NULL, 'G3DSA:3.90.1150.10:FF:000470', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225378, NULL, 'G3DSA:1.20.272.10:FF:000018', NULL, NULL, 'Replication factor C subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(225379, NULL, 'G3DSA:3.30.200.20:FF:000166', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(225380, NULL, 'G3DSA:3.40.47.10:FF:000070', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(225381, NULL, 'G3DSA:3.40.50.300:FF:006565', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(225382, NULL, 'G3DSA:3.30.499.10:FF:000029', NULL, NULL, '3-isopropylmalate dehydratase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(225383, NULL, 'G3DSA:3.40.350.10:FF:000003', NULL, NULL, 'Xaa-pro aminopeptidase P', NULL, NULL, NULL, NULL, NULL, 4),
(225384, NULL, 'G3DSA:2.60.120.650:FF:000162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225385, NULL, 'G3DSA:2.60.40.1660:FF:000009', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(225386, NULL, 'G3DSA:3.90.1150.210:FF:000006', NULL, NULL, 'F-actin-capping protein subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(225387, NULL, 'G3DSA:1.10.510.10:FF:000272', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(225388, NULL, 'G3DSA:2.60.40.10:FF:002422', NULL, NULL, 'Protein sidekick homolog', NULL, NULL, NULL, NULL, NULL, 4),
(225389, NULL, 'G3DSA:3.40.50.300:FF:008145', NULL, NULL, 'Protein CBG12210', NULL, NULL, NULL, NULL, NULL, 4),
(225390, NULL, 'G3DSA:3.30.420.80:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225391, NULL, 'G3DSA:2.30.30.40:FF:000026', NULL, NULL, 'Putative tight junction protein ZO-1', NULL, NULL, NULL, NULL, NULL, 4),
(225392, NULL, 'G3DSA:2.170.190.11:FF:000026', NULL, NULL, 'Molybdenum cofactor biosynthesis protein (MoaA)', NULL, NULL, NULL, NULL, NULL, 4),
(225393, NULL, 'G3DSA:3.40.50.300:FF:007869', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(225394, NULL, 'G3DSA:3.80.10.10:FF:001170', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(225395, NULL, 'G3DSA:3.30.360.10:FF:000051', NULL, NULL, 'Oxidoreductase, Gfo/Idh/MocA family', NULL, NULL, NULL, NULL, NULL, 4),
(225396, NULL, 'G3DSA:3.40.50.300:FF:008471', NULL, NULL, 'ATP-binding cassette transporter, subfamily C, member 15, group MRP protein PpABCC15', NULL, NULL, NULL, NULL, NULL, 4),
(225397, NULL, 'G3DSA:3.30.565.10:FF:000240', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(225398, NULL, 'G3DSA:3.90.550.10:FF:000142', NULL, NULL, 'Hyaluronan synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(225399, NULL, 'G3DSA:3.30.2160.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225400, NULL, 'G3DSA:1.10.238.200:FF:000018', NULL, NULL, 'Defective in cullin neddylation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(225401, NULL, 'G3DSA:2.60.40.10:FF:002692', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(225402, NULL, 'G3DSA:2.40.160.110:FF:000007', NULL, NULL, 'CD68 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(225403, NULL, 'G3DSA:3.40.50.300:FF:004581', NULL, NULL, 'Caspase recruitment domain family member 10', NULL, NULL, NULL, NULL, NULL, 4),
(225404, NULL, 'G3DSA:3.40.50.970:FF:000100', NULL, NULL, 'Putative phosphonopyruvate decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(225405, NULL, 'G3DSA:2.80.10.50:FF:000267', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225406, NULL, 'G3DSA:3.60.21.10:FF:000419', NULL, NULL, 'Sphingomyelin phosphodiesterase, acid-like 3B', NULL, NULL, NULL, NULL, NULL, 4),
(225407, NULL, 'G3DSA:1.20.1070.10:FF:001408', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225408, NULL, 'G3DSA:2.70.130.10:FF:000023', NULL, NULL, 'UPF0577 protein KIAA1324 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(225409, NULL, 'G3DSA:3.40.50.300:FF:006907', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225410, NULL, 'G3DSA:3.30.40.10:FF:002000', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225411, NULL, 'G3DSA:1.10.287.110:FF:000462', NULL, NULL, 'DnaJ homolog 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(225412, NULL, 'G3DSA:2.130.10.10:FF:000871', NULL, NULL, 'Coronin', NULL, NULL, NULL, NULL, NULL, 4),
(225413, NULL, 'G3DSA:2.60.40.60:FF:001043', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(225414, NULL, 'G3DSA:3.20.180.20:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(225415, NULL, 'G3DSA:3.90.260.10:FF:000035', NULL, NULL, 'Protein-glutamine gamma-glutamyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(225416, NULL, 'G3DSA:1.20.58.930:FF:000009', NULL, NULL, 'Arginine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(225417, NULL, 'G3DSA:1.10.510.10:FF:004487', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225418, NULL, 'G3DSA:2.40.70.10:FF:000233', NULL, NULL, 'Acid protease', NULL, NULL, NULL, NULL, NULL, 4),
(225419, NULL, 'G3DSA:2.30.29.30:FF:000222', NULL, NULL, 'amyloid beta A4 precursor protein-binding family A member 3', NULL, NULL, NULL, NULL, NULL, 4),
(225420, NULL, 'G3DSA:3.40.800.20:FF:000029', NULL, NULL, 'Putative histone deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(225421, NULL, 'G3DSA:1.10.510.10:FF:002694', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225422, NULL, 'G3DSA:3.60.21.10:FF:000077', NULL, NULL, 'Sphingomyelin phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(225423, NULL, 'G3DSA:1.10.20.10:FF:000155', NULL, NULL, 'H2A histone family member Y', NULL, NULL, NULL, NULL, NULL, 4),
(225424, NULL, 'G3DSA:3.30.40.10:FF:001376', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225425, NULL, 'G3DSA:1.20.140.10:FF:000078', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(225426, NULL, 'G3DSA:1.10.533.10:FF:000313', NULL, NULL, 'Baculoviral IAP repeat containing 7', NULL, NULL, NULL, NULL, NULL, 4),
(225427, NULL, 'G3DSA:2.60.220.50:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225428, NULL, 'G3DSA:3.40.50.10190:FF:000149', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(225429, NULL, 'G3DSA:1.20.120.1320:FF:000009', NULL, NULL, 'Bifunctional aspartokinase/homoserine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(225430, NULL, 'G3DSA:3.30.360.10:FF:000118', NULL, NULL, 'Probable D-xylose 1-dehydrogenase (NADP(+))', NULL, NULL, NULL, NULL, NULL, 4),
(225431, NULL, 'G3DSA:1.10.238.10:FF:000970', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225432, NULL, 'G3DSA:3.40.190.290:FF:000010', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(225433, NULL, 'G3DSA:3.10.20.90:FF:000792', NULL, NULL, 'F15I1.4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(225434, NULL, 'G3DSA:3.40.50.300:FF:000871', NULL, NULL, 'Chromatin structure-remodeling complex protein SYD', NULL, NULL, NULL, NULL, NULL, 4),
(225435, NULL, 'G3DSA:3.60.21.10:FF:000184', NULL, NULL, 'Ser/thr protein phosphatase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(225436, NULL, 'G3DSA:3.40.50.720:FF:000210', NULL, NULL, 'Gluconate 5-dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(225437, NULL, 'G3DSA:2.10.110.10:FF:000030', NULL, NULL, 'Four and a half LIM domains protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(225438, NULL, 'G3DSA:3.40.1080.10:FF:000015', NULL, NULL, 'GD17454', NULL, NULL, NULL, NULL, NULL, 4),
(225439, NULL, 'G3DSA:3.90.1150.220:FF:000009', NULL, NULL, 'Embryo defective 1379', NULL, NULL, NULL, NULL, NULL, 4),
(225440, NULL, 'G3DSA:3.40.50.300:FF:007577', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225441, NULL, 'G3DSA:3.30.160.60:FF:004608', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225442, NULL, 'G3DSA:3.30.160.60:FF:000831', NULL, NULL, 'Zinc finger and BTB domain-containing protein 17', NULL, NULL, NULL, NULL, NULL, 4),
(225443, NULL, 'G3DSA:3.30.110.40:FF:000002', NULL, NULL, 'Sulfur carrier protein TusA', NULL, NULL, NULL, NULL, NULL, 4),
(225444, NULL, 'G3DSA:2.70.130.10:FF:000074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225445, NULL, 'G3DSA:3.10.20.90:FF:000909', NULL, NULL, 'Ubiquitin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(225446, NULL, 'G3DSA:1.10.510.10:FF:003998', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225447, NULL, 'G3DSA:2.10.25.10:FF:001630', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225448, NULL, 'G3DSA:3.90.740.10:FF:000061', NULL, NULL, 'Isoleucine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(225449, NULL, 'G3DSA:3.40.30.10:FF:000891', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225450, NULL, 'G3DSA:1.10.510.10:FF:000507', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(225451, NULL, 'G3DSA:2.60.40.10:FF:000505', NULL, NULL, 'Bent, isoform J', NULL, NULL, NULL, NULL, NULL, 4),
(225452, NULL, 'G3DSA:3.40.50.10420:FF:000033', NULL, NULL, 'Probable COG0212-type thiamine metabolism protein', NULL, NULL, NULL, NULL, NULL, 4),
(225453, NULL, 'G3DSA:1.20.1070.10:FF:001471', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(225454, NULL, 'G3DSA:3.30.70.330:FF:001937', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225455, NULL, 'G3DSA:2.60.120.590:FF:000003', NULL, NULL, 'alpha-ketoglutarate-dependent dioxygenase alkB homolog 3', NULL, NULL, NULL, NULL, NULL, 4),
(225456, NULL, 'G3DSA:1.10.287.1490:FF:000039', NULL, NULL, 'DNA repair protein Rad50', NULL, NULL, NULL, NULL, NULL, 4),
(225457, NULL, 'G3DSA:3.40.50.1820:FF:001742', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225458, NULL, 'G3DSA:3.40.50.720:FF:000261', NULL, NULL, 'NADPH-dependent 1-acyldihydroxyacetone phosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(225459, NULL, 'G3DSA:1.10.10.60:FF:000860', NULL, NULL, 'Homeotic protein caudal', NULL, NULL, NULL, NULL, NULL, 4),
(225460, NULL, 'G3DSA:3.30.890.10:FF:000023', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225461, NULL, 'G3DSA:1.25.10.10:FF:000216', NULL, NULL, 'Vac14 homolog (S. cerevisiae)', NULL, NULL, NULL, NULL, NULL, 4),
(225462, NULL, 'G3DSA:3.30.160.60:FF:006289', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225463, NULL, 'G3DSA:1.10.3720.10:FF:000219', NULL, NULL, 'Glycine betaine/proline ABC transporter, permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(225464, NULL, 'G3DSA:2.60.40.790:FF:000138', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225465, NULL, 'G3DSA:2.60.40.180:FF:000012', NULL, NULL, '5-hydroxyisourate hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(225466, NULL, 'G3DSA:1.25.40.10:FF:002461', NULL, NULL, 'Kinetoplast_polyadenylation/uridylation_factor_1', NULL, NULL, NULL, NULL, NULL, 4),
(225467, NULL, 'G3DSA:3.10.310.10:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225468, NULL, 'G3DSA:1.20.1300.10:FF:000045', NULL, NULL, 'Succinate dehydrogenase [ubiquinone] cytochrome b small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(225469, NULL, 'G3DSA:3.40.50.2300:FF:000711', NULL, NULL, 'Aliphatic amidase expression-regulating protein', NULL, NULL, NULL, NULL, NULL, 4),
(225470, NULL, 'G3DSA:1.10.220.10:FF:000058', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(225471, NULL, 'G3DSA:2.40.50.100:FF:000023', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(225472, NULL, 'G3DSA:3.90.1490.10:FF:000012', NULL, NULL, 'YALI0F14553p', NULL, NULL, NULL, NULL, NULL, 4),
(225473, NULL, 'G3DSA:3.30.160.60:FF:003597', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225474, NULL, 'G3DSA:3.40.50.300:FF:007925', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225475, NULL, 'G3DSA:3.30.200.20:FF:000840', NULL, NULL, 'Protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(225476, NULL, 'G3DSA:1.10.560.10:FF:000095', NULL, NULL, 'Thermosome, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(225477, NULL, 'G3DSA:1.10.10.60:FF:000023', NULL, NULL, 'protein REVEILLE 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(225478, NULL, 'G3DSA:2.60.120.200:FF:000050', NULL, NULL, 'Adhesion G protein-coupled receptor G6', NULL, NULL, NULL, NULL, NULL, 4),
(225479, NULL, 'G3DSA:1.10.418.10:FF:000063', NULL, NULL, 'Calmin', NULL, NULL, NULL, NULL, NULL, 4),
(225480, NULL, 'G3DSA:3.60.10.10:FF:000395', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(225481, NULL, 'G3DSA:1.10.20.10:FF:000211', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(225482, NULL, 'G3DSA:1.10.472.80:FF:000265', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225483, NULL, 'G3DSA:3.30.9.10:FF:000292', NULL, NULL, 'Sarcosine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(225484, NULL, 'G3DSA:1.20.1070.10:FF:001291', NULL, NULL, 'Dopamine receptor D4a', NULL, NULL, NULL, NULL, NULL, 4),
(225485, NULL, 'G3DSA:2.30.30.30:FF:000023', NULL, NULL, '50S ribosomal protein L24', NULL, NULL, NULL, NULL, NULL, 4),
(225486, NULL, 'G3DSA:3.30.160.60:FF:004086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225487, NULL, 'G3DSA:3.30.160.60:FF:000775', NULL, NULL, 'Zinc finger protein 768', NULL, NULL, NULL, NULL, NULL, 4),
(225488, NULL, 'G3DSA:3.30.40.10:FF:001724', NULL, NULL, 'E3 ubiquitin-protein ligase PEP5', NULL, NULL, NULL, NULL, NULL, 4),
(225489, NULL, 'G3DSA:1.50.40.10:FF:000598', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225490, NULL, 'G3DSA:1.10.167.10:FF:000052', NULL, NULL, 'G protein-coupled receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(225491, NULL, 'G3DSA:2.130.10.10:FF:000601', NULL, NULL, 'Nucleolar protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(225492, NULL, 'G3DSA:3.30.420.10:FF:000668', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225493, NULL, 'G3DSA:1.10.8.60:FF:000275', NULL, NULL, 'Origin of replication complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(225494, NULL, 'G3DSA:1.10.287.4270:FF:000002', NULL, NULL, 'Serine/threonine-protein kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(225495, NULL, 'G3DSA:1.25.40.20:FF:000339', NULL, NULL, 'caskin-2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(225496, NULL, 'G3DSA:1.10.238.10:FF:000425', NULL, NULL, 'Myosin light chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(225497, NULL, 'G3DSA:1.20.140.150:FF:000060', NULL, NULL, 'voltage-dependent calcium channel gamma-7 subunit isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(225498, NULL, 'G3DSA:2.10.25.10:FF:000051', NULL, NULL, 'Laminin subunit alpha 4', NULL, NULL, NULL, NULL, NULL, 4),
(225499, NULL, 'G3DSA:2.60.40.10:FF:003996', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225500, NULL, 'G3DSA:2.30.30.40:FF:000296', NULL, NULL, 'Actin polymerization protein Bzz1', NULL, NULL, NULL, NULL, NULL, 4),
(225501, NULL, 'G3DSA:1.10.533.10:FF:000038', NULL, NULL, 'Caspase 10', NULL, NULL, NULL, NULL, NULL, 4),
(225502, NULL, 'G3DSA:2.60.40.10:FF:002366', NULL, NULL, 'Uncharacterized protein, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(225503, NULL, 'G3DSA:1.10.287.4280:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225504, NULL, 'G3DSA:2.60.40.60:FF:000610', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225505, NULL, 'G3DSA:1.25.40.10:FF:000336', NULL, NULL, 'Poly-beta-1,6 N-acetyl-D-glucosamine export porin PgaA', NULL, NULL, NULL, NULL, NULL, 4),
(225506, NULL, 'G3DSA:3.90.70.10:FF:000425', NULL, NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2', NULL, NULL, NULL, NULL, NULL, 4),
(225507, NULL, 'G3DSA:3.30.200.20:FF:000222', NULL, NULL, 'Serine/threonine-protein kinase psk1', NULL, NULL, NULL, NULL, NULL, 4),
(225508, NULL, 'G3DSA:1.10.10.60:FF:000641', NULL, NULL, 'myb protein', NULL, NULL, NULL, NULL, NULL, 4),
(225509, NULL, 'G3DSA:3.30.160.60:FF:003996', NULL, NULL, 'Protein CBG16748', NULL, NULL, NULL, NULL, NULL, 4),
(225510, NULL, 'G3DSA:2.70.170.10:FF:000295', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225511, NULL, 'G3DSA:3.30.160.60:FF:004760', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225512, NULL, 'G3DSA:1.20.1310.10:FF:000219', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225513, NULL, 'G3DSA:1.20.1600.10:FF:000034', NULL, NULL, 'Outer membrane efflux protein', NULL, NULL, NULL, NULL, NULL, 4),
(225514, NULL, 'G3DSA:3.30.200.20:FF:000492', NULL, NULL, 'probable receptor-like protein kinase At1g11050', NULL, NULL, NULL, NULL, NULL, 4),
(225515, NULL, 'G3DSA:3.40.630.30:FF:000199', NULL, NULL, 'N-acetyltransferase catalytic subunit, putative', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(225516, NULL, 'G3DSA:1.20.1250.20:FF:001454', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225517, NULL, 'G3DSA:2.10.25.10:FF:001411', NULL, NULL, 'Si:ch211-241e1.3', NULL, NULL, NULL, NULL, NULL, 4),
(225518, NULL, 'G3DSA:1.10.10.10:FF:001997', NULL, NULL, 'Rrf2 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(225519, NULL, 'G3DSA:2.160.10.10:FF:000004', NULL, NULL, '2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-succinyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(225520, NULL, 'G3DSA:3.30.160.60:FF:000505', NULL, NULL, 'zinc finger protein 32 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(225521, NULL, 'G3DSA:2.60.40.60:FF:000880', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225522, NULL, 'G3DSA:3.40.50.720:FF:002588', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225523, NULL, 'G3DSA:2.130.10.10:FF:000253', NULL, NULL, 'DDB1- and CUL4-associated factor 12', NULL, NULL, NULL, NULL, NULL, 4),
(225524, NULL, 'G3DSA:3.40.1030.10:FF:000006', NULL, NULL, 'AMP phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(225525, NULL, 'G3DSA:1.10.510.10:FF:000558', NULL, NULL, 'cAMP-dependent protein kinase catalytic subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(225526, NULL, 'G3DSA:1.25.10.10:FF:000834', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225527, NULL, 'G3DSA:2.30.29.30:FF:000003', NULL, NULL, 'Radixin isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(225528, NULL, 'G3DSA:3.30.70.3490:FF:000031', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(225529, NULL, 'G3DSA:3.40.50.300:FF:004429', NULL, NULL, 'Shikimate kinase I', NULL, NULL, NULL, NULL, NULL, 4),
(225530, NULL, 'G3DSA:3.30.70.330:FF:002033', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225531, NULL, 'G3DSA:3.10.20.90:FF:000168', NULL, NULL, 'Regulator of G-protein signaling 12', NULL, NULL, NULL, NULL, NULL, 4),
(225532, NULL, 'G3DSA:2.60.40.10:FF:006076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225533, NULL, 'G3DSA:3.10.20.10:FF:000021', NULL, NULL, '60S ribosomal protein L20', NULL, NULL, NULL, NULL, NULL, 4),
(225534, NULL, 'G3DSA:1.25.40.10:FF:005277', NULL, NULL, 'Phosphatidylinositol 3-kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(225535, NULL, 'G3DSA:1.25.40.10:FF:004607', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225536, NULL, 'G3DSA:2.130.10.10:FF:000652', NULL, NULL, 'Related to VPS15-ser/thr protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(225537, NULL, 'G3DSA:3.30.70.330:FF:001196', NULL, NULL, 'SUPpressor', NULL, NULL, NULL, NULL, NULL, 4),
(225538, NULL, 'G3DSA:1.25.40.20:FF:000491', NULL, NULL, 'ankyrin repeat and KH domain-containing protein 1-like isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(225539, NULL, 'G3DSA:3.40.50.1820:FF:001337', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(225540, NULL, 'G3DSA:1.10.1410.10:FF:000095', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(225541, NULL, 'G3DSA:3.30.565.10:FF:000021', NULL, NULL, 'Heat shock protein 75 kDa, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(225542, NULL, 'G3DSA:1.20.144.10:FF:000137', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(225543, NULL, 'G3DSA:1.25.40.10:FF:001966', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225544, NULL, 'G3DSA:1.20.1250.20:FF:001802', NULL, NULL, 'Solute carrier organic anion transporter family member', NULL, NULL, NULL, NULL, NULL, 4),
(225545, NULL, 'G3DSA:1.20.120.350:FF:000195', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225546, NULL, 'G3DSA:3.90.550.10:FF:000193', NULL, NULL, 'Glycogenin glucosyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(225547, NULL, 'G3DSA:3.40.50.1820:FF:000848', NULL, NULL, 'Dipeptidyl-peptidase 7', NULL, NULL, NULL, NULL, NULL, 4),
(225548, NULL, 'G3DSA:3.40.50.300:FF:008420', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225549, NULL, 'G3DSA:1.20.190.50:FF:000014', NULL, NULL, 'Nuclear pore complex protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(225550, NULL, 'G3DSA:3.15.20.10:FF:000016', NULL, NULL, 'lipopolysaccharide-binding protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(225551, NULL, 'G3DSA:3.90.70.10:FF:000638', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(225552, NULL, 'G3DSA:3.40.50.2000:FF:000161', NULL, NULL, 'UDP-N-acetylglucosamine transferase subunit alg13', NULL, NULL, NULL, NULL, NULL, 4),
(225553, NULL, 'G3DSA:2.130.10.10:FF:000326', NULL, NULL, 'Intraflagellar transport protein 122 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(225554, NULL, 'G3DSA:1.10.3210.30:FF:000001', NULL, NULL, 'CRISPR-associated helicase Cas3', NULL, NULL, NULL, NULL, NULL, 4),
(225555, NULL, 'G3DSA:1.25.40.10:FF:001679', NULL, NULL, 'Pentatricopeptide repeat-containing protein At5g61800', NULL, NULL, NULL, NULL, NULL, 4),
(225556, NULL, 'G3DSA:3.10.290.10:FF:000044', NULL, NULL, '30S ribosomal protein S4e', NULL, NULL, NULL, NULL, NULL, 4),
(225557, NULL, 'G3DSA:3.40.605.10:FF:000028', NULL, NULL, 'NAD-dependent succinate-semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(225558, NULL, 'G3DSA:3.30.160.60:FF:004491', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225559, NULL, 'G3DSA:1.25.10.10:FF:002745', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(225560, NULL, 'G3DSA:1.20.58.220:FF:000004', NULL, NULL, 'Phosphate-specific transport system accessory protein PhoU', NULL, NULL, NULL, NULL, NULL, 4),
(225561, NULL, 'G3DSA:3.40.50.11380:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225562, NULL, 'G3DSA:3.30.1370.10:FF:000101', NULL, NULL, 'Activating signal cointegrator 1 complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(225563, NULL, 'G3DSA:1.10.287.600:FF:000007', NULL, NULL, 'tubulin epsilon chain', NULL, NULL, NULL, NULL, NULL, 4),
(225564, NULL, 'G3DSA:3.40.50.2300:FF:000150', NULL, NULL, 'Two component system response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(225565, NULL, 'G3DSA:2.60.120.40:FF:000062', NULL, NULL, 'Putative uncharacterized protein UNQ5830/PRO19650/PRO19816', NULL, NULL, NULL, NULL, NULL, 4),
(225566, NULL, 'G3DSA:3.40.50.300:FF:002849', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(225567, NULL, 'G3DSA:3.40.140.10:FF:000015', NULL, NULL, 'Lys-63-specific deubiquitinase BRCC36 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(225568, NULL, 'G3DSA:3.40.50.2300:FF:001673', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225569, NULL, 'G3DSA:2.130.10.10:FF:001888', NULL, NULL, 'Probable elongator complex protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(225570, NULL, 'G3DSA:3.30.200.20:FF:000441', NULL, NULL, 'CMGC/SRPK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(225571, NULL, 'G3DSA:2.170.260.10:FF:000025', NULL, NULL, 'Piwi-like protein ergo-1', NULL, NULL, NULL, NULL, NULL, 4),
(225572, NULL, 'G3DSA:1.10.510.10:FF:001401', NULL, NULL, 'Serine/threonine-protein kinase PLK', NULL, NULL, NULL, NULL, NULL, 4),
(225573, NULL, 'G3DSA:1.20.120.790:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225574, NULL, 'G3DSA:3.40.1810.10:FF:000072', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225575, NULL, 'G3DSA:3.40.50.11370:FF:000014', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225576, NULL, 'G3DSA:4.10.60.10:FF:000184', NULL, NULL, 'SON DNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(225577, NULL, 'G3DSA:1.10.10.60:FF:000354', NULL, NULL, 'Double homeobox protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(225578, NULL, 'G3DSA:1.10.510.10:FF:002924', NULL, NULL, 'Probable inactive serine/threonine-protein kinase DDB_G0293184', NULL, NULL, NULL, NULL, NULL, 4),
(225579, NULL, 'G3DSA:1.10.533.10:FF:000077', NULL, NULL, 'Interferon-induced helicase C domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(225580, NULL, 'G3DSA:3.30.70.960:FF:000024', NULL, NULL, 'Mucin 13, cell surface associated', NULL, NULL, NULL, NULL, NULL, 4),
(225581, NULL, 'G3DSA:1.20.120.1750:FF:000059', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(225582, NULL, 'G3DSA:1.10.1050.20:FF:000002', NULL, NULL, 'Telomere length regulator taz1', NULL, NULL, NULL, NULL, NULL, 4),
(225583, NULL, 'G3DSA:3.30.160.60:FF:005103', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225584, NULL, 'G3DSA:3.30.420.40:FF:000716', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225585, NULL, 'G3DSA:1.20.120.620:FF:000011', NULL, NULL, 'Two-component hybrid sensor and regulator', NULL, NULL, NULL, NULL, NULL, 4),
(225586, NULL, 'G3DSA:3.30.40.10:FF:002213', NULL, NULL, 'Chromatin remodeling factor mit1', NULL, NULL, NULL, NULL, NULL, 4),
(225587, NULL, 'G3DSA:1.10.10.60:FF:000298', NULL, NULL, 'Homeobox protein cut-like', NULL, NULL, NULL, NULL, NULL, 4),
(225588, NULL, 'G3DSA:1.10.510.10:FF:004105', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225589, NULL, 'G3DSA:3.30.420.100:FF:000009', NULL, NULL, 'uncharacterized protein LOC106777373 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(225590, NULL, 'G3DSA:2.60.120.10:FF:000569', NULL, NULL, 'Vicilin-like seed storage protein At3g22640', NULL, NULL, NULL, NULL, NULL, 4),
(225591, NULL, 'G3DSA:1.20.120.1070:FF:000007', NULL, NULL, 'Probable translation initiation factor eIF-2B subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(225592, NULL, 'G3DSA:1.20.1090.10:FF:000050', NULL, NULL, '3-dehydroquinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(225593, NULL, 'G3DSA:3.90.1310.10:FF:000022', NULL, NULL, 'Cell division protein ftsI', NULL, NULL, NULL, NULL, NULL, 4),
(225594, NULL, 'G3DSA:1.25.10.10:FF:000660', NULL, NULL, 'Temperature-sensitive Csg2 suppressor', NULL, NULL, NULL, NULL, NULL, 4),
(225595, NULL, 'G3DSA:1.10.510.10:FF:000833', NULL, NULL, 'AGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(225596, NULL, 'G3DSA:1.10.290.10:FF:000006', NULL, NULL, 'DNA topoisomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(225597, NULL, 'G3DSA:1.10.220.10:FF:000019', NULL, NULL, 'Annexin D4', NULL, NULL, NULL, NULL, NULL, 4),
(225598, NULL, 'G3DSA:3.30.60.30:FF:000129', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(225599, NULL, 'G3DSA:4.10.800.10:FF:000024', NULL, NULL, 'CD74 molecule, major histocompatibility complex, class II invariant chain a', NULL, NULL, NULL, NULL, NULL, 4),
(225600, NULL, 'G3DSA:1.20.120.1050:FF:000001', NULL, NULL, 'Nucleoporin NUP170', NULL, NULL, NULL, NULL, NULL, 4),
(225601, NULL, 'G3DSA:2.60.120.260:FF:000202', NULL, NULL, 'Beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(225602, NULL, 'G3DSA:2.160.20.70:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225603, NULL, 'G3DSA:3.20.140.10:FF:000042', NULL, NULL, 'Nicotinate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(225604, NULL, 'G3DSA:1.25.40.20:FF:000485', NULL, NULL, 'Ankyrin repeat domain-containing protein, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(225605, NULL, 'G3DSA:3.30.60.20:FF:000126', NULL, NULL, 'Protein kinase D4', NULL, NULL, NULL, NULL, NULL, 4),
(225606, NULL, 'G3DSA:2.40.70.10:FF:000339', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225607, NULL, 'G3DSA:3.30.160.60:FF:000270', NULL, NULL, 'Zinc finger protein 512', NULL, NULL, NULL, NULL, NULL, 4),
(225608, NULL, 'G3DSA:2.40.30.10:FF:000343', NULL, NULL, 'Elongation factor 1-alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(225609, NULL, 'G3DSA:2.10.25.10:FF:001703', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225610, NULL, 'G3DSA:3.30.160.60:FF:000163', NULL, NULL, 'transcriptional repressor protein YY1', NULL, NULL, NULL, NULL, NULL, 4),
(225611, NULL, 'G3DSA:3.30.160.60:FF:005738', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225612, NULL, 'G3DSA:3.50.7.10:FF:000074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225613, NULL, 'G3DSA:3.90.79.10:FF:000276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225614, NULL, 'G3DSA:1.10.287.1130:FF:000010', NULL, NULL, 'Cytochrome c oxidase copper chaperone, putative', NULL, NULL, NULL, NULL, NULL, 4),
(225615, NULL, 'G3DSA:2.30.42.10:FF:000022', NULL, NULL, 'Glutamate receptor interacting protein 1', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(225616, NULL, 'G3DSA:3.40.50.300:FF:005891', NULL, NULL, 'AAA domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(225617, NULL, 'G3DSA:1.10.10.60:FF:000315', NULL, NULL, 'NK1 homeobox 2', NULL, NULL, NULL, NULL, NULL, 4),
(225618, NULL, 'G3DSA:3.90.1150.10:FF:000144', NULL, NULL, 'Aspartate/methionine/tyrosine aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(225619, NULL, 'G3DSA:3.40.50.1820:FF:001068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225620, NULL, 'G3DSA:2.30.30.40:FF:000638', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(225621, NULL, 'G3DSA:2.30.110.10:FF:000109', NULL, NULL, 'Pyridoxine-5''-phosphate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(225622, NULL, 'G3DSA:3.30.70.330:FF:000740', NULL, NULL, 'RNA binding motif protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(225623, NULL, 'G3DSA:2.60.40.60:FF:000262', NULL, NULL, 'protocadherin-23 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(225624, NULL, 'G3DSA:3.90.1150.10:FF:000200', NULL, NULL, 'Glycine dehydrogenase (decarboxylating)', NULL, NULL, NULL, NULL, NULL, 4),
(225625, NULL, 'G3DSA:1.10.8.10:FF:000288', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225626, NULL, 'G3DSA:2.130.10.10:FF:000365', NULL, NULL, 'WD repeat domain 66', NULL, NULL, NULL, NULL, NULL, 4),
(225627, NULL, 'G3DSA:1.25.40.20:FF:000159', NULL, NULL, 'probable ATP-dependent RNA helicase YTHDC2', NULL, NULL, NULL, NULL, NULL, 4),
(225628, NULL, 'G3DSA:1.10.1070.20:FF:000003', NULL, NULL, 'Serine/threonine-protein kinase CtkA', NULL, NULL, NULL, NULL, NULL, 4),
(225629, NULL, 'G3DSA:1.25.10.10:FF:000508', NULL, NULL, 'Probable helicase mot1', NULL, NULL, NULL, NULL, NULL, 4),
(225630, NULL, 'G3DSA:1.10.238.10:FF:000077', NULL, NULL, 'Centrin 1', NULL, NULL, NULL, NULL, NULL, 4),
(225631, NULL, 'G3DSA:3.40.50.300:FF:002905', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(225632, NULL, 'G3DSA:3.40.50.300:FF:000832', NULL, NULL, 'ADP-ribosylation factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(225633, NULL, 'G3DSA:3.40.50.150:FF:000753', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225634, NULL, 'G3DSA:1.20.5.1180:FF:000004', NULL, NULL, 'geminin', NULL, NULL, NULL, NULL, NULL, 4),
(225635, NULL, 'G3DSA:3.40.50.620:FF:000759', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225636, NULL, 'G3DSA:3.20.20.370:FF:000019', NULL, NULL, 'ChbG/HpnK family deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(225637, NULL, 'G3DSA:3.30.60.30:FF:000242', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225638, NULL, 'G3DSA:3.30.1360.70:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225639, NULL, 'G3DSA:3.30.160.60:FF:004434', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225640, NULL, 'G3DSA:1.25.40.10:FF:000156', NULL, NULL, 'Cytochrome c-type biogenesis protein', NULL, NULL, NULL, NULL, NULL, 4),
(225641, NULL, 'G3DSA:2.60.260.20:FF:000116', NULL, NULL, 'DnaJ heat shock protein family (Hsp40) member B13', NULL, NULL, NULL, NULL, NULL, 4),
(225642, NULL, 'G3DSA:3.40.50.300:FF:000725', NULL, NULL, 'probable ATP-dependent RNA helicase DHX34', NULL, NULL, NULL, NULL, NULL, 4),
(225643, NULL, 'G3DSA:2.60.40.1860:FF:000007', NULL, NULL, 'Peptidyl arginine deiminase, type II', NULL, NULL, NULL, NULL, NULL, 4),
(225644, NULL, 'G3DSA:1.10.287.140:FF:000004', NULL, NULL, 'Glutamate dehydrogenase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(225645, NULL, 'G3DSA:3.40.640.10:FF:000216', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(225646, NULL, 'G3DSA:3.30.460.20:FF:000033', NULL, NULL, 'Cobalt/magnesium transport protein CorA', NULL, NULL, NULL, NULL, NULL, 4),
(225647, NULL, 'G3DSA:1.20.1250.20:FF:000785', NULL, NULL, 'Solute carrier family 29 member 2', NULL, NULL, NULL, NULL, NULL, 4),
(225648, NULL, 'G3DSA:1.25.40.20:FF:001160', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(225649, NULL, 'G3DSA:2.160.10.10:FF:000055', NULL, NULL, 'Probable UDP-3-O-acylglucosamine N-acyltransferase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(225650, NULL, 'G3DSA:3.60.15.10:FF:000074', NULL, NULL, 'Hydroxyacylglutathione hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(225651, NULL, 'G3DSA:3.30.505.50:FF:000006', NULL, NULL, 'Ribosome hibernation promoting factor', NULL, NULL, NULL, NULL, NULL, 4),
(225652, NULL, 'G3DSA:3.80.10.10:FF:003204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225653, NULL, 'G3DSA:1.20.58.670:FF:000010', NULL, NULL, 'Exocyst complex component sec15, putative', NULL, NULL, NULL, NULL, NULL, 4),
(225654, NULL, 'G3DSA:2.170.150.80:FF:000015', NULL, NULL, 'NAC domain-containing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(225655, NULL, 'G3DSA:3.40.140.10:FF:000291', NULL, NULL, 'STAM-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(225656, NULL, 'G3DSA:1.20.5.930:FF:000010', NULL, NULL, 'AT3g08600/F17O14_7', NULL, NULL, NULL, NULL, NULL, 4),
(225657, NULL, 'G3DSA:3.10.20.90:FF:000735', NULL, NULL, 'Ras association domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(225658, NULL, 'G3DSA:1.10.1370.10:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225659, NULL, 'G3DSA:3.90.550.50:FF:000069', NULL, NULL, 'Fringe-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(225660, NULL, 'G3DSA:3.90.550.10:FF:000703', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225661, NULL, 'G3DSA:1.10.287.130:FF:000001', NULL, NULL, 'Two-component sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(225662, NULL, 'G3DSA:3.40.50.12550:FF:000003', NULL, NULL, 'Ubiquitin-activating enzyme E1', NULL, NULL, NULL, NULL, NULL, 4),
(225663, NULL, 'G3DSA:3.30.160.60:FF:002068', NULL, NULL, 'LD31554p', NULL, NULL, NULL, NULL, NULL, 4),
(225664, NULL, 'G3DSA:1.25.40.20:FF:000378', NULL, NULL, 'Ankyrin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(225665, NULL, 'G3DSA:3.30.1490.150:FF:000003', NULL, NULL, 'Uncharacterized protein, PH0010 family/AmmeMemoRadiSam system protein A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(225666, NULL, 'G3DSA:2.120.10.80:FF:000212', NULL, NULL, 'Flagellar outer dynein arm heavy chain alpha', NULL, NULL, NULL, NULL, NULL, 4),
(225667, NULL, 'G3DSA:1.10.1370.30:FF:000046', NULL, NULL, 'Angiotensin-converting enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(225668, NULL, 'G3DSA:1.25.10.10:FF:000328', NULL, NULL, 'Armadillo repeat containing 10', NULL, NULL, NULL, NULL, NULL, 4),
(225669, NULL, 'G3DSA:3.40.50.300:FF:002962', NULL, NULL, 'ATP-dependent DEAD box helicase', NULL, NULL, NULL, NULL, NULL, 4),
(225670, NULL, 'G3DSA:1.10.8.60:FF:000567', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225671, NULL, 'G3DSA:1.25.40.20:FF:001795', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225672, NULL, 'G3DSA:3.40.190.10:FF:000911', NULL, NULL, 'Putative lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(225673, NULL, 'G3DSA:1.10.1070.11:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225674, NULL, 'G3DSA:2.120.10.80:FF:000156', NULL, NULL, 'Kelch domain-containing protein 10 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(225675, NULL, 'G3DSA:1.20.80.30:FF:000001', NULL, NULL, 'Pyruvate, phosphate dikinase', NULL, NULL, NULL, NULL, NULL, 4),
(225676, NULL, 'G3DSA:2.70.170.10:FF:000020', NULL, NULL, 'glutamate-gated chloride channel isoform X12', NULL, NULL, NULL, NULL, NULL, 4),
(225677, NULL, 'G3DSA:3.10.100.10:FF:000261', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225678, NULL, 'G3DSA:1.10.100.10:FF:000010', NULL, NULL, 'GM24840', NULL, NULL, NULL, NULL, NULL, 4),
(225679, NULL, 'G3DSA:3.30.420.610:FF:000005', NULL, NULL, 'Tudor domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(225680, NULL, 'G3DSA:2.60.120.620:FF:000119', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225681, NULL, 'G3DSA:1.20.1070.10:FF:001465', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(225682, NULL, 'G3DSA:3.30.200.20:FF:001745', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225683, NULL, 'G3DSA:3.40.50.2300:FF:001616', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225684, NULL, 'G3DSA:3.30.559.30:FF:000063', NULL, NULL, 'Amino acid adenylation', NULL, NULL, NULL, NULL, NULL, 4),
(225685, NULL, 'G3DSA:1.20.5.1170:FF:000001', NULL, NULL, 'HIT family protein', NULL, NULL, NULL, NULL, NULL, 4),
(225686, NULL, 'G3DSA:3.30.710.10:FF:000134', NULL, NULL, 'Rho related BTB domain containing 2a', NULL, NULL, NULL, NULL, NULL, 4),
(225687, NULL, 'G3DSA:3.30.160.60:FF:002304', NULL, NULL, 'Zinc finger protein 195', NULL, NULL, NULL, NULL, NULL, 4),
(225688, NULL, 'G3DSA:3.40.50.1000:FF:000754', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225689, NULL, 'G3DSA:1.10.3470.10:FF:000003', NULL, NULL, 'Iron ABC transporter permease SitD', NULL, NULL, NULL, NULL, NULL, 4),
(225690, NULL, 'G3DSA:2.60.40.10:FF:005289', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225691, NULL, 'G3DSA:3.30.60.30:FF:000186', NULL, NULL, 'Carrier of wingless, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(225692, NULL, 'G3DSA:3.30.40.10:FF:001432', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225693, NULL, 'G3DSA:3.30.160.60:FF:004378', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225694, NULL, 'G3DSA:3.40.50.12650:FF:000027', NULL, NULL, 'Beta-lactamase superfamily domain/DNA repair metallo-beta-lactamase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(225695, NULL, 'G3DSA:3.40.950.10:FF:000026', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225696, NULL, 'G3DSA:3.30.200.20:FF:000109', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(225697, NULL, 'G3DSA:2.10.110.10:FF:000029', NULL, NULL, 'LIM and senescent cell antigen-like-containing domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(225698, NULL, 'G3DSA:3.40.50.1820:FF:001450', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225699, NULL, 'G3DSA:3.30.420.10:FF:000556', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225700, NULL, 'G3DSA:2.60.120.310:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225701, NULL, 'G3DSA:3.40.50.300:FF:008364', NULL, NULL, 'Protein translocase subunit SecA', NULL, NULL, NULL, NULL, NULL, 4),
(225702, NULL, 'G3DSA:3.30.160.60:FF:004159', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225703, NULL, 'G3DSA:1.20.140.100:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225704, NULL, 'G3DSA:1.10.15.30:FF:000002', NULL, NULL, '50S ribosomal protein L30', NULL, NULL, NULL, NULL, NULL, 4),
(225705, NULL, 'G3DSA:3.30.160.60:FF:002287', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225706, NULL, 'G3DSA:2.60.120.40:FF:000005', NULL, NULL, 'Collagen triple helix repeat', NULL, NULL, NULL, NULL, NULL, 4),
(225707, NULL, 'G3DSA:6.10.10.140:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225708, NULL, 'G3DSA:4.10.900.10:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225709, NULL, 'G3DSA:1.10.1450.10:FF:000041', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(225710, NULL, 'G3DSA:3.80.10.10:FF:001282', NULL, NULL, 'Protein CBG15026', NULL, NULL, NULL, NULL, NULL, 4),
(225711, NULL, 'G3DSA:3.40.50.2300:FF:000037', NULL, NULL, 'Putative metabotropic glutamate receptor 5', NULL, NULL, NULL, NULL, NULL, 4),
(225712, NULL, 'G3DSA:2.60.40.10:FF:002074', NULL, NULL, 'Lymphocyte activating 3', NULL, NULL, NULL, NULL, NULL, 4),
(225713, NULL, 'G3DSA:1.10.1170.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225714, NULL, 'G3DSA:1.10.10.770:FF:000001', NULL, NULL, 'Lysine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(225715, NULL, 'G3DSA:3.40.140.10:FF:000234', NULL, NULL, 'Guanine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(225716, NULL, 'G3DSA:4.10.60.10:FF:000015', NULL, NULL, 'RNA-binding protein 4B isoform X1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(225717, NULL, 'G3DSA:2.130.10.10:FF:004816', NULL, NULL, 'Splicing factor, component of the U4/U6-U5 snRNP complex', NULL, NULL, NULL, NULL, NULL, 4),
(225718, NULL, 'G3DSA:2.170.120.12:FF:000023', NULL, NULL, 'DNA-directed RNA polymerases II IV and V subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(225719, NULL, 'G3DSA:3.40.50.2000:FF:000104', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(225720, NULL, 'G3DSA:1.10.8.270:FF:000140', NULL, NULL, 'RabGAP/TBC domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(225721, NULL, 'G3DSA:2.40.10.10:FF:000510', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225722, NULL, 'G3DSA:3.90.226.10:FF:000158', NULL, NULL, '4-chlorobenzoyl CoA dehalogenase', NULL, NULL, NULL, NULL, NULL, 4),
(225723, NULL, 'G3DSA:1.25.10.10:FF:001003', NULL, NULL, 'BRCA1-associated ATM activator 1', NULL, NULL, NULL, NULL, NULL, 4),
(225724, NULL, 'G3DSA:3.90.70.10:FF:000751', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(225725, NULL, 'G3DSA:3.50.30.30:FF:000138', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225726, NULL, 'G3DSA:3.10.25.10:FF:000009', NULL, NULL, 'Methionyl-tRNA formyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(225727, NULL, 'G3DSA:1.25.10.10:FF:000385', NULL, NULL, 'serine/threonine-protein kinase 36 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(225728, NULL, 'G3DSA:1.20.1250.20:FF:001510', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(225729, NULL, 'G3DSA:1.10.238.10:FF:000133', NULL, NULL, 'Filaggrin', NULL, NULL, NULL, NULL, NULL, 4),
(225730, NULL, 'G3DSA:1.10.132.70:FF:000006', NULL, NULL, 'Telomerase reverse transcriptase', NULL, NULL, NULL, NULL, NULL, 4),
(225731, NULL, 'G3DSA:1.25.40.10:FF:001792', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(225732, NULL, 'G3DSA:1.20.58.390:FF:000196', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225733, NULL, 'G3DSA:2.30.29.30:FF:001239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225734, NULL, 'G3DSA:3.20.20.140:FF:000299', NULL, NULL, 'Dihydroorotase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(225735, NULL, 'G3DSA:1.10.420.10:FF:000006', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(225736, NULL, 'G3DSA:1.20.1250.20:FF:000150', NULL, NULL, 'Solute carrier family 17 member 9', NULL, NULL, NULL, NULL, NULL, 4),
(225737, NULL, 'G3DSA:3.40.50.300:FF:004255', NULL, NULL, 'ATP-dependent Zn protease', NULL, NULL, NULL, NULL, NULL, 4),
(225738, NULL, 'G3DSA:2.30.180.10:FF:000153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225739, NULL, 'G3DSA:2.40.50.1020:FF:000019', NULL, NULL, 'DNA-binding response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(225740, NULL, 'G3DSA:1.10.10.790:FF:000007', NULL, NULL, 'Calcium homeostasis endoplasmic reticulum protein', NULL, NULL, NULL, NULL, NULL, 4),
(225741, NULL, 'G3DSA:1.20.1070.10:FF:001178', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225742, NULL, 'G3DSA:2.40.50.1000:FF:000013', NULL, NULL, '40S ribosomal protein S11-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(225743, NULL, 'G3DSA:3.30.40.10:FF:001488', NULL, NULL, 'RING finger protein 24', NULL, NULL, NULL, NULL, NULL, 4),
(225744, NULL, 'G3DSA:2.130.10.10:FF:002782', NULL, NULL, 'WD repeat and HMG-box DNA-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(225745, NULL, 'G3DSA:1.10.418.10:FF:000231', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225746, NULL, 'G3DSA:3.40.120.10:FF:000014', NULL, NULL, 'Phosphomannomutase/phosphoglucomutase isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(225747, NULL, 'G3DSA:3.40.50.880:FF:000117', NULL, NULL, 'Related to Sno-type pyridoxine vitamin B6 biosynthetic protein SNO1', NULL, NULL, NULL, NULL, NULL, 4),
(225748, NULL, 'G3DSA:2.130.10.10:FF:003979', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225749, NULL, 'G3DSA:3.40.50.2020:FF:000167', NULL, NULL, 'Ribose phosphate pyrophosphokinase NadR', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(225750, NULL, 'G3DSA:2.30.29.30:FF:001296', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225751, NULL, 'G3DSA:3.30.565.10:FF:000526', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225752, NULL, 'G3DSA:1.10.132.60:FF:000003', NULL, NULL, 'DNA polymerase epsilon catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(225753, NULL, 'G3DSA:2.130.10.10:FF:000545', NULL, NULL, 'Xyloglucanase Xgh74A', NULL, NULL, NULL, NULL, NULL, 4),
(225754, NULL, 'G3DSA:1.10.472.130:FF:000036', NULL, NULL, 'Dynein heavy chain 1, cytosolic', NULL, NULL, NULL, NULL, NULL, 4),
(225755, NULL, 'G3DSA:3.40.50.150:FF:000534', NULL, NULL, 'Protein-lysine N-methyltransferase EFM4', NULL, NULL, NULL, NULL, NULL, 4),
(225756, NULL, 'G3DSA:2.60.40.1120:FF:000078', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(225757, NULL, 'G3DSA:1.10.390.10:FF:000065', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225758, NULL, 'G3DSA:3.40.50.300:FF:007689', NULL, NULL, 'Protein-tyrosine sulfotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(225759, NULL, 'G3DSA:3.40.50.880:FF:000174', NULL, NULL, 'Imidazole glycerol phosphate synthase subunit HisH', NULL, NULL, NULL, NULL, NULL, 4),
(225760, NULL, 'G3DSA:2.30.30.140:FF:000292', NULL, NULL, 'Probable ATP-dependent RNA helicase spindle-E', NULL, NULL, NULL, NULL, NULL, 4),
(225761, NULL, 'G3DSA:3.30.70.1170:FF:000004', NULL, NULL, 'probable 28S rRNA (Cytosine-C(5))-methyltransferase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(225762, NULL, 'G3DSA:3.30.420.40:FF:000194', NULL, NULL, 'Actin-related protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(225763, NULL, 'G3DSA:3.40.50.300:FF:000545', NULL, NULL, 'arf-GAP with GTPase, ANK repeat and PH domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(225764, NULL, 'G3DSA:3.40.50.300:FF:006672', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225765, NULL, 'G3DSA:3.10.110.10:FF:000323', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225766, NULL, 'G3DSA:2.60.120.10:FF:000805', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225767, NULL, 'G3DSA:2.60.40.10:FF:000893', NULL, NULL, 'Transmembrane glycoprotein NMB', NULL, NULL, NULL, NULL, NULL, 4),
(225768, NULL, 'G3DSA:1.20.1060.20:FF:000006', NULL, NULL, 'Structural maintenance of chromosomes protein', NULL, NULL, NULL, NULL, NULL, 4),
(225769, NULL, 'G3DSA:1.20.1060.10:FF:000003', NULL, NULL, 'Helicase and polymerase-containing protein TEBICHI', NULL, NULL, NULL, NULL, NULL, 4),
(225770, NULL, 'G3DSA:2.60.120.10:FF:000749', NULL, NULL, 'Cyclic GMP-binding protein D', NULL, NULL, NULL, NULL, NULL, 4),
(225771, NULL, 'G3DSA:2.40.30.270:FF:000030', NULL, NULL, 'DNA replication ATP-dependent helicase/nuclease DNA2-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(225772, NULL, 'G3DSA:3.40.50.300:FF:000489', NULL, NULL, 'Primosome assembly protein PriA', NULL, NULL, NULL, NULL, NULL, 4),
(225773, NULL, 'G3DSA:2.60.40.1730:FF:000109', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225774, NULL, 'G3DSA:2.40.100.10:FF:000056', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(225775, NULL, 'G3DSA:3.40.50.720:FF:001391', NULL, NULL, 'D-amino acid oxidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(225776, NULL, 'G3DSA:3.30.1330.30:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225777, NULL, 'G3DSA:1.10.418.10:FF:000118', NULL, NULL, 'Calponin homology (CH) domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(225778, NULL, 'G3DSA:3.10.100.10:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225779, NULL, 'G3DSA:1.20.58.80:FF:000048', NULL, NULL, 'Katanin p60 ATPase-containing subunit A1', NULL, NULL, NULL, NULL, NULL, 4),
(225780, NULL, 'G3DSA:3.30.519.10:FF:000021', NULL, NULL, 'Rab proteins geranylgeranyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(225781, NULL, 'G3DSA:3.10.110.10:FF:000267', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(225782, NULL, 'G3DSA:2.30.31.10:FF:000008', NULL, NULL, 'AGAP012041-PA', NULL, NULL, NULL, NULL, NULL, 4),
(225783, NULL, 'G3DSA:2.40.30.10:FF:000163', NULL, NULL, 'Ferric reductase transmembrane component 4, variant', NULL, NULL, NULL, NULL, NULL, 4),
(225784, NULL, 'G3DSA:3.80.10.10:FF:003642', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225785, NULL, 'G3DSA:2.40.170.20:FF:000046', NULL, NULL, 'Ferric siderophore receptor protein', NULL, NULL, NULL, NULL, NULL, 4),
(225786, NULL, 'G3DSA:1.20.58.70:FF:000045', NULL, NULL, 'CRE-SYN-13 protein', NULL, NULL, NULL, NULL, NULL, 4),
(225787, NULL, 'G3DSA:3.40.50.12780:FF:000105', NULL, NULL, 'Putative long-chain-fatty-acid-CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(225788, NULL, 'G3DSA:1.25.40.20:FF:000721', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(225789, NULL, 'G3DSA:2.40.50.1060:FF:000003', NULL, NULL, 'DNA-directed RNA polymerase I subunit RPA43', NULL, NULL, NULL, NULL, NULL, 4),
(225790, NULL, 'G3DSA:3.40.30.10:FF:000447', NULL, NULL, 'Protein disulfide-isomerase MPD1', NULL, NULL, NULL, NULL, NULL, 4),
(225791, NULL, 'G3DSA:1.10.8.270:FF:000027', NULL, NULL, 'Growth hormone regulated TBC protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(225792, NULL, 'G3DSA:3.80.20.20:FF:000094', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(225793, NULL, 'G3DSA:1.20.120.680:FF:000001', NULL, NULL, 'Formimidoyltransferase cyclodeaminase', NULL, NULL, NULL, NULL, NULL, 4),
(225794, NULL, 'G3DSA:3.30.420.40:FF:000211', NULL, NULL, 'Phosphotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(225795, NULL, 'G3DSA:2.130.10.10:FF:002344', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225796, NULL, 'G3DSA:2.20.28.120:FF:000009', NULL, NULL, '50S ribosomal protein L33', NULL, NULL, NULL, NULL, NULL, 4),
(225797, NULL, 'G3DSA:2.120.10.30:FF:000512', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225798, NULL, 'G3DSA:3.30.160.60:FF:002809', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225799, NULL, 'G3DSA:3.30.450.190:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225800, NULL, 'G3DSA:1.10.630.10:FF:000781', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225801, NULL, 'G3DSA:2.60.40.10:FF:004165', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225802, NULL, 'G3DSA:3.40.50.300:FF:004873', NULL, NULL, 'Vesicular-fusion protein SEC18, putative', NULL, NULL, NULL, NULL, NULL, 4),
(225803, NULL, 'G3DSA:2.10.25.10:FF:001068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225804, NULL, 'G3DSA:2.70.150.10:FF:000018', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(225805, NULL, 'G3DSA:3.90.960.10:FF:000004', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(225806, NULL, 'G3DSA:3.30.420.150:FF:000002', NULL, NULL, 'Ectonucleoside triphosphate diphosphohydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(225807, NULL, 'G3DSA:1.20.5.340:FF:000108', NULL, NULL, 'Atrial myosin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(225808, NULL, 'G3DSA:3.30.160.60:FF:002523', NULL, NULL, 'Zinc finger protein 484', NULL, NULL, NULL, NULL, NULL, 4),
(225809, NULL, 'G3DSA:3.20.20.150:FF:000015', NULL, NULL, '2-keto-myo-inositol isomerase IolI2', NULL, NULL, NULL, NULL, NULL, 4),
(225810, NULL, 'G3DSA:3.30.160.60:FF:004721', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225811, NULL, 'G3DSA:1.20.1270.280:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225812, NULL, 'G3DSA:3.30.70.330:FF:001426', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225813, NULL, 'G3DSA:2.30.130.40:FF:000035', NULL, NULL, 'Lon protease homolog', NULL, NULL, NULL, NULL, NULL, 4),
(225814, NULL, 'G3DSA:3.30.160.60:FF:002580', NULL, NULL, 'protein krueppel', NULL, NULL, NULL, NULL, NULL, 4),
(225815, NULL, 'G3DSA:3.30.413.10:FF:000011', NULL, NULL, 'Anaerobic sulfite reductase subunit AsrC', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(225816, NULL, 'G3DSA:1.25.10.10:FF:001964', NULL, NULL, 'ARMADILLO BTB ARABIDOPSIS PROTEIN 1', NULL, NULL, NULL, NULL, NULL, 4),
(225817, NULL, 'G3DSA:3.10.450.240:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225818, NULL, 'G3DSA:3.30.160.60:FF:002922', NULL, NULL, 'Transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(225819, NULL, 'G3DSA:2.60.40.150:FF:000183', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(225820, NULL, 'G3DSA:3.40.50.300:FF:002344', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(225821, NULL, 'G3DSA:1.10.418.10:FF:000175', NULL, NULL, 'Kinesin-like protein KIN-14G isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(225822, NULL, 'G3DSA:3.40.50.300:FF:006273', NULL, NULL, 'Ras homolog family member T1', NULL, NULL, NULL, NULL, NULL, 4),
(225823, NULL, 'G3DSA:1.10.8.270:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225824, NULL, 'G3DSA:1.10.760.10:FF:000043', NULL, NULL, 'Probable c-type cytochrome', NULL, NULL, NULL, NULL, NULL, 4),
(225825, NULL, 'G3DSA:1.10.510.10:FF:002363', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225826, NULL, 'G3DSA:2.20.50.20:FF:000005', NULL, NULL, 'Vitellogenin 3', NULL, NULL, NULL, NULL, NULL, 4),
(225827, NULL, 'G3DSA:1.20.1250.20:FF:001509', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225828, NULL, 'G3DSA:1.20.1250.20:FF:001566', NULL, NULL, 'synaptic vesicular amine transporter-like', NULL, NULL, NULL, NULL, NULL, 4),
(225829, NULL, 'G3DSA:1.20.5.470:FF:000006', NULL, NULL, 'Argininosuccinate synthase 1', NULL, NULL, NULL, NULL, NULL, 4),
(225830, NULL, 'G3DSA:3.30.230.10:FF:000221', NULL, NULL, 'DNA topoisomerase (ATP-hydrolyzing)', NULL, NULL, NULL, NULL, NULL, 4),
(225831, NULL, 'G3DSA:2.60.40.420:FF:000011', NULL, NULL, 'Coagulation factor VIII (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(225832, NULL, 'G3DSA:1.20.5.930:FF:000009', NULL, NULL, 'integrin alpha-PS2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(225833, NULL, 'G3DSA:2.70.98.110:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225834, NULL, 'G3DSA:3.10.490.10:FF:000025', NULL, NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase-like', NULL, NULL, NULL, NULL, NULL, 4),
(225835, NULL, 'G3DSA:3.40.50.300:FF:004474', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225836, NULL, 'G3DSA:1.25.50.20:FF:000109', NULL, NULL, 'Aminopeptidase A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(225837, NULL, 'G3DSA:2.10.25.10:FF:001181', NULL, NULL, 'Thyroid peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(225838, NULL, 'G3DSA:1.10.520.10:FF:000059', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(225839, NULL, 'G3DSA:3.30.2310.20:FF:000005', NULL, NULL, 'Addiction module toxin, Txe/YoeB family', NULL, NULL, NULL, NULL, NULL, 4),
(225840, NULL, 'G3DSA:1.10.3430.10:FF:000006', NULL, NULL, 'Ammonium transporter', NULL, NULL, NULL, NULL, NULL, 4),
(225841, NULL, 'G3DSA:2.130.10.10:FF:003799', NULL, NULL, 'Probable cytosolic iron-sulfur protein assembly protein CIAO1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(225842, NULL, 'G3DSA:3.40.850.10:FF:000030', NULL, NULL, 'unconventional myosin-VI isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(225843, NULL, 'G3DSA:1.20.1070.10:FF:000161', NULL, NULL, 'type-2 angiotensin II receptor', NULL, NULL, NULL, NULL, NULL, 4),
(225844, NULL, 'G3DSA:3.30.2310.10:FF:000002', NULL, NULL, 'tRNA methyltransferase O', NULL, NULL, NULL, NULL, NULL, 4),
(225845, NULL, 'G3DSA:2.130.10.10:FF:002400', NULL, NULL, 'Protein CBG10826', NULL, NULL, NULL, NULL, NULL, 4),
(225846, NULL, 'G3DSA:1.20.120.1200:FF:000030', NULL, NULL, 'NADH-ubiquinone oxidoreductase chain 6', NULL, NULL, NULL, NULL, NULL, 4),
(225847, NULL, 'G3DSA:2.40.10.10:FF:000454', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225848, NULL, 'G3DSA:3.10.490.20:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(225849, NULL, 'G3DSA:2.30.29.30:FF:001077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225850, NULL, 'G3DSA:2.10.110.10:FF:000361', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225851, NULL, 'G3DSA:3.20.20.80:FF:000030', NULL, NULL, 'Lysosomal acid glucosylceramidase', NULL, NULL, NULL, NULL, NULL, 4),
(225852, NULL, 'G3DSA:3.30.930.10:FF:000078', NULL, NULL, 'Seryl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(225853, NULL, 'G3DSA:2.40.50.140:FF:000170', NULL, NULL, 'SPOUT domain containing methyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(225854, NULL, 'G3DSA:1.10.1420.10:FF:000157', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225855, NULL, 'G3DSA:2.20.28.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225856, NULL, 'G3DSA:2.130.10.10:FF:004075', NULL, NULL, 'WD domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(225857, NULL, 'G3DSA:2.130.10.10:FF:001669', NULL, NULL, 'WD repeat domain 27', NULL, NULL, NULL, NULL, NULL, 4),
(225858, NULL, 'G3DSA:1.10.10.10:FF:000710', NULL, NULL, 'Transcription factor E', NULL, NULL, NULL, NULL, NULL, 4),
(225859, NULL, 'G3DSA:2.60.40.3210:FF:000008', NULL, NULL, 'Transforming growth factor beta receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(225860, NULL, 'G3DSA:3.40.50.300:FF:006615', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(225861, NULL, 'G3DSA:2.60.40.150:FF:000525', NULL, NULL, 'Translocation protein sec63', NULL, NULL, NULL, NULL, NULL, 4),
(225862, NULL, 'G3DSA:2.40.70.10:FF:000340', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225863, NULL, 'G3DSA:2.60.120.290:FF:000088', NULL, NULL, 'CBN-EAT-18 protein', NULL, NULL, NULL, NULL, NULL, 4),
(225864, NULL, 'G3DSA:1.20.120.1750:FF:000060', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(225865, NULL, 'G3DSA:3.30.310.50:FF:000043', NULL, NULL, 'Phosphoglucomutase/phosphomannomutase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(225866, NULL, 'G3DSA:2.30.30.1020:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225867, NULL, 'G3DSA:3.40.50.150:FF:000298', NULL, NULL, 'Methyltransferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(225868, NULL, 'G3DSA:1.10.10.10:FF:000654', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(225869, NULL, 'G3DSA:3.40.395.10:FF:000027', NULL, NULL, 'SUMO-specific peptidase 6', NULL, NULL, NULL, NULL, NULL, 4),
(225870, NULL, 'G3DSA:3.30.70.1230:FF:000270', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225871, NULL, 'G3DSA:3.30.160.60:FF:002248', NULL, NULL, 'Zinc finger and BTB domain-containing 40', NULL, NULL, NULL, NULL, NULL, 4),
(225872, NULL, 'G3DSA:3.40.50.300:FF:005778', NULL, NULL, 'monofunctional C1-tetrahydrofolate synthase, mitochondrial isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(225873, NULL, 'G3DSA:1.10.287.2250:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225874, NULL, 'G3DSA:1.10.472.130:FF:000075', NULL, NULL, 'Dynein heavy chain 8', NULL, NULL, NULL, NULL, NULL, 4),
(225875, NULL, 'G3DSA:3.30.390.150:FF:000004', NULL, NULL, 'Gastrokine 2', NULL, NULL, NULL, NULL, NULL, 4),
(225876, NULL, 'G3DSA:3.30.310.130:FF:000005', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(225877, NULL, 'G3DSA:1.10.472.10:FF:000339', NULL, NULL, 'G1/S-specific cyclin CCN1', NULL, NULL, NULL, NULL, NULL, 4),
(225878, NULL, 'G3DSA:2.70.150.10:FF:000237', NULL, NULL, 'Copper-transporting ATPase ccc2', NULL, NULL, NULL, NULL, NULL, 4),
(225879, NULL, 'G3DSA:3.40.50.720:FF:001239', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(225880, NULL, 'G3DSA:3.80.10.10:FF:001169', NULL, NULL, 'LRR receptor-like serine/threonine-protein kinase FLS2', NULL, NULL, NULL, NULL, NULL, 4),
(225881, NULL, 'G3DSA:2.60.120.970:FF:000084', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(225882, NULL, 'G3DSA:3.30.70.330:FF:000066', NULL, NULL, 'Splicing factor u2af 23 kDa subunit', NULL, NULL, NULL, NULL, NULL, 4),
(225883, NULL, 'G3DSA:1.25.40.10:FF:002573', NULL, NULL, 'Tetratricopeptide repeat protein 30A2', NULL, NULL, NULL, NULL, NULL, 4),
(225884, NULL, 'G3DSA:2.60.120.920:FF:000108', NULL, NULL, 'Tripartite motif-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(225885, NULL, 'G3DSA:3.80.10.10:FF:003081', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225886, NULL, 'G3DSA:3.30.160.60:FF:006233', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225887, NULL, 'G3DSA:1.20.5.340:FF:000041', NULL, NULL, 'Moz represents a chromatin-associated acetyltransferase protein', NULL, NULL, NULL, NULL, NULL, 4),
(225888, NULL, 'G3DSA:3.30.160.60:FF:006177', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225889, NULL, 'G3DSA:3.30.9.20:FF:000002', NULL, NULL, 'Anthraniloyl-CoA monooxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(225890, NULL, 'G3DSA:3.30.70.1350:FF:000013', NULL, NULL, 'Cobalt-zinc-cadmium resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(225891, NULL, 'G3DSA:1.25.10.10:FF:002127', NULL, NULL, 'Coatomer subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(225892, NULL, 'G3DSA:3.30.830.10:FF:000188', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225893, NULL, 'G3DSA:2.40.50.140:FF:000512', NULL, NULL, 'Single-stranded DNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(225894, NULL, 'G3DSA:1.20.1250.20:FF:002061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225895, NULL, 'G3DSA:1.10.1420.10:FF:000213', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225896, NULL, 'G3DSA:4.10.860.10:FF:000022', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225897, NULL, 'G3DSA:1.25.10.10:FF:002184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225898, NULL, 'G3DSA:2.30.30.100:FF:000015', NULL, NULL, 'Small nuclear ribonucleoprotein Sm D2', NULL, NULL, NULL, NULL, NULL, 4),
(225899, NULL, 'G3DSA:3.20.20.70:FF:000437', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(225900, NULL, 'G3DSA:2.60.40.10:FF:000617', NULL, NULL, 'Immunoglobulin-like and fibronectin type III domain-containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(225901, NULL, 'G3DSA:2.10.220.10:FF:000190', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225902, NULL, 'G3DSA:1.25.10.10:FF:002307', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(225903, NULL, 'G3DSA:1.20.1250.20:FF:001785', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(225904, NULL, 'G3DSA:1.20.1020.10:FF:000006', NULL, NULL, 'Histone acetyltransferase of the CBP family 12', NULL, NULL, NULL, NULL, NULL, 4),
(225905, NULL, 'G3DSA:3.60.15.10:FF:000130', NULL, NULL, 'Metallo-beta-lactamase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(225906, NULL, 'G3DSA:3.40.50.300:FF:004199', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH homolog', NULL, NULL, NULL, NULL, NULL, 4),
(225907, NULL, 'G3DSA:1.10.3120.10:FF:000016', NULL, NULL, 'Trigger factor', NULL, NULL, NULL, NULL, NULL, 4),
(225908, NULL, 'G3DSA:3.40.50.300:FF:006054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225909, NULL, 'G3DSA:2.30.29.30:FF:001352', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225910, NULL, 'G3DSA:1.10.510.10:FF:002183', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225911, NULL, 'G3DSA:1.10.472.10:FF:000053', NULL, NULL, 'Cyclin-G1', NULL, NULL, NULL, NULL, NULL, 4),
(225912, NULL, 'G3DSA:3.40.50.10900:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225913, NULL, 'G3DSA:2.30.30.140:FF:000179', NULL, NULL, 'E3 ubiquitin-protein ligase UHRF1', NULL, NULL, NULL, NULL, NULL, 4),
(225914, NULL, 'G3DSA:2.30.29.30:FF:000857', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(225915, NULL, 'G3DSA:2.60.40.10:FF:000674', NULL, NULL, 'Immunoglobulin superfamily member 3', NULL, NULL, NULL, NULL, NULL, 4),
(225916, NULL, 'G3DSA:3.30.70.330:FF:000009', NULL, NULL, 'cytoplasmic polyadenylation element-binding protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(225917, NULL, 'G3DSA:3.40.30.10:FF:000560', NULL, NULL, 'Thiol-disulfide oxidoreductase LTO1', NULL, NULL, NULL, NULL, NULL, 4),
(225918, NULL, 'G3DSA:2.40.50.580:FF:000003', NULL, NULL, 'Sugar fermentation stimulation protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(225919, NULL, 'G3DSA:1.10.730.10:FF:000215', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225920, NULL, 'G3DSA:3.60.10.10:FF:000102', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(225921, NULL, 'G3DSA:2.170.270.10:FF:000144', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225922, NULL, 'G3DSA:3.30.530.20:FF:000207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225923, NULL, 'G3DSA:3.40.50.720:FF:001458', NULL, NULL, 'UDP-glucose 4-epimerase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(225924, NULL, 'G3DSA:2.60.120.650:FF:000050', NULL, NULL, 'Putative jumonji-like transcription factor family protein', NULL, NULL, NULL, NULL, NULL, 4),
(225925, NULL, 'G3DSA:1.20.120.1760:FF:000006', NULL, NULL, 'Putative ethanolaminephosphotransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(225926, NULL, 'G3DSA:3.20.20.70:FF:000836', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225927, NULL, 'G3DSA:1.20.58.70:FF:000006', NULL, NULL, 'Syntaxin 7', NULL, NULL, NULL, NULL, NULL, 4),
(225928, NULL, 'G3DSA:1.25.40.10:FF:003591', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(225929, NULL, 'G3DSA:2.130.10.10:FF:006054', NULL, NULL, 'Dactylin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(225930, NULL, 'G3DSA:2.30.42.10:FF:000202', NULL, NULL, 'Protease Do-like 1, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(225931, NULL, 'G3DSA:3.30.420.40:FF:000155', NULL, NULL, 'Autoinducer-2 kinase', NULL, NULL, NULL, NULL, NULL, 4),
(225932, NULL, 'G3DSA:3.30.200.20:FF:002526', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225933, NULL, 'G3DSA:1.20.58.60:FF:000003', NULL, NULL, 'Actinin, alpha 1', NULL, NULL, NULL, NULL, NULL, 4),
(225934, NULL, 'G3DSA:2.60.40.150:FF:000705', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(225935, NULL, 'G3DSA:2.70.150.10:FF:000294', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225936, NULL, 'G3DSA:1.20.120.1750:FF:000003', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(225937, NULL, 'G3DSA:3.40.50.1000:FF:000810', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225938, NULL, 'G3DSA:2.40.128.180:FF:000002', NULL, NULL, 'Fas apoptotic inhibitory molecule 1', NULL, NULL, NULL, NULL, NULL, 4),
(225939, NULL, 'G3DSA:2.80.10.50:FF:000155', NULL, NULL, 'Cysteine protease inhibitor WSCP', NULL, NULL, NULL, NULL, NULL, 4),
(225940, NULL, 'G3DSA:2.60.40.420:FF:000230', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(225941, NULL, 'G3DSA:3.90.190.10:FF:000619', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225942, NULL, 'G3DSA:1.10.10.10:FF:000036', NULL, NULL, 'Fatty acid metabolism regulator protein', NULL, NULL, NULL, NULL, NULL, 4),
(225943, NULL, 'G3DSA:3.40.1110.10:FF:000395', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225944, NULL, 'G3DSA:3.10.180.10:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225945, NULL, 'G3DSA:3.40.50.2300:FF:001493', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225946, NULL, 'G3DSA:3.30.9.30:FF:000005', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(225947, NULL, 'G3DSA:1.20.120.420:FF:000007', NULL, NULL, 'Methylthioribose-1-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(225948, NULL, 'G3DSA:3.30.870.10:FF:000022', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(225949, NULL, 'G3DSA:1.20.870.10:FF:000037', NULL, NULL, 'Cyclic GMP-binding protein D', NULL, NULL, NULL, NULL, NULL, 4),
(225950, NULL, 'G3DSA:1.10.3730.20:FF:000049', NULL, NULL, 'Multidrug resistance protein', NULL, NULL, NULL, NULL, NULL, 4),
(225951, NULL, 'G3DSA:3.10.100.10:FF:000441', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225952, NULL, 'G3DSA:2.160.20.10:FF:000117', NULL, NULL, 'Tail spike protein', NULL, NULL, NULL, NULL, NULL, 4),
(225953, NULL, 'G3DSA:3.30.70.330:FF:000408', NULL, NULL, 'Transcription initiation factor TFIID subunit 15-like', NULL, NULL, NULL, NULL, NULL, 4),
(225954, NULL, 'G3DSA:3.40.640.10:FF:000435', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(225955, NULL, 'G3DSA:3.20.80.10:FF:000058', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(225956, NULL, 'G3DSA:3.30.60.60:FF:000003', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(225957, NULL, 'G3DSA:1.10.10.10:FF:000093', NULL, NULL, 'Putative interferon regulatory factor 6', NULL, NULL, NULL, NULL, NULL, 4),
(225958, NULL, 'G3DSA:3.40.50.150:FF:000573', NULL, NULL, 'Sphingolipid C9-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(225959, NULL, 'G3DSA:1.10.472.10:FF:000671', NULL, NULL, 'Retinoblastoma-like 2 (p130)', NULL, NULL, NULL, NULL, NULL, 4),
(225960, NULL, 'G3DSA:3.40.50.300:FF:001849', NULL, NULL, 'Helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(225961, NULL, 'G3DSA:3.30.200.20:FF:001689', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225962, NULL, 'G3DSA:1.50.40.10:FF:000542', NULL, NULL, 'Probable mitochondrial 2-oxodicarboxylate carrier', NULL, NULL, NULL, NULL, NULL, 4),
(225963, NULL, 'G3DSA:2.60.40.10:FF:000275', NULL, NULL, 'fibronectin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(225964, NULL, 'G3DSA:1.10.630.10:FF:000449', NULL, NULL, 'Cytochrome P-450 IIC5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(225965, NULL, 'G3DSA:2.30.30.40:FF:000195', NULL, NULL, 'epidermal growth factor receptor kinase substrate 8-like protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(225966, NULL, 'G3DSA:2.40.30.180:FF:000003', NULL, NULL, 'Ubiquitin-activating enzyme E1', NULL, NULL, NULL, NULL, NULL, 4),
(225967, NULL, 'G3DSA:4.10.280.10:FF:000079', NULL, NULL, 'CLUMA_CG001539, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(225968, NULL, 'G3DSA:3.30.70.330:FF:001971', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225969, NULL, 'G3DSA:3.10.110.10:FF:000211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225970, NULL, 'G3DSA:2.40.160.120:FF:000033', NULL, NULL, 'Oxysterol-binding protein-related protein 3B', NULL, NULL, NULL, NULL, NULL, 4),
(225971, NULL, 'G3DSA:3.30.1120.10:FF:000044', NULL, NULL, 'Arylsulfatase A', NULL, NULL, NULL, NULL, NULL, 4),
(225972, NULL, 'G3DSA:2.40.160.110:FF:000030', NULL, NULL, 'ATPase H+ transporting accessory protein 1 like', NULL, NULL, NULL, NULL, NULL, 4),
(225973, NULL, 'G3DSA:2.70.98.10:FF:000082', NULL, NULL, 'Glucans biosynthesis protein G 2', NULL, NULL, NULL, NULL, NULL, 4),
(225974, NULL, 'G3DSA:3.40.50.300:FF:006790', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225975, NULL, 'G3DSA:2.40.30.10:FF:000039', NULL, NULL, 'U32 family peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(225976, NULL, 'G3DSA:3.30.300.180:FF:000012', NULL, NULL, 'Chromosomal replication initiator protein DnaA 1', NULL, NULL, NULL, NULL, NULL, 4),
(225977, NULL, 'G3DSA:1.10.510.10:FF:000485', NULL, NULL, 'testis-specific serine/threonine-protein kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(225978, NULL, 'G3DSA:3.40.390.10:FF:000016', NULL, NULL, 'Matrix metallopeptidase 17', NULL, NULL, NULL, NULL, NULL, 4),
(225979, NULL, 'G3DSA:1.25.40.340:FF:000003', NULL, NULL, 'Dihydroxyacetone kinase subunit DhaL', NULL, NULL, NULL, NULL, NULL, 4),
(225980, NULL, 'G3DSA:1.20.120.350:FF:000228', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225981, NULL, 'G3DSA:1.20.120.980:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(225982, NULL, 'G3DSA:3.40.800.20:FF:000018', NULL, NULL, 'Histone deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(225983, NULL, 'G3DSA:3.40.50.2000:FF:000503', NULL, NULL, 'Lipopolysaccharide heptosyltransferase I', NULL, NULL, NULL, NULL, NULL, 4),
(225984, NULL, 'G3DSA:2.60.40.1120:FF:000016', NULL, NULL, 'carboxypeptidase D isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(225985, NULL, 'G3DSA:2.130.10.10:FF:005941', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225986, NULL, 'G3DSA:2.60.40.2690:FF:000009', NULL, NULL, 'Splicing factor 3A subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(225987, NULL, 'G3DSA:1.20.5.170:FF:000198', NULL, NULL, 'BZIP transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(225988, NULL, 'G3DSA:3.30.1140.60:FF:000009', NULL, NULL, 'F-actin-capping protein subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(225989, NULL, 'G3DSA:1.10.238.10:FF:001032', NULL, NULL, 'Cardiac myosin light chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(225990, NULL, 'G3DSA:3.30.160.60:FF:000562', NULL, NULL, 'Zinc finger protein 786', NULL, NULL, NULL, NULL, NULL, 4),
(225991, NULL, 'G3DSA:1.10.510.10:FF:004184', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(225992, NULL, 'G3DSA:3.90.470.20:FF:000060', NULL, NULL, 'L-aminoadipate-semialdehyde dehydrogenase-phosphopantetheinyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(225993, NULL, 'G3DSA:3.90.70.10:FF:000880', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(225994, NULL, 'G3DSA:3.40.309.10:FF:000042', NULL, NULL, 'Aldehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(225995, NULL, 'G3DSA:1.10.20.10:FF:000177', NULL, NULL, 'Histone H3', NULL, NULL, NULL, NULL, NULL, 4),
(225996, NULL, 'G3DSA:3.80.20.20:FF:000032', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(225997, NULL, 'G3DSA:1.10.10.10:FF:000249', NULL, NULL, 'Transcriptional regulator, LysR family', NULL, NULL, NULL, NULL, NULL, 4),
(225998, NULL, 'G3DSA:3.90.1600.10:FF:000016', NULL, NULL, 'DNA polymerase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(225999, NULL, 'G3DSA:3.30.160.60:FF:004294', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226000, NULL, 'G3DSA:3.90.550.50:FF:000120', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226001, NULL, 'G3DSA:3.40.50.12650:FF:000022', NULL, NULL, 'Pso2p', NULL, NULL, NULL, NULL, NULL, 4),
(226002, NULL, 'G3DSA:3.30.160.60:FF:004305', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226003, NULL, 'G3DSA:3.30.200.20:FF:001734', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226004, NULL, 'G3DSA:1.20.1070.10:FF:001375', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226005, NULL, 'G3DSA:1.10.150.20:FF:000033', NULL, NULL, 'TfoX family protein', NULL, NULL, NULL, NULL, NULL, 4),
(226006, NULL, 'G3DSA:3.80.10.10:FF:003283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226007, NULL, 'G3DSA:3.30.230.10:FF:000131', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(226008, NULL, 'G3DSA:3.30.1050.10:FF:000015', NULL, NULL, 'Non-specific lipid-transfer protein-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(226009, NULL, 'G3DSA:1.25.40.20:FF:000362', NULL, NULL, 'Ankyrin repeat and SOCS box containing 6', NULL, NULL, NULL, NULL, NULL, 4),
(226010, NULL, 'G3DSA:3.90.1170.50:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226011, NULL, 'G3DSA:3.40.50.300:FF:006801', NULL, NULL, 'Origin recognition complex subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(226012, NULL, 'G3DSA:1.25.40.10:FF:003585', NULL, NULL, 'histone demethylase UTY', NULL, NULL, NULL, NULL, NULL, 4),
(226013, NULL, 'G3DSA:3.30.200.20:FF:000632', NULL, NULL, 'MSP', NULL, NULL, NULL, NULL, NULL, 4),
(226014, NULL, 'G3DSA:3.30.830.10:FF:000334', NULL, NULL, 'Os01g0779100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(226015, NULL, 'G3DSA:1.20.5.110:FF:000287', NULL, NULL, 'Os06g0223000 protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(226016, NULL, 'G3DSA:1.10.1740.10:FF:000029', NULL, NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(226017, NULL, 'G3DSA:1.10.287.110:FF:000377', NULL, NULL, 'DNAJ heat shock N-terminal domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(226018, NULL, 'G3DSA:2.60.34.10:FF:000070', NULL, NULL, 'Actin-like ATPase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(226019, NULL, 'G3DSA:2.30.30.40:FF:000239', NULL, NULL, 'NCK interacting protein with SH3 domain', NULL, NULL, NULL, NULL, NULL, 4),
(226020, NULL, 'G3DSA:3.40.800.10:FF:000015', NULL, NULL, 'Formimidoylglutamase', NULL, NULL, NULL, NULL, NULL, 4),
(226021, NULL, 'G3DSA:1.10.150.780:FF:000005', NULL, NULL, 'Vacuolar protein sorting complex subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(226022, NULL, 'G3DSA:2.40.50.690:FF:000031', NULL, NULL, 'Salivary protein Is3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(226023, NULL, 'G3DSA:1.20.1310.10:FF:000146', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226024, NULL, 'G3DSA:3.30.160.60:FF:000606', NULL, NULL, 'C2H2 transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(226025, NULL, 'G3DSA:1.10.10.60:FF:000124', NULL, NULL, 'Orthopedia homeobox b', NULL, NULL, NULL, NULL, NULL, 4),
(226026, NULL, 'G3DSA:3.30.1140.40:FF:000003', NULL, NULL, 'tctex1 domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(226027, NULL, 'G3DSA:3.10.20.90:FF:000825', NULL, NULL, 'Ubiquitin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(226028, NULL, 'G3DSA:2.40.150.20:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226029, NULL, 'G3DSA:2.120.10.30:FF:000169', NULL, NULL, 'tripartite motif-containing protein 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(226030, NULL, 'G3DSA:3.30.1490.100:FF:000016', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(226031, NULL, 'G3DSA:1.20.1740.10:FF:000179', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226032, NULL, 'G3DSA:1.20.1720.10:FF:000020', NULL, NULL, 'Probable triacylglyceride transporter BCG_1471c', NULL, NULL, NULL, NULL, NULL, 4),
(226033, NULL, 'G3DSA:1.10.10.60:FF:000803', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226034, NULL, 'G3DSA:3.30.200.20:FF:000306', NULL, NULL, 'IKS protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(226035, NULL, 'G3DSA:2.130.10.10:FF:000135', NULL, NULL, 'Apoptotic protease-activating factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(226036, NULL, 'G3DSA:3.40.50.880:FF:000207', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226037, NULL, 'G3DSA:2.30.42.10:FF:000314', NULL, NULL, 'Carboxy-terminal processing protease', NULL, NULL, NULL, NULL, NULL, 4),
(226038, NULL, 'G3DSA:3.30.420.40:FF:000519', NULL, NULL, 'Actin-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(226039, NULL, 'G3DSA:2.70.98.60:FF:000001', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(226040, NULL, 'G3DSA:1.20.58.70:FF:000124', NULL, NULL, 'Syntaxin-22', NULL, NULL, NULL, NULL, NULL, 4),
(226041, NULL, 'G3DSA:3.30.450.30:FF:000018', NULL, NULL, 'Mitogen-activated protein kinase kinase 1 interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(226042, NULL, 'G3DSA:2.40.20.10:FF:000067', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226043, NULL, 'G3DSA:2.60.40.10:FF:001000', NULL, NULL, 'tyrosine-protein phosphatase Lar isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(226044, NULL, 'G3DSA:2.40.50.140:FF:000405', NULL, NULL, 'Maltose/maltodextrin import ATP-binding protein MalK', NULL, NULL, NULL, NULL, NULL, 4),
(226045, NULL, 'G3DSA:4.10.400.10:FF:000168', NULL, NULL, 'LDL receptor related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(226046, NULL, 'G3DSA:2.130.10.10:FF:000461', NULL, NULL, 'Chromatin assembly factor 1 subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(226047, NULL, 'G3DSA:3.40.30.10:FF:000189', NULL, NULL, 'Glutathione S-Transferase', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(226048, NULL, 'G3DSA:3.10.20.310:FF:000049', NULL, NULL, 'Hemolysin activator protein', NULL, NULL, NULL, NULL, NULL, 4),
(226049, NULL, 'G3DSA:3.30.450.260:FF:000007', NULL, NULL, 'Soluble guanylate cyclase gcy-33', NULL, NULL, NULL, NULL, NULL, 4),
(226050, NULL, 'G3DSA:1.10.1420.10:FF:000090', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226051, NULL, 'G3DSA:3.30.70.580:FF:000034', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(226052, NULL, 'G3DSA:2.40.50.290:FF:000001', NULL, NULL, 'Glycyl-glycine endopeptidase LytM', NULL, NULL, NULL, NULL, NULL, 4),
(226053, NULL, 'G3DSA:2.130.10.10:FF:004160', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226054, NULL, 'G3DSA:2.60.40.150:FF:000610', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226055, NULL, 'G3DSA:1.10.8.270:FF:000095', NULL, NULL, 'Rab GTPase activating protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(226056, NULL, 'G3DSA:3.50.50.60:FF:001284', NULL, NULL, 'Probable phytoene dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(226057, NULL, 'G3DSA:2.40.10.10:FF:000465', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226058, NULL, 'G3DSA:3.20.20.70:FF:000628', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226059, NULL, 'G3DSA:2.60.40.1110:FF:000013', NULL, NULL, 'Type I pullulanase', NULL, NULL, NULL, NULL, NULL, 4),
(226060, NULL, 'G3DSA:3.40.120.10:FF:000087', NULL, NULL, 'Phosphohexomutase (Phosphoglucomutase / phosphomannomutase)', NULL, NULL, NULL, NULL, NULL, 4),
(226061, NULL, 'G3DSA:3.30.160.60:FF:003788', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226062, NULL, 'G3DSA:1.10.8.270:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226063, NULL, 'G3DSA:1.20.144.10:FF:000064', NULL, NULL, 'Succinate--CoA ligase [ADP/GDP-forming] subunit alpha, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(226064, NULL, 'G3DSA:2.30.30.140:FF:000269', NULL, NULL, 'Protein CBG13694', NULL, NULL, NULL, NULL, NULL, 4),
(226065, NULL, 'G3DSA:4.10.520.10:FF:000002', NULL, NULL, 'Integration host factor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(226066, NULL, 'G3DSA:2.40.30.10:FF:000365', NULL, NULL, 'NADPH reductase TAH18', NULL, NULL, NULL, NULL, NULL, 4),
(226067, NULL, 'G3DSA:3.40.50.150:FF:000461', NULL, NULL, 'Sarcosine/dimethylglycine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(226068, NULL, 'G3DSA:3.10.110.10:FF:000048', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 15', NULL, NULL, NULL, NULL, NULL, 4),
(226069, NULL, 'G3DSA:2.60.40.10:FF:004182', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226070, NULL, 'G3DSA:3.40.50.10260:FF:000029', NULL, NULL, 'AEL049Wp', NULL, NULL, NULL, NULL, NULL, 4),
(226071, NULL, 'G3DSA:3.30.70.980:FF:000064', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226072, NULL, 'G3DSA:2.40.70.10:FF:000148', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226073, NULL, 'G3DSA:3.90.1100.10:FF:000023', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(226074, NULL, 'G3DSA:3.40.395.10:FF:000005', NULL, NULL, 'Ubiquitin-like-specific protease ESD4', NULL, NULL, NULL, NULL, NULL, 4),
(226075, NULL, 'G3DSA:2.160.20.70:FF:000040', NULL, NULL, 'Tubulin-specific chaperone C', NULL, NULL, NULL, NULL, NULL, 4),
(226076, NULL, 'G3DSA:3.10.129.10:FF:000203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226077, NULL, 'G3DSA:2.60.40.10:FF:000483', NULL, NULL, 'HEPACAM family member 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(226078, NULL, 'G3DSA:3.30.160.60:FF:006429', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226079, NULL, 'G3DSA:1.10.420.10:FF:000040', NULL, NULL, 'Peroxisomal ascorbate peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(226080, NULL, 'G3DSA:1.10.30.10:FF:000116', NULL, NULL, 'HMG box-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(226081, NULL, 'G3DSA:3.80.10.10:FF:001349', NULL, NULL, 'NLR family CARD domain containing 3', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(226082, NULL, 'G3DSA:1.25.40.10:FF:002157', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g45350, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(226083, NULL, 'G3DSA:3.40.50.2020:FF:000189', NULL, NULL, 'Os02g0517564 protein', NULL, NULL, NULL, NULL, NULL, 4),
(226084, NULL, 'G3DSA:4.10.320.10:FF:000021', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(226085, NULL, 'G3DSA:3.30.200.20:FF:002077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226086, NULL, 'G3DSA:3.40.50.620:FF:000034', NULL, NULL, 'Leucine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(226087, NULL, 'G3DSA:3.90.70.10:FF:000554', NULL, NULL, 'Calcium-dependent cysteine protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(226088, NULL, 'G3DSA:3.40.640.10:FF:000143', NULL, NULL, 'DegT/DnrJ/EryC1/StrS aminotransferase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(226089, NULL, 'G3DSA:3.40.50.2300:FF:001268', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226090, NULL, 'G3DSA:1.20.1110.10:FF:000148', NULL, NULL, 'PMCA18 protein', NULL, NULL, NULL, NULL, NULL, 4),
(226091, NULL, 'G3DSA:3.40.50.300:FF:006464', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226092, NULL, 'G3DSA:3.10.50.40:FF:000099', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(226093, NULL, 'G3DSA:3.40.50.1580:FF:000017', NULL, NULL, 'Probable bifunctional mta/sah nucleosidase mtn', NULL, NULL, NULL, NULL, NULL, 4),
(226094, NULL, 'G3DSA:3.80.10.10:FF:003620', NULL, NULL, 'Relaxin receptor 1-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(226095, NULL, 'G3DSA:3.30.420.40:FF:000166', NULL, NULL, 'Actin like 8', NULL, NULL, NULL, NULL, NULL, 4),
(226096, NULL, 'G3DSA:1.10.340.30:FF:000062', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226097, NULL, 'G3DSA:3.40.190.10:FF:000018', NULL, NULL, 'Oligopeptide ABC transporter, oligopeptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(226098, NULL, 'G3DSA:3.30.160.60:FF:004631', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226099, NULL, 'G3DSA:3.30.70.330:FF:001645', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226100, NULL, 'G3DSA:2.40.50.100:FF:000017', NULL, NULL, 'Spermidine/putrescine import ATP-binding protein PotA', NULL, NULL, NULL, NULL, NULL, 4),
(226101, NULL, 'G3DSA:3.40.50.300:FF:000169', NULL, NULL, 'ABC transporter C family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(226102, NULL, 'G3DSA:3.30.40.10:FF:001084', NULL, NULL, 'RING-H2 finger protein ATL52-like', NULL, NULL, NULL, NULL, NULL, 4),
(226103, NULL, 'G3DSA:2.60.40.1730:FF:000093', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226104, NULL, 'G3DSA:1.25.40.10:FF:002820', NULL, NULL, 'Os01g0301700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(226105, NULL, 'G3DSA:2.130.10.10:FF:004513', NULL, NULL, 'EMC Endoplasmic Membrane protein Complex (Yeast EMC) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(226106, NULL, 'G3DSA:3.30.200.20:FF:001397', NULL, NULL, 'Serine/threonine-protein kinase STN8, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(226107, NULL, 'G3DSA:3.30.870.10:FF:000090', NULL, NULL, 'Phospholipase D', NULL, NULL, NULL, NULL, NULL, 4),
(226108, NULL, 'G3DSA:3.90.79.10:FF:000091', NULL, NULL, 'Nudix hydrolase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(226109, NULL, 'G3DSA:3.40.50.1820:FF:001197', NULL, NULL, 'Esterase PIR7B', NULL, NULL, NULL, NULL, NULL, 4),
(226110, NULL, 'G3DSA:1.10.238.10:FF:000189', NULL, NULL, 'Centrin 3', NULL, NULL, NULL, NULL, NULL, 4),
(226111, NULL, 'G3DSA:1.10.10.440:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226112, NULL, 'G3DSA:2.30.30.1190:FF:000010', NULL, NULL, 'C3H-type transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(226113, NULL, 'G3DSA:1.10.472.10:FF:000233', NULL, NULL, 'Cyclin A', NULL, NULL, NULL, NULL, NULL, 4),
(226114, NULL, 'G3DSA:1.10.10.1340:FF:000010', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 31', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(226115, NULL, 'G3DSA:3.30.565.10:FF:000313', NULL, NULL, 'Putative postmeiotic segregation increased 2-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(226116, NULL, 'G3DSA:3.30.1320.10:FF:000025', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226117, NULL, 'G3DSA:1.20.1420.30:FF:000014', NULL, NULL, 'Cation/H+ exchanger protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(226118, NULL, 'G3DSA:3.40.50.150:FF:000770', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(226119, NULL, 'G3DSA:3.30.890.10:FF:000017', NULL, NULL, 'Methyl-CpG-binding domain-containing protein 11', NULL, NULL, NULL, NULL, NULL, 4),
(226120, NULL, 'G3DSA:3.30.60.30:FF:000225', NULL, NULL, 'Agrin-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(226121, NULL, 'G3DSA:3.30.780.20:FF:000001', NULL, NULL, 'DNA helicase 2', NULL, NULL, NULL, NULL, NULL, 4),
(226122, NULL, 'G3DSA:3.40.50.300:FF:006155', NULL, NULL, 'DNA helicase II', NULL, NULL, NULL, NULL, NULL, 4),
(226123, NULL, 'G3DSA:3.40.640.10:FF:000452', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226124, NULL, 'G3DSA:3.40.50.510:FF:000001', NULL, NULL, 'PTS system mannose-specific transporter subunit IIAB', NULL, NULL, NULL, NULL, NULL, 4),
(226125, NULL, 'G3DSA:3.40.50.2300:FF:001577', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226126, NULL, 'G3DSA:1.10.8.800:FF:000001', NULL, NULL, 'DNA polymerase II small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(226127, NULL, 'G3DSA:2.60.40.10:FF:004535', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226128, NULL, 'G3DSA:2.60.40.1910:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226129, NULL, 'G3DSA:3.40.50.300:FF:000641', NULL, NULL, 'caseinolytic peptidase B protein homolog isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(226130, NULL, 'G3DSA:4.10.60.10:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226131, NULL, 'G3DSA:1.10.8.500:FF:000001', NULL, NULL, 'Cell wall metabolism sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(226132, NULL, 'G3DSA:2.60.40.10:FF:000820', NULL, NULL, 'SLAM family member 7', NULL, NULL, NULL, NULL, NULL, 4),
(226133, NULL, 'G3DSA:1.25.40.10:FF:001668', NULL, NULL, 'Crooked neck protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(226134, NULL, 'G3DSA:1.20.140.80:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226135, NULL, 'G3DSA:3.40.50.1820:FF:001208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226136, NULL, 'G3DSA:3.30.450.240:FF:000001', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226137, NULL, 'G3DSA:3.40.50.10810:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226138, NULL, 'G3DSA:1.10.533.10:FF:000049', NULL, NULL, 'NLR family pyrin domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(226139, NULL, 'G3DSA:3.40.50.920:FF:000034', NULL, NULL, '1-deoxy-D-xylulose-5-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(226140, NULL, 'G3DSA:3.90.79.10:FF:000102', NULL, NULL, 'NUDIX domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(226141, NULL, 'G3DSA:1.10.10.10:FF:001986', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226142, NULL, 'G3DSA:3.90.190.10:FF:000378', NULL, NULL, 'receptor-type tyrosine-protein phosphatase alpha-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(226143, NULL, 'G3DSA:1.10.510.10:FF:004493', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226144, NULL, 'G3DSA:2.30.180.10:FF:000035', NULL, NULL, 'fasciclin-1 isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(226145, NULL, 'G3DSA:1.25.10.10:FF:002346', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226146, NULL, 'G3DSA:3.30.1360.100:FF:000004', NULL, NULL, 'Type II secretion system protein L', NULL, NULL, NULL, NULL, NULL, 4),
(226147, NULL, 'G3DSA:1.25.40.20:FF:000569', NULL, NULL, 'AT09114p', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(226148, NULL, 'G3DSA:3.40.50.300:FF:000848', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(226149, NULL, 'G3DSA:2.130.10.10:FF:002259', NULL, NULL, 'WD domain, G-beta repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(226150, NULL, 'G3DSA:3.30.450.40:FF:000140', NULL, NULL, 'PelD', NULL, NULL, NULL, NULL, NULL, 4),
(226151, NULL, 'G3DSA:1.20.1070.10:FF:001712', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226152, NULL, 'G3DSA:2.60.120.10:FF:000446', NULL, NULL, 'Probable mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(226153, NULL, 'G3DSA:3.30.70.80:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226154, NULL, 'G3DSA:2.70.150.10:FF:000092', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(226155, NULL, 'G3DSA:3.40.50.300:FF:005975', NULL, NULL, 'Thymidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(226156, NULL, 'G3DSA:3.30.160.60:FF:002377', NULL, NULL, 'Zinc finger protein 445', NULL, NULL, NULL, NULL, NULL, 4),
(226157, NULL, 'G3DSA:3.90.980.20:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226158, NULL, 'G3DSA:1.25.40.10:FF:004411', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g33350', NULL, NULL, NULL, NULL, NULL, 4),
(226159, NULL, 'G3DSA:3.50.50.100:FF:000045', NULL, NULL, 'Type-II NADH dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(226160, NULL, 'G3DSA:3.30.70.870:FF:000014', NULL, NULL, 'TetQ family GTPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(226161, NULL, 'G3DSA:3.30.160.60:FF:000915', NULL, NULL, 'Zinc finger protein 622', NULL, NULL, NULL, NULL, NULL, 4),
(226162, NULL, 'G3DSA:1.25.70.10:FF:000068', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226163, NULL, 'G3DSA:2.40.10.10:FF:000139', NULL, NULL, 'Acrosin', NULL, NULL, NULL, NULL, NULL, 4),
(226164, NULL, 'G3DSA:3.40.30.10:FF:001032', NULL, NULL, 'Transducin family protein / WD-40 repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(226165, NULL, 'G3DSA:3.50.50.60:FF:000182', NULL, NULL, 'FAD-dependent oxidoreductase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(226166, NULL, 'G3DSA:1.10.8.60:FF:000376', NULL, NULL, 'AAA-type ATPase (CDC48 subfamily)', NULL, NULL, NULL, NULL, NULL, 4),
(226167, NULL, 'G3DSA:1.25.40.10:FF:001977', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g33760', NULL, NULL, NULL, NULL, NULL, 4),
(226168, NULL, 'G3DSA:3.30.420.110:FF:000029', NULL, NULL, 'DNA mismatch repair protein MutS', NULL, NULL, NULL, NULL, NULL, 4),
(226169, NULL, 'G3DSA:3.30.420.100:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226170, NULL, 'G3DSA:1.10.510.10:FF:000822', NULL, NULL, 'Serine/threonine-protein kinase gcn2', NULL, NULL, NULL, NULL, NULL, 4),
(226171, NULL, 'G3DSA:1.10.506.10:FF:000054', NULL, NULL, 'Plexin-A1', NULL, NULL, NULL, NULL, NULL, 4),
(226172, NULL, 'G3DSA:1.10.472.10:FF:000603', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226173, NULL, 'G3DSA:1.10.150.300:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226174, NULL, 'G3DSA:3.30.160.60:FF:005120', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226175, NULL, 'G3DSA:1.20.1250.20:FF:002302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226176, NULL, 'G3DSA:2.170.270.10:FF:000059', NULL, NULL, 'Potential protein lysine methyltransferase SET5', NULL, NULL, NULL, NULL, NULL, 4),
(226177, NULL, 'G3DSA:3.30.460.10:FF:000199', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226178, NULL, 'G3DSA:3.30.1120.90:FF:000011', NULL, NULL, 'Suppressor of presenilin-2', NULL, NULL, NULL, NULL, NULL, 4),
(226179, NULL, 'G3DSA:3.30.360.10:FF:000017', NULL, NULL, 'Oxidoreductase family NAD-binding Rossmann fold', NULL, NULL, NULL, NULL, NULL, 4),
(226180, NULL, 'G3DSA:3.40.50.1000:FF:000451', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(226181, NULL, 'G3DSA:1.10.630.10:FF:000769', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(226182, NULL, 'G3DSA:1.20.5.340:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226183, NULL, 'G3DSA:3.30.70.330:FF:002325', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226184, NULL, 'G3DSA:3.30.43.10:FF:000016', NULL, NULL, 'D-2-hydroxyglutarate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(226185, NULL, 'G3DSA:3.40.30.10:FF:000852', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226186, NULL, 'G3DSA:1.25.40.730:FF:000013', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(226187, NULL, 'G3DSA:2.60.40.10:FF:004209', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226188, NULL, 'G3DSA:1.20.140.100:FF:000039', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226189, NULL, 'G3DSA:1.10.1600.10:FF:000036', NULL, NULL, 'KU70 protein', NULL, NULL, NULL, NULL, NULL, 4),
(226190, NULL, 'G3DSA:2.30.42.10:FF:000005', NULL, NULL, 'Membrane associated guanylate kinase, WW and PDZ domain containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(226191, NULL, 'G3DSA:1.10.1300.10:FF:000007', NULL, NULL, 'Phosphodiesterase 10A', NULL, NULL, NULL, NULL, NULL, 4),
(226192, NULL, 'G3DSA:1.20.58.2010:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226193, NULL, 'G3DSA:2.60.40.1510:FF:000026', NULL, NULL, 'Integrin alpha pat-2', NULL, NULL, NULL, NULL, NULL, 4),
(226194, NULL, 'G3DSA:3.40.50.880:FF:000224', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226195, NULL, 'G3DSA:1.10.287.190:FF:000002', NULL, NULL, 'General transcription factor IIA subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(226196, NULL, 'G3DSA:2.40.10.10:FF:000156', NULL, NULL, 'MIP06385p', NULL, NULL, NULL, NULL, NULL, 4),
(226197, NULL, 'G3DSA:1.20.1280.290:FF:000050', NULL, NULL, 'Sugar transporter SWEET', NULL, NULL, NULL, NULL, NULL, 4),
(226198, NULL, 'G3DSA:2.130.10.10:FF:004176', NULL, NULL, 'WD repeat-containing protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(226199, NULL, 'G3DSA:1.20.58.1250:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226200, NULL, 'G3DSA:3.90.980.20:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226201, NULL, 'G3DSA:3.40.50.300:FF:000539', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(226202, NULL, 'G3DSA:2.40.20.10:FF:000084', NULL, NULL, 'Receptor tyrosine kinase-like orphan receptor', NULL, NULL, NULL, NULL, NULL, 4),
(226203, NULL, 'G3DSA:2.60.40.60:FF:000565', NULL, NULL, 'Cadherin 24', NULL, NULL, NULL, NULL, NULL, 4),
(226204, NULL, 'G3DSA:1.20.58.830:FF:000047', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(226205, NULL, 'G3DSA:1.10.1420.10:FF:000073', NULL, NULL, 'Putative mismatch repair protein MSH8', NULL, NULL, NULL, NULL, NULL, 4),
(226206, NULL, 'G3DSA:3.30.70.580:FF:000017', NULL, NULL, 'Related to DEG1-pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(226207, NULL, 'G3DSA:3.40.50.300:FF:008616', NULL, NULL, 'Dynamin GTPase, switch/motor protein', NULL, NULL, NULL, NULL, NULL, 4),
(226208, NULL, 'G3DSA:3.30.40.10:FF:000010', NULL, NULL, 'E3 ubiquitin-protein ligase RBX1', NULL, NULL, NULL, NULL, NULL, 4),
(226209, NULL, 'G3DSA:1.20.1530.20:FF:000014', NULL, NULL, 'Solute carrier family 10 member 3', NULL, NULL, NULL, NULL, NULL, 4),
(226210, NULL, 'G3DSA:3.40.50.300:FF:002439', NULL, NULL, 'ABC transporter, ATP-binding/permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(226211, NULL, 'G3DSA:3.60.21.10:FF:000476', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226212, NULL, 'G3DSA:1.25.40.10:FF:004265', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(226213, NULL, 'G3DSA:3.40.190.10:FF:000361', NULL, NULL, 'SgrR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(226214, NULL, 'G3DSA:3.30.70.560:FF:000011', NULL, NULL, 'Folic acid synthesis protein fol1', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(226215, NULL, 'G3DSA:1.20.1050.10:FF:000210', NULL, NULL, 'Os11g0125601 protein', NULL, NULL, NULL, NULL, NULL, 4),
(226216, NULL, 'G3DSA:3.30.70.330:FF:001499', NULL, NULL, 'Putative RNA-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(226217, NULL, 'G3DSA:1.25.10.10:FF:000205', NULL, NULL, 'Serine/threonine-protein phosphatase 4 regulatory subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(226218, NULL, 'G3DSA:2.60.120.260:FF:000264', NULL, NULL, 'Cellulose synthase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(226219, NULL, 'G3DSA:3.40.30.10:FF:001015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226220, NULL, 'G3DSA:3.30.1360.200:FF:000001', NULL, NULL, 'Protein translocase subunit SecD', NULL, NULL, NULL, NULL, NULL, 4),
(226221, NULL, 'G3DSA:3.20.20.70:FF:000645', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226222, NULL, 'G3DSA:3.40.50.12780:FF:000111', NULL, NULL, 'Nonribosomal peptide synthase GliP2', NULL, NULL, NULL, NULL, NULL, 4),
(226223, NULL, 'G3DSA:3.30.230.80:FF:000028', NULL, NULL, 'Chaperone protein HtpG', NULL, NULL, NULL, NULL, NULL, 4),
(226224, NULL, 'G3DSA:3.30.420.40:FF:000492', NULL, NULL, 'Actin-like ATPase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(226225, NULL, 'G3DSA:2.40.30.10:FF:000348', NULL, NULL, 'Superoxide-generating NADPH oxidase heavy chain subunit C', NULL, NULL, NULL, NULL, NULL, 4),
(226226, NULL, 'G3DSA:1.10.460.10:FF:000014', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(226227, NULL, 'G3DSA:3.30.40.10:FF:001628', NULL, NULL, 'non-structural maintenance of chromosomes element 1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(226228, NULL, 'G3DSA:1.10.3720.10:FF:000129', NULL, NULL, 'ABC transporter permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(226229, NULL, 'G3DSA:3.90.420.10:FF:000003', NULL, NULL, 'Nitrate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(226230, NULL, 'G3DSA:2.60.40.10:FF:000466', NULL, NULL, 'Uncharacterized protein, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(226231, NULL, 'G3DSA:1.20.920.30:FF:000020', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(226232, NULL, 'G3DSA:3.20.20.450:FF:000004', NULL, NULL, 'Cyclic diguanylate phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(226233, NULL, 'G3DSA:1.10.238.10:FF:000352', NULL, NULL, 'Cell division control protein 31', NULL, NULL, NULL, NULL, NULL, 4),
(226234, NULL, 'G3DSA:1.25.10.10:FF:000429', NULL, NULL, 'Transport and golgi organization 6 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(226235, NULL, 'G3DSA:3.90.1410.10:FF:000007', NULL, NULL, 'Ribosomal lysine N-methyltransferase 4', NULL, NULL, NULL, NULL, NULL, 4),
(226236, NULL, 'G3DSA:3.30.230.70:FF:000025', NULL, NULL, 'Exosome complex component rrp43', NULL, NULL, NULL, NULL, NULL, 4),
(226237, NULL, 'G3DSA:3.90.260.10:FF:000029', NULL, NULL, 'Prostate-specific transglutaminase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(226238, NULL, 'G3DSA:3.40.395.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226239, NULL, 'G3DSA:3.80.10.10:FF:002794', NULL, NULL, 'Receptor like protein 45', NULL, NULL, NULL, NULL, NULL, 4),
(226240, NULL, 'G3DSA:3.40.1050.10:FF:000002', NULL, NULL, 'Carbonic anhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(226241, NULL, 'G3DSA:3.30.160.60:FF:006076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226242, NULL, 'G3DSA:3.30.420.40:FF:000312', NULL, NULL, 'Actin-like protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(226243, NULL, 'G3DSA:3.30.70.980:FF:000047', NULL, NULL, 'Probable transcriptional regulatory protein Chy400_1141', NULL, NULL, NULL, NULL, NULL, 4),
(226244, NULL, 'G3DSA:3.80.10.10:FF:001512', NULL, NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(226245, NULL, 'G3DSA:2.60.40.10:FF:001894', NULL, NULL, 'Stretchin-Mlck, isoform V', NULL, NULL, NULL, NULL, NULL, 4),
(226246, NULL, 'G3DSA:2.90.10.10:FF:000058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(226247, NULL, 'G3DSA:2.160.20.70:FF:000023', NULL, NULL, 'Tubulin binding cofactor C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(226248, NULL, 'G3DSA:3.40.1170.20:FF:000002', NULL, NULL, 'tRNA-splicing endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(226249, NULL, 'G3DSA:3.40.50.1000:FF:000125', NULL, NULL, 'RNA polymerase II C-terminal domain phosphatase-like 4', NULL, NULL, NULL, NULL, NULL, 4),
(226250, NULL, 'G3DSA:3.40.50.1820:FF:000106', NULL, NULL, 'Galactolipase DONGLE, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(226251, NULL, 'G3DSA:3.70.10.10:FF:000046', NULL, NULL, 'Cell cycle checkpoint protein', NULL, NULL, NULL, NULL, NULL, 4),
(226252, NULL, 'G3DSA:3.40.50.10470:FF:000076', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226253, NULL, 'G3DSA:2.10.70.80:FF:000013', NULL, NULL, 'Sortilin', NULL, NULL, NULL, NULL, NULL, 4),
(226254, NULL, 'G3DSA:3.80.10.10:FF:001366', NULL, NULL, 'Receptor like protein 39', NULL, NULL, NULL, NULL, NULL, 4),
(226255, NULL, 'G3DSA:3.40.50.720:FF:001492', NULL, NULL, 'Ornithine cyclodeaminase', NULL, NULL, NULL, NULL, NULL, 4),
(226256, NULL, 'G3DSA:1.20.1070.10:FF:000886', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226257, NULL, 'G3DSA:1.10.10.10:FF:000233', NULL, NULL, 'DNA-binding response regulator PrrA', NULL, NULL, NULL, NULL, NULL, 4),
(226258, NULL, 'G3DSA:2.60.40.1180:FF:000192', NULL, NULL, 'Alpha-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(226259, NULL, 'G3DSA:1.20.120.1200:FF:000029', NULL, NULL, 'NADH-ubiquinone oxidoreductase chain 6', NULL, NULL, NULL, NULL, NULL, 4),
(226260, NULL, 'G3DSA:4.10.320.10:FF:000004', NULL, NULL, 'Nucleoid-associated protein Lsr2', NULL, NULL, NULL, NULL, NULL, 4),
(226261, NULL, 'G3DSA:1.20.140.150:FF:000138', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226262, NULL, 'G3DSA:2.40.160.110:FF:000013', NULL, NULL, 'Lysosomal-associated membrane protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(226263, NULL, 'G3DSA:3.30.70.330:FF:000217', NULL, NULL, 'Polyadenylate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(226264, NULL, 'G3DSA:1.10.510.10:FF:000468', NULL, NULL, 'PTI1-like tyrosine-protein kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(226265, NULL, 'G3DSA:3.90.70.10:FF:000863', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226266, NULL, 'G3DSA:2.60.40.150:FF:000817', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226267, NULL, 'G3DSA:3.40.50.300:FF:007919', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226268, NULL, 'G3DSA:3.90.550.50:FF:000092', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(226269, NULL, 'G3DSA:2.60.40.770:FF:000003', NULL, NULL, 'Lymphocyte antigen 96', NULL, NULL, NULL, NULL, NULL, 4),
(226270, NULL, 'G3DSA:3.90.150.10:FF:000010', NULL, NULL, 'Variant surface glycoprotein (VSG, atypical), putative', NULL, NULL, NULL, NULL, NULL, 4),
(226271, NULL, 'G3DSA:1.10.510.10:FF:003695', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226272, NULL, 'G3DSA:1.10.150.50:FF:000059', NULL, NULL, 'E3 ubiquitin-protein ligase LRSAM1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(226273, NULL, 'G3DSA:2.130.10.10:FF:002243', NULL, NULL, 'WD repeat domain 74', NULL, NULL, NULL, NULL, NULL, 4),
(226274, NULL, 'G3DSA:3.80.10.10:FF:001692', NULL, NULL, 'SCF E3 ubiquitin ligase complex F-box protein grrA', NULL, NULL, NULL, NULL, NULL, 4),
(226275, NULL, 'G3DSA:3.40.50.720:FF:001048', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226276, NULL, 'G3DSA:3.40.50.300:FF:001012', NULL, NULL, 'Septin 1', NULL, NULL, NULL, NULL, NULL, 4),
(226277, NULL, 'G3DSA:3.40.50.300:FF:003867', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226278, NULL, 'G3DSA:2.60.40.10:FF:000792', NULL, NULL, 'titin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(226279, NULL, 'G3DSA:1.10.357.120:FF:000009', NULL, NULL, 'DNA-directed RNA polymerase I subunit rpa1', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(226280, NULL, 'G3DSA:2.40.50.590:FF:000001', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(226281, NULL, 'G3DSA:1.25.10.10:FF:002329', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226282, NULL, 'G3DSA:4.10.60.10:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226283, NULL, 'G3DSA:3.80.20.20:FF:000015', NULL, NULL, 'Putative Insulin growth factor 1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(226284, NULL, 'G3DSA:2.60.40.790:FF:000009', NULL, NULL, '17.6 kDa class I heat shock protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(226285, NULL, 'G3DSA:2.70.40.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226286, NULL, 'G3DSA:3.10.100.10:FF:000446', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226287, NULL, 'G3DSA:2.60.40.10:FF:002720', NULL, NULL, 'Type II inositol-1,4,5-trisphosphate 5-phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(226288, NULL, 'G3DSA:1.10.418.10:FF:000080', NULL, NULL, 'Fimbrin-2', NULL, NULL, NULL, NULL, NULL, 4),
(226289, NULL, 'G3DSA:1.10.510.10:FF:001896', NULL, NULL, 'EPH receptor A2', NULL, NULL, NULL, NULL, NULL, 4),
(226290, NULL, 'G3DSA:3.30.70.270:FF:000031', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(226291, NULL, 'G3DSA:3.80.10.10:FF:003311', NULL, NULL, 'Toll-like receptor 21', NULL, NULL, NULL, NULL, NULL, 4),
(226292, NULL, 'G3DSA:1.10.357.110:FF:000006', NULL, NULL, 'Vacuolar protein sorting-associated protein 53', NULL, NULL, NULL, NULL, NULL, 4),
(226293, NULL, 'G3DSA:3.80.10.10:FF:003592', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226294, NULL, 'G3DSA:1.20.1070.10:FF:001358', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226295, NULL, 'G3DSA:1.10.510.10:FF:002413', NULL, NULL, 'Protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(226296, NULL, 'G3DSA:1.25.40.20:FF:000671', NULL, NULL, 'Serine/threonine-protein phosphatase 6 regulatory ankyrin repeat subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(226297, NULL, 'G3DSA:1.10.730.10:FF:000007', NULL, NULL, 'Valine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(226298, NULL, 'G3DSA:1.10.150.20:FF:000050', NULL, NULL, 'DNA repair protein UVH3', NULL, NULL, NULL, NULL, NULL, 4),
(226299, NULL, 'G3DSA:3.40.1000.50:FF:000016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226300, NULL, 'G3DSA:1.20.1070.10:FF:001066', NULL, NULL, 'G protein-coupled receptor', NULL, NULL, NULL, NULL, NULL, 4),
(226301, NULL, 'G3DSA:3.40.50.2300:FF:001594', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226302, NULL, 'G3DSA:3.20.20.140:FF:000294', NULL, NULL, 'Allantoinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(226303, NULL, 'G3DSA:3.90.480.10:FF:000012', NULL, NULL, 'Probable oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(226304, NULL, 'G3DSA:1.20.1310.10:FF:000129', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226305, NULL, 'G3DSA:3.40.50.720:FF:001357', NULL, NULL, 'NAD-dependent epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(226306, NULL, 'G3DSA:3.10.100.10:FF:000137', NULL, NULL, 'Mannose receptor, C type 2', NULL, NULL, NULL, NULL, NULL, 4),
(226307, NULL, 'G3DSA:3.30.230.10:FF:000114', NULL, NULL, 'Unplaced genomic scaffold supercont1.201, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(226308, NULL, 'G3DSA:3.40.30.10:FF:000868', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(226309, NULL, 'G3DSA:2.60.120.620:FF:000108', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226310, NULL, 'G3DSA:3.10.20.90:FF:000842', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226311, NULL, 'G3DSA:3.30.9.10:FF:000286', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226312, NULL, 'G3DSA:1.20.120.770:FF:000005', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226313, NULL, 'G3DSA:2.10.25.10:FF:001366', NULL, NULL, 'LIN-12 protein, putative', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(226314, NULL, 'G3DSA:1.10.20.10:FF:000205', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226315, NULL, 'G3DSA:3.40.50.300:FF:008072', NULL, NULL, 'Vacuolar sorting protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(226316, NULL, 'G3DSA:1.25.40.10:FF:000033', NULL, NULL, 'Lipopolysaccharide assembly protein B', NULL, NULL, NULL, NULL, NULL, 4),
(226317, NULL, 'G3DSA:3.30.70.890:FF:000037', NULL, NULL, 'Galactokinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(226318, NULL, 'G3DSA:2.170.270.10:FF:000043', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(226319, NULL, 'G3DSA:3.80.10.10:FF:001057', NULL, NULL, 'Leucine-rich repeat containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(226320, NULL, 'G3DSA:1.10.510.10:FF:000159', NULL, NULL, 'Casein kinase I hhp1', NULL, NULL, NULL, NULL, NULL, 4),
(226321, NULL, 'G3DSA:3.30.70.870:FF:000031', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(226322, NULL, 'G3DSA:1.25.10.10:FF:000531', NULL, NULL, 'Negative regulator of mitosis', NULL, NULL, NULL, NULL, NULL, 4),
(226323, NULL, 'G3DSA:1.20.120.1900:FF:000043', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(226324, NULL, 'G3DSA:2.102.10.10:FF:000069', NULL, NULL, 'Putative dioxygenase, iron-sulfur subunit', NULL, NULL, NULL, NULL, NULL, 4),
(226325, NULL, 'G3DSA:2.60.40.10:FF:002411', NULL, NULL, 'Synaptogenesis protein syg-1', NULL, NULL, NULL, NULL, NULL, 4),
(226326, NULL, 'G3DSA:3.90.550.10:FF:000541', NULL, NULL, 'Slr1063 protein', NULL, NULL, NULL, NULL, NULL, 4),
(226327, NULL, 'G3DSA:1.10.3730.20:FF:000077', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226328, NULL, 'G3DSA:2.110.10.10:FF:000080', NULL, NULL, 'Hemopexin', NULL, NULL, NULL, NULL, NULL, 4),
(226329, NULL, 'G3DSA:3.30.70.1450:FF:000043', NULL, NULL, 'Sulfur deprivation response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(226330, NULL, 'G3DSA:1.25.40.10:FF:000903', NULL, NULL, 'E3 ubiquitin-protein ligase PEP5', NULL, NULL, NULL, NULL, NULL, 4),
(226331, NULL, 'G3DSA:1.10.135.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226332, NULL, 'G3DSA:3.40.190.290:FF:000004', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(226333, NULL, 'G3DSA:2.130.10.10:FF:000814', NULL, NULL, 'Embryo sac development arrest 7', NULL, NULL, NULL, NULL, NULL, 4),
(226334, NULL, 'G3DSA:2.30.30.40:FF:000341', NULL, NULL, 'Nuclear fusion protein FUS1', NULL, NULL, NULL, NULL, NULL, 4),
(226335, NULL, 'G3DSA:1.20.5.340:FF:000097', NULL, NULL, 'AaceriAGL235Cp', NULL, NULL, NULL, NULL, NULL, 4),
(226336, NULL, 'G3DSA:4.10.400.10:FF:000185', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(226337, NULL, 'G3DSA:1.10.472.10:FF:000250', NULL, NULL, 'Retinoblastoma-like protein A', NULL, NULL, NULL, NULL, NULL, 4),
(226338, NULL, 'G3DSA:2.40.10.10:FF:000482', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226339, NULL, 'G3DSA:3.30.870.10:FF:000117', NULL, NULL, 'Phosphatidylcholine-hydrolyzing phospholipase D (PLD) family', NULL, NULL, NULL, NULL, NULL, 4),
(226340, NULL, 'G3DSA:1.25.40.20:FF:000906', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226341, NULL, 'G3DSA:2.60.40.10:FF:000157', NULL, NULL, 'filamin-C isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(226342, NULL, 'G3DSA:1.20.144.10:FF:000047', NULL, NULL, 'GD15030', NULL, NULL, NULL, NULL, NULL, 4),
(226343, NULL, 'G3DSA:1.20.1070.10:FF:001049', NULL, NULL, 'AGAP008702-PA', NULL, NULL, NULL, NULL, NULL, 4),
(226344, NULL, 'G3DSA:3.80.10.10:FF:003827', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226345, NULL, 'G3DSA:2.70.150.10:FF:000119', NULL, NULL, 'Cation-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(226346, NULL, 'G3DSA:3.30.70.330:FF:000190', NULL, NULL, 'serine/arginine-rich splicing factor 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(226347, NULL, 'G3DSA:1.25.10.10:FF:002122', NULL, NULL, 'STE/STE11/CDC15 protein kinase', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(226348, NULL, 'G3DSA:2.130.10.10:FF:003996', NULL, NULL, 'DNA damage-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(226349, NULL, 'G3DSA:2.60.40.10:FF:002927', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226350, NULL, 'G3DSA:1.10.730.10:FF:000024', NULL, NULL, 'Methionine--tRNA ligase cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(226351, NULL, 'G3DSA:2.40.50.100:FF:000197', NULL, NULL, 'Exosome complex component RRP4', NULL, NULL, NULL, NULL, NULL, 4),
(226352, NULL, 'G3DSA:1.20.960.30:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226353, NULL, 'G3DSA:1.10.30.10:FF:000133', NULL, NULL, 'Protein CBG16280', NULL, NULL, NULL, NULL, NULL, 4),
(226354, NULL, 'G3DSA:1.20.58.60:FF:000121', NULL, NULL, 'dystonin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(226355, NULL, 'G3DSA:3.30.70.470:FF:000001', NULL, NULL, 'Methyl-coenzyme M reductase I subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(226356, NULL, 'G3DSA:1.10.730.20:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226357, NULL, 'G3DSA:1.10.420.10:FF:000023', NULL, NULL, 'Peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(226358, NULL, 'G3DSA:3.90.70.10:FF:000571', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226359, NULL, 'G3DSA:3.90.1100.10:FF:000006', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(226360, NULL, 'G3DSA:3.10.129.10:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226361, NULL, 'G3DSA:3.40.50.620:FF:000017', NULL, NULL, '7-cyano-7-deazaguanine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(226362, NULL, 'G3DSA:1.20.1390.10:FF:000005', NULL, NULL, 'RNA binding (RRM/RBD/RNP motifs) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(226363, NULL, 'G3DSA:3.100.10.10:FF:000020', NULL, NULL, 'Ribosomal protein L15', NULL, NULL, NULL, NULL, NULL, 4),
(226364, NULL, 'G3DSA:1.25.10.10:FF:000840', NULL, NULL, 'Importin beta-3 subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(226365, NULL, 'G3DSA:3.30.565.10:FF:000330', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(226366, NULL, 'G3DSA:3.40.50.720:FF:002200', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226367, NULL, 'G3DSA:3.30.420.40:FF:000183', NULL, NULL, 'Propionate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(226368, NULL, 'G3DSA:3.30.1370.10:FF:000062', NULL, NULL, 'vigilin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(226369, NULL, 'G3DSA:3.30.160.60:FF:004614', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226370, NULL, 'G3DSA:4.10.960.10:FF:000007', NULL, NULL, 'Peroxisome biogenesis protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(226371, NULL, 'G3DSA:3.90.76.10:FF:000051', NULL, NULL, 'Oligopeptide ABC transporter, periplasmic oligopeptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(226372, NULL, 'G3DSA:3.40.50.300:FF:006481', NULL, NULL, 'Pleiotropic drug resistance protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(226373, NULL, 'G3DSA:1.20.1270.420:FF:000008', NULL, NULL, 'Inhibitor of kappa light polypeptide gene enhancer in B-cells, kinase epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(226374, NULL, 'G3DSA:2.60.40.10:FF:002618', NULL, NULL, 'Beta-D-xylosidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(226375, NULL, 'G3DSA:2.10.70.10:FF:000083', NULL, NULL, 'Beta-2-glycoprotein 1', NULL, NULL, NULL, NULL, NULL, 4),
(226376, NULL, 'G3DSA:1.10.3630.10:FF:000010', NULL, NULL, 'Golgi phosphoprotein 3 (coat-protein)', NULL, NULL, NULL, NULL, NULL, 4),
(226377, NULL, 'G3DSA:2.40.420.20:FF:000038', NULL, NULL, 'Efflux RND transporter periplasmic adaptor subunit', NULL, NULL, NULL, NULL, NULL, 4),
(226378, NULL, 'G3DSA:3.40.50.2000:FF:000520', NULL, NULL, 'Glycosyltransferase family 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(226379, NULL, 'G3DSA:1.10.155.10:FF:000002', NULL, NULL, 'Chemotaxis protein methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(226380, NULL, 'G3DSA:3.40.190.10:FF:000035', NULL, NULL, 'Molybdate ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(226381, NULL, 'G3DSA:3.30.1680.10:FF:000046', NULL, NULL, 'Si:ch211-113g11.6', NULL, NULL, NULL, NULL, NULL, 4),
(226382, NULL, 'G3DSA:1.20.870.10:FF:000009', NULL, NULL, 'RAS guanyl releasing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(226383, NULL, 'G3DSA:3.30.70.330:FF:002090', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226384, NULL, 'G3DSA:1.25.40.10:FF:000342', NULL, NULL, 'Tetratricopeptide repeat domain 21A', NULL, NULL, NULL, NULL, NULL, 4),
(226385, NULL, 'G3DSA:1.20.1080.10:FF:000021', NULL, NULL, 'Probable aquaporin PIP2-8', NULL, NULL, NULL, NULL, NULL, 4),
(226386, NULL, 'G3DSA:2.60.260.20:FF:000122', NULL, NULL, 'Heat shock protein', NULL, NULL, NULL, NULL, NULL, 4),
(226387, NULL, 'G3DSA:3.90.79.10:FF:000074', NULL, NULL, 'Mutt/nudix family protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(226388, NULL, 'G3DSA:1.10.1450.10:FF:000119', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(226389, NULL, 'G3DSA:3.30.60.30:FF:000208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226390, NULL, 'G3DSA:1.10.10.2010:FF:000003', NULL, NULL, 'Nuclear valosin-containing protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(226391, NULL, 'G3DSA:3.40.50.300:FF:007892', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226392, NULL, 'G3DSA:1.10.3720.10:FF:000146', NULL, NULL, 'Amino acid ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(226393, NULL, 'G3DSA:3.90.980.10:FF:000005', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(226394, NULL, 'G3DSA:1.25.10.10:FF:001020', NULL, NULL, 'Heat repeat domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(226395, NULL, 'G3DSA:3.30.70.330:FF:000010', NULL, NULL, 'CUGBP Elav-like family member 4 isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(226396, NULL, 'G3DSA:3.10.450.10:FF:000006', NULL, NULL, 'latexin', NULL, NULL, NULL, NULL, NULL, 4),
(226397, NULL, 'G3DSA:1.20.1260.10:FF:000001', NULL, NULL, 'Non-heme ferritin', NULL, NULL, NULL, NULL, NULL, 4),
(226398, NULL, 'G3DSA:2.130.10.10:FF:003687', NULL, NULL, 'F-box and WD repeat domain-containing 11', NULL, NULL, NULL, NULL, NULL, 4),
(226399, NULL, 'G3DSA:3.30.160.60:FF:002714', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226400, NULL, 'G3DSA:3.80.10.10:FF:003266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226401, NULL, 'G3DSA:3.30.160.60:FF:003203', NULL, NULL, 'Zinc finger protein 715', NULL, NULL, NULL, NULL, NULL, 4),
(226402, NULL, 'G3DSA:3.30.710.10:FF:000050', NULL, NULL, 'Rho related BTB domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(226403, NULL, 'G3DSA:2.60.40.60:FF:000239', NULL, NULL, 'Starry night, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(226404, NULL, 'G3DSA:3.50.70.10:FF:000011', NULL, NULL, 'Chalcone--flavonone isomerase 1', NULL, NULL, NULL, NULL, NULL, 4),
(226405, NULL, 'G3DSA:3.40.50.1100:FF:000037', NULL, NULL, 'Bifunctional D-cysteine desulfhydrase/1-aminocyclopropane-1-carboxylate deaminase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(226406, NULL, 'G3DSA:3.40.850.10:FF:000035', NULL, NULL, 'Kinesin-like protein KIF11', NULL, NULL, NULL, NULL, NULL, 4),
(226407, NULL, 'G3DSA:3.40.225.10:FF:000010', NULL, NULL, 'Probable bifunctional methylthioribulose-1-phosphate dehydratase/enolase-phosphatase E1', NULL, NULL, NULL, NULL, NULL, 4),
(226408, NULL, 'G3DSA:3.40.50.10810:FF:000240', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226409, NULL, 'G3DSA:3.90.226.10:FF:000052', NULL, NULL, 'Peroxisomal bifunctional enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(226410, NULL, 'G3DSA:3.40.50.300:FF:008381', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226411, NULL, 'G3DSA:3.30.70.1660:FF:000016', NULL, NULL, 'Peptide chain release factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(226412, NULL, 'G3DSA:2.60.40.10:FF:004518', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226413, NULL, 'G3DSA:3.40.50.300:FF:002765', NULL, NULL, 'ATLastiN (Endoplasmic reticulum GTPase) related', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(226414, NULL, 'G3DSA:3.50.50.60:FF:000210', NULL, NULL, 'lysine-specific histone demethylase 1 homolog 3', NULL, NULL, NULL, NULL, NULL, 4),
(226415, NULL, 'G3DSA:1.10.510.10:FF:002930', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226416, NULL, 'G3DSA:2.60.40.150:FF:000256', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226417, NULL, 'G3DSA:2.180.10.10:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226418, NULL, 'G3DSA:1.20.58.1080:FF:000013', NULL, NULL, 'ATP-dependent RNA helicase SUV3, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(226419, NULL, 'G3DSA:3.40.50.2000:FF:000211', NULL, NULL, 'ADP-heptose:LPS heptosyltransferase II', NULL, NULL, NULL, NULL, NULL, 4),
(226420, NULL, 'G3DSA:3.40.50.150:FF:000326', NULL, NULL, 'Carnosine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(226421, NULL, 'G3DSA:1.10.418.10:FF:000006', NULL, NULL, 'Filamin-B isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(226422, NULL, 'G3DSA:2.160.20.60:FF:000003', NULL, NULL, 'Ferredoxin-dependent glutamate synthase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(226423, NULL, 'G3DSA:2.10.25.10:FF:000978', NULL, NULL, 'Transmembrane matrix receptor MUP-4', NULL, NULL, NULL, NULL, NULL, 4),
(226424, NULL, 'G3DSA:2.60.120.560:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226425, NULL, 'G3DSA:2.40.100.10:FF:000168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226426, NULL, 'G3DSA:2.60.120.920:FF:000198', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226427, NULL, 'G3DSA:2.10.50.30:FF:000031', NULL, NULL, 'Extracellular calcium-sensing receptor', NULL, NULL, NULL, NULL, NULL, 4),
(226428, NULL, 'G3DSA:3.40.1380.20:FF:000069', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(226429, NULL, 'G3DSA:1.10.150.240:FF:000046', NULL, NULL, 'Contig, possible fusion of chromosomes 20 and 34', NULL, NULL, NULL, NULL, NULL, 4),
(226430, NULL, 'G3DSA:3.30.360.10:FF:000034', NULL, NULL, 'Aspartate-semialdehyde dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(226431, NULL, 'G3DSA:1.25.40.10:FF:003776', NULL, NULL, 'Pentatricopeptide repeat-containing protein 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(226432, NULL, 'G3DSA:1.10.10.10:FF:002048', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226433, NULL, 'G3DSA:3.10.20.30:FF:000044', NULL, NULL, '(2Fe-2S)-binding domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(226434, NULL, 'G3DSA:3.20.20.80:FF:000766', NULL, NULL, 'Beta-glucosidase 32', NULL, NULL, NULL, NULL, NULL, 4),
(226435, NULL, 'G3DSA:3.20.20.70:FF:000763', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226436, NULL, 'G3DSA:4.10.830.10:FF:000003', NULL, NULL, '30S ribosomal protein S14', NULL, NULL, NULL, NULL, NULL, 4),
(226437, NULL, 'G3DSA:1.10.510.10:FF:000261', NULL, NULL, 'cyclin-dependent kinase-like 2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(226438, NULL, 'G3DSA:1.25.70.10:FF:000085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226439, NULL, 'G3DSA:3.40.50.300:FF:006610', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226440, NULL, 'G3DSA:3.40.190.10:FF:000052', NULL, NULL, 'Amino acid ABC transporter substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(226441, NULL, 'G3DSA:2.60.40.1180:FF:000219', NULL, NULL, 'Alpha-xylosidase XylQ', NULL, NULL, NULL, NULL, NULL, 4),
(226442, NULL, 'G3DSA:2.60.40.790:FF:000127', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226443, NULL, 'G3DSA:1.25.40.540:FF:000030', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226444, NULL, 'G3DSA:3.30.420.40:FF:000621', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(226445, NULL, 'G3DSA:3.90.1420.10:FF:000053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226446, NULL, 'G3DSA:1.20.1250.20:FF:000779', NULL, NULL, 'Phthalate transporter, putative', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(226447, NULL, 'G3DSA:1.10.8.60:FF:000359', NULL, NULL, 'AAA ATPase central domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(226448, NULL, 'G3DSA:3.40.50.980:FF:000030', NULL, NULL, 'Chondramide synthase cmdD', NULL, NULL, NULL, NULL, NULL, 4),
(226449, NULL, 'G3DSA:3.30.700.10:FF:000004', NULL, NULL, 'MSHA pilin protein MshC', NULL, NULL, NULL, NULL, NULL, 4),
(226450, NULL, 'G3DSA:3.90.1410.10:FF:000125', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226451, NULL, 'G3DSA:3.30.1360.70:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226452, NULL, 'G3DSA:3.40.640.10:FF:000109', NULL, NULL, 'Aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(226453, NULL, 'G3DSA:1.10.418.20:FF:000009', NULL, NULL, 'Sentrin-specific protease 6', NULL, NULL, NULL, NULL, NULL, 4),
(226454, NULL, 'G3DSA:2.60.200.20:FF:000146', NULL, NULL, 'FHA domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(226455, NULL, 'G3DSA:1.10.287.2250:FF:000003', NULL, NULL, 'Cathepsin L', NULL, NULL, NULL, NULL, NULL, 4),
(226456, NULL, 'G3DSA:3.30.1360.10:FF:000016', NULL, NULL, 'DNA-directed RNA polymerases I and III subunit RPAC1', NULL, NULL, NULL, NULL, NULL, 4),
(226457, NULL, 'G3DSA:1.10.506.10:FF:000037', NULL, NULL, 'GTPase-activating protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(226458, NULL, 'G3DSA:3.40.50.1470:FF:000001', NULL, NULL, 'Peptidyl-tRNA hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(226459, NULL, 'G3DSA:3.30.70.20:FF:000048', NULL, NULL, 'Ferredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(226460, NULL, 'G3DSA:2.60.40.60:FF:000256', NULL, NULL, 'Starry night, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(226461, NULL, 'G3DSA:3.30.160.60:FF:001888', NULL, NULL, 'ras-responsive element-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(226462, NULL, 'G3DSA:3.10.180.10:FF:000013', NULL, NULL, '4-hydroxyphenylpyruvate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(226463, NULL, 'G3DSA:3.10.129.10:FF:000012', NULL, NULL, 'Acyl-coenzyme A thioesterase 9, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(226464, NULL, 'G3DSA:3.30.200.20:FF:001958', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226465, NULL, 'G3DSA:3.30.710.10:FF:000033', NULL, NULL, 'transcription regulator protein BACH2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(226466, NULL, 'G3DSA:2.10.25.10:FF:001484', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226467, NULL, 'G3DSA:2.120.10.30:FF:000624', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226468, NULL, 'G3DSA:3.80.10.10:FF:003518', NULL, NULL, 'GH16156p', NULL, NULL, NULL, NULL, NULL, 4),
(226469, NULL, 'G3DSA:1.20.5.710:FF:000011', NULL, NULL, '50S ribosomal protein L7/L12', NULL, NULL, NULL, NULL, NULL, 4),
(226470, NULL, 'G3DSA:3.90.550.10:FF:000439', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226471, NULL, 'G3DSA:1.20.1250.20:FF:001504', NULL, NULL, 'Putative ERD6-like transporter', NULL, NULL, NULL, NULL, NULL, 4),
(226472, NULL, 'G3DSA:3.40.50.1000:FF:000333', NULL, NULL, 'Copper-transporting ATPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(226473, NULL, 'G3DSA:3.55.50.30:FF:000016', NULL, NULL, 'DUF4974 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(226474, NULL, 'G3DSA:3.40.50.10260:FF:000030', NULL, NULL, 'EDC3 isoform 7', NULL, NULL, NULL, NULL, NULL, 4),
(226475, NULL, 'G3DSA:2.130.10.10:FF:004058', NULL, NULL, 'AGAP009027-PA', NULL, NULL, NULL, NULL, NULL, 4),
(226476, NULL, 'G3DSA:2.30.29.30:FF:001094', NULL, NULL, 'Nos1ap protein', NULL, NULL, NULL, NULL, NULL, 4),
(226477, NULL, 'G3DSA:3.30.160.60:FF:003012', NULL, NULL, 'Draculin-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(226478, NULL, 'G3DSA:2.20.25.530:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226479, NULL, 'G3DSA:3.80.10.10:FF:002001', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226480, NULL, 'G3DSA:2.60.40.10:FF:006082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(226481, NULL, 'G3DSA:3.40.140.10:FF:000116', NULL, NULL, 'Cytidine deaminase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(226482, NULL, 'G3DSA:3.40.50.300:FF:002748', NULL, NULL, 'Platinum sensitivity', NULL, NULL, NULL, NULL, NULL, 4),
(226483, NULL, 'G3DSA:1.10.565.10:FF:000168', NULL, NULL, 'Protein CBG01262', NULL, NULL, NULL, NULL, NULL, 4),
(226484, NULL, 'G3DSA:2.60.40.4070:FF:000002', NULL, NULL, 'Basal-body rod modification protein FlgD', NULL, NULL, NULL, NULL, NULL, 4),
(226485, NULL, 'G3DSA:1.10.579.10:FF:000008', NULL, NULL, 'Deoxyribodipyrimidine photo-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(226486, NULL, 'G3DSA:1.10.10.10:FF:000351', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(226487, NULL, 'G3DSA:3.90.70.10:FF:000537', NULL, NULL, 'Clan CA, family C19, ubiquitin hydrolase-like cysteine peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(226488, NULL, 'G3DSA:3.40.50.300:FF:004901', NULL, NULL, 'RuvB-like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(226489, NULL, 'G3DSA:3.30.160.60:FF:001303', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226490, NULL, 'G3DSA:3.90.79.10:FF:000282', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226491, NULL, 'G3DSA:1.20.1020.10:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226492, NULL, 'G3DSA:3.40.50.720:FF:001374', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(226493, NULL, 'G3DSA:1.10.555.10:FF:000139', NULL, NULL, 'Probable inactive serine/threonine-protein kinase DDB_G0293184', NULL, NULL, NULL, NULL, NULL, 4),
(226494, NULL, 'G3DSA:1.10.10.480:FF:000009', NULL, NULL, 'Probable ATP-dependent 6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(226495, NULL, 'G3DSA:2.60.40.10:FF:002282', NULL, NULL, 'Titin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(226496, NULL, 'G3DSA:2.60.210.10:FF:000071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226497, NULL, 'G3DSA:3.30.2330.20:FF:000001', NULL, NULL, 'Blood-group-substance endo-1,4-beta-galactosidase', NULL, NULL, NULL, NULL, NULL, 4),
(226498, NULL, 'G3DSA:1.20.272.10:FF:000086', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226499, NULL, 'G3DSA:1.50.40.10:FF:000295', NULL, NULL, 'Mitochondrial substrate carrier family protein M', NULL, NULL, NULL, NULL, NULL, 4),
(226500, NULL, 'G3DSA:3.30.565.10:FF:000122', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(226501, NULL, 'G3DSA:3.30.160.60:FF:006194', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226502, NULL, 'G3DSA:3.30.160.60:FF:002495', NULL, NULL, 'Zinc finger protein 764', NULL, NULL, NULL, NULL, NULL, 4),
(226503, NULL, 'G3DSA:1.25.10.10:FF:002638', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226504, NULL, 'G3DSA:1.25.10.10:FF:000177', NULL, NULL, 'Importin beta-like SAD2', NULL, NULL, NULL, NULL, NULL, 4),
(226505, NULL, 'G3DSA:1.10.400.10:FF:000022', NULL, NULL, 'Guanine nucleotide-binding protein alpha-8 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(226506, NULL, 'G3DSA:2.60.40.60:FF:000902', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226507, NULL, 'G3DSA:3.40.50.300:FF:004356', NULL, NULL, 'Oligopeptide/dipeptide ABC transporter, ATPase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(226508, NULL, 'G3DSA:1.25.40.10:FF:001786', NULL, NULL, 'Os11g0433100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(226509, NULL, 'G3DSA:1.10.287.1490:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226510, NULL, 'G3DSA:2.30.29.30:FF:001195', NULL, NULL, 'Docking protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(226511, NULL, 'G3DSA:3.30.70.1350:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226512, NULL, 'G3DSA:3.30.40.10:FF:001746', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226513, NULL, 'G3DSA:3.30.1330.30:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226514, NULL, 'G3DSA:1.25.40.20:FF:001789', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(226515, NULL, 'G3DSA:3.30.160.60:FF:001989', NULL, NULL, 'PR domain zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(226516, NULL, 'G3DSA:3.30.200.20:FF:002532', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226517, NULL, 'G3DSA:2.40.30.230:FF:000007', NULL, NULL, 'Regulator of nonsense transcripts 1', NULL, NULL, NULL, NULL, NULL, 4),
(226518, NULL, 'G3DSA:1.10.510.10:FF:004419', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226519, NULL, 'G3DSA:3.30.160.60:FF:002506', NULL, NULL, 'Rme1p', NULL, NULL, NULL, NULL, NULL, 4),
(226520, NULL, 'G3DSA:3.40.50.1480:FF:000004', NULL, NULL, 'Adenosylhomocysteinase', NULL, NULL, NULL, NULL, NULL, 4),
(226521, NULL, 'G3DSA:3.10.50.40:FF:000127', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(226522, NULL, 'G3DSA:1.10.510.10:FF:002385', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226523, NULL, 'G3DSA:3.40.50.1240:FF:000163', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226524, NULL, 'G3DSA:2.130.10.10:FF:002613', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226525, NULL, 'G3DSA:2.60.40.10:FF:000348', NULL, NULL, 'Interleukin 20 receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(226526, NULL, 'G3DSA:3.40.1810.10:FF:000066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226527, NULL, 'G3DSA:2.130.10.10:FF:002361', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit TRM82', NULL, NULL, NULL, NULL, NULL, 4),
(226528, NULL, 'G3DSA:2.60.40.1180:FF:000118', NULL, NULL, 'Alpha-glucosidase', NULL, NULL, NULL, NULL, NULL, 4),
(226529, NULL, 'G3DSA:4.10.1240.10:FF:000085', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226530, NULL, 'G3DSA:3.30.70.330:FF:001628', NULL, NULL, 'GD17174', NULL, NULL, NULL, NULL, NULL, 4),
(226531, NULL, 'G3DSA:2.10.25.10:FF:000877', NULL, NULL, 'Crumbs', NULL, NULL, NULL, NULL, NULL, 4),
(226532, NULL, 'G3DSA:3.50.50.60:FF:000002', NULL, NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG', NULL, NULL, NULL, NULL, NULL, 4),
(226533, NULL, 'G3DSA:1.20.920.30:FF:000003', NULL, NULL, 'Dynein axonemal heavy chain 17', NULL, NULL, NULL, NULL, NULL, 4),
(226534, NULL, 'G3DSA:3.30.56.30:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226535, NULL, 'G3DSA:4.10.60.10:FF:000077', NULL, NULL, 'Zinc knuckle nucleic acid binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(226536, NULL, 'G3DSA:3.30.310.50:FF:000048', NULL, NULL, 'Os02g0306250 protein', NULL, NULL, NULL, NULL, NULL, 4),
(226537, NULL, 'G3DSA:3.30.200.20:FF:002105', NULL, NULL, 'Protein CBG15591', NULL, NULL, NULL, NULL, NULL, 4),
(226538, NULL, 'G3DSA:3.40.50.300:FF:004890', NULL, NULL, 'GNAS complex locus', NULL, NULL, NULL, NULL, NULL, 4),
(226539, NULL, 'G3DSA:3.40.50.1820:FF:001225', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226540, NULL, 'G3DSA:3.80.10.10:FF:001383', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226541, NULL, 'G3DSA:1.20.5.110:FF:000096', NULL, NULL, 'QA-SNARE protein putative', NULL, NULL, NULL, NULL, NULL, 4),
(226542, NULL, 'G3DSA:2.60.40.150:FF:000508', NULL, NULL, 'Protein kinase C-like 1B', NULL, NULL, NULL, NULL, NULL, 4),
(226543, NULL, 'G3DSA:1.10.10.10:FF:000704', NULL, NULL, 'O-methyltransferase GliM2', NULL, NULL, NULL, NULL, NULL, 4),
(226544, NULL, 'G3DSA:2.130.10.10:FF:005795', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226545, NULL, 'G3DSA:3.30.565.10:FF:000431', NULL, NULL, 'Probable sensor/response regulator hybrid', NULL, NULL, NULL, NULL, NULL, 4),
(226546, NULL, 'G3DSA:1.25.40.10:FF:004720', NULL, NULL, 'Superkiller protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(226547, NULL, 'G3DSA:3.40.50.300:FF:008408', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226548, NULL, 'G3DSA:2.170.270.10:FF:000161', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226549, NULL, 'G3DSA:3.90.400.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(226550, NULL, 'G3DSA:2.60.40.10:FF:005946', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226551, NULL, 'G3DSA:3.40.50.720:FF:001475', NULL, NULL, 'Pyrroline-5-carboxylate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(226552, NULL, 'G3DSA:3.90.70.10:FF:000436', NULL, NULL, 'AGAP001209-PA', NULL, NULL, NULL, NULL, NULL, 4),
(226553, NULL, 'G3DSA:1.10.238.10:FF:000560', NULL, NULL, 'Centrin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(226554, NULL, 'G3DSA:2.130.10.10:FF:000118', NULL, NULL, 'Cleavage and polyadenylation specificity factor subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(226555, NULL, 'G3DSA:3.30.2160.10:FF:000035', NULL, NULL, 'E3 ubiquitin-protein ligase etc-1', NULL, NULL, NULL, NULL, NULL, 4),
(226556, NULL, 'G3DSA:1.10.510.10:FF:002722', NULL, NULL, 'TBC domain-containing protein kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(226557, NULL, 'G3DSA:2.40.10.10:FF:000611', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226558, NULL, 'G3DSA:3.30.1680.10:FF:000063', NULL, NULL, 'Semaphorin 6ba', NULL, NULL, NULL, NULL, NULL, 4),
(226559, NULL, 'G3DSA:1.20.1250.20:FF:001605', NULL, NULL, 'YALI0D15488p', NULL, NULL, NULL, NULL, NULL, 4),
(226560, NULL, 'G3DSA:3.60.15.10:FF:000080', NULL, NULL, 'Ribonuclease Z, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(226561, NULL, 'G3DSA:3.90.550.50:FF:000075', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(226562, NULL, 'G3DSA:1.25.40.10:FF:004057', NULL, NULL, 'Chromosome 10, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(226563, NULL, 'G3DSA:3.30.420.10:FF:000399', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226564, NULL, 'G3DSA:1.10.10.10:FF:000660', NULL, NULL, 'Heat stress transcription factor A-6b', NULL, NULL, NULL, NULL, NULL, 4),
(226565, NULL, 'G3DSA:2.20.70.10:FF:000060', NULL, NULL, 'E3 ubiquitin-protein ligase', NULL, NULL, NULL, NULL, NULL, 4),
(226566, NULL, 'G3DSA:2.10.25.10:FF:001692', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226567, NULL, 'G3DSA:1.10.600.10:FF:000104', NULL, NULL, 'Diterpene cyclase DtcycB', NULL, NULL, NULL, NULL, NULL, 4),
(226568, NULL, 'G3DSA:3.60.21.10:FF:000268', NULL, NULL, 'Double-strand break repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(226569, NULL, 'G3DSA:2.60.40.770:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226570, NULL, 'G3DSA:3.40.50.2000:FF:000897', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(226571, NULL, 'G3DSA:3.40.50.300:FF:006346', NULL, NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 13', NULL, NULL, NULL, NULL, NULL, 4),
(226572, NULL, 'G3DSA:3.40.350.10:FF:000042', NULL, NULL, 'Xaa-Pro aminopeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(226573, NULL, 'G3DSA:3.30.70.330:FF:002016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226574, NULL, 'G3DSA:1.25.40.10:FF:002511', NULL, NULL, 'TPR_7 domain-containing protein/TPR_11 domain-containing protein/Glyco_transf_41 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(226575, NULL, 'G3DSA:3.30.70.330:FF:002134', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226576, NULL, 'G3DSA:1.10.10.570:FF:000003', NULL, NULL, 'Vacuolar protein-sorting-associated protein 25', NULL, NULL, NULL, NULL, NULL, 4),
(226577, NULL, 'G3DSA:3.30.40.10:FF:001393', NULL, NULL, 'DnaJ 2', NULL, NULL, NULL, NULL, NULL, 4),
(226578, NULL, 'G3DSA:1.20.1070.10:FF:000301', NULL, NULL, 'G-protein coupled receptor 157', NULL, NULL, NULL, NULL, NULL, 4),
(226579, NULL, 'G3DSA:1.10.238.10:FF:000009', NULL, NULL, 'Visinin-like protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(226580, NULL, 'G3DSA:2.130.10.10:FF:002260', NULL, NULL, 'GM16967', NULL, NULL, NULL, NULL, NULL, 4),
(226581, NULL, 'G3DSA:3.40.50.1000:FF:000760', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226582, NULL, 'G3DSA:1.10.10.60:FF:000096', NULL, NULL, 'Zinc finger homeobox protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(226583, NULL, 'G3DSA:2.40.37.10:FF:000032', NULL, NULL, 'Pyridoxal-dependent decarboxylase, pyridoxal binding domain containing protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(226584, NULL, 'G3DSA:2.120.10.30:FF:000315', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226585, NULL, 'G3DSA:3.30.160.60:FF:003220', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM39', NULL, NULL, NULL, NULL, NULL, 4),
(226586, NULL, 'G3DSA:3.30.70.330:FF:000425', NULL, NULL, 'Transmembrane protein 63A, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(226587, NULL, 'G3DSA:2.40.160.120:FF:000049', NULL, NULL, 'Oxysterol-binding protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(226588, NULL, 'G3DSA:1.10.10.580:FF:000006', NULL, NULL, 'Cohesin subunit rad21, putative', NULL, NULL, NULL, NULL, NULL, 4),
(226589, NULL, 'G3DSA:2.30.30.140:FF:000286', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(226590, NULL, 'G3DSA:3.90.1600.10:FF:000050', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(226591, NULL, 'G3DSA:3.90.1490.10:FF:000001', NULL, NULL, 'Diphthine--ammonia ligase', NULL, NULL, NULL, NULL, NULL, 4),
(226592, NULL, 'G3DSA:3.40.50.300:FF:000950', NULL, NULL, 'probable ATP-dependent DNA helicase HFM1', NULL, NULL, NULL, NULL, NULL, 4),
(226593, NULL, 'G3DSA:3.40.50.720:FF:001166', NULL, NULL, 'Aspergillus niger contig An11c0010, genomic contig', NULL, NULL, NULL, NULL, NULL, 4),
(226594, NULL, 'G3DSA:2.60.40.10:FF:002591', NULL, NULL, 'Uncharacterized protein, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(226595, NULL, 'G3DSA:2.130.10.10:FF:005486', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226596, NULL, 'G3DSA:3.10.110.10:FF:000065', NULL, NULL, 'Ubiquitin-conjugating enzyme E2 E1', NULL, NULL, NULL, NULL, NULL, 4),
(226597, NULL, 'G3DSA:3.40.50.300:FF:000287', NULL, NULL, 'Multidrug ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(226598, NULL, 'G3DSA:3.40.50.1440:FF:000088', NULL, NULL, 'Tubulin gamma-2 chain', NULL, NULL, NULL, NULL, NULL, 4),
(226599, NULL, 'G3DSA:3.40.30.10:FF:001150', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226600, NULL, 'G3DSA:1.10.287.110:FF:000361', NULL, NULL, 'Zgc:122979', NULL, NULL, NULL, NULL, NULL, 4),
(226601, NULL, 'G3DSA:2.60.40.790:FF:000026', NULL, NULL, 'Outer dense fiber protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(226602, NULL, 'G3DSA:1.10.510.10:FF:000940', NULL, NULL, 'Serine/threonine-protein kinase-like protein CCR1', NULL, NULL, NULL, NULL, NULL, 4),
(226603, NULL, 'G3DSA:3.20.110.10:FF:000012', NULL, NULL, 'Alpha-mannosidase B', NULL, NULL, NULL, NULL, NULL, 4),
(226604, NULL, 'G3DSA:3.10.450.10:FF:000023', NULL, NULL, 'cathelicidin antimicrobial peptide isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(226605, NULL, 'G3DSA:1.10.3430.10:FF:000012', NULL, NULL, 'Rh type C glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(226606, NULL, 'G3DSA:2.10.25.10:FF:001383', NULL, NULL, 'Netrin G1', NULL, NULL, NULL, NULL, NULL, 4),
(226607, NULL, 'G3DSA:3.80.10.10:FF:001720', NULL, NULL, 'F-box/LRR-repeat protein 12-like', NULL, NULL, NULL, NULL, NULL, 4),
(226608, NULL, 'G3DSA:3.30.160.60:FF:005002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226609, NULL, 'G3DSA:3.80.10.10:FF:000669', NULL, NULL, 'Putative leucine-rich repeat receptor-like protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(226610, NULL, 'G3DSA:3.40.50.970:FF:000116', NULL, NULL, 'Indolepyruvate oxidoreductase subunit IorA', NULL, NULL, NULL, NULL, NULL, 4),
(226611, NULL, 'G3DSA:1.20.120.350:FF:000245', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226612, NULL, 'G3DSA:2.60.40.10:FF:000612', NULL, NULL, 'palladin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(226613, NULL, 'G3DSA:2.70.98.10:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226614, NULL, 'G3DSA:3.40.50.150:FF:001141', NULL, NULL, 'At1g33030', NULL, NULL, NULL, NULL, NULL, 4),
(226615, NULL, 'G3DSA:2.40.160.120:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226616, NULL, 'G3DSA:2.60.40.1170:FF:000071', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(226617, NULL, 'G3DSA:1.25.40.10:FF:002466', NULL, NULL, 'Pentatricopeptide repeat-containing protein At1g71420', NULL, NULL, NULL, NULL, NULL, 4),
(226618, NULL, 'G3DSA:3.90.740.10:FF:000050', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226619, NULL, 'G3DSA:2.170.270.10:FF:000060', NULL, NULL, 'SET domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(226620, NULL, 'G3DSA:2.120.10.80:FF:000061', NULL, NULL, 'N-acetylneuraminate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(226621, NULL, 'G3DSA:1.20.1070.10:FF:001392', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226622, NULL, 'G3DSA:1.25.10.10:FF:000514', NULL, NULL, 'HEAT repeats/HEAT repeat, putative', NULL, NULL, NULL, NULL, NULL, 4),
(226623, NULL, 'G3DSA:1.10.1070.11:FF:000024', NULL, NULL, 'Serine/threonine-protein kinase ATR', NULL, NULL, NULL, NULL, NULL, 4),
(226624, NULL, 'G3DSA:1.10.1410.10:FF:000027', NULL, NULL, 'Topoisomerase-related function protein-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(226625, NULL, 'G3DSA:3.40.50.1820:FF:001326', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226626, NULL, 'G3DSA:1.20.5.30:FF:000001', NULL, NULL, 'matrilin-2 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(226627, NULL, 'G3DSA:3.80.10.10:FF:000978', NULL, NULL, 'Relaxin family peptide receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(226628, NULL, 'G3DSA:2.60.40.1180:FF:000074', NULL, NULL, 'Cytoplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(226629, NULL, 'G3DSA:3.20.20.70:FF:000499', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226630, NULL, 'G3DSA:2.130.10.10:FF:004159', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226631, NULL, 'G3DSA:3.90.1410.10:FF:000081', NULL, NULL, 'Protein-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(226632, NULL, 'G3DSA:3.30.40.10:FF:001645', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226633, NULL, 'G3DSA:3.40.50.300:FF:002541', NULL, NULL, 'DNA replication helicase DNA2', NULL, NULL, NULL, NULL, NULL, 4),
(226634, NULL, 'G3DSA:1.10.10.60:FF:000107', NULL, NULL, 'MYB transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(226635, NULL, 'G3DSA:1.20.1250.20:FF:001493', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226636, NULL, 'G3DSA:3.30.40.10:FF:001275', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226637, NULL, 'G3DSA:2.70.98.10:FF:000110', NULL, NULL, 'Chromosome 21, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(226638, NULL, 'G3DSA:3.30.505.50:FF:000001', NULL, NULL, 'Ribosome hibernation promoting factor', NULL, NULL, NULL, NULL, NULL, 4),
(226639, NULL, 'G3DSA:1.10.150.190:FF:000008', NULL, NULL, 'Elongation initiation factor 2 alpha subunit,putative', NULL, NULL, NULL, NULL, NULL, 4),
(226640, NULL, 'G3DSA:1.25.40.10:FF:000257', NULL, NULL, 'anaphase-promoting complex subunit 5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(226641, NULL, 'G3DSA:3.30.40.10:FF:001954', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226642, NULL, 'G3DSA:2.80.10.50:FF:000262', NULL, NULL, 'Transcription factor cbf12', NULL, NULL, NULL, NULL, NULL, 4),
(226643, NULL, 'G3DSA:3.30.230.70:FF:000008', NULL, NULL, 'polyribonucleotide nucleotidyltransferase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(226644, NULL, 'G3DSA:1.25.40.10:FF:002039', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g13650', NULL, NULL, NULL, NULL, NULL, 4),
(226645, NULL, 'G3DSA:3.30.160.60:FF:006093', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226646, NULL, 'G3DSA:3.10.20.90:FF:000808', NULL, NULL, 'Os07g0493033 protein', NULL, NULL, NULL, NULL, NULL, 4),
(226647, NULL, 'G3DSA:3.30.1010.10:FF:000041', NULL, NULL, 'Putative phosphatidylinositol kinase related protein', NULL, NULL, NULL, NULL, NULL, 4),
(226648, NULL, 'G3DSA:3.40.50.300:FF:000495', NULL, NULL, 'Fidgetin like 2', NULL, NULL, NULL, NULL, NULL, 4),
(226649, NULL, 'G3DSA:1.10.510.10:FF:000367', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(226650, NULL, 'G3DSA:1.20.1250.20:FF:001813', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226651, NULL, 'G3DSA:3.40.50.300:FF:001113', NULL, NULL, 'ATP-dependent RNA helicase TDRD9', NULL, NULL, NULL, NULL, NULL, 4),
(226652, NULL, 'G3DSA:3.90.550.10:FF:000333', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(226653, NULL, 'G3DSA:2.60.120.10:FF:000755', NULL, NULL, 'Protein CBG00653', NULL, NULL, NULL, NULL, NULL, 4),
(226654, NULL, 'G3DSA:3.10.20.90:FF:000707', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226655, NULL, 'G3DSA:1.25.40.10:FF:000241', NULL, NULL, 'G-protein-signaling modulator 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(226656, NULL, 'G3DSA:3.40.50.880:FF:000180', NULL, NULL, 'Pyridoxal 5''-phosphate synthase subunit PdxT', NULL, NULL, NULL, NULL, NULL, 4),
(226657, NULL, 'G3DSA:3.40.50.720:FF:001683', NULL, NULL, 'Phosphoglycerate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(226658, NULL, 'G3DSA:3.30.200.20:FF:000323', NULL, NULL, 'Mitogen-activated protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(226659, NULL, 'G3DSA:2.130.10.10:FF:002052', NULL, NULL, 'general transcription factor 3C polypeptide 2', NULL, NULL, NULL, NULL, NULL, 4),
(226660, NULL, 'G3DSA:3.30.60.10:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226661, NULL, 'G3DSA:3.40.50.720:FF:002301', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226662, NULL, 'G3DSA:1.25.40.10:FF:003894', NULL, NULL, 'Pentatricopeptide repeat (PPR) superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(226663, NULL, 'G3DSA:3.40.525.10:FF:000038', NULL, NULL, 'Phosphatidylinositol transfer protein SFH5', NULL, NULL, NULL, NULL, NULL, 4),
(226664, NULL, 'G3DSA:3.40.50.720:FF:001727', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(226665, NULL, 'G3DSA:3.40.50.2300:FF:000604', NULL, NULL, 'Receptor-type adenylate cyclase GRESAG 4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(226666, NULL, 'G3DSA:3.90.70.10:FF:000228', NULL, NULL, 'Putative ubiquitin carboxy-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(226667, NULL, 'G3DSA:3.30.300.330:FF:000001', NULL, NULL, 'Alkylglycerone-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(226668, NULL, 'G3DSA:1.10.287.730:FF:000001', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase B', NULL, NULL, NULL, NULL, NULL, 4),
(226669, NULL, 'G3DSA:1.10.150.20:FF:000151', NULL, NULL, 'Transcription termination/antitermination protein NusA', NULL, NULL, NULL, NULL, NULL, 4),
(226670, NULL, 'G3DSA:3.30.428.10:FF:000051', NULL, NULL, 'HIT-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(226671, NULL, 'G3DSA:2.120.10.80:FF:000414', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226672, NULL, 'G3DSA:3.40.50.1980:FF:000031', NULL, NULL, 'High-affinity heme uptake system protein IsdE', NULL, NULL, NULL, NULL, NULL, 4),
(226673, NULL, 'G3DSA:2.70.98.10:FF:000008', NULL, NULL, 'Aldose 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(226674, NULL, 'G3DSA:3.30.160.60:FF:002815', NULL, NULL, 'Zinc finger protein 236 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(226675, NULL, 'G3DSA:3.10.450.50:FF:000074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226676, NULL, 'G3DSA:3.40.50.1820:FF:001534', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226677, NULL, 'G3DSA:3.30.200.20:FF:002223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226678, NULL, 'G3DSA:3.40.50.300:FF:008038', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226679, NULL, 'G3DSA:2.60.40.340:FF:000015', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226680, NULL, 'G3DSA:3.40.50.300:FF:008280', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226681, NULL, 'G3DSA:2.130.10.10:FF:004721', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226682, NULL, 'G3DSA:1.10.510.10:FF:002267', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(226683, NULL, 'G3DSA:1.10.510.10:FF:004066', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226684, NULL, 'G3DSA:3.30.565.10:FF:000329', NULL, NULL, 'Hybrid sensory kinase', NULL, NULL, NULL, NULL, NULL, 4),
(226685, NULL, 'G3DSA:3.30.497.10:FF:000031', NULL, NULL, 'Putative salivary serpin', NULL, NULL, NULL, NULL, NULL, 4),
(226686, NULL, 'G3DSA:2.40.10.10:FF:000347', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226687, NULL, 'G3DSA:1.25.40.10:FF:001994', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g46610', NULL, NULL, NULL, NULL, NULL, 4),
(226688, NULL, 'G3DSA:1.10.132.10:FF:000011', NULL, NULL, 'DNA topoisomerase I', NULL, NULL, NULL, NULL, NULL, 4),
(226689, NULL, 'G3DSA:2.10.25.10:FF:001175', NULL, NULL, 'Terribly reduced optic lobes, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(226690, NULL, 'G3DSA:2.60.40.640:FF:000077', NULL, NULL, 'Vacuolar protein sorting 26', NULL, NULL, NULL, NULL, NULL, 4),
(226691, NULL, 'G3DSA:1.10.30.50:FF:000004', NULL, NULL, 'HNH endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(226692, NULL, 'G3DSA:3.30.60.30:FF:000017', NULL, NULL, 'Follistatin like 1', NULL, NULL, NULL, NULL, NULL, 4),
(226693, NULL, 'G3DSA:3.40.50.300:FF:004238', NULL, NULL, 'RecBCD enzyme subunit RecB', NULL, NULL, NULL, NULL, NULL, 4),
(226694, NULL, 'G3DSA:2.60.120.260:FF:000163', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226695, NULL, 'G3DSA:2.130.10.10:FF:002922', NULL, NULL, 'Protein DECREASED SIZE EXCLUSION LIMIT 1', NULL, NULL, NULL, NULL, NULL, 4),
(226696, NULL, 'G3DSA:3.40.50.2300:FF:000503', NULL, NULL, 'Transcriptional regulator, LuxR family', NULL, NULL, NULL, NULL, NULL, 4),
(226697, NULL, 'G3DSA:1.10.10.10:FF:000912', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(226698, NULL, 'G3DSA:1.10.30.40:FF:000001', NULL, NULL, 'Ethanolamine ammonia-lyase light chain', NULL, NULL, NULL, NULL, NULL, 4),
(226699, NULL, 'G3DSA:3.40.50.720:FF:000401', NULL, NULL, 'Related to MTD1-methylenetetrahydrofolate dehydrogenase (NAD+)', NULL, NULL, NULL, NULL, NULL, 4),
(226700, NULL, 'G3DSA:2.160.10.10:FF:000072', NULL, NULL, 'DEAD-box ATP-dependent RNA helicase 7', NULL, NULL, NULL, NULL, NULL, 4),
(226701, NULL, 'G3DSA:3.40.50.1820:FF:001635', NULL, NULL, 'Putative phospholipase A2', NULL, NULL, NULL, NULL, NULL, 4),
(226702, NULL, 'G3DSA:1.10.238.10:FF:000217', NULL, NULL, 'RAS and EF-hand domain containing', NULL, NULL, NULL, NULL, NULL, 4),
(226703, NULL, 'G3DSA:3.80.10.10:FF:001793', NULL, NULL, 'Os05g0256100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(226704, NULL, 'G3DSA:3.30.60.20:FF:000014', NULL, NULL, 'Protein kinase C', NULL, NULL, NULL, NULL, NULL, 4),
(226705, NULL, 'G3DSA:1.20.1070.10:FF:000987', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226706, NULL, 'G3DSA:1.10.405.10:FF:000027', NULL, NULL, 'Rab escort protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(226707, NULL, 'G3DSA:2.60.40.1260:FF:000007', NULL, NULL, 'Lamin tail domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(226708, NULL, 'G3DSA:3.20.20.10:FF:000088', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226709, NULL, 'G3DSA:1.20.1250.20:FF:001914', NULL, NULL, 'Sugar transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(226710, NULL, 'G3DSA:1.10.287.110:FF:000170', NULL, NULL, 'Chaperone DnaJ-domain superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(226711, NULL, 'G3DSA:1.10.472.170:FF:000025', NULL, NULL, 'T12H20.13 protein', NULL, NULL, NULL, NULL, NULL, 4),
(226712, NULL, 'G3DSA:2.130.10.10:FF:004822', NULL, NULL, 'WD40-repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(226713, NULL, 'G3DSA:3.40.30.10:FF:000644', NULL, NULL, 'Thioredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(226714, NULL, 'G3DSA:3.40.1280.10:FF:000002', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(226715, NULL, 'G3DSA:1.25.10.10:FF:001958', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226716, NULL, 'G3DSA:3.40.50.1000:FF:000349', NULL, NULL, 'Haloacid dehalogenase family hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(226717, NULL, 'G3DSA:3.40.50.1000:FF:000097', NULL, NULL, 'phosphoethanolamine/phosphocholine phosphatase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(226718, NULL, 'G3DSA:2.160.20.10:FF:000044', NULL, NULL, 'Pectate lyase E', NULL, NULL, NULL, NULL, NULL, 4),
(226719, NULL, 'G3DSA:3.90.70.10:FF:000127', NULL, NULL, 'Ubiquitin C-terminal hydrolase Ubp8', NULL, NULL, NULL, NULL, NULL, 4),
(226720, NULL, 'G3DSA:3.40.366.10:FF:000011', NULL, NULL, 'Polyketide synthetase PksP', NULL, NULL, NULL, NULL, NULL, 4),
(226721, NULL, 'G3DSA:1.20.1070.10:FF:002010', NULL, NULL, 'Si:ch211-132e22.4', NULL, NULL, NULL, NULL, NULL, 4),
(226722, NULL, 'G3DSA:2.130.10.10:FF:004367', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226723, NULL, 'G3DSA:2.130.10.10:FF:002467', NULL, NULL, 'Small nucleolar ribonucleoprotein complex subunit Dip2, putative (AFU_orthologue AFUA_1G02680)', NULL, NULL, NULL, NULL, NULL, 4),
(226724, NULL, 'G3DSA:3.90.190.10:FF:000102', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(226725, NULL, 'G3DSA:2.60.120.200:FF:000061', NULL, NULL, 'Laminin subunit alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(226726, NULL, 'G3DSA:1.20.1250.20:FF:001459', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226727, NULL, 'G3DSA:3.40.50.300:FF:006138', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226728, NULL, 'G3DSA:2.10.220.10:FF:000184', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226729, NULL, 'G3DSA:3.50.50.60:FF:000311', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(226730, NULL, 'G3DSA:3.30.2170.10:FF:000007', NULL, NULL, 'Endonuclease V', NULL, NULL, NULL, NULL, NULL, 4),
(226731, NULL, 'G3DSA:1.10.8.720:FF:000067', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(226732, NULL, 'G3DSA:1.10.510.10:FF:004167', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226733, NULL, 'G3DSA:3.30.1380.20:FF:000037', NULL, NULL, 'Transport protein particle (TRAPP) component', NULL, NULL, NULL, NULL, NULL, 4),
(226734, NULL, 'G3DSA:3.30.60.20:FF:000104', NULL, NULL, 'Rho-associated protein kinase let-502', NULL, NULL, NULL, NULL, NULL, 4),
(226735, NULL, 'G3DSA:3.30.530.20:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226736, NULL, 'G3DSA:1.10.3210.10:FF:000029', NULL, NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(226737, NULL, 'G3DSA:2.80.10.50:FF:000228', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(226738, NULL, 'G3DSA:2.60.200.20:FF:000028', NULL, NULL, 'FHA domain-containing protein DDL', NULL, NULL, NULL, NULL, NULL, 4),
(226739, NULL, 'G3DSA:1.10.10.1730:FF:000003', NULL, NULL, 'Folliculin', NULL, NULL, NULL, NULL, NULL, 4),
(226740, NULL, 'G3DSA:3.30.40.10:FF:000201', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(226741, NULL, 'G3DSA:3.30.559.30:FF:000057', NULL, NULL, 'Nonribosomal peptide synthetase fmqA', NULL, NULL, NULL, NULL, NULL, 4),
(226742, NULL, 'G3DSA:3.40.1090.10:FF:000111', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226743, NULL, 'G3DSA:2.60.40.10:FF:000803', NULL, NULL, 'Complement C4-A', NULL, NULL, NULL, NULL, NULL, 4),
(226744, NULL, 'G3DSA:3.90.400.10:FF:000002', NULL, NULL, 'Sucrose isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(226745, NULL, 'G3DSA:3.10.110.10:FF:000183', NULL, NULL, 'Putative ubiquitin-conjugating enzyme E2 25', NULL, NULL, NULL, NULL, NULL, 4),
(226746, NULL, 'G3DSA:3.80.10.10:FF:003165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226747, NULL, 'G3DSA:2.30.30.40:FF:000240', NULL, NULL, 'SH3 domain containing 19', NULL, NULL, NULL, NULL, NULL, 4),
(226748, NULL, 'G3DSA:1.20.1280.50:FF:000256', NULL, NULL, 'Ribonucleoside-diphosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(226749, NULL, 'G3DSA:2.40.100.10:FF:000062', NULL, NULL, 'Peptidyl-prolyl isomerase CWC27', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(226750, NULL, 'G3DSA:3.30.70.330:FF:000072', NULL, NULL, 'heterogeneous nuclear ribonucleoprotein L isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(226751, NULL, 'G3DSA:1.20.1070.10:FF:001493', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226752, NULL, 'G3DSA:1.10.10.1740:FF:000006', NULL, NULL, 'Protein FATTY ACID EXPORT 3, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(226753, NULL, 'G3DSA:2.60.200.10:FF:000025', NULL, NULL, 'Interferon regulatory factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(226754, NULL, 'G3DSA:2.10.90.10:FF:000067', NULL, NULL, 'Prothoracicotropic hormone, isoform F', NULL, NULL, NULL, NULL, NULL, 4),
(226755, NULL, 'G3DSA:1.25.40.10:FF:000151', NULL, NULL, 'Aspartyl/asparaginyl beta-hydroxylase', NULL, NULL, NULL, NULL, NULL, 4),
(226756, NULL, 'G3DSA:2.60.40.60:FF:000711', NULL, NULL, 'Cadherin-4', NULL, NULL, NULL, NULL, NULL, 4),
(226757, NULL, 'G3DSA:1.25.40.20:FF:000154', NULL, NULL, 'Ankyrin repeat and SOCS box containing 10', NULL, NULL, NULL, NULL, NULL, 4),
(226758, NULL, 'G3DSA:3.30.200.20:FF:000071', NULL, NULL, 'serine/threonine-protein kinase MAK isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(226759, NULL, 'G3DSA:1.20.1330.10:FF:000013', NULL, NULL, 'Flagellar hook-associated protein FlgL', NULL, NULL, NULL, NULL, NULL, 4),
(226760, NULL, 'G3DSA:3.40.50.150:FF:000118', NULL, NULL, 'Histamine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(226761, NULL, 'G3DSA:2.170.150.80:FF:000009', NULL, NULL, 'NAC domain-containing protein 8', NULL, NULL, NULL, NULL, NULL, 4),
(226762, NULL, 'G3DSA:3.30.70.20:FF:000032', NULL, NULL, 'Formate dehydrogenase, alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(226763, NULL, 'G3DSA:3.40.50.300:FF:007684', NULL, NULL, 'DNA replication and repair protein RecF', NULL, NULL, NULL, NULL, NULL, 4),
(226764, NULL, 'G3DSA:1.10.8.270:FF:000123', NULL, NULL, 'RAB GTPase-activating protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(226765, NULL, 'G3DSA:2.130.10.10:FF:003895', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226766, NULL, 'G3DSA:1.20.1250.20:FF:000987', NULL, NULL, 'Protein CBG22168', NULL, NULL, NULL, NULL, NULL, 4),
(226767, NULL, 'G3DSA:2.60.40.150:FF:000402', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226768, NULL, 'G3DSA:3.40.50.300:FF:002647', NULL, NULL, 'ATP-dependent helicase', NULL, NULL, NULL, NULL, NULL, 4),
(226769, NULL, 'G3DSA:2.60.40.1510:FF:000010', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(226770, NULL, 'G3DSA:2.170.120.12:FF:000040', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226771, NULL, 'G3DSA:1.10.3470.10:FF:000020', NULL, NULL, 'Manganese ABC transporter permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(226772, NULL, 'G3DSA:3.30.70.580:FF:000051', NULL, NULL, 'tRNA pseudouridine synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(226773, NULL, 'G3DSA:2.60.40.150:FF:000290', NULL, NULL, 'Domain_of_uncharacterized_function_(DUF3451)_-_pu tative', NULL, NULL, NULL, NULL, NULL, 4),
(226774, NULL, 'G3DSA:1.10.150.20:FF:000241', NULL, NULL, 'DNA polymerase nu', NULL, NULL, NULL, NULL, NULL, 4),
(226775, NULL, 'G3DSA:1.10.730.10:FF:000142', NULL, NULL, 'AGAP004708-PA', NULL, NULL, NULL, NULL, NULL, 4),
(226776, NULL, 'G3DSA:1.10.10.60:FF:000450', NULL, NULL, 'Homeobox protein notochord', NULL, NULL, NULL, NULL, NULL, 4),
(226777, NULL, 'G3DSA:2.30.29.30:FF:000121', NULL, NULL, 'T cell lymphoma invasion and metastasis 1', NULL, NULL, NULL, NULL, NULL, 4),
(226778, NULL, 'G3DSA:2.20.70.10:FF:000104', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(226779, NULL, 'G3DSA:1.20.1280.20:FF:000005', NULL, NULL, 'Co-chaperone protein HscB homolog', NULL, NULL, NULL, NULL, NULL, 4),
(226780, NULL, 'G3DSA:3.40.50.12240:FF:000005', NULL, NULL, 'ATP synthase F1 subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(226781, NULL, 'G3DSA:2.60.40.10:FF:000039', NULL, NULL, 'Unc-5 netrin receptor C', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(226782, NULL, 'G3DSA:1.10.1070.11:FF:000125', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226783, NULL, 'G3DSA:3.90.920.10:FF:000013', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(226784, NULL, 'G3DSA:3.30.160.60:FF:006446', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226785, NULL, 'G3DSA:2.30.30.1020:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226786, NULL, 'G3DSA:3.20.19.10:FF:000017', NULL, NULL, 'Aconitase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(226787, NULL, 'G3DSA:1.10.246.120:FF:000006', NULL, NULL, 'RAB eXchange factor', NULL, NULL, NULL, NULL, NULL, 4),
(226788, NULL, 'G3DSA:2.40.30.10:FF:000247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226789, NULL, 'G3DSA:3.80.10.10:FF:003075', NULL, NULL, 'LD08815p', NULL, NULL, NULL, NULL, NULL, 4),
(226790, NULL, 'G3DSA:2.120.10.80:FF:000162', NULL, NULL, 'Kelch domain-containing protein 10 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(226791, NULL, 'G3DSA:1.25.10.10:FF:000059', NULL, NULL, 'exportin-7 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(226792, NULL, 'G3DSA:1.20.810.10:FF:000017', NULL, NULL, 'Probable intron-encoded endonuclease bI1', NULL, NULL, NULL, NULL, NULL, 4),
(226793, NULL, 'G3DSA:2.130.10.10:FF:000770', NULL, NULL, 'E3 ubiquitin ligase complex SCF subunit sconB', NULL, NULL, NULL, NULL, NULL, 4),
(226794, NULL, 'G3DSA:3.40.50.1000:FF:000804', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226795, NULL, 'G3DSA:3.40.630.30:FF:000429', NULL, NULL, 'GNAT family N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(226796, NULL, 'G3DSA:1.10.510.10:FF:004212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226797, NULL, 'G3DSA:3.40.190.10:FF:000153', NULL, NULL, 'Ionotropic receptor 25a', NULL, NULL, NULL, NULL, NULL, 4),
(226798, NULL, 'G3DSA:1.25.10.10:FF:000413', NULL, NULL, 'Condensin-2 complex subunit D3', NULL, NULL, NULL, NULL, NULL, 4),
(226799, NULL, 'G3DSA:3.40.630.10:FF:000171', NULL, NULL, 'Leucine aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(226800, NULL, 'G3DSA:3.90.780.10:FF:000024', NULL, NULL, 'Uncharacterized metallophosphoesterase YunD', NULL, NULL, NULL, NULL, NULL, 4),
(226801, NULL, 'G3DSA:2.40.30.270:FF:000013', NULL, NULL, 'UvrD/REP helicase N-terminal domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(226802, NULL, 'G3DSA:3.40.50.300:FF:002338', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(226803, NULL, 'G3DSA:3.40.50.300:FF:002086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226804, NULL, 'G3DSA:3.40.50.1580:FF:000034', NULL, NULL, '5-methylthioadenosine nucleosidase, S-adenosylhomocysteine nucleosidase', NULL, NULL, NULL, NULL, NULL, 4),
(226805, NULL, 'G3DSA:4.10.800.10:FF:000029', NULL, NULL, 'Thyroglobulin', NULL, NULL, NULL, NULL, NULL, 4),
(226806, NULL, 'G3DSA:1.20.5.190:FF:000063', NULL, NULL, 'Growth associated protein 43', NULL, NULL, NULL, NULL, NULL, 4),
(226807, NULL, 'G3DSA:1.10.246.130:FF:000009', NULL, NULL, 'Gamma-glutamyltranspeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(226808, NULL, 'G3DSA:3.30.430.20:FF:000014', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(226809, NULL, 'G3DSA:1.20.1060.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226810, NULL, 'G3DSA:4.10.1000.40:FF:000008', NULL, NULL, 'Unplaced genomic scaffold supercont1.1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(226811, NULL, 'G3DSA:2.30.42.10:FF:000106', NULL, NULL, 'Neuroblast differentiation-associated protein AHNAK', NULL, NULL, NULL, NULL, NULL, 4),
(226812, NULL, 'G3DSA:3.40.50.150:FF:000427', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(226813, NULL, 'G3DSA:3.20.20.150:FF:000021', NULL, NULL, 'Protein arginine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(226814, NULL, 'G3DSA:1.25.40.10:FF:000712', NULL, NULL, 'Os07g0670000 protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(226815, NULL, 'G3DSA:1.20.1070.10:FF:000678', NULL, NULL, 'histamine H2 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(226816, NULL, 'G3DSA:1.10.510.10:FF:002621', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226817, NULL, 'G3DSA:2.40.170.20:FF:000119', NULL, NULL, 'Putative ferric aerobactin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(226818, NULL, 'G3DSA:1.20.140.150:FF:000032', NULL, NULL, 'Claudin domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(226819, NULL, 'G3DSA:3.80.10.10:FF:001484', NULL, NULL, 'EIN3-binding F-box protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(226820, NULL, 'G3DSA:3.30.1490.100:FF:000050', NULL, NULL, 'DNA repair protein REV1', NULL, NULL, NULL, NULL, NULL, 4),
(226821, NULL, 'G3DSA:3.50.7.10:FF:000080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226822, NULL, 'G3DSA:1.20.1060.20:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226823, NULL, 'G3DSA:1.10.620.20:FF:000007', NULL, NULL, 'Ribonucleotide reductase small subunit,putative', NULL, NULL, NULL, NULL, NULL, 4),
(226824, NULL, 'G3DSA:1.10.510.10:FF:004521', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226825, NULL, 'G3DSA:3.40.50.300:FF:000186', NULL, NULL, 'ATP-binding cassette sub-family B member 7, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(226826, NULL, 'G3DSA:2.60.40.150:FF:000609', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226827, NULL, 'G3DSA:3.40.190.10:FF:000462', NULL, NULL, 'Probable lipoprotein LpqZ', NULL, NULL, NULL, NULL, NULL, 4),
(226828, NULL, 'G3DSA:4.10.1000.30:FF:000005', NULL, NULL, 'AGAP004265-PA', NULL, NULL, NULL, NULL, NULL, 4),
(226829, NULL, 'G3DSA:2.60.40.10:FF:004390', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226830, NULL, 'G3DSA:1.25.40.10:FF:002612', NULL, NULL, 'Sterile alpha motif domain-containing 9-like', NULL, NULL, NULL, NULL, NULL, 4),
(226831, NULL, 'G3DSA:3.30.830.10:FF:000008', NULL, NULL, 'Mitochondrial-processing peptidase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(226832, NULL, 'G3DSA:2.60.40.60:FF:000357', NULL, NULL, 'CaDHerin family', NULL, NULL, NULL, NULL, NULL, 4),
(226833, NULL, 'G3DSA:1.10.560.10:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226834, NULL, 'G3DSA:1.25.40.20:FF:000715', NULL, NULL, 'SH3 and multiple ankyrin repeat domains protein', NULL, NULL, NULL, NULL, NULL, 4),
(226835, NULL, 'G3DSA:2.10.25.10:FF:000669', NULL, NULL, 'Eyes shut homolog', NULL, NULL, NULL, NULL, NULL, 4),
(226836, NULL, 'G3DSA:3.40.50.11610:FF:000013', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(226837, NULL, 'G3DSA:3.30.1320.10:FF:000008', NULL, NULL, '30S ribosomal protein S16', NULL, NULL, NULL, NULL, NULL, 4),
(226838, NULL, 'G3DSA:3.30.830.10:FF:000317', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226839, NULL, 'G3DSA:3.40.50.300:FF:004547', NULL, NULL, 'Protein CBG05712', NULL, NULL, NULL, NULL, NULL, 4),
(226840, NULL, 'G3DSA:3.40.50.1400:FF:000037', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226841, NULL, 'G3DSA:1.10.220.150:FF:000007', NULL, NULL, 'Arf-GAP with coiled-coil, ANK repeat and PH domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(226842, NULL, 'G3DSA:3.90.650.10:FF:000020', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(226843, NULL, 'G3DSA:3.30.420.40:FF:000503', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(226844, NULL, 'G3DSA:3.10.28.10:FF:000050', NULL, NULL, 'Orf294', NULL, NULL, NULL, NULL, NULL, 4),
(226845, NULL, 'G3DSA:3.10.105.10:FF:000098', NULL, NULL, 'Glutathione-binding protein GsiB', NULL, NULL, NULL, NULL, NULL, 4),
(226846, NULL, 'G3DSA:2.30.180.10:FF:000018', NULL, NULL, 'Stabilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(226847, NULL, 'G3DSA:3.90.1150.10:FF:000060', NULL, NULL, 'Serine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(226848, NULL, 'G3DSA:1.10.510.10:FF:000676', NULL, NULL, 'serine/threonine-protein kinase 32B isoform X2', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(226849, NULL, 'G3DSA:1.25.40.10:FF:002921', NULL, NULL, 'pre-mRNA-processing factor 39-like', NULL, NULL, NULL, NULL, NULL, 4),
(226850, NULL, 'G3DSA:3.30.160.60:FF:002394', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226851, NULL, 'G3DSA:2.40.30.10:FF:000157', NULL, NULL, 'Elongation factor G, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(226852, NULL, 'G3DSA:2.60.40.380:FF:000010', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226853, NULL, 'G3DSA:2.60.40.60:FF:000666', NULL, NULL, 'Cadherin 17', NULL, NULL, NULL, NULL, NULL, 4),
(226854, NULL, 'G3DSA:2.10.110.10:FF:000046', NULL, NULL, 'LIM/homeobox protein Lhx1', NULL, NULL, NULL, NULL, NULL, 4),
(226855, NULL, 'G3DSA:2.40.10.170:FF:000002', NULL, NULL, 'ATP synthase subunit beta, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(226856, NULL, 'G3DSA:3.40.47.10:FF:000036', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase II chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(226857, NULL, 'G3DSA:3.40.50.920:FF:000017', NULL, NULL, '1-deoxy-D-xylulose-5-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(226858, NULL, 'G3DSA:3.30.200.20:FF:000205', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(226859, NULL, 'G3DSA:3.40.1000.10:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226860, NULL, 'G3DSA:3.40.630.30:FF:000278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226861, NULL, 'G3DSA:2.60.40.10:FF:002719', NULL, NULL, 'Type II inositol-1-1,4,5-trisphosphate 5-phosphatase rlated, putative', NULL, NULL, NULL, NULL, NULL, 4),
(226862, NULL, 'G3DSA:1.10.418.10:FF:000186', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226863, NULL, 'G3DSA:3.30.420.40:FF:000418', NULL, NULL, 'LD21269p', NULL, NULL, NULL, NULL, NULL, 4),
(226864, NULL, 'G3DSA:2.40.50.140:FF:000304', NULL, NULL, 'Proteasome regulatory ATPase subunit 3', NULL, NULL, NULL, NULL, NULL, 4),
(226865, NULL, 'G3DSA:2.10.25.10:FF:001260', NULL, NULL, 'FAT atypical cadherin 4', NULL, NULL, NULL, NULL, NULL, 4),
(226866, NULL, 'G3DSA:2.110.10.10:FF:000046', NULL, NULL, 'Matrix metallopeptidase-21', NULL, NULL, NULL, NULL, NULL, 4),
(226867, NULL, 'G3DSA:1.20.272.10:FF:000013', NULL, NULL, 'Replication factor C subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(226868, NULL, 'G3DSA:1.20.58.390:FF:000325', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226869, NULL, 'G3DSA:1.10.472.130:FF:000047', NULL, NULL, 'Dynein heavy chain family protein', NULL, NULL, NULL, NULL, NULL, 4),
(226870, NULL, 'G3DSA:3.10.490.20:FF:000017', NULL, NULL, 'Dynein heavy chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(226871, NULL, 'G3DSA:1.10.472.10:FF:000025', NULL, NULL, 'Cyclin-dependent kinase 5 activator', NULL, NULL, NULL, NULL, NULL, 4),
(226872, NULL, 'G3DSA:3.40.50.720:FF:001609', NULL, NULL, 'NmrA-like family domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(226873, NULL, 'G3DSA:3.40.630.10:FF:000272', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226874, NULL, 'G3DSA:1.10.10.820:FF:000011', NULL, NULL, 'Myosin 10A, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(226875, NULL, 'G3DSA:3.40.50.880:FF:000106', NULL, NULL, 'Carbamoyl-phosphate synthase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(226876, NULL, 'G3DSA:3.30.9.90:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226877, NULL, 'G3DSA:1.20.120.230:FF:000063', NULL, NULL, 'Catenin alpha-1', NULL, NULL, NULL, NULL, NULL, 4),
(226878, NULL, 'G3DSA:3.40.1090.10:FF:000066', NULL, NULL, 'Phospholipase A I', NULL, NULL, NULL, NULL, NULL, 4),
(226879, NULL, 'G3DSA:1.10.1420.10:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226880, NULL, 'G3DSA:2.40.110.10:FF:000017', NULL, NULL, 'Acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(226881, NULL, 'G3DSA:3.40.50.150:FF:000562', NULL, NULL, 'Protein-lysine N-methyltransferase EFM4', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(226882, NULL, 'G3DSA:1.10.110.10:FF:000022', NULL, NULL, 'Putative lipid-transfer protein DIR1', NULL, NULL, NULL, NULL, NULL, 4),
(226883, NULL, 'G3DSA:3.30.160.60:FF:004193', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226884, NULL, 'G3DSA:2.40.30.10:FF:000466', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226885, NULL, 'G3DSA:1.20.1250.20:FF:001577', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226886, NULL, 'G3DSA:3.30.230.10:FF:000232', NULL, NULL, '28S ribosomal protein S9, mitochondrial-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(226887, NULL, 'G3DSA:3.80.10.10:FF:003182', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226888, NULL, 'G3DSA:3.30.160.60:FF:002585', NULL, NULL, 'Zinc finger protein 770', NULL, NULL, NULL, NULL, NULL, 4),
(226889, NULL, 'G3DSA:3.10.490.10:FF:000014', NULL, NULL, 'Branched-chain alpha-keto acid dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(226890, NULL, 'G3DSA:3.60.40.10:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226891, NULL, 'G3DSA:1.20.5.170:FF:000299', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226892, NULL, 'G3DSA:2.130.10.10:FF:003788', NULL, NULL, 'Transducin/WD40 repeat-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(226893, NULL, 'G3DSA:3.90.550.50:FF:000221', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(226894, NULL, 'G3DSA:3.30.200.20:FF:002341', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226895, NULL, 'G3DSA:3.40.50.1820:FF:001416', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226896, NULL, 'G3DSA:3.30.160.60:FF:004406', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226897, NULL, 'G3DSA:3.80.10.10:FF:001574', NULL, NULL, 'Leucine-rich repeat and guanylate kinase domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(226898, NULL, 'G3DSA:2.60.40.10:FF:001101', NULL, NULL, 'Macrophage colony-stimulating factor 1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(226899, NULL, 'G3DSA:1.25.10.10:FF:002554', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226900, NULL, 'G3DSA:1.20.1250.20:FF:001684', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226901, NULL, 'G3DSA:1.20.1250.20:FF:001049', NULL, NULL, 'Solute carrier family 16 member 14', NULL, NULL, NULL, NULL, NULL, 4),
(226902, NULL, 'G3DSA:3.30.200.20:FF:000733', NULL, NULL, 'Phosphoenolpyruvate carboxylase kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(226903, NULL, 'G3DSA:1.10.510.10:FF:002149', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226904, NULL, 'G3DSA:2.10.25.10:FF:000787', NULL, NULL, 'Slit homolog 1b (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(226905, NULL, 'G3DSA:2.130.10.10:FF:004261', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226906, NULL, 'G3DSA:1.20.1070.10:FF:001476', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226907, NULL, 'G3DSA:1.20.120.1080:FF:000095', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226908, NULL, 'G3DSA:1.10.510.10:FF:004285', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226909, NULL, 'G3DSA:3.10.20.90:FF:000247', NULL, NULL, 'Auxin-responsive protein', NULL, NULL, NULL, NULL, NULL, 4),
(226910, NULL, 'G3DSA:2.130.10.10:FF:004412', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226911, NULL, 'G3DSA:3.40.50.720:FF:002071', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226912, NULL, 'G3DSA:2.60.120.290:FF:000189', NULL, NULL, 'AGAP005526-PA', NULL, NULL, NULL, NULL, NULL, 4),
(226913, NULL, 'G3DSA:2.70.130.10:FF:000091', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226914, NULL, 'G3DSA:3.80.10.10:FF:001248', NULL, NULL, 'DNA repair protein rhp7 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(226915, NULL, 'G3DSA:2.130.10.10:FF:004940', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(226916, NULL, 'G3DSA:2.30.30.40:FF:000094', NULL, NULL, 'SH3 domain-containing kinase-binding protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(226917, NULL, 'G3DSA:2.30.29.30:FF:001341', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226918, NULL, 'G3DSA:3.30.160.60:FF:004732', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226919, NULL, 'G3DSA:3.40.50.300:FF:004811', NULL, NULL, 'Sulfate adenylyltransferase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(226920, NULL, 'G3DSA:1.10.940.10:FF:000034', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226921, NULL, 'G3DSA:1.10.167.10:FF:000035', NULL, NULL, 'GD16870', NULL, NULL, NULL, NULL, NULL, 4),
(226922, NULL, 'G3DSA:2.10.70.10:FF:000167', NULL, NULL, 'Neural EGFL like 2', NULL, NULL, NULL, NULL, NULL, 4),
(226923, NULL, 'G3DSA:1.25.40.10:FF:000448', NULL, NULL, 'Tetratricopeptide repeat domain 21B', NULL, NULL, NULL, NULL, NULL, 4),
(226924, NULL, 'G3DSA:3.40.50.2000:FF:000402', NULL, NULL, 'Glycosyltransferase family 4 protein', NULL, NULL, NULL, NULL, NULL, 4),
(226925, NULL, 'G3DSA:3.40.640.10:FF:000244', NULL, NULL, 'L-cysteine desulfhydrase', NULL, NULL, NULL, NULL, NULL, 4),
(226926, NULL, 'G3DSA:1.10.510.10:FF:001210', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(226927, NULL, 'G3DSA:1.25.40.10:FF:002382', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g21065', NULL, NULL, NULL, NULL, NULL, 4),
(226928, NULL, 'G3DSA:1.10.287.110:FF:000276', NULL, NULL, 'Molecular chaperone DnaJ family', NULL, NULL, NULL, NULL, NULL, 4),
(226929, NULL, 'G3DSA:1.10.287.440:FF:000004', NULL, NULL, 'Bifunctional purine biosynthesis protein PURH', NULL, NULL, NULL, NULL, NULL, 4),
(226930, NULL, 'G3DSA:3.40.50.300:FF:000540', NULL, NULL, 'probable ATP-dependent RNA helicase DHX34', NULL, NULL, NULL, NULL, NULL, 4),
(226931, NULL, 'G3DSA:1.10.10.10:FF:001885', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226932, NULL, 'G3DSA:3.40.30.10:FF:001240', NULL, NULL, 'AFR718Wp', NULL, NULL, NULL, NULL, NULL, 4),
(226933, NULL, 'G3DSA:3.30.160.60:FF:000707', NULL, NULL, 'Putative Krueppel-like factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(226934, NULL, 'G3DSA:1.20.1070.10:FF:002100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226935, NULL, 'G3DSA:3.30.530.20:FF:000073', NULL, NULL, 'BnaC09g47310D protein', NULL, NULL, NULL, NULL, NULL, 4),
(226936, NULL, 'G3DSA:2.30.30.30:FF:000091', NULL, NULL, '40S ribosomal protein S4, X isoform, putative', NULL, NULL, NULL, NULL, NULL, 4),
(226937, NULL, 'G3DSA:3.40.50.300:FF:002664', NULL, NULL, 'PROBABLE ''COMPONENT LINKED WITH THE ASSEMBLY OF CYTOCHROME'' TRANSPORT TRANSMEMBRANE ATP-BINDING PROTEIN ABC TRANSPORTER CYDC', NULL, NULL, NULL, NULL, NULL, 4),
(226938, NULL, 'G3DSA:3.30.260.10:FF:000060', NULL, NULL, 'AT04835p', NULL, NULL, NULL, NULL, NULL, 4),
(226939, NULL, 'G3DSA:3.10.20.90:FF:000724', NULL, NULL, 'Neutrophil cytosolic factor 2', NULL, NULL, NULL, NULL, NULL, 4),
(226940, NULL, 'G3DSA:3.40.630.10:FF:000423', NULL, NULL, 'Peptidase, M28 family', NULL, NULL, NULL, NULL, NULL, 4),
(226941, NULL, 'G3DSA:3.90.1640.10:FF:000024', NULL, NULL, 'Inorganic pyrophosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(226942, NULL, 'G3DSA:3.40.50.300:FF:007993', NULL, NULL, 'Si:dkey-265e15.2', NULL, NULL, NULL, NULL, NULL, 4),
(226943, NULL, 'G3DSA:2.60.40.10:FF:005699', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226944, NULL, 'G3DSA:2.120.10.30:FF:000433', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226945, NULL, 'G3DSA:1.10.472.10:FF:000132', NULL, NULL, 'Cyclin E1', NULL, NULL, NULL, NULL, NULL, 4),
(226946, NULL, 'G3DSA:1.25.40.10:FF:002702', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226947, NULL, 'G3DSA:2.60.40.60:FF:000447', NULL, NULL, 'Cadherin-related tumor suppressor', NULL, NULL, NULL, NULL, NULL, 4),
(226948, NULL, 'G3DSA:1.25.40.10:FF:003686', NULL, NULL, 'Tetratricopeptide repeat domain 21B', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(226949, NULL, 'G3DSA:3.40.50.1100:FF:000245', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226950, NULL, 'G3DSA:2.40.50.770:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226951, NULL, 'G3DSA:1.10.10.60:FF:000539', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(226952, NULL, 'G3DSA:3.40.190.10:FF:000243', NULL, NULL, 'Phosphate-binding protein PstS', NULL, NULL, NULL, NULL, NULL, 4),
(226953, NULL, 'G3DSA:2.40.50.100:FF:000091', NULL, NULL, 'Molybdenum import ATP-binding protein ModC', NULL, NULL, NULL, NULL, NULL, 4),
(226954, NULL, 'G3DSA:1.25.10.10:FF:000323', NULL, NULL, 'E3 ubiquitin-protein ligase listerin', NULL, NULL, NULL, NULL, NULL, 4),
(226955, NULL, 'G3DSA:3.40.190.10:FF:000136', NULL, NULL, 'ATP phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(226956, NULL, 'G3DSA:1.25.40.10:FF:004310', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g01400, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(226957, NULL, 'G3DSA:1.25.10.10:FF:000430', NULL, NULL, 'Coatomer subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(226958, NULL, 'G3DSA:2.130.10.130:FF:000053', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226959, NULL, 'G3DSA:3.40.50.300:FF:002557', NULL, NULL, 'Axonemal dynein heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(226960, NULL, 'G3DSA:1.20.58.760:FF:000020', NULL, NULL, 'Mitochondrial ATP-dependent zinc metallopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(226961, NULL, 'G3DSA:1.10.238.10:FF:000088', NULL, NULL, 'Calcium uptake protein 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(226962, NULL, 'G3DSA:3.40.30.10:FF:001133', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226963, NULL, 'G3DSA:1.25.40.480:FF:000011', NULL, NULL, 'Fanconi anemia, complementation group E', NULL, NULL, NULL, NULL, NULL, 4),
(226964, NULL, 'G3DSA:3.10.450.240:FF:000017', NULL, NULL, 'Mitochondrial import inner membrane translocase subunit TIM44', NULL, NULL, NULL, NULL, NULL, 4),
(226965, NULL, 'G3DSA:2.130.10.10:FF:002158', NULL, NULL, 'Flagellar_Member_5', NULL, NULL, NULL, NULL, NULL, 4),
(226966, NULL, 'G3DSA:2.30.30.40:FF:000447', NULL, NULL, 'neutrophil cytosolic factor 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(226967, NULL, 'G3DSA:2.120.10.30:FF:000068', NULL, NULL, 'NHL repeat-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(226968, NULL, 'G3DSA:1.20.140.40:FF:000047', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(226969, NULL, 'G3DSA:2.30.30.30:FF:000102', NULL, NULL, 'Elongation factor P', NULL, NULL, NULL, NULL, NULL, 4),
(226970, NULL, 'G3DSA:2.130.10.10:FF:000360', NULL, NULL, 'DENN domain and WD repeat-containing protein SCD1', NULL, NULL, NULL, NULL, NULL, 4),
(226971, NULL, 'G3DSA:3.10.20.90:FF:000617', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(226972, NULL, 'G3DSA:2.10.25.10:FF:000894', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(226973, NULL, 'G3DSA:3.10.20.230:FF:000002', NULL, NULL, 'serine/threonine-protein kinase DCLK2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(226974, NULL, 'G3DSA:1.20.1070.10:FF:001583', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226975, NULL, 'G3DSA:3.40.630.30:FF:000648', NULL, NULL, 'Putative phosphinothricin acetyltransferase YwnH', NULL, NULL, NULL, NULL, NULL, 4),
(226976, NULL, 'G3DSA:2.130.10.10:FF:004631', NULL, NULL, 'Protein HIRA', NULL, NULL, NULL, NULL, NULL, 4),
(226977, NULL, 'G3DSA:3.40.50.1100:FF:000138', NULL, NULL, 'Tryptophan synthase beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(226978, NULL, 'G3DSA:3.30.465.10:FF:000030', NULL, NULL, 'probable D-lactate dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(226979, NULL, 'G3DSA:3.30.160.60:FF:003889', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226980, NULL, 'G3DSA:3.10.100.10:FF:000340', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(226981, NULL, 'G3DSA:3.30.160.60:FF:002478', NULL, NULL, 'Zinc finger protein 985', NULL, NULL, NULL, NULL, NULL, 4),
(226982, NULL, 'G3DSA:1.10.3260.10:FF:000004', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(226983, NULL, 'G3DSA:2.60.40.10:FF:000921', NULL, NULL, 'sialoadhesin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(226984, NULL, 'G3DSA:3.30.160.60:FF:000354', NULL, NULL, 'C2H2 finger domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(226985, NULL, 'G3DSA:3.80.10.10:FF:001467', NULL, NULL, 'F-box protein SKIP17', NULL, NULL, NULL, NULL, NULL, 4),
(226986, NULL, 'G3DSA:1.20.120.730:FF:000027', NULL, NULL, 'Protein transport protein SEC23', NULL, NULL, NULL, NULL, NULL, 4),
(226987, NULL, 'G3DSA:3.40.1790.10:FF:000001', NULL, NULL, 'Indigoidine synthase A family protein', NULL, NULL, NULL, NULL, NULL, 4),
(226988, NULL, 'G3DSA:3.30.60.30:FF:000124', NULL, NULL, 'Follistatin-related protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(226989, NULL, 'G3DSA:1.25.40.540:FF:000029', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(226990, NULL, 'G3DSA:3.10.100.10:FF:000031', NULL, NULL, 'macrophage mannose receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(226991, NULL, 'G3DSA:2.60.40.10:FF:003928', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(226992, NULL, 'G3DSA:2.60.40.1660:FF:000021', NULL, NULL, 'Sodium/potassium-transporting ATPase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(226993, NULL, 'G3DSA:1.25.40.20:FF:000570', NULL, NULL, 'Glycerophosphocholine phosphodiesterase Gde1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(226994, NULL, 'G3DSA:3.40.50.300:FF:004446', NULL, NULL, 'DDX6 isoform 2', NULL, NULL, NULL, NULL, NULL, 4),
(226995, NULL, 'G3DSA:2.30.30.140:FF:000168', NULL, NULL, 'Qin', NULL, NULL, NULL, NULL, NULL, 4),
(226996, NULL, 'G3DSA:1.25.40.10:FF:000139', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(226997, NULL, 'G3DSA:1.10.238.10:FF:000318', NULL, NULL, 'GG16823', NULL, NULL, NULL, NULL, NULL, 4),
(226998, NULL, 'G3DSA:3.30.40.10:FF:001836', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(226999, NULL, 'G3DSA:3.80.10.10:FF:003491', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(227000, NULL, 'G3DSA:3.40.1110.10:FF:000384', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227001, NULL, 'G3DSA:3.30.60.20:FF:000121', NULL, NULL, 'Probable serine/threonine-protein kinase DDB_G0288147', NULL, NULL, NULL, NULL, NULL, 4),
(227002, NULL, 'G3DSA:3.30.830.10:FF:000233', NULL, NULL, 'AGR251Cp', NULL, NULL, NULL, NULL, NULL, 4),
(227003, NULL, 'G3DSA:3.40.47.10:FF:000300', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227004, NULL, 'G3DSA:2.30.160.11:FF:000001', NULL, NULL, 'G-protein coupled receptor Mth', NULL, NULL, NULL, NULL, NULL, 4),
(227005, NULL, 'G3DSA:3.30.70.330:FF:001746', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227006, NULL, 'G3DSA:3.20.20.100:FF:000040', NULL, NULL, 'Putative aldo-keto reductase', NULL, NULL, NULL, NULL, NULL, 4),
(227007, NULL, 'G3DSA:2.30.42.10:FF:000213', NULL, NULL, 'tax1-binding protein 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(227008, NULL, 'G3DSA:3.30.160.60:FF:004513', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227009, NULL, 'G3DSA:2.30.29.30:FF:000020', NULL, NULL, 'Actin filament-associated protein 1-like 2 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(227010, NULL, 'G3DSA:3.40.640.10:FF:000025', NULL, NULL, 'Histidine decarboxylase', NULL, NULL, NULL, NULL, NULL, 4),
(227011, NULL, 'G3DSA:2.40.50.140:FF:000523', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(227012, NULL, 'G3DSA:2.130.10.10:FF:001990', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227013, NULL, 'G3DSA:2.170.260.10:FF:000014', NULL, NULL, 'AGAP012289-PA', NULL, NULL, NULL, NULL, NULL, 4),
(227014, NULL, 'G3DSA:3.30.572.10:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(227015, NULL, 'G3DSA:2.60.120.260:FF:000500', NULL, NULL, 'Highwire, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227016, NULL, 'G3DSA:1.20.1270.60:FF:000197', NULL, NULL, 'YALI0B15686p', NULL, NULL, NULL, NULL, NULL, 4),
(227017, NULL, 'G3DSA:1.20.120.350:FF:000127', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(227018, NULL, 'G3DSA:2.60.40.60:FF:000812', NULL, NULL, 'Putative protocadherin beta-18', NULL, NULL, NULL, NULL, NULL, 4),
(227019, NULL, 'G3DSA:3.10.20.590:FF:000003', NULL, NULL, 'Leucine-tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(227020, NULL, 'G3DSA:3.30.160.60:FF:002259', NULL, NULL, 'zinc finger protein 271', NULL, NULL, NULL, NULL, NULL, 4),
(227021, NULL, 'G3DSA:2.40.50.140:FF:001069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227022, NULL, 'G3DSA:3.40.50.1820:FF:001096', NULL, NULL, 'Lipase', NULL, NULL, NULL, NULL, NULL, 4),
(227023, NULL, 'G3DSA:3.10.20.90:FF:000926', NULL, NULL, 'Meiotically up-regulated gene 70 protein', NULL, NULL, NULL, NULL, NULL, 4),
(227024, NULL, 'G3DSA:3.30.200.20:FF:000424', NULL, NULL, 'obscurin isoform X5', NULL, NULL, NULL, NULL, NULL, 4),
(227025, NULL, 'G3DSA:3.40.140.10:FF:000206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227026, NULL, 'G3DSA:3.40.50.10990:FF:000012', NULL, NULL, '3,4-dihydroxy-2-butanone-4-phoshate synthase/GTP cyclohydrolase II', NULL, NULL, NULL, NULL, NULL, 4),
(227027, NULL, 'G3DSA:3.30.70.920:FF:000052', NULL, NULL, 'Lrp/AsnC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(227028, NULL, 'G3DSA:3.30.200.20:FF:000514', NULL, NULL, 'Serine/threonine-protein kinase BUR1', NULL, NULL, NULL, NULL, NULL, 4),
(227029, NULL, 'G3DSA:1.10.10.1340:FF:000009', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 31', NULL, NULL, NULL, NULL, NULL, 4),
(227030, NULL, 'G3DSA:2.60.40.10:FF:000702', NULL, NULL, 'Myotilin', NULL, NULL, NULL, NULL, NULL, 4),
(227031, NULL, 'G3DSA:2.30.36.70:FF:000020', NULL, NULL, 'Actin-like protein 6A', NULL, NULL, NULL, NULL, NULL, 4),
(227032, NULL, 'G3DSA:3.80.10.10:FF:003721', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227033, NULL, 'G3DSA:2.60.40.150:FF:000065', NULL, NULL, 'phosphatidylinositol 4-phosphate 3-kinase C2 domain-containing subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(227034, NULL, 'G3DSA:3.20.20.370:FF:000014', NULL, NULL, 'Chitin binding Peritrophin-A', NULL, NULL, NULL, NULL, NULL, 4),
(227035, NULL, 'G3DSA:4.10.410.10:FF:000039', NULL, NULL, 'Protein CBR-MLT-11', NULL, NULL, NULL, NULL, NULL, 4),
(227036, NULL, 'G3DSA:3.90.70.10:FF:000655', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(227037, NULL, 'G3DSA:3.30.230.10:FF:000013', NULL, NULL, 'DNA mismatch repair endonuclease MutL', NULL, NULL, NULL, NULL, NULL, 4),
(227038, NULL, 'G3DSA:3.30.1230.20:FF:000010', NULL, NULL, '40S ribosomal protein S21', NULL, NULL, NULL, NULL, NULL, 4),
(227039, NULL, 'G3DSA:1.10.472.10:FF:000351', NULL, NULL, 'Cyclin domain-containing protein, variant 1', NULL, NULL, NULL, NULL, NULL, 4),
(227040, NULL, 'G3DSA:1.20.1250.20:FF:001375', NULL, NULL, 'Putative MFS-type transporter C09D4.1', NULL, NULL, NULL, NULL, NULL, 4),
(227041, NULL, 'G3DSA:1.25.10.10:FF:002228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227042, NULL, 'G3DSA:2.60.200.20:FF:000264', NULL, NULL, 'SMAD/FHA domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(227043, NULL, 'G3DSA:1.10.1380.10:FF:000001', NULL, NULL, 'endothelin-converting enzyme 2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(227044, NULL, 'G3DSA:3.30.1360.10:FF:000033', NULL, NULL, 'DNA-directed RNA polymerase II, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227045, NULL, 'G3DSA:2.40.30.10:FF:000264', NULL, NULL, 'GTP binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(227046, NULL, 'G3DSA:1.20.1070.10:FF:001274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227047, NULL, 'G3DSA:2.60.120.260:FF:000180', NULL, NULL, 'SUN domain-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(227048, NULL, 'G3DSA:3.90.190.20:FF:000021', NULL, NULL, 'UDP-N-acetylmuramoyl-tripeptide--D-alanyl-D-alanine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(227049, NULL, 'G3DSA:2.60.40.10:FF:004283', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227050, NULL, 'G3DSA:3.30.420.40:FF:000727', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227051, NULL, 'G3DSA:1.20.58.920:FF:000001', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(227052, NULL, 'G3DSA:2.60.40.10:FF:002843', NULL, NULL, 'Chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(227053, NULL, 'G3DSA:1.10.150.20:FF:000134', NULL, NULL, 'ImpB/MucB/SamB family protein', NULL, NULL, NULL, NULL, NULL, 4),
(227054, NULL, 'G3DSA:3.55.50.30:FF:000033', NULL, NULL, 'Putative anti-sigma factor', NULL, NULL, NULL, NULL, NULL, 4),
(227055, NULL, 'G3DSA:3.90.550.10:FF:000456', NULL, NULL, 'Glycoside transferase family 2', NULL, NULL, NULL, NULL, NULL, 4),
(227056, NULL, 'G3DSA:3.90.260.10:FF:000030', NULL, NULL, 'DNA repair protein Rad4 homologue, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227057, NULL, 'G3DSA:1.10.1420.10:FF:000191', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227058, NULL, 'G3DSA:3.90.70.10:FF:000346', NULL, NULL, 'IgG-degrading protease', NULL, NULL, NULL, NULL, NULL, 4),
(227059, NULL, 'G3DSA:3.30.70.1560:FF:000003', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(227060, NULL, 'G3DSA:3.40.50.200:FF:000049', NULL, NULL, 'Subtilase cytotoxin subunit A', NULL, NULL, NULL, NULL, NULL, 4),
(227061, NULL, 'G3DSA:3.40.50.300:FF:003030', NULL, NULL, 'Putative DNA replication licensing factor', NULL, NULL, NULL, NULL, NULL, 4),
(227062, NULL, 'G3DSA:3.30.70.330:FF:001853', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227063, NULL, 'G3DSA:2.60.40.150:FF:000374', NULL, NULL, 'Phosphatidylinositol-4,5-bisphosphate 3-kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227064, NULL, 'G3DSA:3.30.160.60:FF:002276', NULL, NULL, 'zinc finger protein 263 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(227065, NULL, 'G3DSA:3.10.50.30:FF:000006', NULL, NULL, 'Nucleoside diphosphate kinase regulator', NULL, NULL, NULL, NULL, NULL, 4),
(227066, NULL, 'G3DSA:3.30.40.10:FF:000190', NULL, NULL, 'B-cell CLL/lymphoma 9, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(227067, NULL, 'G3DSA:3.40.640.10:FF:000227', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(227068, NULL, 'G3DSA:3.40.50.620:FF:000242', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(227069, NULL, 'G3DSA:1.20.5.340:FF:000007', NULL, NULL, 'Myosin heavy chain, non-muscle', NULL, NULL, NULL, NULL, NULL, 4),
(227070, NULL, 'G3DSA:1.20.1250.20:FF:001268', NULL, NULL, 'Major facilitator superfamily domain containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(227071, NULL, 'G3DSA:1.25.40.10:FF:002365', NULL, NULL, 'PPR repeat/Pentatricopeptide repeat domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227072, NULL, 'G3DSA:1.25.40.20:FF:000816', NULL, NULL, 'Ankyrin repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(227073, NULL, 'G3DSA:2.120.10.30:FF:000214', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227074, NULL, 'G3DSA:2.10.25.10:FF:000568', NULL, NULL, 'Fibulin 7', NULL, NULL, NULL, NULL, NULL, 4),
(227075, NULL, 'G3DSA:2.40.10.10:FF:000701', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227076, NULL, 'G3DSA:1.20.120.140:FF:000036', NULL, NULL, 'Signal recognition particle protein (Docking protein), probable', NULL, NULL, NULL, NULL, NULL, 4),
(227077, NULL, 'G3DSA:3.30.470.30:FF:000003', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(227078, NULL, 'G3DSA:3.40.50.150:FF:000871', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(227079, NULL, 'G3DSA:3.30.2350.10:FF:000061', NULL, NULL, 'RNA pseudouridine synthase 2, chloroplastic isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(227080, NULL, 'G3DSA:3.30.70.420:FF:000003', NULL, NULL, 'L-ascorbate peroxidase 2 cytosolic', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(227081, NULL, 'G3DSA:2.40.50.100:FF:000225', NULL, NULL, 'Gll2840 protein', NULL, NULL, NULL, NULL, NULL, 4),
(227082, NULL, 'G3DSA:3.30.160.60:FF:002624', NULL, NULL, 'ZNF230 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(227083, NULL, 'G3DSA:2.40.110.10:FF:000034', NULL, NULL, 'Acyl-CoA dehydrogenase FadE24', NULL, NULL, NULL, NULL, NULL, 4),
(227084, NULL, 'G3DSA:3.40.50.10810:FF:000015', NULL, NULL, 'lymphoid-specific helicase isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(227085, NULL, 'G3DSA:1.20.5.320:FF:000001', NULL, NULL, '6-phosphogluconate dehydrogenase, decarboxylating', NULL, NULL, NULL, NULL, NULL, 4),
(227086, NULL, 'G3DSA:1.10.510.10:FF:000570', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(227087, NULL, 'G3DSA:2.80.10.50:FF:000037', NULL, NULL, 'Fascin', NULL, NULL, NULL, NULL, NULL, 4),
(227088, NULL, 'G3DSA:2.70.98.20:FF:000023', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(227089, NULL, 'G3DSA:3.30.2350.20:FF:000064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227090, NULL, 'G3DSA:2.80.10.50:FF:000144', NULL, NULL, 'Phospholipase A2 receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(227091, NULL, 'G3DSA:3.40.50.300:FF:006239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227092, NULL, 'G3DSA:1.10.510.10:FF:002514', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227093, NULL, 'G3DSA:2.30.30.40:FF:000431', NULL, NULL, 'Bud emergence protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227094, NULL, 'G3DSA:3.30.1010.10:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227095, NULL, 'G3DSA:2.20.25.10:FF:000135', NULL, NULL, 'Methyltransferase type 11', NULL, NULL, NULL, NULL, NULL, 4),
(227096, NULL, 'G3DSA:1.25.40.10:FF:000813', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(227097, NULL, 'G3DSA:2.70.98.10:FF:000020', NULL, NULL, 'Rhamnogalacturonate lyase A', NULL, NULL, NULL, NULL, NULL, 4),
(227098, NULL, 'G3DSA:2.60.40.150:FF:000716', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(227099, NULL, 'G3DSA:3.30.70.1660:FF:000033', NULL, NULL, 'Mitochondrial translational release factor 1-like', NULL, NULL, NULL, NULL, NULL, 4),
(227100, NULL, 'G3DSA:1.10.8.10:FF:000277', NULL, NULL, 'UBA/TS-N domain protein (AFU_orthologue AFUA_5G09630)', NULL, NULL, NULL, NULL, NULL, 4),
(227101, NULL, 'G3DSA:1.10.600.10:FF:000020', NULL, NULL, 'Phytoene synthase', NULL, NULL, NULL, NULL, NULL, 4),
(227102, NULL, 'G3DSA:3.90.1310.10:FF:000033', NULL, NULL, 'Cell division protein FtsI [Peptidoglycan synthetase]', NULL, NULL, NULL, NULL, NULL, 4),
(227103, NULL, 'G3DSA:3.40.50.10800:FF:000012', NULL, NULL, 'Quinolinate synthase A', NULL, NULL, NULL, NULL, NULL, 4),
(227104, NULL, 'G3DSA:3.40.50.150:FF:000197', NULL, NULL, 'spermine synthase isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(227105, NULL, 'G3DSA:3.40.50.720:FF:002110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227106, NULL, 'G3DSA:2.60.120.650:FF:000055', NULL, NULL, 'Jhd2p', NULL, NULL, NULL, NULL, NULL, 4),
(227107, NULL, 'G3DSA:2.20.25.10:FF:000028', NULL, NULL, 'Transcription elongation factor A protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(227108, NULL, 'G3DSA:2.70.170.10:FF:000121', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(227109, NULL, 'G3DSA:3.30.200.20:FF:002122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227110, NULL, 'G3DSA:1.10.287.70:FF:000758', NULL, NULL, 'Protein CBR-SHW-1', NULL, NULL, NULL, NULL, NULL, 4),
(227111, NULL, 'G3DSA:1.10.10.10:FF:000334', NULL, NULL, 'Heat shock factor protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(227112, NULL, 'G3DSA:2.120.10.80:FF:000313', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227113, NULL, 'G3DSA:3.40.50.1980:FF:000132', NULL, NULL, 'ABC-type transport system periplasmic substrate-binding protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(227114, NULL, 'G3DSA:3.40.50.300:FF:000394', NULL, NULL, 'ATP-binding cassette, sub-family C (CFTR/MRP), member 9', NULL, NULL, NULL, NULL, NULL, 4),
(227115, NULL, 'G3DSA:2.60.40.10:FF:001410', NULL, NULL, 'Interleukin 18 receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(227116, NULL, 'G3DSA:3.40.50.300:FF:005767', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227117, NULL, 'G3DSA:3.40.50.720:FF:001918', NULL, NULL, 'NAD(P)-binding Rossmann-fold superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(227118, NULL, 'G3DSA:3.50.50.60:FF:000108', NULL, NULL, 'Rab proteins geranylgeranyltransferase component A', NULL, NULL, NULL, NULL, NULL, 4),
(227119, NULL, 'G3DSA:3.30.160.60:FF:004530', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227120, NULL, 'G3DSA:3.90.110.10:FF:000002', NULL, NULL, 'Malate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(227121, NULL, 'G3DSA:3.30.200.20:FF:001498', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(227122, NULL, 'G3DSA:2.60.120.10:FF:000654', NULL, NULL, 'Cysteine dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(227123, NULL, 'G3DSA:3.30.40.140:FF:000003', NULL, NULL, 'RING/U-box superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(227124, NULL, 'G3DSA:2.30.180.10:FF:000119', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227125, NULL, 'G3DSA:3.40.630.10:FF:000053', NULL, NULL, 'glutaminyl-peptide cyclotransferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(227126, NULL, 'G3DSA:3.40.50.140:FF:000014', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(227127, NULL, 'G3DSA:1.20.120.1900:FF:000060', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(227128, NULL, 'G3DSA:3.40.50.670:FF:000015', NULL, NULL, 'DNA gyrase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(227129, NULL, 'G3DSA:2.60.40.10:FF:005845', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227130, NULL, 'G3DSA:3.40.50.12780:FF:000010', NULL, NULL, 'Long-chain-fatty-acid--CoA ligase 4 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(227131, NULL, 'G3DSA:1.10.510.10:FF:004313', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227132, NULL, 'G3DSA:3.40.50.10810:FF:000138', NULL, NULL, 'Protein CHROMATIN REMODELING 35', NULL, NULL, NULL, NULL, NULL, 4),
(227133, NULL, 'G3DSA:3.80.10.10:FF:002310', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227134, NULL, 'G3DSA:3.40.640.10:FF:000334', NULL, NULL, 'Serine-pyruvate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(227135, NULL, 'G3DSA:2.60.120.10:FF:000564', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227136, NULL, 'G3DSA:3.10.180.10:FF:000030', NULL, NULL, 'Glyoxalase I', NULL, NULL, NULL, NULL, NULL, 4),
(227137, NULL, 'G3DSA:1.20.1270.280:FF:000039', NULL, NULL, 'Dynein heavy chain 1, cytosolic', NULL, NULL, NULL, NULL, NULL, 4),
(227138, NULL, 'G3DSA:2.10.220.10:FF:000049', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(227139, NULL, 'G3DSA:2.120.10.30:FF:000540', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227140, NULL, 'G3DSA:2.60.40.420:FF:000022', NULL, NULL, 'FET5p Multicopper oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(227141, NULL, 'G3DSA:3.40.190.10:FF:000271', NULL, NULL, 'Arogenate dehydratase/prephenate dehydratase 1', NULL, NULL, NULL, NULL, NULL, 4),
(227142, NULL, 'G3DSA:2.40.440.10:FF:000008', NULL, NULL, 'L,D-transpeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(227143, NULL, 'G3DSA:3.10.20.70:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227144, NULL, 'G3DSA:3.40.50.1000:FF:000350', NULL, NULL, 'Acyl-CoA dehydrogenase family member 10', NULL, NULL, NULL, NULL, NULL, 4),
(227145, NULL, 'G3DSA:1.25.40.10:FF:001893', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(227146, NULL, 'G3DSA:3.30.830.10:FF:000216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(227147, NULL, 'G3DSA:1.25.40.10:FF:003995', NULL, NULL, 'Clathrin heavy chain 2', NULL, NULL, NULL, NULL, NULL, 4),
(227148, NULL, 'G3DSA:3.30.70.1230:FF:000146', NULL, NULL, 'Atrial natriuretic peptide receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227149, NULL, 'G3DSA:1.20.58.480:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227150, NULL, 'G3DSA:3.40.50.300:FF:002187', NULL, NULL, 'AAA family ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(227151, NULL, 'G3DSA:1.25.40.20:FF:001896', NULL, NULL, 'Molting protein MLT-4', NULL, NULL, NULL, NULL, NULL, 4),
(227152, NULL, 'G3DSA:3.40.50.2300:FF:001459', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227153, NULL, 'G3DSA:3.30.2010.10:FF:000024', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227154, NULL, 'G3DSA:3.40.50.150:FF:000236', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(227155, NULL, 'G3DSA:1.25.10.10:FF:002431', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(227156, NULL, 'G3DSA:2.30.29.30:FF:000958', NULL, NULL, 'Putative sorting nexin-29', NULL, NULL, NULL, NULL, NULL, 4),
(227157, NULL, 'G3DSA:3.60.15.10:FF:000006', NULL, NULL, 'MBL fold metallo-hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(227158, NULL, 'G3DSA:1.10.10.10:FF:000250', NULL, NULL, 'transcription factor Spi-B isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(227159, NULL, 'G3DSA:3.30.160.60:FF:005839', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227160, NULL, 'G3DSA:1.20.1270.10:FF:000098', NULL, NULL, 'Heat shock protein 70 homolog lhs1', NULL, NULL, NULL, NULL, NULL, 4),
(227161, NULL, 'G3DSA:2.70.150.10:FF:000193', NULL, NULL, 'Probable cadmium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(227162, NULL, 'G3DSA:2.60.120.650:FF:000201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227163, NULL, 'G3DSA:1.10.510.10:FF:002059', NULL, NULL, 'RfeA', NULL, NULL, NULL, NULL, NULL, 4),
(227164, NULL, 'G3DSA:2.60.40.150:FF:000172', NULL, NULL, 'C2 calcium-dependent domain-containing protein 4C', NULL, NULL, NULL, NULL, NULL, 4),
(227165, NULL, 'G3DSA:3.40.720.10:FF:000189', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227166, NULL, 'G3DSA:3.30.300.130:FF:000020', NULL, NULL, 'Iron-sulfur cluster carrier protein', NULL, NULL, NULL, NULL, NULL, 4),
(227167, NULL, 'G3DSA:2.60.120.10:FF:000671', NULL, NULL, 'Cysteine dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(227168, NULL, 'G3DSA:3.30.530.20:FF:000056', NULL, NULL, 'Uncharacterized conserved protein', NULL, NULL, NULL, NULL, NULL, 4),
(227169, NULL, 'G3DSA:3.40.50.1820:FF:001079', NULL, NULL, 'Hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(227170, NULL, 'G3DSA:3.30.160.60:FF:005497', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227171, NULL, 'G3DSA:2.130.10.10:FF:005677', NULL, NULL, 'Protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227172, NULL, 'G3DSA:3.40.50.1820:FF:000331', NULL, NULL, 'Prolyl endopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(227173, NULL, 'G3DSA:3.30.1640.10:FF:000055', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(227174, NULL, 'G3DSA:3.40.50.300:FF:002529', NULL, NULL, 'Probable ATP-dependent RNA helicase DDX28', NULL, NULL, NULL, NULL, NULL, 4),
(227175, NULL, 'G3DSA:1.20.1110.10:FF:000266', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227176, NULL, 'G3DSA:3.40.50.300:FF:006700', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227177, NULL, 'G3DSA:3.30.420.150:FF:000007', NULL, NULL, 'Retrograde regulation protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(227178, NULL, 'G3DSA:3.30.420.140:FF:000004', NULL, NULL, 'Transcription elongation factor spt6', NULL, NULL, NULL, NULL, NULL, 4),
(227179, NULL, 'G3DSA:2.160.10.10:FF:000100', NULL, NULL, 'UDP-3-O-acylglucosamine N-acyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(227180, NULL, 'G3DSA:1.10.3380.10:FF:000058', NULL, NULL, 'Helicase', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(227181, NULL, 'G3DSA:3.30.230.10:FF:000030', NULL, NULL, 'PMS1 homolog 1, mismatch repair system component', NULL, NULL, NULL, NULL, NULL, 4),
(227182, NULL, 'G3DSA:3.30.565.10:FF:000537', NULL, NULL, 'Sensory histidine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(227183, NULL, 'G3DSA:3.90.550.10:FF:000349', NULL, NULL, 'Glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(227184, NULL, 'G3DSA:3.30.200.20:FF:000177', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(227185, NULL, 'G3DSA:2.160.20.10:FF:000235', NULL, NULL, 'Cell surface protein', NULL, NULL, NULL, NULL, NULL, 4),
(227186, NULL, 'G3DSA:2.40.50.140:FF:000630', NULL, NULL, 'Asparaginyl-tRNA synthetase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(227187, NULL, 'G3DSA:2.130.10.10:FF:002714', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227188, NULL, 'G3DSA:1.20.1250.20:FF:001358', NULL, NULL, 'Membrane transporter', NULL, NULL, NULL, NULL, NULL, 4),
(227189, NULL, 'G3DSA:3.30.830.10:FF:000126', NULL, NULL, 'Clan ME, family M16, insulinase-like metallopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(227190, NULL, 'G3DSA:2.60.40.60:FF:000475', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227191, NULL, 'G3DSA:2.20.70.10:FF:000205', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227192, NULL, 'G3DSA:2.10.25.10:FF:001276', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227193, NULL, 'G3DSA:2.130.10.10:FF:004266', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227194, NULL, 'G3DSA:3.30.160.60:FF:002950', NULL, NULL, 'Zinc finger protein 705F', NULL, NULL, NULL, NULL, NULL, 4),
(227195, NULL, 'G3DSA:3.40.50.2300:FF:000048', NULL, NULL, 'HTH-type transcriptional regulator GalR', NULL, NULL, NULL, NULL, NULL, 4),
(227196, NULL, 'G3DSA:1.20.5.780:FF:000009', NULL, NULL, 'FXYD domain-containing ion transport regulator', NULL, NULL, NULL, NULL, NULL, 4),
(227197, NULL, 'G3DSA:1.10.510.10:FF:002368', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227198, NULL, 'G3DSA:3.90.190.20:FF:000004', NULL, NULL, 'Dihydrofolate synthase/folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(227199, NULL, 'G3DSA:3.90.190.10:FF:000001', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase F isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(227200, NULL, 'G3DSA:3.40.50.300:FF:004665', NULL, NULL, 'p-loop containing nucleoside triphosphate hydrolase protein', NULL, NULL, NULL, NULL, NULL, 4),
(227201, NULL, 'G3DSA:3.40.50.150:FF:001040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227202, NULL, 'G3DSA:2.60.40.10:FF:005929', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227203, NULL, 'G3DSA:3.30.565.10:FF:000228', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(227204, NULL, 'G3DSA:3.30.450.40:FF:000246', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(227205, NULL, 'G3DSA:1.20.1070.10:FF:000402', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227206, NULL, 'G3DSA:1.10.10.60:FF:000197', NULL, NULL, 'Homeobox-leucine zipper protein REVOLUTA', NULL, NULL, NULL, NULL, NULL, 4),
(227207, NULL, 'G3DSA:2.30.30.40:FF:000650', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(227208, NULL, 'G3DSA:3.40.1400.10:FF:000001', NULL, NULL, 'Ribose 5-phosphate isomerase B', NULL, NULL, NULL, NULL, NULL, 4),
(227209, NULL, 'G3DSA:1.20.58.80:FF:000043', NULL, NULL, 'WGS project CABT00000000 data, contig 2.46', NULL, NULL, NULL, NULL, NULL, 4),
(227210, NULL, 'G3DSA:1.10.8.1240:FF:000002', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(227211, NULL, 'G3DSA:2.130.10.10:FF:005896', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227212, NULL, 'G3DSA:3.40.640.10:FF:000008', NULL, NULL, 'Lysine decarboxylase, inducible', NULL, NULL, NULL, NULL, NULL, 4),
(227213, NULL, 'G3DSA:1.10.472.10:FF:000148', NULL, NULL, 'Transcription initiation factor iib, putative', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(227214, NULL, 'G3DSA:3.40.47.10:FF:000154', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227215, NULL, 'G3DSA:3.30.559.70:FF:000035', NULL, NULL, 'Carnitine acyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227216, NULL, 'G3DSA:3.40.50.720:FF:000778', NULL, NULL, 'NAD binding Rossmann fold oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227217, NULL, 'G3DSA:3.40.50.720:FF:001582', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227218, NULL, 'G3DSA:1.25.40.10:FF:002056', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(227219, NULL, 'G3DSA:1.10.20.10:FF:000076', NULL, NULL, 'Histone H4', NULL, NULL, NULL, NULL, NULL, 4),
(227220, NULL, 'G3DSA:3.40.50.2300:FF:001369', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227221, NULL, 'G3DSA:1.10.357.150:FF:000001', NULL, NULL, 'centromere/kinetochore protein zw10 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(227222, NULL, 'G3DSA:2.60.40.150:FF:000391', NULL, NULL, 'Phospholipase A2', NULL, NULL, NULL, NULL, NULL, 4),
(227223, NULL, 'G3DSA:3.30.230.130:FF:000048', NULL, NULL, 'Cullin', NULL, NULL, NULL, NULL, NULL, 4),
(227224, NULL, 'G3DSA:3.90.1140.10:FF:000014', NULL, NULL, 'U6 snRNA phosphodiesterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227225, NULL, 'G3DSA:2.60.40.1860:FF:000002', NULL, NULL, 'Peptidyl arginine deiminase 3', NULL, NULL, NULL, NULL, NULL, 4),
(227226, NULL, 'G3DSA:3.30.519.10:FF:000032', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227227, NULL, 'G3DSA:3.40.50.2020:FF:000088', NULL, NULL, 'Orotate phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(227228, NULL, 'G3DSA:3.10.110.10:FF:000082', NULL, NULL, 'ubiquitin-conjugating enzyme E2 A', NULL, NULL, NULL, NULL, NULL, 4),
(227229, NULL, 'G3DSA:2.60.40.150:FF:000481', NULL, NULL, 'Phosphoinositide-3-kinase, catalytic, alpha polypeptide', NULL, NULL, NULL, NULL, NULL, 4),
(227230, NULL, 'G3DSA:1.10.1420.10:FF:000056', NULL, NULL, 'MutS homolog 4', NULL, NULL, NULL, NULL, NULL, 4),
(227231, NULL, 'G3DSA:3.20.20.140:FF:000378', NULL, NULL, 'Ribonuclease P protein component 3', NULL, NULL, NULL, NULL, NULL, 4),
(227232, NULL, 'G3DSA:3.40.50.150:FF:000545', NULL, NULL, 'Anamorsin homolog', NULL, NULL, NULL, NULL, NULL, 4),
(227233, NULL, 'G3DSA:3.30.70.141:FF:000010', NULL, NULL, 'Nucleoside diphosphate kinase 7', NULL, NULL, NULL, NULL, NULL, 4),
(227234, NULL, 'G3DSA:1.10.10.10:FF:000811', NULL, NULL, 'Homoprotocatechuate degradation operon regulator, HpaR', NULL, NULL, NULL, NULL, NULL, 4),
(227235, NULL, 'G3DSA:2.130.10.10:FF:002153', NULL, NULL, 'Telomerase protein component 1', NULL, NULL, NULL, NULL, NULL, 4),
(227236, NULL, 'G3DSA:1.10.530.40:FF:000001', NULL, NULL, 'Lysozyme', NULL, NULL, NULL, NULL, NULL, 4),
(227237, NULL, 'G3DSA:3.30.160.60:FF:006328', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227238, NULL, 'G3DSA:2.130.10.10:FF:002804', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227239, NULL, 'G3DSA:3.90.550.50:FF:000002', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(227240, NULL, 'G3DSA:3.30.200.20:FF:002431', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227241, NULL, 'G3DSA:3.30.505.10:FF:000085', NULL, NULL, 'Transcription elongation factor SPT6', NULL, NULL, NULL, NULL, NULL, 4),
(227242, NULL, 'G3DSA:1.25.40.10:FF:003467', NULL, NULL, 'Os03g0844000 protein', NULL, NULL, NULL, NULL, NULL, 4),
(227243, NULL, 'G3DSA:3.30.500.10:FF:000023', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227244, NULL, 'G3DSA:2.60.200.20:FF:000129', NULL, NULL, 'Type VI secretion system-associated FHA domain protein TagH', NULL, NULL, NULL, NULL, NULL, 4),
(227245, NULL, 'G3DSA:1.10.460.10:FF:000031', NULL, NULL, 'DNA topoisomerase', NULL, NULL, NULL, NULL, NULL, 4),
(227246, NULL, 'G3DSA:3.30.160.60:FF:002405', NULL, NULL, 'tRNA dimethylallyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(227247, NULL, 'G3DSA:1.20.120.720:FF:000007', NULL, NULL, 'unconventional myosin-XVIIIa isoform X2', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(227248, NULL, 'G3DSA:3.30.230.70:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227249, NULL, 'G3DSA:2.60.40.10:FF:004760', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227250, NULL, 'G3DSA:3.30.1610.10:FF:000008', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227251, NULL, 'G3DSA:3.10.100.10:FF:000014', NULL, NULL, 'Macrophage mannose receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(227252, NULL, 'G3DSA:3.40.980.10:FF:000039', NULL, NULL, 'FAD synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(227253, NULL, 'G3DSA:2.40.50.140:FF:000321', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(227254, NULL, 'G3DSA:3.50.50.60:FF:001492', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(227255, NULL, 'G3DSA:3.50.4.10:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227256, NULL, 'G3DSA:3.30.40.10:FF:001499', NULL, NULL, 'YALI0B03300p', NULL, NULL, NULL, NULL, NULL, 4),
(227257, NULL, 'G3DSA:4.10.320.60:FF:000002', NULL, NULL, 'Sulfhydryl oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(227258, NULL, 'G3DSA:2.30.42.10:FF:000230', NULL, NULL, 'Uncharacterized protein, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(227259, NULL, 'G3DSA:3.30.1040.20:FF:000001', NULL, NULL, 'Thiol-activated cytolysin', NULL, NULL, NULL, NULL, NULL, 4),
(227260, NULL, 'G3DSA:1.20.120.350:FF:000099', NULL, NULL, 'Cation channel sperm associated 4', NULL, NULL, NULL, NULL, NULL, 4),
(227261, NULL, 'G3DSA:1.20.1110.10:FF:000047', NULL, NULL, 'Calcium-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(227262, NULL, 'G3DSA:1.25.40.990:FF:000041', NULL, NULL, 'SAC3/GANP family protein', NULL, NULL, NULL, NULL, NULL, 4),
(227263, NULL, 'G3DSA:2.70.150.10:FF:000209', NULL, NULL, 'Magnesium-translocating P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(227264, NULL, 'G3DSA:2.60.40.1960:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227265, NULL, 'G3DSA:3.40.50.1820:FF:001298', NULL, NULL, 'Lipase/esterase', NULL, NULL, NULL, NULL, NULL, 4),
(227266, NULL, 'G3DSA:1.10.238.10:FF:000762', NULL, NULL, 'Putative calcium-binding protein CML46', NULL, NULL, NULL, NULL, NULL, 4),
(227267, NULL, 'G3DSA:2.10.25.10:FF:001602', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227268, NULL, 'G3DSA:1.10.357.50:FF:000033', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(227269, NULL, 'G3DSA:2.30.42.10:FF:000123', NULL, NULL, 'Na(+)/H(+) exchange regulatory cofactor NHE-RF4', NULL, NULL, NULL, NULL, NULL, 4),
(227270, NULL, 'G3DSA:3.70.10.10:FF:000063', NULL, NULL, 'DNA polymerase sliding clamp 1', NULL, NULL, NULL, NULL, NULL, 4),
(227271, NULL, 'G3DSA:2.30.30.40:FF:000015', NULL, NULL, 'Voltage-dependent L-type calcium channel subunit beta-2', NULL, NULL, NULL, NULL, NULL, 4),
(227272, NULL, 'G3DSA:1.20.1080.10:FF:000122', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227273, NULL, 'G3DSA:2.30.30.30:FF:000012', NULL, NULL, 'Eukaryotic translation initiation factor 5A', NULL, NULL, NULL, NULL, NULL, 4),
(227274, NULL, 'G3DSA:1.25.40.20:FF:000586', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(227275, NULL, 'G3DSA:3.30.63.20:FF:000009', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227276, NULL, 'G3DSA:1.20.1440.100:FF:000008', NULL, NULL, 'Haloacid dehalogenase', NULL, NULL, NULL, NULL, NULL, 4),
(227277, NULL, 'G3DSA:1.25.40.70:FF:000028', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit gamma, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227278, NULL, 'G3DSA:3.80.10.10:FF:003047', NULL, NULL, 'Putative F-box/LRR-repeat protein At4g00320', NULL, NULL, NULL, NULL, NULL, 4),
(227279, NULL, 'G3DSA:3.40.1360.10:FF:000065', NULL, NULL, 'Meiotic recombination protein SPO11-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(227280, NULL, 'G3DSA:3.40.50.300:FF:005992', NULL, NULL, 'DnaA-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(227281, NULL, 'G3DSA:3.30.160.60:FF:004058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(227282, NULL, 'G3DSA:2.40.440.10:FF:000025', NULL, NULL, 'ErfK/YbiS/YcfS/YnhG family protein', NULL, NULL, NULL, NULL, NULL, 4),
(227283, NULL, 'G3DSA:3.30.2450.30:FF:000001', NULL, NULL, 'Purine-rich element binding protein A', NULL, NULL, NULL, NULL, NULL, 4),
(227284, NULL, 'G3DSA:2.70.50.70:FF:000001', NULL, NULL, 'Glycoside hydrolase family 61', NULL, NULL, NULL, NULL, NULL, 4),
(227285, NULL, 'G3DSA:3.30.70.80:FF:000027', NULL, NULL, 'Subtilisin-like protease SBT1.6', NULL, NULL, NULL, NULL, NULL, 4),
(227286, NULL, 'G3DSA:2.40.30.10:FF:000242', NULL, NULL, 'tRNA-specific 2-thiouridylase MnmA', NULL, NULL, NULL, NULL, NULL, 4),
(227287, NULL, 'G3DSA:1.25.50.20:FF:000087', NULL, NULL, 'Aminopeptidase A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227288, NULL, 'G3DSA:1.10.8.210:FF:000004', NULL, NULL, 'Trifunctional enzyme subunit', NULL, NULL, NULL, NULL, NULL, 4),
(227289, NULL, 'G3DSA:3.30.160.60:FF:000786', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227290, NULL, 'G3DSA:3.40.50.720:FF:001273', NULL, NULL, 'Glutamate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(227291, NULL, 'G3DSA:3.30.420.40:FF:000076', NULL, NULL, 'Actin-related protein 6', NULL, NULL, NULL, NULL, NULL, 4),
(227292, NULL, 'G3DSA:1.10.1490.10:FF:000004', NULL, NULL, 'DNAation factor, 45kDa, alpha polypeptide, isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(227293, NULL, 'G3DSA:2.10.25.10:FF:001057', NULL, NULL, 'Nimrod C3', NULL, NULL, NULL, NULL, NULL, 4),
(227294, NULL, 'G3DSA:3.30.70.330:FF:002241', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227295, NULL, 'G3DSA:2.130.10.10:FF:005587', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(227296, NULL, 'G3DSA:2.60.120.260:FF:000045', NULL, NULL, 'Reelin', NULL, NULL, NULL, NULL, NULL, 4),
(227297, NULL, 'G3DSA:2.60.40.640:FF:000116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227298, NULL, 'G3DSA:1.20.140.40:FF:000031', NULL, NULL, 'Pectin methylesterase2', NULL, NULL, NULL, NULL, NULL, 4),
(227299, NULL, 'G3DSA:2.120.10.30:FF:000523', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227300, NULL, 'G3DSA:3.10.100.10:FF:000362', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227301, NULL, 'G3DSA:3.60.21.10:FF:000066', NULL, NULL, 'Purple acid phosphatase 16', NULL, NULL, NULL, NULL, NULL, 4),
(227302, NULL, 'G3DSA:3.30.160.60:FF:004529', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227303, NULL, 'G3DSA:2.50.20.10:FF:000004', NULL, NULL, 'Outer membrane lipoprotein carrier protein LolA', NULL, NULL, NULL, NULL, NULL, 4),
(227304, NULL, 'G3DSA:1.10.30.10:FF:000026', NULL, NULL, 'PMS1 homolog 1, mismatch repair system component', NULL, NULL, NULL, NULL, NULL, 4),
(227305, NULL, 'G3DSA:3.40.50.300:FF:000079', NULL, NULL, 'probable ATP-dependent RNA helicase DDX17', NULL, NULL, NULL, NULL, NULL, 4),
(227306, NULL, 'G3DSA:1.10.510.10:FF:001879', NULL, NULL, 'Phosphoinositide 3-kinase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(227307, NULL, 'G3DSA:2.60.120.970:FF:000073', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227308, NULL, 'G3DSA:1.25.10.10:FF:001121', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227309, NULL, 'G3DSA:2.40.10.120:FF:000021', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(227310, NULL, 'G3DSA:3.30.160.60:FF:001787', NULL, NULL, 'Zinc finger protein 619', NULL, NULL, NULL, NULL, NULL, 4),
(227311, NULL, 'G3DSA:3.50.30.60:FF:000001', NULL, NULL, 'Murein tetrapeptide carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(227312, NULL, 'G3DSA:3.40.50.1000:FF:000434', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227313, NULL, 'G3DSA:3.40.449.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227314, NULL, 'G3DSA:3.40.50.720:FF:001267', NULL, NULL, '2-hydroxy-3-oxopropionate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(227315, NULL, 'G3DSA:3.30.1340.10:FF:000009', NULL, NULL, 'PTS system nitrogen regulatory IIA component', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(227316, NULL, 'G3DSA:3.90.79.10:FF:000175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227317, NULL, 'G3DSA:3.30.420.80:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227318, NULL, 'G3DSA:3.90.175.10:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227319, NULL, 'G3DSA:3.30.830.10:FF:000087', NULL, NULL, 'Probable zinc protease PqqL', NULL, NULL, NULL, NULL, NULL, 4),
(227320, NULL, 'G3DSA:1.10.357.10:FF:000072', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(227321, NULL, 'G3DSA:3.30.63.10:FF:000006', NULL, NULL, 'Guanylate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(227322, NULL, 'G3DSA:1.10.8.270:FF:000016', NULL, NULL, 'TBC1 domain family member 2A', NULL, NULL, NULL, NULL, NULL, 4),
(227323, NULL, 'G3DSA:2.10.25.10:FF:001591', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(227324, NULL, 'G3DSA:2.60.40.150:FF:000407', NULL, NULL, 'Phosphatidylinositol 3-kinase VPS34', NULL, NULL, NULL, NULL, NULL, 4),
(227325, NULL, 'G3DSA:2.60.40.150:FF:000155', NULL, NULL, 'extended synaptotagmin-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(227326, NULL, 'G3DSA:3.40.1280.10:FF:000120', NULL, NULL, 'rRNA methylase', NULL, NULL, NULL, NULL, NULL, 4),
(227327, NULL, 'G3DSA:1.20.58.70:FF:000040', NULL, NULL, 'CBN-SYX-2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(227328, NULL, 'G3DSA:1.25.10.10:FF:002902', NULL, NULL, 'Protein CBR-PPFR-1', NULL, NULL, NULL, NULL, NULL, 4),
(227329, NULL, 'G3DSA:2.30.22.10:FF:000015', NULL, NULL, 'Protein GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(227330, NULL, 'G3DSA:3.30.450.40:FF:000224', NULL, NULL, 'Two-component signal transduction', NULL, NULL, NULL, NULL, NULL, 4),
(227331, NULL, 'G3DSA:3.30.450.20:FF:000105', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(227332, NULL, 'G3DSA:3.10.20.90:FF:000578', NULL, NULL, 'Ubiquitin C', NULL, NULL, NULL, NULL, NULL, 4),
(227333, NULL, 'G3DSA:2.60.40.10:FF:000718', NULL, NULL, 'Tyrosine-protein kinase receptor', NULL, NULL, NULL, NULL, NULL, 4),
(227334, NULL, 'G3DSA:3.40.120.10:FF:000115', NULL, NULL, 'LOC100170455 protein', NULL, NULL, NULL, NULL, NULL, 4),
(227335, NULL, 'G3DSA:2.10.110.10:FF:000041', NULL, NULL, 'LIM and calponin homology domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(227336, NULL, 'G3DSA:2.60.40.60:FF:000582', NULL, NULL, 'Desmocollin 2 like', NULL, NULL, NULL, NULL, NULL, 4),
(227337, NULL, 'G3DSA:2.40.70.10:FF:000351', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227338, NULL, 'G3DSA:3.30.530.20:FF:000163', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227339, NULL, 'G3DSA:1.10.533.10:FF:000302', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227340, NULL, 'G3DSA:2.60.40.4160:FF:000001', NULL, NULL, 'Protein interacting with hsp90', NULL, NULL, NULL, NULL, NULL, 4),
(227341, NULL, 'G3DSA:3.30.200.20:FF:001588', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227342, NULL, 'G3DSA:1.10.560.10:FF:000090', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227343, NULL, 'G3DSA:2.20.70.10:FF:000211', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227344, NULL, 'G3DSA:1.50.40.10:FF:000497', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(227345, NULL, 'G3DSA:2.130.10.10:FF:003878', NULL, NULL, 'Semaphorin 7a', NULL, NULL, NULL, NULL, NULL, 4),
(227346, NULL, 'G3DSA:3.40.50.2020:FF:000066', NULL, NULL, 'Ribose-phosphate pyrophosphokinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(227347, NULL, 'G3DSA:3.30.70.330:FF:000307', NULL, NULL, 'RNA-binding motif protein 12', NULL, NULL, NULL, NULL, NULL, 4),
(227348, NULL, 'G3DSA:2.40.50.100:FF:000208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227349, NULL, 'G3DSA:3.40.50.2000:FF:000312', NULL, NULL, 'Probable glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(227350, NULL, 'G3DSA:1.20.1420.30:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(227351, NULL, 'G3DSA:3.40.50.10810:FF:000032', NULL, NULL, 'Helicase ARIP4', NULL, NULL, NULL, NULL, NULL, 4),
(227352, NULL, 'G3DSA:3.50.50.60:FF:001519', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227353, NULL, 'G3DSA:3.40.50.300:FF:002333', NULL, NULL, 'Deoxycytidylate deaminase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227354, NULL, 'G3DSA:3.40.50.720:FF:001812', NULL, NULL, 'Slr1617 protein', NULL, NULL, NULL, NULL, NULL, 4),
(227355, NULL, 'G3DSA:3.40.50.300:FF:004463', NULL, NULL, 'Bile salt export pump', NULL, NULL, NULL, NULL, NULL, 4),
(227356, NULL, 'G3DSA:1.10.1450.10:FF:000029', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(227357, NULL, 'G3DSA:3.30.160.60:FF:002933', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227358, NULL, 'G3DSA:1.10.760.10:FF:000071', NULL, NULL, 'Cytochrome C peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(227359, NULL, 'G3DSA:1.10.238.10:FF:000234', NULL, NULL, 'Protein BM-40', NULL, NULL, NULL, NULL, NULL, 4),
(227360, NULL, 'G3DSA:3.40.50.1240:FF:000056', NULL, NULL, 'Metal-independent phosphoserine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(227361, NULL, 'G3DSA:3.30.70.330:FF:000111', NULL, NULL, 'U2 snRNP auxiliary factor large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(227362, NULL, 'G3DSA:3.30.300.130:FF:000014', NULL, NULL, 'Unplaced genomic scaffold supercont1.16, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(227363, NULL, 'G3DSA:2.130.10.10:FF:001989', NULL, NULL, 'Protein cortex', NULL, NULL, NULL, NULL, NULL, 4),
(227364, NULL, 'G3DSA:3.40.50.2000:FF:000060', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(227365, NULL, 'G3DSA:1.10.600.10:FF:000003', NULL, NULL, 'Farnesyl-diphosphate farnesyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(227366, NULL, 'G3DSA:1.20.58.1290:FF:000003', NULL, NULL, 'Transcriptional regulator, CarD family', NULL, NULL, NULL, NULL, NULL, 4),
(227367, NULL, 'G3DSA:2.60.40.60:FF:000891', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227368, NULL, 'G3DSA:3.90.550.10:FF:000765', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(227369, NULL, 'G3DSA:2.40.30.130:FF:000005', NULL, NULL, 'Alanyl-tRNA synthetase 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(227370, NULL, 'G3DSA:3.30.559.70:FF:000018', NULL, NULL, 'Choline O-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(227371, NULL, 'G3DSA:1.10.510.10:FF:000569', NULL, NULL, 'Serine/threonine-protein kinase-like protein CCR4', NULL, NULL, NULL, NULL, NULL, 4),
(227372, NULL, 'G3DSA:2.40.30.120:FF:000002', NULL, NULL, 'Capsid protein', NULL, NULL, NULL, NULL, NULL, 4),
(227373, NULL, 'G3DSA:2.10.70.10:FF:000184', NULL, NULL, 'Haptoglobin', NULL, NULL, NULL, NULL, NULL, 4),
(227374, NULL, 'G3DSA:1.10.3720.10:FF:000231', NULL, NULL, 'Amino acid ABC transporter, membrane protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227375, NULL, 'G3DSA:2.20.80.10:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227376, NULL, 'G3DSA:1.20.1070.10:FF:001403', NULL, NULL, 'Leukocyte platelet-activating factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(227377, NULL, 'G3DSA:1.20.5.190:FF:000170', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227378, NULL, 'G3DSA:2.60.40.10:FF:000573', NULL, NULL, 'Cytokine receptor-like factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(227379, NULL, 'G3DSA:3.40.30.10:FF:000661', NULL, NULL, 'Glutathione peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(227380, NULL, 'G3DSA:3.40.50.300:FF:008482', NULL, NULL, 'ATP binding cassette subfamily C member 8', NULL, NULL, NULL, NULL, NULL, 4),
(227381, NULL, 'G3DSA:1.10.238.200:FF:000007', NULL, NULL, 'Defective in cullin neddylation protein', NULL, NULL, NULL, NULL, NULL, 4),
(227382, NULL, 'G3DSA:3.40.47.10:FF:000171', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227383, NULL, 'G3DSA:3.30.1120.30:FF:000010', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(227384, NULL, 'G3DSA:2.130.10.10:FF:002136', NULL, NULL, 'GD23699', NULL, NULL, NULL, NULL, NULL, 4),
(227385, NULL, 'G3DSA:3.30.497.10:FF:000036', NULL, NULL, 'Serpin peptidase inhibitor 31', NULL, NULL, NULL, NULL, NULL, 4),
(227386, NULL, 'G3DSA:2.70.130.10:FF:000118', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227387, NULL, 'G3DSA:3.30.160.810:FF:000005', NULL, NULL, '50S ribosomal protein L3', NULL, NULL, NULL, NULL, NULL, 4),
(227388, NULL, 'G3DSA:1.10.510.10:FF:002604', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227389, NULL, 'G3DSA:1.10.1450.10:FF:000136', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227390, NULL, 'G3DSA:3.30.70.330:FF:001527', NULL, NULL, 'Modulo, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(227391, NULL, 'G3DSA:1.20.1070.10:FF:001931', NULL, NULL, 'Vomeronasal type-1 receptor', NULL, NULL, NULL, NULL, NULL, 4),
(227392, NULL, 'G3DSA:3.40.630.30:FF:000194', NULL, NULL, 'Acetyltransferase Pat', NULL, NULL, NULL, NULL, NULL, 4),
(227393, NULL, 'G3DSA:1.20.5.110:FF:000197', NULL, NULL, 'Protein BET1', NULL, NULL, NULL, NULL, NULL, 4),
(227394, NULL, 'G3DSA:3.10.20.90:FF:000163', NULL, NULL, 'Rap guanine nucleotide exchange factor (GEF) 5', NULL, NULL, NULL, NULL, NULL, 4),
(227395, NULL, 'G3DSA:2.60.40.150:FF:000626', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227396, NULL, 'G3DSA:2.40.50.140:FF:000214', NULL, NULL, '30S ribosomal protein S1', NULL, NULL, NULL, NULL, NULL, 4),
(227397, NULL, 'G3DSA:1.10.510.10:FF:001986', NULL, NULL, 'Kinase-like domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(227398, NULL, 'G3DSA:2.60.120.10:FF:000199', NULL, NULL, 'Unplaced genomic scaffold supercont1.257, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(227399, NULL, 'G3DSA:1.20.200.10:FF:000004', NULL, NULL, 'Adenylosuccinate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(227400, NULL, 'G3DSA:1.10.510.10:FF:003211', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227401, NULL, 'G3DSA:3.10.105.10:FF:000126', NULL, NULL, 'Glycine betaine/proline ABC transporter, periplasmic glycine betaine/proline-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(227402, NULL, 'G3DSA:2.60.200.20:FF:000045', NULL, NULL, 'Forkhead protein', NULL, NULL, NULL, NULL, NULL, 4),
(227403, NULL, 'G3DSA:2.40.70.10:FF:000042', NULL, NULL, 'Cathepsin D', NULL, NULL, NULL, NULL, NULL, 4),
(227404, NULL, 'G3DSA:3.10.180.10:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227405, NULL, 'G3DSA:2.40.10.10:FF:000375', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227406, NULL, 'G3DSA:2.60.40.10:FF:004844', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227407, NULL, 'G3DSA:3.40.50.150:FF:000652', NULL, NULL, 'Lovastatin nonaketide synthase, polyketide synthase component', NULL, NULL, NULL, NULL, NULL, 4),
(227408, NULL, 'G3DSA:3.30.230.70:FF:000132', NULL, NULL, 'Exosomal 3''-5'' exoribonuclease complex, subunit Rrp43, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227409, NULL, 'G3DSA:1.25.40.10:FF:003669', NULL, NULL, 'TPR Domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(227410, NULL, 'G3DSA:3.10.110.10:FF:000166', NULL, NULL, 'Ubiquitin conjugating enzyme E2 U', NULL, NULL, NULL, NULL, NULL, 4),
(227411, NULL, 'G3DSA:2.60.40.10:FF:004316', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227412, NULL, 'G3DSA:3.80.10.10:FF:001809', NULL, NULL, 'GM16316', NULL, NULL, NULL, NULL, NULL, 4),
(227413, NULL, 'G3DSA:2.60.260.20:FF:000021', NULL, NULL, 'Chaperone protein DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(227414, NULL, 'G3DSA:1.10.510.10:FF:002823', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227415, NULL, 'G3DSA:3.30.160.60:FF:002731', NULL, NULL, 'Zinc finger and BTB domain containing 48', NULL, NULL, NULL, NULL, NULL, 4),
(227416, NULL, 'G3DSA:1.10.10.1480:FF:000001', NULL, NULL, 'Replication protein RepB', NULL, NULL, NULL, NULL, NULL, 4),
(227417, NULL, 'G3DSA:1.10.418.10:FF:000107', NULL, NULL, 'M protein repeat protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(227418, NULL, 'G3DSA:3.40.190.290:FF:000105', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(227419, NULL, 'G3DSA:2.70.150.10:FF:000226', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(227420, NULL, 'G3DSA:2.60.120.260:FF:000410', NULL, NULL, 'Coagulation factor VIII, procoagulant component', NULL, NULL, NULL, NULL, NULL, 4),
(227421, NULL, 'G3DSA:3.30.200.20:FF:001279', NULL, NULL, 'Long-flagella protein, kinase, CMGC RCK', NULL, NULL, NULL, NULL, NULL, 4),
(227422, NULL, 'G3DSA:1.10.238.10:FF:000649', NULL, NULL, 'GD21234', NULL, NULL, NULL, NULL, NULL, 4),
(227423, NULL, 'G3DSA:3.80.10.10:FF:001158', NULL, NULL, 'Leucine-rich repeat protein kinase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(227424, NULL, 'G3DSA:2.60.200.10:FF:000042', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227425, NULL, 'G3DSA:1.25.40.10:FF:001887', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(227426, NULL, 'G3DSA:3.90.1150.10:FF:000043', NULL, NULL, 'Serine hydroxymethyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(227427, NULL, 'G3DSA:1.20.890.10:FF:000027', NULL, NULL, 'Protein CBG05895', NULL, NULL, NULL, NULL, NULL, 4),
(227428, NULL, 'G3DSA:1.20.58.390:FF:000241', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227429, NULL, 'G3DSA:3.30.500.10:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227430, NULL, 'G3DSA:1.20.120.1760:FF:000074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227431, NULL, 'G3DSA:4.10.280.10:FF:000096', NULL, NULL, 'Basic helix-loop-helix (BHLH) DNA-binding superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(227432, NULL, 'G3DSA:1.20.1070.10:FF:001622', NULL, NULL, 'Si:dkey-247m21.3', NULL, NULL, NULL, NULL, NULL, 4),
(227433, NULL, 'G3DSA:3.30.70.330:FF:001836', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227434, NULL, 'G3DSA:2.120.10.80:FF:000307', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227435, NULL, 'G3DSA:3.40.930.10:FF:000019', NULL, NULL, 'Solute carrier family 4 member 11', NULL, NULL, NULL, NULL, NULL, 4),
(227436, NULL, 'G3DSA:3.30.2170.10:FF:000002', NULL, NULL, 'Endonuclease V', NULL, NULL, NULL, NULL, NULL, 4),
(227437, NULL, 'G3DSA:3.40.30.10:FF:000970', NULL, NULL, 'Chromosome 19, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(227438, NULL, 'G3DSA:1.10.10.10:FF:000665', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227439, NULL, 'G3DSA:2.30.30.40:FF:000324', NULL, NULL, 'SH3 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(227440, NULL, 'G3DSA:1.20.1310.10:FF:000231', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227441, NULL, 'G3DSA:1.10.510.10:FF:002284', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227442, NULL, 'G3DSA:2.70.170.10:FF:000227', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227443, NULL, 'G3DSA:1.10.472.130:FF:000064', NULL, NULL, 'Dynein heavy chain 7, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(227444, NULL, 'G3DSA:1.10.472.10:FF:000042', NULL, NULL, 'FAM58A isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(227445, NULL, 'G3DSA:3.30.1640.10:FF:000072', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(227446, NULL, 'G3DSA:2.130.10.10:FF:004592', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227447, NULL, 'G3DSA:2.60.40.720:FF:000005', NULL, NULL, 'p53, isoform E', NULL, NULL, NULL, NULL, NULL, 4),
(227448, NULL, 'G3DSA:1.10.10.10:FF:000025', NULL, NULL, '40S ribosomal protein S10', NULL, NULL, NULL, NULL, NULL, 4),
(227449, NULL, 'G3DSA:3.40.910.10:FF:000018', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227450, NULL, 'G3DSA:3.30.200.20:FF:002206', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227451, NULL, 'G3DSA:3.90.550.50:FF:000204', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(227452, NULL, 'G3DSA:2.60.40.10:FF:004625', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227453, NULL, 'G3DSA:3.30.70.120:FF:000020', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227454, NULL, 'G3DSA:3.30.470.30:FF:000020', NULL, NULL, 'RNA guanylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(227455, NULL, 'G3DSA:1.25.40.20:FF:000822', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(227456, NULL, 'G3DSA:1.20.810.10:FF:000034', NULL, NULL, 'Cytochrome b mRNA maturase bI3', NULL, NULL, NULL, NULL, NULL, 4),
(227457, NULL, 'G3DSA:3.20.20.190:FF:000168', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227458, NULL, 'G3DSA:1.10.510.10:FF:002593', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227459, NULL, 'G3DSA:2.130.10.10:FF:004283', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227460, NULL, 'G3DSA:3.20.20.70:FF:000538', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227461, NULL, 'G3DSA:2.60.120.920:FF:000209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227462, NULL, 'G3DSA:3.30.60.30:FF:000091', NULL, NULL, 'Agrin', NULL, NULL, NULL, NULL, NULL, 4),
(227463, NULL, 'G3DSA:1.20.870.10:FF:000026', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(227464, NULL, 'G3DSA:3.80.10.10:FF:003743', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227465, NULL, 'G3DSA:2.160.20.10:FF:000128', NULL, NULL, 'GD20755', NULL, NULL, NULL, NULL, NULL, 4),
(227466, NULL, 'G3DSA:3.40.50.150:FF:000904', NULL, NULL, 'Protein N-lysine methyltransferase METTL21A', NULL, NULL, NULL, NULL, NULL, 4),
(227467, NULL, 'G3DSA:1.25.10.10:FF:002537', NULL, NULL, 'Condensin complex subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227468, NULL, 'G3DSA:3.30.870.10:FF:000011', NULL, NULL, 'Phospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(227469, NULL, 'G3DSA:2.60.40.10:FF:006008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227470, NULL, 'G3DSA:3.30.160.60:FF:000477', NULL, NULL, 'Zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(227471, NULL, 'G3DSA:3.80.10.10:FF:003412', NULL, NULL, 'Fbxl16, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227472, NULL, 'G3DSA:3.30.70.3490:FF:000020', NULL, NULL, 'Oxysterol binding protein (Osh7), putative', NULL, NULL, NULL, NULL, NULL, 4),
(227473, NULL, 'G3DSA:1.20.120.1750:FF:000071', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(227474, NULL, 'G3DSA:2.40.70.10:FF:000132', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227475, NULL, 'G3DSA:3.40.50.300:FF:004682', NULL, NULL, 'G Protein, Alpha subunit', NULL, NULL, NULL, NULL, NULL, 4),
(227476, NULL, 'G3DSA:2.110.10.10:FF:000068', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227477, NULL, 'G3DSA:2.60.40.10:FF:002265', NULL, NULL, 'Alpha-1-B glycoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(227478, NULL, 'G3DSA:3.90.740.10:FF:000033', NULL, NULL, 'Isoleucyl-tRNA synthetase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227479, NULL, 'G3DSA:3.40.50.1820:FF:000005', NULL, NULL, 'Prolyl endopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(227480, NULL, 'G3DSA:4.10.240.10:FF:000189', NULL, NULL, 'Fungal zinc cluster transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227481, NULL, 'G3DSA:3.30.572.10:FF:000009', NULL, NULL, 'Thymidylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(227482, NULL, 'G3DSA:3.50.30.10:FF:000008', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(227483, NULL, 'G3DSA:2.170.150.20:FF:000014', NULL, NULL, 'Peptide-methionine (R)-S-oxide reductase', NULL, NULL, NULL, NULL, NULL, 4),
(227484, NULL, 'G3DSA:3.40.50.300:FF:006716', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227485, NULL, 'G3DSA:3.40.50.720:FF:001503', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227486, NULL, 'G3DSA:2.60.120.620:FF:000097', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(227487, NULL, 'G3DSA:1.10.8.70:FF:000002', NULL, NULL, 'Glutamate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(227488, NULL, 'G3DSA:2.130.10.10:FF:000444', NULL, NULL, 'WD repeat domain 18', NULL, NULL, NULL, NULL, NULL, 4),
(227489, NULL, 'G3DSA:1.10.167.10:FF:000018', NULL, NULL, 'A-kinase anchor protein 10, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(227490, NULL, 'G3DSA:3.40.50.300:FF:004772', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227491, NULL, 'G3DSA:3.10.20.90:FF:000943', NULL, NULL, 'Autophagy protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(227492, NULL, 'G3DSA:3.30.60.30:FF:000197', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227493, NULL, 'G3DSA:2.170.150.10:FF:000011', NULL, NULL, 'Dss4p', NULL, NULL, NULL, NULL, NULL, 4),
(227494, NULL, 'G3DSA:1.25.10.10:FF:000194', NULL, NULL, 'WD repeat-containing protein mip1', NULL, NULL, NULL, NULL, NULL, 4),
(227495, NULL, 'G3DSA:1.10.287.1490:FF:000073', NULL, NULL, 'Mlp1p', NULL, NULL, NULL, NULL, NULL, 4),
(227496, NULL, 'G3DSA:1.20.1310.10:FF:000028', NULL, NULL, 'CDK2-associated and cullin domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(227497, NULL, 'G3DSA:1.20.58.390:FF:000095', NULL, NULL, 'Ionotropic GABA receptor subunit UNC-49B.3', NULL, NULL, NULL, NULL, NULL, 4),
(227498, NULL, 'G3DSA:1.10.1200.270:FF:000009', NULL, NULL, 'Salicylate/benzoate carboxyl methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(227499, NULL, 'G3DSA:1.20.1070.10:FF:001257', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227500, NULL, 'G3DSA:1.25.40.20:FF:000480', NULL, NULL, 'Calmodulin-binding transcription activator 2', NULL, NULL, NULL, NULL, NULL, 4),
(227501, NULL, 'G3DSA:2.60.260.20:FF:000037', NULL, NULL, 'DnaJ heat shock protein', NULL, NULL, NULL, NULL, NULL, 4),
(227502, NULL, 'G3DSA:1.10.620.20:FF:000024', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(227503, NULL, 'G3DSA:3.80.10.10:FF:001613', NULL, NULL, 'Expressed protein', NULL, NULL, NULL, NULL, NULL, 4),
(227504, NULL, 'G3DSA:2.40.33.10:FF:000046', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(227505, NULL, 'G3DSA:1.10.1070.11:FF:000041', NULL, NULL, 'DNA-dependent protein kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(227506, NULL, 'G3DSA:1.20.5.4130:FF:000007', NULL, NULL, 'Putative disease resistance protein At3g14460', NULL, NULL, NULL, NULL, NULL, 4),
(227507, NULL, 'G3DSA:3.90.226.10:FF:000170', NULL, NULL, 'Peptidase S41', NULL, NULL, NULL, NULL, NULL, 4),
(227508, NULL, 'G3DSA:1.10.8.80:FF:000005', NULL, NULL, 'MoxR-like ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(227509, NULL, 'G3DSA:3.40.50.1820:FF:001770', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(227510, NULL, 'G3DSA:3.30.200.20:FF:001953', NULL, NULL, 'Myosin light chain kinase 2', NULL, NULL, NULL, NULL, NULL, 4),
(227511, NULL, 'G3DSA:1.50.40.10:FF:000278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227512, NULL, 'G3DSA:3.40.50.300:FF:006374', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227513, NULL, 'G3DSA:1.10.10.60:FF:000343', NULL, NULL, 'Sigma-54-dependent Fis family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(227514, NULL, 'G3DSA:3.40.50.300:FF:003968', NULL, NULL, 'ABC transporter, ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(227515, NULL, 'G3DSA:1.20.5.370:FF:000010', NULL, NULL, 'Myosin heavy chain, isoform G', NULL, NULL, NULL, NULL, NULL, 4),
(227516, NULL, 'G3DSA:1.10.1200.260:FF:000006', NULL, NULL, 'EAG', NULL, NULL, NULL, NULL, NULL, 4),
(227517, NULL, 'G3DSA:3.40.50.300:FF:008515', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227518, NULL, 'G3DSA:3.30.1010.10:FF:000024', NULL, NULL, 'Phosphatidylinositol 4-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(227519, NULL, 'G3DSA:2.130.10.10:FF:003569', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(227520, NULL, 'G3DSA:3.40.47.10:FF:000261', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227521, NULL, 'G3DSA:3.30.420.40:FF:000385', NULL, NULL, 'Putative actin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(227522, NULL, 'G3DSA:3.90.730.10:FF:000004', NULL, NULL, 'Ribonuclease T2-like', NULL, NULL, NULL, NULL, NULL, 4),
(227523, NULL, 'G3DSA:3.90.470.20:FF:000043', NULL, NULL, '4''-phosphopantetheinyl transferase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(227524, NULL, 'G3DSA:3.40.50.300:FF:008173', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227525, NULL, 'G3DSA:3.40.140.10:FF:000190', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit H', NULL, NULL, NULL, NULL, NULL, 4),
(227526, NULL, 'G3DSA:3.30.160.60:FF:006222', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227527, NULL, 'G3DSA:3.40.109.10:FF:000061', NULL, NULL, 'Nitroreductase', NULL, NULL, NULL, NULL, NULL, 4),
(227528, NULL, 'G3DSA:3.30.160.60:FF:002169', NULL, NULL, 'Zgc:174573', NULL, NULL, NULL, NULL, NULL, 4),
(227529, NULL, 'G3DSA:3.40.50.880:FF:000073', NULL, NULL, 'Glutamine amidotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(227530, NULL, 'G3DSA:3.90.230.10:FF:000056', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227531, NULL, 'G3DSA:1.10.238.10:FF:000543', NULL, NULL, 'Dystrophin-1', NULL, NULL, NULL, NULL, NULL, 4),
(227532, NULL, 'G3DSA:3.90.470.10:FF:000040', NULL, NULL, '50S ribosomal protein L22', NULL, NULL, NULL, NULL, NULL, 4),
(227533, NULL, 'G3DSA:3.30.590.10:FF:000045', NULL, NULL, 'Glutamate-ammonia ligase', NULL, NULL, NULL, NULL, NULL, 4),
(227534, NULL, 'G3DSA:1.10.533.10:FF:000156', NULL, NULL, 'Cell death protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(227535, NULL, 'G3DSA:3.40.50.150:FF:000343', NULL, NULL, 'Fibrillarin-like rRNA/tRNA 2''-O-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(227536, NULL, 'G3DSA:2.10.25.10:FF:001821', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227537, NULL, 'G3DSA:3.90.79.10:FF:000208', NULL, NULL, 'Adenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(227538, NULL, 'G3DSA:3.10.20.30:FF:000061', NULL, NULL, 'Developmentally-regulated GTP-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227539, NULL, 'G3DSA:2.60.40.10:FF:004064', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227540, NULL, 'G3DSA:3.90.1300.10:FF:000004', NULL, NULL, 'Outer envelope protein 64, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(227541, NULL, 'G3DSA:1.25.40.10:FF:002034', NULL, NULL, 'Pentatricopeptide repeat-containing protein, chloroplastic isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(227542, NULL, 'G3DSA:3.90.1410.10:FF:000086', NULL, NULL, 'YALI0F20944p', NULL, NULL, NULL, NULL, NULL, 4),
(227543, NULL, 'G3DSA:1.20.5.390:FF:000016', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227544, NULL, 'G3DSA:1.10.10.60:FF:000433', NULL, NULL, 'Reproductive homeobox 2B', NULL, NULL, NULL, NULL, NULL, 4),
(227545, NULL, 'G3DSA:3.50.7.10:FF:000006', NULL, NULL, 'T-complex protein 1 subunit eta', NULL, NULL, NULL, NULL, NULL, 4),
(227546, NULL, 'G3DSA:3.90.1420.10:FF:000036', NULL, NULL, 'Rubisco large subunit N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(227547, NULL, 'G3DSA:3.30.70.330:FF:000420', NULL, NULL, 'serine-arginine protein 55 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(227548, NULL, 'G3DSA:3.30.450.90:FF:000014', NULL, NULL, 'Toxin co-regulated pilus biosynthesis protein T', NULL, NULL, NULL, NULL, NULL, 4),
(227549, NULL, 'G3DSA:3.30.930.10:FF:000398', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227550, NULL, 'G3DSA:3.30.40.10:FF:001191', NULL, NULL, 'putative E3 ubiquitin-protein ligase UBR7 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(227551, NULL, 'G3DSA:1.25.40.10:FF:004164', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227552, NULL, 'G3DSA:1.25.10.10:FF:000284', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(227553, NULL, 'G3DSA:3.30.160.60:FF:004277', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227554, NULL, 'G3DSA:3.80.10.10:FF:001703', NULL, NULL, 'Probable leucine-rich repeat receptor-like protein kinase At5g63930', NULL, NULL, NULL, NULL, NULL, 4),
(227555, NULL, 'G3DSA:1.10.150.80:FF:000017', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(227556, NULL, 'G3DSA:2.20.28.10:FF:000052', NULL, NULL, 'Ferredoxin-thioredoxin reductase, catalytic subunit, putative/rubredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(227557, NULL, 'G3DSA:3.40.50.2300:FF:001605', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227558, NULL, 'G3DSA:3.10.20.90:FF:000269', NULL, NULL, 'Very-long-chain enoyl-CoA reductase', NULL, NULL, NULL, NULL, NULL, 4),
(227559, NULL, 'G3DSA:3.40.50.1980:FF:000154', NULL, NULL, 'Histidinol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(227560, NULL, 'G3DSA:3.30.499.10:FF:000018', NULL, NULL, 'Aconitate hydratase', NULL, NULL, NULL, NULL, NULL, 4),
(227561, NULL, 'G3DSA:1.10.565.10:FF:000185', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227562, NULL, 'G3DSA:3.30.160.60:FF:004423', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227563, NULL, 'G3DSA:4.10.400.10:FF:000286', NULL, NULL, 'Transmembrane serine protease 2', NULL, NULL, NULL, NULL, NULL, 4),
(227564, NULL, 'G3DSA:3.90.1430.10:FF:000008', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227565, NULL, 'G3DSA:3.30.450.80:FF:000011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227566, NULL, 'G3DSA:1.50.40.10:FF:000188', NULL, NULL, 'Mitochondrial RNA-splicing protein MRS3', NULL, NULL, NULL, NULL, NULL, 4),
(227567, NULL, 'G3DSA:3.40.50.300:FF:002973', NULL, NULL, 'ESX-3 secretion system protein EccC3', NULL, NULL, NULL, NULL, NULL, 4),
(227568, NULL, 'G3DSA:3.10.20.90:FF:000472', NULL, NULL, 'UV excision repair protein RAD23, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227569, NULL, 'G3DSA:1.20.1370.10:FF:000004', NULL, NULL, 'Larval serum protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(227570, NULL, 'G3DSA:4.10.60.10:FF:000116', NULL, NULL, 'Zinc knuckle (CCHC-type) family protein', NULL, NULL, NULL, NULL, NULL, 4),
(227571, NULL, 'G3DSA:1.25.40.10:FF:001758', NULL, NULL, 'Rhomboid protease GluP', NULL, NULL, NULL, NULL, NULL, 4),
(227572, NULL, 'G3DSA:2.60.40.10:FF:002517', NULL, NULL, 'Down syndrome cell adhesion molecule like 1', NULL, NULL, NULL, NULL, NULL, 4),
(227573, NULL, 'G3DSA:1.10.1450.10:FF:000030', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(227574, NULL, 'G3DSA:2.30.130.40:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227575, NULL, 'G3DSA:1.10.533.10:FF:000285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227576, NULL, 'G3DSA:3.40.140.10:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227577, NULL, 'G3DSA:2.10.25.10:FF:001512', NULL, NULL, 'Fibulin-1', NULL, NULL, NULL, NULL, NULL, 4),
(227578, NULL, 'G3DSA:3.30.200.20:FF:000407', NULL, NULL, 'Inka box actin regulator 1', NULL, NULL, NULL, NULL, NULL, 4),
(227579, NULL, 'G3DSA:3.10.20.90:FF:000691', NULL, NULL, 'NSFL1 cofactor p47-like isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(227580, NULL, 'G3DSA:3.30.9.10:FF:000168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227581, NULL, 'G3DSA:1.10.510.10:FF:004392', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227582, NULL, 'G3DSA:3.90.70.10:FF:000672', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227583, NULL, 'G3DSA:3.40.50.1820:FF:001309', NULL, NULL, 'Acetylcholinesterase/butyrylcholinesterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227584, NULL, 'G3DSA:3.40.30.10:FF:000767', NULL, NULL, 'Thiol peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(227585, NULL, 'G3DSA:3.30.1360.120:FF:000084', NULL, NULL, 'Glycine cleavage system T protein', NULL, NULL, NULL, NULL, NULL, 4),
(227586, NULL, 'G3DSA:1.10.510.10:FF:000805', NULL, NULL, 'Mitogen activated kinase-like protein', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(227587, NULL, 'G3DSA:3.90.1290.10:FF:000019', NULL, NULL, 'Short stop, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(227588, NULL, 'G3DSA:3.30.40.10:FF:001729', NULL, NULL, 'Regulating synaptic membrane exocytosis protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(227589, NULL, 'G3DSA:1.20.1070.10:FF:001167', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227590, NULL, 'G3DSA:1.20.120.330:FF:000014', NULL, NULL, 'Abl tyrosine kinase, isoform H', NULL, NULL, NULL, NULL, NULL, 4),
(227591, NULL, 'G3DSA:3.30.420.110:FF:000046', NULL, NULL, 'DNA mismatch repair protein MSH2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227592, NULL, 'G3DSA:1.10.150.60:FF:000011', NULL, NULL, 'AT-rich interactive domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(227593, NULL, 'G3DSA:2.30.110.10:FF:000087', NULL, NULL, 'Flavin reductase domain protein FMN-binding', NULL, NULL, NULL, NULL, NULL, 4),
(227594, NULL, 'G3DSA:3.30.160.60:FF:000713', NULL, NULL, 'Zinc finger protein 513', NULL, NULL, NULL, NULL, NULL, 4),
(227595, NULL, 'G3DSA:3.30.70.330:FF:000201', NULL, NULL, 'heterogeneous nuclear ribonucleoprotein A3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(227596, NULL, 'G3DSA:1.20.58.760:FF:000003', NULL, NULL, 'AFG3-like AAA ATPase 2', NULL, NULL, NULL, NULL, NULL, 4),
(227597, NULL, 'G3DSA:3.40.50.1110:FF:000158', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227598, NULL, 'G3DSA:1.10.510.10:FF:003588', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227599, NULL, 'G3DSA:2.30.30.30:FF:000085', NULL, NULL, '50S ribosomal protein L2', NULL, NULL, NULL, NULL, NULL, 4),
(227600, NULL, 'G3DSA:3.40.630.10:FF:000507', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(227601, NULL, 'G3DSA:3.30.40.10:FF:001971', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227602, NULL, 'G3DSA:2.60.40.10:FF:002826', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227603, NULL, 'G3DSA:3.30.2160.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227604, NULL, 'G3DSA:3.40.50.1000:FF:000765', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227605, NULL, 'G3DSA:1.20.120.340:FF:000017', NULL, NULL, 'Similar to flagellar protein FliS', NULL, NULL, NULL, NULL, NULL, 4),
(227606, NULL, 'G3DSA:3.60.21.10:FF:000375', NULL, NULL, '5'' nucleotidase, ecto, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227607, NULL, 'G3DSA:1.10.540.10:FF:000088', NULL, NULL, 'Acyl-coenzyme A oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(227608, NULL, 'G3DSA:2.90.10.10:FF:000042', NULL, NULL, 'Serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(227609, NULL, 'G3DSA:3.40.50.1240:FF:000146', NULL, NULL, 'Membrane-bound acid phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227610, NULL, 'G3DSA:3.30.70.330:FF:002550', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227611, NULL, 'G3DSA:2.60.40.10:FF:002175', NULL, NULL, 'Twitchin', NULL, NULL, NULL, NULL, NULL, 4),
(227612, NULL, 'G3DSA:3.10.110.10:FF:000312', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227613, NULL, 'G3DSA:2.30.30.40:FF:000088', NULL, NULL, 'Periplakin', NULL, NULL, NULL, NULL, NULL, 4),
(227614, NULL, 'G3DSA:3.90.550.10:FF:000350', NULL, NULL, 'Beta-1,3-glucosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(227615, NULL, 'G3DSA:3.90.70.10:FF:000453', NULL, NULL, 'Senescence-specific cysteine protease SAG39', NULL, NULL, NULL, NULL, NULL, 4),
(227616, NULL, 'G3DSA:1.10.287.110:FF:000254', NULL, NULL, 'DNAj-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(227617, NULL, 'G3DSA:1.10.533.10:FF:000066', NULL, NULL, 'Tumor necrosis factor receptor superfamily member 11B', NULL, NULL, NULL, NULL, NULL, 4),
(227618, NULL, 'G3DSA:1.20.1250.20:FF:001830', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227619, NULL, 'G3DSA:3.10.20.90:FF:000382', NULL, NULL, 'Nedd8-like protein RUB3, putative, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(227620, NULL, 'G3DSA:2.10.50.10:FF:000076', NULL, NULL, 'Neurotrophin receptor associated death domain', NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(227621, NULL, 'G3DSA:1.10.510.10:FF:003897', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227622, NULL, 'G3DSA:1.10.10.570:FF:000008', NULL, NULL, 'Putative dolicholphosphate-mannose synthase', NULL, NULL, NULL, NULL, NULL, 4),
(227623, NULL, 'G3DSA:1.10.238.10:FF:000453', NULL, NULL, 'Leucine zipper and EF-hand containing transmembrane protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(227624, NULL, 'G3DSA:2.60.40.2030:FF:000031', NULL, NULL, 'Adhesion G protein-coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(227625, NULL, 'G3DSA:2.40.70.10:FF:000238', NULL, NULL, 'Os08g0207800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(227626, NULL, 'G3DSA:3.30.160.60:FF:000371', NULL, NULL, 'Zinc finger protein 555', NULL, NULL, NULL, NULL, NULL, 4),
(227627, NULL, 'G3DSA:1.20.1070.10:FF:001818', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227628, NULL, 'G3DSA:1.10.20.10:FF:000306', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227629, NULL, 'G3DSA:3.60.21.10:FF:000285', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(227630, NULL, 'G3DSA:1.25.40.10:FF:004074', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227631, NULL, 'G3DSA:3.40.50.300:FF:008263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227632, NULL, 'G3DSA:2.60.40.10:FF:002484', NULL, NULL, 'EmrB/QacA subfamily drug resistance transporter', NULL, NULL, NULL, NULL, NULL, 4),
(227633, NULL, 'G3DSA:3.40.50.1100:FF:000155', NULL, NULL, 'Cysteine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(227634, NULL, 'G3DSA:3.10.110.10:FF:000060', NULL, NULL, 'Ubiquitin conjugating enzyme (UbcB)', NULL, NULL, NULL, NULL, NULL, 4),
(227635, NULL, 'G3DSA:3.40.50.1820:FF:001551', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227636, NULL, 'G3DSA:3.40.50.11530:FF:000017', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(227637, NULL, 'G3DSA:1.25.40.10:FF:004383', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g14170', NULL, NULL, NULL, NULL, NULL, 4),
(227638, NULL, 'G3DSA:1.10.1140.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227639, NULL, 'G3DSA:3.30.70.60:FF:000021', NULL, NULL, '30S ribosomal protein S6', NULL, NULL, NULL, NULL, NULL, 4),
(227640, NULL, 'G3DSA:1.20.1070.10:FF:001509', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(227641, NULL, 'G3DSA:1.10.510.10:FF:004083', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227642, NULL, 'G3DSA:3.80.10.10:FF:000995', NULL, NULL, 'Leucine-rich repeat-containing protein 40', NULL, NULL, NULL, NULL, NULL, 4),
(227643, NULL, 'G3DSA:3.30.160.60:FF:000932', NULL, NULL, 'zinc finger and SCAN domain-containing protein 20 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(227644, NULL, 'G3DSA:3.30.160.60:FF:000680', NULL, NULL, 'S phase cyclin A-associated protein in the endoplasmic reticulum', NULL, NULL, NULL, NULL, NULL, 4),
(227645, NULL, 'G3DSA:1.10.3720.10:FF:000028', NULL, NULL, 'sn-glycerol-3-phosphate ABC transporter permease UgpA', NULL, NULL, NULL, NULL, NULL, 4),
(227646, NULL, 'G3DSA:2.60.40.1910:FF:000040', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227647, NULL, 'G3DSA:3.80.10.10:FF:001922', NULL, NULL, 'Protein CBG04590', NULL, NULL, NULL, NULL, NULL, 4),
(227648, NULL, 'G3DSA:3.30.450.30:FF:000002', NULL, NULL, 'Dynein light chain roadblock', NULL, NULL, NULL, NULL, NULL, 4),
(227649, NULL, 'G3DSA:3.30.565.10:FF:000206', NULL, NULL, 'Chloroplast sensor kinase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(227650, NULL, 'G3DSA:3.30.70.330:FF:002218', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227651, NULL, 'G3DSA:2.40.50.100:FF:000118', NULL, NULL, 'ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(227652, NULL, 'G3DSA:1.20.50.60:FF:000002', NULL, NULL, 'Exocrine gland-secreted peptide 1', NULL, NULL, NULL, NULL, NULL, 4),
(227653, NULL, 'G3DSA:3.40.50.300:FF:000624', NULL, NULL, 'ADP-ribosylation factor 1', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(227654, NULL, 'G3DSA:1.10.10.10:FF:001969', NULL, NULL, 'Protamine-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(227655, NULL, 'G3DSA:3.90.70.10:FF:000762', NULL, NULL, 'Cathepsin Bb', NULL, NULL, NULL, NULL, NULL, 4),
(227656, NULL, 'G3DSA:3.30.40.10:FF:001168', NULL, NULL, 'U-box domain-containing protein 31', NULL, NULL, NULL, NULL, NULL, 4),
(227657, NULL, 'G3DSA:3.40.50.2300:FF:000520', NULL, NULL, 'Glutamate ionotropic receptor delta type subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(227658, NULL, 'G3DSA:1.20.1540.10:FF:000040', NULL, NULL, 'Ubiquitin-associated /TS-N domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(227659, NULL, 'G3DSA:1.10.20.10:FF:000054', NULL, NULL, 'Putative histone H1.5-like', NULL, NULL, NULL, NULL, NULL, 4),
(227660, NULL, 'G3DSA:3.40.50.1820:FF:001860', NULL, NULL, 'Lipase, endothelial', NULL, NULL, NULL, NULL, NULL, 4),
(227661, NULL, 'G3DSA:1.10.510.10:FF:000715', NULL, NULL, 'Serine/threonine-protein kinase PCRK2', NULL, NULL, NULL, NULL, NULL, 4),
(227662, NULL, 'G3DSA:2.30.30.30:FF:000118', NULL, NULL, '60S ribosomal protein L26-1', NULL, NULL, NULL, NULL, NULL, 4),
(227663, NULL, 'G3DSA:1.20.58.1780:FF:000021', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(227664, NULL, 'G3DSA:2.20.25.210:FF:000001', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(227665, NULL, 'G3DSA:1.25.10.10:FF:001947', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227666, NULL, 'G3DSA:3.80.10.10:FF:001147', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227667, NULL, 'G3DSA:2.40.50.40:FF:000010', NULL, NULL, 'Stromal cell-derived factor 1 precursor', NULL, NULL, NULL, NULL, NULL, 4),
(227668, NULL, 'G3DSA:3.30.160.60:FF:006441', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227669, NULL, 'G3DSA:2.10.250.10:FF:000017', NULL, NULL, 'Calnexin homolog-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(227670, NULL, 'G3DSA:2.60.40.150:FF:000492', NULL, NULL, 'C2 domain-containing protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(227671, NULL, 'G3DSA:2.130.10.10:FF:005929', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227672, NULL, 'G3DSA:3.30.750.24:FF:000133', NULL, NULL, 'Sodium-independent sulfate anion transporter', NULL, NULL, NULL, NULL, NULL, 4),
(227673, NULL, 'G3DSA:1.20.1250.20:FF:000060', NULL, NULL, 'Solute carrier family 17 member 3', NULL, NULL, NULL, NULL, NULL, 4),
(227674, NULL, 'G3DSA:3.40.50.300:FF:000955', NULL, NULL, 'GTPase HflX', NULL, NULL, NULL, NULL, NULL, 4),
(227675, NULL, 'G3DSA:3.90.76.10:FF:000056', NULL, NULL, 'Peptide ABC transporter, peptide-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(227676, NULL, 'G3DSA:2.60.40.10:FF:002725', NULL, NULL, 'Peroxidasin', NULL, NULL, NULL, NULL, NULL, 4),
(227677, NULL, 'G3DSA:4.10.400.10:FF:000319', NULL, NULL, 'Putative vitellogenin receptor', NULL, NULL, NULL, NULL, NULL, 4),
(227678, NULL, 'G3DSA:1.20.1250.20:FF:001583', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227679, NULL, 'G3DSA:3.30.500.50:FF:000001', NULL, NULL, 'Envelope glycoprotein H', NULL, NULL, NULL, NULL, NULL, 4),
(227680, NULL, 'G3DSA:2.60.120.10:FF:000339', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(227681, NULL, 'G3DSA:3.30.160.60:FF:002158', NULL, NULL, 'Zinc finger protein ZIC 3', NULL, NULL, NULL, NULL, NULL, 4),
(227682, NULL, 'G3DSA:3.60.15.10:FF:000102', NULL, NULL, 'Cleavage and polyadenylation specificity factor subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(227683, NULL, 'G3DSA:3.30.40.10:FF:001398', NULL, NULL, 'Putative ubiquitin-hydrolase domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(227684, NULL, 'G3DSA:2.20.70.10:FF:000065', NULL, NULL, 'Rho GTPase activating protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(227685, NULL, 'G3DSA:1.10.3470.10:FF:000031', NULL, NULL, 'Manganese ABC transporter, membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(227686, NULL, 'G3DSA:1.10.510.10:FF:002727', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(227687, NULL, 'G3DSA:3.30.2350.20:FF:000075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227688, NULL, 'G3DSA:4.10.1110.10:FF:000007', NULL, NULL, 'Zinc finger protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227689, NULL, 'G3DSA:1.25.10.10:FF:000424', NULL, NULL, 'Importin subunit beta-3', NULL, NULL, NULL, NULL, NULL, 4),
(227690, NULL, 'G3DSA:1.20.890.10:FF:000016', NULL, NULL, 'AAEL002786-PA', NULL, NULL, NULL, NULL, NULL, 4),
(227691, NULL, 'G3DSA:3.30.70.2360:FF:000001', NULL, NULL, 'Endoribonuclease GhoS', NULL, NULL, NULL, NULL, NULL, 4),
(227692, NULL, 'G3DSA:2.60.260.20:FF:000032', NULL, NULL, 'Chaperone protein DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(227693, NULL, 'G3DSA:2.60.40.150:FF:000503', NULL, NULL, 'Synaptotagmin-C', NULL, NULL, NULL, NULL, NULL, 4),
(227694, NULL, 'G3DSA:1.10.3430.10:FF:000017', NULL, NULL, 'Ammonium transporter', NULL, NULL, NULL, NULL, NULL, 4),
(227695, NULL, 'G3DSA:1.10.8.720:FF:000056', NULL, NULL, 'Dynein heavy chain 11', NULL, NULL, NULL, NULL, NULL, 4),
(227696, NULL, 'G3DSA:1.10.8.60:FF:000595', NULL, NULL, 'Cell division control protein', NULL, NULL, NULL, NULL, NULL, 4),
(227697, NULL, 'G3DSA:3.90.470.20:FF:000048', NULL, NULL, 'Lipopeptide antibiotics iturin a biosynthesisprotein', NULL, NULL, NULL, NULL, NULL, 4),
(227698, NULL, 'G3DSA:3.30.70.330:FF:002011', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227699, NULL, 'G3DSA:2.40.170.20:FF:000035', NULL, NULL, 'Colicin I receptor', NULL, NULL, NULL, NULL, NULL, 4),
(227700, NULL, 'G3DSA:2.40.50.140:FF:000203', NULL, NULL, 'TEN1 subunit of CST complex', NULL, NULL, NULL, NULL, NULL, 4),
(227701, NULL, 'G3DSA:3.40.640.10:FF:000345', NULL, NULL, 'Perosamine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(227702, NULL, 'G3DSA:3.30.559.10:FF:000040', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(227703, NULL, 'G3DSA:1.25.40.10:FF:000347', NULL, NULL, 'Mitochondrial fission 1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(227704, NULL, 'G3DSA:3.40.50.300:FF:006262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227705, NULL, 'G3DSA:3.30.40.10:FF:001409', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227706, NULL, 'G3DSA:1.10.150.20:FF:000140', NULL, NULL, 'DNA-directed RNA polymerase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(227707, NULL, 'G3DSA:2.130.10.10:FF:002703', NULL, NULL, 'WD repeat domain phosphoinositide-interacting protein 3', NULL, NULL, NULL, NULL, NULL, 4),
(227708, NULL, 'G3DSA:1.10.472.130:FF:000053', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(227709, NULL, 'G3DSA:2.40.40.20:FF:000077', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(227710, NULL, 'G3DSA:1.25.40.10:FF:000252', NULL, NULL, 'O-linked N-acetylglucosamine (GlcNAc) transferase', NULL, NULL, NULL, NULL, NULL, 4),
(227711, NULL, 'G3DSA:2.60.40.10:FF:000590', NULL, NULL, 'V-set domain-containing T cell activation inhibitor 1', NULL, NULL, NULL, NULL, NULL, 4),
(227712, NULL, 'G3DSA:1.10.730.10:FF:000131', NULL, NULL, 'Valyl Amino-acyl tRNA Synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(227713, NULL, 'G3DSA:3.30.2160.10:FF:000046', NULL, NULL, 'ADL280Wp', NULL, NULL, NULL, NULL, NULL, 4),
(227714, NULL, 'G3DSA:1.10.10.10:FF:001879', NULL, NULL, 'Histone acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(227715, NULL, 'G3DSA:3.90.400.10:FF:000013', NULL, NULL, 'Amino acid Transporter GlycoProtein subunit', NULL, NULL, NULL, NULL, NULL, 4),
(227716, NULL, 'G3DSA:3.10.20.90:FF:000718', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227717, NULL, 'G3DSA:1.10.510.10:FF:004291', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227718, NULL, 'G3DSA:3.90.70.10:FF:000447', NULL, NULL, 'Putative ubiquitin carboxyl-terminal hydrolase 25', NULL, NULL, NULL, NULL, NULL, 4),
(227719, NULL, 'G3DSA:3.30.497.10:FF:000053', NULL, NULL, 'GM17927', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(227720, NULL, 'G3DSA:1.20.1070.10:FF:001482', NULL, NULL, 'LOC791944 protein', NULL, NULL, NULL, NULL, NULL, 4),
(227721, NULL, 'G3DSA:2.170.140.10:FF:000050', NULL, NULL, 'Chitin deacetylase 5A', NULL, NULL, NULL, NULL, NULL, 4),
(227722, NULL, 'G3DSA:1.10.510.10:FF:000592', NULL, NULL, 'CAMK family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(227723, NULL, 'G3DSA:1.25.40.20:FF:000255', NULL, NULL, 'espin-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(227724, NULL, 'G3DSA:3.30.559.30:FF:000046', NULL, NULL, 'Nonribosomal peptide synthase GliP', NULL, NULL, NULL, NULL, NULL, 4),
(227725, NULL, 'G3DSA:3.80.10.10:FF:004002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227726, NULL, 'G3DSA:3.40.980.10:FF:000045', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(227727, NULL, 'G3DSA:3.40.50.300:FF:006683', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227728, NULL, 'G3DSA:3.30.830.10:FF:000227', NULL, NULL, 'Protein CBG17023', NULL, NULL, NULL, NULL, NULL, 4),
(227729, NULL, 'G3DSA:3.80.10.10:FF:003176', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227730, NULL, 'G3DSA:3.10.490.10:FF:000008', NULL, NULL, 'Gamma-glutamylaminecyclotransferase A', NULL, NULL, NULL, NULL, NULL, 4),
(227731, NULL, 'G3DSA:3.40.50.300:FF:000860', NULL, NULL, 'DExH-box ATP-dependent RNA helicase DExH6', NULL, NULL, NULL, NULL, NULL, 4),
(227732, NULL, 'G3DSA:3.20.20.360:FF:000005', NULL, NULL, 'Malate synthase (GlcB)', NULL, NULL, NULL, NULL, NULL, 4),
(227733, NULL, 'G3DSA:2.130.10.10:FF:004406', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227734, NULL, 'G3DSA:1.25.40.10:FF:003899', NULL, NULL, 'Coatomer subunit epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(227735, NULL, 'G3DSA:1.10.630.10:FF:000764', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227736, NULL, 'G3DSA:1.10.510.10:FF:000603', NULL, NULL, 'Receptor like protein kinase S.2', NULL, NULL, NULL, NULL, NULL, 4),
(227737, NULL, 'G3DSA:3.40.50.261:FF:000012', NULL, NULL, 'Acyl-CoA synthetase FdrA', NULL, NULL, NULL, NULL, NULL, 4),
(227738, NULL, 'G3DSA:1.10.1610.10:FF:000003', NULL, NULL, 'Nicotinate-nucleotide--dimethylbenzimidazole phosphoribosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(227739, NULL, 'G3DSA:2.120.10.30:FF:000181', NULL, NULL, 'RE14803p', NULL, NULL, NULL, NULL, NULL, 4),
(227740, NULL, 'G3DSA:3.40.140.10:FF:000094', NULL, NULL, 'Cytidine deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(227741, NULL, 'G3DSA:3.40.50.1000:FF:000670', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227742, NULL, 'G3DSA:1.25.10.10:FF:000519', NULL, NULL, 'WAPL (Wings apart-like protein regulation of heterochromatin) protein', NULL, NULL, NULL, NULL, NULL, 4),
(227743, NULL, 'G3DSA:3.40.1090.10:FF:000072', NULL, NULL, 'Transmembrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(227744, NULL, 'G3DSA:2.40.110.10:FF:000023', NULL, NULL, 'Acyl-CoA dehydrogenase FadE10', NULL, NULL, NULL, NULL, NULL, 4),
(227745, NULL, 'G3DSA:2.40.10.10:FF:000358', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227746, NULL, 'G3DSA:3.20.20.370:FF:000008', NULL, NULL, 'Chitin deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(227747, NULL, 'G3DSA:1.20.1260.80:FF:000005', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227748, NULL, 'G3DSA:2.110.10.10:FF:000052', NULL, NULL, '72 kDa type IV collagenase-like', NULL, NULL, NULL, NULL, NULL, 4),
(227749, NULL, 'G3DSA:3.40.50.12780:FF:000021', NULL, NULL, 'Long-chain-fatty-acid--CoA ligase ACSBG1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(227750, NULL, 'G3DSA:3.30.200.20:FF:001936', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227751, NULL, 'G3DSA:1.10.10.60:FF:000326', NULL, NULL, 'POU domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(227752, NULL, 'G3DSA:2.170.190.11:FF:000015', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(227753, NULL, 'G3DSA:2.60.120.470:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(227754, NULL, 'G3DSA:1.20.5.190:FF:000147', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227755, NULL, 'G3DSA:2.40.30.10:FF:000472', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(227756, NULL, 'G3DSA:1.25.40.10:FF:004630', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227757, NULL, 'G3DSA:1.25.10.10:FF:000750', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(227758, NULL, 'G3DSA:2.20.130.20:FF:000003', NULL, NULL, 'CD109 molecule', NULL, NULL, NULL, NULL, NULL, 4),
(227759, NULL, 'G3DSA:3.30.560.10:FF:000010', NULL, NULL, 'GMC oxidoreductase, putative (AFU_orthologue AFUA_3G08070)', NULL, NULL, NULL, NULL, NULL, 4),
(227760, NULL, 'G3DSA:1.10.400.10:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227761, NULL, 'G3DSA:1.20.870.10:FF:000021', NULL, NULL, 'Low temperature essential protein', NULL, NULL, NULL, NULL, NULL, 4),
(227762, NULL, 'G3DSA:2.130.10.10:FF:000354', NULL, NULL, 'Protein HIRA', NULL, NULL, NULL, NULL, NULL, 4),
(227763, NULL, 'G3DSA:3.40.50.300:FF:000629', NULL, NULL, 'Adenylyl-sulfate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(227764, NULL, 'G3DSA:2.130.10.10:FF:000242', NULL, NULL, 'WD repeat domain 19, isoform CRA_a', NULL, NULL, NULL, NULL, NULL, 4),
(227765, NULL, 'G3DSA:2.60.120.10:FF:000665', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227766, NULL, 'G3DSA:3.40.640.10:FF:000019', NULL, NULL, 'Pyridoxal phosphate-dependent aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(227767, NULL, 'G3DSA:2.70.170.10:FF:000194', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(227768, NULL, 'G3DSA:2.60.40.150:FF:000166', NULL, NULL, 'Protein C2-DOMAIN ABA-RELATED 1', NULL, NULL, NULL, NULL, NULL, 4),
(227769, NULL, 'G3DSA:2.40.100.10:FF:000084', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(227770, NULL, 'G3DSA:2.60.40.10:FF:000685', NULL, NULL, 'basement membrane-specific heparan sulfate proteoglycan core protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(227771, NULL, 'G3DSA:2.40.30.270:FF:000002', NULL, NULL, 'DNA replication ATP-dependent helicase/nuclease DNA2', NULL, NULL, NULL, NULL, NULL, 4),
(227772, NULL, 'G3DSA:3.40.50.300:FF:004912', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227773, NULL, 'G3DSA:3.40.50.10860:FF:000007', NULL, NULL, 'Glutamate dehydrogenase 1, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(227774, NULL, 'G3DSA:2.60.40.10:FF:006087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227775, NULL, 'G3DSA:1.10.533.10:FF:000061', NULL, NULL, 'nuclear factor NF-kappa-B p100 subunit isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(227776, NULL, 'G3DSA:2.160.20.70:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227777, NULL, 'G3DSA:3.40.50.300:FF:002193', NULL, NULL, 'Polynucleotide kinase', NULL, NULL, NULL, NULL, NULL, 4),
(227778, NULL, 'G3DSA:3.40.50.300:FF:004019', NULL, NULL, 'DNA polymerase III subunit epsilon protein', NULL, NULL, NULL, NULL, NULL, 4),
(227779, NULL, 'G3DSA:3.30.40.10:FF:001623', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(227780, NULL, 'G3DSA:3.30.1360.120:FF:000090', NULL, NULL, 'Putative transferase CAF17, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(227781, NULL, 'G3DSA:3.30.40.10:FF:000212', NULL, NULL, 'pleckstrin homology domain-containing family F member 2', NULL, NULL, NULL, NULL, NULL, 4),
(227782, NULL, 'G3DSA:1.20.5.780:FF:000015', NULL, NULL, 'FXYD domain-containing ion transport regulator', NULL, NULL, NULL, NULL, NULL, 4),
(227783, NULL, 'G3DSA:1.10.533.10:FF:000173', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(227784, NULL, 'G3DSA:2.40.70.10:FF:000255', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227785, NULL, 'G3DSA:3.30.40.10:FF:001735', NULL, NULL, 'Ubiquitinyl hydrolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(227786, NULL, 'G3DSA:1.10.220.150:FF:000002', NULL, NULL, 'arf-GAP with SH3 domain, ANK repeat and PH domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(227787, NULL, 'G3DSA:3.90.228.10:FF:000039', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(227788, NULL, 'G3DSA:3.90.70.10:FF:000094', NULL, NULL, 'ubiquitin carboxyl-terminal hydrolase 35', NULL, NULL, NULL, NULL, NULL, 4),
(227789, NULL, 'G3DSA:3.40.50.720:FF:001817', NULL, NULL, 'Alpha-aminoadipic semialdehyde synthase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(227790, NULL, 'G3DSA:3.90.260.10:FF:000024', NULL, NULL, 'Putative DNA-repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(227791, NULL, 'G3DSA:3.90.960.10:FF:000015', NULL, NULL, 'Proline--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(227792, NULL, 'G3DSA:3.30.700.20:FF:000002', NULL, NULL, 'YOR289W-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(227793, NULL, 'G3DSA:1.20.58.60:FF:000014', NULL, NULL, 'microtubule-actin cross-linking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(227794, NULL, 'G3DSA:1.20.1270.420:FF:000003', NULL, NULL, 'IKK epsilon', NULL, NULL, NULL, NULL, NULL, 4),
(227795, NULL, 'G3DSA:2.40.10.10:FF:000263', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227796, NULL, 'G3DSA:2.130.10.10:FF:003889', NULL, NULL, 'WD repeat protein (AFU_orthologue AFUA_5G11870)', NULL, NULL, NULL, NULL, NULL, 4),
(227797, NULL, 'G3DSA:3.30.200.20:FF:002442', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227798, NULL, 'G3DSA:3.90.1410.10:FF:000114', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227799, NULL, 'G3DSA:3.40.190.10:FF:000142', NULL, NULL, 'Ionotropic receptor 25a', NULL, NULL, NULL, NULL, NULL, 4),
(227800, NULL, 'G3DSA:1.25.10.10:FF:002195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227801, NULL, 'G3DSA:2.60.120.920:FF:000075', NULL, NULL, 'Si:ch211-127b6.2', NULL, NULL, NULL, NULL, NULL, 4),
(227802, NULL, 'G3DSA:2.10.25.10:FF:001052', NULL, NULL, 'Slit homolog 1b (Drosophila)', NULL, NULL, NULL, NULL, NULL, 4),
(227803, NULL, 'G3DSA:3.40.630.10:FF:000064', NULL, NULL, 'Carboxypeptidase A6', NULL, NULL, NULL, NULL, NULL, 4),
(227804, NULL, 'G3DSA:2.60.40.10:FF:005598', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227805, NULL, 'G3DSA:3.40.30.10:FF:000296', NULL, NULL, 'Glutathione S-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(227806, NULL, 'G3DSA:3.30.1300.10:FF:000018', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227807, NULL, 'G3DSA:2.60.40.1910:FF:000028', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227808, NULL, 'G3DSA:2.60.40.60:FF:000251', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227809, NULL, 'G3DSA:3.80.10.10:FF:001473', NULL, NULL, 'Leucine Rich Repeat domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(227810, NULL, 'G3DSA:2.60.40.640:FF:000088', NULL, NULL, 'Uncharacterized protein C557.05', NULL, NULL, NULL, NULL, NULL, 4),
(227811, NULL, 'G3DSA:1.10.220.160:FF:000005', NULL, NULL, 'Histone-lysine N-methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227812, NULL, 'G3DSA:1.10.20.10:FF:000284', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227813, NULL, 'G3DSA:2.60.40.1180:FF:000197', NULL, NULL, 'Glucan (1,4-alpha-),-branching enzyme 1b', NULL, NULL, NULL, NULL, NULL, 4),
(227814, NULL, 'G3DSA:1.20.58.70:FF:000017', NULL, NULL, 'Syntaxin 19', NULL, NULL, NULL, NULL, NULL, 4),
(227815, NULL, 'G3DSA:3.10.20.90:FF:000039', NULL, NULL, 'Tyrosine-protein phosphatase non-receptor type', NULL, NULL, NULL, NULL, NULL, 4),
(227816, NULL, 'G3DSA:1.20.1250.20:FF:001369', NULL, NULL, 'Membrane transporter', NULL, NULL, NULL, NULL, NULL, 4),
(227817, NULL, 'G3DSA:1.20.1070.10:FF:001268', NULL, NULL, 'uncharacterized protein LOC104265789', NULL, NULL, NULL, NULL, NULL, 4),
(227818, NULL, 'G3DSA:1.20.1250.20:FF:001257', NULL, NULL, 'Peptide transporter 3', NULL, NULL, NULL, NULL, NULL, 4),
(227819, NULL, 'G3DSA:1.20.1070.10:FF:001156', NULL, NULL, 'Olfactory receptor', NULL, NULL, NULL, NULL, NULL, 4),
(227820, NULL, 'G3DSA:1.20.5.190:FF:000052', NULL, NULL, 'Abnormal spindle-like microcephaly-associated protein', NULL, NULL, NULL, NULL, NULL, 4);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(227821, NULL, 'G3DSA:1.10.10.10:FF:002043', NULL, NULL, 'Probable sigma-70 factor, ECF subfamily', NULL, NULL, NULL, NULL, NULL, 4),
(227822, NULL, 'G3DSA:3.40.390.10:FF:000123', NULL, NULL, 'Metalloendopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(227823, NULL, 'G3DSA:1.10.533.10:FF:000268', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(227824, NULL, 'G3DSA:2.50.20.20:FF:000002', NULL, NULL, 'Putative lipoprotein lprF', NULL, NULL, NULL, NULL, NULL, 4),
(227825, NULL, 'G3DSA:1.25.40.990:FF:000052', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(227826, NULL, 'G3DSA:1.10.1450.10:FF:000131', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227827, NULL, 'G3DSA:3.30.56.30:FF:000013', NULL, NULL, 'SRP19 protein', NULL, NULL, NULL, NULL, NULL, 4),
(227828, NULL, 'G3DSA:2.180.10.10:FF:000026', NULL, NULL, 'Teneurin-1', NULL, NULL, NULL, NULL, NULL, 4),
(227829, NULL, 'G3DSA:1.10.10.60:FF:000231', NULL, NULL, 'Myb transcription factor', NULL, NULL, NULL, NULL, NULL, 4),
(227830, NULL, 'G3DSA:1.20.1530.20:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227831, NULL, 'G3DSA:1.10.510.10:FF:002048', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227832, NULL, 'G3DSA:3.90.550.50:FF:000108', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(227833, NULL, 'G3DSA:1.10.287.110:FF:000484', NULL, NULL, 'Diphthamide biosynthesis protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(227834, NULL, 'G3DSA:2.60.40.1180:FF:000208', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(227835, NULL, 'G3DSA:3.30.160.60:FF:004187', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227836, NULL, 'G3DSA:3.30.70.330:FF:001494', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(227837, NULL, 'G3DSA:2.60.40.10:FF:000264', NULL, NULL, 'Down syndrome cell adhesion molecule like 1', NULL, NULL, NULL, NULL, NULL, 4),
(227838, NULL, 'G3DSA:3.40.50.720:FF:001722', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227839, NULL, 'G3DSA:3.30.60.20:FF:000003', NULL, NULL, 'Protein kinase C delta', NULL, NULL, NULL, NULL, NULL, 4),
(227840, NULL, 'G3DSA:3.10.20.90:FF:000932', NULL, NULL, 'Phosphatidylinositol 3-kinase catalytic subunit, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227841, NULL, 'G3DSA:2.10.90.10:FF:000168', NULL, NULL, 'Bone morphogenetic protein 8B-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(227842, NULL, 'G3DSA:1.10.510.10:FF:002941', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227843, NULL, 'G3DSA:2.40.30.10:FF:000146', NULL, NULL, 'Elongation factor Tu, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(227844, NULL, 'G3DSA:2.10.25.10:FF:001731', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227845, NULL, 'G3DSA:3.30.830.10:FF:000115', NULL, NULL, 'Zinc protease PQQL-like', NULL, NULL, NULL, NULL, NULL, 4),
(227846, NULL, 'G3DSA:3.80.10.10:FF:003064', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227847, NULL, 'G3DSA:2.30.30.1020:FF:000044', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227848, NULL, 'G3DSA:3.30.160.60:FF:003001', NULL, NULL, 'LD13921p', NULL, NULL, NULL, NULL, NULL, 4),
(227849, NULL, 'G3DSA:1.25.40.10:FF:002590', NULL, NULL, 'Pentatricopeptide repeat-containing protein At2g45350, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(227850, NULL, 'G3DSA:3.40.50.300:FF:002872', NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolases superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(227851, NULL, 'G3DSA:1.10.10.60:FF:000438', NULL, NULL, 'DNA-invertase Hin', NULL, NULL, NULL, NULL, NULL, 4),
(227852, NULL, 'G3DSA:2.60.120.260:FF:000062', NULL, NULL, 'Galactose-binding protein isoform 3', NULL, NULL, NULL, NULL, NULL, 4),
(227853, NULL, 'G3DSA:1.20.58.390:FF:000117', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227854, NULL, 'G3DSA:3.10.180.10:FF:000024', NULL, NULL, '2,3-dihydroxybiphenyl 1,2-dioxygenase', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(227855, NULL, 'G3DSA:1.10.220.10:FF:000047', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(227856, NULL, 'G3DSA:1.10.135.10:FF:000012', NULL, NULL, 'creatine kinase B-type', NULL, NULL, NULL, NULL, NULL, 4),
(227857, NULL, 'G3DSA:2.40.50.690:FF:000019', NULL, NULL, 'YALI0E03630p', NULL, NULL, NULL, NULL, NULL, 4),
(227858, NULL, 'G3DSA:2.60.40.150:FF:000278', NULL, NULL, 'Synaptotagmin protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(227859, NULL, 'G3DSA:2.60.40.780:FF:000001', NULL, NULL, 'von Hippel-Lindau disease tumor suppressor', NULL, NULL, NULL, NULL, NULL, 4),
(227860, NULL, 'G3DSA:2.40.30.10:FF:000360', NULL, NULL, 'Benzoyl-CoA oxygenase, A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(227861, NULL, 'G3DSA:3.40.50.300:FF:007785', NULL, NULL, 'RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227862, NULL, 'G3DSA:3.20.20.70:FF:000847', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227863, NULL, 'G3DSA:1.25.40.10:FF:002601', NULL, NULL, 'UTP6 small subunit processome component', NULL, NULL, NULL, NULL, NULL, 4),
(227864, NULL, 'G3DSA:1.25.40.10:FF:003787', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(227865, NULL, 'G3DSA:1.25.40.60:FF:000008', NULL, NULL, 'Protein transport Sec1b', NULL, NULL, NULL, NULL, NULL, 4),
(227866, NULL, 'G3DSA:1.10.10.580:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227867, NULL, 'G3DSA:2.60.40.60:FF:000346', NULL, NULL, 'Desmocollin b', NULL, NULL, NULL, NULL, NULL, 4),
(227868, NULL, 'G3DSA:3.40.50.2300:FF:000161', NULL, NULL, 'DNA-binding transcriptional repressor EbgR', NULL, NULL, NULL, NULL, NULL, 4),
(227869, NULL, 'G3DSA:3.30.930.10:FF:000393', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227870, NULL, 'G3DSA:2.130.10.10:FF:000449', NULL, NULL, 'Embryonic ectoderm development', NULL, NULL, NULL, NULL, NULL, 4),
(227871, NULL, 'G3DSA:3.90.1480.20:FF:000037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227872, NULL, 'G3DSA:1.10.730.10:FF:000226', NULL, NULL, 'Probable methionine--tRNA ligase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(227873, NULL, 'G3DSA:2.60.40.60:FF:000913', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227874, NULL, 'G3DSA:2.170.130.20:FF:000013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227875, NULL, 'G3DSA:3.40.390.10:FF:000140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227876, NULL, 'G3DSA:3.40.50.1240:FF:000039', NULL, NULL, 'Phosphoglycerate mutase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(227877, NULL, 'G3DSA:1.20.1440.240:FF:000005', NULL, NULL, 'RebO-like L-amino acid oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(227878, NULL, 'G3DSA:1.20.1440.230:FF:000002', NULL, NULL, 'NADH-quinone oxidoreductase subunit F', NULL, NULL, NULL, NULL, NULL, 4),
(227879, NULL, 'G3DSA:3.90.1750.10:FF:000044', NULL, NULL, 'E3 ubiquitin-protein ligase Ufd4', NULL, NULL, NULL, NULL, NULL, 4),
(227880, NULL, 'G3DSA:1.10.238.10:FF:000880', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(227881, NULL, 'G3DSA:3.40.50.450:FF:000079', NULL, NULL, '6-phosphofructokinase', NULL, NULL, NULL, NULL, NULL, 4),
(227882, NULL, 'G3DSA:3.40.1570.10:FF:000002', NULL, NULL, 'Hemin degrading factor', NULL, NULL, NULL, NULL, NULL, 4),
(227883, NULL, 'G3DSA:2.170.130.10:FF:000010', NULL, NULL, 'Ferripyoverdine receptor', NULL, NULL, NULL, NULL, NULL, 4),
(227884, NULL, 'G3DSA:2.60.40.10:FF:005013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227885, NULL, 'G3DSA:3.40.50.2300:FF:001358', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227886, NULL, 'G3DSA:3.30.40.10:FF:001286', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(227887, NULL, 'G3DSA:1.20.1250.20:FF:001471', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227888, NULL, 'G3DSA:3.90.780.10:FF:000029', NULL, NULL, 'Uncharacterized protein C17G6.03', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(227889, NULL, 'G3DSA:1.20.920.30:FF:000008', NULL, NULL, 'Dynein heavy chain domain 1', NULL, NULL, NULL, NULL, NULL, 4),
(227890, NULL, 'G3DSA:2.10.25.10:FF:001714', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227891, NULL, 'G3DSA:3.40.30.10:FF:000975', NULL, NULL, 'NADP-reducing hydrogenase subunit HndB', NULL, NULL, NULL, NULL, NULL, 4),
(227892, NULL, 'G3DSA:2.20.25.10:FF:000129', NULL, NULL, 'DNA-directed RNA polymerase subunit', NULL, NULL, NULL, NULL, NULL, 4),
(227893, NULL, 'G3DSA:3.30.70.330:FF:001847', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227894, NULL, 'G3DSA:3.30.420.110:FF:000041', NULL, NULL, 'DNA mismatch repair protein', NULL, NULL, NULL, NULL, NULL, 4),
(227895, NULL, 'G3DSA:3.40.50.300:FF:004345', NULL, NULL, 'ABC transporter', NULL, NULL, NULL, NULL, NULL, 4),
(227896, NULL, 'G3DSA:3.50.30.30:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227897, NULL, 'G3DSA:3.40.50.2000:FF:000998', NULL, NULL, 'Alpha-1,4 glucan phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(227898, NULL, 'G3DSA:3.40.1810.10:FF:000055', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227899, NULL, 'G3DSA:3.40.50.2020:FF:000184', NULL, NULL, 'Ribose phosphate diphosphokinase Prs1, putative (AFU_orthologue AFUA_7G05670)', NULL, NULL, NULL, NULL, NULL, 4),
(227900, NULL, 'G3DSA:3.30.70.330:FF:002123', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227901, NULL, 'G3DSA:1.50.10.20:FF:000110', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227902, NULL, 'G3DSA:3.30.70.3490:FF:000014', NULL, NULL, 'OSH7p Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(227903, NULL, 'G3DSA:3.30.420.40:FF:000840', NULL, NULL, 'Cell division protein FtsA', NULL, NULL, NULL, NULL, NULL, 4),
(227904, NULL, 'G3DSA:3.10.129.10:FF:000001', NULL, NULL, '3-hydroxyacyl-[acyl-carrier-protein] dehydratase FabZ', NULL, NULL, NULL, NULL, NULL, 4),
(227905, NULL, 'G3DSA:3.40.30.10:FF:001251', NULL, NULL, 'NADH:ubiquinone oxidoreductase core subunit V2', NULL, NULL, NULL, NULL, NULL, 4),
(227906, NULL, 'G3DSA:1.20.140.100:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227907, NULL, 'G3DSA:1.20.1560.10:FF:000041', NULL, NULL, 'Multidrug-Resistance like protein 1, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(227908, NULL, 'G3DSA:2.120.10.30:FF:000208', NULL, NULL, 'Low density lipoprotein receptor-related protein 1Bb', NULL, NULL, NULL, NULL, NULL, 4),
(227909, NULL, 'G3DSA:3.40.630.30:FF:000637', NULL, NULL, 'Putative acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(227910, NULL, 'G3DSA:3.40.640.10:FF:000233', NULL, NULL, 'Aminotransferase class V-fold PLP-dependent enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(227911, NULL, 'G3DSA:3.40.1350.10:FF:000019', NULL, NULL, 'tRNA intron endonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(227912, NULL, 'G3DSA:1.25.40.190:FF:000008', NULL, NULL, 'Actin-related protein 2/3 complex subunit 5', NULL, NULL, NULL, NULL, NULL, 4),
(227913, NULL, 'G3DSA:3.40.50.1440:FF:000015', NULL, NULL, 'Tubulin beta class I', NULL, NULL, NULL, NULL, NULL, 4),
(227914, NULL, 'G3DSA:1.10.287.110:FF:000372', NULL, NULL, 'Diphthamide biosynthesis protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(227915, NULL, 'G3DSA:3.30.160.60:FF:004850', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227916, NULL, 'G3DSA:3.30.300.90:FF:000003', NULL, NULL, 'BolA family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(227917, NULL, 'G3DSA:2.120.10.80:FF:000167', NULL, NULL, 'Kelch motif family protein, expressed', NULL, NULL, NULL, NULL, NULL, 4),
(227918, NULL, 'G3DSA:2.40.50.140:FF:000315', NULL, NULL, 'DNA helicase MCM9, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227919, NULL, 'G3DSA:3.90.1140.10:FF:000008', NULL, NULL, 'U6 snRNA phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(227920, NULL, 'G3DSA:2.40.10.10:FF:000600', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227921, NULL, 'G3DSA:2.170.260.10:FF:000008', NULL, NULL, 'Protein argonaute 7', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(227922, NULL, 'G3DSA:2.102.10.10:FF:000058', NULL, NULL, 'Arsenate reductase (Azurin) small subunit', NULL, NULL, NULL, NULL, NULL, 4),
(227923, NULL, 'G3DSA:3.90.550.10:FF:000664', NULL, NULL, 'Os04g0429500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(227924, NULL, 'G3DSA:1.20.120.340:FF:000006', NULL, NULL, 'Perilipin', NULL, NULL, NULL, NULL, NULL, 4),
(227925, NULL, 'G3DSA:3.40.630.10:FF:000401', NULL, NULL, 'Acetylornithine deacetylase ArgE', NULL, NULL, NULL, NULL, NULL, 4),
(227926, NULL, 'G3DSA:3.30.200.20:FF:002116', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227927, NULL, 'G3DSA:1.20.810.10:FF:000028', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227928, NULL, 'G3DSA:1.20.1560.10:FF:000867', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227929, NULL, 'G3DSA:3.30.60.20:FF:000115', NULL, NULL, 'PRKD2 isoform 13', NULL, NULL, NULL, NULL, NULL, 4),
(227930, NULL, 'G3DSA:3.10.20.70:FF:000033', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227931, NULL, 'G3DSA:3.30.70.20:FF:000043', NULL, NULL, 'Respiratory nitrate reductase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(227932, NULL, 'G3DSA:3.30.500.10:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227933, NULL, 'G3DSA:3.30.40.10:FF:001640', NULL, NULL, 'HMG1/2 (High mobility group) box-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(227934, NULL, 'G3DSA:3.10.100.10:FF:000244', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227935, NULL, 'G3DSA:2.60.200.20:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227936, NULL, 'G3DSA:1.10.3720.10:FF:000236', NULL, NULL, 'Putative uncharacterized protein HI_1475', NULL, NULL, NULL, NULL, NULL, 4),
(227937, NULL, 'G3DSA:2.40.30.10:FF:000258', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227938, NULL, 'G3DSA:3.10.450.50:FF:000001', NULL, NULL, 'calcium/calmodulin-dependent protein kinase type II subunit gamma isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(227939, NULL, 'G3DSA:3.40.449.10:FF:000007', NULL, NULL, 'phosphoenolpyruvate carboxykinase [GTP], mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(227940, NULL, 'G3DSA:3.10.110.10:FF:000172', NULL, NULL, 'SUMO-conjugating enzyme UBC9-B-like', NULL, NULL, NULL, NULL, NULL, 4),
(227941, NULL, 'G3DSA:1.20.120.330:FF:000003', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(227942, NULL, 'G3DSA:1.25.40.10:FF:002713', NULL, NULL, 'TPR repeat', NULL, NULL, NULL, NULL, NULL, 4),
(227943, NULL, 'G3DSA:2.60.40.60:FF:000458', NULL, NULL, 'Cadherin, EGF LAG seven-pass G-type receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(227944, NULL, 'G3DSA:3.10.450.60:FF:000004', NULL, NULL, 'Arachidonate 12-lipoxygenase, 12S-type', NULL, NULL, NULL, NULL, NULL, 4),
(227945, NULL, 'G3DSA:1.10.510.10:FF:002374', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227946, NULL, 'G3DSA:2.60.40.630:FF:000001', NULL, NULL, 'Signal transducer and activator of transcription', NULL, NULL, NULL, NULL, NULL, 4),
(227947, NULL, 'G3DSA:1.25.70.10:FF:000063', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227948, NULL, 'G3DSA:2.30.30.40:FF:000560', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227949, NULL, 'G3DSA:3.40.525.10:FF:000050', NULL, NULL, 'Neurofibromin-A', NULL, NULL, NULL, NULL, NULL, 4),
(227950, NULL, 'G3DSA:1.10.3430.10:FF:000034', NULL, NULL, 'Ammonium transporter, putative', NULL, NULL, NULL, NULL, NULL, 4),
(227951, NULL, 'G3DSA:2.10.25.10:FF:001259', NULL, NULL, 'Crumbs cell polarity complex component 2', NULL, NULL, NULL, NULL, NULL, 4),
(227952, NULL, 'G3DSA:3.80.10.10:FF:001714', NULL, NULL, 'Immunoglobulin superfamily-containing leucine-rich repeat 2', NULL, NULL, NULL, NULL, NULL, 4),
(227953, NULL, 'G3DSA:3.40.50.300:FF:002546', NULL, NULL, 'Irc3p', NULL, NULL, NULL, NULL, NULL, 4),
(227954, NULL, 'G3DSA:3.10.28.10:FF:000055', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(227955, NULL, 'G3DSA:3.90.70.10:FF:000661', NULL, NULL, 'Ubiquitin-specific peptidase 32', NULL, NULL, NULL, NULL, NULL, 4),
(227956, NULL, 'G3DSA:3.40.630.10:FF:000305', NULL, NULL, 'Carboxypeptidase A', NULL, NULL, NULL, NULL, NULL, 4),
(227957, NULL, 'G3DSA:3.80.10.10:FF:002996', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227958, NULL, 'G3DSA:3.40.50.1100:FF:000256', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(227959, NULL, 'G3DSA:2.40.50.100:FF:000219', NULL, NULL, 'ABC transporter related', NULL, NULL, NULL, NULL, NULL, 4),
(227960, NULL, 'G3DSA:3.40.50.300:FF:006245', NULL, NULL, 'Type III restriction enzyme, res subunit family protein', NULL, NULL, NULL, NULL, NULL, 4),
(227961, NULL, 'G3DSA:2.40.170.20:FF:000018', NULL, NULL, 'Carboxypeptidase regulatory-like domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(227962, NULL, 'G3DSA:2.70.150.10:FF:000097', NULL, NULL, 'Cation transporter ATPase G', NULL, NULL, NULL, NULL, NULL, 4),
(227963, NULL, 'G3DSA:3.90.980.20:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227964, NULL, 'G3DSA:2.130.10.10:FF:000337', NULL, NULL, 'ATG16 autophagy related 16-like 1 (S. cerevisiae)', NULL, NULL, NULL, NULL, NULL, 4),
(227965, NULL, 'G3DSA:1.10.238.10:FF:000554', NULL, NULL, 'Reticulocalbin 3', NULL, NULL, NULL, NULL, NULL, 4),
(227966, NULL, 'G3DSA:3.50.4.10:FF:000062', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227967, NULL, 'G3DSA:1.10.287.1970:FF:000008', NULL, NULL, 'Cc2-5', NULL, NULL, NULL, NULL, NULL, 4),
(227968, NULL, 'G3DSA:3.50.50.60:FF:000075', NULL, NULL, 'Nitric oxide reductase FlRd-NAD(+) reductase', NULL, NULL, NULL, NULL, NULL, 4),
(227969, NULL, 'G3DSA:2.60.40.10:FF:002063', NULL, NULL, 'Glucans biosynthesis protein D', NULL, NULL, NULL, NULL, NULL, 4),
(227970, NULL, 'G3DSA:1.10.1780.10:FF:000015', NULL, NULL, 'ATP-dependent chaperone ClpB', NULL, NULL, NULL, NULL, NULL, 4),
(227971, NULL, 'G3DSA:3.50.7.10:FF:000001', NULL, NULL, '60 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(227972, NULL, 'G3DSA:3.40.50.10840:FF:000001', NULL, NULL, 'Ketose-bisphosphate aldolase class-II family protein', NULL, NULL, NULL, NULL, NULL, 4),
(227973, NULL, 'G3DSA:3.30.160.60:FF:000472', NULL, NULL, 'myoneurin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(227974, NULL, 'G3DSA:3.40.50.300:FF:004800', NULL, NULL, 'YALI0F20724p', NULL, NULL, NULL, NULL, NULL, 4),
(227975, NULL, 'G3DSA:3.30.160.60:FF:000808', NULL, NULL, 'Zinc finger and BTB domain-containing protein 43', NULL, NULL, NULL, NULL, NULL, 4),
(227976, NULL, 'G3DSA:1.10.10.10:FF:000244', NULL, NULL, 'ETS-related transcription factor Elf-5 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(227977, NULL, 'G3DSA:3.40.50.970:FF:000223', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227978, NULL, 'G3DSA:3.30.540.10:FF:000008', NULL, NULL, 'Fructose-1,6-bisphosphatase, cytosolic', NULL, NULL, NULL, NULL, NULL, 4),
(227979, NULL, 'G3DSA:3.40.140.10:FF:000105', NULL, NULL, 'Hypothetical_protein_-_conserved', NULL, NULL, NULL, NULL, NULL, 4),
(227980, NULL, 'G3DSA:3.40.190.10:FF:000254', NULL, NULL, 'Prephenate dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(227981, NULL, 'G3DSA:3.50.50.60:FF:001177', NULL, NULL, 'NADPH:adrenodoxin oxidoreductase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(227982, NULL, 'G3DSA:2.60.200.20:FF:000039', NULL, NULL, 'Forkhead transcription factor Fkh1/2', NULL, NULL, NULL, NULL, NULL, 4),
(227983, NULL, 'G3DSA:2.60.40.10:FF:001787', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(227984, NULL, 'G3DSA:3.30.40.10:FF:000100', NULL, NULL, 'E3 ubiquitin-protein ligase RING2', NULL, NULL, NULL, NULL, NULL, 4),
(227985, NULL, 'G3DSA:3.40.50.11980:FF:000017', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227986, NULL, 'G3DSA:3.40.50.1000:FF:000344', NULL, NULL, 'Protein CBG09463', NULL, NULL, NULL, NULL, NULL, 4),
(227987, NULL, 'G3DSA:3.90.226.10:FF:000175', NULL, NULL, '3-hydroxyisobutyryl-CoA hydrolase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(227988, NULL, 'G3DSA:3.40.50.720:FF:001705', NULL, NULL, 'Myo-inositol-1-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(227989, NULL, 'G3DSA:2.120.10.30:FF:000304', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(227990, NULL, 'G3DSA:2.30.180.10:FF:000142', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227991, NULL, 'G3DSA:2.10.220.10:FF:000066', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(227992, NULL, 'G3DSA:1.25.70.10:FF:000080', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227993, NULL, 'G3DSA:3.30.505.10:FF:000118', NULL, NULL, 'SH2 domain-containing adapter protein B', NULL, NULL, NULL, NULL, NULL, 4),
(227994, NULL, 'G3DSA:2.130.10.10:FF:004053', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227995, NULL, 'G3DSA:3.30.160.60:FF:002372', NULL, NULL, 'IKAROS family zinc finger 3', NULL, NULL, NULL, NULL, NULL, 4),
(227996, NULL, 'G3DSA:3.30.160.60:FF:005013', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(227997, NULL, 'G3DSA:2.160.20.60:FF:000008', NULL, NULL, 'Ferredoxin/NAD(P)H-dependent glutamate synthase, large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(227998, NULL, 'G3DSA:1.25.40.10:FF:004304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(227999, NULL, 'G3DSA:1.10.150.340:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228000, NULL, 'G3DSA:3.40.50.1820:FF:001427', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(228001, NULL, 'G3DSA:3.40.50.150:FF:000551', NULL, NULL, 'Methyltransferase domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228002, NULL, 'G3DSA:1.25.10.10:FF:001498', NULL, NULL, 'Pumilio/PUF RNA binding protein 10, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228003, NULL, 'G3DSA:3.30.60.30:FF:000118', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228004, NULL, 'G3DSA:1.10.20.10:FF:000172', NULL, NULL, 'Histone H2A', NULL, NULL, NULL, NULL, NULL, 4),
(228005, NULL, 'G3DSA:1.20.1280.50:FF:000138', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(228006, NULL, 'G3DSA:1.10.10.820:FF:000022', NULL, NULL, 'Uncharacterized protein, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(228007, NULL, 'G3DSA:1.10.760.10:FF:000054', NULL, NULL, 'Cytochrome c551 peroxidase', NULL, NULL, NULL, NULL, NULL, 4),
(228008, NULL, 'G3DSA:1.20.5.390:FF:000005', NULL, NULL, 'LINE-1 retrotransposable element ORF1 protein', NULL, NULL, NULL, NULL, NULL, 4),
(228009, NULL, 'G3DSA:1.20.120.720:FF:000013', NULL, NULL, 'unconventional myosin-Ic isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(228010, NULL, 'G3DSA:2.130.10.10:FF:003777', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228011, NULL, 'G3DSA:3.40.50.2000:FF:000301', NULL, NULL, 'Glycosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(228012, NULL, 'G3DSA:3.30.230.10:FF:000024', NULL, NULL, '30S ribosomal protein S5', NULL, NULL, NULL, NULL, NULL, 4),
(228013, NULL, 'G3DSA:2.130.10.10:FF:004620', NULL, NULL, 'EF hand family protein', NULL, NULL, NULL, NULL, NULL, 4),
(228014, NULL, 'G3DSA:1.25.40.20:FF:001070', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(228015, NULL, 'G3DSA:3.30.200.20:FF:000525', NULL, NULL, 'Serine/threonine-protein kinase KIN3', NULL, NULL, NULL, NULL, NULL, 4),
(228016, NULL, 'G3DSA:1.20.1000.10:FF:000022', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228017, NULL, 'G3DSA:3.90.1480.20:FF:000054', NULL, NULL, 'Alpha-2,8-sialyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(228018, NULL, 'G3DSA:1.25.40.20:FF:000581', NULL, NULL, 'POTE ankyrin domain family member E', NULL, NULL, NULL, NULL, NULL, 4),
(228019, NULL, 'G3DSA:1.20.1250.20:FF:001145', NULL, NULL, 'Battenin', NULL, NULL, NULL, NULL, NULL, 4),
(228020, NULL, 'G3DSA:1.10.1420.10:FF:000062', NULL, NULL, 'DNA mismatch repair protein MSH2', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(228021, NULL, 'G3DSA:3.10.20.90:FF:000606', NULL, NULL, 'MAP kinase', NULL, NULL, NULL, NULL, NULL, 4),
(228022, NULL, 'G3DSA:3.40.50.880:FF:000191', NULL, NULL, 'Imidazole glycerol phosphate synthase hisHF chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(228023, NULL, 'G3DSA:2.160.20.10:FF:000022', NULL, NULL, 'F-box only protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(228024, NULL, 'G3DSA:2.60.40.1120:FF:000011', NULL, NULL, 'Carboxypeptidase N catalytic chain', NULL, NULL, NULL, NULL, NULL, 4),
(228025, NULL, 'G3DSA:3.30.160.60:FF:006424', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228026, NULL, 'G3DSA:1.10.167.10:FF:000029', NULL, NULL, 'G protein-coupled receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(228027, NULL, 'G3DSA:1.20.120.730:FF:000016', NULL, NULL, 'Protein transport protein Sec24-like At3g07100', NULL, NULL, NULL, NULL, NULL, 4),
(228028, NULL, 'G3DSA:3.90.70.10:FF:000335', NULL, NULL, 'Cysteine protease-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(228029, NULL, 'G3DSA:3.30.420.10:FF:000758', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228030, NULL, 'G3DSA:2.60.40.10:FF:000808', NULL, NULL, 'Leukemia inhibitory factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(228031, NULL, 'G3DSA:1.10.405.40:FF:000002', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228032, NULL, 'G3DSA:6.10.140.2150:FF:000012', NULL, NULL, 'Putative sphingosine-1-phosphate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(228033, NULL, 'G3DSA:1.20.58.80:FF:000037', NULL, NULL, 'Putative associated molecule with the SH3 domain of STAM', NULL, NULL, NULL, NULL, NULL, 4),
(228034, NULL, 'G3DSA:1.10.8.60:FF:000578', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228035, NULL, 'G3DSA:1.10.10.10:FF:000805', NULL, NULL, 'ROK family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(228036, NULL, 'G3DSA:3.30.160.60:FF:004524', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228037, NULL, 'G3DSA:1.20.1070.10:FF:001594', NULL, NULL, 'Seven TM Receptor', NULL, NULL, NULL, NULL, NULL, 4),
(228038, NULL, 'G3DSA:2.60.120.920:FF:000187', NULL, NULL, 'LOC100127740 protein', NULL, NULL, NULL, NULL, NULL, 4),
(228039, NULL, 'G3DSA:2.40.100.10:FF:000067', NULL, NULL, 'Peptidyl-prolyl cis-trans isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(228040, NULL, 'G3DSA:3.90.740.10:FF:000038', NULL, NULL, 'Isoleucyl-tRNA synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(228041, NULL, 'G3DSA:3.40.50.300:FF:004671', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228042, NULL, 'G3DSA:3.40.47.10:FF:000160', NULL, NULL, 'Beta-ketoacyl synthase PigJ', NULL, NULL, NULL, NULL, NULL, 4),
(228043, NULL, 'G3DSA:1.50.40.10:FF:000289', NULL, NULL, 'Mitochondrial substrate carrier family protein', NULL, NULL, NULL, NULL, NULL, 4),
(228044, NULL, 'G3DSA:3.30.450.200:FF:000006', NULL, NULL, 'DENN domain and WD repeat-containing protein SCD1', NULL, NULL, NULL, NULL, NULL, 4),
(228045, NULL, 'G3DSA:3.40.50.150:FF:000449', NULL, NULL, '23S rRNA (Uracil-5-)-methyltransferase RumA', NULL, NULL, NULL, NULL, NULL, 4),
(228046, NULL, 'G3DSA:3.90.550.10:FF:000097', NULL, NULL, 'Glycosyl transferase', NULL, NULL, NULL, NULL, NULL, 4),
(228047, NULL, 'G3DSA:3.40.50.1980:FF:000042', NULL, NULL, 'Iron-regulated ABC transporter siderophore-binding protein SirA', NULL, NULL, NULL, NULL, NULL, 4),
(228048, NULL, 'G3DSA:3.30.40.10:FF:001847', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228049, NULL, 'G3DSA:2.40.70.10:FF:000143', NULL, NULL, 'OSJNBa0006A01.20 protein', NULL, NULL, NULL, NULL, NULL, 4),
(228050, NULL, 'G3DSA:1.20.58.60:FF:000031', NULL, NULL, 'Microtubule-actin cross-linking factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(228051, NULL, 'G3DSA:2.120.10.100:FF:000001', NULL, NULL, 'Soluble calcium-activated nucleotidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(228052, NULL, 'G3DSA:2.30.29.30:FF:001228', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228053, NULL, 'G3DSA:3.40.30.10:FF:000649', NULL, NULL, 'Magnesium transporter 1', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(228054, NULL, 'G3DSA:3.40.30.10:FF:000436', NULL, NULL, 'Probable 28S ribosomal protein S25, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(228055, NULL, 'G3DSA:1.10.506.10:FF:000043', NULL, NULL, 'Plexin C1', NULL, NULL, NULL, NULL, NULL, 4),
(228056, NULL, 'G3DSA:1.20.58.1930:FF:000004', NULL, NULL, 'Erythrocyte membrane protein 1, PfEMP1', NULL, NULL, NULL, NULL, NULL, 4),
(228057, NULL, 'G3DSA:2.40.10.10:FF:000246', NULL, NULL, 'inactive serine protease 35', NULL, NULL, NULL, NULL, NULL, 4),
(228058, NULL, 'G3DSA:3.30.565.10:FF:000195', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(228059, NULL, 'G3DSA:1.25.10.10:FF:000183', NULL, NULL, 'Proteasome activator complex subunit 4', NULL, NULL, NULL, NULL, NULL, 4),
(228060, NULL, 'G3DSA:2.70.98.20:FF:000006', NULL, NULL, 'Amine oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(228061, NULL, 'G3DSA:2.60.40.10:FF:005839', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228062, NULL, 'G3DSA:1.20.58.70:FF:000034', NULL, NULL, 'Syntaxin 5', NULL, NULL, NULL, NULL, NULL, 4),
(228063, NULL, 'G3DSA:3.10.10.10:FF:000003', NULL, NULL, 'Retrovirus-related Pol polyprotein from transposon 297-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(228064, NULL, 'G3DSA:2.70.98.10:FF:000003', NULL, NULL, 'Aldose 1-epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(228065, NULL, 'G3DSA:1.25.10.10:FF:000396', NULL, NULL, 'E3 ubiquitin-protein ligase listerin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(228066, NULL, 'G3DSA:2.60.40.150:FF:000733', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(228067, NULL, 'G3DSA:3.40.50.1580:FF:000012', NULL, NULL, 'Probable 6-oxopurine nucleoside phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(228068, NULL, 'G3DSA:4.10.60.10:FF:000004', NULL, NULL, 'cellular nucleic acid-binding protein isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(228069, NULL, 'G3DSA:2.130.10.10:FF:002366', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228070, NULL, 'G3DSA:2.170.270.10:FF:000166', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228071, NULL, 'G3DSA:1.10.510.10:FF:000249', NULL, NULL, 'Calcium-dependent protein kinase SK5', NULL, NULL, NULL, NULL, NULL, 4),
(228072, NULL, 'G3DSA:3.30.1380.20:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228073, NULL, 'G3DSA:2.60.120.620:FF:000092', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228074, NULL, 'G3DSA:2.130.10.10:FF:001877', NULL, NULL, 'Autophagy-related protein 16 isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(228075, NULL, 'G3DSA:3.30.1640.10:FF:000061', NULL, NULL, 'DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(228076, NULL, 'G3DSA:1.20.1250.20:FF:001706', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228077, NULL, 'G3DSA:1.10.10.10:FF:000452', NULL, NULL, 'Rap guanine nucleotide exchange factor 5', NULL, NULL, NULL, NULL, NULL, 4),
(228078, NULL, 'G3DSA:3.40.30.10:FF:000863', NULL, NULL, 'Grx4 family monothiol glutaredoxin', NULL, NULL, NULL, NULL, NULL, 4),
(228079, NULL, 'G3DSA:1.20.1070.10:FF:001723', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228080, NULL, 'G3DSA:3.40.50.970:FF:000015', NULL, NULL, '2-oxoisovalerate dehydrogenase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(228081, NULL, 'G3DSA:3.40.50.300:FF:008156', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228082, NULL, 'G3DSA:2.60.40.60:FF:000801', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228083, NULL, 'G3DSA:3.40.1260.10:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228084, NULL, 'G3DSA:1.10.472.10:FF:000255', NULL, NULL, 'Si:ch211-132b12.8', NULL, NULL, NULL, NULL, NULL, 4),
(228085, NULL, 'G3DSA:3.40.50.300:FF:001231', NULL, NULL, 'Protein CLP1 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(228086, NULL, 'G3DSA:3.90.79.10:FF:000181', NULL, NULL, 'YALI0F26059p', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(228087, NULL, 'G3DSA:3.40.1280.10:FF:000013', NULL, NULL, 'RNA methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(228088, NULL, 'G3DSA:3.10.180.10:FF:000007', NULL, NULL, '4-hydroxyphenylpyruvate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(228089, NULL, 'G3DSA:3.10.20.90:FF:000477', NULL, NULL, 'U11/U12 small nuclear ribonucleoprotein 25 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(228090, NULL, 'G3DSA:3.30.565.10:FF:000223', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(228091, NULL, 'G3DSA:3.30.1380.20:FF:000026', NULL, NULL, 'Transport protein particle (Trapp) component, bet3 protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228092, NULL, 'G3DSA:3.30.2410.10:FF:000038', NULL, NULL, 'HECT-domain ubiquitin--protein ligase E3', NULL, NULL, NULL, NULL, NULL, 4),
(228093, NULL, 'G3DSA:3.50.50.60:FF:000103', NULL, NULL, 'Putative N-methylproline demethylase', NULL, NULL, NULL, NULL, NULL, 4),
(228094, NULL, 'G3DSA:3.30.1360.120:FF:000089', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228095, NULL, 'G3DSA:2.60.40.10:FF:000247', NULL, NULL, 'Vascular endothelial growth factor receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(228096, NULL, 'G3DSA:3.40.50.300:FF:002760', NULL, NULL, 'Unplaced genomic scaffold supercont1.11, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(228097, NULL, 'G3DSA:1.25.10.10:FF:002223', NULL, NULL, 'Os10g0508500 protein', NULL, NULL, NULL, NULL, NULL, 4),
(228098, NULL, 'G3DSA:3.20.20.450:FF:000015', NULL, NULL, 'Biofilm formation regulator HmsP', NULL, NULL, NULL, NULL, NULL, 4),
(228099, NULL, 'G3DSA:3.30.360.10:FF:000028', NULL, NULL, 'GLUCOSE-FRUCTOSE OXIDOREDUCTASE', NULL, NULL, NULL, NULL, NULL, 4),
(228100, NULL, 'G3DSA:2.60.200.20:FF:000247', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228101, NULL, 'G3DSA:1.25.40.20:FF:000704', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228102, NULL, 'G3DSA:1.10.238.10:FF:000228', NULL, NULL, 'polycystin-2 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(228103, NULL, 'G3DSA:2.40.440.10:FF:000019', NULL, NULL, 'L,D-transpeptidase catalytic domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(228104, NULL, 'G3DSA:2.90.10.10:FF:000047', NULL, NULL, 'Putative inactive G-type lectin S-receptor-like serine/threonine-protein kinase SRK', NULL, NULL, NULL, NULL, NULL, 4),
(228105, NULL, 'G3DSA:2.60.40.10:FF:004524', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228106, NULL, 'G3DSA:3.10.129.10:FF:000113', NULL, NULL, 'Thioesterase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(228107, NULL, 'G3DSA:1.10.10.10:FF:001975', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228108, NULL, 'G3DSA:2.170.270.10:FF:000048', NULL, NULL, 'Histone-lysine N-methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228109, NULL, 'G3DSA:3.30.450.20:FF:000589', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228110, NULL, 'G3DSA:1.25.40.10:FF:000701', NULL, NULL, 'Pentatricopeptide repeat protein (AFU_orthologue AFUA_4G07240)', NULL, NULL, NULL, NULL, NULL, 4),
(228111, NULL, 'G3DSA:3.40.50.1980:FF:000137', NULL, NULL, 'Manganese ABC transporter, periplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(228112, NULL, 'G3DSA:3.30.200.20:FF:001386', NULL, NULL, 'Eukaryotic protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(228113, NULL, 'G3DSA:1.10.510.10:FF:003003', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228114, NULL, 'G3DSA:3.30.870.10:FF:000106', NULL, NULL, 'Phosphatidylcholine-hydrolyzing phospholipase D (PLD) family', NULL, NULL, NULL, NULL, NULL, 4),
(228115, NULL, 'G3DSA:1.25.40.10:FF:002152', NULL, NULL, 'Pentatricopeptide repeat-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(228116, NULL, 'G3DSA:4.10.400.10:FF:000084', NULL, NULL, 'Low density lipoprotein receptor', NULL, NULL, NULL, NULL, NULL, 4),
(228117, NULL, 'G3DSA:3.30.160.60:FF:001410', NULL, NULL, 'Histone H4 transcription factor', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(228118, NULL, 'G3DSA:3.40.50.280:FF:000005', NULL, NULL, 'Fused isobutyryl-CoA mutase', NULL, NULL, NULL, NULL, NULL, 4),
(228119, NULL, 'G3DSA:1.10.510.10:FF:002503', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228120, NULL, 'G3DSA:3.30.200.20:FF:001487', NULL, NULL, 'Putative LRR receptor-like serine/threonine-protein kinase isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(228121, NULL, 'G3DSA:3.30.1320.10:FF:000020', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228122, NULL, 'G3DSA:1.10.10.440:FF:000099', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228123, NULL, 'G3DSA:3.30.70.330:FF:000206', NULL, NULL, 'Smooth, isoform L', NULL, NULL, NULL, NULL, NULL, 4),
(228124, NULL, 'G3DSA:2.160.20.10:FF:000134', NULL, NULL, 'F-box protein 10', NULL, NULL, NULL, NULL, NULL, 4),
(228125, NULL, 'G3DSA:3.40.640.10:FF:000121', NULL, NULL, 'Aspartate aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(228126, NULL, 'G3DSA:4.10.320.10:FF:000026', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(228127, NULL, 'G3DSA:3.90.70.10:FF:000217', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(228128, NULL, 'G3DSA:3.70.10.10:FF:000057', NULL, NULL, 'DNA polymerase III subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(228129, NULL, 'G3DSA:3.40.120.10:FF:000109', NULL, NULL, 'Phosphoglucomutase', NULL, NULL, NULL, NULL, NULL, 4),
(228130, NULL, 'G3DSA:3.90.110.10:FF:000007', NULL, NULL, 'ubiquitin-conjugating enzyme E2 variant 3 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(228131, NULL, 'G3DSA:3.40.50.300:FF:004457', NULL, NULL, 'Sulfate adenylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(228132, NULL, 'G3DSA:2.60.40.1800:FF:000001', NULL, NULL, 'Subtilisin-like serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(228133, NULL, 'G3DSA:1.20.1310.10:FF:000023', NULL, NULL, 'cullin-1', NULL, NULL, NULL, NULL, NULL, 4),
(228134, NULL, 'G3DSA:3.40.50.720:FF:001694', NULL, NULL, 'Putative uncharacterized protein YPL276W', NULL, NULL, NULL, NULL, NULL, 4),
(228135, NULL, 'G3DSA:3.40.30.10:FF:000762', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(228136, NULL, 'G3DSA:3.30.420.40:FF:000177', NULL, NULL, 'Glycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(228137, NULL, 'G3DSA:3.40.50.150:FF:000219', NULL, NULL, 'tRNA (Carboxymethyluridine(34)-5-O)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(228138, NULL, 'G3DSA:1.10.510.10:FF:000148', NULL, NULL, 'Serine/threonine-protein kinase Nek7', NULL, NULL, NULL, NULL, NULL, 4),
(228139, NULL, 'G3DSA:3.40.50.1820:FF:000022', NULL, NULL, 'Esterase FrsA', NULL, NULL, NULL, NULL, NULL, 4),
(228140, NULL, 'G3DSA:3.40.250.10:FF:000198', NULL, NULL, 'Adenylyltransferase and sulfurtransferase UBA4', NULL, NULL, NULL, NULL, NULL, 4),
(228141, NULL, 'G3DSA:2.60.40.60:FF:000700', NULL, NULL, 'Protocadherin Fat 4', NULL, NULL, NULL, NULL, NULL, 4),
(228142, NULL, 'G3DSA:3.30.160.60:FF:000685', NULL, NULL, 'Zinc finger protein 653', NULL, NULL, NULL, NULL, NULL, 4),
(228143, NULL, 'G3DSA:1.20.210.10:FF:000033', NULL, NULL, 'Cytochrome c oxidase, subunit I', NULL, NULL, NULL, NULL, NULL, 4),
(228144, NULL, 'G3DSA:2.130.10.10:FF:004502', NULL, NULL, 'Dynein intermediate chain, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228145, NULL, 'G3DSA:2.30.30.30:FF:000113', NULL, NULL, '50S small subunit ribosomal protein L2', NULL, NULL, NULL, NULL, NULL, 4),
(228146, NULL, 'G3DSA:1.10.10.60:FF:001299', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228147, NULL, 'G3DSA:2.60.40.1820:FF:000007', NULL, NULL, 'NDR1/HIN1-like protein 13', NULL, NULL, NULL, NULL, NULL, 4),
(228148, NULL, 'G3DSA:3.30.160.60:FF:004636', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228149, NULL, 'G3DSA:1.10.238.10:FF:000341', NULL, NULL, 'Putative calcium-binding protein CML19', NULL, NULL, NULL, NULL, NULL, 4),
(228150, NULL, 'G3DSA:2.120.10.30:FF:000085', NULL, NULL, 'Teneurin-1', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(228151, NULL, 'G3DSA:3.30.890.10:FF:000006', NULL, NULL, 'Methyl-CpG-binding domain protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(228152, NULL, 'G3DSA:2.30.30.40:FF:000116', NULL, NULL, 'Sorting nexin', NULL, NULL, NULL, NULL, NULL, 4),
(228153, NULL, 'G3DSA:3.30.9.10:FF:000275', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(228154, NULL, 'G3DSA:3.40.50.1820:FF:001545', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228155, NULL, 'G3DSA:3.30.200.20:FF:002212', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228156, NULL, 'G3DSA:2.30.230.10:FF:000011', NULL, NULL, 'Apolipophorins', NULL, NULL, NULL, NULL, NULL, 4),
(228157, NULL, 'G3DSA:3.30.1490.40:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228158, NULL, 'G3DSA:2.130.10.10:FF:004171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228159, NULL, 'G3DSA:2.130.10.10:FF:004491', NULL, NULL, 'WD repeat domain 5B-like', NULL, NULL, NULL, NULL, NULL, 4),
(228160, NULL, 'G3DSA:2.120.10.80:FF:000280', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(228161, NULL, 'G3DSA:3.30.565.10:FF:000318', NULL, NULL, 'DNA mismatch repair protein mlh1', NULL, NULL, NULL, NULL, NULL, 4),
(228162, NULL, 'G3DSA:4.10.400.10:FF:000179', NULL, NULL, 'Terribly reduced optic lobes, isoform AH', NULL, NULL, NULL, NULL, NULL, 4),
(228163, NULL, 'G3DSA:3.30.420.150:FF:000024', NULL, NULL, 'Ppx/GppA phosphatase family-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(228164, NULL, 'G3DSA:1.20.1250.20:FF:000301', NULL, NULL, 'Protein ZINC INDUCED FACILITATOR-LIKE 1', NULL, NULL, NULL, NULL, NULL, 4),
(228165, NULL, 'G3DSA:1.20.1070.10:FF:000200', NULL, NULL, 'Adhesion G protein-coupled receptor L3', NULL, NULL, NULL, NULL, NULL, 4),
(228166, NULL, 'G3DSA:1.10.287.3700:FF:000005', NULL, NULL, 'PAN2-PAN3 deadenylation complex subunit pan3', NULL, NULL, NULL, NULL, NULL, 4),
(228167, NULL, 'G3DSA:3.30.450.200:FF:000012', NULL, NULL, 'DENN domain containing protein 2D', NULL, NULL, NULL, NULL, NULL, 4),
(228168, NULL, 'G3DSA:1.25.40.10:FF:003675', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228169, NULL, 'G3DSA:1.10.472.10:FF:000356', NULL, NULL, 'CYclin A', NULL, NULL, NULL, NULL, NULL, 4),
(228170, NULL, 'G3DSA:2.130.10.10:FF:000803', NULL, NULL, 'WD repeat and SOCS box-containing 1, isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(228171, NULL, 'G3DSA:3.40.30.10:FF:001037', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228172, NULL, 'G3DSA:1.10.510.10:FF:002278', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228173, NULL, 'G3DSA:1.20.1050.10:FF:000300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228174, NULL, 'G3DSA:3.40.50.980:FF:000018', NULL, NULL, 'Non-ribosomal peptide synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(228175, NULL, 'G3DSA:3.60.21.10:FF:000280', NULL, NULL, 'Sphingomyelinase phosphodiesterase C', NULL, NULL, NULL, NULL, NULL, 4),
(228176, NULL, 'G3DSA:1.10.3720.10:FF:000023', NULL, NULL, 'Peptide ABC transporter permease SapB', NULL, NULL, NULL, NULL, NULL, 4),
(228177, NULL, 'G3DSA:3.40.50.300:FF:006711', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228178, NULL, 'G3DSA:3.40.1280.30:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228179, NULL, 'G3DSA:2.60.40.10:FF:004187', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228180, NULL, 'G3DSA:3.40.50.2000:FF:001049', NULL, NULL, 'Protein CBG08157', NULL, NULL, NULL, NULL, NULL, 4),
(228181, NULL, 'G3DSA:3.40.50.300:FF:000517', NULL, NULL, 'Cytoplasmic dynein heavy chain 1', NULL, NULL, NULL, NULL, NULL, 4),
(228182, NULL, 'G3DSA:3.40.50.12390:FF:000011', NULL, NULL, 'Putative 5''-3'' exonuclease', NULL, NULL, NULL, NULL, NULL, 4),
(228183, NULL, 'G3DSA:1.10.287.2900:FF:000007', NULL, NULL, 'MIX14p Mitochondrial intermembrane space protein', NULL, NULL, NULL, NULL, NULL, 4),
(228184, NULL, 'G3DSA:3.40.630.30:FF:000188', NULL, NULL, 'Acetyltransferase, GNAT family', NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(228185, NULL, 'G3DSA:3.30.450.20:FF:000004', NULL, NULL, 'Period circadian protein homolog 3', NULL, NULL, NULL, NULL, NULL, 4),
(228186, NULL, 'G3DSA:3.90.550.10:FF:000125', NULL, NULL, 'Putative glycosyltransferase CsbB', NULL, NULL, NULL, NULL, NULL, 4),
(228187, NULL, 'G3DSA:3.30.40.10:FF:000330', NULL, NULL, 'nitric oxide synthase-interacting protein-like', NULL, NULL, NULL, NULL, NULL, 4),
(228188, NULL, 'G3DSA:1.10.510.10:FF:000575', NULL, NULL, 'Serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(228189, NULL, 'G3DSA:1.10.238.10:FF:000436', NULL, NULL, 'AcTiniN', NULL, NULL, NULL, NULL, NULL, 4),
(228190, NULL, 'G3DSA:3.40.50.300:FF:006812', NULL, NULL, 'ADP-ribosylation factor-like protein 4A', NULL, NULL, NULL, NULL, NULL, 4),
(228191, NULL, 'G3DSA:3.90.550.50:FF:000210', NULL, NULL, 'Hexosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(228192, NULL, 'G3DSA:3.40.47.10:FF:000047', NULL, NULL, 'Acetyl-CoA acetyltransferase FadA6', NULL, NULL, NULL, NULL, NULL, 4),
(228193, NULL, 'G3DSA:3.30.450.30:FF:000007', NULL, NULL, 'Profilin', NULL, NULL, NULL, NULL, NULL, 4),
(228194, NULL, 'G3DSA:3.40.630.10:FF:000182', NULL, NULL, 'Peptidase M14 carboxypeptidase A', NULL, NULL, NULL, NULL, NULL, 4),
(228195, NULL, 'G3DSA:1.10.30.10:FF:000127', NULL, NULL, 'SWI/SNF-related matrix-associated actin-dependent regulator of chromatin subfamily E member 1', NULL, NULL, NULL, NULL, NULL, 4),
(228196, NULL, 'G3DSA:1.10.4080.10:FF:000007', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228197, NULL, 'G3DSA:3.40.50.720:FF:001593', NULL, NULL, 'Putative ubiquinone oxidoreductase ndufa9/39kda subunit', NULL, NULL, NULL, NULL, NULL, 4),
(228198, NULL, 'G3DSA:3.30.70.330:FF:001398', NULL, NULL, 'heterogeneous nuclear ribonucleoprotein A1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(228199, NULL, 'G3DSA:3.40.50.720:FF:002211', NULL, NULL, '2''-dehydrokanamycin reductase', NULL, NULL, NULL, NULL, NULL, 4),
(228200, NULL, 'G3DSA:3.40.50.1100:FF:000262', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228201, NULL, 'G3DSA:1.25.40.10:FF:004181', NULL, NULL, 'Cytochrome c maturation system haem lyase subunit SirG', NULL, NULL, NULL, NULL, NULL, 4),
(228202, NULL, 'G3DSA:3.20.20.220:FF:000076', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(228203, NULL, 'G3DSA:3.40.50.300:FF:004558', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(228204, NULL, 'G3DSA:3.30.1610.10:FF:000019', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(228205, NULL, 'G3DSA:3.90.920.10:FF:000024', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(228206, NULL, 'G3DSA:2.120.10.30:FF:000416', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228207, NULL, 'G3DSA:3.90.70.10:FF:000902', NULL, NULL, 'Probable ubiquitin carboxyl-terminal hydrolase 7', NULL, NULL, NULL, NULL, NULL, 4),
(228208, NULL, 'G3DSA:1.10.150.80:FF:000034', NULL, NULL, 'ATP-dependent helicase SGS1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228209, NULL, 'G3DSA:3.90.550.50:FF:000193', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(228210, NULL, 'G3DSA:2.40.30.10:FF:000028', NULL, NULL, 'GTP-binding protein 1,-like', NULL, NULL, NULL, NULL, NULL, 4),
(228211, NULL, 'G3DSA:1.20.1070.10:FF:000779', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(228212, NULL, 'G3DSA:2.60.120.10:FF:000777', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228213, NULL, 'G3DSA:3.60.21.10:FF:000487', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228214, NULL, 'G3DSA:3.30.230.130:FF:000065', NULL, NULL, 'YALI0E04983p', NULL, NULL, NULL, NULL, NULL, 4),
(228215, NULL, 'G3DSA:3.80.10.10:FF:001585', NULL, NULL, 'Leucine-rich repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(228216, NULL, 'G3DSA:4.10.1190.10:FF:000001', NULL, NULL, 'Photosystem I reaction center subunit N', NULL, NULL, NULL, NULL, NULL, 4),
(228217, NULL, 'G3DSA:2.60.40.10:FF:004204', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(228218, NULL, 'G3DSA:1.10.10.10:FF:000238', NULL, NULL, 'HTH-type transcriptional activator TtdR', NULL, NULL, NULL, NULL, NULL, 4),
(228219, NULL, 'G3DSA:1.25.40.20:FF:000693', NULL, NULL, 'Ankyrin repeat domain 2', NULL, NULL, NULL, NULL, NULL, 4),
(228220, NULL, 'G3DSA:3.10.110.10:FF:000200', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(228221, NULL, 'G3DSA:1.20.5.190:FF:000164', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228222, NULL, 'G3DSA:3.90.70.10:FF:000009', NULL, NULL, 'Putative ubiquitin carboxyl-terminal hydrolase CYLD', NULL, NULL, NULL, NULL, NULL, 4),
(228223, NULL, 'G3DSA:2.60.40.1510:FF:000021', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(228224, NULL, 'G3DSA:3.30.530.20:FF:000062', NULL, NULL, 'LD05321p', NULL, NULL, NULL, NULL, NULL, 4),
(228225, NULL, 'G3DSA:1.20.120.430:FF:000027', NULL, NULL, 'AGAP002133-PA', NULL, NULL, NULL, NULL, NULL, 4),
(228226, NULL, 'G3DSA:2.102.10.10:FF:000064', NULL, NULL, 'Ubiquinol cytochrome C reductase, subunit RIP1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228227, NULL, 'G3DSA:3.90.70.200:FF:000002', NULL, NULL, 'Zinc finger CCCH domain-containing protein 19', NULL, NULL, NULL, NULL, NULL, 4),
(228228, NULL, 'G3DSA:2.130.10.10:FF:005694', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228229, NULL, 'G3DSA:4.10.400.10:FF:000292', NULL, NULL, 'Basement membrane-specific heparan sulfate proteoglycan core protein-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(228230, NULL, 'G3DSA:3.30.360.10:FF:000141', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228231, NULL, 'G3DSA:2.160.20.10:FF:000252', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228232, NULL, 'G3DSA:3.30.590.10:FF:000051', NULL, NULL, 'Creatine kinase, M-type', NULL, NULL, NULL, NULL, NULL, 4),
(228233, NULL, 'G3DSA:3.10.196.10:FF:000010', NULL, NULL, 'Methionine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(228234, NULL, 'G3DSA:3.30.750.24:FF:000150', NULL, NULL, 'Probable sulfate permease C320.05', NULL, NULL, NULL, NULL, NULL, 4),
(228235, NULL, 'G3DSA:3.40.50.300:FF:008061', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228236, NULL, 'G3DSA:3.90.550.10:FF:000552', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228237, NULL, 'G3DSA:1.25.10.10:FF:002324', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228238, NULL, 'G3DSA:1.20.1310.10:FF:000135', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228239, NULL, 'G3DSA:3.30.230.70:FF:000126', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228240, NULL, 'G3DSA:1.10.10.10:FF:001767', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228241, NULL, 'G3DSA:2.70.170.10:FF:000109', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228242, NULL, 'G3DSA:3.30.1540.20:FF:000016', NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, NULL, NULL, NULL, 4),
(228243, NULL, 'G3DSA:2.30.30.40:FF:000228', NULL, NULL, 'RUN and SH3 domain containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(228244, NULL, 'G3DSA:3.90.226.10:FF:000063', NULL, NULL, 'ATP-dependent Clp protease proteolytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(228245, NULL, 'G3DSA:3.30.70.240:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228246, NULL, 'G3DSA:3.30.70.330:FF:001960', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228247, NULL, 'G3DSA:3.30.160.60:FF:002607', NULL, NULL, 'zinc finger protein 184', NULL, NULL, NULL, NULL, NULL, 4),
(228248, NULL, 'G3DSA:3.80.10.10:FF:003625', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228249, NULL, 'G3DSA:3.30.200.20:FF:000290', NULL, NULL, 'Non-specific serine/threonine protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(228250, NULL, 'G3DSA:2.10.25.10:FF:001265', NULL, NULL, 'Protein Z, vitamin K-dependent plasma glycoprotein a', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(228251, NULL, 'G3DSA:3.50.50.60:FF:000530', NULL, NULL, 'Choline dehydrogenase, like protein', NULL, NULL, NULL, NULL, NULL, 4),
(228252, NULL, 'G3DSA:1.10.10.430:FF:000012', NULL, NULL, 'Protein phosphatase, Mg2+/Mn2+-dependent 1N', NULL, NULL, NULL, NULL, NULL, 4),
(228253, NULL, 'G3DSA:3.80.10.10:FF:002788', NULL, NULL, 'Si:dkey-126g1.7', NULL, NULL, NULL, NULL, NULL, 4),
(228254, NULL, 'G3DSA:3.30.160.60:FF:002725', NULL, NULL, 'Zinc finger protein B0310.2', NULL, NULL, NULL, NULL, NULL, 4),
(228255, NULL, 'G3DSA:1.20.1220.12:FF:000001', NULL, NULL, 'Malate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(228256, NULL, 'G3DSA:2.40.70.10:FF:000463', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228257, NULL, 'G3DSA:2.20.70.10:FF:000082', NULL, NULL, 'Phosphorylated CTD-interacting factor', NULL, NULL, NULL, NULL, NULL, 4),
(228258, NULL, 'G3DSA:3.30.420.40:FF:000514', NULL, NULL, 'Glycerol kinase', NULL, NULL, NULL, NULL, NULL, 4),
(228259, NULL, 'G3DSA:3.30.70.580:FF:000039', NULL, NULL, 'Ribosomal small subunit pseudouridylate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(228260, NULL, 'G3DSA:3.30.40.10:FF:001527', NULL, NULL, 'Zinc-binding phosphatase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228261, NULL, 'G3DSA:2.130.10.10:FF:002821', NULL, NULL, 'SVP1-like protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(228262, NULL, 'G3DSA:1.10.510.10:FF:000480', NULL, NULL, 'Pollen receptor-like kinase 1', NULL, NULL, NULL, NULL, NULL, 4),
(228263, NULL, 'G3DSA:3.30.200.20:FF:002324', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228264, NULL, 'G3DSA:1.20.58.390:FF:000235', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228265, NULL, 'G3DSA:1.20.120.1900:FF:000054', NULL, NULL, 'Gamma-tubulin complex component', NULL, NULL, NULL, NULL, NULL, 4),
(228266, NULL, 'G3DSA:3.30.160.60:FF:004283', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228267, NULL, 'G3DSA:3.40.50.1820:FF:001753', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228268, NULL, 'G3DSA:3.10.20.90:FF:000157', NULL, NULL, 'Plexin A3', NULL, NULL, NULL, NULL, NULL, 4),
(228269, NULL, 'G3DSA:1.10.510.10:FF:002166', NULL, NULL, 'Receptor-like protein kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(228270, NULL, 'G3DSA:3.30.160.60:FF:000573', NULL, NULL, 'Putative zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(228271, NULL, 'G3DSA:3.30.420.40:FF:000290', NULL, NULL, 'Arp6p', NULL, NULL, NULL, NULL, NULL, 4),
(228272, NULL, 'G3DSA:2.20.80.10:FF:000021', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228273, NULL, 'G3DSA:3.40.605.10:FF:000096', NULL, NULL, 'Succinate-semialdehyde dehydrogenase, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(228274, NULL, 'G3DSA:3.60.21.10:FF:000392', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228275, NULL, 'G3DSA:1.25.40.20:FF:001311', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(228276, NULL, 'G3DSA:4.10.900.10:FF:000009', NULL, NULL, 'transcription factor 7 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(228277, NULL, 'G3DSA:1.10.287.110:FF:000271', NULL, NULL, 'Mitochondrial import inner membrane translocase subunit TIM16', NULL, NULL, NULL, NULL, NULL, 4),
(228278, NULL, 'G3DSA:3.30.310.210:FF:000001', NULL, NULL, 'insulin-like growth factor 2 mRNA-binding protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(228279, NULL, 'G3DSA:3.40.50.720:FF:000879', NULL, NULL, 'Uronate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(228280, NULL, 'G3DSA:1.10.10.10:FF:000570', NULL, NULL, 'GntR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(228281, NULL, 'G3DSA:3.90.550.10:FF:000563', NULL, NULL, 'Glycosyltransferases', NULL, NULL, NULL, NULL, NULL, 4),
(228282, NULL, 'G3DSA:3.30.160.60:FF:000146', NULL, NULL, 'C2H2 type zinc finger protein', NULL, NULL, NULL, NULL, NULL, 4),
(228283, NULL, 'G3DSA:3.30.20.10:FF:000003', NULL, NULL, 'Chitinase', NULL, NULL, NULL, NULL, NULL, 4),
(228284, NULL, 'G3DSA:3.40.630.30:FF:000396', NULL, NULL, 'FMN reductase', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(228285, NULL, 'G3DSA:3.30.310.220:FF:000004', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228286, NULL, 'G3DSA:3.10.20.90:FF:000365', NULL, NULL, 'UBA52 isoform 14', NULL, NULL, NULL, NULL, NULL, 4),
(228287, NULL, 'G3DSA:3.30.450.40:FF:000241', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(228288, NULL, 'G3DSA:3.40.630.10:FF:000390', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228289, NULL, 'G3DSA:1.20.1070.10:FF:001835', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(228290, NULL, 'G3DSA:2.70.170.10:FF:000222', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228291, NULL, 'G3DSA:3.10.20.90:FF:000595', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228292, NULL, 'G3DSA:2.60.40.10:FF:000713', NULL, NULL, 'Neural cell adhesion molecule L1', NULL, NULL, NULL, NULL, NULL, 4),
(228293, NULL, 'G3DSA:2.130.10.10:FF:005817', NULL, NULL, 'Mitogen-activated protein kinase kinase kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(228294, NULL, 'G3DSA:3.80.10.10:FF:001265', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228295, NULL, 'G3DSA:1.25.40.10:FF:004512', NULL, NULL, 'Bardet-Biedl syndrome 4 protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(228296, NULL, 'G3DSA:2.130.10.10:FF:000680', NULL, NULL, 'UTP7p Nucleolar protein', NULL, NULL, NULL, NULL, NULL, 4),
(228297, NULL, 'G3DSA:2.30.30.40:FF:000655', NULL, NULL, 'Rho GTPase-activating protein 27', NULL, NULL, NULL, NULL, NULL, 4),
(228298, NULL, 'G3DSA:2.60.40.10:FF:002613', NULL, NULL, 'High Incidence of Males (Increased X chromosome loss)', NULL, NULL, NULL, NULL, NULL, 4),
(228299, NULL, 'G3DSA:2.60.200.20:FF:000040', NULL, NULL, 'ras-associating and dilute domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(228300, NULL, 'G3DSA:1.10.560.10:FF:000073', NULL, NULL, 'T-complex protein 1 subunit gamma', NULL, NULL, NULL, NULL, NULL, 4),
(228301, NULL, 'G3DSA:3.40.50.150:FF:000450', NULL, NULL, 'N2,N2-dimethylguanosine tRNA methyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228302, NULL, 'G3DSA:2.60.40.10:FF:001995', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(228303, NULL, 'G3DSA:3.40.50.150:FF:000096', NULL, NULL, 'Guanidinoacetate N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(228304, NULL, 'G3DSA:3.40.50.280:FF:000016', NULL, NULL, 'Anaerobic magnesium-protoporphyrin IX monomethyl ester cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(228305, NULL, 'G3DSA:3.30.70.330:FF:000324', NULL, NULL, 'Polypyrimidine tract-binding protein-like 2', NULL, NULL, NULL, NULL, NULL, 4),
(228306, NULL, 'G3DSA:1.25.40.40:FF:000002', NULL, NULL, 'cytochrome c oxidase subunit 5A, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(228307, NULL, 'G3DSA:3.60.15.10:FF:000214', NULL, NULL, 'CPSF3L protein', NULL, NULL, NULL, NULL, NULL, 4),
(228308, NULL, 'G3DSA:3.40.50.1000:FF:000552', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228309, NULL, 'G3DSA:3.30.70.1660:FF:000027', NULL, NULL, 'Peptide chain release factor PrfB3, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(228310, NULL, 'G3DSA:2.80.10.50:FF:000138', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(228311, NULL, 'G3DSA:2.60.40.10:FF:004642', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228312, NULL, 'G3DSA:2.130.10.10:FF:002580', NULL, NULL, 'Beta transducin Trp-Asp domain-containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228313, NULL, 'G3DSA:2.60.40.10:FF:004412', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228314, NULL, 'G3DSA:2.30.29.30:FF:000031', NULL, NULL, 'protein numb isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(228315, NULL, 'G3DSA:2.60.40.10:FF:000359', NULL, NULL, 'Sidekick cell adhesion molecule 2', NULL, NULL, NULL, NULL, NULL, 4),
(228316, NULL, 'G3DSA:2.60.260.20:FF:000144', NULL, NULL, 'DnAJ-like protein slr0093', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(228317, NULL, 'G3DSA:1.10.8.60:FF:000483', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228318, NULL, 'G3DSA:1.10.20.10:FF:000071', NULL, NULL, 'Transcription factor TFIID complex subunit', NULL, NULL, NULL, NULL, NULL, 4),
(228319, NULL, 'G3DSA:3.40.50.1820:FF:001192', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228320, NULL, 'G3DSA:1.20.1530.20:FF:000008', NULL, NULL, 'Sodium/bile acid cotransporter', NULL, NULL, NULL, NULL, NULL, 4),
(228321, NULL, 'G3DSA:1.10.3730.20:FF:000066', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228322, NULL, 'G3DSA:2.130.10.10:FF:003676', NULL, NULL, 'Protein CBR-IFTA-1', NULL, NULL, NULL, NULL, NULL, 4),
(228323, NULL, 'G3DSA:2.60.40.150:FF:000380', NULL, NULL, 'Synaptotagmin 2', NULL, NULL, NULL, NULL, NULL, 4),
(228324, NULL, 'G3DSA:2.40.10.10:FF:000690', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228325, NULL, 'G3DSA:3.40.50.2300:FF:001257', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228326, NULL, 'G3DSA:3.30.40.10:FF:001185', NULL, NULL, 'PHD-zinc-finger_like_domain/PHD-like_zinc-binding_domain_containing_protein_-_putative', NULL, NULL, NULL, NULL, NULL, 4),
(228327, NULL, 'G3DSA:3.40.50.620:FF:000141', NULL, NULL, 'Argininosuccinate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(228328, NULL, 'G3DSA:3.20.20.70:FF:000398', NULL, NULL, 'Triosephosphate isomerase cytosolic', NULL, NULL, NULL, NULL, NULL, 4),
(228329, NULL, 'G3DSA:3.40.50.720:FF:001155', NULL, NULL, 'Shikimate 5-dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228330, NULL, 'G3DSA:3.10.180.10:FF:000018', NULL, NULL, '4-hydroxyphenylpyruvate dioxygenase', NULL, NULL, NULL, NULL, NULL, 4),
(228331, NULL, 'G3DSA:3.10.120.10:FF:000015', NULL, NULL, 'Cytochrome b5, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228332, NULL, 'G3DSA:3.20.20.70:FF:000752', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228333, NULL, 'G3DSA:1.20.140.40:FF:000036', NULL, NULL, 'Pectinesterase', NULL, NULL, NULL, NULL, NULL, 4),
(228334, NULL, 'G3DSA:1.50.40.10:FF:000525', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(228335, NULL, 'G3DSA:3.10.50.40:FF:000094', NULL, NULL, 'Peptidylprolyl isomerase', NULL, NULL, NULL, NULL, NULL, 4),
(228336, NULL, 'G3DSA:2.130.10.10:FF:000450', NULL, NULL, 'Peptidylprolyl isomerase domain and WD-repeat protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(228337, NULL, 'G3DSA:1.20.1070.10:FF:002111', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(228338, NULL, 'G3DSA:2.60.40.10:FF:004288', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228339, NULL, 'G3DSA:3.40.50.150:FF:000337', NULL, NULL, 'Putative methyltransferase-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(228340, NULL, 'G3DSA:3.30.300.130:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228341, NULL, 'G3DSA:2.70.150.10:FF:000114', NULL, NULL, 'Phospholipid-transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(228342, NULL, 'G3DSA:1.25.40.10:FF:002258', NULL, NULL, 'Os04g0450200 protein', NULL, NULL, NULL, NULL, NULL, 4),
(228343, NULL, 'G3DSA:1.10.530.10:FF:000037', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(228344, NULL, 'G3DSA:3.40.350.10:FF:000031', NULL, NULL, 'Xaa-pro aminopeptidase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228345, NULL, 'G3DSA:2.10.70.10:FF:000291', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228346, NULL, 'G3DSA:3.90.79.10:FF:000304', NULL, NULL, 'Decapping enzyme complex catalytic component', NULL, NULL, NULL, NULL, NULL, 4),
(228347, NULL, 'G3DSA:3.40.1090.10:FF:000100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228348, NULL, 'G3DSA:1.25.10.10:FF:000632', NULL, NULL, 'Pumilio domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(228349, NULL, 'G3DSA:2.40.160.120:FF:000038', NULL, NULL, 'Sterol homeostasis modulator, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228350, NULL, 'G3DSA:3.30.70.330:FF:000083', NULL, NULL, 'Putative ecto-NOX disulfide-thiol exchanger 1', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(228351, NULL, 'G3DSA:1.10.8.960:FF:000009', NULL, NULL, 'Glutamate-cysteine ligase', NULL, NULL, NULL, NULL, NULL, 4),
(228352, NULL, 'G3DSA:3.30.160.60:FF:005598', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228353, NULL, 'G3DSA:3.30.160.60:FF:004075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228354, NULL, 'G3DSA:3.30.70.330:FF:002224', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228355, NULL, 'G3DSA:3.40.50.1000:FF:000439', NULL, NULL, 'Heavy metal translocating P-type ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(228356, NULL, 'G3DSA:3.90.190.20:FF:000015', NULL, NULL, 'Dihydrofolate synthase/folylpolyglutamate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(228357, NULL, 'G3DSA:3.30.420.40:FF:000413', NULL, NULL, 'RNA polymerase II transcription factor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228358, NULL, 'G3DSA:3.60.21.10:FF:000049', NULL, NULL, 'Serine/threonine-protein phosphatase with EF-hands', NULL, NULL, NULL, NULL, NULL, 4),
(228359, NULL, 'G3DSA:3.30.450.40:FF:000128', NULL, NULL, 'Helix-turn-helix transcriptional regulator, IclR family', NULL, NULL, NULL, NULL, NULL, 4),
(228360, NULL, 'G3DSA:1.20.1050.10:FF:000311', NULL, NULL, 'Putative glutathione S-transferase/histidinol dehydrogenase bifunctional related protein', NULL, NULL, NULL, NULL, NULL, 4),
(228361, NULL, 'G3DSA:3.30.160.60:FF:003799', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228362, NULL, 'G3DSA:2.60.40.1910:FF:000034', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228363, NULL, 'G3DSA:2.30.39.10:FF:000099', NULL, NULL, 'Serin peptidase inhibitor, clade A (Alpha-1 antiproteinase, antitrypsin)-like', NULL, NULL, NULL, NULL, NULL, 4),
(228364, NULL, 'G3DSA:2.80.10.50:FF:000239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228365, NULL, 'G3DSA:3.30.40.10:FF:002011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228366, NULL, 'G3DSA:3.40.50.11660:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228367, NULL, 'G3DSA:3.40.50.10810:FF:000245', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(228368, NULL, 'G3DSA:2.60.40.60:FF:000138', NULL, NULL, 'FAT atypical cadherin 4', NULL, NULL, NULL, NULL, NULL, 4),
(228369, NULL, 'G3DSA:2.60.120.560:FF:000039', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(228370, NULL, 'G3DSA:3.30.420.40:FF:000391', NULL, NULL, 'XylR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(228371, NULL, 'G3DSA:1.10.30.10:FF:000009', NULL, NULL, 'Histone-lysine N-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(228372, NULL, 'G3DSA:1.10.510.10:FF:002609', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228373, NULL, 'G3DSA:2.60.40.790:FF:000116', NULL, NULL, 'Sodium-and lithium-tolerant 1', NULL, NULL, NULL, NULL, NULL, 4),
(228374, NULL, 'G3DSA:2.40.10.120:FF:000004', NULL, NULL, 'Serine protease HTRA2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(228375, NULL, 'G3DSA:1.10.357.10:FF:000055', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(228376, NULL, 'G3DSA:3.10.290.10:FF:000027', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(228377, NULL, 'G3DSA:2.60.40.10:FF:002158', NULL, NULL, 'Myotactin form B', NULL, NULL, NULL, NULL, NULL, 4),
(228378, NULL, 'G3DSA:1.20.1510.10:FF:000010', NULL, NULL, 'Putative zinc transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(228379, NULL, 'G3DSA:2.60.40.150:FF:000621', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228380, NULL, 'G3DSA:2.40.160.110:FF:000035', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228381, NULL, 'G3DSA:4.10.60.10:FF:000212', NULL, NULL, 'Nucleic acid binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(228382, NULL, 'G3DSA:2.40.50.140:FF:000074', NULL, NULL, 'DNA repair protein RecO', NULL, NULL, NULL, NULL, NULL, 4),
(228383, NULL, 'G3DSA:1.10.510.10:FF:000137', NULL, NULL, 'Aurora kinase A', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(228384, NULL, 'G3DSA:3.40.50.880:FF:000090', NULL, NULL, 'Glutamine amidotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(228385, NULL, 'G3DSA:3.30.530.20:FF:000168', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228386, NULL, 'G3DSA:1.10.10.1050:FF:000018', NULL, NULL, 'Hydrolase, NUDIX family protein', NULL, NULL, NULL, NULL, NULL, 4),
(228387, NULL, 'G3DSA:2.30.30.40:FF:000217', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(228388, NULL, 'G3DSA:1.20.1310.10:FF:000124', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228389, NULL, 'G3DSA:1.20.1270.60:FF:000298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228390, NULL, 'G3DSA:3.30.160.60:FF:000584', NULL, NULL, 'Zinc finger protein 513', NULL, NULL, NULL, NULL, NULL, 4),
(228391, NULL, 'G3DSA:2.130.10.10:FF:002248', NULL, NULL, 'Bardet-Biedl syndrome 1', NULL, NULL, NULL, NULL, NULL, 4),
(228392, NULL, 'G3DSA:3.30.160.60:FF:001202', NULL, NULL, 'zinc finger protein 629 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(228393, NULL, 'G3DSA:4.10.320.10:FF:000015', NULL, NULL, 'Dihydrolipoamide acetyltransferase component of pyruvate dehydrogenase complex', NULL, NULL, NULL, NULL, NULL, 4),
(228394, NULL, 'G3DSA:1.25.40.10:FF:002051', NULL, NULL, 'E3 ubiquitin-protein ligase CHIP', NULL, NULL, NULL, NULL, NULL, 4),
(228395, NULL, 'G3DSA:3.30.1230.20:FF:000015', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228396, NULL, 'G3DSA:3.40.140.10:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228397, NULL, 'G3DSA:2.60.40.1170:FF:000082', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228398, NULL, 'G3DSA:3.90.480.20:FF:000010', NULL, NULL, 'Sulfite reductase, assimilatory-type', NULL, NULL, NULL, NULL, NULL, 4),
(228399, NULL, 'G3DSA:3.40.50.2020:FF:000083', NULL, NULL, 'Ribose-phosphate pyrophosphokinase', NULL, NULL, NULL, NULL, NULL, 4),
(228400, NULL, 'G3DSA:2.60.40.820:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228401, NULL, 'G3DSA:1.10.287.160:FF:000027', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228402, NULL, 'G3DSA:2.10.25.10:FF:000888', NULL, NULL, 'Crumbs', NULL, NULL, NULL, NULL, NULL, 4),
(228403, NULL, 'G3DSA:3.40.50.880:FF:000202', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228404, NULL, 'G3DSA:3.30.1520.10:FF:000113', NULL, NULL, 'Rho GTPase-activating protein (RhoGAP), putative', NULL, NULL, NULL, NULL, NULL, 4),
(228405, NULL, 'G3DSA:2.60.40.150:FF:000048', NULL, NULL, 'U5 small nuclear ribonucleoprotein 200 kDa helicase', NULL, NULL, NULL, NULL, NULL, 4),
(228406, NULL, 'G3DSA:2.60.40.10:FF:004081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228407, NULL, 'G3DSA:3.40.50.10260:FF:000041', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228408, NULL, 'G3DSA:3.40.50.300:FF:000747', NULL, NULL, 'DNA helicase INO80 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(228409, NULL, 'G3DSA:1.10.10.2590:FF:000002', NULL, NULL, 'Putative nucleus accumbens-associated protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(228410, NULL, 'G3DSA:1.25.40.20:FF:000805', NULL, NULL, 'Os07g0632800 protein', NULL, NULL, NULL, NULL, NULL, 4),
(228411, NULL, 'G3DSA:3.40.50.720:FF:000070', NULL, NULL, 'probable bifunctional methylenetetrahydrofolate dehydrogenase/cyclohydrolase 2', NULL, NULL, NULL, NULL, NULL, 4),
(228412, NULL, 'G3DSA:1.10.287.370:FF:000096', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228413, NULL, 'G3DSA:2.10.25.10:FF:001164', NULL, NULL, 'Laminin, alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(228414, NULL, 'G3DSA:1.25.40.10:FF:001775', NULL, NULL, 'Pentatricopeptide repeat-containing protein At3g26540', NULL, NULL, NULL, NULL, NULL, 4),
(228415, NULL, 'G3DSA:1.25.40.20:FF:000682', NULL, NULL, 'Short transient receptor potential channel', NULL, NULL, NULL, NULL, NULL, 4),
(228416, NULL, 'G3DSA:2.40.10.10:FF:000151', NULL, NULL, 'Corin, isoform B', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(228417, NULL, 'G3DSA:3.40.50.300:FF:008611', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228418, NULL, 'G3DSA:3.90.226.10:FF:000074', NULL, NULL, 'Enoyl-CoA hydratase (AFU_orthologue AFUA_2G10650)', NULL, NULL, NULL, NULL, NULL, 4),
(228419, NULL, 'G3DSA:3.80.10.10:FF:003726', NULL, NULL, 'Os11g0569100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(228420, NULL, 'G3DSA:3.30.1360.70:FF:000017', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228421, NULL, 'G3DSA:3.10.20.90:FF:000820', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228422, NULL, 'G3DSA:1.10.510.10:FF:004077', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228423, NULL, 'G3DSA:1.25.40.10:FF:000802', NULL, NULL, 'Tetratricopeptide repeat (TPR)-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(228424, NULL, 'G3DSA:1.10.287.110:FF:000158', NULL, NULL, 'dnaJ homolog subfamily C member 8', NULL, NULL, NULL, NULL, NULL, 4),
(228425, NULL, 'G3DSA:1.10.10.10:FF:000339', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(228426, NULL, 'G3DSA:3.40.50.11270:FF:000001', NULL, NULL, '4-hydroxy-3-methylbut-2-enyl diphosphate reductase', NULL, NULL, NULL, NULL, NULL, 4),
(228427, NULL, 'G3DSA:3.10.610.10:FF:000002', NULL, NULL, 'General secretion pathway protein J', NULL, NULL, NULL, NULL, NULL, 4),
(228428, NULL, 'G3DSA:2.30.18.10:FF:000011', NULL, NULL, 'Transcription initiation factor IIA subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(228429, NULL, 'G3DSA:1.10.418.10:FF:000214', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(228430, NULL, 'G3DSA:3.30.230.70:FF:000020', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase 2 mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(228431, NULL, 'G3DSA:2.60.40.10:FF:002490', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228432, NULL, 'G3DSA:3.40.50.1820:FF:000230', NULL, NULL, 'Cephalosporin-C deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(228433, NULL, 'G3DSA:3.30.160.60:FF:000926', NULL, NULL, 'Kruppel like factor 13', NULL, NULL, NULL, NULL, NULL, 4),
(228434, NULL, 'G3DSA:3.30.200.20:FF:000413', NULL, NULL, 'Serine/threonine-protein kinase NEK', NULL, NULL, NULL, NULL, NULL, 4),
(228435, NULL, 'G3DSA:2.60.40.1180:FF:000085', NULL, NULL, '1,4-alpha-glucan branching enzyme GlgB', NULL, NULL, NULL, NULL, NULL, 4),
(228436, NULL, 'G3DSA:3.40.50.300:FF:002428', NULL, NULL, 'Sigma-54-dependent Fis family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(228437, NULL, 'G3DSA:3.40.50.300:FF:001023', NULL, NULL, 'Werner syndrome RecQ like helicase', NULL, NULL, NULL, NULL, NULL, 4),
(228438, NULL, 'G3DSA:3.10.300.10:FF:000001', NULL, NULL, 'Putative 3-methyladenine DNA glycosylase', NULL, NULL, NULL, NULL, NULL, 4),
(228439, NULL, 'G3DSA:1.10.390.10:FF:000048', NULL, NULL, 'Peptidase', NULL, NULL, NULL, NULL, NULL, 4),
(228440, NULL, 'G3DSA:2.130.10.10:FF:004732', NULL, NULL, 'UDP-galactose:fucoside alpha-3-galactosyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(228441, NULL, 'G3DSA:3.90.1600.10:FF:000027', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(228442, NULL, 'G3DSA:3.30.160.60:FF:002484', NULL, NULL, 'Protein CBR-LSY-2', NULL, NULL, NULL, NULL, NULL, 4),
(228443, NULL, 'G3DSA:4.10.1130.20:FF:000006', NULL, NULL, 'Os02g0535400 protein', NULL, NULL, NULL, NULL, NULL, 4),
(228444, NULL, 'G3DSA:1.10.1420.10:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228445, NULL, 'G3DSA:3.30.300.10:FF:000036', NULL, NULL, 'S-adenosylmethionine synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(228446, NULL, 'G3DSA:1.20.58.70:FF:000129', NULL, NULL, 'Syntaxin 1A (brain)', NULL, NULL, NULL, NULL, NULL, 4),
(228447, NULL, 'G3DSA:1.20.1250.20:FF:002100', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228448, NULL, 'G3DSA:3.40.800.10:FF:000010', NULL, NULL, 'Formimidoylglutamase', NULL, NULL, NULL, NULL, NULL, 4),
(228449, NULL, 'G3DSA:1.25.10.10:FF:002762', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(228450, NULL, 'G3DSA:3.90.420.10:FF:000008', NULL, NULL, 'Nitrate reductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228451, NULL, 'G3DSA:1.20.5.190:FF:000153', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228452, NULL, 'G3DSA:3.90.79.10:FF:000192', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(228453, NULL, 'G3DSA:3.40.800.20:FF:000013', NULL, NULL, 'Histone deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(228454, NULL, 'G3DSA:1.20.1250.20:FF:001824', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228455, NULL, 'G3DSA:3.40.50.300:FF:000528', NULL, NULL, 'ABC transporter G family member 31', NULL, NULL, NULL, NULL, NULL, 4),
(228456, NULL, 'G3DSA:2.60.120.10:FF:000766', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228457, NULL, 'G3DSA:3.40.50.300:FF:008509', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228458, NULL, 'G3DSA:3.10.450.50:FF:000107', NULL, NULL, 'SOUL heme-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(228459, NULL, 'G3DSA:3.90.1150.10:FF:000402', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(228460, NULL, 'G3DSA:3.40.640.10:FF:000132', NULL, NULL, 'Serine C-palmitoyltransferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228461, NULL, 'G3DSA:3.30.200.20:FF:002004', NULL, NULL, 'CMGC family protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(228462, NULL, 'G3DSA:2.70.98.10:FF:000121', NULL, NULL, 'Aldose 1-epimerase family protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228463, NULL, 'G3DSA:1.10.3720.10:FF:000124', NULL, NULL, 'ABC transporter permease subunit', NULL, NULL, NULL, NULL, NULL, 4),
(228464, NULL, 'G3DSA:2.120.10.30:FF:000293', NULL, NULL, 'peptidyl-glycine alpha-amidating monooxygenase A', NULL, NULL, NULL, NULL, NULL, 4),
(228465, NULL, 'G3DSA:3.80.10.10:FF:003384', NULL, NULL, 'RE59904p', NULL, NULL, NULL, NULL, NULL, 4),
(228466, NULL, 'G3DSA:3.30.420.40:FF:000059', NULL, NULL, 'N-acetylglucosamine operon transcriptional repressor', NULL, NULL, NULL, NULL, NULL, 4),
(228467, NULL, 'G3DSA:3.80.10.10:FF:002102', NULL, NULL, 'Serine/threonine kinase 11 interacting protein', NULL, NULL, NULL, NULL, NULL, 4),
(228468, NULL, 'G3DSA:1.10.3380.30:FF:000030', NULL, NULL, 'ATP-dependent DNA helicase Hel308', NULL, NULL, NULL, NULL, NULL, 4),
(228469, NULL, 'G3DSA:3.40.30.110:FF:000001', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228470, NULL, 'G3DSA:3.30.200.20:FF:001728', NULL, NULL, 'Serine/threonine protein kinase TbPK6', NULL, NULL, NULL, NULL, NULL, 4),
(228471, NULL, 'G3DSA:3.30.1010.10:FF:000030', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(228472, NULL, 'G3DSA:1.25.40.20:FF:000463', NULL, NULL, 'ankyrin repeat domain-containing protein 17 isoform X7', NULL, NULL, NULL, NULL, NULL, 4),
(228473, NULL, 'G3DSA:1.10.510.10:FF:002486', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(228474, NULL, 'G3DSA:2.130.10.130:FF:000058', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228475, NULL, 'G3DSA:3.10.129.10:FF:000102', NULL, NULL, 'Acyl-ACP thioesterase', NULL, NULL, NULL, NULL, NULL, 4),
(228476, NULL, 'G3DSA:3.50.50.100:FF:000056', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228477, NULL, 'G3DSA:1.10.10.60:FF:000118', NULL, NULL, 'WUSCHEL-related homeobox 11', NULL, NULL, NULL, NULL, NULL, 4),
(228478, NULL, 'G3DSA:3.80.10.10:FF:001826', NULL, NULL, 'F-box/LRR-repeat protein 6 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(228479, NULL, 'G3DSA:2.40.70.10:FF:000025', NULL, NULL, 'Aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(228480, NULL, 'G3DSA:3.40.30.120:FF:000004', NULL, NULL, 'Aklavinone 12-hydroxylase DnrF', NULL, NULL, NULL, NULL, NULL, 4),
(228481, NULL, 'G3DSA:1.20.120.980:FF:000057', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(228482, NULL, 'G3DSA:3.30.70.580:FF:000028', NULL, NULL, 'tRNA pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(228483, NULL, 'G3DSA:3.90.280.10:FF:000019', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228484, NULL, 'G3DSA:1.20.1270.280:FF:000034', NULL, NULL, 'Dynein heavy chain, cytosolic, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228485, NULL, 'G3DSA:2.170.150.20:FF:000008', NULL, NULL, 'methionine-R-sulfoxide reductase B1', NULL, NULL, NULL, NULL, NULL, 4),
(228486, NULL, 'G3DSA:3.30.70.330:FF:001729', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228487, NULL, 'G3DSA:1.10.472.10:FF:000710', NULL, NULL, 'Apolipoprotein B-100', NULL, NULL, NULL, NULL, NULL, 4),
(228488, NULL, 'G3DSA:1.25.40.10:FF:000460', NULL, NULL, 'Pentatricopeptide repeat-containing protein mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(228489, NULL, 'G3DSA:3.40.630.30:FF:000519', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228490, NULL, 'G3DSA:3.40.50.300:FF:006357', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228491, NULL, 'G3DSA:2.120.10.80:FF:000072', NULL, NULL, 'Attractin', NULL, NULL, NULL, NULL, NULL, 4),
(228492, NULL, 'G3DSA:1.10.510.10:FF:000811', NULL, NULL, 'Cyclin-dependent kinase WEE1', NULL, NULL, NULL, NULL, NULL, 4),
(228493, NULL, 'G3DSA:1.10.1070.11:FF:000035', NULL, NULL, 'Phosphatidylinositol kinase (PIK-D)', NULL, NULL, NULL, NULL, NULL, 4),
(228494, NULL, 'G3DSA:3.10.100.10:FF:000345', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228495, NULL, 'G3DSA:1.20.1070.10:FF:001605', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228496, NULL, 'G3DSA:3.40.390.10:FF:000022', NULL, NULL, 'Matrix metalloproteinase 1, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(228497, NULL, 'G3DSA:3.40.1160.10:FF:000095', NULL, NULL, 'Aspartokinase 1 chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(228498, NULL, 'G3DSA:1.10.730.10:FF:000232', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228499, NULL, 'G3DSA:1.10.8.60:FF:000589', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228500, NULL, 'G3DSA:3.10.20.90:FF:000819', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228501, NULL, 'G3DSA:3.30.1120.90:FF:000005', NULL, NULL, 'Nucleosome assembly protein11', NULL, NULL, NULL, NULL, NULL, 4),
(228502, NULL, 'G3DSA:3.90.470.20:FF:000054', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228503, NULL, 'G3DSA:3.30.160.60:FF:006435', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228504, NULL, 'G3DSA:1.20.5.340:FF:000131', NULL, NULL, 'Viral A-type inclusion protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228505, NULL, 'G3DSA:3.80.10.10:FF:001153', NULL, NULL, 'Probable LRR receptor-like serine/threonine-protein kinase At4g36180', NULL, NULL, NULL, NULL, NULL, 4),
(228506, NULL, 'G3DSA:1.25.40.10:FF:000353', NULL, NULL, 'Pentatricopeptide repeat-containing protein At4g39530', NULL, NULL, NULL, NULL, NULL, 4),
(228507, NULL, 'G3DSA:1.10.246.120:FF:000001', NULL, NULL, 'GTPase-activating protein and VPS9 domain-containing protein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(228508, NULL, 'G3DSA:3.90.470.10:FF:000051', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228509, NULL, 'G3DSA:3.30.1120.10:FF:000038', NULL, NULL, 'Arylsulfatase', NULL, NULL, NULL, NULL, NULL, 4),
(228510, NULL, 'G3DSA:3.90.550.50:FF:000209', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228511, NULL, 'G3DSA:1.20.1250.20:FF:002201', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228512, NULL, 'G3DSA:3.30.40.10:FF:002016', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228513, NULL, 'G3DSA:1.25.40.10:FF:002500', NULL, NULL, 'Pentatricopeptide repeat-containing protein OTP51, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(228514, NULL, 'G3DSA:3.40.640.10:FF:000351', NULL, NULL, 'Putative low-specificity L-threonine aldolase 1', NULL, NULL, NULL, NULL, NULL, 4),
(228515, NULL, 'G3DSA:3.40.50.1000:FF:000664', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(228516, NULL, 'G3DSA:3.30.160.40:FF:000022', NULL, NULL, 'Probable porphobilinogen deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(228517, NULL, 'G3DSA:3.40.50.300:FF:007886', NULL, NULL, 'ATP-dependent DNA helicase', NULL, NULL, NULL, NULL, NULL, 4),
(228518, NULL, 'G3DSA:1.20.870.10:FF:000015', NULL, NULL, 'Rap guanine nucleotide exchange factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(228519, NULL, 'G3DSA:1.10.3430.10:FF:000023', NULL, NULL, 'Ammonium transporter', NULL, NULL, NULL, NULL, NULL, 4),
(228520, NULL, 'G3DSA:1.25.40.10:FF:001876', NULL, NULL, 'Putative TPR repeat family protein', NULL, NULL, NULL, NULL, NULL, 4),
(228521, NULL, 'G3DSA:3.30.70.3490:FF:000003', NULL, NULL, 'Oxysterol-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(228522, NULL, 'G3DSA:3.30.420.40:FF:000851', NULL, NULL, 'Glucokinase (ROK family protein), conjectural', NULL, NULL, NULL, NULL, NULL, 4),
(228523, NULL, 'G3DSA:3.90.1150.10:FF:000054', NULL, NULL, 'Aminotransferase, class I', NULL, NULL, NULL, NULL, NULL, 4),
(228524, NULL, 'G3DSA:3.40.50.300:FF:000961', NULL, NULL, 'Ras-related protein Rab-8B', NULL, NULL, NULL, NULL, NULL, 4),
(228525, NULL, 'G3DSA:3.30.930.10:FF:000387', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228526, NULL, 'G3DSA:1.25.40.10:FF:004624', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228527, NULL, 'G3DSA:2.60.40.10:FF:000477', NULL, NULL, 'DS cell adhesion molecule like 1', NULL, NULL, NULL, NULL, NULL, 4),
(228528, NULL, 'G3DSA:1.25.10.10:FF:000418', NULL, NULL, 'U-box domain-containing protein 4', NULL, NULL, NULL, NULL, NULL, 4),
(228529, NULL, 'G3DSA:3.40.30.10:FF:000088', NULL, NULL, 'Elongation factor 1-gamma', NULL, NULL, NULL, NULL, NULL, 4),
(228530, NULL, 'G3DSA:1.20.890.10:FF:000022', NULL, NULL, 'cAMP-dependent protein kinase regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(228531, NULL, 'G3DSA:2.170.190.11:FF:000009', NULL, NULL, 'Molybdopterin molybdenumtransferase', NULL, NULL, NULL, NULL, NULL, 4),
(228532, NULL, 'G3DSA:3.50.50.60:FF:001278', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228533, NULL, 'G3DSA:3.40.50.300:FF:008510', NULL, NULL, 'AAA ATPase, cell division control protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228534, NULL, 'G3DSA:2.40.10.10:FF:000471', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228535, NULL, 'G3DSA:1.10.510.10:FF:004178', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228536, NULL, 'G3DSA:1.10.418.10:FF:000091', NULL, NULL, 'Filamin B', NULL, NULL, NULL, NULL, NULL, 4),
(228537, NULL, 'G3DSA:3.30.160.60:FF:002164', NULL, NULL, 'Zinc finger protein chinmo', NULL, NULL, NULL, NULL, NULL, 4),
(228538, NULL, 'G3DSA:3.40.50.300:FF:000854', NULL, NULL, 'Multidrug ABC transporter ATP-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(228539, NULL, 'G3DSA:3.40.50.2300:FF:001476', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228540, NULL, 'G3DSA:1.25.40.20:FF:001879', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228541, NULL, 'G3DSA:2.130.10.10:FF:000562', NULL, NULL, 'DNA damage-binding protein CMR1', NULL, NULL, NULL, NULL, NULL, 4),
(228542, NULL, 'G3DSA:3.40.980.10:FF:000051', NULL, NULL, 'FAD synthase-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(228543, NULL, 'G3DSA:3.40.1550.20:FF:000009', NULL, NULL, 'Transcriptional regulator MraZ', NULL, NULL, NULL, NULL, NULL, 4),
(228544, NULL, 'G3DSA:3.30.70.580:FF:000040', NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(228545, NULL, 'G3DSA:2.130.10.10:FF:000455', NULL, NULL, 'Autophagy-related protein 18f', NULL, NULL, NULL, NULL, NULL, 4),
(228546, NULL, 'G3DSA:2.10.90.10:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228547, NULL, 'G3DSA:3.90.980.20:FF:000031', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228548, NULL, 'G3DSA:3.40.50.720:FF:001716', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228549, NULL, 'G3DSA:3.30.497.10:FF:000047', NULL, NULL, 'Serpin H1', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(228550, NULL, 'G3DSA:3.90.1030.20:FF:000003', NULL, NULL, 'DNA polymerase delta 3, accessory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(228551, NULL, 'G3DSA:1.25.10.10:FF:003398', NULL, NULL, 'Unc-45 homolog B (C. elegans) (Predicted)', NULL, NULL, NULL, NULL, NULL, 4),
(228552, NULL, 'G3DSA:3.30.70.870:FF:000020', NULL, NULL, 'Putative elongation factor', NULL, NULL, NULL, NULL, NULL, 4),
(228553, NULL, 'G3DSA:3.40.50.300:FF:007779', NULL, NULL, 'HL01868p', NULL, NULL, NULL, NULL, NULL, 4),
(228554, NULL, 'G3DSA:1.10.1450.10:FF:000125', NULL, NULL, 'Creatine kinase, M-type', NULL, NULL, NULL, NULL, NULL, 4),
(228555, NULL, 'G3DSA:3.30.60.290:FF:000001', NULL, NULL, 'DNA repair protein Rad4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228556, NULL, 'G3DSA:2.60.40.60:FF:000352', NULL, NULL, 'CAlSYntenin/Alcadein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(228557, NULL, 'G3DSA:1.10.730.10:FF:000125', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(228558, NULL, 'G3DSA:2.60.120.620:FF:000086', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228559, NULL, 'G3DSA:3.30.200.20:FF:000312', NULL, NULL, 'striated muscle preferentially expressed protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(228560, NULL, 'G3DSA:3.30.750.24:FF:000032', NULL, NULL, 'Anti-sigma factor antagonist', NULL, NULL, NULL, NULL, NULL, 4),
(228561, NULL, 'G3DSA:1.20.5.340:FF:000024', NULL, NULL, 'Forkhead box P3, isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(228562, NULL, 'G3DSA:3.40.50.150:FF:000657', NULL, NULL, 'rRNA adenine N(6)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(228563, NULL, 'G3DSA:2.70.170.10:FF:000093', NULL, NULL, 'cDNA FLJ56966, highly similar to Gamma-aminobutyric-acid receptor alpha-5 subunit', NULL, NULL, NULL, NULL, NULL, 4),
(228564, NULL, 'G3DSA:3.40.720.10:FF:000296', NULL, NULL, 'Putative phosphoethanolamine transferase HI_1064', NULL, NULL, NULL, NULL, NULL, 4),
(228565, NULL, 'G3DSA:3.40.50.300:FF:006363', NULL, NULL, 'Muscle-specific beta 1 integrin-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(228566, NULL, 'G3DSA:3.30.160.60:FF:002271', NULL, NULL, 'Zinc finger and BTB domain-containing 47b', NULL, NULL, NULL, NULL, NULL, 4),
(228567, NULL, 'G3DSA:6.10.140.2150:FF:000006', NULL, NULL, 'Sphingosine-1-phosphate lyase', NULL, NULL, NULL, NULL, NULL, 4),
(228568, NULL, 'G3DSA:3.30.70.330:FF:001286', NULL, NULL, 'U2 snRNP auxiliary factor large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(228569, NULL, 'G3DSA:3.30.56.30:FF:000007', NULL, NULL, 'Signal recognition particle 19 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(228570, NULL, 'G3DSA:2.40.170.20:FF:000029', NULL, NULL, 'SusC/RagA family TonB-linked outer membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(228571, NULL, 'G3DSA:3.30.40.10:FF:001415', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(228572, NULL, 'G3DSA:3.40.1110.10:FF:000479', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228573, NULL, 'G3DSA:3.30.160.60:FF:004395', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228574, NULL, 'G3DSA:2.130.10.10:FF:001978', NULL, NULL, 'BING4CT domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(228575, NULL, 'G3DSA:4.10.60.10:FF:000105', NULL, NULL, 'Os05g0120100 protein', NULL, NULL, NULL, NULL, NULL, 4),
(228576, NULL, 'G3DSA:2.40.10.10:FF:000145', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(228577, NULL, 'G3DSA:3.10.100.10:FF:000126', NULL, NULL, 'Regeneration, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(228578, NULL, 'G3DSA:2.60.40.10:FF:002731', NULL, NULL, 'Receptor-type tyrosine-protein phosphatase beta', NULL, NULL, NULL, NULL, NULL, 4),
(228579, NULL, 'G3DSA:3.40.50.300:FF:006256', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228580, NULL, 'G3DSA:3.30.70.330:FF:001393', NULL, NULL, 'RBD (RNA binding domain) protein', NULL, NULL, NULL, NULL, NULL, 4),
(228581, NULL, 'G3DSA:2.10.25.10:FF:001725', NULL, NULL, 'HGF activator', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(228582, NULL, 'G3DSA:2.40.10.10:FF:000038', NULL, NULL, 'Serine protease', NULL, NULL, NULL, NULL, NULL, 4),
(228583, NULL, 'G3DSA:3.30.160.60:FF:003102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228584, NULL, 'G3DSA:2.30.38.10:FF:000001', NULL, NULL, 'Non-ribosomal peptide synthetase PvdI', NULL, NULL, NULL, NULL, NULL, 4),
(228585, NULL, 'G3DSA:3.40.1550.10:FF:000006', NULL, NULL, 'Flagellar motor switch protein FliM', NULL, NULL, NULL, NULL, NULL, 4),
(228586, NULL, 'G3DSA:1.10.510.10:FF:002840', NULL, NULL, 'Tyrosine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(228587, NULL, 'G3DSA:1.10.510.10:FF:002054', NULL, NULL, 'Protein CBG03830', NULL, NULL, NULL, NULL, NULL, 4),
(228588, NULL, 'G3DSA:3.90.1410.10:FF:000097', NULL, NULL, 'Histone-lysine N-methyltransferase setd3-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(228589, NULL, 'G3DSA:1.10.510.10:FF:000923', NULL, NULL, 'Related to serine/threonine-protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(228590, NULL, 'G3DSA:2.70.170.10:FF:000104', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228591, NULL, 'G3DSA:3.30.160.60:FF:004288', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228592, NULL, 'G3DSA:1.10.533.10:FF:000274', NULL, NULL, 'Si:ch211-112c15.8', NULL, NULL, NULL, NULL, NULL, 4),
(228593, NULL, 'G3DSA:2.60.40.10:FF:000691', NULL, NULL, 'Tenascin R', NULL, NULL, NULL, NULL, NULL, 4),
(228594, NULL, 'G3DSA:1.10.533.10:FF:000167', NULL, NULL, 'Nerve growth factor receptor', NULL, NULL, NULL, NULL, NULL, 4),
(228595, NULL, 'G3DSA:2.60.40.10:FF:004069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228596, NULL, 'G3DSA:3.40.50.300:FF:006582', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(228597, NULL, 'G3DSA:3.40.50.300:FF:006470', NULL, NULL, 'GPN-loop GTPase', NULL, NULL, NULL, NULL, NULL, 4),
(228598, NULL, 'G3DSA:2.70.70.10:FF:000001', NULL, NULL, 'PTS system glucose-specific IIA component', NULL, NULL, NULL, NULL, NULL, 4),
(228599, NULL, 'G3DSA:3.40.50.720:FF:001935', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228600, NULL, 'G3DSA:1.20.1390.10:FF:000016', NULL, NULL, 'U1 snRNP-associated protein usp107', NULL, NULL, NULL, NULL, NULL, 4),
(228601, NULL, 'G3DSA:1.20.5.190:FF:000046', NULL, NULL, 'Abnormal spindle-like microcephaly-associated protein homolog', NULL, NULL, NULL, NULL, NULL, 4),
(228602, NULL, 'G3DSA:1.25.10.10:FF:002661', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228603, NULL, 'G3DSA:1.20.5.780:FF:000021', NULL, NULL, 'FXYD domain-containing ion transport regulator', NULL, NULL, NULL, NULL, NULL, 4),
(228604, NULL, 'G3DSA:1.20.58.70:FF:000023', NULL, NULL, 't-SNARE syntaxin', NULL, NULL, NULL, NULL, NULL, 4),
(228605, NULL, 'G3DSA:1.10.533.10:FF:000055', NULL, NULL, 'Interleukin-1 receptor-associated kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(228606, NULL, 'G3DSA:3.30.40.10:FF:001741', NULL, NULL, 'FHA domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228607, NULL, 'G3DSA:3.90.1150.10:FF:000161', NULL, NULL, 'Threonine aldolase', NULL, NULL, NULL, NULL, NULL, 4),
(228608, NULL, 'G3DSA:3.30.420.40:FF:000172', NULL, NULL, 'Heat shock 70 kDa protein', NULL, NULL, NULL, NULL, NULL, 4),
(228609, NULL, 'G3DSA:2.60.120.10:FF:000659', NULL, NULL, 'AGAP005463-PA', NULL, NULL, NULL, NULL, NULL, 4),
(228610, NULL, 'G3DSA:3.90.190.10:FF:000479', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228611, NULL, 'G3DSA:3.20.20.70:FF:000853', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228612, NULL, 'G3DSA:1.25.40.10:FF:001769', NULL, NULL, 'Pentatricopeptide repeat-containing protein chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(228613, NULL, 'G3DSA:2.130.10.10:FF:000236', NULL, NULL, 'Polyubiquitin binding protein (Doa1/Ufd3)', NULL, NULL, NULL, NULL, NULL, 4),
(228614, NULL, 'G3DSA:3.40.50.300:FF:000635', NULL, NULL, 'Sarcalumenin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228615, NULL, 'G3DSA:3.30.60.30:FF:000219', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(228616, NULL, 'G3DSA:3.30.70.60:FF:000032', NULL, NULL, '30S ribosomal protein S6', NULL, NULL, NULL, NULL, NULL, 4),
(228617, NULL, 'G3DSA:3.10.100.10:FF:000019', NULL, NULL, 'Mannose receptor C type 2', NULL, NULL, NULL, NULL, NULL, 4),
(228618, NULL, 'G3DSA:2.60.120.10:FF:000547', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228619, NULL, 'G3DSA:1.10.375.10:FF:000001', NULL, NULL, 'Gag polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(228620, NULL, 'G3DSA:1.20.58.60:FF:000020', NULL, NULL, 'Spectrin alpha chain, non-erythrocytic 1', NULL, NULL, NULL, NULL, NULL, 4),
(228621, NULL, 'G3DSA:1.10.760.10:FF:000060', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228622, NULL, 'G3DSA:3.40.50.1580:FF:000023', NULL, NULL, 'Purine nucleoside permease', NULL, NULL, NULL, NULL, NULL, 4),
(228623, NULL, 'G3DSA:1.10.510.10:FF:002380', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228624, NULL, 'G3DSA:3.30.420.40:FF:000632', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228625, NULL, 'G3DSA:2.60.40.10:FF:006093', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228626, NULL, 'G3DSA:1.10.357.10:FF:000061', NULL, NULL, 'TetR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(228627, NULL, 'G3DSA:2.130.10.10:FF:002602', NULL, NULL, 'LD16387p', NULL, NULL, NULL, NULL, NULL, 4),
(228628, NULL, 'G3DSA:1.20.5.110:FF:000079', NULL, NULL, 'synaptosomal-associated protein 29', NULL, NULL, NULL, NULL, NULL, 4),
(228629, NULL, 'G3DSA:2.30.29.30:FF:001329', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228630, NULL, 'G3DSA:1.10.400.10:FF:000027', NULL, NULL, 'G protein subunit alpha 11', NULL, NULL, NULL, NULL, NULL, 4),
(228631, NULL, 'G3DSA:1.20.1050.10:FF:000070', NULL, NULL, 'Glutathione S-transferase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228632, NULL, 'G3DSA:1.20.5.620:FF:000001', NULL, NULL, 'ATP synthase subunit b', NULL, NULL, NULL, NULL, NULL, 4),
(228633, NULL, 'G3DSA:1.10.510.10:FF:000693', NULL, NULL, 'Serine/threonine protein kinase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228634, NULL, 'G3DSA:1.10.579.10:FF:000003', NULL, NULL, 'Deoxyribodipyrimidine photo-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(228635, NULL, 'G3DSA:3.30.70.3040:FF:000003', NULL, NULL, 'Cell division protein FtsX', NULL, NULL, NULL, NULL, NULL, 4),
(228636, NULL, 'G3DSA:1.10.10.60:FF:000444', NULL, NULL, 'AraC family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(228637, NULL, 'G3DSA:3.30.497.10:FF:000154', NULL, NULL, 'Serpin, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228638, NULL, 'G3DSA:3.40.120.10:FF:000093', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228639, NULL, 'G3DSA:3.30.360.50:FF:000006', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228640, NULL, 'G3DSA:1.20.1060.10:FF:000025', NULL, NULL, 'DNA polymerase I family protein', NULL, NULL, NULL, NULL, NULL, 4),
(228641, NULL, 'G3DSA:3.30.56.10:FF:000001', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit', NULL, NULL, NULL, NULL, NULL, 4),
(228642, NULL, 'G3DSA:2.60.120.260:FF:000056', NULL, NULL, 'reelin', NULL, NULL, NULL, NULL, NULL, 4),
(228643, NULL, 'G3DSA:1.25.40.10:FF:003916', NULL, NULL, 'Anaphase promoting complex subunit 7, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(228644, NULL, 'G3DSA:2.30.29.30:FF:000132', NULL, NULL, 'pleckstrin homology domain-containing family G member 2', NULL, NULL, NULL, NULL, NULL, 4),
(228645, NULL, 'G3DSA:1.25.10.10:FF:000637', NULL, NULL, 'Telomere repeat binding bouquet formation protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(228646, NULL, 'G3DSA:1.25.40.10:FF:004405', NULL, NULL, 'ABL100Wp', NULL, NULL, NULL, NULL, NULL, 4),
(228647, NULL, 'G3DSA:2.60.40.10:FF:000258', NULL, NULL, 'Dyslexia-associated protein KIAA0319 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(228648, NULL, 'G3DSA:2.170.240.10:FF:000007', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(228649, NULL, 'G3DSA:3.30.1330.30:FF:000077', NULL, NULL, 'ERF1 domain 3 family protein', NULL, NULL, NULL, NULL, NULL, 4);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(228650, NULL, 'G3DSA:3.30.70.80:FF:000038', NULL, NULL, 'Peptidase S8/S53 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(228651, NULL, 'G3DSA:3.30.40.10:FF:000111', NULL, NULL, 'Anaphase-promoting complex subunit 11', NULL, NULL, NULL, NULL, NULL, 4),
(228652, NULL, 'G3DSA:2.60.40.790:FF:000122', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228653, NULL, 'G3DSA:1.10.20.10:FF:000278', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228654, NULL, 'G3DSA:2.10.50.30:FF:000042', NULL, NULL, 'Vomeronasal 2, receptor 59', NULL, NULL, NULL, NULL, NULL, 4),
(228655, NULL, 'G3DSA:1.20.1110.10:FF:000249', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228656, NULL, 'G3DSA:2.30.30.1020:FF:000038', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228657, NULL, 'G3DSA:2.10.25.10:FF:001613', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228658, NULL, 'G3DSA:3.30.160.60:FF:004069', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228659, NULL, 'G3DSA:2.60.40.10:FF:001888', NULL, NULL, 'Twitchin', NULL, NULL, NULL, NULL, NULL, 4),
(228660, NULL, 'G3DSA:2.30.29.30:FF:001217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228661, NULL, 'G3DSA:1.10.10.1780:FF:000001', NULL, NULL, 'Toxin B', NULL, NULL, NULL, NULL, NULL, 4),
(228662, NULL, 'G3DSA:1.10.730.10:FF:000013', NULL, NULL, 'leucine--tRNA ligase, cytoplasmic', NULL, NULL, NULL, NULL, NULL, 4),
(228663, NULL, 'G3DSA:3.30.160.60:FF:002383', NULL, NULL, 'Pebbled, isoform A', NULL, NULL, NULL, NULL, NULL, 4),
(228664, NULL, 'G3DSA:2.40.155.10:FF:000008', NULL, NULL, 'Fluorescent protein Dronpa', NULL, NULL, NULL, NULL, NULL, 4),
(228665, NULL, 'G3DSA:3.40.50.720:FF:001256', NULL, NULL, 'Trifunctional enzyme subunit', NULL, NULL, NULL, NULL, NULL, 4),
(228666, NULL, 'G3DSA:2.180.10.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228667, NULL, 'G3DSA:3.50.50.60:FF:001385', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228668, NULL, 'G3DSA:1.10.10.60:FF:000225', NULL, NULL, 'NK3 homeobox 2', NULL, NULL, NULL, NULL, NULL, 4),
(228669, NULL, 'G3DSA:2.130.10.10:FF:004507', NULL, NULL, 'Chromosome 15, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(228670, NULL, 'G3DSA:3.30.450.40:FF:000229', NULL, NULL, 'GAF domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(228671, NULL, 'G3DSA:1.10.510.10:FF:000704', NULL, NULL, 'Guanylate cyclase', NULL, NULL, NULL, NULL, NULL, 4),
(228672, NULL, 'G3DSA:3.30.830.10:FF:000328', NULL, NULL, 'Presequence protease', NULL, NULL, NULL, NULL, NULL, 4),
(228673, NULL, 'G3DSA:2.130.10.10:FF:001866', NULL, NULL, 'Bromodomain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(228674, NULL, 'G3DSA:1.20.120.1150:FF:000008', NULL, NULL, 'Serine/threonine-protein phosphatase 2A activator', NULL, NULL, NULL, NULL, NULL, 4),
(228675, NULL, 'G3DSA:2.60.40.640:FF:000105', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228676, NULL, 'G3DSA:2.60.40.640:FF:000094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228677, NULL, 'G3DSA:3.30.200.20:FF:001835', NULL, NULL, 'Connectin', NULL, NULL, NULL, NULL, NULL, 4),
(228678, NULL, 'G3DSA:3.40.140.10:FF:000195', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228679, NULL, 'G3DSA:3.10.310.10:FF:000052', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228680, NULL, 'G3DSA:3.40.50.300:FF:004906', NULL, NULL, 'GPN-loop GTPase 3', NULL, NULL, NULL, NULL, NULL, 4),
(228681, NULL, 'G3DSA:2.10.25.10:FF:000989', NULL, NULL, 'Hemolectin, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(228682, NULL, 'G3DSA:1.10.8.720:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228683, NULL, 'G3DSA:3.30.1320.10:FF:000019', NULL, NULL, '30S ribosomal protein S16', NULL, NULL, NULL, NULL, NULL, 4),
(228684, NULL, 'G3DSA:3.80.10.10:FF:003277', NULL, NULL, 'AGAP010669-PA', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(228685, NULL, 'G3DSA:3.60.15.10:FF:000001', NULL, NULL, 'Cleavage and polyadenylation specificity factor', NULL, NULL, NULL, NULL, NULL, 4),
(228686, NULL, 'G3DSA:2.40.10.10:FF:000257', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228687, NULL, 'G3DSA:3.40.50.11530:FF:000006', NULL, NULL, 'interleukin-17 receptor E isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(228688, NULL, 'G3DSA:2.40.330.10:FF:000005', NULL, NULL, 'Transcriptional factor B3 family protein', NULL, NULL, NULL, NULL, NULL, 4),
(228689, NULL, 'G3DSA:3.40.50.1440:FF:000009', NULL, NULL, 'Tubulin beta chain', NULL, NULL, NULL, NULL, NULL, 4),
(228690, NULL, 'G3DSA:1.10.3470.10:FF:000025', NULL, NULL, 'Possible conserved integral membrane protein', NULL, NULL, NULL, NULL, NULL, 4),
(228691, NULL, 'G3DSA:3.90.170.10:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228692, NULL, 'G3DSA:2.60.40.10:FF:002512', NULL, NULL, 'Myotactin form B', NULL, NULL, NULL, NULL, NULL, 4),
(228693, NULL, 'G3DSA:3.40.50.300:FF:006037', NULL, NULL, 'Methylenetetrahydrofolate dehydrogenase (NADP+-dependent) 1a, methenyltetrahydrofolate cyclohydrolase, formyltetrahydrofolate synthetase', NULL, NULL, NULL, NULL, NULL, 4),
(228694, NULL, 'G3DSA:1.25.40.20:FF:000356', NULL, NULL, 'Poly [ADP-ribose] polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(228695, NULL, 'G3DSA:1.25.40.190:FF:000014', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228696, NULL, 'G3DSA:1.10.10.60:FF:000770', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228697, NULL, 'G3DSA:1.10.20.10:FF:000059', NULL, NULL, 'Transcription initiation factor TFIID subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(228698, NULL, 'G3DSA:2.10.25.10:FF:001720', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228699, NULL, 'G3DSA:3.40.30.10:FF:000981', NULL, NULL, 'Glutaredoxin family protein', NULL, NULL, NULL, NULL, NULL, 4),
(228700, NULL, 'G3DSA:3.40.50.150:FF:000438', NULL, NULL, 'Probable thiol methyltransferase 2', NULL, NULL, NULL, NULL, NULL, 4),
(228701, NULL, 'G3DSA:1.10.510.10:FF:004420', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228702, NULL, 'G3DSA:1.10.510.10:FF:003796', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228703, NULL, 'G3DSA:3.90.1750.10:FF:000038', NULL, NULL, 'Ubiquitin-protein ligase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228704, NULL, 'G3DSA:3.90.780.10:FF:000035', NULL, NULL, '2`,3`-cyclic-nucleotide 2`-phosphodiesterase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228705, NULL, 'G3DSA:1.25.40.10:FF:000465', NULL, NULL, 'lysine-specific demethylase 6A isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(228706, NULL, 'G3DSA:3.40.50.1240:FF:000045', NULL, NULL, 'Extracellular phytase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228707, NULL, 'G3DSA:1.20.120.1750:FF:000082', NULL, NULL, 'RBR-type E3 ubiquitin transferase', NULL, NULL, NULL, NULL, NULL, 4),
(228708, NULL, 'G3DSA:2.60.40.790:FF:000015', NULL, NULL, 'dynein assembly factor 4, axonemal isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(228709, NULL, 'G3DSA:3.30.565.10:FF:000105', NULL, NULL, 'Histidine kinase-DNA gyrase B-and HSP90-like ATPase family protein', NULL, NULL, NULL, NULL, NULL, 4),
(228710, NULL, 'G3DSA:2.70.150.10:FF:000221', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(228711, NULL, 'G3DSA:2.170.130.10:FF:000004', NULL, NULL, 'Colicin I TonB-dependent receptor', NULL, NULL, NULL, NULL, NULL, 4),
(228712, NULL, 'G3DSA:1.20.120.1760:FF:000085', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228713, NULL, 'G3DSA:1.25.40.180:FF:000011', NULL, NULL, 'Eukaryotic translation initiation factor 4 gamma 2', NULL, NULL, NULL, NULL, NULL, 4),
(228714, NULL, 'G3DSA:2.60.40.10:FF:006109', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228715, NULL, 'G3DSA:3.90.440.10:FF:000004', NULL, NULL, 'Nitric oxide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(228716, NULL, 'G3DSA:3.40.50.450:FF:000085', NULL, NULL, 'Cytokinin riboside 5''-monophosphate phosphoribohydrolase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(228717, NULL, 'G3DSA:3.20.20.140:FF:000395', NULL, NULL, 'TatD DNase domain-containing 2', NULL, NULL, NULL, NULL, NULL, 4),
(228718, NULL, 'G3DSA:3.40.1090.10:FF:000083', NULL, NULL, 'Lysophospholipase', NULL, NULL, NULL, NULL, NULL, 4),
(228719, NULL, 'G3DSA:3.30.230.130:FF:000060', NULL, NULL, 'Cullin', NULL, NULL, NULL, NULL, NULL, 4),
(228720, NULL, 'G3DSA:1.25.10.10:FF:000306', NULL, NULL, 'Serine/threonine protein phosphatase 2A regulatory subunit', NULL, NULL, NULL, NULL, NULL, 4),
(228721, NULL, 'G3DSA:2.60.120.330:FF:000229', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(228722, NULL, 'G3DSA:2.60.40.10:FF:004743', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228723, NULL, 'G3DSA:2.30.30.40:FF:000661', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228724, NULL, 'G3DSA:3.40.1810.10:FF:000049', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228725, NULL, 'G3DSA:2.30.250.10:FF:000001', NULL, NULL, 'Aspartyl aminopeptidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(228726, NULL, 'G3DSA:3.40.50.300:FF:000742', NULL, NULL, 'NFX1-type zinc finger-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(228727, NULL, 'G3DSA:3.30.40.10:FF:001292', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228728, NULL, 'G3DSA:3.30.160.60:FF:004518', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228729, NULL, 'G3DSA:3.30.160.60:FF:000921', NULL, NULL, 'zinc finger and BTB domain-containing protein 21', NULL, NULL, NULL, NULL, NULL, 4),
(228730, NULL, 'G3DSA:3.20.20.70:FF:000297', NULL, NULL, 'Unplaced genomic scaffold supercont1.57, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(228731, NULL, 'G3DSA:3.90.70.10:FF:000329', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 10', NULL, NULL, NULL, NULL, NULL, 4),
(228732, NULL, 'G3DSA:2.20.200.10:FF:000006', NULL, NULL, 'ABC-type macrolide export system secretin component MacC', NULL, NULL, NULL, NULL, NULL, 4),
(228733, NULL, 'G3DSA:1.25.40.90:FF:000101', NULL, NULL, 'AdaPTin or adaptin-related protein', NULL, NULL, NULL, NULL, NULL, 4),
(228734, NULL, 'G3DSA:3.30.420.110:FF:000035', NULL, NULL, 'MutS family protein', NULL, NULL, NULL, NULL, NULL, 4),
(228735, NULL, 'G3DSA:1.20.1480.30:FF:000001', NULL, NULL, 'Putative kinesin', NULL, NULL, NULL, NULL, NULL, 4),
(228736, NULL, 'G3DSA:3.40.50.300:FF:000068', NULL, NULL, 'Site-determining protein', NULL, NULL, NULL, NULL, NULL, 4),
(228737, NULL, 'G3DSA:2.30.30.40:FF:000554', NULL, NULL, 'Bbc1p', NULL, NULL, NULL, NULL, NULL, 4),
(228738, NULL, 'G3DSA:3.40.525.10:FF:000044', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228739, NULL, 'G3DSA:2.170.130.20:FF:000007', NULL, NULL, 'LCCL domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(228740, NULL, 'G3DSA:3.40.1710.10:FF:000002', NULL, NULL, 'Transport permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(228741, NULL, 'G3DSA:3.40.50.300:FF:008268', NULL, NULL, 'Protein CBG17574', NULL, NULL, NULL, NULL, NULL, 4),
(228742, NULL, 'G3DSA:1.10.1300.10:FF:000013', NULL, NULL, 'Phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(228743, NULL, 'G3DSA:2.40.20.10:FF:000078', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228744, NULL, 'G3DSA:3.80.20.20:FF:000021', NULL, NULL, 'Receptor protein-tyrosine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(228745, NULL, 'G3DSA:2.60.40.60:FF:000571', NULL, NULL, 'Cadherin 5', NULL, NULL, NULL, NULL, NULL, 4),
(228746, NULL, 'G3DSA:4.10.400.10:FF:000308', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228747, NULL, 'G3DSA:1.20.58.1380:FF:000013', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228748, NULL, 'G3DSA:1.20.1280.80:FF:000001', NULL, NULL, 'SepL/TyeA/HrpJ family type III secretion system gatekeeper', NULL, NULL, NULL, NULL, NULL, 4),
(228749, NULL, 'G3DSA:1.20.1250.20:FF:001712', NULL, NULL, 'Os05g0567700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(228750, NULL, 'G3DSA:2.60.40.10:FF:000472', NULL, NULL, 'CD166 antigen isoform X2', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(228751, NULL, 'G3DSA:1.10.10.10:FF:002037', NULL, NULL, 'Probable transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(228752, NULL, 'G3DSA:2.110.10.10:FF:000063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228753, NULL, 'G3DSA:2.60.40.10:FF:000814', NULL, NULL, 'Platelet-derived growth factor receptor beta', NULL, NULL, NULL, NULL, NULL, 4),
(228754, NULL, 'G3DSA:2.60.200.20:FF:000141', NULL, NULL, 'Penicillin-binding protein 1B', NULL, NULL, NULL, NULL, NULL, 4),
(228755, NULL, 'G3DSA:3.40.50.300:FF:000416', NULL, NULL, 'p-loop nucleoside triphosphate hydrolase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(228756, NULL, 'G3DSA:3.30.160.60:FF:000247', NULL, NULL, 'Zinc finger protein 236', NULL, NULL, NULL, NULL, NULL, 4),
(228757, NULL, 'G3DSA:3.30.60.20:FF:000093', NULL, NULL, 'Related to ser/thr protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(228758, NULL, 'G3DSA:3.30.70.3490:FF:000008', NULL, NULL, 'Oxysterol-binding protein-related protein 3C', NULL, NULL, NULL, NULL, NULL, 4),
(228759, NULL, 'G3DSA:2.130.10.10:FF:000781', NULL, NULL, 'Cytoplasmic dynein intermediate chain', NULL, NULL, NULL, NULL, NULL, 4),
(228760, NULL, 'G3DSA:3.90.1100.10:FF:000012', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(228761, NULL, 'G3DSA:1.25.40.20:FF:000575', NULL, NULL, 'Potassium channel AKT1', NULL, NULL, NULL, NULL, NULL, 4),
(228762, NULL, 'G3DSA:3.80.10.10:FF:001372', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228763, NULL, 'G3DSA:1.20.1070.10:FF:001162', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228764, NULL, 'G3DSA:1.10.10.10:FF:000457', NULL, NULL, 'Two component transcriptional regulator NrrA', NULL, NULL, NULL, NULL, NULL, 4),
(228765, NULL, 'G3DSA:1.10.1070.11:FF:000136', NULL, NULL, 'Phosphatidylinositol 4,5-bisphosphate 3-kinase catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(228766, NULL, 'G3DSA:1.25.40.10:FF:003793', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228767, NULL, 'G3DSA:1.20.1070.10:FF:001504', NULL, NULL, 'Protease-activated receptor 3', NULL, NULL, NULL, NULL, NULL, 4),
(228768, NULL, 'G3DSA:3.30.40.10:FF:001960', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228769, NULL, 'G3DSA:1.10.8.60:FF:000584', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228770, NULL, 'G3DSA:3.40.50.1000:FF:000119', NULL, NULL, 'Bifunctional riboflavin kinase/FMN phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(228771, NULL, 'G3DSA:2.40.10.10:FF:000252', NULL, NULL, 'Serine protease H158', NULL, NULL, NULL, NULL, NULL, 4),
(228772, NULL, 'G3DSA:1.25.40.10:FF:000920', NULL, NULL, 'Os03g0369700 protein', NULL, NULL, NULL, NULL, NULL, 4),
(228773, NULL, 'G3DSA:3.40.50.720:FF:001930', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228774, NULL, 'G3DSA:3.30.160.60:FF:002720', NULL, NULL, 'Zinc finger protein 234', NULL, NULL, NULL, NULL, NULL, 4),
(228775, NULL, 'G3DSA:2.120.10.80:FF:000173', NULL, NULL, 'Multiple EGF-like-domains 8', NULL, NULL, NULL, NULL, NULL, 4),
(228776, NULL, 'G3DSA:1.10.472.80:FF:000248', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228777, NULL, 'G3DSA:1.10.150.80:FF:000028', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(228778, NULL, 'G3DSA:3.30.830.10:FF:000109', NULL, NULL, 'nardilysin', NULL, NULL, NULL, NULL, NULL, 4),
(228779, NULL, 'G3DSA:1.10.10.820:FF:000016', NULL, NULL, 'Myosin-A', NULL, NULL, NULL, NULL, NULL, 4),
(228780, NULL, 'G3DSA:1.10.730.10:FF:000018', NULL, NULL, 'Leucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(228781, NULL, 'G3DSA:3.30.540.10:FF:000014', NULL, NULL, 'Fructose-1,6-bisphosphatase, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(228782, NULL, 'G3DSA:2.10.25.10:FF:001046', NULL, NULL, 'Cadherin EGF LAG seven-pass G-type receptor 1a', NULL, NULL, NULL, NULL, NULL, 4),
(228783, NULL, 'G3DSA:3.40.50.2020:FF:000190', NULL, NULL, 'Uridine monophosphate synthetase', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(228784, NULL, 'G3DSA:3.30.70.330:FF:002117', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228785, NULL, 'G3DSA:1.10.287.110:FF:000259', NULL, NULL, 'AT29763p', NULL, NULL, NULL, NULL, NULL, 4),
(228786, NULL, 'G3DSA:1.10.510.10:FF:000816', NULL, NULL, 'Uncharacterized protein, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(228787, NULL, 'G3DSA:3.40.50.300:FF:004339', NULL, NULL, 'ABC transporter ATP-binding protein/permease', NULL, NULL, NULL, NULL, NULL, 4),
(228788, NULL, 'G3DSA:1.25.40.20:FF:000923', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228789, NULL, 'G3DSA:3.30.70.980:FF:000053', NULL, NULL, 'YALI0E16214p', NULL, NULL, NULL, NULL, NULL, 4),
(228790, NULL, 'G3DSA:2.60.40.1110:FF:000002', NULL, NULL, 'tensin-1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(228791, NULL, 'G3DSA:1.25.70.10:FF:000074', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228792, NULL, 'G3DSA:3.40.50.880:FF:000101', NULL, NULL, '4-methyl-5(Beta-hydroxyethyl)-thiazole monophosphate synthesis protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228793, NULL, 'G3DSA:3.30.1520.10:FF:000012', NULL, NULL, 'Sorting nexin 10', NULL, NULL, NULL, NULL, NULL, 4),
(228794, NULL, 'G3DSA:3.30.70.330:FF:003079', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228795, NULL, 'G3DSA:1.25.40.10:FF:000572', NULL, NULL, 'Hsp70/Hsp90 organizing protein', NULL, NULL, NULL, NULL, NULL, 4),
(228796, NULL, 'G3DSA:1.20.140.100:FF:000045', NULL, NULL, 'Dynein heavy chain 9', NULL, NULL, NULL, NULL, NULL, 4),
(228797, NULL, 'G3DSA:3.90.25.70:FF:000001', NULL, NULL, 'Fatty acid synthase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(228798, NULL, 'G3DSA:2.60.40.1120:FF:000005', NULL, NULL, 'Carboxypeptidase D', NULL, NULL, NULL, NULL, NULL, 4),
(228799, NULL, 'G3DSA:3.20.20.70:FF:000639', NULL, NULL, 'Glycolate oxidase', NULL, NULL, NULL, NULL, NULL, 4),
(228800, NULL, 'G3DSA:3.30.60.30:FF:000096', NULL, NULL, 'Protein CBG17314', NULL, NULL, NULL, NULL, NULL, 4),
(228801, NULL, 'G3DSA:1.25.40.20:FF:000468', NULL, NULL, 'Ankyrin repeat and sterile alpha motif domain containing 1A', NULL, NULL, NULL, NULL, NULL, 4),
(228802, NULL, 'G3DSA:1.20.1250.20:FF:001370', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228803, NULL, 'G3DSA:1.20.1390.10:FF:000011', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228804, NULL, 'G3DSA:3.30.160.60:FF:000466', NULL, NULL, 'zinc finger protein 62 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(228805, NULL, 'G3DSA:3.40.50.1000:FF:000338', NULL, NULL, 'Inorganic pyrophosphatase 2', NULL, NULL, NULL, NULL, NULL, 4),
(228806, NULL, 'G3DSA:3.90.1150.10:FF:000503', NULL, NULL, 'Glycine cleavage system P protein', NULL, NULL, NULL, NULL, NULL, 4),
(228807, NULL, 'G3DSA:4.10.365.10:FF:000006', NULL, NULL, 'Dacapo', NULL, NULL, NULL, NULL, NULL, 4),
(228808, NULL, 'G3DSA:3.10.320.10:FF:000002', NULL, NULL, 'HLA class II histocompatibility antigen, DR alpha chain', NULL, NULL, NULL, NULL, NULL, 4),
(228809, NULL, 'G3DSA:2.30.30.40:FF:000335', NULL, NULL, 'Endolysin', NULL, NULL, NULL, NULL, NULL, 4),
(228810, NULL, 'G3DSA:1.10.1780.10:FF:000009', NULL, NULL, 'Chaperone protein ClpB1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228811, NULL, 'G3DSA:3.90.70.10:FF:000548', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228812, NULL, 'G3DSA:1.10.10.60:FF:000332', NULL, NULL, 'Motor neuron and pancreas homeobox 2b', NULL, NULL, NULL, NULL, NULL, 4),
(228813, NULL, 'G3DSA:2.40.170.20:FF:000024', NULL, NULL, 'TonB-dependent siderophore receptor', NULL, NULL, NULL, NULL, NULL, 4),
(228814, NULL, 'G3DSA:1.10.8.960:FF:000010', NULL, NULL, 'AaceriAFR086Cp', NULL, NULL, NULL, NULL, NULL, 4),
(228815, NULL, 'G3DSA:2.60.40.10:FF:002057', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(228816, NULL, 'G3DSA:3.40.950.10:FF:000009', NULL, NULL, 'Nuclear prelamin A recognition factor', NULL, NULL, NULL, NULL, NULL, 4),
(228817, NULL, 'G3DSA:3.40.630.10:FF:000070', NULL, NULL, 'Putative carboxypeptidase suro-1', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(228818, NULL, 'G3DSA:1.20.1250.20:FF:000869', NULL, NULL, 'Pept-2', NULL, NULL, NULL, NULL, NULL, 4),
(228819, NULL, 'G3DSA:3.40.1000.50:FF:000022', NULL, NULL, 'Repressor of RNA polymerase III transcription MAF1', NULL, NULL, NULL, NULL, NULL, 4),
(228820, NULL, 'G3DSA:3.40.50.620:FF:000040', NULL, NULL, 'Tyrosine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(228821, NULL, 'G3DSA:3.90.226.10:FF:000304', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228822, NULL, 'G3DSA:2.30.180.10:FF:000136', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228823, NULL, 'G3DSA:1.10.8.270:FF:000005', NULL, NULL, 'TBC1 domain family member 15', NULL, NULL, NULL, NULL, NULL, 4),
(228824, NULL, 'G3DSA:3.30.200.20:FF:000531', NULL, NULL, 'Calcium/calmodulin-dependent protein kinase type', NULL, NULL, NULL, NULL, NULL, 4),
(228825, NULL, 'G3DSA:1.10.405.10:FF:000016', NULL, NULL, 'Amine oxidase, flavin-containing', NULL, NULL, NULL, NULL, NULL, 4),
(228826, NULL, 'G3DSA:2.30.29.30:FF:001099', NULL, NULL, 'Switch-associated protein 70-like Protein', NULL, NULL, NULL, NULL, NULL, 4),
(228827, NULL, 'G3DSA:3.90.1180.10:FF:000005', NULL, NULL, '39S ribosomal protein L13, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(228828, NULL, 'G3DSA:3.30.200.20:FF:001942', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228829, NULL, 'G3DSA:2.130.10.10:FF:003783', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(228830, NULL, 'G3DSA:3.90.79.10:FF:000203', NULL, NULL, 'Phosphohydrolase (MutT/nudix family protein)', NULL, NULL, NULL, NULL, NULL, 4),
(228831, NULL, 'G3DSA:1.25.40.20:FF:000794', NULL, NULL, 'Ankyrin repeat domain-containing protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(228832, NULL, 'G3DSA:2.60.40.60:FF:000245', NULL, NULL, 'Cadherin related family member 2', NULL, NULL, NULL, NULL, NULL, 4),
(228833, NULL, 'G3DSA:3.40.50.2300:FF:000060', NULL, NULL, 'Protein-glutamate methylesterase/protein-glutamine glutaminase', NULL, NULL, NULL, NULL, NULL, 4),
(228834, NULL, 'G3DSA:2.60.40.10:FF:003687', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228835, NULL, 'G3DSA:2.60.40.10:FF:002950', NULL, NULL, 'AGAP003610-PA', NULL, NULL, NULL, NULL, NULL, 4),
(228836, NULL, 'G3DSA:3.40.50.1820:FF:001091', NULL, NULL, 'Protein CBG23034', NULL, NULL, NULL, NULL, NULL, 4),
(228837, NULL, 'G3DSA:3.40.225.10:FF:000004', NULL, NULL, 'gamma-adducin isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(228838, NULL, 'G3DSA:3.30.810.10:FF:000007', NULL, NULL, 'Phosphatidylinositol 4-phosphate 5-kinase', NULL, NULL, NULL, NULL, NULL, 4),
(228839, NULL, 'G3DSA:1.10.357.110:FF:000012', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228840, NULL, 'G3DSA:1.25.10.10:FF:000744', NULL, NULL, 'HEAT repeat-containing protein 3 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(228841, NULL, 'G3DSA:1.10.1200.260:FF:000001', NULL, NULL, 'Potassium voltage-gated channel subfamily H member 7', NULL, NULL, NULL, NULL, NULL, 4),
(228842, NULL, 'G3DSA:3.40.449.10:FF:000013', NULL, NULL, 'Phosphoenolypyruvate CarboxyKinase', NULL, NULL, NULL, NULL, NULL, 4),
(228843, NULL, 'G3DSA:1.10.238.10:FF:000548', NULL, NULL, 'Calcium-dependent protein kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(228844, NULL, 'G3DSA:3.90.260.10:FF:000018', NULL, NULL, 'XPC complex subunit, DNA damage recognition and repair factor', NULL, NULL, NULL, NULL, NULL, 4),
(228845, NULL, 'G3DSA:1.10.418.10:FF:000102', NULL, NULL, 'Related to CDC24-GTP/GDP exchange factor for Cdc42p', NULL, NULL, NULL, NULL, NULL, 4),
(228846, NULL, 'G3DSA:3.90.1800.10:FF:000020', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, NULL, NULL, NULL, NULL, 4),
(228847, NULL, 'G3DSA:3.40.366.10:FF:000022', NULL, NULL, 'Polyketide biosynthesis protein PksE', NULL, NULL, NULL, NULL, NULL, 4),
(228848, NULL, 'G3DSA:1.10.510.10:FF:000581', NULL, NULL, 'Cysteine-rich receptor-like protein kinase 10', NULL, NULL, NULL, NULL, NULL, 4),
(228849, NULL, 'G3DSA:3.90.550.10:FF:000226', NULL, NULL, 'Glucose-1-phosphate adenylyltransferase (ADP-glucose pyrophosphorylase)', NULL, NULL, NULL, NULL, NULL, 4);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(228850, NULL, 'G3DSA:1.25.40.10:FF:000027', NULL, NULL, 'stress-induced-phosphoprotein 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(228851, NULL, 'G3DSA:3.40.50.2300:FF:000402', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228852, NULL, 'G3DSA:3.40.50.300:FF:008049', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228853, NULL, 'G3DSA:3.40.50.1980:FF:000036', NULL, NULL, 'Probable periplasmic iron-transport lipoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(228854, NULL, 'G3DSA:1.10.510.10:FF:003689', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228855, NULL, 'G3DSA:3.40.50.1970:FF:000033', NULL, NULL, 'Alcohol dehydrogenase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228856, NULL, 'G3DSA:3.50.50.60:FF:000081', NULL, NULL, 'prenylcysteine oxidase 1', NULL, NULL, NULL, NULL, NULL, 4),
(228857, NULL, 'G3DSA:3.30.160.60:FF:004737', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228858, NULL, 'G3DSA:2.70.130.10:FF:000107', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228859, NULL, 'G3DSA:1.10.3900.10:FF:000003', NULL, NULL, 'Cell division protein ZapD', NULL, NULL, NULL, NULL, NULL, 4),
(228860, NULL, 'G3DSA:3.50.30.10:FF:000003', NULL, NULL, 'Phosphoenolpyruvate-protein phosphotransferase ptsP', NULL, NULL, NULL, NULL, NULL, 4),
(228861, NULL, 'G3DSA:3.30.160.60:FF:000814', NULL, NULL, 'Zinc finger and BTB domain-containing protein 26', NULL, NULL, NULL, NULL, NULL, 4),
(228862, NULL, 'G3DSA:3.40.50.10860:FF:000013', NULL, NULL, 'Methylenetetrahydrofolate dehydrogenase (NADP+ dependent) 1 like', NULL, NULL, NULL, NULL, NULL, 4),
(228863, NULL, 'G3DSA:1.25.10.10:FF:000525', NULL, NULL, 'Armadillo repeat-containing protein 5', NULL, NULL, NULL, NULL, NULL, 4),
(228864, NULL, 'G3DSA:1.10.720.30:FF:000069', NULL, NULL, 'SUMO ligase', NULL, NULL, NULL, NULL, NULL, 4),
(228865, NULL, 'G3DSA:3.30.160.60:FF:006430', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228866, NULL, 'G3DSA:3.40.190.10:FF:000041', NULL, NULL, 'Putrescine-binding periplasmic protein', NULL, NULL, NULL, NULL, NULL, 4),
(228867, NULL, 'G3DSA:3.40.50.10330:FF:000085', NULL, NULL, 'NAD kinase', NULL, NULL, NULL, NULL, NULL, 4),
(228868, NULL, 'G3DSA:3.40.50.1000:FF:000557', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228869, NULL, 'G3DSA:1.20.1530.20:FF:000003', NULL, NULL, 'Cation/H(+) antiporter 15', NULL, NULL, NULL, NULL, NULL, 4),
(228870, NULL, 'G3DSA:1.25.40.20:FF:000249', NULL, NULL, 'Cyclin-dependent kinase inhibitor 2A', NULL, NULL, NULL, NULL, NULL, 4),
(228871, NULL, 'G3DSA:2.60.120.310:FF:000004', NULL, NULL, 'DBH-like monooxygenase protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(228872, NULL, 'G3DSA:2.40.10.120:FF:000009', NULL, NULL, 'Complement factor B', NULL, NULL, NULL, NULL, NULL, 4),
(228873, NULL, 'G3DSA:2.60.40.60:FF:000790', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228874, NULL, 'G3DSA:1.10.10.60:FF:000551', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(228875, NULL, 'G3DSA:3.30.60.20:FF:000109', NULL, NULL, 'Signal transducer', NULL, NULL, NULL, NULL, NULL, 4),
(228876, NULL, 'G3DSA:3.90.1480.20:FF:000048', NULL, NULL, 'ST3 beta-galactoside alpha-2,3-sialyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(228877, NULL, 'G3DSA:3.40.630.30:FF:000295', NULL, NULL, 'GCN5-related N-acetyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(228878, NULL, 'G3DSA:2.160.20.70:FF:000017', NULL, NULL, 'Similar to tubulin-specific chaperone c', NULL, NULL, NULL, NULL, NULL, 4),
(228879, NULL, 'G3DSA:2.130.10.10:FF:000343', NULL, NULL, 'WD repeat domain, phosphoinositide interacting 1', NULL, NULL, NULL, NULL, NULL, 4),
(228880, NULL, 'G3DSA:3.40.50.720:FF:000300', NULL, NULL, 'Ubiquitin-activating enzyme E1 C', NULL, NULL, NULL, NULL, NULL, 4),
(228881, NULL, 'G3DSA:3.40.50.300:FF:006475', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228882, NULL, 'G3DSA:3.80.10.10:FF:001708', NULL, NULL, 'Disease resistance protein (TIR-NBS-LRR class) family', NULL, NULL, NULL, NULL, NULL, 4);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(228883, NULL, 'G3DSA:3.40.1620.30:FF:000001', NULL, NULL, 'Essential meiotic structure-specific endonuclease 1', NULL, NULL, NULL, NULL, NULL, 4),
(228884, NULL, 'G3DSA:2.60.40.1510:FF:000009', NULL, NULL, 'Integrin alpha M', NULL, NULL, NULL, NULL, NULL, 4),
(228885, NULL, 'G3DSA:4.10.60.10:FF:000217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228886, NULL, 'G3DSA:1.10.730.10:FF:000237', NULL, NULL, 'Methionine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(228887, NULL, 'G3DSA:3.40.50.980:FF:000013', NULL, NULL, 'Long-chain fatty acid--CoA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(228888, NULL, 'G3DSA:1.25.40.10:FF:000246', NULL, NULL, 'SEL1L family member 3', NULL, NULL, NULL, NULL, NULL, 4),
(228889, NULL, 'G3DSA:1.20.1270.170:FF:000001', NULL, NULL, 'Stress response kinase A', NULL, NULL, NULL, NULL, NULL, 4),
(228890, NULL, 'G3DSA:1.20.960.30:FF:000005', NULL, NULL, 'Putative LisH domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(228891, NULL, 'G3DSA:2.120.10.30:FF:000310', NULL, NULL, 'Gluconolaconase', NULL, NULL, NULL, NULL, NULL, 4),
(228892, NULL, 'G3DSA:2.60.260.20:FF:000026', NULL, NULL, 'Uncharacterized protein, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(228893, NULL, 'G3DSA:3.90.400.10:FF:000007', NULL, NULL, 'Sucrose phosphorylase', NULL, NULL, NULL, NULL, NULL, 4),
(228894, NULL, 'G3DSA:3.20.20.70:FF:000858', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228895, NULL, 'G3DSA:3.40.50.200:FF:000156', NULL, NULL, 'Subtilisin-like alkaline protease, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228896, NULL, 'G3DSA:1.10.8.260:FF:000002', NULL, NULL, '3-dehydro-bile acid delta(4,6)-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(228897, NULL, 'G3DSA:3.40.50.1820:FF:001433', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228898, NULL, 'G3DSA:2.130.10.10:FF:000904', NULL, NULL, 'Probable SEC13-protein transport protein', NULL, NULL, NULL, NULL, NULL, 4),
(228899, NULL, 'G3DSA:2.130.10.10:FF:004614', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228900, NULL, 'G3DSA:3.40.50.720:FF:001711', NULL, NULL, 'Oxidoreductase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228901, NULL, 'G3DSA:1.10.238.10:FF:000335', NULL, NULL, 'Calcium-binding protein KIC', NULL, NULL, NULL, NULL, NULL, 4),
(228902, NULL, 'G3DSA:3.40.50.970:FF:000010', NULL, NULL, '1-deoxy-D-xylulose-5-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(228903, NULL, 'G3DSA:3.20.20.450:FF:000021', NULL, NULL, 'Response regulator', NULL, NULL, NULL, NULL, NULL, 4),
(228904, NULL, 'G3DSA:3.30.2350.20:FF:000081', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228905, NULL, 'G3DSA:3.30.40.10:FF:002123', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228906, NULL, 'G3DSA:3.30.1560.10:FF:000003', NULL, NULL, 'Transcription elongation factor A protein-like 4', NULL, NULL, NULL, NULL, NULL, 4),
(228907, NULL, 'G3DSA:3.30.160.60:FF:004176', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228908, NULL, 'G3DSA:2.40.70.10:FF:000356', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228909, NULL, 'G3DSA:3.10.20.90:FF:000264', NULL, NULL, 'ISG15 ubiquitin-like modifier', NULL, NULL, NULL, NULL, NULL, 4),
(228910, NULL, 'G3DSA:3.30.40.10:FF:001634', NULL, NULL, 'Structure-specific endonuclease subunit SLX1', NULL, NULL, NULL, NULL, NULL, 4),
(228911, NULL, 'G3DSA:1.20.1070.10:FF:001381', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(228912, NULL, 'G3DSA:2.60.40.10:FF:003001', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228913, NULL, 'G3DSA:3.90.110.10:FF:000013', NULL, NULL, 'Malate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(228914, NULL, 'G3DSA:3.10.20.90:FF:000483', NULL, NULL, 'Histidine ammonia-lyase', NULL, NULL, NULL, NULL, NULL, 4),
(228915, NULL, 'G3DSA:2.60.40.10:FF:002383', NULL, NULL, 'Muscle M-line assembly protein unc-89', NULL, NULL, NULL, NULL, NULL, 4),
(228916, NULL, 'G3DSA:3.30.30.30:FF:000055', NULL, NULL, 'Hsp70 protein-domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(228917, NULL, 'G3DSA:3.90.550.10:FF:000451', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228918, NULL, 'G3DSA:2.60.40.1660:FF:000026', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228919, NULL, 'G3DSA:1.10.510.10:FF:000255', NULL, NULL, 'Calcium/calmodulin-dependent protein kinase type IV', NULL, NULL, NULL, NULL, NULL, 4),
(228920, NULL, 'G3DSA:3.40.50.300:FF:008162', NULL, NULL, 'Glutathione s-transferase', NULL, NULL, NULL, NULL, NULL, 4),
(228921, NULL, 'G3DSA:2.60.40.1670:FF:000029', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228922, NULL, 'G3DSA:3.40.1280.30:FF:000025', NULL, NULL, 'tRNA (guanine(9)-N1)-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(228923, NULL, 'G3DSA:2.160.20.10:FF:000027', NULL, NULL, 'Probable exopolygalacturonase X', NULL, NULL, NULL, NULL, NULL, 4),
(228924, NULL, 'G3DSA:3.30.450.40:FF:000123', NULL, NULL, 'Sigma-54-dependent Fis family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(228925, NULL, 'G3DSA:2.10.25.10:FF:001490', NULL, NULL, 'Putative fibrillin 2', NULL, NULL, NULL, NULL, NULL, 4),
(228926, NULL, 'G3DSA:2.60.40.10:FF:004530', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228927, NULL, 'G3DSA:3.30.870.10:FF:000112', NULL, NULL, 'Tyrosyl-DNA phosphodiesterase 1', NULL, NULL, NULL, NULL, NULL, 4),
(228928, NULL, 'G3DSA:3.30.1360.120:FF:000106', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228929, NULL, 'G3DSA:3.90.230.10:FF:000067', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228930, NULL, 'G3DSA:3.40.50.1820:FF:000123', NULL, NULL, 'Carboxypeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(228931, NULL, 'G3DSA:3.30.70.330:FF:001735', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228932, NULL, 'G3DSA:3.40.50.1240:FF:000157', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228933, NULL, 'G3DSA:1.10.3720.10:FF:000017', NULL, NULL, 'Arginine ABC transporter permease protein ArtM', NULL, NULL, NULL, NULL, NULL, 4),
(228934, NULL, 'G3DSA:2.10.220.10:FF:000167', NULL, NULL, 'Proprotein convertase subtilisin/kexin type 5', NULL, NULL, NULL, NULL, NULL, 4),
(228935, NULL, 'G3DSA:1.10.238.10:FF:000329', NULL, NULL, 'calcyphosin isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(228936, NULL, 'G3DSA:2.60.120.10:FF:000098', NULL, NULL, 'Germin-like protein 9-3', NULL, NULL, NULL, NULL, NULL, 4),
(228937, NULL, 'G3DSA:1.25.40.10:FF:004282', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228938, NULL, 'G3DSA:3.30.565.10:FF:000217', NULL, NULL, 'Sensory transduction histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(228939, NULL, 'G3DSA:3.30.200.20:FF:002111', NULL, NULL, 'Haspin protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(228940, NULL, 'G3DSA:3.40.50.1980:FF:000143', NULL, NULL, 'Sll1202 protein', NULL, NULL, NULL, NULL, NULL, 4),
(228941, NULL, 'G3DSA:1.10.10.10:FF:001981', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228942, NULL, 'G3DSA:3.80.10.10:FF:003619', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228943, NULL, 'G3DSA:2.60.40.1670:FF:000035', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228944, NULL, 'G3DSA:2.60.200.20:FF:000253', NULL, NULL, 'Gll1406 protein', NULL, NULL, NULL, NULL, NULL, 4),
(228945, NULL, 'G3DSA:2.40.70.10:FF:000250', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228946, NULL, 'G3DSA:2.90.10.10:FF:000053', NULL, NULL, 'G-type lectin S-receptor-like serine/threonine-protein kinase RLK1', NULL, NULL, NULL, NULL, NULL, 4),
(228947, NULL, 'G3DSA:3.30.160.60:FF:006087', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228948, NULL, 'G3DSA:2.60.40.60:FF:000683', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(228949, NULL, 'G3DSA:3.30.30.30:FF:000049', NULL, NULL, 'AGAP007682-PA', NULL, NULL, NULL, NULL, NULL, 4),
(228950, NULL, 'G3DSA:2.30.30.40:FF:000442', NULL, NULL, 'rho GTPase-activating protein 27 isoform X1', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(228951, NULL, 'G3DSA:1.20.1280.50:FF:000239', NULL, NULL, 'F-box/leucine rich repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228952, NULL, 'G3DSA:3.30.70.330:FF:002342', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228953, NULL, 'G3DSA:3.40.50.11610:FF:000030', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(228954, NULL, 'G3DSA:3.30.360.10:FF:000135', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228955, NULL, 'G3DSA:3.30.565.10:FF:000324', NULL, NULL, 'Sensor histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(228956, NULL, 'G3DSA:1.25.10.10:FF:001599', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228957, NULL, 'G3DSA:3.30.1360.120:FF:000095', NULL, NULL, 'Sarcosine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(228958, NULL, 'G3DSA:1.20.1420.30:FF:000003', NULL, NULL, 'sodium/calcium exchanger 1 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(228959, NULL, 'G3DSA:3.80.10.10:FF:000877', NULL, NULL, 'Ubiquitin ligase complex F-box protein GRR1', NULL, NULL, NULL, NULL, NULL, 4),
(228960, NULL, 'G3DSA:3.60.21.10:FF:000167', NULL, NULL, 'Acid sphingomyelinase-like phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(228961, NULL, 'G3DSA:3.30.9.10:FF:000269', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228962, NULL, 'G3DSA:2.60.40.1660:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228963, NULL, 'G3DSA:1.10.287.110:FF:000153', NULL, NULL, 'Chaperone protein DnaJ', NULL, NULL, NULL, NULL, NULL, 4),
(228964, NULL, 'G3DSA:1.20.1250.20:FF:001931', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228965, NULL, 'G3DSA:3.90.79.10:FF:000080', NULL, NULL, '8-oxo-dGDP phosphatase NUDT18', NULL, NULL, NULL, NULL, NULL, 4),
(228966, NULL, 'G3DSA:3.10.110.10:FF:000290', NULL, NULL, 'Ubiquitin-conjugating enzyme E2, J2 (UBC6 homolog, yeast)', NULL, NULL, NULL, NULL, NULL, 4),
(228967, NULL, 'G3DSA:1.10.287.1490:FF:000062', NULL, NULL, 'Protein phosphatase 1 regulatory subunit 9A-like A', NULL, NULL, NULL, NULL, NULL, 4),
(228968, NULL, 'G3DSA:1.25.10.10:FF:002330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228969, NULL, 'G3DSA:2.60.40.1510:FF:000015', NULL, NULL, 'Integrin subunit alpha 11', NULL, NULL, NULL, NULL, NULL, 4),
(228970, NULL, 'G3DSA:1.10.238.10:FF:000661', NULL, NULL, '45 kDa calcium-binding protein', NULL, NULL, NULL, NULL, NULL, 4),
(228971, NULL, 'G3DSA:2.10.25.10:FF:001501', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228972, NULL, 'G3DSA:2.160.20.10:FF:000140', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228973, NULL, 'G3DSA:3.40.50.970:FF:000122', NULL, NULL, 'Related to MET10-sulfite reductase flavin-binding subunit', NULL, NULL, NULL, NULL, NULL, 4),
(228974, NULL, 'G3DSA:3.10.20.90:FF:000590', NULL, NULL, 'Tubulin-folding cofactor B', NULL, NULL, NULL, NULL, NULL, 4),
(228975, NULL, 'G3DSA:1.10.3720.10:FF:000130', NULL, NULL, 'ABC transporter permease protein', NULL, NULL, NULL, NULL, NULL, 4),
(228976, NULL, 'G3DSA:1.20.120.730:FF:000022', NULL, NULL, 'Protein transport protein Sec24C, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228977, NULL, 'G3DSA:3.40.190.10:FF:000147', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(228978, NULL, 'G3DSA:3.30.40.10:FF:001067', NULL, NULL, 'Putative E3 ubiquitin-protein ligase RING1a', NULL, NULL, NULL, NULL, NULL, 4),
(228979, NULL, 'G3DSA:3.50.50.60:FF:000204', NULL, NULL, 'Rab proteins geranylgeranyltransferase component', NULL, NULL, NULL, NULL, NULL, 4),
(228980, NULL, 'G3DSA:1.10.287.110:FF:000046', NULL, NULL, 'dnaJ homolog subfamily C member 21', NULL, NULL, NULL, NULL, NULL, 4),
(228981, NULL, 'G3DSA:1.20.144.10:FF:000053', NULL, NULL, 'Phosphatidylglycerophosphatase B, putative', NULL, NULL, NULL, NULL, NULL, 4),
(228982, NULL, 'G3DSA:3.40.50.300:FF:008055', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(228983, NULL, 'G3DSA:1.10.3210.10:FF:000046', NULL, NULL, 'Retrograde regulation protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(228984, NULL, 'G3DSA:2.60.40.10:FF:002276', NULL, NULL, 'Twitchin', NULL, NULL, NULL, NULL, NULL, 4),
(228985, NULL, 'G3DSA:3.60.21.10:FF:000493', NULL, NULL, 'Serine/threonine-protein phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(228986, NULL, 'G3DSA:3.90.480.10:FF:000001', NULL, NULL, 'Sulfite reductase [ferredoxin], chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(228987, NULL, 'G3DSA:3.80.10.10:FF:001821', NULL, NULL, 'F-box protein SKIP17', NULL, NULL, NULL, NULL, NULL, 4),
(228988, NULL, 'G3DSA:3.30.230.70:FF:000014', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(228989, NULL, 'G3DSA:3.30.200.20:FF:002094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(228990, NULL, 'G3DSA:2.120.10.30:FF:000422', NULL, NULL, 'Tripartite motif-containing 3', NULL, NULL, NULL, NULL, NULL, 4),
(228991, NULL, 'G3DSA:3.40.50.720:FF:001368', NULL, NULL, 'Oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(228992, NULL, 'G3DSA:2.170.150.20:FF:000003', NULL, NULL, 'Peptide methionine sulfoxide reductase MsrB', NULL, NULL, NULL, NULL, NULL, 4),
(228993, NULL, 'G3DSA:2.30.18.10:FF:000005', NULL, NULL, 'transcription initiation factor IIA large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(228994, NULL, 'G3DSA:2.130.10.10:FF:000910', NULL, NULL, 'Diphthamide biosynthesis 7', NULL, NULL, NULL, NULL, NULL, 4),
(228995, NULL, 'G3DSA:3.90.70.10:FF:000099', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(228996, NULL, 'G3DSA:3.90.480.20:FF:000004', NULL, NULL, 'Nitrite reductase large subunit', NULL, NULL, NULL, NULL, NULL, 4),
(228997, NULL, 'G3DSA:3.30.870.10:FF:000095', NULL, NULL, 'Competence protein ComE', NULL, NULL, NULL, NULL, NULL, 4),
(228998, NULL, 'G3DSA:3.40.50.300:FF:002653', NULL, NULL, 'Genome polyprotein', NULL, NULL, NULL, NULL, NULL, 4),
(228999, NULL, 'G3DSA:1.10.1070.11:FF:000030', NULL, NULL, 'Histone acetylase complex subunit Paf400', NULL, NULL, NULL, NULL, NULL, 4),
(229000, NULL, 'G3DSA:1.10.10.440:FF:000009', NULL, NULL, 'pre-mRNA-processing factor 40 homolog A isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(229001, NULL, 'G3DSA:3.90.280.10:FF:000014', NULL, NULL, 'Phosphatidylethanolamine-binding protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(229002, NULL, 'G3DSA:1.10.510.10:FF:001778', NULL, NULL, 'Protein kinase superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(229003, NULL, 'G3DSA:2.30.29.90:FF:000015', NULL, NULL, 'Uncharacterized protein C17G8.12', NULL, NULL, NULL, NULL, NULL, 4),
(229004, NULL, 'G3DSA:3.30.1010.10:FF:000142', NULL, NULL, 'Si:dkeyp-75h12.7', NULL, NULL, NULL, NULL, NULL, 4),
(229005, NULL, 'G3DSA:1.20.58.390:FF:000229', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229006, NULL, 'G3DSA:3.20.20.300:FF:000010', NULL, NULL, 'Putative beta-D-xylosidase 5', NULL, NULL, NULL, NULL, NULL, 4),
(229007, NULL, 'G3DSA:3.30.160.60:FF:002613', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229008, NULL, 'G3DSA:1.10.10.430:FF:000006', NULL, NULL, 'Protein phosphatase 1B (formerly 2C)', NULL, NULL, NULL, NULL, NULL, 4),
(229009, NULL, 'G3DSA:3.30.40.10:FF:001853', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229010, NULL, 'G3DSA:2.40.70.10:FF:000137', NULL, NULL, 'Eukaryotic aspartyl protease family protein', NULL, NULL, NULL, NULL, NULL, 4),
(229011, NULL, 'G3DSA:1.25.40.10:FF:004175', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229012, NULL, 'G3DSA:3.30.50.10:FF:000044', NULL, NULL, 'retinoic acid receptor beta isoform X4', NULL, NULL, NULL, NULL, NULL, 4),
(229013, NULL, 'G3DSA:1.10.620.20:FF:000013', NULL, NULL, 'Benzoyl-CoA oxygenase subunit B', NULL, NULL, NULL, NULL, NULL, 4),
(229014, NULL, 'G3DSA:3.30.70.240:FF:000062', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(229015, NULL, 'G3DSA:2.130.10.10:FF:002254', NULL, NULL, 'WD Repeat protein', NULL, NULL, NULL, NULL, NULL, 4),
(229016, NULL, 'G3DSA:2.170.270.10:FF:000054', NULL, NULL, 'Blast:Chromosome-associated kinesin KIF4A', NULL, NULL, NULL, NULL, NULL, 4),
(229017, NULL, 'G3DSA:2.40.390.10:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229018, NULL, 'G3DSA:3.40.30.10:FF:000537', NULL, NULL, 'Diphosphomevalonate decarboxylase MVD2', NULL, NULL, NULL, NULL, NULL, 4),
(229019, NULL, 'G3DSA:3.80.10.10:FF:003951', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229020, NULL, 'G3DSA:2.130.10.10:FF:005688', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229021, NULL, 'G3DSA:3.90.1420.10:FF:000047', NULL, NULL, 'Rubisco small subunit small subunit n-methyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(229022, NULL, 'G3DSA:3.40.50.1820:FF:001652', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229023, NULL, 'G3DSA:3.90.740.10:FF:000044', NULL, NULL, 'Isoleucine--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(229024, NULL, 'G3DSA:2.60.120.200:FF:000769', NULL, NULL, 'Laminin alpha 2', NULL, NULL, NULL, NULL, NULL, 4),
(229025, NULL, 'G3DSA:1.20.1250.20:FF:001818', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229026, NULL, 'G3DSA:1.20.1070.10:FF:001717', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229027, NULL, 'G3DSA:3.30.230.130:FF:000059', NULL, NULL, 'AFR498Wp', NULL, NULL, NULL, NULL, NULL, 4),
(229028, NULL, 'G3DSA:3.40.50.300:FF:000293', NULL, NULL, 'ATP binding cassette subfamily C member 1', NULL, NULL, NULL, NULL, NULL, 4),
(229029, NULL, 'G3DSA:3.40.47.10:FF:000053', NULL, NULL, 'Alpha-pyrone synthesis polyketide synthase', NULL, NULL, NULL, NULL, NULL, 4),
(229030, NULL, 'G3DSA:2.30.30.40:FF:000329', NULL, NULL, 'Trio, isoform D', NULL, NULL, NULL, NULL, NULL, 4),
(229031, NULL, 'G3DSA:3.30.1490.100:FF:000033', NULL, NULL, 'DNA polymerase IV', NULL, NULL, NULL, NULL, NULL, 4),
(229032, NULL, 'G3DSA:3.10.110.10:FF:000071', NULL, NULL, 'RWD domain-containing protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(229033, NULL, 'G3DSA:1.20.140.150:FF:000037', NULL, NULL, 'GSG1 like 2', NULL, NULL, NULL, NULL, NULL, 4),
(229034, NULL, 'G3DSA:1.25.40.10:FF:002045', NULL, NULL, 'Pentatricopeptide repeat-containing protein, mitochondrial', NULL, NULL, NULL, NULL, NULL, 4),
(229035, NULL, 'G3DSA:3.30.160.60:FF:004743', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(229036, NULL, 'G3DSA:3.40.50.880:FF:000084', NULL, NULL, '4-methyl-5(B-hydroxyethyl)-thiazole monophosphate biosynthesis enzyme', NULL, NULL, NULL, NULL, NULL, 4),
(229037, NULL, 'G3DSA:2.30.42.10:FF:000331', NULL, NULL, 'Protease Do-like 8, chloroplastic', NULL, NULL, NULL, NULL, NULL, 4),
(229038, NULL, 'G3DSA:3.60.21.10:FF:000274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229039, NULL, 'G3DSA:3.40.50.720:FF:001587', NULL, NULL, 'SDR family oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(229040, NULL, 'G3DSA:2.60.40.10:FF:004417', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(229041, NULL, 'G3DSA:3.40.50.261:FF:000017', NULL, NULL, 'Succinyl-CoA synthetase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(229042, NULL, 'G3DSA:1.10.10.10:FF:001868', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229043, NULL, 'G3DSA:3.40.630.10:FF:000406', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229044, NULL, 'G3DSA:3.10.110.10:FF:000301', NULL, NULL, 'Si:ch1073-205c8.3', NULL, NULL, NULL, NULL, NULL, 4),
(229045, NULL, 'G3DSA:2.30.30.40:FF:000099', NULL, NULL, 'Uncharacterized protein, isoform C', NULL, NULL, NULL, NULL, NULL, 4),
(229046, NULL, 'G3DSA:1.10.1670.10:FF:000001', NULL, NULL, 'Endonuclease III', NULL, NULL, NULL, NULL, NULL, 4),
(229047, NULL, 'G3DSA:3.30.420.40:FF:000284', NULL, NULL, 'Probable bifunctional tRNA threonylcarbamoyladenosine biosynthesis protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(229048, NULL, 'G3DSA:3.30.2160.10:FF:000041', NULL, NULL, 'Ubiquitin-ubiquitin ligase', NULL, NULL, NULL, NULL, NULL, 4),
(229049, NULL, 'G3DSA:4.10.1110.10:FF:000002', NULL, NULL, 'Immunoglobulin mu DNA-binding protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(229050, NULL, 'G3DSA:3.40.50.300:FF:006924', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229051, NULL, 'G3DSA:1.20.58.60:FF:000132', NULL, NULL, 'microtubule-actin cross-linking factor 1 isoform X9', NULL, NULL, NULL, NULL, NULL, 4),
(229052, NULL, 'G3DSA:2.10.25.10:FF:000776', NULL, NULL, 'Delta-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(229053, NULL, 'G3DSA:2.120.10.100:FF:000006', NULL, NULL, 'Calcium-activated nucleotidase 1a', NULL, NULL, NULL, NULL, NULL, 4),
(229054, NULL, 'G3DSA:4.10.400.10:FF:000297', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229055, NULL, 'G3DSA:1.10.418.10:FF:000208', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229056, NULL, 'G3DSA:3.40.190.10:FF:000260', NULL, NULL, 'Porphobilinogen deaminase', NULL, NULL, NULL, NULL, NULL, 4),
(229057, NULL, 'G3DSA:3.30.230.80:FF:000017', NULL, NULL, 'GHKL domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(229058, NULL, 'G3DSA:2.120.10.30:FF:000203', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229059, NULL, 'G3DSA:3.40.630.10:FF:000176', NULL, NULL, 'Transferrin receptor, putative', NULL, NULL, NULL, NULL, NULL, 4),
(229060, NULL, 'G3DSA:3.30.160.60:FF:000702', NULL, NULL, 'Transcription factor E4F1 isoform 1', NULL, NULL, NULL, NULL, NULL, 4),
(229061, NULL, 'G3DSA:1.20.5.1200:FF:000010', NULL, NULL, 'Tocopherol (alpha) transfer protein', NULL, NULL, NULL, NULL, NULL, 4),
(229062, NULL, 'G3DSA:3.90.550.10:FF:000119', NULL, NULL, 'Dolichol-phosphate mannosyltransferase subunit 1', NULL, NULL, NULL, NULL, NULL, 4),
(229063, NULL, 'G3DSA:1.10.8.270:FF:000117', NULL, NULL, 'GTPase-activating protein GYP7', NULL, NULL, NULL, NULL, NULL, 4),
(229064, NULL, 'G3DSA:3.30.200.20:FF:002330', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229065, NULL, 'G3DSA:3.20.20.220:FF:000082', NULL, NULL, 'Proline dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(229066, NULL, 'G3DSA:3.90.226.10:FF:000181', NULL, NULL, '3-hydroxybutyryl-CoA dehydratase', NULL, NULL, NULL, NULL, NULL, 4),
(229067, NULL, 'G3DSA:2.60.40.2030:FF:000042', NULL, NULL, 'Adhesion G protein-coupled receptor V1', NULL, NULL, NULL, NULL, NULL, 4),
(229068, NULL, 'G3DSA:2.130.10.10:FF:004165', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229069, NULL, 'G3DSA:3.40.50.300:FF:004564', NULL, NULL, 'mitofusin-2', NULL, NULL, NULL, NULL, NULL, 4),
(229070, NULL, 'G3DSA:3.30.420.40:FF:000520', NULL, NULL, 'Actin, actin related protein', NULL, NULL, NULL, NULL, NULL, 4),
(229071, NULL, 'G3DSA:1.10.950.10:FF:000001', NULL, NULL, 'actin-binding LIM protein 1 isoform X2', NULL, NULL, NULL, NULL, NULL, 4),
(229072, NULL, 'G3DSA:2.60.40.60:FF:000464', NULL, NULL, 'Protocadherin extracellular domain', NULL, NULL, NULL, NULL, NULL, 4),
(229073, NULL, 'G3DSA:3.60.21.10:FF:000386', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(229074, NULL, 'G3DSA:1.10.540.10:FF:000077', NULL, NULL, 'Putative acyl-CoA dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(229075, NULL, 'G3DSA:3.30.559.70:FF:000030', NULL, NULL, 'Carnitine palmitoyltransferase 1B (Muscle)', NULL, NULL, NULL, NULL, NULL, 4),
(229076, NULL, 'G3DSA:2.40.30.90:FF:000001', NULL, NULL, 'Adenosyl-chloride synthase', NULL, NULL, NULL, NULL, NULL, 4),
(229077, NULL, 'G3DSA:1.10.510.10:FF:000474', NULL, NULL, 'Wall-associated receptor kinase 3', NULL, NULL, NULL, NULL, NULL, 4),
(229078, NULL, 'G3DSA:2.10.25.10:FF:001271', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229079, NULL, 'G3DSA:3.40.50.720:FF:000986', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229080, NULL, 'G3DSA:3.40.50.1820:FF:001539', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(229081, NULL, 'G3DSA:1.10.10.2840:FF:000004', NULL, NULL, 'Putative regulatory protein', NULL, NULL, NULL, NULL, NULL, 4),
(229082, NULL, 'G3DSA:3.90.550.10:FF:000338', NULL, NULL, 'Molybdenum cofactor guanylyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(229083, NULL, 'G3DSA:3.10.450.50:FF:000102', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229084, NULL, 'G3DSA:1.10.510.10:FF:000362', NULL, NULL, 'Ser/arg-rich protein kinase 4', NULL, NULL, NULL, NULL, NULL, 4),
(229085, NULL, 'G3DSA:2.10.70.10:FF:000285', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229086, NULL, 'G3DSA:1.20.1070.10:FF:001830', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229087, NULL, 'G3DSA:2.40.50.140:FF:001277', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(229088, NULL, 'G3DSA:1.25.40.20:FF:000917', NULL, NULL, 'SoWAH (Drosophila) homolog', NULL, NULL, NULL, NULL, NULL, 4),
(229089, NULL, 'G3DSA:2.60.40.10:FF:000146', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(229090, NULL, 'G3DSA:3.30.70.330:FF:001954', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(229091, NULL, 'G3DSA:2.60.40.10:FF:002164', NULL, NULL, 'Basigin, isoform J', NULL, NULL, NULL, NULL, NULL, 4),
(229092, NULL, 'G3DSA:1.20.1370.60:FF:000002', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229093, NULL, 'G3DSA:3.40.50.300:FF:001130', NULL, NULL, 'RecBCD enzyme subunit RecD', NULL, NULL, NULL, NULL, NULL, 4),
(229094, NULL, 'G3DSA:3.50.50.60:FF:000316', NULL, NULL, 'Sarcosine dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(229095, NULL, 'G3DSA:3.10.100.10:FF:000238', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(229096, NULL, 'G3DSA:3.30.160.60:FF:000359', NULL, NULL, 'GLIS family zinc finger 2', NULL, NULL, NULL, NULL, NULL, 4),
(229097, NULL, 'G3DSA:1.25.40.730:FF:000002', NULL, NULL, 'Clathrin heavy chain', NULL, NULL, NULL, NULL, NULL, 4),
(229098, NULL, 'G3DSA:3.30.70.2630:FF:000009', NULL, NULL, 'Putative COX1/OXI3 intron 2 protein', NULL, NULL, NULL, NULL, NULL, 4),
(229099, NULL, 'G3DSA:3.40.50.1820:FF:001871', NULL, NULL, 'Dipeptidyl Peptidase Four (IV) family', NULL, NULL, NULL, NULL, NULL, 4),
(229100, NULL, 'G3DSA:3.30.70.2610:FF:000003', NULL, NULL, 'RNA polymerase II transcription factor B subunit 2', NULL, NULL, NULL, NULL, NULL, 4),
(229101, NULL, 'G3DSA:2.40.50.100:FF:000096', NULL, NULL, 'Exosome complex exonuclease RRP4, putative', NULL, NULL, NULL, NULL, NULL, 4),
(229102, NULL, 'G3DSA:2.30.30.30:FF:000107', NULL, NULL, 'Elongation factor P (EF-P) KOW-like domain containing protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(229103, NULL, 'G3DSA:3.90.550.10:FF:000670', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229104, NULL, 'G3DSA:2.10.270.10:FF:000007', NULL, NULL, 'Toxin B', NULL, NULL, NULL, NULL, NULL, 4),
(229105, NULL, 'G3DSA:3.30.160.60:FF:000691', NULL, NULL, 'Zinc finger protein basonuclin-1', NULL, NULL, NULL, NULL, NULL, 4),
(229106, NULL, 'G3DSA:3.80.10.10:FF:001602', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(229107, NULL, 'G3DSA:3.40.50.10810:FF:000133', NULL, NULL, 'SNF2 histone linker PHD RING helicase', NULL, NULL, NULL, NULL, NULL, 4),
(229108, NULL, 'G3DSA:3.30.200.20:FF:001493', NULL, NULL, 'Sporulation protein kinase mde3', NULL, NULL, NULL, NULL, NULL, 4),
(229109, NULL, 'G3DSA:3.30.70.330:FF:000212', NULL, NULL, 'Meiosis regulator and mRNA stability factor 1', NULL, NULL, NULL, NULL, NULL, 4),
(229110, NULL, 'G3DSA:3.30.450.30:FF:000013', NULL, NULL, 'Roadblock/LC7 domain protein', NULL, NULL, NULL, NULL, NULL, 4),
(229111, NULL, 'G3DSA:3.30.505.10:FF:000096', NULL, NULL, 'SH2 domain-containing protein 4B-like', NULL, NULL, NULL, NULL, NULL, 4),
(229112, NULL, 'G3DSA:2.40.50.100:FF:000107', NULL, NULL, 'DNA-directed RNA polymerase subunit beta''', NULL, NULL, NULL, NULL, NULL, 4),
(229113, NULL, 'G3DSA:1.10.1070.11:FF:000142', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(229114, NULL, 'G3DSA:3.30.450.40:FF:000016', NULL, NULL, 'Heat-inducible transcription repressor HrcA', NULL, NULL, NULL, NULL, NULL, 4),
(229115, NULL, 'G3DSA:4.10.400.10:FF:000078', NULL, NULL, 'low-density lipoprotein receptor-related protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(229116, NULL, 'G3DSA:3.30.310.210:FF:000006', NULL, NULL, 'RNA-binding KH domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(229117, NULL, 'G3DSA:2.40.50.90:FF:000002', NULL, NULL, 'Staphylococcal nuclease domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(229118, NULL, 'G3DSA:1.25.40.10:FF:004063', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229119, NULL, 'G3DSA:3.30.200.20:FF:000076', NULL, NULL, 'CMGC/SRPK protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(229120, NULL, 'G3DSA:1.10.287.490:FF:000002', NULL, NULL, 'Peptide synthetase ORF5', NULL, NULL, NULL, NULL, NULL, 4),
(229121, NULL, 'G3DSA:3.90.920.10:FF:000030', NULL, NULL, 'DNA primase', NULL, NULL, NULL, NULL, NULL, 4),
(229122, NULL, 'G3DSA:3.80.10.10:FF:001591', NULL, NULL, 'Os01g0170300 protein', NULL, NULL, NULL, NULL, NULL, 4),
(229123, NULL, 'G3DSA:1.20.1310.10:FF:000017', NULL, NULL, 'Cullin 5', NULL, NULL, NULL, NULL, NULL, 4),
(229124, NULL, 'G3DSA:3.30.450.20:FF:000010', NULL, NULL, 'Aryl hydrocarbon receptor nuclear translocator-like, isoform CRA_b', NULL, NULL, NULL, NULL, NULL, 4),
(229125, NULL, 'G3DSA:1.50.40.10:FF:000396', NULL, NULL, 'alpha-1,2-Mannosidase', NULL, NULL, NULL, NULL, NULL, 4),
(229126, NULL, 'G3DSA:3.40.30.10:FF:000756', NULL, NULL, 'Monothiol glutaredoxin-S6', NULL, NULL, NULL, NULL, NULL, 4),
(229127, NULL, 'G3DSA:3.40.50.1820:FF:001540', NULL, NULL, 'Protein CBG11775', NULL, NULL, NULL, NULL, NULL, 4),
(229128, NULL, 'G3DSA:3.90.70.10:FF:000442', NULL, NULL, 'Cysteine peptidase, Clan CA, family C2, putative', NULL, NULL, NULL, NULL, NULL, 4),
(229129, NULL, 'G3DSA:3.40.50.720:FF:001604', NULL, NULL, 'Prephenate dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(229130, NULL, 'G3DSA:1.10.238.10:FF:000442', NULL, NULL, 'Paralysed Arrest at Two-fold', NULL, NULL, NULL, NULL, NULL, 4),
(229131, NULL, 'G3DSA:3.20.20.60:FF:000069', NULL, NULL, 'Pyruvate kinase', NULL, NULL, NULL, NULL, NULL, 4),
(229132, NULL, 'G3DSA:1.10.560.10:FF:000078', NULL, NULL, '60 kDa chaperonin', NULL, NULL, NULL, NULL, NULL, 4),
(229133, NULL, 'G3DSA:3.30.1680.10:FF:000057', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229134, NULL, 'G3DSA:1.25.10.10:FF:000076', NULL, NULL, 'Elongation factor 3', NULL, NULL, NULL, NULL, NULL, 4),
(229135, NULL, 'G3DSA:3.90.780.10:FF:000041', NULL, NULL, 'Slr0306 protein', NULL, NULL, NULL, NULL, NULL, 4),
(229136, NULL, 'G3DSA:4.10.280.10:FF:000197', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(229137, NULL, 'G3DSA:1.10.220.10:FF:000042', NULL, NULL, 'Annexin', NULL, NULL, NULL, NULL, NULL, 4),
(229138, NULL, 'G3DSA:1.10.1070.11:FF:000029', NULL, NULL, 'Serine/threonine-protein kinase TOR', NULL, NULL, NULL, NULL, NULL, 4),
(229139, NULL, 'G3DSA:3.40.50.300:FF:008274', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229140, NULL, 'G3DSA:3.30.160.60:FF:006323', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(229141, NULL, 'G3DSA:2.120.10.80:FF:000066', NULL, NULL, 'Kelch domain-containing protein 8B', NULL, NULL, NULL, NULL, NULL, 4),
(229142, NULL, 'G3DSA:2.30.22.10:FF:000004', NULL, NULL, 'Protein GrpE', NULL, NULL, NULL, NULL, NULL, 4),
(229143, NULL, 'G3DSA:3.40.50.300:FF:005868', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229144, NULL, 'G3DSA:2.20.70.10:FF:000200', NULL, NULL, 'Pre-mRNA-splicing factor URN1', NULL, NULL, NULL, NULL, NULL, 4),
(229145, NULL, 'G3DSA:2.40.160.10:FF:000071', NULL, NULL, 'Outer membrane channel, putative', NULL, NULL, NULL, NULL, NULL, 4),
(229146, NULL, 'G3DSA:3.10.20.90:FF:000371', NULL, NULL, 'Locomotion defects, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(229147, NULL, 'G3DSA:3.40.50.1440:FF:000116', NULL, NULL, 'Tubulin gamma chain', NULL, NULL, NULL, NULL, NULL, 4);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(229148, NULL, 'G3DSA:1.10.10.10:FF:000564', NULL, NULL, 'ATP-dependent DNA helicase RecQ', NULL, NULL, NULL, NULL, NULL, 4),
(229149, NULL, 'G3DSA:2.60.120.260:FF:000511', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229150, NULL, 'G3DSA:2.40.50.140:FF:000080', NULL, NULL, 'Aspartate--tRNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(229151, NULL, 'G3DSA:1.10.1420.10:FF:000067', NULL, NULL, 'Unplaced genomic scaffold supercont2.4, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(229152, NULL, 'G3DSA:1.10.510.10:FF:004414', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(229153, NULL, 'G3DSA:1.20.1070.10:FF:001611', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229154, NULL, 'G3DSA:2.30.29.30:FF:000025', NULL, NULL, 'Phosphoinositide phospholipase C', NULL, NULL, NULL, NULL, NULL, 4),
(229155, NULL, 'G3DSA:3.40.50.300:FF:006144', NULL, NULL, 'Os11g0312340 protein', NULL, NULL, NULL, NULL, NULL, 4),
(229156, NULL, 'G3DSA:3.90.550.10:FF:000557', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(229157, NULL, 'G3DSA:1.10.238.10:FF:000099', NULL, NULL, 'calpain-2 catalytic subunit', NULL, NULL, NULL, NULL, NULL, 4),
(229158, NULL, 'G3DSA:2.60.40.10:FF:000365', NULL, NULL, 'If kappa light chain', NULL, NULL, NULL, NULL, NULL, 4),
(229159, NULL, 'G3DSA:2.30.110.10:FF:000076', NULL, NULL, 'Flavin reductase', NULL, NULL, NULL, NULL, NULL, 4),
(229160, NULL, 'G3DSA:2.70.130.10:FF:000096', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(229161, NULL, 'G3DSA:3.30.450.40:FF:000235', NULL, NULL, 'Diguanylate cyclase with GAF sensory domain', NULL, NULL, NULL, NULL, NULL, 4),
(229162, NULL, 'G3DSA:2.40.50.140:FF:000422', NULL, NULL, 'Replication protein A subunit', NULL, NULL, NULL, NULL, NULL, 4),
(229163, NULL, 'G3DSA:3.80.10.10:FF:001259', NULL, NULL, 'Leucine rich repeat / protein phosphatase 2C domain containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(229164, NULL, 'G3DSA:3.40.50.300:FF:007998', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229165, NULL, 'G3DSA:3.50.50.60:FF:001497', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229166, NULL, 'G3DSA:1.20.5.4820:FF:000017', NULL, NULL, 'MYO19 isoform 4', NULL, NULL, NULL, NULL, NULL, 4),
(229167, NULL, 'G3DSA:3.80.10.10:FF:003171', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229168, NULL, 'G3DSA:2.60.200.10:FF:000031', NULL, NULL, 'Interferon regulatory factor like protein', NULL, NULL, NULL, NULL, NULL, 4),
(229169, NULL, 'G3DSA:2.130.10.10:FF:002815', NULL, NULL, 'Periodic tryptophan protein 1, putative', NULL, NULL, NULL, NULL, NULL, 4),
(229170, NULL, 'G3DSA:3.40.50.2300:FF:001364', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(229171, NULL, 'G3DSA:1.20.1000.10:FF:000027', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(229172, NULL, 'G3DSA:3.90.190.10:FF:000586', NULL, NULL, 'Putative tyrosine phosphatase', NULL, NULL, NULL, NULL, NULL, 4),
(229173, NULL, 'G3DSA:1.25.40.10:FF:001988', NULL, NULL, 'Os07g0203900 protein', NULL, NULL, NULL, NULL, NULL, 4),
(229174, NULL, 'G3DSA:1.20.1510.10:FF:000004', NULL, NULL, 'zinc transporter 9 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(229175, NULL, 'G3DSA:2.60.40.10:FF:004636', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(229176, NULL, 'G3DSA:3.20.20.140:FF:000389', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229177, NULL, 'G3DSA:3.10.100.10:FF:000351', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(229178, NULL, 'G3DSA:1.20.5.30:FF:000006', NULL, NULL, 'Matrilin 2', NULL, NULL, NULL, NULL, NULL, 4),
(229179, NULL, 'G3DSA:2.40.10.10:FF:000583', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(229180, NULL, 'G3DSA:2.60.40.150:FF:000615', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229181, NULL, 'G3DSA:3.40.50.150:FF:000444', NULL, NULL, 'Phthiotriol/phenolphthiotriol dimycocerosates methyltransferase', NULL, NULL, NULL, NULL, NULL, 4);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(229182, NULL, 'G3DSA:3.40.50.10810:FF:000239', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229183, NULL, 'G3DSA:3.30.200.20:FF:001599', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229184, NULL, 'G3DSA:3.10.20.90:FF:000713', NULL, NULL, 'Afadin', NULL, NULL, NULL, NULL, NULL, 4),
(229185, NULL, 'G3DSA:3.30.70.330:FF:002230', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(229186, NULL, 'G3DSA:3.30.565.10:FF:000436', NULL, NULL, 'Histidine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(229187, NULL, 'G3DSA:2.60.200.20:FF:000034', NULL, NULL, 'kinesin-like protein KIF28P', NULL, NULL, NULL, NULL, NULL, 4),
(229188, NULL, 'G3DSA:1.10.510.10:FF:002615', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(229189, NULL, 'G3DSA:3.40.1370.10:FF:000026', NULL, NULL, '50S ribosomal protein L4', NULL, NULL, NULL, NULL, NULL, 4),
(229190, NULL, 'G3DSA:3.40.800.20:FF:000007', NULL, NULL, 'Histone deacetylase', NULL, NULL, NULL, NULL, NULL, 4),
(229191, NULL, 'G3DSA:2.130.10.10:FF:000674', NULL, NULL, 'WD-repeat protein, putative', NULL, NULL, NULL, NULL, NULL, 4),
(229192, NULL, 'G3DSA:3.60.21.10:FF:000055', NULL, NULL, 'Sphingomyelin phosphodiesterase', NULL, NULL, NULL, NULL, NULL, 4),
(229193, NULL, 'G3DSA:1.20.5.20:FF:000003', NULL, NULL, 'Apolipoprotein AIV', NULL, NULL, NULL, NULL, NULL, 4),
(229194, NULL, 'G3DSA:1.20.120.1900:FF:000048', NULL, NULL, 'Spindle pole body component', NULL, NULL, NULL, NULL, NULL, 4),
(229195, NULL, 'G3DSA:1.25.40.10:FF:002264', NULL, NULL, 'YALI0F26631p', NULL, NULL, NULL, NULL, NULL, 4),
(229196, NULL, 'G3DSA:2.20.80.10:FF:000026', NULL, NULL, 'Uncharacterized protein (Fragment)', NULL, NULL, NULL, NULL, NULL, 4),
(229197, NULL, 'G3DSA:3.30.40.10:FF:000105', NULL, NULL, 'WD repeat and FYVE domain-containing protein 2', NULL, NULL, NULL, NULL, NULL, 4),
(229198, NULL, 'G3DSA:2.70.98.10:FF:000115', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229199, NULL, 'G3DSA:1.20.1640.10:FF:000008', NULL, NULL, 'NPC intracellular cholesterol transporter 1', NULL, NULL, NULL, NULL, NULL, 4),
(229200, NULL, 'G3DSA:2.60.40.10:FF:002506', NULL, NULL, 'Unc-40 protein', NULL, NULL, NULL, NULL, NULL, 4),
(229201, NULL, 'G3DSA:3.40.50.1000:FF:000445', NULL, NULL, 'HAD-superfamily hydrolase, subfamily IIA containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(229202, NULL, 'G3DSA:1.50.40.10:FF:000519', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229203, NULL, 'G3DSA:3.80.10.10:FF:003058', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229204, NULL, 'G3DSA:3.30.43.10:FF:000022', NULL, NULL, 'Possible oxidoreductase', NULL, NULL, NULL, NULL, NULL, 4),
(229205, NULL, 'G3DSA:2.10.25.10:FF:000995', NULL, NULL, 'Integrin beta', NULL, NULL, NULL, NULL, NULL, 4),
(229206, NULL, 'G3DSA:3.20.20.80:FF:000749', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(229207, NULL, 'G3DSA:3.90.1410.10:FF:000108', NULL, NULL, 'Ribosomal lysine N-methyltransferase set11', NULL, NULL, NULL, NULL, NULL, 4),
(229208, NULL, 'G3DSA:1.50.40.10:FF:000177', NULL, NULL, 'Kidney mitochondrial carrier protein 1', NULL, NULL, NULL, NULL, NULL, 4),
(229209, NULL, 'G3DSA:3.30.300.130:FF:000025', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(229210, NULL, 'G3DSA:2.70.150.10:FF:000108', NULL, NULL, 'Cation transporting ATPase', NULL, NULL, NULL, NULL, NULL, 4),
(229211, NULL, 'G3DSA:2.40.330.10:FF:000011', NULL, NULL, 'Putative B3 domain-containing protein At5g66980', NULL, NULL, NULL, NULL, NULL, 4),
(229212, NULL, 'G3DSA:1.25.40.990:FF:000046', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229213, NULL, 'G3DSA:3.80.10.10:FF:003513', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(229214, NULL, 'G3DSA:3.40.350.10:FF:000025', NULL, NULL, 'YER078C-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(229215, NULL, 'G3DSA:2.120.10.30:FF:000309', NULL, NULL, 'Regucalcin', NULL, NULL, NULL, NULL, NULL, 4);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(229216, NULL, 'G3DSA:1.25.40.10:FF:000134', NULL, NULL, 'Beta-barrel assembly-enhancing protease', NULL, NULL, NULL, NULL, NULL, 4),
(229217, NULL, 'G3DSA:2.60.40.150:FF:000273', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(229218, NULL, 'G3DSA:3.30.160.60:FF:002719', NULL, NULL, 'Zinc finger protein 224', NULL, NULL, NULL, NULL, NULL, 4),
(229219, NULL, 'G3DSA:2.40.30.10:FF:000034', NULL, NULL, 'Flavohemoprotein', NULL, NULL, NULL, NULL, NULL, 4),
(229220, NULL, 'G3DSA:1.25.10.10:FF:002094', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229221, NULL, 'G3DSA:1.25.40.10:FF:003568', NULL, NULL, 'WD40 domain-containing protein', NULL, NULL, NULL, NULL, NULL, 4),
(229222, NULL, 'G3DSA:3.30.565.10:FF:000094', NULL, NULL, 'Ethylene receptor', NULL, NULL, NULL, NULL, NULL, 4),
(229223, NULL, 'G3DSA:3.30.505.10:FF:000219', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(229224, NULL, 'G3DSA:3.90.550.50:FF:000103', NULL, NULL, 'Glycoprotein-N-acetylgalactosamine 3-beta-galactosyltransferase 1', NULL, NULL, NULL, NULL, NULL, 4),
(229225, NULL, 'G3DSA:1.10.3730.20:FF:000072', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229226, NULL, 'G3DSA:3.30.70.330:FF:000431', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein C', NULL, NULL, NULL, NULL, NULL, 4),
(229227, NULL, 'G3DSA:3.20.20.70:FF:000746', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(229228, NULL, 'G3DSA:3.60.15.10:FF:000220', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229229, NULL, 'G3DSA:1.10.3380.30:FF:000024', NULL, NULL, 'ATP-dependent DEAD/H RNA helicase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(229230, NULL, 'G3DSA:1.25.40.10:FF:002606', NULL, NULL, 'Zinc finger, C3H1-type-containing', NULL, NULL, NULL, NULL, NULL, 4),
(229231, NULL, 'G3DSA:1.25.10.10:FF:002436', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229232, NULL, 'G3DSA:1.10.472.10:FF:000143', NULL, NULL, 'Yin', NULL, NULL, NULL, NULL, NULL, 4),
(229233, NULL, 'G3DSA:3.30.1540.20:FF:000011', NULL, NULL, 'Mlh3p', NULL, NULL, NULL, NULL, NULL, 4),
(229234, NULL, 'G3DSA:1.25.10.10:FF:000295', NULL, NULL, 'Exportin-T', NULL, NULL, NULL, NULL, NULL, 4),
(229235, NULL, 'G3DSA:3.30.1050.10:FF:000032', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229236, NULL, 'G3DSA:1.10.1410.40:FF:000002', NULL, NULL, 'protein mab-21-like 1', NULL, NULL, NULL, NULL, NULL, 4),
(229237, NULL, 'G3DSA:2.40.50.690:FF:000014', NULL, NULL, 'Probable exosome complex exonuclease RRP44', NULL, NULL, NULL, NULL, NULL, 4),
(229238, NULL, 'G3DSA:1.10.1320.10:FF:000014', NULL, NULL, 'DNA-directed RNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(229239, NULL, 'G3DSA:3.40.50.720:FF:001823', NULL, NULL, 'Homospermidine synthase', NULL, NULL, NULL, NULL, NULL, 4),
(229240, NULL, 'G3DSA:3.30.420.40:FF:000626', NULL, NULL, 'Actin 12', NULL, NULL, NULL, NULL, NULL, 4),
(229241, NULL, 'G3DSA:1.10.8.60:FF:000477', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229242, NULL, 'G3DSA:1.10.1450.10:FF:000018', NULL, NULL, 'Tetraspanin', NULL, NULL, NULL, NULL, NULL, 4),
(229243, NULL, 'G3DSA:2.60.40.10:FF:000707', NULL, NULL, 'Obscurin, cytoskeletal calmodulin and titin-interacting RhoGEF', NULL, NULL, NULL, NULL, NULL, 4),
(229244, NULL, 'G3DSA:3.40.50.300:FF:007200', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(229245, NULL, 'G3DSA:2.60.40.1180:FF:000214', NULL, NULL, 'Maltase-glucoamylase', NULL, NULL, NULL, NULL, NULL, 4),
(229246, NULL, 'G3DSA:1.20.1110.10:FF:000255', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(229247, NULL, 'G3DSA:2.60.40.1180:FF:000091', NULL, NULL, 'Chromosome 1, whole genome shotgun sequence', NULL, NULL, NULL, NULL, NULL, 4),
(229248, NULL, 'G3DSA:3.40.50.10260:FF:000035', NULL, NULL, 'NAD(P)H-hydrate epimerase', NULL, NULL, NULL, NULL, NULL, 4),
(229249, NULL, 'G3DSA:2.60.40.150:FF:000054', NULL, NULL, 'otoferlin isoform X2', NULL, NULL, NULL, NULL, NULL, 4);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(229250, NULL, 'G3DSA:3.40.50.1000:FF:000226', NULL, NULL, 'Cation transporting ATPase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(229251, NULL, 'G3DSA:3.40.630.10:FF:000300', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229252, NULL, 'G3DSA:2.10.110.10:FF:000052', NULL, NULL, 'Four and a half LIM domains 1', NULL, NULL, NULL, NULL, NULL, 4),
(229253, NULL, 'G3DSA:2.60.40.10:FF:004075', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(229254, NULL, 'G3DSA:3.40.50.920:FF:000023', NULL, NULL, '1-deoxy-D-xylulose-5-phosphate synthase', NULL, NULL, NULL, NULL, NULL, 4),
(229255, NULL, 'G3DSA:3.30.470.30:FF:000008', NULL, NULL, 'DNA ligase', NULL, NULL, NULL, NULL, NULL, 4),
(229256, NULL, 'G3DSA:1.10.10.580:FF:000023', NULL, NULL, 'double-strand-break repair protein rad21 homolog', NULL, NULL, NULL, NULL, NULL, 4),
(229257, NULL, 'G3DSA:3.50.50.100:FF:000062', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229258, NULL, 'G3DSA:3.30.1490.40:FF:000006', NULL, NULL, 'Eukaryotic translation initiation factor subunit eIF2A, putative', NULL, NULL, NULL, NULL, NULL, 4),
(229259, NULL, 'G3DSA:3.40.140.10:FF:000088', NULL, NULL, 'Cytidine deaminase, putative', NULL, NULL, NULL, NULL, NULL, 4),
(229260, NULL, 'G3DSA:2.130.10.10:FF:004384', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229261, NULL, 'G3DSA:2.60.40.10:FF:003799', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(229262, NULL, 'G3DSA:3.40.50.720:FF:001481', NULL, NULL, 'uncharacterized protein LOC100179743', NULL, NULL, NULL, NULL, NULL, 4),
(229263, NULL, 'G3DSA:1.10.510.10:FF:002492', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(229264, NULL, 'G3DSA:3.30.160.60:FF:000578', NULL, NULL, 'zinc finger protein 64 isoform X1', NULL, NULL, NULL, NULL, NULL, 4),
(229265, NULL, 'G3DSA:1.20.1250.20:FF:001476', NULL, NULL, 'Major Facilitator Superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(229266, NULL, 'G3DSA:1.25.50.20:FF:000076', NULL, NULL, 'Aminopeptidase', NULL, NULL, NULL, NULL, NULL, 4),
(229267, NULL, 'G3DSA:3.80.10.10:FF:003390', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229268, NULL, 'G3DSA:3.10.20.30:FF:000049', NULL, NULL, '2Fe-2S ferredoxin-like superfamily protein', NULL, NULL, NULL, NULL, NULL, 4),
(229269, NULL, 'G3DSA:3.40.50.2300:FF:001583', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(229270, NULL, 'G3DSA:3.30.160.60:FF:001995', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(229271, NULL, 'G3DSA:2.40.10.10:FF:000706', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(229272, NULL, 'G3DSA:1.20.5.110:FF:000298', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229273, NULL, 'G3DSA:2.80.10.50:FF:000245', NULL, NULL, 'Polypeptide N-acetylgalactosaminyltransferase', NULL, NULL, NULL, NULL, NULL, 4),
(229274, NULL, 'G3DSA:2.130.10.10:FF:001759', NULL, NULL, 'Atg21p', NULL, NULL, NULL, NULL, NULL, 4),
(229275, NULL, 'G3DSA:1.20.1270.280:FF:000028', NULL, NULL, 'Dynein heavy chain 6, axonemal', NULL, NULL, NULL, NULL, NULL, 4),
(229276, NULL, 'G3DSA:1.10.510.10:FF:002834', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(229277, NULL, 'G3DSA:1.10.472.10:FF:000704', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229278, NULL, 'G3DSA:1.10.287.3700:FF:000011', NULL, NULL, 'PAN3-like protein', NULL, NULL, NULL, NULL, NULL, 4),
(229279, NULL, 'G3DSA:1.20.5.320:FF:000012', NULL, NULL, '6-phosphogluconate dehydrogenase, decarboxylating', NULL, NULL, NULL, NULL, NULL, 4),
(229280, NULL, 'G3DSA:2.120.10.30:FF:000080', NULL, NULL, 'E3 ubiquitin-protein ligase TRIM71', NULL, NULL, NULL, NULL, NULL, 4),
(229281, NULL, 'G3DSA:2.30.30.40:FF:000223', NULL, NULL, 'Caspase recruitment domain family, member 14', NULL, NULL, NULL, NULL, NULL, 4),
(229282, NULL, 'G3DSA:1.10.10.10:FF:000126', NULL, NULL, 'MarR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(229283, NULL, 'G3DSA:1.20.1310.10:FF:000130', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(229284, NULL, 'G3DSA:3.40.50.300:FF:000399', NULL, NULL, 'YLP motif containing 1', NULL, NULL, NULL, NULL, NULL, 4),
(229285, NULL, 'G3DSA:1.10.10.60:FF:000663', NULL, NULL, 'GD19964', NULL, NULL, NULL, NULL, NULL, 4),
(229286, NULL, 'G3DSA:3.40.1110.10:FF:000485', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(229287, NULL, 'G3DSA:3.40.50.150:FF:000663', NULL, NULL, 'Alkylated DNA repair protein alkB 8', NULL, NULL, NULL, NULL, NULL, 4),
(229288, NULL, 'G3DSA:3.40.50.12390:FF:000005', NULL, NULL, '5''-3'' exoribonuclease 2', NULL, NULL, NULL, NULL, NULL, 4),
(229289, NULL, 'G3DSA:1.20.1440.230:FF:000007', NULL, NULL, 'NADH:ubiquinone oxidoreductase core subunit V1', NULL, NULL, NULL, NULL, NULL, 4),
(229290, NULL, 'G3DSA:3.30.560.10:FF:000009', NULL, NULL, 'Alcohol dehydrogenase', NULL, NULL, NULL, NULL, NULL, 4),
(229291, NULL, 'G3DSA:3.40.50.1170:FF:000001', NULL, NULL, 'L-asparaginase 2', NULL, NULL, NULL, NULL, NULL, 4),
(229292, NULL, 'G3DSA:3.30.530.20:FF:000174', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229293, NULL, 'G3DSA:1.25.40.430:FF:000013', NULL, NULL, 'BUB1 mitotic checkpoint serine/threonine kinase', NULL, NULL, NULL, NULL, NULL, 4),
(229294, NULL, 'G3DSA:3.40.50.300:FF:006705', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229295, NULL, 'G3DSA:3.60.15.10:FF:000107', NULL, NULL, 'DNA cross-link repair 1C', NULL, NULL, NULL, NULL, NULL, 4),
(229296, NULL, 'G3DSA:2.60.40.10:FF:000926', NULL, NULL, 'Interleukin 20 receptor subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(229297, NULL, 'G3DSA:3.40.640.10:FF:000126', NULL, NULL, 'Aminotransferase', NULL, NULL, NULL, NULL, NULL, 4),
(229298, NULL, 'G3DSA:1.10.150.240:FF:000063', NULL, NULL, 'Putative glycosyl hydrolase', NULL, NULL, NULL, NULL, NULL, 4),
(229299, NULL, 'G3DSA:3.30.420.40:FF:000065', NULL, NULL, 'N-acetylglucosamine repressor NagC', NULL, NULL, NULL, NULL, NULL, 4),
(229300, NULL, 'G3DSA:2.130.10.10:FF:002035', NULL, NULL, 'probable U3 small nucleolar RNA-associated protein 7', NULL, NULL, NULL, NULL, NULL, 4),
(229301, NULL, 'G3DSA:2.30.33.40:FF:000027', NULL, NULL, 'Os06g0197550 protein', NULL, NULL, NULL, NULL, NULL, 4),
(229302, NULL, 'G3DSA:3.40.800.10:FF:000004', NULL, NULL, 'Agmatinase', NULL, NULL, NULL, NULL, NULL, 4),
(229303, NULL, 'G3DSA:3.40.1550.10:FF:000012', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(229304, NULL, 'G3DSA:3.30.450.20:FF:000696', NULL, NULL, 'Energy taxis modulating methyl accepting sensory transducer with Cache_2 sensory domain', NULL, NULL, NULL, NULL, NULL, 4),
(229305, NULL, 'G3DSA:2.60.40.10:FF:000584', NULL, NULL, 'Cell surface glycoprotein CD200 receptor 1', NULL, NULL, NULL, NULL, NULL, 4),
(229306, NULL, 'G3DSA:1.10.10.10:FF:000345', NULL, NULL, 'Replication protein O', NULL, NULL, NULL, NULL, NULL, 4),
(229307, NULL, 'G3DSA:1.25.40.450:FF:000019', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229308, NULL, 'G3DSA:1.10.287.1970:FF:000003', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229309, NULL, 'G3DSA:2.60.40.10:FF:001202', NULL, NULL, 'PKHD1 like 1', NULL, NULL, NULL, NULL, NULL, 4),
(229310, NULL, 'G3DSA:1.10.472.10:FF:000362', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229311, NULL, 'G3DSA:3.30.70.1230:FF:000247', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(229312, NULL, 'G3DSA:2.60.120.10:FF:000772', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229313, NULL, 'G3DSA:2.30.42.10:FF:000112', NULL, NULL, 'inaD-like protein isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(229314, NULL, 'G3DSA:3.80.10.10:FF:002895', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229315, NULL, 'G3DSA:3.30.160.60:FF:002832', NULL, NULL, 'Weckle, isoform B', NULL, NULL, NULL, NULL, NULL, 4),
(229316, NULL, 'G3DSA:1.10.630.10:FF:000758', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229317, NULL, 'G3DSA:2.60.40.1730:FF:000076', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(229318, NULL, 'G3DSA:2.40.30.10:FF:000253', NULL, NULL, 'NADPH-cytochrome P450 reductase', NULL, NULL, NULL, NULL, NULL, 4),
(229319, NULL, 'G3DSA:3.10.100.10:FF:000132', NULL, NULL, 'Intimin', NULL, NULL, NULL, NULL, NULL, 4),
(229320, NULL, 'G3DSA:1.10.510.10:FF:003110', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(229321, NULL, 'G3DSA:1.10.1420.10:FF:000180', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229322, NULL, 'G3DSA:2.40.10.10:FF:000364', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(229323, NULL, 'G3DSA:3.90.1600.10:FF:000033', NULL, NULL, 'DNA polymerase', NULL, NULL, NULL, NULL, NULL, 4),
(229324, NULL, 'G3DSA:3.40.50.300:FF:002434', NULL, NULL, 'ATP-dependent RNA helicase SUV3, putative', NULL, NULL, NULL, NULL, NULL, 4),
(229325, NULL, 'G3DSA:3.40.50.720:FF:001149', NULL, NULL, '2-dehydropantoate 2-reductase', NULL, NULL, NULL, NULL, NULL, 4),
(229326, NULL, 'G3DSA:1.20.140.40:FF:000042', NULL, NULL, 'Invertase/pectin methylesterase inhibitor family protein', NULL, NULL, NULL, NULL, NULL, 4),
(229327, NULL, 'G3DSA:3.40.190.290:FF:000083', NULL, NULL, 'LysR family transcriptional regulator', NULL, NULL, NULL, NULL, NULL, 4),
(229328, NULL, 'G3DSA:1.10.510.10:FF:002273', NULL, NULL, 'Eukaryotic protein kinase', NULL, NULL, NULL, NULL, NULL, 4),
(229329, NULL, 'G3DSA:1.25.40.20:FF:000811', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229330, NULL, 'G3DSA:1.20.5.340:FF:000018', NULL, NULL, 'Mitochondrial protein FMP32', NULL, NULL, NULL, NULL, NULL, 4),
(229331, NULL, 'G3DSA:3.30.1360.10:FF:000022', NULL, NULL, 'DNA-directed RNA polymerase subunit alpha', NULL, NULL, NULL, NULL, NULL, 4),
(229332, NULL, 'G3DSA:3.10.120.10:FF:000021', NULL, NULL, 'Delta(8)-fatty-acid desaturase 2', NULL, NULL, NULL, NULL, NULL, 4),
(229333, NULL, 'G3DSA:3.30.160.60:FF:002490', NULL, NULL, 'Krueppel protein', NULL, NULL, NULL, NULL, NULL, 4),
(229334, NULL, 'G3DSA:3.80.10.10:FF:003732', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229335, NULL, 'G3DSA:3.30.420.40:FF:000407', NULL, NULL, 'Heat shock protein 70, putative', NULL, NULL, NULL, NULL, NULL, 4),
(229336, NULL, 'G3DSA:2.130.10.10:FF:005469', NULL, NULL, 'WD repeat domain 90', NULL, NULL, NULL, NULL, NULL, 4),
(229337, NULL, 'G3DSA:2.60.40.10:FF:004294', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 4),
(229338, NULL, 'G3DSA:2.10.25.10:FF:001158', NULL, NULL, 'Crumbs cell polarity complex component 1', NULL, NULL, NULL, NULL, NULL, 4),
(229339, NULL, 'G3DSA:1.20.1280.20:FF:000011', NULL, NULL, 'DNaJ domain (Prokaryotic heat shock protein)', NULL, NULL, NULL, NULL, NULL, 4),
(229340, NULL, 'G3DSA:3.30.200.20:FF:002217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229341, NULL, 'G3DSA:1.10.510.10:FF:001997', NULL, NULL, 'Serine/threonine-protein kinase PEPKR2', NULL, NULL, NULL, NULL, NULL, 4),
(229342, NULL, 'G3DSA:3.40.50.300:FF:001017', NULL, NULL, 'Phosphonate C-P lyase system protein PhnK', NULL, NULL, NULL, NULL, NULL, 4),
(229343, NULL, 'G3DSA:1.20.1550.10:FF:000001', NULL, NULL, 'Disulfide bond formation protein B', NULL, NULL, NULL, NULL, NULL, 4),
(229344, NULL, 'G3DSA:1.25.10.10:FF:002217', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229345, NULL, 'G3DSA:1.10.418.10:FF:000085', NULL, NULL, 'protein-methionine sulfoxide oxidase Mical isoform X3', NULL, NULL, NULL, NULL, NULL, 4),
(229346, NULL, 'G3DSA:1.10.287.1270:FF:000001', NULL, NULL, 'G protein-coupled receptor kinase', NULL, NULL, NULL, NULL, NULL, 4),
(229347, NULL, 'G3DSA:3.40.1160.10:FF:000089', NULL, NULL, 'Predicted protein', NULL, NULL, NULL, NULL, NULL, 4),
(229348, NULL, 'G3DSA:2.70.170.10:FF:000216', NULL, NULL, 'Uncharacterized protein', NULL, NULL, NULL, NULL, NULL, 4),
(229349, NULL, 'G3DSA:1.10.287.4300', NULL, NULL, NULL, NULL, '', NULL, NULL, 31890, 5),
(229350, NULL, 'G3DSA:6.10.250.2300', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229351, NULL, 'G3DSA:3.30.360.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(229352, NULL, 'G3DSA:3.30.1490.360', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229353, NULL, 'G3DSA:3.30.428.40', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF3067', NULL, NULL, NULL, 5),
(229354, NULL, 'G3DSA:6.20.420.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229355, NULL, 'G3DSA:3.30.1490.480', NULL, NULL, NULL, NULL, 'Endolytic murein transglycosylase', NULL, NULL, NULL, 5),
(229356, NULL, 'G3DSA:3.30.160.340', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229357, NULL, 'G3DSA:1.10.10.1530', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229358, NULL, 'G3DSA:3.30.70.370', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229359, NULL, 'G3DSA:3.30.565.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 32916, 5),
(229360, NULL, 'G3DSA:2.60.120.400', NULL, NULL, NULL, NULL, '', NULL, NULL, 29591, 5),
(229361, NULL, 'G3DSA:1.10.287.1060', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229362, NULL, 'G3DSA:1.10.246.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229363, NULL, 'G3DSA:2.30.160.11', NULL, NULL, NULL, NULL, '', NULL, NULL, 35923, 5),
(229364, NULL, 'G3DSA:2.60.40.1570', NULL, NULL, NULL, NULL, 'Dr adhesin', NULL, NULL, 27451, 5),
(229365, NULL, 'G3DSA:3.40.50.10440', NULL, NULL, NULL, NULL, 'Dihydroxyacetone kinase; domain 1', NULL, NULL, NULL, 5),
(229366, NULL, 'G3DSA:2.40.30.230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229367, NULL, 'G3DSA:2.10.80.10', NULL, NULL, NULL, NULL, 'Lipase, subunit A', NULL, NULL, NULL, 5),
(229368, NULL, 'G3DSA:3.30.70.1020', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229369, NULL, 'G3DSA:1.10.490.20', NULL, NULL, NULL, NULL, 'Phycocyanins', NULL, NULL, 32661, 5),
(229370, NULL, 'G3DSA:2.60.40.3460', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229371, NULL, 'G3DSA:2.40.128.680', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229372, NULL, 'G3DSA:3.90.1720.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229373, NULL, 'G3DSA:3.30.1490.440', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229374, NULL, 'G3DSA:1.10.3050.10', NULL, NULL, NULL, NULL, 'borna disease virus nucleoprotein, domain 2', NULL, NULL, 9011, 5),
(229375, NULL, 'G3DSA:2.70.70.10', NULL, NULL, NULL, NULL, 'Glucose Permease (Domain IIA)', NULL, NULL, 9063, 5),
(229376, NULL, 'G3DSA:3.60.130.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 35937, 5),
(229377, NULL, 'G3DSA:1.20.140.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229378, NULL, 'G3DSA:6.10.280.250', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229379, NULL, 'G3DSA:1.20.1270.190', NULL, NULL, NULL, NULL, '', NULL, NULL, 33934, 5),
(229380, NULL, 'G3DSA:2.60.500.10', NULL, NULL, NULL, NULL, 'Surface Active Protein domain', NULL, NULL, 31038, 5),
(229381, NULL, 'G3DSA:1.10.1200.80', NULL, NULL, NULL, NULL, 'Putative flavin oxidoreducatase; domain 2', NULL, NULL, 18881, 5),
(229382, NULL, 'G3DSA:2.40.40.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229383, NULL, 'G3DSA:1.20.150.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 29717, 5),
(229384, NULL, 'G3DSA:1.10.8.860', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229385, NULL, 'G3DSA:3.40.140.10', NULL, NULL, NULL, NULL, 'Cytidine Deaminase, domain 2', NULL, NULL, NULL, 5),
(229386, NULL, 'G3DSA:3.30.1370.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 31480, 5),
(229387, NULL, 'G3DSA:6.10.250.1670', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229388, NULL, 'G3DSA:2.20.28.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229389, NULL, 'G3DSA:6.10.250.1750', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229390, NULL, 'G3DSA:2.60.40.2990', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229391, NULL, 'G3DSA:6.10.250.1590', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229392, NULL, 'G3DSA:6.10.250.1830', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229393, NULL, 'G3DSA:3.30.70.3550', NULL, NULL, NULL, NULL, '', NULL, NULL, 36837, 5),
(229394, NULL, 'G3DSA:4.10.91.10', NULL, NULL, NULL, NULL, 'Cytochrome c oxidase, subunit VIIa', NULL, NULL, 33414, 5);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(229395, NULL, 'G3DSA:4.10.80.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229396, NULL, 'G3DSA:3.10.450.300', NULL, NULL, NULL, NULL, '', NULL, NULL, 30708, 5),
(229397, NULL, 'G3DSA:1.10.10.1080', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229398, NULL, 'G3DSA:1.20.58.790', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229399, NULL, 'G3DSA:6.10.330.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229400, NULL, 'G3DSA:3.30.110.170', NULL, NULL, NULL, NULL, 'Protein of unknown function (DUF541), domain 1', NULL, NULL, NULL, 5),
(229401, NULL, 'G3DSA:3.40.50.10820', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229402, NULL, 'G3DSA:1.10.10.1450', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229403, NULL, 'G3DSA:3.30.160.180', NULL, NULL, NULL, NULL, '', NULL, NULL, 27766, 5),
(229404, NULL, 'G3DSA:2.60.40.1300', NULL, NULL, NULL, NULL, '', NULL, NULL, 31100, 5),
(229405, NULL, 'G3DSA:3.30.70.3180', NULL, NULL, NULL, NULL, '', NULL, NULL, 27287, 5),
(229406, NULL, 'G3DSA:3.20.20.300', NULL, NULL, NULL, NULL, '', NULL, NULL, 28148, 5),
(229407, NULL, 'G3DSA:1.10.10.500', NULL, NULL, NULL, NULL, '', NULL, NULL, 28353, 5),
(229408, NULL, 'G3DSA:1.10.3920.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 26562, 5),
(229409, NULL, 'G3DSA:1.10.287.1140', NULL, NULL, NULL, NULL, '', NULL, NULL, 29808, 5),
(229410, NULL, 'G3DSA:6.10.250.2220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229411, NULL, 'G3DSA:2.60.120.320', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229412, NULL, 'G3DSA:3.30.450.180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229413, NULL, 'G3DSA:2.60.40.3380', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229414, NULL, 'G3DSA:3.40.50.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 24758, 5),
(229415, NULL, 'G3DSA:2.60.40.3700', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229416, NULL, 'G3DSA:3.30.450.340', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229417, NULL, 'G3DSA:3.40.50.1760', NULL, NULL, NULL, NULL, '', NULL, NULL, 28363, 5),
(229418, NULL, 'G3DSA:2.60.98.20', NULL, NULL, NULL, NULL, 'Flagellar hook protein FlgE', NULL, NULL, 29511, 5),
(229419, NULL, 'G3DSA:1.10.1140.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 18845, 5),
(229420, NULL, 'G3DSA:1.10.3980.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229421, NULL, 'G3DSA:3.30.40.150', NULL, NULL, NULL, NULL, '', NULL, NULL, 36332, 5),
(229422, NULL, 'G3DSA:1.25.40.440', NULL, NULL, NULL, NULL, 'Nucleoporin, helical domain, central subdomain', NULL, NULL, 34523, 5),
(229423, NULL, 'G3DSA:3.50.30.80', NULL, NULL, NULL, NULL, '', NULL, NULL, 30949, 5),
(229424, NULL, 'G3DSA:2.60.120.1390', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229425, NULL, 'G3DSA:2.40.490.10', NULL, NULL, NULL, NULL, 'Newcastle disease virus like domain', NULL, NULL, NULL, 5),
(229426, NULL, 'G3DSA:6.10.250.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229427, NULL, 'G3DSA:1.10.287.890', NULL, NULL, NULL, NULL, 'Crystal structure of tRNA isopentenylpyrophosphate transferase (bh2366) domain', NULL, NULL, NULL, 5),
(229428, NULL, 'G3DSA:2.10.80.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229429, NULL, 'G3DSA:4.10.1000.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229430, NULL, 'G3DSA:3.30.1680.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229431, NULL, 'G3DSA:1.20.120.1920', NULL, NULL, NULL, NULL, 'UBAP1 SOUBA domain', NULL, NULL, 34181, 5),
(229432, NULL, 'G3DSA:1.20.58.1970', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229433, NULL, 'G3DSA:3.90.1480.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229434, NULL, 'G3DSA:2.20.25.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229435, NULL, 'G3DSA:3.40.1120.10', NULL, NULL, NULL, NULL, 'Ribosomal protein l15e', NULL, NULL, 23305, 5),
(229436, NULL, 'G3DSA:6.10.250.320', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5),
(229437, NULL, 'G3DSA:3.90.340.10', NULL, NULL, NULL, NULL, 'Nitric Oxide Synthase; Chain A, domain 1', NULL, NULL, 34146, 5);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(229438, NULL, 'G3DSA:3.30.2330.10', NULL, NULL, NULL, NULL, 'arginine biosynthesis bifunctional protein suprefamily', NULL, NULL, NULL, 5),
(229439, NULL, 'G3DSA:1.10.287.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229440, NULL, 'G3DSA:3.90.70.50', NULL, NULL, NULL, NULL, 'Peptidase C10, streptopain', NULL, NULL, 34531, 5),
(229441, NULL, 'G3DSA:3.40.50.11000', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229442, NULL, 'G3DSA:3.90.870.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229443, NULL, 'G3DSA:3.40.1690.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229444, NULL, 'G3DSA:2.60.40.290', NULL, NULL, NULL, NULL, '', NULL, NULL, 13619, 5),
(229445, NULL, 'G3DSA:3.40.1520.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31695, 5),
(229446, NULL, 'G3DSA:3.30.70.610', NULL, NULL, NULL, NULL, '', NULL, NULL, 11934, 5),
(229447, NULL, 'G3DSA:3.100.10.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229448, NULL, 'G3DSA:3.30.310.100', NULL, NULL, NULL, NULL, '', NULL, NULL, 31472, 5),
(229449, NULL, 'G3DSA:1.10.870.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29892, 5),
(229450, NULL, 'G3DSA:3.40.630.180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229451, NULL, 'G3DSA:6.10.250.2060', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229452, NULL, 'G3DSA:3.30.1200.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32994, 5),
(229453, NULL, 'G3DSA:1.10.10.1290', NULL, NULL, NULL, NULL, '', NULL, NULL, 30235, 5),
(229454, NULL, 'G3DSA:3.90.440.10', NULL, NULL, NULL, NULL, 'Nitric Oxide Synthase;Heme Domain;Chain A domain 2', NULL, NULL, 34382, 5),
(229455, NULL, 'G3DSA:1.20.5.1180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229456, NULL, 'G3DSA:1.10.150.250', NULL, NULL, NULL, NULL, 'Flavinator of succinate dehydrogenase', NULL, NULL, 31719, 5),
(229457, NULL, 'G3DSA:4.10.260.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 35245, 5),
(229458, NULL, 'G3DSA:1.10.287.1350', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229459, NULL, 'G3DSA:3.30.160.710', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229460, NULL, 'G3DSA:2.60.40.3830', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229461, NULL, 'G3DSA:3.40.1820.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229462, NULL, 'G3DSA:3.40.1390.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229463, NULL, 'G3DSA:3.30.1450.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31833, 5),
(229464, NULL, 'G3DSA:1.20.1270.350', NULL, NULL, NULL, NULL, '', NULL, NULL, 35898, 5),
(229465, NULL, 'G3DSA:1.20.58.870', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229466, NULL, 'G3DSA:1.20.1270.430', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229467, NULL, 'G3DSA:3.90.1670.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 12108, 5),
(229468, NULL, 'G3DSA:2.50.10.10', NULL, NULL, NULL, NULL, 'Bacteriochlorophyll A', NULL, NULL, 33314, 5),
(229469, NULL, 'G3DSA:1.20.120.1020', NULL, NULL, NULL, NULL, '', NULL, NULL, 28988, 5),
(229470, NULL, 'G3DSA:1.10.10.1900', NULL, NULL, NULL, NULL, '', NULL, NULL, 36167, 5),
(229471, NULL, 'G3DSA:1.20.225.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 34075, 5),
(229472, NULL, 'G3DSA:3.30.70.660', NULL, NULL, NULL, NULL, '', NULL, NULL, 16199, 5),
(229473, NULL, 'G3DSA:2.40.128.150', NULL, NULL, NULL, NULL, 'Cysteine proteinases', NULL, NULL, NULL, 5),
(229474, NULL, 'G3DSA:2.70.20.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 37235, 5),
(229475, NULL, 'G3DSA:6.10.250.2010', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229476, NULL, 'G3DSA:1.10.8.490', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229477, NULL, 'G3DSA:2.60.40.3090', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229478, NULL, 'G3DSA:3.90.260.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31682, 5),
(229479, NULL, 'G3DSA:3.30.420.410', NULL, NULL, NULL, NULL, '', NULL, NULL, 30113, 5),
(229480, NULL, 'G3DSA:2.170.190.11', NULL, NULL, NULL, NULL, 'Molybdopterin biosynthesis moea protein, domain 3.', NULL, NULL, NULL, 5),
(229481, NULL, 'G3DSA:6.20.230.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(229482, NULL, 'G3DSA:1.10.1200.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 8768, 5),
(229483, NULL, 'G3DSA:2.20.25.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229484, NULL, 'G3DSA:3.30.800.10', NULL, NULL, NULL, NULL, 'Phosphatidylinositol Phosphate Kinase II Beta', NULL, NULL, 26948, 5),
(229485, NULL, 'G3DSA:6.10.250.1910', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229486, NULL, 'G3DSA:2.170.130.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29626, 5),
(229487, NULL, 'G3DSA:3.90.930.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229488, NULL, 'G3DSA:2.30.290.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 11920, 5),
(229489, NULL, 'G3DSA:1.20.890.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229490, NULL, 'G3DSA:6.20.290.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229491, NULL, 'G3DSA:6.10.250.1460', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229492, NULL, 'G3DSA:1.25.10.30', NULL, NULL, NULL, NULL, 'IP3 receptor type 1 binding core, RIH domain', NULL, NULL, NULL, 5),
(229493, NULL, 'G3DSA:1.10.8.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229494, NULL, 'G3DSA:3.30.1990.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229495, NULL, 'G3DSA:6.10.250.2510', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229496, NULL, 'G3DSA:3.30.470.140', NULL, NULL, NULL, NULL, '', NULL, NULL, 37729, 5),
(229497, NULL, 'G3DSA:3.40.50.10160', NULL, NULL, NULL, NULL, '', NULL, NULL, 29554, 5),
(229498, NULL, 'G3DSA:1.10.420.10', NULL, NULL, NULL, NULL, 'Peroxidase, domain 2', NULL, NULL, NULL, 5),
(229499, NULL, 'G3DSA:1.10.287.510', NULL, NULL, NULL, NULL, 'Helix hairpin bin', NULL, NULL, NULL, 5),
(229500, NULL, 'G3DSA:1.10.8.210', NULL, NULL, NULL, NULL, 'Sirohaem synthase, dimerisation domain', NULL, NULL, 28470, 5),
(229501, NULL, 'G3DSA:6.10.250.2140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229502, NULL, 'G3DSA:3.10.20.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229503, NULL, 'G3DSA:3.40.140.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 37052, 5),
(229504, NULL, 'G3DSA:1.10.287.1270', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229505, NULL, 'G3DSA:1.10.8.730', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229506, NULL, 'G3DSA:4.10.650.10', NULL, NULL, NULL, NULL, 'Metallothionein domain superfamily, yeast', NULL, NULL, 28236, 5),
(229507, NULL, 'G3DSA:1.10.8.1220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229508, NULL, 'G3DSA:1.10.287.760', NULL, NULL, NULL, NULL, '', NULL, NULL, 17330, 5),
(229509, NULL, 'G3DSA:1.10.220.110', NULL, NULL, NULL, NULL, 'GDNF binding domain', NULL, NULL, NULL, 5),
(229510, NULL, 'G3DSA:1.10.274.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229511, NULL, 'G3DSA:2.40.30.310', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229512, NULL, 'G3DSA:3.40.50.10900', NULL, NULL, NULL, NULL, '', NULL, NULL, 27306, 5),
(229513, NULL, 'G3DSA:1.20.58.2070', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229514, NULL, 'G3DSA:2.40.10.480', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229515, NULL, 'G3DSA:1.10.260.200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229516, NULL, 'G3DSA:3.10.330.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229517, NULL, 'G3DSA:3.40.140.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 12495, 5),
(229518, NULL, 'G3DSA:1.20.5.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229519, NULL, 'G3DSA:3.30.1140.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 32128, 5),
(229520, NULL, 'G3DSA:3.30.920.80', NULL, NULL, NULL, NULL, '', NULL, NULL, 32057, 5),
(229521, NULL, 'G3DSA:6.10.250.240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229522, NULL, 'G3DSA:2.60.120.670', NULL, NULL, NULL, NULL, 'Minor capsid protein.', NULL, NULL, 32711, 5),
(229523, NULL, 'G3DSA:3.30.2210.10', NULL, NULL, NULL, NULL, 'Integron cassette protein superfamily', NULL, NULL, NULL, 5),
(229524, NULL, 'G3DSA:2.60.40.1630', NULL, NULL, NULL, NULL, 'bacillus anthracis domain', NULL, NULL, NULL, 5),
(229525, NULL, 'G3DSA:1.10.357.20', NULL, NULL, NULL, NULL, 'SLC41 divalent cation transporters, integral membrane domain', NULL, NULL, 31583, 5);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(229526, NULL, 'G3DSA:2.30.18.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 6384, 5),
(229527, NULL, 'G3DSA:3.30.2010.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229528, NULL, 'G3DSA:1.10.439.10', NULL, NULL, NULL, NULL, 'Penicillin Amidohydrolase, domain 1', NULL, NULL, 15616, 5),
(229529, NULL, 'G3DSA:4.10.1120.10', NULL, NULL, NULL, NULL, 'Retinal cGMP phosphodiesterase, gamma subunit', NULL, NULL, 27400, 5),
(229530, NULL, 'G3DSA:3.80.30.20', NULL, NULL, NULL, NULL, 'tm_1862 like domain', NULL, NULL, 16142, 5),
(229531, NULL, 'G3DSA:1.20.1440.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 27591, 5),
(229532, NULL, 'G3DSA:1.20.5.4130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229533, NULL, 'G3DSA:4.10.220.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229534, NULL, 'G3DSA:6.10.250.1620', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229535, NULL, 'G3DSA:3.30.1120.120', NULL, NULL, NULL, NULL, '', NULL, NULL, 37755, 5),
(229536, NULL, 'G3DSA:1.20.1650.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229537, NULL, 'G3DSA:2.60.40.4220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229538, NULL, 'G3DSA:6.20.240.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229539, NULL, 'G3DSA:3.90.1170.10', NULL, NULL, NULL, NULL, 'Ribosomal protein L10e/L16', NULL, NULL, 32501, 5),
(229540, NULL, 'G3DSA:1.25.40.890', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229541, NULL, 'G3DSA:6.10.280.120', NULL, NULL, NULL, NULL, '', NULL, NULL, 35128, 5),
(229542, NULL, 'G3DSA:3.30.1280.10', NULL, NULL, NULL, NULL, 'Phosphoribosylformylglycinamidine synthase subunit PurS', NULL, NULL, 32729, 5),
(229543, NULL, 'G3DSA:1.20.1370.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229544, NULL, 'G3DSA:3.30.70.1320', NULL, NULL, NULL, NULL, 'Multidrug efflux transporter AcrB pore domain like', NULL, NULL, NULL, 5),
(229545, NULL, 'G3DSA:1.20.82.10', NULL, NULL, NULL, NULL, 'ADP Ribosyl Cyclase; Chain A, domain 1', NULL, NULL, NULL, 5),
(229546, NULL, 'G3DSA:3.30.390.80', NULL, NULL, NULL, NULL, 'DNA repair protein Rad52/59/22', NULL, NULL, 37161, 5),
(229547, NULL, 'G3DSA:2.70.98.100', NULL, NULL, NULL, NULL, '', NULL, NULL, 37079, 5),
(229548, NULL, 'G3DSA:3.90.215.10', NULL, NULL, NULL, NULL, 'Gamma Fibrinogen, chain A, domain 1', NULL, NULL, 18336, 5),
(229549, NULL, 'G3DSA:3.30.160.390', NULL, NULL, NULL, NULL, '', NULL, NULL, 32950, 5),
(229550, NULL, 'G3DSA:2.60.40.1760', NULL, NULL, NULL, NULL, 'glycosyl hydrolase (family 31)', NULL, NULL, NULL, 5),
(229551, NULL, 'G3DSA:4.10.1130.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229552, NULL, 'G3DSA:3.40.190.120', NULL, NULL, NULL, NULL, 'Osmoprotection protein (prox); domain 2', NULL, NULL, NULL, 5),
(229553, NULL, 'G3DSA:3.40.1010.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229554, NULL, 'G3DSA:3.30.70.1750', NULL, NULL, NULL, NULL, 'Uncharacterised protein PF11491, DUF3213', NULL, NULL, NULL, 5),
(229555, NULL, 'G3DSA:3.30.67.10', NULL, NULL, NULL, NULL, 'Viral Envelope Glycoprotein, domain 2', NULL, NULL, 7744, 5),
(229556, NULL, 'G3DSA:3.40.50.10320', NULL, NULL, NULL, NULL, '', NULL, NULL, 18518, 5),
(229557, NULL, 'G3DSA:2.20.28.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229558, NULL, 'G3DSA:3.30.1010.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229559, NULL, 'G3DSA:1.20.120.690', NULL, NULL, NULL, NULL, 'RDM1 protein domain', NULL, NULL, 27960, 5),
(229560, NULL, 'G3DSA:2.70.210.12', NULL, NULL, NULL, NULL, 'GTP1/OBG domain', NULL, NULL, 31592, 5),
(229561, NULL, 'G3DSA:2.40.30.100', NULL, NULL, NULL, NULL, '', NULL, NULL, 29961, 5),
(229562, NULL, 'G3DSA:4.10.80.400', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229563, NULL, 'G3DSA:3.40.50.2020', NULL, NULL, NULL, NULL, '', NULL, NULL, 24733, 5),
(229564, NULL, 'G3DSA:4.10.40.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 32469, 5),
(229565, NULL, 'G3DSA:3.40.50.10870', NULL, NULL, NULL, NULL, 'Glycosyl hydrolase family 3', NULL, NULL, NULL, 5),
(229566, NULL, 'G3DSA:6.10.250.1540', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(229567, NULL, 'G3DSA:1.20.5.290', NULL, NULL, NULL, NULL, 'Phospholamban', NULL, NULL, NULL, 5),
(229568, NULL, 'G3DSA:1.20.120.1310', NULL, NULL, NULL, NULL, '', NULL, NULL, 36017, 5),
(229569, NULL, 'G3DSA:3.30.450.390', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229570, NULL, 'G3DSA:2.60.40.3330', NULL, NULL, NULL, NULL, '', NULL, NULL, 32276, 5),
(229571, NULL, 'G3DSA:1.10.950.10', NULL, NULL, NULL, NULL, 'Villin headpiece domain', NULL, NULL, 28546, 5),
(229572, NULL, 'G3DSA:3.30.10.30', NULL, NULL, NULL, NULL, 'DYRK', NULL, NULL, 37144, 5),
(229573, NULL, 'G3DSA:3.20.20.70', NULL, NULL, NULL, NULL, 'Aldolase class I', NULL, NULL, 11456, 5),
(229574, NULL, 'G3DSA:2.30.30.980', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229575, NULL, 'G3DSA:3.40.190.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229576, NULL, 'G3DSA:3.30.62.10', NULL, NULL, NULL, NULL, 'Nef Regulatory Factor', NULL, NULL, 24125, 5),
(229577, NULL, 'G3DSA:2.20.25.210', NULL, NULL, NULL, NULL, 'Hepatitis C NS5A, domain 1B', NULL, NULL, 30063, 5),
(229578, NULL, 'G3DSA:4.10.740.10', NULL, NULL, NULL, NULL, 'Coagulation Factor IX', NULL, NULL, 17442, 5),
(229579, NULL, 'G3DSA:6.10.250.1880', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229580, NULL, 'G3DSA:3.30.497.10', NULL, NULL, NULL, NULL, 'Antithrombin, subunit I, domain 2', NULL, NULL, 34997, 5),
(229581, NULL, 'G3DSA:2.60.40.2860', NULL, NULL, NULL, NULL, '', NULL, NULL, 30525, 5),
(229582, NULL, 'G3DSA:6.10.280.200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229583, NULL, 'G3DSA:3.30.160.210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229584, NULL, 'G3DSA:6.10.250.1700', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229585, NULL, 'G3DSA:1.10.286.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 10626, 5),
(229586, NULL, 'G3DSA:3.40.50.410', NULL, NULL, NULL, NULL, 'von Willebrand factor, type A domain', NULL, NULL, 29607, 5),
(229587, NULL, 'G3DSA:1.20.5.1760', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229588, NULL, 'G3DSA:1.20.58.670', NULL, NULL, NULL, NULL, 'Dsl1p vesicle tethering complex, Tip20p subunit, domain D', NULL, NULL, 30157, 5),
(229589, NULL, 'G3DSA:3.10.410.10', NULL, NULL, NULL, NULL, 'Formyltetrahydrofolate synthetase, domain 3', NULL, NULL, NULL, 5),
(229590, NULL, 'G3DSA:6.10.140.300', NULL, NULL, NULL, NULL, '', NULL, NULL, 33951, 5),
(229591, NULL, 'G3DSA:1.10.10.2130', NULL, NULL, NULL, NULL, '', NULL, NULL, 30141, 5),
(229592, NULL, 'G3DSA:3.55.50.50', NULL, NULL, NULL, NULL, 'Baseplate protein Gp16, domain 2', NULL, NULL, 35040, 5),
(229593, NULL, 'G3DSA:3.90.25.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229594, NULL, 'G3DSA:3.30.70.1370', NULL, NULL, NULL, NULL, 'HD domain like', NULL, NULL, NULL, 5),
(229595, NULL, 'G3DSA:1.10.287.30', NULL, NULL, NULL, NULL, 'E2 (early) protein, N terminal domain, subdomain 1', NULL, NULL, 36889, 5),
(229596, NULL, 'G3DSA:3.30.2350.20', NULL, NULL, NULL, NULL, 'TruD, catalytic domain', NULL, NULL, 35127, 5),
(229597, NULL, 'G3DSA:3.30.40.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229598, NULL, 'G3DSA:1.10.10.180', NULL, NULL, NULL, NULL, '', NULL, NULL, 7569, 5),
(229599, NULL, 'G3DSA:3.40.5.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229600, NULL, 'G3DSA:3.30.60.90', NULL, NULL, NULL, NULL, '', NULL, NULL, 35097, 5),
(229601, NULL, 'G3DSA:1.10.1390.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 16012, 5),
(229602, NULL, 'G3DSA:3.50.30.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229603, NULL, 'G3DSA:1.10.132.110', NULL, NULL, NULL, NULL, 'Serum amyloid A protein', NULL, NULL, NULL, 5),
(229604, NULL, 'G3DSA:3.90.930.20', NULL, NULL, NULL, NULL, 'Small outer capsid protein Soc', NULL, NULL, 32993, 5),
(229605, NULL, 'G3DSA:1.10.10.1820', NULL, NULL, NULL, NULL, '', NULL, NULL, 30841, 5),
(229606, NULL, 'G3DSA:1.10.8.650', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229607, NULL, 'G3DSA:2.60.120.1180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229608, NULL, 'G3DSA:1.10.287.3700', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(229609, NULL, 'G3DSA:2.40.128.470', NULL, NULL, NULL, NULL, '', NULL, NULL, 29576, 5),
(229610, NULL, 'G3DSA:1.10.1580.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 11406, 5),
(229611, NULL, 'G3DSA:3.55.50.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229612, NULL, 'G3DSA:3.30.1910.10', NULL, NULL, NULL, NULL, 'so0334 like domain', NULL, NULL, NULL, 5),
(229613, NULL, 'G3DSA:2.40.10.350', NULL, NULL, NULL, NULL, '', NULL, NULL, 34932, 5),
(229614, NULL, 'G3DSA:3.30.1640.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229615, NULL, 'G3DSA:1.10.530.50', NULL, NULL, NULL, NULL, 'Peptidase U40', NULL, NULL, 31482, 5),
(229616, NULL, 'G3DSA:1.10.8.1190', NULL, NULL, NULL, NULL, '', NULL, NULL, 34627, 5),
(229617, NULL, 'G3DSA:2.40.50.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229618, NULL, 'G3DSA:1.20.5.5100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229619, NULL, 'G3DSA:2.60.40.4140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229620, NULL, 'G3DSA:6.10.250.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229621, NULL, 'G3DSA:1.10.1900.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229622, NULL, 'G3DSA:3.30.230.60', NULL, NULL, NULL, NULL, '', NULL, NULL, 29537, 5),
(229623, NULL, 'G3DSA:2.60.200.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229624, NULL, 'G3DSA:3.30.70.1980', NULL, NULL, NULL, NULL, 'Uncharacterised protein PF09406, DUF2004', NULL, NULL, NULL, 5),
(229625, NULL, 'G3DSA:2.60.40.1140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229626, NULL, 'G3DSA:3.30.1830.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229627, NULL, 'G3DSA:2.60.40.4300', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229628, NULL, 'G3DSA:2.40.30.280', NULL, NULL, NULL, NULL, '', NULL, NULL, 29514, 5),
(229629, NULL, 'G3DSA:2.40.37.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 35041, 5),
(229630, NULL, 'G3DSA:3.40.50.11210', NULL, NULL, NULL, NULL, '', NULL, NULL, 18179, 5),
(229631, NULL, 'G3DSA:3.30.420.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29012, 5),
(229632, NULL, 'G3DSA:3.30.780.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229633, NULL, 'G3DSA:2.30.130.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229634, NULL, 'G3DSA:3.30.720.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229635, NULL, 'G3DSA:3.30.1490.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 19656, 5),
(229636, NULL, 'G3DSA:2.60.240.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 33542, 5),
(229637, NULL, 'G3DSA:1.20.58.2150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229638, NULL, 'G3DSA:3.30.460.10', NULL, NULL, NULL, NULL, 'Beta Polymerase, domain 2', NULL, NULL, 35189, 5),
(229639, NULL, 'G3DSA:2.60.120.710', NULL, NULL, NULL, NULL, 'Toxoplasma gondii micronemal protein 1 TgMIC1', NULL, NULL, 33557, 5),
(229640, NULL, 'G3DSA:2.30.36.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229641, NULL, 'G3DSA:6.10.250.2800', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229642, NULL, 'G3DSA:2.20.25.180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229643, NULL, 'G3DSA:6.10.250.530', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229644, NULL, 'G3DSA:3.90.105.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229645, NULL, 'G3DSA:3.10.20.310', NULL, NULL, NULL, NULL, 'membrane protein fhac', NULL, NULL, NULL, 5),
(229646, NULL, 'G3DSA:3.30.70.790', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229647, NULL, 'G3DSA:3.90.100.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229648, NULL, 'G3DSA:3.10.180.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229649, NULL, 'G3DSA:3.30.70.3340', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229650, NULL, 'G3DSA:2.130.10.80', NULL, NULL, NULL, NULL, '', NULL, NULL, 32572, 5),
(229651, NULL, 'G3DSA:2.40.128.390', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229652, NULL, 'G3DSA:2.60.40.3170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229653, NULL, 'G3DSA:1.20.120.1150', NULL, NULL, NULL, NULL, '', NULL, NULL, 34817, 5);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(229654, NULL, 'G3DSA:2.60.40.1220', NULL, NULL, NULL, NULL, '', NULL, NULL, 8076, 5),
(229655, NULL, 'G3DSA:3.30.2410.10', NULL, NULL, NULL, NULL, 'Hect, E3 ligase catalytic domain', NULL, NULL, NULL, 5),
(229656, NULL, 'G3DSA:1.10.287.2110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229657, NULL, 'G3DSA:2.40.380.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29540, 5),
(229658, NULL, 'G3DSA:1.10.575.10', NULL, NULL, NULL, NULL, 'P1 Nuclease', NULL, NULL, 8509, 5),
(229659, NULL, 'G3DSA:1.10.8.1060', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229660, NULL, 'G3DSA:1.10.1810.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31366, 5),
(229661, NULL, 'G3DSA:1.10.10.2270', NULL, NULL, NULL, NULL, 'Dsl1p vesicle tethering complex, Tip20p subunit, domain E', NULL, NULL, 30343, 5),
(229662, NULL, 'G3DSA:3.40.50.11420', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229663, NULL, 'G3DSA:2.60.40.1270', NULL, NULL, NULL, NULL, '', NULL, NULL, 26794, 5),
(229664, NULL, 'G3DSA:1.10.1240.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229665, NULL, 'G3DSA:1.10.10.790', NULL, NULL, NULL, NULL, 'Surp module', NULL, NULL, 29568, 5),
(229666, NULL, 'G3DSA:3.30.60.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229667, NULL, 'G3DSA:3.40.1570.10', NULL, NULL, NULL, NULL, 'HemS/ChuS/ChuX like domains', NULL, NULL, NULL, 5),
(229668, NULL, 'G3DSA:1.20.120.1100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229669, NULL, 'G3DSA:1.20.1270.220', NULL, NULL, NULL, NULL, '', NULL, NULL, 32550, 5),
(229670, NULL, 'G3DSA:1.10.12.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 34953, 5),
(229671, NULL, 'G3DSA:2.60.40.3120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229672, NULL, 'G3DSA:3.40.50.1970', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229673, NULL, 'G3DSA:6.10.20.140', NULL, NULL, NULL, NULL, '50S ribosomal protein L1; Chain A, Domain 1', NULL, NULL, NULL, 5),
(229674, NULL, 'G3DSA:3.40.109.30', NULL, NULL, NULL, NULL, 'putative nitroreductase (tm1586), domain 2', NULL, NULL, NULL, 5),
(229675, NULL, 'G3DSA:2.60.175.20', NULL, NULL, NULL, NULL, 'Major capsid L1 (late) superfamily, Papillomavirus', NULL, NULL, 30424, 5),
(229676, NULL, 'G3DSA:4.10.1180.10', NULL, NULL, NULL, NULL, 'tm1086 domain', NULL, NULL, 36192, 5),
(229677, NULL, 'G3DSA:4.10.81.10', NULL, NULL, NULL, NULL, 'Cytochrome c oxidase, subunit 8', NULL, NULL, 33254, 5),
(229678, NULL, 'G3DSA:1.10.10.390', NULL, NULL, NULL, NULL, '', NULL, NULL, 7092, 5),
(229679, NULL, 'G3DSA:3.10.20.570', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF3248', NULL, NULL, NULL, 5),
(229680, NULL, 'G3DSA:6.10.140.220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229681, NULL, 'G3DSA:1.20.120.1230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229682, NULL, 'G3DSA:3.10.20.840', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229683, NULL, 'G3DSA:2.60.40.3200', NULL, NULL, NULL, NULL, 'Alphavirus E2 glycoprotein, A domain', NULL, NULL, 35277, 5),
(229684, NULL, 'G3DSA:3.30.450.280', NULL, NULL, NULL, NULL, 'GAF domain', NULL, NULL, 31081, 5),
(229685, NULL, 'G3DSA:2.40.170.10', NULL, NULL, NULL, NULL, 'Porin, LamB type', NULL, NULL, 28257, 5),
(229686, NULL, 'G3DSA:1.20.1460.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229687, NULL, 'G3DSA:1.10.140.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 16298, 5),
(229688, NULL, 'G3DSA:1.10.10.2050', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229689, NULL, 'G3DSA:1.20.1270.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 25934, 5),
(229690, NULL, 'G3DSA:6.10.140.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229691, NULL, 'G3DSA:3.90.870.10', NULL, NULL, NULL, NULL, 'DHBP synthase', NULL, NULL, NULL, 5),
(229692, NULL, 'G3DSA:2.60.40.2940', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229693, NULL, 'G3DSA:6.20.50.150', NULL, NULL, NULL, NULL, '', NULL, NULL, 29664, 5),
(229694, NULL, 'G3DSA:1.20.5.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229695, NULL, 'G3DSA:3.60.10.10', NULL, NULL, NULL, NULL, 'Endonuclease/exonuclease/phosphatase', NULL, NULL, 31435, 5);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(229696, NULL, 'G3DSA:3.10.20.890', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229697, NULL, 'G3DSA:1.10.150.490', NULL, NULL, NULL, NULL, 'Retroviral GAG p10 protein', NULL, NULL, 31785, 5),
(229698, NULL, 'G3DSA:3.90.56.20', NULL, NULL, NULL, NULL, 'replication protein C, winged helix domain', NULL, NULL, NULL, 5),
(229699, NULL, 'G3DSA:1.20.5.1890', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229700, NULL, 'G3DSA:3.10.310.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229701, NULL, 'G3DSA:1.25.40.970', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229702, NULL, 'G3DSA:3.40.190.290', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229703, NULL, 'G3DSA:3.10.129.150', NULL, NULL, NULL, NULL, 'Domain of unknown function (DUF5070)', NULL, NULL, NULL, 5),
(229704, NULL, 'G3DSA:3.30.450.420', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229705, NULL, 'G3DSA:2.60.40.3250', NULL, NULL, NULL, NULL, '', NULL, NULL, 29875, 5),
(229706, NULL, 'G3DSA:3.40.950.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229707, NULL, 'G3DSA:2.60.120.1260', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229708, NULL, 'G3DSA:3.20.100.30', NULL, NULL, NULL, NULL, 'VTC, catalytic tunnel domain', NULL, NULL, 34042, 5),
(229709, NULL, 'G3DSA:1.20.1270.270', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229710, NULL, 'G3DSA:2.60.300.12', NULL, NULL, NULL, NULL, '', NULL, NULL, 7447, 5),
(229711, NULL, 'G3DSA:1.10.10.1740', NULL, NULL, NULL, NULL, '', NULL, NULL, 36338, 5),
(229712, NULL, 'G3DSA:1.10.10.1060', NULL, NULL, NULL, NULL, 'Catalase HPII, helical domain', NULL, NULL, NULL, 5),
(229713, NULL, 'G3DSA:3.30.40.230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229714, NULL, 'G3DSA:3.30.70.1440', NULL, NULL, NULL, NULL, 'Multidrug efflux transporter AcrB pore domain', NULL, NULL, NULL, 5),
(229715, NULL, 'G3DSA:1.20.5.2020', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229716, NULL, 'G3DSA:2.30.29.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229717, NULL, 'G3DSA:1.10.287.180', NULL, NULL, NULL, NULL, '', NULL, NULL, 33459, 5),
(229718, NULL, 'G3DSA:1.10.1490.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229719, NULL, 'G3DSA:3.30.56.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 32543, 5),
(229720, NULL, 'G3DSA:3.40.50.11340', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229721, NULL, 'G3DSA:1.10.287.1130', NULL, NULL, NULL, NULL, 'CytochromE C oxidase copper chaperone', NULL, NULL, NULL, 5),
(229722, NULL, 'G3DSA:3.30.2310.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 32013, 5),
(229723, NULL, 'G3DSA:1.10.287.1010', NULL, NULL, NULL, NULL, '', NULL, NULL, 23585, 5),
(229724, NULL, 'G3DSA:1.10.10.1540', NULL, NULL, NULL, NULL, 'Costar domain', NULL, NULL, 29550, 5),
(229725, NULL, 'G3DSA:3.30.1120.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229726, NULL, 'G3DSA:2.60.120.280', NULL, NULL, NULL, NULL, 'Regulatory protein AraC', NULL, NULL, NULL, 5),
(229727, NULL, 'G3DSA:2.40.128.340', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229728, NULL, 'G3DSA:3.30.2220.10', NULL, NULL, NULL, NULL, 'rbstp2171', NULL, NULL, NULL, 5),
(229729, NULL, 'G3DSA:3.10.180.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229730, NULL, 'G3DSA:1.20.1660.10', NULL, NULL, NULL, NULL, 'Hypothetical protein (EF3068)', NULL, NULL, NULL, 5),
(229731, NULL, 'G3DSA:1.10.8.520', NULL, NULL, NULL, NULL, '', NULL, NULL, 34346, 5),
(229732, NULL, 'G3DSA:2.40.10.270', NULL, NULL, NULL, NULL, '', NULL, NULL, 33802, 5),
(229733, NULL, 'G3DSA:3.30.2300.10', NULL, NULL, NULL, NULL, 'THUMP superfamily', NULL, NULL, NULL, 5),
(229734, NULL, 'G3DSA:3.40.50.10240', NULL, NULL, NULL, NULL, 'Thiamin pyrophosphokinase, catalytic domain', NULL, NULL, 32229, 5),
(229735, NULL, 'G3DSA:1.10.8.1010', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229736, NULL, 'G3DSA:3.30.60.160', NULL, NULL, NULL, NULL, '', NULL, NULL, 32206, 5),
(229737, NULL, 'G3DSA:1.20.5.3790', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229738, NULL, 'G3DSA:2.40.500.10', NULL, NULL, NULL, NULL, 'Upper collar protein gp10 (connector protein)', NULL, NULL, NULL, 5);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(229739, NULL, 'G3DSA:1.10.132.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229740, NULL, 'G3DSA:3.30.70.3420', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229741, NULL, 'G3DSA:1.20.930.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229742, NULL, 'G3DSA:1.10.2080.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28945, 5),
(229743, NULL, 'G3DSA:1.20.58.2230', NULL, NULL, NULL, NULL, '', NULL, NULL, 31447, 5),
(229744, NULL, 'G3DSA:3.30.430.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 31405, 5),
(229745, NULL, 'G3DSA:3.40.50.620', NULL, NULL, NULL, NULL, 'HUPs', NULL, NULL, 13013, 5),
(229746, NULL, 'G3DSA:3.30.56.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229747, NULL, 'G3DSA:3.30.66.10', NULL, NULL, NULL, NULL, 'DNA topoisomerase I domain', NULL, NULL, 20167, 5),
(229748, NULL, 'G3DSA:2.130.10.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 6147, 5),
(229749, NULL, 'G3DSA:2.40.320.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229750, NULL, 'G3DSA:6.10.250.450', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229751, NULL, 'G3DSA:6.10.250.2720', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5),
(229752, NULL, 'G3DSA:3.10.310.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229753, NULL, 'G3DSA:1.10.132.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 29926, 5),
(229754, NULL, 'G3DSA:3.20.20.370', NULL, NULL, NULL, NULL, 'Glycoside hydrolase/deacetylase', NULL, NULL, NULL, 5),
(229755, NULL, 'G3DSA:3.30.1550.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33007, 5),
(229756, NULL, 'G3DSA:1.10.287.260', NULL, NULL, NULL, NULL, '', NULL, NULL, 18585, 5),
(229757, NULL, 'G3DSA:1.10.520.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229758, NULL, 'G3DSA:1.10.10.620', NULL, NULL, NULL, NULL, 'ribosome modulation factor like domain', NULL, NULL, 17060, 5),
(229759, NULL, 'G3DSA:6.10.20.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229760, NULL, 'G3DSA:1.20.120.1420', NULL, NULL, NULL, NULL, 'LntA helical domain', NULL, NULL, 36467, 5),
(229761, NULL, 'G3DSA:4.10.430.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29836, 5),
(229762, NULL, 'G3DSA:3.40.50.12190', NULL, NULL, NULL, NULL, '', NULL, NULL, 32054, 5),
(229763, NULL, 'G3DSA:3.90.740.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 9808, 5),
(229764, NULL, 'G3DSA:3.30.43.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229765, NULL, 'G3DSA:1.10.274.110', NULL, NULL, NULL, NULL, '', NULL, NULL, 31902, 5),
(229766, NULL, 'G3DSA:2.30.29.200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229767, NULL, 'G3DSA:2.60.40.4350', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229768, NULL, 'G3DSA:2.60.40.2730', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229769, NULL, 'G3DSA:6.10.140.890', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229770, NULL, 'G3DSA:6.10.250.3110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229771, NULL, 'G3DSA:6.10.140.970', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229772, NULL, 'G3DSA:2.60.40.4270', NULL, NULL, NULL, NULL, '', NULL, NULL, 36125, 5),
(229773, NULL, 'G3DSA:1.25.40.760', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229774, NULL, 'G3DSA:3.40.50.12800', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229775, NULL, 'G3DSA:1.10.10.2420', NULL, NULL, NULL, NULL, '', NULL, NULL, 35193, 5),
(229776, NULL, 'G3DSA:3.30.2450.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229777, NULL, 'G3DSA:1.10.287.1770', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229778, NULL, 'G3DSA:3.30.200.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 9172, 5),
(229779, NULL, 'G3DSA:3.90.20.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229780, NULL, 'G3DSA:6.10.230.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229781, NULL, 'G3DSA:2.60.60.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229782, NULL, 'G3DSA:1.20.81.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 30103, 5),
(229783, NULL, 'G3DSA:1.10.10.2260', NULL, NULL, NULL, NULL, '', NULL, NULL, 30494, 5),
(229784, NULL, 'G3DSA:6.10.140.510', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(229785, NULL, 'G3DSA:1.20.58.1180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229786, NULL, 'G3DSA:2.60.40.4310', NULL, NULL, NULL, NULL, 'Alphavirus E2 glycoprotein, domain B', NULL, NULL, 35130, 5),
(229787, NULL, 'G3DSA:3.20.14.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 27142, 5),
(229788, NULL, 'G3DSA:6.10.280.80', NULL, NULL, NULL, NULL, 'NCX, peripheral helical region', NULL, NULL, NULL, 5),
(229789, NULL, 'G3DSA:2.60.120.580', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229790, NULL, 'G3DSA:6.20.370.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229791, NULL, 'G3DSA:6.10.140.1770', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229792, NULL, 'G3DSA:1.20.120.1600', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229793, NULL, 'G3DSA:2.30.30.930', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229794, NULL, 'G3DSA:3.30.160.370', NULL, NULL, NULL, NULL, 'Domain of unknown function DUF5064', NULL, NULL, NULL, 5),
(229795, NULL, 'G3DSA:4.10.770.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 25540, 5),
(229796, NULL, 'G3DSA:1.20.1110.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229797, NULL, 'G3DSA:3.30.65.10', NULL, NULL, NULL, NULL, 'Bacterial Topoisomerase I, domain 1', NULL, NULL, NULL, 5),
(229798, NULL, 'G3DSA:3.10.450.720', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229799, NULL, 'G3DSA:1.25.40.1030', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229800, NULL, 'G3DSA:1.20.120.1440', NULL, NULL, NULL, NULL, '', NULL, NULL, 36389, 5),
(229801, NULL, 'G3DSA:1.10.10.760', NULL, NULL, NULL, NULL, '', NULL, NULL, 34001, 5),
(229802, NULL, 'G3DSA:2.40.128.510', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF4738', NULL, NULL, NULL, 5),
(229803, NULL, 'G3DSA:2.60.120.1130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229804, NULL, 'G3DSA:3.30.1370.210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229805, NULL, 'G3DSA:1.10.110.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229806, NULL, 'G3DSA:3.30.720.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229807, NULL, 'G3DSA:1.10.8.600', NULL, NULL, NULL, NULL, '', NULL, NULL, 29772, 5),
(229808, NULL, 'G3DSA:1.20.5.620', NULL, NULL, NULL, NULL, 'F1F0 ATP synthase subunit B, membrane domain', NULL, NULL, NULL, 5),
(229809, NULL, 'G3DSA:1.20.5.970', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229810, NULL, 'G3DSA:2.60.120.740', NULL, NULL, NULL, NULL, '', NULL, NULL, 34242, 5),
(229811, NULL, 'G3DSA:1.20.1270.110', NULL, NULL, NULL, NULL, 'Uncharacterised protein family UPF0058', NULL, NULL, 32713, 5),
(229812, NULL, 'G3DSA:4.10.1040.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31691, 5),
(229813, NULL, 'G3DSA:1.20.58.190', NULL, NULL, NULL, NULL, 'Translin; domain 1', NULL, NULL, 10386, 5),
(229814, NULL, 'G3DSA:2.30.130.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229815, NULL, 'G3DSA:1.10.720.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229816, NULL, 'G3DSA:3.30.1890.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229817, NULL, 'G3DSA:6.10.140.350', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229818, NULL, 'G3DSA:6.10.10.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229819, NULL, 'G3DSA:1.20.120.940', NULL, NULL, NULL, NULL, '', NULL, NULL, 28792, 5),
(229820, NULL, 'G3DSA:4.10.81.20', NULL, NULL, NULL, NULL, 'KCNMB2, ball/chain domain', NULL, NULL, 32873, 5),
(229821, NULL, 'G3DSA:3.30.56.130', NULL, NULL, NULL, NULL, 'Transcriptional regulator CtsR, winged HTH domain', NULL, NULL, 30072, 5),
(229822, NULL, 'G3DSA:2.30.30.1160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229823, NULL, 'G3DSA:3.10.450.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229824, NULL, 'G3DSA:3.40.50.11260', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229825, NULL, 'G3DSA:3.90.1410.10', NULL, NULL, NULL, NULL, 'set domain protein methyltransferase, domain 1', NULL, NULL, NULL, 5),
(229826, NULL, 'G3DSA:2.60.40.1190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229827, NULL, 'G3DSA:3.40.50.1370', NULL, NULL, NULL, NULL, 'Aspartate/ornithine carbamoyltransferase', NULL, NULL, 31611, 5);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(229828, NULL, 'G3DSA:3.30.530.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 16429, 5),
(229829, NULL, 'G3DSA:2.100.10.20', NULL, NULL, NULL, NULL, 'Vitelline membrane outer layer protein I (VOMI)', NULL, NULL, 31612, 5),
(229830, NULL, 'G3DSA:1.10.530.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229831, NULL, 'G3DSA:2.60.40.3000', NULL, NULL, NULL, NULL, 'Pestivirus envelope glycoprotein E2, domain B', NULL, NULL, 35358, 5),
(229832, NULL, 'G3DSA:2.40.160.210', NULL, NULL, NULL, NULL, '', NULL, NULL, 35005, 5),
(229833, NULL, 'G3DSA:3.30.1490.100', NULL, NULL, NULL, NULL, '', NULL, NULL, 31791, 5),
(229834, NULL, 'G3DSA:3.40.50.450', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229835, NULL, 'G3DSA:3.90.176.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229836, NULL, 'G3DSA:2.30.30.310', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229837, NULL, 'G3DSA:3.30.590.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229838, NULL, 'G3DSA:3.20.20.410', NULL, NULL, NULL, NULL, 'Protein of unknown function UPF0759', NULL, NULL, 32629, 5),
(229839, NULL, 'G3DSA:1.20.58.960', NULL, NULL, NULL, NULL, 'Protein of unknown function (DUF3120)', NULL, NULL, 31075, 5),
(229840, NULL, 'G3DSA:3.10.25.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229841, NULL, 'G3DSA:1.10.3420.10', NULL, NULL, NULL, NULL, 'putative ntp pyrophosphohydrolase like domain', NULL, NULL, 20999, 5),
(229842, NULL, 'G3DSA:2.30.30.90', NULL, NULL, NULL, NULL, '', NULL, NULL, 30795, 5),
(229843, NULL, 'G3DSA:3.30.230.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 18557, 5),
(229844, NULL, 'G3DSA:2.40.10.180', NULL, NULL, NULL, NULL, 'Phage tail proteins', NULL, NULL, NULL, 5),
(229845, NULL, 'G3DSA:1.10.287.690', NULL, NULL, NULL, NULL, 'Helix hairpin bin', NULL, NULL, NULL, 5),
(229846, NULL, 'G3DSA:2.30.36.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229847, NULL, 'G3DSA:4.10.1190.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 34263, 5),
(229848, NULL, 'G3DSA:1.20.5.540', NULL, NULL, NULL, NULL, 'Single helix bin', NULL, NULL, NULL, 5),
(229849, NULL, 'G3DSA:3.90.1510.10', NULL, NULL, NULL, NULL, 'Glycerate kinase, domain 2', NULL, NULL, 19854, 5),
(229850, NULL, 'G3DSA:1.20.1220.20', NULL, NULL, NULL, NULL, 'Uncharcterised protein PF01724', NULL, NULL, NULL, 5),
(229851, NULL, 'G3DSA:1.20.58.820', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229852, NULL, 'G3DSA:3.30.70.2530', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229853, NULL, 'G3DSA:6.10.250.370', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229854, NULL, 'G3DSA:1.10.150.770', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229855, NULL, 'G3DSA:3.90.1530.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229856, NULL, 'G3DSA:1.20.1280.30', NULL, NULL, NULL, NULL, 'Methane monooxygenase, gamma chain, domain 2', NULL, NULL, 8180, 5),
(229857, NULL, 'G3DSA:2.30.31.10', NULL, NULL, NULL, NULL, 'Transcriptional Coactivator Pc4; Chain A', NULL, NULL, 12413, 5),
(229858, NULL, 'G3DSA:2.60.40.3040', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229859, NULL, 'G3DSA:1.10.238.80', NULL, NULL, NULL, NULL, '', NULL, NULL, 27745, 5),
(229860, NULL, 'G3DSA:1.20.5.300', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229861, NULL, 'G3DSA:3.40.30.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229862, NULL, 'G3DSA:6.10.140.1600', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229863, NULL, 'G3DSA:2.40.30.150', NULL, NULL, NULL, NULL, 'Bacteriophage T4, Gp27, baseplate hub, domain 3', NULL, NULL, 34687, 5),
(229864, NULL, 'G3DSA:3.90.940.40', NULL, NULL, NULL, NULL, 'Protein CHLORORESPIRATORY REDUCTION 7', NULL, NULL, 32715, 5),
(229865, NULL, 'G3DSA:1.20.920.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229866, NULL, 'G3DSA:3.10.390.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 10218, 5),
(229867, NULL, 'G3DSA:1.25.40.390', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229868, NULL, 'G3DSA:3.30.560.10', NULL, NULL, NULL, NULL, 'Glucose Oxidase, domain 3', NULL, NULL, NULL, 5);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(229869, NULL, 'G3DSA:2.20.28.230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229870, NULL, 'G3DSA:1.20.58.1470', NULL, NULL, NULL, NULL, '', NULL, NULL, 31301, 5),
(229871, NULL, 'G3DSA:3.90.640.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229872, NULL, 'G3DSA:4.10.900.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 25832, 5),
(229873, NULL, 'G3DSA:1.20.5.350', NULL, NULL, NULL, NULL, '', NULL, NULL, 31556, 5),
(229874, NULL, 'G3DSA:2.30.30.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229875, NULL, 'G3DSA:6.10.250.1120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229876, NULL, 'G3DSA:2.170.260.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229877, NULL, 'G3DSA:3.40.30.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 33616, 5),
(229878, NULL, 'G3DSA:3.90.550.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229879, NULL, 'G3DSA:1.10.10.1950', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229880, NULL, 'G3DSA:2.30.30.560', NULL, NULL, NULL, NULL, '', NULL, NULL, 34514, 5),
(229881, NULL, 'G3DSA:1.20.1250.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 28507, 5),
(229882, NULL, 'G3DSA:1.20.120.490', NULL, NULL, NULL, NULL, '', NULL, NULL, 18789, 5),
(229883, NULL, 'G3DSA:3.90.1150.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229884, NULL, 'G3DSA:2.60.120.1420', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229885, NULL, 'G3DSA:3.40.50.11550', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229886, NULL, 'G3DSA:3.30.70.600', NULL, NULL, NULL, NULL, 'Ribosomal protein S10 domain', NULL, NULL, 27802, 5),
(229887, NULL, 'G3DSA:1.20.5.160', NULL, NULL, NULL, NULL, 'Bacterial aa3 type cytochrome c oxidase subunit IV', NULL, NULL, 32021, 5),
(229888, NULL, 'G3DSA:6.10.250.1170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229889, NULL, 'G3DSA:3.30.1360.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33789, 5),
(229890, NULL, 'G3DSA:3.30.2140.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229891, NULL, 'G3DSA:1.20.120.1810', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229892, NULL, 'G3DSA:6.10.140.1980', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229893, NULL, 'G3DSA:3.30.70.1360', NULL, NULL, NULL, NULL, '', NULL, NULL, 31774, 5),
(229894, NULL, 'G3DSA:3.10.20.180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229895, NULL, 'G3DSA:1.20.1280.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 32083, 5),
(229896, NULL, 'G3DSA:1.20.120.160', NULL, NULL, NULL, NULL, 'HPT domain', NULL, NULL, 28021, 5),
(229897, NULL, 'G3DSA:1.10.1060.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229898, NULL, 'G3DSA:3.30.1740.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28265, 5),
(229899, NULL, 'G3DSA:3.30.70.2130', NULL, NULL, NULL, NULL, 'Metalloenzyme domain', NULL, NULL, 35417, 5),
(229900, NULL, 'G3DSA:1.20.5.790', NULL, NULL, NULL, NULL, 'Single helix bin', NULL, NULL, NULL, 5),
(229901, NULL, 'G3DSA:6.10.140.1930', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229902, NULL, 'G3DSA:3.90.132.10', NULL, NULL, NULL, NULL, 'Leishmanolysin , domain 2', NULL, NULL, NULL, 5),
(229903, NULL, 'G3DSA:3.30.70.2580', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229904, NULL, 'G3DSA:2.40.50.860', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229905, NULL, 'G3DSA:1.10.10.920', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229906, NULL, 'G3DSA:3.10.520.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 4299, 5),
(229907, NULL, 'G3DSA:1.10.287.4270', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229908, NULL, 'G3DSA:6.20.20.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229909, NULL, 'G3DSA:3.30.70.1600', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229910, NULL, 'G3DSA:1.10.3370.10', NULL, NULL, NULL, NULL, 'SecY subunit domain', NULL, NULL, 17309, 5),
(229911, NULL, 'G3DSA:3.30.300.220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229912, NULL, 'G3DSA:1.20.120.530', NULL, NULL, NULL, NULL, '', NULL, NULL, 8714, 5),
(229913, NULL, 'G3DSA:2.90.10.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(229914, NULL, 'G3DSA:2.40.50.610', NULL, NULL, NULL, NULL, '', NULL, NULL, 35257, 5),
(229915, NULL, 'G3DSA:6.10.250.990', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229916, NULL, 'G3DSA:3.90.1150.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 31098, 5),
(229917, NULL, 'G3DSA:2.60.40.1850', NULL, NULL, NULL, NULL, '', NULL, NULL, 28911, 5),
(229918, NULL, 'G3DSA:1.20.1280.270', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229919, NULL, 'G3DSA:2.40.50.240', NULL, NULL, NULL, NULL, '', NULL, NULL, 18964, 5),
(229920, NULL, 'G3DSA:2.60.40.2110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229921, NULL, 'G3DSA:3.10.580.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 34341, 5),
(229922, NULL, 'G3DSA:3.40.50.11500', NULL, NULL, NULL, NULL, '', NULL, NULL, 37408, 5),
(229923, NULL, 'G3DSA:4.10.640.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229924, NULL, 'G3DSA:1.10.630.10', NULL, NULL, NULL, NULL, 'Cytochrome P450', NULL, NULL, 28905, 5),
(229925, NULL, 'G3DSA:6.10.140.680', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229926, NULL, 'G3DSA:2.20.25.680', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229927, NULL, 'G3DSA:1.10.1040.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 11005, 5),
(229928, NULL, 'G3DSA:3.40.91.90', NULL, NULL, NULL, NULL, '', NULL, NULL, 32565, 5),
(229929, NULL, 'G3DSA:1.10.8.360', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229930, NULL, 'G3DSA:2.60.40.1800', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229931, NULL, 'G3DSA:3.40.580.10', NULL, NULL, NULL, NULL, 'Eco RI Endonuclease, subunit A', NULL, NULL, 13940, 5),
(229932, NULL, 'G3DSA:2.30.230.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 12935, 5),
(229933, NULL, 'G3DSA:3.40.1230.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 27872, 5),
(229934, NULL, 'G3DSA:2.170.120.12', NULL, NULL, NULL, NULL, '', NULL, NULL, 29552, 5),
(229935, NULL, 'G3DSA:3.40.50.12480', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229936, NULL, 'G3DSA:3.30.70.1260', NULL, NULL, NULL, NULL, 'bacterial protein sp0830 like', NULL, NULL, NULL, 5),
(229937, NULL, 'G3DSA:3.90.480.10', NULL, NULL, NULL, NULL, 'Sulfite Reductase Hemoprotein;Domain 2', NULL, NULL, NULL, 5),
(229938, NULL, 'G3DSA:1.10.1790.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229939, NULL, 'G3DSA:1.10.287.2320', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229940, NULL, 'G3DSA:2.10.110.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229941, NULL, 'G3DSA:1.20.1440.170', NULL, NULL, NULL, NULL, '', NULL, NULL, 33199, 5),
(229942, NULL, 'G3DSA:2.40.50.290', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229943, NULL, 'G3DSA:6.10.250.2190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229944, NULL, 'G3DSA:3.40.1030.10', NULL, NULL, NULL, NULL, 'Nucleoside phosphorylase/phosphoribosyltransferase catalytic domain', NULL, NULL, 14454, 5),
(229945, NULL, 'G3DSA:1.10.240.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229946, NULL, 'G3DSA:2.40.128.500', NULL, NULL, NULL, NULL, '', NULL, NULL, 32665, 5),
(229947, NULL, 'G3DSA:3.30.2390.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229948, NULL, 'G3DSA:2.30.30.340', NULL, NULL, NULL, NULL, 'Hypothetical protein YfhH like domains', NULL, NULL, NULL, 5),
(229949, NULL, 'G3DSA:6.10.140.1310', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229950, NULL, 'G3DSA:2.20.25.630', NULL, NULL, NULL, NULL, '', NULL, NULL, 31288, 5),
(229951, NULL, 'G3DSA:6.10.20.60', NULL, NULL, NULL, NULL, 'PHD finger protein 12', NULL, NULL, 29976, 5),
(229952, NULL, 'G3DSA:3.40.50.12430', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229953, NULL, 'G3DSA:1.10.150.440', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229954, NULL, 'G3DSA:1.20.200.10', NULL, NULL, NULL, NULL, 'Fumarase/aspartase (Central domain)', NULL, NULL, NULL, 5),
(229955, NULL, 'G3DSA:1.10.3130.10', NULL, NULL, NULL, NULL, 'serine acetyltransferase, domain 1', NULL, NULL, 34815, 5),
(229956, NULL, 'G3DSA:3.30.30.60', NULL, NULL, NULL, NULL, '', NULL, NULL, 31614, 5),
(229957, NULL, 'G3DSA:6.10.250.660', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(229958, NULL, 'G3DSA:3.60.150.10', NULL, NULL, NULL, NULL, 'Chorismate synthase AroC', NULL, NULL, 10625, 5),
(229959, NULL, 'G3DSA:1.10.238.100', NULL, NULL, NULL, NULL, 'YAP1 redox domain. Chain B', NULL, NULL, NULL, 5),
(229960, NULL, 'G3DSA:3.10.310.10', NULL, NULL, NULL, NULL, 'Diaminopimelate Epimerase; Chain A, domain 1', NULL, NULL, NULL, 5),
(229961, NULL, 'G3DSA:1.20.1440.120', NULL, NULL, NULL, NULL, '', NULL, NULL, 33769, 5),
(229962, NULL, 'G3DSA:6.20.80.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229963, NULL, 'G3DSA:3.30.450.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 23298, 5),
(229964, NULL, 'G3DSA:4.10.690.10', NULL, NULL, NULL, NULL, 'Cricket Paralysis Virus, Vp4; Chain D', NULL, NULL, NULL, 5),
(229965, NULL, 'G3DSA:2.60.420.10', NULL, NULL, NULL, NULL, 'Maltose phosphorylase, domain 3', NULL, NULL, NULL, 5),
(229966, NULL, 'G3DSA:3.40.50.10950', NULL, NULL, NULL, NULL, '', NULL, NULL, 35585, 5),
(229967, NULL, 'G3DSA:3.40.140.100', NULL, NULL, NULL, NULL, '', NULL, NULL, 37369, 5),
(229968, NULL, 'G3DSA:1.20.1270.60', NULL, NULL, NULL, NULL, 'Arfaptin homology (AH) domain/BAR domain', NULL, NULL, 17289, 5),
(229969, NULL, 'G3DSA:1.20.58.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229970, NULL, 'G3DSA:1.10.60.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 15654, 5),
(229971, NULL, 'G3DSA:3.30.30.100', NULL, NULL, NULL, NULL, '', NULL, NULL, 31409, 5),
(229972, NULL, 'G3DSA:3.30.386.10', NULL, NULL, NULL, NULL, 'Chitosanase, subunit A, domain 2', NULL, NULL, 15574, 5),
(229973, NULL, 'G3DSA:1.10.8.400', NULL, NULL, NULL, NULL, 'Enoyl acyl carrier protein reductase', NULL, NULL, NULL, 5),
(229974, NULL, 'G3DSA:2.10.50.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229975, NULL, 'G3DSA:1.10.150.810', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229976, NULL, 'G3DSA:1.20.58.1400', NULL, NULL, NULL, NULL, 'Domain of unknown function DUF3837', NULL, NULL, 29759, 5),
(229977, NULL, 'G3DSA:6.10.250.610', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229978, NULL, 'G3DSA:1.20.58.520', NULL, NULL, NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, 5),
(229979, NULL, 'G3DSA:6.10.250.2560', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229980, NULL, 'G3DSA:3.30.2240.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229981, NULL, 'G3DSA:2.30.30.600', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229982, NULL, 'G3DSA:6.10.140.560', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229983, NULL, 'G3DSA:2.60.34.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 33519, 5),
(229984, NULL, 'G3DSA:2.20.70.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229985, NULL, 'G3DSA:2.60.40.3590', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229986, NULL, 'G3DSA:1.20.5.1500', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229987, NULL, 'G3DSA:3.40.570.10', NULL, NULL, NULL, NULL, 'Extracellular Endonuclease, subunit A', NULL, NULL, 36593, 5),
(229988, NULL, 'G3DSA:3.10.490.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229989, NULL, 'G3DSA:4.10.680.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29522, 5),
(229990, NULL, 'G3DSA:3.40.50.11050', NULL, NULL, NULL, NULL, '', NULL, NULL, 27412, 5),
(229991, NULL, 'G3DSA:3.40.50.960', NULL, NULL, NULL, NULL, 'Lumazine/riboflavin synthase', NULL, NULL, 29925, 5),
(229992, NULL, 'G3DSA:1.20.190.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229993, NULL, 'G3DSA:3.30.1490.310', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229994, NULL, 'G3DSA:2.40.10.430', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229995, NULL, 'G3DSA:1.10.1420.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229996, NULL, 'G3DSA:3.30.360.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229997, NULL, 'G3DSA:6.10.250.870', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(229998, NULL, 'G3DSA:2.40.10.300', NULL, NULL, NULL, NULL, 'Copper resistance protein K', NULL, NULL, 31044, 5),
(229999, NULL, 'G3DSA:1.10.10.2470', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230000, NULL, 'G3DSA:3.30.200.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(230001, NULL, 'G3DSA:3.30.300.100', NULL, NULL, NULL, NULL, '', NULL, NULL, 26887, 5),
(230002, NULL, 'G3DSA:3.60.160.10', NULL, NULL, NULL, NULL, 'Mitochondrial biogenesis AIM24', NULL, NULL, 31960, 5),
(230003, NULL, 'G3DSA:6.10.280.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230004, NULL, 'G3DSA:3.90.220.20', NULL, NULL, NULL, NULL, 'DNA methylase specificity domains', NULL, NULL, 36937, 5),
(230005, NULL, 'G3DSA:1.20.120.880', NULL, NULL, NULL, NULL, 'Histidine kinase (KinB), sensor domain', NULL, NULL, 28699, 5),
(230006, NULL, 'G3DSA:3.40.50.11920', NULL, NULL, NULL, NULL, '', NULL, NULL, 32161, 5),
(230007, NULL, 'G3DSA:1.10.443.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 31436, 5),
(230008, NULL, 'G3DSA:6.10.140.1100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230009, NULL, 'G3DSA:1.10.1370.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230010, NULL, 'G3DSA:1.20.120.1650', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230011, NULL, 'G3DSA:3.30.1370.170', NULL, NULL, NULL, NULL, '', NULL, NULL, 27928, 5),
(230012, NULL, 'G3DSA:1.10.472.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230013, NULL, 'G3DSA:3.30.70.1150', NULL, NULL, NULL, NULL, '', NULL, NULL, 24887, 5),
(230014, NULL, 'G3DSA:3.30.390.130', NULL, NULL, NULL, NULL, '', NULL, NULL, 33357, 5),
(230015, NULL, 'G3DSA:3.30.110.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 28155, 5),
(230016, NULL, 'G3DSA:1.20.120.1490', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230017, NULL, 'G3DSA:6.10.140.1720', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230018, NULL, 'G3DSA:3.40.91.70', NULL, NULL, NULL, NULL, 'Type II restriction endonuclease, HindIII', NULL, NULL, 32987, 5),
(230019, NULL, 'G3DSA:1.10.750.20', NULL, NULL, NULL, NULL, 'SOCS box', NULL, NULL, NULL, 5),
(230020, NULL, 'G3DSA:6.10.250.2970', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230021, NULL, 'G3DSA:4.10.70.10', NULL, NULL, NULL, NULL, 'Disintegrin domain', NULL, NULL, 28176, 5),
(230022, NULL, 'G3DSA:3.10.260.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230023, NULL, 'G3DSA:3.90.1150.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230024, NULL, 'G3DSA:3.30.1330.180', NULL, NULL, NULL, NULL, 'Cyanuric acid hydrolase/Barbiturase, RU B', NULL, NULL, 36473, 5),
(230025, NULL, 'G3DSA:1.10.10.2210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230026, NULL, 'G3DSA:1.10.490.60', NULL, NULL, NULL, NULL, 'Phage p2 RNA dependent RNA polymerase domain', NULL, NULL, 36794, 5),
(230027, NULL, 'G3DSA:2.60.120.790', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230028, NULL, 'G3DSA:1.10.1290.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33250, 5),
(230029, NULL, 'G3DSA:2.40.10.370', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF3599', NULL, NULL, 33724, 5),
(230030, NULL, 'G3DSA:3.30.1170.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230031, NULL, 'G3DSA:3.60.60.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 35720, 5),
(230032, NULL, 'G3DSA:6.10.250.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230033, NULL, 'G3DSA:3.10.540.10', NULL, NULL, NULL, NULL, 'duf1285 like domain', NULL, NULL, NULL, 5),
(230034, NULL, 'G3DSA:2.60.40.3750', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230035, NULL, 'G3DSA:1.10.150.560', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230036, NULL, 'G3DSA:1.10.1070.11', NULL, NULL, NULL, NULL, '', NULL, NULL, 28003, 5),
(230037, NULL, 'G3DSA:3.10.620.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28461, 5),
(230038, NULL, 'G3DSA:3.90.360.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28171, 5),
(230039, NULL, 'G3DSA:1.10.1220.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230040, NULL, 'G3DSA:2.70.220.10', NULL, NULL, NULL, NULL, 'Ganglioside GM2 activator', NULL, NULL, 31886, 5),
(230041, NULL, 'G3DSA:3.30.70.2080', NULL, NULL, NULL, NULL, '', NULL, NULL, 33796, 5),
(230042, NULL, 'G3DSA:6.10.140.720', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230043, NULL, 'G3DSA:3.30.1490.150', NULL, NULL, NULL, NULL, 'Hypothetical protein ph0010; domain 2', NULL, NULL, NULL, 5);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(230044, NULL, 'G3DSA:3.30.70.580', NULL, NULL, NULL, NULL, '', NULL, NULL, 16092, 5),
(230045, NULL, 'G3DSA:1.20.120.990', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230046, NULL, 'G3DSA:3.30.950.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 8820, 5),
(230047, NULL, 'G3DSA:3.60.9.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31141, 5),
(230048, NULL, 'G3DSA:3.40.1580.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 30563, 5),
(230049, NULL, 'G3DSA:3.50.70.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 10028, 5),
(230050, NULL, 'G3DSA:1.10.150.60', NULL, NULL, NULL, NULL, '', NULL, NULL, 28410, 5),
(230051, NULL, 'G3DSA:3.90.1570.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230052, NULL, 'G3DSA:1.10.10.1400', NULL, NULL, NULL, NULL, '', NULL, NULL, 30936, 5),
(230053, NULL, 'G3DSA:3.20.20.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230054, NULL, 'G3DSA:3.40.1710.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230055, NULL, 'G3DSA:1.10.150.430', NULL, NULL, NULL, NULL, 'DUF3349, helical bundle', NULL, NULL, 36855, 5),
(230056, NULL, 'G3DSA:4.10.1030.10', NULL, NULL, NULL, NULL, 'Ring Box Chain A; domain 5', NULL, NULL, NULL, 5),
(230057, NULL, 'G3DSA:4.10.520.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 8222, 5),
(230058, NULL, 'G3DSA:2.60.410.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29700, 5),
(230059, NULL, 'G3DSA:3.40.50.1390', NULL, NULL, NULL, NULL, '', NULL, NULL, 30253, 5),
(230060, NULL, 'G3DSA:2.60.120.1010', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230061, NULL, 'G3DSA:2.30.30.150', NULL, NULL, NULL, NULL, '', NULL, NULL, 29409, 5),
(230062, NULL, 'G3DSA:3.30.1110.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230063, NULL, 'G3DSA:3.30.1300.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 34809, 5),
(230064, NULL, 'G3DSA:1.10.418.90', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF1823', NULL, NULL, NULL, 5),
(230065, NULL, 'G3DSA:1.20.1700.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230066, NULL, 'G3DSA:2.10.50.10', NULL, NULL, NULL, NULL, 'Tumor Necrosis Factor Receptor, subunit A, domain 2', NULL, NULL, NULL, 5),
(230067, NULL, 'G3DSA:1.10.3450.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230068, NULL, 'G3DSA:1.10.720.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230069, NULL, 'G3DSA:6.10.290.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230070, NULL, 'G3DSA:1.10.3560.10', NULL, NULL, NULL, NULL, 'yst0336 like domain', NULL, NULL, 17366, 5),
(230071, NULL, 'G3DSA:1.10.530.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230072, NULL, 'G3DSA:1.20.120.340', NULL, NULL, NULL, NULL, 'Flagellar protein FliS', NULL, NULL, NULL, 5),
(230073, NULL, 'G3DSA:6.10.140.1810', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230074, NULL, 'G3DSA:3.10.105.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230075, NULL, 'G3DSA:2.170.150.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230076, NULL, 'G3DSA:3.90.1760.10', NULL, NULL, NULL, NULL, 'Anthrax toxin, edema factor, central domain', NULL, NULL, 28493, 5),
(230077, NULL, 'G3DSA:1.10.10.2380', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230078, NULL, 'G3DSA:3.40.35.10', NULL, NULL, NULL, NULL, 'Phosphotransferase system, sorbose subfamily IIB component', NULL, NULL, 28776, 5),
(230079, NULL, 'G3DSA:3.40.50.10790', NULL, NULL, NULL, NULL, '', NULL, NULL, 12315, 5),
(230080, NULL, 'G3DSA:1.10.3550.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230081, NULL, 'G3DSA:3.40.1140.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230082, NULL, 'G3DSA:2.40.50.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230083, NULL, 'G3DSA:2.60.120.420', NULL, NULL, NULL, NULL, 'Membrane penetration protein mu1, Chain B, domain 4', NULL, NULL, 8770, 5),
(230084, NULL, 'G3DSA:2.10.10.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28167, 5),
(230085, NULL, 'G3DSA:2.40.50.400', NULL, NULL, NULL, NULL, '', NULL, NULL, 29952, 5),
(230086, NULL, 'G3DSA:2.30.320.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(230087, NULL, 'G3DSA:1.10.170.10', NULL, NULL, NULL, NULL, 'Bluetongue Virus 10, subunit 1, domain 3', NULL, NULL, 10018, 5),
(230088, NULL, 'G3DSA:1.20.58.1060', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230089, NULL, 'G3DSA:3.40.30.60', NULL, NULL, NULL, NULL, 'FHIPEP family, domain 1', NULL, NULL, 35251, 5),
(230090, NULL, 'G3DSA:3.40.50.12690', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230091, NULL, 'G3DSA:2.40.160.10', NULL, NULL, NULL, NULL, 'Porin', NULL, NULL, 16370, 5),
(230092, NULL, 'G3DSA:3.40.50.10740', NULL, NULL, NULL, NULL, '', NULL, NULL, 24646, 5),
(230093, NULL, 'G3DSA:3.30.70.2120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230094, NULL, 'G3DSA:3.10.20.330', NULL, NULL, NULL, NULL, 'Protein of unknown function YopT', NULL, NULL, 31105, 5),
(230095, NULL, 'G3DSA:1.10.1660.60', NULL, NULL, NULL, NULL, 'Putative excisionased domain DUF1233', NULL, NULL, 31295, 5),
(230096, NULL, 'G3DSA:3.30.1660.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 27901, 5),
(230097, NULL, 'G3DSA:1.10.40.50', NULL, NULL, NULL, NULL, 'Probable gtpase engc; domain 3', NULL, NULL, NULL, 5),
(230098, NULL, 'G3DSA:6.10.140.2080', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230099, NULL, 'G3DSA:1.25.40.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230100, NULL, 'G3DSA:3.30.1180.20', NULL, NULL, NULL, NULL, 'Dihydroxyacetone kinase; domain 2', NULL, NULL, NULL, 5),
(230101, NULL, 'G3DSA:1.20.1260.100', NULL, NULL, NULL, NULL, 'TspO/MBR protein', NULL, NULL, 28625, 5),
(230102, NULL, 'G3DSA:3.10.450.220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230103, NULL, 'G3DSA:2.60.470.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230104, NULL, 'G3DSA:6.10.140.2030', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230105, NULL, 'G3DSA:6.10.250.1330', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230106, NULL, 'G3DSA:6.20.200.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230107, NULL, 'G3DSA:1.20.140.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230108, NULL, 'G3DSA:6.10.140.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230109, NULL, 'G3DSA:3.30.460.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230110, NULL, 'G3DSA:3.30.420.200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230111, NULL, 'G3DSA:1.20.910.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230112, NULL, 'G3DSA:3.30.70.1490', NULL, NULL, NULL, NULL, 'Cysteine protease Prp', NULL, NULL, 32410, 5),
(230113, NULL, 'G3DSA:2.20.70.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230114, NULL, 'G3DSA:3.10.40.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28314, 5),
(230115, NULL, 'G3DSA:1.10.1200.240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230116, NULL, 'G3DSA:1.20.1240.10', NULL, NULL, NULL, NULL, 'Photosystem I PsaL, reaction centre subunit XI', NULL, NULL, 32581, 5),
(230117, NULL, 'G3DSA:3.30.420.250', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230118, NULL, 'G3DSA:6.10.250.780', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230119, NULL, 'G3DSA:6.10.140.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230120, NULL, 'G3DSA:6.10.250.1380', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230121, NULL, 'G3DSA:3.30.460.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230122, NULL, 'G3DSA:3.30.300.90', NULL, NULL, NULL, NULL, '', NULL, NULL, 29811, 5),
(230123, NULL, 'G3DSA:3.10.450.270', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230124, NULL, 'G3DSA:3.30.750.210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230125, NULL, 'G3DSA:2.30.30.770', NULL, NULL, NULL, NULL, '', NULL, NULL, 33291, 5),
(230126, NULL, 'G3DSA:3.30.1330.170', NULL, NULL, NULL, NULL, 'Cyanuric acid hydrolase/Barbiturase, RU A', NULL, NULL, 36024, 5),
(230127, NULL, 'G3DSA:2.20.70.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230128, NULL, 'G3DSA:3.90.470.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230129, NULL, 'G3DSA:3.10.20.390', NULL, NULL, NULL, NULL, '', NULL, NULL, 32448, 5);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(230130, NULL, 'G3DSA:3.30.70.2740', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230131, NULL, 'G3DSA:3.30.1460.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230132, NULL, 'G3DSA:1.10.40.60', NULL, NULL, NULL, NULL, '', NULL, NULL, 32610, 5),
(230133, NULL, 'G3DSA:1.25.40.550', NULL, NULL, NULL, NULL, '', NULL, NULL, 33510, 5),
(230134, NULL, 'G3DSA:1.10.3540.10', NULL, NULL, NULL, NULL, 'uncharacterized protein from magnetospirillum magneticum domain', NULL, NULL, 17246, 5),
(230135, NULL, 'G3DSA:3.50.4.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 30915, 5),
(230136, NULL, 'G3DSA:1.10.246.20', NULL, NULL, NULL, NULL, 'Coactivator CBP, KIX domain', NULL, NULL, 33227, 5),
(230137, NULL, 'G3DSA:3.30.70.3000', NULL, NULL, NULL, NULL, '', NULL, NULL, 32009, 5),
(230138, NULL, 'G3DSA:2.60.310.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31863, 5),
(230139, NULL, 'G3DSA:3.40.1350.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230140, NULL, 'G3DSA:3.10.20.340', NULL, NULL, NULL, NULL, '', NULL, NULL, 37355, 5),
(230141, NULL, 'G3DSA:2.30.140.40', NULL, NULL, NULL, NULL, 'Pestivirus Npro endopeptidase C53, interaction domain', NULL, NULL, 34145, 5),
(230142, NULL, 'G3DSA:2.60.120.1680', NULL, NULL, NULL, NULL, '', NULL, NULL, 35320, 5),
(230143, NULL, 'G3DSA:1.10.580.10', NULL, NULL, NULL, NULL, 'Citrate Synthase, domain 1', NULL, NULL, 9136, 5),
(230144, NULL, 'G3DSA:2.160.20.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 14047, 5),
(230145, NULL, 'G3DSA:6.10.250.3320', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230146, NULL, 'G3DSA:3.30.1360.170', NULL, NULL, NULL, NULL, '', NULL, NULL, 27287, 5),
(230147, NULL, 'G3DSA:6.10.140.1150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230148, NULL, 'G3DSA:1.10.260.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230149, NULL, 'G3DSA:4.10.240.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28495, 5),
(230150, NULL, 'G3DSA:2.60.40.790', NULL, NULL, NULL, NULL, '', NULL, NULL, 9356, 5),
(230151, NULL, 'G3DSA:3.40.1810.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28178, 5),
(230152, NULL, 'G3DSA:1.10.246.110', NULL, NULL, NULL, NULL, '', NULL, NULL, 33662, 5),
(230153, NULL, 'G3DSA:3.90.1680.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230154, NULL, 'G3DSA:6.20.370.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230155, NULL, 'G3DSA:1.10.645.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 21549, 5),
(230156, NULL, 'G3DSA:3.30.519.10', NULL, NULL, NULL, NULL, 'Guanine Nucleotide Dissociation Inhibitor, domain 2', NULL, NULL, NULL, 5),
(230157, NULL, 'G3DSA:6.10.140.2120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230158, NULL, 'G3DSA:2.160.20.60', NULL, NULL, NULL, NULL, '', NULL, NULL, 29998, 5),
(230159, NULL, 'G3DSA:2.60.40.2570', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230160, NULL, 'G3DSA:3.40.1620.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230161, NULL, 'G3DSA:1.20.120.320', NULL, NULL, NULL, NULL, 'Group V grass pollen allergen', NULL, NULL, 27509, 5),
(230162, NULL, 'G3DSA:1.20.58.1680', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230163, NULL, 'G3DSA:6.10.250.3230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230164, NULL, 'G3DSA:1.20.120.1940', NULL, NULL, NULL, NULL, 'YfdX protein domain', NULL, NULL, NULL, 5),
(230165, NULL, 'G3DSA:2.40.128.710', NULL, NULL, NULL, NULL, '', NULL, NULL, 34812, 5),
(230166, NULL, 'G3DSA:3.30.70.1770', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230167, NULL, 'G3DSA:2.60.40.740', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230168, NULL, 'G3DSA:1.10.246.90', NULL, NULL, NULL, NULL, 'Nop domain', NULL, NULL, 33871, 5),
(230169, NULL, 'G3DSA:3.40.630.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230170, NULL, 'G3DSA:4.10.490.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28279, 5),
(230171, NULL, 'G3DSA:4.10.870.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 25671, 5),
(230172, NULL, 'G3DSA:3.30.1770.10', NULL, NULL, NULL, NULL, 'TPR 1 domain of DNA polymerase', NULL, NULL, NULL, 5),
(230173, NULL, 'G3DSA:3.90.226.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 34686, 5);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(230174, NULL, 'G3DSA:3.30.70.2170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230175, NULL, 'G3DSA:1.10.260.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 28695, 5),
(230176, NULL, 'G3DSA:3.40.1620.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230177, NULL, 'G3DSA:6.10.250.2350', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230178, NULL, 'G3DSA:3.40.109.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230179, NULL, 'G3DSA:6.10.250.820', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230180, NULL, 'G3DSA:1.20.58.2010', NULL, NULL, NULL, NULL, 'PRONE domain, subdomain 1', NULL, NULL, NULL, 5),
(230181, NULL, 'G3DSA:2.10.70.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230182, NULL, 'G3DSA:3.40.20.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230183, NULL, 'G3DSA:6.10.250.3280', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230184, NULL, 'G3DSA:2.60.40.1380', NULL, NULL, NULL, NULL, 'E set domains; domain 4', NULL, NULL, 14797, 5),
(230185, NULL, 'G3DSA:3.40.630.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230186, NULL, 'G3DSA:1.10.150.650', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230187, NULL, 'G3DSA:6.10.140.470', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230188, NULL, 'G3DSA:6.20.120.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230189, NULL, 'G3DSA:1.20.1480.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 13695, 5),
(230190, NULL, 'G3DSA:1.20.120.770', NULL, NULL, NULL, NULL, 'Amyloid precursor protein, E2 domain', NULL, NULL, 31619, 5),
(230191, NULL, 'G3DSA:2.40.50.450', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230192, NULL, 'G3DSA:6.10.20.180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230193, NULL, 'G3DSA:2.30.30.810', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230194, NULL, 'G3DSA:1.20.1560.10', NULL, NULL, NULL, NULL, 'ABC transporter type 1, transmembrane domain', NULL, NULL, 27004, 5),
(230195, NULL, 'G3DSA:2.10.70.60', NULL, NULL, NULL, NULL, '', NULL, NULL, 35563, 5),
(230196, NULL, 'G3DSA:1.10.8.100', NULL, NULL, NULL, NULL, '', NULL, NULL, 15910, 5),
(230197, NULL, 'G3DSA:3.10.530.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32403, 5),
(230198, NULL, 'G3DSA:4.10.220.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 24522, 5),
(230199, NULL, 'G3DSA:1.25.40.480', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230200, NULL, 'G3DSA:3.30.70.1480', NULL, NULL, NULL, NULL, '', NULL, NULL, 21718, 5),
(230201, NULL, 'G3DSA:3.40.1720.10', NULL, NULL, NULL, NULL, 'Streptococcus thermophilus LMG 18311 protein like', NULL, NULL, 33953, 5),
(230202, NULL, 'G3DSA:1.20.200.20', NULL, NULL, NULL, NULL, 'She2 domain', NULL, NULL, 27698, 5),
(230203, NULL, 'G3DSA:1.10.1670.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 8227, 5),
(230204, NULL, 'G3DSA:6.10.250.1210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230205, NULL, 'G3DSA:1.10.287.2070', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230206, NULL, 'G3DSA:2.60.120.1300', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230207, NULL, 'G3DSA:3.90.1810.10', NULL, NULL, NULL, NULL, 'Reovirus components', NULL, NULL, NULL, 5),
(230208, NULL, 'G3DSA:3.30.30.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31179, 5),
(230209, NULL, 'G3DSA:6.10.80.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31502, 5),
(230210, NULL, 'G3DSA:3.30.70.2110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230211, NULL, 'G3DSA:1.20.5.5270', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230212, NULL, 'G3DSA:1.20.5.260', NULL, NULL, NULL, NULL, '', NULL, NULL, 29715, 5),
(230213, NULL, 'G3DSA:3.40.50.11380', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230214, NULL, 'G3DSA:3.40.50.11460', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230215, NULL, 'G3DSA:3.30.1920.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 16326, 5),
(230216, NULL, 'G3DSA:2.60.40.2450', NULL, NULL, NULL, NULL, '', NULL, NULL, 32431, 5),
(230217, NULL, 'G3DSA:1.10.8.290', NULL, NULL, NULL, NULL, 'uncharacterized protein sp1917 domain', NULL, NULL, 19798, 5);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(230218, NULL, 'G3DSA:3.30.70.2030', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230219, NULL, 'G3DSA:3.40.1780.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 35001, 5),
(230220, NULL, 'G3DSA:3.30.70.1990', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230221, NULL, 'G3DSA:2.30.30.220', NULL, NULL, NULL, NULL, '', NULL, NULL, 27729, 5),
(230222, NULL, 'G3DSA:1.20.1440.240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230223, NULL, 'G3DSA:3.40.50.790', NULL, NULL, NULL, NULL, '', NULL, NULL, 10394, 5),
(230224, NULL, 'G3DSA:1.10.8.930', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF1465', NULL, NULL, 31413, 5),
(230225, NULL, 'G3DSA:1.10.3060.10', NULL, NULL, NULL, NULL, 'Helical scaffold and wing domains of SecA', NULL, NULL, NULL, 5),
(230226, NULL, 'G3DSA:3.30.310.270', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230227, NULL, 'G3DSA:6.20.370.40', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5),
(230228, NULL, 'G3DSA:1.10.20.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230229, NULL, 'G3DSA:3.10.290.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31713, 5),
(230230, NULL, 'G3DSA:1.20.1600.10', NULL, NULL, NULL, NULL, 'Outer membrane efflux proteins (OEP)', NULL, NULL, NULL, 5),
(230231, NULL, 'G3DSA:3.30.300.230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230232, NULL, 'G3DSA:2.40.128.220', NULL, NULL, NULL, NULL, '', NULL, NULL, 33854, 5),
(230233, NULL, 'G3DSA:1.10.238.210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230234, NULL, 'G3DSA:3.30.60.280', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230235, NULL, 'G3DSA:1.10.490.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230236, NULL, 'G3DSA:3.40.970.20', NULL, NULL, NULL, NULL, 'Carbon monoxide dehydrogenase alpha subunit. Chain D, domain 4', NULL, NULL, NULL, 5),
(230237, NULL, 'G3DSA:6.10.250.2680', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230238, NULL, 'G3DSA:3.20.190.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 14103, 5),
(230239, NULL, 'G3DSA:2.20.25.590', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230240, NULL, 'G3DSA:1.20.1310.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 35158, 5),
(230241, NULL, 'G3DSA:1.20.5.930', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230242, NULL, 'G3DSA:1.10.287.650', NULL, NULL, NULL, NULL, 'L27 domain', NULL, NULL, NULL, 5),
(230243, NULL, 'G3DSA:6.10.250.2760', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230244, NULL, 'G3DSA:1.20.1440.320', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230245, NULL, 'G3DSA:4.10.800.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28476, 5),
(230246, NULL, 'G3DSA:1.20.58.250', NULL, NULL, NULL, NULL, '', NULL, NULL, 27624, 5),
(230247, NULL, 'G3DSA:6.10.250.3290', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230248, NULL, 'G3DSA:1.10.418.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230249, NULL, 'G3DSA:3.30.2340.10', NULL, NULL, NULL, NULL, 'TruD, insertion domain', NULL, NULL, 34672, 5),
(230250, NULL, 'G3DSA:3.30.30.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230251, NULL, 'G3DSA:6.10.250.3370', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230252, NULL, 'G3DSA:3.40.50.280', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230253, NULL, 'G3DSA:3.40.50.11890', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230254, NULL, 'G3DSA:3.90.110.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 8107, 5),
(230255, NULL, 'G3DSA:3.90.120.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230256, NULL, 'G3DSA:1.10.275.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230257, NULL, 'G3DSA:1.20.5.690', NULL, NULL, NULL, NULL, '', NULL, NULL, 30249, 5),
(230258, NULL, 'G3DSA:1.20.58.1270', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230259, NULL, 'G3DSA:3.90.226.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230260, NULL, 'G3DSA:3.10.20.800', NULL, NULL, NULL, NULL, '', NULL, NULL, 32315, 5),
(230261, NULL, 'G3DSA:3.30.450.300', NULL, NULL, NULL, NULL, 'Sensor histidine kinase RisS, periplasmic domain', NULL, NULL, 31248, 5);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(230262, NULL, 'G3DSA:1.10.3450.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230263, NULL, 'G3DSA:6.20.370.150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230264, NULL, 'G3DSA:2.60.120.240', NULL, NULL, NULL, NULL, 'Protective antigen, heptamerisation domain', NULL, NULL, 29609, 5),
(230265, NULL, 'G3DSA:6.20.50.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230266, NULL, 'G3DSA:1.25.40.250', NULL, NULL, NULL, NULL, 'ARM repeat; domain 1', NULL, NULL, 8383, 5),
(230267, NULL, 'G3DSA:2.40.310.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29862, 5),
(230268, NULL, 'G3DSA:2.40.50.790', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230269, NULL, 'G3DSA:3.10.420.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 16822, 5),
(230270, NULL, 'G3DSA:1.10.220.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230271, NULL, 'G3DSA:6.10.250.1130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230272, NULL, 'G3DSA:4.10.240.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230273, NULL, 'G3DSA:2.10.60.10', NULL, NULL, NULL, NULL, 'CD59', NULL, NULL, 34199, 5),
(230274, NULL, 'G3DSA:6.10.140.2200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230275, NULL, 'G3DSA:6.10.140.770', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230276, NULL, 'G3DSA:1.10.1050.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230277, NULL, 'G3DSA:3.30.1390.40', NULL, NULL, NULL, NULL, 'Ribosomal protein L30p/L7e', NULL, NULL, NULL, 5),
(230278, NULL, 'G3DSA:1.10.3530.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 16734, 5),
(230279, NULL, 'G3DSA:1.20.140.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230280, NULL, 'G3DSA:2.60.120.1220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230281, NULL, 'G3DSA:6.10.140.1060', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230282, NULL, 'G3DSA:2.60.40.1840', NULL, NULL, NULL, NULL, '', NULL, NULL, 32056, 5),
(230283, NULL, 'G3DSA:2.30.30.300', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5),
(230284, NULL, 'G3DSA:4.10.670.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31368, 5),
(230285, NULL, 'G3DSA:3.30.2040.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230286, NULL, 'G3DSA:6.10.140.340', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230287, NULL, 'G3DSA:6.10.140.1860', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230288, NULL, 'G3DSA:1.20.970.20', NULL, NULL, NULL, NULL, 'Glycogen synthesis protein GlgS', NULL, NULL, 31663, 5),
(230289, NULL, 'G3DSA:2.110.10.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32437, 5),
(230290, NULL, 'G3DSA:2.60.120.860', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230291, NULL, 'G3DSA:6.10.140.550', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230292, NULL, 'G3DSA:2.20.28.240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230293, NULL, 'G3DSA:2.30.38.10', NULL, NULL, NULL, NULL, 'Luciferase; Domain 3', NULL, NULL, NULL, 5),
(230294, NULL, 'G3DSA:3.30.240.10', NULL, NULL, NULL, NULL, 'CRO Repressor', NULL, NULL, 31396, 5),
(230295, NULL, 'G3DSA:3.10.450.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 6070, 5),
(230296, NULL, 'G3DSA:1.20.120.1190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230297, NULL, 'G3DSA:2.30.30.730', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230298, NULL, 'G3DSA:2.60.40.2820', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230299, NULL, 'G3DSA:2.60.210.10', NULL, NULL, NULL, NULL, 'Apoptosis, Tumor Necrosis Factor Receptor Associated Protein 2; Chain A', NULL, NULL, 9466, 5),
(230300, NULL, 'G3DSA:3.30.460.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230301, NULL, 'G3DSA:3.90.70.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230302, NULL, 'G3DSA:1.10.287.1890', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230303, NULL, 'G3DSA:6.10.140.1650', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230304, NULL, 'G3DSA:3.30.70.2620', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230305, NULL, 'G3DSA:1.20.920.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230306, NULL, 'G3DSA:3.40.1350.80', NULL, NULL, NULL, NULL, '', NULL, NULL, 31040, 5);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(230307, NULL, 'G3DSA:1.20.120.1560', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230308, NULL, 'G3DSA:6.10.140.1270', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230309, NULL, 'G3DSA:2.60.60.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230310, NULL, 'G3DSA:3.60.20.30', NULL, NULL, NULL, NULL, '(Glycosyl)asparaginase', NULL, NULL, NULL, 5),
(230311, NULL, 'G3DSA:3.40.50.11700', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230312, NULL, 'G3DSA:3.10.20.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230313, NULL, 'G3DSA:4.10.950.10', NULL, NULL, NULL, NULL, 'Ribosomal protein L2, domain 3', NULL, NULL, 9153, 5),
(230314, NULL, 'G3DSA:3.20.170.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 31981, 5),
(230315, NULL, 'G3DSA:6.10.140.1780', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230316, NULL, 'G3DSA:1.20.1270.130', NULL, NULL, NULL, NULL, 'Shigella T3SS effector IpaH domain', NULL, NULL, NULL, 5),
(230317, NULL, 'G3DSA:2.70.50.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230318, NULL, 'G3DSA:1.20.58.540', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230319, NULL, 'G3DSA:1.25.40.850', NULL, NULL, NULL, NULL, '', NULL, NULL, 37704, 5),
(230320, NULL, 'G3DSA:3.40.1620.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230321, NULL, 'G3DSA:4.10.780.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28208, 5),
(230322, NULL, 'G3DSA:6.10.140.1140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230323, NULL, 'G3DSA:3.40.50.12230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230324, NULL, 'G3DSA:6.20.50.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230325, NULL, 'G3DSA:6.10.250.2980', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230326, NULL, 'G3DSA:2.30.29.160', NULL, NULL, NULL, NULL, '', NULL, NULL, 27417, 5),
(230327, NULL, 'G3DSA:3.40.50.11830', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230328, NULL, 'G3DSA:3.30.2450.10', NULL, NULL, NULL, NULL, 'Secreted effector protein pipB2', NULL, NULL, NULL, 5),
(230329, NULL, 'G3DSA:6.10.250.3070', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230330, NULL, 'G3DSA:1.10.340.30', NULL, NULL, NULL, NULL, 'Hypothetical protein; domain 2', NULL, NULL, NULL, 5),
(230331, NULL, 'G3DSA:1.10.472.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230332, NULL, 'G3DSA:4.10.530.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230333, NULL, 'G3DSA:3.40.80.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 30377, 5),
(230334, NULL, 'G3DSA:6.10.10.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230335, NULL, 'G3DSA:2.30.130.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230336, NULL, 'G3DSA:1.10.1200.20', NULL, NULL, NULL, NULL, 'Colicin E immunity protein', NULL, NULL, 14966, 5),
(230337, NULL, 'G3DSA:1.20.120.1860', NULL, NULL, NULL, NULL, '', NULL, NULL, 27033, 5),
(230338, NULL, 'G3DSA:6.10.250.2470', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230339, NULL, 'G3DSA:2.40.50.810', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230340, NULL, 'G3DSA:1.20.930.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 32034, 5),
(230341, NULL, 'G3DSA:1.25.40.930', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230342, NULL, 'G3DSA:3.40.1670.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230343, NULL, 'G3DSA:3.40.1800.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32033, 5),
(230344, NULL, 'G3DSA:3.90.55.10', NULL, NULL, NULL, NULL, 'Dimethylsulfoxide Reductase, domain 3', NULL, NULL, NULL, 5),
(230345, NULL, 'G3DSA:1.10.10.710', NULL, NULL, NULL, NULL, 'PSPTO_1197 like', NULL, NULL, 31043, 5),
(230346, NULL, 'G3DSA:6.10.250.860', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230347, NULL, 'G3DSA:1.20.5.2480', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230348, NULL, 'G3DSA:1.50.10.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230349, NULL, 'G3DSA:1.20.120.440', NULL, NULL, NULL, NULL, '', NULL, NULL, 16640, 5),
(230350, NULL, 'G3DSA:1.20.1420.10', NULL, NULL, NULL, NULL, 'Talin, central domain', NULL, NULL, NULL, 5);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(230351, NULL, 'G3DSA:1.10.287.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230352, NULL, 'G3DSA:1.10.2090.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28980, 5),
(230353, NULL, 'G3DSA:2.10.70.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230354, NULL, 'G3DSA:1.20.1480.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230355, NULL, 'G3DSA:1.25.40.210', NULL, NULL, NULL, NULL, '', NULL, NULL, 31023, 5),
(230356, NULL, 'G3DSA:3.90.930.12', NULL, NULL, NULL, NULL, '', NULL, NULL, 33163, 5),
(230357, NULL, 'G3DSA:2.102.20.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28372, 5),
(230358, NULL, 'G3DSA:3.40.50.12020', NULL, NULL, NULL, NULL, 'Uncharacterised protein family UPF0261, NN domain', NULL, NULL, NULL, 5),
(230359, NULL, 'G3DSA:1.10.1720.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29393, 5),
(230360, NULL, 'G3DSA:3.40.630.190', NULL, NULL, NULL, NULL, 'LCP protein', NULL, NULL, NULL, 5),
(230361, NULL, 'G3DSA:1.20.120.1640', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230362, NULL, 'G3DSA:1.20.890.70', NULL, NULL, NULL, NULL, 'Protein translocase subunit SecA, preprotein binding domain', NULL, NULL, NULL, 5),
(230363, NULL, 'G3DSA:1.25.40.640', NULL, NULL, NULL, NULL, 'Avirulence protein ATR13', NULL, NULL, 33675, 5),
(230364, NULL, 'G3DSA:3.30.1370.250', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230365, NULL, 'G3DSA:2.60.40.4340', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230366, NULL, 'G3DSA:1.10.285.20', NULL, NULL, NULL, NULL, 'Uncharacterised protein PF01937, DUF89, domain 2', NULL, NULL, NULL, 5),
(230367, NULL, 'G3DSA:6.20.50.110', NULL, NULL, NULL, NULL, '', NULL, NULL, 29622, 5),
(230368, NULL, 'G3DSA:3.30.70.1780', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230369, NULL, 'G3DSA:2.60.40.1770', NULL, NULL, NULL, NULL, 'ephrin a2 ectodomain', NULL, NULL, NULL, 5),
(230370, NULL, 'G3DSA:2.60.40.2900', NULL, NULL, NULL, NULL, '', NULL, NULL, 31088, 5),
(230371, NULL, 'G3DSA:3.90.1290.10', NULL, NULL, NULL, NULL, 'Plakin repeat', NULL, NULL, 18528, 5),
(230372, NULL, 'G3DSA:3.40.190.200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230373, NULL, 'G3DSA:6.20.120.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230374, NULL, 'G3DSA:1.20.1060.10', NULL, NULL, NULL, NULL, 'Taq DNA Polymerase; Chain T, domain 4', NULL, NULL, NULL, 5),
(230375, NULL, 'G3DSA:1.20.1280.220', NULL, NULL, NULL, NULL, '', NULL, NULL, 32617, 5),
(230376, NULL, 'G3DSA:1.10.890.30', NULL, NULL, NULL, NULL, 'YmgD protein', NULL, NULL, 31226, 5),
(230377, NULL, 'G3DSA:2.60.40.1970', NULL, NULL, NULL, NULL, 'YEATS domain', NULL, NULL, 31455, 5),
(230378, NULL, 'G3DSA:2.60.40.2160', NULL, NULL, NULL, NULL, '', NULL, NULL, 32535, 5),
(230379, NULL, 'G3DSA:2.60.40.1390', NULL, NULL, NULL, NULL, '', NULL, NULL, 28418, 5),
(230380, NULL, 'G3DSA:3.30.2080.10', NULL, NULL, NULL, NULL, 'GH92 mannosidase domain', NULL, NULL, NULL, 5),
(230381, NULL, 'G3DSA:3.90.170.10', NULL, NULL, NULL, NULL, 'Adenylosuccinate Synthetase, subunit A, domain 3', NULL, NULL, 35820, 5),
(230382, NULL, 'G3DSA:1.10.287.740', NULL, NULL, NULL, NULL, 'Photosystem II PsbZ, reaction centre', NULL, NULL, 30368, 5),
(230383, NULL, 'G3DSA:2.120.10.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 9017, 5),
(230384, NULL, 'G3DSA:2.40.128.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230385, NULL, 'G3DSA:6.10.140.850', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230386, NULL, 'G3DSA:1.10.260.70', NULL, NULL, NULL, NULL, 'SATB, CULT domain', NULL, NULL, 33975, 5),
(230387, NULL, 'G3DSA:3.40.420.10', NULL, NULL, NULL, NULL, 'Ricin (A subunit), domain 1', NULL, NULL, 11210, 5),
(230388, NULL, 'G3DSA:6.20.390.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230389, NULL, 'G3DSA:1.10.3020.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230390, NULL, 'G3DSA:6.20.250.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230391, NULL, 'G3DSA:3.90.1160.10', NULL, NULL, NULL, NULL, 'Baseplate structural protein gp11, finger domain', NULL, NULL, 9354, 5),
(230392, NULL, 'G3DSA:3.30.70.1560', NULL, NULL, NULL, NULL, '', NULL, NULL, 30420, 5);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(230393, NULL, 'G3DSA:3.30.70.2330', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230394, NULL, 'G3DSA:4.10.640.10', NULL, NULL, NULL, NULL, 'Ribosomal protein S18', NULL, NULL, 28232, 5),
(230395, NULL, 'G3DSA:1.10.10.2460', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230396, NULL, 'G3DSA:2.60.40.2580', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230397, NULL, 'G3DSA:3.30.750.140', NULL, NULL, NULL, NULL, '', NULL, NULL, 32289, 5),
(230398, NULL, 'G3DSA:1.10.3170.10', NULL, NULL, NULL, NULL, 'Recbcd, chain B, domain 2', NULL, NULL, NULL, 5),
(230399, NULL, 'G3DSA:3.30.70.2750', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230400, NULL, 'G3DSA:3.30.450.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230401, NULL, 'G3DSA:2.60.120.940', NULL, NULL, NULL, NULL, '', NULL, NULL, 36535, 5),
(230402, NULL, 'G3DSA:3.40.50.12030', NULL, NULL, NULL, NULL, 'Uncharacterised protein family UPF0261, NC domain', NULL, NULL, NULL, 5),
(230403, NULL, 'G3DSA:1.10.220.50', NULL, NULL, NULL, NULL, '', NULL, NULL, 29633, 5),
(230404, NULL, 'G3DSA:1.10.287.1970', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230405, NULL, 'G3DSA:1.20.58.810', NULL, NULL, NULL, NULL, 'Photosystem II Pbs27', NULL, NULL, 31140, 5),
(230406, NULL, 'G3DSA:6.10.320.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230407, NULL, 'G3DSA:3.10.20.350', NULL, NULL, NULL, NULL, '', NULL, NULL, 31147, 5),
(230408, NULL, 'G3DSA:2.30.30.280', NULL, NULL, NULL, NULL, '', NULL, NULL, 16566, 5),
(230409, NULL, 'G3DSA:1.10.132.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230410, NULL, 'G3DSA:4.10.1090.10', NULL, NULL, NULL, NULL, 'Endosialidase, domain 4', NULL, NULL, 36237, 5),
(230411, NULL, 'G3DSA:1.20.1200.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31600, 5),
(230412, NULL, 'G3DSA:1.10.150.220', NULL, NULL, NULL, NULL, '', NULL, NULL, 29823, 5),
(230413, NULL, 'G3DSA:3.90.1280.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 11945, 5),
(230414, NULL, 'G3DSA:2.60.120.1430', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230415, NULL, 'G3DSA:2.40.128.350', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230416, NULL, 'G3DSA:3.30.420.370', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230417, NULL, 'G3DSA:6.10.140.1360', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230418, NULL, 'G3DSA:1.10.1200.120', NULL, NULL, NULL, NULL, '', NULL, NULL, 27945, 5),
(230419, NULL, 'G3DSA:3.10.450.690', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230420, NULL, 'G3DSA:1.10.4030.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230421, NULL, 'G3DSA:2.60.40.1180', NULL, NULL, NULL, NULL, '', NULL, NULL, 11036, 5),
(230422, NULL, 'G3DSA:6.10.250.3440', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230423, NULL, 'G3DSA:1.20.1570.10', NULL, NULL, NULL, NULL, 'dip2346 domain like', NULL, NULL, NULL, 5),
(230424, NULL, 'G3DSA:3.90.70.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230425, NULL, 'G3DSA:1.20.58.1480', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230426, NULL, 'G3DSA:3.30.360.110', NULL, NULL, NULL, NULL, '', NULL, NULL, 34736, 5),
(230427, NULL, 'G3DSA:3.90.79.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 32621, 5),
(230428, NULL, 'G3DSA:1.20.1270.310', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230429, NULL, 'G3DSA:1.25.40.530', NULL, NULL, NULL, NULL, 'MyTH4 domain', NULL, NULL, 30323, 5),
(230430, NULL, 'G3DSA:1.10.4090.10', NULL, NULL, NULL, NULL, 'Viral capsid, core domain supefamily, Hepatitis B virus', NULL, NULL, 28355, 5),
(230431, NULL, 'G3DSA:1.20.58.1050', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230432, NULL, 'G3DSA:1.10.10.1120', NULL, NULL, NULL, NULL, '', NULL, NULL, 30603, 5),
(230433, NULL, 'G3DSA:6.10.140.1560', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230434, NULL, 'G3DSA:1.20.5.800', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230435, NULL, 'G3DSA:3.30.720.180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230436, NULL, 'G3DSA:3.40.1350.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 33563, 5);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(230437, NULL, 'G3DSA:1.20.58.1560', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230438, NULL, 'G3DSA:2.40.128.430', NULL, NULL, NULL, NULL, '', NULL, NULL, 37518, 5),
(230439, NULL, 'G3DSA:3.30.70.2240', NULL, NULL, NULL, NULL, '', NULL, NULL, 35721, 5),
(230440, NULL, 'G3DSA:1.10.1240.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230441, NULL, 'G3DSA:1.10.287.830', NULL, NULL, NULL, NULL, 'putative peptidase helix hairpin domain like', NULL, NULL, NULL, 5),
(230442, NULL, 'G3DSA:4.10.260.10', NULL, NULL, NULL, NULL, 'Transducin (heterotrimeric G protein), gamma chain', NULL, NULL, 31493, 5),
(230443, NULL, 'G3DSA:3.30.380.10', NULL, NULL, NULL, NULL, 'MS2 Viral Coat Protein', NULL, NULL, 8440, 5),
(230444, NULL, 'G3DSA:1.20.120.1370', NULL, NULL, NULL, NULL, 'Regulator of RNA polymerase sigma(70) subunit, domain 4', NULL, NULL, 28984, 5),
(230445, NULL, 'G3DSA:2.30.30.190', NULL, NULL, NULL, NULL, '', NULL, NULL, 28322, 5),
(230446, NULL, 'G3DSA:1.10.3910.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33313, 5),
(230447, NULL, 'G3DSA:6.10.250.3160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230448, NULL, 'G3DSA:2.30.30.1000', NULL, NULL, NULL, NULL, 'Replicase polyprotein 1a', NULL, NULL, 27446, 5),
(230449, NULL, 'G3DSA:3.40.50.1010', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230450, NULL, 'G3DSA:1.10.340.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 15743, 5),
(230451, NULL, 'G3DSA:2.60.120.1000', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230452, NULL, 'G3DSA:2.60.120.700', NULL, NULL, NULL, NULL, 'Peptidase G1', NULL, NULL, 32181, 5),
(230453, NULL, 'G3DSA:3.90.175.10', NULL, NULL, NULL, NULL, 'Diphtheria Toxin, domain 1', NULL, NULL, NULL, 5),
(230454, NULL, 'G3DSA:1.10.287.840', NULL, NULL, NULL, NULL, 'Mycolic acid cyclopropane synthase domain like', NULL, NULL, 15939, 5),
(230455, NULL, 'G3DSA:3.30.1300.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230456, NULL, 'G3DSA:3.30.70.1270', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230457, NULL, 'G3DSA:4.10.80.150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230458, NULL, 'G3DSA:1.10.10.830', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230459, NULL, 'G3DSA:1.10.220.90', NULL, NULL, NULL, NULL, 'Mistic', NULL, NULL, 29810, 5),
(230460, NULL, 'G3DSA:6.10.140.1480', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230461, NULL, 'G3DSA:3.30.1110.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230462, NULL, 'G3DSA:6.10.250.3080', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230463, NULL, 'G3DSA:2.60.40.2240', NULL, NULL, NULL, NULL, '', NULL, NULL, 36506, 5),
(230464, NULL, 'G3DSA:3.90.1240.10', NULL, NULL, NULL, NULL, 'Metalloproteases ("zincins"), catalytic domain like', NULL, NULL, NULL, 5),
(230465, NULL, 'G3DSA:1.10.2020.10', NULL, NULL, NULL, NULL, 'uronate isomerase, domain 2, chain A', NULL, NULL, NULL, 5),
(230466, NULL, 'G3DSA:6.10.140.760', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230467, NULL, 'G3DSA:2.60.40.3790', NULL, NULL, NULL, NULL, '', NULL, NULL, 32296, 5),
(230468, NULL, 'G3DSA:3.30.780.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230469, NULL, 'G3DSA:3.40.1730.10', NULL, NULL, NULL, NULL, 'pa0076 domain', NULL, NULL, 33608, 5),
(230470, NULL, 'G3DSA:2.20.25.80', NULL, NULL, NULL, NULL, 'WRKY domain', NULL, NULL, 31292, 5),
(230471, NULL, 'G3DSA:3.40.525.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28268, 5),
(230472, NULL, 'G3DSA:1.10.8.610', NULL, NULL, NULL, NULL, '', NULL, NULL, 35874, 5),
(230473, NULL, 'G3DSA:3.30.1490.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230474, NULL, 'G3DSA:4.10.1230.10', NULL, NULL, NULL, NULL, 'Ecotin, trypsin inhibitor', NULL, NULL, 22479, 5),
(230475, NULL, 'G3DSA:4.10.970.10', NULL, NULL, NULL, NULL, 'Ku70, bridge and pillars', NULL, NULL, 25572, 5),
(230476, NULL, 'G3DSA:1.20.1170.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230477, NULL, 'G3DSA:3.30.230.20', NULL, NULL, NULL, NULL, 'lpxc deacetylase, domain 1', NULL, NULL, 13999, 5),
(230478, NULL, 'G3DSA:2.160.10.10', NULL, NULL, NULL, NULL, 'Hexapeptide repeat proteins', NULL, NULL, NULL, 5);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(230479, NULL, 'G3DSA:1.10.472.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230480, NULL, 'G3DSA:3.30.160.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 33411, 5),
(230481, NULL, 'G3DSA:2.60.40.2070', NULL, NULL, NULL, NULL, '', NULL, NULL, 35133, 5),
(230482, NULL, 'G3DSA:1.20.58.160', NULL, NULL, NULL, NULL, '', NULL, NULL, 31024, 5),
(230483, NULL, 'G3DSA:1.25.40.190', NULL, NULL, NULL, NULL, '', NULL, NULL, 31789, 5),
(230484, NULL, 'G3DSA:1.20.120.610', NULL, NULL, NULL, NULL, '', NULL, NULL, 26425, 5),
(230485, NULL, 'G3DSA:2.60.40.3210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230486, NULL, 'G3DSA:6.10.140.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230487, NULL, 'G3DSA:3.90.1150.180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230488, NULL, 'G3DSA:1.20.120.820', NULL, NULL, NULL, NULL, '', NULL, NULL, 33058, 5),
(230489, NULL, 'G3DSA:2.60.270.30', NULL, NULL, NULL, NULL, 'Vibrio parahaemolyticus thermostable direct hemolysin', NULL, NULL, 33517, 5),
(230490, NULL, 'G3DSA:6.10.140.980', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230491, NULL, 'G3DSA:6.10.140.1440', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230492, NULL, 'G3DSA:1.20.120.1770', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230493, NULL, 'G3DSA:1.20.5.590', NULL, NULL, NULL, NULL, 'Single helix bin', NULL, NULL, NULL, 5),
(230494, NULL, 'G3DSA:1.20.1280.310', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230495, NULL, 'G3DSA:3.30.60.290', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230496, NULL, 'G3DSA:2.40.128.660', NULL, NULL, NULL, NULL, 'Uncharacterised protein PF15525, DUF4652', NULL, NULL, NULL, 5),
(230497, NULL, 'G3DSA:2.30.30.520', NULL, NULL, NULL, NULL, '', NULL, NULL, 29221, 5),
(230498, NULL, 'G3DSA:2.40.480.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 36173, 5),
(230499, NULL, 'G3DSA:3.90.70.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230500, NULL, 'G3DSA:2.60.40.4130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230501, NULL, 'G3DSA:1.10.10.2890', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230502, NULL, 'G3DSA:6.20.10.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230503, NULL, 'G3DSA:6.10.250.2850', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230504, NULL, 'G3DSA:6.10.160.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 31243, 5),
(230505, NULL, 'G3DSA:3.30.730.20', NULL, NULL, NULL, NULL, 'Cell division activator CedA', NULL, NULL, 32237, 5),
(230506, NULL, 'G3DSA:1.20.1550.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 15817, 5),
(230507, NULL, 'G3DSA:3.30.1160.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31161, 5),
(230508, NULL, 'G3DSA:3.40.1580.20', NULL, NULL, NULL, NULL, 'Syd protein', NULL, NULL, 33834, 5),
(230509, NULL, 'G3DSA:6.10.140.190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230510, NULL, 'G3DSA:4.10.640.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 32725, 5),
(230511, NULL, 'G3DSA:3.30.40.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 13826, 5),
(230512, NULL, 'G3DSA:1.20.1730.10', NULL, NULL, NULL, NULL, 'Sodium/glucose cotransporter', NULL, NULL, 29866, 5),
(230513, NULL, 'G3DSA:3.90.1640.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230514, NULL, 'G3DSA:3.40.50.10940', NULL, NULL, NULL, NULL, '', NULL, NULL, 32294, 5),
(230515, NULL, 'G3DSA:1.20.190.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31631, 5),
(230516, NULL, 'G3DSA:3.30.1330.220', NULL, NULL, NULL, NULL, 'Arterivirus nonstructural protein 7 alpha', NULL, NULL, 31397, 5),
(230517, NULL, 'G3DSA:3.30.2250.10', NULL, NULL, NULL, NULL, 'Bifunctional DNA primase/polymerase domain', NULL, NULL, NULL, 5),
(230518, NULL, 'G3DSA:3.30.2090.10', NULL, NULL, NULL, NULL, 'Multidrug efflux transporter AcrB TolC docking domain; DN and DC subdomains', NULL, NULL, 26581, 5),
(230519, NULL, 'G3DSA:1.20.58.1630', NULL, NULL, NULL, NULL, 'Chaperone lipoprotein PulS/OutS', NULL, NULL, 31210, 5),
(230520, NULL, 'G3DSA:2.60.40.3420', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230521, NULL, 'G3DSA:2.60.40.4110', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF4354', NULL, NULL, NULL, 5); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(230522, NULL, 'G3DSA:1.20.1280.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230523, NULL, 'G3DSA:6.20.250.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230524, NULL, 'G3DSA:2.60.120.1210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230525, NULL, 'G3DSA:3.30.70.2450', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230526, NULL, 'G3DSA:6.10.10.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 36329, 5),
(230527, NULL, 'G3DSA:1.20.58.460', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230528, NULL, 'G3DSA:3.30.1330.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 24892, 5),
(230529, NULL, 'G3DSA:3.30.720.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230530, NULL, 'G3DSA:2.40.50.730', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230531, NULL, 'G3DSA:2.20.20.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230532, NULL, 'G3DSA:1.10.40.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230533, NULL, 'G3DSA:1.20.58.610', NULL, NULL, NULL, NULL, 'Cdc37, Hsp90 binding domain', NULL, NULL, 31380, 5),
(230534, NULL, 'G3DSA:3.30.70.1570', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230535, NULL, 'G3DSA:3.30.1330.120', NULL, NULL, NULL, NULL, '', NULL, NULL, 35078, 5),
(230536, NULL, 'G3DSA:3.40.850.10', NULL, NULL, NULL, NULL, 'Kinesin motor domain', NULL, NULL, 28351, 5),
(230537, NULL, 'G3DSA:1.10.150.850', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230538, NULL, 'G3DSA:4.10.365.10', NULL, NULL, NULL, NULL, 'p27', NULL, NULL, 36226, 5),
(230539, NULL, 'G3DSA:3.10.20.710', NULL, NULL, NULL, NULL, '', NULL, NULL, 27119, 5),
(230540, NULL, 'G3DSA:3.40.605.10', NULL, NULL, NULL, NULL, 'Aldehyde Dehydrogenase; Chain A, domain 1', NULL, NULL, 11560, 5),
(230541, NULL, 'G3DSA:1.10.3780.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230542, NULL, 'G3DSA:4.10.320.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 30971, 5),
(230543, NULL, 'G3DSA:1.25.40.270', NULL, NULL, NULL, NULL, '', NULL, NULL, 15815, 5),
(230544, NULL, 'G3DSA:3.30.160.830', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230545, NULL, 'G3DSA:1.25.40.180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230546, NULL, 'G3DSA:3.40.50.1220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230547, NULL, 'G3DSA:3.30.70.2320', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230548, NULL, 'G3DSA:2.40.33.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 8970, 5),
(230549, NULL, 'G3DSA:6.10.300.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230550, NULL, 'G3DSA:1.10.150.280', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230551, NULL, 'G3DSA:2.60.40.2150', NULL, NULL, NULL, NULL, '', NULL, NULL, 35224, 5),
(230552, NULL, 'G3DSA:2.40.128.590', NULL, NULL, NULL, NULL, 'CpcT/CpeT domain', NULL, NULL, 33765, 5),
(230553, NULL, 'G3DSA:3.30.2010.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 27903, 5),
(230554, NULL, 'G3DSA:6.10.250.2550', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230555, NULL, 'G3DSA:3.30.160.150', NULL, NULL, NULL, NULL, 'Lipoprotein like domain', NULL, NULL, NULL, 5),
(230556, NULL, 'G3DSA:2.40.230.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 31839, 5),
(230557, NULL, 'G3DSA:3.90.1660.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230558, NULL, 'G3DSA:1.10.8.570', NULL, NULL, NULL, NULL, 'Hypothetical protein YfmB', NULL, NULL, 27797, 5),
(230559, NULL, 'G3DSA:2.30.29.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230560, NULL, 'G3DSA:3.30.200.260', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230561, NULL, 'G3DSA:6.10.140.1350', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230562, NULL, 'G3DSA:3.40.50.12440', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230563, NULL, 'G3DSA:3.90.1150.210', NULL, NULL, NULL, NULL, '', NULL, NULL, 34966, 5),
(230564, NULL, 'G3DSA:1.20.1260.140', NULL, NULL, NULL, NULL, 'Alternative oxidase', NULL, NULL, 32913, 5),
(230565, NULL, 'G3DSA:6.10.250.1000', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230566, NULL, 'G3DSA:3.40.1190.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31792, 5);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(230567, NULL, 'G3DSA:2.10.290.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 23544, 5),
(230568, NULL, 'G3DSA:2.60.520.10', NULL, NULL, NULL, NULL, 'Phage fibre proteins', NULL, NULL, NULL, 5),
(230569, NULL, 'G3DSA:6.20.140.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230570, NULL, 'G3DSA:3.30.70.2540', NULL, NULL, NULL, NULL, '', NULL, NULL, 36084, 5),
(230571, NULL, 'G3DSA:3.30.920.30', NULL, NULL, NULL, NULL, 'Hypothetical protein.', NULL, NULL, 32357, 5),
(230572, NULL, 'G3DSA:2.30.30.490', NULL, NULL, NULL, NULL, '', NULL, NULL, 34418, 5),
(230573, NULL, 'G3DSA:1.10.10.2670', NULL, NULL, NULL, NULL, '', NULL, NULL, 30225, 5),
(230574, NULL, 'G3DSA:1.10.3400.10', NULL, NULL, NULL, NULL, 'af_2093 domain like', NULL, NULL, 15558, 5),
(230575, NULL, 'G3DSA:1.10.418.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230576, NULL, 'G3DSA:2.60.40.2370', NULL, NULL, NULL, NULL, '', NULL, NULL, 30599, 5),
(230577, NULL, 'G3DSA:2.40.50.250', NULL, NULL, NULL, NULL, 'bipa protein', NULL, NULL, 35079, 5),
(230578, NULL, 'G3DSA:1.20.1440.330', NULL, NULL, NULL, NULL, '', NULL, NULL, 36418, 5),
(230579, NULL, 'G3DSA:2.60.120.820', NULL, NULL, NULL, NULL, 'PHR domain', NULL, NULL, 33767, 5),
(230580, NULL, 'G3DSA:6.10.250.2770', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230581, NULL, 'G3DSA:4.10.1220.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230582, NULL, 'G3DSA:2.40.470.10', NULL, NULL, NULL, NULL, 'catalase hpii domain', NULL, NULL, NULL, 5),
(230583, NULL, 'G3DSA:6.20.50.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230584, NULL, 'G3DSA:2.30.29.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 13231, 5),
(230585, NULL, 'G3DSA:3.30.390.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 23143, 5),
(230586, NULL, 'G3DSA:1.50.10.150', NULL, NULL, NULL, NULL, '', NULL, NULL, 32906, 5),
(230587, NULL, 'G3DSA:3.90.520.10', NULL, NULL, NULL, NULL, 'SMAD MH1 domain', NULL, NULL, 29529, 5),
(230588, NULL, 'G3DSA:3.30.1540.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 34336, 5),
(230589, NULL, 'G3DSA:1.10.20.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230590, NULL, 'G3DSA:1.20.120.960', NULL, NULL, NULL, NULL, 'Histidine kinase NarX, sensor domain', NULL, NULL, 34559, 5),
(230591, NULL, 'G3DSA:3.30.420.580', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230592, NULL, 'G3DSA:1.10.3380.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230593, NULL, 'G3DSA:6.10.140.1570', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230594, NULL, 'G3DSA:3.50.80.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230595, NULL, 'G3DSA:1.20.5.3960', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230596, NULL, 'G3DSA:1.10.3670.10', NULL, NULL, NULL, NULL, 'Putative xylanase like domain', NULL, NULL, NULL, 5),
(230597, NULL, 'G3DSA:1.20.1270.440', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230598, NULL, 'G3DSA:2.40.280.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 8364, 5),
(230599, NULL, 'G3DSA:1.10.10.2340', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230600, NULL, 'G3DSA:3.90.930.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230601, NULL, 'G3DSA:1.20.80.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 8065, 5),
(230602, NULL, 'G3DSA:1.20.58.1710', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230603, NULL, 'G3DSA:3.40.50.10700', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230604, NULL, 'G3DSA:6.10.250.740', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5),
(230605, NULL, 'G3DSA:1.10.10.1250', NULL, NULL, NULL, NULL, '', NULL, NULL, 31775, 5),
(230606, NULL, 'G3DSA:3.30.420.240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230607, NULL, 'G3DSA:1.20.120.1980', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230608, NULL, 'G3DSA:1.10.357.150', NULL, NULL, NULL, NULL, '', NULL, NULL, 37560, 5),
(230609, NULL, 'G3DSA:1.10.10.1790', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230610, NULL, 'G3DSA:6.10.140.1230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230611, NULL, 'G3DSA:1.10.8.1020', NULL, NULL, NULL, NULL, '', NULL, NULL, 36160, 5);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(230612, NULL, 'G3DSA:1.20.120.1010', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230613, NULL, 'G3DSA:3.15.10.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 27584, 5),
(230614, NULL, 'G3DSA:2.30.110.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230615, NULL, 'G3DSA:3.90.820.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230616, NULL, 'G3DSA:3.40.50.10350', NULL, NULL, NULL, NULL, 'Glycerate kinase; domain 1', NULL, NULL, 7527, 5),
(230617, NULL, 'G3DSA:3.40.91.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230618, NULL, 'G3DSA:3.20.170.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 32191, 5),
(230619, NULL, 'G3DSA:6.10.250.2100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230620, NULL, 'G3DSA:2.40.50.270', NULL, NULL, NULL, NULL, 'transglycosylase MltA', NULL, NULL, NULL, 5),
(230621, NULL, 'G3DSA:2.30.130.10', NULL, NULL, NULL, NULL, 'PUA domain', NULL, NULL, 30449, 5),
(230622, NULL, 'G3DSA:2.60.40.1720', NULL, NULL, NULL, NULL, '', NULL, NULL, 32368, 5),
(230623, NULL, 'G3DSA:2.10.10.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 36112, 5),
(230624, NULL, 'G3DSA:6.10.140.430', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230625, NULL, 'G3DSA:3.20.20.100', NULL, NULL, NULL, NULL, '', NULL, NULL, 33295, 5),
(230626, NULL, 'G3DSA:1.20.58.1690', NULL, NULL, NULL, NULL, '', NULL, NULL, 31249, 5),
(230627, NULL, 'G3DSA:3.40.309.10', NULL, NULL, NULL, NULL, 'Aldehyde Dehydrogenase; Chain A, domain 2', NULL, NULL, 11713, 5),
(230628, NULL, 'G3DSA:3.40.1690.10', NULL, NULL, NULL, NULL, 'secretion proteins EscU', NULL, NULL, 26881, 5),
(230629, NULL, 'G3DSA:1.20.120.860', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230630, NULL, 'G3DSA:1.10.10.680', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230631, NULL, 'G3DSA:4.10.40.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230632, NULL, 'G3DSA:1.20.120.1520', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230633, NULL, 'G3DSA:3.90.330.10', NULL, NULL, NULL, NULL, 'Nitrile hydratase alpha /Thiocyanate hydrolase gamma', NULL, NULL, 30545, 5),
(230634, NULL, 'G3DSA:6.10.140.1690', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230635, NULL, 'G3DSA:1.25.40.590', NULL, NULL, NULL, NULL, 'Type IV / VI secretion system, DotU', NULL, NULL, 33535, 5),
(230636, NULL, 'G3DSA:2.40.10.360', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230637, NULL, 'G3DSA:1.10.10.1280', NULL, NULL, NULL, NULL, '', NULL, NULL, 30022, 5),
(230638, NULL, 'G3DSA:3.10.450.560', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230639, NULL, 'G3DSA:3.30.70.3270', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230640, NULL, 'G3DSA:1.10.10.1730', NULL, NULL, NULL, NULL, 'Folliculin', NULL, NULL, 36452, 5),
(230641, NULL, 'G3DSA:3.10.20.470', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230642, NULL, 'G3DSA:2.30.30.850', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230643, NULL, 'G3DSA:1.10.490.50', NULL, NULL, NULL, NULL, '', NULL, NULL, 29957, 5),
(230644, NULL, 'G3DSA:6.10.30.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230645, NULL, 'G3DSA:6.10.250.1550', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230646, NULL, 'G3DSA:3.40.50.12350', NULL, NULL, NULL, NULL, '', NULL, NULL, 30310, 5),
(230647, NULL, 'G3DSA:6.20.390.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230648, NULL, 'G3DSA:1.10.287.880', NULL, NULL, NULL, NULL, 'Hypothetical protein YfhH domain', NULL, NULL, NULL, 5),
(230649, NULL, 'G3DSA:1.10.10.2520', NULL, NULL, NULL, NULL, 'Cell wall hydrolase SleB, domain 1', NULL, NULL, 30016, 5),
(230650, NULL, 'G3DSA:1.10.150.520', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230651, NULL, 'G3DSA:3.30.70.1430', NULL, NULL, NULL, NULL, 'Multidrug efflux transporter AcrB pore domain', NULL, NULL, NULL, 5),
(230652, NULL, 'G3DSA:1.20.120.2010', NULL, NULL, NULL, NULL, 'NAB conserved domain 2', NULL, NULL, 27216, 5),
(230653, NULL, 'G3DSA:4.10.80.10', NULL, NULL, NULL, NULL, 'Picornavirus coat protein VP4', NULL, NULL, 31899, 5),
(230654, NULL, 'G3DSA:1.10.3970.10', NULL, NULL, NULL, NULL, 'BSD domain', NULL, NULL, 25941, 5);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(230655, NULL, 'G3DSA:3.30.360.10', NULL, NULL, NULL, NULL, 'Dihydrodipicolinate Reductase; domain 2', NULL, NULL, NULL, 5),
(230656, NULL, 'G3DSA:3.30.70.590', NULL, NULL, NULL, NULL, 'Poly(A) polymerase predicted RNA binding domain', NULL, NULL, NULL, 5),
(230657, NULL, 'G3DSA:3.30.300.350', NULL, NULL, NULL, NULL, '', NULL, NULL, 27759, 5),
(230658, NULL, 'G3DSA:3.40.5.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 35867, 5),
(230659, NULL, 'G3DSA:2.60.40.2810', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230660, NULL, 'G3DSA:2.60.40.4190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230661, NULL, 'G3DSA:1.25.40.840', NULL, NULL, NULL, NULL, '', NULL, NULL, 33704, 5),
(230662, NULL, 'G3DSA:3.60.15.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28436, 5),
(230663, NULL, 'G3DSA:3.90.1570.10', NULL, NULL, NULL, NULL, 'tt1808, chain A', NULL, NULL, 13622, 5),
(230664, NULL, 'G3DSA:2.20.70.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230665, NULL, 'G3DSA:2.60.40.2280', NULL, NULL, NULL, NULL, '', NULL, NULL, 31302, 5),
(230666, NULL, 'G3DSA:1.20.58.900', NULL, NULL, NULL, NULL, '', NULL, NULL, 33420, 5),
(230667, NULL, 'G3DSA:3.30.930.10', NULL, NULL, NULL, NULL, 'Bira Bifunctional Protein; Domain 2', NULL, NULL, 37340, 5),
(230668, NULL, 'G3DSA:2.60.270.20', NULL, NULL, NULL, NULL, 'Cytolysin/lectin', NULL, NULL, 8312, 5),
(230669, NULL, 'G3DSA:3.30.450.50', NULL, NULL, NULL, NULL, 'Longin domain', NULL, NULL, NULL, 5),
(230670, NULL, 'G3DSA:1.20.5.700', NULL, NULL, NULL, NULL, 'Single helix bin', NULL, NULL, NULL, 5),
(230671, NULL, 'G3DSA:1.20.120.400', NULL, NULL, NULL, NULL, '', NULL, NULL, 31300, 5),
(230672, NULL, 'G3DSA:6.20.320.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230673, NULL, 'G3DSA:1.20.1260.90', NULL, NULL, NULL, NULL, '', NULL, NULL, 32954, 5),
(230674, NULL, 'G3DSA:1.20.1440.200', NULL, NULL, NULL, NULL, '', NULL, NULL, 33206, 5),
(230675, NULL, 'G3DSA:3.40.50.11840', NULL, NULL, NULL, NULL, 'Diphthamide synthesis DPH1/DPH2 domain 1', NULL, NULL, 34787, 5),
(230676, NULL, 'G3DSA:3.40.5.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28289, 5),
(230677, NULL, 'G3DSA:3.30.160.170', NULL, NULL, NULL, NULL, '', NULL, NULL, 23322, 5),
(230678, NULL, 'G3DSA:6.10.140.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 29870, 5),
(230679, NULL, 'G3DSA:3.10.28.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230680, NULL, 'G3DSA:1.20.58.370', NULL, NULL, NULL, NULL, '', NULL, NULL, 17200, 5),
(230681, NULL, 'G3DSA:6.10.250.2640', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230682, NULL, 'G3DSA:1.20.5.460', NULL, NULL, NULL, NULL, 'Single helix bin', NULL, NULL, NULL, 5),
(230683, NULL, 'G3DSA:3.30.2320.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230684, NULL, 'G3DSA:2.60.120.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 25659, 5),
(230685, NULL, 'G3DSA:1.10.8.370', NULL, NULL, NULL, NULL, 'nsp7 replicase', NULL, NULL, 33114, 5),
(230686, NULL, 'G3DSA:1.10.150.310', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230687, NULL, 'G3DSA:3.50.30.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230688, NULL, 'G3DSA:2.60.120.1340', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230689, NULL, 'G3DSA:6.10.250.1760', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230690, NULL, 'G3DSA:3.90.1380.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29868, 5),
(230691, NULL, 'G3DSA:3.30.70.3060', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230692, NULL, 'G3DSA:1.10.1200.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230693, NULL, 'G3DSA:3.30.2310.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 29962, 5),
(230694, NULL, 'G3DSA:2.10.70.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230695, NULL, 'G3DSA:3.30.70.380', NULL, NULL, NULL, NULL, '', NULL, NULL, 31473, 5),
(230696, NULL, 'G3DSA:2.60.290.11', NULL, NULL, NULL, NULL, '', NULL, NULL, 29674, 5),
(230697, NULL, 'G3DSA:4.10.49.10', NULL, NULL, NULL, NULL, 'Cytochrome c oxidase subunit VIIc', NULL, NULL, 30830, 5),
(230698, NULL, 'G3DSA:3.10.20.770', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(230699, NULL, 'G3DSA:2.60.240.10', NULL, NULL, NULL, NULL, 'Major secreted virus protein', NULL, NULL, 33325, 5),
(230700, NULL, 'G3DSA:3.30.60.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230701, NULL, 'G3DSA:1.20.58.1390', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230702, NULL, 'G3DSA:2.60.40.4380', NULL, NULL, NULL, NULL, 'Translational regulator CsrA', NULL, NULL, 32680, 5),
(230703, NULL, 'G3DSA:3.30.70.2200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230704, NULL, 'G3DSA:4.10.410.10', NULL, NULL, NULL, NULL, 'Pancreatic trypsin inhibitor Kunitz domain', NULL, NULL, 28419, 5),
(230705, NULL, 'G3DSA:2.60.120.1190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230706, NULL, 'G3DSA:3.30.110.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230707, NULL, 'G3DSA:2.30.170.40', NULL, NULL, NULL, NULL, 'Ribosomal protein L28/L24', NULL, NULL, 29990, 5),
(230708, NULL, 'G3DSA:3.30.60.50', NULL, NULL, NULL, NULL, 'Hypothetical oxidoreductase yiak; domain 3', NULL, NULL, NULL, 5),
(230709, NULL, 'G3DSA:6.10.250.2340', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230710, NULL, 'G3DSA:1.10.357.100', NULL, NULL, NULL, NULL, 'Dsl1p vesicle tethering complex, Tip20p subunit, domain C', NULL, NULL, 30289, 5),
(230711, NULL, 'G3DSA:1.20.5.4090', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230712, NULL, 'G3DSA:3.60.21.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230713, NULL, 'G3DSA:2.60.120.1670', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230714, NULL, 'G3DSA:3.40.50.11040', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230715, NULL, 'G3DSA:3.30.360.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230716, NULL, 'G3DSA:3.40.1000.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 33719, 5),
(230717, NULL, 'G3DSA:3.90.25.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230718, NULL, 'G3DSA:2.60.40.1930', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230719, NULL, 'G3DSA:2.10.70.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230720, NULL, 'G3DSA:3.30.1820.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 7814, 5),
(230721, NULL, 'G3DSA:3.10.540.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230722, NULL, 'G3DSA:2.60.120.520', NULL, NULL, NULL, NULL, '', NULL, NULL, 26433, 5),
(230723, NULL, 'G3DSA:6.10.250.2310', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230724, NULL, 'G3DSA:3.30.230.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230725, NULL, 'G3DSA:3.40.390.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230726, NULL, 'G3DSA:2.60.40.2030', NULL, NULL, NULL, NULL, '', NULL, NULL, 31711, 5),
(230727, NULL, 'G3DSA:3.30.1440.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 14958, 5),
(230728, NULL, 'G3DSA:1.10.287.600', NULL, NULL, NULL, NULL, 'Helix hairpin bin', NULL, NULL, 16690, 5),
(230729, NULL, 'G3DSA:3.30.1920.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230730, NULL, 'G3DSA:3.40.50.1820', NULL, NULL, NULL, NULL, 'alpha/beta hydrolase', NULL, NULL, 24739, 5),
(230731, NULL, 'G3DSA:2.60.290.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230732, NULL, 'G3DSA:3.30.1690.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230733, NULL, 'G3DSA:1.20.120.1070', NULL, NULL, NULL, NULL, '', NULL, NULL, 37284, 5),
(230734, NULL, 'G3DSA:4.10.860.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230735, NULL, 'G3DSA:1.10.10.1490', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230736, NULL, 'G3DSA:3.30.420.540', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230737, NULL, 'G3DSA:3.90.380.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230738, NULL, 'G3DSA:2.60.90.20', NULL, NULL, NULL, NULL, 'Virus attachment protein , globular domain', NULL, NULL, NULL, 5),
(230739, NULL, 'G3DSA:3.10.20.260', NULL, NULL, NULL, NULL, '', NULL, NULL, 29693, 5),
(230740, NULL, 'G3DSA:1.20.120.1730', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230741, NULL, 'G3DSA:3.30.70.2660', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230742, NULL, 'G3DSA:3.10.490.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 34882, 5);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(230743, NULL, 'G3DSA:1.10.132.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230744, NULL, 'G3DSA:6.10.250.440', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230745, NULL, 'G3DSA:2.160.20.50', NULL, NULL, NULL, NULL, 'Insect antifreeze protein', NULL, NULL, NULL, 5),
(230746, NULL, 'G3DSA:1.10.8.1180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230747, NULL, 'G3DSA:4.10.490.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230748, NULL, 'G3DSA:3.30.1880.10', NULL, NULL, NULL, NULL, 'protein ne1242 domain like', NULL, NULL, 20929, 5),
(230749, NULL, 'G3DSA:4.10.470.10', NULL, NULL, NULL, NULL, 'Ricin (A Subunit), domain 2', NULL, NULL, 11452, 5),
(230750, NULL, 'G3DSA:3.30.1330.90', NULL, NULL, NULL, NULL, '', NULL, NULL, 24105, 5),
(230751, NULL, 'G3DSA:3.40.50.12790', NULL, NULL, NULL, NULL, 'FHIPEP family, domain 4', NULL, NULL, 35260, 5),
(230752, NULL, 'G3DSA:2.30.36.70', NULL, NULL, NULL, NULL, 'Actin; Chain A, domain 2', NULL, NULL, NULL, 5),
(230753, NULL, 'G3DSA:1.10.10.2040', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230754, NULL, 'G3DSA:2.60.40.1590', NULL, NULL, NULL, NULL, 'Peptidoglycan hydrolase domains', NULL, NULL, NULL, 5),
(230755, NULL, 'G3DSA:6.10.140.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230756, NULL, 'G3DSA:1.20.120.1220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230757, NULL, 'G3DSA:3.30.70.3090', NULL, NULL, NULL, NULL, '', NULL, NULL, 35042, 5),
(230758, NULL, 'G3DSA:3.30.70.2970', NULL, NULL, NULL, NULL, 'Protein of unknown function (DUF541), domain 2', NULL, NULL, NULL, 5),
(230759, NULL, 'G3DSA:3.30.1950.10', NULL, NULL, NULL, NULL, 'wza like domain', NULL, NULL, NULL, 5),
(230760, NULL, 'G3DSA:3.90.70.110', NULL, NULL, NULL, NULL, 'Alphavirus nsP2 protease domain', NULL, NULL, 36981, 5),
(230761, NULL, 'G3DSA:2.20.28.150', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5),
(230762, NULL, 'G3DSA:3.30.1460.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 18765, 5),
(230763, NULL, 'G3DSA:1.10.720.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230764, NULL, 'G3DSA:3.55.20.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 7655, 5),
(230765, NULL, 'G3DSA:3.30.40.80', NULL, NULL, NULL, NULL, 'Effector protein NleG', NULL, NULL, 31432, 5),
(230766, NULL, 'G3DSA:2.40.50.170', NULL, NULL, NULL, NULL, 'Cysteine proteinases. Chain C', NULL, NULL, NULL, 5),
(230767, NULL, 'G3DSA:1.10.10.1580', NULL, NULL, NULL, NULL, '', NULL, NULL, 36260, 5),
(230768, NULL, 'G3DSA:3.30.70.860', NULL, NULL, NULL, NULL, '', NULL, NULL, 27622, 5),
(230769, NULL, 'G3DSA:2.40.30.190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230770, NULL, 'G3DSA:3.30.70.1140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230771, NULL, 'G3DSA:6.10.250.1040', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230772, NULL, 'G3DSA:2.40.160.180', NULL, NULL, NULL, NULL, '', NULL, NULL, 33554, 5),
(230773, NULL, 'G3DSA:2.130.10.130', NULL, NULL, NULL, NULL, '', NULL, NULL, 23792, 5),
(230774, NULL, 'G3DSA:1.10.238.120', NULL, NULL, NULL, NULL, '', NULL, NULL, 15449, 5),
(230775, NULL, 'G3DSA:2.40.128.130', NULL, NULL, NULL, NULL, '', NULL, NULL, 31884, 5),
(230776, NULL, 'G3DSA:1.20.5.2650', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230777, NULL, 'G3DSA:1.20.1370.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31803, 5),
(230778, NULL, 'G3DSA:1.20.5.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230779, NULL, 'G3DSA:2.60.40.3880', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230780, NULL, 'G3DSA:1.10.3550.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 22750, 5),
(230781, NULL, 'G3DSA:1.20.120.1270', NULL, NULL, NULL, NULL, 'CagA exotoxin domain III', NULL, NULL, NULL, 5),
(230782, NULL, 'G3DSA:1.20.1270.260', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230783, NULL, 'G3DSA:3.30.40.220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230784, NULL, 'G3DSA:3.10.290.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230785, NULL, 'G3DSA:3.30.450.210', NULL, NULL, NULL, NULL, '', NULL, NULL, 32338, 5);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(230786, NULL, 'G3DSA:1.25.40.120', NULL, NULL, NULL, NULL, 'Protein prenylyltransferase', NULL, NULL, NULL, 5),
(230787, NULL, 'G3DSA:2.20.70.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230788, NULL, 'G3DSA:3.30.70.80', NULL, NULL, NULL, NULL, 'Peptidase S8 propeptide/proteinase inhibitor I9', NULL, NULL, 29343, 5),
(230789, NULL, 'G3DSA:1.10.720.50', NULL, NULL, NULL, NULL, 'PWWP, helical domain', NULL, NULL, NULL, 5),
(230790, NULL, 'G3DSA:3.60.21.40', NULL, NULL, NULL, NULL, 'GpdQ, catalytic alpha/beta sandwich domain', NULL, NULL, 34979, 5),
(230791, NULL, 'G3DSA:3.30.1070.10', NULL, NULL, NULL, NULL, 'Cell division topological specificity factor MinE', NULL, NULL, 31584, 5),
(230792, NULL, 'G3DSA:1.10.246.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230793, NULL, 'G3DSA:3.40.50.1260', NULL, NULL, NULL, NULL, '', NULL, NULL, 8907, 5),
(230794, NULL, 'G3DSA:6.10.250.290', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230795, NULL, 'G3DSA:2.10.25.20', NULL, NULL, NULL, NULL, 'reovirus attachment protein sigma1; domain 1', NULL, NULL, NULL, 5),
(230796, NULL, 'G3DSA:3.30.310.230', NULL, NULL, NULL, NULL, '', NULL, NULL, 31223, 5),
(230797, NULL, 'G3DSA:1.10.287.390', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230798, NULL, 'G3DSA:3.40.1540.10', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF1780, putative endonuclease', NULL, NULL, 29880, 5),
(230799, NULL, 'G3DSA:1.10.3630.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 27416, 5),
(230800, NULL, 'G3DSA:1.20.5.1350', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230801, NULL, 'G3DSA:1.20.1500.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 15761, 5),
(230802, NULL, 'G3DSA:1.20.5.750', NULL, NULL, NULL, NULL, 'Moricin domain', NULL, NULL, 29350, 5),
(230803, NULL, 'G3DSA:3.40.50.1470', NULL, NULL, NULL, NULL, '', NULL, NULL, 27523, 5),
(230804, NULL, 'G3DSA:1.10.10.1940', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230805, NULL, 'G3DSA:3.40.630.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230806, NULL, 'G3DSA:1.25.40.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 36416, 5),
(230807, NULL, 'G3DSA:2.30.30.1150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230808, NULL, 'G3DSA:3.90.15.10', NULL, NULL, NULL, NULL, 'Topoisomerase I; Chain A, domain 3', NULL, NULL, 7008, 5),
(230809, NULL, 'G3DSA:3.40.50.12650', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230810, NULL, 'G3DSA:4.10.810.10', NULL, NULL, NULL, NULL, 'Virus Scaffolding Protein; Chain A', NULL, NULL, 25774, 5),
(230811, NULL, 'G3DSA:6.20.160.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230812, NULL, 'G3DSA:3.40.50.11860', NULL, NULL, NULL, NULL, 'Diphthamide synthesis DPH1/DPH2 domain 3', NULL, NULL, 34519, 5),
(230813, NULL, 'G3DSA:1.20.225.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 30302, 5),
(230814, NULL, 'G3DSA:2.20.60.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28015, 5),
(230815, NULL, 'G3DSA:1.20.1120.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29032, 5),
(230816, NULL, 'G3DSA:1.10.260.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230817, NULL, 'G3DSA:1.20.5.2230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230818, NULL, 'G3DSA:2.60.220.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230819, NULL, 'G3DSA:2.40.10.510', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230820, NULL, 'G3DSA:3.30.750.24', NULL, NULL, NULL, NULL, 'STAS domain', NULL, NULL, 30454, 5),
(230821, NULL, 'G3DSA:2.10.77.10', NULL, NULL, NULL, NULL, 'Hemagglutinin Chain A, Domain 2', NULL, NULL, NULL, 5),
(230822, NULL, 'G3DSA:1.10.287.3290', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230823, NULL, 'G3DSA:3.30.1490.230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230824, NULL, 'G3DSA:3.30.720.200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230825, NULL, 'G3DSA:4.10.1000.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230826, NULL, 'G3DSA:1.20.5.1170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230827, NULL, 'G3DSA:1.20.120.1930', NULL, NULL, NULL, NULL, 'Uncharacterised protein PF16691, DUF5062', NULL, NULL, 28515, 5);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(230828, NULL, 'G3DSA:3.30.310.110', NULL, NULL, NULL, NULL, '', NULL, NULL, 9537, 5),
(230829, NULL, 'G3DSA:6.10.140.640', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230830, NULL, 'G3DSA:1.10.245.10', NULL, NULL, NULL, NULL, 'SWIB/MDM2 domain', NULL, NULL, 28635, 5),
(230831, NULL, 'G3DSA:1.10.10.1070', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230832, NULL, 'G3DSA:2.70.98.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 18726, 5),
(230833, NULL, 'G3DSA:1.10.405.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230834, NULL, 'G3DSA:1.10.1520.10', NULL, NULL, NULL, NULL, 'Ribonuclease III domain', NULL, NULL, 28487, 5),
(230835, NULL, 'G3DSA:1.25.40.630', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230836, NULL, 'G3DSA:6.10.140.2090', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230837, NULL, 'G3DSA:3.30.310.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230838, NULL, 'G3DSA:2.40.50.420', NULL, NULL, NULL, NULL, 'Envelope glycoprotein gp160, DUF2291, alpha/beta domain', NULL, NULL, NULL, 5),
(230839, NULL, 'G3DSA:3.90.1310.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230840, NULL, 'G3DSA:3.30.750.80', NULL, NULL, NULL, NULL, 'RNA methyltransferase domain (HRMD) like', NULL, NULL, NULL, 5),
(230841, NULL, 'G3DSA:1.20.1700.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 14113, 5),
(230842, NULL, 'G3DSA:2.60.120.690', NULL, NULL, NULL, NULL, 'Proprotein convertase subtilisin/kexin type 9', NULL, NULL, NULL, 5),
(230843, NULL, 'G3DSA:2.60.40.780', NULL, NULL, NULL, NULL, '', NULL, NULL, 28414, 5),
(230844, NULL, 'G3DSA:6.10.250.2890', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230845, NULL, 'G3DSA:3.30.505.10', NULL, NULL, NULL, NULL, 'SH2 domain', NULL, NULL, 28366, 5),
(230846, NULL, 'G3DSA:2.60.460.10', NULL, NULL, NULL, NULL, 'protein yfey like domain', NULL, NULL, 31260, 5),
(230847, NULL, 'G3DSA:6.10.140.1020', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230848, NULL, 'G3DSA:6.10.250.950', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230849, NULL, 'G3DSA:3.90.1680.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32569, 5),
(230850, NULL, 'G3DSA:6.10.140.2110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230851, NULL, 'G3DSA:1.10.246.150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230852, NULL, 'G3DSA:2.40.128.120', NULL, NULL, NULL, NULL, 'Quinohemoprotein amine dehydrogenase alpha subunit, domain 2', NULL, NULL, 32236, 5),
(230853, NULL, 'G3DSA:2.30.30.940', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230854, NULL, 'G3DSA:1.10.3350.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 8926, 5),
(230855, NULL, 'G3DSA:1.10.275.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 34694, 5),
(230856, NULL, 'G3DSA:3.30.450.190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230857, NULL, 'G3DSA:1.25.50.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230858, NULL, 'G3DSA:2.160.20.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 14009, 5),
(230859, NULL, 'G3DSA:1.20.1090.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230860, NULL, 'G3DSA:2.60.40.2400', NULL, NULL, NULL, NULL, 'Alphavirus E2 glycoprotein, domain C', NULL, NULL, 35115, 5),
(230861, NULL, 'G3DSA:1.10.8.280', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230862, NULL, 'G3DSA:1.10.10.2910', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230863, NULL, 'G3DSA:2.60.120.950', NULL, NULL, NULL, NULL, 'Circovirus capsid protein', NULL, NULL, 32428, 5),
(230864, NULL, 'G3DSA:1.25.40.510', NULL, NULL, NULL, NULL, '', NULL, NULL, 33790, 5),
(230865, NULL, 'G3DSA:3.90.1860.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 27214, 5),
(230866, NULL, 'G3DSA:3.30.160.590', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230867, NULL, 'G3DSA:3.30.300.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 36086, 5),
(230868, NULL, 'G3DSA:3.30.1520.20', NULL, NULL, NULL, NULL, 'Exonuclease ExoI, domain 2', NULL, NULL, 27056, 5),
(230869, NULL, 'G3DSA:1.10.10.1460', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230870, NULL, 'G3DSA:3.40.50.11220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(230871, NULL, 'G3DSA:2.60.40.1150', NULL, NULL, NULL, NULL, '', NULL, NULL, 14008, 5),
(230872, NULL, 'G3DSA:2.170.230.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 20923, 5),
(230873, NULL, 'G3DSA:3.40.30.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230874, NULL, 'G3DSA:3.40.50.11590', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230875, NULL, 'G3DSA:3.10.450.260', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230876, NULL, 'G3DSA:2.60.40.2040', NULL, NULL, NULL, NULL, 'CFA/I fimbrial subunit E, pilin domain', NULL, NULL, NULL, 5),
(230877, NULL, 'G3DSA:3.40.50.10110', NULL, NULL, NULL, NULL, 'DNA polymerase III subunit chi', NULL, NULL, 33492, 5),
(230878, NULL, 'G3DSA:2.20.28.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 23678, 5),
(230879, NULL, 'G3DSA:3.30.70.1800', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230880, NULL, 'G3DSA:1.10.287.2610', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230881, NULL, 'G3DSA:6.10.250.1820', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230882, NULL, 'G3DSA:1.10.287.1520', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230883, NULL, 'G3DSA:3.90.640.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230884, NULL, 'G3DSA:6.10.250.2430', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230885, NULL, 'G3DSA:2.60.40.1470', NULL, NULL, NULL, NULL, 'ApaG domain', NULL, NULL, 27898, 5),
(230886, NULL, 'G3DSA:1.10.1440.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 16793, 5),
(230887, NULL, 'G3DSA:1.20.120.290', NULL, NULL, NULL, NULL, '', NULL, NULL, 2398, 5),
(230888, NULL, 'G3DSA:2.20.25.340', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230889, NULL, 'G3DSA:1.20.150.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 34755, 5),
(230890, NULL, 'G3DSA:1.10.890.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 7078, 5),
(230891, NULL, 'G3DSA:6.10.250.1340', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230892, NULL, 'G3DSA:3.30.70.1690', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230893, NULL, 'G3DSA:2.20.70.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 30137, 5),
(230894, NULL, 'G3DSA:1.10.150.730', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230895, NULL, 'G3DSA:1.10.3200.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31617, 5),
(230896, NULL, 'G3DSA:3.30.930.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230897, NULL, 'G3DSA:1.10.600.10', NULL, NULL, NULL, NULL, 'Farnesyl Diphosphate Synthase', NULL, NULL, 8666, 5),
(230898, NULL, 'G3DSA:3.40.50.10610', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230899, NULL, 'G3DSA:3.40.366.30', NULL, NULL, NULL, NULL, '50S ribosomal protein L16 arginine hydroxylase; Chain A, Domain 2', NULL, NULL, NULL, 5),
(230900, NULL, 'G3DSA:1.10.220.100', NULL, NULL, NULL, NULL, '', NULL, NULL, 34973, 5),
(230901, NULL, 'G3DSA:6.10.250.1250', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230902, NULL, 'G3DSA:2.30.30.1240', NULL, NULL, NULL, NULL, '', NULL, NULL, 35497, 5),
(230903, NULL, 'G3DSA:2.40.50.580', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230904, NULL, 'G3DSA:1.10.287.630', NULL, NULL, NULL, NULL, 'Helix hairpin bin', NULL, NULL, NULL, 5),
(230905, NULL, 'G3DSA:3.40.50.11010', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230906, NULL, 'G3DSA:1.20.120.980', NULL, NULL, NULL, NULL, 'Serine carboxypeptidase S28, SKS domain', NULL, NULL, 34029, 5),
(230907, NULL, 'G3DSA:3.30.360.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230908, NULL, 'G3DSA:3.30.70.1110', NULL, NULL, NULL, NULL, '', NULL, NULL, 29217, 5),
(230909, NULL, 'G3DSA:1.25.40.720', NULL, NULL, NULL, NULL, '', NULL, NULL, 33550, 5),
(230910, NULL, 'G3DSA:3.90.1150.80', NULL, NULL, NULL, NULL, '', NULL, NULL, 32283, 5),
(230911, NULL, 'G3DSA:1.20.58.1800', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230912, NULL, 'G3DSA:2.30.170.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 36649, 5),
(230913, NULL, 'G3DSA:1.20.58.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230914, NULL, 'G3DSA:1.10.3070.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32014, 5);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(230915, NULL, 'G3DSA:3.20.20.220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230916, NULL, 'G3DSA:1.10.3620.10', NULL, NULL, NULL, NULL, 'YdcF like domain', NULL, NULL, NULL, 5),
(230917, NULL, 'G3DSA:1.10.8.850', NULL, NULL, NULL, NULL, '', NULL, NULL, 36077, 5),
(230918, NULL, 'G3DSA:2.60.40.3580', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230919, NULL, 'G3DSA:2.40.15.10', NULL, NULL, NULL, NULL, 'TCL1/MTCP1', NULL, NULL, 28747, 5),
(230920, NULL, 'G3DSA:1.20.1440.50', NULL, NULL, NULL, NULL, '', NULL, NULL, 11846, 5),
(230921, NULL, 'G3DSA:1.10.3730.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230922, NULL, 'G3DSA:3.40.630.10', NULL, NULL, NULL, NULL, 'Zn peptidases', NULL, NULL, NULL, 5),
(230923, NULL, 'G3DSA:2.20.28.50', NULL, NULL, NULL, NULL, 'degv family protein', NULL, NULL, NULL, 5),
(230924, NULL, 'G3DSA:3.30.1490.140', NULL, NULL, NULL, NULL, '', NULL, NULL, 31939, 5),
(230925, NULL, 'G3DSA:6.20.30.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230926, NULL, 'G3DSA:6.10.250.3100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230927, NULL, 'G3DSA:3.20.20.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 31509, 5),
(230928, NULL, 'G3DSA:2.60.40.1610', NULL, NULL, NULL, NULL, 'Domain of unknown function DUF1254', NULL, NULL, 29201, 5),
(230929, NULL, 'G3DSA:3.90.940.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 19131, 5),
(230930, NULL, 'G3DSA:2.170.170.11', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230931, NULL, 'G3DSA:1.10.150.640', NULL, NULL, NULL, NULL, 'AcsD, thumb domain, helical bundle', NULL, NULL, 35121, 5),
(230932, NULL, 'G3DSA:3.40.1550.20', NULL, NULL, NULL, NULL, 'Transcriptional regulator MraZ domain', NULL, NULL, 29854, 5),
(230933, NULL, 'G3DSA:1.10.357.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230934, NULL, 'G3DSA:1.20.970.10', NULL, NULL, NULL, NULL, 'Transferase, Pyrimidine Nucleoside Phosphorylase; Chain C', NULL, NULL, NULL, 5),
(230935, NULL, 'G3DSA:3.30.910.30', NULL, NULL, NULL, NULL, 'Peptidase C10 family', NULL, NULL, NULL, 5),
(230936, NULL, 'G3DSA:1.10.3210.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 27997, 5),
(230937, NULL, 'G3DSA:6.10.250.3400', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230938, NULL, 'G3DSA:2.60.110.10', NULL, NULL, NULL, NULL, 'Thaumatin', NULL, NULL, 33232, 5),
(230939, NULL, 'G3DSA:6.10.140.1800', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230940, NULL, 'G3DSA:3.30.750.180', NULL, NULL, NULL, NULL, '', NULL, NULL, 34923, 5),
(230941, NULL, 'G3DSA:1.10.1740.80', NULL, NULL, NULL, NULL, '', NULL, NULL, 33831, 5),
(230942, NULL, 'G3DSA:1.25.40.420', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230943, NULL, 'G3DSA:3.30.70.400', NULL, NULL, NULL, NULL, '', NULL, NULL, 7329, 5),
(230944, NULL, 'G3DSA:3.10.450.350', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230945, NULL, 'G3DSA:3.30.420.330', NULL, NULL, NULL, NULL, '', NULL, NULL, 29950, 5),
(230946, NULL, 'G3DSA:3.40.50.1380', NULL, NULL, NULL, NULL, '', NULL, NULL, 28731, 5),
(230947, NULL, 'G3DSA:2.30.30.640', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230948, NULL, 'G3DSA:6.10.250.2520', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230949, NULL, 'G3DSA:6.10.250.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230950, NULL, 'G3DSA:2.60.270.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230951, NULL, 'G3DSA:2.60.40.3760', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230952, NULL, 'G3DSA:2.40.155.10', NULL, NULL, NULL, NULL, 'Green fluorescent protein', NULL, NULL, 9913, 5),
(230953, NULL, 'G3DSA:3.90.1330.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29057, 5),
(230954, NULL, 'G3DSA:6.10.250.650', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230955, NULL, 'G3DSA:1.10.239.10', NULL, NULL, NULL, NULL, 'Elicitin domain', NULL, NULL, 29549, 5),
(230956, NULL, 'G3DSA:2.40.160.60', NULL, NULL, NULL, NULL, 'Outer membrane protein transport protein (OMPP1/FadL/TodX)', NULL, NULL, NULL, 5),
(230957, NULL, 'G3DSA:3.10.110.10', NULL, NULL, NULL, NULL, 'Ubiquitin Conjugating Enzyme', NULL, NULL, 11093, 5);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(230958, NULL, 'G3DSA:3.30.160.190', NULL, NULL, NULL, NULL, 'atu1810 like domain', NULL, NULL, 27922, 5),
(230959, NULL, 'G3DSA:2.40.30.300', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230960, NULL, 'G3DSA:1.20.140.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230961, NULL, 'G3DSA:2.70.170.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31554, 5),
(230962, NULL, 'G3DSA:3.10.450.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230963, NULL, 'G3DSA:3.30.70.2960', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230964, NULL, 'G3DSA:6.10.250.2130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230965, NULL, 'G3DSA:6.10.140.1990', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230966, NULL, 'G3DSA:2.60.120.730', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230967, NULL, 'G3DSA:4.10.910.10', NULL, NULL, NULL, NULL, '30s ribosomal protein s13, domain 2', NULL, NULL, 22379, 5),
(230968, NULL, 'G3DSA:3.30.110.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230969, NULL, 'G3DSA:2.60.40.3670', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230970, NULL, 'G3DSA:2.20.20.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230971, NULL, 'G3DSA:6.20.90.20', NULL, NULL, NULL, NULL, 'Benzylsuccinate synthase gamma subunit', NULL, NULL, 27189, 5),
(230972, NULL, 'G3DSA:6.20.220.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32641, 5),
(230973, NULL, 'G3DSA:3.30.1370.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230974, NULL, 'G3DSA:2.60.90.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 9058, 5),
(230975, NULL, 'G3DSA:3.90.1580.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 30928, 5),
(230976, NULL, 'G3DSA:1.20.1260.20', NULL, NULL, NULL, NULL, 'PPE superfamily', NULL, NULL, 32606, 5),
(230977, NULL, 'G3DSA:2.20.150.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230978, NULL, 'G3DSA:3.30.1120.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230979, NULL, 'G3DSA:4.10.210.10', NULL, NULL, NULL, NULL, 'Transactivator Protein (TAT, TAT EIAVY)', NULL, NULL, NULL, 5),
(230980, NULL, 'G3DSA:6.10.120.10', NULL, NULL, NULL, NULL, 'Bacterial aspartate aminotransferase, helical domain', NULL, NULL, NULL, 5),
(230981, NULL, 'G3DSA:1.10.10.2250', NULL, NULL, NULL, NULL, '', NULL, NULL, 30031, 5),
(230982, NULL, 'G3DSA:2.30.26.10', NULL, NULL, NULL, NULL, 'Dihydroorotate Dehydrogenase A, chain A, domain 2', NULL, NULL, 19003, 5),
(230983, NULL, 'G3DSA:3.30.1310.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230984, NULL, 'G3DSA:3.30.9.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230985, NULL, 'G3DSA:1.20.5.2440', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230986, NULL, 'G3DSA:3.30.390.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230987, NULL, 'G3DSA:3.10.20.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 12135, 5),
(230988, NULL, 'G3DSA:1.20.5.1130', NULL, NULL, NULL, NULL, 'Connexin43', NULL, NULL, 29119, 5),
(230989, NULL, 'G3DSA:3.30.1180.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 34860, 5),
(230990, NULL, 'G3DSA:1.10.418.60', NULL, NULL, NULL, NULL, 'Ncd80 complex, Nuf2 subunit', NULL, NULL, 31114, 5),
(230991, NULL, 'G3DSA:2.60.40.1360', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230992, NULL, 'G3DSA:2.60.200.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230993, NULL, 'G3DSA:3.30.870.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 30075, 5),
(230994, NULL, 'G3DSA:6.20.340.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230995, NULL, 'G3DSA:1.20.5.3730', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230996, NULL, 'G3DSA:3.30.310.240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230997, NULL, 'G3DSA:3.75.10.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230998, NULL, 'G3DSA:1.10.287.3160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(230999, NULL, 'G3DSA:3.40.50.11710', NULL, NULL, NULL, NULL, 'Cyclodipeptide synthase', NULL, NULL, 32012, 5),
(231000, NULL, 'G3DSA:1.20.58.290', NULL, NULL, NULL, NULL, 'Hypothetical membrane protein ta0354_69_121.', NULL, NULL, NULL, 5);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(231001, NULL, 'G3DSA:1.20.1450.10', NULL, NULL, NULL, NULL, 'Ammonia/particulate methane monooxygenase, subunit A', NULL, NULL, 28465, 5),
(231002, NULL, 'G3DSA:1.20.120.330', NULL, NULL, NULL, NULL, 'Nucleotidyltransferases  domain 2', NULL, NULL, NULL, 5),
(231003, NULL, 'G3DSA:3.40.50.12470', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231004, NULL, 'G3DSA:1.10.10.1020', NULL, NULL, NULL, NULL, '', NULL, NULL, 31412, 5),
(231005, NULL, 'G3DSA:3.55.10.10', NULL, NULL, NULL, NULL, 'Archease domain', NULL, NULL, 28000, 5),
(231006, NULL, 'G3DSA:3.90.640.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231007, NULL, 'G3DSA:3.40.440.10', NULL, NULL, NULL, NULL, 'Adenylosuccinate Synthetase, subunit A, domain 1', NULL, NULL, 35645, 5),
(231008, NULL, 'G3DSA:1.10.275.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231009, NULL, 'G3DSA:2.60.175.10', NULL, NULL, NULL, NULL, 'Capsid protein VP1,Polyomavirus', NULL, NULL, 32969, 5),
(231010, NULL, 'G3DSA:3.40.250.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231011, NULL, 'G3DSA:2.50.20.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 33362, 5),
(231012, NULL, 'G3DSA:2.60.40.4070', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231013, NULL, 'G3DSA:6.20.180.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231014, NULL, 'G3DSA:3.60.60.10', NULL, NULL, NULL, NULL, 'Penicillin V Acylase; Chain A', NULL, NULL, NULL, 5),
(231015, NULL, 'G3DSA:1.10.287.460', NULL, NULL, NULL, NULL, '', NULL, NULL, 28127, 5),
(231016, NULL, 'G3DSA:1.10.3940.10', NULL, NULL, NULL, NULL, 'AF_0924 domain', NULL, NULL, NULL, 5),
(231017, NULL, 'G3DSA:2.30.30.1250', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231018, NULL, 'G3DSA:1.20.5.500', NULL, NULL, NULL, NULL, 'Single helix bin', NULL, NULL, NULL, 5),
(231019, NULL, 'G3DSA:6.10.250.2280', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231020, NULL, 'G3DSA:1.10.10.1100', NULL, NULL, NULL, NULL, '', NULL, NULL, 30882, 5),
(231021, NULL, 'G3DSA:1.20.120.1110', NULL, NULL, NULL, NULL, 'TAFH/NHR1 domain', NULL, NULL, 31530, 5),
(231022, NULL, 'G3DSA:4.10.420.10', NULL, NULL, NULL, NULL, 'Smk Toxin, alpha chain', NULL, NULL, 13954, 5),
(231023, NULL, 'G3DSA:3.30.1340.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 2153, 5),
(231024, NULL, 'G3DSA:1.10.196.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 18847, 5),
(231025, NULL, 'G3DSA:1.10.4150.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 8240, 5),
(231026, NULL, 'G3DSA:3.60.20.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 33148, 5),
(231027, NULL, 'G3DSA:3.30.1310.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28897, 5),
(231028, NULL, 'G3DSA:2.40.240.10', NULL, NULL, NULL, NULL, 'Ribosomal Protein L25; Chain P', NULL, NULL, 16195, 5),
(231029, NULL, 'G3DSA:3.40.1420.20', NULL, NULL, NULL, NULL, 'Pathogenicity island component CagD', NULL, NULL, 33503, 5),
(231030, NULL, 'G3DSA:1.10.150.400', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231031, NULL, 'G3DSA:3.40.50.10960', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231032, NULL, 'G3DSA:1.10.730.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231033, NULL, 'G3DSA:1.10.760.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28639, 5),
(231034, NULL, 'G3DSA:3.40.50.10690', NULL, NULL, NULL, NULL, 'putative lor/sdh protein like domains', NULL, NULL, NULL, 5),
(231035, NULL, 'G3DSA:1.10.8.430', NULL, NULL, NULL, NULL, '', NULL, NULL, 35143, 5),
(231036, NULL, 'G3DSA:4.10.830.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231037, NULL, 'G3DSA:3.20.20.440', NULL, NULL, NULL, NULL, '', NULL, NULL, 29656, 5),
(231038, NULL, 'G3DSA:4.10.640.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 31327, 5),
(231039, NULL, 'G3DSA:6.20.50.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231040, NULL, 'G3DSA:2.40.37.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231041, NULL, 'G3DSA:1.25.50.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29824, 5),
(231042, NULL, 'G3DSA:1.10.4120.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 24183, 5),
(231043, NULL, 'G3DSA:1.10.2020.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 30222, 5);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(231044, NULL, 'G3DSA:2.40.160.70', NULL, NULL, NULL, NULL, 'outer membrane protein from Thermus thermophilus HB27.', NULL, NULL, NULL, 5),
(231045, NULL, 'G3DSA:1.20.930.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231046, NULL, 'G3DSA:3.40.1770.10', NULL, NULL, NULL, NULL, 'Urocanase superfamily', NULL, NULL, NULL, 5),
(231047, NULL, 'G3DSA:2.40.128.700', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231048, NULL, 'G3DSA:3.30.420.110', NULL, NULL, NULL, NULL, 'MutS, connector domain', NULL, NULL, 29690, 5),
(231049, NULL, 'G3DSA:1.20.5.230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231050, NULL, 'G3DSA:1.20.1440.210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231051, NULL, 'G3DSA:1.10.8.720', NULL, NULL, NULL, NULL, 'Region D6 of dynein motor', NULL, NULL, 36007, 5),
(231052, NULL, 'G3DSA:1.10.246.40', NULL, NULL, NULL, NULL, 'Tn5 transposase; domain 1', NULL, NULL, 33938, 5),
(231053, NULL, 'G3DSA:3.30.730.30', NULL, NULL, NULL, NULL, 'YaiA protein', NULL, NULL, 32066, 5),
(231054, NULL, 'G3DSA:3.30.420.60', NULL, NULL, NULL, NULL, 'eRF1 domain 2', NULL, NULL, 33908, 5),
(231055, NULL, 'G3DSA:6.10.250.1080', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231056, NULL, 'G3DSA:1.20.91.20', NULL, NULL, NULL, NULL, 'Anaphylotoxins (complement system)', NULL, NULL, NULL, 5),
(231057, NULL, 'G3DSA:3.30.572.10', NULL, NULL, NULL, NULL, 'Thymidylate synthase/dCMP hydroxymethylase domain', NULL, NULL, 32684, 5),
(231058, NULL, 'G3DSA:6.10.250.910', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231059, NULL, 'G3DSA:6.10.140.2150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231060, NULL, 'G3DSA:2.60.40.1520', NULL, NULL, NULL, NULL, '', NULL, NULL, 28217, 5),
(231061, NULL, 'G3DSA:1.20.5.960', NULL, NULL, NULL, NULL, 'Bacteriophage t4 gene product 9 (gp9)', NULL, NULL, NULL, 5),
(231062, NULL, 'G3DSA:2.40.10.500', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231063, NULL, 'G3DSA:1.10.246.100', NULL, NULL, NULL, NULL, '', NULL, NULL, 31928, 5),
(231064, NULL, 'G3DSA:1.10.287.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231065, NULL, 'G3DSA:3.30.470.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231066, NULL, 'G3DSA:1.10.220.80', NULL, NULL, NULL, NULL, '', NULL, NULL, 15586, 5),
(231067, NULL, 'G3DSA:2.40.128.210', NULL, NULL, NULL, NULL, 'Pab87 octamerisation domain', NULL, NULL, 29566, 5),
(231068, NULL, 'G3DSA:2.60.40.2930', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231069, NULL, 'G3DSA:1.10.132.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231070, NULL, 'G3DSA:3.30.46.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231071, NULL, 'G3DSA:1.10.1090.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33457, 5),
(231072, NULL, 'G3DSA:3.40.1530.20', NULL, NULL, NULL, NULL, 'Protein of unknown function (DUF1491)', NULL, NULL, NULL, 5),
(231073, NULL, 'G3DSA:1.20.120.1240', NULL, NULL, NULL, NULL, 'Dynamin, middle domain', NULL, NULL, NULL, 5),
(231074, NULL, 'G3DSA:1.10.1060.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 6027, 5),
(231075, NULL, 'G3DSA:3.90.1560.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31568, 5),
(231076, NULL, 'G3DSA:1.10.287.980', NULL, NULL, NULL, NULL, 'plastocyanin oxidoreductase', NULL, NULL, NULL, 5),
(231077, NULL, 'G3DSA:1.10.1220.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 11467, 5),
(231078, NULL, 'G3DSA:6.10.140.230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231079, NULL, 'G3DSA:1.10.10.930', NULL, NULL, NULL, NULL, '', NULL, NULL, 31862, 5),
(231080, NULL, 'G3DSA:3.30.70.2730', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231081, NULL, 'G3DSA:1.10.3870.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231082, NULL, 'G3DSA:1.20.1270.320', NULL, NULL, NULL, NULL, 'Poxvirus poly(A) polymerase, N domain', NULL, NULL, 32728, 5),
(231083, NULL, 'G3DSA:3.10.590.10', NULL, NULL, NULL, NULL, 'ph1033 like domains', NULL, NULL, NULL, 5),
(231084, NULL, 'G3DSA:2.60.90.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 31173, 5),
(231085, NULL, 'G3DSA:3.30.70.2940', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(231086, NULL, 'G3DSA:6.10.250.3200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231087, NULL, 'G3DSA:1.10.1410.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231088, NULL, 'G3DSA:1.10.10.720', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231089, NULL, 'G3DSA:1.20.120.80', NULL, NULL, NULL, NULL, '', NULL, NULL, 17667, 5),
(231090, NULL, 'G3DSA:2.60.120.380', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231091, NULL, 'G3DSA:1.10.3680.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 21681, 5),
(231092, NULL, 'G3DSA:1.20.58.1540', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231093, NULL, 'G3DSA:2.60.120.1330', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231094, NULL, 'G3DSA:1.20.58.1380', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231095, NULL, 'G3DSA:3.10.450.360', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231096, NULL, 'G3DSA:6.10.280.110', NULL, NULL, NULL, NULL, '', NULL, NULL, 29770, 5),
(231097, NULL, 'G3DSA:3.20.20.360', NULL, NULL, NULL, NULL, 'Malate synthase, domain 3', NULL, NULL, 34252, 5),
(231098, NULL, 'G3DSA:1.20.120.1080', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231099, NULL, 'G3DSA:1.20.1160.11', NULL, NULL, NULL, NULL, 'Paired amphipathic helix', NULL, NULL, 32700, 5),
(231100, NULL, 'G3DSA:3.40.50.10230', NULL, NULL, NULL, NULL, '', NULL, NULL, 32998, 5),
(231101, NULL, 'G3DSA:3.10.20.750', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231102, NULL, 'G3DSA:3.10.10.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231103, NULL, 'G3DSA:1.10.8.380', NULL, NULL, NULL, NULL, 'Uncharacterised protein PF01937, DUF89, domain 1', NULL, NULL, NULL, 5),
(231104, NULL, 'G3DSA:1.20.1280.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231105, NULL, 'G3DSA:1.25.10.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231106, NULL, 'G3DSA:1.10.8.1330', NULL, NULL, NULL, NULL, 'Intein homing endonuclease, domain III', NULL, NULL, NULL, 5),
(231107, NULL, 'G3DSA:4.10.80.410', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231108, NULL, 'G3DSA:6.10.140.880', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231109, NULL, 'G3DSA:3.90.70.100', NULL, NULL, NULL, NULL, '', NULL, NULL, 34612, 5),
(231110, NULL, 'G3DSA:1.10.287.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231111, NULL, 'G3DSA:2.60.40.1600', NULL, NULL, NULL, NULL, '', NULL, NULL, 33451, 5),
(231112, NULL, 'G3DSA:3.30.1490.220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231113, NULL, 'G3DSA:2.60.120.1620', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231114, NULL, 'G3DSA:6.10.250.700', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231115, NULL, 'G3DSA:1.10.1280.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 8563, 5),
(231116, NULL, 'G3DSA:3.30.70.2810', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231117, NULL, 'G3DSA:2.60.40.1880', NULL, NULL, NULL, NULL, 'Invasion associated locus B (IalB) protein', NULL, NULL, 32557, 5),
(231118, NULL, 'G3DSA:6.10.140.520', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231119, NULL, 'G3DSA:3.30.1360.240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231120, NULL, 'G3DSA:3.30.110.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 18695, 5),
(231121, NULL, 'G3DSA:3.60.20.10', NULL, NULL, NULL, NULL, 'Glutamine Phosphoribosylpyrophosphate, subunit 1, domain 1', NULL, NULL, 24446, 5),
(231122, NULL, 'G3DSA:1.10.790.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32528, 5),
(231123, NULL, 'G3DSA:2.60.120.780', NULL, NULL, NULL, NULL, 'PINIT domain', NULL, NULL, 32167, 5),
(231124, NULL, 'G3DSA:1.10.555.10', NULL, NULL, NULL, NULL, 'Rho GTPase activation protein', NULL, NULL, 8873, 5),
(231125, NULL, 'G3DSA:3.90.1590.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231126, NULL, 'G3DSA:3.20.20.60', NULL, NULL, NULL, NULL, '', NULL, NULL, 31362, 5),
(231127, NULL, 'G3DSA:3.40.50.1460', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231128, NULL, 'G3DSA:3.30.160.560', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231129, NULL, 'G3DSA:3.40.5.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(231130, NULL, 'G3DSA:3.90.310.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 9391, 5),
(231131, NULL, 'G3DSA:6.10.140.1400', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231132, NULL, 'G3DSA:3.40.1310.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231133, NULL, 'G3DSA:3.10.20.550', NULL, NULL, NULL, NULL, 'ASAP complex, SAP18 subunit', NULL, NULL, 34769, 5),
(231134, NULL, 'G3DSA:3.10.310.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231135, NULL, 'G3DSA:1.10.150.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231136, NULL, 'G3DSA:3.30.70.870', NULL, NULL, NULL, NULL, 'Elongation Factor G (Translational Gtpase), domain 3', NULL, NULL, NULL, 5),
(231137, NULL, 'G3DSA:6.10.140.960', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231138, NULL, 'G3DSA:3.15.10.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231139, NULL, 'G3DSA:1.20.1020.10', NULL, NULL, NULL, NULL, 'TAZ domain', NULL, NULL, 20075, 5),
(231140, NULL, 'G3DSA:6.20.150.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231141, NULL, 'G3DSA:6.10.250.2650', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231142, NULL, 'G3DSA:3.10.50.50', NULL, NULL, NULL, NULL, 'Rubella virus capsid protein', NULL, NULL, 36248, 5),
(231143, NULL, 'G3DSA:3.30.1120.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231144, NULL, 'G3DSA:1.20.5.740', NULL, NULL, NULL, NULL, 'Single helix  bin', NULL, NULL, NULL, 5),
(231145, NULL, 'G3DSA:1.10.285.10', NULL, NULL, NULL, NULL, 'Glutamate Dehydrogenase, chain A, domain 3', NULL, NULL, NULL, 5),
(231146, NULL, 'G3DSA:3.20.16.10', NULL, NULL, NULL, NULL, 'Herpesvirus/Caudovirus protease domain', NULL, NULL, 31736, 5),
(231147, NULL, 'G3DSA:3.30.1490.300', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231148, NULL, 'G3DSA:6.20.310.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231149, NULL, 'G3DSA:1.10.287.730', NULL, NULL, NULL, NULL, 'Helix hairpin bin', NULL, NULL, NULL, 5),
(231150, NULL, 'G3DSA:1.10.8.140', NULL, NULL, NULL, NULL, '', NULL, NULL, 28862, 5),
(231151, NULL, 'G3DSA:3.30.1140.32', NULL, NULL, NULL, NULL, '', NULL, NULL, 27669, 5),
(231152, NULL, 'G3DSA:6.20.120.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31824, 5),
(231153, NULL, 'G3DSA:3.30.1150.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231154, NULL, 'G3DSA:2.60.40.3680', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231155, NULL, 'G3DSA:6.10.250.2360', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231156, NULL, 'G3DSA:3.90.180.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231157, NULL, 'G3DSA:1.20.58.760', NULL, NULL, NULL, NULL, 'Peptidase M41', NULL, NULL, 33266, 5),
(231158, NULL, 'G3DSA:1.10.150.610', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231159, NULL, 'G3DSA:1.10.3250.10', NULL, NULL, NULL, NULL, 'type ii restriction endonuclease, domain 1', NULL, NULL, NULL, 5),
(231160, NULL, 'G3DSA:3.30.70.1380', NULL, NULL, NULL, NULL, 'Transcriptional regulatory protein pf0864 domain like', NULL, NULL, NULL, 5),
(231161, NULL, 'G3DSA:3.30.70.2000', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231162, NULL, 'G3DSA:2.60.120.620', NULL, NULL, NULL, NULL, 'q2cbj1_9rhob like domain', NULL, NULL, NULL, 5),
(231163, NULL, 'G3DSA:1.10.8.1000', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231164, NULL, 'G3DSA:1.10.490.110', NULL, NULL, NULL, NULL, 'Uncharacterized conserved protein DUF2267', NULL, NULL, 31439, 5),
(231165, NULL, 'G3DSA:3.20.20.150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231166, NULL, 'G3DSA:1.10.260.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 8252, 5),
(231167, NULL, 'G3DSA:2.30.30.760', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231168, NULL, 'G3DSA:3.10.450.400', NULL, NULL, NULL, NULL, 'Uncharacterised protein PF15513, DUF4651', NULL, NULL, NULL, 5),
(231169, NULL, 'G3DSA:3.40.910.10', NULL, NULL, NULL, NULL, 'Deoxyhypusine synthase', NULL, NULL, 30419, 5),
(231170, NULL, 'G3DSA:1.25.40.1040', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231171, NULL, 'G3DSA:3.40.50.12390', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(231172, NULL, 'G3DSA:3.10.129.110', NULL, NULL, NULL, NULL, 'Polyketide synthase dehydratase', NULL, NULL, 30680, 5),
(231173, NULL, 'G3DSA:3.40.1530.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 30236, 5),
(231174, NULL, 'G3DSA:1.10.150.110', NULL, NULL, NULL, NULL, '', NULL, NULL, 25486, 5),
(231175, NULL, 'G3DSA:3.90.76.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231176, NULL, 'G3DSA:1.20.5.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231177, NULL, 'G3DSA:3.40.50.11300', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231178, NULL, 'G3DSA:2.60.40.2200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231179, NULL, 'G3DSA:1.10.3140.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231180, NULL, 'G3DSA:3.40.50.700', NULL, NULL, NULL, NULL, '', NULL, NULL, 27244, 5),
(231181, NULL, 'G3DSA:3.90.1840.10', NULL, NULL, NULL, NULL, 'Major capsid protein', NULL, NULL, 27927, 5),
(231182, NULL, 'G3DSA:1.10.166.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28300, 5),
(231183, NULL, 'G3DSA:3.30.70.1700', NULL, NULL, NULL, NULL, 'Phage minor tail protein U', NULL, NULL, 31571, 5),
(231184, NULL, 'G3DSA:2.60.40.1650', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231185, NULL, 'G3DSA:3.30.70.1450', NULL, NULL, NULL, NULL, '', NULL, NULL, 31823, 5),
(231186, NULL, 'G3DSA:1.25.40.810', NULL, NULL, NULL, NULL, 'UpxZ', NULL, NULL, 33931, 5),
(231187, NULL, 'G3DSA:2.60.40.1170', NULL, NULL, NULL, NULL, 'Mu homology domain, subdomain B', NULL, NULL, NULL, 5),
(231188, NULL, 'G3DSA:1.10.1240.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231189, NULL, 'G3DSA:1.20.272.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231190, NULL, 'G3DSA:2.70.98.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231191, NULL, 'G3DSA:6.10.140.2070', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5),
(231192, NULL, 'G3DSA:1.20.58.440', NULL, NULL, NULL, NULL, 'choline binding protein A', NULL, NULL, NULL, 5),
(231193, NULL, 'G3DSA:6.10.140.150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231194, NULL, 'G3DSA:2.60.40.4280', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231195, NULL, 'G3DSA:2.30.30.420', NULL, NULL, NULL, NULL, 'glucansucrase', NULL, NULL, NULL, 5),
(231196, NULL, 'G3DSA:3.10.20.830', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231197, NULL, 'G3DSA:6.20.370.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231198, NULL, 'G3DSA:1.10.1740.180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231199, NULL, 'G3DSA:3.40.220.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 27399, 5),
(231200, NULL, 'G3DSA:3.40.50.11720', NULL, NULL, NULL, NULL, '', NULL, NULL, 30015, 5),
(231201, NULL, 'G3DSA:3.10.450.280', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231202, NULL, 'G3DSA:1.20.5.820', NULL, NULL, NULL, NULL, 'Preprotein translocase SecE subunit', NULL, NULL, 15991, 5),
(231203, NULL, 'G3DSA:1.10.287.1040', NULL, NULL, NULL, NULL, 'Exonuclease VII, small subunit', NULL, NULL, 28037, 5),
(231204, NULL, 'G3DSA:1.20.58.1250', NULL, NULL, NULL, NULL, '', NULL, NULL, 29583, 5),
(231205, NULL, 'G3DSA:1.10.10.640', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231206, NULL, 'G3DSA:3.30.70.2860', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231207, NULL, 'G3DSA:1.20.1270.210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231208, NULL, 'G3DSA:1.10.287.3030', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231209, NULL, 'G3DSA:1.20.272.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231210, NULL, 'G3DSA:2.170.120.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231211, NULL, 'G3DSA:1.20.1630.10', NULL, NULL, NULL, NULL, 'Formate dehydrogenase/DMSO reductase domain', NULL, NULL, NULL, 5),
(231212, NULL, 'G3DSA:1.10.287.2480', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231213, NULL, 'G3DSA:2.60.40.3080', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231214, NULL, 'G3DSA:1.10.8.480', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231215, NULL, 'G3DSA:6.10.140.280', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(231216, NULL, 'G3DSA:6.10.140.1920', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231217, NULL, 'G3DSA:2.70.20.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 35211, 5),
(231218, NULL, 'G3DSA:3.30.67.20', NULL, NULL, NULL, NULL, 'Rubella membrane glycoprotein E1, domain 2', NULL, NULL, 36770, 5),
(231219, NULL, 'G3DSA:3.30.2070.10', NULL, NULL, NULL, NULL, 'Formate dehydrogenase/DMSO reductase,', NULL, NULL, NULL, 5),
(231220, NULL, 'G3DSA:6.20.250.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231221, NULL, 'G3DSA:6.10.280.60', NULL, NULL, NULL, NULL, '', NULL, NULL, 29937, 5),
(231222, NULL, 'G3DSA:1.20.5.440', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231223, NULL, 'G3DSA:2.40.330.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231224, NULL, 'G3DSA:2.60.40.1230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231225, NULL, 'G3DSA:3.40.50.10980', NULL, NULL, NULL, NULL, 'Nibrin, BRCT2 domain', NULL, NULL, 36391, 5),
(231226, NULL, 'G3DSA:3.30.70.1660', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231227, NULL, 'G3DSA:3.40.1820.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231228, NULL, 'G3DSA:1.10.290.10', NULL, NULL, NULL, NULL, 'Topoisomerase I, domain 4', NULL, NULL, 17593, 5),
(231229, NULL, 'G3DSA:3.40.1390.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 24127, 5),
(231230, NULL, 'G3DSA:3.90.640.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 28186, 5),
(231231, NULL, 'G3DSA:6.10.250.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231232, NULL, 'G3DSA:2.60.40.180', NULL, NULL, NULL, NULL, 'Transthyretin/hydroxyisourate hydrolase domain', NULL, NULL, 27689, 5),
(231233, NULL, 'G3DSA:3.60.100.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29313, 5),
(231234, NULL, 'G3DSA:1.10.3300.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 15863, 5),
(231235, NULL, 'G3DSA:1.10.1870.10', NULL, NULL, NULL, NULL, 'Domain 3, Saccharopine reductase', NULL, NULL, NULL, 5),
(231236, NULL, 'G3DSA:1.20.5.3600', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231237, NULL, 'G3DSA:6.10.140.1610', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231238, NULL, 'G3DSA:6.10.250.2860', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231239, NULL, 'G3DSA:3.40.220.10', NULL, NULL, NULL, NULL, 'Leucine Aminopeptidase, subunit E, domain 1', NULL, NULL, 34548, 5),
(231240, NULL, 'G3DSA:3.40.462.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231241, NULL, 'G3DSA:4.10.8.20', NULL, NULL, NULL, NULL, 'DNA/RNA polymerases', NULL, NULL, NULL, 5),
(231242, NULL, 'G3DSA:3.10.110.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 36255, 5),
(231243, NULL, 'G3DSA:1.20.58.2140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231244, NULL, 'G3DSA:2.70.130.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 10000, 5),
(231245, NULL, 'G3DSA:1.10.1790.10', NULL, NULL, NULL, NULL, 'PRD domain', NULL, NULL, NULL, 5),
(231246, NULL, 'G3DSA:3.30.390.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231247, NULL, 'G3DSA:3.30.60.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231248, NULL, 'G3DSA:3.40.50.12100', NULL, NULL, NULL, NULL, 'Stimulator of interferon genes protein', NULL, NULL, 32837, 5),
(231249, NULL, 'G3DSA:3.30.2000.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 27893, 5),
(231250, NULL, 'G3DSA:2.60.40.3390', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231251, NULL, 'G3DSA:1.10.287.2170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231252, NULL, 'G3DSA:3.40.1520.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231253, NULL, 'G3DSA:3.40.980.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 35273, 5),
(231254, NULL, 'G3DSA:2.60.40.2190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231255, NULL, 'G3DSA:1.10.10.200', NULL, NULL, NULL, NULL, '', NULL, NULL, 20546, 5),
(231256, NULL, 'G3DSA:6.20.90.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231257, NULL, 'G3DSA:1.10.150.370', NULL, NULL, NULL, NULL, '', NULL, NULL, 35020, 5),
(231258, NULL, 'G3DSA:3.90.660.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231259, NULL, 'G3DSA:1.10.220.60', NULL, NULL, NULL, NULL, 'GRIP domain', NULL, NULL, NULL, 5);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(231260, NULL, 'G3DSA:1.10.390.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231261, NULL, 'G3DSA:1.20.1670.10', NULL, NULL, NULL, NULL, 'Type II deoxyuridine triphosphatase', NULL, NULL, NULL, 5),
(231262, NULL, 'G3DSA:6.10.250.2070', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231263, NULL, 'G3DSA:6.10.250.2150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231264, NULL, 'G3DSA:1.10.150.450', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231265, NULL, 'G3DSA:2.30.180.10', NULL, NULL, NULL, NULL, 'FAS1 domain', NULL, NULL, 32325, 5),
(231266, NULL, 'G3DSA:1.10.287.750', NULL, NULL, NULL, NULL, '', NULL, NULL, 33242, 5),
(231267, NULL, 'G3DSA:3.30.2190.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33474, 5),
(231268, NULL, 'G3DSA:1.10.150.530', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231269, NULL, 'G3DSA:3.30.70.1970', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231270, NULL, 'G3DSA:2.30.30.400', NULL, NULL, NULL, NULL, '', NULL, NULL, 31258, 5),
(231271, NULL, 'G3DSA:3.30.2030.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231272, NULL, 'G3DSA:3.30.70.1890', NULL, NULL, NULL, NULL, '', NULL, NULL, 36392, 5),
(231273, NULL, 'G3DSA:6.10.250.3040', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231274, NULL, 'G3DSA:3.40.1830.10', NULL, NULL, NULL, NULL, 'Thermophilic metalloprotease (M29)', NULL, NULL, 7657, 5),
(231275, NULL, 'G3DSA:3.30.300.130', NULL, NULL, NULL, NULL, '', NULL, NULL, 28053, 5),
(231276, NULL, 'G3DSA:3.30.1490.430', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231277, NULL, 'G3DSA:3.40.1850.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231278, NULL, 'G3DSA:2.40.128.690', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231279, NULL, 'G3DSA:6.10.280.170', NULL, NULL, NULL, NULL, 'Substrate of the Dot/Icm secretion system', NULL, NULL, NULL, 5),
(231280, NULL, 'G3DSA:2.60.40.3470', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231281, NULL, 'G3DSA:2.30.31.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231282, NULL, 'G3DSA:2.60.30.10', NULL, NULL, NULL, NULL, 'Methylamine/Aralkylamine dehydrogenase light chain', NULL, NULL, 33361, 5),
(231283, NULL, 'G3DSA:3.40.1440.60', NULL, NULL, NULL, NULL, '', NULL, NULL, 36772, 5),
(231284, NULL, 'G3DSA:1.25.40.830', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231285, NULL, 'G3DSA:6.10.140.1390', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231286, NULL, 'G3DSA:3.90.1720.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231287, NULL, 'G3DSA:2.30.140.50', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF2790', NULL, NULL, NULL, 5),
(231288, NULL, 'G3DSA:1.10.3270.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 15763, 5),
(231289, NULL, 'G3DSA:1.10.10.1830', NULL, NULL, NULL, NULL, '', NULL, NULL, 34142, 5),
(231290, NULL, 'G3DSA:1.10.287.520', NULL, NULL, NULL, NULL, 'Helix hairpin bin', NULL, NULL, NULL, 5),
(231291, NULL, 'G3DSA:2.30.30.1040', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231292, NULL, 'G3DSA:1.20.58.1960', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231293, NULL, 'G3DSA:1.20.850.10', NULL, NULL, NULL, NULL, 'Hydroxylamine Oxidoreductase; Chain A, domain 2', NULL, NULL, NULL, 5),
(231294, NULL, 'G3DSA:6.10.140.440', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231295, NULL, 'G3DSA:1.10.520.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 24699, 5),
(231296, NULL, 'G3DSA:4.10.280.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 27274, 5),
(231297, NULL, 'G3DSA:2.60.40.1550', NULL, NULL, NULL, NULL, 'SARS coronavirus X4', NULL, NULL, 31377, 5),
(231298, NULL, 'G3DSA:3.30.160.270', NULL, NULL, NULL, NULL, '', NULL, NULL, 29746, 5),
(231299, NULL, 'G3DSA:3.40.1660.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231300, NULL, 'G3DSA:6.10.90.10', NULL, NULL, NULL, NULL, 'Apolipoprotein CIII', NULL, NULL, 29800, 5),
(231301, NULL, 'G3DSA:1.10.287.4310', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231302, NULL, 'G3DSA:3.50.7.10', NULL, NULL, NULL, NULL, 'GroEL', NULL, NULL, 24719, 5);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(231303, NULL, 'G3DSA:1.20.1260.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231304, NULL, 'G3DSA:3.30.1360.100', NULL, NULL, NULL, NULL, 'General secretion pathway protein M, EpsM', NULL, NULL, NULL, 5),
(231305, NULL, 'G3DSA:2.60.120.1120', NULL, NULL, NULL, NULL, '', NULL, NULL, 33590, 5),
(231306, NULL, 'G3DSA:1.20.5.1700', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231307, NULL, 'G3DSA:3.30.43.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 11964, 5),
(231308, NULL, 'G3DSA:3.50.50.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231309, NULL, 'G3DSA:1.25.40.520', NULL, NULL, NULL, NULL, '', NULL, NULL, 33945, 5),
(231310, NULL, 'G3DSA:2.60.40.1530', NULL, NULL, NULL, NULL, 'ntegrin, alpha v. Chain A, domain 4', NULL, NULL, NULL, 5),
(231311, NULL, 'G3DSA:3.40.1630.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231312, NULL, 'G3DSA:2.20.150.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 18966, 5),
(231313, NULL, 'G3DSA:1.10.489.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31822, 5),
(231314, NULL, 'G3DSA:1.20.120.950', NULL, NULL, NULL, NULL, 'Uncharacterised protein DUF5062', NULL, NULL, NULL, 5),
(231315, NULL, 'G3DSA:3.10.20.540', NULL, NULL, NULL, NULL, '', NULL, NULL, 34891, 5),
(231316, NULL, 'G3DSA:2.30.210.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231317, NULL, 'G3DSA:2.60.120.590', NULL, NULL, NULL, NULL, '', NULL, NULL, 29666, 5),
(231318, NULL, 'G3DSA:2.40.50.690', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231319, NULL, 'G3DSA:2.20.180.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 19300, 5),
(231320, NULL, 'G3DSA:3.10.129.10', NULL, NULL, NULL, NULL, 'Hotdog Thioesterase', NULL, NULL, NULL, 5),
(231321, NULL, 'G3DSA:1.10.10.510', NULL, NULL, NULL, NULL, '', NULL, NULL, 28244, 5),
(231322, NULL, 'G3DSA:2.60.40.3160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231323, NULL, 'G3DSA:1.20.1720.10', NULL, NULL, NULL, NULL, 'Multidrug resistance protein D', NULL, NULL, NULL, 5),
(231324, NULL, 'G3DSA:2.60.60.20', NULL, NULL, NULL, NULL, 'PLAT/LH2 domain', NULL, NULL, NULL, 5),
(231325, NULL, 'G3DSA:3.40.50.10070', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231326, NULL, 'G3DSA:6.10.20.100', NULL, NULL, NULL, NULL, '', NULL, NULL, 33872, 5),
(231327, NULL, 'G3DSA:3.10.20.590', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231328, NULL, 'G3DSA:2.10.50.20', NULL, NULL, NULL, NULL, 'Inosine monophosphate dehydrogenase (IMPDH)', NULL, NULL, NULL, 5),
(231329, NULL, 'G3DSA:1.20.50.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231330, NULL, 'G3DSA:3.90.540.10', NULL, NULL, NULL, NULL, 'Colicin/pyocin, DNase domain', NULL, NULL, 29994, 5),
(231331, NULL, 'G3DSA:2.120.10.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231332, NULL, 'G3DSA:1.10.8.870', NULL, NULL, NULL, NULL, '', NULL, NULL, 31469, 5),
(231333, NULL, 'G3DSA:2.40.30.320', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231334, NULL, 'G3DSA:3.40.50.12050', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231335, NULL, 'G3DSA:3.90.105.50', NULL, NULL, NULL, NULL, '', NULL, NULL, 31284, 5),
(231336, NULL, 'G3DSA:3.30.305.10', NULL, NULL, NULL, NULL, 'Colicin Ia; domain 2', NULL, NULL, 31488, 5),
(231337, NULL, 'G3DSA:1.20.5.80', NULL, NULL, NULL, NULL, '', NULL, NULL, 15935, 5),
(231338, NULL, 'G3DSA:1.10.3810.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 30571, 5),
(231339, NULL, 'G3DSA:3.30.2010.10', NULL, NULL, NULL, NULL, 'Metalloproteases ("zincins"), catalytic domain', NULL, NULL, NULL, 5),
(231340, NULL, 'G3DSA:1.10.1660.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231341, NULL, 'G3DSA:2.10.50.30', NULL, NULL, NULL, NULL, 'GPCR, family 3, nine cysteines domain', NULL, NULL, 33923, 5),
(231342, NULL, 'G3DSA:2.60.40.1450', NULL, NULL, NULL, NULL, 'LAG1, DNA binding domain', NULL, NULL, 32753, 5),
(231343, NULL, 'G3DSA:3.90.1570.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231344, NULL, 'G3DSA:2.60.40.4360', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231345, NULL, 'G3DSA:1.20.1440.80', NULL, NULL, NULL, NULL, '', NULL, NULL, 33331, 5);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(231346, NULL, 'G3DSA:3.40.50.10280', NULL, NULL, NULL, NULL, '', NULL, NULL, 27061, 5),
(231347, NULL, 'G3DSA:3.90.1730.10', NULL, NULL, NULL, NULL, 'Infectious bursal virus vp1 polymerase domain', NULL, NULL, 33730, 5),
(231348, NULL, 'G3DSA:3.10.580.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231349, NULL, 'G3DSA:1.20.120.650', NULL, NULL, NULL, NULL, 'Colicin D', NULL, NULL, 31311, 5),
(231350, NULL, 'G3DSA:3.30.300.340', NULL, NULL, NULL, NULL, '', NULL, NULL, 36606, 5),
(231351, NULL, 'G3DSA:3.10.450.150', NULL, NULL, NULL, NULL, 'enterococcus faecalis protein', NULL, NULL, NULL, 5),
(231352, NULL, 'G3DSA:1.10.40.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231353, NULL, 'G3DSA:3.30.30.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231354, NULL, 'G3DSA:2.40.50.480', NULL, NULL, NULL, NULL, '', NULL, NULL, 30170, 5),
(231355, NULL, 'G3DSA:3.90.1150.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231356, NULL, 'G3DSA:4.10.80.40', NULL, NULL, NULL, NULL, 'succinate dehydrogenase protein domain', NULL, NULL, NULL, 5),
(231357, NULL, 'G3DSA:6.10.250.3430', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231358, NULL, 'G3DSA:6.10.250.1890', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231359, NULL, 'G3DSA:1.10.490.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231360, NULL, 'G3DSA:3.30.160.350', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231361, NULL, 'G3DSA:3.30.450.250', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231362, NULL, 'G3DSA:1.25.40.310', NULL, NULL, NULL, NULL, '', NULL, NULL, 31364, 5),
(231363, NULL, 'G3DSA:1.20.5.840', NULL, NULL, NULL, NULL, 'hypothetical RNA methyltransferase', NULL, NULL, NULL, 5),
(231364, NULL, 'G3DSA:3.10.196.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28117, 5),
(231365, NULL, 'G3DSA:3.30.1460.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231366, NULL, 'G3DSA:1.20.81.10', NULL, NULL, NULL, NULL, 'RAP domain', NULL, NULL, 27630, 5),
(231367, NULL, 'G3DSA:3.40.30.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231368, NULL, 'G3DSA:3.90.148.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33158, 5),
(231369, NULL, 'G3DSA:2.40.30.240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231370, NULL, 'G3DSA:2.60.40.2720', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231371, NULL, 'G3DSA:3.10.330.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231372, NULL, 'G3DSA:2.60.120.290', NULL, NULL, NULL, NULL, 'Spermadhesin, CUB domain', NULL, NULL, 19210, 5),
(231373, NULL, 'G3DSA:2.60.120.980', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231374, NULL, 'G3DSA:6.10.140.750', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231375, NULL, 'G3DSA:1.20.150.10', NULL, NULL, NULL, NULL, 'Fertilization protein', NULL, NULL, 12715, 5),
(231376, NULL, 'G3DSA:3.30.1490.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231377, NULL, 'G3DSA:2.150.10.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 9423, 5),
(231378, NULL, 'G3DSA:3.40.50.10730', NULL, NULL, NULL, NULL, 'Urocanase like domains', NULL, NULL, 32847, 5),
(231379, NULL, 'G3DSA:6.10.140.670', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231380, NULL, 'G3DSA:3.40.50.12180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231381, NULL, 'G3DSA:6.10.250.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231382, NULL, 'G3DSA:1.20.120.1680', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231383, NULL, 'G3DSA:1.20.5.710', NULL, NULL, NULL, NULL, 'Single helix bin', NULL, NULL, 28253, 5),
(231384, NULL, 'G3DSA:2.60.240.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231385, NULL, 'G3DSA:1.10.155.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33337, 5),
(231386, NULL, 'G3DSA:2.10.22.10', NULL, NULL, NULL, NULL, 'Antistasin; domain 1', NULL, NULL, NULL, 5),
(231387, NULL, 'G3DSA:1.20.5.5160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231388, NULL, 'G3DSA:1.20.1320.20', NULL, NULL, NULL, NULL, 'hef helicase domain', NULL, NULL, NULL, 5),
(231389, NULL, 'G3DSA:1.10.1660.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(231390, NULL, 'G3DSA:2.20.220.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231391, NULL, 'G3DSA:3.40.50.1440', NULL, NULL, NULL, NULL, 'Tubulin/FtsZ, GTPase domain', NULL, NULL, 32754, 5),
(231392, NULL, 'G3DSA:6.10.250.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231393, NULL, 'G3DSA:1.10.287.1120', NULL, NULL, NULL, NULL, 'Bipartite methylase S protein', NULL, NULL, NULL, 5),
(231394, NULL, 'G3DSA:6.20.50.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231395, NULL, 'G3DSA:2.40.160.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231396, NULL, 'G3DSA:3.40.390.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231397, NULL, 'G3DSA:1.10.3130.20', NULL, NULL, NULL, NULL, 'Phycobilisome linker domain', NULL, NULL, 27054, 5),
(231398, NULL, 'G3DSA:2.60.40.2800', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231399, NULL, 'G3DSA:2.40.30.120', NULL, NULL, NULL, NULL, 'Positive stranded ssRNA viruses', NULL, NULL, NULL, 5),
(231400, NULL, 'G3DSA:1.20.58.1040', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231401, NULL, 'G3DSA:3.40.1010.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231402, NULL, 'G3DSA:3.10.20.620', NULL, NULL, NULL, NULL, '', NULL, NULL, 33818, 5),
(231403, NULL, 'G3DSA:6.10.140.310', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231404, NULL, 'G3DSA:4.10.320.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231405, NULL, 'G3DSA:2.40.160.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231406, NULL, 'G3DSA:1.10.532.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 30478, 5),
(231407, NULL, 'G3DSA:3.30.2130.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231408, NULL, 'G3DSA:3.30.1070.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231409, NULL, 'G3DSA:3.30.300.260', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231410, NULL, 'G3DSA:1.10.220.120', NULL, NULL, NULL, NULL, '', NULL, NULL, 36573, 5),
(231411, NULL, 'G3DSA:6.10.140.360', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231412, NULL, 'G3DSA:1.20.58.1880', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231413, NULL, 'G3DSA:3.30.70.640', NULL, NULL, NULL, NULL, 'Molybdopterin cofactor biosynthesis C (MoaC) domain', NULL, NULL, 32817, 5),
(231414, NULL, 'G3DSA:1.10.418.30', NULL, NULL, NULL, NULL, 'Ncd80 complex, Ncd80 subunit', NULL, NULL, 32185, 5),
(231415, NULL, 'G3DSA:1.20.120.430', NULL, NULL, NULL, NULL, 'tRNA modification GTPase MnmE domain 2', NULL, NULL, 21975, 5),
(231416, NULL, 'G3DSA:1.20.1280.80', NULL, NULL, NULL, NULL, '', NULL, NULL, 32601, 5),
(231417, NULL, 'G3DSA:3.30.1370.240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231418, NULL, 'G3DSA:6.10.250.3120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231419, NULL, 'G3DSA:3.30.1040.70', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5),
(231420, NULL, 'G3DSA:1.10.439.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 35961, 5),
(231421, NULL, 'G3DSA:3.90.1850.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231422, NULL, 'G3DSA:4.10.540.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32536, 5),
(231423, NULL, 'G3DSA:3.30.1230.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 32347, 5),
(231424, NULL, 'G3DSA:3.40.50.10150', NULL, NULL, NULL, NULL, '', NULL, NULL, 8963, 5),
(231425, NULL, 'G3DSA:2.30.30.970', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231426, NULL, 'G3DSA:1.20.1280.10', NULL, NULL, NULL, NULL, 'Methane monooxygenase, gamma chain, domain 1', NULL, NULL, 8417, 5),
(231427, NULL, 'G3DSA:3.40.1760.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 11315, 5),
(231428, NULL, 'G3DSA:1.10.1040.30', NULL, NULL, NULL, NULL, 'ISWI, HAND domain', NULL, NULL, 31922, 5),
(231429, NULL, 'G3DSA:1.10.10.430', NULL, NULL, NULL, NULL, '', NULL, NULL, 29789, 5),
(231430, NULL, 'G3DSA:1.20.1250.80', NULL, NULL, NULL, NULL, '', NULL, NULL, 28977, 5),
(231431, NULL, 'G3DSA:1.10.443.10', NULL, NULL, NULL, NULL, 'Intergrase catalytic core', NULL, NULL, 7769, 5),
(231432, NULL, 'G3DSA:3.30.70.1650', NULL, NULL, NULL, NULL, 'PDO, CxxC motif', NULL, NULL, NULL, 5);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(231433, NULL, 'G3DSA:1.25.40.700', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231434, NULL, 'G3DSA:1.10.1620.10', NULL, NULL, NULL, NULL, 'Ribosomal protein L39e', NULL, NULL, 12079, 5),
(231435, NULL, 'G3DSA:1.10.8.790', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231436, NULL, 'G3DSA:1.20.120.830', NULL, NULL, NULL, NULL, '', NULL, NULL, 28511, 5),
(231437, NULL, 'G3DSA:1.20.1390.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231438, NULL, 'G3DSA:1.10.287.770', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231439, NULL, 'G3DSA:1.20.58.1610', NULL, NULL, NULL, NULL, 'NADH:ubiquinone/plastoquinone oxidoreductase, chain 3', NULL, NULL, 31041, 5),
(231440, NULL, 'G3DSA:3.90.1690.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231441, NULL, 'G3DSA:2.60.320.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33559, 5),
(231442, NULL, 'G3DSA:3.10.180.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231443, NULL, 'G3DSA:1.10.288.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231444, NULL, 'G3DSA:1.10.390.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231445, NULL, 'G3DSA:1.10.1000.11', NULL, NULL, NULL, NULL, '', NULL, NULL, 16262, 5),
(231446, NULL, 'G3DSA:2.60.40.3180', NULL, NULL, NULL, NULL, '', NULL, NULL, 29938, 5),
(231447, NULL, 'G3DSA:3.40.630.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231448, NULL, 'G3DSA:6.10.140.1180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231449, NULL, 'G3DSA:2.70.100.10', NULL, NULL, NULL, NULL, 'Glycoside hydrolase, family 7, domain', NULL, NULL, 28408, 5),
(231450, NULL, 'G3DSA:6.10.250.2990', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231451, NULL, 'G3DSA:1.10.3210.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231452, NULL, 'G3DSA:2.60.120.1100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231453, NULL, 'G3DSA:1.20.58.1150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231454, NULL, 'G3DSA:1.10.10.250', NULL, NULL, NULL, NULL, '', NULL, NULL, 33276, 5),
(231455, NULL, 'G3DSA:1.10.8.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231456, NULL, 'G3DSA:1.10.150.630', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231457, NULL, 'G3DSA:4.10.510.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 11188, 5),
(231458, NULL, 'G3DSA:3.30.2200.10', NULL, NULL, NULL, NULL, 'histidine kinase doma clostridium symbiosum atcc 14940', NULL, NULL, NULL, 5),
(231459, NULL, 'G3DSA:2.30.31.50', NULL, NULL, NULL, NULL, 'Borrelia outer surface protein E/F', NULL, NULL, 33768, 5),
(231460, NULL, 'G3DSA:1.20.120.1380', NULL, NULL, NULL, NULL, 'Flagellar FlhF biosynthesis protein, N domain', NULL, NULL, NULL, 5),
(231461, NULL, 'G3DSA:2.60.40.2700', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231462, NULL, 'G3DSA:1.20.1280.70', NULL, NULL, NULL, NULL, 'Exonuclease ExoI, domain 3', NULL, NULL, NULL, 5),
(231463, NULL, 'G3DSA:3.40.50.10620', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231464, NULL, 'G3DSA:1.10.520.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 31146, 5),
(231465, NULL, 'G3DSA:6.10.150.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231466, NULL, 'G3DSA:1.10.1510.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 34772, 5),
(231467, NULL, 'G3DSA:3.30.70.2260', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231468, NULL, 'G3DSA:1.10.760.20', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF3243', NULL, NULL, 31354, 5),
(231469, NULL, 'G3DSA:1.10.10.1330', NULL, NULL, NULL, NULL, '', NULL, NULL, 30539, 5),
(231470, NULL, 'G3DSA:2.40.50.590', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231471, NULL, 'G3DSA:3.30.70.1840', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231472, NULL, 'G3DSA:3.10.310.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231473, NULL, 'G3DSA:1.10.3730.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231474, NULL, 'G3DSA:1.20.1000.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231475, NULL, 'G3DSA:3.40.970.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29958, 5),
(231476, NULL, 'G3DSA:3.30.2000.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(231477, NULL, 'G3DSA:6.10.140.1740', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231478, NULL, 'G3DSA:3.10.450.590', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231479, NULL, 'G3DSA:3.30.750.44', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231480, NULL, 'G3DSA:3.30.413.10', NULL, NULL, NULL, NULL, 'Sulfite Reductase Hemoprotein, domain 1', NULL, NULL, 33838, 5),
(231481, NULL, 'G3DSA:3.30.1490.170', NULL, NULL, NULL, NULL, 'Allophycocyanin linker chain (domain)', NULL, NULL, 10432, 5),
(231482, NULL, 'G3DSA:3.30.410.10', NULL, NULL, NULL, NULL, 'Cholesterol Oxidase; domain 2', NULL, NULL, NULL, 5),
(231483, NULL, 'G3DSA:1.10.890.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31186, 5),
(231484, NULL, 'G3DSA:1.10.8.1050', NULL, NULL, NULL, NULL, '', NULL, NULL, 35835, 5),
(231485, NULL, 'G3DSA:3.90.210.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231486, NULL, 'G3DSA:2.30.29.230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231487, NULL, 'G3DSA:6.10.140.540', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231488, NULL, 'G3DSA:2.30.310.10', NULL, NULL, NULL, NULL, 'ibrinogen binding protein from staphylococcus aureus domain', NULL, NULL, NULL, 5),
(231489, NULL, 'G3DSA:2.60.40.1130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231490, NULL, 'G3DSA:3.40.50.11200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231491, NULL, 'G3DSA:3.40.50.11120', NULL, NULL, NULL, NULL, '', NULL, NULL, 37597, 5),
(231492, NULL, 'G3DSA:1.10.10.1360', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231493, NULL, 'G3DSA:6.10.140.860', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231494, NULL, 'G3DSA:3.90.850.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31915, 5),
(231495, NULL, 'G3DSA:2.60.120.600', NULL, NULL, NULL, NULL, '', NULL, NULL, 29358, 5),
(231496, NULL, 'G3DSA:3.30.200.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231497, NULL, 'G3DSA:3.30.1560.10', NULL, NULL, NULL, NULL, 'Mago nashi', NULL, NULL, 32971, 5),
(231498, NULL, 'G3DSA:1.10.287.150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231499, NULL, 'G3DSA:3.30.720.220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231500, NULL, 'G3DSA:1.20.920.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28108, 5),
(231501, NULL, 'G3DSA:6.10.140.490', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231502, NULL, 'G3DSA:3.90.870.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231503, NULL, 'G3DSA:1.20.1050.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231504, NULL, 'G3DSA:2.70.98.110', NULL, NULL, NULL, NULL, '', NULL, NULL, 32073, 5),
(231505, NULL, 'G3DSA:2.60.40.3900', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231506, NULL, 'G3DSA:2.40.128.540', NULL, NULL, NULL, NULL, 'Domain of unknown function DUF4822', NULL, NULL, NULL, 5),
(231507, NULL, 'G3DSA:2.40.30.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231508, NULL, 'G3DSA:1.10.10.410', NULL, NULL, NULL, NULL, '', NULL, NULL, 9170, 5),
(231509, NULL, 'G3DSA:2.40.20.10', NULL, NULL, NULL, NULL, 'Plasminogen Kringle 4', NULL, NULL, 29558, 5),
(231510, NULL, 'G3DSA:1.20.120.390', NULL, NULL, NULL, NULL, 'Hla class ii histocompatibility antigen, dr alpha chain. Chain D, domain 1', NULL, NULL, NULL, 5),
(231511, NULL, 'G3DSA:3.40.50.10490', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231512, NULL, 'G3DSA:1.10.3100.10', NULL, NULL, NULL, NULL, 'Putative cytoplasmic protein', NULL, NULL, 23292, 5),
(231513, NULL, 'G3DSA:2.30.33.40', NULL, NULL, NULL, NULL, 'GroES chaperonin', NULL, NULL, 28112, 5),
(231514, NULL, 'G3DSA:1.20.90.10', NULL, NULL, NULL, NULL, 'Phospholipase A2 domain', NULL, NULL, 31577, 5),
(231515, NULL, 'G3DSA:3.30.70.1790', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231516, NULL, 'G3DSA:1.20.120.670', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231517, NULL, 'G3DSA:1.10.4020.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32134, 5),
(231518, NULL, 'G3DSA:3.30.30.80', NULL, NULL, NULL, NULL, '', NULL, NULL, 33978, 5),
(231519, NULL, 'G3DSA:1.10.8.770', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(231520, NULL, 'G3DSA:2.130.10.110', NULL, NULL, NULL, NULL, '', NULL, NULL, 9139, 5),
(231521, NULL, 'G3DSA:2.20.25.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231522, NULL, 'G3DSA:2.40.40.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231523, NULL, 'G3DSA:3.90.1170.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 31940, 5),
(231524, NULL, 'G3DSA:3.30.70.250', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231525, NULL, 'G3DSA:1.10.150.200', NULL, NULL, NULL, NULL, 'Maltooligosyl trehalose synthase; domain 3', NULL, NULL, NULL, 5),
(231526, NULL, 'G3DSA:1.20.58.1120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231527, NULL, 'G3DSA:1.10.930.10', NULL, NULL, NULL, NULL, 'Syk Kinase; Chain A, domain 2', NULL, NULL, 16068, 5),
(231528, NULL, 'G3DSA:3.30.1360.110', NULL, NULL, NULL, NULL, 'Domain 2, Phosphonoacetate Hydrolase', NULL, NULL, 6635, 5),
(231529, NULL, 'G3DSA:2.60.40.1990', NULL, NULL, NULL, NULL, '', NULL, NULL, 31050, 5),
(231530, NULL, 'G3DSA:3.40.50.720', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231531, NULL, 'G3DSA:6.10.300.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231532, NULL, 'G3DSA:1.25.40.730', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231533, NULL, 'G3DSA:1.10.490.10', NULL, NULL, NULL, NULL, 'Globins', NULL, NULL, 13947, 5),
(231534, NULL, 'G3DSA:1.10.8.660', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231535, NULL, 'G3DSA:1.25.40.410', NULL, NULL, NULL, NULL, '', NULL, NULL, 34582, 5),
(231536, NULL, 'G3DSA:1.10.10.1200', NULL, NULL, NULL, NULL, 'MAGE homology domain, winged helix WH1 motif', NULL, NULL, 30901, 5),
(231537, NULL, 'G3DSA:6.20.240.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231538, NULL, 'G3DSA:4.10.91.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231539, NULL, 'G3DSA:3.40.50.12780', NULL, NULL, NULL, NULL, '', NULL, NULL, 30961, 5),
(231540, NULL, 'G3DSA:3.40.462.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231541, NULL, 'G3DSA:3.10.450.130', NULL, NULL, NULL, NULL, 'folded 79 residue fragment of lin0334 like domains', NULL, NULL, NULL, 5),
(231542, NULL, 'G3DSA:4.10.80.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231543, NULL, 'G3DSA:6.10.250.690', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231544, NULL, 'G3DSA:6.10.250.3250', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231545, NULL, 'G3DSA:3.30.300.360', NULL, NULL, NULL, NULL, 'Protein of unknown function (DUF2498)', NULL, NULL, 29563, 5),
(231546, NULL, 'G3DSA:1.20.58.450', NULL, NULL, NULL, NULL, 'Cell division control protein 42 homolog', NULL, NULL, NULL, 5),
(231547, NULL, 'G3DSA:2.40.30.270', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231548, NULL, 'G3DSA:2.160.20.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231549, NULL, 'G3DSA:3.10.290.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231550, NULL, 'G3DSA:1.10.20.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 35702, 5),
(231551, NULL, 'G3DSA:3.10.20.410', NULL, NULL, NULL, NULL, '', NULL, NULL, 27708, 5),
(231552, NULL, 'G3DSA:3.50.30.70', NULL, NULL, NULL, NULL, 'Swiveling domain of dehydratase reactivase alpha subunit', NULL, NULL, 24350, 5),
(231553, NULL, 'G3DSA:6.10.250.1300', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231554, NULL, 'G3DSA:3.30.310.120', NULL, NULL, NULL, NULL, 'Rbstp2229 like protein', NULL, NULL, NULL, 5),
(231555, NULL, 'G3DSA:3.30.160.80', NULL, NULL, NULL, NULL, 'Amb V Allergen', NULL, NULL, 31907, 5),
(231556, NULL, 'G3DSA:1.25.40.620', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231557, NULL, 'G3DSA:3.30.70.1090', NULL, NULL, NULL, NULL, 'Dimeric alpha+beta barrel.', NULL, NULL, 32466, 5),
(231558, NULL, 'G3DSA:1.20.1440.230', NULL, NULL, NULL, NULL, '', NULL, NULL, 33164, 5),
(231559, NULL, 'G3DSA:1.10.8.560', NULL, NULL, NULL, NULL, 'Antirestriction protein ArdA, domain 2', NULL, NULL, 30120, 5),
(231560, NULL, 'G3DSA:3.30.1940.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29947, 5),
(231561, NULL, 'G3DSA:6.10.140.650', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(231562, NULL, 'G3DSA:1.20.120.900', NULL, NULL, NULL, NULL, 'Pex19, mPTS binding domain', NULL, NULL, 28607, 5),
(231563, NULL, 'G3DSA:1.20.1310.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231564, NULL, 'G3DSA:6.10.250.3300', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231565, NULL, 'G3DSA:1.20.1420.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 33056, 5),
(231566, NULL, 'G3DSA:1.20.1260.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 7627, 5),
(231567, NULL, 'G3DSA:1.25.40.570', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231568, NULL, 'G3DSA:3.10.10.10', NULL, NULL, NULL, NULL, 'HIV Type 1 Reverse Transcriptase, subunit A, domain 1', NULL, NULL, NULL, 5),
(231569, NULL, 'G3DSA:2.20.25.420', NULL, NULL, NULL, NULL, 'ZPR1, zinc finger domain', NULL, NULL, 33895, 5),
(231570, NULL, 'G3DSA:6.10.250.2670', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231571, NULL, 'G3DSA:6.20.370.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231572, NULL, 'G3DSA:1.10.287.120', NULL, NULL, NULL, NULL, '', NULL, NULL, 32481, 5),
(231573, NULL, 'G3DSA:3.60.20.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 35116, 5),
(231574, NULL, 'G3DSA:1.20.5.5260', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231575, NULL, 'G3DSA:1.10.340.60', NULL, NULL, NULL, NULL, 'AcsD, palm domain, helix bundle', NULL, NULL, 35997, 5),
(231576, NULL, 'G3DSA:1.20.5.3310', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231577, NULL, 'G3DSA:1.10.3080.10', NULL, NULL, NULL, NULL, 'Clc chloride channel', NULL, NULL, NULL, 5),
(231578, NULL, 'G3DSA:3.30.250.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 34414, 5),
(231579, NULL, 'G3DSA:2.20.25.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231580, NULL, 'G3DSA:1.20.141.10', NULL, NULL, NULL, NULL, 'Chitosanase, subunit A, domain 1', NULL, NULL, NULL, 5),
(231581, NULL, 'G3DSA:3.30.210.10', NULL, NULL, NULL, NULL, 'DNA polymerase, thumb domain', NULL, NULL, 29918, 5),
(231582, NULL, 'G3DSA:3.30.70.1250', NULL, NULL, NULL, NULL, 'Phosphopentomutase', NULL, NULL, 12458, 5),
(231583, NULL, 'G3DSA:1.10.286.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231584, NULL, 'G3DSA:2.60.40.1960', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231585, NULL, 'G3DSA:1.10.132.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231586, NULL, 'G3DSA:3.40.50.1980', NULL, NULL, NULL, NULL, 'Nitrogenase molybdenum iron protein domain', NULL, NULL, NULL, 5),
(231587, NULL, 'G3DSA:1.20.5.1140', NULL, NULL, NULL, NULL, 'Docking domain of the erythromycin polyketide synthase (DEBS)', NULL, NULL, NULL, 5),
(231588, NULL, 'G3DSA:6.10.280.130', NULL, NULL, NULL, NULL, '', NULL, NULL, 31240, 5),
(231589, NULL, 'G3DSA:3.40.50.10330', NULL, NULL, NULL, NULL, '', NULL, NULL, 11894, 5),
(231590, NULL, 'G3DSA:4.10.372.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 23057, 5),
(231591, NULL, 'G3DSA:1.10.10.1700', NULL, NULL, NULL, NULL, '', NULL, NULL, 30679, 5),
(231592, NULL, 'G3DSA:3.40.50.10860', NULL, NULL, NULL, NULL, 'Leucine Dehydrogenase, chain A, domain 1', NULL, NULL, NULL, 5),
(231593, NULL, 'G3DSA:2.60.120.770', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231594, NULL, 'G3DSA:1.20.140.180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231595, NULL, 'G3DSA:2.30.120.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 35383, 5),
(231596, NULL, 'G3DSA:3.90.1340.10', NULL, NULL, NULL, NULL, 'Phage tail collar domain', NULL, NULL, 29374, 5),
(231597, NULL, 'G3DSA:3.30.70.1470', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231598, NULL, 'G3DSA:3.40.850.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231599, NULL, 'G3DSA:6.10.250.520', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231600, NULL, 'G3DSA:2.40.390.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 12382, 5),
(231601, NULL, 'G3DSA:3.30.1850.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29922, 5),
(231602, NULL, 'G3DSA:2.60.40.4100', NULL, NULL, NULL, NULL, '', NULL, NULL, 36242, 5),
(231603, NULL, 'G3DSA:1.10.3880.10', NULL, NULL, NULL, NULL, 'Fe(II) trafficking protein YggX', NULL, NULL, 32378, 5);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(231604, NULL, 'G3DSA:6.10.50.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231605, NULL, 'G3DSA:3.30.2060.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231606, NULL, 'G3DSA:3.90.1460.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 30660, 5),
(231607, NULL, 'G3DSA:1.20.58.1930', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231608, NULL, 'G3DSA:3.30.240.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231609, NULL, 'G3DSA:1.10.150.550', NULL, NULL, NULL, NULL, 'Arenavirus nucleocapsid protein, head domain', NULL, NULL, NULL, 5),
(231610, NULL, 'G3DSA:3.90.79.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 36443, 5),
(231611, NULL, 'G3DSA:1.20.1280.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231612, NULL, 'G3DSA:6.10.140.830', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231613, NULL, 'G3DSA:3.30.70.2050', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231614, NULL, 'G3DSA:3.40.600.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 34006, 5),
(231615, NULL, 'G3DSA:1.20.58.1980', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231616, NULL, 'G3DSA:3.30.457.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29888, 5),
(231617, NULL, 'G3DSA:1.20.1050.40', NULL, NULL, NULL, NULL, 'Endopeptidase. Chain P; domain 1', NULL, NULL, 12266, 5),
(231618, NULL, 'G3DSA:1.10.100.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231619, NULL, 'G3DSA:1.20.58.1360', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231620, NULL, 'G3DSA:1.20.1280.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231621, NULL, 'G3DSA:2.30.29.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231622, NULL, 'G3DSA:1.10.418.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28152, 5),
(231623, NULL, 'G3DSA:3.30.1120.180', NULL, NULL, NULL, NULL, '', NULL, NULL, 28877, 5),
(231624, NULL, 'G3DSA:6.10.250.2230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231625, NULL, 'G3DSA:1.10.287.560', NULL, NULL, NULL, NULL, '', NULL, NULL, 28491, 5),
(231626, NULL, 'G3DSA:3.40.50.12640', NULL, NULL, NULL, NULL, 'Phosphopantoate/pantothenate synthetase', NULL, NULL, 32359, 5),
(231627, NULL, 'G3DSA:6.10.280.240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231628, NULL, 'G3DSA:2.60.40.1340', NULL, NULL, NULL, NULL, '', NULL, NULL, 11172, 5),
(231629, NULL, 'G3DSA:6.10.140.1900', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231630, NULL, 'G3DSA:3.40.430.10', NULL, NULL, NULL, NULL, 'Dihydrofolate Reductase, subunit A', NULL, NULL, 18665, 5),
(231631, NULL, 'G3DSA:2.60.40.380', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231632, NULL, 'G3DSA:3.30.160.140', NULL, NULL, NULL, NULL, '', NULL, NULL, 29914, 5),
(231633, NULL, 'G3DSA:2.60.120.1310', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231634, NULL, 'G3DSA:3.30.730.10', NULL, NULL, NULL, NULL, 'AP2/ERF domain', NULL, NULL, 28228, 5),
(231635, NULL, 'G3DSA:1.10.287.930', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231636, NULL, 'G3DSA:3.30.110.110', NULL, NULL, NULL, NULL, 'Mre11, capping domain', NULL, NULL, 32624, 5),
(231637, NULL, 'G3DSA:3.30.1540.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 34782, 5),
(231638, NULL, 'G3DSA:3.10.129.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 36278, 5),
(231639, NULL, 'G3DSA:2.30.60.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29673, 5),
(231640, NULL, 'G3DSA:3.40.50.80', NULL, NULL, NULL, NULL, '', NULL, NULL, 33418, 5),
(231641, NULL, 'G3DSA:1.10.287.800', NULL, NULL, NULL, NULL, 'protein ne1242', NULL, NULL, NULL, 5),
(231642, NULL, 'G3DSA:6.10.140.1950', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231643, NULL, 'G3DSA:1.10.4180.10', NULL, NULL, NULL, NULL, 'Protein LEAFY', NULL, NULL, 31136, 5),
(231644, NULL, 'G3DSA:4.10.93.10', NULL, NULL, NULL, NULL, 'Mitochondrial cytochrome c oxidase subunit VIc/VIIs', NULL, NULL, 29555, 5),
(231645, NULL, 'G3DSA:1.20.1050.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231646, NULL, 'G3DSA:3.30.70.2690', NULL, NULL, NULL, NULL, 'LOR/SDH bifunctional enzyme, conserved domain', NULL, NULL, 36376, 5),
(231647, NULL, 'G3DSA:6.20.70.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(231648, NULL, 'G3DSA:1.10.1350.10', NULL, NULL, NULL, NULL, 'Viral capsid alpha domain', NULL, NULL, NULL, 5),
(231649, NULL, 'G3DSA:6.20.50.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231650, NULL, 'G3DSA:6.10.250.1260', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231651, NULL, 'G3DSA:2.70.20.40', NULL, NULL, NULL, NULL, 'Borna disease virus, matrix protein', NULL, NULL, 27239, 5),
(231652, NULL, 'G3DSA:6.20.10.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231653, NULL, 'G3DSA:3.40.198.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 24109, 5),
(231654, NULL, 'G3DSA:1.10.246.230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231655, NULL, 'G3DSA:3.30.1370.190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231656, NULL, 'G3DSA:2.60.40.1460', NULL, NULL, NULL, NULL, 'Integrin domains. Chain A, domain 2', NULL, NULL, NULL, 5),
(231657, NULL, 'G3DSA:2.60.40.1910', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231658, NULL, 'G3DSA:1.10.150.920', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231659, NULL, 'G3DSA:3.30.420.320', NULL, NULL, NULL, NULL, '', NULL, NULL, 31064, 5),
(231660, NULL, 'G3DSA:4.10.1240.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231661, NULL, 'G3DSA:3.30.2390.20', NULL, NULL, NULL, NULL, 'Type VII secretion system EccB, repeat 1 domain', NULL, NULL, 34619, 5),
(231662, NULL, 'G3DSA:2.30.30.440', NULL, NULL, NULL, NULL, 'Domain of unknown function DUF1918', NULL, NULL, NULL, 5),
(231663, NULL, 'G3DSA:2.70.9.20', NULL, NULL, NULL, NULL, 'Major capsid protein Vp54', NULL, NULL, 32152, 5),
(231664, NULL, 'G3DSA:3.30.500.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231665, NULL, 'G3DSA:6.10.250.1680', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231666, NULL, 'G3DSA:1.20.120.640', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231667, NULL, 'G3DSA:3.30.70.440', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231668, NULL, 'G3DSA:3.30.1370.80', NULL, NULL, NULL, NULL, '', NULL, NULL, 31383, 5),
(231669, NULL, 'G3DSA:1.10.3900.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231670, NULL, 'G3DSA:3.10.20.320', NULL, NULL, NULL, NULL, 'Putative peptidoglycan bound protein (lpxtg motif)', NULL, NULL, NULL, 5),
(231671, NULL, 'G3DSA:4.10.60.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231672, NULL, 'G3DSA:1.20.1070.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231673, NULL, 'G3DSA:3.30.63.10', NULL, NULL, NULL, NULL, 'Guanylate Kinase phosphate binding domain', NULL, NULL, NULL, 5),
(231674, NULL, 'G3DSA:1.10.8.950', NULL, NULL, NULL, NULL, '', NULL, NULL, 35878, 5),
(231675, NULL, 'G3DSA:1.20.58.340', NULL, NULL, NULL, NULL, 'Magnesium transport protein CorA, transmembrane region', NULL, NULL, NULL, 5),
(231676, NULL, 'G3DSA:1.10.3710.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231677, NULL, 'G3DSA:1.20.5.210', NULL, NULL, NULL, NULL, '', NULL, NULL, 30560, 5),
(231678, NULL, 'G3DSA:6.10.250.1900', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231679, NULL, 'G3DSA:6.10.140.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231680, NULL, 'G3DSA:1.10.1220.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231681, NULL, 'G3DSA:1.20.1390.10', NULL, NULL, NULL, NULL, 'PWI domain', NULL, NULL, NULL, 5),
(231682, NULL, 'G3DSA:2.60.120.1150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231683, NULL, 'G3DSA:2.60.120.810', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231684, NULL, 'G3DSA:3.10.450.30', NULL, NULL, NULL, NULL, 'Microbial ribonucleases', NULL, NULL, NULL, 5),
(231685, NULL, 'G3DSA:2.60.40.3130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231686, NULL, 'G3DSA:1.20.120.1900', NULL, NULL, NULL, NULL, '', NULL, NULL, 33580, 5),
(231687, NULL, 'G3DSA:6.10.250.1290', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231688, NULL, 'G3DSA:2.40.50.770', NULL, NULL, NULL, NULL, '', NULL, NULL, 37629, 5),
(231689, NULL, 'G3DSA:2.20.140.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231690, NULL, 'G3DSA:6.10.10.80', NULL, NULL, NULL, NULL, '', NULL, NULL, 31061, 5);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(231691, NULL, 'G3DSA:2.20.25.290', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231692, NULL, 'G3DSA:6.10.140.330', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231693, NULL, 'G3DSA:3.40.1530.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 27838, 5),
(231694, NULL, 'G3DSA:3.20.20.490', NULL, NULL, NULL, NULL, '', NULL, NULL, 32042, 5),
(231695, NULL, 'G3DSA:1.10.287.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 33397, 5),
(231696, NULL, 'G3DSA:1.50.10.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 7544, 5),
(231697, NULL, 'G3DSA:3.30.70.1630', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231698, NULL, 'G3DSA:1.10.3100.20', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF269', NULL, NULL, NULL, 5),
(231699, NULL, 'G3DSA:3.30.370.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 11447, 5),
(231700, NULL, 'G3DSA:3.30.1370.140', NULL, NULL, NULL, NULL, '', NULL, NULL, 27576, 5),
(231701, NULL, 'G3DSA:3.30.70.2440', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231702, NULL, 'G3DSA:3.30.1120.40', NULL, NULL, NULL, NULL, 'Stage V sporulation protein G', NULL, NULL, 32060, 5),
(231703, NULL, 'G3DSA:3.90.940.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 30145, 5),
(231704, NULL, 'G3DSA:3.60.21.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 24118, 5),
(231705, NULL, 'G3DSA:3.30.920.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 33117, 5),
(231706, NULL, 'G3DSA:3.40.50.10830', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231707, NULL, 'G3DSA:6.10.250.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231708, NULL, 'G3DSA:2.60.40.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 32123, 5),
(231709, NULL, 'G3DSA:3.40.50.11410', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231710, NULL, 'G3DSA:3.30.70.2470', NULL, NULL, NULL, NULL, '', NULL, NULL, 30498, 5),
(231711, NULL, 'G3DSA:1.20.1050.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231712, NULL, 'G3DSA:3.30.70.670', NULL, NULL, NULL, NULL, '', NULL, NULL, 29825, 5),
(231713, NULL, 'G3DSA:3.20.120.10', NULL, NULL, NULL, NULL, 'Hydrophobin', NULL, NULL, 32380, 5),
(231714, NULL, 'G3DSA:3.40.50.11130', NULL, NULL, NULL, NULL, 'Glycoprotein VP7, domain 1', NULL, NULL, 35149, 5),
(231715, NULL, 'G3DSA:1.10.287.900', NULL, NULL, NULL, NULL, 'The crystal structure of the spermine/spermidine acetyltransferase from enterococcus faecali', NULL, NULL, 26965, 5),
(231716, NULL, 'G3DSA:6.10.140.2170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231717, NULL, 'G3DSA:3.30.2020.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231718, NULL, 'G3DSA:3.90.1650.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33366, 5),
(231719, NULL, 'G3DSA:2.60.40.2910', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231720, NULL, 'G3DSA:3.30.70.2210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231721, NULL, 'G3DSA:2.60.40.2750', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231722, NULL, 'G3DSA:2.30.30.240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231723, NULL, 'G3DSA:1.10.287.860', NULL, NULL, NULL, NULL, 'Nucleotidyltransferase', NULL, NULL, NULL, 5),
(231724, NULL, 'G3DSA:3.30.70.2830', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231725, NULL, 'G3DSA:2.60.40.1940', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231726, NULL, 'G3DSA:3.90.350.10', NULL, NULL, NULL, NULL, 'Transposase Inhibitor Protein From Tn5; Chain A, domain 1', NULL, NULL, NULL, 5),
(231727, NULL, 'G3DSA:1.10.150.790', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5),
(231728, NULL, 'G3DSA:2.70.230.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231729, NULL, 'G3DSA:3.10.450.570', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231730, NULL, 'G3DSA:3.30.310.160', NULL, NULL, NULL, NULL, 'YycH protein, domain 2', NULL, NULL, 34858, 5),
(231731, NULL, 'G3DSA:3.90.39.10', NULL, NULL, NULL, NULL, 'Hexon Major Viral Coat Protein, domain 2', NULL, NULL, 36954, 5),
(231732, NULL, 'G3DSA:6.10.250.480', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5),
(231733, NULL, 'G3DSA:2.20.25.510', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(231734, NULL, 'G3DSA:3.30.565.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231735, NULL, 'G3DSA:1.20.120.1510', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231736, NULL, 'G3DSA:2.30.130.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231737, NULL, 'G3DSA:3.40.970.40', NULL, NULL, NULL, NULL, 'fibrinogen binding protein from staphylococcus aureus domain like', NULL, NULL, NULL, 5),
(231738, NULL, 'G3DSA:1.10.150.420', NULL, NULL, NULL, NULL, '', NULL, NULL, 31873, 5),
(231739, NULL, 'G3DSA:2.60.120.1540', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231740, NULL, 'G3DSA:3.10.450.580', NULL, NULL, NULL, NULL, 'Mediator complex, subunit Med6', NULL, NULL, 30511, 5),
(231741, NULL, 'G3DSA:3.40.630.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231742, NULL, 'G3DSA:3.30.1030.10', NULL, NULL, NULL, NULL, 'Methenyltetrahydromethanopterin Cyclohydrolase; Chain A, domain 2', NULL, NULL, NULL, 5),
(231743, NULL, 'G3DSA:3.40.50.1070', NULL, NULL, NULL, NULL, '', NULL, NULL, 27285, 5),
(231744, NULL, 'G3DSA:3.90.228.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 14040, 5),
(231745, NULL, 'G3DSA:3.10.330.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231746, NULL, 'G3DSA:1.10.10.2120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231747, NULL, 'G3DSA:3.30.310.140', NULL, NULL, NULL, NULL, 'sec7 domains', NULL, NULL, 30744, 5),
(231748, NULL, 'G3DSA:1.20.1440.260', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231749, NULL, 'G3DSA:2.30.30.630', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231750, NULL, 'G3DSA:1.10.167.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231751, NULL, 'G3DSA:6.10.140.1010', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5),
(231752, NULL, 'G3DSA:3.40.190.170', NULL, NULL, NULL, NULL, '', NULL, NULL, 27458, 5),
(231753, NULL, 'G3DSA:2.40.240.130', NULL, NULL, NULL, NULL, '', NULL, NULL, 29895, 5),
(231754, NULL, 'G3DSA:3.30.2320.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231755, NULL, 'G3DSA:1.25.40.200', NULL, NULL, NULL, NULL, '', NULL, NULL, 32243, 5),
(231756, NULL, 'G3DSA:2.60.120.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231757, NULL, 'G3DSA:1.10.1850.10', NULL, NULL, NULL, NULL, 'Scaffold protein D', NULL, NULL, 30523, 5),
(231758, NULL, 'G3DSA:3.30.1750.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 21947, 5),
(231759, NULL, 'G3DSA:3.30.760.10', NULL, NULL, NULL, NULL, 'RNA Cap, Translation Initiation Factor Eif4e', NULL, NULL, 16121, 5),
(231760, NULL, 'G3DSA:3.30.310.60', NULL, NULL, NULL, NULL, '', NULL, NULL, 29630, 5),
(231761, NULL, 'G3DSA:1.20.190.30', NULL, NULL, NULL, NULL, 'CAG pathogenicity island protein, CagZ', NULL, NULL, 31747, 5),
(231762, NULL, 'G3DSA:1.20.1270.340', NULL, NULL, NULL, NULL, '', NULL, NULL, 32796, 5),
(231763, NULL, 'G3DSA:3.30.500.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29779, 5),
(231764, NULL, 'G3DSA:3.30.750.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231765, NULL, 'G3DSA:1.20.5.810', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231766, NULL, 'G3DSA:1.10.10.2330', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231767, NULL, 'G3DSA:1.25.40.780', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231768, NULL, 'G3DSA:1.10.1320.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29964, 5),
(231769, NULL, 'G3DSA:3.30.470.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 37202, 5),
(231770, NULL, 'G3DSA:1.20.120.230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231771, NULL, 'G3DSA:2.10.150.10', NULL, NULL, NULL, NULL, 'Urease, beta subunit', NULL, NULL, 28395, 5),
(231772, NULL, 'G3DSA:1.20.1280.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231773, NULL, 'G3DSA:2.30.280.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31580, 5),
(231774, NULL, 'G3DSA:1.10.8.1210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231775, NULL, 'G3DSA:2.40.10.230', NULL, NULL, NULL, NULL, 'Probable tRNA pseudouridine synthase domain', NULL, NULL, 33666, 5),
(231776, NULL, 'G3DSA:3.30.1650.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32310, 5);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(231777, NULL, 'G3DSA:6.20.440.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231778, NULL, 'G3DSA:1.20.50.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231779, NULL, 'G3DSA:1.10.10.850', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231780, NULL, 'G3DSA:1.10.238.220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231781, NULL, 'G3DSA:2.170.140.10', NULL, NULL, NULL, NULL, 'Chitin binding domain', NULL, NULL, NULL, 5),
(231782, NULL, 'G3DSA:1.10.238.270', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231783, NULL, 'G3DSA:3.30.450.220', NULL, NULL, NULL, NULL, '', NULL, NULL, 35975, 5),
(231784, NULL, 'G3DSA:1.10.3230.20', NULL, NULL, NULL, NULL, 'P22 tail accessory factor (Gp4)', NULL, NULL, 27355, 5),
(231785, NULL, 'G3DSA:2.40.40.50', NULL, NULL, NULL, NULL, '', NULL, NULL, 34986, 5),
(231786, NULL, 'G3DSA:1.20.120.1300', NULL, NULL, NULL, NULL, '', NULL, NULL, 31964, 5),
(231787, NULL, 'G3DSA:6.10.250.2260', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231788, NULL, 'G3DSA:6.10.250.730', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231789, NULL, 'G3DSA:3.30.457.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231790, NULL, 'G3DSA:1.10.287.620', NULL, NULL, NULL, NULL, 'Helix Hairpins', NULL, NULL, NULL, 5),
(231791, NULL, 'G3DSA:1.10.8.240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231792, NULL, 'G3DSA:3.40.50.11620', NULL, NULL, NULL, NULL, '', NULL, NULL, 32333, 5),
(231793, NULL, 'G3DSA:1.10.150.740', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231794, NULL, 'G3DSA:1.20.58.1770', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231795, NULL, 'G3DSA:3.10.450.750', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231796, NULL, 'G3DSA:1.25.40.10', NULL, NULL, NULL, NULL, 'Tetratricopeptide repeat domain', NULL, NULL, 12923, 5),
(231797, NULL, 'G3DSA:6.20.90.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231798, NULL, 'G3DSA:6.10.250.2490', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231799, NULL, 'G3DSA:6.10.250.2440', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231800, NULL, 'G3DSA:3.30.980.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231801, NULL, 'G3DSA:2.20.28.200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231802, NULL, 'G3DSA:3.30.1040.10', NULL, NULL, NULL, NULL, 'Carboxypeptidase inhibitor', NULL, NULL, 8097, 5),
(231803, NULL, 'G3DSA:6.10.250.1510', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231804, NULL, 'G3DSA:3.30.70.3190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231805, NULL, 'G3DSA:3.30.200.20', NULL, NULL, NULL, NULL, 'Phosphorylase Kinase; domain 1', NULL, NULL, NULL, 5),
(231806, NULL, 'G3DSA:2.60.40.2520', NULL, NULL, NULL, NULL, 'CFA/I fimbrial subunit E, adhesin domain', NULL, NULL, 33709, 5),
(231807, NULL, 'G3DSA:1.10.8.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231808, NULL, 'G3DSA:1.10.287.3550', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231809, NULL, 'G3DSA:4.10.80.20', NULL, NULL, NULL, NULL, 'DNA polymerase; domain 5', NULL, NULL, NULL, 5),
(231810, NULL, 'G3DSA:1.10.10.2080', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231811, NULL, 'G3DSA:3.30.70.2600', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231812, NULL, 'G3DSA:3.55.60.10', NULL, NULL, NULL, NULL, 'Reovirus components', NULL, NULL, NULL, 5),
(231813, NULL, 'G3DSA:3.30.160.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231814, NULL, 'G3DSA:1.10.30.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 35030, 5),
(231815, NULL, 'G3DSA:4.10.1310.10', NULL, NULL, NULL, NULL, 'Dinoflagellate luciferase repeat', NULL, NULL, 34002, 5),
(231816, NULL, 'G3DSA:2.60.40.3890', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231817, NULL, 'G3DSA:6.20.250.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231818, NULL, 'G3DSA:3.30.450.130', NULL, NULL, NULL, NULL, 'irre protein', NULL, NULL, NULL, 5),
(231819, NULL, 'G3DSA:1.10.1070.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231820, NULL, 'G3DSA:1.10.287.380', NULL, NULL, NULL, NULL, '', NULL, NULL, 28242, 5);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(231821, NULL, 'G3DSA:3.30.920.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231822, NULL, 'G3DSA:2.40.128.190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231823, NULL, 'G3DSA:6.20.250.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231824, NULL, 'G3DSA:4.10.860.20', NULL, NULL, NULL, NULL, 'Rabenosyn, Rab binding domain', NULL, NULL, NULL, 5),
(231825, NULL, 'G3DSA:3.30.1360.210', NULL, NULL, NULL, NULL, '', NULL, NULL, 27811, 5),
(231826, NULL, 'G3DSA:3.10.20.250', NULL, NULL, NULL, NULL, '', NULL, NULL, 14967, 5),
(231827, NULL, 'G3DSA:3.10.350.10', NULL, NULL, NULL, NULL, 'LysM domain', NULL, NULL, 33105, 5),
(231828, NULL, 'G3DSA:6.10.20.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231829, NULL, 'G3DSA:1.10.720.180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231830, NULL, 'G3DSA:3.30.1330.50', NULL, NULL, NULL, NULL, '', NULL, NULL, 31207, 5),
(231831, NULL, 'G3DSA:3.10.450.250', NULL, NULL, NULL, NULL, 'S. aureus uracil DNA glycosylase inhibitor', NULL, NULL, 36405, 5),
(231832, NULL, 'G3DSA:1.10.287.550', NULL, NULL, NULL, NULL, 'Helix hairpin bin', NULL, NULL, NULL, 5),
(231833, NULL, 'G3DSA:2.170.30.10', NULL, NULL, NULL, NULL, 'Parvovirus coat protein VP1/VP2', NULL, NULL, 30610, 5),
(231834, NULL, 'G3DSA:2.160.20.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231835, NULL, 'G3DSA:1.20.920.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231836, NULL, 'G3DSA:1.20.120.1260', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231837, NULL, 'G3DSA:4.10.860.10', NULL, NULL, NULL, NULL, 'UVR domain', NULL, NULL, NULL, 5),
(231838, NULL, 'G3DSA:3.30.70.1240', NULL, NULL, NULL, NULL, '', NULL, NULL, 16776, 5),
(231839, NULL, 'G3DSA:3.90.650.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29804, 5),
(231840, NULL, 'G3DSA:1.10.405.10', NULL, NULL, NULL, NULL, 'Guanine Nucleotide Dissociation Inhibitor, domain 1', NULL, NULL, NULL, 5),
(231841, NULL, 'G3DSA:2.60.60.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231842, NULL, 'G3DSA:6.10.250.1470', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231843, NULL, 'G3DSA:2.60.120.560', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231844, NULL, 'G3DSA:3.40.1000.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231845, NULL, 'G3DSA:2.70.20.60', NULL, NULL, NULL, NULL, '', NULL, NULL, 33634, 5),
(231846, NULL, 'G3DSA:1.10.220.150', NULL, NULL, NULL, NULL, 'Arf GTPase activating protein', NULL, NULL, 31893, 5),
(231847, NULL, 'G3DSA:3.30.70.2650', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231848, NULL, 'G3DSA:3.30.450.270', NULL, NULL, NULL, NULL, '', NULL, NULL, 33996, 5),
(231849, NULL, 'G3DSA:2.60.250.10', NULL, NULL, NULL, NULL, 'Baculovirus p35', NULL, NULL, 33371, 5),
(231850, NULL, 'G3DSA:2.60.260.40', NULL, NULL, NULL, NULL, 'q5lls5 like domains', NULL, NULL, NULL, 5),
(231851, NULL, 'G3DSA:2.20.28.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231852, NULL, 'G3DSA:4.10.80.30', NULL, NULL, NULL, NULL, 'DNA polymerase; domain 6', NULL, NULL, NULL, 5),
(231853, NULL, 'G3DSA:1.20.5.1070', NULL, NULL, NULL, NULL, 'Head and neck region of the ectodomain of NDV fusion glycoprotein', NULL, NULL, NULL, 5),
(231854, NULL, 'G3DSA:3.30.43.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 35778, 5),
(231855, NULL, 'G3DSA:1.10.10.800', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231856, NULL, 'G3DSA:3.30.70.1290', NULL, NULL, NULL, NULL, '', NULL, NULL, 30215, 5),
(231857, NULL, 'G3DSA:2.60.34.10', NULL, NULL, NULL, NULL, 'Substrate Binding Domain Of DNAk; Chain A, domain 1', NULL, NULL, 25744, 5),
(231858, NULL, 'G3DSA:3.30.160.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231859, NULL, 'G3DSA:6.10.250.2880', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231860, NULL, 'G3DSA:3.90.840.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31932, 5),
(231861, NULL, 'G3DSA:1.10.1200.150', NULL, NULL, NULL, NULL, '', NULL, NULL, 30591, 5),
(231862, NULL, 'G3DSA:3.30.420.480', NULL, NULL, NULL, NULL, 'Domain of unknown function (DUF4445)', NULL, NULL, 34776, 5);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(231863, NULL, 'G3DSA:1.10.8.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231864, NULL, 'G3DSA:2.60.40.4330', NULL, NULL, NULL, NULL, '', NULL, NULL, 30372, 5),
(231865, NULL, 'G3DSA:1.20.120.850', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231866, NULL, 'G3DSA:3.30.1610.10', NULL, NULL, NULL, NULL, 'Peptidase S59, nucleoporin', NULL, NULL, 31901, 5),
(231867, NULL, 'G3DSA:2.115.10.10', NULL, NULL, NULL, NULL, 'Tachylectin 2', NULL, NULL, NULL, 5),
(231868, NULL, 'G3DSA:2.60.40.1410', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231869, NULL, 'G3DSA:6.10.140.2040', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231870, NULL, 'G3DSA:1.20.1270.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231871, NULL, 'G3DSA:3.40.50.10930', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231872, NULL, 'G3DSA:3.30.70.930', NULL, NULL, NULL, NULL, '', NULL, NULL, 26209, 5),
(231873, NULL, 'G3DSA:1.25.40.990', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231874, NULL, 'G3DSA:2.60.480.10', NULL, NULL, NULL, NULL, 'eubacterium ventriosum atcc domain', NULL, NULL, 31197, 5),
(231875, NULL, 'G3DSA:2.60.40.2960', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231876, NULL, 'G3DSA:2.30.220.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231877, NULL, 'G3DSA:1.10.1750.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 10030, 5),
(231878, NULL, 'G3DSA:6.10.250.1720', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231879, NULL, 'G3DSA:2.30.30.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231880, NULL, 'G3DSA:1.10.150.350', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231881, NULL, 'G3DSA:6.10.140.1510', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231882, NULL, 'G3DSA:1.20.5.340', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231883, NULL, 'G3DSA:3.10.450.330', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231884, NULL, 'G3DSA:1.10.10.1990', NULL, NULL, NULL, NULL, '', NULL, NULL, 30429, 5),
(231885, NULL, 'G3DSA:3.90.600.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231886, NULL, 'G3DSA:3.40.1350.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231887, NULL, 'G3DSA:1.10.3340.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33305, 5),
(231888, NULL, 'G3DSA:3.90.980.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29807, 5),
(231889, NULL, 'G3DSA:3.60.140.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32799, 5),
(231890, NULL, 'G3DSA:2.170.150.80', NULL, NULL, NULL, NULL, 'NAC domain', NULL, NULL, 27238, 5),
(231891, NULL, 'G3DSA:6.10.140.200', NULL, NULL, NULL, NULL, '', NULL, NULL, 34192, 5),
(231892, NULL, 'G3DSA:1.25.40.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 33123, 5),
(231893, NULL, 'G3DSA:3.30.1790.10', NULL, NULL, NULL, NULL, 'hypothetical protein mp506/mpn330, domain 2', NULL, NULL, 16257, 5),
(231894, NULL, 'G3DSA:1.10.3180.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 15732, 5),
(231895, NULL, 'G3DSA:4.10.480.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29544, 5),
(231896, NULL, 'G3DSA:6.10.250.2330', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231897, NULL, 'G3DSA:6.10.250.940', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231898, NULL, 'G3DSA:2.170.200.10', NULL, NULL, NULL, NULL, 'Papillomavirus E2 early protein domain', NULL, NULL, 36546, 5),
(231899, NULL, 'G3DSA:1.10.287.1030', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231900, NULL, 'G3DSA:3.20.20.330', NULL, NULL, NULL, NULL, '', NULL, NULL, 32917, 5),
(231901, NULL, 'G3DSA:3.20.20.390', NULL, NULL, NULL, NULL, '', NULL, NULL, 32220, 5),
(231902, NULL, 'G3DSA:6.10.250.1800', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231903, NULL, 'G3DSA:1.20.5.2210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231904, NULL, 'G3DSA:3.30.70.1130', NULL, NULL, NULL, NULL, 'EIF_2_alpha', NULL, NULL, 12343, 5),
(231905, NULL, 'G3DSA:3.65.10.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 28032, 5),
(231906, NULL, 'G3DSA:3.30.60.300', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231907, NULL, 'G3DSA:3.30.430.10', NULL, NULL, NULL, NULL, 'Killer Toxin P4, subunit A', NULL, NULL, NULL, 5);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(231908, NULL, 'G3DSA:3.30.1490.330', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231909, NULL, 'G3DSA:2.60.200.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 11669, 5),
(231910, NULL, 'G3DSA:1.40.10.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33287, 5),
(231911, NULL, 'G3DSA:6.10.280.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231912, NULL, 'G3DSA:1.10.246.130', NULL, NULL, NULL, NULL, '', NULL, NULL, 35195, 5),
(231913, NULL, 'G3DSA:3.30.310.190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231914, NULL, 'G3DSA:1.10.287.700', NULL, NULL, NULL, NULL, 'Helix hairpin bin', NULL, NULL, NULL, 5),
(231915, NULL, 'G3DSA:2.60.40.4200', NULL, NULL, NULL, NULL, '', NULL, NULL, 35403, 5),
(231916, NULL, 'G3DSA:1.10.2000.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33386, 5),
(231917, NULL, 'G3DSA:1.20.5.530', NULL, NULL, NULL, NULL, 'Single helix bin', NULL, NULL, NULL, 5),
(231918, NULL, 'G3DSA:1.20.58.2040', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231919, NULL, 'G3DSA:1.20.1440.160', NULL, NULL, NULL, NULL, '', NULL, NULL, 33025, 5),
(231920, NULL, 'G3DSA:3.30.2230.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 26596, 5),
(231921, NULL, 'G3DSA:3.50.30.10', NULL, NULL, NULL, NULL, 'Phosphohistidine domain', NULL, NULL, NULL, 5),
(231922, NULL, 'G3DSA:2.60.20.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 14395, 5),
(231923, NULL, 'G3DSA:3.40.50.11540', NULL, NULL, NULL, NULL, '', NULL, NULL, 29146, 5),
(231924, NULL, 'G3DSA:2.60.40.2290', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231925, NULL, 'G3DSA:1.20.140.90', NULL, NULL, NULL, NULL, '', NULL, NULL, 33308, 5),
(231926, NULL, 'G3DSA:1.20.1440.60', NULL, NULL, NULL, NULL, '', NULL, NULL, 29897, 5),
(231927, NULL, 'G3DSA:3.90.1470.10', NULL, NULL, NULL, NULL, 'thrh gene product, domain 2', NULL, NULL, NULL, 5),
(231928, NULL, 'G3DSA:1.10.1790.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231929, NULL, 'G3DSA:6.10.140.1430', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231930, NULL, 'G3DSA:3.30.310.210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231931, NULL, 'G3DSA:3.20.10.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 34829, 5),
(231932, NULL, 'G3DSA:3.10.450.90', NULL, NULL, NULL, NULL, 'ArcTGT, C2 domain', NULL, NULL, 27870, 5),
(231933, NULL, 'G3DSA:2.40.160.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231934, NULL, 'G3DSA:3.10.680.10', NULL, NULL, NULL, NULL, 'Photosystem II CP47 reaction center protein', NULL, NULL, NULL, 5),
(231935, NULL, 'G3DSA:1.10.472.180', NULL, NULL, NULL, NULL, '', NULL, NULL, 36454, 5),
(231936, NULL, 'G3DSA:3.30.1300.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 27974, 5),
(231937, NULL, 'G3DSA:3.30.2370.10', NULL, NULL, NULL, NULL, 'putative pyruvate dehydrogenase', NULL, NULL, NULL, 5),
(231938, NULL, 'G3DSA:3.10.20.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231939, NULL, 'G3DSA:1.10.1780.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 30568, 5),
(231940, NULL, 'G3DSA:3.90.470.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 28137, 5),
(231941, NULL, 'G3DSA:3.40.1350.150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231942, NULL, 'G3DSA:3.40.50.11850', NULL, NULL, NULL, NULL, 'Diphthamide synthesis DPH1/DPH2 domain 2', NULL, NULL, 34839, 5),
(231943, NULL, 'G3DSA:1.10.10.1930', NULL, NULL, NULL, NULL, '', NULL, NULL, 29542, 5),
(231944, NULL, 'G3DSA:2.60.120.1440', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231945, NULL, 'G3DSA:3.30.1360.120', NULL, NULL, NULL, NULL, 'Probable tRNA modification gtpase trme; domain 1', NULL, NULL, 17031, 5),
(231946, NULL, 'G3DSA:1.20.1270.240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231947, NULL, 'G3DSA:3.40.50.12360', NULL, NULL, NULL, NULL, '', NULL, NULL, 32197, 5),
(231948, NULL, 'G3DSA:2.40.160.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231949, NULL, 'G3DSA:3.30.230.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231950, NULL, 'G3DSA:2.20.25.390', NULL, NULL, NULL, NULL, 'Stomagen', NULL, NULL, 29923, 5),
(231951, NULL, 'G3DSA:1.10.230.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 9197, 5);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(231952, NULL, 'G3DSA:3.40.50.10180', NULL, NULL, NULL, NULL, '', NULL, NULL, 32414, 5),
(231953, NULL, 'G3DSA:2.70.180.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231954, NULL, 'G3DSA:1.10.3410.10', NULL, NULL, NULL, NULL, 'putative deoxyguanosinetriphosphate triphosphohydrolase like domain', NULL, NULL, 15701, 5),
(231955, NULL, 'G3DSA:3.10.50.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 24132, 5),
(231956, NULL, 'G3DSA:1.20.1270.140', NULL, NULL, NULL, NULL, 'AvrPto', NULL, NULL, 30024, 5),
(231957, NULL, 'G3DSA:2.60.220.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 10220, 5),
(231958, NULL, 'G3DSA:1.10.287.1090', NULL, NULL, NULL, NULL, '', NULL, NULL, 10109, 5),
(231959, NULL, 'G3DSA:2.60.40.770', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231960, NULL, 'G3DSA:1.20.120.1720', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231961, NULL, 'G3DSA:6.10.140.180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231962, NULL, 'G3DSA:3.30.200.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231963, NULL, 'G3DSA:6.10.140.1490', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5),
(231964, NULL, 'G3DSA:1.10.10.880', NULL, NULL, NULL, NULL, '', NULL, NULL, 28771, 5),
(231965, NULL, 'G3DSA:3.90.78.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 27475, 5),
(231966, NULL, 'G3DSA:2.40.30.90', NULL, NULL, NULL, NULL, 'Bacterial fluorinating enzyme like', NULL, NULL, 7299, 5),
(231967, NULL, 'G3DSA:2.60.40.2020', NULL, NULL, NULL, NULL, '', NULL, NULL, 28106, 5),
(231968, NULL, 'G3DSA:3.20.20.520', NULL, NULL, NULL, NULL, 'Glycosyl hydrolase family 115', NULL, NULL, 33856, 5),
(231969, NULL, 'G3DSA:3.40.50.12280', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231970, NULL, 'G3DSA:3.40.91.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 13977, 5),
(231971, NULL, 'G3DSA:2.60.40.2080', NULL, NULL, NULL, NULL, '', NULL, NULL, 29359, 5),
(231972, NULL, 'G3DSA:3.40.50.10050', NULL, NULL, NULL, NULL, '', NULL, NULL, 32562, 5),
(231973, NULL, 'G3DSA:6.10.250.3020', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231974, NULL, 'G3DSA:3.30.1860.10', NULL, NULL, NULL, NULL, 'uncharacterized conserved protein from methanopyrus kandleri domain like', NULL, NULL, NULL, 5),
(231975, NULL, 'G3DSA:3.90.1640.20', NULL, NULL, NULL, NULL, 'TON_0340', NULL, NULL, NULL, 5),
(231976, NULL, 'G3DSA:1.25.40.340', NULL, NULL, NULL, NULL, '', NULL, NULL, 32800, 5),
(231977, NULL, 'G3DSA:3.40.210.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 36111, 5),
(231978, NULL, 'G3DSA:1.10.1740.150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231979, NULL, 'G3DSA:2.60.40.1890', NULL, NULL, NULL, NULL, 'PCu(A)C copper chaperone', NULL, NULL, 33198, 5),
(231980, NULL, 'G3DSA:2.60.40.640', NULL, NULL, NULL, NULL, '', NULL, NULL, 14110, 5),
(231981, NULL, 'G3DSA:2.30.42.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231982, NULL, 'G3DSA:3.30.365.10', NULL, NULL, NULL, NULL, 'Aldehyde oxidase/xanthine dehydrogenase, molybdopterin binding domain', NULL, NULL, NULL, 5),
(231983, NULL, 'G3DSA:3.90.70.10', NULL, NULL, NULL, NULL, 'Cysteine proteinases', NULL, NULL, NULL, 5),
(231984, NULL, 'G3DSA:6.10.250.270', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231985, NULL, 'G3DSA:3.10.290.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231986, NULL, 'G3DSA:3.30.70.1340', NULL, NULL, NULL, NULL, '', NULL, NULL, 8742, 5),
(231987, NULL, 'G3DSA:1.10.10.140', NULL, NULL, NULL, NULL, 'Cytochrome c oxidase, subunit VIb', NULL, NULL, 33102, 5),
(231988, NULL, 'G3DSA:3.40.50.12150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231989, NULL, 'G3DSA:6.10.140.1220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231990, NULL, 'G3DSA:1.20.1440.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231991, NULL, 'G3DSA:3.30.420.600', NULL, NULL, NULL, NULL, 'Thermoplasma acidophilum protein TA0956', NULL, NULL, 29828, 5),
(231992, NULL, 'G3DSA:3.90.640.10', NULL, NULL, NULL, NULL, 'Actin; Chain A, domain 4', NULL, NULL, NULL, 5),
(231993, NULL, 'G3DSA:2.40.128.580', NULL, NULL, NULL, NULL, 'GXWXG domain', NULL, NULL, NULL, 5);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(231994, NULL, 'G3DSA:2.60.40.1680', NULL, NULL, NULL, NULL, '', NULL, NULL, 21907, 5),
(231995, NULL, 'G3DSA:3.90.1280.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231996, NULL, 'G3DSA:2.60.40.3860', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231997, NULL, 'G3DSA:1.25.40.800', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231998, NULL, 'G3DSA:4.10.400.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(231999, NULL, 'G3DSA:1.10.10.900', NULL, NULL, NULL, NULL, '', NULL, NULL, 29878, 5),
(232000, NULL, 'G3DSA:6.10.250.2620', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232001, NULL, 'G3DSA:3.30.70.3290', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232002, NULL, 'G3DSA:3.20.20.120', NULL, NULL, NULL, NULL, '', NULL, NULL, 31643, 5),
(232003, NULL, 'G3DSA:2.60.40.4390', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232004, NULL, 'G3DSA:1.20.1440.90', NULL, NULL, NULL, NULL, 'Phosphoenolpyruvate/pyruvate domain', NULL, NULL, NULL, 5),
(232005, NULL, 'G3DSA:1.10.470.10', NULL, NULL, NULL, NULL, 'Variant Surface Glycoprotein, subunit A, domain 2', NULL, NULL, NULL, 5),
(232006, NULL, 'G3DSA:3.30.70.990', NULL, NULL, NULL, NULL, '', NULL, NULL, 27570, 5),
(232007, NULL, 'G3DSA:3.40.1590.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32376, 5),
(232008, NULL, 'G3DSA:3.10.630.10', NULL, NULL, NULL, NULL, 'dip2346 domain like', NULL, NULL, NULL, 5),
(232009, NULL, 'G3DSA:1.10.30.10', NULL, NULL, NULL, NULL, 'High mobility group box domain', NULL, NULL, 28964, 5),
(232010, NULL, 'G3DSA:1.10.1610.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 19820, 5),
(232011, NULL, 'G3DSA:3.10.129.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232012, NULL, 'G3DSA:2.60.40.4260', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5),
(232013, NULL, 'G3DSA:3.40.1380.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 32907, 5),
(232014, NULL, 'G3DSA:6.10.250.2390', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232015, NULL, 'G3DSA:3.40.50.10400', NULL, NULL, NULL, NULL, 'Hypothetical protein PA1492', NULL, NULL, NULL, 5),
(232016, NULL, 'G3DSA:4.10.430.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232017, NULL, 'G3DSA:1.25.40.290', NULL, NULL, NULL, NULL, 'ARM repeat domains', NULL, NULL, NULL, 5),
(232018, NULL, 'G3DSA:1.20.120.360', NULL, NULL, NULL, NULL, '', NULL, NULL, 27851, 5),
(232019, NULL, 'G3DSA:2.60.120.470', NULL, NULL, NULL, NULL, 'PITH domain', NULL, NULL, 29379, 5),
(232020, NULL, 'G3DSA:4.10.940.10', NULL, NULL, NULL, NULL, 'Quinohemoprotein amine dehydrogenase, gamma subunit structural domain', NULL, NULL, 31145, 5),
(232021, NULL, 'G3DSA:3.40.50.360', NULL, NULL, NULL, NULL, '', NULL, NULL, 24724, 5),
(232022, NULL, 'G3DSA:1.20.120.240', NULL, NULL, NULL, NULL, 'Lipoprotein, type 6', NULL, NULL, 28138, 5),
(232023, NULL, 'G3DSA:2.40.160.220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232024, NULL, 'G3DSA:3.60.110.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33384, 5),
(232025, NULL, 'G3DSA:1.20.58.980', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232026, NULL, 'G3DSA:2.60.120.1360', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232027, NULL, 'G3DSA:4.10.340.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 7724, 5),
(232028, NULL, 'G3DSA:3.20.20.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 31956, 5),
(232029, NULL, 'G3DSA:2.60.40.3570', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232030, NULL, 'G3DSA:3.10.450.730', NULL, NULL, NULL, NULL, 'BLIP domain', NULL, NULL, NULL, 5),
(232031, NULL, 'G3DSA:3.40.1480.10', NULL, NULL, NULL, NULL, 'MOFRL domain', NULL, NULL, 29098, 5),
(232032, NULL, 'G3DSA:1.20.5.4520', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232033, NULL, 'G3DSA:1.10.601.10', NULL, NULL, NULL, NULL, 'RNA Polymerase Primary Sigma Factor', NULL, NULL, NULL, 5),
(232034, NULL, 'G3DSA:1.20.5.830', NULL, NULL, NULL, NULL, 'luxt domain from vibrio parahaemolyticus', NULL, NULL, NULL, 5),
(232035, NULL, 'G3DSA:2.20.210.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232036, NULL, 'G3DSA:4.10.1200.10', NULL, NULL, NULL, NULL, 'nitrate reductase tail', NULL, NULL, 36346, 5);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(232037, NULL, 'G3DSA:1.10.287.280', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232038, NULL, 'G3DSA:1.10.437.20', NULL, NULL, NULL, NULL, 'dsDNA poxvirus', NULL, NULL, 36298, 5),
(232039, NULL, 'G3DSA:1.10.10.2830', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232040, NULL, 'G3DSA:1.20.58.1510', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232041, NULL, 'G3DSA:1.20.960.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232042, NULL, 'G3DSA:1.10.300.10', NULL, NULL, NULL, NULL, 'Adenylosuccinate Synthetase, subunit A, domain 2', NULL, NULL, 35577, 5),
(232043, NULL, 'G3DSA:2.120.10.80', NULL, NULL, NULL, NULL, '', NULL, NULL, 7126, 5),
(232044, NULL, 'G3DSA:3.30.70.3370', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232045, NULL, 'G3DSA:1.20.120.1050', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232046, NULL, 'G3DSA:2.40.10.320', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232047, NULL, 'G3DSA:1.10.225.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232048, NULL, 'G3DSA:1.10.1410.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232049, NULL, 'G3DSA:6.10.210.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232050, NULL, 'G3DSA:2.20.28.100', NULL, NULL, NULL, NULL, '', NULL, NULL, 30471, 5),
(232051, NULL, 'G3DSA:1.10.287.110', NULL, NULL, NULL, NULL, 'DnaJ domain', NULL, NULL, 28329, 5),
(232052, NULL, 'G3DSA:3.10.560.10', NULL, NULL, NULL, NULL, 'Outer membrane lipoprotein wza domain like', NULL, NULL, NULL, 5),
(232053, NULL, 'G3DSA:1.10.10.750', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232054, NULL, 'G3DSA:4.10.410.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232055, NULL, 'G3DSA:3.10.20.720', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232056, NULL, 'G3DSA:3.30.70.3520', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232057, NULL, 'G3DSA:3.10.450.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232058, NULL, 'G3DSA:2.30.110.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232059, NULL, 'G3DSA:1.20.58.400', NULL, NULL, NULL, NULL, '', NULL, NULL, 31441, 5),
(232060, NULL, 'G3DSA:2.60.40.2310', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232061, NULL, 'G3DSA:3.40.1390.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232062, NULL, 'G3DSA:2.60.270.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232063, NULL, 'G3DSA:3.60.70.12', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232064, NULL, 'G3DSA:1.20.1270.370', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232065, NULL, 'G3DSA:6.10.240.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232066, NULL, 'G3DSA:3.30.200.200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232067, NULL, 'G3DSA:2.30.24.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 30538, 5),
(232068, NULL, 'G3DSA:2.40.50.660', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232069, NULL, 'G3DSA:3.30.70.2700', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232070, NULL, 'G3DSA:2.30.30.610', NULL, NULL, NULL, NULL, 'Chromatin protein Cren7', NULL, NULL, 31199, 5),
(232071, NULL, 'G3DSA:6.10.140.260', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232072, NULL, 'G3DSA:2.60.40.3960', NULL, NULL, NULL, NULL, 'Velvet domain', NULL, NULL, 32697, 5),
(232073, NULL, 'G3DSA:3.10.450.460', NULL, NULL, NULL, NULL, '', NULL, NULL, 36929, 5),
(232074, NULL, 'G3DSA:1.10.8.530', NULL, NULL, NULL, NULL, '', NULL, NULL, 35082, 5),
(232075, NULL, 'G3DSA:3.20.20.380', NULL, NULL, NULL, NULL, 'Copper homeostasis (CutC) domain', NULL, NULL, 27912, 5),
(232076, NULL, 'G3DSA:3.90.1020.10', NULL, NULL, NULL, NULL, 'ArcTGT, C1 domain', NULL, NULL, 32960, 5),
(232077, NULL, 'G3DSA:1.20.58.1300', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232078, NULL, 'G3DSA:3.30.420.140', NULL, NULL, NULL, NULL, '', NULL, NULL, 27396, 5),
(232079, NULL, 'G3DSA:3.30.1340.20', NULL, NULL, NULL, NULL, '3H domain', NULL, NULL, 26981, 5),
(232080, NULL, 'G3DSA:3.40.1160.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28286, 5),
(232081, NULL, 'G3DSA:3.90.1750.10', NULL, NULL, NULL, NULL, 'Hect, E3 ligase catalytic domains', NULL, NULL, NULL, 5);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(232082, NULL, 'G3DSA:1.20.5.1450', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232083, NULL, 'G3DSA:1.20.1440.370', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232084, NULL, 'G3DSA:2.10.240.10', NULL, NULL, NULL, NULL, 'Dihydroorotate dehydrogenase, electron transfer subunit', NULL, NULL, 28340, 5),
(232085, NULL, 'G3DSA:3.30.9.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232086, NULL, 'G3DSA:1.10.10.2750', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232087, NULL, 'G3DSA:1.20.120.1780', NULL, NULL, NULL, NULL, 'UbiA prenyltransferase', NULL, NULL, NULL, 5),
(232088, NULL, 'G3DSA:6.10.250.1570', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232089, NULL, 'G3DSA:1.20.1530.10', NULL, NULL, NULL, NULL, 'Na+/H+ antiporter like domain', NULL, NULL, 9868, 5),
(232090, NULL, 'G3DSA:2.170.130.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232091, NULL, 'G3DSA:3.30.390.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232092, NULL, 'G3DSA:3.40.1170.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232093, NULL, 'G3DSA:3.90.190.10', NULL, NULL, NULL, NULL, 'Protein tyrosine phosphatase superfamily', NULL, NULL, 26687, 5),
(232094, NULL, 'G3DSA:2.20.25.540', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232095, NULL, 'G3DSA:2.60.40.60', NULL, NULL, NULL, NULL, 'Cadherins', NULL, NULL, NULL, 5),
(232096, NULL, 'G3DSA:3.30.1390.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232097, NULL, 'G3DSA:1.10.287.1240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232098, NULL, 'G3DSA:1.10.1470.20', NULL, NULL, NULL, NULL, 'Fatty acid synthase; domain 2', NULL, NULL, NULL, 5),
(232099, NULL, 'G3DSA:3.10.450.540', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232100, NULL, 'G3DSA:1.10.1200.50', NULL, NULL, NULL, NULL, '', NULL, NULL, 29672, 5),
(232101, NULL, 'G3DSA:1.20.5.130', NULL, NULL, NULL, NULL, '', NULL, NULL, 15712, 5),
(232102, NULL, 'G3DSA:3.30.240.20', NULL, NULL, NULL, NULL, 'bsu07140 like domains', NULL, NULL, 15760, 5),
(232103, NULL, 'G3DSA:3.30.420.220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232104, NULL, 'G3DSA:3.30.1360.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 1940, 5),
(232105, NULL, 'G3DSA:1.10.10.2590', NULL, NULL, NULL, NULL, 'BEN domain', NULL, NULL, NULL, 5),
(232106, NULL, 'G3DSA:2.40.128.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 28844, 5),
(232107, NULL, 'G3DSA:6.10.250.2200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232108, NULL, 'G3DSA:3.40.800.10', NULL, NULL, NULL, NULL, 'Ureohydrolase domain', NULL, NULL, NULL, 5),
(232109, NULL, 'G3DSA:6.10.20.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232110, NULL, 'G3DSA:3.40.91.80', NULL, NULL, NULL, NULL, '', NULL, NULL, 32709, 5),
(232111, NULL, 'G3DSA:3.40.50.10720', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232112, NULL, 'G3DSA:3.40.50.10800', NULL, NULL, NULL, NULL, '', NULL, NULL, 27425, 5),
(232113, NULL, 'G3DSA:1.10.1020.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 7890, 5),
(232114, NULL, 'G3DSA:6.10.130.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232115, NULL, 'G3DSA:1.20.1370.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232116, NULL, 'G3DSA:2.60.40.2610', NULL, NULL, NULL, NULL, 'Outer membrane usher protein FimD, plug domain', NULL, NULL, 34791, 5),
(232117, NULL, 'G3DSA:1.20.120.570', NULL, NULL, NULL, NULL, '', NULL, NULL, 33134, 5),
(232118, NULL, 'G3DSA:3.40.1130.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232119, NULL, 'G3DSA:3.30.70.1000', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232120, NULL, 'G3DSA:1.10.10.1760', NULL, NULL, NULL, NULL, '60S ribosomal protein L36', NULL, NULL, 29612, 5),
(232121, NULL, 'G3DSA:3.30.160.600', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232122, NULL, 'G3DSA:2.60.120.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 9966, 5),
(232123, NULL, 'G3DSA:2.60.40.1620', NULL, NULL, NULL, NULL, '', NULL, NULL, 28189, 5),
(232124, NULL, 'G3DSA:3.30.160.870', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232125, NULL, 'G3DSA:2.40.290.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 11694, 5);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(232126, NULL, 'G3DSA:2.20.25.230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232127, NULL, 'G3DSA:1.10.1040.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232128, NULL, 'G3DSA:1.20.190.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 27866, 5),
(232129, NULL, 'G3DSA:1.10.1200.180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232130, NULL, 'G3DSA:3.30.720.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232131, NULL, 'G3DSA:3.30.1370.110', NULL, NULL, NULL, NULL, '', NULL, NULL, 29528, 5),
(232132, NULL, 'G3DSA:1.20.950.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232133, NULL, 'G3DSA:1.10.10.1180', NULL, NULL, NULL, NULL, '', NULL, NULL, 30564, 5),
(232134, NULL, 'G3DSA:1.10.10.1780', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232135, NULL, 'G3DSA:4.10.270.10', NULL, NULL, NULL, NULL, 'Myosin, subunit A', NULL, NULL, NULL, 5),
(232136, NULL, 'G3DSA:3.30.70.3080', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232137, NULL, 'G3DSA:1.20.1330.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232138, NULL, 'G3DSA:6.20.370.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232139, NULL, 'G3DSA:2.20.20.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232140, NULL, 'G3DSA:3.30.465.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 11888, 5),
(232141, NULL, 'G3DSA:3.30.1370.50', NULL, NULL, NULL, NULL, '', NULL, NULL, 28192, 5),
(232142, NULL, 'G3DSA:6.10.250.2540', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232143, NULL, 'G3DSA:1.10.620.20', NULL, NULL, NULL, NULL, 'Ribonucleotide Reductase, subunit A', NULL, NULL, 7969, 5),
(232144, NULL, 'G3DSA:4.10.160.10', NULL, NULL, NULL, NULL, 'Methanol dehydrogenase, beta subunit', NULL, NULL, 27545, 5),
(232145, NULL, 'G3DSA:1.20.144.10', NULL, NULL, NULL, NULL, 'Phosphatidic acid phosphatase type 2/haloperoxidase', NULL, NULL, NULL, 5),
(232146, NULL, 'G3DSA:3.30.200.180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232147, NULL, 'G3DSA:3.30.1250.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33136, 5),
(232148, NULL, 'G3DSA:6.10.250.1930', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232149, NULL, 'G3DSA:3.90.280.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28201, 5),
(232150, NULL, 'G3DSA:1.20.58.690', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232151, NULL, 'G3DSA:1.20.58.320', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232152, NULL, 'G3DSA:3.30.9.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232153, NULL, 'G3DSA:3.40.50.12570', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232154, NULL, 'G3DSA:3.40.1510.10', NULL, NULL, NULL, NULL, 'Hut operon regulatory protein HutP', NULL, NULL, 31267, 5),
(232155, NULL, 'G3DSA:2.10.270.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232156, NULL, 'G3DSA:1.20.272.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 31598, 5),
(232157, NULL, 'G3DSA:3.40.50.11960', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232158, NULL, 'G3DSA:2.40.450.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 30656, 5),
(232159, NULL, 'G3DSA:1.20.58.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232160, NULL, 'G3DSA:2.60.40.2230', NULL, NULL, NULL, NULL, '', NULL, NULL, 32371, 5),
(232161, NULL, 'G3DSA:1.10.357.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232162, NULL, 'G3DSA:2.40.50.740', NULL, NULL, NULL, NULL, '', NULL, NULL, 29606, 5),
(232163, NULL, 'G3DSA:1.20.58.1220', NULL, NULL, NULL, NULL, '', NULL, NULL, 35413, 5),
(232164, NULL, 'G3DSA:3.30.1900.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232165, NULL, 'G3DSA:3.30.420.610', NULL, NULL, NULL, NULL, '', NULL, NULL, 30905, 5),
(232166, NULL, 'G3DSA:3.30.1360.140', NULL, NULL, NULL, NULL, '', NULL, NULL, 32160, 5),
(232167, NULL, 'G3DSA:6.10.250.1180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232168, NULL, 'G3DSA:3.10.450.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 8162, 5),
(232169, NULL, 'G3DSA:6.10.10.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232170, NULL, 'G3DSA:2.170.220.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(232171, NULL, 'G3DSA:3.30.2450.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232172, NULL, 'G3DSA:1.20.58.770', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232173, NULL, 'G3DSA:6.10.140.930', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232174, NULL, 'G3DSA:2.10.55.10', NULL, NULL, NULL, NULL, 'Leishmanolysin domain 3', NULL, NULL, NULL, 5),
(232175, NULL, 'G3DSA:2.40.50.60', NULL, NULL, NULL, NULL, 'Antifungal protein domain', NULL, NULL, 21143, 5),
(232176, NULL, 'G3DSA:1.10.1200.260', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232177, NULL, 'G3DSA:3.30.700.10', NULL, NULL, NULL, NULL, 'Glycoprotein, Type 4 Pilin', NULL, NULL, NULL, 5),
(232178, NULL, 'G3DSA:3.30.70.3160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232179, NULL, 'G3DSA:1.10.418.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 36463, 5),
(232180, NULL, 'G3DSA:1.10.150.710', NULL, NULL, NULL, NULL, 'Glutamate cysteine ligase subdomain', NULL, NULL, NULL, 5),
(232181, NULL, 'G3DSA:3.30.70.1210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232182, NULL, 'G3DSA:2.60.40.3780', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232183, NULL, 'G3DSA:3.30.230.40', NULL, NULL, NULL, NULL, 'Imidazole glycerol phosphate dehydratase; domain 1', NULL, NULL, 32349, 5),
(232184, NULL, 'G3DSA:3.20.190.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 37601, 5),
(232185, NULL, 'G3DSA:6.20.120.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 30807, 5),
(232186, NULL, 'G3DSA:6.10.250.190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232187, NULL, 'G3DSA:2.60.40.1830', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232188, NULL, 'G3DSA:3.10.260.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28746, 5),
(232189, NULL, 'G3DSA:3.30.1120.60', NULL, NULL, NULL, NULL, 'Colicin', NULL, NULL, NULL, 5),
(232190, NULL, 'G3DSA:6.10.340.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232191, NULL, 'G3DSA:3.30.70.2760', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232192, NULL, 'G3DSA:1.10.287.1150', NULL, NULL, NULL, NULL, 'TPP helical domain', NULL, NULL, NULL, 5),
(232193, NULL, 'G3DSA:1.10.533.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 31306, 5),
(232194, NULL, 'G3DSA:1.25.40.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232195, NULL, 'G3DSA:1.10.10.1650', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232196, NULL, 'G3DSA:6.10.140.620', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232197, NULL, 'G3DSA:1.20.1580.10', NULL, NULL, NULL, NULL, 'ABC transporter ATPase  like domain', NULL, NULL, NULL, 5),
(232198, NULL, 'G3DSA:3.30.390.180', NULL, NULL, NULL, NULL, 'RNA silencing suppressor P19', NULL, NULL, 33152, 5),
(232199, NULL, 'G3DSA:3.40.1260.20', NULL, NULL, NULL, NULL, 'Ribonuclease E, catalytic domain', NULL, NULL, NULL, 5),
(232200, NULL, 'G3DSA:3.30.300.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232201, NULL, 'G3DSA:3.30.1300.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232202, NULL, 'G3DSA:3.30.1330.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232203, NULL, 'G3DSA:3.30.1310.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232204, NULL, 'G3DSA:3.10.20.280', NULL, NULL, NULL, NULL, '', NULL, NULL, 28498, 5),
(232205, NULL, 'G3DSA:1.10.10.1390', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232206, NULL, 'G3DSA:2.170.9.10', NULL, NULL, NULL, NULL, 'Adenovirus Type 2 Hexon, domain 1', NULL, NULL, NULL, 5),
(232207, NULL, 'G3DSA:3.30.1490.120', NULL, NULL, NULL, NULL, '', NULL, NULL, 28760, 5),
(232208, NULL, 'G3DSA:1.10.3570.10', NULL, NULL, NULL, NULL, 'Rhabdovirus nucleocapsid protein like domain', NULL, NULL, 15791, 5),
(232209, NULL, 'G3DSA:3.30.70.2100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232210, NULL, 'G3DSA:2.10.10.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232211, NULL, 'G3DSA:2.60.40.3650', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232212, NULL, 'G3DSA:2.60.40.4180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232213, NULL, 'G3DSA:3.30.110.60', NULL, NULL, NULL, NULL, '', NULL, NULL, 24549, 5);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(232214, NULL, 'G3DSA:3.30.160.660', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232215, NULL, 'G3DSA:3.30.1490.250', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232216, NULL, 'G3DSA:1.20.89.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232217, NULL, 'G3DSA:3.30.2160.10', NULL, NULL, NULL, NULL, 'Hect, E3 ligase catalytic domain', NULL, NULL, NULL, 5),
(232218, NULL, 'G3DSA:2.60.40.4050', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232219, NULL, 'G3DSA:2.20.20.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 34756, 5),
(232220, NULL, 'G3DSA:2.60.390.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 27517, 5),
(232221, NULL, 'G3DSA:2.10.210.10', NULL, NULL, NULL, NULL, 'Cytochrome Bc1 Complex; Chain I', NULL, NULL, NULL, 5),
(232222, NULL, 'G3DSA:3.90.510.10', NULL, NULL, NULL, NULL, 'Phycoerythrin alpha chain', NULL, NULL, 28195, 5),
(232223, NULL, 'G3DSA:3.30.2400.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232224, NULL, 'G3DSA:6.10.30.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232225, NULL, 'G3DSA:4.10.1060.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232226, NULL, 'G3DSA:1.20.1480.40', NULL, NULL, NULL, NULL, 'Uncharacterised protein PF16133, DUF4844', NULL, NULL, 33220, 5),
(232227, NULL, 'G3DSA:1.20.120.50', NULL, NULL, NULL, NULL, '', NULL, NULL, 14089, 5),
(232228, NULL, 'G3DSA:6.10.140.1300', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232229, NULL, 'G3DSA:3.10.130.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 27543, 5),
(232230, NULL, 'G3DSA:1.10.8.740', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232231, NULL, 'G3DSA:6.10.250.2410', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232232, NULL, 'G3DSA:3.30.70.120', NULL, NULL, NULL, NULL, '', NULL, NULL, 13528, 5),
(232233, NULL, 'G3DSA:6.10.280.210', NULL, NULL, NULL, NULL, 'Dsl1p vesicle tethering complex, Tip20p subunit, domain A', NULL, NULL, 30007, 5),
(232234, NULL, 'G3DSA:4.10.1260.10', NULL, NULL, NULL, NULL, 'Scaffolding protein gpD of bacteriophage procapsid', NULL, NULL, 32595, 5),
(232235, NULL, 'G3DSA:2.30.30.1210', NULL, NULL, NULL, NULL, 'Domain of unknown function DUF1541', NULL, NULL, NULL, 5),
(232236, NULL, 'G3DSA:2.40.128.600', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232237, NULL, 'G3DSA:1.10.1900.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232238, NULL, 'G3DSA:3.40.50.1360', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232239, NULL, 'G3DSA:6.10.250.1360', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232240, NULL, 'G3DSA:6.10.140.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232241, NULL, 'G3DSA:3.40.50.11390', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232242, NULL, 'G3DSA:3.30.310.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232243, NULL, 'G3DSA:1.20.5.190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232244, NULL, 'G3DSA:1.25.40.380', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF1810', NULL, NULL, 31561, 5),
(232245, NULL, 'G3DSA:3.90.1820.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232246, NULL, 'G3DSA:3.30.170.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28174, 5),
(232247, NULL, 'G3DSA:3.30.450.380', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232248, NULL, 'G3DSA:2.60.40.1700', NULL, NULL, NULL, NULL, '', NULL, NULL, 33342, 5),
(232249, NULL, 'G3DSA:3.30.1380.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 8571, 5),
(232250, NULL, 'G3DSA:1.10.1710.10', NULL, NULL, NULL, NULL, 'ProQ/FinO domain', NULL, NULL, 31870, 5),
(232251, NULL, 'G3DSA:2.40.50.1040', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232252, NULL, 'G3DSA:6.10.250.1050', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232253, NULL, 'G3DSA:2.60.40.3340', NULL, NULL, NULL, NULL, 'Domain of unknown function DUF4426', NULL, NULL, NULL, 5),
(232254, NULL, 'G3DSA:3.30.20.10', NULL, NULL, NULL, NULL, 'Endochitinase, domain 2', NULL, NULL, NULL, 5),
(232255, NULL, 'G3DSA:1.20.120.1550', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF5063', NULL, NULL, 28798, 5);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(232256, NULL, 'G3DSA:3.30.1510.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232257, NULL, 'G3DSA:3.30.450.20', NULL, NULL, NULL, NULL, 'PAS domain', NULL, NULL, NULL, 5),
(232258, NULL, 'G3DSA:6.10.20.40', NULL, NULL, NULL, NULL, 'TEA/ATTS domain', NULL, NULL, 29794, 5),
(232259, NULL, 'G3DSA:6.20.110.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232260, NULL, 'G3DSA:3.90.380.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232261, NULL, 'G3DSA:3.30.70.390', NULL, NULL, NULL, NULL, '', NULL, NULL, 28061, 5),
(232262, NULL, 'G3DSA:1.20.1440.180', NULL, NULL, NULL, NULL, 'KEN domain', NULL, NULL, 33118, 5),
(232263, NULL, 'G3DSA:1.20.120.1800', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232264, NULL, 'G3DSA:3.30.565.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28922, 5),
(232265, NULL, 'G3DSA:3.30.420.530', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232266, NULL, 'G3DSA:3.40.109.10', NULL, NULL, NULL, NULL, 'NADH Oxidase', NULL, NULL, 6830, 5),
(232267, NULL, 'G3DSA:3.30.1530.10', NULL, NULL, NULL, NULL, 'manganese catalase, domain 2, chain A', NULL, NULL, 21588, 5),
(232268, NULL, 'G3DSA:3.30.310.80', NULL, NULL, NULL, NULL, 'Kinase associated domain 1, KA1', NULL, NULL, NULL, 5),
(232269, NULL, 'G3DSA:3.30.1350.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28087, 5),
(232270, NULL, 'G3DSA:2.60.120.1570', NULL, NULL, NULL, NULL, '', NULL, NULL, 35326, 5),
(232271, NULL, 'G3DSA:2.40.240.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232272, NULL, 'G3DSA:2.60.40.2100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232273, NULL, 'G3DSA:1.10.287.820', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232274, NULL, 'G3DSA:3.30.1050.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232275, NULL, 'G3DSA:3.30.110.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232276, NULL, 'G3DSA:6.10.250.2020', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232277, NULL, 'G3DSA:3.30.1040.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232278, NULL, 'G3DSA:3.30.230.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 24612, 5),
(232279, NULL, 'G3DSA:6.20.200.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232280, NULL, 'G3DSA:3.40.50.10360', NULL, NULL, NULL, NULL, 'Hypothetical protein TT1679', NULL, NULL, 26942, 5),
(232281, NULL, 'G3DSA:3.40.470.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28851, 5),
(232282, NULL, 'G3DSA:3.30.1330.160', NULL, NULL, NULL, NULL, 'Cyanuric acid hydrolase/Barbituras, RU C', NULL, NULL, 36042, 5),
(232283, NULL, 'G3DSA:2.60.40.2680', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232284, NULL, 'G3DSA:2.60.40.1080', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232285, NULL, 'G3DSA:3.90.1320.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232286, NULL, 'G3DSA:2.30.29.210', NULL, NULL, NULL, NULL, 'FACT complex subunit Spt16p/Cdc68p', NULL, NULL, NULL, 5),
(232287, NULL, 'G3DSA:2.60.40.3260', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232288, NULL, 'G3DSA:2.40.128.480', NULL, NULL, NULL, NULL, '', NULL, NULL, 31287, 5),
(232289, NULL, 'G3DSA:3.30.2430.10', NULL, NULL, NULL, NULL, 'phosphothreonine lyase', NULL, NULL, 31646, 5),
(232290, NULL, 'G3DSA:3.30.2360.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232291, NULL, 'G3DSA:1.10.10.1010', NULL, NULL, NULL, NULL, 'Intein homing endonuclease, domain IV', NULL, NULL, NULL, 5),
(232292, NULL, 'G3DSA:3.40.190.190', NULL, NULL, NULL, NULL, 'CypI, domain 2', NULL, NULL, 34707, 5),
(232293, NULL, 'G3DSA:1.20.5.600', NULL, NULL, NULL, NULL, 'Potassium channel, voltage dependent, Kv1.4, tandem inactivation domain', NULL, NULL, 29567, 5),
(232294, NULL, 'G3DSA:3.40.50.11180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232295, NULL, 'G3DSA:1.20.58.1070', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232296, NULL, 'G3DSA:2.60.320.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232297, NULL, 'G3DSA:1.10.890.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232298, NULL, 'G3DSA:2.30.29.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(232299, NULL, 'G3DSA:3.10.20.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232300, NULL, 'G3DSA:3.30.70.1880', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF881', NULL, NULL, NULL, 5),
(232301, NULL, 'G3DSA:6.10.140.1820', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232302, NULL, 'G3DSA:2.60.120.1050', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232303, NULL, 'G3DSA:3.90.580.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 30260, 5),
(232304, NULL, 'G3DSA:1.20.120.1390', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232305, NULL, 'G3DSA:3.90.1310.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232306, NULL, 'G3DSA:1.10.150.660', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232307, NULL, 'G3DSA:3.40.630.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232308, NULL, 'G3DSA:3.30.70.2370', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232309, NULL, 'G3DSA:2.60.40.3230', NULL, NULL, NULL, NULL, '', NULL, NULL, 30320, 5),
(232310, NULL, 'G3DSA:2.30.29.150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232311, NULL, 'G3DSA:2.30.29.180', NULL, NULL, NULL, NULL, '', NULL, NULL, 30129, 5),
(232312, NULL, 'G3DSA:1.10.246.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232313, NULL, 'G3DSA:3.40.630.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 37103, 5),
(232314, NULL, 'G3DSA:2.30.30.480', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232315, NULL, 'G3DSA:3.30.70.1730', NULL, NULL, NULL, NULL, '', NULL, NULL, 34828, 5),
(232316, NULL, 'G3DSA:1.20.120.1360', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232317, NULL, 'G3DSA:1.10.1270.20', NULL, NULL, NULL, NULL, 'tRNA(m1g37)methyltransferase, domain 2', NULL, NULL, 7857, 5),
(232318, NULL, 'G3DSA:1.20.1270.150', NULL, NULL, NULL, NULL, 'Surface Active Protein', NULL, NULL, 32884, 5),
(232319, NULL, 'G3DSA:1.20.5.1150', NULL, NULL, NULL, NULL, 'Ribosomal protein S8', NULL, NULL, 29635, 5),
(232320, NULL, 'G3DSA:3.10.450.430', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF2787', NULL, NULL, NULL, 5),
(232321, NULL, 'G3DSA:6.10.140.1850', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232322, NULL, 'G3DSA:1.10.10.1410', NULL, NULL, NULL, NULL, '', NULL, NULL, 30638, 5),
(232323, NULL, 'G3DSA:3.30.420.400', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232324, NULL, 'G3DSA:2.40.128.420', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232325, NULL, 'G3DSA:6.10.250.580', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232326, NULL, 'G3DSA:2.30.30.530', NULL, NULL, NULL, NULL, '', NULL, NULL, 34339, 5),
(232327, NULL, 'G3DSA:1.10.150.510', NULL, NULL, NULL, NULL, 'Receptor activity modifying family', NULL, NULL, 31521, 5),
(232328, NULL, 'G3DSA:2.60.40.1790', NULL, NULL, NULL, NULL, 'Fungal immunomodulatory protein Fve', NULL, NULL, NULL, 5),
(232329, NULL, 'G3DSA:3.40.50.10540', NULL, NULL, NULL, NULL, '', NULL, NULL, 16621, 5),
(232330, NULL, 'G3DSA:1.20.120.1410', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232331, NULL, 'G3DSA:3.30.450.140', NULL, NULL, NULL, NULL, '', NULL, NULL, 31285, 5),
(232332, NULL, 'G3DSA:3.30.70.1180', NULL, NULL, NULL, NULL, 'Vacuolar atp synthase subunit c; domain 1', NULL, NULL, NULL, 5),
(232333, NULL, 'G3DSA:6.10.310.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232334, NULL, 'G3DSA:2.30.30.370', NULL, NULL, NULL, NULL, 'FAH', NULL, NULL, NULL, 5),
(232335, NULL, 'G3DSA:4.10.280.20', NULL, NULL, NULL, NULL, 'membrane protein stannin', NULL, NULL, 24153, 5),
(232336, NULL, 'G3DSA:3.30.40.30', NULL, NULL, NULL, NULL, 'YqaI domain', NULL, NULL, 14561, 5),
(232337, NULL, 'G3DSA:3.40.50.11740', NULL, NULL, NULL, NULL, 'HypD, alpha/beta domain 2', NULL, NULL, 33884, 5),
(232338, NULL, 'G3DSA:1.50.10.130', NULL, NULL, NULL, NULL, '', NULL, NULL, 28263, 5),
(232339, NULL, 'G3DSA:2.40.230.10', NULL, NULL, NULL, NULL, 'Phospholipase A1', NULL, NULL, 33097, 5),
(232340, NULL, 'G3DSA:1.10.287.850', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232341, NULL, 'G3DSA:1.10.20.10', NULL, NULL, NULL, NULL, 'Histone, subunit A', NULL, NULL, 6064, 5);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(232342, NULL, 'G3DSA:1.10.10.2230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232343, NULL, 'G3DSA:1.25.40.680', NULL, NULL, NULL, NULL, '', NULL, NULL, 34170, 5),
(232344, NULL, 'G3DSA:1.10.10.670', NULL, NULL, NULL, NULL, 'photosystem ii from thermosynechococcus elongatus', NULL, NULL, 36022, 5),
(232345, NULL, 'G3DSA:6.10.250.630', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232346, NULL, 'G3DSA:3.30.240.40', NULL, NULL, NULL, NULL, 'E6 early regulatory protein', NULL, NULL, 32353, 5),
(232347, NULL, 'G3DSA:4.10.80.370', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232348, NULL, 'G3DSA:3.30.30.180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232349, NULL, 'G3DSA:3.30.342.10', NULL, NULL, NULL, NULL, 'DNA Polymerase, chain B, domain 1', NULL, NULL, NULL, 5),
(232350, NULL, 'G3DSA:6.20.210.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31607, 5),
(232351, NULL, 'G3DSA:6.10.140.1070', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232352, NULL, 'G3DSA:3.30.2050.10', NULL, NULL, NULL, NULL, 'photosynthetic oxygen evolving center domain', NULL, NULL, NULL, 5),
(232353, NULL, 'G3DSA:3.40.50.11900', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232354, NULL, 'G3DSA:1.20.120.260', NULL, NULL, NULL, NULL, 'Virulence factor YopE uncharacterised domain', NULL, NULL, 29642, 5),
(232355, NULL, 'G3DSA:1.10.8.710', NULL, NULL, NULL, NULL, '', NULL, NULL, 37026, 5),
(232356, NULL, 'G3DSA:6.10.250.1390', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232357, NULL, 'G3DSA:1.20.1510.10', NULL, NULL, NULL, NULL, 'Cation efflux protein transmembrane domain', NULL, NULL, 24858, 5),
(232358, NULL, 'G3DSA:6.10.250.2960', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232359, NULL, 'G3DSA:3.40.1420.10', NULL, NULL, NULL, NULL, 'Inhibitor of vertebrate lysozyme', NULL, NULL, 31185, 5),
(232360, NULL, 'G3DSA:3.40.30.150', NULL, NULL, NULL, NULL, 'Coronavirus polyprotein cleavage domain', NULL, NULL, 29644, 5),
(232361, NULL, 'G3DSA:3.30.160.810', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232362, NULL, 'G3DSA:3.10.460.20', NULL, NULL, NULL, NULL, 'Rhabdovirus matrix protein M2', NULL, NULL, 29714, 5),
(232363, NULL, 'G3DSA:6.10.330.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 32589, 5),
(232364, NULL, 'G3DSA:3.30.1980.10', NULL, NULL, NULL, NULL, 'Hypothetical protein YunC', NULL, NULL, 31312, 5),
(232365, NULL, 'G3DSA:2.40.50.220', NULL, NULL, NULL, NULL, 'EutN/Ccml', NULL, NULL, 28998, 5),
(232366, NULL, 'G3DSA:1.20.58.530', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232367, NULL, 'G3DSA:2.30.30.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28098, 5),
(232368, NULL, 'G3DSA:2.60.40.4150', NULL, NULL, NULL, NULL, 'Type VI secretion system, lipoprotein SciN', NULL, NULL, 30510, 5),
(232369, NULL, 'G3DSA:1.10.8.1160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232370, NULL, 'G3DSA:1.10.3450.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 30516, 5),
(232371, NULL, 'G3DSA:3.40.1620.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232372, NULL, 'G3DSA:2.30.140.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 27427, 5),
(232373, NULL, 'G3DSA:3.30.70.330', NULL, NULL, NULL, NULL, '', NULL, NULL, 12096, 5),
(232374, NULL, 'G3DSA:1.10.472.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 31299, 5),
(232375, NULL, 'G3DSA:3.90.1150.220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232376, NULL, 'G3DSA:6.20.50.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232377, NULL, 'G3DSA:3.30.450.170', NULL, NULL, NULL, NULL, '', NULL, NULL, 31069, 5),
(232378, NULL, 'G3DSA:2.10.280.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232379, NULL, 'G3DSA:1.20.5.360', NULL, NULL, NULL, NULL, 'SFTPD helical domain', NULL, NULL, NULL, 5),
(232380, NULL, 'G3DSA:2.60.260.50', NULL, NULL, NULL, NULL, 'Flavivirus polyprotein propeptide domain', NULL, NULL, 33763, 5),
(232381, NULL, 'G3DSA:1.10.357.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 37607, 5),
(232382, NULL, 'G3DSA:1.50.10.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232383, NULL, 'G3DSA:2.40.30.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(232384, NULL, 'G3DSA:1.10.10.2020', NULL, NULL, NULL, NULL, '', NULL, NULL, 30060, 5),
(232385, NULL, 'G3DSA:2.40.220.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 20350, 5),
(232386, NULL, 'G3DSA:2.30.29.70', NULL, NULL, NULL, NULL, 'Proteasomal ubiquitin receptor Rpn13/ADRM1', NULL, NULL, 27319, 5),
(232387, NULL, 'G3DSA:3.50.30.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232388, NULL, 'G3DSA:3.30.300.190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232389, NULL, 'G3DSA:6.10.140.800', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232390, NULL, 'G3DSA:1.10.10.1620', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232391, NULL, 'G3DSA:3.40.600.10', NULL, NULL, NULL, NULL, 'DNA mismatch repair MutH/Restriction endonuclease, type II', NULL, NULL, 29603, 5),
(232392, NULL, 'G3DSA:1.10.8.1310', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232393, NULL, 'G3DSA:3.40.50.10220', NULL, NULL, NULL, NULL, 'DNA polymerase III, psi subunit', NULL, NULL, 28743, 5),
(232394, NULL, 'G3DSA:3.10.450.160', NULL, NULL, NULL, NULL, 'inner membrane protein cigr', NULL, NULL, NULL, 5),
(232395, NULL, 'G3DSA:3.40.1060.10', NULL, NULL, NULL, NULL, 'Aconitase, Domain 2', NULL, NULL, 8278, 5),
(232396, NULL, 'G3DSA:3.40.1260.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 24633, 5),
(232397, NULL, 'G3DSA:3.30.420.590', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232398, NULL, 'G3DSA:6.20.50.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232399, NULL, 'G3DSA:1.10.274.30', NULL, NULL, NULL, NULL, 'MRG domain', NULL, NULL, 27483, 5),
(232400, NULL, 'G3DSA:6.10.140.570', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232401, NULL, 'G3DSA:1.10.20.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232402, NULL, 'G3DSA:2.40.240.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232403, NULL, 'G3DSA:3.90.245.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28305, 5),
(232404, NULL, 'G3DSA:1.10.287.1660', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232405, NULL, 'G3DSA:6.20.210.20', NULL, NULL, NULL, NULL, 'THAP domain', NULL, NULL, 31331, 5),
(232406, NULL, 'G3DSA:2.40.240.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232407, NULL, 'G3DSA:1.10.274.100', NULL, NULL, NULL, NULL, 'RNA polymerase Rpb1, domain 3', NULL, NULL, 30788, 5),
(232408, NULL, 'G3DSA:2.60.34.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 27013, 5),
(232409, NULL, 'G3DSA:2.40.10.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232410, NULL, 'G3DSA:1.20.1280.240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232411, NULL, 'G3DSA:2.60.60.30', NULL, NULL, NULL, NULL, 'sav2460 like domains', NULL, NULL, NULL, 5),
(232412, NULL, 'G3DSA:1.10.8.1130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232413, NULL, 'G3DSA:1.10.390.10', NULL, NULL, NULL, NULL, 'Neutral Protease Domain 2', NULL, NULL, 24606, 5),
(232414, NULL, 'G3DSA:1.10.8.110', NULL, NULL, NULL, NULL, 'Photosystem I PsaF, reaction centre subunit III', NULL, NULL, 31124, 5),
(232415, NULL, 'G3DSA:1.10.10.1440', NULL, NULL, NULL, NULL, '', NULL, NULL, 29565, 5),
(232416, NULL, 'G3DSA:1.25.20.10', NULL, NULL, NULL, NULL, 'Bacterial muramidases', NULL, NULL, NULL, 5),
(232417, NULL, 'G3DSA:1.10.150.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232418, NULL, 'G3DSA:1.20.120.1200', NULL, NULL, NULL, NULL, '', NULL, NULL, 34921, 5),
(232419, NULL, 'G3DSA:3.10.310.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232420, NULL, 'G3DSA:1.10.220.10', NULL, NULL, NULL, NULL, 'Annexin', NULL, NULL, 28029, 5),
(232421, NULL, 'G3DSA:1.20.1230.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 37530, 5),
(232422, NULL, 'G3DSA:6.10.250.2780', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232423, NULL, 'G3DSA:1.20.1440.190', NULL, NULL, NULL, NULL, 'Tenuivirus movement protein', NULL, NULL, 35473, 5),
(232424, NULL, 'G3DSA:3.30.1580.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 30606, 5),
(232425, NULL, 'G3DSA:3.10.20.150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232426, NULL, 'G3DSA:1.10.3740.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 24252, 5);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(232427, NULL, 'G3DSA:2.60.40.2620', NULL, NULL, NULL, NULL, '', NULL, NULL, 34917, 5),
(232428, NULL, 'G3DSA:1.20.58.560', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232429, NULL, 'G3DSA:2.10.70.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232430, NULL, 'G3DSA:1.20.91.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 10575, 5),
(232431, NULL, 'G3DSA:3.30.559.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 36325, 5),
(232432, NULL, 'G3DSA:2.40.128.240', NULL, NULL, NULL, NULL, '', NULL, NULL, 30136, 5),
(232433, NULL, 'G3DSA:1.10.3210.10', NULL, NULL, NULL, NULL, 'Hypothetical protein af1432', NULL, NULL, NULL, 5),
(232434, NULL, 'G3DSA:3.30.70.1070', NULL, NULL, NULL, NULL, 'Sporulation related repeat', NULL, NULL, 29506, 5),
(232435, NULL, 'G3DSA:3.30.420.190', NULL, NULL, NULL, NULL, 'conserved archaeal protein q6m145', NULL, NULL, NULL, 5),
(232436, NULL, 'G3DSA:1.20.1440.340', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232437, NULL, 'G3DSA:2.30.30.710', NULL, NULL, NULL, NULL, '', NULL, NULL, 35276, 5),
(232438, NULL, 'G3DSA:1.20.140.150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232439, NULL, 'G3DSA:2.60.40.3020', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232440, NULL, 'G3DSA:6.10.250.1410', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232441, NULL, 'G3DSA:2.30.150.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33806, 5),
(232442, NULL, 'G3DSA:3.40.830.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232443, NULL, 'G3DSA:2.20.200.10', NULL, NULL, NULL, NULL, 'Outer membrane efflux proteins (OEP)', NULL, NULL, NULL, 5),
(232444, NULL, 'G3DSA:6.10.80.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232445, NULL, 'G3DSA:1.20.58.710', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232446, NULL, 'G3DSA:2.20.70.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232447, NULL, 'G3DSA:2.40.30.40', NULL, NULL, NULL, NULL, 'Peptidase M42, domain 2', NULL, NULL, 15525, 5),
(232448, NULL, 'G3DSA:2.60.310.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232449, NULL, 'G3DSA:1.20.120.1430', NULL, NULL, NULL, NULL, 'HP0721 helical bundle', NULL, NULL, 28594, 5),
(232450, NULL, 'G3DSA:3.10.20.880', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232451, NULL, 'G3DSA:3.30.300.160', NULL, NULL, NULL, NULL, '', NULL, NULL, 32416, 5),
(232452, NULL, 'G3DSA:3.90.1010.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232453, NULL, 'G3DSA:3.30.160.840', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232454, NULL, 'G3DSA:2.60.490.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 25183, 5),
(232455, NULL, 'G3DSA:3.30.70.3100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232456, NULL, 'G3DSA:6.10.250.2930', NULL, NULL, NULL, NULL, '', NULL, NULL, 34415, 5),
(232457, NULL, 'G3DSA:6.20.40.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 36215, 5),
(232458, NULL, 'G3DSA:1.25.40.650', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232459, NULL, 'G3DSA:1.20.5.1240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232460, NULL, 'G3DSA:2.40.50.500', NULL, NULL, NULL, NULL, '', NULL, NULL, 29515, 5),
(232461, NULL, 'G3DSA:6.20.130.20', NULL, NULL, NULL, NULL, 'Mitochondrial ribosomal protein L55', NULL, NULL, 36264, 5),
(232462, NULL, 'G3DSA:2.10.69.10', NULL, NULL, NULL, NULL, 'Cysteine Protease (Bromelain) Inhibitor, subunit H', NULL, NULL, 16307, 5),
(232463, NULL, 'G3DSA:1.10.3440.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 10127, 5),
(232464, NULL, 'G3DSA:3.10.360.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232465, NULL, 'G3DSA:6.10.250.3330', NULL, NULL, NULL, NULL, '', NULL, NULL, 34108, 5),
(232466, NULL, 'G3DSA:3.30.1370.10', NULL, NULL, NULL, NULL, 'K Homology domain, type 1', NULL, NULL, 30414, 5),
(232467, NULL, 'G3DSA:2.60.120.1200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232468, NULL, 'G3DSA:2.60.40.3410', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232469, NULL, 'G3DSA:4.10.760.10', NULL, NULL, NULL, NULL, 'Agouti domain', NULL, NULL, 27807, 5),
(232470, NULL, 'G3DSA:6.20.380.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(232471, NULL, 'G3DSA:6.20.390.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232472, NULL, 'G3DSA:3.30.70.2160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232473, NULL, 'G3DSA:3.20.70.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232474, NULL, 'G3DSA:4.10.320.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232475, NULL, 'G3DSA:2.40.128.630', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232476, NULL, 'G3DSA:3.30.1370.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 11762, 5),
(232477, NULL, 'G3DSA:3.30.720.20', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF1797', NULL, NULL, 30969, 5),
(232478, NULL, 'G3DSA:3.30.750.220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232479, NULL, 'G3DSA:3.30.470.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232480, NULL, 'G3DSA:6.10.140.1640', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232481, NULL, 'G3DSA:3.10.360.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232482, NULL, 'G3DSA:1.10.1040.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 28382, 5),
(232483, NULL, 'G3DSA:6.10.250.790', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232484, NULL, 'G3DSA:3.30.70.1940', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232485, NULL, 'G3DSA:2.40.10.380', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232486, NULL, 'G3DSA:1.20.58.350', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232487, NULL, 'G3DSA:3.40.1000.10', NULL, NULL, NULL, NULL, 'Mog1/PsbP, alpha/beta/alpha sandwich', NULL, NULL, NULL, 5),
(232488, NULL, 'G3DSA:6.10.110.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33621, 5),
(232489, NULL, 'G3DSA:3.30.200.60', NULL, NULL, NULL, NULL, 'Peptidase C65 Otubain, subdomain 1', NULL, NULL, 35879, 5),
(232490, NULL, 'G3DSA:3.90.660.20', NULL, NULL, NULL, NULL, 'Protoporphyrinogen oxidase, mitochondrial; domain 2', NULL, NULL, NULL, 5),
(232491, NULL, 'G3DSA:3.90.780.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33599, 5),
(232492, NULL, 'G3DSA:1.10.4000.10', NULL, NULL, NULL, NULL, 'Flagellar transcriptional activator FlhD', NULL, NULL, 29075, 5),
(232493, NULL, 'G3DSA:4.10.40.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232494, NULL, 'G3DSA:3.90.1530.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232495, NULL, 'G3DSA:1.10.10.2390', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232496, NULL, 'G3DSA:3.30.70.2520', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232497, NULL, 'G3DSA:4.10.375.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232498, NULL, 'G3DSA:3.30.540.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232499, NULL, 'G3DSA:3.40.190.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232500, NULL, 'G3DSA:2.70.50.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232501, NULL, 'G3DSA:3.90.1800.10', NULL, NULL, NULL, NULL, 'RNA polymerase alpha subunit dimerisation domain', NULL, NULL, NULL, 5),
(232502, NULL, 'G3DSA:3.90.1520.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32867, 5),
(232503, NULL, 'G3DSA:1.10.10.2580', NULL, NULL, NULL, NULL, 'Penicillin Acylase III; Chain A, Domain 2', NULL, NULL, NULL, 5),
(232504, NULL, 'G3DSA:2.40.50.870', NULL, NULL, NULL, NULL, 'Protein of unknown function (DUF3299)', NULL, NULL, NULL, 5),
(232505, NULL, 'G3DSA:6.10.140.410', NULL, NULL, NULL, NULL, '', NULL, NULL, 29870, 5),
(232506, NULL, 'G3DSA:1.10.150.480', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232507, NULL, 'G3DSA:6.10.140.990', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232508, NULL, 'G3DSA:3.30.1490.490', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232509, NULL, 'G3DSA:1.20.970.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 32944, 5),
(232510, NULL, 'G3DSA:3.55.50.60', NULL, NULL, NULL, NULL, 'DotD protein', NULL, NULL, 30609, 5),
(232511, NULL, 'G3DSA:3.40.50.10750', NULL, NULL, NULL, NULL, '', NULL, NULL, 35850, 5),
(232512, NULL, 'G3DSA:1.10.10.1230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232513, NULL, 'G3DSA:3.40.50.10760', NULL, NULL, NULL, NULL, 'Reovirus core', NULL, NULL, NULL, 5);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(232514, NULL, 'G3DSA:6.10.250.810', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232515, NULL, 'G3DSA:2.60.40.3440', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232516, NULL, 'G3DSA:2.60.40.2830', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232517, NULL, 'G3DSA:3.90.1490.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232518, NULL, 'G3DSA:2.60.510.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232519, NULL, 'G3DSA:4.10.180.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232520, NULL, 'G3DSA:2.30.30.320', NULL, NULL, NULL, NULL, '', NULL, NULL, 28159, 5),
(232521, NULL, 'G3DSA:3.20.130.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28882, 5),
(232522, NULL, 'G3DSA:2.60.40.1290', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232523, NULL, 'G3DSA:6.10.250.210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232524, NULL, 'G3DSA:1.20.1250.50', NULL, NULL, NULL, NULL, '', NULL, NULL, 28807, 5),
(232525, NULL, 'G3DSA:3.30.1330.140', NULL, NULL, NULL, NULL, '', NULL, NULL, 36291, 5),
(232526, NULL, 'G3DSA:6.10.250.3360', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232527, NULL, 'G3DSA:3.40.930.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 11766, 5),
(232528, NULL, 'G3DSA:1.10.287.470', NULL, NULL, NULL, NULL, 'Helix hairpin bin', NULL, NULL, NULL, 5),
(232529, NULL, 'G3DSA:1.10.3470.10', NULL, NULL, NULL, NULL, 'ABC transporter involved in vitamin B12 uptake, BtuC', NULL, NULL, 29894, 5),
(232530, NULL, 'G3DSA:2.60.120.1230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232531, NULL, 'G3DSA:3.90.1030.20', NULL, NULL, NULL, NULL, 'DNA polymerase delta, p66 (Cdc27) subunit, wHTH domain', NULL, NULL, 30309, 5),
(232532, NULL, 'G3DSA:2.40.128.270', NULL, NULL, NULL, NULL, '', NULL, NULL, 33509, 5),
(232533, NULL, 'G3DSA:4.10.80.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232534, NULL, 'G3DSA:3.30.60.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232535, NULL, 'G3DSA:3.40.366.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 5066, 5),
(232536, NULL, 'G3DSA:2.40.50.1070', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232537, NULL, 'G3DSA:1.20.120.1180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232538, NULL, 'G3DSA:6.10.140.1280', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232539, NULL, 'G3DSA:1.10.195.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 9755, 5),
(232540, NULL, 'G3DSA:1.20.1440.310', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232541, NULL, 'G3DSA:2.60.40.3050', NULL, NULL, NULL, NULL, '', NULL, NULL, 29838, 5),
(232542, NULL, 'G3DSA:1.20.58.1280', NULL, NULL, NULL, NULL, '', NULL, NULL, 29513, 5),
(232543, NULL, 'G3DSA:2.60.40.2440', NULL, NULL, NULL, NULL, '', NULL, NULL, 29787, 5),
(232544, NULL, 'G3DSA:3.90.182.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232545, NULL, 'G3DSA:1.20.5.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232546, NULL, 'G3DSA:1.20.58.740', NULL, NULL, NULL, NULL, '', NULL, NULL, 34814, 5),
(232547, NULL, 'G3DSA:3.40.1170.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232548, NULL, 'G3DSA:6.10.250.2750', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232549, NULL, 'G3DSA:2.60.120.570', NULL, NULL, NULL, NULL, 'Particulate methane monooxygenase, b subunit. Chain: A, domain 1', NULL, NULL, 7081, 5),
(232550, NULL, 'G3DSA:1.10.560.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 24734, 5),
(232551, NULL, 'G3DSA:1.10.820.10', NULL, NULL, NULL, NULL, 'RNA Helicase Chain A , domain 3', NULL, NULL, NULL, 5),
(232552, NULL, 'G3DSA:1.20.190.40', NULL, NULL, NULL, NULL, 'Viral ssDNA binding protein, head domain', NULL, NULL, 35016, 5),
(232553, NULL, 'G3DSA:6.10.140.390', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232554, NULL, 'G3DSA:1.10.1200.230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232555, NULL, 'G3DSA:1.10.441.10', NULL, NULL, NULL, NULL, 'Phosphomannose Isomerase, domain 2', NULL, NULL, NULL, 5),
(232556, NULL, 'G3DSA:3.40.190.220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232557, NULL, 'G3DSA:3.30.70.360', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(232558, NULL, 'G3DSA:3.90.450.1', NULL, NULL, NULL, NULL, 'Minor Coat Protein; Domain 2', NULL, NULL, 17644, 5),
(232559, NULL, 'G3DSA:3.30.70.150', NULL, NULL, NULL, NULL, '', NULL, NULL, 31386, 5),
(232560, NULL, 'G3DSA:1.20.140.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232561, NULL, 'G3DSA:3.30.1700.10', NULL, NULL, NULL, NULL, 'lpxc deacetylase, domain 2', NULL, NULL, 13775, 5),
(232562, NULL, 'G3DSA:6.10.140.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232563, NULL, 'G3DSA:2.60.40.3800', NULL, NULL, NULL, NULL, '', NULL, NULL, 32903, 5),
(232564, NULL, 'G3DSA:3.60.21.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 32385, 5),
(232565, NULL, 'G3DSA:3.40.50.11880', NULL, NULL, NULL, NULL, 'Plasmid SOS inhibition protein', NULL, NULL, 32079, 5),
(232566, NULL, 'G3DSA:2.40.30.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232567, NULL, 'G3DSA:1.10.225.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 29827, 5),
(232568, NULL, 'G3DSA:2.40.150.20', NULL, NULL, NULL, NULL, 'Ribosomal protein L14', NULL, NULL, 31701, 5),
(232569, NULL, 'G3DSA:3.90.75.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 36672, 5),
(232570, NULL, 'G3DSA:3.10.310.20', NULL, NULL, NULL, NULL, 'DHHA2 domain', NULL, NULL, 27439, 5),
(232571, NULL, 'G3DSA:2.20.28.290', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232572, NULL, 'G3DSA:2.60.98.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232573, NULL, 'G3DSA:1.20.120.930', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232574, NULL, 'G3DSA:2.10.109.10', NULL, NULL, NULL, NULL, 'Umud Fragment, subunit A', NULL, NULL, NULL, 5),
(232575, NULL, 'G3DSA:3.40.50.11690', NULL, NULL, NULL, NULL, 'Cell division protein FtsQ/DivIB', NULL, NULL, 34949, 5),
(232576, NULL, 'G3DSA:1.10.20.150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232577, NULL, 'G3DSA:2.70.10.10', NULL, NULL, NULL, NULL, 'Thrombin Inhibitor (Hirudin), subunit I', NULL, NULL, 23189, 5),
(232578, NULL, 'G3DSA:6.10.250.420', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232579, NULL, 'G3DSA:3.30.63.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232580, NULL, 'G3DSA:1.20.5.4730', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232581, NULL, 'G3DSA:1.10.150.50', NULL, NULL, NULL, NULL, '', NULL, NULL, 7881, 5),
(232582, NULL, 'G3DSA:3.30.1300.50', NULL, NULL, NULL, NULL, '', NULL, NULL, 33917, 5),
(232583, NULL, 'G3DSA:2.10.110.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 33883, 5),
(232584, NULL, 'G3DSA:1.10.287.3810', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232585, NULL, 'G3DSA:2.60.40.820', NULL, NULL, NULL, NULL, '', NULL, NULL, 28010, 5),
(232586, NULL, 'G3DSA:2.30.29.50', NULL, NULL, NULL, NULL, 'Bacterial Pleckstrin homology domain', NULL, NULL, 29735, 5),
(232587, NULL, 'G3DSA:1.10.10.2200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232588, NULL, 'G3DSA:3.10.180.80', NULL, NULL, NULL, NULL, 'Uncharacterised protein PF07063, DUF1338', NULL, NULL, NULL, 5),
(232589, NULL, 'G3DSA:1.20.120.10', NULL, NULL, NULL, NULL, 'Cytochrome c/b562', NULL, NULL, NULL, 5),
(232590, NULL, 'G3DSA:3.90.1420.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31276, 5),
(232591, NULL, 'G3DSA:3.30.200.150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232592, NULL, 'G3DSA:1.10.287.1480', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232593, NULL, 'G3DSA:6.10.250.2570', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232594, NULL, 'G3DSA:3.10.600.10', NULL, NULL, NULL, NULL, 'pyruvate carboxylase f1077a mutant domain', NULL, NULL, NULL, 5),
(232595, NULL, 'G3DSA:6.10.250.3150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232596, NULL, 'G3DSA:3.10.260.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 27397, 5),
(232597, NULL, 'G3DSA:1.20.58.920', NULL, NULL, NULL, NULL, '', NULL, NULL, 31211, 5),
(232598, NULL, 'G3DSA:1.20.1280.210', NULL, NULL, NULL, NULL, '', NULL, NULL, 32704, 5),
(232599, NULL, 'G3DSA:1.20.58.2250', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232600, NULL, 'G3DSA:1.10.189.10', NULL, NULL, NULL, NULL, 'Pyruvate Phosphate Dikinase, domain 2', NULL, NULL, NULL, 5);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(232601, NULL, 'G3DSA:1.10.150.870', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232602, NULL, 'G3DSA:1.10.60.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232603, NULL, 'G3DSA:3.40.532.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28064, 5),
(232604, NULL, 'G3DSA:1.20.5.900', NULL, NULL, NULL, NULL, 'transmembrane domain of human cd4', NULL, NULL, NULL, 5),
(232605, NULL, 'G3DSA:1.10.287.680', NULL, NULL, NULL, NULL, 'Helix hairpin bin', NULL, NULL, 15511, 5),
(232606, NULL, 'G3DSA:3.30.420.560', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232607, NULL, 'G3DSA:6.10.250.1200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232608, NULL, 'G3DSA:1.20.120.540', NULL, NULL, NULL, NULL, '', NULL, NULL, 25000, 5),
(232609, NULL, 'G3DSA:1.10.246.200', NULL, NULL, NULL, NULL, 'WPP domain', NULL, NULL, 33922, 5),
(232610, NULL, 'G3DSA:3.30.1330.110', NULL, NULL, NULL, NULL, 'BB2672', NULL, NULL, 14115, 5),
(232611, NULL, 'G3DSA:3.30.420.380', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232612, NULL, 'G3DSA:3.40.91.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232613, NULL, 'G3DSA:1.25.40.470', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232614, NULL, 'G3DSA:1.10.3640.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29722, 5),
(232615, NULL, 'G3DSA:6.10.140.780', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232616, NULL, 'G3DSA:1.20.120.150', NULL, NULL, NULL, NULL, '', NULL, NULL, 33218, 5),
(232617, NULL, 'G3DSA:6.10.250.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232618, NULL, 'G3DSA:1.10.150.90', NULL, NULL, NULL, NULL, 'Immunodeficiency lentiviruses, gag gene matrix protein p17', NULL, NULL, 7997, 5),
(232619, NULL, 'G3DSA:6.10.250.600', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232620, NULL, 'G3DSA:2.10.250.10', NULL, NULL, NULL, NULL, 'Calreticulin/calnexin, P domain', NULL, NULL, 9670, 5),
(232621, NULL, 'G3DSA:2.30.30.690', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232622, NULL, 'G3DSA:3.50.50.80', NULL, NULL, NULL, NULL, '', NULL, NULL, 34380, 5),
(232623, NULL, 'G3DSA:3.40.720.10', NULL, NULL, NULL, NULL, 'Alkaline Phosphatase, subunit A', NULL, NULL, 20942, 5),
(232624, NULL, 'G3DSA:1.10.287.990', NULL, NULL, NULL, NULL, 'Fe,Mn superoxide dismutase (SOD) domain', NULL, NULL, 28328, 5),
(232625, NULL, 'G3DSA:3.30.2460.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232626, NULL, 'G3DSA:6.20.280.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232627, NULL, 'G3DSA:2.60.120.870', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232628, NULL, 'G3DSA:3.30.450.80', NULL, NULL, NULL, NULL, '', NULL, NULL, 31748, 5),
(232629, NULL, 'G3DSA:1.10.357.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 29582, 5),
(232630, NULL, 'G3DSA:3.40.1460.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232631, NULL, 'G3DSA:6.10.280.190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232632, NULL, 'G3DSA:4.10.80.340', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232633, NULL, 'G3DSA:3.30.428.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31944, 5),
(232634, NULL, 'G3DSA:3.30.70.1550', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232635, NULL, 'G3DSA:1.20.1260.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232636, NULL, 'G3DSA:1.20.1270.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232637, NULL, 'G3DSA:2.30.30.110', NULL, NULL, NULL, NULL, '', NULL, NULL, 10153, 5),
(232638, NULL, 'G3DSA:2.40.50.140', NULL, NULL, NULL, NULL, '', NULL, NULL, 7999, 5),
(232639, NULL, 'G3DSA:3.90.930.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232640, NULL, 'G3DSA:6.10.250.1780', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232641, NULL, 'G3DSA:1.20.140.40', NULL, NULL, NULL, NULL, 'Invertase/pectin methylesterase inhibitor family protein', NULL, NULL, 32270, 5),
(232642, NULL, 'G3DSA:3.30.1680.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232643, NULL, 'G3DSA:2.170.150.20', NULL, NULL, NULL, NULL, 'Peptide methionine sulfoxide reductase.', NULL, NULL, NULL, 5),
(232644, NULL, 'G3DSA:3.90.1390.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(232645, NULL, 'G3DSA:3.30.30.200', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5),
(232646, NULL, 'G3DSA:2.60.120.1030', NULL, NULL, NULL, NULL, 'Clp1, DNA binding domain', NULL, NULL, 33928, 5),
(232647, NULL, 'G3DSA:1.10.10.1130', NULL, NULL, NULL, NULL, 'Uncharacterised protein PF10982, DUF2789', NULL, NULL, 31983, 5),
(232648, NULL, 'G3DSA:3.30.1050.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33258, 5),
(232649, NULL, 'G3DSA:6.10.250.2180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232650, NULL, 'G3DSA:2.170.120.20', NULL, NULL, NULL, NULL, 'Ribosomal protein L25, beta domain', NULL, NULL, 28441, 5),
(232651, NULL, 'G3DSA:3.40.718.10', NULL, NULL, NULL, NULL, 'Isopropylmalate Dehydrogenase', NULL, NULL, NULL, 5),
(232652, NULL, 'G3DSA:6.20.410.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232653, NULL, 'G3DSA:2.60.40.3620', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232654, NULL, 'G3DSA:3.30.750.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232655, NULL, 'G3DSA:3.30.70.3310', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232656, NULL, 'G3DSA:3.30.1810.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29545, 5),
(232657, NULL, 'G3DSA:1.10.1740.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232658, NULL, 'G3DSA:3.40.50.2000', NULL, NULL, NULL, NULL, 'Glycogen Phosphorylase B;', NULL, NULL, NULL, 5),
(232659, NULL, 'G3DSA:1.10.287.3240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232660, NULL, 'G3DSA:3.10.450.490', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232661, NULL, 'G3DSA:3.30.300.370', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232662, NULL, 'G3DSA:1.10.10.540', NULL, NULL, NULL, NULL, '', NULL, NULL, 28484, 5),
(232663, NULL, 'G3DSA:3.55.50.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 37224, 5),
(232664, NULL, 'G3DSA:2.40.128.450', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232665, NULL, 'G3DSA:2.40.50.710', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232666, NULL, 'G3DSA:3.30.70.2910', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232667, NULL, 'G3DSA:3.30.70.141', NULL, NULL, NULL, NULL, '', NULL, NULL, 31973, 5),
(232668, NULL, 'G3DSA:1.10.357.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232669, NULL, 'G3DSA:3.40.50.2300', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232670, NULL, 'G3DSA:2.170.210.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 33722, 5),
(232671, NULL, 'G3DSA:6.10.10.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232672, NULL, 'G3DSA:4.10.87.10', NULL, NULL, NULL, NULL, 'mRNA Capping Enzyme; domain 3', NULL, NULL, NULL, 5),
(232673, NULL, 'G3DSA:1.20.58.1460', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232674, NULL, 'G3DSA:1.10.287.480', NULL, NULL, NULL, NULL, 'helix hairpin bin', NULL, NULL, 4952, 5),
(232675, NULL, 'G3DSA:3.30.190.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232676, NULL, 'G3DSA:1.10.10.460', NULL, NULL, NULL, NULL, 'Ribonuclease hii. Domain 2', NULL, NULL, 9476, 5),
(232677, NULL, 'G3DSA:3.30.160.570', NULL, NULL, NULL, NULL, 'Ncd80 complex, Spc24 subunit', NULL, NULL, NULL, 5),
(232678, NULL, 'G3DSA:1.10.250.10', NULL, NULL, NULL, NULL, 'Bluetongue Virus 10, subunit 1, domain 1', NULL, NULL, 10204, 5),
(232679, NULL, 'G3DSA:2.60.40.2260', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232680, NULL, 'G3DSA:1.20.1270.420', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232681, NULL, 'G3DSA:4.10.840.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28428, 5),
(232682, NULL, 'G3DSA:1.10.10.1800', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232683, NULL, 'G3DSA:3.40.50.800', NULL, NULL, NULL, NULL, '', NULL, NULL, 30909, 5),
(232684, NULL, 'G3DSA:3.30.9.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232685, NULL, 'G3DSA:2.60.40.1860', NULL, NULL, NULL, NULL, '', NULL, NULL, 32631, 5),
(232686, NULL, 'G3DSA:3.100.10.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 35032, 5),
(232687, NULL, 'G3DSA:3.40.50.11930', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232688, NULL, 'G3DSA:1.25.40.860', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(232689, NULL, 'G3DSA:6.10.360.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 8901, 5),
(232690, NULL, 'G3DSA:3.30.300.200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232691, NULL, 'G3DSA:3.40.920.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 5755, 5),
(232692, NULL, 'G3DSA:2.60.40.1870', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232693, NULL, 'G3DSA:4.10.60.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232694, NULL, 'G3DSA:1.20.120.550', NULL, NULL, NULL, NULL, '', NULL, NULL, 19055, 5),
(232695, NULL, 'G3DSA:6.10.250.970', NULL, NULL, NULL, NULL, '', NULL, NULL, 37724, 5),
(232696, NULL, 'G3DSA:3.40.140.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232697, NULL, 'G3DSA:1.10.4070.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232698, NULL, 'G3DSA:1.20.1440.270', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232699, NULL, 'G3DSA:1.10.1300.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28929, 5),
(232700, NULL, 'G3DSA:2.170.160.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 17189, 5),
(232701, NULL, 'G3DSA:6.10.140.1460', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232702, NULL, 'G3DSA:1.10.10.990', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232703, NULL, 'G3DSA:3.50.30.50', NULL, NULL, NULL, NULL, 'Putative cyclase', NULL, NULL, 33215, 5),
(232704, NULL, 'G3DSA:6.10.250.3340', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232705, NULL, 'G3DSA:6.20.260.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32154, 5),
(232706, NULL, 'G3DSA:3.40.1090.10', NULL, NULL, NULL, NULL, 'Cytosolic phospholipase A2 catalytic domain', NULL, NULL, NULL, 5),
(232707, NULL, 'G3DSA:1.20.5.1000', NULL, NULL, NULL, NULL, 'arf6 gtpase in complex with a specific effector, jip4', NULL, NULL, NULL, 5),
(232708, NULL, 'G3DSA:2.60.120.890', NULL, NULL, NULL, NULL, '', NULL, NULL, 32340, 5),
(232709, NULL, 'G3DSA:1.10.1200.220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232710, NULL, 'G3DSA:1.20.120.1960', NULL, NULL, NULL, NULL, 'QSOX sulfhydryl oxidase domain', NULL, NULL, 34388, 5),
(232711, NULL, 'G3DSA:1.20.1280.250', NULL, NULL, NULL, NULL, '', NULL, NULL, 32615, 5),
(232712, NULL, 'G3DSA:6.10.290.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 28669, 5),
(232713, NULL, 'G3DSA:1.20.120.1750', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232714, NULL, 'G3DSA:2.10.300.10', NULL, NULL, NULL, NULL, 'Porin MspA ribbon domain', NULL, NULL, NULL, 5),
(232715, NULL, 'G3DSA:1.10.150.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 27588, 5),
(232716, NULL, 'G3DSA:2.70.50.30', NULL, NULL, NULL, NULL, 'Coagulation Factor XIII, subunit A, domain 1', NULL, NULL, 23030, 5),
(232717, NULL, 'G3DSA:2.30.30.350', NULL, NULL, NULL, NULL, 'mobile metagenome of vibrio cholerae. Integron cassette protein vch_cass4.', NULL, NULL, NULL, 5),
(232718, NULL, 'G3DSA:1.10.150.910', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232719, NULL, 'G3DSA:1.10.20.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232720, NULL, 'G3DSA:3.30.450.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232721, NULL, 'G3DSA:3.10.50.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 33552, 5),
(232722, NULL, 'G3DSA:2.40.128.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232723, NULL, 'G3DSA:1.10.4010.10', NULL, NULL, NULL, NULL, 'Type II deoxyuridine triphosphatase', NULL, NULL, NULL, 5),
(232724, NULL, 'G3DSA:3.30.70.2340', NULL, NULL, NULL, NULL, 'Uncharacterised protein PF12112 family, DUF3579', NULL, NULL, NULL, 5),
(232725, NULL, 'G3DSA:6.10.250.2790', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232726, NULL, 'G3DSA:1.10.472.150', NULL, NULL, NULL, NULL, '', NULL, NULL, 35467, 5),
(232727, NULL, 'G3DSA:3.90.1570.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232728, NULL, 'G3DSA:2.60.120.10', NULL, NULL, NULL, NULL, 'Jelly Rolls', NULL, NULL, 17924, 5),
(232729, NULL, 'G3DSA:1.20.58.300', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232730, NULL, 'G3DSA:6.10.250.890', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232731, NULL, 'G3DSA:1.20.120.470', NULL, NULL, NULL, NULL, '', NULL, NULL, 33416, 5);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(232732, NULL, 'G3DSA:1.25.40.610', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232733, NULL, 'G3DSA:3.30.1420.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 34751, 5),
(232734, NULL, 'G3DSA:2.30.30.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232735, NULL, 'G3DSA:6.10.140.2010', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232736, NULL, 'G3DSA:3.90.290.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31628, 5),
(232737, NULL, 'G3DSA:3.30.30.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232738, NULL, 'G3DSA:3.90.1150.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232739, NULL, 'G3DSA:3.30.420.80', NULL, NULL, NULL, NULL, 'Ribosomal protein S11', NULL, NULL, 28753, 5),
(232740, NULL, 'G3DSA:3.40.50.11940', NULL, NULL, NULL, NULL, '', NULL, NULL, 32164, 5),
(232741, NULL, 'G3DSA:6.10.250.3420', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232742, NULL, 'G3DSA:6.10.250.3260', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232743, NULL, 'G3DSA:2.60.530.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29782, 5),
(232744, NULL, 'G3DSA:3.40.1420.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232745, NULL, 'G3DSA:2.60.40.1510', NULL, NULL, NULL, NULL, 'ntegrin, alpha v. Chain A, domain 3', NULL, NULL, NULL, 5),
(232746, NULL, 'G3DSA:2.102.30.10', NULL, NULL, NULL, NULL, 'tm1086 (SG structure) domain', NULL, NULL, 36480, 5),
(232747, NULL, 'G3DSA:3.30.720.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232748, NULL, 'G3DSA:6.20.370.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232749, NULL, 'G3DSA:1.10.4200.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232750, NULL, 'G3DSA:3.30.1910.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232751, NULL, 'G3DSA:1.25.40.450', NULL, NULL, NULL, NULL, '', NULL, NULL, 37511, 5),
(232752, NULL, 'G3DSA:1.20.5.370', NULL, NULL, NULL, NULL, '', NULL, NULL, 7311, 5),
(232753, NULL, 'G3DSA:3.30.1230.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29948, 5),
(232754, NULL, 'G3DSA:2.60.15.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33280, 5),
(232755, NULL, 'G3DSA:3.30.67.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232756, NULL, 'G3DSA:1.10.238.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232757, NULL, 'G3DSA:1.20.120.600', NULL, NULL, NULL, NULL, 'Crystal structure from the mobile metagenome of halifax harbour sewage outfall', NULL, NULL, NULL, 5),
(232758, NULL, 'G3DSA:2.30.30.620', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232759, NULL, 'G3DSA:1.10.840.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28065, 5),
(232760, NULL, 'G3DSA:2.60.40.2340', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232761, NULL, 'G3DSA:1.10.418.50', NULL, NULL, NULL, NULL, '', NULL, NULL, 34585, 5),
(232762, NULL, 'G3DSA:1.20.5.480', NULL, NULL, NULL, NULL, 'Single helix bin', NULL, NULL, 29688, 5),
(232763, NULL, 'G3DSA:1.10.472.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232764, NULL, 'G3DSA:3.40.50.11490', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232765, NULL, 'G3DSA:2.40.110.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232766, NULL, 'G3DSA:3.40.50.920', NULL, NULL, NULL, NULL, '', NULL, NULL, 9687, 5),
(232767, NULL, 'G3DSA:4.10.470.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232768, NULL, 'G3DSA:1.20.58.1320', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232769, NULL, 'G3DSA:3.30.70.2510', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232770, NULL, 'G3DSA:3.30.2030.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232771, NULL, 'G3DSA:1.10.3760.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232772, NULL, 'G3DSA:1.10.287.790', NULL, NULL, NULL, NULL, 'luxt domain from vibrio parahaemolyticus', NULL, NULL, NULL, 5),
(232773, NULL, 'G3DSA:1.20.120.710', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232774, NULL, 'G3DSA:3.30.70.1590', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232775, NULL, 'G3DSA:2.100.10.10', NULL, NULL, NULL, NULL, 'Pesticidal crystal protein, central domain', NULL, NULL, 31712, 5);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(232776, NULL, 'G3DSA:6.10.140.1380', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232777, NULL, 'G3DSA:3.30.830.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232778, NULL, 'G3DSA:2.40.50.470', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232779, NULL, 'G3DSA:3.30.70.1520', NULL, NULL, NULL, NULL, 'Heterotetrameric sarcosine oxidase', NULL, NULL, NULL, 5),
(232780, NULL, 'G3DSA:1.20.1050.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232781, NULL, 'G3DSA:2.40.50.840', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232782, NULL, 'G3DSA:2.60.120.970', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232783, NULL, 'G3DSA:3.90.70.150', NULL, NULL, NULL, NULL, 'Helper component proteinase', NULL, NULL, 36517, 5),
(232784, NULL, 'G3DSA:6.10.140.1910', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232785, NULL, 'G3DSA:2.30.270.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232786, NULL, 'G3DSA:6.10.140.290', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232787, NULL, 'G3DSA:1.10.150.830', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232788, NULL, 'G3DSA:1.10.3950.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32339, 5),
(232789, NULL, 'G3DSA:6.20.250.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232790, NULL, 'G3DSA:3.30.2220.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 27671, 5),
(232791, NULL, 'G3DSA:6.10.140.660', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232792, NULL, 'G3DSA:6.10.140.1700', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232793, NULL, 'G3DSA:6.20.60.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232794, NULL, 'G3DSA:1.10.1660.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 31503, 5),
(232795, NULL, 'G3DSA:6.10.140.1540', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232796, NULL, 'G3DSA:2.40.50.1060', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232797, NULL, 'G3DSA:1.10.150.460', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232798, NULL, 'G3DSA:4.10.170.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29578, 5),
(232799, NULL, 'G3DSA:1.10.10.2490', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232800, NULL, 'G3DSA:2.170.40.20', NULL, NULL, NULL, NULL, 'Human immunodeficiency virus 1, Gp160, envelope glycoprotein', NULL, NULL, 32177, 5),
(232801, NULL, 'G3DSA:2.40.170.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 28182, 5),
(232802, NULL, 'G3DSA:3.30.2020.40', NULL, NULL, NULL, NULL, 'Uncharacterised protein PF10387, DUF2442', NULL, NULL, NULL, 5),
(232803, NULL, 'G3DSA:2.30.29.190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232804, NULL, 'G3DSA:3.40.20.10', NULL, NULL, NULL, NULL, 'Severin', NULL, NULL, 24083, 5),
(232805, NULL, 'G3DSA:3.40.1580.30', NULL, NULL, NULL, NULL, 'Domain of unknown function (DUF5066)', NULL, NULL, NULL, 5),
(232806, NULL, 'G3DSA:1.10.220.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232807, NULL, 'G3DSA:6.10.140.820', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232808, NULL, 'G3DSA:3.30.70.2140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232809, NULL, 'G3DSA:3.40.1360.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232810, NULL, 'G3DSA:2.60.40.2500', NULL, NULL, NULL, NULL, '', NULL, NULL, 30665, 5),
(232811, NULL, 'G3DSA:3.90.1640.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232812, NULL, 'G3DSA:1.10.1170.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232813, NULL, 'G3DSA:6.10.250.1020', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232814, NULL, 'G3DSA:1.10.1240.30', NULL, NULL, NULL, NULL, 'KaiA/RbsU domain', NULL, NULL, 2799, 5),
(232815, NULL, 'G3DSA:1.20.120.180', NULL, NULL, NULL, NULL, '', NULL, NULL, 28103, 5),
(232816, NULL, 'G3DSA:2.40.50.630', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232817, NULL, 'G3DSA:3.20.20.105', NULL, NULL, NULL, NULL, '', NULL, NULL, 30208, 5),
(232818, NULL, 'G3DSA:3.30.1370.230', NULL, NULL, NULL, NULL, '', NULL, NULL, 30747, 5),
(232819, NULL, 'G3DSA:3.30.30.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232820, NULL, 'G3DSA:3.50.4.10', NULL, NULL, NULL, NULL, 'Hepatocyte Growth Factor', NULL, NULL, NULL, 5);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(232821, NULL, 'G3DSA:6.10.140.370', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232822, NULL, 'G3DSA:3.90.550.10', NULL, NULL, NULL, NULL, 'Spore Coat Polysaccharide Biosynthesis Protein SpsA; Chain A', NULL, NULL, 24008, 5),
(232823, NULL, 'G3DSA:3.10.450.230', NULL, NULL, NULL, NULL, 'VirB8 protein', NULL, NULL, NULL, 5),
(232824, NULL, 'G3DSA:2.60.120.1110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232825, NULL, 'G3DSA:3.40.1550.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 24427, 5),
(232826, NULL, 'G3DSA:3.90.1830.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 36521, 5),
(232827, NULL, 'G3DSA:6.10.10.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232828, NULL, 'G3DSA:1.20.120.920', NULL, NULL, NULL, NULL, '', NULL, NULL, 35173, 5),
(232829, NULL, 'G3DSA:1.10.287.400', NULL, NULL, NULL, NULL, '', NULL, NULL, 12008, 5),
(232830, NULL, 'G3DSA:1.20.58.1160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232831, NULL, 'G3DSA:3.30.70.2350', NULL, NULL, NULL, NULL, '', NULL, NULL, 33689, 5),
(232832, NULL, 'G3DSA:6.10.250.2950', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232833, NULL, 'G3DSA:4.10.1170.10', NULL, NULL, NULL, NULL, 'MAP kinase activated protein kinase 2', NULL, NULL, 24590, 5),
(232834, NULL, 'G3DSA:3.30.70.1670', NULL, NULL, NULL, NULL, '', NULL, NULL, 31384, 5),
(232835, NULL, 'G3DSA:2.40.128.110', NULL, NULL, NULL, NULL, '', NULL, NULL, 32091, 5),
(232836, NULL, 'G3DSA:2.60.40.2470', NULL, NULL, NULL, NULL, 'SoxY domain', NULL, NULL, 30895, 5),
(232837, NULL, 'G3DSA:1.20.120.1320', NULL, NULL, NULL, NULL, 'Aspartokinase, catalytic domain', NULL, NULL, 35029, 5),
(232838, NULL, 'G3DSA:1.20.58.1110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232839, NULL, 'G3DSA:2.60.130.10', NULL, NULL, NULL, NULL, 'Aromatic compound dioxygenase', NULL, NULL, 7098, 5),
(232840, NULL, 'G3DSA:3.10.300.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28264, 5),
(232841, NULL, 'G3DSA:6.20.200.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31054, 5),
(232842, NULL, 'G3DSA:6.10.250.680', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232843, NULL, 'G3DSA:1.10.1220.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232844, NULL, 'G3DSA:6.10.250.3050', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232845, NULL, 'G3DSA:6.10.280.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 28062, 5),
(232846, NULL, 'G3DSA:3.30.750.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232847, NULL, 'G3DSA:3.40.1800.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232848, NULL, 'G3DSA:3.90.1430.10', NULL, NULL, NULL, NULL, 'Yeast translation eEF2 (G'' domain)', NULL, NULL, NULL, 5),
(232849, NULL, 'G3DSA:1.20.120.840', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232850, NULL, 'G3DSA:3.30.230.130', NULL, NULL, NULL, NULL, 'Cullin; Chain C, Domain 2', NULL, NULL, NULL, 5),
(232851, NULL, 'G3DSA:2.40.160.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232852, NULL, 'G3DSA:3.90.800.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232853, NULL, 'G3DSA:1.25.40.370', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232854, NULL, 'G3DSA:3.60.15.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232855, NULL, 'G3DSA:3.30.1040.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232856, NULL, 'G3DSA:1.25.40.820', NULL, NULL, NULL, NULL, '', NULL, NULL, 33684, 5),
(232857, NULL, 'G3DSA:3.40.1020.10', NULL, NULL, NULL, NULL, 'Biosynthetic Threonine Deaminase; Domain 3', NULL, NULL, 30347, 5),
(232858, NULL, 'G3DSA:1.10.1220.190', NULL, NULL, NULL, NULL, 'VirC2, RHH domain', NULL, NULL, 32495, 5),
(232859, NULL, 'G3DSA:6.10.140.1620', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232860, NULL, 'G3DSA:3.30.930.20', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF1054', NULL, NULL, NULL, 5),
(232861, NULL, 'G3DSA:1.25.40.320', NULL, NULL, NULL, NULL, '', NULL, NULL, 33876, 5),
(232862, NULL, 'G3DSA:6.10.250.2870', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232863, NULL, 'G3DSA:3.40.50.10780', NULL, NULL, NULL, NULL, 'Dipeptide transport protein', NULL, NULL, 24877, 5);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(232864, NULL, 'G3DSA:6.10.140.1250', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232865, NULL, 'G3DSA:3.30.890.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232866, NULL, 'G3DSA:1.20.58.1080', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232867, NULL, 'G3DSA:1.10.150.380', NULL, NULL, NULL, NULL, '', NULL, NULL, 37563, 5),
(232868, NULL, 'G3DSA:3.90.420.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28430, 5),
(232869, NULL, 'G3DSA:6.10.250.3180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232870, NULL, 'G3DSA:2.30.42.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 27069, 5),
(232871, NULL, 'G3DSA:1.20.920.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232872, NULL, 'G3DSA:6.20.450.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232873, NULL, 'G3DSA:3.20.180.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 36209, 5),
(232874, NULL, 'G3DSA:1.10.3520.10', NULL, NULL, NULL, NULL, 'Glycolipid transfer protein', NULL, NULL, 31477, 5),
(232875, NULL, 'G3DSA:1.10.150.750', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232876, NULL, 'G3DSA:1.20.5.770', NULL, NULL, NULL, NULL, 'Single helix bin', NULL, NULL, NULL, 5),
(232877, NULL, 'G3DSA:2.30.42.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232878, NULL, 'G3DSA:1.10.340.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 36651, 5),
(232879, NULL, 'G3DSA:6.10.140.1670', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232880, NULL, 'G3DSA:1.20.58.1030', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232881, NULL, 'G3DSA:3.40.1350.50', NULL, NULL, NULL, NULL, '', NULL, NULL, 36132, 5),
(232882, NULL, 'G3DSA:4.10.1300.10', NULL, NULL, NULL, NULL, 'Dinoflagellate luciferase', NULL, NULL, 36103, 5),
(232883, NULL, 'G3DSA:1.10.530.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 20595, 5),
(232884, NULL, 'G3DSA:6.20.50.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232885, NULL, 'G3DSA:3.30.1300.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232886, NULL, 'G3DSA:2.40.50.550', NULL, NULL, NULL, NULL, '', NULL, NULL, 33710, 5),
(232887, NULL, 'G3DSA:2.60.40.2420', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232888, NULL, 'G3DSA:3.30.70.2220', NULL, NULL, NULL, NULL, '', NULL, NULL, 33860, 5),
(232889, NULL, 'G3DSA:1.10.287.970', NULL, NULL, NULL, NULL, 'His Kinase A (phosphoacceptor) domain', NULL, NULL, 26787, 5),
(232890, NULL, 'G3DSA:4.10.280.110', NULL, NULL, NULL, NULL, '', NULL, NULL, 31846, 5),
(232891, NULL, 'G3DSA:2.40.50.180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232892, NULL, 'G3DSA:2.60.40.2050', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232893, NULL, 'G3DSA:2.30.30.170', NULL, NULL, NULL, NULL, '', NULL, NULL, 30382, 5),
(232894, NULL, 'G3DSA:3.90.249.10', NULL, NULL, NULL, NULL, 'Hexon Major Viral Coat Protein, domain 3', NULL, NULL, 11063, 5),
(232895, NULL, 'G3DSA:2.30.31.30', NULL, NULL, NULL, NULL, 'Arterivirus nps1beta, nuclease domain', NULL, NULL, NULL, 5),
(232896, NULL, 'G3DSA:3.10.170.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232897, NULL, 'G3DSA:3.30.450.400', NULL, NULL, NULL, NULL, 'Colicin M, catalytic domain', NULL, NULL, NULL, 5),
(232898, NULL, 'G3DSA:2.30.29.220', NULL, NULL, NULL, NULL, '', NULL, NULL, 30198, 5),
(232899, NULL, 'G3DSA:6.10.140.740', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232900, NULL, 'G3DSA:2.170.280.10', NULL, NULL, NULL, NULL, 'f41 fragment of flagellin, middle domain', NULL, NULL, NULL, 5),
(232901, NULL, 'G3DSA:1.10.10.2570', NULL, NULL, NULL, NULL, '', NULL, NULL, 28275, 5),
(232902, NULL, 'G3DSA:4.10.75.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28044, 5),
(232903, NULL, 'G3DSA:6.10.250.1100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232904, NULL, 'G3DSA:1.10.720.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 9005, 5),
(232905, NULL, 'G3DSA:2.60.120.760', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232906, NULL, 'G3DSA:2.40.50.260', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232907, NULL, 'G3DSA:1.20.120.1620', NULL, NULL, NULL, NULL, '', NULL, NULL, 28518, 5);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(232908, NULL, 'G3DSA:2.30.30.830', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232909, NULL, 'G3DSA:6.10.140.610', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232910, NULL, 'G3DSA:1.10.110.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31340, 5),
(232911, NULL, 'G3DSA:3.30.1460.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 27688, 5),
(232912, NULL, 'G3DSA:2.60.40.50', NULL, NULL, NULL, NULL, '', NULL, NULL, 9224, 5),
(232913, NULL, 'G3DSA:3.40.50.10010', NULL, NULL, NULL, NULL, '', NULL, NULL, 29749, 5),
(232914, NULL, 'G3DSA:2.20.25.570', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232915, NULL, 'G3DSA:2.60.40.2890', NULL, NULL, NULL, NULL, 'Domain of unknown function DUF5300', NULL, NULL, NULL, 5),
(232916, NULL, 'G3DSA:1.10.400.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 9151, 5),
(232917, NULL, 'G3DSA:1.20.120.420', NULL, NULL, NULL, NULL, '', NULL, NULL, 21706, 5),
(232918, NULL, 'G3DSA:6.10.250.3390', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232919, NULL, 'G3DSA:6.10.250.840', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232920, NULL, 'G3DSA:3.30.310.170', NULL, NULL, NULL, NULL, 'Outer membrane protein assembly factor BamC', NULL, NULL, 34322, 5),
(232921, NULL, 'G3DSA:2.30.270.10', NULL, NULL, NULL, NULL, 'duf1285 protein', NULL, NULL, 19061, 5),
(232922, NULL, 'G3DSA:1.10.1200.100', NULL, NULL, NULL, NULL, 'conserved protein domain from corynebacterium diphtheriae', NULL, NULL, 34398, 5),
(232923, NULL, 'G3DSA:3.30.70.1910', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232924, NULL, 'G3DSA:1.20.1060.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232925, NULL, 'G3DSA:3.30.30.90', NULL, NULL, NULL, NULL, '', NULL, NULL, 32404, 5),
(232926, NULL, 'G3DSA:3.30.70.2720', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232927, NULL, 'G3DSA:3.30.70.2800', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232928, NULL, 'G3DSA:1.20.5.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232929, NULL, 'G3DSA:6.20.400.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232930, NULL, 'G3DSA:3.10.20.370', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232931, NULL, 'G3DSA:2.30.30.910', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232932, NULL, 'G3DSA:2.30.30.210', NULL, NULL, NULL, NULL, 'Ribonuclease P/MRP, subunit p29', NULL, NULL, 30040, 5),
(232933, NULL, 'G3DSA:1.10.10.1970', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232934, NULL, 'G3DSA:6.20.370.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232935, NULL, 'G3DSA:3.90.150.10', NULL, NULL, NULL, NULL, 'Variant Surface Glycoprotein, subunit A domain 1', NULL, NULL, NULL, 5),
(232936, NULL, 'G3DSA:3.20.160.10', NULL, NULL, NULL, NULL, 'vpa0580 domain like', NULL, NULL, 32297, 5),
(232937, NULL, 'G3DSA:3.40.350.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 25711, 5),
(232938, NULL, 'G3DSA:1.25.40.400', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232939, NULL, 'G3DSA:6.10.250.920', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232940, NULL, 'G3DSA:1.10.1240.20', NULL, NULL, NULL, NULL, 'Lytic transglycosylase, superhelical linker domain', NULL, NULL, 29907, 5),
(232941, NULL, 'G3DSA:6.10.250.3210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232942, NULL, 'G3DSA:1.25.40.660', NULL, NULL, NULL, NULL, '', NULL, NULL, 33539, 5),
(232943, NULL, 'G3DSA:3.40.50.970', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232944, NULL, 'G3DSA:1.20.870.10', NULL, NULL, NULL, NULL, 'Son of sevenless (SoS) protein Chain: S domain 1', NULL, NULL, NULL, 5),
(232945, NULL, 'G3DSA:3.40.50.11810', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232946, NULL, 'G3DSA:6.10.140.2220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232947, NULL, 'G3DSA:1.10.468.10', NULL, NULL, NULL, NULL, 'Photosynthetic Reaction Center, subunit C, domain 2', NULL, NULL, 4340, 5),
(232948, NULL, 'G3DSA:3.30.300.250', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232949, NULL, 'G3DSA:1.10.260.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232950, NULL, 'G3DSA:1.10.1410.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(232951, NULL, 'G3DSA:1.25.40.580', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232952, NULL, 'G3DSA:1.25.10.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232953, NULL, 'G3DSA:1.10.1200.270', NULL, NULL, NULL, NULL, '', NULL, NULL, 30451, 5),
(232954, NULL, 'G3DSA:6.10.140.2140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232955, NULL, 'G3DSA:6.10.250.3130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232956, NULL, 'G3DSA:1.25.40.740', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232957, NULL, 'G3DSA:4.10.710.10', NULL, NULL, NULL, NULL, 'Hepatitis C Virus Capsid Protein; Chain A', NULL, NULL, 36052, 5),
(232958, NULL, 'G3DSA:2.60.40.2710', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232959, NULL, 'G3DSA:3.10.340.11', NULL, NULL, NULL, NULL, 'Methenyltetrahydromethanopterin Cyclohydrolase; Chain A, domain 1', NULL, NULL, NULL, 5),
(232960, NULL, 'G3DSA:6.10.140.2060', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232961, NULL, 'G3DSA:6.10.250.1230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232962, NULL, 'G3DSA:2.60.120.920', NULL, NULL, NULL, NULL, '', NULL, NULL, 35477, 5),
(232963, NULL, 'G3DSA:1.20.58.800', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232964, NULL, 'G3DSA:1.20.1050.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232965, NULL, 'G3DSA:4.10.1100.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28717, 5),
(232966, NULL, 'G3DSA:3.40.50.1400', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232967, NULL, 'G3DSA:1.20.120.1460', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232968, NULL, 'G3DSA:3.30.1480.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33139, 5),
(232969, NULL, 'G3DSA:6.10.140.450', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232970, NULL, 'G3DSA:1.20.120.760', NULL, NULL, NULL, NULL, 'Staphylcoagulase, helix bundle, domain 2', NULL, NULL, 37334, 5),
(232971, NULL, 'G3DSA:2.70.40.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 30655, 5),
(232972, NULL, 'G3DSA:6.10.20.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232973, NULL, 'G3DSA:1.10.150.320', NULL, NULL, NULL, NULL, 'Photosystem II 12 kDa extrinsic protein', NULL, NULL, NULL, 5),
(232974, NULL, 'G3DSA:1.10.3830.10', NULL, NULL, NULL, NULL, 'Diacylglycerol kinase (DAGK) domain', NULL, NULL, NULL, 5),
(232975, NULL, 'G3DSA:2.20.70.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232976, NULL, 'G3DSA:1.10.1740.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232977, NULL, 'G3DSA:6.10.140.1750', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232978, NULL, 'G3DSA:3.40.50.180', NULL, NULL, NULL, NULL, '', NULL, NULL, 11590, 5),
(232979, NULL, 'G3DSA:3.10.20.530', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232980, NULL, 'G3DSA:3.30.70.2190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232981, NULL, 'G3DSA:3.30.750.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232982, NULL, 'G3DSA:3.30.379.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232983, NULL, 'G3DSA:1.20.120.510', NULL, NULL, NULL, NULL, 'mg296 homolog like', NULL, NULL, 21619, 5),
(232984, NULL, 'G3DSA:3.30.260.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 24832, 5),
(232985, NULL, 'G3DSA:2.40.360.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232986, NULL, 'G3DSA:1.10.3210.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232987, NULL, 'G3DSA:1.10.8.130', NULL, NULL, NULL, NULL, '', NULL, NULL, 27939, 5),
(232988, NULL, 'G3DSA:3.30.1670.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32932, 5),
(232989, NULL, 'G3DSA:2.60.40.2550', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232990, NULL, 'G3DSA:1.10.8.340', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232991, NULL, 'G3DSA:3.40.50.12090', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232992, NULL, 'G3DSA:3.90.1720.10', NULL, NULL, NULL, NULL, 'endopeptidase domain like (from Nostoc punctiforme)', NULL, NULL, NULL, 5),
(232993, NULL, 'G3DSA:1.20.120.520', NULL, NULL, NULL, NULL, 'nmb1532 protein domain like', NULL, NULL, NULL, 5),
(232994, NULL, 'G3DSA:6.10.140.1170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(232995, NULL, 'G3DSA:1.10.287.2500', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232996, NULL, 'G3DSA:2.30.30.1260', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232997, NULL, 'G3DSA:1.10.40.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232998, NULL, 'G3DSA:3.40.50.12620', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(232999, NULL, 'G3DSA:6.10.140.1040', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233000, NULL, 'G3DSA:1.10.10.570', NULL, NULL, NULL, NULL, '', NULL, NULL, 7244, 5),
(233001, NULL, 'G3DSA:2.60.40.2410', NULL, NULL, NULL, NULL, 'Uncharacterised protein PF12988, DUF3872', NULL, NULL, 31007, 5),
(233002, NULL, 'G3DSA:1.10.287.80', NULL, NULL, NULL, NULL, 'ATP synthase, gamma subunit, helix hairpin domain', NULL, NULL, NULL, 5),
(233003, NULL, 'G3DSA:3.90.80.10', NULL, NULL, NULL, NULL, 'Inorganic pyrophosphatase', NULL, NULL, 28009, 5),
(233004, NULL, 'G3DSA:1.10.1650.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 9103, 5),
(233005, NULL, 'G3DSA:6.10.250.2290', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233006, NULL, 'G3DSA:1.10.150.540', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233007, NULL, 'G3DSA:2.20.230.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233008, NULL, 'G3DSA:1.20.970.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233009, NULL, 'G3DSA:1.20.142.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 36202, 5),
(233010, NULL, 'G3DSA:3.30.1370.100', NULL, NULL, NULL, NULL, '', NULL, NULL, 34539, 5),
(233011, NULL, 'G3DSA:6.10.140.1960', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233012, NULL, 'G3DSA:3.40.980.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 27832, 5),
(233013, NULL, 'G3DSA:3.90.1150.50', NULL, NULL, NULL, NULL, '', NULL, NULL, 29614, 5),
(233014, NULL, 'G3DSA:6.10.140.1830', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233015, NULL, 'G3DSA:3.30.460.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233016, NULL, 'G3DSA:1.10.150.670', NULL, NULL, NULL, NULL, '', NULL, NULL, 37195, 5),
(233017, NULL, 'G3DSA:1.10.150.590', NULL, NULL, NULL, NULL, '', NULL, NULL, 31929, 5),
(233018, NULL, 'G3DSA:1.20.5.450', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233019, NULL, 'G3DSA:3.30.70.3030', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233020, NULL, 'G3DSA:3.40.50.11600', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233021, NULL, 'G3DSA:1.10.10.650', NULL, NULL, NULL, NULL, '', NULL, NULL, 16295, 5),
(233022, NULL, 'G3DSA:3.40.250.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28463, 5),
(233023, NULL, 'G3DSA:3.40.50.11780', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233024, NULL, 'G3DSA:6.10.140.1880', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233025, NULL, 'G3DSA:2.70.98.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233026, NULL, 'G3DSA:2.170.15.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233027, NULL, 'G3DSA:1.20.5.400', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233028, NULL, 'G3DSA:3.90.1480.20', NULL, NULL, NULL, NULL, 'Glycosyl transferase family 29', NULL, NULL, 32330, 5),
(233029, NULL, 'G3DSA:3.30.70.3110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233030, NULL, 'G3DSA:3.90.1710.10', NULL, NULL, NULL, NULL, 'Enterococcus faecalis V583 domain', NULL, NULL, NULL, 5),
(233031, NULL, 'G3DSA:3.40.50.11650', NULL, NULL, NULL, NULL, '', NULL, NULL, 34615, 5),
(233032, NULL, 'G3DSA:3.10.390.20', NULL, NULL, NULL, NULL, 'Viral glycoprotein L', NULL, NULL, 28632, 5),
(233033, NULL, 'G3DSA:3.90.1720.30', NULL, NULL, NULL, NULL, 'PPPDE domains', NULL, NULL, 34697, 5),
(233034, NULL, 'G3DSA:3.30.70.1830', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233035, NULL, 'G3DSA:1.20.140.190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233036, NULL, 'G3DSA:2.60.40.1640', NULL, NULL, NULL, NULL, 'Conserved domain protein.', NULL, NULL, NULL, 5),
(233037, NULL, 'G3DSA:1.20.120.1590', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233038, NULL, 'G3DSA:3.30.300.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(233039, NULL, 'G3DSA:6.10.140.580', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233040, NULL, 'G3DSA:2.60.40.1660', NULL, NULL, NULL, NULL, '', NULL, NULL, 31877, 5),
(233041, NULL, 'G3DSA:1.10.1240.40', NULL, NULL, NULL, NULL, 'ENT domain', NULL, NULL, 28565, 5),
(233042, NULL, 'G3DSA:3.30.44.10', NULL, NULL, NULL, NULL, 'Smk Toxin, beta chain', NULL, NULL, 31092, 5),
(233043, NULL, 'G3DSA:6.10.250.760', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233044, NULL, 'G3DSA:2.40.350.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 15338, 5),
(233045, NULL, 'G3DSA:2.40.50.90', NULL, NULL, NULL, NULL, '', NULL, NULL, 31722, 5),
(233046, NULL, 'G3DSA:1.10.10.2360', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233047, NULL, 'G3DSA:3.30.910.20', NULL, NULL, NULL, NULL, 'Skp domain', NULL, NULL, 21699, 5),
(233048, NULL, 'G3DSA:1.10.357.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233049, NULL, 'G3DSA:3.90.79.10', NULL, NULL, NULL, NULL, 'Nucleoside Triphosphate Pyrophosphohydrolase', NULL, NULL, NULL, 5),
(233050, NULL, 'G3DSA:1.20.140.140', NULL, NULL, NULL, NULL, '', NULL, NULL, 33196, 5),
(233051, NULL, 'G3DSA:2.60.40.730', NULL, NULL, NULL, NULL, 'SOR catalytic domain', NULL, NULL, 32051, 5),
(233052, NULL, 'G3DSA:3.90.660.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233053, NULL, 'G3DSA:2.30.30.750', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233054, NULL, 'G3DSA:6.10.250.710', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233055, NULL, 'G3DSA:1.20.1260.120', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF2935', NULL, NULL, NULL, 5),
(233056, NULL, 'G3DSA:3.30.70.2010', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233057, NULL, 'G3DSA:1.10.1380.10', NULL, NULL, NULL, NULL, 'Neutral endopeptidase , domain2', NULL, NULL, 30739, 5),
(233058, NULL, 'G3DSA:6.10.250.1310', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233059, NULL, 'G3DSA:2.40.50.340', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233060, NULL, 'G3DSA:1.20.1130.10', NULL, NULL, NULL, NULL, 'Photosystem I PsaA/PsaB', NULL, NULL, 31547, 5),
(233061, NULL, 'G3DSA:1.10.3450.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 27042, 5),
(233062, NULL, 'G3DSA:3.30.70.1010', NULL, NULL, NULL, NULL, 'Translation elongation factor EF1B, gamma chain, conserved domain', NULL, NULL, 28320, 5),
(233063, NULL, 'G3DSA:2.40.100.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 25776, 5),
(233064, NULL, 'G3DSA:1.10.287.660', NULL, NULL, NULL, NULL, 'Helix hairpin bin', NULL, NULL, 24317, 5),
(233065, NULL, 'G3DSA:1.10.1370.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 30047, 5),
(233066, NULL, 'G3DSA:3.30.460.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233067, NULL, 'G3DSA:6.10.140.530', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233068, NULL, 'G3DSA:1.10.10.1190', NULL, NULL, NULL, NULL, 'Antirestriction protein ArdA, domain 3', NULL, NULL, 30014, 5),
(233069, NULL, 'G3DSA:1.10.10.1050', NULL, NULL, NULL, NULL, 'Dcp2, box A domain', NULL, NULL, 33352, 5),
(233070, NULL, 'G3DSA:3.30.559.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 5492, 5),
(233071, NULL, 'G3DSA:3.40.1000.50', NULL, NULL, NULL, NULL, 'Repressor of RNA polymerase III transcription  Maf1', NULL, NULL, 32406, 5),
(233072, NULL, 'G3DSA:3.40.5.120', NULL, NULL, NULL, NULL, '', NULL, NULL, 31672, 5),
(233073, NULL, 'G3DSA:3.30.70.2060', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233074, NULL, 'G3DSA:6.10.140.1090', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233075, NULL, 'G3DSA:1.10.8.260', NULL, NULL, NULL, NULL, '', NULL, NULL, 15858, 5),
(233076, NULL, 'G3DSA:2.60.40.2630', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233077, NULL, 'G3DSA:3.60.120.10', NULL, NULL, NULL, NULL, 'Anthranilate synthase', NULL, NULL, 5661, 5),
(233078, NULL, 'G3DSA:3.40.50.12700', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233079, NULL, 'G3DSA:1.10.2050.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 36959, 5),
(233080, NULL, 'G3DSA:2.60.40.680', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(233081, NULL, 'G3DSA:2.10.25.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 27087, 5),
(233082, NULL, 'G3DSA:1.10.510.10', NULL, NULL, NULL, NULL, 'Transferase(Phosphotransferase) domain 1', NULL, NULL, NULL, 5),
(233083, NULL, 'G3DSA:3.40.91.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233084, NULL, 'G3DSA:1.10.1220.150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233085, NULL, 'G3DSA:6.10.250.2530', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233086, NULL, 'G3DSA:6.10.250.180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233087, NULL, 'G3DSA:3.30.920.10', NULL, NULL, NULL, NULL, 'Frataxin/CyaY', NULL, NULL, 32790, 5),
(233088, NULL, 'G3DSA:1.20.58.1590', NULL, NULL, NULL, NULL, 'Tethering factor for nuclear proteasome Cut8/Sts1', NULL, NULL, 31305, 5),
(233089, NULL, 'G3DSA:1.10.472.60', NULL, NULL, NULL, NULL, 'putative protein disulfide isomerase domain', NULL, NULL, NULL, 5),
(233090, NULL, 'G3DSA:3.30.590.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233091, NULL, 'G3DSA:1.20.960.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233092, NULL, 'G3DSA:3.30.1490.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 7739, 5),
(233093, NULL, 'G3DSA:3.30.70.140', NULL, NULL, NULL, NULL, '', NULL, NULL, 33089, 5),
(233094, NULL, 'G3DSA:6.20.190.10', NULL, NULL, NULL, NULL, 'Nutrient germinant receptor protein C, domain 1', NULL, NULL, NULL, 5),
(233095, NULL, 'G3DSA:3.30.720.10', NULL, NULL, NULL, NULL, 'Signal recognition particle alu RNA binding heterodimer, srp9/1', NULL, NULL, 9784, 5),
(233096, NULL, 'G3DSA:3.30.420.270', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233097, NULL, 'G3DSA:6.10.250.1440', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233098, NULL, 'G3DSA:1.20.860.20', NULL, NULL, NULL, NULL, 'Photosystem I PsaK, reaction centre', NULL, NULL, 28283, 5),
(233099, NULL, 'G3DSA:3.30.1740.20', NULL, NULL, NULL, NULL, 'Ribosomal protein S26e', NULL, NULL, 27878, 5),
(233100, NULL, 'G3DSA:2.20.25.440', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233101, NULL, 'G3DSA:2.20.110.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233102, NULL, 'G3DSA:3.30.70.2770', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233103, NULL, 'G3DSA:1.10.150.170', NULL, NULL, NULL, NULL, 'Putative methyltransferase TM0872, insert domain', NULL, NULL, 16401, 5),
(233104, NULL, 'G3DSA:2.100.10.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 31706, 5),
(233105, NULL, 'G3DSA:3.30.720.50', NULL, NULL, NULL, NULL, '', NULL, NULL, 32186, 5),
(233106, NULL, 'G3DSA:6.10.140.2190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233107, NULL, 'G3DSA:6.10.20.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233108, NULL, 'G3DSA:2.60.40.760', NULL, NULL, NULL, NULL, '', NULL, NULL, 32492, 5),
(233109, NULL, 'G3DSA:3.10.450.610', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233110, NULL, 'G3DSA:2.30.30.880', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233111, NULL, 'G3DSA:3.30.1360.150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233112, NULL, 'G3DSA:2.170.120.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233113, NULL, 'G3DSA:2.20.160.10', NULL, NULL, NULL, NULL, 'titin domain like', NULL, NULL, 21064, 5),
(233114, NULL, 'G3DSA:3.40.50.11230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233115, NULL, 'G3DSA:2.60.40.4400', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233116, NULL, 'G3DSA:3.30.1360.230', NULL, NULL, NULL, NULL, '', NULL, NULL, 32951, 5),
(233117, NULL, 'G3DSA:2.60.40.3310', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233118, NULL, 'G3DSA:2.60.40.1740', NULL, NULL, NULL, NULL, 'hypothetical protein (bacova_03559)', NULL, NULL, NULL, 5),
(233119, NULL, 'G3DSA:3.40.50.10140', NULL, NULL, NULL, NULL, '', NULL, NULL, 10383, 5),
(233120, NULL, 'G3DSA:1.10.10.1840', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233121, NULL, 'G3DSA:1.20.1270.410', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233122, NULL, 'G3DSA:2.40.10.410', NULL, NULL, NULL, NULL, '', NULL, NULL, 29795, 5);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(233123, NULL, 'G3DSA:1.10.287.3440', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233124, NULL, 'G3DSA:3.40.50.11730', NULL, NULL, NULL, NULL, 'Peroxisome assembly protein 22', NULL, NULL, 32228, 5),
(233125, NULL, 'G3DSA:2.70.20.10', NULL, NULL, NULL, NULL, 'Topoisomerase I, domain 3', NULL, NULL, 17845, 5),
(233126, NULL, 'G3DSA:2.30.30.70', NULL, NULL, NULL, NULL, 'Ribosomal protein L21', NULL, NULL, 30521, 5),
(233127, NULL, 'G3DSA:1.10.357.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233128, NULL, 'G3DSA:2.60.120.1450', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233129, NULL, 'G3DSA:1.20.58.1660', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233130, NULL, 'G3DSA:1.10.10.1680', NULL, NULL, NULL, NULL, '', NULL, NULL, 30639, 5),
(233131, NULL, 'G3DSA:3.30.70.2640', NULL, NULL, NULL, NULL, 'Arenavirus RNA polymerase', NULL, NULL, NULL, 5),
(233132, NULL, 'G3DSA:1.20.58.1740', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233133, NULL, 'G3DSA:1.10.1240.10', NULL, NULL, NULL, NULL, 'Methionine synthase domain', NULL, NULL, 32861, 5),
(233134, NULL, 'G3DSA:2.40.440.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32567, 5),
(233135, NULL, 'G3DSA:6.10.250.1600', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233136, NULL, 'G3DSA:1.25.40.90', NULL, NULL, NULL, NULL, '', NULL, NULL, 8986, 5),
(233137, NULL, 'G3DSA:1.10.606.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233138, NULL, 'G3DSA:2.40.128.370', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233139, NULL, 'G3DSA:1.20.840.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 8747, 5),
(233140, NULL, 'G3DSA:4.10.1060.50', NULL, NULL, NULL, NULL, '', NULL, NULL, 27782, 5),
(233141, NULL, 'G3DSA:3.30.70.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233142, NULL, 'G3DSA:2.170.14.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33240, 5),
(233143, NULL, 'G3DSA:3.30.300.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 8124, 5),
(233144, NULL, 'G3DSA:3.40.50.12670', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233145, NULL, 'G3DSA:6.10.280.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233146, NULL, 'G3DSA:6.20.100.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233147, NULL, 'G3DSA:1.10.8.880', NULL, NULL, NULL, NULL, 'Birnavirus VP3 protein, domain 2', NULL, NULL, 35787, 5),
(233148, NULL, 'G3DSA:3.30.1490.160', NULL, NULL, NULL, NULL, 'ctc02137 like domains', NULL, NULL, NULL, 5),
(233149, NULL, 'G3DSA:1.20.5.1160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233150, NULL, 'G3DSA:6.10.20.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233151, NULL, 'G3DSA:3.20.170.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233152, NULL, 'G3DSA:1.10.10.730', NULL, NULL, NULL, NULL, '', NULL, NULL, 30356, 5),
(233153, NULL, 'G3DSA:1.20.50.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 10339, 5),
(233154, NULL, 'G3DSA:3.30.1120.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233155, NULL, 'G3DSA:6.10.140.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233156, NULL, 'G3DSA:3.30.387.10', NULL, NULL, NULL, NULL, 'Viral Envelope Glycoprotein, domain 3', NULL, NULL, 7950, 5),
(233157, NULL, 'G3DSA:4.10.960.10', NULL, NULL, NULL, NULL, 'Ribosomal protein L3, domain 3', NULL, NULL, 36093, 5),
(233158, NULL, 'G3DSA:1.10.4100.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 34893, 5),
(233159, NULL, 'G3DSA:1.10.1200.200', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF3227', NULL, NULL, 34196, 5),
(233160, NULL, 'G3DSA:6.10.140.400', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233161, NULL, 'G3DSA:1.20.1400.10', NULL, NULL, NULL, NULL, 'Attractin', NULL, NULL, 29640, 5),
(233162, NULL, 'G3DSA:6.20.160.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233163, NULL, 'G3DSA:3.30.160.490', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233164, NULL, 'G3DSA:3.30.70.3490', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233165, NULL, 'G3DSA:3.30.450.350', NULL, NULL, NULL, NULL, 'CHASE domain', NULL, NULL, 33594, 5),
(233166, NULL, 'G3DSA:1.20.58.2050', NULL, NULL, NULL, NULL, '', NULL, NULL, 31457, 5);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(233167, NULL, 'G3DSA:3.30.110.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 28569, 5),
(233168, NULL, 'G3DSA:6.10.250.2370', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233169, NULL, 'G3DSA:6.10.250.1980', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233170, NULL, 'G3DSA:1.20.58.480', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233171, NULL, 'G3DSA:1.20.930.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233172, NULL, 'G3DSA:2.40.128.530', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233173, NULL, 'G3DSA:6.20.120.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233174, NULL, 'G3DSA:3.10.430.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233175, NULL, 'G3DSA:3.10.180.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233176, NULL, 'G3DSA:6.10.140.1120', NULL, NULL, NULL, NULL, '', NULL, NULL, 34340, 5),
(233177, NULL, 'G3DSA:1.10.10.1340', NULL, NULL, NULL, NULL, 'Mediator of RNA polymerase II, submodule Med31 (Soh1)', NULL, NULL, 31082, 5),
(233178, NULL, 'G3DSA:1.10.20.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 29686, 5),
(233179, NULL, 'G3DSA:3.15.20.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233180, NULL, 'G3DSA:2.10.70.40', NULL, NULL, NULL, NULL, 'peptidoglycan hydrolase', NULL, NULL, NULL, 5),
(233181, NULL, 'G3DSA:1.20.225.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 6061, 5),
(233182, NULL, 'G3DSA:6.10.250.2900', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233183, NULL, 'G3DSA:1.10.10.1260', NULL, NULL, NULL, NULL, 'Envelope glycoprotein gp160, DUF2291, helical domain', NULL, NULL, NULL, 5),
(233184, NULL, 'G3DSA:1.20.85.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31567, 5),
(233185, NULL, 'G3DSA:3.55.50.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233186, NULL, 'G3DSA:3.30.457.50', NULL, NULL, NULL, NULL, 'Chromosome segregation protein Spc25', NULL, NULL, NULL, 5),
(233187, NULL, 'G3DSA:1.10.287.580', NULL, NULL, NULL, NULL, 'Helix hairpin bin', NULL, NULL, NULL, 5),
(233188, NULL, 'G3DSA:1.10.472.100', NULL, NULL, NULL, NULL, 'Presenilin', NULL, NULL, 37424, 5),
(233189, NULL, 'G3DSA:1.10.287.2210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233190, NULL, 'G3DSA:2.40.128.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233191, NULL, 'G3DSA:1.10.1790.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233192, NULL, 'G3DSA:3.30.980.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233193, NULL, 'G3DSA:3.30.10.10', NULL, NULL, NULL, NULL, 'Trypsin Inhibitor V, subunit A', NULL, NULL, NULL, 5),
(233194, NULL, 'G3DSA:6.10.60.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233195, NULL, 'G3DSA:2.20.50.20', NULL, NULL, NULL, NULL, 'Lipovitellin. Chain A, domain 3', NULL, NULL, 12921, 5),
(233196, NULL, 'G3DSA:1.10.10.1470', NULL, NULL, NULL, NULL, '', NULL, NULL, 36331, 5),
(233197, NULL, 'G3DSA:2.30.140.10', NULL, NULL, NULL, NULL, 'Spermidine synthase, tetramerisation domain', NULL, NULL, 29581, 5),
(233198, NULL, 'G3DSA:1.10.286.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233199, NULL, 'G3DSA:3.10.450.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233200, NULL, 'G3DSA:2.60.40.4030', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233201, NULL, 'G3DSA:3.40.50.10970', NULL, NULL, NULL, NULL, '', NULL, NULL, 27438, 5),
(233202, NULL, 'G3DSA:2.10.110.10', NULL, NULL, NULL, NULL, 'Cysteine Rich Protein', NULL, NULL, NULL, 5),
(233203, NULL, 'G3DSA:3.30.30.120', NULL, NULL, NULL, NULL, '', NULL, NULL, 31445, 5),
(233204, NULL, 'G3DSA:6.10.280.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 37074, 5),
(233205, NULL, 'G3DSA:3.30.1590.10', NULL, NULL, NULL, NULL, 'Maltooligosyl trehalose synthase, domain 2', NULL, NULL, NULL, 5),
(233206, NULL, 'G3DSA:3.30.1360.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233207, NULL, 'G3DSA:1.20.1270.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 10889, 5),
(233208, NULL, 'G3DSA:2.60.450.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233209, NULL, 'G3DSA:1.20.120.620', NULL, NULL, NULL, NULL, 'Backbone structure of the membrane domain of e. Coli histidine kinase receptor kdpd,', NULL, NULL, 28638, 5);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(233210, NULL, 'G3DSA:3.30.700.20', NULL, NULL, NULL, NULL, 'Hypothetical protein ph0010; domain 1', NULL, NULL, 26870, 5),
(233211, NULL, 'G3DSA:1.10.1050.10', NULL, NULL, NULL, NULL, 'Ribosomal Protein S4 Delta 41; Chain A, domain 1', NULL, NULL, NULL, 5),
(233212, NULL, 'G3DSA:3.30.190.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 29903, 5),
(233213, NULL, 'G3DSA:1.10.10.2150', NULL, NULL, NULL, NULL, '', NULL, NULL, 30386, 5),
(233214, NULL, 'G3DSA:6.10.140.240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233215, NULL, 'G3DSA:6.10.250.550', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233216, NULL, 'G3DSA:3.30.428.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 18818, 5),
(233217, NULL, 'G3DSA:4.10.70.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233218, NULL, 'G3DSA:2.40.160.160', NULL, NULL, NULL, NULL, '', NULL, NULL, 29684, 5),
(233219, NULL, 'G3DSA:1.10.10.490', NULL, NULL, NULL, NULL, '', NULL, NULL, 28836, 5),
(233220, NULL, 'G3DSA:3.10.450.450', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233221, NULL, 'G3DSA:1.10.287.3280', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233222, NULL, 'G3DSA:3.30.420.430', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233223, NULL, 'G3DSA:1.10.4170.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32500, 5),
(233224, NULL, 'G3DSA:1.10.10.41', NULL, NULL, NULL, NULL, '', NULL, NULL, 14301, 5),
(233225, NULL, 'G3DSA:2.70.50.40', NULL, NULL, NULL, NULL, 'GMP phosphodiesterase, delta subunit', NULL, NULL, 29309, 5),
(233226, NULL, 'G3DSA:1.10.10.2100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233227, NULL, 'G3DSA:1.10.8.1240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233228, NULL, 'G3DSA:1.20.58.1950', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233229, NULL, 'G3DSA:1.20.120.1330', NULL, NULL, NULL, NULL, '', NULL, NULL, 34496, 5),
(233230, NULL, 'G3DSA:1.10.287.1110', NULL, NULL, NULL, NULL, 'Tubulin, GTPase', NULL, NULL, NULL, 5),
(233231, NULL, 'G3DSA:1.10.8.1290', NULL, NULL, NULL, NULL, '', NULL, NULL, 35118, 5),
(233232, NULL, 'G3DSA:2.60.120.510', NULL, NULL, NULL, NULL, 'Mitogen Ypm', NULL, NULL, 31216, 5),
(233233, NULL, 'G3DSA:3.30.428.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 34834, 5),
(233234, NULL, 'G3DSA:3.40.50.11440', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233235, NULL, 'G3DSA:2.60.120.260', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233236, NULL, 'G3DSA:1.20.120.970', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233237, NULL, 'G3DSA:3.40.462.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 11886, 5),
(233238, NULL, 'G3DSA:3.30.230.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233239, NULL, 'G3DSA:2.60.120.1080', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233240, NULL, 'G3DSA:2.70.50.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233241, NULL, 'G3DSA:2.30.110.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 28284, 5),
(233242, NULL, 'G3DSA:1.20.5.1940', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233243, NULL, 'G3DSA:4.10.450.10', NULL, NULL, NULL, NULL, 'Glucose Oxidase, domain 2', NULL, NULL, 23041, 5),
(233244, NULL, 'G3DSA:3.40.1170.40', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF3203', NULL, NULL, 31579, 5),
(233245, NULL, 'G3DSA:3.30.160.780', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233246, NULL, 'G3DSA:6.10.250.3000', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233247, NULL, 'G3DSA:3.10.20.560', NULL, NULL, NULL, NULL, 'Phenol hydroxylase', NULL, NULL, 36966, 5),
(233248, NULL, 'G3DSA:3.40.50.11070', NULL, NULL, NULL, NULL, '', NULL, NULL, 33324, 5),
(233249, NULL, 'G3DSA:3.10.380.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 29593, 5),
(233250, NULL, 'G3DSA:3.30.70.3320', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233251, NULL, 'G3DSA:4.10.260.20', NULL, NULL, NULL, NULL, 'Iron hydrogenase, small subunit', NULL, NULL, 31970, 5),
(233252, NULL, 'G3DSA:3.30.160.240', NULL, NULL, NULL, NULL, 'Rv1738', NULL, NULL, 30804, 5),
(233253, NULL, 'G3DSA:1.20.1300.20', NULL, NULL, NULL, NULL, 'Peptidase C65 Otubain, subdomain 2', NULL, NULL, 37544, 5);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(233254, NULL, 'G3DSA:1.10.3660.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233255, NULL, 'G3DSA:1.10.443.30', NULL, NULL, NULL, NULL, 'Telomere resolvase', NULL, NULL, 31119, 5),
(233256, NULL, 'G3DSA:1.20.58.1330', NULL, NULL, NULL, NULL, 'Plasmodium falciparum UIS3 membrane protein', NULL, NULL, 29523, 5),
(233257, NULL, 'G3DSA:4.10.40.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233258, NULL, 'G3DSA:1.20.5.1610', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233259, NULL, 'G3DSA:1.10.287.320', NULL, NULL, NULL, NULL, 'Viral phosphoprotein oligmorisation site domain', NULL, NULL, 37281, 5),
(233260, NULL, 'G3DSA:2.60.120.480', NULL, NULL, NULL, NULL, 'Ureidoglycolate hydrolase', NULL, NULL, 12335, 5),
(233261, NULL, 'G3DSA:3.40.50.11020', NULL, NULL, NULL, NULL, '', NULL, NULL, 34779, 5),
(233262, NULL, 'G3DSA:1.10.238.20', NULL, NULL, NULL, NULL, 'Pheromone/general odorant binding protein domain', NULL, NULL, 31699, 5),
(233263, NULL, 'G3DSA:3.40.50.11990', NULL, NULL, NULL, NULL, '', NULL, NULL, 30122, 5),
(233264, NULL, 'G3DSA:3.90.930.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233265, NULL, 'G3DSA:3.90.870.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 32963, 5),
(233266, NULL, 'G3DSA:1.10.8.470', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233267, NULL, 'G3DSA:2.60.200.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233268, NULL, 'G3DSA:2.60.260.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233269, NULL, 'G3DSA:6.10.250.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233270, NULL, 'G3DSA:2.60.120.750', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF3845', NULL, NULL, NULL, 5),
(233271, NULL, 'G3DSA:3.20.20.510', NULL, NULL, NULL, NULL, 'Uncharacterised protein PF12979, DUF3863', NULL, NULL, NULL, 5),
(233272, NULL, 'G3DSA:3.30.2320.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233273, NULL, 'G3DSA:2.60.40.2840', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233274, NULL, 'G3DSA:6.10.250.1150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233275, NULL, 'G3DSA:1.20.58.1790', NULL, NULL, NULL, NULL, 'JHP933, helical tail domain', NULL, NULL, NULL, 5),
(233276, NULL, 'G3DSA:6.10.250.500', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233277, NULL, 'G3DSA:1.10.8.840', NULL, NULL, NULL, NULL, '', NULL, NULL, 34566, 5),
(233278, NULL, 'G3DSA:3.90.550.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233279, NULL, 'G3DSA:3.10.320.10', NULL, NULL, NULL, NULL, 'Class II Histocompatibility Antigen, M Beta Chain; Chain B, domain 1', NULL, NULL, 12093, 5),
(233280, NULL, 'G3DSA:2.60.450.10', NULL, NULL, NULL, NULL, 'Lipopolysaccharide (LPS) transport protein A like domain', NULL, NULL, NULL, 5),
(233281, NULL, 'G3DSA:3.90.199.10', NULL, NULL, NULL, NULL, 'Topoisomerase II, domain 5', NULL, NULL, 7559, 5),
(233282, NULL, 'G3DSA:1.20.140.80', NULL, NULL, NULL, NULL, 'Transcription factor DP', NULL, NULL, 30450, 5),
(233283, NULL, 'G3DSA:2.60.40.3770', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233284, NULL, 'G3DSA:3.30.70.970', NULL, NULL, NULL, NULL, '', NULL, NULL, 29859, 5),
(233285, NULL, 'G3DSA:3.20.20.190', NULL, NULL, NULL, NULL, 'Phosphatidylinositol (PI) phosphodiesterase', NULL, NULL, 19479, 5),
(233286, NULL, 'G3DSA:3.90.1100.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233287, NULL, 'G3DSA:1.10.3090.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233288, NULL, 'G3DSA:2.40.460.10', NULL, NULL, NULL, NULL, 'Biotin dependent carboxylase carboxyltransferase', NULL, NULL, NULL, 5),
(233289, NULL, 'G3DSA:1.20.58.930', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233290, NULL, 'G3DSA:2.60.200.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233291, NULL, 'G3DSA:6.10.250.2080', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233292, NULL, 'G3DSA:1.10.3930.10', NULL, NULL, NULL, NULL, 'Arginine deiminase', NULL, NULL, NULL, 5),
(233293, NULL, 'G3DSA:1.20.1340.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233294, NULL, 'G3DSA:1.10.150.330', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(233295, NULL, 'G3DSA:3.30.1300.90', NULL, NULL, NULL, NULL, '', NULL, NULL, 30544, 5),
(233296, NULL, 'G3DSA:3.40.50.10470', NULL, NULL, NULL, NULL, '', NULL, NULL, 37010, 5),
(233297, NULL, 'G3DSA:1.10.472.40', NULL, NULL, NULL, NULL, 'Hypothetical protein mg237 homolog; domain 3', NULL, NULL, NULL, 5),
(233298, NULL, 'G3DSA:6.10.140.790', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233299, NULL, 'G3DSA:3.30.1490.130', NULL, NULL, NULL, NULL, '', NULL, NULL, 15633, 5),
(233300, NULL, 'G3DSA:2.40.30.250', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233301, NULL, 'G3DSA:1.10.287.670', NULL, NULL, NULL, NULL, 'Phycobilisome degradation protein NblA', NULL, NULL, 31987, 5),
(233302, NULL, 'G3DSA:2.30.300.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 36872, 5),
(233303, NULL, 'G3DSA:3.30.70.920', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233304, NULL, 'G3DSA:1.10.4040.10', NULL, NULL, NULL, NULL, 'Penicillinase repressor domain', NULL, NULL, NULL, 5),
(233305, NULL, 'G3DSA:1.10.10.1890', NULL, NULL, NULL, NULL, '', NULL, NULL, 30179, 5),
(233306, NULL, 'G3DSA:3.40.50.11280', NULL, NULL, NULL, NULL, '', NULL, NULL, 37021, 5),
(233307, NULL, 'G3DSA:2.60.40.3360', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233308, NULL, 'G3DSA:6.10.180.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233309, NULL, 'G3DSA:3.20.100.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28184, 5),
(233310, NULL, 'G3DSA:3.40.1310.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233311, NULL, 'G3DSA:2.40.50.1010', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233312, NULL, 'G3DSA:3.30.720.150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233313, NULL, 'G3DSA:1.10.4110.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 8434, 5),
(233314, NULL, 'G3DSA:1.20.1280.200', NULL, NULL, NULL, NULL, '', NULL, NULL, 37587, 5),
(233315, NULL, 'G3DSA:1.10.3650.10', NULL, NULL, NULL, NULL, 'nitrate reductase domain like', NULL, NULL, 27059, 5),
(233316, NULL, 'G3DSA:4.10.20.10', NULL, NULL, NULL, NULL, 'Tat domain', NULL, NULL, 28331, 5),
(233317, NULL, 'G3DSA:3.30.160.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233318, NULL, 'G3DSA:3.90.1360.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29721, 5),
(233319, NULL, 'G3DSA:3.30.70.2870', NULL, NULL, NULL, NULL, 'Mastadenovirus E4 ORF3', NULL, NULL, 32687, 5),
(233320, NULL, 'G3DSA:6.20.370.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233321, NULL, 'G3DSA:3.10.310.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233322, NULL, 'G3DSA:1.20.120.310', NULL, NULL, NULL, NULL, 'ERV/ALR sulfhydryl oxidase domain', NULL, NULL, 27162, 5),
(233323, NULL, 'G3DSA:1.20.1440.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233324, NULL, 'G3DSA:1.20.5.950', NULL, NULL, NULL, NULL, '', NULL, NULL, 29702, 5),
(233325, NULL, 'G3DSA:3.80.30.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233326, NULL, 'G3DSA:1.10.1820.10', NULL, NULL, NULL, NULL, 'protein kinase ck2 holoenzyme, chain C, domain 1', NULL, NULL, 11058, 5),
(233327, NULL, 'G3DSA:3.30.1330.70', NULL, NULL, NULL, NULL, 'Holliday junction resolvase RusA', NULL, NULL, 28364, 5),
(233328, NULL, 'G3DSA:3.40.91.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233329, NULL, 'G3DSA:2.60.40.350', NULL, NULL, NULL, NULL, '', NULL, NULL, 4844, 5),
(233330, NULL, 'G3DSA:3.40.10.10', NULL, NULL, NULL, NULL, 'DNA Methylphosphotriester Repair Domain', NULL, NULL, 20036, 5),
(233331, NULL, 'G3DSA:3.10.550.10', NULL, NULL, NULL, NULL, 'Hypothetical protein Atu2299', NULL, NULL, 20861, 5),
(233332, NULL, 'G3DSA:6.10.250.2580', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233333, NULL, 'G3DSA:6.10.140.1590', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233334, NULL, 'G3DSA:2.30.340.10', NULL, NULL, NULL, NULL, 'PAZ domain superfamily', NULL, NULL, NULL, 5),
(233335, NULL, 'G3DSA:1.10.10.940', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233336, NULL, 'G3DSA:1.10.3380.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233337, NULL, 'G3DSA:2.60.120.1400', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(233338, NULL, 'G3DSA:3.60.90.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233339, NULL, 'G3DSA:3.30.700.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233340, NULL, 'G3DSA:4.10.410.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233341, NULL, 'G3DSA:1.20.5.240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233342, NULL, 'G3DSA:2.60.40.3100', NULL, NULL, NULL, NULL, '', NULL, NULL, 32028, 5),
(233343, NULL, 'G3DSA:3.90.1200.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233344, NULL, 'G3DSA:1.10.10.1670', NULL, NULL, NULL, NULL, 'HetR, flap domain', NULL, NULL, 30654, 5),
(233345, NULL, 'G3DSA:1.10.3700.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 15266, 5),
(233346, NULL, 'G3DSA:1.10.10.1630', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233347, NULL, 'G3DSA:1.10.3510.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 17266, 5),
(233348, NULL, 'G3DSA:2.60.40.1820', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233349, NULL, 'G3DSA:6.10.280.150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233350, NULL, 'G3DSA:2.40.10.200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233351, NULL, 'G3DSA:2.40.30.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233352, NULL, 'G3DSA:1.10.287.1080', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233353, NULL, 'G3DSA:6.10.180.10', NULL, NULL, NULL, NULL, 'Antitoxin ParD', NULL, NULL, 31102, 5),
(233354, NULL, 'G3DSA:6.10.250.2120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233355, NULL, 'G3DSA:1.20.58.890', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233356, NULL, 'G3DSA:3.30.300.330', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233357, NULL, 'G3DSA:3.30.60.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233358, NULL, 'G3DSA:3.90.1150.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233359, NULL, 'G3DSA:3.40.50.1780', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233360, NULL, 'G3DSA:3.30.2310.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 27470, 5),
(233361, NULL, 'G3DSA:3.30.1240.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 34659, 5),
(233362, NULL, 'G3DSA:3.30.450.360', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233363, NULL, 'G3DSA:4.10.140.10', NULL, NULL, NULL, NULL, 'Thrombin light chain domain', NULL, NULL, 28361, 5),
(233364, NULL, 'G3DSA:1.20.1270.460', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233365, NULL, 'G3DSA:3.30.160.320', NULL, NULL, NULL, NULL, '', NULL, NULL, 27571, 5),
(233366, NULL, 'G3DSA:3.30.390.70', NULL, NULL, NULL, NULL, 'Salmonella typhimurium protein', NULL, NULL, NULL, 5),
(233367, NULL, 'G3DSA:1.10.3800.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233368, NULL, 'G3DSA:1.10.1370.10', NULL, NULL, NULL, NULL, 'Neurolysin, domain 3', NULL, NULL, 12408, 5),
(233369, NULL, 'G3DSA:2.40.10.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 34873, 5),
(233370, NULL, 'G3DSA:3.10.20.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233371, NULL, 'G3DSA:1.20.1260.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 32888, 5),
(233372, NULL, 'G3DSA:4.10.1250.10', NULL, NULL, NULL, NULL, 'Aminomethyltransferase  fragment', NULL, NULL, NULL, 5),
(233373, NULL, 'G3DSA:3.30.1050.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233374, NULL, 'G3DSA:6.20.350.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233375, NULL, 'G3DSA:1.20.1440.300', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233376, NULL, 'G3DSA:1.10.287.2920', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233377, NULL, 'G3DSA:2.60.40.1200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233378, NULL, 'G3DSA:4.10.220.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 6800, 5),
(233379, NULL, 'G3DSA:1.20.58.180', NULL, NULL, NULL, NULL, 'Class II aaRS and biotin synthetases; domain 2', NULL, NULL, NULL, 5),
(233380, NULL, 'G3DSA:1.10.357.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233381, NULL, 'G3DSA:1.20.80.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233382, NULL, 'G3DSA:3.30.2000.40', NULL, NULL, NULL, NULL, 'Myoviridae tail sheath stabiliser', NULL, NULL, 27649, 5);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(233383, NULL, 'G3DSA:6.10.20.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233384, NULL, 'G3DSA:2.60.40.1370', NULL, NULL, NULL, NULL, 'Bacterial adhesin receptor binding domain', NULL, NULL, 32129, 5),
(233385, NULL, 'G3DSA:2.20.25.650', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233386, NULL, 'G3DSA:3.30.1690.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233387, NULL, 'G3DSA:6.10.250.1650', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233388, NULL, 'G3DSA:1.10.150.880', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233389, NULL, 'G3DSA:3.20.20.80', NULL, NULL, NULL, NULL, 'Glycosidases', NULL, NULL, NULL, 5),
(233390, NULL, 'G3DSA:2.40.128.320', NULL, NULL, NULL, NULL, '', NULL, NULL, 35863, 5),
(233391, NULL, 'G3DSA:1.20.1050.70', NULL, NULL, NULL, NULL, 'Large T antigen, SV40, domain 3', NULL, NULL, NULL, 5),
(233392, NULL, 'G3DSA:3.30.1780.10', NULL, NULL, NULL, NULL, 'ornithine cyclodeaminase, domain 1', NULL, NULL, 16196, 5),
(233393, NULL, 'G3DSA:2.130.10.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 8126, 5),
(233394, NULL, 'G3DSA:6.10.250.1770', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233395, NULL, 'G3DSA:3.30.70.2560', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233396, NULL, 'G3DSA:6.10.250.2740', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233397, NULL, 'G3DSA:1.20.58.430', NULL, NULL, NULL, NULL, '', NULL, NULL, 5364, 5),
(233398, NULL, 'G3DSA:2.60.11.10', NULL, NULL, NULL, NULL, 'Cytochrome c oxidase, subunit Vb', NULL, NULL, 28869, 5),
(233399, NULL, 'G3DSA:1.10.132.60', NULL, NULL, NULL, NULL, '', NULL, NULL, 30142, 5),
(233400, NULL, 'G3DSA:6.10.140.1330', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233401, NULL, 'G3DSA:1.20.120.1880', NULL, NULL, NULL, NULL, '', NULL, NULL, 33629, 5),
(233402, NULL, 'G3DSA:3.40.50.12140', NULL, NULL, NULL, NULL, 'Domain of unknown function DUF4159', NULL, NULL, NULL, 5),
(233403, NULL, 'G3DSA:1.20.990.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 15753, 5),
(233404, NULL, 'G3DSA:3.30.1120.150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233405, NULL, 'G3DSA:3.40.50.10920', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233406, NULL, 'G3DSA:1.10.287.1100', NULL, NULL, NULL, NULL, 'Sporulation inhibitor A', NULL, NULL, 28582, 5),
(233407, NULL, 'G3DSA:3.90.1070.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233408, NULL, 'G3DSA:3.30.160.280', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233409, NULL, 'G3DSA:2.60.40.2180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233410, NULL, 'G3DSA:1.10.287.950', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233411, NULL, 'G3DSA:1.20.58.240', NULL, NULL, NULL, NULL, 'STAT; domain 1', NULL, NULL, NULL, 5),
(233412, NULL, 'G3DSA:2.30.29.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233413, NULL, 'G3DSA:2.60.40.2390', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233414, NULL, 'G3DSA:3.30.56.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233415, NULL, 'G3DSA:3.30.70.3530', NULL, NULL, NULL, NULL, 'GCM motif', NULL, NULL, 36214, 5),
(233416, NULL, 'G3DSA:3.50.14.10', NULL, NULL, NULL, NULL, 'Replication terminator Tus, domain 1 superfamily/Replication terminator Tus', NULL, NULL, 32003, 5),
(233417, NULL, 'G3DSA:1.20.120.700', NULL, NULL, NULL, NULL, 'nitrate reductase, subunit delta (NarJ)', NULL, NULL, NULL, 5),
(233418, NULL, 'G3DSA:6.20.50.180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233419, NULL, 'G3DSA:1.20.58.1290', NULL, NULL, NULL, NULL, '', NULL, NULL, 35238, 5),
(233420, NULL, 'G3DSA:1.20.5.510', NULL, NULL, NULL, NULL, 'Single helix bin', NULL, NULL, NULL, 5),
(233421, NULL, 'G3DSA:2.60.40.2130', NULL, NULL, NULL, NULL, '', NULL, NULL, 32217, 5),
(233422, NULL, 'G3DSA:2.40.30.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 16414, 5),
(233423, NULL, 'G3DSA:1.10.1900.20', NULL, NULL, NULL, NULL, 'Ribosomal protein L20', NULL, NULL, 27528, 5),
(233424, NULL, 'G3DSA:3.90.1150.190', NULL, NULL, NULL, NULL, 'SLED domain', NULL, NULL, 33001, 5),
(233425, NULL, 'G3DSA:1.20.5.630', NULL, NULL, NULL, NULL, 'Integrin beta subunit, cytoplasmic domain', NULL, NULL, NULL, 5);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(233426, NULL, 'G3DSA:1.20.1270.250', NULL, NULL, NULL, NULL, '', NULL, NULL, 37655, 5),
(233427, NULL, 'G3DSA:3.10.20.870', NULL, NULL, NULL, NULL, '', NULL, NULL, 31667, 5),
(233428, NULL, 'G3DSA:2.60.120.1290', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233429, NULL, 'G3DSA:3.90.1010.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233430, NULL, 'G3DSA:3.30.530.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233431, NULL, 'G3DSA:6.20.50.130', NULL, NULL, NULL, NULL, '', NULL, NULL, 29604, 5),
(233432, NULL, 'G3DSA:3.10.500.10', NULL, NULL, NULL, NULL, 'Staphopain proregion domain', NULL, NULL, 29502, 5),
(233433, NULL, 'G3DSA:3.30.412.10', NULL, NULL, NULL, NULL, 'Proaerolysin, chain A, domain 2', NULL, NULL, NULL, 5),
(233434, NULL, 'G3DSA:2.30.40.10', NULL, NULL, NULL, NULL, 'Urease, subunit C, domain 1', NULL, NULL, 9044, 5),
(233435, NULL, 'G3DSA:1.10.8.700', NULL, NULL, NULL, NULL, 'Bacteriophage clamp loader A subunit, A domain', NULL, NULL, NULL, 5),
(233436, NULL, 'G3DSA:1.10.287.3020', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233437, NULL, 'G3DSA:3.10.20.820', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233438, NULL, 'G3DSA:1.20.58.1240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233439, NULL, 'G3DSA:2.140.10.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 1760, 5),
(233440, NULL, 'G3DSA:6.10.250.1810', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233441, NULL, 'G3DSA:1.25.40.1050', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233442, NULL, 'G3DSA:1.10.132.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 7210, 5),
(233443, NULL, 'G3DSA:2.40.30.80', NULL, NULL, NULL, NULL, '', NULL, NULL, 20582, 5),
(233444, NULL, 'G3DSA:3.30.230.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233445, NULL, 'G3DSA:2.160.10.20', NULL, NULL, NULL, NULL, 'Insect antifreeze protein', NULL, NULL, NULL, 5),
(233446, NULL, 'G3DSA:1.10.8.1080', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233447, NULL, 'G3DSA:3.40.50.10300', NULL, NULL, NULL, NULL, '', NULL, NULL, 21783, 5),
(233448, NULL, 'G3DSA:3.30.1120.30', NULL, NULL, NULL, NULL, 'POLO box domain', NULL, NULL, 30824, 5),
(233449, NULL, 'G3DSA:1.25.40.1000', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233450, NULL, 'G3DSA:6.10.250.1860', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233451, NULL, 'G3DSA:1.10.3480.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233452, NULL, 'G3DSA:1.10.8.590', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233453, NULL, 'G3DSA:2.60.120.1240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233454, NULL, 'G3DSA:2.60.40.4290', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233455, NULL, 'G3DSA:3.30.40.210', NULL, NULL, NULL, NULL, '', NULL, NULL, 31840, 5),
(233456, NULL, 'G3DSA:3.30.70.2890', NULL, NULL, NULL, NULL, 'XS domain', NULL, NULL, 32327, 5),
(233457, NULL, 'G3DSA:2.20.90.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 27387, 5),
(233458, NULL, 'G3DSA:1.20.58.2220', NULL, NULL, NULL, NULL, 'Formin, FH2 domain', NULL, NULL, 35372, 5),
(233459, NULL, 'G3DSA:2.60.40.1110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233460, NULL, 'G3DSA:3.40.190.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233461, NULL, 'G3DSA:3.90.1740.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233462, NULL, 'G3DSA:6.20.240.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233463, NULL, 'G3DSA:3.90.70.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233464, NULL, 'G3DSA:3.90.1170.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233465, NULL, 'G3DSA:2.60.40.3980', NULL, NULL, NULL, NULL, '', NULL, NULL, 36751, 5),
(233466, NULL, 'G3DSA:3.90.1260.10', NULL, NULL, NULL, NULL, 'Argininosuccinate synthetase, chain A, domain 2', NULL, NULL, 12370, 5),
(233467, NULL, 'G3DSA:2.160.20.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233468, NULL, 'G3DSA:3.40.50.10260', NULL, NULL, NULL, NULL, '', NULL, NULL, 28663, 5),
(233469, NULL, 'G3DSA:2.20.170.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 18900, 5);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(233470, NULL, 'G3DSA:2.30.30.380', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233471, NULL, 'G3DSA:1.20.58.2170', NULL, NULL, NULL, NULL, '', NULL, NULL, 37550, 5),
(233472, NULL, 'G3DSA:2.130.10.150', NULL, NULL, NULL, NULL, 'Peptidase/esterase ''gauge'' domain', NULL, NULL, NULL, 5),
(233473, NULL, 'G3DSA:3.30.2350.10', NULL, NULL, NULL, NULL, 'Pseudouridine synthase', NULL, NULL, NULL, 5),
(233474, NULL, 'G3DSA:3.90.1170.50', NULL, NULL, NULL, NULL, 'Aldehyde oxidase/xanthine dehydrogenase, a/b hammerhead', NULL, NULL, NULL, 5),
(233475, NULL, 'G3DSA:2.30.31.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233476, NULL, 'G3DSA:6.10.250.390', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233477, NULL, 'G3DSA:3.90.105.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 34586, 5),
(233478, NULL, 'G3DSA:1.20.5.2700', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233479, NULL, 'G3DSA:1.10.287.1170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233480, NULL, 'G3DSA:6.10.140.900', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233481, NULL, 'G3DSA:2.60.40.3930', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233482, NULL, 'G3DSA:1.10.8.680', NULL, NULL, NULL, NULL, '', NULL, NULL, 35574, 5),
(233483, NULL, 'G3DSA:6.10.250.340', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233484, NULL, 'G3DSA:3.40.1500.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233485, NULL, 'G3DSA:1.10.1740.170', NULL, NULL, NULL, NULL, 'Erythrocyte binding antigen 175 region VI', NULL, NULL, 36068, 5),
(233486, NULL, 'G3DSA:3.90.1230.10', NULL, NULL, NULL, NULL, 'Nitric Oxide Synthase; Chain A, domain 3', NULL, NULL, 36693, 5),
(233487, NULL, 'G3DSA:3.90.70.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233488, NULL, 'G3DSA:1.10.150.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233489, NULL, 'G3DSA:1.10.8.1120', NULL, NULL, NULL, NULL, '', NULL, NULL, 32275, 5),
(233490, NULL, 'G3DSA:3.90.70.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 32926, 5),
(233491, NULL, 'G3DSA:3.30.40.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233492, NULL, 'G3DSA:6.10.140.950', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233493, NULL, 'G3DSA:1.10.196.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 18814, 5),
(233494, NULL, 'G3DSA:3.40.50.300', NULL, NULL, NULL, NULL, '', NULL, NULL, 23652, 5),
(233495, NULL, 'G3DSA:6.10.250.2250', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233496, NULL, 'G3DSA:1.10.10.530', NULL, NULL, NULL, NULL, '', NULL, NULL, 31504, 5),
(233497, NULL, 'G3DSA:2.40.30.180', NULL, NULL, NULL, NULL, '', NULL, NULL, 33652, 5),
(233498, NULL, 'G3DSA:3.10.450.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233499, NULL, 'G3DSA:2.60.120.390', NULL, NULL, NULL, NULL, 'Olfactory marker', NULL, NULL, 32145, 5),
(233500, NULL, 'G3DSA:1.10.3610.10', NULL, NULL, NULL, NULL, 'Nucleoprotein', NULL, NULL, 15537, 5),
(233501, NULL, 'G3DSA:3.30.60.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 33896, 5),
(233502, NULL, 'G3DSA:1.10.860.10', NULL, NULL, NULL, NULL, 'DNAb Helicase; Chain A', NULL, NULL, 11104, 5),
(233503, NULL, 'G3DSA:2.60.40.4040', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233504, NULL, 'G3DSA:2.40.30.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 33412, 5),
(233505, NULL, 'G3DSA:6.20.50.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233506, NULL, 'G3DSA:3.40.1190.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 24324, 5),
(233507, NULL, 'G3DSA:3.90.1470.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233508, NULL, 'G3DSA:3.40.50.11170', NULL, NULL, NULL, NULL, 'Uncharacterised protein PF08960, DUF1874', NULL, NULL, 32803, 5),
(233509, NULL, 'G3DSA:3.10.450.410', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233510, NULL, 'G3DSA:1.10.8.890', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5),
(233511, NULL, 'G3DSA:3.30.1330.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 28024, 5),
(233512, NULL, 'G3DSA:1.20.120.1210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233513, NULL, 'G3DSA:1.10.3500.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 15838, 5);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(233514, NULL, 'G3DSA:3.30.870.10', NULL, NULL, NULL, NULL, 'Endonuclease Chain A', NULL, NULL, NULL, 5),
(233515, NULL, 'G3DSA:3.30.1360.80', NULL, NULL, NULL, NULL, '', NULL, NULL, 28342, 5),
(233516, NULL, 'G3DSA:3.30.500.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233517, NULL, 'G3DSA:2.20.25.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233518, NULL, 'G3DSA:1.10.1240.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233519, NULL, 'G3DSA:3.40.1170.10', NULL, NULL, NULL, NULL, 'DNA repair protein MutS, domain I', NULL, NULL, 11144, 5),
(233520, NULL, 'G3DSA:3.10.670.10', NULL, NULL, NULL, NULL, 'Secreted effector protein ssei.', NULL, NULL, NULL, 5),
(233521, NULL, 'G3DSA:2.60.40.3550', NULL, NULL, NULL, NULL, 'Domain of unknown function DUF4466', NULL, NULL, NULL, 5),
(233522, NULL, 'G3DSA:1.20.5.2050', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233523, NULL, 'G3DSA:6.10.250.1190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233524, NULL, 'G3DSA:3.30.160.820', NULL, NULL, NULL, NULL, '', NULL, NULL, 35950, 5),
(233525, NULL, 'G3DSA:3.40.50.10850', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233526, NULL, 'G3DSA:1.20.1260.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233527, NULL, 'G3DSA:2.60.40.2880', NULL, NULL, NULL, NULL, '', NULL, NULL, 32583, 5),
(233528, NULL, 'G3DSA:3.30.70.850', NULL, NULL, NULL, NULL, '', NULL, NULL, 32435, 5),
(233529, NULL, 'G3DSA:2.60.40.3490', NULL, NULL, NULL, NULL, '', NULL, NULL, 32036, 5),
(233530, NULL, 'G3DSA:1.10.10.910', NULL, NULL, NULL, NULL, 'ATP synthase, F1 beta subunit', NULL, NULL, 31796, 5),
(233531, NULL, 'G3DSA:3.30.2310.50', NULL, NULL, NULL, NULL, 'Protein of unknown function (DUF3228), domain 1', NULL, NULL, NULL, 5),
(233532, NULL, 'G3DSA:1.10.287.540', NULL, NULL, NULL, NULL, 'Helix hairpin bin', NULL, NULL, NULL, 5),
(233533, NULL, 'G3DSA:2.140.10.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233534, NULL, 'G3DSA:3.30.2130.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233535, NULL, 'G3DSA:6.20.40.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233536, NULL, 'G3DSA:3.15.30.10', NULL, NULL, NULL, NULL, 'putative capsid protein of prophage domain like', NULL, NULL, NULL, 5),
(233537, NULL, 'G3DSA:1.10.1200.140', NULL, NULL, NULL, NULL, 'Alkaline phosphatase, crown domain', NULL, NULL, 30359, 5),
(233538, NULL, 'G3DSA:2.70.20.50', NULL, NULL, NULL, NULL, '', NULL, NULL, 33842, 5),
(233539, NULL, 'G3DSA:1.10.506.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233540, NULL, 'G3DSA:3.30.70.3600', NULL, NULL, NULL, NULL, '', NULL, NULL, 31166, 5),
(233541, NULL, 'G3DSA:1.25.40.880', NULL, NULL, NULL, NULL, 'Alkyl sulfatase, dimerisation domain', NULL, NULL, 33632, 5),
(233542, NULL, 'G3DSA:1.10.1240.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233543, NULL, 'G3DSA:2.60.40.3430', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233544, NULL, 'G3DSA:2.40.160.50', NULL, NULL, NULL, NULL, 'membrane protein fhac: a member of the omp85/tpsb transporter family', NULL, NULL, NULL, 5),
(233545, NULL, 'G3DSA:1.10.101.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33045, 5),
(233546, NULL, 'G3DSA:2.40.50.50', NULL, NULL, NULL, NULL, '', NULL, NULL, 32659, 5),
(233547, NULL, 'G3DSA:1.10.460.10', NULL, NULL, NULL, NULL, 'Topoisomerase I, domain 2', NULL, NULL, 17691, 5),
(233548, NULL, 'G3DSA:3.10.129.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233549, NULL, 'G3DSA:1.20.58.840', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233550, NULL, 'G3DSA:1.10.3200.20', NULL, NULL, NULL, NULL, 'DNA Polymerase alpha, zinc finger', NULL, NULL, 27533, 5),
(233551, NULL, 'G3DSA:3.30.70.260', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233552, NULL, 'G3DSA:3.40.50.10770', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233553, NULL, 'G3DSA:3.30.1490.470', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233554, NULL, 'G3DSA:3.30.56.60', NULL, NULL, NULL, NULL, '', NULL, NULL, 25057, 5),
(233555, NULL, 'G3DSA:1.20.120.1130', NULL, NULL, NULL, NULL, '', NULL, NULL, 33069, 5);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(233556, NULL, 'G3DSA:1.10.1130.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233557, NULL, 'G3DSA:2.10.10.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233558, NULL, 'G3DSA:4.10.1240.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233559, NULL, 'G3DSA:3.90.56.10', NULL, NULL, NULL, NULL, 'Monooxygenase component MmoB/DmpM', NULL, NULL, 28690, 5),
(233560, NULL, 'G3DSA:2.40.128.100', NULL, NULL, NULL, NULL, 'OPCA outer membrane adhesin/invasin', NULL, NULL, NULL, 5),
(233561, NULL, 'G3DSA:6.10.250.2170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233562, NULL, 'G3DSA:1.10.238.190', NULL, NULL, NULL, NULL, '', NULL, NULL, 33976, 5),
(233563, NULL, 'G3DSA:2.40.128.380', NULL, NULL, NULL, NULL, 'T3SS negative regulator GrlR', NULL, NULL, 36246, 5),
(233564, NULL, 'G3DSA:1.10.60.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233565, NULL, 'G3DSA:1.10.8.970', NULL, NULL, NULL, NULL, '', NULL, NULL, 31372, 5),
(233566, NULL, 'G3DSA:6.10.140.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233567, NULL, 'G3DSA:3.30.160.230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233568, NULL, 'G3DSA:1.10.274.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 15625, 5),
(233569, NULL, 'G3DSA:1.20.58.200', NULL, NULL, NULL, NULL, 'Translin; domain 2', NULL, NULL, 10417, 5),
(233570, NULL, 'G3DSA:1.10.10.740', NULL, NULL, NULL, NULL, 'Crisp domain', NULL, NULL, 30033, 5),
(233571, NULL, 'G3DSA:6.10.250.2700', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233572, NULL, 'G3DSA:6.10.250.430', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233573, NULL, 'G3DSA:1.10.10.1550', NULL, NULL, NULL, NULL, 'ROS/MUCR transcriptional regulator protein', NULL, NULL, 30427, 5),
(233574, NULL, 'G3DSA:1.10.472.90', NULL, NULL, NULL, NULL, 'Conserved carboxylase domain', NULL, NULL, NULL, 5),
(233575, NULL, 'G3DSA:4.10.40.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233576, NULL, 'G3DSA:2.30.30.790', NULL, NULL, NULL, NULL, '', NULL, NULL, 33637, 5),
(233577, NULL, 'G3DSA:3.40.1620.80', NULL, NULL, NULL, NULL, '', NULL, NULL, 30155, 5),
(233578, NULL, 'G3DSA:1.10.10.610', NULL, NULL, NULL, NULL, '', NULL, NULL, 29691, 5),
(233579, NULL, 'G3DSA:3.50.40.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 21295, 5),
(233580, NULL, 'G3DSA:3.30.1330.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233581, NULL, 'G3DSA:1.10.357.110', NULL, NULL, NULL, NULL, '', NULL, NULL, 27086, 5),
(233582, NULL, 'G3DSA:3.10.20.860', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233583, NULL, 'G3DSA:3.30.2120.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 21705, 5),
(233584, NULL, 'G3DSA:3.30.1330.190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233585, NULL, 'G3DSA:1.10.3230.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33376, 5),
(233586, NULL, 'G3DSA:3.40.390.30', NULL, NULL, NULL, NULL, 'Metalloproteases ("zincins"), catalytic domain', NULL, NULL, 15614, 5),
(233587, NULL, 'G3DSA:3.30.70.1050', NULL, NULL, NULL, NULL, '', NULL, NULL, 28438, 5),
(233588, NULL, 'G3DSA:1.20.1690.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33867, 5),
(233589, NULL, 'G3DSA:3.30.160.220', NULL, NULL, NULL, NULL, 'YoaG', NULL, NULL, 31407, 5),
(233590, NULL, 'G3DSA:2.60.120.430', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233591, NULL, 'G3DSA:3.30.300.290', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233592, NULL, 'G3DSA:2.80.10.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233593, NULL, 'G3DSA:1.10.10.1720', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233594, NULL, 'G3DSA:1.20.1220.12', NULL, NULL, NULL, NULL, 'Malate synthase, domain III', NULL, NULL, 11393, 5),
(233595, NULL, 'G3DSA:1.20.58.1860', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233596, NULL, 'G3DSA:3.10.450.390', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF3889', NULL, NULL, NULL, 5),
(233597, NULL, 'G3DSA:3.10.20.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 29706, 5),
(233598, NULL, 'G3DSA:1.10.1200.60', NULL, NULL, NULL, NULL, '', NULL, NULL, 9394, 5),
(233599, NULL, 'G3DSA:1.10.700.10', NULL, NULL, NULL, NULL, 'Dioxygenase LigAB, LigA subunit', NULL, NULL, 28535, 5);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(233600, NULL, 'G3DSA:1.20.5.990', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233601, NULL, 'G3DSA:2.40.10.240', NULL, NULL, NULL, NULL, '', NULL, NULL, 34872, 5),
(233602, NULL, 'G3DSA:3.30.420.280', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233603, NULL, 'G3DSA:3.40.5.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233604, NULL, 'G3DSA:6.10.250.1940', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233605, NULL, 'G3DSA:3.90.1140.10', NULL, NULL, NULL, NULL, 'Cyclic phosphodiesterase', NULL, NULL, NULL, 5),
(233606, NULL, 'G3DSA:1.20.890.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233607, NULL, 'G3DSA:1.20.58.380', NULL, NULL, NULL, NULL, 'Flagellar protein flit.', NULL, NULL, NULL, 5),
(233608, NULL, 'G3DSA:1.10.168.10', NULL, NULL, NULL, NULL, 'Phosducin, domain 2', NULL, NULL, 19770, 5),
(233609, NULL, 'G3DSA:2.60.40.3220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233610, NULL, 'G3DSA:2.40.340.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31013, 5),
(233611, NULL, 'G3DSA:3.90.1620.10', NULL, NULL, NULL, NULL, 'adenovirus 2 penton base, domain 2', NULL, NULL, NULL, 5),
(233612, NULL, 'G3DSA:1.20.272.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233613, NULL, 'G3DSA:3.40.1080.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 32411, 5),
(233614, NULL, 'G3DSA:3.30.70.2840', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233615, NULL, 'G3DSA:1.10.10.1420', NULL, NULL, NULL, NULL, '', NULL, NULL, 29790, 5),
(233616, NULL, 'G3DSA:1.20.1280.170', NULL, NULL, NULL, NULL, 'Exocyst complex component Exo70', NULL, NULL, NULL, 5),
(233617, NULL, 'G3DSA:3.30.2440.10', NULL, NULL, NULL, NULL, 'Secreted effector protein SifA', NULL, NULL, NULL, 5),
(233618, NULL, 'G3DSA:6.10.250.220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233619, NULL, 'G3DSA:1.10.150.80', NULL, NULL, NULL, NULL, 'HRDC domain', NULL, NULL, 35433, 5),
(233620, NULL, 'G3DSA:3.40.50.10640', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233621, NULL, 'G3DSA:2.40.50.300', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233622, NULL, 'G3DSA:2.60.40.3810', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233623, NULL, 'G3DSA:1.10.8.500', NULL, NULL, NULL, NULL, 'HAMP domain in histidine kinase', NULL, NULL, NULL, 5),
(233624, NULL, 'G3DSA:1.10.287.780', NULL, NULL, NULL, NULL, '', NULL, NULL, 20503, 5),
(233625, NULL, 'G3DSA:2.70.150.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233626, NULL, 'G3DSA:3.30.160.130', NULL, NULL, NULL, NULL, 'ykff protein like domains', NULL, NULL, 28587, 5),
(233627, NULL, 'G3DSA:3.30.390.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233628, NULL, 'G3DSA:3.40.630.150', NULL, NULL, NULL, NULL, '', NULL, NULL, 35282, 5),
(233629, NULL, 'G3DSA:6.10.250.1430', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233630, NULL, 'G3DSA:2.30.30.1060', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233631, NULL, 'G3DSA:3.40.1570.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233632, NULL, 'G3DSA:3.30.420.300', NULL, NULL, NULL, NULL, '', NULL, NULL, 35486, 5),
(233633, NULL, 'G3DSA:3.15.10.60', NULL, NULL, NULL, NULL, 'Alkylmercury lyase', NULL, NULL, NULL, 5),
(233634, NULL, 'G3DSA:1.10.1080.10', NULL, NULL, NULL, NULL, 'Glutathione Synthetase; Chain A, domain 3', NULL, NULL, 13823, 5),
(233635, NULL, 'G3DSA:1.20.120.780', NULL, NULL, NULL, NULL, 'DNA mimic ocr', NULL, NULL, 31234, 5),
(233636, NULL, 'G3DSA:1.10.150.130', NULL, NULL, NULL, NULL, '', NULL, NULL, 8931, 5),
(233637, NULL, 'G3DSA:2.40.33.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233638, NULL, 'G3DSA:1.10.1740.220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233639, NULL, 'G3DSA:3.40.50.12820', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233640, NULL, 'G3DSA:2.60.40.2670', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233641, NULL, 'G3DSA:3.30.230.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233642, NULL, 'G3DSA:3.30.860.10', NULL, NULL, NULL, NULL, '30s Ribosomal Protein S19; Chain A', NULL, NULL, 20334, 5);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(233643, NULL, 'G3DSA:2.60.40.3940', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233644, NULL, 'G3DSA:3.30.300.150', NULL, NULL, NULL, NULL, 'DNA polymerase III, tau subunit, domain V', NULL, NULL, 27582, 5),
(233645, NULL, 'G3DSA:3.30.450.150', NULL, NULL, NULL, NULL, '', NULL, NULL, 31360, 5),
(233646, NULL, 'G3DSA:3.30.505.50', NULL, NULL, NULL, NULL, '', NULL, NULL, 31446, 5),
(233647, NULL, 'G3DSA:2.20.25.370', NULL, NULL, NULL, NULL, '', NULL, NULL, 29699, 5),
(233648, NULL, 'G3DSA:6.10.100.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 34077, 5),
(233649, NULL, 'G3DSA:3.30.110.70', NULL, NULL, NULL, NULL, 'Hypothetical protein apc22750. Chain B', NULL, NULL, NULL, 5),
(233650, NULL, 'G3DSA:2.60.90.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233651, NULL, 'G3DSA:1.10.40.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233652, NULL, 'G3DSA:1.20.50.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233653, NULL, 'G3DSA:3.30.70.2920', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233654, NULL, 'G3DSA:1.25.10.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233655, NULL, 'G3DSA:6.10.250.350', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233656, NULL, 'G3DSA:3.40.50.220', NULL, NULL, NULL, NULL, '', NULL, NULL, 23230, 5),
(233657, NULL, 'G3DSA:2.40.10.190', NULL, NULL, NULL, NULL, 'translation elongation factor selb, chain A, domain 4', NULL, NULL, 33837, 5),
(233658, NULL, 'G3DSA:3.30.160.310', NULL, NULL, NULL, NULL, '', NULL, NULL, 30480, 5),
(233659, NULL, 'G3DSA:6.20.410.20', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5),
(233660, NULL, 'G3DSA:2.60.40.3720', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233661, NULL, 'G3DSA:2.60.40.1120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233662, NULL, 'G3DSA:2.60.40.690', NULL, NULL, NULL, NULL, '', NULL, NULL, 33572, 5),
(233663, NULL, 'G3DSA:3.10.450.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233664, NULL, 'G3DSA:3.20.110.10', NULL, NULL, NULL, NULL, 'Glycoside hydrolase 38, N terminal domain', NULL, NULL, 25128, 5),
(233665, NULL, 'G3DSA:3.30.1490.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233666, NULL, 'G3DSA:6.10.250.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233667, NULL, 'G3DSA:3.40.640.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 7398, 5),
(233668, NULL, 'G3DSA:2.60.40.420', NULL, NULL, NULL, NULL, '', NULL, NULL, 9392, 5),
(233669, NULL, 'G3DSA:2.60.40.4120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233670, NULL, 'G3DSA:3.90.1700.10', NULL, NULL, NULL, NULL, 'v583 domain like', NULL, NULL, NULL, 5),
(233671, NULL, 'G3DSA:3.50.70.20', NULL, NULL, NULL, NULL, 'Cytochrome P460', NULL, NULL, 30773, 5),
(233672, NULL, 'G3DSA:2.60.40.2170', NULL, NULL, NULL, NULL, 'Wnt, WIF domain', NULL, NULL, 32016, 5),
(233673, NULL, 'G3DSA:3.30.1360.220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233674, NULL, 'G3DSA:1.10.287.1700', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233675, NULL, 'G3DSA:4.10.890.10', NULL, NULL, NULL, NULL, 'HIV 1 nef anchor domain', NULL, NULL, 24384, 5),
(233676, NULL, 'G3DSA:1.20.58.2180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233677, NULL, 'G3DSA:3.30.450.370', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233678, NULL, 'G3DSA:1.10.10.160', NULL, NULL, NULL, NULL, '', NULL, NULL, 7071, 5),
(233679, NULL, 'G3DSA:1.10.287.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 30734, 5),
(233680, NULL, 'G3DSA:3.40.30.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233681, NULL, 'G3DSA:3.30.70.3150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233682, NULL, 'G3DSA:1.10.287.870', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233683, NULL, 'G3DSA:2.20.25.100', NULL, NULL, NULL, NULL, '', NULL, NULL, 16446, 5),
(233684, NULL, 'G3DSA:1.20.1440.110', NULL, NULL, NULL, NULL, 'acylaminoacyl peptidase', NULL, NULL, NULL, 5),
(233685, NULL, 'G3DSA:1.10.1510.20', NULL, NULL, NULL, NULL, 'Propanediol/glycerol dehydratase, small subunit', NULL, NULL, 32109, 5),
(233686, NULL, 'G3DSA:6.10.140.2180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(233687, NULL, 'G3DSA:2.60.40.1690', NULL, NULL, NULL, NULL, 'Head and neck region of the ectodomain of NDV fusion glycoprotein', NULL, NULL, NULL, 5),
(233688, NULL, 'G3DSA:1.20.58.1780', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233689, NULL, 'G3DSA:2.70.98.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 28204, 5),
(233690, NULL, 'G3DSA:6.10.140.1870', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233691, NULL, 'G3DSA:2.40.100.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233692, NULL, 'G3DSA:3.30.310.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 29166, 5),
(233693, NULL, 'G3DSA:3.90.120.10', NULL, NULL, NULL, NULL, 'DNA Methylase, subunit A, domain 2', NULL, NULL, NULL, 5),
(233694, NULL, 'G3DSA:3.40.1450.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29508, 5),
(233695, NULL, 'G3DSA:3.30.70.3020', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233696, NULL, 'G3DSA:1.20.1590.10', NULL, NULL, NULL, NULL, 'YP_001051499.1 domain like', NULL, NULL, 15778, 5),
(233697, NULL, 'G3DSA:3.30.70.470', NULL, NULL, NULL, NULL, '', NULL, NULL, 7785, 5),
(233698, NULL, 'G3DSA:3.30.1220.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 27055, 5),
(233699, NULL, 'G3DSA:3.30.920.50', NULL, NULL, NULL, NULL, '', NULL, NULL, 35514, 5),
(233700, NULL, 'G3DSA:1.10.1620.20', NULL, NULL, NULL, NULL, 'ATP synthase, F1 complex, epsilon  subunit superfamily, mitochondrial', NULL, NULL, 31953, 5),
(233701, NULL, 'G3DSA:3.30.30.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233702, NULL, 'G3DSA:6.10.250.2380', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233703, NULL, 'G3DSA:6.20.300.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233704, NULL, 'G3DSA:2.40.70.10', NULL, NULL, NULL, NULL, 'Acid Proteases', NULL, NULL, 15382, 5),
(233705, NULL, 'G3DSA:1.20.58.630', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233706, NULL, 'G3DSA:2.60.40.630', NULL, NULL, NULL, NULL, '', NULL, NULL, 7638, 5),
(233707, NULL, 'G3DSA:6.10.250.1850', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233708, NULL, 'G3DSA:2.40.290.30', NULL, NULL, NULL, NULL, 'Mediator complex subunit 25, ACID domain', NULL, NULL, 30369, 5),
(233709, NULL, 'G3DSA:3.30.160.120', NULL, NULL, NULL, NULL, 'Hypothetical protein MTH1880', NULL, NULL, 29873, 5),
(233710, NULL, 'G3DSA:2.30.280.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233711, NULL, 'G3DSA:6.10.250.1490', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233712, NULL, 'G3DSA:3.40.140.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233713, NULL, 'G3DSA:6.10.140.1050', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233714, NULL, 'G3DSA:1.20.5.850', NULL, NULL, NULL, NULL, 'Rbstp2229 protein', NULL, NULL, NULL, 5),
(233715, NULL, 'G3DSA:1.10.246.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233716, NULL, 'G3DSA:3.30.420.570', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233717, NULL, 'G3DSA:3.30.1370.60', NULL, NULL, NULL, NULL, 'Hypothetical oxidoreductase yiak; domain 2', NULL, NULL, 35107, 5),
(233718, NULL, 'G3DSA:1.10.246.180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233719, NULL, 'G3DSA:3.30.110.190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233720, NULL, 'G3DSA:6.20.170.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233721, NULL, 'G3DSA:3.30.70.1040', NULL, NULL, NULL, NULL, 'Dystroglycan, domain 2', NULL, NULL, 23588, 5),
(233722, NULL, 'G3DSA:1.10.1180.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33015, 5),
(233723, NULL, 'G3DSA:1.20.1260.110', NULL, NULL, NULL, NULL, 'DNA integrity scanning linker region', NULL, NULL, 28909, 5),
(233724, NULL, 'G3DSA:3.10.430.100', NULL, NULL, NULL, NULL, '', NULL, NULL, 33153, 5),
(233725, NULL, 'G3DSA:2.60.120.340', NULL, NULL, NULL, NULL, 'Nucleoplasmin core domain', NULL, NULL, NULL, 5),
(233726, NULL, 'G3DSA:4.10.80.270', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233727, NULL, 'G3DSA:3.90.550.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233728, NULL, 'G3DSA:6.20.50.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(233729, NULL, 'G3DSA:1.10.1740.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233730, NULL, 'G3DSA:1.10.3750.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 12204, 5),
(233731, NULL, 'G3DSA:2.20.28.90', NULL, NULL, NULL, NULL, '', NULL, NULL, 28437, 5),
(233732, NULL, 'G3DSA:2.60.98.30', NULL, NULL, NULL, NULL, 'Rubella membrane glycoprotein E1, domain 1', NULL, NULL, 36921, 5),
(233733, NULL, 'G3DSA:3.30.1490.200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233734, NULL, 'G3DSA:3.30.310.260', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233735, NULL, 'G3DSA:3.30.110.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33104, 5),
(233736, NULL, 'G3DSA:2.60.330.10', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5),
(233737, NULL, 'G3DSA:3.30.360.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 30488, 5),
(233738, NULL, 'G3DSA:2.20.28.180', NULL, NULL, NULL, NULL, 'Arenavirus glycoprotein, zinc binding domain', NULL, NULL, 36092, 5),
(233739, NULL, 'G3DSA:1.10.1740.30', NULL, NULL, NULL, NULL, 'Secreted effector protein SifA helical domain', NULL, NULL, 36541, 5),
(233740, NULL, 'G3DSA:2.30.30.870', NULL, NULL, NULL, NULL, 'Pelota, domain A', NULL, NULL, 32798, 5),
(233741, NULL, 'G3DSA:3.40.50.510', NULL, NULL, NULL, NULL, '', NULL, NULL, 28774, 5),
(233742, NULL, 'G3DSA:1.20.1520.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33864, 5),
(233743, NULL, 'G3DSA:1.20.1690.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233744, NULL, 'G3DSA:2.20.70.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233745, NULL, 'G3DSA:1.10.4160.10', NULL, NULL, NULL, NULL, 'Hydantoin permease', NULL, NULL, NULL, 5),
(233746, NULL, 'G3DSA:2.40.128.520', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233747, NULL, 'G3DSA:3.40.395.10', NULL, NULL, NULL, NULL, 'Adenoviral Proteinase; Chain A', NULL, NULL, NULL, 5),
(233748, NULL, 'G3DSA:2.40.50.430', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233749, NULL, 'G3DSA:1.10.10.820', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233750, NULL, 'G3DSA:1.10.800.10', NULL, NULL, NULL, NULL, 'Aromatic amino acid hydroxylase', NULL, NULL, 30975, 5),
(233751, NULL, 'G3DSA:2.60.40.710', NULL, NULL, NULL, NULL, '', NULL, NULL, 28552, 5),
(233752, NULL, 'G3DSA:2.10.70.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233753, NULL, 'G3DSA:3.30.300.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 24144, 5),
(233754, NULL, 'G3DSA:3.40.1490.10', NULL, NULL, NULL, NULL, 'Bit1', NULL, NULL, 16300, 5),
(233755, NULL, 'G3DSA:3.30.110.130', NULL, NULL, NULL, NULL, '', NULL, NULL, 37228, 5),
(233756, NULL, 'G3DSA:6.10.140.2050', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233757, NULL, 'G3DSA:3.40.5.40', NULL, NULL, NULL, NULL, 'FHIPEP family, domain 2', NULL, NULL, NULL, 5),
(233758, NULL, 'G3DSA:1.20.58.1650', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233759, NULL, 'G3DSA:3.90.1150.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233760, NULL, 'G3DSA:1.20.810.10', NULL, NULL, NULL, NULL, 'Cytochrome Bc1 Complex; Chain C', NULL, NULL, 24608, 5),
(233761, NULL, 'G3DSA:2.20.20.40', NULL, NULL, NULL, NULL, 'Integron cassette protein', NULL, NULL, NULL, 5),
(233762, NULL, 'G3DSA:1.10.10.1510', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233763, NULL, 'G3DSA:3.10.450.200', NULL, NULL, NULL, NULL, '', NULL, NULL, 31528, 5),
(233764, NULL, 'G3DSA:3.40.630.60', NULL, NULL, NULL, NULL, '', NULL, NULL, 32095, 5),
(233765, NULL, 'G3DSA:2.60.40.720', NULL, NULL, NULL, NULL, '', NULL, NULL, 7501, 5),
(233766, NULL, 'G3DSA:1.25.60.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 27806, 5),
(233767, NULL, 'G3DSA:6.10.250.800', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233768, NULL, 'G3DSA:2.60.120.1600', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233769, NULL, 'G3DSA:3.90.600.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28206, 5),
(233770, NULL, 'G3DSA:3.40.50.11160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233771, NULL, 'G3DSA:1.10.3120.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29078, 5),
(233772, NULL, 'G3DSA:2.20.20.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(233773, NULL, 'G3DSA:6.20.270.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233774, NULL, 'G3DSA:1.10.260.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233775, NULL, 'G3DSA:3.40.1350.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233776, NULL, 'G3DSA:3.30.1360.190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233777, NULL, 'G3DSA:3.90.810.10', NULL, NULL, NULL, NULL, 'CRIB domain', NULL, NULL, 28165, 5),
(233778, NULL, 'G3DSA:3.30.1490.260', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233779, NULL, 'G3DSA:3.90.220.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 11737, 5),
(233780, NULL, 'G3DSA:2.60.40.1090', NULL, NULL, NULL, NULL, '', NULL, NULL, 28362, 5),
(233781, NULL, 'G3DSA:1.10.4140.10', NULL, NULL, NULL, NULL, 'effector protein (NleL)', NULL, NULL, 32190, 5),
(233782, NULL, 'G3DSA:1.20.1050.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233783, NULL, 'G3DSA:4.10.430.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233784, NULL, 'G3DSA:1.10.4080.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31955, 5),
(233785, NULL, 'G3DSA:2.60.40.3640', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233786, NULL, 'G3DSA:2.40.30.330', NULL, NULL, NULL, NULL, '', NULL, NULL, 33904, 5),
(233787, NULL, 'G3DSA:3.30.450.240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233788, NULL, 'G3DSA:1.10.1790.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233789, NULL, 'G3DSA:1.10.274.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233790, NULL, 'G3DSA:6.10.250.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233791, NULL, 'G3DSA:1.10.238.150', NULL, NULL, NULL, NULL, 'Formin, FH3 diaphanous domain', NULL, NULL, NULL, 5),
(233792, NULL, 'G3DSA:3.30.1570.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31492, 5),
(233793, NULL, 'G3DSA:3.30.70.560', NULL, NULL, NULL, NULL, '', NULL, NULL, 10878, 5),
(233794, NULL, 'G3DSA:1.10.40.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233795, NULL, 'G3DSA:6.10.140.700', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233796, NULL, 'G3DSA:3.55.30.10', NULL, NULL, NULL, NULL, 'Hsp33 domain', NULL, NULL, 11549, 5),
(233797, NULL, 'G3DSA:3.10.100.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 11522, 5),
(233798, NULL, 'G3DSA:1.10.720.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233799, NULL, 'G3DSA:3.40.50.12610', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233800, NULL, 'G3DSA:2.60.40.3730', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233801, NULL, 'G3DSA:2.30.30.130', NULL, NULL, NULL, NULL, '', NULL, NULL, 9880, 5),
(233802, NULL, 'G3DSA:3.90.241.10', NULL, NULL, NULL, NULL, 'Foki Restriction Endonuclease, Chain A, domain 1', NULL, NULL, 34420, 5),
(233803, NULL, 'G3DSA:2.20.80.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233804, NULL, 'G3DSA:1.20.1150.12', NULL, NULL, NULL, NULL, '', NULL, NULL, 27741, 5),
(233805, NULL, 'G3DSA:1.25.40.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 14046, 5),
(233806, NULL, 'G3DSA:3.30.70.2710', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233807, NULL, 'G3DSA:3.30.9.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233808, NULL, 'G3DSA:3.30.1320.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 17800, 5),
(233809, NULL, 'G3DSA:3.90.1630.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233810, NULL, 'G3DSA:3.40.1350.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 13927, 5),
(233811, NULL, 'G3DSA:1.20.58.1440', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233812, NULL, 'G3DSA:1.20.120.730', NULL, NULL, NULL, NULL, 'Sec23/Sec24 helical domain', NULL, NULL, NULL, 5),
(233813, NULL, 'G3DSA:3.40.630.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233814, NULL, 'G3DSA:2.20.25.400', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233815, NULL, 'G3DSA:2.40.50.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233816, NULL, 'G3DSA:2.30.110.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 7904, 5),
(233817, NULL, 'G3DSA:3.30.420.360', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233818, NULL, 'G3DSA:1.10.167.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 35707, 5);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(233819, NULL, 'G3DSA:2.30.30.1270', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233820, NULL, 'G3DSA:3.30.70.2630', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233821, NULL, 'G3DSA:2.70.240.10', NULL, NULL, NULL, NULL, 'Leukocidin/porin MspA', NULL, NULL, NULL, 5),
(233822, NULL, 'G3DSA:1.10.10.2400', NULL, NULL, NULL, NULL, '', NULL, NULL, 30046, 5),
(233823, NULL, 'G3DSA:2.10.10.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233824, NULL, 'G3DSA:3.40.1440.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233825, NULL, 'G3DSA:1.10.287.1400', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233826, NULL, 'G3DSA:2.60.40.2540', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233827, NULL, 'G3DSA:2.40.128.230', NULL, NULL, NULL, NULL, 'Pilot protein MxiM', NULL, NULL, 32260, 5),
(233828, NULL, 'G3DSA:3.30.160.740', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233829, NULL, 'G3DSA:6.10.250.1220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233830, NULL, 'G3DSA:1.20.5.1230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233831, NULL, 'G3DSA:2.60.40.3600', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233832, NULL, 'G3DSA:1.10.260.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233833, NULL, 'G3DSA:2.40.128.650', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233834, NULL, 'G3DSA:1.20.58.360', NULL, NULL, NULL, NULL, 'Shigella T3SS effector IpaH defines', NULL, NULL, NULL, 5),
(233835, NULL, 'G3DSA:3.30.70.3540', NULL, NULL, NULL, NULL, 'Nsp8 replicase, head domain', NULL, NULL, 29079, 5),
(233836, NULL, 'G3DSA:2.20.130.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233837, NULL, 'G3DSA:3.30.379.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233838, NULL, 'G3DSA:2.30.130.30', NULL, NULL, NULL, NULL, 'Hypothetical protein.', NULL, NULL, NULL, 5),
(233839, NULL, 'G3DSA:3.30.1190.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28734, 5),
(233840, NULL, 'G3DSA:6.10.140.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233841, NULL, 'G3DSA:1.10.3020.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233842, NULL, 'G3DSA:4.10.6.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233843, NULL, 'G3DSA:4.10.880.10', NULL, NULL, NULL, NULL, 'Poliovirus 3D polymerase  Domain 1 (Nucleotidyltransferase)', NULL, NULL, NULL, 5),
(233844, NULL, 'G3DSA:3.30.1300.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233845, NULL, 'G3DSA:2.100.10.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233846, NULL, 'G3DSA:3.40.50.11820', NULL, NULL, NULL, NULL, '', NULL, NULL, 35098, 5),
(233847, NULL, 'G3DSA:1.10.8.1320', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233848, NULL, 'G3DSA:3.30.70.1920', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233849, NULL, 'G3DSA:3.90.950.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 24333, 5),
(233850, NULL, 'G3DSA:2.70.250.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 8488, 5),
(233851, NULL, 'G3DSA:2.60.40.1210', NULL, NULL, NULL, NULL, 'Cellobiose dehydrogenase, cytochrome domain', NULL, NULL, NULL, 5),
(233852, NULL, 'G3DSA:1.10.210.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233853, NULL, 'G3DSA:2.40.50.510', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233854, NULL, 'G3DSA:3.30.990.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29519, 5),
(233855, NULL, 'G3DSA:3.10.450.380', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233856, NULL, 'G3DSA:1.10.238.90', NULL, NULL, NULL, NULL, 'Restriction endonuclease BsobI, helical domain', NULL, NULL, 37592, 5),
(233857, NULL, 'G3DSA:3.15.10.30', NULL, NULL, NULL, NULL, 'Haemolymph juvenile hormone binding protein', NULL, NULL, 28979, 5),
(233858, NULL, 'G3DSA:6.10.250.2460', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233859, NULL, 'G3DSA:3.30.1490.390', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233860, NULL, 'G3DSA:1.25.40.490', NULL, NULL, NULL, NULL, '', NULL, NULL, 33567, 5),
(233861, NULL, 'G3DSA:1.20.250.10', NULL, NULL, NULL, NULL, 'Colicin Ia, domain 1', NULL, NULL, NULL, 5);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(233862, NULL, 'G3DSA:3.30.70.340', NULL, NULL, NULL, NULL, '', NULL, NULL, 31613, 5),
(233863, NULL, 'G3DSA:3.30.310.180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233864, NULL, 'G3DSA:2.60.40.3510', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233865, NULL, 'G3DSA:4.10.800.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233866, NULL, 'G3DSA:1.10.287.440', NULL, NULL, NULL, NULL, '', NULL, NULL, 12003, 5),
(233867, NULL, 'G3DSA:1.10.599.10', NULL, NULL, NULL, NULL, 'Aldehyde Ferredoxin Oxidoreductase Protein, subunit A, domain 3', NULL, NULL, 12775, 5),
(233868, NULL, 'G3DSA:3.40.50.10680', NULL, NULL, NULL, NULL, '', NULL, NULL, 32043, 5),
(233869, NULL, 'G3DSA:4.10.1000.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233870, NULL, 'G3DSA:3.90.1750.20', NULL, NULL, NULL, NULL, 'Putative Large Serine Recombinase; Chain B, Domain 2', NULL, NULL, 29898, 5),
(233871, NULL, 'G3DSA:1.40.20.10', NULL, NULL, NULL, NULL, 'CHAD domain', NULL, NULL, 30261, 5),
(233872, NULL, 'G3DSA:3.40.1800.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233873, NULL, 'G3DSA:2.60.120.1520', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233874, NULL, 'G3DSA:1.10.640.10', NULL, NULL, NULL, NULL, 'Haem peroxidase domain superfamily, animal type', NULL, NULL, 28040, 5),
(233875, NULL, 'G3DSA:6.10.50.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233876, NULL, 'G3DSA:3.30.450.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233877, NULL, 'G3DSA:3.30.565.60', NULL, NULL, NULL, NULL, '', NULL, NULL, 32395, 5),
(233878, NULL, 'G3DSA:3.40.50.11080', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233879, NULL, 'G3DSA:3.90.570.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31661, 5),
(233880, NULL, 'G3DSA:3.40.190.270', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233881, NULL, 'G3DSA:1.20.5.1060', NULL, NULL, NULL, NULL, 'Tetrabrachion', NULL, NULL, 32905, 5),
(233882, NULL, 'G3DSA:3.30.420.440', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF4152', NULL, NULL, NULL, 5),
(233883, NULL, 'G3DSA:3.10.470.10', NULL, NULL, NULL, NULL, 'Chromosomal protein MC1', NULL, NULL, 28371, 5),
(233884, NULL, 'G3DSA:2.40.10.330', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233885, NULL, 'G3DSA:3.90.70.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233886, NULL, 'G3DSA:1.20.58.1200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233887, NULL, 'G3DSA:3.90.1780.10', NULL, NULL, NULL, NULL, 'Trimeric adhesin', NULL, NULL, 27173, 5),
(233888, NULL, 'G3DSA:1.10.8.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 14817, 5),
(233889, NULL, 'G3DSA:2.40.50.670', NULL, NULL, NULL, NULL, '', NULL, NULL, 27830, 5),
(233890, NULL, 'G3DSA:3.30.390.150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233891, NULL, 'G3DSA:2.30.90.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33195, 5),
(233892, NULL, 'G3DSA:1.20.5.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233893, NULL, 'G3DSA:1.10.10.440', NULL, NULL, NULL, NULL, 'FF domain', NULL, NULL, 30030, 5),
(233894, NULL, 'G3DSA:2.40.410.10', NULL, NULL, NULL, NULL, 'putative membrane protein from Corynebacterium diphtheriae superfamily', NULL, NULL, 16834, 5),
(233895, NULL, 'G3DSA:2.40.350.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233896, NULL, 'G3DSA:2.40.50.640', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233897, NULL, 'G3DSA:3.30.9.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233898, NULL, 'G3DSA:1.10.287.3980', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233899, NULL, 'G3DSA:6.10.10.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233900, NULL, 'G3DSA:1.10.135.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33030, 5),
(233901, NULL, 'G3DSA:3.90.320.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 13508, 5),
(233902, NULL, 'G3DSA:3.60.60.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233903, NULL, 'G3DSA:3.10.690.10', NULL, NULL, NULL, NULL, 'Bifunctional nuclease domain', NULL, NULL, 33004, 5),
(233904, NULL, 'G3DSA:2.70.40.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 33370, 5);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(233905, NULL, 'G3DSA:4.10.1330.10', NULL, NULL, NULL, NULL, 'non globular Virulence effector SptP domain', NULL, NULL, 34314, 5),
(233906, NULL, 'G3DSA:1.10.440.10', NULL, NULL, NULL, NULL, 'T4 endonuclease V', NULL, NULL, 23148, 5),
(233907, NULL, 'G3DSA:6.10.140.940', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233908, NULL, 'G3DSA:1.25.40.790', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233909, NULL, 'G3DSA:2.60.40.2300', NULL, NULL, NULL, NULL, '', NULL, NULL, 32075, 5),
(233910, NULL, 'G3DSA:6.10.140.460', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233911, NULL, 'G3DSA:2.40.360.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 15781, 5),
(233912, NULL, 'G3DSA:1.10.10.2850', NULL, NULL, NULL, NULL, '', NULL, NULL, 31737, 5),
(233913, NULL, 'G3DSA:3.90.770.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 15197, 5),
(233914, NULL, 'G3DSA:3.30.160.110', NULL, NULL, NULL, NULL, 'Siroheme synthase; domain 2', NULL, NULL, NULL, 5),
(233915, NULL, 'G3DSA:4.10.280.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 31365, 5),
(233916, NULL, 'G3DSA:3.30.1390.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 18977, 5),
(233917, NULL, 'G3DSA:6.10.20.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 31348, 5),
(233918, NULL, 'G3DSA:1.10.286.70', NULL, NULL, NULL, NULL, 'Get5 dimerization domain', NULL, NULL, NULL, 5),
(233919, NULL, 'G3DSA:3.10.280.10', NULL, NULL, NULL, NULL, 'Mitochondrial glycoprotein', NULL, NULL, 33429, 5),
(233920, NULL, 'G3DSA:3.30.54.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233921, NULL, 'G3DSA:3.30.540.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233922, NULL, 'G3DSA:3.10.450.530', NULL, NULL, NULL, NULL, '', NULL, NULL, 30547, 5),
(233923, NULL, 'G3DSA:3.30.1970.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 27801, 5),
(233924, NULL, 'G3DSA:2.40.128.290', NULL, NULL, NULL, NULL, 'Uncharacterised protein Atu4866, PF11512', NULL, NULL, 31274, 5),
(233925, NULL, 'G3DSA:1.20.5.760', NULL, NULL, NULL, NULL, 'Single helix bin', NULL, NULL, NULL, 5),
(233926, NULL, 'G3DSA:3.40.190.150', NULL, NULL, NULL, NULL, 'Bordetella uptake gene, domain 1', NULL, NULL, 30509, 5),
(233927, NULL, 'G3DSA:1.10.8.550', NULL, NULL, NULL, NULL, '', NULL, NULL, 33649, 5),
(233928, NULL, 'G3DSA:3.30.1370.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233929, NULL, 'G3DSA:6.10.250.2590', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233930, NULL, 'G3DSA:3.40.630.110', NULL, NULL, NULL, NULL, '', NULL, NULL, 35414, 5),
(233931, NULL, 'G3DSA:1.20.5.390', NULL, NULL, NULL, NULL, 'L1 transposable element, trimerization domain', NULL, NULL, NULL, 5),
(233932, NULL, 'G3DSA:2.20.20.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233933, NULL, 'G3DSA:6.10.250.260', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233934, NULL, 'G3DSA:2.40.510.10', NULL, NULL, NULL, NULL, 'Positive stranded ssRNA viruses', NULL, NULL, NULL, 5),
(233935, NULL, 'G3DSA:3.30.1520.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28306, 5),
(233936, NULL, 'G3DSA:2.60.90.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233937, NULL, 'G3DSA:1.20.58.1230', NULL, NULL, NULL, NULL, '', NULL, NULL, 34147, 5),
(233938, NULL, 'G3DSA:3.30.700.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233939, NULL, 'G3DSA:6.10.130.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233940, NULL, 'G3DSA:1.10.4060.10', NULL, NULL, NULL, NULL, 'BPP1347 like domain', NULL, NULL, NULL, 5),
(233941, NULL, 'G3DSA:3.30.2030.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233942, NULL, 'G3DSA:1.20.5.2950', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233943, NULL, 'G3DSA:1.10.418.40', NULL, NULL, NULL, NULL, 'Autophagy protein 6/Beclin 1', NULL, NULL, 31458, 5),
(233944, NULL, 'G3DSA:6.10.140.1710', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233945, NULL, 'G3DSA:6.10.250.1280', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233946, NULL, 'G3DSA:1.10.4120.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233947, NULL, 'G3DSA:3.40.50.880', NULL, NULL, NULL, NULL, '', NULL, NULL, 24711, 5);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(233948, NULL, 'G3DSA:6.10.250.1070', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233949, NULL, 'G3DSA:2.60.40.2760', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233950, NULL, 'G3DSA:4.10.410.60', NULL, NULL, NULL, NULL, '', NULL, NULL, 29154, 5),
(233951, NULL, 'G3DSA:1.20.1440.360', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233952, NULL, 'G3DSA:1.10.4190.10', NULL, NULL, NULL, NULL, 'Urease accessory protein UreF', NULL, NULL, 31421, 5),
(233953, NULL, 'G3DSA:2.60.40.3850', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233954, NULL, 'G3DSA:1.10.269.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32900, 5),
(233955, NULL, 'G3DSA:6.10.250.2160', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5),
(233956, NULL, 'G3DSA:1.20.1440.150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233957, NULL, 'G3DSA:1.20.120.750', NULL, NULL, NULL, NULL, 'Staphylcoagulase, helix bundle domain 1', NULL, NULL, 33584, 5),
(233958, NULL, 'G3DSA:1.20.58.850', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233959, NULL, 'G3DSA:3.10.129.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233960, NULL, 'G3DSA:1.10.780.10', NULL, NULL, NULL, NULL, 'Hydroxylamine Oxidoreductase; Chain A, domain 1', NULL, NULL, NULL, 5),
(233961, NULL, 'G3DSA:1.10.1040.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233962, NULL, 'G3DSA:3.30.160.650', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233963, NULL, 'G3DSA:4.10.1270.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 36162, 5),
(233964, NULL, 'G3DSA:1.20.5.5200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233965, NULL, 'G3DSA:3.30.60.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233966, NULL, 'G3DSA:3.30.70.680', NULL, NULL, NULL, NULL, '', NULL, NULL, 32444, 5),
(233967, NULL, 'G3DSA:1.25.40.500', NULL, NULL, NULL, NULL, 'TFIID subunit TAF5, NTD2 domain', NULL, NULL, 31704, 5),
(233968, NULL, 'G3DSA:6.20.400.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233969, NULL, 'G3DSA:3.30.70.2020', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233970, NULL, 'G3DSA:1.20.1280.290', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233971, NULL, 'G3DSA:3.30.420.150', NULL, NULL, NULL, NULL, 'Exopolyphosphatase. Domain 2', NULL, NULL, NULL, 5),
(233972, NULL, 'G3DSA:4.10.1070.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 36375, 5),
(233973, NULL, 'G3DSA:3.90.25.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233974, NULL, 'G3DSA:1.20.1250.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 6138, 5),
(233975, NULL, 'G3DSA:3.30.70.1390', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233976, NULL, 'G3DSA:3.30.300.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233977, NULL, 'G3DSA:6.10.250.3380', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233978, NULL, 'G3DSA:3.30.420.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233979, NULL, 'G3DSA:2.60.40.2000', NULL, NULL, NULL, NULL, '', NULL, NULL, 31196, 5),
(233980, NULL, 'G3DSA:3.40.50.670', NULL, NULL, NULL, NULL, '', NULL, NULL, 7792, 5),
(233981, NULL, 'G3DSA:3.30.160.690', NULL, NULL, NULL, NULL, 'Bacterial toxin RNase RnlA/LsoA, N repeated domain', NULL, NULL, NULL, 5),
(233982, NULL, 'G3DSA:2.30.30.60', NULL, NULL, NULL, NULL, '', NULL, NULL, 16339, 5),
(233983, NULL, 'G3DSA:3.90.390.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 7981, 5),
(233984, NULL, 'G3DSA:1.10.750.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28230, 5),
(233985, NULL, 'G3DSA:3.30.70.1620', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233986, NULL, 'G3DSA:3.30.310.200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233987, NULL, 'G3DSA:2.60.40.2970', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233988, NULL, 'G3DSA:2.60.40.150', NULL, NULL, NULL, NULL, 'C2 domain', NULL, NULL, 6539, 5),
(233989, NULL, 'G3DSA:2.70.180.10', NULL, NULL, NULL, NULL, 'Hypothetical protein YojF', NULL, NULL, 31224, 5),
(233990, NULL, 'G3DSA:1.20.1270.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233991, NULL, 'G3DSA:1.10.196.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(233992, NULL, 'G3DSA:2.170.150.10', NULL, NULL, NULL, NULL, 'Metal Binding Protein, Guanine Nucleotide Exchange Factor; Chain A', NULL, NULL, 13539, 5),
(233993, NULL, 'G3DSA:3.30.465.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233994, NULL, 'G3DSA:2.30.30.40', NULL, NULL, NULL, NULL, 'SH3 Domains', NULL, NULL, NULL, 5),
(233995, NULL, 'G3DSA:2.60.40.3070', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233996, NULL, 'G3DSA:3.30.1460.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233997, NULL, 'G3DSA:3.30.1330.60', NULL, NULL, NULL, NULL, '', NULL, NULL, 31662, 5),
(233998, NULL, 'G3DSA:3.40.50.12080', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(233999, NULL, 'G3DSA:3.30.160.400', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234000, NULL, 'G3DSA:3.10.20.740', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234001, NULL, 'G3DSA:3.10.20.440', NULL, NULL, NULL, NULL, '', NULL, NULL, 35069, 5),
(234002, NULL, 'G3DSA:1.10.10.950', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234003, NULL, 'G3DSA:1.10.1760.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234004, NULL, 'G3DSA:3.70.10.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234005, NULL, 'G3DSA:1.20.5.320', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234006, NULL, 'G3DSA:6.10.290.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 28629, 5),
(234007, NULL, 'G3DSA:3.30.1900.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234008, NULL, 'G3DSA:2.60.40.2510', NULL, NULL, NULL, NULL, '', NULL, NULL, 32563, 5),
(234009, NULL, 'G3DSA:3.50.30.60', NULL, NULL, NULL, NULL, '', NULL, NULL, 24784, 5),
(234010, NULL, 'G3DSA:6.10.140.1530', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234011, NULL, 'G3DSA:2.60.120.1160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234012, NULL, 'G3DSA:3.40.50.11680', NULL, NULL, NULL, NULL, 'Poxvirus mRNA capping enzyme, small subunit', NULL, NULL, 35682, 5),
(234013, NULL, 'G3DSA:2.160.10.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234014, NULL, 'G3DSA:3.30.70.2500', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234015, NULL, 'G3DSA:1.10.287.4290', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234016, NULL, 'G3DSA:1.20.930.10', NULL, NULL, NULL, NULL, 'Conserved domain common to transcription factors TFIIS, elongin A, CRSP70', NULL, NULL, 31778, 5),
(234017, NULL, 'G3DSA:3.90.1070.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234018, NULL, 'G3DSA:1.10.8.940', NULL, NULL, NULL, NULL, 'Uncharacterised protein, phage p2 ORF12', NULL, NULL, 35024, 5),
(234019, NULL, 'G3DSA:1.25.40.600', NULL, NULL, NULL, NULL, '', NULL, NULL, 33683, 5),
(234020, NULL, 'G3DSA:2.40.128.570', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF4909', NULL, NULL, NULL, 5),
(234021, NULL, 'G3DSA:1.20.1440.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 19126, 5),
(234022, NULL, 'G3DSA:1.20.5.2710', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234023, NULL, 'G3DSA:6.10.350.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234024, NULL, 'G3DSA:6.10.140.910', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234025, NULL, 'G3DSA:6.10.140.2020', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234026, NULL, 'G3DSA:3.40.30.50', NULL, NULL, NULL, NULL, '', NULL, NULL, 33930, 5),
(234027, NULL, 'G3DSA:1.10.260.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234028, NULL, 'G3DSA:3.30.750.200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234029, NULL, 'G3DSA:3.40.50.10190', NULL, NULL, NULL, NULL, 'BRCT domain', NULL, NULL, 27639, 5),
(234030, NULL, 'G3DSA:1.20.1290.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 23934, 5),
(234031, NULL, 'G3DSA:4.10.1290.10', NULL, NULL, NULL, NULL, 'Tumor necrosis factor receptor superfamily', NULL, NULL, NULL, 5),
(234032, NULL, 'G3DSA:3.30.470.30', NULL, NULL, NULL, NULL, 'DNA ligase/mRNA capping enzyme', NULL, NULL, NULL, 5),
(234033, NULL, 'G3DSA:1.20.120.380', NULL, NULL, NULL, NULL, '', NULL, NULL, 21560, 5),
(234034, NULL, 'G3DSA:2.60.40.840', NULL, NULL, NULL, NULL, '', NULL, NULL, 14202, 5);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(234035, NULL, 'G3DSA:6.10.270.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234036, NULL, 'G3DSA:1.20.140.100', NULL, NULL, NULL, NULL, '', NULL, NULL, 36011, 5),
(234037, NULL, 'G3DSA:6.10.20.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234038, NULL, 'G3DSA:3.60.40.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234039, NULL, 'G3DSA:1.20.5.4570', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234040, NULL, 'G3DSA:2.60.340.10', NULL, NULL, NULL, NULL, 'baseplate structural protein gp8, domain 1', NULL, NULL, NULL, 5),
(234041, NULL, 'G3DSA:6.10.250.2820', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234042, NULL, 'G3DSA:3.50.90.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 16639, 5),
(234043, NULL, 'G3DSA:2.40.50.880', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234044, NULL, 'G3DSA:1.10.287.230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234045, NULL, 'G3DSA:1.25.40.540', NULL, NULL, NULL, NULL, '', NULL, NULL, 33924, 5),
(234046, NULL, 'G3DSA:3.30.70.1170', NULL, NULL, NULL, NULL, 'Sun protein; domain 3', NULL, NULL, NULL, 5),
(234047, NULL, 'G3DSA:3.90.230.10', NULL, NULL, NULL, NULL, 'Creatinase/methionine aminopeptidase superfamily', NULL, NULL, 30058, 5),
(234048, NULL, 'G3DSA:3.40.50.11290', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234049, NULL, 'G3DSA:1.10.246.60', NULL, NULL, NULL, NULL, 'Eukaryotic translation initiation factor 3 like domains', NULL, NULL, 18170, 5),
(234050, NULL, 'G3DSA:6.10.250.1520', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234051, NULL, 'G3DSA:3.40.50.10890', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234052, NULL, 'G3DSA:3.30.1600.10', NULL, NULL, NULL, NULL, 'SIR2/SIRT2 ''Small Domain''', NULL, NULL, 23369, 5),
(234053, NULL, 'G3DSA:2.60.430.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 8453, 5),
(234054, NULL, 'G3DSA:6.10.250.3220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234055, NULL, 'G3DSA:3.90.470.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 31338, 5),
(234056, NULL, 'G3DSA:2.60.40.830', NULL, NULL, NULL, NULL, 'Cytochrome f large domain', NULL, NULL, 27904, 5),
(234057, NULL, 'G3DSA:2.60.40.550', NULL, NULL, NULL, NULL, 'Ecotin', NULL, NULL, NULL, 5),
(234058, NULL, 'G3DSA:6.10.30.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234059, NULL, 'G3DSA:2.160.20.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234060, NULL, 'G3DSA:3.30.960.10', NULL, NULL, NULL, NULL, 'eRF1 domain 1', NULL, NULL, 9254, 5),
(234061, NULL, 'G3DSA:3.40.50.12590', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234062, NULL, 'G3DSA:6.10.140.1200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234063, NULL, 'G3DSA:3.40.50.1100', NULL, NULL, NULL, NULL, '', NULL, NULL, 32755, 5),
(234064, NULL, 'G3DSA:3.30.60.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234065, NULL, 'G3DSA:3.90.1150.10', NULL, NULL, NULL, NULL, 'Aspartate Aminotransferase, domain 1', NULL, NULL, 7027, 5),
(234066, NULL, 'G3DSA:1.10.260.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234067, NULL, 'G3DSA:4.10.80.180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234068, NULL, 'G3DSA:3.90.640.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234069, NULL, 'G3DSA:2.60.350.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 24343, 5),
(234070, NULL, 'G3DSA:6.10.250.2400', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234071, NULL, 'G3DSA:2.150.10.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234072, NULL, 'G3DSA:3.40.50.11770', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234073, NULL, 'G3DSA:6.10.250.770', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234074, NULL, 'G3DSA:1.10.287.450', NULL, NULL, NULL, NULL, 'Helix hairpin bin', NULL, NULL, NULL, 5),
(234075, NULL, 'G3DSA:3.40.275.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 27195, 5),
(234076, NULL, 'G3DSA:2.40.50.910', NULL, NULL, NULL, NULL, 'Type VII secretion system EccB, repeat 3 domain', NULL, NULL, 35590, 5),
(234077, NULL, 'G3DSA:2.60.120.650', NULL, NULL, NULL, NULL, 'Cupin', NULL, NULL, NULL, 5);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(234078, NULL, 'G3DSA:1.25.10.20', NULL, NULL, NULL, NULL, 'Vitellinogen, superhelical', NULL, NULL, 9193, 5),
(234079, NULL, 'G3DSA:3.30.1840.10', NULL, NULL, NULL, NULL, 'Polyphosphate kinase middle domain', NULL, NULL, 27958, 5),
(234080, NULL, 'G3DSA:1.10.8.760', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234081, NULL, 'G3DSA:3.10.50.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234082, NULL, 'G3DSA:2.40.128.400', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234083, NULL, 'G3DSA:3.10.120.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31703, 5),
(234084, NULL, 'G3DSA:3.40.50.11610', NULL, NULL, NULL, NULL, '', NULL, NULL, 34502, 5),
(234085, NULL, 'G3DSA:3.40.600.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 32901, 5),
(234086, NULL, 'G3DSA:1.20.120.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 27943, 5),
(234087, NULL, 'G3DSA:3.30.70.2390', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234088, NULL, 'G3DSA:2.40.160.150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234089, NULL, 'G3DSA:2.10.220.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234090, NULL, 'G3DSA:6.10.250.560', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234091, NULL, 'G3DSA:1.10.132.130', NULL, NULL, NULL, NULL, '', NULL, NULL, 36570, 5),
(234092, NULL, 'G3DSA:1.20.58.1020', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234093, NULL, 'G3DSA:1.25.40.1010', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234094, NULL, 'G3DSA:1.10.287.410', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234095, NULL, 'G3DSA:2.40.128.140', NULL, NULL, NULL, NULL, 'Outer membrane protein', NULL, NULL, 28083, 5),
(234096, NULL, 'G3DSA:1.10.286.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 34678, 5),
(234097, NULL, 'G3DSA:3.40.228.10', NULL, NULL, NULL, NULL, 'Dimethylsulfoxide Reductase, domain 2', NULL, NULL, NULL, 5),
(234098, NULL, 'G3DSA:1.25.40.150', NULL, NULL, NULL, NULL, '', NULL, NULL, 33605, 5),
(234099, NULL, 'G3DSA:3.30.70.1710', NULL, NULL, NULL, NULL, '', NULL, NULL, 29526, 5),
(234100, NULL, 'G3DSA:3.90.920.10', NULL, NULL, NULL, NULL, 'DNA primase, PRIM domain', NULL, NULL, NULL, 5),
(234101, NULL, 'G3DSA:3.10.450.740', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234102, NULL, 'G3DSA:3.30.70.980', NULL, NULL, NULL, NULL, '', NULL, NULL, 24302, 5),
(234103, NULL, 'G3DSA:3.40.50.11100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234104, NULL, 'G3DSA:3.30.1370.220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234105, NULL, 'G3DSA:4.10.92.10', NULL, NULL, NULL, NULL, 'Aminolevulinic Acid Synthase 2', NULL, NULL, NULL, 5),
(234106, NULL, 'G3DSA:3.10.20.650', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234107, NULL, 'G3DSA:2.30.29.100', NULL, NULL, NULL, NULL, '', NULL, NULL, 27317, 5),
(234108, NULL, 'G3DSA:1.10.340.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234109, NULL, 'G3DSA:2.60.40.4370', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234110, NULL, 'G3DSA:1.20.5.520', NULL, NULL, NULL, NULL, 'Single helix bin', NULL, NULL, 29530, 5),
(234111, NULL, 'G3DSA:1.20.120.1700', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234112, NULL, 'G3DSA:6.20.240.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234113, NULL, 'G3DSA:6.10.140.250', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234114, NULL, 'G3DSA:1.10.10.2160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234115, NULL, 'G3DSA:1.10.286.90', NULL, NULL, NULL, NULL, 'MFS transporter, transmembrane helix TM10b', NULL, NULL, NULL, 5),
(234116, NULL, 'G3DSA:1.20.120.680', NULL, NULL, NULL, NULL, '', NULL, NULL, 32909, 5),
(234117, NULL, 'G3DSA:1.20.58.600', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234118, NULL, 'G3DSA:3.40.1370.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 18505, 5),
(234119, NULL, 'G3DSA:1.10.720.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234120, NULL, 'G3DSA:2.40.30.210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234121, NULL, 'G3DSA:3.30.1360.20', NULL, NULL, NULL, NULL, 'Transcriptional coactivator/pterin dehydratase', NULL, NULL, 28002, 5);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(234122, NULL, 'G3DSA:3.40.1400.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31256, 5),
(234123, NULL, 'G3DSA:3.10.50.20', NULL, NULL, NULL, NULL, 'Cloacin immunity protein', NULL, NULL, 33176, 5),
(234124, NULL, 'G3DSA:2.40.50.460', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234125, NULL, 'G3DSA:1.20.58.150', NULL, NULL, NULL, NULL, 'ANTH domain', NULL, NULL, 9487, 5),
(234126, NULL, 'G3DSA:3.90.70.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234127, NULL, 'G3DSA:2.60.40.1900', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234128, NULL, 'G3DSA:2.40.10.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234129, NULL, 'G3DSA:2.20.120.10', NULL, NULL, NULL, NULL, 'Multimodular pneumococcal cell wall endolysin, domain 3', NULL, NULL, NULL, 5),
(234130, NULL, 'G3DSA:3.30.470.160', NULL, NULL, NULL, NULL, 'Inositol polyphosphate kinase', NULL, NULL, 31101, 5),
(234131, NULL, 'G3DSA:3.30.70.1200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234132, NULL, 'G3DSA:1.10.357.140', NULL, NULL, NULL, NULL, 'UbiA prenyltransferase', NULL, NULL, 35422, 5),
(234133, NULL, 'G3DSA:3.90.1170.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 28205, 5),
(234134, NULL, 'G3DSA:3.40.1350.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234135, NULL, 'G3DSA:1.20.5.2620', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234136, NULL, 'G3DSA:2.30.30.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 18620, 5),
(234137, NULL, 'G3DSA:1.10.2040.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 8681, 5),
(234138, NULL, 'G3DSA:6.10.280.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234139, NULL, 'G3DSA:3.40.1680.10', NULL, NULL, NULL, NULL, 'yp_829618.1 domain like', NULL, NULL, NULL, 5),
(234140, NULL, 'G3DSA:1.20.5.870', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234141, NULL, 'G3DSA:1.20.120.1820', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234142, NULL, 'G3DSA:1.20.1280.260', NULL, NULL, NULL, NULL, '', NULL, NULL, 32658, 5),
(234143, NULL, 'G3DSA:3.40.50.10130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234144, NULL, 'G3DSA:3.10.450.620', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234145, NULL, 'G3DSA:6.20.60.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234146, NULL, 'G3DSA:3.30.70.3450', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234147, NULL, 'G3DSA:2.60.40.2120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234148, NULL, 'G3DSA:6.10.250.2910', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234149, NULL, 'G3DSA:2.60.120.1070', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234150, NULL, 'G3DSA:3.30.160.860', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234151, NULL, 'G3DSA:2.40.110.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 37761, 5),
(234152, NULL, 'G3DSA:2.60.20.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234153, NULL, 'G3DSA:3.40.1790.10', NULL, NULL, NULL, NULL, 'Indigoidine synthase domain', NULL, NULL, 17149, 5),
(234154, NULL, 'G3DSA:3.10.650.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234155, NULL, 'G3DSA:1.10.10.770', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234156, NULL, 'G3DSA:1.10.10.400', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234157, NULL, 'G3DSA:3.30.70.890', NULL, NULL, NULL, NULL, '', NULL, NULL, 30062, 5),
(234158, NULL, 'G3DSA:4.10.1240.10', NULL, NULL, NULL, NULL, 'GPCR, family 2, extracellular hormone receptor domain', NULL, NULL, 28290, 5),
(234159, NULL, 'G3DSA:3.90.970.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 9474, 5),
(234160, NULL, 'G3DSA:3.40.225.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31700, 5),
(234161, NULL, 'G3DSA:3.30.40.250', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234162, NULL, 'G3DSA:3.30.720.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234163, NULL, 'G3DSA:1.10.3290.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234164, NULL, 'G3DSA:1.20.1270.290', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234165, NULL, 'G3DSA:1.20.1160.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(234166, NULL, 'G3DSA:2.20.130.30', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF2782', NULL, NULL, NULL, 5),
(234167, NULL, 'G3DSA:2.60.40.4250', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234168, NULL, 'G3DSA:3.30.70.2480', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234169, NULL, 'G3DSA:1.10.287.1250', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234170, NULL, 'G3DSA:6.10.250.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234171, NULL, 'G3DSA:6.10.140.1320', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234172, NULL, 'G3DSA:3.40.50.850', NULL, NULL, NULL, NULL, '', NULL, NULL, 32439, 5),
(234173, NULL, 'G3DSA:3.30.70.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234174, NULL, 'G3DSA:1.10.533.10', NULL, NULL, NULL, NULL, 'Death Domain, Fas', NULL, NULL, 9051, 5),
(234175, NULL, 'G3DSA:1.10.10.1850', NULL, NULL, NULL, NULL, '', NULL, NULL, 30954, 5),
(234176, NULL, 'G3DSA:3.30.200.160', NULL, NULL, NULL, NULL, 'TFIIIC, subcomplex tauA, subunit Sfc1, barrel domain', NULL, NULL, 37730, 5),
(234177, NULL, 'G3DSA:2.50.20.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 33454, 5),
(234178, NULL, 'G3DSA:1.10.10.1600', NULL, NULL, NULL, NULL, 'Bacterial DNA polymerase III alpha subunit, thumb domain', NULL, NULL, 30710, 5),
(234179, NULL, 'G3DSA:1.10.486.10', NULL, NULL, NULL, NULL, 'PCRA; domain 4', NULL, NULL, NULL, 5),
(234180, NULL, 'G3DSA:3.30.1240.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234181, NULL, 'G3DSA:6.10.300.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234182, NULL, 'G3DSA:6.10.140.1500', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234183, NULL, 'G3DSA:1.10.10.980', NULL, NULL, NULL, NULL, '', NULL, NULL, 30267, 5),
(234184, NULL, 'G3DSA:3.10.28.10', NULL, NULL, NULL, NULL, 'Homing endonucleases', NULL, NULL, 24987, 5),
(234185, NULL, 'G3DSA:3.10.310.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234186, NULL, 'G3DSA:6.10.10.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 36441, 5),
(234187, NULL, 'G3DSA:1.20.120.590', NULL, NULL, NULL, NULL, '', NULL, NULL, 33091, 5),
(234188, NULL, 'G3DSA:3.30.200.100', NULL, NULL, NULL, NULL, '', NULL, NULL, 30441, 5),
(234189, NULL, 'G3DSA:3.30.1490.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234190, NULL, 'G3DSA:2.60.120.370', NULL, NULL, NULL, NULL, 'YhcH/YjgK/YiaL', NULL, NULL, 28160, 5),
(234191, NULL, 'G3DSA:2.40.128.310', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234192, NULL, 'G3DSA:3.30.420.510', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234193, NULL, 'G3DSA:1.20.5.640', NULL, NULL, NULL, NULL, 'Single helix bin', NULL, NULL, NULL, 5),
(234194, NULL, 'G3DSA:1.20.58.2200', NULL, NULL, NULL, NULL, '', NULL, NULL, 31290, 5),
(234195, NULL, 'G3DSA:2.30.30.460', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234196, NULL, 'G3DSA:2.40.128.50', NULL, NULL, NULL, NULL, '', NULL, NULL, 26560, 5),
(234197, NULL, 'G3DSA:6.10.250.470', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234198, NULL, 'G3DSA:2.40.50.1020', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234199, NULL, 'G3DSA:2.60.120.1370', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234200, NULL, 'G3DSA:3.90.1000.10', NULL, NULL, NULL, NULL, 'Hypothetical protein TM0875', NULL, NULL, 27777, 5),
(234201, NULL, 'G3DSA:6.10.170.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234202, NULL, 'G3DSA:3.40.1280.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 32116, 5),
(234203, NULL, 'G3DSA:1.25.40.240', NULL, NULL, NULL, NULL, '', NULL, NULL, 31308, 5),
(234204, NULL, 'G3DSA:3.75.10.20', NULL, NULL, NULL, NULL, 'Succinylarginine dihydrolase', NULL, NULL, 27128, 5),
(234205, NULL, 'G3DSA:3.30.160.100', NULL, NULL, NULL, NULL, '', NULL, NULL, 31194, 5),
(234206, NULL, 'G3DSA:1.10.3860.10', NULL, NULL, NULL, NULL, 'Sodium:dicarboxylate symporter', NULL, NULL, 28161, 5),
(234207, NULL, 'G3DSA:1.20.58.220', NULL, NULL, NULL, NULL, 'Phosphate transport system protein phou homolog 2; domain 2', NULL, NULL, 27519, 5),
(234208, NULL, 'G3DSA:1.10.1160.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 16324, 5);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(234209, NULL, 'G3DSA:1.20.58.970', NULL, NULL, NULL, NULL, '', NULL, NULL, 31057, 5),
(234210, NULL, 'G3DSA:3.10.25.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28379, 5),
(234211, NULL, 'G3DSA:1.10.150.340', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234212, NULL, 'G3DSA:3.30.2320.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234213, NULL, 'G3DSA:2.60.40.4160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234214, NULL, 'G3DSA:2.60.40.1240', NULL, NULL, NULL, NULL, '', NULL, NULL, 25706, 5),
(234215, NULL, 'G3DSA:3.30.70.1410', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234216, NULL, 'G3DSA:2.20.25.670', NULL, NULL, NULL, NULL, 'GCM domain, large subdomain', NULL, NULL, 36294, 5),
(234217, NULL, 'G3DSA:3.40.50.1860', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234218, NULL, 'G3DSA:1.20.58.1310', NULL, NULL, NULL, NULL, 'PRONE domain, subdomain 2', NULL, NULL, NULL, 5),
(234219, NULL, 'G3DSA:1.20.1270.380', NULL, NULL, NULL, NULL, '', NULL, NULL, 32806, 5),
(234220, NULL, 'G3DSA:3.30.2270.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 27868, 5),
(234221, NULL, 'G3DSA:6.10.280.230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234222, NULL, 'G3DSA:3.20.20.460', NULL, NULL, NULL, NULL, 'Monomethylamine methyltransferase MtmB', NULL, NULL, 29615, 5),
(234223, NULL, 'G3DSA:2.10.10.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234224, NULL, 'G3DSA:3.30.50.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 7063, 5),
(234225, NULL, 'G3DSA:1.10.60.10', NULL, NULL, NULL, NULL, 'Iron dependent repressor, metal binding and dimerisation domain', NULL, NULL, 27747, 5),
(234226, NULL, 'G3DSA:1.10.15.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234227, NULL, 'G3DSA:1.25.40.900', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234228, NULL, 'G3DSA:3.40.50.11400', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234229, NULL, 'G3DSA:6.10.250.2040', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234230, NULL, 'G3DSA:1.10.8.460', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234231, NULL, 'G3DSA:6.20.70.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234232, NULL, 'G3DSA:3.30.60.220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234233, NULL, 'G3DSA:6.10.250.1640', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234234, NULL, 'G3DSA:4.10.400.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32750, 5),
(234235, NULL, 'G3DSA:3.40.50.10310', NULL, NULL, NULL, NULL, 'Creatininase', NULL, NULL, 12129, 5),
(234236, NULL, 'G3DSA:3.90.470.10', NULL, NULL, NULL, NULL, 'Ribosomal protein L22/L17', NULL, NULL, 28781, 5),
(234237, NULL, 'G3DSA:2.60.120.680', NULL, NULL, NULL, NULL, 'GOLD domain', NULL, NULL, NULL, 5),
(234238, NULL, 'G3DSA:3.30.70.3360', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234239, NULL, 'G3DSA:3.30.1870.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234240, NULL, 'G3DSA:6.10.280.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234241, NULL, 'G3DSA:1.20.80.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 34919, 5),
(234242, NULL, 'G3DSA:6.10.250.1730', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234243, NULL, 'G3DSA:3.40.220.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 34421, 5),
(234244, NULL, 'G3DSA:3.55.50.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234245, NULL, 'G3DSA:6.10.140.730', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234246, NULL, 'G3DSA:1.10.1580.20', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF1040', NULL, NULL, 31664, 5),
(234247, NULL, 'G3DSA:1.10.1220.160', NULL, NULL, NULL, NULL, 'DNA sulphur modification protein DndE', NULL, NULL, 32804, 5),
(234248, NULL, 'G3DSA:1.20.5.3800', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234249, NULL, 'G3DSA:2.20.210.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234250, NULL, 'G3DSA:6.10.140.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234251, NULL, 'G3DSA:3.15.10.50', NULL, NULL, NULL, NULL, '', NULL, NULL, 28539, 5),
(234252, NULL, 'G3DSA:6.10.250.2610', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(234253, NULL, 'G3DSA:2.60.120.640', NULL, NULL, NULL, NULL, 'gp9', NULL, NULL, 21565, 5),
(234254, NULL, 'G3DSA:1.10.2010.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234255, NULL, 'G3DSA:6.10.180.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234256, NULL, 'G3DSA:1.20.120.1910', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234257, NULL, 'G3DSA:1.20.5.730', NULL, NULL, NULL, NULL, 'Single helix bin', NULL, NULL, NULL, 5),
(234258, NULL, 'G3DSA:1.10.1840.10', NULL, NULL, NULL, NULL, 'main proteinase (3clpro) structure, domain 3', NULL, NULL, 33776, 5),
(234259, NULL, 'G3DSA:1.25.40.330', NULL, NULL, NULL, NULL, '', NULL, NULL, 29881, 5),
(234260, NULL, 'G3DSA:6.10.250.3010', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234261, NULL, 'G3DSA:3.20.110.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234262, NULL, 'G3DSA:2.40.50.390', NULL, NULL, NULL, NULL, 'Conjugative transposon protein, DUF961', NULL, NULL, 29661, 5),
(234263, NULL, 'G3DSA:2.40.260.10', NULL, NULL, NULL, NULL, 'Sortase', NULL, NULL, 20102, 5),
(234264, NULL, 'G3DSA:3.40.140.30', NULL, NULL, NULL, NULL, 'Hypothetical protein TM1506', NULL, NULL, 29616, 5),
(234265, NULL, 'G3DSA:3.30.740.10', NULL, NULL, NULL, NULL, 'Protein Inhibitor Of Neuronal Nitric Oxide Synthase;', NULL, NULL, 31668, 5),
(234266, NULL, 'G3DSA:2.60.40.2210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234267, NULL, 'G3DSA:3.40.1650.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 10633, 5),
(234268, NULL, 'G3DSA:2.120.10.90', NULL, NULL, NULL, NULL, '', NULL, NULL, 31422, 5),
(234269, NULL, 'G3DSA:3.10.270.10', NULL, NULL, NULL, NULL, 'Urate Oxidase;', NULL, NULL, NULL, 5),
(234270, NULL, 'G3DSA:3.20.20.10', NULL, NULL, NULL, NULL, 'Alanine racemase', NULL, NULL, 24949, 5),
(234271, NULL, 'G3DSA:3.30.2020.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33090, 5),
(234272, NULL, 'G3DSA:1.20.1480.10', NULL, NULL, NULL, NULL, 'hypothetical protein mp506/mpn330, domain 1', NULL, NULL, 16007, 5),
(234273, NULL, 'G3DSA:3.30.300.320', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234274, NULL, 'G3DSA:2.105.10.10', NULL, NULL, NULL, NULL, 'Pseudo beta propeller', NULL, NULL, 8062, 5),
(234275, NULL, 'G3DSA:3.40.50.11980', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234276, NULL, 'G3DSA:2.60.40.3190', NULL, NULL, NULL, NULL, '', NULL, NULL, 29562, 5),
(234277, NULL, 'G3DSA:3.30.1120.90', NULL, NULL, NULL, NULL, 'Nucleosome assembly protein', NULL, NULL, NULL, 5),
(234278, NULL, 'G3DSA:3.40.50.1950', NULL, NULL, NULL, NULL, '', NULL, NULL, 33108, 5),
(234279, NULL, 'G3DSA:4.10.80.390', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234280, NULL, 'G3DSA:6.10.140.1410', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234281, NULL, 'G3DSA:1.10.10.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234282, NULL, 'G3DSA:3.40.50.12380', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234283, NULL, 'G3DSA:3.90.1150.150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234284, NULL, 'G3DSA:2.60.40.1330', NULL, NULL, NULL, NULL, '', NULL, NULL, 8217, 5),
(234285, NULL, 'G3DSA:3.30.1620.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234286, NULL, 'G3DSA:3.30.950.30', NULL, NULL, NULL, NULL, 'Schlafen, AAA domain', NULL, NULL, 32005, 5),
(234287, NULL, 'G3DSA:1.25.10.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 12883, 5),
(234288, NULL, 'G3DSA:3.40.50.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234289, NULL, 'G3DSA:2.170.260.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234290, NULL, 'G3DSA:1.20.1250.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234291, NULL, 'G3DSA:2.20.28.270', NULL, NULL, NULL, NULL, '', NULL, NULL, 31316, 5),
(234292, NULL, 'G3DSA:3.90.550.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234293, NULL, 'G3DSA:1.20.1270.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234294, NULL, 'G3DSA:3.30.428.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 31944, 5),
(234295, NULL, 'G3DSA:3.30.160.850', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(234296, NULL, 'G3DSA:3.30.70.2570', NULL, NULL, NULL, NULL, '', NULL, NULL, 32786, 5),
(234297, NULL, 'G3DSA:6.10.250.460', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234298, NULL, 'G3DSA:6.10.250.2810', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234299, NULL, 'G3DSA:2.60.120.1140', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF192', NULL, NULL, 32409, 5),
(234300, NULL, 'G3DSA:2.170.8.10', NULL, NULL, NULL, NULL, 'Phosphoenolpyruvate Carboxykinase, domain 2', NULL, NULL, NULL, 5),
(234301, NULL, 'G3DSA:1.10.10.2060', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234302, NULL, 'G3DSA:1.20.20.10', NULL, NULL, NULL, NULL, 'F1F0 ATP synthase subunit C', NULL, NULL, 32512, 5),
(234303, NULL, 'G3DSA:2.170.240.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28027, 5),
(234304, NULL, 'G3DSA:2.60.40.1430', NULL, NULL, NULL, NULL, 'Perfringolysin, domain 4', NULL, NULL, 31266, 5),
(234305, NULL, 'G3DSA:3.90.70.190', NULL, NULL, NULL, NULL, 'Domain of unknown function (DUF5086)', NULL, NULL, 34526, 5),
(234306, NULL, 'G3DSA:3.30.2140.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234307, NULL, 'G3DSA:4.10.80.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234308, NULL, 'G3DSA:3.30.70.3120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234309, NULL, 'G3DSA:1.20.1280.40', NULL, NULL, NULL, NULL, 'HHA', NULL, NULL, 29936, 5),
(234310, NULL, 'G3DSA:1.20.5.4770', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234311, NULL, 'G3DSA:3.30.530.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234312, NULL, 'G3DSA:1.20.20.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 29989, 5),
(234313, NULL, 'G3DSA:6.10.250.1160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234314, NULL, 'G3DSA:2.60.510.10', NULL, NULL, NULL, NULL, 'EV matrix protein', NULL, NULL, 17022, 5),
(234315, NULL, 'G3DSA:1.20.245.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234316, NULL, 'G3DSA:1.10.185.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234317, NULL, 'G3DSA:1.10.8.190', NULL, NULL, NULL, NULL, 'Carbon monoxide dehydrogenase alpha subunit. Chain M, domain 1', NULL, NULL, NULL, 5),
(234318, NULL, 'G3DSA:2.20.25.190', NULL, NULL, NULL, NULL, '', NULL, NULL, 29815, 5),
(234319, NULL, 'G3DSA:6.10.250.380', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234320, NULL, 'G3DSA:3.30.2320.60', NULL, NULL, NULL, NULL, '', NULL, NULL, 34978, 5),
(234321, NULL, 'G3DSA:6.10.250.1240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234322, NULL, 'G3DSA:6.10.140.1030', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234323, NULL, 'G3DSA:3.40.50.11570', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF257', NULL, NULL, NULL, 5),
(234324, NULL, 'G3DSA:2.60.40.3970', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234325, NULL, 'G3DSA:3.40.50.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234326, NULL, 'G3DSA:3.40.210.10', NULL, NULL, NULL, NULL, 'PVUII Endonuclease, subunit A', NULL, NULL, 27201, 5),
(234327, NULL, 'G3DSA:3.40.50.12550', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234328, NULL, 'G3DSA:3.40.47.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 12631, 5),
(234329, NULL, 'G3DSA:3.60.21.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234330, NULL, 'G3DSA:1.10.132.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 27038, 5),
(234331, NULL, 'G3DSA:6.10.250.540', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234332, NULL, 'G3DSA:6.10.250.2730', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234333, NULL, 'G3DSA:2.40.128.250', NULL, NULL, NULL, NULL, '', NULL, NULL, 33749, 5),
(234334, NULL, 'G3DSA:3.90.370.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 24081, 5),
(234335, NULL, 'G3DSA:3.30.780.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234336, NULL, 'G3DSA:3.30.1500.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28768, 5),
(234337, NULL, 'G3DSA:3.30.70.60', NULL, NULL, NULL, NULL, '', NULL, NULL, 18310, 5),
(234338, NULL, 'G3DSA:3.30.30.110', NULL, NULL, NULL, NULL, '', NULL, NULL, 31398, 5),
(234339, NULL, 'G3DSA:1.10.238.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(234340, NULL, 'G3DSA:1.10.287.490', NULL, NULL, NULL, NULL, 'Helix hairpin bin', NULL, NULL, NULL, 5),
(234341, NULL, 'G3DSA:1.20.58.730', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234342, NULL, 'G3DSA:2.40.128.330', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234343, NULL, 'G3DSA:1.10.274.60', NULL, NULL, NULL, NULL, 'Spidroin, repetitive domain', NULL, NULL, 34592, 5),
(234344, NULL, 'G3DSA:3.90.530.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28066, 5),
(234345, NULL, 'G3DSA:3.10.20.850', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF3861', NULL, NULL, 29655, 5),
(234346, NULL, 'G3DSA:3.20.20.350', NULL, NULL, NULL, NULL, 'Diol/glycerol dehydratase, large subunit', NULL, NULL, 28018, 5),
(234347, NULL, 'G3DSA:1.10.8.250', NULL, NULL, NULL, NULL, 'DNA polymerase III clamp loader domain like', NULL, NULL, NULL, 5),
(234348, NULL, 'G3DSA:1.10.1670.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234349, NULL, 'G3DSA:3.10.660.10', NULL, NULL, NULL, NULL, 'DPH Zinc finger', NULL, NULL, 29933, 5),
(234350, NULL, 'G3DSA:3.30.410.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234351, NULL, 'G3DSA:3.40.50.1700', NULL, NULL, NULL, NULL, '', NULL, NULL, 28576, 5),
(234352, NULL, 'G3DSA:2.170.11.10', NULL, NULL, NULL, NULL, 'DNA Topoisomerase I, domain 2', NULL, NULL, 14138, 5),
(234353, NULL, 'G3DSA:3.30.910.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32424, 5),
(234354, NULL, 'G3DSA:3.40.50.1170', NULL, NULL, NULL, NULL, '', NULL, NULL, 29713, 5),
(234355, NULL, 'G3DSA:3.30.70.1060', NULL, NULL, NULL, NULL, 'Dimeric alpha+beta barrel', NULL, NULL, NULL, 5),
(234356, NULL, 'G3DSA:3.30.460.80', NULL, NULL, NULL, NULL, 'NADH:ubiquinone oxidoreductase, 30kDa subunit', NULL, NULL, 27070, 5),
(234357, NULL, 'G3DSA:2.60.40.3110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234358, NULL, 'G3DSA:1.10.20.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234359, NULL, 'G3DSA:3.40.30.40', NULL, NULL, NULL, NULL, 'Perfringolysin', NULL, NULL, NULL, 5),
(234360, NULL, 'G3DSA:3.30.420.390', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234361, NULL, 'G3DSA:2.60.120.1170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234362, NULL, 'G3DSA:1.10.10.2220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234363, NULL, 'G3DSA:6.10.140.1110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234364, NULL, 'G3DSA:6.20.270.20', NULL, NULL, NULL, NULL, 'LapD/MoxY periplasmic domain', NULL, NULL, 34929, 5),
(234365, NULL, 'G3DSA:1.10.238.110', NULL, NULL, NULL, NULL, 'Diacylglycerol kinase alpha.', NULL, NULL, 29692, 5),
(234366, NULL, 'G3DSA:2.40.300.10', NULL, NULL, NULL, NULL, 'Head decoration protein D', NULL, NULL, NULL, 5),
(234367, NULL, 'G3DSA:1.20.1300.10', NULL, NULL, NULL, NULL, 'Fumarate reductase/succinate dehydrogenase, transmembrane subunit', NULL, NULL, 31402, 5),
(234368, NULL, 'G3DSA:3.30.300.180', NULL, NULL, NULL, NULL, '', NULL, NULL, 31313, 5),
(234369, NULL, 'G3DSA:1.10.45.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 11625, 5),
(234370, NULL, 'G3DSA:1.10.238.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 18364, 5),
(234371, NULL, 'G3DSA:2.20.25.560', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234372, NULL, 'G3DSA:2.60.120.610', NULL, NULL, NULL, NULL, 'arabinofuranosyltransferase like domain', NULL, NULL, 26039, 5),
(234373, NULL, 'G3DSA:2.30.30.430', NULL, NULL, NULL, NULL, 'Kinase associated protein B domain', NULL, NULL, 31269, 5),
(234374, NULL, 'G3DSA:3.30.1370.150', NULL, NULL, NULL, NULL, 'Uncharacterised protein PF10928, DUF2810', NULL, NULL, NULL, 5),
(234375, NULL, 'G3DSA:1.20.1050.50', NULL, NULL, NULL, NULL, 'Particulate methane monooxygenase subunit c2. Chain: C', NULL, NULL, 20676, 5),
(234376, NULL, 'G3DSA:1.20.5.1010', NULL, NULL, NULL, NULL, 'TRPM, tetramerisation domain', NULL, NULL, 29667, 5),
(234377, NULL, 'G3DSA:3.40.50.11270', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234378, NULL, 'G3DSA:3.90.1530.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234379, NULL, 'G3DSA:3.40.1280.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 26973, 5);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(234380, NULL, 'G3DSA:1.20.1050.80', NULL, NULL, NULL, NULL, 'VPS9 domain', NULL, NULL, 31952, 5),
(234381, NULL, 'G3DSA:3.10.450.520', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234382, NULL, 'G3DSA:6.10.250.1610', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234383, NULL, 'G3DSA:3.30.720.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234384, NULL, 'G3DSA:1.20.58.410', NULL, NULL, NULL, NULL, 'Release factor', NULL, NULL, NULL, 5),
(234385, NULL, 'G3DSA:1.20.120.1610', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234386, NULL, 'G3DSA:1.20.5.920', NULL, NULL, NULL, NULL, 'rhodobacter sphaeroides pufx membrane protein', NULL, NULL, NULL, 5),
(234387, NULL, 'G3DSA:3.30.2300.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234388, NULL, 'G3DSA:1.20.58.1910', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234389, NULL, 'G3DSA:6.10.20.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234390, NULL, 'G3DSA:1.20.50.20', NULL, NULL, NULL, NULL, 'DnaG, RNA polymerase domain, helical bundle', NULL, NULL, NULL, 5),
(234391, NULL, 'G3DSA:6.10.140.1970', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234392, NULL, 'G3DSA:3.40.1600.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33020, 5),
(234393, NULL, 'G3DSA:3.40.1410.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 24113, 5),
(234394, NULL, 'G3DSA:2.40.160.130', NULL, NULL, NULL, NULL, 'Capsule assembly protein Wzi', NULL, NULL, 31359, 5),
(234395, NULL, 'G3DSA:1.10.8.540', NULL, NULL, NULL, NULL, 'FHIPEP family, domain 3', NULL, NULL, 35487, 5),
(234396, NULL, 'G3DSA:3.30.110.90', NULL, NULL, NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, 5),
(234397, NULL, 'G3DSA:3.50.30.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 29546, 5),
(234398, NULL, 'G3DSA:3.30.1920.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 34985, 5),
(234399, NULL, 'G3DSA:3.90.1150.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234400, NULL, 'G3DSA:1.10.286.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 9280, 5),
(234401, NULL, 'G3DSA:3.40.1440.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 13544, 5),
(234402, NULL, 'G3DSA:3.90.1370.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 8868, 5),
(234403, NULL, 'G3DSA:3.90.20.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 7631, 5),
(234404, NULL, 'G3DSA:1.20.120.1400', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234405, NULL, 'G3DSA:3.30.379.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 23403, 5),
(234406, NULL, 'G3DSA:2.30.30.660', NULL, NULL, NULL, NULL, 'Protein of unknown function (DUF3539)', NULL, NULL, NULL, 5),
(234407, NULL, 'G3DSA:1.20.272.50', NULL, NULL, NULL, NULL, 'Bacteriophage clamp loader A subunit, A'' domain', NULL, NULL, NULL, 5),
(234408, NULL, 'G3DSA:3.40.1470.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234409, NULL, 'G3DSA:1.10.10.2430', NULL, NULL, NULL, NULL, '', NULL, NULL, 29575, 5),
(234410, NULL, 'G3DSA:1.20.58.1620', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234411, NULL, 'G3DSA:2.20.28.30', NULL, NULL, NULL, NULL, 'RNA polymerase ii, chain L', NULL, NULL, NULL, 5),
(234412, NULL, 'G3DSA:1.10.1220.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234413, NULL, 'G3DSA:3.30.70.1900', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234414, NULL, 'G3DSA:2.60.40.3910', NULL, NULL, NULL, NULL, 'Inclusion body protein', NULL, NULL, 31060, 5),
(234415, NULL, 'G3DSA:1.10.540.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29535, 5),
(234416, NULL, 'G3DSA:1.20.120.1530', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234417, NULL, 'G3DSA:3.90.1300.10', NULL, NULL, NULL, NULL, 'Amidase signature (AS) domain', NULL, NULL, 32637, 5),
(234418, NULL, 'G3DSA:2.60.98.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234419, NULL, 'G3DSA:6.10.130.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 27610, 5),
(234420, NULL, 'G3DSA:1.25.40.670', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234421, NULL, 'G3DSA:1.10.10.2790', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234422, NULL, 'G3DSA:6.10.250.830', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(234423, NULL, 'G3DSA:2.60.40.3540', NULL, NULL, NULL, NULL, 'Domain of unknown function DUF4458', NULL, NULL, 31163, 5),
(234424, NULL, 'G3DSA:2.60.120.1020', NULL, NULL, NULL, NULL, 'Peptide N glycanase, PAW domain', NULL, NULL, 33877, 5),
(234425, NULL, 'G3DSA:3.30.720.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234426, NULL, 'G3DSA:1.10.1370.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234427, NULL, 'G3DSA:6.10.250.750', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234428, NULL, 'G3DSA:6.10.140.600', NULL, NULL, NULL, NULL, '', NULL, NULL, 32789, 5),
(234429, NULL, 'G3DSA:1.10.10.1270', NULL, NULL, NULL, NULL, 'Sbi, C3 binding domain IV', NULL, NULL, 30989, 5),
(234430, NULL, 'G3DSA:2.60.40.2690', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234431, NULL, 'G3DSA:1.10.8.350', NULL, NULL, NULL, NULL, 'Bacterial muramidase', NULL, NULL, NULL, 5),
(234432, NULL, 'G3DSA:2.40.128.410', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234433, NULL, 'G3DSA:2.40.50.1000', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234434, NULL, 'G3DSA:3.30.1120.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234435, NULL, 'G3DSA:2.30.110.40', NULL, NULL, NULL, NULL, 'Phage tail tube protein', NULL, NULL, 31250, 5),
(234436, NULL, 'G3DSA:2.60.40.2560', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234437, NULL, 'G3DSA:2.30.250.10', NULL, NULL, NULL, NULL, 'Aminopeptidase i, Domain 2', NULL, NULL, 19311, 5),
(234438, NULL, 'G3DSA:2.20.25.350', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234439, NULL, 'G3DSA:3.40.50.12710', NULL, NULL, NULL, NULL, '', NULL, NULL, 32893, 5),
(234440, NULL, 'G3DSA:1.20.5.420', NULL, NULL, NULL, NULL, 'Immunoglobulin FC, subunit C', NULL, NULL, NULL, 5),
(234441, NULL, 'G3DSA:1.20.960.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234442, NULL, 'G3DSA:3.30.70.2400', NULL, NULL, NULL, NULL, 'Uncharacterised protein PF13773, DUF4170', NULL, NULL, NULL, 5),
(234443, NULL, 'G3DSA:2.40.50.700', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234444, NULL, 'G3DSA:2.40.128.460', NULL, NULL, NULL, NULL, '', NULL, NULL, 33363, 5),
(234445, NULL, 'G3DSA:6.10.10.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 34970, 5),
(234446, NULL, 'G3DSA:6.10.250.2600', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5),
(234447, NULL, 'G3DSA:2.170.210.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32168, 5),
(234448, NULL, 'G3DSA:2.60.120.830', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234449, NULL, 'G3DSA:6.10.250.1320', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234450, NULL, 'G3DSA:2.40.50.330', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234451, NULL, 'G3DSA:2.60.120.460', NULL, NULL, NULL, NULL, '', NULL, NULL, 24628, 5),
(234452, NULL, 'G3DSA:3.90.70.60', NULL, NULL, NULL, NULL, '', NULL, NULL, 32814, 5),
(234453, NULL, 'G3DSA:3.40.50.11350', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234454, NULL, 'G3DSA:1.10.490.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234455, NULL, 'G3DSA:3.30.70.3040', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234456, NULL, 'G3DSA:6.20.370.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234457, NULL, 'G3DSA:4.10.80.380', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234458, NULL, 'G3DSA:3.40.50.1910', NULL, NULL, NULL, NULL, '', NULL, NULL, 24269, 5),
(234459, NULL, 'G3DSA:3.40.630.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 31639, 5),
(234460, NULL, 'G3DSA:1.10.357.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234461, NULL, 'G3DSA:1.10.10.690', NULL, NULL, NULL, NULL, '', NULL, NULL, 26822, 5),
(234462, NULL, 'G3DSA:2.30.30.390', NULL, NULL, NULL, NULL, '', NULL, NULL, 28867, 5),
(234463, NULL, 'G3DSA:3.30.50.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234464, NULL, 'G3DSA:1.10.10.520', NULL, NULL, NULL, NULL, 'Ubiquitin activating enzymes (Uba3). Chain: B, domain 2', NULL, NULL, 16380, 5),
(234465, NULL, 'G3DSA:6.10.250.1370', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234466, NULL, 'G3DSA:1.10.569.10', NULL, NULL, NULL, NULL, 'Aldehyde Ferredoxin Oxidoreductase Protein, subunit A, domain 2', NULL, NULL, 12624, 5);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(234467, NULL, 'G3DSA:3.40.50.12760', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234468, NULL, 'G3DSA:3.30.70.2490', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234469, NULL, 'G3DSA:3.30.54.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234470, NULL, 'G3DSA:3.30.110.150', NULL, NULL, NULL, NULL, '', NULL, NULL, 32346, 5),
(234471, NULL, 'G3DSA:6.20.240.30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5),
(234472, NULL, 'G3DSA:3.10.250.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31520, 5),
(234473, NULL, 'G3DSA:6.10.140.1840', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234474, NULL, 'G3DSA:2.60.40.1280', NULL, NULL, NULL, NULL, '', NULL, NULL, 13188, 5),
(234475, NULL, 'G3DSA:3.10.20.520', NULL, NULL, NULL, NULL, 'Phenylacetic acid degradation B', NULL, NULL, 32802, 5),
(234476, NULL, 'G3DSA:2.60.120.1250', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234477, NULL, 'G3DSA:1.10.287.3080', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234478, NULL, 'G3DSA:1.10.590.10', NULL, NULL, NULL, NULL, 'Chorismate mutase, AroQ class superfamily, eukaryotic', NULL, NULL, 29171, 5),
(234479, NULL, 'G3DSA:2.60.40.3240', NULL, NULL, NULL, NULL, '', NULL, NULL, 34660, 5),
(234480, NULL, 'G3DSA:3.30.70.1030', NULL, NULL, NULL, NULL, 'Apc35880; domain 1', NULL, NULL, NULL, 5),
(234481, NULL, 'G3DSA:3.30.1930.10', NULL, NULL, NULL, NULL, 'capsid protein of prophage domain', NULL, NULL, NULL, 5),
(234482, NULL, 'G3DSA:2.40.10.210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234483, NULL, 'G3DSA:3.30.70.1400', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234484, NULL, 'G3DSA:3.30.420.260', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234485, NULL, 'G3DSA:6.10.140.1890', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234486, NULL, 'G3DSA:1.10.287.160', NULL, NULL, NULL, NULL, 'HR1 repeat', NULL, NULL, NULL, 5),
(234487, NULL, 'G3DSA:1.10.287.1490', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234488, NULL, 'G3DSA:1.20.120.1160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234489, NULL, 'G3DSA:1.10.150.700', NULL, NULL, NULL, NULL, 'PolC, middle finger domain', NULL, NULL, 36609, 5),
(234490, NULL, 'G3DSA:2.60.120.1350', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF4465', NULL, NULL, NULL, 5),
(234491, NULL, 'G3DSA:2.30.260.10', NULL, NULL, NULL, NULL, 'putative xylanase like domain', NULL, NULL, NULL, 5),
(234492, NULL, 'G3DSA:3.90.870.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234493, NULL, 'G3DSA:3.30.310.250', NULL, NULL, NULL, NULL, 'Sporulation inhibitor of replication protein SirA', NULL, NULL, 31389, 5),
(234494, NULL, 'G3DSA:1.10.287.2250', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234495, NULL, 'G3DSA:2.60.200.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 12993, 5),
(234496, NULL, 'G3DSA:3.10.570.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234497, NULL, 'G3DSA:3.20.180.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28233, 5),
(234498, NULL, 'G3DSA:1.10.8.1070', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234499, NULL, 'G3DSA:3.90.460.10', NULL, NULL, NULL, NULL, 'Ferredoxin thioredoxin reductase catalytic beta subunit', NULL, NULL, 30999, 5),
(234500, NULL, 'G3DSA:3.20.20.540', NULL, NULL, NULL, NULL, 'Radical SAM ThiC family, central domain', NULL, NULL, 32249, 5),
(234501, NULL, 'G3DSA:1.10.287.4070', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234502, NULL, 'G3DSA:6.10.250.3310', NULL, NULL, NULL, NULL, 'signal transducer and activator of transcription 1', NULL, NULL, 31303, 5),
(234503, NULL, 'G3DSA:6.10.250.2940', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234504, NULL, 'G3DSA:6.10.250.590', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234505, NULL, 'G3DSA:1.10.287.720', NULL, NULL, NULL, NULL, 'Pollen allergen ole e 6', NULL, NULL, 31401, 5),
(234506, NULL, 'G3DSA:3.30.460.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 28173, 5),
(234507, NULL, 'G3DSA:2.40.30.220', NULL, NULL, NULL, NULL, 'Photosystem II Psb28', NULL, NULL, 33973, 5),
(234508, NULL, 'G3DSA:3.30.980.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(234509, NULL, 'G3DSA:2.40.160.200', NULL, NULL, NULL, NULL, '', NULL, NULL, 32049, 5),
(234510, NULL, 'G3DSA:3.30.505.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234511, NULL, 'G3DSA:3.40.50.11790', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234512, NULL, 'G3DSA:3.30.1610.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 27826, 5),
(234513, NULL, 'G3DSA:3.90.480.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234514, NULL, 'G3DSA:3.30.70.3560', NULL, NULL, NULL, NULL, '', NULL, NULL, 31681, 5),
(234515, NULL, 'G3DSA:1.20.58.780', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234516, NULL, 'G3DSA:6.10.250.3410', NULL, NULL, NULL, NULL, 'DBF zinc finger', NULL, NULL, 27825, 5),
(234517, NULL, 'G3DSA:3.60.40.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28092, 5),
(234518, NULL, 'G3DSA:6.10.140.590', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234519, NULL, 'G3DSA:1.20.890.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234520, NULL, 'G3DSA:1.20.930.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 33251, 5),
(234521, NULL, 'G3DSA:1.10.10.1660', NULL, NULL, NULL, NULL, 'Nicotine adenine dinucleotide glycohydrolase, helical linker domain', NULL, NULL, 30553, 5),
(234522, NULL, 'G3DSA:1.10.12.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 7427, 5),
(234523, NULL, 'G3DSA:2.40.128.200', NULL, NULL, NULL, NULL, '', NULL, NULL, 28235, 5),
(234524, NULL, 'G3DSA:2.40.30.10', NULL, NULL, NULL, NULL, 'Translation factors', NULL, NULL, NULL, 5),
(234525, NULL, 'G3DSA:1.10.3230.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234526, NULL, 'G3DSA:3.30.450.410', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234527, NULL, 'G3DSA:2.160.20.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234528, NULL, 'G3DSA:3.20.90.10', NULL, NULL, NULL, NULL, 'Tubby Protein; Chain A', NULL, NULL, 23935, 5),
(234529, NULL, 'G3DSA:2.20.25.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234530, NULL, 'G3DSA:3.30.1680.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234531, NULL, 'G3DSA:2.40.30.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234532, NULL, 'G3DSA:3.30.60.230', NULL, NULL, NULL, NULL, 'Lsr2, dimerization domain', NULL, NULL, 34774, 5),
(234533, NULL, 'G3DSA:6.10.140.1080', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234534, NULL, 'G3DSA:3.30.710.10', NULL, NULL, NULL, NULL, 'Potassium Channel Kv1.1; Chain A', NULL, NULL, 13762, 5),
(234535, NULL, 'G3DSA:1.20.58.860', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234536, NULL, 'G3DSA:1.20.58.940', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234537, NULL, 'G3DSA:2.60.220.50', NULL, NULL, NULL, NULL, '', NULL, NULL, 33564, 5),
(234538, NULL, 'G3DSA:6.10.250.410', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234539, NULL, 'G3DSA:3.90.190.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 30009, 5),
(234540, NULL, 'G3DSA:1.20.920.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234541, NULL, 'G3DSA:1.10.8.810', NULL, NULL, NULL, NULL, 'Daxx helical bundle domain', NULL, NULL, 31227, 5),
(234542, NULL, 'G3DSA:1.10.472.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234543, NULL, 'G3DSA:1.20.1270.180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234544, NULL, 'G3DSA:3.30.40.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234545, NULL, 'G3DSA:3.90.320.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 28377, 5),
(234546, NULL, 'G3DSA:3.60.130.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 30956, 5),
(234547, NULL, 'G3DSA:2.30.29.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234548, NULL, 'G3DSA:3.20.170.50', NULL, NULL, NULL, NULL, '', NULL, NULL, 34313, 5),
(234549, NULL, 'G3DSA:1.20.1460.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234550, NULL, 'G3DSA:2.20.28.300', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234551, NULL, 'G3DSA:1.20.120.1870', NULL, NULL, NULL, NULL, 'Fic/DOC protein, Fido domain', NULL, NULL, NULL, 5),
(234552, NULL, 'G3DSA:2.60.40.2980', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234553, NULL, 'G3DSA:3.30.70.1740', NULL, NULL, NULL, NULL, '', NULL, NULL, 30174, 5);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(234554, NULL, 'G3DSA:2.30.22.10', NULL, NULL, NULL, NULL, 'Head domain of nucleotide exchange factor GrpE', NULL, NULL, 9926, 5),
(234555, NULL, 'G3DSA:2.40.250.10', NULL, NULL, NULL, NULL, 'Core binding factor, beta subunit', NULL, NULL, 33372, 5),
(234556, NULL, 'G3DSA:1.20.120.1450', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234557, NULL, 'G3DSA:1.10.1330.10', NULL, NULL, NULL, NULL, 'Dockerin domain', NULL, NULL, 31543, 5),
(234558, NULL, 'G3DSA:2.40.50.200', NULL, NULL, NULL, NULL, '', NULL, NULL, 31971, 5),
(234559, NULL, 'G3DSA:1.20.5.1030', NULL, NULL, NULL, NULL, 'Preprotein translocase secy subunit', NULL, NULL, 29997, 5),
(234560, NULL, 'G3DSA:3.90.1600.10', NULL, NULL, NULL, NULL, 'Palm domain of DNA polymerase', NULL, NULL, 2811, 5),
(234561, NULL, 'G3DSA:3.30.70.2360', NULL, NULL, NULL, NULL, '', NULL, NULL, 33971, 5),
(234562, NULL, 'G3DSA:3.10.380.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32235, 5),
(234563, NULL, 'G3DSA:3.30.499.10', NULL, NULL, NULL, NULL, 'Aconitase, domain 3', NULL, NULL, 12600, 5),
(234564, NULL, 'G3DSA:3.55.40.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 29322, 5),
(234565, NULL, 'G3DSA:6.10.250.1450', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234566, NULL, 'G3DSA:3.40.50.11950', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234567, NULL, 'G3DSA:3.30.70.3170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234568, NULL, 'G3DSA:3.90.1310.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234569, NULL, 'G3DSA:2.40.420.10', NULL, NULL, NULL, NULL, 'conserved putative lor/sdh protein from methanococcus maripaludis s2 domain', NULL, NULL, NULL, 5),
(234570, NULL, 'G3DSA:1.10.150.240', NULL, NULL, NULL, NULL, 'Putative phosphatase; domain 2', NULL, NULL, 15591, 5),
(234571, NULL, 'G3DSA:4.10.10.10', NULL, NULL, NULL, NULL, 'Metallothionein Isoform II', NULL, NULL, 20997, 5),
(234572, NULL, 'G3DSA:3.20.140.10', NULL, NULL, NULL, NULL, 'nicotinate phosphoribosyltransferase', NULL, NULL, NULL, 5),
(234573, NULL, 'G3DSA:3.30.70.3330', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234574, NULL, 'G3DSA:6.10.250.1970', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234575, NULL, 'G3DSA:2.50.20.10', NULL, NULL, NULL, NULL, 'Lipoprotein localisation LolA/LolB/LppX', NULL, NULL, NULL, 5),
(234576, NULL, 'G3DSA:6.10.140.2100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234577, NULL, 'G3DSA:4.10.60.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 31858, 5),
(234578, NULL, 'G3DSA:1.20.58.1700', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234579, NULL, 'G3DSA:3.30.1050.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234580, NULL, 'G3DSA:1.10.10.350', NULL, NULL, NULL, NULL, '', NULL, NULL, 14736, 5),
(234581, NULL, 'G3DSA:3.30.450.30', NULL, NULL, NULL, NULL, 'Dynein light chain 2a, cytoplasmic', NULL, NULL, NULL, 5),
(234582, NULL, 'G3DSA:3.90.1030.10', NULL, NULL, NULL, NULL, 'Ribosomal protein L17', NULL, NULL, 28238, 5),
(234583, NULL, 'G3DSA:1.20.1270.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 10651, 5),
(234584, NULL, 'G3DSA:4.10.95.10', NULL, NULL, NULL, NULL, 'Cytochrome c oxidase, subunit VIa', NULL, NULL, 27704, 5),
(234585, NULL, 'G3DSA:1.10.3490.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234586, NULL, 'G3DSA:3.10.20.700', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234587, NULL, 'G3DSA:2.40.128.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 12031, 5),
(234588, NULL, 'G3DSA:6.10.20.150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234589, NULL, 'G3DSA:1.10.10.2010', NULL, NULL, NULL, NULL, '', NULL, NULL, 29953, 5),
(234590, NULL, 'G3DSA:3.30.420.180', NULL, NULL, NULL, NULL, '', NULL, NULL, 30147, 5),
(234591, NULL, 'G3DSA:6.10.250.1660', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234592, NULL, 'G3DSA:1.10.1200.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234593, NULL, 'G3DSA:1.20.1420.20', NULL, NULL, NULL, NULL, 'M75 peptidase, HXXE motif', NULL, NULL, 33438, 5),
(234594, NULL, 'G3DSA:3.40.50.11480', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(234595, NULL, 'G3DSA:4.10.1010.10', NULL, NULL, NULL, NULL, 'Apical membrane antigen 1', NULL, NULL, 12291, 5),
(234596, NULL, 'G3DSA:1.10.490.30', NULL, NULL, NULL, NULL, 'Colicin', NULL, NULL, 31087, 5),
(234597, NULL, 'G3DSA:3.30.70.520', NULL, NULL, NULL, NULL, '', NULL, NULL, 16409, 5),
(234598, NULL, 'G3DSA:3.30.40.10', NULL, NULL, NULL, NULL, 'Zinc/RING finger domain, C3HC4 (zinc finger)', NULL, NULL, 7167, 5),
(234599, NULL, 'G3DSA:2.160.30.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234600, NULL, 'G3DSA:3.40.1050.10', NULL, NULL, NULL, NULL, 'Carbonic anhydrase', NULL, NULL, 28036, 5),
(234601, NULL, 'G3DSA:3.10.330.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234602, NULL, 'G3DSA:3.40.1350.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234603, NULL, 'G3DSA:6.10.250.1530', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234604, NULL, 'G3DSA:3.10.510.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 16516, 5),
(234605, NULL, 'G3DSA:2.40.50.120', NULL, NULL, NULL, NULL, '', NULL, NULL, 9642, 5),
(234606, NULL, 'G3DSA:2.20.20.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234607, NULL, 'G3DSA:2.30.240.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 27925, 5),
(234608, NULL, 'G3DSA:6.10.140.2230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234609, NULL, 'G3DSA:2.60.40.2770', NULL, NULL, NULL, NULL, '', NULL, NULL, 33269, 5),
(234610, NULL, 'G3DSA:1.10.565.10', NULL, NULL, NULL, NULL, 'Retinoid X Receptor', NULL, NULL, 29864, 5),
(234611, NULL, 'G3DSA:3.30.70.2150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234612, NULL, 'G3DSA:6.10.250.1400', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234613, NULL, 'G3DSA:2.60.40.230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234614, NULL, 'G3DSA:3.30.390.140', NULL, NULL, NULL, NULL, '', NULL, NULL, 31094, 5),
(234615, NULL, 'G3DSA:1.10.1200.210', NULL, NULL, NULL, NULL, '', NULL, NULL, 29101, 5),
(234616, NULL, 'G3DSA:2.30.30.180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234617, NULL, 'G3DSA:3.30.160.430', NULL, NULL, NULL, NULL, '', NULL, NULL, 31453, 5),
(234618, NULL, 'G3DSA:2.20.20.150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234619, NULL, 'G3DSA:3.50.80.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 16148, 5),
(234620, NULL, 'G3DSA:3.40.190.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234621, NULL, 'G3DSA:1.20.900.10', NULL, NULL, NULL, NULL, 'Dbl homology (DH) domain', NULL, NULL, 20821, 5),
(234622, NULL, 'G3DSA:1.10.30.20', NULL, NULL, NULL, NULL, 'Bacterial XPD DNA helicase, FeS cluster domain', NULL, NULL, 33668, 5),
(234623, NULL, 'G3DSA:6.10.220.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234624, NULL, 'G3DSA:2.60.120.310', NULL, NULL, NULL, NULL, '', NULL, NULL, 28129, 5),
(234625, NULL, 'G3DSA:3.20.170.20', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF952', NULL, NULL, NULL, 5),
(234626, NULL, 'G3DSA:4.10.1130.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234627, NULL, 'G3DSA:6.10.250.620', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234628, NULL, 'G3DSA:1.10.60.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 31725, 5),
(234629, NULL, 'G3DSA:3.30.920.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234630, NULL, 'G3DSA:1.20.5.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 28310, 5),
(234631, NULL, 'G3DSA:2.60.40.2650', NULL, NULL, NULL, NULL, 'Rubella membrane glycoprotein E1, domain 3', NULL, NULL, 36643, 5),
(234632, NULL, 'G3DSA:3.10.170.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234633, NULL, 'G3DSA:1.20.120.1760', NULL, NULL, NULL, NULL, '', NULL, NULL, 34876, 5),
(234634, NULL, 'G3DSA:3.40.50.10590', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234635, NULL, 'G3DSA:3.30.450.200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234636, NULL, 'G3DSA:3.30.1020.10', NULL, NULL, NULL, NULL, 'Antioxidant, Horf6; Chain A, domain2', NULL, NULL, NULL, 5),
(234637, NULL, 'G3DSA:1.10.3280.10', NULL, NULL, NULL, NULL, 'Siroheme synthase; domain 3', NULL, NULL, NULL, 5);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(234638, NULL, 'G3DSA:2.70.50.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234639, NULL, 'G3DSA:2.40.30.290', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234640, NULL, 'G3DSA:6.10.250.670', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234641, NULL, 'G3DSA:1.10.1220.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234642, NULL, 'G3DSA:2.60.40.10', NULL, NULL, NULL, NULL, 'Immunoglobulins', NULL, NULL, 11361, 5),
(234643, NULL, 'G3DSA:3.30.1490.80', NULL, NULL, NULL, NULL, '', NULL, NULL, 7353, 5),
(234644, NULL, 'G3DSA:3.90.209.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 17577, 5),
(234645, NULL, 'G3DSA:1.10.8.640', NULL, NULL, NULL, NULL, 'Cytochrome C biogenesis protein', NULL, NULL, 31009, 5),
(234646, NULL, 'G3DSA:1.10.3190.10', NULL, NULL, NULL, NULL, 'yfbu gene product, domain 2', NULL, NULL, 15665, 5),
(234647, NULL, 'G3DSA:2.20.25.270', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234648, NULL, 'G3DSA:1.20.1690.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234649, NULL, 'G3DSA:2.10.110.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234650, NULL, 'G3DSA:3.30.450.330', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234651, NULL, 'G3DSA:4.10.790.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234652, NULL, 'G3DSA:3.65.10.10', NULL, NULL, NULL, NULL, 'Enolpyruvate transferase domain', NULL, NULL, 28578, 5),
(234653, NULL, 'G3DSA:2.170.130.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 30099, 5),
(234654, NULL, 'G3DSA:4.10.75.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234655, NULL, 'G3DSA:3.10.450.140', NULL, NULL, NULL, NULL, 'dsDNA mimic, putative', NULL, NULL, 32436, 5),
(234656, NULL, 'G3DSA:3.50.50.60', NULL, NULL, NULL, NULL, '', NULL, NULL, 27422, 5),
(234657, NULL, 'G3DSA:1.20.1270.360', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234658, NULL, 'G3DSA:3.30.70.2280', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234659, NULL, 'G3DSA:1.20.5.4980', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234660, NULL, 'G3DSA:1.20.120.910', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234661, NULL, 'G3DSA:2.60.40.2850', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234662, NULL, 'G3DSA:6.10.250.1840', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234663, NULL, 'G3DSA:3.40.210.20', NULL, NULL, NULL, NULL, 'MvaI/BcnI restriction endonuclease, catalytic domain', NULL, NULL, 36310, 5),
(234664, NULL, 'G3DSA:1.20.5.1930', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234665, NULL, 'G3DSA:6.10.250.980', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234666, NULL, 'G3DSA:1.10.287.3610', NULL, NULL, NULL, NULL, '', NULL, NULL, 28394, 5),
(234667, NULL, 'G3DSA:2.60.120.1090', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234668, NULL, 'G3DSA:3.30.230.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234669, NULL, 'G3DSA:2.10.70.10', NULL, NULL, NULL, NULL, 'Complement Module, domain 1', NULL, NULL, NULL, 5),
(234670, NULL, 'G3DSA:3.30.70.1610', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234671, NULL, 'G3DSA:1.20.58.590', NULL, NULL, NULL, NULL, 'Chromosome partition protein MukF, middle domain', NULL, NULL, 28571, 5),
(234672, NULL, 'G3DSA:6.10.250.1580', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234673, NULL, 'G3DSA:1.10.246.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234674, NULL, 'G3DSA:3.40.140.80', NULL, NULL, NULL, NULL, '', NULL, NULL, 34925, 5),
(234675, NULL, 'G3DSA:1.10.287.4280', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234676, NULL, 'G3DSA:3.20.19.10', NULL, NULL, NULL, NULL, 'Aconitase, domain 4', NULL, NULL, 10945, 5),
(234677, NULL, 'G3DSA:2.60.40.3030', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234678, NULL, 'G3DSA:3.50.20.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 11205, 5),
(234679, NULL, 'G3DSA:2.60.40.1490', NULL, NULL, NULL, NULL, '', NULL, NULL, 32046, 5),
(234680, NULL, 'G3DSA:1.20.120.1850', NULL, NULL, NULL, NULL, 'Ebh helix bundles repeating unit (S and A modules)', NULL, NULL, NULL, 5),
(234681, NULL, 'G3DSA:6.10.250.3170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(234682, NULL, 'G3DSA:4.10.290.10', NULL, NULL, NULL, NULL, 'Bacteriorhodopsin Fragment', NULL, NULL, NULL, 5),
(234683, NULL, 'G3DSA:1.20.1440.130', NULL, NULL, NULL, NULL, 'VKOR domain', NULL, NULL, 33464, 5),
(234684, NULL, 'G3DSA:3.30.70.1300', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234685, NULL, 'G3DSA:6.10.250.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234686, NULL, 'G3DSA:1.20.81.30', NULL, NULL, NULL, NULL, 'Type II secretion system (T2SS), domain F', NULL, NULL, 30884, 5),
(234687, NULL, 'G3DSA:1.20.1270.390', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234688, NULL, 'G3DSA:1.10.287.310', NULL, NULL, NULL, NULL, '', NULL, NULL, 32613, 5),
(234689, NULL, 'G3DSA:1.10.1410.30', NULL, NULL, NULL, NULL, 'CCA tRNA nucleotidyltransferase, domain 2', NULL, NULL, 30566, 5),
(234690, NULL, 'G3DSA:1.10.2030.10', NULL, NULL, NULL, NULL, 'Anthrax toxin lethal factor, domain 3, chain A', NULL, NULL, NULL, 5),
(234691, NULL, 'G3DSA:3.30.160.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234692, NULL, 'G3DSA:3.90.1400.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 18951, 5),
(234693, NULL, 'G3DSA:3.30.200.190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234694, NULL, 'G3DSA:2.160.20.180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234695, NULL, 'G3DSA:3.30.160.620', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234696, NULL, 'G3DSA:2.40.128.80', NULL, NULL, NULL, NULL, 'Cathepsin C, exclusion domain', NULL, NULL, 31485, 5),
(234697, NULL, 'G3DSA:2.60.40.3820', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234698, NULL, 'G3DSA:1.20.58.2240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234699, NULL, 'G3DSA:3.30.1490.50', NULL, NULL, NULL, NULL, '', NULL, NULL, 7155, 5),
(234700, NULL, 'G3DSA:1.20.5.650', NULL, NULL, NULL, NULL, 'Single helix bin', NULL, NULL, NULL, 5),
(234701, NULL, 'G3DSA:3.10.20.360', NULL, NULL, NULL, NULL, 'CKK domain', NULL, NULL, 29904, 5),
(234702, NULL, 'G3DSA:6.10.250.230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234703, NULL, 'G3DSA:3.40.390.10', NULL, NULL, NULL, NULL, 'Collagenase (Catalytic Domain)', NULL, NULL, 12024, 5),
(234704, NULL, 'G3DSA:1.20.120.1950', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234705, NULL, 'G3DSA:1.10.1740.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234706, NULL, 'G3DSA:1.20.970.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234707, NULL, 'G3DSA:3.90.640.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234708, NULL, 'G3DSA:6.10.10.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234709, NULL, 'G3DSA:3.40.710.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 7550, 5),
(234710, NULL, 'G3DSA:3.40.1700.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28918, 5),
(234711, NULL, 'G3DSA:2.60.40.1780', NULL, NULL, NULL, NULL, 'Carmovirus coat protein', NULL, NULL, NULL, 5),
(234712, NULL, 'G3DSA:1.20.58.120', NULL, NULL, NULL, NULL, 'BAG domain', NULL, NULL, 33396, 5),
(234713, NULL, 'G3DSA:3.90.660.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234714, NULL, 'G3DSA:6.10.140.1260', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234715, NULL, 'G3DSA:6.10.250.200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234716, NULL, 'G3DSA:2.70.160.11', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234717, NULL, 'G3DSA:2.60.40.2090', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234718, NULL, 'G3DSA:1.10.287.1260', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234719, NULL, 'G3DSA:2.60.120.1560', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234720, NULL, 'G3DSA:6.10.250.1010', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234721, NULL, 'G3DSA:3.90.400.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 34207, 5),
(234722, NULL, 'G3DSA:3.90.920.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 36646, 5),
(234723, NULL, 'G3DSA:3.90.75.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234724, NULL, 'G3DSA:6.10.10.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234725, NULL, 'G3DSA:1.20.58.2190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(234726, NULL, 'G3DSA:1.10.10.2770', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234727, NULL, 'G3DSA:2.60.40.650', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234728, NULL, 'G3DSA:2.60.40.2220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234729, NULL, 'G3DSA:6.10.140.380', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234730, NULL, 'G3DSA:1.10.287.2460', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234731, NULL, 'G3DSA:2.60.40.810', NULL, NULL, NULL, NULL, '', NULL, NULL, 25640, 5),
(234732, NULL, 'G3DSA:3.30.70.3510', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234733, NULL, 'G3DSA:3.30.70.3570', NULL, NULL, NULL, NULL, 'MvaI/BcnI restriction endonuclease, recognition domain', NULL, NULL, 36426, 5),
(234734, NULL, 'G3DSA:2.60.98.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234735, NULL, 'G3DSA:2.60.40.2060', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234736, NULL, 'G3DSA:2.60.370.10', NULL, NULL, NULL, NULL, 'Ctag/Cox11', NULL, NULL, 16064, 5),
(234737, NULL, 'G3DSA:1.20.120.220', NULL, NULL, NULL, NULL, 'ATP synthase, F0 complex, subunit A', NULL, NULL, 11220, 5),
(234738, NULL, 'G3DSA:6.10.140.1290', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234739, NULL, 'G3DSA:3.40.50.11580', NULL, NULL, NULL, NULL, '', NULL, NULL, 34831, 5),
(234740, NULL, 'G3DSA:3.30.70.960', NULL, NULL, NULL, NULL, 'SEA domain', NULL, NULL, 32789, 5),
(234741, NULL, 'G3DSA:2.40.330.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 12943, 5),
(234742, NULL, 'G3DSA:1.10.287.2510', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234743, NULL, 'G3DSA:2.40.50.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234744, NULL, 'G3DSA:1.20.1250.60', NULL, NULL, NULL, NULL, 'Interferon lambda', NULL, NULL, 28816, 5),
(234745, NULL, 'G3DSA:6.10.250.1920', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234746, NULL, 'G3DSA:6.10.140.1660', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234747, NULL, 'G3DSA:2.10.25.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234748, NULL, 'G3DSA:3.30.40.190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234749, NULL, 'G3DSA:2.40.10.390', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234750, NULL, 'G3DSA:2.60.40.4240', NULL, NULL, NULL, NULL, 'Transcription activator, Churchill', NULL, NULL, 27598, 5),
(234751, NULL, 'G3DSA:3.30.1360.130', NULL, NULL, NULL, NULL, 'Dipeptide transport protein', NULL, NULL, NULL, 5),
(234752, NULL, 'G3DSA:6.10.250.2420', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234753, NULL, 'G3DSA:3.30.70.2880', NULL, NULL, NULL, NULL, '', NULL, NULL, 32858, 5),
(234754, NULL, 'G3DSA:1.10.3600.10', NULL, NULL, NULL, NULL, 'Putative bacterial toxin ydaT', NULL, NULL, 29282, 5),
(234755, NULL, 'G3DSA:3.30.460.60', NULL, NULL, NULL, NULL, 'Poxvirus poly(A) polymerase, nucleotidyltransferase domain', NULL, NULL, 31239, 5),
(234756, NULL, 'G3DSA:1.20.120.350', NULL, NULL, NULL, NULL, '', NULL, NULL, 21702, 5),
(234757, NULL, 'G3DSA:3.40.50.10810', NULL, NULL, NULL, NULL, '', NULL, NULL, 32787, 5),
(234758, NULL, 'G3DSA:3.30.390.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 11577, 5),
(234759, NULL, 'G3DSA:1.10.287.1880', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234760, NULL, 'G3DSA:1.20.58.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234761, NULL, 'G3DSA:1.20.1270.280', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234762, NULL, 'G3DSA:3.30.1680.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234763, NULL, 'G3DSA:3.30.70.1220', NULL, NULL, NULL, NULL, '', NULL, NULL, 13701, 5),
(234764, NULL, 'G3DSA:2.40.128.640', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234765, NULL, 'G3DSA:1.10.375.10', NULL, NULL, NULL, NULL, 'Human Immunodeficiency Virus Type 1 Capsid Protein', NULL, NULL, 8814, 5),
(234766, NULL, 'G3DSA:3.40.50.10170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234767, NULL, 'G3DSA:1.10.150.470', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234768, NULL, 'G3DSA:2.60.40.200', NULL, NULL, NULL, NULL, 'Superoxide dismutase, copper/zinc binding domain', NULL, NULL, 27871, 5);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(234769, NULL, 'G3DSA:3.30.40.240', NULL, NULL, NULL, NULL, 'Transglutaminase elicitor, body domain', NULL, NULL, NULL, 5),
(234770, NULL, 'G3DSA:3.90.226.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234771, NULL, 'G3DSA:3.30.420.130', NULL, NULL, NULL, NULL, '', NULL, NULL, 33383, 5),
(234772, NULL, 'G3DSA:3.40.190.180', NULL, NULL, NULL, NULL, 'Cypl, domain I', NULL, NULL, 34584, 5),
(234773, NULL, 'G3DSA:3.30.310.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 13644, 5),
(234774, NULL, 'G3DSA:1.20.58.1090', NULL, NULL, NULL, NULL, 'Phage polarity suppression protein monomer', NULL, NULL, NULL, 5),
(234775, NULL, 'G3DSA:2.30.31.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 33573, 5),
(234776, NULL, 'G3DSA:1.20.5.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234777, NULL, 'G3DSA:1.10.442.10', NULL, NULL, NULL, NULL, 'Cytochrome c oxidase subunit IV', NULL, NULL, 30554, 5),
(234778, NULL, 'G3DSA:3.30.56.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234779, NULL, 'G3DSA:2.60.40.1670', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234780, NULL, 'G3DSA:1.20.5.490', NULL, NULL, NULL, NULL, 'Single helix bin', NULL, NULL, NULL, 5),
(234781, NULL, 'G3DSA:3.10.450.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234782, NULL, 'G3DSA:6.10.250.3140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234783, NULL, 'G3DSA:6.10.250.850', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234784, NULL, 'G3DSA:3.40.50.2060', NULL, NULL, NULL, NULL, '', NULL, NULL, 34080, 5),
(234785, NULL, 'G3DSA:6.10.140.2210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234786, NULL, 'G3DSA:1.20.142.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 27711, 5),
(234787, NULL, 'G3DSA:2.115.10.20', NULL, NULL, NULL, NULL, 'Glycosyl hydrolase domain; family 43', NULL, NULL, 15954, 5),
(234788, NULL, 'G3DSA:1.20.89.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234789, NULL, 'G3DSA:1.20.140.50', NULL, NULL, NULL, NULL, 'alix/aip1 like domains', NULL, NULL, NULL, 5),
(234790, NULL, 'G3DSA:1.20.5.1430', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234791, NULL, 'G3DSA:3.30.2320.10', NULL, NULL, NULL, NULL, 'hypothetical protein PF0899 domain', NULL, NULL, NULL, 5),
(234792, NULL, 'G3DSA:2.60.40.2870', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234793, NULL, 'G3DSA:2.30.30.1190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234794, NULL, 'G3DSA:1.20.140.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234795, NULL, 'G3DSA:3.30.60.210', NULL, NULL, NULL, NULL, 'Stc1 domain', NULL, NULL, 34943, 5),
(234796, NULL, 'G3DSA:6.20.370.30', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5),
(234797, NULL, 'G3DSA:2.40.10.520', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234798, NULL, 'G3DSA:3.40.50.11370', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234799, NULL, 'G3DSA:1.10.8.900', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234800, NULL, 'G3DSA:3.30.1350.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234801, NULL, 'G3DSA:1.20.120.560', NULL, NULL, NULL, NULL, 'alix/aip1 in complex with the ypdl late domain', NULL, NULL, NULL, 5),
(234802, NULL, 'G3DSA:1.20.890.20', NULL, NULL, NULL, NULL, 'mpn423 like domain', NULL, NULL, NULL, 5),
(234803, NULL, 'G3DSA:6.10.140.2000', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234804, NULL, 'G3DSA:3.30.1920.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234805, NULL, 'G3DSA:3.30.1490.270', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234806, NULL, 'G3DSA:1.20.58.310', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234807, NULL, 'G3DSA:2.60.120.660', NULL, NULL, NULL, NULL, 'icosahedral virus', NULL, NULL, NULL, 5),
(234808, NULL, 'G3DSA:3.40.50.1480', NULL, NULL, NULL, NULL, '', NULL, NULL, 34845, 5),
(234809, NULL, 'G3DSA:3.30.70.940', NULL, NULL, NULL, NULL, '', NULL, NULL, 31513, 5),
(234810, NULL, 'G3DSA:3.30.70.1950', NULL, NULL, NULL, NULL, '', NULL, NULL, 32438, 5),
(234811, NULL, 'G3DSA:6.10.250.3350', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(234812, NULL, 'G3DSA:3.30.1120.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234813, NULL, 'G3DSA:1.20.5.1190', NULL, NULL, NULL, NULL, 'iswi atpase', NULL, NULL, NULL, 5),
(234814, NULL, 'G3DSA:1.10.10.2740', NULL, NULL, NULL, NULL, '', NULL, NULL, 30306, 5),
(234815, NULL, 'G3DSA:6.10.140.1420', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234816, NULL, 'G3DSA:3.30.190.10', NULL, NULL, NULL, NULL, 'Ribulose bisphosphate carboxylase, small subunit', NULL, NULL, 32365, 5),
(234817, NULL, 'G3DSA:6.10.280.180', NULL, NULL, NULL, NULL, '', NULL, NULL, 36109, 5),
(234818, NULL, 'G3DSA:1.10.150.900', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234819, NULL, 'G3DSA:2.10.160.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 27602, 5),
(234820, NULL, 'G3DSA:3.30.457.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234821, NULL, 'G3DSA:3.40.50.10380', NULL, NULL, NULL, NULL, '', NULL, NULL, 29932, 5),
(234822, NULL, 'G3DSA:3.40.1170.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234823, NULL, 'G3DSA:2.60.40.3630', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234824, NULL, 'G3DSA:1.20.140.130', NULL, NULL, NULL, NULL, '', NULL, NULL, 33072, 5),
(234825, NULL, 'G3DSA:3.30.1660.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 24103, 5),
(234826, NULL, 'G3DSA:1.10.260.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234827, NULL, 'G3DSA:6.10.140.1450', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234828, NULL, 'G3DSA:3.15.10.40', NULL, NULL, NULL, NULL, 'Uncharacterised protein PF07273, DUF1439', NULL, NULL, NULL, 5),
(234829, NULL, 'G3DSA:3.30.9.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234830, NULL, 'G3DSA:1.10.168.20', NULL, NULL, NULL, NULL, 'Ribosomal protein S8e, subdomain', NULL, NULL, 35500, 5),
(234831, NULL, 'G3DSA:1.10.287.1050', NULL, NULL, NULL, NULL, '', NULL, NULL, 23931, 5),
(234832, NULL, 'G3DSA:1.10.472.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234833, NULL, 'G3DSA:4.10.110.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234834, NULL, 'G3DSA:2.60.98.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31776, 5),
(234835, NULL, 'G3DSA:1.10.150.290', NULL, NULL, NULL, NULL, '', NULL, NULL, 7533, 5),
(234836, NULL, 'G3DSA:2.60.40.4210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234837, NULL, 'G3DSA:4.10.1150.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 12092, 5),
(234838, NULL, 'G3DSA:1.10.260.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234839, NULL, 'G3DSA:3.30.1120.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234840, NULL, 'G3DSA:1.25.40.280', NULL, NULL, NULL, NULL, 'alix/aip1 like domains', NULL, NULL, 33885, 5),
(234841, NULL, 'G3DSA:1.10.1740.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234842, NULL, 'G3DSA:3.90.1150.200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234843, NULL, 'G3DSA:3.30.70.1510', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234844, NULL, 'G3DSA:3.30.70.3460', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234845, NULL, 'G3DSA:3.30.1490.240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234846, NULL, 'G3DSA:3.30.2460.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 35333, 5),
(234847, NULL, 'G3DSA:1.10.3390.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234848, NULL, 'G3DSA:6.10.250.1740', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234849, NULL, 'G3DSA:3.90.980.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234850, NULL, 'G3DSA:1.10.3330.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33401, 5),
(234851, NULL, 'G3DSA:3.30.2400.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234852, NULL, 'G3DSA:1.10.10.1310', NULL, NULL, NULL, NULL, 'ToxT, HTH1 motif', NULL, NULL, 35138, 5),
(234853, NULL, 'G3DSA:2.60.220.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234854, NULL, 'G3DSA:1.10.1740.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234855, NULL, 'G3DSA:2.60.40.2250', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234856, NULL, 'G3DSA:1.20.1280.180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(234857, NULL, 'G3DSA:3.40.1340.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31540, 5),
(234858, NULL, 'G3DSA:3.55.50.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234859, NULL, 'G3DSA:3.20.20.210', NULL, NULL, NULL, NULL, '', NULL, NULL, 30612, 5),
(234860, NULL, 'G3DSA:6.10.190.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234861, NULL, 'G3DSA:1.20.10.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31019, 5),
(234862, NULL, 'G3DSA:3.30.70.3500', NULL, NULL, NULL, NULL, 'MukB, hinge domain', NULL, NULL, 36665, 5),
(234863, NULL, 'G3DSA:6.10.140.1470', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234864, NULL, 'G3DSA:3.30.56.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 33623, 5),
(234865, NULL, 'G3DSA:3.30.310.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234866, NULL, 'G3DSA:1.10.287.90', NULL, NULL, NULL, NULL, '', NULL, NULL, 29468, 5),
(234867, NULL, 'G3DSA:2.50.20.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234868, NULL, 'G3DSA:2.30.30.1230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234869, NULL, 'G3DSA:3.90.45.10', NULL, NULL, NULL, NULL, 'Peptide deformylase', NULL, NULL, 27933, 5),
(234870, NULL, 'G3DSA:3.40.47.40', NULL, NULL, NULL, NULL, 'Stage V sporulation protein AD', NULL, NULL, 32961, 5),
(234871, NULL, 'G3DSA:1.10.287.710', NULL, NULL, NULL, NULL, 'Helix hairpin bin', NULL, NULL, 13905, 5),
(234872, NULL, 'G3DSA:1.10.132.50', NULL, NULL, NULL, NULL, 'ATP synthase (C/AC39) subunit, domain 3', NULL, NULL, 34475, 5),
(234873, NULL, 'G3DSA:1.20.1260.60', NULL, NULL, NULL, NULL, '', NULL, NULL, 34524, 5),
(234874, NULL, 'G3DSA:1.20.120.450', NULL, NULL, NULL, NULL, 'dinb family like domain', NULL, NULL, 7249, 5),
(234875, NULL, 'G3DSA:1.10.4050.10', NULL, NULL, NULL, NULL, 'Glutamine synthase adenylyltransferase GlnE', NULL, NULL, NULL, 5),
(234876, NULL, 'G3DSA:2.60.40.3610', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234877, NULL, 'G3DSA:2.60.120.880', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234878, NULL, 'G3DSA:3.30.2420.10', NULL, NULL, NULL, NULL, 'TonB', NULL, NULL, NULL, 5),
(234879, NULL, 'G3DSA:6.10.140.210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234880, NULL, 'G3DSA:2.180.10.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234881, NULL, 'G3DSA:3.30.1490.290', NULL, NULL, NULL, NULL, '', NULL, NULL, 34059, 5),
(234882, NULL, 'G3DSA:6.10.250.1630', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234883, NULL, 'G3DSA:1.20.140.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 33277, 5),
(234884, NULL, 'G3DSA:1.10.10.1150', NULL, NULL, NULL, NULL, 'Coenzyme PQQ synthesis protein D (PqqD)', NULL, NULL, 30651, 5),
(234885, NULL, 'G3DSA:1.20.1440.280', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234886, NULL, 'G3DSA:3.30.1370.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234887, NULL, 'G3DSA:3.90.1210.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234888, NULL, 'G3DSA:3.10.440.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 8892, 5),
(234889, NULL, 'G3DSA:3.30.160.250', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234890, NULL, 'G3DSA:6.10.250.1790', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234891, NULL, 'G3DSA:3.30.70.3300', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234892, NULL, 'G3DSA:4.10.1050.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 22660, 5),
(234893, NULL, 'G3DSA:6.20.50.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234894, NULL, 'G3DSA:2.60.120.1380', NULL, NULL, NULL, NULL, '', NULL, NULL, 33109, 5),
(234895, NULL, 'G3DSA:2.40.50.540', NULL, NULL, NULL, NULL, '', NULL, NULL, 30869, 5),
(234896, NULL, 'G3DSA:1.10.357.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 30303, 5),
(234897, NULL, 'G3DSA:2.60.40.2270', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234898, NULL, 'G3DSA:3.10.20.230', NULL, NULL, NULL, NULL, 'Doublecortin domain', NULL, NULL, 31052, 5),
(234899, NULL, 'G3DSA:1.10.490.40', NULL, NULL, NULL, NULL, 'Diphtheria toxin, translocation domain', NULL, NULL, NULL, 5),
(234900, NULL, 'G3DSA:3.40.50.12370', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(234901, NULL, 'G3DSA:6.20.30.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234902, NULL, 'G3DSA:1.10.10.2240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234903, NULL, 'G3DSA:1.10.1740.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234904, NULL, 'G3DSA:1.20.1270.230', NULL, NULL, NULL, NULL, 'DNA terminal protein Gp3, priming domain', NULL, NULL, 34644, 5),
(234905, NULL, 'G3DSA:3.30.160.670', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234906, NULL, 'G3DSA:1.10.238.180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234907, NULL, 'G3DSA:1.20.58.910', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234908, NULL, 'G3DSA:3.30.1310.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234909, NULL, 'G3DSA:3.30.1360.60', NULL, NULL, NULL, NULL, 'Glucose permease domain IIB', NULL, NULL, 28039, 5),
(234910, NULL, 'G3DSA:1.10.3580.10', NULL, NULL, NULL, NULL, 'ATP12 ATPase', NULL, NULL, 19229, 5),
(234911, NULL, 'G3DSA:1.20.120.140', NULL, NULL, NULL, NULL, '', NULL, NULL, 31000, 5),
(234912, NULL, 'G3DSA:3.10.20.730', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234913, NULL, 'G3DSA:1.10.8.160', NULL, NULL, NULL, NULL, 'DNA primase S; domain 2', NULL, NULL, NULL, 5),
(234914, NULL, 'G3DSA:6.10.250.3190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234915, NULL, 'G3DSA:1.10.268.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234916, NULL, 'G3DSA:1.20.1250.90', NULL, NULL, NULL, NULL, 'Thymic stromal lymphopoietin', NULL, NULL, 28665, 5),
(234917, NULL, 'G3DSA:1.10.3960.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 23921, 5),
(234918, NULL, 'G3DSA:2.30.140.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234919, NULL, 'G3DSA:1.20.5.470', NULL, NULL, NULL, NULL, 'Single helix bin', NULL, NULL, NULL, 5),
(234920, NULL, 'G3DSA:2.70.240.20', NULL, NULL, NULL, NULL, 'Leukocidin/Hemolysin toxin, cytolysin domain', NULL, NULL, NULL, 5),
(234921, NULL, 'G3DSA:3.40.367.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234922, NULL, 'G3DSA:1.20.58.2030', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234923, NULL, 'G3DSA:1.20.5.560', NULL, NULL, NULL, NULL, 'Single Heli x bin', NULL, NULL, 9200, 5),
(234924, NULL, 'G3DSA:1.10.8.330', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234925, NULL, 'G3DSA:3.30.160.800', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234926, NULL, 'G3DSA:2.20.210.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234927, NULL, 'G3DSA:1.20.58.1100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234928, NULL, 'G3DSA:6.10.250.1030', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234929, NULL, 'G3DSA:3.40.50.11310', NULL, NULL, NULL, NULL, 'Bacterial phosphonate metabolism protein PhnH', NULL, NULL, 32393, 5),
(234930, NULL, 'G3DSA:3.30.200.110', NULL, NULL, NULL, NULL, '', NULL, NULL, 36285, 5),
(234931, NULL, 'G3DSA:6.10.250.250', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234932, NULL, 'G3DSA:3.30.420.210', NULL, NULL, NULL, NULL, 'SEP domain', NULL, NULL, 29736, 5),
(234933, NULL, 'G3DSA:3.30.1380.20', NULL, NULL, NULL, NULL, 'Trafficking protein particle complex subunit 3', NULL, NULL, NULL, 5),
(234934, NULL, 'G3DSA:3.40.50.12500', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234935, NULL, 'G3DSA:6.20.290.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234936, NULL, 'G3DSA:2.60.320.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234937, NULL, 'G3DSA:2.60.40.2660', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234938, NULL, 'G3DSA:1.10.12.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234939, NULL, 'G3DSA:3.40.50.1110', NULL, NULL, NULL, NULL, 'SGNH hydrolase', NULL, NULL, 30092, 5),
(234940, NULL, 'G3DSA:3.30.110.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234941, NULL, 'G3DSA:3.30.750.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234942, NULL, 'G3DSA:3.40.30.30', NULL, NULL, NULL, NULL, 'Hypothetical protein sa0798.', NULL, NULL, 33568, 5),
(234943, NULL, 'G3DSA:2.40.10.250', NULL, NULL, NULL, NULL, 'Replicase NSP9', NULL, NULL, 31304, 5);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(234944, NULL, 'G3DSA:6.10.250.2000', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234945, NULL, 'G3DSA:6.10.140.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234946, NULL, 'G3DSA:2.40.50.150', NULL, NULL, NULL, NULL, '', NULL, NULL, 9348, 5),
(234947, NULL, 'G3DSA:2.60.40.3010', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234948, NULL, 'G3DSA:1.10.287.920', NULL, NULL, NULL, NULL, 'Pheromone alpha factor receptor.', NULL, NULL, 26670, 5),
(234949, NULL, 'G3DSA:6.10.140.810', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234950, NULL, 'G3DSA:2.60.200.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234951, NULL, 'G3DSA:1.10.1660.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234952, NULL, 'G3DSA:1.20.1250.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 6138, 5),
(234953, NULL, 'G3DSA:6.10.70.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234954, NULL, 'G3DSA:2.40.180.10', NULL, NULL, NULL, NULL, 'Catalase core domain', NULL, NULL, NULL, 5),
(234955, NULL, 'G3DSA:2.40.10.220', NULL, NULL, NULL, NULL, 'predicted glycosyltransferase like domains', NULL, NULL, NULL, 5),
(234956, NULL, 'G3DSA:3.40.50.10990', NULL, NULL, NULL, NULL, 'GTP cyclohydrolase II', NULL, NULL, 28568, 5),
(234957, NULL, 'G3DSA:6.10.250.960', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234958, NULL, 'G3DSA:1.10.150.300', NULL, NULL, NULL, NULL, '', NULL, NULL, 18137, 5),
(234959, NULL, 'G3DSA:1.20.120.720', NULL, NULL, NULL, NULL, 'Myosin VI head, motor domain, U50 subdomain', NULL, NULL, NULL, 5),
(234960, NULL, 'G3DSA:2.40.33.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 28934, 5),
(234961, NULL, 'G3DSA:1.20.120.1030', NULL, NULL, NULL, NULL, '', NULL, NULL, 30876, 5),
(234962, NULL, 'G3DSA:3.10.450.310', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234963, NULL, 'G3DSA:2.40.10.340', NULL, NULL, NULL, NULL, '', NULL, NULL, 36355, 5),
(234964, NULL, 'G3DSA:2.30.30.470', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234965, NULL, 'G3DSA:6.10.250.640', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234966, NULL, 'G3DSA:2.60.120.330', NULL, NULL, NULL, NULL, '', NULL, NULL, 25625, 5),
(234967, NULL, 'G3DSA:3.40.50.980', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234968, NULL, 'G3DSA:3.40.50.10600', NULL, NULL, NULL, NULL, '', NULL, NULL, 27049, 5),
(234969, NULL, 'G3DSA:3.30.450.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234970, NULL, 'G3DSA:3.30.479.30', NULL, NULL, NULL, NULL, 'Band 7 domain', NULL, NULL, 27501, 5),
(234971, NULL, 'G3DSA:3.90.105.10', NULL, NULL, NULL, NULL, 'Molybdopterin biosynthesis moea protein, domain 2', NULL, NULL, NULL, 5),
(234972, NULL, 'G3DSA:3.30.360.30', NULL, NULL, NULL, NULL, 'homospermidine synthase like', NULL, NULL, 11786, 5),
(234973, NULL, 'G3DSA:1.10.10.1770', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234974, NULL, 'G3DSA:3.30.30.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234975, NULL, 'G3DSA:1.10.287.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234976, NULL, 'G3DSA:1.10.287.570', NULL, NULL, NULL, NULL, 'Helical hairpin bin', NULL, NULL, NULL, 5),
(234977, NULL, 'G3DSA:3.40.50.11530', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234978, NULL, 'G3DSA:1.20.5.120', NULL, NULL, NULL, NULL, '', NULL, NULL, 28239, 5),
(234979, NULL, 'G3DSA:3.30.530.70', NULL, NULL, NULL, NULL, 'Uncharacterised protein PF12723, DUF3809', NULL, NULL, NULL, 5),
(234980, NULL, 'G3DSA:1.25.40.460', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234981, NULL, 'G3DSA:2.10.25.160', NULL, NULL, NULL, NULL, 'Granulin', NULL, NULL, 32830, 5),
(234982, NULL, 'G3DSA:3.20.20.450', NULL, NULL, NULL, NULL, 'EAL domain', NULL, NULL, 24870, 5),
(234983, NULL, 'G3DSA:1.10.10.190', NULL, NULL, NULL, NULL, '', NULL, NULL, 10133, 5),
(234984, NULL, 'G3DSA:2.60.120.1060', NULL, NULL, NULL, NULL, 'NPCBM/NEW2 domain', NULL, NULL, 33207, 5),
(234985, NULL, 'G3DSA:1.10.1600.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234986, NULL, 'G3DSA:3.30.160.890', NULL, NULL, NULL, NULL, 'Hepatitis C virus envelope glycoprotein E1, chain C', NULL, NULL, NULL, 5);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(234987, NULL, 'G3DSA:3.60.130.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234988, NULL, 'G3DSA:4.10.40.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234989, NULL, 'G3DSA:3.40.600.20', NULL, NULL, NULL, NULL, 'Restriction endonuclease BglI', NULL, NULL, 34261, 5),
(234990, NULL, 'G3DSA:1.20.120.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234991, NULL, 'G3DSA:1.10.150.260', NULL, NULL, NULL, NULL, '', NULL, NULL, 33216, 5),
(234992, NULL, 'G3DSA:3.30.1490.450', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234993, NULL, 'G3DSA:2.40.160.190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234994, NULL, 'G3DSA:1.10.287.3990', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234995, NULL, 'G3DSA:2.60.40.3450', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234996, NULL, 'G3DSA:3.40.50.11190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(234997, NULL, 'G3DSA:2.10.270.10', NULL, NULL, NULL, NULL, 'Cholin Binding', NULL, NULL, NULL, 5),
(234998, NULL, 'G3DSA:1.10.1130.10', NULL, NULL, NULL, NULL, 'Flavocytochrome C3; Chain A', NULL, NULL, NULL, 5),
(234999, NULL, 'G3DSA:6.10.140.1680', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235000, NULL, 'G3DSA:1.10.1030.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28950, 5),
(235001, NULL, 'G3DSA:3.40.1000.40', NULL, NULL, NULL, NULL, 'Respiratory growth induced protein 1', NULL, NULL, 33514, 5),
(235002, NULL, 'G3DSA:3.30.60.190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235003, NULL, 'G3DSA:3.10.450.700', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235004, NULL, 'G3DSA:1.10.10.2560', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235005, NULL, 'G3DSA:3.40.5.20', NULL, NULL, NULL, NULL, 'YqbF domain', NULL, NULL, 27812, 5),
(235006, NULL, 'G3DSA:2.170.300.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235007, NULL, 'G3DSA:3.30.230.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 28146, 5),
(235008, NULL, 'G3DSA:6.10.250.2210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235009, NULL, 'G3DSA:3.40.1380.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235010, NULL, 'G3DSA:3.10.20.690', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235011, NULL, 'G3DSA:1.10.260.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235012, NULL, 'G3DSA:1.20.120.1790', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235013, NULL, 'G3DSA:3.40.50.11140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235014, NULL, 'G3DSA:1.20.1050.90', NULL, NULL, NULL, NULL, '', NULL, NULL, 34639, 5),
(235015, NULL, 'G3DSA:3.30.60.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235016, NULL, 'G3DSA:1.10.3990.20', NULL, NULL, NULL, NULL, 'protein bp1543', NULL, NULL, 32118, 5),
(235017, NULL, 'G3DSA:3.50.20.20', NULL, NULL, NULL, NULL, 'Janus/Ocnus', NULL, NULL, 32242, 5),
(235018, NULL, 'G3DSA:3.30.1330.150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235019, NULL, 'G3DSA:4.10.830.30', NULL, NULL, NULL, NULL, 'Ribosomal protein L31', NULL, NULL, 37292, 5),
(235020, NULL, 'G3DSA:3.40.50.9200', NULL, NULL, NULL, NULL, 'Hypothetical protein MTH538', NULL, NULL, 31332, 5),
(235021, NULL, 'G3DSA:6.10.140.1240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235022, NULL, 'G3DSA:3.40.50.12770', NULL, NULL, NULL, NULL, 'Nitrate reductase alpha subunit', NULL, NULL, NULL, 5),
(235023, NULL, 'G3DSA:3.30.2150.10', NULL, NULL, NULL, NULL, 'Fibrillarin homologue', NULL, NULL, NULL, 5),
(235024, NULL, 'G3DSA:1.20.58.110', NULL, NULL, NULL, NULL, 'Ribosomal protein S20', NULL, NULL, 30390, 5),
(235025, NULL, 'G3DSA:3.30.70.1230', NULL, NULL, NULL, NULL, 'Nucleotide cyclase', NULL, NULL, 25507, 5),
(235026, NULL, 'G3DSA:3.90.70.200', NULL, NULL, NULL, NULL, '', NULL, NULL, 33225, 5),
(235027, NULL, 'G3DSA:3.40.190.210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235028, NULL, 'G3DSA:4.10.320.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235029, NULL, 'G3DSA:1.10.790.20', NULL, NULL, NULL, NULL, 'Domain of unknown function DUF1476', NULL, NULL, 31172, 5);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(235030, NULL, 'G3DSA:3.40.50.10390', NULL, NULL, NULL, NULL, 'Gingipain r; domain 1', NULL, NULL, 24231, 5),
(235031, NULL, 'G3DSA:1.10.287.2620', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235032, NULL, 'G3DSA:3.40.1350.90', NULL, NULL, NULL, NULL, 'Uncharacterised protein PF11572, DUF3234', NULL, NULL, NULL, 5),
(235033, NULL, 'G3DSA:2.40.128.620', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235034, NULL, 'G3DSA:6.10.250.2920', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235035, NULL, 'G3DSA:3.30.70.3580', NULL, NULL, NULL, NULL, 'Antirestriction protein', NULL, NULL, 33581, 5),
(235036, NULL, 'G3DSA:1.20.58.570', NULL, NULL, NULL, NULL, '', NULL, NULL, 34581, 5),
(235037, NULL, 'G3DSA:3.40.1170.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235038, NULL, 'G3DSA:1.20.1540.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 25566, 5),
(235039, NULL, 'G3DSA:1.20.120.740', NULL, NULL, NULL, NULL, 'YgfB uncharacterised protein family UPF0149, PF03695', NULL, NULL, 29194, 5),
(235040, NULL, 'G3DSA:3.90.640.90', NULL, NULL, NULL, NULL, '', NULL, NULL, 32973, 5),
(235041, NULL, 'G3DSA:1.20.1080.10', NULL, NULL, NULL, NULL, 'Glycerol uptake facilitator protein.', NULL, NULL, 13680, 5),
(235042, NULL, 'G3DSA:2.60.40.2430', NULL, NULL, NULL, NULL, '', NULL, NULL, 35310, 5),
(235043, NULL, 'G3DSA:2.40.128.280', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235044, NULL, 'G3DSA:1.10.437.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 27815, 5),
(235045, NULL, 'G3DSA:3.30.160.460', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235046, NULL, 'G3DSA:2.30.30.290', NULL, NULL, NULL, NULL, '', NULL, NULL, 16758, 5),
(235047, NULL, 'G3DSA:4.10.1140.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235048, NULL, 'G3DSA:1.20.5.1200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235049, NULL, 'G3DSA:2.10.25.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235050, NULL, 'G3DSA:1.20.5.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235051, NULL, 'G3DSA:1.10.10.1590', NULL, NULL, NULL, NULL, '', NULL, NULL, 30256, 5),
(235052, NULL, 'G3DSA:1.25.40.690', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235053, NULL, 'G3DSA:2.40.50.930', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235054, NULL, 'G3DSA:3.10.50.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 33322, 5),
(235055, NULL, 'G3DSA:2.60.40.2480', NULL, NULL, NULL, NULL, '', NULL, NULL, 32504, 5),
(235056, NULL, 'G3DSA:3.30.1330.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235057, NULL, 'G3DSA:2.60.40.3870', NULL, NULL, NULL, NULL, 'Uncharacterised protein PF16024, DUF4785', NULL, NULL, NULL, 5),
(235058, NULL, 'G3DSA:1.10.1520.20', NULL, NULL, NULL, NULL, 'Ribonuclease III', NULL, NULL, 31926, 5),
(235059, NULL, 'G3DSA:3.40.50.10210', NULL, NULL, NULL, NULL, '', NULL, NULL, 32440, 5),
(235060, NULL, 'G3DSA:1.10.10.2030', NULL, NULL, NULL, NULL, '', NULL, NULL, 27014, 5),
(235061, NULL, 'G3DSA:1.10.274.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28335, 5),
(235062, NULL, 'G3DSA:1.20.120.1740', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235063, NULL, 'G3DSA:3.40.50.12160', NULL, NULL, NULL, NULL, '', NULL, NULL, 32374, 5),
(235064, NULL, 'G3DSA:1.10.10.370', NULL, NULL, NULL, NULL, '', NULL, NULL, 31590, 5),
(235065, NULL, 'G3DSA:2.10.25.60', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5),
(235066, NULL, 'G3DSA:6.10.30.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235067, NULL, 'G3DSA:6.10.140.1630', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235068, NULL, 'G3DSA:4.10.80.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235069, NULL, 'G3DSA:3.30.280.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29890, 5),
(235070, NULL, 'G3DSA:1.10.150.690', NULL, NULL, NULL, NULL, 'DUF2063', NULL, NULL, 36951, 5),
(235071, NULL, 'G3DSA:1.10.220.70', NULL, NULL, NULL, NULL, 'lyase', NULL, NULL, 36685, 5),
(235072, NULL, 'G3DSA:3.40.50.12110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235073, NULL, 'G3DSA:1.10.8.1170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(235074, NULL, 'G3DSA:1.20.5.680', NULL, NULL, NULL, NULL, 'Single Helix bin', NULL, NULL, NULL, 5),
(235075, NULL, 'G3DSA:2.30.30.1020', NULL, NULL, NULL, NULL, '', NULL, NULL, 27293, 5),
(235076, NULL, 'G3DSA:3.30.1400.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32100, 5),
(235077, NULL, 'G3DSA:3.40.50.11670', NULL, NULL, NULL, NULL, 'DNA replication regulator HobA', NULL, NULL, 33140, 5),
(235078, NULL, 'G3DSA:3.90.25.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235079, NULL, 'G3DSA:2.40.430.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235080, NULL, 'G3DSA:1.10.1200.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235081, NULL, 'G3DSA:1.10.287.500', NULL, NULL, NULL, NULL, 'Helix hairpin bin', NULL, NULL, NULL, 5),
(235082, NULL, 'G3DSA:3.30.540.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 31072, 5),
(235083, NULL, 'G3DSA:2.102.10.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32919, 5),
(235084, NULL, 'G3DSA:3.40.50.12120', NULL, NULL, NULL, NULL, 'POC1 chaperone', NULL, NULL, 32162, 5),
(235085, NULL, 'G3DSA:2.70.9.30', NULL, NULL, NULL, NULL, 'Viral coat protein p3', NULL, NULL, 11167, 5),
(235086, NULL, 'G3DSA:3.30.70.1720', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235087, NULL, 'G3DSA:1.20.58.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235088, NULL, 'G3DSA:3.30.1460.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235089, NULL, 'G3DSA:6.10.250.1420', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235090, NULL, 'G3DSA:1.20.1430.10', NULL, NULL, NULL, NULL, 'Families 57/38 glycoside transferase, middle domain', NULL, NULL, 27311, 5),
(235091, NULL, 'G3DSA:6.10.140.420', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235092, NULL, 'G3DSA:1.10.880.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235093, NULL, 'G3DSA:2.60.40.3400', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235094, NULL, 'G3DSA:3.90.50.10', NULL, NULL, NULL, NULL, 'Photosynthetic Reaction Center, subunit H, domain 2', NULL, NULL, 11248, 5),
(235095, NULL, 'G3DSA:6.10.250.1950', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235096, NULL, 'G3DSA:1.10.1760.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32219, 5),
(235097, NULL, 'G3DSA:3.90.1150.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235098, NULL, 'G3DSA:2.60.40.1920', NULL, NULL, NULL, NULL, '', NULL, NULL, 31370, 5),
(235099, NULL, 'G3DSA:4.10.720.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29585, 5),
(235100, NULL, 'G3DSA:1.10.167.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235101, NULL, 'G3DSA:1.25.40.170', NULL, NULL, NULL, NULL, 'Smaug, PHAT domain', NULL, NULL, 32526, 5),
(235102, NULL, 'G3DSA:3.30.2380.10', NULL, NULL, NULL, NULL, 'CGI121/TPRKB', NULL, NULL, 31192, 5),
(235103, NULL, 'G3DSA:6.10.280.220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235104, NULL, 'G3DSA:2.30.34.10', NULL, NULL, NULL, NULL, 'Leishmanolysin domain 4', NULL, NULL, NULL, 5),
(235105, NULL, 'G3DSA:2.20.20.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 18287, 5),
(235106, NULL, 'G3DSA:6.20.70.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235107, NULL, 'G3DSA:3.30.450.310', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235108, NULL, 'G3DSA:2.30.300.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235109, NULL, 'G3DSA:2.10.260.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235110, NULL, 'G3DSA:3.30.2170.10', NULL, NULL, NULL, NULL, 'archaeoglobus fulgidus dsm 4304 superfamily', NULL, NULL, NULL, 5),
(235111, NULL, 'G3DSA:3.40.50.10420', NULL, NULL, NULL, NULL, '', NULL, NULL, 9468, 5),
(235112, NULL, 'G3DSA:6.10.140.690', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235113, NULL, 'G3DSA:1.10.1200.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235114, NULL, 'G3DSA:3.90.1150.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235115, NULL, 'G3DSA:3.40.50.460', NULL, NULL, NULL, NULL, 'Phosphofructokinase domain', NULL, NULL, 29818, 5),
(235116, NULL, 'G3DSA:2.30.130.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(235117, NULL, 'G3DSA:3.10.610.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235118, NULL, 'G3DSA:3.30.70.420', NULL, NULL, NULL, NULL, '', NULL, NULL, 9992, 5),
(235119, NULL, 'G3DSA:1.20.58.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235120, NULL, 'G3DSA:1.20.5.4820', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235121, NULL, 'G3DSA:1.20.1280.300', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235122, NULL, 'G3DSA:3.40.50.12600', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235123, NULL, 'G3DSA:6.10.250.510', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235124, NULL, 'G3DSA:3.40.50.12170', NULL, NULL, NULL, NULL, 'Uncharacterised protein PF07075, DUF1343', NULL, NULL, NULL, 5),
(235125, NULL, 'G3DSA:1.10.10.2110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235126, NULL, 'G3DSA:1.10.3260.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32487, 5),
(235127, NULL, 'G3DSA:1.20.1250.20', NULL, NULL, NULL, NULL, 'MFS general substrate transporter like domains', NULL, NULL, 30757, 5),
(235128, NULL, 'G3DSA:2.40.30.260', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235129, NULL, 'G3DSA:6.10.250.2840', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235130, NULL, 'G3DSA:3.30.70.650', NULL, NULL, NULL, NULL, 'Translation repressor RegA', NULL, NULL, 30069, 5),
(235131, NULL, 'G3DSA:1.25.40.560', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235132, NULL, 'G3DSA:2.160.20.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 10832, 5),
(235133, NULL, 'G3DSA:3.40.30.10', NULL, NULL, NULL, NULL, 'Glutaredoxin', NULL, NULL, NULL, 5),
(235134, NULL, 'G3DSA:2.10.310.10', NULL, NULL, NULL, NULL, 'Serpins superfamily', NULL, NULL, NULL, 5),
(235135, NULL, 'G3DSA:2.40.50.360', NULL, NULL, NULL, NULL, '', NULL, NULL, 36532, 5),
(235136, NULL, 'G3DSA:1.20.1310.10', NULL, NULL, NULL, NULL, 'Cullin Repeats', NULL, NULL, NULL, 5),
(235137, NULL, 'G3DSA:3.80.10.10', NULL, NULL, NULL, NULL, 'Ribonuclease Inhibitor', NULL, NULL, 18173, 5),
(235138, NULL, 'G3DSA:1.10.533.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235139, NULL, 'G3DSA:3.30.450.230', NULL, NULL, NULL, NULL, '', NULL, NULL, 31309, 5),
(235140, NULL, 'G3DSA:1.10.340.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235141, NULL, 'G3DSA:1.20.1050.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235142, NULL, 'G3DSA:3.40.1750.10', NULL, NULL, NULL, NULL, 'peptide peptidase (sppa) like domain', NULL, NULL, NULL, 5),
(235143, NULL, 'G3DSA:2.30.170.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235144, NULL, 'G3DSA:2.40.128.300', NULL, NULL, NULL, NULL, '', NULL, NULL, 34677, 5),
(235145, NULL, 'G3DSA:1.20.58.700', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235146, NULL, 'G3DSA:2.40.200.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 21421, 5),
(235147, NULL, 'G3DSA:1.10.3290.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32545, 5),
(235148, NULL, 'G3DSA:3.30.1370.120', NULL, NULL, NULL, NULL, '', NULL, NULL, 32074, 5),
(235149, NULL, 'G3DSA:4.10.80.300', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235150, NULL, 'G3DSA:1.20.58.420', NULL, NULL, NULL, NULL, 'AHSP', NULL, NULL, NULL, 5),
(235151, NULL, 'G3DSA:2.30.30.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235152, NULL, 'G3DSA:6.10.140.1000', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235153, NULL, 'G3DSA:2.60.169.10', NULL, NULL, NULL, NULL, 'Microviridae F protein', NULL, NULL, 28348, 5),
(235154, NULL, 'G3DSA:1.10.8.200', NULL, NULL, NULL, NULL, 'Replisome organizer (g39p helicase loader/inhibitor protein)', NULL, NULL, NULL, 5),
(235155, NULL, 'G3DSA:1.10.740.10', NULL, NULL, NULL, NULL, 'Transferase Inhibitor Protein From Tn5; Chain', NULL, NULL, 12009, 5),
(235156, NULL, 'G3DSA:6.10.250.490', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235157, NULL, 'G3DSA:3.40.50.11970', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235158, NULL, 'G3DSA:3.40.50.12580', NULL, NULL, NULL, NULL, '', NULL, NULL, 35109, 5),
(235159, NULL, 'G3DSA:3.40.30.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(235160, NULL, 'G3DSA:6.10.200.10', NULL, NULL, NULL, NULL, 'Regulatory phage protein Cox', NULL, NULL, 31039, 5),
(235161, NULL, 'G3DSA:2.10.70.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235162, NULL, 'G3DSA:2.30.30.570', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235163, NULL, 'G3DSA:3.40.50.10880', NULL, NULL, NULL, NULL, 'Uncharacterised protein PF01937, DUF89, domain 3', NULL, NULL, NULL, 5),
(235164, NULL, 'G3DSA:3.30.2310.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235165, NULL, 'G3DSA:1.20.58.1000', NULL, NULL, NULL, NULL, '', NULL, NULL, 29520, 5),
(235166, NULL, 'G3DSA:2.60.40.340', NULL, NULL, NULL, NULL, '', NULL, NULL, 29886, 5),
(235167, NULL, 'G3DSA:1.10.287.2230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235168, NULL, 'G3DSA:3.30.2280.10', NULL, NULL, NULL, NULL, 'Hypothetical protein (hspc210)', NULL, NULL, 9073, 5),
(235169, NULL, 'G3DSA:3.40.50.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235170, NULL, 'G3DSA:1.20.120.660', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235171, NULL, 'G3DSA:1.10.287.940', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235172, NULL, 'G3DSA:2.40.37.10', NULL, NULL, NULL, NULL, 'Lyase, Ornithine Decarboxylase; Chain A, domain 1', NULL, NULL, 9821, 5),
(235173, NULL, 'G3DSA:2.70.9.10', NULL, NULL, NULL, NULL, 'Adenovirus Type 2 Hexon, domain 4', NULL, NULL, NULL, 5),
(235174, NULL, 'G3DSA:1.10.10.450', NULL, NULL, NULL, NULL, '', NULL, NULL, 31931, 5),
(235175, NULL, 'G3DSA:3.30.70.3280', NULL, NULL, NULL, NULL, 'Peptide chain release factor 3, domain III', NULL, NULL, 32082, 5),
(235176, NULL, 'G3DSA:1.10.10.1500', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235177, NULL, 'G3DSA:2.60.40.3290', NULL, NULL, NULL, NULL, 'Fimbrial protein EcpA', NULL, NULL, 32209, 5),
(235178, NULL, 'G3DSA:1.20.59.10', NULL, NULL, NULL, NULL, 'Chorismate mutase', NULL, NULL, 30252, 5),
(235179, NULL, 'G3DSA:1.10.30.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235180, NULL, 'G3DSA:2.20.25.240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235181, NULL, 'G3DSA:1.10.150.780', NULL, NULL, NULL, NULL, '', NULL, NULL, 31536, 5),
(235182, NULL, 'G3DSA:3.40.50.11320', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235183, NULL, 'G3DSA:3.40.800.20', NULL, NULL, NULL, NULL, 'Histone deacetylase domain', NULL, NULL, 28384, 5),
(235184, NULL, 'G3DSA:4.10.110.10', NULL, NULL, NULL, NULL, 'Spasmolytic Protein, domain 1', NULL, NULL, 36039, 5),
(235185, NULL, 'G3DSA:2.60.120.800', NULL, NULL, NULL, NULL, '', NULL, NULL, 35071, 5),
(235186, NULL, 'G3DSA:3.40.960.10', NULL, NULL, NULL, NULL, 'VSR Endonuclease', NULL, NULL, NULL, 5),
(235187, NULL, 'G3DSA:3.40.33.10', NULL, NULL, NULL, NULL, 'CAP', NULL, NULL, 7577, 5),
(235188, NULL, 'G3DSA:1.10.357.10', NULL, NULL, NULL, NULL, 'Tetracycline Repressor, domain 2', NULL, NULL, NULL, 5),
(235189, NULL, 'G3DSA:6.10.140.710', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235190, NULL, 'G3DSA:2.60.120.1040', NULL, NULL, NULL, NULL, 'ZPR1, A/B domain', NULL, NULL, 33987, 5),
(235191, NULL, 'G3DSA:2.30.27.10', NULL, NULL, NULL, NULL, 'Phage FD Coat Protein,Membrane penetration domain', NULL, NULL, NULL, 5),
(235192, NULL, 'G3DSA:3.30.2400.10', NULL, NULL, NULL, NULL, 'Major capsid protein gp5', NULL, NULL, NULL, 5),
(235193, NULL, 'G3DSA:2.60.40.1730', NULL, NULL, NULL, NULL, 'tricorn interacting facor f3 domain', NULL, NULL, 30731, 5),
(235194, NULL, 'G3DSA:3.40.50.11110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235195, NULL, 'G3DSA:3.30.450.290', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235196, NULL, 'G3DSA:3.90.550.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235197, NULL, 'G3DSA:1.20.120.1350', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235198, NULL, 'G3DSA:1.20.210.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32914, 5),
(235199, NULL, 'G3DSA:3.30.700.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235200, NULL, 'G3DSA:6.10.250.2110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235201, NULL, 'G3DSA:3.30.70.2460', NULL, NULL, NULL, NULL, '', NULL, NULL, 36622, 5);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(235202, NULL, 'G3DSA:3.10.20.270', NULL, NULL, NULL, NULL, '', NULL, NULL, 33944, 5),
(235203, NULL, 'G3DSA:1.10.357.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235204, NULL, 'G3DSA:2.170.290.10', NULL, NULL, NULL, NULL, 'baseplate structural protein gp8, domain 2', NULL, NULL, NULL, 5),
(235205, NULL, 'G3DSA:3.30.110.180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235206, NULL, 'G3DSA:1.10.10.2170', NULL, NULL, NULL, NULL, '', NULL, NULL, 29589, 5),
(235207, NULL, 'G3DSA:2.60.40.1250', NULL, NULL, NULL, NULL, '', NULL, NULL, 32766, 5),
(235208, NULL, 'G3DSA:1.20.120.1250', NULL, NULL, NULL, NULL, 'Sulfhydryl oxidase R596, ORFan domain', NULL, NULL, NULL, 5),
(235209, NULL, 'G3DSA:3.40.120.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235210, NULL, 'G3DSA:2.30.29.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235211, NULL, 'G3DSA:1.20.1410.10', NULL, NULL, NULL, NULL, 'I/LWEQ domain', NULL, NULL, NULL, 5),
(235212, NULL, 'G3DSA:1.10.10.660', NULL, NULL, NULL, NULL, 'conserved protein of unknown function from Enterococcus faecalis V583', NULL, NULL, 18820, 5),
(235213, NULL, 'G3DSA:3.30.720.190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235214, NULL, 'G3DSA:1.10.8.750', NULL, NULL, NULL, NULL, 'Phosphoribosylformylglycinamidine synthase, linker domain', NULL, NULL, NULL, 5),
(235215, NULL, 'G3DSA:6.20.220.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235216, NULL, 'G3DSA:6.10.250.1480', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235217, NULL, 'G3DSA:1.10.2010.10', NULL, NULL, NULL, NULL, 'Crustacean CHH/MIH/GIH neurohormone', NULL, NULL, 32560, 5),
(235218, NULL, 'G3DSA:3.30.70.2250', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235219, NULL, 'G3DSA:2.80.20.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235220, NULL, 'G3DSA:2.90.10.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28486, 5),
(235221, NULL, 'G3DSA:1.10.8.620', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235222, NULL, 'G3DSA:3.40.50.11090', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235223, NULL, 'G3DSA:3.30.590.10', NULL, NULL, NULL, NULL, 'Glutamine synthetase/guanido kinase, catalytic domain', NULL, NULL, NULL, 5),
(235224, NULL, 'G3DSA:3.30.420.230', NULL, NULL, NULL, NULL, '', NULL, NULL, 37197, 5),
(235225, NULL, 'G3DSA:2.60.120.720', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235226, NULL, 'G3DSA:1.20.58.1190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235227, NULL, 'G3DSA:2.10.90.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 23517, 5),
(235228, NULL, 'G3DSA:2.30.29.240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235229, NULL, 'G3DSA:3.30.750.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235230, NULL, 'G3DSA:3.30.160.290', NULL, NULL, NULL, NULL, 'Rag2 PHD finger', NULL, NULL, NULL, 5),
(235231, NULL, 'G3DSA:1.10.2060.10', NULL, NULL, NULL, NULL, 'PutA proline dehydrogenase (PRODH), domain 2', NULL, NULL, NULL, 5),
(235232, NULL, 'G3DSA:1.10.287.810', NULL, NULL, NULL, NULL, 'Mitochondrial import inner membrane translocase subunit tim13 like domains', NULL, NULL, 19215, 5),
(235233, NULL, 'G3DSA:1.20.58.390', NULL, NULL, NULL, NULL, '', NULL, NULL, 31761, 5),
(235234, NULL, 'G3DSA:1.10.1530.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 35288, 5),
(235235, NULL, 'G3DSA:3.40.5.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235236, NULL, 'G3DSA:3.30.900.10', NULL, NULL, NULL, NULL, 'HORMA domain', NULL, NULL, 31393, 5),
(235237, NULL, 'G3DSA:3.30.2260.10', NULL, NULL, NULL, NULL, 'Enhancer of rudimentary', NULL, NULL, 18725, 5),
(235238, NULL, 'G3DSA:3.40.630.100', NULL, NULL, NULL, NULL, '', NULL, NULL, 32006, 5),
(235239, NULL, 'G3DSA:3.30.1370.200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235240, NULL, 'G3DSA:1.10.1740.70', NULL, NULL, NULL, NULL, 'ChaB', NULL, NULL, 33407, 5),
(235241, NULL, 'G3DSA:2.60.120.220', NULL, NULL, NULL, NULL, 'Satellite virus coat domain', NULL, NULL, NULL, 5),
(235242, NULL, 'G3DSA:3.30.390.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(235243, NULL, 'G3DSA:1.10.150.720', NULL, NULL, NULL, NULL, '', NULL, NULL, 36589, 5),
(235244, NULL, 'G3DSA:1.20.58.620', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235245, NULL, 'G3DSA:3.30.450.260', NULL, NULL, NULL, NULL, 'Haem NO binding associated domain', NULL, NULL, 37749, 5),
(235246, NULL, 'G3DSA:1.10.3790.10', NULL, NULL, NULL, NULL, 'NinB', NULL, NULL, 28483, 5),
(235247, NULL, 'G3DSA:6.10.140.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235248, NULL, 'G3DSA:6.10.250.1350', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235249, NULL, 'G3DSA:2.20.20.30', NULL, NULL, NULL, NULL, 'reverse gyrase domain', NULL, NULL, NULL, 5),
(235250, NULL, 'G3DSA:3.40.1640.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235251, NULL, 'G3DSA:2.60.120.630', NULL, NULL, NULL, NULL, 'mth639 domain like', NULL, NULL, 11626, 5),
(235252, NULL, 'G3DSA:6.10.250.570', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235253, NULL, 'G3DSA:2.60.40.1980', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235254, NULL, 'G3DSA:6.10.300.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235255, NULL, 'G3DSA:3.30.900.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235256, NULL, 'G3DSA:2.20.25.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235257, NULL, 'G3DSA:1.10.1450.10', NULL, NULL, NULL, NULL, 'Tetraspanin', NULL, NULL, 8745, 5),
(235258, NULL, 'G3DSA:2.170.270.10', NULL, NULL, NULL, NULL, 'SET domain', NULL, NULL, 37706, 5),
(235259, NULL, 'G3DSA:6.10.250.720', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235260, NULL, 'G3DSA:6.10.140.630', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235261, NULL, 'G3DSA:2.60.40.1710', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235262, NULL, 'G3DSA:1.10.287.190', NULL, NULL, NULL, NULL, '', NULL, NULL, 6279, 5),
(235263, NULL, 'G3DSA:1.10.1470.10', NULL, NULL, NULL, NULL, 'YjbJ', NULL, NULL, 28301, 5),
(235264, NULL, 'G3DSA:2.60.120.530', NULL, NULL, NULL, NULL, 'Cucumovirus coat protein, subunit A', NULL, NULL, 28075, 5),
(235265, NULL, 'G3DSA:1.25.40.300', NULL, NULL, NULL, NULL, 'Putative secreted effector protein', NULL, NULL, NULL, 5),
(235266, NULL, 'G3DSA:3.10.400.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235267, NULL, 'G3DSA:2.40.128.260', NULL, NULL, NULL, NULL, 'Type IV secretion system, VirB10/TraB/TrbI', NULL, NULL, 35136, 5),
(235268, NULL, 'G3DSA:1.20.5.1300', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235269, NULL, 'G3DSA:1.20.58.1730', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235270, NULL, 'G3DSA:3.40.50.10580', NULL, NULL, NULL, NULL, 'ATPase, V1 complex, subunit F', NULL, NULL, 33753, 5),
(235271, NULL, 'G3DSA:3.30.1490.410', NULL, NULL, NULL, NULL, 'Uncharacterised protein PF16224, DUF4883', NULL, NULL, NULL, 5),
(235272, NULL, 'G3DSA:2.60.40.2530', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235273, NULL, 'G3DSA:3.30.750.190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235274, NULL, 'G3DSA:3.30.720.90', NULL, NULL, NULL, NULL, '', NULL, NULL, 32467, 5),
(235275, NULL, 'G3DSA:3.30.70.1860', NULL, NULL, NULL, NULL, 'Uncharacterised protein family Ycf54', NULL, NULL, 31202, 5),
(235276, NULL, 'G3DSA:3.30.70.2070', NULL, NULL, NULL, NULL, 'VP9 protein domain', NULL, NULL, 33891, 5),
(235277, NULL, 'G3DSA:1.20.5.580', NULL, NULL, NULL, NULL, 'Single Helix bin', NULL, NULL, NULL, 5),
(235278, NULL, 'G3DSA:6.10.20.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235279, NULL, 'G3DSA:2.100.10.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235280, NULL, 'G3DSA:6.10.140.1190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235281, NULL, 'G3DSA:6.10.140.480', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235282, NULL, 'G3DSA:6.10.250.2030', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235283, NULL, 'G3DSA:2.20.100.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32452, 5),
(235284, NULL, 'G3DSA:1.10.40.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235285, NULL, 'G3DSA:6.10.160.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(235286, NULL, 'G3DSA:1.20.5.4880', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235287, NULL, 'G3DSA:3.30.60.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28114, 5),
(235288, NULL, 'G3DSA:1.10.10.1690', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235289, NULL, 'G3DSA:1.10.15.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235290, NULL, 'G3DSA:2.20.130.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235291, NULL, 'G3DSA:1.20.120.580', NULL, NULL, NULL, NULL, '', NULL, NULL, 29013, 5),
(235292, NULL, 'G3DSA:2.60.40.3350', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235293, NULL, 'G3DSA:2.40.30.200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235294, NULL, 'G3DSA:3.40.1440.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235295, NULL, 'G3DSA:3.30.70.2380', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235296, NULL, 'G3DSA:2.30.39.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 34706, 5),
(235297, NULL, 'G3DSA:6.20.250.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235298, NULL, 'G3DSA:2.60.40.1480', NULL, NULL, NULL, NULL, 'Coatomer, gamma subunit, appendage domain', NULL, NULL, 29941, 5),
(235299, NULL, 'G3DSA:2.30.30.650', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235300, NULL, 'G3DSA:1.10.287.3510', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235301, NULL, 'G3DSA:2.60.40.4170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235302, NULL, 'G3DSA:6.10.130.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 37702, 5),
(235303, NULL, 'G3DSA:3.40.50.11240', NULL, NULL, NULL, NULL, '', NULL, NULL, 35087, 5),
(235304, NULL, 'G3DSA:1.20.910.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 9499, 5),
(235305, NULL, 'G3DSA:1.20.940.10', NULL, NULL, NULL, NULL, 'Functional domain of the splicing factor Prp18', NULL, NULL, NULL, 5),
(235306, NULL, 'G3DSA:1.10.10.2090', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235307, NULL, 'G3DSA:6.10.140.1730', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235308, NULL, 'G3DSA:4.10.410.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235309, NULL, 'G3DSA:3.40.50.1580', NULL, NULL, NULL, NULL, 'Nucleoside phosphorylase domain', NULL, NULL, 16321, 5),
(235310, NULL, 'G3DSA:3.40.1500.10', NULL, NULL, NULL, NULL, 'Coproporphyrinogen III oxidase, aerobic', NULL, NULL, 31558, 5),
(235311, NULL, 'G3DSA:2.30.130.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 34246, 5),
(235312, NULL, 'G3DSA:1.20.120.1060', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235313, NULL, 'G3DSA:2.170.150.40', NULL, NULL, NULL, NULL, 'Domain of unknown function (DUF427)', NULL, NULL, 32251, 5),
(235314, NULL, 'G3DSA:1.10.720.30', NULL, NULL, NULL, NULL, 'SAP domain', NULL, NULL, 32600, 5),
(235315, NULL, 'G3DSA:6.10.140.840', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235316, NULL, 'G3DSA:6.10.250.280', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235317, NULL, 'G3DSA:1.20.1270.50', NULL, NULL, NULL, NULL, 'Glycoside hydrolase family 38, central domain', NULL, NULL, 32712, 5),
(235318, NULL, 'G3DSA:3.30.70.2670', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235319, NULL, 'G3DSA:6.10.250.2710', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235320, NULL, 'G3DSA:6.20.460.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235321, NULL, 'G3DSA:3.40.50.11250', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF3013', NULL, NULL, NULL, 5),
(235322, NULL, 'G3DSA:3.10.20.510', NULL, NULL, NULL, NULL, 'RNA polymerase inhibitor', NULL, NULL, 32756, 5),
(235323, NULL, 'G3DSA:4.10.230.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29893, 5),
(235324, NULL, 'G3DSA:3.40.1610.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 25718, 5),
(235325, NULL, 'G3DSA:1.25.40.710', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235326, NULL, 'G3DSA:2.30.30.670', NULL, NULL, NULL, NULL, 'Thioester domain', NULL, NULL, NULL, 5),
(235327, NULL, 'G3DSA:1.10.8.420', NULL, NULL, NULL, NULL, 'RecR Domain 1', NULL, NULL, NULL, 5),
(235328, NULL, 'G3DSA:3.30.300.300', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(235329, NULL, 'G3DSA:1.10.287.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235330, NULL, 'G3DSA:3.30.160.750', NULL, NULL, NULL, NULL, '', NULL, NULL, 34983, 5),
(235331, NULL, 'G3DSA:1.25.40.350', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235332, NULL, 'G3DSA:1.20.5.270', NULL, NULL, NULL, NULL, 'Ubiquinol cytochrome reductase, transmembrane domain', NULL, NULL, 28210, 5),
(235333, NULL, 'G3DSA:1.25.10.60', NULL, NULL, NULL, NULL, 'Rad61, Wapl domain', NULL, NULL, 33830, 5),
(235334, NULL, 'G3DSA:1.25.40.430', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235335, NULL, 'G3DSA:1.10.150.210', NULL, NULL, NULL, NULL, 'Phosphoserine phosphatase; domain 2', NULL, NULL, NULL, 5),
(235336, NULL, 'G3DSA:2.60.40.2320', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235337, NULL, 'G3DSA:1.10.520.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235338, NULL, 'G3DSA:1.10.1500.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235339, NULL, 'G3DSA:1.10.287.3490', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235340, NULL, 'G3DSA:2.60.40.3950', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235341, NULL, 'G3DSA:3.30.420.340', NULL, NULL, NULL, NULL, 'UvrC, RNAse H endonuclease domain', NULL, NULL, 32423, 5),
(235342, NULL, 'G3DSA:6.10.140.1790', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235343, NULL, 'G3DSA:2.40.30.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 19040, 5),
(235344, NULL, 'G3DSA:1.20.1440.30', NULL, NULL, NULL, NULL, 'Biosynthetic Protein domain', NULL, NULL, NULL, 5),
(235345, NULL, 'G3DSA:1.10.3590.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235346, NULL, 'G3DSA:1.20.5.4280', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235347, NULL, 'G3DSA:3.10.450.320', NULL, NULL, NULL, NULL, 'Mitochondrial import inner membrane translocase subunit Tim21', NULL, NULL, 32169, 5),
(235348, NULL, 'G3DSA:3.30.10.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235349, NULL, 'G3DSA:2.60.120.550', NULL, NULL, NULL, NULL, 'Penton protein; domain 1', NULL, NULL, NULL, 5),
(235350, NULL, 'G3DSA:6.10.250.360', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235351, NULL, 'G3DSA:1.10.8.960', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235352, NULL, 'G3DSA:6.10.250.2630', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235353, NULL, 'G3DSA:2.60.40.2010', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235354, NULL, 'G3DSA:3.90.1440.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235355, NULL, 'G3DSA:6.10.140.1210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235356, NULL, 'G3DSA:6.10.250.1140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235357, NULL, 'G3DSA:1.10.10.970', NULL, NULL, NULL, NULL, '', NULL, NULL, 31635, 5),
(235358, NULL, 'G3DSA:3.30.310.220', NULL, NULL, NULL, NULL, '', NULL, NULL, 36341, 5),
(235359, NULL, 'G3DSA:3.40.1760.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 33863, 5),
(235360, NULL, 'G3DSA:1.20.120.890', NULL, NULL, NULL, NULL, 'tRNA(Met) cytidine acetyltransferase, tail domain', NULL, NULL, 28542, 5),
(235361, NULL, 'G3DSA:6.10.140.1130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235362, NULL, 'G3DSA:3.30.70.2980', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235363, NULL, 'G3DSA:3.10.290.60', NULL, NULL, NULL, NULL, '', NULL, NULL, 27843, 5),
(235364, NULL, 'G3DSA:3.10.450.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235365, NULL, 'G3DSA:1.10.1650.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235366, NULL, 'G3DSA:3.10.450.710', NULL, NULL, NULL, NULL, 'Tgt2/MlaC', NULL, NULL, 33529, 5),
(235367, NULL, 'G3DSA:6.10.250.1060', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235368, NULL, 'G3DSA:1.20.80.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235369, NULL, 'G3DSA:1.20.1440.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 23268, 5),
(235370, NULL, 'G3DSA:3.30.1060.10', NULL, NULL, NULL, NULL, 'Peptide methionine sulphoxide reductase MsrA', NULL, NULL, 30098, 5),
(235371, NULL, 'G3DSA:3.30.70.1120', NULL, NULL, NULL, NULL, '', NULL, NULL, 27614, 5);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(235372, NULL, 'G3DSA:6.10.250.2320', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235373, NULL, 'G3DSA:1.10.1740.100', NULL, NULL, NULL, NULL, 'Set2, Rpb1 interacting domain', NULL, NULL, 29986, 5),
(235374, NULL, 'G3DSA:2.60.40.2380', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235375, NULL, 'G3DSA:1.20.1440.250', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235376, NULL, 'G3DSA:1.10.10.580', NULL, NULL, NULL, NULL, 'Structural maintenance of chromosome 1. Chain E', NULL, NULL, 15596, 5),
(235377, NULL, 'G3DSA:3.40.50.261', NULL, NULL, NULL, NULL, '', NULL, NULL, 11141, 5),
(235378, NULL, 'G3DSA:1.10.10.2320', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235379, NULL, 'G3DSA:6.10.250.2690', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235380, NULL, 'G3DSA:1.10.3720.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 13815, 5),
(235381, NULL, 'G3DSA:1.20.5.4010', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235382, NULL, 'G3DSA:2.60.120.1270', NULL, NULL, NULL, NULL, '', NULL, NULL, 33948, 5),
(235383, NULL, 'G3DSA:6.20.50.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235384, NULL, 'G3DSA:3.90.1220.10', NULL, NULL, NULL, NULL, 'Cellulose docking domain, dockering', NULL, NULL, 9768, 5),
(235385, NULL, 'G3DSA:2.30.30.700', NULL, NULL, NULL, NULL, 'SLA1 homology domain 1', NULL, NULL, NULL, 5),
(235386, NULL, 'G3DSA:1.10.10.2920', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235387, NULL, 'G3DSA:1.20.120.1500', NULL, NULL, NULL, NULL, '', NULL, NULL, 35587, 5),
(235388, NULL, 'G3DSA:4.10.1280.10', NULL, NULL, NULL, NULL, 'Clostridium neurotoxins', NULL, NULL, NULL, 5),
(235389, NULL, 'G3DSA:6.10.140.920', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235390, NULL, 'G3DSA:6.10.30.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235391, NULL, 'G3DSA:2.30.42.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235392, NULL, 'G3DSA:1.10.510.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235393, NULL, 'G3DSA:1.10.10.1350', NULL, NULL, NULL, NULL, '', NULL, NULL, 33993, 5),
(235394, NULL, 'G3DSA:1.10.246.140', NULL, NULL, NULL, NULL, '', NULL, NULL, 33892, 5),
(235395, NULL, 'G3DSA:1.10.287.210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235396, NULL, 'G3DSA:3.30.1490.420', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235397, NULL, 'G3DSA:1.10.1510.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235398, NULL, 'G3DSA:3.10.450.630', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235399, NULL, 'G3DSA:2.30.32.30', NULL, NULL, NULL, NULL, 'CBM10', NULL, NULL, 33513, 5),
(235400, NULL, 'G3DSA:1.10.8.270', NULL, NULL, NULL, NULL, 'putative rabgap domain of human tbc1 domain family member 14 like domains', NULL, NULL, NULL, 5),
(235401, NULL, 'G3DSA:2.20.25.450', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5),
(235402, NULL, 'G3DSA:2.20.220.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235403, NULL, 'G3DSA:3.90.1150.40', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF2002', NULL, NULL, NULL, 5),
(235404, NULL, 'G3DSA:1.10.150.360', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235405, NULL, 'G3DSA:2.20.70.150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235406, NULL, 'G3DSA:6.10.250.1710', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235407, NULL, 'G3DSA:3.40.1620.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 34052, 5),
(235408, NULL, 'G3DSA:4.10.240.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235409, NULL, 'G3DSA:3.30.1360.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 31707, 5),
(235410, NULL, 'G3DSA:1.10.579.10', NULL, NULL, NULL, NULL, 'DNA Cyclobutane Dipyrimidine Photolyase, subunit A, domain 3', NULL, NULL, NULL, 5),
(235411, NULL, 'G3DSA:1.20.1280.150', NULL, NULL, NULL, NULL, '', NULL, NULL, 35086, 5),
(235412, NULL, 'G3DSA:1.10.720.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235413, NULL, 'G3DSA:2.30.30.360', NULL, NULL, NULL, NULL, '', NULL, NULL, 9596, 5),
(235414, NULL, 'G3DSA:3.40.50.10710', NULL, NULL, NULL, NULL, '', NULL, NULL, 34987, 5);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(235415, NULL, 'G3DSA:6.20.430.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235416, NULL, 'G3DSA:2.10.10.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235417, NULL, 'G3DSA:1.10.275.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 12653, 5),
(235418, NULL, 'G3DSA:2.60.40.3480', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235419, NULL, 'G3DSA:1.10.246.220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235420, NULL, 'G3DSA:3.30.1390.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 32924, 5),
(235421, NULL, 'G3DSA:2.60.40.2590', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235422, NULL, 'G3DSA:3.30.160.300', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235423, NULL, 'G3DSA:6.20.250.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235424, NULL, 'G3DSA:1.10.287.2900', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235425, NULL, 'G3DSA:1.10.472.20', NULL, NULL, NULL, NULL, 'Nitrile hydratase, beta subunit', NULL, NULL, 34507, 5),
(235426, NULL, 'G3DSA:3.40.1350.140', NULL, NULL, NULL, NULL, '', NULL, NULL, 33736, 5),
(235427, NULL, 'G3DSA:2.170.260.10', NULL, NULL, NULL, NULL, 'paz domain', NULL, NULL, NULL, 5),
(235428, NULL, 'G3DSA:1.20.1370.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 35370, 5),
(235429, NULL, 'G3DSA:1.10.8.390', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235430, NULL, 'G3DSA:6.20.360.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235431, NULL, 'G3DSA:6.20.240.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235432, NULL, 'G3DSA:1.20.120.1710', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235433, NULL, 'G3DSA:2.170.16.10', NULL, NULL, NULL, NULL, 'Hedgehog/Intein (Hint) domain', NULL, NULL, NULL, 5),
(235434, NULL, 'G3DSA:3.40.50.150', NULL, NULL, NULL, NULL, 'Vaccinia Virus protein VP39', NULL, NULL, 24808, 5),
(235435, NULL, 'G3DSA:2.20.25.530', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235436, NULL, 'G3DSA:2.40.160.40', NULL, NULL, NULL, NULL, 'monomeric porin ompg', NULL, NULL, NULL, 5),
(235437, NULL, 'G3DSA:1.10.455.10', NULL, NULL, NULL, NULL, 'Ribosomal protein S7 domain', NULL, NULL, 27594, 5),
(235438, NULL, 'G3DSA:1.10.8.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235439, NULL, 'G3DSA:1.10.10.2840', NULL, NULL, NULL, NULL, '', NULL, NULL, 31806, 5),
(235440, NULL, 'G3DSA:3.30.1490.180', NULL, NULL, NULL, NULL, 'RNA polymerase ii', NULL, NULL, NULL, 5),
(235441, NULL, 'G3DSA:3.30.160.380', NULL, NULL, NULL, NULL, 'Dicer dimerisation domain', NULL, NULL, 27619, 5),
(235442, NULL, 'G3DSA:3.40.449.10', NULL, NULL, NULL, NULL, 'Phosphoenolpyruvate Carboxykinase, domain 1', NULL, NULL, 7029, 5),
(235443, NULL, 'G3DSA:1.20.1710.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33501, 5),
(235444, NULL, 'G3DSA:1.20.58.1520', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235445, NULL, 'G3DSA:3.90.70.180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235446, NULL, 'G3DSA:3.10.450.420', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235447, NULL, 'G3DSA:3.30.2290.10', NULL, NULL, NULL, NULL, 'PmbA/TldD superfamily', NULL, NULL, 33750, 5),
(235448, NULL, 'G3DSA:2.40.50.960', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235449, NULL, 'G3DSA:1.20.120.870', NULL, NULL, NULL, NULL, '', NULL, NULL, 36507, 5),
(235450, NULL, 'G3DSA:1.10.400.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235451, NULL, 'G3DSA:1.20.1530.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 33016, 5),
(235452, NULL, 'G3DSA:1.20.120.790', NULL, NULL, NULL, NULL, '', NULL, NULL, 31888, 5),
(235453, NULL, 'G3DSA:3.10.450.240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235454, NULL, 'G3DSA:1.20.120.1630', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235455, NULL, 'G3DSA:2.40.290.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235456, NULL, 'G3DSA:3.30.720.210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235457, NULL, 'G3DSA:3.30.2020.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 33127, 5),
(235458, NULL, 'G3DSA:1.20.190.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(235459, NULL, 'G3DSA:6.10.140.270', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235460, NULL, 'G3DSA:1.10.10.1030', NULL, NULL, NULL, NULL, 'IrrE, HTH domain', NULL, NULL, 36471, 5),
(235461, NULL, 'G3DSA:3.40.1390.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235462, NULL, 'G3DSA:3.30.530.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235463, NULL, 'G3DSA:3.90.700.10', NULL, NULL, NULL, NULL, 'Succinate dehydrogenase/fumarate reductase flavoprotein, catalytic domain', NULL, NULL, 24036, 5),
(235464, NULL, 'G3DSA:3.30.30.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235465, NULL, 'G3DSA:1.10.1400.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 34506, 5),
(235466, NULL, 'G3DSA:3.10.640.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 27518, 5),
(235467, NULL, 'G3DSA:3.40.30.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235468, NULL, 'G3DSA:1.10.10.2450', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235469, NULL, 'G3DSA:6.10.10.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235470, NULL, 'G3DSA:3.30.559.30', NULL, NULL, NULL, NULL, 'Nonribosomal peptide synthetase, condensation domain', NULL, NULL, NULL, 5),
(235471, NULL, 'G3DSA:4.10.820.10', NULL, NULL, NULL, NULL, 'Translocated intimin receptor, central domain', NULL, NULL, 28199, 5),
(235472, NULL, 'G3DSA:2.40.50.780', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235473, NULL, 'G3DSA:1.20.58.1210', NULL, NULL, NULL, NULL, '', NULL, NULL, 35190, 5),
(235474, NULL, 'G3DSA:2.30.330.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28278, 5),
(235475, NULL, 'G3DSA:3.40.50.12660', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235476, NULL, 'G3DSA:3.30.360.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235477, NULL, 'G3DSA:2.130.10.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235478, NULL, 'G3DSA:3.40.50.10630', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235479, NULL, 'G3DSA:1.10.10.600', NULL, NULL, NULL, NULL, '', NULL, NULL, 27694, 5),
(235480, NULL, 'G3DSA:1.10.287.3180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235481, NULL, 'G3DSA:3.20.20.110', NULL, NULL, NULL, NULL, '', NULL, NULL, 32224, 5),
(235482, NULL, 'G3DSA:6.10.250.1270', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235483, NULL, 'G3DSA:2.40.10.310', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235484, NULL, 'G3DSA:1.20.1500.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235485, NULL, 'G3DSA:2.40.50.650', NULL, NULL, NULL, NULL, '', NULL, NULL, 33954, 5),
(235486, NULL, 'G3DSA:3.30.479.20', NULL, NULL, NULL, NULL, 'Elongation factor Ts, dimerisation domain', NULL, NULL, 29452, 5),
(235487, NULL, 'G3DSA:2.40.420.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235488, NULL, 'G3DSA:3.40.50.11030', NULL, NULL, NULL, NULL, '', NULL, NULL, 27053, 5),
(235489, NULL, 'G3DSA:3.30.70.2590', NULL, NULL, NULL, NULL, '', NULL, NULL, 32377, 5),
(235490, NULL, 'G3DSA:4.10.280.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235491, NULL, 'G3DSA:3.30.420.310', NULL, NULL, NULL, NULL, '', NULL, NULL, 35361, 5),
(235492, NULL, 'G3DSA:6.10.250.2500', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235493, NULL, 'G3DSA:3.40.1380.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235494, NULL, 'G3DSA:3.40.50.740', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235495, NULL, 'G3DSA:3.20.20.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 8630, 5),
(235496, NULL, 'G3DSA:6.20.330.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235497, NULL, 'G3DSA:3.30.160.880', NULL, NULL, NULL, NULL, '', NULL, NULL, 36157, 5),
(235498, NULL, 'G3DSA:4.10.1240.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235499, NULL, 'G3DSA:3.30.1130.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 34670, 5),
(235500, NULL, 'G3DSA:3.10.400.10', NULL, NULL, NULL, NULL, 'Sulfate adenylyltransferase', NULL, NULL, NULL, 5),
(235501, NULL, 'G3DSA:3.10.129.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235502, NULL, 'G3DSA:3.20.80.10', NULL, NULL, NULL, NULL, 'Regulatory factor, effector binding domain', NULL, NULL, 8993, 5);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(235503, NULL, 'G3DSA:3.90.1110.10', NULL, NULL, NULL, NULL, 'RNA polymerase Rpb2, domain 2', NULL, NULL, 29207, 5),
(235504, NULL, 'G3DSA:1.10.1270.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29716, 5),
(235505, NULL, 'G3DSA:3.30.1760.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 17451, 5),
(235506, NULL, 'G3DSA:1.25.40.920', NULL, NULL, NULL, NULL, '', NULL, NULL, 33721, 5),
(235507, NULL, 'G3DSA:2.60.20.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 32180, 5),
(235508, NULL, 'G3DSA:3.40.50.1000', NULL, NULL, NULL, NULL, '', NULL, NULL, 4943, 5),
(235509, NULL, 'G3DSA:3.40.50.12270', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235510, NULL, 'G3DSA:1.20.1280.280', NULL, NULL, NULL, NULL, '', NULL, NULL, 32761, 5),
(235511, NULL, 'G3DSA:6.10.250.2240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235512, NULL, 'G3DSA:1.10.150.620', NULL, NULL, NULL, NULL, 'Capsid protein VP3, domain 1', NULL, NULL, 35726, 5),
(235513, NULL, 'G3DSA:2.60.40.2360', NULL, NULL, NULL, NULL, 'Intracellular proteinase inhibitor BsuPI', NULL, NULL, 30812, 5),
(235514, NULL, 'G3DSA:3.90.730.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28071, 5),
(235515, NULL, 'G3DSA:3.40.50.10550', NULL, NULL, NULL, NULL, 'Hypothetical protein af1403; domain 2', NULL, NULL, NULL, 5),
(235516, NULL, 'G3DSA:4.10.80.280', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235517, NULL, 'G3DSA:6.10.140.1520', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235518, NULL, 'G3DSA:3.90.830.10', NULL, NULL, NULL, NULL, 'Syntaxin Binding Protein 1; Chain A, domain 2', NULL, NULL, 34070, 5),
(235519, NULL, 'G3DSA:3.30.1730.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28259, 5),
(235520, NULL, 'G3DSA:1.10.287.1540', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235521, NULL, 'G3DSA:1.10.1900.40', NULL, NULL, NULL, NULL, 'Acidic terminal segments, variant surface antigen of PfEMP1', NULL, NULL, 36612, 5),
(235522, NULL, 'G3DSA:3.90.760.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32848, 5),
(235523, NULL, 'G3DSA:1.20.1280.100', NULL, NULL, NULL, NULL, 'Pas factor, saposin domain', NULL, NULL, NULL, 5),
(235524, NULL, 'G3DSA:2.30.30.1130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235525, NULL, 'G3DSA:3.10.620.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235526, NULL, 'G3DSA:3.30.1490.340', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235527, NULL, 'G3DSA:6.10.250.930', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235528, NULL, 'G3DSA:1.10.287.610', NULL, NULL, NULL, NULL, 'Helix hairpin bin', NULL, NULL, NULL, 5),
(235529, NULL, 'G3DSA:3.30.390.60', NULL, NULL, NULL, NULL, '', NULL, NULL, 6718, 5),
(235530, NULL, 'G3DSA:3.40.50.11750', NULL, NULL, NULL, NULL, 'HypD, alpha/beta domain 1', NULL, NULL, 33884, 5),
(235531, NULL, 'G3DSA:2.10.230.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235532, NULL, 'G3DSA:3.30.1470.10', NULL, NULL, NULL, NULL, 'Photosystem I PsaD, reaction center subunit II', NULL, NULL, NULL, 5),
(235533, NULL, 'G3DSA:1.10.3730.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235534, NULL, 'G3DSA:1.10.238.200', NULL, NULL, NULL, NULL, 'Cullin, PONY binding domain', NULL, NULL, 37088, 5),
(235535, NULL, 'G3DSA:1.10.10.480', NULL, NULL, NULL, NULL, 'Phosphofructokinase; domain 3', NULL, NULL, NULL, 5),
(235536, NULL, 'G3DSA:1.20.1610.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235537, NULL, 'G3DSA:1.10.3030.10', NULL, NULL, NULL, NULL, 'Gametocyte protein Pfg27', NULL, NULL, 31217, 5),
(235538, NULL, 'G3DSA:2.40.128.490', NULL, NULL, NULL, NULL, 'Uncharacterised protein PF14869, DUF4488', NULL, NULL, NULL, 5),
(235539, NULL, 'G3DSA:3.90.1770.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235540, NULL, 'G3DSA:6.10.250.3060', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235541, NULL, 'G3DSA:3.30.70.2850', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235542, NULL, 'G3DSA:3.10.20.600', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235543, NULL, 'G3DSA:2.60.40.4320', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235544, NULL, 'G3DSA:3.30.310.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 26533, 5);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(235545, NULL, 'G3DSA:3.40.50.10090', NULL, NULL, NULL, NULL, '', NULL, NULL, 32642, 5),
(235546, NULL, 'G3DSA:1.10.1740.240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235547, NULL, 'G3DSA:2.60.270.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235548, NULL, 'G3DSA:3.40.5.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235549, NULL, 'G3DSA:2.70.98.90', NULL, NULL, NULL, NULL, '', NULL, NULL, 27131, 5),
(235550, NULL, 'G3DSA:3.40.970.30', NULL, NULL, NULL, NULL, 'yp_829618.1 like domains', NULL, NULL, NULL, 5),
(235551, NULL, 'G3DSA:3.90.1180.10', NULL, NULL, NULL, NULL, 'Ribosomal protein L13', NULL, NULL, 28910, 5),
(235552, NULL, 'G3DSA:3.40.50.12240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235553, NULL, 'G3DSA:2.60.40.3740', NULL, NULL, NULL, NULL, '', NULL, NULL, 36469, 5),
(235554, NULL, 'G3DSA:3.30.300.210', NULL, NULL, NULL, NULL, 'Nutrient germinant receptor protein C, domain 3', NULL, NULL, 31738, 5),
(235555, NULL, 'G3DSA:1.20.120.460', NULL, NULL, NULL, NULL, 'protein pf1176 like', NULL, NULL, 28617, 5),
(235556, NULL, 'G3DSA:2.120.10.100', NULL, NULL, NULL, NULL, 'Apyrase', NULL, NULL, 29659, 5),
(235557, NULL, 'G3DSA:3.30.1360.200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235558, NULL, 'G3DSA:3.30.1140.60', NULL, NULL, NULL, NULL, '', NULL, NULL, 36683, 5),
(235559, NULL, 'G3DSA:2.60.120.200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235560, NULL, 'G3DSA:6.10.250.3030', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235561, NULL, 'G3DSA:6.10.250.150', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235562, NULL, 'G3DSA:2.120.10.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235563, NULL, 'G3DSA:3.30.70.3400', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235564, NULL, 'G3DSA:2.60.40.700', NULL, NULL, NULL, NULL, '', NULL, NULL, 33267, 5),
(235565, NULL, 'G3DSA:3.30.200.210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235566, NULL, 'G3DSA:6.10.280.10', NULL, NULL, NULL, NULL, 'Mediator complex, subunit Med21', NULL, NULL, NULL, 5),
(235567, NULL, 'G3DSA:3.10.20.580', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235568, NULL, 'G3DSA:2.40.128.440', NULL, NULL, NULL, NULL, 'Uncharacterised protein PF14274, DUF4361', NULL, NULL, NULL, 5),
(235569, NULL, 'G3DSA:2.60.20.10', NULL, NULL, NULL, NULL, 'Crystallins', NULL, NULL, NULL, 5),
(235570, NULL, 'G3DSA:3.30.200.270', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235571, NULL, 'G3DSA:3.30.1660.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 29560, 5),
(235572, NULL, 'G3DSA:3.30.810.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235573, NULL, 'G3DSA:3.30.1360.180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235574, NULL, 'G3DSA:2.70.98.50', NULL, NULL, NULL, NULL, 'putative glycoside hydrolase family protein from bacillus halodurans', NULL, NULL, NULL, 5),
(235575, NULL, 'G3DSA:3.30.70.1280', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235576, NULL, 'G3DSA:1.10.10.1920', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235577, NULL, 'G3DSA:2.60.40.2140', NULL, NULL, NULL, NULL, '', NULL, NULL, 36268, 5),
(235578, NULL, 'G3DSA:1.10.10.840', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235579, NULL, 'G3DSA:1.10.3110.10', NULL, NULL, NULL, NULL, 'protoporphyrinogen ix oxidase, domain 3', NULL, NULL, NULL, 5),
(235580, NULL, 'G3DSA:3.20.200.10', NULL, NULL, NULL, NULL, 'MHCK/EF2 kinase', NULL, NULL, NULL, 5),
(235581, NULL, 'G3DSA:3.30.1410.10', NULL, NULL, NULL, NULL, 'GTP cyclohydrolase I feedback regulatory protein GFRP', NULL, NULL, 32326, 5),
(235582, NULL, 'G3DSA:3.30.70.2820', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235583, NULL, 'G3DSA:6.10.140.1340', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235584, NULL, 'G3DSA:1.10.10.1870', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235585, NULL, 'G3DSA:3.40.50.11630', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235586, NULL, 'G3DSA:1.20.5.1210', NULL, NULL, NULL, NULL, 'Integron cassette protein helical domain', NULL, NULL, NULL, 5); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(235587, NULL, 'G3DSA:2.170.150.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235588, NULL, 'G3DSA:3.40.50.1450', NULL, NULL, NULL, NULL, '', NULL, NULL, 16213, 5),
(235589, NULL, 'G3DSA:4.10.51.10', NULL, NULL, NULL, NULL, 'Cytochrome C Oxidase, chain K', NULL, NULL, 6798, 5),
(235590, NULL, 'G3DSA:2.60.120.230', NULL, NULL, NULL, NULL, '', NULL, NULL, 8834, 5),
(235591, NULL, 'G3DSA:1.10.10.1480', NULL, NULL, NULL, NULL, 'Plasmid replication protein', NULL, NULL, 30304, 5),
(235592, NULL, 'G3DSA:6.10.140.2160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235593, NULL, 'G3DSA:3.40.190.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235594, NULL, 'G3DSA:2.40.50.800', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235595, NULL, 'G3DSA:6.20.370.140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235596, NULL, 'G3DSA:3.80.20.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 28077, 5),
(235597, NULL, 'G3DSA:1.10.287.370', NULL, NULL, NULL, NULL, '', NULL, NULL, 6083, 5),
(235598, NULL, 'G3DSA:3.10.450.210', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235599, NULL, 'G3DSA:2.30.30.990', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235600, NULL, 'G3DSA:1.10.940.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 26251, 5),
(235601, NULL, 'G3DSA:6.20.150.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235602, NULL, 'G3DSA:3.10.260.20', NULL, NULL, NULL, NULL, 'Ski', NULL, NULL, 28099, 5),
(235603, NULL, 'G3DSA:1.20.1640.10', NULL, NULL, NULL, NULL, 'Multidrug efflux transporter AcrB transmembrane domain', NULL, NULL, NULL, 5),
(235604, NULL, 'G3DSA:3.30.70.1350', NULL, NULL, NULL, NULL, 'Cation efflux protein, cytoplasmic domain', NULL, NULL, 27699, 5),
(235605, NULL, 'G3DSA:1.20.59.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235606, NULL, 'G3DSA:3.90.10.10', NULL, NULL, NULL, NULL, 'Cytochrome C3', NULL, NULL, NULL, 5),
(235607, NULL, 'G3DSA:3.80.30.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235608, NULL, 'G3DSA:1.20.5.220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235609, NULL, 'G3DSA:1.10.10.1140', NULL, NULL, NULL, NULL, '', NULL, NULL, 31205, 5),
(235610, NULL, 'G3DSA:3.20.100.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 37742, 5),
(235611, NULL, 'G3DSA:6.20.130.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235612, NULL, 'G3DSA:2.60.320.20', NULL, NULL, NULL, NULL, 'Pestivirus envelope glycoprotein E2, domain A', NULL, NULL, 36666, 5),
(235613, NULL, 'G3DSA:2.20.28.40', NULL, NULL, NULL, NULL, 'H/ACA ribonucleoprotein complex, subunit Nop10', NULL, NULL, NULL, 5),
(235614, NULL, 'G3DSA:2.120.10.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235615, NULL, 'G3DSA:2.60.40.3690', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235616, NULL, 'G3DSA:3.30.160.540', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235617, NULL, 'G3DSA:6.10.20.10', NULL, NULL, NULL, NULL, 'Lysine tRNA ligase, stem contact fold domain', NULL, NULL, 31531, 5),
(235618, NULL, 'G3DSA:3.30.300.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235619, NULL, 'G3DSA:1.20.50.60', NULL, NULL, NULL, NULL, 'ESP1, core domain', NULL, NULL, 35758, 5),
(235620, NULL, 'G3DSA:3.30.1120.50', NULL, NULL, NULL, NULL, '', NULL, NULL, 32204, 5),
(235621, NULL, 'G3DSA:6.10.250.900', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235622, NULL, 'G3DSA:3.10.20.300', NULL, NULL, NULL, NULL, 'mk0293 like domain', NULL, NULL, NULL, 5),
(235623, NULL, 'G3DSA:3.20.20.240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235624, NULL, 'G3DSA:6.10.250.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235625, NULL, 'G3DSA:1.20.1680.10', NULL, NULL, NULL, NULL, 'Type II deoxyuridine triphosphatase', NULL, NULL, NULL, 5),
(235626, NULL, 'G3DSA:1.25.10.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235627, NULL, 'G3DSA:2.80.10.70', NULL, NULL, NULL, NULL, 'Spindlin/Ssty', NULL, NULL, 34408, 5),
(235628, NULL, 'G3DSA:2.40.160.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235629, NULL, 'G3DSA:6.10.250.3090', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(235630, NULL, 'G3DSA:6.10.250.2480', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235631, NULL, 'G3DSA:6.10.250.1870', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235632, NULL, 'G3DSA:1.10.10.2660', NULL, NULL, NULL, NULL, '', NULL, NULL, 30737, 5),
(235633, NULL, 'G3DSA:1.20.58.1340', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235634, NULL, 'G3DSA:1.10.246.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235635, NULL, 'G3DSA:2.40.128.720', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235636, NULL, 'G3DSA:3.30.310.280', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235637, NULL, 'G3DSA:3.10.510.20', NULL, NULL, NULL, NULL, 'YcgL domain', NULL, NULL, 31307, 5),
(235638, NULL, 'G3DSA:3.30.1120.160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235639, NULL, 'G3DSA:1.10.10.1110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235640, NULL, 'G3DSA:1.20.120.1660', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235641, NULL, 'G3DSA:3.40.50.9100', NULL, NULL, NULL, NULL, 'Dehydroquinase, class II', NULL, NULL, 28163, 5),
(235642, NULL, 'G3DSA:1.20.960.10', NULL, NULL, NULL, NULL, 'Mitochondrial outer membrane translocase complex, subunit Tom20 domain', NULL, NULL, 15889, 5),
(235643, NULL, 'G3DSA:3.40.50.10840', NULL, NULL, NULL, NULL, '', NULL, NULL, 29477, 5),
(235644, NULL, 'G3DSA:1.20.5.880', NULL, NULL, NULL, NULL, 'Photosystem II reaction center protein H', NULL, NULL, 28315, 5),
(235645, NULL, 'G3DSA:1.20.5.1040', NULL, NULL, NULL, NULL, 'Sensor protein qsec.', NULL, NULL, NULL, 5),
(235646, NULL, 'G3DSA:2.30.30.230', NULL, NULL, NULL, NULL, '', NULL, NULL, 31129, 5),
(235647, NULL, 'G3DSA:6.10.140.2130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235648, NULL, 'G3DSA:6.10.250.880', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235649, NULL, 'G3DSA:1.10.10.470', NULL, NULL, NULL, NULL, 'Maltooligosyl trehalose synthase; domain 4', NULL, NULL, 10294, 5),
(235650, NULL, 'G3DSA:2.60.40.4230', NULL, NULL, NULL, NULL, 'Resistin head domain', NULL, NULL, 29742, 5),
(235651, NULL, 'G3DSA:3.30.420.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235652, NULL, 'G3DSA:1.10.275.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235653, NULL, 'G3DSA:2.60.40.2920', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235654, NULL, 'G3DSA:1.20.1180.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29641, 5),
(235655, NULL, 'G3DSA:4.10.990.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 25738, 5),
(235656, NULL, 'G3DSA:4.10.860.120', NULL, NULL, NULL, NULL, 'RNA polymerase II, clamp domain', NULL, NULL, 34267, 5),
(235657, NULL, 'G3DSA:2.30.30.720', NULL, NULL, NULL, NULL, 'Protein of unknown function (DUF3247)', NULL, NULL, NULL, 5),
(235658, NULL, 'G3DSA:1.10.220.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235659, NULL, 'G3DSA:2.20.25.220', NULL, NULL, NULL, NULL, 'Hepatitis C virus NS5A, 1B domain', NULL, NULL, 29598, 5),
(235660, NULL, 'G3DSA:1.10.10.2480', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235661, NULL, 'G3DSA:2.40.160.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235662, NULL, 'G3DSA:1.10.3690.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29920, 5),
(235663, NULL, 'G3DSA:3.90.640.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235664, NULL, 'G3DSA:1.10.287.2720', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235665, NULL, 'G3DSA:3.30.370.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235666, NULL, 'G3DSA:1.10.8.440', NULL, NULL, NULL, NULL, '', NULL, NULL, 35357, 5),
(235667, NULL, 'G3DSA:3.10.20.480', NULL, NULL, NULL, NULL, 'Antirestriction protein ArdA, domain 1', NULL, NULL, 30017, 5),
(235668, NULL, 'G3DSA:1.10.287.1020', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235669, NULL, 'G3DSA:2.60.40.3500', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235670, NULL, 'G3DSA:6.10.140.320', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235671, NULL, 'G3DSA:3.90.950.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 29531, 5),
(235672, NULL, 'G3DSA:1.20.5.430', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(235673, NULL, 'G3DSA:1.10.10.1210', NULL, NULL, NULL, NULL, 'MAGE homology domain, winged helix WH2 motif', NULL, NULL, 30720, 5),
(235674, NULL, 'G3DSA:1.10.10.1000', NULL, NULL, NULL, NULL, 'Type III secretion system virulence factor YopR, core domain', NULL, NULL, 30246, 5),
(235675, NULL, 'G3DSA:3.40.1000.20', NULL, NULL, NULL, NULL, '', NULL, NULL, 25393, 5),
(235676, NULL, 'G3DSA:2.60.40.1400', NULL, NULL, NULL, NULL, '', NULL, NULL, 9936, 5),
(235677, NULL, 'G3DSA:1.10.150.180', NULL, NULL, NULL, NULL, '', NULL, NULL, 30690, 5),
(235678, NULL, 'G3DSA:3.20.20.470', NULL, NULL, NULL, NULL, 'Glucansucrase', NULL, NULL, NULL, 5),
(235679, NULL, 'G3DSA:3.30.1330.200', NULL, NULL, NULL, NULL, '', NULL, NULL, 32221, 5),
(235680, NULL, 'G3DSA:4.10.80.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235681, NULL, 'G3DSA:1.10.3320.10', NULL, NULL, NULL, NULL, 'pa2218 like domain', NULL, NULL, 15772, 5),
(235682, NULL, 'G3DSA:3.30.40.110', NULL, NULL, NULL, NULL, '', NULL, NULL, 31030, 5),
(235683, NULL, 'G3DSA:3.10.450.190', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235684, NULL, 'G3DSA:3.30.350.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 27548, 5),
(235685, NULL, 'G3DSA:1.25.40.40', NULL, NULL, NULL, NULL, 'Cytochrome c oxidase, subunit Va/VI', NULL, NULL, 33106, 5),
(235686, NULL, 'G3DSA:3.30.500.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235687, NULL, 'G3DSA:2.40.50.830', NULL, NULL, NULL, NULL, '', NULL, NULL, 37535, 5),
(235688, NULL, 'G3DSA:6.10.140.1580', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235689, NULL, 'G3DSA:2.40.50.990', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235690, NULL, 'G3DSA:3.30.70.2610', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235691, NULL, 'G3DSA:2.40.50.320', NULL, NULL, NULL, NULL, 'Copper binding periplasmic protein CusF', NULL, NULL, 36015, 5),
(235692, NULL, 'G3DSA:3.40.1180.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 27551, 5),
(235693, NULL, 'G3DSA:1.10.3380.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235694, NULL, 'G3DSA:3.90.960.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32254, 5),
(235695, NULL, 'G3DSA:1.10.3680.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235696, NULL, 'G3DSA:1.50.40.10', NULL, NULL, NULL, NULL, 'Mitochondrial carrier domain', NULL, NULL, 16096, 5),
(235697, NULL, 'G3DSA:3.30.565.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235698, NULL, 'G3DSA:1.20.1320.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235699, NULL, 'G3DSA:3.40.1350.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235700, NULL, 'G3DSA:3.90.70.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235701, NULL, 'G3DSA:3.30.70.3590', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235702, NULL, 'G3DSA:3.90.198.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 34480, 5),
(235703, NULL, 'G3DSA:1.25.40.980', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235704, NULL, 'G3DSA:2.90.20.10', NULL, NULL, NULL, NULL, 'Plasmodium vivax P25 domain', NULL, NULL, NULL, 5),
(235705, NULL, 'G3DSA:1.10.1540.10', NULL, NULL, NULL, NULL, 'BEACH domain', NULL, NULL, 28396, 5),
(235706, NULL, 'G3DSA:1.10.1220.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235707, NULL, 'G3DSA:3.90.1170.40', NULL, NULL, NULL, NULL, 'Molybdopterin biosynthesis MoaE subunit', NULL, NULL, 33044, 5),
(235708, NULL, 'G3DSA:2.60.120.180', NULL, NULL, NULL, NULL, '', NULL, NULL, 11258, 5),
(235709, NULL, 'G3DSA:1.20.58.2130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235710, NULL, 'G3DSA:4.10.800.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 34164, 5),
(235711, NULL, 'G3DSA:1.20.120.20', NULL, NULL, NULL, NULL, 'Apolipoprotein', NULL, NULL, NULL, 5),
(235712, NULL, 'G3DSA:1.10.210.10', NULL, NULL, NULL, NULL, 'Secretoglobin', NULL, NULL, NULL, 5),
(235713, NULL, 'G3DSA:1.20.1420.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235714, NULL, 'G3DSA:1.10.3820.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32258, 5),
(235715, NULL, 'G3DSA:3.30.160.360', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(235716, NULL, 'G3DSA:3.30.1340.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235717, NULL, 'G3DSA:6.10.250.1090', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235718, NULL, 'G3DSA:1.10.405.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235719, NULL, 'G3DSA:1.10.3430.10', NULL, NULL, NULL, NULL, 'Ammonium transporter AmtB like domains', NULL, NULL, 21621, 5),
(235720, NULL, 'G3DSA:1.20.5.570', NULL, NULL, NULL, NULL, 'Single helix bin', NULL, NULL, NULL, 5),
(235721, NULL, 'G3DSA:3.90.1350.10', NULL, NULL, NULL, NULL, 'Exotoxin A, middle domain', NULL, NULL, 31065, 5),
(235722, NULL, 'G3DSA:3.30.457.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235723, NULL, 'G3DSA:3.30.160.510', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235724, NULL, 'G3DSA:6.10.250.3270', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235725, NULL, 'G3DSA:3.40.1310.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 34026, 5),
(235726, NULL, 'G3DSA:2.60.40.2950', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235727, NULL, 'G3DSA:1.20.5.2280', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235728, NULL, 'G3DSA:3.40.50.12060', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235729, NULL, 'G3DSA:2.140.10.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235730, NULL, 'G3DSA:3.30.1460.70', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235731, NULL, 'G3DSA:3.30.70.1820', NULL, NULL, NULL, NULL, 'L1 transposable element, RRM domain', NULL, NULL, NULL, 5),
(235732, NULL, 'G3DSA:3.40.50.11660', NULL, NULL, NULL, NULL, '', NULL, NULL, 32345, 5),
(235733, NULL, 'G3DSA:6.20.370.60', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235734, NULL, 'G3DSA:1.10.1200.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 33014, 5),
(235735, NULL, 'G3DSA:3.90.25.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235736, NULL, 'G3DSA:3.10.150.10', NULL, NULL, NULL, NULL, 'DNA Polymerase III, subunit A, domain 2', NULL, NULL, NULL, 5),
(235737, NULL, 'G3DSA:6.10.250.2450', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235738, NULL, 'G3DSA:3.40.1010.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 8586, 5),
(235739, NULL, 'G3DSA:3.20.20.480', NULL, NULL, NULL, NULL, '', NULL, NULL, 32274, 5),
(235740, NULL, 'G3DSA:2.170.15.10', NULL, NULL, NULL, NULL, 'Proaerolysin, chain A, domain 3', NULL, NULL, NULL, 5),
(235741, NULL, 'G3DSA:3.30.300.50', NULL, NULL, NULL, NULL, '', NULL, NULL, 33520, 5),
(235742, NULL, 'G3DSA:3.30.70.3250', NULL, NULL, NULL, NULL, 'Ribonuclease P, Pop5 subunit', NULL, NULL, 31103, 5),
(235743, NULL, 'G3DSA:3.30.1330.40', NULL, NULL, NULL, NULL, '', NULL, NULL, 19191, 5),
(235744, NULL, 'G3DSA:2.40.128.180', NULL, NULL, NULL, NULL, '', NULL, NULL, 32117, 5),
(235745, NULL, 'G3DSA:1.10.287.340', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235746, NULL, 'G3DSA:3.40.50.10910', NULL, NULL, NULL, NULL, 'Amidohydrolase', NULL, NULL, NULL, 5),
(235747, NULL, 'G3DSA:6.10.280.50', NULL, NULL, NULL, NULL, '', NULL, NULL, 31315, 5),
(235748, NULL, 'G3DSA:1.20.120.1690', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235749, NULL, 'G3DSA:3.40.50.2030', NULL, NULL, NULL, NULL, '', NULL, NULL, 10579, 5),
(235750, NULL, 'G3DSA:3.50.100.10', NULL, NULL, NULL, NULL, 'protein il1583 domain', NULL, NULL, NULL, 5),
(235751, NULL, 'G3DSA:1.10.3360.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235752, NULL, 'G3DSA:2.60.120.990', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235753, NULL, 'G3DSA:3.30.1640.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 29978, 5),
(235754, NULL, 'G3DSA:1.20.5.2120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235755, NULL, 'G3DSA:1.25.70.10', NULL, NULL, NULL, NULL, 'Transcription termination factor 3, mitochondrial', NULL, NULL, 33507, 5),
(235756, NULL, 'G3DSA:2.70.98.20', NULL, NULL, NULL, NULL, 'Copper amine oxidase, catalytic domain', NULL, NULL, 31962, 5),
(235757, NULL, 'G3DSA:3.30.70.1420', NULL, NULL, NULL, NULL, 'Structure from the mobile metagenome of cole harbour salt marsh: integron cassette protein hfx_cass1', NULL, NULL, NULL, 5);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(235758, NULL, 'G3DSA:1.10.10.1710', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235759, NULL, 'G3DSA:1.10.246.190', NULL, NULL, NULL, NULL, 'Autophagy protein Apg5, helix rich domain', NULL, NULL, 33688, 5),
(235760, NULL, 'G3DSA:3.40.1080.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235761, NULL, 'G3DSA:2.30.30.780', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235762, NULL, 'G3DSA:3.30.70.240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235763, NULL, 'G3DSA:2.40.40.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28987, 5),
(235764, NULL, 'G3DSA:3.40.50.1240', NULL, NULL, NULL, NULL, '', NULL, NULL, 24454, 5),
(235765, NULL, 'G3DSA:3.30.1960.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32533, 5),
(235766, NULL, 'G3DSA:2.60.40.1580', NULL, NULL, NULL, NULL, 'Particulate methane monooxygenase, b subunit. Chain: A, domain 3', NULL, NULL, 9503, 5),
(235767, NULL, 'G3DSA:2.60.40.4060', NULL, NULL, NULL, NULL, 'Reeler domain', NULL, NULL, 36804, 5),
(235768, NULL, 'G3DSA:1.20.5.780', NULL, NULL, NULL, NULL, 'Single helix bin', NULL, NULL, NULL, 5),
(235769, NULL, 'G3DSA:6.10.40.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235770, NULL, 'G3DSA:3.30.470.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235771, NULL, 'G3DSA:1.20.920.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235772, NULL, 'G3DSA:3.30.1710.10', NULL, NULL, NULL, NULL, 'top7, de novo designed protein', NULL, NULL, NULL, 5),
(235773, NULL, 'G3DSA:1.10.238.230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235774, NULL, 'G3DSA:1.10.1630.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29960, 5),
(235775, NULL, 'G3DSA:1.20.960.50', NULL, NULL, NULL, NULL, 'Cleavage stimulation factor subunit 1, dimerisation domain', NULL, NULL, 30078, 5),
(235776, NULL, 'G3DSA:3.30.160.720', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235777, NULL, 'G3DSA:2.20.25.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235778, NULL, 'G3DSA:1.20.5.550', NULL, NULL, NULL, NULL, 'Single Helix bin', NULL, NULL, 12237, 5),
(235779, NULL, 'G3DSA:1.10.238.260', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235780, NULL, 'G3DSA:2.30.170.20', NULL, NULL, NULL, NULL, 'Ribosomal protein L24e', NULL, NULL, 27116, 5),
(235781, NULL, 'G3DSA:6.10.280.160', NULL, NULL, NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 22', NULL, NULL, NULL, 5),
(235782, NULL, 'G3DSA:1.10.287.910', NULL, NULL, NULL, NULL, 'bacterial mercury transporter, merf', NULL, NULL, NULL, 5),
(235783, NULL, 'G3DSA:1.10.3040.10', NULL, NULL, NULL, NULL, 'borna disease virus nucleoprotein, domain 1', NULL, NULL, 9209, 5),
(235784, NULL, 'G3DSA:1.10.287.1390', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235785, NULL, 'G3DSA:3.40.30.170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235786, NULL, 'G3DSA:3.40.1740.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235787, NULL, 'G3DSA:6.20.50.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235788, NULL, 'G3DSA:2.60.440.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 26555, 5),
(235789, NULL, 'G3DSA:4.10.1210.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31090, 5),
(235790, NULL, 'G3DSA:2.10.10.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235791, NULL, 'G3DSA:6.10.250.2660', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235792, NULL, 'G3DSA:1.20.930.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235793, NULL, 'G3DSA:3.10.20.420', NULL, NULL, NULL, NULL, '', NULL, NULL, 30460, 5),
(235794, NULL, 'G3DSA:1.10.606.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 11254, 5),
(235795, NULL, 'G3DSA:1.10.8.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235796, NULL, 'G3DSA:3.90.70.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 32643, 5),
(235797, NULL, 'G3DSA:1.20.58.830', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235798, NULL, 'G3DSA:1.10.10.630', NULL, NULL, NULL, NULL, '', NULL, NULL, 29014, 5),
(235799, NULL, 'G3DSA:3.10.290.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 11624, 5),
(235800, NULL, 'G3DSA:3.30.56.110', NULL, NULL, NULL, NULL, 'Protein of unknown function DUF2237', NULL, NULL, NULL, 5);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(235801, NULL, 'G3DSA:3.30.70.270', NULL, NULL, NULL, NULL, '', NULL, NULL, 35210, 5),
(235802, NULL, 'G3DSA:1.10.1100.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 27979, 5),
(235803, NULL, 'G3DSA:6.10.250.3240', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235804, NULL, 'G3DSA:1.10.40.40', NULL, NULL, NULL, NULL, 'Deoxyribonucleotidase; domain 2', NULL, NULL, NULL, 5),
(235805, NULL, 'G3DSA:1.20.120.1090', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235806, NULL, 'G3DSA:1.20.5.1220', NULL, NULL, NULL, NULL, 'Regulatory protein rop', NULL, NULL, NULL, 5),
(235807, NULL, 'G3DSA:6.20.450.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235808, NULL, 'G3DSA:3.30.70.3220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235809, NULL, 'G3DSA:2.60.9.10', NULL, NULL, NULL, NULL, 'Neurohypophysial hormone domain', NULL, NULL, 27535, 5),
(235810, NULL, 'G3DSA:1.10.274.70', NULL, NULL, NULL, NULL, '', NULL, NULL, 30572, 5),
(235811, NULL, 'G3DSA:3.40.1210.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32898, 5),
(235812, NULL, 'G3DSA:3.30.500.50', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235813, NULL, 'G3DSA:1.20.1290.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 32455, 5),
(235814, NULL, 'G3DSA:6.10.250.330', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235815, NULL, 'G3DSA:3.30.300.280', NULL, NULL, NULL, NULL, '', NULL, NULL, 34915, 5),
(235816, NULL, 'G3DSA:6.10.140.1160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235817, NULL, 'G3DSA:3.30.70.1530', NULL, NULL, NULL, NULL, 'Hypothetical protein rpa1041', NULL, NULL, NULL, 5),
(235818, NULL, 'G3DSA:4.10.280.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235819, NULL, 'G3DSA:2.60.40.3920', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235820, NULL, 'G3DSA:3.30.2110.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32324, 5),
(235821, NULL, 'G3DSA:3.40.1560.10', NULL, NULL, NULL, NULL, 'type ii restriction endonuclease, domain 2', NULL, NULL, 14000, 5),
(235822, NULL, 'G3DSA:6.10.10.120', NULL, NULL, NULL, NULL, '', NULL, NULL, 31102, 5),
(235823, NULL, 'G3DSA:3.40.50.12420', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235824, NULL, 'G3DSA:3.30.470.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235825, NULL, 'G3DSA:1.10.8.990', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235826, NULL, 'G3DSA:1.20.120.810', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235827, NULL, 'G3DSA:1.20.50.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235828, NULL, 'G3DSA:1.10.3460.10', NULL, NULL, NULL, NULL, 'Chlorophyll a/b binding protein domain', NULL, NULL, NULL, 5),
(235829, NULL, 'G3DSA:2.20.28.120', NULL, NULL, NULL, NULL, 'Ribosomal protein L33', NULL, NULL, 29847, 5),
(235830, NULL, 'G3DSA:1.10.10.1810', NULL, NULL, NULL, NULL, 'RNA ligase', NULL, NULL, 30042, 5),
(235831, NULL, 'G3DSA:2.60.120.1690', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235832, NULL, 'G3DSA:3.40.1110.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 14904, 5),
(235833, NULL, 'G3DSA:3.90.1570.40', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235834, NULL, 'G3DSA:2.60.40.1260', NULL, NULL, NULL, NULL, 'Lamin Tail domain', NULL, NULL, 27914, 5),
(235835, NULL, 'G3DSA:1.10.520.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 15755, 5),
(235836, NULL, 'G3DSA:6.10.250.2270', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235837, NULL, 'G3DSA:2.20.25.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 13764, 5),
(235838, NULL, 'G3DSA:3.30.1330.230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235839, NULL, 'G3DSA:3.30.70.2040', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235840, NULL, 'G3DSA:4.10.1080.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 26844, 5),
(235841, NULL, 'G3DSA:6.10.140.1760', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235842, NULL, 'G3DSA:2.20.230.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235843, NULL, 'G3DSA:6.20.370.90', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235844, NULL, 'G3DSA:1.20.1740.10', NULL, NULL, NULL, NULL, 'Amino acid/polyamine transporter I', NULL, NULL, NULL, 5);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(235845, NULL, 'G3DSA:3.30.2220.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 27761, 5),
(235846, NULL, 'G3DSA:3.10.20.810', NULL, NULL, NULL, NULL, '', NULL, NULL, 28313, 5),
(235847, NULL, 'G3DSA:3.40.50.10670', NULL, NULL, NULL, NULL, 'af2093 domain', NULL, NULL, NULL, 5),
(235848, NULL, 'G3DSA:3.30.1330.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 32923, 5),
(235849, NULL, 'G3DSA:1.10.268.10', NULL, NULL, NULL, NULL, 'Topoisomerase, domain 3', NULL, NULL, 7976, 5),
(235850, NULL, 'G3DSA:2.60.40.1320', NULL, NULL, NULL, NULL, 'SRS domain', NULL, NULL, 32080, 5),
(235851, NULL, 'G3DSA:1.20.1420.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 36258, 5),
(235852, NULL, 'G3DSA:1.20.58.1420', NULL, NULL, NULL, NULL, 'Dsl1p vesicle tethering complex, Tip20p subunit, domain B', NULL, NULL, 30408, 5),
(235853, NULL, 'G3DSA:3.90.930.1', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235854, NULL, 'G3DSA:3.10.460.10', NULL, NULL, NULL, NULL, 'VSV matrix protein', NULL, NULL, 33665, 5),
(235855, NULL, 'G3DSA:6.10.140.870', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235856, NULL, 'G3DSA:3.30.429.10', NULL, NULL, NULL, NULL, 'Macrophage Migration Inhibitory Factor', NULL, NULL, 12729, 5),
(235857, NULL, 'G3DSA:1.20.5.3070', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235858, NULL, 'G3DSA:2.60.120.960', NULL, NULL, NULL, NULL, '', NULL, NULL, 36089, 5),
(235859, NULL, 'G3DSA:2.60.40.3530', NULL, NULL, NULL, NULL, '', NULL, NULL, 31277, 5),
(235860, NULL, 'G3DSA:3.40.1190.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235861, NULL, 'G3DSA:3.30.70.3260', NULL, NULL, NULL, NULL, 'Uncharacterised protein PF10802, DUF2540', NULL, NULL, NULL, 5),
(235862, NULL, 'G3DSA:3.30.980.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235863, NULL, 'G3DSA:6.10.140.500', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235864, NULL, 'G3DSA:1.10.3480.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235865, NULL, 'G3DSA:2.40.370.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 15661, 5),
(235866, NULL, 'G3DSA:2.60.40.3320', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235867, NULL, 'G3DSA:6.10.250.1500', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235868, NULL, 'G3DSA:1.10.390.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 34777, 5),
(235869, NULL, 'G3DSA:1.10.8.1040', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235870, NULL, 'G3DSA:1.10.150.570', NULL, NULL, NULL, NULL, '', NULL, NULL, 36827, 5),
(235871, NULL, 'G3DSA:3.30.160.330', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235872, NULL, 'G3DSA:3.30.2000.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235873, NULL, 'G3DSA:2.20.25.500', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235874, NULL, 'G3DSA:1.20.140.30', NULL, NULL, NULL, NULL, 'MOB kinase activator', NULL, NULL, 31919, 5),
(235875, NULL, 'G3DSA:3.40.1840.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 8399, 5),
(235876, NULL, 'G3DSA:3.30.1370.180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235877, NULL, 'G3DSA:4.10.830.10', NULL, NULL, NULL, NULL, '30s Ribosomal Protein S14; Chain N', NULL, NULL, 35396, 5),
(235878, NULL, 'G3DSA:3.10.200.10', NULL, NULL, NULL, NULL, 'Alpha carbonic anhydrase', NULL, NULL, 31669, 5),
(235879, NULL, 'G3DSA:1.50.10.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235880, NULL, 'G3DSA:3.30.2180.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 34878, 5),
(235881, NULL, 'G3DSA:1.20.120.1140', NULL, NULL, NULL, NULL, 'CAG pathogenicity island protein 13, CagS', NULL, NULL, 28956, 5),
(235882, NULL, 'G3DSA:3.90.1720.80', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235883, NULL, 'G3DSA:6.10.260.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235884, NULL, 'G3DSA:3.10.180.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 24585, 5),
(235885, NULL, 'G3DSA:1.10.506.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 8873, 5),
(235886, NULL, 'G3DSA:1.20.5.860', NULL, NULL, NULL, NULL, 'Photosystem II cytochrome b559, alpha subunit', NULL, NULL, 27015, 5),
(235887, NULL, 'G3DSA:3.30.70.2430', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(235888, NULL, 'G3DSA:3.30.70.2290', NULL, NULL, NULL, NULL, 'Protein of unknown function (DUF3208)', NULL, NULL, NULL, 5),
(235889, NULL, 'G3DSA:3.40.50.10660', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235890, NULL, 'G3DSA:3.90.430.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28654, 5),
(235891, NULL, 'G3DSA:3.90.1450.10', NULL, NULL, NULL, NULL, 'Guanylin', NULL, NULL, 32312, 5),
(235892, NULL, 'G3DSA:6.10.140.1550', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235893, NULL, 'G3DSA:1.10.150.390', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235894, NULL, 'G3DSA:3.40.50.11060', NULL, NULL, NULL, NULL, '', NULL, NULL, 33596, 5),
(235895, NULL, 'G3DSA:1.10.3890.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29559, 5),
(235896, NULL, 'G3DSA:1.10.1240.90', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 5),
(235897, NULL, 'G3DSA:1.20.1380.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 27580, 5),
(235898, NULL, 'G3DSA:6.10.140.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235899, NULL, 'G3DSA:3.40.50.200', NULL, NULL, NULL, NULL, 'Peptidase S8/S53 domain', NULL, NULL, 31887, 5),
(235900, NULL, 'G3DSA:3.30.56.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235901, NULL, 'G3DSA:3.30.110.200', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235902, NULL, 'G3DSA:1.10.3160.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235903, NULL, 'G3DSA:1.10.10.2690', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235904, NULL, 'G3DSA:2.40.128.360', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235905, NULL, 'G3DSA:1.20.58.1370', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235906, NULL, 'G3DSA:1.10.3350.20', NULL, NULL, NULL, NULL, 'Tmem141 protein family', NULL, NULL, 27031, 5),
(235907, NULL, 'G3DSA:3.40.50.10480', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235908, NULL, 'G3DSA:1.10.8.800', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235909, NULL, 'G3DSA:1.25.40.770', NULL, NULL, NULL, NULL, '', NULL, NULL, 37642, 5),
(235910, NULL, 'G3DSA:3.90.228.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235911, NULL, 'G3DSA:1.25.40.950', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235912, NULL, 'G3DSA:6.10.250.3450', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235913, NULL, 'G3DSA:2.60.40.1500', NULL, NULL, NULL, NULL, 'Glycosyl hydrolase domain; family 39', NULL, NULL, NULL, 5),
(235914, NULL, 'G3DSA:2.60.120.1320', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235915, NULL, 'G3DSA:1.20.1270.330', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235916, NULL, 'G3DSA:6.10.140.1370', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235917, NULL, 'G3DSA:3.30.2320.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 32131, 5),
(235918, NULL, 'G3DSA:2.170.150.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 33654, 5),
(235919, NULL, 'G3DSA:3.30.750.130', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235920, NULL, 'G3DSA:2.60.40.2460', NULL, NULL, NULL, NULL, 'Phage bIL170 RBP, head domain', NULL, NULL, 34397, 5),
(235921, NULL, 'G3DSA:1.25.40.750', NULL, NULL, NULL, NULL, 'Domain of unknown function DUF5071', NULL, NULL, 32135, 5),
(235922, NULL, 'G3DSA:2.60.40.3710', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235923, NULL, 'G3DSA:3.30.9.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235924, NULL, 'G3DSA:1.20.1050.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235925, NULL, 'G3DSA:2.70.98.60', NULL, NULL, NULL, NULL, '', NULL, NULL, 32101, 5),
(235926, NULL, 'G3DSA:6.10.250.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235927, NULL, 'G3DSA:2.40.270.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 29061, 5),
(235928, NULL, 'G3DSA:2.20.25.690', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235929, NULL, 'G3DSA:6.20.10.30', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235930, NULL, 'G3DSA:6.10.140.1940', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235931, NULL, 'G3DSA:6.10.250.2090', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235932, NULL, 'G3DSA:3.30.60.270', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(235933, NULL, 'G3DSA:2.10.25.10', NULL, NULL, NULL, NULL, 'Laminin', NULL, NULL, NULL, 5),
(235934, NULL, 'G3DSA:3.30.1490.190', NULL, NULL, NULL, NULL, '', NULL, NULL, 34975, 5),
(235935, NULL, 'G3DSA:2.30.30.550', NULL, NULL, NULL, NULL, 'Major Vault Protein repeat', NULL, NULL, 36428, 5),
(235936, NULL, 'G3DSA:1.10.287.1960', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235937, NULL, 'G3DSA:3.30.2330.20', NULL, NULL, NULL, NULL, 'family 98 glycoside hydrolase', NULL, NULL, NULL, 5),
(235938, NULL, 'G3DSA:3.30.250.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235939, NULL, 'G3DSA:1.20.120.630', NULL, NULL, NULL, NULL, '', NULL, NULL, 31848, 5),
(235940, NULL, 'G3DSA:2.40.50.230', NULL, NULL, NULL, NULL, '', NULL, NULL, 27039, 5),
(235941, NULL, 'G3DSA:6.10.250.1690', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235942, NULL, 'G3DSA:2.40.30.60', NULL, NULL, NULL, NULL, 'RimM', NULL, NULL, 30230, 5),
(235943, NULL, 'G3DSA:3.30.1430.10', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235944, NULL, 'G3DSA:1.20.1280.120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235945, NULL, 'G3DSA:2.60.40.3140', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235946, NULL, 'G3DSA:1.10.10.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 28198, 5),
(235947, NULL, 'G3DSA:3.90.1150.30', NULL, NULL, NULL, NULL, '', NULL, NULL, 32106, 5),
(235948, NULL, 'G3DSA:3.90.1150.100', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235949, NULL, 'G3DSA:1.10.472.110', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235950, NULL, 'G3DSA:4.10.460.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 34102, 5),
(235951, NULL, 'G3DSA:3.10.20.80', NULL, NULL, NULL, NULL, '', NULL, NULL, 33468, 5),
(235952, NULL, 'G3DSA:2.170.180.11', NULL, NULL, NULL, NULL, 'Methuselah ectodomain, domain 2', NULL, NULL, 17058, 5),
(235953, NULL, 'G3DSA:3.40.50.12810', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235954, NULL, 'G3DSA:3.55.40.10', NULL, NULL, NULL, NULL, 'minor pseudopilin epsh domain', NULL, NULL, NULL, 5),
(235955, NULL, 'G3DSA:1.10.150.190', NULL, NULL, NULL, NULL, 'Translation initiation factor 2; subunit 1; domain 2', NULL, NULL, 12388, 5),
(235956, NULL, 'G3DSA:3.30.479.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 31168, 5),
(235957, NULL, 'G3DSA:2.40.400.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 15871, 5),
(235958, NULL, 'G3DSA:2.20.140.10', NULL, NULL, NULL, NULL, 'WGR domain', NULL, NULL, NULL, 5),
(235959, NULL, 'G3DSA:3.30.390.170', NULL, NULL, NULL, NULL, '', NULL, NULL, 28896, 5),
(235960, NULL, 'G3DSA:1.10.730.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235961, NULL, 'G3DSA:3.90.79.20', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235962, NULL, 'G3DSA:1.10.10.1320', NULL, NULL, NULL, NULL, '', NULL, NULL, 30004, 5),
(235963, NULL, 'G3DSA:1.20.5.250', NULL, NULL, NULL, NULL, '', NULL, NULL, 12304, 5),
(235964, NULL, 'G3DSA:3.30.160.60', NULL, NULL, NULL, NULL, 'Classic Zinc Finger', NULL, NULL, NULL, 5),
(235965, NULL, 'G3DSA:1.20.120.1480', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 5),
(235966, NULL, 'G3DSA:4.10.90.10', NULL, NULL, NULL, NULL, 'Capsid protein VP4 superfamily, Picornavirus', NULL, NULL, 29884, 5),
(235967, NULL, 'G3DSA:4.10.1110.10', NULL, NULL, NULL, NULL, '', NULL, NULL, 4883, 5),
(235968, NULL, 'G3DSA:3.40.5.90', NULL, NULL, NULL, NULL, '', NULL, NULL, 35123, 5),
(235969, NULL, 'G3DSA:1.50.10.100', NULL, NULL, NULL, NULL, 'Chondroitin AC/alginate lyase', NULL, NULL, 8627, 5),
(235970, NULL, 'mobidb-lite', NULL, NULL, 'consensus disorder prediction', NULL, 'disorder_prediction', NULL, NULL, NULL, 6),
(235971, NULL, 'MF_01800', NULL, NULL, 'Chromosome partition protein MukB [mukB].', NULL, 'MukB', NULL, NULL, 12982, 7),
(235972, NULL, 'MF_00257', NULL, NULL, 'Putative snRNP Sm-like protein.', NULL, 'Lsm_RuxX', NULL, NULL, 17255, 7),
(235973, NULL, 'MF_03047', NULL, NULL, 'Ataxin-7-like protein 3 [ATXN7L3].', NULL, 'Sgf11', NULL, NULL, 12839, 7),
(235974, NULL, 'MF_00636', NULL, NULL, 'RNase adapter protein RapZ [rapZ].', NULL, 'RapZ_like', NULL, NULL, 6056, 7);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(235975, NULL, 'MF_01214', NULL, NULL, 'PyrE-like protein.', NULL, 'PyrE_like', NULL, NULL, 17414, 7),
(235976, NULL, 'MF_00913', NULL, NULL, 'Probable peptidoglycan glycosyltransferase FtsW [ftsW].', NULL, 'PGT_FtsW_proteobact', NULL, NULL, 9298, 7),
(235977, NULL, 'MF_00969', NULL, NULL, 'Transcription-repair-coupling factor [mfd].', NULL, 'TRCF', NULL, NULL, 905, 7),
(235978, NULL, 'MF_03128', NULL, NULL, 'Lipoyl synthase, mitochondrial [LIP1].', NULL, 'Lipoyl_synth_plantM', NULL, NULL, 23565, 7),
(235979, NULL, 'MF_01947', NULL, NULL, 'N(4)-bis(aminopropyl)spermidine synthase [bpsA].', NULL, 'Aminopropyltransf_BpsA', NULL, NULL, 7565, 7),
(235980, NULL, 'MF_02119', NULL, NULL, 'Lipoyl-[GcvH]:protein N-lipoyltransferase [lipL].', NULL, 'LipL', NULL, NULL, 21651, 7),
(235981, NULL, 'MF_00230', NULL, NULL, 'Nicotinate-nucleotide--dimethylbenzimidazole phosphoribosyltransferase [cobT].', NULL, 'CobT', NULL, NULL, 12862, 7),
(235982, NULL, 'MF_01077', NULL, NULL, 'Ribosome maturation factor RimP [rimP].', NULL, 'RimP', NULL, NULL, 6109, 7),
(235983, NULL, 'MF_02099', NULL, NULL, 'Hydrogenase maturation factor HybF [hybF].', NULL, 'HybF_subfam', NULL, NULL, 30973, 7),
(235984, NULL, 'MF_00853', NULL, NULL, 'Protoporphyrinogen IX dehydrogenase [quinone] [hemG].', NULL, 'HemG', NULL, NULL, 35375, 7),
(235985, NULL, 'MF_00361', NULL, NULL, 'NAD kinase [nadK].', NULL, 'NAD_kinase', NULL, NULL, 815, 7),
(235986, NULL, 'MF_01322', NULL, NULL, 'DNA-directed RNA polymerase subunit beta'' [rpoC].', NULL, 'RNApol_bact_RpoC', NULL, NULL, 9563, 7),
(235987, NULL, 'MF_01673', NULL, NULL, '5-deoxy-glucuronate isomerase [iolB].', NULL, 'IolB', NULL, NULL, 7341, 7),
(235988, NULL, 'MF_00037', NULL, NULL, 'UDP-N-acetylenolpyruvoylglucosamine reductase [murB].', NULL, 'MurB', NULL, NULL, 1983, 7),
(235989, NULL, 'MF_00618', NULL, NULL, 'Phycocyanobilin:ferredoxin oxidoreductase [pcyA].', NULL, 'Ferredoxin_bilin_red', NULL, NULL, 17449, 7),
(235990, NULL, 'MF_01559', NULL, NULL, 'L-lactate dehydrogenase [lldD].', NULL, 'L_lact_dehydr', NULL, NULL, 14931, 7),
(235991, NULL, 'MF_00685', NULL, NULL, '1,4-alpha-glucan branching enzyme GlgB [glgB].', NULL, 'GlgB', NULL, NULL, 5584, 7),
(235992, NULL, 'MF_01534', NULL, NULL, 'HTH-type transcriptional activator RhaS [rhaS].', NULL, 'HTH_type_RhaS', NULL, NULL, 16102, 7),
(235993, NULL, 'MF_03116', NULL, NULL, 'Methylthioribulose-1-phosphate dehydratase [APIP].', NULL, 'Salvage_MtnB_euk', NULL, NULL, 23055, 7),
(235994, NULL, 'MF_00121', NULL, NULL, 'Aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase subunit B [gatB].', NULL, 'GatB', NULL, NULL, 5859, 7),
(235995, NULL, 'MF_02005', NULL, NULL, 'Valine--tRNA ligase [valS].', NULL, 'Val_tRNA_synth_type2', NULL, NULL, 3846, 7),
(235996, NULL, 'MF_00937', NULL, NULL, 'DNA topoisomerase 4 subunit A [parC].', NULL, 'ParC_type2', NULL, NULL, 4690, 7),
(235997, NULL, 'MF_00566', NULL, NULL, 'Plastocyanin [petE].', NULL, 'Cytb6_f_plastocyanin', NULL, NULL, 16428, 7),
(235998, NULL, 'MF_01923', NULL, NULL, 'Glutamate mutase epsilon subunit [glmE].', NULL, 'Me_Asp_mutase_E', NULL, NULL, 5556, 7),
(235999, NULL, 'MF_04008', NULL, NULL, 'Capsid scaffolding protein.', NULL, 'HSV_SCAF', NULL, NULL, 4422, 7),
(236000, NULL, 'MF_03023', NULL, NULL, 'Meiotic spindle formation protein mei-1 [mei-1].', NULL, 'Katanin_p60_A1', NULL, NULL, 26024, 7),
(236001, NULL, 'MF_04085', NULL, NULL, 'Nucleoprotein [N].', NULL, 'ARENA_NCAP', NULL, NULL, 987, 7),
(236002, NULL, 'MF_00294', NULL, NULL, '50S ribosomal protein L33 [rpmG].', NULL, 'Ribosomal_L33', NULL, NULL, 3058, 7),
(236003, NULL, 'MF_00223', NULL, NULL, 'GTP cyclohydrolase 1 [folE].', NULL, 'FolE', NULL, NULL, 3218, 7),
(236004, NULL, 'MF_00126', NULL, NULL, 'Glutamine--tRNA ligase [glnS].', NULL, 'Gln_tRNA_synth', NULL, NULL, 17356, 7),
(236005, NULL, 'MF_01026', NULL, NULL, '3-isopropylmalate dehydratase large subunit [leuC].', NULL, 'LeuC_type1', NULL, NULL, 7408, 7),
(236006, NULL, 'MF_00997', NULL, NULL, 'Beta-barrel assembly-enhancing protease [bepA].', NULL, 'Protease_BepA', NULL, NULL, 24238, 7);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(236007, NULL, 'MF_01076', NULL, NULL, 'UPF0273 protein <locus_tag>.', NULL, 'UPF0273', NULL, NULL, 15970, 7),
(236008, NULL, 'MF_04160', NULL, NULL, 'Head completion nuclease.', NULL, 'NUCL_HEAD_T4', NULL, NULL, 37689, 7),
(236009, NULL, 'MF_01094', NULL, NULL, 'Tetrahydromethanopterin S-methyltransferase subunit B [mtrB].', NULL, 'MtrB', NULL, NULL, 13335, 7),
(236010, NULL, 'MF_00429', NULL, NULL, 'Na(+)-translocating NADH-quinone reductase subunit E [nqrE].', NULL, 'NqrE', NULL, NULL, 2240, 7),
(236011, NULL, 'MF_02227', NULL, NULL, 'Ribulose-phosphate 3-epimerase [rpe].', NULL, 'RPE', NULL, NULL, 26404, 7),
(236012, NULL, 'MF_00669', NULL, NULL, 'Small, acid-soluble spore protein I [sspI].', NULL, 'SspI', NULL, NULL, 14562, 7),
(236013, NULL, 'MF_01241', NULL, NULL, 'Glucosamine-6-phosphate deaminase [nagB].', NULL, 'GlcN6P_deamin', NULL, NULL, 660, 7),
(236014, NULL, 'MF_01448', NULL, NULL, 'UPF0473 protein <locus_tag>.', NULL, 'UPF0473', NULL, NULL, 12287, 7),
(236015, NULL, 'MF_01078', NULL, NULL, 'RNA-free ribonuclease P.', NULL, 'RNA_free_RNase_P', NULL, NULL, 13186, 7),
(236016, NULL, 'MF_01203', NULL, NULL, 'Voltage-gated ClC-type chloride channel ClcB [clcB].', NULL, 'CLC_ClcB', NULL, NULL, 7079, 7),
(236017, NULL, 'MF_00062', NULL, NULL, 'Sulfate adenylyltransferase subunit 1 [cysN].', NULL, 'Sulf_adenylyltr_sub1', NULL, NULL, 13320, 7),
(236018, NULL, 'MF_00583_B', NULL, NULL, 'Putative ribose-phosphate pyrophosphokinase [prs].', NULL, 'RibP_PPkinase_B', NULL, NULL, 28742, 7),
(236019, NULL, 'MF_00116', NULL, NULL, 'Deoxyuridine 5''-triphosphate nucleotidohydrolase [dut].', NULL, 'dUTPase_bact', NULL, NULL, 7207, 7),
(236020, NULL, 'MF_00224', NULL, NULL, 'Dihydroorotate dehydrogenase [pyrD].', NULL, 'DHO_dh_type1', NULL, NULL, 14824, 7),
(236021, NULL, 'MF_01670', NULL, NULL, 'Malonate-semialdehyde dehydrogenase [iolA].', NULL, 'IolA', NULL, NULL, 16614, 7),
(236022, NULL, 'MF_01599', NULL, NULL, 'Na(+)/H(+) antiporter NhaB [nhaB].', NULL, 'NhaB', NULL, NULL, 2742, 7),
(236023, NULL, 'MF_00949', NULL, NULL, 'Transcription elongation factor Spt4 [spt4].', NULL, 'Spt4_arch', NULL, NULL, 744, 7),
(236024, NULL, 'MF_01661', NULL, NULL, 'D-ribose pyranase [rbsD].', NULL, 'D_rib_pyranase', NULL, NULL, 15151, 7),
(236025, NULL, 'MF_01211', NULL, NULL, 'Dihydroorotate dehydrogenase B (NAD(+)), electron transfer subunit [pyrK].', NULL, 'DHODB_Fe_S_bind', NULL, NULL, 16397, 7),
(236026, NULL, 'MF_00460', NULL, NULL, 'Protein RnfH [rnfH].', NULL, 'UPF0125_RnfH', NULL, NULL, 6402, 7),
(236027, NULL, 'MF_00792', NULL, NULL, '15,16-dihydrobiliverdin:ferredoxin oxidoreductase [pebA].', NULL, 'PebA', NULL, NULL, 16400, 7),
(236028, NULL, 'MF_01461', NULL, NULL, 'Energy-coupling factor transporter transmembrane protein EcfT [ecfT].', NULL, 'EcfT', NULL, NULL, 14784, 7),
(236029, NULL, 'MF_01331_B', NULL, NULL, '50S ribosomal protein L22 [rplV].', NULL, 'Ribosomal_L22_B', NULL, NULL, 4926, 7),
(236030, NULL, 'MF_01406', NULL, NULL, 'UPF0282 protein <locus_tag>.', NULL, 'UPF0282', NULL, NULL, 7718, 7),
(236031, NULL, 'MF_01340', NULL, NULL, 'UPF0353 protein <locus_tag>.', NULL, 'UPF0353', NULL, NULL, 14706, 7),
(236032, NULL, 'MF_02097', NULL, NULL, 'Carnitine monooxygenase oxygenase subunit.', NULL, 'Carnitine_monoox_A', NULL, NULL, 30598, 7),
(236033, NULL, 'MF_00168', NULL, NULL, 'Queuine tRNA-ribosyltransferase [tgt].', NULL, 'Q_tRNA_Tgt', NULL, NULL, 5703, 7),
(236034, NULL, 'MF_01337_B', NULL, NULL, '50S ribosomal protein L18 [rplR].', NULL, 'Ribosomal_L18_B', NULL, NULL, 5796, 7),
(236035, NULL, 'MF_00903', NULL, NULL, 'Probable Sec-independent protein translocase protein TatE [tatE].', NULL, 'TatE', NULL, NULL, 14957, 7),
(236036, NULL, 'MF_01894', NULL, NULL, 'Chromosome partition protein Smc [smc].', NULL, 'Smc_prok', NULL, NULL, 8540, 7),
(236037, NULL, 'MF_00360', NULL, NULL, '30S ribosomal protein S6 [rpsF].', NULL, 'Ribosomal_S6', NULL, NULL, 21155, 7),
(236038, NULL, 'MF_00318', NULL, NULL, 'Enolase [eno].', NULL, 'Enolase', NULL, NULL, 3263, 7),
(236039, NULL, 'MF_02089', NULL, NULL, 'Epoxyqueuosine reductase QueH [queH].', NULL, 'QueH', NULL, NULL, 6275, 7);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(236040, NULL, 'MF_01462', NULL, NULL, 'Cobalt transport protein CbiM [cbiM].', NULL, 'CbiM', NULL, NULL, 11565, 7),
(236041, NULL, 'MF_01187', NULL, NULL, 'UPF0434 protein YcaR [ycaR].', NULL, 'UPF0434', NULL, NULL, 2573, 7),
(236042, NULL, 'MF_00241', NULL, NULL, '8-oxoguanine DNA glycosylase/AP lyase [ogg].', NULL, 'Ogg', NULL, NULL, 12894, 7),
(236043, NULL, 'MF_01892', NULL, NULL, 'tRNA(Ile2) 2-agmatinylcytidine synthetase TiaS [tiaS].', NULL, 'tRNA_Ile2_agm2C_synt', NULL, NULL, 14862, 7),
(236044, NULL, 'MF_00864', NULL, NULL, 'DNA-directed RNA polymerase subunit Rpo4 [rpo4].', NULL, 'RNApol_arch_Rpo4', NULL, NULL, 8651, 7),
(236045, NULL, 'MF_01115', NULL, NULL, 'Putative ion-transport protein YfeO [yfeO].', NULL, 'CLC_YfeO', NULL, NULL, 14652, 7),
(236046, NULL, 'MF_04203', NULL, NULL, 'Membrane protein [M].', NULL, 'GAMMA_CORONA_M', NULL, NULL, 35442, 7),
(236047, NULL, 'MF_00930', NULL, NULL, 'Transcription elongation factor GreB [greB].', NULL, 'GreB', NULL, NULL, 5898, 7),
(236048, NULL, 'MF_01200_A', NULL, NULL, 'Orotidine 5''-phosphate decarboxylase [pyrF].', NULL, 'OMPdecase_type1_A', NULL, NULL, 9132, 7),
(236049, NULL, 'MF_00847', NULL, NULL, 'Energy-dependent translational throttle protein EttA [ettA].', NULL, 'EttA', NULL, NULL, 15431, 7),
(236050, NULL, 'MF_02103', NULL, NULL, 'Lactate utilization protein B [lutB].', NULL, 'LutB', NULL, NULL, 17277, 7),
(236051, NULL, 'MF_00247', NULL, NULL, 'Soluble pyridine nucleotide transhydrogenase [sthA].', NULL, 'SthA', NULL, NULL, 14996, 7),
(236052, NULL, 'MF_01818', NULL, NULL, 'Ribonuclease BN [rbn].', NULL, 'RNase_Z_BN', NULL, NULL, 10166, 7),
(236053, NULL, 'MF_00357', NULL, NULL, 'Probable DNA-directed RNA polymerase subunit delta [rpoE].', NULL, 'RNApol_bact_RpoE', NULL, NULL, 25575, 7),
(236054, NULL, 'MF_01905', NULL, NULL, 'GlcNAc-binding protein A [gbpA].', NULL, 'GbpA', NULL, NULL, 20980, 7),
(236055, NULL, 'MF_01009', NULL, NULL, 'Thiosulfate sulfurtransferase GlpE [glpE].', NULL, 'Thiosulf_sulfurtr', NULL, NULL, 11863, 7),
(236056, NULL, 'MF_01870', NULL, NULL, 'Probable 4-deoxy-4-formamido-L-arabinose-phosphoundecaprenol deformylase ArnD [arnD].', NULL, 'ArnD', NULL, NULL, 9080, 7),
(236057, NULL, 'MF_02028', NULL, NULL, 'UDP-N-acetylglucosamine 2-epimerase [wecB].', NULL, 'WecB_RffE', NULL, NULL, 23782, 7),
(236058, NULL, 'MF_00432', NULL, NULL, 'Cytochrome b6-f complex subunit 5 [petG].', NULL, 'Cytb6_f_PetG', NULL, NULL, 1800, 7),
(236059, NULL, 'MF_01423', NULL, NULL, 'Multidrug resistance protein MdtB [mdtB].', NULL, 'MdtB', NULL, NULL, 15000, 7),
(236060, NULL, 'MF_02223', NULL, NULL, 'Pantoate kinase.', NULL, 'Pantoate_kinase', NULL, NULL, 11094, 7),
(236061, NULL, 'MF_03229', NULL, NULL, 'Fat storage-inducing transmembrane protein 1 [FITM1].', NULL, 'FITM1', NULL, NULL, 37713, 7),
(236062, NULL, 'MF_00092', NULL, NULL, 'Endonuclease MutS2 [mutS2].', NULL, 'MutS2', NULL, NULL, 4909, 7),
(236063, NULL, 'MF_04051', NULL, NULL, 'Hexon protein [L3].', NULL, 'ADV_CAPSH', NULL, NULL, 32429, 7),
(236064, NULL, 'MF_00637', NULL, NULL, 'Anti-sigma F factor [spoIIAB].', NULL, 'Anti_sigma_F', NULL, NULL, 4030, 7),
(236065, NULL, 'MF_00084', NULL, NULL, 'Nodulation protein A [nodA].', NULL, 'NodA', NULL, NULL, 6471, 7),
(236066, NULL, 'MF_01511', NULL, NULL, 'GMP reductase [guaC].', NULL, 'GMP_reduct_type2', NULL, NULL, 1117, 7),
(236067, NULL, 'MF_01198', NULL, NULL, 'Anti-adapter protein IraP [iraP].', NULL, 'Anti_adapt_IraP', NULL, NULL, 20585, 7),
(236068, NULL, 'MF_00700', NULL, NULL, 'DNA primase small subunit PriS [priS].', NULL, 'DNA_primase_sml_arc', NULL, NULL, 16311, 7),
(236069, NULL, 'MF_01429', NULL, NULL, 'Iron-binding protein IscA [iscA].', NULL, 'Fe_S_insert_IscA', NULL, NULL, 10006, 7),
(236070, NULL, 'MF_02228', NULL, NULL, 'Sulfopropanediol 3-dehydrogenase [hpsN].', NULL, 'Sulfopropanediol_dehydrog', NULL, NULL, 34653, 7),
(236071, NULL, 'MF_03055', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase [METTL1].', NULL, 'tRNA_methyltr_TrmB_euk', NULL, NULL, 23997, 7),
(236072, NULL, 'MF_00144', NULL, NULL, 'tRNA-specific 2-thiouridylase MnmA [mnmA].', NULL, 'tRNA_thiouridyl_MnmA', NULL, NULL, 1671, 7);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(236073, NULL, 'MF_00815', NULL, NULL, 'ATP synthase gamma chain [atpG].', NULL, 'ATP_synth_gamma_bact', NULL, NULL, 1624, 7),
(236074, NULL, 'MF_01320_A', NULL, NULL, '50S ribosomal protein L2 [rplB].', NULL, 'Ribosomal_L2_A', NULL, NULL, 969, 7),
(236075, NULL, 'MF_01402_B', NULL, NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase [apgM].', NULL, 'ApgM_B', NULL, NULL, 906, 7),
(236076, NULL, 'MF_00711', NULL, NULL, 'Glycine dehydrogenase (decarboxylating) [gcvP].', NULL, 'GcvP', NULL, NULL, 5225, 7),
(236077, NULL, 'MF_04091', NULL, NULL, 'Non-structural glycoprotein 4.', NULL, 'ROTA_NSP4', NULL, NULL, 5054, 7),
(236078, NULL, 'MF_00532_A', NULL, NULL, '30S ribosomal protein S9 [rpsI].', NULL, 'Ribosomal_S9_A', NULL, NULL, 12648, 7),
(236079, NULL, 'MF_01921', NULL, NULL, 'S-adenosyl-L-methionine-dependent tRNA 4-demethylwyosine synthase [taw1].', NULL, 'TYW1_archaea', NULL, NULL, 18399, 7),
(236080, NULL, 'MF_00531', NULL, NULL, '30S ribosomal protein S19 [rpsS].', NULL, 'Ribosomal_S19', NULL, NULL, 22, 7),
(236081, NULL, 'MF_00970', NULL, NULL, 'Ribonuclease E [rne].', NULL, 'RNase_E', NULL, NULL, 21514, 7),
(236082, NULL, 'MF_00561', NULL, NULL, 'ADP-specific phosphofructokinase [pfkC].', NULL, 'ADP_PFKinase', NULL, NULL, 13428, 7),
(236083, NULL, 'MF_03013', NULL, NULL, 'Clustered mitochondria protein homolog [CLU1].', NULL, 'CLU', NULL, NULL, 23445, 7),
(236084, NULL, 'MF_03122', NULL, NULL, '40S ribosomal protein S1 [RPS3A].', NULL, 'Ribosomal_S3Ae_euk', NULL, NULL, 23194, 7),
(236085, NULL, 'MF_00087', NULL, NULL, 'Glutamyl-tRNA reductase [hemA].', NULL, 'Glu_tRNA_reductase', NULL, NULL, 39, 7),
(236086, NULL, 'MF_03120', NULL, NULL, 'Lon protease homolog, mitochondrial [LONP1].', NULL, 'lonm_euk', NULL, NULL, 23240, 7),
(236087, NULL, 'MF_01554_B', NULL, NULL, 'Phosphoglucosamine mutase [glmM].', NULL, 'GlmM_B', NULL, NULL, 4722, 7),
(236088, NULL, 'MF_01634', NULL, NULL, 'tRNA-guanine(15) transglycosylase [tgtA].', NULL, 'TgtA_arch', NULL, NULL, 5521, 7),
(236089, NULL, 'MF_01002', NULL, NULL, 'TDP-N-acetylfucosamine:lipid II N-acetylfucosaminyltransferase [wecF].', NULL, 'WecF_RffT', NULL, NULL, 8844, 7),
(236090, NULL, 'MF_01438', NULL, NULL, 'DNA integrity scanning protein DisA [disA].', NULL, 'DisA', NULL, NULL, 14987, 7),
(236091, NULL, 'MF_01359', NULL, NULL, 'NADH-quinone oxidoreductase subunit C/D [nuoC].', NULL, 'NDH1_NuoCD_1', NULL, NULL, 15489, 7),
(236092, NULL, 'MF_00694', NULL, NULL, 'Probable 5-dehydro-4-deoxyglucarate dehydratase.', NULL, 'KDGDH', NULL, NULL, 17400, 7),
(236093, NULL, 'MF_01583', NULL, NULL, 'Threonine/serine transporter TdcC [tdcC].', NULL, 'Thr_Ser_transp_TdcC', NULL, NULL, 7254, 7),
(236094, NULL, 'MF_00117', NULL, NULL, '33 kDa chaperonin [hslO].', NULL, 'HslO', NULL, NULL, 4769, 7),
(236095, NULL, 'MF_00380', NULL, NULL, 'Integration host factor subunit alpha [ihfA].', NULL, 'IHF_alpha', NULL, NULL, 3834, 7),
(236096, NULL, 'MF_00426', NULL, NULL, 'Na(+)-translocating NADH-quinone reductase subunit B [nqrB].', NULL, 'NqrB', NULL, NULL, 2054, 7),
(236097, NULL, 'MF_00854', NULL, NULL, 'Carboxysome shell protein CcmK [ccmK].', NULL, 'CcmK', NULL, NULL, 33936, 7),
(236098, NULL, 'MF_00336', NULL, NULL, 'ATP-dependent dethiobiotin synthetase BioD [bioD].', NULL, 'BioD', NULL, NULL, 7060, 7),
(236099, NULL, 'MF_00118_B', NULL, NULL, 'Elongation factor Tu [tuf].', NULL, 'EF_Tu_B', NULL, NULL, 1868, 7),
(236100, NULL, 'MF_04120', NULL, NULL, 'Portal protein.', NULL, 'PORTAL_PROTEIN_T7', NULL, NULL, 32506, 7),
(236101, NULL, 'MF_01815', NULL, NULL, '3-oxoacyl-[acyl-carrier-protein] synthase 3 [fabH].', NULL, 'FabH', NULL, NULL, 2722, 7),
(236102, NULL, 'MF_03031', NULL, NULL, 'Protein argonaute-2 [AGO2].', NULL, 'AGO2', NULL, NULL, 26395, 7),
(236103, NULL, 'MF_00399', NULL, NULL, 'Thiol:disulfide interchange protein DsbD [dsbD].', NULL, 'DbsD', NULL, NULL, 17396, 7),
(236104, NULL, 'MF_04009', NULL, NULL, 'Shutoff alkaline exonuclease.', NULL, 'HSV_AN', NULL, NULL, 5359, 7),
(236105, NULL, 'MF_00593', NULL, NULL, 'D-alanine--D-alanyl carrier protein ligase [dltA].', NULL, 'DltA', NULL, NULL, 6100, 7); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(236106, NULL, 'MF_00709', NULL, NULL, 'Fumarate reductase subunit D [frdD].', NULL, 'Fumarate_red_D', NULL, NULL, 5171, 7),
(236107, NULL, 'MF_00796', NULL, NULL, 'Nucleoside-triphosphatase <locus_tag>.', NULL, 'NTPase_1', NULL, NULL, 2519, 7),
(236108, NULL, 'MF_03064', NULL, NULL, 'Mitochondrial glycine transporter [SLC25A38].', NULL, 'SLC25A38', NULL, NULL, 21795, 7),
(236109, NULL, 'MF_00358', NULL, NULL, '30S ribosomal protein S21 [rpsU].', NULL, 'Ribosomal_S21', NULL, NULL, 4023, 7),
(236110, NULL, 'MF_00525', NULL, NULL, 'Surface composition regulator [glgS].', NULL, 'GlgS', NULL, NULL, 8748, 7),
(236111, NULL, 'MF_00330', NULL, NULL, 'Cobalt transport protein CbiN [cbiN].', NULL, 'CbiN', NULL, NULL, 6373, 7),
(236112, NULL, 'MF_00919', NULL, NULL, 'Ribosome modulation factor [rmf].', NULL, 'RMF', NULL, NULL, 6606, 7),
(236113, NULL, 'MF_02073', NULL, NULL, 'Putrescine transporter PotE [potE].', NULL, 'Putrescine_transp', NULL, NULL, 23449, 7),
(236114, NULL, 'MF_03034', NULL, NULL, 'RISC-loading complex subunit @gn(TARBP2) [TARBP2].', NULL, 'TRBP2', NULL, NULL, 25622, 7),
(236115, NULL, 'MF_03065', NULL, NULL, 'Regulator of telomere elongation helicase 1 [RTEL1].', NULL, 'RTEL1', NULL, NULL, 21707, 7),
(236116, NULL, 'MF_01690', NULL, NULL, 'Succinyl-diaminopimelate desuccinylase [dapE].', NULL, 'DapE', NULL, NULL, 417, 7),
(236117, NULL, 'MF_00627', NULL, NULL, 'L-threonine 3-dehydrogenase [tdh].', NULL, 'Thr_dehydrog', NULL, NULL, 2480, 7),
(236118, NULL, 'MF_03070', NULL, NULL, 'Scavenger receptor class A member 5 [SCARA5].', NULL, 'SCARA5', NULL, NULL, 29378, 7),
(236119, NULL, 'MF_01932', NULL, NULL, 'AMP nucleosidase [amn].', NULL, 'AMP_nucleosidase', NULL, NULL, 9612, 7),
(236120, NULL, 'MF_01401', NULL, NULL, 'Peptide methionine sulfoxide reductase MsrA [msrA].', NULL, 'MsrA', NULL, NULL, 1834, 7),
(236121, NULL, 'MF_03199', NULL, NULL, 'Palmitoyltransferase <gene_name> [PFA4].', NULL, 'DHHC_PAT_PFA4', NULL, NULL, 29588, 7),
(236122, NULL, 'MF_02009', NULL, NULL, 'Tyrosine--tRNA ligase [tyrS].', NULL, 'Tyr_tRNA_synth_type4', NULL, NULL, 14558, 7),
(236123, NULL, 'MF_00411', NULL, NULL, 'DNA-directed RNA polymerase subunit Rpo1C [rpo1C].', NULL, 'RNApol_arch_Rpo1C', NULL, NULL, 9663, 7),
(236124, NULL, 'MF_02248', NULL, NULL, 'Inner membrane lipoprotein DcrB [dcrB].', NULL, 'DcrB', NULL, NULL, 33685, 7),
(236125, NULL, 'MF_03037', NULL, NULL, 'Probable cytosolic iron-sulfur protein assembly protein CIAO1 [CIAO1].', NULL, 'ciao1', NULL, NULL, 25935, 7),
(236126, NULL, 'MF_01327', NULL, NULL, 'Thiamine-phosphate synthase [thiE].', NULL, 'TMP_synthase_cyanobact', NULL, NULL, 17422, 7),
(236127, NULL, 'MF_01416', NULL, NULL, 'ATP synthase subunit delta [atpD].', NULL, 'ATP_synth_delta_bact', NULL, NULL, 3968, 7),
(236128, NULL, 'MF_00695', NULL, NULL, 'High frequency lysogenization protein HflD [hflD].', NULL, 'HflD_protein', NULL, NULL, 4581, 7),
(236129, NULL, 'MF_04100', NULL, NULL, 'DNA-directed DNA polymerase.', NULL, 'DPOL_T4', NULL, NULL, 10447, 7),
(236130, NULL, 'MF_01064', NULL, NULL, 'UPF0253 protein YaeP [yaeP].', NULL, 'UPF0253', NULL, NULL, 1928, 7),
(236131, NULL, 'MF_01836', NULL, NULL, 'Circadian clock protein kinase KaiC [kaiC].', NULL, 'KaiC', NULL, NULL, 7433, 7),
(236132, NULL, 'MF_04052', NULL, NULL, 'Penton protein [L2].', NULL, 'ADV_CAPSP', NULL, NULL, 1516, 7),
(236133, NULL, 'MF_00833', NULL, NULL, 'FMN reductase (NADH) RutF [rutF].', NULL, 'RutF', NULL, NULL, 18234, 7),
(236134, NULL, 'MF_00133', NULL, NULL, 'Tryptophan synthase beta chain [trpB].', NULL, 'Trp_synth_beta', NULL, NULL, 15203, 7),
(236135, NULL, 'MF_00397', NULL, NULL, '2-(5''''-triphosphoribosyl)-3''-dephosphocoenzyme-A synthase [citG].', NULL, 'CitG', NULL, NULL, 14575, 7),
(236136, NULL, 'MF_00666', NULL, NULL, 'Small, acid-soluble spore protein P [sspP].', NULL, 'SspP', NULL, NULL, 9592, 7),
(236137, NULL, 'MF_02000', NULL, NULL, 'Small heat shock protein IbpA [ibpA].', NULL, 'HSP20_IbpA', NULL, NULL, 7669, 7),
(236138, NULL, 'MF_00491', NULL, NULL, 'NAD(P)H-quinone oxidoreductase chain 4 [ndhD].', NULL, 'NDH1_NuoM', NULL, NULL, 15275, 7);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(236139, NULL, 'MF_01489', NULL, NULL, 'Putative DNA helicase Rad25 [rad25].', NULL, 'Helicase_Rad25_arch', NULL, NULL, 25454, 7),
(236140, NULL, 'MF_00417', NULL, NULL, 'Pyrrolidone-carboxylate peptidase [pcp].', NULL, 'Pyrrolid_peptidase', NULL, NULL, 24735, 7),
(236141, NULL, 'MF_02037', NULL, NULL, 'Histidine N-alpha-methyltransferase [egtD].', NULL, 'EgtD', NULL, NULL, 24072, 7),
(236142, NULL, 'MF_01303', NULL, NULL, 'Photosystem I iron-sulfur center [psaC].', NULL, 'PSI_PsaC', NULL, NULL, 20592, 7),
(236143, NULL, 'MF_00028', NULL, NULL, 'Cobyric acid synthase [cobQ].', NULL, 'CobQ', NULL, NULL, 7278, 7),
(236144, NULL, 'MF_00455', NULL, NULL, 'Xylose isomerase [xylA].', NULL, 'Xylose_isom_A', NULL, NULL, 2374, 7),
(236145, NULL, 'MF_01465', NULL, NULL, 'Protein translocase subunit SecY [secY].', NULL, 'SecY', NULL, NULL, 26674, 7),
(236146, NULL, 'MF_01194', NULL, NULL, 'Heat shock protein HspQ [hspQ].', NULL, 'HspQ', NULL, NULL, 17097, 7),
(236147, NULL, 'MF_00772', NULL, NULL, 'Methylated-DNA--protein-cysteine methyltransferase [ogt].', NULL, 'OGT', NULL, NULL, 16728, 7),
(236148, NULL, 'MF_00754', NULL, NULL, 'Ribonuclease P protein component 1 [rnp1].', NULL, 'RNase_P_1', NULL, NULL, 16692, 7),
(236149, NULL, 'MF_01504', NULL, NULL, 'Small, acid-soluble spore protein K [sspK].', NULL, 'SspK', NULL, NULL, 9770, 7),
(236150, NULL, 'MF_01837', NULL, NULL, 'Adaptive-response sensory-kinase SasA [sasA].', NULL, 'Kinase_SasA', NULL, NULL, 16113, 7),
(236151, NULL, 'MF_01962', NULL, NULL, 'Adenine deaminase.', NULL, 'Adenine_deaminase', NULL, NULL, 26750, 7),
(236152, NULL, 'MF_00818', NULL, NULL, 'NADPH-dependent 7-cyano-7-deazaguanine reductase [queF].', NULL, 'QueF_type1', NULL, NULL, 16179, 7),
(236153, NULL, 'MF_01688', NULL, NULL, '2-hydroxy-6-oxo-6-phenylhexa-2,4-dienoate hydrolase [bphD].', NULL, 'Biphenyl_BphD', NULL, NULL, 18340, 7),
(236154, NULL, 'MF_00698', NULL, NULL, 'Xaa-Pro dipeptidyl-peptidase [pepX].', NULL, 'Aminopeptidase_S15', NULL, NULL, 1813, 7),
(236155, NULL, 'MF_00790', NULL, NULL, 'Lipase chaperone [lifO].', NULL, 'Lipase_chap', NULL, NULL, 2868, 7),
(236156, NULL, 'MF_00068', NULL, NULL, 'N-acetylmuramic acid 6-phosphate etherase [murQ].', NULL, 'MurQ', NULL, NULL, 602, 7),
(236157, NULL, 'MF_01468', NULL, NULL, 'Mini-ribonuclease 3 [mrnC].', NULL, 'RNase_Mini_III', NULL, NULL, 720, 7),
(236158, NULL, 'MF_01566', NULL, NULL, 'UPF0370 protein YpfN [ypfN].', NULL, 'UPF0370', NULL, NULL, 14501, 7),
(236159, NULL, 'MF_00744', NULL, NULL, 'Met repressor [metJ].', NULL, 'MetJ', NULL, NULL, 1487, 7),
(236160, NULL, 'MF_01403', NULL, NULL, 'Probable phosphoketolase.', NULL, 'Phosphoketolase', NULL, NULL, 8344, 7),
(236161, NULL, 'MF_01510', NULL, NULL, 'GMP synthase [glutamine-hydrolyzing] subunit A [guaAA].', NULL, 'GMP_synthase_A', NULL, NULL, 14956, 7),
(236162, NULL, 'MF_00527', NULL, NULL, 'Putative 3-methyladenine DNA glycosylase.', NULL, '3MGH', NULL, NULL, 2693, 7),
(236163, NULL, 'MF_00961', NULL, NULL, 'RNA polymerase sigma factor RpoH [rpoH].', NULL, 'Sigma70_RpoH', NULL, NULL, 9931, 7),
(236164, NULL, 'MF_01864', NULL, NULL, 'tRNA-2-methylthio-N(6)-dimethylallyladenosine synthase [miaB].', NULL, 'tRNA_metthiotr_MiaB', NULL, NULL, 4220, 7),
(236165, NULL, 'MF_00829', NULL, NULL, 'UPF0435 protein <locus_tag>.', NULL, 'UPF0435', NULL, NULL, 9415, 7),
(236166, NULL, 'MF_01117', NULL, NULL, 'CDP-archaeol synthase [carS].', NULL, 'CDP_archaeol_synth', NULL, NULL, 3541, 7),
(236167, NULL, 'MF_00546', NULL, NULL, 'Acid shock protein [asr].', NULL, 'Asr', NULL, NULL, 16123, 7),
(236168, NULL, 'MF_00497_A', NULL, NULL, 'Glycerol-1-phosphate dehydrogenase [NAD(P)+] [egsA].', NULL, 'G1P_dehydrogenase_A', NULL, NULL, 15252, 7),
(236169, NULL, 'MF_00324', NULL, NULL, 'DNA polymerase II large subunit [polC].', NULL, 'DNApol_II_L_arch', NULL, NULL, 7416, 7),
(236170, NULL, 'MF_01500', NULL, NULL, 'Tetrahydromethanopterin S-methyltransferase subunit G [mtrG].', NULL, 'MtrG', NULL, NULL, 6881, 7),
(236171, NULL, 'MF_00131', NULL, NULL, 'Tryptophan synthase alpha chain [trpA].', NULL, 'Trp_synth_alpha', NULL, NULL, 5400, 7);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(236172, NULL, 'MF_00017', NULL, NULL, 'Recombination protein RecR [recR].', NULL, 'RecR', NULL, NULL, 2576, 7),
(236173, NULL, 'MF_02242', NULL, NULL, 'Archaetidylinositol phosphate synthase.', NULL, 'AIP_synthase', NULL, NULL, 35246, 7),
(236174, NULL, 'MF_00347', NULL, NULL, 'Polyphosphate kinase [ppk].', NULL, 'Polyphosphate_kinase', NULL, NULL, 5349, 7),
(236175, NULL, 'MF_00472', NULL, NULL, 'Ubiquinone biosynthesis O-methyltransferase [ubiG].', NULL, 'UbiG', NULL, NULL, 4324, 7),
(236176, NULL, 'MF_00188', NULL, NULL, 'Protease HtpX [htpX].', NULL, 'Pept_M48_protease_HtpX', NULL, NULL, 17354, 7),
(236177, NULL, 'MF_02006', NULL, NULL, 'Tyrosine--tRNA ligase [tyrS].', NULL, 'Tyr_tRNA_synth_type1', NULL, NULL, 12246, 7),
(236178, NULL, 'MF_04113', NULL, NULL, 'Capsid vertex protein.', NULL, 'CAPSID_P_T4', NULL, NULL, 30997, 7),
(236179, NULL, 'MF_01313', NULL, NULL, 'Nitric oxide reductase FlRd-NAD(+) reductase [norW].', NULL, 'NorW', NULL, NULL, 14907, 7),
(236180, NULL, 'MF_01366', NULL, NULL, '50S ribosomal protein L13 [rplM].', NULL, 'Ribosomal_L13', NULL, NULL, 5885, 7),
(236181, NULL, 'MF_00053', NULL, NULL, 'Ribonuclease HIII [rnhC].', NULL, 'RNase_HIII', NULL, NULL, 2176, 7),
(236182, NULL, 'MF_00161', NULL, NULL, 'Lipoprotein signal peptidase [lspA].', NULL, 'LspA', NULL, NULL, 4162, 7),
(236183, NULL, 'MF_00480_B', NULL, NULL, '30S ribosomal protein S7 [rpsG].', NULL, 'Ribosomal_S7_B', NULL, NULL, 4693, 7),
(236184, NULL, 'MF_00842', NULL, NULL, 'Outer membrane protein A [ompA].', NULL, 'OmpA', NULL, NULL, 6431, 7),
(236185, NULL, 'MF_01812', NULL, NULL, 'N-acetyltransferase Eis [eis].', NULL, 'Eis', NULL, NULL, 17145, 7),
(236186, NULL, 'MF_01865', NULL, NULL, 'Ribosomal protein S12 methylthiotransferase RimO [rimO].', NULL, 'MTTase_RimO', NULL, NULL, 5917, 7),
(236187, NULL, 'MF_00337', NULL, NULL, 'Exodeoxyribonuclease 7 small subunit [xseB].', NULL, 'Exonuc_7_S', NULL, NULL, 2204, 7),
(236188, NULL, 'MF_00044', NULL, NULL, 'Aspartate--tRNA(Asp/Asn) ligase [aspS].', NULL, 'Asp_tRNA_synth_type1', NULL, NULL, 1774, 7),
(236189, NULL, 'MF_00338', NULL, NULL, 'UPF0145 protein YbjQ [ybjQ].', NULL, 'UPF0145', NULL, NULL, 4386, 7),
(236190, NULL, 'MF_00834', NULL, NULL, 'Adenosylmethionine-8-amino-7-oxononanoate aminotransferase [bioA].', NULL, 'BioA', NULL, NULL, 5680, 7),
(236191, NULL, 'MF_00130', NULL, NULL, 'Holliday junction resolvase RecU [recU].', NULL, 'RecU', NULL, NULL, 581, 7),
(236192, NULL, 'MF_00003', NULL, NULL, 'Ribosome-binding factor A [rbfA].', NULL, 'RbfA', NULL, NULL, 4857, 7),
(236193, NULL, 'MF_01165', NULL, NULL, 'Undecaprenyl phosphate-alpha-4-amino-4-deoxy-L-arabinose arabinosyl transferase [arnT].', NULL, 'ArnT_transfer', NULL, NULL, 17213, 7),
(236194, NULL, 'MF_00760', NULL, NULL, 'UPF0302 protein <locus_tag>.', NULL, 'UPF0302', NULL, NULL, 10786, 7),
(236195, NULL, 'MF_01275', NULL, NULL, 'Gamma-aminobutyraldehyde dehydrogenase [patD].', NULL, 'Aldedh_Prr', NULL, NULL, 18542, 7),
(236196, NULL, 'MF_01477', NULL, NULL, 'Ribosomal silencing factor RsfS [rsfS].', NULL, 'Iojap_RsfS', NULL, NULL, 5605, 7),
(236197, NULL, 'MF_02232', NULL, NULL, 'Ubiquinone biosynthesis protein UbiU [ubiU].', NULL, 'UbiU', NULL, NULL, 35374, 7),
(236198, NULL, 'MF_00496', NULL, NULL, 'Fructose-6-phosphate aldolase [fsa].', NULL, 'F6P_aldolase', NULL, NULL, 15458, 7),
(236199, NULL, 'MF_02065', NULL, NULL, 'Endolytic murein transglycosylase [mltG].', NULL, 'MltG', NULL, NULL, 2434, 7),
(236200, NULL, 'MF_01216', NULL, NULL, 'FMN dependent NADH:quinone oxidoreductase [azoR].', NULL, 'Azoreductase_type1', NULL, NULL, 15245, 7),
(236201, NULL, 'MF_01015', NULL, NULL, 'Putative transport protein YbjL [ybjL].', NULL, 'YbjL', NULL, NULL, 15324, 7),
(236202, NULL, 'MF_01141', NULL, NULL, 'Antiholin-like protein LrgA [lrgA].', NULL, 'LrgA', NULL, NULL, 7516, 7),
(236203, NULL, 'MF_03038', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NUBP1 [NUBP1].', NULL, 'NUBP1', NULL, NULL, 26053, 7),
(236204, NULL, 'MF_00536', NULL, NULL, '4-hydroxythreonine-4-phosphate dehydrogenase [pdxA].', NULL, 'PdxA', NULL, NULL, 33933, 7);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(236205, NULL, 'MF_00418', NULL, NULL, '4-hydroxy-tetrahydrodipicolinate synthase [dapA].', NULL, 'DapA', NULL, NULL, 4098, 7),
(236206, NULL, 'MF_01036', NULL, NULL, 'Exoribonuclease 2 [rnb].', NULL, 'RNase_II', NULL, NULL, 13199, 7),
(236207, NULL, 'MF_02059', NULL, NULL, 'Choline trimethylamine-lyase activating enzyme [cutD].', NULL, 'Activ_enz_CutD', NULL, NULL, 25420, 7),
(236208, NULL, 'MF_02088', NULL, NULL, 'Probable queuosine precursor transporter.', NULL, 'Q_prec_transport', NULL, NULL, 2380, 7),
(236209, NULL, 'MF_00280', NULL, NULL, '50S ribosomal protein L10 [rpl10].', NULL, 'Ribosomal_L10_arch', NULL, NULL, 17240, 7),
(236210, NULL, 'MF_01446', NULL, NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase [kae1].', NULL, 'Kae1', NULL, NULL, 29411, 7),
(236211, NULL, 'MF_01529', NULL, NULL, 'Multidrug resistance protein MdtH [mdtH].', NULL, 'MFS_MdtH', NULL, NULL, 17025, 7),
(236212, NULL, 'MF_01319', NULL, NULL, 'Thiol-disulfide oxidoreductase ResA [resA].', NULL, 'ResA', NULL, NULL, 12840, 7),
(236213, NULL, 'MF_02034', NULL, NULL, 'Glutamate--cysteine ligase EgtA [egtA].', NULL, 'EgtA', NULL, NULL, 19109, 7),
(236214, NULL, 'MF_01256', NULL, NULL, 'Putative metal-dependent hydrolase <locus_tag>.', NULL, 'YfiT_hydrol', NULL, NULL, 10405, 7),
(236215, NULL, 'MF_02039', NULL, NULL, 'Cell division protein FtsN [ftsN].', NULL, 'FtsN_entero', NULL, NULL, 11166, 7),
(236216, NULL, 'MF_00210', NULL, NULL, '3-phosphoshikimate 1-carboxyvinyltransferase [aroA].', NULL, 'EPSP_synth', NULL, NULL, 3826, 7),
(236217, NULL, 'MF_01144', NULL, NULL, 'UPF0299 membrane protein YohJ [yohJ].', NULL, 'UPF0299', NULL, NULL, 14909, 7),
(236218, NULL, 'MF_03046', NULL, NULL, 'Transcription and mRNA export factor <gene_name> [SUS1].', NULL, 'ENY2_Sus1', NULL, NULL, 19015, 7),
(236219, NULL, 'MF_00167', NULL, NULL, 'Translational regulator CsrA [csrA].', NULL, 'CsrA', NULL, NULL, 2339, 7),
(236220, NULL, 'MF_01007', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase H [rsmH].', NULL, '16SrRNA_methyltr_H', NULL, NULL, 6127, 7),
(236221, NULL, 'MF_01020', NULL, NULL, 'Phosphoribosyl-ATP pyrophosphatase [hisE].', NULL, 'HisE', NULL, NULL, 7130, 7),
(236222, NULL, 'MF_04126', NULL, NULL, 'Intermediate capsid protein VP6.', NULL, 'Rota_VP6', NULL, NULL, 2134, 7),
(236223, NULL, 'MF_03163', NULL, NULL, 'AdoMet-dependent rRNA methyltransferase <gene_name> [SPB1].', NULL, 'RNA_methyltr_E_SPB1', NULL, NULL, 23653, 7),
(236224, NULL, 'MF_01447', NULL, NULL, 'Probable bifunctional tRNA threonylcarbamoyladenosine biosynthesis protein.', NULL, 'Kae1_Bud32_arch', NULL, NULL, 10485, 7),
(236225, NULL, 'MF_00910', NULL, NULL, 'Cell division protein FtsL [ftsL].', NULL, 'FtsL', NULL, NULL, 11308, 7),
(236226, NULL, 'MF_01639', NULL, NULL, 'Pyridoxal kinase PdxY [pdxY].', NULL, 'PdxY', NULL, NULL, 16299, 7),
(236227, NULL, 'MF_01046', NULL, NULL, 'Protein/nucleic acid deglycase HchA [hchA].', NULL, 'Deglycase_HchA', NULL, NULL, 16225, 7),
(236228, NULL, 'MF_02020', NULL, NULL, 'UDP-N-acetylmuramate--L-alanyl-gamma-D-glutamyl-meso-2,6-diaminoheptandioate ligase [mpl].', NULL, 'Mpl', NULL, NULL, 4532, 7),
(236229, NULL, 'MF_00047', NULL, NULL, 'D-alanine--D-alanine ligase [ddl].', NULL, 'Dala_Dala_lig', NULL, NULL, 487, 7),
(236230, NULL, 'MF_00915', NULL, NULL, 'Cell division protein FtsP [ftsP].', NULL, 'FtsP', NULL, NULL, 26980, 7),
(236231, NULL, 'MF_02205', NULL, NULL, 'ATP-dependent DNA helicase DinG [dinG].', NULL, 'DinG_proteobact', NULL, NULL, 30777, 7),
(236232, NULL, 'MF_03009', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit J [EIF3J].', NULL, 'eIF3j', NULL, NULL, 17868, 7),
(236233, NULL, 'MF_00924', NULL, NULL, 'Outer membrane protein assembly factor BamC [bamC].', NULL, 'OM_assembly_BamC', NULL, NULL, 11316, 7),
(236234, NULL, 'MF_00140_B', NULL, NULL, 'Tryptophan--tRNA ligase [trpS].', NULL, 'Trp_tRNA_synth_B', NULL, NULL, 10074, 7),
(236235, NULL, 'MF_03144', NULL, NULL, 'RNA-splicing ligase RtcB homolog [RTCB].', NULL, 'RtcB_euk', NULL, NULL, 24686, 7),
(236236, NULL, 'MF_00081', NULL, NULL, 'Heat-inducible transcription repressor HrcA [hrcA].', NULL, 'HrcA', NULL, NULL, 1793, 7);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(236237, NULL, 'MF_00946', NULL, NULL, 'Acid stress chaperone HdeA [hdeA].', NULL, 'HdeA', NULL, NULL, 21657, 7),
(236238, NULL, 'MF_01397', NULL, NULL, 'NADH-quinone oxidoreductase subunit C/D [nuoC].', NULL, 'NDH1_NuoCD_2', NULL, NULL, 22648, 7),
(236239, NULL, 'MF_01671', NULL, NULL, 'Inositol 2-dehydrogenase/D-chiro-inositol 3-dehydrogenase [iolG].', NULL, 'IolG', NULL, NULL, 16991, 7),
(236240, NULL, 'MF_00041', NULL, NULL, 'Cysteine--tRNA ligase [cysS].', NULL, 'Cys_tRNA_synth', NULL, NULL, 12788, 7),
(236241, NULL, 'MF_02052', NULL, NULL, '3-hydroxy-5-phosphonooxypentane-2,4-dione thiolase [lsrF].', NULL, 'LsrF', NULL, NULL, 29178, 7),
(236242, NULL, 'MF_02067', NULL, NULL, 'Fructose-1,6-bisphosphate aldolase/phosphatase [fbp].', NULL, 'FBP_aldolase_phosphatase', NULL, NULL, 4556, 7),
(236243, NULL, 'MF_01955', NULL, NULL, 'Urease subunit alpha [ureA].', NULL, 'Urease_beta_gamma', NULL, NULL, 973, 7),
(236244, NULL, 'MF_00112', NULL, NULL, 'Geranylgeranylglyceryl phosphate synthase [pcrB].', NULL, 'GGGP_HepGP_synthase', NULL, NULL, 7128, 7),
(236245, NULL, 'MF_01103', NULL, NULL, 'UPF0291 protein <locus_tag>.', NULL, 'UPF0291', NULL, NULL, 13978, 7),
(236246, NULL, 'MF_01452', NULL, NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B [addB].', NULL, 'AddB_type1', NULL, NULL, 14001, 7),
(236247, NULL, 'MF_00939', NULL, NULL, 'DNA topoisomerase 4 subunit B [parE].', NULL, 'ParE_type2', NULL, NULL, 4920, 7),
(236248, NULL, 'MF_00434', NULL, NULL, 'Putative pterin-4-alpha-carbinolamine dehydratase.', NULL, 'Pterin_4_alpha', NULL, NULL, 5894, 7),
(236249, NULL, 'MF_01229', NULL, NULL, 'Alkanesulfonate monooxygenase [ssuD].', NULL, 'Alkanesulf_monooxygen', NULL, NULL, 18083, 7),
(236250, NULL, 'MF_01911', NULL, NULL, 'HTH-type transcriptional regulator Hpr [hpr].', NULL, 'HTH_type_Hpr', NULL, NULL, 16285, 7),
(236251, NULL, 'MF_00153', NULL, NULL, 'Probable deoxyhypusine synthase [dys].', NULL, 'DHS', NULL, NULL, 15046, 7),
(236252, NULL, 'MF_00628', NULL, NULL, 'Peptidyl-tRNA hydrolase [pth].', NULL, 'Pept_tRNA_hydro_arch', NULL, NULL, 29183, 7),
(236253, NULL, 'MF_04025', NULL, NULL, 'Capsid vertex component 2 [CVC2].', NULL, 'HSV_CVC2', NULL, NULL, 854, 7),
(236254, NULL, 'MF_01697', NULL, NULL, 'L-cysteine:1D-myo-inositol 2-amino-2-deoxy-alpha-D-glucopyranoside ligase [mshC].', NULL, 'MshC', NULL, NULL, 19428, 7),
(236255, NULL, 'MF_00288', NULL, NULL, 'Methionine synthase [metE].', NULL, 'MetE', NULL, NULL, 14704, 7),
(236256, NULL, 'MF_01091', NULL, NULL, '5,10-methylenetetrahydromethanopterin reductase [mer].', NULL, 'F420_mer', NULL, NULL, 18343, 7),
(236257, NULL, 'MF_00659', NULL, NULL, 'UPF0250 protein YbeD [ybeD].', NULL, 'UPF0250', NULL, NULL, 4894, 7),
(236258, NULL, 'MF_01238', NULL, NULL, 'Sialic acid transporter NanT [nanT].', NULL, 'MFS_NanT', NULL, NULL, 5118, 7),
(236259, NULL, 'MF_03217', NULL, NULL, 'Phosphatidylethanolamine N-methyltransferase.', NULL, 'PEMT', NULL, NULL, 17233, 7),
(236260, NULL, 'MF_03227', NULL, NULL, 'Butyryl-CoA:acetate CoA-transferase.', NULL, 'But_acet_CoA_trans', NULL, NULL, 12577, 7),
(236261, NULL, 'MF_00503', NULL, NULL, '50S ribosomal protein L9 [rplI].', NULL, 'Ribosomal_L9', NULL, NULL, 20688, 7),
(236262, NULL, 'MF_00198', NULL, NULL, 'Polyamine aminopropyltransferase [speE].', NULL, 'Spermidine_synth', NULL, NULL, 2335, 7),
(236263, NULL, 'MF_01571', NULL, NULL, 'Proline--tRNA ligase [proS].', NULL, 'Pro_tRNA_synth_type3', NULL, NULL, 1911, 7),
(236264, NULL, 'MF_00203', NULL, NULL, 'UvrABC system protein C [uvrC].', NULL, 'UvrC', NULL, NULL, 5159, 7),
(236265, NULL, 'MF_00986', NULL, NULL, 'L-fuculokinase [fucK].', NULL, 'Fuculokinase', NULL, NULL, 9074, 7),
(236266, NULL, 'MF_04150', NULL, NULL, 'RNA ligase 2.', NULL, 'RNALIG2_T4', NULL, NULL, 34938, 7),
(236267, NULL, 'MF_03050', NULL, NULL, 'Molybdenum cofactor sulfurase [MOCOS].', NULL, 'MOCOS', NULL, NULL, 23826, 7),
(236268, NULL, 'MF_00222', NULL, NULL, 'Shikimate dehydrogenase (NADP(+)) [aroE].', NULL, 'Shikimate_DH_AroE', NULL, NULL, 14737, 7),
(236269, NULL, 'MF_00436', NULL, NULL, 'RNA-binding protein Hfq [hfq].', NULL, 'Hfq', NULL, NULL, 831, 7);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(236270, NULL, 'MF_01293', NULL, NULL, 'D-tagatose-1,6-bisphosphate aldolase subunit KbaY [kbaY].', NULL, 'TagBP_aldolase_KbaY', NULL, NULL, 11679, 7),
(236271, NULL, 'MF_01149', NULL, NULL, 'Uncharacterized MFS-type transporter YcaD [ycaD].', NULL, 'MFS_YcaD', NULL, NULL, 16872, 7),
(236272, NULL, 'MF_01478', NULL, NULL, '50S ribosomal protein L12 [rpl12].', NULL, 'Ribosomal_L12_arch', NULL, NULL, 26463, 7),
(236273, NULL, 'MF_00499', NULL, NULL, '50S ribosomal protein L13e [rpl13e].', NULL, 'Ribosomal_L13e', NULL, NULL, 6863, 7),
(236274, NULL, 'MF_01309_B', NULL, NULL, '30S ribosomal protein S3 [rpsC].', NULL, 'Ribosomal_S3_B', NULL, NULL, 3509, 7),
(236275, NULL, 'MF_00218', NULL, NULL, 'Uroporphyrinogen decarboxylase [hemE].', NULL, 'URO_D', NULL, NULL, 5844, 7),
(236276, NULL, 'MF_01269', NULL, NULL, 'Shikimate kinase 2 [aroL].', NULL, 'Shikimate_kinase_2', NULL, NULL, 23684, 7),
(236277, NULL, 'MF_01306_B', NULL, NULL, '30S ribosomal protein S4 [rpsD].', NULL, 'Ribosomal_S4_B', NULL, NULL, 3978, 7),
(236278, NULL, 'MF_04166', NULL, NULL, 'N6-succino-2-amino-2''-deoxyadenylate synthase [purZ].', NULL, 'Phage_PURZ', NULL, NULL, 34946, 7),
(236279, NULL, 'MF_00292', NULL, NULL, '30S ribosomal protein S28e [rps28e].', NULL, 'Ribosomal_S28e', NULL, NULL, 4886, 7),
(236280, NULL, 'MF_02217', NULL, NULL, 'tRNA 5-hydroxyuridine methyltransferase [trmR].', NULL, 'TrmR_methyltr', NULL, NULL, 35278, 7),
(236281, NULL, 'MF_00099', NULL, NULL, 'Protein-glutamate methylesterase/protein-glutamine glutaminase [cheB].', NULL, 'CheB_chemtxs', NULL, NULL, 652, 7),
(236282, NULL, 'MF_00113', NULL, NULL, 'S-adenosylmethionine:tRNA ribosyltransferase-isomerase [queA].', NULL, 'QueA', NULL, NULL, 6366, 7),
(236283, NULL, 'MF_01030', NULL, NULL, 'D-serine dehydratase [dsdA].', NULL, 'D_Ser_dehydrat', NULL, NULL, 13225, 7),
(236284, NULL, 'MF_01225_A', NULL, NULL, 'GTP 3'',8-cyclase [moaA].', NULL, 'MoaA_A', NULL, NULL, 10126, 7),
(236285, NULL, 'MF_01105', NULL, NULL, 'Amino-acid acetyltransferase [argA].', NULL, 'N_acetyl_glu_synth', NULL, NULL, 10556, 7),
(236286, NULL, 'MF_00379', NULL, NULL, 'tRNA modification GTPase MnmE [mnmE].', NULL, 'GTPase_MnmE', NULL, NULL, 1679, 7),
(236287, NULL, 'MF_00684', NULL, NULL, 'N(4)-acetylcytidine amidohydrolase.', NULL, 'ac4C_amidohydr', NULL, NULL, 7885, 7),
(236288, NULL, 'MF_00615', NULL, NULL, 'DNA-directed RNA polymerase subunit Rpo12 [rpo12].', NULL, 'RNApol_arch_Rpo12', NULL, NULL, 16035, 7),
(236289, NULL, 'MF_00996', NULL, NULL, '1,4-dihydroxy-6-naphtoate synthase [mqnD].', NULL, 'MqnD', NULL, NULL, 22622, 7),
(236290, NULL, 'MF_02244', NULL, NULL, 'Coproheme decarboxylase [chdC].', NULL, 'Coproheme_decarbox_2', NULL, NULL, NULL, 7),
(236291, NULL, 'MF_00473', NULL, NULL, 'Glucose-6-phosphate isomerase [pgi].', NULL, 'G6P_isomerase', NULL, NULL, 3021, 7),
(236292, NULL, 'MF_00768', NULL, NULL, 'HTH-type transcriptional regulator BetI [betI].', NULL, 'HTH_type_BetI', NULL, NULL, 18885, 7),
(236293, NULL, 'MF_00464', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme [speH].', NULL, 'AdoMetDC_1', NULL, NULL, 17570, 7),
(236294, NULL, 'MF_01582', NULL, NULL, 'Serine/threonine transporter SstT [sstT].', NULL, 'Ser_Thr_transp_SstT', NULL, NULL, 15230, 7),
(236295, NULL, 'MF_01656', NULL, NULL, '4-hydroxy-2-oxovalerate aldolase [mhpE].', NULL, 'HOA', NULL, NULL, 16764, 7),
(236296, NULL, 'MF_03223', NULL, NULL, 'Protein N-terminal and lysine N-methyltransferase EFM7 [EFM7].', NULL, 'Methyltr_EFM7', NULL, NULL, 23150, 7),
(236297, NULL, 'MF_04071', NULL, NULL, 'Neuraminidase [NA].', NULL, 'INFV_NRAM', NULL, NULL, 4359, 7),
(236298, NULL, 'MF_01499', NULL, NULL, 'Diadenylate cyclase [dacA].', NULL, 'DacA', NULL, NULL, 30851, 7),
(236299, NULL, 'MF_03207', NULL, NULL, 'Elongation of very long chain fatty acids protein 7 [ELOVL7].', NULL, 'VLCF_elongase_7', NULL, NULL, 31938, 7),
(236300, NULL, 'MF_01487', NULL, NULL, 'RecBCD enzyme subunit RecD [recD].', NULL, 'RecD', NULL, NULL, 4702, 7),
(236301, NULL, 'MF_00301', NULL, NULL, 'Homoserine kinase [thrB].', NULL, 'Homoser_kinase_2', NULL, NULL, 4258, 7);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(236302, NULL, 'MF_00008', NULL, NULL, 'Thymidylate synthase [thyA].', NULL, 'Thymidy_synth_bact', NULL, NULL, 6989, 7),
(236303, NULL, 'MF_00469', NULL, NULL, 'tRNA uridine(34) hydroxylase [trhO].', NULL, 'TrhO', NULL, NULL, 14722, 7),
(236304, NULL, 'MF_01428', NULL, NULL, 'Glutamyl-Q tRNA(Asp) synthetase [gluQ].', NULL, 'Glu_Q_tRNA_synth', NULL, NULL, 15969, 7),
(236305, NULL, 'MF_01114', NULL, NULL, 'Regulatory protein RecX [recX].', NULL, 'RecX', NULL, NULL, 3062, 7),
(236306, NULL, 'MF_04136', NULL, NULL, 'SAR-endolysin.', NULL, 'SAR_ENDOLYSIN', NULL, NULL, 35076, 7),
(236307, NULL, 'MF_02213', NULL, NULL, 'Lipid II isoglutaminyl synthase (glutamine-hydrolyzing) subunit GatD [gatD].', NULL, 'Lipid_II_synth_GatD', NULL, NULL, 35166, 7),
(236308, NULL, 'MF_01257', NULL, NULL, 'Phosphoenolpyruvate transferase [fbiA].', NULL, 'CofD', NULL, NULL, 10733, 7),
(236309, NULL, 'MF_01182', NULL, NULL, 'Cytochrome c-552 [nrfA].', NULL, 'Cytochrom_C552', NULL, NULL, 15697, 7),
(236310, NULL, 'MF_02202', NULL, NULL, 'Tol-Pal system protein TolQ [tolQ].', NULL, 'TolQ', NULL, NULL, 14460, 7),
(236311, NULL, 'MF_01316', NULL, NULL, 'Photosystem II reaction center protein I [psbI].', NULL, 'PSII_PsbI', NULL, NULL, 1606, 7),
(236312, NULL, 'MF_03148', NULL, NULL, 'Inosine triphosphate pyrophosphatase [ITPA].', NULL, 'HAM1_NTPase', NULL, NULL, 22190, 7),
(236313, NULL, 'MF_01693', NULL, NULL, '8-amino-7-oxononanoate synthase [bioF].', NULL, 'BioF_aminotrans_2', NULL, NULL, 5591, 7),
(236314, NULL, 'MF_04125', NULL, NULL, 'Outer capsid protein VP4.', NULL, 'Rota_VP4', NULL, NULL, 35031, 7),
(236315, NULL, 'MF_00509', NULL, NULL, 'Cell division protein ZipA [zipA].', NULL, 'ZipA', NULL, NULL, 11171, 7),
(236316, NULL, 'MF_02225', NULL, NULL, 'Coenzyme A biosynthesis bifunctional protein CoaBC [coaBC].', NULL, 'CoaBC', NULL, NULL, 11359, 7),
(236317, NULL, 'MF_01580', NULL, NULL, 'Cell division activator CedA [cedA].', NULL, 'CedA', NULL, NULL, 20549, 7),
(236318, NULL, 'MF_01341', NULL, NULL, '50S ribosomal protein L15 [rplO].', NULL, 'Ribosomal_L15', NULL, NULL, 2970, 7),
(236319, NULL, 'MF_01846', NULL, NULL, 'Nucleoside triphosphatase NudI [nudI].', NULL, 'Nudix_NudI', NULL, NULL, 16691, 7),
(236320, NULL, 'MF_01492', NULL, NULL, 'Ribonuclease J [rnj].', NULL, 'RNase_J_arch', NULL, NULL, 26920, 7),
(236321, NULL, 'MF_01859', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase G [rlmG].', NULL, '23SrRNA_methyltr_G', NULL, NULL, 15370, 7),
(236322, NULL, 'MF_04080', NULL, NULL, 'Protein Vpr [vpr].', NULL, 'HIV_VPR', NULL, NULL, 2929, 7),
(236323, NULL, 'MF_00832', NULL, NULL, 'Putative aminoacrylate hydrolase RutD [rutD].', NULL, 'RutD', NULL, NULL, 14894, 7),
(236324, NULL, 'MF_00020', NULL, NULL, 'Acetate kinase [ackA].', NULL, 'Acetate_kinase', NULL, NULL, 5234, 7),
(236325, NULL, 'MF_00622', NULL, NULL, 'Exosome complex component Rrp42 [rrp42].', NULL, 'Exosome_Rrp42', NULL, NULL, 20672, 7),
(236326, NULL, 'MF_01274', NULL, NULL, 'Type III pantothenate kinase [coaX].', NULL, 'Pantothen_kinase_3', NULL, NULL, 2249, 7),
(236327, NULL, 'MF_00640', NULL, NULL, 'Deoxyhypusine synthase-like protein.', NULL, 'DHS_like', NULL, NULL, 16730, 7),
(236328, NULL, 'MF_01210_A', NULL, NULL, 'Carbamoyl-phosphate synthase large chain [carB].', NULL, 'CPSase_L_chain_A', NULL, NULL, 3896, 7),
(236329, NULL, 'MF_00448', NULL, NULL, '50S ribosomal protein L10e [rpl10e].', NULL, 'Ribosomal_L10e', NULL, NULL, 15109, 7),
(236330, NULL, 'MF_01343_A', NULL, NULL, '30S ribosomal protein S15 [rpsO].', NULL, 'Ribosomal_S15_A', NULL, NULL, 15090, 7),
(236331, NULL, 'MF_00049_B', NULL, NULL, 'Leucine--tRNA ligase [leuS].', NULL, 'Leu_tRNA_synth_B', NULL, NULL, 6442, 7),
(236332, NULL, 'MF_00255', NULL, NULL, 'Glycine--tRNA ligase beta subunit [glyS].', NULL, 'Gly_tRNA_synth_beta', NULL, NULL, 8398, 7),
(236333, NULL, 'MF_01544', NULL, NULL, 'p-hydroxybenzoic acid efflux pump subunit AaeA [aaeA].', NULL, 'AaeA', NULL, NULL, 17214, 7),
(236334, NULL, 'MF_00839', NULL, NULL, 'Ribosome hibernation promoting factor [hpf].', NULL, 'HPF', NULL, NULL, 16255, 7);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(236335, NULL, 'MF_02002', NULL, NULL, 'Isoleucine--tRNA ligase [ileS].', NULL, 'Ile_tRNA_synth_type1', NULL, NULL, 16430, 7),
(236336, NULL, 'MF_03036', NULL, NULL, '2''-deoxynucleoside 5''-phosphate N-hydrolase 1 [DNPH1].', NULL, 'Nuc_phosphate_hydrolase', NULL, NULL, 25877, 7),
(236337, NULL, 'MF_00517', NULL, NULL, 'Probable sugar efflux transporter [sotB].', NULL, 'MFS_SotB', NULL, NULL, 16385, 7),
(236338, NULL, 'MF_01247', NULL, NULL, 'HTH-type transcriptional regulator MalT [malT].', NULL, 'HTH_type_MalT', NULL, NULL, 16699, 7),
(236339, NULL, 'MF_01562', NULL, NULL, 'Flotillin-like protein FloA [floA].', NULL, 'FloA', NULL, NULL, 16489, 7),
(236340, NULL, 'MF_00444', NULL, NULL, 'ATP-dependent Clp protease proteolytic subunit [clpP].', NULL, 'ClpP', NULL, NULL, 2293, 7),
(236341, NULL, 'MF_00809', NULL, NULL, 'ADP-dependent glucose/glucosamine kinase [glkA].', NULL, 'ADP_glucokinase', NULL, NULL, 23865, 7),
(236342, NULL, 'MF_00727', NULL, NULL, 'Protein-glutamine gamma-glutamyltransferase [tgl].', NULL, 'Tgl', NULL, NULL, 20565, 7),
(236343, NULL, 'MF_01358', NULL, NULL, 'NAD(P)H-quinone oxidoreductase subunit H, chloroplastic [ndhH].', NULL, 'NDH1_NuoD', NULL, NULL, 14853, 7),
(236344, NULL, 'MF_04146', NULL, NULL, 'Terminase, large subunit.', NULL, 'TERL_T4', NULL, NULL, 35366, 7),
(236345, NULL, 'MF_00196', NULL, NULL, 'Mannitol-1-phosphate 5-dehydrogenase [mtlD].', NULL, 'Mannitol_dehydrog', NULL, NULL, 15314, 7),
(236346, NULL, 'MF_00935', NULL, NULL, 'Alanine dehydrogenase [ala].', NULL, 'AlaDH_arch', NULL, NULL, 25321, 7),
(236347, NULL, 'MF_01096', NULL, NULL, 'Tetrahydromethanopterin S-methyltransferase subunit C [mtrC].', NULL, 'MtrC', NULL, NULL, 6628, 7),
(236348, NULL, 'MF_01694', NULL, NULL, 'Biotin synthase [bioB].', NULL, 'BioB', NULL, NULL, 2832, 7),
(236349, NULL, 'MF_01035', NULL, NULL, '3-isopropylmalate dehydrogenase [leuB].', NULL, 'LeuB_type2', NULL, NULL, 11511, 7),
(236350, NULL, 'MF_00844_A', NULL, NULL, 'Rqc2 homolog RqcH [rqcH].', NULL, 'RqcH_A', NULL, NULL, 35104, 7),
(236351, NULL, 'MF_01543', NULL, NULL, 'Formate--tetrahydrofolate ligase [fhs].', NULL, 'FTHFS', NULL, NULL, 5667, 7),
(236352, NULL, 'MF_01116', NULL, NULL, '16S rRNA aminocarboxypropyltransferase.', NULL, 'TSR3', NULL, NULL, 14673, 7),
(236353, NULL, 'MF_00246', NULL, NULL, 'Galactokinase [galK].', NULL, 'Galactokinase', NULL, NULL, 14945, 7),
(236354, NULL, 'MF_03188', NULL, NULL, 'EEF1A lysine methyltransferase 2 [EEF1AKMT2].', NULL, 'Methyltr_EFM4', NULL, NULL, 25145, 7),
(236355, NULL, 'MF_00492', NULL, NULL, 'Transaldolase [tal].', NULL, 'Transaldolase_1', NULL, NULL, 3526, 7),
(236356, NULL, 'MF_00274', NULL, NULL, 'Nucleoid-associated protein YbaB [ybaB].', NULL, 'DNA_YbaB_EbfC', NULL, NULL, 5991, 7),
(236357, NULL, 'MF_00094', NULL, NULL, 'Peptide chain release factor 2 [prfB].', NULL, 'Rel_fac_2', NULL, NULL, 5116, 7),
(236358, NULL, 'MF_00723', NULL, NULL, 'Glutathione-dependent formaldehyde-activating enzyme [gfa].', NULL, 'Formald_GSH', NULL, NULL, 8557, 7),
(236359, NULL, 'MF_03205', NULL, NULL, 'Elongation of very long chain fatty acids protein 5 [ELOVL5].', NULL, 'VLCF_elongase_5', NULL, NULL, 29913, 7),
(236360, NULL, 'MF_01125', NULL, NULL, 'Reverse gyrase [rgy].', NULL, 'Reverse_gyrase', NULL, NULL, 4786, 7),
(236361, NULL, 'MF_01440', NULL, NULL, 'Chemoreceptor glutamine deamidase CheD [cheD].', NULL, 'CheD', NULL, NULL, 3505, 7),
(236362, NULL, 'MF_00072', NULL, NULL, 'Peptide chain release factor 3 [prfC].', NULL, 'Rel_fac_3', NULL, NULL, 747, 7),
(236363, NULL, 'MF_04076', NULL, NULL, 'External core antigen [C].', NULL, 'HBV_HBEAG', NULL, NULL, 1316, 7),
(236364, NULL, 'MF_00277', NULL, NULL, 'Bifunctional uridylyltransferase/uridylyl-removing enzyme [glnD].', NULL, 'PII_uridylyl_transf', NULL, NULL, 5439, 7),
(236365, NULL, 'MF_00589', NULL, NULL, 'Photosystem II 12 kDa extrinsic protein [psbU].', NULL, 'PSII_PsbU', NULL, NULL, 12339, 7),
(236366, NULL, 'MF_03193', NULL, NULL, 'Ubiquinone biosynthesis monooxygenase COQ6, mitochondrial [COQ6].', NULL, 'COQ6_monooxygenase', NULL, NULL, 3802, 7);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(236367, NULL, 'MF_00569', NULL, NULL, 'Quinolinate synthase A [nadA].', NULL, 'NadA_type3', NULL, NULL, 16344, 7),
(236368, NULL, 'MF_00174', NULL, NULL, 'Elongation factor P--(R)-beta-lysine ligase [epmA].', NULL, 'EF_P_modif_A', NULL, NULL, 1729, 7),
(236369, NULL, 'MF_01023', NULL, NULL, 'Histidinol-phosphate aminotransferase [hisC].', NULL, 'HisC_aminotrans_2', NULL, NULL, 6815, 7),
(236370, NULL, 'MF_01430', NULL, NULL, 'Outer membrane protein assembly factor BamA [bamA].', NULL, 'OM_assembly_BamA', NULL, NULL, 14914, 7),
(236371, NULL, 'MF_02014', NULL, NULL, 'Cell division suppressor protein YneA [yneA].', NULL, 'YneA', NULL, NULL, 14518, 7),
(236372, NULL, 'MF_01018', NULL, NULL, 'ATP phosphoribosyltransferase [hisG].', NULL, 'HisG_Short', NULL, NULL, 17609, 7),
(236373, NULL, 'MF_03003', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit D [EIF3D].', NULL, 'eIF3d', NULL, NULL, 2197, 7),
(236374, NULL, 'MF_03153', NULL, NULL, 'U1 small nuclear ribonucleoprotein C [SNRPC].', NULL, 'U1_C', NULL, NULL, 17094, 7),
(236375, NULL, 'MF_03162', NULL, NULL, 'Putative tRNA (cytidine(32)/guanosine(34)-2''-O)-methyltransferase [TRM7].', NULL, 'RNA_methyltr_E_TRM7', NULL, NULL, 23991, 7),
(236376, NULL, 'MF_03103', NULL, NULL, 'Maintenance of mitochondrial morphology protein 1 [MMM1].', NULL, 'Mmm1', NULL, NULL, 23821, 7),
(236377, NULL, 'MF_00674', NULL, NULL, 'UPF0251 protein <locus_tag>.', NULL, 'UPF0251', NULL, NULL, 5808, 7),
(236378, NULL, 'MF_03113', NULL, NULL, 'Golgi to ER traffic protein 1 [GET1].', NULL, 'Get1', NULL, NULL, 26998, 7),
(236379, NULL, 'MF_01282', NULL, NULL, 'Virginiamycin B lyase [vgb].', NULL, 'VirginiamycinB_lyase', NULL, NULL, 10717, 7),
(236380, NULL, 'MF_00940', NULL, NULL, 'Tat proofreading chaperone DmsD [dmsD].', NULL, 'DmsD_chaperone', NULL, NULL, 25446, 7),
(236381, NULL, 'MF_01354', NULL, NULL, 'NAD(P)H-quinone oxidoreductase subunit O [ndhO].', NULL, 'NDH1_NDH1O', NULL, NULL, 14777, 7),
(236382, NULL, 'MF_01219', NULL, NULL, 'Bifunctional protein PyrR [pyrR].', NULL, 'PyrR', NULL, NULL, 15272, 7),
(236383, NULL, 'MF_00018', NULL, NULL, 'UPF0758 protein YicR [yicR].', NULL, 'UPF0758_YicR', NULL, NULL, 17202, 7),
(236384, NULL, 'MF_00162', NULL, NULL, 'Glutathione synthetase [gshB].', NULL, 'GSH_S', NULL, NULL, 3545, 7),
(236385, NULL, 'MF_01380', NULL, NULL, 'Iron-sulfur cluster insertion protein ErpA [erpA].', NULL, 'Fe_S_insert_ErpA', NULL, NULL, 15265, 7),
(236386, NULL, 'MF_00912', NULL, NULL, 'Cell division protein DivIB [divIB].', NULL, 'DivIB', NULL, NULL, 25091, 7),
(236387, NULL, 'MF_02096', NULL, NULL, 'DNA repair protein.', NULL, 'Nre', NULL, NULL, 32454, 7),
(236388, NULL, 'MF_00697', NULL, NULL, 'UPF0276 protein <locus_tag>.', NULL, 'UPF0276', NULL, NULL, 2494, 7),
(236389, NULL, 'MF_04084', NULL, NULL, 'Pre-glycoprotein polyprotein GP complex [GPC].', NULL, 'ARENA_GPC', NULL, NULL, 3403, 7),
(236390, NULL, 'MF_00183', NULL, NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase [dxr].', NULL, 'DXP_reductoisom', NULL, NULL, 3142, 7),
(236391, NULL, 'MF_00064', NULL, NULL, 'Sulfate adenylyltransferase subunit 2 [cysD].', NULL, 'Sulf_adenylyltr_sub2', NULL, NULL, 13281, 7),
(236392, NULL, 'MF_01669', NULL, NULL, '3D-(3,5/4)-trihydroxycyclohexane-1,2-dione hydrolase [iolD].', NULL, 'IolD', NULL, NULL, 10603, 7),
(236393, NULL, 'MF_01201', NULL, NULL, 'Alanine racemase.', NULL, 'Ala_racemase', NULL, NULL, 4785, 7),
(236394, NULL, 'MF_02246', NULL, NULL, 'Guanosine-inosine kinase [gsk].', NULL, 'Gua_Ino_kinase', NULL, NULL, 33814, 7),
(236395, NULL, 'MF_03141', NULL, NULL, 'Platelet-activating factor acetylhydrolase IB subunit alpha [PAFAH1B1].', NULL, 'lis1', NULL, NULL, 15845, 7),
(236396, NULL, 'MF_00135', NULL, NULL, 'N-(5''-phosphoribosyl)anthranilate isomerase [trpF].', NULL, 'PRAI', NULL, NULL, 2448, 7),
(236397, NULL, 'MF_00498', NULL, NULL, 'UPF0179 protein <locus_tag>.', NULL, 'UPF0179', NULL, NULL, 6355, 7),
(236398, NULL, 'MF_00654', NULL, NULL, 'Pyrroloquinoline-quinone synthase [pqqC].', NULL, 'PQQ_syn_PqqC', NULL, NULL, 13925, 7);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(236399, NULL, 'MF_01541', NULL, NULL, 'Sulfite reductase [NADPH] flavoprotein alpha-component [cysJ].', NULL, 'CysJ', NULL, NULL, 24299, 7),
(236400, NULL, 'MF_01814', NULL, NULL, 'Transcription factor FapR [fapR].', NULL, 'Transcrip_fact_FapR', NULL, NULL, 16455, 7),
(236401, NULL, 'MF_01364_A', NULL, NULL, '30S ribosomal protein S14 type Z [rpsZ].', NULL, 'Ribosomal_S14_2_A', NULL, NULL, 12389, 7),
(236402, NULL, 'MF_00749', NULL, NULL, 'RNA chaperone ProQ [proQ].', NULL, 'ProQ', NULL, NULL, 16514, 7),
(236403, NULL, 'MF_00667', NULL, NULL, 'Small, acid-soluble spore protein H [sspH].', NULL, 'SspH', NULL, NULL, 9801, 7),
(236404, NULL, 'MF_00565', NULL, NULL, 'D-alanyl carrier protein [dltC].', NULL, 'DltC', NULL, NULL, 2501, 7),
(236405, NULL, 'MF_04018', NULL, NULL, 'Triplex capsid protein 1 [TRX1].', NULL, 'HSV_TRX1', NULL, NULL, 769, 7),
(236406, NULL, 'MF_01508', NULL, NULL, 'Replication factor C large subunit [rfcL].', NULL, 'RfcL', NULL, NULL, 6135, 7),
(236407, NULL, 'MF_00069', NULL, NULL, 'Hydroxylamine reductase [hcp].', NULL, 'Hydroxylam_reduct', NULL, NULL, 5305, 7),
(236408, NULL, 'MF_04059', NULL, NULL, 'Protease [L3].', NULL, 'ADV_PRO', NULL, NULL, 444, 7),
(236409, NULL, 'MF_00138', NULL, NULL, 'Phosphoribosylamine--glycine ligase [purD].', NULL, 'GARS', NULL, NULL, 3823, 7),
(236410, NULL, 'MF_01804', NULL, NULL, 'Segregation and condensation protein B [scpB].', NULL, 'ScpB', NULL, NULL, 11445, 7),
(236411, NULL, 'MF_02054', NULL, NULL, 'Tyrosine recombinase XerH [xerH].', NULL, 'Recomb_XerH', NULL, NULL, 31522, 7),
(236412, NULL, 'MF_00675', NULL, NULL, 'Uronate isomerase [uxaC].', NULL, 'UxaC', NULL, NULL, 2027, 7),
(236413, NULL, 'MF_01370', NULL, NULL, 'Photosystem II reaction center Psb28 protein [psb28].', NULL, 'PSII_Psb28', NULL, NULL, 2611, 7),
(236414, NULL, 'MF_01967', NULL, NULL, 'NAD-dependent protein deacetylase [cobB].', NULL, 'Sirtuin_ClassII', NULL, NULL, 23294, 7),
(236415, NULL, 'MF_01049', NULL, NULL, 'L-carnitine/gamma-butyrobetaine antiporter [caiT].', NULL, 'CaiT', NULL, NULL, 16395, 7),
(236416, NULL, 'MF_01110', NULL, NULL, 'N-acetyl-gamma-glutamyl-phosphate reductase [argC].', NULL, 'ArgC_type2', NULL, NULL, 10760, 7),
(236417, NULL, 'MF_00176', NULL, NULL, 'Serine--tRNA ligase [serS].', NULL, 'Ser_tRNA_synth_type1', NULL, NULL, 6055, 7),
(236418, NULL, 'MF_00303', NULL, NULL, 'Trigger factor [tig].', NULL, 'Trigger_factor_Tig', NULL, NULL, 10949, 7),
(236419, NULL, 'MF_00273', NULL, NULL, '50S ribosomal protein L18Ae [rpl18a].', NULL, 'Ribosomal_L18Ae', NULL, NULL, 21526, 7),
(236420, NULL, 'MF_02124', NULL, NULL, 'Alpha-1,4-glucan:maltose-1-phosphate maltosyltransferase [glgE].', NULL, 'GlgE', NULL, NULL, 25330, 7),
(236421, NULL, 'MF_03004', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit E [EIF3E].', NULL, 'eIF3e', NULL, NULL, 19550, 7),
(236422, NULL, 'MF_01467', NULL, NULL, 'Hypoxanthine/guanine phosphoribosyltransferase [hpt].', NULL, 'Hypx_phosphoribosyltr', NULL, NULL, 22471, 7),
(236423, NULL, 'MF_01975', NULL, NULL, 'Methionine aminopeptidase [map].', NULL, 'MetAP_2_arc', NULL, NULL, 26117, 7),
(236424, NULL, 'MF_01612', NULL, NULL, '5-amino-6-(D-ribitylamino)uracil--L-tyrosine 4-hydroxyphenyl transferase [cofH].', NULL, 'FO_synth_sub2', NULL, NULL, 18397, 7),
(236425, NULL, 'MF_00571', NULL, NULL, 'Galactose-1-phosphate uridylyltransferase [galT].', NULL, 'GalP_UDP_trans', NULL, NULL, 6770, 7),
(236426, NULL, 'MF_00373', NULL, NULL, '50S ribosomal protein L28 [rpmB].', NULL, 'Ribosomal_L28', NULL, NULL, 2378, 7),
(236427, NULL, 'MF_00258', NULL, NULL, 'Glutamate racemase [murI].', NULL, 'Glu_racemase', NULL, NULL, 5839, 7),
(236428, NULL, 'MF_00542', NULL, NULL, 'Probable butyrate kinase [buk].', NULL, 'Butyrate_kinase', NULL, NULL, 10655, 7),
(236429, NULL, 'MF_00478', NULL, NULL, 'Ion-translocating oxidoreductase complex subunit E [rsxE].', NULL, 'RsxE_RnfE', NULL, NULL, 2475, 7),
(236430, NULL, 'MF_00633', NULL, NULL, 'Cytochrome b6 [petB].', NULL, 'Cytb6_f_cytb6', NULL, NULL, 16481, 7),
(236431, NULL, 'MF_04152', NULL, NULL, 'Single-stranded DNA-binding protein [32].', NULL, 'SSB_T4', NULL, NULL, 37752, 7);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(236432, NULL, 'MF_00706', NULL, NULL, 'Ecotin [eco].', NULL, 'Ecotin', NULL, NULL, 15797, 7),
(236433, NULL, 'MF_01152', NULL, NULL, 'Chaperone protein DnaJ [dnaJ].', NULL, 'DnaJ', NULL, NULL, 11588, 7),
(236434, NULL, 'MF_04145', NULL, NULL, 'Terminase, large subunit.', NULL, 'TERL_SPP1', NULL, NULL, 33900, 7),
(236435, NULL, 'MF_01386', NULL, NULL, 'Photosystem II reaction center X protein [psbX].', NULL, 'PSII_PsbX_1', NULL, NULL, 16010, 7),
(236436, NULL, 'MF_01377', NULL, NULL, 'Probable lipid kinase YegS [yegS].', NULL, 'YegS', NULL, NULL, 15717, 7),
(236437, NULL, 'MF_00090', NULL, NULL, 'Protein-L-isoaspartate O-methyltransferase [pcm].', NULL, 'PIMT', NULL, NULL, 6763, 7),
(236438, NULL, 'MF_00313', NULL, NULL, 'Glutaminase [glsA].', NULL, 'Glutaminase', NULL, NULL, 13674, 7),
(236439, NULL, 'MF_04122', NULL, NULL, 'Internal virion protein gp15.', NULL, 'GP15_T7', NULL, NULL, 32524, 7),
(236440, NULL, 'MF_00848', NULL, NULL, 'ATP-binding protein Uup [uup].', NULL, 'Uup', NULL, NULL, 35096, 7),
(236441, NULL, 'MF_01681', NULL, NULL, 'Enolase-phosphatase E1 [mtnC].', NULL, 'Salvage_MtnC', NULL, NULL, 10362, 7),
(236442, NULL, 'MF_00556', NULL, NULL, 'Bacteriohemerythrin.', NULL, 'Hemerythrin', NULL, NULL, 16137, 7),
(236443, NULL, 'MF_01177', NULL, NULL, 'HTH-type transcriptional repressor NsrR [nsrR].', NULL, 'HTH_type_NsrR', NULL, NULL, 16761, 7),
(236444, NULL, 'MF_04023', NULL, NULL, 'Nuclear egress protein 1 [NEC1].', NULL, 'HSV_NEC1', NULL, NULL, 15287, 7),
(236445, NULL, 'MF_01573', NULL, NULL, 'Pyrrolysine--tRNA ligase [pylS].', NULL, 'Pyl_tRNA_synth', NULL, NULL, 8553, 7),
(236446, NULL, 'MF_00420', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase subunit PurL [purL].', NULL, 'PurL_2', NULL, NULL, 2328, 7),
(236447, NULL, 'MF_01977', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase [pfp].', NULL, 'Phosphofructokinase_II_P', NULL, NULL, 7951, 7),
(236448, NULL, 'MF_00287', NULL, NULL, 'Probable disulfide formation protein [bdbC].', NULL, 'BdbC', NULL, NULL, 12821, 7),
(236449, NULL, 'MF_00193', NULL, NULL, 'NH(3)-dependent NAD(+) synthetase [nadE].', NULL, 'NadE_ammonia_dep', NULL, NULL, 14859, 7),
(236450, NULL, 'MF_01291', NULL, NULL, '5-keto-4-deoxy-D-glucarate aldolase [garL].', NULL, 'KDGluc_aldolase', NULL, NULL, 16860, 7),
(236451, NULL, 'MF_01985', NULL, NULL, 'Phenolic acid decarboxylase.', NULL, 'UbiD_YclC', NULL, NULL, 23831, 7),
(236452, NULL, 'MF_00109', NULL, NULL, 'Shikimate kinase [aroK].', NULL, 'Shikimate_kinase', NULL, NULL, 5997, 7),
(236453, NULL, 'MF_04142', NULL, NULL, 'NAD--protein ADP-ribosyltransferase modB [modB].', NULL, 'MODB_T4', NULL, NULL, 34797, 7),
(236454, NULL, 'MF_00575', NULL, NULL, 'UDP-2,3-diacylglucosamine hydrolase [lpxH].', NULL, 'LpxH', NULL, NULL, 10662, 7),
(236455, NULL, 'MF_01986', NULL, NULL, 'Probable UbiX-like flavin prenyltransferase.', NULL, 'ubiX_pad_yclB', NULL, NULL, 23981, 7),
(236456, NULL, 'MF_00858', NULL, NULL, 'Carboxysome shell vertex protein CcmL [ccmL].', NULL, 'CcmL', NULL, NULL, 34680, 7),
(236457, NULL, 'MF_01374', NULL, NULL, 'Hydroxyacylglutathione hydrolase [gloB].', NULL, 'Glyoxalase_2', NULL, NULL, 19369, 7),
(236458, NULL, 'MF_00146', NULL, NULL, 'dCTP deaminase, dUMP-forming [dcd].', NULL, 'dCTP_deaminase', NULL, NULL, 11416, 7),
(236459, NULL, 'MF_01472', NULL, NULL, 'UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase GtfA subunit [gtfA].', NULL, 'GtfA', NULL, NULL, 11289, 7),
(236460, NULL, 'MF_01925', NULL, NULL, 'Pyrroline-5-carboxylate reductase [proC].', NULL, 'P5C_reductase', NULL, NULL, 803, 7),
(236461, NULL, 'MF_04027', NULL, NULL, 'Ribonucleoside-diphosphate reductase large subunit-like protein [RIR1].', NULL, 'HSV_RIR1_betahv', NULL, NULL, 8484, 7),
(236462, NULL, 'MF_01594', NULL, NULL, 'Rhomboid protease GlpG [glpG].', NULL, 'Rhomboid_GlpG', NULL, NULL, 641, 7),
(236463, NULL, 'MF_00070', NULL, NULL, '2-keto-3-deoxygluconate permease [kdgT].', NULL, 'KdgT', NULL, NULL, 3442, 7),
(236464, NULL, 'MF_01445', NULL, NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase [tsaD].', NULL, 'TsaD', NULL, NULL, 21322, 7);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(236465, NULL, 'MF_01333_A', NULL, NULL, '50S ribosomal protein L5 [rplE].', NULL, 'Ribosomal_L5_A', NULL, NULL, 14655, 7),
(236466, NULL, 'MF_00291_B', NULL, NULL, '30S ribosomal protein S2 [rpsB].', NULL, 'Ribosomal_S2_B', NULL, NULL, 3546, 7),
(236467, NULL, 'MF_01908', NULL, NULL, 'Cyclic 2,3-diphosphoglycerate synthetase [cpgS].', NULL, 'Cyc_PG_syn', NULL, NULL, 17867, 7),
(236468, NULL, 'MF_01896', NULL, NULL, 'DNA gyrase inhibitor [sbmC].', NULL, 'DNA_gyrase_inhibitor', NULL, NULL, 14526, 7),
(236469, NULL, 'MF_01546', NULL, NULL, 'Protein AaeX [aaeX].', NULL, 'AaeX', NULL, NULL, 14186, 7),
(236470, NULL, 'MF_03043', NULL, NULL, 'Queuine tRNA-ribosyltransferase accessory subunit 2 [QTRT2].', NULL, 'QTRT2', NULL, NULL, 23668, 7),
(236471, NULL, 'MF_01668', NULL, NULL, '5-dehydro-2-deoxygluconokinase [iolC].', NULL, 'IolC', NULL, NULL, 17300, 7),
(236472, NULL, 'MF_01245', NULL, NULL, 'UPF0248 protein <locus_tag>.', NULL, 'UPF0248', NULL, NULL, 3561, 7),
(236473, NULL, 'MF_01609', NULL, NULL, 'Glutamate--cysteine ligase [gshA].', NULL, 'Glu_cys_ligase_2', NULL, NULL, 13350, 7),
(236474, NULL, 'MF_01217', NULL, NULL, 'Acyl carrier protein [acpP].', NULL, 'Acyl_carrier', NULL, NULL, 2555, 7),
(236475, NULL, 'MF_01038', NULL, NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase [gpmI].', NULL, 'GpmI', NULL, NULL, 1480, 7),
(236476, NULL, 'MF_01471', NULL, NULL, 'CRISPR-associated endoribonuclease Cas2 [cas2].', NULL, 'Cas2', NULL, NULL, 10800, 7),
(236477, NULL, 'MF_04063', NULL, NULL, 'Polymerase acidic protein [PA].', NULL, 'INFV_PA', NULL, NULL, 27418, 7),
(236478, NULL, 'MF_00186', NULL, NULL, 'Glycerol kinase [glpK].', NULL, 'Glycerol_kin', NULL, NULL, 1235, 7),
(236479, NULL, 'MF_00119', NULL, NULL, 'Translation initiation factor 2 subunit gamma [eif2g].', NULL, 'eIF_2_gamma', NULL, NULL, 15708, 7),
(236480, NULL, 'MF_00819', NULL, NULL, 'Putative septation protein SpoVG [spoVG].', NULL, 'SpoVG', NULL, NULL, 447, 7),
(236481, NULL, 'MF_00500', NULL, NULL, '30S ribosomal protein S20 [rpsT].', NULL, 'Ribosomal_S20', NULL, NULL, 1788, 7),
(236482, NULL, 'MF_02046', NULL, NULL, 'NAD-dependent glucose-6-phosphate dehydrogenase.', NULL, 'Glc6PDH_archaea', NULL, NULL, 25242, 7),
(236483, NULL, 'MF_01906', NULL, NULL, 'D-(-)-3-hydroxybutyrate oligomer hydrolase.', NULL, '3HBOH', NULL, NULL, 17594, 7),
(236484, NULL, 'MF_01655', NULL, NULL, '2-keto-4-pentenoate hydratase [mhpD].', NULL, 'MhpD', NULL, NULL, 16555, 7),
(236485, NULL, 'MF_04138', NULL, NULL, 'Tape measure protein [H].', NULL, 'TMP_LAMBDA', NULL, NULL, 34802, 7),
(236486, NULL, 'MF_01051', NULL, NULL, 'Carnitinyl-CoA dehydratase [caiD].', NULL, 'CaiD', NULL, NULL, 17284, 7),
(236487, NULL, 'MF_01021', NULL, NULL, 'Phosphoribosyl-AMP cyclohydrolase [hisI].', NULL, 'HisI', NULL, NULL, 22794, 7),
(236488, NULL, 'MF_00328', NULL, NULL, 'Guanylate kinase [gmk].', NULL, 'Guanylate_kinase', NULL, NULL, 17438, 7),
(236489, NULL, 'MF_00039', NULL, NULL, 'Putative adenylate kinase.', NULL, 'Adenylate_kinase_AK6', NULL, NULL, 20013, 7),
(236490, NULL, 'MF_00392', NULL, NULL, 'Lipid-A-disaccharide synthase [lpxB].', NULL, 'LpxB', NULL, NULL, 3160, 7),
(236491, NULL, 'MF_02128', NULL, NULL, 'Thiamine-monophosphate kinase [thiL].', NULL, 'TMP_kinase', NULL, NULL, 3742, 7),
(236492, NULL, 'MF_01622', NULL, NULL, 'tRNA 2-selenouridine synthase [selU].', NULL, 'tRNA_sel_U_synth', NULL, NULL, 15620, 7),
(236493, NULL, 'MF_01972', NULL, NULL, 'Tryptophan 2,3-dioxygenase [kynA].', NULL, 'T23O', NULL, NULL, 852, 7),
(236494, NULL, 'MF_02062', NULL, NULL, 'Sodium/glutamate symporter [gltS].', NULL, 'GltS', NULL, NULL, 7406, 7),
(236495, NULL, 'MF_04135', NULL, NULL, 'Portal protein B [B].', NULL, 'PORTAL_LAMBDA', NULL, NULL, 6793, 7),
(236496, NULL, 'MF_01135', NULL, NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit delta [cdhD].', NULL, 'CdhD', NULL, NULL, 1421, 7),
(236497, NULL, 'MF_00914', NULL, NULL, 'L-alanine exporter AlaE [alaE].', NULL, 'L_Ala_exporter', NULL, NULL, 8094, 7),
(236498, NULL, 'MF_00452', NULL, NULL, 'Phosphoenolpyruvate carboxykinase [GTP] [pckG].', NULL, 'PEPCK_GTP', NULL, NULL, 7480, 7); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(236499, NULL, 'MF_00991', NULL, NULL, 'Futalosine hydrolase [mqnB].', NULL, 'MqnB', NULL, NULL, 15557, 7),
(236500, NULL, 'MF_01112', NULL, NULL, 'UPF0201 protein <locus_tag>.', NULL, 'UPF0201', NULL, NULL, 3797, 7),
(236501, NULL, 'MF_01218_B', NULL, NULL, 'Uracil phosphoribosyltransferase [upp].', NULL, 'Upp_B', NULL, NULL, 298, 7),
(236502, NULL, 'MF_00365', NULL, NULL, 'DNA replication and repair protein RecF [recF].', NULL, 'RecF', NULL, NULL, 814, 7),
(236503, NULL, 'MF_00449', NULL, NULL, 'DNA double-strand break repair Rad50 ATPase [rad50].', NULL, 'RAD50', NULL, NULL, 15284, 7),
(236504, NULL, 'MF_02086', NULL, NULL, '4-hydroxythreonine-4-phosphate dehydrogenase [pdxA].', NULL, 'PdxA_Epsilonprot', NULL, NULL, 33087, 7),
(236505, NULL, 'MF_01497', NULL, NULL, 'Stress response kinase A [srkA].', NULL, 'SrkA_kinase', NULL, NULL, 25255, 7),
(236506, NULL, 'MF_03111', NULL, NULL, 'Ubiquinone biosynthesis protein <gene_name>, mitochondrial [COQ4].', NULL, 'Coq4', NULL, NULL, 23770, 7),
(236507, NULL, 'MF_04033', NULL, NULL, 'Envelope glycoprotein H [gH].', NULL, 'HSV_GH', NULL, NULL, 6341, 7),
(236508, NULL, 'MF_00401', NULL, NULL, 'Peroxiredoxin.', NULL, 'Peroxiredoxin', NULL, NULL, 17033, 7),
(236509, NULL, 'MF_01251', NULL, NULL, 'UPF0313 protein YgiQ [ygiQ].', NULL, 'UPF0313', NULL, NULL, 14517, 7),
(236510, NULL, 'MF_02115', NULL, NULL, 'FAD synthase [ribL].', NULL, 'FAD_synth_arch', NULL, NULL, 21818, 7),
(236511, NULL, 'MF_00033', NULL, NULL, 'UDP-N-acetylglucosamine--N-acetylmuramyl-(pentapeptide) pyrophosphoryl-undecaprenol N-acetylglucosamine transferase [murG].', NULL, 'MurG', NULL, NULL, 1266, 7),
(236512, NULL, 'MF_01343_B', NULL, NULL, '30S ribosomal protein S15 [rpsO].', NULL, 'Ribosomal_S15_B', NULL, NULL, 4167, 7),
(236513, NULL, 'MF_01617', NULL, NULL, 'Fatty acid oxidation complex subunit alpha [fadJ].', NULL, 'FadJ', NULL, NULL, 12882, 7),
(236514, NULL, 'MF_03026', NULL, NULL, 'Leucine zipper putative tumor suppressor 2 [LZTS2].', NULL, 'LZTS2', NULL, NULL, 26295, 7),
(236515, NULL, 'MF_00785', NULL, NULL, 'Sirohydrochlorin cobaltochelatase [cbiX].', NULL, 'CbiX', NULL, NULL, 16186, 7),
(236516, NULL, 'MF_02133', NULL, NULL, 'Prokaryotic ubiquitin-like protein UBact [ubact].', NULL, 'UBact', NULL, NULL, 27313, 7),
(236517, NULL, 'MF_00074', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase G [rsmG].', NULL, '16SrRNA_methyltr_G', NULL, NULL, 1890, 7),
(236518, NULL, 'MF_00437', NULL, NULL, 'Photosystem I assembly protein Ycf4 [ycf4].', NULL, 'Ycf4', NULL, NULL, 4169, 7),
(236519, NULL, 'MF_01488', NULL, NULL, 'ATP-dependent RecD-like DNA helicase [recD2].', NULL, 'RecD_like', NULL, NULL, 4774, 7),
(236520, NULL, 'MF_01531', NULL, NULL, 'Vitamin B12 transporter BtuB [btuB].', NULL, 'BtuB', NULL, NULL, 2381, 7),
(236521, NULL, 'MF_00055', NULL, NULL, 'MEMO1 family protein <locus_tag>.', NULL, 'MEMO1', NULL, NULL, 3653, 7),
(236522, NULL, 'MF_01212', NULL, NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase-like protein.', NULL, 'dGTPase_type2', NULL, NULL, 15003, 7),
(236523, NULL, 'MF_01378', NULL, NULL, 'Cytochrome c-550 [psbV].', NULL, 'PSII_Cyt550', NULL, NULL, 13608, 7),
(236524, NULL, 'MF_00169', NULL, NULL, '3-dehydroquinate dehydratase [aroQ].', NULL, 'AroQ', NULL, NULL, 4460, 7),
(236525, NULL, 'MF_00194', NULL, NULL, 'Recombination-associated protein RdgC [rdgC].', NULL, 'RdgC', NULL, NULL, 2379, 7),
(236526, NULL, 'MF_03226', NULL, NULL, 'Splicing factor YJU2 [YJU2].', NULL, 'YJU2', NULL, NULL, 35402, 7),
(236527, NULL, 'MF_00493', NULL, NULL, 'Transaldolase [tal].', NULL, 'Transaldolase_2', NULL, NULL, 3698, 7),
(236528, NULL, 'MF_00206', NULL, NULL, 'Lipoyl synthase [lipA].', NULL, 'Lipoyl_synth', NULL, NULL, 2415, 7),
(236529, NULL, 'MF_00765', NULL, NULL, 'UPF0307 protein YjgA [yjgA].', NULL, 'UPF0307', NULL, NULL, 3689, 7),
(236530, NULL, 'MF_01917', NULL, NULL, 'Cardiolipin synthase B [clsB].', NULL, 'Cardiolipin_synth_ClsB', NULL, NULL, 23661, 7),
(236531, NULL, 'MF_01834', NULL, NULL, 'tRNA-splicing endonuclease [endA].', NULL, 'EndA_long', NULL, NULL, 16988, 7);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(236532, NULL, 'MF_00954', NULL, NULL, 'Regulator of nucleoside diphosphate kinase [rnk].', NULL, 'Rnk', NULL, NULL, 25587, 7),
(236533, NULL, 'MF_00459', NULL, NULL, 'Ion-translocating oxidoreductase complex subunit A [rsxA].', NULL, 'RsxA_RnfA', NULL, NULL, 10059, 7),
(236534, NULL, 'MF_00504', NULL, NULL, 'Peptidase B [pepB].', NULL, 'Aminopeptidase_M17', NULL, NULL, 7888, 7),
(236535, NULL, 'MF_01300', NULL, NULL, 'C4-dicarboxylate transport protein [dctA].', NULL, 'C4_dicarb_transport', NULL, NULL, 8025, 7),
(236536, NULL, 'MF_00180', NULL, NULL, '3,4-dihydroxy-2-butanone 4-phosphate synthase [ribB].', NULL, 'RibB', NULL, NULL, 6525, 7),
(236537, NULL, 'MF_03010', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit K [EIF3K].', NULL, 'eIF3k', NULL, NULL, 14489, 7),
(236538, NULL, 'MF_03224', NULL, NULL, 'Cyanide hydratase.', NULL, 'CN_hydrolase', NULL, NULL, 27040, 7),
(236539, NULL, 'MF_00145', NULL, NULL, 'Phosphoglycerate kinase [pgk].', NULL, 'Phosphoglyc_kinase', NULL, NULL, 5397, 7),
(236540, NULL, 'MF_00297', NULL, NULL, 'NAD-capped RNA hydrolase NudC [nudC].', NULL, 'Nudix_NudC', NULL, NULL, 14554, 7),
(236541, NULL, 'MF_00922', NULL, NULL, 'Outer membrane protein assembly factor BamD [bamD].', NULL, 'OM_assembly_BamD', NULL, NULL, 17776, 7),
(236542, NULL, 'MF_04036', NULL, NULL, 'Envelope glycoprotein L [gL].', NULL, 'HSV_GL_betahv', NULL, NULL, 2630, 7),
(236543, NULL, 'MF_01434', NULL, NULL, 'Monofunctional glycosyltransferase [mgt].', NULL, 'MGT', NULL, NULL, 14780, 7),
(236544, NULL, 'MF_00108', NULL, NULL, '2-C-methyl-D-erythritol 4-phosphate cytidylyltransferase [ispD].', NULL, 'IspD', NULL, NULL, 790, 7),
(236545, NULL, 'MF_01957', NULL, NULL, 'Serine/threonine-protein kinase PknD [pknD].', NULL, 'PknD_kinase', NULL, NULL, 16004, 7),
(236546, NULL, 'MF_01984', NULL, NULL, 'Flavin prenyltransferase UbiX [ubiX].', NULL, 'ubiX_pad', NULL, NULL, 1820, 7),
(236547, NULL, 'MF_00925', NULL, NULL, 'Outer membrane protein assembly factor BamE [bamE].', NULL, 'OM_assembly_BamE', NULL, NULL, 26505, 7),
(236548, NULL, 'MF_02249', NULL, NULL, '3-oxopimeloyl-[acyl-carrier-protein] synthase [bioZ].', NULL, 'BioZ', NULL, NULL, 33585, 7),
(236549, NULL, 'MF_01382', NULL, NULL, 'Protein translocase subunit SecA [secA].', NULL, 'SecA', NULL, NULL, 1607, 7),
(236550, NULL, 'MF_00232', NULL, NULL, 'Translation initiation factor 2 subunit beta [eif2b].', NULL, 'eIF_2_beta', NULL, NULL, 7191, 7),
(236551, NULL, 'MF_00136', NULL, NULL, 'S-adenosylmethionine synthase [mat].', NULL, 'S_AdoMet_synth2', NULL, NULL, 4801, 7),
(236552, NULL, 'MF_00016', NULL, NULL, 'Holliday junction ATP-dependent DNA helicase RuvB [ruvB].', NULL, 'DNA_helic_RuvB', NULL, NULL, 939, 7),
(236553, NULL, 'MF_02230', NULL, NULL, 'Ribose 1,5-bisphosphate isomerase.', NULL, 'R15P_isomerase', NULL, NULL, 11184, 7),
(236554, NULL, 'MF_00519', NULL, NULL, 'L-arabinose isomerase [araA].', NULL, 'Arabinose_Isome', NULL, NULL, 6372, 7),
(236555, NULL, 'MF_01287', NULL, NULL, 'Digeranylgeranylglycerophospholipid reductase.', NULL, 'DGGGPL_reductase', NULL, NULL, 21186, 7),
(236556, NULL, 'MF_00435', NULL, NULL, 'Ketol-acid reductoisomerase (NADP(+)) [ilvC].', NULL, 'IlvC', NULL, NULL, 12939, 7),
(236557, NULL, 'MF_00468', NULL, NULL, 'Sulfate transporter CysZ [cysZ].', NULL, 'CysZ', NULL, NULL, 15052, 7),
(236558, NULL, 'MF_01155', NULL, NULL, 'Chaperone modulatory protein CbpM [cbpM].', NULL, 'CbpM', NULL, NULL, 899, 7),
(236559, NULL, 'MF_01907', NULL, NULL, 'thr operon leader peptide [thrL].', NULL, 'Leader_Thr', NULL, NULL, 10938, 7),
(236560, NULL, 'MF_04148', NULL, NULL, 'Terminase, large subunit.', NULL, 'TERL_BPP22', NULL, NULL, 35439, 7),
(236561, NULL, 'MF_00022', NULL, NULL, 'Glutamate--tRNA ligase [gltX].', NULL, 'Glu_tRNA_synth_type1', NULL, NULL, 1637, 7),
(236562, NULL, 'MF_00529', NULL, NULL, 'Nitrogenase-stabilizing/protective protein NifW [nifW].', NULL, 'NifW', NULL, NULL, 349, 7),
(236563, NULL, 'MF_02132', NULL, NULL, 'AMP phosphorylase.', NULL, 'AMP_phosphorylase', NULL, NULL, 17723, 7),
(236564, NULL, 'MF_00831', NULL, NULL, 'Putative aminoacrylate peracid reductase RutC [rutC].', NULL, 'RutC', NULL, NULL, 14788, 7);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(236565, NULL, 'MF_00781', NULL, NULL, 'DNA-binding transcriptional activator HetR [hetR].', NULL, 'HetR', NULL, NULL, 5482, 7),
(236566, NULL, 'MF_00124', NULL, NULL, 'Thymidine kinase [tdk].', NULL, 'Thymidine_kinase', NULL, NULL, 198, 7),
(236567, NULL, 'MF_01221', NULL, NULL, 'UPF0210 protein <locus_tag>.', NULL, 'UPF0210', NULL, NULL, 2365, 7),
(236568, NULL, 'MF_01852', NULL, NULL, 'Threonylcarbamoyl-AMP synthase [tsaC].', NULL, 'TsaC', NULL, NULL, 16538, 7),
(236569, NULL, 'MF_01902', NULL, NULL, 'Error-prone DNA polymerase [dnaE2].', NULL, 'DNApol_error_prone', NULL, NULL, 15323, 7),
(236570, NULL, 'MF_01626', NULL, NULL, 'Protein ViaA [viaA].', NULL, 'ViaA', NULL, NULL, 16755, 7),
(236571, NULL, 'MF_01147', NULL, NULL, 'Phosphatidylglycerol--prolipoprotein diacylglyceryl transferase [lgt].', NULL, 'Lgt', NULL, NULL, 3232, 7),
(236572, NULL, 'MF_01474', NULL, NULL, '30S ribosomal protein S19e [rps19e].', NULL, 'Ribosomal_S19e', NULL, NULL, 23630, 7),
(236573, NULL, 'MF_01326_B', NULL, NULL, '50S ribosomal protein L24 [rplX].', NULL, 'Ribosomal_L24_B', NULL, NULL, 2995, 7),
(236574, NULL, 'MF_00715', NULL, NULL, 'Protein SlyX [slyX].', NULL, 'SlyX', NULL, NULL, 6627, 7),
(236575, NULL, 'MF_01189', NULL, NULL, 'Purine ribonucleoside efflux pump NepI [nepI].', NULL, 'MFS_NepI', NULL, NULL, 7270, 7),
(236576, NULL, 'MF_00266', NULL, NULL, 'tRNA(Phe) 7-((3-amino-3-carboxypropyl)-4-demethylwyosine(37)-N(4))-methyltransferase [taw3].', NULL, 'TYW3_archaea', NULL, NULL, 17395, 7),
(236577, NULL, 'MF_04205', NULL, NULL, 'Envelope small membrane protein [E].', NULL, 'ALPHA_CORONA_E', NULL, NULL, 34298, 7),
(236578, NULL, 'MF_01574', NULL, NULL, '6-phospho-beta-galactosidase [lacG].', NULL, 'LacG', NULL, NULL, 312, 7),
(236579, NULL, 'MF_01592', NULL, NULL, 'Uncharacterized Nudix hydrolase NudL [nudL].', NULL, 'Nudix_NudL', NULL, NULL, 10219, 7),
(236580, NULL, 'MF_01289', NULL, NULL, 'D-galactonate dehydratase [dgoD].', NULL, 'Galacton_dehydrat', NULL, NULL, 16422, 7),
(236581, NULL, 'MF_04144', NULL, NULL, 'Terminase, large subunit.', NULL, 'TERL_LAMBDA', NULL, NULL, 7639, 7),
(236582, NULL, 'MF_01853', NULL, NULL, 'Protein pelota homolog [pelA].', NULL, 'PelO', NULL, NULL, 16645, 7),
(236583, NULL, 'MF_00595', NULL, NULL, 'Phosphoenolpyruvate carboxylase [ppc].', NULL, 'PEPcase_type1', NULL, NULL, 17257, 7),
(236584, NULL, 'MF_00725', NULL, NULL, 'Flagellar transcriptional regulator FlhD [flhD].', NULL, 'FlhD', NULL, NULL, 10349, 7),
(236585, NULL, 'MF_00782', NULL, NULL, 'Glutathione biosynthesis bifunctional protein GshAB [gshAB].', NULL, 'Glut_biosynth', NULL, NULL, 4710, 7),
(236586, NULL, 'MF_01232', NULL, NULL, 'UPF0229 protein YeaH [yeaH].', NULL, 'UPF0229', NULL, NULL, 2418, 7),
(236587, NULL, 'MF_00410', NULL, NULL, '50S ribosomal protein L31e [rpl31e].', NULL, 'Ribosomal_L31e', NULL, NULL, 2781, 7),
(236588, NULL, 'MF_00820', NULL, NULL, '2,3-diketo-L-gulonate reductase [dlgD].', NULL, 'Diketo_gul_reduc', NULL, NULL, 11568, 7),
(236589, NULL, 'MF_00040', NULL, NULL, 'Ribosome-recycling factor [frr].', NULL, 'RRF', NULL, NULL, 2767, 7),
(236590, NULL, 'MF_03212', NULL, NULL, 'NADPH--cytochrome P450 reductase [POR].', NULL, 'NCPR', NULL, NULL, 15804, 7),
(236591, NULL, 'MF_01553', NULL, NULL, 'DNA-directed RNA polymerase subunit epsilon [rpoY].', NULL, 'RNApol_bact_RpoY', NULL, NULL, 14252, 7),
(236592, NULL, 'MF_01877', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase I [rsmI].', NULL, '16SrRNA_methyltr_I', NULL, NULL, 7184, 7),
(236593, NULL, 'MF_00712', NULL, NULL, 'Probable glycine dehydrogenase (decarboxylating) subunit 1 [gcvPA].', NULL, 'GcvPA', NULL, NULL, 15285, 7),
(236594, NULL, 'MF_01820', NULL, NULL, 'Small ribosomal subunit biogenesis GTPase RsgA [rsgA].', NULL, 'GTPase_RsgA', NULL, NULL, 7245, 7),
(236595, NULL, 'MF_01345_B', NULL, NULL, '30S ribosomal protein S17 [rpsQ].', NULL, 'Ribosomal_S17_B', NULL, NULL, 17291, 7),
(236596, NULL, 'MF_00384', NULL, NULL, 'Homoserine kinase [thrB].', NULL, 'Homoser_kinase', NULL, NULL, 4502, 7),
(236597, NULL, 'MF_02117', NULL, NULL, 'N(2)-fixation sustaining protein CowN [cowN].', NULL, 'CowN', NULL, NULL, 21816, 7);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(236598, NULL, 'MF_04050', NULL, NULL, 'Hexon-interlacing protein [IX].', NULL, 'ADV_CAP9', NULL, NULL, 2677, 7),
(236599, NULL, 'MF_02024', NULL, NULL, 'Lipid III flippase [wzxE].', NULL, 'WzxE', NULL, NULL, 23679, 7),
(236600, NULL, 'MF_02077', NULL, NULL, 'Lipid II flippase Amj [amj].', NULL, 'Amj_flippase', NULL, NULL, 17996, 7),
(236601, NULL, 'MF_02007', NULL, NULL, 'Tyrosine--tRNA ligase [tyrS].', NULL, 'Tyr_tRNA_synth_type2', NULL, NULL, 13128, 7),
(236602, NULL, 'MF_01171', NULL, NULL, 'Arginine N-succinyltransferase [astA].', NULL, 'AstA', NULL, NULL, 6868, 7),
(236603, NULL, 'MF_01935', NULL, NULL, 'Isochorismate synthase MenF [menF].', NULL, 'MenF', NULL, NULL, 7379, 7),
(236604, NULL, 'MF_04043', NULL, NULL, 'Inner tegument protein.', NULL, 'HSV_ITP', NULL, NULL, 29455, 7),
(236605, NULL, 'MF_02112', NULL, NULL, 'Proteasome-associated ATPase [mpa].', NULL, 'ARC_ATPase', NULL, NULL, 16256, 7),
(236606, NULL, 'MF_00200', NULL, NULL, 'RNA 3''-terminal phosphate cyclase [rtcA].', NULL, 'RTC', NULL, NULL, 18934, 7),
(236607, NULL, 'MF_01506', NULL, NULL, 'Small, acid-soluble spore protein Tlp [tlp].', NULL, 'Tlp', NULL, NULL, 14912, 7),
(236608, NULL, 'MF_00958', NULL, NULL, 'Regulator of RpoS [rssB].', NULL, 'RssB', NULL, NULL, 25314, 7),
(236609, NULL, 'MF_00019', NULL, NULL, 'Phosphate acyltransferase [plsX].', NULL, 'PlsX', NULL, NULL, 8475, 7),
(236610, NULL, 'MF_00213', NULL, NULL, 'Hydrogenase maturation factor HypA [hypA].', NULL, 'HypA_HybF', NULL, NULL, 6785, 7),
(236611, NULL, 'MF_01385', NULL, NULL, 'Urease accessory protein UreF [ureF].', NULL, 'UreF', NULL, NULL, 2583, 7),
(236612, NULL, 'MF_04030', NULL, NULL, 'DNA replication helicase [HELI].', NULL, 'HSV_HELI', NULL, NULL, 8298, 7),
(236613, NULL, 'MF_01854', NULL, NULL, 'Fructose-1,6-bisphosphatase class 3 [fbp].', NULL, 'FBPase_class3', NULL, NULL, 9522, 7),
(236614, NULL, 'MF_00614', NULL, NULL, 'Flap endonuclease 1 [fen].', NULL, 'Fen', NULL, NULL, 16212, 7),
(236615, NULL, 'MF_00400', NULL, NULL, 'Multidrug resistance protein MdtK [mdtK].', NULL, 'MdtK', NULL, NULL, 17224, 7),
(236616, NULL, 'MF_01953', NULL, NULL, 'Urease subunit alpha [ureC].', NULL, 'Urease_alpha', NULL, NULL, 5851, 7),
(236617, NULL, 'MF_00570', NULL, NULL, 'Nicotinate phosphoribosyltransferase [pncB].', NULL, 'NAPRTase', NULL, NULL, 5827, 7),
(236618, NULL, 'MF_04089', NULL, NULL, 'Non-structural protein 2.', NULL, 'ROTA_NSP2', NULL, NULL, 1299, 7),
(236619, NULL, 'MF_00300', NULL, NULL, 'Chorismate synthase [aroC].', NULL, 'Chorismate_synth', NULL, NULL, 6508, 7),
(236620, NULL, 'MF_01915', NULL, NULL, 'Lipopolysaccharide export system protein LptC [lptC].', NULL, 'LPS_assembly_LptC', NULL, NULL, 21865, 7),
(236621, NULL, 'MF_00325', NULL, NULL, 'DNA polymerase II small subunit [polB].', NULL, 'DNApol_II_A_arch', NULL, NULL, 10206, 7),
(236622, NULL, 'MF_01250', NULL, NULL, 'Pyrophosphatase PpaX [ppaX].', NULL, 'Pyrophosphat_PpaX', NULL, NULL, 16670, 7),
(236623, NULL, 'MF_02082', NULL, NULL, '[LysW]-aminoadipate/[LysW]-glutamate kinase [lysZ].', NULL, 'LysZ', NULL, NULL, 28649, 7),
(236624, NULL, 'MF_01350', NULL, NULL, 'NAD(P)H-quinone oxidoreductase subunit 1, chloroplastic [ndhA].', NULL, 'NDH1_NuoH', NULL, NULL, 3295, 7),
(236625, NULL, 'MF_01369_B', NULL, NULL, '50S ribosomal protein L23 [rplW].', NULL, 'Ribosomal_L23_B', NULL, NULL, 11244, 7),
(236626, NULL, 'MF_00052_A', NULL, NULL, 'Ribonuclease HII [rnhB].', NULL, 'RNase_HII_A', NULL, NULL, 19420, 7),
(236627, NULL, 'MF_02106', NULL, NULL, 'Prokaryotic ubiquitin-like protein Pup [pup].', NULL, 'Pup', NULL, NULL, 12747, 7),
(236628, NULL, 'MF_02047', NULL, NULL, '6-phosphogluconate dehydrogenase, NAD(+)-dependent, decarboxylating.', NULL, '6PGDH_archaea', NULL, NULL, 25056, 7),
(236629, NULL, 'MF_00857', NULL, NULL, 'Cell division protein DrpB [drpB].', NULL, 'DrpB', NULL, NULL, 34611, 7),
(236630, NULL, 'MF_00784', NULL, NULL, 'Accessory gene regulator protein B [agrB].', NULL, 'AgrB', NULL, NULL, 2511, 7),
(236631, NULL, 'MF_01964', NULL, NULL, 'Inosine-5''-monophosphate dehydrogenase [guaB].', NULL, 'IMPDH', NULL, NULL, 1005, 7);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(236632, NULL, 'MF_00422', NULL, NULL, 'Protein translocase subunit SecE [secE].', NULL, 'SecE', NULL, NULL, 2105, 7),
(236633, NULL, 'MF_00992', NULL, NULL, 'Cyclic dehypoxanthine futalosine synthase [mqnC].', NULL, 'MqnC', NULL, NULL, 15775, 7),
(236634, NULL, 'MF_01225_B', NULL, NULL, 'GTP 3'',8-cyclase [moaA].', NULL, 'MoaA_B', NULL, NULL, 10365, 7),
(236635, NULL, 'MF_01297', NULL, NULL, 'Peroxynitrite isomerase.', NULL, 'nitrobindin', NULL, NULL, 14753, 7),
(236636, NULL, 'MF_02085', NULL, NULL, 'UTP--glucose-1-phosphate uridylyltransferase [cugP].', NULL, 'CugP_cyano', NULL, NULL, 33051, 7),
(236637, NULL, 'MF_04155', NULL, NULL, 'DnaB-like replicative helicase [41].', NULL, 'Helic_T4', NULL, NULL, 33734, 7),
(236638, NULL, 'MF_01218_A', NULL, NULL, 'Uracil phosphoribosyltransferase [upp].', NULL, 'Upp_A', NULL, NULL, 32151, 7),
(236639, NULL, 'MF_00665', NULL, NULL, 'Small, acid-soluble spore protein O [sspO].', NULL, 'SspO', NULL, NULL, 9707, 7),
(236640, NULL, 'MF_01249', NULL, NULL, 'HPr kinase/phosphorylase [hprK].', NULL, 'HPr_kinase', NULL, NULL, 6246, 7),
(236641, NULL, 'MF_01850', NULL, NULL, 'tRNA-cytidine(32) 2-sulfurtransferase [ttcA].', NULL, 'TtcA', NULL, NULL, 12770, 7),
(236642, NULL, 'MF_02015', NULL, NULL, 'Nucleoid occlusion protein [noc].', NULL, 'ParB_Noc', NULL, NULL, 16203, 7),
(236643, NULL, 'MF_02092', NULL, NULL, 'Quinone-dependent D-lactate dehydrogenase [dld].', NULL, 'DLDH_Dld', NULL, NULL, 11760, 7),
(236644, NULL, 'MF_01883', NULL, NULL, '2-(5''''-triphosphoribosyl)-3''-dephosphocoenzyme-A synthase [mdcB].', NULL, 'MdcB', NULL, NULL, 14610, 7),
(236645, NULL, 'MF_01842', NULL, NULL, 'Archaemetzincin [amzA].', NULL, 'Archaemetzincin', NULL, NULL, 12627, 7),
(236646, NULL, 'MF_04079', NULL, NULL, 'Protein Tat [tat].', NULL, 'HIV_TAT', NULL, NULL, 4441, 7),
(236647, NULL, 'MF_00086', NULL, NULL, 'S-adenosylmethionine synthase [metK].', NULL, 'S_AdoMet_synth1', NULL, NULL, 5293, 7),
(236648, NULL, 'MF_00621', NULL, NULL, 'GTP-sensing transcriptional pleiotropic repressor CodY [codY].', NULL, 'HTH_type_CodY', NULL, NULL, 14459, 7),
(236649, NULL, 'MF_01356', NULL, NULL, 'NAD(P)H-quinone oxidoreductase subunit K, chloroplastic [ndhK].', NULL, 'NDH1_NuoB', NULL, NULL, 10454, 7),
(236650, NULL, 'MF_01979', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase [pfp].', NULL, 'Phosphofructokinase_II_Short', NULL, NULL, 7508, 7),
(236651, NULL, 'MF_01976', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase [pfp].', NULL, 'Phosphofructokinase_III', NULL, NULL, 12951, 7),
(236652, NULL, 'MF_01129', NULL, NULL, 'Putative K(+)-stimulated pyrophosphate-energized sodium pump [hppA].', NULL, 'PPase_energized_pump', NULL, NULL, 2515, 7),
(236653, NULL, 'MF_04022', NULL, NULL, 'Small capsomere-interacting protein [SCP].', NULL, 'HSV_SCP_gammahv', NULL, NULL, 13638, 7),
(236654, NULL, 'MF_03117', NULL, NULL, 'Enolase-phosphatase E1 [ENOPH1].', NULL, 'Salvage_MtnC_euk', NULL, NULL, 23232, 7),
(236655, NULL, 'MF_01433', NULL, NULL, 'Pyrimidine-specific ribonucleoside hydrolase RihB [rihB].', NULL, 'Pyrim_hydro_RihB', NULL, NULL, 14509, 7),
(236656, NULL, 'MF_01904', NULL, NULL, 'Phosphoenolpyruvate carboxylase [ppcA].', NULL, 'PEPcase_type2', NULL, NULL, 1687, 7),
(236657, NULL, 'MF_00251', NULL, NULL, '50S ribosomal protein L36 [rpmJ].', NULL, 'Ribosomal_L36', NULL, NULL, 6769, 7),
(236658, NULL, 'MF_02208', NULL, NULL, 'UDP-N-acetylmuramoyl-L-alanine--L-glutamate ligase [murD2].', NULL, 'MurD2_subfam', NULL, NULL, 34842, 7),
(236659, NULL, 'MF_04082', NULL, NULL, 'Protein Vpu [vpu].', NULL, 'HIV_VPU', NULL, NULL, 7289, 7),
(236660, NULL, 'MF_01641', NULL, NULL, 'UPF0509 protein YciZ [yciZ].', NULL, 'UPF0509', NULL, NULL, 20763, 7),
(236661, NULL, 'MF_01209', NULL, NULL, 'Carbamoyl-phosphate synthase small chain [carA].', NULL, 'CPSase_S_chain', NULL, NULL, 3551, 7),
(236662, NULL, 'MF_01312', NULL, NULL, 'Anaerobic nitric oxide reductase flavorubredoxin [norV].', NULL, 'NorV', NULL, NULL, 20060, 7),
(236663, NULL, 'MF_00245', NULL, NULL, 'UPF0122 protein <locus_tag>.', NULL, 'UPF0122', NULL, NULL, 3795, 7); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(236664, NULL, 'MF_03039', NULL, NULL, 'Cytosolic Fe-S cluster assembly factor NUBP2 [NUBP2].', NULL, 'NUBP2', NULL, NULL, 26471, 7),
(236665, NULL, 'MF_00356', NULL, NULL, 'DNA polymerase III PolC-type [polC].', NULL, 'DNApol_PolC', NULL, NULL, 4956, 7),
(236666, NULL, 'MF_00584', NULL, NULL, 'Putative HTH-type transcriptional regulatory protein <locus_tag>.', NULL, 'HTH_type_cro_C1', NULL, NULL, 20664, 7),
(236667, NULL, 'MF_01213', NULL, NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase-like protein.', NULL, 'dGTPase_type3', NULL, NULL, 15154, 7),
(236668, NULL, 'MF_00010', NULL, NULL, 'UPF0060 membrane protein YnfA [ynfA].', NULL, 'UPF0060', NULL, NULL, 3360, 7),
(236669, NULL, 'MF_00471', NULL, NULL, 'Regulator of ribonuclease activity A [rraA].', NULL, 'RraA', NULL, NULL, 10119, 7),
(236670, NULL, 'MF_01466', NULL, NULL, 'Accessory Sec system protein translocase subunit SecY2 [secY2].', NULL, 'SecY2', NULL, NULL, 11237, 7),
(236671, NULL, 'MF_01845', NULL, NULL, 'UPF0597 protein YhaM [yhaM].', NULL, 'UPF0597', NULL, NULL, 15467, 7),
(236672, NULL, 'MF_00918', NULL, NULL, 'Probable transcriptional regulatory protein YeeN [yeeN].', NULL, 'Transcrip_reg_TACO1_YeeN', NULL, NULL, 24304, 7),
(236673, NULL, 'MF_00660', NULL, NULL, 'PqqA peptide cyclase [pqqE].', NULL, 'PqqE', NULL, NULL, 13521, 7),
(236674, NULL, 'MF_00403_A', NULL, NULL, '30S ribosomal protein S12 [rpsL].', NULL, 'Ribosomal_S12_A', NULL, NULL, 16924, 7),
(236675, NULL, 'MF_01674', NULL, NULL, 'O-phosphoserine--tRNA(Cys) ligase [sepS].', NULL, 'Sep_tRNA_synth', NULL, NULL, 11061, 7),
(236676, NULL, 'MF_01153', NULL, NULL, 'Co-chaperone protein DjlA [djlA].', NULL, 'DjlA', NULL, NULL, 16552, 7),
(236677, NULL, 'MF_00926', NULL, NULL, 'RNA polymerase-binding transcription factor DksA [dksA].', NULL, 'DksA', NULL, NULL, 9657, 7),
(236678, NULL, 'MF_01363', NULL, NULL, '50S ribosomal protein L21 [rplU].', NULL, 'Ribosomal_L21', NULL, NULL, 4280, 7),
(236679, NULL, 'MF_00424', NULL, NULL, 'Peptide chain release factor subunit 1 [prf1].', NULL, 'Rel_fact_arch_1', NULL, NULL, 14837, 7),
(236680, NULL, 'MF_01528', NULL, NULL, 'Multidrug resistance protein MdtG [mdtG].', NULL, 'MFS_MdtG', NULL, NULL, 7387, 7),
(236681, NULL, 'MF_00352', NULL, NULL, 'Light-independent protochlorophyllide reductase subunit N [bchN].', NULL, 'ChlN_BchN', NULL, NULL, 1134, 7),
(236682, NULL, 'MF_01084', NULL, NULL, 'Diphthine synthase [dphB].', NULL, 'Diphthine_synth', NULL, NULL, 977, 7),
(236683, NULL, 'MF_00375', NULL, NULL, 'Glutamate-1-semialdehyde 2,1-aminomutase [hemL].', NULL, 'HemL_aminotrans_3', NULL, NULL, 2306, 7),
(236684, NULL, 'MF_01451', NULL, NULL, 'ATP-dependent helicase/nuclease subunit A [addA].', NULL, 'AddA', NULL, NULL, 14223, 7),
(236685, NULL, 'MF_00999', NULL, NULL, 'Sulfofructose kinase.', NULL, 'SF_kinase', NULL, NULL, 24159, 7),
(236686, NULL, 'MF_00442', NULL, NULL, 'ATP-dependent DNA helicase Hel308 [hel308].', NULL, 'Helicase_Hel308', NULL, NULL, 16436, 7),
(236687, NULL, 'MF_00724', NULL, NULL, 'Flagellar hook-basal body complex protein FliE [fliE].', NULL, 'FliE', NULL, NULL, 3094, 7),
(236688, NULL, 'MF_01695', NULL, NULL, 'D-inositol-3-phosphate glycosyltransferase [mshA].', NULL, 'MshA', NULL, NULL, 19355, 7),
(236689, NULL, 'MF_01589', NULL, NULL, 'Carboxy-S-adenosyl-L-methionine synthase [cmoA].', NULL, 'Cx_SAM_synthase', NULL, NULL, 4131, 7),
(236690, NULL, 'MF_00687', NULL, NULL, '4-deoxy-L-threo-5-hexosulose-uronate ketol-isomerase [kduI].', NULL, 'KduI', NULL, NULL, 6661, 7),
(236691, NULL, 'MF_02021', NULL, NULL, 'Cell division protein DamX [damX].', NULL, 'DamX', NULL, NULL, 24441, 7),
(236692, NULL, 'MF_01635', NULL, NULL, '4-hydroxybenzoate octaprenyltransferase [ubiA].', NULL, 'UbiA', NULL, NULL, 5847, 7),
(236693, NULL, 'MF_00851', NULL, NULL, 'Leader peptide SpeFL [speFL].', NULL, 'Leader_SpeFL', NULL, NULL, 17917, 7),
(236694, NULL, 'MF_00548', NULL, NULL, 'Zinc transporter ZupT [zupT].', NULL, 'ZupT', NULL, NULL, 16382, 7),
(236695, NULL, 'MF_02105', NULL, NULL, 'Lactate utilization protein A [lutA].', NULL, 'LutA', NULL, NULL, 17259, 7);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(236696, NULL, 'MF_01513', NULL, NULL, 'Putative phenylalanine aminotransferase [pat].', NULL, 'Phe_aminotrans_2', NULL, NULL, 17911, 7),
(236697, NULL, 'MF_01937', NULL, NULL, '1,4-dihydroxy-2-naphthoate octaprenyltransferase [menA].', NULL, 'MenA_1', NULL, NULL, 2998, 7),
(236698, NULL, 'MF_00933', NULL, NULL, 'Arylsulfate sulfotransferase AssT [assT].', NULL, 'Arylsulfotrans_AssT', NULL, NULL, 24199, 7),
(236699, NULL, 'MF_00846', NULL, NULL, 'Ribosome protection protein VmlR [vmlR].', NULL, 'VmlR', NULL, NULL, 34518, 7),
(236700, NULL, 'MF_02201', NULL, NULL, 'Ferredoxin-type protein NapF [napF].', NULL, 'NapF', NULL, NULL, 1870, 7),
(236701, NULL, 'MF_00901', NULL, NULL, '3''-5'' ssDNA/RNA exonuclease TatD [tatD].', NULL, 'TatD_exonuclease', NULL, NULL, 14654, 7),
(236702, NULL, 'MF_01390', NULL, NULL, 'Maturase K [matK].', NULL, 'MatK', NULL, NULL, 5508, 7),
(236703, NULL, 'MF_00598', NULL, NULL, 'Protein Smg [smg].', NULL, 'Smg', NULL, NULL, 4653, 7),
(236704, NULL, 'MF_01831', NULL, NULL, 'Cysteine desulfurase [sufS].', NULL, 'SufS_aminotrans_5', NULL, NULL, 2389, 7),
(236705, NULL, 'MF_01415', NULL, NULL, 'Glutathione-regulated potassium-efflux system ancillary protein KefG [kefG].', NULL, 'K_H_efflux_KefG', NULL, NULL, 8352, 7),
(236706, NULL, 'MF_01207', NULL, NULL, 'Protein-methionine-sulfoxide reductase heme-binding subunit MsrQ [msrQ].', NULL, 'MsrQ', NULL, NULL, 836, 7),
(236707, NULL, 'MF_01949', NULL, NULL, 'O-acetyltransferase WecH [wecH].', NULL, 'Acetyltr_WecH', NULL, NULL, 24226, 7),
(236708, NULL, 'MF_00682', NULL, NULL, 'Co-chaperone protein HscB [hscB].', NULL, 'HscB', NULL, NULL, 2252, 7),
(236709, NULL, 'MF_01678', NULL, NULL, 'Putative methylthioribose-1-phosphate isomerase [mtnA].', NULL, 'Salvage_MtnA', NULL, NULL, 11351, 7),
(236710, NULL, 'MF_00568', NULL, NULL, 'Quinolinate synthase A [nadA].', NULL, 'NadA_type2', NULL, NULL, 15474, 7),
(236711, NULL, 'MF_00032', NULL, NULL, 'Translation initiation factor 6 [eif6].', NULL, 'eIF_6', NULL, NULL, 4654, 7),
(236712, NULL, 'MF_01886', NULL, NULL, 'tRNA(Met) cytidine acetyltransferase TmcA [tmcA].', NULL, 'tRNA_acetyltr_TmcA', NULL, NULL, 14716, 7),
(236713, NULL, 'MF_00080', NULL, NULL, 'Translation initiation factor IF-3 [infC].', NULL, 'IF_3', NULL, NULL, 373, 7),
(236714, NULL, 'MF_01278', NULL, NULL, 'Type-2 serine--tRNA ligase [serS].', NULL, 'Ser_tRNA_synth_type2', NULL, NULL, 1634, 7),
(236715, NULL, 'MF_01484', NULL, NULL, 'Multidrug efflux pump accessory protein AcrZ [acrZ].', NULL, 'AcrZ', NULL, NULL, 20211, 7),
(236716, NULL, 'MF_01945', NULL, NULL, 'Lipid A 1-diphosphate synthase [lpxT].', NULL, 'Lipid_A_LpxT', NULL, NULL, 24094, 7),
(236717, NULL, 'MF_01266', NULL, NULL, 'Probable L-ascorbate-6-phosphate lactonase UlaG [ulaG].', NULL, 'UlaG', NULL, NULL, 19565, 7),
(236718, NULL, 'MF_01498', NULL, NULL, 'DNA repair protein RadA [radA].', NULL, 'RadA_bact', NULL, NULL, 1831, 7),
(236719, NULL, 'MF_01373', NULL, NULL, 'Lipoprotein LpqB [lpqB].', NULL, 'LpqB_lipoprot', NULL, NULL, 8147, 7),
(236720, NULL, 'MF_01220_A', NULL, NULL, 'Uridylate kinase [pyrH].', NULL, 'PyrH_A', NULL, NULL, 13252, 7),
(236721, NULL, 'MF_00630', NULL, NULL, 'UPF0232 protein <locus_tag>.', NULL, 'UPF0232', NULL, NULL, 15241, 7),
(236722, NULL, 'MF_00260', NULL, NULL, 'Porphobilinogen deaminase [hemC].', NULL, 'Porphobil_deam', NULL, NULL, 3144, 7),
(236723, NULL, 'MF_00275', NULL, NULL, 'Potassium-transporting ATPase potassium-binding subunit [kdpA].', NULL, 'KdpA', NULL, NULL, 2414, 7),
(236724, NULL, 'MF_02222', NULL, NULL, 'Homocitrate synthase.', NULL, 'Homocitr_synth_fung_arch', NULL, NULL, 14228, 7),
(236725, NULL, 'MF_00125', NULL, NULL, 'ATP phosphoribosyltransferase regulatory subunit [hisZ].', NULL, 'HisZ', NULL, NULL, 1583, 7),
(236726, NULL, 'MF_01944', NULL, NULL, 'Lipid A biosynthesis myristoyltransferase [lpxM].', NULL, 'Lipid_A_LpxM', NULL, NULL, 11415, 7),
(236727, NULL, 'MF_03114', NULL, NULL, 'Golgi to ER traffic protein 2 [GET2].', NULL, 'Get2', NULL, NULL, 11690, 7),
(236728, NULL, 'MF_00604', NULL, NULL, 'Protein translation factor SUI1 homolog.', NULL, 'SUI1', NULL, NULL, 15857, 7);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(236729, NULL, 'MF_01264', NULL, NULL, 'CCA-adding enzyme [cca].', NULL, 'CCA_arch', NULL, NULL, 673, 7),
(236730, NULL, 'MF_01637', NULL, NULL, 'Fe/S biogenesis protein NfuA [nfuA].', NULL, 'Fe_S_biogen_NfuA', NULL, NULL, 18160, 7),
(236731, NULL, 'MF_02214', NULL, NULL, 'Lipid II isoglutaminyl synthase (glutamine-hydrolyzing) subunit MurT [murT].', NULL, 'Lipid_II_synth_MurT', NULL, NULL, 35088, 7),
(236732, NULL, 'MF_00011', NULL, NULL, 'Adenylosuccinate synthetase [purA].', NULL, 'Adenylosucc_synth', NULL, NULL, 1412, 7),
(236733, NULL, 'MF_04055', NULL, NULL, 'DNA polymerase [POL].', NULL, 'ADV_DPOL', NULL, NULL, 12355, 7),
(236734, NULL, 'MF_00651', NULL, NULL, 'Putative pre-16S rRNA nuclease [yqgF].', NULL, 'Nuclease_YqgF', NULL, NULL, 11163, 7),
(236735, NULL, 'MF_00679', NULL, NULL, 'Chaperone protein HscA [hscA].', NULL, 'HscA', NULL, NULL, 4126, 7),
(236736, NULL, 'MF_01616', NULL, NULL, 'Membrane-bound lytic murein transglycosylase C [mltC].', NULL, 'MltC', NULL, NULL, 16359, 7),
(236737, NULL, 'MF_01989', NULL, NULL, 'Cyanuric acid amidohydrolase.', NULL, 'Cyc_amidohydrol', NULL, NULL, 14274, 7),
(236738, NULL, 'MF_01302_B', NULL, NULL, '30S ribosomal protein S8 [rpsH].', NULL, 'Ribosomal_S8_B', NULL, NULL, 5531, 7),
(236739, NULL, 'MF_00202', NULL, NULL, 'Isopentenyl-diphosphate Delta-isomerase [idi].', NULL, 'Idi', NULL, NULL, 14121, 7),
(236740, NULL, 'MF_03201', NULL, NULL, 'Elongation of very long chain fatty acids protein 1 [ELOVL1].', NULL, 'VLCF_elongase_1', NULL, NULL, 29872, 7),
(236741, NULL, 'MF_00942', NULL, NULL, 'Endonuclease III [nth].', NULL, 'Nth', NULL, NULL, 4783, 7),
(236742, NULL, 'MF_01320_B', NULL, NULL, '50S ribosomal protein L2 [rplB].', NULL, 'Ribosomal_L2_B', NULL, NULL, 6859, 7),
(236743, NULL, 'MF_01578', NULL, NULL, 'Quinate/shikimate dehydrogenase [ydiB].', NULL, 'Shikimate_DH_YdiB', NULL, NULL, 17001, 7),
(236744, NULL, 'MF_01610', NULL, NULL, 'Probable L-tyrosine/L-aspartate decarboxylase [mfnA].', NULL, 'MfnA_decarbox', NULL, NULL, 14811, 7),
(236745, NULL, 'MF_00908', NULL, NULL, 'Negative modulator of initiation of replication [seqA].', NULL, 'SeqA', NULL, NULL, 2902, 7),
(236746, NULL, 'MF_00152', NULL, NULL, 'Probable endonuclease 4 [nfo].', NULL, 'Nfo', NULL, NULL, 3499, 7),
(236747, NULL, 'MF_02226', NULL, NULL, 'D-allulose-6-phosphate 3-epimerase [alsE].', NULL, 'AlluloseP_3_epimer', NULL, NULL, 35232, 7),
(236748, NULL, 'MF_01280', NULL, NULL, 'Processive diacylglycerol beta-glucosyltransferase [ugtP].', NULL, 'Diacylglyc_glucosyltr', NULL, NULL, 17020, 7),
(236749, NULL, 'MF_00514', NULL, NULL, '50S ribosomal protein L35 [rpmI].', NULL, 'Ribosomal_L35', NULL, NULL, 3300, 7),
(236750, NULL, 'MF_04002', NULL, NULL, 'Major capsid protein L1 [L1].', NULL, 'PPV_L1', NULL, NULL, 239, 7),
(236751, NULL, 'MF_04000', NULL, NULL, 'Replication protein E1 [E1].', NULL, 'PPV_E1', NULL, NULL, 21114, 7),
(236752, NULL, 'MF_01045', NULL, NULL, 'D-cysteine desulfhydrase [dcyD].', NULL, 'D_Cys_desulfhydr', NULL, NULL, 16820, 7),
(236753, NULL, 'MF_00909', NULL, NULL, 'Cell division protein FtsZ [ftsZ].', NULL, 'FtsZ', NULL, NULL, 1534, 7),
(236754, NULL, 'MF_01545', NULL, NULL, 'p-hydroxybenzoic acid efflux pump subunit AaeB [aaeB].', NULL, 'AaeB', NULL, NULL, 7266, 7),
(236755, NULL, 'MF_00545', NULL, NULL, '30S ribosomal protein S24e [rps24e].', NULL, 'Ribosomal_S24e', NULL, NULL, 2417, 7),
(236756, NULL, 'MF_00956', NULL, NULL, 'GDP-L-fucose synthase [fcl].', NULL, 'GDP_fucose_synth', NULL, NULL, 25024, 7),
(236757, NULL, 'MF_01158', NULL, NULL, 'DnaA regulatory inactivator Hda [hda].', NULL, 'Hda', NULL, NULL, 17166, 7),
(236758, NULL, 'MF_01878', NULL, NULL, 'Dipeptide and tripeptide permease A [dtpA].', NULL, 'PTR2_DtpA_subfam', NULL, NULL, 16705, 7),
(236759, NULL, 'MF_04159', NULL, NULL, 'Protein spackle [sp].', NULL, 'SPACKLE_T4', NULL, NULL, 37666, 7),
(236760, NULL, 'MF_01689', NULL, NULL, 'Ornithine aminotransferase [rocD].', NULL, 'Ornith_aminotrans_3', NULL, NULL, 29365, 7),
(236761, NULL, 'MF_00049_A', NULL, NULL, 'Leucine--tRNA ligase [leuS].', NULL, 'Leu_tRNA_synth_A', NULL, NULL, 20966, 7);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(236762, NULL, 'MF_00508', NULL, NULL, '30S ribosomal protein S10 [rpsJ].', NULL, 'Ribosomal_S10', NULL, NULL, 4264, 7),
(236763, NULL, 'MF_01231', NULL, NULL, 'Haloalkane dehalogenase [dhaA].', NULL, 'Haloalk_dehal_type2', NULL, NULL, 16172, 7),
(236764, NULL, 'MF_01302_A', NULL, NULL, '30S ribosomal protein S8 [rpsH].', NULL, 'Ribosomal_S8_A', NULL, NULL, 5531, 7),
(236765, NULL, 'MF_00308', NULL, NULL, 'Prefoldin subunit alpha [pfdA].', NULL, 'PfdA', NULL, NULL, 10037, 7),
(236766, NULL, 'MF_01920', NULL, NULL, 'ATP-dependent DNA helicase Rep [rep].', NULL, 'Helicase_Rep', NULL, NULL, 4842, 7),
(236767, NULL, 'MF_04014', NULL, NULL, 'Tripartite terminase subunit 1 [TRM1].', NULL, 'HSV_TRM1', NULL, NULL, 4293, 7),
(236768, NULL, 'MF_01458', NULL, NULL, 'ATP-dependent zinc metalloprotease FtsH [ftsH].', NULL, 'FtsH', NULL, NULL, 448, 7),
(236769, NULL, 'MF_00680', NULL, NULL, 'UPF0263 protein YciU [yciU].', NULL, 'UPF0263', NULL, NULL, 5843, 7),
(236770, NULL, 'MF_01916', NULL, NULL, 'Cardiolipin synthase.', NULL, 'Cardiolipin_synth_Cls', NULL, NULL, 23851, 7),
(236771, NULL, 'MF_01236', NULL, NULL, 'HTH-type transcriptional repressor NanR [nanR].', NULL, 'HTH_NanR', NULL, NULL, 16719, 7),
(236772, NULL, 'MF_01885', NULL, NULL, 'tRNA (cytidine(34)-2''-O)-methyltransferase [trmL].', NULL, 'tRNA_methyltr_TrmL', NULL, NULL, 17296, 7),
(236773, NULL, 'MF_00110', NULL, NULL, '3-dehydroquinate synthase [aroB].', NULL, 'DHQ_synthase', NULL, NULL, 17459, 7),
(236774, NULL, 'MF_01205', NULL, NULL, 'O-acetyl-ADP-ribose deacetylase [ymdB].', NULL, 'YmdB', NULL, NULL, 22366, 7),
(236775, NULL, 'MF_00157', NULL, NULL, 'Ribonuclease T [rnt].', NULL, 'RNase_T', NULL, NULL, 1039, 7),
(236776, NULL, 'MF_00739', NULL, NULL, 'Urease subunit gamma [ureA].', NULL, 'Urease_gamma', NULL, NULL, 10548, 7),
(236777, NULL, 'MF_01930', NULL, NULL, 'Phosphoribosylglycinamide formyltransferase [purN].', NULL, 'PurN', NULL, NULL, 957, 7),
(236778, NULL, 'MF_01490', NULL, NULL, 'Holliday junction resolvase Hjc [hjc].', NULL, 'HJ_Resolv_Hjc', NULL, NULL, 7574, 7),
(236779, NULL, 'MF_00523', NULL, NULL, 'UDP-3-O-(3-hydroxymyristoyl)glucosamine N-acyltransferase [lpxD].', NULL, 'LpxD', NULL, NULL, 1402, 7),
(236780, NULL, 'MF_00335', NULL, NULL, 'Ribonuclease Y [rny].', NULL, 'RNase_Y', NULL, NULL, 17848, 7),
(236781, NULL, 'MF_01924', NULL, NULL, 'D-alanyl-D-alanine dipeptidase [ddpX].', NULL, 'A_A_dipeptidase', NULL, NULL, 6750, 7),
(236782, NULL, 'MF_00101', NULL, NULL, 'Holo-[acyl-carrier-protein] synthase [acpS].', NULL, 'AcpS', NULL, NULL, 1707, 7),
(236783, NULL, 'MF_00137', NULL, NULL, 'Phosphoribosylaminoimidazole-succinocarboxamide synthase [purC].', NULL, 'SAICAR_synth', NULL, NULL, 22083, 7),
(236784, NULL, 'MF_04108', NULL, NULL, 'Holin.', NULL, 'HOLIN_T7', NULL, NULL, 20435, 7),
(236785, NULL, 'MF_00588', NULL, NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit E [gatE].', NULL, 'GatE', NULL, NULL, 7381, 7),
(236786, NULL, 'MF_00285', NULL, NULL, 'Potassium-transporting ATPase ATP-binding subunit [kdpB].', NULL, 'KdpB', NULL, NULL, 5958, 7),
(236787, NULL, 'MF_00714', NULL, NULL, 'Alkylmercury lyase [merB].', NULL, 'MerB', NULL, NULL, 1675, 7),
(236788, NULL, 'MF_04118', NULL, NULL, 'Internal virion protein gp14.', NULL, 'GP14_T7', NULL, NULL, 32657, 7),
(236789, NULL, 'MF_01819', NULL, NULL, 'Transcriptional regulator SlyA [slyA].', NULL, 'HTH_type_SlyA', NULL, NULL, 15092, 7),
(236790, NULL, 'MF_01332', NULL, NULL, 'Secretion monitor [secM].', NULL, 'SecM', NULL, NULL, 9009, 7),
(236791, NULL, 'MF_00635', NULL, NULL, 'Probable deoxyuridine 5''-triphosphate nucleotidohydrolase [dut].', NULL, 'dUTPase_arch', NULL, NULL, 16151, 7),
(236792, NULL, 'MF_01505', NULL, NULL, 'Small, acid-soluble spore protein N [sspN].', NULL, 'SspN', NULL, NULL, 9769, 7),
(236793, NULL, 'MF_01145', NULL, NULL, 'Foldase protein PrsA [prsA].', NULL, 'Foldase_PrsA', NULL, NULL, 15333, 7),
(236794, NULL, 'MF_03112', NULL, NULL, 'ATPase <gene_name> [GET3].', NULL, 'Asna1_Get3', NULL, NULL, 26799, 7),
(236795, NULL, 'MF_01151', NULL, NULL, 'Protein GrpE [grpE].', NULL, 'GrpE', NULL, NULL, 3633, 7);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(236796, NULL, 'MF_00312', NULL, NULL, 'V-type ATP synthase subunit F [atpF].', NULL, 'ATP_synth_F_arch', NULL, NULL, 14660, 7),
(236797, NULL, 'MF_00699', NULL, NULL, 'Probable Brix domain-containing ribosomal biogenesis protein.', NULL, 'BriX', NULL, NULL, 16667, 7),
(236798, NULL, 'MF_01283', NULL, NULL, 'Riboflavin biosynthesis protein RibBA [ribBA].', NULL, 'RibBA', NULL, NULL, 19959, 7),
(236799, NULL, 'MF_00173', NULL, NULL, 'Arginine repressor [argR].', NULL, 'Arg_repressor', NULL, NULL, 5143, 7),
(236800, NULL, 'MF_00793', NULL, NULL, 'Phycoerythrobilin:ferredoxin oxidoreductase [pebB].', NULL, 'PebB', NULL, NULL, 17223, 7),
(236801, NULL, 'MF_01414', NULL, NULL, 'Glutathione-regulated potassium-efflux system ancillary protein KefF [kefF].', NULL, 'K_H_efflux_KefF', NULL, NULL, 8031, 7),
(236802, NULL, 'MF_01512', NULL, NULL, 'Metallothiol transferase FosB [fosB].', NULL, 'FosB', NULL, NULL, 17306, 7),
(236803, NULL, 'MF_02122', NULL, NULL, '2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-succinyltransferase [dapD].', NULL, 'DapD_type2', NULL, NULL, 22859, 7),
(236804, NULL, 'MF_01686', NULL, NULL, 'Putative thymidylate synthase [thyA].', NULL, 'Thymidy_synth_arch', NULL, NULL, 9975, 7),
(236805, NULL, 'MF_03052', NULL, NULL, 'Molybdopterin synthase catalytic subunit [cnxH].', NULL, 'MOC2B', NULL, NULL, 23698, 7),
(236806, NULL, 'MF_01482', NULL, NULL, 'Mycothiol S-conjugate amidase [mca].', NULL, 'Mca', NULL, NULL, 19006, 7),
(236807, NULL, 'MF_01851', NULL, NULL, 'UPF0637 protein <locus_tag>.', NULL, 'UPF0637', NULL, NULL, 8436, 7),
(236808, NULL, 'MF_00463', NULL, NULL, 'Ion-translocating oxidoreductase complex subunit B [rsxB].', NULL, 'RsxB_RnfB', NULL, NULL, 4464, 7),
(236809, NULL, 'MF_00613', NULL, NULL, 'Photosystem I reaction center subunit IV [psaE].', NULL, 'PSI_PsaE', NULL, NULL, 4320, 7),
(236810, NULL, 'MF_00237', NULL, NULL, 'Sec-independent protein translocase protein TatB [tatB].', NULL, 'TatB', NULL, NULL, 16798, 7),
(236811, NULL, 'MF_01181', NULL, NULL, 'Regulator of sigma D [rsd].', NULL, 'Rsd', NULL, NULL, 16917, 7),
(236812, NULL, 'MF_00209', NULL, NULL, 'Inorganic pyrophosphatase [ppa].', NULL, 'Inorganic_PPase', NULL, NULL, 7463, 7),
(236813, NULL, 'MF_00175', NULL, NULL, 'ATP-dependent Clp protease ATP-binding subunit ClpX [clpX].', NULL, 'ClpX', NULL, NULL, 37673, 7),
(236814, NULL, 'MF_01353', NULL, NULL, 'NAD(P)H-quinone oxidoreductase subunit N [ndhN].', NULL, 'NDH1_NDH1N', NULL, NULL, 21380, 7),
(236815, NULL, 'MF_00311', NULL, NULL, 'V-type proton ATPase subunit E [atpE].', NULL, 'ATP_synth_E_arch', NULL, NULL, 5423, 7),
(236816, NULL, 'MF_01607', NULL, NULL, 'HTH-type transcriptional regulator YidZ [yidZ].', NULL, 'HTH_type_YidZ', NULL, NULL, 10995, 7),
(236817, NULL, 'MF_03204', NULL, NULL, 'Elongation of very long chain fatty acids protein 4 [ELOVL4].', NULL, 'VLCF_elongase_4', NULL, NULL, 29889, 7),
(236818, NULL, 'MF_00340', NULL, NULL, '50S ribosomal protein L32 [rpmF].', NULL, 'Ribosomal_L32', NULL, NULL, 2512, 7),
(236819, NULL, 'MF_00852', NULL, NULL, '(S)-8-amino-7-oxononanoate synthase BioU [bioU].', NULL, 'BioU', NULL, NULL, 34996, 7),
(236820, NULL, 'MF_00989', NULL, NULL, 'L-ribulose-5-phosphate 4-epimerase [araD].', NULL, 'AraD_entero', NULL, NULL, 32910, 7),
(236821, NULL, 'MF_01537', NULL, NULL, 'Pyrimidine/purine nucleoside phosphorylase [ppnP].', NULL, 'Nucleos_phosphorylase_PpnP', NULL, NULL, 11528, 7),
(236822, NULL, 'MF_03021', NULL, NULL, 'Spastin [SPAST].', NULL, 'Spastin', NULL, NULL, 21171, 7),
(236823, NULL, 'MF_01184', NULL, NULL, 'Xanthine phosphoribosyltransferase [xpt].', NULL, 'XPRTase', NULL, NULL, 2329, 7),
(236824, NULL, 'MF_01074', NULL, NULL, 'Pyridinium-3,5-bisthiocarboxylic acid mononucleotide nickel insertion protein [larC].', NULL, 'LarC', NULL, NULL, 6495, 7),
(236825, NULL, 'MF_01127', NULL, NULL, 'Acetyltransferase YpeA [ypeA].', NULL, 'Acetyltransf_YpeA', NULL, NULL, 15224, 7),
(236826, NULL, 'MF_01449', NULL, NULL, 'HTH-type transcriptional regulator SgrR [sgrR].', NULL, 'HTH_type_SgrR', NULL, NULL, 16517, 7); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(236827, NULL, 'MF_01863', NULL, NULL, 'UPF0741 protein <locus_tag>.', NULL, 'UPF0741', NULL, NULL, 19896, 7),
(236828, NULL, 'MF_01085', NULL, NULL, 'UPF0283 membrane protein YcjF [ycjF].', NULL, 'UPF0283', NULL, NULL, 7354, 7),
(236829, NULL, 'MF_01933', NULL, NULL, 'o-succinylbenzoate synthase [menC].', NULL, 'MenC_2', NULL, NULL, 4278, 7),
(236830, NULL, 'MF_00118_A', NULL, NULL, 'Elongation factor Tu [tuf].', NULL, 'EF_Tu_A', NULL, NULL, 1953, 7),
(236831, NULL, 'MF_01402_A', NULL, NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase [apgM].', NULL, 'ApgM_A', NULL, NULL, 906, 7),
(236832, NULL, 'MF_01556', NULL, NULL, 'Galactose-6-phosphate isomerase subunit LacB [lacB].', NULL, 'LacB', NULL, NULL, 5082, 7),
(236833, NULL, 'MF_02087', NULL, NULL, 'Pyridoxal phosphate homeostasis protein.', NULL, 'PLP_homeostasis', NULL, NULL, 9662, 7),
(236834, NULL, 'MF_00038', NULL, NULL, 'Phospho-N-acetylmuramoyl-pentapeptide-transferase [mraY].', NULL, 'MraY', NULL, NULL, 6217, 7),
(236835, NULL, 'MF_03024', NULL, NULL, 'Katanin p60 ATPase-containing subunit A-like 1 [KATNAL1].', NULL, 'Katanin_p60_AL1', NULL, NULL, 23949, 7),
(236836, NULL, 'MF_00641', NULL, NULL, 'Malate synthase G [glcB].', NULL, 'Malate_synth_G', NULL, NULL, 3775, 7),
(236837, NULL, 'MF_04096', NULL, NULL, 'Nucleoprotein [N].', NULL, 'BETA_CORONA_NCAP', NULL, NULL, 34553, 7),
(236838, NULL, 'MF_01948', NULL, NULL, 'Lipopolysaccharide assembly protein A [lapA].', NULL, 'LPS_assembly_LapA', NULL, NULL, 24212, 7),
(236839, NULL, 'MF_01072', NULL, NULL, 'Glucans biosynthesis glucosyltransferase H [mdoH].', NULL, 'MdoH_OpgH', NULL, NULL, 16909, 7),
(236840, NULL, 'MF_01160', NULL, NULL, 'Divalent-cation tolerance protein CutA [cutA].', NULL, 'CutA', NULL, NULL, 11639, 7),
(236841, NULL, 'MF_02066', NULL, NULL, 'Cell division coordinator CpoB [cpoB].', NULL, 'CpoB', NULL, NULL, 19490, 7),
(236842, NULL, 'MF_00208', NULL, NULL, 'UDP-N-acetylmuramoyl-L-alanyl-D-glutamate--2,6-diaminopimelate ligase [murE].', NULL, 'MurE', NULL, NULL, 4749, 7),
(236843, NULL, 'MF_01254', NULL, NULL, 'L-fucose isomerase [fucI].', NULL, 'Fucose_iso', NULL, NULL, 4897, 7),
(236844, NULL, 'MF_01024', NULL, NULL, 'Histidinol dehydrogenase [hisD].', NULL, 'HisD', NULL, NULL, 13893, 7),
(236845, NULL, 'MF_01042', NULL, NULL, 'UPF0115 protein YfcN [yfcN].', NULL, 'UPF0115', NULL, NULL, 15387, 7),
(236846, NULL, 'MF_04060', NULL, NULL, 'Shutoff protein [L4].', NULL, 'ADV_SHUT', NULL, NULL, 4050, 7),
(236847, NULL, 'MF_00407', NULL, NULL, 'DNA ligase [lig].', NULL, 'DNA_ligase', NULL, NULL, 17100, 7),
(236848, NULL, 'MF_00717', NULL, NULL, 'Photosystem II protein Y [psbY].', NULL, 'PSII_PsbY', NULL, NULL, 8081, 7),
(236849, NULL, 'MF_01913', NULL, NULL, '3-sulfolactaldehyde reductase.', NULL, 'SLA_reductase', NULL, NULL, 23649, 7),
(236850, NULL, 'MF_00381', NULL, NULL, 'Integration host factor subunit beta [ihfB].', NULL, 'IHF_beta', NULL, NULL, 3798, 7),
(236851, NULL, 'MF_00385', NULL, NULL, '30S ribosomal protein S16 [rpsP].', NULL, 'Ribosomal_S16', NULL, NULL, 923, 7),
(236852, NULL, 'MF_00797', NULL, NULL, 'UPF0335 protein <locus_tag>.', NULL, 'UPF0335', NULL, NULL, 18158, 7),
(236853, NULL, 'MF_00441', NULL, NULL, 'Photosystem II reaction center protein K [psbK].', NULL, 'PSII_PsbK', NULL, NULL, 4449, 7),
(236854, NULL, 'MF_02104', NULL, NULL, 'Lactate utilization protein C [lutC].', NULL, 'LutC', NULL, NULL, 17434, 7),
(236855, NULL, 'MF_00528', NULL, NULL, 'dTTP/UTP pyrophosphatase.', NULL, 'Maf', NULL, NULL, 2141, 7),
(236856, NULL, 'MF_00932', NULL, NULL, 'Thiol:disulfide interchange protein DsbL [dsbL].', NULL, 'DsbL', NULL, NULL, 21584, 7),
(236857, NULL, 'MF_01310', NULL, NULL, '30S ribosomal protein S11 [rpsK].', NULL, 'Ribosomal_S11', NULL, NULL, 2246, 7),
(236858, NULL, 'MF_00502', NULL, NULL, '50S ribosomal protein L31 type B [rpmE2].', NULL, 'Ribosomal_L31_2', NULL, NULL, 25842, 7),
(236859, NULL, 'MF_00006', NULL, NULL, 'Argininosuccinate lyase [argH].', NULL, 'Arg_succ_lyase', NULL, NULL, 6393, 7),
(236860, NULL, 'MF_03071', NULL, NULL, 'Chromodomain-helicase-DNA-binding protein 8 [CHD8].', NULL, 'CHD8', NULL, NULL, 19046, 7);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(236861, NULL, 'MF_00344', NULL, NULL, 'GMP synthase [glutamine-hydrolyzing] [guaA].', NULL, 'GMP_synthase', NULL, NULL, 14899, 7),
(236862, NULL, 'MF_01162', NULL, NULL, 'Bifunctional protein Aas [aas].', NULL, 'Aas', NULL, NULL, 14886, 7),
(236863, NULL, 'MF_03027', NULL, NULL, 'Ribosome biogenesis protein @gn(BOP1) [BOP1].', NULL, 'BOP1', NULL, NULL, 26090, 7),
(236864, NULL, 'MF_03154', NULL, NULL, '1,2-dihydroxy-3-keto-5-methylthiopentene dioxygenase [ADI1].', NULL, 'Salvage_MtnD_euk', NULL, NULL, 25064, 7),
(236865, NULL, 'MF_01677', NULL, NULL, 'Methylthioribulose-1-phosphate dehydratase [mtnB].', NULL, 'Salvage_MtnB', NULL, NULL, 17821, 7),
(236866, NULL, 'MF_00661', NULL, NULL, 'ATP-dependent RNA helicase RhlB [rhlB].', NULL, 'DEAD_helicase_RhlB', NULL, NULL, 8369, 7),
(236867, NULL, 'MF_03025', NULL, NULL, 'Katanin p60 ATPase-containing subunit A-like 2 [KATNAL2].', NULL, 'Katanin_p60_AL2', NULL, NULL, 25948, 7),
(236868, NULL, 'MF_01173', NULL, NULL, 'Succinylornithine transaminase [astC].', NULL, 'AstC_aminotrans_3', NULL, NULL, 26559, 7),
(236869, NULL, 'MF_03115', NULL, NULL, 'Fe-S cluster assembly protein <gene_name> [DRE2].', NULL, 'Anamorsin', NULL, NULL, 2358, 7),
(236870, NULL, 'MF_04073', NULL, NULL, 'Protein P [P].', NULL, 'HBV_DPOL', NULL, NULL, 27177, 7),
(236871, NULL, 'MF_04072', NULL, NULL, 'Hemagglutinin [HA].', NULL, 'INFV_HEMA', NULL, NULL, 2002, 7),
(236872, NULL, 'MF_00535', NULL, NULL, 'Cyanate hydratase [cynS].', NULL, 'Cyanate_hydrat', NULL, NULL, 6040, 7),
(236873, NULL, 'MF_01351', NULL, NULL, 'NAD(P)H-quinone oxidoreductase subunit I, chloroplastic [ndhI].', NULL, 'NDH1_NuoI', NULL, NULL, 4243, 7),
(236874, NULL, 'MF_02094', NULL, NULL, 'Phosphogluconate dehydratase [edd].', NULL, 'Edd', NULL, NULL, 5012, 7),
(236875, NULL, 'MF_00944', NULL, NULL, 'Ribosome-binding ATPase YchF [ychF].', NULL, 'YchF_OLA1_ATPase', NULL, NULL, 5645, 7),
(236876, NULL, 'MF_00406', NULL, NULL, '3-hydroxyacyl-[acyl-carrier-protein] dehydratase FabZ [fabZ].', NULL, 'FabZ', NULL, NULL, 2074, 7),
(236877, NULL, 'MF_01555', NULL, NULL, 'Galactose-6-phosphate isomerase subunit LacA [lacA].', NULL, 'LacA', NULL, NULL, 5182, 7),
(236878, NULL, 'MF_01090', NULL, NULL, '5,10-methenyltetrahydromethanopterin hydrogenase [hmd].', NULL, 'HMD', NULL, NULL, 6460, 7),
(236879, NULL, 'MF_00741', NULL, NULL, 'Phosphoribosylformylglycinamidine cyclo-ligase [purM].', NULL, 'AIRS', NULL, NULL, 3937, 7),
(236880, NULL, 'MF_01657', NULL, NULL, 'Acetaldehyde dehydrogenase [mhpF].', NULL, 'Ac_ald_DH_ac', NULL, NULL, 4427, 7),
(236881, NULL, 'MF_04158', NULL, NULL, 'Antitermination protein Q [Q].', NULL, 'Antitermination_lambda', NULL, NULL, 2985, 7),
(236882, NULL, 'MF_01324', NULL, NULL, 'DNA-directed RNA polymerase subunit beta'' [rpoC2].', NULL, 'RNApol_bact_RpoC2', NULL, NULL, 9603, 7),
(236883, NULL, 'MF_00089', NULL, NULL, 'Phosphomethylpyrimidine synthase [thiC].', NULL, 'ThiC', NULL, NULL, 33910, 7),
(236884, NULL, 'MF_00143', NULL, NULL, 'UPF0114 protein YqhA [yqhA].', NULL, 'UPF0114', NULL, NULL, 20249, 7),
(236885, NULL, 'MF_01290', NULL, NULL, '2-keto-3-deoxy-L-rhamnonate aldolase [rhmA].', NULL, 'KDR_aldolase', NULL, NULL, 16330, 7),
(236886, NULL, 'MF_00216', NULL, NULL, 'Translation initiation factor 1A [eif1a].', NULL, 'aIF_1A', NULL, NULL, 624, 7),
(236887, NULL, 'MF_00620', NULL, NULL, 'Putative transcriptional regulatory protein <locus_tag>.', NULL, 'HTH_type_Tfx', NULL, NULL, 20394, 7),
(236888, NULL, 'MF_01398', NULL, NULL, 'ATP synthase subunit b [atpF].', NULL, 'ATP_synth_b_bprime', NULL, NULL, 1150, 7),
(236889, NULL, 'MF_03143', NULL, NULL, 'Pentafunctional AROM polypeptide [aroM].', NULL, 'Pentafunct_AroM', NULL, NULL, 8626, 7),
(236890, NULL, 'MF_00102', NULL, NULL, '4-hydroxy-tetrahydrodipicolinate reductase [dapB].', NULL, 'DapB', NULL, NULL, 8465, 7),
(236891, NULL, 'MF_01308', NULL, NULL, 'envelope membrane protein, chloroplastic [cemA].', NULL, 'CemA', NULL, NULL, 4549, 7),
(236892, NULL, 'MF_01100', NULL, NULL, '5''-deoxynucleotidase YfbR [yfbR].', NULL, '5DNU', NULL, NULL, 14774, 7);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(236893, NULL, 'MF_01832', NULL, NULL, 'Cysteine desulfuration protein SufE [sufE].', NULL, 'SufE', NULL, NULL, 17445, 7),
(236894, NULL, 'MF_00905', NULL, NULL, '3'',5''-cyclic adenosine monophosphate phosphodiesterase CpdA [cpdA].', NULL, 'cAMP_phosphodiest_CpdA', NULL, NULL, 37648, 7),
(236895, NULL, 'MF_00632', NULL, NULL, 'UPF0234 protein YajQ [yajQ].', NULL, 'UPF0234', NULL, NULL, 3556, 7),
(236896, NULL, 'MF_00104', NULL, NULL, 'Ribonuclease 3 [rnc].', NULL, 'RNase_III', NULL, NULL, 12015, 7),
(236897, NULL, 'MF_01080', NULL, NULL, 'tRNA pseudouridine synthase B [truB].', NULL, 'TruB_bact', NULL, NULL, 8750, 7),
(236898, NULL, 'MF_01202', NULL, NULL, 'D-amino acid dehydrogenase [dadA].', NULL, 'DadA', NULL, NULL, 15461, 7),
(236899, NULL, 'MF_01059', NULL, NULL, 'Cytoplasmic trehalase [treF].', NULL, 'Cyt_trehalase', NULL, NULL, 16773, 7),
(236900, NULL, 'MF_00095', NULL, NULL, 'Sugar fermentation stimulation protein A [sfsA].', NULL, 'SfsA', NULL, NULL, 11383, 7),
(236901, NULL, 'MF_00085', NULL, NULL, 'Translation initiation factor 5A [eif5a].', NULL, 'eIF_5A', NULL, NULL, 14962, 7),
(236902, NULL, 'MF_00814', NULL, NULL, 'Nascent polypeptide-associated complex protein [nac].', NULL, 'NAC_arch', NULL, NULL, 11236, 7),
(236903, NULL, 'MF_01328_A', NULL, NULL, '50S ribosomal protein L4 [rplD].', NULL, 'Ribosomal_L4_A', NULL, NULL, 15956, 7),
(236904, NULL, 'MF_01849', NULL, NULL, 'Dual-specificity RNA methyltransferase RlmN [rlmN].', NULL, 'RNA_methyltr_RlmN', NULL, NULL, 21654, 7),
(236905, NULL, 'MF_02090', NULL, NULL, 'Glutamine-dependent NAD(+) synthetase [nadE].', NULL, 'NadE_glutamine_dep', NULL, NULL, 9881, 7),
(236906, NULL, 'MF_01527_B', NULL, NULL, 'GTP cyclohydrolase FolE2 [folE2].', NULL, 'GTP_cyclohydrol_B', NULL, NULL, 599, 7),
(236907, NULL, 'MF_00737', NULL, NULL, 'Formimidoylglutamase [hutG].', NULL, 'Formimidoylglutam', NULL, NULL, 205, 7),
(236908, NULL, 'MF_02245', NULL, NULL, 'ClpXP adapter protein SpxH [spxH].', NULL, 'Adapter_SpxH', NULL, NULL, 33591, 7),
(236909, NULL, 'MF_00254', NULL, NULL, 'Glycine--tRNA ligase alpha subunit [glyQ].', NULL, 'Gly_tRNA_synth_alpha', NULL, NULL, 6021, 7),
(236910, NULL, 'MF_00755', NULL, NULL, 'Ribonuclease P protein component 2 [rnp2].', NULL, 'RNase_P_2', NULL, NULL, 4097, 7),
(236911, NULL, 'MF_00197', NULL, NULL, 'Diaminopimelate epimerase [dapF].', NULL, 'DAP_epimerase', NULL, NULL, 11041, 7),
(236912, NULL, 'MF_00433', NULL, NULL, 'Cytochrome b6-f complex subunit 6 [petL].', NULL, 'Cytb6_f_PetL', NULL, NULL, 2476, 7),
(236913, NULL, 'MF_03006', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit G [EIF3G].', NULL, 'eIF3g', NULL, NULL, 17241, 7),
(236914, NULL, 'MF_01014', NULL, NULL, '1-(5-phosphoribosyl)-5-[(5-phosphoribosylamino)methylideneamino] imidazole-4-carboxamide isomerase [hisA].', NULL, 'HisA', NULL, NULL, 15173, 7),
(236915, NULL, 'MF_01259', NULL, NULL, 'Bifunctional F420 biosynthesis protein FbiB [fbiB].', NULL, 'F420_ligase_FbiB', NULL, NULL, 710, 7),
(236916, NULL, 'MF_00976', NULL, NULL, 'Outer membrane lipoprotein RcsF [rcsF].', NULL, 'RcsF', NULL, NULL, 25261, 7),
(236917, NULL, 'MF_03041', NULL, NULL, 'Protein Spindly [SPDL1].', NULL, 'SPDLY', NULL, NULL, 23846, 7),
(236918, NULL, 'MF_00623', NULL, NULL, 'Exosome complex component Rrp4 [rrp4].', NULL, 'Exosome_Rrp4', NULL, NULL, 16045, 7),
(236919, NULL, 'MF_00710', NULL, NULL, 'Malonate decarboxylase acyl carrier protein [mdcC].', NULL, 'Malonate_deCO2ase_dsu', NULL, NULL, 11810, 7),
(236920, NULL, 'MF_00298', NULL, NULL, 'RNA pyrophosphohydrolase [rppH].', NULL, 'Nudix_RppH', NULL, NULL, 14615, 7),
(236921, NULL, 'MF_02041', NULL, NULL, 'tRNA-dihydrouridine(20/20a) synthase [dusA].', NULL, 'DusA_subfam', NULL, NULL, 2684, 7),
(236922, NULL, 'MF_00936', NULL, NULL, 'DNA topoisomerase 4 subunit A [parC].', NULL, 'ParC_type1', NULL, NULL, 4988, 7),
(236923, NULL, 'MF_00339', NULL, NULL, 'ATP-dependent 6-phosphofructokinase [pfkA].', NULL, 'Phosphofructokinase_I_B1', NULL, NULL, 12744, 7),
(236924, NULL, 'MF_03232', NULL, NULL, 'Acyl-coenzyme A diphosphatase YFT2 [YFT2].', NULL, 'YFT2', NULL, NULL, 37545, 7); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(236925, NULL, 'MF_01391', NULL, NULL, 'Cytochrome c biogenesis protein CcsA [ccsA].', NULL, 'CytC_CcsA', NULL, NULL, 15308, 7),
(236926, NULL, 'MF_02074', NULL, NULL, 'Renalase.', NULL, 'Bact_renalase', NULL, NULL, 18577, 7),
(236927, NULL, 'MF_00554', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase Nep1 [nep1].', NULL, 'NEP1', NULL, NULL, 16155, 7),
(236928, NULL, 'MF_01133', NULL, NULL, 'Ribulose bisphosphate carboxylase [rbcL].', NULL, 'RuBisCO_L_type3', NULL, NULL, 17920, 7),
(236929, NULL, 'MF_00315', NULL, NULL, '1-deoxy-D-xylulose-5-phosphate synthase [dxs].', NULL, 'DXP_synth', NULL, NULL, 786, 7),
(236930, NULL, 'MF_00963', NULL, NULL, 'RNA polymerase sigma factor RpoD [rpoD].', NULL, 'Sigma70_RpoD_SigA', NULL, NULL, 22470, 7),
(236931, NULL, 'MF_04003', NULL, NULL, 'Minor capsid protein L2 [L2].', NULL, 'PPV_L2', NULL, NULL, 4916, 7),
(236932, NULL, 'MF_01638', NULL, NULL, 'Pyridoxine/pyridoxal/pyridoxamine kinase [pdxK].', NULL, 'PdxK', NULL, NULL, 16149, 7),
(236933, NULL, 'MF_00191', NULL, NULL, '4-hydroxy-3-methylbut-2-enyl diphosphate reductase [ispH].', NULL, 'IspH', NULL, NULL, 5344, 7),
(236934, NULL, 'MF_00830', NULL, NULL, 'Ureidoacrylate amidohydrolase RutB [rutB].', NULL, 'RutB', NULL, NULL, 14725, 7),
(236935, NULL, 'MF_00027', NULL, NULL, 'Hydrogenobyrinate a,c-diamide synthase [cobB].', NULL, 'CobB_CbiA', NULL, NULL, 1453, 7),
(236936, NULL, 'MF_00036_A', NULL, NULL, 'Alanine--tRNA ligase [alaS].', NULL, 'Ala_tRNA_synth_A', NULL, NULL, 15709, 7),
(236937, NULL, 'MF_00096', NULL, NULL, 'DNA mismatch repair protein MutS [mutS].', NULL, 'MutS', NULL, NULL, 4837, 7),
(236938, NULL, 'MF_01648', NULL, NULL, '3-phenylpropionate/cinnamic acid dioxygenase subunit alpha [hcaE].', NULL, 'HcaE', NULL, NULL, 19571, 7),
(236939, NULL, 'MF_00591', NULL, NULL, 'Exosome complex component Rrp41 [rrp41].', NULL, 'Exosome_Rrp41', NULL, NULL, 13078, 7),
(236940, NULL, 'MF_00142', NULL, NULL, 'Iron-sulfur cluster assembly protein CyaY [cyaY].', NULL, 'CyaY', NULL, NULL, 6348, 7),
(236941, NULL, 'MF_00189', NULL, NULL, 'Membrane-spanning protein YciB [yciB].', NULL, 'YciB', NULL, NULL, 1137, 7),
(236942, NULL, 'MF_00494', NULL, NULL, 'Probable transaldolase [tal].', NULL, 'Transaldolase_3b', NULL, NULL, 15389, 7),
(236943, NULL, 'MF_01368', NULL, NULL, '50S ribosomal protein L17 [rplQ].', NULL, 'Ribosomal_L17', NULL, NULL, 6840, 7),
(236944, NULL, 'MF_03216', NULL, NULL, 'Phosphatidyl-N-methylethanolamine N-methyltransferase [PEMT].', NULL, 'PLMT', NULL, NULL, 23961, 7),
(236945, NULL, 'MF_03168', NULL, NULL, 'Adenylate kinase 2, mitochondrial [AK2].', NULL, 'Adenylate_kinase_AK2', NULL, NULL, 23909, 7),
(236946, NULL, 'MF_00466', NULL, NULL, 'Probable M18 family aminopeptidase 1 [apeA].', NULL, 'Aminopeptidase_M18_1', NULL, NULL, 15148, 7),
(236947, NULL, 'MF_02032', NULL, NULL, '2-hydroxy-3-oxopropionate reductase [garR].', NULL, 'Tartronate_sem_reduc', NULL, NULL, 5782, 7),
(236948, NULL, 'MF_00577', NULL, NULL, 'Urocanate hydratase [hutU].', NULL, 'HutU', NULL, NULL, 870, 7),
(236949, NULL, 'MF_04112', NULL, NULL, 'Lysis inhibition accessory protein.', NULL, 'Linr3_BPT4', NULL, NULL, 18984, 7),
(236950, NULL, 'MF_01017', NULL, NULL, 'NAD(P)H dehydrogenase (quinone).', NULL, 'NQOR', NULL, NULL, 31125, 7),
(236951, NULL, 'MF_00398', NULL, NULL, 'Probable apo-citrate lyase phosphoribosyl-dephospho-CoA transferase [citX].', NULL, 'CitX', NULL, NULL, 1586, 7),
(236952, NULL, 'MF_00957', NULL, NULL, 'Poly(A) polymerase I [pcnB].', NULL, 'PolyA_pol', NULL, NULL, 4002, 7),
(236953, NULL, 'MF_01233', NULL, NULL, 'HTH-type transcriptional regulator HdfR [hdfR].', NULL, 'HTH_type_HdfR', NULL, NULL, 19687, 7),
(236954, NULL, 'MF_00752', NULL, NULL, 'Photosystem II reaction center protein H [psbH].', NULL, 'PSII_PsbH', NULL, NULL, 5078, 7),
(236955, NULL, 'MF_00751', NULL, NULL, 'Preprotein translocase subunit SecG [secG].', NULL, 'SecG', NULL, NULL, 16638, 7),
(236956, NULL, 'MF_00078', NULL, NULL, 'UPF0107 protein <locus_tag>.', NULL, 'UPF0107', NULL, NULL, 20558, 7),
(236957, NULL, 'MF_00776', NULL, NULL, 'Glyoxylate reductase [gyaR].', NULL, 'GyaR', NULL, NULL, 16783, 7);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(236958, NULL, 'MF_00307', NULL, NULL, 'Prefoldin subunit beta [pfdB].', NULL, 'PfdB', NULL, NULL, 11884, 7),
(236959, NULL, 'MF_01841', NULL, NULL, 'Agmatine deiminase [aguA].', NULL, 'Agmatine_deimin', NULL, NULL, 18848, 7),
(236960, NULL, 'MF_03172', NULL, NULL, 'UMP-CMP kinase [CMPK1].', NULL, 'Adenylate_kinase_UMP_CMP_kin', NULL, NULL, 3660, 7),
(236961, NULL, 'MF_01292', NULL, NULL, '4-hydroxy-2-oxo-heptane-1,7-dioate aldolase [hpcH].', NULL, 'HKHD_aldolase', NULL, NULL, 14795, 7),
(236962, NULL, 'MF_01420', NULL, NULL, 'Probable cell division protein WhiA [whiA].', NULL, 'HTH_type_WhiA', NULL, NULL, 3133, 7),
(236963, NULL, 'MF_01847', NULL, NULL, 'HMP-PP phosphatase [cof].', NULL, 'HMP_PP_phosphat', NULL, NULL, 17439, 7),
(236964, NULL, 'MF_01143', NULL, NULL, 'Holin-like protein CidA [cidA].', NULL, 'CidA', NULL, NULL, 10185, 7),
(236965, NULL, 'MF_02209', NULL, NULL, 'UDP-N-acetyl-alpha-D-muramoyl-L-alanyl-L-glutamate epimerase [murL].', NULL, 'MurL', NULL, NULL, 34727, 7),
(236966, NULL, 'MF_01539', NULL, NULL, 'tRNA(Met) cytidine acetate ligase [tmcAL].', NULL, 'TmcAL', NULL, NULL, 12772, 7),
(236967, NULL, 'MF_01888', NULL, NULL, 'Regulator of ribonuclease activity B [rraB].', NULL, 'RraB', NULL, NULL, 21345, 7),
(236968, NULL, 'MF_04065', NULL, NULL, 'RNA-directed RNA polymerase catalytic subunit [PB1].', NULL, 'INFV_RDRP', NULL, NULL, 3385, 7),
(236969, NULL, 'MF_00968', NULL, NULL, 'ATP-dependent RNA helicase RhlE [rhlE].', NULL, 'DEAD_helicase_RhlE', NULL, NULL, 25373, 7),
(236970, NULL, 'MF_03198', NULL, NULL, 'Protein-lysine N-methyltransferase <gene_name> [EFM6].', NULL, 'Methyltr_EFM6', NULL, NULL, 29877, 7),
(236971, NULL, 'MF_00650', NULL, NULL, 'Phosphoribosyl-dephospho-CoA transferase [mdcG].', NULL, 'Malonate_MdcG', NULL, NULL, 14713, 7),
(236972, NULL, 'MF_01536', NULL, NULL, 'UPF0344 protein <locus_tag>.', NULL, 'UPF0344', NULL, NULL, 12220, 7),
(236973, NULL, 'MF_04077', NULL, NULL, 'Protein Rev [rev].', NULL, 'REV_HIV1', NULL, NULL, 5802, 7),
(236974, NULL, 'MF_00226_B', NULL, NULL, 'Putative competence-damage inducible protein [cinA].', NULL, 'CinA_B', NULL, NULL, 6259, 7),
(236975, NULL, 'MF_01538', NULL, NULL, 'UPF0346 protein <locus_tag>.', NULL, 'UPF0346', NULL, NULL, 9160, 7),
(236976, NULL, 'MF_02114', NULL, NULL, '2-phospho-L-lactate  guanylyltransferase [cofC].', NULL, 'CofC', NULL, NULL, 5110, 7),
(236977, NULL, 'MF_04016', NULL, NULL, 'Major capsid protein [MCP].', NULL, 'HSV_MCP', NULL, NULL, 332, 7),
(236978, NULL, 'MF_01204', NULL, NULL, 'Probable malonic semialdehyde reductase RutE [rutE].', NULL, 'Oxidoreductase_RutE_HadB', NULL, NULL, 17056, 7),
(236979, NULL, 'MF_03106', NULL, NULL, 'Sulfate adenylyltransferase [MET3].', NULL, 'Sulf_adenylyltr_euk', NULL, NULL, 23675, 7),
(236980, NULL, 'MF_04202', NULL, NULL, 'Membrane protein [M].', NULL, 'BETA_CORONA_M', NULL, NULL, 1683, 7),
(236981, NULL, 'MF_00590', NULL, NULL, 'GTP-dependent dephospho-CoA kinase.', NULL, 'Dephospho_CoA_kinase_GTP_dep', NULL, NULL, 240, 7),
(236982, NULL, 'MF_01244', NULL, NULL, '3-dehydroquinate synthase [aroB''].', NULL, 'Arch_DHQ_synthase', NULL, NULL, 4881, 7),
(236983, NULL, 'MF_00393', NULL, NULL, 'Glycerol-3-phosphate acyltransferase [plsB].', NULL, 'Glyc3P_acyltrans', NULL, NULL, 26305, 7),
(236984, NULL, 'MF_01830', NULL, NULL, 'Putative hydro-lyase <locus_tag>.', NULL, 'Hydro_lyase', NULL, NULL, 17882, 7),
(236985, NULL, 'MF_00377', NULL, NULL, 'Chromosomal replication initiator protein DnaA [dnaA].', NULL, 'DnaA_bact', NULL, NULL, 4459, 7),
(236986, NULL, 'MF_00249', NULL, NULL, 'ATP-dependent protease ATPase subunit HslU [hslU].', NULL, 'HslU', NULL, NULL, 1315, 7),
(236987, NULL, 'MF_00520', NULL, NULL, 'Ribulokinase [araB].', NULL, 'Ribulokinase', NULL, NULL, 140, 7),
(236988, NULL, 'MF_00863', NULL, NULL, 'DNA-directed RNA polymerase subunit Rpo1N [rpo1N].', NULL, 'RNApol_arch_Rpo1N', NULL, NULL, 9691, 7),
(236989, NULL, 'MF_01435', NULL, NULL, 'Protein YebF [yebF].', NULL, 'YebF', NULL, NULL, 21226, 7),
(236990, NULL, 'MF_01296', NULL, NULL, 'D-tagatose-1,6-bisphosphate aldolase subunit GatZ [gatZ].', NULL, 'Tagatose_aldol_GatZ', NULL, NULL, 16459, 7);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(236991, NULL, 'MF_00524', NULL, NULL, 'Glucokinase [glk].', NULL, 'Glucokinase', NULL, NULL, 3388, 7),
(236992, NULL, 'MF_01086', NULL, NULL, 'UPF0284 protein <locus_tag>.', NULL, 'UPF0284', NULL, NULL, 4994, 7),
(236993, NULL, 'MF_04163', NULL, NULL, 'Sliding-clamp-loader small subunit.', NULL, 'T4_Clamp_Loader_S', NULL, NULL, 26767, 7),
(236994, NULL, 'MF_00692', NULL, NULL, 'Protein adenylyltransferase SelO [selO].', NULL, 'SelO', NULL, NULL, 3081, 7),
(236995, NULL, 'MF_02240', NULL, NULL, 'Phosphoserine phosphatase.', NULL, 'PSP', NULL, NULL, 35447, 7),
(236996, NULL, 'MF_01188', NULL, NULL, 'UPF0441 protein YgiB [ygiB].', NULL, 'UPF0441', NULL, NULL, 725, 7),
(236997, NULL, 'MF_00923', NULL, NULL, 'Outer membrane protein assembly factor BamB [bamB].', NULL, 'OM_assembly_BamB', NULL, NULL, 17754, 7),
(236998, NULL, 'MF_01172', NULL, NULL, 'N-succinylarginine dihydrolase [astB].', NULL, 'AstB', NULL, NULL, 394, 7),
(236999, NULL, 'MF_01260', NULL, NULL, 'Pimeloyl-[acyl-carrier protein] methyl ester esterase [bioH].', NULL, 'Carboxylester', NULL, NULL, 2266, 7),
(237000, NULL, 'MF_01662', NULL, NULL, 'L-fucose mutarotase [fucU].', NULL, 'L_fucose_rotase', NULL, NULL, 10519, 7),
(237001, NULL, 'MF_00408', NULL, NULL, 'TATA-box-binding protein [tbp].', NULL, 'TATA_bind_prot_arch', NULL, NULL, 4552, 7),
(237002, NULL, 'MF_01958', NULL, NULL, 'Acetyl esterase [aes].', NULL, 'Acetyl_esterase', NULL, NULL, 16322, 7),
(237003, NULL, 'MF_00309', NULL, NULL, 'V-type ATP synthase alpha chain [atpA].', NULL, 'ATP_synth_A_arch', NULL, NULL, 16998, 7),
(237004, NULL, 'MF_01552', NULL, NULL, 'Ribosomal protein S6--L-glutamate ligase [rimK].', NULL, 'RimK', NULL, NULL, 16571, 7),
(237005, NULL, 'MF_01450', NULL, NULL, 'Acylphosphatase [yccX].', NULL, 'Acylphosphatase_entero', NULL, NULL, 25573, 7),
(237006, NULL, 'MF_02022', NULL, NULL, 'Cell division protein DedD [dedD].', NULL, 'DedD', NULL, NULL, 24011, 7),
(237007, NULL, 'MF_04134', NULL, NULL, 'Tail assembly protein GT.', NULL, 'GT_LAMBD', NULL, NULL, 13159, 7),
(237008, NULL, 'MF_04069', NULL, NULL, 'Matrix protein 2 [M].', NULL, 'INFV_M2', NULL, NULL, 1449, 7),
(237009, NULL, 'MF_00396', NULL, NULL, 'Cytochrome b6-f complex subunit 7 [petM].', NULL, 'Cytb6_f_PetM', NULL, NULL, 9282, 7),
(237010, NULL, 'MF_00631', NULL, NULL, 'Cell division protein CrgA [crgA].', NULL, 'CrgA', NULL, NULL, 1597, 7),
(237011, NULL, 'MF_00293', NULL, NULL, 'Protein PsbN [psbN].', NULL, 'PSII_PsbN', NULL, NULL, 5449, 7),
(237012, NULL, 'MF_01109', NULL, NULL, 'Ornithine carbamoyltransferase, catabolic [argI].', NULL, 'OTCase', NULL, NULL, 25253, 7),
(237013, NULL, 'MF_00278', NULL, NULL, 'Imidazole glycerol phosphate synthase subunit HisH [hisH].', NULL, 'HisH', NULL, NULL, 10763, 7),
(237014, NULL, 'MF_00840', NULL, NULL, 'Diadenylate cyclase [dacZ].', NULL, 'DacZ', NULL, NULL, 10547, 7),
(237015, NULL, 'MF_03008', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit I [EIF3I].', NULL, 'eIF3i', NULL, NULL, 25317, 7),
(237016, NULL, 'MF_00757', NULL, NULL, 'Ribonuclease P protein component 4 [rnp4].', NULL, 'RNase_P_4', NULL, NULL, 21048, 7),
(237017, NULL, 'MF_00221', NULL, NULL, 'Divalent metal cation transporter MntH [mntH].', NULL, 'NRAMP', NULL, NULL, 2110, 7),
(237018, NULL, 'MF_01087', NULL, NULL, 'UPF0285 protein <locus_tag>.', NULL, 'UPF0285', NULL, NULL, 21096, 7),
(237019, NULL, 'MF_00240', NULL, NULL, 'Outer-membrane lipoprotein carrier protein [lolA].', NULL, 'LolA', NULL, NULL, 17516, 7),
(237020, NULL, 'MF_00612', NULL, NULL, 'UPF0225 protein YchJ [ychJ].', NULL, 'UPF0225', NULL, NULL, 15396, 7),
(237021, NULL, 'MF_01056', NULL, NULL, 'Protein FixB [fixB].', NULL, 'FixB', NULL, NULL, 16232, 7),
(237022, NULL, 'MF_01146', NULL, NULL, 'Aquaporin Z [aqpZ].', NULL, 'Aquaporin_Z', NULL, NULL, 16846, 7),
(237023, NULL, 'MF_04106', NULL, NULL, 'Baseplate wedge protein gp10.', NULL, 'BP10_T4', NULL, NULL, 7267, 7),
(237024, NULL, 'MF_01683', NULL, NULL, 'Methylthioribose kinase [mtnK].', NULL, 'Salvage_MtnK', NULL, NULL, 10470, 7),
(237025, NULL, 'MF_02010', NULL, NULL, 'Anti-adapter protein IraD [iraD].', NULL, 'IraD', NULL, NULL, 16607, 7);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(237026, NULL, 'MF_00688', NULL, NULL, 'Leucyl/phenylalanyl-tRNA--protein transferase [aat].', NULL, 'Leu_Phe_trans', NULL, NULL, 2216, 7),
(237027, NULL, 'MF_01025', NULL, NULL, '2-isopropylmalate synthase [leuA].', NULL, 'LeuA_type1', NULL, NULL, 3819, 7),
(237028, NULL, 'MF_00657', NULL, NULL, 'PKHD-type hydroxylase YbiX [ybiX].', NULL, 'Hydroxyl_YbiX', NULL, NULL, 16393, 7),
(237029, NULL, 'MF_00625', NULL, NULL, 'Selenide, water dikinase [selD].', NULL, 'SelD', NULL, NULL, 15286, 7),
(237030, NULL, 'MF_02091', NULL, NULL, 'Uncharacterized MFS-type transporter YfcJ [yfcJ].', NULL, 'MFS_YfcJ', NULL, NULL, 32656, 7),
(237031, NULL, 'MF_00012', NULL, NULL, 'Dihydroxy-acid dehydratase [ilvD].', NULL, 'IlvD', NULL, NULL, 5923, 7),
(237032, NULL, 'MF_04127', NULL, NULL, 'Inner capsid protein VP2.', NULL, 'Rota_VP2_A', NULL, NULL, 1174, 7),
(237033, NULL, 'MF_00929', NULL, NULL, 'Cellobiose 2-epimerase.', NULL, 'Cellobiose_2_epim', NULL, NULL, 22531, 7),
(237034, NULL, 'MF_00164', NULL, NULL, 'Glutamine--fructose-6-phosphate aminotransferase [isomerizing] [glmS].', NULL, 'GlmS', NULL, NULL, 6572, 7),
(237035, NULL, 'MF_01422', NULL, NULL, 'Multidrug resistance protein MdtA [mdtA].', NULL, 'MdtA', NULL, NULL, 1520, 7),
(237036, NULL, 'MF_01649', NULL, NULL, '3-phenylpropionate/cinnamic acid dioxygenase subunit beta [hcaF].', NULL, 'HcaF', NULL, NULL, 16669, 7),
(237037, NULL, 'MF_01960', NULL, NULL, 'D-aminopeptidase [dap].', NULL, 'D_aminopeptidase', NULL, NULL, 6867, 7),
(237038, NULL, 'MF_00036_B', NULL, NULL, 'Alanine--tRNA ligase [alaS].', NULL, 'Ala_tRNA_synth_B', NULL, NULL, 15405, 7),
(237039, NULL, 'MF_00259', NULL, NULL, 'Aminomethyltransferase [gcvT].', NULL, 'GcvT', NULL, NULL, 17353, 7),
(237040, NULL, 'MF_01185', NULL, NULL, 'Flagellar assembly factor FliW [fliW].', NULL, 'FliW', NULL, NULL, 6268, 7),
(237041, NULL, 'MF_01352', NULL, NULL, 'NAD(P)H-quinone oxidoreductase subunit M [ndhM].', NULL, 'NDH1_NDH1M', NULL, NULL, 14831, 7),
(237042, NULL, 'MF_01518', NULL, NULL, 'Adenine deaminase [ade].', NULL, 'Adenine_deamin', NULL, NULL, 1736, 7),
(237043, NULL, 'MF_01940', NULL, NULL, 'RNA 2'',3''-cyclic phosphodiesterase [thpR].', NULL, 'RNA_CPDase', NULL, NULL, 2689, 7),
(237044, NULL, 'MF_00646', NULL, NULL, 'Elongation factor P-like protein [yeiP].', NULL, 'EFP', NULL, NULL, 12415, 7),
(237045, NULL, 'MF_00836', NULL, NULL, 'Ribose 1,5-bisphosphate phosphokinase PhnN [phnN].', NULL, 'PhnN', NULL, NULL, 11883, 7),
(237046, NULL, 'MF_02019', NULL, NULL, 'UDP-N-acetylmuramoyl-tripeptide--D-alanyl-D-alanine ligase [murF].', NULL, 'MurF', NULL, NULL, 6755, 7),
(237047, NULL, 'MF_00182', NULL, NULL, 'Methionyl-tRNA formyltransferase [fmt].', NULL, 'Formyl_trans', NULL, NULL, 6728, 7),
(237048, NULL, 'MF_00239', NULL, NULL, 'Cytidylate kinase [cmk].', NULL, 'Cytidyl_kinase_type2', NULL, NULL, 8523, 7),
(237049, NULL, 'MF_02051', NULL, NULL, '(4S)-4-hydroxy-5-phosphonooxypentane-2,3-dione isomerase [lsrG].', NULL, 'LsrG', NULL, NULL, 32929, 7),
(237050, NULL, 'MF_01317', NULL, NULL, 'Photosystem II reaction center protein L [psbL].', NULL, 'PSII_PsbL', NULL, NULL, 4419, 7),
(237051, NULL, 'MF_01563', NULL, NULL, 'HTH-type transcriptional regulator UlaR [ulaR].', NULL, 'HTH_type_UlaR', NULL, NULL, 7170, 7),
(237052, NULL, 'MF_00904', NULL, NULL, 'Modulator protein MzrA [mzrA].', NULL, 'Modulator_MzrA', NULL, NULL, 21628, 7),
(237053, NULL, 'MF_00310', NULL, NULL, 'V-type ATP synthase beta chain [atpB].', NULL, 'ATP_synth_B_arch', NULL, NULL, 17381, 7),
(237054, NULL, 'MF_03104', NULL, NULL, 'Mitochondrial distribution and morphology protein 12 [MDM12].', NULL, 'Mdm12', NULL, NULL, 25465, 7),
(237055, NULL, 'MF_00686', NULL, NULL, 'Probable Fe(2+)-trafficking protein [yggX].', NULL, 'Fe_traffic_YggX', NULL, NULL, 4621, 7),
(237056, NULL, 'MF_01950', NULL, NULL, 'Acyl carrier protein phosphodiesterase [acpH].', NULL, 'AcpH', NULL, NULL, 16477, 7),
(237057, NULL, 'MF_03210', NULL, NULL, 'Formate dehydrogenase, mitochondrial.', NULL, 'Formate_dehydrogenase', NULL, NULL, 28359, 7),
(237058, NULL, 'MF_01065', NULL, NULL, 'UPF0257 lipoprotein YnfC [ynfC].', NULL, 'UPF0257', NULL, NULL, 9178, 7);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(237059, NULL, 'MF_00204', NULL, NULL, 'UvrABC system protein B [uvrB].', NULL, 'UvrB', NULL, NULL, 4298, 7),
(237060, NULL, 'MF_01043', NULL, NULL, 'Glycerol-3-phosphate acyltransferase [plsY].', NULL, 'PlsY', NULL, NULL, 6290, 7),
(237061, NULL, 'MF_01138', NULL, NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit beta [cdhC].', NULL, 'CdhC', NULL, NULL, 16119, 7),
(237062, NULL, 'MF_00479', NULL, NULL, 'Ion-translocating oxidoreductase complex subunit G [rsxG].', NULL, 'RsxG_RnfG', NULL, NULL, 4378, 7),
(237063, NULL, 'MF_02045', NULL, NULL, 'Phosphoribosylaminoimidazole carboxylase [purE].', NULL, 'PurE_classII', NULL, NULL, 31498, 7),
(237064, NULL, 'MF_00150', NULL, NULL, 'N-acetyl-gamma-glutamyl-phosphate reductase [argC].', NULL, 'ArgC_type1', NULL, NULL, 6715, 7),
(237065, NULL, 'MF_01666', NULL, NULL, 'Glyoxylate/hydroxypyruvate reductase A [ghrA].', NULL, '2_Hacid_dh_C_GhrA', NULL, NULL, 16114, 7),
(237066, NULL, 'MF_00728', NULL, NULL, 'Septation ring formation regulator EzrA [ezrA].', NULL, 'EzrA', NULL, NULL, 9389, 7),
(237067, NULL, 'MF_01522', NULL, NULL, 'Low affinity potassium transport system protein kup [kup].', NULL, 'Kup', NULL, NULL, 15255, 7),
(237068, NULL, 'MF_00192', NULL, NULL, 'DNA-directed RNA polymerase subunit Rpo6 [rpo6].', NULL, 'RNApol_arch_Rpo6', NULL, NULL, 10354, 7),
(237069, NULL, 'MF_00689', NULL, NULL, 'Aspartate/glutamate leucyltransferase [bpt].', NULL, 'Bpt', NULL, NULL, 20506, 7),
(237070, NULL, 'MF_01242', NULL, NULL, 'Aliphatic amidase [amiE].', NULL, 'Aliphatic_amidase', NULL, NULL, 7592, 7),
(237071, NULL, 'MF_00648', NULL, NULL, 'Inosine/xanthosine triphosphatase.', NULL, 'Non_canon_purine_NTPase_YjjX', NULL, NULL, 4641, 7),
(237072, NULL, 'MF_03067', NULL, NULL, 'E3 ubiquitin-protein ligase RNF8 [RNF8].', NULL, 'RNF8', NULL, NULL, 17052, 7),
(237073, NULL, 'MF_04054', NULL, NULL, 'DNA-binding protein [DBP].', NULL, 'ADV_DNB2', NULL, NULL, 32928, 7),
(237074, NULL, 'MF_01328_B', NULL, NULL, '50S ribosomal protein L4 [rplD].', NULL, 'Ribosomal_L4_B', NULL, NULL, 18869, 7),
(237075, NULL, 'MF_01527_A', NULL, NULL, 'GTP cyclohydrolase FolE2 [folE2].', NULL, 'GTP_cyclohydrol_A', NULL, NULL, 17480, 7),
(237076, NULL, 'MF_04153', NULL, NULL, 'Single-stranded DNA-binding protein.', NULL, 'SSB_T7', NULL, NULL, 21375, 7),
(237077, NULL, 'MF_01220_B', NULL, NULL, 'Uridylate kinase [pyrH].', NULL, 'PyrH_B', NULL, NULL, 8973, 7),
(237078, NULL, 'MF_00921', NULL, NULL, 'Putative pyruvate, phosphate dikinase regulatory protein.', NULL, 'PDRP', NULL, NULL, 21784, 7),
(237079, NULL, 'MF_00083', NULL, NULL, 'Peptidyl-tRNA hydrolase [pth].', NULL, 'Pept_tRNA_hydro_bact', NULL, NULL, 2443, 7),
(237080, NULL, 'MF_00043', NULL, NULL, 'Elongation factor 1-beta [ef1b].', NULL, 'EF1_beta', NULL, NULL, 1782, 7),
(237081, NULL, 'MF_01807', NULL, NULL, 'Tyrosine recombinase XerD [xerD].', NULL, 'Recomb_XerD', NULL, NULL, 11374, 7),
(237082, NULL, 'MF_03011', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit L [EIF3L].', NULL, 'eIF3l', NULL, NULL, 15711, 7),
(237083, NULL, 'MF_00185', NULL, NULL, 'tRNA dimethylallyltransferase [miaA].', NULL, 'IPP_trans', NULL, NULL, 16702, 7),
(237084, NULL, 'MF_01396', NULL, NULL, 'ATP synthase subunit c [atpH].', NULL, 'ATP_synth_c_bact', NULL, NULL, 6579, 7),
(237085, NULL, 'MF_01895', NULL, NULL, 'Ribonuclease R [rnr].', NULL, 'RNase_R', NULL, NULL, 13106, 7),
(237086, NULL, 'MF_01687', NULL, NULL, 'Beta-galactosidase [lacZ].', NULL, 'Beta_gal', NULL, NULL, 6071, 7),
(237087, NULL, 'MF_01939', NULL, NULL, '2-methylisocitrate lyase [prpB].', NULL, 'PrpB', NULL, NULL, 11960, 7),
(237088, NULL, 'MF_02076', NULL, NULL, 'Glutamate--tRNA ligase [gltX].', NULL, 'Glu_tRNA_synth_type2', NULL, NULL, 1513, 7),
(237089, NULL, 'MF_00440', NULL, NULL, 'Transcriptional repressor NrdR [nrdR].', NULL, 'NrdR', NULL, NULL, 3117, 7),
(237090, NULL, 'MF_02011', NULL, NULL, 'Cell cycle protein GpsB [gpsB].', NULL, 'GpsB', NULL, NULL, 10502, 7),
(237091, NULL, 'MF_01234', NULL, NULL, 'N-acetylmannosamine kinase [nanK].', NULL, 'ManNAc_kinase', NULL, NULL, 18272, 7);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(237092, NULL, 'MF_00438', NULL, NULL, 'Photosystem II reaction center protein M [psbM].', NULL, 'PSII_PsbM', NULL, NULL, 2262, 7),
(237093, NULL, 'MF_00780', NULL, NULL, 'Protein YceI [yceI].', NULL, 'UPF0312', NULL, NULL, 16660, 7),
(237094, NULL, 'MF_00629', NULL, NULL, '50S ribosomal protein L39e [rpl39e].', NULL, 'Ribosomal_L39e', NULL, NULL, 2661, 7),
(237095, NULL, 'MF_01959', NULL, NULL, 'Cytochrome c-type biogenesis protein CcmE [ccmE].', NULL, 'CcmE', NULL, NULL, 4950, 7),
(237096, NULL, 'MF_02130', NULL, NULL, 'Dihydroneopterin aldolase [mptD].', NULL, 'DHNA_arch', NULL, NULL, 23952, 7),
(237097, NULL, 'MF_01411', NULL, NULL, 'LPS-assembly protein LptD [lptD].', NULL, 'LPS_assembly_LptD', NULL, NULL, 20588, 7),
(237098, NULL, 'MF_01055', NULL, NULL, 'Protein FixA [fixA].', NULL, 'FixA', NULL, NULL, 16392, 7),
(237099, NULL, 'MF_03007', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit H [EIF3H].', NULL, 'eIF3h', NULL, NULL, 25491, 7),
(237100, NULL, 'MF_00756', NULL, NULL, 'Ribonuclease P protein component 3 [rnp3].', NULL, 'RNase_P_3', NULL, NULL, 16694, 7),
(237101, NULL, 'MF_01339', NULL, NULL, 'Ribulose bisphosphate carboxylase [cbbM].', NULL, 'RuBisCO_L_type2', NULL, NULL, 21170, 7),
(237102, NULL, 'MF_00226_A', NULL, NULL, 'Putative competence-damage inducible protein [cinA].', NULL, 'CinA_A', NULL, NULL, 15030, 7),
(237103, NULL, 'MF_00670', NULL, NULL, 'Altronate oxidoreductase [uxaB].', NULL, 'Altron_oxidoreduct', NULL, NULL, 16184, 7),
(237104, NULL, 'MF_00975', NULL, NULL, 'Exosome complex component Csl4 [csl4].', NULL, 'Exosome_Csl4', NULL, NULL, 22194, 7),
(237105, NULL, 'MF_01164', NULL, NULL, 'Undecaprenyl-phosphate 4-deoxy-4-formamido-L-arabinose transferase [arnC].', NULL, 'ArnC_transfer', NULL, NULL, 17138, 7),
(237106, NULL, 'MF_04128', NULL, NULL, 'Protein VP3.', NULL, 'Rota_VP3_A', NULL, NULL, 10967, 7),
(237107, NULL, 'MF_02110', NULL, NULL, 'UPF0763 protein <locus_tag>.', NULL, 'UPF0763', NULL, NULL, 20697, 7),
(237108, NULL, 'MF_01001', NULL, NULL, 'UDP-N-acetyl-D-mannosaminuronic acid transferase [wecG].', NULL, 'WecG_RffM', NULL, NULL, 15928, 7),
(237109, NULL, 'MF_02234', NULL, NULL, 'N-acetylornithine carbamoyltransferase [argF''].', NULL, 'AOTCase', NULL, NULL, 35003, 7),
(237110, NULL, 'MF_04011', NULL, NULL, 'DNA primase.', NULL, 'HSV_PRIM', NULL, NULL, 28400, 7),
(237111, NULL, 'MF_03202', NULL, NULL, 'Elongation of very long chain fatty acids protein 2 [ELOVL2].', NULL, 'VLCF_elongase_2', NULL, NULL, 29577, 7),
(237112, NULL, 'MF_00014', NULL, NULL, 'Ribosome maturation factor RimM [rimM].', NULL, 'Ribosome_mat_RimM', NULL, NULL, 11433, 7),
(237113, NULL, 'MF_00079', NULL, NULL, 'ATP phosphoribosyltransferase [hisG].', NULL, 'HisG_Long', NULL, NULL, 19811, 7),
(237114, NULL, 'MF_01323', NULL, NULL, 'DNA-directed RNA polymerase subunit gamma [rpoC1].', NULL, 'RNApol_bact_RpoC1', NULL, NULL, 29326, 7),
(237115, NULL, 'MF_01912', NULL, NULL, 'Sulfofructosephosphate aldolase.', NULL, 'SFP_aldolase', NULL, NULL, 16335, 7),
(237116, NULL, 'MF_01222', NULL, NULL, 'Protein archease.', NULL, 'Archease_arch', NULL, NULL, 14735, 7),
(237117, NULL, 'MF_02016', NULL, NULL, 'Membrane-bound lytic murein transglycosylase F [mltF].', NULL, 'MltF', NULL, NULL, 16066, 7),
(237118, NULL, 'MF_02093', NULL, NULL, 'Probable beta-carotene 15,15''-dioxygenase.', NULL, 'Beta_carotene_diox', NULL, NULL, 15171, 7),
(237119, NULL, 'MF_01551', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase M [rlmM].', NULL, '23SrRNA_methyltr_M', NULL, NULL, 10893, 7),
(237120, NULL, 'MF_00626', NULL, NULL, 'Germination protease [gpr].', NULL, 'Germination_prot', NULL, NULL, 10123, 7),
(237121, NULL, 'MF_00773', NULL, NULL, '50S ribosomal protein L24e [rpl24e].', NULL, 'Ribosomal_L24e', NULL, NULL, 16258, 7),
(237122, NULL, 'MF_01844', NULL, NULL, 'Na(+)/H(+) antiporter NhaA [nhaA].', NULL, 'NhaA', NULL, NULL, 2613, 7),
(237123, NULL, 'MF_00971', NULL, NULL, 'DNA-binding protein MutS2 [mutS2].', NULL, 'MutS2_archaea', NULL, NULL, 13388, 7),
(237124, NULL, 'MF_00600', NULL, NULL, 'Chaperonin GroEL [groEL].', NULL, 'CH60', NULL, NULL, 4116, 7);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(237125, NULL, 'MF_01978', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase [pfp].', NULL, 'Phosphofructokinase_II_B2', NULL, NULL, 7572, 7),
(237126, NULL, 'MF_04131', NULL, NULL, 'Outer capsid glycoprotein VP7.', NULL, 'Rota_VP7_A', NULL, NULL, 2125, 7),
(237127, NULL, 'MF_01393', NULL, NULL, 'ATP synthase subunit a [atpB].', NULL, 'ATP_synth_a_bact', NULL, NULL, 5815, 7),
(237128, NULL, 'MF_01311', NULL, NULL, 'Protein-disulfide oxidoreductase DsbI [dsbI].', NULL, 'DsbI', NULL, NULL, 11628, 7),
(237129, NULL, 'MF_01456', NULL, NULL, 'NAD(P)H-quinone oxidoreductase subunit 4L, chloroplastic [ndhE].', NULL, 'NDH1_NuoK', NULL, NULL, 1167, 7),
(237130, NULL, 'MF_01876', NULL, NULL, 'Pseudouridine-5''-phosphate glycosidase [psuG].', NULL, 'PsiMP_glycosidase', NULL, NULL, 5832, 7),
(237131, NULL, 'MF_00270', NULL, NULL, '30S ribosomal protein S18 [rpsR].', NULL, 'Ribosomal_S18', NULL, NULL, 5190, 7),
(237132, NULL, 'MF_03035', NULL, NULL, 'Polyribonucleotide 5''-hydroxyl-kinase Clp1 [CLP1].', NULL, 'Clp1', NULL, NULL, 25716, 7),
(237133, NULL, 'MF_00777', NULL, NULL, '30S ribosomal protein S27ae [rps27ae].', NULL, 'Ribosomal_S27ae', NULL, NULL, 14761, 7),
(237134, NULL, 'MF_01082', NULL, NULL, 'tRNA pseudouridine synthase D [truD].', NULL, 'TruD', NULL, NULL, 3207, 7),
(237135, NULL, 'MF_01335', NULL, NULL, 'Cytochrome b6-f complex iron-sulfur subunit [petC].', NULL, 'Cytb6_f_Rieske', NULL, NULL, 8496, 7),
(237136, NULL, 'MF_00826', NULL, NULL, 'Glycine/sarcosine/betaine reductase complex component A [grdA].', NULL, 'GRDA', NULL, NULL, 3806, 7),
(237137, NULL, 'MF_04057', NULL, NULL, 'Packaging protein 1 [IVa2].', NULL, 'ADV_PKG1', NULL, NULL, 4353, 7),
(237138, NULL, 'MF_02048', NULL, NULL, 'D-aminoacyl-tRNA deacylase [dtd3].', NULL, 'Deacylase_DTD3', NULL, NULL, 29077, 7),
(237139, NULL, 'MF_00995', NULL, NULL, 'Chorismate dehydratase [mqnA].', NULL, 'MqnA', NULL, NULL, 22923, 7),
(237140, NULL, 'MF_03030', NULL, NULL, 'Mitochondrial genome maintenance exonuclease 1 [MGME1].', NULL, 'MGME1', NULL, NULL, NULL, 7),
(237141, NULL, 'MF_03230', NULL, NULL, 'Acyl-coenzyme A diphosphatase FITM2 [FITM2].', NULL, 'FITM2', NULL, NULL, 37740, 7),
(237142, NULL, 'MF_01271', NULL, NULL, 'N-acetyl-D-glucosamine kinase [nagK].', NULL, 'GlcNAc_kinase', NULL, NULL, 16211, 7),
(237143, NULL, 'MF_03015', NULL, NULL, '40S ribosomal protein SA [rps-0].', NULL, 'Ribosomal_S2_euk', NULL, NULL, 25845, 7),
(237144, NULL, 'MF_04204', NULL, NULL, 'Envelope small membrane protein [E].', NULL, 'BETA_CORONA_E', NULL, NULL, 34187, 7),
(237145, NULL, 'MF_01062', NULL, NULL, 'Phosphoenolpyruvate synthase regulatory protein [ppsR].', NULL, 'PSRP', NULL, NULL, 23291, 7),
(237146, NULL, 'MF_04026', NULL, NULL, 'Ribonucleoside-diphosphate reductase large subunit [RIR1].', NULL, 'HSV_RIR1', NULL, NULL, 8274, 7),
(237147, NULL, 'MF_00445', NULL, NULL, 'NAD(P)H-quinone oxidoreductase subunit 2, chloroplastic [ndhB].', NULL, 'NDH1_NuoN_1', NULL, NULL, 2288, 7),
(237148, NULL, 'MF_01369_A', NULL, NULL, '50S ribosomal protein L23 [rplW].', NULL, 'Ribosomal_L23_A', NULL, NULL, 11244, 7),
(237149, NULL, 'MF_03169', NULL, NULL, 'GTP:AMP phosphotransferase AK3, mitochondrial [AK3].', NULL, 'Adenylate_kinase_AK3', NULL, NULL, 23870, 7),
(237150, NULL, 'MF_00046', NULL, NULL, 'UDP-N-acetylmuramate--L-alanine ligase [murC].', NULL, 'MurC', NULL, NULL, 4705, 7),
(237151, NULL, 'MF_00228', NULL, NULL, 'Hydroxyethylthiazole kinase [thiM].', NULL, 'Thz_kinase', NULL, NULL, 6810, 7),
(237152, NULL, 'MF_00813', NULL, NULL, 'Probable allantoicase [alc].', NULL, 'Allantoicase', NULL, NULL, 4645, 7),
(237153, NULL, 'MF_00951', NULL, NULL, 'Transcription antitermination protein RfaH [rfaH].', NULL, 'RfaH', NULL, NULL, 4399, 7),
(237154, NULL, 'MF_04015', NULL, NULL, 'Tripartite terminase subunit 2 [TRM2].', NULL, 'HSV_TRM2', NULL, NULL, 5438, 7),
(237155, NULL, 'MF_03221', NULL, NULL, 'Succinate--CoA ligase [GDP-forming] subunit beta, mitochondrial [SUCLG2].', NULL, 'Succ_CoA_betaG_euk', NULL, NULL, 29321, 7),
(237156, NULL, 'MF_04114', NULL, NULL, 'Portal protein.', NULL, 'PORTAL_T4', NULL, NULL, 10597, 7);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(237157, NULL, 'MF_00931', NULL, NULL, 'Aldehyde decarbonylase.', NULL, 'Aldeh_decarbonylase', NULL, NULL, 16560, 7),
(237158, NULL, 'MF_01897', NULL, NULL, 'DNA gyrase subunit A [gyrA].', NULL, 'GyrA', NULL, NULL, 4677, 7),
(237159, NULL, 'MF_04086', NULL, NULL, 'RNA-directed RNA polymerase L [L].', NULL, 'ARENA_L', NULL, NULL, 10282, 7),
(237160, NULL, 'MF_04056', NULL, NULL, 'Pre-histone-like nucleoprotein [L2].', NULL, 'ADV_PVII', NULL, NULL, 1881, 7),
(237161, NULL, 'MF_01342', NULL, NULL, '50S ribosomal protein L16 [rplP].', NULL, 'Ribosomal_L16', NULL, NULL, 2905, 7),
(237162, NULL, 'MF_00816', NULL, NULL, 'UPF0352 protein YejL [yejL].', NULL, 'UPF0352', NULL, NULL, 14258, 7),
(237163, NULL, 'MF_01375', NULL, NULL, 'Phosphonoacetaldehyde hydrolase [phnX].', NULL, 'PhnX', NULL, NULL, 4746, 7),
(237164, NULL, 'MF_00127', NULL, NULL, 'Histidine--tRNA ligase [hisS].', NULL, 'His_tRNA_synth', NULL, NULL, 12773, 7),
(237165, NULL, 'MF_00060', NULL, NULL, '5''/3''-nucleotidase SurE [surE].', NULL, 'SurE', NULL, NULL, 22685, 7),
(237166, NULL, 'MF_03175', NULL, NULL, 'Methionine aminopeptidase 2 [METAP2].', NULL, 'MetAP_2_euk', NULL, NULL, 6844, 7),
(237167, NULL, 'MF_00058', NULL, NULL, 'F420-dependent methylenetetrahydromethanopterin dehydrogenase [mtd].', NULL, 'MTD', NULL, NULL, 5526, 7),
(237168, NULL, 'MF_00409', NULL, NULL, 'Tetraacyldisaccharide 4''-kinase [lpxK].', NULL, 'LpxK', NULL, NULL, 2245, 7),
(237169, NULL, 'MF_01491', NULL, NULL, 'Ribonuclease J [rnj].', NULL, 'RNase_J_bact', NULL, NULL, 23541, 7),
(237170, NULL, 'MF_04121', NULL, NULL, 'Peptidoglycan transglycosylase gp16.', NULL, 'TRANSGLYCOSYLASE_T7', NULL, NULL, 32632, 7),
(237171, NULL, 'MF_00616', NULL, NULL, 'Ureidoglycolate lyase [allA].', NULL, 'Ureidogly_lyase', NULL, NULL, 16105, 7),
(237172, NULL, 'MF_01810', NULL, NULL, 'Membrane protein insertase YidC [yidC].', NULL, 'YidC_type1', NULL, NULL, 11506, 7),
(237173, NULL, 'MF_04040', NULL, NULL, 'Cytoplasmic envelopment protein 3.', NULL, 'HSV_CEP3_alphahv', NULL, NULL, 22096, 7),
(237174, NULL, 'MF_01404', NULL, NULL, 'Pyruvoyl-dependent arginine decarboxylase [pdaD].', NULL, 'PvlArgDC', NULL, NULL, 3752, 7),
(237175, NULL, 'MF_01495', NULL, NULL, 'Photosystem II CP47 reaction center protein [psbB].', NULL, 'PSII_PsbB_CP47', NULL, NULL, 20689, 7),
(237176, NULL, 'MF_00220_B', NULL, NULL, 'Dihydroorotase [pyrC].', NULL, 'PyrC_classI_B', NULL, NULL, 3107, 7),
(237177, NULL, 'MF_00788', NULL, NULL, '50S ribosomal protein L40e [rpl40e].', NULL, 'Ribosomal_L40e', NULL, NULL, 16292, 7),
(237178, NULL, 'MF_04061', NULL, NULL, 'Preterminal protein [PTP].', NULL, 'ADV_TERM', NULL, NULL, 5404, 7),
(237179, NULL, 'MF_00265', NULL, NULL, 'tRNA(fMet)-specific endonuclease VapC [vapC].', NULL, 'VapC_Nob1', NULL, NULL, 17485, 7),
(237180, NULL, 'MF_01970', NULL, NULL, 'Kynureninase [kynU].', NULL, 'Kynureninase', NULL, NULL, 2098, 7),
(237181, NULL, 'MF_00950', NULL, NULL, 'Transcription elongation factor Spt5 [spt5].', NULL, 'Spt5_arch', NULL, NULL, 11365, 7),
(237182, NULL, 'MF_00467', NULL, NULL, 'Probable M18 family aminopeptidase 2 [apeB].', NULL, 'Aminopeptidase_M18_2', NULL, NULL, 15010, 7),
(237183, NULL, 'MF_01157', NULL, NULL, 'DnaA initiator-associating protein DiaA [diaA].', NULL, 'SIS_DiaA', NULL, NULL, 15367, 7),
(237184, NULL, 'MF_04044', NULL, NULL, 'Large tegument protein deneddylase.', NULL, 'HSV_LTP', NULL, NULL, 7539, 7),
(237185, NULL, 'MF_03048', NULL, NULL, 'Ubiquitin-related modifier 1 [URM1].', NULL, 'Urm1', NULL, NULL, 10531, 7),
(237186, NULL, 'MF_00845', NULL, NULL, 'Flavin-dependent monooxygenase.', NULL, 'TetX_monooxygenase', NULL, NULL, 35225, 7),
(237187, NULL, 'MF_01215', NULL, NULL, 'Orotidine 5''-phosphate decarboxylase [pyrF].', NULL, 'OMPdecase_type2', NULL, NULL, 12206, 7),
(237188, NULL, 'MF_00371', NULL, NULL, '30S ribosomal protein S27e [rps27e].', NULL, 'Ribosomal_S27e', NULL, NULL, 5666, 7),
(237189, NULL, 'MF_01577', NULL, NULL, 'Putative multidrug resistance protein MdtD [mdtD].', NULL, 'MFS_MdtD', NULL, NULL, 7321, 7),
(237190, NULL, 'MF_00376', NULL, NULL, 'Dephospho-CoA kinase [coaE].', NULL, 'Dephospho_CoA_kinase', NULL, NULL, 4095, 7);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(237191, NULL, 'MF_01163', NULL, NULL, '5-formaminoimidazole-4-carboxamide-1-(beta)-D-ribofuranosyl 5''-monophosphate synthetase [purP].', NULL, 'IMP_biosynth_PurP', NULL, NULL, 724, 7),
(237192, NULL, 'MF_01576', NULL, NULL, 'Bifunctional protein FolD [folD].', NULL, 'THF_DHG_CYH', NULL, NULL, 6568, 7),
(237193, NULL, 'MF_01417', NULL, NULL, 'Biosynthetic arginine decarboxylase [speA].', NULL, 'SpeA', NULL, NULL, 7168, 7),
(237194, NULL, 'MF_04119', NULL, NULL, 'Minor capsid protein.', NULL, 'CAPSID_PROTEIN_T7', NULL, NULL, 27462, 7),
(237195, NULL, 'MF_00172', NULL, NULL, '5-methyltetrahydropteroyltriglutamate--homocysteine methyltransferase [metE].', NULL, 'Meth_synth', NULL, NULL, 3772, 7),
(237196, NULL, 'MF_00253_A', NULL, NULL, 'Glycine--tRNA ligase [glyQS].', NULL, 'Gly_tRNA_synth_A', NULL, NULL, 17925, 7),
(237197, NULL, 'MF_00678', NULL, NULL, 'UPF0262 protein <locus_tag>.', NULL, 'UPF0262', NULL, NULL, 7804, 7),
(237198, NULL, 'MF_03206', NULL, NULL, 'Elongation of very long chain fatty acids protein 6 [ELOVL6].', NULL, 'VLCF_elongase_6', NULL, NULL, 29955, 7),
(237199, NULL, 'MF_01315', NULL, NULL, '30S ribosomal protein S13 [rpsM].', NULL, 'Ribosomal_S13_S18', NULL, NULL, 4401, 7),
(237200, NULL, 'MF_01421', NULL, NULL, 'UPF0323 lipoprotein <locus_tag>.', NULL, 'UPF0323', NULL, NULL, 14947, 7),
(237201, NULL, 'MF_01309_A', NULL, NULL, '30S ribosomal protein S3 [rpsC].', NULL, 'Ribosomal_S3_A', NULL, NULL, 25869, 7),
(237202, NULL, 'MF_00296', NULL, NULL, 'Homoserine O-acetyltransferase [metXA].', NULL, 'MetX_acyltransf', NULL, NULL, 886, 7),
(237203, NULL, 'MF_00272', NULL, NULL, 'Glycine cleavage system H protein [gcvH].', NULL, 'GcvH', NULL, NULL, 6929, 7),
(237204, NULL, 'MF_01475', NULL, NULL, '50S ribosomal protein L19e [rpl19e].', NULL, 'Ribosomal_L19e', NULL, NULL, 1105, 7),
(237205, NULL, 'MF_04083', NULL, NULL, 'Envelope glycoprotein gp160 [env].', NULL, 'HIV_ENV', NULL, NULL, 32722, 7),
(237206, NULL, 'MF_04201', NULL, NULL, 'Membrane protein [M].', NULL, 'ALPHA_CORONA_M', NULL, NULL, 35253, 7),
(237207, NULL, 'MF_02057', NULL, NULL, 'tRNA 5-carboxymethoxyuridine methyltransferase [cmoM].', NULL, 'tRNA_methyltr_CmoM', NULL, NULL, 30712, 7),
(237208, NULL, 'MF_00065', NULL, NULL, 'Adenylyl-sulfate kinase [cysC].', NULL, 'Adenylyl_sulf_kinase', NULL, NULL, 6483, 7),
(237209, NULL, 'MF_01286', NULL, NULL, 'Digeranylgeranylglyceryl phosphate synthase.', NULL, 'DGGGP_synth', NULL, NULL, 16596, 7),
(237210, NULL, 'MF_00367', NULL, NULL, 'GTPase Era [era].', NULL, 'GTPase_Era', NULL, NULL, 3580, 7),
(237211, NULL, 'MF_00495', NULL, NULL, 'Phosphoglycolate phosphatase [gph].', NULL, 'GPH_hydrolase_bact', NULL, NULL, 33624, 7),
(237212, NULL, 'MF_00720', NULL, NULL, 'Primosomal replication protein N [priB].', NULL, 'PriB', NULL, NULL, 16241, 7),
(237213, NULL, 'MF_00844_B', NULL, NULL, 'Rqc2 homolog RqcH [rqcH].', NULL, 'RqcH_B', NULL, NULL, 35022, 7),
(237214, NULL, 'MF_04141', NULL, NULL, 'NAD--protein ADP-ribosyltransferase modA [modA].', NULL, 'MODA_T4', NULL, NULL, 35262, 7),
(237215, NULL, 'MF_00787', NULL, NULL, 'Cobalt-precorrin-5B C(1)-methyltransferase [cbiD].', NULL, 'CbiD', NULL, NULL, 3670, 7),
(237216, NULL, 'MF_04070', NULL, NULL, 'Nucleoprotein [NP].', NULL, 'INFV_NCAP', NULL, NULL, 1126, 7),
(237217, NULL, 'MF_00734', NULL, NULL, 'Tagatose 1,6-diphosphate aldolase [lacD].', NULL, 'LacD', NULL, NULL, 224, 7),
(237218, NULL, 'MF_04117', NULL, NULL, 'Major capsid protein.', NULL, 'CAPSID_H_T4', NULL, NULL, 32630, 7),
(237219, NULL, 'MF_02120', NULL, NULL, 'Diaminopimelate decarboxylase [lysA].', NULL, 'LysA', NULL, NULL, 7012, 7),
(237220, NULL, 'MF_01560', NULL, NULL, 'UPF0358 protein <locus_tag>.', NULL, 'UPF0358', NULL, NULL, 8315, 7),
(237221, NULL, 'MF_01006', NULL, NULL, 'Undecaprenyl-diphosphatase [uppP].', NULL, 'Undec_diphosphatase', NULL, NULL, 3431, 7),
(237222, NULL, 'MF_00783', NULL, NULL, 'Probable flagellum biosynthesis repressor protein FlbT [flbT].', NULL, 'FlbT', NULL, NULL, 8159, 7),
(237223, NULL, 'MF_01667', NULL, NULL, 'Glyoxylate/hydroxypyruvate reductase B [ghrB].', NULL, '2_Hacid_dh_C_GhrB', NULL, NULL, 10828, 7);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(237224, NULL, 'MF_03107', NULL, NULL, 'Very-long-chain 3-oxoacyl-CoA reductase.', NULL, '3_ketoreductase', NULL, NULL, 25307, 7),
(237225, NULL, 'MF_01982', NULL, NULL, '2-phytyl-1,4-naphtoquinone methyltransferase [menG].', NULL, 'MenG_phylloquinone_subfam', NULL, NULL, 24291, 7),
(237226, NULL, 'MF_02095', NULL, NULL, '3''(2''),5''-bisphosphate nucleotidase CysQ [cysQ].', NULL, 'CysQ', NULL, NULL, 3821, 7),
(237227, NULL, 'MF_01427', NULL, NULL, '3''-5'' exoribonuclease YhaM [yhaM].', NULL, '3_5_Exoribonuc_YhaM', NULL, NULL, 21498, 7),
(237228, NULL, 'MF_02235', NULL, NULL, 'N-succinylornithine carbamoyltransferase [argF''].', NULL, 'SOTCase', NULL, NULL, 35046, 7),
(237229, NULL, 'MF_00779', NULL, NULL, 'Hut operon positive regulatory protein [hutP].', NULL, 'HutP', NULL, NULL, 16117, 7),
(237230, NULL, 'MF_01550', NULL, NULL, 'Guanosine-5''-triphosphate,3''-diphosphate pyrophosphatase [gppA].', NULL, 'GppA', NULL, NULL, 7429, 7),
(237231, NULL, 'MF_01943', NULL, NULL, 'Lipid A biosynthesis palmitoleoyltransferase [lpxP].', NULL, 'Lipid_A_LpxP', NULL, NULL, 23874, 7),
(237232, NULL, 'MF_00054_A', NULL, NULL, 'Elongation factor G [fusA].', NULL, 'EF_G_EF_2_A', NULL, NULL, 918, 7),
(237233, NULL, 'MF_00959', NULL, NULL, 'RNA polymerase sigma factor RpoS [rpoS].', NULL, 'Sigma70_RpoS', NULL, NULL, 9851, 7),
(237234, NULL, 'MF_03105', NULL, NULL, 'Mitochondrial distribution and morphology protein 34 [MDM34].', NULL, 'Mdm34', NULL, NULL, 23510, 7),
(237235, NULL, 'MF_01816', NULL, NULL, 'Tyrosine recombinase XerS [xerS].', NULL, 'Recomb_XerS', NULL, NULL, 789, 7),
(237236, NULL, 'MF_01364_B', NULL, NULL, '30S ribosomal protein S14 type Z [rpsZ].', NULL, 'Ribosomal_S14_2_B', NULL, NULL, 15189, 7),
(237237, NULL, 'MF_01480', NULL, NULL, 'CRISPR-associated endonuclease Cas9 [cas9].', NULL, 'Cas9', NULL, NULL, 25856, 7),
(237238, NULL, 'MF_02056', NULL, NULL, 'O-succinylhomoserine sulfhydrylase [metZ].', NULL, 'MetZ', NULL, NULL, 3655, 7),
(237239, NULL, 'MF_00219', NULL, NULL, 'Dihydroorotase [pyrC].', NULL, 'PyrC_classII', NULL, NULL, 3154, 7),
(237240, NULL, 'MF_01240', NULL, NULL, 'UPF0309 protein <locus_tag>.', NULL, 'UPF0309', NULL, NULL, 14592, 7),
(237241, NULL, 'MF_01148', NULL, NULL, 'Apolipoprotein N-acyltransferase [lnt].', NULL, 'Lnt', NULL, NULL, 768, 7),
(237242, NULL, 'MF_01070', NULL, NULL, 'Phosphoglycerol transferase I [mdoB].', NULL, 'MdoB_OpgB', NULL, NULL, 19891, 7),
(237243, NULL, 'MF_01437', NULL, NULL, 'CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase [pgsA].', NULL, 'PgsA', NULL, NULL, 14769, 7),
(237244, NULL, 'MF_04109', NULL, NULL, 'Endolysin.', NULL, 'ENDOLYSIN_LAMBDA', NULL, NULL, 7489, 7),
(237245, NULL, 'MF_00501', NULL, NULL, '50S ribosomal protein L31 [rpmE].', NULL, 'Ribosomal_L31_1', NULL, NULL, 25969, 7),
(237246, NULL, 'MF_00316', NULL, NULL, 'Molybdenum cofactor guanylyltransferase [mobA].', NULL, 'MobA', NULL, NULL, 10190, 7),
(237247, NULL, 'MF_01061', NULL, NULL, 'Primosomal protein 1 [dnaT].', NULL, 'DnaT', NULL, NULL, 20584, 7),
(237248, NULL, 'MF_00154', NULL, NULL, 'Protoheme IX farnesyltransferase [cyoE].', NULL, 'CyoE_CtaB', NULL, NULL, 5512, 7),
(237249, NULL, 'MF_00916', NULL, NULL, 'Epoxyqueuosine reductase [queG].', NULL, 'QueG', NULL, NULL, 7038, 7),
(237250, NULL, 'MF_01230', NULL, NULL, 'Haloalkane dehalogenase [dhmA].', NULL, 'Haloalk_dehal_type1', NULL, NULL, 16237, 7),
(237251, NULL, 'MF_01496', NULL, NULL, 'Photosystem II CP43 reaction center protein [psbC].', NULL, 'PSII_PsbC_CP43', NULL, NULL, 6871, 7),
(237252, NULL, 'MF_04110', NULL, NULL, 'Endolysin.', NULL, 'ENDOLYSIN_T4', NULL, NULL, 7108, 7),
(237253, NULL, 'MF_00567', NULL, NULL, 'Quinolinate synthase A [nadA].', NULL, 'NadA_type1', NULL, NULL, 16008, 7),
(237254, NULL, 'MF_00764', NULL, NULL, 'UPF0306 protein YhbP [yhbP].', NULL, 'UPF0306', NULL, NULL, 10509, 7),
(237255, NULL, 'MF_00828', NULL, NULL, 'Photosystem I reaction center subunit XII [psaM].', NULL, 'PSI_PsaM', NULL, NULL, 8858, 7),
(237256, NULL, 'MF_01243', NULL, NULL, 'Formamidase [amiF].', NULL, 'Formamidase', NULL, NULL, 17280, 7);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(237257, NULL, 'MF_00742', NULL, NULL, 'Formyl-CoA:oxalate CoA-transferase [frc].', NULL, 'Formyl_CoA_transfer', NULL, NULL, 17317, 7),
(237258, NULL, 'MF_00965', NULL, NULL, 'ATP-dependent RNA helicase DbpA [dbpA].', NULL, 'DEAD_helicase_DbpA', NULL, NULL, 25306, 7),
(237259, NULL, 'MF_00413', NULL, NULL, 'Sulfur carrier protein TusA [tusA].', NULL, 'Thiourid_synth_A', NULL, NULL, 14771, 7),
(237260, NULL, 'MF_01360', NULL, NULL, 'UPF0367 protein <locus_tag>.', NULL, 'UPF0367', NULL, NULL, 20702, 7),
(237261, NULL, 'MF_01963', NULL, NULL, 'S-methyl-5''-thioadenosine phosphorylase [mtnP].', NULL, 'MTAP', NULL, NULL, 5106, 7),
(237262, NULL, 'MF_00973', NULL, NULL, 'Gluconeogenesis factor.', NULL, 'Gluconeogen_factor', NULL, NULL, 10984, 7),
(237263, NULL, 'MF_01486', NULL, NULL, 'RecBCD enzyme subunit RecC [recC].', NULL, 'RecC', NULL, NULL, 2394, 7),
(237264, NULL, 'MF_00348', NULL, NULL, 'DNA repair and recombination protein RadA [radA].', NULL, 'RadA_arch', NULL, NULL, 11371, 7),
(237265, NULL, 'MF_01047', NULL, NULL, 'UPF0227 protein YcfP [ycfP].', NULL, 'UPF0227', NULL, NULL, 15211, 7),
(237266, NULL, 'MF_00821', NULL, NULL, 'Protein-export protein SecB [secB].', NULL, 'SecB', NULL, NULL, 2087, 7),
(237267, NULL, 'MF_01246', NULL, NULL, 'Chitooligosaccharide deacetylase [chbG].', NULL, 'COD', NULL, NULL, 14893, 7),
(237268, NULL, 'MF_00073', NULL, NULL, 'Transcription antitermination protein NusB [nusB].', NULL, 'NusB', NULL, NULL, 11454, 7),
(237269, NULL, 'MF_01453', NULL, NULL, 'ATP-dependent helicase/deoxyribonuclease subunit B [rexB].', NULL, 'AddB_type2', NULL, NULL, 14394, 7),
(237270, NULL, 'MF_04087', NULL, NULL, 'RING finger protein Z [Z].', NULL, 'ARENA_Z', NULL, NULL, 13458, 7),
(237271, NULL, 'MF_01946', NULL, NULL, 'Tubulin-like protein CetZ [cetZ].', NULL, 'CetZ', NULL, NULL, 24257, 7),
(237272, NULL, 'MF_01392', NULL, NULL, 'Cytochrome c biogenesis protein Ccs1 [ccs1].', NULL, 'CytC_Ccs1', NULL, NULL, 16722, 7),
(237273, NULL, 'MF_01365_A', NULL, NULL, '50S ribosomal protein L6 [rplF].', NULL, 'Ribosomal_L6_A', NULL, NULL, 11800, 7),
(237274, NULL, 'MF_04151', NULL, NULL, 'Pre-baseplate central spike protein Gp5 [5].', NULL, 'NEEDLE_T4', NULL, NULL, 37533, 7),
(237275, NULL, 'MF_00029', NULL, NULL, '30S ribosomal protein S8e [rps8e].', NULL, 'Ribosomal_S8e', NULL, NULL, 14505, 7),
(237276, NULL, 'MF_00644', NULL, NULL, 'Photosystem II reaction center protein Z [psbZ].', NULL, 'PSII_PsbZ', NULL, NULL, 2813, 7),
(237277, NULL, 'MF_01696', NULL, NULL, '1D-myo-inositol 2-acetamido-2-deoxy-alpha-D-glucopyranoside deacetylase [mshB].', NULL, 'MshB', NULL, NULL, 19265, 7),
(237278, NULL, 'MF_01988', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit alpha [sucD].', NULL, 'Succ_CoA_alpha', NULL, NULL, 5670, 7),
(237279, NULL, 'MF_00248', NULL, NULL, 'ATP-dependent protease subunit HslV [hslV].', NULL, 'HslV', NULL, NULL, 15133, 7),
(237280, NULL, 'MF_01636', NULL, NULL, '3-octaprenyl-4-hydroxybenzoate carboxy-lyase [ubiD].', NULL, 'UbiD', NULL, NULL, 16126, 7),
(237281, NULL, 'MF_00390', NULL, NULL, 'Sulfurtransferase TusD [tusD].', NULL, 'Thiourid_synth_D', NULL, NULL, 20547, 7),
(237282, NULL, 'MF_00643', NULL, NULL, 'Cytochrome b559 subunit beta [psbF].', NULL, 'PSII_PsbF', NULL, NULL, 3917, 7),
(237283, NULL, 'MF_01279', NULL, NULL, 'Xaa-Pro dipeptidase [pepQ].', NULL, 'X_Pro_dipeptid', NULL, NULL, 17068, 7),
(237284, NULL, 'MF_00317', NULL, NULL, 'DNA polymerase sliding clamp [pcn].', NULL, 'DNApol_clamp_arch', NULL, NULL, 6819, 7),
(237285, NULL, 'MF_01108', NULL, NULL, 'Acetylornithine deacetylase [argE].', NULL, 'ArgE', NULL, NULL, 10727, 7),
(237286, NULL, 'MF_01413', NULL, NULL, 'Glutathione-regulated potassium-efflux system protein KefC [kefC].', NULL, 'K_H_efflux_KefC', NULL, NULL, 10043, 7),
(237287, NULL, 'MF_01111', NULL, NULL, 'UPF0200 protein <locus_tag>.', NULL, 'UPF0200', NULL, NULL, 14944, 7),
(237288, NULL, 'MF_00284', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit [pheT].', NULL, 'Phe_tRNA_synth_beta2', NULL, NULL, 17162, 7),
(237289, NULL, 'MF_01067', NULL, NULL, 'UPF0259 membrane protein YciC [yciC].', NULL, 'UPF0259', NULL, NULL, 1616, 7);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(237290, NULL, 'MF_04078', NULL, NULL, 'Protein Nef [nef].', NULL, 'NEF_HIV', NULL, NULL, 3382, 7),
(237291, NULL, 'MF_00856', NULL, NULL, 'RuBisCO accumulation factor 1 [raf1].', NULL, 'Raf1', NULL, NULL, 34725, 7),
(237292, NULL, 'MF_00421', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase subunit PurQ [purQ].', NULL, 'PurQ', NULL, NULL, 2154, 7),
(237293, NULL, 'MF_01608', NULL, NULL, 'Coenzyme A disulfide reductase [cdr].', NULL, 'CoA_diS_reduct', NULL, NULL, 16795, 7),
(237294, NULL, 'MF_00994', NULL, NULL, 'Lipopolysaccharide assembly protein B [lapB].', NULL, 'LPS_assembly_LapB', NULL, NULL, 22841, 7),
(237295, NULL, 'MF_00900', NULL, NULL, 'GTPase HflX [hflX].', NULL, 'GTPase_HflX', NULL, NULL, 16478, 7),
(237296, NULL, 'MF_03203', NULL, NULL, 'Elongation of very long chain fatty acids protein 3 [ELOVL3].', NULL, 'VLCF_elongase_3', NULL, NULL, 29647, 7),
(237297, NULL, 'MF_01692', NULL, NULL, 'N-acetyldiaminopimelate deacetylase.', NULL, 'DapEL', NULL, NULL, 18043, 7),
(237298, NULL, 'MF_03130', NULL, NULL, 'Alpha-tubulin N-acetyltransferase 1 [mec-17].', NULL, 'mec17', NULL, NULL, 4497, 7),
(237299, NULL, 'MF_03028', NULL, NULL, 'Pescadillo homolog [PES1].', NULL, 'Pescadillo', NULL, NULL, 8253, 7),
(237300, NULL, 'MF_00512', NULL, NULL, '30S ribosomal protein S6e [rps6e].', NULL, 'Ribosomal_S6e', NULL, NULL, 14541, 7),
(237301, NULL, 'MF_00647', NULL, NULL, 'Phosphopantetheine adenylyltransferase [coaD].', NULL, 'PPAT_arch', NULL, NULL, 16088, 7),
(237302, NULL, 'MF_01081', NULL, NULL, 'Probable tRNA pseudouridine synthase B [truB].', NULL, 'TruB_arch', NULL, NULL, 23907, 7),
(237303, NULL, 'MF_00234', NULL, NULL, 'Adenylate kinase [adkA].', NULL, 'Adenylate_kinase_AdkA', NULL, NULL, 16480, 7),
(237304, NULL, 'MF_02239', NULL, NULL, 'Protoporphyrinogen IX oxidase.', NULL, 'HemJ', NULL, NULL, 4201, 7),
(237305, NULL, 'MF_00521', NULL, NULL, '3-deoxy-D-manno-octulosonic acid kinase [kdkA].', NULL, 'KDO_kinase', NULL, NULL, 17105, 7),
(237306, NULL, 'MF_00314', NULL, NULL, 'V-type ATP synthase subunit C [atpC].', NULL, 'ATP_synth_C_arch', NULL, NULL, 8640, 7),
(237307, NULL, 'MF_00696', NULL, NULL, 'Fatty acid metabolism regulator protein [fadR].', NULL, 'HTH_FadR', NULL, NULL, 8507, 7),
(237308, NULL, 'MF_00753', NULL, NULL, 'Anaerobic glycerol-3-phosphate dehydrogenase subunit B [glpB].', NULL, 'Glycerol3P_GlpB', NULL, NULL, 9827, 7),
(237309, NULL, 'MF_00804', NULL, NULL, 'Betaine aldehyde dehydrogenase [betB].', NULL, 'BADH', NULL, NULL, 11319, 7),
(237310, NULL, 'MF_00611', NULL, NULL, 'Protein FdhE [fdhE].', NULL, 'FdeH', NULL, NULL, 6997, 7),
(237311, NULL, 'MF_00114', NULL, NULL, 'Deoxyribose-phosphate aldolase [deoC].', NULL, 'DeoC_type1', NULL, NULL, 22599, 7),
(237312, NULL, 'MF_04012', NULL, NULL, 'Portal protein.', NULL, 'HSV_PORTL', NULL, NULL, 2766, 7),
(237313, NULL, 'MF_01579', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase F [rsmF].', NULL, '16SrRNA_methyltr_F', NULL, NULL, 16620, 7),
(237314, NULL, 'MF_02247', NULL, NULL, 'Carboxylic acid reductase [car].', NULL, 'Carbox_acid_reduct', NULL, NULL, 36536, 7),
(237315, NULL, 'MF_04029', NULL, NULL, 'Thymidine kinase [TK].', NULL, 'HSV_KITH', NULL, NULL, 4232, 7),
(237316, NULL, 'MF_00938', NULL, NULL, 'DNA topoisomerase 4 subunit B [parE].', NULL, 'ParE_type1', NULL, NULL, 4547, 7),
(237317, NULL, 'MF_04105', NULL, NULL, 'Antiholin.', NULL, 'ANTIH_T4', NULL, NULL, 7335, 7),
(237318, NULL, 'MF_02084', NULL, NULL, '[LysW]-aminoadipate semialdehyde/glutamate semialdehyde transaminase [lysJ].', NULL, 'LysJ_aminotrans_3', NULL, NULL, 33019, 7),
(237319, NULL, 'MF_00934', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase J [rlmJ].', NULL, '23SrRNA_methyltr_J', NULL, NULL, 4868, 7),
(237320, NULL, 'MF_00812', NULL, NULL, 'Thiopurine S-methyltransferase [tpm].', NULL, 'Thiopur_methtran', NULL, NULL, 23400, 7),
(237321, NULL, 'MF_00163', NULL, NULL, 'Peptide deformylase [def].', NULL, 'Pep_deformylase', NULL, NULL, 6229, 7),
(237322, NULL, 'MF_01871', NULL, NULL, 'Probable inorganic carbon transporter subunit DabA [dabA].', NULL, 'DabA', NULL, NULL, 18377, 7);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(237323, NULL, 'MF_01276', NULL, NULL, 'Putrescine aminotransferase [patA].', NULL, 'Putres_aminotrans_3', NULL, NULL, 18576, 7),
(237324, NULL, 'MF_02203', NULL, NULL, 'Tol-Pal system protein TolR [tolR].', NULL, 'TolR', NULL, NULL, 8882, 7),
(237325, NULL, 'MF_01179', NULL, NULL, 'Cell division inhibitor SulA [sulA].', NULL, 'SulA', NULL, NULL, 858, 7),
(237326, NULL, 'MF_01318_B', NULL, NULL, '50S ribosomal protein L1 [rplA].', NULL, 'Ribosomal_L1_B', NULL, NULL, 6683, 7),
(237327, NULL, 'MF_01140', NULL, NULL, 'Polyisoprenyl-teichoic acid--peptidoglycan teichoic acid transferase TagU [tagU].', NULL, 'TagU_transferase', NULL, NULL, 7643, 7),
(237328, NULL, 'MF_00305', NULL, NULL, 'Signal recognition particle 19 kDa protein [srp19].', NULL, 'SRP19', NULL, NULL, 14915, 7),
(237329, NULL, 'MF_00372', NULL, NULL, 'Imidazolonepropionase [hutI].', NULL, 'HutI', NULL, NULL, 9, 7),
(237330, NULL, 'MF_00673', NULL, NULL, 'UPF0254 protein <locus_tag>.', NULL, 'UPF0254', NULL, NULL, 1773, 7),
(237331, NULL, 'MF_03066', NULL, NULL, 'E3 ubiquitin-protein ligase RNF168 [RNF168].', NULL, 'RNF168', NULL, NULL, 30839, 7),
(237332, NULL, 'MF_00128', NULL, NULL, 'Protein NrdI [nrdI].', NULL, 'NrdI', NULL, NULL, 20609, 7),
(237333, NULL, 'MF_00451', NULL, NULL, 'Nucleoside diphosphate kinase [ndk].', NULL, 'NDP_kinase', NULL, NULL, 3427, 7),
(237334, NULL, 'MF_01879', NULL, NULL, 'Dipeptide and tripeptide permease B [dtpB].', NULL, 'PTR2_DtpB_subfam', NULL, NULL, 16703, 7),
(237335, NULL, 'MF_01926', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase subunit PurS [purS].', NULL, 'PurS', NULL, NULL, 3392, 7),
(237336, NULL, 'MF_01224_A', NULL, NULL, 'Cyclic pyranopterin monophosphate synthase [moaC].', NULL, 'MoaC_A', NULL, NULL, 15477, 7),
(237337, NULL, 'MF_00091', NULL, NULL, 'S-ribosylhomocysteine lyase [luxS].', NULL, 'LuxS', NULL, NULL, 3109, 7),
(237338, NULL, 'MF_00107', NULL, NULL, '2-C-methyl-D-erythritol 2,4-cyclodiphosphate synthase [ispF].', NULL, 'IspF', NULL, NULL, 6440, 7),
(237339, NULL, 'MF_00596', NULL, NULL, 'GMP reductase [guaC].', NULL, 'GMP_reduct_type1', NULL, NULL, 1330, 7),
(237340, NULL, 'MF_00758', NULL, NULL, 'UPF0301 protein YqgE [yqgE].', NULL, 'UPF0301', NULL, NULL, 2682, 7),
(237341, NULL, 'MF_00333', NULL, NULL, 'Oxygen-dependent coproporphyrinogen-III oxidase [hemF].', NULL, 'Coprogen_oxidas', NULL, NULL, 2460, 7),
(237342, NULL, 'MF_00480_A', NULL, NULL, '30S ribosomal protein S7 [rpsG].', NULL, 'Ribosomal_S7_A', NULL, NULL, 24174, 7),
(237343, NULL, 'MF_01633', NULL, NULL, '7-cyano-7-deazaguanine synthase [queC].', NULL, 'QueC', NULL, NULL, 16631, 7),
(237344, NULL, 'MF_02003', NULL, NULL, 'Isoleucine--tRNA ligase [ileS].', NULL, 'Ile_tRNA_synth_type2', NULL, NULL, 16725, 7),
(237345, NULL, 'MF_00134_B', NULL, NULL, 'Indole-3-glycerol phosphate synthase [trpC].', NULL, 'IGPS_B', NULL, NULL, 9165, 7),
(237346, NULL, 'MF_00581', NULL, NULL, 'Argininosuccinate synthase [argG].', NULL, 'Arg_succ_synth_type2', NULL, NULL, 16100, 7),
(237347, NULL, 'MF_01268', NULL, NULL, 'Bifunctional enzyme Fae/Hps [fae-hps].', NULL, 'Fae_Hps', NULL, NULL, 20978, 7),
(237348, NULL, 'MF_00236', NULL, NULL, 'Sec-independent protein translocase protein TatA [tatA].', NULL, 'TatA_E', NULL, NULL, 4802, 7),
(237349, NULL, 'MF_00543', NULL, NULL, 'Tyrosine phenol-lyase [tpl].', NULL, 'Tyr_phenol_lyase', NULL, NULL, 9059, 7),
(237350, NULL, 'MF_01558', NULL, NULL, 'Cytidine deaminase [cdd].', NULL, 'Cyt_deam', NULL, NULL, 20056, 7),
(237351, NULL, 'MF_04147', NULL, NULL, 'Terminase, large subunit.', NULL, 'TERL_T7', NULL, NULL, 35580, 7),
(237352, NULL, 'MF_00534', NULL, NULL, 'Asparagine--tRNA ligase [asnS].', NULL, 'Asn_tRNA_synth', NULL, NULL, 1805, 7),
(237353, NULL, 'MF_04095', NULL, NULL, 'Nucleoprotein [N].', NULL, 'ALPHA_CORONA_NCAP', NULL, NULL, 35134, 7),
(237354, NULL, 'MF_01345_A', NULL, NULL, '30S ribosomal protein S17 [rpsQ].', NULL, 'Ribosomal_S17_A', NULL, NULL, 11838, 7),
(237355, NULL, 'MF_01227', NULL, NULL, 'CTP synthase [pyrG].', NULL, 'PyrG', NULL, NULL, 7211, 7),
(237356, NULL, 'MF_04139', NULL, NULL, 'NAD(+)--arginine ADP-ribosyltransferase [alt].', NULL, 'ALT_T4', NULL, NULL, 17263, 7);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(237357, NULL, 'MF_00291_A', NULL, NULL, '30S ribosomal protein S2 [rpsB].', NULL, 'Ribosomal_S2_A', NULL, NULL, 16282, 7),
(237358, NULL, 'MF_04021', NULL, NULL, 'Small capsomere-interacting protein [SCP].', NULL, 'HSV_SCP_betahv', NULL, NULL, 24426, 7),
(237359, NULL, 'MF_03151', NULL, NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit F, mitochondrial [GTF1].', NULL, 'GatF', NULL, NULL, 22060, 7),
(237360, NULL, 'MF_00841', NULL, NULL, 'Glucosyltransferase 3 [gtf3].', NULL, 'Gtf3', NULL, NULL, 35169, 7),
(237361, NULL, 'MF_00967', NULL, NULL, 'ATP-dependent RNA helicase SrmB [srmB].', NULL, 'DEAD_helicase_SrmB', NULL, NULL, 25367, 7),
(237362, NULL, 'MF_01252', NULL, NULL, 'Flavohemoprotein [hmp].', NULL, 'Hmp', NULL, NULL, 19801, 7),
(237363, NULL, 'MF_02078', NULL, NULL, 'Probable lipid II flippase MurJ [murJ].', NULL, 'MurJ_MviN', NULL, NULL, 3910, 7),
(237364, NULL, 'MF_00001', NULL, NULL, 'Aspartate carbamoyltransferase [pyrB].', NULL, 'Asp_carb_tr', NULL, NULL, 1251, 7),
(237365, NULL, 'MF_01548', NULL, NULL, 'UPF0354 protein <locus_tag>.', NULL, 'UPF0354', NULL, NULL, 11501, 7),
(237366, NULL, 'MF_00658', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase H [rlmH].', NULL, '23SrRNA_methyltr_H', NULL, NULL, 4425, 7),
(237367, NULL, 'MF_00671', NULL, NULL, 'Tol-Pal system protein TolB [tolB].', NULL, 'TolB', NULL, NULL, 8560, 7),
(237368, NULL, 'MF_02044', NULL, NULL, 'DNA double-strand break repair protein Mre11 [mre11].', NULL, 'Mre11', NULL, NULL, 25023, 7),
(237369, NULL, 'MF_00238', NULL, NULL, 'Cytidylate kinase [cmk].', NULL, 'Cytidyl_kinase_type1', NULL, NULL, 1936, 7),
(237370, NULL, 'MF_01588', NULL, NULL, 'DNA ligase [ligA].', NULL, 'DNA_ligase_A', NULL, NULL, 3390, 7),
(237371, NULL, 'MF_02207', NULL, NULL, 'Cell shape-determining protein MreB [mreB].', NULL, 'MreB', NULL, NULL, 5416, 7),
(237372, NULL, 'MF_01479', NULL, NULL, 'Transcriptional regulator WhiB [whiB].', NULL, 'WhiB', NULL, NULL, 6433, 7),
(237373, NULL, 'MF_02027', NULL, NULL, 'dTDP-fucosamine acetyltransferase [wecD].', NULL, 'WecD_RffC', NULL, NULL, 9565, 7),
(237374, NULL, 'MF_01914', NULL, NULL, 'Lipopolysaccharide export system protein LptA [lptA].', NULL, 'LPS_assembly_LptA', NULL, NULL, 11121, 7),
(237375, NULL, 'MF_01248', NULL, NULL, 'Glycogen debranching enzyme [glgX].', NULL, 'GlgX', NULL, NULL, 17295, 7),
(237376, NULL, 'MF_00045', NULL, NULL, 'Oligoribonuclease [orn].', NULL, 'Oligoribonuclease', NULL, NULL, 17386, 7),
(237377, NULL, 'MF_02001', NULL, NULL, 'Small heat shock protein IbpB [ibpB].', NULL, 'HSP20_IbpB', NULL, NULL, 15593, 7),
(237378, NULL, 'MF_03109', NULL, NULL, 'Protein SEY1 [SEY1].', NULL, 'Sey1', NULL, NULL, 13962, 7),
(237379, NULL, 'MF_01167', NULL, NULL, 'UDP-4-amino-4-deoxy-L-arabinose--oxoglutarate aminotransferase [arnB].', NULL, 'ArnB_transfer', NULL, NULL, 15682, 7),
(237380, NULL, 'MF_00731', NULL, NULL, '2-succinylbenzoate--CoA ligase [menE].', NULL, 'MenE', NULL, NULL, 4319, 7),
(237381, NULL, 'MF_00825', NULL, NULL, '3-hydroxyanthranilate 3,4-dioxygenase [nbaC].', NULL, '3_HAO', NULL, NULL, 8899, 7),
(237382, NULL, 'MF_00990', NULL, NULL, 'L-2-hydroxyglutarate dehydrogenase [lhgD].', NULL, 'L_hydroxyglutarate_dehydrogenase', NULL, NULL, 22857, 7),
(237383, NULL, 'MF_01338', NULL, NULL, 'Ribulose bisphosphate carboxylase large chain [rbcL].', NULL, 'RuBisCO_L_type1', NULL, NULL, 20958, 7),
(237384, NULL, 'MF_02049', NULL, NULL, 'Nucleoside permease NupG [nupG].', NULL, 'NupG', NULL, NULL, 28821, 7),
(237385, NULL, 'MF_04129', NULL, NULL, 'Intermediate capsid protein VP6.', NULL, 'Rota_VP6_A', NULL, NULL, 2134, 7),
(237386, NULL, 'MF_01299', NULL, NULL, 'Oxaloacetate decarboxylase.', NULL, 'OadC', NULL, NULL, 7300, 7),
(237387, NULL, 'MF_00560', NULL, NULL, 'Trans-aconitate 2-methyltransferase [tam].', NULL, 'Tran_acon_Me_trans', NULL, NULL, 16065, 7),
(237388, NULL, 'MF_03101', NULL, NULL, 'Deoxyhypusine hydroxylase [DOHH].', NULL, 'Deoxyhypusine_hydroxylase', NULL, NULL, 23113, 7),
(237389, NULL, 'MF_00707', NULL, NULL, 'UPF0735 ACT domain-containing protein <locus_tag>.', NULL, 'UPF0735', NULL, NULL, 7962, 7);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(237390, NULL, 'MF_03005', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit F [EIF3F].', NULL, 'eIF3f', NULL, NULL, 25172, 7),
(237391, NULL, 'MF_01442', NULL, NULL, 'Coproheme decarboxylase [chdC].', NULL, 'Coproheme_decarbox_1', NULL, NULL, 26439, 7),
(237392, NULL, 'MF_01384', NULL, NULL, 'Urease accessory protein UreD [ureD].', NULL, 'UreD', NULL, NULL, 2770, 7),
(237393, NULL, 'MF_00005', NULL, NULL, 'Argininosuccinate synthase [argG].', NULL, 'Arg_succ_synth_type1', NULL, NULL, 16396, 7),
(237394, NULL, 'MF_00252', NULL, NULL, 'Lysine--tRNA ligase [lysS].', NULL, 'Lys_tRNA_synth_class2', NULL, NULL, 5673, 7),
(237395, NULL, 'MF_00077', NULL, NULL, 'tRNA (cytidine(56)-2''-O)-methyltransferase.', NULL, 'tRNA_methyltr_aTrm56', NULL, NULL, 5635, 7),
(237396, NULL, 'MF_02127', NULL, NULL, 'Glucose 1-dehydrogenase [gdh].', NULL, 'Glucose_DH', NULL, NULL, 23724, 7),
(237397, NULL, 'MF_02029', NULL, NULL, 'UDP-N-acetyl-D-mannosamine dehydrogenase [wecC].', NULL, 'WecC_RffD', NULL, NULL, 23988, 7),
(237398, NULL, 'MF_02058', NULL, NULL, 'Choline trimethylamine-lyase [cutC].', NULL, 'Choline_CutC', NULL, NULL, 25380, 7),
(237399, NULL, 'MF_03126', NULL, NULL, 'Adenylosuccinate synthetase isozyme 1 [ADSSL1].', NULL, 'Adenylosucc_synth_vert_basic', NULL, NULL, 23447, 7),
(237400, NULL, 'MF_00799', NULL, NULL, 'UPF0336 protein <locus_tag>.', NULL, 'UPF0336', NULL, NULL, 20068, 7),
(237401, NULL, 'MF_04004', NULL, NULL, 'Protein E7 [E7].', NULL, 'PPV_E7', NULL, NULL, 3941, 7),
(237402, NULL, 'MF_00827', NULL, NULL, 'UPF0386 protein YjhX [yjhX].', NULL, 'UPF0386', NULL, NULL, 16757, 7),
(237403, NULL, 'MF_02083', NULL, NULL, '[LysW]-L-2-aminoadipate/[LysW]-L-glutamate phosphate reductase [lysY].', NULL, 'LysY', NULL, NULL, 31650, 7),
(237404, NULL, 'MF_01126', NULL, NULL, 'UPF0298 protein <locus_tag>.', NULL, 'UPF0298', NULL, NULL, 17645, 7),
(237405, NULL, 'MF_01175', NULL, NULL, 'tRNA-modifying protein YgfZ [ygfZ].', NULL, 'tRNA_modifying_YgfZ', NULL, NULL, 16573, 7),
(237406, NULL, 'MF_03134', NULL, NULL, 'Probable alanine--tRNA ligase, chloroplastic.', NULL, 'Ala_tRNA_synth_plantC', NULL, NULL, 24551, 7),
(237407, NULL, 'MF_01575', NULL, NULL, 'UPF0398 protein <locus_tag>.', NULL, 'UPF0398', NULL, NULL, 9925, 7),
(237408, NULL, 'MF_02200', NULL, NULL, 'Chaperone NapD [napD].', NULL, 'NapD', NULL, NULL, 2641, 7),
(237409, NULL, 'MF_01572', NULL, NULL, 'UPF0397 protein <locus_tag>.', NULL, 'UPF0397', NULL, NULL, 14658, 7),
(237410, NULL, 'MF_03012', NULL, NULL, 'COP9/Signalosome and eIF3 complex-shared subunit 1 [EIF3M].', NULL, 'eIF3m', NULL, NULL, 25132, 7),
(237411, NULL, 'MF_01223', NULL, NULL, 'UPF0212 protein <locus_tag>.', NULL, 'UPF0212', NULL, NULL, 1875, 7),
(237412, NULL, 'MF_00341', NULL, NULL, 'UPF0146 protein <locus_tag>.', NULL, 'UPF0146', NULL, NULL, 6191, 7),
(237413, NULL, 'MF_00663', NULL, NULL, 'Phosphatidylserine decarboxylase proenzyme [psd].', NULL, 'PS_decarb_PSD_B_type2', NULL, NULL, 29939, 7),
(237414, NULL, 'MF_00795', NULL, NULL, 'Copper homeostasis protein CutC [cutC].', NULL, 'CutC', NULL, NULL, 2572, 7),
(237415, NULL, 'MF_01481', NULL, NULL, 'Photosystem II lipoprotein Psb27 [psb27].', NULL, 'PSII_Psb27', NULL, NULL, 24774, 7),
(237416, NULL, 'MF_00205', NULL, NULL, 'UvrABC system protein A [uvrA].', NULL, 'UvrA', NULL, NULL, 909, 7),
(237417, NULL, 'MF_00217', NULL, NULL, 'Mevalonate kinase [mvk].', NULL, 'Mevalonate_kinase', NULL, NULL, 14948, 7),
(237418, NULL, 'MF_01139', NULL, NULL, 'Ditrans,polycis-undecaprenyl-diphosphate synthase ((2E,6E)-farnesyl-diphosphate specific) [uppS].', NULL, 'ISPT', NULL, NULL, 3313, 7),
(237419, NULL, 'MF_01432', NULL, NULL, 'Non-specific ribonucleoside hydrolase RihC [rihC].', NULL, 'Nucleosid_hydro_RihC', NULL, NULL, 14719, 7),
(237420, NULL, 'MF_03063', NULL, NULL, 'Elongation factor G, chloroplastic.', NULL, 'EF_G_plantC', NULL, NULL, 21516, 7),
(237421, NULL, 'MF_01426', NULL, NULL, 'Cation/acetate symporter ActP [actP].', NULL, 'Acet_symport_ActP', NULL, NULL, 14122, 7),
(237422, NULL, 'MF_01288', NULL, NULL, 'L-rhamnonate dehydratase [rhmD].', NULL, 'Rhamnon_dehydrat', NULL, NULL, 16222, 7);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(237423, NULL, 'MF_01570', NULL, NULL, 'Proline--tRNA ligase [proS].', NULL, 'Pro_tRNA_synth_type2', NULL, NULL, 10054, 7),
(237424, NULL, 'MF_01969', NULL, NULL, 'Kynurenine formamidase [kynB].', NULL, 'KynB', NULL, NULL, 20897, 7),
(237425, NULL, 'MF_04068', NULL, NULL, 'Matrix protein 1 [M].', NULL, 'INFV_M1', NULL, NULL, 27150, 7),
(237426, NULL, 'MF_00805', NULL, NULL, 'Citrate lyase acyl carrier protein [citD].', NULL, 'CitD', NULL, NULL, 6211, 7),
(237427, NULL, 'MF_02060', NULL, NULL, 'tRNA (guanosine(18)-2''-O)-methyltransferase [trmH].', NULL, 'tRNA_methyltr_TrmH', NULL, NULL, 29863, 7),
(237428, NULL, 'MF_01361', NULL, NULL, 'UPF0391 membrane protein YtjA [ytjA].', NULL, 'UPF0391', NULL, NULL, 12368, 7),
(237429, NULL, 'MF_00713', NULL, NULL, 'Probable glycine dehydrogenase (decarboxylating) subunit 2 [gcvPB].', NULL, 'GcvPB', NULL, NULL, 15178, 7),
(237430, NULL, 'MF_01630', NULL, NULL, 'Periplasmic nitrate reductase [napA].', NULL, 'Nitrate_reduct_NapA', NULL, NULL, 5064, 7),
(237431, NULL, 'MF_02102', NULL, NULL, 'Putrescine carbamoyltransferase [ptcA].', NULL, 'PTCase', NULL, NULL, 21635, 7),
(237432, NULL, 'MF_01611', NULL, NULL, '7,8-didemethyl-8-hydroxy-5-deazariboflavin synthase [cofG].', NULL, 'FO_synth_sub1', NULL, NULL, 18150, 7),
(237433, NULL, 'MF_03040', NULL, NULL, 'U6 snRNA phosphodiesterase [USB1].', NULL, 'USB1', NULL, NULL, 23371, 7),
(237434, NULL, 'MF_04049', NULL, NULL, 'Pre-hexon-linking protein VIII [L4].', NULL, 'ADV_CAP8', NULL, NULL, 4227, 7),
(237435, NULL, 'MF_04149', NULL, NULL, 'RNA ligase 1.', NULL, 'RNALIG_T4', NULL, NULL, 10435, 7),
(237436, NULL, 'MF_01561', NULL, NULL, 'Probable phosphatase YcdX [ycdX].', NULL, 'YcdX_phosphat', NULL, NULL, 7356, 7),
(237437, NULL, 'MF_01881', NULL, NULL, 'Propionate kinase [tdcD].', NULL, 'Propion_kin_subfam1', NULL, NULL, 14730, 7),
(237438, NULL, 'MF_01595', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase [pnp].', NULL, 'PNPase', NULL, NULL, 7490, 7),
(237439, NULL, 'MF_01348', NULL, NULL, 'Ycf48-like protein [hcf136].', NULL, 'Ycf48', NULL, NULL, 20317, 7),
(237440, NULL, 'MF_00547', NULL, NULL, '50S ribosomal protein L37e [rpl37e].', NULL, 'Ribosomal_L37e', NULL, NULL, 5209, 7),
(237441, NULL, 'MF_00551', NULL, NULL, 'Uridine kinase [udk].', NULL, 'Uridine_kinase', NULL, NULL, 2508, 7),
(237442, NULL, 'MF_00705', NULL, NULL, 'IMP cyclohydrolase [purO].', NULL, 'IMP_cyclohydrol', NULL, NULL, 4180, 7),
(237443, NULL, 'MF_00771', NULL, NULL, 'UPF0310 protein <locus_tag>.', NULL, 'UPF0310', NULL, NULL, 15027, 7),
(237444, NULL, 'MF_01206', NULL, NULL, 'Protein-methionine-sulfoxide reductase catalytic subunit MsrP [msrP].', NULL, 'MsrP', NULL, NULL, 17222, 7),
(237445, NULL, 'MF_00953', NULL, NULL, 'DNA topoisomerase 3 [topB].', NULL, 'Topoisom_3_prok', NULL, NULL, 4588, 7),
(237446, NULL, 'MF_02211', NULL, NULL, 'Murein peptide amidase A [mpaA].', NULL, 'MpaA_carboxypeptidase', NULL, NULL, 34683, 7),
(237447, NULL, 'MF_00271', NULL, NULL, 'V-type ATP synthase subunit D [atpD].', NULL, 'ATP_synth_D_arch', NULL, NULL, 3948, 7),
(237448, NULL, 'MF_03059', NULL, NULL, 'Ribosome-releasing factor 2, mitochondrial [GFM2].', NULL, 'mEF_G_2', NULL, NULL, 21530, 7),
(237449, NULL, 'MF_01581', NULL, NULL, 'UPF0482 protein YnfB [ynfB].', NULL, 'UPF0482', NULL, NULL, 11890, 7),
(237450, NULL, 'MF_00178', NULL, NULL, '6,7-dimethyl-8-ribityllumazine synthase [ribH].', NULL, 'Lumazine_synth', NULL, NULL, 14502, 7),
(237451, NULL, 'MF_00332', NULL, NULL, 'Chaperone protein DnaK [dnaK].', NULL, 'DnaK', NULL, NULL, 11662, 7),
(237452, NULL, 'MF_01973', NULL, NULL, 'Lon protease [lon].', NULL, 'lon_bact', NULL, NULL, 26769, 7),
(237453, NULL, 'MF_03002', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit C [EIF3C].', NULL, 'eIF3c', NULL, NULL, 23871, 7),
(237454, NULL, 'MF_04062', NULL, NULL, 'Polymerase basic protein 2 [PB2].', NULL, 'INV_PB2', NULL, NULL, 3480, 7),
(237455, NULL, 'MF_01060', NULL, NULL, 'Periplasmic trehalase [treA].', NULL, 'Peripl_trehalase', NULL, NULL, 16815, 7),
(237456, NULL, 'MF_03102', NULL, NULL, 'Mitochondrial distribution and morphology protein 10 [MDM10].', NULL, 'Mdm10', NULL, NULL, 23916, 7);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(237457, NULL, 'MF_00139', NULL, NULL, 'Bifunctional purine biosynthesis protein PurH [purH].', NULL, 'PurH', NULL, NULL, 3950, 7),
(237458, NULL, 'MF_00681', NULL, NULL, '(5-formylfuran-3-yl)methyl phosphate synthase [mfnB].', NULL, 'MfnB', NULL, NULL, 29387, 7),
(237459, NULL, 'MF_00056', NULL, NULL, '2-dehydro-3-deoxyphosphooctonate aldolase [kdsA].', NULL, 'KDO8P_synth', NULL, NULL, 3925, 7),
(237460, NULL, 'MF_01593', NULL, NULL, 'Protein MtfA [mtfA].', NULL, 'MtfA', NULL, NULL, 9412, 7),
(237461, NULL, 'MF_00052_B', NULL, NULL, 'Ribonuclease HII [rnhB].', NULL, 'RNase_HII_B', NULL, NULL, 17359, 7),
(237462, NULL, 'MF_02219', NULL, NULL, 'Type 3 secretion system secretin [sctC].', NULL, 'Type_III_secretin', NULL, NULL, 6223, 7),
(237463, NULL, 'MF_04090', NULL, NULL, 'Non-structural protein 3.', NULL, 'ROTA_NSP3', NULL, NULL, 5638, 7),
(237464, NULL, 'MF_00349', NULL, NULL, '50S ribosomal protein L34e [rpl34e].', NULL, 'Ribosomal_L34e', NULL, NULL, 7305, 7),
(237465, NULL, 'MF_00526', NULL, NULL, 'Glutamate mutase sigma subunit [glmS].', NULL, 'Me_Asp_mutase_S', NULL, NULL, 5647, 7),
(237466, NULL, 'MF_00105', NULL, NULL, 'Transcription elongation factor GreA [greA].', NULL, 'GreA_GreB', NULL, NULL, 25301, 7),
(237467, NULL, 'MF_00555', NULL, NULL, 'Aspartate--ammonia ligase [asnA].', NULL, 'AsnA', NULL, NULL, 2212, 7),
(237468, NULL, 'MF_00540', NULL, NULL, 'Adenosine deaminase [add].', NULL, 'A_deaminase', NULL, NULL, 26781, 7),
(237469, NULL, 'MF_00719', NULL, NULL, 'Adenosylcobinamide-GDP ribazoletransferase [cobS].', NULL, 'CobS', NULL, NULL, 3183, 7),
(237470, NULL, 'MF_01409', NULL, NULL, 'UPF0219 protein <locus_tag>.', NULL, 'UPF0219', NULL, NULL, 2756, 7),
(237471, NULL, 'MF_00532_B', NULL, NULL, '30S ribosomal protein S9 [rpsI].', NULL, 'Ribosomal_S9_B', NULL, NULL, 15162, 7),
(237472, NULL, 'MF_01825', NULL, NULL, 'Erythronate-4-phosphate dehydrogenase [pdxB].', NULL, 'PdxB', NULL, NULL, 14682, 7),
(237473, NULL, 'MF_01502', NULL, NULL, 'UPF0295 protein <locus_tag>.', NULL, 'UPF0295', NULL, NULL, 14664, 7),
(237474, NULL, 'MF_00057', NULL, NULL, '8-amino-3,8-dideoxy-manno-octulosonate cytidylyltransferase [kdsB].', NULL, 'KdsB', NULL, NULL, 1570, 7),
(237475, NULL, 'MF_00639', NULL, NULL, 'UDP-N-acetylmuramoylalanine--D-glutamate ligase [murD].', NULL, 'MurD', NULL, NULL, 4849, 7),
(237476, NULL, 'MF_00981', NULL, NULL, 'Transcriptional regulatory protein RcsB [rcsB].', NULL, 'RcsB', NULL, NULL, 2875, 7),
(237477, NULL, 'MF_00030', NULL, NULL, 'Deoxyguanosinetriphosphate triphosphohydrolase [dgt].', NULL, 'dGTPase_type1', NULL, NULL, 20707, 7),
(237478, NULL, 'MF_00446', NULL, NULL, 'Aspartate 1-decarboxylase [panD].', NULL, 'PanD', NULL, NULL, 1642, 7),
(237479, NULL, 'MF_00486', NULL, NULL, 'Methenyltetrahydromethanopterin cyclohydrolase [mch].', NULL, 'McH', NULL, NULL, 2202, 7),
(237480, NULL, 'MF_00244', NULL, NULL, 'Probable nicotinate-nucleotide adenylyltransferase [nadD].', NULL, 'NaMN_adenylyltr', NULL, NULL, 11102, 7),
(237481, NULL, 'MF_01463_A', NULL, NULL, 'Protein translocase subunit SecD [secD].', NULL, 'SecD_A', NULL, NULL, 21304, 7),
(237482, NULL, 'MF_02216', NULL, NULL, 'Ubiquinone biosynthesis accessory factor UbiK [ubiK].', NULL, 'UbiK', NULL, NULL, 2210, 7),
(237483, NULL, 'MF_01097', NULL, NULL, 'Tetrahydromethanopterin S-methyltransferase subunit D [mtrD].', NULL, 'MtrD', NULL, NULL, 5976, 7),
(237484, NULL, 'MF_01443', NULL, NULL, 'Bis(5''-nucleosyl)-tetraphosphatase PrpE [asymmetrical] [prpE].', NULL, 'PrpE', NULL, NULL, 10366, 7),
(237485, NULL, 'MF_01346', NULL, NULL, 'ATP synthase subunit alpha [atpA].', NULL, 'ATP_synth_alpha_bact', NULL, NULL, 4160, 7),
(237486, NULL, 'MF_00607', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase A [rsmA].', NULL, '16SrRNA_methyltr_A', NULL, NULL, 8518, 7),
(237487, NULL, 'MF_01012', NULL, NULL, '23S rRNA (uracil(747)-C(5))-methyltransferase RlmC [rlmC].', NULL, '23SrRNA_methyltr_RlmC', NULL, NULL, 13734, 7),
(237488, NULL, 'MF_01052', NULL, NULL, 'Crotonobetainyl-CoA reductase [caiA].', NULL, 'CaiA', NULL, NULL, 16386, 7); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(237489, NULL, 'MF_00394', NULL, NULL, 'Glycerol-3-phosphate dehydrogenase [NAD(P)+] [gpsA].', NULL, 'NAD_Glyc3P_dehydrog', NULL, NULL, 10110, 7),
(237490, NULL, 'MF_00063', NULL, NULL, 'Adenosine 5''-phosphosulfate reductase [cysH].', NULL, 'CysH', NULL, NULL, 1912, 7),
(237491, NULL, 'MF_01591', NULL, NULL, 'Protein Ves [ves].', NULL, 'Ves', NULL, NULL, 16605, 7),
(237492, NULL, 'MF_00601', NULL, NULL, 'Ethanolamine ammonia-lyase small subunit [eutC].', NULL, 'EutC', NULL, NULL, 13604, 7),
(237493, NULL, 'MF_01525', NULL, NULL, 'Carnitine operon protein CaiE [caiE].', NULL, 'CaiE', NULL, NULL, 16457, 7),
(237494, NULL, 'MF_00233', NULL, NULL, 'Outer-membrane lipoprotein LolB [lolB].', NULL, 'LolB', NULL, NULL, 577, 7),
(237495, NULL, 'MF_00256', NULL, NULL, '50S ribosomal protein L15e [rpl15e].', NULL, 'Ribosomal_L15e', NULL, NULL, 14905, 7),
(237496, NULL, 'MF_01473', NULL, NULL, 'UDP-N-acetylglucosamine--peptide N-acetylglucosaminyltransferase stabilizing protein GtfB [gtfB].', NULL, 'GtfB', NULL, NULL, 11391, 7),
(237497, NULL, 'MF_00664', NULL, NULL, 'Phosphatidylserine decarboxylase proenzyme [psd].', NULL, 'PS_decarb_PSD_A', NULL, NULL, 29584, 7),
(237498, NULL, 'MF_02204', NULL, NULL, 'Peptidoglycan-associated lipoprotein [pal].', NULL, 'Pal', NULL, NULL, 30925, 7),
(237499, NULL, 'MF_01839', NULL, NULL, 'Nucleoid occlusion factor SlmA [slmA].', NULL, 'NO_factor_SlmA', NULL, NULL, 16841, 7),
(237500, NULL, 'MF_01654', NULL, NULL, '2-hydroxy-6-oxononadienedioate/2-hydroxy-6-oxononatrienedioate hydrolase [mhpC].', NULL, 'MhpC', NULL, NULL, 16606, 7),
(237501, NULL, 'MF_00817', NULL, NULL, 'NADPH-dependent 7-cyano-7-deazaguanine reductase [queF].', NULL, 'QueF_type2', NULL, NULL, 21107, 7),
(237502, NULL, 'MF_00599', NULL, NULL, 'Cell division protein FtsB [ftsB].', NULL, 'FtsB', NULL, NULL, 15210, 7),
(237503, NULL, 'MF_01333_B', NULL, NULL, '50S ribosomal protein L5 [rplE].', NULL, 'Ribosomal_L5_B', NULL, NULL, 14714, 7),
(237504, NULL, 'MF_01520', NULL, NULL, 'Bifunctional enzyme IspD/IspF [ispDF].', NULL, 'IspDF', NULL, NULL, 23166, 7),
(237505, NULL, 'MF_00977', NULL, NULL, '3''-5'' exoribonuclease.', NULL, '3_5_Exoribonuc_actinobact', NULL, NULL, 25468, 7),
(237506, NULL, 'MF_01011', NULL, NULL, 'tRNA/tmRNA (uracil-C(5))-methyltransferase [trmA].', NULL, 'RNA_methyltr_TrmA', NULL, NULL, 13787, 7),
(237507, NULL, 'MF_01464_A', NULL, NULL, 'Protein-export membrane protein SecF [secF].', NULL, 'SecF_A', NULL, NULL, 25870, 7),
(237508, NULL, 'MF_00395', NULL, NULL, 'Cytochrome b6-f complex subunit 8 [petN].', NULL, 'Cytb6_f_PetN', NULL, NULL, 940, 7),
(237509, NULL, 'MF_04137', NULL, NULL, 'Spanin, inner membrane subunit.', NULL, 'I_SPANIN_LAMBDA', NULL, NULL, 1592, 7),
(237510, NULL, 'MF_00158', NULL, NULL, 'Pantothenate synthetase [panC].', NULL, 'PanC', NULL, NULL, 2187, 7),
(237511, NULL, 'MF_00289_A', NULL, NULL, 'Proteasome subunit alpha [prcA].', NULL, 'Proteasome_A_A', NULL, NULL, 11592, 7),
(237512, NULL, 'MF_00775', NULL, NULL, 'UPF0311 protein <locus_tag>.', NULL, 'UPF0311', NULL, NULL, 14508, 7),
(237513, NULL, 'MF_00718', NULL, NULL, 'Tautomerase PptA [pptA].', NULL, 'Tautomerase_PptA', NULL, NULL, 16236, 7),
(237514, NULL, 'MF_02025', NULL, NULL, 'ECA polysaccharide chain length modulation protein [wzzE].', NULL, 'WzzE', NULL, NULL, 23777, 7),
(237515, NULL, 'MF_02241', NULL, NULL, 'Phosphatidylinositol phosphate synthase.', NULL, 'PIP_synthase', NULL, NULL, 35214, 7),
(237516, NULL, 'MF_00865', NULL, NULL, 'DNA-directed RNA polymerase subunit Rpo7 [rpo7].', NULL, 'RNApol_arch_Rpo7', NULL, NULL, 37619, 7),
(237517, NULL, 'MF_01629', NULL, NULL, 'Pyridoxine/pyridoxamine 5''-phosphate oxidase [pdxH].', NULL, 'PdxH', NULL, NULL, 5899, 7),
(237518, NULL, 'MF_02111', NULL, NULL, 'Pup--protein ligase [pafA].', NULL, 'Pup_ligase', NULL, NULL, 15497, 7),
(237519, NULL, 'MF_04093', NULL, NULL, 'Non-structural protein 6.', NULL, 'ROTA_NSP6', NULL, NULL, NULL, 7),
(237520, NULL, 'MF_00701', NULL, NULL, 'DNA primase large subunit PriL [priL].', NULL, 'DNA_primase_lrg_arc', NULL, NULL, 16041, 7);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(237521, NULL, 'MF_01400', NULL, NULL, 'Peptide methionine sulfoxide reductase MsrB [msrB].', NULL, 'MsrB', NULL, NULL, 1901, 7),
(237522, NULL, 'MF_01032', NULL, NULL, 'Methanogen homoaconitase small subunit [hacB].', NULL, 'LeuD_type2', NULL, NULL, 13969, 7),
(237523, NULL, 'MF_04132', NULL, NULL, 'Outer capsid protein VP4.', NULL, 'Rota_A_VP4', NULL, NULL, 35031, 7),
(237524, NULL, 'MF_00559', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase [gap].', NULL, 'G3P_dehdrog_arch', NULL, NULL, 6546, 7),
(237525, NULL, 'MF_00225', NULL, NULL, 'Dihydroorotate dehydrogenase (quinone) [pyrD].', NULL, 'DHO_dh_type2', NULL, NULL, 4859, 7),
(237526, NULL, 'MF_02040', NULL, NULL, 'Iron-sulfur cluster carrier protein.', NULL, 'Mrp_NBP35', NULL, NULL, 20305, 7),
(237527, NULL, 'MF_00733', NULL, NULL, '1-pyrroline-5-carboxylate dehydrogenase [rocA].', NULL, 'RocA', NULL, NULL, 218, 7),
(237528, NULL, 'MF_01180', NULL, NULL, 'Flagellar protein FliT [fliT].', NULL, 'FliT', NULL, NULL, 14410, 7),
(237529, NULL, 'MF_00803', NULL, NULL, 'Ribosome biogenesis protein Nop10 [nop10].', NULL, 'Nop10', NULL, NULL, 16727, 7),
(237530, NULL, 'MF_00098', NULL, NULL, 'Methionine--tRNA ligase [metG].', NULL, 'Met_tRNA_synth_type1', NULL, NULL, 16160, 7),
(237531, NULL, 'MF_00484', NULL, NULL, 'Glycogen synthase [glgA].', NULL, 'Glycogen_synth', NULL, NULL, 13535, 7),
(237532, NULL, 'MF_01331_A', NULL, NULL, '50S ribosomal protein L22 [rplV].', NULL, 'Ribosomal_L22_A', NULL, NULL, 4780, 7),
(237533, NULL, 'MF_02243', NULL, NULL, 'Tagaturonate/fructuronate epimerase [uxaE].', NULL, 'UxaE', NULL, NULL, 21881, 7),
(237534, NULL, 'MF_00048', NULL, NULL, 'UPF0102 protein YraN [yraN].', NULL, 'UPF0102', NULL, NULL, 6225, 7),
(237535, NULL, 'MF_00120', NULL, NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit A [gatA].', NULL, 'GatA', NULL, NULL, 5915, 7),
(237536, NULL, 'MF_03045', NULL, NULL, 'DIS3-like exonuclease 2 [DIS3L2].', NULL, 'DIS3L2', NULL, NULL, 23715, 7),
(237537, NULL, 'MF_01193', NULL, NULL, 'Endoribonuclease SymE [symE].', NULL, 'Endoribonucl_SymE', NULL, NULL, 20784, 7),
(237538, NULL, 'MF_01614', NULL, NULL, 'NADPH dehydrogenase [namA].', NULL, 'NamA', NULL, NULL, 16230, 7),
(237539, NULL, 'MF_00490', NULL, NULL, '2-phosphosulfolactate phosphatase [comB].', NULL, 'ComB', NULL, NULL, 11431, 7),
(237540, NULL, 'MF_01237', NULL, NULL, 'N-acetylneuraminate lyase [nanA].', NULL, 'N_acetylneuram_lyase', NULL, NULL, 4396, 7),
(237541, NULL, 'MF_01597', NULL, NULL, 'Spermidine export protein MdtI [mdtI].', NULL, 'MdtI', NULL, NULL, 10406, 7),
(237542, NULL, 'MF_04019', NULL, NULL, 'Triplex capsid protein 2 [TRX2].', NULL, 'HSV_TRX2', NULL, NULL, 2760, 7),
(237543, NULL, 'MF_03056', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase non-catalytic subunit <gene_name> [WDR4].', NULL, 'TRM82', NULL, NULL, 25369, 7),
(237544, NULL, 'MF_00583_A', NULL, NULL, 'Putative ribose-phosphate pyrophosphokinase [prs].', NULL, 'RibP_PPkinase_A', NULL, NULL, 33238, 7),
(237545, NULL, 'MF_01424', NULL, NULL, 'Multidrug resistance protein MdtC [mdtC].', NULL, 'MdtC', NULL, NULL, 6407, 7),
(237546, NULL, 'MF_00580', NULL, NULL, 'Co-chaperonin GroES [groES].', NULL, 'CH10', NULL, NULL, 14568, 7),
(237547, NULL, 'MF_00151', NULL, NULL, 'Phosphopantetheine adenylyltransferase [coaD].', NULL, 'PPAT_bact', NULL, NULL, 4360, 7),
(237548, NULL, 'MF_00597', NULL, NULL, 'Probable acetoacetate decarboxylase [adc].', NULL, 'ADC', NULL, NULL, 16759, 7),
(237549, NULL, 'MF_00917', NULL, NULL, '7-carboxy-7-deazaguanine synthase [queE].', NULL, 'QueE', NULL, NULL, 25541, 7),
(237550, NULL, 'MF_01540', NULL, NULL, 'Sulfite reductase [NADPH] hemoprotein beta-component [cysI].', NULL, 'CysI', NULL, NULL, 13080, 7),
(237551, NULL, 'MF_00404', NULL, NULL, 'Probable oxaloacetate decarboxylase gamma chain [oadG].', NULL, 'OadG', NULL, NULL, 16001, 7),
(237552, NULL, 'MF_01903', NULL, NULL, 'Xanthine-guanine phosphoribosyltransferase [gpt].', NULL, 'XGPRT', NULL, NULL, 16928, 7),
(237553, NULL, 'MF_00945_B', NULL, NULL, 'Transcription termination/antitermination protein NusA [nusA].', NULL, 'NusA_B', NULL, NULL, 23601, 7);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(237554, NULL, 'MF_02042', NULL, NULL, 'tRNA-dihydrouridine synthase B [dusB].', NULL, 'DusB_subfam', NULL, NULL, 24221, 7),
(237555, NULL, 'MF_02069', NULL, NULL, 'Ribulose-5-phosphate reductase [tarJ].', NULL, 'TarJ', NULL, NULL, 20718, 7),
(237556, NULL, 'MF_02063', NULL, NULL, 'Proton/glutamate-aspartate symporter [gltP].', NULL, 'GltP_subfam', NULL, NULL, 19149, 7),
(237557, NULL, 'MF_00920', NULL, NULL, 'Signal recognition particle receptor FtsY [ftsY].', NULL, 'FtsY', NULL, NULL, 5505, 7),
(237558, NULL, 'MF_04165', NULL, NULL, 'Late transcription coactivator.', NULL, 'T4_TRANSCR_COACT', NULL, NULL, 34652, 7),
(237559, NULL, 'MF_00276', NULL, NULL, 'Potassium-transporting ATPase KdpC subunit [kdpC].', NULL, 'KdpC', NULL, NULL, 3260, 7),
(237560, NULL, 'MF_01027', NULL, NULL, '3-isopropylmalate dehydratase large subunit [leuC].', NULL, 'LeuC_type2', NULL, NULL, 13596, 7),
(237561, NULL, 'MF_01934', NULL, NULL, '1,4-dihydroxy-2-naphthoyl-CoA synthase [menB].', NULL, 'MenB', NULL, NULL, 4274, 7),
(237562, NULL, 'MF_02008', NULL, NULL, 'Tyrosine--tRNA ligase [tyrS].', NULL, 'Tyr_tRNA_synth_type3', NULL, NULL, 14766, 7),
(237563, NULL, 'MF_01093', NULL, NULL, 'Tetrahydromethanopterin S-methyltransferase subunit A [mtrA].', NULL, 'MtrA', NULL, NULL, 5513, 7),
(237564, NULL, 'MF_01069', NULL, NULL, 'Glucans biosynthesis protein G [mdoG].', NULL, 'MdoG_OpgG', NULL, NULL, 14888, 7),
(237565, NULL, 'MF_01855', NULL, NULL, 'Fructose-1,6-bisphosphatase class 1 [fbp].', NULL, 'FBPase_class1', NULL, NULL, 3945, 7),
(237566, NULL, 'MF_01199', NULL, NULL, 'Anti-adapter protein IraM [iraM].', NULL, 'Anti_adapt_IraM', NULL, NULL, 9923, 7),
(237567, NULL, 'MF_01835', NULL, NULL, 'Circadian clock protein KaiB [kaiB].', NULL, 'KaiB', NULL, NULL, 10379, 7),
(237568, NULL, 'MF_02098', NULL, NULL, 'Carnitine monooxygenase reductase subunit.', NULL, 'Carnitine_monoox_B', NULL, NULL, 30922, 7),
(237569, NULL, 'MF_04104', NULL, NULL, 'Holin.', NULL, 'HOLIN_T4', NULL, NULL, 15513, 7),
(237570, NULL, 'MF_00801', NULL, NULL, 'Endonuclease V [nfi].', NULL, 'Endonuclease_5', NULL, NULL, 1950, 7),
(237571, NULL, 'MF_01663', NULL, NULL, 'L-rhamnose mutarotase [rhaM].', NULL, 'L_rham_rotase', NULL, NULL, 9128, 7),
(237572, NULL, 'MF_02031', NULL, NULL, 'Galactarate dehydratase (L-threo-forming) [garD].', NULL, 'Galactar_dehydrat', NULL, NULL, 23853, 7),
(237573, NULL, 'MF_04024', NULL, NULL, 'Nuclear egress protein 2 [NEC2].', NULL, 'HSV_NEC2', NULL, NULL, 2589, 7),
(237574, NULL, 'MF_00179', NULL, NULL, 'GTP cyclohydrolase-2 [ribA].', NULL, 'RibA', NULL, NULL, 3494, 7),
(237575, NULL, 'MF_00606', NULL, NULL, 'UV DNA damage endonuclease [uvsE].', NULL, 'UV_endonuclease', NULL, NULL, 16091, 7),
(237576, NULL, 'MF_00740', NULL, NULL, 'Phosphopentomutase [deoB].', NULL, 'Phosphopentomut', NULL, NULL, 5455, 7),
(237577, NULL, 'MF_01355', NULL, NULL, 'NAD(P)H-quinone oxidoreductase subunit L [ndhL].', NULL, 'NDH1_NDH1L', NULL, NULL, 20721, 7),
(237578, NULL, 'MF_01016', NULL, NULL, 'Putative transport protein YidE [yidE].', NULL, 'YidE', NULL, NULL, 15089, 7),
(237579, NULL, 'MF_00181', NULL, NULL, 'Probable cytosol aminopeptidase [pepA].', NULL, 'Cytosol_peptidase_M17', NULL, NULL, 15061, 7),
(237580, NULL, 'MF_04039', NULL, NULL, 'Cytoplasmic envelopment protein 2.', NULL, 'HSV_CEP2', NULL, NULL, 4915, 7),
(237581, NULL, 'MF_01128', NULL, NULL, 'H(+)/Cl(-) exchange transporter ClcA [clcA].', NULL, 'CLC_ClcA', NULL, NULL, 8446, 7),
(237582, NULL, 'MF_04066', NULL, NULL, 'Non-structural protein 1 [NS].', NULL, 'INFV_NS1', NULL, NULL, 3725, 7),
(237583, NULL, 'MF_04099', NULL, NULL, 'Spike glycoprotein [S].', NULL, 'BETA_CORONA_SPIKE', NULL, NULL, 36706, 7),
(237584, NULL, 'MF_01843', NULL, NULL, 'Protein Thf1 [thf1].', NULL, 'Thf1', NULL, NULL, 20523, 7),
(237585, NULL, 'MF_02125', NULL, NULL, '50S ribosomal protein L3 glutamine methyltransferase [prmB].', NULL, 'L3_methyltr_PrmB', NULL, NULL, 20730, 7),
(237586, NULL, 'MF_02126', NULL, NULL, 'Release factor glutamine methyltransferase [prmC].', NULL, 'RF_methyltr_PrmC', NULL, NULL, 16594, 7); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(237587, NULL, 'MF_01010', NULL, NULL, '23S rRNA (uracil(1939)-C(5))-methyltransferase RlmD [rlmD].', NULL, '23SrRNA_methyltr_RlmD', NULL, NULL, 5099, 7),
(237588, NULL, 'MF_03170', NULL, NULL, 'Adenylate kinase 4, mitochondrial [AK4].', NULL, 'Adenylate_kinase_AK4', NULL, NULL, 23799, 7),
(237589, NULL, 'MF_04094', NULL, NULL, 'Non-structural protein 3.', NULL, 'ROTA_A_NSP3', NULL, NULL, 5638, 7),
(237590, NULL, 'MF_01136', NULL, NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit gamma [cdhE].', NULL, 'CdhE', NULL, NULL, 16412, 7),
(237591, NULL, 'MF_04116', NULL, NULL, 'Highly immunogenic outer capsid protein.', NULL, 'HOC_T4', NULL, NULL, 32982, 7),
(237592, NULL, 'MF_00978', NULL, NULL, 'Bifunctional ligase/repressor BirA [birA].', NULL, 'Bifunct_BirA', NULL, NULL, 25062, 7),
(237593, NULL, 'MF_04007', NULL, NULL, 'Major DNA-binding protein [DBP].', NULL, 'HSV_DNBI', NULL, NULL, 5704, 7),
(237594, NULL, 'MF_02231', NULL, NULL, 'Ubiquinone biosynthesis accessory factor UbiT [ubiT].', NULL, 'UbiT', NULL, NULL, 16349, 7),
(237595, NULL, 'MF_01349', NULL, NULL, 'Bifunctional pantoate ligase/cytidylate kinase [panC/cmk].', NULL, 'PanCY', NULL, NULL, 20031, 7),
(237596, NULL, 'MF_01190', NULL, NULL, 'HTH-type transcriptional repressor FabR [fabR].', NULL, 'HTH_type_FabR', NULL, NULL, 16897, 7),
(237597, NULL, 'MF_00329', NULL, NULL, '50S ribosomal protein L18e [rpl18e].', NULL, 'Ribosomal_L18e', NULL, NULL, 14803, 7),
(237598, NULL, 'MF_01675', NULL, NULL, 'O-phospho-L-seryl-tRNA:Cys-tRNA synthase.', NULL, 'Sep_Cys_tRNA_synth', NULL, NULL, 11137, 7),
(237599, NULL, 'MF_01176', NULL, NULL, 'HTH-type transcriptional regulator IscR [iscR].', NULL, 'HTH_type_IscR', NULL, NULL, 5337, 7),
(237600, NULL, 'MF_01848', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase F [rlmF].', NULL, '23SrRNA_methyltr_F', NULL, NULL, 17184, 7),
(237601, NULL, 'MF_00122', NULL, NULL, 'Aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase subunit C [gatC].', NULL, 'GatC', NULL, NULL, 3098, 7),
(237602, NULL, 'MF_00140_A', NULL, NULL, 'Tryptophan--tRNA ligase [trpS].', NULL, 'Trp_tRNA_synth_A', NULL, NULL, 20962, 7),
(237603, NULL, 'MF_02123', NULL, NULL, 'F420-dependent glucose-6-phosphate dehydrogenase [fgd].', NULL, 'F420_G6P_DH', NULL, NULL, 18351, 7),
(237604, NULL, 'MF_01557', NULL, NULL, 'Tagatose-6-phosphate kinase [lacC].', NULL, 'LacC', NULL, NULL, 429, 7),
(237605, NULL, 'MF_01470', NULL, NULL, 'CRISPR-associated endonuclease Cas1 [cas1].', NULL, 'Cas1', NULL, NULL, 3676, 7),
(237606, NULL, 'MF_03051', NULL, NULL, 'Molybdopterin synthase sulfur carrier subunit [cnxG].', NULL, 'MOCS2A', NULL, NULL, 23882, 7),
(237607, NULL, 'MF_01660', NULL, NULL, '2-succinyl-6-hydroxy-2,4-cyclohexadiene-1-carboxylate synthase [menH].', NULL, 'MenH', NULL, NULL, 16496, 7),
(237608, NULL, 'MF_01106', NULL, NULL, 'Arginine biosynthesis bifunctional protein ArgJ [argJ].', NULL, 'ArgJ', NULL, NULL, 4625, 7),
(237609, NULL, 'MF_00770', NULL, NULL, 'Rhamnulose-1-phosphate aldolase [rhaD].', NULL, 'RhaD', NULL, NULL, 9174, 7),
(237610, NULL, 'MF_00211', NULL, NULL, 'Anthranilate phosphoribosyltransferase [trpD].', NULL, 'TrpD', NULL, NULL, 449, 7),
(237611, NULL, 'MF_01329', NULL, NULL, 'Photosystem II reaction center protein Ycf12 [ycf12].', NULL, 'PSII_Ycf12', NULL, NULL, 7613, 7),
(237612, NULL, 'MF_00906', NULL, NULL, 'Cell division protein ZapC [zapC].', NULL, 'ZapC', NULL, NULL, 13197, 7),
(237613, NULL, 'MF_02070', NULL, NULL, 'N-acetylglucosaminyldiphosphoundecaprenol N-acetyl-beta-D-mannosaminyltransferase.', NULL, 'TagA_TarA', NULL, NULL, 18875, 7),
(237614, NULL, 'MF_02210', NULL, NULL, '[Ribosomal protein S18]-alanine N-acetyltransferase [rimI].', NULL, 'RimI', NULL, NULL, 35454, 7),
(237615, NULL, 'MF_00402', NULL, NULL, '50S ribosomal protein L19 [rplS].', NULL, 'Ribosomal_L19', NULL, NULL, 4104, 7),
(237616, NULL, 'MF_03181', NULL, NULL, 'PAN2-PAN3 deadenylation complex subunit PAN3 [PAN3].', NULL, 'PAN3', NULL, NULL, 21983, 7),
(237617, NULL, 'MF_00703', NULL, NULL, 'Putative thymidine phosphorylase.', NULL, 'Thymid_phosp_2', NULL, NULL, 25290, 7);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(237618, NULL, 'MF_01118', NULL, NULL, 'Uncharacterized MFS-type transporter YhhS [yhhS].', NULL, 'MFS_YhhS', NULL, NULL, 15376, 7),
(237619, NULL, 'MF_01526', NULL, NULL, 'UPF0342 protein <locus_tag>.', NULL, 'UPF0342', NULL, NULL, 8957, 7),
(237620, NULL, 'MF_01615', NULL, NULL, 'Pyridoxal 5''-phosphate synthase subunit PdxT [pdxT].', NULL, 'PdxT', NULL, NULL, 5189, 7),
(237621, NULL, 'MF_00023', NULL, NULL, 'SsrA-binding protein [smpB].', NULL, 'SmpB', NULL, NULL, 2703, 7),
(237622, NULL, 'MF_00353', NULL, NULL, 'Light-independent protochlorophyllide reductase subunit B [bchB].', NULL, 'ChlB_BchB', NULL, NULL, 1409, 7),
(237623, NULL, 'MF_01866', NULL, NULL, 'Protein YcgL [ycgL].', NULL, 'UPF0745', NULL, NULL, 24202, 7),
(237624, NULL, 'MF_01191', NULL, NULL, 'UPF0442 protein YjjB [yjjB].', NULL, 'UPF0442', NULL, NULL, 14675, 7),
(237625, NULL, 'MF_02035', NULL, NULL, 'Hercynine oxygenase [egtB].', NULL, 'EgtB', NULL, NULL, 22602, 7),
(237626, NULL, 'MF_01860', NULL, NULL, 'UPF0736 protein <locus_tag>.', NULL, 'UPF0736', NULL, NULL, 14548, 7),
(237627, NULL, 'MF_00462', NULL, NULL, 'Ion-translocating oxidoreductase complex subunit D [rsxD].', NULL, 'RsxD_RnfD', NULL, NULL, 12021, 7),
(237628, NULL, 'MF_02061', NULL, NULL, 'Thioredoxin/glutathione peroxidase BtuE [btuE].', NULL, 'Thiored_glutath_peroxid', NULL, NULL, 28712, 7),
(237629, NULL, 'MF_00652', NULL, NULL, 'UPF0246 protein YaaA [yaaA].', NULL, 'UPF0246', NULL, NULL, 1862, 7),
(237630, NULL, 'MF_00279', NULL, NULL, 'Pyridoxine 5''-phosphate synthase [pdxJ].', NULL, 'PdxJ', NULL, NULL, 730, 7),
(237631, NULL, 'MF_03049', NULL, NULL, 'Adenylyltransferase and sulfurtransferase MOCS3 [MOCS3].', NULL, 'MOCS3_Uba4', NULL, NULL, 25258, 7),
(237632, NULL, 'MF_00838', NULL, NULL, 'Diadenylate cyclase [dacB].', NULL, 'DacB', NULL, NULL, 16443, 7),
(237633, NULL, 'MF_00945_A', NULL, NULL, 'Transcription termination/antitermination protein NusA [nusA].', NULL, 'NusA_A', NULL, NULL, 4064, 7),
(237634, NULL, 'MF_01200_B', NULL, NULL, 'Orotidine 5''-phosphate decarboxylase [pyrF].', NULL, 'OMPdecase_type1_B', NULL, NULL, 9132, 7),
(237635, NULL, 'MF_01068', NULL, NULL, 'Glucans biosynthesis protein D [mdoD].', NULL, 'MdoD_OpgD', NULL, NULL, 16937, 7),
(237636, NULL, 'MF_03068', NULL, NULL, 'ATP-dependent RNA helicase DHX29 [DHX29].', NULL, 'DHX29', NULL, NULL, 9984, 7),
(237637, NULL, 'MF_03158', NULL, NULL, 'Thiamine thiazole synthase, chloroplastic [THI4].', NULL, 'THI4', NULL, NULL, 25300, 7),
(237638, NULL, 'MF_01459', NULL, NULL, 'Chromophore lyase CpcS/CpeS [cpcS].', NULL, 'Chrphore_lyase_CpxS', NULL, NULL, 14729, 7),
(237639, NULL, 'MF_00326', NULL, NULL, '50S ribosomal protein L7Ae [rpl7ae].', NULL, 'Ribosomal_L7Ae_Arch', NULL, NULL, 16118, 7),
(237640, NULL, 'MF_00386', NULL, NULL, 'Putative membrane protein insertion efficiency factor [yidD].', NULL, 'UPF0161_YidD', NULL, NULL, 3956, 7),
(237641, NULL, 'MF_00475', NULL, NULL, 'Trp operon repressor [trpR].', NULL, 'Trp_repressor', NULL, NULL, 18602, 7),
(237642, NULL, 'MF_01178', NULL, NULL, 'Sigma factor-binding protein Crl [crl].', NULL, 'Crl', NULL, NULL, 8250, 7),
(237643, NULL, 'MF_01585', NULL, NULL, 'Lysophospholipid transporter LplT [lplT].', NULL, 'MFS_LplT', NULL, NULL, 7403, 7),
(237644, NULL, 'MF_04156', NULL, NULL, 'DNA helicase assembly protein [59].', NULL, 'HELIC_LOADER_T4', NULL, NULL, 8700, 7),
(237645, NULL, 'MF_00066', NULL, NULL, 'Sulfate adenylyltransferase [sat].', NULL, 'Sulf_adenylyltr', NULL, NULL, 20739, 7),
(237646, NULL, 'MF_00165', NULL, NULL, 'Thymidylate kinase [tmk].', NULL, 'Thymidylate_kinase', NULL, NULL, 20548, 7),
(237647, NULL, 'MF_00195', NULL, NULL, 'GTPase Der [der].', NULL, 'GTPase_Der', NULL, NULL, 15435, 7),
(237648, NULL, 'MF_00769', NULL, NULL, '2-phosphoglycerate kinase [pgk2].', NULL, '2PGK', NULL, NULL, 19681, 7),
(237649, NULL, 'MF_04140', NULL, NULL, 'Flap endonuclease.', NULL, 'FEN_T5', NULL, NULL, 34606, 7),
(237650, NULL, 'MF_01071', NULL, NULL, 'UPF0266 membrane protein YobD [yobD].', NULL, 'UPF0266', NULL, NULL, 14342, 7);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(237651, NULL, 'MF_00489', NULL, NULL, 'UPF0178 protein YaiI [yaiI].', NULL, 'UPF0178', NULL, NULL, 6168, 7),
(237652, NULL, 'MF_02118', NULL, NULL, 'Octanoyltransferase LipM [lipM].', NULL, 'LipM', NULL, NULL, 21602, 7),
(237653, NULL, 'MF_01838', NULL, NULL, 'Trans-2-enoyl-CoA reductase [NADH] [fabV].', NULL, 'FabV_reductase', NULL, NULL, 9671, 7),
(237654, NULL, 'MF_00533', NULL, NULL, 'Nitrogenase iron protein [nifH].', NULL, 'NifH', NULL, NULL, 1464, 7),
(237655, NULL, 'MF_00516', NULL, NULL, 'Monomeric sarcosine oxidase [soxA].', NULL, 'MSOX', NULL, NULL, 3931, 7),
(237656, NULL, 'MF_01981', NULL, NULL, 'ATP-dependent 6-phosphofructokinase [pfkA].', NULL, 'Phosphofructokinase_II_X', NULL, NULL, 10062, 7),
(237657, NULL, 'MF_03069', NULL, NULL, 'Protein kintoun [DNAAF2].', NULL, 'Kintoun', NULL, NULL, 20289, 7),
(237658, NULL, 'MF_01372', NULL, NULL, 'UPF0412 protein YaaI [yaaI].', NULL, 'UPF0412', NULL, NULL, 21148, 7),
(237659, NULL, 'MF_03208', NULL, NULL, 'Phosphatidylserine decarboxylase proenzyme [PISD].', NULL, 'PS_decarb_PSD_B_type1_euk', NULL, NULL, 29556, 7),
(237660, NULL, 'MF_00184', NULL, NULL, 'Threonine--tRNA ligase [thrS].', NULL, 'Thr_tRNA_synth', NULL, NULL, 6103, 7),
(237661, NULL, 'MF_01270', NULL, NULL, 'Anhydro-N-acetylmuramic acid kinase [anmK].', NULL, 'AnhMurNAc_kinase', NULL, NULL, 6303, 7),
(237662, NULL, 'MF_00264', NULL, NULL, 'UPF0128 protein <locus_tag>.', NULL, 'UPF0128', NULL, NULL, 4110, 7),
(237663, NULL, 'MF_04154', NULL, NULL, 'DNA helicase/primase [4].', NULL, 'Helic_Prim_T7', NULL, NULL, 33602, 7),
(237664, NULL, 'MF_00557', NULL, NULL, 'Alginate lyase [algL].', NULL, 'Alginate_lyase', NULL, NULL, 16636, 7),
(237665, NULL, 'MF_01410', NULL, NULL, 'Glucose-6-phosphate isomerase [pgiA].', NULL, 'G6P_isomerase_arch', NULL, NULL, 21159, 7),
(237666, NULL, 'MF_00268', NULL, NULL, 'Protein RecA [recA].', NULL, 'RecA', NULL, NULL, 7303, 7),
(237667, NULL, 'MF_04088', NULL, NULL, 'Non-structural protein 1.', NULL, 'ROTA_NSP1', NULL, NULL, 5282, 7),
(237668, NULL, 'MF_01682', NULL, NULL, 'Acireductone dioxygenase [mtnD].', NULL, 'Salvage_MtnD', NULL, NULL, 8208, 7),
(237669, NULL, 'MF_01567', NULL, NULL, 'UPF0371 protein <locus_tag>.', NULL, 'UPF0371', NULL, NULL, 7907, 7),
(237670, NULL, 'MF_01868', NULL, NULL, 'Lipopolysaccharide core heptose(II)-phosphate phosphatase [ais].', NULL, 'Ais', NULL, NULL, 10210, 7),
(237671, NULL, 'MF_01073', NULL, NULL, 'Macrodomain Ter protein [matP].', NULL, 'MatP', NULL, NULL, 8409, 7),
(237672, NULL, 'MF_01008', NULL, NULL, 'Transcriptional regulator MraZ [mraZ].', NULL, 'MraZ', NULL, NULL, 5375, 7),
(237673, NULL, 'MF_01684', NULL, NULL, '5''-methylthioadenosine/S-adenosylhomocysteine nucleosidase [mtnN].', NULL, 'Salvage_MtnN', NULL, NULL, 5440, 7),
(237674, NULL, 'MF_00750', NULL, NULL, 'Oxygen-dependent choline dehydrogenase [betA].', NULL, 'Choline_dehydrogen', NULL, NULL, 8925, 7),
(237675, NULL, 'MF_01890', NULL, NULL, 'Penicillin-binding protein activator LpoA [lpoA].', NULL, 'LpoA', NULL, NULL, 4819, 7),
(237676, NULL, 'MF_00378', NULL, NULL, 'Exodeoxyribonuclease 7 large subunit [xseA].', NULL, 'Exonuc_7_L', NULL, NULL, 2366, 7),
(237677, NULL, 'MF_01301', NULL, NULL, 'Maltoporin [lamB].', NULL, 'LamB', NULL, NULL, 16781, 7),
(237678, NULL, 'MF_00572', NULL, NULL, '2-isopropylmalate synthase [leuA].', NULL, 'LeuA_type2', NULL, NULL, 3702, 7),
(237679, NULL, 'MF_01408', NULL, NULL, 'Flavin-dependent thymidylate synthase [thyX].', NULL, 'ThyX', NULL, NULL, 1196, 7),
(237680, NULL, 'MF_01326_A', NULL, NULL, '50S ribosomal protein L24 [rplX].', NULL, 'Ribosomal_L24_A', NULL, NULL, 4891, 7),
(237681, NULL, 'MF_01603', NULL, NULL, 'Bifunctional protein HldE [hldE].', NULL, 'HldE', NULL, NULL, 15186, 7),
(237682, NULL, 'MF_04048', NULL, NULL, 'Pre-protein VI [L3].', NULL, 'ADV_CAP6', NULL, NULL, 3699, 7),
(237683, NULL, 'MF_01569', NULL, NULL, 'Proline--tRNA ligase [proS].', NULL, 'Pro_tRNA_synth_type1', NULL, NULL, 10053, 7),
(237684, NULL, 'MF_00747', NULL, NULL, 'Isocitrate dehydrogenase kinase/phosphatase [aceK].', NULL, 'AceK', NULL, NULL, 10307, 7);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(237685, NULL, 'MF_01691', NULL, NULL, '2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-acetyltransferase [dapH].', NULL, 'DapH', NULL, NULL, 16997, 7),
(237686, NULL, 'MF_01983', NULL, NULL, 'UbiD-like decarboxylase.', NULL, 'UbiD_FDC', NULL, NULL, 24240, 7),
(237687, NULL, 'MF_00156', NULL, NULL, '3-methyl-2-oxobutanoate hydroxymethyltransferase [panB].', NULL, 'PanB', NULL, NULL, 2403, 7),
(237688, NULL, 'MF_04092', NULL, NULL, 'Non-structural protein 5.', NULL, 'ROTA_NSP5', NULL, NULL, 976, 7),
(237689, NULL, 'MF_00363', NULL, NULL, 'UPF0154 protein <locus_tag>.', NULL, 'UPF0154', NULL, NULL, 6314, 7),
(237690, NULL, 'MF_00320', NULL, NULL, 'DNA-directed RNA polymerase subunit Rpo3 [rpo3].', NULL, 'RNApol_arch_Rpo3', NULL, NULL, 14519, 7),
(237691, NULL, 'MF_01833', NULL, NULL, 'tRNA-splicing endonuclease [endA].', NULL, 'EndA_short', NULL, NULL, 15130, 7),
(237692, NULL, 'MF_00766', NULL, NULL, 'Biosynthetic peptidoglycan transglycosylase [mtgA].', NULL, 'PGT_MtgA', NULL, NULL, 13135, 7),
(237693, NULL, 'MF_04035', NULL, NULL, 'Envelope glycoprotein M [gM].', NULL, 'HSV_GM', NULL, NULL, 4600, 7),
(237694, NULL, 'MF_04207', NULL, NULL, 'Hemagglutinin-esterase [HE].', NULL, 'BETA_CORONA_HE', NULL, NULL, 37725, 7),
(237695, NULL, 'MF_00123', NULL, NULL, 'Arginine--tRNA ligase [argS].', NULL, 'Arg_tRNA_synth', NULL, NULL, 34, 7),
(237696, NULL, 'MF_01956', NULL, NULL, 'G/U mismatch-specific DNA glycosylase [mug].', NULL, 'MUG', NULL, NULL, 16373, 7),
(237697, NULL, 'MF_01000', NULL, NULL, 'Vitamin B12-binding protein [btuF].', NULL, 'BtuF', NULL, NULL, 16899, 7),
(237698, NULL, 'MF_01627', NULL, NULL, 'Purine nucleoside phosphorylase DeoD-type [deoD].', NULL, 'Pur_nucleosid_phosp', NULL, NULL, 5573, 7),
(237699, NULL, 'MF_01033', NULL, NULL, '3-isopropylmalate dehydrogenase [leuB].', NULL, 'LeuB_type1', NULL, NULL, 7334, 7),
(237700, NULL, 'MF_00823', NULL, NULL, 'Acetyl-coenzyme A carboxylase carboxyl transferase subunit alpha [accA].', NULL, 'AcetylCoA_CT_alpha', NULL, NULL, 2312, 7),
(237701, NULL, 'MF_00511', NULL, NULL, '30S ribosomal protein S17e [rps17e].', NULL, 'Ribosomal_S17e', NULL, NULL, 1414, 7),
(237702, NULL, 'MF_01273', NULL, NULL, 'Type II pantothenate kinase [coaW].', NULL, 'Pantothen_kinase_2', NULL, NULL, 11103, 7),
(237703, NULL, 'MF_04143', NULL, NULL, 'Poxin-Schlafen.', NULL, 'Poxins', NULL, NULL, 3808, 7),
(237704, NULL, 'MF_01824', NULL, NULL, 'Pyridoxal 5''-phosphate synthase subunit PdxS [pdxS].', NULL, 'PdxS', NULL, NULL, 4143, 7),
(237705, NULL, 'MF_00767', NULL, NULL, 'Succinylglutamate desuccinylase [astE].', NULL, 'Arg_catab_AstE', NULL, NULL, 20010, 7),
(237706, NULL, 'MF_01048', NULL, NULL, 'Protein PsiE [psiE].', NULL, 'PsiE', NULL, NULL, 14330, 7),
(237707, NULL, 'MF_00007', NULL, NULL, 'DNA primase DnaG [dnaG].', NULL, 'DNA_primase_DnaG_arc', NULL, NULL, 14935, 7),
(237708, NULL, 'MF_00082', NULL, NULL, 'Acetylglutamate kinase [argB].', NULL, 'ArgB', NULL, NULL, 32765, 7),
(237709, NULL, 'MF_00850', NULL, NULL, 'Pyruvate dehydrogenase [ubiquinone] [poxB].', NULL, 'POX', NULL, NULL, 36475, 7),
(237710, NULL, 'MF_00655', NULL, NULL, 'PqqA binding protein [pqqD].', NULL, 'PQQ_syn_PqqD', NULL, NULL, 16261, 7),
(237711, NULL, 'MF_01004', NULL, NULL, 'Vitamin B12 import system permease protein BtuC [btuC].', NULL, 'BtuC', NULL, NULL, 11731, 7),
(237712, NULL, 'MF_00111', NULL, NULL, 'UDP-N-acetylglucosamine 1-carboxyvinyltransferase [murA].', NULL, 'MurA', NULL, NULL, 4695, 7),
(237713, NULL, 'MF_04037', NULL, NULL, 'Envelope glycoprotein N [gN].', NULL, 'HSV_GN', NULL, NULL, 8311, 7),
(237714, NULL, 'MF_01803', NULL, NULL, 'Chromosome partition protein MukF [mukF].', NULL, 'MukF', NULL, NULL, 1523, 7),
(237715, NULL, 'MF_00859', NULL, NULL, 'Ribulose bisphosphate carboxylase small subunit [cbbS].', NULL, 'RuBisCO_S_bact', NULL, NULL, 3362, 7),
(237716, NULL, 'MF_01606', NULL, NULL, 'Iron-sulfur cluster repair protein YtfE [ytfE].', NULL, 'RIC_YtfE', NULL, NULL, 10732, 7),
(237717, NULL, 'MF_01501', NULL, NULL, 'Tetrahydromethanopterin S-methyltransferase subunit H [mtrH].', NULL, 'MtrH', NULL, NULL, 22104, 7);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(237718, NULL, 'MF_01159', NULL, NULL, 'Initiation-control protein YabA.', NULL, 'YabA', NULL, NULL, 9232, 7),
(237719, NULL, 'MF_01344', NULL, NULL, 'Cytochrome b6-f complex subunit 4 [petD].', NULL, 'Cytb6_f_subIV', NULL, NULL, 6964, 7),
(237720, NULL, 'MF_00366', NULL, NULL, 'DNA-directed RNA polymerase subunit omega [rpoZ].', NULL, 'RNApol_bact_RpoZ', NULL, NULL, 2383, 7),
(237721, NULL, 'MF_00261', NULL, NULL, 'DNA-directed RNA polymerase subunit Rpo11 [rpo11].', NULL, 'RNApol_arch_Rpo11', NULL, NULL, 17265, 7),
(237722, NULL, 'MF_01867', NULL, NULL, 'Putative cysteine ligase BshC [bshC].', NULL, 'BshC', NULL, NULL, 9674, 7),
(237723, NULL, 'MF_00025', NULL, NULL, 'DNA-directed RNA polymerase subunit Rpo5 [rpo5].', NULL, 'RNApol_Rpo5_RPB5', NULL, NULL, 12210, 7),
(237724, NULL, 'MF_00454', NULL, NULL, 'Putative fluoride ion transporter CrcB [crcB].', NULL, 'CrcB', NULL, NULL, 1540, 7),
(237725, NULL, 'MF_04001', NULL, NULL, 'Regulatory protein E2 [E2].', NULL, 'PPV_E2', NULL, NULL, 29600, 7),
(237726, NULL, 'MF_00485', NULL, NULL, '30S ribosomal protein S4e [rps4e].', NULL, 'Ribosomal_S4e', NULL, NULL, 4627, 7),
(237727, NULL, 'MF_00250', NULL, NULL, 'DNA-directed RNA polymerase subunit Rpo10 [rpo10].', NULL, 'RNApol_arch_Rpo10', NULL, NULL, 593, 7),
(237728, NULL, 'MF_01514', NULL, NULL, 'UPF0314 protein <locus_tag>.', NULL, 'UPF0314', NULL, NULL, 20232, 7),
(237729, NULL, 'MF_03060', NULL, NULL, 'Draxin [DRAXIN].', NULL, 'Draxin', NULL, NULL, 25252, 7),
(237730, NULL, 'MF_01974', NULL, NULL, 'Methionine aminopeptidase [map].', NULL, 'MetAP_1', NULL, NULL, 6896, 7),
(237731, NULL, 'MF_00170', NULL, NULL, 'Ribose-5-phosphate isomerase A [rpiA].', NULL, 'Rib_5P_isom_A', NULL, NULL, 20767, 7),
(237732, NULL, 'MF_00323', NULL, NULL, 'Coproporphyrin III ferrochelatase [cpfC].', NULL, 'Ferrochelatase', NULL, NULL, 2295, 7),
(237733, NULL, 'MF_01875', NULL, NULL, 'Non-homologous end joining protein Ku [ku].', NULL, 'Prokaryotic_Ku', NULL, NULL, 9701, 7),
(237734, NULL, 'MF_04161', NULL, NULL, 'Sliding clamp.', NULL, 'Sliding_clamp_T4', NULL, NULL, 33889, 7),
(237735, NULL, 'MF_01632', NULL, NULL, 'Chorismate pyruvate-lyase [ubiC].', NULL, 'UbiC', NULL, NULL, 4455, 7),
(237736, NULL, 'MF_00051', NULL, NULL, 'Serine hydroxymethyltransferase [glyA].', NULL, 'SHMT', NULL, NULL, 2430, 7),
(237737, NULL, 'MF_00368', NULL, NULL, '50S ribosomal protein L7/L12 [rplL].', NULL, 'Ribosomal_L7_L12', NULL, NULL, 3982, 7),
(237738, NULL, 'MF_02131', NULL, NULL, '6-hydroxymethyl-7,8-dihydropterin pyrophosphokinase [mptE].', NULL, 'HMPDK_arch', NULL, NULL, 23569, 7),
(237739, NULL, 'MF_01357', NULL, NULL, 'NAD(P)H-quinone oxidoreductase subunit J, chloroplastic [ndhJ].', NULL, 'NDH1_NuoC', NULL, NULL, 4063, 7),
(237740, NULL, 'MF_01265', NULL, NULL, 'L-aspartate dehydrogenase [nadX].', NULL, 'NadX', NULL, NULL, 20365, 7),
(237741, NULL, 'MF_01294', NULL, NULL, 'D-tagatose-1,6-bisphosphate aldolase subunit GatY [gatY].', NULL, 'TagBP_aldolase_GatY', NULL, NULL, 10683, 7),
(237742, NULL, 'MF_03032', NULL, NULL, 'Protein argonaute-3 [EIF2C3].', NULL, 'AGO3', NULL, NULL, 26377, 7),
(237743, NULL, 'MF_04098', NULL, NULL, 'Spike glycoprotein [S].', NULL, 'GAMMA_CORONA_SPIKE', NULL, NULL, NULL, 7),
(237744, NULL, 'MF_00093', NULL, NULL, 'Peptide chain release factor 1 [prfA].', NULL, 'Rel_fac_1', NULL, NULL, 5097, 7),
(237745, NULL, 'MF_01040', NULL, NULL, 'Probable phosphoglycerate mutase GpmB [gpmB].', NULL, 'PGAM_GpmB', NULL, NULL, 15965, 7),
(237746, NULL, 'MF_00608', NULL, NULL, 'GTP cyclohydrolase III [gch3].', NULL, 'GTP_cyclohydro_3', NULL, NULL, 2033, 7),
(237747, NULL, 'MF_02036', NULL, NULL, 'Gamma-glutamyl-hercynylcysteine sulfoxide hydrolase [egtC].', NULL, 'EgtC', NULL, NULL, 22846, 7),
(237748, NULL, 'MF_01089', NULL, NULL, 'UPF0288 protein <locus_tag>.', NULL, 'UPF0288', NULL, NULL, 15039, 7),
(237749, NULL, 'MF_02221', NULL, NULL, 'Carbamoyl-phosphate synthase.', NULL, 'CPSase', NULL, NULL, 35308, 7),
(237750, NULL, 'MF_00207', NULL, NULL, 'Probable manganese-dependent inorganic pyrophosphatase [ppaC].', NULL, 'PPase_C', NULL, NULL, 14640, 7);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(237751, NULL, 'MF_01304', NULL, NULL, 'UPF0194 membrane protein YbhG [ybhG].', NULL, 'UPF0194', NULL, NULL, 14942, 7),
(237752, NULL, 'MF_01394', NULL, NULL, 'NAD(P)H-quinone oxidoreductase subunit 3, chloroplastic [ndhC].', NULL, 'NDH1_NuoA', NULL, NULL, 15296, 7),
(237753, NULL, 'MF_02079', NULL, NULL, 'Peptidoglycan glycosyltransferase MrdB [mrdB].', NULL, 'PGT_RodA', NULL, NULL, 11318, 7),
(237754, NULL, 'MF_00403_B', NULL, NULL, '30S ribosomal protein S12 [rpsL].', NULL, 'Ribosomal_S12_B', NULL, NULL, 3549, 7),
(237755, NULL, 'MF_00362', NULL, NULL, '50S ribosomal protein L10 [rplJ].', NULL, 'Ribosomal_L10', NULL, NULL, 14829, 7),
(237756, NULL, 'MF_00425', NULL, NULL, 'Na(+)-translocating NADH-quinone reductase subunit A [nqrA].', NULL, 'NqrA', NULL, NULL, 13060, 7),
(237757, NULL, 'MF_00483', NULL, NULL, 'DNA replication terminus site-binding protein [tus].', NULL, 'Rep_term_Tus', NULL, NULL, 7866, 7),
(237758, NULL, 'MF_03228', NULL, NULL, 'Probable butyrate:acetyl-CoA coenzyme A-transferase.', NULL, 'But_CoA_trans', NULL, NULL, 12577, 7),
(237759, NULL, 'MF_01931', NULL, NULL, 'Amidophosphoribosyltransferase [purF].', NULL, 'PurF', NULL, NULL, 6710, 7),
(237760, NULL, 'MF_01457', NULL, NULL, 'Flagellar brake protein YcgR [ycgR].', NULL, 'YcgR', NULL, NULL, 16655, 7),
(237761, NULL, 'MF_00388', NULL, NULL, 'UDP-3-O-acyl-N-acetylglucosamine deacetylase [lpxC].', NULL, 'LpxC', NULL, NULL, 7070, 7),
(237762, NULL, 'MF_01927', NULL, NULL, 'Formyltetrahydrofolate deformylase [purU].', NULL, 'PurU', NULL, NULL, 4457, 7),
(237763, NULL, 'MF_01464_B', NULL, NULL, 'Protein-export membrane protein SecF [secF].', NULL, 'SecF_B', NULL, NULL, 3809, 7),
(237764, NULL, 'MF_04053', NULL, NULL, 'Core-capsid bridging protein [L2].', NULL, 'ADV_CORE5', NULL, NULL, 2936, 7),
(237765, NULL, 'MF_03220', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta, mitochondrial [SUCLA2].', NULL, 'Succ_CoA_betaA_euk', NULL, NULL, 29254, 7),
(237766, NULL, 'MF_01929', NULL, NULL, 'N5-carboxyaminoimidazole ribonucleotide mutase [purE].', NULL, 'PurE_classI', NULL, NULL, 30835, 7),
(237767, NULL, 'MF_01938', NULL, NULL, '2-carboxy-1,4-naphthoquinone phytyltransferase [menA].', NULL, 'MenA_2', NULL, NULL, 11353, 7),
(237768, NULL, 'MF_01565', NULL, NULL, 'Zinc transport protein ZntB [zntB].', NULL, 'ZntB', NULL, NULL, 10517, 7),
(237769, NULL, 'MF_01910', NULL, NULL, 'Probable ribonuclease FAU-1 [fau-1].', NULL, 'RNA_binding_AU_1', NULL, NULL, 21006, 7),
(237770, NULL, 'MF_01554_A', NULL, NULL, 'Phosphoglucosamine mutase [glmM].', NULL, 'GlmM_A', NULL, NULL, 8489, 7),
(237771, NULL, 'MF_01533', NULL, NULL, 'HTH-type transcriptional activator RhaR [rhaR].', NULL, 'HTH_type_RhaR', NULL, NULL, 7310, 7),
(237772, NULL, 'MF_00592', NULL, NULL, 'Deoxyribose-phosphate aldolase [deoC].', NULL, 'DeoC_type2', NULL, NULL, 16362, 7),
(237773, NULL, 'MF_01521', NULL, NULL, 'Probable manganese efflux pump MntP [mntP].', NULL, 'MntP_pump', NULL, NULL, 14632, 7),
(237774, NULL, 'MF_00553', NULL, NULL, 'Proteasome-activating nucleotidase [pan].', NULL, 'PAN', NULL, NULL, 16067, 7),
(237775, NULL, 'MF_01121', NULL, NULL, 'NAD-dependent protein deacylase [cobB].', NULL, 'Sirtuin_ClassIII', NULL, NULL, 23616, 7),
(237776, NULL, 'MF_01174', NULL, NULL, 'N-succinylglutamate 5-semialdehyde dehydrogenase [astD].', NULL, 'Aldedh_AstD', NULL, NULL, 17368, 7),
(237777, NULL, 'MF_00159', NULL, NULL, '4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase (ferredoxin) [ispG].', NULL, 'IspG', NULL, NULL, 883, 7),
(237778, NULL, 'MF_01168', NULL, NULL, 'N-glycosylase/DNA lyase.', NULL, 'AGOG', NULL, NULL, 16219, 7),
(237779, NULL, 'MF_01210_B', NULL, NULL, 'Carbamoyl-phosphate synthase large chain [carB].', NULL, 'CPSase_L_chain_B', NULL, NULL, 3896, 7),
(237780, NULL, 'MF_02053', NULL, NULL, 'Autoinducer-2 kinase [lsrK].', NULL, 'LsrK', NULL, NULL, 29466, 7),
(237781, NULL, 'MF_02121', NULL, NULL, 'Aspartate-semialdehyde dehydrogenase [asd].', NULL, 'ASADH', NULL, NULL, 12938, 7),
(237782, NULL, 'MF_04157', NULL, NULL, 'DNA primase.', NULL, 'PRIMASE_T4', NULL, NULL, 36998, 7);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(237783, NULL, 'MF_00927', NULL, NULL, 'Cell wall synthesis protein CwsA [cwsA].', NULL, 'CwsA', NULL, NULL, 20418, 7),
(237784, NULL, 'MF_01889', NULL, NULL, 'Penicillin-binding protein activator LpoB [lpoB].', NULL, 'LpoB', NULL, NULL, 14414, 7),
(237785, NULL, 'MF_01285', NULL, NULL, 'Riboflavin kinase [ribK].', NULL, 'Riboflavin_kinase', NULL, NULL, 16167, 7),
(237786, NULL, 'MF_00414', NULL, NULL, 'Probable protein kinase UbiB [ubiB].', NULL, 'UbiB', NULL, NULL, 4381, 7),
(237787, NULL, 'MF_01642', NULL, NULL, 'LL-diaminopimelate aminotransferase [dapL].', NULL, 'DapL_aminotrans_1', NULL, NULL, 18151, 7),
(237788, NULL, 'MF_01083', NULL, NULL, 'Glutarate 2-hydroxylase [glaH].', NULL, 'glutarate_hydroxylase', NULL, NULL, 7932, 7),
(237789, NULL, 'MF_01587', NULL, NULL, 'DNA ligase B [ligB].', NULL, 'DNA_ligase_B', NULL, NULL, 14825, 7),
(237790, NULL, 'MF_02068', NULL, NULL, 'Ribitol-5-phosphate cytidylyltransferase [tarI].', NULL, 'TarI', NULL, NULL, 20905, 7),
(237791, NULL, 'MF_00231', NULL, NULL, 'Translation initiation factor 2 subunit alpha [eif2a].', NULL, 'eIF_2_alpha', NULL, NULL, 15759, 7),
(237792, NULL, 'MF_01028', NULL, NULL, 'Putative (R)-citramalate synthase CimA [cimA].', NULL, 'CimA', NULL, NULL, 17849, 7),
(237793, NULL, 'MF_03187', NULL, NULL, 'EEF1A lysine methyltransferase 1 [EEF1AKMT1].', NULL, 'Methyltr_EFM5', NULL, NULL, 15911, 7),
(237794, NULL, 'MF_01882', NULL, NULL, 'Probable propionate kinase [pduW].', NULL, 'Propion_kin_subfam2', NULL, NULL, 16475, 7),
(237795, NULL, 'MF_02212', NULL, NULL, 'Broad specificity amino-acid racemase.', NULL, 'Bsr_racemase', NULL, NULL, 35018, 7),
(237796, NULL, 'MF_00594', NULL, NULL, 'Cytochrome c6 [petJ].', NULL, 'Cytc_PetJ', NULL, NULL, 16371, 7),
(237797, NULL, 'MF_01101', NULL, NULL, 'UPF0208 membrane protein YfbV [yfbV].', NULL, 'UPF0208', NULL, NULL, 5370, 7),
(237798, NULL, 'MF_00513', NULL, NULL, 'HTH-type transcriptional regulator ArgP [argP].', NULL, 'HTH_type_ArgP', NULL, NULL, 16029, 7),
(237799, NULL, 'MF_03231', NULL, NULL, 'Acyl-coenzyme A diphosphatase SCS3 [SCS3].', NULL, 'SCS3', NULL, NULL, 37760, 7),
(237800, NULL, 'MF_00515', NULL, NULL, 'N-methyl-L-tryptophan oxidase [solA].', NULL, 'MTOX', NULL, NULL, 16050, 7),
(237801, NULL, 'MF_01532', NULL, NULL, 'L-rhamnose-proton symporter [rhaT].', NULL, 'RhaT', NULL, NULL, 2986, 7),
(237802, NULL, 'MF_01951', NULL, NULL, 'L-ribulose-5-phosphate 3-epimerase UlaE [ulaE].', NULL, 'UlaE', NULL, NULL, 16182, 7),
(237803, NULL, 'MF_01605', NULL, NULL, '6-phosphogluconolactonase [pgl].', NULL, '6P_gluconolactonase', NULL, NULL, 16146, 7),
(237804, NULL, 'MF_00447', NULL, NULL, 'Photosystem I reaction center subunit XI [psaL].', NULL, 'PSI_PsaL', NULL, NULL, 15119, 7),
(237805, NULL, 'MF_01645', NULL, NULL, 'Allantoinase [allB].', NULL, 'Hydantoinase', NULL, NULL, 15512, 7),
(237806, NULL, 'MF_00716', NULL, NULL, 'Nitrous-oxide reductase [nosZ].', NULL, 'NosZ', NULL, NULL, 16337, 7),
(237807, NULL, 'MF_01650', NULL, NULL, '3-phenylpropionate/cinnamic acid dioxygenase ferredoxin subunit [hcaC].', NULL, 'HcaC', NULL, NULL, 14731, 7),
(237808, NULL, 'MF_00562', NULL, NULL, 'D-aminoacyl-tRNA deacylase [dtdA].', NULL, 'Deacylase_DtdA', NULL, NULL, 19072, 7),
(237809, NULL, 'MF_01383', NULL, NULL, 'Photosystem II D2 protein [psbD].', NULL, 'PSII_PsbD_D2', NULL, NULL, 6665, 7),
(237810, NULL, 'MF_01306_A', NULL, NULL, '30S ribosomal protein S4 [rpsD].', NULL, 'Ribosomal_S4_A', NULL, NULL, 14861, 7),
(237811, NULL, 'MF_00690', NULL, NULL, 'UPF0270 protein YheU [yheU].', NULL, 'UPF0270', NULL, NULL, 9268, 7),
(237812, NULL, 'MF_01379', NULL, NULL, 'Photosystem II protein D1 [psbA].', NULL, 'PSII_PsbA_D1', NULL, NULL, 6523, 7),
(237813, NULL, 'MF_01031', NULL, NULL, '3-isopropylmalate dehydratase small subunit [leuD].', NULL, 'LeuD_type1', NULL, NULL, 7146, 7),
(237814, NULL, 'MF_03183', NULL, NULL, 'Endonuclease III-like protein 1 [NTHL1].', NULL, 'Endonuclease_III_Nth', NULL, NULL, 21507, 7),
(237815, NULL, 'MF_01869', NULL, NULL, 'Probable 4-amino-4-deoxy-L-arabinose-phosphoundecaprenol flippase subunit ArnE [arnE].', NULL, 'Flippase_ArnE', NULL, NULL, 17069, 7);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(237816, NULL, 'MF_00134_A', NULL, NULL, 'Indole-3-glycerol phosphate synthase [trpC].', NULL, 'IGPS_A', NULL, NULL, 9165, 7),
(237817, NULL, 'MF_00988', NULL, NULL, 'D-allose kinase [alsK].', NULL, 'Allose_kinase', NULL, NULL, 26646, 7),
(237818, NULL, 'MF_00955', NULL, NULL, 'GDP-mannose 4,6-dehydratase [gmd].', NULL, 'GDP_Man_dehydratase', NULL, NULL, 5537, 7),
(237819, NULL, 'MF_02229', NULL, NULL, '5-deoxyribose 1-phosphate isomerase [drdI].', NULL, 'Deoxyribose1P_isomerase', NULL, NULL, 35394, 7),
(237820, NULL, 'MF_02013', NULL, NULL, 'Cell division protein ZapA [zapA].', NULL, 'ZapA_type2', NULL, NULL, 14762, 7),
(237821, NULL, 'MF_00061', NULL, NULL, 'Putative 4-diphosphocytidyl-2-C-methyl-D-erythritol kinase [ispE].', NULL, 'IspE', NULL, NULL, 7397, 7),
(237822, NULL, 'MF_00299', NULL, NULL, 'Probable RNA 2''-phosphotransferase [kptA].', NULL, 'KptA', NULL, NULL, 14865, 7),
(237823, NULL, 'MF_01821', NULL, NULL, 'RNA polymerase-associated protein RapA [rapA].', NULL, 'Helicase_RapA', NULL, NULL, 8289, 7),
(237824, NULL, 'MF_01255', NULL, NULL, 'L-ectoine synthase [ectC].', NULL, 'Ectoine_synth', NULL, NULL, 10136, 7),
(237825, NULL, 'MF_00849', NULL, NULL, '50S ribosomal subunit assembly factor BipA [bipA].', NULL, 'BipA', NULL, NULL, 4974, 7),
(237826, NULL, 'MF_01119', NULL, NULL, 'UPF0294 protein YafD [yafD].', NULL, 'UPF0294', NULL, NULL, 14751, 7),
(237827, NULL, 'MF_01535', NULL, NULL, 'Rhamnulokinase [rhaB].', NULL, 'Rhamnulokinase', NULL, NULL, 9368, 7),
(237828, NULL, 'MF_00609', NULL, NULL, 'Histidine decarboxylase [hdc].', NULL, 'Pyridoxal_decarbox', NULL, NULL, 16406, 7),
(237829, NULL, 'MF_03129', NULL, NULL, 'Lipoyl synthase, chloroplastic [LIP1P].', NULL, 'Lipoyl_synth_plantC', NULL, NULL, 23843, 7),
(237830, NULL, 'MF_00235', NULL, NULL, 'Adenylate kinase [adk].', NULL, 'Adenylate_kinase_Adk', NULL, NULL, 174, 7),
(237831, NULL, 'MF_00263', NULL, NULL, 'UPF0127 protein <locus_tag>.', NULL, 'UPF0127', NULL, NULL, 17286, 7),
(237832, NULL, 'MF_02116', NULL, NULL, '2-amino-5-formylamino-6-ribosylaminopyrimidin-4(3H)-one 5''-monophosphate deformylase [arfB].', NULL, 'FAPy_deform', NULL, NULL, 21703, 7),
(237833, NULL, 'MF_00243', NULL, NULL, 'Nicotinamide-nucleotide adenylyltransferase.', NULL, 'NMN_adenylyltr', NULL, NULL, 6696, 7),
(237834, NULL, 'MF_00824', NULL, NULL, 'Uncharacterized N-acetyltransferase <locus_tag>.', NULL, 'Acetyltransf_YlbP', NULL, NULL, 16124, 7),
(237835, NULL, 'MF_01647', NULL, NULL, '3-phenylpropionate-dihydrodiol/cinnamic acid-dihydrodiol dehydrogenase [hcaB].', NULL, 'HcaB', NULL, NULL, 16462, 7),
(237836, NULL, 'MF_04031', NULL, NULL, 'Deoxyuridine 5''-triphosphate nucleotidohydrolase [DUT].', NULL, 'HSV_DUT', NULL, NULL, 29072, 7),
(237837, NULL, 'MF_04075', NULL, NULL, 'Large envelope protein [S].', NULL, 'HBV_HBSAG', NULL, NULL, 4957, 7),
(237838, NULL, 'MF_01653', NULL, NULL, '2,3-dihydroxyphenylpropionate/2,3-dihydroxicinnamic acid 1,2-dioxygenase [mhpB].', NULL, 'MhpB', NULL, NULL, 16623, 7),
(237839, NULL, 'MF_00745', NULL, NULL, 'Protein SprT-like.', NULL, 'SprT_like', NULL, NULL, 16842, 7),
(237840, NULL, 'MF_00579', NULL, NULL, 'Formylmethanofuran--tetrahydromethanopterin formyltransferase [ftr].', NULL, 'FTR', NULL, NULL, 18639, 7),
(237841, NULL, 'MF_01318_A', NULL, NULL, '50S ribosomal protein L1 [rplA].', NULL, 'Ribosomal_L1_A', NULL, NULL, 776, 7),
(237842, NULL, 'MF_01659', NULL, NULL, '2-succinyl-5-enolpyruvyl-6-hydroxy-3-cyclohexene-1-carboxylate synthase [menD].', NULL, 'MenD', NULL, NULL, 7373, 7),
(237843, NULL, 'MF_03118', NULL, NULL, 'Probable bifunctional methylthioribulose-1-phosphate dehydratase/enolase-phosphatase E1.', NULL, 'Salvage_MtnBC', NULL, NULL, 23066, 7),
(237844, NULL, 'MF_01387', NULL, NULL, 'Chromatin protein Cren7 [creN7].', NULL, 'Chromatin_Cren7', NULL, NULL, 14872, 7),
(237845, NULL, 'MF_00387', NULL, NULL, 'Acyl-[acyl-carrier-protein]--UDP-N-acetylglucosamine O-acyltransferase [lpxA].', NULL, 'LpxA', NULL, NULL, 10746, 7),
(237846, NULL, 'MF_03100', NULL, NULL, 'Structure-specific endonuclease subunit <gene_name> [SLX1].', NULL, 'Endonuc_su_Slx1', NULL, NULL, 23255, 7);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(237847, NULL, 'MF_00212', NULL, NULL, 'Probable malate:quinone oxidoreductase [mqo].', NULL, 'MQO', NULL, NULL, 11342, 7),
(237848, NULL, 'MF_01646', NULL, NULL, 'Siroheme synthase [cysG].', NULL, 'Siroheme_synth', NULL, NULL, 13215, 7),
(237849, NULL, 'MF_01102', NULL, NULL, 'tRNA 5-methylaminomethyl-2-thiouridine biosynthesis bifunctional protein MnmC [mnmC].', NULL, 'MnmC', NULL, NULL, 15453, 7),
(237850, NULL, 'MF_01463_B', NULL, NULL, 'Protein translocase subunit SecD [secD].', NULL, 'SecD_B', NULL, NULL, 5772, 7),
(237851, NULL, 'MF_00024', NULL, NULL, 'Cobalamin biosynthesis protein CbiB [cbiB].', NULL, 'CobD_CbiB', NULL, NULL, 1037, 7),
(237852, NULL, 'MF_01196', NULL, NULL, 'Cell division protein ZapB [zapB].', NULL, 'ZapB', NULL, NULL, 13952, 7),
(237853, NULL, 'MF_01336', NULL, NULL, '50S ribosomal protein L25 [rplY].', NULL, 'Ribosomal_L25', NULL, NULL, 16294, 7),
(237854, NULL, 'MF_01107', NULL, NULL, 'Acetylornithine/succinyldiaminopimelate aminotransferase [argD].', NULL, 'ArgD_aminotrans_3', NULL, NULL, 2412, 7),
(237855, NULL, 'MF_00343', NULL, NULL, 'UPF0148 protein <locus_tag>.', NULL, 'UPF0148', NULL, NULL, 14827, 7),
(237856, NULL, 'MF_02017', NULL, NULL, 'Cytoskeleton protein RodZ [rodZ].', NULL, 'RodZ', NULL, NULL, 16216, 7),
(237857, NULL, 'MF_01388', NULL, NULL, 'Photosystem II reaction center X protein [psbX].', NULL, 'PSII_PsbX_2', NULL, NULL, 16174, 7),
(237858, NULL, 'MF_00346', NULL, NULL, 'UPF0149 protein YgfB [ygfB].', NULL, 'UPF0149', NULL, NULL, 13124, 7),
(237859, NULL, 'MF_00465', NULL, NULL, 'S-adenosylmethionine decarboxylase proenzyme [speD].', NULL, 'AdoMetDC_2', NULL, NULL, 9744, 7),
(237860, NULL, 'MF_00806', NULL, NULL, 'Autonomous glycyl radical cofactor [grcA].', NULL, 'GrcA', NULL, NULL, 10193, 7),
(237861, NULL, 'MF_00952', NULL, NULL, 'DNA topoisomerase 1 [topA].', NULL, 'Topoisom_1_prok', NULL, NULL, 25079, 7),
(237862, NULL, 'MF_04017', NULL, NULL, 'Capsid vertex component 1 [CVC1].', NULL, 'HSV_CVC1', NULL, NULL, 2433, 7),
(237863, NULL, 'MF_00786', NULL, NULL, 'Probable cobalt-precorrin-6B C(15)-methyltransferase (decarboxylating) [cbiT].', NULL, 'CbiT', NULL, NULL, 16426, 7),
(237864, NULL, 'MF_01381', NULL, NULL, 'Endo-type membrane-bound lytic murein transglycosylase A [emtA].', NULL, 'EmtA', NULL, NULL, 8216, 7),
(237865, NULL, 'MF_03062', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 16 [USP16].', NULL, 'UBP16', NULL, NULL, 21868, 7),
(237866, NULL, 'MF_03121', NULL, NULL, 'Lon protease homolog 2, peroxisomal [LONP2].', NULL, 'lonp2_euk', NULL, NULL, 23228, 7),
(237867, NULL, 'MF_04064', NULL, NULL, 'Protein PB1-F2 [PB1].', NULL, 'INFV_PB1F2', NULL, NULL, 15208, 7),
(237868, NULL, 'MF_02113_B', NULL, NULL, 'Proteasome subunit beta [prcB].', NULL, 'Proteasome_B_B', NULL, NULL, 16444, 7),
(237869, NULL, 'MF_01281', NULL, NULL, '5''-deoxyadenosine deaminase [dadD].', NULL, 'MTA_SAH_deamin', NULL, NULL, 16893, 7),
(237870, NULL, 'MF_01965', NULL, NULL, 'ADP-dependent (S)-NAD(P)H-hydrate dehydratase [nnrD].', NULL, 'NADHX_dehydratase', NULL, NULL, 5788, 7),
(237871, NULL, 'MF_01817', NULL, NULL, 'Tyrosine recombinase XerD-like.', NULL, 'Recomb_XerD_like', NULL, NULL, 21206, 7),
(237872, NULL, 'MF_00497_B', NULL, NULL, 'Glycerol-1-phosphate dehydrogenase [NAD(P)+] [egsA].', NULL, 'G1P_dehydrogenase_B', NULL, NULL, 15022, 7),
(237873, NULL, 'MF_00668', NULL, NULL, '6-carboxyhexanoate--CoA ligase [bioW].', NULL, 'BioW', NULL, NULL, 890, 7),
(237874, NULL, 'MF_00129', NULL, NULL, 'tRNA uridine 5-carboxymethylaminomethyl modification enzyme MnmG [mnmG].', NULL, 'MnmG_GidA', NULL, NULL, 7194, 7),
(237875, NULL, 'MF_00031', NULL, NULL, 'Holliday junction ATP-dependent DNA helicase RuvA [ruvA].', NULL, 'DNA_helic_RuvA', NULL, NULL, 2934, 7),
(237876, NULL, 'MF_01862', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase C [rsmC].', NULL, '16SrRNA_methyltr_C', NULL, NULL, 16712, 7),
(237877, NULL, 'MF_00021', NULL, NULL, 'tRNA sulfurtransferase [thiI].', NULL, 'ThiI', NULL, NULL, 2095, 7),
(237878, NULL, 'MF_00034', NULL, NULL, 'Crossover junction endodeoxyribonuclease RuvC [ruvC].', NULL, 'RuvC', NULL, NULL, 5021, 7);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(237879, NULL, 'MF_00576', NULL, NULL, 'Gas vesicle structural protein [gvpA].', NULL, 'Gas_vesicle_A', NULL, NULL, 3707, 7),
(237880, NULL, 'MF_01455', NULL, NULL, 'UPF0757 protein YmgG [ymgG].', NULL, 'UPF0757', NULL, NULL, 5617, 7),
(237881, NULL, 'MF_03182', NULL, NULL, 'PAN2-PAN3 deadenylation complex catalytic subunit PAN2 [PAN2].', NULL, 'PAN2', NULL, NULL, 21569, 7),
(237882, NULL, 'MF_01092', NULL, NULL, 'Cell division protein ZapD [zapD].', NULL, 'ZapD', NULL, NULL, 12942, 7),
(237883, NULL, 'MF_00947', NULL, NULL, 'Acid stress chaperone HdeB [hdeB].', NULL, 'HdeB', NULL, NULL, 21768, 7),
(237884, NULL, 'MF_01142', NULL, NULL, 'Antiholin-like protein LrgB [lrgB].', NULL, 'LrgB', NULL, NULL, 17934, 7),
(237885, NULL, 'MF_01123', NULL, NULL, 'Acetyl-coenzyme A synthetase [acs].', NULL, 'Ac_CoA_synth', NULL, NULL, 12064, 7),
(237886, NULL, 'MF_00354', NULL, NULL, 'Isopentenyl-diphosphate delta-isomerase [fni].', NULL, 'Idi_2', NULL, NULL, 10669, 7),
(237887, NULL, 'MF_04058', NULL, NULL, 'Packaging protein 3 [L1].', NULL, 'ADV_PKG3', NULL, NULL, 32850, 7),
(237888, NULL, 'MF_00822', NULL, NULL, 'Urease accessory protein UreE [ureE].', NULL, 'UreE', NULL, NULL, 13315, 7),
(237889, NULL, 'MF_01858', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase K/L [rlmL].', NULL, '23SrRNA_methyltr_KL', NULL, NULL, 15895, 7),
(237890, NULL, 'MF_00088', NULL, NULL, 'UPF0109 protein <locus_tag>.', NULL, 'UPF0109', NULL, NULL, 19819, 7),
(237891, NULL, 'MF_00331', NULL, NULL, 'Cysteine desulfurase IscS [iscS].', NULL, 'Cys_desulf_IscS', NULL, NULL, 5424, 7),
(237892, NULL, 'MF_02215', NULL, NULL, 'Ubiquinone biosynthesis accessory factor UbiJ [ubiJ].', NULL, 'UbiJ', NULL, NULL, 30984, 7),
(237893, NULL, 'MF_00026', NULL, NULL, 'DNA-binding protein <locus_tag>.', NULL, 'dsDNA_bind', NULL, NULL, 17092, 7),
(237894, NULL, 'MF_00552', NULL, NULL, 'Zinc transporter ZitB [zitB].', NULL, 'ZitB', NULL, NULL, 16051, 7),
(237895, NULL, 'MF_00960', NULL, NULL, '2-amino-3,7-dideoxy-D-threo-hept-6-ulosonate synthase [aroA''].', NULL, 'ADH_synthase', NULL, NULL, 4029, 7),
(237896, NULL, 'MF_00132', NULL, NULL, 'Type 2 DNA topoisomerase 6 subunit A [top6A].', NULL, 'Top6A', NULL, NULL, 1723, 7),
(237897, NULL, 'MF_01050', NULL, NULL, 'L-carnitine CoA-transferase [caiB].', NULL, 'CaiB', NULL, NULL, 16249, 7),
(237898, NULL, 'MF_01258', NULL, NULL, 'Coenzyme F420:L-glutamate ligase [cofE].', NULL, 'F420_ligase_CofE', NULL, NULL, 575, 7),
(237899, NULL, 'MF_01971', NULL, NULL, 'Kynurenine 3-monooxygenase [kmo].', NULL, 'Kynurenine_monooxygenase', NULL, NULL, 26838, 7),
(237900, NULL, 'MF_04074', NULL, NULL, 'Protein X [X].', NULL, 'HBV_X', NULL, NULL, 4489, 7),
(237901, NULL, 'MF_01980', NULL, NULL, 'Pyrophosphate--fructose 6-phosphate 1-phosphotransferase [pfp].', NULL, 'Phosphofructokinase_II_Long', NULL, NULL, 10691, 7),
(237902, NULL, 'MF_04006', NULL, NULL, 'Protein E6 [E6].', NULL, 'HPV_E6', NULL, NULL, 2348, 7),
(237903, NULL, 'MF_00866', NULL, NULL, 'DNA-directed RNA polymerase subunit Rpo8 [rpo8].', NULL, 'RNApol_arch_Rpo8', NULL, NULL, 24403, 7),
(237904, NULL, 'MF_00794', NULL, NULL, 'Putative antitoxin <locus_tag>.', NULL, 'UPF0330', NULL, NULL, 3198, 7),
(237905, NULL, 'MF_01037', NULL, NULL, 'Methylenetetrahydrofolate--tRNA-(uracil-5-)-methyltransferase TrmFO [trmFO].', NULL, 'TrmFO', NULL, NULL, 7216, 7),
(237906, NULL, 'MF_01679', NULL, NULL, '2,3-diketo-5-methylthiopentyl-1-phosphate enolase [mtnW].', NULL, 'Salvage_MtnW', NULL, NULL, 17555, 7),
(237907, NULL, 'MF_01134', NULL, NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit epsilon [cdhB].', NULL, 'CdhB', NULL, NULL, 2030, 7),
(237908, NULL, 'MF_00672', NULL, NULL, 'UPF0761 membrane protein YihY [yihY].', NULL, 'UPF0761', NULL, NULL, 16579, 7),
(237909, NULL, 'MF_00798', NULL, NULL, 'Transcription attenuation protein MtrB [mtrB].', NULL, 'Trp_attenuator', NULL, NULL, 4841, 7),
(237910, NULL, 'MF_01022', NULL, NULL, 'Histidine biosynthesis bifunctional protein HisB [hisB].', NULL, 'Bifunc_HisB', NULL, NULL, 18693, 7),
(237911, NULL, 'MF_01672', NULL, NULL, 'Inosose dehydratase [iolE].', NULL, 'IolE', NULL, NULL, 8073, 7);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(237912, NULL, 'MF_04200', NULL, NULL, 'Spike glycoprotein [S].', NULL, 'ALPHA_CORONA_SPIKE', NULL, NULL, 35052, 7),
(237913, NULL, 'MF_01161', NULL, NULL, 'tRNA(Ile)-lysidine synthase [tilS].', NULL, 'tRNA_Ile_lys_synt', NULL, NULL, 12879, 7),
(237914, NULL, 'MF_01698', NULL, NULL, 'Mycothiol acetyltransferase [mshD].', NULL, 'MshD', NULL, NULL, 19182, 7),
(237915, NULL, 'MF_01987', NULL, NULL, 'Ribokinase [rbsK].', NULL, 'Ribokinase', NULL, NULL, 14352, 7),
(237916, NULL, 'MF_01347', NULL, NULL, 'ATP synthase subunit beta [atpB].', NULL, 'ATP_synth_beta_bact', NULL, NULL, 4559, 7),
(237917, NULL, 'MF_03057', NULL, NULL, 'Succinate dehydrogenase assembly factor 2, mitochondrial [SDHAF2].', NULL, 'SDHAF2', NULL, NULL, 22489, 7),
(237918, NULL, 'MF_00160', NULL, NULL, 'Phosphoserine aminotransferase [serC].', NULL, 'SerC_aminotrans_5', NULL, NULL, 15261, 7),
(237919, NULL, 'MF_00453', NULL, NULL, 'Phosphoenolpyruvate carboxykinase (ATP) [pckA].', NULL, 'PEPCK_ATP', NULL, NULL, 5279, 7),
(237920, NULL, 'MF_04047', NULL, NULL, 'Pre-hexon-linking protein IIIa.', NULL, 'ADV_CAP3', NULL, NULL, 6451, 7),
(237921, NULL, 'MF_00267', NULL, NULL, 'Probable septum site-determining protein MinC [minC].', NULL, 'MinC', NULL, NULL, 12628, 7),
(237922, NULL, 'MF_01954', NULL, NULL, 'Urease subunit beta [ureB].', NULL, 'Urease_beta', NULL, NULL, 2157, 7),
(237923, NULL, 'MF_00972', NULL, NULL, 'tRNA-specific adenosine deaminase [tadA].', NULL, 'tRNA_aden_deaminase', NULL, NULL, 25323, 7),
(237924, NULL, 'MF_00015', NULL, NULL, 'LexA repressor [lexA].', NULL, 'LexA', NULL, NULL, 11325, 7),
(237925, NULL, 'MF_01584', NULL, NULL, 'UPF0502 protein YceH [yceH].', NULL, 'UPF0502', NULL, NULL, 3618, 7),
(237926, NULL, 'MF_02018', NULL, NULL, 'PanD regulatory factor [panZ].', NULL, 'PanZ_PanM', NULL, NULL, 24420, 7),
(237927, NULL, 'MF_00458', NULL, NULL, 'Photosystem I P700 chlorophyll a apoprotein A1 [psaA].', NULL, 'PSI_PsaA', NULL, NULL, 3623, 7),
(237928, NULL, 'MF_01918', NULL, NULL, 'Cardiolipin synthase C [clsC].', NULL, 'Cardiolipin_synth_ClsC', NULL, NULL, 23922, 7),
(237929, NULL, 'MF_00076', NULL, NULL, 'Imidazoleglycerol-phosphate dehydratase [hisB].', NULL, 'HisB', NULL, NULL, 4708, 7),
(237930, NULL, 'MF_00214', NULL, NULL, '3-dehydroquinate dehydratase [aroD].', NULL, 'AroD', NULL, NULL, 6658, 7),
(237931, NULL, 'MF_04032', NULL, NULL, 'Envelope glycoprotein B [gB].', NULL, 'HSV_GB', NULL, NULL, 695, 7),
(237932, NULL, 'MF_00585', NULL, NULL, 'UPF0216 protein <locus_tag>.', NULL, 'UPF0216', NULL, NULL, 3831, 7),
(237933, NULL, 'MF_01305', NULL, NULL, 'Photosystem II reaction center protein J [psbJ].', NULL, 'PSII_PsbJ', NULL, NULL, 2543, 7),
(237934, NULL, 'MF_00582', NULL, NULL, 'UPF0215 protein <locus_tag>.', NULL, 'UPF0215', NULL, NULL, 4738, 7),
(237935, NULL, 'MF_03177', NULL, NULL, 'ATP-dependent DNA helicase RRM3 [RRM3].', NULL, 'RRM3', NULL, NULL, 22154, 7),
(237936, NULL, 'MF_00638', NULL, NULL, 'Serine-protein kinase RsbW [rsbW].', NULL, 'Anti_sigma_B', NULL, NULL, 4155, 7),
(237937, NULL, 'MF_00488', NULL, NULL, 'L-lactate dehydrogenase [ldh].', NULL, 'Lactate_dehydrog', NULL, NULL, 10775, 7),
(237938, NULL, 'MF_01367', NULL, NULL, '50S ribosomal protein L14 [rplN].', NULL, 'Ribosomal_L14', NULL, NULL, 1825, 7),
(237939, NULL, 'MF_00985', NULL, NULL, '2-amino-3-ketobutyrate coenzyme A ligase [kbl].', NULL, '2am3keto_CoA_ligase', NULL, NULL, 10347, 7),
(237940, NULL, 'MF_01802', NULL, NULL, 'Chromosome partition protein MukE [mukE].', NULL, 'MukE', NULL, NULL, 6423, 7),
(237941, NULL, 'MF_01485', NULL, NULL, 'RecBCD enzyme subunit RecB [recB].', NULL, 'RecB', NULL, NULL, 556, 7),
(237942, NULL, 'MF_01053', NULL, NULL, 'UPF0231 protein YacL [yacL].', NULL, 'UPF0231', NULL, NULL, 764, 7),
(237943, NULL, 'MF_00617', NULL, NULL, 'Mannosyl-3-phosphoglycerate phosphatase [mngB].', NULL, 'MPGP_rel', NULL, NULL, 12517, 7),
(237944, NULL, 'MF_01295', NULL, NULL, 'D-tagatose-1,6-bisphosphate aldolase subunit KbaZ [kbaZ].', NULL, 'Tagatose_aldol_KbaZ', NULL, NULL, 16063, 7),
(237945, NULL, 'MF_01598', NULL, NULL, 'Spermidine export protein MdtJ [mdtJ].', NULL, 'MdtJ', NULL, NULL, 10071, 7);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(237946, NULL, 'MF_04111', NULL, NULL, 'Endolysin.', NULL, 'ENDOLYSIN_T7', NULL, NULL, 18796, 7),
(237947, NULL, 'MF_01029', NULL, NULL, 'UPF0213 protein YhbQ [yhbQ].', NULL, 'UPF0213', NULL, NULL, 15344, 7),
(237948, NULL, 'MF_01005', NULL, NULL, 'Vitamin B12 import ATP-binding protein BtuD [btuD].', NULL, 'BtuD', NULL, NULL, 11680, 7),
(237949, NULL, 'MF_00286', NULL, NULL, 'Disulfide bond formation protein B [dsbB].', NULL, 'DsbB', NULL, NULL, 17268, 7),
(237950, NULL, 'MF_00732', NULL, NULL, 'HTH-type transcriptional regulator MntR [mntR].', NULL, 'HTH_MntR', NULL, NULL, 14767, 7),
(237951, NULL, 'MF_01922', NULL, NULL, 'tRNA(Phe) (4-demethylwyosine(37)-C(7)) aminocarboxypropyltransferase [taw2].', NULL, 'TYW2_archaea', NULL, NULL, 23741, 7),
(237952, NULL, 'MF_00319', NULL, NULL, 'CDP-diacylglycerol pyrophosphatase [cdh].', NULL, 'Cdh', NULL, NULL, 2442, 7),
(237953, NULL, 'MF_00983', NULL, NULL, 'Probable primosomal protein N'' [priA].', NULL, 'PriA', NULL, NULL, 4066, 7),
(237954, NULL, 'MF_03176', NULL, NULL, 'ATP-dependent DNA helicase PIF1 [PIF1].', NULL, 'PIF1', NULL, NULL, 7882, 7),
(237955, NULL, 'MF_01590', NULL, NULL, 'tRNA U34 carboxymethyltransferase [cmoB].', NULL, 'tRNA_carboxymethyltr_CmoB', NULL, NULL, 5500, 7),
(237956, NULL, 'MF_02224', NULL, NULL, '4-phosphopantoate--beta-alanine ligase.', NULL, 'PPS', NULL, NULL, 5793, 7),
(237957, NULL, 'MF_01371_A', NULL, NULL, '50S ribosomal protein L30 [rpmD].', NULL, 'Ribosomal_L30_A', NULL, NULL, 1392, 7),
(237958, NULL, 'MF_01122', NULL, NULL, 'DNA/RNA-binding protein Alba [albA].', NULL, 'AlbA', NULL, NULL, 9652, 7),
(237959, NULL, 'MF_01150', NULL, NULL, 'Chaperone protein TorD [torD].', NULL, 'TorD', NULL, NULL, 15023, 7),
(237960, NULL, 'MF_02236', NULL, NULL, 'N-acetyl-L-citrulline deacetylase [argE''].', NULL, 'ACDase', NULL, NULL, 35170, 7),
(237961, NULL, 'MF_00482', NULL, NULL, 'Photosystem I P700 chlorophyll a apoprotein A2 [psaB].', NULL, 'PSI_PsaB', NULL, NULL, 3799, 7),
(237962, NULL, 'MF_01658', NULL, NULL, '3-demethoxyubiquinol 3-hydroxylase [coq7].', NULL, 'COQ7', NULL, NULL, 8226, 7),
(237963, NULL, 'MF_01399', NULL, NULL, 'ATP synthase subunit b'' [atpF2].', NULL, 'ATP_synth_bprime', NULL, NULL, 32067, 7),
(237964, NULL, 'MF_01419', NULL, NULL, 'Phosphoglycolate phosphatase.', NULL, 'GPH_hydrolase_arch', NULL, NULL, 5850, 7),
(237965, NULL, 'MF_03033', NULL, NULL, 'Protein argonaute-4 [EIF2C4].', NULL, 'AGO4', NULL, NULL, 26187, 7),
(237966, NULL, 'MF_02129', NULL, NULL, 'L-carnitine dehydrogenase [lcdH].', NULL, 'L_carnitine_dehydrog', NULL, NULL, 26595, 7),
(237967, NULL, 'MF_00586', NULL, NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit D [gatD].', NULL, 'GatD', NULL, NULL, 8511, 7),
(237968, NULL, 'MF_01263', NULL, NULL, 'CCA-adding enzyme [cca].', NULL, 'CCA_bact_type3', NULL, NULL, 15456, 7),
(237969, NULL, 'MF_00364', NULL, NULL, 'Beta-hexosaminidase [nagZ].', NULL, 'NagZ', NULL, NULL, 14746, 7),
(237970, NULL, 'MF_00389', NULL, NULL, 'Protein TusC [tusC].', NULL, 'Thiourid_synth_C', NULL, NULL, 30657, 7),
(237971, NULL, 'MF_00855', NULL, NULL, 'RuBisCO chaperone RbcX [rbcX].', NULL, 'RbcX', NULL, NULL, 34699, 7),
(237972, NULL, 'MF_00370', NULL, NULL, 'Shikimate kinase [aroK].', NULL, 'Shik_kinase_arch', NULL, NULL, 4456, 7),
(237973, NULL, 'MF_00461', NULL, NULL, 'Ion-translocating oxidoreductase complex subunit C [rsxC].', NULL, 'RsxC_RnfC', NULL, NULL, 4333, 7),
(237974, NULL, 'MF_01899', NULL, NULL, 'Ribonuclease D [rnd].', NULL, 'RNase_D', NULL, NULL, 3816, 7),
(237975, NULL, 'MF_01330', NULL, NULL, 'Protein Ycf2 [ycf2].', NULL, 'Ycf2', NULL, NULL, 13173, 7),
(237976, NULL, 'MF_01873', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase Cfr [cfr].', NULL, '23SrRNA_methyltr_Cfr', NULL, NULL, 17412, 7),
(237977, NULL, 'MF_00227', NULL, NULL, 'Ribonuclease P protein component [rnpA].', NULL, 'RNase_P', NULL, NULL, 3569, 7),
(237978, NULL, 'MF_01325_A', NULL, NULL, '50S ribosomal protein L3 [rplC].', NULL, 'Ribosomal_L3_A', NULL, NULL, 15043, 7),
(237979, NULL, 'MF_00610', NULL, NULL, 'Cytochrome f [petA].', NULL, 'Cytb6_f_cytF', NULL, NULL, 6398, 7);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(237980, NULL, 'MF_01057', NULL, NULL, 'tRNA (guanine-N(7)-)-methyltransferase [trmB].', NULL, 'tRNA_methyltr_TrmB', NULL, NULL, 4397, 7),
(237981, NULL, 'MF_01277', NULL, NULL, 'HTH-type transcriptional repressor PurR [purR].', NULL, 'HTH_type_PurR', NULL, NULL, 20571, 7),
(237982, NULL, 'MF_02081', NULL, NULL, 'Peptidoglycan D,D-transpeptidase MrdA [mrdA].', NULL, 'MrdA_transpept', NULL, NULL, 19382, 7),
(237983, NULL, 'MF_01362', NULL, NULL, 'UPF0387 membrane protein YohO [yohO].', NULL, 'UPF0387', NULL, NULL, 21277, 7),
(237984, NULL, 'MF_04164', NULL, NULL, 'RNA polymerase sigma-like factor.', NULL, 'T4_Sigma_like_factor', NULL, NULL, 34601, 7),
(237985, NULL, 'MF_01628', NULL, NULL, 'Thymidine phosphorylase [deoA].', NULL, 'Thymid_phosp', NULL, NULL, 10207, 7),
(237986, NULL, 'MF_01186', NULL, NULL, 'LPS-assembly lipoprotein LptE [lptE].', NULL, 'LPS_assembly_LptE', NULL, NULL, 10385, 7),
(237987, NULL, 'MF_01811', NULL, NULL, 'Membrane protein insertase YidC [yidC].', NULL, 'YidC_type2', NULL, NULL, 15159, 7),
(237988, NULL, 'MF_00730', NULL, NULL, 'Nucleoid-associated protein YejK [yejK].', NULL, 'NdpA', NULL, NULL, 5821, 7),
(237989, NULL, 'MF_00907', NULL, NULL, 'Proofreading thioesterase EntH [entH].', NULL, 'Thioesterase_EntH', NULL, NULL, 25386, 7),
(237990, NULL, 'MF_01507', NULL, NULL, 'UPF0297 protein <locus_tag>.', NULL, 'UPF0297', NULL, NULL, 14210, 7),
(237991, NULL, 'MF_01137', NULL, NULL, 'Acetyl-CoA decarbonylase/synthase complex subunit alpha [cdhA].', NULL, 'CdhA', NULL, NULL, 7265, 7),
(237992, NULL, 'MF_00928', NULL, NULL, '4-O-beta-D-mannosyl-D-glucose phosphorylase.', NULL, 'Man_Glc_phosphorylase', NULL, NULL, 22890, 7),
(237993, NULL, 'MF_01601', NULL, NULL, 'ADP-L-glycero-D-manno-heptose-6-epimerase [hldD].', NULL, 'Heptose_epimerase', NULL, NULL, 12165, 7),
(237994, NULL, 'MF_00474', NULL, NULL, 'Photosystem I reaction center subunit PsaK [psaK].', NULL, 'PSI_PsaK', NULL, NULL, 20526, 7),
(237995, NULL, 'MF_01808', NULL, NULL, 'Tyrosine recombinase XerC [xerC].', NULL, 'Recomb_XerC_XerD', NULL, NULL, 15071, 7),
(237996, NULL, 'MF_00653', NULL, NULL, 'Coenzyme PQQ synthesis protein B [pqqB].', NULL, 'PQQ_syn_PqqB', NULL, NULL, 13737, 7),
(237997, NULL, 'MF_04130', NULL, NULL, 'Outer capsid glycoprotein VP7.', NULL, 'Rota_VP7', NULL, NULL, 2125, 7),
(237998, NULL, 'MF_02218', NULL, NULL, 'Glucosamine kinase.', NULL, 'GlcN_kinase', NULL, NULL, 35685, 7),
(237999, NULL, 'MF_00229', NULL, NULL, 'Histidine ammonia-lyase [hutH].', NULL, 'His_ammonia_lyase', NULL, NULL, 105, 7),
(238000, NULL, 'MF_00289_B', NULL, NULL, 'Proteasome subunit alpha [prcA].', NULL, 'Proteasome_A_B', NULL, NULL, 15399, 7),
(238001, NULL, 'MF_04162', NULL, NULL, 'Sliding-clamp-loader large subunit.', NULL, 'T4_Clamp_Loader_L', NULL, NULL, 34884, 7),
(238002, NULL, 'MF_00811', NULL, NULL, '2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-succinyltransferase [dapD].', NULL, 'DapD', NULL, NULL, 3597, 7),
(238003, NULL, 'MF_00419', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase [purL].', NULL, 'PurL_1', NULL, NULL, 2156, 7),
(238004, NULL, 'MF_01170', NULL, NULL, 'Chromosome-anchoring protein RacA [racA].', NULL, 'RacA', NULL, NULL, 16900, 7),
(238005, NULL, 'MF_01272', NULL, NULL, 'Heme oxygenase (staphylobilin-producing) [isdG].', NULL, 'Heme_degrading_monooxygenase', NULL, NULL, 20340, 7),
(238006, NULL, 'MF_01941', NULL, NULL, 'Mid-cell-anchored protein Z [mapZ].', NULL, 'MapZ', NULL, NULL, 23507, 7),
(238007, NULL, 'MF_00306', NULL, NULL, 'Signal recognition particle 54 kDa protein [srp54].', NULL, 'SRP54', NULL, NULL, 14844, 7),
(238008, NULL, 'MF_01856', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase B [rsmB].', NULL, '16SrRNA_methyltr_B', NULL, NULL, 16544, 7),
(238009, NULL, 'MF_00415', NULL, NULL, 'Flagellar L-ring protein [flgH].', NULL, 'FlgH', NULL, NULL, 5637, 7),
(238010, NULL, 'MF_02050', NULL, NULL, 'Fused isobutyryl-CoA mutase [icmF].', NULL, 'IcmF', NULL, NULL, 28992, 7),
(238011, NULL, 'MF_00911', NULL, NULL, 'Cell division protein FtsQ [ftsQ].', NULL, 'FtsQ_subfam', NULL, NULL, 25433, 7);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(238012, NULL, 'MF_00456', NULL, NULL, 'Glutamate 5-kinase [proB].', NULL, 'ProB', NULL, NULL, 3943, 7),
(238013, NULL, 'MF_00269', NULL, NULL, 'Thiol peroxidase [tpx].', NULL, 'Tpx', NULL, NULL, 5071, 7),
(238014, NULL, 'MF_00602', NULL, NULL, 'Protein-arginine kinase [mcsB].', NULL, 'Prot_Arg_kinase', NULL, NULL, 16437, 7),
(238015, NULL, 'MF_01195', NULL, NULL, 'N-acetylneuraminate epimerase [nanM].', NULL, 'NanM', NULL, NULL, 18303, 7),
(238016, NULL, 'MF_00430', NULL, NULL, 'Na(+)-translocating NADH-quinone reductase subunit F [nqrF].', NULL, 'NqrF', NULL, NULL, 4134, 7),
(238017, NULL, 'MF_01586', NULL, NULL, 'Probable [Fe-S]-dependent transcriptional repressor [feoC].', NULL, 'FeoC', NULL, NULL, 10260, 7),
(238018, NULL, 'MF_00427', NULL, NULL, 'Na(+)-translocating NADH-quinone reductase subunit C [nqrC].', NULL, 'NqrC', NULL, NULL, 4170, 7),
(238019, NULL, 'MF_00774', NULL, NULL, 'Acyl transferase [luxD].', NULL, 'LuxD', NULL, NULL, 1549, 7),
(238020, NULL, 'MF_00861', NULL, NULL, 'Ethanolamine ammonia-lyase large subunit [eutB].', NULL, 'EutB', NULL, NULL, 9112, 7),
(238021, NULL, 'MF_01928', NULL, NULL, 'N5-carboxyaminoimidazole ribonucleotide synthase [purK].', NULL, 'PurK', NULL, NULL, 6890, 7),
(238022, NULL, 'MF_00322', NULL, NULL, 'Type 2 DNA topoisomerase 6 subunit B [top6B].', NULL, 'Top6B', NULL, NULL, 4838, 7),
(238023, NULL, 'MF_00550', NULL, NULL, 'Peptidase T [pepT].', NULL, 'Aminopeptidase_M20', NULL, NULL, 10716, 7),
(238024, NULL, 'MF_00166', NULL, NULL, 'DNA-binding protein Fis [fis].', NULL, 'DNA_binding_Fis', NULL, NULL, 7106, 7),
(238025, NULL, 'MF_00374', NULL, NULL, '50S ribosomal protein L29 [rpmC].', NULL, 'Ribosomal_L29', NULL, NULL, 4326, 7),
(238026, NULL, 'MF_03029', NULL, NULL, 'Ribosome biogenesis protein @gn(WDR12) [WDR12].', NULL, 'WDR12', NULL, NULL, 26496, 7),
(238027, NULL, 'MF_00283', NULL, NULL, 'Phenylalanine--tRNA ligase beta subunit [pheT].', NULL, 'Phe_tRNA_synth_beta1', NULL, NULL, 1763, 7),
(238028, NULL, 'MF_01494', NULL, NULL, 'DEAD-box ATP-dependent RNA helicase CshB [cshB].', NULL, 'DEAD_helicase_CshB', NULL, NULL, 27000, 7),
(238029, NULL, 'MF_01618', NULL, NULL, '3-ketoacyl-CoA thiolase [fadI].', NULL, 'FadI', NULL, NULL, 12892, 7),
(238030, NULL, 'MF_01019', NULL, NULL, 'Histidine biosynthesis bifunctional protein HisIE [hisI].', NULL, 'HisIE', NULL, NULL, 15481, 7),
(238031, NULL, 'MF_01066', NULL, NULL, 'Glucans biosynthesis protein C [mdoC].', NULL, 'MdoC_OpgC', NULL, NULL, 16787, 7),
(238032, NULL, 'MF_00383', NULL, NULL, 'Transcription initiation factor IIB [tfb].', NULL, 'TF2B_arch', NULL, NULL, 16451, 7),
(238033, NULL, 'MF_04101', NULL, NULL, 'DNA-directed DNA polymerase.', NULL, 'DPOL_T7', NULL, NULL, 8293, 7),
(238034, NULL, 'MF_00691', NULL, NULL, '5-oxoprolinase subunit A [pxpA].', NULL, 'PxpA', NULL, NULL, 616, 7),
(238035, NULL, 'MF_00302', NULL, NULL, 'ATP-dependent Clp protease adapter protein ClpS [clpS].', NULL, 'ClpS', NULL, NULL, 14997, 7),
(238036, NULL, 'MF_00187', NULL, NULL, 'Sulfur carrier protein FdhD [fdhD].', NULL, 'FdhD', NULL, NULL, 3222, 7),
(238037, NULL, 'MF_00538', NULL, NULL, 'Probable 4-amino-4-deoxy-L-arabinose-phosphoundecaprenol flippase subunit ArnF [arnF].', NULL, 'Flippase_ArnF', NULL, NULL, 14527, 7),
(238038, NULL, 'MF_01124', NULL, NULL, 'Adapter protein MecA [mecA].', NULL, 'MecA', NULL, NULL, 12898, 7),
(238039, NULL, 'MF_01376', NULL, NULL, '2-aminoethylphosphonate--pyruvate transaminase [phnW].', NULL, 'PhnW_aminotrans_5', NULL, NULL, 11594, 7),
(238040, NULL, 'MF_04038', NULL, NULL, 'Cytoplasmic envelopment protein 1.', NULL, 'HSV_CEP1', NULL, NULL, 1574, 7),
(238041, NULL, 'MF_01154', NULL, NULL, 'Curved DNA-binding protein [cbpA].', NULL, 'CbpA', NULL, NULL, 8040, 7),
(238042, NULL, 'MF_02100', NULL, NULL, 'Uncharacterized methyltransferase <locus_tag>.', NULL, 'Methyltr_YrrT', NULL, NULL, 12817, 7),
(238043, NULL, 'MF_00304', NULL, NULL, 'Thiamine thiazole synthase [thi4].', NULL, 'Thi4', NULL, NULL, 17271, 7),
(238044, NULL, 'MF_01861', NULL, NULL, 'UPF0738 protein <locus_tag>.', NULL, 'UPF0738', NULL, NULL, 14511, 7);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(238045, NULL, 'MF_01623', NULL, NULL, 'Penicillin-insensitive murein endopeptidase [mepA].', NULL, 'MepA', NULL, NULL, 10450, 7),
(238046, NULL, 'MF_03184', NULL, NULL, 'ATP-dependent 6-phosphofructokinase.', NULL, 'Phosphofructokinase_I_E', NULL, NULL, 9778, 7),
(238047, NULL, 'MF_00693', NULL, NULL, 'Probable transcriptional regulatory protein YebC [yebC].', NULL, 'Transcrip_reg_TACO1', NULL, NULL, 5846, 7),
(238048, NULL, 'MF_00791', NULL, NULL, 'Protein ApaG [apaG].', NULL, 'ApaG', NULL, NULL, 15355, 7),
(238049, NULL, 'MF_00097', NULL, NULL, 'Thiamine-phosphate synthase [thiE].', NULL, 'TMP_synthase', NULL, NULL, 14563, 7),
(238050, NULL, 'MF_01524', NULL, NULL, 'Crotonobetaine/carnitine--CoA ligase [caiC].', NULL, 'CaiC', NULL, NULL, 16270, 7),
(238051, NULL, 'MF_03022', NULL, NULL, 'Katanin p80 WD40 repeat-containing subunit B1 [KATNB1].', NULL, 'Katanin_p80_B1', NULL, NULL, 25780, 7),
(238052, NULL, 'MF_00220_A', NULL, NULL, 'Dihydroorotase [pyrC].', NULL, 'PyrC_classI_A', NULL, NULL, 3107, 7),
(238053, NULL, 'MF_00980', NULL, NULL, 'Phosphotransferase RcsD [rcsD].', NULL, 'RcsD', NULL, NULL, 2553, 7),
(238054, NULL, 'MF_02206', NULL, NULL, '3''-5'' exonuclease DinG [dinG].', NULL, 'DinG_exonucl', NULL, NULL, 4635, 7),
(238055, NULL, 'MF_00746', NULL, NULL, 'Protein SprT [sprT].', NULL, 'SprT', NULL, NULL, 16664, 7),
(238056, NULL, 'MF_00974', NULL, NULL, 'DNA primase [dnaG].', NULL, 'DNA_primase_DnaG', NULL, NULL, 22500, 7),
(238057, NULL, 'MF_00574', NULL, NULL, 'Putative ribosomal protein L7Ae-like.', NULL, 'Ribosomal_L7Ae_Bact', NULL, NULL, 16413, 7),
(238058, NULL, 'MF_00729', NULL, NULL, 'Fructose-bisphosphate aldolase class 1 [fda].', NULL, 'FBP_aldolase_1', NULL, NULL, 15472, 7),
(238059, NULL, 'MF_03211', NULL, NULL, 'RNA cytidine acetyltransferase [NAT10].', NULL, 'RNA_acetyltr_Nat10', NULL, NULL, 28016, 7),
(238060, NULL, 'MF_00943', NULL, NULL, 'Maleate isomerase [maiA].', NULL, 'Maleate_isomerase', NULL, NULL, 25022, 7),
(238061, NULL, 'MF_01893', NULL, NULL, 'tRNA pseudouridine synthase Pus10 [pus10].', NULL, 'Pus10_arch', NULL, NULL, 407, 7),
(238062, NULL, 'MF_02238', NULL, NULL, '3-dehydroshikimate dehydratase.', NULL, 'DSD', NULL, NULL, 35355, 7),
(238063, NULL, 'MF_02023', NULL, NULL, 'Dissimilatory sulfite reductase.', NULL, 'Sulfite_red', NULL, NULL, 24181, 7),
(238064, NULL, 'MF_02109', NULL, NULL, 'Cysteate synthase.', NULL, 'Cya_synthase', NULL, NULL, 15716, 7),
(238065, NULL, 'MF_01483', NULL, NULL, 'RNA polymerase-binding protein RbpA [rbpA].', NULL, 'RbpA', NULL, NULL, 22768, 7),
(238066, NULL, 'MF_04124', NULL, NULL, 'Protein VP3.', NULL, 'Rota_VP3', NULL, NULL, 10967, 7),
(238067, NULL, 'MF_04013', NULL, NULL, 'Tripartite terminase subunit 3 [TRM3].', NULL, 'HSV_TRM3', NULL, NULL, 31099, 7),
(238068, NULL, 'MF_04081', NULL, NULL, 'Virion infectivity factor [vif].', NULL, 'HIV_VIF', NULL, NULL, 6553, 7),
(238069, NULL, 'MF_04133', NULL, NULL, 'Major capsid protein [E].', NULL, 'CAPSID_LAMBDA', NULL, NULL, 1811, 7),
(238070, NULL, 'MF_00382', NULL, NULL, '50S ribosomal protein L20 [rplT].', NULL, 'Ribosomal_L20', NULL, NULL, 5975, 7),
(238071, NULL, 'MF_00735', NULL, NULL, 'Ribosomal protein L11 methyltransferase [prmA].', NULL, 'Methyltr_PrmA', NULL, NULL, 1970, 7),
(238072, NULL, 'MF_01436', NULL, NULL, 'Enterobactin exporter EntS [entS].', NULL, 'MFS_EntS', NULL, NULL, 7948, 7),
(238073, NULL, 'MF_00050', NULL, NULL, 'Elongation factor Ts [tsf].', NULL, 'EF_Ts', NULL, NULL, 4418, 7),
(238074, NULL, 'MF_00541', NULL, NULL, 'L-rhamnose isomerase [rhaA].', NULL, 'RhaA', NULL, NULL, 13924, 7),
(238075, NULL, 'MF_04067', NULL, NULL, 'Nuclear export protein [NS].', NULL, 'INFV_NEP', NULL, NULL, 3159, 7),
(238076, NULL, 'MF_00605', NULL, NULL, 'tRNA (guanine-N(1)-)-methyltransferase [trmD].', NULL, 'TrmD', NULL, NULL, 2522, 7),
(238077, NULL, 'MF_00507', NULL, NULL, 'UPF0181 protein YoaH [yoaH].', NULL, 'UPF0181', NULL, NULL, 6023, 7),
(238078, NULL, 'MF_00759', NULL, NULL, 'DNA mismatch repair protein MutH [mutH].', NULL, 'MutH', NULL, NULL, 3659, 7);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(238079, NULL, 'MF_00539', NULL, NULL, '50S ribosomal protein L27 [rpmA].', NULL, 'Ribosomal_L27', NULL, NULL, 3236, 7),
(238080, NULL, 'MF_00662', NULL, NULL, 'Phosphatidylserine decarboxylase proenzyme [psd].', NULL, 'PS_decarb_PSD_B_type1', NULL, NULL, 29720, 7),
(238081, NULL, 'MF_00721', NULL, NULL, '50S ribosomal protein L14e [rpl14e].', NULL, 'Ribosomal_L14e', NULL, NULL, 16306, 7),
(238082, NULL, 'MF_00350', NULL, NULL, 'DNA repair and recombination protein RadB [radB].', NULL, 'RadB', NULL, NULL, 11423, 7),
(238083, NULL, 'MF_00962', NULL, NULL, 'RNA polymerase sigma factor FliA [fliA].', NULL, 'Sigma70_FliA', NULL, NULL, 25366, 7),
(238084, NULL, 'MF_01253', NULL, NULL, 'Endonuclease 8 [nei].', NULL, 'Endonuclease_8', NULL, NULL, 16650, 7),
(238085, NULL, 'MF_00106', NULL, NULL, 'Mannonate dehydratase [uxuA].', NULL, 'UxuA', NULL, NULL, 2373, 7),
(238086, NULL, 'MF_00800', NULL, NULL, 'UPF0340 protein <locus_tag>.', NULL, 'UPF0340', NULL, NULL, 4776, 7),
(238087, NULL, 'MF_00369', NULL, NULL, '50S ribosomal protein L21e [rpl21e].', NULL, 'Ribosomal_L21e', NULL, NULL, 17378, 7),
(238088, NULL, 'MF_01604', NULL, NULL, 'Thiamine kinase [thiK].', NULL, 'Thiamine_kinase', NULL, NULL, 14248, 7),
(238089, NULL, 'MF_01515', NULL, NULL, 'UPF0316 protein <locus_tag>.', NULL, 'UPF0316', NULL, NULL, 14542, 7),
(238090, NULL, 'MF_01469', NULL, NULL, 'Ribonuclease M5 [rnmV].', NULL, 'RNase_M5', NULL, NULL, 7007, 7),
(238091, NULL, 'MF_01454', NULL, NULL, 'GTPase Obg [obg].', NULL, 'GTPase_Obg', NULL, NULL, 14434, 7),
(238092, NULL, 'MF_01874', NULL, NULL, 'UPF0756 membrane protein YeaL [yeaL].', NULL, 'UPF0756', NULL, NULL, 5929, 7),
(238093, NULL, 'MF_00295', NULL, NULL, 'Homoserine O-succinyltransferase [metAS].', NULL, 'MetA_acyltransf', NULL, NULL, 30160, 7),
(238094, NULL, 'MF_00009', NULL, NULL, 'Endoribonuclease YbeY [ybeY].', NULL, 'Endoribonucl_YbeY', NULL, NULL, 2117, 7),
(238095, NULL, 'MF_02026', NULL, NULL, 'dTDP-4-amino-4,6-dideoxygalactose transaminase [wecE].', NULL, 'WecE_RffA', NULL, NULL, 23643, 7),
(238096, NULL, 'MF_00481', NULL, NULL, '50S ribosomal protein L30e [rpl30e].', NULL, 'Ribosomal_L30e', NULL, NULL, 685, 7),
(238097, NULL, 'MF_03058', NULL, NULL, 'Vacuolar ATPase assembly integral membrane protein <gene_name> [VMA21].', NULL, 'VMA21', NULL, NULL, 15605, 7),
(238098, NULL, 'MF_01887', NULL, NULL, '23S rRNA (guanosine-2''-O-)-methyltransferase RlmB [rlmB].', NULL, '23SrRNA_methyltr_B', NULL, NULL, 23535, 7),
(238099, NULL, 'MF_00457', NULL, NULL, 'UPF0173 metal-dependent hydrolase <locus_tag>.', NULL, 'UPF0173', NULL, NULL, 16693, 7),
(238100, NULL, 'MF_04103', NULL, NULL, 'Baseplate wedge protein gp7.', NULL, 'BP07_T4', NULL, NULL, 7055, 7),
(238101, NULL, 'MF_00067', NULL, NULL, 'Phosphoheptose isomerase [gmhA].', NULL, 'GmhA', NULL, NULL, 1711, 7),
(238102, NULL, 'MF_01058', NULL, NULL, 'Der GTPase-activating protein YihI [yihI].', NULL, 'GAP_YihI', NULL, NULL, 5444, 7),
(238103, NULL, 'MF_01104', NULL, NULL, 'Protein Syd [syd].', NULL, 'Syd', NULL, NULL, 8418, 7),
(238104, NULL, 'MF_00518', NULL, NULL, 'D-aminoacyl-tRNA deacylase [dtd].', NULL, 'Deacylase_Dtd', NULL, NULL, 2046, 7),
(238105, NULL, 'MF_00763', NULL, NULL, 'UPF0305 protein <locus_tag>.', NULL, 'UPF0305', NULL, NULL, 19176, 7),
(238106, NULL, 'MF_01337_A', NULL, NULL, '50S ribosomal protein L18 [rplR].', NULL, 'Ribosomal_L18_A', NULL, NULL, 657, 7),
(238107, NULL, 'MF_00004', NULL, NULL, 'Adenine phosphoribosyltransferase [apt].', NULL, 'Aden_phosphoribosyltr', NULL, NULL, 4928, 7),
(238108, NULL, 'MF_00351', NULL, NULL, 'Fibrillarin-like rRNA/tRNA 2''-O-methyltransferase [flpA].', NULL, 'RNA_methyltransf_FlpA', NULL, NULL, 6978, 7),
(238109, NULL, 'MF_00242', NULL, NULL, 'Arginine deiminase [arcA].', NULL, 'Arg_deiminase', NULL, NULL, 4408, 7),
(238110, NULL, 'MF_00416', NULL, NULL, 'Flagellar P-ring protein [flgI].', NULL, 'FlgI', NULL, NULL, 3457, 7),
(238111, NULL, 'MF_00345', NULL, NULL, 'GMP synthase [glutamine-hydrolyzing] subunit B [guaAB].', NULL, 'GMP_synthase_B', NULL, NULL, 25171, 7);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(238112, NULL, 'MF_00862', NULL, NULL, 'Probable inorganic carbon transporter subunit DabB [dabB].', NULL, 'DabB', NULL, NULL, 37756, 7),
(238113, NULL, 'MF_01389', NULL, NULL, 'Urease accessory protein UreG [ureG].', NULL, 'UreG', NULL, NULL, 5747, 7),
(238114, NULL, 'MF_01267', NULL, NULL, '3-keto-L-gulonate-6-phosphate decarboxylase UlaD [ulaD].', NULL, 'UlaD', NULL, NULL, 9795, 7),
(238115, NULL, 'MF_01156', NULL, NULL, 'Iron-sulfur cluster repair protein ScdA [scdA].', NULL, 'RIC_ScdA', NULL, NULL, 16647, 7),
(238116, NULL, 'MF_01596', NULL, NULL, 'PhoP/PhoQ regulator MgrB [mgrB].', NULL, 'MgrB', NULL, NULL, 14910, 7),
(238117, NULL, 'MF_02033', NULL, NULL, 'Cell division protein FtsA [ftsA].', NULL, 'FtsA', NULL, NULL, 20656, 7),
(238118, NULL, 'MF_00253_B', NULL, NULL, 'Glycine--tRNA ligase [glyQS].', NULL, 'Gly_tRNA_synth_B', NULL, NULL, 17790, 7),
(238119, NULL, 'MF_01261', NULL, NULL, 'Multifunctional CCA protein [cca].', NULL, 'CCA_bact_type1', NULL, NULL, 10154, 7),
(238120, NULL, 'MF_02072', NULL, NULL, 'Inhibitor of hydrogen peroxide resistance [iprA].', NULL, 'IprA', NULL, NULL, 30794, 7),
(238121, NULL, 'MF_04097', NULL, NULL, 'Nucleoprotein [N].', NULL, 'GAMMA_CORONA_NCAP', NULL, NULL, 35171, 7),
(238122, NULL, 'MF_02038', NULL, NULL, 'Probable hercynylcysteine sulfoxide lyase [egtE].', NULL, 'EgtE', NULL, NULL, 26640, 7),
(238123, NULL, 'MF_01901', NULL, NULL, 'Arginine exporter protein ArgO [argO].', NULL, 'ArgO', NULL, NULL, 16343, 7),
(238124, NULL, 'MF_00054_B', NULL, NULL, 'Elongation factor G [fusA].', NULL, 'EF_G_EF_2_B', NULL, NULL, 1630, 7),
(238125, NULL, 'MF_01095', NULL, NULL, 'UPF0292 protein <locus_tag>.', NULL, 'UPF0292', NULL, NULL, 14679, 7),
(238126, NULL, 'MF_03110', NULL, NULL, 'Structure-specific endonuclease subunit @gn(SLX4) [SLX4].', NULL, 'Endonuc_su_Slx4', NULL, NULL, 26043, 7),
(238127, NULL, 'MF_02220', NULL, NULL, 'Xylulose kinase [xylB].', NULL, 'XylB', NULL, NULL, 1194, 7),
(238128, NULL, 'MF_00802', NULL, NULL, 'Bifunctional glutamine synthetase adenylyltransferase/adenylyl-removing enzyme [glnE].', NULL, 'GlnE', NULL, NULL, 15114, 7),
(238129, NULL, 'MF_00902', NULL, NULL, 'Sec-independent protein translocase protein TatC [tatC].', NULL, 'TatC', NULL, NULL, 5257, 7),
(238130, NULL, 'MF_00722', NULL, NULL, 'Endonuclease NucS [nucS].', NULL, 'NucS', NULL, NULL, 4591, 7),
(238131, NULL, 'MF_02233', NULL, NULL, 'Ubiquinone biosynthesis protein UbiV [ubiV].', NULL, 'UbiV', NULL, NULL, 35312, 7),
(238132, NULL, 'MF_01460', NULL, NULL, 'Chromophore lyase CpcT/CpeT [cpcT].', NULL, 'Chrphore_lyase_CpxT', NULL, NULL, 9465, 7),
(238133, NULL, 'MF_00100_B', NULL, NULL, 'Translation initiation factor IF-2 [infB].', NULL, 'IF_2_B', NULL, NULL, 1737, 7),
(238134, NULL, 'MF_02071', NULL, NULL, 'Endolytic peptidoglycan transglycosylase RlpA [rlpA].', NULL, 'RlpA', NULL, NULL, 30868, 7),
(238135, NULL, 'MF_00443', NULL, NULL, 'Thiazole synthase [thiG].', NULL, 'ThiG', NULL, NULL, 7821, 7),
(238136, NULL, 'MF_00190', NULL, NULL, 'Cardiolipin synthase A [clsA].', NULL, 'Cardiolipin_synth_ClsA', NULL, NULL, 21871, 7),
(238137, NULL, 'MF_00013', NULL, NULL, 'Octanoyltransferase [lipB].', NULL, 'LipB', NULL, NULL, 5986, 7),
(238138, NULL, 'MF_00677', NULL, NULL, 'UPF0261 protein <locus_tag>.', NULL, 'UPF0261', NULL, NULL, 7958, 7),
(238139, NULL, 'MF_04042', NULL, NULL, 'Cytoplasmic envelopment protein 3.', NULL, 'HSV_CEP3_gammahv', NULL, NULL, 22361, 7),
(238140, NULL, 'MF_01321', NULL, NULL, 'DNA-directed RNA polymerase subunit beta [rpoB].', NULL, 'RNApol_bact_RpoB', NULL, NULL, 5393, 7),
(238141, NULL, 'MF_01547', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase E [rlmE].', NULL, 'RNA_methyltr_E', NULL, NULL, 8392, 7),
(238142, NULL, 'MF_00201', NULL, NULL, 'DNA repair protein RecO [recO].', NULL, 'RecO', NULL, NULL, 2058, 7),
(238143, NULL, 'MF_03171', NULL, NULL, 'Adenylate kinase isoenzyme 1 [AK1].', NULL, 'Adenylate_kinase_AK1', NULL, NULL, 23994, 7),
(238144, NULL, 'MF_01418', NULL, NULL, 'Agmatinase [speB].', NULL, 'SpeB', NULL, NULL, 9436, 7);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(238145, NULL, 'MF_01431', NULL, NULL, 'Pyrimidine-specific ribonucleoside hydrolase RihA [rihA].', NULL, 'Pyrim_hydro_RihA', NULL, NULL, 14695, 7),
(238146, NULL, 'MF_01898', NULL, NULL, 'DNA gyrase subunit B [gyrB].', NULL, 'GyrB', NULL, NULL, 8382, 7),
(238147, NULL, 'MF_00002', NULL, NULL, 'Aspartate carbamoyltransferase regulatory chain [pyrI].', NULL, 'Asp_carb_tr_reg', NULL, NULL, 4679, 7),
(238148, NULL, 'MF_00810', NULL, NULL, '50S ribosomal protein L32e [rpl32e].', NULL, 'Ribosomal_L32e', NULL, NULL, 746, 7),
(238149, NULL, 'MF_01235', NULL, NULL, 'Putative N-acetylmannosamine-6-phosphate 2-epimerase [nanE].', NULL, 'ManNAc6P_epimer', NULL, NULL, 6524, 7),
(238150, NULL, 'MF_00587', NULL, NULL, 'tRNA (pseudouridine(54)-N(1))-methyltransferase [trmY].', NULL, 'tRNA_methyltr_TrmY', NULL, NULL, 202, 7),
(238151, NULL, 'MF_00391', NULL, NULL, '50S ribosomal protein L34 [rpmH].', NULL, 'Ribosomal_L34', NULL, NULL, 872, 7),
(238152, NULL, 'MF_00979', NULL, NULL, 'Sensor histidine kinase RcsC [rcsC].', NULL, 'RcsC', NULL, NULL, 23513, 7),
(238153, NULL, 'MF_01872', NULL, NULL, 'tRNA1(Val) (adenine(37)-N6)-methyltransferase [yfiC].', NULL, 'tRNA_methyltr_YfiC', NULL, NULL, 17285, 7),
(238154, NULL, 'MF_01909', NULL, NULL, 'Transcription factor E [tfe].', NULL, 'TFE_arch', NULL, NULL, 15345, 7),
(238155, NULL, 'MF_03044', NULL, NULL, '25S rRNA (adenine(2142)-N(1))-methyltransferase [BMT2].', NULL, 'BMT2', NULL, NULL, 19599, 7),
(238156, NULL, 'MF_04028', NULL, NULL, 'Ribonucleoside-diphosphate reductase small subunit [RIR2].', NULL, 'HSV_RIR2', NULL, NULL, 8468, 7),
(238157, NULL, 'MF_00199', NULL, NULL, 'Bis(5''-nucleosyl)-tetraphosphatase, symmetrical [apaH].', NULL, 'ApaH', NULL, NULL, 2296, 7),
(238158, NULL, 'MF_00649', NULL, NULL, 'DNA gyrase inhibitor YacG [yacG].', NULL, 'DNA_gyrase_inhibitor_YacG', NULL, NULL, 1829, 7),
(238159, NULL, 'MF_01644', NULL, NULL, 'D-phenylhydantoinase [hyuA].', NULL, 'D_hydantoinase', NULL, NULL, 7428, 7),
(238160, NULL, 'MF_04123', NULL, NULL, 'Inner capsid protein VP2.', NULL, 'Rota_VP2', NULL, NULL, 1174, 7),
(238161, NULL, 'MF_01197', NULL, NULL, 'Cell division protein SepF [sepF].', NULL, 'SepF', NULL, NULL, 15394, 7),
(238162, NULL, 'MF_01476', NULL, NULL, '50S ribosomal protein L44e [rpl44e].', NULL, 'Ribosomal_L44e', NULL, NULL, 5586, 7),
(238163, NULL, 'MF_01325_B', NULL, NULL, '50S ribosomal protein L3 [rplC].', NULL, 'Ribosomal_L3_B', NULL, NULL, 15086, 7),
(238164, NULL, 'MF_03053', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 1 [CTU1].', NULL, 'CTU1', NULL, NULL, 5615, 7),
(238165, NULL, 'MF_01966', NULL, NULL, 'NAD(P)H-hydrate epimerase [nnrE].', NULL, 'NADHX_epimerase', NULL, NULL, 7325, 7),
(238166, NULL, 'MF_01523', NULL, NULL, 'Ribosomal RNA small subunit methyltransferase J [rsmJ].', NULL, '16SrRNA_methyltr_J', NULL, NULL, 10595, 7),
(238167, NULL, 'MF_00321', NULL, NULL, 'Probable GTP-binding protein EngB [engB].', NULL, 'GTPase_EngB', NULL, NULL, 11644, 7),
(238168, NULL, 'MF_01509', NULL, NULL, 'Replication factor C small subunit [rfcS].', NULL, 'RfcS', NULL, NULL, 16508, 7),
(238169, NULL, 'MF_00103', NULL, NULL, 'Formamidopyrimidine-DNA glycosylase [mutM].', NULL, 'Fapy_DNA_glycosyl', NULL, NULL, 19827, 7),
(238170, NULL, 'MF_01664', NULL, NULL, 'Heme A synthase [ctaA].', NULL, 'HemeA_synth_type1', NULL, NULL, 10571, 7),
(238171, NULL, 'MF_00564', NULL, NULL, 'Ribonuclease PH [rph].', NULL, 'RNase_PH', NULL, NULL, 6590, 7),
(238172, NULL, 'MF_00941', NULL, NULL, 'GDP-mannose mannosyl hydrolase [gmm].', NULL, 'GDPMH_gmm', NULL, NULL, 25052, 7),
(238173, NULL, 'MF_00948', NULL, NULL, 'Transcription termination/antitermination protein NusG [nusG].', NULL, 'NusG', NULL, NULL, 1357, 7),
(238174, NULL, 'MF_02004', NULL, NULL, 'Valine--tRNA ligase [valS].', NULL, 'Val_tRNA_synth_type1', NULL, NULL, 4388, 7),
(238175, NULL, 'MF_00656', NULL, NULL, 'Coenzyme PQQ synthesis protein A [pqqA].', NULL, 'PQQ_syn_PqqA', NULL, NULL, 11585, 7),
(238176, NULL, 'MF_00412', NULL, NULL, 'Gamma-glutamyl phosphate reductase [proA].', NULL, 'ProA', NULL, NULL, 241, 7);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(238177, NULL, 'MF_00355', NULL, NULL, 'Light-independent protochlorophyllide reductase iron-sulfur ATP-binding protein [bchL].', NULL, 'ChlL_BchL', NULL, NULL, 1447, 7),
(238178, NULL, 'MF_01003', NULL, NULL, 'Probable ECA polymerase [wzyE].', NULL, 'WzyE', NULL, NULL, 9273, 7),
(238179, NULL, 'MF_00544', NULL, NULL, 'Tryptophanase [tnaA].', NULL, 'Tryptophanase', NULL, NULL, 9288, 7),
(238180, NULL, 'MF_00619', NULL, NULL, 'Probable 30S ribosomal protein 3, chloroplastic [ycf65].', NULL, 'Ribosomal_plastid_S3', NULL, NULL, 4558, 7),
(238181, NULL, 'MF_01805', NULL, NULL, 'Segregation and condensation protein A [scpA].', NULL, 'ScpA', NULL, NULL, 6129, 7),
(238182, NULL, 'MF_04010', NULL, NULL, 'DNA helicase/primase complex-associated protein.', NULL, 'HSV_HEPA', NULL, NULL, 553, 7),
(238183, NULL, 'MF_00071', NULL, NULL, 'Elongation factor 4 [lepA].', NULL, 'LepA', NULL, NULL, 4538, 7),
(238184, NULL, 'MF_03001', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit B [EIF3B].', NULL, 'eIF3b', NULL, NULL, 7636, 7),
(238185, NULL, 'MF_01208', NULL, NULL, 'Orotate phosphoribosyltransferase [pyrE].', NULL, 'PyrE', NULL, NULL, 15320, 7),
(238186, NULL, 'MF_00487', NULL, NULL, 'Malate dehydrogenase [mdh].', NULL, 'Malate_dehydrog_3', NULL, NULL, 10124, 7),
(238187, NULL, 'MF_01098', NULL, NULL, 'Tetrahydromethanopterin S-methyltransferase subunit E [mtrE].', NULL, 'MtrE', NULL, NULL, 5908, 7),
(238188, NULL, 'MF_00281', NULL, NULL, 'Phenylalanine--tRNA ligase alpha subunit [pheS].', NULL, 'Phe_tRNA_synth_alpha1', NULL, NULL, 17467, 7),
(238189, NULL, 'MF_01952', NULL, NULL, 'L-ribulose-5-phosphate 4-epimerase UlaF [ulaF].', NULL, 'UlaF', NULL, NULL, 16086, 7),
(238190, NULL, 'MF_00431', NULL, NULL, 'Photosystem I reaction center subunit VIII [psaI].', NULL, 'PSI_PsaI', NULL, NULL, 104, 7),
(238191, NULL, 'MF_00327', NULL, NULL, '50S ribosomal protein L37Ae [rpl37ae].', NULL, 'Ribosomal_L37Ae', NULL, NULL, 2773, 7),
(238192, NULL, 'MF_00843', NULL, NULL, 'Major outer membrane lipoprotein Lpp [lpp].', NULL, 'Lpp', NULL, NULL, 20264, 7),
(238193, NULL, 'MF_00148', NULL, NULL, 'Uracil-DNA glycosylase [ung].', NULL, 'UDG', NULL, NULL, 1399, 7),
(238194, NULL, 'MF_02237', NULL, NULL, 'tRNA (cytosine(72)-C(5))-methyltransferase.', NULL, 'NSUN6', NULL, NULL, 34742, 7),
(238195, NULL, 'MF_01039', NULL, NULL, '2,3-bisphosphoglycerate-dependent phosphoglycerate mutase [gpmA].', NULL, 'PGAM_GpmA', NULL, NULL, 192, 7),
(238196, NULL, 'MF_00075', NULL, NULL, 'Translation initiation factor IF-1 [infA].', NULL, 'IF_1', NULL, NULL, 5451, 7),
(238197, NULL, 'MF_00530', NULL, NULL, 'ATP synthase epsilon chain [atpC].', NULL, 'ATP_synth_epsil_bac', NULL, NULL, 6132, 7),
(238198, NULL, 'MF_01314', NULL, NULL, 'Anaerobic nitric oxide reductase transcription regulator NorR [norR].', NULL, 'NorR', NULL, NULL, 8203, 7),
(238199, NULL, 'MF_01517', NULL, NULL, 'Malate dehydrogenase [mdh].', NULL, 'Malate_dehydrog_2', NULL, NULL, 1965, 7),
(238200, NULL, 'MF_00563', NULL, NULL, 'S-inosyl-L-homocysteine hydrolase [ahcY].', NULL, 'AdoHcyase', NULL, NULL, 3741, 7),
(238201, NULL, 'MF_03178', NULL, NULL, 'NADPH-dependent diflavin oxidoreductase 1 [TAH18].', NULL, 'NDOR1', NULL, NULL, 22031, 7),
(238202, NULL, 'MF_00290', NULL, NULL, 'tRNA (guanine(26)-N(2))-dimethyltransferase [trm1].', NULL, 'tRNA_dimethyltr_TRM1', NULL, NULL, 14669, 7),
(238203, NULL, 'MF_00789', NULL, NULL, 'UPF0319 protein YccT [yccT].', NULL, 'UPF0319', NULL, NULL, 16071, 7),
(238204, NULL, 'MF_02064', NULL, NULL, 'RNA polymerase sigma factor SigI [sigI].', NULL, 'Sigma70_SigI', NULL, NULL, 11398, 7),
(238205, NULL, 'MF_00505', NULL, NULL, 'Chaperone protein HtpG [htpG].', NULL, 'HSP90', NULL, NULL, 7377, 7),
(238206, NULL, 'MF_00439', NULL, NULL, 'Photosystem I assembly protein Ycf3 [ycf3].', NULL, 'Ycf3', NULL, NULL, 15912, 7),
(238207, NULL, 'MF_02108', NULL, NULL, 'HTH-type transcriptional regulator MurR [murR].', NULL, 'HTH_type_MurR', NULL, NULL, 17348, 7),
(238208, NULL, 'MF_00262', NULL, NULL, 'Cell division topological specificity factor [minE].', NULL, 'MinE', NULL, NULL, 1808, 7);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(238209, NULL, 'MF_00147_B', NULL, NULL, 'Triosephosphate isomerase [tpiA].', NULL, 'TIM_B', NULL, NULL, 15351, 7),
(238210, NULL, 'MF_01307_B', NULL, NULL, '30S ribosomal protein S5 [rpsE].', NULL, 'Ribosomal_S5_B', NULL, NULL, 3942, 7),
(238211, NULL, 'MF_01063', NULL, NULL, 'Esterase FrsA [frsA].', NULL, 'FrsA', NULL, NULL, 36321, 7),
(238212, NULL, 'MF_01942', NULL, NULL, 'Lipid A biosynthesis lauroyltransferase [lpxL].', NULL, 'Lipid_A_LpxL_LpxP', NULL, NULL, 11079, 7),
(238213, NULL, 'MF_00405', NULL, NULL, '3-hydroxydecanoyl-[acyl-carrier-protein] dehydratase [fabA].', NULL, 'FabA', NULL, NULL, 2099, 7),
(238214, NULL, 'MF_00987', NULL, NULL, 'L-fuculose phosphate aldolase [fucA].', NULL, 'FucA', NULL, NULL, 5475, 7),
(238215, NULL, 'MF_01884', NULL, NULL, 'Transcription termination factor Rho [rho].', NULL, 'Rho', NULL, NULL, 2943, 7),
(238216, NULL, 'MF_01120', NULL, NULL, '[LysW]-lysine/[LysW]-ornithine hydrolase [lysK].', NULL, 'LysK', NULL, NULL, 4015, 7),
(238217, NULL, 'MF_01441', NULL, NULL, 'DNA protection during starvation protein [dps].', NULL, 'Dps', NULL, NULL, 15193, 7),
(238218, NULL, 'MF_01493', NULL, NULL, 'DEAD-box ATP-dependent RNA helicase CshA [cshA].', NULL, 'DEAD_helicase_CshA', NULL, NULL, 26951, 7),
(238219, NULL, 'MF_01334', NULL, NULL, '50S ribosomal protein L25 [rplY].', NULL, 'Ribosomal_L25_CTC', NULL, NULL, 2289, 7),
(238220, NULL, 'MF_01625', NULL, NULL, 'ATPase RavA [ravA].', NULL, 'ATPase_RavA', NULL, NULL, 16336, 7),
(238221, NULL, 'MF_01620', NULL, NULL, '3-ketoacyl-CoA thiolase [fadA].', NULL, 'FadA', NULL, NULL, 12743, 7),
(238222, NULL, 'MF_01034', NULL, NULL, 'Putative D-alanyl-D-alanine carboxypeptidase [yfeW].', NULL, 'S12_YfeW', NULL, NULL, 17446, 7),
(238223, NULL, 'MF_01600', NULL, NULL, 'UPF0182 protein <locus_tag>.', NULL, 'UPF0182', NULL, NULL, 6849, 7),
(238224, NULL, 'MF_00177', NULL, NULL, 'Lysine--tRNA ligase [lysS].', NULL, 'Lys_tRNA_synth_class1', NULL, NULL, 6277, 7),
(238225, NULL, 'MF_04020', NULL, NULL, 'Small capsomere-interacting protein [SCP].', NULL, 'HSV_SCP_alphahv', NULL, NULL, 2530, 7),
(238226, NULL, 'MF_01652', NULL, NULL, '3-(3-hydroxy-phenyl)propionate/3-hydroxycinnamic acid hydroxylase [mhpA].', NULL, 'MhpA', NULL, NULL, 8871, 7),
(238227, NULL, 'MF_01503', NULL, NULL, 'Putative regulatory protein <locus_tag>.', NULL, 'RemA', NULL, NULL, 416, 7),
(238228, NULL, 'MF_01619', NULL, NULL, 'NAD-dependent malic enzyme [maeA].', NULL, 'NAD_malic_enz', NULL, NULL, 16445, 7),
(238229, NULL, 'MF_01680', NULL, NULL, '2-hydroxy-3-keto-5-methylthiopentenyl-1-phosphate phosphatase [mtnX].', NULL, 'Salvage_MtnX', NULL, NULL, 17864, 7),
(238230, NULL, 'MF_00736', NULL, NULL, '50S ribosomal protein L11 [rplK].', NULL, 'Ribosomal_L11', NULL, NULL, 337, 7),
(238231, NULL, 'MF_01088', NULL, NULL, 'Universal stress protein B [uspB].', NULL, 'UspB', NULL, NULL, 20372, 7),
(238232, NULL, 'MF_01640', NULL, NULL, 'D-erythrose-4-phosphate dehydrogenase [epd].', NULL, 'E4P_dehydrog', NULL, NULL, 6843, 7),
(238233, NULL, 'MF_00342', NULL, NULL, 'UPF0147 protein <locus_tag>.', NULL, 'UPF0147', NULL, NULL, 6315, 7),
(238234, NULL, 'MF_01131', NULL, NULL, 'Redox-sensing transcriptional repressor Rex [rex].', NULL, 'Rex', NULL, NULL, 14715, 7),
(238235, NULL, 'MF_01549', NULL, NULL, 'Protein DsrB [dsrB].', NULL, 'DsrB', NULL, NULL, 20591, 7),
(238236, NULL, 'MF_03016', NULL, NULL, '40S ribosomal protein SA [RPSA].', NULL, 'Ribosomal_S2_laminin_receptor', NULL, NULL, 25942, 7),
(238237, NULL, 'MF_03127', NULL, NULL, 'Adenylosuccinate synthetase isozyme 2 [ADSS].', NULL, 'Adenylosucc_synth_vert_acid', NULL, NULL, 23895, 7),
(238238, NULL, 'MF_00982', NULL, NULL, 'Transcriptional regulatory protein RcsA [rcsA].', NULL, 'RcsA', NULL, NULL, 26092, 7),
(238239, NULL, 'MF_00558', NULL, NULL, 'Succinate--CoA ligase [ADP-forming] subunit beta [sucC].', NULL, 'Succ_CoA_beta', NULL, NULL, 5660, 7),
(238240, NULL, 'MF_00100_A', NULL, NULL, 'Translation initiation factor IF-2 [infB].', NULL, 'IF_2_A', NULL, NULL, 941, 7),
(238241, NULL, 'MF_00155', NULL, NULL, 'Cytochrome c oxidase assembly protein CtaG [ctaG].', NULL, 'CtaG', NULL, NULL, 10861, 7);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(238242, NULL, 'MF_00215', NULL, NULL, 'Pantothenate kinase [coaA].', NULL, 'Pantothen_kinase_1', NULL, NULL, 736, 7),
(238243, NULL, 'MF_01307_A', NULL, NULL, '30S ribosomal protein S5 [rpsE].', NULL, 'Ribosomal_S5_A', NULL, NULL, 3845, 7),
(238244, NULL, 'MF_00510', NULL, NULL, 'Peptidase E [pepE].', NULL, 'Peptidase_E', NULL, NULL, 8185, 7),
(238245, NULL, 'MF_02080', NULL, NULL, 'Peptidoglycan D,D-transpeptidase FtsI [ftsI].', NULL, 'FtsI_transpept', NULL, NULL, 28575, 7),
(238246, NULL, 'MF_04041', NULL, NULL, 'Cytoplasmic envelopment protein 3.', NULL, 'HSV_CEP3_betahv', NULL, NULL, 7801, 7),
(238247, NULL, 'MF_00964', NULL, NULL, 'ATP-dependent RNA helicase DeaD [deaD].', NULL, 'DEAD_helicase_DeaD', NULL, NULL, 25165, 7),
(238248, NULL, 'MF_01631', NULL, NULL, 'Bifunctional protein GlmU [glmU].', NULL, 'GlmU', NULL, NULL, 6653, 7),
(238249, NULL, 'MF_01516', NULL, NULL, 'Malate dehydrogenase [mdh].', NULL, 'Malate_dehydrog_1', NULL, NULL, 8307, 7),
(238250, NULL, 'MF_01857', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase I [rlmI].', NULL, '23SrRNA_methyltr_I', NULL, NULL, 16634, 7),
(238251, NULL, 'MF_02030', NULL, NULL, 'Undecaprenyl-phosphate alpha-N-acetylglucosaminyl 1-phosphate transferase [wecA].', NULL, 'WecA_Gammaproteo', NULL, NULL, 9579, 7),
(238252, NULL, 'MF_01602', NULL, NULL, 'Lipoate-protein ligase A [lplA].', NULL, 'LplA', NULL, NULL, 10814, 7),
(238253, NULL, 'MF_01880', NULL, NULL, 'Dipeptide permease D [dtpD].', NULL, 'PTR2_DtpD_subfam', NULL, NULL, 16522, 7),
(238254, NULL, 'MF_01099', NULL, NULL, 'Tetrahydromethanopterin S-methyltransferase subunit F [mtrF].', NULL, 'MtrF', NULL, NULL, 10003, 7),
(238255, NULL, 'MF_01041', NULL, NULL, 'UPF0223 protein <locus_tag>.', NULL, 'UPF0223', NULL, NULL, 3143, 7),
(238256, NULL, 'MF_01968', NULL, NULL, 'NAD-dependent protein deacetylase [cobB].', NULL, 'Sirtuin_ClassU', NULL, NULL, 25653, 7),
(238257, NULL, 'MF_01651', NULL, NULL, '3-phenylpropionate/cinnamic acid dioxygenase ferredoxin--NAD(+) reductase component [hcaD].', NULL, 'HcaD', NULL, NULL, 14807, 7),
(238258, NULL, 'MF_01936', NULL, NULL, '1,4-dihydroxy-2-naphthoyl-CoA hydrolase [menI].', NULL, 'MenI', NULL, NULL, 2847, 7),
(238259, NULL, 'MF_01676', NULL, NULL, 'Alkyl hydroperoxide reductase AhpD [ahpD].', NULL, 'AhpD', NULL, NULL, 2850, 7),
(238260, NULL, 'MF_02055', NULL, NULL, 'Tyrosine recombinase XerA [xerA].', NULL, 'Recomb_XerA', NULL, NULL, 32693, 7),
(238261, NULL, 'MF_00998', NULL, NULL, 'Sulfoquinovose isomerase.', NULL, 'SQ_isomerase', NULL, NULL, 24357, 7),
(238262, NULL, 'MF_03000', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit A [EIF3A].', NULL, 'eIF3a', NULL, NULL, 23635, 7),
(238263, NULL, 'MF_01262', NULL, NULL, 'CCA-adding enzyme [cca].', NULL, 'CCA_bact_type2', NULL, NULL, 10154, 7),
(238264, NULL, 'MF_00761', NULL, NULL, 'UPF0303 protein <locus_tag>.', NULL, 'UPF0303', NULL, NULL, 8541, 7),
(238265, NULL, 'MF_03138', NULL, NULL, 'Translation factor GUF1 homolog, organellar chromatophore [lepA].', NULL, 'GUFP', NULL, NULL, 24837, 7),
(238266, NULL, 'MF_01685', NULL, NULL, 'Ferredoxin--NADP reductase.', NULL, 'FENR2', NULL, NULL, 15443, 7),
(238267, NULL, 'MF_00428', NULL, NULL, 'Na(+)-translocating NADH-quinone reductase subunit D [nqrD].', NULL, 'NqrD', NULL, NULL, 10143, 7),
(238268, NULL, 'MF_02043', NULL, NULL, 'tRNA-dihydrouridine(16) synthase [dusC].', NULL, 'DusC_subfam', NULL, NULL, 25313, 7),
(238269, NULL, 'MF_01013', NULL, NULL, 'Imidazole glycerol phosphate synthase subunit HisF [hisF].', NULL, 'HisF', NULL, NULL, 2673, 7),
(238270, NULL, 'MF_00537', NULL, NULL, '30S ribosomal protein S14 [rpsN].', NULL, 'Ribosomal_S14_1', NULL, NULL, 15008, 7),
(238271, NULL, 'MF_00676', NULL, NULL, 'UPF0260 protein YcgN [ycgN].', NULL, 'UPF0260', NULL, NULL, 714, 7),
(238272, NULL, 'MF_00578', NULL, NULL, 'Glutamate--cysteine ligase [gshA].', NULL, 'Glu_cys_ligase', NULL, NULL, 4551, 7),
(238273, NULL, 'MF_01624', NULL, NULL, 'Arsenate reductase [arsC].', NULL, 'Arsenate_reduct', NULL, NULL, 13423, 7),
(238274, NULL, 'MF_00522', NULL, NULL, 'Photosystem I reaction center subunit IX [psaJ].', NULL, 'PSI_PsaJ', NULL, NULL, 1612, 7); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(238275, NULL, 'MF_00835', NULL, NULL, 'Malonyl-[acyl-carrier protein] O-methyltransferase [bioC].', NULL, 'BioC', NULL, NULL, 13278, 7),
(238276, NULL, 'MF_04206', NULL, NULL, 'Envelope small membrane protein [E].', NULL, 'GAMMA_CORONA_E', NULL, NULL, 5485, 7),
(238277, NULL, 'MF_00645', NULL, NULL, 'Protein <locus_tag>.', NULL, 'AMMECR1', NULL, NULL, 16095, 7),
(238278, NULL, 'MF_01054', NULL, NULL, 'UPF0237 protein <locus_tag>.', NULL, 'UPF0237', NULL, NULL, 15463, 7),
(238279, NULL, 'MF_01530', NULL, NULL, 'Multidrug resistance protein MdtL [mdtL].', NULL, 'MFS_MdtL', NULL, NULL, 7366, 7),
(238280, NULL, 'MF_00059', NULL, NULL, 'DNA-directed RNA polymerase subunit alpha [rpoA].', NULL, 'RNApol_bact_RpoA', NULL, NULL, 13362, 7),
(238281, NULL, 'MF_03014', NULL, NULL, 'Kynurenine formamidase [AFMID].', NULL, 'KFase', NULL, NULL, 23451, 7),
(238282, NULL, 'MF_00359', NULL, NULL, '30S ribosomal protein S3Ae [rps3ae].', NULL, 'Ribosomal_S3Ae', NULL, NULL, 21939, 7),
(238283, NULL, 'MF_01840', NULL, NULL, 'Aerobic magnesium-protoporphyrin IX monomethyl ester [oxidative] cyclase [acsF].', NULL, 'AcsF', NULL, NULL, 8937, 7),
(238284, NULL, 'MF_02012', NULL, NULL, 'Cell division protein ZapA [zapA].', NULL, 'ZapA_type1', NULL, NULL, 16983, 7),
(238285, NULL, 'MF_00762', NULL, NULL, 'UPF0304 protein YfbU [yfbU].', NULL, 'UPF0304', NULL, NULL, 1556, 7),
(238286, NULL, 'MF_00807', NULL, NULL, '1-aminocyclopropane-1-carboxylate deaminase [acdS].', NULL, 'ACC_deaminase', NULL, NULL, 20911, 7),
(238287, NULL, 'MF_00573', NULL, NULL, '50S ribosomal protein L35Ae [rpl35ae].', NULL, 'Ribosomal_L35Ae', NULL, NULL, 3005, 7),
(238288, NULL, 'MF_02113_A', NULL, NULL, 'Proteasome subunit beta [prcB].', NULL, 'Proteasome_B_A', NULL, NULL, 11582, 7),
(238289, NULL, 'MF_01228', NULL, NULL, 'Methionine--tRNA ligase [metG].', NULL, 'Met_tRNA_synth_type2', NULL, NULL, 16271, 7),
(238290, NULL, 'MF_01542', NULL, NULL, 'UPF0349 protein <locus_tag>.', NULL, 'UPF0349', NULL, NULL, 14532, 7),
(238291, NULL, 'MF_00476', NULL, NULL, 'Nickel-responsive regulator [nikR].', NULL, 'NikR', NULL, NULL, 15316, 7),
(238292, NULL, 'MF_01699', NULL, NULL, 'Pyrimidine monooxygenase RutA [rutA].', NULL, 'RutA', NULL, NULL, 14946, 7),
(238293, NULL, 'MF_01961', NULL, NULL, 'Catalase-peroxidase [katG].', NULL, 'Catal_peroxid', NULL, NULL, 6933, 7),
(238294, NULL, 'MF_00634', NULL, NULL, 'UPF0235 protein YggU [yggU].', NULL, 'UPF0235', NULL, NULL, 2129, 7),
(238295, NULL, 'MF_01919', NULL, NULL, 'Cell division protein ZapE [zapE].', NULL, 'ZapE', NULL, NULL, 23556, 7),
(238296, NULL, 'MF_01044', NULL, NULL, 'Protein TsgA [tsgA].', NULL, 'MFS_TsgA', NULL, NULL, 16745, 7),
(238297, NULL, 'MF_00147_A', NULL, NULL, 'Triosephosphate isomerase [tpiA].', NULL, 'TIM_A', NULL, NULL, 15001, 7),
(238298, NULL, 'MF_00966', NULL, NULL, 'Glucose-6-phosphate 1-dehydrogenase [zwf].', NULL, 'G6PD', NULL, NULL, 2174, 7),
(238299, NULL, 'MF_00708', NULL, NULL, 'Fumarate reductase subunit C [frdC].', NULL, 'Fumarate_red_C', NULL, NULL, 6231, 7),
(238300, NULL, 'MF_00334', NULL, NULL, 'Homogentisate 1,2-dioxygenase [hmgA].', NULL, 'Homogentis_dioxygen', NULL, NULL, 14924, 7),
(238301, NULL, 'MF_00423', NULL, NULL, 'L-seryl-tRNA(Sec) selenium transferase [selA].', NULL, 'SelA', NULL, NULL, 1855, 7),
(238302, NULL, 'MF_00704', NULL, NULL, 'Probable aspartoacylase.', NULL, 'Aspartoacylase', NULL, NULL, 20165, 7),
(238303, NULL, 'MF_01169', NULL, NULL, '2-oxoglutarate dehydrogenase E1 component [odhA].', NULL, 'SucA_OdhA', NULL, NULL, 16625, 7),
(238304, NULL, 'MF_00984', NULL, NULL, 'Single-stranded DNA-binding protein.', NULL, 'SSB', NULL, NULL, 10569, 7),
(238305, NULL, 'MF_02075', NULL, NULL, 'Aspartate--tRNA(Asp) ligase [aspS].', NULL, 'Asp_tRNA_synth_type2', NULL, NULL, 1987, 7),
(238306, NULL, 'MF_01568', NULL, NULL, 'UPF0374 protein <locus_tag>.', NULL, 'UPF0374', NULL, NULL, 16733, 7),
(238307, NULL, 'MF_00778', NULL, NULL, 'Probable subtilase-type protease inhibitor [sti].', NULL, 'SSI', NULL, NULL, 3559, 7),
(238308, NULL, 'MF_00115', NULL, NULL, 'Large-conductance mechanosensitive channel [mscL].', NULL, 'MscL', NULL, NULL, 1354, 7);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(238309, NULL, 'MF_01519', NULL, NULL, 'UPF0325 protein YaeH [yaeH].', NULL, 'UPF0325', NULL, NULL, 14994, 7),
(238310, NULL, 'MF_01564', NULL, NULL, 'Protein TusB [tusB].', NULL, 'Thiourid_synth_B', NULL, NULL, 16830, 7),
(238311, NULL, 'MF_01891', NULL, NULL, 'Flagellar transcriptional regulator FlhC [flhC].', NULL, 'FhlC', NULL, NULL, 4127, 7),
(238312, NULL, 'MF_00141', NULL, NULL, 'Elongation factor P [efp].', NULL, 'EF_P', NULL, NULL, 10038, 7),
(238313, NULL, 'MF_00149', NULL, NULL, 'DNA mismatch repair protein MutL [mutL].', NULL, 'DNA_mis_repair', NULL, NULL, 20514, 7),
(238314, NULL, 'MF_01192', NULL, NULL, 'Flap endonuclease Xni [xni].', NULL, 'Xni', NULL, NULL, 14812, 7),
(238315, NULL, 'MF_01395', NULL, NULL, 'Acetyl-coenzyme A carboxylase carboxyl transferase subunit beta, chloroplastic [accD].', NULL, 'AcetylCoA_CT_beta', NULL, NULL, 5891, 7),
(238316, NULL, 'MF_01407', NULL, NULL, 'ORC1-type DNA replication protein.', NULL, 'ORC1_type_DNA_replic_protein', NULL, NULL, 8995, 7),
(238317, NULL, 'MF_00282', NULL, NULL, 'Phenylalanine--tRNA ligase alpha subunit [pheS].', NULL, 'Phe_tRNA_synth_alpha2', NULL, NULL, 17171, 7),
(238318, NULL, 'MF_00042', NULL, NULL, 'Ribonuclease H [rnhA].', NULL, 'RNase_H', NULL, NULL, 17478, 7),
(238319, NULL, 'MF_00808', NULL, NULL, 'Photosystem II reaction center protein T [psbT].', NULL, 'PSII_PsbT', NULL, NULL, 3153, 7),
(238320, NULL, 'MF_01166', NULL, NULL, 'Bifunctional polymyxin resistance protein ArnA [arnA].', NULL, 'ArnA', NULL, NULL, 15045, 7),
(238321, NULL, 'MF_01183', NULL, NULL, 'Chaperone SurA [surA].', NULL, 'Chaperone_SurA', NULL, NULL, 15450, 7),
(238322, NULL, 'MF_01425', NULL, NULL, 'Ferrous-iron efflux pump FieF [fieF].', NULL, 'Cation_efflux_FieF', NULL, NULL, 16512, 7),
(238323, NULL, 'MF_00506', NULL, NULL, 'UPF0180 protein <locus_tag>.', NULL, 'UPF0180', NULL, NULL, 6133, 7),
(238324, NULL, 'MF_00624', NULL, NULL, 'Glucose-1-phosphate adenylyltransferase [glgC].', NULL, 'GlgC', NULL, NULL, 15100, 7),
(238325, NULL, 'MF_00470', NULL, NULL, 'o-succinylbenzoate synthase [menC].', NULL, 'MenC_1', NULL, NULL, 4083, 7),
(238326, NULL, 'MF_01298', NULL, NULL, 'Arginine decarboxylase proenzyme.', NULL, 'ArgDC', NULL, NULL, 24854, 7),
(238327, NULL, 'MF_04034', NULL, NULL, 'Envelope glycoprotein L [gL].', NULL, 'HSV_GL_alphagamma', NULL, NULL, 8243, 7),
(238328, NULL, 'MF_00171', NULL, NULL, 'tRNA pseudouridine synthase A [truA].', NULL, 'TruA', NULL, NULL, 7190, 7),
(238329, NULL, 'MF_00683', NULL, NULL, 'UPF0265 protein YeeX [yeeX].', NULL, 'UPF0265', NULL, NULL, 4689, 7),
(238330, NULL, 'MF_00993', NULL, NULL, 'Aminodeoxyfutalosine synthase [mqnE].', NULL, 'MqnE', NULL, NULL, 15790, 7),
(238331, NULL, 'MF_01079', NULL, NULL, 'UPF0280 protein <locus_tag>.', NULL, 'UPF0280', NULL, NULL, 27732, 7),
(238332, NULL, 'MF_01621', NULL, NULL, 'Fatty acid oxidation complex subunit alpha [fadB].', NULL, 'FadB', NULL, NULL, 11982, 7),
(238333, NULL, 'MF_01813', NULL, NULL, 'Ubiquinone/menaquinone biosynthesis C-methyltransferase UbiE [ubiE].', NULL, 'MenG_UbiE_methyltr', NULL, NULL, 838, 7),
(238334, NULL, 'MF_01405', NULL, NULL, 'dITP/XTP pyrophosphatase.', NULL, 'Non_canon_purine_NTPase', NULL, NULL, 14639, 7),
(238335, NULL, 'MF_00642', NULL, NULL, 'Cytochrome b559 subunit alpha [psbE].', NULL, 'PSII_PsbE', NULL, NULL, 11484, 7),
(238336, NULL, 'MF_01371_B', NULL, NULL, '50S ribosomal protein L30 [rpmD].', NULL, 'Ribosomal_L30_B', NULL, NULL, 1445, 7),
(238337, NULL, 'MF_04115', NULL, NULL, 'Small outer capsid protein.', NULL, 'SOC_T4', NULL, NULL, 22663, 7),
(238338, NULL, 'MF_01365_B', NULL, NULL, '50S ribosomal protein L6 [rplF].', NULL, 'Ribosomal_L6_B', NULL, NULL, 11815, 7),
(238339, NULL, 'MF_03152', NULL, NULL, 'tRNA (guanine(37)-N1)-methyltransferase [TRMT5].', NULL, 'TRM5', NULL, NULL, 22605, 7),
(238340, NULL, 'MF_01665', NULL, NULL, 'Heme A synthase [ctaA].', NULL, 'HemeA_synth_type2', NULL, NULL, 10833, 7),
(238341, NULL, 'MF_02101', NULL, NULL, '1,4-dihydroxy-2-naphthoyl-CoA hydrolase.', NULL, 'DHNA_CoA_hydrolase', NULL, NULL, 17454, 7);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(238342, NULL, 'MF_01132', NULL, NULL, 'Global transcriptional regulator Spx [spx].', NULL, 'Spx', NULL, NULL, 7505, 7),
(238343, NULL, 'MF_01224_B', NULL, NULL, 'Cyclic pyranopterin monophosphate synthase [moaC].', NULL, 'MoaC_B', NULL, NULL, 15016, 7),
(238344, NULL, 'MF_00837', NULL, NULL, 'Lipid A palmitoyltransferase PagP [pagP].', NULL, 'PagP_transferase', NULL, NULL, 12022, 7),
(238345, NULL, 'MF_01412', NULL, NULL, 'Glutathione-regulated potassium-efflux system protein KefB [kefB].', NULL, 'K_H_efflux_KefB', NULL, NULL, 19939, 7),
(238346, NULL, 'MF_00743', NULL, NULL, 'Fumarate hydratase class II [fumC].', NULL, 'FumaraseC', NULL, NULL, 3732, 7),
(238347, NULL, 'MF_01643', NULL, NULL, 'Formate-dependent phosphoribosylglycinamide formyltransferase [purT].', NULL, 'PurT', NULL, NULL, 6949, 7),
(238348, NULL, 'MF_01075', NULL, NULL, 'K(+)/H(+) antiporter NhaP2 [nhaP2].', NULL, 'NhaP2', NULL, NULL, 16641, 7),
(238349, NULL, 'MF_01113', NULL, NULL, 'DNA polymerase IV [dinB].', NULL, 'DNApol_IV', NULL, NULL, 17120, 7),
(238350, NULL, 'MF_00549', NULL, NULL, 'Methylglyoxal synthase [mgsA].', NULL, 'Methylglyoxal_synth', NULL, NULL, 5073, 7),
(238351, NULL, 'MF_04102', NULL, NULL, 'Baseplate wedge protein gp6.', NULL, 'BP06_T4', NULL, NULL, 7865, 7),
(238352, NULL, 'MF_03054', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 2 [CTU2].', NULL, 'CTU2', NULL, NULL, 16750, 7),
(238353, NULL, 'MF_01444', NULL, NULL, 'Putative phosphoesterase <locus_tag>.', NULL, '2H_phosphoesterase_YjcG', NULL, NULL, 14550, 7),
(238354, NULL, 'PTHR34271', NULL, NULL, NULL, NULL, 'NUCLEOLAR HISTONE METHYLTRANSFERASE-RELATED PROTEIN', NULL, NULL, NULL, 8),
(238355, NULL, 'PTHR15288', NULL, NULL, NULL, NULL, 'DENN DOMAIN-CONTAINING PROTEIN 2', NULL, NULL, NULL, 8),
(238356, NULL, 'PTHR38739', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(238357, NULL, 'PTHR31395', NULL, NULL, NULL, NULL, 'SHISA', NULL, NULL, 26629, 8),
(238358, NULL, 'PTHR34207', NULL, NULL, NULL, NULL, 'PROTEIN BIC1', NULL, NULL, 27774, 8),
(238359, NULL, 'PTHR42841', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', NULL, NULL, NULL, 8),
(238360, NULL, 'PTHR40787', NULL, NULL, NULL, NULL, 'SECRETED PROTEIN', NULL, NULL, NULL, 8),
(238361, NULL, 'PTHR34294', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', NULL, NULL, NULL, 8),
(238362, NULL, 'PTHR32219', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN YLMH-RELATED', NULL, NULL, NULL, 8),
(238363, NULL, 'PTHR37767', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', NULL, NULL, NULL, 8),
(238364, NULL, 'PTHR48172', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(238365, NULL, 'PTHR16095', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 143 FAMILY MEMBER', NULL, NULL, NULL, 8),
(238366, NULL, 'PTHR33479', NULL, NULL, NULL, NULL, 'BOWMAN-BIRK TYPE BRAN TRYPSIN INHIBITOR', NULL, NULL, NULL, 8),
(238367, NULL, 'PTHR46486', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(238368, NULL, 'PTHR24396', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', NULL, NULL, NULL, 8),
(238369, NULL, 'PTHR10772', NULL, NULL, NULL, NULL, '10 KDA HEAT SHOCK PROTEIN', NULL, NULL, 14568, 8),
(238370, NULL, 'PTHR11963', NULL, NULL, NULL, NULL, 'LEUCINE AMINOPEPTIDASE-RELATED', NULL, NULL, 14647, 8),
(238371, NULL, 'PTHR14594', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 70 KDA', NULL, NULL, 28730, 8),
(238372, NULL, 'PTHR14146', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT 4', NULL, NULL, 27290, 8),
(238373, NULL, 'PTHR36735', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(238374, NULL, 'PTHR16119', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 144', NULL, NULL, 9271, 8),
(238375, NULL, 'PTHR22106', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 78', NULL, NULL, 32203, 8),
(238376, NULL, 'PTHR30252', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PEPTIDE TRANSPORTER', NULL, NULL, NULL, 8),
(238377, NULL, 'PTHR46717', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF180', NULL, NULL, 29233, 8),
(238378, NULL, 'PTHR31610', NULL, NULL, NULL, NULL, 'SLR0360 PROTEIN', NULL, NULL, NULL, 8);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(238379, NULL, 'PTHR47997', NULL, NULL, NULL, NULL, 'MYB DOMAIN PROTEIN 55', NULL, NULL, NULL, 8),
(238380, NULL, 'PTHR11371', NULL, NULL, NULL, NULL, 'DEOXYRIBONUCLEASE', NULL, NULL, NULL, 8),
(238381, NULL, 'PTHR47787', NULL, NULL, NULL, NULL, 'CENTROMERE-BINDING PROTEIN 1', NULL, NULL, NULL, 8),
(238382, NULL, 'PTHR34457', NULL, NULL, NULL, NULL, 'EMBRYO DEFECTIVE 2410', NULL, NULL, NULL, 8),
(238383, NULL, 'PTHR10624', NULL, NULL, NULL, NULL, 'UROKINASE PLASMINOGEN ACTIVATOR SURFACE RECEPTOR-RELATED', NULL, NULL, NULL, 8),
(238384, NULL, 'PTHR23220', NULL, NULL, NULL, NULL, 'INTEGRIN ALPHA', NULL, NULL, NULL, 8),
(238385, NULL, 'PTHR34963', NULL, NULL, NULL, NULL, '', NULL, NULL, 2611, 8),
(238386, NULL, 'PTHR19303', NULL, NULL, NULL, NULL, 'TRANSPOSON', NULL, NULL, NULL, 8),
(238387, NULL, 'PTHR48105', NULL, NULL, NULL, NULL, 'THIOREDOXIN REDUCTASE 1-RELATED-RELATED', NULL, NULL, NULL, 8),
(238388, NULL, 'PTHR46078', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN J2 FAMILY MEMBER', NULL, NULL, 36542, 8),
(238389, NULL, 'PTHR33284', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L25/GLN-TRNA SYNTHETASE, ANTI-CODON-BINDING DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(238390, NULL, 'PTHR15746', NULL, NULL, NULL, NULL, 'RAB11-RELATED', NULL, NULL, 30028, 8),
(238391, NULL, 'PTHR37561', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(238392, NULL, 'PTHR46359', NULL, NULL, NULL, NULL, 'GEO07743P1', NULL, NULL, NULL, 8),
(238393, NULL, 'PTHR38454', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN-RELATED', NULL, NULL, 15240, 8),
(238394, NULL, 'PTHR43738', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, MEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(238395, NULL, 'PTHR40661', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(238396, NULL, 'PTHR11873', NULL, NULL, NULL, NULL, 'RETINOL-BINDING PROTEIN 4', NULL, NULL, 6779, 8),
(238397, NULL, 'PTHR19862', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 48', NULL, NULL, NULL, 8),
(238398, NULL, 'PTHR38042', NULL, NULL, NULL, NULL, 'UROPORPHYRINOGEN-III SYNTHASE, CHLOROPLASTIC', NULL, NULL, 31427, 8),
(238399, NULL, 'PTHR47508', NULL, NULL, NULL, NULL, 'SAM DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(238400, NULL, 'PTHR12039', NULL, NULL, NULL, NULL, 'NICOTINAMIDE MONONUCLEOTIDE ADENYLYLTRANSFERASE', NULL, NULL, NULL, 8),
(238401, NULL, 'PTHR46775', NULL, NULL, NULL, NULL, 'FLOCCULATION PROTEIN (DUF1296)', NULL, NULL, 36149, 8),
(238402, NULL, 'PTHR22938', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 598', NULL, NULL, 34905, 8),
(238403, NULL, 'PTHR40741', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(238404, NULL, 'PTHR28291', NULL, NULL, NULL, NULL, 'CTD KINASE SUBUNIT GAMMA', NULL, NULL, 35291, 8),
(238405, NULL, 'PTHR46089', NULL, NULL, NULL, NULL, 'ALSIN HOMOLOG', NULL, NULL, NULL, 8),
(238406, NULL, 'PTHR34095', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L55, MITOCHONDRIAL', NULL, NULL, 16115, 8),
(238407, NULL, 'PTHR24104', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE NHLRC1-RELATED', NULL, NULL, NULL, 8),
(238408, NULL, 'PTHR47606', NULL, NULL, NULL, NULL, 'KILLER CELL LECTIN-LIKE RECEPTOR SUBFAMILY G MEMBER 2', NULL, NULL, 34019, 8),
(238409, NULL, 'PTHR46573', NULL, NULL, NULL, NULL, 'WD REPEAT, SAM AND U-BOX DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(238410, NULL, 'PTHR36961', NULL, NULL, NULL, NULL, 'LEUKEMIA-ASSOCIATED PROTEIN 7', NULL, NULL, 24602, 8),
(238411, NULL, 'PTHR33782', NULL, NULL, NULL, NULL, 'OS01G0121600 PROTEIN', NULL, NULL, NULL, 8),
(238412, NULL, 'PTHR11269', NULL, NULL, NULL, NULL, 'PERIOD CIRCADIAN PROTEIN', NULL, NULL, NULL, 8),
(238413, NULL, 'PTHR43285', NULL, NULL, NULL, NULL, 'ANTHRANILATE PHOSPHORIBOSYLTRANSFERASE', NULL, NULL, 449, 8),
(238414, NULL, 'PTHR12689', NULL, NULL, NULL, NULL, 'A1 CISTRON SPLICING FACTOR AAR2-RELATED', NULL, NULL, 4228, 8),
(238415, NULL, 'PTHR31302', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN WITH METALLOPHOSPHOESTERASE DOMAIN-RELATED', NULL, NULL, NULL, 8),
(238416, NULL, 'PTHR21083', NULL, NULL, NULL, NULL, 'TWISTER', NULL, NULL, 24106, 8);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(238417, NULL, 'PTHR43378', NULL, NULL, NULL, NULL, 'UDP-3-O-ACYLGLUCOSAMINE N-ACYLTRANSFERASE', NULL, NULL, 1402, 8),
(238418, NULL, 'PTHR44177', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 8', NULL, NULL, 24342, 8),
(238419, NULL, 'PTHR43814', NULL, NULL, NULL, NULL, 'ARGININOSUCCINATE LYASE', NULL, NULL, 6393, 8),
(238420, NULL, 'PTHR35468', NULL, NULL, NULL, NULL, 'MYOSIN-LIKE PROTEIN', NULL, NULL, NULL, 8),
(238421, NULL, 'PTHR35124', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY PROTEIN', NULL, NULL, NULL, 8),
(238422, NULL, 'PTHR14495', NULL, NULL, NULL, NULL, 'SHIELDIN COMPLEX SUBUNIT 2', NULL, NULL, 24861, 8),
(238423, NULL, 'PTHR47657', NULL, NULL, NULL, NULL, 'STEROL REGULATORY ELEMENT-BINDING PROTEIN ECM22', NULL, NULL, NULL, 8),
(238424, NULL, 'PTHR11136', NULL, NULL, NULL, NULL, 'FOLYLPOLYGLUTAMATE SYNTHASE-RELATED', NULL, NULL, 3125, 8),
(238425, NULL, 'PTHR35715', NULL, NULL, NULL, NULL, 'OS08G0511800 PROTEIN', NULL, NULL, NULL, 8),
(238426, NULL, 'PTHR21719', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(238427, NULL, 'PTHR35936', NULL, NULL, NULL, NULL, 'MEMBRANE-BOUND LYTIC MUREIN TRANSGLYCOSYLASE F', NULL, NULL, NULL, 8),
(238428, NULL, 'PTHR36405', NULL, NULL, NULL, NULL, 'BNAA10G09140D PROTEIN', NULL, NULL, NULL, 8),
(238429, NULL, 'PTHR34488', NULL, NULL, NULL, NULL, 'SI:CH211-245H14.1-RELATED', NULL, NULL, NULL, 8),
(238430, NULL, 'PTHR42650', NULL, NULL, NULL, NULL, 'TAIL-ANCHORED PROTEIN INSERTION RECEPTOR WRB', NULL, NULL, NULL, 8),
(238431, NULL, 'PTHR24023', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA', NULL, NULL, NULL, 8),
(238432, NULL, 'PTHR28174', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN L36, MITOCHONDRIAL', NULL, NULL, 10993, 8),
(238433, NULL, 'PTHR44215', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 75', NULL, NULL, NULL, 8),
(238434, NULL, 'PTHR30083', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(238435, NULL, 'PTHR11067', NULL, NULL, NULL, NULL, 'INOSINE TRIPHOSPHATE PYROPHOSPHATASE/HAM1 PROTEIN', NULL, NULL, 2878, 8),
(238436, NULL, 'PTHR39160', NULL, NULL, NULL, NULL, 'CELL WALL-BINDING PROTEIN YOCH', NULL, NULL, NULL, 8),
(238437, NULL, 'PTHR13826', NULL, NULL, NULL, NULL, 'INTESTINAL TREFOIL FACTOR-RELATED', NULL, NULL, 13806, 8),
(238438, NULL, 'PTHR46519', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(238439, NULL, 'PTHR38107', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(238440, NULL, 'PTHR45973', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT SDS22-RELATED', NULL, NULL, NULL, 8),
(238441, NULL, 'PTHR43751', NULL, NULL, NULL, NULL, 'SULFATASE', NULL, NULL, NULL, 8),
(238442, NULL, 'PTHR16263', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 38', NULL, NULL, 31647, 8),
(238443, NULL, 'PTHR45662', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITIDE PHOSPHATASE SAC1', NULL, NULL, NULL, 8),
(238444, NULL, 'PTHR47230', NULL, NULL, NULL, NULL, 'TIR DOMAIN-CONTAINING ADAPTER MOLECULE 1', NULL, NULL, NULL, 8),
(238445, NULL, 'PTHR11036', NULL, NULL, NULL, NULL, 'SEMAPHORIN', NULL, NULL, 21589, 8),
(238446, NULL, 'PTHR15333', NULL, NULL, NULL, NULL, 'SNRNA-ACTIVATING PROTEIN COMPLEX SUBUNIT 5', NULL, NULL, 23818, 8),
(238447, NULL, 'PTHR36368', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CASEINOLYTIC PROTEASE/CROTONASE FAMILY PROTEIN', NULL, NULL, NULL, 8),
(238448, NULL, 'PTHR43297', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORT ATP-BINDING PROTEIN APPD', NULL, NULL, NULL, 8),
(238449, NULL, 'PTHR34411', NULL, NULL, NULL, NULL, '', NULL, NULL, 27655, 8),
(238450, NULL, 'PTHR11952', NULL, NULL, NULL, NULL, 'UDP- GLUCOSE PYROPHOSPHORYLASE', NULL, NULL, 28367, 8),
(238451, NULL, 'PTHR17597', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN MLC1', NULL, NULL, 26863, 8),
(238452, NULL, 'PTHR45877', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SIAH2', NULL, NULL, 2552, 8),
(238453, NULL, 'PTHR35804', NULL, NULL, NULL, NULL, 'LYSINE EXPORTER LYSO', NULL, NULL, 2736, 8),
(238454, NULL, 'PTHR23426', NULL, NULL, NULL, NULL, 'FERREDOXIN/ADRENODOXIN', NULL, NULL, 2350, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(238455, NULL, 'PTHR47998', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB51-LIKE ISOFORM X1', NULL, NULL, NULL, 8),
(238456, NULL, 'PTHR13374', NULL, NULL, NULL, NULL, 'DET1 HOMOLOG  DE-ETIOLATED-1 HOMOLOG', NULL, NULL, 17961, 8),
(238457, NULL, 'PTHR12046', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE TYPE B CATALYTIC SUBUNIT', NULL, NULL, 18282, 8),
(238458, NULL, 'PTHR47973', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH RECEPTOR-LIKE PROTEIN KINASE 3', NULL, NULL, NULL, 8),
(238459, NULL, 'PTHR38448', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN YLBF-RELATED', NULL, NULL, NULL, 8),
(238460, NULL, 'PTHR46336', NULL, NULL, NULL, NULL, 'OS02G0260700 PROTEIN', NULL, NULL, 37108, 8),
(238461, NULL, 'PTHR16516', NULL, NULL, NULL, NULL, 'AGAP007109-PA', NULL, NULL, NULL, 8),
(238462, NULL, 'PTHR13847', NULL, NULL, NULL, NULL, 'SARCOSINE DEHYDROGENASE-RELATED', NULL, NULL, NULL, 8),
(238463, NULL, 'PTHR34965', NULL, NULL, NULL, NULL, 'OS07G0118300 PROTEIN', NULL, NULL, NULL, 8),
(238464, NULL, 'PTHR21225', NULL, NULL, NULL, NULL, 'PHOSPHO-2-DEHYDRO-3-DEOXYHEPTONATE ALDOLASE  DAHP SYNTHETASE', NULL, NULL, 11346, 8),
(238465, NULL, 'PTHR30591', NULL, NULL, NULL, NULL, 'RECBCD ENZYME SUBUNIT RECC', NULL, NULL, NULL, 8),
(238466, NULL, 'PTHR36325', NULL, NULL, NULL, NULL, 'MYOSIN-2 HEAVY CHAIN-LIKE PROTEIN', NULL, NULL, NULL, 8),
(238467, NULL, 'PTHR33477', NULL, NULL, NULL, NULL, 'P-LOOP NTPASE DOMAIN-CONTAINING PROTEIN LPA1 HOMOLOG 1', NULL, NULL, NULL, 8),
(238468, NULL, 'PTHR11113', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINE-6-PHOSPHATE DEACETYLASE', NULL, NULL, NULL, 8),
(238469, NULL, 'PTHR16284', NULL, NULL, NULL, NULL, 'PROTEIN CDV3 HOMOLOG', NULL, NULL, 22044, 8),
(238470, NULL, 'PTHR31933', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 2-RELATED', NULL, NULL, NULL, 8),
(238471, NULL, 'PTHR32410', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN FAMILY PROTEIN', NULL, NULL, NULL, 8),
(238472, NULL, 'PTHR33794', NULL, NULL, NULL, NULL, 'BACILLOLYSIN', NULL, NULL, NULL, 8),
(238473, NULL, 'PTHR38812', NULL, NULL, NULL, NULL, 'MU-LIKE PROPHAGE FLUMU PROTEIN GP42', NULL, NULL, NULL, 8),
(238474, NULL, 'PTHR13483', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(238475, NULL, 'PTHR12731', NULL, NULL, NULL, NULL, 'TRANSLOCON-ASSOCIATED PROTEIN, DELTA SUBUNIT', NULL, NULL, 13807, 8),
(238476, NULL, 'PTHR23340', NULL, NULL, NULL, NULL, 'ARGININE/SERINE RICH SPLICING FACTOR SF4/14', NULL, NULL, 31813, 8),
(238477, NULL, 'PTHR37308', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN', NULL, NULL, 246, 8),
(238478, NULL, 'PTHR12622', NULL, NULL, NULL, NULL, 'DELTEX-RELATED', NULL, NULL, 33120, 8),
(238479, NULL, 'PTHR12700', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT D, MITOCHONDRIAL', NULL, NULL, 13045, 8),
(238480, NULL, 'PTHR15511', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 13B', NULL, NULL, 15896, 8),
(238481, NULL, 'PTHR38039', NULL, NULL, NULL, NULL, 'TOXIN YOEB', NULL, NULL, 1696, 8),
(238482, NULL, 'PTHR33820', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 17', NULL, NULL, 32472, 8),
(238483, NULL, 'PTHR36475', NULL, NULL, NULL, NULL, 'LEUCINE-RICH SINGLE-PASS MEMBRANE PROTEIN 1', NULL, NULL, 24688, 8),
(238484, NULL, 'PTHR45964', NULL, NULL, NULL, NULL, 'WSCD FAMILY MEMBER CG9164', NULL, NULL, NULL, 8),
(238485, NULL, 'PTHR24045', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(238486, NULL, 'PTHR23167', NULL, NULL, NULL, NULL, 'CALPONIN HOMOLOGY DOMAIN-CONTAINING PROTEIN DDB_G0272472-RELATED', NULL, NULL, NULL, 8),
(238487, NULL, 'PTHR35713', NULL, NULL, NULL, NULL, 'ARGININE/SERINE-RICH-LIKE SPLICING FACTOR', NULL, NULL, NULL, 8),
(238488, NULL, 'PTHR46368', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(238489, NULL, 'PTHR41156', NULL, NULL, NULL, NULL, 'AGAP006184-PA', NULL, NULL, NULL, 8),
(238490, NULL, 'PTHR47857', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', NULL, NULL, NULL, 8),
(238491, NULL, 'PTHR45825', NULL, NULL, NULL, NULL, 'GRANULE-BOUND STARCH SYNTHASE 1, CHLOROPLASTIC/AMYLOPLASTIC', NULL, NULL, NULL, 8);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(238492, NULL, 'PTHR33731', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(238493, NULL, 'PTHR13261', NULL, NULL, NULL, NULL, 'BRCA2 AND CDKN1A INTERACTING PROTEIN', NULL, NULL, 24775, 8),
(238494, NULL, 'PTHR34671', NULL, NULL, NULL, NULL, 'EM-LIKE PROTEIN GEA1', NULL, NULL, 6677, 8),
(238495, NULL, 'PTHR47948', NULL, NULL, NULL, NULL, 'TRANS-CINNAMATE 4-MONOOXYGENASE', NULL, NULL, NULL, 8),
(238496, NULL, 'PTHR11527', NULL, NULL, NULL, NULL, 'HEAT-SHOCK PROTEIN 20 FAMILY MEMBER', NULL, NULL, NULL, 8),
(238497, NULL, 'PTHR13080', NULL, NULL, NULL, NULL, 'ATP SYNTHASE F CHAIN, MITOCHONDRIAL-RELATED', NULL, NULL, 15579, 8),
(238498, NULL, 'PTHR31913', NULL, NULL, NULL, NULL, 'VACUOLAR IMPORT AND DEGRADATION PROTEIN 27', NULL, NULL, 32863, 8),
(238499, NULL, 'PTHR12103', NULL, NULL, NULL, NULL, '5''-NUCLEOTIDASE DOMAIN-CONTAINING', NULL, NULL, 7587, 8),
(238500, NULL, 'PTHR23542', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(238501, NULL, 'PTHR14365', NULL, NULL, NULL, NULL, 'APOPTOSIS REGULATORY PROTEIN SIVA', NULL, NULL, 11380, 8),
(238502, NULL, 'PTHR35744', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(238503, NULL, 'PTHR47937', NULL, NULL, NULL, NULL, 'PLASTID TRANSCRIPTIONALLY ACTIVE CHROMOSOME 2-LIKE PROTEIN', NULL, NULL, NULL, 8),
(238504, NULL, 'PTHR47645', NULL, NULL, NULL, NULL, 'PROTEIN CBG08267', NULL, NULL, NULL, 8),
(238505, NULL, 'PTHR31963', NULL, NULL, NULL, NULL, 'RAS GUANINE NUCLEOTIDE EXCHANGE FACTOR K', NULL, NULL, 19964, 8),
(238506, NULL, 'PTHR14903', NULL, NULL, NULL, NULL, 'SCLEROSTIN-RELATED', NULL, NULL, 13777, 8),
(238507, NULL, 'PTHR43690', NULL, NULL, NULL, NULL, 'NARDILYSIN', NULL, NULL, NULL, 8),
(238508, NULL, 'PTHR31316', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE-LIKE PROTEIN NCA3, MITOCHONDRIAL-RELATED', NULL, NULL, NULL, 8),
(238509, NULL, 'PTHR36304', NULL, NULL, NULL, NULL, 'DOMAIN GTPASE-ACTIVATING PROTEIN, PUTATIVE-RELATED-RELATED', NULL, NULL, NULL, 8),
(238510, NULL, 'PTHR37263', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(238511, NULL, 'PTHR47843', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(238512, NULL, 'PTHR23095', NULL, NULL, NULL, NULL, 'PARANEOPLASTIC ANTIGEN', NULL, NULL, 23038, 8),
(238513, NULL, 'PTHR35254', NULL, NULL, NULL, NULL, 'STIMULATED BY RETINOIC ACID GENE 8 PROTEIN HOMOLOG', NULL, NULL, 33171, 8),
(238514, NULL, 'PTHR15832', NULL, NULL, NULL, NULL, 'SHC (SRC HOMOLOGY DOMAIN C-TERMINAL) ADAPTOR HOMOLOG', NULL, NULL, NULL, 8),
(238515, NULL, 'PTHR40068', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR NIAR-RELATED', NULL, NULL, 25279, 8),
(238516, NULL, 'PTHR14726', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 24428, 8),
(238517, NULL, 'PTHR35190', NULL, NULL, NULL, NULL, 'PROTEIN DCD1B', NULL, NULL, NULL, 8),
(238518, NULL, 'PTHR12534', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S2  PROKARYOTIC AND ORGANELLAR', NULL, NULL, 3546, 8),
(238519, NULL, 'PTHR14523', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN C17ORF53 HOMOLOG', NULL, NULL, 24412, 8),
(238520, NULL, 'PTHR31861', NULL, NULL, NULL, NULL, 'OS10G0507500 PROTEIN', NULL, NULL, NULL, 8),
(238521, NULL, 'PTHR14776', NULL, NULL, NULL, NULL, 'CADHERIN-LIKE AND PC-ESTERASE DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(238522, NULL, 'PTHR47265', NULL, NULL, NULL, NULL, 'IRON-SULFUR ASSEMBLY PROTEIN ISCA, CHLOROPLASTIC', NULL, NULL, 21556, 8),
(238523, NULL, 'PTHR35832', NULL, NULL, NULL, NULL, 'OS12G0248400 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(238524, NULL, 'PTHR10476', NULL, NULL, NULL, NULL, 'CHARGED MULTIVESICULAR BODY PROTEIN', NULL, NULL, 1313, 8),
(238525, NULL, 'PTHR43224', NULL, NULL, NULL, NULL, 'AMIDINOTRANSFERASE', NULL, NULL, 12394, 8),
(238526, NULL, 'PTHR46947', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 73', NULL, NULL, 36121, 8),
(238527, NULL, 'PTHR36489', NULL, NULL, NULL, NULL, 'PROTEIN-COUPLED RECEPTOR GPR1, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(238528, NULL, 'PTHR37443', NULL, NULL, NULL, NULL, 'PROTEIN CBG09852-RELATED', NULL, NULL, 27019, 8);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(238529, NULL, 'PTHR14596', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', NULL, NULL, NULL, 8),
(238530, NULL, 'PTHR38433', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(238531, NULL, 'PTHR31159', NULL, NULL, NULL, NULL, 'COMM DOMAIN-CONTAINING PROTEIN 3', NULL, NULL, 29080, 8),
(238532, NULL, 'PTHR37769', NULL, NULL, NULL, NULL, 'OS08G0243900 PROTEIN', NULL, NULL, NULL, 8),
(238533, NULL, 'PTHR47746', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(238534, NULL, 'PTHR37536', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_3G02970)-RELATED', NULL, NULL, 4604, 8),
(238535, NULL, 'PTHR34224', NULL, NULL, NULL, NULL, 'INTERACTOR OF CONSTITUTIVE ACTIVE ROPS 2, CHLOROPLASTIC-RELATED', NULL, NULL, 25492, 8),
(238536, NULL, 'PTHR37429', NULL, NULL, NULL, NULL, 'PROTEIN CBG19148-RELATED', NULL, NULL, NULL, 8),
(238537, NULL, 'PTHR38384', NULL, NULL, NULL, NULL, 'MEMBRANE LIPOPROTEIN-RELATED', NULL, NULL, NULL, 8),
(238538, NULL, 'PTHR34802', NULL, NULL, NULL, NULL, 'CHORISMATE SYNTHASE', NULL, NULL, NULL, 8),
(238539, NULL, 'PTHR35081', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 105', NULL, NULL, 31867, 8),
(238540, NULL, 'PTHR47393', NULL, NULL, NULL, NULL, 'CYSTATIN-12-RELATED', NULL, NULL, NULL, 8),
(238541, NULL, 'PTHR45979', NULL, NULL, NULL, NULL, 'PAP/OAS1 SUBSTRATE-BINDING DOMAIN SUPERFAMILY', NULL, NULL, NULL, 8),
(238542, NULL, 'PTHR40696', NULL, NULL, NULL, NULL, 'DUF371 FAMILY PROTEIN', NULL, NULL, 492, 8),
(238543, NULL, 'PTHR43522', NULL, NULL, NULL, NULL, 'TRANSKETOLASE', NULL, NULL, 27066, 8),
(238544, NULL, 'PTHR12839', NULL, NULL, NULL, NULL, 'NONSENSE-MEDIATED MRNA DECAY PROTEIN 2  UP-FRAMESHIFT SUPPRESSOR 2', NULL, NULL, 33500, 8),
(238545, NULL, 'PTHR39601', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(238546, NULL, 'PTHR12620', NULL, NULL, NULL, NULL, 'U2 SNRNP AUXILIARY FACTOR, SMALL SUBUNIT', NULL, NULL, 10269, 8),
(238547, NULL, 'PTHR46755', NULL, NULL, NULL, NULL, 'METHIONINE-R-SULFOXIDE REDUCTASE B1', NULL, NULL, NULL, 8),
(238548, NULL, 'PTHR44051', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE-RELATED', NULL, NULL, NULL, 8),
(238549, NULL, 'PTHR31524', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(238550, NULL, 'PTHR13016', NULL, NULL, NULL, NULL, 'AMMECR1 HOMOLOG', NULL, NULL, 16023, 8),
(238551, NULL, 'PTHR47169', NULL, NULL, NULL, NULL, 'OS01G0541250 PROTEIN', NULL, NULL, NULL, 8),
(238552, NULL, 'PTHR46279', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(238553, NULL, 'PTHR12783', NULL, NULL, NULL, NULL, 'RALA BINDING PROTEIN 1  RALBP1', NULL, NULL, 33173, 8),
(238554, NULL, 'PTHR31082', NULL, NULL, NULL, NULL, 'PHEROMONE-REGULATED MEMBRANE PROTEIN 10', NULL, NULL, NULL, 8),
(238555, NULL, 'PTHR45527', NULL, NULL, NULL, NULL, 'NONRIBOSOMAL PEPTIDE SYNTHETASE', NULL, NULL, NULL, 8),
(238556, NULL, 'PTHR12714', NULL, NULL, NULL, NULL, 'PROTEIN-S ISOPRENYLCYSTEINE O-METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(238557, NULL, 'PTHR31811', NULL, NULL, NULL, NULL, 'TRNA A64-2''-O-RIBOSYLPHOSPHATE TRANSFERASE', NULL, NULL, 4817, 8),
(238558, NULL, 'PTHR34041', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REPAIR PROTEIN PSB27-H1, CHLOROPLASTIC', NULL, NULL, 24774, 8),
(238559, NULL, 'PTHR48168', NULL, NULL, NULL, NULL, 'RNA GUANINE-7 METHYLTRANSFERASE-ACTIVATING SUBUNIT-LIKE (PSEUDOGENE)-RELATED', NULL, NULL, NULL, 8),
(238560, NULL, 'PTHR13861', NULL, NULL, NULL, NULL, 'VACUOLAR ATP SYNTHASE SUBUNIT F', NULL, NULL, NULL, 8),
(238561, NULL, 'PTHR37978', NULL, NULL, NULL, NULL, 'PROTEIN CBG22381-RELATED', NULL, NULL, NULL, 8),
(238562, NULL, 'PTHR43078', NULL, NULL, NULL, NULL, 'UDP-GLUCURONIC ACID DECARBOXYLASE-RELATED', NULL, NULL, 36584, 8),
(238563, NULL, 'PTHR32010', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II STABILITY/ASSEMBLY FACTOR HCF136, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(238564, NULL, 'PTHR33359', NULL, NULL, NULL, NULL, 'MOLYBDOPTERIN SYNTHASE SULFUR CARRIER SUBUNIT', NULL, NULL, 35799, 8),
(238565, NULL, 'PTHR35690', NULL, NULL, NULL, NULL, 'OS01G0363500 PROTEIN', NULL, NULL, NULL, 8);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(238566, NULL, 'PTHR12220', NULL, NULL, NULL, NULL, '50S/60S RIBOSOMAL PROTEIN L16', NULL, NULL, 2905, 8),
(238567, NULL, 'PTHR23077', NULL, NULL, NULL, NULL, 'AAA-FAMILY ATPASE', NULL, NULL, NULL, 8),
(238568, NULL, 'PTHR11329', NULL, NULL, NULL, NULL, 'LEUKOCYTE CELL-DERIVED CHEMOTAXIN 2', NULL, NULL, 12785, 8),
(238569, NULL, 'PTHR24102', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN', NULL, NULL, NULL, 8),
(238570, NULL, 'PTHR40050', NULL, NULL, NULL, NULL, 'INNER SPORE COAT PROTEIN H', NULL, NULL, 13172, 8),
(238571, NULL, 'PTHR44464', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 17', NULL, NULL, NULL, 8),
(238572, NULL, 'PTHR16566', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN C-II', NULL, NULL, 5318, 8),
(238573, NULL, 'PTHR11787', NULL, NULL, NULL, NULL, 'RAB GDP-DISSOCIATION INHIBITOR', NULL, NULL, 19834, 8),
(238574, NULL, 'PTHR35511', NULL, NULL, NULL, NULL, 'A-KINASE ANCHOR-LIKE PROTEIN', NULL, NULL, NULL, 8),
(238575, NULL, 'PTHR15938', NULL, NULL, NULL, NULL, 'TBP-1 INTERACTING PROTEIN', NULL, NULL, 28561, 8),
(238576, NULL, 'PTHR43867', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE CATALYTIC SUBUNIT A [UDP-FORMING]', NULL, NULL, NULL, 8),
(238577, NULL, 'PTHR21479', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(238578, NULL, 'PTHR21106', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(238579, NULL, 'PTHR47438', NULL, NULL, NULL, NULL, 'PHOSPHATE METABOLISM PROTEIN 8-RELATED', NULL, NULL, NULL, 8),
(238580, NULL, 'PTHR19849', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A-2-ACTIVATING PROTEIN', NULL, NULL, NULL, 8),
(238581, NULL, 'PTHR40033', NULL, NULL, NULL, NULL, 'NA(+)-MALATE SYMPORTER', NULL, NULL, 3141, 8),
(238582, NULL, 'PTHR40027', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN DIVIC', NULL, NULL, 27058, 8),
(238583, NULL, 'PTHR34855', NULL, NULL, NULL, NULL, 'TRICHOHYALIN', NULL, NULL, 29246, 8),
(238584, NULL, 'PTHR37482', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN ASSEMBLY FACTOR BAME', NULL, NULL, 26505, 8),
(238585, NULL, 'PTHR31096', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN ACR4-RELATED', NULL, NULL, 31131, 8),
(238586, NULL, 'PTHR39209', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(238587, NULL, 'PTHR10077', NULL, NULL, NULL, NULL, 'CALPASTATIN', NULL, NULL, 23411, 8),
(238588, NULL, 'PTHR10635', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT BETA', NULL, NULL, 15112, 8),
(238589, NULL, 'PTHR36790', NULL, NULL, NULL, NULL, 'MYELIN TRANSCRIPTION FACTOR', NULL, NULL, NULL, 8),
(238590, NULL, 'PTHR35725', NULL, NULL, NULL, NULL, 'CLASSICAL ARABINOGALACTAN PROTEIN 26', NULL, NULL, 29086, 8),
(238591, NULL, 'PTHR21071', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLENOLPYRUVOYLGLUCOSAMINE REDUCTASE', NULL, NULL, 1983, 8),
(238592, NULL, 'PTHR15208', NULL, NULL, NULL, NULL, 'RECEPTOR-BINDING CANCER ANTIGEN EXPRESSED ON SISO CELLS  CANCER ASSOCIATED SURFACE ANTIGEN RCAS1   ESTROGEN RECEPTOR-BINDING FRAGMENT- ASSOCIATED GENE 9 PROTEIN', NULL, NULL, 18622, 8),
(238593, NULL, 'PTHR22708', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 31847, 8),
(238594, NULL, 'PTHR36329', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(238595, NULL, 'PTHR28022', NULL, NULL, NULL, NULL, 'GPI MANNOSYLTRANSFERASE 2 SUBUNIT PGA1', NULL, NULL, 17041, 8),
(238596, NULL, 'PTHR27004', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 12 ISOFORM X1', NULL, NULL, 34703, 8),
(238597, NULL, 'PTHR33150', NULL, NULL, NULL, NULL, 'EXTRACELLULAR MATRIX-BINDING PROTEIN EBH', NULL, NULL, NULL, 8),
(238598, NULL, 'PTHR18962', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 39', NULL, NULL, 31716, 8),
(238599, NULL, 'PTHR37344', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 5', NULL, NULL, NULL, 8),
(238600, NULL, 'PTHR16091', NULL, NULL, NULL, NULL, 'TTC17 PROTEIN', NULL, NULL, NULL, 8),
(238601, NULL, 'PTHR13511', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 27060, 8),
(238602, NULL, 'PTHR46413', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 6', NULL, NULL, 34472, 8);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(238603, NULL, 'PTHR13480', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HAKAI-RELATED', NULL, NULL, 28585, 8),
(238604, NULL, 'PTHR37968', NULL, NULL, NULL, NULL, 'PROTEIN CBG06678', NULL, NULL, NULL, 8),
(238605, NULL, 'PTHR33908', NULL, NULL, NULL, NULL, 'MANNOSYLTRANSFERASE YKCB-RELATED', NULL, NULL, NULL, 8),
(238606, NULL, 'PTHR42708', NULL, NULL, NULL, NULL, 'ATP/GTP-BINDING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(238607, NULL, 'PTHR28112', NULL, NULL, NULL, NULL, 'SRP-INDEPENDENT TARGETING PROTEIN 3', NULL, NULL, 12529, 8),
(238608, NULL, 'PTHR33657', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G00600)-RELATED', NULL, NULL, 13440, 8),
(238609, NULL, 'PTHR31412', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEASE EGY1', NULL, NULL, 35015, 8),
(238610, NULL, 'PTHR24172', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(238611, NULL, 'PTHR48094', NULL, NULL, NULL, NULL, 'PROTEIN/NUCLEIC ACID DEGLYCASE DJ-1-RELATED', NULL, NULL, NULL, 8),
(238612, NULL, 'PTHR23039', NULL, NULL, NULL, NULL, 'NANCE-HORAN SYNDROME PROTEIN', NULL, NULL, NULL, 8),
(238613, NULL, 'PTHR46391', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER 34', NULL, NULL, NULL, 8),
(238614, NULL, 'PTHR47792', NULL, NULL, NULL, NULL, 'PROTEIN SOK2-RELATED', NULL, NULL, 22239, 8),
(238615, NULL, 'PTHR12650', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S30/UBIQUITIN-LIKE PROTEIN FUBI', NULL, NULL, NULL, 8),
(238616, NULL, 'PTHR12184', NULL, NULL, NULL, NULL, 'UBIQUINOL-CYTOCHROME C REDUCTASE COMPLEX ASSEMBLY FACTOR 1 FAMILY MEMBER', NULL, NULL, 82, 8),
(238617, NULL, 'PTHR46169', NULL, NULL, NULL, NULL, 'DNA REPLICATION-RELATED ELEMENT FACTOR, ISOFORM A', NULL, NULL, NULL, 8),
(238618, NULL, 'PTHR46248', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(238619, NULL, 'PTHR38664', NULL, NULL, NULL, NULL, 'SLR0058 PROTEIN', NULL, NULL, 12143, 8),
(238620, NULL, 'PTHR40630', NULL, NULL, NULL, NULL, 'POSSIBLE DNA-BINDING PROTEIN', NULL, NULL, 18853, 8),
(238621, NULL, 'PTHR11931', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE', NULL, NULL, 192, 8),
(238622, NULL, 'PTHR31003', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR', NULL, NULL, 36490, 8),
(238623, NULL, 'PTHR34941', NULL, NULL, NULL, NULL, 'DEHYDRIN HIRD11', NULL, NULL, 32694, 8),
(238624, NULL, 'PTHR28384', NULL, NULL, NULL, NULL, 'PROGRESSIVE ANKYLOSIS PROTEIN HOMOLOG', NULL, NULL, 14356, 8),
(238625, NULL, 'PTHR10388', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR SUI1', NULL, NULL, NULL, 8),
(238626, NULL, 'PTHR43373', NULL, NULL, NULL, NULL, 'NA(+)/H(+) ANTIPORTER SUBUNIT', NULL, NULL, NULL, 8),
(238627, NULL, 'PTHR32092', NULL, NULL, NULL, NULL, '6-PHOSPHO-BETA-GLUCOSIDASE-RELATED', NULL, NULL, 2142, 8),
(238628, NULL, 'PTHR47187', NULL, NULL, NULL, NULL, 'NFATC2-INTERACTING PROTEIN', NULL, NULL, NULL, 8),
(238629, NULL, 'PTHR14753', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 38', NULL, NULL, 36779, 8),
(238630, NULL, 'PTHR37897', NULL, NULL, NULL, NULL, 'DNAK FAMILY PROTEIN', NULL, NULL, NULL, 8),
(238631, NULL, 'PTHR42705', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL NON-HOMOLOGOUS END JOINING PROTEIN LIGD', NULL, NULL, NULL, 8),
(238632, NULL, 'PTHR37941', NULL, NULL, NULL, NULL, 'FUMARASE E-RELATED', NULL, NULL, 1326, 8),
(238633, NULL, 'PTHR13231', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOMAL PROTEIN S31', NULL, NULL, 25604, 8),
(238634, NULL, 'PTHR43443', NULL, NULL, NULL, NULL, '3-HEXULOSE-6-PHOSPHATE ISOMERASE', NULL, NULL, 14897, 8),
(238635, NULL, 'PTHR17039', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RIBONUCLEOPROTEIN PROTEIN MPP10', NULL, NULL, 7149, 8),
(238636, NULL, 'PTHR39517', NULL, NULL, NULL, NULL, 'SLL0192 PROTEIN', NULL, NULL, 16626, 8),
(238637, NULL, 'PTHR16246', NULL, NULL, NULL, NULL, 'HOST CELL FACTOR C1 REGULATOR 1', NULL, NULL, 21540, 8),
(238638, NULL, 'PTHR33493', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN 6-RELATED', NULL, NULL, 761, 8),
(238639, NULL, 'PTHR35658', NULL, NULL, NULL, NULL, 'RCG58666, ISOFORM CRA_A', NULL, NULL, 21547, 8);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(238640, NULL, 'PTHR42509', NULL, NULL, NULL, NULL, 'DIX DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(238641, NULL, 'PTHR35729', NULL, NULL, NULL, NULL, 'T1B9.12 PROTEIN', NULL, NULL, NULL, 8),
(238642, NULL, 'PTHR46142', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(238643, NULL, 'PTHR39579', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YHCB', NULL, NULL, 8391, 8),
(238644, NULL, 'PTHR10383', NULL, NULL, NULL, NULL, 'SERINE INCORPORATOR', NULL, NULL, 884, 8),
(238645, NULL, 'PTHR24317', NULL, NULL, NULL, NULL, 'PEROXISOMAL TRANS-2-ENOYL-COA REDUCTASE', NULL, NULL, NULL, 8),
(238646, NULL, 'PTHR39136', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN 11', NULL, NULL, 32978, 8),
(238647, NULL, 'PTHR37211', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(238648, NULL, 'PTHR12728', NULL, NULL, NULL, NULL, 'BRIX DOMAIN CONTAINING PROTEIN', NULL, NULL, 27206, 8),
(238649, NULL, 'PTHR47600', NULL, NULL, NULL, NULL, 'NUCLEIC ACID-BINDING, OB-FOLD-LIKE PROTEIN', NULL, NULL, NULL, 8),
(238650, NULL, 'PTHR37710', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(238651, NULL, 'PTHR16477', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 106', NULL, NULL, 23832, 8),
(238652, NULL, 'PTHR23405', NULL, NULL, NULL, NULL, 'MAINTENANCE OF KILLER 16  MAK16  PROTEIN-RELATED', NULL, NULL, NULL, 8),
(238653, NULL, 'PTHR45910', NULL, NULL, NULL, NULL, 'N-ALPHA-ACETYLTRANSFERASE 20', NULL, NULL, NULL, 8),
(238654, NULL, 'PTHR39405', NULL, NULL, NULL, NULL, 'DSC E3 UBIQUITIN LIGASE COMPLEX SUBUNIT 4', NULL, NULL, 29319, 8),
(238655, NULL, 'PTHR31935', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 13', NULL, NULL, 27021, 8),
(238656, NULL, 'PTHR33873', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR VOZ1', NULL, NULL, 30614, 8),
(238657, NULL, 'PTHR39324', NULL, NULL, NULL, NULL, 'CALCIUM DODECIN', NULL, NULL, 8377, 8),
(238658, NULL, 'PTHR32027', NULL, NULL, NULL, NULL, 'CYTOSINE DEAMINASE', NULL, NULL, NULL, 8),
(238659, NULL, 'PTHR46559', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE NON-RECEPTOR TYPE 11', NULL, NULL, NULL, 8),
(238660, NULL, 'PTHR33054', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(238661, NULL, 'PTHR30268', NULL, NULL, NULL, NULL, 'L-RHAMNOSE ISOMERASE', NULL, NULL, NULL, 8),
(238662, NULL, 'PTHR16105', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 36531, 8),
(238663, NULL, 'PTHR11843', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S12', NULL, NULL, 5896, 8),
(238664, NULL, 'PTHR14819', NULL, NULL, NULL, NULL, 'GTP-BINDING', NULL, NULL, NULL, 8),
(238665, NULL, 'PTHR36128', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 117', NULL, NULL, 25564, 8),
(238666, NULL, 'PTHR33603', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', NULL, NULL, 4425, 8),
(238667, NULL, 'PTHR14552', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(238668, NULL, 'PTHR43396', NULL, NULL, NULL, NULL, 'FLAVOHEMOPROTEIN', NULL, NULL, NULL, 8),
(238669, NULL, 'PTHR25952', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(238670, NULL, 'PTHR33963', NULL, NULL, NULL, NULL, 'MKRN2 OPPOSITE STRAND PROTEIN', NULL, NULL, 25861, 8),
(238671, NULL, 'PTHR15725', NULL, NULL, NULL, NULL, 'ZN-FINGER, C-X8-C-X5-C-X3-H TYPE-CONTAINING', NULL, NULL, NULL, 8),
(238672, NULL, 'PTHR21583', NULL, NULL, NULL, NULL, 'ELYS PROTEIN', NULL, NULL, NULL, 8),
(238673, NULL, 'PTHR38429', NULL, NULL, NULL, NULL, 'SEPTATION PROTEIN SPOVG-RELATED', NULL, NULL, 447, 8),
(238674, NULL, 'PTHR12191', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 39', NULL, NULL, NULL, 8),
(238675, NULL, 'PTHR15052', NULL, NULL, NULL, NULL, 'RNA POLYMERASE III TRANSCRIPTION INITIATION FACTOR COMPLEX SUBUNIT', NULL, NULL, NULL, 8),
(238676, NULL, 'PTHR37376', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(238677, NULL, 'PTHR15905', NULL, NULL, NULL, NULL, 'GOLGI-ASSOCIATED KINASE 1B-RELATED', NULL, NULL, 26968, 8),
(238678, NULL, 'PTHR46779', NULL, NULL, NULL, NULL, 'BETA-1,6-GALACTOSYLTRANSFERASE GALT29A', NULL, NULL, NULL, 8);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(238679, NULL, 'PTHR22633', NULL, NULL, NULL, NULL, 'NEURONAL TYROSINE-PHOSPHORYLATED PHOSPHOINOSITIDE-3-KINASE ADAPTER 2-RELATED', NULL, NULL, 21993, 8),
(238680, NULL, 'PTHR48128', NULL, NULL, NULL, NULL, 'REPELLENT PROTEIN 1', NULL, NULL, NULL, 8),
(238681, NULL, 'PTHR42933', NULL, NULL, NULL, NULL, 'SLR6095 PROTEIN', NULL, NULL, NULL, 8),
(238682, NULL, 'PTHR13610', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 23131, 8),
(238683, NULL, 'PTHR38839', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR WHID-RELATED', NULL, NULL, 6433, 8),
(238684, NULL, 'PTHR11383', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE-LINKED MOIETY X MOTIF 13', NULL, NULL, NULL, 8),
(238685, NULL, 'PTHR38398', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(238686, NULL, 'PTHR37411', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(238687, NULL, 'PTHR12694', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIA SUBUNIT 1', NULL, NULL, 7318, 8),
(238688, NULL, 'PTHR43499', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER I FAMILY MEMBER 1', NULL, NULL, 6931, 8),
(238689, NULL, 'PTHR37318', NULL, NULL, NULL, NULL, 'BSL7504 PROTEIN', NULL, NULL, NULL, 8),
(238690, NULL, 'PTHR40032', NULL, NULL, NULL, NULL, 'EXPORTED PROTEIN-RELATED', NULL, NULL, NULL, 8),
(238691, NULL, 'PTHR34584', NULL, NULL, NULL, NULL, 'NA(+)/H(+) ANTIPORTER SUBUNIT E1', NULL, NULL, 4372, 8),
(238692, NULL, 'PTHR11844', NULL, NULL, NULL, NULL, 'METALLOPROTEASE INHIBITOR', NULL, NULL, 4440, 8),
(238693, NULL, 'PTHR40788', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(238694, NULL, 'PTHR45670', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIP12', NULL, NULL, 37163, 8),
(238695, NULL, 'PTHR36733', NULL, NULL, NULL, NULL, 'CELL WALL PROTEIN-RELATED', NULL, NULL, 3796, 8),
(238696, NULL, 'PTHR31525', NULL, NULL, NULL, NULL, 'HEME TRANSPORTER HRG1', NULL, NULL, 26185, 8),
(238697, NULL, 'PTHR33345', NULL, NULL, NULL, NULL, 'ADAPTER PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(238698, NULL, 'PTHR15876', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN ADIPOCYTE-ASSOCIATED 1', NULL, NULL, 19167, 8),
(238699, NULL, 'PTHR34921', NULL, NULL, NULL, NULL, 'MEIOTIC RECOMBINATION PROTEIN REC114', NULL, NULL, 21919, 8),
(238700, NULL, 'PTHR15901', NULL, NULL, NULL, NULL, 'TESTICULAR HAPLOID EXPRESSED GENE PROTEIN', NULL, NULL, 37246, 8),
(238701, NULL, 'PTHR23318', NULL, NULL, NULL, NULL, 'ATP SYNTHASE GAMMA-RELATED', NULL, NULL, NULL, 8),
(238702, NULL, 'PTHR33788', NULL, NULL, NULL, NULL, 'OS07G0114300 PROTEIN', NULL, NULL, 28448, 8),
(238703, NULL, 'PTHR40761', NULL, NULL, NULL, NULL, 'CONSERVED INTEGRAL MEMBRANE ALANINE VALINE AND LEUCINE RICH PROTEIN-RELATED', NULL, NULL, NULL, 8),
(238704, NULL, 'PTHR34441', NULL, NULL, NULL, NULL, 'MOTILE SPERM DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, 32769, 8),
(238705, NULL, 'PTHR46484', NULL, NULL, NULL, NULL, 'SI:CH211-171H4.5-RELATED', NULL, NULL, NULL, 8),
(238706, NULL, 'PTHR31215', NULL, NULL, NULL, NULL, 'OS05G0510400 PROTEIN-RELATED', NULL, NULL, 36397, 8),
(238707, NULL, 'PTHR36814', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I REACTION CENTER SUBUNIT N, CHLOROPLASTIC', NULL, NULL, 13736, 8),
(238708, NULL, 'PTHR35271', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, SUBSTRATE-BINDING LIPOPROTEIN-RELATED', NULL, NULL, 10094, 8),
(238709, NULL, 'PTHR13025', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN D', NULL, NULL, 31395, 8),
(238710, NULL, 'PTHR45676', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL51-RELATED', NULL, NULL, 34161, 8),
(238711, NULL, 'PTHR15060', NULL, NULL, NULL, NULL, 'INTERLEUKIN-15 RECEPTOR SUBUNIT ALPHA', NULL, NULL, 37299, 8),
(238712, NULL, 'PTHR16520', NULL, NULL, NULL, NULL, 'KINETOCHORE SCAFFOLD 1', NULL, NULL, 29316, 8),
(238713, NULL, 'PTHR28057', NULL, NULL, NULL, NULL, 'PROTEIN IFH1-RELATED', NULL, NULL, 20067, 8),
(238714, NULL, 'PTHR36748', NULL, NULL, NULL, NULL, 'MENTAL RETARDATION GTPASE ACTIVATING PROTEIN', NULL, NULL, NULL, 8),
(238715, NULL, 'PTHR20851', NULL, NULL, NULL, NULL, 'DORSAL INTERACTING PROTEIN 3', NULL, NULL, NULL, 8);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(238716, NULL, 'PTHR10641', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR', NULL, NULL, NULL, 8),
(238717, NULL, 'PTHR47816', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA SMALL SUBUNIT METHYLTRANSFERASE C', NULL, NULL, NULL, 8),
(238718, NULL, 'PTHR39441', NULL, NULL, NULL, NULL, '', NULL, NULL, 17231, 8),
(238719, NULL, 'PTHR33285', NULL, NULL, NULL, NULL, 'PHYTOSULFOKINES 3', NULL, NULL, 8334, 8),
(238720, NULL, 'PTHR13343', NULL, NULL, NULL, NULL, 'CREG1 PROTEIN', NULL, NULL, NULL, 8),
(238721, NULL, 'PTHR35499', NULL, NULL, NULL, NULL, 'OS05G0128300 PROTEIN', NULL, NULL, NULL, 8),
(238722, NULL, 'PTHR38043', NULL, NULL, NULL, NULL, 'PROTEIN HEMX', NULL, NULL, 4893, 8),
(238723, NULL, 'PTHR33975', NULL, NULL, NULL, NULL, 'MYELIN-ASSOCIATED OLIGODENDROCYTE BASIC PROTEIN', NULL, NULL, NULL, 8),
(238724, NULL, 'PTHR22948', NULL, NULL, NULL, NULL, 'TUDOR DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(238725, NULL, 'PTHR33181', NULL, NULL, NULL, NULL, 'OS01G0778500 PROTEIN', NULL, NULL, NULL, 8),
(238726, NULL, 'PTHR31064', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORT PROTEIN DDB_G0292412-RELATED', NULL, NULL, NULL, 8),
(238727, NULL, 'PTHR45290', NULL, NULL, NULL, NULL, 'OS03G0300300 PROTEIN', NULL, NULL, NULL, 8),
(238728, NULL, 'PTHR33227', NULL, NULL, NULL, NULL, 'STIGMA-SPECIFIC STIG1-LIKE PROTEIN 3', NULL, NULL, 5643, 8),
(238729, NULL, 'PTHR12780', NULL, NULL, NULL, NULL, 'RNA POLYMERASE III  DNA DIRECTED , 39KD SUBUNIT-RELATED', NULL, NULL, 7990, 8),
(238730, NULL, 'PTHR13627', NULL, NULL, NULL, NULL, 'FUKUTIN RELATED PROTEIN', NULL, NULL, NULL, 8),
(238731, NULL, 'PTHR31272', NULL, NULL, NULL, NULL, 'CYTOCHROME C-TYPE BIOGENESIS PROTEIN HI_1454-RELATED', NULL, NULL, NULL, 8),
(238732, NULL, 'PTHR46975', NULL, NULL, NULL, NULL, 'PROTEIN SWEETIE', NULL, NULL, 34854, 8),
(238733, NULL, 'PTHR42655', NULL, NULL, NULL, NULL, 'GLYCOGEN PHOSPHORYLASE', NULL, NULL, NULL, 8),
(238734, NULL, 'PTHR30429', NULL, NULL, NULL, NULL, 'D-METHIONINE-BINDING LIPOPROTEIN METQ', NULL, NULL, 7183, 8),
(238735, NULL, 'PTHR48190', NULL, NULL, NULL, NULL, 'PROGRAMMED CELL DEATH PROTEIN 7', NULL, NULL, NULL, 8),
(238736, NULL, 'PTHR21098', NULL, NULL, NULL, NULL, 'RIBOFLAVIN SYNTHASE ALPHA CHAIN', NULL, NULL, 4430, 8),
(238737, NULL, 'PTHR47740', NULL, NULL, NULL, NULL, 'LCK-INTERACTING TRANSMEMBRANE ADAPTER 1, LIME1', NULL, NULL, 21764, 8),
(238738, NULL, 'PTHR33915', NULL, NULL, NULL, NULL, 'OSJNBA0033G05.11 PROTEIN', NULL, NULL, NULL, 8),
(238739, NULL, 'PTHR14741', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE-DEPENDENT METHYLTRANSFERASE RELATED', NULL, NULL, NULL, 8),
(238740, NULL, 'PTHR36072', NULL, NULL, NULL, NULL, 'OS01G0541600 PROTEIN', NULL, NULL, NULL, 8),
(238741, NULL, 'PTHR13381', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II HOLOENZYME COMPONENT SRB7', NULL, NULL, 18176, 8),
(238742, NULL, 'PTHR11571', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE', NULL, NULL, NULL, 8),
(238743, NULL, 'PTHR46456', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RAD51 HOMOLOG 2', NULL, NULL, 26899, 8),
(238744, NULL, 'PTHR15314', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P PROTEIN SUBUNIT P20', NULL, NULL, 8341, 8),
(238745, NULL, 'PTHR11884', NULL, NULL, NULL, NULL, 'SELECTIN LIGAND RELATED', NULL, NULL, 33034, 8),
(238746, NULL, 'PTHR31019', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 21465, 8),
(238747, NULL, 'PTHR46075', NULL, NULL, NULL, NULL, 'CHIMERIN FAMILY MEMBER', NULL, NULL, NULL, 8),
(238748, NULL, 'PTHR11257', NULL, NULL, NULL, NULL, 'CHEMOSENSORY PROTEIN-RELATED', NULL, NULL, 2222, 8),
(238749, NULL, 'PTHR14014', NULL, NULL, NULL, NULL, 'TELOMERE REPEATS-BINDING BOUQUET FORMATION PROTEIN 1', NULL, NULL, 36945, 8),
(238750, NULL, 'PTHR46541', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN AEBP2', NULL, NULL, NULL, 8),
(238751, NULL, 'PTHR47789', NULL, NULL, NULL, NULL, 'LAS SEVENTEEN-BINDING PROTEIN 5', NULL, NULL, 34405, 8),
(238752, NULL, 'PTHR36706', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', NULL, NULL, NULL, 8),
(238753, NULL, 'PTHR11601', NULL, NULL, NULL, NULL, 'CYSTEINE DESULFURYLASE FAMILY MEMBER', NULL, NULL, NULL, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(238754, NULL, 'PTHR10068', NULL, NULL, NULL, NULL, 'BONE MARROW PROTEOGLYCAN', NULL, NULL, NULL, 8),
(238755, NULL, 'PTHR10168', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN', NULL, NULL, 12443, 8),
(238756, NULL, 'PTHR31088', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED PROTEIN VIPP1, CHLOROPLASTIC', NULL, NULL, 30, 8),
(238757, NULL, 'PTHR34124', NULL, NULL, NULL, NULL, 'F16B3.27 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(238758, NULL, 'PTHR10160', NULL, NULL, NULL, NULL, 'NAD(P) TRANSHYDROGENASE', NULL, NULL, NULL, 8),
(238759, NULL, 'PTHR12499', NULL, NULL, NULL, NULL, 'OPTIC ATROPHY 3 PROTEIN  OPA3', NULL, NULL, 9704, 8),
(238760, NULL, 'PTHR34205', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(238761, NULL, 'PTHR23070', NULL, NULL, NULL, NULL, 'BCS1 AAA-TYPE ATPASE', NULL, NULL, NULL, 8),
(238762, NULL, 'PTHR11773', NULL, NULL, NULL, NULL, 'GLYCINE DEHYDROGENASE, DECARBOXYLATING', NULL, NULL, 19057, 8),
(238763, NULL, 'PTHR26454', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', NULL, NULL, NULL, 8),
(238764, NULL, 'PTHR35275', NULL, NULL, NULL, NULL, 'ZCF37', NULL, NULL, 37273, 8),
(238765, NULL, 'PTHR36112', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA SMALL SUBUNIT METHYLTRANSFERASE J', NULL, NULL, 10595, 8),
(238766, NULL, 'PTHR43575', NULL, NULL, NULL, NULL, 'PROTEIN ABCI7, CHLOROPLASTIC', NULL, NULL, 12144, 8),
(238767, NULL, 'PTHR43755', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(238768, NULL, 'PTHR31278', NULL, NULL, NULL, NULL, 'CHCHD1', NULL, NULL, 31399, 8),
(238769, NULL, 'PTHR14919', NULL, NULL, NULL, NULL, 'KPL2-RELATED', NULL, NULL, NULL, 8),
(238770, NULL, 'PTHR43510', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE FUNCTION, HYPOTHETICAL (EUROFUNG)', NULL, NULL, NULL, 8),
(238771, NULL, 'PTHR34778', NULL, NULL, NULL, NULL, 'OS02G0580700 PROTEIN', NULL, NULL, NULL, 8),
(238772, NULL, 'PTHR13674', NULL, NULL, NULL, NULL, 'GROWTH AND TRANSFORMATION-DEPENDENT PROTEIN', NULL, NULL, 8463, 8),
(238773, NULL, 'PTHR46178', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR', NULL, NULL, NULL, 8),
(238774, NULL, 'PTHR14879', NULL, NULL, NULL, NULL, 'CASPASE REGULATOR, RING FINGER DOMAIN-CONTAINING', NULL, NULL, NULL, 8),
(238775, NULL, 'PTHR37576', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(238776, NULL, 'PTHR33930', NULL, NULL, NULL, NULL, 'ALKYL HYDROPEROXIDE REDUCTASE AHPD', NULL, NULL, NULL, 8),
(238777, NULL, 'PTHR46892', NULL, NULL, NULL, NULL, 'VISUAL SYSTEM HOMEOBOX 2', NULL, NULL, NULL, 8),
(238778, NULL, 'PTHR31633', NULL, NULL, NULL, NULL, 'H/ACA RIBONUCLEOPROTEIN COMPLEX NON-CORE SUBUNIT NAF1', NULL, NULL, 31385, 8),
(238779, NULL, 'PTHR37325', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE 21 KDA SUBUNIT, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G05910)-RELATED', NULL, NULL, 15454, 8),
(238780, NULL, 'PTHR34378', NULL, NULL, NULL, NULL, 'GLUTAMATE--CYSTEINE LIGASE, CHLOROPLASTIC', NULL, NULL, 29799, 8),
(238781, NULL, 'PTHR12561', NULL, NULL, NULL, NULL, 'LIPOATE-PROTEIN LIGASE', NULL, NULL, 876, 8),
(238782, NULL, 'PTHR17384', NULL, NULL, NULL, NULL, 'P-SELECTIN GLYCOPROTEIN LIGAND-1', NULL, NULL, 25202, 8),
(238783, NULL, 'PTHR46136', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GTE8', NULL, NULL, NULL, 8),
(238784, NULL, 'PTHR32080', NULL, NULL, NULL, NULL, 'ANTIFUNGAL PROTEIN GINKBILOBIN-2-LIKE', NULL, NULL, NULL, 8),
(238785, NULL, 'PTHR21102', NULL, NULL, NULL, NULL, 'OPALIN', NULL, NULL, 22441, 8),
(238786, NULL, 'PTHR43446', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(238787, NULL, 'PTHR10613', NULL, NULL, NULL, NULL, 'LEUKOCYTE SURFACE ANTIGEN CD47', NULL, NULL, 2416, 8),
(238788, NULL, 'PTHR31619', NULL, NULL, NULL, NULL, '4-HYDROXY-3-METHYLBUT-2-ENYL DIPHOSPHATE REDUCTASE, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(238789, NULL, 'PTHR37346', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 19', NULL, NULL, 23338, 8),
(238790, NULL, 'PTHR47252', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', NULL, NULL, NULL, 8),
(238791, NULL, 'PTHR38530', NULL, NULL, NULL, NULL, 'OS06G0468300 PROTEIN', NULL, NULL, NULL, 8),
(238792, NULL, 'PTHR47719', NULL, NULL, NULL, NULL, 'SKP1-INTERACTING PARTNER 15', NULL, NULL, NULL, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(238793, NULL, 'PTHR11407', NULL, NULL, NULL, NULL, 'LYSOZYME C', NULL, NULL, 4337, 8),
(238794, NULL, 'PTHR43188', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A OXIDASE', NULL, NULL, 34623, 8),
(238795, NULL, 'PTHR43629', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', NULL, NULL, NULL, 8),
(238796, NULL, 'PTHR47151', NULL, NULL, NULL, NULL, 'LEU/ILE/VAL-BINDING ABC TRANSPORTER SUBUNIT', NULL, NULL, NULL, 8),
(238797, NULL, 'PTHR39961', NULL, NULL, NULL, NULL, 'HYPOTHETICAL CYTOSOLIC PROTEIN', NULL, NULL, 3837, 8),
(238798, NULL, 'PTHR46756', NULL, NULL, NULL, NULL, 'TRANSGELIN', NULL, NULL, NULL, 8),
(238799, NULL, 'PTHR31232', NULL, NULL, NULL, NULL, '', NULL, NULL, 7674, 8),
(238800, NULL, 'PTHR35990', NULL, NULL, NULL, NULL, 'GAG1AT PROTEIN', NULL, NULL, NULL, 8),
(238801, NULL, 'PTHR11903', NULL, NULL, NULL, NULL, 'PROSTAGLANDIN G/H SYNTHASE', NULL, NULL, NULL, 8),
(238802, NULL, 'PTHR32248', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA-54 FACTOR', NULL, NULL, 4668, 8),
(238803, NULL, 'PTHR33481', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE', NULL, NULL, NULL, 8),
(238804, NULL, 'PTHR43447', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE', NULL, NULL, NULL, 8),
(238805, NULL, 'PTHR12224', NULL, NULL, NULL, NULL, 'BETA-1,4-MANNOSYL-GLYCOPROTEIN BETA-1,4-N-ACETYLGLUCOSAMINYL-TRANSFERASE', NULL, NULL, 3674, 8),
(238806, NULL, 'PTHR21433', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN INDUCED BY TUMOR NECROSIS FACTOR ALPHA', NULL, NULL, 7594, 8),
(238807, NULL, 'PTHR46836', NULL, NULL, NULL, NULL, 'AFADIN', NULL, NULL, NULL, 8),
(238808, NULL, 'PTHR28457', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 189', NULL, NULL, 26160, 8),
(238809, NULL, 'PTHR40278', NULL, NULL, NULL, NULL, 'DNA UTILIZATION PROTEIN HOFN', NULL, NULL, NULL, 8),
(238810, NULL, 'PTHR35760', NULL, NULL, NULL, NULL, 'SI:CH211-22I13.2', NULL, NULL, NULL, 8),
(238811, NULL, 'PTHR43125', NULL, NULL, NULL, NULL, 'INOSITOL-3-PHOSPHATE SYNTHASE', NULL, NULL, NULL, 8),
(238812, NULL, 'PTHR15417', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE INHIBITOR AND DOPAMINE- AND CAMP-REGULATED NEURONAL PHOSPHOPROTEIN', NULL, NULL, 12053, 8),
(238813, NULL, 'PTHR32182', NULL, NULL, NULL, NULL, 'DNA REPLICATION AND REPAIR PROTEIN RECF', NULL, NULL, NULL, 8),
(238814, NULL, 'PTHR42878', NULL, NULL, NULL, NULL, 'TWO-COMPONENT HISTIDINE KINASE', NULL, NULL, NULL, 8),
(238815, NULL, 'PTHR47214', NULL, NULL, NULL, NULL, 'PROTEIN ROUGH SHEATH 2 HOMOLOG', NULL, NULL, NULL, 8),
(238816, NULL, 'PTHR12616', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING VPS41', NULL, NULL, 34455, 8),
(238817, NULL, 'PTHR40641', NULL, NULL, NULL, NULL, 'INVOLUCRIN REPEAT PROTEIN (AFU_ORTHOLOGUE AFUA_2G08060)', NULL, NULL, NULL, 8),
(238818, NULL, 'PTHR14351', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC SERINE KINASE SUBSTRATE', NULL, NULL, 22102, 8),
(238819, NULL, 'PTHR22846', NULL, NULL, NULL, NULL, 'WD40 REPEAT PROTEIN', NULL, NULL, 34359, 8),
(238820, NULL, 'PTHR31050', NULL, NULL, NULL, NULL, 'OS08G0413200 PROTEIN', NULL, NULL, NULL, 8),
(238821, NULL, 'PTHR13094', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE PDSW SUBUNIT', NULL, NULL, 30483, 8),
(238822, NULL, 'PTHR30524', NULL, NULL, NULL, NULL, 'MANNITOL-1-PHOSPHATE 5-DEHYDROGENASE', NULL, NULL, NULL, 8),
(238823, NULL, 'PTHR46650', NULL, NULL, NULL, NULL, 'PEROXISOMAL ADENINE NUCLEOTIDE TRANSPORTER 1', NULL, NULL, 34579, 8),
(238824, NULL, 'PTHR44068', NULL, NULL, NULL, NULL, 'ZGC:194242', NULL, NULL, NULL, 8),
(238825, NULL, 'PTHR19961', NULL, NULL, NULL, NULL, 'FIMBRIN/PLASTIN', NULL, NULL, 31289, 8),
(238826, NULL, 'PTHR46153', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN', NULL, NULL, 34880, 8),
(238827, NULL, 'PTHR20957', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 33943, 8),
(238828, NULL, 'PTHR46047', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE NON-RECEPTOR TYPE 61F', NULL, NULL, NULL, 8),
(238829, NULL, 'PTHR15032', NULL, NULL, NULL, NULL, 'N-ACYL-PHOSPHATIDYLETHANOLAMINE-HYDROLYZING PHOSPHOLIPASE D', NULL, NULL, NULL, 8),
(238830, NULL, 'PTHR46315', NULL, NULL, NULL, NULL, 'SPERMINE SYNTHASE', NULL, NULL, 9535, 8);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(238831, NULL, 'PTHR45270', NULL, NULL, NULL, NULL, 'OS03G0832900 PROTEIN', NULL, NULL, NULL, 8),
(238832, NULL, 'PTHR13205', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 15-RELATED', NULL, NULL, 25289, 8),
(238833, NULL, 'PTHR14416', NULL, NULL, NULL, NULL, 'PROTEIN NJMU-R1', NULL, NULL, 26663, 8),
(238834, NULL, 'PTHR12706', NULL, NULL, NULL, NULL, 'STRAWBERRY NOTCH-RELATED', NULL, NULL, 25662, 8),
(238835, NULL, 'PTHR33562', NULL, NULL, NULL, NULL, 'ATILLA, ISOFORM B-RELATED-RELATED', NULL, NULL, NULL, 8),
(238836, NULL, 'PTHR11264', NULL, NULL, NULL, NULL, 'URACIL-DNA GLYCOSYLASE', NULL, NULL, 1399, 8),
(238837, NULL, 'PTHR12859', NULL, NULL, NULL, NULL, 'PRA1 PROTEIN', NULL, NULL, 90, 8),
(238838, NULL, 'PTHR24054', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT ALPHA', NULL, NULL, 36206, 8),
(238839, NULL, 'PTHR35094', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT EXTENSIN-LIKE PROTEIN 2', NULL, NULL, NULL, 8),
(238840, NULL, 'PTHR10918', NULL, NULL, NULL, NULL, 'HOMER', NULL, NULL, 35819, 8),
(238841, NULL, 'PTHR10372', NULL, NULL, NULL, NULL, 'PLAKOPHILLIN-RELATED', NULL, NULL, 21583, 8),
(238842, NULL, 'PTHR39640', NULL, NULL, NULL, NULL, 'VNG6129C', NULL, NULL, 12468, 8),
(238843, NULL, 'PTHR47874', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, 36963, 8),
(238844, NULL, 'PTHR35319', NULL, NULL, NULL, NULL, '', NULL, NULL, 20182, 8),
(238845, NULL, 'PTHR37245', NULL, NULL, NULL, NULL, 'PAMP-INDUCED SECRETED PEPTIDE 1', NULL, NULL, 27278, 8),
(238846, NULL, 'PTHR33198', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(238847, NULL, 'PTHR34048', NULL, NULL, NULL, NULL, 'LOW-DENSITY RECEPTOR-LIKE PROTEIN', NULL, NULL, 27973, 8),
(238848, NULL, 'PTHR24161', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(238849, NULL, 'PTHR33705', NULL, NULL, NULL, NULL, 'PHOSPHOCARRIER PROTEIN HPR', NULL, NULL, NULL, 8),
(238850, NULL, 'PTHR34726', NULL, NULL, NULL, NULL, 'GBP DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(238851, NULL, 'PTHR31005', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 11006, 8),
(238852, NULL, 'PTHR31983', NULL, NULL, NULL, NULL, 'ENDO-1,3(4)-BETA-GLUCANASE 1', NULL, NULL, 5368, 8),
(238853, NULL, 'PTHR45663', NULL, NULL, NULL, NULL, 'GEO12009P1', NULL, NULL, NULL, 8),
(238854, NULL, 'PTHR37951', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', NULL, NULL, 18097, 8),
(238855, NULL, 'PTHR47660', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR WITH C2H2 AND ZN(2)-CYS(6) DNA BINDING DOMAIN (EUROFUNG)-RELATED-RELATED', NULL, NULL, NULL, 8),
(238856, NULL, 'PTHR34979', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YGAZ', NULL, NULL, 12766, 8),
(238857, NULL, 'PTHR48178', NULL, NULL, NULL, NULL, 'PEROXISOME BIOGENESIS FACTOR 2', NULL, NULL, NULL, 8),
(238858, NULL, 'PTHR13558', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 28293, 8),
(238859, NULL, 'PTHR37391', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE', NULL, NULL, NULL, 8),
(238860, NULL, 'PTHR34481', NULL, NULL, NULL, NULL, 'TRYPSIN/FACTOR XIIA INHIBITOR-RELATED', NULL, NULL, NULL, 8),
(238861, NULL, 'PTHR22990', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN', NULL, NULL, NULL, 8),
(238862, NULL, 'PTHR10800', NULL, NULL, NULL, NULL, 'PULMONARY SURFACTANT-ASSOCIATED PROTEIN C', NULL, NULL, 3424, 8),
(238863, NULL, 'PTHR40467', NULL, NULL, NULL, NULL, '', NULL, NULL, 28823, 8),
(238864, NULL, 'PTHR30522', NULL, NULL, NULL, NULL, 'NUCLEOSIDE TRIPHOSPHATE PYROPHOSPHOHYDROLASE', NULL, NULL, 10169, 8),
(238865, NULL, 'PTHR10921', NULL, NULL, NULL, NULL, 'NUCLEAR DISTRIBUTION PROTEIN NUDE HOMOLOG 1', NULL, NULL, 30980, 8),
(238866, NULL, 'PTHR47232', NULL, NULL, NULL, NULL, 'TRANSDUCIN FAMILY PROTEIN / WD-40 REPEAT FAMILY PROTEIN', NULL, NULL, NULL, 8),
(238867, NULL, 'PTHR35993', NULL, NULL, NULL, NULL, 'OUTER ENVELOPE PORE PROTEIN 21B, CHLOROPLASTIC', NULL, NULL, 4721, 8),
(238868, NULL, 'PTHR42685', NULL, NULL, NULL, NULL, 'GERANYLGERANYL DIPHOSPHATE REDUCTASE', NULL, NULL, NULL, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(238869, NULL, 'PTHR17097', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE KFYI SUBUNIT', NULL, NULL, 25168, 8),
(238870, NULL, 'PTHR47272', NULL, NULL, NULL, NULL, 'DDE_TNP_1_7 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(238871, NULL, 'PTHR10098', NULL, NULL, NULL, NULL, 'RAPSYN-RELATED', NULL, NULL, NULL, 8),
(238872, NULL, 'PTHR32411', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH REPEAT SECRETORY PROTEIN 38-RELATED', NULL, NULL, NULL, 8),
(238873, NULL, 'PTHR37383', NULL, NULL, NULL, NULL, 'OS01G0694200 PROTEIN', NULL, NULL, NULL, 8),
(238874, NULL, 'PTHR34060', NULL, NULL, NULL, NULL, 'POLYKETIDE CYCLASE / DEHYDRASE AND LIPID TRANSPORT PROTEIN', NULL, NULL, NULL, 8),
(238875, NULL, 'PTHR42814', NULL, NULL, NULL, NULL, 'AMP-BINDING DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(238876, NULL, 'PTHR28173', NULL, NULL, NULL, NULL, 'RIBONUCLEASES P/MRP PROTEIN SUBUNIT POP8', NULL, NULL, 19542, 8),
(238877, NULL, 'PTHR41260', NULL, NULL, NULL, NULL, 'PROTEIN ECSC', NULL, NULL, 23542, 8),
(238878, NULL, 'PTHR47246', NULL, NULL, NULL, NULL, 'MUCIN-19', NULL, NULL, NULL, 8),
(238879, NULL, 'PTHR11649', NULL, NULL, NULL, NULL, 'MSS1/TRME-RELATED GTP-BINDING PROTEIN', NULL, NULL, NULL, 8),
(238880, NULL, 'PTHR33710', NULL, NULL, NULL, NULL, 'BNAC02G09200D PROTEIN', NULL, NULL, NULL, 8),
(238881, NULL, 'PTHR31250', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN IQM3', NULL, NULL, 35218, 8),
(238882, NULL, 'PTHR16524', NULL, NULL, NULL, NULL, 'CELL DEATH REGULATOR AVEN', NULL, NULL, 25392, 8),
(238883, NULL, 'PTHR28523', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY FACTOR 1', NULL, NULL, 36528, 8),
(238884, NULL, 'PTHR13410', NULL, NULL, NULL, NULL, 'PROTEIN PBDC1', NULL, NULL, 12104, 8),
(238885, NULL, 'PTHR32142', NULL, NULL, NULL, NULL, 'B BOX-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(238886, NULL, 'PTHR46414', NULL, NULL, NULL, NULL, 'PROTEIN BHLHB9-RELATED', NULL, NULL, 34846, 8),
(238887, NULL, 'PTHR45431', NULL, NULL, NULL, NULL, 'RHODANESE-LIKE DOMAIN-CONTAINING PROTEIN 15, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(238888, NULL, 'PTHR23266', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN HEAVY CHAIN', NULL, NULL, NULL, 8),
(238889, NULL, 'PTHR34562', NULL, NULL, NULL, NULL, 'WPP DOMAIN-INTERACTING PROTEIN 2', NULL, NULL, 36141, 8),
(238890, NULL, 'PTHR10622', NULL, NULL, NULL, NULL, 'HET DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(238891, NULL, 'PTHR12612', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSPORT FACTOR 2', NULL, NULL, 36153, 8),
(238892, NULL, 'PTHR36804', NULL, NULL, NULL, NULL, 'OSJNBA0013K16.11 PROTEIN', NULL, NULL, NULL, 8),
(238893, NULL, 'PTHR10464', NULL, NULL, NULL, NULL, 'UREA TRANSPORTER', NULL, NULL, 1856, 8),
(238894, NULL, 'PTHR34055', NULL, NULL, NULL, NULL, 'OS09G0491596 PROTEIN', NULL, NULL, NULL, 8),
(238895, NULL, 'PTHR19846', NULL, NULL, NULL, NULL, 'WD40 REPEAT PROTEIN', NULL, NULL, NULL, 8),
(238896, NULL, 'PTHR44337', NULL, NULL, NULL, NULL, 'CARCINOEMBRYONIC ANTIGEN-RELATED CELL ADHESION MOLECULE 8', NULL, NULL, NULL, 8),
(238897, NULL, 'PTHR45436', NULL, NULL, NULL, NULL, 'SENSOR HISTIDINE KINASE YKOH', NULL, NULL, NULL, 8),
(238898, NULL, 'PTHR31694', NULL, NULL, NULL, NULL, 'DESICCATION-LIKE PROTEIN', NULL, NULL, NULL, 8),
(238899, NULL, 'PTHR47119', NULL, NULL, NULL, NULL, 'PLANT VIRAL-RESPONSE FAMILY PROTEIN', NULL, NULL, NULL, 8),
(238900, NULL, 'PTHR14865', NULL, NULL, NULL, NULL, 'CST COMPLEX SUBUNIT CTC1', NULL, NULL, 35388, 8),
(238901, NULL, 'PTHR36719', NULL, NULL, NULL, NULL, 'OS01G0676200 PROTEIN', NULL, NULL, NULL, 8),
(238902, NULL, 'PTHR46769', NULL, NULL, NULL, NULL, 'POLYCYSTIC KIDNEY AND HEPATIC DISEASE 1 (AUTOSOMAL RECESSIVE)-LIKE 1', NULL, NULL, NULL, 8),
(238903, NULL, 'PTHR13464', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR PROTEIN HCNGP', NULL, NULL, 11844, 8),
(238904, NULL, 'PTHR38355', NULL, NULL, NULL, NULL, 'OS06G0149500 PROTEIN', NULL, NULL, NULL, 8),
(238905, NULL, 'PTHR34305', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(238906, NULL, 'PTHR15446', NULL, NULL, NULL, NULL, 'UROPLAKIN III', NULL, NULL, 20679, 8);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(238907, NULL, 'PTHR32463', NULL, NULL, NULL, NULL, 'L-FUCOSE KINASE', NULL, NULL, NULL, 8),
(238908, NULL, 'PTHR47033', NULL, NULL, NULL, NULL, 'CYSTATIN-M', NULL, NULL, NULL, 8),
(238909, NULL, 'PTHR33220', NULL, NULL, NULL, NULL, 'BNAA09G04420D PROTEIN', NULL, NULL, NULL, 8),
(238910, NULL, 'PTHR11573', NULL, NULL, NULL, NULL, 'RIBONUCLEOSIDE-DIPHOSPHATE REDUCTASE LARGE CHAIN', NULL, NULL, 31231, 8),
(238911, NULL, 'PTHR43819', NULL, NULL, NULL, NULL, 'ARCHAEAL-TYPE GLUTAMATE SYNTHASE [NADPH]', NULL, NULL, NULL, 8),
(238912, NULL, 'PTHR47594', NULL, NULL, NULL, NULL, 'PPR CONTAINING PLANT-LIKE PROTEIN', NULL, NULL, 35048, 8),
(238913, NULL, 'PTHR30520', NULL, NULL, NULL, NULL, 'FORMATE TRANSPORTER-RELATED', NULL, NULL, 525, 8),
(238914, NULL, 'PTHR35533', NULL, NULL, NULL, NULL, 'CONSERVED REPEAT DOMAIN PROTEIN', NULL, NULL, NULL, 8),
(238915, NULL, 'PTHR35508', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT L-TYPE CALCIUM CHANNEL SUBUNIT', NULL, NULL, NULL, 8),
(238916, NULL, 'PTHR10356', NULL, NULL, NULL, NULL, 'ALLOGRAFT INFLAMMATORY FACTOR-1', NULL, NULL, 34045, 8),
(238917, NULL, 'PTHR23343', NULL, NULL, NULL, NULL, 'ZONA PELLUCIDA SPERM-BINDING PROTEIN', NULL, NULL, NULL, 8),
(238918, NULL, 'PTHR16116', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 839', NULL, NULL, 28516, 8),
(238919, NULL, 'PTHR21252', NULL, NULL, NULL, NULL, 'TB1 PROTEIN-RELATED', NULL, NULL, 32811, 8),
(238920, NULL, 'PTHR47820', NULL, NULL, NULL, NULL, 'BNAC05G24000D PROTEIN', NULL, NULL, NULL, 8),
(238921, NULL, 'PTHR43532', NULL, NULL, NULL, NULL, 'GLUCOSE-1-PHOSPHATE THYMIDYLYLTRANSFERASE', NULL, NULL, 232, 8),
(238922, NULL, 'PTHR30012', NULL, NULL, NULL, NULL, 'GENERAL SECRETION PATHWAY PROTEIN', NULL, NULL, 7349, 8),
(238923, NULL, 'PTHR10507', NULL, NULL, NULL, NULL, 'CDC45-RELATED PROTEIN', NULL, NULL, 4342, 8),
(238924, NULL, 'PTHR18898', NULL, NULL, NULL, NULL, 'NUCLEOPROTEIN TPR-RELATED', NULL, NULL, NULL, 8),
(238925, NULL, 'PTHR34916', NULL, NULL, NULL, NULL, 'GI:13385330', NULL, NULL, NULL, 8),
(238926, NULL, 'PTHR11240', NULL, NULL, NULL, NULL, 'RIBONUCLEASE T2', NULL, NULL, 5024, 8),
(238927, NULL, 'PTHR33589', NULL, NULL, NULL, NULL, 'OS11G0524900 PROTEIN', NULL, NULL, NULL, 8),
(238928, NULL, 'PTHR10417', NULL, NULL, NULL, NULL, 'GLUCOCORTICOID MODULATORY ELEMENT-BINDING PROTEIN', NULL, NULL, 20569, 8),
(238929, NULL, 'PTHR12675', NULL, NULL, NULL, NULL, 'MUSCLEBLIND-LIKE PROTEIN', NULL, NULL, NULL, 8),
(238930, NULL, 'PTHR47050', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 24', NULL, NULL, 21489, 8),
(238931, NULL, 'PTHR43055', NULL, NULL, NULL, NULL, 'FORMATE-DEPENDENT PHOSPHORIBOSYLGLYCINAMIDE FORMYLTRANSFERASE', NULL, NULL, NULL, 8),
(238932, NULL, 'PTHR11551', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR BINDING PROTEIN', NULL, NULL, NULL, 8),
(238933, NULL, 'PTHR23123', NULL, NULL, NULL, NULL, 'PHD/F-BOX CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(238934, NULL, 'PTHR33531', NULL, NULL, NULL, NULL, 'RUBRERYTHRIN SUBFAMILY', NULL, NULL, NULL, 8),
(238935, NULL, 'PTHR36796', NULL, NULL, NULL, NULL, 'PROTEIN KINASE SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(238936, NULL, 'PTHR39227', NULL, NULL, NULL, NULL, 'ADIPOGENESIS REGULATORY FACTOR', NULL, NULL, 2558, 8),
(238937, NULL, 'PTHR33642', NULL, NULL, NULL, NULL, 'COX1/OXI3 INTRON 1 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(238938, NULL, 'PTHR35108', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN 3, CHLOROPLASTIC', NULL, NULL, 4558, 8),
(238939, NULL, 'PTHR34658', NULL, NULL, NULL, NULL, 'OS01G0151800 PROTEIN', NULL, NULL, NULL, 8),
(238940, NULL, 'PTHR31606', NULL, NULL, NULL, NULL, 'WW DOMAIN BINDING PROTEIN 2, ISOFORM E', NULL, NULL, 34440, 8),
(238941, NULL, 'PTHR43344', NULL, NULL, NULL, NULL, 'PHOSPHOSERINE PHOSPHATASE', NULL, NULL, NULL, 8),
(238942, NULL, 'PTHR40042', NULL, NULL, NULL, NULL, 'HYPOTHETICAL MEMBRANE SPANNING PROTEIN', NULL, NULL, 13436, 8),
(238943, NULL, 'PTHR47445', NULL, NULL, NULL, NULL, 'OS08G0441400 PROTEIN', NULL, NULL, NULL, 8),
(238944, NULL, 'PTHR46462', NULL, NULL, NULL, NULL, 'UPSET, ISOFORM A', NULL, NULL, NULL, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(238945, NULL, 'PTHR12035', NULL, NULL, NULL, NULL, 'SIALIC ACID BINDING IMMUNOGLOBULIN-LIKE LECTIN', NULL, NULL, NULL, 8),
(238946, NULL, 'PTHR11839', NULL, NULL, NULL, NULL, 'UDP/ADP-SUGAR PYROPHOSPHATASE', NULL, NULL, NULL, 8),
(238947, NULL, 'PTHR37342', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC689959', NULL, NULL, 24897, 8),
(238948, NULL, 'PTHR45939', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN PMP34-RELATED', NULL, NULL, NULL, 8),
(238949, NULL, 'PTHR40758', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', NULL, NULL, NULL, 8),
(238950, NULL, 'PTHR35784', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 5', NULL, NULL, 11037, 8),
(238951, NULL, 'PTHR45743', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL AKT1', NULL, NULL, 35641, 8),
(238952, NULL, 'PTHR21047', NULL, NULL, NULL, NULL, 'DTDP-6-DEOXY-D-GLUCOSE-3,5 EPIMERASE', NULL, NULL, 353, 8),
(238953, NULL, 'PTHR38631', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(238954, NULL, 'PTHR47457', NULL, NULL, NULL, NULL, 'OS05G0345500 PROTEIN', NULL, NULL, NULL, 8),
(238955, NULL, 'PTHR10466', NULL, NULL, NULL, NULL, 'PHOSPHOMANNOMUTASE', NULL, NULL, 639, 8),
(238956, NULL, 'PTHR11626', NULL, NULL, NULL, NULL, 'FARNESYL-DIPHOSPHATE FARNESYLTRANSFERASE', NULL, NULL, 34066, 8),
(238957, NULL, 'PTHR34689', NULL, NULL, NULL, NULL, 'NUCLEIC ACID-BINDING PROTEIN', NULL, NULL, NULL, 8),
(238958, NULL, 'PTHR37875', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC685964', NULL, NULL, 32947, 8),
(238959, NULL, 'PTHR45856', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(238960, NULL, 'PTHR45134', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(238961, NULL, 'PTHR37558', NULL, NULL, NULL, NULL, 'HTH CENPB-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(238962, NULL, 'PTHR37189', NULL, NULL, NULL, NULL, 'CONCANAVALIN A-LIKE LECTIN/GLUCANASE DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(238963, NULL, 'PTHR37490', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(238964, NULL, 'PTHR15422', NULL, NULL, NULL, NULL, 'OS05G0565100 PROTEIN', NULL, NULL, 36694, 8),
(238965, NULL, 'PTHR43177', NULL, NULL, NULL, NULL, 'PROTEIN NRFC', NULL, NULL, NULL, 8),
(238966, NULL, 'PTHR11363', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L3-RELATED', NULL, NULL, 35521, 8),
(238967, NULL, 'PTHR40078', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN-RELATED', NULL, NULL, 28677, 8),
(238968, NULL, 'PTHR46757', NULL, NULL, NULL, NULL, 'SORTING NEXIN-RELATED', NULL, NULL, 34668, 8),
(238969, NULL, 'PTHR28017', NULL, NULL, NULL, NULL, 'DASH COMPLEX SUBUNIT DAD3', NULL, NULL, 7648, 8),
(238970, NULL, 'PTHR37705', NULL, NULL, NULL, NULL, 'BNAA08G11710D PROTEIN', NULL, NULL, NULL, 8),
(238971, NULL, 'PTHR21644', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 8386, 8),
(238972, NULL, 'PTHR46477', NULL, NULL, NULL, NULL, 'CYSTEINE/HISTIDINE-RICH C1 DOMAIN FAMILY PROTEIN', NULL, NULL, NULL, 8),
(238973, NULL, 'PTHR28671', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 169', NULL, NULL, 23594, 8),
(238974, NULL, 'PTHR39411', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 113', NULL, NULL, NULL, 8),
(238975, NULL, 'PTHR42678', NULL, NULL, NULL, NULL, 'AMIDASE', NULL, NULL, NULL, 8),
(238976, NULL, 'PTHR34138', NULL, NULL, NULL, NULL, 'CELL SHAPE-DETERMINING PROTEIN MREC', NULL, NULL, 6189, 8),
(238977, NULL, 'PTHR24062', NULL, NULL, NULL, NULL, 'VOMERONASAL TYPE-1 RECEPTOR', NULL, NULL, 1741, 8),
(238978, NULL, 'PTHR35378', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', NULL, NULL, NULL, 8),
(238979, NULL, 'PTHR45661', NULL, NULL, NULL, NULL, 'SURFACE ANTIGEN', NULL, NULL, NULL, 8),
(238980, NULL, 'PTHR22692', NULL, NULL, NULL, NULL, 'MYOSIN VII, XV', NULL, NULL, NULL, 8),
(238981, NULL, 'PTHR10381', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE PROTEOLYTIC SUBUNIT', NULL, NULL, 10061, 8),
(238982, NULL, 'PTHR34449', NULL, NULL, NULL, NULL, 'RHO TERMINATION FACTOR', NULL, NULL, NULL, 8),
(238983, NULL, 'PTHR46959', NULL, NULL, NULL, NULL, 'SULFOQUINOVOSIDASE', NULL, NULL, NULL, 8);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(238984, NULL, 'PTHR36577', NULL, NULL, NULL, NULL, 'DUF521 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_6G00490)', NULL, NULL, NULL, 8),
(238985, NULL, 'PTHR34818', NULL, NULL, NULL, NULL, 'PROTEIN BLI-3', NULL, NULL, NULL, 8),
(238986, NULL, 'PTHR15071', NULL, NULL, NULL, NULL, 'MANNOSE-6-PHOSPHATE RECEPTOR FAMILY MEMBER', NULL, NULL, NULL, 8),
(238987, NULL, 'PTHR13183', NULL, NULL, NULL, NULL, 'AXONEMAL INNER ARM DYNEIN LIGHT CHAIN 28', NULL, NULL, 15540, 8),
(238988, NULL, 'PTHR42713', NULL, NULL, NULL, NULL, 'HISTIDINE KINASE-RELATED', NULL, NULL, NULL, 8),
(238989, NULL, 'PTHR37748', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(238990, NULL, 'PTHR33286', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(238991, NULL, 'PTHR31682', NULL, NULL, NULL, NULL, 'UDP-ARABINOSE MUTASE', NULL, NULL, 27113, 8),
(238992, NULL, 'PTHR13814', NULL, NULL, NULL, NULL, 'FETUIN', NULL, NULL, NULL, 8),
(238993, NULL, 'PTHR39173', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE', NULL, NULL, NULL, 8),
(238994, NULL, 'PTHR21386', NULL, NULL, NULL, NULL, 'INSCUTEABLE', NULL, NULL, 32182, 8),
(238995, NULL, 'PTHR21738', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 13847, 8),
(238996, NULL, 'PTHR47289', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, PUTATIVE (DUF1664)-RELATED', NULL, NULL, NULL, 8),
(238997, NULL, 'PTHR14248', NULL, NULL, NULL, NULL, 'CYCLIN Y, ISOFORM A', NULL, NULL, NULL, 8),
(238998, NULL, 'PTHR18870', NULL, NULL, NULL, NULL, 'PROTEIN TAG-278-RELATED', NULL, NULL, 24889, 8),
(238999, NULL, 'PTHR23361', NULL, NULL, NULL, NULL, 'MUCIN', NULL, NULL, NULL, 8),
(239000, NULL, 'PTHR34452', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN-RELATED PROTEIN', NULL, NULL, NULL, 8),
(239001, NULL, 'PTHR13363', NULL, NULL, NULL, NULL, 'RING FINGER AND SRY DOMAIN-CONTAINING', NULL, NULL, 36526, 8),
(239002, NULL, 'PTHR33711', NULL, NULL, NULL, NULL, 'DIOXYGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G02910)-RELATED', NULL, NULL, NULL, 8),
(239003, NULL, 'PTHR12004', NULL, NULL, NULL, NULL, 'RELAXIN', NULL, NULL, NULL, 8),
(239004, NULL, 'PTHR10164', NULL, NULL, NULL, NULL, 'ISLET CELL AUTOANTIGEN 1', NULL, NULL, 9668, 8),
(239005, NULL, 'PTHR13186', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 31', NULL, NULL, 13542, 8),
(239006, NULL, 'PTHR12349', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND LEM DOMAIN-CONTAINING PROTEIN 2', NULL, NULL, NULL, 8),
(239007, NULL, 'PTHR33895', NULL, NULL, NULL, NULL, 'HUMANIN-LIKE 4', NULL, NULL, 23441, 8),
(239008, NULL, 'PTHR13763', NULL, NULL, NULL, NULL, 'BREAST CANCER TYPE 1 SUSCEPTIBILITY PROTEIN BRCA1', NULL, NULL, 21709, 8),
(239009, NULL, 'PTHR24302', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 3', NULL, NULL, NULL, 8),
(239010, NULL, 'PTHR14571', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(239011, NULL, 'PTHR24043', NULL, NULL, NULL, NULL, 'SCAVENGER RECEPTOR CLASS F', NULL, NULL, 35600, 8),
(239012, NULL, 'PTHR16127', NULL, NULL, NULL, NULL, 'TAXILIN', NULL, NULL, 21110, 8),
(239013, NULL, 'PTHR31768', NULL, NULL, NULL, NULL, 'B BOX-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, 27596, 8),
(239014, NULL, 'PTHR32009', NULL, NULL, NULL, NULL, 'TMV RESISTANCE PROTEIN N-LIKE', NULL, NULL, NULL, 8),
(239015, NULL, 'PTHR12801', NULL, NULL, NULL, NULL, 'RNA EXONUCLEASE REXO1 / RECO3 FAMILY MEMBER-RELATED', NULL, NULL, NULL, 8),
(239016, NULL, 'PTHR37192', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(239017, NULL, 'PTHR39235', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL N-ACETYLGLUCOSAMINYLTRANSFERASE SUBUNIT Y', NULL, NULL, NULL, 8),
(239018, NULL, 'PTHR46842', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 266', NULL, NULL, 35827, 8),
(239019, NULL, 'PTHR47247', NULL, NULL, NULL, NULL, 'KUNITZ-TYPE PROTEASE INHIBITOR 2', NULL, NULL, NULL, 8),
(239020, NULL, 'PTHR13595', NULL, NULL, NULL, NULL, 'ARL6IP4 PROTEIN', NULL, NULL, NULL, 8),
(239021, NULL, 'PTHR23161', NULL, NULL, NULL, NULL, 'PROTEIN CIP2A', NULL, NULL, 34752, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(239022, NULL, 'PTHR31944', NULL, NULL, NULL, NULL, 'HEME-RESPONSIVE ZINC FINGER TRANSCRIPTION FACTOR HAP1', NULL, NULL, NULL, 8),
(239023, NULL, 'PTHR31645', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORTER YGL114W-RELATED', NULL, NULL, 35684, 8),
(239024, NULL, 'PTHR47429', NULL, NULL, NULL, NULL, 'PROTEIN TWIN LOV 1', NULL, NULL, NULL, 8),
(239025, NULL, 'PTHR42070', NULL, NULL, NULL, NULL, 'FILAMENT ASSOCIATED PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G06630)-RELATED', NULL, NULL, NULL, 8),
(239026, NULL, 'PTHR45728', NULL, NULL, NULL, NULL, 'ACETYL-COA CARBOXYLASE, ISOFORM A', NULL, NULL, NULL, 8),
(239027, NULL, 'PTHR16631', NULL, NULL, NULL, NULL, 'GLUCAN 1,3-BETA-GLUCOSIDASE', NULL, NULL, NULL, 8),
(239028, NULL, 'PTHR34196', NULL, NULL, NULL, NULL, 'OS02G0697700 PROTEIN', NULL, NULL, NULL, 8),
(239029, NULL, 'PTHR46222', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP7/14', NULL, NULL, NULL, 8),
(239030, NULL, 'PTHR14928', NULL, NULL, NULL, NULL, 'MICRO-RNA BINDING ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 7', NULL, NULL, 28012, 8),
(239031, NULL, 'PTHR23015', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED C.ELEGANS PROTEIN', NULL, NULL, 30874, 8),
(239032, NULL, 'PTHR22779', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 14571, 8),
(239033, NULL, 'PTHR40700', NULL, NULL, NULL, NULL, 'HYPOTHETICAL MEMBRANE PROTEIN, CONSERVED, DUF63 FAMILY', NULL, NULL, 3848, 8),
(239034, NULL, 'PTHR11486', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR', NULL, NULL, 5967, 8),
(239035, NULL, 'PTHR37442', NULL, NULL, NULL, NULL, 'F18A1.7 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(239036, NULL, 'PTHR14880', NULL, NULL, NULL, NULL, 'PROLINE AND SERINE-RICH PROTEIN 1', NULL, NULL, 35392, 8),
(239037, NULL, 'PTHR45873', NULL, NULL, NULL, NULL, 'DNA POLYMERASE ETA', NULL, NULL, NULL, 8),
(239038, NULL, 'PTHR43039', NULL, NULL, NULL, NULL, 'ESTERASE-RELATED', NULL, NULL, NULL, 8),
(239039, NULL, 'PTHR47009', NULL, NULL, NULL, NULL, 'HEPATITIS A VIRUS CELLULAR RECEPTOR 1 HOMOLOG', NULL, NULL, NULL, 8),
(239040, NULL, 'PTHR38019', NULL, NULL, NULL, NULL, 'KDA ANTIGEN P200, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(239041, NULL, 'PTHR37327', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(239042, NULL, 'PTHR43675', NULL, NULL, NULL, NULL, 'ARSENITE METHYLTRANSFERASE', NULL, NULL, 21933, 8),
(239043, NULL, 'PTHR16039', NULL, NULL, NULL, NULL, 'HAUS AUGMIN-LIKE COMPLEX SUBUNIT 2', NULL, NULL, 21937, 8),
(239044, NULL, 'PTHR12415', NULL, NULL, NULL, NULL, 'TYROSYL-DNA PHOSPHODIESTERASE 1', NULL, NULL, 8807, 8),
(239045, NULL, 'PTHR46619', NULL, NULL, NULL, NULL, 'RNA RECOGNITION MOTIF XS DOMAIN PROTEIN-RELATED', NULL, NULL, NULL, 8),
(239046, NULL, 'PTHR21234', NULL, NULL, NULL, NULL, 'PURINE NUCLEOSIDE PHOSPHORYLASE', NULL, NULL, NULL, 8),
(239047, NULL, 'PTHR30514', NULL, NULL, NULL, NULL, 'GLUCOKINASE', NULL, NULL, NULL, 8),
(239048, NULL, 'PTHR10012', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT B', NULL, NULL, 4863, 8),
(239049, NULL, 'PTHR38936', NULL, NULL, NULL, NULL, 'TITIN-LIKE ISOFORM X2', NULL, NULL, NULL, 8),
(239050, NULL, 'PTHR47961', NULL, NULL, NULL, NULL, 'DNA POLYMERASE THETA, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G05260)-RELATED', NULL, NULL, NULL, 8),
(239051, NULL, 'PTHR10559', NULL, NULL, NULL, NULL, 'TRANSCOBALAMIN-1/GASTRIC INTRINSIC FACTOR', NULL, NULL, NULL, 8),
(239052, NULL, 'PTHR13952', NULL, NULL, NULL, NULL, 'U1 SMALL NUCLEAR RIBONUCLEOPROTEIN 70 KD', NULL, NULL, NULL, 8),
(239053, NULL, 'PTHR43774', NULL, NULL, NULL, NULL, 'PEPTIDE METHIONINE SULFOXIDE REDUCTASE', NULL, NULL, NULL, 8),
(239054, NULL, 'PTHR34769', NULL, NULL, NULL, NULL, 'RCG42593, ISOFORM CRA_A', NULL, NULL, 31636, 8),
(239055, NULL, 'PTHR30111', NULL, NULL, NULL, NULL, '33 KDA CHAPERONIN', NULL, NULL, 4769, 8),
(239056, NULL, 'PTHR12611', NULL, NULL, NULL, NULL, 'PUR-TRANSCRIPTIONAL ACTIVATOR', NULL, NULL, 1090, 8),
(239057, NULL, 'PTHR43017', NULL, NULL, NULL, NULL, 'GALACTOSIDE O-ACETYLTRANSFERASE', NULL, NULL, 30728, 8);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(239058, NULL, 'PTHR13605', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 32902, 8),
(239059, NULL, 'PTHR39653', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 20-2', NULL, NULL, NULL, 8),
(239060, NULL, 'PTHR36033', NULL, NULL, NULL, NULL, 'NUCLEIC ACID-BINDING PROTEINS SUPERFAMILY', NULL, NULL, NULL, 8),
(239061, NULL, 'PTHR48047', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', NULL, NULL, NULL, 8),
(239062, NULL, 'PTHR12209', NULL, NULL, NULL, NULL, 'NON-SPECIFIC SERINE/THREONINE PROTEIN KINASE', NULL, NULL, 16317, 8),
(239063, NULL, 'PTHR37533', NULL, NULL, NULL, NULL, 'FLAGELLAR HOOK-LENGTH CONTROL PROTEIN', NULL, NULL, NULL, 8),
(239064, NULL, 'PTHR21074', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 28907, 8),
(239065, NULL, 'PTHR47609', NULL, NULL, NULL, NULL, 'MICOS COMPLEX SUBUNIT MIC25', NULL, NULL, 34107, 8),
(239066, NULL, 'PTHR12509', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED 4-RELATED', NULL, NULL, NULL, 8),
(239067, NULL, 'PTHR46426', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE TMX3', NULL, NULL, NULL, 8),
(239068, NULL, 'PTHR14152', NULL, NULL, NULL, NULL, 'SQUAMOUS CELL CARCINOMA ANTIGEN RECOGNISED BY CYTOTOXIC T LYMPHOCYTES', NULL, NULL, 640, 8),
(239069, NULL, 'PTHR16260', NULL, NULL, NULL, NULL, 'SIMILAR TO 1700123O20RIK PROTEIN', NULL, NULL, 21820, 8),
(239070, NULL, 'PTHR13062', NULL, NULL, NULL, NULL, 'COLLAGENASE', NULL, NULL, NULL, 8),
(239071, NULL, 'PTHR33184', NULL, NULL, NULL, NULL, 'PROTEIN TAPETUM DETERMINANT 1-LIKE-RELATED', NULL, NULL, 28854, 8),
(239072, NULL, 'PTHR12902', NULL, NULL, NULL, NULL, 'WASP-1', NULL, NULL, 22817, 8),
(239073, NULL, 'PTHR11972', NULL, NULL, NULL, NULL, 'NADPH OXIDASE', NULL, NULL, NULL, 8),
(239074, NULL, 'PTHR40631', NULL, NULL, NULL, NULL, 'ALPHA-L-ARABINOFURANOSIDASE AXHA-2-RELATED', NULL, NULL, 6321, 8),
(239075, NULL, 'PTHR46197', NULL, NULL, NULL, NULL, 'PROTEIN ABHD14B-LIKE', NULL, NULL, NULL, 8),
(239076, NULL, 'PTHR48165', NULL, NULL, NULL, NULL, 'BNAC03G44900D PROTEIN', NULL, NULL, NULL, 8),
(239077, NULL, 'PTHR35577', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH, ACIDIC INTEGRAL MEMBRANE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(239078, NULL, 'PTHR27007', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(239079, NULL, 'PTHR11878', NULL, NULL, NULL, NULL, 'SODIUM/CALCIUM EXCHANGER', NULL, NULL, NULL, 8),
(239080, NULL, 'PTHR12233', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING 26 RELATED', NULL, NULL, 23683, 8),
(239081, NULL, 'PTHR47186', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 57', NULL, NULL, NULL, 8),
(239082, NULL, 'PTHR30065', NULL, NULL, NULL, NULL, 'FLAGELLAR BIOSYNTHETIC PROTEIN FLIR', NULL, NULL, 4685, 8),
(239083, NULL, 'PTHR38767', NULL, NULL, NULL, NULL, 'DNA POLYMERASE III SUBUNIT CHI', NULL, NULL, 4647, 8),
(239084, NULL, 'PTHR36468', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 19, MITOCHONDRIAL', NULL, NULL, 23648, 8),
(239085, NULL, 'PTHR13302', NULL, NULL, NULL, NULL, 'CONSERVED OLIGOMERIC GOLGI COMPLEX COMPONENT 3', NULL, NULL, 6947, 8),
(239086, NULL, 'PTHR30098', NULL, NULL, NULL, NULL, 'LEUCYL/PHENYLALANYL-TRNA--PROTEIN TRANSFERASE', NULL, NULL, 2216, 8),
(239087, NULL, 'PTHR31708', NULL, NULL, NULL, NULL, 'ABPBG26-RELATED', NULL, NULL, 13207, 8),
(239088, NULL, 'PTHR12178', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', NULL, NULL, 27339, 8),
(239089, NULL, 'PTHR11274', NULL, NULL, NULL, NULL, 'RAD25/XP-B DNA REPAIR HELICASE', NULL, NULL, NULL, 8),
(239090, NULL, 'PTHR45398', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(239091, NULL, 'PTHR35331', NULL, NULL, NULL, NULL, 'STAGE V SPORULATION PROTEIN S', NULL, NULL, 5987, 8),
(239092, NULL, 'PTHR37236', NULL, NULL, NULL, NULL, 'AUXIN-BINDING PROTEIN 1', NULL, NULL, 5698, 8),
(239093, NULL, 'PTHR47993', NULL, NULL, NULL, NULL, 'OS09G0372900 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(239094, NULL, 'PTHR39428', NULL, NULL, NULL, NULL, 'F420H(2)-DEPENDENT QUINONE REDUCTASE RV1261C', NULL, NULL, NULL, 8),
(239095, NULL, 'PTHR35466', NULL, NULL, NULL, NULL, 'SERINE/ARGININE REPETITIVE MATRIX PROTEIN 1', NULL, NULL, NULL, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(239096, NULL, 'PTHR47564', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH AND TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, 35351, 8),
(239097, NULL, 'PTHR46497', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN 11', NULL, NULL, NULL, 8),
(239098, NULL, 'PTHR12333', NULL, NULL, NULL, NULL, 'COMM DOMAIN CONTAINING PROTEIN 10', NULL, NULL, 32920, 8),
(239099, NULL, 'PTHR18884', NULL, NULL, NULL, NULL, 'SEPTIN', NULL, NULL, NULL, 8),
(239100, NULL, 'PTHR10361', NULL, NULL, NULL, NULL, 'SODIUM-BILE ACID COTRANSPORTER', NULL, NULL, 3461, 8),
(239101, NULL, 'PTHR47079', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING PROTEIN-LIKE', NULL, NULL, NULL, 8),
(239102, NULL, 'PTHR22624', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE ATG4', NULL, NULL, 10179, 8),
(239103, NULL, 'PTHR41307', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(239104, NULL, 'PTHR47176', NULL, NULL, NULL, NULL, 'OSJNBA0020J04.13 PROTEIN', NULL, NULL, NULL, 8),
(239105, NULL, 'PTHR34051', NULL, NULL, NULL, NULL, 'PROTEIN LOW PSII ACCUMULATION 3, CHLOROPLASTIC', NULL, NULL, 34532, 8),
(239106, NULL, 'PTHR30413', NULL, NULL, NULL, NULL, 'INNER MEMBRANE TRANSPORT PERMEASE', NULL, NULL, NULL, 8),
(239107, NULL, 'PTHR21347', NULL, NULL, NULL, NULL, 'CLEFT LIP AND PALATE ASSOCIATED TRANSMEMBRANE PROTEIN-RELATED', NULL, NULL, 8677, 8),
(239108, NULL, 'PTHR39556', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', NULL, NULL, 7372, 8),
(239109, NULL, 'PTHR21184', NULL, NULL, NULL, NULL, 'MENORIN (DENDRITIC BRANCHING PROTEIN)', NULL, NULL, 15730, 8),
(239110, NULL, 'PTHR34719', NULL, NULL, NULL, NULL, 'NICKEL-RESPONSIVE REGULATOR', NULL, NULL, NULL, 8),
(239111, NULL, 'PTHR22956', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING PROTEIN F37A4.4-RELATED-RELATED', NULL, NULL, NULL, 8),
(239112, NULL, 'PTHR21193', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE-LIKE DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, 27081, 8),
(239113, NULL, 'PTHR42924', NULL, NULL, NULL, NULL, 'EXONUCLEASE', NULL, NULL, NULL, 8),
(239114, NULL, 'PTHR15527', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM6 HOMOLOG', NULL, NULL, 21977, 8),
(239115, NULL, 'PTHR13563', NULL, NULL, NULL, NULL, 'TRNA (GUANINE-9-) METHYLTRANSFERASE', NULL, NULL, 5959, 8),
(239116, NULL, 'PTHR45445', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(239117, NULL, 'PTHR12472', NULL, NULL, NULL, NULL, 'RAB3-GAP REGULATORY DOMAIN', NULL, NULL, 24325, 8),
(239118, NULL, 'PTHR35129', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT GAMMA 1', NULL, NULL, 37068, 8),
(239119, NULL, 'PTHR13428', NULL, NULL, NULL, NULL, 'INNER NUCLEAR MEMBRANE PROTEIN MAN1  LEM DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(239120, NULL, 'PTHR46679', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(239121, NULL, 'PTHR20935', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE-RELATED', NULL, NULL, NULL, 8),
(239122, NULL, 'PTHR21525', NULL, NULL, NULL, NULL, 'MOTILE SPERM PROTEIN', NULL, NULL, NULL, 8),
(239123, NULL, 'PTHR24300', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 508A4-RELATED', NULL, NULL, NULL, 8),
(239124, NULL, 'PTHR43048', NULL, NULL, NULL, NULL, 'METHYLMALONYL-COA EPIMERASE', NULL, NULL, NULL, 8),
(239125, NULL, 'PTHR19879', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID', NULL, NULL, 28906, 8),
(239126, NULL, 'PTHR46483', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1 PLIP2, CHLOROPLASTIC', NULL, NULL, 34236, 8),
(239127, NULL, 'PTHR35492', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN', NULL, NULL, 34074, 8),
(239128, NULL, 'PTHR31570', NULL, NULL, NULL, NULL, 'HAUS AUGMIN-LIKE COMPLEX SUBUNIT 1', NULL, NULL, 24525, 8),
(239129, NULL, 'PTHR37156', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(239130, NULL, 'PTHR20881', NULL, NULL, NULL, NULL, '3-METHYL-2-OXOBUTANOATE HYDROXYMETHYLTRANSFERASE', NULL, NULL, 2403, 8),
(239131, NULL, 'PTHR14107', NULL, NULL, NULL, NULL, 'WD REPEAT PROTEIN', NULL, NULL, NULL, 8),
(239132, NULL, 'PTHR42892', NULL, NULL, NULL, NULL, 'GLUCOSAMINE-6-PHOSPHATE DEAMINASE-LIKE PROTEIN BT_0258-RELATED', NULL, NULL, NULL, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(239133, NULL, 'PTHR10741', NULL, NULL, NULL, NULL, 'TRANSLIN AND TRANSLIN ASSOCIATED PROTEIN X', NULL, NULL, 5858, 8),
(239134, NULL, 'PTHR11926', NULL, NULL, NULL, NULL, 'GLUCOSYL/GLUCURONOSYL TRANSFERASES', NULL, NULL, NULL, 8),
(239135, NULL, 'PTHR14168', NULL, NULL, NULL, NULL, 'TUMOR-ASSOCIATED CALCIUM SIGNAL TRANSDUCER', NULL, NULL, 37735, 8),
(239136, NULL, 'PTHR47494', NULL, NULL, NULL, NULL, 'NKG2-D TYPE II INTEGRAL MEMBRANE PROTEIN', NULL, NULL, 37347, 8),
(239137, NULL, 'PTHR38079', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(239138, NULL, 'PTHR23177', NULL, NULL, NULL, NULL, 'MKIAA1688 PROTEIN', NULL, NULL, 34565, 8),
(239139, NULL, 'PTHR47584', NULL, NULL, NULL, NULL, '', NULL, NULL, 35849, 8),
(239140, NULL, 'PTHR33931', NULL, NULL, NULL, NULL, 'HOLIN-LIKE PROTEIN CIDA-RELATED', NULL, NULL, 1735, 8),
(239141, NULL, 'PTHR37451', NULL, NULL, NULL, NULL, 'MARVEL DOMAIN', NULL, NULL, NULL, 8),
(239142, NULL, 'PTHR14272', NULL, NULL, NULL, NULL, 'SERTA DOMAIN-CONTAINING PROTEIN 4', NULL, NULL, 23639, 8),
(239143, NULL, 'PTHR43113', NULL, NULL, NULL, NULL, 'NUCLEOSIDE-DIPHOSPHATE-SUGAR EPIMERASE', NULL, NULL, NULL, 8),
(239144, NULL, 'PTHR31338', NULL, NULL, NULL, NULL, 'POLYKETIDE CYCLASE/DEHYDRASE AND LIPID TRANSPORT SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(239145, NULL, 'PTHR39341', NULL, NULL, NULL, NULL, 'BSL7085 PROTEIN', NULL, NULL, 17785, 8),
(239146, NULL, 'PTHR24406', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR CTCFL-RELATED', NULL, NULL, NULL, 8),
(239147, NULL, 'PTHR34353', NULL, NULL, NULL, NULL, 'CRISPR-ASSOCIATED ENDONUCLEASE CAS1 1', NULL, NULL, NULL, 8),
(239148, NULL, 'PTHR22115', NULL, NULL, NULL, NULL, 'C3ORF6 PROTEIN-RELATED', NULL, NULL, 27474, 8),
(239149, NULL, 'PTHR31228', NULL, NULL, NULL, NULL, 'CYSTATIN/MONELLIN SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(239150, NULL, 'PTHR34228', NULL, NULL, NULL, NULL, 'PROTEIN CBG09474-RELATED', NULL, NULL, NULL, 8),
(239151, NULL, 'PTHR31508', NULL, NULL, NULL, NULL, 'PROTEIN PITCHFORK', NULL, NULL, 28084, 8),
(239152, NULL, 'PTHR48233', NULL, NULL, NULL, NULL, 'MUCIN 4B, ISOFORM B-RELATED', NULL, NULL, NULL, 8),
(239153, NULL, 'PTHR42926', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(239154, NULL, 'PTHR31468', NULL, NULL, NULL, NULL, '1,3-BETA-GLUCANOSYLTRANSFERASE GAS1', NULL, NULL, 344, 8),
(239155, NULL, 'PTHR46920', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(239156, NULL, 'PTHR40599', NULL, NULL, NULL, NULL, '[CITRATE [PRO-3S]-LYASE] LIGASE', NULL, NULL, 10820, 8),
(239157, NULL, 'PTHR14870', NULL, NULL, NULL, NULL, 'TUBULIN EPSILON AND DELTA COMPLEX PROTEIN 2', NULL, NULL, 26714, 8),
(239158, NULL, 'PTHR48027', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN 87F-RELATED', NULL, NULL, NULL, 8),
(239159, NULL, 'PTHR30454', NULL, NULL, NULL, NULL, '4-HYDROXY-3-METHYLBUT-2-EN-1-YL DIPHOSPHATE SYNTHASE', NULL, NULL, 883, 8),
(239160, NULL, 'PTHR17601', NULL, NULL, NULL, NULL, 'RAFTLIN-RELATED', NULL, NULL, 24760, 8),
(239161, NULL, 'PTHR38457', NULL, NULL, NULL, NULL, 'REGULATOR ABRB-RELATED', NULL, NULL, 2422, 8),
(239162, NULL, 'PTHR43293', NULL, NULL, NULL, NULL, 'ACETATE COA-TRANSFERASE YDIF', NULL, NULL, NULL, 8),
(239163, NULL, 'PTHR44119', NULL, NULL, NULL, NULL, 'MAGNESIUM-CHELATASE SUBUNIT CHLH, CHLOROPLASTIC', NULL, NULL, 6086, 8),
(239164, NULL, 'PTHR22691', NULL, NULL, NULL, NULL, 'YEAST SPT2-RELATED', NULL, NULL, NULL, 8),
(239165, NULL, 'PTHR31470', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASES SUPERFAMILY PROTEIN-RELATED-RELATED', NULL, NULL, NULL, 8),
(239166, NULL, 'PTHR10666', NULL, NULL, NULL, NULL, 'UBIQUITIN', NULL, NULL, NULL, 8),
(239167, NULL, 'PTHR37331', NULL, NULL, NULL, NULL, 'YALI0F11671P', NULL, NULL, NULL, 8),
(239168, NULL, 'PTHR10926', NULL, NULL, NULL, NULL, 'CELL CYCLE CONTROL PROTEIN 50', NULL, NULL, 2479, 8),
(239169, NULL, 'PTHR37870', NULL, NULL, NULL, NULL, 'CHROMOSOME 1 OPEN READING FRAME 54', NULL, NULL, 24315, 8),
(239170, NULL, 'PTHR43606', NULL, NULL, NULL, NULL, 'PHOSPHATASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G08710)-RELATED', NULL, NULL, NULL, 8);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(239171, NULL, 'PTHR10706', NULL, NULL, NULL, NULL, 'F-BOX FAMILY PROTEIN', NULL, NULL, 34217, 8),
(239172, NULL, 'PTHR46478', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR A DOMAIN-CONTAINING PROTEIN 3A', NULL, NULL, NULL, 8),
(239173, NULL, 'PTHR21381', NULL, NULL, NULL, NULL, 'ZGC:162297', NULL, NULL, 7446, 8),
(239174, NULL, 'PTHR47712', NULL, NULL, NULL, NULL, 'OS09G0555300 PROTEIN', NULL, NULL, NULL, 8),
(239175, NULL, 'PTHR28002', NULL, NULL, NULL, NULL, 'MIOREX COMPLEX COMPONENT 11', NULL, NULL, 19661, 8),
(239176, NULL, 'PTHR11778', NULL, NULL, NULL, NULL, 'SERYL-TRNA SYNTHETASE', NULL, NULL, 6055, 8),
(239177, NULL, 'PTHR23028', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE', NULL, NULL, NULL, 8),
(239178, NULL, 'PTHR43722', NULL, NULL, NULL, NULL, 'PROLINE IMINOPEPTIDASE', NULL, NULL, 138, 8),
(239179, NULL, 'PTHR39192', NULL, NULL, NULL, NULL, 'IRON UPTAKE SYSTEM COMPONENT EFEO', NULL, NULL, NULL, 8),
(239180, NULL, 'PTHR13113', NULL, NULL, NULL, NULL, 'ECSIT  EVOLUTIONARILY CONSERVED SIGNALING INTERMEDIATE IN TOLL PATHWAYS', NULL, NULL, 9171, 8),
(239181, NULL, 'PTHR23523', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(239182, NULL, 'PTHR21964', NULL, NULL, NULL, NULL, 'BREAST CANCER METASTASIS-SUPPRESSOR 1', NULL, NULL, 17533, 8),
(239183, NULL, 'PTHR23147', NULL, NULL, NULL, NULL, 'SERINE/ARGININE RICH SPLICING FACTOR', NULL, NULL, NULL, 8),
(239184, NULL, 'PTHR35546', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN INTERACTION DOMAIN PROTEIN-RELATED', NULL, NULL, NULL, 8),
(239185, NULL, 'PTHR35689', NULL, NULL, NULL, NULL, 'EARLY ENDOSOME ANTIGEN', NULL, NULL, NULL, 8),
(239186, NULL, 'PTHR16004', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 31-RELATED', NULL, NULL, 22348, 8),
(239187, NULL, 'PTHR37161', NULL, NULL, NULL, NULL, 'HDC10475', NULL, NULL, 4287, 8),
(239188, NULL, 'PTHR43010', NULL, NULL, NULL, NULL, 'UNIVERSAL STRESS PROTEIN SLR1230', NULL, NULL, NULL, 8),
(239189, NULL, 'PTHR37432', NULL, NULL, NULL, NULL, 'PROTEIN CBG21304', NULL, NULL, NULL, 8),
(239190, NULL, 'PTHR12940', NULL, NULL, NULL, NULL, 'ES-2 PROTEIN - RELATED', NULL, NULL, 18254, 8),
(239191, NULL, 'PTHR46841', NULL, NULL, NULL, NULL, 'OX-2 MEMBRANE GLYCOPROTEIN', NULL, NULL, NULL, 8),
(239192, NULL, 'PTHR33102', NULL, NULL, NULL, NULL, 'DVL19-RELATED-RELATED', NULL, NULL, NULL, 8),
(239193, NULL, 'PTHR35014', NULL, NULL, NULL, NULL, 'INFECTION RESPONSE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(239194, NULL, 'PTHR11324', NULL, NULL, NULL, NULL, 'IL16-RELATED', NULL, NULL, NULL, 8),
(239195, NULL, 'PTHR47027', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(239196, NULL, 'PTHR14754', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR A', NULL, NULL, NULL, 8),
(239197, NULL, 'PTHR47636', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN RCO1', NULL, NULL, NULL, 8),
(239198, NULL, 'PTHR16525', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 14950, 8),
(239199, NULL, 'PTHR15902', NULL, NULL, NULL, NULL, 'NEURITIN-RELATED', NULL, NULL, 23192, 8),
(239200, NULL, 'PTHR33348', NULL, NULL, NULL, NULL, 'PRECURSOR OF CEP5', NULL, NULL, 29175, 8),
(239201, NULL, 'PTHR12623', NULL, NULL, NULL, NULL, 'NGFI-A BINDING PROTEIN', NULL, NULL, 28215, 8),
(239202, NULL, 'PTHR43194', NULL, NULL, NULL, NULL, 'HYDROLASE ALPHA/BETA FOLD FAMILY', NULL, NULL, NULL, 8),
(239203, NULL, 'PTHR40703', NULL, NULL, NULL, NULL, 'TRNA (PSEUDOURIDINE(54)-N(1))-METHYLTRANSFERASE', NULL, NULL, 202, 8),
(239204, NULL, 'PTHR34057', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR', NULL, NULL, NULL, 8),
(239205, NULL, 'PTHR34301', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(239206, NULL, 'PTHR31466', NULL, NULL, NULL, NULL, 'GENE 5591-RELATED', NULL, NULL, 32111, 8),
(239207, NULL, 'PTHR37173', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', NULL, NULL, NULL, 8),
(239208, NULL, 'PTHR45756', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE', NULL, NULL, NULL, 8),
(239209, NULL, 'PTHR28654', NULL, NULL, NULL, NULL, 'AXIN INTERACTOR, DORSALIZATION-ASSOCIATED PROTEIN', NULL, NULL, NULL, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(239210, NULL, 'PTHR15665', NULL, NULL, NULL, NULL, 'ASTEROID PROTEIN', NULL, NULL, 22235, 8),
(239211, NULL, 'PTHR15138', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 4', NULL, NULL, 36970, 8),
(239212, NULL, 'PTHR31117', NULL, NULL, NULL, NULL, 'PROTEIN KREG-1', NULL, NULL, 29036, 8),
(239213, NULL, 'PTHR31698', NULL, NULL, NULL, NULL, 'LYSOZYME G FAMILY MEMBER', NULL, NULL, NULL, 8),
(239214, NULL, 'PTHR22874', NULL, NULL, NULL, NULL, 'ACTIVATING MOLECULE IN BECN1-REGULATED AUTOPHAGY PROTEIN 1', NULL, NULL, NULL, 8),
(239215, NULL, 'PTHR47529', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE D', NULL, NULL, NULL, 8),
(239216, NULL, 'PTHR36018', NULL, NULL, NULL, NULL, 'OS09G0481800 PROTEIN', NULL, NULL, NULL, 8),
(239217, NULL, 'PTHR35691', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(239218, NULL, 'PTHR28581', NULL, NULL, NULL, NULL, 'CONSORTIN', NULL, NULL, 35059, 8),
(239219, NULL, 'PTHR15402', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR-LIKE 5 PROTEIN', NULL, NULL, 33488, 8),
(239220, NULL, 'PTHR47434', NULL, NULL, NULL, NULL, 'PROTEIN PTST HOMOLOG 3, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(239221, NULL, 'PTHR31776', NULL, NULL, NULL, NULL, 'ALPHA-L-ARABINOFURANOSIDASE 1', NULL, NULL, NULL, 8),
(239222, NULL, 'PTHR21220', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 34344, 8),
(239223, NULL, 'PTHR14699', NULL, NULL, NULL, NULL, 'STI2 PROTEIN-RELATED', NULL, NULL, 29940, 8),
(239224, NULL, 'PTHR38382', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN', NULL, NULL, NULL, 8),
(239225, NULL, 'PTHR15654', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(239226, NULL, 'PTHR47497', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 8', NULL, NULL, NULL, 8),
(239227, NULL, 'PTHR14440', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE I SUBUNIT RPA49', NULL, NULL, 11941, 8),
(239228, NULL, 'PTHR47658', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP B PROTEIN 12-RELATED', NULL, NULL, NULL, 8),
(239229, NULL, 'PTHR45957', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT 2', NULL, NULL, 36201, 8),
(239230, NULL, 'PTHR31728', NULL, NULL, NULL, NULL, 'ABRAXAS FAMILY MEMBER', NULL, NULL, 15851, 8),
(239231, NULL, 'PTHR37562', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(239232, NULL, 'PTHR34951', NULL, NULL, NULL, NULL, 'B6F COMPLEX SUBUNIT, PUTATIVE, EXPRESSED-RELATED', NULL, NULL, NULL, 8),
(239233, NULL, 'PTHR31897', NULL, NULL, NULL, NULL, 'PROTEIN CBG17011-RELATED', NULL, NULL, NULL, 8),
(239234, NULL, 'PTHR15722', NULL, NULL, NULL, NULL, 'IFT140/172-RELATED', NULL, NULL, NULL, 8),
(239235, NULL, 'PTHR36166', NULL, NULL, NULL, NULL, 'CHROMOSOME 9, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(239236, NULL, 'PTHR43165', NULL, NULL, NULL, NULL, 'METALLOPHOSPHOESTERASE', NULL, NULL, NULL, 8),
(239237, NULL, 'PTHR10768', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L37', NULL, NULL, NULL, 8),
(239238, NULL, 'PTHR33538', NULL, NULL, NULL, NULL, 'PROTEIN GAMETE EXPRESSED 1', NULL, NULL, 27101, 8),
(239239, NULL, 'PTHR18949', NULL, NULL, NULL, NULL, 'CALDESMON', NULL, NULL, 1208, 8),
(239240, NULL, 'PTHR35089', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN SKP', NULL, NULL, 2735, 8),
(239241, NULL, 'PTHR35829', NULL, NULL, NULL, NULL, 'OS05G0470900 PROTEIN', NULL, NULL, NULL, 8),
(239242, NULL, 'PTHR36799', NULL, NULL, NULL, NULL, '', NULL, NULL, 18570, 8),
(239243, NULL, 'PTHR37232', NULL, NULL, NULL, NULL, 'FASCICLIN DOMAIN PROTEIN', NULL, NULL, NULL, 8),
(239244, NULL, 'PTHR30578', NULL, NULL, NULL, NULL, 'ELECTRON TRANSPORT COMPLEX PROTEIN RNFD', NULL, NULL, 4511, 8),
(239245, NULL, 'PTHR12809', NULL, NULL, NULL, NULL, 'MEDIATOR COMPLEX SUBUNIT', NULL, NULL, 7580, 8),
(239246, NULL, 'PTHR35726', NULL, NULL, NULL, NULL, 'GLUTAMIC ACID-RICH PROTEIN-LIKE', NULL, NULL, NULL, 8),
(239247, NULL, 'PTHR40375', NULL, NULL, NULL, NULL, 'SPORULATION-SPECIFIC PROTEIN 22', NULL, NULL, 33836, 8),
(239248, NULL, 'PTHR15441', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P PROTEIN SUBUNIT P14', NULL, NULL, NULL, 8);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(239249, NULL, 'PTHR33914', NULL, NULL, NULL, NULL, '18S PRE-RIBOSOMAL ASSEMBLY PROTEIN GAR2-LIKE PROTEIN', NULL, NULL, 27520, 8),
(239250, NULL, 'PTHR46970', NULL, NULL, NULL, NULL, 'BASIC HELIX-LOOP-HELIX DOMAIN-CONTAINING PROTEIN USF3', NULL, NULL, NULL, 8),
(239251, NULL, 'PTHR34109', NULL, NULL, NULL, NULL, 'BNAUNNG04460D PROTEIN-RELATED', NULL, NULL, NULL, 8),
(239252, NULL, 'PTHR12729', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 10518, 8),
(239253, NULL, 'PTHR42182', NULL, NULL, NULL, NULL, 'SLL0359 PROTEIN', NULL, NULL, 24237, 8),
(239254, NULL, 'PTHR34444', NULL, NULL, NULL, NULL, 'LOC361192', NULL, NULL, 23339, 8),
(239255, NULL, 'PTHR15363', NULL, NULL, NULL, NULL, 'POU DOMAIN CLASS 2-ASSOCIATING FACTOR 1', NULL, NULL, NULL, 8),
(239256, NULL, 'PTHR33163', NULL, NULL, NULL, NULL, 'PROTEIN TIC 214-RELATED', NULL, NULL, 7685, 8),
(239257, NULL, 'PTHR46364', NULL, NULL, NULL, NULL, 'OS08G0421900 PROTEIN', NULL, NULL, NULL, 8),
(239258, NULL, 'PTHR36091', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN 9, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(239259, NULL, 'PTHR10363', NULL, NULL, NULL, NULL, 'BLEOMYCIN HYDROLASE', NULL, NULL, 2919, 8),
(239260, NULL, 'PTHR36354', NULL, NULL, NULL, NULL, 'IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT', NULL, NULL, NULL, 8),
(239261, NULL, 'PTHR14987', NULL, NULL, NULL, NULL, 'PROTEIN LBH-RELATED', NULL, NULL, 35876, 8),
(239262, NULL, 'PTHR40400', NULL, NULL, NULL, NULL, 'SLR1512 PROTEIN', NULL, NULL, 7813, 8),
(239263, NULL, 'PTHR36787', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(239264, NULL, 'PTHR37196', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(239265, NULL, 'PTHR30441', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(239266, NULL, 'PTHR36971', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', NULL, NULL, NULL, 8),
(239267, NULL, 'PTHR45917', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN 1-RELATED', NULL, NULL, 35004, 8),
(239268, NULL, 'PTHR37715', NULL, NULL, NULL, NULL, 'OS01G0120700 PROTEIN', NULL, NULL, NULL, 8),
(239269, NULL, 'PTHR13510', NULL, NULL, NULL, NULL, 'FYVE-FINGER-CONTAINING RAB5 EFFECTOR PROTEIN RABENOSYN-5-RELATED', NULL, NULL, NULL, 8),
(239270, NULL, 'PTHR14202', NULL, NULL, NULL, NULL, '60 KDA RIBONUCLEOPROTEIN SSA/RO', NULL, NULL, 30294, 8),
(239271, NULL, 'PTHR31377', NULL, NULL, NULL, NULL, 'AGMATINE DEIMINASE-RELATED', NULL, NULL, 4864, 8),
(239272, NULL, 'PTHR22035', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 7', NULL, NULL, 26036, 8),
(239273, NULL, 'PTHR34821', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YDCZ', NULL, NULL, 2938, 8),
(239274, NULL, 'PTHR30505', NULL, NULL, NULL, NULL, 'FRUCTOSE-LIKE PERMEASE', NULL, NULL, NULL, 8),
(239275, NULL, 'PTHR34814', NULL, NULL, NULL, NULL, 'NITROSOGUANIDINE RESISTANCE PROTEIN SNG1', NULL, NULL, NULL, 8),
(239276, NULL, 'PTHR21467', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 4 REGULATORY SUBUNIT 4 PPP4R4', NULL, NULL, 27495, 8),
(239277, NULL, 'PTHR19430', NULL, NULL, NULL, NULL, 'PROTEIN BEX1-RELATED', NULL, NULL, 2603, 8),
(239278, NULL, 'PTHR28578', NULL, NULL, NULL, NULL, 'MITOTIC-SPINDLE ORGANIZING PROTEIN 2A-RELATED', NULL, NULL, 24516, 8),
(239279, NULL, 'PTHR12154', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE-RELATED', NULL, NULL, 7784, 8),
(239280, NULL, 'PTHR46199', NULL, NULL, NULL, NULL, 'RAC GTPASE-ACTIVATING PROTEIN 1', NULL, NULL, NULL, 8),
(239281, NULL, 'PTHR31290', NULL, NULL, NULL, NULL, 'UV-DAMAGE ENDONUCLEASE', NULL, NULL, 532, 8),
(239282, NULL, 'PTHR22666', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 25353, 8),
(239283, NULL, 'PTHR37203', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(239284, NULL, 'PTHR45672', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE C17H9.14C-RELATED', NULL, NULL, NULL, 8),
(239285, NULL, 'PTHR38787', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(239286, NULL, 'PTHR43598', NULL, NULL, NULL, NULL, 'TUNGSTEN-CONTAINING FORMYLMETHANOFURAN DEHYDROGENASE 2 SUBUNIT B', NULL, NULL, NULL, 8);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(239287, NULL, 'PTHR34684', NULL, NULL, NULL, NULL, 'OS08G0192200 PROTEIN', NULL, NULL, NULL, 8),
(239288, NULL, 'PTHR40562', NULL, NULL, NULL, NULL, '', NULL, NULL, 18387, 8),
(239289, NULL, 'PTHR33800', NULL, NULL, NULL, NULL, 'OS06G0113600 PROTEIN', NULL, NULL, NULL, 8),
(239290, NULL, 'PTHR23049', NULL, NULL, NULL, NULL, 'MYOSIN REGULATORY LIGHT CHAIN 2', NULL, NULL, NULL, 8),
(239291, NULL, 'PTHR34569', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(239292, NULL, 'PTHR28186', NULL, NULL, NULL, NULL, 'MEIOTICALLY UP-REGULATED GENE 9 PROTEIN', NULL, NULL, 19735, 8),
(239293, NULL, 'PTHR32432', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN FTSA-RELATED', NULL, NULL, NULL, 8),
(239294, NULL, 'PTHR44490', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION ELONGATION FACTOR 1 EPSILON-1', NULL, NULL, 33505, 8),
(239295, NULL, 'PTHR12000', NULL, NULL, NULL, NULL, 'HEMOGLOBINASE FAMILY MEMBER', NULL, NULL, 1162, 8),
(239296, NULL, 'PTHR15297', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN SUPERFAMILY MEMBER 6', NULL, NULL, 27082, 8),
(239297, NULL, 'PTHR33219', NULL, NULL, NULL, NULL, 'YLMG HOMOLOG PROTEIN 2, CHLOROPLASTIC', NULL, NULL, 5263, 8),
(239298, NULL, 'PTHR47908', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(239299, NULL, 'PTHR43858', NULL, NULL, NULL, NULL, 'ENERGY-DEPENDENT TRANSLATIONAL THROTTLE PROTEIN ETTA', NULL, NULL, 15431, 8),
(239300, NULL, 'PTHR14684', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 34222, 8),
(239301, NULL, 'PTHR34174', NULL, NULL, NULL, NULL, 'HYDROLETHALUS SYNDROME PROTEIN 1', NULL, NULL, NULL, 8),
(239302, NULL, 'PTHR31748', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS V', NULL, NULL, NULL, 8),
(239303, NULL, 'PTHR47099', NULL, NULL, NULL, NULL, 'METHYLCOBAMIDE:COM METHYLTRANSFERASE MTBA', NULL, NULL, NULL, 8),
(239304, NULL, 'PTHR10962', NULL, NULL, NULL, NULL, 'INTEGRAL TRANSMEMBRANE PROTEIN 2', NULL, NULL, 30263, 8),
(239305, NULL, 'PTHR36142', NULL, NULL, NULL, NULL, 'METALLO-HYDROLASE/OXIDOREDUCTASE SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(239306, NULL, 'PTHR22747', NULL, NULL, NULL, NULL, 'NUCLEOPLASMIN', NULL, NULL, 4589, 8),
(239307, NULL, 'PTHR31393', NULL, NULL, NULL, NULL, 'C5ORF31', NULL, NULL, 23775, 8),
(239308, NULL, 'PTHR44947', NULL, NULL, NULL, NULL, 'OS05G0501001 PROTEIN', NULL, NULL, NULL, 8),
(239309, NULL, 'PTHR31952', NULL, NULL, NULL, NULL, 'CB1 CANNABINOID RECEPTOR-INTERACTING PROTEIN 1', NULL, NULL, 26950, 8),
(239310, NULL, 'PTHR43868', NULL, NULL, NULL, NULL, 'OS02G0711200 PROTEIN', NULL, NULL, NULL, 8),
(239311, NULL, 'PTHR47914', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(239312, NULL, 'PTHR36869', NULL, NULL, NULL, NULL, 'CHROMOSOME 16 OPEN READING FRAME 46', NULL, NULL, 22321, 8),
(239313, NULL, 'PTHR10676', NULL, NULL, NULL, NULL, 'DYNEIN HEAVY CHAIN FAMILY PROTEIN', NULL, NULL, 23364, 8),
(239314, NULL, 'PTHR42881', NULL, NULL, NULL, NULL, 'PROLYL ENDOPEPTIDASE', NULL, NULL, NULL, 8),
(239315, NULL, 'PTHR43242', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(239316, NULL, 'PTHR43259', NULL, NULL, NULL, NULL, 'SPT10P', NULL, NULL, NULL, 8),
(239317, NULL, 'PTHR47288', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 9', NULL, NULL, 36097, 8),
(239318, NULL, 'PTHR17149', NULL, NULL, NULL, NULL, 'NUCLEAR PROTEIN 1 AND 2', NULL, NULL, 19298, 8),
(239319, NULL, 'PTHR34206', NULL, NULL, NULL, NULL, 'OS06G0193300 PROTEIN', NULL, NULL, NULL, 8),
(239320, NULL, 'PTHR23356', NULL, NULL, NULL, NULL, 'DPY30-RELATED', NULL, NULL, 28837, 8),
(239321, NULL, 'PTHR21639', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 32499, 8),
(239322, NULL, 'PTHR35420', NULL, NULL, NULL, NULL, 'OS02G0198500 PROTEIN', NULL, NULL, NULL, 8),
(239323, NULL, 'PTHR43639', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE, SHORT-CHAIN DEHYDROGENASE/REDUCTASE FAMILY (AFU_ORTHOLOGUE AFUA_5G02870)', NULL, NULL, NULL, 8),
(239324, NULL, 'PTHR22989', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED DUF13  C.ELEGANS', NULL, NULL, NULL, 8);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(239325, NULL, 'PTHR15066', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 187', NULL, NULL, 26780, 8),
(239326, NULL, 'PTHR38082', NULL, NULL, NULL, NULL, 'ENDOTOXIN_N DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(239327, NULL, 'PTHR12040', NULL, NULL, NULL, NULL, 'ANTI-SILENCING PROTEIN 1', NULL, NULL, 3583, 8),
(239328, NULL, 'PTHR38462', NULL, NULL, NULL, NULL, 'EXONUCLEASE-LIKE PROTEIN', NULL, NULL, NULL, 8),
(239329, NULL, 'PTHR10909', NULL, NULL, NULL, NULL, 'ELECTRON TRANSPORT OXIDOREDUCTASE', NULL, NULL, 11956, 8),
(239330, NULL, 'PTHR10407', NULL, NULL, NULL, NULL, 'HUNTINGTIN INTERACTING PROTEIN 1', NULL, NULL, 23540, 8),
(239331, NULL, 'PTHR14363', NULL, NULL, NULL, NULL, 'HEPARANASE-RELATED', NULL, NULL, NULL, 8),
(239332, NULL, 'PTHR31571', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN 6', NULL, NULL, NULL, 8),
(239333, NULL, 'PTHR13148', NULL, NULL, NULL, NULL, 'PER1-RELATED', NULL, NULL, 6118, 8),
(239334, NULL, 'PTHR21477', NULL, NULL, NULL, NULL, 'ZGC:172139', NULL, NULL, 17825, 8),
(239335, NULL, 'PTHR45777', NULL, NULL, NULL, NULL, 'METHIONINE AMINOPEPTIDASE 2', NULL, NULL, NULL, 8),
(239336, NULL, 'PTHR13299', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 14397, 8),
(239337, NULL, 'PTHR31444', NULL, NULL, NULL, NULL, 'OS11G0490100 PROTEIN', NULL, NULL, 6980, 8),
(239338, NULL, 'PTHR46965', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN 19', NULL, NULL, 35186, 8),
(239339, NULL, 'PTHR33490', NULL, NULL, NULL, NULL, 'BLR5614 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(239340, NULL, 'PTHR10338', NULL, NULL, NULL, NULL, 'INTER-ALPHA-TRYPSIN INHIBITOR HEAVY CHAIN FAMILY MEMBER', NULL, NULL, NULL, 8),
(239341, NULL, 'PTHR42789', NULL, NULL, NULL, NULL, 'D-ISOMER SPECIFIC 2-HYDROXYACID DEHYDROGENASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_6G10090)', NULL, NULL, NULL, 8),
(239342, NULL, 'PTHR11769', NULL, NULL, NULL, NULL, 'HYALURONIDASE', NULL, NULL, 13551, 8),
(239343, NULL, 'PTHR21696', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 22209, 8),
(239344, NULL, 'PTHR17453', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE 19 KD PROTEIN', NULL, NULL, 4664, 8),
(239345, NULL, 'PTHR47339', NULL, NULL, NULL, NULL, 'CELL DIVISION CONTROL PROTEIN 24', NULL, NULL, NULL, 8),
(239346, NULL, 'PTHR37191', NULL, NULL, NULL, NULL, 'ZINC FINGER/BTB DOMAIN PROTEIN', NULL, NULL, NULL, 8),
(239347, NULL, 'PTHR16029', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 31739, 8),
(239348, NULL, 'PTHR40633', NULL, NULL, NULL, NULL, 'MATRIX PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G05410)-RELATED', NULL, NULL, NULL, 8),
(239349, NULL, 'PTHR48207', NULL, NULL, NULL, NULL, 'SUCCINATE--HYDROXYMETHYLGLUTARATE COA-TRANSFERASE', NULL, NULL, NULL, 8),
(239350, NULL, 'PTHR47332', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN 5', NULL, NULL, NULL, 8),
(239351, NULL, 'PTHR33621', NULL, NULL, NULL, NULL, 'ASPARTIC/GLUTAMIC ACID-RICH PROTEIN', NULL, NULL, NULL, 8),
(239352, NULL, 'PTHR14559', NULL, NULL, NULL, NULL, 'CASPASE RECRUITMENT DOMAIN FAMILY', NULL, NULL, NULL, 8),
(239353, NULL, 'PTHR34200', NULL, NULL, NULL, NULL, 'DENTIN SIALOPHOSPHOPROTEIN-LIKE ISOFORM X1', NULL, NULL, NULL, 8),
(239354, NULL, 'PTHR47495', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE', NULL, NULL, NULL, 8),
(239355, NULL, 'PTHR11058', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE CHAIN 3', NULL, NULL, 5603, 8),
(239356, NULL, 'PTHR33801', NULL, NULL, NULL, NULL, 'ABSCISIC STRESS-RIPENING PROTEIN 5', NULL, NULL, 6242, 8),
(239357, NULL, 'PTHR10374', NULL, NULL, NULL, NULL, 'LACTOYLGLUTATHIONE LYASE  GLYOXALASE I', NULL, NULL, NULL, 8),
(239358, NULL, 'PTHR13678', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 37', NULL, NULL, NULL, 8),
(239359, NULL, 'PTHR44054', NULL, NULL, NULL, NULL, 'SYNAPTIC VESICLE MEMBRANE PROTEIN VAT-1 HOMOLOG-LIKE', NULL, NULL, NULL, 8),
(239360, NULL, 'PTHR35666', NULL, NULL, NULL, NULL, 'SIMILAR TO RIKEN CDNA 4921536K21', NULL, NULL, 29959, 8),
(239361, NULL, 'PTHR37755', NULL, NULL, NULL, NULL, 'PROTEIN TIC 56, CHLOROPLASTIC', NULL, NULL, 27140, 8);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(239362, NULL, 'PTHR43682', NULL, NULL, NULL, NULL, 'LACTATE UTILIZATION PROTEIN C', NULL, NULL, NULL, 8),
(239363, NULL, 'PTHR19229', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE TRANSPORTER SUBFAMILY A  ABCA', NULL, NULL, 21772, 8),
(239364, NULL, 'PTHR47933', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN 1, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(239365, NULL, 'PTHR28262', NULL, NULL, NULL, NULL, 'DASH COMPLEX SUBUNIT SPC19', NULL, NULL, 13498, 8),
(239366, NULL, 'PTHR16078', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 87', NULL, NULL, 27358, 8),
(239367, NULL, 'PTHR39387', NULL, NULL, NULL, NULL, 'SHAVENOID, ISOFORM B', NULL, NULL, NULL, 8),
(239368, NULL, 'PTHR40064', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(239369, NULL, 'PTHR46933', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DNA-BINDING DOMAIN-CONTAINING PROTEIN 2', NULL, NULL, 34013, 8),
(239370, NULL, 'PTHR40083', NULL, NULL, NULL, NULL, 'UPF0122 PROTEIN CBO2450/CLC_2298', NULL, NULL, 3795, 8),
(239371, NULL, 'PTHR44835', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE--PEPTIDE N-ACETYLGLUCOSAMINYLTRANSFERASE SPINDLY-RELATED', NULL, NULL, NULL, 8),
(239372, NULL, 'PTHR32241', NULL, NULL, NULL, NULL, 'PATATIN-LIKE PROTEIN 6', NULL, NULL, NULL, 8),
(239373, NULL, 'PTHR10605', NULL, NULL, NULL, NULL, 'HEPARAN SULFATE SULFOTRANSFERASE', NULL, NULL, 27564, 8),
(239374, NULL, 'PTHR15090', NULL, NULL, NULL, NULL, 'SEQUESTOSOME 1-RELATED', NULL, NULL, NULL, 8),
(239375, NULL, 'PTHR40455', NULL, NULL, NULL, NULL, 'ANTITOXIN HIGA', NULL, NULL, 27108, 8),
(239376, NULL, 'PTHR11521', NULL, NULL, NULL, NULL, 'TROPONIN T', NULL, NULL, 25316, 8),
(239377, NULL, 'PTHR21304', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 10510, 8),
(239378, NULL, 'PTHR31125', NULL, NULL, NULL, NULL, 'F20P5.22 PROTEIN-RELATED', NULL, NULL, 10440, 8),
(239379, NULL, 'PTHR31008', NULL, NULL, NULL, NULL, 'COP1-INTERACTING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(239380, NULL, 'PTHR31241', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 2C', NULL, NULL, NULL, 8),
(239381, NULL, 'PTHR13931', NULL, NULL, NULL, NULL, 'UBIQUITINATION FACTOR E4', NULL, NULL, 36843, 8),
(239382, NULL, 'PTHR43341', NULL, NULL, NULL, NULL, 'AMINO ACID PERMEASE', NULL, NULL, NULL, 8),
(239383, NULL, 'PTHR39336', NULL, NULL, NULL, NULL, 'PYRIDOXAMINE PHOSPHATE OXIDASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_6G11440)', NULL, NULL, NULL, 8),
(239384, NULL, 'PTHR32305', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(239385, NULL, 'PTHR37410', NULL, NULL, NULL, NULL, 'ADHESIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(239386, NULL, 'PTHR20978', NULL, NULL, NULL, NULL, 'SPLICING FACTOR 3B SUBUNIT 5', NULL, NULL, 13211, 8),
(239387, NULL, 'PTHR46455', NULL, NULL, NULL, NULL, 'SET AND MYND DOMAIN CONTAINING, ARTHROPOD-SPECIFIC, MEMBER 4, ISOFORM A', NULL, NULL, NULL, 8),
(239388, NULL, 'PTHR45703', NULL, NULL, NULL, NULL, 'DYNEIN HEAVY CHAIN', NULL, NULL, 23364, 8),
(239389, NULL, 'PTHR13243', NULL, NULL, NULL, NULL, 'HSPC111 PROTEIN-RELATED', NULL, NULL, 15766, 8),
(239390, NULL, 'PTHR13419', NULL, NULL, NULL, NULL, 'ZINC FINGER-CONTAINING', NULL, NULL, 30308, 8),
(239391, NULL, 'PTHR20855', NULL, NULL, NULL, NULL, 'ADIPOR/PROGESTIN RECEPTOR-RELATED', NULL, NULL, 3825, 8),
(239392, NULL, 'PTHR31980', NULL, NULL, NULL, NULL, 'PROTEIN FAM220A', NULL, NULL, 27886, 8),
(239393, NULL, 'PTHR12398', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE INHIBITOR', NULL, NULL, 6671, 8),
(239394, NULL, 'PTHR39299', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(239395, NULL, 'PTHR30181', NULL, NULL, NULL, NULL, 'MANNITOL PERMEASE IIC COMPONENT', NULL, NULL, NULL, 8),
(239396, NULL, 'PTHR35495', NULL, NULL, NULL, NULL, 'OS06G0679600 PROTEIN', NULL, NULL, NULL, 8),
(239397, NULL, 'PTHR11452', NULL, NULL, NULL, NULL, 'ALPHA-GALACTOSIDASE/ALPHA-N-ACETYLGALACTOSAMINIDASE', NULL, NULL, 5507, 8),
(239398, NULL, 'PTHR21299', NULL, NULL, NULL, NULL, 'CYTIDYLATE KINASE/PANTOATE-BETA-ALANINE LIGASE', NULL, NULL, NULL, 8);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(239399, NULL, 'PTHR33750', NULL, NULL, NULL, NULL, 'PROTEIN CBG02727', NULL, NULL, NULL, 8),
(239400, NULL, 'PTHR45659', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX', NULL, NULL, NULL, 8),
(239401, NULL, 'PTHR46348', NULL, NULL, NULL, NULL, 'DELETED IN LUNG AND ESOPHAGEAL CANCER PROTEIN 1', NULL, NULL, 28787, 8),
(239402, NULL, 'PTHR24333', NULL, NULL, NULL, NULL, 'HOMEO BOX HB9 LIKE A-RELATED', NULL, NULL, NULL, 8),
(239403, NULL, 'PTHR10379', NULL, NULL, NULL, NULL, 'MTG8 ETO  EIGHT TWENTY ONE PROTEIN', NULL, NULL, 8731, 8),
(239404, NULL, 'PTHR35106', NULL, NULL, NULL, NULL, 'BNAA07G25190D PROTEIN', NULL, NULL, NULL, 8),
(239405, NULL, 'PTHR28076', NULL, NULL, NULL, NULL, 'SPORULATION-SPECIFIC PROTEIN 71', NULL, NULL, 27505, 8),
(239406, NULL, 'PTHR21530', NULL, NULL, NULL, NULL, 'PHEROMONE SHUTDOWN PROTEIN', NULL, NULL, 37570, 8),
(239407, NULL, 'PTHR21007', NULL, NULL, NULL, NULL, 'LIVER EXPRESSED ANTIMICROBIAL PEPTIDE 2', NULL, NULL, 8449, 8),
(239408, NULL, 'PTHR11410', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT A', NULL, NULL, 36133, 8),
(239409, NULL, 'PTHR11782', NULL, NULL, NULL, NULL, 'ADENOSINE/GUANOSINE DIPHOSPHATASE', NULL, NULL, 4996, 8),
(239410, NULL, 'PTHR43073', NULL, NULL, NULL, NULL, 'DIHYDROPYRIMIDINE DEHYDROGENASE [NADP(+)]', NULL, NULL, NULL, 8),
(239411, NULL, 'PTHR41773', NULL, NULL, NULL, NULL, 'GTP PYROPHOSPHATASE-RELATED', NULL, NULL, NULL, 8),
(239412, NULL, 'PTHR30487', NULL, NULL, NULL, NULL, 'TYPE 4 PREPILIN-LIKE PROTEINS LEADER PEPTIDE-PROCESSING ENZYME', NULL, NULL, NULL, 8),
(239413, NULL, 'PTHR12394', NULL, NULL, NULL, NULL, 'ZYGIN', NULL, NULL, 10765, 8),
(239414, NULL, 'PTHR13084', NULL, NULL, NULL, NULL, 'T-CELL LYMPHOMA BREAKPOINT-ASSOCIATED TARGET 1-RELATED', NULL, NULL, 12551, 8),
(239415, NULL, 'PTHR36460', NULL, NULL, NULL, NULL, 'UPF0132 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_3G10255)', NULL, NULL, NULL, 8),
(239416, NULL, 'PTHR45686', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE ACTIVATING PROTEIN 3, ISOFORM H-RELATED', NULL, NULL, NULL, 8),
(239417, NULL, 'PTHR45631', NULL, NULL, NULL, NULL, 'OS07G0107800 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(239418, NULL, 'PTHR40398', NULL, NULL, NULL, NULL, 'PTS SYSTEM GLUCITOL/SORBITOL-SPECIFIC EIIA COMPONENT', NULL, NULL, 3493, 8),
(239419, NULL, 'PTHR36594', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(239420, NULL, 'PTHR47534', NULL, NULL, NULL, NULL, 'YALI0E05731P', NULL, NULL, NULL, 8),
(239421, NULL, 'PTHR10755', NULL, NULL, NULL, NULL, 'COPROPORPHYRINOGEN III OXIDASE, MITOCHONDRIAL', NULL, NULL, 2460, 8),
(239422, NULL, 'PTHR31518', NULL, NULL, NULL, NULL, 'ARGININE/SERINE-RICH PROTEIN PNISR', NULL, NULL, 24531, 8),
(239423, NULL, 'PTHR28199', NULL, NULL, NULL, NULL, 'PROCESSING OF GAS1 AND ALP PROTEIN 2', NULL, NULL, 13934, 8),
(239424, NULL, 'PTHR43981', NULL, NULL, NULL, NULL, 'ENOYL-[ACYL-CARRIER-PROTEIN] REDUCTASE, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(239425, NULL, 'PTHR12286', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(239426, NULL, 'PTHR13409', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 39S RIBOSOMAL PROTEIN L51', NULL, NULL, 15834, 8),
(239427, NULL, 'PTHR35587', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(239428, NULL, 'PTHR36026', NULL, NULL, NULL, NULL, 'OS05G0542100 PROTEIN', NULL, NULL, NULL, 8),
(239429, NULL, 'PTHR45857', NULL, NULL, NULL, NULL, 'FORMIN-LIKE PROTEIN', NULL, NULL, 35207, 8),
(239430, NULL, 'PTHR37422', NULL, NULL, NULL, NULL, 'TEICHURONIC ACID BIOSYNTHESIS PROTEIN TUAE', NULL, NULL, NULL, 8),
(239431, NULL, 'PTHR43643', NULL, NULL, NULL, NULL, 'HISTIDINOL-PHOSPHATE AMINOTRANSFERASE 2', NULL, NULL, NULL, 8),
(239432, NULL, 'PTHR48185', NULL, NULL, NULL, NULL, 'BNACNNG12700D PROTEIN', NULL, NULL, NULL, 8),
(239433, NULL, 'PTHR46703', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(239434, NULL, 'PTHR31344', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP205', NULL, NULL, 19513, 8),
(239435, NULL, 'PTHR43016', NULL, NULL, NULL, NULL, 'PRESEQUENCE PROTEASE', NULL, NULL, NULL, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(239436, NULL, 'PTHR14768', NULL, NULL, NULL, NULL, 'UPF0338 PROTEIN', NULL, NULL, NULL, 8),
(239437, NULL, 'PTHR14076', NULL, NULL, NULL, NULL, 'RECEPTOR ACTIVITY MODIFYING PROTEIN  RAMP', NULL, NULL, 5620, 8),
(239438, NULL, 'PTHR44755', NULL, NULL, NULL, NULL, 'NATRIURETIC PEPTIDE RECEPTOR 3-RELATED', NULL, NULL, NULL, 8),
(239439, NULL, 'PTHR46612', NULL, NULL, NULL, NULL, 'XYLOSIDE XYLOSYLTRANSFERASE 1', NULL, NULL, 35592, 8),
(239440, NULL, 'PTHR37378', NULL, NULL, NULL, NULL, 'BOWMAN_BIRK DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, 36906, 8),
(239441, NULL, 'PTHR33769', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 26 ISOFORM X3', NULL, NULL, 35281, 8),
(239442, NULL, 'PTHR31743', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL CHANNEL 4-ASSOCIATED PROTEIN TCPC4AP', NULL, NULL, 20756, 8),
(239443, NULL, 'PTHR34706', NULL, NULL, NULL, NULL, 'SLR1338 PROTEIN', NULL, NULL, NULL, 8),
(239444, NULL, 'PTHR44499', NULL, NULL, NULL, NULL, 'JOUBERIN', NULL, NULL, NULL, 8),
(239445, NULL, 'PTHR12709', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE II, III', NULL, NULL, 34471, 8),
(239446, NULL, 'PTHR10961', NULL, NULL, NULL, NULL, 'PEROXISOMAL SARCOSINE OXIDASE', NULL, NULL, 36658, 8),
(239447, NULL, 'PTHR15502', NULL, NULL, NULL, NULL, 'CALCINEURIN-BINDING PROTEIN CABIN 1-RELATED', NULL, NULL, 30955, 8),
(239448, NULL, 'PTHR13044', NULL, NULL, NULL, NULL, 'ACTIVATING TRANSCRIPTION FACTOR  ATF  4/5', NULL, NULL, NULL, 8),
(239449, NULL, 'PTHR46319', NULL, NULL, NULL, NULL, 'ZINC FINGER FYVE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(239450, NULL, 'PTHR46307', NULL, NULL, NULL, NULL, 'G9A, ISOFORM B', NULL, NULL, 35703, 8),
(239451, NULL, 'PTHR10795', NULL, NULL, NULL, NULL, 'PROPROTEIN CONVERTASE SUBTILISIN/KEXIN', NULL, NULL, 35509, 8),
(239452, NULL, 'PTHR16154', NULL, NULL, NULL, NULL, 'NEURABIN', NULL, NULL, 34355, 8),
(239453, NULL, 'PTHR16306', NULL, NULL, NULL, NULL, 'TRANSLIN-ASSOCIATED FACTOR X-INTERACTING PROTEIN 1', NULL, NULL, NULL, 8),
(239454, NULL, 'PTHR16081', NULL, NULL, NULL, NULL, 'VERTNIN', NULL, NULL, 31184, 8),
(239455, NULL, 'PTHR39181', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE YWQE', NULL, NULL, 20378, 8),
(239456, NULL, 'PTHR34461', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(239457, NULL, 'PTHR43187', NULL, NULL, NULL, NULL, 'GLUTAMINE AMIDOTRANSFERASE DUG3-RELATED', NULL, NULL, NULL, 8),
(239458, NULL, 'PTHR43948', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY B', NULL, NULL, NULL, 8),
(239459, NULL, 'PTHR36048', NULL, NULL, NULL, NULL, 'RIBOSOME MATURATION FACTOR', NULL, NULL, NULL, 8),
(239460, NULL, 'PTHR21596', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P SUBUNIT P38', NULL, NULL, 34942, 8),
(239461, NULL, 'PTHR18871', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 112 KDA', NULL, NULL, NULL, 8),
(239462, NULL, 'PTHR11481', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN FC RECEPTOR', NULL, NULL, NULL, 8),
(239463, NULL, 'PTHR46130', NULL, NULL, NULL, NULL, 'LAMGL DOMAIN-CONTAINING PROTEIN', NULL, NULL, 35832, 8),
(239464, NULL, 'PTHR12570', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 13255, 8),
(239465, NULL, 'PTHR35042', NULL, NULL, NULL, NULL, 'ANTHRONE OXYGENASE ENCC', NULL, NULL, NULL, 8),
(239466, NULL, 'PTHR16181', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(239467, NULL, 'PTHR37604', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT', NULL, NULL, NULL, 8),
(239468, NULL, 'PTHR28559', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN XRCC4', NULL, NULL, 8464, 8),
(239469, NULL, 'PTHR16124', NULL, NULL, NULL, NULL, 'MIS18-BINDING PROTEIN 1', NULL, NULL, 28337, 8),
(239470, NULL, 'PTHR46645', NULL, NULL, NULL, NULL, 'GRAM DOMAIN-CONTAINING PROTEIN 2B-RELATED', NULL, NULL, NULL, 8),
(239471, NULL, 'PTHR39673', NULL, NULL, NULL, NULL, 'TUNGSTEN FORMYLMETHANOFURAN DEHYDROGENASE, SUBUNIT C (FWDC)', NULL, NULL, NULL, 8),
(239472, NULL, 'PTHR10643', NULL, NULL, NULL, NULL, 'KINETOCHORE PROTEIN NDC80', NULL, NULL, 1512, 8),
(239473, NULL, 'PTHR30612', NULL, NULL, NULL, NULL, 'SECA INNER MEMBRANE COMPONENT OF SEC PROTEIN SECRETION SYSTEM', NULL, NULL, 1607, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(239474, NULL, 'PTHR15949', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 264', NULL, NULL, NULL, 8),
(239475, NULL, 'PTHR47909', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(239476, NULL, 'PTHR31500', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN 9', NULL, NULL, 33349, 8),
(239477, NULL, 'PTHR14577', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 12', NULL, NULL, 18089, 8),
(239478, NULL, 'PTHR23278', NULL, NULL, NULL, NULL, 'SIDESTEP PROTEIN', NULL, NULL, NULL, 8),
(239479, NULL, 'PTHR11504', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE POLYPEPTIDE VIA', NULL, NULL, 2116, 8),
(239480, NULL, 'PTHR21574', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 32045, 8),
(239481, NULL, 'PTHR24164', NULL, NULL, NULL, NULL, 'RELA-ASSOCIATED INHIBITOR', NULL, NULL, 24635, 8),
(239482, NULL, 'PTHR33751', NULL, NULL, NULL, NULL, 'CBB3-TYPE CYTOCHROME C OXIDASE SUBUNIT FIXP', NULL, NULL, NULL, 8),
(239483, NULL, 'PTHR23097', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER', NULL, NULL, NULL, 8),
(239484, NULL, 'PTHR35975', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 11A', NULL, NULL, 33562, 8),
(239485, NULL, 'PTHR21725', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE UBR4', NULL, NULL, 34824, 8),
(239486, NULL, 'PTHR13200', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 15911, 8),
(239487, NULL, 'PTHR47366', NULL, NULL, NULL, NULL, 'TWO-ON-TWO HEMOGLOBIN-3', NULL, NULL, 36143, 8),
(239488, NULL, 'PTHR10245', NULL, NULL, NULL, NULL, 'ENDOTHELIAL DIFFERENTIATION-RELATED FACTOR 1  MULTIPROTEIN BRIDGING FACTOR 1', NULL, NULL, NULL, 8),
(239489, NULL, 'PTHR28658', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 180', NULL, NULL, 27219, 8),
(239490, NULL, 'PTHR45924', NULL, NULL, NULL, NULL, 'FI17866P1', NULL, NULL, NULL, 8),
(239491, NULL, 'PTHR13964', NULL, NULL, NULL, NULL, 'RBP-RELATED', NULL, NULL, NULL, 8),
(239492, NULL, 'PTHR39142', NULL, NULL, NULL, NULL, 'MID1P', NULL, NULL, 24779, 8),
(239493, NULL, 'PTHR39671', NULL, NULL, NULL, NULL, 'COMPLEX PROTEIN NUCLEASE, PUTATIVE KREPB1-RELATED-RELATED', NULL, NULL, NULL, 8),
(239494, NULL, 'PTHR31242', NULL, NULL, NULL, NULL, 'ACETOLACTATE SYNTHASE SMALL SUBUNIT, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(239495, NULL, 'PTHR19317', NULL, NULL, NULL, NULL, 'PRENYLATED RAB ACCEPTOR 1-RELATED', NULL, NULL, 90, 8),
(239496, NULL, 'PTHR39211', NULL, NULL, NULL, NULL, 'CHROMOSOME 7, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(239497, NULL, 'PTHR28266', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN L20, MITOCHONDRIAL', NULL, NULL, 23146, 8),
(239498, NULL, 'PTHR34042', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR OFP17', NULL, NULL, 35304, 8),
(239499, NULL, 'PTHR15427', NULL, NULL, NULL, NULL, 'EMILIN  ELASTIN MICROFIBRIL INTERFACE-LOCATED PROTEIN   ELASTIN MICROFIBRIL INTERFACER', NULL, NULL, NULL, 8),
(239500, NULL, 'PTHR43849', NULL, NULL, NULL, NULL, 'BLL3936 PROTEIN', NULL, NULL, NULL, 8),
(239501, NULL, 'PTHR22945', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS D  DELTA', NULL, NULL, NULL, 8),
(239502, NULL, 'PTHR31614', NULL, NULL, NULL, NULL, 'PROTEIN DOWNSTREAM OF FLC-RELATED', NULL, NULL, 2595, 8),
(239503, NULL, 'PTHR36833', NULL, NULL, NULL, NULL, 'SLR0610 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(239504, NULL, 'PTHR22798', NULL, NULL, NULL, NULL, 'MCT-1 PROTEIN', NULL, NULL, 15097, 8),
(239505, NULL, 'PTHR44027', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 5 HOMOLOG', NULL, NULL, NULL, 8),
(239506, NULL, 'PTHR10366', NULL, NULL, NULL, NULL, 'NAD DEPENDENT EPIMERASE/DEHYDRATASE', NULL, NULL, NULL, 8),
(239507, NULL, 'PTHR15467', NULL, NULL, NULL, NULL, 'ZINC-FINGERS AND HOMEOBOXES RELATED', NULL, NULL, NULL, 8),
(239508, NULL, 'PTHR43665', NULL, NULL, NULL, NULL, 'ISOPENTENYL-DIPHOSPHATE DELTA-ISOMERASE', NULL, NULL, 10669, 8),
(239509, NULL, 'PTHR39369', NULL, NULL, NULL, NULL, 'LIN-24 (TWENTY-FOUR) LIKE', NULL, NULL, NULL, 8),
(239510, NULL, 'PTHR23525', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE-RELATED', NULL, NULL, NULL, 8);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(239511, NULL, 'PTHR35140', NULL, NULL, NULL, NULL, 'MITOTIC CHECK POINT PROTEIN BFA1', NULL, NULL, 248, 8),
(239512, NULL, 'PTHR18849', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT PROTEIN', NULL, NULL, NULL, 8),
(239513, NULL, 'PTHR21771', NULL, NULL, NULL, NULL, 'MITOCHONDRIA-EATING PROTEIN-RELATED', NULL, NULL, 25434, 8),
(239514, NULL, 'PTHR42110', NULL, NULL, NULL, NULL, 'L-ASPARAGINASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G11890)-RELATED', NULL, NULL, 8841, 8),
(239515, NULL, 'PTHR24002', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER 18', NULL, NULL, NULL, 8),
(239516, NULL, 'PTHR47226', NULL, NULL, NULL, NULL, 'C2 CALCIUM-DEPENDENT DOMAIN-CONTAINING PROTEIN 4A', NULL, NULL, 28051, 8),
(239517, NULL, 'PTHR42813', NULL, NULL, NULL, NULL, 'ZINC-TYPE ALCOHOL DEHYDROGENASE-LIKE', NULL, NULL, NULL, 8),
(239518, NULL, 'PTHR36522', NULL, NULL, NULL, NULL, 'AT HOOK-CONTAINING PROTEIN ATTF-4', NULL, NULL, 30552, 8),
(239519, NULL, 'PTHR39472', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(239520, NULL, 'PTHR47690', NULL, NULL, NULL, NULL, 'GLUCOKINASE', NULL, NULL, NULL, 8),
(239521, NULL, 'PTHR32556', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(239522, NULL, 'PTHR36454', NULL, NULL, NULL, NULL, 'LMO2823 PROTEIN', NULL, NULL, 7644, 8),
(239523, NULL, 'PTHR31270', NULL, NULL, NULL, NULL, 'GLUTAMINYL-PEPTIDE CYCLOTRANSFERASE', NULL, NULL, 2044, 8),
(239524, NULL, 'PTHR15837', NULL, NULL, NULL, NULL, 'RAN GUANINE NUCLEOTIDE RELEASE FACTOR', NULL, NULL, 636, 8),
(239525, NULL, 'PTHR37885', NULL, NULL, NULL, NULL, 'CMT1A DUPLICATED REGION TRANSCRIPT 4 PROTEIN', NULL, NULL, 21726, 8),
(239526, NULL, 'PTHR45751', NULL, NULL, NULL, NULL, 'COPINE FAMILY PROTEIN 1', NULL, NULL, NULL, 8),
(239527, NULL, 'PTHR11108', NULL, NULL, NULL, NULL, 'FERROCHELATASE', NULL, NULL, 2295, 8),
(239528, NULL, 'PTHR30466', NULL, NULL, NULL, NULL, 'FLAVIN REDUCTASE', NULL, NULL, NULL, 8),
(239529, NULL, 'PTHR34313', NULL, NULL, NULL, NULL, 'ENDOGENOUS RETROVIRUS GROUP K MEMBER 113 ENV POLYPROTEIN-RELATED', NULL, NULL, NULL, 8),
(239530, NULL, 'PTHR38146', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S12, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(239531, NULL, 'PTHR35735', NULL, NULL, NULL, NULL, 'PROTEIN NIM1-INTERACTING 2', NULL, NULL, 101, 8),
(239532, NULL, 'PTHR35453', NULL, NULL, NULL, NULL, 'PROSTATE ANDROGEN-REGULATED MUCIN-LIKE PROTEIN 1', NULL, NULL, 26459, 8),
(239533, NULL, 'PTHR47227', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT K', NULL, NULL, NULL, 8),
(239534, NULL, 'PTHR37915', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(239535, NULL, 'PTHR31735', NULL, NULL, NULL, NULL, 'VACUOLAR MEMBRANE PROTEIN YPL162C', NULL, NULL, 20696, 8),
(239536, NULL, 'PTHR45927', NULL, NULL, NULL, NULL, 'LYSM-DOMAIN RECEPTOR-LIKE KINASE-RELATED', NULL, NULL, NULL, 8),
(239537, NULL, 'PTHR36424', NULL, NULL, NULL, NULL, 'PHEROMONE-REGULATED MEMBRANE PROTEIN 6', NULL, NULL, 25556, 8),
(239538, NULL, 'PTHR42180', NULL, NULL, NULL, NULL, 'HOMOLOGY DOMAIN-CONTAINING PROTEIN,PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(239539, NULL, 'PTHR43018', NULL, NULL, NULL, NULL, 'PHOSPHO-2-DEHYDRO-3-DEOXYHEPTONATE ALDOLASE', NULL, NULL, NULL, 8),
(239540, NULL, 'PTHR46350', NULL, NULL, NULL, NULL, 'RAS LIKE FAMILY 10 MEMBER B-RELATED', NULL, NULL, NULL, 8),
(239541, NULL, 'PTHR16120', NULL, NULL, NULL, NULL, 'AP-5 COMPLEX SUBUNIT SIGMA-1', NULL, NULL, 23344, 8),
(239542, NULL, 'PTHR11785', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER', NULL, NULL, NULL, 8),
(239543, NULL, 'PTHR42815', NULL, NULL, NULL, NULL, 'FAD-BINDING, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G07600)-RELATED', NULL, NULL, NULL, 8),
(239544, NULL, 'PTHR13619', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 10870, 8),
(239545, NULL, 'PTHR31994', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 42', NULL, NULL, 27028, 8),
(239546, NULL, 'PTHR40237', NULL, NULL, NULL, NULL, 'LD44813P', NULL, NULL, NULL, 8),
(239547, NULL, 'PTHR10938', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR IF-3', NULL, NULL, 373, 8);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(239548, NULL, 'PTHR23104', NULL, NULL, NULL, NULL, 'MULTIPLE COAGULATION FACTOR DEFICIENCY PROTEIN 2  NEURAL STEM CELL DERIVED NEURONAL SURVIVAL PROTEIN', NULL, NULL, NULL, 8),
(239549, NULL, 'PTHR12166', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT SECRETION ACTIVATOR', NULL, NULL, 32510, 8),
(239550, NULL, 'PTHR47604', NULL, NULL, NULL, NULL, 'ADENYLYL CYCLASE', NULL, NULL, NULL, 8),
(239551, NULL, 'PTHR43846', NULL, NULL, NULL, NULL, 'UPF0176 PROTEIN YCEA', NULL, NULL, NULL, 8),
(239552, NULL, 'PTHR22406', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 25150, 8),
(239553, NULL, 'PTHR42990', NULL, NULL, NULL, NULL, 'ATPASE', NULL, NULL, NULL, 8),
(239554, NULL, 'PTHR20929', NULL, NULL, NULL, NULL, 'LUNG ADENOMA SUSCEPTIBILITY 1-RELATED', NULL, NULL, 15570, 8),
(239555, NULL, 'PTHR47325', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SUVR5', NULL, NULL, NULL, 8),
(239556, NULL, 'PTHR36515', NULL, NULL, NULL, NULL, 'PROTEIN CBG00810', NULL, NULL, NULL, 8),
(239557, NULL, 'PTHR33869', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 3', NULL, NULL, 27431, 8),
(239558, NULL, 'PTHR15301', NULL, NULL, NULL, NULL, 'INSULIN-INDUCED GENE 1', NULL, NULL, 24846, 8),
(239559, NULL, 'PTHR46923', NULL, NULL, NULL, NULL, 'CATION CHANNEL SPERM-ASSOCIATED PROTEIN 2', NULL, NULL, 23444, 8),
(239560, NULL, 'PTHR11695', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE RELATED', NULL, NULL, NULL, 8),
(239561, NULL, 'PTHR11607', NULL, NULL, NULL, NULL, 'ALPHA-MANNOSIDASE', NULL, NULL, NULL, 8),
(239562, NULL, 'PTHR34075', NULL, NULL, NULL, NULL, 'BLR3430 PROTEIN', NULL, NULL, NULL, 8),
(239563, NULL, 'PTHR46229', NULL, NULL, NULL, NULL, 'BOLA TRANSCRIPTION REGULATOR', NULL, NULL, NULL, 8),
(239564, NULL, 'PTHR21847', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING DOMAIN-CONTAINING PROTEIN 10', NULL, NULL, 27383, 8),
(239565, NULL, 'PTHR14789', NULL, NULL, NULL, NULL, 'CHONDROLECTIN VARIANT CHODLFDELTAE.', NULL, NULL, NULL, 8),
(239566, NULL, 'PTHR11918', NULL, NULL, NULL, NULL, 'RADICAL SAM PROTEINS', NULL, NULL, NULL, 8),
(239567, NULL, 'PTHR35488', NULL, NULL, NULL, NULL, 'OS05G0358900 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(239568, NULL, 'PTHR12652', NULL, NULL, NULL, NULL, 'PEROXISOMAL BIOGENESIS FACTOR 11', NULL, NULL, NULL, 8),
(239569, NULL, 'PTHR47100', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE PHS1', NULL, NULL, 12208, 8),
(239570, NULL, 'PTHR47035', NULL, NULL, NULL, NULL, 'OS11G0150450 PROTEIN', NULL, NULL, NULL, 8),
(239571, NULL, 'PTHR13388', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 25803, 8),
(239572, NULL, 'PTHR33098', NULL, NULL, NULL, NULL, 'COTTON FIBER (DUF761)', NULL, NULL, NULL, 8),
(239573, NULL, 'PTHR11590', NULL, NULL, NULL, NULL, 'PROTEIN-GLUTAMINE GAMMA-GLUTAMYLTRANSFERASE', NULL, NULL, NULL, 8),
(239574, NULL, 'PTHR44427', NULL, NULL, NULL, NULL, 'CARCINOEMBRYONIC ANTIGEN-RELATED CELL ADHESION MOLECULE 19', NULL, NULL, NULL, 8),
(239575, NULL, 'PTHR34797', NULL, NULL, NULL, NULL, 'ATG8-INTERACTING PROTEIN 2', NULL, NULL, 31825, 8),
(239576, NULL, 'PTHR44240', NULL, NULL, NULL, NULL, 'DNAJ DOMAIN (PROKARYOTIC HEAT SHOCK PROTEIN)-RELATED', NULL, NULL, NULL, 8),
(239577, NULL, 'PTHR23107', NULL, NULL, NULL, NULL, 'SYNOVIAL SARCOMA ASSOCIATED SS18 PROTEIN', NULL, NULL, 34761, 8),
(239578, NULL, 'PTHR46742', NULL, NULL, NULL, NULL, 'LYSINE-RICH COILED-COIL PROTEIN 1', NULL, NULL, NULL, 8),
(239579, NULL, 'PTHR38848', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(239580, NULL, 'PTHR13298', NULL, NULL, NULL, NULL, 'CYTOSOLIC REGULATOR PIANISSIMO', NULL, NULL, 23468, 8),
(239581, NULL, 'PTHR44279', NULL, NULL, NULL, NULL, 'HYDROXYSTEROID (11-BETA) DEHYDROGENASE 1-LIKE B-RELATED', NULL, NULL, NULL, 8),
(239582, NULL, 'PTHR10094', NULL, NULL, NULL, NULL, 'STEROL CARRIER PROTEIN 2  SCP-2  FAMILY PROTEIN', NULL, NULL, 27063, 8),
(239583, NULL, 'PTHR32379', NULL, NULL, NULL, NULL, 'GUANIDINOACETATE N-METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(239584, NULL, 'PTHR47639', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN 18', NULL, NULL, 34466, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(239585, NULL, 'PTHR42089', NULL, NULL, NULL, NULL, 'YALI0F09427P', NULL, NULL, NULL, 8),
(239586, NULL, 'PTHR14275', NULL, NULL, NULL, NULL, 'PROMETHIN', NULL, NULL, 23567, 8),
(239587, NULL, 'PTHR36056', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', NULL, NULL, 31587, 8),
(239588, NULL, 'PTHR46719', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR C2H2 FAMILY-RELATED', NULL, NULL, 34739, 8),
(239589, NULL, 'PTHR23349', NULL, NULL, NULL, NULL, 'BASIC HELIX-LOOP-HELIX TRANSCRIPTION FACTOR, TWIST', NULL, NULL, NULL, 8),
(239590, NULL, 'PTHR47370', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASES (NAT) SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(239591, NULL, 'PTHR36571', NULL, NULL, NULL, NULL, 'PROTEIN YGIW', NULL, NULL, NULL, 8),
(239592, NULL, 'PTHR37761', NULL, NULL, NULL, NULL, 'OS09G0108400 PROTEIN', NULL, NULL, NULL, 8),
(239593, NULL, 'PTHR21640', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 22772, 8),
(239594, NULL, 'PTHR34251', NULL, NULL, NULL, NULL, 'LEUCINE-, GLUTAMATE- AND LYSINE-RICH PROTEIN 1', NULL, NULL, 32115, 8),
(239595, NULL, 'PTHR14130', NULL, NULL, NULL, NULL, '3BP-1 RELATED RHOGAP', NULL, NULL, NULL, 8),
(239596, NULL, 'PTHR47683', NULL, NULL, NULL, NULL, 'PSEUDOURIDINE SYNTHASE FAMILY PROTEIN-RELATED', NULL, NULL, NULL, 8),
(239597, NULL, 'PTHR31919', NULL, NULL, NULL, NULL, 'ZINC FINGERS AND HOMEOBOXES PROTEIN 1, ISOFORM 2', NULL, NULL, 29031, 8),
(239598, NULL, 'PTHR14383', NULL, NULL, NULL, NULL, 'SWAP-70 RECOMBINASE', NULL, NULL, NULL, 8),
(239599, NULL, 'PTHR12974', NULL, NULL, NULL, NULL, 'PRION-LIKE- Q/N-RICH -DOMAIN-BEARING PROTEIN PROTEIN 44', NULL, NULL, 8460, 8),
(239600, NULL, 'PTHR39177', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE YTRC-RELATED', NULL, NULL, NULL, 8),
(239601, NULL, 'PTHR36401', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 BETA SUBCOMPLEX SUBUNIT 8, MITOCHONDRIAL', NULL, NULL, 32745, 8),
(239602, NULL, 'PTHR23157', NULL, NULL, NULL, NULL, 'GRIP AND COILED-COIL DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(239603, NULL, 'PTHR46568', NULL, NULL, NULL, NULL, 'ALKYLDIHYDROXYACETONEPHOSPHATE SYNTHASE, PEROXISOMAL', NULL, NULL, 24668, 8),
(239604, NULL, 'PTHR21535', NULL, NULL, NULL, NULL, 'MAGNESIUM AND COBALT TRANSPORT PROTEIN/MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM8', NULL, NULL, NULL, 8),
(239605, NULL, 'PTHR14493', NULL, NULL, NULL, NULL, 'UNKEMPT FAMILY MEMBER', NULL, NULL, 36988, 8),
(239606, NULL, 'PTHR34707', NULL, NULL, NULL, NULL, 'VIMENTIN-TYPE INTERMEDIATE FILAMENT-ASSOCIATED COILED-COIL PROTEIN', NULL, NULL, NULL, 8),
(239607, NULL, 'PTHR13037', NULL, NULL, NULL, NULL, 'FORMIN', NULL, NULL, NULL, 8),
(239608, NULL, 'PTHR40448', NULL, NULL, NULL, NULL, 'TWO-COMPONENT SENSOR HISTIDINE KINASE', NULL, NULL, NULL, 8),
(239609, NULL, 'PTHR39174', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', NULL, NULL, 9375, 8),
(239610, NULL, 'PTHR33095', NULL, NULL, NULL, NULL, 'OS07G0619500 PROTEIN', NULL, NULL, NULL, 8),
(239611, NULL, 'PTHR45008', NULL, NULL, NULL, NULL, 'PTS SYSTEM GLUCOSE-SPECIFIC EIIA COMPONENT', NULL, NULL, NULL, 8),
(239612, NULL, 'PTHR21635', NULL, NULL, NULL, NULL, 'LEUCINE ZIPPER TRANSCRIPTION FACTOR LIKE', NULL, NULL, 22779, 8),
(239613, NULL, 'PTHR37732', NULL, NULL, NULL, NULL, 'OS08G0104400 PROTEIN', NULL, NULL, 35883, 8),
(239614, NULL, 'PTHR45987', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L12', NULL, NULL, 3982, 8),
(239615, NULL, 'PTHR35284', NULL, NULL, NULL, NULL, 'OUTER ENVELOPE PORE PROTEIN 24A, CHLOROPLASTIC-RELATED', NULL, NULL, 17884, 8),
(239616, NULL, 'PTHR33528', NULL, NULL, NULL, NULL, 'OS07G0239500 PROTEIN', NULL, NULL, NULL, 8),
(239617, NULL, 'PTHR37448', NULL, NULL, NULL, NULL, '', NULL, NULL, 27260, 8),
(239618, NULL, 'PTHR22166', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM JUNCTION FORMATION PROTEIN LUNAPARK', NULL, NULL, 27085, 8),
(239619, NULL, 'PTHR21720', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(239620, NULL, 'PTHR43460', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', NULL, NULL, NULL, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(239621, NULL, 'PTHR34379', NULL, NULL, NULL, NULL, 'OS07G0553800 PROTEIN', NULL, NULL, 27963, 8),
(239622, NULL, 'PTHR45908', NULL, NULL, NULL, NULL, 'PROTEIN CBG11750-RELATED', NULL, NULL, NULL, 8),
(239623, NULL, 'PTHR14949', NULL, NULL, NULL, NULL, 'EGF-LIKE-DOMAIN, MULTIPLE 7, 8', NULL, NULL, NULL, 8),
(239624, NULL, 'PTHR11055', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL 3''-PHOSPHOADENOSINE 5''-PHOSPHOSULFATE SYNTHASE', NULL, NULL, NULL, 8),
(239625, NULL, 'PTHR14455', NULL, NULL, NULL, NULL, 'ASKOPOS', NULL, NULL, 25135, 8),
(239626, NULL, 'PTHR31513', NULL, NULL, NULL, NULL, 'EPHRIN TYPE-B RECEPTOR', NULL, NULL, NULL, 8),
(239627, NULL, 'PTHR46004', NULL, NULL, NULL, NULL, 'CYCLIC AMP RESPONSE ELEMENT-BINDING PROTEIN A', NULL, NULL, NULL, 8),
(239628, NULL, 'PTHR33543', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN-LIKE PROTEIN 2A', NULL, NULL, 4692, 8),
(239629, NULL, 'PTHR41878', NULL, NULL, NULL, NULL, 'LEXA REPRESSOR-RELATED', NULL, NULL, 13452, 8),
(239630, NULL, 'PTHR46080', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE CARRIER FAMILY PROTEIN J', NULL, NULL, NULL, 8),
(239631, NULL, 'PTHR21689', NULL, NULL, NULL, NULL, 'LIN-9', NULL, NULL, 8117, 8),
(239632, NULL, 'PTHR36498', NULL, NULL, NULL, NULL, 'TATA-BINDING PROTEIN-ASSOCIATED FACTOR 172', NULL, NULL, 35740, 8),
(239633, NULL, 'PTHR13036', NULL, NULL, NULL, NULL, 'BETA1,4 MANNOSYLTRANSFERASE', NULL, NULL, 23977, 8),
(239634, NULL, 'PTHR11073', NULL, NULL, NULL, NULL, 'CALRETICULIN AND CALNEXIN', NULL, NULL, 3101, 8),
(239635, NULL, 'PTHR34839', NULL, NULL, NULL, NULL, 'CS DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(239636, NULL, 'PTHR18640', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 10 MEMBER 7', NULL, NULL, 16378, 8),
(239637, NULL, 'PTHR47403', NULL, NULL, NULL, NULL, 'LOC100145250 PROTEIN', NULL, NULL, NULL, 8),
(239638, NULL, 'PTHR38481', NULL, NULL, NULL, NULL, 'HYALURONATE LYASE', NULL, NULL, 30328, 8),
(239639, NULL, 'PTHR21734', NULL, NULL, NULL, NULL, 'INHIBITOR OF NUCLEAR FACTOR KAPPA-B KINASE-INTERACTING PROTEIN', NULL, NULL, 11234, 8),
(239640, NULL, 'PTHR43839', NULL, NULL, NULL, NULL, 'OPPC IN A BINDING PROTEIN-DEPENDENT TRANSPORT SYSTEM', NULL, NULL, NULL, 8),
(239641, NULL, 'PTHR47020', NULL, NULL, NULL, NULL, 'HILLARIN', NULL, NULL, NULL, 8),
(239642, NULL, 'PTHR10937', NULL, NULL, NULL, NULL, 'GLUCOSAMINE--FRUCTOSE-6-PHOSPHATE AMINOTRANSFERASE, ISOMERIZING', NULL, NULL, NULL, 8),
(239643, NULL, 'PTHR23250', NULL, NULL, NULL, NULL, 'DYSFERLIN-RELATED', NULL, NULL, NULL, 8),
(239644, NULL, 'PTHR22367', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 14', NULL, NULL, 23593, 8),
(239645, NULL, 'PTHR34709', NULL, NULL, NULL, NULL, 'OS10G0396666 PROTEIN', NULL, NULL, NULL, 8),
(239646, NULL, 'PTHR34011', NULL, NULL, NULL, NULL, 'PHYCOBILISOME 32.1 KDA LINKER POLYPEPTIDE, PHYCOCYANIN-ASSOCIATED, ROD 2-RELATED', NULL, NULL, NULL, 8),
(239647, NULL, 'PTHR24368', NULL, NULL, NULL, NULL, 'AMPHOTERIN-INDUCED PROTEIN', NULL, NULL, 22192, 8),
(239648, NULL, 'PTHR11266', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN 2, PXMP2  MPV17', NULL, NULL, 6998, 8),
(239649, NULL, 'PTHR47210', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 26C-RELATED', NULL, NULL, 34775, 8),
(239650, NULL, 'PTHR46791', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(239651, NULL, 'PTHR46320', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE 1', NULL, NULL, NULL, 8),
(239652, NULL, 'PTHR47387', NULL, NULL, NULL, NULL, 'NECTIN-2', NULL, NULL, NULL, 8),
(239653, NULL, 'PTHR34119', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN-LIKE', NULL, NULL, 27744, 8),
(239654, NULL, 'PTHR22743', NULL, NULL, NULL, NULL, 'MEPRIN/TRAF-LIKE MATH FAMILY-C.ELEGANS', NULL, NULL, NULL, 8),
(239655, NULL, 'PTHR30283', NULL, NULL, NULL, NULL, 'PEROXIDE STRESS RESPONSE PROTEIN YAAA', NULL, NULL, 1862, 8),
(239656, NULL, 'PTHR15817', NULL, NULL, NULL, NULL, 'STG PROTEIN', NULL, NULL, 24680, 8),
(239657, NULL, 'PTHR19376', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE', NULL, NULL, 33803, 8);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(239658, NULL, 'PTHR36367', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(239659, NULL, 'PTHR10896', NULL, NULL, NULL, NULL, 'GALACTOSYLGALACTOSYLXYLOSYLPROTEIN 3-BETA-GLUCURONOSYLTRANSFERASE  BETA-1,3-GLUCURONYLTRANSFERASE', NULL, NULL, 1093, 8),
(239660, NULL, 'PTHR33663', NULL, NULL, NULL, NULL, '', NULL, NULL, 25276, 8),
(239661, NULL, 'PTHR46000', NULL, NULL, NULL, NULL, 'SEVEN TM RECEPTOR-RELATED', NULL, NULL, NULL, 8),
(239662, NULL, 'PTHR47034', NULL, NULL, NULL, NULL, 'ZINC FINGER TRANSCRIPTION FACTOR TRPS1', NULL, NULL, 23238, 8),
(239663, NULL, 'PTHR33825', NULL, NULL, NULL, NULL, 'CHITINASE-LIKE PROTEIN', NULL, NULL, NULL, 8),
(239664, NULL, 'PTHR28441', NULL, NULL, NULL, NULL, 'PROTEIN FAM91A1', NULL, NULL, 32732, 8),
(239665, NULL, 'PTHR22967', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE', NULL, NULL, NULL, 8),
(239666, NULL, 'PTHR11661', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L12', NULL, NULL, 337, 8),
(239667, NULL, 'PTHR43636', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR G, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(239668, NULL, 'PTHR37031', NULL, NULL, NULL, NULL, 'METALLOPHOSPHATASE BINDING DOMAIN PROTEIN', NULL, NULL, NULL, 8),
(239669, NULL, 'PTHR32100', NULL, NULL, NULL, NULL, 'OMEGA-6 FATTY ACID DESATURASE, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(239670, NULL, 'PTHR44668', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(239671, NULL, 'PTHR45960', NULL, NULL, NULL, NULL, 'GRB2-ASSOCIATED-BINDING PROTEIN', NULL, NULL, 37623, 8),
(239672, NULL, 'PTHR43744', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN MG189-RELATED-RELATED', NULL, NULL, NULL, 8),
(239673, NULL, 'PTHR38522', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE-ASSOCIATED CATION-BINDING PROTEIN 1', NULL, NULL, 12226, 8),
(239674, NULL, 'PTHR34480', NULL, NULL, NULL, NULL, 'OS01G0967800 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(239675, NULL, 'PTHR35519', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEINS', NULL, NULL, 22932, 8),
(239676, NULL, 'PTHR31447', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN-RELATED', NULL, NULL, 36498, 8),
(239677, NULL, 'PTHR37816', NULL, NULL, NULL, NULL, 'YALI0E33011P', NULL, NULL, NULL, 8),
(239678, NULL, 'PTHR47643', NULL, NULL, NULL, NULL, 'TPR DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_5G12710)', NULL, NULL, NULL, 8),
(239679, NULL, 'PTHR46095', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 593', NULL, NULL, NULL, 8),
(239680, NULL, 'PTHR47847', NULL, NULL, NULL, NULL, 'FCS-LIKE ZINC FINGER 17', NULL, NULL, 36730, 8),
(239681, NULL, 'PTHR47058', NULL, NULL, NULL, NULL, 'REPLICATION PROTEIN A 14 KDA SUBUNIT A-RELATED', NULL, NULL, NULL, 8),
(239682, NULL, 'PTHR35462', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(239683, NULL, 'PTHR40624', NULL, NULL, NULL, NULL, 'BIOSYNTHESIS MONOOXYGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G12025)-RELATED', NULL, NULL, NULL, 8),
(239684, NULL, 'PTHR30341', NULL, NULL, NULL, NULL, 'SODIUM ION/PROTON ANTIPORTER NHAA-RELATED', NULL, NULL, 2613, 8),
(239685, NULL, 'PTHR28576', NULL, NULL, NULL, NULL, 'PIGGYBAC TRANSPOSABLE ELEMENT-DERIVED PROTEIN 5', NULL, NULL, 34633, 8),
(239686, NULL, 'PTHR30040', NULL, NULL, NULL, NULL, 'THIAMINE BIOSYNTHESIS LIPOPROTEIN APBE', NULL, NULL, 21855, 8),
(239687, NULL, 'PTHR45626', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR 2-RELATED', NULL, NULL, NULL, 8),
(239688, NULL, 'PTHR22742', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(239689, NULL, 'PTHR10067', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLSERINE DECARBOXYLASE', NULL, NULL, 3483, 8),
(239690, NULL, 'PTHR43673', NULL, NULL, NULL, NULL, 'NAD(P)H NITROREDUCTASE YDGI-RELATED', NULL, NULL, NULL, 8),
(239691, NULL, 'PTHR14742', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P SUBUNIT P21', NULL, NULL, NULL, 8),
(239692, NULL, 'PTHR35551', NULL, NULL, NULL, NULL, '', NULL, NULL, 17510, 8),
(239693, NULL, 'PTHR36566', NULL, NULL, NULL, NULL, 'NICKEL INSERTION PROTEIN-RELATED', NULL, NULL, 6495, 8),
(239694, NULL, 'PTHR13023', NULL, NULL, NULL, NULL, 'APYRASE', NULL, NULL, 13885, 8);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(239695, NULL, 'PTHR27003', NULL, NULL, NULL, NULL, 'OS07G0166700 PROTEIN', NULL, NULL, 34588, 8),
(239696, NULL, 'PTHR13696', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASE', NULL, NULL, NULL, 8),
(239697, NULL, 'PTHR47066', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 9', NULL, NULL, 35316, 8),
(239698, NULL, 'PTHR13628', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 21673, 8),
(239699, NULL, 'PTHR16434', NULL, NULL, NULL, NULL, 'EWING''S TUMOR-ASSOCIATED ANTIGEN 1 ETAA1', NULL, NULL, 24654, 8),
(239700, NULL, 'PTHR37014', NULL, NULL, NULL, NULL, 'EXPRESSION LETHALITY PROTEIN HEL10, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G06580)-RELATED', NULL, NULL, NULL, 8),
(239701, NULL, 'PTHR43884', NULL, NULL, NULL, NULL, 'ACYL-COA DEHYDROGENASE', NULL, NULL, NULL, 8),
(239702, NULL, 'PTHR10286', NULL, NULL, NULL, NULL, 'INORGANIC PYROPHOSPHATASE', NULL, NULL, 7463, 8),
(239703, NULL, 'PTHR35172', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(239704, NULL, 'PTHR44917', NULL, NULL, NULL, NULL, 'PROTEIN HIGH CHLOROPHYLL FLUORESCENT 107', NULL, NULL, 36050, 8),
(239705, NULL, 'PTHR30086', NULL, NULL, NULL, NULL, 'ARGININE EXPORTER PROTEIN ARGO', NULL, NULL, 1116, 8),
(239706, NULL, 'PTHR17616', NULL, NULL, NULL, NULL, 'YES-ASSOCIATED PROTEIN YAP1 FAMILY MEMBER', NULL, NULL, NULL, 8),
(239707, NULL, 'PTHR38674', NULL, NULL, NULL, NULL, 'ALKANE 1-MONOOXYGENASE 1', NULL, NULL, 29135, 8),
(239708, NULL, 'PTHR12854', NULL, NULL, NULL, NULL, 'ATAXIN 2-RELATED', NULL, NULL, 36974, 8),
(239709, NULL, 'PTHR12378', NULL, NULL, NULL, NULL, 'DESUMOYLATING ISOPEPTIDASE', NULL, NULL, 13814, 8),
(239710, NULL, 'PTHR31818', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 16', NULL, NULL, NULL, 8),
(239711, NULL, 'PTHR42903', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YCCF', NULL, NULL, NULL, 8),
(239712, NULL, 'PTHR24198', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(239713, NULL, 'PTHR36925', NULL, NULL, NULL, NULL, 'COBALT-PRECORRIN-6A REDUCTASE', NULL, NULL, 2052, 8),
(239714, NULL, 'PTHR18919', NULL, NULL, NULL, NULL, 'ACETYL-COA C-ACYLTRANSFERASE', NULL, NULL, NULL, 8),
(239715, NULL, 'PTHR23059', NULL, NULL, NULL, NULL, 'CYSTEINE AND HISTIDINE-RICH PROTEIN 1', NULL, NULL, 33340, 8),
(239716, NULL, 'PTHR48139', NULL, NULL, NULL, NULL, 'SI:DKEY-56M19.5', NULL, NULL, NULL, 8),
(239717, NULL, 'PTHR47112', NULL, NULL, NULL, NULL, 'PX DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(239718, NULL, 'PTHR32015', NULL, NULL, NULL, NULL, 'FASTING INDUCED LIPASE', NULL, NULL, 6046, 8),
(239719, NULL, 'PTHR47577', NULL, NULL, NULL, NULL, 'THAP DOMAIN-CONTAINING PROTEIN 6', NULL, NULL, NULL, 8),
(239720, NULL, 'PTHR47714', NULL, NULL, NULL, NULL, 'CRS1/YHBY DOMAIN CONTAINING PROTEIN, EXPRESSED', NULL, NULL, NULL, 8),
(239721, NULL, 'PTHR21715', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(239722, NULL, 'PTHR23052', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(239723, NULL, 'PTHR42867', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(239724, NULL, 'PTHR11158', NULL, NULL, NULL, NULL, 'MSF1/PX19 RELATED', NULL, NULL, 29676, 8),
(239725, NULL, 'PTHR19443', NULL, NULL, NULL, NULL, 'HEXOKINASE', NULL, NULL, 317, 8),
(239726, NULL, 'PTHR36448', NULL, NULL, NULL, NULL, 'BLR7373 PROTEIN', NULL, NULL, NULL, 8),
(239727, NULL, 'PTHR46040', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP PROTEIN 2', NULL, NULL, NULL, 8),
(239728, NULL, 'PTHR13132', NULL, NULL, NULL, NULL, 'ALPHA- 1,6 -FUCOSYLTRANSFERASE', NULL, NULL, NULL, 8),
(239729, NULL, 'PTHR47233', NULL, NULL, NULL, NULL, 'CHEMOTAXIS PROTEIN CHEV', NULL, NULL, NULL, 8),
(239730, NULL, 'PTHR47797', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G05805)-RELATED', NULL, NULL, NULL, 8),
(239731, NULL, 'PTHR30255', NULL, NULL, NULL, NULL, 'SINGLE-STRANDED-DNA-SPECIFIC EXONUCLEASE RECJ', NULL, NULL, NULL, 8),
(239732, NULL, 'PTHR11544', NULL, NULL, NULL, NULL, 'COLD SHOCK DOMAIN CONTAINING PROTEINS', NULL, NULL, NULL, 8);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(239733, NULL, 'PTHR11153', NULL, NULL, NULL, NULL, 'SIDEROFLEXIN', NULL, NULL, 3167, 8),
(239734, NULL, 'PTHR37940', NULL, NULL, NULL, NULL, 'LYSINE--TRNA LIGASE', NULL, NULL, 6277, 8),
(239735, NULL, 'PTHR45768', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF13-LIKE', NULL, NULL, NULL, 8),
(239736, NULL, 'PTHR16703', NULL, NULL, NULL, NULL, 'CLAUDIN-12', NULL, NULL, 8886, 8),
(239737, NULL, 'PTHR42804', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE', NULL, NULL, NULL, 8),
(239738, NULL, 'PTHR42262', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(239739, NULL, 'PTHR14569', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 6 FAMILY MEMBER G6E', NULL, NULL, 31116, 8),
(239740, NULL, 'PTHR46286', NULL, NULL, NULL, NULL, 'VIN3-LIKE PROTEIN 2-RELATED', NULL, NULL, 36654, 8),
(239741, NULL, 'PTHR21245', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN', NULL, NULL, NULL, 8),
(239742, NULL, 'PTHR36724', NULL, NULL, NULL, NULL, 'COMPLEX 1 LYR-LIKE PROTEIN', NULL, NULL, NULL, 8),
(239743, NULL, 'PTHR35759', NULL, NULL, NULL, NULL, 'BNAA09G03860D PROTEIN', NULL, NULL, NULL, 8),
(239744, NULL, 'PTHR47538', NULL, NULL, NULL, NULL, 'PERILIPIN 4', NULL, NULL, NULL, 8),
(239745, NULL, 'PTHR45560', NULL, NULL, NULL, NULL, 'OS04G0163150 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(239746, NULL, 'PTHR46517', NULL, NULL, NULL, NULL, 'FRUCTOSE-2,6-BISPHOSPHATASE TIGAR', NULL, NULL, NULL, 8),
(239747, NULL, 'PTHR21064', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(239748, NULL, 'PTHR35496', NULL, NULL, NULL, NULL, '2S SEED STORAGE PROTEIN 1-RELATED', NULL, NULL, 5887, 8),
(239749, NULL, 'PTHR47771', NULL, NULL, NULL, NULL, 'LD27203P-RELATED', NULL, NULL, NULL, 8),
(239750, NULL, 'PTHR38461', NULL, NULL, NULL, NULL, '4-DEOXY-L-THREO-5-HEXOSULOSE-URONATE KETOL-ISOMERASE', NULL, NULL, 6661, 8),
(239751, NULL, 'PTHR10790', NULL, NULL, NULL, NULL, 'TPR-DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(239752, NULL, 'PTHR46102', NULL, NULL, NULL, NULL, 'AXIN', NULL, NULL, 33816, 8),
(239753, NULL, 'PTHR43752', NULL, NULL, NULL, NULL, 'BNR/ASP-BOX REPEAT FAMILY PROTEIN', NULL, NULL, NULL, 8),
(239754, NULL, 'PTHR37774', NULL, NULL, NULL, NULL, 'ATP SYNTHASE PROTEIN MI25-RELATED', NULL, NULL, 35814, 8),
(239755, NULL, 'PTHR46290', NULL, NULL, NULL, NULL, 'DI-N-ACETYLCHITOBIASE', NULL, NULL, NULL, 8),
(239756, NULL, 'PTHR47301', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC681006', NULL, NULL, 33746, 8),
(239757, NULL, 'PTHR47389', NULL, NULL, NULL, NULL, 'OS09G0436400 PROTEIN', NULL, NULL, NULL, 8),
(239758, NULL, 'PTHR30258', NULL, NULL, NULL, NULL, 'TYPE II SECRETION SYSTEM PROTEIN GSPE-RELATED', NULL, NULL, NULL, 8),
(239759, NULL, 'PTHR15191', NULL, NULL, NULL, NULL, 'PROTEIN CBG20567', NULL, NULL, NULL, 8),
(239760, NULL, 'PTHR43371', NULL, NULL, NULL, NULL, 'VITAMIN B12-DEPENDENT RIBONUCLEOTIDE REDUCTASE', NULL, NULL, NULL, 8),
(239761, NULL, 'PTHR21152', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE CLASS V', NULL, NULL, NULL, 8),
(239762, NULL, 'PTHR36617', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(239763, NULL, 'PTHR42341', NULL, NULL, NULL, NULL, 'HYDROPHOBIN', NULL, NULL, 9083, 8),
(239764, NULL, 'PTHR32552', NULL, NULL, NULL, NULL, 'FERRICHROME IRON RECEPTOR-RELATED', NULL, NULL, 33080, 8),
(239765, NULL, 'PTHR36168', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(239766, NULL, 'PTHR12497', NULL, NULL, NULL, NULL, 'TAZ PROTEIN  TAFAZZIN', NULL, NULL, 4628, 8),
(239767, NULL, 'PTHR48223', NULL, NULL, NULL, NULL, 'DEFECTIVE 2759, PUTATIVE ISOFORM 1-RELATED', NULL, NULL, NULL, 8),
(239768, NULL, 'PTHR11961', NULL, NULL, NULL, NULL, 'CYTOCHROME C', NULL, NULL, 6028, 8),
(239769, NULL, 'PTHR16523', NULL, NULL, NULL, NULL, 'PEST PROTEOLYTIC SIGNAL-CONTAINING NUCLEAR PROTEIN', NULL, NULL, 26966, 8),
(239770, NULL, 'PTHR21055', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 22982, 8),
(239771, NULL, 'PTHR15352', NULL, NULL, NULL, NULL, 'LYMPHOID-RESTRICTED MEMBRANE PROTEIN, JAW1', NULL, NULL, 12602, 8);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(239772, NULL, 'PTHR16172', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(239773, NULL, 'PTHR38494', NULL, NULL, NULL, NULL, 'STEROID RECEPTOR-ASSOCIATED AND REGULATED PROTEIN', NULL, NULL, 25912, 8),
(239774, NULL, 'PTHR46527', NULL, NULL, NULL, NULL, 'NUCLEOPORIN-LIKE PROTEIN 2', NULL, NULL, NULL, 8),
(239775, NULL, 'PTHR34282', NULL, NULL, NULL, NULL, 'OS01G0228800 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(239776, NULL, 'PTHR31940', NULL, NULL, NULL, NULL, 'SMALL KINETOCHORE-ASSOCIATED PROTEIN', NULL, NULL, 31187, 8),
(239777, NULL, 'PTHR39222', NULL, NULL, NULL, NULL, 'MCG9903', NULL, NULL, 31418, 8),
(239778, NULL, 'PTHR38687', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN DEDD-RELATED', NULL, NULL, NULL, 8),
(239779, NULL, 'PTHR20275', NULL, NULL, NULL, NULL, 'NAD KINASE', NULL, NULL, NULL, 8),
(239780, NULL, 'PTHR10552', NULL, NULL, NULL, NULL, 'U2 SMALL NUCLEAR RIBONUCLEOPROTEIN A', NULL, NULL, 37700, 8),
(239781, NULL, 'PTHR47269', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP21-4', NULL, NULL, NULL, 8),
(239782, NULL, 'PTHR46832', NULL, NULL, NULL, NULL, '5''-METHYLTHIOADENOSINE/S-ADENOSYLHOMOCYSTEINE NUCLEOSIDASE', NULL, NULL, NULL, 8),
(239783, NULL, 'PTHR16087', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 206', NULL, NULL, 26435, 8),
(239784, NULL, 'PTHR10900', NULL, NULL, NULL, NULL, 'PERIOSTIN-RELATED', NULL, NULL, NULL, 8),
(239785, NULL, 'PTHR38766', NULL, NULL, NULL, NULL, 'FLAGELLAR PROTEIN FLIO', NULL, NULL, NULL, 8),
(239786, NULL, 'PTHR37355', NULL, NULL, NULL, NULL, 'PLACENTA-SPECIFIC PROTEIN 9', NULL, NULL, 24857, 8),
(239787, NULL, 'PTHR47130', NULL, NULL, NULL, NULL, 'SI:DKEY-19B23.11-RELATED', NULL, NULL, NULL, 8),
(239788, NULL, 'PTHR46291', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', NULL, NULL, 35754, 8),
(239789, NULL, 'PTHR17600', NULL, NULL, NULL, NULL, 'MESODERM DEVELOPMENT CANDIDATE 2', NULL, NULL, 14636, 8),
(239790, NULL, 'PTHR35300', NULL, NULL, NULL, NULL, 'COACTIVATOR CBP, KIX DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(239791, NULL, 'PTHR30267', NULL, NULL, NULL, NULL, 'PROTEIN KINASE PRKA', NULL, NULL, NULL, 8),
(239792, NULL, 'PTHR22763', NULL, NULL, NULL, NULL, 'RING ZINC FINGER PROTEIN', NULL, NULL, NULL, 8),
(239793, NULL, 'PTHR47313', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA LARGE SUBUNIT METHYLTRANSFERASE K/L', NULL, NULL, NULL, 8),
(239794, NULL, 'PTHR45735', NULL, NULL, NULL, NULL, 'CLEAVAGE STIMULATION FACTOR SUBUNIT 2', NULL, NULL, NULL, 8),
(239795, NULL, 'PTHR37151', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 61', NULL, NULL, 23595, 8),
(239796, NULL, 'PTHR36373', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(239797, NULL, 'PTHR23176', NULL, NULL, NULL, NULL, 'RHO/RAC/CDC GTPASE-ACTIVATING PROTEIN', NULL, NULL, NULL, 8),
(239798, NULL, 'PTHR13639', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY FACTOR 4 HOMOLOG, MITOCHONDRIAL', NULL, NULL, 32461, 8),
(239799, NULL, 'PTHR42918', NULL, NULL, NULL, NULL, 'LYSYL-TRNA SYNTHETASE', NULL, NULL, NULL, 8),
(239800, NULL, 'PTHR15271', NULL, NULL, NULL, NULL, 'CHROMATIN ASSEMBLY FACTOR 1 SUBUNIT B', NULL, NULL, 36675, 8),
(239801, NULL, 'PTHR15426', NULL, NULL, NULL, NULL, 'PROTEIN DEPP1', NULL, NULL, 13899, 8),
(239802, NULL, 'PTHR47976', NULL, NULL, NULL, NULL, 'G-TYPE LECTIN S-RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE SD2-5', NULL, NULL, NULL, 8),
(239803, NULL, 'PTHR46240', NULL, NULL, NULL, NULL, 'SER/THR PROTEIN KINASE ULK4', NULL, NULL, 37591, 8),
(239804, NULL, 'PTHR15375', NULL, NULL, NULL, NULL, 'ACTIVATOR OF S-PHASE KINASE-RELATED', NULL, NULL, NULL, 8),
(239805, NULL, 'PTHR12515', NULL, NULL, NULL, NULL, 'STERILE ALPHA MOTIF DOMAIN CONTAINING PROTEIN 4-RELATED', NULL, NULL, NULL, 8),
(239806, NULL, 'PTHR12190', NULL, NULL, NULL, NULL, 'A-KINASE ANCHOR PROTEIN  AKAP  8', NULL, NULL, 7044, 8),
(239807, NULL, 'PTHR24324', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HHEX', NULL, NULL, NULL, 8),
(239808, NULL, 'PTHR12686', NULL, NULL, NULL, NULL, '3''-5'' EXORIBONUCLEASE CSL4-RELATED', NULL, NULL, 33125, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(239809, NULL, 'PTHR46137', NULL, NULL, NULL, NULL, 'OS05G0310600 PROTEIN', NULL, NULL, NULL, 8),
(239810, NULL, 'PTHR43069', NULL, NULL, NULL, NULL, 'FUMARYLACETOACETASE', NULL, NULL, 303, 8),
(239811, NULL, 'PTHR12487', NULL, NULL, NULL, NULL, 'TEASHIRT-RELATED', NULL, NULL, 23562, 8),
(239812, NULL, 'PTHR10774', NULL, NULL, NULL, NULL, 'EXTENDED SYNAPTOTAGMIN-RELATED', NULL, NULL, 33521, 8),
(239813, NULL, 'PTHR37371', NULL, NULL, NULL, NULL, 'OS08G0180400 PROTEIN', NULL, NULL, NULL, 8),
(239814, NULL, 'PTHR46354', NULL, NULL, NULL, NULL, 'DOG1 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(239815, NULL, 'PTHR22980', NULL, NULL, NULL, NULL, 'CORTISTATIN', NULL, NULL, NULL, 8),
(239816, NULL, 'PTHR38471', NULL, NULL, NULL, NULL, '', NULL, NULL, 10099, 8),
(239817, NULL, 'PTHR43375', NULL, NULL, NULL, NULL, 'OROTIDINE 5''-PHOSPHATE DECARBOXYLASE', NULL, NULL, 12206, 8),
(239818, NULL, 'PTHR24015', NULL, NULL, NULL, NULL, 'OS07G0578800 PROTEIN-RELATED', NULL, NULL, 36004, 8),
(239819, NULL, 'PTHR46099', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(239820, NULL, 'PTHR33426', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(239821, NULL, 'PTHR10454', NULL, NULL, NULL, NULL, 'CASPASE', NULL, NULL, 6115, 8),
(239822, NULL, 'PTHR11454', NULL, NULL, NULL, NULL, 'INSULIN/INSULIN GROWTH FACTOR', NULL, NULL, 4085, 8),
(239823, NULL, 'PTHR45903', NULL, NULL, NULL, NULL, 'GLUTAMATE-RICH WD REPEAT-CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(239824, NULL, 'PTHR36387', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLMURAMOYL-L-ALANYL-D-GLUTAMATE-2, 6-DIAMINOPIMELATE LIGASE', NULL, NULL, NULL, 8),
(239825, NULL, 'PTHR10884', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE  UBIQUINONE  IRON-SULFUR PROTEIN 3', NULL, NULL, NULL, 8),
(239826, NULL, 'PTHR31755', NULL, NULL, NULL, NULL, 'FOLATE RECEPTOR-LIKE', NULL, NULL, 31297, 8),
(239827, NULL, 'PTHR28122', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SUBSTRATE RECEPTOR MMS22', NULL, NULL, 15598, 8),
(239828, NULL, 'PTHR34806', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY NITRATE TRANSPORTER 3.2', NULL, NULL, 19347, 8),
(239829, NULL, 'PTHR43129', NULL, NULL, NULL, NULL, 'FOSMIDOMYCIN RESISTANCE PROTEIN', NULL, NULL, NULL, 8),
(239830, NULL, 'PTHR34874', NULL, NULL, NULL, NULL, 'PROTEIN YCHN', NULL, NULL, NULL, 8),
(239831, NULL, 'PTHR13806', NULL, NULL, NULL, NULL, 'FLOTILLIN-RELATED', NULL, NULL, 25482, 8),
(239832, NULL, 'PTHR21682', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 18229, 8),
(239833, NULL, 'PTHR32022', NULL, NULL, NULL, NULL, 'D-GLUTAMATE CYCLASE, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(239834, NULL, 'PTHR18939', NULL, NULL, NULL, NULL, 'RIBOSOME BINDING PROTEIN-1', NULL, NULL, 32246, 8),
(239835, NULL, 'PTHR21368', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L9', NULL, NULL, 755, 8),
(239836, NULL, 'PTHR14581', NULL, NULL, NULL, NULL, '', NULL, NULL, 22656, 8),
(239837, NULL, 'PTHR48171', NULL, NULL, NULL, NULL, 'DUF946 FAMILY PROTEIN', NULL, NULL, NULL, 8),
(239838, NULL, 'PTHR10779', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN ROADBLOCK', NULL, NULL, NULL, 8),
(239839, NULL, 'PTHR35146', NULL, NULL, NULL, NULL, 'UPF0178 PROTEIN YAII', NULL, NULL, 6168, 8),
(239840, NULL, 'PTHR10199', NULL, NULL, NULL, NULL, 'THROMBOSPONDIN', NULL, NULL, NULL, 8),
(239841, NULL, 'PTHR42748', NULL, NULL, NULL, NULL, 'NITROGEN METABOLITE REPRESSION PROTEIN NMRA FAMILY MEMBER', NULL, NULL, NULL, 8),
(239842, NULL, 'PTHR14614', NULL, NULL, NULL, NULL, 'HEPATOCELLULAR CARCINOMA-ASSOCIATED ANTIGEN', NULL, NULL, 16800, 8),
(239843, NULL, 'PTHR18947', NULL, NULL, NULL, NULL, 'HOOK PROTEINS', NULL, NULL, NULL, 8),
(239844, NULL, 'PTHR13178', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE SGDH SUBUNIT', NULL, NULL, 18017, 8),
(239845, NULL, 'PTHR31915', NULL, NULL, NULL, NULL, 'SKICH DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(239846, NULL, 'PTHR13530', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 7', NULL, NULL, 27137, 8),
(239847, NULL, 'PTHR23196', NULL, NULL, NULL, NULL, 'PAX TRANSCRIPTION ACTIVATION DOMAIN INTERACTING PROTEIN', NULL, NULL, NULL, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(239848, NULL, 'PTHR40057', NULL, NULL, NULL, NULL, 'SLR1162 PROTEIN', NULL, NULL, 32635, 8),
(239849, NULL, 'PTHR30005', NULL, NULL, NULL, NULL, 'EXOPOLYPHOSPHATASE', NULL, NULL, NULL, 8),
(239850, NULL, 'PTHR32154', NULL, NULL, NULL, NULL, 'PYRUVATE-FLAVODOXIN OXIDOREDUCTASE-RELATED', NULL, NULL, NULL, 8),
(239851, NULL, 'PTHR12132', NULL, NULL, NULL, NULL, 'DNA REPAIR AND RECOMBINATION PROTEIN RAD52, RAD59', NULL, NULL, 6898, 8),
(239852, NULL, 'PTHR34291', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', NULL, NULL, 28963, 8),
(239853, NULL, 'PTHR37354', NULL, NULL, NULL, NULL, 'CHROMOSOME ALIGNMENT-MAINTAINING PHOSPHOPROTEIN 1', NULL, NULL, 33604, 8),
(239854, NULL, 'PTHR40314', NULL, NULL, NULL, NULL, 'PROTEIN CBG09102-RELATED', NULL, NULL, NULL, 8),
(239855, NULL, 'PTHR47340', NULL, NULL, NULL, NULL, 'DUPLICATED HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(239856, NULL, 'PTHR10686', NULL, NULL, NULL, NULL, 'FOLATE TRANSPORTER', NULL, NULL, 2897, 8),
(239857, NULL, 'PTHR31163', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER', NULL, NULL, NULL, 8),
(239858, NULL, 'PTHR34104', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 254', NULL, NULL, 24803, 8),
(239859, NULL, 'PTHR43633', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE YQHD', NULL, NULL, 36888, 8),
(239860, NULL, 'PTHR24373', NULL, NULL, NULL, NULL, 'SLIT RELATED LEUCINE-RICH REPEAT NEURONAL PROTEIN', NULL, NULL, NULL, 8),
(239861, NULL, 'PTHR36877', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 13', NULL, NULL, 25589, 8),
(239862, NULL, 'PTHR11615', NULL, NULL, NULL, NULL, 'NITRATE, FORMATE, IRON DEHYDROGENASE', NULL, NULL, NULL, 8),
(239863, NULL, 'PTHR33516', NULL, NULL, NULL, NULL, 'LEXA REPRESSOR', NULL, NULL, NULL, 8),
(239864, NULL, 'PTHR19876', NULL, NULL, NULL, NULL, 'COATOMER', NULL, NULL, NULL, 8),
(239865, NULL, 'PTHR43607', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE CATALYTIC SUBUNIT A', NULL, NULL, 16998, 8),
(239866, NULL, 'PTHR42904', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE, NUDC SUBFAMILY', NULL, NULL, NULL, 8),
(239867, NULL, 'PTHR36764', NULL, NULL, NULL, NULL, 'TRNA (ILE)-LYSIDINE SYNTHASE', NULL, NULL, NULL, 8),
(239868, NULL, 'PTHR28263', NULL, NULL, NULL, NULL, 'GOLGI TO ER TRAFFIC PROTEIN 2', NULL, NULL, 21659, 8),
(239869, NULL, 'PTHR19354', NULL, NULL, NULL, NULL, 'ZIPPER PUTATIVE TUMOR SUPPRESSOR 2 HOMOLOG-LIKE PROTEIN-RELATED', NULL, NULL, 34753, 8),
(239870, NULL, 'PTHR35367', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(239871, NULL, 'PTHR39087', NULL, NULL, NULL, NULL, 'UPF0104 MEMBRANE PROTEIN MJ1595', NULL, NULL, NULL, 8),
(239872, NULL, 'PTHR47485', NULL, NULL, NULL, NULL, 'THYLAKOID LUMENAL 17.4 KDA PROTEIN, CHLOROPLASTIC', NULL, NULL, 36848, 8),
(239873, NULL, 'PTHR48251', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 160', NULL, NULL, NULL, 8),
(239874, NULL, 'PTHR43798', NULL, NULL, NULL, NULL, 'MONOACYLGLYCEROL LIPASE', NULL, NULL, NULL, 8),
(239875, NULL, 'PTHR43776', NULL, NULL, NULL, NULL, 'TRANSPORT ATP-BINDING PROTEIN', NULL, NULL, NULL, 8),
(239876, NULL, 'PTHR46726', NULL, NULL, NULL, NULL, 'TWO PORE CHANNEL 3', NULL, NULL, NULL, 8),
(239877, NULL, 'PTHR36024', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT PROTEIN SKIP35', NULL, NULL, 36917, 8),
(239878, NULL, 'PTHR28008', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G10980)-RELATED', NULL, NULL, NULL, 8),
(239879, NULL, 'PTHR12538', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S26', NULL, NULL, 4610, 8),
(239880, NULL, 'PTHR15628', NULL, NULL, NULL, NULL, 'RWD DOMAIN-CONTAINING PROTEIN 3', NULL, NULL, 30604, 8),
(239881, NULL, 'PTHR33308', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN HYDROLASE FLGJ', NULL, NULL, NULL, 8),
(239882, NULL, 'PTHR47276', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 22', NULL, NULL, 34501, 8),
(239883, NULL, 'PTHR31274', NULL, NULL, NULL, NULL, 'PROTEIN ECM3', NULL, NULL, 27940, 8),
(239884, NULL, 'PTHR16458', NULL, NULL, NULL, NULL, 'GLYCINE N-METHYLTRANSFERASE', NULL, NULL, 12467, 8);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(239885, NULL, 'PTHR10792', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L24', NULL, NULL, 42, 8),
(239886, NULL, 'PTHR38730', NULL, NULL, NULL, NULL, 'SLL7028 PROTEIN', NULL, NULL, NULL, 8),
(239887, NULL, 'PTHR11208', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN RELATED', NULL, NULL, 36883, 8),
(239888, NULL, 'PTHR23169', NULL, NULL, NULL, NULL, 'ENVOPLAKIN', NULL, NULL, 34576, 8),
(239889, NULL, 'PTHR35531', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YBCI-RELATED', NULL, NULL, NULL, 8),
(239890, NULL, 'PTHR42951', NULL, NULL, NULL, NULL, 'METALLO-BETA-LACTAMASE DOMAIN-CONTAINING', NULL, NULL, NULL, 8),
(239891, NULL, 'PTHR35718', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(239892, NULL, 'PTHR22091', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 28873, 8),
(239893, NULL, 'PTHR46181', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL GLYCINE TRANSPORTER', NULL, NULL, NULL, 8),
(239894, NULL, 'PTHR47975', NULL, NULL, NULL, NULL, 'S-LOCUS LECTIN KINASE FAMILY PROTEIN', NULL, NULL, NULL, 8),
(239895, NULL, 'PTHR47266', NULL, NULL, NULL, NULL, 'ENDONUCLEASE-RELATED', NULL, NULL, NULL, 8),
(239896, NULL, 'PTHR38440', NULL, NULL, NULL, NULL, 'UPF0398 PROTEIN YPSA', NULL, NULL, 9925, 8),
(239897, NULL, 'PTHR35004', NULL, NULL, NULL, NULL, 'TRANSPOSASE RV3428C-RELATED', NULL, NULL, NULL, 8),
(239898, NULL, 'PTHR42701', NULL, NULL, NULL, NULL, 'IMIDAZOLE GLYCEROL PHOSPHATE SYNTHASE SUBUNIT HISH', NULL, NULL, 10763, 8),
(239899, NULL, 'PTHR18804', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN', NULL, NULL, NULL, 8),
(239900, NULL, 'PTHR31822', NULL, NULL, NULL, NULL, 'SERINE-RICH SINGLE-PASS MEMBRANE PROTEIN 1', NULL, NULL, 23944, 8),
(239901, NULL, 'PTHR32246', NULL, NULL, NULL, NULL, 'INGRESSION PROTEIN FIC1', NULL, NULL, NULL, 8),
(239902, NULL, 'PTHR13518', NULL, NULL, NULL, NULL, 'PUTATIVE TREBLE-CLEF ZINC-FINGER C2ORF42 FAMILY MEMBER', NULL, NULL, 23584, 8),
(239903, NULL, 'PTHR46365', NULL, NULL, NULL, NULL, 'COPPER TRANSPORT PROTEIN ATOX1', NULL, NULL, NULL, 8),
(239904, NULL, 'PTHR10270', NULL, NULL, NULL, NULL, 'SOX TRANSCRIPTION FACTOR', NULL, NULL, NULL, 8),
(239905, NULL, 'PTHR46565', NULL, NULL, NULL, NULL, 'COLD SHOCK DOMAIN PROTEIN 2', NULL, NULL, NULL, 8),
(239906, NULL, 'PTHR33389', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE (DUF2921)-RELATED', NULL, NULL, 17896, 8),
(239907, NULL, 'PTHR21649', NULL, NULL, NULL, NULL, 'CHLOROPHYLL A/B BINDING PROTEIN', NULL, NULL, 7257, 8),
(239908, NULL, 'PTHR47846', NULL, NULL, NULL, NULL, 'OS06G0681300 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(239909, NULL, 'PTHR31789', NULL, NULL, NULL, NULL, 'OS05G0482600 PROTEIN', NULL, NULL, NULL, 8),
(239910, NULL, 'PTHR15228', NULL, NULL, NULL, NULL, 'SPERMATHECAL PHYSIOLOGY VARIANT', NULL, NULL, NULL, 8),
(239911, NULL, 'PTHR24305', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', NULL, NULL, NULL, 8),
(239912, NULL, 'PTHR13463', NULL, NULL, NULL, NULL, 'PROTEIN C10', NULL, NULL, 25987, 8),
(239913, NULL, 'PTHR14155', NULL, NULL, NULL, NULL, 'RING FINGER DOMAIN-CONTAINING', NULL, NULL, NULL, 8),
(239914, NULL, 'PTHR13401', NULL, NULL, NULL, NULL, 'RAGULATOR COMPLEX PROTEIN LAMTOR1', NULL, NULL, NULL, 8),
(239915, NULL, 'PTHR21444', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 180', NULL, NULL, NULL, 8),
(239916, NULL, 'PTHR11594', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S27', NULL, NULL, 5666, 8),
(239917, NULL, 'PTHR13600', NULL, NULL, NULL, NULL, 'LEUCINE CARBOXYL METHYLTRANSFERASE', NULL, NULL, 19705, 8),
(239918, NULL, 'PTHR12639', NULL, NULL, NULL, NULL, 'VITAMIN K-DEPENDENT GAMMA-CARBOXYLASE', NULL, NULL, 1312, 8),
(239919, NULL, 'PTHR33414', NULL, NULL, NULL, NULL, 'PROTEIN PLASTID MOVEMENT IMPAIRED 1-RELATED 1', NULL, NULL, 27258, 8),
(239920, NULL, 'PTHR11438', NULL, NULL, NULL, NULL, 'PROENKEPHALIN', NULL, NULL, 1075, 8),
(239921, NULL, 'PTHR47267', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(239922, NULL, 'PTHR15384', NULL, NULL, NULL, NULL, 'PROTEIN EVI2B', NULL, NULL, 31253, 8),
(239923, NULL, 'PTHR11830', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S3A', NULL, NULL, NULL, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(239924, NULL, 'PTHR12241', NULL, NULL, NULL, NULL, 'TUBULIN POLYGLUTAMYLASE', NULL, NULL, NULL, 8),
(239925, NULL, 'PTHR47756', NULL, NULL, NULL, NULL, 'BLL6612 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(239926, NULL, 'PTHR15346', NULL, NULL, NULL, NULL, 'DYNACTIN SUBUNIT', NULL, NULL, 25453, 8),
(239927, NULL, 'PTHR13337', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE', NULL, NULL, 4380, 8),
(239928, NULL, 'PTHR32178', NULL, NULL, NULL, NULL, 'FAM187', NULL, NULL, 27129, 8),
(239929, NULL, 'PTHR35318', NULL, NULL, NULL, NULL, 'BNAA10G08410D PROTEIN', NULL, NULL, NULL, 8),
(239930, NULL, 'PTHR43520', NULL, NULL, NULL, NULL, 'ATP7, ISOFORM B', NULL, NULL, NULL, 8),
(239931, NULL, 'PTHR48261', NULL, NULL, NULL, NULL, 'ACETYLGLUCOSAMINYLTRANSFERASE', NULL, NULL, NULL, 8),
(239932, NULL, 'PTHR11127', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L14', NULL, NULL, 28180, 8),
(239933, NULL, 'PTHR46323', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', NULL, NULL, NULL, 8),
(239934, NULL, 'PTHR12217', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 2D', NULL, NULL, 27371, 8),
(239935, NULL, 'PTHR37458', NULL, NULL, NULL, NULL, 'THISBE', NULL, NULL, NULL, 8),
(239936, NULL, 'PTHR46760', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR 1', NULL, NULL, NULL, 8),
(239937, NULL, 'PTHR38792', NULL, NULL, NULL, NULL, 'BNR/ASP-BOX REPEAT DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_7G06430)-RELATED', NULL, NULL, NULL, 8),
(239938, NULL, 'PTHR46927', NULL, NULL, NULL, NULL, 'AGAP005574-PA', NULL, NULL, NULL, 8),
(239939, NULL, 'PTHR12865', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-KINASE TYPE-II', NULL, NULL, 33135, 8),
(239940, NULL, 'PTHR43167', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_6G01830)-RELATED', NULL, NULL, NULL, 8),
(239941, NULL, 'PTHR36786', NULL, NULL, NULL, NULL, '2-ISOPROPYLMALATE SYNTHASE', NULL, NULL, NULL, 8),
(239942, NULL, 'PTHR35110', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(239943, NULL, 'PTHR43052', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(239944, NULL, 'PTHR30509', NULL, NULL, NULL, NULL, 'P-HYDROXYBENZOIC ACID EFFLUX PUMP SUBUNIT-RELATED', NULL, NULL, NULL, 8),
(239945, NULL, 'PTHR34945', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(239946, NULL, 'PTHR37512', NULL, NULL, NULL, NULL, 'TRIFUNCTIONAL NAD BIOSYNTHESIS/REGULATOR PROTEIN NADR', NULL, NULL, NULL, 8),
(239947, NULL, 'PTHR36370', NULL, NULL, NULL, NULL, 'THYLAKOID SOLUBLE PHOSPHOPROTEIN', NULL, NULL, 18828, 8),
(239948, NULL, 'PTHR24067', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2', NULL, NULL, NULL, 8),
(239949, NULL, 'PTHR13156', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE 13 KD-A SUBUNIT', NULL, NULL, NULL, 8),
(239950, NULL, 'PTHR23106', NULL, NULL, NULL, NULL, 'ANGIOGENIC FACTOR WITH G PATCH AND FHA DOMAINS 1', NULL, NULL, NULL, 8),
(239951, NULL, 'PTHR38377', NULL, NULL, NULL, NULL, 'THREONINE-TRNA LIGASE 2', NULL, NULL, NULL, 8),
(239952, NULL, 'PTHR34630', NULL, NULL, NULL, NULL, 'OS11G0677101 PROTEIN', NULL, NULL, NULL, 8),
(239953, NULL, 'PTHR37213', NULL, NULL, NULL, NULL, 'SUBTILISIN-LIKE PROTEASE', NULL, NULL, NULL, 8),
(239954, NULL, 'PTHR21442', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 19857, 8),
(239955, NULL, 'PTHR46806', NULL, NULL, NULL, NULL, 'F5/8 TYPE C DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(239956, NULL, 'PTHR12862', NULL, NULL, NULL, NULL, 'BADF TYPE ATPASE DOMAIN-CONTAINING PROTEIN', NULL, NULL, 33378, 8),
(239957, NULL, 'PTHR36912', NULL, NULL, NULL, NULL, 'ANTIGEN 332, DBL-LIKE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(239958, NULL, 'PTHR33991', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RECO', NULL, NULL, 2058, 8),
(239959, NULL, 'PTHR48000', NULL, NULL, NULL, NULL, 'OS09G0431300 PROTEIN', NULL, NULL, NULL, 8),
(239960, NULL, 'PTHR22647', NULL, NULL, NULL, NULL, 'SH3 DOMAIN AND TETRATRICOPEPTIDE REPEATS CONTAINING PROTEIN', NULL, NULL, 35612, 8),
(239961, NULL, 'PTHR35797', NULL, NULL, NULL, NULL, 'PROTEASE-RELATED', NULL, NULL, 34297, 8);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(239962, NULL, 'PTHR46163', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE-RELATED', NULL, NULL, NULL, 8),
(239963, NULL, 'PTHR34298', NULL, NULL, NULL, NULL, 'SEGREGATION AND CONDENSATION PROTEIN B', NULL, NULL, 11445, 8),
(239964, NULL, 'PTHR47069', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(239965, NULL, 'PTHR12644', NULL, NULL, NULL, NULL, 'ARP2/3 COMPLEX 16 KD SUBUNIT  P16-ARC', NULL, NULL, 3311, 8),
(239966, NULL, 'PTHR47946', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 78A7-RELATED', NULL, NULL, NULL, 8),
(239967, NULL, 'PTHR40040', NULL, NULL, NULL, NULL, 'SMALL HYDROPHOBIC PROTEIN-RELATED', NULL, NULL, NULL, 8),
(239968, NULL, 'PTHR40132', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(239969, NULL, 'PTHR47571', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE 3-3', NULL, NULL, 36130, 8),
(239970, NULL, 'PTHR36071', NULL, NULL, NULL, NULL, 'DNA DOUBLE-STRAND BREAK REPAIR PROTEIN', NULL, NULL, NULL, 8),
(239971, NULL, 'PTHR11629', NULL, NULL, NULL, NULL, 'VACUOLAR PROTON ATPASES', NULL, NULL, 687, 8),
(239972, NULL, 'PTHR46437', NULL, NULL, NULL, NULL, 'MORN REPEAT-CONTAINING PROTEIN 5', NULL, NULL, 35389, 8),
(239973, NULL, 'PTHR47487', NULL, NULL, NULL, NULL, 'OS06G0651300 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(239974, NULL, 'PTHR31837', NULL, NULL, NULL, NULL, 'CYTOCHROME B-245 CHAPERONE 1', NULL, NULL, 26193, 8),
(239975, NULL, 'PTHR19869', NULL, NULL, NULL, NULL, 'SPERMATID WD-REPEAT PROTEIN', NULL, NULL, 31106, 8),
(239976, NULL, 'PTHR23116', NULL, NULL, NULL, NULL, 'PDZ DOMAIN CONTAINING WHIRLIN AND HARMONIN-RELATED', NULL, NULL, NULL, 8),
(239977, NULL, 'PTHR44489', NULL, NULL, NULL, NULL, '', NULL, NULL, 34645, 8),
(239978, NULL, 'PTHR13303', NULL, NULL, NULL, NULL, 'PREFOLDIN SUBUNIT 2', NULL, NULL, 26062, 8),
(239979, NULL, 'PTHR23063', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID ACYLTRANSFERASE', NULL, NULL, NULL, 8),
(239980, NULL, 'PTHR21724', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(239981, NULL, 'PTHR34946', NULL, NULL, NULL, NULL, 'OS03G0310200 PROTEIN', NULL, NULL, NULL, 8),
(239982, NULL, 'PTHR12768', NULL, NULL, NULL, NULL, 'BECLIN 1', NULL, NULL, 6781, 8),
(239983, NULL, 'PTHR43140', NULL, NULL, NULL, NULL, 'TYPE-1 RESTRICTION ENZYME ECOKI SPECIFICITY PROTEIN', NULL, NULL, NULL, 8),
(239984, NULL, 'PTHR22903', NULL, NULL, NULL, NULL, 'PLEKHH PROTEIN', NULL, NULL, NULL, 8),
(239985, NULL, 'PTHR43943', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE (SDR FAMILY) MEMBER 4', NULL, NULL, NULL, 8),
(239986, NULL, 'PTHR40547', NULL, NULL, NULL, NULL, 'SLL0298 PROTEIN', NULL, NULL, NULL, 8),
(239987, NULL, 'PTHR37829', NULL, NULL, NULL, NULL, 'PHAGE-LIKE ELEMENT PBSX PROTEIN XKDT', NULL, NULL, NULL, 8),
(239988, NULL, 'PTHR11409', NULL, NULL, NULL, NULL, 'ADENOSINE DEAMINASE', NULL, NULL, 4550, 8),
(239989, NULL, 'PTHR22978', NULL, NULL, NULL, NULL, 'B-CELL TRANSLOCATION GENE', NULL, NULL, 27824, 8),
(239990, NULL, 'PTHR23092', NULL, NULL, NULL, NULL, 'POLY(A) RNA POLYMERASE', NULL, NULL, 33784, 8),
(239991, NULL, 'PTHR35750', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID HYDROPEROXIDE GLUTATHIONE PEROXIDASE', NULL, NULL, NULL, 8),
(239992, NULL, 'PTHR40393', NULL, NULL, NULL, NULL, 'LYSINE BIOSYNTHESIS PROTEIN-RELATED-RELATED', NULL, NULL, 436, 8),
(239993, NULL, 'PTHR36144', NULL, NULL, NULL, NULL, 'S-ANTIGEN PROTEIN', NULL, NULL, NULL, 8),
(239994, NULL, 'PTHR37154', NULL, NULL, NULL, NULL, 'MITOREGULIN', NULL, NULL, 30128, 8),
(239995, NULL, 'PTHR16833', NULL, NULL, NULL, NULL, 'DNA DAMAGE-INDUCIBLE TRANSCRIPT 3 DDIT3', NULL, NULL, 20467, 8),
(239996, NULL, 'PTHR45598', NULL, NULL, NULL, NULL, 'PROTEIN CBG11839-RELATED', NULL, NULL, NULL, 8),
(239997, NULL, 'PTHR39355', NULL, NULL, NULL, NULL, 'PROTEIN CBG20624', NULL, NULL, 27167, 8),
(239998, NULL, 'PTHR46402', NULL, NULL, NULL, NULL, 'SET AND MYND DOMAIN-CONTAINING PROTEIN 5', NULL, NULL, NULL, 8),
(239999, NULL, 'PTHR21723', NULL, NULL, NULL, NULL, 'RESISTANCE TO INHIBITORS OF CHOLINESTERASE PROTEIN 3  RIC3', NULL, NULL, 22708, 8),
(240000, NULL, 'PTHR15104', NULL, NULL, NULL, NULL, 'DIHYDROPTERIDINE REDUCTASE', NULL, NULL, NULL, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(240001, NULL, 'PTHR37538', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(240002, NULL, 'PTHR10217', NULL, NULL, NULL, NULL, 'VOLTAGE AND LIGAND GATED POTASSIUM CHANNEL', NULL, NULL, NULL, 8),
(240003, NULL, 'PTHR40048', NULL, NULL, NULL, NULL, 'RHAMNOSYL O-METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(240004, NULL, 'PTHR42695', NULL, NULL, NULL, NULL, 'GLUTAMINE AMIDOTRANSFERASE YLR126C-RELATED', NULL, NULL, 34625, 8),
(240005, NULL, 'PTHR35530', NULL, NULL, NULL, NULL, 'TAUTOMERASE-RELATED', NULL, NULL, NULL, 8),
(240006, NULL, 'PTHR33488', NULL, NULL, NULL, NULL, 'ZGC:162509', NULL, NULL, NULL, 8),
(240007, NULL, 'PTHR24116', NULL, NULL, NULL, NULL, 'KINASE D-INTERACTING SUBSTRATE OF 220 KDA', NULL, NULL, NULL, 8),
(240008, NULL, 'PTHR40736', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(240009, NULL, 'PTHR36649', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(240010, NULL, 'PTHR21448', NULL, NULL, NULL, NULL, 'SMOOTH MUSCLE MYOSIN HEAVY CHAIN-RELATED', NULL, NULL, 31033, 8),
(240011, NULL, 'PTHR47450', NULL, NULL, NULL, NULL, 'GLUCOKINASE', NULL, NULL, NULL, 8),
(240012, NULL, 'PTHR36052', NULL, NULL, NULL, NULL, 'EXCITATORY AMINO ACID TRANSPORTER', NULL, NULL, NULL, 8),
(240013, NULL, 'PTHR43236', NULL, NULL, NULL, NULL, 'ANTITOXIN HIGA1', NULL, NULL, NULL, 8),
(240014, NULL, 'PTHR42940', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE 1-RELATED', NULL, NULL, NULL, 8),
(240015, NULL, 'PTHR16155', NULL, NULL, NULL, NULL, 'DED DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(240016, NULL, 'PTHR28567', NULL, NULL, NULL, NULL, '', NULL, NULL, 26107, 8),
(240017, NULL, 'PTHR47286', NULL, NULL, NULL, NULL, 'F3I6.9 PROTEIN', NULL, NULL, NULL, 8),
(240018, NULL, 'PTHR47803', NULL, NULL, NULL, NULL, 'TRNA-SPECIFIC ADENOSINE DEAMINASE 1', NULL, NULL, 36283, 8),
(240019, NULL, 'PTHR18881', NULL, NULL, NULL, NULL, 'POLYAMINE-MODULATED FACTOR 1-BINDING PROTEIN 1-RELATED', NULL, NULL, 33901, 8),
(240020, NULL, 'PTHR37822', NULL, NULL, NULL, NULL, 'SPORE PHOTOPRODUCT LYASE-RELATED', NULL, NULL, NULL, 8),
(240021, NULL, 'PTHR47003', NULL, NULL, NULL, NULL, 'OS01G0970900 PROTEIN', NULL, NULL, 36328, 8),
(240022, NULL, 'PTHR34277', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 26', NULL, NULL, 27236, 8),
(240023, NULL, 'PTHR34403', NULL, NULL, NULL, NULL, 'TOL-PAL SYSTEM PROTEIN TOLA', NULL, NULL, NULL, 8),
(240024, NULL, 'PTHR15215', NULL, NULL, NULL, NULL, 'CABIT DOMAIN-CONTAINING PROTEIN', NULL, NULL, 32558, 8),
(240025, NULL, 'PTHR46159', NULL, NULL, NULL, NULL, 'PROTEIN TESMIN/TSO1-LIKE CXC 2', NULL, NULL, 34759, 8),
(240026, NULL, 'PTHR48280', NULL, NULL, NULL, NULL, 'OS05G0394900 PROTEIN', NULL, NULL, NULL, 8),
(240027, NULL, 'PTHR11362', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLETHANOLAMINE-BINDING PROTEIN', NULL, NULL, 28661, 8),
(240028, NULL, 'PTHR35748', NULL, NULL, NULL, NULL, 'OS05G0358400 PROTEIN', NULL, NULL, NULL, 8),
(240029, NULL, 'PTHR22227', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 21727, 8),
(240030, NULL, 'PTHR35362', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(240031, NULL, 'PTHR43406', NULL, NULL, NULL, NULL, 'TRYPTOPHAN SYNTHASE, ALPHA CHAIN', NULL, NULL, 5400, 8),
(240032, NULL, 'PTHR31710', NULL, NULL, NULL, NULL, 'GB|AAF16529.1-RELATED', NULL, NULL, NULL, 8),
(240033, NULL, 'PTHR12322', NULL, NULL, NULL, NULL, 'DOUBLESEX AND MAB-3 RELATED TRANSCRIPTION FACTOR  DMRT', NULL, NULL, 26991, 8),
(240034, NULL, 'PTHR12044', NULL, NULL, NULL, NULL, 'BCL2 INTERACTING MEDIATOR OF CELL DEATH', NULL, NULL, NULL, 8),
(240035, NULL, 'PTHR42932', NULL, NULL, NULL, NULL, 'GENERAL STRESS PROTEIN 20U', NULL, NULL, 488, 8),
(240036, NULL, 'PTHR28618', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN POC5', NULL, NULL, 28063, 8),
(240037, NULL, 'PTHR31421', NULL, NULL, NULL, NULL, '', NULL, NULL, 9353, 8),
(240038, NULL, 'PTHR31238', NULL, NULL, NULL, NULL, 'GERMIN-LIKE PROTEIN SUBFAMILY 3 MEMBER 3', NULL, NULL, NULL, 8),
(240039, NULL, 'PTHR46969', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL PROTEIN HLDE', NULL, NULL, NULL, 8);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(240040, NULL, 'PTHR36127', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(240041, NULL, 'PTHR34132', NULL, NULL, NULL, NULL, 'EMB|CAB87627.1-RELATED', NULL, NULL, NULL, 8),
(240042, NULL, 'PTHR36203', NULL, NULL, NULL, NULL, 'ASCORBATE-SPECIFIC PTS SYSTEM EIIA COMPONENT', NULL, NULL, NULL, 8),
(240043, NULL, 'PTHR45938', NULL, NULL, NULL, NULL, 'ACP24A4-RELATED', NULL, NULL, NULL, 8),
(240044, NULL, 'PTHR21163', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 9237, 8),
(240045, NULL, 'PTHR36772', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-KINASE', NULL, NULL, NULL, 8),
(240046, NULL, 'PTHR15180', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR 3C POLYPEPTIDE 1', NULL, NULL, 34902, 8),
(240047, NULL, 'PTHR35923', NULL, NULL, NULL, NULL, 'MAJOR EXTRACELLULAR ENDOGLUCANASE', NULL, NULL, NULL, 8),
(240048, NULL, 'PTHR34448', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE', NULL, NULL, NULL, 8),
(240049, NULL, 'PTHR43133', NULL, NULL, NULL, NULL, 'RNA POLYMERASE ECF-TYPE SIGMA FACTO', NULL, NULL, 33385, 8),
(240050, NULL, 'PTHR15603', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(240051, NULL, 'PTHR34539', NULL, NULL, NULL, NULL, 'T6J4.11 PROTEIN', NULL, NULL, NULL, 8),
(240052, NULL, 'PTHR43310', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORTER YBAR-RELATED', NULL, NULL, NULL, 8),
(240053, NULL, 'PTHR30003', NULL, NULL, NULL, NULL, 'L-LACTATE PERMEASE', NULL, NULL, 3157, 8),
(240054, NULL, 'PTHR33406', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN MJ1562-RELATED', NULL, NULL, NULL, 8),
(240055, NULL, 'PTHR45569', NULL, NULL, NULL, NULL, 'SENSOR PROTEIN KDPD', NULL, NULL, NULL, 8),
(240056, NULL, 'PTHR12710', NULL, NULL, NULL, NULL, 'NUCLEAR PROTEIN LOCALIZATION 4', NULL, NULL, 17818, 8),
(240057, NULL, 'PTHR33990', NULL, NULL, NULL, NULL, 'PROTEIN YJDN-RELATED', NULL, NULL, NULL, 8),
(240058, NULL, 'PTHR21004', NULL, NULL, NULL, NULL, 'SERINE PROTEASE-RELATED', NULL, NULL, 32537, 8),
(240059, NULL, 'PTHR13031', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P SUBUNIT P30', NULL, NULL, 3874, 8),
(240060, NULL, 'PTHR21629', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(240061, NULL, 'PTHR43057', NULL, NULL, NULL, NULL, 'ARSENITE EFFLUX TRANSPORTER', NULL, NULL, 3315, 8),
(240062, NULL, 'PTHR33469', NULL, NULL, NULL, NULL, 'PROTEIN ELF4-LIKE 4', NULL, NULL, 28966, 8),
(240063, NULL, 'PTHR14313', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 6 COMPLEX LOCUS PROTEIN G5B', NULL, NULL, 32622, 8),
(240064, NULL, 'PTHR10836', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE 3-PHOSPHATE DEHYDROGENASE', NULL, NULL, 19323, 8),
(240065, NULL, 'PTHR31984', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (DUF179)-RELATED', NULL, NULL, 2682, 8),
(240066, NULL, 'PTHR42908', NULL, NULL, NULL, NULL, 'TRANSLATION ELONGATION FACTOR-RELATED', NULL, NULL, NULL, 8),
(240067, NULL, 'PTHR37929', NULL, NULL, NULL, NULL, 'GRIP AND COILED-COIL DOMAIN-CONTAINING PROTEIN PFC0235W', NULL, NULL, NULL, 8),
(240068, NULL, 'PTHR40388', NULL, NULL, NULL, NULL, 'BRYOPORIN', NULL, NULL, NULL, 8),
(240069, NULL, 'PTHR24261', NULL, NULL, NULL, NULL, 'PLASMINOGEN-RELATED', NULL, NULL, NULL, 8),
(240070, NULL, 'PTHR37515', NULL, NULL, NULL, NULL, 'YALI0C09240P', NULL, NULL, NULL, 8),
(240071, NULL, 'PTHR31903', NULL, NULL, NULL, NULL, 'F12F1.11-RELATED', NULL, NULL, NULL, 8),
(240072, NULL, 'PTHR10520', NULL, NULL, NULL, NULL, 'TRIFUNCTIONAL PURINE BIOSYNTHETIC PROTEIN ADENOSINE-3-RELATED', NULL, NULL, 3937, 8),
(240073, NULL, 'PTHR28081', NULL, NULL, NULL, NULL, 'DAMAGE-REGULATED IMPORT FACILITATOR 1-RELATED', NULL, NULL, 17871, 8),
(240074, NULL, 'PTHR43601', NULL, NULL, NULL, NULL, 'THIOREDOXIN, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(240075, NULL, 'PTHR45887', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR EIF-2B SUBUNIT EPSILON', NULL, NULL, NULL, 8),
(240076, NULL, 'PTHR39540', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(240077, NULL, 'PTHR47394', NULL, NULL, NULL, NULL, 'SMALL CELL ADHESION GLYCOPROTEIN', NULL, NULL, 34669, 8),
(240078, NULL, 'PTHR34052', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN-LIKE', NULL, NULL, NULL, 8);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(240079, NULL, 'PTHR33955', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 52', NULL, NULL, 31865, 8),
(240080, NULL, 'PTHR48083', NULL, NULL, NULL, NULL, 'MEDIUM-CHAIN SPECIFIC ACYL-COA DEHYDROGENASE, MITOCHONDRIAL-RELATED', NULL, NULL, NULL, 8),
(240081, NULL, 'PTHR15106', NULL, NULL, NULL, NULL, 'RETINOIC ACID RECEPTOR RESPONDER PROTEIN 2', NULL, NULL, 25440, 8),
(240082, NULL, 'PTHR33568', NULL, NULL, NULL, NULL, 'DNA POLYMERASE', NULL, NULL, NULL, 8),
(240083, NULL, 'PTHR47263', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE ACTIVATION PROTEIN GIT1', NULL, NULL, NULL, 8),
(240084, NULL, 'PTHR38542', NULL, NULL, NULL, NULL, 'OS04G0450500 PROTEIN', NULL, NULL, NULL, 8),
(240085, NULL, 'PTHR44809', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(240086, NULL, 'PTHR43535', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE CYTIDYLYLTRANSFERASE', NULL, NULL, NULL, 8),
(240087, NULL, 'PTHR33159', NULL, NULL, NULL, NULL, 'RPM1-INTERACTING PROTEIN 4 (RIN4) FAMILY PROTEIN', NULL, NULL, 27288, 8),
(240088, NULL, 'PTHR36844', NULL, NULL, NULL, NULL, 'PROTEASE PRSW', NULL, NULL, 26792, 8),
(240089, NULL, 'PTHR19305', NULL, NULL, NULL, NULL, 'SYNAPTOSOMAL ASSOCIATED PROTEIN', NULL, NULL, NULL, 8),
(240090, NULL, 'PTHR39415', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 27', NULL, NULL, 27529, 8),
(240091, NULL, 'PTHR22770', NULL, NULL, NULL, NULL, 'UBIQUITIN CONJUGATING ENZYME 7 INTERACTING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(240092, NULL, 'PTHR13943', NULL, NULL, NULL, NULL, 'HRAS-LIKE SUPPRESSOR - RELATED', NULL, NULL, NULL, 8),
(240093, NULL, 'PTHR11404', NULL, NULL, NULL, NULL, 'SUPEROXIDE DISMUTASE 2', NULL, NULL, NULL, 8),
(240094, NULL, 'PTHR24422', NULL, NULL, NULL, NULL, 'CHEMOTAXIS PROTEIN METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(240095, NULL, 'PTHR38083', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT CELL ADHESION MOLECULE 1-RELATED', NULL, NULL, NULL, 8),
(240096, NULL, 'PTHR21213', NULL, NULL, NULL, NULL, 'GEO09665P1-RELATED', NULL, NULL, 36315, 8),
(240097, NULL, 'PTHR13929', NULL, NULL, NULL, NULL, '1,4-DIHYDROXY-2-NAPHTHOATE OCTAPRENYLTRANSFERASE', NULL, NULL, 21752, 8),
(240098, NULL, 'PTHR37011', NULL, NULL, NULL, NULL, 'POT FAMILY PEPTIDE TRANSPORT PROTEIN-RELATED', NULL, NULL, 8161, 8),
(240099, NULL, 'PTHR35363', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(240100, NULL, 'PTHR31659', NULL, NULL, NULL, NULL, 'PROTEIN: UPF0503-LIKE PROTEIN, PUTATIVE (DUF740)-RELATED', NULL, NULL, 5033, 8),
(240101, NULL, 'PTHR30239', NULL, NULL, NULL, NULL, 'ACETOLACTATE SYNTHASE SMALL SUBUNIT', NULL, NULL, 5100, 8),
(240102, NULL, 'PTHR10037', NULL, NULL, NULL, NULL, 'VOLTAGE-GATED CATION CHANNEL  CALCIUM AND SODIUM', NULL, NULL, 34910, 8),
(240103, NULL, 'PTHR37979', NULL, NULL, NULL, NULL, 'PROTEIN HER-1', NULL, NULL, 13317, 8),
(240104, NULL, 'PTHR21371', NULL, NULL, NULL, NULL, 'KETOL-ACID REDUCTOISOMERASE, MITOCHONDRIAL', NULL, NULL, 12939, 8),
(240105, NULL, 'PTHR28069', NULL, NULL, NULL, NULL, 'GH20023P', NULL, NULL, NULL, 8),
(240106, NULL, 'PTHR12661', NULL, NULL, NULL, NULL, 'PETER PAN-RELATED', NULL, NULL, 34048, 8),
(240107, NULL, 'PTHR46016', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE', NULL, NULL, NULL, 8),
(240108, NULL, 'PTHR39933', NULL, NULL, NULL, NULL, 'CENTAURIN-GAMMA-1A-LIKE PROTEIN', NULL, NULL, NULL, 8),
(240109, NULL, 'PTHR34230', NULL, NULL, NULL, NULL, 'ASSEMBLY ABNORMAL PROTEIN 6, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(240110, NULL, 'PTHR14215', NULL, NULL, NULL, NULL, 'PROTEIN OF UNKNOWN FUNCTION DUF729', NULL, NULL, 4038, 8),
(240111, NULL, 'PTHR36926', NULL, NULL, NULL, NULL, 'COLICIN V PRODUCTION PROTEIN', NULL, NULL, NULL, 8),
(240112, NULL, 'PTHR10639', NULL, NULL, NULL, NULL, 'CLATHRIN LIGHT CHAIN', NULL, NULL, 3001, 8),
(240113, NULL, 'PTHR34112', NULL, NULL, NULL, NULL, 'C-JUN-AMINO-TERMINAL KINASE-INTERACTING PROTEIN', NULL, NULL, NULL, 8),
(240114, NULL, 'PTHR14309', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, 27111, 8),
(240115, NULL, 'PTHR14084', NULL, NULL, NULL, NULL, 'KYNURENINASE', NULL, NULL, 2098, 8),
(240116, NULL, 'PTHR16214', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 260', NULL, NULL, NULL, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(240117, NULL, 'PTHR14205', NULL, NULL, NULL, NULL, 'WD-REPEAT PROTEIN', NULL, NULL, 30104, 8),
(240118, NULL, 'PTHR39147', NULL, NULL, NULL, NULL, 'PROTEIN SPT21', NULL, NULL, 36588, 8),
(240119, NULL, 'PTHR23056', NULL, NULL, NULL, NULL, 'CALCINEURIN B', NULL, NULL, 36251, 8),
(240120, NULL, 'PTHR43781', NULL, NULL, NULL, NULL, 'SACCHAROPINE DEHYDROGENASE', NULL, NULL, NULL, 8),
(240121, NULL, 'PTHR44376', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR OF FILAMENTOUS GROWTH FLO8', NULL, NULL, 34223, 8),
(240122, NULL, 'PTHR37180', NULL, NULL, NULL, NULL, 'PRECURSOR OF CEP14', NULL, NULL, 32672, 8),
(240123, NULL, 'PTHR10826', NULL, NULL, NULL, NULL, 'COMPLEMENT COMPONENT 1', NULL, NULL, 5254, 8),
(240124, NULL, 'PTHR11987', NULL, NULL, NULL, NULL, 'ALPHA-2,8-SIALYLTRANSFERASE', NULL, NULL, NULL, 8),
(240125, NULL, 'PTHR43704', NULL, NULL, NULL, NULL, 'BSR5907 PROTEIN', NULL, NULL, NULL, 8),
(240126, NULL, 'PTHR37017', NULL, NULL, NULL, NULL, 'AB HYDROLASE-1 DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(240127, NULL, 'PTHR37067', NULL, NULL, NULL, NULL, 'PX DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(240128, NULL, 'PTHR47218', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 7 MEMBER A', NULL, NULL, 35977, 8),
(240129, NULL, 'PTHR37028', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT-RELATED', NULL, NULL, NULL, 8),
(240130, NULL, 'PTHR46685', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S15, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(240131, NULL, 'PTHR12855', NULL, NULL, NULL, NULL, 'DNA METHYLTRANSFERASE 1-ASSOCIATED PROTEIN 1 FAMILY MEMBER', NULL, NULL, 22820, 8),
(240132, NULL, 'PTHR15173', NULL, NULL, NULL, NULL, 'OREXIN', NULL, NULL, 3130, 8),
(240133, NULL, 'PTHR16501', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 12513, 8),
(240134, NULL, 'PTHR15591', NULL, NULL, NULL, NULL, 'RUN AND SH3 DOMAIN CONTAINING', NULL, NULL, NULL, 8),
(240135, NULL, 'PTHR15836', NULL, NULL, NULL, NULL, 'PERIPHILIN 1', NULL, NULL, 23763, 8),
(240136, NULL, 'PTHR14299', NULL, NULL, NULL, NULL, 'PHORBOL-12-MYRISTATE-13-ACETATE-INDUCED PROTEIN 1', NULL, NULL, 12233, 8),
(240137, NULL, 'PTHR14091', NULL, NULL, NULL, NULL, 'PERIODIC TRYPTOPHAN PROTEIN 1', NULL, NULL, 34109, 8),
(240138, NULL, 'PTHR46187', NULL, NULL, NULL, NULL, 'ALKALINE CERAMIDASE 3', NULL, NULL, 7883, 8),
(240139, NULL, 'PTHR22829', NULL, NULL, NULL, NULL, 'DEP DOMAIN PROTEIN', NULL, NULL, NULL, 8),
(240140, NULL, 'PTHR34660', NULL, NULL, NULL, NULL, 'MYB-LIKE PROTEIN X', NULL, NULL, NULL, 8),
(240141, NULL, 'PTHR34782', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLFORMYLGLYCINAMIDINE SYNTHASE', NULL, NULL, NULL, 8),
(240142, NULL, 'PTHR28489', NULL, NULL, NULL, NULL, 'RENTINAL DEGENERATION 3-LIKE', NULL, NULL, 26217, 8),
(240143, NULL, 'PTHR44328', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE L1', NULL, NULL, 35475, 8),
(240144, NULL, 'PTHR43536', NULL, NULL, NULL, NULL, 'MANNOSYLGLYCOPROTEIN ENDO-BETA-MANNOSIDASE', NULL, NULL, 35844, 8),
(240145, NULL, 'PTHR28677', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE SUBUNIT 4A-RELATED', NULL, NULL, 35157, 8),
(240146, NULL, 'PTHR17271', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY  PH  DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(240147, NULL, 'PTHR33798', NULL, NULL, NULL, NULL, 'FLAVOPROTEIN OXYGENASE', NULL, NULL, NULL, 8),
(240148, NULL, 'PTHR21210', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 10899, 8),
(240149, NULL, 'PTHR42995', NULL, NULL, NULL, NULL, 'ACETYL-COENZYME A CARBOXYLASE CARBOXYL TRANSFERASE SUBUNIT BETA, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(240150, NULL, 'PTHR28422', NULL, NULL, NULL, NULL, 'SIMILAR TO HUMAN CHROMOSOME 15 OPEN READING FRAME 39', NULL, NULL, 32532, 8),
(240151, NULL, 'PTHR28072', NULL, NULL, NULL, NULL, 'CRUCIFORM CUTTING ENDONUCLEASE 1, MITOCHONDRIAL-RELATED', NULL, NULL, 32841, 8),
(240152, NULL, 'PTHR28529', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN SWI5 HOMOLOG', NULL, NULL, 9669, 8),
(240153, NULL, 'PTHR35742', NULL, NULL, NULL, NULL, 'THYLAKOID LUMENAL 16.5 KDA PROTEIN, CHLOROPLASTIC', NULL, NULL, 32603, 8);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(240154, NULL, 'PTHR28535', NULL, NULL, NULL, NULL, 'ZINC FINGER GRF-TYPE CONTAINING 1', NULL, NULL, NULL, 8),
(240155, NULL, 'PTHR11419', NULL, NULL, NULL, NULL, 'INTERFERON GAMMA', NULL, NULL, 1035, 8),
(240156, NULL, 'PTHR32289', NULL, NULL, NULL, NULL, 'PROTEIN FAM167A', NULL, NULL, NULL, 8),
(240157, NULL, 'PTHR47974', NULL, NULL, NULL, NULL, 'OS07G0415500 PROTEIN', NULL, NULL, NULL, 8),
(240158, NULL, 'PTHR35280', NULL, NULL, NULL, NULL, 'F17L21.9', NULL, NULL, NULL, 8),
(240159, NULL, 'PTHR46547', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN GIS', NULL, NULL, 34275, 8),
(240160, NULL, 'PTHR36573', NULL, NULL, NULL, NULL, 'INTERMEMBRANE PHOSPHOLIPID TRANSPORT SYSTEM BINDING PROTEIN MLAC', NULL, NULL, 7689, 8),
(240161, NULL, 'PTHR16500', NULL, NULL, NULL, NULL, 'BRCA2-INTERACTING TRANSCRIPTIONAL REPRESSOR EMSY', NULL, NULL, 32292, 8),
(240162, NULL, 'PTHR46288', NULL, NULL, NULL, NULL, 'PHORBOL-ESTER/DAG-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(240163, NULL, 'PTHR44920', NULL, NULL, NULL, NULL, 'RHODANESE-LIKE DOMAIN-CONTAINING PROTEIN 14, CHLOROPLASTIC-RELATED', NULL, NULL, 35409, 8),
(240164, NULL, 'PTHR13429', NULL, NULL, NULL, NULL, 'FERM DOMAIN (PROTEIN4.1-EZRIN-RADIXIN-MOESIN) FAMILY', NULL, NULL, NULL, 8),
(240165, NULL, 'PTHR31057', NULL, NULL, NULL, NULL, 'E3 UFM1-PROTEIN LIGASE 1', NULL, NULL, 16399, 8),
(240166, NULL, 'PTHR11893', NULL, NULL, NULL, NULL, 'INNEXIN', NULL, NULL, 3193, 8),
(240167, NULL, 'PTHR20852', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE', NULL, NULL, NULL, 8),
(240168, NULL, 'PTHR24100', NULL, NULL, NULL, NULL, 'BUTYROPHILIN', NULL, NULL, NULL, 8),
(240169, NULL, 'PTHR34286', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(240170, NULL, 'PTHR39947', NULL, NULL, NULL, NULL, 'IP19862P', NULL, NULL, NULL, 8),
(240171, NULL, 'PTHR35465', NULL, NULL, NULL, NULL, 'CAVEOLIN-1 PROTEIN', NULL, NULL, NULL, 8),
(240172, NULL, 'PTHR43692', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLMURAMOYLALANINE--D-GLUTAMATE LIGASE', NULL, NULL, NULL, 8),
(240173, NULL, 'PTHR43333', NULL, NULL, NULL, NULL, '2-HACID_DH_C DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(240174, NULL, 'PTHR42894', NULL, NULL, NULL, NULL, 'N-(5''-PHOSPHORIBOSYL)ANTHRANILATE ISOMERASE', NULL, NULL, 36168, 8),
(240175, NULL, 'PTHR12478', NULL, NULL, NULL, NULL, 'DNA-DAMAGE-INDUCIBLE TRANSCRIPT 4 PROTEIN DDIT4', NULL, NULL, 7860, 8),
(240176, NULL, 'PTHR47629', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN-RELATED', NULL, NULL, NULL, 8),
(240177, NULL, 'PTHR46144', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 385B-LIKE', NULL, NULL, NULL, 8),
(240178, NULL, 'PTHR28360', NULL, NULL, NULL, NULL, 'DYNACTIN SUBUNIT 3', NULL, NULL, 8777, 8),
(240179, NULL, 'PTHR21253', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(240180, NULL, 'PTHR43147', NULL, NULL, NULL, NULL, 'PROTEIN TAS', NULL, NULL, NULL, 8),
(240181, NULL, 'PTHR14132', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM-TRANSPORTING ATPASE SUBUNIT GAMMA', NULL, NULL, NULL, 8),
(240182, NULL, 'PTHR34934', NULL, NULL, NULL, NULL, 'FLAVIN-DEPENDENT THYMIDYLATE SYNTHASE', NULL, NULL, 1196, 8),
(240183, NULL, 'PTHR22836', NULL, NULL, NULL, NULL, 'WD40 REPEAT PROTEIN', NULL, NULL, 33906, 8),
(240184, NULL, 'PTHR31785', NULL, NULL, NULL, NULL, 'UPF0524 PROTEIN C3ORF70', NULL, NULL, 23751, 8),
(240185, NULL, 'PTHR42980', NULL, NULL, NULL, NULL, '2-OXOISOVALERATE DEHYDROGENASE SUBUNIT BETA-RELATED', NULL, NULL, NULL, 8),
(240186, NULL, 'PTHR48143', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(240187, NULL, 'PTHR31311', NULL, NULL, NULL, NULL, 'XYLOGLUCAN 6-XYLOSYLTRANSFERASE 5-RELATED-RELATED', NULL, NULL, 14197, 8),
(240188, NULL, 'PTHR44395', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(240189, NULL, 'PTHR15132', NULL, NULL, NULL, NULL, 'SNRNA-ACTIVATING PROTEIN COMPLEX SUBUNIT 2', NULL, NULL, 17898, 8),
(240190, NULL, 'PTHR14057', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR ONECUT', NULL, NULL, NULL, 8),
(240191, NULL, 'PTHR14362', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 81', NULL, NULL, 22229, 8);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(240192, NULL, 'PTHR48210', NULL, NULL, NULL, NULL, 'OS05G0352800 PROTEIN', NULL, NULL, NULL, 8),
(240193, NULL, 'PTHR31205', NULL, NULL, NULL, NULL, 'ACTIN CROSS-LINKING PROTEIN (DUF569)', NULL, NULL, NULL, 8),
(240194, NULL, 'PTHR46235', NULL, NULL, NULL, NULL, 'PHD FINGER-CONTAINING PROTEIN DDB_G0268158', NULL, NULL, NULL, 8),
(240195, NULL, 'PTHR31358', NULL, NULL, NULL, NULL, 'PROTEIN WVD2-LIKE 4', NULL, NULL, 36986, 8),
(240196, NULL, 'PTHR31677', NULL, NULL, NULL, NULL, 'AP2 DOMAIN CLASS TRANSCRIPTION FACTOR', NULL, NULL, NULL, 8),
(240197, NULL, 'PTHR35371', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(240198, NULL, 'PTHR33797', NULL, NULL, NULL, NULL, 'ORGANIC HYDROPEROXIDE RESISTANCE PROTEIN-LIKE', NULL, NULL, 18344, 8),
(240199, NULL, 'PTHR35402', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(240200, NULL, 'PTHR23002', NULL, NULL, NULL, NULL, 'ZINC FINGER CCHC DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(240201, NULL, 'PTHR48133', NULL, NULL, NULL, NULL, 'GRF-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(240202, NULL, 'PTHR35075', NULL, NULL, NULL, NULL, 'A-KINASE ANCHOR PROTEIN 14', NULL, NULL, NULL, 8),
(240203, NULL, 'PTHR28241', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT PROTEIN 1', NULL, NULL, 13463, 8),
(240204, NULL, 'PTHR36718', NULL, NULL, NULL, NULL, 'OS05G0435400 PROTEIN', NULL, NULL, NULL, 8),
(240205, NULL, 'PTHR11524', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L7', NULL, NULL, 27781, 8),
(240206, NULL, 'PTHR31279', NULL, NULL, NULL, NULL, 'PROTEIN EXORDIUM-LIKE 5', NULL, NULL, 3325, 8),
(240207, NULL, 'PTHR39963', NULL, NULL, NULL, NULL, 'SLL0983 PROTEIN', NULL, NULL, NULL, 8),
(240208, NULL, 'PTHR24423', NULL, NULL, NULL, NULL, 'TWO-COMPONENT SENSOR HISTIDINE KINASE', NULL, NULL, NULL, 8),
(240209, NULL, 'PTHR14429', NULL, NULL, NULL, NULL, 'FIBROSIN FAMILY MEMBER', NULL, NULL, 15715, 8),
(240210, NULL, 'PTHR28075', NULL, NULL, NULL, NULL, 'CHROMOSOME 16, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, 14239, 8),
(240211, NULL, 'PTHR36811', NULL, NULL, NULL, NULL, 'OS08G0444440 PROTEIN', NULL, NULL, NULL, 8),
(240212, NULL, 'PTHR33972', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(240213, NULL, 'PTHR12272', NULL, NULL, NULL, NULL, 'DEADENYLATION COMPLEX SUBUNIT PAN3', NULL, NULL, 21983, 8),
(240214, NULL, 'PTHR37427', NULL, NULL, NULL, NULL, 'PROTEIN CBG20963-RELATED', NULL, NULL, NULL, 8),
(240215, NULL, 'PTHR47342', NULL, NULL, NULL, NULL, 'PROTEIN PTST, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(240216, NULL, 'PTHR46270', NULL, NULL, NULL, NULL, 'ARMADILLO-TYPE FOLD-RELATED', NULL, NULL, NULL, 8),
(240217, NULL, 'PTHR38564', NULL, NULL, NULL, NULL, 'SI:CH73-250A16.5-RELATED', NULL, NULL, NULL, 8),
(240218, NULL, 'PTHR47061', NULL, NULL, NULL, NULL, 'LYR MOTIF-CONTAINING PROTEIN 9', NULL, NULL, NULL, 8),
(240219, NULL, 'PTHR33876', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', NULL, NULL, NULL, 8),
(240220, NULL, 'PTHR13720', NULL, NULL, NULL, NULL, 'WD-40 REPEAT PROTEIN', NULL, NULL, NULL, 8),
(240221, NULL, 'PTHR14102', NULL, NULL, NULL, NULL, 'PAR-6-RELATED', NULL, NULL, NULL, 8),
(240222, NULL, 'PTHR15382', NULL, NULL, NULL, NULL, 'CTG4A-RELATED', NULL, NULL, NULL, 8),
(240223, NULL, 'PTHR39598', NULL, NULL, NULL, NULL, 'AUSTINOL SYNTHESIS PROTEIN F-RELATED', NULL, NULL, NULL, 8),
(240224, NULL, 'PTHR13042', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE PROTEIN 5', NULL, NULL, 27366, 8),
(240225, NULL, 'PTHR33598', NULL, NULL, NULL, NULL, 'OS02G0833400 PROTEIN', NULL, NULL, NULL, 8),
(240226, NULL, 'PTHR30426', NULL, NULL, NULL, NULL, '4-HYDROXY-3-METHYLBUT-2-ENYL DIPHOSPHATE REDUCTASE', NULL, NULL, 5344, 8),
(240227, NULL, 'PTHR23419', NULL, NULL, NULL, NULL, 'DIVALENT CATION TOLERANCE CUTA-RELATED', NULL, NULL, 4969, 8),
(240228, NULL, 'PTHR37335', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1700003F12 GENE', NULL, NULL, 24645, 8),
(240229, NULL, 'PTHR46944', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 33', NULL, NULL, 35256, 8),
(240230, NULL, 'PTHR45427', NULL, NULL, NULL, NULL, 'MUCIN-15', NULL, NULL, 25347, 8);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(240231, NULL, 'PTHR38685', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN ZIPA', NULL, NULL, 11171, 8),
(240232, NULL, 'PTHR46934', NULL, NULL, NULL, NULL, 'MYB_DNA-BIND_3 DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(240233, NULL, 'PTHR20938', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(240234, NULL, 'PTHR10117', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL CHANNEL', NULL, NULL, 358, 8),
(240235, NULL, 'PTHR38702', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(240236, NULL, 'PTHR13021', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR ISY1', NULL, NULL, 14329, 8),
(240237, NULL, 'PTHR46963', NULL, NULL, NULL, NULL, 'SIMILAR TO RIKEN CDNA E130308A19', NULL, NULL, 35229, 8),
(240238, NULL, 'PTHR12316', NULL, NULL, NULL, NULL, 'NINJURIN-RELATED', NULL, NULL, 6560, 8),
(240239, NULL, 'PTHR10644', NULL, NULL, NULL, NULL, 'DNA REPAIR/RNA PROCESSING CPSF FAMILY', NULL, NULL, NULL, 8),
(240240, NULL, 'PTHR48058', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE FLS2-RELATED', NULL, NULL, NULL, 8),
(240241, NULL, 'PTHR37361', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE III DOMAIN-CONTAINING PROTEIN 9', NULL, NULL, NULL, 8),
(240242, NULL, 'PTHR46481', NULL, NULL, NULL, NULL, 'ZINC FINGER BED DOMAIN-CONTAINING PROTEIN 4', NULL, NULL, NULL, 8),
(240243, NULL, 'PTHR31512', NULL, NULL, NULL, NULL, 'GENE 12569-RELATED', NULL, NULL, NULL, 8),
(240244, NULL, 'PTHR47386', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 1B', NULL, NULL, NULL, 8),
(240245, NULL, 'PTHR47360', NULL, NULL, NULL, NULL, 'MUREIN DD-ENDOPEPTIDASE MEPS/MUREIN LD-CARBOXYPEPTIDASE', NULL, NULL, NULL, 8),
(240246, NULL, 'PTHR37781', NULL, NULL, NULL, NULL, 'TFIIH COMPLEX SUBUNIT', NULL, NULL, 2643, 8),
(240247, NULL, 'PTHR33868', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(240248, NULL, 'PTHR16134', NULL, NULL, NULL, NULL, 'F-BOX/TPR REPEAT PROTEIN POF3', NULL, NULL, NULL, 8),
(240249, NULL, 'PTHR10185', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D - RELATED', NULL, NULL, NULL, 8),
(240250, NULL, 'PTHR14986', NULL, NULL, NULL, NULL, 'RURM1 PROTEIN', NULL, NULL, 10531, 8),
(240251, NULL, 'PTHR36806', NULL, NULL, NULL, NULL, 'ADENINE PHOSPHORIBOSYLTRANSFERASE', NULL, NULL, NULL, 8),
(240252, NULL, 'PTHR10724', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S1', NULL, NULL, NULL, 8),
(240253, NULL, 'PTHR14339', NULL, NULL, NULL, NULL, 'VASCULIN', NULL, NULL, 21876, 8),
(240254, NULL, 'PTHR47522', NULL, NULL, NULL, NULL, 'SALVADOR FAMILY WW DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, 25146, 8),
(240255, NULL, 'PTHR43848', NULL, NULL, NULL, NULL, 'PUTRESCINE TRANSPORT SYSTEM PERMEASE PROTEIN POTI', NULL, NULL, NULL, 8),
(240256, NULL, 'PTHR34135', NULL, NULL, NULL, NULL, 'LYSOZYME', NULL, NULL, NULL, 8),
(240257, NULL, 'PTHR33694', NULL, NULL, NULL, NULL, 'UDP-3-O-ACYL-N-ACETYLGLUCOSAMINE DEACETYLASE 1, MITOCHONDRIAL-RELATED', NULL, NULL, 7070, 8),
(240258, NULL, 'PTHR43821', NULL, NULL, NULL, NULL, 'NAD(P)H NITROREDUCTASE YDJA-RELATED', NULL, NULL, NULL, 8),
(240259, NULL, 'PTHR47739', NULL, NULL, NULL, NULL, 'TRNA1(VAL) (ADENINE(37)-N6)-METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(240260, NULL, 'PTHR34796', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, 983, 8),
(240261, NULL, 'PTHR10942', NULL, NULL, NULL, NULL, 'LEISHMANOLYSIN-LIKE PEPTIDASE', NULL, NULL, 5367, 8),
(240262, NULL, 'PTHR23511', NULL, NULL, NULL, NULL, 'SYNAPTIC VESICLE GLYCOPROTEIN 2', NULL, NULL, NULL, 8),
(240263, NULL, 'PTHR13119', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEI', NULL, NULL, 36563, 8),
(240264, NULL, 'PTHR12696', NULL, NULL, NULL, NULL, 'TIP120', NULL, NULL, 31357, 8),
(240265, NULL, 'PTHR35475', NULL, NULL, NULL, NULL, 'WD REPEAT PROTEIN', NULL, NULL, NULL, 8),
(240266, NULL, 'PTHR43196', NULL, NULL, NULL, NULL, 'SULFATE ADENYLYLTRANSFERASE SUBUNIT 2', NULL, NULL, NULL, 8),
(240267, NULL, 'PTHR38120', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(240268, NULL, 'PTHR38519', NULL, NULL, NULL, NULL, 'PRA1 FAMILY PROTEIN', NULL, NULL, NULL, 8);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(240269, NULL, 'PTHR37839', NULL, NULL, NULL, NULL, 'NA(+)-TRANSLOCATING NADH-QUINONE REDUCTASE SUBUNIT A', NULL, NULL, 13060, 8),
(240270, NULL, 'PTHR36899', NULL, NULL, NULL, NULL, 'OS04G0395700 PROTEIN', NULL, NULL, NULL, 8),
(240271, NULL, 'PTHR46346', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL N-ACETYLGLUCOSAMINYLTRANSFERASE SUBUNIT P', NULL, NULL, NULL, 8),
(240272, NULL, 'PTHR37744', NULL, NULL, NULL, NULL, 'STAR LIPID TRANSFER-LIKE PROTEIN', NULL, NULL, NULL, 8),
(240273, NULL, 'PTHR35170', NULL, NULL, NULL, NULL, 'PROTEIN DD3-3', NULL, NULL, NULL, 8),
(240274, NULL, 'PTHR37049', NULL, NULL, NULL, NULL, 'PEPTIDASE S41 FAMILY PROTEIN', NULL, NULL, NULL, 8),
(240275, NULL, 'PTHR44554', NULL, NULL, NULL, NULL, 'LRP2-BINDING PROTEIN', NULL, NULL, NULL, 8),
(240276, NULL, 'PTHR31540', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 131 KDA', NULL, NULL, 23262, 8),
(240277, NULL, 'PTHR21678', NULL, NULL, NULL, NULL, 'GROWTH INHIBITION AND DIFFERENTIATION RELATED PROTEIN 88', NULL, NULL, 27246, 8),
(240278, NULL, 'PTHR47864', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(240279, NULL, 'PTHR43695', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_2G17250)-RELATED', NULL, NULL, 30336, 8),
(240280, NULL, 'PTHR36451', NULL, NULL, NULL, NULL, 'PAPS-DEPENDENT SULFOTRANSFERASE STF3', NULL, NULL, NULL, 8),
(240281, NULL, 'PTHR31962', NULL, NULL, NULL, NULL, 'SPHINGOLIPID LONG CHAIN BASE-RESPONSIVE PROTEIN PIL1', NULL, NULL, 21697, 8),
(240282, NULL, 'PTHR36366', NULL, NULL, NULL, NULL, 'PROTEIN RDM1', NULL, NULL, 12410, 8),
(240283, NULL, 'PTHR12192', NULL, NULL, NULL, NULL, 'CATION TRANSPORT PROTEIN CHAC-RELATED', NULL, NULL, 3878, 8),
(240284, NULL, 'PTHR35176', NULL, NULL, NULL, NULL, 'HEME OXYGENASE HI_0854-RELATED', NULL, NULL, NULL, 8),
(240285, NULL, 'PTHR47783', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', NULL, NULL, NULL, 8),
(240286, NULL, 'PTHR16932', NULL, NULL, NULL, NULL, 'INTERFERON ALPHA-INDUCIBLE PROTEIN 27', NULL, NULL, 14300, 8),
(240287, NULL, 'PTHR47849', NULL, NULL, NULL, NULL, 'CHITIN-BINDING LECTIN 1', NULL, NULL, NULL, 8),
(240288, NULL, 'PTHR39156', NULL, NULL, NULL, NULL, 'RIBONUCLEASE M5', NULL, NULL, NULL, 8),
(240289, NULL, 'PTHR40836', NULL, NULL, NULL, NULL, 'RB1-INDUCIBLE COILED-COIL PROTEIN', NULL, NULL, NULL, 8),
(240290, NULL, 'PTHR35983', NULL, NULL, NULL, NULL, 'UPF0166 PROTEIN TM_0021', NULL, NULL, NULL, 8),
(240291, NULL, 'PTHR13208', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 4', NULL, NULL, 19824, 8),
(240292, NULL, 'PTHR35893', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', NULL, NULL, 7746, 8),
(240293, NULL, 'PTHR10791', NULL, NULL, NULL, NULL, 'RAG1-ACTIVATING PROTEIN 1', NULL, NULL, NULL, 8),
(240294, NULL, 'PTHR40038', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED PROTEIN TCAA', NULL, NULL, NULL, 8),
(240295, NULL, 'PTHR12181', NULL, NULL, NULL, NULL, 'LIPIN', NULL, NULL, 24151, 8),
(240296, NULL, 'PTHR21320', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY PROTEIN COX11-RELATED', NULL, NULL, NULL, 8),
(240297, NULL, 'PTHR31004', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 79', NULL, NULL, NULL, 8),
(240298, NULL, 'PTHR14254', NULL, NULL, NULL, NULL, 'GENE 33 POLYPEPTIDE', NULL, NULL, NULL, 8),
(240299, NULL, 'PTHR37238', NULL, NULL, NULL, NULL, 'OS05G0532500 PROTEIN', NULL, NULL, NULL, 8),
(240300, NULL, 'PTHR33206', NULL, NULL, NULL, NULL, 'PROTEIN CBG10425', NULL, NULL, NULL, 8),
(240301, NULL, 'PTHR33209', NULL, NULL, NULL, NULL, 'PROTEASE 4', NULL, NULL, NULL, 8),
(240302, NULL, 'PTHR43941', NULL, NULL, NULL, NULL, 'STRUCTURAL MAINTENANCE OF CHROMOSOMES PROTEIN 2', NULL, NULL, NULL, 8),
(240303, NULL, 'PTHR10890', NULL, NULL, NULL, NULL, 'CYSTEINYL-TRNA SYNTHETASE', NULL, NULL, 14597, 8),
(240304, NULL, 'PTHR43106', NULL, NULL, NULL, NULL, 'DEHYDROGENASE-RELATED', NULL, NULL, NULL, 8),
(240305, NULL, 'PTHR47602', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SKIP22', NULL, NULL, NULL, 8),
(240306, NULL, 'PTHR42055', NULL, NULL, NULL, NULL, 'YALI0E03476P', NULL, NULL, NULL, 8);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(240307, NULL, 'PTHR42759', NULL, NULL, NULL, NULL, 'MOXR FAMILY PROTEIN', NULL, NULL, NULL, 8),
(240308, NULL, 'PTHR47111', NULL, NULL, NULL, NULL, 'BCDNA.LD29892', NULL, NULL, NULL, 8),
(240309, NULL, 'PTHR15171', NULL, NULL, NULL, NULL, 'EMERIN', NULL, NULL, 12177, 8),
(240310, NULL, 'PTHR47190', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(240311, NULL, 'PTHR16024', NULL, NULL, NULL, NULL, 'XK-RELATED PROTEIN', NULL, NULL, NULL, 8),
(240312, NULL, 'PTHR45923', NULL, NULL, NULL, NULL, 'PROTEIN SEY1', NULL, NULL, 13962, 8),
(240313, NULL, 'PTHR33885', NULL, NULL, NULL, NULL, 'PHAGE SHOCK PROTEIN C', NULL, NULL, NULL, 8),
(240314, NULL, 'PTHR38111', NULL, NULL, NULL, NULL, 'ZN(2)-C6 FUNGAL-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(240315, NULL, 'PTHR43143', NULL, NULL, NULL, NULL, 'METALLOPHOSPHOESTERASE, CALCINEURIN SUPERFAMILY', NULL, NULL, NULL, 8),
(240316, NULL, 'PTHR11920', NULL, NULL, NULL, NULL, 'GUANYLYL CYCLASE', NULL, NULL, NULL, 8),
(240317, NULL, 'PTHR11260', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE, GST, SUPERFAMILY, GST DOMAIN CONTAINING', NULL, NULL, 35570, 8),
(240318, NULL, 'PTHR39179', NULL, NULL, NULL, NULL, 'SPORE COAT PROTEIN I', NULL, NULL, NULL, 8),
(240319, NULL, 'PTHR28631', NULL, NULL, NULL, NULL, 'UPF0692 PROTEIN C19ORF54', NULL, NULL, 31356, 8),
(240320, NULL, 'PTHR21035', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S26, MITOCHONDRIAL', NULL, NULL, 22993, 8),
(240321, NULL, 'PTHR42702', NULL, NULL, NULL, NULL, 'NUCLEOTIDE PYROPHOSPHOHYDROLASE', NULL, NULL, NULL, 8),
(240322, NULL, 'PTHR15109', NULL, NULL, NULL, NULL, 'AGAP004327-PA', NULL, NULL, 24927, 8),
(240323, NULL, 'PTHR48149', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L37A-2', NULL, NULL, NULL, 8),
(240324, NULL, 'PTHR46479', NULL, NULL, NULL, NULL, 'BIOGENESIS OF LYSOSOME-RELATED ORGANELLES COMPLEX 1 SUBUNIT 2', NULL, NULL, 19991, 8),
(240325, NULL, 'PTHR22800', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN PROTEINS', NULL, NULL, NULL, 8),
(240326, NULL, 'PTHR37810', NULL, NULL, NULL, NULL, 'IMMUNITY PROTEIN SDPI', NULL, NULL, NULL, 8),
(240327, NULL, 'PTHR46325', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN RIC8', NULL, NULL, 34589, 8),
(240328, NULL, 'PTHR33353', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_1G12560)-RELATED', NULL, NULL, NULL, 8),
(240329, NULL, 'PTHR46930', NULL, NULL, NULL, NULL, 'CDK5 REGULATORY SUBUNIT-ASSOCIATED PROTEIN 2', NULL, NULL, 34626, 8),
(240330, NULL, 'PTHR44029', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 21', NULL, NULL, NULL, 8),
(240331, NULL, 'PTHR35105', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(240332, NULL, 'PTHR39602', NULL, NULL, NULL, NULL, 'ACW-9', NULL, NULL, NULL, 8),
(240333, NULL, 'PTHR10705', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE SUBUNIT DAD1', NULL, NULL, 29, 8),
(240334, NULL, 'PTHR47258', NULL, NULL, NULL, NULL, '', NULL, NULL, 37708, 8),
(240335, NULL, 'PTHR33400', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 6-RELATED', NULL, NULL, NULL, 8),
(240336, NULL, 'PTHR28333', NULL, NULL, NULL, NULL, 'NUCLEAR FRAGILE X MENTAL RETARDATION-INTERACTING PROTEIN 2', NULL, NULL, 22225, 8),
(240337, NULL, 'PTHR15703', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4931406P16 GENE', NULL, NULL, 35148, 8),
(240338, NULL, 'PTHR47379', NULL, NULL, NULL, NULL, 'SIALYLTRANSFERASE-LIKE PROTEIN 2', NULL, NULL, NULL, 8),
(240339, NULL, 'PTHR35734', NULL, NULL, NULL, NULL, 'OS01G0805200 PROTEIN', NULL, NULL, 18540, 8),
(240340, NULL, 'PTHR47630', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY-RELATED-RELATED', NULL, NULL, NULL, 8),
(240341, NULL, 'PTHR30383', NULL, NULL, NULL, NULL, 'THIOESTERASE 1/PROTEASE 1/LYSOPHOSPHOLIPASE L1', NULL, NULL, NULL, 8),
(240342, NULL, 'PTHR39145', NULL, NULL, NULL, NULL, 'BIOGENESIS OF LYSOSOME-RELATED ORGANELLES COMPLEX 1 SUBUNIT CNL1', NULL, NULL, 7392, 8),
(240343, NULL, 'PTHR34201', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN', NULL, NULL, NULL, 8);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(240344, NULL, 'PTHR31631', NULL, NULL, NULL, NULL, 'PROTEIN NETWORKED 2D', NULL, NULL, NULL, 8),
(240345, NULL, 'PTHR48057', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT SERINE/THREONINE-PROTEIN KINASE 1', NULL, NULL, NULL, 8),
(240346, NULL, 'PTHR23192', NULL, NULL, NULL, NULL, 'OLFACTOMEDIN-RELATED', NULL, NULL, NULL, 8),
(240347, NULL, 'PTHR12775', NULL, NULL, NULL, NULL, 'PROTEIN C20ORF43 HOMOLOG', NULL, NULL, 2908, 8),
(240348, NULL, 'PTHR39413', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 136', NULL, NULL, 15872, 8),
(240349, NULL, 'PTHR13413', NULL, NULL, NULL, NULL, 'YLP MOTIF CONTAINING PROTEIN NUCLEAR PROTEIN ZAP', NULL, NULL, 25881, 8),
(240350, NULL, 'PTHR31291', NULL, NULL, NULL, NULL, 'ALPHA-KETOGLUTARATE-DEPENDENT DIOXYGENASE FTO', NULL, NULL, 22834, 8),
(240351, NULL, 'PTHR46454', NULL, NULL, NULL, NULL, 'DYNEIN AXONEMAL HEAVY CHAIN 7-RELATED', NULL, NULL, NULL, 8),
(240352, NULL, 'PTHR48066', NULL, NULL, NULL, NULL, 'CARNOSINE SYNTHASE 1', NULL, NULL, 25211, 8),
(240353, NULL, 'PTHR12553', NULL, NULL, NULL, NULL, 'ZINC PHOSPHODIESTERASE ELAC PROTEIN 2', NULL, NULL, NULL, 8),
(240354, NULL, 'PTHR35545', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(240355, NULL, 'PTHR33122', NULL, NULL, NULL, NULL, 'LIPID BINDING PROTEIN-RELATED', NULL, NULL, 30647, 8),
(240356, NULL, 'PTHR47215', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(240357, NULL, 'PTHR47884', NULL, NULL, NULL, NULL, 'PROSTATE AND TESTIS EXPRESSED PROTEIN 2', NULL, NULL, 25241, 8),
(240358, NULL, 'PTHR21569', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S9', NULL, NULL, 6788, 8),
(240359, NULL, 'PTHR11022', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN RECOGNITION PROTEIN', NULL, NULL, 8372, 8),
(240360, NULL, 'PTHR45761', NULL, NULL, NULL, NULL, 'EXTENDED SYNAPTOTAGMIN-LIKE PROTEIN 2, ISOFORM C', NULL, NULL, NULL, 8),
(240361, NULL, 'PTHR10709', NULL, NULL, NULL, NULL, 'ACTIN-RELATED PROTEIN 2/3 COMPLEX SUBUNIT 1', NULL, NULL, 18213, 8),
(240362, NULL, 'PTHR37247', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(240363, NULL, 'PTHR28511', NULL, NULL, NULL, NULL, 'ENDONUCLEASE V', NULL, NULL, 1950, 8),
(240364, NULL, 'PTHR43257', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT BETA SUBUNIT', NULL, NULL, NULL, 8),
(240365, NULL, 'PTHR14385', NULL, NULL, NULL, NULL, 'CXC CHEMOKINE LIGAND', NULL, NULL, 22017, 8),
(240366, NULL, 'PTHR16926', NULL, NULL, NULL, NULL, 'INTERLEUKIN 9', NULL, NULL, 20294, 8),
(240367, NULL, 'PTHR46314', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 25 MEMBER 44', NULL, NULL, 34857, 8),
(240368, NULL, 'PTHR22969', NULL, NULL, NULL, NULL, 'IKB KINASE', NULL, NULL, NULL, 8),
(240369, NULL, 'PTHR45796', NULL, NULL, NULL, NULL, 'FORKHEAD BOX P, ISOFORM C', NULL, NULL, NULL, 8),
(240370, NULL, 'PTHR40387', NULL, NULL, NULL, NULL, 'PROTEIN FAM240B', NULL, NULL, 27182, 8),
(240371, NULL, 'PTHR10036', NULL, NULL, NULL, NULL, 'CD59 GLYCOPROTEIN', NULL, NULL, NULL, 8),
(240372, NULL, 'PTHR36289', NULL, NULL, NULL, NULL, 'CHROMOSOME 12 OPEN READING FRAME 60', NULL, NULL, NULL, 8),
(240373, NULL, 'PTHR11370', NULL, NULL, NULL, NULL, 'DNA-REPAIR PROTEIN XRCC1', NULL, NULL, NULL, 8),
(240374, NULL, 'PTHR12766', NULL, NULL, NULL, NULL, 'DEATH DOMAIN-ASSOCIATED PROTEIN 6 DAXX', NULL, NULL, NULL, 8),
(240375, NULL, 'PTHR11908', NULL, NULL, NULL, NULL, 'XANTHINE DEHYDROGENASE', NULL, NULL, 17394, 8),
(240376, NULL, 'PTHR36879', NULL, NULL, NULL, NULL, 'GLUTAMATE-RICH PROTEIN 4', NULL, NULL, 26875, 8),
(240377, NULL, 'PTHR35805', NULL, NULL, NULL, NULL, 'ASPARTATE CARBAMOYLTRANSFERASE REGULATORY CHAIN', NULL, NULL, 4679, 8),
(240378, NULL, 'PTHR24409', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 142', NULL, NULL, NULL, 8),
(240379, NULL, 'PTHR30024', NULL, NULL, NULL, NULL, 'ALIPHATIC SULFONATES-BINDING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(240380, NULL, 'PTHR46684', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR FAMA', NULL, NULL, 34089, 8),
(240381, NULL, 'PTHR35548', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, 29557, 8);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(240382, NULL, 'PTHR15664', NULL, NULL, NULL, NULL, 'C20ORF30 PROTEIN', NULL, NULL, 34937, 8),
(240383, NULL, 'PTHR33607', NULL, NULL, NULL, NULL, 'ENDONUCLEASE-1', NULL, NULL, 5912, 8),
(240384, NULL, 'PTHR43827', NULL, NULL, NULL, NULL, '2,5-DIKETO-D-GLUCONIC ACID REDUCTASE', NULL, NULL, 19615, 8),
(240385, NULL, 'PTHR42828', NULL, NULL, NULL, NULL, 'DHBP SYNTHASE RIBB-LIKE ALPHA/BETA DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(240386, NULL, 'PTHR21623', NULL, NULL, NULL, NULL, 'SPERIOLIN-BINDING FACTOR', NULL, NULL, 27105, 8),
(240387, NULL, 'PTHR47147', NULL, NULL, NULL, NULL, 'SYNCOILIN', NULL, NULL, 25090, 8),
(240388, NULL, 'PTHR46961', NULL, NULL, NULL, NULL, 'DYNEIN HEAVY CHAIN 1, AXONEMAL-LIKE PROTEIN', NULL, NULL, 23364, 8),
(240389, NULL, 'PTHR33864', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE-LIKE PROTEIN-RELATED', NULL, NULL, 27902, 8),
(240390, NULL, 'PTHR39210', NULL, NULL, NULL, NULL, 'HEPARIN-SULFATE LYASE', NULL, NULL, NULL, 8),
(240391, NULL, 'PTHR46695', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 44-RELATED', NULL, NULL, NULL, 8),
(240392, NULL, 'PTHR44998', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(240393, NULL, 'PTHR42064', NULL, NULL, NULL, NULL, 'YALI0F28677P', NULL, NULL, NULL, 8),
(240394, NULL, 'PTHR21666', NULL, NULL, NULL, NULL, 'PEPTIDASE-RELATED', NULL, NULL, NULL, 8),
(240395, NULL, 'PTHR37679', NULL, NULL, NULL, NULL, 'ARMADILLO-LIKE HELICAL DOMAIN-CONTAINING PROTEIN 2', NULL, NULL, 27364, 8),
(240396, NULL, 'PTHR46807', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PIF3', NULL, NULL, 35236, 8),
(240397, NULL, 'PTHR40714', NULL, NULL, NULL, NULL, 'TMF-REGULATED NUCLEAR PROTEIN 1', NULL, NULL, 27250, 8),
(240398, NULL, 'PTHR32102', NULL, NULL, NULL, NULL, 'DUF1084 DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(240399, NULL, 'PTHR39164', NULL, NULL, NULL, NULL, 'PROTEIN CCDC', NULL, NULL, 25180, 8),
(240400, NULL, 'PTHR47413', NULL, NULL, NULL, NULL, 'LIPASE-LIKE PAD4', NULL, NULL, NULL, 8),
(240401, NULL, 'PTHR43900', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE RHO', NULL, NULL, NULL, 8),
(240402, NULL, 'PTHR36486', NULL, NULL, NULL, NULL, 'OS01G0977800 PROTEIN', NULL, NULL, NULL, 8),
(240403, NULL, 'PTHR46518', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 151', NULL, NULL, 30722, 8),
(240404, NULL, 'PTHR45863', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE BSK5', NULL, NULL, 36280, 8),
(240405, NULL, 'PTHR34450', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 245-RELATED', NULL, NULL, 9486, 8),
(240406, NULL, 'PTHR37690', NULL, NULL, NULL, NULL, 'CHORISMATE DEHYDRATASE', NULL, NULL, 22923, 8),
(240407, NULL, 'PTHR11352', NULL, NULL, NULL, NULL, 'PROLIFERATING CELL NUCLEAR ANTIGEN', NULL, NULL, NULL, 8),
(240408, NULL, 'PTHR33870', NULL, NULL, NULL, NULL, 'CARDIOMYOPATHY-ASSOCIATED PROTEIN', NULL, NULL, NULL, 8),
(240409, NULL, 'PTHR23146', NULL, NULL, NULL, NULL, 'LEO1 PROTEIN', NULL, NULL, 156, 8),
(240410, NULL, 'PTHR21026', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L32, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(240411, NULL, 'PTHR36923', NULL, NULL, NULL, NULL, 'FERREDOXIN', NULL, NULL, NULL, 8),
(240412, NULL, 'PTHR38136', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN', NULL, NULL, 32454, 8),
(240413, NULL, 'PTHR22412', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(240414, NULL, 'PTHR46924', NULL, NULL, NULL, NULL, 'METABOTROPIC GLUTAMATE RECEPTOR-LIKE PROTEIN C-RELATED-RELATED', NULL, NULL, NULL, 8),
(240415, NULL, 'PTHR13466', NULL, NULL, NULL, NULL, 'TEX2 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(240416, NULL, 'PTHR30566', NULL, NULL, NULL, NULL, 'YNAI-RELATED MECHANOSENSITIVE ION CHANNEL', NULL, NULL, NULL, 8),
(240417, NULL, 'PTHR15237', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RAD9', NULL, NULL, 7317, 8),
(240418, NULL, 'PTHR22725', NULL, NULL, NULL, NULL, 'FATTY ACID-BINDING PROTEIN HOMOLOG 1-RELATED-RELATED', NULL, NULL, 31630, 8),
(240419, NULL, 'PTHR37002', NULL, NULL, NULL, NULL, 'AGAP007005-PA', NULL, NULL, NULL, 8),
(240420, NULL, 'PTHR28235', NULL, NULL, NULL, NULL, 'PROTEIN FYV4, MITOCHONDRIAL', NULL, NULL, 27357, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(240421, NULL, 'PTHR33559', NULL, NULL, NULL, NULL, 'PROTEASOME ASSEMBLY CHAPERONE 4', NULL, NULL, 26297, 8),
(240422, NULL, 'PTHR43144', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE', NULL, NULL, 18151, 8),
(240423, NULL, 'PTHR34762', NULL, NULL, NULL, NULL, 'SMALL VASOHIBIN-BINDING PROTEIN', NULL, NULL, 25568, 8),
(240424, NULL, 'PTHR46252', NULL, NULL, NULL, NULL, 'BRORIN FAMILY MEMBER', NULL, NULL, 35405, 8),
(240425, NULL, 'PTHR14240', NULL, NULL, NULL, NULL, 'RETINITIS PIGMENTOSA GTPASE REGULATOR-INTERACTING PROTEIN', NULL, NULL, 22913, 8),
(240426, NULL, 'PTHR43592', NULL, NULL, NULL, NULL, 'CAAX AMINO TERMINAL PROTEASE', NULL, NULL, NULL, 8),
(240427, NULL, 'PTHR46593', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 64', NULL, NULL, NULL, 8),
(240428, NULL, 'PTHR33142', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT PROTEIN KINASE INHIBITOR SMR13', NULL, NULL, 30012, 8),
(240429, NULL, 'PTHR34961', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(240430, NULL, 'PTHR46242', NULL, NULL, NULL, NULL, 'ZINC FINGER CCHC DOMAIN-CONTAINING PROTEIN 9 ZCCHC9', NULL, NULL, 37140, 8),
(240431, NULL, 'PTHR13007', NULL, NULL, NULL, NULL, 'PRE-MRNA SPLICING FACTOR-RELATED', NULL, NULL, 28754, 8),
(240432, NULL, 'PTHR34340', NULL, NULL, NULL, NULL, '', NULL, NULL, 24124, 8),
(240433, NULL, 'PTHR35513', NULL, NULL, NULL, NULL, 'OS02G0158600 PROTEIN', NULL, NULL, NULL, 8),
(240434, NULL, 'PTHR35099', NULL, NULL, NULL, NULL, 'OS02G0182700 PROTEIN', NULL, NULL, NULL, 8),
(240435, NULL, 'PTHR16311', NULL, NULL, NULL, NULL, 'THROMBOSPONDIN TYPE I DOMAIN-CONTAINING 1', NULL, NULL, 30627, 8),
(240436, NULL, 'PTHR37177', NULL, NULL, NULL, NULL, 'PROTEIN PSY1', NULL, NULL, 16009, 8),
(240437, NULL, 'PTHR43037', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT-RELATED', NULL, NULL, NULL, 8),
(240438, NULL, 'PTHR42943', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE KAPPA', NULL, NULL, NULL, 8),
(240439, NULL, 'PTHR36339', NULL, NULL, NULL, NULL, 'F23A5.5', NULL, NULL, NULL, 8),
(240440, NULL, 'PTHR12829', NULL, NULL, NULL, NULL, 'N6-ADENOSINE-METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(240441, NULL, 'PTHR10256', NULL, NULL, NULL, NULL, 'SELENIDE, WATER DIKINASE', NULL, NULL, 1501, 8),
(240442, NULL, 'PTHR11907', NULL, NULL, NULL, NULL, 'AMIDOPHOSPHORIBOSYLTRANSFERASE', NULL, NULL, NULL, 8),
(240443, NULL, 'PTHR37868', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 190', NULL, NULL, 21968, 8),
(240444, NULL, 'PTHR24124', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY A', NULL, NULL, NULL, 8),
(240445, NULL, 'PTHR43103', NULL, NULL, NULL, NULL, 'NUCLEOSIDE-DIPHOSPHATE-SUGAR EPIMERASE', NULL, NULL, NULL, 8),
(240446, NULL, 'PTHR35910', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(240447, NULL, 'PTHR16797', NULL, NULL, NULL, NULL, 'FACTOR VIII-ASSOCIATED GENE 1', NULL, NULL, 28641, 8),
(240448, NULL, 'PTHR38777', NULL, NULL, NULL, NULL, 'FELS-2 PROPHAGE PROTEIN', NULL, NULL, NULL, 8),
(240449, NULL, 'PTHR43288', NULL, NULL, NULL, NULL, 'BIOTIN SYNTHASE-RELATED PROTEIN, RADICAL SAM SUPERFAMILY', NULL, NULL, NULL, 8),
(240450, NULL, 'PTHR33729', NULL, NULL, NULL, NULL, 'METHYL-CPG BINDING DOMAIN CONTAINING PROTEIN, EXPRESSED', NULL, NULL, 27389, 8),
(240451, NULL, 'PTHR34977', NULL, NULL, NULL, NULL, 'UPF0337 PROTEIN YJBJ', NULL, NULL, NULL, 8),
(240452, NULL, 'PTHR46700', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(240453, NULL, 'PTHR47834', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE PROTEIN CITRX, CHLOROPLASTIC', NULL, NULL, 36567, 8),
(240454, NULL, 'PTHR35449', NULL, NULL, NULL, NULL, 'PROTEIN SIX6OS1', NULL, NULL, 25628, 8),
(240455, NULL, 'PTHR15302', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF103', NULL, NULL, 33840, 8),
(240456, NULL, 'PTHR43777', NULL, NULL, NULL, NULL, 'MOLYBDENUM COFACTOR CYTIDYLYLTRANSFERASE', NULL, NULL, NULL, 8),
(240457, NULL, 'PTHR46490', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 12 MEMBER A-RELATED', NULL, NULL, NULL, 8),
(240458, NULL, 'PTHR35555', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(240459, NULL, 'PTHR11584', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE', NULL, NULL, 37698, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(240460, NULL, 'PTHR31639', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN-LIKE', NULL, NULL, NULL, 8),
(240461, NULL, 'PTHR21010', NULL, NULL, NULL, NULL, 'AGAP001581-PA', NULL, NULL, NULL, 8),
(240462, NULL, 'PTHR48152', NULL, NULL, NULL, NULL, 'F1C9.34 PROTEIN', NULL, NULL, NULL, 8),
(240463, NULL, 'PTHR33153', NULL, NULL, NULL, NULL, 'MYND-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(240464, NULL, 'PTHR46304', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR II-I REPEAT DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(240465, NULL, 'PTHR19854', NULL, NULL, NULL, NULL, 'TRANSDUCIN BETA-LIKE 3', NULL, NULL, NULL, 8),
(240466, NULL, 'PTHR24095', NULL, NULL, NULL, NULL, 'ACETYL-COENZYME A SYNTHETASE', NULL, NULL, NULL, 8),
(240467, NULL, 'PTHR33343', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN BL35M', NULL, NULL, NULL, 8),
(240468, NULL, 'PTHR10828', NULL, NULL, NULL, NULL, 'M-PHASE INDUCER PHOSPHATASE  DUAL SPECIFICITY PHOSPHATASE CDC25', NULL, NULL, NULL, 8),
(240469, NULL, 'PTHR34414', NULL, NULL, NULL, NULL, 'HET DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(240470, NULL, 'PTHR44111', NULL, NULL, NULL, NULL, 'ELONGATOR COMPLEX PROTEIN 2', NULL, NULL, 29697, 8),
(240471, NULL, 'PTHR30586', NULL, NULL, NULL, NULL, 'ELECTRON TRANSPORT COMPLEX PROTEIN RNFE', NULL, NULL, NULL, 8),
(240472, NULL, 'PTHR23389', NULL, NULL, NULL, NULL, 'CHROMOSOME TRANSMISSION FIDELITY FACTOR 18', NULL, NULL, NULL, 8),
(240473, NULL, 'PTHR40845', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(240474, NULL, 'PTHR39244', NULL, NULL, NULL, NULL, 'NATTERIN-4', NULL, NULL, NULL, 8),
(240475, NULL, 'PTHR43096', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG 1, MITOCHONDRIAL-RELATED', NULL, NULL, NULL, 8),
(240476, NULL, 'PTHR28533', NULL, NULL, NULL, NULL, 'PROTEIN PBN1', NULL, NULL, 35735, 8),
(240477, NULL, 'PTHR14856', NULL, NULL, NULL, NULL, 'PQ-LOOP REPEAT-CONTAINING PROTEIN 1-LIKE PROTEIN', NULL, NULL, NULL, 8),
(240478, NULL, 'PTHR19271', NULL, NULL, NULL, NULL, 'CYTOCHROME B', NULL, NULL, NULL, 8),
(240479, NULL, 'PTHR48028', NULL, NULL, NULL, NULL, 'GLYCINE-RICH RNA-BINDING PROTEIN RZ1A', NULL, NULL, NULL, 8),
(240480, NULL, 'PTHR33169', NULL, NULL, NULL, NULL, 'PADR-FAMILY TRANSCRIPTIONAL REGULATOR', NULL, NULL, NULL, 8),
(240481, NULL, 'PTHR13477', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 39S RIBOSOMAL PROTEIN L49', NULL, NULL, 1488, 8),
(240482, NULL, 'PTHR22972', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE', NULL, NULL, NULL, 8),
(240483, NULL, 'PTHR47698', NULL, NULL, NULL, NULL, 'FATTY-ACID-BINDING PROTEIN 3, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(240484, NULL, 'PTHR33673', NULL, NULL, NULL, NULL, 'SUPPRESSOR SRP40-LIKE PROTEIN', NULL, NULL, NULL, 8),
(240485, NULL, 'PTHR37307', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN WHIA-RELATED', NULL, NULL, 3133, 8),
(240486, NULL, 'PTHR38688', NULL, NULL, NULL, NULL, 'PYR_REDOX_2 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(240487, NULL, 'PTHR35535', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN HSLJ', NULL, NULL, NULL, 8),
(240488, NULL, 'PTHR33883', NULL, NULL, NULL, NULL, 'WPP DOMAIN-ASSOCIATED PROTEIN', NULL, NULL, 30111, 8),
(240489, NULL, 'PTHR34372', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 5C-2-RELATED', NULL, NULL, 8953, 8),
(240490, NULL, 'PTHR31040', NULL, NULL, NULL, NULL, 'NURIM', NULL, NULL, 31994, 8),
(240491, NULL, 'PTHR31813', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 23B', NULL, NULL, NULL, 8),
(240492, NULL, 'PTHR21615', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 27322, 8),
(240493, NULL, 'PTHR47915', NULL, NULL, NULL, NULL, 'SI:DKEY-19B23.7', NULL, NULL, NULL, 8),
(240494, NULL, 'PTHR18864', NULL, NULL, NULL, NULL, 'KINECTIN', NULL, NULL, 18553, 8),
(240495, NULL, 'PTHR37760', NULL, NULL, NULL, NULL, 'CHAPERONE', NULL, NULL, NULL, 8),
(240496, NULL, 'PTHR35685', NULL, NULL, NULL, NULL, '825-OAK-RELATED-RELATED', NULL, NULL, NULL, 8),
(240497, NULL, 'PTHR33726', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(240498, NULL, 'PTHR19963', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(240499, NULL, 'PTHR41771', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', NULL, NULL, 12614, 8),
(240500, NULL, 'PTHR11458', NULL, NULL, NULL, NULL, 'DELTA-AMINOLEVULINIC ACID DEHYDRATASE', NULL, NULL, 3275, 8),
(240501, NULL, 'PTHR15304', NULL, NULL, NULL, NULL, 'MYOD FAMILY INHIBITOR', NULL, NULL, 25986, 8),
(240502, NULL, 'PTHR31718', NULL, NULL, NULL, NULL, 'PLAT DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(240503, NULL, 'PTHR42791', NULL, NULL, NULL, NULL, 'GNAT FAMILY ACETYLTRANSFERASE', NULL, NULL, NULL, 8),
(240504, NULL, 'PTHR48236', NULL, NULL, NULL, NULL, 'COX19-LIKE CHCH FAMILY PROTEIN', NULL, NULL, NULL, 8),
(240505, NULL, 'PTHR12634', NULL, NULL, NULL, NULL, 'SIT4 YEAST -ASSOCIATING PROTEIN-RELATED', NULL, NULL, 2827, 8),
(240506, NULL, 'PTHR46380', NULL, NULL, NULL, NULL, 'CYCLIN-D-BINDING MYB-LIKE TRANSCRIPTION FACTOR 1', NULL, NULL, NULL, 8),
(240507, NULL, 'PTHR23329', NULL, NULL, NULL, NULL, 'TUFTELIN-INTERACTING PROTEIN 11-RELATED', NULL, NULL, 36056, 8),
(240508, NULL, 'PTHR46025', NULL, NULL, NULL, NULL, 'XYLOSYLTRANSFERASE OXT', NULL, NULL, 35220, 8),
(240509, NULL, 'PTHR36932', NULL, NULL, NULL, NULL, 'CAPSULAR POLYSACCHARIDE BIOSYNTHESIS PROTEIN', NULL, NULL, NULL, 8),
(240510, NULL, 'PTHR48059', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE INHIBITOR 1', NULL, NULL, NULL, 8),
(240511, NULL, 'PTHR30521', NULL, NULL, NULL, NULL, 'DEFERROCHELATASE/PEROXIDASE', NULL, NULL, NULL, 8),
(240512, NULL, 'PTHR14964', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR BINDING FACTOR 2', NULL, NULL, 33426, 8),
(240513, NULL, 'PTHR13580', NULL, NULL, NULL, NULL, 'TGF-BETA INDUCED APOPTOSIS PROTEIN', NULL, NULL, 19719, 8),
(240514, NULL, 'PTHR32157', NULL, NULL, NULL, NULL, 'GENE 6268-RELATED', NULL, NULL, 25222, 8),
(240515, NULL, 'PTHR31346', NULL, NULL, NULL, NULL, 'MULTIPLE ORGANELLAR RNA EDITING FACTOR 2, CHLOROPLASTIC-RELATED-RELATED', NULL, NULL, 31861, 8),
(240516, NULL, 'PTHR34704', NULL, NULL, NULL, NULL, 'ATPASE', NULL, NULL, NULL, 8),
(240517, NULL, 'PTHR43019', NULL, NULL, NULL, NULL, 'SERINE ENDOPROTEASE DEGS', NULL, NULL, NULL, 8),
(240518, NULL, 'PTHR46893', NULL, NULL, NULL, NULL, 'LCCL DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(240519, NULL, 'PTHR34356', NULL, NULL, NULL, NULL, 'ANTIGENIC HEAT-STABLE PROTEIN', NULL, NULL, NULL, 8),
(240520, NULL, 'PTHR35682', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 252', NULL, NULL, 4694, 8),
(240521, NULL, 'PTHR48136', NULL, NULL, NULL, NULL, 'RUBREDOXIN-LIKE SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(240522, NULL, 'PTHR46062', NULL, NULL, NULL, NULL, 'STEROL REGULATORY ELEMENT-BINDING PROTEIN', NULL, NULL, NULL, 8),
(240523, NULL, 'PTHR16213', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(240524, NULL, 'PTHR31801', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN 24, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(240525, NULL, 'PTHR36520', NULL, NULL, NULL, NULL, 'PROTEIN CBG13000-RELATED', NULL, NULL, NULL, 8),
(240526, NULL, 'PTHR10721', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM44', NULL, NULL, 27361, 8),
(240527, NULL, 'PTHR47641', NULL, NULL, NULL, NULL, 'PERIAXIN-LIKE', NULL, NULL, NULL, 8),
(240528, NULL, 'PTHR33680', NULL, NULL, NULL, NULL, 'OS07G0190500 PROTEIN', NULL, NULL, NULL, 8),
(240529, NULL, 'PTHR12374', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ADAPTOR 2  ADA2 -RELATED', NULL, NULL, NULL, 8),
(240530, NULL, 'PTHR33156', NULL, NULL, NULL, NULL, 'OS02G0230000 PROTEIN', NULL, NULL, 35037, 8),
(240531, NULL, 'PTHR14106', NULL, NULL, NULL, NULL, 'TRIADIN', NULL, NULL, 10561, 8),
(240532, NULL, 'PTHR31626', NULL, NULL, NULL, NULL, 'SUSHI DOMAIN-CONTAINING PROTEIN', NULL, NULL, 20981, 8),
(240533, NULL, 'PTHR33391', NULL, NULL, NULL, NULL, 'CYTOCHROME B559 SUBUNIT BETA-RELATED', NULL, NULL, NULL, 8),
(240534, NULL, 'PTHR12585', NULL, NULL, NULL, NULL, 'SCC1 / RAD21 FAMILY MEMBER', NULL, NULL, 33450, 8),
(240535, NULL, 'PTHR33768', NULL, NULL, NULL, NULL, 'MIP11318P', NULL, NULL, 30687, 8),
(240536, NULL, 'PTHR20934', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 2340, 8);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(240537, NULL, 'PTHR46066', NULL, NULL, NULL, NULL, 'CHITINASE DOMAIN-CONTAINING PROTEIN 1 FAMILY MEMBER', NULL, NULL, NULL, 8),
(240538, NULL, 'PTHR15706', NULL, NULL, NULL, NULL, 'SH3 MULTIPLE DOMAIN', NULL, NULL, NULL, 8),
(240539, NULL, 'PTHR45237', NULL, NULL, NULL, NULL, 'POSSIBLE PARA-NITROBENZYL ESTERASE', NULL, NULL, NULL, 8),
(240540, NULL, 'PTHR13030', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE', NULL, NULL, 30492, 8),
(240541, NULL, 'PTHR47840', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', NULL, NULL, NULL, 8),
(240542, NULL, 'PTHR46024', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE EGGLESS', NULL, NULL, NULL, 8),
(240543, NULL, 'PTHR17550', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TTC3', NULL, NULL, NULL, 8),
(240544, NULL, 'PTHR48077', NULL, NULL, NULL, NULL, 'TRYPTOPHAN SYNTHASE-RELATED', NULL, NULL, NULL, 8),
(240545, NULL, 'PTHR34656', NULL, NULL, NULL, NULL, 'PYRROLINE-5-CARBOXYLATE REDUCTASE', NULL, NULL, NULL, 8),
(240546, NULL, 'PTHR38605', NULL, NULL, NULL, NULL, 'ATPASE-RELATED', NULL, NULL, 3643, 8),
(240547, NULL, 'PTHR35161', NULL, NULL, NULL, NULL, 'OS02G0303100 PROTEIN', NULL, NULL, NULL, 8),
(240548, NULL, 'PTHR46899', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 27', NULL, NULL, NULL, 8),
(240549, NULL, 'PTHR36129', NULL, NULL, NULL, NULL, 'ORGANIC SOLUTE TRANSPORTER SUBUNIT BETA-RELATED', NULL, NULL, NULL, 8),
(240550, NULL, 'PTHR47622', NULL, NULL, NULL, NULL, 'ARGININE/SERINE-RICH PROTEIN 1', NULL, NULL, 25489, 8),
(240551, NULL, 'PTHR43590', NULL, NULL, NULL, NULL, 'ARSENIC RESISTANCE PROTEIN ARSH (AFU_ORTHOLOGUE AFUA_5G15030)', NULL, NULL, 13006, 8),
(240552, NULL, 'PTHR42767', NULL, NULL, NULL, NULL, 'ENDO-BETA-1,6-GALACTANASE', NULL, NULL, 28735, 8),
(240553, NULL, 'PTHR35123', NULL, NULL, NULL, NULL, 'OS07G0633900 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(240554, NULL, 'PTHR31105', NULL, NULL, NULL, NULL, 'EXTRA-LARGE G-PROTEIN-LIKE', NULL, NULL, 31879, 8),
(240555, NULL, 'PTHR13336', NULL, NULL, NULL, NULL, 'OVARIAN CARCINOMA IMMUNOREACTIVE ANTIGEN', NULL, NULL, 27437, 8),
(240556, NULL, 'PTHR43766', NULL, NULL, NULL, NULL, 'TRYPTOPHAN--TRNA LIGASE, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(240557, NULL, 'PTHR37304', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', NULL, NULL, 6310, 8),
(240558, NULL, 'PTHR31378', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN-RELATED-RELATED', NULL, NULL, NULL, 8),
(240559, NULL, 'PTHR12596', NULL, NULL, NULL, NULL, 'EXPORTIN 4,7-RELATED', NULL, NULL, 36552, 8),
(240560, NULL, 'PTHR43501', NULL, NULL, NULL, NULL, 'CYTOSOL NON-SPECIFIC DIPEPTIDASE', NULL, NULL, 1462, 8),
(240561, NULL, 'PTHR21974', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(240562, NULL, 'PTHR41687', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 9', NULL, NULL, 32084, 8),
(240563, NULL, 'PTHR22600', NULL, NULL, NULL, NULL, 'BETA-HEXOSAMINIDASE', NULL, NULL, 26346, 8),
(240564, NULL, 'PTHR36100', NULL, NULL, NULL, NULL, 'BUD SITE SELECTION PROTEIN 4', NULL, NULL, NULL, 8),
(240565, NULL, 'PTHR47084', NULL, NULL, NULL, NULL, 'SERINE PALMITOYLTRANSFERASE SMALL SUBUNIT A', NULL, NULL, NULL, 8),
(240566, NULL, 'PTHR12881', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 1', NULL, NULL, NULL, 8),
(240567, NULL, 'PTHR42254', NULL, NULL, NULL, NULL, 'METALLOPHOS DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(240568, NULL, 'PTHR48252', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE 2-RELATED', NULL, NULL, NULL, 8),
(240569, NULL, 'PTHR11950', NULL, NULL, NULL, NULL, 'RUNT RELATED', NULL, NULL, 2709, 8),
(240570, NULL, 'PTHR37000', NULL, NULL, NULL, NULL, 'MUCIN-22', NULL, NULL, NULL, 8),
(240571, NULL, 'PTHR35151', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(240572, NULL, 'PTHR47280', NULL, NULL, NULL, NULL, 'PHEOPHYTINASE, CHLOROPLASTIC', NULL, NULL, 34505, 8),
(240573, NULL, 'PTHR10913', NULL, NULL, NULL, NULL, 'FOLLISTATIN-RELATED', NULL, NULL, NULL, 8),
(240574, NULL, 'PTHR12066', NULL, NULL, NULL, NULL, 'TELOMERASE REVERSE TRANSCRIPTASE', NULL, NULL, 7065, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(240575, NULL, 'PTHR31747', NULL, NULL, NULL, NULL, 'PROTEIN LSD1', NULL, NULL, 31255, 8),
(240576, NULL, 'PTHR46457', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RAD51 HOMOLOG 4', NULL, NULL, NULL, 8),
(240577, NULL, 'PTHR33703', NULL, NULL, NULL, NULL, 'OS07G0691300 PROTEIN', NULL, NULL, 13331, 8),
(240578, NULL, 'PTHR33630', NULL, NULL, NULL, NULL, 'CUTINASE RV1984C-RELATED-RELATED', NULL, NULL, NULL, 8),
(240579, NULL, 'PTHR15696', NULL, NULL, NULL, NULL, 'SMG-7  SUPPRESSOR WITH MORPHOLOGICAL EFFECT ON GENITALIA PROTEIN 7', NULL, NULL, 36577, 8),
(240580, NULL, 'PTHR33829', NULL, NULL, NULL, NULL, 'OSJNBA0044M19.10 PROTEIN', NULL, NULL, NULL, 8),
(240581, NULL, 'PTHR45800', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 4-KINASE GAMMA', NULL, NULL, 36444, 8),
(240582, NULL, 'PTHR38138', NULL, NULL, NULL, NULL, 'VNG6441H', NULL, NULL, NULL, 8),
(240583, NULL, 'PTHR36363', NULL, NULL, NULL, NULL, 'OS04G0687200 PROTEIN', NULL, NULL, NULL, 8),
(240584, NULL, 'PTHR18934', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE', NULL, NULL, NULL, 8),
(240585, NULL, 'PTHR21568', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 32140, 8),
(240586, NULL, 'PTHR13194', NULL, NULL, NULL, NULL, 'COMPLEX I INTERMEDIATE-ASSOCIATED PROTEIN 30', NULL, NULL, 27755, 8),
(240587, NULL, 'PTHR23342', NULL, NULL, NULL, NULL, 'N-ACETYLGLUTAMATE SYNTHASE', NULL, NULL, NULL, 8),
(240588, NULL, 'PTHR48232', NULL, NULL, NULL, NULL, 'INSULIN RECEPTOR SUBSTRATE HOMOLOG', NULL, NULL, NULL, 8),
(240589, NULL, 'PTHR34460', NULL, NULL, NULL, NULL, 'VITELLOGENIN-LIKE PROTEIN', NULL, NULL, NULL, 8),
(240590, NULL, 'PTHR31800', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 32', NULL, NULL, 21903, 8),
(240591, NULL, 'PTHR15487', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 2-BINDING PROTEIN', NULL, NULL, 32887, 8),
(240592, NULL, 'PTHR33978', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-KINASE', NULL, NULL, NULL, 8),
(240593, NULL, 'PTHR37340', NULL, NULL, NULL, NULL, 'GENE 7073-RELATED', NULL, NULL, 32058, 8),
(240594, NULL, 'PTHR22422', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AND COILED-COIL DOMAIN-CONTAINING PROTEIN 5B-RELATED', NULL, NULL, 22020, 8),
(240595, NULL, 'PTHR38789', NULL, NULL, NULL, NULL, 'REPRESSIBLE PROTEIN GRG1, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G14210)-RELATED', NULL, NULL, 12687, 8),
(240596, NULL, 'PTHR47527', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(240597, NULL, 'PTHR45855', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PIF1-RELATED', NULL, NULL, 25232, 8),
(240598, NULL, 'PTHR14991', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 32', NULL, NULL, 34323, 8),
(240599, NULL, 'PTHR16228', NULL, NULL, NULL, NULL, 'DIVALENT CATION TRANSPORTER  SOLUTE CARRIER FAMILY 41', NULL, NULL, 34936, 8),
(240600, NULL, 'PTHR11923', NULL, NULL, NULL, NULL, 'SCAVENGER RECEPTOR CLASS B TYPE-1  SR-B1', NULL, NULL, 270, 8),
(240601, NULL, 'PTHR33796', NULL, NULL, NULL, NULL, 'HOLLIDAY JUNCTION ATP-DEPENDENT DNA HELICASE RUVA', NULL, NULL, 2934, 8),
(240602, NULL, 'PTHR46782', NULL, NULL, NULL, NULL, 'OS01G0757700 PROTEIN', NULL, NULL, 36090, 8),
(240603, NULL, 'PTHR21162', NULL, NULL, NULL, NULL, 'P53 AND DNA DAMAGE-REGULATED PROTEIN', NULL, NULL, 23681, 8),
(240604, NULL, 'PTHR24271', NULL, NULL, NULL, NULL, 'KALLIKREIN-RELATED', NULL, NULL, NULL, 8),
(240605, NULL, 'PTHR46495', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE 21', NULL, NULL, NULL, 8),
(240606, NULL, 'PTHR46764', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE BAH1', NULL, NULL, 32493, 8),
(240607, NULL, 'PTHR31488', NULL, NULL, NULL, NULL, 'DPY-19-LIKE 1, LIKE (H. SAPIENS)', NULL, NULL, 18059, 8),
(240608, NULL, 'PTHR30308', NULL, NULL, NULL, NULL, 'TMRNA-BINDING COMPONENT OF TRANS-TRANSLATION TAGGING COMPLEX', NULL, NULL, 2703, 8),
(240609, NULL, 'PTHR46833', NULL, NULL, NULL, NULL, 'TELOMERIC REPEAT-BINDING FACTOR 2 TERF2', NULL, NULL, 22848, 8),
(240610, NULL, 'PTHR22736', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 32571, 8),
(240611, NULL, 'PTHR47784', NULL, NULL, NULL, NULL, 'STEROL UPTAKE CONTROL PROTEIN 2', NULL, NULL, NULL, 8);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(240612, NULL, 'PTHR10342', NULL, NULL, NULL, NULL, 'ARYLSULFATASE', NULL, NULL, NULL, 8),
(240613, NULL, 'PTHR47253', NULL, NULL, NULL, NULL, '', NULL, NULL, 37573, 8),
(240614, NULL, 'PTHR36432', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(240615, NULL, 'PTHR35791', NULL, NULL, NULL, NULL, 'UPF0754 MEMBRANE PROTEIN YHEB', NULL, NULL, NULL, 8),
(240616, NULL, 'PTHR46432', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 42', NULL, NULL, NULL, 8),
(240617, NULL, 'PTHR46814', NULL, NULL, NULL, NULL, 'EGALITARIAN, ISOFORM B', NULL, NULL, NULL, 8),
(240618, NULL, 'PTHR34354', NULL, NULL, NULL, NULL, 'NADPH-DEPENDENT 7-CYANO-7-DEAZAGUANINE REDUCTASE', NULL, NULL, NULL, 8),
(240619, NULL, 'PTHR33515', NULL, NULL, NULL, NULL, 'RIBOSOME-BINDING FACTOR A, CHLOROPLASTIC-RELATED', NULL, NULL, 4857, 8),
(240620, NULL, 'PTHR36357', NULL, NULL, NULL, NULL, 'OS03G0148300 PROTEIN', NULL, NULL, NULL, 8),
(240621, NULL, 'PTHR34213', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSPORT FACTOR 2 (NTF2) FAMILY PROTEIN', NULL, NULL, NULL, 8),
(240622, NULL, 'PTHR36705', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 20', NULL, NULL, NULL, 8),
(240623, NULL, 'PTHR19861', NULL, NULL, NULL, NULL, 'WD40 REPEAT PROTEIN SWD2', NULL, NULL, 30209, 8),
(240624, NULL, 'PTHR47848', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(240625, NULL, 'PTHR32493', NULL, NULL, NULL, NULL, 'SUSHI DOMAIN-CONTAINING PROTEIN 5', NULL, NULL, NULL, 8),
(240626, NULL, 'PTHR37023', NULL, NULL, NULL, NULL, 'TRANSPOSASE', NULL, NULL, NULL, 8),
(240627, NULL, 'PTHR11206', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN', NULL, NULL, NULL, 8),
(240628, NULL, 'PTHR33407', NULL, NULL, NULL, NULL, 'PECTATE LYASE F-RELATED', NULL, NULL, 1743, 8),
(240629, NULL, 'PTHR31406', NULL, NULL, NULL, NULL, 'PROTEIN CBG06702-RELATED', NULL, NULL, NULL, 8),
(240630, NULL, 'PTHR37550', NULL, NULL, NULL, NULL, 'ANTITOXIN VAPB1', NULL, NULL, NULL, 8),
(240631, NULL, 'PTHR24031', NULL, NULL, NULL, NULL, 'RNA HELICASE', NULL, NULL, NULL, 8),
(240632, NULL, 'PTHR47625', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(240633, NULL, 'PTHR13064', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 9 FAMILY MEMBER', NULL, NULL, 13840, 8),
(240634, NULL, 'PTHR14149', NULL, NULL, NULL, NULL, 'RAS GTPASE-ACTIVATING PROTEIN WITH IQ MOTIF', NULL, NULL, NULL, 8),
(240635, NULL, 'PTHR41153', NULL, NULL, NULL, NULL, 'RE41427P', NULL, NULL, NULL, 8),
(240636, NULL, 'PTHR22426', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(240637, NULL, 'PTHR31116', NULL, NULL, NULL, NULL, 'OS04G0501200 PROTEIN', NULL, NULL, NULL, 8),
(240638, NULL, 'PTHR33096', NULL, NULL, NULL, NULL, 'CXC2 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(240639, NULL, 'PTHR46298', NULL, NULL, NULL, NULL, 'ANDROGLOBIN', NULL, NULL, NULL, 8),
(240640, NULL, 'PTHR30160', NULL, NULL, NULL, NULL, 'TETRAACYLDISACCHARIDE 4''-KINASE-RELATED', NULL, NULL, NULL, 8),
(240641, NULL, 'PTHR22988', NULL, NULL, NULL, NULL, 'MYOTONIC DYSTROPHY S/T KINASE-RELATED', NULL, NULL, NULL, 8),
(240642, NULL, 'PTHR42765', NULL, NULL, NULL, NULL, 'SOLEUCYL-TRNA SYNTHETASE', NULL, NULL, NULL, 8),
(240643, NULL, 'PTHR10390', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN SIX', NULL, NULL, NULL, 8),
(240644, NULL, 'PTHR39419', NULL, NULL, NULL, NULL, 'SLL0814 PROTEIN', NULL, NULL, 5701, 8),
(240645, NULL, 'PTHR11885', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S15P/S13E', NULL, NULL, 15090, 8),
(240646, NULL, 'PTHR48102', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE ATP-BINDING SUBUNIT CLPX-LIKE, MITOCHONDRIAL-RELATED', NULL, NULL, NULL, 8),
(240647, NULL, 'PTHR31581', NULL, NULL, NULL, NULL, 'KICSTOR COMPLEX PROTEIN C12ORF66', NULL, NULL, 14927, 8),
(240648, NULL, 'PTHR15933', NULL, NULL, NULL, NULL, 'PROTEIN CBG16327', NULL, NULL, 21754, 8),
(240649, NULL, 'PTHR28052', NULL, NULL, NULL, NULL, 'UPF0545 PROTEIN C22ORF39', NULL, NULL, 18409, 8),
(240650, NULL, 'PTHR35309', NULL, NULL, NULL, NULL, '', NULL, NULL, 25557, 8),
(240651, NULL, 'PTHR15076', NULL, NULL, NULL, NULL, 'CD99/MIC2 PROTEIN RELATED', NULL, NULL, 20659, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(240652, NULL, 'PTHR36016', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 7', NULL, NULL, 27423, 8),
(240653, NULL, 'PTHR47462', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE PROTEIN 5', NULL, NULL, 37238, 8),
(240654, NULL, 'PTHR34812', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REACTION CENTER PROTEIN J', NULL, NULL, 2543, 8),
(240655, NULL, 'PTHR34674', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLCHOLINE:DIACYLGLYCEROL CHOLINEPHOSPHOTRANSFERASE 1-RELATED', NULL, NULL, NULL, 8),
(240656, NULL, 'PTHR43233', NULL, NULL, NULL, NULL, 'FAMILY N-ACETYLTRANSFERASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G03350)-RELATED', NULL, NULL, NULL, 8),
(240657, NULL, 'PTHR30603', NULL, NULL, NULL, NULL, 'RNA POLYMERASE SIGMA FACTOR RPO', NULL, NULL, NULL, 8),
(240658, NULL, 'PTHR45588', NULL, NULL, NULL, NULL, 'TPR DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(240659, NULL, 'PTHR42776', NULL, NULL, NULL, NULL, 'SERINE PEPTIDASE S9 FAMILY MEMBER', NULL, NULL, NULL, 8),
(240660, NULL, 'PTHR18834', NULL, NULL, NULL, NULL, 'STEROID RECEPTOR RNA ACTIVATOR 1', NULL, NULL, 32305, 8),
(240661, NULL, 'PTHR48062', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 14', NULL, NULL, NULL, 8),
(240662, NULL, 'PTHR43888', NULL, NULL, NULL, NULL, 'DNAJ-LIKE-2, ISOFORM A-RELATED', NULL, NULL, 34859, 8),
(240663, NULL, 'PTHR13589', NULL, NULL, NULL, NULL, 'CREB-REGULATED TRANSCRIPTION COACTIVATOR', NULL, NULL, 23855, 8),
(240664, NULL, 'PTHR11429', NULL, NULL, NULL, NULL, 'MYELIN BASIC PROTEIN', NULL, NULL, 5901, 8),
(240665, NULL, 'PTHR38353', NULL, NULL, NULL, NULL, 'TROPOMYOSIN', NULL, NULL, NULL, 8),
(240666, NULL, 'PTHR38780', NULL, NULL, NULL, NULL, 'PROTEIN TUSC', NULL, NULL, 20607, 8),
(240667, NULL, 'PTHR21449', NULL, NULL, NULL, NULL, 'PROTEIN CBG05271-RELATED', NULL, NULL, NULL, 8),
(240668, NULL, 'PTHR12243', NULL, NULL, NULL, NULL, 'MADF DOMAIN TRANSCRIPTION FACTOR', NULL, NULL, 33010, 8),
(240669, NULL, 'PTHR39398', NULL, NULL, NULL, NULL, 'YALI0F14311P', NULL, NULL, NULL, 8),
(240670, NULL, 'PTHR36443', NULL, NULL, NULL, NULL, 'BSR5223 PROTEIN', NULL, NULL, 17515, 8),
(240671, NULL, 'PTHR27006', NULL, NULL, NULL, NULL, 'PROMASTIGOTE SURFACE ANTIGEN PROTEIN PSA', NULL, NULL, NULL, 8),
(240672, NULL, 'PTHR23117', NULL, NULL, NULL, NULL, 'GUANYLATE KINASE-RELATED', NULL, NULL, NULL, 8),
(240673, NULL, 'PTHR47349', NULL, NULL, NULL, NULL, 'CHROMOSOME 8, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(240674, NULL, 'PTHR37322', NULL, NULL, NULL, NULL, '', NULL, NULL, 33446, 8),
(240675, NULL, 'PTHR14421', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 1', NULL, NULL, 32762, 8),
(240676, NULL, 'PTHR37728', NULL, NULL, NULL, NULL, 'BNAA04G26730D PROTEIN', NULL, NULL, NULL, 8),
(240677, NULL, 'PTHR38627', NULL, NULL, NULL, NULL, 'GA BINDING AND ACTIVATING AND SPK (SPK) DOMAIN CONTAINING-RELATED', NULL, NULL, NULL, 8),
(240678, NULL, 'PTHR35761', NULL, NULL, NULL, NULL, 'ATR INTERACTING PROTEIN', NULL, NULL, 35407, 8),
(240679, NULL, 'PTHR12899', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L18, MITOCHONDRIAL', NULL, NULL, 910, 8),
(240680, NULL, 'PTHR30182', NULL, NULL, NULL, NULL, 'L-SERINE DEHYDRATASE', NULL, NULL, NULL, 8),
(240681, NULL, 'PTHR47388', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 18', NULL, NULL, NULL, 8),
(240682, NULL, 'PTHR33347', NULL, NULL, NULL, NULL, 'OSJNBA0091C07.3 PROTEIN', NULL, NULL, 36225, 8),
(240683, NULL, 'PTHR19855', NULL, NULL, NULL, NULL, 'WD40 REPEAT PROTEIN 12, 37', NULL, NULL, NULL, 8),
(240684, NULL, 'PTHR43877', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(240685, NULL, 'PTHR42923', NULL, NULL, NULL, NULL, 'PROTOPORPHYRINOGEN OXIDASE', NULL, NULL, NULL, 8),
(240686, NULL, 'PTHR16026', NULL, NULL, NULL, NULL, 'CARTILAGE ACIDIC PROTEIN 1', NULL, NULL, NULL, 8),
(240687, NULL, 'PTHR31203', NULL, NULL, NULL, NULL, 'BETA-KERATIN-RELATED PROTEIN-RELATED', NULL, NULL, 5419, 8),
(240688, NULL, 'PTHR19343', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 1-2', NULL, NULL, NULL, 8),
(240689, NULL, 'PTHR24185', NULL, NULL, NULL, NULL, 'CALCIUM-INDEPENDENT PHOSPHOLIPASE A2-GAMMA', NULL, NULL, NULL, 8);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(240690, NULL, 'PTHR10877', NULL, NULL, NULL, NULL, 'POLYCYSTIN FAMILY MEMBER', NULL, NULL, NULL, 8),
(240691, NULL, 'PTHR28136', NULL, NULL, NULL, NULL, 'NUCLEUS EXPORT PROTEIN BRR6', NULL, NULL, 31497, 8),
(240692, NULL, 'PTHR43253', NULL, NULL, NULL, NULL, 'TRICORN PROTEASE HOMOLOG 2-RELATED', NULL, NULL, 13029, 8),
(240693, NULL, 'PTHR45836', NULL, NULL, NULL, NULL, 'SLIT HOMOLOG', NULL, NULL, NULL, 8),
(240694, NULL, 'PTHR13103', NULL, NULL, NULL, NULL, 'SCHWANNOMIN INTERACTING PROTEIN 1', NULL, NULL, 28698, 8),
(240695, NULL, 'PTHR46796', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL ACTIVATOR RHAS-RELATED', NULL, NULL, NULL, 8),
(240696, NULL, 'PTHR38820', NULL, NULL, NULL, NULL, 'ANNEXIN-2 RECEPTOR', NULL, NULL, 24275, 8),
(240697, NULL, 'PTHR42855', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING SUBUNIT', NULL, NULL, NULL, 8),
(240698, NULL, 'PTHR46605', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR', NULL, NULL, NULL, 8),
(240699, NULL, 'PTHR36864', NULL, NULL, NULL, NULL, 'CANCER-ASSOCIATED GENE 1 PROTEIN', NULL, NULL, NULL, 8),
(240700, NULL, 'PTHR28599', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 12', NULL, NULL, 24916, 8),
(240701, NULL, 'PTHR10093', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER ASSEMBLY ENZYME  NIFU HOMOLOG', NULL, NULL, 5732, 8),
(240702, NULL, 'PTHR38626', NULL, NULL, NULL, NULL, 'SKN-1 DEPENDENT ZYGOTIC TRANSCRIPT-RELATED', NULL, NULL, 31218, 8),
(240703, NULL, 'PTHR36734', NULL, NULL, NULL, NULL, 'YCF37-LIKE PROTEIN', NULL, NULL, NULL, 8),
(240704, NULL, 'PTHR20967', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(240705, NULL, 'PTHR33099', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(240706, NULL, 'PTHR45629', NULL, NULL, NULL, NULL, 'SNF2/RAD54 FAMILY MEMBER', NULL, NULL, NULL, 8),
(240707, NULL, 'PTHR44269', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE SDR FAMILY MEMBER 7-RELATED', NULL, NULL, NULL, 8),
(240708, NULL, 'PTHR41287', NULL, NULL, NULL, NULL, '', NULL, NULL, 1270, 8),
(240709, NULL, 'PTHR22572', NULL, NULL, NULL, NULL, 'SUGAR-1-PHOSPHATE GUANYL TRANSFERASE', NULL, NULL, NULL, 8),
(240710, NULL, 'PTHR13041', NULL, NULL, NULL, NULL, 'JTB PROTEIN-RELATED', NULL, NULL, 12940, 8),
(240711, NULL, 'PTHR12761', NULL, NULL, NULL, NULL, 'HERMANSKY-PUDLAK SYNDROME PROTEIN 1', NULL, NULL, 25205, 8),
(240712, NULL, 'PTHR34258', NULL, NULL, NULL, NULL, 'ARMADILLO-LIKE HELICAL DOMAIN CONTAINING PROTEIN 1', NULL, NULL, 29488, 8),
(240713, NULL, 'PTHR24012', NULL, NULL, NULL, NULL, 'RNA BINDING PROTEIN', NULL, NULL, NULL, 8),
(240714, NULL, 'PTHR31887', NULL, NULL, NULL, NULL, 'NEMATODE SPECIFIC PEPTIDE FAMILY, GROUP B', NULL, NULL, NULL, 8),
(240715, NULL, 'PTHR10161', NULL, NULL, NULL, NULL, 'TARTRATE-RESISTANT ACID PHOSPHATASE TYPE 5', NULL, NULL, NULL, 8),
(240716, NULL, 'PTHR31143', NULL, NULL, NULL, NULL, '', NULL, NULL, 24283, 8),
(240717, NULL, 'PTHR12439', NULL, NULL, NULL, NULL, 'PLACENTAL PROTEIN 11-RELATED', NULL, NULL, 27386, 8),
(240718, NULL, 'PTHR36124', NULL, NULL, NULL, NULL, '', NULL, NULL, 36798, 8),
(240719, NULL, 'PTHR21452', NULL, NULL, NULL, NULL, 'EXPORTIN-6', NULL, NULL, 31337, 8),
(240720, NULL, 'PTHR13333', NULL, NULL, NULL, NULL, 'M-AAA PROTEASE-INTERACTING PROTEIN 1, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(240721, NULL, 'PTHR36999', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NADP]', NULL, NULL, 7114, 8),
(240722, NULL, 'PTHR12460', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR-RELATED PROTEIN', NULL, NULL, NULL, 8),
(240723, NULL, 'PTHR43465', NULL, NULL, NULL, NULL, 'DUF1680 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_1G08910)', NULL, NULL, NULL, 8),
(240724, NULL, 'PTHR44573', NULL, NULL, NULL, NULL, 'NADPH-DEPENDENT ALKENAL/ONE OXIDOREDUCTASE, CHLOROPLASTIC', NULL, NULL, 36305, 8),
(240725, NULL, 'PTHR16083', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(240726, NULL, 'PTHR35299', NULL, NULL, NULL, NULL, 'RUBISCO ACCUMULATION FACTOR 1', NULL, NULL, 27560, 8),
(240727, NULL, 'PTHR18956', NULL, NULL, NULL, NULL, 'HYALURONAN MEDIATED MOTILITY RECEPTOR', NULL, NULL, 24573, 8);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(240728, NULL, 'PTHR13767', NULL, NULL, NULL, NULL, 'TRNA-PSEUDOURIDINE SYNTHASE', NULL, NULL, 8750, 8),
(240729, NULL, 'PTHR10498', NULL, NULL, NULL, NULL, 'PARALEMMIN-RELATED', NULL, NULL, NULL, 8),
(240730, NULL, 'PTHR19315', NULL, NULL, NULL, NULL, 'ER MEMBRANE PROTEIN COMPLEX SUBUNIT 4', NULL, NULL, 8284, 8),
(240731, NULL, 'PTHR45974', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE PROTEIN 55', NULL, NULL, NULL, 8),
(240732, NULL, 'PTHR37171', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE YRZF-RELATED', NULL, NULL, NULL, 8),
(240733, NULL, 'PTHR42029', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(240734, NULL, 'PTHR14447', NULL, NULL, NULL, NULL, 'UROTENSIN 2', NULL, NULL, NULL, 8),
(240735, NULL, 'PTHR46904', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN T', NULL, NULL, 26969, 8),
(240736, NULL, 'PTHR44442', NULL, NULL, NULL, NULL, '3-KETO-STEROID REDUCTASE', NULL, NULL, NULL, 8),
(240737, NULL, 'PTHR35177', NULL, NULL, NULL, NULL, 'HYDROGENASE MATURATION FACTOR HYBG', NULL, NULL, 1282, 8),
(240738, NULL, 'PTHR35712', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN-LIKE PROTEIN', NULL, NULL, NULL, 8),
(240739, NULL, 'PTHR23517', NULL, NULL, NULL, NULL, 'RESISTANCE PROTEIN MDTM, PUTATIVE-RELATED-RELATED', NULL, NULL, NULL, 8),
(240740, NULL, 'PTHR30401', NULL, NULL, NULL, NULL, 'TRNA 2-SELENOURIDINE SYNTHASE', NULL, NULL, NULL, 8),
(240741, NULL, 'PTHR21385', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN-RELATED', NULL, NULL, NULL, 8),
(240742, NULL, 'PTHR38393', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA (GLN) AMIDOTRANSFERASE SUBUNIT C', NULL, NULL, NULL, 8),
(240743, NULL, 'PTHR46766', NULL, NULL, NULL, NULL, 'GLUTAMINE-RICH PROTEIN 2', NULL, NULL, NULL, 8),
(240744, NULL, 'PTHR35549', NULL, NULL, NULL, NULL, 'OS04G0584500 PROTEIN', NULL, NULL, NULL, 8),
(240745, NULL, 'PTHR47804', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L19', NULL, NULL, NULL, 8),
(240746, NULL, 'PTHR48227', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE 1-LIKE', NULL, NULL, NULL, 8),
(240747, NULL, 'PTHR30332', NULL, NULL, NULL, NULL, 'PROBABLE GENERAL SECRETION PATHWAY PROTEIN D', NULL, NULL, NULL, 8),
(240748, NULL, 'PTHR33420', NULL, NULL, NULL, NULL, 'FIMBRIAL SUBUNIT ELFA-RELATED', NULL, NULL, NULL, 8),
(240749, NULL, 'PTHR31204', NULL, NULL, NULL, NULL, 'SIGMA INTRACELLULAR RECEPTOR 2', NULL, NULL, NULL, 8),
(240750, NULL, 'PTHR47827', NULL, NULL, NULL, NULL, 'AHD DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(240751, NULL, 'PTHR42336', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(240752, NULL, 'PTHR38580', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 192', NULL, NULL, 30562, 8),
(240753, NULL, 'PTHR44663', NULL, NULL, NULL, NULL, 'JUNCTIONAL ADHESION MOLECULE B', NULL, NULL, 35694, 8),
(240754, NULL, 'PTHR31929', NULL, NULL, NULL, NULL, 'SAUR-LIKE AUXIN-RESPONSIVE PROTEIN FAMILY-RELATED', NULL, NULL, 6134, 8),
(240755, NULL, 'PTHR38847', NULL, NULL, NULL, NULL, '', NULL, NULL, 24637, 8),
(240756, NULL, 'PTHR38762', NULL, NULL, NULL, NULL, 'CRYPTIC OUTER MEMBRANE PORIN BGLH-RELATED', NULL, NULL, NULL, 8),
(240757, NULL, 'PTHR34546', NULL, NULL, NULL, NULL, 'OS06G0153600 PROTEIN', NULL, NULL, NULL, 8),
(240758, NULL, 'PTHR38041', NULL, NULL, NULL, NULL, 'CHORISMATE MUTASE', NULL, NULL, NULL, 8),
(240759, NULL, 'PTHR10233', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR EIF-2B', NULL, NULL, NULL, 8),
(240760, NULL, 'PTHR37038', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', NULL, NULL, NULL, 8),
(240761, NULL, 'PTHR42948', NULL, NULL, NULL, NULL, 'TRANSPORTER', NULL, NULL, NULL, 8),
(240762, NULL, 'PTHR45771', NULL, NULL, NULL, NULL, 'HOMEOTIC PROTEIN DEFORMED', NULL, NULL, NULL, 8),
(240763, NULL, 'PTHR13098', NULL, NULL, NULL, NULL, 'WOLFRAMIN', NULL, NULL, 25693, 8),
(240764, NULL, 'PTHR18829', NULL, NULL, NULL, NULL, 'PROTEIN YAE1 HOMOLOG', NULL, NULL, 30799, 8),
(240765, NULL, 'PTHR34357', NULL, NULL, NULL, NULL, 'F7A19.14 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(240766, NULL, 'PTHR45652', NULL, NULL, NULL, NULL, 'GLIAL FIBRILLARY ACIDIC PROTEIN', NULL, NULL, NULL, 8);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(240767, NULL, 'PTHR24330', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN BARH-LIKE', NULL, NULL, NULL, 8),
(240768, NULL, 'PTHR47292', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR (TFIIS) FAMILY PROTEIN-RELATED', NULL, NULL, NULL, 8),
(240769, NULL, 'PTHR24103', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM', NULL, NULL, NULL, 8),
(240770, NULL, 'PTHR22997', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(240771, NULL, 'PTHR30473', NULL, NULL, NULL, NULL, 'PROTEIN PHOH', NULL, NULL, NULL, 8),
(240772, NULL, 'PTHR11056', NULL, NULL, NULL, NULL, 'HOMOGENTISATE 1,2-DIOXYGENASE', NULL, NULL, 3838, 8),
(240773, NULL, 'PTHR37970', NULL, NULL, NULL, NULL, 'PROTEIN CBG08587', NULL, NULL, NULL, 8),
(240774, NULL, 'PTHR46765', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOSIDE TRIPHOSPHATE HYDROLASES SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(240775, NULL, 'PTHR33415', NULL, NULL, NULL, NULL, 'PROTEIN EMBRYO DEFECTIVE 514', NULL, NULL, 36266, 8),
(240776, NULL, 'PTHR43200', NULL, NULL, NULL, NULL, 'PHOSPHATASE', NULL, NULL, NULL, 8),
(240777, NULL, 'PTHR39082', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE C-BETA-2-RELATED', NULL, NULL, NULL, 8),
(240778, NULL, 'PTHR35763', NULL, NULL, NULL, NULL, 'COMPLEX 1 LYR-LIKE PROTEIN', NULL, NULL, NULL, 8),
(240779, NULL, 'PTHR43515', NULL, NULL, NULL, NULL, 'THREONINE SYNTHASE-LIKE 1', NULL, NULL, NULL, 8),
(240780, NULL, 'PTHR24252', NULL, NULL, NULL, NULL, 'ACROSIN-RELATED', NULL, NULL, NULL, 8),
(240781, NULL, 'PTHR46999', NULL, NULL, NULL, NULL, 'ALPHA-GLUCAN WATER DIKINASE 1, CHLOROPLASTIC-RELATED', NULL, NULL, NULL, 8),
(240782, NULL, 'PTHR32263', NULL, NULL, NULL, NULL, 'INACTIVE POLY [ADP-RIBOSE] POLYMERASE SRO4-RELATED', NULL, NULL, 36745, 8),
(240783, NULL, 'PTHR33074', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', NULL, NULL, NULL, 8),
(240784, NULL, 'PTHR46117', NULL, NULL, NULL, NULL, 'FI24210P1', NULL, NULL, NULL, 8),
(240785, NULL, 'PTHR38332', NULL, NULL, NULL, NULL, 'PROTEIN CBG11604', NULL, NULL, NULL, 8),
(240786, NULL, 'PTHR15177', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 143', NULL, NULL, 6144, 8),
(240787, NULL, 'PTHR12959', NULL, NULL, NULL, NULL, 'GPI TRANSAMIDASE COMPONENT PIG-T-RELATED', NULL, NULL, 6501, 8),
(240788, NULL, 'PTHR47702', NULL, NULL, NULL, NULL, 'RETROTRANSPOSON GAG-LIKE PROTEIN 9', NULL, NULL, 34283, 8),
(240789, NULL, 'PTHR12144', NULL, NULL, NULL, NULL, 'NEGATIVE ELONGATION FACTOR D', NULL, NULL, 5784, 8),
(240790, NULL, 'PTHR33966', NULL, NULL, NULL, NULL, 'PROTEIN ODR-4 HOMOLOG', NULL, NULL, 25925, 8),
(240791, NULL, 'PTHR20903', NULL, NULL, NULL, NULL, 'PREFOLDIN SUBUNIT 1-RELATED', NULL, NULL, NULL, 8),
(240792, NULL, 'PTHR35325', NULL, NULL, NULL, NULL, '', NULL, NULL, 4449, 8),
(240793, NULL, 'PTHR15735', NULL, NULL, NULL, NULL, 'FCH AND DOUBLE SH3 DOMAINS PROTEIN', NULL, NULL, NULL, 8),
(240794, NULL, 'PTHR46221', NULL, NULL, NULL, NULL, 'FERM AND PDZ DOMAIN-CONTAINING PROTEIN FAMILY MEMBER', NULL, NULL, NULL, 8),
(240795, NULL, 'PTHR15282', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY E MEMBER 1, 3', NULL, NULL, 458, 8),
(240796, NULL, 'PTHR47659', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', NULL, NULL, NULL, 8),
(240797, NULL, 'PTHR37261', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S27', NULL, NULL, NULL, 8),
(240798, NULL, 'PTHR11051', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE-RELATED', NULL, NULL, NULL, 8),
(240799, NULL, 'PTHR12468', NULL, NULL, NULL, NULL, 'GPI MANNOSYLTRANSFERASE 2', NULL, NULL, 4812, 8),
(240800, NULL, 'PTHR48193', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEASE ZMPB-RELATED', NULL, NULL, NULL, 8),
(240801, NULL, 'PTHR36755', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(240802, NULL, 'PTHR12691', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 23', NULL, NULL, 18567, 8),
(240803, NULL, 'PTHR42738', NULL, NULL, NULL, NULL, 'HYDROXYMETHYLGLUTARYL-COA LYASE', NULL, NULL, 35797, 8),
(240804, NULL, 'PTHR36027', NULL, NULL, NULL, NULL, 'MEIOSIS-SPECIFIC PROTEIN ASY3', NULL, NULL, 33282, 8);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(240805, NULL, 'PTHR33664', NULL, NULL, NULL, NULL, 'RCG26366', NULL, NULL, 27524, 8),
(240806, NULL, 'PTHR40020', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY FACTOR 2', NULL, NULL, NULL, 8),
(240807, NULL, 'PTHR13950', NULL, NULL, NULL, NULL, 'RABCONNECTIN-RELATED', NULL, NULL, NULL, 8),
(240808, NULL, 'PTHR48268', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN KNOTTED-1-LIKE 6 ISOFORM X1', NULL, NULL, NULL, 8),
(240809, NULL, 'PTHR43170', NULL, NULL, NULL, NULL, 'GMP REDUCTASE', NULL, NULL, NULL, 8),
(240810, NULL, 'PTHR31157', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(240811, NULL, 'PTHR48229', NULL, NULL, NULL, NULL, 'CAIB/BAIF FAMILY ENZYME (AFU_ORTHOLOGUE AFUA_1G05360)-RELATED', NULL, NULL, NULL, 8),
(240812, NULL, 'PTHR46614', NULL, NULL, NULL, NULL, 'MORN REPEAT-CONTAINING PROTEIN 4', NULL, NULL, NULL, 8),
(240813, NULL, 'PTHR47335', NULL, NULL, NULL, NULL, 'UNCONVENTIONAL MYOSIN-XVI', NULL, NULL, NULL, 8),
(240814, NULL, 'PTHR39956', NULL, NULL, NULL, NULL, 'GH09530P-RELATED', NULL, NULL, NULL, 8),
(240815, NULL, 'PTHR28582', NULL, NULL, NULL, NULL, 'TRNA-SPLICING ENDONUCLEASE SUBUNIT SEN15', NULL, NULL, NULL, 8),
(240816, NULL, 'PTHR15387', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 17', NULL, NULL, 28655, 8),
(240817, NULL, 'PTHR24042', NULL, NULL, NULL, NULL, 'NEL HOMOLOG', NULL, NULL, NULL, 8),
(240818, NULL, 'PTHR35764', NULL, NULL, NULL, NULL, 'PROTEIN SHORTAGE IN CHIASMATA 1', NULL, NULL, 30534, 8),
(240819, NULL, 'PTHR28612', NULL, NULL, NULL, NULL, 'SERINE PALMITOYLTRANSFERASE SMALL SUBUNIT B', NULL, NULL, NULL, 8),
(240820, NULL, 'PTHR31434', NULL, NULL, NULL, NULL, 'S PHASE CYCLIN A-ASSOCIATED PROTEIN IN THE ENDOPLASMIC RETICULUM', NULL, NULL, NULL, 8),
(240821, NULL, 'PTHR36784', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(240822, NULL, 'PTHR47541', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(240823, NULL, 'PTHR31843', NULL, NULL, NULL, NULL, 'ALLENE OXIDE CYCLASE 4, CHLOROPLASTIC', NULL, NULL, 8288, 8),
(240824, NULL, 'PTHR34784', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L34', NULL, NULL, 10607, 8),
(240825, NULL, 'PTHR35477', NULL, NULL, NULL, NULL, 'OS06G0728500 PROTEIN', NULL, NULL, NULL, 8),
(240826, NULL, 'PTHR19139', NULL, NULL, NULL, NULL, 'AQUAPORIN TRANSPORTER', NULL, NULL, 24028, 8),
(240827, NULL, 'PTHR11387', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 6B', NULL, NULL, 2128, 8),
(240828, NULL, 'PTHR16866', NULL, NULL, NULL, NULL, 'GASTRIN-RELEASING PEPTIDE', NULL, NULL, 76, 8),
(240829, NULL, 'PTHR31331', NULL, NULL, NULL, NULL, 'LCCL DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_5G08630)', NULL, NULL, NULL, 8),
(240830, NULL, 'PTHR36300', NULL, NULL, NULL, NULL, 'RAW, ISOFORM A', NULL, NULL, NULL, 8),
(240831, NULL, 'PTHR34559', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 8', NULL, NULL, 12719, 8),
(240832, NULL, 'PTHR11608', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL PROTEIN PYRR', NULL, NULL, NULL, 8),
(240833, NULL, 'PTHR46013', NULL, NULL, NULL, NULL, 'VASCULAR CELL ADHESION MOLECULE 1', NULL, NULL, NULL, 8),
(240834, NULL, 'PTHR10856', NULL, NULL, NULL, NULL, 'CORONIN', NULL, NULL, 8088, 8),
(240835, NULL, 'PTHR35245', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(240836, NULL, 'PTHR12403', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT 2', NULL, NULL, 2166, 8),
(240837, NULL, 'PTHR43393', NULL, NULL, NULL, NULL, 'CYTOKININ RIBOSIDE 5''-MONOPHOSPHATE PHOSPHORIBOHYDROLASE', NULL, NULL, NULL, 8),
(240838, NULL, 'PTHR24107', NULL, NULL, NULL, NULL, 'YNEIN REGULATORY COMPLEX SUBUNIT 5', NULL, NULL, NULL, 8),
(240839, NULL, 'PTHR22618', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 32683, 8),
(240840, NULL, 'PTHR47444', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(240841, NULL, 'PTHR34043', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(240842, NULL, 'PTHR36406', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 30', NULL, NULL, 3695, 8);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(240843, NULL, 'PTHR36138', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', NULL, NULL, NULL, 8),
(240844, NULL, 'PTHR23400', NULL, NULL, NULL, NULL, 'DENTIN MATRIX ACIDIC PHOSPHOPROTEIN 1', NULL, NULL, 14026, 8),
(240845, NULL, 'PTHR10322', NULL, NULL, NULL, NULL, 'DNA POLYMERASE CATALYTIC SUBUNIT', NULL, NULL, NULL, 8),
(240846, NULL, 'PTHR47506', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', NULL, NULL, NULL, 8),
(240847, NULL, 'PTHR31756', NULL, NULL, NULL, NULL, 'PYRUVATE, PHOSPHATE DIKINASE REGULATORY PROTEIN 1, CHLOROPLASTIC', NULL, NULL, 5152, 8),
(240848, NULL, 'PTHR43790', NULL, NULL, NULL, NULL, 'CARBOHYDRATE TRANSPORT ATP-BINDING PROTEIN MG119-RELATED', NULL, NULL, NULL, 8),
(240849, NULL, 'PTHR37010', NULL, NULL, NULL, NULL, 'SULFURTRANSFERASE TUSE', NULL, NULL, 4858, 8),
(240850, NULL, 'PTHR35308', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 7', NULL, NULL, 29730, 8),
(240851, NULL, 'PTHR47106', NULL, NULL, NULL, NULL, 'COILED-COIL-HELIX-COILED-COIL-HELIX DOMAIN-CONTAINING PROTEIN 5', NULL, NULL, NULL, 8),
(240852, NULL, 'PTHR46309', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN 12', NULL, NULL, 34762, 8),
(240853, NULL, 'PTHR30420', NULL, NULL, NULL, NULL, 'N-SUCCINYLARGININE DIHYDROLASE', NULL, NULL, NULL, 8),
(240854, NULL, 'PTHR33939', NULL, NULL, NULL, NULL, 'PROTEIN CBG22215', NULL, NULL, NULL, 8),
(240855, NULL, 'PTHR45961', NULL, NULL, NULL, NULL, 'IP21249P', NULL, NULL, NULL, 8),
(240856, NULL, 'PTHR44566', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(240857, NULL, 'PTHR34830', NULL, NULL, NULL, NULL, 'SIMILAR TO HYPOTHETICAL PROTEIN MGC34837', NULL, NULL, 28916, 8),
(240858, NULL, 'PTHR15394', NULL, NULL, NULL, NULL, 'SERINE HYDROLASE RBBP9', NULL, NULL, NULL, 8),
(240859, NULL, 'PTHR34314', NULL, NULL, NULL, NULL, 'CRENARCHAEAL PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(240860, NULL, 'PTHR14677', NULL, NULL, NULL, NULL, 'ARSENITE INDUCUBLE RNA ASSOCIATED PROTEIN AIP-1-RELATED', NULL, NULL, NULL, 8),
(240861, NULL, 'PTHR23260', NULL, NULL, NULL, NULL, 'KERATIN ASSOCIATED PROTEIN 3-3-RELATED', NULL, NULL, 65, 8),
(240862, NULL, 'PTHR31014', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 7561, 8),
(240863, NULL, 'PTHR48014', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE FRAY2', NULL, NULL, NULL, 8),
(240864, NULL, 'PTHR10689', NULL, NULL, NULL, NULL, 'MICROSOMAL GLUTATHIONE S-TRANSFERASE 1', NULL, NULL, 30287, 8),
(240865, NULL, 'PTHR23261', NULL, NULL, NULL, NULL, 'GROUNDHOG-RELATED', NULL, NULL, NULL, 8),
(240866, NULL, 'PTHR14555', NULL, NULL, NULL, NULL, 'MYELIN-ASSOCIATED OLIGODENDROCYTIC BASIC PROTEIN  MOBP -RELATED', NULL, NULL, NULL, 8),
(240867, NULL, 'PTHR43706', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE', NULL, NULL, 35657, 8),
(240868, NULL, 'PTHR28348', NULL, NULL, NULL, NULL, 'UPF0193 PROTEIN EVG1', NULL, NULL, 3307, 8),
(240869, NULL, 'PTHR24349', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE', NULL, NULL, NULL, 8),
(240870, NULL, 'PTHR13165', NULL, NULL, NULL, NULL, 'ARSENITE-RESISTANCE PROTEIN 2', NULL, NULL, 27392, 8),
(240871, NULL, 'PTHR46054', NULL, NULL, NULL, NULL, 'MATERNAL EFFECT PROTEIN STAUFEN', NULL, NULL, NULL, 8),
(240872, NULL, 'PTHR34319', NULL, NULL, NULL, NULL, 'MAJOR EXPORTED PROTEIN', NULL, NULL, NULL, 8),
(240873, NULL, 'PTHR35306', NULL, NULL, NULL, NULL, 'BNAA03G57290D PROTEIN', NULL, NULL, NULL, 8),
(240874, NULL, 'PTHR10003', NULL, NULL, NULL, NULL, 'SUPEROXIDE DISMUTASE  CU-ZN -RELATED', NULL, NULL, 12075, 8),
(240875, NULL, 'PTHR43254', NULL, NULL, NULL, NULL, 'C-TERMINAL BINDING PROTEIN AN-RELATED', NULL, NULL, 34665, 8),
(240876, NULL, 'PTHR40111', NULL, NULL, NULL, NULL, 'CEPHALOSPORIN-C DEACETYLASE', NULL, NULL, 32568, 8),
(240877, NULL, 'PTHR35733', NULL, NULL, NULL, NULL, 'OS02G0307800 PROTEIN', NULL, NULL, NULL, 8),
(240878, NULL, 'PTHR11547', NULL, NULL, NULL, NULL, 'ARGININE OR CREATINE KINASE', NULL, NULL, 4666, 8),
(240879, NULL, 'PTHR21136', NULL, NULL, NULL, NULL, 'SNARE PROTEINS', NULL, NULL, NULL, 8);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(240880, NULL, 'PTHR30461', NULL, NULL, NULL, NULL, 'DNA-INVERTASE FROM LAMBDOID PROPHAGE', NULL, NULL, NULL, 8),
(240881, NULL, 'PTHR46061', NULL, NULL, NULL, NULL, 'THYROTROPIN-RELEASING HORMONE RECEPTOR', NULL, NULL, 1406, 8),
(240882, NULL, 'PTHR33784', NULL, NULL, NULL, NULL, 'OS05G0482100 PROTEIN', NULL, NULL, 27899, 8),
(240883, NULL, 'PTHR47236', NULL, NULL, NULL, NULL, 'GENE, 32742-RELATED-RELATED', NULL, NULL, NULL, 8),
(240884, NULL, 'PTHR32294', NULL, NULL, NULL, NULL, 'DNA POLYMERASE III SUBUNIT ALPHA', NULL, NULL, 4370, 8),
(240885, NULL, 'PTHR42200', NULL, NULL, NULL, NULL, 'ARCHAEAL FLAGELLA-RELATED PROTEIN F-RELATED', NULL, NULL, 4964, 8),
(240886, NULL, 'PTHR22751', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR-RELATED', NULL, NULL, NULL, 8),
(240887, NULL, 'PTHR11937', NULL, NULL, NULL, NULL, 'ACTIN', NULL, NULL, 749, 8),
(240888, NULL, 'PTHR36800', NULL, NULL, NULL, NULL, 'POLYAMINE-MODULATED FACTOR 1-BINDING PROTEIN', NULL, NULL, NULL, 8),
(240889, NULL, 'PTHR10969', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEINS 1A/1B LIGHT CHAIN 3-RELATED', NULL, NULL, 3849, 8),
(240890, NULL, 'PTHR31374', NULL, NULL, NULL, NULL, 'AUXIN-INDUCED PROTEIN-LIKE-RELATED', NULL, NULL, 6134, 8),
(240891, NULL, 'PTHR36172', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(240892, NULL, 'PTHR28160', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN L15, MITOCHONDRIAL', NULL, NULL, 31027, 8),
(240893, NULL, 'PTHR34952', NULL, NULL, NULL, NULL, 'OS05G0113500 PROTEIN', NULL, NULL, NULL, 8),
(240894, NULL, 'PTHR21937', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 25194, 8),
(240895, NULL, 'PTHR46795', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE-RELATED-RELATED', NULL, NULL, NULL, 8),
(240896, NULL, 'PTHR42711', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN', NULL, NULL, NULL, 8),
(240897, NULL, 'PTHR43728', NULL, NULL, NULL, NULL, 'SLR0304 PROTEIN', NULL, NULL, 23017, 8),
(240898, NULL, 'PTHR13055', NULL, NULL, NULL, NULL, 'TUMOR ENDOTHELIAL MARKER 7 RELATED', NULL, NULL, 25458, 8),
(240899, NULL, 'PTHR37464', NULL, NULL, NULL, NULL, 'BLL2463 PROTEIN', NULL, NULL, NULL, 8),
(240900, NULL, 'PTHR46563', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(240901, NULL, 'PTHR46948', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P PROTEIN SUBUNIT P38', NULL, NULL, 36033, 8),
(240902, NULL, 'PTHR11721', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L27A', NULL, NULL, NULL, 8),
(240903, NULL, 'PTHR12250', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL GLYCAN, CLASS N', NULL, NULL, 7224, 8),
(240904, NULL, 'PTHR33128', NULL, NULL, NULL, NULL, 'OS05G0103400 PROTEIN', NULL, NULL, 19362, 8),
(240905, NULL, 'PTHR12599', NULL, NULL, NULL, NULL, 'PTERIN-4-ALPHA-CARBINOLAMINE DEHYDRATASE', NULL, NULL, 5894, 8),
(240906, NULL, 'PTHR37488', NULL, NULL, NULL, NULL, 'DUF1275 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(240907, NULL, 'PTHR37179', NULL, NULL, NULL, NULL, 'TRANSGLYCOSYLASE', NULL, NULL, NULL, 8),
(240908, NULL, 'PTHR16483', NULL, NULL, NULL, NULL, 'GASTROKINE 1', NULL, NULL, NULL, 8),
(240909, NULL, 'PTHR34791', NULL, NULL, NULL, NULL, 'OS02G0272100 PROTEIN', NULL, NULL, NULL, 8),
(240910, NULL, 'PTHR33871', NULL, NULL, NULL, NULL, 'OS05G0503100 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(240911, NULL, 'PTHR36338', NULL, NULL, NULL, NULL, 'OS02G0495900 PROTEIN', NULL, NULL, NULL, 8),
(240912, NULL, 'PTHR42782', NULL, NULL, NULL, NULL, 'SI:CH73-314G15.3', NULL, NULL, NULL, 8),
(240913, NULL, 'PTHR46158', NULL, NULL, NULL, NULL, 'OS02G0165000 PROTEIN', NULL, NULL, NULL, 8),
(240914, NULL, 'PTHR43757', NULL, NULL, NULL, NULL, 'AMINOMETHYLTRANSFERASE', NULL, NULL, 21266, 8),
(240915, NULL, 'PTHR45682', NULL, NULL, NULL, NULL, 'AGAP008228-PA', NULL, NULL, 18607, 8),
(240916, NULL, 'PTHR41247', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REPRESSOR YCNK', NULL, NULL, 12338, 8),
(240917, NULL, 'PTHR35088', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 178', NULL, NULL, 30833, 8),
(240918, NULL, 'PTHR43857', NULL, NULL, NULL, NULL, 'BLR7761 PROTEIN', NULL, NULL, NULL, 8);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(240919, NULL, 'PTHR38133', NULL, NULL, NULL, NULL, 'SLR1429 PROTEIN', NULL, NULL, NULL, 8),
(240920, NULL, 'PTHR13134', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 9007, 8),
(240921, NULL, 'PTHR43528', NULL, NULL, NULL, NULL, 'ALPHA-KETOGLUTARATE PERMEASE', NULL, NULL, NULL, 8),
(240922, NULL, 'PTHR11109', NULL, NULL, NULL, NULL, 'GTP CYCLOHYDROLASE I', NULL, NULL, 3218, 8),
(240923, NULL, 'PTHR28255', NULL, NULL, NULL, NULL, '', NULL, NULL, 8541, 8),
(240924, NULL, 'PTHR37758', NULL, NULL, NULL, NULL, 'OS03G0334300 PROTEIN', NULL, NULL, NULL, 8),
(240925, NULL, 'PTHR47798', NULL, NULL, NULL, NULL, 'OS04G0555800 PROTEIN', NULL, NULL, NULL, 8),
(240926, NULL, 'PTHR11780', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE FLAVOPROTEIN 1  NDUFV1', NULL, NULL, NULL, 8),
(240927, NULL, 'PTHR45955', NULL, NULL, NULL, NULL, 'PHOSPHOACETYLGLUCOSAMINE MUTASE', NULL, NULL, NULL, 8),
(240928, NULL, 'PTHR13738', NULL, NULL, NULL, NULL, 'TROPONIN I', NULL, NULL, NULL, 8),
(240929, NULL, 'PTHR44873', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 30, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(240930, NULL, 'PTHR11766', NULL, NULL, NULL, NULL, 'TYROSYL-TRNA SYNTHETASE', NULL, NULL, 9891, 8),
(240931, NULL, 'PTHR39175', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G15060)-RELATED', NULL, NULL, NULL, 8),
(240932, NULL, 'PTHR36019', NULL, NULL, NULL, NULL, 'PLANT/PROTEIN', NULL, NULL, NULL, 8),
(240933, NULL, 'PTHR36947', NULL, NULL, NULL, NULL, 'PROTEIN CBG04364', NULL, NULL, NULL, 8),
(240934, NULL, 'PTHR47479', NULL, NULL, NULL, NULL, 'OS05G0393200 PROTEIN', NULL, NULL, 36058, 8),
(240935, NULL, 'PTHR31356', NULL, NULL, NULL, NULL, 'THYLAKOID LUMENAL 29 KDA PROTEIN, CHLOROPLASTIC-RELATED', NULL, NULL, 34394, 8),
(240936, NULL, 'PTHR28094', NULL, NULL, NULL, NULL, 'MEIOTICALLY UP-REGULATED GENE 113 PROTEIN', NULL, NULL, NULL, 8),
(240937, NULL, 'PTHR39942', NULL, NULL, NULL, NULL, 'BCDNA.LD26519-RELATED', NULL, NULL, NULL, 8),
(240938, NULL, 'PTHR24148', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 39 HOMOLOG-RELATED', NULL, NULL, NULL, 8),
(240939, NULL, 'PTHR28063', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II NUCLEAR LOCALIZATION PROTEIN IWR1', NULL, NULL, 30457, 8),
(240940, NULL, 'PTHR13126', NULL, NULL, NULL, NULL, 'CHAPERONE ATP11', NULL, NULL, 8122, 8),
(240941, NULL, 'PTHR47896', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN BETA-9', NULL, NULL, 35350, 8),
(240942, NULL, 'PTHR30328', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR', NULL, NULL, NULL, 8),
(240943, NULL, 'PTHR37187', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(240944, NULL, 'PTHR31080', NULL, NULL, NULL, NULL, 'PECTINESTERASE INHIBITOR-LIKE', NULL, NULL, NULL, 8),
(240945, NULL, 'PTHR41152', NULL, NULL, NULL, NULL, 'AT26438P-RELATED', NULL, NULL, NULL, 8),
(240946, NULL, 'PTHR35683', NULL, NULL, NULL, NULL, 'YALI0C04136P', NULL, NULL, NULL, 8),
(240947, NULL, 'PTHR12281', NULL, NULL, NULL, NULL, 'RP42 RELATED', NULL, NULL, 11877, 8),
(240948, NULL, 'PTHR13421', NULL, NULL, NULL, NULL, 'SNRNA-ACTIVATING PROTEIN COMPLEX SUBUNIT 3', NULL, NULL, 20120, 8),
(240949, NULL, 'PTHR35696', NULL, NULL, NULL, NULL, 'ELECTRON CARRIER/IRON ION-BINDING PROTEIN', NULL, NULL, NULL, 8),
(240950, NULL, 'PTHR38815', NULL, NULL, NULL, NULL, 'HYPOTHETICAL MEMBRANE PROTEIN, CONSERVED, DUF373 FAMILY', NULL, NULL, 6992, 8),
(240951, NULL, 'PTHR43051', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDE ADENYLYLTRANSFERASE FAMILY PROTEIN', NULL, NULL, NULL, 8),
(240952, NULL, 'PTHR34614', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(240953, NULL, 'PTHR31294', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(240954, NULL, 'PTHR46991', NULL, NULL, NULL, NULL, '23.5 KDA HEAT SHOCK PROTEIN, MITOCHONDRIAL', NULL, NULL, 35855, 8),
(240955, NULL, 'PTHR33833', NULL, NULL, NULL, NULL, 'NUCLEOLAR-LIKE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(240956, NULL, 'PTHR46014', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 1', NULL, NULL, NULL, 8),
(240957, NULL, 'PTHR47759', NULL, NULL, NULL, NULL, 'OS04G0509100 PROTEIN', NULL, NULL, NULL, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(240958, NULL, 'PTHR46337', NULL, NULL, NULL, NULL, 'RCC1-LIKE G EXCHANGING FACTOR-LIKE PROTEIN', NULL, NULL, NULL, 8),
(240959, NULL, 'PTHR24209', NULL, NULL, NULL, NULL, 'PROTEIN DA1-RELATED 2', NULL, NULL, 36244, 8),
(240960, NULL, 'PTHR12713', NULL, NULL, NULL, NULL, 'VACUOLAR ATP SYNTHASE SUBUNIT G', NULL, NULL, 7438, 8),
(240961, NULL, 'PTHR31306', NULL, NULL, NULL, NULL, 'ALPHA-1,6-MANNOSYLTRANSFERASE MNN11-RELATED', NULL, NULL, 14197, 8),
(240962, NULL, 'PTHR31410', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 246', NULL, NULL, 24035, 8),
(240963, NULL, 'PTHR38015', NULL, NULL, NULL, NULL, 'BLR6086 PROTEIN', NULL, NULL, NULL, 8),
(240964, NULL, 'PTHR31713', NULL, NULL, NULL, NULL, 'OS02G0177800 PROTEIN', NULL, NULL, 13483, 8),
(240965, NULL, 'PTHR37553', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(240966, NULL, 'PTHR11620', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L23A', NULL, NULL, 11244, 8),
(240967, NULL, 'PTHR42930', NULL, NULL, NULL, NULL, 'PHOSPHATE-SPECIFIC TRANSPORT SYSTEM ACCESSORY PROTEIN PHOU', NULL, NULL, 21969, 8),
(240968, NULL, 'PTHR43618', NULL, NULL, NULL, NULL, '7-ALPHA-HYDROXYSTEROID DEHYDROGENASE', NULL, NULL, NULL, 8),
(240969, NULL, 'PTHR37752', NULL, NULL, NULL, NULL, 'OS02G0610700 PROTEIN', NULL, NULL, NULL, 8),
(240970, NULL, 'PTHR35603', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(240971, NULL, 'PTHR34157', NULL, NULL, NULL, NULL, 'TUZIN', NULL, NULL, NULL, 8),
(240972, NULL, 'PTHR21346', NULL, NULL, NULL, NULL, 'FUN14 DOMAIN CONTAINING', NULL, NULL, 6874, 8),
(240973, NULL, 'PTHR10844', NULL, NULL, NULL, NULL, 'CAVEOLIN', NULL, NULL, 5330, 8),
(240974, NULL, 'PTHR19331', NULL, NULL, NULL, NULL, 'SCAVENGER RECEPTOR DOMAIN-CONTAINING', NULL, NULL, NULL, 8),
(240975, NULL, 'PTHR45990', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN REV1', NULL, NULL, NULL, 8),
(240976, NULL, 'PTHR42907', NULL, NULL, NULL, NULL, 'FMN-LINKED OXIDOREDUCTASES SUPERFAMILY PROTEIN', NULL, NULL, 2684, 8),
(240977, NULL, 'PTHR22754', NULL, NULL, NULL, NULL, 'DISCO-INTERACTING PROTEIN 2  DIP2 -RELATED', NULL, NULL, NULL, 8),
(240978, NULL, 'PTHR46280', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY F MEMBER 2-RELATED', NULL, NULL, NULL, 8),
(240979, NULL, 'PTHR11946', NULL, NULL, NULL, NULL, 'VALYL-TRNA SYNTHETASES', NULL, NULL, 4388, 8),
(240980, NULL, 'PTHR34681', NULL, NULL, NULL, NULL, 'UVEAL AUTOANTIGEN WITH COILED-COIL/ANKYRIN', NULL, NULL, NULL, 8),
(240981, NULL, 'PTHR45710', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN-CONTAINING PROTEIN 180', NULL, NULL, NULL, 8),
(240982, NULL, 'PTHR46339', NULL, NULL, NULL, NULL, 'PROTEIN CBG15282-RELATED', NULL, NULL, NULL, 8),
(240983, NULL, 'PTHR43632', NULL, NULL, NULL, NULL, 'PERMEASE COMPONENT OF TUNGSTATE ABC TRANSPORTER', NULL, NULL, NULL, 8),
(240984, NULL, 'PTHR33050', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(240985, NULL, 'PTHR21713', NULL, NULL, NULL, NULL, 'NASCENT POLYPEPTIDE ASSOCIATED COMPLEX ALPHA SUBUNIT-RELATED', NULL, NULL, 19425, 8),
(240986, NULL, 'PTHR42982', NULL, NULL, NULL, NULL, 'SEC-INDEPENDENT PROTEIN TRANSLOCASE PROTEIN TATA', NULL, NULL, NULL, 8),
(240987, NULL, 'PTHR28232', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN RXT2', NULL, NULL, 27192, 8),
(240988, NULL, 'PTHR12952', NULL, NULL, NULL, NULL, 'SYS1', NULL, NULL, 18134, 8),
(240989, NULL, 'PTHR28236', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN L44, MITOCHONDRIAL', NULL, NULL, 36925, 8),
(240990, NULL, 'PTHR48006', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN DDB_G0281931-RELATED', NULL, NULL, NULL, 8),
(240991, NULL, 'PTHR23069', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING', NULL, NULL, 34509, 8),
(240992, NULL, 'PTHR19847', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 11', NULL, NULL, NULL, 8),
(240993, NULL, 'PTHR15590', NULL, NULL, NULL, NULL, 'CX9C MOTIF-CONTAINING PROTEIN 4', NULL, NULL, 21971, 8),
(240994, NULL, 'PTHR37228', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S21 FAMILY PROTEIN', NULL, NULL, NULL, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(240995, NULL, 'PTHR32075', NULL, NULL, NULL, NULL, 'ISWI CHROMATIN-REMODELING COMPLEX SUBUNIT YPL216W-RELATED', NULL, NULL, NULL, 8),
(240996, NULL, 'PTHR47968', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN E', NULL, NULL, NULL, 8),
(240997, NULL, 'PTHR35024', NULL, NULL, NULL, NULL, 'HYPOTHETICAL CYTOSOLIC PROTEIN', NULL, NULL, 2537, 8),
(240998, NULL, 'PTHR34261', NULL, NULL, NULL, NULL, 'APC REGULATOR OF WNT-SIGNALING PATHWAY-RELATED', NULL, NULL, NULL, 8),
(240999, NULL, 'PTHR23512', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(241000, NULL, 'PTHR23235', NULL, NULL, NULL, NULL, 'KRUEPPEL-LIKE TRANSCRIPTION FACTOR', NULL, NULL, NULL, 8),
(241001, NULL, 'PTHR22662', NULL, NULL, NULL, NULL, 'TIRAP', NULL, NULL, 16228, 8),
(241002, NULL, 'PTHR46387', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDYL TRANSFERASE, RIBONUCLEASE H-LIKE SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(241003, NULL, 'PTHR47055', NULL, NULL, NULL, NULL, 'DDE_TNP_1_7 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(241004, NULL, 'PTHR13389', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 27975, 8),
(241005, NULL, 'PTHR24269', NULL, NULL, NULL, NULL, 'KREMEN PROTEIN', NULL, NULL, NULL, 8),
(241006, NULL, 'PTHR47355', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SPL2', NULL, NULL, 34348, 8),
(241007, NULL, 'PTHR38819', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 20A-RELATED', NULL, NULL, 25405, 8),
(241008, NULL, 'PTHR44793', NULL, NULL, NULL, NULL, 'MATRIX REMODELING-ASSOCIATED PROTEIN 8', NULL, NULL, 35683, 8),
(241009, NULL, 'PTHR46604', NULL, NULL, NULL, NULL, 'PROTEIN MID1-COMPLEMENTING ACTIVITY 1', NULL, NULL, NULL, 8),
(241010, NULL, 'PTHR47481', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(241011, NULL, 'PTHR43036', NULL, NULL, NULL, NULL, 'OSJNBB0011N17.9 PROTEIN', NULL, NULL, NULL, 8),
(241012, NULL, 'PTHR46625', NULL, NULL, NULL, NULL, '72 KDA INOSITOL POLYPHOSPHATE 5-PHOSPHATASE', NULL, NULL, 35542, 8),
(241013, NULL, 'PTHR43610', NULL, NULL, NULL, NULL, 'BLL6696 PROTEIN', NULL, NULL, NULL, 8),
(241014, NULL, 'PTHR33428', NULL, NULL, NULL, NULL, 'CHLOROPHYLLASE-2, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(241015, NULL, 'PTHR31195', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 31022, 8),
(241016, NULL, 'PTHR42994', NULL, NULL, NULL, NULL, 'PEPTIDASE T', NULL, NULL, NULL, 8),
(241017, NULL, 'PTHR46802', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE BAZ1B', NULL, NULL, NULL, 8),
(241018, NULL, 'PTHR33069', NULL, NULL, NULL, NULL, 'CHROMOSOME 7, WHOLE GENOME SHOTGUN SEQUENCE-RELATED', NULL, NULL, NULL, 8),
(241019, NULL, 'PTHR18860', NULL, NULL, NULL, NULL, '14-3-3 PROTEIN', NULL, NULL, 801, 8),
(241020, NULL, 'PTHR37185', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(241021, NULL, 'PTHR33843', NULL, NULL, NULL, NULL, 'ASCORBATE-SPECIFIC PTS SYSTEM EIIC COMPONENT', NULL, NULL, NULL, 8),
(241022, NULL, 'PTHR11034', NULL, NULL, NULL, NULL, 'N-MYC DOWNSTREAM REGULATED', NULL, NULL, 2615, 8),
(241023, NULL, 'PTHR37996', NULL, NULL, NULL, NULL, 'B- AND T-LYMPHOCYTE ATTENUATOR', NULL, NULL, 31715, 8),
(241024, NULL, 'PTHR32337', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 7', NULL, NULL, 27245, 8),
(241025, NULL, 'PTHR13561', NULL, NULL, NULL, NULL, 'DNA REPLICATION REGULATOR DPB11-RELATED', NULL, NULL, NULL, 8),
(241026, NULL, 'PTHR37197', NULL, NULL, NULL, NULL, 'F19K23.17 PROTEIN', NULL, NULL, NULL, 8),
(241027, NULL, 'PTHR37259', NULL, NULL, NULL, NULL, 'OS07G0474300 PROTEIN', NULL, NULL, NULL, 8),
(241028, NULL, 'PTHR33946', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(241029, NULL, 'PTHR37246', NULL, NULL, NULL, NULL, 'OS07G0658000 PROTEIN', NULL, NULL, NULL, 8),
(241030, NULL, 'PTHR35610', NULL, NULL, NULL, NULL, '3-ISOPROPYLMALATE DEHYDRATASE-RELATED', NULL, NULL, NULL, 8),
(241031, NULL, 'PTHR31476', NULL, NULL, NULL, NULL, 'PROTEIN WHAT''S THIS FACTOR 1 HOMOLOG, CHLOROPLASTIC', NULL, NULL, 35696, 8),
(241032, NULL, 'PTHR48289', NULL, NULL, NULL, NULL, 'DDE TNP4 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(241033, NULL, 'PTHR24226', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 182 AND ESTROGEN RECEPTOR 1', NULL, NULL, NULL, 8),
(241034, NULL, 'PTHR28564', NULL, NULL, NULL, NULL, 'STANNIN', NULL, NULL, 32479, 8),
(241035, NULL, 'PTHR30602', NULL, NULL, NULL, NULL, 'AMINO-ACID ACETYLTRANSFERASE', NULL, NULL, 10556, 8),
(241036, NULL, 'PTHR37334', NULL, NULL, NULL, NULL, 'RGD1561796', NULL, NULL, 25407, 8),
(241037, NULL, 'PTHR24296', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', NULL, NULL, NULL, 8),
(241038, NULL, 'PTHR38934', NULL, NULL, NULL, NULL, 'HYPHALLY REGULATED CELL WALL PROTEIN 1', NULL, NULL, NULL, 8),
(241039, NULL, 'PTHR46616', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE', NULL, NULL, NULL, 8),
(241040, NULL, 'PTHR37299', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', NULL, NULL, NULL, 8),
(241041, NULL, 'PTHR46183', NULL, NULL, NULL, NULL, 'PROTEIN CLMP1', NULL, NULL, 36839, 8),
(241042, NULL, 'PTHR38165', NULL, NULL, NULL, NULL, '', NULL, NULL, 33452, 8),
(241043, NULL, 'PTHR23289', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY PROTEIN COX15', NULL, NULL, 10833, 8),
(241044, NULL, 'PTHR11831', NULL, NULL, NULL, NULL, '30S 40S RIBOSOMAL PROTEIN', NULL, NULL, 14802, 8),
(241045, NULL, 'PTHR35458', NULL, NULL, NULL, NULL, 'SLR0755 PROTEIN', NULL, NULL, NULL, 8),
(241046, NULL, 'PTHR43490', NULL, NULL, NULL, NULL, '(+)-NEOMENTHOL DEHYDROGENASE', NULL, NULL, NULL, 8),
(241047, NULL, 'PTHR38501', NULL, NULL, NULL, NULL, 'PHOTORECEPTOR DISK COMPONENT PRCD', NULL, NULL, 24827, 8),
(241048, NULL, 'PTHR10965', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L38', NULL, NULL, 2923, 8),
(241049, NULL, 'PTHR11124', NULL, NULL, NULL, NULL, 'VACUOLAR SORTING PROTEIN VPS29', NULL, NULL, 3116, 8),
(241050, NULL, 'PTHR37365', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 44', NULL, NULL, 26486, 8),
(241051, NULL, 'PTHR10722', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L19', NULL, NULL, 33110, 8),
(241052, NULL, 'PTHR16968', NULL, NULL, NULL, NULL, 'LENS EPITHELIAL CELL PROTEIN LEP503', NULL, NULL, 21874, 8),
(241053, NULL, 'PTHR10458', NULL, NULL, NULL, NULL, 'PEPTIDE DEFORMYLASE', NULL, NULL, 6229, 8),
(241054, NULL, 'PTHR23236', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4B/4H', NULL, NULL, NULL, 8),
(241055, NULL, 'PTHR37449', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(241056, NULL, 'PTHR30432', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR MODE', NULL, NULL, NULL, 8),
(241057, NULL, 'PTHR11243', NULL, NULL, NULL, NULL, 'GROWTH FACTOR RECEPTOR-BOUND PROTEIN', NULL, NULL, 27174, 8),
(241058, NULL, 'PTHR15825', NULL, NULL, NULL, NULL, 'UBIQUITIN-FOLD MODIFIER 1', NULL, NULL, 6620, 8),
(241059, NULL, 'PTHR12792', NULL, NULL, NULL, NULL, 'EXTRA SPINDLE POLES 1-RELATED', NULL, NULL, 5108, 8),
(241060, NULL, 'PTHR23004', NULL, NULL, NULL, NULL, 'DOUBLECORTIN DOMAIN CONTAINING 2', NULL, NULL, NULL, 8),
(241061, NULL, 'PTHR33926', NULL, NULL, NULL, NULL, 'PROTEIN TIC 22, CHLOROPLASTIC', NULL, NULL, 5760, 8),
(241062, NULL, 'PTHR43775', NULL, NULL, NULL, NULL, 'FATTY ACID SYNTHASE', NULL, NULL, NULL, 8),
(241063, NULL, 'PTHR11761', NULL, NULL, NULL, NULL, '50S/60S RIBOSOMAL PROTEIN L14/L23', NULL, NULL, 1825, 8),
(241064, NULL, 'PTHR13034', NULL, NULL, NULL, NULL, 'DYNACTIN P62 SUBUNIT', NULL, NULL, 14257, 8),
(241065, NULL, 'PTHR36466', NULL, NULL, NULL, NULL, 'BCL-2-LIKE PROTEIN 15', NULL, NULL, 28411, 8),
(241066, NULL, 'PTHR47796', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE-LIKE PROTEIN', NULL, NULL, NULL, 8),
(241067, NULL, 'PTHR46318', NULL, NULL, NULL, NULL, 'UPSTREAM BINDING TRANSCRIPTION FACTOR', NULL, NULL, NULL, 8),
(241068, NULL, 'PTHR23033', NULL, NULL, NULL, NULL, 'BETA1,3-GALACTOSYLTRANSFERASE', NULL, NULL, NULL, 8),
(241069, NULL, 'PTHR39708', NULL, NULL, NULL, NULL, 'OS07G0483400 PROTEIN', NULL, NULL, NULL, 8),
(241070, NULL, 'PTHR46572', NULL, NULL, NULL, NULL, 'RHO1 GDP-GTP EXCHANGE PROTEIN 1-RELATED', NULL, NULL, NULL, 8),
(241071, NULL, 'PTHR17117', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE', NULL, NULL, 25438, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(241072, NULL, 'PTHR22902', NULL, NULL, NULL, NULL, 'SESQUIPEDALIAN', NULL, NULL, 34810, 8),
(241073, NULL, 'PTHR30032', NULL, NULL, NULL, NULL, 'N-ACETYLMURAMOYL-L-ALANINE AMIDASE-RELATED', NULL, NULL, NULL, 8),
(241074, NULL, 'PTHR15499', NULL, NULL, NULL, NULL, 'HMG BOX-CONTAINING PROTEIN 1', NULL, NULL, 27156, 8),
(241075, NULL, 'PTHR36070', NULL, NULL, NULL, NULL, 'OSJNBA0019G23.7 PROTEIN', NULL, NULL, NULL, 8),
(241076, NULL, 'PTHR44218', NULL, NULL, NULL, NULL, 'PROTEIN SPA1-RELATED 2', NULL, NULL, 36352, 8),
(241077, NULL, 'PTHR47287', NULL, NULL, NULL, NULL, 'C2H2 AND C2HC ZINC FINGERS SUPERFAMILY PROTEIN', NULL, NULL, 34478, 8),
(241078, NULL, 'PTHR43120', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA REDUCTASE 1, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(241079, NULL, 'PTHR46357', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR ATRX', NULL, NULL, NULL, 8),
(241080, NULL, 'PTHR15680', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L19', NULL, NULL, 4104, 8),
(241081, NULL, 'PTHR15917', NULL, NULL, NULL, NULL, '', NULL, NULL, 24931, 8),
(241082, NULL, 'PTHR46661', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ZNRF1-LIKE PROTEIN', NULL, NULL, NULL, 8),
(241083, NULL, 'PTHR32343', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RICH SPLICING FACTOR', NULL, NULL, NULL, 8),
(241084, NULL, 'PTHR47832', NULL, NULL, NULL, NULL, 'DNA PHOTOLYASE', NULL, NULL, NULL, 8),
(241085, NULL, 'PTHR31714', NULL, NULL, NULL, NULL, 'F-BOX ASSOCIATED UBIQUITINATION EFFECTOR FAMILY PROTEIN-RELATED', NULL, NULL, NULL, 8),
(241086, NULL, 'PTHR32217', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 6H', NULL, NULL, NULL, 8),
(241087, NULL, 'PTHR47574', NULL, NULL, NULL, NULL, 'CANCER-RELATED REGULATOR OF ACTIN DYNAMICS', NULL, NULL, NULL, 8),
(241088, NULL, 'PTHR28268', NULL, NULL, NULL, NULL, 'MICOS SUBUNIT MIC26', NULL, NULL, 32999, 8),
(241089, NULL, 'PTHR40621', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR KAPC-RELATED', NULL, NULL, NULL, 8),
(241090, NULL, 'PTHR30006', NULL, NULL, NULL, NULL, 'THIAMINE-BINDING PERIPLASMIC PROTEIN-RELATED', NULL, NULL, NULL, 8),
(241091, NULL, 'PTHR34098', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 47', NULL, NULL, 31544, 8),
(241092, NULL, 'PTHR43616', NULL, NULL, NULL, NULL, 'GLYCEROL DEHYDROGENASE', NULL, NULL, 17489, 8),
(241093, NULL, 'PTHR19346', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 23269, 8),
(241094, NULL, 'PTHR34114', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN PEPTIDE 1', NULL, NULL, 32664, 8),
(241095, NULL, 'PTHR19309', NULL, NULL, NULL, NULL, 'GASTRIN', NULL, NULL, 33393, 8),
(241096, NULL, 'PTHR28580', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR IIH SUBUNIT 5', NULL, NULL, 8320, 8),
(241097, NULL, 'PTHR11441', NULL, NULL, NULL, NULL, 'THYMIDINE KINASE', NULL, NULL, 198, 8),
(241098, NULL, 'PTHR23009', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 24742, 8),
(241099, NULL, 'PTHR24208', NULL, NULL, NULL, NULL, 'LIM/HOMEOBOX PROTEIN LHX', NULL, NULL, NULL, 8),
(241100, NULL, 'PTHR37784', NULL, NULL, NULL, NULL, 'PROTEIN MSN1', NULL, NULL, NULL, 8),
(241101, NULL, 'PTHR36878', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 30', NULL, NULL, 23676, 8),
(241102, NULL, 'PTHR28664', NULL, NULL, NULL, NULL, 'TIGHT JUNCTION-ASSOCIATED PROTEIN 1', NULL, NULL, 35194, 8),
(241103, NULL, 'PTHR48211', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(241104, NULL, 'PTHR35339', NULL, NULL, NULL, NULL, '', NULL, NULL, 19358, 8),
(241105, NULL, 'PTHR12510', NULL, NULL, NULL, NULL, 'TROPONIN C-AKIN-1 PROTEIN', NULL, NULL, 27527, 8),
(241106, NULL, 'PTHR48104', NULL, NULL, NULL, NULL, 'METACASPASE-4', NULL, NULL, NULL, 8),
(241107, NULL, 'PTHR13822', NULL, NULL, NULL, NULL, 'ATP SYNTHASE DELTA/EPSILON CHAIN', NULL, NULL, 6132, 8),
(241108, NULL, 'PTHR33432', NULL, NULL, NULL, NULL, 'PROTEIN EMSY-LIKE 4', NULL, NULL, 32616, 8),
(241109, NULL, 'PTHR40552', NULL, NULL, NULL, NULL, 'AT05186P-RELATED', NULL, NULL, NULL, 8),
(241110, NULL, 'PTHR46993', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR', NULL, NULL, NULL, 8);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(241111, NULL, 'PTHR11904', NULL, NULL, NULL, NULL, 'METHYLTHIOADENOSINE/PURINE NUCLEOSIDE PHOSPHORYLASE', NULL, NULL, 9806, 8),
(241112, NULL, 'PTHR31705', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 30', NULL, NULL, 15460, 8),
(241113, NULL, 'PTHR12872', NULL, NULL, NULL, NULL, 'ALPHA-N-ACETYLGLUCOSAMINIDASE', NULL, NULL, 1398, 8),
(241114, NULL, 'PTHR34493', NULL, NULL, NULL, NULL, 'PROTEIN CBG13422-RELATED', NULL, NULL, NULL, 8),
(241115, NULL, 'PTHR46444', NULL, NULL, NULL, NULL, 'DCD (DEVELOPMENT AND CELL DEATH) DOMAIN PROTEIN-RELATED', NULL, NULL, NULL, 8),
(241116, NULL, 'PTHR46979', NULL, NULL, NULL, NULL, 'SORTING NEXIN-41', NULL, NULL, NULL, 8),
(241117, NULL, 'PTHR43449', NULL, NULL, NULL, NULL, 'NUCLEOTIDYLTRANSFERASE', NULL, NULL, NULL, 8),
(241118, NULL, 'PTHR12983', NULL, NULL, NULL, NULL, 'RING FINGER 10 FAMILY MEMBER', NULL, NULL, 31334, 8),
(241119, NULL, 'PTHR42658', NULL, NULL, NULL, NULL, '', NULL, NULL, 10584, 8),
(241120, NULL, 'PTHR35977', NULL, NULL, NULL, NULL, 'CHROMOSOME 16 OPEN READING FRAME 71', NULL, NULL, 25757, 8),
(241121, NULL, 'PTHR36015', NULL, NULL, NULL, NULL, 'HOLLIDAY JUNCTION RESOLVASE MOC1, CHLOROPLASTIC-RELATED', NULL, NULL, 34300, 8),
(241122, NULL, 'PTHR35895', NULL, NULL, NULL, NULL, 'CHROMOSOME 16, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, 33504, 8),
(241123, NULL, 'PTHR13884', NULL, NULL, NULL, NULL, 'DUF853 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(241124, NULL, 'PTHR47573', NULL, NULL, NULL, NULL, 'PROTEIN AF-9 HOMOLOG', NULL, NULL, NULL, 8),
(241125, NULL, 'PTHR41913', NULL, NULL, NULL, NULL, '', NULL, NULL, 14402, 8),
(241126, NULL, 'PTHR22298', NULL, NULL, NULL, NULL, 'ENDO-1,4-BETA-GLUCANASE', NULL, NULL, NULL, 8),
(241127, NULL, 'PTHR47987', NULL, NULL, NULL, NULL, 'OS08G0249100 PROTEIN', NULL, NULL, NULL, 8),
(241128, NULL, 'PTHR42104', NULL, NULL, NULL, NULL, 'EXTRACELLULAR GUANYL-SPECIFIC RIBONUCLEASE RNTA (AFU_ORTHOLOGUE AFUA_4G03230)', NULL, NULL, NULL, 8),
(241129, NULL, 'PTHR36517', NULL, NULL, NULL, NULL, 'PROTEIN CBG25732', NULL, NULL, NULL, 8),
(241130, NULL, 'PTHR40382', NULL, NULL, NULL, NULL, '', NULL, NULL, 28764, 8),
(241131, NULL, 'PTHR46585', NULL, NULL, NULL, NULL, 'INTEGRASE CORE DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(241132, NULL, 'PTHR13364', NULL, NULL, NULL, NULL, 'DEFECTIVE SPERMATOGENESIS PROTEIN 39', NULL, NULL, 31104, 8),
(241133, NULL, 'PTHR46537', NULL, NULL, NULL, NULL, 'OS11G0578200 PROTEIN', NULL, NULL, 34288, 8),
(241134, NULL, 'PTHR43804', NULL, NULL, NULL, NULL, 'LD18447P', NULL, NULL, NULL, 8),
(241135, NULL, 'PTHR31083', NULL, NULL, NULL, NULL, 'UPSTREAM OF FLC PROTEIN (DUF966)', NULL, NULL, 8896, 8),
(241136, NULL, 'PTHR13071', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 28S RIBOSOMAL PROTEIN S22', NULL, NULL, 15758, 8),
(241137, NULL, 'PTHR10578', NULL, NULL, NULL, NULL, 'S -2-HYDROXY-ACID OXIDASE-RELATED', NULL, NULL, NULL, 8),
(241138, NULL, 'PTHR36712', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(241139, NULL, 'PTHR38105', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN-RELATED-RELATED', NULL, NULL, 14438, 8),
(241140, NULL, 'PTHR31901', NULL, NULL, NULL, NULL, 'GH3 DOMAIN-CONTAINING PROTEIN', NULL, NULL, 637, 8),
(241141, NULL, 'PTHR10957', NULL, NULL, NULL, NULL, 'RAP1 GTPASE-GDP DISSOCIATION STIMULATOR 1', NULL, NULL, 30371, 8),
(241142, NULL, 'PTHR43615', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE SYNTHASE-RELATED', NULL, NULL, NULL, 8),
(241143, NULL, 'PTHR48148', NULL, NULL, NULL, NULL, 'KERATINOCYTE PROLINE-RICH PROTEIN', NULL, NULL, NULL, 8),
(241144, NULL, 'PTHR12932', NULL, NULL, NULL, NULL, 'P25 ALPHA-RELATED', NULL, NULL, 7504, 8),
(241145, NULL, 'PTHR10982', NULL, NULL, NULL, NULL, 'MALONYL COA-ACYL CARRIER PROTEIN TRANSACYLASE', NULL, NULL, NULL, 8),
(241146, NULL, 'PTHR10566', NULL, NULL, NULL, NULL, 'CHAPERONE-ACTIVITY OF BC1 COMPLEX  CABC1 -RELATED', NULL, NULL, NULL, 8),
(241147, NULL, 'PTHR44598', NULL, NULL, NULL, NULL, 'JUNCTIONAL ADHESION MOLECULE C', NULL, NULL, 35284, 8),
(241148, NULL, 'PTHR40903', NULL, NULL, NULL, NULL, 'GLYCINE-RICH CELL WALL STRUCTURAL PROTEIN 1-LIKE', NULL, NULL, NULL, 8);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(241149, NULL, 'PTHR14652', NULL, NULL, NULL, NULL, 'TYPE 2 DNA TOPOISOMERASE 6 SUBUNIT B-LIKE', NULL, NULL, 23549, 8),
(241150, NULL, 'PTHR47917', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(241151, NULL, 'PTHR46034', NULL, NULL, NULL, NULL, '', NULL, NULL, 36359, 8),
(241152, NULL, 'PTHR31968', NULL, NULL, NULL, NULL, 'SERINE/ARGININE-RELATED PROTEIN 53', NULL, NULL, 10564, 8),
(241153, NULL, 'PTHR11842', NULL, NULL, NULL, NULL, 'MITOTIC SPINDLE ASSEMBLY CHECKPOINT PROTEIN MAD2', NULL, NULL, 36636, 8),
(241154, NULL, 'PTHR35497', NULL, NULL, NULL, NULL, 'ACYL-UDP-N-ACETYLGLUCOSAMINE O-ACYLTRANSFERASE', NULL, NULL, NULL, 8),
(241155, NULL, 'PTHR44329', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE TNNI3K-RELATED', NULL, NULL, NULL, 8),
(241156, NULL, 'PTHR11604', NULL, NULL, NULL, NULL, 'PROFILIN', NULL, NULL, 952, 8),
(241157, NULL, 'PTHR46470', NULL, NULL, NULL, NULL, 'N-ACYLNEURAMINATE-9-PHOSPHATASE', NULL, NULL, NULL, 8),
(241158, NULL, 'PTHR47608', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR KAZAL-TYPE 2, SPINK2', NULL, NULL, 37177, 8),
(241159, NULL, 'PTHR10259', NULL, NULL, NULL, NULL, 'THIOPURINE S-METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(241160, NULL, 'PTHR21517', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 31317, 8),
(241161, NULL, 'PTHR31966', NULL, NULL, NULL, NULL, 'OS01G0783500 PROTEIN', NULL, NULL, 36032, 8),
(241162, NULL, 'PTHR46692', NULL, NULL, NULL, NULL, 'INOSINE-URIDINE PREFERRING NUCLEOSIDE HYDROLASE FAMILY PROTEIN', NULL, NULL, NULL, 8),
(241163, NULL, 'PTHR10841', NULL, NULL, NULL, NULL, 'SYNAPSIN', NULL, NULL, NULL, 8),
(241164, NULL, 'PTHR23331', NULL, NULL, NULL, NULL, 'CXYORF1', NULL, NULL, 22879, 8),
(241165, NULL, 'PTHR30128', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN, OMPA-RELATED', NULL, NULL, NULL, 8),
(241166, NULL, 'PTHR36030', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(241167, NULL, 'PTHR42691', NULL, NULL, NULL, NULL, 'ASPARTATE AMINOTRANSFERASE YHDR-RELATED', NULL, NULL, NULL, 8),
(241168, NULL, 'PTHR13504', NULL, NULL, NULL, NULL, 'FIDO DOMAIN-CONTAINING PROTEIN DDB_G0283145', NULL, NULL, 28457, 8),
(241169, NULL, 'PTHR43308', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN ALPHA-RELATED', NULL, NULL, NULL, 8),
(241170, NULL, 'PTHR12498', NULL, NULL, NULL, NULL, 'N-TERMINAL ASPARAGINE AMIDOHYDROLASE', NULL, NULL, 24262, 8),
(241171, NULL, 'PTHR38117', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(241172, NULL, 'PTHR36805', NULL, NULL, NULL, NULL, 'AGENET DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(241173, NULL, 'PTHR11655', NULL, NULL, NULL, NULL, '60S/50S RIBOSOMAL PROTEIN L6/L9', NULL, NULL, 6759, 8),
(241174, NULL, 'PTHR43334', NULL, NULL, NULL, NULL, 'ACETATE--COA LIGASE [ADP-FORMING]', NULL, NULL, NULL, 8),
(241175, NULL, 'PTHR47743', NULL, NULL, NULL, NULL, 'KIAA1210 / KIAA1211 FAMILY MEMBER', NULL, NULL, 21982, 8),
(241176, NULL, 'PTHR13377', NULL, NULL, NULL, NULL, 'PLACENTAL PROTEIN 6', NULL, NULL, 9552, 8),
(241177, NULL, 'PTHR33573', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 4A4', NULL, NULL, NULL, 8),
(241178, NULL, 'PTHR12506', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE RELATED', NULL, NULL, NULL, 8),
(241179, NULL, 'PTHR36770', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I ASSEMBLY FACTOR PSA3, CHLOROPLASTIC', NULL, NULL, 27490, 8),
(241180, NULL, 'PTHR37477', NULL, NULL, NULL, NULL, 'COBALT-PRECORRIN-5A HYDROLASE', NULL, NULL, NULL, 8),
(241181, NULL, 'PTHR33724', NULL, NULL, NULL, NULL, 'INTRAFLAGELLAR TRANSPORT PROTEIN 43 HOMOLOG', NULL, NULL, 24932, 8),
(241182, NULL, 'PTHR31313', NULL, NULL, NULL, NULL, 'TY1 ENHANCER ACTIVATOR', NULL, NULL, NULL, 8),
(241183, NULL, 'PTHR33509', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENIS ABUNDANT PROTEIN 2-RELATED', NULL, NULL, 1647, 8),
(241184, NULL, 'PTHR44819', NULL, NULL, NULL, NULL, 'V-TYPE IMMUNOGLOBULIN DOMAIN-CONTAINING SUPPRESSOR OF T-CELL ACTIVATION', NULL, NULL, 34907, 8),
(241185, NULL, 'PTHR46932', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 47', NULL, NULL, 35942, 8),
(241186, NULL, 'PTHR40289', NULL, NULL, NULL, NULL, 'PROTEIN CBG04714', NULL, NULL, 35382, 8);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(241187, NULL, 'PTHR45500', NULL, NULL, NULL, NULL, 'OS02G0202600 PROTEIN', NULL, NULL, NULL, 8),
(241188, NULL, 'PTHR47401', NULL, NULL, NULL, NULL, 'INTERLEUKIN-4', NULL, NULL, 6343, 8),
(241189, NULL, 'PTHR14239', NULL, NULL, NULL, NULL, 'DUDULIN-RELATED', NULL, NULL, NULL, 8),
(241190, NULL, 'PTHR33132', NULL, NULL, NULL, NULL, 'OSJNBB0118P14.9 PROTEIN', NULL, NULL, NULL, 8),
(241191, NULL, 'PTHR11683', NULL, NULL, NULL, NULL, 'MYELIN PROTEOLIPID', NULL, NULL, 5237, 8),
(241192, NULL, 'PTHR46048', NULL, NULL, NULL, NULL, 'HYDROXYCARBOXYLIC ACID RECEPTOR 2', NULL, NULL, NULL, 8),
(241193, NULL, 'PTHR45007', NULL, NULL, NULL, NULL, 'CARBOXYLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G07570)-RELATED', NULL, NULL, NULL, 8),
(241194, NULL, 'PTHR22879', NULL, NULL, NULL, NULL, 'NUT FAMILY MEMBER 1', NULL, NULL, 24958, 8),
(241195, NULL, 'PTHR30034', NULL, NULL, NULL, NULL, 'FLAGELLAR MOTOR SWITCH PROTEIN FLIM', NULL, NULL, NULL, 8),
(241196, NULL, 'PTHR47516', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS U-RELATED', NULL, NULL, NULL, 8),
(241197, NULL, 'PTHR24230', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR', NULL, NULL, NULL, 8),
(241198, NULL, 'PTHR46630', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 29', NULL, NULL, NULL, 8),
(241199, NULL, 'PTHR12300', NULL, NULL, NULL, NULL, 'HVA22-LIKE PROTEINS', NULL, NULL, 5147, 8),
(241200, NULL, 'PTHR37216', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(241201, NULL, 'PTHR12375', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN LUC7-RELATED', NULL, NULL, 7312, 8),
(241202, NULL, 'PTHR14920', NULL, NULL, NULL, NULL, 'OSMOTIC AVOIDANCE ABNORMAL PROTEIN 1/WD REPEAT MEMBRANE PROTEIN', NULL, NULL, 29030, 8),
(241203, NULL, 'PTHR13989', NULL, NULL, NULL, NULL, 'REPLICATION PROTEIN A-RELATED', NULL, NULL, 32660, 8),
(241204, NULL, 'PTHR30629', NULL, NULL, NULL, NULL, 'PROPHAGE INTEGRASE', NULL, NULL, NULL, 8),
(241205, NULL, 'PTHR32268', NULL, NULL, NULL, NULL, 'HOMOSERINE O-ACETYLTRANSFERASE', NULL, NULL, 886, 8),
(241206, NULL, 'PTHR42849', NULL, NULL, NULL, NULL, 'N-ACETYLNEURAMINATE LYASE', NULL, NULL, NULL, 8),
(241207, NULL, 'PTHR37224', NULL, NULL, NULL, NULL, 'OS02G0804400 PROTEIN', NULL, NULL, NULL, 8),
(241208, NULL, 'PTHR43215', NULL, NULL, NULL, NULL, 'RADIAL SPOKE HEAD 1 HOMOLOG', NULL, NULL, NULL, 8),
(241209, NULL, 'PTHR15668', NULL, NULL, NULL, NULL, 'JM1 PROTEIN', NULL, NULL, 13316, 8),
(241210, NULL, 'PTHR43562', NULL, NULL, NULL, NULL, 'NAPA-TYPE SODIUM/HYDROGEN ANTIPORTER', NULL, NULL, NULL, 8),
(241211, NULL, 'PTHR43032', NULL, NULL, NULL, NULL, 'PROTEIN-METHIONINE-SULFOXIDE REDUCTASE', NULL, NULL, NULL, 8),
(241212, NULL, 'PTHR46440', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-D12-RELATED', NULL, NULL, NULL, 8),
(241213, NULL, 'PTHR43451', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE (GNAT) FAMILY PROTEIN', NULL, NULL, NULL, 8),
(241214, NULL, 'PTHR43855', NULL, NULL, NULL, NULL, 'THIOSULFATE SULFURTRANSFERASE', NULL, NULL, NULL, 8),
(241215, NULL, 'PTHR14526', NULL, NULL, NULL, NULL, 'AURORA KINASE A AND NINEIN-INTERACTING PROTEIN', NULL, NULL, 26497, 8),
(241216, NULL, 'PTHR12998', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 28556, 8),
(241217, NULL, 'PTHR37809', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S12 METHYLTHIOTRANSFERASE ACCESSORY FACTOR YCAO', NULL, NULL, NULL, 8),
(241218, NULL, 'PTHR33704', NULL, NULL, NULL, NULL, 'PROTEIN HEAT INTOLERANT 4-RELATED', NULL, NULL, 27232, 8),
(241219, NULL, 'PTHR41749', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(241220, NULL, 'PTHR16517', NULL, NULL, NULL, NULL, 'TUBBY-RELATED', NULL, NULL, NULL, 8),
(241221, NULL, 'PTHR22842', NULL, NULL, NULL, NULL, 'WD40 REPEAT PROTEIN', NULL, NULL, NULL, 8),
(241222, NULL, 'PTHR14557', NULL, NULL, NULL, NULL, 'PROTEIN C7ORF21', NULL, NULL, 27900, 8),
(241223, NULL, 'PTHR20849', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 30673, 8),
(241224, NULL, 'PTHR33127', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(241225, NULL, 'PTHR14464', NULL, NULL, NULL, NULL, 'EXONUCLEASE V', NULL, NULL, 18167, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(241226, NULL, 'PTHR11241', NULL, NULL, NULL, NULL, 'DEOXYURIDINE 5''-TRIPHOSPHATE NUCLEOTIDOHYDROLASE', NULL, NULL, 7207, 8),
(241227, NULL, 'PTHR35092', NULL, NULL, NULL, NULL, 'CHLORINASE MJ1651', NULL, NULL, 3576, 8),
(241228, NULL, 'PTHR44590', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE-RELATED', NULL, NULL, NULL, 8),
(241229, NULL, 'PTHR12725', NULL, NULL, NULL, NULL, 'HALOACID DEHALOGENASE-LIKE HYDROLASE', NULL, NULL, NULL, 8),
(241230, NULL, 'PTHR38781', NULL, NULL, NULL, NULL, 'ANTITOXIN DINJ-RELATED', NULL, NULL, 5328, 8),
(241231, NULL, 'PTHR20861', NULL, NULL, NULL, NULL, 'HOMOSERINE/4-DIPHOSPHOCYTIDYL-2-C-METHYL-D-ERYTHRITOL KINASE', NULL, NULL, NULL, 8),
(241232, NULL, 'PTHR10122', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 5B, MITOCHONDRIAL', NULL, NULL, 5450, 8),
(241233, NULL, 'PTHR34933', NULL, NULL, NULL, NULL, 'FLAGELLAR L-RING PROTEIN', NULL, NULL, 5637, 8),
(241234, NULL, 'PTHR37534', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR PROTEIN UGA3', NULL, NULL, NULL, 8),
(241235, NULL, 'PTHR15907', NULL, NULL, NULL, NULL, 'DUF614 FAMILY PROTEIN-RELATED', NULL, NULL, 6654, 8),
(241236, NULL, 'PTHR46815', NULL, NULL, NULL, NULL, 'PROTEIN KISH-B', NULL, NULL, 34419, 8),
(241237, NULL, 'PTHR12642', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS PROTEIN NSA2 HOMOLOG', NULL, NULL, 27526, 8),
(241238, NULL, 'PTHR33779', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(241239, NULL, 'PTHR31214', NULL, NULL, NULL, NULL, 'PROTEIN FAM221A-RELATED', NULL, NULL, 24395, 8),
(241240, NULL, 'PTHR31657', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF061', NULL, NULL, NULL, 8),
(241241, NULL, 'PTHR47372', NULL, NULL, NULL, NULL, 'DAUER UP-REGULATED-RELATED', NULL, NULL, NULL, 8),
(241242, NULL, 'PTHR10974', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 3986, 8),
(241243, NULL, 'PTHR31846', NULL, NULL, NULL, NULL, 'CRS1 / YHBY (CRM) DOMAIN-CONTAINING PROTEIN', NULL, NULL, 35908, 8),
(241244, NULL, 'PTHR36427', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN L1, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(241245, NULL, 'PTHR12921', NULL, NULL, NULL, NULL, 'UBIQUITIN-FOLD MODIFIER-CONJUGATING ENZYME 1', NULL, NULL, 11952, 8),
(241246, NULL, 'PTHR46540', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 12', NULL, NULL, 34590, 8),
(241247, NULL, 'PTHR39400', NULL, NULL, NULL, NULL, 'YALI0E29227P', NULL, NULL, NULL, 8),
(241248, NULL, 'PTHR36034', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(241249, NULL, 'PTHR35561', NULL, NULL, NULL, NULL, 'RNA 2'',3''-CYCLIC PHOSPHODIESTERASE', NULL, NULL, 2689, 8),
(241250, NULL, 'PTHR31061', NULL, NULL, NULL, NULL, 'LD22376P', NULL, NULL, NULL, 8),
(241251, NULL, 'PTHR43391', NULL, NULL, NULL, NULL, 'RETINOL DEHYDROGENASE-RELATED', NULL, NULL, NULL, 8),
(241252, NULL, 'PTHR43771', NULL, NULL, NULL, NULL, 'PHOSPHOMANNOMUTASE', NULL, NULL, NULL, 8),
(241253, NULL, 'PTHR10315', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN PROTEIN LIGASE SIAH', NULL, NULL, NULL, 8),
(241254, NULL, 'PTHR34126', NULL, NULL, NULL, NULL, 'PEROXISOME BIOGENESIS PROTEIN 22', NULL, NULL, 27982, 8),
(241255, NULL, 'PTHR47382', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 52-LIKE', NULL, NULL, NULL, 8),
(241256, NULL, 'PTHR23402', NULL, NULL, NULL, NULL, 'PROTEASE FAMILY C15 PYROGLUTAMYL-PEPTIDASE I-RELATED', NULL, NULL, 11413, 8),
(241257, NULL, 'PTHR15570', NULL, NULL, NULL, NULL, 'G0/G1 SWITCH PROTEIN 2', NULL, NULL, 15032, 8),
(241258, NULL, 'PTHR35289', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(241259, NULL, 'PTHR47919', NULL, NULL, NULL, NULL, 'INFECTION RESPONSE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(241260, NULL, 'PTHR34474', NULL, NULL, NULL, NULL, 'SIGNAL TRANSDUCTION PROTEIN TRAP', NULL, NULL, NULL, 8),
(241261, NULL, 'PTHR18964', NULL, NULL, NULL, NULL, 'ROK (REPRESSOR, ORF, KINASE) FAMILY', NULL, NULL, 5948, 8),
(241262, NULL, 'PTHR43163', NULL, NULL, NULL, NULL, 'DIPEPTIDE TRANSPORT SYSTEM PERMEASE PROTEIN DPPB-RELATED', NULL, NULL, NULL, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(241263, NULL, 'PTHR35396', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(241264, NULL, 'PTHR10696', NULL, NULL, NULL, NULL, 'GAMMA-BUTYROBETAINE HYDROXYLASE-RELATED', NULL, NULL, NULL, 8),
(241265, NULL, 'PTHR37764', NULL, NULL, NULL, NULL, 'KETOSE/ALDOSE ISOMERASE, PUTATIVE (MOG1/PSBP/DUF1795-LIKE PHOTOSYSTEM II REACTION CENTER PSBP FAMILY PROTEIN)-RELATED', NULL, NULL, NULL, 8),
(241266, NULL, 'PTHR10060', NULL, NULL, NULL, NULL, 'TATD FAMILY DEOXYRIBONUCLEASE', NULL, NULL, NULL, 8),
(241267, NULL, 'PTHR31696', NULL, NULL, NULL, NULL, 'PROTEIN MIZU-KUSSEI 1', NULL, NULL, 6990, 8),
(241268, NULL, 'PTHR22704', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 27255, 8),
(241269, NULL, 'PTHR45508', NULL, NULL, NULL, NULL, 'RHODANESE-LIKE DOMAIN-CONTAINING PROTEIN 9, CHLOROPLASTIC', NULL, NULL, 36158, 8),
(241270, NULL, 'PTHR43603', NULL, NULL, NULL, NULL, 'COBW DOMAIN-CONTAINING PROTEIN DDB_G0274527', NULL, NULL, NULL, 8),
(241271, NULL, 'PTHR12610', NULL, NULL, NULL, NULL, 'SINGLE STRANDED DNA BINDING PROTEIN', NULL, NULL, NULL, 8),
(241272, NULL, 'PTHR37266', NULL, NULL, NULL, NULL, 'CYTOCHROME B6-F COMPLEX SUBUNIT 6', NULL, NULL, 2476, 8),
(241273, NULL, 'PTHR45759', NULL, NULL, NULL, NULL, 'NUCLEOLAR GTP-BINDING PROTEIN 1', NULL, NULL, NULL, 8),
(241274, NULL, 'PTHR42778', NULL, NULL, NULL, NULL, '2-AMINOETHYLPHOSPHONATE--PYRUVATE TRANSAMINASE', NULL, NULL, NULL, 8),
(241275, NULL, 'PTHR21522', NULL, NULL, NULL, NULL, 'PROTON CHANNEL OTOP', NULL, NULL, 7020, 8),
(241276, NULL, 'PTHR47124', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SKIP8', NULL, NULL, 34708, 8),
(241277, NULL, 'PTHR17534', NULL, NULL, NULL, NULL, 'OX40 LIGAND', NULL, NULL, 36146, 8),
(241278, NULL, 'PTHR21669', NULL, NULL, NULL, NULL, 'CAPZ-INTERACTING PROTEIN AND RELATED PROTEINS', NULL, NULL, NULL, 8),
(241279, NULL, 'PTHR38500', NULL, NULL, NULL, NULL, 'SURFACTANT-ASSOCIATED PROTEIN 2', NULL, NULL, 22374, 8),
(241280, NULL, 'PTHR30157', NULL, NULL, NULL, NULL, 'FERRIC REDUCTASE, NADPH-DEPENDENT', NULL, NULL, 33268, 8),
(241281, NULL, 'PTHR43641', NULL, NULL, NULL, NULL, 'FORMATE ACETYLTRANSFERASE 3-RELATED', NULL, NULL, NULL, 8),
(241282, NULL, 'PTHR20884', NULL, NULL, NULL, NULL, 'GDP-D-GLUCOSE PHOSPHORYLASE 1', NULL, NULL, 23045, 8),
(241283, NULL, 'PTHR22870', NULL, NULL, NULL, NULL, 'REGULATOR OF CHROMOSOME CONDENSATION', NULL, NULL, NULL, 8),
(241284, NULL, 'PTHR22926', NULL, NULL, NULL, NULL, 'PHOSPHO-N-ACETYLMURAMOYL-PENTAPEPTIDE-TRANSFERASE', NULL, NULL, 3918, 8),
(241285, NULL, 'PTHR43537', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, GNTR FAMILY', NULL, NULL, NULL, 8),
(241286, NULL, 'PTHR15627', NULL, NULL, NULL, NULL, 'NATURAL KILLER CELL-SPECIFIC ANTIGEN KLIP1', NULL, NULL, NULL, 8),
(241287, NULL, 'PTHR38420', NULL, NULL, NULL, NULL, 'AP-4-A PHOSPHORYLASE II', NULL, NULL, 9502, 8),
(241288, NULL, 'PTHR10815', NULL, NULL, NULL, NULL, 'METHYLATED-DNA--PROTEIN-CYSTEINE METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(241289, NULL, 'PTHR21394', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 17380, 8),
(241290, NULL, 'PTHR43583', NULL, NULL, NULL, NULL, '2-IMINOACETATE SYNTHASE', NULL, NULL, 6065, 8),
(241291, NULL, 'PTHR13286', NULL, NULL, NULL, NULL, 'SAP30', NULL, NULL, 12542, 8),
(241292, NULL, 'PTHR36220', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', NULL, NULL, NULL, 8),
(241293, NULL, 'PTHR23232', NULL, NULL, NULL, NULL, 'KRAB DOMAIN C2H2 ZINC FINGER', NULL, NULL, NULL, 8),
(241294, NULL, 'PTHR31744', NULL, NULL, NULL, NULL, 'PROTEIN CUP-SHAPED COTYLEDON 2-RELATED', NULL, NULL, NULL, 8),
(241295, NULL, 'PTHR34698', NULL, NULL, NULL, NULL, '5-OXOPROLINASE SUBUNIT B', NULL, NULL, 5206, 8),
(241296, NULL, 'PTHR46215', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN 24-RELATED', NULL, NULL, 3613, 8),
(241297, NULL, 'PTHR34693', NULL, NULL, NULL, NULL, 'PROTEIN PAR32', NULL, NULL, NULL, 8),
(241298, NULL, 'PTHR10050', NULL, NULL, NULL, NULL, 'DOLICHYL-PHOSPHATE-MANNOSE--PROTEIN MANNOSYLTRANSFERASE', NULL, NULL, 26052, 8),
(241299, NULL, 'PTHR40572', NULL, NULL, NULL, NULL, 'PROTEIN BAX', NULL, NULL, NULL, 8);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(241300, NULL, 'PTHR13713', NULL, NULL, NULL, NULL, 'SIALYLTRANSFERASE', NULL, NULL, NULL, 8),
(241301, NULL, 'PTHR34081', NULL, NULL, NULL, NULL, 'MALECTIN DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(241302, NULL, 'PTHR45737', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR A DOMAIN-CONTAINING PROTEIN 5A', NULL, NULL, NULL, 8),
(241303, NULL, 'PTHR43544', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/REDUCTASE', NULL, NULL, NULL, 8),
(241304, NULL, 'PTHR30555', NULL, NULL, NULL, NULL, 'HYDROPEROXIDASE I, BIFUNCTIONAL CATALASE-PEROXIDASE', NULL, NULL, 6933, 8),
(241305, NULL, 'PTHR13137', NULL, NULL, NULL, NULL, 'DC11  ACN9 HOMOLOG', NULL, NULL, 7510, 8),
(241306, NULL, 'PTHR42281', NULL, NULL, NULL, NULL, '', NULL, NULL, 7307, 8),
(241307, NULL, 'PTHR32083', NULL, NULL, NULL, NULL, 'CILIA AND FLAGELLA-ASSOCIATED PROTEIN 58-RELATED', NULL, NULL, NULL, 8),
(241308, NULL, 'PTHR47661', NULL, NULL, NULL, NULL, 'PHOSPHOGLUCAN PHOSPHATASE LSF1, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(241309, NULL, 'PTHR19368', NULL, NULL, NULL, NULL, 'XLR/SCP3/FAM9', NULL, NULL, NULL, 8),
(241310, NULL, 'PTHR37828', NULL, NULL, NULL, NULL, 'GSR2449 PROTEIN', NULL, NULL, NULL, 8),
(241311, NULL, 'PTHR35563', NULL, NULL, NULL, NULL, 'BARREL METAL-DEPENDENT HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G16240)-RELATED', NULL, NULL, NULL, 8),
(241312, NULL, 'PTHR42899', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 20', NULL, NULL, 5833, 8),
(241313, NULL, 'PTHR48189', NULL, NULL, NULL, NULL, 'BNAA10G07240D PROTEIN', NULL, NULL, NULL, 8),
(241314, NULL, 'PTHR47555', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINYL TRANSFERASE COMPONENT FAMILY PROTEIN / GPI1 FAMILY PROTEIN', NULL, NULL, NULL, 8),
(241315, NULL, 'PTHR11164', NULL, NULL, NULL, NULL, 'GLUTAMATE CYSTEINE LIGASE', NULL, NULL, 4856, 8),
(241316, NULL, 'PTHR24377', NULL, NULL, NULL, NULL, 'IP01015P-RELATED', NULL, NULL, NULL, 8),
(241317, NULL, 'PTHR43230', NULL, NULL, NULL, NULL, 'ABC-TYPE DIPEPTIDE/OLIGOPEPTIDE TRANSPORT SYSTEM, ATPASE COMPONENT', NULL, NULL, NULL, 8),
(241318, NULL, 'PTHR35312', NULL, NULL, NULL, NULL, 'OS07G0641800 PROTEIN', NULL, NULL, NULL, 8),
(241319, NULL, 'PTHR46411', NULL, NULL, NULL, NULL, 'FAMILY ATPASE, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(241320, NULL, 'PTHR37911', NULL, NULL, NULL, NULL, 'OSJNBA0067K08.20 PROTEIN', NULL, NULL, NULL, 8),
(241321, NULL, 'PTHR46823', NULL, NULL, NULL, NULL, 'CALCINEURIN B HOMOLOGOUS PROTEIN 3', NULL, NULL, NULL, 8),
(241322, NULL, 'PTHR36494', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(241323, NULL, 'PTHR12848', NULL, NULL, NULL, NULL, 'REGULATORY-ASSOCIATED PROTEIN OF MTOR', NULL, NULL, 1843, 8),
(241324, NULL, 'PTHR13202', NULL, NULL, NULL, NULL, 'MICROSOMAL SIGNAL PEPTIDASE 12 KDA SUBUNIT', NULL, NULL, 10299, 8),
(241325, NULL, 'PTHR12200', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCIBLE PROTEIN AIM2 FAMILY MEMBER', NULL, NULL, 27026, 8),
(241326, NULL, 'PTHR42690', NULL, NULL, NULL, NULL, 'THREONINE SYNTHASE FAMILY MEMBER', NULL, NULL, NULL, 8),
(241327, NULL, 'PTHR13878', NULL, NULL, NULL, NULL, 'GULONOLACTONE OXIDASE', NULL, NULL, NULL, 8),
(241328, NULL, 'PTHR12262', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(241329, NULL, 'PTHR12388', NULL, NULL, NULL, NULL, 'MITOCHONDRIA ASSOCIATED GRANULOCYTE MACROPHAGE CSF SIGNALING MOLECULE', NULL, NULL, 6048, 8),
(241330, NULL, 'PTHR22255', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(241331, NULL, 'PTHR35323', NULL, NULL, NULL, NULL, 'SAP DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(241332, NULL, 'PTHR43491', NULL, NULL, NULL, NULL, 'UDP-N-ACETYL-D-MANNOSAMINE DEHYDROGENASE', NULL, NULL, NULL, 8),
(241333, NULL, 'PTHR12292', NULL, NULL, NULL, NULL, 'RWD DOMAIN-CONTAINING PROTEIN', NULL, NULL, 27944, 8),
(241334, NULL, 'PTHR47814', NULL, NULL, NULL, NULL, 'PEPTIDYL-TRNA HYDROLASE ARFB', NULL, NULL, NULL, 8),
(241335, NULL, 'PTHR14938', NULL, NULL, NULL, NULL, 'HCLS1-ASSOCIATED PROTEIN X-1', NULL, NULL, 15920, 8),
(241336, NULL, 'PTHR15360', NULL, NULL, NULL, NULL, 'PLATELET-DERIVED GROWTH FACTOR RECEPTOR LIKE', NULL, NULL, NULL, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(241337, NULL, 'PTHR37695', NULL, NULL, NULL, NULL, 'RECOMBINATION INITIATION DEFECTS 3-RELATED', NULL, NULL, 17893, 8),
(241338, NULL, 'PTHR36984', NULL, NULL, NULL, NULL, 'CRISPR-ASSOCIATED ENDORIBONUCLEASE CAS6 1', NULL, NULL, 10582, 8),
(241339, NULL, 'PTHR31722', NULL, NULL, NULL, NULL, 'OS06G0675200 PROTEIN', NULL, NULL, NULL, 8),
(241340, NULL, 'PTHR37804', NULL, NULL, NULL, NULL, 'CDAA REGULATORY PROTEIN CDAR', NULL, NULL, NULL, 8),
(241341, NULL, 'PTHR31612', NULL, NULL, NULL, NULL, 'MULTIVESICULAR BODY SUBUNIT 12A', NULL, NULL, 27380, 8),
(241342, NULL, 'PTHR19306', NULL, NULL, NULL, NULL, 'STRUCTURAL MAINTENANCE OF CHROMOSOMES 5,6  SMC5, SMC6', NULL, NULL, NULL, 8),
(241343, NULL, 'PTHR28467', NULL, NULL, NULL, NULL, 'PAXIP1-ASSOCIATED GLUTAMATE-RICH PROTEIN 1', NULL, NULL, 22248, 8),
(241344, NULL, 'PTHR34826', NULL, NULL, NULL, NULL, 'UPF0590 PROTEIN C409.17C', NULL, NULL, NULL, 8),
(241345, NULL, 'PTHR22935', NULL, NULL, NULL, NULL, 'PENICILLIN-BINDING PROTEIN', NULL, NULL, NULL, 8),
(241346, NULL, 'PTHR33066', NULL, NULL, NULL, NULL, 'INTEGRASE_SAM-LIKE_N DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(241347, NULL, 'PTHR46496', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(241348, NULL, 'PTHR33204', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, MARR FAMILY', NULL, NULL, NULL, 8),
(241349, NULL, 'PTHR11564', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE 54K PROTEIN SRP54', NULL, NULL, 14844, 8),
(241350, NULL, 'PTHR45871', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINYL-PHOSPHATIDYLINOSITOL BIOSYNTHETIC PROTEIN', NULL, NULL, NULL, 8),
(241351, NULL, 'PTHR28525', NULL, NULL, NULL, NULL, 'REACTIVE OXYGEN SPECIES MODULATOR 1', NULL, NULL, 9290, 8),
(241352, NULL, 'PTHR36291', NULL, NULL, NULL, NULL, 'UBAP1-MVB12-ASSOCIATED (UMA)-DOMAIN CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(241353, NULL, 'PTHR10225', NULL, NULL, NULL, NULL, 'HYALURONAN  RECEPTOR', NULL, NULL, 36377, 8),
(241354, NULL, 'PTHR47022', NULL, NULL, NULL, NULL, 'BTB AND MATH DOMAIN-CONTAINING PROTEIN 36-RELATED', NULL, NULL, NULL, 8),
(241355, NULL, 'PTHR43027', NULL, NULL, NULL, NULL, 'DOXORUBICIN RESISTANCE ABC TRANSPORTER PERMEASE PROTEIN DRRC-RELATED', NULL, NULL, NULL, 8),
(241356, NULL, 'PTHR22878', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(241357, NULL, 'PTHR10113', NULL, NULL, NULL, NULL, 'PEPTIDE CHAIN RELEASE FACTOR SUBUNIT 1', NULL, NULL, 5970, 8),
(241358, NULL, 'PTHR10339', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLTRANSFERASE', NULL, NULL, NULL, 8),
(241359, NULL, 'PTHR47898', NULL, NULL, NULL, NULL, 'KUNITZ-TYPE PROTEASE INHIBITOR 4', NULL, NULL, 36252, 8),
(241360, NULL, 'PTHR38697', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN SIMILAR TO S. CEREVISIAE NUP2 (EUROFUNG)', NULL, NULL, NULL, 8),
(241361, NULL, 'PTHR34067', NULL, NULL, NULL, NULL, 'OS04G0193200 PROTEIN', NULL, NULL, 31968, 8),
(241362, NULL, 'PTHR31907', NULL, NULL, NULL, NULL, 'MLP-LIKE PROTEIN 423', NULL, NULL, NULL, 8),
(241363, NULL, 'PTHR42716', NULL, NULL, NULL, NULL, 'L-ASPARTATE OXIDASE', NULL, NULL, 4276, 8),
(241364, NULL, 'PTHR37714', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(241365, NULL, 'PTHR24168', NULL, NULL, NULL, NULL, 'KN MOTIF AND ANKYRIN REPEAT DOMAIN-CONTAINING', NULL, NULL, NULL, 8),
(241366, NULL, 'PTHR13405', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP133', NULL, NULL, 32670, 8),
(241367, NULL, 'PTHR31464', NULL, NULL, NULL, NULL, 'PROTEIN CBG01266', NULL, NULL, 1051, 8),
(241368, NULL, 'PTHR45707', NULL, NULL, NULL, NULL, 'C2 CALCIUM/LIPID-BINDING PLANT PHOSPHORIBOSYLTRANSFERASE FAMILY PROTEIN', NULL, NULL, NULL, 8),
(241369, NULL, 'PTHR13691', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L2', NULL, NULL, 210, 8),
(241370, NULL, 'PTHR34551', NULL, NULL, NULL, NULL, 'GLUTAMATE-RICH 3', NULL, NULL, NULL, 8),
(241371, NULL, 'PTHR23513', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE EFFLUX PROTEIN-RELATED', NULL, NULL, NULL, 8),
(241372, NULL, 'PTHR31084', NULL, NULL, NULL, NULL, 'ALPHA-L-FUCOSIDASE 2', NULL, NULL, NULL, 8);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(241373, NULL, 'PTHR12393', NULL, NULL, NULL, NULL, 'SPHINGOMYELIN PHOSPHODIESTERASE RELATED', NULL, NULL, 32808, 8),
(241374, NULL, 'PTHR22237', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 15530, 8),
(241375, NULL, 'PTHR21024', NULL, NULL, NULL, NULL, 'GROWTH HORMONE-INDUCIBLE SOLUBLE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(241376, NULL, 'PTHR23321', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S15, BACTERIAL AND ORGANELLAR', NULL, NULL, 4167, 8),
(241377, NULL, 'PTHR40065', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN YHBY', NULL, NULL, NULL, 8),
(241378, NULL, 'PTHR46407', NULL, NULL, NULL, NULL, 'OS02G0208700 PROTEIN', NULL, NULL, 34249, 8),
(241379, NULL, 'PTHR21219', NULL, NULL, NULL, NULL, 'FI19613P1', NULL, NULL, NULL, 8),
(241380, NULL, 'PTHR37886', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(241381, NULL, 'PTHR31284', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE-LIKE PROTEIN', NULL, NULL, NULL, 8),
(241382, NULL, 'PTHR46138', NULL, NULL, NULL, NULL, 'PROTEIN DR1', NULL, NULL, 33893, 8),
(241383, NULL, 'PTHR21645', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(241384, NULL, 'PTHR38614', NULL, NULL, NULL, NULL, 'PROTEIN CBG09954', NULL, NULL, 8007, 8),
(241385, NULL, 'PTHR46395', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN 1', NULL, NULL, NULL, 8),
(241386, NULL, 'PTHR31689', NULL, NULL, NULL, NULL, 'DIAMINOPIMELATE EPIMERASE, CHLOROPLASTIC', NULL, NULL, 11041, 8),
(241387, NULL, 'PTHR47607', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUBFAMILY MEMBER 3', NULL, NULL, 17227, 8),
(241388, NULL, 'PTHR38834', NULL, NULL, NULL, NULL, 'PERIPLASMIC SUBSTRATE BINDING PROTEIN FAMILY 3', NULL, NULL, NULL, 8),
(241389, NULL, 'PTHR21235', NULL, NULL, NULL, NULL, 'IMIDAZOLE GLYCEROL PHOSPHATE SYNTHASE SUBUNIT HISF/H  IGP SYNTHASE SUBUNIT HISF/H', NULL, NULL, NULL, 8),
(241390, NULL, 'PTHR46891', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H-RELATED', NULL, NULL, NULL, 8),
(241391, NULL, 'PTHR19367', NULL, NULL, NULL, NULL, 'T-CELL RECEPTOR ALPHA CHAIN V REGION', NULL, NULL, NULL, 8),
(241392, NULL, 'PTHR36037', NULL, NULL, NULL, NULL, 'RNA-DIRECTED DNA POLYMERASE (REVERSE TRANSCRIPTASE)-RELATED FAMILY PROTEIN', NULL, NULL, NULL, 8),
(241393, NULL, 'PTHR43483', NULL, NULL, NULL, NULL, 'MEMBRANE TRANSPORTER PROTEIN HI_0806-RELATED', NULL, NULL, NULL, 8),
(241394, NULL, 'PTHR48249', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 13', NULL, NULL, NULL, 8),
(241395, NULL, 'PTHR12373', NULL, NULL, NULL, NULL, 'ENHANCER OF RUDIMENTARY ERH', NULL, NULL, 6842, 8),
(241396, NULL, 'PTHR38658', NULL, NULL, NULL, NULL, 'OXPP CYCLE PROTEIN OPCA-RELATED', NULL, NULL, 783, 8),
(241397, NULL, 'PTHR30222', NULL, NULL, NULL, NULL, 'SPERMIDINE/PUTRESCINE-BINDING PERIPLASMIC PROTEIN', NULL, NULL, NULL, 8),
(241398, NULL, 'PTHR43130', NULL, NULL, NULL, NULL, 'ARAC-FAMILY TRANSCRIPTIONAL REGULATOR', NULL, NULL, NULL, 8),
(241399, NULL, 'PTHR35262', NULL, NULL, NULL, NULL, 'NHL REPEAT-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(241400, NULL, 'PTHR28628', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 88-RELATED', NULL, NULL, 29594, 8),
(241401, NULL, 'PTHR38044', NULL, NULL, NULL, NULL, 'BOUQUET FORMATION PROTEIN 4', NULL, NULL, 33320, 8),
(241402, NULL, 'PTHR37825', NULL, NULL, NULL, NULL, 'TRNA(MET) CYTIDINE ACETATE LIGASE', NULL, NULL, 12772, 8),
(241403, NULL, 'PTHR45951', NULL, NULL, NULL, NULL, 'PROTEIN DISPATCHED-RELATED', NULL, NULL, NULL, 8),
(241404, NULL, 'PTHR16742', NULL, NULL, NULL, NULL, 'CYCLICIN', NULL, NULL, 25001, 8),
(241405, NULL, 'PTHR35871', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(241406, NULL, 'PTHR43711', NULL, NULL, NULL, NULL, 'TWO-COMPONENT HISTIDINE KINASE', NULL, NULL, NULL, 8),
(241407, NULL, 'PTHR31932', NULL, NULL, NULL, NULL, 'TUBULIN POLYGLUTAMYLASE COMPLEX SUBUNIT 1', NULL, NULL, 33249, 8),
(241408, NULL, 'PTHR11668', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE', NULL, NULL, NULL, 8);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(241409, NULL, 'PTHR23211', NULL, NULL, NULL, NULL, 'TRANS-GOLGI NETWORK INTEGRAL MEMBRANE PROTEIN TGN38', NULL, NULL, NULL, 8),
(241410, NULL, 'PTHR42860', NULL, NULL, NULL, NULL, 'VITAMIN B12-BINDING PROTEIN', NULL, NULL, NULL, 8),
(241411, NULL, 'PTHR28207', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT H, MITOCHONDRIAL', NULL, NULL, 20926, 8),
(241412, NULL, 'PTHR10846', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM/CALCIUM EXCHANGER', NULL, NULL, 7420, 8),
(241413, NULL, 'PTHR33354', NULL, NULL, NULL, NULL, 'ENDONUCLEASE/EXONUCLEASE/PHOSPHATASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_1G01540)', NULL, NULL, NULL, 8),
(241414, NULL, 'PTHR43148', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE 2', NULL, NULL, 19323, 8),
(241415, NULL, 'PTHR38140', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 19-3-RELATED', NULL, NULL, NULL, 8),
(241416, NULL, 'PTHR37077', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(241417, NULL, 'PTHR46472', NULL, NULL, NULL, NULL, 'NUCLEOREDOXIN', NULL, NULL, NULL, 8),
(241418, NULL, 'PTHR46328', NULL, NULL, NULL, NULL, 'FAR-RED IMPAIRED RESPONSIVE (FAR1) FAMILY PROTEIN-RELATED', NULL, NULL, NULL, 8),
(241419, NULL, 'PTHR47410', NULL, NULL, NULL, NULL, 'TOLL-LIKE RECEPTOR 7-RELATED', NULL, NULL, NULL, 8),
(241420, NULL, 'PTHR21681', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT J', NULL, NULL, 17868, 8),
(241421, NULL, 'PTHR13088', NULL, NULL, NULL, NULL, 'FAS APOPTOTIC INHIBITORY MOLECULE FAIM', NULL, NULL, 9549, 8),
(241422, NULL, 'PTHR37368', NULL, NULL, NULL, NULL, 'TSSK6-ACTIVATING CO-CHAPERONE PROTEIN', NULL, NULL, 25502, 8),
(241423, NULL, 'PTHR37188', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT-RELATED', NULL, NULL, 32878, 8),
(241424, NULL, 'PTHR23206', NULL, NULL, NULL, NULL, 'MASK PROTEIN', NULL, NULL, NULL, 8),
(241425, NULL, 'PTHR31531', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE E3D FAMILY MEMBER', NULL, NULL, 18165, 8),
(241426, NULL, 'PTHR40029', NULL, NULL, NULL, NULL, '', NULL, NULL, 33406, 8),
(241427, NULL, 'PTHR34724', NULL, NULL, NULL, NULL, 'OS12G0596101 PROTEIN', NULL, NULL, NULL, 8),
(241428, NULL, 'PTHR37456', NULL, NULL, NULL, NULL, 'SI:CH211-266K2.1', NULL, NULL, NULL, 8),
(241429, NULL, 'PTHR43337', NULL, NULL, NULL, NULL, 'XANTHINE/URACIL PERMEASE C887.17-RELATED', NULL, NULL, 36928, 8),
(241430, NULL, 'PTHR13063', NULL, NULL, NULL, NULL, 'ENOS INTERACTING PROTEIN', NULL, NULL, 15183, 8),
(241431, NULL, 'PTHR35970', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL AND CLATHRIN LINKER 1', NULL, NULL, 33645, 8),
(241432, NULL, 'PTHR47193', NULL, NULL, NULL, NULL, 'CATION CHANNEL SPERM-ASSOCIATED PROTEIN 1', NULL, NULL, 23178, 8),
(241433, NULL, 'PTHR13018', NULL, NULL, NULL, NULL, 'PROBABLE MEMBRANE PROTEIN DUF221-RELATED', NULL, NULL, 36511, 8),
(241434, NULL, 'PTHR11941', NULL, NULL, NULL, NULL, 'ENOYL-COA HYDRATASE-RELATED', NULL, NULL, NULL, 8),
(241435, NULL, 'PTHR10434', NULL, NULL, NULL, NULL, '1-ACYL-SN-GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE', NULL, NULL, NULL, 8),
(241436, NULL, 'PTHR12106', NULL, NULL, NULL, NULL, 'SORTILIN RELATED', NULL, NULL, NULL, 8),
(241437, NULL, 'PTHR34482', NULL, NULL, NULL, NULL, 'DNA DAMAGE-INDUCIBLE PROTEIN 1-LIKE', NULL, NULL, NULL, 8),
(241438, NULL, 'PTHR42241', NULL, NULL, NULL, NULL, 'HYPOTHETICAL MEMBRANE PROTEIN, CONSERVED, DUF998 FAMILY', NULL, NULL, NULL, 8),
(241439, NULL, 'PTHR45725', NULL, NULL, NULL, NULL, 'FORMIN HOMOLOGY 2 FAMILY MEMBER', NULL, NULL, NULL, 8),
(241440, NULL, 'PTHR47671', NULL, NULL, NULL, NULL, 'PLECKSTRIN DOMAIN-CONTAINING FAMILY G MEMBER 6', NULL, NULL, 34354, 8),
(241441, NULL, 'PTHR12381', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN U FAMILY MEMBER', NULL, NULL, NULL, 8),
(241442, NULL, 'PTHR11618', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIB-RELATED', NULL, NULL, 6776, 8),
(241443, NULL, 'PTHR24364', NULL, NULL, NULL, NULL, 'LP06937P', NULL, NULL, NULL, 8),
(241444, NULL, 'PTHR43707', NULL, NULL, NULL, NULL, 'HISTIDYL-TRNA SYNTHETASE', NULL, NULL, 1964, 8);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(241445, NULL, 'PTHR39380', NULL, NULL, NULL, NULL, 'FIP (FUNGUS-INDUCED PROTEIN) RELATED-RELATED-RELATED', NULL, NULL, NULL, 8),
(241446, NULL, 'PTHR34564', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE G', NULL, NULL, NULL, 8),
(241447, NULL, 'PTHR40265', NULL, NULL, NULL, NULL, 'BLL2707 PROTEIN', NULL, NULL, NULL, 8),
(241448, NULL, 'PTHR14058', NULL, NULL, NULL, NULL, 'AMYLOID BETA A4 PRECURSOR PROTEIN-BINDING FAMILY B', NULL, NULL, 33527, 8),
(241449, NULL, 'PTHR15337', NULL, NULL, NULL, NULL, 'ANTERIOR GRADIENT PROTEIN-RELATED', NULL, NULL, NULL, 8),
(241450, NULL, 'PTHR10271', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED PROTEIN WITH TETRATRICOPEPTIDE REPEATS', NULL, NULL, NULL, 8),
(241451, NULL, 'PTHR22904', NULL, NULL, NULL, NULL, 'TPR REPEAT CONTAINING PROTEIN', NULL, NULL, 36761, 8),
(241452, NULL, 'PTHR36358', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE SUBUNIT 4, MITOCHONDRIAL', NULL, NULL, 35094, 8),
(241453, NULL, 'PTHR31319', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CONSTANS-LIKE 4', NULL, NULL, 37309, 8),
(241454, NULL, 'PTHR38709', NULL, NULL, NULL, NULL, 'SI:CH73-193C12.2-RELATED', NULL, NULL, NULL, 8),
(241455, NULL, 'PTHR34227', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN YCDY', NULL, NULL, NULL, 8),
(241456, NULL, 'PTHR24217', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(241457, NULL, 'PTHR10609', NULL, NULL, NULL, NULL, 'BIOTINIDASE-RELATED', NULL, NULL, 27123, 8),
(241458, NULL, 'PTHR46502', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING', NULL, NULL, NULL, 8),
(241459, NULL, 'PTHR20920', NULL, NULL, NULL, NULL, 'RPE-SPONDIN', NULL, NULL, 32263, 8),
(241460, NULL, 'PTHR36108', NULL, NULL, NULL, NULL, 'COLOSSIN-B-RELATED', NULL, NULL, NULL, 8),
(241461, NULL, 'PTHR45339', NULL, NULL, NULL, NULL, 'HYBRID SIGNAL TRANSDUCTION HISTIDINE KINASE J', NULL, NULL, NULL, 8),
(241462, NULL, 'PTHR28051', NULL, NULL, NULL, NULL, 'PROTEIN MTL1-RELATED', NULL, NULL, NULL, 8),
(241463, NULL, 'PTHR11066', NULL, NULL, NULL, NULL, 'ACYL-COA THIOESTERASE', NULL, NULL, 2268, 8),
(241464, NULL, 'PTHR37476', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 171', NULL, NULL, NULL, 8),
(241465, NULL, 'PTHR39233', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE III DOMAIN-CONTAINING PROTEIN 10', NULL, NULL, 2273, 8),
(241466, NULL, 'PTHR31123', NULL, NULL, NULL, NULL, 'ACCUMULATION OF DYADS PROTEIN 2-RELATED', NULL, NULL, NULL, 8),
(241467, NULL, 'PTHR14085', NULL, NULL, NULL, NULL, 'WD-REPEAT PROTEIN BING4', NULL, NULL, 31293, 8),
(241468, NULL, 'PTHR21593', NULL, NULL, NULL, NULL, 'PRION-LIKE- Q/N-RICH -DOMAIN-BEARING PROTEIN PROTEIN', NULL, NULL, NULL, 8),
(241469, NULL, 'PTHR16299', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN KIZUNA', NULL, NULL, 25728, 8),
(241470, NULL, 'PTHR10343', NULL, NULL, NULL, NULL, '5''-AMP-ACTIVATED PROTEIN KINASE , BETA SUBUNIT', NULL, NULL, NULL, 8),
(241471, NULL, 'PTHR13799', NULL, NULL, NULL, NULL, 'NGG1 INTERACTING FACTOR 3', NULL, NULL, 2763, 8),
(241472, NULL, 'PTHR31618', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN 5', NULL, NULL, 20233, 8),
(241473, NULL, 'PTHR45586', NULL, NULL, NULL, NULL, 'TPR REPEAT-CONTAINING PROTEIN PA4667', NULL, NULL, NULL, 8),
(241474, NULL, 'PTHR15934', NULL, NULL, NULL, NULL, 'RNA 2'',3''-CYCLIC PHOSPHODIESTERASE', NULL, NULL, NULL, 8),
(241475, NULL, 'PTHR32205', NULL, NULL, NULL, NULL, 'ARCHAEMETZINCIN-2-RELATED', NULL, NULL, NULL, 8),
(241476, NULL, 'PTHR21641', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR-RELATED', NULL, NULL, 32934, 8),
(241477, NULL, 'PTHR34781', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(241478, NULL, 'PTHR46770', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN ORTHOPEDIA', NULL, NULL, NULL, 8),
(241479, NULL, 'PTHR43578', NULL, NULL, NULL, NULL, 'NADH-QUINONE OXIDOREDUCTASE SUBUNIT F', NULL, NULL, NULL, 8),
(241480, NULL, 'PTHR24028', NULL, NULL, NULL, NULL, 'CADHERIN-87A', NULL, NULL, NULL, 8),
(241481, NULL, 'PTHR43749', NULL, NULL, NULL, NULL, 'RNA-SPLICING LIGASE RTCB', NULL, NULL, NULL, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(241482, NULL, 'PTHR11224', NULL, NULL, NULL, NULL, 'MAKORIN-RELATED', NULL, NULL, 36652, 8),
(241483, NULL, 'PTHR46139', NULL, NULL, NULL, NULL, 'ALKALINE CERAMIDASE', NULL, NULL, 7883, 8),
(241484, NULL, 'PTHR36389', NULL, NULL, NULL, NULL, 'OS05G0110100 PROTEIN', NULL, NULL, NULL, 8),
(241485, NULL, 'PTHR43128', NULL, NULL, NULL, NULL, 'L-2-HYDROXYCARBOXYLATE DEHYDROGENASE (NAD(P)(+))', NULL, NULL, NULL, 8),
(241486, NULL, 'PTHR11592', NULL, NULL, NULL, NULL, 'GLUTATHIONE PEROXIDASE', NULL, NULL, 4632, 8),
(241487, NULL, 'PTHR31638', NULL, NULL, NULL, NULL, 'DAZ-ASSOCIATED PROTEIN 2', NULL, NULL, 16918, 8),
(241488, NULL, 'PTHR47194', NULL, NULL, NULL, NULL, 'SORTING NEXIN-29-RELATED', NULL, NULL, NULL, 8),
(241489, NULL, 'PTHR46636', NULL, NULL, NULL, NULL, 'CDK2-ASSOCIATED AND CULLIN DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, 35913, 8),
(241490, NULL, 'PTHR33747', NULL, NULL, NULL, NULL, 'UPF0225 PROTEIN SCO1677', NULL, NULL, NULL, 8),
(241491, NULL, 'PTHR13082', NULL, NULL, NULL, NULL, 'SAP18', NULL, NULL, 12001, 8),
(241492, NULL, 'PTHR12842', NULL, NULL, NULL, NULL, 'FI01459P', NULL, NULL, 4177, 8),
(241493, NULL, 'PTHR45958', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', NULL, NULL, NULL, 8),
(241494, NULL, 'PTHR37698', NULL, NULL, NULL, NULL, 'PHOTOSYNTHETIC NDH SUBUNIT OF SUBCOMPLEX B 1, CHLOROPLASTIC', NULL, NULL, 35918, 8),
(241495, NULL, 'PTHR30161', NULL, NULL, NULL, NULL, 'FLAGELLAR EXPORT PROTEIN, MEMBRANE FLHA SUBUNIT-RELATED', NULL, NULL, 3422, 8),
(241496, NULL, 'PTHR46744', NULL, NULL, NULL, NULL, 'PROTEIN UNC-93 HOMOLOG B1', NULL, NULL, 34770, 8),
(241497, NULL, 'PTHR11417', NULL, NULL, NULL, NULL, 'SOMATOTROPIN,PROLACTIN', NULL, NULL, 5388, 8),
(241498, NULL, 'PTHR42068', NULL, NULL, NULL, NULL, 'YALI0B18964P', NULL, NULL, NULL, 8),
(241499, NULL, 'PTHR45732', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 8', NULL, NULL, NULL, 8),
(241500, NULL, 'PTHR11135', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE-RELATED', NULL, NULL, 27220, 8),
(241501, NULL, 'PTHR15885', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 22293, 8),
(241502, NULL, 'PTHR31759', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 167', NULL, NULL, 22281, 8),
(241503, NULL, 'PTHR12357', NULL, NULL, NULL, NULL, 'YTH  YT521-B HOMOLOGY  DOMAIN-CONTAINING', NULL, NULL, 34051, 8),
(241504, NULL, 'PTHR31660', NULL, NULL, NULL, NULL, 'GAG-POL POLYPROTEIN-LIKE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(241505, NULL, 'PTHR46688', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 16', NULL, NULL, NULL, 8),
(241506, NULL, 'PTHR43320', NULL, NULL, NULL, NULL, 'SUGAR KINASE', NULL, NULL, NULL, 8),
(241507, NULL, 'PTHR46115', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE PROTEIN 1', NULL, NULL, NULL, 8),
(241508, NULL, 'PTHR38593', NULL, NULL, NULL, NULL, 'BLR2558 PROTEIN', NULL, NULL, NULL, 8),
(241509, NULL, 'PTHR34835', NULL, NULL, NULL, NULL, 'OS07G0283600 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(241510, NULL, 'PTHR42959', NULL, NULL, NULL, NULL, 'CARBAMOYLTRANSFERASE', NULL, NULL, NULL, 8),
(241511, NULL, 'PTHR42053', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(241512, NULL, 'PTHR47535', NULL, NULL, NULL, NULL, 'MUSCLE-SPECIFIC PROTEIN 300 KDA, ISOFORM G', NULL, NULL, NULL, 8),
(241513, NULL, 'PTHR42891', NULL, NULL, NULL, NULL, 'D-GLYCERO-BETA-D-MANNO-HEPTOSE-1,7-BISPHOSPHATE 7-PHOSPHATASE', NULL, NULL, 7080, 8),
(241514, NULL, 'PTHR21308', NULL, NULL, NULL, NULL, 'PHYTANOYL-COA ALPHA-HYDROXYLASE', NULL, NULL, NULL, 8),
(241515, NULL, 'PTHR30367', NULL, NULL, NULL, NULL, 'P-HYDROXYBENZOIC ACID EFFLUX PUMP SUBUNIT AAEA-RELATED', NULL, NULL, NULL, 8),
(241516, NULL, 'PTHR22529', NULL, NULL, NULL, NULL, 'EPITHELIAL-STROMAL INTERACTION PROTEIN 1', NULL, NULL, 25368, 8),
(241517, NULL, 'PTHR42252', NULL, NULL, NULL, NULL, 'DUF5616 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(241518, NULL, 'PTHR34370', NULL, NULL, NULL, NULL, 'OS04G0600100 PROTEIN', NULL, NULL, NULL, 8),
(241519, NULL, 'PTHR47869', NULL, NULL, NULL, NULL, 'OS03G0410700 PROTEIN', NULL, NULL, NULL, 8);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(241520, NULL, 'PTHR43977', NULL, NULL, NULL, NULL, 'STRUCTURAL MAINTENANCE OF CHROMOSOMES PROTEIN 3', NULL, NULL, NULL, 8),
(241521, NULL, 'PTHR21286', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP160', NULL, NULL, 19177, 8),
(241522, NULL, 'PTHR30535', NULL, NULL, NULL, NULL, 'VITAMIN B12-BINDING PROTEIN', NULL, NULL, NULL, 8),
(241523, NULL, 'PTHR33442', NULL, NULL, NULL, NULL, 'TRANS-3-HYDROXY-L-PROLINE DEHYDRATASE', NULL, NULL, 13600, 8),
(241524, NULL, 'PTHR43091', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE', NULL, NULL, NULL, 8),
(241525, NULL, 'PTHR30480', NULL, NULL, NULL, NULL, 'BETA-HEXOSAMINIDASE-RELATED', NULL, NULL, NULL, 8),
(241526, NULL, 'PTHR31382', NULL, NULL, NULL, NULL, 'NA(+)/H(+) ANTIPORTER', NULL, NULL, NULL, 8),
(241527, NULL, 'PTHR36177', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(241528, NULL, 'PTHR33022', NULL, NULL, NULL, NULL, 'DUF1985 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(241529, NULL, 'PTHR43024', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLMURAMOYL-TRIPEPTIDE--D-ALANYL-D-ALANINE LIGASE', NULL, NULL, NULL, 8),
(241530, NULL, 'PTHR24057', NULL, NULL, NULL, NULL, 'GLYCOGEN SYNTHASE KINASE-3 ALPHA', NULL, NULL, NULL, 8),
(241531, NULL, 'PTHR43311', NULL, NULL, NULL, NULL, 'GLUTAMATE--TRNA LIGASE', NULL, NULL, NULL, 8),
(241532, NULL, 'PTHR48061', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR PROTEIN KINASE EMS1-LIKE-RELATED', NULL, NULL, NULL, 8),
(241533, NULL, 'PTHR13386', NULL, NULL, NULL, NULL, 'HISTONE PARYLATION FACTOR 1', NULL, NULL, 15685, 8),
(241534, NULL, 'PTHR10408', NULL, NULL, NULL, NULL, 'STEROL O-ACYLTRANSFERASE', NULL, NULL, 12239, 8),
(241535, NULL, 'PTHR30624', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN TLDD AND PMBA', NULL, NULL, NULL, 8),
(241536, NULL, 'PTHR22907', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(241537, NULL, 'PTHR30134', NULL, NULL, NULL, NULL, 'HYDROGENASE PROTEIN ASSEMBLY PROTEIN, NICKEL CHAPERONE', NULL, NULL, 5621, 8),
(241538, NULL, 'PTHR31777', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 169', NULL, NULL, 26276, 8),
(241539, NULL, 'PTHR31151', NULL, NULL, NULL, NULL, 'PROLINE-TRNA LIGASE (DUF1680)', NULL, NULL, NULL, 8),
(241540, NULL, 'PTHR38585', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(241541, NULL, 'PTHR16199', NULL, NULL, NULL, NULL, 'CONDENSIN-2 COMPLEX SUBUNIT G2', NULL, NULL, NULL, 8),
(241542, NULL, 'PTHR12202', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 28299, 8),
(241543, NULL, 'PTHR43569', NULL, NULL, NULL, NULL, 'AMIDOHYDROLASE', NULL, NULL, NULL, 8),
(241544, NULL, 'PTHR48063', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE KINASE', NULL, NULL, NULL, 8),
(241545, NULL, 'PTHR14738', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 14', NULL, NULL, 29996, 8),
(241546, NULL, 'PTHR22014', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 33', NULL, NULL, 27442, 8),
(241547, NULL, 'PTHR21650', NULL, NULL, NULL, NULL, 'MEMBRALIN/KINETOCHORE PROTEIN NUF2', NULL, NULL, NULL, 8),
(241548, NULL, 'PTHR39383', NULL, NULL, NULL, NULL, 'PROTEIN CBG16996', NULL, NULL, NULL, 8),
(241549, NULL, 'PTHR33491', NULL, NULL, NULL, NULL, 'OSJNBA0016N04.9 PROTEIN', NULL, NULL, NULL, 8),
(241550, NULL, 'PTHR31179', NULL, NULL, NULL, NULL, 'RAB GTPASE-BINDING EFFECTOR PROTEIN', NULL, NULL, 6098, 8),
(241551, NULL, 'PTHR33823', NULL, NULL, NULL, NULL, 'RNA POLYMERASE-BINDING TRANSCRIPTION FACTOR DKSA-RELATED', NULL, NULL, NULL, 8),
(241552, NULL, 'PTHR37393', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 1A-LIKE', NULL, NULL, NULL, 8),
(241553, NULL, 'PTHR13180', NULL, NULL, NULL, NULL, 'SMALL MEMBRANE PROTEIN-RELATED', NULL, NULL, 3065, 8),
(241554, NULL, 'PTHR31750', NULL, NULL, NULL, NULL, 'PROTEIN STAY-GREEN 1, CHLOROPLASTIC-RELATED', NULL, NULL, NULL, 8),
(241555, NULL, 'PTHR40623', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(241556, NULL, 'PTHR40861', NULL, NULL, NULL, NULL, 'DUF2183 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(241557, NULL, 'PTHR46081', NULL, NULL, NULL, NULL, 'PEPTIDE METHIONINE SULFOXIDE REDUCTASE 2', NULL, NULL, 25526, 8);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(241558, NULL, 'PTHR43680', NULL, NULL, NULL, NULL, 'NITRATE REDUCTASE MOLYBDENUM COFACTOR ASSEMBLY CHAPERONE', NULL, NULL, 2487, 8),
(241559, NULL, 'PTHR14186', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR BINDING PROTEIN-RELATED', NULL, NULL, 14818, 8),
(241560, NULL, 'PTHR30028', NULL, NULL, NULL, NULL, 'UPF0014 INNER MEMBRANE PROTEIN YBBM-RELATED', NULL, NULL, 11253, 8),
(241561, NULL, 'PTHR22629', NULL, NULL, NULL, NULL, 'ARP2/3 COMPLEX 20 KD SUBUNIT', NULL, NULL, 7598, 8),
(241562, NULL, 'PTHR31720', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS Z-RELATED', NULL, NULL, NULL, 8),
(241563, NULL, 'PTHR35097', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE', NULL, NULL, NULL, 8),
(241564, NULL, 'PTHR36775', NULL, NULL, NULL, NULL, 'LYR MOTIF PROTEIN', NULL, NULL, NULL, 8),
(241565, NULL, 'PTHR28304', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN PEX29', NULL, NULL, NULL, 8),
(241566, NULL, 'PTHR33304', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(241567, NULL, 'PTHR41700', NULL, NULL, NULL, NULL, 'GCN5-RELATED N-ACETYLTRANSFERASE', NULL, NULL, 32485, 8),
(241568, NULL, 'PTHR37687', NULL, NULL, NULL, NULL, 'AGAP006772-PA', NULL, NULL, NULL, 8),
(241569, NULL, 'PTHR47425', NULL, NULL, NULL, NULL, 'FARB-RELATED', NULL, NULL, NULL, 8),
(241570, NULL, 'PTHR31774', NULL, NULL, NULL, NULL, 'PROTEIN SHISA-9-RELATED', NULL, NULL, 26629, 8),
(241571, NULL, 'PTHR47279', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SOX-30', NULL, NULL, NULL, 8),
(241572, NULL, 'PTHR47938', NULL, NULL, NULL, NULL, 'RESPIRATORY COMPLEX I CHAPERONE (CIA84), PUTATIVE (AFU_ORTHOLOGUE AFUA_2G06020)-RELATED', NULL, NULL, NULL, 8),
(241573, NULL, 'PTHR21178', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 61', NULL, NULL, 28766, 8),
(241574, NULL, 'PTHR37300', NULL, NULL, NULL, NULL, 'UPF0291 PROTEIN CBO2609/CLC_2481', NULL, NULL, 13978, 8),
(241575, NULL, 'PTHR11988', NULL, NULL, NULL, NULL, 'THYROTROPH EMBRYONIC FACTOR RELATED', NULL, NULL, 31680, 8),
(241576, NULL, 'PTHR35504', NULL, NULL, NULL, NULL, 'PROTEIN EMBRYONIC FLOWER 1', NULL, NULL, 29601, 8),
(241577, NULL, 'PTHR43086', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN 3-OXOOACYL-COA REDUCTASE', NULL, NULL, NULL, 8),
(241578, NULL, 'PTHR15576', NULL, NULL, NULL, NULL, 'RIBITOL-5-PHOSPHATE XYLOSYLTRANSFERASE 1', NULL, NULL, NULL, 8),
(241579, NULL, 'PTHR48101', NULL, NULL, NULL, NULL, 'METHYLMALONYL-COA MUTASE, MITOCHONDRIAL-RELATED', NULL, NULL, NULL, 8),
(241580, NULL, 'PTHR34078', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(241581, NULL, 'PTHR44314', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 70', NULL, NULL, NULL, 8),
(241582, NULL, 'PTHR46446', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PRE', NULL, NULL, 34766, 8),
(241583, NULL, 'PTHR37519', NULL, NULL, NULL, NULL, '', NULL, NULL, 9065, 8),
(241584, NULL, 'PTHR23113', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE EXCHANGE FACTOR', NULL, NULL, 8989, 8),
(241585, NULL, 'PTHR14909', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 6 COMPLEX LOCUS PROTEIN G5C', NULL, NULL, 25060, 8),
(241586, NULL, 'PTHR37273', NULL, NULL, NULL, NULL, 'CHROMOSOME 8, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(241587, NULL, 'PTHR23062', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN  C.ELEGANS', NULL, NULL, NULL, 8),
(241588, NULL, 'PTHR47703', NULL, NULL, NULL, NULL, 'D-AMINOACID AMINOTRANSFERASE-LIKE PLP-DEPENDENT ENZYMES SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(241589, NULL, 'PTHR21716', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, 1977, 8),
(241590, NULL, 'PTHR45717', NULL, NULL, NULL, NULL, 'OS12G0527900 PROTEIN', NULL, NULL, NULL, 8),
(241591, NULL, 'PTHR39224', NULL, NULL, NULL, NULL, 'IGA-INDUCING PROTEIN HOMOLOG', NULL, NULL, 30960, 8),
(241592, NULL, 'PTHR31221', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR PROTEIN 1-RELATED', NULL, NULL, 34764, 8),
(241593, NULL, 'PTHR33995', NULL, NULL, NULL, NULL, 'PROTEIN CBG18546', NULL, NULL, NULL, 8),
(241594, NULL, 'PTHR28161', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT F, MITOCHONDRIAL', NULL, NULL, 20520, 8);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(241595, NULL, 'PTHR28164', NULL, NULL, NULL, NULL, 'PROTEIN STB3', NULL, NULL, 19726, 8),
(241596, NULL, 'PTHR39168', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR-RELATED', NULL, NULL, NULL, 8),
(241597, NULL, 'PTHR19134', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE TYROSINE-PROTEIN PHOSPHATASE', NULL, NULL, NULL, 8),
(241598, NULL, 'PTHR42780', NULL, NULL, NULL, NULL, 'SOLEUCYL-TRNA SYNTHETASE', NULL, NULL, 16725, 8),
(241599, NULL, 'PTHR48173', NULL, NULL, NULL, NULL, 'GNK2-HOMOLOGOUS DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(241600, NULL, 'PTHR23336', NULL, NULL, NULL, NULL, 'ZINC FINGER CW-TYPE COILED-COIL DOMAIN PROTEIN 3.', NULL, NULL, 35594, 8),
(241601, NULL, 'PTHR42305', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN RV1733C-RELATED', NULL, NULL, 28266, 8),
(241602, NULL, 'PTHR42827', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER-BINDING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(241603, NULL, 'PTHR36419', NULL, NULL, NULL, NULL, 'ARRESTIN FAMILY PROTEIN 1', NULL, NULL, NULL, 8),
(241604, NULL, 'PTHR35351', NULL, NULL, NULL, NULL, 'GERMINAL CENTER-ASSOCIATED SIGNALING AND MOTILITY-LIKE PROTEIN', NULL, NULL, 25567, 8),
(241605, NULL, 'PTHR43255', NULL, NULL, NULL, NULL, 'IRON-SULFUR-BINDING OXIDOREDUCTASE FADF-RELATED-RELATED', NULL, NULL, NULL, 8),
(241606, NULL, 'PTHR11311', NULL, NULL, NULL, NULL, 'SPONDIN', NULL, NULL, NULL, 8),
(241607, NULL, 'PTHR46643', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN GOOSECOID-RELATED', NULL, NULL, NULL, 8),
(241608, NULL, 'PTHR47407', NULL, NULL, NULL, NULL, 'PROTEIN CBG15905-RELATED', NULL, NULL, NULL, 8),
(241609, NULL, 'PTHR14347', NULL, NULL, NULL, NULL, 'CLAUDIN DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, 36512, 8),
(241610, NULL, 'PTHR28556', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 106B', NULL, NULL, 13426, 8),
(241611, NULL, 'PTHR46689', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(241612, NULL, 'PTHR38009', NULL, NULL, NULL, NULL, 'CONSERVED HYPOTHETICAL PHAGE TAIL PROTEIN', NULL, NULL, 11747, 8),
(241613, NULL, 'PTHR43456', NULL, NULL, NULL, NULL, 'RIESKE (2FE-2S) DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(241614, NULL, 'PTHR13093', NULL, NULL, NULL, NULL, 'ZINC FINGER HIT DOMAIN CONTAINING PROTEIN 1', NULL, NULL, 31017, 8),
(241615, NULL, 'PTHR13371', NULL, NULL, NULL, NULL, 'GLYCINE-, GLUTAMATE-, THIENYLCYCLOHEXYLPIPERIDINE-BINDING PROTEIN', NULL, NULL, NULL, 8),
(241616, NULL, 'PTHR33355', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE CARBOXY-TERMINAL PROTEIN-RELATED', NULL, NULL, NULL, 8),
(241617, NULL, 'PTHR37720', NULL, NULL, NULL, NULL, 'OS10G0481400 PROTEIN', NULL, NULL, NULL, 8),
(241618, NULL, 'PTHR37264', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L31', NULL, NULL, NULL, 8),
(241619, NULL, 'PTHR43301', NULL, NULL, NULL, NULL, 'ARABINAN ENDO-1,5-ALPHA-L-ARABINOSIDASE', NULL, NULL, NULL, 8),
(241620, NULL, 'PTHR24220', NULL, NULL, NULL, NULL, 'IMPORT ATP-BINDING PROTEIN', NULL, NULL, NULL, 8),
(241621, NULL, 'PTHR43816', NULL, NULL, NULL, NULL, 'NICOTINAMIDE PHOSPHORIBOSYLTRANSFERASE', NULL, NULL, 15118, 8),
(241622, NULL, 'PTHR13412', NULL, NULL, NULL, NULL, 'T-CELL IMMUNOMODULATORY PROTEIN HOMOLOG', NULL, NULL, 26849, 8),
(241623, NULL, 'PTHR11895', NULL, NULL, NULL, NULL, 'TRANSAMIDASE', NULL, NULL, 1787, 8),
(241624, NULL, 'PTHR31652', NULL, NULL, NULL, NULL, 'LIMR FAMILY PROTEIN DDB_G0283707-RELATED', NULL, NULL, NULL, 8),
(241625, NULL, 'PTHR37305', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(241626, NULL, 'PTHR35112', NULL, NULL, NULL, NULL, 'OS08G0360500 PROTEIN', NULL, NULL, NULL, 8),
(241627, NULL, 'PTHR45798', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL61-RELATED-RELATED', NULL, NULL, NULL, 8),
(241628, NULL, 'PTHR28520', NULL, NULL, NULL, NULL, 'MITOTIC-SPINDLE ORGANIZING PROTEIN 1', NULL, NULL, 21450, 8),
(241629, NULL, 'PTHR31862', NULL, NULL, NULL, NULL, 'UPF0261 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_1G10120)', NULL, NULL, NULL, 8),
(241630, NULL, 'PTHR47620', NULL, NULL, NULL, NULL, 'CHROMOSOME 2 OPEN READING FRAME 66', NULL, NULL, 26113, 8);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(241631, NULL, 'PTHR37338', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 32', NULL, NULL, 24901, 8),
(241632, NULL, 'PTHR47947', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 82C3-RELATED', NULL, NULL, NULL, 8),
(241633, NULL, 'PTHR39289', NULL, NULL, NULL, NULL, '', NULL, NULL, 10136, 8),
(241634, NULL, 'PTHR12586', NULL, NULL, NULL, NULL, 'CDP-DIACYLGLYCEROL--SERINE O-PHOSPHATIDYLTRANSFERASE', NULL, NULL, 19529, 8),
(241635, NULL, 'PTHR42044', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(241636, NULL, 'PTHR35204', NULL, NULL, NULL, NULL, 'YALI0A21131P', NULL, NULL, 33644, 8),
(241637, NULL, 'PTHR43599', NULL, NULL, NULL, NULL, 'MULTIFUNCTIONAL PROTEIN ADE2', NULL, NULL, NULL, 8),
(241638, NULL, 'PTHR11587', NULL, NULL, NULL, NULL, 'ARGININOSUCCINATE SYNTHASE', NULL, NULL, 3432, 8),
(241639, NULL, 'PTHR38684', NULL, NULL, NULL, NULL, 'PROTEIN AMPE', NULL, NULL, NULL, 8),
(241640, NULL, 'PTHR37841', NULL, NULL, NULL, NULL, 'GLR2918 PROTEIN', NULL, NULL, NULL, 8),
(241641, NULL, 'PTHR33601', NULL, NULL, NULL, NULL, 'PROTEIN LITTLE ZIPPER 4', NULL, NULL, 27275, 8),
(241642, NULL, 'PTHR47761', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN-RELATED', NULL, NULL, NULL, 8),
(241643, NULL, 'PTHR13557', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 21574, 8),
(241644, NULL, 'PTHR15600', NULL, NULL, NULL, NULL, 'SACSIN', NULL, NULL, NULL, 8),
(241645, NULL, 'PTHR47922', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H', NULL, NULL, NULL, 8),
(241646, NULL, 'PTHR23131', NULL, NULL, NULL, NULL, 'ENDORIBONUCLEASE LACTB2', NULL, NULL, NULL, 8),
(241647, NULL, 'PTHR21314', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 17086, 8),
(241648, NULL, 'PTHR28605', NULL, NULL, NULL, NULL, 'CTF8, CHROMOSOME TRANSMISSION FIDELITY FACTOR 8 HOMOLOG (S. CEREVISIAE)', NULL, NULL, NULL, 8),
(241649, NULL, 'PTHR31804', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 15', NULL, NULL, NULL, 8),
(241650, NULL, 'PTHR32382', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN', NULL, NULL, 29269, 8),
(241651, NULL, 'PTHR37938', NULL, NULL, NULL, NULL, 'BLL0215 PROTEIN', NULL, NULL, NULL, 8),
(241652, NULL, 'PTHR28189', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT GAMMA', NULL, NULL, 30763, 8),
(241653, NULL, 'PTHR24193', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT PROTEIN', NULL, NULL, NULL, 8),
(241654, NULL, 'PTHR22899', NULL, NULL, NULL, NULL, 'CYCLIN-RELATED F-BOX FAMILY', NULL, NULL, NULL, 8),
(241655, NULL, 'PTHR10730', NULL, NULL, NULL, NULL, 'PROCOLLAGEN-LYSINE,2-OXOGLUTARATE 5-DIOXYGENASE/GLYCOSYLTRANSFERASE 25 FAMILY MEMBER', NULL, NULL, NULL, 8),
(241656, NULL, 'PTHR36251', NULL, NULL, NULL, NULL, 'FELS-1 PROPHAGE HOST SPECIFICITY PROTEIN-RELATED', NULL, NULL, NULL, 8),
(241657, NULL, 'PTHR37845', NULL, NULL, NULL, NULL, '', NULL, NULL, 32564, 8),
(241658, NULL, 'PTHR45906', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(241659, NULL, 'PTHR31390', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(241660, NULL, 'PTHR48299', NULL, NULL, NULL, NULL, 'ACT DOMAIN-CONTAINING PROTEIN ACR9', NULL, NULL, NULL, 8),
(241661, NULL, 'PTHR16537', NULL, NULL, NULL, NULL, 'SJOEGREN SYNDROME/SCLERODERMA AUTOANTIGEN 1', NULL, NULL, NULL, 8),
(241662, NULL, 'PTHR16505', NULL, NULL, NULL, NULL, 'PROTEIN LZIC', NULL, NULL, 27202, 8),
(241663, NULL, 'PTHR46857', NULL, NULL, NULL, NULL, 'EPITHELIAL CELL-TRANSFORMING SEQUENCE 2 ONCOGENE-LIKE', NULL, NULL, NULL, 8),
(241664, NULL, 'PTHR42958', NULL, NULL, NULL, NULL, 'HYDROGENASE-2 LARGE CHAIN', NULL, NULL, NULL, 8),
(241665, NULL, 'PTHR31865', NULL, NULL, NULL, NULL, 'OSJNBA0071G03.3 PROTEIN', NULL, NULL, NULL, 8),
(241666, NULL, 'PTHR13121', NULL, NULL, NULL, NULL, 'GPI TRANSAMIDASE COMPONENT PIG-U', NULL, NULL, 1744, 8),
(241667, NULL, 'PTHR11089', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(241668, NULL, 'PTHR35730', NULL, NULL, NULL, NULL, 'KINETOCHORE PROTEIN SPC24 HOMOLOG-RELATED', NULL, NULL, 35144, 8),
(241669, NULL, 'PTHR40940', NULL, NULL, NULL, NULL, '', NULL, NULL, 24935, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(241670, NULL, 'PTHR47920', NULL, NULL, NULL, NULL, 'PROTEIN CBG13378-RELATED', NULL, NULL, NULL, 8),
(241671, NULL, 'PTHR47077', NULL, NULL, NULL, NULL, 'ION_TRANS DOMAIN-CONTAINING PROTEIN', NULL, NULL, 23123, 8),
(241672, NULL, 'PTHR13723', NULL, NULL, NULL, NULL, 'ADAMTS  A DISINTEGRIN AND METALLOPROTEASE WITH THROMBOSPONDIN MOTIFS  PROTEASE', NULL, NULL, NULL, 8),
(241673, NULL, 'PTHR15093', NULL, NULL, NULL, NULL, 'PROSTATE APOPTOSIS RESPONSE PROTEIN PAR-4', NULL, NULL, 25720, 8),
(241674, NULL, 'PTHR46008', NULL, NULL, NULL, NULL, 'LEAF RUST 10 DISEASE-RESISTANCE LOCUS RECEPTOR-LIKE PROTEIN KINASE-LIKE 1.4', NULL, NULL, 35644, 8),
(241675, NULL, 'PTHR18444', NULL, NULL, NULL, NULL, 'UPF0538 FAMILY MEMBER', NULL, NULL, 19042, 8),
(241676, NULL, 'PTHR44414', NULL, NULL, NULL, NULL, 'PROTEIN NEDD1', NULL, NULL, NULL, 8),
(241677, NULL, 'PTHR42846', NULL, NULL, NULL, NULL, 'NI-SIROHYDROCHLORIN A,C-DIAMIDE REDUCTIVE CYCLASE COMPLEX, COMPONENT CFBD', NULL, NULL, NULL, 8),
(241678, NULL, 'PTHR31038', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', NULL, NULL, NULL, 8),
(241679, NULL, 'PTHR30614', NULL, NULL, NULL, NULL, 'MEMBRANE COMPONENT OF AMINO ACID ABC TRANSPORTER', NULL, NULL, 34871, 8),
(241680, NULL, 'PTHR33383', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN INSERTION EFFICIENCY FACTOR-RELATED', NULL, NULL, 3956, 8),
(241681, NULL, 'PTHR47419', NULL, NULL, NULL, NULL, 'DROMYOSUPPRESSIN RECEPTOR RELATED-RELATED', NULL, NULL, NULL, 8),
(241682, NULL, 'PTHR28067', NULL, NULL, NULL, NULL, 'DNA REPLICATION REGULATOR SLD3', NULL, NULL, 35141, 8),
(241683, NULL, 'PTHR13622', NULL, NULL, NULL, NULL, 'THIAMIN PYROPHOSPHOKINASE', NULL, NULL, NULL, 8),
(241684, NULL, 'PTHR10725', NULL, NULL, NULL, NULL, 'THAP DOMAIN-CONTAINING PROTEIN 9', NULL, NULL, NULL, 8),
(241685, NULL, 'PTHR32023', NULL, NULL, NULL, NULL, 'PILR ALPHA-ASSOCIATED NEURAL PROTEIN', NULL, NULL, 27436, 8),
(241686, NULL, 'PTHR21226', NULL, NULL, NULL, NULL, 'ABPA10-RELATED', NULL, NULL, 11090, 8),
(241687, NULL, 'PTHR31370', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN FAMILY-LIKE', NULL, NULL, 32286, 8),
(241688, NULL, 'PTHR43400', NULL, NULL, NULL, NULL, 'FUMARATE REDUCTASE', NULL, NULL, NULL, 8),
(241689, NULL, 'PTHR31589', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF239)-RELATED-RELATED', NULL, NULL, NULL, 8),
(241690, NULL, 'PTHR24083', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR', NULL, NULL, NULL, 8),
(241691, NULL, 'PTHR47957', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT HELICASE HRQ1', NULL, NULL, NULL, 8),
(241692, NULL, 'PTHR23058', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN PEX14', NULL, NULL, 24366, 8),
(241693, NULL, 'PTHR31573', NULL, NULL, NULL, NULL, 'ALPHA-KETOGLUTARATE-DEPENDENT DIOXYGENASE ALKB HOMOLOG 2', NULL, NULL, 22521, 8),
(241694, NULL, 'PTHR46896', NULL, NULL, NULL, NULL, 'SENTRIN-SPECIFIC PROTEASE', NULL, NULL, NULL, 8),
(241695, NULL, 'PTHR39662', NULL, NULL, NULL, NULL, '', NULL, NULL, 434, 8),
(241696, NULL, 'PTHR12315', NULL, NULL, NULL, NULL, 'BICOID-INTERACTING PROTEIN RELATED', NULL, NULL, 27211, 8),
(241697, NULL, 'PTHR43493', NULL, NULL, NULL, NULL, 'DNA GYRASE/TOPOISOMERASE SUBUNIT A', NULL, NULL, NULL, 8),
(241698, NULL, 'PTHR43731', NULL, NULL, NULL, NULL, 'RHOMBOID PROTEASE', NULL, NULL, NULL, 8),
(241699, NULL, 'PTHR13430', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 33048, 8),
(241700, NULL, 'PTHR47436', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE ATXR2', NULL, NULL, 34743, 8),
(241701, NULL, 'PTHR21012', NULL, NULL, NULL, NULL, 'ASPARTATE 1-DECARBOXYLASE', NULL, NULL, 1642, 8),
(241702, NULL, 'PTHR45180', NULL, NULL, NULL, NULL, 'OS01G0307686 PROTEIN', NULL, NULL, NULL, 8),
(241703, NULL, 'PTHR12542', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX PROTEIN EXO70', NULL, NULL, 2716, 8),
(241704, NULL, 'PTHR47524', NULL, NULL, NULL, NULL, '20S RRNA ACCUMULATION PROTEIN 4', NULL, NULL, NULL, 8),
(241705, NULL, 'PTHR12653', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE 13 KD-B SUBUNIT', NULL, NULL, 3963, 8),
(241706, NULL, 'PTHR24060', NULL, NULL, NULL, NULL, 'METABOTROPIC GLUTAMATE RECEPTOR', NULL, NULL, NULL, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(241707, NULL, 'PTHR36046', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(241708, NULL, 'PTHR15039', NULL, NULL, NULL, NULL, 'DOLICHOL PHOSPHATE-MANNOSE BIOSYNTHESIS REGULATORY PROTEIN', NULL, NULL, 14060, 8),
(241709, NULL, 'PTHR33960', NULL, NULL, NULL, NULL, 'SIMILAR TO KIAA0825 PROTEIN', NULL, NULL, 24872, 8),
(241710, NULL, 'PTHR10816', NULL, NULL, NULL, NULL, 'MYELIN TRANSCRIPTION FACTOR 1-RELATED', NULL, NULL, NULL, 8),
(241711, NULL, 'PTHR11092', NULL, NULL, NULL, NULL, 'SUGAR NUCLEOTIDE EPIMERASE RELATED', NULL, NULL, NULL, 8),
(241712, NULL, 'PTHR33404', NULL, NULL, NULL, NULL, 'CELL DIVISION TOPOLOGICAL SPECIFICITY FACTOR HOMOLOG, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(241713, NULL, 'PTHR11910', NULL, NULL, NULL, NULL, 'ATP SYNTHASE DELTA CHAIN', NULL, NULL, 3968, 8),
(241714, NULL, 'PTHR20661', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-GLYCAN BIOSYNTHESIS CLASS W PROTEIN', NULL, NULL, 8303, 8),
(241715, NULL, 'PTHR34053', NULL, NULL, NULL, NULL, 'PROTEIN ULTRAPETALA 1', NULL, NULL, 21247, 8),
(241716, NULL, 'PTHR31149', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(241717, NULL, 'PTHR46196', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH155-LIKE ISOFORM X1-RELATED', NULL, NULL, 35084, 8),
(241718, NULL, 'PTHR42692', NULL, NULL, NULL, NULL, 'NUCLEOTIDE PYROPHOSPHOHYDROLASE', NULL, NULL, NULL, 8),
(241719, NULL, 'PTHR37753', NULL, NULL, NULL, NULL, 'OS01G0940600 PROTEIN', NULL, NULL, NULL, 8),
(241720, NULL, 'PTHR22803', NULL, NULL, NULL, NULL, 'MANNOSE, PHOSPHOLIPASE, LECTIN RECEPTOR RELATED', NULL, NULL, NULL, 8),
(241721, NULL, 'PTHR47364', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR 5', NULL, NULL, NULL, 8),
(241722, NULL, 'PTHR24323', NULL, NULL, NULL, NULL, 'CEH-10 HOMEODOMAIN-CONTAINING HOMOLOG', NULL, NULL, NULL, 8),
(241723, NULL, 'PTHR16705', NULL, NULL, NULL, NULL, 'COMPLEXIN', NULL, NULL, 13850, 8),
(241724, NULL, 'PTHR42812', NULL, NULL, NULL, NULL, 'BETA-XYLOSIDASE', NULL, NULL, NULL, 8),
(241725, NULL, 'PTHR21577', NULL, NULL, NULL, NULL, 'SHUGOSHIN', NULL, NULL, 32173, 8),
(241726, NULL, 'PTHR33248', NULL, NULL, NULL, NULL, 'ZINC ION-BINDING PROTEIN', NULL, NULL, NULL, 8),
(241727, NULL, 'PTHR11247', NULL, NULL, NULL, NULL, 'PALMITOYL-PROTEIN THIOESTERASE/DOLICHYLDIPHOSPHATASE 1', NULL, NULL, NULL, 8),
(241728, NULL, 'PTHR47837', NULL, NULL, NULL, NULL, 'GTP PYROPHOSPHOKINASE YJBM', NULL, NULL, NULL, 8),
(241729, NULL, 'PTHR11374', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE DEHYDROGENASE/UDP-MANNAC DEHYDROGENASE', NULL, NULL, 26334, 8),
(241730, NULL, 'PTHR15741', NULL, NULL, NULL, NULL, 'BASIC HELIX-LOOP-HELIX ZIP TRANSCRIPTION FACTOR', NULL, NULL, NULL, 8),
(241731, NULL, 'PTHR31497', NULL, NULL, NULL, NULL, 'AUTOCRINE PROLIFERATION REPRESSOR PROTEIN A', NULL, NULL, 9989, 8),
(241732, NULL, 'PTHR24245', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR', NULL, NULL, NULL, 8),
(241733, NULL, 'PTHR30126', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR', NULL, NULL, NULL, 8),
(241734, NULL, 'PTHR43883', NULL, NULL, NULL, NULL, 'SLR0207 PROTEIN', NULL, NULL, NULL, 8),
(241735, NULL, 'PTHR10607', NULL, NULL, NULL, NULL, 'OSTEOPONTIN', NULL, NULL, 2211, 8),
(241736, NULL, 'PTHR13309', NULL, NULL, NULL, NULL, 'NUCLEAR FRAGILE X MENTAL RETARDATION PROTEIN INTERACTING PROTEIN 1', NULL, NULL, NULL, 8),
(241737, NULL, 'PTHR36437', NULL, NULL, NULL, NULL, 'GLYOXALASE/BLEOMYCIN RESISTANCE PROTEIN/DIOXYGENASE', NULL, NULL, NULL, 8),
(241738, NULL, 'PTHR11027', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN A-II', NULL, NULL, 3996, 8),
(241739, NULL, 'PTHR48146', NULL, NULL, NULL, NULL, 'K-STIMULATED PYROPHOSPHATE-ENERGIZED SODIUM PUMP PROTEIN', NULL, NULL, NULL, 8),
(241740, NULL, 'PTHR43384', NULL, NULL, NULL, NULL, 'SEPTUM SITE-DETERMINING PROTEIN MIND HOMOLOG, CHLOROPLASTIC-RELATED', NULL, NULL, NULL, 8),
(241741, NULL, 'PTHR47723', NULL, NULL, NULL, NULL, 'OS05G0353850 PROTEIN', NULL, NULL, NULL, 8),
(241742, NULL, 'PTHR34925', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(241743, NULL, 'PTHR10219', NULL, NULL, NULL, NULL, 'GLYCOLIPID TRANSFER PROTEIN-RELATED', NULL, NULL, NULL, 8);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(241744, NULL, 'PTHR46735', NULL, NULL, NULL, NULL, 'CALPAIN, SMALL SUBUNIT 1 A-RELATED', NULL, NULL, NULL, 8),
(241745, NULL, 'PTHR34347', NULL, NULL, NULL, NULL, 'DNA REPAIR-SCAFFOLDING PROTEIN SPIDR', NULL, NULL, NULL, 8),
(241746, NULL, 'PTHR15852', NULL, NULL, NULL, NULL, 'PLASTID TRANSCRIPTIONALLY ACTIVE PROTEIN', NULL, NULL, NULL, 8),
(241747, NULL, 'PTHR13620', NULL, NULL, NULL, NULL, '3-5 EXONUCLEASE', NULL, NULL, NULL, 8),
(241748, NULL, 'PTHR13459', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(241749, NULL, 'PTHR35023', NULL, NULL, NULL, NULL, 'CHELATASE-RELATED', NULL, NULL, NULL, 8),
(241750, NULL, 'PTHR23337', NULL, NULL, NULL, NULL, 'ZINC FINGER CW-TYPE COILED-COIL DOMAIN PROTEIN 1', NULL, NULL, NULL, 8),
(241751, NULL, 'PTHR39611', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(241752, NULL, 'PTHR10150', NULL, NULL, NULL, NULL, 'DNA REPAIR ENDONUCLEASE XPF', NULL, NULL, NULL, 8),
(241753, NULL, 'PTHR37167', NULL, NULL, NULL, NULL, '1,4-DIHYDROXY-6-NAPHTOATE SYNTHASE', NULL, NULL, 22622, 8),
(241754, NULL, 'PTHR38775', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', NULL, NULL, 9941, 8),
(241755, NULL, 'PTHR28398', NULL, NULL, NULL, NULL, 'SYNAPTONEMAL COMPLEX CENTRAL ELEMENT PROTEIN 2', NULL, NULL, 11450, 8),
(241756, NULL, 'PTHR46360', NULL, NULL, NULL, NULL, 'DISKS LARGE HOMOLOG 5', NULL, NULL, NULL, 8),
(241757, NULL, 'PTHR43377', NULL, NULL, NULL, NULL, 'BILIVERDIN REDUCTASE A', NULL, NULL, NULL, 8),
(241758, NULL, 'PTHR47981', NULL, NULL, NULL, NULL, 'RAB FAMILY', NULL, NULL, NULL, 8),
(241759, NULL, 'PTHR34665', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(241760, NULL, 'PTHR31545', NULL, NULL, NULL, NULL, 'SEEDY PROTEIN A/C FAMILY MEMBER', NULL, NULL, NULL, 8),
(241761, NULL, 'PTHR11795', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN AMINO ACID TRANSPORT SYSTEM PERMEASE PROTEIN LIVH', NULL, NULL, NULL, 8),
(241762, NULL, 'PTHR12475', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(241763, NULL, 'PTHR31544', NULL, NULL, NULL, NULL, 'AIG2-LIKE PROTEIN D', NULL, NULL, 35769, 8),
(241764, NULL, 'PTHR28376', NULL, NULL, NULL, NULL, 'RGD1562914', NULL, NULL, 32891, 8),
(241765, NULL, 'PTHR48198', NULL, NULL, NULL, NULL, 'EC PROTEIN HOMOLOG', NULL, NULL, NULL, 8),
(241766, NULL, 'PTHR37425', NULL, NULL, NULL, NULL, '', NULL, NULL, 7609, 8),
(241767, NULL, 'PTHR31183', NULL, NULL, NULL, NULL, 'TRICHOPLEIN KERATIN FILAMENT-BINDING PROTEIN FAMILY MEMBER', NULL, NULL, 35753, 8),
(241768, NULL, 'PTHR40891', NULL, NULL, NULL, NULL, 'DUF295 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(241769, NULL, 'PTHR37880', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 54', NULL, NULL, 32146, 8),
(241770, NULL, 'PTHR11063', NULL, NULL, NULL, NULL, 'GLUTAMATE SEMIALDEHYDE DEHYDROGENASE', NULL, NULL, NULL, 8),
(241771, NULL, 'PTHR40137', NULL, NULL, NULL, NULL, 'PROTEIN GVPK 1', NULL, NULL, 2092, 8),
(241772, NULL, 'PTHR31912', NULL, NULL, NULL, NULL, 'IP13529P', NULL, NULL, NULL, 8),
(241773, NULL, 'PTHR13667', NULL, NULL, NULL, NULL, 'HOMOLOC-13', NULL, NULL, 24607, 8),
(241774, NULL, 'PTHR14037', NULL, NULL, NULL, NULL, 'MAMMAGLOBIN-RELATED', NULL, NULL, NULL, 8),
(241775, NULL, 'PTHR11556', NULL, NULL, NULL, NULL, 'FRUCTOSE-1,6-BISPHOSPHATASE-RELATED', NULL, NULL, 3945, 8),
(241776, NULL, 'PTHR13865', NULL, NULL, NULL, NULL, 'TIGHT JUNCTION PROTEIN', NULL, NULL, NULL, 8),
(241777, NULL, 'PTHR34846', NULL, NULL, NULL, NULL, '4-CARBOXYMUCONOLACTONE DECARBOXYLASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_6G11590)', NULL, NULL, NULL, 8),
(241778, NULL, 'PTHR45708', NULL, NULL, NULL, NULL, 'ENDOCHITINASE', NULL, NULL, NULL, 8),
(241779, NULL, 'PTHR38689', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE HYDROPHOBIC MEMBRANE ANCHOR SUBUNIT', NULL, NULL, 9937, 8),
(241780, NULL, 'PTHR45971', NULL, NULL, NULL, NULL, 'PHOX (PX) DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(241781, NULL, 'PTHR30557', NULL, NULL, NULL, NULL, 'THIAMINE BIOSYNTHESIS PROTEIN THIC', NULL, NULL, 4807, 8),
(241782, NULL, 'PTHR10505', NULL, NULL, NULL, NULL, 'CALCITONIN-RELATED', NULL, NULL, 17332, 8);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(241783, NULL, 'PTHR11834', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ENHANCER FACTOR  TEF  RELATED', NULL, NULL, NULL, 8),
(241784, NULL, 'PTHR10075', NULL, NULL, NULL, NULL, 'BASIGIN RELATED', NULL, NULL, 34723, 8),
(241785, NULL, 'PTHR36507', NULL, NULL, NULL, NULL, 'BLL1555 PROTEIN', NULL, NULL, NULL, 8),
(241786, NULL, 'PTHR14025', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA GROUP M FANCM FAMILY MEMBER', NULL, NULL, NULL, 8),
(241787, NULL, 'PTHR14064', NULL, NULL, NULL, NULL, 'CHONDROMODULIN-RELATED', NULL, NULL, 33646, 8),
(241788, NULL, 'PTHR42854', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 2 SUBUNIT 3 FAMILY MEMBER', NULL, NULL, NULL, 8),
(241789, NULL, 'PTHR11193', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN E', NULL, NULL, 25667, 8),
(241790, NULL, 'PTHR14678', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 27161, 8),
(241791, NULL, 'PTHR22538', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(241792, NULL, 'PTHR31620', NULL, NULL, NULL, NULL, 'PROTEIN RETICULATA-RELATED 2, CHLOROPLASTIC-RELATED', NULL, NULL, NULL, 8),
(241793, NULL, 'PTHR36680', NULL, NULL, NULL, NULL, 'HYPOTHETICAL LOC498675', NULL, NULL, 26446, 8),
(241794, NULL, 'PTHR11624', NULL, NULL, NULL, NULL, 'DEHYDROGENASE RELATED', NULL, NULL, 22608, 8),
(241795, NULL, 'PTHR39605', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(241796, NULL, 'PTHR47449', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHODIESTER PHOSPHODIESTERASE GDPD4', NULL, NULL, 36370, 8),
(241797, NULL, 'PTHR11977', NULL, NULL, NULL, NULL, 'VILLIN', NULL, NULL, 315, 8),
(241798, NULL, 'PTHR33875', NULL, NULL, NULL, NULL, 'OS09G0542200 PROTEIN', NULL, NULL, NULL, 8),
(241799, NULL, 'PTHR37469', NULL, NULL, NULL, NULL, 'CELLOBIONIC ACID PHOSPHORYLASE-RELATED', NULL, NULL, NULL, 8),
(241800, NULL, 'PTHR14156', NULL, NULL, NULL, NULL, 'MOTILIN', NULL, NULL, 17937, 8),
(241801, NULL, 'PTHR35281', NULL, NULL, NULL, NULL, 'BNAA02G34170D PROTEIN', NULL, NULL, NULL, 8),
(241802, NULL, 'PTHR47936', NULL, NULL, NULL, NULL, 'PPR_LONG DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(241803, NULL, 'PTHR11999', NULL, NULL, NULL, NULL, 'GROUP II PYRIDOXAL-5-PHOSPHATE DECARBOXYLASE', NULL, NULL, NULL, 8),
(241804, NULL, 'PTHR13005', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH HYDROPHOBIC DOMAIN PROTEIN  BRAIN X-LINKED PROTEIN', NULL, NULL, 32107, 8),
(241805, NULL, 'PTHR43352', NULL, NULL, NULL, NULL, 'ACETYL-COA SYNTHETASE', NULL, NULL, NULL, 8),
(241806, NULL, 'PTHR46828', NULL, NULL, NULL, NULL, 'ENDO-1,4-BETA-XYLANASE A-RELATED', NULL, NULL, NULL, 8),
(241807, NULL, 'PTHR35120', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE KAT6B-LIKE', NULL, NULL, NULL, 8),
(241808, NULL, 'PTHR15730', NULL, NULL, NULL, NULL, 'EXPERIMENTAL AUTOIMMUNE PROSTATITIS ANTIGEN 2-RELATED', NULL, NULL, NULL, 8),
(241809, NULL, 'PTHR34670', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(241810, NULL, 'PTHR43459', NULL, NULL, NULL, NULL, 'ENOYL-COA HYDRATASE', NULL, NULL, NULL, 8),
(241811, NULL, 'PTHR10992', NULL, NULL, NULL, NULL, 'METHYLESTERASE FAMILY MEMBER', NULL, NULL, 33731, 8),
(241812, NULL, 'PTHR13105', NULL, NULL, NULL, NULL, 'MYELOID LEUKEMIA FACTOR', NULL, NULL, 15893, 8),
(241813, NULL, 'PTHR31210', NULL, NULL, NULL, NULL, 'OS06G0731900 PROTEIN', NULL, NULL, 3228, 8),
(241814, NULL, 'PTHR24331', NULL, NULL, NULL, NULL, 'DBX', NULL, NULL, NULL, 8),
(241815, NULL, 'PTHR38425', NULL, NULL, NULL, NULL, 'LONG CHRONOLOGICAL LIFESPAN PROTEIN 2', NULL, NULL, 17770, 8),
(241816, NULL, 'PTHR46086', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', NULL, NULL, 33532, 8),
(241817, NULL, 'PTHR19211', NULL, NULL, NULL, NULL, 'ATP-BINDING TRANSPORT PROTEIN-RELATED', NULL, NULL, NULL, 8),
(241818, NULL, 'PTHR13206', NULL, NULL, NULL, NULL, 'UBIQUITIN LIGASE PROTEIN PHF9  FANCONI ANEMIA GROUP L PROTEIN', NULL, NULL, 24627, 8),
(241819, NULL, 'PTHR46341', NULL, NULL, NULL, NULL, 'PROTEIN FAM84B-RELATED', NULL, NULL, 36380, 8),
(241820, NULL, 'PTHR36769', NULL, NULL, NULL, NULL, '2,3-BISPHOSPHOGLYCERATE-DEPENDENT PHOSPHOGLYCERATE MUTASE', NULL, NULL, NULL, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(241821, NULL, 'PTHR31605', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE O-ACYLTRANSFERASE 1', NULL, NULL, NULL, 8),
(241822, NULL, 'PTHR45665', NULL, NULL, NULL, NULL, 'AQUAPORIN-8', NULL, NULL, 24028, 8),
(241823, NULL, 'PTHR28553', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE B', NULL, NULL, 8721, 8),
(241824, NULL, 'PTHR43813', NULL, NULL, NULL, NULL, 'ACYL-ACTIVATING ENZYME 16, CHLOROPLASTIC-RELATED', NULL, NULL, NULL, 8),
(241825, NULL, 'PTHR24210', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING PROTEIN', NULL, NULL, 17037, 8),
(241826, NULL, 'PTHR13077', NULL, NULL, NULL, NULL, 'SELENOPROTEIN F', NULL, NULL, 30173, 8),
(241827, NULL, 'PTHR36757', NULL, NULL, NULL, NULL, 'BNAANNG22500D PROTEIN', NULL, NULL, NULL, 8),
(241828, NULL, 'PTHR44889', NULL, NULL, NULL, NULL, 'INACTIVE HYDROXYSTEROID DEHYDROGENASE-LIKE PROTEIN 1', NULL, NULL, NULL, 8),
(241829, NULL, 'PTHR34439', NULL, NULL, NULL, NULL, 'CENTROBIN', NULL, NULL, 33855, 8),
(241830, NULL, 'PTHR48011', NULL, NULL, NULL, NULL, 'CCR4-NOT TRANSCRIPTIONAL COMPLEX SUBUNIT CAF120-RELATED', NULL, NULL, NULL, 8),
(241831, NULL, 'PTHR37310', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', NULL, NULL, NULL, 8),
(241832, NULL, 'PTHR43376', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORT SYSTEM PERMEASE PROTEIN', NULL, NULL, NULL, 8),
(241833, NULL, 'PTHR12489', NULL, NULL, NULL, NULL, 'LIPOMA HMGIC FUSION PARTNER-LIKE PROTEIN', NULL, NULL, 15529, 8),
(241834, NULL, 'PTHR47466', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(241835, NULL, 'PTHR33844', NULL, NULL, NULL, NULL, 'SULFOTRANSFER_1 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(241836, NULL, 'PTHR43394', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT PERMEASE MDL1, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(241837, NULL, 'PTHR34648', NULL, NULL, NULL, NULL, 'CLOCK-INTERACTING PACEMAKER', NULL, NULL, 25185, 8),
(241838, NULL, 'PTHR42733', NULL, NULL, NULL, NULL, 'DJ-1 PROTEIN', NULL, NULL, 3765, 8),
(241839, NULL, 'PTHR46553', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(241840, NULL, 'PTHR10371', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE  UBIQUINONE  FLAVOPROTEIN 2, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(241841, NULL, 'PTHR20923', NULL, NULL, NULL, NULL, 'BAT4 PROTEIN-RELATED', NULL, NULL, 32889, 8),
(241842, NULL, 'PTHR12521', NULL, NULL, NULL, NULL, 'PROTEIN C6ORF130', NULL, NULL, NULL, 8),
(241843, NULL, 'PTHR13129', NULL, NULL, NULL, NULL, 'VPRBP PROTEIN-RELATED', NULL, NULL, 28124, 8),
(241844, NULL, 'PTHR38648', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4930451I11 GENE', NULL, NULL, 32942, 8),
(241845, NULL, 'PTHR12782', NULL, NULL, NULL, NULL, 'MICROSOMAL PROSTAGLANDIN E SYNTHASE-2', NULL, NULL, NULL, 8),
(241846, NULL, 'PTHR22234', NULL, NULL, NULL, NULL, 'TESTIS SPERMATOCYTE APOPTOSIS-RELATED GENE 1 PROTEIN', NULL, NULL, 21851, 8),
(241847, NULL, 'PTHR15081', NULL, NULL, NULL, NULL, 'NUCLEAR AUTOANTIGENIC SPERM PROTEIN  NASP -RELATED', NULL, NULL, NULL, 8),
(241848, NULL, 'PTHR28158', NULL, NULL, NULL, NULL, '37S RIBOSOMAL PROTEIN S35, MITOCHONDRIAL', NULL, NULL, 15009, 8),
(241849, NULL, 'PTHR33431', NULL, NULL, NULL, NULL, 'ENABLED-LIKE PROTEIN (DUF1635)', NULL, NULL, 12296, 8),
(241850, NULL, 'PTHR15641', NULL, NULL, NULL, NULL, 'ELONGATOR COMPLEX PROTEIN 5', NULL, NULL, 18250, 8),
(241851, NULL, 'PTHR28594', NULL, NULL, NULL, NULL, 'ATR-INTERACTING PROTEIN', NULL, NULL, 28453, 8),
(241852, NULL, 'PTHR12841', NULL, NULL, NULL, NULL, 'PROTEIN UNC-50 HOMOLOG', NULL, NULL, 3346, 8),
(241853, NULL, 'PTHR42920', NULL, NULL, NULL, NULL, 'OS03G0707200 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(241854, NULL, 'PTHR31916', NULL, NULL, NULL, NULL, '', NULL, NULL, 19204, 8),
(241855, NULL, 'PTHR14725', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 32783, 8),
(241856, NULL, 'PTHR10517', NULL, NULL, NULL, NULL, 'FOLATE RECEPTOR', NULL, NULL, 3558, 8),
(241857, NULL, 'PTHR34341', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 107', NULL, NULL, 26941, 8),
(241858, NULL, 'PTHR37969', NULL, NULL, NULL, NULL, 'PROTEIN CBG07421-RELATED', NULL, NULL, NULL, 8);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(241859, NULL, 'PTHR28607', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, 10009, 8),
(241860, NULL, 'PTHR36773', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(241861, NULL, 'PTHR36781', NULL, NULL, NULL, NULL, 'OS05G0114600 PROTEIN', NULL, NULL, NULL, 8),
(241862, NULL, 'PTHR33086', NULL, NULL, NULL, NULL, 'OS05G0468200 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(241863, NULL, 'PTHR37751', NULL, NULL, NULL, NULL, 'LOW PROTEIN: M-PHASE INDUCER PHOSPHATASE-LIKE PROTEIN', NULL, NULL, NULL, 8),
(241864, NULL, 'PTHR44372', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-GAMMA 1-RELATED', NULL, NULL, 35085, 8),
(241865, NULL, 'PTHR34959', NULL, NULL, NULL, NULL, 'PROTEIN LAZY 1', NULL, NULL, 31236, 8),
(241866, NULL, 'PTHR12390', NULL, NULL, NULL, NULL, 'UROPORPHYRINOGEN III SYNTHASE', NULL, NULL, 31427, 8),
(241867, NULL, 'PTHR12830', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT 5', NULL, NULL, 27970, 8),
(241868, NULL, 'PTHR13218', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 11-RELATED', NULL, NULL, 36999, 8),
(241869, NULL, 'PTHR13774', NULL, NULL, NULL, NULL, 'PHENAZINE BIOSYNTHESIS PROTEIN', NULL, NULL, 2059, 8),
(241870, NULL, 'PTHR15670', NULL, NULL, NULL, NULL, 'RHO GTPASE ACTIVATING PROTEIN 11A', NULL, NULL, 35984, 8),
(241871, NULL, 'PTHR10121', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT DELTA', NULL, NULL, 24886, 8),
(241872, NULL, 'PTHR30399', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN YGJP', NULL, NULL, NULL, 8),
(241873, NULL, 'PTHR12389', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 294', NULL, NULL, 31319, 8),
(241874, NULL, 'PTHR46629', NULL, NULL, NULL, NULL, 'OS01G0917900 PROTEIN', NULL, NULL, NULL, 8),
(241875, NULL, 'PTHR23420', NULL, NULL, NULL, NULL, 'ADENOSYLHOMOCYSTEINASE', NULL, NULL, 3741, 8),
(241876, NULL, 'PTHR33696', NULL, NULL, NULL, NULL, 'T22J18.15-RELATED', NULL, NULL, NULL, 8),
(241877, NULL, 'PTHR14143', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCIBLE GTPASE FAMILY MEMBER', NULL, NULL, NULL, 8),
(241878, NULL, 'PTHR31641', NULL, NULL, NULL, NULL, 'RENAL CANCER DIFFERENTIATION GENE 1 PROTEIN', NULL, NULL, 26086, 8),
(241879, NULL, 'PTHR43899', NULL, NULL, NULL, NULL, 'RH59310P', NULL, NULL, NULL, 8),
(241880, NULL, 'PTHR44154', NULL, NULL, NULL, NULL, 'QUINONE OXIDOREDUCTASE', NULL, NULL, NULL, 8),
(241881, NULL, 'PTHR45679', NULL, NULL, NULL, NULL, 'ER DEGRADATION-ENHANCING ALPHA-MANNOSIDASE-LIKE PROTEIN 2', NULL, NULL, 34096, 8),
(241882, NULL, 'PTHR47011', NULL, NULL, NULL, NULL, 'CD226 ANTIGEN', NULL, NULL, 35242, 8),
(241883, NULL, 'PTHR33167', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR, PUTATIVE (DUF863)-RELATED', NULL, NULL, NULL, 8),
(241884, NULL, 'PTHR46140', NULL, NULL, NULL, NULL, 'VACUOLAR TRANSPORTER CHAPERONE 1-RELATED', NULL, NULL, NULL, 8),
(241885, NULL, 'PTHR31181', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(241886, NULL, 'PTHR48312', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(241887, NULL, 'PTHR15335', NULL, NULL, NULL, NULL, 'PROTEIN TFG', NULL, NULL, 29491, 8),
(241888, NULL, 'PTHR10715', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L6', NULL, NULL, 3066, 8),
(241889, NULL, 'PTHR32125', NULL, NULL, NULL, NULL, '2-C-METHYL-D-ERYTHRITOL 4-PHOSPHATE CYTIDYLYLTRANSFERASE, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(241890, NULL, 'PTHR12734', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE-RELATED', NULL, NULL, 27106, 8),
(241891, NULL, 'PTHR28258', NULL, NULL, NULL, NULL, 'VACUOLAR SEGREGATION PROTEIN 7', NULL, NULL, 12155, 8),
(241892, NULL, 'PTHR48253', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(241893, NULL, 'PTHR34687', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ-LIKE PROTEIN', NULL, NULL, NULL, 8),
(241894, NULL, 'PTHR31941', NULL, NULL, NULL, NULL, 'CYTOSKELETAL SIGNALING PROTEIN SLM1', NULL, NULL, NULL, 8),
(241895, NULL, 'PTHR15496', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR 3C POLYPEPTIDE 4 FAMILY', NULL, NULL, 34616, 8),
(241896, NULL, 'PTHR42250', NULL, NULL, NULL, NULL, 'ASCH DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(241897, NULL, 'PTHR46667', NULL, NULL, NULL, NULL, 'OS05G0182700 PROTEIN', NULL, NULL, NULL, 8),
(241898, NULL, 'PTHR44936', NULL, NULL, NULL, NULL, 'SENSOR PROTEIN CREC', NULL, NULL, NULL, 8),
(241899, NULL, 'PTHR23505', NULL, NULL, NULL, NULL, 'SPINSTER', NULL, NULL, 34140, 8),
(241900, NULL, 'PTHR36893', NULL, NULL, NULL, NULL, 'OS01G0275950 PROTEIN', NULL, NULL, NULL, 8),
(241901, NULL, 'PTHR10078', NULL, NULL, NULL, NULL, 'INTERLEUKIN-1 FAMILY MEMBER', NULL, NULL, 3267, 8),
(241902, NULL, 'PTHR12463', NULL, NULL, NULL, NULL, 'OXYGENASE-RELATED', NULL, NULL, 23605, 8),
(241903, NULL, 'PTHR46425', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR RHO', NULL, NULL, 2943, 8),
(241904, NULL, 'PTHR35842', NULL, NULL, NULL, NULL, 'SI:CH211-67E16.11', NULL, NULL, NULL, 8),
(241905, NULL, 'PTHR37492', NULL, NULL, NULL, NULL, 'SI:CH211-171H4.7-RELATED', NULL, NULL, NULL, 8),
(241906, NULL, 'PTHR46587', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', NULL, NULL, NULL, 8),
(241907, NULL, 'PTHR31736', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(241908, NULL, 'PTHR15481', NULL, NULL, NULL, NULL, 'RIBONUCLEIC ACID BINDING PROTEIN S1', NULL, NULL, NULL, 8),
(241909, NULL, 'PTHR31816', NULL, NULL, NULL, NULL, 'MICOS COMPLEX SUBUNIT MIC13', NULL, NULL, 24093, 8),
(241910, NULL, 'PTHR44094', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK N-TERMINAL DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(241911, NULL, 'PTHR34039', NULL, NULL, NULL, NULL, 'UPF0102 PROTEIN YRAN', NULL, NULL, 6225, 8),
(241912, NULL, 'PTHR36473', NULL, NULL, NULL, NULL, 'CHROMOSOME 3 OPEN READING FRAME 49', NULL, NULL, NULL, 8),
(241913, NULL, 'PTHR15296', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED PROTEIN MAP17', NULL, NULL, 25865, 8),
(241914, NULL, 'PTHR43404', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE CHOLINEPHOSPHOTRANSFERASE LICD', NULL, NULL, NULL, 8),
(241915, NULL, 'PTHR21557', NULL, NULL, NULL, NULL, 'CORDON-BLEU', NULL, NULL, 32223, 8),
(241916, NULL, 'PTHR39203', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', NULL, NULL, 14245, 8),
(241917, NULL, 'PTHR31415', NULL, NULL, NULL, NULL, 'OS05G0367900 PROTEIN', NULL, NULL, 36040, 8),
(241918, NULL, 'PTHR10177', NULL, NULL, NULL, NULL, 'CYCLINS', NULL, NULL, 33273, 8),
(241919, NULL, 'PTHR23358', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 27098, 8),
(241920, NULL, 'PTHR23409', NULL, NULL, NULL, NULL, 'RIBONUCLEOSIDE-DIPHOSPHATE REDUCTASE SMALL CHAIN', NULL, NULL, 120, 8),
(241921, NULL, 'PTHR32309', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', NULL, NULL, NULL, 8),
(241922, NULL, 'PTHR18929', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE ISOMERASE', NULL, NULL, NULL, 8),
(241923, NULL, 'PTHR46120', NULL, NULL, NULL, NULL, 'BETAINE--HOMOCYSTEINE S-METHYLTRANSFERASE 1', NULL, NULL, NULL, 8),
(241924, NULL, 'PTHR16064', NULL, NULL, NULL, NULL, 'BTB  POZ  DOMAIN CONTAINING 7', NULL, NULL, 36381, 8),
(241925, NULL, 'PTHR15151', NULL, NULL, NULL, NULL, 'PROTEIN EIGER', NULL, NULL, NULL, 8),
(241926, NULL, 'PTHR37815', NULL, NULL, NULL, NULL, 'UPF0397 PROTEIN BC_2624-RELATED', NULL, NULL, NULL, 8),
(241927, NULL, 'PTHR46578', NULL, NULL, NULL, NULL, 'ARM-REPEAT/TETRATRICOPEPTIDE REPEAT (TPR)-LIKE PROTEIN', NULL, NULL, NULL, 8),
(241928, NULL, 'PTHR24139', NULL, NULL, NULL, NULL, 'CALCIUM-INDEPENDENT PHOSPHOLIPASE A2', NULL, NULL, NULL, 8),
(241929, NULL, 'PTHR15720', NULL, NULL, NULL, NULL, 'GREB1-RELATED', NULL, NULL, 21955, 8),
(241930, NULL, 'PTHR46858', NULL, NULL, NULL, NULL, 'OS05G0521000 PROTEIN', NULL, NULL, NULL, 8),
(241931, NULL, 'PTHR43351', NULL, NULL, NULL, NULL, 'L(+)-TARTRATE DEHYDRATASE SUBUNIT BETA', NULL, NULL, NULL, 8),
(241932, NULL, 'PTHR39113', NULL, NULL, NULL, NULL, 'MEMBRANE LIPOPROTEIN-RELATED', NULL, NULL, NULL, 8),
(241933, NULL, 'PTHR33916', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(241934, NULL, 'PTHR13164', NULL, NULL, NULL, NULL, 'CALICYLIN BINDING PROTEIN', NULL, NULL, NULL, 8),
(241935, NULL, 'PTHR10533', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE Y/PANCREATIC HORMONE/PEPTIDE YY', NULL, NULL, 2149, 8);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(241936, NULL, 'PTHR28436', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM5 HOMOLOG', NULL, NULL, 21920, 8),
(241937, NULL, 'PTHR18874', NULL, NULL, NULL, NULL, 'CMF/LEK/CENP CELL DIVISION-RELATED', NULL, NULL, 34600, 8),
(241938, NULL, 'PTHR46606', NULL, NULL, NULL, NULL, 'SHOOTIN-1', NULL, NULL, 22202, 8),
(241939, NULL, 'PTHR11550', NULL, NULL, NULL, NULL, 'CTP SYNTHASE', NULL, NULL, 7211, 8),
(241940, NULL, 'PTHR10894', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 5  NUCLEOLAR PROTEIN NOP5  NOP58', NULL, NULL, 34085, 8),
(241941, NULL, 'PTHR33137', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 15A-RELATED', NULL, NULL, 35155, 8),
(241942, NULL, 'PTHR33699', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(241943, NULL, 'PTHR30559', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE CLASS 2', NULL, NULL, 5608, 8),
(241944, NULL, 'PTHR34773', NULL, NULL, NULL, NULL, 'FLAGELLAR SECRETION CHAPERONE FLIS', NULL, NULL, 2413, 8),
(241945, NULL, 'PTHR35667', NULL, NULL, NULL, NULL, 'LEUKEMIA NUP98 FUSION PARTNER 1', NULL, NULL, 26319, 8),
(241946, NULL, 'PTHR43625', NULL, NULL, NULL, NULL, 'AFLATOXIN B1 ALDEHYDE REDUCTASE', NULL, NULL, NULL, 8),
(241947, NULL, 'PTHR47071', NULL, NULL, NULL, NULL, 'PROTEIN TRM32', NULL, NULL, 33655, 8),
(241948, NULL, 'PTHR13154', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN-INTERACTING PROTEIN 2', NULL, NULL, 27767, 8),
(241949, NULL, 'PTHR13144', NULL, NULL, NULL, NULL, 'TEX261 PROTEIN', NULL, NULL, 7246, 8),
(241950, NULL, 'PTHR45286', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(241951, NULL, 'PTHR22089', NULL, NULL, NULL, NULL, 'MIRROR-IMAGE POLYDACTYLY GENE 1 PROTEIN', NULL, NULL, 25097, 8),
(241952, NULL, 'PTHR35467', NULL, NULL, NULL, NULL, '', NULL, NULL, 29380, 8),
(241953, NULL, 'PTHR31334', NULL, NULL, NULL, NULL, 'SMITH-MAGENIS SYNDROME REGION GENE 8 PROTEIN', NULL, NULL, NULL, 8),
(241954, NULL, 'PTHR15010', NULL, NULL, NULL, NULL, 'ACYLOXYACYL HYDROLASE', NULL, NULL, 33317, 8),
(241955, NULL, 'PTHR10740', NULL, NULL, NULL, NULL, 'TRANSFORMING GROWTH FACTOR ALPHA', NULL, NULL, NULL, 8),
(241956, NULL, 'PTHR11256', NULL, NULL, NULL, NULL, 'BCL-2 RELATED', NULL, NULL, 21508, 8),
(241957, NULL, 'PTHR47985', NULL, NULL, NULL, NULL, 'OS07G0668900 PROTEIN', NULL, NULL, NULL, 8),
(241958, NULL, 'PTHR47727', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 9 MEMBER A', NULL, NULL, 34569, 8),
(241959, NULL, 'PTHR15727', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 214', NULL, NULL, NULL, 8),
(241960, NULL, 'PTHR31927', NULL, NULL, NULL, NULL, 'FI07246P-RELATED-RELATED', NULL, NULL, NULL, 8),
(241961, NULL, 'PTHR39327', NULL, NULL, NULL, NULL, '', NULL, NULL, 8870, 8),
(241962, NULL, 'PTHR43479', NULL, NULL, NULL, NULL, 'ACREF/ENVCD OPERON REPRESSOR-RELATED', NULL, NULL, NULL, 8),
(241963, NULL, 'PTHR36845', NULL, NULL, NULL, NULL, 'HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G05090)-RELATED', NULL, NULL, NULL, 8),
(241964, NULL, 'PTHR39614', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(241965, NULL, 'PTHR22963', NULL, NULL, NULL, NULL, 'ENDOGLIN-RELATED', NULL, NULL, NULL, 8),
(241966, NULL, 'PTHR46545', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 51', NULL, NULL, 34963, 8),
(241967, NULL, 'PTHR46907', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN BETA-7-RELATED', NULL, NULL, NULL, 8),
(241968, NULL, 'PTHR13167', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 24685, 8),
(241969, NULL, 'PTHR46861', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 1A', NULL, NULL, NULL, 8),
(241970, NULL, 'PTHR45463', NULL, NULL, NULL, NULL, 'OS09G0392200 PROTEIN', NULL, NULL, 36330, 8),
(241971, NULL, 'PTHR33172', NULL, NULL, NULL, NULL, 'OS08G0516900 PROTEIN', NULL, NULL, NULL, 8),
(241972, NULL, 'PTHR19143', NULL, NULL, NULL, NULL, 'FIBRINOGEN/TENASCIN/ANGIOPOEITIN', NULL, NULL, NULL, 8),
(241973, NULL, 'PTHR11710', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S19', NULL, NULL, 187, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(241974, NULL, 'PTHR46826', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(241975, NULL, 'PTHR30381', NULL, NULL, NULL, NULL, 'FLAGELLAR P-RING PERIPLASMIC PROTEIN FLGI', NULL, NULL, 3457, 8),
(241976, NULL, 'PTHR13003', NULL, NULL, NULL, NULL, 'NUP107-RELATED', NULL, NULL, 6667, 8),
(241977, NULL, 'PTHR47767', NULL, NULL, NULL, NULL, 'ADHESION G PROTEIN-COUPLED RECEPTOR G7', NULL, NULL, NULL, 8),
(241978, NULL, 'PTHR10739', NULL, NULL, NULL, NULL, 'CYTIDYLYLTRANSFERASE', NULL, NULL, 34989, 8),
(241979, NULL, 'PTHR34295', NULL, NULL, NULL, NULL, 'BIOTIN TRANSPORTER BIOY', NULL, NULL, 3487, 8),
(241980, NULL, 'PTHR36004', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN PROTEIN', NULL, NULL, NULL, 8),
(241981, NULL, 'PTHR36576', NULL, NULL, NULL, NULL, 'UPF0654 PROTEIN C11D3.01C-RELATED', NULL, NULL, NULL, 8),
(241982, NULL, 'PTHR44575', NULL, NULL, NULL, NULL, 'OS01G0589200 PROTEIN', NULL, NULL, NULL, 8),
(241983, NULL, 'PTHR35481', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT ALPHA', NULL, NULL, NULL, 8),
(241984, NULL, 'PTHR31354', NULL, NULL, NULL, NULL, 'OS01G0793500 PROTEIN', NULL, NULL, NULL, 8),
(241985, NULL, 'PTHR43283', NULL, NULL, NULL, NULL, 'BETA-LACTAMASE-RELATED', NULL, NULL, NULL, 8),
(241986, NULL, 'PTHR36234', NULL, NULL, NULL, NULL, 'LYSYL ENDOPEPTIDASE', NULL, NULL, NULL, 8),
(241987, NULL, 'PTHR16509', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(241988, NULL, 'PTHR22921', NULL, NULL, NULL, NULL, 'PROTEIN CBG20088-RELATED', NULL, NULL, NULL, 8),
(241989, NULL, 'PTHR43534', NULL, NULL, NULL, NULL, 'MIND SUPERFAMILY P-LOOP ATPASE CONTAINING AN INSERTED FERREDOXIN DOMAIN', NULL, NULL, NULL, 8),
(241990, NULL, 'PTHR21508', NULL, NULL, NULL, NULL, 'MITOGUARDIN', NULL, NULL, 15894, 8),
(241991, NULL, 'PTHR36121', NULL, NULL, NULL, NULL, 'PROTEIN SXY', NULL, NULL, NULL, 8),
(241992, NULL, 'PTHR46449', NULL, NULL, NULL, NULL, 'ZGC:158260', NULL, NULL, 21541, 8),
(241993, NULL, 'PTHR43152', NULL, NULL, NULL, NULL, 'UVRABC SYSTEM PROTEIN A', NULL, NULL, NULL, 8),
(241994, NULL, 'PTHR45739', NULL, NULL, NULL, NULL, 'MATRIX PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(241995, NULL, 'PTHR17085', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR COACTIVATOR 4', NULL, NULL, 28888, 8),
(241996, NULL, 'PTHR11035', NULL, NULL, NULL, NULL, 'VERY-LONG-CHAIN (3R)-3-HYDROXYACYL-COA DEHYDRATASE', NULL, NULL, 10293, 8),
(241997, NULL, 'PTHR48224', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 270-RELATED', NULL, NULL, NULL, 8),
(241998, NULL, 'PTHR24120', NULL, NULL, NULL, NULL, 'GH07239P', NULL, NULL, NULL, 8),
(241999, NULL, 'PTHR31807', NULL, NULL, NULL, NULL, 'AUGMIN FAMILY MEMBER', NULL, NULL, NULL, 8),
(242000, NULL, 'PTHR14562', NULL, NULL, NULL, NULL, 'TATA BOX-BINDING PROTEIN ASSOCIATED FACTOR RNA POLYMERASE I SUBUNIT D', NULL, NULL, 25053, 8),
(242001, NULL, 'PTHR13317', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 5314, 8),
(242002, NULL, 'PTHR35703', NULL, NULL, NULL, NULL, 'HEME OXYGENASE 1, CHLOROPLASTIC-RELATED', NULL, NULL, 17828, 8),
(242003, NULL, 'PTHR35631', NULL, NULL, NULL, NULL, 'OS08G0114150 PROTEIN', NULL, NULL, NULL, 8),
(242004, NULL, 'PTHR46548', NULL, NULL, NULL, NULL, 'BAH AND TFIIS DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(242005, NULL, 'PTHR28586', NULL, NULL, NULL, NULL, 'PROTEIN PAXX', NULL, NULL, 25509, 8),
(242006, NULL, 'PTHR34071', NULL, NULL, NULL, NULL, '5-NITROIMIDAZOLE ANTIBIOTICS RESISTANCE PROTEIN, NIMA-FAMILY-RELATED PROTEIN-RELATED', NULL, NULL, NULL, 8),
(242007, NULL, 'PTHR18901', NULL, NULL, NULL, NULL, '2-DEOXYGLUCOSE-6-PHOSPHATE PHOSPHATASE 2', NULL, NULL, NULL, 8),
(242008, NULL, 'PTHR47157', NULL, NULL, NULL, NULL, 'CHROMODOMAIN-HELICASE-DNA-BINDING PROTEIN 1-LIKE', NULL, NULL, 26225, 8),
(242009, NULL, 'PTHR31051', NULL, NULL, NULL, NULL, 'PROTEASOME ASSEMBLY CHAPERONE 3', NULL, NULL, 19112, 8),
(242010, NULL, 'PTHR10224', NULL, NULL, NULL, NULL, 'ES1 PROTEIN HOMOLOG, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(242011, NULL, 'PTHR44688', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(242012, NULL, 'PTHR46499', NULL, NULL, NULL, NULL, 'QUEUINE TRNA-RIBOSYLTRANSFERASE', NULL, NULL, NULL, 8),
(242013, NULL, 'PTHR34967', NULL, NULL, NULL, NULL, 'OS02G0257200 PROTEIN', NULL, NULL, NULL, 8),
(242014, NULL, 'PTHR34943', NULL, NULL, NULL, NULL, '', NULL, NULL, 34803, 8),
(242015, NULL, 'PTHR42637', NULL, NULL, NULL, NULL, 'TRNA-(MS[2]IO[6]A)-HYDROXYLASE', NULL, NULL, 9264, 8),
(242016, NULL, 'PTHR37377', NULL, NULL, NULL, NULL, 'RIBULOSE BISPHOSPHATE CARBOXYLASE LARGE CHAIN', NULL, NULL, 33129, 8),
(242017, NULL, 'PTHR11716', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A2 FAMILY MEMBER', NULL, NULL, 1343, 8),
(242018, NULL, 'PTHR47470', NULL, NULL, NULL, NULL, 'CHOLESTEROL OXIDASE', NULL, NULL, NULL, 8),
(242019, NULL, 'PTHR24264', NULL, NULL, NULL, NULL, 'TRYPSIN-RELATED', NULL, NULL, NULL, 8),
(242020, NULL, 'PTHR12295', NULL, NULL, NULL, NULL, 'FURRY-RELATED', NULL, NULL, 32138, 8),
(242021, NULL, 'PTHR12843', NULL, NULL, NULL, NULL, 'PROTEIN-LYSINE N-METHYLTRANSFERASE METTL10', NULL, NULL, NULL, 8),
(242022, NULL, 'PTHR10099', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLFORMYLGLYCINAMIDINE SYNTHASE', NULL, NULL, NULL, 8),
(242023, NULL, 'PTHR23148', NULL, NULL, NULL, NULL, 'SERINE/ARGININE REGULATED NUCLEAR MATRIX PROTEIN', NULL, NULL, NULL, 8),
(242024, NULL, 'PTHR36396', NULL, NULL, NULL, NULL, 'MALTASE-GLUCOAMYLASE, INTESTINAL PROTEIN', NULL, NULL, NULL, 8),
(242025, NULL, 'PTHR38339', NULL, NULL, NULL, NULL, 'TRANSGLUTAMINASE DOMAIN PROTEIN', NULL, NULL, NULL, 8),
(242026, NULL, 'PTHR47268', NULL, NULL, NULL, NULL, 'ACYLPHOSPHATASE', NULL, NULL, 20982, 8),
(242027, NULL, 'PTHR22767', NULL, NULL, NULL, NULL, 'N-TERMINAL ACETYLTRANSFERASE-RELATED', NULL, NULL, NULL, 8),
(242028, NULL, 'PTHR12025', NULL, NULL, NULL, NULL, 'VASCULAR ENDOTHELIAL GROWTH FACTOR', NULL, NULL, NULL, 8),
(242029, NULL, 'PTHR45893', NULL, NULL, NULL, NULL, 'POLYCOMB GROUP RING FINGER PROTEIN', NULL, NULL, NULL, 8),
(242030, NULL, 'PTHR23119', NULL, NULL, NULL, NULL, 'DISCS LARGE', NULL, NULL, NULL, 8),
(242031, NULL, 'PTHR35882', NULL, NULL, NULL, NULL, 'PELA', NULL, NULL, NULL, 8),
(242032, NULL, 'PTHR38048', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(242033, NULL, 'PTHR35135', NULL, NULL, NULL, NULL, 'OS05G0517800 PROTEIN', NULL, NULL, NULL, 8),
(242034, NULL, 'PTHR24291', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 4', NULL, NULL, NULL, 8),
(242035, NULL, 'PTHR13479', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S18', NULL, NULL, 5190, 8),
(242036, NULL, 'PTHR32472', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RADA', NULL, NULL, NULL, 8),
(242037, NULL, 'PTHR37898', NULL, NULL, NULL, NULL, 'OS05G0540200 PROTEIN', NULL, NULL, 32136, 8),
(242038, NULL, 'PTHR37997', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN C1ORF162', NULL, NULL, 32121, 8),
(242039, NULL, 'PTHR34343', NULL, NULL, NULL, NULL, 'SEROLOGICALLY DEFINED COLON CANCER ANTIGEN 8', NULL, NULL, 26740, 8),
(242040, NULL, 'PTHR30376', NULL, NULL, NULL, NULL, 'SIGMA FACTOR RPOH  HEAT SHOCK  RELATED', NULL, NULL, NULL, 8),
(242041, NULL, 'PTHR36865', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1700001O22 GENE', NULL, NULL, NULL, 8),
(242042, NULL, 'PTHR31775', NULL, NULL, NULL, NULL, 'OS02G0117200 PROTEIN', NULL, NULL, NULL, 8),
(242043, NULL, 'PTHR48225', NULL, NULL, NULL, NULL, 'HORMA DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(242044, NULL, 'PTHR22950', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER', NULL, NULL, NULL, 8),
(242045, NULL, 'PTHR14115', NULL, NULL, NULL, NULL, 'AMELOBLASTIN', NULL, NULL, 2123, 8),
(242046, NULL, 'PTHR13028', NULL, NULL, NULL, NULL, 'RRNA PROCESSING PROTEIN EBNA1-BINDING PROTEIN-RELATED', NULL, NULL, 14441, 8),
(242047, NULL, 'PTHR31326', NULL, NULL, NULL, NULL, 'PROTEIN CLT2, CHLOROPLASTIC', NULL, NULL, 14203, 8),
(242048, NULL, 'PTHR45690', NULL, NULL, NULL, NULL, 'NACHT, LRR AND PYD DOMAINS-CONTAINING PROTEIN 12', NULL, NULL, NULL, 8),
(242049, NULL, 'PTHR48023', NULL, NULL, NULL, NULL, 'D-XYLOSE-PROTON SYMPORTER-LIKE 2', NULL, NULL, NULL, 8),
(242050, NULL, 'PTHR35826', NULL, NULL, NULL, NULL, 'PROTEIN ATP6V1FNB-LIKE', NULL, NULL, NULL, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(242051, NULL, 'PTHR23319', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(242052, NULL, 'PTHR12640', NULL, NULL, NULL, NULL, 'RIBOPHORIN II', NULL, NULL, 13779, 8),
(242053, NULL, 'PTHR17357', NULL, NULL, NULL, NULL, 'GM2 GANGLIOSIDE ACTIVATOR PROTEIN', NULL, NULL, 23973, 8),
(242054, NULL, 'PTHR16768', NULL, NULL, NULL, NULL, 'DOWN REGULATED IN RENAL CARCINOMA 1/TU3A', NULL, NULL, 10107, 8),
(242055, NULL, 'PTHR37330', NULL, NULL, NULL, NULL, 'CONSERVED TRANSMEMBRANE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(242056, NULL, 'PTHR33690', NULL, NULL, NULL, NULL, 'DUF4605 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(242057, NULL, 'PTHR42470', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(242058, NULL, 'PTHR45764', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR 44', NULL, NULL, NULL, 8),
(242059, NULL, 'PTHR24229', NULL, NULL, NULL, NULL, 'NEUROPEPTIDES RECEPTOR', NULL, NULL, NULL, 8),
(242060, NULL, 'PTHR45946', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN ROUGH-RELATED', NULL, NULL, 33664, 8),
(242061, NULL, 'PTHR33214', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', NULL, NULL, 30536, 8),
(242062, NULL, 'PTHR31212', NULL, NULL, NULL, NULL, 'ALPHA-KETOGLUTARATE-DEPENDENT DIOXYGENASE ALKB HOMOLOG 3', NULL, NULL, 23619, 8),
(242063, NULL, 'PTHR38108', NULL, NULL, NULL, NULL, 'UPF0319 PROTEIN YCCT', NULL, NULL, 16071, 8),
(242064, NULL, 'PTHR46529', NULL, NULL, NULL, NULL, 'TRNA WYBUTOSINE-SYNTHESIZING PROTEIN 4', NULL, NULL, NULL, 8),
(242065, NULL, 'PTHR21197', NULL, NULL, NULL, NULL, 'UDP-GALACTOPYRANOSE MUTASE', NULL, NULL, NULL, 8),
(242066, NULL, 'PTHR43683', NULL, NULL, NULL, NULL, 'MULTIDRUG EFFLUX PROTEIN YFMO', NULL, NULL, NULL, 8),
(242067, NULL, 'PTHR45733', NULL, NULL, NULL, NULL, 'FORMIN-J', NULL, NULL, NULL, 8),
(242068, NULL, 'PTHR34402', NULL, NULL, NULL, NULL, 'PROTEIN CBG02762', NULL, NULL, NULL, 8),
(242069, NULL, 'PTHR12922', NULL, NULL, NULL, NULL, 'UBIQUINONE BIOSYNTHESIS PROTEIN', NULL, NULL, 1046, 8),
(242070, NULL, 'PTHR34714', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(242071, NULL, 'PTHR12837', NULL, NULL, NULL, NULL, 'POLY ADP-RIBOSE  GLYCOHYDROLASE', NULL, NULL, 1298, 8),
(242072, NULL, 'PTHR35165', NULL, NULL, NULL, NULL, 'OS08G0113900 PROTEIN', NULL, NULL, NULL, 8),
(242073, NULL, 'PTHR12514', NULL, NULL, NULL, NULL, 'ENHANCER OF YELLOW 2 TRANSCRIPTION FACTOR', NULL, NULL, 19015, 8),
(242074, NULL, 'PTHR24329', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN ARISTALESS', NULL, NULL, NULL, 8),
(242075, NULL, 'PTHR10102', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE, MITOCHONDRIAL', NULL, NULL, 5453, 8),
(242076, NULL, 'PTHR46916', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 205', NULL, NULL, 36193, 8),
(242077, NULL, 'PTHR31213', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(242078, NULL, 'PTHR22444', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 21854, 8),
(242079, NULL, 'PTHR15196', NULL, NULL, NULL, NULL, 'CILIARY NEUROTROPHIC FACTOR', NULL, NULL, 1783, 8),
(242080, NULL, 'PTHR28147', NULL, NULL, NULL, NULL, 'N-GLYCOSYLATION PROTEIN EOS1', NULL, NULL, 15057, 8),
(242081, NULL, 'PTHR37283', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN YHR131C', NULL, NULL, NULL, 8),
(242082, NULL, 'PTHR45835', NULL, NULL, NULL, NULL, 'YALI0A06105P', NULL, NULL, NULL, 8),
(242083, NULL, 'PTHR16675', NULL, NULL, NULL, NULL, 'MHC CLASS I-RELATED', NULL, NULL, NULL, 8),
(242084, NULL, 'PTHR46646', NULL, NULL, NULL, NULL, 'TOM1-LIKE PROTEIN 1', NULL, NULL, 36422, 8),
(242085, NULL, 'PTHR35290', NULL, NULL, NULL, NULL, 'PROTEIN CASPARIAN STRIP INTEGRITY FACTOR 1-RELATED', NULL, NULL, 30808, 8),
(242086, NULL, 'PTHR24335', NULL, NULL, NULL, NULL, 'MOTOR NEURON AND PANCREAS HOMEOBOX PROTEIN', NULL, NULL, 35734, 8),
(242087, NULL, 'PTHR37937', NULL, NULL, NULL, NULL, 'CONJUGATIVE TRANSFER: DNA TRANSPORT', NULL, NULL, NULL, 8),
(242088, NULL, 'PTHR24132', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX PROTEIN 6', NULL, NULL, NULL, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(242089, NULL, 'PTHR19890', NULL, NULL, NULL, NULL, 'FIBROBLAST GROWTH FACTOR RECEPTOR', NULL, NULL, NULL, 8),
(242090, NULL, 'PTHR23302', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE CHANNEL-RELATED', NULL, NULL, 31329, 8),
(242091, NULL, 'PTHR24392', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', NULL, NULL, NULL, 8),
(242092, NULL, 'PTHR47850', NULL, NULL, NULL, NULL, 'F-BOX/KELCH-REPEAT PROTEIN OR23', NULL, NULL, NULL, 8),
(242093, NULL, 'PTHR23303', NULL, NULL, NULL, NULL, 'CARBOXYPEPTIDASE REGULATORY REGION-CONTAINING', NULL, NULL, NULL, 8),
(242094, NULL, 'PTHR43696', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 157', NULL, NULL, 25051, 8),
(242095, NULL, 'PTHR14918', NULL, NULL, NULL, NULL, 'KICSTOR COMPLEX PROTEIN SZT2', NULL, NULL, 33458, 8),
(242096, NULL, 'PTHR31709', NULL, NULL, NULL, NULL, 'LEUCINE ZIPPER PROTEIN 4-RELATED', NULL, NULL, NULL, 8),
(242097, NULL, 'PTHR34310', NULL, NULL, NULL, NULL, 'DUF427 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_3G02220)', NULL, NULL, NULL, 8),
(242098, NULL, 'PTHR16243', NULL, NULL, NULL, NULL, 'BTG3-ASSOCIATED NUCLEAR PROTEIN BANP', NULL, NULL, 36387, 8),
(242099, NULL, 'PTHR18853', NULL, NULL, NULL, NULL, 'FORKHEAD-ASSOCIATED DOMAIN-CONTAINING PROTEIN 1-RELATED', NULL, NULL, NULL, 8),
(242100, NULL, 'PTHR31299', NULL, NULL, NULL, NULL, 'ESTERASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G05850)-RELATED', NULL, NULL, NULL, 8),
(242101, NULL, 'PTHR24182', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX CONTAINING 4', NULL, NULL, NULL, 8),
(242102, NULL, 'PTHR37834', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_2G00620)', NULL, NULL, NULL, 8),
(242103, NULL, 'PTHR33180', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II CP43 REACTION CENTER PROTEIN', NULL, NULL, NULL, 8),
(242104, NULL, 'PTHR34311', NULL, NULL, NULL, NULL, 'PROTEIN CBG21698-RELATED', NULL, NULL, NULL, 8),
(242105, NULL, 'PTHR23310', NULL, NULL, NULL, NULL, 'ACYL-COA-BINDING PROTEIN, ACBP', NULL, NULL, NULL, 8),
(242106, NULL, 'PTHR35291', NULL, NULL, NULL, NULL, 'PROTEIN SHROOM-LIKE', NULL, NULL, NULL, 8),
(242107, NULL, 'PTHR23091', NULL, NULL, NULL, NULL, 'N-TERMINAL ACETYLTRANSFERASE', NULL, NULL, 36946, 8),
(242108, NULL, 'PTHR12356', NULL, NULL, NULL, NULL, 'NUCLEAR MOVEMENT PROTEIN NUDC', NULL, NULL, 30396, 8),
(242109, NULL, 'PTHR37233', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(242110, NULL, 'PTHR31664', NULL, NULL, NULL, NULL, 'PROTEIN CBG16427', NULL, NULL, NULL, 8),
(242111, NULL, 'PTHR33786', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', NULL, NULL, NULL, 8),
(242112, NULL, 'PTHR46285', NULL, NULL, NULL, NULL, 'PROTEINASE INHIBITOR I4, SERPIN (DUF716)-RELATED', NULL, NULL, NULL, 8),
(242113, NULL, 'PTHR30388', NULL, NULL, NULL, NULL, 'ALDEHYDE OXIDOREDUCTASE MOLYBDENUM COFACTOR ASSEMBLY PROTEIN', NULL, NULL, NULL, 8),
(242114, NULL, 'PTHR47123', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SKIP23', NULL, NULL, NULL, 8),
(242115, NULL, 'PTHR37030', NULL, NULL, NULL, NULL, 'NUCLEOTIDYLTRANSFERASE', NULL, NULL, NULL, 8),
(242116, NULL, 'PTHR21427', NULL, NULL, NULL, NULL, 'UBIQUINONE BIOSYNTHESIS PROTEIN COQ9, MITOCHONDRIAL', NULL, NULL, 9585, 8),
(242117, NULL, 'PTHR23207', NULL, NULL, NULL, NULL, 'CORNEODESMOSIN', NULL, NULL, 24579, 8),
(242118, NULL, 'PTHR34661', NULL, NULL, NULL, NULL, 'INCREASED DNA METHYLATION 3', NULL, NULL, 27159, 8),
(242119, NULL, 'PTHR48169', NULL, NULL, NULL, NULL, 'DED DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(242120, NULL, 'PTHR38430', NULL, NULL, NULL, NULL, 'PROTEIN-ARGININE KINASE ACTIVATOR PROTEIN', NULL, NULL, 24078, 8),
(242121, NULL, 'PTHR23411', NULL, NULL, NULL, NULL, 'TAPASIN', NULL, NULL, NULL, 8),
(242122, NULL, 'PTHR14710', NULL, NULL, NULL, NULL, 'GEM-ASSOCIATED PROTEIN 6', NULL, NULL, 8082, 8),
(242123, NULL, 'PTHR22397', NULL, NULL, NULL, NULL, 'JUNCTIONAL SARCOPLASMIC RETICULUM PROTEIN 1', NULL, NULL, 25094, 8),
(242124, NULL, 'PTHR35391', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(242125, NULL, 'PTHR31557', NULL, NULL, NULL, NULL, '5C820-RELATED-RELATED', NULL, NULL, NULL, 8),
(242126, NULL, 'PTHR23205', NULL, NULL, NULL, NULL, 'SPLICING FACTOR 3A SUBUNIT 2', NULL, NULL, NULL, 8),
(242127, NULL, 'PTHR46973', NULL, NULL, NULL, NULL, 'GRAM DOMAIN-CONTAINING PROTEIN 2A', NULL, NULL, 35809, 8),
(242128, NULL, 'PTHR11223', NULL, NULL, NULL, NULL, 'EXPORTIN 1/5', NULL, NULL, 36720, 8),
(242129, NULL, 'PTHR46850', NULL, NULL, NULL, NULL, 'CHROMODOMAIN-HELICASE-DNA-BINDING PROTEIN 9', NULL, NULL, NULL, 8),
(242130, NULL, 'PTHR33447', NULL, NULL, NULL, NULL, 'GLUTATHIONE GAMMA-GLUTAMYLCYSTEINYLTRANSFERASE', NULL, NULL, 27329, 8),
(242131, NULL, 'PTHR37722', NULL, NULL, NULL, NULL, 'OS01G0167700 PROTEIN', NULL, NULL, NULL, 8),
(242132, NULL, 'PTHR46844', NULL, NULL, NULL, NULL, 'SLR5058 PROTEIN', NULL, NULL, NULL, 8),
(242133, NULL, 'PTHR36479', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(242134, NULL, 'PTHR32018', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONATE LYASE FAMILY PROTEIN', NULL, NULL, NULL, 8),
(242135, NULL, 'PTHR34046', NULL, NULL, NULL, NULL, 'OS06G0218800 PROTEIN', NULL, NULL, NULL, 8),
(242136, NULL, 'PTHR13308', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 25886, 8),
(242137, NULL, 'PTHR30425', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORT SYSTEM PERMEASE PROTEIN PST', NULL, NULL, NULL, 8),
(242138, NULL, 'PTHR38887', NULL, NULL, NULL, NULL, 'CHROMOSOME 21, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(242139, NULL, 'PTHR37821', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER YUIF-RELATED', NULL, NULL, NULL, 8),
(242140, NULL, 'PTHR37799', NULL, NULL, NULL, NULL, '37S RIBOSOMAL PROTEIN S25, MITOCHONDRIAL', NULL, NULL, 17703, 8),
(242141, NULL, 'PTHR37301', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(242142, NULL, 'PTHR46835', NULL, NULL, NULL, NULL, 'BASIC-LEUCINE ZIPPER (BZIP) TRANSCRIPTION FACTOR FAMILY PROTEIN-RELATED', NULL, NULL, 35202, 8),
(242143, NULL, 'PTHR24106', NULL, NULL, NULL, NULL, 'NACHT, LRR AND CARD DOMAINS-CONTAINING', NULL, NULL, NULL, 8),
(242144, NULL, 'PTHR46780', NULL, NULL, NULL, NULL, 'PROTEIN EVA-1', NULL, NULL, NULL, 8),
(242145, NULL, 'PTHR47720', NULL, NULL, NULL, NULL, 'AQUAPORIN SIP2-1-RELATED', NULL, NULL, 34635, 8),
(242146, NULL, 'PTHR38774', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', NULL, NULL, 11500, 8),
(242147, NULL, 'PTHR43302', NULL, NULL, NULL, NULL, 'TRANSPORTER ARSB-RELATED', NULL, NULL, NULL, 8),
(242148, NULL, 'PTHR10267', NULL, NULL, NULL, NULL, 'DNA POLYMERASE SUBUNIT GAMMA-1', NULL, NULL, 361, 8),
(242149, NULL, 'PTHR30029', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 3677, 8),
(242150, NULL, 'PTHR45975', NULL, NULL, NULL, NULL, 'NUCLEOSOME-REMODELING FACTOR SUBUNIT BPTF', NULL, NULL, 33165, 8),
(242151, NULL, 'PTHR45843', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE-LIKE 4', NULL, NULL, 31535, 8),
(242152, NULL, 'PTHR42723', NULL, NULL, NULL, NULL, 'CHLOROPHYLL SYNTHASE', NULL, NULL, NULL, 8),
(242153, NULL, 'PTHR37616', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR 60-LIKE', NULL, NULL, NULL, 8),
(242154, NULL, 'PTHR21093', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(242155, NULL, 'PTHR33544', NULL, NULL, NULL, NULL, '', NULL, NULL, 27263, 8),
(242156, NULL, 'PTHR34574', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING EF-HAND FAMILY PROTEIN-RELATED', NULL, NULL, NULL, 8),
(242157, NULL, 'PTHR36315', NULL, NULL, NULL, NULL, 'PHOTOSYNTHETIC NDH SUBUNIT OF SUBCOMPLEX B 4, CHLOROPLASTIC', NULL, NULL, 18393, 8),
(242158, NULL, 'PTHR47460', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE-LIKE PROTEIN ACR4', NULL, NULL, NULL, 8),
(242159, NULL, 'PTHR31386', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN KIAA2013', NULL, NULL, 19391, 8),
(242160, NULL, 'PTHR17130', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL OUTER MEMBRANE PROTEIN 25', NULL, NULL, NULL, 8),
(242161, NULL, 'PTHR11361', NULL, NULL, NULL, NULL, 'DNA MISMATCH REPAIR PROTEIN MUTS FAMILY MEMBER', NULL, NULL, 36898, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(242162, NULL, 'PTHR33789', NULL, NULL, NULL, NULL, 'LACHRYMATORY-FACTOR SYNTHASE', NULL, NULL, NULL, 8),
(242163, NULL, 'PTHR31425', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLANTHRANILATE TRANSFERASE ISOFORM 1', NULL, NULL, NULL, 8),
(242164, NULL, 'PTHR15577', NULL, NULL, NULL, NULL, 'ZINC FINGER CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(242165, NULL, 'PTHR43802', NULL, NULL, NULL, NULL, 'ENOYL-COA HYDRATASE', NULL, NULL, NULL, 8),
(242166, NULL, 'PTHR10442', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S21', NULL, NULL, 2160, 8),
(242167, NULL, 'PTHR21084', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 24247, 8),
(242168, NULL, 'PTHR31185', NULL, NULL, NULL, NULL, 'FIN BUD INITIATION FACTOR FIBIN', NULL, NULL, 24310, 8),
(242169, NULL, 'PTHR30433', NULL, NULL, NULL, NULL, 'CHEMOTAXIS PROTEIN MOTA', NULL, NULL, NULL, 8),
(242170, NULL, 'PTHR15887', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 69', NULL, NULL, 19817, 8),
(242171, NULL, 'PTHR42703', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE', NULL, NULL, NULL, 8),
(242172, NULL, 'PTHR15571', NULL, NULL, NULL, NULL, 'GEM-ASSOCIATED PROTEIN 4', NULL, NULL, 29011, 8),
(242173, NULL, 'PTHR47762', NULL, NULL, NULL, NULL, 'OSJNBB0079B02.4 PROTEIN', NULL, NULL, NULL, 8),
(242174, NULL, 'PTHR37756', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(242175, NULL, 'PTHR46940', NULL, NULL, NULL, NULL, 'NKAP DOMAIN-CONTAINING 1', NULL, NULL, 35689, 8),
(242176, NULL, 'PTHR34803', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I REACTION CENTER SUBUNIT XI, CHLOROPLASTIC', NULL, NULL, 15119, 8),
(242177, NULL, 'PTHR31352', NULL, NULL, NULL, NULL, 'BETA-AMYLASE 1, CHLOROPLASTIC', NULL, NULL, 5992, 8),
(242178, NULL, 'PTHR38499', NULL, NULL, NULL, NULL, 'ADIPOGENIN', NULL, NULL, 24796, 8),
(242179, NULL, 'PTHR43428', NULL, NULL, NULL, NULL, 'ARSENATE REDUCTASE', NULL, NULL, NULL, 8),
(242180, NULL, 'PTHR30442', NULL, NULL, NULL, NULL, 'IRON III  DICITRATE TRANSPORT PROTEIN FECA', NULL, NULL, 33080, 8),
(242181, NULL, 'PTHR14469', NULL, NULL, NULL, NULL, 'SARCOMA ANTIGEN NY-SAR-23', NULL, NULL, NULL, 8),
(242182, NULL, 'PTHR31252', NULL, NULL, NULL, NULL, '', NULL, NULL, 26381, 8),
(242183, NULL, 'PTHR45820', NULL, NULL, NULL, NULL, 'FI23527P1', NULL, NULL, NULL, 8),
(242184, NULL, 'PTHR24029', NULL, NULL, NULL, NULL, 'UVRABC SYSTEM PROTEIN B', NULL, NULL, 4298, 8),
(242185, NULL, 'PTHR10133', NULL, NULL, NULL, NULL, 'DNA POLYMERASE I', NULL, NULL, 212, 8),
(242186, NULL, 'PTHR44444', NULL, NULL, NULL, NULL, 'PROTEIN SEL-1 HOMOLOG 3', NULL, NULL, 35628, 8),
(242187, NULL, 'PTHR10306', NULL, NULL, NULL, NULL, 'SYNAPTOPHYSIN', NULL, NULL, 107, 8),
(242188, NULL, 'PTHR37827', NULL, NULL, NULL, NULL, 'TUDOR DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(242189, NULL, 'PTHR47000', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(242190, NULL, 'PTHR46626', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN B17', NULL, NULL, 36099, 8),
(242191, NULL, 'PTHR36195', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G01990)-RELATED-RELATED', NULL, NULL, NULL, 8),
(242192, NULL, 'PTHR13460', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 32742, 8),
(242193, NULL, 'PTHR11886', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT CHAIN', NULL, NULL, 463, 8),
(242194, NULL, 'PTHR47369', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(242195, NULL, 'PTHR38378', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN-LIKE PROTEIN', NULL, NULL, NULL, 8),
(242196, NULL, 'PTHR23510', NULL, NULL, NULL, NULL, 'INNER MEMBRANE TRANSPORT PROTEIN YAJR', NULL, NULL, NULL, 8),
(242197, NULL, 'PTHR21521', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(242198, NULL, 'PTHR30189', NULL, NULL, NULL, NULL, 'LPS-ASSEMBLY PROTEIN', NULL, NULL, NULL, 8),
(242199, NULL, 'PTHR15044', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE FF', NULL, NULL, 5067, 8),
(242200, NULL, 'PTHR32121', NULL, NULL, NULL, NULL, 'PCNA-INTERACTING PARTNER', NULL, NULL, 30593, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(242201, NULL, 'PTHR31569', NULL, NULL, NULL, NULL, 'SWIM-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(242202, NULL, 'PTHR45730', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN JAGGED', NULL, NULL, 37165, 8),
(242203, NULL, 'PTHR36013', NULL, NULL, NULL, NULL, 'ATP SYNTHASE 24 KDA SUBUNIT, MITOCHONDRIAL-RELATED', NULL, NULL, 24423, 8),
(242204, NULL, 'PTHR28589', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S34, MITOCHONDRIAL', NULL, NULL, 22922, 8),
(242205, NULL, 'PTHR33361', NULL, NULL, NULL, NULL, 'GLR0591 PROTEIN', NULL, NULL, 7635, 8),
(242206, NULL, 'PTHR47447', NULL, NULL, NULL, NULL, 'OS03G0856100 PROTEIN', NULL, NULL, NULL, 8),
(242207, NULL, 'PTHR34492', NULL, NULL, NULL, NULL, 'GUSTATORY RECEPTOR FAMILY', NULL, NULL, NULL, 8),
(242208, NULL, 'PTHR36008', NULL, NULL, NULL, NULL, 'OS09G0478400 PROTEIN', NULL, NULL, NULL, 8),
(242209, NULL, 'PTHR28627', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY FACTOR 5', NULL, NULL, 19276, 8),
(242210, NULL, 'PTHR43700', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLAMINOIMIDAZOLE-SUCCINOCARBOXAMIDE SYNTHASE', NULL, NULL, NULL, 8),
(242211, NULL, 'PTHR15067', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF8', NULL, NULL, NULL, 8),
(242212, NULL, 'PTHR10258', NULL, NULL, NULL, NULL, 'CALCIUM-ACTIVATED POTASSIUM CHANNEL SUBUNIT BETA', NULL, NULL, 6199, 8),
(242213, NULL, 'PTHR36714', NULL, NULL, NULL, NULL, 'T23E23.1', NULL, NULL, NULL, 8),
(242214, NULL, 'PTHR12628', NULL, NULL, NULL, NULL, 'POLYCOMB-LIKE TRANSCRIPTION FACTOR', NULL, NULL, NULL, 8),
(242215, NULL, 'PTHR13659', NULL, NULL, NULL, NULL, 'AUTOSOMAL HIGHLY CONSERVED PROTEIN', NULL, NULL, 32108, 8),
(242216, NULL, 'PTHR35741', NULL, NULL, NULL, NULL, 'FACTOR CWC22-LIKE PROTEIN, PUTATIVE (DUF3245)-RELATED', NULL, NULL, NULL, 8),
(242217, NULL, 'PTHR22769', NULL, NULL, NULL, NULL, 'MUTT/NUDIX HYDROLASE', NULL, NULL, NULL, 8),
(242218, NULL, 'PTHR43023', NULL, NULL, NULL, NULL, 'PROTEIN TRIGALACTOSYLDIACYLGLYCEROL 3, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(242219, NULL, 'PTHR21321', NULL, NULL, NULL, NULL, 'PNAS-3 RELATED', NULL, NULL, 24060, 8),
(242220, NULL, 'PTHR12609', NULL, NULL, NULL, NULL, 'MICROTUBULE ASSOCIATED PROTEIN XMAP215', NULL, NULL, 34528, 8),
(242221, NULL, 'PTHR28242', NULL, NULL, NULL, NULL, 'PHOSPHORELAY INTERMEDIATE PROTEIN YPD1', NULL, NULL, 34439, 8),
(242222, NULL, 'PTHR28221', NULL, NULL, NULL, NULL, 'RNA POLYMERASE I-SPECIFIC TRANSCRIPTION INITIATION FACTOR RRN6', NULL, NULL, 15916, 8),
(242223, NULL, 'PTHR10558', NULL, NULL, NULL, NULL, 'SOMATOSTATIN', NULL, NULL, 3990, 8),
(242224, NULL, 'PTHR15545', NULL, NULL, NULL, NULL, 'PDZ DOMAIN CONTAINING RING FINGER PROTEIN 3, 4', NULL, NULL, NULL, 8),
(242225, NULL, 'PTHR11502', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S6', NULL, NULL, 6808, 8),
(242226, NULL, 'PTHR36305', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLGLYCEROPHOSPHATASE A', NULL, NULL, 24835, 8),
(242227, NULL, 'PTHR37473', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(242228, NULL, 'PTHR14773', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(242229, NULL, 'PTHR38761', NULL, NULL, NULL, NULL, 'GLUTAMATE--CYSTEINE LIGASE', NULL, NULL, 4551, 8),
(242230, NULL, 'PTHR20963', NULL, NULL, NULL, NULL, 'MULTIPLE INOSITOL POLYPHOSPHATE PHOSPHATASE-RELATED', NULL, NULL, NULL, 8),
(242231, NULL, 'PTHR32525', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE-PHOSPHATASE', NULL, NULL, NULL, 8),
(242232, NULL, 'PTHR31651', NULL, NULL, NULL, NULL, '', NULL, NULL, 35796, 8),
(242233, NULL, 'PTHR36455', NULL, NULL, NULL, NULL, '', NULL, NULL, 7713, 8),
(242234, NULL, 'PTHR46236', NULL, NULL, NULL, NULL, 'TRAF-LIKE SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(242235, NULL, 'PTHR23020', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED NUCLEAR HORMONE RECEPTOR-RELATED', NULL, NULL, NULL, 8),
(242236, NULL, 'PTHR16043', NULL, NULL, NULL, NULL, 'DALRD3 PROTEIN', NULL, NULL, 29164, 8),
(242237, NULL, 'PTHR21533', NULL, NULL, NULL, NULL, 'LEUCINE-RICH PROTEIN', NULL, NULL, NULL, 8),
(242238, NULL, 'PTHR39638', NULL, NULL, NULL, NULL, 'YCF35', NULL, NULL, 11857, 8);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(242239, NULL, 'PTHR12120', NULL, NULL, NULL, NULL, 'TNFR-CYS DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(242240, NULL, 'PTHR31150', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(242241, NULL, 'PTHR13011', NULL, NULL, NULL, NULL, 'TFIIF-ALPHA', NULL, NULL, 13641, 8),
(242242, NULL, 'PTHR47959', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE RHLE-RELATED', NULL, NULL, NULL, 8),
(242243, NULL, 'PTHR46409', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(242244, NULL, 'PTHR36074', NULL, NULL, NULL, NULL, 'ISOPENTENYL-DIPHOSPHATE DELTA-ISOMERASE', NULL, NULL, NULL, 8),
(242245, NULL, 'PTHR12878', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE B8 SUBUNIT', NULL, NULL, 15058, 8),
(242246, NULL, 'PTHR12490', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 27408, 8),
(242247, NULL, 'PTHR34966', NULL, NULL, NULL, NULL, 'OSJNBA0043L24.15 PROTEIN', NULL, NULL, NULL, 8),
(242248, NULL, 'PTHR36113', NULL, NULL, NULL, NULL, 'LYASE, PUTATIVE-RELATED-RELATED', NULL, NULL, NULL, 8),
(242249, NULL, 'PTHR38657', NULL, NULL, NULL, NULL, 'SLR1343 PROTEIN', NULL, NULL, NULL, 8),
(242250, NULL, 'PTHR12621', NULL, NULL, NULL, NULL, 'CYSTEINE AND HISTIDINE-RICH DOMAIN  CHORD -CONTAINING PROTEIN', NULL, NULL, 27367, 8),
(242251, NULL, 'PTHR38443', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(242252, NULL, 'PTHR11738', NULL, NULL, NULL, NULL, 'MHC CLASS I NK CELL RECEPTOR', NULL, NULL, NULL, 8),
(242253, NULL, 'PTHR37349', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 12', NULL, NULL, 21788, 8),
(242254, NULL, 'PTHR33668', NULL, NULL, NULL, NULL, 'PROTEIN BRICK1', NULL, NULL, 32592, 8),
(242255, NULL, 'PTHR37297', NULL, NULL, NULL, NULL, 'PROTEIN NRDI', NULL, NULL, 7443, 8),
(242256, NULL, 'PTHR43743', NULL, NULL, NULL, NULL, 'POTASSIUM-TRANSPORTING ATPASE ATP-BINDING SUBUNIT', NULL, NULL, 5958, 8),
(242257, NULL, 'PTHR10019', NULL, NULL, NULL, NULL, 'SNF5', NULL, NULL, NULL, 8),
(242258, NULL, 'PTHR34976', NULL, NULL, NULL, NULL, 'RIBONUCLEASE YQCG-RELATED', NULL, NULL, NULL, 8),
(242259, NULL, 'PTHR47996', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR DUO1', NULL, NULL, NULL, 8),
(242260, NULL, 'PTHR45769', NULL, NULL, NULL, NULL, 'ADENOSINE KINASE', NULL, NULL, 4188, 8),
(242261, NULL, 'PTHR24383', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', NULL, NULL, NULL, 8),
(242262, NULL, 'PTHR42829', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE CHAIN 5', NULL, NULL, 7292, 8),
(242263, NULL, 'PTHR46174', NULL, NULL, NULL, NULL, 'CXXC-TYPE ZINC FINGER PROTEIN 1', NULL, NULL, 30190, 8),
(242264, NULL, 'PTHR17605', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS PROTEIN BOP1  BLOCK OF PROLIFERATION 1 PROTEIN', NULL, NULL, 26090, 8),
(242265, NULL, 'PTHR10880', NULL, NULL, NULL, NULL, 'MORTALITY FACTOR 4-LIKE PROTEIN', NULL, NULL, 12860, 8),
(242266, NULL, 'PTHR37882', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC690352', NULL, NULL, 21829, 8),
(242267, NULL, 'PTHR11449', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L30', NULL, NULL, 31031, 8),
(242268, NULL, 'PTHR12384', NULL, NULL, NULL, NULL, 'MATERNAL PROTEIN EXUPERANTIA', NULL, NULL, 27959, 8),
(242269, NULL, 'PTHR39226', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1700013G24 GENE', NULL, NULL, NULL, 8),
(242270, NULL, 'PTHR10073', NULL, NULL, NULL, NULL, 'DNA MISMATCH REPAIR PROTEIN  MLH, PMS, MUTL', NULL, NULL, 30902, 8),
(242271, NULL, 'PTHR13349', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 18487, 8),
(242272, NULL, 'PTHR11394', NULL, NULL, NULL, NULL, 'TASTE RECEPTOR TYPE 2', NULL, NULL, NULL, 8),
(242273, NULL, 'PTHR32295', NULL, NULL, NULL, NULL, 'IQ-DOMAIN 5-RELATED', NULL, NULL, NULL, 8),
(242274, NULL, 'PTHR34003', NULL, NULL, NULL, NULL, 'BLL2395 PROTEIN', NULL, NULL, NULL, 8),
(242275, NULL, 'PTHR47593', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 4-LIKE', NULL, NULL, NULL, 8),
(242276, NULL, 'PTHR45837', NULL, NULL, NULL, NULL, 'VESICLE-TRAFFICKING PROTEIN SEC22B', NULL, NULL, 36144, 8),
(242277, NULL, 'PTHR37877', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL COILED-COIL DOMAIN PROTEIN 1', NULL, NULL, 25246, 8);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(242278, NULL, 'PTHR19923', NULL, NULL, NULL, NULL, 'WD40 REPEAT PROTEINPRL1/PRL2-RELATED', NULL, NULL, 35933, 8),
(242279, NULL, 'PTHR45628', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL TYPE A SUBUNIT ALPHA-1', NULL, NULL, NULL, 8),
(242280, NULL, 'PTHR10537', NULL, NULL, NULL, NULL, 'DNA PRIMASE LARGE SUBUNIT', NULL, NULL, 6887, 8),
(242281, NULL, 'PTHR34361', NULL, NULL, NULL, NULL, 'OS08G0157800 PROTEIN', NULL, NULL, NULL, 8),
(242282, NULL, 'PTHR21327', NULL, NULL, NULL, NULL, 'GTP CYCLOHYDROLASE II-RELATED', NULL, NULL, NULL, 8),
(242283, NULL, 'PTHR10459', NULL, NULL, NULL, NULL, 'DNA LIGASE', NULL, NULL, NULL, 8),
(242284, NULL, 'PTHR12369', NULL, NULL, NULL, NULL, 'CHONDROITIN SYNTHASE', NULL, NULL, NULL, 8),
(242285, NULL, 'PTHR28021', NULL, NULL, NULL, NULL, 'PRESEQUENCE TRANSLOCATED-ASSOCIATED MOTOR SUBUNIT PAM17, MITOCHONDRIAL', NULL, NULL, 9986, 8),
(242286, NULL, 'PTHR16967', NULL, NULL, NULL, NULL, 'LEYDIG CELL TUMOR 10 KDA PROTEIN HOMOLOG', NULL, NULL, 15825, 8),
(242287, NULL, 'PTHR13329', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOMAL PROTEIN S18B', NULL, NULL, 31444, 8),
(242288, NULL, 'PTHR21297', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE II', NULL, NULL, 36806, 8),
(242289, NULL, 'PTHR42689', NULL, NULL, NULL, NULL, 'ACETYL-COA ACYLTRANSFERASE FADA2 (3-KETOACYL-COA THIOLASE) (BETA-KETOTHIOLASE)-RELATED', NULL, NULL, NULL, 8),
(242290, NULL, 'PTHR21254', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(242291, NULL, 'PTHR33317', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDYL TRANSFERASE, RIBONUCLEASE H-LIKE SUPERFAMILY PROTEIN', NULL, NULL, 11163, 8),
(242292, NULL, 'PTHR15004', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 3098, 8),
(242293, NULL, 'PTHR36036', NULL, NULL, NULL, NULL, 'PROLINE-RICH FAMILY PROTEIN', NULL, NULL, 31821, 8),
(242294, NULL, 'PTHR10553', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN', NULL, NULL, 35525, 8),
(242295, NULL, 'PTHR31873', NULL, NULL, NULL, NULL, 'L-ASPARTATE DEHYDROGENASE-RELATED', NULL, NULL, NULL, 8),
(242296, NULL, 'PTHR48199', NULL, NULL, NULL, NULL, 'ALPHA KAFIRIN', NULL, NULL, NULL, 8),
(242297, NULL, 'PTHR31048', NULL, NULL, NULL, NULL, 'OS03G0233200 PROTEIN', NULL, NULL, 2232, 8),
(242298, NULL, 'PTHR35459', NULL, NULL, NULL, NULL, 'T1N6.14 PROTEIN', NULL, NULL, NULL, 8),
(242299, NULL, 'PTHR31044', NULL, NULL, NULL, NULL, 'BETA-1,3 GLUCANASE', NULL, NULL, 34695, 8),
(242300, NULL, 'PTHR11416', NULL, NULL, NULL, NULL, 'PRO-OPIOMELANOCORTIN', NULL, NULL, NULL, 8),
(242301, NULL, 'PTHR47501', NULL, NULL, NULL, NULL, 'TRANSPOSASE-RELATED', NULL, NULL, NULL, 8),
(242302, NULL, 'PTHR36511', NULL, NULL, NULL, NULL, 'MERR FAMILY BACTERIAL REGULATORY PROTEIN', NULL, NULL, NULL, 8),
(242303, NULL, 'PTHR38372', NULL, NULL, NULL, NULL, 'DENTIN SIALOPHOSPHOPROTEIN-LIKE PROTEIN', NULL, NULL, NULL, 8),
(242304, NULL, 'PTHR30489', NULL, NULL, NULL, NULL, 'LIPOPROTEIN-RELEASING SYSTEM TRANSMEMBRANE PROTEIN LOLE', NULL, NULL, NULL, 8),
(242305, NULL, 'PTHR10693', NULL, NULL, NULL, NULL, 'RAS GTPASE-ACTIVATING PROTEIN-BINDING PROTEIN', NULL, NULL, 27251, 8),
(242306, NULL, 'PTHR33984', NULL, NULL, NULL, NULL, 'OS02G0717600 PROTEIN', NULL, NULL, NULL, 8),
(242307, NULL, 'PTHR33297', NULL, NULL, NULL, NULL, 'AMASTIN-LIKE SURFACE PROTEIN-LIKE PROTEIN-RELATED', NULL, NULL, 8109, 8),
(242308, NULL, 'PTHR46774', NULL, NULL, NULL, NULL, 'CHROMATIN MODIFICATION-RELATED PROTEIN EAF1 A-RELATED', NULL, NULL, 35386, 8),
(242309, NULL, 'PTHR28640', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 6-INTERACTING PROTEIN 6', NULL, NULL, 26457, 8),
(242310, NULL, 'PTHR12327', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 31967, 8),
(242311, NULL, 'PTHR10030', NULL, NULL, NULL, NULL, 'ALPHA-L-FUCOSIDASE', NULL, NULL, 3200, 8),
(242312, NULL, 'PTHR47932', NULL, NULL, NULL, NULL, 'ATPASE EXPRESSION PROTEIN 3', NULL, NULL, NULL, 8),
(242313, NULL, 'PTHR14948', NULL, NULL, NULL, NULL, 'NG5', NULL, NULL, NULL, 8),
(242314, NULL, 'PTHR34860', NULL, NULL, NULL, NULL, 'REPRESSOR-LIKE PROTEIN SSO7C3', NULL, NULL, NULL, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(242315, NULL, 'PTHR14843', NULL, NULL, NULL, NULL, 'DEUBIQUITINATING PROTEIN VCIP135', NULL, NULL, 27227, 8),
(242316, NULL, 'PTHR33427', NULL, NULL, NULL, NULL, 'HNH ENDONUCLEASE', NULL, NULL, NULL, 8),
(242317, NULL, 'PTHR45678', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 2-OXODICARBOXYLATE CARRIER 1-RELATED', NULL, NULL, NULL, 8),
(242318, NULL, 'PTHR33802', NULL, NULL, NULL, NULL, 'SI:CH211-161H7.5-RELATED', NULL, NULL, NULL, 8),
(242319, NULL, 'PTHR10337', NULL, NULL, NULL, NULL, 'SHC TRANSFORMING PROTEIN', NULL, NULL, NULL, 8),
(242320, NULL, 'PTHR31902', NULL, NULL, NULL, NULL, 'ACTIN PATCHES DISTAL PROTEIN 1', NULL, NULL, 12051, 8),
(242321, NULL, 'PTHR42786', NULL, NULL, NULL, NULL, 'TRNA/RRNA METHYLTRANSFERASE', NULL, NULL, 5935, 8),
(242322, NULL, 'PTHR43818', NULL, NULL, NULL, NULL, 'BCDNA.GH03377', NULL, NULL, NULL, 8),
(242323, NULL, 'PTHR11560', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L10, MITOCHONDRIAL', NULL, NULL, 4424, 8),
(242324, NULL, 'PTHR44006', NULL, NULL, NULL, NULL, 'U5 SMALL NUCLEAR RIBONUCLEOPROTEIN 40 KDA PROTEIN', NULL, NULL, NULL, 8),
(242325, NULL, 'PTHR38081', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(242326, NULL, 'PTHR23317', NULL, NULL, NULL, NULL, 'DEDICATOR OF CYTOKINESIS  DOCK', NULL, NULL, 22644, 8),
(242327, NULL, 'PTHR37234', NULL, NULL, NULL, NULL, 'OS03G0319200 PROTEIN', NULL, NULL, NULL, 8),
(242328, NULL, 'PTHR48003', NULL, NULL, NULL, NULL, 'OS07G0626500 PROTEIN', NULL, NULL, NULL, 8),
(242329, NULL, 'PTHR47568', NULL, NULL, NULL, NULL, '', NULL, NULL, 34781, 8),
(242330, NULL, 'PTHR15614', NULL, NULL, NULL, NULL, 'INTRAFLAGELLAR TRANSPORT PROTEIN 81 HOMOLOG', NULL, NULL, 24816, 8),
(242331, NULL, 'PTHR18861', NULL, NULL, NULL, NULL, 'ELKS/RAB6-INTERACTING/CAST PROTEIN', NULL, NULL, NULL, 8),
(242332, NULL, 'PTHR35890', NULL, NULL, NULL, NULL, '', NULL, NULL, 2860, 8),
(242333, NULL, 'PTHR47298', NULL, NULL, NULL, NULL, 'OXIDIZED LOW-DENSITY LIPOPROTEIN RECEPTOR 1', NULL, NULL, NULL, 8),
(242334, NULL, 'PTHR46168', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT ONLY 4', NULL, NULL, NULL, 8),
(242335, NULL, 'PTHR11510', NULL, NULL, NULL, NULL, 'MYO-INOSITOL-1 PHOSPHATE SYNTHASE', NULL, NULL, 1907, 8),
(242336, NULL, 'PTHR36147', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(242337, NULL, 'PTHR35118', NULL, NULL, NULL, NULL, 'KINASE FAMILY PROTEIN', NULL, NULL, NULL, 8),
(242338, NULL, 'PTHR34859', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', NULL, NULL, NULL, 8),
(242339, NULL, 'PTHR23164', NULL, NULL, NULL, NULL, 'EARLY ENDOSOME ANTIGEN 1', NULL, NULL, NULL, 8),
(242340, NULL, 'PTHR31685', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_6G12730)-RELATED', NULL, NULL, NULL, 8),
(242341, NULL, 'PTHR11093', NULL, NULL, NULL, NULL, 'RUVB-RELATED REPTIN AND PONTIN', NULL, NULL, 26238, 8),
(242342, NULL, 'PTHR39959', NULL, NULL, NULL, NULL, 'RE44287P-RELATED', NULL, NULL, NULL, 8),
(242343, NULL, 'PTHR33512', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF1191)-RELATED', NULL, NULL, 8155, 8),
(242344, NULL, 'PTHR35489', NULL, NULL, NULL, NULL, 'TITAN9', NULL, NULL, NULL, 8),
(242345, NULL, 'PTHR33411', NULL, NULL, NULL, NULL, 'OS08G0392500 PROTEIN', NULL, NULL, NULL, 8),
(242346, NULL, 'PTHR40516', NULL, NULL, NULL, NULL, 'ANTITOXIN CHPS-RELATED', NULL, NULL, 33484, 8),
(242347, NULL, 'PTHR47893', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN PCHR', NULL, NULL, NULL, 8),
(242348, NULL, 'PTHR38338', NULL, NULL, NULL, NULL, 'AGAP013079-PA', NULL, NULL, NULL, 8),
(242349, NULL, 'PTHR48109', NULL, NULL, NULL, NULL, 'DIHYDROOROTATE DEHYDROGENASE (QUINONE), MITOCHONDRIAL-RELATED', NULL, NULL, NULL, 8),
(242350, NULL, 'PTHR39323', NULL, NULL, NULL, NULL, 'BLR1149 PROTEIN', NULL, NULL, NULL, 8),
(242351, NULL, 'PTHR39330', NULL, NULL, NULL, NULL, 'ETHANOLAMINE AMMONIA-LYASE LIGHT CHAIN', NULL, NULL, 13604, 8),
(242352, NULL, 'PTHR48070', NULL, NULL, NULL, NULL, 'ESTERASE OVCA2', NULL, NULL, NULL, 8),
(242353, NULL, 'PTHR43275', NULL, NULL, NULL, NULL, 'D-MALATE DEHYDROGENASE [DECARBOXYLATING]', NULL, NULL, NULL, 8),
(242354, NULL, 'PTHR35340', NULL, NULL, NULL, NULL, 'PQQ ENZYME REPEAT PROTEIN-RELATED', NULL, NULL, NULL, 8);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(242355, NULL, 'PTHR45844', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH30', NULL, NULL, 36406, 8),
(242356, NULL, 'PTHR39084', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(242357, NULL, 'PTHR36874', NULL, NULL, NULL, NULL, 'EQUATORIN', NULL, NULL, 26406, 8),
(242358, NULL, 'PTHR43620', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHORYL DIESTER PHOSPHODIESTERASE', NULL, NULL, NULL, 8),
(242359, NULL, 'PTHR33640', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(242360, NULL, 'PTHR45005', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(242361, NULL, 'PTHR33246', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(242362, NULL, 'PTHR12015', NULL, NULL, NULL, NULL, 'SMALL INDUCIBLE CYTOKINE A', NULL, NULL, 28302, 8),
(242363, NULL, 'PTHR31568', NULL, NULL, NULL, NULL, 'RCG49325, ISOFORM CRA_A', NULL, NULL, 34657, 8),
(242364, NULL, 'PTHR34180', NULL, NULL, NULL, NULL, 'PEPTIDASE C45', NULL, NULL, NULL, 8),
(242365, NULL, 'PTHR36745', NULL, NULL, NULL, NULL, 'OS02G0824400 PROTEIN', NULL, NULL, NULL, 8),
(242366, NULL, 'PTHR36051', NULL, NULL, NULL, NULL, 'DYNAMIN', NULL, NULL, NULL, 8),
(242367, NULL, 'PTHR10773', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASES I, II, AND III SUBUNIT RPABC2', NULL, NULL, NULL, 8),
(242368, NULL, 'PTHR48150', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE-ASSEMBLY FACTOR COX23, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(242369, NULL, 'PTHR47580', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE FAMILY PROTEIN', NULL, NULL, NULL, 8),
(242370, NULL, 'PTHR11561', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYKINASE', NULL, NULL, 7480, 8),
(242371, NULL, 'PTHR38074', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN 24, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(242372, NULL, 'PTHR10009', NULL, NULL, NULL, NULL, 'PROTEIN YELLOW-RELATED', NULL, NULL, 19326, 8),
(242373, NULL, 'PTHR11616', NULL, NULL, NULL, NULL, 'SODIUM/CHLORIDE DEPENDENT TRANSPORTER', NULL, NULL, 3769, 8),
(242374, NULL, 'PTHR32448', NULL, NULL, NULL, NULL, 'OS08G0158400 PROTEIN', NULL, NULL, NULL, 8),
(242375, NULL, 'PTHR39965', NULL, NULL, NULL, NULL, 'CRISPR SYSTEM CMR SUBUNIT CMR6', NULL, NULL, 10642, 8),
(242376, NULL, 'PTHR12812', NULL, NULL, NULL, NULL, 'HEPARAN SULFATE 6-O-SULFOTRANSFERASE 3', NULL, NULL, 9113, 8),
(242377, NULL, 'PTHR34958', NULL, NULL, NULL, NULL, 'CONDITIONAL LOSS-OF-GROWTH 1', NULL, NULL, NULL, 8),
(242378, NULL, 'PTHR12565', NULL, NULL, NULL, NULL, 'STEROL REGULATORY ELEMENT-BINDING PROTEIN', NULL, NULL, 18637, 8),
(242379, NULL, 'PTHR21558', NULL, NULL, NULL, NULL, 'SPEER/SPETEX', NULL, NULL, NULL, 8),
(242380, NULL, 'PTHR46856', NULL, NULL, NULL, NULL, 'PX DOMAIN-CONTAINING PROTEIN EREL1-RELATED', NULL, NULL, 34277, 8),
(242381, NULL, 'PTHR41403', NULL, NULL, NULL, NULL, 'RCG43477-RELATED', NULL, NULL, 31474, 8),
(242382, NULL, 'PTHR35408', NULL, NULL, NULL, NULL, 'CHROMOSOME 15, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(242383, NULL, 'PTHR33588', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 299', NULL, NULL, 25521, 8),
(242384, NULL, 'PTHR46725', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 57', NULL, NULL, 34852, 8),
(242385, NULL, 'PTHR43807', NULL, NULL, NULL, NULL, 'FI04487P', NULL, NULL, NULL, 8),
(242386, NULL, 'PTHR28184', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL HOMOLOGOUS RECOMBINATION PROTEIN 1', NULL, NULL, 13866, 8),
(242387, NULL, 'PTHR46185', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-1', NULL, NULL, NULL, 8),
(242388, NULL, 'PTHR42955', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE', NULL, NULL, NULL, 8),
(242389, NULL, 'PTHR18914', NULL, NULL, NULL, NULL, 'ALPHA CATENIN', NULL, NULL, NULL, 8),
(242390, NULL, 'PTHR10612', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN D', NULL, NULL, NULL, 8),
(242391, NULL, 'PTHR48201', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(242392, NULL, 'PTHR21425', NULL, NULL, NULL, NULL, 'NICE-3', NULL, NULL, 11949, 8),
(242393, NULL, 'PTHR34236', NULL, NULL, NULL, NULL, 'DIMETHYL SULFOXIDE REDUCTASE TRANSCRIPTIONAL ACTIVATOR', NULL, NULL, NULL, 8);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(242394, NULL, 'PTHR46909', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L36, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(242395, NULL, 'PTHR46203', NULL, NULL, NULL, NULL, 'PROBABLE PEPTIDE CHAIN RELEASE FACTOR C12ORF65', NULL, NULL, NULL, 8),
(242396, NULL, 'PTHR33591', NULL, NULL, NULL, NULL, 'BETA-CAROTENE ISOMERASE D27', NULL, NULL, 31593, 8),
(242397, NULL, 'PTHR22991', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(242398, NULL, 'PTHR24256', NULL, NULL, NULL, NULL, 'TRYPTASE-RELATED', NULL, NULL, NULL, 8),
(242399, NULL, 'PTHR34541', NULL, NULL, NULL, NULL, 'OS01G0729900 PROTEIN', NULL, NULL, NULL, 8),
(242400, NULL, 'PTHR25462', NULL, NULL, NULL, NULL, 'BONUS, ISOFORM C-RELATED', NULL, NULL, NULL, 8),
(242401, NULL, 'PTHR43579', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(242402, NULL, 'PTHR42038', NULL, NULL, NULL, NULL, '', NULL, NULL, 31860, 8),
(242403, NULL, 'PTHR10293', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN FAMILY MEMBER', NULL, NULL, 7251, 8),
(242404, NULL, 'PTHR43503', NULL, NULL, NULL, NULL, 'MCG48959-RELATED', NULL, NULL, NULL, 8),
(242405, NULL, 'PTHR13859', NULL, NULL, NULL, NULL, 'ATROPHIN-RELATED', NULL, NULL, NULL, 8),
(242406, NULL, 'PTHR13353', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 19', NULL, NULL, 4852, 8),
(242407, NULL, 'PTHR43732', NULL, NULL, NULL, NULL, 'RIBOSE 5-PHOSPHATE ISOMERASE-RELATED', NULL, NULL, NULL, 8),
(242408, NULL, 'PTHR38000', NULL, NULL, NULL, NULL, 'RIKEN CDNA 2900092C05', NULL, NULL, 33329, 8),
(242409, NULL, 'PTHR24350', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE IAL-RELATED', NULL, NULL, 24677, 8),
(242410, NULL, 'PTHR35136', NULL, NULL, NULL, NULL, 'CYCLOEUCALENOL CYCLOISOMERASE', NULL, NULL, 21077, 8),
(242411, NULL, 'PTHR12302', NULL, NULL, NULL, NULL, 'EBNA2 BINDING PROTEIN P100', NULL, NULL, NULL, 8),
(242412, NULL, 'PTHR44191', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR KUA1', NULL, NULL, NULL, 8),
(242413, NULL, 'PTHR10536', NULL, NULL, NULL, NULL, 'DNA PRIMASE SMALL SUBUNIT', NULL, NULL, 9089, 8),
(242414, NULL, 'PTHR21057', NULL, NULL, NULL, NULL, 'PHOSPHO-2-DEHYDRO-3-DEOXYHEPTONATE ALDOLASE', NULL, NULL, 3925, 8),
(242415, NULL, 'PTHR30272', NULL, NULL, NULL, NULL, '3-HYDROXYACYL-[ACYL-CARRIER-PROTEIN] DEHYDRATASE', NULL, NULL, 18899, 8),
(242416, NULL, 'PTHR10110', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER', NULL, NULL, 21401, 8),
(242417, NULL, 'PTHR36793', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA SMALL SUBUNIT METHYLTRANSFERASE J', NULL, NULL, NULL, 8),
(242418, NULL, 'PTHR37375', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(242419, NULL, 'PTHR35184', NULL, NULL, NULL, NULL, 'YALI0C10208P', NULL, NULL, NULL, 8),
(242420, NULL, 'PTHR46571', NULL, NULL, NULL, NULL, 'SORTING NEXIN-8', NULL, NULL, 22659, 8),
(242421, NULL, 'PTHR31765', NULL, NULL, NULL, NULL, 'PROTEIN CBG12783', NULL, NULL, NULL, 8),
(242422, NULL, 'PTHR14150', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RNA-ASSOCIATED PROTEIN 14', NULL, NULL, 2243, 8),
(242423, NULL, 'PTHR35813', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YBAN', NULL, NULL, 3520, 8),
(242424, NULL, 'PTHR15924', NULL, NULL, NULL, NULL, 'CLE', NULL, NULL, 19539, 8),
(242425, NULL, 'PTHR46327', NULL, NULL, NULL, NULL, 'F16F4.11 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(242426, NULL, 'PTHR42972', NULL, NULL, NULL, NULL, 'TOL-PAL SYSTEM PROTEIN TOLB', NULL, NULL, NULL, 8),
(242427, NULL, 'PTHR21450', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(242428, NULL, 'PTHR43433', NULL, NULL, NULL, NULL, 'HYDROLASE, ALPHA/BETA FOLD FAMILY PROTEIN', NULL, NULL, NULL, 8),
(242429, NULL, 'PTHR46954', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(242430, NULL, 'PTHR18842', NULL, NULL, NULL, NULL, 'INTERLEUKIN-1 RECEPTOR-ASSOCIATED KINASE 1-BINDING PROTEIN 1', NULL, NULL, 23303, 8),
(242431, NULL, 'PTHR45267', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(242432, NULL, 'PTHR28139', NULL, NULL, NULL, NULL, 'UPF0768 PROTEIN YBL029C-A', NULL, NULL, NULL, 8),
(242433, NULL, 'PTHR33989', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(242434, NULL, 'PTHR33472', NULL, NULL, NULL, NULL, 'OS01G0106600 PROTEIN', NULL, NULL, NULL, 8),
(242435, NULL, 'PTHR48306', NULL, NULL, NULL, NULL, 'XYLOSE ISOMERASE', NULL, NULL, NULL, 8),
(242436, NULL, 'PTHR30013', NULL, NULL, NULL, NULL, 'NIFE / NIFESE HYDROGENASE SMALL SUBUNIT FAMILY MEMBER', NULL, NULL, 4482, 8),
(242437, NULL, 'PTHR35128', NULL, NULL, NULL, NULL, 'SECRETION-REGULATING GUANINE NUCLEOTIDE EXCHANGE FACTOR', NULL, NULL, NULL, 8),
(242438, NULL, 'PTHR33745', NULL, NULL, NULL, NULL, 'RSBT ANTAGONIST PROTEIN RSBS-RELATED', NULL, NULL, NULL, 8),
(242439, NULL, 'PTHR35218', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(242440, NULL, 'PTHR35665', NULL, NULL, NULL, NULL, 'PROTEIN LKAAEAR1', NULL, NULL, 25885, 8),
(242441, NULL, 'PTHR15057', NULL, NULL, NULL, NULL, 'STATHERIN', NULL, NULL, 25783, 8),
(242442, NULL, 'PTHR12001', NULL, NULL, NULL, NULL, 'GERANYLGERANYL PYROPHOSPHATE SYNTHASE', NULL, NULL, NULL, 8),
(242443, NULL, 'PTHR45712', NULL, NULL, NULL, NULL, 'AGAP008170-PA', NULL, NULL, NULL, 8),
(242444, NULL, 'PTHR11562', NULL, NULL, NULL, NULL, 'CATION EFFLUX PROTEIN/ ZINC TRANSPORTER', NULL, NULL, NULL, 8),
(242445, NULL, 'PTHR47545', NULL, NULL, NULL, NULL, 'MULTIFUNCTIONAL CCA PROTEIN', NULL, NULL, NULL, 8),
(242446, NULL, 'PTHR45080', NULL, NULL, NULL, NULL, 'CONTACTIN 5', NULL, NULL, NULL, 8),
(242447, NULL, 'PTHR43061', NULL, NULL, NULL, NULL, 'GTP DIPHOSPHOKINASE RSH1, CHLOROPLASTIC-RELATED', NULL, NULL, NULL, 8),
(242448, NULL, 'PTHR33874', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN', NULL, NULL, NULL, 8),
(242449, NULL, 'PTHR36985', NULL, NULL, NULL, NULL, 'TRANSLOCATION AND ASSEMBLY MODULE SUBUNIT TAMB', NULL, NULL, NULL, 8),
(242450, NULL, 'PTHR30598', NULL, NULL, NULL, NULL, 'NITRATE REDUCTASE PRIVATE CHAPERONE, REDOX ENZYME MATURATION PROTEIN  REMP  FAMILY', NULL, NULL, NULL, 8),
(242451, NULL, 'PTHR36575', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G14430)-RELATED', NULL, NULL, NULL, 8),
(242452, NULL, 'PTHR14944', NULL, NULL, NULL, NULL, 'RPA-RELATED PROTEIN RADX', NULL, NULL, 32018, 8),
(242453, NULL, 'PTHR46863', NULL, NULL, NULL, NULL, 'OS09G0572100 PROTEIN', NULL, NULL, NULL, 8),
(242454, NULL, 'PTHR46151', NULL, NULL, NULL, NULL, 'NEP1-INTERACTING PROTEIN-LIKE 2', NULL, NULL, 34897, 8),
(242455, NULL, 'PTHR23346', NULL, NULL, NULL, NULL, 'TRANSLATIONAL ACTIVATOR GCN1-RELATED', NULL, NULL, NULL, 8),
(242456, NULL, 'PTHR36399', NULL, NULL, NULL, NULL, 'PHOTOSYNTHETIC NDH SUBUNIT OF SUBCOMPLEX B 5, CHLOROPLASTIC', NULL, NULL, 18235, 8),
(242457, NULL, 'PTHR39473', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(242458, NULL, 'PTHR48242', NULL, NULL, NULL, NULL, 'BNAA02G09820D PROTEIN', NULL, NULL, NULL, 8),
(242459, NULL, 'PTHR35564', NULL, NULL, NULL, NULL, '', NULL, NULL, 9807, 8),
(242460, NULL, 'PTHR12159', NULL, NULL, NULL, NULL, 'G/T AND G/U MISMATCH-SPECIFIC DNA GLYCOSYLASE', NULL, NULL, 17999, 8),
(242461, NULL, 'PTHR47517', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN-RELATED', NULL, NULL, NULL, 8),
(242462, NULL, 'PTHR13264', NULL, NULL, NULL, NULL, 'GCIP-INTERACTING PROTEIN P29', NULL, NULL, 13445, 8),
(242463, NULL, 'PTHR42202', NULL, NULL, NULL, NULL, 'GTP CYCLOHYDROLASE III', NULL, NULL, 2033, 8),
(242464, NULL, 'PTHR10954', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H2 SUBUNIT A', NULL, NULL, 2316, 8),
(242465, NULL, 'PTHR22552', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(242466, NULL, 'PTHR33746', NULL, NULL, NULL, NULL, 'RUBRERYTHRIN', NULL, NULL, NULL, 8),
(242467, NULL, 'PTHR22738', NULL, NULL, NULL, NULL, 'RASSF', NULL, NULL, 31335, 8),
(242468, NULL, 'PTHR28079', NULL, NULL, NULL, NULL, 'RNA POLYMERASE I-SPECIFIC TRANSCRIPTION INITIATION FACTOR RRN5', NULL, NULL, 27342, 8),
(242469, NULL, 'PTHR12111', NULL, NULL, NULL, NULL, 'SPLICING FACTOR YJU2', NULL, NULL, 2664, 8),
(242470, NULL, 'PTHR12995', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 16587, 8),
(242471, NULL, 'PTHR33067', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(242472, NULL, 'PTHR42810', NULL, NULL, NULL, NULL, 'PURINE PERMEASE C1399.01C-RELATED', NULL, NULL, NULL, 8);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(242473, NULL, 'PTHR23007', NULL, NULL, NULL, NULL, 'CBL', NULL, NULL, 9672, 8),
(242474, NULL, 'PTHR37315', NULL, NULL, NULL, NULL, 'UPF0311 PROTEIN BLR7842', NULL, NULL, 14508, 8),
(242475, NULL, 'PTHR42758', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLGLYCEROL PHOSPHOLIPASE C', NULL, NULL, NULL, 8),
(242476, NULL, 'PTHR12203', NULL, NULL, NULL, NULL, 'KDEL  LYS-ASP-GLU-LEU  CONTAINING - RELATED', NULL, NULL, NULL, 8),
(242477, NULL, 'PTHR35974', NULL, NULL, NULL, NULL, 'NONCOMPACT MYELIN-ASSOCIATED PROTEIN', NULL, NULL, 29294, 8),
(242478, NULL, 'PTHR21765', NULL, NULL, NULL, NULL, 'SIMILAR TO CHROMODOMAIN-HELICASE-DNA-BINDING PROTEIN 1 (CHD-1)', NULL, NULL, 27480, 8),
(242479, NULL, 'PTHR33332', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(242480, NULL, 'PTHR19447', NULL, NULL, NULL, NULL, 'OOCYTE-EXPRESSED PROTEIN HOMOLOG-RELATED', NULL, NULL, NULL, 8),
(242481, NULL, 'PTHR30502', NULL, NULL, NULL, NULL, '2-KETO-3-DEOXY-L-RHAMNONATE ALDOLASE', NULL, NULL, NULL, 8),
(242482, NULL, 'PTHR38341', NULL, NULL, NULL, NULL, 'FRUCTOSE-1,6-BISPHOSPHATE ALDOLASE/PHOSPHATASE', NULL, NULL, 4556, 8),
(242483, NULL, 'PTHR28023', NULL, NULL, NULL, NULL, 'UPF0357 PROTEIN YCL012C', NULL, NULL, 15278, 8),
(242484, NULL, 'PTHR45024', NULL, NULL, NULL, NULL, 'DEHYDROGENASES, SHORT CHAIN', NULL, NULL, NULL, 8),
(242485, NULL, 'PTHR47852', NULL, NULL, NULL, NULL, 'OS06G0298400 PROTEIN', NULL, NULL, NULL, 8),
(242486, NULL, 'PTHR33845', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(242487, NULL, 'PTHR44548', NULL, NULL, NULL, NULL, 'GST N-TERMINAL DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(242488, NULL, 'PTHR14680', NULL, NULL, NULL, NULL, 'SI:DKEY-126G1.9-RELATED', NULL, NULL, 26326, 8),
(242489, NULL, 'PTHR21541', NULL, NULL, NULL, NULL, 'BTB  POZ  DOMAIN CONTAINING 12', NULL, NULL, NULL, 8),
(242490, NULL, 'PTHR38607', NULL, NULL, NULL, NULL, 'PROTEIN CBG00180-RELATED', NULL, NULL, NULL, 8),
(242491, NULL, 'PTHR28005', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 17', NULL, NULL, 6638, 8),
(242492, NULL, 'PTHR37285', NULL, NULL, NULL, NULL, '', NULL, NULL, 2364, 8),
(242493, NULL, 'PTHR31530', NULL, NULL, NULL, NULL, 'MAJOR INTRINSICALLY DISORDERED NOTCH2-BINDING RECEPTOR 1 MINAR1 FAMILY MEMBER', NULL, NULL, 28107, 8),
(242494, NULL, 'PTHR43662', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(242495, NULL, 'PTHR34838', NULL, NULL, NULL, NULL, 'OS08G0142100 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(242496, NULL, 'PTHR12221', NULL, NULL, NULL, NULL, 'PESCADILLO - RELATED', NULL, NULL, 8253, 8),
(242497, NULL, 'PTHR21363', NULL, NULL, NULL, NULL, 'PREPHENATE DEHYDROGENASE', NULL, NULL, NULL, 8),
(242498, NULL, 'PTHR36362', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT BETA', NULL, NULL, NULL, 8),
(242499, NULL, 'PTHR36328', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(242500, NULL, 'PTHR35369', NULL, NULL, NULL, NULL, 'BLR3025 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(242501, NULL, 'PTHR37221', NULL, NULL, NULL, NULL, 'OS02G0582400 PROTEIN', NULL, NULL, NULL, 8),
(242502, NULL, 'PTHR35989', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 32', NULL, NULL, 31688, 8),
(242503, NULL, 'PTHR33593', NULL, NULL, NULL, NULL, 'DUF1442 FAMILY PROTEIN', NULL, NULL, 14278, 8),
(242504, NULL, 'PTHR12715', NULL, NULL, NULL, NULL, 'TRANSPORTER, DRUG/METABOLITE EXPORTER FAMILY', NULL, NULL, NULL, 8),
(242505, NULL, 'PTHR45810', NULL, NULL, NULL, NULL, 'HISTONE H3.2', NULL, NULL, 1526, 8),
(242506, NULL, 'PTHR46935', NULL, NULL, NULL, NULL, 'OS01G0674700 PROTEIN', NULL, NULL, 36468, 8),
(242507, NULL, 'PTHR15321', NULL, NULL, NULL, NULL, 'TUMOR SUPPRESSOR P53-BINDING PROTEIN 1', NULL, NULL, NULL, 8),
(242508, NULL, 'PTHR16103', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 140', NULL, NULL, 21528, 8),
(242509, NULL, 'PTHR46635', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE FAMILY 1 PROTEIN', NULL, NULL, NULL, 8),
(242510, NULL, 'PTHR21348', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 20272, 8);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(242511, NULL, 'PTHR39937', NULL, NULL, NULL, NULL, 'ATP SYNTHASE PROTEIN 8', NULL, NULL, NULL, 8),
(242512, NULL, 'PTHR35731', NULL, NULL, NULL, NULL, '8-AMINO-7-OXONONANOATE SYNTHASE', NULL, NULL, NULL, 8),
(242513, NULL, 'PTHR43723', NULL, NULL, NULL, NULL, 'COBALT TRANSPORT PROTEIN CBIQ', NULL, NULL, NULL, 8),
(242514, NULL, 'PTHR22793', NULL, NULL, NULL, NULL, 'MYOCARDIN-RELATED TRANSCRIPTION FACTOR-RELATED', NULL, NULL, 33821, 8),
(242515, NULL, 'PTHR46445', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II DEGRADATION FACTOR-LIKE PROTEIN (DUF1296)', NULL, NULL, NULL, 8),
(242516, NULL, 'PTHR45766', NULL, NULL, NULL, NULL, 'DNA ANNEALING HELICASE AND ENDONUCLEASE ZRANB3 FAMILY MEMBER', NULL, NULL, NULL, 8),
(242517, NULL, 'PTHR42871', NULL, NULL, NULL, NULL, 'CITRATE SYNTHASE', NULL, NULL, NULL, 8),
(242518, NULL, 'PTHR15951', NULL, NULL, NULL, NULL, 'T-CELL RECEPTOR-ASSOCIATED TRANSMEMBRANE ADAPTER 1', NULL, NULL, 20900, 8),
(242519, NULL, 'PTHR32122', NULL, NULL, NULL, NULL, 'TATA BOX-BINDING PROTEIN ASSOCIATED FACTOR RNA POLYMERASE I SUBUNIT A', NULL, NULL, NULL, 8),
(242520, NULL, 'PTHR35807', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR REDD-RELATED', NULL, NULL, NULL, 8),
(242521, NULL, 'PTHR15904', NULL, NULL, NULL, NULL, 'FAM13', NULL, NULL, 31615, 8),
(242522, NULL, 'PTHR12084', NULL, NULL, NULL, NULL, 'NUCLEAR PORE GLYCOPROTEIN P62-RELATED', NULL, NULL, 22505, 8),
(242523, NULL, 'PTHR22806', NULL, NULL, NULL, NULL, 'NUCLEOPORIN NUP37  P37 -RELATED', NULL, NULL, 32949, 8),
(242524, NULL, 'PTHR36756', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(242525, NULL, 'PTHR43693', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE CHEZ', NULL, NULL, NULL, 8),
(242526, NULL, 'PTHR13222', NULL, NULL, NULL, NULL, 'RB1-INDUCIBLE COILED-COIL', NULL, NULL, 27547, 8),
(242527, NULL, 'PTHR47897', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 124', NULL, NULL, NULL, 8),
(242528, NULL, 'PTHR12124', NULL, NULL, NULL, NULL, 'POLYMYOSITIS/SCLERODERMA AUTOANTIGEN-RELATED', NULL, NULL, 36796, 8),
(242529, NULL, 'PTHR37239', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN 9', NULL, NULL, 22898, 8),
(242530, NULL, 'PTHR45098', NULL, NULL, NULL, NULL, 'DNAJ DOMAIN CONTAINING PROTEIN, EXPRESSED', NULL, NULL, NULL, 8),
(242531, NULL, 'PTHR11432', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE SUBUNIT 1', NULL, NULL, 3295, 8),
(242532, NULL, 'PTHR47770', NULL, NULL, NULL, NULL, 'PLANT UBX DOMAIN-CONTAINING PROTEIN 11', NULL, NULL, NULL, 8),
(242533, NULL, 'PTHR36109', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(242534, NULL, 'PTHR47930', NULL, NULL, NULL, NULL, 'YALI0C12947P', NULL, NULL, NULL, 8),
(242535, NULL, 'PTHR28118', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDE 5''-TRIPHOSPHATASE-RELATED', NULL, NULL, 27127, 8),
(242536, NULL, 'PTHR37833', NULL, NULL, NULL, NULL, 'LIPOPROTEIN-RELATED', NULL, NULL, NULL, 8),
(242537, NULL, 'PTHR36372', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(242538, NULL, 'PTHR15898', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(242539, NULL, 'PTHR37838', NULL, NULL, NULL, NULL, 'NA(+)-TRANSLOCATING NADH-QUINONE REDUCTASE SUBUNIT C', NULL, NULL, 4170, 8),
(242540, NULL, 'PTHR22973', NULL, NULL, NULL, NULL, 'LD35087P', NULL, NULL, NULL, 8),
(242541, NULL, 'PTHR34968', NULL, NULL, NULL, NULL, 'AUGMIN SUBUNIT 5', NULL, NULL, 36129, 8),
(242542, NULL, 'PTHR31060', NULL, NULL, NULL, NULL, 'OSJNBA0011J08.25 PROTEIN-RELATED', NULL, NULL, 27218, 8),
(242543, NULL, 'PTHR31672', NULL, NULL, NULL, NULL, 'BNACNNG10540D PROTEIN', NULL, NULL, NULL, 8),
(242544, NULL, 'PTHR47096', NULL, NULL, NULL, NULL, 'MISSHAPEN LIKE KINASE 1', NULL, NULL, NULL, 8),
(242545, NULL, 'PTHR10819', NULL, NULL, NULL, NULL, 'PHOSPHOTRIESTERASE-RELATED', NULL, NULL, 5123, 8),
(242546, NULL, 'PTHR48005', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT KINASE 2', NULL, NULL, NULL, 8),
(242547, NULL, 'PTHR45915', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INTERMEDIARY FACTOR', NULL, NULL, NULL, 8),
(242548, NULL, 'PTHR21859', NULL, NULL, NULL, NULL, 'ACROSOME-SPECIFIC PROTEIN', NULL, NULL, NULL, 8);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(242549, NULL, 'PTHR12027', NULL, NULL, NULL, NULL, 'WNT RELATED', NULL, NULL, 5688, 8),
(242550, NULL, 'PTHR32024', NULL, NULL, NULL, NULL, 'TRK SYSTEM POTASSIUM UPTAKE PROTEIN TRKG-RELATED', NULL, NULL, NULL, 8),
(242551, NULL, 'PTHR36452', NULL, NULL, NULL, NULL, 'CHROMOSOME 12, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, 12502, 8),
(242552, NULL, 'PTHR47679', NULL, NULL, NULL, NULL, 'PROTEIN TORNADO 1', NULL, NULL, NULL, 8),
(242553, NULL, 'PTHR31975', NULL, NULL, NULL, NULL, 'BUD SITE SELECTION PROTEIN 7-RELATED', NULL, NULL, 14396, 8),
(242554, NULL, 'PTHR46592', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL67', NULL, NULL, 34005, 8),
(242555, NULL, 'PTHR37739', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIN-12D', NULL, NULL, 36850, 8),
(242556, NULL, 'PTHR13100', NULL, NULL, NULL, NULL, 'CELL GROWTH-REGULATING NUCLEOLAR PROTEIN LYAR', NULL, NULL, 27424, 8),
(242557, NULL, 'PTHR39414', NULL, NULL, NULL, NULL, 'SERINE/ARGININE REPETITIVE MATRIX PROTEIN 5-RELATED', NULL, NULL, NULL, 8),
(242558, NULL, 'PTHR36866', NULL, NULL, NULL, NULL, 'CHROMOSOME 4 OPEN READING FRAME 50', NULL, NULL, NULL, 8),
(242559, NULL, 'PTHR47070', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN-LIKE', NULL, NULL, NULL, 8),
(242560, NULL, 'PTHR34501', NULL, NULL, NULL, NULL, 'PROTEIN YDDL-RELATED', NULL, NULL, NULL, 8),
(242561, NULL, 'PTHR31951', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN-RELATED', NULL, NULL, NULL, 8),
(242562, NULL, 'PTHR42967', NULL, NULL, NULL, NULL, 'METAL DEPENDENT HYDROLASE', NULL, NULL, NULL, 8),
(242563, NULL, 'PTHR14374', NULL, NULL, NULL, NULL, 'FOIE GRAS', NULL, NULL, NULL, 8),
(242564, NULL, 'PTHR40106', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN RCLC', NULL, NULL, 5769, 8),
(242565, NULL, 'PTHR39191', NULL, NULL, NULL, NULL, 'GALACTOSE-1-PHOSPHATE URIDYLYLTRANSFERASE', NULL, NULL, 6770, 8),
(242566, NULL, 'PTHR46731', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 15', NULL, NULL, NULL, 8),
(242567, NULL, 'PTHR44656', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE SDR FAMILY MEMBER 12', NULL, NULL, NULL, 8),
(242568, NULL, 'PTHR45977', NULL, NULL, NULL, NULL, 'TARGET OF ERK KINASE MPK-1', NULL, NULL, NULL, 8),
(242569, NULL, 'PTHR34216', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(242570, NULL, 'PTHR33395', NULL, NULL, NULL, NULL, 'TRANSCRIPTASE, PUTATIVE-RELATED-RELATED', NULL, NULL, NULL, 8),
(242571, NULL, 'PTHR42826', NULL, NULL, NULL, NULL, 'DICARBOXYLATE TRANSPORTER 2.1, CHLOROPLASTIC', NULL, NULL, 23866, 8),
(242572, NULL, 'PTHR22731', NULL, NULL, NULL, NULL, 'RIBONUCLEASES P/MRP PROTEIN SUBUNIT POP1', NULL, NULL, 32763, 8),
(242573, NULL, 'PTHR36727', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT L, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(242574, NULL, 'PTHR47021', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN AGD6-RELATED', NULL, NULL, 35219, 8),
(242575, NULL, 'PTHR34218', NULL, NULL, NULL, NULL, 'PEPTIDASE S45 PENICILLIN AMIDASE', NULL, NULL, 3777, 8),
(242576, NULL, 'PTHR38409', NULL, NULL, NULL, NULL, 'MDM10-COMPLEMENTING PROTEIN 1', NULL, NULL, 27860, 8),
(242577, NULL, 'PTHR14401', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN K', NULL, NULL, 14696, 8),
(242578, NULL, 'PTHR15853', NULL, NULL, NULL, NULL, 'THIOREDOXIN-RELATED', NULL, NULL, 31506, 8),
(242579, NULL, 'PTHR31961', NULL, NULL, NULL, NULL, 'SENSITIVE TO HIGH EXPRESSION PROTEIN 9, MITOCHONDRIAL', NULL, NULL, 13949, 8),
(242580, NULL, 'PTHR15976', NULL, NULL, NULL, NULL, 'CONSTITUTIVE COACTIVATOR OF PEROXISOME PROLIFERATOR-ACTIVATED RECEPTOR GAMMA', NULL, NULL, 25709, 8),
(242581, NULL, 'PTHR47437', NULL, NULL, NULL, NULL, 'JNK-INTERACTING PROTEIN 1-LIKE PROTEIN', NULL, NULL, NULL, 8),
(242582, NULL, 'PTHR43852', NULL, NULL, NULL, NULL, 'NUCLEOTIDYLTRANSFERASE', NULL, NULL, NULL, 8),
(242583, NULL, 'PTHR37960', NULL, NULL, NULL, NULL, 'PROTEIN CBG06493-RELATED', NULL, NULL, NULL, 8),
(242584, NULL, 'PTHR28011', NULL, NULL, NULL, NULL, 'NON-CLASSICAL EXPORT PROTEIN 1', NULL, NULL, 20341, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(242585, NULL, 'PTHR47308', NULL, NULL, NULL, NULL, 'NUCLEAR GTPASE SLIP-GC', NULL, NULL, NULL, 8),
(242586, NULL, 'PTHR21726', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL N-ACETYLGLUCOSAMINYLTRANSFERASE SUBUNIT P  DOWN SYNDROME CRITICAL REGION PROTEIN 5 -RELATED', NULL, NULL, NULL, 8),
(242587, NULL, 'PTHR31396', NULL, NULL, NULL, NULL, 'PROTEIN FAM163B MEMBER', NULL, NULL, 32280, 8),
(242588, NULL, 'PTHR47561', NULL, NULL, NULL, NULL, 'POLYSACCHARIDE DEACETYLASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_6G05030)', NULL, NULL, NULL, 8),
(242589, NULL, 'PTHR37998', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 262', NULL, NULL, 28709, 8),
(242590, NULL, 'PTHR15356', NULL, NULL, NULL, NULL, 'NEUROTENSIN/NEUROMEDIN N', NULL, NULL, 5158, 8),
(242591, NULL, 'PTHR43796', NULL, NULL, NULL, NULL, 'CARBOXYNORSPERMIDINE SYNTHASE', NULL, NULL, NULL, 8),
(242592, NULL, 'PTHR13391', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL DISTRIBUTION REGULATOR MISATO', NULL, NULL, NULL, 8),
(242593, NULL, 'PTHR10194', NULL, NULL, NULL, NULL, 'RAS GTPASE-ACTIVATING PROTEINS', NULL, NULL, 33284, 8),
(242594, NULL, 'PTHR13395', NULL, NULL, NULL, NULL, 'SISTER CHROMATID COHESION PROTEIN DCC1-RELATED', NULL, NULL, 17869, 8),
(242595, NULL, 'PTHR47016', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE ATP-BINDING SUBUNIT CLPT1, CHLOROPLASTIC', NULL, NULL, 34786, 8),
(242596, NULL, 'PTHR23415', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASES REGULATORY SUBUNIT/60S RIBOSOME SUBUNIT BIOGENESIS PROTEIN NIP7', NULL, NULL, NULL, 8),
(242597, NULL, 'PTHR38784', NULL, NULL, NULL, NULL, 'SUCROSE PHOSPHORYLASE', NULL, NULL, NULL, 8),
(242598, NULL, 'PTHR36549', NULL, NULL, NULL, NULL, 'LYSINE-RICH ARABINOGALACTAN PROTEIN 19', NULL, NULL, 32053, 8),
(242599, NULL, 'PTHR33662', NULL, NULL, NULL, NULL, 'OTU DEUBIQUITINASE WITH LINEAR LINKAGE-SPECIFICITY A-RELATED', NULL, NULL, 15517, 8),
(242600, NULL, 'PTHR46971', NULL, NULL, NULL, NULL, 'CALCINEURIN B SUBUNIT (PROTEIN PHOSPHATASE 2B REGULATORY SUBUNIT)-LIKE PROTEIN', NULL, NULL, NULL, 8),
(242601, NULL, 'PTHR13214', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 330', NULL, NULL, 14142, 8),
(242602, NULL, 'PTHR21630', NULL, NULL, NULL, NULL, 'VEPH-A/MELTED', NULL, NULL, 27405, 8),
(242603, NULL, 'PTHR31959', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(242604, NULL, 'PTHR10179', NULL, NULL, NULL, NULL, 'CXC CHEMOKINE', NULL, NULL, 2287, 8),
(242605, NULL, 'PTHR43647', NULL, NULL, NULL, NULL, 'DEHYDROGENASE', NULL, NULL, NULL, 8),
(242606, NULL, 'PTHR46808', NULL, NULL, NULL, NULL, 'H2.0-LIKE HOMEOBOX PROTEIN', NULL, NULL, NULL, 8),
(242607, NULL, 'PTHR12174', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDE PEPTIDASE', NULL, NULL, 5771, 8),
(242608, NULL, 'PTHR36044', NULL, NULL, NULL, NULL, 'HEME BINDING PROTEIN', NULL, NULL, NULL, 8),
(242609, NULL, 'PTHR11471', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR FAMILY MEMBER', NULL, NULL, NULL, 8),
(242610, NULL, 'PTHR32288', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN C-IV', NULL, NULL, 25544, 8),
(242611, NULL, 'PTHR33919', NULL, NULL, NULL, NULL, 'OS09G0127700 PROTEIN', NULL, NULL, NULL, 8),
(242612, NULL, 'PTHR13958', NULL, NULL, NULL, NULL, 'CENTROSOME-ASSOCIATED PROTEIN 350', NULL, NULL, 26623, 8),
(242613, NULL, 'PTHR36948', NULL, NULL, NULL, NULL, 'PROTEIN CBG04856', NULL, NULL, NULL, 8),
(242614, NULL, 'PTHR19972', NULL, NULL, NULL, NULL, 'CALBINDIN', NULL, NULL, NULL, 8),
(242615, NULL, 'PTHR31798', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN-LIKE', NULL, NULL, 28830, 8),
(242616, NULL, 'PTHR45224', NULL, NULL, NULL, NULL, 'OS01G0527900 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(242617, NULL, 'PTHR16076', NULL, NULL, NULL, NULL, 'CYTOSKELETON ASSOCIATED PROTEIN 2-RELATED', NULL, NULL, 23446, 8),
(242618, NULL, 'PTHR10903', NULL, NULL, NULL, NULL, 'GTPASE, IMAP FAMILY MEMBER-RELATED', NULL, NULL, 36211, 8),
(242619, NULL, 'PTHR35542', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 168', NULL, NULL, NULL, 8),
(242620, NULL, 'PTHR21721', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(242621, NULL, 'PTHR35918', NULL, NULL, NULL, NULL, 'OS06G0674800 PROTEIN', NULL, NULL, 35228, 8);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(242622, NULL, 'PTHR28181', NULL, NULL, NULL, NULL, 'UPF0655 PROTEIN YCR015C', NULL, NULL, NULL, 8),
(242623, NULL, 'PTHR34384', NULL, NULL, NULL, NULL, 'L-2,3-DIAMINOPROPANOATE--CITRATE LIGASE', NULL, NULL, 27170, 8),
(242624, NULL, 'PTHR45956', NULL, NULL, NULL, NULL, 'RUN AND FYVE DOMAIN-CONTAINING PROTEIN 2-LIKE PROTEIN', NULL, NULL, NULL, 8),
(242625, NULL, 'PTHR21447', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(242626, NULL, 'PTHR31389', NULL, NULL, NULL, NULL, 'LD39211P', NULL, NULL, NULL, 8),
(242627, NULL, 'PTHR35767', NULL, NULL, NULL, NULL, 'HAPLESS PROTEIN', NULL, NULL, NULL, 8),
(242628, NULL, 'PTHR30532', NULL, NULL, NULL, NULL, 'IRON III  DICITRATE-BINDING PERIPLASMIC PROTEIN', NULL, NULL, NULL, 8),
(242629, NULL, 'PTHR41286', NULL, NULL, NULL, NULL, 'HNH NUCLEASE YAJD-RELATED', NULL, NULL, NULL, 8),
(242630, NULL, 'PTHR42781', NULL, NULL, NULL, NULL, 'SPERMIDINE/PUTRESCINE IMPORT ATP-BINDING PROTEIN POTA', NULL, NULL, NULL, 8),
(242631, NULL, 'PTHR28251', NULL, NULL, NULL, NULL, 'V-TYPE ATPASE ASSEMBLY FACTOR PKR1', NULL, NULL, 7840, 8),
(242632, NULL, 'PTHR34971', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REACTION CENTER PROTEIN Z', NULL, NULL, 2813, 8),
(242633, NULL, 'PTHR31917', NULL, NULL, NULL, NULL, 'AGENET DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(242634, NULL, 'PTHR24278', NULL, NULL, NULL, NULL, 'COAGULATION FACTOR', NULL, NULL, NULL, 8),
(242635, NULL, 'PTHR21353', NULL, NULL, NULL, NULL, '', NULL, NULL, 9493, 8),
(242636, NULL, 'PTHR13305', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS PROTEIN NOP10', NULL, NULL, 6821, 8),
(242637, NULL, 'PTHR43740', NULL, NULL, NULL, NULL, 'LEUCYL-TRNA SYNTHETASE', NULL, NULL, 6442, 8),
(242638, NULL, 'PTHR31767', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL GAMMA-LIKE SUBUNIT', NULL, NULL, 26001, 8),
(242639, NULL, 'PTHR24173', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT CONTAINING', NULL, NULL, NULL, 8),
(242640, NULL, 'PTHR45627', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE TYPE 1', NULL, NULL, NULL, 8),
(242641, NULL, 'PTHR35969', NULL, NULL, NULL, NULL, 'PROTEIN FAM243A-RELATED', NULL, NULL, 33278, 8),
(242642, NULL, 'PTHR34820', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YEBZ', NULL, NULL, 26949, 8),
(242643, NULL, 'PTHR10131', NULL, NULL, NULL, NULL, 'TNF RECEPTOR ASSOCIATED FACTOR', NULL, NULL, NULL, 8),
(242644, NULL, 'PTHR45714', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN HAT14', NULL, NULL, NULL, 8),
(242645, NULL, 'PTHR33985', NULL, NULL, NULL, NULL, 'OS02G0491300 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(242646, NULL, 'PTHR47063', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H2 SUBUNIT C', NULL, NULL, NULL, 8),
(242647, NULL, 'PTHR37220', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 23', NULL, NULL, 35919, 8),
(242648, NULL, 'PTHR39352', NULL, NULL, NULL, NULL, 'PROTEIN CBG14251', NULL, NULL, NULL, 8),
(242649, NULL, 'PTHR18820', NULL, NULL, NULL, NULL, 'LEG1', NULL, NULL, 12105, 8),
(242650, NULL, 'PTHR21240', NULL, NULL, NULL, NULL, '2-AMINO-3-CARBOXYLMUCONATE-6-SEMIALDEHYDE DECARBOXYLASE', NULL, NULL, 17936, 8),
(242651, NULL, 'PTHR42041', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(242652, NULL, 'PTHR43719', NULL, NULL, NULL, NULL, 'TWO-COMPONENT HISTIDINE KINASE', NULL, NULL, NULL, 8),
(242653, NULL, 'PTHR33265', NULL, NULL, NULL, NULL, 'AVR9/CF-9 RAPIDLY ELICITED PROTEIN-RELATED', NULL, NULL, NULL, 8),
(242654, NULL, 'PTHR37390', NULL, NULL, NULL, NULL, 'OS02G0592500 PROTEIN', NULL, NULL, NULL, 8),
(242655, NULL, 'PTHR13110', NULL, NULL, NULL, NULL, 'U6 SNRNA-ASSOCIATED SM-LIKE PROTEIN LSM3', NULL, NULL, 27090, 8),
(242656, NULL, 'PTHR37856', NULL, NULL, NULL, NULL, 'MAST CELL-EXPRESSED MEMBRANE PROTEIN 1', NULL, NULL, 30913, 8),
(242657, NULL, 'PTHR12216', NULL, NULL, NULL, NULL, 'UROCANATE HYDRATASE', NULL, NULL, 870, 8),
(242658, NULL, 'PTHR36361', NULL, NULL, NULL, NULL, 'PROTEIN APEM9', NULL, NULL, 18382, 8),
(242659, NULL, 'PTHR33307', NULL, NULL, NULL, NULL, 'ALPHA-RHAMNOSIDASE (EUROFUNG)', NULL, NULL, NULL, 8),
(242660, NULL, 'PTHR11640', NULL, NULL, NULL, NULL, 'NEPHRIN', NULL, NULL, NULL, 8);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(242661, NULL, 'PTHR38453', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', NULL, NULL, 3570, 8),
(242662, NULL, 'PTHR43405', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE DIGH', NULL, NULL, NULL, 8),
(242663, NULL, 'PTHR37592', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(242664, NULL, 'PTHR31661', NULL, NULL, NULL, NULL, 'SIMILAR TO CDNA SEQUENCE BC052040', NULL, NULL, 24933, 8),
(242665, NULL, 'PTHR13054', NULL, NULL, NULL, NULL, 'DIGEORGE SYNDROME CRITICAL REGION 6 DGCR6 FAMILY MEMBER', NULL, NULL, 11787, 8),
(242666, NULL, 'PTHR33727', NULL, NULL, NULL, NULL, 'OS07G0446900 PROTEIN', NULL, NULL, NULL, 8),
(242667, NULL, 'PTHR13076', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 31035, 8),
(242668, NULL, 'PTHR12957', NULL, NULL, NULL, NULL, 'DEAD/H BOX POLYPEPTIDE 26/DICE1-RELATED', NULL, NULL, NULL, 8),
(242669, NULL, 'PTHR34926', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(242670, NULL, 'PTHR11986', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE CLASS III', NULL, NULL, NULL, 8),
(242671, NULL, 'PTHR10398', NULL, NULL, NULL, NULL, 'AFADIN', NULL, NULL, NULL, 8),
(242672, NULL, 'PTHR40094', NULL, NULL, NULL, NULL, 'ALPHA-2-MACROGLOBULIN HOMOLOG', NULL, NULL, NULL, 8),
(242673, NULL, 'PTHR47768', NULL, NULL, NULL, NULL, 'GLOBIN RELATED-RELATED', NULL, NULL, NULL, 8),
(242674, NULL, 'PTHR14942', NULL, NULL, NULL, NULL, 'U11/U12 SMALL NUCLEAR RIBONUCLEOPROTEIN 25 KDA PROTEIN', NULL, NULL, 28207, 8),
(242675, NULL, 'PTHR48013', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY MITOGEN-ACTIVATED PROTEIN KINASE KINASE 5-RELATED', NULL, NULL, NULL, 8),
(242676, NULL, 'PTHR46370', NULL, NULL, NULL, NULL, 'GPALPP MOTIFS-CONTAINING PROTEIN 1', NULL, NULL, 37636, 8),
(242677, NULL, 'PTHR43107', NULL, NULL, NULL, NULL, 'LONG-CHAIN FATTY ACID TRANSPORT PROTEIN', NULL, NULL, NULL, 8),
(242678, NULL, 'PTHR31219', NULL, NULL, NULL, NULL, 'CHROMOSOME 28 C12ORF29 HOMOLOG', NULL, NULL, 28719, 8),
(242679, NULL, 'PTHR47271', NULL, NULL, NULL, NULL, 'ARGININE DEIMINASE', NULL, NULL, NULL, 8),
(242680, NULL, 'PTHR10509', NULL, NULL, NULL, NULL, 'O-METHYLTRANSFERASE-RELATED', NULL, NULL, NULL, 8),
(242681, NULL, 'PTHR46219', NULL, NULL, NULL, NULL, 'PROTEIN CBG11138', NULL, NULL, NULL, 8),
(242682, NULL, 'PTHR13193', NULL, NULL, NULL, NULL, 'CGI-140', NULL, NULL, 6377, 8),
(242683, NULL, 'PTHR47507', NULL, NULL, NULL, NULL, 'BARRIER TO AUTOINTEGRATION FACTOR 2', NULL, NULL, NULL, 8),
(242684, NULL, 'PTHR21174', NULL, NULL, NULL, NULL, '', NULL, NULL, 10334, 8),
(242685, NULL, 'PTHR15510', NULL, NULL, NULL, NULL, 'SPERM-ASSOCIATED ANTIGEN 8', NULL, NULL, 24920, 8),
(242686, NULL, 'PTHR46046', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(242687, NULL, 'PTHR43630', NULL, NULL, NULL, NULL, 'POLY-BETA-1,6-N-ACETYL-D-GLUCOSAMINE SYNTHASE', NULL, NULL, NULL, 8),
(242688, NULL, 'PTHR21463', NULL, NULL, NULL, NULL, 'ANGIOPOIETIN-LIKE PROTEIN 8', NULL, NULL, 22300, 8),
(242689, NULL, 'PTHR37336', NULL, NULL, NULL, NULL, 'SIMILAR TO 9930012K11RIK PROTEIN', NULL, NULL, NULL, 8),
(242690, NULL, 'PTHR15425', NULL, NULL, NULL, NULL, 'CD160 ANTIGEN', NULL, NULL, 36668, 8),
(242691, NULL, 'PTHR34808', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(242692, NULL, 'PTHR33232', NULL, NULL, NULL, NULL, 'PROTEIN SIEVE ELEMENT OCCLUSION B-LIKE', NULL, NULL, 27196, 8),
(242693, NULL, 'PTHR47824', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(242694, NULL, 'PTHR42966', NULL, NULL, NULL, NULL, 'N-ACETYLNEURAMINATE SYNTHASE', NULL, NULL, NULL, 8),
(242695, NULL, 'PTHR23417', NULL, NULL, NULL, NULL, '3-DEOXY-D-MANNO-OCTULOSONIC-ACID TRANSFERASE/TRNA  GUANINE-N 7 - -METHYLTRANSFERASE', NULL, NULL, 4397, 8),
(242696, NULL, 'PTHR43332', NULL, NULL, NULL, NULL, 'INNER MEMBRANE TRANSPORT PERMEASE YADH-RELATED', NULL, NULL, NULL, 8),
(242697, NULL, 'PTHR32002', NULL, NULL, NULL, NULL, 'PROTEIN NLP8', NULL, NULL, 34194, 8),
(242698, NULL, 'PTHR35793', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YJIG', NULL, NULL, NULL, 8),
(242699, NULL, 'PTHR46401', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE WBBK-RELATED', NULL, NULL, NULL, 8);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(242700, NULL, 'PTHR34753', NULL, NULL, NULL, NULL, 'TELOMERASE RNA COMPONENT INTERACTING RNASE', NULL, NULL, 32148, 8),
(242701, NULL, 'PTHR31953', NULL, NULL, NULL, NULL, 'BETA-FRUCTOFURANOSIDASE, INSOLUBLE ISOENZYME CWINV1-RELATED', NULL, NULL, NULL, 8),
(242702, NULL, 'PTHR47039', NULL, NULL, NULL, NULL, 'INOSITOL POLYPHOSPHATE 5-PHOSPHATASE E', NULL, NULL, NULL, 8),
(242703, NULL, 'PTHR47548', NULL, NULL, NULL, NULL, 'BNAA06G32370D PROTEIN', NULL, NULL, NULL, 8),
(242704, NULL, 'PTHR37206', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(242705, NULL, 'PTHR47939', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED SALT-INDUCIBLE PROTEIN-LIKE', NULL, NULL, NULL, 8),
(242706, NULL, 'PTHR15526', NULL, NULL, NULL, NULL, 'MUSKELIN', NULL, NULL, NULL, 8),
(242707, NULL, 'PTHR33088', NULL, NULL, NULL, NULL, 'MUCIN-2', NULL, NULL, 36220, 8),
(242708, NULL, 'PTHR32011', NULL, NULL, NULL, NULL, 'OS08G0472400 PROTEIN', NULL, NULL, NULL, 8),
(242709, NULL, 'PTHR33964', NULL, NULL, NULL, NULL, 'RE45066P-RELATED', NULL, NULL, NULL, 8),
(242710, NULL, 'PTHR21631', NULL, NULL, NULL, NULL, 'ISOCITRATE LYASE/MALATE SYNTHASE', NULL, NULL, 3922, 8),
(242711, NULL, 'PTHR36080', NULL, NULL, NULL, NULL, 'DBJ|BAA96220.1', NULL, NULL, NULL, 8),
(242712, NULL, 'PTHR38899', NULL, NULL, NULL, NULL, 'DOMAIN OOKINETE PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(242713, NULL, 'PTHR14332', NULL, NULL, NULL, NULL, 'DISRUPTED IN SCHIZOPHRENIA 1 PROTEIN', NULL, NULL, 21626, 8),
(242714, NULL, 'PTHR43372', NULL, NULL, NULL, NULL, 'FATTY-ACID AMIDE HYDROLASE', NULL, NULL, NULL, 8),
(242715, NULL, 'PTHR38616', NULL, NULL, NULL, NULL, 'PROTEIN CBG03925', NULL, NULL, 27240, 8),
(242716, NULL, 'PTHR32091', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4B', NULL, NULL, 9142, 8),
(242717, NULL, 'PTHR11973', NULL, NULL, NULL, NULL, 'CELL SURFACE GLYCOPROTEIN MUC18-RELATED', NULL, NULL, NULL, 8),
(242718, NULL, 'PTHR45760', NULL, NULL, NULL, NULL, 'FI19922P1-RELATED', NULL, NULL, 37302, 8),
(242719, NULL, 'PTHR38596', NULL, NULL, NULL, NULL, 'UPF0114 PROTEIN YQHA', NULL, NULL, 20249, 8),
(242720, NULL, 'PTHR34565', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(242721, NULL, 'PTHR23017', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS X', NULL, NULL, NULL, 8),
(242722, NULL, 'PTHR34133', NULL, NULL, NULL, NULL, 'OS07G0633000 PROTEIN', NULL, NULL, NULL, 8),
(242723, NULL, 'PTHR44586', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', NULL, NULL, NULL, 8),
(242724, NULL, 'PTHR44281', NULL, NULL, NULL, NULL, 'SPINDLE ASSEMBLY ABNORMAL PROTEIN 6 HOMOLOG', NULL, NULL, NULL, 8),
(242725, NULL, 'PTHR11943', NULL, NULL, NULL, NULL, 'GALACTOSE-1-PHOSPHATE URIDYLYLTRANSFERASE', NULL, NULL, 4254, 8),
(242726, NULL, 'PTHR12835', NULL, NULL, NULL, NULL, 'BIOTIN PROTEIN LIGASE', NULL, NULL, NULL, 8),
(242727, NULL, 'PTHR47782', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', NULL, NULL, NULL, 8),
(242728, NULL, 'PTHR42051', NULL, NULL, NULL, NULL, 'MEIOTICALLY UP-REGULATED PROTEIN PB1A10.08', NULL, NULL, 6537, 8),
(242729, NULL, 'PTHR46504', NULL, NULL, NULL, NULL, 'TRNASE Z TRZ1', NULL, NULL, NULL, 8),
(242730, NULL, 'PTHR12889', NULL, NULL, NULL, NULL, 'GAMMA-SECRETASE SUBUNIT APH-1', NULL, NULL, 13625, 8),
(242731, NULL, 'PTHR34931', NULL, NULL, NULL, NULL, 'FI02976P-RELATED', NULL, NULL, 2885, 8),
(242732, NULL, 'PTHR35335', NULL, NULL, NULL, NULL, 'UPF0716 PROTEIN FXSA', NULL, NULL, 4678, 8),
(242733, NULL, 'PTHR28096', NULL, NULL, NULL, NULL, 'PROTEIN FAF1', NULL, NULL, NULL, 8),
(242734, NULL, 'PTHR13373', NULL, NULL, NULL, NULL, 'FROUNT PROTEIN-RELATED', NULL, NULL, 12651, 8),
(242735, NULL, 'PTHR22730', NULL, NULL, NULL, NULL, 'PROMININ  PROM  PROTEIN', NULL, NULL, 13550, 8),
(242736, NULL, 'PTHR28092', NULL, NULL, NULL, NULL, 'FACTOR-INDUCED GENE 1 PROTEIN', NULL, NULL, 29695, 8),
(242737, NULL, 'PTHR12695', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR IIH SUBUNIT 2', NULL, NULL, NULL, 8),
(242738, NULL, 'PTHR33505', NULL, NULL, NULL, NULL, 'ZGC:162634', NULL, NULL, NULL, 8);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(242739, NULL, 'PTHR23083', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN, TPR', NULL, NULL, NULL, 8),
(242740, NULL, 'PTHR34763', NULL, NULL, NULL, NULL, 'PROTEIN FAM104A', NULL, NULL, 26826, 8),
(242741, NULL, 'PTHR34068', NULL, NULL, NULL, NULL, 'UPF0145 PROTEIN YBJQ', NULL, NULL, 4386, 8),
(242742, NULL, 'PTHR32439', NULL, NULL, NULL, NULL, 'FERREDOXIN--NITRITE REDUCTASE, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(242743, NULL, 'PTHR15168', NULL, NULL, NULL, NULL, 'CYTOCHROME B-245 LIGHT CHAIN', NULL, NULL, 1155, 8),
(242744, NULL, 'PTHR40593', NULL, NULL, NULL, NULL, 'PENICILLIN-BINDING PROTEIN ACTIVATOR LPOB', NULL, NULL, 14414, 8),
(242745, NULL, 'PTHR31884', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE', NULL, NULL, NULL, 8),
(242746, NULL, 'PTHR37415', NULL, NULL, NULL, NULL, 'EFF-1A', NULL, NULL, 26866, 8),
(242747, NULL, 'PTHR24159', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(242748, NULL, 'PTHR23293', NULL, NULL, NULL, NULL, 'FAD SYNTHETASE-RELATED  FMN ADENYLYLTRANSFERASE', NULL, NULL, NULL, 8),
(242749, NULL, 'PTHR43440', NULL, NULL, NULL, NULL, 'UREASE', NULL, NULL, NULL, 8),
(242750, NULL, 'PTHR21601', NULL, NULL, NULL, NULL, 'SPA2 PROTEIN', NULL, NULL, 28924, 8),
(242751, NULL, 'PTHR37364', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 182', NULL, NULL, 25570, 8),
(242752, NULL, 'PTHR10426', NULL, NULL, NULL, NULL, 'STRICTOSIDINE SYNTHASE-RELATED', NULL, NULL, NULL, 8),
(242753, NULL, 'PTHR39652', NULL, NULL, NULL, NULL, 'UPF0201 PROTEIN TK1335', NULL, NULL, 3797, 8),
(242754, NULL, 'PTHR31563', NULL, NULL, NULL, NULL, 'ION CHANNEL POLLUX-RELATED', NULL, NULL, 35165, 8),
(242755, NULL, 'PTHR30217', NULL, NULL, NULL, NULL, 'PEPTIDASE U32 FAMILY', NULL, NULL, NULL, 8),
(242756, NULL, 'PTHR47093', NULL, NULL, NULL, NULL, 'PROTEIN JSN1-RELATED', NULL, NULL, NULL, 8),
(242757, NULL, 'PTHR12459', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 24372, 8),
(242758, NULL, 'PTHR46331', NULL, NULL, NULL, NULL, 'VALACYCLOVIR HYDROLASE', NULL, NULL, NULL, 8),
(242759, NULL, 'PTHR35728', NULL, NULL, NULL, NULL, 'MICROTUBULE-BINDING PROTEIN TANGLED-RELATED', NULL, NULL, 34690, 8),
(242760, NULL, 'PTHR43026', NULL, NULL, NULL, NULL, '2-HYDROXYACID DEHYDROGENASE HOMOLOG 1-RELATED', NULL, NULL, NULL, 8),
(242761, NULL, 'PTHR31972', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, 14418, 8),
(242762, NULL, 'PTHR43343', NULL, NULL, NULL, NULL, 'PEPTIDASE S12', NULL, NULL, NULL, 8),
(242763, NULL, 'PTHR46340', NULL, NULL, NULL, NULL, 'UBX DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(242764, NULL, 'PTHR21411', NULL, NULL, NULL, NULL, 'APONTIC', NULL, NULL, NULL, 8),
(242765, NULL, 'PTHR21312', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR', NULL, NULL, NULL, 8),
(242766, NULL, 'PTHR36936', NULL, NULL, NULL, NULL, 'PROTEIN CBG25168', NULL, NULL, NULL, 8),
(242767, NULL, 'PTHR42083', NULL, NULL, NULL, NULL, 'MARVEL DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(242768, NULL, 'PTHR13006', NULL, NULL, NULL, NULL, 'PAPILLOMAVIRUS REGULATORY FACTOR PRF-1', NULL, NULL, NULL, 8),
(242769, NULL, 'PTHR40080', NULL, NULL, NULL, NULL, 'LMO1763 PROTEIN', NULL, NULL, 18852, 8),
(242770, NULL, 'PTHR19863', NULL, NULL, NULL, NULL, 'NEMITIN (NEURONAL ENRICHED MAP INTERACTING PROTEIN) HOMOLOG', NULL, NULL, 31115, 8),
(242771, NULL, 'PTHR39475', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(242772, NULL, 'PTHR36886', NULL, NULL, NULL, NULL, 'PROTEIN FRIGIDA-ESSENTIAL 1', NULL, NULL, NULL, 8),
(242773, NULL, 'PTHR23030', NULL, NULL, NULL, NULL, 'PCD6 INTERACTING PROTEIN-RELATED', NULL, NULL, 34353, 8),
(242774, NULL, 'PTHR31674', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN REM-LIKE 3-RELATED', NULL, NULL, 30751, 8),
(242775, NULL, 'PTHR15466', NULL, NULL, NULL, NULL, 'V-SET AND IMMUNOGLOBULIN DOMAIN CONTAINING 4', NULL, NULL, 29479, 8),
(242776, NULL, 'PTHR11570', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE DECARBOXYLASE', NULL, NULL, 4703, 8),
(242777, NULL, 'PTHR43134', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE RECEPTOR SUBUNIT ALPHA', NULL, NULL, NULL, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(242778, NULL, 'PTHR43085', NULL, NULL, NULL, NULL, 'HEXOKINASE FAMILY MEMBER', NULL, NULL, NULL, 8),
(242779, NULL, 'PTHR47531', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(242780, NULL, 'PTHR34917', NULL, NULL, NULL, NULL, 'RBPJ-INTERACTING AND TUBULIN-ASSOCIATED PROTEIN 1', NULL, NULL, 26266, 8),
(242781, NULL, 'PTHR45842', NULL, NULL, NULL, NULL, 'SYNAPTIC ADHESION-LIKE MOLECULE SALM', NULL, NULL, NULL, 8),
(242782, NULL, 'PTHR47152', NULL, NULL, NULL, NULL, 'SLR2084 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(242783, NULL, 'PTHR15332', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(242784, NULL, 'PTHR14074', NULL, NULL, NULL, NULL, 'HELICASE WITH DEATH DOMAIN-RELATED', NULL, NULL, NULL, 8),
(242785, NULL, 'PTHR11250', NULL, NULL, NULL, NULL, 'TACHYKININ', NULL, NULL, NULL, 8),
(242786, NULL, 'PTHR32198', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ESCAPE PROTEIN 2', NULL, NULL, 27374, 8),
(242787, NULL, 'PTHR31925', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 251', NULL, NULL, 23869, 8),
(242788, NULL, 'PTHR35575', NULL, NULL, NULL, NULL, 'PROTEIN CBG23599-RELATED', NULL, NULL, NULL, 8),
(242789, NULL, 'PTHR36860', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 35', NULL, NULL, 23995, 8),
(242790, NULL, 'PTHR35469', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(242791, NULL, 'PTHR46423', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II-ASSOCIATED PROTEIN 3', NULL, NULL, NULL, 8),
(242792, NULL, 'PTHR36683', NULL, NULL, NULL, NULL, 'CELL CYCLE EXIT AND NEURONAL DIFFERENTIATION PROTEIN 1', NULL, NULL, 13626, 8),
(242793, NULL, 'PTHR30335', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN OF SOXR-REDUCING COMPLEX', NULL, NULL, NULL, 8),
(242794, NULL, 'PTHR34385', NULL, NULL, NULL, NULL, 'D-ALANYL-D-ALANINE CARBOXYPEPTIDASE', NULL, NULL, NULL, 8),
(242795, NULL, 'PTHR42093', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(242796, NULL, 'PTHR13966', NULL, NULL, NULL, NULL, 'ENDONUCLEASE RELATED', NULL, NULL, 32967, 8),
(242797, NULL, 'PTHR10026', NULL, NULL, NULL, NULL, 'CYCLIN', NULL, NULL, 34535, 8),
(242798, NULL, 'PTHR10529', NULL, NULL, NULL, NULL, 'AP COMPLEX SUBUNIT MU', NULL, NULL, NULL, 8),
(242799, NULL, 'PTHR20996', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 18214, 8),
(242800, NULL, 'PTHR39340', NULL, NULL, NULL, NULL, 'SULFOFRUCTOSEPHOSPHATE ALDOLASE', NULL, NULL, NULL, 8),
(242801, NULL, 'PTHR14700', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN 2, MITOCHONDRIAL', NULL, NULL, 17642, 8),
(242802, NULL, 'PTHR47488', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORT/DETOXIFICATION SUPERFAMILY PROTEIN', NULL, NULL, 35419, 8),
(242803, NULL, 'PTHR37313', NULL, NULL, NULL, NULL, 'UPF0749 PROTEIN RV1825', NULL, NULL, 7538, 8),
(242804, NULL, 'PTHR34208', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASE-RELATED', NULL, NULL, 34700, 8),
(242805, NULL, 'PTHR12086', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN  C-TERMINAL  CONTAINING PROTEIN', NULL, NULL, 31238, 8),
(242806, NULL, 'PTHR32347', NULL, NULL, NULL, NULL, 'EFFLUX SYSTEM COMPONENT YKNX-RELATED', NULL, NULL, NULL, 8),
(242807, NULL, 'PTHR13722', NULL, NULL, NULL, NULL, 'ATP SYNTHASE PROTEIN 8', NULL, NULL, 33306, 8),
(242808, NULL, 'PTHR48018', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', NULL, NULL, NULL, 8),
(242809, NULL, 'PTHR31930', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS R', NULL, NULL, 2824, 8),
(242810, NULL, 'PTHR13808', NULL, NULL, NULL, NULL, 'CBP/P300-RELATED', NULL, NULL, 17050, 8),
(242811, NULL, 'PTHR43162', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(242812, NULL, 'PTHR14522', NULL, NULL, NULL, NULL, 'EMO2-RELATED', NULL, NULL, 25773, 8),
(242813, NULL, 'PTHR34401', NULL, NULL, NULL, NULL, 'PROTEIN CBG12388-RELATED', NULL, NULL, NULL, 8),
(242814, NULL, 'PTHR21037', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L14, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(242815, NULL, 'PTHR23199', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(242816, NULL, 'PTHR34975', NULL, NULL, NULL, NULL, 'SPORE GERMINATION PROTEIN A2', NULL, NULL, 5080, 8);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(242817, NULL, 'PTHR32055', NULL, NULL, NULL, NULL, 'INTEGRIN BETA-1-BINDING PROTEIN 1', NULL, NULL, 18395, 8),
(242818, NULL, 'PTHR45972', NULL, NULL, NULL, NULL, 'BTB_2 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(242819, NULL, 'PTHR32061', NULL, NULL, NULL, NULL, 'NMDA RECEPTOR SYNAPTONUCLEAR SIGNALING AND NEURONAL MIGRATION FACTOR', NULL, NULL, 32834, 8),
(242820, NULL, 'PTHR23023', NULL, NULL, NULL, NULL, 'DIMETHYLANILINE MONOOXYGENASE', NULL, NULL, NULL, 8),
(242821, NULL, 'PTHR31367', NULL, NULL, NULL, NULL, 'CYTOSOLIC 5''-NUCLEOTIDASE 1 FAMILY MEMBER', NULL, NULL, 9266, 8),
(242822, NULL, 'PTHR43169', NULL, NULL, NULL, NULL, 'EXSB FAMILY PROTEIN', NULL, NULL, NULL, 8),
(242823, NULL, 'PTHR36737', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(242824, NULL, 'PTHR21399', NULL, NULL, NULL, NULL, 'CHLORIDE CONDUCTANCE REGULATORY PROTEIN ICLN', NULL, NULL, 30071, 8),
(242825, NULL, 'PTHR23186', NULL, NULL, NULL, NULL, 'RETINOIC ACID-INDUCED PROTEIN 2', NULL, NULL, 24839, 8),
(242826, NULL, 'PTHR38459', NULL, NULL, NULL, NULL, 'PROPHAGE BACTOPRENOL-LINKED GLUCOSE TRANSLOCASE HOMOLOG', NULL, NULL, NULL, 8),
(242827, NULL, 'PTHR13486', NULL, NULL, NULL, NULL, 'TELOMERE LENGTH AND SILENCING PROTEIN 1 TLS1 FAMILY MEMBER', NULL, NULL, 9590, 8),
(242828, NULL, 'PTHR34064', NULL, NULL, NULL, NULL, 'OS04G0672300 PROTEIN', NULL, NULL, NULL, 8),
(242829, NULL, 'PTHR13059', NULL, NULL, NULL, NULL, 'HMG-BOX TRANSCRIPTION FACTOR BBX', NULL, NULL, NULL, 8),
(242830, NULL, 'PTHR46539', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE ATL42', NULL, NULL, NULL, 8),
(242831, NULL, 'PTHR46371', NULL, NULL, NULL, NULL, 'OS04G0464100 PROTEIN', NULL, NULL, 36361, 8),
(242832, NULL, 'PTHR34567', NULL, NULL, NULL, NULL, 'FK506-BINDING-LIKE PROTEIN', NULL, NULL, NULL, 8),
(242833, NULL, 'PTHR12960', NULL, NULL, NULL, NULL, 'GLE-1-RELATED', NULL, NULL, 14366, 8),
(242834, NULL, 'PTHR12420', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN', NULL, NULL, NULL, 8),
(242835, NULL, 'PTHR47621', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH-TYPE ANTIVIRAL PROTEIN 1-LIKE', NULL, NULL, 25310, 8),
(242836, NULL, 'PTHR46482', NULL, NULL, NULL, NULL, '5''-ADENYLYLSULFATE REDUCTASE 3, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(242837, NULL, 'PTHR19268', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR', NULL, NULL, NULL, 8),
(242838, NULL, 'PTHR13318', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(242839, NULL, 'PTHR41328', NULL, NULL, NULL, NULL, 'TERMINASE SMALL SUBUNIT-RELATED', NULL, NULL, NULL, 8),
(242840, NULL, 'PTHR46281', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 6B', NULL, NULL, 2128, 8),
(242841, NULL, 'PTHR12735', NULL, NULL, NULL, NULL, 'BOLA-LIKE PROTEIN-RELATED', NULL, NULL, 34337, 8),
(242842, NULL, 'PTHR36868', NULL, NULL, NULL, NULL, 'NUTRITIONALLY-REGULATED ADIPOSE AND CARDIAC ENRICHED PROTEIN HOMOLOG', NULL, NULL, 24929, 8),
(242843, NULL, 'PTHR34730', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', NULL, NULL, NULL, 8),
(242844, NULL, 'PTHR15437', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR, MITOCHONDRIAL', NULL, NULL, 4579, 8),
(242845, NULL, 'PTHR36156', NULL, NULL, NULL, NULL, 'SLR2101 PROTEIN', NULL, NULL, NULL, 8),
(242846, NULL, 'PTHR12936', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX 10', NULL, NULL, 17362, 8),
(242847, NULL, 'PTHR31675', NULL, NULL, NULL, NULL, 'PROTEIN YABBY 6-RELATED', NULL, NULL, 3055, 8),
(242848, NULL, 'PTHR45432', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ 11, CHLOROPLASTIC-LIKE', NULL, NULL, NULL, 8),
(242849, NULL, 'PTHR12886', NULL, NULL, NULL, NULL, 'PIG-M MANNOSYLTRANSFERASE', NULL, NULL, 1133, 8),
(242850, NULL, 'PTHR24033', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(242851, NULL, 'PTHR46849', NULL, NULL, NULL, NULL, 'RCC1 DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(242852, NULL, 'PTHR31515', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(242853, NULL, 'PTHR10281', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED PROGESTERONE RECEPTOR COMPONENT-RELATED', NULL, NULL, NULL, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(242854, NULL, 'PTHR43656', NULL, NULL, NULL, NULL, 'BINDING OXIDOREDUCTASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G08260)-RELATED', NULL, NULL, NULL, 8),
(242855, NULL, 'PTHR46936', NULL, NULL, NULL, NULL, 'ARABINOSYLTRANSFERASE XEG113', NULL, NULL, NULL, 8),
(242856, NULL, 'PTHR37532', NULL, NULL, NULL, NULL, 'PROTEIN ISCX', NULL, NULL, 10235, 8),
(242857, NULL, 'PTHR30105', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED YIBQ-RELATED', NULL, NULL, 3953, 8),
(242858, NULL, 'PTHR42976', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL CHITINASE/LYSOZYME-RELATED', NULL, NULL, NULL, 8),
(242859, NULL, 'PTHR13354', NULL, NULL, NULL, NULL, 'ROUND SPERMATID BASIC PROTEIN 1', NULL, NULL, 25820, 8),
(242860, NULL, 'PTHR13038', NULL, NULL, NULL, NULL, 'APG9 AUTOPHAGY 9', NULL, NULL, 6846, 8),
(242861, NULL, 'PTHR28632', NULL, NULL, NULL, NULL, 'TRANSLATION MACHINERY-ASSOCIATED PROTEIN 7', NULL, NULL, 9521, 8),
(242862, NULL, 'PTHR31931', NULL, NULL, NULL, NULL, 'PROTEIN CHURCHILL', NULL, NULL, 9078, 8),
(242863, NULL, 'PTHR11435', NULL, NULL, NULL, NULL, 'NADH UBIQUINONE OXIDOREDUCTASE SUBUNIT ND6', NULL, NULL, NULL, 8),
(242864, NULL, 'PTHR32282', NULL, NULL, NULL, NULL, 'BINDING PROTEIN TRANSPEPTIDASE, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(242865, NULL, 'PTHR46998', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 11', NULL, NULL, 36164, 8),
(242866, NULL, 'PTHR19359', NULL, NULL, NULL, NULL, 'CYTOCHROME B5', NULL, NULL, NULL, 8),
(242867, NULL, 'PTHR30176', NULL, NULL, NULL, NULL, 'FERREDOXIN-TYPE PROTEIN NAPH', NULL, NULL, NULL, 8),
(242868, NULL, 'PTHR45750', NULL, NULL, NULL, NULL, 'GH11602P', NULL, NULL, 30618, 8),
(242869, NULL, 'PTHR47554', NULL, NULL, NULL, NULL, 'SORTING NEXIN MVP1', NULL, NULL, 22659, 8),
(242870, NULL, 'PTHR35831', NULL, NULL, NULL, NULL, 'OS01G0642200 PROTEIN', NULL, NULL, NULL, 8),
(242871, NULL, 'PTHR15494', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING TYROSINE PHOSPHORYLATION-REGULATED PROTEIN', NULL, NULL, 32669, 8),
(242872, NULL, 'PTHR18839', NULL, NULL, NULL, NULL, 'MITOTIC INTERACTOR AND SUBSTRATE OF PLK1 MISP FAMILY MEMBER', NULL, NULL, 35681, 8),
(242873, NULL, 'PTHR37544', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(242874, NULL, 'PTHR15925', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOMAL PROTEIN S23', NULL, NULL, 18206, 8),
(242875, NULL, 'PTHR31848', NULL, NULL, NULL, NULL, '', NULL, NULL, 22271, 8),
(242876, NULL, 'PTHR15379', NULL, NULL, NULL, NULL, 'CELL GROWTH REGULATOR WITH RING FINGER DOMAIN PROTEIN 1', NULL, NULL, 36902, 8),
(242877, NULL, 'PTHR21559', NULL, NULL, NULL, NULL, 'DYSTROGLYCAN-RELATED', NULL, NULL, NULL, 8),
(242878, NULL, 'PTHR45776', NULL, NULL, NULL, NULL, 'MIP04163P', NULL, NULL, NULL, 8),
(242879, NULL, 'PTHR14758', NULL, NULL, NULL, NULL, 'AGAP005440-PA', NULL, NULL, 25199, 8),
(242880, NULL, 'PTHR21339', NULL, NULL, NULL, NULL, 'RADICAL S-ADENOSYL METHIONINE DOMAIN-CONTAINING PROTEIN 2', NULL, NULL, NULL, 8),
(242881, NULL, 'PTHR37258', NULL, NULL, NULL, NULL, 'FANTOM PROTEIN', NULL, NULL, NULL, 8),
(242882, NULL, 'PTHR33178', NULL, NULL, NULL, NULL, '', NULL, NULL, 34602, 8),
(242883, NULL, 'PTHR33569', NULL, NULL, NULL, NULL, 'UREASE', NULL, NULL, NULL, 8),
(242884, NULL, 'PTHR47171', NULL, NULL, NULL, NULL, 'FARA-RELATED', NULL, NULL, NULL, 8),
(242885, NULL, 'PTHR16140', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 26765, 8),
(242886, NULL, 'PTHR38444', NULL, NULL, NULL, NULL, 'ENTEROBACTIN BIOSYNTHESIS PROTEIN YBDZ', NULL, NULL, 33444, 8),
(242887, NULL, 'PTHR32297', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL MODIFIER 1', NULL, NULL, 27656, 8),
(242888, NULL, 'PTHR18895', NULL, NULL, NULL, NULL, 'HEMK METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(242889, NULL, 'PTHR36342', NULL, NULL, NULL, NULL, 'PTB DOMAIN ENGULFMENT ADAPTER', NULL, NULL, NULL, 8),
(242890, NULL, 'PTHR33560', NULL, NULL, NULL, NULL, 'PROTEIN FAM227B', NULL, NULL, 23503, 8),
(242891, NULL, 'PTHR45687', NULL, NULL, NULL, NULL, 'AQUAPORIN OR AQUAGLYCEROPORIN RELATED', NULL, NULL, 24028, 8),
(242892, NULL, 'PTHR36808', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR ATRX-LIKE PROTEIN', NULL, NULL, NULL, 8);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(242893, NULL, 'PTHR22093', NULL, NULL, NULL, NULL, 'LEUKOCYTE RECEPTOR CLUSTER  LRC  MEMBER 1', NULL, NULL, 32341, 8),
(242894, NULL, 'PTHR34929', NULL, NULL, NULL, NULL, 'ZGC:153157', NULL, NULL, NULL, 8),
(242895, NULL, 'PTHR32258', NULL, NULL, NULL, NULL, 'PROTEIN NETWORKED 4A', NULL, NULL, NULL, 8),
(242896, NULL, 'PTHR47525', NULL, NULL, NULL, NULL, 'OS07G0295200 PROTEIN', NULL, NULL, NULL, 8),
(242897, NULL, 'PTHR39560', NULL, NULL, NULL, NULL, 'PROTEIN ADENYLYLTRANSFERASE FIC-RELATED', NULL, NULL, NULL, 8),
(242898, NULL, 'PTHR46511', NULL, NULL, NULL, NULL, 'MORN REPEAT-CONTAINING PROTEIN 3', NULL, NULL, NULL, 8),
(242899, NULL, 'PTHR42921', NULL, NULL, NULL, NULL, 'ACETOACETYL-COA SYNTHETASE', NULL, NULL, NULL, 8),
(242900, NULL, 'PTHR11953', NULL, NULL, NULL, NULL, 'EXOSOME COMPLEX COMPONENT', NULL, NULL, NULL, 8),
(242901, NULL, 'PTHR12199', NULL, NULL, NULL, NULL, 'INTERPHOTORECEPTOR MATRIX PROTEOGLYCAN', NULL, NULL, 27212, 8),
(242902, NULL, 'PTHR46269', NULL, NULL, NULL, NULL, 'EPIPHYCAN-RELATED', NULL, NULL, 35537, 8),
(242903, NULL, 'PTHR46524', NULL, NULL, NULL, NULL, 'CW-TYPE ZINC FINGER', NULL, NULL, NULL, 8),
(242904, NULL, 'PTHR46220', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN AGD12', NULL, NULL, 34998, 8),
(242905, NULL, 'PTHR14778', NULL, NULL, NULL, NULL, 'KINETOCHORE-ASSOCIATED PROTEIN DSN1 HOMOLOG', NULL, NULL, 12154, 8),
(242906, NULL, 'PTHR46361', NULL, NULL, NULL, NULL, 'ELECTRON CARRIER/ PROTEIN DISULFIDE OXIDOREDUCTASE', NULL, NULL, NULL, 8),
(242907, NULL, 'PTHR35896', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(242908, NULL, 'PTHR36450', NULL, NULL, NULL, NULL, 'THIOREDOXIN', NULL, NULL, 11040, 8),
(242909, NULL, 'PTHR10066', NULL, NULL, NULL, NULL, 'BETA-GLUCURONIDASE', NULL, NULL, NULL, 8),
(242910, NULL, 'PTHR33148', NULL, NULL, NULL, NULL, 'PLASTID MOVEMENT IMPAIRED PROTEIN-RELATED', NULL, NULL, NULL, 8),
(242911, NULL, 'PTHR40389', NULL, NULL, NULL, NULL, 'ENDOGENOUS RETROVIRUS GROUP K MEMBER 24 GAG POLYPROTEIN-RELATED', NULL, NULL, NULL, 8),
(242912, NULL, 'PTHR36394', NULL, NULL, NULL, NULL, 'OS01G0277700 PROTEIN', NULL, NULL, NULL, 8),
(242913, NULL, 'PTHR23406', NULL, NULL, NULL, NULL, 'MALIC ENZYME-RELATED', NULL, NULL, NULL, 8),
(242914, NULL, 'PTHR15316', NULL, NULL, NULL, NULL, 'SPLICEOSOME ASSOCIATED PROTEIN 114/SWAP SPLICING FACTOR-RELATED', NULL, NULL, 36698, 8),
(242915, NULL, 'PTHR12684', NULL, NULL, NULL, NULL, 'PUTATIVE PHOSPHOTRANSFERASE', NULL, NULL, 3912, 8),
(242916, NULL, 'PTHR43367', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(242917, NULL, 'PTHR31762', NULL, NULL, NULL, NULL, 'FAS-BINDING FACTOR-LIKE PROTEIN', NULL, NULL, 31120, 8),
(242918, NULL, 'PTHR39646', NULL, NULL, NULL, NULL, 'RNA POLYMERASE RPB4', NULL, NULL, 8651, 8),
(242919, NULL, 'PTHR37813', NULL, NULL, NULL, NULL, 'FELS-2 PROPHAGE PROTEIN', NULL, NULL, NULL, 8),
(242920, NULL, 'PTHR34280', NULL, NULL, NULL, NULL, 'OS01G0920100 PROTEIN', NULL, NULL, 31625, 8),
(242921, NULL, 'PTHR31839', NULL, NULL, NULL, NULL, 'DEHYDRATION-RESPONSIVE ELEMENT-BINDING PROTEIN 1D', NULL, NULL, 37443, 8),
(242922, NULL, 'PTHR38504', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 7-1', NULL, NULL, 17596, 8),
(242923, NULL, 'PTHR31450', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 19 LRRC19 FAMILY MEMBER', NULL, NULL, NULL, 8),
(242924, NULL, 'PTHR31526', NULL, NULL, NULL, NULL, 'SOSS COMPLEX SUBUNIT C', NULL, NULL, 22742, 8),
(242925, NULL, 'PTHR30613', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN YBIU-RELATED', NULL, NULL, 11616, 8),
(242926, NULL, 'PTHR35253', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 152', NULL, NULL, 31490, 8),
(242927, NULL, 'PTHR22593', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 18', NULL, NULL, NULL, 8),
(242928, NULL, 'PTHR21506', NULL, NULL, NULL, NULL, 'COMPONENT OF OLIGOMERIC GOLGI COMPLEX 6', NULL, NULL, 10337, 8),
(242929, NULL, 'PTHR31712', NULL, NULL, NULL, NULL, 'DIETARY RESTRICTION OVER EXPRESSED', NULL, NULL, 31538, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(242930, NULL, 'PTHR31024', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN', NULL, NULL, NULL, 8),
(242931, NULL, 'PTHR43566', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', NULL, NULL, NULL, 8),
(242932, NULL, 'PTHR41521', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(242933, NULL, 'PTHR42798', NULL, NULL, NULL, NULL, 'LIPOPROTEIN-RELEASING SYSTEM ATP-BINDING PROTEIN LOLD', NULL, NULL, NULL, 8),
(242934, NULL, 'PTHR12655', NULL, NULL, NULL, NULL, 'ACYL-COA THIOESTERASE', NULL, NULL, NULL, 8),
(242935, NULL, 'PTHR36385', NULL, NULL, NULL, NULL, 'OS07G0562900 PROTEIN', NULL, NULL, NULL, 8),
(242936, NULL, 'PTHR35822', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 45', NULL, NULL, 32130, 8),
(242937, NULL, 'PTHR15197', NULL, NULL, NULL, NULL, 'COILIN P80', NULL, NULL, 22243, 8),
(242938, NULL, 'PTHR43042', NULL, NULL, NULL, NULL, 'SAM-DEPENDENT METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(242939, NULL, 'PTHR12869', NULL, NULL, NULL, NULL, 'SMALL SEVEN TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN', NULL, NULL, 18212, 8),
(242940, NULL, 'PTHR33638', NULL, NULL, NULL, NULL, 'SELENOPROTEIN H', NULL, NULL, NULL, 8),
(242941, NULL, 'PTHR13465', NULL, NULL, NULL, NULL, 'UPF0183 PROTEIN', NULL, NULL, 32737, 8),
(242942, NULL, 'PTHR47324', NULL, NULL, NULL, NULL, 'PROTEIN IRG-7-RELATED', NULL, NULL, NULL, 8),
(242943, NULL, 'PTHR45944', NULL, NULL, NULL, NULL, 'SCHNURRI, ISOFORM F', NULL, NULL, NULL, 8),
(242944, NULL, 'PTHR20916', NULL, NULL, NULL, NULL, 'CYSTEINE AND GLYCINE-RICH PROTEIN 2 BINDING PROTEIN', NULL, NULL, NULL, 8),
(242945, NULL, 'PTHR33669', NULL, NULL, NULL, NULL, 'PROTEIN NEGATIVE REGULATOR OF RESISTANCE', NULL, NULL, 26286, 8),
(242946, NULL, 'PTHR45885', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE 5-LIKE PROTEIN', NULL, NULL, NULL, 8),
(242947, NULL, 'PTHR47536', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 5 MEMBER A', NULL, NULL, NULL, 8),
(242948, NULL, 'PTHR22913', NULL, NULL, NULL, NULL, 'HYALURONAN SYNTHASE', NULL, NULL, NULL, 8),
(242949, NULL, 'PTHR36134', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN C16ORF54', NULL, NULL, 24767, 8),
(242950, NULL, 'PTHR43546', NULL, NULL, NULL, NULL, 'UPF0173 METAL-DEPENDENT HYDROLASE MJ1163-RELATED', NULL, NULL, NULL, 8),
(242951, NULL, 'PTHR37241', NULL, NULL, NULL, NULL, 'NEUROFILAMENT HEAVY PROTEIN', NULL, NULL, NULL, 8),
(242952, NULL, 'PTHR13385', NULL, NULL, NULL, NULL, 'AUTOPHAGY PROTEIN 12', NULL, NULL, 7000, 8),
(242953, NULL, 'PTHR24166', NULL, NULL, NULL, NULL, 'ROLLING PEBBLES, ISOFORM B', NULL, NULL, NULL, 8),
(242954, NULL, 'PTHR47813', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(242955, NULL, 'PTHR43669', NULL, NULL, NULL, NULL, '5-KETO-D-GLUCONATE 5-REDUCTASE', NULL, NULL, NULL, 8),
(242956, NULL, 'PTHR38737', NULL, NULL, NULL, NULL, 'ACTIN-FRAGMIN KINASE DDB_G0279609-RELATED', NULL, NULL, 33084, 8),
(242957, NULL, 'PTHR43646', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', NULL, NULL, NULL, 8),
(242958, NULL, 'PTHR16048', NULL, NULL, NULL, NULL, 'MSL2-RELATED', NULL, NULL, 33101, 8),
(242959, NULL, 'PTHR12800', NULL, NULL, NULL, NULL, 'CDC37-RELATED', NULL, NULL, 1812, 8),
(242960, NULL, 'PTHR36321', NULL, NULL, NULL, NULL, 'CLASSICAL ARABINOGALACTAN PROTEIN 9', NULL, NULL, 36931, 8),
(242961, NULL, 'PTHR38645', NULL, NULL, NULL, NULL, 'CHROMOSOME 9, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(242962, NULL, 'PTHR46512', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', NULL, NULL, NULL, 8),
(242963, NULL, 'PTHR22683', NULL, NULL, NULL, NULL, 'SPORULATION PROTEIN RELATED', NULL, NULL, NULL, 8),
(242964, NULL, 'PTHR10362', NULL, NULL, NULL, NULL, 'HISTIDINE AMMONIA-LYASE', NULL, NULL, 2427, 8),
(242965, NULL, 'PTHR47667', NULL, NULL, NULL, NULL, 'REGULATOR OF TY1 TRANSPOSITION PROTEIN 107', NULL, NULL, NULL, 8),
(242966, NULL, 'PTHR22889', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 33151, 8),
(242967, NULL, 'PTHR47689', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(242968, NULL, 'PTHR47259', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(242969, NULL, 'PTHR47235', NULL, NULL, NULL, NULL, 'BLR6548 PROTEIN', NULL, NULL, NULL, 8),
(242970, NULL, 'PTHR42861', NULL, NULL, NULL, NULL, 'CALCIUM-TRANSPORTING ATPASE', NULL, NULL, NULL, 8),
(242971, NULL, 'PTHR13871', NULL, NULL, NULL, NULL, 'THIOREDOXIN', NULL, NULL, NULL, 8),
(242972, NULL, 'PTHR31549', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF247)-RELATED-RELATED', NULL, NULL, 2671, 8),
(242973, NULL, 'PTHR45999', NULL, NULL, NULL, NULL, 'UNC-13-4A, ISOFORM B', NULL, NULL, NULL, 8),
(242974, NULL, 'PTHR43008', NULL, NULL, NULL, NULL, 'BENZIL REDUCTASE', NULL, NULL, NULL, 8),
(242975, NULL, 'PTHR37863', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 196-RELATED', NULL, NULL, NULL, 8),
(242976, NULL, 'PTHR36975', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(242977, NULL, 'PTHR31355', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN TORTIFOLIA1', NULL, NULL, 29705, 8),
(242978, NULL, 'PTHR41791', NULL, NULL, NULL, NULL, 'SSL7039 PROTEIN', NULL, NULL, 13055, 8),
(242979, NULL, 'PTHR34939', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I REACTION CENTER SUBUNIT III, CHLOROPLASTIC', NULL, NULL, 1272, 8),
(242980, NULL, 'PTHR31226', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 117', NULL, NULL, 26489, 8),
(242981, NULL, 'PTHR47530', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN LIGASE BIG BROTHER-RELATED', NULL, NULL, 34195, 8),
(242982, NULL, 'PTHR35457', NULL, NULL, NULL, NULL, 'HEME A SYNTHASE', NULL, NULL, NULL, 8),
(242983, NULL, 'PTHR15583', NULL, NULL, NULL, NULL, 'INTERLEUKIN-17 RECEPTOR', NULL, NULL, 32675, 8),
(242984, NULL, 'PTHR30026', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN TOLC', NULL, NULL, NULL, 8),
(242985, NULL, 'PTHR23189', NULL, NULL, NULL, NULL, 'RNA RECOGNITION MOTIF-CONTAINING', NULL, NULL, NULL, 8),
(242986, NULL, 'PTHR13158', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(242987, NULL, 'PTHR31007', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-DEPENDENT PROTEIN KINASE II INHIBITOR 2', NULL, NULL, 24195, 8),
(242988, NULL, 'PTHR31551', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR CWF18', NULL, NULL, 8912, 8),
(242989, NULL, 'PTHR33517', NULL, NULL, NULL, NULL, 'PROTEIN FAM170B-RELATED', NULL, NULL, 33028, 8),
(242990, NULL, 'PTHR20952', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION-LIKE FACTOR 6-INTERACTING PROTEIN', NULL, NULL, NULL, 8),
(242991, NULL, 'PTHR43689', NULL, NULL, NULL, NULL, 'HYDROLASE', NULL, NULL, NULL, 8),
(242992, NULL, 'PTHR48131', NULL, NULL, NULL, NULL, 'RESIII DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(242993, NULL, 'PTHR14550', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 109', NULL, NULL, 28791, 8),
(242994, NULL, 'PTHR13246', NULL, NULL, NULL, NULL, 'ENDO BETA N-ACETYLGLUCOSAMINIDASE', NULL, NULL, 25359, 8),
(242995, NULL, 'PTHR23127', NULL, NULL, NULL, NULL, 'CENTROMERE/MICROTUBULE BINDING PROTEIN CBF5', NULL, NULL, 5628, 8),
(242996, NULL, 'PTHR47615', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 158', NULL, NULL, 25602, 8),
(242997, NULL, 'PTHR37406', NULL, NULL, NULL, NULL, 'T4-TYPE LYSOZYME 1-RELATED', NULL, NULL, NULL, 8),
(242998, NULL, 'PTHR11567', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE-RELATED', NULL, NULL, NULL, 8),
(242999, NULL, 'PTHR47391', NULL, NULL, NULL, NULL, 'BIORIENTATION OF CHROMOSOMES IN CELL DIVISION 1 LIKE 1', NULL, NULL, 35627, 8),
(243000, NULL, 'PTHR28074', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT K, MITOCHONDRIAL', NULL, NULL, 17519, 8),
(243001, NULL, 'PTHR30183', NULL, NULL, NULL, NULL, 'MOLYBDENUM TRANSPORT SYSTEM PERMEASE PROTEIN MODB', NULL, NULL, NULL, 8),
(243002, NULL, 'PTHR46876', NULL, NULL, NULL, NULL, 'LOW-DENSITY LIPOPROTEIN RECEPTOR-RELATED PROTEIN 11', NULL, NULL, NULL, 8),
(243003, NULL, 'PTHR37977', NULL, NULL, NULL, NULL, 'PROTEIN CBG18402-RELATED', NULL, NULL, NULL, 8),
(243004, NULL, 'PTHR42688', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', NULL, NULL, NULL, 8),
(243005, NULL, 'PTHR23197', NULL, NULL, NULL, NULL, 'TARSH-RELATED FIBRONECTIN DOMAIN-CONTAINING', NULL, NULL, NULL, 8),
(243006, NULL, 'PTHR24118', NULL, NULL, NULL, NULL, 'POTE ANKYRIN DOMAIN', NULL, NULL, NULL, 8);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(243007, NULL, 'PTHR30576', NULL, NULL, NULL, NULL, 'COLANIC BIOSYNTHESIS UDP-GLUCOSE LIPID CARRIER TRANSFERASE', NULL, NULL, NULL, 8),
(243008, NULL, 'PTHR34969', NULL, NULL, NULL, NULL, 'OS01G0621700 PROTEIN', NULL, NULL, NULL, 8),
(243009, NULL, 'PTHR22876', NULL, NULL, NULL, NULL, 'ZGC:101016', NULL, NULL, 15878, 8),
(243010, NULL, 'PTHR24416', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE RECEPTOR', NULL, NULL, NULL, 8),
(243011, NULL, 'PTHR47786', NULL, NULL, NULL, NULL, 'ALPHA-1,4-GLUCAN:MALTOSE-1-PHOSPHATE MALTOSYLTRANSFERASE', NULL, NULL, NULL, 8),
(243012, NULL, 'PTHR47651', NULL, NULL, NULL, NULL, 'NAD-DEPENDENT HISTONE DEACETYLASE HST4', NULL, NULL, NULL, 8),
(243013, NULL, 'PTHR47692', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(243014, NULL, 'PTHR46990', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING CYSTEINE-RICH PROTEIN 1', NULL, NULL, 34154, 8),
(243015, NULL, 'PTHR33979', NULL, NULL, NULL, NULL, 'OS02G0221600 PROTEIN', NULL, NULL, NULL, 8),
(243016, NULL, 'PTHR10514', NULL, NULL, NULL, NULL, 'ANGIOTENSIN-CONVERTING ENZYME', NULL, NULL, 3355, 8),
(243017, NULL, 'PTHR43558', NULL, NULL, NULL, NULL, 'REDUCTASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G10540)-RELATED', NULL, NULL, NULL, 8),
(243018, NULL, 'PTHR42698', NULL, NULL, NULL, NULL, 'GTPASE ERA', NULL, NULL, 3580, 8),
(243019, NULL, 'PTHR47960', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 50', NULL, NULL, NULL, 8),
(243020, NULL, 'PTHR28071', NULL, NULL, NULL, NULL, 'REDOX PROTEIN FMP46, MITOCHONDRIAL-RELATED', NULL, NULL, 13140, 8),
(243021, NULL, 'PTHR28027', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR MIT1', NULL, NULL, 16417, 8),
(243022, NULL, 'PTHR47205', NULL, NULL, NULL, NULL, 'OS07G0599000 PROTEIN', NULL, NULL, 36383, 8),
(243023, NULL, 'PTHR35213', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(243024, NULL, 'PTHR23202', NULL, NULL, NULL, NULL, 'WASP INTERACTING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(243025, NULL, 'PTHR13097', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIE, ALPHA SUBUNIT', NULL, NULL, 30074, 8),
(243026, NULL, 'PTHR12549', NULL, NULL, NULL, NULL, 'JMJC DOMAIN-CONTAINING HISTONE DEMETHYLATION PROTEIN', NULL, NULL, 34254, 8),
(243027, NULL, 'PTHR44699', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN SUPERFAMILY MEMBER 11', NULL, NULL, NULL, 8),
(243028, NULL, 'PTHR43468', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(243029, NULL, 'PTHR33785', NULL, NULL, NULL, NULL, 'OS06G0550800 PROTEIN', NULL, NULL, NULL, 8),
(243030, NULL, 'PTHR36397', NULL, NULL, NULL, NULL, 'OSJNBA0081L15.1 PROTEIN', NULL, NULL, NULL, 8),
(243031, NULL, 'PTHR47182', NULL, NULL, NULL, NULL, 'CELL WALL ALPHA-1,3-GLUCAN SYNTHASE AGS1-RELATED', NULL, NULL, NULL, 8),
(243032, NULL, 'PTHR32153', NULL, NULL, NULL, NULL, 'OJ000223_09.16 PROTEIN', NULL, NULL, 36597, 8),
(243033, NULL, 'PTHR14154', NULL, NULL, NULL, NULL, 'UPF0041 BRAIN PROTEIN 44-RELATED', NULL, NULL, NULL, 8),
(243034, NULL, 'PTHR15926', NULL, NULL, NULL, NULL, 'ALL-TRANS RETINOIC ACID-INDUCED DIFFERENTIATION FACTOR', NULL, NULL, 36464, 8),
(243035, NULL, 'PTHR22936', NULL, NULL, NULL, NULL, 'RHOMBOID-RELATED', NULL, NULL, 1791, 8),
(243036, NULL, 'PTHR22773', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE', NULL, NULL, NULL, 8),
(243037, NULL, 'PTHR16059', NULL, NULL, NULL, NULL, 'ANTHRAX TOXIN RECEPTOR', NULL, NULL, NULL, 8),
(243038, NULL, 'PTHR30472', NULL, NULL, NULL, NULL, 'FERRIC ENTEROBACTIN TRANSPORT SYSTEM PERMEASE PROTEIN', NULL, NULL, 5544, 8),
(243039, NULL, 'PTHR43513', NULL, NULL, NULL, NULL, 'DIHYDROOROTATE DEHYDROGENASE B (NAD(+)), ELECTRON TRANSFER SUBUNIT', NULL, NULL, NULL, 8),
(243040, NULL, 'PTHR37740', NULL, NULL, NULL, NULL, 'OS02G0193500 PROTEIN', NULL, NULL, NULL, 8),
(243041, NULL, 'PTHR12656', NULL, NULL, NULL, NULL, 'BRG-1 ASSOCIATED FACTOR 250  BAF250', NULL, NULL, 19944, 8),
(243042, NULL, 'PTHR44783', NULL, NULL, NULL, NULL, 'CXADR-LIKE MEMBRANE PROTEIN', NULL, NULL, 34233, 8),
(243043, NULL, 'PTHR18902', NULL, NULL, NULL, NULL, 'NUCLEAR MITOTIC APPARATUS PROTEIN 1-RELATED', NULL, NULL, NULL, 8);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(243044, NULL, 'PTHR13402', NULL, NULL, NULL, NULL, 'RGPR-RELATED', NULL, NULL, 26400, 8),
(243045, NULL, 'PTHR26451', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(243046, NULL, 'PTHR46461', NULL, NULL, NULL, NULL, 'KELCH DOMAIN-CONTAINING PROTEIN 3', NULL, NULL, NULL, 8),
(243047, NULL, 'PTHR36816', NULL, NULL, NULL, NULL, 'ATP SYNTHASE PROTEIN YMF19', NULL, NULL, 35536, 8),
(243048, NULL, 'PTHR16021', NULL, NULL, NULL, NULL, 'MANSC DOMAIN CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(243049, NULL, 'PTHR36968', NULL, NULL, NULL, NULL, 'HOMEOBOX-DDT DOMAIN PROTEIN RLT2', NULL, NULL, 36983, 8),
(243050, NULL, 'PTHR46666', NULL, NULL, NULL, NULL, '60S RIBOSOMAL L18A-LIKE PROTEIN', NULL, NULL, NULL, 8),
(243051, NULL, 'PTHR37069', NULL, NULL, NULL, NULL, 'DDE_TNP_1_7 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(243052, NULL, 'PTHR24051', NULL, NULL, NULL, NULL, 'SUSHI DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(243053, NULL, 'PTHR33968', NULL, NULL, NULL, NULL, 'PROTEIN PET100 HOMOLOG, MITOCHONDRIAL', NULL, NULL, 16470, 8),
(243054, NULL, 'PTHR43030', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE SYNTHASE', NULL, NULL, 4979, 8),
(243055, NULL, 'PTHR47416', NULL, NULL, NULL, NULL, 'BASIC-LEUCINE ZIPPER TRANSCRIPTION FACTOR F-RELATED', NULL, NULL, NULL, 8),
(243056, NULL, 'PTHR33830', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 184-RELATED', NULL, NULL, 11936, 8),
(243057, NULL, 'PTHR13219', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 30353, 8),
(243058, NULL, 'PTHR32161', NULL, NULL, NULL, NULL, 'DPP6 N-TERMINAL DOMAIN-LIKE PROTEIN', NULL, NULL, NULL, 8),
(243059, NULL, 'PTHR48126', NULL, NULL, NULL, NULL, 'RE24507P', NULL, NULL, NULL, 8),
(243060, NULL, 'PTHR37103', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(243061, NULL, 'PTHR42870', NULL, NULL, NULL, NULL, 'ACETYL-COA C-ACETYLTRANSFERASE', NULL, NULL, NULL, 8),
(243062, NULL, 'PTHR30537', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR', NULL, NULL, NULL, 8),
(243063, NULL, 'PTHR42061', NULL, NULL, NULL, NULL, 'ENDO-CHITOSANASE', NULL, NULL, 8049, 8),
(243064, NULL, 'PTHR36861', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 116', NULL, NULL, 25862, 8),
(243065, NULL, 'PTHR32077', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN', NULL, NULL, 36847, 8),
(243066, NULL, 'PTHR37832', NULL, NULL, NULL, NULL, 'BLL2683 PROTEIN', NULL, NULL, NULL, 8),
(243067, NULL, 'PTHR13361', NULL, NULL, NULL, NULL, 'WW DOMAIN-BINDING PROTEIN 11', NULL, NULL, 15958, 8),
(243068, NULL, 'PTHR36488', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 1U1', NULL, NULL, 34912, 8),
(243069, NULL, 'PTHR43580', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE GLYR1-RELATED', NULL, NULL, NULL, 8),
(243070, NULL, 'PTHR24356', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE', NULL, NULL, NULL, 8),
(243071, NULL, 'PTHR36900', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT M, CHLOROPLASTIC', NULL, NULL, 14831, 8),
(243072, NULL, 'PTHR37387', NULL, NULL, NULL, NULL, 'PROTEIN SAMBA', NULL, NULL, 33040, 8),
(243073, NULL, 'PTHR45197', NULL, NULL, NULL, NULL, 'SYNTHASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G04190)-RELATED', NULL, NULL, NULL, 8),
(243074, NULL, 'PTHR47158', NULL, NULL, NULL, NULL, 'OS08G0239000 PROTEIN', NULL, NULL, NULL, 8),
(243075, NULL, 'PTHR46617', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN G1', NULL, NULL, NULL, 8),
(243076, NULL, 'PTHR47414', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP20-2, CHLOROPLASTIC', NULL, NULL, 35117, 8),
(243077, NULL, 'PTHR38973', NULL, NULL, NULL, NULL, 'PLASMID PARTITIONING CONTROL PROTEIN-RELATED', NULL, NULL, NULL, 8),
(243078, NULL, 'PTHR43655', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT PROTEASE', NULL, NULL, NULL, 8),
(243079, NULL, 'PTHR14198', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 4 L6 FAMILY MEMBER 1-RELATED', NULL, NULL, 12584, 8),
(243080, NULL, 'PTHR35037', NULL, NULL, NULL, NULL, 'C-TERMINAL REGION OF AIDA-LIKE PROTEIN', NULL, NULL, NULL, 8);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(243081, NULL, 'PTHR28652', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 59-LIKE PROTEIN', NULL, NULL, 20788, 8),
(243082, NULL, 'PTHR47790', NULL, NULL, NULL, NULL, 'TRNA/TMRNA (URACIL-C(5))-METHYLTRANSFERASE', NULL, NULL, 13787, 8),
(243083, NULL, 'PTHR46866', NULL, NULL, NULL, NULL, 'GH12955P', NULL, NULL, NULL, 8),
(243084, NULL, 'PTHR47778', NULL, NULL, NULL, NULL, 'BNAA05G14870D PROTEIN', NULL, NULL, NULL, 8),
(243085, NULL, 'PTHR14513', NULL, NULL, NULL, NULL, 'PROTECTION OF TELOMERES 1', NULL, NULL, 26736, 8),
(243086, NULL, 'PTHR21662', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(243087, NULL, 'PTHR47053', NULL, NULL, NULL, NULL, 'MUREIN DD-ENDOPEPTIDASE MEPH-RELATED', NULL, NULL, NULL, 8),
(243088, NULL, 'PTHR11081', NULL, NULL, NULL, NULL, 'FLAP ENDONUCLEASE FAMILY MEMBER', NULL, NULL, 2855, 8),
(243089, NULL, 'PTHR10106', NULL, NULL, NULL, NULL, 'CYTOCHROME B561-RELATED', NULL, NULL, 36440, 8),
(243090, NULL, 'PTHR47886', NULL, NULL, NULL, NULL, 'CYSTATIN-11', NULL, NULL, 36419, 8),
(243091, NULL, 'PTHR14292', NULL, NULL, NULL, NULL, 'INTERLEUKIN-18-BINDING PROTEIN', NULL, NULL, 27369, 8),
(243092, NULL, 'PTHR47614', NULL, NULL, NULL, NULL, 'GLYCOPHORIN-C', NULL, NULL, 34879, 8),
(243093, NULL, 'PTHR15088', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR RIP140', NULL, NULL, 23666, 8),
(243094, NULL, 'PTHR38046', NULL, NULL, NULL, NULL, 'CRYPTIC LOCI REGULATOR 2', NULL, NULL, 30755, 8),
(243095, NULL, 'PTHR38002', NULL, NULL, NULL, NULL, 'C4ORF36 ISOFORM 11', NULL, NULL, 22339, 8),
(243096, NULL, 'PTHR31676', NULL, NULL, NULL, NULL, 'T31J12.3 PROTEIN-RELATED', NULL, NULL, 10466, 8),
(243097, NULL, 'PTHR22894', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 32634, 8),
(243098, NULL, 'PTHR46467', NULL, NULL, NULL, NULL, 'TETHER CONTAINING UBX DOMAIN FOR GLUT4', NULL, NULL, NULL, 8),
(243099, NULL, 'PTHR12758', NULL, NULL, NULL, NULL, 'APOPTOSIS INHIBITOR 5-RELATED', NULL, NULL, 7656, 8),
(243100, NULL, 'PTHR45993', NULL, NULL, NULL, NULL, 'B-CELL LYMPHOMA/LEUKEMIA 11', NULL, NULL, NULL, 8),
(243101, NULL, 'PTHR30136', NULL, NULL, NULL, NULL, 'HELIX-TURN-HELIX TRANSCRIPTIONAL REGULATOR, ICLR FAMILY', NULL, NULL, NULL, 8),
(243102, NULL, 'PTHR34549', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I REACTION CENTER SUBUNIT IV A, CHLOROPLASTIC-RELATED', NULL, NULL, 4320, 8),
(243103, NULL, 'PTHR17314', NULL, NULL, NULL, NULL, 'REGULATED ENDOCRINE SPECIFIC PROTEIN 18', NULL, NULL, 22136, 8),
(243104, NULL, 'PTHR32331', NULL, NULL, NULL, NULL, 'UPF0313 PROTEIN YGIQ', NULL, NULL, 14517, 8),
(243105, NULL, 'PTHR23300', NULL, NULL, NULL, NULL, 'METHANETHIOL OXIDASE', NULL, NULL, 13664, 8),
(243106, NULL, 'PTHR42345', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(243107, NULL, 'PTHR36982', NULL, NULL, NULL, NULL, 'CLCA DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(243108, NULL, 'PTHR43191', NULL, NULL, NULL, NULL, 'RRNA METHYLTRANSFERASE 3,', NULL, NULL, NULL, 8),
(243109, NULL, 'PTHR38932', NULL, NULL, NULL, NULL, 'BNAC03G64660D PROTEIN', NULL, NULL, NULL, 8),
(243110, NULL, 'PTHR11540', NULL, NULL, NULL, NULL, 'MALATE AND LACTATE DEHYDROGENASE', NULL, NULL, NULL, 8),
(243111, NULL, 'PTHR44156', NULL, NULL, NULL, NULL, 'SUPERNUMERARY LIMBS, ISOFORM B-RELATED', NULL, NULL, NULL, 8),
(243112, NULL, 'PTHR47940', NULL, NULL, NULL, NULL, 'OS12G0283900 PROTEIN', NULL, NULL, NULL, 8),
(243113, NULL, 'PTHR47972', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KLP-3', NULL, NULL, NULL, 8),
(243114, NULL, 'PTHR32193', NULL, NULL, NULL, NULL, 'REGULATOR OF CELL CYCLE RGCC', NULL, NULL, 21563, 8),
(243115, NULL, 'PTHR47181', NULL, NULL, NULL, NULL, 'BRCA1 C TERMINUS DOMAIN CONTAINING PROTEIN, EXPRESSED', NULL, NULL, 34536, 8),
(243116, NULL, 'PTHR15556', NULL, NULL, NULL, NULL, 'EP300-INTERACTING INHIBITOR OF DIFFERENTIATION 2-RELATED', NULL, NULL, 31943, 8),
(243117, NULL, 'PTHR46652', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND IQ DOMAIN-CONTAINING PROTEIN 1-RELATED', NULL, NULL, NULL, 8),
(243118, NULL, 'PTHR11715', NULL, NULL, NULL, NULL, 'GLYCINE CLEAVAGE SYSTEM H PROTEIN', NULL, NULL, 6929, 8);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(243119, NULL, 'PTHR14340', NULL, NULL, NULL, NULL, 'MICROFIBRIL-ASSOCIATED GLYCOPROTEIN 3', NULL, NULL, 31006, 8),
(243120, NULL, 'PTHR35722', NULL, NULL, NULL, NULL, 'MAL D 1-ASSOCIATED PROTEIN', NULL, NULL, NULL, 8),
(243121, NULL, 'PTHR21578', NULL, NULL, NULL, NULL, 'PROTEIN CBG03826', NULL, NULL, NULL, 8),
(243122, NULL, 'PTHR10598', NULL, NULL, NULL, NULL, 'SET1/ASH2 HISTONE METHYLTRANSFERASE COMPLEX SUBUNIT ASH2', NULL, NULL, 27599, 8),
(243123, NULL, 'PTHR12976', NULL, NULL, NULL, NULL, 'RETINAL ROD RHODOPSIN-SENSITIVE CGMP 3'',5''-CYCLIC PHOSPHODIESTERASE DELTA-SUBUNIT', NULL, NULL, NULL, 8),
(243124, NULL, 'PTHR11733', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEASE FAMILY M13 NEPRILYSIN-RELATED', NULL, NULL, 3756, 8),
(243125, NULL, 'PTHR44924', NULL, NULL, NULL, NULL, 'DNAJ SUBFAMILY A MEMBER 2', NULL, NULL, NULL, 8),
(243126, NULL, 'PTHR13000', NULL, NULL, NULL, NULL, 'NUCLEOPORIN P54', NULL, NULL, 22112, 8),
(243127, NULL, 'PTHR28128', NULL, NULL, NULL, NULL, 'GOLGI APPARATUS MEMBRANE PROTEIN TVP15', NULL, NULL, 14254, 8),
(243128, NULL, 'PTHR34056', NULL, NULL, NULL, NULL, 'GPI-ANCHORED PROTEIN', NULL, NULL, 27690, 8),
(243129, NULL, 'PTHR31584', NULL, NULL, NULL, NULL, 'TUMOR PROTEIN P53-INDUCIBLE PROTEIN 11', NULL, NULL, 26521, 8),
(243130, NULL, 'PTHR31010', NULL, NULL, NULL, NULL, 'RAN-SPECIFIC GTPASE-ACTIVATING PROTEIN 30-RELATED', NULL, NULL, 13936, 8),
(243131, NULL, 'PTHR13314', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 15660, 8),
(243132, NULL, 'PTHR30290', NULL, NULL, NULL, NULL, 'PERIPLASMIC BINDING COMPONENT OF ABC TRANSPORTER', NULL, NULL, 33160, 8),
(243133, NULL, 'PTHR15326', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 2/TAMOZHENNIC', NULL, NULL, NULL, 8),
(243134, NULL, 'PTHR23172', NULL, NULL, NULL, NULL, 'AUXILIN/CYCLIN G-ASSOCIATED KINASE-RELATED', NULL, NULL, NULL, 8),
(243135, NULL, 'PTHR36792', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(243136, NULL, 'PTHR24408', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', NULL, NULL, NULL, 8),
(243137, NULL, 'PTHR30349', NULL, NULL, NULL, NULL, 'PHAGE INTEGRASE-RELATED', NULL, NULL, NULL, 8),
(243138, NULL, 'PTHR46732', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT PROTEASE LA (LON) DOMAIN PROTEIN', NULL, NULL, NULL, 8),
(243139, NULL, 'PTHR10174', NULL, NULL, NULL, NULL, 'ALPHA-TOCOPHEROL TRANSFER PROTEIN-RELATED', NULL, NULL, NULL, 8),
(243140, NULL, 'PTHR12988', NULL, NULL, NULL, NULL, 'SPHINGOMYELIN PHOSPHODIESTERASE 4', NULL, NULL, 14081, 8),
(243141, NULL, 'PTHR45929', NULL, NULL, NULL, NULL, 'JAK PATHWAY SIGNAL TRANSDUCTION ADAPTOR MOLECULE', NULL, NULL, NULL, 8),
(243142, NULL, 'PTHR38694', NULL, NULL, NULL, NULL, 'CONSERVED EXPRESSED PROTEIN', NULL, NULL, 19113, 8),
(243143, NULL, 'PTHR10265', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR 1', NULL, NULL, NULL, 8),
(243144, NULL, 'PTHR35830', NULL, NULL, NULL, NULL, 'OS05G0299200 PROTEIN', NULL, NULL, NULL, 8),
(243145, NULL, 'PTHR37909', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(243146, NULL, 'PTHR35360', NULL, NULL, NULL, NULL, 'OS01G0324125 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(243147, NULL, 'PTHR48002', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', NULL, NULL, NULL, 8),
(243148, NULL, 'PTHR33112', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(243149, NULL, 'PTHR46618', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING PROTEIN 3', NULL, NULL, NULL, 8),
(243150, NULL, 'PTHR47681', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL N-ACETYLGLUCOSAMINYLTRANSFERASE SUBUNIT P-RELATED', NULL, NULL, NULL, 8),
(243151, NULL, 'PTHR45699', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P0', NULL, NULL, NULL, 8),
(243152, NULL, 'PTHR22931', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE DIKINASE-RELATED', NULL, NULL, 10902, 8),
(243153, NULL, 'PTHR23221', NULL, NULL, NULL, NULL, 'GLYCOSYLPHOSPHATIDYLINOSITOL PHOSPHOLIPASE D', NULL, NULL, NULL, 8),
(243154, NULL, 'PTHR46366', NULL, NULL, NULL, NULL, 'PRO-APOPTOTIC SERINE PROTEASE NMA111', NULL, NULL, NULL, 8);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(243155, NULL, 'PTHR37027', NULL, NULL, NULL, NULL, 'KDE4', NULL, NULL, 30934, 8),
(243156, NULL, 'PTHR45090', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ 20 CHLOROPLASTIC', NULL, NULL, NULL, 8),
(243157, NULL, 'PTHR36111', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', NULL, NULL, 1864, 8),
(243158, NULL, 'PTHR47357', NULL, NULL, NULL, NULL, 'COP1-INTERACTIVE PROTEIN 1', NULL, NULL, NULL, 8),
(243159, NULL, 'PTHR10182', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN 39-RELATED', NULL, NULL, 17702, 8),
(243160, NULL, 'PTHR45862', NULL, NULL, NULL, NULL, 'PROTEIN SGT1 HOMOLOG', NULL, NULL, 36300, 8),
(243161, NULL, 'PTHR35119', NULL, NULL, NULL, NULL, 'PROTEIN POLYCHOME', NULL, NULL, 316, 8),
(243162, NULL, 'PTHR12789', NULL, NULL, NULL, NULL, 'DENSITY-REGULATED PROTEIN HOMOLOG', NULL, NULL, NULL, 8),
(243163, NULL, 'PTHR22069', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOMAL PROTEIN S18', NULL, NULL, NULL, 8),
(243164, NULL, 'PTHR12629', NULL, NULL, NULL, NULL, 'DIPHOSPHOINOSITOL POLYPHOSPHATE PHOSPHOHYDROLASE', NULL, NULL, NULL, 8),
(243165, NULL, 'PTHR15435', NULL, NULL, NULL, NULL, 'KICSTOR COMPLEX PROTEIN KAPTIN', NULL, NULL, 21918, 8),
(243166, NULL, 'PTHR45093', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ACTIVATOR MSS11', NULL, NULL, NULL, 8),
(243167, NULL, 'PTHR14667', NULL, NULL, NULL, NULL, 'BARDET-BIEDL SYNDROME 10 PROTEIN', NULL, NULL, 35853, 8),
(243168, NULL, 'PTHR15597', NULL, NULL, NULL, NULL, 'ATAXIN 2-BINDING PROTEIN 1-RELATED', NULL, NULL, NULL, 8),
(243169, NULL, 'PTHR36180', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN-RELATED-RELATED', NULL, NULL, NULL, 8),
(243170, NULL, 'PTHR19845', NULL, NULL, NULL, NULL, 'KATANIN P80 SUBUNIT', NULL, NULL, NULL, 8),
(243171, NULL, 'PTHR21581', NULL, NULL, NULL, NULL, 'D-ALANYL-D-ALANINE CARBOXYPEPTIDASE', NULL, NULL, NULL, 8),
(243172, NULL, 'PTHR43336', NULL, NULL, NULL, NULL, 'OXYGEN SENSOR HISTIDINE KINASE RESPONSE REGULATOR DEVS/DOSS', NULL, NULL, NULL, 8),
(243173, NULL, 'PTHR31906', NULL, NULL, NULL, NULL, 'PLASTID-LIPID-ASSOCIATED PROTEIN 4, CHLOROPLASTIC-RELATED', NULL, NULL, 27008, 8),
(243174, NULL, 'PTHR38622', NULL, NULL, NULL, NULL, 'PROTEIN CBG07046', NULL, NULL, NULL, 8),
(243175, NULL, 'PTHR21248', NULL, NULL, NULL, NULL, 'CARDIOLIPIN SYNTHASE', NULL, NULL, NULL, 8),
(243176, NULL, 'PTHR12659', NULL, NULL, NULL, NULL, 'RHO-TYPE GTPASE ACTIVATING PROTEIN', NULL, NULL, NULL, 8),
(243177, NULL, 'PTHR13817', NULL, NULL, NULL, NULL, 'TITIN', NULL, NULL, NULL, 8),
(243178, NULL, 'PTHR34793', NULL, NULL, NULL, NULL, 'PROTEIN THYLAKOID FORMATION 1, CHLOROPLASTIC', NULL, NULL, 20523, 8),
(243179, NULL, 'PTHR45897', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY CHOLINE TRANSPORTER 1', NULL, NULL, NULL, 8),
(243180, NULL, 'PTHR16017', NULL, NULL, NULL, NULL, 'GASTRULATION DEFECTIVE PROTEIN 1-RELATED', NULL, NULL, NULL, 8),
(243181, NULL, 'PTHR46146', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE-LIKE PROTEIN CCR4', NULL, NULL, 35230, 8),
(243182, NULL, 'PTHR36076', NULL, NULL, NULL, NULL, 'THIOREDOXIN SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(243183, NULL, 'PTHR37559', NULL, NULL, NULL, NULL, 'PAREP6 PART 2, AUTHENTIC FRAMESHIFT', NULL, NULL, NULL, 8),
(243184, NULL, 'PTHR36771', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER', NULL, NULL, NULL, 8),
(243185, NULL, 'PTHR22891', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 2C', NULL, NULL, NULL, 8),
(243186, NULL, 'PTHR36882', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED SEQUENCE 37 PROTEIN', NULL, NULL, 26314, 8),
(243187, NULL, 'PTHR33941', NULL, NULL, NULL, NULL, 'PROPANEDIOL UTILIZATION PROTEIN PDUA', NULL, NULL, NULL, 8),
(243188, NULL, 'PTHR22777', NULL, NULL, NULL, NULL, 'HEMOLYSIN-RELATED', NULL, NULL, NULL, 8),
(243189, NULL, 'PTHR48176', NULL, NULL, NULL, NULL, 'DDRGK DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(243190, NULL, 'PTHR45965', NULL, NULL, NULL, NULL, 'INACTIVE RHOMBOID PROTEIN', NULL, NULL, NULL, 8),
(243191, NULL, 'PTHR48203', NULL, NULL, NULL, NULL, 'BNAC01G40110D PROTEIN', NULL, NULL, NULL, 8),
(243192, NULL, 'PTHR13743', NULL, NULL, NULL, NULL, 'BEIGE/BEACH-RELATED', NULL, NULL, NULL, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(243193, NULL, 'PTHR12777', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN SM D2', NULL, NULL, 26855, 8),
(243194, NULL, 'PTHR40691', NULL, NULL, NULL, NULL, '', NULL, NULL, 10174, 8),
(243195, NULL, 'PTHR34537', NULL, NULL, NULL, NULL, 'OS08G0459300 PROTEIN', NULL, NULL, NULL, 8),
(243196, NULL, 'PTHR45742', NULL, NULL, NULL, NULL, 'COMPLEMENT COMPONENT C6', NULL, NULL, NULL, 8),
(243197, NULL, 'PTHR34795', NULL, NULL, NULL, NULL, 'NEMATODE RESISTANCE PROTEIN-LIKE HSPRO1', NULL, NULL, 33434, 8),
(243198, NULL, 'PTHR46701', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE-LIKE KOBITO 1', NULL, NULL, 34883, 8),
(243199, NULL, 'PTHR35515', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT N, CHLOROPLASTIC', NULL, NULL, 21380, 8),
(243200, NULL, 'PTHR22835', NULL, NULL, NULL, NULL, 'ZINC FINGER FYVE DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(243201, NULL, 'PTHR31233', NULL, NULL, NULL, NULL, 'BICAUDAL D FAMILY MEMBER', NULL, NULL, 21187, 8),
(243202, NULL, 'PTHR46580', NULL, NULL, NULL, NULL, 'SENSOR KINASE-RELATED', NULL, NULL, NULL, 8),
(243203, NULL, 'PTHR33775', NULL, NULL, NULL, NULL, 'CARDIAC-ENRICHED FHL2-INTERACTING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(243204, NULL, 'PTHR45996', NULL, NULL, NULL, NULL, 'AGAP001464-PB', NULL, NULL, NULL, 8),
(243205, NULL, 'PTHR25480', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 73', NULL, NULL, NULL, 8),
(243206, NULL, 'PTHR24351', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S6 KINASE', NULL, NULL, NULL, 8),
(243207, NULL, 'PTHR13348', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P SUBUNIT P29', NULL, NULL, 16159, 8),
(243208, NULL, 'PTHR22810', NULL, NULL, NULL, NULL, 'TESTIS DEVELOPMENT PROTEIN NYD-SP26', NULL, NULL, 22498, 8),
(243209, NULL, 'PTHR23153', NULL, NULL, NULL, NULL, 'UBX-RELATED', NULL, NULL, NULL, 8),
(243210, NULL, 'PTHR35490', NULL, NULL, NULL, NULL, 'BACTERIOPHAGE N4 ADSORPTION B PROTEIN', NULL, NULL, NULL, 8),
(243211, NULL, 'PTHR13415', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR-RELATED', NULL, NULL, NULL, 8),
(243212, NULL, 'PTHR36691', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 247', NULL, NULL, 26876, 8),
(243213, NULL, 'PTHR14200', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE POLYPEPTIDE', NULL, NULL, 1933, 8),
(243214, NULL, 'PTHR31068', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL DISTRIBUTION AND MORPHOLOGY PROTEIN 31', NULL, NULL, 9404, 8),
(243215, NULL, 'PTHR37394', NULL, NULL, NULL, NULL, 'PROTEIN PARTING DANCERS', NULL, NULL, 33190, 8),
(243216, NULL, 'PTHR22133', NULL, NULL, NULL, NULL, 'AT01821P-RELATED', NULL, NULL, NULL, 8),
(243217, NULL, 'PTHR31194', NULL, NULL, NULL, NULL, 'SHN  SHINE , DNA BINDING / TRANSCRIPTION FACTOR', NULL, NULL, NULL, 8),
(243218, NULL, 'PTHR34446', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 10', NULL, NULL, 26460, 8),
(243219, NULL, 'PTHR13617', NULL, NULL, NULL, NULL, 'PROTEIN ABHD18', NULL, NULL, 18035, 8),
(243220, NULL, 'PTHR46460', NULL, NULL, NULL, NULL, 'METHYLATED-DNA--PROTEIN-CYSTEINE METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(243221, NULL, 'PTHR28025', NULL, NULL, NULL, NULL, 'DASH COMPLEX SUBUNIT DAD1', NULL, NULL, 7855, 8),
(243222, NULL, 'PTHR40252', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(243223, NULL, 'PTHR15031', NULL, NULL, NULL, NULL, 'CARTILAGE INTERMEDIATE LAYER PROTEIN  CLIP', NULL, NULL, 33219, 8),
(243224, NULL, 'PTHR23418', NULL, NULL, NULL, NULL, 'ACIREDUCTONE DIOXYGENASE', NULL, NULL, 4735, 8),
(243225, NULL, 'PTHR10072', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER ASSEMBLY PROTEIN', NULL, NULL, NULL, 8),
(243226, NULL, 'PTHR43161', NULL, NULL, NULL, NULL, 'SORBITOL DEHYDROGENASE', NULL, NULL, NULL, 8),
(243227, NULL, 'PTHR33872', NULL, NULL, NULL, NULL, 'DNA POLYMERASE EPSILON CATALYTIC SUBUNIT A', NULL, NULL, NULL, 8),
(243228, NULL, 'PTHR31888', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 19', NULL, NULL, 26417, 8),
(243229, NULL, 'PTHR37884', NULL, NULL, NULL, NULL, 'SEPTIN 4', NULL, NULL, 24473, 8),
(243230, NULL, 'PTHR43611', NULL, NULL, NULL, NULL, 'ALPHA-D-GLUCOSE 1-PHOSPHATE PHOSPHATASE', NULL, NULL, NULL, 8);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(243231, NULL, 'PTHR44229', NULL, NULL, NULL, NULL, '15-HYDROXYPROSTAGLANDIN DEHYDROGENASE [NAD(+)]', NULL, NULL, NULL, 8),
(243232, NULL, 'PTHR11959', NULL, NULL, NULL, NULL, '4-HYDROXYPHENYLPYRUVATE DIOXYGENASE', NULL, NULL, 283, 8),
(243233, NULL, 'PTHR36058', NULL, NULL, NULL, NULL, 'NUCLEOPHOSMIN', NULL, NULL, NULL, 8),
(243234, NULL, 'PTHR47274', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN CONTAINING PROTEIN, EXPRESSED-RELATED', NULL, NULL, 35970, 8),
(243235, NULL, 'PTHR37412', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN 5', NULL, NULL, 30860, 8),
(243236, NULL, 'PTHR46428', NULL, NULL, NULL, NULL, 'KELCH DOMAIN-CONTAINING PROTEIN 10', NULL, NULL, NULL, 8),
(243237, NULL, 'PTHR16270', NULL, NULL, NULL, NULL, 'HYPOTHETICAL LOC287798', NULL, NULL, 28935, 8),
(243238, NULL, 'PTHR33191', NULL, NULL, NULL, NULL, 'RIPENING-RELATED PROTEIN 2-RELATED', NULL, NULL, 30827, 8),
(243239, NULL, 'PTHR13780', NULL, NULL, NULL, NULL, 'AMP-ACTIVATED PROTEIN KINASE, GAMMA REGULATORY SUBUNIT', NULL, NULL, NULL, 8),
(243240, NULL, 'PTHR23061', NULL, NULL, NULL, NULL, 'DNA POLYMERASE 2 ALPHA 70 KDA SUBUNIT', NULL, NULL, 21273, 8),
(243241, NULL, 'PTHR38772', NULL, NULL, NULL, NULL, '', NULL, NULL, 5821, 8),
(243242, NULL, 'PTHR37460', NULL, NULL, NULL, NULL, 'ENDONUCLEASE III', NULL, NULL, 5119, 8),
(243243, NULL, 'PTHR15020', NULL, NULL, NULL, NULL, 'FLAVIN REDUCTASE-RELATED', NULL, NULL, NULL, 8),
(243244, NULL, 'PTHR12429', NULL, NULL, NULL, NULL, 'NEURALIZED', NULL, NULL, 31450, 8),
(243245, NULL, 'PTHR22970', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 2', NULL, NULL, NULL, 8),
(243246, NULL, 'PTHR21592', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(243247, NULL, 'PTHR17416', NULL, NULL, NULL, NULL, 'SMALL MUSCULAR PROTEIN', NULL, NULL, 26494, 8),
(243248, NULL, 'PTHR43272', NULL, NULL, NULL, NULL, 'LONG-CHAIN-FATTY-ACID--COA LIGASE', NULL, NULL, NULL, 8),
(243249, NULL, 'PTHR48235', NULL, NULL, NULL, NULL, 'OS01G0916700 PROTEIN', NULL, NULL, NULL, 8),
(243250, NULL, 'PTHR35117', NULL, NULL, NULL, NULL, 'MYOSIN-M HEAVY PROTEIN', NULL, NULL, NULL, 8),
(243251, NULL, 'PTHR40517', NULL, NULL, NULL, NULL, 'METAL-DEPENDENT PHOSPHOHYDROLASE, HD SUPERFAMILY-RELATED', NULL, NULL, 28627, 8),
(243252, NULL, 'PTHR37994', NULL, NULL, NULL, NULL, 'ARAE_2_N DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(243253, NULL, 'PTHR45968', NULL, NULL, NULL, NULL, 'OSJNBA0019K04.7 PROTEIN', NULL, NULL, NULL, 8),
(243254, NULL, 'PTHR14234', NULL, NULL, NULL, NULL, 'RIM BINDING PROTEIN-RELATED', NULL, NULL, 30053, 8),
(243255, NULL, 'PTHR34563', NULL, NULL, NULL, NULL, 'BNACNNG33880D PROTEIN', NULL, NULL, NULL, 8),
(243256, NULL, 'PTHR10572', NULL, NULL, NULL, NULL, '3-HYDROXY-3-METHYLGLUTARYL-COENZYME A REDUCTASE', NULL, NULL, 235, 8),
(243257, NULL, 'PTHR31350', NULL, NULL, NULL, NULL, 'SI:DKEY-261L7.2', NULL, NULL, NULL, 8),
(243258, NULL, 'PTHR36983', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 13', NULL, NULL, 36814, 8),
(243259, NULL, 'PTHR34618', NULL, NULL, NULL, NULL, 'SURFACE PROTEIN MAS1, PUTATIVE-RELATED', NULL, NULL, 18430, 8),
(243260, NULL, 'PTHR30616', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN YFIH', NULL, NULL, 2018, 8),
(243261, NULL, 'PTHR24250', NULL, NULL, NULL, NULL, 'CHYMOTRYPSIN-RELATED', NULL, NULL, NULL, 8),
(243262, NULL, 'PTHR35985', NULL, NULL, NULL, NULL, 'OS07G0675200 PROTEIN', NULL, NULL, NULL, 8),
(243263, NULL, 'PTHR43205', NULL, NULL, NULL, NULL, 'PROSTAGLANDIN REDUCTASE', NULL, NULL, 34379, 8),
(243264, NULL, 'PTHR22739', NULL, NULL, NULL, NULL, 'STRIATED MUSCLE ACTIVATOR OF RHO-DEPENDENT SIGNALING-RELATED', NULL, NULL, 25767, 8),
(243265, NULL, 'PTHR33659', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED-RELATED', NULL, NULL, NULL, 8),
(243266, NULL, 'PTHR42729', NULL, NULL, NULL, NULL, 'OLIGO/DIPEPTIDE TRANSPORT, PERMEASE PROTEIN (DPPC-2)', NULL, NULL, NULL, 8),
(243267, NULL, 'PTHR34685', NULL, NULL, NULL, NULL, 'RED CHLOROPHYLL CATABOLITE REDUCTASE, CHLOROPLASTIC', NULL, NULL, 8406, 8),
(243268, NULL, 'PTHR12738', NULL, NULL, NULL, NULL, 'NEUROENDOCRINE PROTEIN 7B2', NULL, NULL, 4181, 8);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(243269, NULL, 'PTHR24156', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', NULL, NULL, 35712, 8),
(243270, NULL, 'PTHR28188', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM5', NULL, NULL, NULL, 8),
(243271, NULL, 'PTHR24341', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN ENGRAILED', NULL, NULL, NULL, 8),
(243272, NULL, 'PTHR34292', NULL, NULL, NULL, NULL, 'OUTER SPORE WALL PROTEIN LDS1', NULL, NULL, NULL, 8),
(243273, NULL, 'PTHR43559', NULL, NULL, NULL, NULL, 'HYDROLASE YCAC-RELATED', NULL, NULL, NULL, 8),
(243274, NULL, 'PTHR14963', NULL, NULL, NULL, NULL, 'RHO GTPASE ACTIVATING PROTEIN 18,19-RELATED', NULL, NULL, NULL, 8),
(243275, NULL, 'PTHR39220', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN PVRIG', NULL, NULL, 2720, 8),
(243276, NULL, 'PTHR13587', NULL, NULL, NULL, NULL, 'INTEGRATOR COMPLEX SUBUNIT 3', NULL, NULL, 37431, 8),
(243277, NULL, 'PTHR13237', NULL, NULL, NULL, NULL, 'SOMETHING ABOUT SILENCING PROTEIN 10-RELATED', NULL, NULL, 145, 8),
(243278, NULL, 'PTHR41694', NULL, NULL, NULL, NULL, 'ENDOGENOUS RETROVIRUS GROUP K MEMBER POL PROTEIN', NULL, NULL, NULL, 8),
(243279, NULL, 'PTHR38098', NULL, NULL, NULL, NULL, 'LPS-ASSEMBLY LIPOPROTEIN LPTE', NULL, NULL, 10385, 8),
(243280, NULL, 'PTHR43976', NULL, NULL, NULL, NULL, 'SHORT CHAIN DEHYDROGENASE', NULL, NULL, NULL, 8),
(243281, NULL, 'PTHR35779', NULL, NULL, NULL, NULL, 'PH-RESPONSE REGULATOR PROTEIN PALH/RIM21', NULL, NULL, 11704, 8),
(243282, NULL, 'PTHR38736', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(243283, NULL, 'PTHR14199', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(243284, NULL, 'PTHR43530', NULL, NULL, NULL, NULL, 'QUEUINE TRNA-RIBOSYLTRANSFERASE CATALYTIC SUBUNIT 1', NULL, NULL, NULL, 8),
(243285, NULL, 'PTHR44321', NULL, NULL, NULL, NULL, 'TRANSDUCIN BETA-LIKE PROTEIN 2', NULL, NULL, 36746, 8),
(243286, NULL, 'PTHR35862', NULL, NULL, NULL, NULL, 'FELS-2 PROPHAGE PROTEIN', NULL, NULL, NULL, 8),
(243287, NULL, 'PTHR15298', NULL, NULL, NULL, NULL, 'L-COA N-ACYLTRANSFERASE-RELATED', NULL, NULL, 8947, 8),
(243288, NULL, 'PTHR12146', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S10', NULL, NULL, 28536, 8),
(243289, NULL, 'PTHR47565', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE 19-1', NULL, NULL, NULL, 8),
(243290, NULL, 'PTHR21040', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 31200, 8),
(243291, NULL, 'PTHR37614', NULL, NULL, NULL, NULL, 'OS02G0121400 PROTEIN', NULL, NULL, NULL, 8),
(243292, NULL, 'PTHR34300', NULL, NULL, NULL, NULL, 'QUEUOSINE PRECURSOR TRANSPORTER-RELATED', NULL, NULL, 2380, 8),
(243293, NULL, 'PTHR24206', NULL, NULL, NULL, NULL, 'OS06G0237300 PROTEIN', NULL, NULL, 35614, 8),
(243294, NULL, 'PTHR33109', NULL, NULL, NULL, NULL, 'EPIDERMAL PATTERNING FACTOR-LIKE PROTEIN 4', NULL, NULL, 30889, 8),
(243295, NULL, 'PTHR21391', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(243296, NULL, 'PTHR35154', NULL, NULL, NULL, NULL, 'GBP PROTEIN', NULL, NULL, 5102, 8),
(243297, NULL, 'PTHR47175', NULL, NULL, NULL, NULL, 'LIPASE ATG15-RELATED', NULL, NULL, NULL, 8),
(243298, NULL, 'PTHR13663', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 32039, 8),
(243299, NULL, 'PTHR13555', NULL, NULL, NULL, NULL, 'C2H2 ZINC FINGER CGI-62-RELATED', NULL, NULL, 25543, 8),
(243300, NULL, 'PTHR23034', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 24175, 8),
(243301, NULL, 'PTHR47299', NULL, NULL, NULL, NULL, 'PROTEIN FAM166A', NULL, NULL, NULL, 8),
(243302, NULL, 'PTHR38731', NULL, NULL, NULL, NULL, 'LIPL45-RELATED LIPOPROTEIN-RELATED', NULL, NULL, NULL, 8),
(243303, NULL, 'PTHR47329', NULL, NULL, NULL, NULL, 'OS05G0129900 PROTEIN', NULL, NULL, NULL, 8),
(243304, NULL, 'PTHR31617', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 171', NULL, NULL, 26990, 8),
(243305, NULL, 'PTHR43667', NULL, NULL, NULL, NULL, 'CYCLOPROPANE-FATTY-ACYL-PHOSPHOLIPID SYNTHASE', NULL, NULL, NULL, 8),
(243306, NULL, 'PTHR15083', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 BETA SUBCOMPLEX SUBUNIT 6', NULL, NULL, 18299, 8);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(243307, NULL, 'PTHR31034', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 101', NULL, NULL, 26473, 8),
(243308, NULL, 'PTHR38169', NULL, NULL, NULL, NULL, 'OS12G0178300 PROTEIN', NULL, NULL, NULL, 8),
(243309, NULL, 'PTHR47013', NULL, NULL, NULL, NULL, 'SPLICING FACTOR, ARGININE/SERINE-RICH 19', NULL, NULL, 35216, 8),
(243310, NULL, 'PTHR13155', NULL, NULL, NULL, NULL, 'A-KINASE ANCHOR PROTEINS', NULL, NULL, NULL, 8),
(243311, NULL, 'PTHR22924', NULL, NULL, NULL, NULL, 'LEGHEMOGLOBIN-RELATED', NULL, NULL, 2894, 8),
(243312, NULL, 'PTHR31167', NULL, NULL, NULL, NULL, 'SPINDLE AND CENTRIOLE ASSOCIATED PROTEIN 1 SPICE1', NULL, NULL, 25445, 8),
(243313, NULL, 'PTHR10652', NULL, NULL, NULL, NULL, 'ADENYLYL CYCLASE-ASSOCIATED PROTEIN', NULL, NULL, 4366, 8),
(243314, NULL, 'PTHR46594', NULL, NULL, NULL, NULL, 'P-TYPE CATION-TRANSPORTING ATPASE', NULL, NULL, NULL, 8),
(243315, NULL, 'PTHR37731', NULL, NULL, NULL, NULL, 'PEPTIDE TRANSPORTER FAMILY PROTEIN', NULL, NULL, NULL, 8),
(243316, NULL, 'PTHR43859', NULL, NULL, NULL, NULL, 'ACYL-ACTIVATING ENZYME', NULL, NULL, NULL, 8),
(243317, NULL, 'PTHR47910', NULL, NULL, NULL, NULL, 'RIBULOSE BISPHOSPHATE CARBOXYLASE LARGE CHAIN, CATALYTIC DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(243318, NULL, 'PTHR45854', NULL, NULL, NULL, NULL, 'ASAP FAMILY MEMBER', NULL, NULL, 35287, 8),
(243319, NULL, 'PTHR30606', NULL, NULL, NULL, NULL, 'LIPID A BIOSYNTHESIS LAUROYL ACYLTRANSFERASE', NULL, NULL, 2780, 8),
(243320, NULL, 'PTHR47348', NULL, NULL, NULL, NULL, 'MEIOTICALLY UP-REGULATED GENE 190 PROTEIN', NULL, NULL, NULL, 8),
(243321, NULL, 'PTHR11864', NULL, NULL, NULL, NULL, 'PRE-MRNA-PROCESSING PROTEIN PRP40', NULL, NULL, 33491, 8),
(243322, NULL, 'PTHR47358', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HOS1', NULL, NULL, 34954, 8),
(243323, NULL, 'PTHR28358', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 127', NULL, NULL, 27719, 8),
(243324, NULL, 'PTHR15273', NULL, NULL, NULL, NULL, 'DAN DOMAIN FAMILY MEMBER 5', NULL, NULL, 16049, 8),
(243325, NULL, 'PTHR37229', NULL, NULL, NULL, NULL, '6,7-DIMETHYL-8-RIBITYLLUMAZINE SYNTHASE', NULL, NULL, NULL, 8),
(243326, NULL, 'PTHR16291', NULL, NULL, NULL, NULL, 'NUCLEAR CAP-BINDING PROTEIN SUBUNIT 3', NULL, NULL, 16848, 8),
(243327, NULL, 'PTHR23021', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS T', NULL, NULL, 16630, 8),
(243328, NULL, 'PTHR47569', NULL, NULL, NULL, NULL, 'NO-ASSOCIATED PROTEIN 1, CHLOROPLASTIC/MITOCHONDRIAL', NULL, NULL, 34908, 8),
(243329, NULL, 'PTHR37516', NULL, NULL, NULL, NULL, 'SCA1 COMPLEX SCAFFOLD PROTEIN SCAA', NULL, NULL, 29418, 8),
(243330, NULL, 'PTHR36447', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE GANA', NULL, NULL, 6496, 8),
(243331, NULL, 'PTHR21459', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(243332, NULL, 'PTHR36902', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(243333, NULL, 'PTHR19865', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RNA INTERACTING PROTEIN 2', NULL, NULL, 31996, 8),
(243334, NULL, 'PTHR31601', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S36, MITOCHONDRIAL', NULL, NULL, 19617, 8),
(243335, NULL, 'PTHR30503', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 13482, 8),
(243336, NULL, 'PTHR22670', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(243337, NULL, 'PTHR10412', NULL, NULL, NULL, NULL, 'MANNOSYL-OLIGOSACCHARIDE GLUCOSIDASE', NULL, NULL, 377, 8),
(243338, NULL, 'PTHR37824', NULL, NULL, NULL, NULL, 'IRON-REGULATED SURFACE DETERMINANT PROTEIN C', NULL, NULL, NULL, 8),
(243339, NULL, 'PTHR21402', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(243340, NULL, 'PTHR44436', NULL, NULL, NULL, NULL, 'F-BOX/WD REPEAT-CONTAINING PROTEIN 2', NULL, NULL, 35516, 8),
(243341, NULL, 'PTHR20991', NULL, NULL, NULL, NULL, 'PARATHYROID HORMONE-RESPONSIVE B1 GENE', NULL, NULL, 23406, 8),
(243342, NULL, 'PTHR45891', NULL, NULL, NULL, NULL, 'ZINC FINGER HOMEOBOX PROTEIN', NULL, NULL, NULL, 8),
(243343, NULL, 'PTHR37314', NULL, NULL, NULL, NULL, 'SLR0142 PROTEIN', NULL, NULL, NULL, 8);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(243344, NULL, 'PTHR30540', NULL, NULL, NULL, NULL, 'OSMOTIC STRESS POTASSIUM TRANSPORTER', NULL, NULL, 3007, 8),
(243345, NULL, 'PTHR10648', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP2A 65 KDA REGULATORY SUBUNIT', NULL, NULL, NULL, 8),
(243346, NULL, 'PTHR33970', NULL, NULL, NULL, NULL, 'VIOLAXANTHIN DE-EPOXIDASE, CHLOROPLASTIC-RELATED', NULL, NULL, 36491, 8),
(243347, NULL, 'PTHR39532', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(243348, NULL, 'PTHR46487', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN XRCC3', NULL, NULL, NULL, 8),
(243349, NULL, 'PTHR28524', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE ASSEMBLY FACTOR 4, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(243350, NULL, 'PTHR30002', NULL, NULL, NULL, NULL, 'EPOXYQUEUOSINE REDUCTASE', NULL, NULL, 7038, 8),
(243351, NULL, 'PTHR31947', NULL, NULL, NULL, NULL, 'DNA/RNA-BINDING PROTEIN ALBA 3', NULL, NULL, 12383, 8),
(243352, NULL, 'PTHR22888', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE, SUBUNIT II', NULL, NULL, 34430, 8),
(243353, NULL, 'PTHR34981', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN ZAPA', NULL, NULL, 2498, 8),
(243354, NULL, 'PTHR46125', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 28', NULL, NULL, 35960, 8),
(243355, NULL, 'PTHR27009', NULL, NULL, NULL, NULL, 'RUST RESISTANCE KINASE LR10-RELATED', NULL, NULL, 36503, 8),
(243356, NULL, 'PTHR47928', NULL, NULL, NULL, NULL, 'REPEAT-CONTAINING PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(243357, NULL, 'PTHR14009', NULL, NULL, NULL, NULL, 'LEUCINE ZIPPER-EF-HAND CONTAINING TRANSMEMBRANE PROTEIN', NULL, NULL, 34885, 8),
(243358, NULL, 'PTHR43694', NULL, NULL, NULL, NULL, 'RIBONUCLEASE J', NULL, NULL, NULL, 8),
(243359, NULL, 'PTHR15615', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 14364, 8),
(243360, NULL, 'PTHR22545', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 22297, 8),
(243361, NULL, 'PTHR37900', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(243362, NULL, 'PTHR30153', NULL, NULL, NULL, NULL, 'REPLICATIVE DNA HELICASE DNAB', NULL, NULL, NULL, 8),
(243363, NULL, 'PTHR11692', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL PURINE BIOSYNTHESIS PROTEIN PURH', NULL, NULL, 3950, 8),
(243364, NULL, 'PTHR34993', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(243365, NULL, 'PTHR41533', NULL, NULL, NULL, NULL, 'L,D-TRANSPEPTIDASE HI_1667-RELATED', NULL, NULL, NULL, 8),
(243366, NULL, 'PTHR12442', NULL, NULL, NULL, NULL, 'DYNEIN INTERMEDIATE CHAIN', NULL, NULL, NULL, 8),
(243367, NULL, 'PTHR43349', NULL, NULL, NULL, NULL, 'PINORESINOL REDUCTASE-RELATED', NULL, NULL, NULL, 8),
(243368, NULL, 'PTHR31144', NULL, NULL, NULL, NULL, 'UPF0602 PROTEIN C4ORF47', NULL, NULL, 26124, 8),
(243369, NULL, 'PTHR47206', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(243370, NULL, 'PTHR21564', NULL, NULL, NULL, NULL, 'BRAKELESS PROTEIN', NULL, NULL, 32278, 8),
(243371, NULL, 'PTHR48054', NULL, NULL, NULL, NULL, 'RECEPTOR KINASE-LIKE PROTEIN XA21', NULL, NULL, NULL, 8),
(243372, NULL, 'PTHR47380', NULL, NULL, NULL, NULL, 'OS02G0533000 PROTEIN', NULL, NULL, 35400, 8),
(243373, NULL, 'PTHR10120', NULL, NULL, NULL, NULL, 'CAAX PRENYL PROTEASE 1', NULL, NULL, NULL, 8),
(243374, NULL, 'PTHR33748', NULL, NULL, NULL, NULL, 'PROTEIN CBG04600', NULL, NULL, NULL, 8),
(243375, NULL, 'PTHR15258', NULL, NULL, NULL, NULL, 'FGF BINDING PROTEIN-RELATED', NULL, NULL, 10390, 8),
(243376, NULL, 'PTHR13624', NULL, NULL, NULL, NULL, 'RE42071P', NULL, NULL, 16540, 8),
(243377, NULL, 'PTHR24070', NULL, NULL, NULL, NULL, 'RAS, DI-RAS, AND RHEB FAMILY MEMBERS OF SMALL GTPASE SUPERFAMILY', NULL, NULL, 19707, 8),
(243378, NULL, 'PTHR33499', NULL, NULL, NULL, NULL, 'OS12G0282400 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(243379, NULL, 'PTHR22890', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 16633, 8),
(243380, NULL, 'PTHR38703', NULL, NULL, NULL, NULL, 'CHROMOSOME 8, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(243381, NULL, 'PTHR37194', NULL, NULL, NULL, NULL, 'T2E6.7-RELATED', NULL, NULL, NULL, 8),
(243382, NULL, 'PTHR34093', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL CLIC-LIKE PROTEIN 1', NULL, NULL, 12701, 8);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(243383, NULL, 'PTHR47567', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL SUBSTRATE/SOLUTE CARRIER', NULL, NULL, NULL, 8),
(243384, NULL, 'PTHR12422', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 27328, 8),
(243385, NULL, 'PTHR10633', NULL, NULL, NULL, NULL, 'LEUKEMIA INHIBITORY FACTOR', NULL, NULL, 523, 8),
(243386, NULL, 'PTHR15896', NULL, NULL, NULL, NULL, 'GOLGI PHOSPHOPROTEIN 2/GP73-RELATED', NULL, NULL, 23412, 8),
(243387, NULL, 'PTHR10589', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', NULL, NULL, 3443, 8),
(243388, NULL, 'PTHR22854', NULL, NULL, NULL, NULL, 'TRYPTOPHAN BIOSYNTHESIS PROTEIN', NULL, NULL, 34060, 8),
(243389, NULL, 'PTHR36493', NULL, NULL, NULL, NULL, 'NEUROBLAST DIFFERENTIATION-ASSOCIATED PROTEIN AHNAK-LIKE PROTEIN', NULL, NULL, NULL, 8),
(243390, NULL, 'PTHR21229', NULL, NULL, NULL, NULL, 'LUNG SEVEN TRANSMEMBRANE RECEPTOR', NULL, NULL, 10852, 8),
(243391, NULL, 'PTHR41693', NULL, NULL, NULL, NULL, 'HEME-BINDING PROTEIN 1', NULL, NULL, NULL, 8),
(243392, NULL, 'PTHR32247', NULL, NULL, NULL, NULL, 'DIABLO HOMOLOG, MITOCHONDRIAL', NULL, NULL, 9764, 8),
(243393, NULL, 'PTHR48140', NULL, NULL, NULL, NULL, 'FATTY ACID DESATURASE 4, CHLOROPLASTIC-RELATED', NULL, NULL, NULL, 8),
(243394, NULL, 'PTHR43652', NULL, NULL, NULL, NULL, 'BASIC AMINO ACID ANTIPORTER YFCC-RELATED', NULL, NULL, NULL, 8),
(243395, NULL, 'PTHR37366', NULL, NULL, NULL, NULL, 'SPERM ACROSOME MEMBRANE-ASSOCIATED PROTEIN 6', NULL, NULL, 17778, 8),
(243396, NULL, 'PTHR34732', NULL, NULL, NULL, NULL, '69 KDA PARAFLAGELLAR ROD PROTEIN-RELATED', NULL, NULL, NULL, 8),
(243397, NULL, 'PTHR40051', NULL, NULL, NULL, NULL, 'IG HYPOTHETICAL 15966', NULL, NULL, NULL, 8),
(243398, NULL, 'PTHR35315', NULL, NULL, NULL, NULL, 'ACI13', NULL, NULL, NULL, 8),
(243399, NULL, 'PTHR10830', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE 48 KDA SUBUNIT', NULL, NULL, 942, 8),
(243400, NULL, 'PTHR35116', NULL, NULL, NULL, NULL, 'HELICASE PROTEIN MOM1', NULL, NULL, 27254, 8),
(243401, NULL, 'PTHR21355', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(243402, NULL, 'PTHR40619', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(243403, NULL, 'PTHR47367', NULL, NULL, NULL, NULL, 'AUXIN-REGULATED PROTEIN-LIKE', NULL, NULL, NULL, 8),
(243404, NULL, 'PTHR37697', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR SNZ', NULL, NULL, NULL, 8),
(243405, NULL, 'PTHR43622', NULL, NULL, NULL, NULL, '3-DEHYDROQUINATE SYNTHASE', NULL, NULL, NULL, 8),
(243406, NULL, 'PTHR33373', NULL, NULL, NULL, NULL, 'OS07G0479600 PROTEIN', NULL, NULL, NULL, 8),
(243407, NULL, 'PTHR31741', NULL, NULL, NULL, NULL, 'OS02G0726500 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(243408, NULL, 'PTHR19422', NULL, NULL, NULL, NULL, 'GAG RETROVIRAL POLYPROTEIN', NULL, NULL, NULL, 8),
(243409, NULL, 'PTHR45805', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR HR3-RELATED', NULL, NULL, NULL, 8),
(243410, NULL, 'PTHR13903', NULL, NULL, NULL, NULL, 'PIRIN-RELATED', NULL, NULL, 12696, 8),
(243411, NULL, 'PTHR12893', NULL, NULL, NULL, NULL, 'GOLGI REASSEMBLY STACKING PROTEIN  GRASP', NULL, NULL, 2909, 8),
(243412, NULL, 'PTHR28629', NULL, NULL, NULL, NULL, 'TRIOKINASE/FMN CYCLASE', NULL, NULL, NULL, 8),
(243413, NULL, 'PTHR34785', NULL, NULL, NULL, NULL, 'ECA1 GAMETOGENESIS RELATED FAMILY PROTEIN-RELATED', NULL, NULL, NULL, 8),
(243414, NULL, 'PTHR15950', NULL, NULL, NULL, NULL, 'TRANSCRIPTION COFACTOR VESTIGIAL-LIKE PROTEIN', NULL, NULL, 12635, 8),
(243415, NULL, 'PTHR46043', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(243416, NULL, 'PTHR47213', NULL, NULL, NULL, NULL, 'OS07G0567300 PROTEIN', NULL, NULL, 34823, 8),
(243417, NULL, 'PTHR21445', NULL, NULL, NULL, NULL, 'ENDONUCLEASE IV  ENDODEOXYRIBONUCLEASE IV', NULL, NULL, 3499, 8),
(243418, NULL, 'PTHR30133', NULL, NULL, NULL, NULL, 'CATIONIC AMINO ACID TRANSPORTER, MEMBRANE COMPONENT', NULL, NULL, NULL, 8),
(243419, NULL, 'PTHR34483', NULL, NULL, NULL, NULL, 'OS09G0129800 PROTEIN', NULL, NULL, NULL, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(243420, NULL, 'PTHR31885', NULL, NULL, NULL, NULL, 'GH04784P', NULL, NULL, 12959, 8),
(243421, NULL, 'PTHR20951', NULL, NULL, NULL, NULL, 'C13ORF1 PROTEIN-RELATED', NULL, NULL, 31431, 8),
(243422, NULL, 'PTHR35778', NULL, NULL, NULL, NULL, 'SIGNALING MUCIN HKR1-RELATED', NULL, NULL, 29636, 8),
(243423, NULL, 'PTHR28518', NULL, NULL, NULL, NULL, 'TRNA-SPLICING ENDONUCLEASE SUBUNIT SEN15', NULL, NULL, 35866, 8),
(243424, NULL, 'PTHR42740', NULL, NULL, NULL, NULL, 'RIBONUCLEASE VAPC3', NULL, NULL, NULL, 8),
(243425, NULL, 'PTHR46345', NULL, NULL, NULL, NULL, 'INVERTED FORMIN-2', NULL, NULL, NULL, 8),
(243426, NULL, 'PTHR47664', NULL, NULL, NULL, NULL, 'NLPC_P60 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(243427, NULL, 'PTHR21879', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 14153, 8),
(243428, NULL, 'PTHR47842', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(243429, NULL, 'PTHR12992', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE', NULL, NULL, 35759, 8),
(243430, NULL, 'PTHR47250', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(243431, NULL, 'PTHR48039', NULL, NULL, NULL, NULL, 'RNA-BINDING MOTIF PROTEIN 14B', NULL, NULL, NULL, 8),
(243432, NULL, 'PTHR45931', NULL, NULL, NULL, NULL, 'SI:CH211-59O9.10', NULL, NULL, NULL, 8),
(243433, NULL, 'PTHR46268', NULL, NULL, NULL, NULL, 'STRESS RESPONSE PROTEIN NHAX', NULL, NULL, NULL, 8),
(243434, NULL, 'PTHR33138', NULL, NULL, NULL, NULL, 'OS01G0690200 PROTEIN', NULL, NULL, NULL, 8),
(243435, NULL, 'PTHR36002', NULL, NULL, NULL, NULL, 'PYRD', NULL, NULL, NULL, 8),
(243436, NULL, 'PTHR33237', NULL, NULL, NULL, NULL, 'F2P16.13 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(243437, NULL, 'PTHR48085', NULL, NULL, NULL, NULL, 'CADMIUM/ZINC-TRANSPORTING ATPASE HMA2-RELATED', NULL, NULL, NULL, 8),
(243438, NULL, 'PTHR39664', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(243439, NULL, 'PTHR34755', NULL, NULL, NULL, NULL, 'SERINE/ARGININE REPETITIVE MATRIX PROTEIN 3-RELATED', NULL, NULL, NULL, 8),
(243440, NULL, 'PTHR12949', NULL, NULL, NULL, NULL, 'RNA POLYMERASE III  DNA DIRECTED -RELATED', NULL, NULL, 31215, 8),
(243441, NULL, 'PTHR23431', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASES I, II, AND III SUBUNIT RPABC5 FAMILY MEMBER', NULL, NULL, 593, 8),
(243442, NULL, 'PTHR30574', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YEDE', NULL, NULL, NULL, 8),
(243443, NULL, 'PTHR24131', NULL, NULL, NULL, NULL, 'APOPTOSIS-STIMULATING OF P53 PROTEIN', NULL, NULL, NULL, 8),
(243444, NULL, 'PTHR28661', NULL, NULL, NULL, NULL, 'SJOEGREN SYNDROME NUCLEAR AUTOANTIGEN 1', NULL, NULL, 30626, 8),
(243445, NULL, 'PTHR47052', NULL, NULL, NULL, NULL, 'CONSERVED SERINE PROLINE-RICH PROTEIN (AFU_ORTHOLOGUE AFUA_2G01790)', NULL, NULL, NULL, 8),
(243446, NULL, 'PTHR34128', NULL, NULL, NULL, NULL, 'CYTOCHROME C-TYPE BIOGENESIS PROTEIN CCME HOMOLOG, MITOCHONDRIAL', NULL, NULL, 4950, 8),
(243447, NULL, 'PTHR14113', NULL, NULL, NULL, NULL, 'PICCOLO/BASSOON', NULL, NULL, NULL, 8),
(243448, NULL, 'PTHR10681', NULL, NULL, NULL, NULL, 'THIOREDOXIN PEROXIDASE', NULL, NULL, NULL, 8),
(243449, NULL, 'PTHR42942', NULL, NULL, NULL, NULL, '6-O-METHYLGUANINE DNA METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(243450, NULL, 'PTHR30414', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 21781, 8),
(243451, NULL, 'PTHR31849', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH PDF MOTIF DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, 34129, 8),
(243452, NULL, 'PTHR12947', NULL, NULL, NULL, NULL, 'AMSH-LIKE PROTEASE', NULL, NULL, NULL, 8),
(243453, NULL, 'PTHR15025', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL GAMMA-1 SUBUNIT-RELATED', NULL, NULL, NULL, 8),
(243454, NULL, 'PTHR48156', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(243455, NULL, 'PTHR33293', NULL, NULL, NULL, NULL, 'INSERTION ELEMENT IS1 1 PROTEIN INSB-RELATED', NULL, NULL, NULL, 8),
(243456, NULL, 'PTHR46305', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(243457, NULL, 'PTHR31442', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN-RELATED', NULL, NULL, 35321, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(243458, NULL, 'PTHR34276', NULL, NULL, NULL, NULL, 'MINI-RIBONUCLEASE 3', NULL, NULL, NULL, 8),
(243459, NULL, 'PTHR41291', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(243460, NULL, 'PTHR34400', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(243461, NULL, 'PTHR10746', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L4', NULL, NULL, 18869, 8),
(243462, NULL, 'PTHR47780', NULL, NULL, NULL, NULL, 'PROTEIN SET DOMAIN GROUP 41', NULL, NULL, NULL, 8),
(243463, NULL, 'PTHR45746', NULL, NULL, NULL, NULL, 'LP21163P', NULL, NULL, NULL, 8),
(243464, NULL, 'PTHR30096', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(243465, NULL, 'PTHR42794', NULL, NULL, NULL, NULL, 'HEMIN IMPORT ATP-BINDING PROTEIN HMUV', NULL, NULL, NULL, 8),
(243466, NULL, 'PTHR24149', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 12', NULL, NULL, NULL, 8),
(243467, NULL, 'PTHR46476', NULL, NULL, NULL, NULL, 'CHITINASE 2-LIKE', NULL, NULL, NULL, 8),
(243468, NULL, 'PTHR10534', NULL, NULL, NULL, NULL, 'PYRIDOXAL KINASE', NULL, NULL, 2078, 8),
(243469, NULL, 'PTHR21112', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(243470, NULL, 'PTHR15691', NULL, NULL, NULL, NULL, 'WASH COMPLEX SUBUNIT 5', NULL, NULL, 16515, 8),
(243471, NULL, 'PTHR43014', NULL, NULL, NULL, NULL, 'MERCURIC REDUCTASE', NULL, NULL, NULL, 8),
(243472, NULL, 'PTHR42898', NULL, NULL, NULL, NULL, 'TROPINONE REDUCTASE', NULL, NULL, 35906, 8),
(243473, NULL, 'PTHR13869', NULL, NULL, NULL, NULL, 'MYELIN P0 RELATED', NULL, NULL, 430, 8),
(243474, NULL, 'PTHR33692', NULL, NULL, NULL, NULL, 'RIBOSOME MATURATION FACTOR RIMM', NULL, NULL, NULL, 8),
(243475, NULL, 'PTHR46674', NULL, NULL, NULL, NULL, 'INACTIVE PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP6', NULL, NULL, NULL, 8),
(243476, NULL, 'PTHR46768', NULL, NULL, NULL, NULL, 'TWO PORE CALCIUM CHANNEL PROTEIN 2', NULL, NULL, 25546, 8),
(243477, NULL, 'PTHR37954', NULL, NULL, NULL, NULL, 'BLL4979 PROTEIN', NULL, NULL, 6476, 8),
(243478, NULL, 'PTHR34471', NULL, NULL, NULL, NULL, 'ARGININE REPRESSOR', NULL, NULL, 5143, 8),
(243479, NULL, 'PTHR10981', NULL, NULL, NULL, NULL, 'BATTENIN', NULL, NULL, 6043, 8),
(243480, NULL, 'PTHR41517', NULL, NULL, NULL, NULL, '1,2-DIOXYGENASE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(243481, NULL, 'PTHR17614', NULL, NULL, NULL, NULL, 'ZINC FINGER-CONTAINING', NULL, NULL, NULL, 8),
(243482, NULL, 'PTHR37733', NULL, NULL, NULL, NULL, 'SMAD/FHA DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(243483, NULL, 'PTHR45705', NULL, NULL, NULL, NULL, 'FI20236P1', NULL, NULL, NULL, 8),
(243484, NULL, 'PTHR43540', NULL, NULL, NULL, NULL, 'PEROXYUREIDOACRYLATE/UREIDOACRYLATE AMIDOHYDROLASE-RELATED', NULL, NULL, NULL, 8),
(243485, NULL, 'PTHR31454', NULL, NULL, NULL, NULL, 'ACTIVE REGULATOR OF SIRT1', NULL, NULL, 19697, 8),
(243486, NULL, 'PTHR47592', NULL, NULL, NULL, NULL, 'PBF68 PROTEIN', NULL, NULL, NULL, 8),
(243487, NULL, 'PTHR16049', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN C', NULL, NULL, 36620, 8),
(243488, NULL, 'PTHR11207', NULL, NULL, NULL, NULL, 'RIBONUCLEASE III', NULL, NULL, 12015, 8),
(243489, NULL, 'PTHR43407', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE', NULL, NULL, NULL, 8),
(243490, NULL, 'PTHR23168', NULL, NULL, NULL, NULL, 'MITOTIC SPINDLE ASSEMBLY CHECKPOINT PROTEIN MAD1  MITOTIC ARREST DEFICIENT-LIKE PROTEIN 1', NULL, NULL, 12649, 8),
(243491, NULL, 'PTHR23279', NULL, NULL, NULL, NULL, 'DEFECTIVE PROBOSCIS EXTENSION RESPONSE  DPR -RELATED', NULL, NULL, 33221, 8),
(243492, NULL, 'PTHR31520', NULL, NULL, NULL, NULL, 'VEXIN', NULL, NULL, 27381, 8),
(243493, NULL, 'PTHR38099', NULL, NULL, NULL, NULL, 'LARGE RIBOSOMAL RNA SUBUNIT ACCUMULATION PROTEIN YCED', NULL, NULL, 31526, 8),
(243494, NULL, 'PTHR30135', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN YVCK-RELATED', NULL, NULL, 10984, 8),
(243495, NULL, 'PTHR33480', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(243496, NULL, 'PTHR32419', NULL, NULL, NULL, NULL, 'GLUTATHIONYL-HYDROQUINONE REDUCTASE', NULL, NULL, 19076, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(243497, NULL, 'PTHR23128', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(243498, NULL, 'PTHR47730', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 29', NULL, NULL, 34054, 8),
(243499, NULL, 'PTHR31692', NULL, NULL, NULL, NULL, 'EXPANSIN-B3', NULL, NULL, NULL, 8),
(243500, NULL, 'PTHR10642', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H1', NULL, NULL, NULL, 8),
(243501, NULL, 'PTHR31829', NULL, NULL, NULL, NULL, 'PYRIDOXAL 5''-PHOSPHATE SYNTHASE SUBUNIT SNZ1-RELATED', NULL, NULL, 4143, 8),
(243502, NULL, 'PTHR12526', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', NULL, NULL, NULL, 8),
(243503, NULL, 'PTHR31969', NULL, NULL, NULL, NULL, 'GEM-LIKE PROTEIN 2', NULL, NULL, 32457, 8),
(243504, NULL, 'PTHR47321', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS W', NULL, NULL, NULL, 8),
(243505, NULL, 'PTHR43304', NULL, NULL, NULL, NULL, 'PHYTOCHROME-LIKE PROTEIN CPH1', NULL, NULL, NULL, 8),
(243506, NULL, 'PTHR10422', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 1', NULL, NULL, 456, 8),
(243507, NULL, 'PTHR43721', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR TU-RELATED', NULL, NULL, NULL, 8),
(243508, NULL, 'PTHR30589', NULL, NULL, NULL, NULL, 'PROLIPOPROTEIN DIACYLGLYCERYL TRANSFERASE', NULL, NULL, 3232, 8),
(243509, NULL, 'PTHR38686', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN N-ACYLTRANSFERASE', NULL, NULL, NULL, 8),
(243510, NULL, 'PTHR15317', NULL, NULL, NULL, NULL, 'T-CELL SURFACE PROTEIN TACTILE', NULL, NULL, 36537, 8),
(243511, NULL, 'PTHR43159', NULL, NULL, NULL, NULL, 'ENOYL-[ACYL-CARRIER-PROTEIN] REDUCTASE', NULL, NULL, 11154, 8),
(243512, NULL, 'PTHR44267', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 43', NULL, NULL, NULL, 8),
(243513, NULL, 'PTHR15592', NULL, NULL, NULL, NULL, 'MATRIN 3/NUCLEAR PROTEIN 220-RELATED', NULL, NULL, NULL, 8),
(243514, NULL, 'PTHR35745', NULL, NULL, NULL, NULL, 'BNACNNG14650D PROTEIN', NULL, NULL, 27307, 8),
(243515, NULL, 'PTHR11879', NULL, NULL, NULL, NULL, 'ASPARTATE AMINOTRANSFERASE', NULL, NULL, 4545, 8),
(243516, NULL, 'PTHR28254', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT 10', NULL, NULL, 18314, 8),
(243517, NULL, 'PTHR48134', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN 96-92-RELATED-RELATED', NULL, NULL, NULL, 8),
(243518, NULL, 'PTHR46100', NULL, NULL, NULL, NULL, 'IMP2''P', NULL, NULL, NULL, 8),
(243519, NULL, 'PTHR46119', NULL, NULL, NULL, NULL, 'OS08G0405700 PROTEIN', NULL, NULL, 34799, 8),
(243520, NULL, 'PTHR31197', NULL, NULL, NULL, NULL, 'OS01G0612600 PROTEIN', NULL, NULL, NULL, 8),
(243521, NULL, 'PTHR21192', NULL, NULL, NULL, NULL, 'NUCLEAR PROTEIN E3-3', NULL, NULL, 10751, 8),
(243522, NULL, 'PTHR13887', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE KAPPA', NULL, NULL, NULL, 8),
(243523, NULL, 'PTHR12849', NULL, NULL, NULL, NULL, 'RNA LARIAT DEBRANCHING ENZYME', NULL, NULL, NULL, 8),
(243524, NULL, 'PTHR47969', NULL, NULL, NULL, NULL, 'CHROMOSOME-ASSOCIATED KINESIN KIF4A-RELATED', NULL, NULL, NULL, 8),
(243525, NULL, 'PTHR37172', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(243526, NULL, 'PTHR46412', NULL, NULL, NULL, NULL, 'BES1-INTERACTING MYC-LIKE PROTEIN', NULL, NULL, 35485, 8),
(243527, NULL, 'PTHR18843', NULL, NULL, NULL, NULL, 'TORSIN-1A-INTERACTING PROTEIN', NULL, NULL, 12934, 8),
(243528, NULL, 'PTHR34199', NULL, NULL, NULL, NULL, 'NUMOD3 MOTIF FAMILY PROTEIN, EXPRESSED', NULL, NULL, NULL, 8),
(243529, NULL, 'PTHR13199', NULL, NULL, NULL, NULL, 'GH03947P', NULL, NULL, NULL, 8),
(243530, NULL, 'PTHR31308', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(243531, NULL, 'PTHR16238', NULL, NULL, NULL, NULL, 'GEM-ASSOCIATED PROTEIN 8', NULL, NULL, 8717, 8),
(243532, NULL, 'PTHR23024', NULL, NULL, NULL, NULL, 'ARYLACETAMIDE DEACETYLASE', NULL, NULL, NULL, 8),
(243533, NULL, 'PTHR47110', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC EXPRESSED PROTEIN 55', NULL, NULL, NULL, 8),
(243534, NULL, 'PTHR35630', NULL, NULL, NULL, NULL, 'LEGUMINOSIN GROUP486 SECRETED PEPTIDE', NULL, NULL, NULL, 8),
(243535, NULL, 'PTHR48209', NULL, NULL, NULL, NULL, 'AGL056WP', NULL, NULL, NULL, 8);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(243536, NULL, 'PTHR34490', NULL, NULL, NULL, NULL, 'PROTEIN CBG12054-RELATED', NULL, NULL, NULL, 8),
(243537, NULL, 'PTHR36763', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(243538, NULL, 'PTHR34156', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN-RELATED-RELATED', NULL, NULL, NULL, 8),
(243539, NULL, 'PTHR24212', NULL, NULL, NULL, NULL, 'ZYXIN/TRIP6', NULL, NULL, NULL, 8),
(243540, NULL, 'PTHR30409', NULL, NULL, NULL, NULL, 'CARBAMATE KINASE', NULL, NULL, 7437, 8),
(243541, NULL, 'PTHR22607', NULL, NULL, NULL, NULL, 'DELETED IN ORAL CANCER 1/CDK2-ASSOCIATED PROTEIN 1', NULL, NULL, 16056, 8),
(243542, NULL, 'PTHR31836', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(243543, NULL, 'PTHR21177', NULL, NULL, NULL, NULL, 'IP06524P-RELATED', NULL, NULL, NULL, 8),
(243544, NULL, 'PTHR22198', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(243545, NULL, 'PTHR36069', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', NULL, NULL, NULL, 8),
(243546, NULL, 'PTHR46212', NULL, NULL, NULL, NULL, 'PEFLIN', NULL, NULL, NULL, 8),
(243547, NULL, 'PTHR37210', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(243548, NULL, 'PTHR34108', NULL, NULL, NULL, NULL, 'SEPTUM SITE-DETERMINING PROTEIN MINC', NULL, NULL, 12628, 8),
(243549, NULL, 'PTHR21243', NULL, NULL, NULL, NULL, 'PROTEIN SCAI', NULL, NULL, NULL, 8),
(243550, NULL, 'PTHR48188', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L43', NULL, NULL, NULL, 8),
(243551, NULL, 'PTHR22245', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 31440, 8),
(243552, NULL, 'PTHR31240', NULL, NULL, NULL, NULL, 'MATERNAL EFFECT EMBRYO ARREST 18', NULL, NULL, NULL, 8),
(243553, NULL, 'PTHR45770', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT 6-PHOSPHOFRUCTOKINASE 1', NULL, NULL, NULL, 8),
(243554, NULL, 'PTHR22906', NULL, NULL, NULL, NULL, 'PROPERDIN', NULL, NULL, NULL, 8),
(243555, NULL, 'PTHR43760', NULL, NULL, NULL, NULL, 'ENDORIBONUCLEASE-RELATED', NULL, NULL, NULL, 8),
(243556, NULL, 'PTHR47132', NULL, NULL, NULL, NULL, 'MYOGLOBIN', NULL, NULL, 6209, 8),
(243557, NULL, 'PTHR47677', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY FACTOR 6', NULL, NULL, NULL, 8),
(243558, NULL, 'PTHR11947', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE KINASE', NULL, NULL, 31892, 8),
(243559, NULL, 'PTHR10125', NULL, NULL, NULL, NULL, 'P2X PURINOCEPTOR', NULL, NULL, NULL, 8),
(243560, NULL, 'PTHR32145', NULL, NULL, NULL, NULL, 'DIFLAVIN FLAVOPROTEIN A 2-RELATED', NULL, NULL, NULL, 8),
(243561, NULL, 'PTHR34478', NULL, NULL, NULL, NULL, 'PROTEIN LEMA', NULL, NULL, 318, 8),
(243562, NULL, 'PTHR33693', NULL, NULL, NULL, NULL, 'TYPE-5 URACIL-DNA GLYCOSYLASE', NULL, NULL, NULL, 8),
(243563, NULL, 'PTHR28093', NULL, NULL, NULL, NULL, 'MORPHOGENESIS-RELATED PROTEIN MSB1', NULL, NULL, 31174, 8),
(243564, NULL, 'PTHR46624', NULL, NULL, NULL, NULL, 'AGAP002036-PA', NULL, NULL, 34375, 8),
(243565, NULL, 'PTHR46574', NULL, NULL, NULL, NULL, '43 KDA RECEPTOR-ASSOCIATED PROTEIN OF THE SYNAPSE', NULL, NULL, NULL, 8),
(243566, NULL, 'PTHR16071', NULL, NULL, NULL, NULL, 'CHROMOSOME 1 OPEN READING FRAME 112', NULL, NULL, 23226, 8),
(243567, NULL, 'PTHR43651', NULL, NULL, NULL, NULL, '1,4-ALPHA-GLUCAN-BRANCHING ENZYME', NULL, NULL, NULL, 8),
(243568, NULL, 'PTHR37024', NULL, NULL, NULL, NULL, 'TYPE VI SECRETION SYSTEM DUF2094 AND IMPA-RELATED DOMAIN PROTEIN', NULL, NULL, NULL, 8),
(243569, NULL, 'PTHR28064', NULL, NULL, NULL, NULL, 'INNER KINETOCHORE SUBUNIT NKP2', NULL, NULL, 15187, 8),
(243570, NULL, 'PTHR13350', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 30118, 8),
(243571, NULL, 'PTHR15653', NULL, NULL, NULL, NULL, 'STRIATIN', NULL, NULL, NULL, 8),
(243572, NULL, 'PTHR12227', NULL, NULL, NULL, NULL, 'GLYCERATE KINASE', NULL, NULL, 27491, 8),
(243573, NULL, 'PTHR11994', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L11-RELATED', NULL, NULL, 1038, 8),
(243574, NULL, 'PTHR21451', NULL, NULL, NULL, NULL, 'HISTONE H3 METHYLTRANSFERASE', NULL, NULL, 22506, 8),
(243575, NULL, 'PTHR33606', NULL, NULL, NULL, NULL, 'PROTEIN YCII', NULL, NULL, NULL, 8);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(243576, NULL, 'PTHR28012', NULL, NULL, NULL, NULL, 'NUCLEAR FUSION PROTEIN KAR5', NULL, NULL, 7123, 8),
(243577, NULL, 'PTHR48112', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP PROTEIN DSP1', NULL, NULL, NULL, 8),
(243578, NULL, 'PTHR35484', NULL, NULL, NULL, NULL, 'OUTER ENVELOPE PORE PROTEIN 37, CHLOROPLASTIC', NULL, NULL, 30616, 8),
(243579, NULL, 'PTHR23422', NULL, NULL, NULL, NULL, 'DIPEPTIDYL PEPTIDASE III-RELATED', NULL, NULL, 33183, 8),
(243580, NULL, 'PTHR10587', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE-RELATED', NULL, NULL, NULL, 8),
(243581, NULL, 'PTHR23122', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED GUANYLATE KINASE  MAGUK', NULL, NULL, NULL, 8),
(243582, NULL, 'PTHR33861', NULL, NULL, NULL, NULL, 'PROTEIN CBG18333', NULL, NULL, 24339, 8),
(243583, NULL, 'PTHR34615', NULL, NULL, NULL, NULL, 'PX DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(243584, NULL, 'PTHR11574', NULL, NULL, NULL, NULL, 'KIT LIGAND', NULL, NULL, 5303, 8),
(243585, NULL, 'PTHR30333', NULL, NULL, NULL, NULL, 'CYTOCHROME C-TYPE PROTEIN', NULL, NULL, NULL, 8),
(243586, NULL, 'PTHR19431', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L4', NULL, NULL, 34352, 8),
(243587, NULL, 'PTHR39427', NULL, NULL, NULL, NULL, '', NULL, NULL, 3348, 8),
(243588, NULL, 'PTHR39677', NULL, NULL, NULL, NULL, 'RIBONUCLEASE VAPC6', NULL, NULL, NULL, 8),
(243589, NULL, 'PTHR23314', NULL, NULL, NULL, NULL, 'SPERM-ASSOCIATED ANTIGEN 6  ARMADILLO REPEAT-CONTAINING', NULL, NULL, NULL, 8),
(243590, NULL, 'PTHR22055', NULL, NULL, NULL, NULL, '28 KDA HEAT- AND ACID-STABLE PHOSPHOPROTEIN  PDGF-ASSOCIATED PROTEIN', NULL, NULL, 32156, 8),
(243591, NULL, 'PTHR33937', NULL, NULL, NULL, NULL, 'IRON-MOLYBDENUM PROTEIN-RELATED-RELATED', NULL, NULL, NULL, 8),
(243592, NULL, 'PTHR36595', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(243593, NULL, 'PTHR22872', NULL, NULL, NULL, NULL, 'BTK-BINDING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(243594, NULL, 'PTHR15359', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(243595, NULL, 'PTHR15913', NULL, NULL, NULL, NULL, 'ACID CLUSTER PROTEIN 33', NULL, NULL, 23470, 8),
(243596, NULL, 'PTHR32138', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLETHANOLAMINE N-METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(243597, NULL, 'PTHR48238', NULL, NULL, NULL, NULL, 'BNACNNG09570D PROTEIN', NULL, NULL, NULL, 8),
(243598, NULL, 'PTHR34223', NULL, NULL, NULL, NULL, 'OS11G0201299 PROTEIN', NULL, NULL, NULL, 8),
(243599, NULL, 'PTHR35167', NULL, NULL, NULL, NULL, 'OS05G0216466 PROTEIN', NULL, NULL, NULL, 8),
(243600, NULL, 'PTHR34609', NULL, NULL, NULL, NULL, 'GEO08273P1-RELATED', NULL, NULL, NULL, 8),
(243601, NULL, 'PTHR28244', NULL, NULL, NULL, NULL, 'RNA POLYMERASE I-SPECIFIC TRANSCRIPTION INITIATION FACTOR RRN11', NULL, NULL, NULL, 8),
(243602, NULL, 'PTHR36987', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 BETA SUBCOMPLEX SUBUNIT 2-LIKE', NULL, NULL, 35603, 8),
(243603, NULL, 'PTHR31802', NULL, NULL, NULL, NULL, '32 KDA HEAT SHOCK PROTEIN-RELATED', NULL, NULL, NULL, 8),
(243604, NULL, 'PTHR10766', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 9 SUPERFAMILY PROTEIN', NULL, NULL, 3822, 8),
(243605, NULL, 'PTHR31281', NULL, NULL, NULL, NULL, '', NULL, NULL, 23975, 8),
(243606, NULL, 'PTHR15129', NULL, NULL, NULL, NULL, 'SRC-ASSOCIATED ADAPTOR PROTEIN', NULL, NULL, 28076, 8),
(243607, NULL, 'PTHR32414', NULL, NULL, NULL, NULL, 'NEUROMEDIN-S', NULL, NULL, 34251, 8),
(243608, NULL, 'PTHR13179', NULL, NULL, NULL, NULL, 'DEP DOMAIN CONTAINING PROTEIN 5', NULL, NULL, 26304, 8),
(243609, NULL, 'PTHR10229', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN HFLX', NULL, NULL, 16478, 8),
(243610, NULL, 'PTHR43758', NULL, NULL, NULL, NULL, '7,8-DIHYDRO-8-OXOGUANINE TRIPHOSPHATASE', NULL, NULL, NULL, 8),
(243611, NULL, 'PTHR14463', NULL, NULL, NULL, NULL, 'LIPASE MATURATION FACTOR', NULL, NULL, 1792, 8),
(243612, NULL, 'PTHR22792', NULL, NULL, NULL, NULL, 'LUPUS LA PROTEIN-RELATED', NULL, NULL, 34338, 8),
(243613, NULL, 'PTHR15546', NULL, NULL, NULL, NULL, 'BROMODOMAIN ADJACENT TO ZINC FINGER DOMAIN, 2A', NULL, NULL, NULL, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(243614, NULL, 'PTHR46648', NULL, NULL, NULL, NULL, 'HIT FAMILY PROTEIN 1', NULL, NULL, 2385, 8),
(243615, NULL, 'PTHR33884', NULL, NULL, NULL, NULL, 'UPF0410 PROTEIN YMGE', NULL, NULL, 5742, 8),
(243616, NULL, 'PTHR37372', NULL, NULL, NULL, NULL, 'OS06G0316800 PROTEIN', NULL, NULL, NULL, 8),
(243617, NULL, 'PTHR22983', NULL, NULL, NULL, NULL, 'PROTEIN KINASE RELATED', NULL, NULL, 34605, 8),
(243618, NULL, 'PTHR16156', NULL, NULL, NULL, NULL, 'AFTIPHILIN A-RELATED', NULL, NULL, 36907, 8),
(243619, NULL, 'PTHR36891', NULL, NULL, NULL, NULL, 'OS01G0127400 PROTEIN', NULL, NULL, 19094, 8),
(243620, NULL, 'PTHR31438', NULL, NULL, NULL, NULL, 'LYSINE N-ACYLTRANSFERASE C17G9.06C-RELATED', NULL, NULL, NULL, 8),
(243621, NULL, 'PTHR47381', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(243622, NULL, 'PTHR35354', NULL, NULL, NULL, NULL, 'RGD1561648', NULL, NULL, 23873, 8),
(243623, NULL, 'PTHR28187', NULL, NULL, NULL, NULL, 'PROTEIN RCR1-RELATED', NULL, NULL, 20837, 8),
(243624, NULL, 'PTHR48125', NULL, NULL, NULL, NULL, 'LP07818P1', NULL, NULL, NULL, 8),
(243625, NULL, 'PTHR24240', NULL, NULL, NULL, NULL, 'OPSIN', NULL, NULL, NULL, 8),
(243626, NULL, 'PTHR13544', NULL, NULL, NULL, NULL, 'SELENOPROTEIN T', NULL, NULL, 15664, 8),
(243627, NULL, 'PTHR21732', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DNA-BINDING DOMAIN-CONTAINING PROTEIN 4', NULL, NULL, 22926, 8),
(243628, NULL, 'PTHR15254', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA GROUP G PROTEIN FAMILY MEMBER', NULL, NULL, 27465, 8),
(243629, NULL, 'PTHR46349', NULL, NULL, NULL, NULL, 'CINGULIN-LIKE PROTEIN 1-RELATED', NULL, NULL, NULL, 8),
(243630, NULL, 'PTHR47261', NULL, NULL, NULL, NULL, 'CALCIUM-DEPENDENT LIPID-BINDING (CALB DOMAIN) FAMILY PROTEIN', NULL, NULL, NULL, 8),
(243631, NULL, 'PTHR21664', NULL, NULL, NULL, NULL, 'CHRONIC MYELOGENOUS LEUKEMIA TUMOR ANTIGEN 66', NULL, NULL, 30692, 8),
(243632, NULL, 'PTHR21330', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 24730, 8),
(243633, NULL, 'PTHR33124', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR IBH1-LIKE 1', NULL, NULL, 35007, 8),
(243634, NULL, 'PTHR10489', NULL, NULL, NULL, NULL, 'CELL ADHESION MOLECULE', NULL, NULL, NULL, 8),
(243635, NULL, 'PTHR22901', NULL, NULL, NULL, NULL, 'SIALATE O-ACETYLESTERASE', NULL, NULL, 33083, 8),
(243636, NULL, 'PTHR46554', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 26A-RELATED', NULL, NULL, 34182, 8),
(243637, NULL, 'PTHR37904', NULL, NULL, NULL, NULL, 'OS10G0566900 PROTEIN', NULL, NULL, 30633, 8),
(243638, NULL, 'PTHR36928', NULL, NULL, NULL, NULL, 'PHOSPHATASE YCDX-RELATED', NULL, NULL, NULL, 8),
(243639, NULL, 'PTHR23503', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 2', NULL, NULL, 37265, 8),
(243640, NULL, 'PTHR12308', NULL, NULL, NULL, NULL, 'ANOCTAMIN', NULL, NULL, 2075, 8),
(243641, NULL, 'PTHR32000', NULL, NULL, NULL, NULL, 'SIMILAR TO HYPOTHETICAL PROTEIN', NULL, NULL, 28031, 8),
(243642, NULL, 'PTHR11969', NULL, NULL, NULL, NULL, 'MAX DIMERIZATION, MAD', NULL, NULL, NULL, 8),
(243643, NULL, 'PTHR15690', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR COACTIVATOR 6', NULL, NULL, 23351, 8),
(243644, NULL, 'PTHR46431', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(243645, NULL, 'PTHR31665', NULL, NULL, NULL, NULL, 'FLYWCH FAMILY MEMBER 2-RELATED', NULL, NULL, 31235, 8),
(243646, NULL, 'PTHR47888', NULL, NULL, NULL, NULL, 'UPF0730 PROTEIN ENCODED BY LINC00643-RELATED', NULL, NULL, 25802, 8),
(243647, NULL, 'PTHR31446', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE/VANADIUM-DEPENDENT HALOPEROXIDASE-RELATED PROTEIN', NULL, NULL, 6294, 8),
(243648, NULL, 'PTHR47390', NULL, NULL, NULL, NULL, 'PODOPLANIN', NULL, NULL, NULL, 8),
(243649, NULL, 'PTHR34995', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT BETA', NULL, NULL, NULL, 8),
(243650, NULL, 'PTHR12592', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT (S)-NAD(P)H-HYDRATE DEHYDRATASE FAMILY MEMBER', NULL, NULL, NULL, 8),
(243651, NULL, 'PTHR43204', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER I FAMILY MEMBER 6, CHLOROPLASTIC', NULL, NULL, 4082, 8);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(243652, NULL, 'PTHR40061', NULL, NULL, NULL, NULL, 'SPORULATION PROTEIN YLMC-RELATED', NULL, NULL, 10885, 8),
(243653, NULL, 'PTHR26453', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', NULL, NULL, NULL, 8),
(243654, NULL, 'PTHR36862', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 428', NULL, NULL, 30594, 8),
(243655, NULL, 'PTHR21137', NULL, NULL, NULL, NULL, 'ODORANT RECEPTOR', NULL, NULL, 1629, 8),
(243656, NULL, 'PTHR23350', NULL, NULL, NULL, NULL, 'PEROXISOME ASSEMBLY PROTEIN 10', NULL, NULL, NULL, 8),
(243657, NULL, 'PTHR12049', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 6299, 8),
(243658, NULL, 'PTHR12906', NULL, NULL, NULL, NULL, 'PROTEIN C20ORF24  RAB5-INTERACTING PROTEIN', NULL, NULL, 9946, 8),
(243659, NULL, 'PTHR43785', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYLPUTRESCINE SYNTHETASE', NULL, NULL, NULL, 8),
(243660, NULL, 'PTHR46175', NULL, NULL, NULL, NULL, 'BACTERIOOPSIN TRANSCRIPTIONAL ACTIVATOR', NULL, NULL, NULL, 8),
(243661, NULL, 'PTHR13503', NULL, NULL, NULL, NULL, 'NEGATIVE ELONGATION FACTOR COMPLEX MEMBER B', NULL, NULL, 9307, 8),
(243662, NULL, 'PTHR32037', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 12A', NULL, NULL, 15723, 8),
(243663, NULL, 'PTHR12980', NULL, NULL, NULL, NULL, 'UBIQUINOL-CYTOCHROME C REDUCTASE COMPLEX, SUBUNIT X', NULL, NULL, 5029, 8),
(243664, NULL, 'PTHR16074', NULL, NULL, NULL, NULL, 'BARDET-BIEDL SYNDROME 7 PROTEIN', NULL, NULL, NULL, 8),
(243665, NULL, 'PTHR47174', NULL, NULL, NULL, NULL, 'BRIDGING INTEGRATOR 3', NULL, NULL, NULL, 8),
(243666, NULL, 'PTHR24073', NULL, NULL, NULL, NULL, 'DRAB5-RELATED', NULL, NULL, NULL, 8),
(243667, NULL, 'PTHR37840', NULL, NULL, NULL, NULL, 'L-FUCOSE ISOMERASE', NULL, NULL, NULL, 8),
(243668, NULL, 'PTHR42704', NULL, NULL, NULL, NULL, 'RIBULOSE BISPHOSPHATE CARBOXYLASE', NULL, NULL, 29493, 8),
(243669, NULL, 'PTHR12363', NULL, NULL, NULL, NULL, 'TRANSPORTIN 3 AND IMPORTIN 13', NULL, NULL, NULL, 8),
(243670, NULL, 'PTHR16423', NULL, NULL, NULL, NULL, 'TREM-LIKE TRANSCRIPT PROTEIN', NULL, NULL, NULL, 8),
(243671, NULL, 'PTHR43572', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN CLPD, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(243672, NULL, 'PTHR46419', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR GTPASE-ACTIVATING PROTEIN AGD5', NULL, NULL, 34911, 8),
(243673, NULL, 'PTHR37089', NULL, NULL, NULL, NULL, 'PROTEIN U-RELATED', NULL, NULL, NULL, 8),
(243674, NULL, 'PTHR21501', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(243675, NULL, 'PTHR45775', NULL, NULL, NULL, NULL, 'RAD, GEM/KIR FAMILY MEMBER 2, ISOFORM C', NULL, NULL, NULL, 8),
(243676, NULL, 'PTHR10963', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE-RELATED', NULL, NULL, NULL, 8),
(243677, NULL, 'PTHR47736', NULL, NULL, NULL, NULL, 'BPI FOLD-CONTAINING FAMILY A MEMBER 3', NULL, NULL, 25305, 8),
(243678, NULL, 'PTHR42949', NULL, NULL, NULL, NULL, 'ANAEROBIC GLYCEROL-3-PHOSPHATE DEHYDROGENASE SUBUNIT B', NULL, NULL, NULL, 8),
(243679, NULL, 'PTHR11210', NULL, NULL, NULL, NULL, 'RING BOX', NULL, NULL, NULL, 8),
(243680, NULL, 'PTHR30042', NULL, NULL, NULL, NULL, 'POTASSIUM-TRANSPORTING ATPASE C CHAIN', NULL, NULL, 3260, 8),
(243681, NULL, 'PTHR13602', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 26291, 8),
(243682, NULL, 'PTHR40697', NULL, NULL, NULL, NULL, 'ACETOIN CATABOLISM PROTEIN X', NULL, NULL, 32885, 8),
(243683, NULL, 'PTHR46213', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR DEMETER', NULL, NULL, 36087, 8),
(243684, NULL, 'PTHR43398', NULL, NULL, NULL, NULL, 'DOLICHOL-PHOSPHATE MANNOSYLTRANSFERASE SUBUNIT 1', NULL, NULL, 31112, 8),
(243685, NULL, 'PTHR47351', NULL, NULL, NULL, NULL, 'CHITIN BIOSYNTHESIS PROTEIN CHS5', NULL, NULL, NULL, 8),
(243686, NULL, 'PTHR10822', NULL, NULL, NULL, NULL, 'GLYPICAN', NULL, NULL, 4088, 8),
(243687, NULL, 'PTHR34765', NULL, NULL, NULL, NULL, 'CASPASE RECRUITMENT DOMAIN-CONTAINING PROTEIN 19', NULL, NULL, 35713, 8),
(243688, NULL, 'PTHR16770', NULL, NULL, NULL, NULL, '', NULL, NULL, 21519, 8),
(243689, NULL, 'PTHR28448', NULL, NULL, NULL, NULL, 'UPF0728 PROTEIN C10ORF53', NULL, NULL, 23723, 8);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(243690, NULL, 'PTHR19051', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN', NULL, NULL, 4055, 8),
(243691, NULL, 'PTHR38599', NULL, NULL, NULL, NULL, 'CUPIN DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_3G13620)', NULL, NULL, NULL, 8),
(243692, NULL, 'PTHR14517', NULL, NULL, NULL, NULL, 'RIB43A-RELATED', NULL, NULL, 13716, 8),
(243693, NULL, 'PTHR37549', NULL, NULL, NULL, NULL, 'LIPOPROTEIN LPRI', NULL, NULL, NULL, 8),
(243694, NULL, 'PTHR42744', NULL, NULL, NULL, NULL, 'BINDING-PROTEIN-DEPENDENT TRANSPORT SYSTEMS INNER MEMBRANE COMPONENT', NULL, NULL, NULL, 8),
(243695, NULL, 'PTHR11472', NULL, NULL, NULL, NULL, 'DNA REPAIR DEAD HELICASE RAD3/XP-D SUBFAMILY MEMBER', NULL, NULL, 35815, 8),
(243696, NULL, 'PTHR48226', NULL, NULL, NULL, NULL, 'OS06G0326200 PROTEIN', NULL, NULL, NULL, 8),
(243697, NULL, 'PTHR37369', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 270', NULL, NULL, 21806, 8),
(243698, NULL, 'PTHR46386', NULL, NULL, NULL, NULL, 'NUCLEAR BODY PROTEIN SP140', NULL, NULL, 35027, 8),
(243699, NULL, 'PTHR11559', NULL, NULL, NULL, NULL, 'CARBOXYLESTERASE', NULL, NULL, NULL, 8),
(243700, NULL, 'PTHR31033', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(243701, NULL, 'PTHR14456', NULL, NULL, NULL, NULL, 'INOSITOL POLYPHOSPHATE KINASE 1', NULL, NULL, 13731, 8),
(243702, NULL, 'PTHR46773', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(243703, NULL, 'PTHR36402', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(243704, NULL, 'PTHR13542', NULL, NULL, NULL, NULL, 'LSM12 HOMOLOG', NULL, NULL, 27404, 8),
(243705, NULL, 'PTHR13585', NULL, NULL, NULL, NULL, 'CHASCON, ISOFORM D-RELATED', NULL, NULL, NULL, 8),
(243706, NULL, 'PTHR23108', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE-RELATED', NULL, NULL, 32653, 8),
(243707, NULL, 'PTHR14972', NULL, NULL, NULL, NULL, 'AGAP011572-PA', NULL, NULL, 23660, 8),
(243708, NULL, 'PTHR45936', NULL, NULL, NULL, NULL, 'TRNA-DIHYDROURIDINE(20) SYNTHASE [NAD(P)+]-LIKE', NULL, NULL, NULL, 8),
(243709, NULL, 'PTHR21377', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 37385, 8),
(243710, NULL, 'PTHR12485', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE SUBUNIT B', NULL, NULL, 8470, 8),
(243711, NULL, 'PTHR15897', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND MYND DOMAIN PROTEIN 1', NULL, NULL, NULL, 8),
(243712, NULL, 'PTHR31283', NULL, NULL, NULL, NULL, 'EKC/KEOPS COMPLEX SUBUNIT PCC1 FAMILY MEMBER', NULL, NULL, 7214, 8),
(243713, NULL, 'PTHR34408', NULL, NULL, NULL, NULL, 'FAMILY PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(243714, NULL, 'PTHR46410', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 2', NULL, NULL, NULL, 8),
(243715, NULL, 'PTHR20919', NULL, NULL, NULL, NULL, 'HOMOSERINE O-SUCCINYLTRANSFERASE', NULL, NULL, 30160, 8),
(243716, NULL, 'PTHR43817', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE', NULL, NULL, NULL, 8),
(243717, NULL, 'PTHR37508', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(243718, NULL, 'PTHR10510', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE POLYPEPTIDE 7A', NULL, NULL, 1568, 8),
(243719, NULL, 'PTHR46632', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SINA-LIKE 4', NULL, NULL, 34119, 8),
(243720, NULL, 'PTHR36531', NULL, NULL, NULL, NULL, 'CRISPR-ASSOCIATED EXONUCLEASE CAS4', NULL, NULL, NULL, 8),
(243721, NULL, 'PTHR46627', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE O', NULL, NULL, 30863, 8),
(243722, NULL, 'PTHR20939', NULL, NULL, NULL, NULL, 'SORTING NEXIN 20, 21', NULL, NULL, 32354, 8),
(243723, NULL, 'PTHR37848', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(243724, NULL, 'PTHR22446', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 22114, 8),
(243725, NULL, 'PTHR34585', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(243726, NULL, 'PTHR35461', NULL, NULL, NULL, NULL, 'BNAANNG14610D PROTEIN', NULL, NULL, NULL, 8),
(243727, NULL, 'PTHR30296', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN YKGE', NULL, NULL, NULL, 8),
(243728, NULL, 'PTHR46576', NULL, NULL, NULL, NULL, 'BROMO ADJACENT HOMOLOGY DOMAIN-CONTAINING 1 PROTEIN', NULL, NULL, NULL, 8);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(243729, NULL, 'PTHR11238', NULL, NULL, NULL, NULL, 'PROMININ ISOFORM D-RELATED', NULL, NULL, NULL, 8),
(243730, NULL, 'PTHR21471', NULL, NULL, NULL, NULL, 'GNAT FAMILY ACETYLTRANSFERASE-RELATED', NULL, NULL, NULL, 8),
(243731, NULL, 'PTHR17223', NULL, NULL, NULL, NULL, 'PARATHYROID HORMONE-RELATED', NULL, NULL, 1138, 8),
(243732, NULL, 'PTHR23244', NULL, NULL, NULL, NULL, 'KELCH REPEAT DOMAIN', NULL, NULL, NULL, 8),
(243733, NULL, 'PTHR47316', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN H1', NULL, NULL, NULL, 8),
(243734, NULL, 'PTHR10956', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L31', NULL, NULL, 2781, 8),
(243735, NULL, 'PTHR38797', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(243736, NULL, 'PTHR12844', NULL, NULL, NULL, NULL, 'CONNECTOR ENCHANCER OF KINASE SUPPRESSOR OF RAS', NULL, NULL, NULL, 8),
(243737, NULL, 'PTHR46011', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-86-RELATED', NULL, NULL, NULL, 8),
(243738, NULL, 'PTHR11455', NULL, NULL, NULL, NULL, 'CRYPTOCHROME', NULL, NULL, 1245, 8),
(243739, NULL, 'PTHR43208', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER SUBSTRATE-BINDING PROTEIN', NULL, NULL, NULL, 8),
(243740, NULL, 'PTHR11781', NULL, NULL, NULL, NULL, 'IODOTHYRONINE DEIODINASE', NULL, NULL, 3863, 8),
(243741, NULL, 'PTHR13507', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 10167, 8),
(243742, NULL, 'PTHR47014', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY S MEMBER 1', NULL, NULL, 34855, 8),
(243743, NULL, 'PTHR11098', NULL, NULL, NULL, NULL, 'NICOTINATE PHOSPHORIBOSYLTRANSFERASE', NULL, NULL, 6673, 8),
(243744, NULL, 'PTHR35755', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(243745, NULL, 'PTHR23325', NULL, NULL, NULL, NULL, 'SERUM RESPONSE FACTOR-BINDING', NULL, NULL, 30467, 8),
(243746, NULL, 'PTHR12486', NULL, NULL, NULL, NULL, 'APRATAXIN-RELATED', NULL, NULL, NULL, 8),
(243747, NULL, 'PTHR35007', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(243748, NULL, 'PTHR20863', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN', NULL, NULL, 2555, 8),
(243749, NULL, 'PTHR14690', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(243750, NULL, 'PTHR23354', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 7/ESTROGEN RECEPTOR COACTIVATOR-RELATED', NULL, NULL, NULL, 8),
(243751, NULL, 'PTHR36205', NULL, NULL, NULL, NULL, 'CHROMOSOME 19, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, 19767, 8),
(243752, NULL, 'PTHR22912', NULL, NULL, NULL, NULL, 'DISULFIDE OXIDOREDUCTASE', NULL, NULL, NULL, 8),
(243753, NULL, 'PTHR47854', NULL, NULL, NULL, NULL, 'SURFEIT LOCUS PROTEIN 2 (SURF2)', NULL, NULL, NULL, 8),
(243754, NULL, 'PTHR35736', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(243755, NULL, 'PTHR12910', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE SUBUNIT B17.2', NULL, NULL, 1209, 8),
(243756, NULL, 'PTHR15185', NULL, NULL, NULL, NULL, 'BCL9', NULL, NULL, 17684, 8),
(243757, NULL, 'PTHR15251', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC BASIC PROTEIN Y 1-RELATED', NULL, NULL, NULL, 8),
(243758, NULL, 'PTHR23142', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 2049, 8),
(243759, NULL, 'PTHR24274', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 161', NULL, NULL, NULL, 8),
(243760, NULL, 'PTHR47091', NULL, NULL, NULL, NULL, 'ALPHA-PROTEIN KINASE 2-RELATED', NULL, NULL, NULL, 8),
(243761, NULL, 'PTHR46068', NULL, NULL, NULL, NULL, 'PROTEIN CBG27172', NULL, NULL, NULL, 8),
(243762, NULL, 'PTHR15941', NULL, NULL, NULL, NULL, 'MYOZENIN', NULL, NULL, 8726, 8),
(243763, NULL, 'PTHR42253', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(243764, NULL, 'PTHR13370', NULL, NULL, NULL, NULL, 'RNA METHYLASE-RELATED', NULL, NULL, NULL, 8),
(243765, NULL, 'PTHR46021', NULL, NULL, NULL, NULL, 'ARF-GAP WITH DUAL PH DOMAIN-CONTAINING PROTEIN 1-LIKE PROTEIN', NULL, NULL, NULL, 8),
(243766, NULL, 'PTHR11203', NULL, NULL, NULL, NULL, 'CLEAVAGE AND POLYADENYLATION SPECIFICITY FACTOR FAMILY MEMBER', NULL, NULL, NULL, 8);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(243767, NULL, 'PTHR40625', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN ESDC-RELATED', NULL, NULL, NULL, 8),
(243768, NULL, 'PTHR36890', NULL, NULL, NULL, NULL, 'PROTEIN CYCLOPS', NULL, NULL, 27516, 8),
(243769, NULL, 'PTHR36316', NULL, NULL, NULL, NULL, 'OS06G0213900 PROTEIN', NULL, NULL, NULL, 8),
(243770, NULL, 'PTHR34721', NULL, NULL, NULL, NULL, 'PROTEIN CBG09734', NULL, NULL, NULL, 8),
(243771, NULL, 'PTHR28082', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', NULL, NULL, NULL, 8),
(243772, NULL, 'PTHR45680', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY', NULL, NULL, NULL, 8),
(243773, NULL, 'PTHR37402', NULL, NULL, NULL, NULL, 'GRAM DOMAIN-CONTAINING PROTEIN 4', NULL, NULL, 32061, 8),
(243774, NULL, 'PTHR15225', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED PROTEIN 35/NMI N-MYC/STAT INTERACTING PROTEIN', NULL, NULL, NULL, 8),
(243775, NULL, 'PTHR20842', NULL, NULL, NULL, NULL, 'PROTEASE S51 ALPHA-ASPARTYL DIPEPTIDASE', NULL, NULL, NULL, 8),
(243776, NULL, 'PTHR43553', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORTER', NULL, NULL, NULL, 8),
(243777, NULL, 'PTHR38407', NULL, NULL, NULL, NULL, 'PROTEIN IVY1', NULL, NULL, 27352, 8),
(243778, NULL, 'PTHR45920', NULL, NULL, NULL, NULL, 'FORMIN HOMOLOGY 2 DOMAIN CONTAINING, ISOFORM I', NULL, NULL, NULL, 8),
(243779, NULL, 'PTHR13523', NULL, NULL, NULL, NULL, 'COILED-COIL-HELIX-COILED-COIL-HELIX DOMAIN CONTAINING 2/NUR77', NULL, NULL, NULL, 8),
(243780, NULL, 'PTHR21733', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 10374, 8),
(243781, NULL, 'PTHR34776', NULL, NULL, NULL, NULL, 'F17F16.3 PROTEIN', NULL, NULL, NULL, 8),
(243782, NULL, 'PTHR21686', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 27268, 8),
(243783, NULL, 'PTHR48034', NULL, NULL, NULL, NULL, 'TRANSFORMER-2 SEX-DETERMINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(243784, NULL, 'PTHR48215', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(243785, NULL, 'PTHR28538', NULL, NULL, NULL, NULL, 'INTEGRAL INNER NUCLEAR MEMBRANE PROTEIN IMA1', NULL, NULL, 35163, 8),
(243786, NULL, 'PTHR13177', NULL, NULL, NULL, NULL, 'DEATH-ASSOCIATED PROTEIN 1', NULL, NULL, 8299, 8),
(243787, NULL, 'PTHR41686', NULL, NULL, NULL, NULL, 'MYOMIXER', NULL, NULL, 32420, 8),
(243788, NULL, 'PTHR43557', NULL, NULL, NULL, NULL, 'APOPTOSIS-INDUCING FACTOR 1', NULL, NULL, NULL, 8),
(243789, NULL, 'PTHR37805', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', NULL, NULL, NULL, 8),
(243790, NULL, 'PTHR40035', NULL, NULL, NULL, NULL, 'ATP SYNTHASE PROTEIN I', NULL, NULL, 33359, 8),
(243791, NULL, 'PTHR30188', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN-RELATED', NULL, NULL, 22267, 8),
(243792, NULL, 'PTHR20971', NULL, NULL, NULL, NULL, 'U6 SNRNA-ASSOCIATED PROTEIN', NULL, NULL, 29133, 8),
(243793, NULL, 'PTHR21576', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED NODULIN-LIKE PROTEIN', NULL, NULL, NULL, 8),
(243794, NULL, 'PTHR46739', NULL, NULL, NULL, NULL, 'AQUAPORIN SIP1-1', NULL, NULL, 34682, 8),
(243795, NULL, 'PTHR39490', NULL, NULL, NULL, NULL, 'ARRESTIN DOMAIN-CONTAINING PROTEIN D', NULL, NULL, NULL, 8),
(243796, NULL, 'PTHR35560', NULL, NULL, NULL, NULL, 'BLL0132 PROTEIN', NULL, NULL, NULL, 8),
(243797, NULL, 'PTHR46864', NULL, NULL, NULL, NULL, 'LAFORIN', NULL, NULL, 35613, 8),
(243798, NULL, 'PTHR21194', NULL, NULL, NULL, NULL, 'CARDIAC PHOSPHOLAMBAN', NULL, NULL, 1257, 8),
(243799, NULL, 'PTHR33448', NULL, NULL, NULL, NULL, 'CHLOROPLAST PROTEIN HCF243-RELATED', NULL, NULL, NULL, 8),
(243800, NULL, 'PTHR39463', NULL, NULL, NULL, NULL, 'MEDUSA', NULL, NULL, NULL, 8),
(243801, NULL, 'PTHR45919', NULL, NULL, NULL, NULL, 'GDP-MAN:MAN(3)GLCNAC(2)-PP-DOL ALPHA-1,2-MANNOSYLTRANSFERASE', NULL, NULL, 27513, 8),
(243802, NULL, 'PTHR23252', NULL, NULL, NULL, NULL, 'INTIMAL THICKNESS RECEPTOR-RELATED', NULL, NULL, NULL, 8),
(243803, NULL, 'PTHR34123', NULL, NULL, NULL, NULL, 'OS04G0578200 PROTEIN', NULL, NULL, NULL, 8),
(243804, NULL, 'PTHR48192', NULL, NULL, NULL, NULL, 'ZN(2)-C6 FUNGAL-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(243805, NULL, 'PTHR12013', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE 14 KD PROTEIN', NULL, NULL, 3459, 8);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(243806, NULL, 'PTHR42251', NULL, NULL, NULL, NULL, 'UPF0147 PROTEIN MJ1419', NULL, NULL, NULL, 8),
(243807, NULL, 'PTHR15284', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR INTERLEUKIN-3-REGULATED PROTEIN', NULL, NULL, NULL, 8),
(243808, NULL, 'PTHR31905', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 58', NULL, NULL, 18230, 8),
(243809, NULL, 'PTHR33393', NULL, NULL, NULL, NULL, 'POLYGLUTAMINE SYNTHESIS ACCESSORY PROTEIN RV0574C-RELATED', NULL, NULL, NULL, 8),
(243810, NULL, 'PTHR12638', NULL, NULL, NULL, NULL, 'PROTEIN MAGO NASHI HOMOLOG', NULL, NULL, 804, 8),
(243811, NULL, 'PTHR35697', NULL, NULL, NULL, NULL, 'OS08G0108300 PROTEIN', NULL, NULL, 35337, 8),
(243812, NULL, 'PTHR43856', NULL, NULL, NULL, NULL, 'CARDIOLIPIN HYDROLASE', NULL, NULL, NULL, 8),
(243813, NULL, 'PTHR33149', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II PROTEIN D1', NULL, NULL, 5823, 8),
(243814, NULL, 'PTHR33266', NULL, NULL, NULL, NULL, 'CHROMOSOME 15, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(243815, NULL, 'PTHR43597', NULL, NULL, NULL, NULL, 'SULFUR ACCEPTOR PROTEIN CSDE', NULL, NULL, 3029, 8),
(243816, NULL, 'PTHR20904', NULL, NULL, NULL, NULL, 'INDUCIBLE T-CELL COSTIMULATOR ICOS', NULL, NULL, 32445, 8),
(243817, NULL, 'PTHR21212', NULL, NULL, NULL, NULL, 'BERNARDINELLI-SEIP CONGENITAL LIPODYSTROPHY 2 HOMOLOG  BSCL2 PROTEIN', NULL, NULL, 1775, 8),
(243818, NULL, 'PTHR45668', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 5-RELATED', NULL, NULL, NULL, 8),
(243819, NULL, 'PTHR22716', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 27409, 8),
(243820, NULL, 'PTHR28495', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC100359752', NULL, NULL, 23779, 8),
(243821, NULL, 'PTHR36934', NULL, NULL, NULL, NULL, 'BLR0278 PROTEIN', NULL, NULL, 24141, 8),
(243822, NULL, 'PTHR47732', NULL, NULL, NULL, NULL, 'RUN AND FYVE DOMAIN-CONTAINING PROTEIN 4', NULL, NULL, 36759, 8),
(243823, NULL, 'PTHR42914', NULL, NULL, NULL, NULL, '7-CYANO-7-DEAZAGUANINE SYNTHASE', NULL, NULL, 16631, 8),
(243824, NULL, 'PTHR37446', NULL, NULL, NULL, NULL, 'CLAUDIN-LIKE IN CAENORHABDITIS', NULL, NULL, NULL, 8),
(243825, NULL, 'PTHR21727', NULL, NULL, NULL, NULL, 'PHOSPHORYLATED CTD INTERACTING FACTOR 1', NULL, NULL, 27500, 8),
(243826, NULL, 'PTHR45794', NULL, NULL, NULL, NULL, 'LEUCYL-TRNA SYNTHETASE', NULL, NULL, 1364, 8),
(243827, NULL, 'PTHR43907', NULL, NULL, NULL, NULL, 'SLEI FAMILY PROTEIN', NULL, NULL, NULL, 8),
(243828, NULL, 'PTHR47818', NULL, NULL, NULL, NULL, 'RNI-LIKE SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(243829, NULL, 'PTHR36685', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(243830, NULL, 'PTHR34359', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 10', NULL, NULL, 27252, 8),
(243831, NULL, 'PTHR35084', NULL, NULL, NULL, NULL, 'TCF3 FUSION PARTNER', NULL, NULL, 29052, 8),
(243832, NULL, 'PTHR45476', NULL, NULL, NULL, NULL, 'CHLORIDE INTRACELLULAR CHANNEL PROTEIN 6-RELATED', NULL, NULL, NULL, 8),
(243833, NULL, 'PTHR43741', NULL, NULL, NULL, NULL, 'FMN-DEPENDENT NADH-AZOREDUCTASE 1', NULL, NULL, NULL, 8),
(243834, NULL, 'PTHR46530', NULL, NULL, NULL, NULL, 'PROTEIN MONO-ADP-RIBOSYLTRANSFERASE PARP4', NULL, NULL, 25752, 8),
(243835, NULL, 'PTHR10736', NULL, NULL, NULL, NULL, 'BESTROPHIN', NULL, NULL, 4494, 8),
(243836, NULL, 'PTHR36311', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I SUBUNIT O', NULL, NULL, 20799, 8),
(243837, NULL, 'PTHR12484', NULL, NULL, NULL, NULL, 'B-LYMPHOCYTE ANTIGEN-RELATED', NULL, NULL, NULL, 8),
(243838, NULL, 'PTHR33377', NULL, NULL, NULL, NULL, 'OS10G0134700 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(243839, NULL, 'PTHR14618', NULL, NULL, NULL, NULL, 'HOMEODOX-CONTAINING PROTEIN 1 HMBOX1', NULL, NULL, 29707, 8),
(243840, NULL, 'PTHR31609', NULL, NULL, NULL, NULL, 'YDJC DEACETYLASE FAMILY MEMBER', NULL, NULL, 4777, 8),
(243841, NULL, 'PTHR43390', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE I', NULL, NULL, 3507, 8),
(243842, NULL, 'PTHR46728', NULL, NULL, NULL, NULL, 'AN1-TYPE ZINC FINGER PROTEIN 4', NULL, NULL, NULL, 8),
(243843, NULL, 'PTHR10300', NULL, NULL, NULL, NULL, 'CALCIPRESSIN', NULL, NULL, 5412, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(243844, NULL, 'PTHR28670', NULL, NULL, NULL, NULL, 'UV-STIMULATED SCAFFOLD PROTEIN A', NULL, NULL, 16290, 8),
(243845, NULL, 'PTHR31745', NULL, NULL, NULL, NULL, 'SINGLE-STRANDED DNA-BINDING PROTEIN WHY2, MITOCHONDRIAL', NULL, NULL, 7946, 8),
(243846, NULL, 'PTHR14304', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE AND APOPTOSIS REGULATOR PROTEIN', NULL, NULL, 25867, 8),
(243847, NULL, 'PTHR31879', NULL, NULL, NULL, NULL, 'DET1- AND DDB1-ASSOCIATED PROTEIN 1', NULL, NULL, 31634, 8),
(243848, NULL, 'PTHR46609', NULL, NULL, NULL, NULL, 'EXONUCLEASE, PHAGE-TYPE/RECB, C-TERMINAL DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(243849, NULL, 'PTHR31086', NULL, NULL, NULL, NULL, 'ALUMINUM-ACTIVATED MALATE TRANSPORTER 10', NULL, NULL, NULL, 8),
(243850, NULL, 'PTHR42935', NULL, NULL, NULL, NULL, 'SLR0930 PROTEIN', NULL, NULL, NULL, 8),
(243851, NULL, 'PTHR28606', NULL, NULL, NULL, NULL, 'INTERLEUKIN-34', NULL, NULL, 20277, 8),
(243852, NULL, 'PTHR31781', NULL, NULL, NULL, NULL, 'UNC80', NULL, NULL, NULL, 8),
(243853, NULL, 'PTHR43290', NULL, NULL, NULL, NULL, 'MEVALONATE KINASE', NULL, NULL, 11129, 8),
(243854, NULL, 'PTHR31020', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 174', NULL, NULL, 22004, 8),
(243855, NULL, 'PTHR32267', NULL, NULL, NULL, NULL, 'T-CELL LEUKEMIA TRANSLOCATION-ALTERED GENE PROTEIN', NULL, NULL, 17548, 8),
(243856, NULL, 'PTHR11145', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING ADAPTER FOR CUL3-MEDIATED RHOA DEGRADATION PROTEIN FAMILY MEMBER', NULL, NULL, 36873, 8),
(243857, NULL, 'PTHR47872', NULL, NULL, NULL, NULL, 'NUCLEAR RNA EXPORT FACTOR SDE5-RELATED', NULL, NULL, NULL, 8),
(243858, NULL, 'PTHR43045', NULL, NULL, NULL, NULL, 'SHIKIMATE TRANSPORTER', NULL, NULL, NULL, 8),
(243859, NULL, 'PTHR34204', NULL, NULL, NULL, NULL, 'RNA-BINDING ASCH DOMAIN PROTEIN', NULL, NULL, NULL, 8),
(243860, NULL, 'PTHR13843', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN', NULL, NULL, 21581, 8),
(243861, NULL, 'PTHR35671', NULL, NULL, NULL, NULL, 'PROTEIN TOPAZ1', NULL, NULL, 30537, 8),
(243862, NULL, 'PTHR36355', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(243863, NULL, 'PTHR43830', NULL, NULL, NULL, NULL, 'PROTEIN PSP1', NULL, NULL, NULL, 8),
(243864, NULL, 'PTHR28271', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN L31, MITOCHONDRIAL', NULL, NULL, 20497, 8),
(243865, NULL, 'PTHR33223', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(243866, NULL, 'PTHR10516', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', NULL, NULL, NULL, 8),
(243867, NULL, 'PTHR47297', NULL, NULL, NULL, NULL, '', NULL, NULL, 34716, 8),
(243868, NULL, 'PTHR28572', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 103', NULL, NULL, 34229, 8),
(243869, NULL, 'PTHR21223', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 1712, 8),
(243870, NULL, 'PTHR46265', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 7', NULL, NULL, NULL, 8),
(243871, NULL, 'PTHR30563', NULL, NULL, NULL, NULL, 'DNA RECOMBINATION PROTEIN RMUC', NULL, NULL, 3425, 8),
(243872, NULL, 'PTHR46957', NULL, NULL, NULL, NULL, 'CYTOKINE RECEPTOR', NULL, NULL, NULL, 8),
(243873, NULL, 'PTHR33564', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(243874, NULL, 'PTHR31153', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 34459, 8),
(243875, NULL, 'PTHR11593', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L17', NULL, NULL, 4780, 8),
(243876, NULL, 'PTHR47572', NULL, NULL, NULL, NULL, 'LIPOPROTEIN-RELATED', NULL, NULL, NULL, 8),
(243877, NULL, 'PTHR33334', NULL, NULL, NULL, NULL, 'PROTEIN LNK1', NULL, NULL, 27256, 8),
(243878, NULL, 'PTHR47237', NULL, NULL, NULL, NULL, 'SLL0310 PROTEIN', NULL, NULL, NULL, 8),
(243879, NULL, 'PTHR47585', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(243880, NULL, 'PTHR37523', NULL, NULL, NULL, NULL, 'METALLOPHOSPHOESTERASE', NULL, NULL, NULL, 8),
(243881, NULL, 'PTHR15854', NULL, NULL, NULL, NULL, 'THAP4 PROTEIN', NULL, NULL, 36515, 8),
(243882, NULL, 'PTHR10046', NULL, NULL, NULL, NULL, 'ATP DEPENDENT LON PROTEASE FAMILY MEMBER', NULL, NULL, 24616, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(243883, NULL, 'PTHR47057', NULL, NULL, NULL, NULL, 'AFADIN/ALPHA-ACTININ-BINDING', NULL, NULL, NULL, 8),
(243884, NULL, 'PTHR35846', NULL, NULL, NULL, NULL, 'PROTEIN CBG05131', NULL, NULL, NULL, 8),
(243885, NULL, 'PTHR45006', NULL, NULL, NULL, NULL, 'DNAJ-LIKE PROTEIN 1', NULL, NULL, NULL, 8),
(243886, NULL, 'PTHR23264', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-BINDING PROTEIN NBP35 YEAST -RELATED', NULL, NULL, 20305, 8),
(243887, NULL, 'PTHR21624', NULL, NULL, NULL, NULL, 'STEROL DESATURASE-RELATED PROTEIN', NULL, NULL, NULL, 8),
(243888, NULL, 'PTHR33059', NULL, NULL, NULL, NULL, 'FCS-LIKE ZINC FINGER 5', NULL, NULL, NULL, 8),
(243889, NULL, 'PTHR36754', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM37', NULL, NULL, NULL, 8),
(243890, NULL, 'PTHR46964', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS I-RELATED', NULL, NULL, NULL, 8),
(243891, NULL, 'PTHR34054', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, 37033, 8),
(243892, NULL, 'PTHR21643', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 27301, 8),
(243893, NULL, 'PTHR17250', NULL, NULL, NULL, NULL, 'NEGATIVE ELONGATION FACTOR E', NULL, NULL, 33099, 8),
(243894, NULL, 'PTHR47557', NULL, NULL, NULL, NULL, 'PLANT UBX DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, 34638, 8),
(243895, NULL, 'PTHR12919', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S16', NULL, NULL, 923, 8),
(243896, NULL, 'PTHR21294', NULL, NULL, NULL, NULL, 'ELECTRON TRANSFER FLAVOPROTEIN BETA-SUBUNIT', NULL, NULL, 11885, 8),
(243897, NULL, 'PTHR31385', NULL, NULL, NULL, NULL, 'PUTATIVE (DUF220)-RELATED', NULL, NULL, NULL, 8),
(243898, NULL, 'PTHR34406', NULL, NULL, NULL, NULL, 'PROTEIN YCEI', NULL, NULL, NULL, 8),
(243899, NULL, 'PTHR45287', NULL, NULL, NULL, NULL, 'OS03G0691500 PROTEIN', NULL, NULL, 27493, 8),
(243900, NULL, 'PTHR10013', NULL, NULL, NULL, NULL, 'GENERAL VESICULAR TRANSPORT FACTOR P115', NULL, NULL, NULL, 8),
(243901, NULL, 'PTHR12321', NULL, NULL, NULL, NULL, 'CPG BINDING PROTEIN', NULL, NULL, 34634, 8),
(243902, NULL, 'PTHR23018', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS XA-RELATED', NULL, NULL, 2397, 8),
(243903, NULL, 'PTHR11453', NULL, NULL, NULL, NULL, 'ANION EXCHANGE PROTEIN', NULL, NULL, 43, 8),
(243904, NULL, 'PTHR32429', NULL, NULL, NULL, NULL, '', NULL, NULL, 36985, 8),
(243905, NULL, 'PTHR36041', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE SUBUNIT 7A, MITOCHONDRIAL-RELATED', NULL, NULL, 4361, 8),
(243906, NULL, 'PTHR12175', NULL, NULL, NULL, NULL, 'AD039  HT014   THIOREDOXIN FAMILY TRP26', NULL, NULL, 35731, 8),
(243907, NULL, 'PTHR36513', NULL, NULL, NULL, NULL, 'ABC TRANSMEMBRANE TYPE-1 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(243908, NULL, 'PTHR11496', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE', NULL, NULL, 27841, 8),
(243909, NULL, 'PTHR35796', NULL, NULL, NULL, NULL, 'HYPOTHETICAL CYTOSOLIC PROTEIN', NULL, NULL, NULL, 8),
(243910, NULL, 'PTHR14281', NULL, NULL, NULL, NULL, 'KINETOCHORE PROTEIN SPC25-RELATED', NULL, NULL, 36560, 8),
(243911, NULL, 'PTHR44758', NULL, NULL, NULL, NULL, 'NAD(P) TRANSHYDROGENASE SUBUNIT BETA', NULL, NULL, NULL, 8),
(243912, NULL, 'PTHR45657', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN YKL091C-RELATED', NULL, NULL, NULL, 8),
(243913, NULL, 'PTHR32001', NULL, NULL, NULL, NULL, 'KERATINOCYTE-ASSOCIATED PROTEIN 2', NULL, NULL, 16450, 8),
(243914, NULL, 'PTHR43564', NULL, NULL, NULL, NULL, 'KYNURENINE FORMAMIDASE-LIKE PROTEIN', NULL, NULL, NULL, 8),
(243915, NULL, 'PTHR30193', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN', NULL, NULL, NULL, 8),
(243916, NULL, 'PTHR33545', NULL, NULL, NULL, NULL, 'UPF0750 MEMBRANE PROTEIN YITT-RELATED', NULL, NULL, NULL, 8),
(243917, NULL, 'PTHR48244', NULL, NULL, NULL, NULL, 'ZEIN-ALPHA A20-RELATED', NULL, NULL, NULL, 8),
(243918, NULL, 'PTHR45747', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE E(Z)', NULL, NULL, 34549, 8),
(243919, NULL, 'PTHR35185', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-RICH PROTEIN ADG2-RELATED', NULL, NULL, NULL, 8),
(243920, NULL, 'PTHR15551', NULL, NULL, NULL, NULL, 'LIM DOMAIN ONLY 7', NULL, NULL, NULL, 8);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(243921, NULL, 'PTHR24345', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PLK', NULL, NULL, NULL, 8),
(243922, NULL, 'PTHR46238', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(243923, NULL, 'PTHR44916', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN-RELATED', NULL, NULL, 35099, 8),
(243924, NULL, 'PTHR13773', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE CYTIDYLYLTRANSFERASE', NULL, NULL, 21414, 8),
(243925, NULL, 'PTHR44404', NULL, NULL, NULL, NULL, 'HYDROXYSTEROID DEHYDROGENASE 1M', NULL, NULL, NULL, 8),
(243926, NULL, 'PTHR13793', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEINS', NULL, NULL, NULL, 8),
(243927, NULL, 'PTHR12953', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN CH1 RELATED', NULL, NULL, 36781, 8),
(243928, NULL, 'PTHR24332', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN CDX', NULL, NULL, NULL, 8),
(243929, NULL, 'PTHR42730', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE SYNTHASE SUBUNIT KORC', NULL, NULL, NULL, 8),
(243930, NULL, 'PTHR12332', NULL, NULL, NULL, NULL, 'KEREN-RELATED', NULL, NULL, 36979, 8),
(243931, NULL, 'PTHR43218', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLTRANSFERASE-RELATED', NULL, NULL, NULL, 8),
(243932, NULL, 'PTHR36337', NULL, NULL, NULL, NULL, 'OBSCURIN-LIKE PROTEIN', NULL, NULL, NULL, 8),
(243933, NULL, 'PTHR37524', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA LARGE SUBUNIT METHYLTRANSFERASE M', NULL, NULL, NULL, 8),
(243934, NULL, 'PTHR43442', NULL, NULL, NULL, NULL, 'GLUCONOKINASE-RELATED', NULL, NULL, 1419, 8),
(243935, NULL, 'PTHR36334', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF2358)-RELATED', NULL, NULL, NULL, 8),
(243936, NULL, 'PTHR43550', NULL, NULL, NULL, NULL, '3-KETODIHYDROSPHINGOSINE REDUCTASE', NULL, NULL, NULL, 8),
(243937, NULL, 'PTHR22625', NULL, NULL, NULL, NULL, 'PLEXIN', NULL, NULL, 24135, 8),
(243938, NULL, 'PTHR45348', NULL, NULL, NULL, NULL, 'HYPOTHETICAL OXIDOREDUCTASE (EUROFUNG)', NULL, NULL, NULL, 8),
(243939, NULL, 'PTHR11239', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE', NULL, NULL, 7498, 8),
(243940, NULL, 'PTHR43087', NULL, NULL, NULL, NULL, 'LYSINE/ARGININE/ORNITHINE TRANSPORT SYSTEM KINASE', NULL, NULL, NULL, 8),
(243941, NULL, 'PTHR12058', NULL, NULL, NULL, NULL, 'ARP2/3 COMPLEX 34 KDA SUBUNIT', NULL, NULL, 1057, 8),
(243942, NULL, 'PTHR15992', NULL, NULL, NULL, NULL, 'HOLLIDAY JUNCTION RECOGNITION PROTEIN', NULL, NULL, NULL, 8),
(243943, NULL, 'PTHR42999', NULL, NULL, NULL, NULL, 'ANTIBIOTIC RESISTANCE PROTEIN MCBG', NULL, NULL, NULL, 8),
(243944, NULL, 'PTHR37707', NULL, NULL, NULL, NULL, 'MATERNAL EFFECT EMBRYO ARREST 9', NULL, NULL, NULL, 8),
(243945, NULL, 'PTHR15568', NULL, NULL, NULL, NULL, 'ECOTROPIC VIRAL INTEGRATION SITE 2A', NULL, NULL, 14277, 8),
(243946, NULL, 'PTHR47424', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN GAL4', NULL, NULL, NULL, 8),
(243947, NULL, 'PTHR24091', NULL, NULL, NULL, NULL, 'LYMPHOCYTE TRANSMEMBRANE ADAPTER 1', NULL, NULL, 25478, 8),
(243948, NULL, 'PTHR16779', NULL, NULL, NULL, NULL, 'BETA-1,4-MANNOSYLTRANSFERASE EGH', NULL, NULL, 24566, 8),
(243949, NULL, 'PTHR17502', NULL, NULL, NULL, NULL, 'C-C MOTIF CHEMOKINE 27 FAMILY MEMBER', NULL, NULL, NULL, 8),
(243950, NULL, 'PTHR16676', NULL, NULL, NULL, NULL, 'SIGNAL TRANSDUCER CD24', NULL, NULL, 21640, 8),
(243951, NULL, 'PTHR38566', NULL, NULL, NULL, NULL, 'RNA_LIG_T4_1 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(243952, NULL, 'PTHR21512', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT 9', NULL, NULL, 14488, 8),
(243953, NULL, 'PTHR44592', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(243954, NULL, 'PTHR34568', NULL, NULL, NULL, NULL, 'RRM DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(243955, NULL, 'PTHR20977', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 1054, 8),
(243956, NULL, 'PTHR36308', NULL, NULL, NULL, NULL, 'DENTIN SIALOPHOSPHOPROTEIN-RELATED', NULL, NULL, NULL, 8),
(243957, NULL, 'PTHR46610', NULL, NULL, NULL, NULL, 'OS05G0181300 PROTEIN', NULL, NULL, 37217, 8),
(243958, NULL, 'PTHR42160', NULL, NULL, NULL, NULL, 'URACIL-DNA GLYCOSYLASE SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(243959, NULL, 'PTHR33791', NULL, NULL, NULL, NULL, 'CHAPERONIN-LIKE RBCX PROTEIN 1, CHLOROPLASTIC', NULL, NULL, 5362, 8),
(243960, NULL, 'PTHR15572', NULL, NULL, NULL, NULL, 'GLIOMA TUMOR SUPPRESSOR CANDIDATE REGION GENE 1', NULL, NULL, NULL, 8),
(243961, NULL, 'PTHR45880', NULL, NULL, NULL, NULL, 'RNA-BINDING MOTIF PROTEIN, X-LINKED 2', NULL, NULL, NULL, 8),
(243962, NULL, 'PTHR10266', NULL, NULL, NULL, NULL, 'CYTOCHROME C1', NULL, NULL, 6349, 8),
(243963, NULL, 'PTHR22699', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN 16', NULL, NULL, 31838, 8),
(243964, NULL, 'PTHR31699', NULL, NULL, NULL, NULL, 'NUDIX T16 FAMILY MEMBER', NULL, NULL, NULL, 8),
(243965, NULL, 'PTHR34547', NULL, NULL, NULL, NULL, 'YACP-LIKE NYN DOMAIN PROTEIN', NULL, NULL, 7571, 8),
(243966, NULL, 'PTHR10378', NULL, NULL, NULL, NULL, 'LIM DOMAIN-BINDING PROTEIN', NULL, NULL, 26989, 8),
(243967, NULL, 'PTHR23022', NULL, NULL, NULL, NULL, 'TRANSPOSABLE ELEMENT-RELATED', NULL, NULL, NULL, 8),
(243968, NULL, 'PTHR45833', NULL, NULL, NULL, NULL, 'METHIONINE SYNTHASE', NULL, NULL, NULL, 8),
(243969, NULL, 'PTHR40386', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 26', NULL, NULL, 30756, 8),
(243970, NULL, 'PTHR33103', NULL, NULL, NULL, NULL, 'OS01G0153900 PROTEIN', NULL, NULL, 1125, 8),
(243971, NULL, 'PTHR16055', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 23229, 8),
(243972, NULL, 'PTHR13342', NULL, NULL, NULL, NULL, 'RAGULATOR COMPLEX PROTEIN LAMTOR5', NULL, NULL, 8270, 8),
(243973, NULL, 'PTHR13493', NULL, NULL, NULL, NULL, 'ZINC FINGER CCHC DOMAIN-CONTAINING', NULL, NULL, 27197, 8),
(243974, NULL, 'PTHR34061', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(243975, NULL, 'PTHR13138', NULL, NULL, NULL, NULL, 'PROTEIN LIN1', NULL, NULL, 27083, 8),
(243976, NULL, 'PTHR13362', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOMAL PROTEIN S33', NULL, NULL, 12028, 8),
(243977, NULL, 'PTHR20426', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS PROTEIN TSR3 HOMOLOG', NULL, NULL, 14673, 8),
(243978, NULL, 'PTHR42913', NULL, NULL, NULL, NULL, 'APOPTOSIS-INDUCING FACTOR 1', NULL, NULL, NULL, 8),
(243979, NULL, 'PTHR47722', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, 34637, 8),
(243980, NULL, 'PTHR11469', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE ISOMERASE', NULL, NULL, 3021, 8),
(243981, NULL, 'PTHR39158', NULL, NULL, NULL, NULL, 'OS08G0560600 PROTEIN', NULL, NULL, NULL, 8),
(243982, NULL, 'PTHR33922', NULL, NULL, NULL, NULL, 'OS01G0888066 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(243983, NULL, 'PTHR46672', NULL, NULL, NULL, NULL, 'OS08G0495500 PROTEIN-RELATED', NULL, NULL, 34116, 8),
(243984, NULL, 'PTHR46295', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM RESIDENT PROTEIN 44', NULL, NULL, NULL, 8),
(243985, NULL, 'PTHR47763', NULL, NULL, NULL, NULL, 'ALPHA-PROTEIN KINASE VWKA', NULL, NULL, NULL, 8),
(243986, NULL, 'PTHR11134', NULL, NULL, NULL, NULL, 'ADAPTOR COMPLEX SUBUNIT BETA FAMILY MEMBER', NULL, NULL, 25403, 8),
(243987, NULL, 'PTHR47042', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN-LIKE', NULL, NULL, NULL, 8),
(243988, NULL, 'PTHR35302', NULL, NULL, NULL, NULL, '', NULL, NULL, 19714, 8),
(243989, NULL, 'PTHR15549', NULL, NULL, NULL, NULL, 'PAIRED IMMUNOGLOBULIN-LIKE TYPE 2 RECEPTOR', NULL, NULL, NULL, 8),
(243990, NULL, 'PTHR10000', NULL, NULL, NULL, NULL, 'PHOSPHOSERINE PHOSPHATASE', NULL, NULL, NULL, 8),
(243991, NULL, 'PTHR32227', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,3-BETA-GLUCOSIDASE BG1-RELATED-RELATED', NULL, NULL, 35424, 8),
(243992, NULL, 'PTHR35345', NULL, NULL, NULL, NULL, 'TELOMERE REPEATS-BINDING BOUQUET FORMATION PROTEIN 2', NULL, NULL, 26851, 8),
(243993, NULL, 'PTHR46129', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN 14, ISOFORM D', NULL, NULL, 35274, 8),
(243994, NULL, 'PTHR31681', NULL, NULL, NULL, NULL, 'C2H2-LIKE ZINC FINGER PROTEIN', NULL, NULL, NULL, 8),
(243995, NULL, 'PTHR36508', NULL, NULL, NULL, NULL, 'PROTEIN SLYX', NULL, NULL, 6627, 8),
(243996, NULL, 'PTHR45389', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN RUP1', NULL, NULL, 36187, 8);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(243997, NULL, 'PTHR43244', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(243998, NULL, 'PTHR37691', NULL, NULL, NULL, NULL, 'BLR3518 PROTEIN', NULL, NULL, NULL, 8),
(243999, NULL, 'PTHR43875', NULL, NULL, NULL, NULL, 'MALTODEXTRIN IMPORT ATP-BINDING PROTEIN MSMX', NULL, NULL, NULL, 8),
(244000, NULL, 'PTHR12981', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN-LIKE 1', NULL, NULL, 28965, 8),
(244001, NULL, 'PTHR28651', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 232', NULL, NULL, 23516, 8),
(244002, NULL, 'PTHR46926', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING CYSTEINE-RICH PROTEIN 2', NULL, NULL, 31900, 8),
(244003, NULL, 'PTHR42048', NULL, NULL, NULL, NULL, 'ARS-BINDING PROTEIN 2', NULL, NULL, 15383, 8),
(244004, NULL, 'PTHR32467', NULL, NULL, NULL, NULL, 'AP2-LIKE ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR', NULL, NULL, NULL, 8),
(244005, NULL, 'PTHR15963', NULL, NULL, NULL, NULL, 'GENERAL RECEPTOR FOR PHOSPHOINOSITIDES 1-ASSOCIATED SCAFFOLD PROTEIN-RELATED', NULL, NULL, NULL, 8),
(244006, NULL, 'PTHR21856', NULL, NULL, NULL, NULL, 'FIBROUS SHEATH-INTERACTING PROTEIN 2', NULL, NULL, NULL, 8),
(244007, NULL, 'PTHR30081', NULL, NULL, NULL, NULL, 'PROTEIN-EXPORT MEMBRANE PROTEIN SEC', NULL, NULL, 14574, 8),
(244008, NULL, 'PTHR30529', NULL, NULL, NULL, NULL, 'CYTOCHROME B561', NULL, NULL, NULL, 8),
(244009, NULL, 'PTHR36759', NULL, NULL, NULL, NULL, 'DYNEIN BETA CHAIN, CILIARY PROTEIN', NULL, NULL, NULL, 8),
(244010, NULL, 'PTHR18034', NULL, NULL, NULL, NULL, 'CELL CYCLE CONTROL PROTEIN CWF22-RELATED', NULL, NULL, NULL, 8),
(244011, NULL, 'PTHR15016', NULL, NULL, NULL, NULL, 'BREAST CARCINOMA-AMPLIFIED SEQUENCE 1', NULL, NULL, 25933, 8),
(244012, NULL, 'PTHR12354', NULL, NULL, NULL, NULL, 'INTERFERON-RELATED DEVELOPMENTAL REGULATOR', NULL, NULL, 27051, 8),
(244013, NULL, 'PTHR15207', NULL, NULL, NULL, NULL, 'NONSYNDROMIC HEARING IMPAIRMENT PROTEIN', NULL, NULL, 37520, 8),
(244014, NULL, 'PTHR11557', NULL, NULL, NULL, NULL, 'PORPHOBILINOGEN DEAMINASE', NULL, NULL, 3144, 8),
(244015, NULL, 'PTHR42707', NULL, NULL, NULL, NULL, 'ACYL-COA DEHYDROGENASE', NULL, NULL, NULL, 8),
(244016, NULL, 'PTHR45998', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 16', NULL, NULL, NULL, 8),
(244017, NULL, 'PTHR45781', NULL, NULL, NULL, NULL, 'AGAP000281-PA', NULL, NULL, NULL, 8),
(244018, NULL, 'PTHR13151', NULL, NULL, NULL, NULL, 'CBF1 INTERACTING COREPRESSOR CIR', NULL, NULL, 27453, 8),
(244019, NULL, 'PTHR13147', NULL, NULL, NULL, NULL, 'FOUR-JOINTED BOX PROTEIN 1', NULL, NULL, 22156, 8),
(244020, NULL, 'PTHR45084', NULL, NULL, NULL, NULL, 'ERAD-ASSOCIATED E3 UBIQUITIN-PROTEIN LIGASE COMPONENT HRD3A-RELATED', NULL, NULL, 36320, 8),
(244021, NULL, 'PTHR37874', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1500011B03 GENE-RELATED', NULL, NULL, NULL, 8),
(244022, NULL, 'PTHR35615', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244023, NULL, 'PTHR36319', NULL, NULL, NULL, NULL, 'PROTEIN GIGANTEA', NULL, NULL, 26481, 8),
(244024, NULL, 'PTHR24056', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN KINASE', NULL, NULL, NULL, 8),
(244025, NULL, 'PTHR13306', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 8011, 8),
(244026, NULL, 'PTHR37702', NULL, NULL, NULL, NULL, 'PROLINE-RICH FAMILY PROTEIN', NULL, NULL, NULL, 8),
(244027, NULL, 'PTHR47537', NULL, NULL, NULL, NULL, 'CUBILIN', NULL, NULL, NULL, 8),
(244028, NULL, 'PTHR40660', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244029, NULL, 'PTHR15184', NULL, NULL, NULL, NULL, 'ATP SYNTHASE', NULL, NULL, NULL, 8),
(244030, NULL, 'PTHR24098', NULL, NULL, NULL, NULL, 'OUTER SEGMENT 5', NULL, NULL, NULL, 8),
(244031, NULL, 'PTHR33735', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(244032, NULL, 'PTHR12756', NULL, NULL, NULL, NULL, 'CYTOSOLIC CARBOXYPEPTIDASE', NULL, NULL, NULL, 8),
(244033, NULL, 'PTHR37153', NULL, NULL, NULL, NULL, 'CHROMOSOME 19 C19ORF81 HOMOLOG', NULL, NULL, 23823, 8),
(244034, NULL, 'PTHR48043', NULL, NULL, NULL, NULL, 'EG:EG0003.4 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(244035, NULL, 'PTHR12747', NULL, NULL, NULL, NULL, 'ELONGATOR COMPLEX PROTEIN 1', NULL, NULL, 3521, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(244036, NULL, 'PTHR36965', NULL, NULL, NULL, NULL, 'FE(2+)-TRAFFICKING PROTEIN-RELATED', NULL, NULL, 4621, 8),
(244037, NULL, 'PTHR31667', NULL, NULL, NULL, NULL, 'SPERM EQUATORIAL SEGMENT PROTEIN 1', NULL, NULL, 25936, 8),
(244038, NULL, 'PTHR47935', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN MRL1, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(244039, NULL, 'PTHR16433', NULL, NULL, NULL, NULL, 'DOLICHOL-PHOSPHATE MANNOSYLTRANSFERASE SUBUNIT 3', NULL, NULL, 17010, 8),
(244040, NULL, 'PTHR43799', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(244041, NULL, 'PTHR45912', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 47', NULL, NULL, NULL, 8),
(244042, NULL, 'PTHR31853', NULL, NULL, NULL, NULL, 'PSORIASIS SUSCEPTIBILITY 1 CANDIDATE GENE 2 PROTEIN', NULL, NULL, 26453, 8),
(244043, NULL, 'PTHR45692', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F2_4 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(244044, NULL, 'PTHR10943', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT', NULL, NULL, NULL, 8),
(244045, NULL, 'PTHR45784', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 20 MEMBER A-RELATED', NULL, NULL, NULL, 8),
(244046, NULL, 'PTHR42788', NULL, NULL, NULL, NULL, 'TAURINE IMPORT ATP-BINDING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(244047, NULL, 'PTHR12471', NULL, NULL, NULL, NULL, 'VACUOLAR ATP SYNTHASE SUBUNIT S1', NULL, NULL, 7542, 8),
(244048, NULL, 'PTHR36029', NULL, NULL, NULL, NULL, 'TSET COMPLEX MEMBER TSTA', NULL, NULL, 33878, 8),
(244049, NULL, 'PTHR47773', NULL, NULL, NULL, NULL, 'SI:DKEY-9I5.2-RELATED', NULL, NULL, NULL, 8),
(244050, NULL, 'PTHR24020', NULL, NULL, NULL, NULL, 'COLLAGEN ALPHA', NULL, NULL, NULL, 8),
(244051, NULL, 'PTHR12186', NULL, NULL, NULL, NULL, 'SIKE FAMILY MEMBER', NULL, NULL, 13275, 8),
(244052, NULL, 'PTHR31867', NULL, NULL, NULL, NULL, 'EXPANSIN-A15', NULL, NULL, 832, 8),
(244053, NULL, 'PTHR12358', NULL, NULL, NULL, NULL, 'SPHINGOSINE KINASE', NULL, NULL, NULL, 8),
(244054, NULL, 'PTHR36083', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L32, CHLOROPLASTIC', NULL, NULL, 35271, 8),
(244055, NULL, 'PTHR37973', NULL, NULL, NULL, NULL, 'CHONDROITIN PROTEOGLYCAN 3', NULL, NULL, 31878, 8),
(244056, NULL, 'PTHR34212', NULL, NULL, NULL, NULL, 'OS02G0104200 PROTEIN', NULL, NULL, NULL, 8),
(244057, NULL, 'PTHR28494', NULL, NULL, NULL, NULL, 'UPF0600 PROTEIN C5ORF51', NULL, NULL, 32868, 8),
(244058, NULL, 'PTHR46659', NULL, NULL, NULL, NULL, 'SERINE/THREONINE/TYROSINE-INTERACTING-LIKE PROTEIN 1', NULL, NULL, NULL, 8),
(244059, NULL, 'PTHR13572', NULL, NULL, NULL, NULL, 'ENDO-ALPHA-1,2-MANNOSIDASE', NULL, NULL, 21625, 8),
(244060, NULL, 'PTHR40115', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN WITH PEPSY TM HELIX', NULL, NULL, 25127, 8),
(244061, NULL, 'PTHR39150', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN L28, MITOCHONDRIAL', NULL, NULL, 35472, 8),
(244062, NULL, 'PTHR34679', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244063, NULL, 'PTHR47544', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 4', NULL, NULL, NULL, 8),
(244064, NULL, 'PTHR45656', NULL, NULL, NULL, NULL, 'PROTEIN CBR-CLEC-78', NULL, NULL, NULL, 8),
(244065, NULL, 'PTHR36068', NULL, NULL, NULL, NULL, 'OS01G0102500 PROTEIN', NULL, NULL, NULL, 8),
(244066, NULL, 'PTHR10166', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL SUBUNIT ALPHA-2/DELTA-RELATED', NULL, NULL, NULL, 8),
(244067, NULL, 'PTHR36064', NULL, NULL, NULL, NULL, 'EMBRYO DEFECTIVE 2735', NULL, NULL, NULL, 8),
(244068, NULL, 'PTHR43296', NULL, NULL, NULL, NULL, 'PEROXISOMAL 2,4-DIENOYL-COA REDUCTASE', NULL, NULL, 35985, 8),
(244069, NULL, 'PTHR47744', NULL, NULL, NULL, NULL, 'OS05G0526300 PROTEIN', NULL, NULL, NULL, 8),
(244070, NULL, 'PTHR21403', NULL, NULL, NULL, NULL, 'ATP PHOSPHORIBOSYLTRANSFERASE  ATP-PRTASE', NULL, NULL, 7145, 8),
(244071, NULL, 'PTHR38324', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 158', NULL, NULL, 30499, 8),
(244072, NULL, 'PTHR17125', NULL, NULL, NULL, NULL, 'OUTER DENSE FIBER PROTEIN 1', NULL, NULL, 29137, 8);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(244073, NULL, 'PTHR47558', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE HOS3', NULL, NULL, NULL, 8),
(244074, NULL, 'PTHR13748', NULL, NULL, NULL, NULL, 'COBW-RELATED', NULL, NULL, NULL, 8),
(244075, NULL, 'PTHR11954', NULL, NULL, NULL, NULL, 'D-DOPACHROME DECARBOXYLASE', NULL, NULL, 3434, 8),
(244076, NULL, 'PTHR21131', NULL, NULL, NULL, NULL, 'SERINE-TYPE ENDOPEPTIDASE INHIBITOR', NULL, NULL, NULL, 8),
(244077, NULL, 'PTHR47665', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE-LIKE PROTEIN', NULL, NULL, NULL, 8),
(244078, NULL, 'PTHR13538', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE 6', NULL, NULL, 27249, 8),
(244079, NULL, 'PTHR37009', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(244080, NULL, 'PTHR34215', NULL, NULL, NULL, NULL, 'BLL0784 PROTEIN', NULL, NULL, 27005, 8),
(244081, NULL, 'PTHR11005', NULL, NULL, NULL, NULL, 'LYSOSOMAL ACID LIPASE-RELATED', NULL, NULL, NULL, 8),
(244082, NULL, 'PTHR36876', NULL, NULL, NULL, NULL, 'UROTENSIN-2B', NULL, NULL, 34105, 8),
(244083, NULL, 'PTHR38010', NULL, NULL, NULL, NULL, 'SLR0848 PROTEIN', NULL, NULL, NULL, 8),
(244084, NULL, 'PTHR11814', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORTER', NULL, NULL, 2264, 8),
(244085, NULL, 'PTHR22996', NULL, NULL, NULL, NULL, 'MAHOGUNIN', NULL, NULL, 34928, 8),
(244086, NULL, 'PTHR16852', NULL, NULL, NULL, NULL, 'GTP CYCLOHYDROLASE 1 FEEDBACK REGULATORY PROTEIN', NULL, NULL, 7959, 8),
(244087, NULL, 'PTHR35746', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT (PPR) SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(244088, NULL, 'PTHR13182', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 622', NULL, NULL, 27348, 8),
(244089, NULL, 'PTHR12806', NULL, NULL, NULL, NULL, 'EAP30 SUBUNIT OF ELL COMPLEX', NULL, NULL, 20438, 8),
(244090, NULL, 'PTHR42873', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA LARGE SUBUNIT METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(244091, NULL, 'PTHR38134', NULL, NULL, NULL, NULL, 'SLR1395 PROTEIN', NULL, NULL, NULL, 8),
(244092, NULL, 'PTHR38222', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244093, NULL, 'PTHR12283', NULL, NULL, NULL, NULL, 'GLUTAMINYL-PEPTIDE CYCLOTRANSFERASE', NULL, NULL, 28815, 8),
(244094, NULL, 'PTHR17602', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS REGULATORY PROTEIN', NULL, NULL, 6833, 8),
(244095, NULL, 'PTHR36005', NULL, NULL, NULL, NULL, 'DNA LIGASE-LIKE PROTEIN', NULL, NULL, NULL, 8),
(244096, NULL, 'PTHR37201', NULL, NULL, NULL, NULL, 'WD REPEAT PROTEIN', NULL, NULL, NULL, 8),
(244097, NULL, 'PTHR43166', NULL, NULL, NULL, NULL, 'AMINO ACID IMPORT ATP-BINDING PROTEIN', NULL, NULL, NULL, 8),
(244098, NULL, 'PTHR33722', NULL, NULL, NULL, NULL, 'CATION CHANNEL SPERM-ASSOCIATED PROTEIN SUBUNIT DELTA-RELATED', NULL, NULL, 23049, 8),
(244099, NULL, 'PTHR14437', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 168', NULL, NULL, 24501, 8),
(244100, NULL, 'PTHR31602', NULL, NULL, NULL, NULL, 'GROWTH-REGULATING FACTOR 5', NULL, NULL, 25304, 8),
(244101, NULL, 'PTHR33337', NULL, NULL, NULL, NULL, 'GFA DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(244102, NULL, 'PTHR46057', NULL, NULL, NULL, NULL, 'FCS-LIKE ZINC FINGER 1-RELATED', NULL, NULL, 34631, 8),
(244103, NULL, 'PTHR40438', NULL, NULL, NULL, NULL, 'PYRUVOYL-DEPENDENT ARGININE DECARBOXYLASE', NULL, NULL, 3752, 8),
(244104, NULL, 'PTHR30547', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN YHCG-RELATED', NULL, NULL, NULL, 8),
(244105, NULL, 'PTHR21685', NULL, NULL, NULL, NULL, 'TON-B BOX DOMAIN', NULL, NULL, 25408, 8),
(244106, NULL, 'PTHR48318', NULL, NULL, NULL, NULL, 'PROTEIN EVA-1 HOMOLOG B', NULL, NULL, NULL, 8),
(244107, NULL, 'PTHR42107', NULL, NULL, NULL, NULL, 'YALI0D24453P', NULL, NULL, NULL, 8),
(244108, NULL, 'PTHR13070', NULL, NULL, NULL, NULL, 'TRNA-SPLICING ENDONUCLEASE SUBUNIT SEN34-RELATED', NULL, NULL, NULL, 8),
(244109, NULL, 'PTHR36006', NULL, NULL, NULL, NULL, 'BNAC02G25390D PROTEIN', NULL, NULL, NULL, 8),
(244110, NULL, 'PTHR34655', NULL, NULL, NULL, NULL, 'CONSERVED WITHIN P. AEROPHILUM', NULL, NULL, NULL, 8),
(244111, NULL, 'PTHR46303', NULL, NULL, NULL, NULL, 'VWFC DOMAIN-CONTAINING PROTEIN', NULL, NULL, 36343, 8);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(244112, NULL, 'PTHR46637', NULL, NULL, NULL, NULL, 'TIS1421-TRANSPOSASE PROTEIN A', NULL, NULL, NULL, 8),
(244113, NULL, 'PTHR47469', NULL, NULL, NULL, NULL, 'MONOOXYGENASE-LIKE', NULL, NULL, NULL, 8),
(244114, NULL, 'PTHR13596', NULL, NULL, NULL, NULL, 'SMALL EDRK-RICH FACTOR 1', NULL, NULL, 27144, 8),
(244115, NULL, 'PTHR32057', NULL, NULL, NULL, NULL, 'PROTEIN ADENYLYLTRANSFERASE SELO, MITOCHONDRIAL', NULL, NULL, 3081, 8),
(244116, NULL, 'PTHR31945', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SCREAM2-RELATED', NULL, NULL, NULL, 8),
(244117, NULL, 'PTHR48124', NULL, NULL, NULL, NULL, 'GRF-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(244118, NULL, 'PTHR10146', NULL, NULL, NULL, NULL, 'PROLINE SYNTHETASE CO-TRANSCRIBED BACTERIAL HOMOLOG PROTEIN', NULL, NULL, 9662, 8),
(244119, NULL, 'PTHR38590', NULL, NULL, NULL, NULL, 'BLL0828 PROTEIN', NULL, NULL, NULL, 8),
(244120, NULL, 'PTHR40079', NULL, NULL, NULL, NULL, 'MANNAN ENDO-1,4-BETA-MANNOSIDASE E-RELATED', NULL, NULL, 4991, 8),
(244121, NULL, 'PTHR35337', NULL, NULL, NULL, NULL, 'SLR1478 PROTEIN', NULL, NULL, NULL, 8),
(244122, NULL, 'PTHR31011', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 27145, 8),
(244123, NULL, 'PTHR37421', NULL, NULL, NULL, NULL, 'UPF0260 PROTEIN YCGN', NULL, NULL, 714, 8),
(244124, NULL, 'PTHR14308', NULL, NULL, NULL, NULL, 'WAP FOUR-DISULFIDE CORE DOMAIN PROTEIN 1', NULL, NULL, 36691, 8),
(244125, NULL, 'PTHR35288', NULL, NULL, NULL, NULL, 'TAIL FIBER', NULL, NULL, NULL, 8),
(244126, NULL, 'PTHR45966', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE', NULL, NULL, 36075, 8),
(244127, NULL, 'PTHR35286', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(244128, NULL, 'PTHR34252', NULL, NULL, NULL, NULL, 'UPF0705 PROTEIN C11ORF49', NULL, NULL, 27356, 8),
(244129, NULL, 'PTHR42771', NULL, NULL, NULL, NULL, 'IRON(3+)-HYDROXAMATE IMPORT ATP-BINDING PROTEIN FHUC', NULL, NULL, NULL, 8),
(244130, NULL, 'PTHR43267', NULL, NULL, NULL, NULL, 'TRNA THREONYLCARBAMOYLADENOSINE DEHYDRATASE', NULL, NULL, 37008, 8),
(244131, NULL, 'PTHR43853', NULL, NULL, NULL, NULL, '3-KETOACYL-COA THIOLASE, PEROXISOMAL', NULL, NULL, NULL, 8),
(244132, NULL, 'PTHR24355', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR KINASE/RIBOSOMAL PROTEIN S6 KINASE', NULL, NULL, NULL, 8),
(244133, NULL, 'PTHR21490', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(244134, NULL, 'PTHR35090', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT I', NULL, NULL, NULL, 8),
(244135, NULL, 'PTHR46533', NULL, NULL, NULL, NULL, 'ZINC FINGER MYND DOMAIN-CONTAINING PROTEIN 12', NULL, NULL, NULL, 8),
(244136, NULL, 'PTHR41148', NULL, NULL, NULL, NULL, 'LP09875P', NULL, NULL, NULL, 8),
(244137, NULL, 'PTHR33155', NULL, NULL, NULL, NULL, 'FANTASTIC FOUR-LIKE PROTEIN (DUF3049)', NULL, NULL, 18291, 8),
(244138, NULL, 'PTHR30632', NULL, NULL, NULL, NULL, 'MOLYBDATE-BINDING PERIPLASMIC PROTEIN', NULL, NULL, NULL, 8),
(244139, NULL, 'PTHR10344', NULL, NULL, NULL, NULL, 'THYMIDYLATE KINASE', NULL, NULL, NULL, 8),
(244140, NULL, 'PTHR48181', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244141, NULL, 'PTHR13323', NULL, NULL, NULL, NULL, 'LATE ENDOSOMAL/LYSOSOMAL MP1 INTERACTING PROTEIN', NULL, NULL, 33075, 8),
(244142, NULL, 'PTHR24270', NULL, NULL, NULL, NULL, 'LOW-DENSITY LIPOPROTEIN RECEPTOR-RELATED', NULL, NULL, NULL, 8),
(244143, NULL, 'PTHR13482', NULL, NULL, NULL, NULL, 'MICRORNA PROCESSOR COMPLEX SUBUNIT DGCR8', NULL, NULL, 28630, 8),
(244144, NULL, 'PTHR45125', NULL, NULL, NULL, NULL, 'F21J9.4-RELATED', NULL, NULL, NULL, 8),
(244145, NULL, 'PTHR46958', NULL, NULL, NULL, NULL, 'B-CELL RECEPTOR CD22', NULL, NULL, NULL, 8),
(244146, NULL, 'PTHR31148', NULL, NULL, NULL, NULL, 'U1 SMALL NUCLEAR RIBONUCLEOPROTEIN C', NULL, NULL, 17094, 8),
(244147, NULL, 'PTHR13815', NULL, NULL, NULL, NULL, 'GOLGIN-84', NULL, NULL, 18281, 8),
(244148, NULL, 'PTHR10032', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN WITH KRAB AND SCAN DOMAINS', NULL, NULL, 23937, 8),
(244149, NULL, 'PTHR46003', NULL, NULL, NULL, NULL, 'HOST CELL FACTOR', NULL, NULL, 36905, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(244150, NULL, 'PTHR12708', NULL, NULL, NULL, NULL, 'DNA POLYMERASE EPSILON SUBUNIT B', NULL, NULL, 19598, 8),
(244151, NULL, 'PTHR46882', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY N MEMBER 1', NULL, NULL, 35398, 8),
(244152, NULL, 'PTHR13223', NULL, NULL, NULL, NULL, 'ACIDIC FIBROBLAST GROWTH FACTOR INTRACELLULAR BINDING PROTEIN', NULL, NULL, 14271, 8),
(244153, NULL, 'PTHR13284', NULL, NULL, NULL, NULL, 'GH01354P', NULL, NULL, 27411, 8),
(244154, NULL, 'PTHR15937', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE 7 SUPERFAMILY MEMBER 3', NULL, NULL, 36760, 8),
(244155, NULL, 'PTHR39328', NULL, NULL, NULL, NULL, 'BLL2871 PROTEIN', NULL, NULL, NULL, 8),
(244156, NULL, 'PTHR37381', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT (PPR) SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(244157, NULL, 'PTHR11334', NULL, NULL, NULL, NULL, 'MAS-RELATED G-PROTEIN COUPLED RECEPTOR', NULL, NULL, 26664, 8),
(244158, NULL, 'PTHR10858', NULL, NULL, NULL, NULL, 'DEOXYRIBONUCLEASE II', NULL, NULL, 2627, 8),
(244159, NULL, 'PTHR31982', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I REACTION CENTER SUBUNIT II-1, CHLOROPLASTIC-RELATED', NULL, NULL, 1691, 8),
(244160, NULL, 'PTHR37872', NULL, NULL, NULL, NULL, 'SIMILAR TO RIKEN CDNA 1700029I15', NULL, NULL, 23987, 8),
(244161, NULL, 'PTHR31260', NULL, NULL, NULL, NULL, 'CYSTATIN/MONELLIN SUPERFAMILY PROTEIN', NULL, NULL, 6639, 8),
(244162, NULL, 'PTHR31534', NULL, NULL, NULL, NULL, 'ATAXIN 7, ISOFORM A', NULL, NULL, NULL, 8),
(244163, NULL, 'PTHR38432', NULL, NULL, NULL, NULL, 'TELA-LIKE PROTEIN SAOUHSC_01408', NULL, NULL, 13726, 8),
(244164, NULL, 'PTHR34142', NULL, NULL, NULL, NULL, 'ENDO-BETA-1,4-GLUCANASE A', NULL, NULL, NULL, 8),
(244165, NULL, 'PTHR48118', NULL, NULL, NULL, NULL, 'SPINDLE AND KINETOCHORE-ASSOCIATED PROTEIN 3', NULL, NULL, 31381, 8),
(244166, NULL, 'PTHR46758', NULL, NULL, NULL, NULL, 'MYND DOMAIN-CONTAINING', NULL, NULL, 34511, 8),
(244167, NULL, 'PTHR12304', NULL, NULL, NULL, NULL, 'INOSINE-URIDINE PREFERRING NUCLEOSIDE HYDROLASE', NULL, NULL, 13922, 8),
(244168, NULL, 'PTHR47943', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 93A3-LIKE', NULL, NULL, NULL, 8),
(244169, NULL, 'PTHR10404', NULL, NULL, NULL, NULL, 'N-ACETYLATED-ALPHA-LINKED ACIDIC DIPEPTIDASE', NULL, NULL, 33013, 8),
(244170, NULL, 'PTHR34533', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN CCDC163', NULL, NULL, 32810, 8),
(244171, NULL, 'PTHR24281', NULL, NULL, NULL, NULL, 'STEROID 21-HYDROXYLASE-RELATED', NULL, NULL, NULL, 8),
(244172, NULL, 'PTHR36704', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(244173, NULL, 'PTHR46843', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN 16', NULL, NULL, 35302, 8),
(244174, NULL, 'PTHR12687', NULL, NULL, NULL, NULL, 'NUCLEOLAR COMPLEX 2 AND RAD4-RELATED', NULL, NULL, 6039, 8),
(244175, NULL, 'PTHR43284', NULL, NULL, NULL, NULL, 'ASPARAGINE SYNTHETASE (GLUTAMINE-HYDROLYZING)', NULL, NULL, NULL, 8),
(244176, NULL, 'PTHR22094', NULL, NULL, NULL, NULL, 'DIFFUSE PANBRONCHIOLITIS CRITICAL REGION GENE 1', NULL, NULL, 22092, 8),
(244177, NULL, 'PTHR36761', NULL, NULL, NULL, NULL, 'ORF03 PROTEIN', NULL, NULL, NULL, 8),
(244178, NULL, 'PTHR18806', NULL, NULL, NULL, NULL, 'RBM25 PROTEIN', NULL, NULL, NULL, 8),
(244179, NULL, 'PTHR24258', NULL, NULL, NULL, NULL, 'SERINE PROTEASE-RELATED', NULL, NULL, NULL, 8),
(244180, NULL, 'PTHR11017', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN', NULL, NULL, 35119, 8),
(244181, NULL, 'PTHR13233', NULL, NULL, NULL, NULL, 'MICROSPHERULE PROTEIN 1', NULL, NULL, 31909, 8),
(244182, NULL, 'PTHR43213', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL DTTP/UTP PYROPHOSPHATASE/METHYLTRANSFERASE PROTEIN-RELATED', NULL, NULL, 2141, 8),
(244183, NULL, 'PTHR45651', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED ION CHANNEL 15-RELATED-RELATED', NULL, NULL, NULL, 8),
(244184, NULL, 'PTHR12603', NULL, NULL, NULL, NULL, 'CCR4-NOT TRANSCRIPTION COMPLEX RELATED', NULL, NULL, 33387, 8),
(244185, NULL, 'PTHR10807', NULL, NULL, NULL, NULL, 'MYOTUBULARIN-RELATED', NULL, NULL, 25303, 8);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(244186, NULL, 'PTHR24241', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE RECEPTOR-RELATED G-PROTEIN COUPLED RECEPTOR', NULL, NULL, NULL, 8),
(244187, NULL, 'PTHR47207', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P3-1-RELATED', NULL, NULL, 36483, 8),
(244188, NULL, 'PTHR14566', NULL, NULL, NULL, NULL, 'CELL CYCLE REGULATOR OF NON-HOMOLOGOUS END JOINING', NULL, NULL, 26619, 8),
(244189, NULL, 'PTHR11254', NULL, NULL, NULL, NULL, 'HECT DOMAIN UBIQUITIN-PROTEIN LIGASE', NULL, NULL, NULL, 8),
(244190, NULL, 'PTHR38040', NULL, NULL, NULL, NULL, 'UBIQUINONE BIOSYNTHESIS ACCESSORY FACTOR UBIK', NULL, NULL, 2210, 8),
(244191, NULL, 'PTHR42799', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PEPTIDE METHIONINE SULFOXIDE REDUCTASE', NULL, NULL, NULL, 8),
(244192, NULL, 'PTHR47562', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244193, NULL, 'PTHR11215', NULL, NULL, NULL, NULL, 'METAL DEPENDENT HYDROLASE - RELATED', NULL, NULL, 2711, 8),
(244194, NULL, 'PTHR14270', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 32895, 8),
(244195, NULL, 'PTHR43168', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L33, CHLOROPLASTIC', NULL, NULL, 3058, 8),
(244196, NULL, 'PTHR12677', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 7157, 8),
(244197, NULL, 'PTHR20383', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II SUBUNIT A C-TERMINAL DOMAIN PHOSPHATASE', NULL, NULL, 3861, 8),
(244198, NULL, 'PTHR10070', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN J CHAIN', NULL, NULL, 9860, 8),
(244199, NULL, 'PTHR43189', NULL, NULL, NULL, NULL, 'ZINC-TYPE ALCOHOL DEHYDROGENASE-LIKE PROTEIN C1198.01-RELATED', NULL, NULL, NULL, 8),
(244200, NULL, 'PTHR35493', NULL, NULL, NULL, NULL, 'STRUCTURAL MAINTENANCE OF CHROMOSOMES PROTEIN', NULL, NULL, NULL, 8),
(244201, NULL, 'PTHR33264', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(244202, NULL, 'PTHR34523', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 138', NULL, NULL, 32425, 8),
(244203, NULL, 'PTHR14931', NULL, NULL, NULL, NULL, 'GENE 340-RELATED', NULL, NULL, 24662, 8),
(244204, NULL, 'PTHR37811', NULL, NULL, NULL, NULL, 'BLL5343 PROTEIN', NULL, NULL, NULL, 8),
(244205, NULL, 'PTHR36081', NULL, NULL, NULL, NULL, 'CELL WALL INTEGRITY/STRESS RESPONSE COMPONENT', NULL, NULL, NULL, 8),
(244206, NULL, 'PTHR48046', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 72E1', NULL, NULL, NULL, 8),
(244207, NULL, 'PTHR11021', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN F  SNRNP-F', NULL, NULL, 15317, 8),
(244208, NULL, 'PTHR46721', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN N1', NULL, NULL, NULL, 8),
(244209, NULL, 'PTHR42709', NULL, NULL, NULL, NULL, 'ALKALINE PHOSPHATASE LIKE PROTEIN', NULL, NULL, NULL, 8),
(244210, NULL, 'PTHR20990', NULL, NULL, NULL, NULL, 'PEROXISOMAL BIOGENESIS FACTOR 11', NULL, NULL, 23454, 8),
(244211, NULL, 'PTHR45296', NULL, NULL, NULL, NULL, 'TRANSDUCIN/WD40 REPEAT-LIKE SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(244212, NULL, 'PTHR45000', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(244213, NULL, 'PTHR44846', NULL, NULL, NULL, NULL, 'MANNOSYL-D-GLYCERATE TRANSPORT/METABOLISM SYSTEM REPRESSOR MNGR-RELATED', NULL, NULL, NULL, 8),
(244214, NULL, 'PTHR23088', NULL, NULL, NULL, NULL, 'NITRILASE-RELATED', NULL, NULL, NULL, 8),
(244215, NULL, 'PTHR37198', NULL, NULL, NULL, NULL, 'NUCLEOLIN', NULL, NULL, NULL, 8),
(244216, NULL, 'PTHR15530', NULL, NULL, NULL, NULL, 'SERTA DOMAIN-CONTAINING PROTEIN 3', NULL, NULL, 33204, 8),
(244217, NULL, 'PTHR46044', NULL, NULL, NULL, NULL, 'NITRILASE', NULL, NULL, 33890, 8),
(244218, NULL, 'PTHR44145', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY A MEMBER 3, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(244219, NULL, 'PTHR23130', NULL, NULL, NULL, NULL, 'CYTOCHROME B561 AND DOMON DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(244220, NULL, 'PTHR34930', NULL, NULL, NULL, NULL, 'GEO05313P1', NULL, NULL, 29775, 8),
(244221, NULL, 'PTHR39639', NULL, NULL, NULL, NULL, 'CHROMOSOME 16, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(244222, NULL, 'PTHR46551', NULL, NULL, NULL, NULL, 'SAP DOMAIN-CONTAINING RIBONUCLEOPROTEIN', NULL, NULL, NULL, 8),
(244223, NULL, 'PTHR11697', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR 2-RELATED ZINC FINGER PROTEIN', NULL, NULL, NULL, 8),
(244224, NULL, 'PTHR12128', NULL, NULL, NULL, NULL, 'DIHYDRODIPICOLINATE SYNTHASE', NULL, NULL, 5807, 8),
(244225, NULL, 'PTHR33238', NULL, NULL, NULL, NULL, 'IRON (METAL) DEPENDENT REPRESSOR, DTXR FAMILY', NULL, NULL, NULL, 8),
(244226, NULL, 'PTHR34209', NULL, NULL, NULL, NULL, 'RHODANESE/CELL CYCLE CONTROL PHOSPHATASE SUPERFAMILY PROTEIN', NULL, NULL, 34554, 8),
(244227, NULL, 'PTHR24036', NULL, NULL, NULL, NULL, 'SKELETOR-RELATED', NULL, NULL, NULL, 8),
(244228, NULL, 'PTHR43273', NULL, NULL, NULL, NULL, 'ANAEROBIC SULFATASE-MATURATING ENZYME HOMOLOG ASLB-RELATED', NULL, NULL, 16896, 8),
(244229, NULL, 'PTHR31176', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(244230, NULL, 'PTHR36435', NULL, NULL, NULL, NULL, 'SLR1288 PROTEIN', NULL, NULL, NULL, 8),
(244231, NULL, 'PTHR34491', NULL, NULL, NULL, NULL, 'A-TYPE INCLUSION PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(244232, NULL, 'PTHR21388', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN-RELATED', NULL, NULL, NULL, 8),
(244233, NULL, 'PTHR31095', NULL, NULL, NULL, NULL, 'RIKEN CDNA 9930021J03 GENE', NULL, NULL, 31400, 8),
(244234, NULL, 'PTHR47867', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(244235, NULL, 'PTHR10015', NULL, NULL, NULL, NULL, 'HEAT SHOCK TRANSCRIPTION FACTOR', NULL, NULL, 23969, 8),
(244236, NULL, 'PTHR28342', NULL, NULL, NULL, NULL, 'MONOOXYGENASE P33MONOX-RELATED', NULL, NULL, 24353, 8),
(244237, NULL, 'PTHR45870', NULL, NULL, NULL, NULL, 'TUBULIN MONOGLYCYLASE TTLL3', NULL, NULL, NULL, 8),
(244238, NULL, 'PTHR43975', NULL, NULL, NULL, NULL, 'ZGC:101858', NULL, NULL, NULL, 8),
(244239, NULL, 'PTHR13244', NULL, NULL, NULL, NULL, 'ZINC FINGER MYND DOMAIN CONTAINING PROTEIN 10', NULL, NULL, NULL, 8),
(244240, NULL, 'PTHR46960', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE KEG', NULL, NULL, 36327, 8),
(244241, NULL, 'PTHR46232', NULL, NULL, NULL, NULL, 'SMARCE1 REGULATOR OF CHROMATIN', NULL, NULL, NULL, 8),
(244242, NULL, 'PTHR31506', NULL, NULL, NULL, NULL, 'BES1/BZR1 HOMOLOG PROTEIN 3-RELATED', NULL, NULL, 29126, 8),
(244243, NULL, 'PTHR11501', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN', NULL, NULL, 24976, 8),
(244244, NULL, 'PTHR23100', NULL, NULL, NULL, NULL, 'ARGININE BIOSYNTHESIS BIFUNCTIONAL PROTEIN ARGJ', NULL, NULL, 4625, 8),
(244245, NULL, 'PTHR43383', NULL, NULL, NULL, NULL, 'NODULIN 6', NULL, NULL, NULL, 8),
(244246, NULL, 'PTHR10983', NULL, NULL, NULL, NULL, '1-ACYLGLYCEROL-3-PHOSPHATE ACYLTRANSFERASE-RELATED', NULL, NULL, NULL, 8),
(244247, NULL, 'PTHR31168', NULL, NULL, NULL, NULL, 'OS02G0292800 PROTEIN', NULL, NULL, NULL, 8),
(244248, NULL, 'PTHR24362', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NEK', NULL, NULL, NULL, 8),
(244249, NULL, 'PTHR43767', NULL, NULL, NULL, NULL, 'LONG-CHAIN-FATTY-ACID--COA LIGASE', NULL, NULL, NULL, 8),
(244250, NULL, 'PTHR46397', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY-RELATED', NULL, NULL, NULL, 8),
(244251, NULL, 'PTHR30249', NULL, NULL, NULL, NULL, 'PUTATIVE SEROTONIN TRANSPORTER', NULL, NULL, 48, 8),
(244252, NULL, 'PTHR32204', NULL, NULL, NULL, NULL, 'ATPASE RAVA', NULL, NULL, NULL, 8),
(244253, NULL, 'PTHR31387', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 19', NULL, NULL, 25125, 8),
(244254, NULL, 'PTHR12219', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE', NULL, NULL, 4557, 8),
(244255, NULL, 'PTHR34883', NULL, NULL, NULL, NULL, 'SERINE-RICH PROTEIN, PUTATIVE-RELATED-RELATED', NULL, NULL, NULL, 8),
(244256, NULL, 'PTHR15952', NULL, NULL, NULL, NULL, 'EXPORTIN-T/LOS1', NULL, NULL, 31144, 8),
(244257, NULL, 'PTHR14052', NULL, NULL, NULL, NULL, 'ORIGIN RECOGNITION COMPLEX SUBUNIT 2', NULL, NULL, 6434, 8),
(244258, NULL, 'PTHR11226', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE GLYCOPROTEIN:GLUCOSYLTRANSFERASE', NULL, NULL, 8499, 8);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(244259, NULL, 'PTHR30354', NULL, NULL, NULL, NULL, 'GNT FAMILY GLUCONATE TRANSPORTER', NULL, NULL, 6292, 8),
(244260, NULL, 'PTHR37481', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE EXPORT SYSTEM PROTEIN LPTC', NULL, NULL, NULL, 8),
(244261, NULL, 'PTHR11712', NULL, NULL, NULL, NULL, 'POLYKETIDE SYNTHASE-RELATED', NULL, NULL, 4751, 8),
(244262, NULL, 'PTHR35022', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(244263, NULL, 'PTHR15505', NULL, NULL, NULL, NULL, 'RIIA DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(244264, NULL, 'PTHR20859', NULL, NULL, NULL, NULL, 'INTERFERON/INTERLEUKIN RECEPTOR', NULL, NULL, NULL, 8),
(244265, NULL, 'PTHR13378', NULL, NULL, NULL, NULL, 'REGULATOR COMPLEX PROTEIN LAMTOR3', NULL, NULL, 7513, 8),
(244266, NULL, 'PTHR13107', NULL, NULL, NULL, NULL, 'N6-ADENOSINE-METHYLTRANSFERASE NON-CATALYTIC SUBUNIT', NULL, NULL, 36868, 8),
(244267, NULL, 'PTHR31405', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PDR8-RELATED', NULL, NULL, NULL, 8),
(244268, NULL, 'PTHR35098', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, 27341, 8),
(244269, NULL, 'PTHR13633', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 31268, 8),
(244270, NULL, 'PTHR24211', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(244271, NULL, 'PTHR16788', NULL, NULL, NULL, NULL, 'EPIDIDYMAL SECRETORY PROTEIN E3 ALPHA', NULL, NULL, 34934, 8),
(244272, NULL, 'PTHR17008', NULL, NULL, NULL, NULL, 'MEIOSIS-EXPRESSED GENE 1 PROTEIN', NULL, NULL, 17679, 8),
(244273, NULL, 'PTHR31324', NULL, NULL, NULL, NULL, 'MORF4 FAMILY-ASSOCIATED PROTEIN 1-RELATED', NULL, NULL, 21994, 8),
(244274, NULL, 'PTHR15289', NULL, NULL, NULL, NULL, 'TASTIN', NULL, NULL, 25661, 8),
(244275, NULL, 'PTHR16007', NULL, NULL, NULL, NULL, 'EPIDIDYMAL MEMBRANE PROTEIN E9-RELATED', NULL, NULL, 35430, 8),
(244276, NULL, 'PTHR36863', NULL, NULL, NULL, NULL, 'SHIELDIN COMPLEX SUBUNIT 1', NULL, NULL, 22493, 8),
(244277, NULL, 'PTHR35446', NULL, NULL, NULL, NULL, 'SI:CH211-175M2.5', NULL, NULL, NULL, 8),
(244278, NULL, 'PTHR30345', NULL, NULL, NULL, NULL, 'RIBOSE-5-PHOSPHATE ISOMERASE B', NULL, NULL, 6482, 8),
(244279, NULL, 'PTHR40980', NULL, NULL, NULL, NULL, 'PLUG DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(244280, NULL, 'PTHR10623', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN RP/EB FAMILY MEMBER', NULL, NULL, 24626, 8),
(244281, NULL, 'PTHR46198', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE-PHOSPHATASE', NULL, NULL, 7843, 8),
(244282, NULL, 'PTHR37958', NULL, NULL, NULL, NULL, 'SODIUM-POTASSIUM/PROTON ANTIPORTER CHAA', NULL, NULL, NULL, 8),
(244283, NULL, 'PTHR35851', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN FTSQ', NULL, NULL, 25433, 8),
(244284, NULL, 'PTHR45570', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', NULL, NULL, NULL, 8),
(244285, NULL, 'PTHR19932', NULL, NULL, NULL, NULL, 'WD REPEAT AND HMG-BOX DNA BINDING PROTEIN', NULL, NULL, NULL, 8),
(244286, NULL, 'PTHR35660', NULL, NULL, NULL, NULL, 'SERINE-RICH AND TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, 23689, 8),
(244287, NULL, 'PTHR43808', NULL, NULL, NULL, NULL, 'ACETYLORNITHINE DEACETYLASE', NULL, NULL, NULL, 8),
(244288, NULL, 'PTHR14179', NULL, NULL, NULL, NULL, 'SMR1-RELATED', NULL, NULL, 22633, 8),
(244289, NULL, 'PTHR14735', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 25788, 8),
(244290, NULL, 'PTHR12307', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT', NULL, NULL, NULL, 8),
(244291, NULL, 'PTHR40021', NULL, NULL, NULL, NULL, 'DEFECT AT LOW TEMPERATURE PROTEIN 1', NULL, NULL, 32449, 8),
(244292, NULL, 'PTHR13554', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 5-RELATED', NULL, NULL, 19351, 8),
(244293, NULL, 'PTHR13035', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 27432, 8),
(244294, NULL, 'PTHR12183', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL UBIQUITIN LIGASE ACTIVATOR OF NFKB 1', NULL, NULL, NULL, 8),
(244295, NULL, 'PTHR13289', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1-BINDING PROTEIN BIFOCAL', NULL, NULL, 17909, 8);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(244296, NULL, 'PTHR31426', NULL, NULL, NULL, NULL, 'GROUP II INTRON SPLICING FACTOR CRS1-LIKE', NULL, NULL, 31693, 8),
(244297, NULL, 'PTHR23112', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR 157-RELATED', NULL, NULL, NULL, 8),
(244298, NULL, 'PTHR24322', NULL, NULL, NULL, NULL, 'PKSB', NULL, NULL, NULL, 8),
(244299, NULL, 'PTHR22427', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(244300, NULL, 'PTHR20995', NULL, NULL, NULL, NULL, 'F-BOX/WD REPEAT-CONTAINING PROTEIN 5', NULL, NULL, 36803, 8),
(244301, NULL, 'PTHR48155', NULL, NULL, NULL, NULL, 'OS09G0497600 PROTEIN', NULL, NULL, NULL, 8),
(244302, NULL, 'PTHR10331', NULL, NULL, NULL, NULL, 'T COMPLEX PROTEIN 10', NULL, NULL, 26912, 8),
(244303, NULL, 'PTHR22918', NULL, NULL, NULL, NULL, 'SEMINAL PLASMA PROTEIN', NULL, NULL, NULL, 8),
(244304, NULL, 'PTHR36572', NULL, NULL, NULL, NULL, 'DNA DAMAGE-INDUCIBLE PROTEIN I-RELATED', NULL, NULL, 9028, 8),
(244305, NULL, 'PTHR12929', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 52', NULL, NULL, 14242, 8),
(244306, NULL, 'PTHR30625', NULL, NULL, NULL, NULL, 'PROTEIN TOLQ', NULL, NULL, NULL, 8),
(244307, NULL, 'PTHR12419', NULL, NULL, NULL, NULL, 'OTU DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(244308, NULL, 'PTHR13398', NULL, NULL, NULL, NULL, 'GDP-FUCOSE PROTEIN O-FUCOSYLTRANSFERASE 2', NULL, NULL, 36777, 8),
(244309, NULL, 'PTHR40596', NULL, NULL, NULL, NULL, 'CITRATE LYASE ALPHA CHAIN', NULL, NULL, 6450, 8),
(244310, NULL, 'PTHR47223', NULL, NULL, NULL, NULL, 'SPERM ACROSOME MEMBRANE-ASSOCIATED PROTEIN 1', NULL, NULL, 27077, 8),
(244311, NULL, 'PTHR13937', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITATION FACTOR 3, SUBUNIT 8  EIF3S8 -RELATED', NULL, NULL, 23871, 8),
(244312, NULL, 'PTHR45801', NULL, NULL, NULL, NULL, 'OS07G0101800 PROTEIN', NULL, NULL, NULL, 8),
(244313, NULL, 'PTHR12416', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(244314, NULL, 'PTHR27005', NULL, NULL, NULL, NULL, 'WALL-ASSOCIATED RECEPTOR KINASE-LIKE 21', NULL, NULL, 37338, 8),
(244315, NULL, 'PTHR30344', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONOLACTONASE-RELATED', NULL, NULL, NULL, 8),
(244316, NULL, 'PTHR42978', NULL, NULL, NULL, NULL, 'QUORUM-QUENCHING LACTONASE YTNP-RELATED-RELATED', NULL, NULL, NULL, 8),
(244317, NULL, 'PTHR39479', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244318, NULL, 'PTHR15438', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX INTERACTING PROTEIN', NULL, NULL, 8024, 8),
(244319, NULL, 'PTHR36327', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', NULL, NULL, NULL, 8),
(244320, NULL, 'PTHR35753', NULL, NULL, NULL, NULL, 'PROTEIN MAINTENANCE OF PSII UNDER HIGH LIGHT 1', NULL, NULL, 29812, 8),
(244321, NULL, 'PTHR12338', NULL, NULL, NULL, NULL, 'AUTOTRANSPORTER', NULL, NULL, NULL, 8),
(244322, NULL, 'PTHR34722', NULL, NULL, NULL, NULL, 'HOMOLOG OF ODR-2 (TWO)-RELATED', NULL, NULL, 8317, 8),
(244323, NULL, 'PTHR13024', NULL, NULL, NULL, NULL, 'MICROSOMAL TRIGLYCERIDE TRANSFER PROTEIN, LARGE SUBUNIT', NULL, NULL, 30175, 8),
(244324, NULL, 'PTHR14628', NULL, NULL, NULL, NULL, 'BEN DOMAIN-CONTAINING PROTEIN 5', NULL, NULL, 30162, 8),
(244325, NULL, 'PTHR13232', NULL, NULL, NULL, NULL, 'NAD(P)H-HYDRATE EPIMERASE', NULL, NULL, 25484, 8),
(244326, NULL, 'PTHR40381', NULL, NULL, NULL, NULL, 'PEROXISOMAL TESTIS-SPECIFIC PROTEIN 1', NULL, NULL, 21689, 8),
(244327, NULL, 'PTHR24205', NULL, NULL, NULL, NULL, 'FOUR AND A HALF LIM DOMAINS PROTEIN', NULL, NULL, 32008, 8),
(244328, NULL, 'PTHR38525', NULL, NULL, NULL, NULL, 'OS03G0824500 PROTEIN', NULL, NULL, NULL, 8),
(244329, NULL, 'PTHR23313', NULL, NULL, NULL, NULL, 'TSEC1-RELATED', NULL, NULL, NULL, 8),
(244330, NULL, 'PTHR47244', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE-PHOSPHATASE IBR5', NULL, NULL, 34538, 8),
(244331, NULL, 'PTHR10948', NULL, NULL, NULL, NULL, 'TRANSPOSASE', NULL, NULL, NULL, 8),
(244332, NULL, 'PTHR21437', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 32966, 8),
(244333, NULL, 'PTHR12967', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 31213, 8),
(244334, NULL, 'PTHR47591', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZAT2-RELATED', NULL, NULL, NULL, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(244335, NULL, 'PTHR33622', NULL, NULL, NULL, NULL, 'OS03G0724500 PROTEIN', NULL, NULL, NULL, 8),
(244336, NULL, 'PTHR39193', NULL, NULL, NULL, NULL, '5-DEOXY-GLUCURONATE ISOMERASE', NULL, NULL, 13792, 8),
(244337, NULL, 'PTHR36541', NULL, NULL, NULL, NULL, 'SUPEROXIDE REDUCTASE-RELATED', NULL, NULL, NULL, 8),
(244338, NULL, 'PTHR43034', NULL, NULL, NULL, NULL, 'ION-TRANSLOCATING OXIDOREDUCTASE COMPLEX SUBUNIT C', NULL, NULL, 4333, 8),
(244339, NULL, 'PTHR22605', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 21537, 8),
(244340, NULL, 'PTHR47925', NULL, NULL, NULL, NULL, 'OS01G0913400 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(244341, NULL, 'PTHR42741', NULL, NULL, NULL, NULL, 'NITROREDUCTASE FAMILY PROTEIN', NULL, NULL, NULL, 8),
(244342, NULL, 'PTHR41386', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN-RELATED', NULL, NULL, 9206, 8),
(244343, NULL, 'PTHR13278', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 27037, 8),
(244344, NULL, 'PTHR31216', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS BETA-1-RELATED-RELATED', NULL, NULL, 5672, 8),
(244345, NULL, 'PTHR44468', NULL, NULL, NULL, NULL, 'COXSACKIEVIRUS AND ADENOVIRUS RECEPTOR-RELATED', NULL, NULL, NULL, 8),
(244346, NULL, 'PTHR36194', NULL, NULL, NULL, NULL, 'S-LAYER-LIKE PROTEIN', NULL, NULL, NULL, 8),
(244347, NULL, 'PTHR16276', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT DOMAIN-CONTAINING PROTEIN 3', NULL, NULL, 29082, 8),
(244348, NULL, 'PTHR15869', NULL, NULL, NULL, NULL, 'ENDOMUCIN-RELATED', NULL, NULL, 9572, 8),
(244349, NULL, 'PTHR36807', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCOLATE PHOSPHATASE', NULL, NULL, NULL, 8),
(244350, NULL, 'PTHR46503', NULL, NULL, NULL, NULL, 'INTER-ALPHA-TRYPSIN INHIBITOR HEAVY CHAIN-LIKE PROTEIN', NULL, NULL, NULL, 8),
(244351, NULL, 'PTHR35518', NULL, NULL, NULL, NULL, 'MAINTENANCE OF TELOMOERE CAPPING', NULL, NULL, NULL, 8),
(244352, NULL, 'PTHR35491', NULL, NULL, NULL, NULL, 'OS12G0638500-LIKE PROTEIN', NULL, NULL, NULL, 8),
(244353, NULL, 'PTHR12587', NULL, NULL, NULL, NULL, 'LAR INTERACTING PROTEIN  LIP -RELATED PROTEIN', NULL, NULL, 22434, 8),
(244354, NULL, 'PTHR36326', NULL, NULL, NULL, NULL, 'PROTEIN POLLENLESS 3-LIKE 2', NULL, NULL, 36731, 8),
(244355, NULL, 'PTHR41729', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA SYNTHETASE', NULL, NULL, 23260, 8),
(244356, NULL, 'PTHR14499', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL TETRAMERIZATION DOMAIN-CONTAINING', NULL, NULL, NULL, 8),
(244357, NULL, 'PTHR42842', NULL, NULL, NULL, NULL, 'FAD/NAD(P)-BINDING OXIDOREDUCTASE', NULL, NULL, 2171, 8),
(244358, NULL, 'PTHR47411', NULL, NULL, NULL, NULL, 'B3GNT1, BETA-1,3-N-ACETYLGUCOSAMINYLTRANSFERASE 1, HOMOLOG', NULL, NULL, NULL, 8),
(244359, NULL, 'PTHR42832', NULL, NULL, NULL, NULL, 'AMINO ACID AMINOTRANSFERASE', NULL, NULL, NULL, 8),
(244360, NULL, 'PTHR19851', NULL, NULL, NULL, NULL, 'OS02G0203500 PROTEIN', NULL, NULL, NULL, 8),
(244361, NULL, 'PTHR33700', NULL, NULL, NULL, NULL, 'MYB-LIKE PROTEIN X', NULL, NULL, NULL, 8),
(244362, NULL, 'PTHR12961', NULL, NULL, NULL, NULL, 'CONSERVED OLIGOMERIC GOLGI COMPLEX COMPONENT 2', NULL, NULL, 14404, 8),
(244363, NULL, 'PTHR15682', NULL, NULL, NULL, NULL, 'UNHEALTHY RIBOSOME BIOGENESIS PROTEIN 2 HOMOLOG', NULL, NULL, NULL, 8),
(244364, NULL, 'PTHR15459', NULL, NULL, NULL, NULL, 'POLYAMINE-MODULATED FACTOR 1', NULL, NULL, 396, 8),
(244365, NULL, 'PTHR12876', NULL, NULL, NULL, NULL, 'N4BP1-RELATED', NULL, NULL, NULL, 8),
(244366, NULL, 'PTHR35507', NULL, NULL, NULL, NULL, 'OS09G0488600 PROTEIN', NULL, NULL, NULL, 8),
(244367, NULL, 'PTHR46030', NULL, NULL, NULL, NULL, 'ALPHA-KETOGLUTARATE-DEPENDENT DIOXYGENASE ALKB HOMOLOG 6', NULL, NULL, 23133, 8),
(244368, NULL, 'PTHR31504', NULL, NULL, NULL, NULL, 'ZW10 INTERACTOR ZWINT', NULL, NULL, 25371, 8),
(244369, NULL, 'PTHR11048', NULL, NULL, NULL, NULL, 'PRENYLTRANSFERASES', NULL, NULL, 27273, 8),
(244370, NULL, 'PTHR45666', NULL, NULL, NULL, NULL, 'TYPE IV INOSITOL POLYPHOSPHATE 5-PHOSPHATASE 9', NULL, NULL, 36010, 8),
(244371, NULL, 'PTHR31678', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 6-3', NULL, NULL, 31149, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(244372, NULL, 'PTHR30347', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL RELATED', NULL, NULL, NULL, 8),
(244373, NULL, 'PTHR43397', NULL, NULL, NULL, NULL, 'ERGOTHIONEINE BIOSYNTHESIS PROTEIN 1', NULL, NULL, NULL, 8),
(244374, NULL, 'PTHR22949', NULL, NULL, NULL, NULL, 'WHITE COLLAR 2 PROTEIN  WC2', NULL, NULL, NULL, 8),
(244375, NULL, 'PTHR47552', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLFORMYLGLYCINAMIDINE SYNTHASE SUBUNIT PURQ', NULL, NULL, NULL, 8),
(244376, NULL, 'PTHR36011', NULL, NULL, NULL, NULL, 'BAT2 DOMAIN PROTEIN', NULL, NULL, NULL, 8),
(244377, NULL, 'PTHR21053', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 32685, 8),
(244378, NULL, 'PTHR45667', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE MITOCHONDRIAL CARRIER PROTEIN', NULL, NULL, NULL, 8),
(244379, NULL, 'PTHR12764', NULL, NULL, NULL, NULL, 'WD REPEAT DOMAIN-RELATED', NULL, NULL, 31415, 8),
(244380, NULL, 'PTHR35901', NULL, NULL, NULL, NULL, 'RIBONUCLEASE VAPC3', NULL, NULL, NULL, 8),
(244381, NULL, 'PTHR43063', NULL, NULL, NULL, NULL, '4FE-4S CLUSTER CONTAINING PARA FAMILY ATPASE PROTEIN', NULL, NULL, NULL, 8),
(244382, NULL, 'PTHR43201', NULL, NULL, NULL, NULL, 'ACYL-COA SYNTHETASE', NULL, NULL, NULL, 8),
(244383, NULL, 'PTHR36407', NULL, NULL, NULL, NULL, 'MEDIATOR-ASSOCIATED PROTEIN 2', NULL, NULL, 30531, 8),
(244384, NULL, 'PTHR43834', NULL, NULL, NULL, NULL, 'GTPASE DER', NULL, NULL, NULL, 8),
(244385, NULL, 'PTHR37563', NULL, NULL, NULL, NULL, 'PHYTANOYL-COA DIOXYGENASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_2G03330)', NULL, NULL, NULL, 8),
(244386, NULL, 'PTHR36335', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(244387, NULL, 'PTHR35537', NULL, NULL, NULL, NULL, 'DNA DAMAGE-INDUCIBLE APOPTOSIS SUPPRESSOR PROTEIN DDIAS', NULL, NULL, 35822, 8),
(244388, NULL, 'PTHR35674', NULL, NULL, NULL, NULL, 'CDNA SEQUENCE CK137956', NULL, NULL, 25350, 8),
(244389, NULL, 'PTHR34130', NULL, NULL, NULL, NULL, 'OS08G0243800 PROTEIN', NULL, NULL, NULL, 8),
(244390, NULL, 'PTHR33618', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L53, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(244391, NULL, 'PTHR47392', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 82-RELATED', NULL, NULL, 34467, 8),
(244392, NULL, 'PTHR47030', NULL, NULL, NULL, NULL, 'LIPASE CLASS 3 FAMILY PROTEIN', NULL, NULL, NULL, 8),
(244393, NULL, 'PTHR43523', NULL, NULL, NULL, NULL, 'GLUCOSE-1-PHOSPHATE ADENYLYLTRANSFERASE-RELATED', NULL, NULL, 13890, 8),
(244394, NULL, 'PTHR34988', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(244395, NULL, 'PTHR35825', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT ALPHA PRIME-INTERACTING PROTEIN', NULL, NULL, 30613, 8),
(244396, NULL, 'PTHR22897', NULL, NULL, NULL, NULL, 'QUIESCIN Q6-RELATED SULFHYDRYL OXIDASE', NULL, NULL, 27243, 8),
(244397, NULL, 'PTHR39610', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244398, NULL, 'PTHR34856', NULL, NULL, NULL, NULL, 'PROTEIN NRFD', NULL, NULL, NULL, 8),
(244399, NULL, 'PTHR14689', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(244400, NULL, 'PTHR44914', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ 13', NULL, NULL, 34874, 8),
(244401, NULL, 'PTHR19860', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 12-RELATED', NULL, NULL, NULL, 8),
(244402, NULL, 'PTHR28034', NULL, NULL, NULL, NULL, 'SET1 COMPLEX COMPONENT SHG1', NULL, NULL, NULL, 8),
(244403, NULL, 'PTHR12631', NULL, NULL, NULL, NULL, 'ALPHA-L-IDURONIDASE', NULL, NULL, NULL, 8),
(244404, NULL, 'PTHR28004', NULL, NULL, NULL, NULL, 'ZGC:162816-RELATED', NULL, NULL, NULL, 8),
(244405, NULL, 'PTHR31138', NULL, NULL, NULL, NULL, 'CHROMOSOME 19, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(244406, NULL, 'PTHR15011', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN F', NULL, NULL, 25872, 8),
(244407, NULL, 'PTHR13091', NULL, NULL, NULL, NULL, 'AMPLIFIED IN BREAST CANCER 2-RELATED', NULL, NULL, 25542, 8),
(244408, NULL, 'PTHR14087', NULL, NULL, NULL, NULL, 'THYMOCYTE NUCLEAR PROTEIN 1', NULL, NULL, NULL, 8),
(244409, NULL, 'PTHR37184', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 27', NULL, NULL, 27445, 8);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(244410, NULL, 'PTHR37474', NULL, NULL, NULL, NULL, 'RNA LIGASE/CYCLIC NUCLEOTIDE PHOSPHODIESTERASE', NULL, NULL, NULL, 8),
(244411, NULL, 'PTHR12466', NULL, NULL, NULL, NULL, 'CDC73 DOMAIN PROTEIN', NULL, NULL, 2137, 8),
(244412, NULL, 'PTHR13248', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR B POLYPEPTIDE 2', NULL, NULL, 32710, 8),
(244413, NULL, 'PTHR33836', NULL, NULL, NULL, NULL, 'LOW-TEMPERATURE-INDUCED 65 KDA PROTEIN-RELATED', NULL, NULL, 32864, 8),
(244414, NULL, 'PTHR13159', NULL, NULL, NULL, NULL, 'RADIAL SPOKEHEAD-RELATED', NULL, NULL, 3641, 8),
(244415, NULL, 'PTHR46928', NULL, NULL, NULL, NULL, 'MESENCHYME-SPECIFIC CELL SURFACE GLYCOPROTEIN', NULL, NULL, NULL, 8),
(244416, NULL, 'PTHR47162', NULL, NULL, NULL, NULL, 'OS02G0192300 PROTEIN', NULL, NULL, NULL, 8),
(244417, NULL, 'PTHR34355', NULL, NULL, NULL, NULL, 'JOSEPHIN-LIKE PROTEIN', NULL, NULL, NULL, 8),
(244418, NULL, 'PTHR37807', NULL, NULL, NULL, NULL, 'OS07G0160300 PROTEIN', NULL, NULL, NULL, 8),
(244419, NULL, 'PTHR35163', NULL, NULL, NULL, NULL, 'OS02G0467300 PROTEIN', NULL, NULL, NULL, 8),
(244420, NULL, 'PTHR13168', NULL, NULL, NULL, NULL, 'ASSOCIATE OF C-MYC  AMY-1', NULL, NULL, 24407, 8),
(244421, NULL, 'PTHR16198', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(244422, NULL, 'PTHR33620', NULL, NULL, NULL, NULL, 'UREASE ACCESSORY PROTEIN F', NULL, NULL, NULL, 8),
(244423, NULL, 'PTHR12411', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEASE FAMILY C1-RELATED', NULL, NULL, NULL, 8),
(244424, NULL, 'PTHR35768', NULL, NULL, NULL, NULL, 'PROTEIN MULTIPOLAR SPINDLE 1', NULL, NULL, 32542, 8),
(244425, NULL, 'PTHR33866', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE DECARBOXYLASE PROENZYME', NULL, NULL, 3195, 8),
(244426, NULL, 'PTHR47603', NULL, NULL, NULL, NULL, 'PPR CONTAINING-LIKE PROTEIN', NULL, NULL, NULL, 8),
(244427, NULL, 'PTHR45788', NULL, NULL, NULL, NULL, 'SUCCINATE/FUMARATE MITOCHONDRIAL TRANSPORTER-RELATED', NULL, NULL, NULL, 8),
(244428, NULL, 'PTHR37170', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-RELATED', NULL, NULL, NULL, 8),
(244429, NULL, 'PTHR35310', NULL, NULL, NULL, NULL, 'CELL WALL INTEGRITY/STRESS RESPONSE COMPONENT-LIKE PROTEIN', NULL, NULL, NULL, 8),
(244430, NULL, 'PTHR28035', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL DISTRIBUTION AND MORPHOLOGY PROTEIN 10', NULL, NULL, 23916, 8),
(244431, NULL, 'PTHR22684', NULL, NULL, NULL, NULL, 'NULP1-RELATED', NULL, NULL, 5527, 8),
(244432, NULL, 'PTHR34849', NULL, NULL, NULL, NULL, 'SSL5025 PROTEIN', NULL, NULL, NULL, 8),
(244433, NULL, 'PTHR23273', NULL, NULL, NULL, NULL, 'REPLICATION FACTOR A 1, RFA1', NULL, NULL, 751, 8),
(244434, NULL, 'PTHR35158', NULL, NULL, NULL, NULL, 'CDNA SEQUENCE CN725425', NULL, NULL, 23752, 8),
(244435, NULL, 'PTHR35401', NULL, NULL, NULL, NULL, 'COPG FAMILY HELIX-TURN-HELIX PROTEIN-RELATED-RELATED', NULL, NULL, 11427, 8),
(244436, NULL, 'PTHR28250', NULL, NULL, NULL, NULL, 'CYTOCHROME B PRE-MRNA-PROCESSING PROTEIN 6', NULL, NULL, 31091, 8),
(244437, NULL, 'PTHR48239', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244438, NULL, 'PTHR35046', NULL, NULL, NULL, NULL, 'ZINC KNUCKLE (CCHC-TYPE) FAMILY PROTEIN', NULL, NULL, NULL, 8),
(244439, NULL, 'PTHR37743', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(244440, NULL, 'PTHR30510', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 2418, 8),
(244441, NULL, 'PTHR33653', NULL, NULL, NULL, NULL, 'RIBONUCLEASE VAPC2', NULL, NULL, NULL, 8),
(244442, NULL, 'PTHR35976', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN J', NULL, NULL, NULL, 8),
(244443, NULL, 'PTHR35528', NULL, NULL, NULL, NULL, 'BLL1675 PROTEIN', NULL, NULL, NULL, 8),
(244444, NULL, 'PTHR12778', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 33  ACETYL-COA TRANSPORTER -RELATED', NULL, NULL, 5458, 8),
(244445, NULL, 'PTHR24284', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY', NULL, NULL, NULL, 8),
(244446, NULL, 'PTHR37048', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244447, NULL, 'PTHR21633', NULL, NULL, NULL, NULL, 'IQ MOTIF CONTAINING F', NULL, NULL, 27022, 8);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(244448, NULL, 'PTHR11877', NULL, NULL, NULL, NULL, 'HYDROXYMETHYLGLUTARYL-COA SYNTHASE', NULL, NULL, 10247, 8),
(244449, NULL, 'PTHR16518', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 153, 162', NULL, NULL, 15157, 8),
(244450, NULL, 'PTHR10638', NULL, NULL, NULL, NULL, 'COPPER AMINE OXIDASE', NULL, NULL, 771, 8),
(244451, NULL, 'PTHR11726', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L10', NULL, NULL, 1491, 8),
(244452, NULL, 'PTHR36078', NULL, NULL, NULL, NULL, 'BNACNNG21220D PROTEIN', NULL, NULL, NULL, 8),
(244453, NULL, 'PTHR30353', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN DEDA-RELATED', NULL, NULL, 25499, 8),
(244454, NULL, 'PTHR11703', NULL, NULL, NULL, NULL, 'DEOXYHYPUSINE SYNTHASE', NULL, NULL, 4674, 8),
(244455, NULL, 'PTHR30445', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(244456, NULL, 'PTHR15914', NULL, NULL, NULL, NULL, 'ALPHA-HEMOGLOBIN-STABILIZING PROTEIN', NULL, NULL, 13234, 8),
(244457, NULL, 'PTHR30244', NULL, NULL, NULL, NULL, 'TRANSAMINASE', NULL, NULL, 4124, 8),
(244458, NULL, 'PTHR11091', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE-RELATED', NULL, NULL, 2438, 8),
(244459, NULL, 'PTHR40518', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244460, NULL, 'PTHR10993', NULL, NULL, NULL, NULL, 'OCTANOYLTRANSFERASE', NULL, NULL, NULL, 8),
(244461, NULL, 'PTHR45916', NULL, NULL, NULL, NULL, 'STRUCTURAL MAINTENANCE OF CHROMOSOMES PROTEIN 5', NULL, NULL, 22465, 8),
(244462, NULL, 'PTHR14386', NULL, NULL, NULL, NULL, 'PROTEIN FAM204A', NULL, NULL, 28671, 8),
(244463, NULL, 'PTHR28540', NULL, NULL, NULL, NULL, 'BCL2-ASSOCIATED AGONIST OF CELL DEATH', NULL, NULL, 20646, 8),
(244464, NULL, 'PTHR11049', NULL, NULL, NULL, NULL, 'ACYL COENZYME A THIOESTER HYDROLASE', NULL, NULL, 27476, 8),
(244465, NULL, 'PTHR43686', NULL, NULL, NULL, NULL, 'SULFURTRANSFERASE-RELATED', NULL, NULL, NULL, 8),
(244466, NULL, 'PTHR40130', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(244467, NULL, 'PTHR46583', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING 22', NULL, NULL, 35831, 8),
(244468, NULL, 'PTHR38032', NULL, NULL, NULL, NULL, 'POLYMERASE-RELATED', NULL, NULL, 2958, 8),
(244469, NULL, 'PTHR48051', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244470, NULL, 'PTHR33240', NULL, NULL, NULL, NULL, 'OS08G0508500 PROTEIN', NULL, NULL, NULL, 8),
(244471, NULL, 'PTHR24567', NULL, NULL, NULL, NULL, 'CRP FAMILY TRANSCRIPTIONAL REGULATORY PROTEIN', NULL, NULL, NULL, 8),
(244472, NULL, 'PTHR45824', NULL, NULL, NULL, NULL, 'GH16843P', NULL, NULL, NULL, 8),
(244473, NULL, 'PTHR10430', NULL, NULL, NULL, NULL, 'PEROXIREDOXIN', NULL, NULL, 29516, 8),
(244474, NULL, 'PTHR37306', NULL, NULL, NULL, NULL, 'COLICIN V PRODUCTION PROTEIN', NULL, NULL, NULL, 8),
(244475, NULL, 'PTHR23060', NULL, NULL, NULL, NULL, 'TESTIS EXPRESSED GENE 14', NULL, NULL, 33281, 8),
(244476, NULL, 'PTHR11742', NULL, NULL, NULL, NULL, 'MANNOSYL-OLIGOSACCHARIDE ALPHA-1,2-MANNOSIDASE-RELATED', NULL, NULL, NULL, 8),
(244477, NULL, 'PTHR47900', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 131A', NULL, NULL, NULL, 8),
(244478, NULL, 'PTHR32094', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA GROUP E PROTEIN', NULL, NULL, 27604, 8),
(244479, NULL, 'PTHR42155', NULL, NULL, NULL, NULL, 'CATION CHANNEL SPERM-ASSOCIATED PROTEIN SUBUNIT ZETA', NULL, NULL, 31827, 8),
(244480, NULL, 'PTHR48257', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244481, NULL, 'PTHR43210', NULL, NULL, NULL, NULL, 'DETHIOBIOTIN SYNTHETASE', NULL, NULL, 7060, 8),
(244482, NULL, 'PTHR36433', NULL, NULL, NULL, NULL, 'HYPOTHETICAL CYTOSOLIC PROTEIN', NULL, NULL, 363, 8),
(244483, NULL, 'PTHR34462', NULL, NULL, NULL, NULL, 'OS05G0587400 PROTEIN', NULL, NULL, NULL, 8),
(244484, NULL, 'PTHR46188', NULL, NULL, NULL, NULL, 'BOLA-LIKE PROTEIN 3', NULL, NULL, NULL, 8),
(244485, NULL, 'PTHR34179', NULL, NULL, NULL, NULL, 'TUMOR PROTEIN P53-INDUCIBLE PROTEIN 13', NULL, NULL, NULL, 8),
(244486, NULL, 'PTHR42970', NULL, NULL, NULL, NULL, 'PECTATE LYASE C-RELATED', NULL, NULL, NULL, 8),
(244487, NULL, 'PTHR17070', NULL, NULL, NULL, NULL, 'DEXAMETHASONE-INDUCED PROTEIN', NULL, NULL, 18781, 8);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(244488, NULL, 'PTHR12811', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING VPS16', NULL, NULL, 16229, 8),
(244489, NULL, 'PTHR33976', NULL, NULL, NULL, NULL, 'OS07G0645000 PROTEIN', NULL, NULL, 37051, 8),
(244490, NULL, 'PTHR11820', NULL, NULL, NULL, NULL, 'ACYLPYRUVASE', NULL, NULL, NULL, 8),
(244491, NULL, 'PTHR35279', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244492, NULL, 'PTHR22941', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR', NULL, NULL, NULL, 8),
(244493, NULL, 'PTHR23114', NULL, NULL, NULL, NULL, 'M7GPPPN-MRNA HYDROLASE', NULL, NULL, NULL, 8),
(244494, NULL, 'PTHR14003', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR PROTEIN YY', NULL, NULL, NULL, 8),
(244495, NULL, 'PTHR33470', NULL, NULL, NULL, NULL, 'OS01G0164075 PROTEIN', NULL, NULL, NULL, 8),
(244496, NULL, 'PTHR11848', NULL, NULL, NULL, NULL, 'TGF-BETA FAMILY', NULL, NULL, 17443, 8),
(244497, NULL, 'PTHR47184', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 3-AND 4-KINASE FAMILY PROTEIN-RELATED', NULL, NULL, NULL, 8),
(244498, NULL, 'PTHR13651', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 31143, 8),
(244499, NULL, 'PTHR43054', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244500, NULL, 'PTHR31704', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DNA-BINDING DOMAIN PROTEIN-RELATED', NULL, NULL, NULL, 8),
(244501, NULL, 'PTHR47477', NULL, NULL, NULL, NULL, 'TNF RECEPTOR-ASSOCIATED FACTOR HOMOLOG 1A', NULL, NULL, NULL, 8),
(244502, NULL, 'PTHR36914', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244503, NULL, 'PTHR45806', NULL, NULL, NULL, NULL, 'SYNAPTOBREVIN HOMOLOG YKT6', NULL, NULL, NULL, 8),
(244504, NULL, 'PTHR31045', NULL, NULL, NULL, NULL, 'PLAC8 FAMILY PROTEIN-RELATED', NULL, NULL, NULL, 8),
(244505, NULL, 'PTHR35740', NULL, NULL, NULL, NULL, 'OS12G0111700 PROTEIN', NULL, NULL, NULL, 8),
(244506, NULL, 'PTHR22839', NULL, NULL, NULL, NULL, 'THO COMPLEX SUBUNIT 3  THO3', NULL, NULL, 27175, 8),
(244507, NULL, 'PTHR37347', NULL, NULL, NULL, NULL, 'MEGAKARYOCYTE AND PLATELET INHIBITORY RECEPTOR G6B', NULL, NULL, 26577, 8),
(244508, NULL, 'PTHR45821', NULL, NULL, NULL, NULL, 'SNF2 DOMAIN-CONTAINING PROTEIN CLASSY 2-RELATED', NULL, NULL, 36337, 8),
(244509, NULL, 'PTHR14392', NULL, NULL, NULL, NULL, 'NIBAN FAMILY MEMBER', NULL, NULL, 21989, 8),
(244510, NULL, 'PTHR21356', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT CONTAINING 2', NULL, NULL, 31153, 8),
(244511, NULL, 'PTHR32191', NULL, NULL, NULL, NULL, 'TETRASPANIN-8-RELATED', NULL, NULL, 36554, 8),
(244512, NULL, 'PTHR33215', NULL, NULL, NULL, NULL, 'PROTEIN DISTAL ANTENNA', NULL, NULL, NULL, 8),
(244513, NULL, 'PTHR47361', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(244514, NULL, 'PTHR10142', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN COMPLEMENTING XP-A CELLS', NULL, NULL, 6723, 8),
(244515, NULL, 'PTHR47012', NULL, NULL, NULL, NULL, 'LAMIN TAIL DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, 35286, 8),
(244516, NULL, 'PTHR34044', NULL, NULL, NULL, NULL, 'NUCLEAR PROTEIN', NULL, NULL, NULL, 8),
(244517, NULL, 'PTHR36679', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE S', NULL, NULL, 25271, 8),
(244518, NULL, 'PTHR14625', NULL, NULL, NULL, NULL, 'MICROCEPHALIN', NULL, NULL, 20366, 8),
(244519, NULL, 'PTHR46543', NULL, NULL, NULL, NULL, 'ZINC FINGER CCHC DOMAIN-CONTAINING PROTEIN 7', NULL, NULL, NULL, 8),
(244520, NULL, 'PTHR48163', NULL, NULL, NULL, NULL, 'BNAC02G25670D PROTEIN', NULL, NULL, NULL, 8),
(244521, NULL, 'PTHR36445', NULL, NULL, NULL, NULL, 'GTP CYCLOHYDROLASE MPTA', NULL, NULL, 3453, 8),
(244522, NULL, 'PTHR21094', NULL, NULL, NULL, NULL, 'GOS-28 SNARE- RELATED', NULL, NULL, 16284, 8),
(244523, NULL, 'PTHR31803', NULL, NULL, NULL, NULL, 'ALTERNATIVE OXIDASE', NULL, NULL, 2676, 8),
(244524, NULL, 'PTHR20883', NULL, NULL, NULL, NULL, 'PHYTANOYL-COA DIOXYGENASE DOMAIN CONTAINING 1', NULL, NULL, NULL, 8),
(244525, NULL, 'PTHR40074', NULL, NULL, NULL, NULL, 'O-ACETYLTRANSFERASE WECH', NULL, NULL, NULL, 8),
(244526, NULL, 'PTHR33173', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244527, NULL, 'PTHR44252', NULL, NULL, NULL, NULL, 'D-ERYTHRULOSE REDUCTASE', NULL, NULL, NULL, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(244528, NULL, 'PTHR33670', NULL, NULL, NULL, NULL, 'SPLICING FACTOR, PROLINE- AND GLUTAMINE-RICH-LIKE', NULL, NULL, NULL, 8),
(244529, NULL, 'PTHR15126', NULL, NULL, NULL, NULL, 'SH3-BINDING', NULL, NULL, 32367, 8),
(244530, NULL, 'PTHR21359', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 32976, 8),
(244531, NULL, 'PTHR45909', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-RELATED PROTEIN 1', NULL, NULL, NULL, 8),
(244532, NULL, 'PTHR15238', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN L39, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(244533, NULL, 'PTHR47221', NULL, NULL, NULL, NULL, 'FIBRINOGEN ALPHA CHAIN', NULL, NULL, 27735, 8),
(244534, NULL, 'PTHR37252', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN-INTERACTING PROTEIN 6', NULL, NULL, 30940, 8),
(244535, NULL, 'PTHR42783', NULL, NULL, NULL, NULL, 'GLUTAMATE SYNTHASE [NADPH] SMALL CHAIN', NULL, NULL, NULL, 8),
(244536, NULL, 'PTHR31715', NULL, NULL, NULL, NULL, 'UREASE ACCESSORY PROTEIN G', NULL, NULL, 5747, 8),
(244537, NULL, 'PTHR36398', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE FUSION PROTEIN', NULL, NULL, NULL, 8),
(244538, NULL, 'PTHR30621', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE ADENYLYLTRANSFERASE', NULL, NULL, 15114, 8),
(244539, NULL, 'PTHR33280', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L31, CHLOROPLASTIC', NULL, NULL, 5403, 8),
(244540, NULL, 'PTHR23410', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L5-RELATED', NULL, NULL, 657, 8),
(244541, NULL, 'PTHR39228', NULL, NULL, NULL, NULL, 'LORICRIN', NULL, NULL, NULL, 8),
(244542, NULL, 'PTHR10806', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE COMPLEX CATALYTIC SUBUNIT SEC11', NULL, NULL, 3357, 8),
(244543, NULL, 'PTHR45953', NULL, NULL, NULL, NULL, 'IDURONATE 2-SULFATASE', NULL, NULL, NULL, 8),
(244544, NULL, 'PTHR33120', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', NULL, NULL, NULL, 8),
(244545, NULL, 'PTHR40394', NULL, NULL, NULL, NULL, 'LIPOPROTEIN-RELATED', NULL, NULL, NULL, 8),
(244546, NULL, 'PTHR47618', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL OLIGORIBONUCLEASE AND PAP PHOSPHATASE NRNA', NULL, NULL, NULL, 8),
(244547, NULL, 'PTHR40089', NULL, NULL, NULL, NULL, 'ETHANOLAMINE UTILIZATION PROTEIN EUTH', NULL, NULL, 4901, 8),
(244548, NULL, 'PTHR34631', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244549, NULL, 'PTHR23080', NULL, NULL, NULL, NULL, 'THAP DOMAIN PROTEIN', NULL, NULL, NULL, 8),
(244550, NULL, 'PTHR46724', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 9-RELATED', NULL, NULL, NULL, 8),
(244551, NULL, 'PTHR43874', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR', NULL, NULL, 35630, 8),
(244552, NULL, 'PTHR11100', NULL, NULL, NULL, NULL, 'HEREGULIN-NEUREGULIN FAMILY MEMBER', NULL, NULL, 32165, 8),
(244553, NULL, 'PTHR11082', NULL, NULL, NULL, NULL, 'TRNA-DIHYDROURIDINE SYNTHASE', NULL, NULL, NULL, 8),
(244554, NULL, 'PTHR15431', NULL, NULL, NULL, NULL, 'FGFR1 ONCOGENE PARTNER/LISH DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(244555, NULL, 'PTHR41542', NULL, NULL, NULL, NULL, 'BLL5807 PROTEIN', NULL, NULL, NULL, 8),
(244556, NULL, 'PTHR16592', NULL, NULL, NULL, NULL, '', NULL, NULL, 25107, 8),
(244557, NULL, 'PTHR11118', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 788, 8),
(244558, NULL, 'PTHR33619', NULL, NULL, NULL, NULL, 'POLYSACCHARIDE EXPORT PROTEIN GFCE-RELATED', NULL, NULL, NULL, 8),
(244559, NULL, 'PTHR43539', NULL, NULL, NULL, NULL, 'FLAVIN-BINDING MONOOXYGENASE-LIKE PROTEIN (AFU_ORTHOLOGUE AFUA_4G09220)', NULL, NULL, NULL, 8),
(244560, NULL, 'PTHR37292', NULL, NULL, NULL, NULL, 'VNG6097C', NULL, NULL, NULL, 8),
(244561, NULL, 'PTHR10502', NULL, NULL, NULL, NULL, 'ANNEXIN', NULL, NULL, NULL, 8),
(244562, NULL, 'PTHR31954', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 157', NULL, NULL, 32507, 8),
(244563, NULL, 'PTHR35967', NULL, NULL, NULL, NULL, 'UPF0450 PROTEIN C17ORF58', NULL, NULL, NULL, 8),
(244564, NULL, 'PTHR21439', NULL, NULL, NULL, NULL, 'OXIDORED-NITRO DOMAIN-CONTAINING PROTEIN', NULL, NULL, 14612, 8),
(244565, NULL, 'PTHR42796', NULL, NULL, NULL, NULL, 'FUMARYLACETOACETATE HYDROLASE DOMAIN-CONTAINING PROTEIN 2A-RELATED', NULL, NULL, NULL, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(244566, NULL, 'PTHR43518', NULL, NULL, NULL, NULL, 'NITRATE REDUCTASE BETA SUBUNIT', NULL, NULL, NULL, 8),
(244567, NULL, 'PTHR43385', NULL, NULL, NULL, NULL, 'RIBOFLAVIN TRANSPORTER RIBJ', NULL, NULL, NULL, 8),
(244568, NULL, 'PTHR38653', NULL, NULL, NULL, NULL, 'GENE 572-RELATED', NULL, NULL, 24190, 8),
(244569, NULL, 'PTHR21443', NULL, NULL, NULL, NULL, 'CONSERVED OLIGOMERIC GOLGI COMPLEX COMPONENT 7', NULL, NULL, 14671, 8),
(244570, NULL, 'PTHR11010', NULL, NULL, NULL, NULL, 'PROTEASE S28 PRO-X CARBOXYPEPTIDASE-RELATED', NULL, NULL, NULL, 8),
(244571, NULL, 'PTHR13321', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION, SUBUNIT 18', NULL, NULL, 17751, 8),
(244572, NULL, 'PTHR47691', NULL, NULL, NULL, NULL, 'REGULATOR-RELATED', NULL, NULL, NULL, 8),
(244573, NULL, 'PTHR13280', NULL, NULL, NULL, NULL, 'PHOSPHOFURIN ACIDIC CLUSTER SORTING PROTEIN', NULL, NULL, 15823, 8),
(244574, NULL, 'PTHR46160', NULL, NULL, NULL, NULL, 'ALPHA-TECTORIN-RELATED', NULL, NULL, NULL, 8),
(244575, NULL, 'PTHR31640', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN KIAA1109', NULL, NULL, 29503, 8),
(244576, NULL, 'PTHR12131', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA AND DNA HELICASE', NULL, NULL, NULL, 8),
(244577, NULL, 'PTHR43568', NULL, NULL, NULL, NULL, 'P PROTEIN', NULL, NULL, NULL, 8),
(244578, NULL, 'PTHR31170', NULL, NULL, NULL, NULL, 'BNAC04G53230D PROTEIN', NULL, NULL, NULL, 8),
(244579, NULL, 'PTHR28222', NULL, NULL, NULL, NULL, 'DASH COMPLEX SUBUNIT DAD4', NULL, NULL, 7935, 8),
(244580, NULL, 'PTHR42763', NULL, NULL, NULL, NULL, 'ADP-GLUCOSE PHOSPHORYLASE', NULL, NULL, NULL, 8),
(244581, NULL, 'PTHR12129', NULL, NULL, NULL, NULL, 'HEPARAN SULFATE 2-O-SULFOTRANSFERASE', NULL, NULL, 1292, 8),
(244582, NULL, 'PTHR11511', NULL, NULL, NULL, NULL, 'LARVAL STORAGE PROTEIN/PHENOLOXIDASE', NULL, NULL, 12518, 8),
(244583, NULL, 'PTHR33147', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 1', NULL, NULL, NULL, 8),
(244584, NULL, 'PTHR47294', NULL, NULL, NULL, NULL, 'OS08G0431150 PROTEIN', NULL, NULL, NULL, 8),
(244585, NULL, 'PTHR45266', NULL, NULL, NULL, NULL, 'OXALOACETATE DECARBOXYLASE ALPHA CHAIN', NULL, NULL, NULL, 8),
(244586, NULL, 'PTHR33567', NULL, NULL, NULL, NULL, 'CHROMATE ION TRANSPORTER (EUROFUNG)', NULL, NULL, NULL, 8),
(244587, NULL, 'PTHR30292', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN YBGL-RELATED', NULL, NULL, 616, 8),
(244588, NULL, 'PTHR19364', NULL, NULL, NULL, NULL, 'IMMUNITY-RELATED GTPASE FAMILY Q PROTEIN', NULL, NULL, 31406, 8),
(244589, NULL, 'PTHR45851', NULL, NULL, NULL, NULL, 'MYC PROTO-ONCOGENE', NULL, NULL, NULL, 8),
(244590, NULL, 'PTHR23413', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L32 AND DNA-DIRECTED RNA POLYMERASE II, SUBUNIT N', NULL, NULL, 6254, 8),
(244591, NULL, 'PTHR38813', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244592, NULL, 'PTHR46207', NULL, NULL, NULL, NULL, 'PROTEIN RCC2', NULL, NULL, 26631, 8),
(244593, NULL, 'PTHR46009', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN VTA1 HOMOLOG', NULL, NULL, 34980, 8),
(244594, NULL, 'PTHR45762', NULL, NULL, NULL, NULL, 'ZINC FINGER RNA-BINDING PROTEIN', NULL, NULL, NULL, 8),
(244595, NULL, 'PTHR47257', NULL, NULL, NULL, NULL, 'PH-RESPONSE TRANSCRIPTION FACTOR PACC/RIM101', NULL, NULL, NULL, 8),
(244596, NULL, 'PTHR48025', NULL, NULL, NULL, NULL, 'OS02G0815200 PROTEIN', NULL, NULL, NULL, 8),
(244597, NULL, 'PTHR33737', NULL, NULL, NULL, NULL, 'OS05G0121800 PROTEIN', NULL, NULL, 37162, 8),
(244598, NULL, 'PTHR14572', NULL, NULL, NULL, NULL, 'PANCREATIC PROGENITOR CELL DIFFERENTIATION AND PROLIFERATION FACTOR', NULL, NULL, 24017, 8),
(244599, NULL, 'PTHR30007', NULL, NULL, NULL, NULL, 'PHP DOMAIN PROTEIN', NULL, NULL, NULL, 8),
(244600, NULL, 'PTHR31430', NULL, NULL, NULL, NULL, 'PROTEIN CBG22332-RELATED', NULL, NULL, NULL, 8),
(244601, NULL, 'PTHR36307', NULL, NULL, NULL, NULL, 'FLAGELLA BASAL BODY P-RING FORMATION PROTEIN FLGA', NULL, NULL, 32991, 8),
(244602, NULL, 'PTHR12968', NULL, NULL, NULL, NULL, 'B9 DOMAIN-CONTAINING', NULL, NULL, 10891, 8),
(244603, NULL, 'PTHR45867', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE', NULL, NULL, NULL, 8);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(244604, NULL, 'PTHR47613', NULL, NULL, NULL, NULL, 'SPERM ACROSOME MEMBRANE-ASSOCIATED PROTEIN 4', NULL, NULL, 37578, 8),
(244605, NULL, 'PTHR22409', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 31486, 8),
(244606, NULL, 'PTHR14320', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 181', NULL, NULL, 25807, 8),
(244607, NULL, 'PTHR40707', NULL, NULL, NULL, NULL, 'POSSIBLE NUCLEASE OF RNASE H FOLD, RUVC/YQGF FAMILY', NULL, NULL, 3726, 8),
(244608, NULL, 'PTHR16040', NULL, NULL, NULL, NULL, 'AUSTRALIN, ISOFORM A-RELATED', NULL, NULL, 20743, 8),
(244609, NULL, 'PTHR39597', NULL, NULL, NULL, NULL, 'UBA DOMAIN-CONTAINING PROTEIN RUP1', NULL, NULL, NULL, 8),
(244610, NULL, 'PTHR21632', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 21674, 8),
(244611, NULL, 'PTHR35068', NULL, NULL, NULL, NULL, 'BEN DOMAIN-CONTAINING PROTEIN 7', NULL, NULL, NULL, 8),
(244612, NULL, 'PTHR46793', NULL, NULL, NULL, NULL, '1700018F24RIK PROTEIN-RELATED-RELATED', NULL, NULL, NULL, 8),
(244613, NULL, 'PTHR28245', NULL, NULL, NULL, NULL, 'ARF3-INTERACTING PROTEIN 1', NULL, NULL, NULL, 8),
(244614, NULL, 'PTHR46588', NULL, NULL, NULL, NULL, 'SERINE/THREONINE/TYROSINE-INTERACTING PROTEIN', NULL, NULL, NULL, 8),
(244615, NULL, 'PTHR43076', NULL, NULL, NULL, NULL, 'FO SYNTHASE (COFH)', NULL, NULL, 30559, 8),
(244616, NULL, 'PTHR15453', NULL, NULL, NULL, NULL, 'TUMOR SUPPRESSOR CANDIDATE 2', NULL, NULL, 23031, 8),
(244617, NULL, 'PTHR24082', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR', NULL, NULL, NULL, 8),
(244618, NULL, 'PTHR46045', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS U-RELATED', NULL, NULL, 3426, 8),
(244619, NULL, 'PTHR31058', NULL, NULL, NULL, NULL, 'ZINC FINGER C4H2 DOMAIN-CONTAINING PROTEIN', NULL, NULL, 9422, 8),
(244620, NULL, 'PTHR31793', NULL, NULL, NULL, NULL, '4-HYDROXYBENZOYL-COA THIOESTERASE FAMILY MEMBER', NULL, NULL, NULL, 8),
(244621, NULL, 'PTHR30329', NULL, NULL, NULL, NULL, 'STATOR ELEMENT OF FLAGELLAR MOTOR COMPLEX', NULL, NULL, NULL, 8),
(244622, NULL, 'PTHR13904', NULL, NULL, NULL, NULL, 'PRE-MRNA SPLICING FACTOR PRP31', NULL, NULL, 22732, 8),
(244623, NULL, 'PTHR31870', NULL, NULL, NULL, NULL, 'SI:DKEY-183I3.9-RELATED', NULL, NULL, 32866, 8),
(244624, NULL, 'PTHR31764', NULL, NULL, NULL, NULL, 'PROTEIN HAPLESS 2', NULL, NULL, 27905, 8),
(244625, NULL, 'PTHR28200', NULL, NULL, NULL, NULL, 'DASH COMPLEX SUBUNIT ASK1', NULL, NULL, 7733, 8),
(244626, NULL, 'PTHR15420', NULL, NULL, NULL, NULL, 'UBIQUINOL-CYTOCHROME C REDUCTASE COMPLEX 6.4 KD PROTEIN', NULL, NULL, 8534, 8),
(244627, NULL, 'PTHR47008', NULL, NULL, NULL, NULL, 'PROTEIN CORDON-BLEU', NULL, NULL, 32223, 8),
(244628, NULL, 'PTHR35727', NULL, NULL, NULL, NULL, 'BNAA05G33520D PROTEIN', NULL, NULL, NULL, 8),
(244629, NULL, 'PTHR35478', NULL, NULL, NULL, NULL, 'ZINC FINGER FYVE DOMAIN PROTEIN', NULL, NULL, NULL, 8),
(244630, NULL, 'PTHR10554', NULL, NULL, NULL, NULL, 'SYNTROPHIN', NULL, NULL, 9222, 8),
(244631, NULL, 'PTHR15276', NULL, NULL, NULL, NULL, 'H4 D10S170  PROTEIN-RELATED', NULL, NULL, 18053, 8),
(244632, NULL, 'PTHR31402', NULL, NULL, NULL, NULL, 'UPF0711 PROTEIN C18ORF21', NULL, NULL, 26541, 8),
(244633, NULL, 'PTHR35749', NULL, NULL, NULL, NULL, 'OSJNBA0084A10.10 PROTEIN', NULL, NULL, NULL, 8),
(244634, NULL, 'PTHR34217', NULL, NULL, NULL, NULL, 'METAL-DEPENDENT CARBOXYPEPTIDASE', NULL, NULL, 438, 8),
(244635, NULL, 'PTHR46678', NULL, NULL, NULL, NULL, 'LECITHIN RETINOL ACYLTRANSFERASE', NULL, NULL, 34522, 8),
(244636, NULL, 'PTHR11748', NULL, NULL, NULL, NULL, 'D-LACTATE DEHYDROGENASE', NULL, NULL, NULL, 8),
(244637, NULL, 'PTHR15124', NULL, NULL, NULL, NULL, 'SELENOPROTEIN W', NULL, NULL, NULL, 8),
(244638, NULL, 'PTHR10010', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 34  SODIUM PHOSPHATE , MEMBER 2-RELATED', NULL, NULL, 3205, 8),
(244639, NULL, 'PTHR38400', NULL, NULL, NULL, NULL, 'OS02G0317800 PROTEIN', NULL, NULL, NULL, 8),
(244640, NULL, 'PTHR30538', NULL, NULL, NULL, NULL, 'LYSINE 2,3-AMINOMUTASE-RELATED', NULL, NULL, 2409, 8),
(244641, NULL, 'PTHR40466', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, 28737, 8);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(244642, NULL, 'PTHR33399', NULL, NULL, NULL, NULL, 'OXYGEN-EVOLVING ENHANCER PROTEIN 3-1, CHLOROPLASTIC', NULL, NULL, 13546, 8),
(244643, NULL, 'PTHR33075', NULL, NULL, NULL, NULL, 'OS02G0499800 PROTEIN', NULL, NULL, NULL, 8),
(244644, NULL, 'PTHR39661', NULL, NULL, NULL, NULL, 'UPF0310 PROTEIN MJECL36', NULL, NULL, NULL, 8),
(244645, NULL, 'PTHR31451', NULL, NULL, NULL, NULL, '', NULL, NULL, 35212, 8),
(244646, NULL, 'PTHR31852', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY', NULL, NULL, NULL, 8),
(244647, NULL, 'PTHR36343', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(244648, NULL, 'PTHR16875', NULL, NULL, NULL, NULL, 'SELENOPROTEIN K', NULL, NULL, 24498, 8),
(244649, NULL, 'PTHR14097', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE HTATIP2', NULL, NULL, NULL, 8),
(244650, NULL, 'PTHR36012', NULL, NULL, NULL, NULL, 'OS01G0654400 PROTEIN', NULL, NULL, NULL, 8),
(244651, NULL, 'PTHR10494', NULL, NULL, NULL, NULL, 'BONE MORPHOGENETIC PROTEIN INHIBITOR, NOGGIN', NULL, NULL, 13453, 8),
(244652, NULL, 'PTHR22932', NULL, NULL, NULL, NULL, 'TELOMERASE-BINDING PROTEIN P23  HSP90 CO-CHAPERONE', NULL, NULL, 34211, 8),
(244653, NULL, 'PTHR47473', NULL, NULL, NULL, NULL, 'BTA1P', NULL, NULL, NULL, 8),
(244654, NULL, 'PTHR21179', NULL, NULL, NULL, NULL, 'SERINE-TYPE ENDOPEPTIDASE INHIBITOR', NULL, NULL, 30269, 8),
(244655, NULL, 'PTHR10501', NULL, NULL, NULL, NULL, 'U1 SMALL NUCLEAR RIBONUCLEOPROTEIN A/U2 SMALL NUCLEAR RIBONUCLEOPROTEIN B', NULL, NULL, NULL, 8),
(244656, NULL, 'PTHR43015', NULL, NULL, NULL, NULL, 'D-RIBITOL-5-PHOSPHATE CYTIDYLYLTRANSFERASE', NULL, NULL, NULL, 8),
(244657, NULL, 'PTHR20948', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 23490, 8),
(244658, NULL, 'PTHR10091', NULL, NULL, NULL, NULL, 'ALDOSE-1-EPIMERASE', NULL, NULL, NULL, 8),
(244659, NULL, 'PTHR14098', NULL, NULL, NULL, NULL, 'SH2 DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(244660, NULL, 'PTHR10980', NULL, NULL, NULL, NULL, 'RHO GDP-DISSOCIATION INHIBITOR', NULL, NULL, 4782, 8),
(244661, NULL, 'PTHR11633', NULL, NULL, NULL, NULL, 'PLATELET-DERIVED GROWTH FACTOR', NULL, NULL, NULL, 8),
(244662, NULL, 'PTHR13359', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L40, MITOCHONDRIAL', NULL, NULL, 29141, 8),
(244663, NULL, 'PTHR35928', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S3, MITOCHONDRIAL', NULL, NULL, 35095, 8),
(244664, NULL, 'PTHR32052', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244665, NULL, 'PTHR34349', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 32', NULL, NULL, 24514, 8),
(244666, NULL, 'PTHR35902', NULL, NULL, NULL, NULL, 'S-LAYER DOMAIN-LIKE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(244667, NULL, 'PTHR31794', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX TRANSPORTER FAMILY PROTEIN (EUROFUNG)', NULL, NULL, NULL, 8),
(244668, NULL, 'PTHR46831', NULL, NULL, NULL, NULL, 'ZINC FINGER MYND DOMAIN-CONTAINING PROTEIN 19', NULL, NULL, 25395, 8),
(244669, NULL, 'PTHR33033', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDYL TRANSFERASE, RIBONUCLEASE H-LIKE SUPERFAMILY PROTEIN-RELATED', NULL, NULL, NULL, 8),
(244670, NULL, 'PTHR12670', NULL, NULL, NULL, NULL, 'CERAMIDASE', NULL, NULL, 3754, 8),
(244671, NULL, 'PTHR43437', NULL, NULL, NULL, NULL, 'HYDROXYACYL-THIOESTER DEHYDRATASE TYPE 2, MITOCHONDRIAL-RELATED', NULL, NULL, NULL, 8),
(244672, NULL, 'PTHR38498', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 191B-RELATED', NULL, NULL, 21900, 8),
(244673, NULL, 'PTHR45623', NULL, NULL, NULL, NULL, 'CHROMODOMAIN-HELICASE-DNA-BINDING PROTEIN 3-RELATED-RELATED', NULL, NULL, NULL, 8),
(244674, NULL, 'PTHR13090', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(244675, NULL, 'PTHR35178', NULL, NULL, NULL, NULL, 'FOLATE RECEPTOR HOMOLOG-RELATED', NULL, NULL, NULL, 8),
(244676, NULL, 'PTHR35867', NULL, NULL, NULL, NULL, 'PROTEIN RSEC', NULL, NULL, 5919, 8),
(244677, NULL, 'PTHR43116', NULL, NULL, NULL, NULL, 'PEPTIDE CHAIN RELEASE FACTOR 2', NULL, NULL, NULL, 8),
(244678, NULL, 'PTHR42847', NULL, NULL, NULL, NULL, 'ALKANESULFONATE MONOOXYGENASE', NULL, NULL, NULL, 8);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(244679, NULL, 'PTHR16208', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN/SYNTAPHILIN', NULL, NULL, NULL, 8),
(244680, NULL, 'PTHR38438', NULL, NULL, NULL, NULL, 'RIBOFLAVIN TRANSPORTER RIBU', NULL, NULL, 23102, 8),
(244681, NULL, 'PTHR45727', NULL, NULL, NULL, NULL, 'NPC INTRACELLULAR CHOLESTEROL TRANSPORTER 1', NULL, NULL, NULL, 8),
(244682, NULL, 'PTHR16146', NULL, NULL, NULL, NULL, 'INTELECTIN', NULL, NULL, NULL, 8),
(244683, NULL, 'PTHR35523', NULL, NULL, NULL, NULL, 'CELL WALL PROTEIN SED1', NULL, NULL, 32361, 8),
(244684, NULL, 'PTHR31093', NULL, NULL, NULL, NULL, 'CELL SURFACE GLYCOPROTEIN GP138-RELATED-RELATED', NULL, NULL, NULL, 8),
(244685, NULL, 'PTHR40039', NULL, NULL, NULL, NULL, 'PROTEIN DLTD', NULL, NULL, 6475, 8),
(244686, NULL, 'PTHR28249', NULL, NULL, NULL, NULL, 'SPORULATION-SPECIFIC PROTEIN SPO7', NULL, NULL, 2882, 8),
(244687, NULL, 'PTHR33730', NULL, NULL, NULL, NULL, 'OS05G0542732 PROTEIN-RELATED', NULL, NULL, 25592, 8),
(244688, NULL, 'PTHR28645', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 119', NULL, NULL, 25028, 8),
(244689, NULL, 'PTHR32274', NULL, NULL, NULL, NULL, 'NEDD4-BINDING PROTEIN 3', NULL, NULL, 27687, 8),
(244690, NULL, 'PTHR11001', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL FISSION PROCESS PROTEIN 1', NULL, NULL, 19263, 8),
(244691, NULL, 'PTHR34599', NULL, NULL, NULL, NULL, 'PEROXIDASE-RELATED', NULL, NULL, NULL, 8),
(244692, NULL, 'PTHR14958', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL TETRAMERISATION DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(244693, NULL, 'PTHR30319', NULL, NULL, NULL, NULL, 'PHENYLACETIC ACID REGULATOR-RELATED TRANSCRIPTIONAL REPRESSOR', NULL, NULL, NULL, 8),
(244694, NULL, 'PTHR30336', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN, PROBABLE PERMEASE', NULL, NULL, NULL, 8),
(244695, NULL, 'PTHR37876', NULL, NULL, NULL, NULL, 'PROTEIN GAR2-LIKE', NULL, NULL, 28970, 8),
(244696, NULL, 'PTHR14017', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE', NULL, NULL, NULL, 8),
(244697, NULL, 'PTHR35455', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', NULL, NULL, 26350, 8),
(244698, NULL, 'PTHR28660', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 73', NULL, NULL, 23514, 8),
(244699, NULL, 'PTHR38699', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, 17954, 8),
(244700, NULL, 'PTHR31115', NULL, NULL, NULL, NULL, 'OS05G0107300 PROTEIN', NULL, NULL, NULL, 8),
(244701, NULL, 'PTHR33667', NULL, NULL, NULL, NULL, 'SI:DKEY-57N24.6', NULL, NULL, NULL, 8),
(244702, NULL, 'PTHR21208', NULL, NULL, NULL, NULL, 'ADP-DEPENDENT GLUCOKINASE', NULL, NULL, 147, 8),
(244703, NULL, 'PTHR30287', NULL, NULL, NULL, NULL, 'MEMBRANE COMPONENT OF PREDICTED ABC SUPERFAMILY METABOLITE UPTAKE TRANSPORTER', NULL, NULL, 27953, 8),
(244704, NULL, 'PTHR21257', NULL, NULL, NULL, NULL, 'DELTA(14)-STEROL REDUCTASE', NULL, NULL, NULL, 8),
(244705, NULL, 'PTHR15622', NULL, NULL, NULL, NULL, 'WD40 REPEAT PROTEIN', NULL, NULL, NULL, 8),
(244706, NULL, 'PTHR22382', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4921504E06 GENE', NULL, NULL, 31262, 8),
(244707, NULL, 'PTHR42872', NULL, NULL, NULL, NULL, 'PROTEIN-GLUTAMATE METHYLESTERASE/PROTEIN-GLUTAMINE GLUTAMINASE', NULL, NULL, NULL, 8),
(244708, NULL, 'PTHR13650', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 23139, 8),
(244709, NULL, 'PTHR35072', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 91', NULL, NULL, 4651, 8),
(244710, NULL, 'PTHR34645', NULL, NULL, NULL, NULL, 'SIMILAR TO HYPOTHETICAL PROTEIN', NULL, NULL, 31451, 8),
(244711, NULL, 'PTHR10630', NULL, NULL, NULL, NULL, 'MONOCYTE DIFFERENTIATION ANTIGEN CD14', NULL, NULL, 20482, 8),
(244712, NULL, 'PTHR16231', NULL, NULL, NULL, NULL, 'COMM DOMAIN-CONTAINING PROTEIN 4-8 FAMILY MEMBER', NULL, NULL, NULL, 8),
(244713, NULL, 'PTHR28621', NULL, NULL, NULL, NULL, 'SELENOPROTEIN S', NULL, NULL, 11918, 8),
(244714, NULL, 'PTHR34593', NULL, NULL, NULL, NULL, 'MATING RESPONSE PROTEIN POI2', NULL, NULL, NULL, 8),
(244715, NULL, 'PTHR33563', NULL, NULL, NULL, NULL, '', NULL, NULL, 4881, 8),
(244716, NULL, 'PTHR42910', NULL, NULL, NULL, NULL, 'TRANSPORTER SCO4007-RELATED', NULL, NULL, NULL, 8);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(244717, NULL, 'PTHR36743', NULL, NULL, NULL, NULL, 'OS04G0495300 PROTEIN', NULL, NULL, NULL, 8),
(244718, NULL, 'PTHR47191', NULL, NULL, NULL, NULL, 'OS05G0170800 PROTEIN', NULL, NULL, NULL, 8),
(244719, NULL, 'PTHR10840', NULL, NULL, NULL, NULL, 'PROGRAMMED CELL DEATH PROTEIN 5', NULL, NULL, 5290, 8),
(244720, NULL, 'PTHR42683', NULL, NULL, NULL, NULL, 'ALDEHYDE REDUCTASE', NULL, NULL, NULL, 8),
(244721, NULL, 'PTHR38344', NULL, NULL, NULL, NULL, 'UPF0753 PROTEIN AQ_863', NULL, NULL, 18377, 8),
(244722, NULL, 'PTHR30069', NULL, NULL, NULL, NULL, 'TONB-DEPENDENT OUTER MEMBRANE RECEPTOR', NULL, NULL, 33080, 8),
(244723, NULL, 'PTHR31899', NULL, NULL, NULL, NULL, 'BETA-CAROTENE 3-HYDROXYLASE 1, CHLOROPLASTIC', NULL, NULL, 36743, 8),
(244724, NULL, 'PTHR38406', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR OPI1', NULL, NULL, 14143, 8),
(244725, NULL, 'PTHR43475', NULL, NULL, NULL, NULL, 'METHYLTHIORIBOSE-1-PHOSPHATE ISOMERASE', NULL, NULL, NULL, 8),
(244726, NULL, 'PTHR48153', NULL, NULL, NULL, NULL, 'UFM1-SPECIFIC PROTEASE 2', NULL, NULL, NULL, 8),
(244727, NULL, 'PTHR37611', NULL, NULL, NULL, NULL, 'VIRUS-SPECIFIC-SIGNALING-PATHWAY REGULATED PROTEIN-RELATED', NULL, NULL, NULL, 8),
(244728, NULL, 'PTHR47523', NULL, NULL, NULL, NULL, 'F21O3.11 PROTEIN', NULL, NULL, NULL, 8),
(244729, NULL, 'PTHR34260', NULL, NULL, NULL, NULL, 'UBIQUINOL-CYTOCHROME-C REDUCTASE COMPLEX ASSEMBLY FACTOR 2', NULL, NULL, 28670, 8),
(244730, NULL, 'PTHR30036', NULL, NULL, NULL, NULL, 'D-XYLOSE-BINDING PERIPLASMIC PROTEIN', NULL, NULL, NULL, 8),
(244731, NULL, 'PTHR39430', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED PROTEASE-RELATED', NULL, NULL, NULL, 8),
(244732, NULL, 'PTHR46890', NULL, NULL, NULL, NULL, 'NON-LTR RETROLELEMENT REVERSE TRANSCRIPTASE-LIKE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(244733, NULL, 'PTHR28006', NULL, NULL, NULL, NULL, 'MONOPOLIN COMPLEX SUBUNIT CSM1', NULL, NULL, 27931, 8),
(244734, NULL, 'PTHR10865', NULL, NULL, NULL, NULL, 'METASTASIS-ASSOCIATED PROTEIN AND MESODERM INDUCTION EARLY RESPONSE PROTEIN', NULL, NULL, 30039, 8),
(244735, NULL, 'PTHR30508', NULL, NULL, NULL, NULL, 'FES CLUSTER ASSEMBLY PROTEIN SUF', NULL, NULL, NULL, 8),
(244736, NULL, 'PTHR38850', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244737, NULL, 'PTHR11995', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE', NULL, NULL, NULL, 8),
(244738, NULL, 'PTHR34059', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(244739, NULL, 'PTHR12406', NULL, NULL, NULL, NULL, 'CALCIUM-INDEPENDENT PHOSPHOLIPASE A2  IPLA2 -RELATED', NULL, NULL, 31866, 8),
(244740, NULL, 'PTHR13495', NULL, NULL, NULL, NULL, 'NEFA-INTERACTING NUCLEAR PROTEIN NIP30', NULL, NULL, 27138, 8),
(244741, NULL, 'PTHR46601', NULL, NULL, NULL, NULL, 'ULP_PROTEASE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(244742, NULL, 'PTHR46383', NULL, NULL, NULL, NULL, 'ASPARTATE AMINOTRANSFERASE', NULL, NULL, NULL, 8),
(244743, NULL, 'PTHR22844', NULL, NULL, NULL, NULL, 'F-BOX AND WD40 DOMAIN PROTEIN', NULL, NULL, 34030, 8),
(244744, NULL, 'PTHR47550', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE PPS1', NULL, NULL, NULL, 8),
(244745, NULL, 'PTHR43865', NULL, NULL, NULL, NULL, 'RUBRERYTHRIN-RELATED', NULL, NULL, NULL, 8),
(244746, NULL, 'PTHR31859', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 39 FAMILY MEMBER', NULL, NULL, 16687, 8),
(244747, NULL, 'PTHR34825', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN, WITH A WEAK D-GALACTARATE DEHYDRATASE/ALTRONATE HYDROLASE DOMAIN', NULL, NULL, NULL, 8),
(244748, NULL, 'PTHR42937', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244749, NULL, 'PTHR11225', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP93  NUCLEOPORIN NUP93   DEAD EYE PROTEIN', NULL, NULL, 6712, 8),
(244750, NULL, 'PTHR14484', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 71', NULL, NULL, 24356, 8),
(244751, NULL, 'PTHR12550', NULL, NULL, NULL, NULL, 'HEPATOMA-DERIVED GROWTH FACTOR-RELATED', NULL, NULL, NULL, 8),
(244752, NULL, 'PTHR47040', NULL, NULL, NULL, NULL, 'OSJNBA0068L06.9 PROTEIN', NULL, NULL, NULL, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(244753, NULL, 'PTHR43504', NULL, NULL, NULL, NULL, 'ISOCITRATE DEHYDROGENASE [NADP]', NULL, NULL, 7459, 8),
(244754, NULL, 'PTHR15268', NULL, NULL, NULL, NULL, 'THRAP3/BCLAF1', NULL, NULL, 26523, 8),
(244755, NULL, 'PTHR33911', NULL, NULL, NULL, NULL, 'RRNA-PROCESSING PROTEIN EFG1', NULL, NULL, NULL, 8),
(244756, NULL, 'PTHR10272', NULL, NULL, NULL, NULL, 'PLATELET-ACTIVATING FACTOR ACETYLHYDROLASE', NULL, NULL, 2194, 8),
(244757, NULL, 'PTHR34306', NULL, NULL, NULL, NULL, 'RAD60-SLD DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(244758, NULL, 'PTHR43765', NULL, NULL, NULL, NULL, '2-DEHYDROPANTOATE 2-REDUCTASE-RELATED', NULL, NULL, NULL, 8),
(244759, NULL, 'PTHR21780', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 18054, 8),
(244760, NULL, 'PTHR41349', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244761, NULL, 'PTHR38456', NULL, NULL, NULL, NULL, 'CYCLIC DI-AMP RECEPTOR A', NULL, NULL, 9217, 8),
(244762, NULL, 'PTHR38137', NULL, NULL, NULL, NULL, 'PRC-BARREL DOMAIN PROTEIN', NULL, NULL, NULL, 8),
(244763, NULL, 'PTHR37351', NULL, NULL, NULL, NULL, 'C-X-C MOTIF CHEMOKINE 17', NULL, NULL, 21992, 8),
(244764, NULL, 'PTHR46584', NULL, NULL, NULL, NULL, 'HMG DOMAIN-CONTAINING PROTEIN 4', NULL, NULL, 36890, 8),
(244765, NULL, 'PTHR31047', NULL, NULL, NULL, NULL, 'MEIOTICALLY UP-REGULATED GENE 157 PROTEIN', NULL, NULL, 7502, 8),
(244766, NULL, 'PTHR43482', NULL, NULL, NULL, NULL, 'PROTEIN AST1-RELATED', NULL, NULL, NULL, 8),
(244767, NULL, 'PTHR42979', NULL, NULL, NULL, NULL, '3-ISOPROPYLMALATE DEHYDROGENASE', NULL, NULL, 7334, 8),
(244768, NULL, 'PTHR40043', NULL, NULL, NULL, NULL, 'UPF0719 INNER MEMBRANE PROTEIN YJFL', NULL, NULL, NULL, 8),
(244769, NULL, 'PTHR46827', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN DDB_G0288861-RELATED', NULL, NULL, NULL, 8),
(244770, NULL, 'PTHR35790', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR PCHR', NULL, NULL, NULL, 8),
(244771, NULL, 'PTHR28491', NULL, NULL, NULL, NULL, 'UPF0688 PROTEIN C1ORF174', NULL, NULL, 25010, 8),
(244772, NULL, 'PTHR14950', NULL, NULL, NULL, NULL, 'DICER-RELATED', NULL, NULL, NULL, 8),
(244773, NULL, 'PTHR21529', NULL, NULL, NULL, NULL, 'MAMMARY TURMOR VIRUS RECEPTOR HOMOLOG 1, 2  MTVR1, 2', NULL, NULL, 31003, 8),
(244774, NULL, 'PTHR15092', NULL, NULL, NULL, NULL, 'POLY A -SPECIFIC RIBONUCLEASE/TARGET OF EGR1, MEMBER 1', NULL, NULL, NULL, 8),
(244775, NULL, 'PTHR42195', NULL, NULL, NULL, NULL, 'UCP015877 FAMILY PROTEIN', NULL, NULL, 11159, 8),
(244776, NULL, 'PTHR12385', NULL, NULL, NULL, NULL, 'CHOLINE TRANSPORTER-LIKE (SLC FAMILY 44)', NULL, NULL, 2582, 8),
(244777, NULL, 'PTHR14305', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE CCNB1IP1', NULL, NULL, 35764, 8),
(244778, NULL, 'PTHR10908', NULL, NULL, NULL, NULL, 'SEROTONIN N-ACETYLTRANSFERASE', NULL, NULL, NULL, 8),
(244779, NULL, 'PTHR36039', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244780, NULL, 'PTHR37209', NULL, NULL, NULL, NULL, 'LYSINE-RICH ARABINOGALACTAN PROTEIN 17-RELATED', NULL, NULL, 35963, 8),
(244781, NULL, 'PTHR12097', NULL, NULL, NULL, NULL, 'SPLICING FACTOR 3B, SUBUNIT 1-RELATED', NULL, NULL, 32602, 8),
(244782, NULL, 'PTHR12904', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244783, NULL, 'PTHR15974', NULL, NULL, NULL, NULL, 'CYTOKINE-LIKE PROTEIN 1', NULL, NULL, 21578, 8),
(244784, NULL, 'PTHR13301', NULL, NULL, NULL, NULL, 'X-BOX TRANSCRIPTION FACTOR-RELATED', NULL, NULL, NULL, 8),
(244785, NULL, 'PTHR38659', NULL, NULL, NULL, NULL, 'METAL-DEPENDENT PHOSPHOHYDROLASE', NULL, NULL, NULL, 8),
(244786, NULL, 'PTHR13393', NULL, NULL, NULL, NULL, 'SAM-DEPENDENT METHYLTRANSFERASE', NULL, NULL, 7633, 8),
(244787, NULL, 'PTHR43049', NULL, NULL, NULL, NULL, 'EARLY ENDOSOME ANTIGEN', NULL, NULL, NULL, 8),
(244788, NULL, 'PTHR47642', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', NULL, NULL, NULL, 8),
(244789, NULL, 'PTHR23429', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE 1-DEHYDROGENASE  G6PD', NULL, NULL, 2174, 8),
(244790, NULL, 'PTHR34008', NULL, NULL, NULL, NULL, 'REPETITIVE PROLINE-RICH CELL WALL PROTEIN 1', NULL, NULL, NULL, 8);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(244791, NULL, 'PTHR34673', NULL, NULL, NULL, NULL, 'COLD-REGULATED PROTEIN', NULL, NULL, NULL, 8),
(244792, NULL, 'PTHR46638', NULL, NULL, NULL, NULL, 'CORRINOID ADENOSYLTRANSFERASE', NULL, NULL, NULL, 8),
(244793, NULL, 'PTHR12176', NULL, NULL, NULL, NULL, 'SAM-DEPENDENT METHYLTRANSFERASE SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(244794, NULL, 'PTHR13856', NULL, NULL, NULL, NULL, 'VHS DOMAIN CONTAINING PROTEIN FAMILY', NULL, NULL, NULL, 8),
(244795, NULL, 'PTHR47891', NULL, NULL, NULL, NULL, 'TRANSPORTER-RELATED', NULL, NULL, NULL, 8),
(244796, NULL, 'PTHR36009', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244797, NULL, 'PTHR10799', NULL, NULL, NULL, NULL, 'SNF2/RAD54 HELICASE FAMILY', NULL, NULL, NULL, 8),
(244798, NULL, 'PTHR48304', NULL, NULL, NULL, NULL, 'QLQ DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(244799, NULL, 'PTHR12850', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S25', NULL, NULL, 773, 8),
(244800, NULL, 'PTHR40399', NULL, NULL, NULL, NULL, 'PTS SYSTEM GLUCITOL/SORBITOL-SPECIFIC EIIC COMPONENT', NULL, NULL, 3466, 8),
(244801, NULL, 'PTHR37869', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 89', NULL, NULL, 26798, 8),
(244802, NULL, 'PTHR10129', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MAF', NULL, NULL, 22429, 8),
(244803, NULL, 'PTHR13259', NULL, NULL, NULL, NULL, 'BLADDER CANCER 10 KD PROTEIN HOMOLOG', NULL, NULL, 1833, 8),
(244804, NULL, 'PTHR36323', NULL, NULL, NULL, NULL, 'MYOTUBULARIN-LIKE PROTEIN', NULL, NULL, NULL, 8),
(244805, NULL, 'PTHR23290', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(244806, NULL, 'PTHR37746', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(244807, NULL, 'PTHR15116', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN SATB FAMILY MEMBER', NULL, NULL, 32582, 8),
(244808, NULL, 'PTHR38390', NULL, NULL, NULL, NULL, 'OS01G0103900 PROTEIN', NULL, NULL, NULL, 8),
(244809, NULL, 'PTHR48245', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244810, NULL, 'PTHR35069', NULL, NULL, NULL, NULL, 'PROTEIN C9ORF135', NULL, NULL, 23002, 8),
(244811, NULL, 'PTHR22900', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 209, 8),
(244812, NULL, 'PTHR12630', NULL, NULL, NULL, NULL, 'N-LINKED OLIGOSACCHARIDE PROCESSING', NULL, NULL, 27373, 8),
(244813, NULL, 'PTHR43138', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE, GNAT FAMILY', NULL, NULL, NULL, 8),
(244814, NULL, 'PTHR44099', NULL, NULL, NULL, NULL, 'RABCONNECTIN-3B, ISOFORM A', NULL, NULL, NULL, 8),
(244815, NULL, 'PTHR15504', NULL, NULL, NULL, NULL, 'NASOPHARYNGEAL EPITHELIUM SPECIFIC PROTEIN 1', NULL, NULL, 30156, 8),
(244816, NULL, 'PTHR37754', NULL, NULL, NULL, NULL, 'CALCIUM ION-BINDING PROTEIN', NULL, NULL, NULL, 8),
(244817, NULL, 'PTHR13251', NULL, NULL, NULL, NULL, 'EPILEPSY HOLOPROSENCEPHALY CANDIDATE 1/TMEM1', NULL, NULL, 36687, 8),
(244818, NULL, 'PTHR12067', NULL, NULL, NULL, NULL, 'PODOCALYXIN', NULL, NULL, 18470, 8),
(244819, NULL, 'PTHR30372', NULL, NULL, NULL, NULL, 'LIPID-A-DISACCHARIDE SYNTHASE', NULL, NULL, 3160, 8),
(244820, NULL, 'PTHR34740', NULL, NULL, NULL, NULL, 'FINGER, C3HC4 TYPE, PUTATIVE-RELATED-RELATED', NULL, NULL, 32494, 8),
(244821, NULL, 'PTHR12533', NULL, NULL, NULL, NULL, 'NFAT', NULL, NULL, 7925, 8),
(244822, NULL, 'PTHR13015', NULL, NULL, NULL, NULL, 'PROTEIN AD-016-RELATED', NULL, NULL, 14570, 8),
(244823, NULL, 'PTHR12918', NULL, NULL, NULL, NULL, 'CYSTEINE DIOXYGENASE', NULL, NULL, 7640, 8),
(244824, NULL, 'PTHR12920', NULL, NULL, NULL, NULL, 'RYBP AND YAF2-RELATED', NULL, NULL, 27151, 8),
(244825, NULL, 'PTHR21436', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 24318, 8),
(244826, NULL, 'PTHR13448', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 214', NULL, NULL, 14701, 8),
(244827, NULL, 'PTHR14030', NULL, NULL, NULL, NULL, 'MITOTIC CHECKPOINT SERINE/THREONINE-PROTEIN KINASE BUB1', NULL, NULL, 17975, 8),
(244828, NULL, 'PTHR13068', NULL, NULL, NULL, NULL, 'CGI-12 PROTEIN-RELATED', NULL, NULL, 4579, 8),
(244829, NULL, 'PTHR12537', NULL, NULL, NULL, NULL, 'RNA BINDING PROTEIN PUMILIO-RELATED', NULL, NULL, NULL, 8);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(244830, NULL, 'PTHR31345', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN Q', NULL, NULL, 22349, 8),
(244831, NULL, 'PTHR31838', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 55 KDA', NULL, NULL, 27166, 8),
(244832, NULL, 'PTHR34957', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSPORT FACTOR 2 (NTF2) FAMILY PROTEIN', NULL, NULL, NULL, 8),
(244833, NULL, 'PTHR36956', NULL, NULL, NULL, NULL, 'UTERINE LUMIN EXPRESSED/LOCAILIZED-RELATED', NULL, NULL, NULL, 8),
(244834, NULL, 'PTHR42081', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244835, NULL, 'PTHR34106', NULL, NULL, NULL, NULL, 'GLYCOSIDASE', NULL, NULL, 574, 8),
(244836, NULL, 'PTHR13703', NULL, NULL, NULL, NULL, 'SMAD', NULL, NULL, 12843, 8),
(244837, NULL, 'PTHR45700', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE E3C', NULL, NULL, 36096, 8),
(244838, NULL, 'PTHR48144', NULL, NULL, NULL, NULL, 'DNA-DIRECTED DNA POLYMERASE', NULL, NULL, NULL, 8),
(244839, NULL, 'PTHR23050', NULL, NULL, NULL, NULL, 'CALCIUM BINDING PROTEIN', NULL, NULL, NULL, 8),
(244840, NULL, 'PTHR46488', NULL, NULL, NULL, NULL, 'AP-5 COMPLEX SUBUNIT ZETA-1', NULL, NULL, 23798, 8),
(244841, NULL, 'PTHR14705', NULL, NULL, NULL, NULL, 'CATION CHANNEL SPERM-ASSOCIATED PROTEIN SUBUNIT BETA', NULL, NULL, 23219, 8),
(244842, NULL, 'PTHR31120', NULL, NULL, NULL, NULL, 'METALLOPROTEASE TIKI', NULL, NULL, 31237, 8),
(244843, NULL, 'PTHR17598', NULL, NULL, NULL, NULL, 'DNA POLYMERASE DELTA SUBUNIT 3', NULL, NULL, 15546, 8),
(244844, NULL, 'PTHR14716', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 69', NULL, NULL, NULL, 8),
(244845, NULL, 'PTHR26312', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 5', NULL, NULL, NULL, 8),
(244846, NULL, 'PTHR46182', NULL, NULL, NULL, NULL, 'FI19480P1', NULL, NULL, 23237, 8),
(244847, NULL, 'PTHR21648', NULL, NULL, NULL, NULL, 'FLAGELLAR RADIAL SPOKE PROTEIN 3', NULL, NULL, 13976, 8),
(244848, NULL, 'PTHR14543', NULL, NULL, NULL, NULL, 'PROTRUDIN', NULL, NULL, 36740, 8),
(244849, NULL, 'PTHR38489', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244850, NULL, 'PTHR30519', NULL, NULL, NULL, NULL, '5-METHYLTETRAHYDROPTEROYLTRIGLUTAMATE--HOMOCYSTEINE METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(244851, NULL, 'PTHR47624', NULL, NULL, NULL, NULL, 'OS01G0204900 PROTEIN', NULL, NULL, NULL, 8),
(244852, NULL, 'PTHR10867', NULL, NULL, NULL, NULL, 'NNMT/PNMT/TEMT FAMILY MEMBER', NULL, NULL, 3408, 8),
(244853, NULL, 'PTHR43654', NULL, NULL, NULL, NULL, 'GLUTAMATE 5-KINASE', NULL, NULL, NULL, 8),
(244854, NULL, 'PTHR11772', NULL, NULL, NULL, NULL, 'ASPARAGINE SYNTHETASE', NULL, NULL, NULL, 8),
(244855, NULL, 'PTHR35463', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(244856, NULL, 'PTHR10742', NULL, NULL, NULL, NULL, 'FLAVIN MONOAMINE OXIDASE', NULL, NULL, NULL, 8),
(244857, NULL, 'PTHR15922', NULL, NULL, NULL, NULL, 'NEUROBLASTOMA-AMPLIFIED SEQUENCE', NULL, NULL, NULL, 8),
(244858, NULL, 'PTHR48092', NULL, NULL, NULL, NULL, 'KNIRPS-RELATED PROTEIN-RELATED', NULL, NULL, NULL, 8),
(244859, NULL, 'PTHR46152', NULL, NULL, NULL, NULL, 'NF-KAPPA-B INHIBITOR-INTERACTING RAS-LIKE PROTEIN', NULL, NULL, 37289, 8),
(244860, NULL, 'PTHR14740', NULL, NULL, NULL, NULL, 'CASPASE ACTIVITY AND APOPTOSIS INHIBITOR 1', NULL, NULL, 30515, 8),
(244861, NULL, 'PTHR12884', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L29', NULL, NULL, 2994, 8),
(244862, NULL, 'PTHR35586', NULL, NULL, NULL, NULL, 'SLL1691 PROTEIN', NULL, NULL, NULL, 8),
(244863, NULL, 'PTHR47423', NULL, NULL, NULL, NULL, 'G-PATCH DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(244864, NULL, 'PTHR23242', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(244865, NULL, 'PTHR24306', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244866, NULL, 'PTHR22727', NULL, NULL, NULL, NULL, 'PROTEIN CBG13728', NULL, NULL, 32674, 8),
(244867, NULL, 'PTHR24081', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR SUBFAMILY 0 GROUP B', NULL, NULL, 33074, 8),
(244868, NULL, 'PTHR43250', NULL, NULL, NULL, NULL, '', NULL, NULL, 32948, 8),
(244869, NULL, 'PTHR35786', NULL, NULL, NULL, NULL, 'REDOX-SENSING TRANSCRIPTIONAL REPRESSOR REX', NULL, NULL, 14715, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(244870, NULL, 'PTHR14695', NULL, NULL, NULL, NULL, 'SHC SH2-DOMAIN BINDING PROTEIN 1-RELATED', NULL, NULL, 36955, 8),
(244871, NULL, 'PTHR43184', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY TRANSPORTER 16, ISOFORM B', NULL, NULL, NULL, 8),
(244872, NULL, 'PTHR11902', NULL, NULL, NULL, NULL, 'ENOLASE', NULL, NULL, 3263, 8),
(244873, NULL, 'PTHR47873', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(244874, NULL, 'PTHR12447', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 13', NULL, NULL, 19786, 8),
(244875, NULL, 'PTHR15299', NULL, NULL, NULL, NULL, 'HERV-H LTR-ASSOCIATING PROTEIN 1', NULL, NULL, 31108, 8),
(244876, NULL, 'PTHR34512', NULL, NULL, NULL, NULL, 'CELL SURFACE PROTEIN', NULL, NULL, NULL, 8),
(244877, NULL, 'PTHR28042', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE COMPLEX SLX5-SLX8 SUBUNIT SLX5', NULL, NULL, 32419, 8),
(244878, NULL, 'PTHR36154', NULL, NULL, NULL, NULL, 'DNA-BINDING TRANSCRIPTIONAL ACTIVATOR ALPA', NULL, NULL, NULL, 8),
(244879, NULL, 'PTHR34344', NULL, NULL, NULL, NULL, 'UPF0184 PROTEIN C9ORF16', NULL, NULL, 6093, 8),
(244880, NULL, 'PTHR14907', NULL, NULL, NULL, NULL, 'FI14130P', NULL, NULL, 24924, 8),
(244881, NULL, 'PTHR15759', NULL, NULL, NULL, NULL, 'PANNEXIN', NULL, NULL, 32705, 8),
(244882, NULL, 'PTHR13505', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 208', NULL, NULL, 12158, 8),
(244883, NULL, 'PTHR21000', NULL, NULL, NULL, NULL, 'DIHYDROXY-ACID DEHYDRATASE  DAD', NULL, NULL, NULL, 8),
(244884, NULL, 'PTHR43844', NULL, NULL, NULL, NULL, 'METHIONINE SYNTHASE', NULL, NULL, NULL, 8),
(244885, NULL, 'PTHR34187', NULL, NULL, NULL, NULL, 'FGR18P', NULL, NULL, NULL, 8),
(244886, NULL, 'PTHR24088', NULL, NULL, NULL, NULL, '28S RIBOSOMAL PROTEIN S17, MITOCHONDRIAL', NULL, NULL, 32785, 8),
(244887, NULL, 'PTHR35013', NULL, NULL, NULL, NULL, 'PROTEIN CBG22618-RELATED', NULL, NULL, 13928, 8),
(244888, NULL, 'PTHR34396', NULL, NULL, NULL, NULL, 'OS03G0264950 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(244889, NULL, 'PTHR35668', NULL, NULL, NULL, NULL, 'PROTEIN SHORTAGE IN CHIASMATA 1 ORTHOLOG', NULL, NULL, 33832, 8),
(244890, NULL, 'PTHR44523', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 13', NULL, NULL, NULL, 8),
(244891, NULL, 'PTHR34272', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(244892, NULL, 'PTHR47802', NULL, NULL, NULL, NULL, 'GLYOXALASE FAMILY PROTEIN, EXPRESSED', NULL, NULL, NULL, 8),
(244893, NULL, 'PTHR31059', NULL, NULL, NULL, NULL, 'HSSA/B-LIKE PROTEIN 1-RELATED-RELATED', NULL, NULL, NULL, 8),
(244894, NULL, 'PTHR23093', NULL, NULL, NULL, NULL, 'SIMILAR TO CHROMOSOME 3 OPEN READING FRAME 20', NULL, NULL, NULL, 8),
(244895, NULL, 'PTHR38644', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(244896, NULL, 'PTHR45940', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 1-RELATED', NULL, NULL, 36313, 8),
(244897, NULL, 'PTHR33778', NULL, NULL, NULL, NULL, 'PROTEIN MGTC', NULL, NULL, 4094, 8),
(244898, NULL, 'PTHR43139', NULL, NULL, NULL, NULL, 'SI:DKEY-122A22.2', NULL, NULL, NULL, 8),
(244899, NULL, 'PTHR46531', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER 6', NULL, NULL, NULL, 8),
(244900, NULL, 'PTHR43420', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE', NULL, NULL, NULL, 8),
(244901, NULL, 'PTHR11130', NULL, NULL, NULL, NULL, 'GLUTATHIONE SYNTHETASE', NULL, NULL, 2539, 8),
(244902, NULL, 'PTHR31375', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244903, NULL, 'PTHR45828', NULL, NULL, NULL, NULL, 'CYTOCHROME B561/FERRIC REDUCTASE TRANSMEMBRANE', NULL, NULL, NULL, 8),
(244904, NULL, 'PTHR36324', NULL, NULL, NULL, NULL, 'OS09G0460100 PROTEIN', NULL, NULL, NULL, 8),
(244905, NULL, 'PTHR30307', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE:TRNA RIBOSYLTRANSFERASE-ISOMERASE', NULL, NULL, 6366, 8),
(244906, NULL, 'PTHR13848', NULL, NULL, NULL, NULL, 'PROTEIN YIPPEE-LIKE CG15309-RELATED', NULL, NULL, 33453, 8),
(244907, NULL, 'PTHR31092', NULL, NULL, NULL, NULL, 'SORORIN', NULL, NULL, 15913, 8),
(244908, NULL, 'PTHR34195', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I REACTION CENTER SUBUNIT V, CHLOROPLASTIC-RELATED', NULL, NULL, 20393, 8);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(244909, NULL, 'PTHR44176', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 25', NULL, NULL, 36126, 8),
(244910, NULL, 'PTHR32099', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH REPEAT SECRETORY PROTEIN', NULL, NULL, NULL, 8),
(244911, NULL, 'PTHR32518', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244912, NULL, 'PTHR20872', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(244913, NULL, 'PTHR39332', NULL, NULL, NULL, NULL, 'BLL4707 PROTEIN', NULL, NULL, NULL, 8),
(244914, NULL, 'PTHR47155', NULL, NULL, NULL, NULL, 'DOWNSTREAM OF DAF-16 (REGULATED BY DAF-16)-RELATED', NULL, NULL, NULL, 8),
(244915, NULL, 'PTHR42939', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN ALBC-RELATED', NULL, NULL, NULL, 8),
(244916, NULL, 'PTHR35256', NULL, NULL, NULL, NULL, 'CHROMOSOME 8 OPEN READING FRAME 48', NULL, NULL, NULL, 8),
(244917, NULL, 'PTHR12434', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 22', NULL, NULL, 14222, 8),
(244918, NULL, 'PTHR24180', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR 2C-RELATED', NULL, NULL, NULL, 8),
(244919, NULL, 'PTHR34184', NULL, NULL, NULL, NULL, 'UPF0718 PROTEIN YCGR', NULL, NULL, NULL, 8),
(244920, NULL, 'PTHR35153', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 154', NULL, NULL, 23511, 8),
(244921, NULL, 'PTHR36562', NULL, NULL, NULL, NULL, 'SERINE/ARGININE REPETITIVE MATRIX 2', NULL, NULL, NULL, 8),
(244922, NULL, 'PTHR43782', NULL, NULL, NULL, NULL, 'ARGINASE', NULL, NULL, 2546, 8),
(244923, NULL, 'PTHR12496', NULL, NULL, NULL, NULL, 'CGI-41 METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(244924, NULL, 'PTHR10901', NULL, NULL, NULL, NULL, 'TROPOMODULIN', NULL, NULL, 1514, 8),
(244925, NULL, 'PTHR12236', NULL, NULL, NULL, NULL, 'STRUCTURAL CONTITUENT OF CUTICLE', NULL, NULL, NULL, 8),
(244926, NULL, 'PTHR38503', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 1', NULL, NULL, 23877, 8),
(244927, NULL, 'PTHR20981', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L21', NULL, NULL, 1342, 8),
(244928, NULL, 'PTHR31453', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 236', NULL, NULL, 19352, 8),
(244929, NULL, 'PTHR36514', NULL, NULL, NULL, NULL, 'PROTEIN CBG00436', NULL, NULL, NULL, 8),
(244930, NULL, 'PTHR35710', NULL, NULL, NULL, NULL, 'OBP3-RESPONSIVE PROTEIN 4 (ORG4)', NULL, NULL, NULL, 8),
(244931, NULL, 'PTHR46241', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING PROTEIN 4 ARMC4', NULL, NULL, NULL, 8),
(244932, NULL, 'PTHR11777', NULL, NULL, NULL, NULL, 'ALANYL-TRNA SYNTHETASE', NULL, NULL, NULL, 8),
(244933, NULL, 'PTHR19237', NULL, NULL, NULL, NULL, 'NUCLEOBINDIN', NULL, NULL, 31429, 8),
(244934, NULL, 'PTHR16560', NULL, NULL, NULL, NULL, 'ALPHA-2-MACROGLOBULIN RECEPTOR-ASSOCIATED PROTEIN', NULL, NULL, 33202, 8),
(244935, NULL, 'PTHR12100', NULL, NULL, NULL, NULL, 'SEC10', NULL, NULL, 8145, 8),
(244936, NULL, 'PTHR45184', NULL, NULL, NULL, NULL, 'DNAJ PROTEIN ERDJ3A', NULL, NULL, NULL, 8),
(244937, NULL, 'PTHR38791', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED-RELATED', NULL, NULL, NULL, 8),
(244938, NULL, 'PTHR10173', NULL, NULL, NULL, NULL, 'METHIONINE SULFOXIDE REDUCTASE', NULL, NULL, 25526, 8),
(244939, NULL, 'PTHR43031', NULL, NULL, NULL, NULL, 'FAD-DEPENDENT OXIDOREDUCTASE', NULL, NULL, NULL, 8),
(244940, NULL, 'PTHR45774', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING', NULL, NULL, NULL, 8),
(244941, NULL, 'PTHR15932', NULL, NULL, NULL, NULL, 'UBIQUITIN INTERACTION MOTIF-CONTAINING PROTEIN 1', NULL, NULL, 31815, 8),
(244942, NULL, 'PTHR40396', NULL, NULL, NULL, NULL, 'ATPASE-LIKE PROTEIN', NULL, NULL, NULL, 8),
(244943, NULL, 'PTHR24123', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING', NULL, NULL, NULL, 8),
(244944, NULL, 'PTHR47812', NULL, NULL, NULL, NULL, 'SMR (SMALL MUTS RELATED) DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(244945, NULL, 'PTHR31133', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN', NULL, NULL, 31273, 8),
(244946, NULL, 'PTHR47830', NULL, NULL, NULL, NULL, 'OS11G0534100 PROTEIN', NULL, NULL, NULL, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(244947, NULL, 'PTHR43176', NULL, NULL, NULL, NULL, '3-HYDROXYISOBUTYRYL-COA HYDROLASE-RELATED', NULL, NULL, 23592, 8),
(244948, NULL, 'PTHR10188', NULL, NULL, NULL, NULL, 'L-ASPARAGINASE', NULL, NULL, 4311, 8),
(244949, NULL, 'PTHR11119', NULL, NULL, NULL, NULL, 'XANTHINE-URACIL / VITAMIN C PERMEASE FAMILY MEMBER', NULL, NULL, NULL, 8),
(244950, NULL, 'PTHR36495', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244951, NULL, 'PTHR21237', NULL, NULL, NULL, NULL, 'GRPE PROTEIN', NULL, NULL, 3633, 8),
(244952, NULL, 'PTHR32341', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCIBLE GTPASE', NULL, NULL, NULL, 8),
(244953, NULL, 'PTHR16305', NULL, NULL, NULL, NULL, 'TESTICULAR SOLUBLE ADENYLYL CYCLASE', NULL, NULL, NULL, 8),
(244954, NULL, 'PTHR32468', NULL, NULL, NULL, NULL, 'CATION/H +  ANTIPORTER', NULL, NULL, NULL, 8),
(244955, NULL, 'PTHR47805', NULL, NULL, NULL, NULL, 'SAGA-ASSOCIATED FACTOR 73', NULL, NULL, 30025, 8),
(244956, NULL, 'PTHR12805', NULL, NULL, NULL, NULL, 'KIN17  KIN, ANTIGENIC DETERMINANT OF RECA PROTEIN HOMOLOG', NULL, NULL, 33098, 8),
(244957, NULL, 'PTHR36736', NULL, NULL, NULL, NULL, 'OS03G0100030 PROTEIN', NULL, NULL, NULL, 8),
(244958, NULL, 'PTHR14696', NULL, NULL, NULL, NULL, 'HERMANSKY-PUDLAK SYNDROME 6 PROTEIN', NULL, NULL, 15014, 8),
(244959, NULL, 'PTHR47256', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', NULL, NULL, NULL, 8),
(244960, NULL, 'PTHR35569', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(244961, NULL, 'PTHR16757', NULL, NULL, NULL, NULL, 'DENDRIN', NULL, NULL, 23325, 8),
(244962, NULL, 'PTHR47336', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR HMS1-RELATED', NULL, NULL, NULL, 8),
(244963, NULL, 'PTHR13399', NULL, NULL, NULL, NULL, 'TRANSLOCON-ASSOCIATED PROTEIN  TRAP , GAMMA SUBUNIT', NULL, NULL, 12815, 8),
(244964, NULL, 'PTHR22930', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 34241, 8),
(244965, NULL, 'PTHR36053', NULL, NULL, NULL, NULL, 'OSJNBB0017I01.18 PROTEIN', NULL, NULL, NULL, 8),
(244966, NULL, 'PTHR21500', NULL, NULL, NULL, NULL, 'TUBULIN-SPECIFIC CHAPERONE A', NULL, NULL, 3984, 8),
(244967, NULL, 'PTHR23245', NULL, NULL, NULL, NULL, 'TRNA METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(244968, NULL, 'PTHR38612', NULL, NULL, NULL, NULL, 'PROTEIN DCT-5-RELATED', NULL, NULL, 19646, 8),
(244969, NULL, 'PTHR47471', NULL, NULL, NULL, NULL, 'GYF DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(244970, NULL, 'PTHR19278', NULL, NULL, NULL, NULL, 'OROTATE PHOSPHORIBOSYLTRANSFERASE', NULL, NULL, NULL, 8),
(244971, NULL, 'PTHR31740', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN L', NULL, NULL, 21761, 8),
(244972, NULL, 'PTHR46247', NULL, NULL, NULL, NULL, 'CRS2-ASSOCIATED FACTOR 1, CHLOROPLASTIC', NULL, NULL, 34527, 8),
(244973, NULL, 'PTHR35450', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(244974, NULL, 'PTHR21520', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 24424, 8),
(244975, NULL, 'PTHR39425', NULL, NULL, NULL, NULL, 'LIPOPROTEIN CYTOCHROME C', NULL, NULL, 32964, 8),
(244976, NULL, 'PTHR14490', NULL, NULL, NULL, NULL, 'ZINC FINGER, ZZ TYPE', NULL, NULL, 19491, 8),
(244977, NULL, 'PTHR16011', NULL, NULL, NULL, NULL, 'IFT57/HIPPI', NULL, NULL, 19381, 8),
(244978, NULL, 'PTHR31995', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR IIS FAMILY PROTEIN-RELATED', NULL, NULL, NULL, 8),
(244979, NULL, 'PTHR31988', NULL, NULL, NULL, NULL, 'ESTERASE, PUTATIVE (DUF303)-RELATED', NULL, NULL, NULL, 8),
(244980, NULL, 'PTHR36973', NULL, NULL, NULL, NULL, 'SLL1456 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(244981, NULL, 'PTHR40629', NULL, NULL, NULL, NULL, 'PRO41 PROTEIN', NULL, NULL, NULL, 8),
(244982, NULL, 'PTHR35155', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 24', NULL, NULL, 21830, 8),
(244983, NULL, 'PTHR20772', NULL, NULL, NULL, NULL, 'PROTEIN FMP42', NULL, NULL, NULL, 8),
(244984, NULL, 'PTHR28280', NULL, NULL, NULL, NULL, 'SHUTTLING PRE-60S FACTOR ECM1', NULL, NULL, NULL, 8),
(244985, NULL, 'PTHR22966', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 12040, 8);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(244986, NULL, 'PTHR31895', NULL, NULL, NULL, NULL, 'PROTEIN CBG03177-RELATED', NULL, NULL, NULL, 8),
(244987, NULL, 'PTHR33473', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE ADAPTER PROTEIN CLPS1, CHLOROPLASTIC', NULL, NULL, 14997, 8),
(244988, NULL, 'PTHR40637', NULL, NULL, NULL, NULL, 'ESSS SUBUNIT OF NADH:UBIQUINONE OXIDOREDUCTASE (COMPLEX I) PROTEIN', NULL, NULL, NULL, 8),
(244989, NULL, 'PTHR31650', NULL, NULL, NULL, NULL, 'O-ACYLTRANSFERASE (WSD1-LIKE) FAMILY PROTEIN', NULL, NULL, 35988, 8),
(244990, NULL, 'PTHR34113', NULL, NULL, NULL, NULL, 'INACTIVE PURPLE ACID PHOSPHATASE-LIKE PROTEIN', NULL, NULL, NULL, 8),
(244991, NULL, 'PTHR46664', NULL, NULL, NULL, NULL, 'ATM INTERACTOR', NULL, NULL, NULL, 8),
(244992, NULL, 'PTHR37946', NULL, NULL, NULL, NULL, 'SLL1969 PROTEIN', NULL, NULL, NULL, 8),
(244993, NULL, 'PTHR33539', NULL, NULL, NULL, NULL, 'UPF0764 PROTEIN C16ORF89', NULL, NULL, 25902, 8),
(244994, NULL, 'PTHR46282', NULL, NULL, NULL, NULL, 'LEUCINE-RICH MELANOCYTE DIFFERENTIATION-ASSOCIATED PROTEIN', NULL, NULL, 34726, 8),
(244995, NULL, 'PTHR38700', NULL, NULL, NULL, NULL, 'YALI0E22418P', NULL, NULL, NULL, 8),
(244996, NULL, 'PTHR30346', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL DUAL REGULATOR HCAR-RELATED', NULL, NULL, NULL, 8),
(244997, NULL, 'PTHR43489', NULL, NULL, NULL, NULL, 'ISOMERASE', NULL, NULL, NULL, 8),
(244998, NULL, 'PTHR20910', NULL, NULL, NULL, NULL, 'AGAP001623-PA', NULL, NULL, NULL, 8),
(244999, NULL, 'PTHR34592', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(245000, NULL, 'PTHR17178', NULL, NULL, NULL, NULL, 'SECRETORY GRANULE PROTEOGLYCAN CORE PROTEIN', NULL, NULL, NULL, 8),
(245001, NULL, 'PTHR32183', NULL, NULL, NULL, NULL, '', NULL, NULL, 36978, 8),
(245002, NULL, 'PTHR30481', NULL, NULL, NULL, NULL, 'DNA ADENINE METHYLASE', NULL, NULL, 11638, 8),
(245003, NULL, 'PTHR35543', NULL, NULL, NULL, NULL, 'PROTEIN C11ORF74', NULL, NULL, 27346, 8),
(245004, NULL, 'PTHR10876', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZPR1', NULL, NULL, 30392, 8),
(245005, NULL, 'PTHR39650', NULL, NULL, NULL, NULL, 'CDP-ARCHAEOL SYNTHASE', NULL, NULL, 21575, 8),
(245006, NULL, 'PTHR31029', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE-LIKE PROTEIN', NULL, NULL, 34620, 8),
(245007, NULL, 'PTHR47774', NULL, NULL, NULL, NULL, 'GROWTH-DIFFERENTIATION TRANSITION PROTEIN 5-RELATED', NULL, NULL, NULL, 8),
(245008, NULL, 'PTHR15999', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 35586, 8),
(245009, NULL, 'PTHR39364', NULL, NULL, NULL, NULL, 'PROTEIN CBG04867', NULL, NULL, NULL, 8),
(245010, NULL, 'PTHR14873', NULL, NULL, NULL, NULL, 'OS06G0694100 PROTEIN', NULL, NULL, NULL, 8),
(245011, NULL, 'PTHR36089', NULL, NULL, NULL, NULL, 'CHITIN SYNTHASE 3 COMPLEX PROTEIN CSI2-RELATED', NULL, NULL, NULL, 8),
(245012, NULL, 'PTHR33766', NULL, NULL, NULL, NULL, 'PROTEIN FAM181B', NULL, NULL, 26203, 8),
(245013, NULL, 'PTHR16445', NULL, NULL, NULL, NULL, 'SIMILAR TO HYPOTHETICAL PROTEIN FLJ20010', NULL, NULL, 25263, 8),
(245014, NULL, 'PTHR11958', NULL, NULL, NULL, NULL, 'SODIUM/DICARBOXYLATE SYMPORTER-RELATED', NULL, NULL, NULL, 8),
(245015, NULL, 'PTHR37735', NULL, NULL, NULL, NULL, 'OS08G0567000 PROTEIN', NULL, NULL, NULL, 8),
(245016, NULL, 'PTHR35464', NULL, NULL, NULL, NULL, 'OS06G0115200 PROTEIN', NULL, NULL, 34044, 8),
(245017, NULL, 'PTHR47177', NULL, NULL, NULL, NULL, 'F18C1.6 PROTEIN', NULL, NULL, NULL, 8),
(245018, NULL, 'PTHR44743', NULL, NULL, NULL, NULL, 'PUTATIVE, EXPRESSED-RELATED', NULL, NULL, NULL, 8),
(245019, NULL, 'PTHR12931', NULL, NULL, NULL, NULL, 'UBIQUITIN THIOLESTERASE PROTEIN OTUB', NULL, NULL, 16974, 8),
(245020, NULL, 'PTHR12788', NULL, NULL, NULL, NULL, 'PROTEIN-TYROSINE SULFOTRANSFERASE 2', NULL, NULL, 25378, 8),
(245021, NULL, 'PTHR33133', NULL, NULL, NULL, NULL, 'OS08G0107100 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245022, NULL, 'PTHR48100', NULL, NULL, NULL, NULL, 'BROAD-SPECIFICITY PHOSPHATASE YOR283W-RELATED', NULL, NULL, NULL, 8),
(245023, NULL, 'PTHR16151', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 22090, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(245024, NULL, 'PTHR23504', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY DOMAIN-CONTAINING PROTEIN 10', NULL, NULL, NULL, 8),
(245025, NULL, 'PTHR44360', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY B MEMBER 9', NULL, NULL, NULL, 8),
(245026, NULL, 'PTHR45941', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(245027, NULL, 'PTHR23239', NULL, NULL, NULL, NULL, 'INTERMEDIATE FILAMENT', NULL, NULL, 6510, 8),
(245028, NULL, 'PTHR38796', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(245029, NULL, 'PTHR15154', NULL, NULL, NULL, NULL, 'HAMARTIN', NULL, NULL, 10164, 8),
(245030, NULL, 'PTHR40368', NULL, NULL, NULL, NULL, 'YALI0F14399P', NULL, NULL, NULL, 8),
(245031, NULL, 'PTHR36050', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE 30', NULL, NULL, NULL, 8),
(245032, NULL, 'PTHR33303', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245033, NULL, 'PTHR15439', NULL, NULL, NULL, NULL, 'RETINOBLASTOMA-BINDING PROTEIN 6', NULL, NULL, 32175, 8),
(245034, NULL, 'PTHR28288', NULL, NULL, NULL, NULL, 'PROTEASE B INHIBITOR 2', NULL, NULL, NULL, 8),
(245035, NULL, 'PTHR37936', NULL, NULL, NULL, NULL, 'TRANSPOSASE INSC FOR INSERTION ELEMENT IS2A-RELATED', NULL, NULL, NULL, 8),
(245036, NULL, 'PTHR45618', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL DICARBOXYLATE CARRIER-RELATED', NULL, NULL, NULL, 8),
(245037, NULL, 'PTHR33982', NULL, NULL, NULL, NULL, 'OUTER ENVELOPE MEMBRANE PROTEIN 7-RELATED', NULL, NULL, 31542, 8),
(245038, NULL, 'PTHR42946', NULL, NULL, NULL, NULL, 'PHOSPHOHEXOSE MUTASE', NULL, NULL, NULL, 8),
(245039, NULL, 'PTHR40636', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(245040, NULL, 'PTHR46681', NULL, NULL, NULL, NULL, 'KINETOCHORE PROTEIN NDC80 HOMOLOG', NULL, NULL, NULL, 8),
(245041, NULL, 'PTHR42743', NULL, NULL, NULL, NULL, 'AMINO-ACID AMINOTRANSFERASE', NULL, NULL, NULL, 8),
(245042, NULL, 'PTHR12425', NULL, NULL, NULL, NULL, 'SYNEMBRYN', NULL, NULL, 14630, 8),
(245043, NULL, 'PTHR45048', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(245044, NULL, 'PTHR23248', NULL, NULL, NULL, NULL, 'PHOSPHOLIPID SCRAMBLASE-RELATED', NULL, NULL, 1733, 8),
(245045, NULL, 'PTHR48162', NULL, NULL, NULL, NULL, 'YALI0A06930P', NULL, NULL, NULL, 8),
(245046, NULL, 'PTHR12418', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A THIOESTERASE THEM4', NULL, NULL, NULL, 8),
(245047, NULL, 'PTHR23065', NULL, NULL, NULL, NULL, 'PROLINE-SERINE-THREONINE PHOSPHATASE INTERACTING PROTEIN 1', NULL, NULL, NULL, 8),
(245048, NULL, 'PTHR33162', NULL, NULL, NULL, NULL, 'SEC-INDEPENDENT PROTEIN TRANSLOCASE PROTEIN TATA, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(245049, NULL, 'PTHR43594', NULL, NULL, NULL, NULL, 'QUERCETIN 2,3-DIOXYGENASE', NULL, NULL, NULL, 8),
(245050, NULL, 'PTHR34718', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(245051, NULL, 'PTHR46937', NULL, NULL, NULL, NULL, 'FERREDOXIN-THIOREDOXIN REDUCTASE, VARIABLE CHAIN', NULL, NULL, 36684, 8),
(245052, NULL, 'PTHR46049', NULL, NULL, NULL, NULL, 'AGAP003327-PA', NULL, NULL, NULL, 8),
(245053, NULL, 'PTHR31992', NULL, NULL, NULL, NULL, 'DOF ZINC FINGER PROTEIN DOF1.4-RELATED', NULL, NULL, 34593, 8),
(245054, NULL, 'PTHR12482', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 35339, 8),
(245055, NULL, 'PTHR10743', NULL, NULL, NULL, NULL, 'PROTEIN RER1', NULL, NULL, 1588, 8),
(245056, NULL, 'PTHR35039', NULL, NULL, NULL, NULL, '3-KETO-L-GULONATE-6-PHOSPHATE DECARBOXYLASE SGBH-RELATED', NULL, NULL, NULL, 8),
(245057, NULL, 'PTHR12062', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINYLTRANSFERASE VI', NULL, NULL, 3370, 8),
(245058, NULL, 'PTHR34418', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP214 ISOFORM X1', NULL, NULL, 34837, 8),
(245059, NULL, 'PTHR28591', NULL, NULL, NULL, NULL, 'LATEXIN', NULL, NULL, 11678, 8),
(245060, NULL, 'PTHR22435', NULL, NULL, NULL, NULL, 'CHROMOSOME 6 OPEN READING FRAME 222', NULL, NULL, 4879, 8),
(245061, NULL, 'PTHR34456', NULL, NULL, NULL, NULL, 'MITOVIRUS RNA-DEPENDENT RNA POLYMERASE', NULL, NULL, 12686, 8),
(245062, NULL, 'PTHR33683', NULL, NULL, NULL, NULL, '1, PUTATIVE-RELATED', NULL, NULL, NULL, 8);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(245063, NULL, 'PTHR45613', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(245064, NULL, 'PTHR36057', NULL, NULL, NULL, NULL, '', NULL, NULL, 9109, 8),
(245065, NULL, 'PTHR36155', NULL, NULL, NULL, NULL, 'BLL5354 PROTEIN', NULL, NULL, 267, 8),
(245066, NULL, 'PTHR34000', NULL, NULL, NULL, NULL, 'LRRGT00142-RELATED', NULL, NULL, NULL, 8),
(245067, NULL, 'PTHR44090', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 61', NULL, NULL, NULL, 8),
(245068, NULL, 'PTHR35534', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L32', NULL, NULL, 35341, 8),
(245069, NULL, 'PTHR43464', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(245070, NULL, 'PTHR36539', NULL, NULL, NULL, NULL, 'ETHANOLAMINE UTILIZATION PROTEIN EUTN', NULL, NULL, 778, 8),
(245071, NULL, 'PTHR42739', NULL, NULL, NULL, NULL, 'MALATE SYNTHASE G', NULL, NULL, 3775, 8),
(245072, NULL, 'PTHR37871', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 22', NULL, NULL, 25991, 8),
(245073, NULL, 'PTHR31433', NULL, NULL, NULL, NULL, 'PX DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, 31741, 8),
(245074, NULL, 'PTHR45839', NULL, NULL, NULL, NULL, '', NULL, NULL, 12782, 8),
(245075, NULL, 'PTHR21531', NULL, NULL, NULL, NULL, 'LOW-TEMPERATURE VIABILITY PROTEIN LTV1-RELATED', NULL, NULL, 4966, 8),
(245076, NULL, 'PTHR47318', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP37, CHLOROPLASTIC', NULL, NULL, 34886, 8),
(245077, NULL, 'PTHR34395', NULL, NULL, NULL, NULL, 'OS11G0427500 PROTEIN', NULL, NULL, NULL, 8),
(245078, NULL, 'PTHR45376', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245079, NULL, 'PTHR36003', NULL, NULL, NULL, NULL, 'TONB-DEPENDENT HEME RECEPTOR A', NULL, NULL, NULL, 8),
(245080, NULL, 'PTHR46150', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 100F', NULL, NULL, NULL, 8),
(245081, NULL, 'PTHR36114', NULL, NULL, NULL, NULL, '16.7 KDA PROTEIN IN WHIE LOCUS', NULL, NULL, NULL, 8),
(245082, NULL, 'PTHR12312', NULL, NULL, NULL, NULL, 'TWISTED GASTRULATION PROTEIN HOMOLOG 1-A-RELATED', NULL, NULL, 3151, 8),
(245083, NULL, 'PTHR32315', NULL, NULL, NULL, NULL, 'ADENINE PHOSPHORIBOSYLTRANSFERASE', NULL, NULL, NULL, 8),
(245084, NULL, 'PTHR22698', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN 9', NULL, NULL, 32608, 8),
(245085, NULL, 'PTHR12413', NULL, NULL, NULL, NULL, 'DOLICHYL GLYCOSYLTRANSFERASE', NULL, NULL, 7099, 8),
(245086, NULL, 'PTHR10340', NULL, NULL, NULL, NULL, 'SPHINGOMYELIN PHOSPHODIESTERASE', NULL, NULL, NULL, 8),
(245087, NULL, 'PTHR30194', NULL, NULL, NULL, NULL, 'CROSSOVER JUNCTION ENDODEOXYRIBONUCLEASE RUVC', NULL, NULL, 5021, 8),
(245088, NULL, 'PTHR39757', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(245089, NULL, 'PTHR12903', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOMAL PROTEIN L24', NULL, NULL, 2995, 8),
(245090, NULL, 'PTHR38451', NULL, NULL, NULL, NULL, 'TRNA (ADENINE(22)-N(1))-METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(245091, NULL, 'PTHR21549', NULL, NULL, NULL, NULL, 'MUTATED IN BLADDER CANCER 1', NULL, NULL, 31132, 8),
(245092, NULL, 'PTHR46813', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 18', NULL, NULL, 36019, 8),
(245093, NULL, 'PTHR32387', NULL, NULL, NULL, NULL, 'WU:FJ29H11', NULL, NULL, NULL, 8),
(245094, NULL, 'PTHR34680', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(245095, NULL, 'PTHR14609', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 219', NULL, NULL, 32673, 8),
(245096, NULL, 'PTHR24298', NULL, NULL, NULL, NULL, 'FLAVONOID 3''-MONOOXYGENASE-RELATED', NULL, NULL, NULL, 8),
(245097, NULL, 'PTHR14553', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN C1ORF50', NULL, NULL, 19475, 8),
(245098, NULL, 'PTHR46526', NULL, NULL, NULL, NULL, 'CHORDIN', NULL, NULL, NULL, 8),
(245099, NULL, 'PTHR20835', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE PPP1R11-RELATED', NULL, NULL, 11332, 8),
(245100, NULL, 'PTHR37485', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN FTSB', NULL, NULL, 15210, 8),
(245101, NULL, 'PTHR40277', NULL, NULL, NULL, NULL, 'BLL5419 PROTEIN', NULL, NULL, NULL, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(245102, NULL, 'PTHR35346', NULL, NULL, NULL, NULL, 'BEN DOMAIN-CONTAINING PROTEIN 6', NULL, NULL, 27165, 8),
(245103, NULL, 'PTHR32325', NULL, NULL, NULL, NULL, 'BETA-ELIMINATING LYASE-LIKE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245104, NULL, 'PTHR12050', NULL, NULL, NULL, NULL, 'LEPTIN RECEPTOR-RELATED', NULL, NULL, 6813, 8),
(245105, NULL, 'PTHR12021', NULL, NULL, NULL, NULL, 'THYMOSIN BETA', NULL, NULL, 1377, 8),
(245106, NULL, 'PTHR46870', NULL, NULL, NULL, NULL, 'PROTEIN THYLAKOID ASSEMBLY 8-LIKE, CHLOROPLASTIC', NULL, NULL, 35996, 8),
(245107, NULL, 'PTHR36715', NULL, NULL, NULL, NULL, 'BNAANNG41370D PROTEIN', NULL, NULL, NULL, 8),
(245108, NULL, 'PTHR44757', NULL, NULL, NULL, NULL, 'DIGUANYLATE CYCLASE DGCP', NULL, NULL, NULL, 8),
(245109, NULL, 'PTHR12608', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN HTP-1 RELATED', NULL, NULL, 3321, 8),
(245110, NULL, 'PTHR47581', NULL, NULL, NULL, NULL, 'OS09G0431600 PROTEIN', NULL, NULL, 36717, 8),
(245111, NULL, 'PTHR38325', NULL, NULL, NULL, NULL, 'MCG55969', NULL, NULL, 31079, 8),
(245112, NULL, 'PTHR23360', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(245113, NULL, 'PTHR46422', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE BSL3', NULL, NULL, NULL, 8),
(245114, NULL, 'PTHR23280', NULL, NULL, NULL, NULL, '4.1 G PROTEIN', NULL, NULL, NULL, 8),
(245115, NULL, 'PTHR15249', NULL, NULL, NULL, NULL, 'TRAF FAMILY MEMBER-ASSOCIATED NF-KAPPA-B ACTIVATOR', NULL, NULL, 27163, 8),
(245116, NULL, 'PTHR48208', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN I', NULL, NULL, NULL, 8),
(245117, NULL, 'PTHR38468', NULL, NULL, NULL, NULL, 'SLL0939 PROTEIN', NULL, NULL, 13174, 8),
(245118, NULL, 'PTHR31817', NULL, NULL, NULL, NULL, '', NULL, NULL, 8595, 8),
(245119, NULL, 'PTHR33336', NULL, NULL, NULL, NULL, 'QUINOL MONOOXYGENASE YGIN-RELATED', NULL, NULL, NULL, 8),
(245120, NULL, 'PTHR24119', NULL, NULL, NULL, NULL, 'ACYL-COA-BINDING DOMAIN-CONTAINING PROTEIN 6', NULL, NULL, NULL, 8),
(245121, NULL, 'PTHR36565', NULL, NULL, NULL, NULL, 'UPF0332 PROTEIN TM_1000', NULL, NULL, NULL, 8),
(245122, NULL, 'PTHR44969', NULL, NULL, NULL, NULL, 'CELL SURFACE A33 ANTIGEN', NULL, NULL, 34225, 8),
(245123, NULL, 'PTHR46788', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING DOMAIN-CONTAINING PROTEIN 5', NULL, NULL, NULL, 8),
(245124, NULL, 'PTHR46653', NULL, NULL, NULL, NULL, 'SPECIFICITY PROTEIN PHOSPHATASE, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(245125, NULL, 'PTHR45782', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOME-ASSOCIATED GTPASE 1', NULL, NULL, NULL, 8),
(245126, NULL, 'PTHR33709', NULL, NULL, NULL, NULL, 'OSJNBA0035M09.9 PROTEIN', NULL, NULL, 27989, 8),
(245127, NULL, 'PTHR19308', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLCHOLINE TRANSFER PROTEIN', NULL, NULL, NULL, 8),
(245128, NULL, 'PTHR48157', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(245129, NULL, 'PTHR11475', NULL, NULL, NULL, NULL, 'OXIDASE/PEROXIDASE', NULL, NULL, NULL, 8),
(245130, NULL, 'PTHR36296', NULL, NULL, NULL, NULL, 'GAMMA-CRYSTALLIN A', NULL, NULL, 30088, 8),
(245131, NULL, 'PTHR19327', NULL, NULL, NULL, NULL, 'GOLGIN', NULL, NULL, NULL, 8),
(245132, NULL, 'PTHR46772', NULL, NULL, NULL, NULL, 'BHLH DOMAIN-CONTAINING PROTEIN', NULL, NULL, 36384, 8),
(245133, NULL, 'PTHR22807', NULL, NULL, NULL, NULL, 'NOP2 YEAST -RELATED NOL1/NOP2/FMU SUN  DOMAIN-CONTAINING', NULL, NULL, 14055, 8),
(245134, NULL, 'PTHR43175', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', NULL, NULL, 3319, 8),
(245135, NULL, 'PTHR43005', NULL, NULL, NULL, NULL, 'BLR7065 PROTEIN', NULL, NULL, NULL, 8),
(245136, NULL, 'PTHR12861', NULL, NULL, NULL, NULL, 'TRANSLOCON-ASSOCIATED PROTEIN, BETA SUBUNIT PRECURSOR  TRAP-BETA   SIGNAL SEQUENCE RECEPTOR BETA SUBUNIT', NULL, NULL, NULL, 8),
(245137, NULL, 'PTHR12963', NULL, NULL, NULL, NULL, 'THYROID RECEPTOR INTERACTING PROTEIN RELATED', NULL, NULL, 27840, 8),
(245138, NULL, 'PTHR36082', NULL, NULL, NULL, NULL, '', NULL, NULL, 1612, 8),
(245139, NULL, 'PTHR34862', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(245140, NULL, 'PTHR43666', NULL, NULL, NULL, NULL, 'TLDD PROTEIN', NULL, NULL, NULL, 8);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(245141, NULL, 'PTHR37457', NULL, NULL, NULL, NULL, 'TRNA SELENOCYSTEINE 1-ASSOCIATED PROTEIN 1-RELATED', NULL, NULL, 28540, 8),
(245142, NULL, 'PTHR38595', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245143, NULL, 'PTHR48030', NULL, NULL, NULL, NULL, 'SPLICING FACTOR 3B SUBUNIT 4', NULL, NULL, NULL, 8),
(245144, NULL, 'PTHR30011', NULL, NULL, NULL, NULL, 'ALKANESULFONATE MONOOXYGENASE-RELATED', NULL, NULL, NULL, 8),
(245145, NULL, 'PTHR21224', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 31483, 8),
(245146, NULL, 'PTHR11728', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE DEHYDROGENASE', NULL, NULL, NULL, 8),
(245147, NULL, 'PTHR35095', NULL, NULL, NULL, NULL, 'OS05G0143300 PROTEIN', NULL, NULL, NULL, 8),
(245148, NULL, 'PTHR40699', NULL, NULL, NULL, NULL, 'UPF0179 PROTEIN MJ1627', NULL, NULL, 6355, 8),
(245149, NULL, 'PTHR43294', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM-TRANSPORTING ATPASE SUBUNIT ALPHA', NULL, NULL, NULL, 8),
(245150, NULL, 'PTHR40086', NULL, NULL, NULL, NULL, 'PHOSPHOTRANSFERASE YTMP-RELATED', NULL, NULL, NULL, 8),
(245151, NULL, 'PTHR31314', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR PHL7-LIKE', NULL, NULL, NULL, 8),
(245152, NULL, 'PTHR23299', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN', NULL, NULL, 2164, 8),
(245153, NULL, 'PTHR33678', NULL, NULL, NULL, NULL, 'BLL1576 PROTEIN', NULL, NULL, NULL, 8),
(245154, NULL, 'PTHR23090', NULL, NULL, NULL, NULL, 'NH 3 /GLUTAMINE-DEPENDENT NAD +  SYNTHETASE', NULL, NULL, 1517, 8),
(245155, NULL, 'PTHR10027', NULL, NULL, NULL, NULL, 'CALCIUM-ACTIVATED POTASSIUM CHANNEL ALPHA CHAIN', NULL, NULL, NULL, 8),
(245156, NULL, 'PTHR47807', NULL, NULL, NULL, NULL, 'PROTEIN TBF1', NULL, NULL, NULL, 8),
(245157, NULL, 'PTHR12820', NULL, NULL, NULL, NULL, 'VACUOLAR SORTING PROTEIN 53', NULL, NULL, 33229, 8),
(245158, NULL, 'PTHR36444', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR PROTEIN YOBU-RELATED', NULL, NULL, NULL, 8),
(245159, NULL, 'PTHR28590', NULL, NULL, NULL, NULL, 'SPEXIN', NULL, NULL, 21682, 8),
(245160, NULL, 'PTHR46245', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS07G0563300', NULL, NULL, NULL, 8),
(245161, NULL, 'PTHR31263', NULL, NULL, NULL, NULL, 'CELLULASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_5G14560)', NULL, NULL, NULL, 8),
(245162, NULL, 'PTHR23187', NULL, NULL, NULL, NULL, 'FLJ44216 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245163, NULL, 'PTHR47906', NULL, NULL, NULL, NULL, 'OSJNBB0050O03.9 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245164, NULL, 'PTHR35332', NULL, NULL, NULL, NULL, 'REGULATION OF ENOLASE PROTEIN 1', NULL, NULL, 13125, 8),
(245165, NULL, 'PTHR39669', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(245166, NULL, 'PTHR16451', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL DYNAMICS PROTEINS 49/51 FAMILY MEMBER', NULL, NULL, 34031, 8),
(245167, NULL, 'PTHR34676', NULL, NULL, NULL, NULL, 'DUF4219 DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245168, NULL, 'PTHR11653', NULL, NULL, NULL, NULL, 'PARVALBUMIN ALPHA', NULL, NULL, 6178, 8),
(245169, NULL, 'PTHR31192', NULL, NULL, NULL, NULL, 'SPERM-SPECIFIC FAMILY, CLASS Q', NULL, NULL, NULL, 8),
(245170, NULL, 'PTHR37066', NULL, NULL, NULL, NULL, 'HELICASE-ASSOCIATED', NULL, NULL, NULL, 8),
(245171, NULL, 'PTHR31851', NULL, NULL, NULL, NULL, 'FE(2+)/MN(2+) TRANSPORTER PCL1', NULL, NULL, 535, 8),
(245172, NULL, 'PTHR38442', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245173, NULL, 'PTHR34822', NULL, NULL, NULL, NULL, 'GRPB DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_1G01530)', NULL, NULL, 5933, 8),
(245174, NULL, 'PTHR24367', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(245175, NULL, 'PTHR14083', NULL, NULL, NULL, NULL, 'YIP1 INTERACTING FACTOR HOMOLOG  YIF1 PROTEIN', NULL, NULL, 1594, 8),
(245176, NULL, 'PTHR12121', NULL, NULL, NULL, NULL, 'CARBON CATABOLITE REPRESSOR PROTEIN 4', NULL, NULL, NULL, 8),
(245177, NULL, 'PTHR37792', NULL, NULL, NULL, NULL, 'RIBONUCLEASE MRP PROTEIN SUBUNIT RMP1', NULL, NULL, NULL, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(245178, NULL, 'PTHR34407', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(245179, NULL, 'PTHR30163', NULL, NULL, NULL, NULL, 'MEMBRANE-BOUND LYTIC MUREIN TRANSGLYCOSYLASE B', NULL, NULL, 34126, 8),
(245180, NULL, 'PTHR46038', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', NULL, NULL, 36813, 8),
(245181, NULL, 'PTHR33295', NULL, NULL, NULL, NULL, 'ATPASE', NULL, NULL, NULL, 8),
(245182, NULL, 'PTHR31528', NULL, NULL, NULL, NULL, '4-AMINO-5-HYDROXYMETHYL-2-METHYLPYRIMIDINE PHOSPHATE SYNTHASE THI11-RELATED', NULL, NULL, 23890, 8),
(245183, NULL, 'PTHR47742', NULL, NULL, NULL, NULL, 'GAMETOGENETIN', NULL, NULL, 25349, 8),
(245184, NULL, 'PTHR30154', NULL, NULL, NULL, NULL, 'LEUCINE-RESPONSIVE REGULATORY PROTEIN', NULL, NULL, NULL, 8),
(245185, NULL, 'PTHR46287', NULL, NULL, NULL, NULL, 'BTB/POZ AND TAZ DOMAIN-CONTAINING PROTEIN 3-RELATED', NULL, NULL, 34149, 8),
(245186, NULL, 'PTHR39223', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1700029H14 GENE', NULL, NULL, 27079, 8),
(245187, NULL, 'PTHR38431', NULL, NULL, NULL, NULL, 'BLL2305 PROTEIN', NULL, NULL, NULL, 8),
(245188, NULL, 'PTHR10138', NULL, NULL, NULL, NULL, 'TRYPTOPHAN 2,3-DIOXYGENASE', NULL, NULL, 852, 8),
(245189, NULL, 'PTHR11776', NULL, NULL, NULL, NULL, 'ADENINE PHOSPHORIBOSYLTRANSFERASE', NULL, NULL, NULL, 8),
(245190, NULL, 'PTHR33166', NULL, NULL, NULL, NULL, 'GAG_P30 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(245191, NULL, 'PTHR43664', NULL, NULL, NULL, NULL, 'MONOAMINE OXIDASE-RELATED', NULL, NULL, NULL, 8),
(245192, NULL, 'PTHR41800', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(245193, NULL, 'PTHR46176', NULL, NULL, NULL, NULL, 'LD21662P', NULL, NULL, 22837, 8),
(245194, NULL, 'PTHR14511', NULL, NULL, NULL, NULL, 'G PROTEIN COUPLED RECEPTOR, CLASS C, GROUP 5', NULL, NULL, NULL, 8),
(245195, NULL, 'PTHR23087', NULL, NULL, NULL, NULL, 'NONHISTONE CHROMOSOMAL PROTEIN HMG', NULL, NULL, NULL, 8),
(245196, NULL, 'PTHR28032', NULL, NULL, NULL, NULL, 'FI02826P', NULL, NULL, 9685, 8),
(245197, NULL, 'PTHR46983', NULL, NULL, NULL, NULL, 'CYSTEINE AND HISTIDINE-RICH DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(245198, NULL, 'PTHR11913', NULL, NULL, NULL, NULL, 'COFILIN-RELATED', NULL, NULL, 8375, 8),
(245199, NULL, 'PTHR31065', NULL, NULL, NULL, NULL, 'PLATZ TRANSCRIPTION FACTOR FAMILY PROTEIN', NULL, NULL, NULL, 8),
(245200, NULL, 'PTHR13491', NULL, NULL, NULL, NULL, 'ZCCHC10 PROTEIN', NULL, NULL, 28143, 8),
(245201, NULL, 'PTHR33321', NULL, NULL, NULL, NULL, '', NULL, NULL, 10724, 8),
(245202, NULL, 'PTHR43265', NULL, NULL, NULL, NULL, 'ESTERASE ESTD', NULL, NULL, NULL, 8),
(245203, NULL, 'PTHR46913', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL16', NULL, NULL, 36368, 8),
(245204, NULL, 'PTHR11422', NULL, NULL, NULL, NULL, 'T-CELL SURFACE GLYCOPROTEIN CD4', NULL, NULL, NULL, 8),
(245205, NULL, 'PTHR34828', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 45', NULL, NULL, 23789, 8),
(245206, NULL, 'PTHR23008', NULL, NULL, NULL, NULL, 'CHROMOSOME 28 C10ORF62 HOMOLOG', NULL, NULL, 31183, 8),
(245207, NULL, 'PTHR45789', NULL, NULL, NULL, NULL, 'FI18025P1', NULL, NULL, NULL, 8),
(245208, NULL, 'PTHR13634', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS PROTEIN BRIX', NULL, NULL, 21405, 8),
(245209, NULL, 'PTHR35482', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT', NULL, NULL, NULL, 8),
(245210, NULL, 'PTHR15961', NULL, NULL, NULL, NULL, 'PROTEIN EURL HOMOLOG', NULL, NULL, 11629, 8),
(245211, NULL, 'PTHR31307', NULL, NULL, NULL, NULL, 'TRIHELIX TRANSCRIPTION FACTOR ASIL2', NULL, NULL, 34851, 8),
(245212, NULL, 'PTHR37193', NULL, NULL, NULL, NULL, 'ALPHA-1,6-MANNOSYL-GLYCOPROTEIN 2-BETA-N-ACETYLGLUCOSAMINYLTRANSFERASE', NULL, NULL, NULL, 8),
(245213, NULL, 'PTHR36686', NULL, NULL, NULL, NULL, 'SYNAPTONEMAL COMPLEX CENTRAL ELEMENT PROTEIN 3', NULL, NULL, 21950, 8),
(245214, NULL, 'PTHR14882', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING 74A', NULL, NULL, 31275, 8),
(245215, NULL, 'PTHR39178', NULL, NULL, NULL, NULL, 'HYPOTHETICAL RIBOSOME-ASSOCIATED PROTEIN', NULL, NULL, 3544, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(245216, NULL, 'PTHR11800', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE', NULL, NULL, NULL, 8),
(245217, NULL, 'PTHR28065', NULL, NULL, NULL, NULL, 'FREQUENIN', NULL, NULL, NULL, 8),
(245218, NULL, 'PTHR33732', NULL, NULL, NULL, NULL, 'REF/SRPP-LIKE PROTEIN OS05G0151300/LOC_OS05G05940', NULL, NULL, 13887, 8),
(245219, NULL, 'PTHR10849', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE  UBIQUINONE  IRON-SULFUR PROTEIN 8, MITOCHONDRIAL', NULL, NULL, 4243, 8),
(245220, NULL, 'PTHR45181', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN DNAJ WITH TETRATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(245221, NULL, 'PTHR22937', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF165', NULL, NULL, 35213, 8),
(245222, NULL, 'PTHR32507', NULL, NULL, NULL, NULL, 'NA(+)/H(+) ANTIPORTER 1', NULL, NULL, NULL, 8),
(245223, NULL, 'PTHR24287', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', NULL, NULL, NULL, 8),
(245224, NULL, 'PTHR46787', NULL, NULL, NULL, NULL, 'SYNDROMES PUTATIVE CHAPERONIN-RELATED', NULL, NULL, 26652, 8),
(245225, NULL, 'PTHR39444', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(245226, NULL, 'PTHR43090', NULL, NULL, NULL, NULL, '1-(5-PHOSPHORIBOSYL)-5-[(5-PHOSPHORIBOSYLAMINO)METHYLIDENEAMINO] IMIDAZOLE-4-CARBOXAMIDE ISOMERASE', NULL, NULL, 34667, 8),
(245227, NULL, 'PTHR16308', NULL, NULL, NULL, NULL, 'UBIQUITIN ASSOCIATED PROTEIN 2-LIKE/LINGERER', NULL, NULL, NULL, 8),
(245228, NULL, 'PTHR30506', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(245229, NULL, 'PTHR12588', NULL, NULL, NULL, NULL, 'MYOINOSITOL OXYGENASE', NULL, NULL, 2318, 8),
(245230, NULL, 'PTHR45817', NULL, NULL, NULL, NULL, 'LYSYL OXIDASE-LIKE-RELATED', NULL, NULL, NULL, 8),
(245231, NULL, 'PTHR43829', NULL, NULL, NULL, NULL, 'AQUAPORIN OR AQUAGLYCEROPORIN RELATED', NULL, NULL, NULL, 8),
(245232, NULL, 'PTHR42919', NULL, NULL, NULL, NULL, 'N-ALPHA-ACETYLTRANSFERASE', NULL, NULL, NULL, 8),
(245233, NULL, 'PTHR46640', NULL, NULL, NULL, NULL, 'TRIACYLGLYCEROL LIPASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G06510)-RELATED', NULL, NULL, NULL, 8),
(245234, NULL, 'PTHR34545', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 22', NULL, NULL, 29290, 8),
(245235, NULL, 'PTHR14166', NULL, NULL, NULL, NULL, 'SLIT-ROBO RHO GTPASE ACTIVATING PROTEIN', NULL, NULL, NULL, 8),
(245236, NULL, 'PTHR37852', NULL, NULL, NULL, NULL, 'YALI0B21208P', NULL, NULL, NULL, 8),
(245237, NULL, 'PTHR12323', NULL, NULL, NULL, NULL, 'SR-RELATED CTD ASSOCIATED FACTOR 6', NULL, NULL, 28431, 8),
(245238, NULL, 'PTHR32003', NULL, NULL, NULL, NULL, 'PROTEIN FAM199X', NULL, NULL, 23966, 8),
(245239, NULL, 'PTHR13029', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(245240, NULL, 'PTHR38706', NULL, NULL, NULL, NULL, 'SI:CH211-198C19.1-RELATED', NULL, NULL, NULL, 8),
(245241, NULL, 'PTHR47338', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', NULL, NULL, NULL, 8),
(245242, NULL, 'PTHR35173', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(245243, NULL, 'PTHR37362', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 38', NULL, NULL, 25555, 8),
(245244, NULL, 'PTHR46682', NULL, NULL, NULL, NULL, 'ADHESION G-PROTEIN COUPLED RECEPTOR V1', NULL, NULL, 26960, 8),
(245245, NULL, 'PTHR34040', NULL, NULL, NULL, NULL, 'FLAGELLAR BIOSYNTHETIC PROTEIN FLIQ', NULL, NULL, 5091, 8),
(245246, NULL, 'PTHR15704', NULL, NULL, NULL, NULL, 'SUPERKILLER 3 PROTEIN-RELATED', NULL, NULL, 32651, 8),
(245247, NULL, 'PTHR13220', NULL, NULL, NULL, NULL, 'TIMELESS INTERACTING-RELATED', NULL, NULL, 27737, 8),
(245248, NULL, 'PTHR46180', NULL, NULL, NULL, NULL, 'VINCULIN', NULL, NULL, 19017, 8),
(245249, NULL, 'PTHR36290', NULL, NULL, NULL, NULL, 'RIKEN CDNA D630039A03 GENE', NULL, NULL, NULL, 8),
(245250, NULL, 'PTHR36059', NULL, NULL, NULL, NULL, 'OS02G0175800 PROTEIN', NULL, NULL, NULL, 8),
(245251, NULL, 'PTHR22789', NULL, NULL, NULL, NULL, 'FUCULOSE PHOSPHATE ALDOLASE', NULL, NULL, NULL, 8),
(245252, NULL, 'PTHR34717', NULL, NULL, NULL, NULL, 'EG:BACR7A4.20 PROTEIN', NULL, NULL, NULL, 8);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(245253, NULL, 'PTHR47059', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 32', NULL, NULL, NULL, 8),
(245254, NULL, 'PTHR15110', NULL, NULL, NULL, NULL, 'REGULATORY FACTOR X-ASSOCIATED PROTEIN', NULL, NULL, 24990, 8),
(245255, NULL, 'PTHR19441', NULL, NULL, NULL, NULL, 'WHEY ACDIC PROTEIN  WAP', NULL, NULL, NULL, 8),
(245256, NULL, 'PTHR23120', NULL, NULL, NULL, NULL, 'MAESTRO-RELATED HEAT DOMAIN-CONTAINING', NULL, NULL, 36857, 8),
(245257, NULL, 'PTHR28077', NULL, NULL, NULL, NULL, 'INOSITOL PHOSPHORYLCERAMIDE SYNTHASE REGULATORY SUBUNIT KEI1', NULL, NULL, 9727, 8),
(245258, NULL, 'PTHR15267', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR LIGAND SUPERFAMILY MEMBER 18', NULL, NULL, 36586, 8),
(245259, NULL, 'PTHR43939', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 158', NULL, NULL, NULL, 8),
(245260, NULL, 'PTHR13407', NULL, NULL, NULL, NULL, 'RNF121 PROTEIN', NULL, NULL, 27705, 8),
(245261, NULL, 'PTHR34453', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE (DEFL) FAMILY PROTEIN-RELATED', NULL, NULL, 16523, 8),
(245262, NULL, 'PTHR12446', NULL, NULL, NULL, NULL, 'TESMIN/TSO1-RELATED', NULL, NULL, 23119, 8),
(245263, NULL, 'PTHR41294', NULL, NULL, NULL, NULL, 'CADMIUM-INDUCED PROTEIN CADI', NULL, NULL, NULL, 8),
(245264, NULL, 'PTHR28617', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 77', NULL, NULL, 25581, 8),
(245265, NULL, 'PTHR43183', NULL, NULL, NULL, NULL, 'HYPOTHETICAL DIHYDROXYACID DEHYDRATASE (EUROFUNG)-RELATED', NULL, NULL, NULL, 8),
(245266, NULL, 'PTHR14917', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 7', NULL, NULL, 26155, 8),
(245267, NULL, 'PTHR31673', NULL, NULL, NULL, NULL, 'PROTEIN COBRA', NULL, NULL, 4903, 8),
(245268, NULL, 'PTHR30047', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY CHOLINE TRANSPORT PROTEIN-RELATED', NULL, NULL, 3667, 8),
(245269, NULL, 'PTHR31432', NULL, NULL, NULL, NULL, 'INTRAFLAGELLAR TRANSPORT PROTEIN 74 HOMOLOG', NULL, NULL, 24634, 8),
(245270, NULL, 'PTHR32243', NULL, NULL, NULL, NULL, 'MALTOSE TRANSPORT SYSTEM PERMEASE-RELATED', NULL, NULL, NULL, 8),
(245271, NULL, 'PTHR22772', NULL, NULL, NULL, NULL, 'NOVEL ZZ TYPE ZINC FINGER DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(245272, NULL, 'PTHR35562', NULL, NULL, NULL, NULL, 'DNA ENDONUCLEASE SMRA-RELATED', NULL, NULL, NULL, 8),
(245273, NULL, 'PTHR47217', NULL, NULL, NULL, NULL, 'GLOBIN-LIKE PROTEIN', NULL, NULL, NULL, 8),
(245274, NULL, 'PTHR37029', NULL, NULL, NULL, NULL, 'SSR1768 PROTEIN', NULL, NULL, NULL, 8),
(245275, NULL, 'PTHR10351', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BTF3 FAMILY MEMBER', NULL, NULL, 33061, 8),
(245276, NULL, 'PTHR24369', NULL, NULL, NULL, NULL, 'ANTIGEN BSP, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(245277, NULL, 'PTHR24370', NULL, NULL, NULL, NULL, 'OPTICIN', NULL, NULL, NULL, 8),
(245278, NULL, 'PTHR30408', NULL, NULL, NULL, NULL, 'TYPE-1 RESTRICTION ENZYME ECOKI SPECIFICITY PROTEIN', NULL, NULL, NULL, 8),
(245279, NULL, 'PTHR32163', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR LIGAND SUPERFAMILY MEMBER 8', NULL, NULL, NULL, 8),
(245280, NULL, 'PTHR40613', NULL, NULL, NULL, NULL, '', NULL, NULL, 24944, 8),
(245281, NULL, 'PTHR37878', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC689039', NULL, NULL, 26600, 8),
(245282, NULL, 'PTHR33279', NULL, NULL, NULL, NULL, 'SULFUR CARRIER PROTEIN YEDF-RELATED', NULL, NULL, NULL, 8),
(245283, NULL, 'PTHR34094', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(245284, NULL, 'PTHR12448', NULL, NULL, NULL, NULL, 'ATP SYNTHASE EPSILON CHAIN, MITOCHONDRIAL', NULL, NULL, 2449, 8),
(245285, NULL, 'PTHR13360', NULL, NULL, NULL, NULL, 'ACTIVATING SIGNAL COINTEGRATOR 1 COMPLEX SUBUNIT 1', NULL, NULL, 10375, 8),
(245286, NULL, 'PTHR42069', NULL, NULL, NULL, NULL, 'HYPHAL ANASTAMOSIS-8 PROTEIN', NULL, NULL, NULL, 8),
(245287, NULL, 'PTHR46669', NULL, NULL, NULL, NULL, 'LEUCINE-RICH PPR MOTIF-CONTAINING PROTEIN, MITOCHONDRIAL', NULL, NULL, 32284, 8),
(245288, NULL, 'PTHR35578', NULL, NULL, NULL, NULL, 'PROLINE-RICH TRANSMEMBRANE PROTEIN 4-RELATED', NULL, NULL, NULL, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(245289, NULL, 'PTHR47705', NULL, NULL, NULL, NULL, 'AGAP000321-PA', NULL, NULL, NULL, 8),
(245290, NULL, 'PTHR24223', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY C', NULL, NULL, NULL, 8),
(245291, NULL, 'PTHR23259', NULL, NULL, NULL, NULL, 'RIDDLE', NULL, NULL, NULL, 8),
(245292, NULL, 'PTHR43100', NULL, NULL, NULL, NULL, 'GLUTAMATE SYNTHASE [NADPH] SMALL CHAIN', NULL, NULL, NULL, 8),
(245293, NULL, 'PTHR31280', NULL, NULL, NULL, NULL, 'PROTEIN UNC-13 HOMOLOG', NULL, NULL, 13254, 8),
(245294, NULL, 'PTHR11012', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(245295, NULL, 'PTHR36348', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(245296, NULL, 'PTHR12391', NULL, NULL, NULL, NULL, 'ARP2/3 COMPLEX 21 KD SUBUNIT', NULL, NULL, 1083, 8),
(245297, NULL, 'PTHR10977', NULL, NULL, NULL, NULL, 'DIPHOSPHOMEVALONATE DECARBOXYLASE', NULL, NULL, NULL, 8),
(245298, NULL, 'PTHR38122', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(245299, NULL, 'PTHR11774', NULL, NULL, NULL, NULL, 'GERANYLGERANYL TRANSFERASE TYPE BETA SUBUNIT', NULL, NULL, 36681, 8),
(245300, NULL, 'PTHR37724', NULL, NULL, NULL, NULL, 'OS02G0564300 PROTEIN', NULL, NULL, NULL, 8),
(245301, NULL, 'PTHR43524', NULL, NULL, NULL, NULL, 'RADICAL SAM SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(245302, NULL, 'PTHR43227', NULL, NULL, NULL, NULL, 'BLL4140 PROTEIN', NULL, NULL, NULL, 8),
(245303, NULL, 'PTHR12225', NULL, NULL, NULL, NULL, 'ADHESION REGULATING MOLECULE 1  110 KDA CELL MEMBRANE GLYCOPROTEIN', NULL, NULL, 3011, 8),
(245304, NULL, 'PTHR11548', NULL, NULL, NULL, NULL, 'THYMIDYLATE SYNTHASE 1', NULL, NULL, 35765, 8),
(245305, NULL, 'PTHR46254', NULL, NULL, NULL, NULL, 'PROTEIN GVQW1-RELATED', NULL, NULL, NULL, 8),
(245306, NULL, 'PTHR13271', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PUTATIVE METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(245307, NULL, 'PTHR47883', NULL, NULL, NULL, NULL, 'YIPPEE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(245308, NULL, 'PTHR24301', NULL, NULL, NULL, NULL, 'THROMBOXANE-A SYNTHASE', NULL, NULL, NULL, 8),
(245309, NULL, 'PTHR33781', NULL, NULL, NULL, NULL, 'PROTEIN PHYTOCHROME KINASE SUBSTRATE 1-RELATED', NULL, NULL, 27199, 8),
(245310, NULL, 'PTHR21100', NULL, NULL, NULL, NULL, 'PREFOLDIN SUBUNIT 4', NULL, NULL, 20370, 8),
(245311, NULL, 'PTHR11845', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 33222, 8),
(245312, NULL, 'PTHR31900', NULL, NULL, NULL, NULL, 'F-BOX/RNI SUPERFAMILY PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245313, NULL, 'PTHR45444', NULL, NULL, NULL, NULL, 'XANTHINE DEHYDROGENASE', NULL, NULL, NULL, 8),
(245314, NULL, 'PTHR38808', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 95', NULL, NULL, 24696, 8),
(245315, NULL, 'PTHR45721', NULL, NULL, NULL, NULL, 'LAMIN DM0-RELATED', NULL, NULL, NULL, 8),
(245316, NULL, 'PTHR10423', NULL, NULL, NULL, NULL, 'INSULIN-LIKE 3', NULL, NULL, 35309, 8),
(245317, NULL, 'PTHR35115', NULL, NULL, NULL, NULL, 'CYCLIN DELTA-3', NULL, NULL, 35854, 8),
(245318, NULL, 'PTHR35747', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(245319, NULL, 'PTHR10480', NULL, NULL, NULL, NULL, 'PROTEIN UNC-13 HOMOLOG', NULL, NULL, 25719, 8),
(245320, NULL, 'PTHR46621', NULL, NULL, NULL, NULL, 'SNRNA-ACTIVATING PROTEIN COMPLEX SUBUNIT 4', NULL, NULL, NULL, 8),
(245321, NULL, 'PTHR34737', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(245322, NULL, 'PTHR10202', NULL, NULL, NULL, NULL, 'PRESENILIN', NULL, NULL, 5281, 8),
(245323, NULL, 'PTHR37891', NULL, NULL, NULL, NULL, 'OS06G0113900 PROTEIN', NULL, NULL, NULL, 8),
(245324, NULL, 'PTHR46974', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL GTP/GDP CARRIER PROTEIN 1', NULL, NULL, NULL, 8),
(245325, NULL, 'PTHR48009', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT (LRR) FAMILY PROTEIN', NULL, NULL, NULL, 8),
(245326, NULL, 'PTHR10628', NULL, NULL, NULL, NULL, 'SIALIDASE', NULL, NULL, 24991, 8),
(245327, NULL, 'PTHR41733', NULL, NULL, NULL, NULL, 'UBIQUITIN-ASSOCIATED/TRANSLATION ELONGATION FACTOR EF1B, N-TERMINAL, EUKARYOTE', NULL, NULL, NULL, 8);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(245328, NULL, 'PTHR17488', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSITION PROTEIN 2', NULL, NULL, 3572, 8),
(245329, NULL, 'PTHR14110', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM22', NULL, NULL, 32984, 8),
(245330, NULL, 'PTHR45988', NULL, NULL, NULL, NULL, 'C2H2 TYPE ZINC FINGER TRANSCRIPTION FACTOR FAMILY-RELATED', NULL, NULL, 36439, 8),
(245331, NULL, 'PTHR13954', NULL, NULL, NULL, NULL, 'IRE1-RELATED', NULL, NULL, 34930, 8),
(245332, NULL, 'PTHR37734', NULL, NULL, NULL, NULL, 'LARGE RIBOSOMAL RNA SUBUNIT ACCUMULATION PROTEIN YCED HOMOLOG 2, CHLOROPLASTIC', NULL, NULL, 35940, 8),
(245333, NULL, 'PTHR33294', NULL, NULL, NULL, NULL, 'AWPM-19-LIKE FAMILY PROTEIN', NULL, NULL, 7794, 8),
(245334, NULL, 'PTHR35356', NULL, NULL, NULL, NULL, 'OS01G0156300 PROTEIN-RELATED', NULL, NULL, 14327, 8),
(245335, NULL, 'PTHR34122', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245336, NULL, 'PTHR22916', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', NULL, NULL, NULL, 8),
(245337, NULL, 'PTHR35716', NULL, NULL, NULL, NULL, 'OS05G0574700 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245338, NULL, 'PTHR30204', NULL, NULL, NULL, NULL, 'REDOX-CYCLING DRUG-SENSING TRANSCRIPTIONAL ACTIVATOR SOXR', NULL, NULL, NULL, 8),
(245339, NULL, 'PTHR43713', NULL, NULL, NULL, NULL, 'GLUTAMATE-1-SEMIALDEHYDE 2,1-AMINOMUTASE', NULL, NULL, NULL, 8),
(245340, NULL, 'PTHR39607', NULL, NULL, NULL, NULL, 'XANTHOCILLIN BIOSYNTHESIS CLUSTER TRANSCRIPTION FACTOR XANC-RELATED', NULL, NULL, NULL, 8),
(245341, NULL, 'PTHR13420', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 2129, 8),
(245342, NULL, 'PTHR11889', NULL, NULL, NULL, NULL, 'HEDGEHOG', NULL, NULL, NULL, 8),
(245343, NULL, 'PTHR43245', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL POLYMYXIN RESISTANCE PROTEIN ARNA', NULL, NULL, NULL, 8),
(245344, NULL, 'PTHR42915', NULL, NULL, NULL, NULL, 'HYPOTHETICAL 460 KDA PROTEIN IN FEUA-SIGW INTERGENIC REGION [PRECURSOR]', NULL, NULL, 8610, 8),
(245345, NULL, 'PTHR43295', NULL, NULL, NULL, NULL, 'ARGININE DECARBOXYLASE', NULL, NULL, 7168, 8),
(245346, NULL, 'PTHR36693', NULL, NULL, NULL, NULL, 'GH02722P', NULL, NULL, 24042, 8),
(245347, NULL, 'PTHR21561', NULL, NULL, NULL, NULL, 'INO80 COMPLEX SUBUNIT B', NULL, NULL, 23732, 8),
(245348, NULL, 'PTHR16521', NULL, NULL, NULL, NULL, 'TYPE-1 ANGIOTENSIN II RECEPTOR-ASSOCIATED PROTEIN', NULL, NULL, 8027, 8),
(245349, NULL, 'PTHR45622', NULL, NULL, NULL, NULL, 'UBIQUITIN-PROTEIN LIGASE E3A-RELATED', NULL, NULL, NULL, 8),
(245350, NULL, 'PTHR31009', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE:CARBOXYL METHYLTRANSFERASE FAMILY PROTEIN', NULL, NULL, 5490, 8),
(245351, NULL, 'PTHR43596', NULL, NULL, NULL, NULL, 'ADP,ATP CARRIER PROTEIN', NULL, NULL, NULL, 8),
(245352, NULL, 'PTHR28646', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 201', NULL, NULL, 31376, 8),
(245353, NULL, 'PTHR24342', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 17', NULL, NULL, NULL, 8),
(245354, NULL, 'PTHR33695', NULL, NULL, NULL, NULL, 'LIPOPROTEIN SIGNAL PEPTIDASE', NULL, NULL, 4162, 8),
(245355, NULL, 'PTHR30313', NULL, NULL, NULL, NULL, 'DNA PRIMASE', NULL, NULL, NULL, 8),
(245356, NULL, 'PTHR13387', NULL, NULL, NULL, NULL, 'PROTEIN HGH1 HOMOLOG', NULL, NULL, 28380, 8),
(245357, NULL, 'PTHR31108', NULL, NULL, NULL, NULL, 'TUMOR PROTEIN P63-REGULATED GENE 1-LIKE PROTEIN', NULL, NULL, 31787, 8),
(245358, NULL, 'PTHR30511', NULL, NULL, NULL, NULL, 'ALANINE RACEMASE', NULL, NULL, NULL, 8),
(245359, NULL, 'PTHR36780', NULL, NULL, NULL, NULL, 'OS05G0241400 PROTEIN', NULL, NULL, NULL, 8),
(245360, NULL, 'PTHR11815', NULL, NULL, NULL, NULL, 'SUCCINYL-COA SYNTHETASE BETA CHAIN', NULL, NULL, 5660, 8),
(245361, NULL, 'PTHR33360', NULL, NULL, NULL, NULL, 'TRANSPOSASE FOR INSERTION SEQUENCE ELEMENT IS200', NULL, NULL, NULL, 8),
(245362, NULL, 'PTHR11596', NULL, NULL, NULL, NULL, 'ALKALINE PHOSPHATASE', NULL, NULL, 2005, 8),
(245363, NULL, 'PTHR47331', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(245364, NULL, 'PTHR36223', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(245365, NULL, 'PTHR11645', NULL, NULL, NULL, NULL, 'PYRROLINE-5-CARBOXYLATE REDUCTASE', NULL, NULL, 803, 8),
(245366, NULL, 'PTHR38150', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(245367, NULL, 'PTHR45720', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN 2', NULL, NULL, NULL, 8),
(245368, NULL, 'PTHR38337', NULL, NULL, NULL, NULL, 'AGAP010540-PA', NULL, NULL, NULL, 8),
(245369, NULL, 'PTHR43104', NULL, NULL, NULL, NULL, 'L-2-HYDROXYGLUTARATE DEHYDROGENASE, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(245370, NULL, 'PTHR13040', NULL, NULL, NULL, NULL, 'AUTOPHAGY PROTEIN 5', NULL, NULL, 6970, 8),
(245371, NULL, 'PTHR31964', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(245372, NULL, 'PTHR37260', NULL, NULL, NULL, NULL, 'PHOSPHORELAY PROTEIN', NULL, NULL, NULL, 8),
(245373, NULL, 'PTHR43388', NULL, NULL, NULL, NULL, 'HYDROGENASE MATURATION FACTOR HOXX', NULL, NULL, NULL, 8),
(245374, NULL, 'PTHR10302', NULL, NULL, NULL, NULL, 'SINGLE-STRANDED DNA-BINDING PROTEIN', NULL, NULL, 10569, 8),
(245375, NULL, 'PTHR43432', NULL, NULL, NULL, NULL, 'SLR0285 PROTEIN', NULL, NULL, 28785, 8),
(245376, NULL, 'PTHR21580', NULL, NULL, NULL, NULL, 'SHIPPO-1-RELATED', NULL, NULL, NULL, 8),
(245377, NULL, 'PTHR45526', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN DPIA', NULL, NULL, 13781, 8),
(245378, NULL, 'PTHR30477', NULL, NULL, NULL, NULL, 'ABC-TRANSPORTER METAL-BINDING PROTEIN', NULL, NULL, 3115, 8),
(245379, NULL, 'PTHR47241', NULL, NULL, NULL, NULL, 'FINGER PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(245380, NULL, 'PTHR45649', NULL, NULL, NULL, NULL, 'AMINO-ACID PERMEASE BAT1', NULL, NULL, NULL, 8),
(245381, NULL, 'PTHR12239', NULL, NULL, NULL, NULL, 'PROTEIN CBG20215-RELATED', NULL, NULL, NULL, 8),
(245382, NULL, 'PTHR34652', NULL, NULL, NULL, NULL, 'AGAP002134-PA', NULL, NULL, NULL, 8),
(245383, NULL, 'PTHR37243', NULL, NULL, NULL, NULL, 'NEGATIVE REGULATOR OF SYSTEMIC ACQUIRED RESISTANCE SNI1', NULL, NULL, 450, 8),
(245384, NULL, 'PTHR46790', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN N', NULL, NULL, NULL, 8),
(245385, NULL, 'PTHR12211', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM PROTEIN ERP29', NULL, NULL, 16281, 8),
(245386, NULL, 'PTHR43543', NULL, NULL, NULL, NULL, 'MALONIC SEMIALDEHYDE REDUCTASE RUTE-RELATED', NULL, NULL, NULL, 8),
(245387, NULL, 'PTHR36157', NULL, NULL, NULL, NULL, 'PROTEIN CBG12671-RELATED', NULL, NULL, NULL, 8),
(245388, NULL, 'PTHR10357', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE FAMILY MEMBER', NULL, NULL, NULL, 8),
(245389, NULL, 'PTHR43425', NULL, NULL, NULL, NULL, 'OXYGEN-INSENSITIVE NADPH NITROREDUCTASE', NULL, NULL, 15397, 8),
(245390, NULL, 'PTHR43068', NULL, NULL, NULL, NULL, 'SLR1854 PROTEIN', NULL, NULL, NULL, 8),
(245391, NULL, 'PTHR11921', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE IRON-SULFUR PROTEIN', NULL, NULL, NULL, 8),
(245392, NULL, 'PTHR14368', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED BASIC PROTEIN 1', NULL, NULL, 30735, 8),
(245393, NULL, 'PTHR41964', NULL, NULL, NULL, NULL, 'GLOBAL NITROGEN REGULATOR NRPR', NULL, NULL, 27203, 8),
(245394, NULL, 'PTHR31268', NULL, NULL, NULL, NULL, '', NULL, NULL, 13843, 8),
(245395, NULL, 'PTHR37096', NULL, NULL, NULL, NULL, 'YALI0E33429P', NULL, NULL, NULL, 8),
(245396, NULL, 'PTHR13083', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 31448, 8),
(245397, NULL, 'PTHR44303', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 16', NULL, NULL, NULL, 8),
(245398, NULL, 'PTHR35137', NULL, NULL, NULL, NULL, 'CHROMOPHORE LYASE CRL, CHLOROPLASTIC', NULL, NULL, 9465, 8),
(245399, NULL, 'PTHR31032', NULL, NULL, NULL, NULL, 'PGR5-LIKE PROTEIN 1B, CHLOROPLASTIC', NULL, NULL, 33676, 8),
(245400, NULL, 'PTHR14492', NULL, NULL, NULL, NULL, 'JBTS17', NULL, NULL, 22891, 8),
(245401, NULL, 'PTHR36333', NULL, NULL, NULL, NULL, 'DIMETHYLALLYL, ADENOSINE TRNA METHYLTHIOTRANSFERASE', NULL, NULL, NULL, 8),
(245402, NULL, 'PTHR12863', NULL, NULL, NULL, NULL, 'FATTY ACID HYDROXYLASE', NULL, NULL, 7841, 8);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(245403, NULL, 'PTHR11662', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 17', NULL, NULL, NULL, 8),
(245404, NULL, 'PTHR43472', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLAMINE--GLYCINE LIGASE', NULL, NULL, 3823, 8),
(245405, NULL, 'PTHR21661', NULL, NULL, NULL, NULL, 'EPOXIDE HYDROLASE 1-RELATED', NULL, NULL, NULL, 8),
(245406, NULL, 'PTHR15381', NULL, NULL, NULL, NULL, 'CHONDROITIN SULFATE PROTEOGLYCAN 5 -RELATED', NULL, NULL, 36714, 8),
(245407, NULL, 'PTHR34141', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(245408, NULL, 'PTHR35476', NULL, NULL, NULL, NULL, 'MUCIN-LIKE PROTEIN', NULL, NULL, NULL, 8),
(245409, NULL, 'PTHR43836', NULL, NULL, NULL, NULL, 'CATECHOL O-METHYLTRANSFERASE 1-RELATED', NULL, NULL, NULL, 8),
(245410, NULL, 'PTHR15959', NULL, NULL, NULL, NULL, 'SYNTAXIN-18', NULL, NULL, NULL, 8),
(245411, NULL, 'PTHR14636', NULL, NULL, NULL, NULL, 'TPA-INDUCED TRANSMEMBRANE PROTEIN', NULL, NULL, 27788, 8),
(245412, NULL, 'PTHR30450', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE', NULL, NULL, NULL, 8),
(245413, NULL, 'PTHR37333', NULL, NULL, NULL, NULL, 'LEUCINE-RICH SINGLE-PASS MEMBRANE PROTEIN 2', NULL, NULL, 25534, 8),
(245414, NULL, 'PTHR47240', NULL, NULL, NULL, NULL, 'CHROMO DOMAIN-CONTAINING PROTEIN LHP1', NULL, NULL, 34498, 8),
(245415, NULL, 'PTHR11722', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L13', NULL, NULL, 6863, 8),
(245416, NULL, 'PTHR34438', NULL, NULL, NULL, NULL, 'SI:DKEY-97L20.6', NULL, NULL, 24642, 8),
(245417, NULL, 'PTHR15919', NULL, NULL, NULL, NULL, 'DAPPER-RELATED', NULL, NULL, 16297, 8),
(245418, NULL, 'PTHR13469', NULL, NULL, NULL, NULL, 'HEXAMETHYLENE BISACETAMIDE INDUCIBLE 1', NULL, NULL, 22241, 8),
(245419, NULL, 'PTHR46651', NULL, NULL, NULL, NULL, 'POLYADENYLATE-BINDING PROTEIN-INTERACTING PROTEIN 7', NULL, NULL, NULL, 8),
(245420, NULL, 'PTHR36574', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONATE LYASE-RELATED', NULL, NULL, 17900, 8),
(245421, NULL, 'PTHR16062', NULL, NULL, NULL, NULL, 'SWI/SNF-RELATED', NULL, NULL, 29262, 8),
(245422, NULL, 'PTHR45653', NULL, NULL, NULL, NULL, 'DEDICATOR OF CYTOKINESIS', NULL, NULL, 22644, 8),
(245423, NULL, 'PTHR43033', NULL, NULL, NULL, NULL, 'TRNA(ILE)-LYSIDINE SYNTHASE-RELATED', NULL, NULL, 12879, 8),
(245424, NULL, 'PTHR34118', NULL, NULL, NULL, NULL, 'NF-KAPPA-B INHIBITOR-LIKE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245425, NULL, 'PTHR39563', NULL, NULL, NULL, NULL, 'XANTHINE PHOSPHORIBOSYLTRANSFERASE', NULL, NULL, 16928, 8),
(245426, NULL, 'PTHR47295', NULL, NULL, NULL, NULL, 'EG45-LIKE DOMAIN CONTAINING PROTEIN 1-RELATED', NULL, NULL, 34698, 8),
(245427, NULL, 'PTHR40063', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245428, NULL, 'PTHR46450', NULL, NULL, NULL, NULL, 'INACTIVE HISTONE-LYSINE N-METHYLTRANSFERASE SUVR1-RELATED', NULL, NULL, NULL, 8),
(245429, NULL, 'PTHR10728', NULL, NULL, NULL, NULL, 'CYTOSOLIC PHOSPHOLIPASE A2', NULL, NULL, NULL, 8),
(245430, NULL, 'PTHR31265', NULL, NULL, NULL, NULL, 'OS02G0527500 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245431, NULL, 'PTHR43072', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE', NULL, NULL, NULL, 8),
(245432, NULL, 'PTHR14350', NULL, NULL, NULL, NULL, 'ARGININE VASOPRESSIN-INDUCED PROTEIN 1', NULL, NULL, 27305, 8),
(245433, NULL, 'PTHR47707', NULL, NULL, NULL, NULL, '8-OXO-DGTP DIPHOSPHATASE', NULL, NULL, NULL, 8),
(245434, NULL, 'PTHR37806', NULL, NULL, NULL, NULL, 'LMO0724 PROTEIN', NULL, NULL, NULL, 8),
(245435, NULL, 'PTHR11492', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR I', NULL, NULL, 6645, 8),
(245436, NULL, 'PTHR11037', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR CP2', NULL, NULL, 27337, 8),
(245437, NULL, 'PTHR15975', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 14787, 8),
(245438, NULL, 'PTHR38033', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245439, NULL, 'PTHR14897', NULL, NULL, NULL, NULL, 'WD REPEAT AND COILED-COIL-CONTAINING PROTEIN', NULL, NULL, 24732, 8),
(245440, NULL, 'PTHR36391', NULL, NULL, NULL, NULL, 'FURRY', NULL, NULL, NULL, 8),
(245441, NULL, 'PTHR12970', NULL, NULL, NULL, NULL, 'PROTEASOME ASSEMBLY CHAPERONE 2', NULL, NULL, 17801, 8);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(245442, NULL, 'PTHR28682', NULL, NULL, NULL, NULL, 'INHIBITORY SYNAPTIC FACTOR 2A-RELATED', NULL, NULL, 23638, 8),
(245443, NULL, 'PTHR47682', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(245444, NULL, 'PTHR44516', NULL, NULL, NULL, NULL, '2-METHYL-6-PHYTYL-1,4-HYDROQUINONE METHYLTRANSFERASE, CHLOROPLASTIC', NULL, NULL, 36362, 8),
(245445, NULL, 'PTHR33527', NULL, NULL, NULL, NULL, 'OS07G0274300 PROTEIN', NULL, NULL, NULL, 8),
(245446, NULL, 'PTHR15344', NULL, NULL, NULL, NULL, 'CDC42 EFFECTOR PROTEIN  BORG', NULL, NULL, NULL, 8),
(245447, NULL, 'PTHR46036', NULL, NULL, NULL, NULL, 'LACTOYLGLUTATHIONE LYASE', NULL, NULL, NULL, 8),
(245448, NULL, 'PTHR37467', NULL, NULL, NULL, NULL, 'EXPORTED CALCIUM-BINDING GLYCOPROTEIN-RELATED', NULL, NULL, NULL, 8),
(245449, NULL, 'PTHR14926', NULL, NULL, NULL, NULL, 'M-PHASE PHOSPHOPROTEIN 9', NULL, NULL, 25467, 8),
(245450, NULL, 'PTHR46968', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF138', NULL, NULL, NULL, 8),
(245451, NULL, 'PTHR22550', NULL, NULL, NULL, NULL, 'SPORE GERMINATION PROTEIN', NULL, NULL, NULL, 8),
(245452, NULL, 'PTHR15960', NULL, NULL, NULL, NULL, 'LD44032P', NULL, NULL, 31648, 8),
(245453, NULL, 'PTHR23427', NULL, NULL, NULL, NULL, 'SURFEIT LOCUS PROTEIN', NULL, NULL, 36123, 8),
(245454, NULL, 'PTHR11434', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE SUBUNIT ND4L', NULL, NULL, 1167, 8),
(245455, NULL, 'PTHR46118', NULL, NULL, NULL, NULL, 'PROTEIN ABHD11', NULL, NULL, NULL, 8),
(245456, NULL, 'PTHR34221', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC691189', NULL, NULL, 23761, 8),
(245457, NULL, 'PTHR11932', NULL, NULL, NULL, NULL, 'CULLIN', NULL, NULL, 36525, 8),
(245458, NULL, 'PTHR31016', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(245459, NULL, 'PTHR46797', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR', NULL, NULL, NULL, 8),
(245460, NULL, 'PTHR11061', NULL, NULL, NULL, NULL, 'RNA M5U METHYLTRANSFERASE', NULL, NULL, 7630, 8),
(245461, NULL, 'PTHR14894', NULL, NULL, NULL, NULL, 'CDK5 REGULATORY SUBUNIT-ASSOCIATED PROTEIN 3', NULL, NULL, 12006, 8),
(245462, NULL, 'PTHR35273', NULL, NULL, NULL, NULL, 'ALPHA-1,4 POLYGALACTOSAMINIDASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G07890)-RELATED', NULL, NULL, NULL, 8),
(245463, NULL, 'PTHR13437', NULL, NULL, NULL, NULL, 'NUCLEOPORIN P58/P45  NUCLEOPORIN-LIKE PROTEIN 1', NULL, NULL, 26743, 8),
(245464, NULL, 'PTHR47610', NULL, NULL, NULL, NULL, 'TSC22 DOMAIN FAMILY PROTEIN 4', NULL, NULL, 33941, 8),
(245465, NULL, 'PTHR24064', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 22 MEMBER', NULL, NULL, NULL, 8),
(245466, NULL, 'PTHR15484', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE I SUBUNIT RPA34', NULL, NULL, 12855, 8),
(245467, NULL, 'PTHR28190', NULL, NULL, NULL, NULL, 'NUCLEAR MIGRATION PROTEIN NUM1', NULL, NULL, NULL, 8),
(245468, NULL, 'PTHR34069', NULL, NULL, NULL, NULL, '3-OXOACYL-[ACYL-CARRIER-PROTEIN] SYNTHASE 3', NULL, NULL, NULL, 8),
(245469, NULL, 'PTHR36695', NULL, NULL, NULL, NULL, 'AGAP008648-PA', NULL, NULL, NULL, 8),
(245470, NULL, 'PTHR48295', NULL, NULL, NULL, NULL, 'CRANIOFACIAL DEVELOPMENT PROTEIN 1', NULL, NULL, NULL, 8),
(245471, NULL, 'PTHR37823', NULL, NULL, NULL, NULL, 'CYTOCHROME C-553-LIKE', NULL, NULL, NULL, 8),
(245472, NULL, 'PTHR33289', NULL, NULL, NULL, NULL, 'ANCHORAGE SUBUNIT, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(245473, NULL, 'PTHR32385', NULL, NULL, NULL, NULL, 'MANNOSYL PHOSPHORYLINOSITOL CERAMIDE SYNTHASE', NULL, NULL, NULL, 8),
(245474, NULL, 'PTHR28003', NULL, NULL, NULL, NULL, 'NUCLEOPORIN POM34', NULL, NULL, 9455, 8),
(245475, NULL, 'PTHR17408', NULL, NULL, NULL, NULL, 'HISTONE RNA HAIRPIN-BINDING PROTEIN', NULL, NULL, 23009, 8),
(245476, NULL, 'PTHR30451', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE USHER PROTEIN', NULL, NULL, 6736, 8),
(245477, NULL, 'PTHR41709', NULL, NULL, NULL, NULL, 'KAIB-LIKE PROTEIN 1', NULL, NULL, 31957, 8),
(245478, NULL, 'PTHR46087', NULL, NULL, NULL, NULL, 'PUTATIVE, EXPRESSED-RELATED', NULL, NULL, NULL, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(245479, NULL, 'PTHR28668', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 234', NULL, NULL, 20968, 8),
(245480, NULL, 'PTHR10603', NULL, NULL, NULL, NULL, 'FRAGILE X MENTAL RETARDATION SYNDROME-RELATED PROTEIN', NULL, NULL, 30743, 8),
(245481, NULL, 'PTHR21063', NULL, NULL, NULL, NULL, 'LFA-3', NULL, NULL, NULL, 8),
(245482, NULL, 'PTHR23344', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHORYL DIESTER PHOSPHODIESTERASE', NULL, NULL, NULL, 8),
(245483, NULL, 'PTHR14715', NULL, NULL, NULL, NULL, '', NULL, NULL, 26487, 8),
(245484, NULL, 'PTHR34672', NULL, NULL, NULL, NULL, 'POLLEN-SPECIFIC ARABINOGALACTA PROTEIN BAN102', NULL, NULL, 34655, 8),
(245485, NULL, 'PTHR14189', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE METHYLESTERASE-1 RELATED', NULL, NULL, 15364, 8),
(245486, NULL, 'PTHR45166', NULL, NULL, NULL, NULL, 'V-SET AND IMMUNOGLOBULIN DOMAIN-CONTAINING PROTEIN 8', NULL, NULL, NULL, 8),
(245487, NULL, 'PTHR33239', NULL, NULL, NULL, NULL, 'CELLULOSE-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245488, NULL, 'PTHR12109', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 141-RELATED', NULL, NULL, NULL, 8),
(245489, NULL, 'PTHR24336', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR LBX', NULL, NULL, NULL, 8),
(245490, NULL, 'PTHR36470', NULL, NULL, NULL, NULL, 'IZUMO SPERM-EGG FUSION PROTEIN 3', NULL, NULL, NULL, 8),
(245491, NULL, 'PTHR24280', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 20A1', NULL, NULL, NULL, 8),
(245492, NULL, 'PTHR47539', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN OTP51, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(245493, NULL, 'PTHR23145', NULL, NULL, NULL, NULL, 'NUCLEOSOMAL BINDING PROTEIN 1', NULL, NULL, 27200, 8),
(245494, NULL, 'PTHR46550', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 3', NULL, NULL, NULL, 8),
(245495, NULL, 'PTHR33405', NULL, NULL, NULL, NULL, 'PROTEIN FLX-LIKE 2', NULL, NULL, 29122, 8),
(245496, NULL, 'PTHR35202', NULL, NULL, NULL, NULL, '', NULL, NULL, 27479, 8),
(245497, NULL, 'PTHR42742', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR MPRA', NULL, NULL, NULL, 8),
(245498, NULL, 'PTHR36132', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 221', NULL, NULL, NULL, 8),
(245499, NULL, 'PTHR47117', NULL, NULL, NULL, NULL, 'STAR-RELATED LIPID TRANSFER PROTEIN 9', NULL, NULL, NULL, 8),
(245500, NULL, 'PTHR42747', NULL, NULL, NULL, NULL, 'NITRONATE MONOOXYGENASE-RELATED', NULL, NULL, NULL, 8),
(245501, NULL, 'PTHR35852', NULL, NULL, NULL, NULL, 'PROTEIN CBG16246', NULL, NULL, NULL, 8),
(245502, NULL, 'PTHR31330', NULL, NULL, NULL, NULL, 'NEMATODE SPECIFIC PEPTIDE FAMILY, GROUP C', NULL, NULL, NULL, 8),
(245503, NULL, 'PTHR24346', NULL, NULL, NULL, NULL, 'MAP/MICROTUBULE AFFINITY-REGULATING KINASE', NULL, NULL, NULL, 8),
(245504, NULL, 'PTHR48032', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN MUSASHI HOMOLOG RBP6', NULL, NULL, NULL, 8),
(245505, NULL, 'PTHR43127', NULL, NULL, NULL, NULL, 'DEVELOPMENTALLY-REGULATED GTP-BINDING PROTEIN 2', NULL, NULL, 36547, 8),
(245506, NULL, 'PTHR46451', NULL, NULL, NULL, NULL, 'RAS-RESPONSIVE ELEMENT-BINDING PROTEIN 1', NULL, NULL, NULL, 8),
(245507, NULL, 'PTHR35894', NULL, NULL, NULL, NULL, 'GENERAL SECRETION PATHWAY PROTEIN A-RELATED', NULL, NULL, NULL, 8),
(245508, NULL, 'PTHR15564', NULL, NULL, NULL, NULL, 'MACPF DOMAIN-CONTAINING PROTEIN', NULL, NULL, 31363, 8),
(245509, NULL, 'PTHR46925', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR TKR-1-RELATED', NULL, NULL, NULL, 8),
(245510, NULL, 'PTHR41164', NULL, NULL, NULL, NULL, 'CURLI PRODUCTION ASSEMBLY/TRANSPORT COMPONENT CSGG', NULL, NULL, NULL, 8),
(245511, NULL, 'PTHR10933', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN-BINDING PROTEIN 1', NULL, NULL, 4543, 8),
(245512, NULL, 'PTHR45614', NULL, NULL, NULL, NULL, 'MYB PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245513, NULL, 'PTHR43702', NULL, NULL, NULL, NULL, 'L-FUCOSE-PROTON SYMPORTER', NULL, NULL, NULL, 8),
(245514, NULL, 'PTHR33231', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN', NULL, NULL, NULL, 8),
(245515, NULL, 'PTHR13986', NULL, NULL, NULL, NULL, 'PROTEIN LYSINE HYDROXYLATION COMPLEX COMPONENT', NULL, NULL, NULL, 8);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(245516, NULL, 'PTHR47926', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(245517, NULL, 'PTHR32430', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE III DOMAIN-CONTAINING PROTEIN 8', NULL, NULL, NULL, 8),
(245518, NULL, 'PTHR31129', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN HORMONE ALPHA-2', NULL, NULL, NULL, 8),
(245519, NULL, 'PTHR14286', NULL, NULL, NULL, NULL, 'GENE, 49355-RELATED', NULL, NULL, 23932, 8),
(245520, NULL, 'PTHR33879', NULL, NULL, NULL, NULL, '17.6 KDA CLASS II HEAT SHOCK PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245521, NULL, 'PTHR47374', NULL, NULL, NULL, NULL, 'ENDOSOME ANTIGEN-LIKE PROTEIN, PUTATIVE (DUF3444)-RELATED', NULL, NULL, NULL, 8),
(245522, NULL, 'PTHR32046', NULL, NULL, NULL, NULL, 'G DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(245523, NULL, 'PTHR22840', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 36', NULL, NULL, NULL, 8),
(245524, NULL, 'PTHR46677', NULL, NULL, NULL, NULL, 'SMC5-SMC6 COMPLEX LOCALIZATION FACTOR PROTEIN 1', NULL, NULL, 37621, 8),
(245525, NULL, 'PTHR10488', NULL, NULL, NULL, NULL, 'GLYCINE AMIDINOTRANSFERASE, MITOCHONDRIAL', NULL, NULL, 27652, 8),
(245526, NULL, 'PTHR11359', NULL, NULL, NULL, NULL, 'AMP DEAMINASE', NULL, NULL, 4562, 8),
(245527, NULL, 'PTHR12452', NULL, NULL, NULL, NULL, '42-9-9 PROTEIN-RELATED', NULL, NULL, 34435, 8),
(245528, NULL, 'PTHR38618', NULL, NULL, NULL, NULL, 'PROTEIN CBG21701-RELATED', NULL, NULL, NULL, 8),
(245529, NULL, 'PTHR28643', NULL, NULL, NULL, NULL, 'SWI5-DEPENDENT RECOMBINATION DNA REPAIR PROTEIN 1 HOMOLOG', NULL, NULL, 34083, 8),
(245530, NULL, 'PTHR14218', NULL, NULL, NULL, NULL, 'PROTEASE S8 TRIPEPTIDYL PEPTIDASE I  CLN2', NULL, NULL, NULL, 8),
(245531, NULL, 'PTHR46498', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN 8', NULL, NULL, NULL, 8),
(245532, NULL, 'PTHR35334', NULL, NULL, NULL, NULL, 'SERINE TRANSPORTER', NULL, NULL, NULL, 8),
(245533, NULL, 'PTHR21113', NULL, NULL, NULL, NULL, 'AGAP001705-PA', NULL, NULL, NULL, 8),
(245534, NULL, 'PTHR47278', NULL, NULL, NULL, NULL, 'GLUTATHIONE HYDROLASE 6', NULL, NULL, NULL, 8),
(245535, NULL, 'PTHR38104', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(245536, NULL, 'PTHR47072', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(245537, NULL, 'PTHR45675', NULL, NULL, NULL, NULL, 'MYB TRANSCRIPTION FACTOR-RELATED-RELATED', NULL, NULL, 34284, 8),
(245538, NULL, 'PTHR33596', NULL, NULL, NULL, NULL, 'COLD-REGULATED 413 PLASMA MEMBRANE PROTEIN 2', NULL, NULL, 7773, 8),
(245539, NULL, 'PTHR38849', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(245540, NULL, 'PTHR47685', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORT PROTEIN CORA', NULL, NULL, NULL, 8),
(245541, NULL, 'PTHR39338', NULL, NULL, NULL, NULL, 'BLL5662 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245542, NULL, 'PTHR14319', NULL, NULL, NULL, NULL, 'FIVE-SPAN TRANSMEMBRANE PROTEIN M83', NULL, NULL, 19739, 8),
(245543, NULL, 'PTHR46976', NULL, NULL, NULL, NULL, 'PROTEIN ARABIDILLO 1', NULL, NULL, NULL, 8),
(245544, NULL, 'PTHR37001', NULL, NULL, NULL, NULL, 'PHOSPHORYN, PUTATIVE-RELATED-RELATED', NULL, NULL, NULL, 8),
(245545, NULL, 'PTHR43876', NULL, NULL, NULL, NULL, 'UBIQUINONE BIOSYNTHESIS MONOOXYGENASE COQ6, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(245546, NULL, 'PTHR10206', NULL, NULL, NULL, NULL, 'CATHELICIDIN', NULL, NULL, 2393, 8),
(245547, NULL, 'PTHR46070', NULL, NULL, NULL, NULL, 'PINSTRIPE, ISOFORM A', NULL, NULL, NULL, 8),
(245548, NULL, 'PTHR19248', NULL, NULL, NULL, NULL, 'ATP-BINDING TRANSPORT PROTEIN-RELATED', NULL, NULL, 8711, 8),
(245549, NULL, 'PTHR12964', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE B14 SUBUNIT', NULL, NULL, 15050, 8),
(245550, NULL, 'PTHR46705', NULL, NULL, NULL, NULL, 'PROTEIN CBG09805', NULL, NULL, NULL, 8),
(245551, NULL, 'PTHR23509', NULL, NULL, NULL, NULL, 'PA-PL1 PHOSPHOLIPASE FAMILY', NULL, NULL, NULL, 8),
(245552, NULL, 'PTHR10631', NULL, NULL, NULL, NULL, 'N 2 ,N 2 -DIMETHYLGUANOSINE TRNA METHYLTRANSFERASE', NULL, NULL, 6289, 8),
(245553, NULL, 'PTHR37248', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR', NULL, NULL, NULL, 8);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(245554, NULL, 'PTHR47208', NULL, NULL, NULL, NULL, 'OS02G0174800 PROTEIN', NULL, NULL, 36071, 8),
(245555, NULL, 'PTHR11635', NULL, NULL, NULL, NULL, 'CAMP-DEPENDENT PROTEIN KINASE REGULATORY CHAIN', NULL, NULL, NULL, 8),
(245556, NULL, 'PTHR43710', NULL, NULL, NULL, NULL, '2-HYDROXYACYL-COA LYASE', NULL, NULL, 35615, 8),
(245557, NULL, 'PTHR22911', NULL, NULL, NULL, NULL, 'ACYL-MALONYL CONDENSING ENZYME-RELATED', NULL, NULL, NULL, 8),
(245558, NULL, 'PTHR48138', NULL, NULL, NULL, NULL, 'KERATINOCYTE PROLINE-RICH PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245559, NULL, 'PTHR38755', NULL, NULL, NULL, NULL, '5,10-METHYLENETETRAHYDROFOLATE REDUCTASE', NULL, NULL, NULL, 8),
(245560, NULL, 'PTHR15189', NULL, NULL, NULL, NULL, 'BRISC AND BRCA1-A COMPLEX MEMBER 2', NULL, NULL, 8877, 8),
(245561, NULL, 'PTHR43277', NULL, NULL, NULL, NULL, 'ARGININE DECARBOXYLASE', NULL, NULL, NULL, 8),
(245562, NULL, 'PTHR46459', NULL, NULL, NULL, NULL, 'E1A-BINDING PROTEIN P400-RELATED', NULL, NULL, NULL, 8),
(245563, NULL, 'PTHR28185', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL DISTRIBUTION AND MORPHOLOGY PROTEIN 34', NULL, NULL, 23510, 8),
(245564, NULL, 'PTHR34554', NULL, NULL, NULL, NULL, 'RGS1-HXK1-INTERACTING PROTEIN 1', NULL, NULL, NULL, 8),
(245565, NULL, 'PTHR22880', NULL, NULL, NULL, NULL, 'FALZ-RELATED BROMODOMAIN-CONTAINING PROTEINS', NULL, NULL, NULL, 8),
(245566, NULL, 'PTHR43314', NULL, NULL, NULL, NULL, '', NULL, NULL, 11004, 8),
(245567, NULL, 'PTHR34844', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(245568, NULL, 'PTHR39339', NULL, NULL, NULL, NULL, 'SLR1444 PROTEIN', NULL, NULL, NULL, 8),
(245569, NULL, 'PTHR16121', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(245570, NULL, 'PTHR28575', NULL, NULL, NULL, NULL, 'MEIOSIS-SPECIFIC PROTEIN MEI4', NULL, NULL, 24213, 8),
(245571, NULL, 'PTHR43745', NULL, NULL, NULL, NULL, 'NITROREDUCTASE MJ1384-RELATED', NULL, NULL, NULL, 8),
(245572, NULL, 'PTHR46544', NULL, NULL, NULL, NULL, 'EXTRACELLULAR MATRIX PROTEIN 2-RELATED', NULL, NULL, 34614, 8),
(245573, NULL, 'PTHR21838', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 25995, 8),
(245574, NULL, 'PTHR21461', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(245575, NULL, 'PTHR46658', NULL, NULL, NULL, NULL, 'CYS OR MET METABOLISM PYRIDOXAL-PHOSPHATE-DEPENDENT ENZYME', NULL, NULL, 11015, 8),
(245576, NULL, 'PTHR13327', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE ESSS SUBUNIT, MITOCHONDRIAL PRECURSOR', NULL, NULL, 14649, 8),
(245577, NULL, 'PTHR31142', NULL, NULL, NULL, NULL, 'TOBAMOVIRUS MULTIPLICATION PROTEIN 1-LIKE ISOFORM X1', NULL, NULL, 31325, 8),
(245578, NULL, 'PTHR47528', NULL, NULL, NULL, NULL, 'PARALEMMIN-3', NULL, NULL, 11303, 8),
(245579, NULL, 'PTHR48082', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT ALPHA, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(245580, NULL, 'PTHR34598', NULL, NULL, NULL, NULL, 'BLL6449 PROTEIN', NULL, NULL, 36028, 8),
(245581, NULL, 'PTHR24224', NULL, NULL, NULL, NULL, 'CARDIOACCELERATORY PEPTIDE RECEPTOR-RELATED', NULL, NULL, NULL, 8),
(245582, NULL, 'PTHR42866', NULL, NULL, NULL, NULL, '3-DEOXY-MANNO-OCTULOSONATE CYTIDYLYLTRANSFERASE', NULL, NULL, NULL, 8),
(245583, NULL, 'PTHR47198', NULL, NULL, NULL, NULL, 'OS05G0299300 PROTEIN', NULL, NULL, NULL, 8),
(245584, NULL, 'PTHR28623', NULL, NULL, NULL, NULL, 'PROTEIN FAM118B', NULL, NULL, 27047, 8),
(245585, NULL, 'PTHR45581', NULL, NULL, NULL, NULL, 'PROTEIN CBG10435', NULL, NULL, NULL, 8),
(245586, NULL, 'PTHR37440', NULL, NULL, NULL, NULL, 'PROTEIN CBG17852-RELATED', NULL, NULL, NULL, 8),
(245587, NULL, 'PTHR12205', NULL, NULL, NULL, NULL, 'CENTROMERE/KINETOCHORE PROTEIN ZW10', NULL, NULL, NULL, 8),
(245588, NULL, 'PTHR39450', NULL, NULL, NULL, NULL, 'MOLYBDOPTERIN OXIDOREDUCTASE, 4FE-4S CLUSTER-BINDING SUBUNIT', NULL, NULL, 14056, 8),
(245589, NULL, 'PTHR15275', NULL, NULL, NULL, NULL, 'CG1 PROTEIN/F18', NULL, NULL, 25681, 8),
(245590, NULL, 'PTHR34047', NULL, NULL, NULL, NULL, 'NUCLEAR INTRON MATURASE 1, MITOCHONDRIAL-RELATED', NULL, NULL, NULL, 8),
(245591, NULL, 'PTHR18460', NULL, NULL, NULL, NULL, 'TEL2 INTERACTING PROTEIN 1 TTI1 FAMILY MEMBER', NULL, NULL, NULL, 8);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(245592, NULL, 'PTHR37253', NULL, NULL, NULL, NULL, 'PROTEIN GAMETE EXPRESSED 3', NULL, NULL, 37203, 8),
(245593, NULL, 'PTHR20900', NULL, NULL, NULL, NULL, 'NADH:UBIQUINONE OXIDOREDUCTASE B18-LIKE SUBUNIT', NULL, NULL, 13424, 8),
(245594, NULL, 'PTHR23175', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(245595, NULL, 'PTHR28028', NULL, NULL, NULL, NULL, '60S RIBOSOMAL SUBUNIT ASSEMBLY/EXPORT PROTEIN LOC1', NULL, NULL, 31068, 8),
(245596, NULL, 'PTHR20908', NULL, NULL, NULL, NULL, 'LD15586P', NULL, NULL, NULL, 8),
(245597, NULL, 'PTHR10519', NULL, NULL, NULL, NULL, 'GABA-B RECEPTOR', NULL, NULL, 6823, 8),
(245598, NULL, 'PTHR34548', NULL, NULL, NULL, NULL, 'PROTEIN TIC 21, CHLOROPLASTIC', NULL, NULL, 20008, 8),
(245599, NULL, 'PTHR38450', NULL, NULL, NULL, NULL, 'STAGE V SPORULATION PROTEIN AC-RELATED', NULL, NULL, 1957, 8),
(245600, NULL, 'PTHR43674', NULL, NULL, NULL, NULL, 'NITRILASE C965.09-RELATED', NULL, NULL, NULL, 8),
(245601, NULL, 'PTHR16886', NULL, NULL, NULL, NULL, 'HYPOXIA-INDUCIBLE PROTEIN 2', NULL, NULL, 25342, 8),
(245602, NULL, 'PTHR35301', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 41-RELATED', NULL, NULL, 27907, 8),
(245603, NULL, 'PTHR34949', NULL, NULL, NULL, NULL, 'OS05G0443700 PROTEIN', NULL, NULL, NULL, 8),
(245604, NULL, 'PTHR37858', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC689589', NULL, NULL, 26184, 8),
(245605, NULL, 'PTHR46671', NULL, NULL, NULL, NULL, 'PROTEIN CBG11221', NULL, NULL, NULL, 8),
(245606, NULL, 'PTHR11532', NULL, NULL, NULL, NULL, 'PROTEASE M14 CARBOXYPEPTIDASE', NULL, NULL, NULL, 8),
(245607, NULL, 'PTHR38604', NULL, NULL, NULL, NULL, 'PERIPLASMIC NITRATE REDUCTASE, ELECTRON TRANSFER SUBUNIT', NULL, NULL, 2779, 8),
(245608, NULL, 'PTHR21181', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(245609, NULL, 'PTHR23527', NULL, NULL, NULL, NULL, 'BLL3282 PROTEIN', NULL, NULL, NULL, 8),
(245610, NULL, 'PTHR44188', NULL, NULL, NULL, NULL, 'GDAP1, ISOFORM A', NULL, NULL, NULL, 8),
(245611, NULL, 'PTHR36032', NULL, NULL, NULL, NULL, 'PHOSPHOPANTOTHENATE--CYSTEINE LIGASE 2', NULL, NULL, NULL, 8),
(245612, NULL, 'PTHR46473', NULL, NULL, NULL, NULL, 'GH08155P', NULL, NULL, NULL, 8),
(245613, NULL, 'PTHR12145', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 9831, 8),
(245614, NULL, 'PTHR15673', NULL, NULL, NULL, NULL, 'IQ CALMODULIN-BINDING MOTIF CONTAINING PROTEIN 1', NULL, NULL, 21559, 8),
(245615, NULL, 'PTHR38487', NULL, NULL, NULL, NULL, 'TESTIS EXPRESSED 11', NULL, NULL, NULL, 8),
(245616, NULL, 'PTHR22838', NULL, NULL, NULL, NULL, 'WD REPEAT PROTEIN 26-RELATED', NULL, NULL, NULL, 8),
(245617, NULL, 'PTHR43698', NULL, NULL, NULL, NULL, 'RIBD C-TERMINAL DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(245618, NULL, 'PTHR36849', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245619, NULL, 'PTHR35348', NULL, NULL, NULL, NULL, 'TESTIS, PROSTATE AND PLACENTA-EXPRESSED PROTEIN', NULL, NULL, 29848, 8),
(245620, NULL, 'PTHR10881', NULL, NULL, NULL, NULL, 'GOLGIN SUBFAMILY A MEMBER-RELATED', NULL, NULL, 22481, 8),
(245621, NULL, 'PTHR23502', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY', NULL, NULL, NULL, 8),
(245622, NULL, 'PTHR37168', NULL, NULL, NULL, NULL, 'CRISPR-ASSOCIATED EXONUCLEASE CAS4', NULL, NULL, NULL, 8),
(245623, NULL, 'PTHR48064', NULL, NULL, NULL, NULL, 'OS01G0750400 PROTEIN', NULL, NULL, NULL, 8),
(245624, NULL, 'PTHR34186', NULL, NULL, NULL, NULL, 'CYANATE HYDRATASE', NULL, NULL, 6040, 8),
(245625, NULL, 'PTHR48081', NULL, NULL, NULL, NULL, 'AB HYDROLASE SUPERFAMILY PROTEIN C4A8.06C', NULL, NULL, NULL, 8),
(245626, NULL, 'PTHR37814', NULL, NULL, NULL, NULL, 'CONSERVED MEMBRANE PROTEIN', NULL, NULL, 31883, 8),
(245627, NULL, 'PTHR31832', NULL, NULL, NULL, NULL, 'B-BOX ZINC FINGER PROTEIN 22', NULL, NULL, NULL, 8),
(245628, NULL, 'PTHR43119', NULL, NULL, NULL, NULL, 'ABC TRANSPORT PROTEIN ATP-BINDING COMPONENT-RELATED', NULL, NULL, NULL, 8),
(245629, NULL, 'PTHR43217', NULL, NULL, NULL, NULL, 'SUCCINATE SEMIALDEHYDE DEHYDROGENASE [NAD(P)+] SAD', NULL, NULL, NULL, 8);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(245630, NULL, 'PTHR32329', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL PROTEIN [INCLUDES 2-HYDROXYACYL-COA DEHYDRATASE (N-TER) AND ITS ACTIVATOR DOMAIN (C_TERM)-RELATED', NULL, NULL, NULL, 8),
(245631, NULL, 'PTHR21319', NULL, NULL, NULL, NULL, 'RING FINGER AND CHY ZINC FINGER DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(245632, NULL, 'PTHR13608', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 32029, 8),
(245633, NULL, 'PTHR11439', NULL, NULL, NULL, NULL, 'GAG-POL-RELATED RETROTRANSPOSON', NULL, NULL, NULL, 8),
(245634, NULL, 'PTHR37358', NULL, NULL, NULL, NULL, 'MUCIN-20', NULL, NULL, 413, 8),
(245635, NULL, 'PTHR11070', NULL, NULL, NULL, NULL, 'UVRD / RECB / PCRA DNA HELICASE FAMILY MEMBER', NULL, NULL, 1638, 8),
(245636, NULL, 'PTHR22175', NULL, NULL, NULL, NULL, 'SMALL ACIDIC PROTEIN-RELATED', NULL, NULL, 21756, 8),
(245637, NULL, 'PTHR46641', NULL, NULL, NULL, NULL, 'FMRFAMIDE RECEPTOR-RELATED', NULL, NULL, NULL, 8),
(245638, NULL, 'PTHR31042', NULL, NULL, NULL, NULL, 'CORE-2/I-BRANCHING BETA-1,6-N-ACETYLGLUCOSAMINYLTRANSFERASE FAMILY PROTEIN-RELATED', NULL, NULL, 36797, 8),
(245639, NULL, 'PTHR37352', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC GENE 13 PROTEIN', NULL, NULL, 21922, 8),
(245640, NULL, 'PTHR23118', NULL, NULL, NULL, NULL, 'ATP-CITRATE SYNTHASE', NULL, NULL, NULL, 8),
(245641, NULL, 'PTHR35252', NULL, NULL, NULL, NULL, 'RETINITIS PIGMENTOSA 9 PROTEIN', NULL, NULL, 29504, 8),
(245642, NULL, 'PTHR43699', NULL, NULL, NULL, NULL, '3-DEHYDROQUINATE DEHYDRATASE', NULL, NULL, NULL, 8),
(245643, NULL, 'PTHR43791', NULL, NULL, NULL, NULL, 'PERMEASE-RELATED', NULL, NULL, NULL, 8),
(245644, NULL, 'PTHR37345', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 107', NULL, NULL, 30205, 8),
(245645, NULL, 'PTHR34190', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(245646, NULL, 'PTHR45866', NULL, NULL, NULL, NULL, 'DNA GYRASE/TOPOISOMERASE SUBUNIT B', NULL, NULL, NULL, 8),
(245647, NULL, 'PTHR36803', NULL, NULL, NULL, NULL, 'PROTEIN CHLORORESPIRATORY REDUCTION 7, CHLOROPLASTIC', NULL, NULL, 20033, 8),
(245648, NULL, 'PTHR35479', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', NULL, NULL, NULL, 8),
(245649, NULL, 'PTHR43627', NULL, NULL, NULL, NULL, '', NULL, NULL, 11565, 8),
(245650, NULL, 'PTHR10155', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 3-KINASE REGULATORY SUBUNIT', NULL, NULL, NULL, 8),
(245651, NULL, 'PTHR42087', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(245652, NULL, 'PTHR26374', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZAT5', NULL, NULL, NULL, 8),
(245653, NULL, 'PTHR21708', NULL, NULL, NULL, NULL, 'PROBABLE 2-DEHYDROPANTOATE 2-REDUCTASE', NULL, NULL, NULL, 8),
(245654, NULL, 'PTHR43448', NULL, NULL, NULL, NULL, 'PROTOHEME IX FARNESYLTRANSFERASE, MITOCHONDRIAL', NULL, NULL, 5512, 8),
(245655, NULL, 'PTHR47918', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN FIS', NULL, NULL, NULL, 8),
(245656, NULL, 'PTHR16008', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 4', NULL, NULL, 33963, 8),
(245657, NULL, 'PTHR38937', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN OF ER BODY-LIKE PROTEIN', NULL, NULL, NULL, 8),
(245658, NULL, 'PTHR33136', NULL, NULL, NULL, NULL, 'RAPID ALKALINIZATION FACTOR-LIKE', NULL, NULL, NULL, 8),
(245659, NULL, 'PTHR47955', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 71 PROTEIN', NULL, NULL, NULL, 8),
(245660, NULL, 'PTHR47753', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN-RELATED', NULL, NULL, NULL, 8),
(245661, NULL, 'PTHR13980', NULL, NULL, NULL, NULL, 'CDC68 RELATED', NULL, NULL, 32740, 8),
(245662, NULL, 'PTHR11461', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR, SERPIN', NULL, NULL, 1892, 8),
(245663, NULL, 'PTHR45791', NULL, NULL, NULL, NULL, 'CALCIUM AND INTEGRIN BINDING FAMILY MEMBER 2', NULL, NULL, NULL, 8),
(245664, NULL, 'PTHR23529', NULL, NULL, NULL, NULL, 'GH19118P-RELATED', NULL, NULL, NULL, 8),
(245665, NULL, 'PTHR43028', NULL, NULL, NULL, NULL, '3''(2''),5''-BISPHOSPHATE NUCLEOTIDASE 1', NULL, NULL, NULL, 8),
(245666, NULL, 'PTHR22775', NULL, NULL, NULL, NULL, 'SORTING NEXIN', NULL, NULL, NULL, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(245667, NULL, 'PTHR37935', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(245668, NULL, 'PTHR33445', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT B'', CHLOROPLASTIC', NULL, NULL, NULL, 8),
(245669, NULL, 'PTHR40275', NULL, NULL, NULL, NULL, 'SSL7038 PROTEIN', NULL, NULL, 13296, 8),
(245670, NULL, 'PTHR14181', NULL, NULL, NULL, NULL, 'DUFFY ANTIGEN/CHEMOKINE RECEPTOR', NULL, NULL, 6987, 8),
(245671, NULL, 'PTHR15629', NULL, NULL, NULL, NULL, 'SH3YL1 PROTEIN', NULL, NULL, NULL, 8),
(245672, NULL, 'PTHR13356', NULL, NULL, NULL, NULL, 'OB FOLD NUCLEIC ACID BINDING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245673, NULL, 'PTHR35298', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN S1FA2', NULL, NULL, 3168, 8),
(245674, NULL, 'PTHR47853', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(245675, NULL, 'PTHR33983', NULL, NULL, NULL, NULL, 'OS07G0185900 PROTEIN', NULL, NULL, NULL, 8),
(245676, NULL, 'PTHR34928', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 217', NULL, NULL, 25791, 8),
(245677, NULL, 'PTHR12155', NULL, NULL, NULL, NULL, 'SCHLAFEN', NULL, NULL, 24001, 8),
(245678, NULL, 'PTHR21573', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 26567, 8),
(245679, NULL, 'PTHR13345', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 10', NULL, NULL, NULL, 8),
(245680, NULL, 'PTHR46353', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 5', NULL, NULL, 36043, 8),
(245681, NULL, 'PTHR43547', NULL, NULL, NULL, NULL, 'TWO-COMPONENT HISTIDINE KINASE', NULL, NULL, NULL, 8),
(245682, NULL, 'PTHR47015', NULL, NULL, NULL, NULL, 'BPI FOLD-CONTAINING FAMILY A MEMBER 1', NULL, NULL, NULL, 8),
(245683, NULL, 'PTHR35827', NULL, NULL, NULL, NULL, 'ZINC FINGER BED DOMAIN-CONTAINING PROTEIN 3', NULL, NULL, 35324, 8),
(245684, NULL, 'PTHR11757', NULL, NULL, NULL, NULL, 'PROTEASE FAMILY S9A OLIGOPEPTIDASE', NULL, NULL, NULL, 8),
(245685, NULL, 'PTHR46986', NULL, NULL, NULL, NULL, 'ENDORIBONUCLEASE YBEY, CHLOROPLASTIC', NULL, NULL, 2117, 8),
(245686, NULL, 'PTHR15495', NULL, NULL, NULL, NULL, 'NEGATIVE REGULATOR OF VESICLE FORMATION-RELATED', NULL, NULL, 33094, 8),
(245687, NULL, 'PTHR43395', NULL, NULL, NULL, NULL, 'SENSOR HISTIDINE KINASE CHEA', NULL, NULL, NULL, 8),
(245688, NULL, 'PTHR13215', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II TRANSCRIPTIONAL COACTIVATOR', NULL, NULL, 36859, 8),
(245689, NULL, 'PTHR31429', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 36-RELATED', NULL, NULL, 34764, 8),
(245690, NULL, 'PTHR23011', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 35235, 8),
(245691, NULL, 'PTHR35342', NULL, NULL, NULL, NULL, 'TRICARBOXYLIC TRANSPORT PROTEIN', NULL, NULL, NULL, 8),
(245692, NULL, 'PTHR47010', NULL, NULL, NULL, NULL, 'CYSTATIN-8-RELATED', NULL, NULL, NULL, 8),
(245693, NULL, 'PTHR36349', NULL, NULL, NULL, NULL, 'PROTEIN CLAVATA 3', NULL, NULL, 36556, 8),
(245694, NULL, 'PTHR45673', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2B CATALYTIC SUBUNIT 1-RELATED', NULL, NULL, 35050, 8),
(245695, NULL, 'PTHR34268', NULL, NULL, NULL, NULL, 'OS01G0321850 PROTEIN', NULL, NULL, NULL, 8),
(245696, NULL, 'PTHR11724', NULL, NULL, NULL, NULL, 'LEPTIN', NULL, NULL, 3616, 8),
(245697, NULL, 'PTHR35798', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN SEPF', NULL, NULL, 15394, 8),
(245698, NULL, 'PTHR22604', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASES', NULL, NULL, NULL, 8),
(245699, NULL, 'PTHR46662', NULL, NULL, NULL, NULL, 'DI-GLUCOSE BINDING PROTEIN WITH LEUCINE-RICH REPEAT DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(245700, NULL, 'PTHR30053', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR P', NULL, NULL, 20700, 8),
(245701, NULL, 'PTHR39586', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', NULL, NULL, 5952, 8),
(245702, NULL, 'PTHR11984', NULL, NULL, NULL, NULL, 'CONNEXIN', NULL, NULL, 6919, 8),
(245703, NULL, 'PTHR44067', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASE SUPERFAMILY PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245704, NULL, 'PTHR46865', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE-RELATED', NULL, NULL, NULL, 8);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(245705, NULL, 'PTHR21148', NULL, NULL, NULL, NULL, 'THIOREDOXIN DOMAIN-CONTAINING PROTEIN 9', NULL, NULL, NULL, 8),
(245706, NULL, 'PTHR34262', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 220', NULL, NULL, NULL, 8),
(245707, NULL, 'PTHR21227', NULL, NULL, NULL, NULL, 'TRNA-SPLICING ENDONUCLEASE SUBUNIT SEN2', NULL, NULL, 1603, 8),
(245708, NULL, 'PTHR33595', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR A DOMAIN PROTEIN', NULL, NULL, NULL, 8),
(245709, NULL, 'PTHR33643', NULL, NULL, NULL, NULL, 'UREASE ACCESSORY PROTEIN D', NULL, NULL, 2770, 8),
(245710, NULL, 'PTHR14208', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER AND W2 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(245711, NULL, 'PTHR12117', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE COMPLEX', NULL, NULL, NULL, 8),
(245712, NULL, 'PTHR35399', NULL, NULL, NULL, NULL, 'SLR8030 PROTEIN', NULL, NULL, NULL, 8),
(245713, NULL, 'PTHR34045', NULL, NULL, NULL, NULL, 'OS03G0406300 PROTEIN', NULL, NULL, 36055, 8),
(245714, NULL, 'PTHR43252', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR YQJI', NULL, NULL, NULL, 8),
(245715, NULL, 'PTHR34863', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(245716, NULL, 'PTHR38001', NULL, NULL, NULL, NULL, 'PROTEIN CEBPZOS', NULL, NULL, 32279, 8),
(245717, NULL, 'PTHR43531', NULL, NULL, NULL, NULL, 'PROTEIN ICFG', NULL, NULL, NULL, 8),
(245718, NULL, 'PTHR11447', NULL, NULL, NULL, NULL, 'CELLULAR TUMOR ANTIGEN P53', NULL, NULL, 1310, 8),
(245719, NULL, 'PTHR39153', NULL, NULL, NULL, NULL, 'AGR244WP', NULL, NULL, 32257, 8),
(245720, NULL, 'PTHR31209', NULL, NULL, NULL, NULL, 'COFACTOR-INDEPENDENT PHOSPHOGLYCERATE MUTASE', NULL, NULL, 7075, 8),
(245721, NULL, 'PTHR47238', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE 5', NULL, NULL, NULL, 8),
(245722, NULL, 'PTHR42825', NULL, NULL, NULL, NULL, 'AMINO ACID AMINOTRANSFERASE', NULL, NULL, 5921, 8),
(245723, NULL, 'PTHR43260', NULL, NULL, NULL, NULL, '3-KETOSTEROID-DELTA-1-DEHYDROGENASE', NULL, NULL, 10082, 8),
(245724, NULL, 'PTHR13128', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN-SORTING-ASSOCIATED PROTEIN 36', NULL, NULL, 32388, 8),
(245725, NULL, 'PTHR16003', NULL, NULL, NULL, NULL, 'C9ORF40 ISOFORM 1', NULL, NULL, 36821, 8),
(245726, NULL, 'PTHR37531', NULL, NULL, NULL, NULL, 'HEME EXPORTER PROTEIN D', NULL, NULL, NULL, 8),
(245727, NULL, 'PTHR34459', NULL, NULL, NULL, NULL, 'OS01G0264500 PROTEIN', NULL, NULL, NULL, 8),
(245728, NULL, 'PTHR22762', NULL, NULL, NULL, NULL, 'ALPHA-GLUCOSIDASE', NULL, NULL, NULL, 8),
(245729, NULL, 'PTHR22882', NULL, NULL, NULL, NULL, 'SYNPHILIN-1', NULL, NULL, 27375, 8),
(245730, NULL, 'PTHR33672', NULL, NULL, NULL, NULL, 'YCF3-INTERACTING PROTEIN 1, CHLOROPLASTIC', NULL, NULL, 27643, 8),
(245731, NULL, 'PTHR36384', NULL, NULL, NULL, NULL, 'SAWADEE PROTEIN', NULL, NULL, NULL, 8),
(245732, NULL, 'PTHR12613', NULL, NULL, NULL, NULL, 'ERO1-RELATED', NULL, NULL, 6565, 8),
(245733, NULL, 'PTHR46675', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF182', NULL, NULL, 35000, 8),
(245734, NULL, 'PTHR30092', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN CRED', NULL, NULL, 8821, 8),
(245735, NULL, 'PTHR31097', NULL, NULL, NULL, NULL, 'SI:DKEY-276J7.1', NULL, NULL, 31746, 8),
(245736, NULL, 'PTHR31857', NULL, NULL, NULL, NULL, 'HSSA/B-LIKE PROTEIN 17-RELATED', NULL, NULL, NULL, 8),
(245737, NULL, 'PTHR40708', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1700113H08 GENE', NULL, NULL, 24120, 8),
(245738, NULL, 'PTHR43841', NULL, NULL, NULL, NULL, '3-HYDROXYACYL-THIOESTER DEHYDRATASE HTDX-RELATED', NULL, NULL, NULL, 8),
(245739, NULL, 'PTHR12451', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR CASTOR  PROTEIN MING -RELATED', NULL, NULL, 28857, 8),
(245740, NULL, 'PTHR12231', NULL, NULL, NULL, NULL, 'CTX-RELATED TYPE I TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(245741, NULL, 'PTHR35738', NULL, NULL, NULL, NULL, 'OS05G0577800 PROTEIN', NULL, NULL, NULL, 8),
(245742, NULL, 'PTHR45930', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 124-LIKE PROTEIN', NULL, NULL, NULL, 8),
(245743, NULL, 'PTHR12449', NULL, NULL, NULL, NULL, 'DEATH DOMAIN-CONTAINING PROTEIN', NULL, NULL, 27448, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(245744, NULL, 'PTHR46033', NULL, NULL, NULL, NULL, 'PROTEIN MAIN-LIKE 2', NULL, NULL, 34017, 8),
(245745, NULL, 'PTHR21844', NULL, NULL, NULL, NULL, 'AKT1 SUBSTRATE 1 PROTEIN', NULL, NULL, 25697, 8),
(245746, NULL, 'PTHR36167', NULL, NULL, NULL, NULL, 'C2H2 FINGER DOMAIN TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', NULL, NULL, 30898, 8),
(245747, NULL, 'PTHR33940', NULL, NULL, NULL, NULL, 'PROTEIN CBG13625', NULL, NULL, NULL, 8),
(245748, NULL, 'PTHR30118', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR LEUO-RELATED', NULL, NULL, NULL, 8),
(245749, NULL, 'PTHR15390', NULL, NULL, NULL, NULL, 'NEUROMEDIN-U', NULL, NULL, 36635, 8),
(245750, NULL, 'PTHR38603', NULL, NULL, NULL, NULL, 'CHAPERONE NAPD', NULL, NULL, 2641, 8),
(245751, NULL, 'PTHR42700', NULL, NULL, NULL, NULL, 'SULFATE ADENYLYLTRANSFERASE', NULL, NULL, NULL, 8),
(245752, NULL, 'PTHR12399', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT 7', NULL, NULL, 2197, 8),
(245753, NULL, 'PTHR36152', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245754, NULL, 'PTHR28297', NULL, NULL, NULL, NULL, 'FUNGAL PROTEIN', NULL, NULL, 20151, 8),
(245755, NULL, 'PTHR27000', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE FAMILY PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245756, NULL, 'PTHR36871', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 190', NULL, NULL, 25120, 8),
(245757, NULL, 'PTHR22746', NULL, NULL, NULL, NULL, 'RAB6A-GEF COMPLEX PARTNER PROTEIN 1', NULL, NULL, 31605, 8),
(245758, NULL, 'PTHR11949', NULL, NULL, NULL, NULL, 'INTERFERON REGULATORY FACTOR', NULL, NULL, NULL, 8),
(245759, NULL, 'PTHR21221', NULL, NULL, NULL, NULL, 'UREIDOGLYCOLATE HYDROLASE', NULL, NULL, 6726, 8),
(245760, NULL, 'PTHR31081', NULL, NULL, NULL, NULL, 'UREIDE PERMEASE 1-RELATED-RELATED', NULL, NULL, 21612, 8),
(245761, NULL, 'PTHR42080', NULL, NULL, NULL, NULL, 'SRR1 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(245762, NULL, 'PTHR36510', NULL, NULL, NULL, NULL, 'GLUTAMATE--CYSTEINE LIGASE 2-RELATED', NULL, NULL, NULL, 8),
(245763, NULL, 'PTHR23213', NULL, NULL, NULL, NULL, 'FORMIN-RELATED', NULL, NULL, 26955, 8),
(245764, NULL, 'PTHR43828', NULL, NULL, NULL, NULL, 'ASPARAGINASE', NULL, NULL, NULL, 8),
(245765, NULL, 'PTHR31165', NULL, NULL, NULL, NULL, 'PROTEIN G1-LIKE2', NULL, NULL, 31391, 8),
(245766, NULL, 'PTHR40743', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-DIPHOSPHO-SUGAR TRANSFERASE CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(245767, NULL, 'PTHR34391', NULL, NULL, NULL, NULL, 'UPF0658 GOLGI APPARATUS MEMBRANE PROTEIN C1952.10C-RELATED', NULL, NULL, 27992, 8),
(245768, NULL, 'PTHR23341', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP PROTEINS HMG-A AND C', NULL, NULL, NULL, 8),
(245769, NULL, 'PTHR48022', NULL, NULL, NULL, NULL, 'PLASTIDIC GLUCOSE TRANSPORTER 4', NULL, NULL, NULL, 8),
(245770, NULL, 'PTHR40590', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245771, NULL, 'PTHR43382', NULL, NULL, NULL, NULL, 'PROLYL-TRNA SYNTHETASE', NULL, NULL, 1911, 8),
(245772, NULL, 'PTHR41404', NULL, NULL, NULL, NULL, 'SHIELDIN COMPLEX SUBUNIT 3', NULL, NULL, 27295, 8),
(245773, NULL, 'PTHR12280', NULL, NULL, NULL, NULL, 'PANTOTHENATE KINASE', NULL, NULL, 784, 8),
(245774, NULL, 'PTHR21110', NULL, NULL, NULL, NULL, 'PHOSPHOPENTOMUTASE', NULL, NULL, 5455, 8),
(245775, NULL, 'PTHR42792', NULL, NULL, NULL, NULL, 'FLAGELLIN', NULL, NULL, 6428, 8),
(245776, NULL, 'PTHR31875', NULL, NULL, NULL, NULL, 'PROTEIN DEHYDRATION-INDUCED 19', NULL, NULL, 31947, 8),
(245777, NULL, 'PTHR22883', NULL, NULL, NULL, NULL, 'ZINC FINGER DHHC DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(245778, NULL, 'PTHR15160', NULL, NULL, NULL, NULL, 'VON HIPPEL-LINDAU PROTEIN', NULL, NULL, NULL, 8),
(245779, NULL, 'PTHR46746', NULL, NULL, NULL, NULL, 'KILLER CELL LECTIN-LIKE RECEPTOR SUBFAMILY F MEMBER 2', NULL, NULL, NULL, 8),
(245780, NULL, 'PTHR33273', NULL, NULL, NULL, NULL, 'DOMAIN-CONTAINING PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(245781, NULL, 'PTHR43157', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-GLYCAN BIOSYNTHESIS CLASS F PROTEIN-RELATED', NULL, NULL, NULL, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(245782, NULL, 'PTHR37363', NULL, NULL, NULL, NULL, 'EKC/KEOPS COMPLEX SUBUNIT GON7', NULL, NULL, 25537, 8),
(245783, NULL, 'PTHR37078', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(245784, NULL, 'PTHR47135', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE III DOMAIN-CONTAINING PROTEIN 7', NULL, NULL, NULL, 8),
(245785, NULL, 'PTHR47637', NULL, NULL, NULL, NULL, 'CHAPERONE SURA', NULL, NULL, NULL, 8),
(245786, NULL, 'PTHR12259', NULL, NULL, NULL, NULL, 'RGS-GAIP INTERACTING PROTEIN GIPC', NULL, NULL, 18177, 8),
(245787, NULL, 'PTHR48183', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(245788, NULL, 'PTHR38696', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(245789, NULL, 'PTHR40351', NULL, NULL, NULL, NULL, 'PROTEIN CBG19323', NULL, NULL, NULL, 8),
(245790, NULL, 'PTHR47821', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE MUTASE FAMILY PROTEIN', NULL, NULL, NULL, 8),
(245791, NULL, 'PTHR43560', NULL, NULL, NULL, NULL, 'ION-TRANSLOCATING OXIDOREDUCTASE COMPLEX SUBUNIT B', NULL, NULL, NULL, 8),
(245792, NULL, 'PTHR43081', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE, TERMINAL-DIFFERENTIATION SPECIFIC-RELATED', NULL, NULL, NULL, 8),
(245793, NULL, 'PTHR22042', NULL, NULL, NULL, NULL, 'TANKYRASE 1 BINDING PROTEIN', NULL, NULL, 27472, 8),
(245794, NULL, 'PTHR15263', NULL, NULL, NULL, NULL, 'I-KAPPA-B-LIKE PROTEIN  IKBL', NULL, NULL, 30649, 8),
(245795, NULL, 'PTHR35833', NULL, NULL, NULL, NULL, 'GALACTOSE-BINDING DOMAIN-LIKE, ARMADILLO-TYPE FOLD PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245796, NULL, 'PTHR33047', NULL, NULL, NULL, NULL, 'PROTEIN TAR1', NULL, NULL, NULL, 8),
(245797, NULL, 'PTHR28125', NULL, NULL, NULL, NULL, 'MEIOTIC EXPRESSION UP-REGULATED PROTEIN 26', NULL, NULL, NULL, 8),
(245798, NULL, 'PTHR23520', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G04000)-RELATED', NULL, NULL, NULL, 8),
(245799, NULL, 'PTHR47188', NULL, NULL, NULL, NULL, 'PROTEIN TAR1', NULL, NULL, 36349, 8),
(245800, NULL, 'PTHR24260', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(245801, NULL, 'PTHR38527', NULL, NULL, NULL, NULL, 'OS01G0838200 PROTEIN', NULL, NULL, NULL, 8),
(245802, NULL, 'PTHR10044', NULL, NULL, NULL, NULL, 'INHIBITOR OF APOPTOSIS', NULL, NULL, NULL, 8),
(245803, NULL, 'PTHR16955', NULL, NULL, NULL, NULL, 'METASTASIS-SUPPRESSOR KISS-1', NULL, NULL, 18947, 8),
(245804, NULL, 'PTHR21575', NULL, NULL, NULL, NULL, 'PROTEIN HID1', NULL, NULL, 24444, 8),
(245805, NULL, 'PTHR38666', NULL, NULL, NULL, NULL, '', NULL, NULL, 18681, 8),
(245806, NULL, 'PTHR38323', NULL, NULL, NULL, NULL, 'PROTEIN HEATR9', NULL, NULL, NULL, 8),
(245807, NULL, 'PTHR46311', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN 8-RELATED', NULL, NULL, NULL, 8),
(245808, NULL, 'PTHR10059', NULL, NULL, NULL, NULL, 'GRANULOCYTE-MACROPHAGE COLONY-STIMULATING FACTOR  GM-CSF', NULL, NULL, 6701, 8),
(245809, NULL, 'PTHR47866', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', NULL, NULL, NULL, 8),
(245810, NULL, 'PTHR22705', NULL, NULL, NULL, NULL, 'ZINC FINGER, ZZ DOMAIN CONTAINING 3', NULL, NULL, 30535, 8),
(245811, NULL, 'PTHR47475', NULL, NULL, NULL, NULL, 'CHROMOSOME TRANSMISSION FIDELITY PROTEIN 8', NULL, NULL, NULL, 8),
(245812, NULL, 'PTHR28243', NULL, NULL, NULL, NULL, 'AGL049CP', NULL, NULL, NULL, 8),
(245813, NULL, 'PTHR10920', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(245814, NULL, 'PTHR34365', NULL, NULL, NULL, NULL, 'ENOLASE (DUF1399)', NULL, NULL, 13439, 8),
(245815, NULL, 'PTHR21679', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(245816, NULL, 'PTHR10786', NULL, NULL, NULL, NULL, 'CHOLECYSTOKININ', NULL, NULL, 9420, 8),
(245817, NULL, 'PTHR33305', NULL, NULL, NULL, NULL, 'ETHYLENE INSENSITIVE 3-LIKE 2 PROTEIN', NULL, NULL, 5580, 8),
(245818, NULL, 'PTHR45976', NULL, NULL, NULL, NULL, 'ARMADILLO SEGMENT POLARITY PROTEIN', NULL, NULL, 8697, 8),
(245819, NULL, 'PTHR48218', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(245820, NULL, 'PTHR21485', NULL, NULL, NULL, NULL, 'HAD SUPERFAMILY MEMBERS CMAS AND KDSC', NULL, NULL, NULL, 8);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(245821, NULL, 'PTHR16220', NULL, NULL, NULL, NULL, 'WD REPEAT PROTEIN 8-RELATED', NULL, NULL, NULL, 8),
(245822, NULL, 'PTHR43585', NULL, NULL, NULL, NULL, 'FUMIPYRROLE BIOSYNTHESIS PROTEIN C', NULL, NULL, NULL, 8),
(245823, NULL, 'PTHR19357', NULL, NULL, NULL, NULL, 'TRIGGERING RECEPTOR EXPRESSED ON MYELOID CELLS 1', NULL, NULL, NULL, 8),
(245824, NULL, 'PTHR46729', NULL, NULL, NULL, NULL, 'LEUKOCYTE RECEPTOR CLUSTER MEMBER 9', NULL, NULL, 35750, 8),
(245825, NULL, 'PTHR45669', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN DOMAIN-CONTAINING CYSTEINE-RICH PROTEIN CG12206-RELATED', NULL, NULL, NULL, 8),
(245826, NULL, 'PTHR48151', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(245827, NULL, 'PTHR36151', NULL, NULL, NULL, NULL, 'BLR2777 PROTEIN', NULL, NULL, NULL, 8),
(245828, NULL, 'PTHR37530', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN SLP', NULL, NULL, 2884, 8),
(245829, NULL, 'PTHR47984', NULL, NULL, NULL, NULL, 'OS01G0323000 PROTEIN', NULL, NULL, NULL, 8),
(245830, NULL, 'PTHR33827', NULL, NULL, NULL, NULL, 'PROTEIN SAWADEE HOMEODOMAIN HOMOLOG 2', NULL, NULL, 30623, 8),
(245831, NULL, 'PTHR35770', NULL, NULL, NULL, NULL, 'U2 SMALL NUCLEAR RIBONUCLEOPROTEIN AUXILIARY FACTOR-LIKE PROTEIN', NULL, NULL, NULL, 8),
(245832, NULL, 'PTHR10183', NULL, NULL, NULL, NULL, 'CALPAIN', NULL, NULL, NULL, 8),
(245833, NULL, 'PTHR46121', NULL, NULL, NULL, NULL, 'STEROIDOGENIC ACUTE REGULATORY PROTEIN-LIKE', NULL, NULL, NULL, 8),
(245834, NULL, 'PTHR12210', NULL, NULL, NULL, NULL, 'DULLARD PROTEIN PHOSPHATASE', NULL, NULL, NULL, 8),
(245835, NULL, 'PTHR10503', NULL, NULL, NULL, NULL, 'HP1 LIKE (HETEROCHROMATIN PROTEIN)-RELATED', NULL, NULL, 28843, 8),
(245836, NULL, 'PTHR28048', NULL, NULL, NULL, NULL, 'ACR195WP', NULL, NULL, NULL, 8),
(245837, NULL, 'PTHR15460', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN 4', NULL, NULL, 19342, 8),
(245838, NULL, 'PTHR15607', NULL, NULL, NULL, NULL, 'SYNAPTONEMAL COMPLEX PROTEIN-RELATED', NULL, NULL, 15856, 8),
(245839, NULL, 'PTHR42769', NULL, NULL, NULL, NULL, 'SUPEROXIDE DISMUTASE', NULL, NULL, NULL, 8),
(245840, NULL, 'PTHR35079', NULL, NULL, NULL, NULL, 'LUNG ADENOMA SUSCEPTIBILITY PROTEIN 2', NULL, NULL, NULL, 8),
(245841, NULL, 'PTHR10039', NULL, NULL, NULL, NULL, 'AMELOGENIN', NULL, NULL, NULL, 8),
(245842, NULL, 'PTHR47559', NULL, NULL, NULL, NULL, 'OS03G0844900 PROTEIN', NULL, NULL, NULL, 8),
(245843, NULL, 'PTHR24125', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND DEATH DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(245844, NULL, 'PTHR12887', NULL, NULL, NULL, NULL, 'NANOS PROTEIN', NULL, NULL, 13470, 8),
(245845, NULL, 'PTHR48187', NULL, NULL, NULL, NULL, 'LD21810P', NULL, NULL, NULL, 8),
(245846, NULL, 'PTHR34309', NULL, NULL, NULL, NULL, 'SLR1406 PROTEIN', NULL, NULL, NULL, 8),
(245847, NULL, 'PTHR36022', NULL, NULL, NULL, NULL, 'GPI-ANCHORED ADHESIN-LIKE PROTEIN', NULL, NULL, NULL, 8),
(245848, NULL, 'PTHR37953', NULL, NULL, NULL, NULL, 'UPF0127 PROTEIN MJ1496', NULL, NULL, 6037, 8),
(245849, NULL, 'PTHR16065', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN CONTAINING 198', NULL, NULL, 21586, 8),
(245850, NULL, 'PTHR31701', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM MEMBRANE-ASSOCIATED RNA DEGRADATION PROTEIN', NULL, NULL, 27188, 8),
(245851, NULL, 'PTHR41299', NULL, NULL, NULL, NULL, 'THIAMINE PYROPHOSPHOKINASE', NULL, NULL, NULL, 8),
(245852, NULL, 'PTHR37424', NULL, NULL, NULL, NULL, 'BACTERIOFERRITIN-ASSOCIATED FERREDOXIN', NULL, NULL, NULL, 8),
(245853, NULL, 'PTHR43298', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN NORM-RELATED', NULL, NULL, NULL, 8),
(245854, NULL, 'PTHR45706', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE', NULL, NULL, NULL, 8),
(245855, NULL, 'PTHR40429', NULL, NULL, NULL, NULL, 'FLAGELLAR ASSOCIATED PROTEIN', NULL, NULL, NULL, 8),
(245856, NULL, 'PTHR43174', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE 2-EPIMERASE', NULL, NULL, 23720, 8),
(245857, NULL, 'PTHR22674', NULL, NULL, NULL, NULL, 'NTPASE, KAP FAMILY P-LOOP DOMAIN-CONTAINING 1', NULL, NULL, NULL, 8),
(245858, NULL, 'PTHR31099', NULL, NULL, NULL, NULL, 'OS06G0165300 PROTEIN', NULL, NULL, NULL, 8);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(245859, NULL, 'PTHR46590', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL TRANSFER PROTEIN CSR1-RELATED', NULL, NULL, NULL, 8),
(245860, NULL, 'PTHR35820', NULL, NULL, NULL, NULL, 'SPERM MITOCHONDRIAL-ASSOCIATED CYSTEINE-RICH PROTEIN', NULL, NULL, NULL, 8),
(245861, NULL, 'PTHR23528', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(245862, NULL, 'PTHR38092', NULL, NULL, NULL, NULL, 'REGULATOR CUDA, PUTATIVE-RELATED', NULL, NULL, 28533, 8),
(245863, NULL, 'PTHR35706', NULL, NULL, NULL, NULL, 'F14O23.11 PROTEIN', NULL, NULL, NULL, 8),
(245864, NULL, 'PTHR10210', NULL, NULL, NULL, NULL, 'RIBOSE-PHOSPHATE DIPHOSPHOKINASE FAMILY MEMBER', NULL, NULL, 231, 8),
(245865, NULL, 'PTHR30417', NULL, NULL, NULL, NULL, 'N-ACETYLMURAMOYL-L-ALANINE AMIDASE AMID', NULL, NULL, NULL, 8),
(245866, NULL, 'PTHR47254', NULL, NULL, NULL, NULL, 'CELL WALL MANNOPROTEIN CIS3-RELATED', NULL, NULL, NULL, 8),
(245867, NULL, 'PTHR15508', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S6 KINASE', NULL, NULL, NULL, 8),
(245868, NULL, 'PTHR10336', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE-SPECIFIC PHOSPHOLIPASE C FAMILY PROTEIN', NULL, NULL, 1363, 8),
(245869, NULL, 'PTHR46799', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN UNC-4 HOMOLOG', NULL, NULL, NULL, 8),
(245870, NULL, 'PTHR15193', NULL, NULL, NULL, NULL, 'CD83 ANTIGEN', NULL, NULL, NULL, 8),
(245871, NULL, 'PTHR12978', NULL, NULL, NULL, NULL, 'HISTIDINE TRIAD  HIT  PROTEIN MEMBER', NULL, NULL, 14311, 8),
(245872, NULL, 'PTHR14049', NULL, NULL, NULL, NULL, 'LEPRECAN 1', NULL, NULL, 33667, 8),
(245873, NULL, 'PTHR32215', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 57', NULL, NULL, NULL, 8),
(245874, NULL, 'PTHR43506', NULL, NULL, NULL, NULL, 'BIOTIN/LIPOATE A/B PROTEIN LIGASE FAMILY', NULL, NULL, NULL, 8),
(245875, NULL, 'PTHR21109', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 28S RIBOSOMAL PROTEIN S21', NULL, NULL, 4023, 8),
(245876, NULL, 'PTHR21354', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 33006, 8),
(245877, NULL, 'PTHR37294', NULL, NULL, NULL, NULL, '3''-5'' EXORIBONUCLEASE YHAM', NULL, NULL, NULL, 8),
(245878, NULL, 'PTHR39374', NULL, NULL, NULL, NULL, 'PROTEIN CBG12861', NULL, NULL, NULL, 8),
(245879, NULL, 'PTHR47426', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASES (NAT) SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(245880, NULL, 'PTHR23012', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER DOMAIN-CONTAINING', NULL, NULL, 28248, 8),
(245881, NULL, 'PTHR48060', NULL, NULL, NULL, NULL, 'DNA DAMAGE-REPAIR/TOLERATION PROTEIN DRT100', NULL, NULL, NULL, 8),
(245882, NULL, 'PTHR46421', NULL, NULL, NULL, NULL, 'PROGRAMMED CELL DEATH PROTEIN 2-LIKE', NULL, NULL, NULL, 8),
(245883, NULL, 'PTHR14971', NULL, NULL, NULL, NULL, 'VESICULAR, OVEREXPRESSED IN CANCER, PROSURVIVAL PROTEIN 1', NULL, NULL, 25611, 8),
(245884, NULL, 'PTHR22895', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(245885, NULL, 'PTHR46110', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HMX', NULL, NULL, NULL, 8),
(245886, NULL, 'PTHR30004', NULL, NULL, NULL, NULL, '4-HYDROXYTHREONINE-4-PHOSPHATE DEHYDROGENASE', NULL, NULL, 11328, 8),
(245887, NULL, 'PTHR10546', NULL, NULL, NULL, NULL, 'SODIUM CHANNEL SUBUNIT BETA-1 AND 3', NULL, NULL, 21813, 8),
(245888, NULL, 'PTHR36206', NULL, NULL, NULL, NULL, 'ASPERCRYPTIN BIOSYNTHESIS CLUSTER-SPECIFIC TRANSCRIPTION REGULATOR ATNN-RELATED', NULL, NULL, NULL, 8),
(245889, NULL, 'PTHR15327', NULL, NULL, NULL, NULL, 'MICROFIBRIL-ASSOCIATED PROTEIN', NULL, NULL, 29369, 8),
(245890, NULL, 'PTHR35806', NULL, NULL, NULL, NULL, 'OXALOACETATE DECARBOXYLASE BETA CHAIN 2', NULL, NULL, 3717, 8),
(245891, NULL, 'PTHR35374', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 11A-LIKE', NULL, NULL, NULL, 8),
(245892, NULL, 'PTHR16840', NULL, NULL, NULL, NULL, 'GROWTH ARREST-SPECIFIC PROTEIN 1', NULL, NULL, 33512, 8),
(245893, NULL, 'PTHR34219', NULL, NULL, NULL, NULL, 'IRON-REGULATED INNER MEMBRANE PROTEIN-RELATED', NULL, NULL, 2965, 8),
(245894, NULL, 'PTHR46523', NULL, NULL, NULL, NULL, 'DCTP PYROPHOSPHATASE 1', NULL, NULL, NULL, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(245895, NULL, 'PTHR46801', NULL, NULL, NULL, NULL, 'OS06G0309200 PROTEIN', NULL, NULL, 34732, 8),
(245896, NULL, 'PTHR31607', NULL, NULL, NULL, NULL, 'DUF1216 DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245897, NULL, 'PTHR13140', NULL, NULL, NULL, NULL, 'MYOSIN', NULL, NULL, NULL, 8),
(245898, NULL, 'PTHR28613', NULL, NULL, NULL, NULL, 'SI:CH211-232M10.4-RELATED', NULL, NULL, 26499, 8),
(245899, NULL, 'PTHR12773', NULL, NULL, NULL, NULL, 'UPF0315 PROTEIN-RELATED', NULL, NULL, 27658, 8),
(245900, NULL, 'PTHR46343', NULL, NULL, NULL, NULL, 'HYR DOMAIN-CONTAINING PROTEIN', NULL, NULL, 34214, 8),
(245901, NULL, 'PTHR36010', NULL, NULL, NULL, NULL, 'CYTOCHROME C BIOGENESIS CCMF C-TERMINAL-LIKE MITOCHONDRIAL PROTEIN-RELATED', NULL, NULL, 34666, 8),
(245902, NULL, 'PTHR28113', NULL, NULL, NULL, NULL, 'DASH COMPLEX SUBUNIT DAM1', NULL, NULL, 7532, 8),
(245903, NULL, 'PTHR37514', NULL, NULL, NULL, NULL, 'N-TERMINAL DELTA ENDOTOXIN DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245904, NULL, 'PTHR47104', NULL, NULL, NULL, NULL, 'SEC14P-LIKE PHOSPHATIDYLINOSITOL TRANSFER FAMILY PROTEIN', NULL, NULL, NULL, 8),
(245905, NULL, 'PTHR31089', NULL, NULL, NULL, NULL, 'CYCLIC DOF FACTOR 2', NULL, NULL, 34593, 8),
(245906, NULL, 'PTHR38778', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', NULL, NULL, 3654, 8),
(245907, NULL, 'PTHR47966', NULL, NULL, NULL, NULL, 'BETA-SITE APP-CLEAVING ENZYME, ISOFORM A-RELATED', NULL, NULL, 6342, 8),
(245908, NULL, 'PTHR13026', NULL, NULL, NULL, NULL, 'NNP-1 PROTEIN  NOVEL NUCLEAR PROTEIN 1   NOP52', NULL, NULL, 7880, 8),
(245909, NULL, 'PTHR30270', NULL, NULL, NULL, NULL, 'THIAMINE-MONOPHOSPHATE KINASE', NULL, NULL, 3742, 8),
(245910, NULL, 'PTHR35255', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 71', NULL, NULL, 25325, 8),
(245911, NULL, 'PTHR33834', NULL, NULL, NULL, NULL, 'SIGNALING PEPTIDE TAXIMIN 2', NULL, NULL, NULL, 8),
(245912, NULL, 'PTHR28106', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ATPASE COMPLEX SUBUNIT ATP10', NULL, NULL, 2276, 8),
(245913, NULL, 'PTHR10632', NULL, NULL, NULL, NULL, 'SULFIDE:QUINONE OXIDOREDUCTASE', NULL, NULL, 11966, 8),
(245914, NULL, 'PTHR30605', NULL, NULL, NULL, NULL, 'ANHYDRO-N-ACETYLMURAMIC ACID KINASE', NULL, NULL, 6303, 8),
(245915, NULL, 'PTHR46356', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 2-OXODICARBOXYLATE CARRIER', NULL, NULL, NULL, 8),
(245916, NULL, 'PTHR32502', NULL, NULL, NULL, NULL, 'N-ACETYLGALACTOSAMINE PERMEASE II COMPONENT-RELATED', NULL, NULL, NULL, 8),
(245917, NULL, 'PTHR35700', NULL, NULL, NULL, NULL, 'OS07G0181800 PROTEIN', NULL, NULL, NULL, 8),
(245918, NULL, 'PTHR33070', NULL, NULL, NULL, NULL, 'OS06G0725500 PROTEIN', NULL, NULL, NULL, 8),
(245919, NULL, 'PTHR34058', NULL, NULL, NULL, NULL, 'OXYGEN-EVOLVING ENHANCER PROTEIN 1-2, CHLOROPLASTIC', NULL, NULL, 2997, 8),
(245920, NULL, 'PTHR31140', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING TRANSCRIPTION FACTOR ABI3', NULL, NULL, 34437, 8),
(245921, NULL, 'PTHR39219', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(245922, NULL, 'PTHR11385', NULL, NULL, NULL, NULL, 'SERUM ALBUMIN-RELATED', NULL, NULL, 528, 8),
(245923, NULL, 'PTHR46972', NULL, NULL, NULL, NULL, 'MONOOXYGENASE ASQM-RELATED', NULL, NULL, NULL, 8),
(245924, NULL, 'PTHR33647', NULL, NULL, NULL, NULL, 'OS01G0793900 PROTEIN', NULL, NULL, NULL, 8),
(245925, NULL, 'PTHR36738', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(245926, NULL, 'PTHR31560', NULL, NULL, NULL, NULL, 'UPF0652 PROTEIN C16A11.03C-RELATED', NULL, NULL, 15445, 8),
(245927, NULL, 'PTHR12680', NULL, NULL, NULL, NULL, 'PUTATIVE HOMEODOMAIN TRANSCRIPTION FACTOR  PHTF', NULL, NULL, 33233, 8),
(245928, NULL, 'PTHR24304', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 7', NULL, NULL, NULL, 8),
(245929, NULL, 'PTHR37316', NULL, NULL, NULL, NULL, 'TEICHOIC ACID GLYCEROL-PHOSPHATE PRIMASE', NULL, NULL, NULL, 8),
(245930, NULL, 'PTHR34815', NULL, NULL, NULL, NULL, 'LYSINE ACETYLTRANSFERASE', NULL, NULL, NULL, 8),
(245931, NULL, 'PTHR30427', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR PROTEIN LYSR', NULL, NULL, NULL, 8);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(245932, NULL, 'PTHR38630', NULL, NULL, NULL, NULL, 'PROTEIN CBG12780', NULL, NULL, NULL, 8),
(245933, NULL, 'PTHR30627', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN D,D-TRANSPEPTIDASE', NULL, NULL, NULL, 8),
(245934, NULL, 'PTHR36819', NULL, NULL, NULL, NULL, 'REGULATOR OF PHOSPHOLIPASE D SRF1', NULL, NULL, 27267, 8),
(245935, NULL, 'PTHR47687', NULL, NULL, NULL, NULL, 'G8 DOMAIN-CONTAINING PROTEIN DDB_G0288475-RELATED', NULL, NULL, NULL, 8),
(245936, NULL, 'PTHR42981', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE [UBIQUINONE]', NULL, NULL, NULL, 8),
(245937, NULL, 'PTHR40710', NULL, NULL, NULL, NULL, 'RIKEN CDNA E230025N22 GENE', NULL, NULL, NULL, 8),
(245938, NULL, 'PTHR12743', NULL, NULL, NULL, NULL, 'CYTOCHROME C1 HEME LYASE', NULL, NULL, 6567, 8),
(245939, NULL, 'PTHR24273', NULL, NULL, NULL, NULL, 'FI04643P-RELATED', NULL, NULL, NULL, 8),
(245940, NULL, 'PTHR47674', NULL, NULL, NULL, NULL, 'SAGA-ASSOCIATED FACTOR 11', NULL, NULL, NULL, 8),
(245941, NULL, 'PTHR11353', NULL, NULL, NULL, NULL, 'CHAPERONIN', NULL, NULL, 19266, 8),
(245942, NULL, 'PTHR47988', NULL, NULL, NULL, NULL, 'SOMATIC EMBRYOGENESIS RECEPTOR KINASE 1', NULL, NULL, NULL, 8),
(245943, NULL, 'PTHR12703', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 33', NULL, NULL, NULL, 8),
(245944, NULL, 'PTHR35509', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (DUF1995)-RELATED', NULL, NULL, NULL, 8),
(245945, NULL, 'PTHR37262', NULL, NULL, NULL, NULL, 'PROTEIN PEP-RELATED DEVELOPMENT ARRESTED 1, CHLOROPLASTIC', NULL, NULL, 30291, 8),
(245946, NULL, 'PTHR43362', NULL, NULL, NULL, NULL, 'MANNITOL DEHYDROGENASE DSF1-RELATED', NULL, NULL, NULL, 8),
(245947, NULL, 'PTHR13131', NULL, NULL, NULL, NULL, 'CYSTINOSIN', NULL, NULL, 4117, 8),
(245948, NULL, 'PTHR36848', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN (PUTATIVE SECRETED PROTEIN)-RELATED', NULL, NULL, NULL, 8),
(245949, NULL, 'PTHR35679', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4933402J07 GENE', NULL, NULL, 26763, 8),
(245950, NULL, 'PTHR46052', NULL, NULL, NULL, NULL, 'PHOSDUCIN-LIKE PROTEIN', NULL, NULL, NULL, 8),
(245951, NULL, 'PTHR13394', NULL, NULL, NULL, NULL, 'ORIGIN RECOGNITION COMPLEX SUBUNIT 6', NULL, NULL, 19569, 8),
(245952, NULL, 'PTHR38690', NULL, NULL, NULL, NULL, 'PROTEASE-RELATED', NULL, NULL, 13720, 8),
(245953, NULL, 'PTHR35397', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245954, NULL, 'PTHR46113', NULL, NULL, NULL, NULL, 'SNAC DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(245955, NULL, 'PTHR10231', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-SUGAR TRANSMEMBRANE TRANSPORTER', NULL, NULL, 7432, 8),
(245956, NULL, 'PTHR31833', NULL, NULL, NULL, NULL, 'UPF0690 PROTEIN C1ORF52', NULL, NULL, NULL, 8),
(245957, NULL, 'PTHR46424', NULL, NULL, NULL, NULL, 'UBX DOMAIN-CONTAINING PROTEIN 4', NULL, NULL, NULL, 8),
(245958, NULL, 'PTHR31938', NULL, NULL, NULL, NULL, 'NUCLEAR SPECKLE SPLICING REGULATORY PROTEIN 1', NULL, NULL, 36615, 8),
(245959, NULL, 'PTHR33881', NULL, NULL, NULL, NULL, 'NEUROGENIC LOCUS NOTCH-LIKE PROTEIN', NULL, NULL, NULL, 8),
(245960, NULL, 'PTHR47916', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE CLASS 1', NULL, NULL, NULL, 8),
(245961, NULL, 'PTHR36478', NULL, NULL, NULL, NULL, 'OS04G0614237 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245962, NULL, 'PTHR13532', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 27354, 8),
(245963, NULL, 'PTHR48001', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', NULL, NULL, NULL, 8),
(245964, NULL, 'PTHR47892', NULL, NULL, NULL, NULL, 'UNIVERSAL STRESS PROTEIN E', NULL, NULL, NULL, 8),
(245965, NULL, 'PTHR37831', NULL, NULL, NULL, NULL, 'D-RIBOSE PYRANASE', NULL, NULL, 15151, 8),
(245966, NULL, 'PTHR16322', NULL, NULL, NULL, NULL, 'PHOSPHOPROTEIN ASSOCIATED WITH GLYCOSPHINGOLIPID-ENRICHED MICRODOMAINS 1', NULL, NULL, 22376, 8),
(245967, NULL, 'PTHR47116', NULL, NULL, NULL, NULL, 'PHLOEM FILAMENT PROTEIN', NULL, NULL, 26845, 8),
(245968, NULL, 'PTHR12098', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE PELLINO-RELATED', NULL, NULL, 3534, 8),
(245969, NULL, 'PTHR32123', NULL, NULL, NULL, NULL, 'BICD FAMILY-LIKE CARGO ADAPTER', NULL, NULL, NULL, 8);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(245970, NULL, 'PTHR43323', NULL, NULL, NULL, NULL, '3-HYDROXY-3-METHYLGLUTARYL COENZYME A SYNTHASE', NULL, NULL, NULL, 8),
(245971, NULL, 'PTHR33202', NULL, NULL, NULL, NULL, 'ZINC UPTAKE REGULATION PROTEIN', NULL, NULL, 550, 8),
(245972, NULL, 'PTHR47417', NULL, NULL, NULL, NULL, 'SMR DOMAIN-CONTAINING PROTEIN YPL199C', NULL, NULL, NULL, 8),
(245973, NULL, 'PTHR46513', NULL, NULL, NULL, NULL, 'VITELLOGENIN RECEPTOR-LIKE PROTEIN-RELATED-RELATED', NULL, NULL, NULL, 8),
(245974, NULL, 'PTHR35723', NULL, NULL, NULL, NULL, 'POLYPHOSPHATIDYLINOSITOL PHOSPHATASE', NULL, NULL, NULL, 8),
(245975, NULL, 'PTHR37384', NULL, NULL, NULL, NULL, 'OS01G0835600 PROTEIN', NULL, NULL, NULL, 8),
(245976, NULL, 'PTHR19959', NULL, NULL, NULL, NULL, 'KINESIN LIGHT CHAIN', NULL, NULL, NULL, 8),
(245977, NULL, 'PTHR36487', NULL, NULL, NULL, NULL, 'OS09G0296500 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(245978, NULL, 'PTHR43321', NULL, NULL, NULL, NULL, 'GLUTAMATE DECARBOXYLASE', NULL, NULL, 2333, 8),
(245979, NULL, 'PTHR35392', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED-RELATED', NULL, NULL, NULL, 8),
(245980, NULL, 'PTHR33597', NULL, NULL, NULL, NULL, 'OS02G0760400 PROTEIN', NULL, NULL, NULL, 8),
(245981, NULL, 'PTHR11141', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN SEC23', NULL, NULL, 29724, 8),
(245982, NULL, 'PTHR23524', NULL, NULL, NULL, NULL, 'TRANSPORTER, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G04850)-RELATED', NULL, NULL, NULL, 8),
(245983, NULL, 'PTHR12544', NULL, NULL, NULL, NULL, 'GLUTAMINASE', NULL, NULL, 13674, 8),
(245984, NULL, 'PTHR37353', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4921517D22 GENE', NULL, NULL, 27231, 8),
(245985, NULL, 'PTHR47285', NULL, NULL, NULL, NULL, 'PROTEIN TIC 62, CHLOROPLASTIC', NULL, NULL, 34974, 8),
(245986, NULL, 'PTHR39117', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 28', NULL, NULL, 7053, 8),
(245987, NULL, 'PTHR13754', NULL, NULL, NULL, NULL, 'METALLO-BETA-LACTAMASE SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(245988, NULL, 'PTHR11038', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM10', NULL, NULL, NULL, 8),
(245989, NULL, 'PTHR35043', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(245990, NULL, 'PTHR44825', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(245991, NULL, 'PTHR32235', NULL, NULL, NULL, NULL, 'NON-HOMOLOGOUS END-JOINING FACTOR 1', NULL, NULL, NULL, 8),
(245992, NULL, 'PTHR38402', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL OUTER MEMBRANE PROTEIN OM14', NULL, NULL, 30916, 8),
(245993, NULL, 'PTHR46786', NULL, NULL, NULL, NULL, 'ZINC FINGER MATRIN-TYPE PROTEIN 3', NULL, NULL, NULL, 8),
(245994, NULL, 'PTHR47605', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ELONGATION REGULATOR MINIYO', NULL, NULL, NULL, 8),
(245995, NULL, 'PTHR10697', NULL, NULL, NULL, NULL, 'MAMMALIAN EPENDYMIN-RELATED PROTEIN 1', NULL, NULL, 571, 8),
(245996, NULL, 'PTHR48075', NULL, NULL, NULL, NULL, '3-HYDROXYACYL-COA DEHYDROGENASE FAMILY PROTEIN', NULL, NULL, NULL, 8),
(245997, NULL, 'PTHR36353', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(245998, NULL, 'PTHR15678', NULL, NULL, NULL, NULL, 'ANTIGEN MLAA-22-RELATED', NULL, NULL, 34180, 8),
(245999, NULL, 'PTHR36331', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN', NULL, NULL, NULL, 8),
(246000, NULL, 'PTHR16489', NULL, NULL, NULL, NULL, 'GH11727P', NULL, NULL, NULL, 8),
(246001, NULL, 'PTHR43280', NULL, NULL, NULL, NULL, 'ARAC-FAMILY TRANSCRIPTIONAL REGULATOR', NULL, NULL, NULL, 8),
(246002, NULL, 'PTHR43211', NULL, NULL, NULL, NULL, 'FUMARYLACETOACETATE HYDROLASE', NULL, NULL, NULL, 8),
(246003, NULL, 'PTHR43671', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NEK', NULL, NULL, NULL, 8),
(246004, NULL, 'PTHR46660', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246005, NULL, 'PTHR46763', NULL, NULL, NULL, NULL, 'DYNEIN REGULATORY COMPLEX PROTEIN 8', NULL, NULL, NULL, 8),
(246006, NULL, 'PTHR47724', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP26-2, CHLOROPLASTIC', NULL, NULL, 34567, 8);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(246007, NULL, 'PTHR10024', NULL, NULL, NULL, NULL, 'SYNAPTOTAGMIN', NULL, NULL, NULL, 8),
(246008, NULL, 'PTHR34589', NULL, NULL, NULL, NULL, 'SIMILAR TO RIKEN CDNA 2700081O15', NULL, NULL, NULL, 8),
(246009, NULL, 'PTHR22534', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(246010, NULL, 'PTHR10891', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(246011, NULL, 'PTHR43180', NULL, NULL, NULL, NULL, '3-OXOACYL-(ACYL-CARRIER-PROTEIN) REDUCTASE (AFU_ORTHOLOGUE AFUA_6G11210)', NULL, NULL, NULL, 8),
(246012, NULL, 'PTHR20933', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 33', NULL, NULL, 32248, 8),
(246013, NULL, 'PTHR39456', NULL, NULL, NULL, NULL, '', NULL, NULL, 16201, 8),
(246014, NULL, 'PTHR46243', NULL, NULL, NULL, NULL, 'BIS(5''-ADENOSYL)-TRIPHOSPHATASE', NULL, NULL, NULL, 8),
(246015, NULL, 'PTHR10170', NULL, NULL, NULL, NULL, 'HUNTINGTON DISEASE PROTEIN', NULL, NULL, 25530, 8),
(246016, NULL, 'PTHR28681', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 196', NULL, NULL, 32554, 8),
(246017, NULL, 'PTHR24192', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN 40', NULL, NULL, 32633, 8),
(246018, NULL, 'PTHR10328', NULL, NULL, NULL, NULL, 'PROTEIN MAX  MYC-ASSOCIATED FACTOR X', NULL, NULL, 33257, 8),
(246019, NULL, 'PTHR31312', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ACTIVATOR GLK1', NULL, NULL, 35329, 8),
(246020, NULL, 'PTHR15029', NULL, NULL, NULL, NULL, 'CAMPATH-1 ANTIGEN', NULL, NULL, 23974, 8),
(246021, NULL, 'PTHR45711', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN', NULL, NULL, NULL, 8),
(246022, NULL, 'PTHR20838', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 86', NULL, NULL, 32453, 8),
(246023, NULL, 'PTHR11610', NULL, NULL, NULL, NULL, 'LIPASE', NULL, NULL, 3924, 8),
(246024, NULL, 'PTHR46878', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN M1', NULL, NULL, 35222, 8),
(246025, NULL, 'PTHR11609', NULL, NULL, NULL, NULL, 'PURINE BIOSYNTHESIS PROTEIN 6/7, PUR6/7', NULL, NULL, NULL, 8),
(246026, NULL, 'PTHR15995', NULL, NULL, NULL, NULL, 'PROTEIN ZWILCH HOMOLOG', NULL, NULL, 16020, 8),
(246027, NULL, 'PTHR47183', NULL, NULL, NULL, NULL, 'GLUCOSE-1-PHOSPHATE CYTIDYLYLTRANSFERASE-RELATED', NULL, NULL, NULL, 8),
(246028, NULL, 'PTHR12930', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 183', NULL, NULL, 28640, 8),
(246029, NULL, 'PTHR47472', NULL, NULL, NULL, NULL, 'PROPIONYL-COA CARBOXYLASE', NULL, NULL, NULL, 8),
(246030, NULL, 'PTHR47420', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE ASHR2', NULL, NULL, 34992, 8),
(246031, NULL, 'PTHR45757', NULL, NULL, NULL, NULL, 'PROTEIN CBG23364-RELATED', NULL, NULL, NULL, 8),
(246032, NULL, 'PTHR28562', NULL, NULL, NULL, NULL, 'COP9 SIGNALOSOME COMPLEX SUBUNIT 9', NULL, NULL, 23160, 8),
(246033, NULL, 'PTHR39342', NULL, NULL, NULL, NULL, 'UPF0283 MEMBRANE PROTEIN YCJF', NULL, NULL, 7354, 8),
(246034, NULL, 'PTHR46204', NULL, NULL, NULL, NULL, 'CHITIN ELICITOR RECEPTOR KINASE 1-RELATED', NULL, NULL, 34933, 8),
(246035, NULL, 'PTHR10602', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 2 SUBUNIT 1', NULL, NULL, 12620, 8),
(246036, NULL, 'PTHR34145', NULL, NULL, NULL, NULL, 'OS02G0105600 PROTEIN', NULL, NULL, NULL, 8),
(246037, NULL, 'PTHR43122', NULL, NULL, NULL, NULL, 'FERREDOXIN SUBUNIT OF PYRUVATE:FLAVODOXIN OXIDOREDUCTASE-RELATED', NULL, NULL, NULL, 8),
(246038, NULL, 'PTHR45011', NULL, NULL, NULL, NULL, 'DAP3-BINDING CELL DEATH ENHANCER 1', NULL, NULL, NULL, 8),
(246039, NULL, 'PTHR21777', NULL, NULL, NULL, NULL, 'RCG55159-LIKE', NULL, NULL, 25782, 8),
(246040, NULL, 'PTHR47631', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS E (EPSILON)-RELATED', NULL, NULL, NULL, 8),
(246041, NULL, 'PTHR40430', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246042, NULL, 'PTHR21290', NULL, NULL, NULL, NULL, 'SPHINGOMYELIN SYNTHETASE', NULL, NULL, 36479, 8),
(246043, NULL, 'PTHR14381', NULL, NULL, NULL, NULL, 'DACTYLIN', NULL, NULL, NULL, 8),
(246044, NULL, 'PTHR24255', NULL, NULL, NULL, NULL, 'COMPLEMENT COMPONENT 1, S SUBCOMPONENT-RELATED', NULL, NULL, NULL, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(246045, NULL, 'PTHR48161', NULL, NULL, NULL, NULL, 'BNACNNG12870D PROTEIN', NULL, NULL, NULL, 8),
(246046, NULL, 'PTHR43505', NULL, NULL, NULL, NULL, 'REVERSE GYRASE', NULL, NULL, 4786, 8),
(246047, NULL, 'PTHR14952', NULL, NULL, NULL, NULL, 'ROPPORIN-1-LIKE PROTEIN', NULL, NULL, NULL, 8),
(246048, NULL, 'PTHR46704', NULL, NULL, NULL, NULL, 'CXC DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(246049, NULL, 'PTHR31529', NULL, NULL, NULL, NULL, 'LOB DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(246050, NULL, 'PTHR12818', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 27515, 8),
(246051, NULL, 'PTHR46006', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR AT 64C, ISOFORM A', NULL, NULL, NULL, 8),
(246052, NULL, 'PTHR36153', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(246053, NULL, 'PTHR15428', NULL, NULL, NULL, NULL, 'ENDOTHELIAL CELL-SPECIFIC MOLECULE 1  ESM-1', NULL, NULL, 32706, 8),
(246054, NULL, 'PTHR39267', NULL, NULL, NULL, NULL, 'SURVIVAL MOTOR NEURON-LIKE PROTEIN 1', NULL, NULL, NULL, 8),
(246055, NULL, 'PTHR30523', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYLASE', NULL, NULL, 15264, 8),
(246056, NULL, 'PTHR32086', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA GROUP D2 PROTEIN', NULL, NULL, 25524, 8),
(246057, NULL, 'PTHR24228', NULL, NULL, NULL, NULL, 'B2 BRADYKININ RECEPTOR/ANGIOTENSIN II RECEPTOR', NULL, NULL, NULL, 8),
(246058, NULL, 'PTHR34924', NULL, NULL, NULL, NULL, 'UPF0573 PROTEIN C2ORF70', NULL, NULL, NULL, 8),
(246059, NULL, 'PTHR34066', NULL, NULL, NULL, NULL, 'GROWTH FACTOR 2', NULL, NULL, 17762, 8),
(246060, NULL, 'PTHR13497', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE COMPLEX SUBUNIT SAP130', NULL, NULL, 9886, 8),
(246061, NULL, 'PTHR24637', NULL, NULL, NULL, NULL, 'COLLAGEN', NULL, NULL, NULL, 8),
(246062, NULL, 'PTHR41752', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246063, NULL, 'PTHR14330', NULL, NULL, NULL, NULL, 'A-KINASE-INTERACTING PROTEIN 1', NULL, NULL, 29138, 8),
(246064, NULL, 'PTHR14237', NULL, NULL, NULL, NULL, 'MOLYBDOPTERIN COFACTOR SULFURASE  MOSC', NULL, NULL, NULL, 8),
(246065, NULL, 'PTHR47551', NULL, NULL, NULL, NULL, 'TUBULIN--TYROSINE LIGASE PBY1-RELATED', NULL, NULL, 24534, 8),
(246066, NULL, 'PTHR46143', NULL, NULL, NULL, NULL, 'CALPAIN-7', NULL, NULL, NULL, 8),
(246067, NULL, 'PTHR35313', NULL, NULL, NULL, NULL, 'NO EXINE FORMATION 1', NULL, NULL, NULL, 8),
(246068, NULL, 'PTHR24032', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN-RELATED-RELATED', NULL, NULL, NULL, 8),
(246069, NULL, 'PTHR46022', NULL, NULL, NULL, NULL, 'PROTEIN PATCHED', NULL, NULL, NULL, 8),
(246070, NULL, 'PTHR22881', NULL, NULL, NULL, NULL, 'BROMODOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(246071, NULL, 'PTHR23200', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 33059, 8),
(246072, NULL, 'PTHR23071', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL GLYCAN', NULL, NULL, 27096, 8),
(246073, NULL, 'PTHR10061', NULL, NULL, NULL, NULL, 'S-FORMYLGLUTATHIONE HYDROLASE', NULL, NULL, 8761, 8),
(246074, NULL, 'PTHR34413', NULL, NULL, NULL, NULL, 'PROPHAGE TAIL FIBER ASSEMBLY PROTEIN HOMOLOG TFAE-RELATED-RELATED', NULL, NULL, NULL, 8),
(246075, NULL, 'PTHR10751', NULL, NULL, NULL, NULL, 'GUANYLATE BINDING PROTEIN', NULL, NULL, NULL, 8),
(246076, NULL, 'PTHR12890', NULL, NULL, NULL, NULL, 'DREV PROTEIN', NULL, NULL, 3479, 8),
(246077, NULL, 'PTHR13078', NULL, NULL, NULL, NULL, 'PEROXISOMAL MULTIFUNCTIONAL ENZYME TYPE 2-RELATED', NULL, NULL, NULL, 8),
(246078, NULL, 'PTHR36930', NULL, NULL, NULL, NULL, 'METAL-SULFUR CLUSTER BIOSYNTHESIS PROTEINS YUAD-RELATED', NULL, NULL, NULL, 8),
(246079, NULL, 'PTHR40642', NULL, NULL, NULL, NULL, 'YALI0F31295P', NULL, NULL, 24702, 8),
(246080, NULL, 'PTHR22799', NULL, NULL, NULL, NULL, 'TETRANECTIN-RELATED', NULL, NULL, NULL, 8),
(246081, NULL, 'PTHR35841', NULL, NULL, NULL, NULL, 'PHOSPHONATES-BINDING PERIPLASMIC PROTEIN', NULL, NULL, NULL, 8),
(246082, NULL, 'PTHR48021', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246083, NULL, 'PTHR13924', NULL, NULL, NULL, NULL, 'TRANSFORMING ACIDIC COILED-COIL CONTAINING PROTEIN 1/2', NULL, NULL, 32077, 8);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(246084, NULL, 'PTHR32141', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246085, NULL, 'PTHR46820', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SETD7', NULL, NULL, NULL, 8),
(246086, NULL, 'PTHR13621', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN PRCC', NULL, NULL, 19054, 8),
(246087, NULL, 'PTHR44591', NULL, NULL, NULL, NULL, 'STRESS RESPONSE REGULATOR PROTEIN 1', NULL, NULL, NULL, 8),
(246088, NULL, 'PTHR35005', NULL, NULL, NULL, NULL, '3-DEHYDRO-SCYLLO-INOSOSE HYDROLASE', NULL, NULL, 3155, 8),
(246089, NULL, 'PTHR43366', NULL, NULL, NULL, NULL, 'PYRUVATE SYNTHASE SUBUNIT PORC', NULL, NULL, NULL, 8),
(246090, NULL, 'PTHR45046', NULL, NULL, NULL, NULL, 'V-SET AND IMMUNOGLOBULIN DOMAIN-CONTAINING PROTEIN 2', NULL, NULL, 34327, 8),
(246091, NULL, 'PTHR28588', NULL, NULL, NULL, NULL, 'HAUS AUGMIN-LIKE COMPLEX SUBUNIT 5', NULL, NULL, NULL, 8),
(246092, NULL, 'PTHR24179', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 12', NULL, NULL, NULL, 8),
(246093, NULL, 'PTHR19353', NULL, NULL, NULL, NULL, 'FATTY ACID DESATURASE 2', NULL, NULL, 7200, 8),
(246094, NULL, 'PTHR45849', NULL, NULL, NULL, NULL, 'FACT COMPLEX SUBUNIT SSRP1', NULL, NULL, NULL, 8),
(246095, NULL, 'PTHR37849', NULL, NULL, NULL, NULL, 'YALI0E11605P', NULL, NULL, NULL, 8),
(246096, NULL, 'PTHR43787', NULL, NULL, NULL, NULL, 'FEMO COFACTOR BIOSYNTHESIS PROTEIN NIFB-RELATED', NULL, NULL, NULL, 8),
(246097, NULL, 'PTHR28259', NULL, NULL, NULL, NULL, 'FLUORIDE EXPORT PROTEIN 1-RELATED', NULL, NULL, 1540, 8),
(246098, NULL, 'PTHR12042', NULL, NULL, NULL, NULL, 'LACTOSYLCERAMIDE 4-ALPHA-GALACTOSYLTRANSFERASE  ALPHA- 1,4-GALACTOSYLTRANSFERASE', NULL, NULL, NULL, 8),
(246099, NULL, 'PTHR15222', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 BETA SUBCOMPLEX SUBUNIT 1', NULL, NULL, 9283, 8),
(246100, NULL, 'PTHR15336', NULL, NULL, NULL, NULL, 'UBIQUINOL-CYTOCHROME C REDUCTASE COMPLEX 7.8 KDA PROTEIN', NULL, NULL, 5437, 8),
(246101, NULL, 'PTHR35278', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(246102, NULL, 'PTHR38095', NULL, NULL, NULL, NULL, 'ANAEROBIC DIMETHYL SULFOXIDE REDUCTASE CHAIN YNFH', NULL, NULL, 6854, 8),
(246103, NULL, 'PTHR13276', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE EXCHANGE FACTOR MSS4', NULL, NULL, 10774, 8),
(246104, NULL, 'PTHR37341', NULL, NULL, NULL, NULL, 'PROTEIN INCA1', NULL, NULL, 24850, 8),
(246105, NULL, 'PTHR36471', NULL, NULL, NULL, NULL, 'SMALL MEMBRANE A-KINASE ANCHOR PROTEIN', NULL, NULL, 24029, 8),
(246106, NULL, 'PTHR46600', NULL, NULL, NULL, NULL, 'THAP DOMAIN-CONTAINING', NULL, NULL, 23331, 8),
(246107, NULL, 'PTHR10780', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CARRIER HOMOLOG', NULL, NULL, NULL, 8),
(246108, NULL, 'PTHR36924', NULL, NULL, NULL, NULL, 'ANTITOXIN HIGA-1', NULL, NULL, 9106, 8),
(246109, NULL, 'PTHR48316', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246110, NULL, 'PTHR36382', NULL, NULL, NULL, NULL, 'OSJNBA0043L09.26 PROTEIN', NULL, NULL, NULL, 8),
(246111, NULL, 'PTHR19370', NULL, NULL, NULL, NULL, 'NADH-CYTOCHROME B5 REDUCTASE', NULL, NULL, 4310, 8),
(246112, NULL, 'PTHR47791', NULL, NULL, NULL, NULL, 'MEIOTICALLY UP-REGULATED GENE 191 PROTEIN', NULL, NULL, NULL, 8),
(246113, NULL, 'PTHR40260', NULL, NULL, NULL, NULL, 'BLR8190 PROTEIN', NULL, NULL, NULL, 8),
(246114, NULL, 'PTHR10057', NULL, NULL, NULL, NULL, 'PERIPHERAL-TYPE BENZODIAZEPINE RECEPTOR', NULL, NULL, 4649, 8),
(246115, NULL, 'PTHR28675', NULL, NULL, NULL, NULL, 'MELANOCORTIN-2 RECEPTOR ACCESSORY PROTEIN 2', NULL, NULL, 23114, 8),
(246116, NULL, 'PTHR13759', NULL, NULL, NULL, NULL, 'TWINFILIN', NULL, NULL, 25545, 8),
(246117, NULL, 'PTHR46296', NULL, NULL, NULL, NULL, 'BNAA05G37250D PROTEIN', NULL, NULL, 34293, 8),
(246118, NULL, 'PTHR11647', NULL, NULL, NULL, NULL, 'HYDRANTOINASE/DIHYDROPYRIMIDINASE FAMILY MEMBER', NULL, NULL, NULL, 8),
(246119, NULL, 'PTHR30458', NULL, NULL, NULL, NULL, 'PHENYLACETIC ACID DEGRADATION PROTEIN PAA', NULL, NULL, NULL, 8),
(246120, NULL, 'PTHR21351', NULL, NULL, NULL, NULL, 'BARDET-BIEDL SYNDROME PROTEIN 5', NULL, NULL, 1164, 8);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(246121, NULL, 'PTHR46097', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR KINASE INTERACTING ARFGAP', NULL, NULL, NULL, 8),
(246122, NULL, 'PTHR35096', NULL, NULL, NULL, NULL, 'BNAA08G28570D PROTEIN', NULL, NULL, NULL, 8),
(246123, NULL, 'PTHR33351', NULL, NULL, NULL, NULL, 'HISACTOPHILIN-1-RELATED', NULL, NULL, NULL, 8),
(246124, NULL, 'PTHR21284', NULL, NULL, NULL, NULL, 'EG:80H7.2 PROTEIN', NULL, NULL, NULL, 8),
(246125, NULL, 'PTHR32226', NULL, NULL, NULL, NULL, 'TELO2-INTERACTING PROTEIN 2', NULL, NULL, 20925, 8),
(246126, NULL, 'PTHR36365', NULL, NULL, NULL, NULL, 'OS05G0500400 PROTEIN', NULL, NULL, NULL, 8),
(246127, NULL, 'PTHR36332', NULL, NULL, NULL, NULL, 'STRESS RESPONSE PROTEIN', NULL, NULL, NULL, 8),
(246128, NULL, 'PTHR40738', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246129, NULL, 'PTHR18875', NULL, NULL, NULL, NULL, 'SARCOMA ANTIGEN NY-SAR-24/CYTOSKELETAL PROTEIN SOJO', NULL, NULL, NULL, 8),
(246130, NULL, 'PTHR41251', NULL, NULL, NULL, NULL, 'NON-HOMOLOGOUS END JOINING PROTEIN KU', NULL, NULL, 9701, 8),
(246131, NULL, 'PTHR33743', NULL, NULL, NULL, NULL, 'PROTEIN GOLVEN 6-RELATED', NULL, NULL, NULL, 8),
(246132, NULL, 'PTHR46123', NULL, NULL, NULL, NULL, 'MIX-TYPE HOMEOBOX GENE 1-RELATED', NULL, NULL, NULL, 8),
(246133, NULL, 'PTHR13287', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 22016, 8),
(246134, NULL, 'PTHR34715', NULL, NULL, NULL, NULL, 'KINASE, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(246135, NULL, 'PTHR11177', NULL, NULL, NULL, NULL, 'CHITINASE', NULL, NULL, NULL, 8),
(246136, NULL, 'PTHR37574', NULL, NULL, NULL, NULL, 'LIPASE B', NULL, NULL, NULL, 8),
(246137, NULL, 'PTHR10358', NULL, NULL, NULL, NULL, 'ENDOSULFINE', NULL, NULL, 3229, 8),
(246138, NULL, 'PTHR37226', NULL, NULL, NULL, NULL, 'GOLGIN FAMILY A PROTEIN', NULL, NULL, NULL, 8),
(246139, NULL, 'PTHR45023', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246140, NULL, 'PTHR38045', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(246141, NULL, 'PTHR47540', NULL, NULL, NULL, NULL, 'THIAMINE REPRESSIBLE GENES REGULATORY PROTEIN THI5', NULL, NULL, NULL, 8),
(246142, NULL, 'PTHR47122', NULL, NULL, NULL, NULL, 'MYB-LIKE DNA-BINDING DOMAIN CONTAINING PROTEIN, EXPRESSED', NULL, NULL, NULL, 8),
(246143, NULL, 'PTHR45799', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN', NULL, NULL, NULL, 8),
(246144, NULL, 'PTHR42831', NULL, NULL, NULL, NULL, 'FE-S PROTEIN MATURATION AUXILIARY FACTOR YITW', NULL, NULL, NULL, 8),
(246145, NULL, 'PTHR47670', NULL, NULL, NULL, NULL, 'ADENYLYLSULFATASE HINT3', NULL, NULL, NULL, 8),
(246146, NULL, 'PTHR16027', NULL, NULL, NULL, NULL, 'DILUTE DOMAIN-CONTAINING PROTEIN YPR089W', NULL, NULL, NULL, 8),
(246147, NULL, 'PTHR24014', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE AND IRON-DEPENDENT OXYGENASE DOMAIN-CONTAINING PROTEIN 2', NULL, NULL, NULL, 8),
(246148, NULL, 'PTHR34701', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR MRAZ', NULL, NULL, 5375, 8),
(246149, NULL, 'PTHR24034', NULL, NULL, NULL, NULL, 'EGF-LIKE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(246150, NULL, 'PTHR35091', NULL, NULL, NULL, NULL, 'FLAGELLAR PROTEIN FLIL', NULL, NULL, 659, 8),
(246151, NULL, 'PTHR11265', NULL, NULL, NULL, NULL, 'S-ADENOSYL-METHYLTRANSFERASE MRAW', NULL, NULL, 6127, 8),
(246152, NULL, 'PTHR20437', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUBFAMILY MEMBER 13/17', NULL, NULL, 34821, 8),
(246153, NULL, 'PTHR38662', NULL, NULL, NULL, NULL, '', NULL, NULL, 6373, 8),
(246154, NULL, 'PTHR21310', NULL, NULL, NULL, NULL, 'AMINOGLYCOSIDE PHOSPHOTRANSFERASE-RELATED-RELATED', NULL, NULL, NULL, 8),
(246155, NULL, 'PTHR43339', NULL, NULL, NULL, NULL, 'RUBRERYTHRIN-RELATED', NULL, NULL, NULL, 8),
(246156, NULL, 'PTHR45899', NULL, NULL, NULL, NULL, 'RHO GTPASE ACTIVATING PROTEIN AT 15B, ISOFORM C', NULL, NULL, NULL, 8),
(246157, NULL, 'PTHR33566', NULL, NULL, NULL, NULL, 'EN/SPM-LIKE TRANSPOSON-RELATED', NULL, NULL, NULL, 8),
(246158, NULL, 'PTHR43626', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASE', NULL, NULL, 34903, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(246159, NULL, 'PTHR43637', NULL, NULL, NULL, NULL, 'UPF0273 PROTEIN TM_0370', NULL, NULL, NULL, 8),
(246160, NULL, 'PTHR46441', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EPIDIDYMAL FAMILY MEMBER 3', NULL, NULL, NULL, 8),
(246161, NULL, 'PTHR35756', NULL, NULL, NULL, NULL, 'OS05G0337400 PROTEIN', NULL, NULL, NULL, 8),
(246162, NULL, 'PTHR43342', NULL, NULL, NULL, NULL, 'NADH-QUINONE OXIDOREDUCTASE, E SUBUNIT', NULL, NULL, NULL, 8),
(246163, NULL, 'PTHR24038', NULL, NULL, NULL, NULL, 'STABILIN', NULL, NULL, NULL, 8),
(246164, NULL, 'PTHR15819', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN FAM155', NULL, NULL, NULL, 8),
(246165, NULL, 'PTHR45864', NULL, NULL, NULL, NULL, 'SLINGSHOT PROTEIN PHOSPHATASE HOMOLOG', NULL, NULL, 35249, 8),
(246166, NULL, 'PTHR23233', NULL, NULL, NULL, NULL, 'SAL-LIKE PROTEIN', NULL, NULL, NULL, 8),
(246167, NULL, 'PTHR21107', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY PROTEIN COX19', NULL, NULL, NULL, 8),
(246168, NULL, 'PTHR44899', NULL, NULL, NULL, NULL, 'CAMK FAMILY PROTEIN KINASE', NULL, NULL, NULL, 8),
(246169, NULL, 'PTHR46706', NULL, NULL, NULL, NULL, 'PROTEIN QUA-1-RELATED', NULL, NULL, NULL, 8),
(246170, NULL, 'PTHR15672', NULL, NULL, NULL, NULL, 'CAMP-REGULATED PHOSPHOPROTEIN 21 RELATED R3H DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(246171, NULL, 'PTHR10837', NULL, NULL, NULL, NULL, 'PEPTIDYLARGININE DEIMINASE', NULL, NULL, 4814, 8),
(246172, NULL, 'PTHR15048', NULL, NULL, NULL, NULL, 'STARCH-BINDING DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(246173, NULL, 'PTHR34783', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 144-RELATED', NULL, NULL, NULL, 8),
(246174, NULL, 'PTHR42681', NULL, NULL, NULL, NULL, 'MALONYL-COA-ACYL CARRIER PROTEIN TRANSACYLASE, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(246175, NULL, 'PTHR38758', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(246176, NULL, 'PTHR34761', NULL, NULL, NULL, NULL, 'NUCLEOLUS AND NEURAL PROGENITOR PROTEIN', NULL, NULL, NULL, 8),
(246177, NULL, 'PTHR34049', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SKIP27', NULL, NULL, 35836, 8),
(246178, NULL, 'PTHR43243', NULL, NULL, NULL, NULL, 'INNER MEMBRANE TRANSPORTER YGJI-RELATED', NULL, NULL, NULL, 8),
(246179, NULL, 'PTHR41302', NULL, NULL, NULL, NULL, 'PRESPORE-SPECIFIC TRANSCRIPTIONAL REGULATOR RSFA-RELATED', NULL, NULL, 10544, 8),
(246180, NULL, 'PTHR22975', NULL, NULL, NULL, NULL, 'UBIQUITIN SPECIFIC PROTEINASE', NULL, NULL, NULL, 8),
(246181, NULL, 'PTHR33110', NULL, NULL, NULL, NULL, 'F-BOX/KELCH-REPEAT PROTEIN-RELATED', NULL, NULL, NULL, 8),
(246182, NULL, 'PTHR35565', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', NULL, NULL, 7871, 8),
(246183, NULL, 'PTHR10276', NULL, NULL, NULL, NULL, 'CORE-BINDING FACTOR, BETA SUBUNIT', NULL, NULL, 5167, 8),
(246184, NULL, 'PTHR43326', NULL, NULL, NULL, NULL, 'METHIONYL-TRNA SYNTHETASE', NULL, NULL, 16271, 8),
(246185, NULL, 'PTHR12504', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM22', NULL, NULL, 3708, 8),
(246186, NULL, 'PTHR11046', NULL, NULL, NULL, NULL, 'OLIGORIBONUCLEASE, MITOCHONDRIAL', NULL, NULL, 17386, 8),
(246187, NULL, 'PTHR13568', NULL, NULL, NULL, NULL, 'FAM11A, B PROTEIN', NULL, NULL, 16810, 8),
(246188, NULL, 'PTHR22896', NULL, NULL, NULL, NULL, 'CDK5 AND ABL1 ENZYME SUBSTRATE 1', NULL, NULL, 13391, 8),
(246189, NULL, 'PTHR47764', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE-SPECIFIC PROTEASE 2B-RELATED', NULL, NULL, NULL, 8),
(246190, NULL, 'PTHR31814', NULL, NULL, NULL, NULL, '', NULL, NULL, 20867, 8),
(246191, NULL, 'PTHR47715', NULL, NULL, NULL, NULL, 'TRYPTOPHAN/TYROSINE PERMEASE', NULL, NULL, NULL, 8),
(246192, NULL, 'PTHR23099', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR', NULL, NULL, NULL, 8),
(246193, NULL, 'PTHR30199', NULL, NULL, NULL, NULL, 'MFS FAMILY TRANSPORTER, PREDICTED SUBSTRATE BENZOATE', NULL, NULL, 3429, 8),
(246194, NULL, 'PTHR13802', NULL, NULL, NULL, NULL, 'MUCIN 4-RELATED', NULL, NULL, NULL, 8),
(246195, NULL, 'PTHR36031', NULL, NULL, NULL, NULL, 'F21O3.15 PROTEIN', NULL, NULL, NULL, 8),
(246196, NULL, 'PTHR38223', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(246197, NULL, 'PTHR46064', NULL, NULL, NULL, NULL, 'QUEUINE TRNA-RIBOSYLTRANSFERASE ACCESSORY SUBUNIT 2', NULL, NULL, NULL, 8),
(246198, NULL, 'PTHR28592', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(246199, NULL, 'PTHR12265', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 13437, 8),
(246200, NULL, 'PTHR46104', NULL, NULL, NULL, NULL, 'GENE 9195-RELATED-RELATED', NULL, NULL, NULL, 8),
(246201, NULL, 'PTHR43346', NULL, NULL, NULL, NULL, 'LIGAND BINDING DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G14370)-RELATED', NULL, NULL, NULL, 8),
(246202, NULL, 'PTHR43004', NULL, NULL, NULL, NULL, 'TRK SYSTEM POTASSIUM UPTAKE PROTEIN', NULL, NULL, NULL, 8),
(246203, NULL, 'PTHR36496', NULL, NULL, NULL, NULL, 'CADHERIN DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(246204, NULL, 'PTHR39183', NULL, NULL, NULL, NULL, 'SPORE COAT PROTEIN F-LIKE PROTEIN YHCQ', NULL, NULL, 12103, 8),
(246205, NULL, 'PTHR37181', NULL, NULL, NULL, NULL, 'F6A14.6 PROTEIN', NULL, NULL, NULL, 8),
(246206, NULL, 'PTHR21050', NULL, NULL, NULL, NULL, 'MIDKINE AND PLEIOTROPHIN 1, ISOFORM A-RELATED', NULL, NULL, NULL, 8),
(246207, NULL, 'PTHR28595', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L54, MITOCHONDRIAL', NULL, NULL, 9804, 8),
(246208, NULL, 'PTHR47503', NULL, NULL, NULL, NULL, 'PURKINJE CELL PROTEIN 2', NULL, NULL, 37218, 8),
(246209, NULL, 'PTHR45992', NULL, NULL, NULL, NULL, 'EUKARYOTIC ELONGATION FACTOR 2 KINASE-RELATED', NULL, NULL, NULL, 8),
(246210, NULL, 'PTHR12311', NULL, NULL, NULL, NULL, 'ACTIVATOR OF BASAL TRANSCRIPTION 1', NULL, NULL, 32899, 8),
(246211, NULL, 'PTHR46246', NULL, NULL, NULL, NULL, 'GUANOSINE-3'',5''-BIS(DIPHOSPHATE) 3''-PYROPHOSPHOHYDROLASE MESH1', NULL, NULL, NULL, 8),
(246212, NULL, 'PTHR19871', NULL, NULL, NULL, NULL, 'BETA TRANSDUCIN-RELATED PROTEIN', NULL, NULL, NULL, 8),
(246213, NULL, 'PTHR48186', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(246214, NULL, 'PTHR40047', NULL, NULL, NULL, NULL, 'UPF0703 PROTEIN YCGQ', NULL, NULL, 14075, 8),
(246215, NULL, 'PTHR10985', NULL, NULL, NULL, NULL, 'BASIC HELIX-LOOP-HELIX TRANSCRIPTION FACTOR, HES-RELATED', NULL, NULL, NULL, 8),
(246216, NULL, 'PTHR40644', NULL, NULL, NULL, NULL, 'UPF0653 PROTEIN C607.02C', NULL, NULL, 32238, 8),
(246217, NULL, 'PTHR31208', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(246218, NULL, 'PTHR22801', NULL, NULL, NULL, NULL, 'LITHOSTATHINE', NULL, NULL, NULL, 8),
(246219, NULL, 'PTHR39951', NULL, NULL, NULL, NULL, 'FI22632P1', NULL, NULL, NULL, 8),
(246220, NULL, 'PTHR13445', NULL, NULL, NULL, NULL, 'TUMOR SUPPRESSING SUBTRANSFERABLE CANDIDATE 4 TSSC4', NULL, NULL, 23552, 8),
(246221, NULL, 'PTHR34792', NULL, NULL, NULL, NULL, 'OS02G0121500 PROTEIN', NULL, NULL, 27971, 8),
(246222, NULL, 'PTHR39377', NULL, NULL, NULL, NULL, 'PROTEIN CBG18423-RELATED', NULL, NULL, NULL, 8),
(246223, NULL, 'PTHR36102', NULL, NULL, NULL, NULL, 'CHROMOSOME 10, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, 17866, 8),
(246224, NULL, 'PTHR47114', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246225, NULL, 'PTHR30046', NULL, NULL, NULL, NULL, 'FLAGELLAR M-RING PROTEIN', NULL, NULL, 34367, 8),
(246226, NULL, 'PTHR16212', NULL, NULL, NULL, NULL, 'FOCADHESIN FAMILY MEMBER', NULL, NULL, 36629, 8),
(246227, NULL, 'PTHR33272', NULL, NULL, NULL, NULL, 'PROTEIN CBG22877-RELATED', NULL, NULL, 23222, 8),
(246228, NULL, 'PTHR36943', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(246229, NULL, 'PTHR12577', NULL, NULL, NULL, NULL, 'DACHSHUND', NULL, NULL, NULL, 8),
(246230, NULL, 'PTHR21432', NULL, NULL, NULL, NULL, 'ACETYL-COA HYDROLASE-RELATED', NULL, NULL, 36688, 8),
(246231, NULL, 'PTHR40392', NULL, NULL, NULL, NULL, '2-PHOSPHO-L-LACTATE GUANYLYLTRANSFERASE', NULL, NULL, 5110, 8),
(246232, NULL, 'PTHR47579', NULL, NULL, NULL, NULL, 'COMPLEX 1 LYR PROTEIN', NULL, NULL, NULL, 8),
(246233, NULL, 'PTHR24244', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE S RECEPTOR', NULL, NULL, NULL, 8),
(246234, NULL, 'PTHR47704', NULL, NULL, NULL, NULL, 'POTASSIUM TRANSPORTER KIMA', NULL, NULL, NULL, 8);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(246235, NULL, 'PTHR35737', NULL, NULL, NULL, NULL, 'CRYPTIC LOCI REGULATOR', NULL, NULL, NULL, 8),
(246236, NULL, 'PTHR21058', NULL, NULL, NULL, NULL, '6,7-DIMETHYL-8-RIBITYLLUMAZINE SYNTHASE  DMRL SYNTHASE   LUMAZINE SYNTHASE', NULL, NULL, 14502, 8),
(246237, NULL, 'PTHR46067', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASES (NAT) SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(246238, NULL, 'PTHR46822', NULL, NULL, NULL, NULL, 'COILED-COIL ALPHA-HELICAL ROD PROTEIN 1', NULL, NULL, 13415, 8),
(246239, NULL, 'PTHR31257', NULL, NULL, NULL, NULL, 'RICIN B-LIKE LECTIN EULS3', NULL, NULL, 31575, 8),
(246240, NULL, 'PTHR35795', NULL, NULL, NULL, NULL, 'SLR1885 PROTEIN', NULL, NULL, NULL, 8),
(246241, NULL, 'PTHR15201', NULL, NULL, NULL, NULL, 'CRSP70', NULL, NULL, 37562, 8),
(246242, NULL, 'PTHR31475', NULL, NULL, NULL, NULL, 'UPF0462 PROTEIN', NULL, NULL, NULL, 8),
(246243, NULL, 'PTHR36986', NULL, NULL, NULL, NULL, 'UPF0643 PROTEIN PB2B2.08', NULL, NULL, NULL, 8),
(246244, NULL, 'PTHR30168', NULL, NULL, NULL, NULL, 'PUTATIVE MEMBRANE PROTEIN YPFJ', NULL, NULL, 5817, 8),
(246245, NULL, 'PTHR21483', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II-ASSOCIATED PROTEIN 1', NULL, NULL, 27117, 8),
(246246, NULL, 'PTHR21595', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 23561, 8),
(246247, NULL, 'PTHR21503', NULL, NULL, NULL, NULL, 'F-BOX-CONTAINING HYPOTHETICAL PROTEIN  C.ELEGANS', NULL, NULL, NULL, 8),
(246248, NULL, 'PTHR11213', NULL, NULL, NULL, NULL, 'GLUCAGON-FAMILY NEUROPEPTIDE', NULL, NULL, 8430, 8),
(246249, NULL, 'PTHR31102', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246250, NULL, 'PTHR45086', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN PCN', NULL, NULL, 35729, 8),
(246251, NULL, 'PTHR24093', NULL, NULL, NULL, NULL, 'CATION TRANSPORTING ATPASE', NULL, NULL, NULL, 8),
(246252, NULL, 'PTHR33339', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246253, NULL, 'PTHR23530', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN-RELATED', NULL, NULL, NULL, 8),
(246254, NULL, 'PTHR35038', NULL, NULL, NULL, NULL, 'DISSIMILATORY SULFITE REDUCTASE SIRA', NULL, NULL, NULL, 8),
(246255, NULL, 'PTHR46494', NULL, NULL, NULL, NULL, 'CORA FAMILY METAL ION TRANSPORTER (EUROFUNG)', NULL, NULL, NULL, 8),
(246256, NULL, 'PTHR43022', NULL, NULL, NULL, NULL, 'PROTEIN SMF', NULL, NULL, 6413, 8),
(246257, NULL, 'PTHR13456', NULL, NULL, NULL, NULL, 'UPF0729 PROTEIN C18ORF32', NULL, NULL, 25531, 8),
(246258, NULL, 'PTHR46577', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATORY PROTEIN GABR', NULL, NULL, NULL, 8),
(246259, NULL, 'PTHR46988', NULL, NULL, NULL, NULL, 'TWO PORE CALCIUM CHANNEL PROTEIN 1', NULL, NULL, 36326, 8),
(246260, NULL, 'PTHR42023', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246261, NULL, 'PTHR34149', NULL, NULL, NULL, NULL, 'PROTEIN CBG11905-RELATED', NULL, NULL, 14596, 8),
(246262, NULL, 'PTHR43313', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/REDUCTASE FAMILY 9C', NULL, NULL, NULL, 8),
(246263, NULL, 'PTHR33877', NULL, NULL, NULL, NULL, 'SLL1193 PROTEIN', NULL, NULL, NULL, 8),
(246264, NULL, 'PTHR46792', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 80', NULL, NULL, NULL, 8),
(246265, NULL, 'PTHR10252', NULL, NULL, NULL, NULL, 'HISTONE-LIKE TRANSCRIPTION FACTOR CCAAT-RELATED', NULL, NULL, NULL, 8),
(246266, NULL, 'PTHR17613', NULL, NULL, NULL, NULL, 'CEREBRAL PROTEIN-11-RELATED', NULL, NULL, 16943, 8),
(246267, NULL, 'PTHR35836', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246268, NULL, 'PTHR46335', NULL, NULL, NULL, NULL, 'CUBILIN', NULL, NULL, NULL, 8),
(246269, NULL, 'PTHR10130', NULL, NULL, NULL, NULL, 'PEROXISOMAL TARGETING SIGNAL 1 RECEPTOR  PEX5', NULL, NULL, 9783, 8),
(246270, NULL, 'PTHR46051', NULL, NULL, NULL, NULL, 'SH2 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(246271, NULL, 'PTHR15371', NULL, NULL, NULL, NULL, 'TIM23', NULL, NULL, 35826, 8),
(246272, NULL, 'PTHR23040', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 27065, 8),
(246273, NULL, 'PTHR37853', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE FAMILY 92 PROTEIN', NULL, NULL, NULL, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(246274, NULL, 'PTHR11558', NULL, NULL, NULL, NULL, 'SPERMIDINE/SPERMINE SYNTHASE', NULL, NULL, 2335, 8),
(246275, NULL, 'PTHR13994', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE RELATED', NULL, NULL, 3473, 8),
(246276, NULL, 'PTHR11028', NULL, NULL, NULL, NULL, 'VACUOLAR ATP SYNTHASE SUBUNIT AC39', NULL, NULL, 21497, 8),
(246277, NULL, 'PTHR47733', NULL, NULL, NULL, NULL, 'ATAXIN-7 LIKE PROTEIN 3B, ATXN7L3B', NULL, NULL, 36845, 8),
(246278, NULL, 'PTHR30561', NULL, NULL, NULL, NULL, 'SMR FAMILY PROTON-DEPENDENT DRUG EFFLUX TRANSPORTER SUGE', NULL, NULL, 4566, 8),
(246279, NULL, 'PTHR13681', NULL, NULL, NULL, NULL, 'SURVIVAL OF MOTOR NEURON-RELATED-SPLICING FACTOR 30-RELATED', NULL, NULL, NULL, 8),
(246280, NULL, 'PTHR33605', NULL, NULL, NULL, NULL, 'EARLY NODULIN-93', NULL, NULL, 2357, 8),
(246281, NULL, 'PTHR45962', NULL, NULL, NULL, NULL, 'N-FATTY-ACYL-AMINO ACID SYNTHASE/HYDROLASE PM20D1', NULL, NULL, NULL, 8),
(246282, NULL, 'PTHR24184', NULL, NULL, NULL, NULL, 'SI:CH211-189E2.2', NULL, NULL, NULL, 8),
(246283, NULL, 'PTHR24174', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND STERILE ALPHA MOTIF DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(246284, NULL, 'PTHR11603', NULL, NULL, NULL, NULL, 'AAA FAMILY ATPASE', NULL, NULL, NULL, 8),
(246285, NULL, 'PTHR31827', NULL, NULL, NULL, NULL, 'EMB|CAB89363.1', NULL, NULL, NULL, 8),
(246286, NULL, 'PTHR24094', NULL, NULL, NULL, NULL, 'SECRETED PROTEIN', NULL, NULL, NULL, 8),
(246287, NULL, 'PTHR37435', NULL, NULL, NULL, NULL, 'PROTEIN CBG14344', NULL, NULL, NULL, 8),
(246288, NULL, 'PTHR42802', NULL, NULL, NULL, NULL, 'MONOOXYGENASE', NULL, NULL, 21981, 8),
(246289, NULL, 'PTHR31594', NULL, NULL, NULL, NULL, 'AIG1-TYPE G DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(246290, NULL, 'PTHR14431', NULL, NULL, NULL, NULL, 'HCLS1-BINDING PROTEIN 3', NULL, NULL, 31411, 8),
(246291, NULL, 'PTHR33548', NULL, NULL, NULL, NULL, 'GLYCINE-RICH CELL WALL STRUCTURAL PROTEIN 2', NULL, NULL, 28779, 8),
(246292, NULL, 'PTHR23506', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246293, NULL, 'PTHR28019', NULL, NULL, NULL, NULL, 'CELL MEMBRANE PROTEIN YLR413W-RELATED', NULL, NULL, NULL, 8),
(246294, NULL, 'PTHR24046', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDE, CUB AND EGF-LIKE DOMAIN-CONTAINING', NULL, NULL, NULL, 8),
(246295, NULL, 'PTHR47597', NULL, NULL, NULL, NULL, 'IS A MEMBER OF THE PF|00364 BIOTIN-REQUIRING ENZYMES FAMILY-RELATED', NULL, NULL, NULL, 8),
(246296, NULL, 'PTHR37992', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, 14406, 8),
(246297, NULL, 'PTHR16188', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 INHIBITOR POTENTIATED BY PROTEIN KINASE C', NULL, NULL, 5294, 8),
(246298, NULL, 'PTHR12396', NULL, NULL, NULL, NULL, 'METHYL-CPG BINDING PROTEIN, MBD', NULL, NULL, NULL, 8),
(246299, NULL, 'PTHR10063', NULL, NULL, NULL, NULL, 'TUBERIN', NULL, NULL, 24533, 8),
(246300, NULL, 'PTHR23274', NULL, NULL, NULL, NULL, 'DNA HELICASE-RELATED', NULL, NULL, NULL, 8),
(246301, NULL, 'PTHR13902', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE WNK  WITH NO LYSINE -RELATED', NULL, NULL, NULL, 8),
(246302, NULL, 'PTHR35541', NULL, NULL, NULL, NULL, 'RAD9, HUS1, RAD1-INTERACTING NUCLEAR ORPHAN PROTEIN 1', NULL, NULL, 24682, 8),
(246303, NULL, 'PTHR15407', NULL, NULL, NULL, NULL, 'FUKUTIN-RELATED', NULL, NULL, 11213, 8),
(246304, NULL, 'PTHR21409', NULL, NULL, NULL, NULL, 'HEMATOPOIETIC CELL SIGNAL TRANSDUCER', NULL, NULL, 14070, 8),
(246305, NULL, 'PTHR46373', NULL, NULL, NULL, NULL, 'PROTEIN RKD4', NULL, NULL, 36154, 8),
(246306, NULL, 'PTHR15414', NULL, NULL, NULL, NULL, 'OS-9-RELATED', NULL, NULL, 36799, 8),
(246307, NULL, 'PTHR18950', NULL, NULL, NULL, NULL, 'PROGESTERONE-INDUCED BLOCKING FACTOR 1', NULL, NULL, 24722, 8),
(246308, NULL, 'PTHR12883', NULL, NULL, NULL, NULL, 'ADIPOCYTE-SPECIFIC PROTEIN 4-RELATED', NULL, NULL, 13372, 8),
(246309, NULL, 'PTHR35988', NULL, NULL, NULL, NULL, '15-CIS-ZETA-CAROTENE ISOMERASE, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(246310, NULL, 'PTHR31297', NULL, NULL, NULL, NULL, 'GLUCAN ENDO-1,6-BETA-GLUCOSIDASE B', NULL, NULL, NULL, 8);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(246311, NULL, 'PTHR35991', NULL, NULL, NULL, NULL, 'CA-RESPONSIVE PROTEIN', NULL, NULL, NULL, 8),
(246312, NULL, 'PTHR33430', NULL, NULL, NULL, NULL, 'MATERNAL EFFECT EMBRYO ARREST PROTEIN', NULL, NULL, NULL, 8),
(246313, NULL, 'PTHR10496', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S24', NULL, NULL, 2417, 8),
(246314, NULL, 'PTHR46372', NULL, NULL, NULL, NULL, 'PROTEIN WVD2-LIKE 3', NULL, NULL, 34719, 8),
(246315, NULL, 'PTHR31145', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_7G01610)', NULL, NULL, 31891, 8),
(246316, NULL, 'PTHR43995', NULL, NULL, NULL, NULL, 'PRE-MRNA-PROCESSING FACTOR 19', NULL, NULL, 29039, 8),
(246317, NULL, 'PTHR24037', NULL, NULL, NULL, NULL, 'HEART DEVELOPMENT PROTEIN WITH EGF-LIKE DOMAINS 1', NULL, NULL, 22937, 8),
(246318, NULL, 'PTHR17005', NULL, NULL, NULL, NULL, 'MALE-ENHANCED ANTIGEN-1', NULL, NULL, 11940, 8),
(246319, NULL, 'PTHR44830', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1 ALPHA', NULL, NULL, NULL, 8),
(246320, NULL, 'PTHR35719', NULL, NULL, NULL, NULL, 'OS01G0680600 PROTEIN', NULL, NULL, NULL, 8),
(246321, NULL, 'PTHR36927', NULL, NULL, NULL, NULL, 'BLR4337 PROTEIN', NULL, NULL, NULL, 8),
(246322, NULL, 'PTHR11075', NULL, NULL, NULL, NULL, 'PEPTIDE CHAIN RELEASE FACTOR', NULL, NULL, NULL, 8),
(246323, NULL, 'PTHR38764', NULL, NULL, NULL, NULL, 'ACYL CARRIER PROTEIN PHOSPHODIESTERASE', NULL, NULL, 3565, 8),
(246324, NULL, 'PTHR35897', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE AUSD', NULL, NULL, NULL, 8),
(246325, NULL, 'PTHR44666', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 53', NULL, NULL, 33881, 8),
(246326, NULL, 'PTHR28554', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L45, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(246327, NULL, 'PTHR11851', NULL, NULL, NULL, NULL, 'METALLOPROTEASE', NULL, NULL, NULL, 8),
(246328, NULL, 'PTHR43286', NULL, NULL, NULL, NULL, 'ENDONUCLEASE III-LIKE PROTEIN 1', NULL, NULL, NULL, 8),
(246329, NULL, 'PTHR37323', NULL, NULL, NULL, NULL, 'GCN5-RELATED N-ACETYLTRANSFERASE', NULL, NULL, NULL, 8),
(246330, NULL, 'PTHR11699', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE-RELATED', NULL, NULL, NULL, 8),
(246331, NULL, 'PTHR11188', NULL, NULL, NULL, NULL, 'ARRESTIN DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(246332, NULL, 'PTHR32093', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT EXTENSIN-LIKE PROTEIN 3-RELATED', NULL, NULL, NULL, 8),
(246333, NULL, 'PTHR46888', NULL, NULL, NULL, NULL, 'ZINC KNUCKLE DOMAINCONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(246334, NULL, 'PTHR42770', NULL, NULL, NULL, NULL, 'AMINO ACID TRANSPORTER-RELATED', NULL, NULL, NULL, 8),
(246335, NULL, 'PTHR45701', NULL, NULL, NULL, NULL, 'SYNAPTOBREVIN FAMILY MEMBER', NULL, NULL, 15311, 8),
(246336, NULL, 'PTHR20516', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 114/235 FAMILY MEMBER', NULL, NULL, 30095, 8),
(246337, NULL, 'PTHR38460', NULL, NULL, NULL, NULL, 'TAUTOMERASE YOLI-RELATED', NULL, NULL, 33435, 8),
(246338, NULL, 'PTHR45716', NULL, NULL, NULL, NULL, 'BITESIZE, ISOFORM I', NULL, NULL, NULL, 8),
(246339, NULL, 'PTHR46903', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(246340, NULL, 'PTHR34777', NULL, NULL, NULL, NULL, 'VQ MOTIF-CONTAINING PROTEIN 10', NULL, NULL, 27183, 8),
(246341, NULL, 'PTHR34274', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(246342, NULL, 'PTHR37254', NULL, NULL, NULL, NULL, 'OS01G0100500 PROTEIN', NULL, NULL, NULL, 8),
(246343, NULL, 'PTHR14093', NULL, NULL, NULL, NULL, 'HLA CLASS II GAMMA CHAIN', NULL, NULL, NULL, 8),
(246344, NULL, 'PTHR46131', NULL, NULL, NULL, NULL, 'SD08549P', NULL, NULL, NULL, 8),
(246345, NULL, 'PTHR46093', NULL, NULL, NULL, NULL, 'ACYL-COA-BINDING DOMAIN-CONTAINING PROTEIN 5', NULL, NULL, NULL, 8),
(246346, NULL, 'PTHR40730', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR PROTEIN-LIKE PROTEIN', NULL, NULL, NULL, 8),
(246347, NULL, 'PTHR13124', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L46, MITOCHONDRIAL PRECURSOR-RELATED', NULL, NULL, 31764, 8),
(246348, NULL, 'PTHR35011', NULL, NULL, NULL, NULL, '2,3-DIKETO-L-GULONATE TRAP TRANSPORTER SMALL PERMEASE PROTEIN YIAM', NULL, NULL, 6317, 8);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(246349, NULL, 'PTHR31022', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 23983, 8),
(246350, NULL, 'PTHR15856', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN 20-RELATED', NULL, NULL, 33549, 8),
(246351, NULL, 'PTHR35596', NULL, NULL, NULL, NULL, 'DUF2263 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(246352, NULL, 'PTHR45814', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SETD1', NULL, NULL, 36113, 8),
(246353, NULL, 'PTHR47901', NULL, NULL, NULL, NULL, 'CASPASE RECRUITMENT DOMAIN-CONTAINING PROTEIN 18', NULL, NULL, 6115, 8),
(246354, NULL, 'PTHR46310', NULL, NULL, NULL, NULL, 'AMIDASE 1', NULL, NULL, NULL, 8),
(246355, NULL, 'PTHR35705', NULL, NULL, NULL, NULL, 'WPP DOMAIN-INTERACTING TAIL-ANCHORED PROTEIN 1', NULL, NULL, 33556, 8),
(246356, NULL, 'PTHR34235', NULL, NULL, NULL, NULL, 'SLR1203 PROTEIN-RELATED', NULL, NULL, 2721, 8),
(246357, NULL, 'PTHR46429', NULL, NULL, NULL, NULL, '23S RRNA (GUANOSINE-2''-O-)-METHYLTRANSFERASE RLMB', NULL, NULL, 7179, 8),
(246358, NULL, 'PTHR33671', NULL, NULL, NULL, NULL, 'N-METHYLTRANSFERASE, PUTATIVE (DUF688)-RELATED', NULL, NULL, NULL, 8),
(246359, NULL, 'PTHR46312', NULL, NULL, NULL, NULL, 'NACHT DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(246360, NULL, 'PTHR21068', NULL, NULL, NULL, NULL, 'SPARTIN', NULL, NULL, 35564, 8),
(246361, NULL, 'PTHR30352', NULL, NULL, NULL, NULL, 'PYRUVATE FORMATE-LYASE-ACTIVATING ENZYME', NULL, NULL, 30505, 8),
(246362, NULL, 'PTHR47075', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH47', NULL, NULL, NULL, 8),
(246363, NULL, 'PTHR47694', NULL, NULL, NULL, NULL, 'PLANT UBX DOMAIN-CONTAINING PROTEIN 2', NULL, NULL, NULL, 8),
(246364, NULL, 'PTHR30534', NULL, NULL, NULL, NULL, 'FLAGELLAR MOTOR SWITCH PROTEIN FLIG', NULL, NULL, 2510, 8),
(246365, NULL, 'PTHR35903', NULL, NULL, NULL, NULL, 'FLAGELLIN B1', NULL, NULL, 4964, 8),
(246366, NULL, 'PTHR14790', NULL, NULL, NULL, NULL, 'RECQ-MEDIATED GENOME INSTABILITY PROTEIN 1 RMI1', NULL, NULL, NULL, 8),
(246367, NULL, 'PTHR48216', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246368, NULL, 'PTHR46210', NULL, NULL, NULL, NULL, 'FHA DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(246369, NULL, 'PTHR12474', NULL, NULL, NULL, NULL, 'P53 REGULATED PA26 NUCLEAR PROTEIN SESTRIN', NULL, NULL, 2118, 8),
(246370, NULL, 'PTHR31684', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 43', NULL, NULL, 32854, 8),
(246371, NULL, 'PTHR38695', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246372, NULL, 'PTHR14549', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 25076, 8),
(246373, NULL, 'PTHR43484', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246374, NULL, 'PTHR46821', NULL, NULL, NULL, NULL, 'OS07G0586332 PROTEIN', NULL, NULL, 36493, 8),
(246375, NULL, 'PTHR37450', NULL, NULL, NULL, NULL, 'CIPC PROTEIN', NULL, NULL, 21072, 8),
(246376, NULL, 'PTHR46056', NULL, NULL, NULL, NULL, 'LONG-CHAIN-ALCOHOL OXIDASE', NULL, NULL, NULL, 8),
(246377, NULL, 'PTHR36901', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED-RELATED', NULL, NULL, NULL, 8),
(246378, NULL, 'PTHR12197', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SMYD', NULL, NULL, NULL, 8),
(246379, NULL, 'PTHR35566', NULL, NULL, NULL, NULL, 'BLR3599 PROTEIN', NULL, NULL, 7753, 8),
(246380, NULL, 'PTHR16254', NULL, NULL, NULL, NULL, 'POTASSIUM/PROTON ANTIPORTER-RELATED', NULL, NULL, 35973, 8),
(246381, NULL, 'PTHR14297', NULL, NULL, NULL, NULL, 'MEMBRANE TRANSPORT PROTEIN XK FAMILY MEMBER', NULL, NULL, NULL, 8),
(246382, NULL, 'PTHR47717', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP19, CHLOROPLASTIC', NULL, NULL, 34658, 8),
(246383, NULL, 'PTHR36953', NULL, NULL, NULL, NULL, 'PROTEIN CBG07386-RELATED', NULL, NULL, 27511, 8),
(246384, NULL, 'PTHR36762', NULL, NULL, NULL, NULL, 'LIGHT-REGULATED PROTEIN 1, CHLOROPLASTIC', NULL, NULL, 14425, 8),
(246385, NULL, 'PTHR47231', NULL, NULL, NULL, NULL, 'UPF0722 PROTEIN C11ORF88', NULL, NULL, 28251, 8),
(246386, NULL, 'PTHR24293', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 46 SUBFAMILY A', NULL, NULL, 28993, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(246387, NULL, 'PTHR30191', NULL, NULL, NULL, NULL, 'FORMATE ACETYLTRANSFERASE', NULL, NULL, NULL, 8),
(246388, NULL, 'PTHR45564', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT 2 B, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(246389, NULL, 'PTHR10048', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL KINASE', NULL, NULL, 8528, 8),
(246390, NULL, 'PTHR13551', NULL, NULL, NULL, NULL, 'BRAIN PROTEIN I3', NULL, NULL, 14573, 8),
(246391, NULL, 'PTHR45852', NULL, NULL, NULL, NULL, 'SER/THR-PROTEIN KINASE RIO2', NULL, NULL, NULL, 8),
(246392, NULL, 'PTHR47273', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(246393, NULL, 'PTHR14619', NULL, NULL, NULL, NULL, 'NEURON-DERIVED NEUROTROPHIC FACTOR', NULL, NULL, 14918, 8),
(246394, NULL, 'PTHR33129', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(246395, NULL, 'PTHR46634', NULL, NULL, NULL, NULL, 'M REDUCTASE II SUBUNIT GAMMA, PUTATIVE (DUF3741)-RELATED', NULL, NULL, NULL, 8),
(246396, NULL, 'PTHR36933', NULL, NULL, NULL, NULL, 'SLL0788 PROTEIN', NULL, NULL, NULL, 8),
(246397, NULL, 'PTHR12064', NULL, NULL, NULL, NULL, 'METAL TRANSPORTER CNNM', NULL, NULL, 36131, 8),
(246398, NULL, 'PTHR47395', NULL, NULL, NULL, NULL, 'BPI FOLD-CONTAINING FAMILY B MEMBER 1', NULL, NULL, 15353, 8),
(246399, NULL, 'PTHR28141', NULL, NULL, NULL, NULL, '2'',3''-CYCLIC-NUCLEOTIDE 3''-PHOSPHODIESTERASE', NULL, NULL, 13018, 8),
(246400, NULL, 'PTHR42203', NULL, NULL, NULL, NULL, 'UPF0058 PROTEIN MJ1205', NULL, NULL, 3531, 8),
(246401, NULL, 'PTHR24237', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR', NULL, NULL, NULL, 8),
(246402, NULL, 'PTHR12029', NULL, NULL, NULL, NULL, 'RNA METHYLTRANSFERASE', NULL, NULL, 36437, 8),
(246403, NULL, 'PTHR31300', NULL, NULL, NULL, NULL, 'LIPASE', NULL, NULL, 4906, 8),
(246404, NULL, 'PTHR38563', NULL, NULL, NULL, NULL, 'FL(2)D-ASSOCIATED COMPLEX COMPONENT', NULL, NULL, 31807, 8),
(246405, NULL, 'PTHR34667', NULL, NULL, NULL, NULL, 'D-AMINOACYL-TRNA DEACYLASE', NULL, NULL, 10559, 8),
(246406, NULL, 'PTHR16206', NULL, NULL, NULL, NULL, 'DEP DOMAIN-CONTAINING', NULL, NULL, NULL, 8),
(246407, NULL, 'PTHR37076', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE, H3 LYSINE-79 SPECIFIC-LIKE-RELATED', NULL, NULL, NULL, 8),
(246408, NULL, 'PTHR35699', NULL, NULL, NULL, NULL, 'F2J10.10 PROTEIN', NULL, NULL, NULL, 8),
(246409, NULL, 'PTHR20766', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246410, NULL, 'PTHR42735', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246411, NULL, 'PTHR37693', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLGLYCEROL LYSYLTRANSFERASE', NULL, NULL, NULL, 8),
(246412, NULL, 'PTHR47502', NULL, NULL, NULL, NULL, 'THAP DOMAIN-CONTAINING PROTEIN 7', NULL, NULL, 23399, 8),
(246413, NULL, 'PTHR31539', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 19K CEP19', NULL, NULL, 23914, 8),
(246414, NULL, 'PTHR24372', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN HORMONE RECEPTOR', NULL, NULL, NULL, 8),
(246415, NULL, 'PTHR33244', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(246416, NULL, 'PTHR36141', NULL, NULL, NULL, NULL, 'OS08G0148500 PROTEIN', NULL, NULL, NULL, 8),
(246417, NULL, 'PTHR35680', NULL, NULL, NULL, NULL, 'NFAT ACTIVATION MOLECULE 1', NULL, NULL, 33622, 8),
(246418, NULL, 'PTHR19965', NULL, NULL, NULL, NULL, 'RNA AND EXPORT FACTOR BINDING PROTEIN', NULL, NULL, NULL, 8),
(246419, NULL, 'PTHR47649', NULL, NULL, NULL, NULL, 'RIBONUCLEASE D', NULL, NULL, NULL, 8),
(246420, NULL, 'PTHR16717', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE POLYPEPTIDE VIII', NULL, NULL, 3042, 8),
(246421, NULL, 'PTHR35872', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_5G07110)', NULL, NULL, NULL, 8),
(246422, NULL, 'PTHR28289', NULL, NULL, NULL, NULL, 'DASH COMPLEX SUBUNIT HSK3', NULL, NULL, 35488, 8),
(246423, NULL, 'PTHR46208', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM70', NULL, NULL, NULL, 8),
(246424, NULL, 'PTHR43581', NULL, NULL, NULL, NULL, 'ATP/GTP PHOSPHATASE', NULL, NULL, NULL, 8);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(246425, NULL, 'PTHR44411', NULL, NULL, NULL, NULL, 'THO COMPLEX SUBUNIT 6 HOMOLOG', NULL, NULL, 35584, 8),
(246426, NULL, 'PTHR35669', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 9', NULL, NULL, 26620, 8),
(246427, NULL, 'PTHR11195', NULL, NULL, NULL, NULL, 'DESTABILASE-RELATED', NULL, NULL, 14087, 8),
(246428, NULL, 'PTHR10541', NULL, NULL, NULL, NULL, 'PARATHYROID HORMONE', NULL, NULL, 1329, 8),
(246429, NULL, 'PTHR32063', NULL, NULL, NULL, NULL, '', NULL, NULL, 2816, 8),
(246430, NULL, 'PTHR23054', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(246431, NULL, 'PTHR38447', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR YDEB-RELATED', NULL, NULL, NULL, 8),
(246432, NULL, 'PTHR43247', NULL, NULL, NULL, NULL, 'PHOSPHOSERINE AMINOTRANSFERASE', NULL, NULL, 15261, 8),
(246433, NULL, 'PTHR43917', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246434, NULL, 'PTHR15498', NULL, NULL, NULL, NULL, 'T-CELL IMMUNOGLOBULIN AND MUCIN DOMAIN CONTAINING  TIM', NULL, NULL, NULL, 8),
(246435, NULL, 'PTHR11685', NULL, NULL, NULL, NULL, 'RBR FAMILY  RING FINGER AND IBR DOMAIN-CONTAINING', NULL, NULL, 23864, 8),
(246436, NULL, 'PTHR34494', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246437, NULL, 'PTHR33600', NULL, NULL, NULL, NULL, 'PLASTID DIVISION PROTEIN PDV2', NULL, NULL, 31673, 8),
(246438, NULL, 'PTHR13999', NULL, NULL, NULL, NULL, 'INTERFERON INDUCIBLE TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(246439, NULL, 'PTHR13914', NULL, NULL, NULL, NULL, 'PROLINE OXIDASE', NULL, NULL, 17897, 8),
(246440, NULL, 'PTHR45921', NULL, NULL, NULL, NULL, 'IP01054P', NULL, NULL, 34733, 8),
(246441, NULL, 'PTHR14081', NULL, NULL, NULL, NULL, 'SPERM-ASSOCIATED ANTIGEN 11A-RELATED-RELATED', NULL, NULL, 4099, 8),
(246442, NULL, 'PTHR36178', NULL, NULL, NULL, NULL, 'SLR0625 PROTEIN', NULL, NULL, 7406, 8),
(246443, NULL, 'PTHR16023', NULL, NULL, NULL, NULL, 'TAX1 BINDING PROTEIN-RELATED', NULL, NULL, 22155, 8),
(246444, NULL, 'PTHR47819', NULL, NULL, NULL, NULL, 'DENTIN SIALOPHOSPHOPROTEIN', NULL, NULL, NULL, 8),
(246445, NULL, 'PTHR33052', NULL, NULL, NULL, NULL, 'DUF4228 DOMAIN PROTEIN-RELATED', NULL, NULL, NULL, 8),
(246446, NULL, 'PTHR23359', NULL, NULL, NULL, NULL, 'NUCLEOTIDE KINASE', NULL, NULL, 174, 8),
(246447, NULL, 'PTHR28037', NULL, NULL, NULL, NULL, 'ALCOHOL O-ACETYLTRANSFERASE 1-RELATED', NULL, NULL, NULL, 8),
(246448, NULL, 'PTHR25466', NULL, NULL, NULL, NULL, 'T-LYMPHOCYTE ACTIVATION ANTIGEN', NULL, NULL, NULL, 8),
(246449, NULL, 'PTHR21382', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE SUBUNIT', NULL, NULL, 32735, 8),
(246450, NULL, 'PTHR22934', NULL, NULL, NULL, NULL, 'PROTEIN ESC1/WETA-RELATED', NULL, NULL, NULL, 8),
(246451, NULL, 'PTHR46358', NULL, NULL, NULL, NULL, 'TONSOKU-LIKE PROTEIN', NULL, NULL, NULL, 8),
(246452, NULL, 'PTHR15099', NULL, NULL, NULL, NULL, 'PROTEIN PM1', NULL, NULL, 25686, 8),
(246453, NULL, 'PTHR11117', NULL, NULL, NULL, NULL, 'SUCCINYL-COA LIGASE SUBUNIT ALPHA', NULL, NULL, NULL, 8),
(246454, NULL, 'PTHR35775', NULL, NULL, NULL, NULL, '', NULL, NULL, 104, 8),
(246455, NULL, 'PTHR13930', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT TRNA 4-DEMETHYLWYOSINE SYNTHASE', NULL, NULL, 9223, 8),
(246456, NULL, 'PTHR15666', NULL, NULL, NULL, NULL, 'COMM DOMAIN CONTAINING PROTEIN 5', NULL, NULL, 29219, 8),
(246457, NULL, 'PTHR13257', NULL, NULL, NULL, NULL, 'NUCLEOPORIN NUP84-RELATED', NULL, NULL, 30625, 8),
(246458, NULL, 'PTHR31036', NULL, NULL, NULL, NULL, 'FANCD2 OPPOSITE STRAND PROTEIN', NULL, NULL, 24169, 8),
(246459, NULL, 'PTHR46041', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL INNER MEMBRANE PROTEASE SUBUNIT 2', NULL, NULL, 33462, 8),
(246460, NULL, 'PTHR45689', NULL, NULL, NULL, NULL, 'I[[H]] CHANNEL, ISOFORM E', NULL, NULL, NULL, 8),
(246461, NULL, 'PTHR15723', NULL, NULL, NULL, NULL, 'CARBOHYDRATE SULFOTRANSFERASE 15', NULL, NULL, NULL, 8),
(246462, NULL, 'PTHR47038', NULL, NULL, NULL, NULL, 'BAG-ASSOCIATED GRAM PROTEIN 1', NULL, NULL, 36296, 8),
(246463, NULL, 'PTHR43322', NULL, NULL, NULL, NULL, '1-D-DEOXYXYLULOSE 5-PHOSPHATE SYNTHASE-RELATED', NULL, NULL, 786, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(246464, NULL, 'PTHR15350', NULL, NULL, NULL, NULL, 'COP9 SIGNALOSOME COMPLEX SUBUNIT 7/DENDRITIC CELL PROTEIN GA17', NULL, NULL, 36638, 8),
(246465, NULL, 'PTHR35454', NULL, NULL, NULL, NULL, 'AGAP005206-PA', NULL, NULL, NULL, 8),
(246466, NULL, 'PTHR36317', NULL, NULL, NULL, NULL, 'PROTEIN MULTIPLE CHLOROPLAST DIVISION SITE 1', NULL, NULL, 3555, 8),
(246467, NULL, 'PTHR42037', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246468, NULL, 'PTHR47668', NULL, NULL, NULL, NULL, 'DIENELACTONE HYDROLASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_6G01940)', NULL, NULL, NULL, 8),
(246469, NULL, 'PTHR11142', NULL, NULL, NULL, NULL, 'PSEUDOURIDYLATE SYNTHASE', NULL, NULL, 7190, 8),
(246470, NULL, 'PTHR44227', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246471, NULL, 'PTHR21145', NULL, NULL, NULL, NULL, 'CHORISMATE MUTASE', NULL, NULL, 849, 8),
(246472, NULL, 'PTHR34090', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L52, MITOCHONDRIAL', NULL, NULL, 11273, 8),
(246473, NULL, 'PTHR11377', NULL, NULL, NULL, NULL, 'N-MYRISTOYL TRANSFERASE', NULL, NULL, 3351, 8),
(246474, NULL, 'PTHR28290', NULL, NULL, NULL, NULL, 'ENHANCER OF TRANSLATION TERMINATION 1', NULL, NULL, 26753, 8),
(246475, NULL, 'PTHR12619', NULL, NULL, NULL, NULL, 'RFX TRANSCRIPTION FACTOR FAMILY', NULL, NULL, 33210, 8),
(246476, NULL, 'PTHR24321', NULL, NULL, NULL, NULL, 'DEHYDROGENASES, SHORT CHAIN', NULL, NULL, NULL, 8),
(246477, NULL, 'PTHR23416', NULL, NULL, NULL, NULL, 'SIALIC ACID SYNTHASE-RELATED', NULL, NULL, NULL, 8),
(246478, NULL, 'PTHR42047', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G03560)-RELATED', NULL, NULL, NULL, 8),
(246479, NULL, 'PTHR13645', NULL, NULL, NULL, NULL, 'DEFENSIN', NULL, NULL, NULL, 8),
(246480, NULL, 'PTHR46647', NULL, NULL, NULL, NULL, 'RAB9 EFFECTOR PROTEIN WITH KELCH MOTIFS', NULL, NULL, NULL, 8),
(246481, NULL, 'PTHR45884', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE ECO', NULL, NULL, NULL, 8),
(246482, NULL, 'PTHR31187', NULL, NULL, NULL, NULL, '', NULL, NULL, 2967, 8),
(246483, NULL, 'PTHR37348', NULL, NULL, NULL, NULL, 'LLLL AND CFNLAS MOTIF-CONTAINING PROTEIN 1', NULL, NULL, 25985, 8),
(246484, NULL, 'PTHR34467', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(246485, NULL, 'PTHR31495', NULL, NULL, NULL, NULL, 'PEROXYGENASE 3-RELATED', NULL, NULL, 1390, 8),
(246486, NULL, 'PTHR24407', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(246487, NULL, 'PTHR39670', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246488, NULL, 'PTHR14470', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE III DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(246489, NULL, 'PTHR31457', NULL, NULL, NULL, NULL, 'METHYLMALONIC ACIDURIA AND HOMOCYSTINURIA TYPE C PROTEIN', NULL, NULL, 23342, 8),
(246490, NULL, 'PTHR38224', NULL, NULL, NULL, NULL, 'PHLOEM SPECIFIC PROTEIN', NULL, NULL, NULL, 8),
(246491, NULL, 'PTHR40407', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-LIKE PROTEIN', NULL, NULL, NULL, 8),
(246492, NULL, 'PTHR43514', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER I FAMILY MEMBER 10', NULL, NULL, NULL, 8),
(246493, NULL, 'PTHR24334', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN GBX', NULL, NULL, 34517, 8),
(246494, NULL, 'PTHR35330', NULL, NULL, NULL, NULL, 'SIROHEME BIOSYNTHESIS PROTEIN MET8', NULL, NULL, 23990, 8),
(246495, NULL, 'PTHR33349', NULL, NULL, NULL, NULL, 'EMB|CAB62594.1', NULL, NULL, NULL, 8),
(246496, NULL, 'PTHR43619', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASE YKTD-RELATED', NULL, NULL, NULL, 8),
(246497, NULL, 'PTHR22977', NULL, NULL, NULL, NULL, 'COX ASSEMBLY MITOCHONDRIAL PROTEIN', NULL, NULL, 17810, 8),
(246498, NULL, 'PTHR47098', NULL, NULL, NULL, NULL, 'PROTEIN MAK32', NULL, NULL, NULL, 8),
(246499, NULL, 'PTHR37741', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(246500, NULL, 'PTHR23271', NULL, NULL, NULL, NULL, 'HEPATOCELLULAR CARCINOMA-ASSOCIATED ANTIGEN 66', NULL, NULL, 7894, 8),
(246501, NULL, 'PTHR12767', NULL, NULL, NULL, NULL, 'BCL7 RELATED', NULL, NULL, 3954, 8);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(246502, NULL, 'PTHR47543', NULL, NULL, NULL, NULL, 'OS08G0169600 PROTEIN', NULL, NULL, NULL, 8),
(246503, NULL, 'PTHR47697', NULL, NULL, NULL, NULL, 'OS03G0340700 PROTEIN', NULL, NULL, NULL, 8),
(246504, NULL, 'PTHR22118', NULL, NULL, NULL, NULL, 'DYNEIN ASSEMBLY FACTOR 3, AXONEMAL', NULL, NULL, 27327, 8),
(246505, NULL, 'PTHR22573', NULL, NULL, NULL, NULL, 'PHOSPHOHEXOMUTASE FAMILY MEMBER', NULL, NULL, 36614, 8),
(246506, NULL, 'PTHR41390', NULL, NULL, NULL, NULL, 'CHROMOSOME 7, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(246507, NULL, 'PTHR47400', NULL, NULL, NULL, NULL, 'PROLINE-RICH TRANSMEMBRANE PROTEIN 3', NULL, NULL, 35068, 8),
(246508, NULL, 'PTHR42956', NULL, NULL, NULL, NULL, 'NITROGENASE IRON-MOLYBDENUM COFACTOR BIOSYNTHESIS PROTEIN NIFE', NULL, NULL, NULL, 8),
(246509, NULL, 'PTHR14905', NULL, NULL, NULL, NULL, 'NG37', NULL, NULL, NULL, 8),
(246510, NULL, 'PTHR11006', NULL, NULL, NULL, NULL, 'PROTEIN ARGININE N-METHYLTRANSFERASE', NULL, NULL, 22929, 8),
(246511, NULL, 'PTHR11216', NULL, NULL, NULL, NULL, 'EH DOMAIN', NULL, NULL, NULL, 8),
(246512, NULL, 'PTHR21562', NULL, NULL, NULL, NULL, 'NOTUM-RELATED', NULL, NULL, 2898, 8),
(246513, NULL, 'PTHR45688', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246514, NULL, 'PTHR34723', NULL, NULL, NULL, NULL, 'PROTEIN CBG17025', NULL, NULL, NULL, 8),
(246515, NULL, 'PTHR34798', NULL, NULL, NULL, NULL, 'PROTEIN TIME FOR COFFEE', NULL, NULL, 33255, 8),
(246516, NULL, 'PTHR31254', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC690617', NULL, NULL, 26632, 8),
(246517, NULL, 'PTHR20854', NULL, NULL, NULL, NULL, 'INOSITOL MONOPHOSPHATASE', NULL, NULL, NULL, 8),
(246518, NULL, 'PTHR24282', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY MEMBER', NULL, NULL, NULL, 8),
(246519, NULL, 'PTHR43214', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR', NULL, NULL, NULL, 8),
(246520, NULL, 'PTHR45674', NULL, NULL, NULL, NULL, 'DNA LIGASE 1/3 FAMILY MEMBER', NULL, NULL, NULL, 8),
(246521, NULL, 'PTHR36042', NULL, NULL, NULL, NULL, 'OS05G0490900 PROTEIN', NULL, NULL, NULL, 8),
(246522, NULL, 'PTHR12392', NULL, NULL, NULL, NULL, 'LADININ 1', NULL, NULL, 18398, 8),
(246523, NULL, 'PTHR14445', NULL, NULL, NULL, NULL, 'GRB10 INTERACTING GYF PROTEIN', NULL, NULL, NULL, 8),
(246524, NULL, 'PTHR35487', NULL, NULL, NULL, NULL, 'DUF3824 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(246525, NULL, 'PTHR43725', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 4-EPIMERASE', NULL, NULL, NULL, 8),
(246526, NULL, 'PTHR38493', NULL, NULL, NULL, NULL, 'CHROMOSOME 1 OPEN READING FRAME 167', NULL, NULL, 25739, 8),
(246527, NULL, 'PTHR21660', NULL, NULL, NULL, NULL, 'THIOESTERASE SUPERFAMILY MEMBER-RELATED', NULL, NULL, 27007, 8),
(246528, NULL, 'PTHR21349', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L21', NULL, NULL, 24583, 8),
(246529, NULL, 'PTHR10196', NULL, NULL, NULL, NULL, 'SUGAR KINASE', NULL, NULL, NULL, 8),
(246530, NULL, 'PTHR47941', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN 3, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(246531, NULL, 'PTHR46037', NULL, NULL, NULL, NULL, 'PROTEIN ENHANCER OF SEVENLESS 2B', NULL, NULL, 34806, 8),
(246532, NULL, 'PTHR31541', NULL, NULL, NULL, NULL, 'B3 DOMAIN PLANT PROTEIN-RELATED', NULL, NULL, 986, 8),
(246533, NULL, 'PTHR39365', NULL, NULL, NULL, NULL, 'MX REGION OF TRA-2 RELATED-RELATED', NULL, NULL, 22694, 8),
(246534, NULL, 'PTHR34131', NULL, NULL, NULL, NULL, '(RAP ANNOTATION RELEASE2) GALACTOSE-BINDING LIKE DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(246535, NULL, 'PTHR13771', NULL, NULL, NULL, NULL, 'INTERCELLULAR ADHESION MOLECULE', NULL, NULL, NULL, 8),
(246536, NULL, 'PTHR23308', NULL, NULL, NULL, NULL, 'NUCLEAR INHIBITOR OF PROTEIN PHOSPHATASE-1', NULL, NULL, NULL, 8),
(246537, NULL, 'PTHR46465', NULL, NULL, NULL, NULL, 'LATERAL SIGNALING TARGET PROTEIN 2 HOMOLOG', NULL, NULL, NULL, 8),
(246538, NULL, 'PTHR46848', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING 3', NULL, NULL, NULL, 8),
(246539, NULL, 'PTHR23075', NULL, NULL, NULL, NULL, 'PUTATIVE ATP-ASE', NULL, NULL, 32975, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(246540, NULL, 'PTHR15921', NULL, NULL, NULL, NULL, 'PRE-MRNA CLEAVAGE COMPLEX II', NULL, NULL, 35779, 8),
(246541, NULL, 'PTHR14241', NULL, NULL, NULL, NULL, 'INTERFERON-INDUCED PROTEIN 44', NULL, NULL, NULL, 8),
(246542, NULL, 'PTHR31599', NULL, NULL, NULL, NULL, 'CALCIUM UP-REGULATED PROTEIN A-RELATED', NULL, NULL, NULL, 8),
(246543, NULL, 'PTHR39075', NULL, NULL, NULL, NULL, 'FI19908P1', NULL, NULL, NULL, 8),
(246544, NULL, 'PTHR46949', NULL, NULL, NULL, NULL, 'LEUCINE REPEAT ADAPTER PROTEIN 25', NULL, NULL, NULL, 8),
(246545, NULL, 'PTHR12522', NULL, NULL, NULL, NULL, 'ZINC-FINGER PROTEIN NOLZ1-RELATED', NULL, NULL, NULL, 8),
(246546, NULL, 'PTHR39297', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246547, NULL, 'PTHR33199', NULL, NULL, NULL, NULL, 'MACPF DOMAIN-CONTAINING PROTEIN CAD1', NULL, NULL, 36002, 8),
(246548, NULL, 'PTHR36919', NULL, NULL, NULL, NULL, 'BLR1215 PROTEIN', NULL, NULL, NULL, 8),
(246549, NULL, 'PTHR34591', NULL, NULL, NULL, NULL, 'OS03G0653100 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(246550, NULL, 'PTHR11122', NULL, NULL, NULL, NULL, 'APOSPORY-ASSOCIATED PROTEIN C-RELATED', NULL, NULL, NULL, 8),
(246551, NULL, 'PTHR34198', NULL, NULL, NULL, NULL, 'OS01G0175100 PROTEIN', NULL, NULL, NULL, 8),
(246552, NULL, 'PTHR13136', NULL, NULL, NULL, NULL, 'TESTIS DEVELOPMENT PROTEIN PRTD', NULL, NULL, 25021, 8),
(246553, NULL, 'PTHR47542', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASES (NAT) SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(246554, NULL, 'PTHR35205', NULL, NULL, NULL, NULL, 'NB-ARC AND TPR DOMAIN PROTEIN', NULL, NULL, NULL, 8),
(246555, NULL, 'PTHR21337', NULL, NULL, NULL, NULL, 'PHOSPHO-2-DEHYDRO-3-DEOXYHEPTONATE ALDOLASE 1, 2', NULL, NULL, 598, 8),
(246556, NULL, 'PTHR31642', NULL, NULL, NULL, NULL, 'TRICHOTHECENE 3-O-ACETYLTRANSFERASE', NULL, NULL, NULL, 8),
(246557, NULL, 'PTHR21454', NULL, NULL, NULL, NULL, 'DPH3 HOMOLOG-RELATED', NULL, NULL, 36354, 8),
(246558, NULL, 'PTHR43158', NULL, NULL, NULL, NULL, 'SKFA PEPTIDE EXPORT ATP-BINDING PROTEIN SKFE', NULL, NULL, NULL, 8),
(246559, NULL, 'PTHR26379', NULL, NULL, NULL, NULL, 'BTB/POZ AND MATH DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, 36880, 8),
(246560, NULL, 'PTHR33171', NULL, NULL, NULL, NULL, 'LAR_N DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(246561, NULL, 'PTHR45949', NULL, NULL, NULL, NULL, 'SORTING NEXIN-4', NULL, NULL, NULL, 8),
(246562, NULL, 'PTHR31494', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246563, NULL, 'PTHR31172', NULL, NULL, NULL, NULL, 'STOMATAL CLOSURE-RELATED ACTIN-BINDING PROTEIN 1', NULL, NULL, 27025, 8),
(246564, NULL, 'PTHR13163', NULL, NULL, NULL, NULL, 'SPINAL CORD EXPRESSION PROTEIN 4', NULL, NULL, 27636, 8),
(246565, NULL, 'PTHR14564', NULL, NULL, NULL, NULL, 'MICOS COMPLEX SUBUNIT MIC26 / MIC27 FAMILY MEMBER', NULL, NULL, 32667, 8),
(246566, NULL, 'PTHR47745', NULL, NULL, NULL, NULL, 'IZUMO SPERM-EGG FUSION PROTEIN 2', NULL, NULL, 34315, 8),
(246567, NULL, 'PTHR31359', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 92', NULL, NULL, NULL, 8),
(246568, NULL, 'PTHR12873', NULL, NULL, NULL, NULL, 'T7-LIKE MITOCHONDRIAL DNA HELICASE', NULL, NULL, 24255, 8),
(246569, NULL, 'PTHR36946', NULL, NULL, NULL, NULL, 'PROTEIN CBG13897-RELATED', NULL, NULL, NULL, 8),
(246570, NULL, 'PTHR23231', NULL, NULL, NULL, NULL, 'GERM CELL-LESS PROTEIN', NULL, NULL, 35510, 8),
(246571, NULL, 'PTHR37879', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH TAIL PROTEIN 1', NULL, NULL, 20937, 8),
(246572, NULL, 'PTHR36615', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(246573, NULL, 'PTHR16112', NULL, NULL, NULL, NULL, 'METHYL-CPG BINDING PROTEIN, DROSOPHILA', NULL, NULL, 27473, 8),
(246574, NULL, 'PTHR21397', NULL, NULL, NULL, NULL, 'CHROMATIN COMPLEXES SUBUNIT BAP18-RELATED', NULL, NULL, NULL, 8),
(246575, NULL, 'PTHR47304', NULL, NULL, NULL, NULL, 'COMPLEMENT COMPONENT C8 GAMMA CHAIN', NULL, NULL, 35299, 8),
(246576, NULL, 'PTHR45229', NULL, NULL, NULL, NULL, 'CONSTITUTIVE ORNITHINE DECARBOXYLASE', NULL, NULL, NULL, 8),
(246577, NULL, 'PTHR12982', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL GLYCAN, CLASS C', NULL, NULL, 9048, 8);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(246578, NULL, 'PTHR36578', NULL, NULL, NULL, NULL, 'CHROMOSOME 15, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(246579, NULL, 'PTHR46542', NULL, NULL, NULL, NULL, 'X-BOX BINDING PROTEIN 1', NULL, NULL, NULL, 8),
(246580, NULL, 'PTHR46126', NULL, NULL, NULL, NULL, 'DYNACTIN SUBUNIT 5', NULL, NULL, NULL, 8),
(246581, NULL, 'PTHR33565', NULL, NULL, NULL, NULL, 'DORMANCY-ASSOCIATED PROTEIN 1', NULL, NULL, 8883, 8),
(246582, NULL, 'PTHR14947', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', NULL, NULL, 29422, 8),
(246583, NULL, 'PTHR46710', NULL, NULL, NULL, NULL, 'ARM REPEAT PROTEIN INTERACTING WITH ABF2', NULL, NULL, 34307, 8),
(246584, NULL, 'PTHR40280', NULL, NULL, NULL, NULL, 'BLR6907 PROTEIN', NULL, NULL, NULL, 8),
(246585, NULL, 'PTHR20870', NULL, NULL, NULL, NULL, 'BARDET-BIEDL SYNDROME 1 PROTEIN', NULL, NULL, 26608, 8),
(246586, NULL, 'PTHR37311', NULL, NULL, NULL, NULL, '2-PHOSPHOSULFOLACTATE PHOSPHATASE-RELATED', NULL, NULL, 11431, 8),
(246587, NULL, 'PTHR35859', NULL, NULL, NULL, NULL, 'NONSELECTIVE CATION CHANNEL PROTEIN', NULL, NULL, NULL, 8),
(246588, NULL, 'PTHR22848', NULL, NULL, NULL, NULL, 'WD40 REPEAT PROTEIN', NULL, NULL, 34009, 8),
(246589, NULL, 'PTHR34960', NULL, NULL, NULL, NULL, 'EMB|CAB68146.1-RELATED', NULL, NULL, NULL, 8),
(246590, NULL, 'PTHR21029', NULL, NULL, NULL, NULL, 'R-SEVEN BINDING PROTEIN (R7BP) HOMOLOG', NULL, NULL, 23606, 8),
(246591, NULL, 'PTHR46995', NULL, NULL, NULL, NULL, 'OS09G0508200 PROTEIN', NULL, NULL, NULL, 8),
(246592, NULL, 'PTHR30373', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(246593, NULL, 'PTHR43098', NULL, NULL, NULL, NULL, 'L-ORNITHINE N(5)-MONOOXYGENASE-RELATED', NULL, NULL, NULL, 8),
(246594, NULL, 'PTHR11727', NULL, NULL, NULL, NULL, 'DIMETHYLADENOSINE TRANSFERASE', NULL, NULL, 3332, 8),
(246595, NULL, 'PTHR15566', NULL, NULL, NULL, NULL, 'POM121-LIKE', NULL, NULL, 37279, 8),
(246596, NULL, 'PTHR38100', NULL, NULL, NULL, NULL, 'HIGH FREQUENCY LYSOGENIZATION PROTEIN HFLD', NULL, NULL, 4581, 8),
(246597, NULL, 'PTHR28498', NULL, NULL, NULL, NULL, 'ZINC FINGER SWIM DOMAIN-CONTAINING PROTEIN 7', NULL, NULL, NULL, 8),
(246598, NULL, 'PTHR16943', NULL, NULL, NULL, NULL, '2-METHYLCITRATE DEHYDRATASE-RELATED', NULL, NULL, 2840, 8),
(246599, NULL, 'PTHR40658', NULL, NULL, NULL, NULL, '', NULL, NULL, 8612, 8),
(246600, NULL, 'PTHR15028', NULL, NULL, NULL, NULL, 'CD72-RELATED', NULL, NULL, 28488, 8),
(246601, NULL, 'PTHR42722', NULL, NULL, NULL, NULL, 'LEUCINE DEHYDROGENASE', NULL, NULL, 17341, 8),
(246602, NULL, 'PTHR42991', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE', NULL, NULL, NULL, 8),
(246603, NULL, 'PTHR35702', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(246604, NULL, 'PTHR11741', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR TS', NULL, NULL, 4418, 8),
(246605, NULL, 'PTHR46834', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH91', NULL, NULL, 34944, 8),
(246606, NULL, 'PTHR39206', NULL, NULL, NULL, NULL, 'SLL8004 PROTEIN', NULL, NULL, NULL, 8),
(246607, NULL, 'PTHR23055', NULL, NULL, NULL, NULL, 'CALCIUM BINDING PROTEINS', NULL, NULL, 25284, 8),
(246608, NULL, 'PTHR33890', NULL, NULL, NULL, NULL, 'OS10G0571000 PROTEIN', NULL, NULL, NULL, 8),
(246609, NULL, 'PTHR12296', NULL, NULL, NULL, NULL, 'DENN DOMAIN-CONTAINING PROTEIN 4', NULL, NULL, NULL, 8),
(246610, NULL, 'PTHR10126', NULL, NULL, NULL, NULL, 'TATA-BOX BINDING PROTEIN', NULL, NULL, 4552, 8),
(246611, NULL, 'PTHR21277', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ADAPTER 1', NULL, NULL, 10296, 8),
(246612, NULL, 'PTHR31114', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA', NULL, NULL, NULL, 8),
(246613, NULL, 'PTHR14663', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 35768, 8),
(246614, NULL, 'PTHR48026', NULL, NULL, NULL, NULL, 'HOMOLOGOUS TO DROSOPHILA SQD (SQUID) PROTEIN', NULL, NULL, NULL, 8),
(246615, NULL, 'PTHR38608', NULL, NULL, NULL, NULL, 'PROTEIN CBG07207', NULL, NULL, NULL, 8),
(246616, NULL, 'PTHR39576', NULL, NULL, NULL, NULL, 'ATTACHING AND EFFACING PROTEIN HOMOLOG-RELATED-RELATED', NULL, NULL, NULL, 8);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(246617, NULL, 'PTHR38928', NULL, NULL, NULL, NULL, 'ARGOS7', NULL, NULL, NULL, 8),
(246618, NULL, 'PTHR40069', NULL, NULL, NULL, NULL, 'YWBE PROTEIN', NULL, NULL, 19280, 8),
(246619, NULL, 'PTHR33888', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4932415D10 GENE', NULL, NULL, NULL, 8),
(246620, NULL, 'PTHR23081', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II CTD PHOSPHATASE', NULL, NULL, 32801, 8),
(246621, NULL, 'PTHR47800', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(246622, NULL, 'PTHR34281', NULL, NULL, NULL, NULL, 'PROTEIN EARLY FLOWERING 3', NULL, NULL, 27413, 8),
(246623, NULL, 'PTHR21528', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 32253, 8),
(246624, NULL, 'PTHR39945', NULL, NULL, NULL, NULL, 'FI14129P', NULL, NULL, NULL, 8),
(246625, NULL, 'PTHR28674', NULL, NULL, NULL, NULL, 'SIMILAR TO DNA SEGMENT, CHR 10, WAYNE STATE UNIVERSITY 102,-EXPRESSED', NULL, NULL, 23159, 8),
(246626, NULL, 'PTHR46234', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(246627, NULL, 'PTHR36512', NULL, NULL, NULL, NULL, 'D-AMINOPEPTIDASE', NULL, NULL, 5684, 8),
(246628, NULL, 'PTHR46214', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING-CH-TYPE', NULL, NULL, NULL, 8),
(246629, NULL, 'PTHR42927', NULL, NULL, NULL, NULL, 'HELICASE SUPERFAMILY 1 AND 2 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(246630, NULL, 'PTHR14005', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3, THETA SUBUNIT', NULL, NULL, 23635, 8),
(246631, NULL, 'PTHR31644', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR ARO80-RELATED', NULL, NULL, NULL, 8),
(246632, NULL, 'PTHR42803', NULL, NULL, NULL, NULL, 'ACYL-COA DEHYDROGENASE', NULL, NULL, NULL, 8),
(246633, NULL, 'PTHR38435', NULL, NULL, NULL, NULL, '', NULL, NULL, 14262, 8),
(246634, NULL, 'PTHR44942', NULL, NULL, NULL, NULL, 'METHYLTRANSF_11 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(246635, NULL, 'PTHR36193', NULL, NULL, NULL, NULL, 'PHISTB DOMAIN-CONTAINING RESA-LIKE PROTEIN 1', NULL, NULL, NULL, 8),
(246636, NULL, 'PTHR23309', NULL, NULL, NULL, NULL, '3-HYDROXYACYL-COA DEHYROGENASE', NULL, NULL, NULL, 8),
(246637, NULL, 'PTHR34116', NULL, NULL, NULL, NULL, 'PLASMINOGEN ACTIVATOR INHIBITOR', NULL, NULL, NULL, 8),
(246638, NULL, 'PTHR42773', NULL, NULL, NULL, NULL, 'METALLO-BETA-LACTAMASE-RELATED', NULL, NULL, NULL, 8),
(246639, NULL, 'PTHR35512', NULL, NULL, NULL, NULL, 'OS11G0550900 PROTEIN', NULL, NULL, NULL, 8),
(246640, NULL, 'PTHR46889', NULL, NULL, NULL, NULL, 'TRANSPOSASE INSF FOR INSERTION SEQUENCE IS3B-RELATED', NULL, NULL, NULL, 8),
(246641, NULL, 'PTHR15082', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE B12 SUBUNIT', NULL, NULL, 9289, 8),
(246642, NULL, 'PTHR48204', NULL, NULL, NULL, NULL, 'OS07G0265100 PROTEIN', NULL, NULL, NULL, 8),
(246643, NULL, 'PTHR10688', NULL, NULL, NULL, NULL, 'PWWP DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(246644, NULL, 'PTHR31630', NULL, NULL, NULL, NULL, 'PHYTANOYL-COA DIOXYGENASE-RELATED-RELATED', NULL, NULL, NULL, 8),
(246645, NULL, 'PTHR10824', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A THIOESTERASE-RELATED', NULL, NULL, NULL, 8),
(246646, NULL, 'PTHR38886', NULL, NULL, NULL, NULL, 'SESA DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(246647, NULL, 'PTHR33639', NULL, NULL, NULL, NULL, 'THIOL-DISULFIDE OXIDOREDUCTASE DCC', NULL, NULL, NULL, 8),
(246648, NULL, 'PTHR15962', NULL, NULL, NULL, NULL, 'ACTIVITY-REGULATED CYTOSKELETON-ASSOCIATED PROTEIN', NULL, NULL, 19948, 8),
(246649, NULL, 'PTHR24147', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN 36-RELATED', NULL, NULL, NULL, 8),
(246650, NULL, 'PTHR11880', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S19P FAMILY MEMBER', NULL, NULL, 22, 8),
(246651, NULL, 'PTHR36842', NULL, NULL, NULL, NULL, 'PROTEIN TOLB HOMOLOG', NULL, NULL, NULL, 8),
(246652, NULL, 'PTHR12755', NULL, NULL, NULL, NULL, 'CLEAVAGE/POLYADENYLATION FACTOR IA SUBUNIT CLP1P', NULL, NULL, 35953, 8),
(246653, NULL, 'PTHR46292', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 102A', NULL, NULL, NULL, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(246654, NULL, 'PTHR11306', NULL, NULL, NULL, NULL, 'NIEMANN PICK TYPE C2 PROTEIN NPC2-RELATED', NULL, NULL, 33208, 8),
(246655, NULL, 'PTHR30633', NULL, NULL, NULL, NULL, 'CYTOCHROME C-552 RESPIRATORY NITRITE REDUCTASE', NULL, NULL, 4438, 8),
(246656, NULL, 'PTHR34819', NULL, NULL, NULL, NULL, 'LARGE CYSTEINE-RICH PERIPLASMIC PROTEIN OMCB', NULL, NULL, NULL, 8),
(246657, NULL, 'PTHR39162', NULL, NULL, NULL, NULL, 'GLL3345 PROTEIN', NULL, NULL, 10841, 8),
(246658, NULL, 'PTHR24412', NULL, NULL, NULL, NULL, 'KELCH PROTEIN', NULL, NULL, NULL, 8),
(246659, NULL, 'PTHR46978', NULL, NULL, NULL, NULL, 'ZINC KNUCKLE (CCHC-TYPE) FAMILY PROTEIN', NULL, NULL, NULL, 8),
(246660, NULL, 'PTHR36159', NULL, NULL, NULL, NULL, 'PROTEIN CBG23766', NULL, NULL, NULL, 8),
(246661, NULL, 'PTHR32234', NULL, NULL, NULL, NULL, 'THIOL:DISULFIDE INTERCHANGE PROTEIN DSBD', NULL, NULL, NULL, 8),
(246662, NULL, 'PTHR33977', NULL, NULL, NULL, NULL, 'ZINC ION BINDING PROTEIN', NULL, NULL, NULL, 8),
(246663, NULL, 'PTHR45879', NULL, NULL, NULL, NULL, 'CYCLIC AMP RESPONSE ELEMENT-BINDING PROTEIN B', NULL, NULL, 3253, 8),
(246664, NULL, 'PTHR36352', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(246665, NULL, 'PTHR28450', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA GROUP B PROTEIN', NULL, NULL, 28724, 8),
(246666, NULL, 'PTHR11249', NULL, NULL, NULL, NULL, 'GLIAL FACTOR NATURATION FACTOR', NULL, NULL, 10598, 8),
(246667, NULL, 'PTHR28577', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN P', NULL, NULL, 23731, 8),
(246668, NULL, 'PTHR45646', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE DOA-RELATED', NULL, NULL, NULL, 8),
(246669, NULL, 'PTHR45637', NULL, NULL, NULL, NULL, 'FLIPPASE KINASE 1-RELATED', NULL, NULL, NULL, 8),
(246670, NULL, 'PTHR22993', NULL, NULL, NULL, NULL, 'FORMAMIDOPYRIMIDINE-DNA GLYCOSYLASE', NULL, NULL, NULL, 8),
(246671, NULL, 'PTHR42916', NULL, NULL, NULL, NULL, '2-SUCCINYL-5-ENOLPYRUVYL-6-HYDROXY-3-CYCLOHEXENE-1-CARBOXYLATE SYNTHASE', NULL, NULL, NULL, 8),
(246672, NULL, 'PTHR11817', NULL, NULL, NULL, NULL, 'PYRUVATE KINASE', NULL, NULL, 3451, 8),
(246673, NULL, 'PTHR41391', NULL, NULL, NULL, NULL, 'RESTRICTION OF TELOMERE CAPPING PROTEIN 4', NULL, NULL, 33499, 8),
(246674, NULL, 'PTHR14728', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 10687, 8),
(246675, NULL, 'PTHR28359', NULL, NULL, NULL, NULL, 'ASHWIN', NULL, NULL, 26579, 8),
(246676, NULL, 'PTHR14534', NULL, NULL, NULL, NULL, 'VACUOLAR IMPORT AND DEGRADATION PROTEIN 24', NULL, NULL, NULL, 8),
(246677, NULL, 'PTHR46032', NULL, NULL, NULL, NULL, 'ALPHA-2,3-SIALYLTRANSFERASE ST3GAL I ISOFORM X1', NULL, NULL, NULL, 8),
(246678, NULL, 'PTHR36955', NULL, NULL, NULL, NULL, 'SECRETED NEMATODE CLADE V PROTEIN GENE FAMILY', NULL, NULL, NULL, 8),
(246679, NULL, 'PTHR43279', NULL, NULL, NULL, NULL, 'CATECHOL-2,3-DIOXYGENASE', NULL, NULL, NULL, 8),
(246680, NULL, 'PTHR38035', NULL, NULL, NULL, NULL, 'UPF0070 PROTEIN YFGM', NULL, NULL, 24824, 8),
(246681, NULL, 'PTHR39953', NULL, NULL, NULL, NULL, 'RE54151P', NULL, NULL, NULL, 8),
(246682, NULL, 'PTHR12934', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L15', NULL, NULL, 4728, 8),
(246683, NULL, 'PTHR33386', NULL, NULL, NULL, NULL, 'OS02G0740600 PROTEIN', NULL, NULL, NULL, 8),
(246684, NULL, 'PTHR20882', NULL, NULL, NULL, NULL, 'CYTOPLASMIC TRNA 2-THIOLATION PROTEIN 2', NULL, NULL, 16750, 8),
(246685, NULL, 'PTHR40606', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246686, NULL, 'PTHR23031', NULL, NULL, NULL, NULL, 'RHOPHILIN', NULL, NULL, NULL, 8),
(246687, NULL, 'PTHR28309', NULL, NULL, NULL, NULL, 'REQUIRED FOR EXCISION 1-B DOMAIN-CONTAINING PROTEIN', NULL, NULL, 28841, 8),
(246688, NULL, 'PTHR46060', NULL, NULL, NULL, NULL, 'MARINER MOS1 TRANSPOSASE-LIKE PROTEIN', NULL, NULL, NULL, 8),
(246689, NULL, 'PTHR27008', NULL, NULL, NULL, NULL, 'OS04G0122200 PROTEIN', NULL, NULL, NULL, 8),
(246690, NULL, 'PTHR10429', NULL, NULL, NULL, NULL, 'DNA-3-METHYLADENINE GLYCOSYLASE', NULL, NULL, 2693, 8),
(246691, NULL, 'PTHR19858', NULL, NULL, NULL, NULL, 'WD40 REPEAT PROTEIN', NULL, NULL, 21260, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(246692, NULL, 'PTHR12198', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN PROSPERO/PROX-1/CEH-26', NULL, NULL, 33477, 8),
(246693, NULL, 'PTHR32494', NULL, NULL, NULL, NULL, 'ALLANTOATE DEIMINASE-RELATED', NULL, NULL, 10627, 8),
(246694, NULL, 'PTHR10551', NULL, NULL, NULL, NULL, 'FASCIN', NULL, NULL, 9303, 8),
(246695, NULL, 'PTHR31155', NULL, NULL, NULL, NULL, 'ACYL- ACYL-CARRIER-PROTEIN  DESATURASE-RELATED', NULL, NULL, 2203, 8),
(246696, NULL, 'PTHR34185', NULL, NULL, NULL, NULL, 'DIADENYLATE CYCLASE', NULL, NULL, NULL, 8),
(246697, NULL, 'PTHR15054', NULL, NULL, NULL, NULL, 'HISTIDINE-RICH CALCIUM-BINDING PROTEIN-RELATED', NULL, NULL, 17976, 8),
(246698, NULL, 'PTHR10640', NULL, NULL, NULL, NULL, 'METHYLTHIORIBULOSE-1-PHOSPHATE DEHYDRATASE', NULL, NULL, NULL, 8),
(246699, NULL, 'PTHR45696', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN P1', NULL, NULL, NULL, 8),
(246700, NULL, 'PTHR36474', NULL, NULL, NULL, NULL, 'PROTEIN LIAT1', NULL, NULL, 32125, 8),
(246701, NULL, 'PTHR39201', NULL, NULL, NULL, NULL, 'EXPORTED PROTEIN-RELATED', NULL, NULL, NULL, 8),
(246702, NULL, 'PTHR21472', NULL, NULL, NULL, NULL, 'ENDONUCLEASE DOMAIN-CONTAINING 1 PROTEIN ENDOD1', NULL, NULL, 27122, 8),
(246703, NULL, 'PTHR43415', NULL, NULL, NULL, NULL, 'SPERMIDINE N(1)-ACETYLTRANSFERASE', NULL, NULL, NULL, 8),
(246704, NULL, 'PTHR24233', NULL, NULL, NULL, NULL, 'P2Y PURINOCEPTOR-RELATED G-PROTEIN COUPLED RECEPTOR', NULL, NULL, NULL, 8),
(246705, NULL, 'PTHR37526', NULL, NULL, NULL, NULL, 'PROTEIN TUSB', NULL, NULL, 6300, 8),
(246706, NULL, 'PTHR32114', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ABCH.3', NULL, NULL, NULL, 8),
(246707, NULL, 'PTHR37176', NULL, NULL, NULL, NULL, 'F10K1.23', NULL, NULL, 35460, 8),
(246708, NULL, 'PTHR38225', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(246709, NULL, 'PTHR46885', NULL, NULL, NULL, NULL, 'PROTEIN ANKUB1', NULL, NULL, 34372, 8),
(246710, NULL, 'PTHR36776', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(246711, NULL, 'PTHR22168', NULL, NULL, NULL, NULL, 'TMEM26 PROTEIN', NULL, NULL, 18412, 8),
(246712, NULL, 'PTHR13322', NULL, NULL, NULL, NULL, 'C1ORF73 PROTEIN', NULL, NULL, 33482, 8),
(246713, NULL, 'PTHR47758', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS M-RELATED', NULL, NULL, NULL, 8),
(246714, NULL, 'PTHR32059', NULL, NULL, NULL, NULL, 'RAB11-BINDING PROTEIN RELCH', NULL, NULL, 28884, 8),
(246715, NULL, 'PTHR15012', NULL, NULL, NULL, NULL, 'APICAL PROTEIN/SHROOM-RELATED', NULL, NULL, 25190, 8),
(246716, NULL, 'PTHR22953', NULL, NULL, NULL, NULL, 'ACID PHOSPHATASE RELATED', NULL, NULL, 33184, 8),
(246717, NULL, 'PTHR33352', NULL, NULL, NULL, NULL, 'SLR1095 PROTEIN', NULL, NULL, NULL, 8),
(246718, NULL, 'PTHR43784', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G00820)-RELATED', NULL, NULL, NULL, 8),
(246719, NULL, 'PTHR33453', NULL, NULL, NULL, NULL, '', NULL, NULL, 3122, 8),
(246720, NULL, 'PTHR35259', NULL, NULL, NULL, NULL, 'BOMBESIN RECEPTOR-ACTIVATED PROTEIN C6ORF89', NULL, NULL, 30624, 8),
(246721, NULL, 'PTHR31397', NULL, NULL, NULL, NULL, 'BLOC-1-RELATED COMPLEX SUBUNIT 7 BORSC7', NULL, NULL, 26419, 8),
(246722, NULL, 'PTHR47133', NULL, NULL, NULL, NULL, 'TALIN ROD DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, 35181, 8),
(246723, NULL, 'PTHR47262', NULL, NULL, NULL, NULL, 'OS02G0132600 PROTEIN', NULL, NULL, NULL, 8),
(246724, NULL, 'PTHR15347', NULL, NULL, NULL, NULL, 'SPERM-ASSOCIATED ANTIGEN 5', NULL, NULL, 22529, 8),
(246725, NULL, 'PTHR10997', NULL, NULL, NULL, NULL, 'IMPORTIN-7, 8, 11', NULL, NULL, NULL, 8),
(246726, NULL, 'PTHR42090', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246727, NULL, 'PTHR11922', NULL, NULL, NULL, NULL, 'GMP SYNTHASE-RELATED', NULL, NULL, NULL, 8),
(246728, NULL, 'PTHR46751', NULL, NULL, NULL, NULL, 'EPPIN', NULL, NULL, NULL, 8),
(246729, NULL, 'PTHR24153', NULL, NULL, NULL, NULL, 'ESPIN', NULL, NULL, NULL, 8),
(246730, NULL, 'PTHR33909', NULL, NULL, NULL, NULL, 'SEC TRANSLOCON ACCESSORY COMPLEX SUBUNIT YAJC', NULL, NULL, 3067, 8);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(246731, NULL, 'PTHR34360', NULL, NULL, NULL, NULL, 'OS08G0519400 PROTEIN', NULL, NULL, NULL, 8),
(246732, NULL, 'PTHR45694', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN 2', NULL, NULL, NULL, 8),
(246733, NULL, 'PTHR34454', NULL, NULL, NULL, NULL, 'TUNICAMYCIN INDUCED PROTEIN', NULL, NULL, NULL, 8),
(246734, NULL, 'PTHR12669', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4E-BINDING PROTEIN', NULL, NULL, NULL, 8),
(246735, NULL, 'PTHR31543', NULL, NULL, NULL, NULL, 'DYNEIN REGULATORY COMPLEX SUBUNIT 4', NULL, NULL, 27110, 8),
(246736, NULL, 'PTHR21338', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOMAL PROTEIN L41', NULL, NULL, 18426, 8),
(246737, NULL, 'PTHR45698', NULL, NULL, NULL, NULL, 'TRACE AMINE-ASSOCIATED RECEPTOR 19N-RELATED', NULL, NULL, NULL, 8),
(246738, NULL, 'PTHR42801', NULL, NULL, NULL, NULL, 'THIOREDOXIN-DEPENDENT PEROXIDE REDUCTASE', NULL, NULL, NULL, 8),
(246739, NULL, 'PTHR30055', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR RUTR', NULL, NULL, NULL, 8),
(246740, NULL, 'PTHR39468', NULL, NULL, NULL, NULL, 'CHROMOSOME 7, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, 31355, 8),
(246741, NULL, 'PTHR12673', NULL, NULL, NULL, NULL, 'FACIOGENITAL DYSPLASIA PROTEIN', NULL, NULL, NULL, 8),
(246742, NULL, 'PTHR19868', NULL, NULL, NULL, NULL, 'RECEPTOR FOR ACTIVATED PROTEIN KINASE C  RACK1', NULL, NULL, 34570, 8),
(246743, NULL, 'PTHR31437', NULL, NULL, NULL, NULL, 'SREK1IP1 FAMILY MEMBER', NULL, NULL, NULL, 8),
(246744, NULL, 'PTHR30093', NULL, NULL, NULL, NULL, 'GENERAL SECRETION PATHWAY PROTEIN G', NULL, NULL, NULL, 8),
(246745, NULL, 'PTHR31321', NULL, NULL, NULL, NULL, 'ACYL-COA THIOESTER HYDROLASE YBHC-RELATED', NULL, NULL, NULL, 8),
(246746, NULL, 'PTHR35609', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246747, NULL, 'PTHR10882', NULL, NULL, NULL, NULL, 'DIPHTHINE SYNTHASE', NULL, NULL, 977, 8),
(246748, NULL, 'PTHR21499', NULL, NULL, NULL, NULL, 'ASPARTATE KINASE', NULL, NULL, NULL, 8),
(246749, NULL, 'PTHR35672', NULL, NULL, NULL, NULL, 'C-U-EDITING ENZYME APOBEC-4-RELATED', NULL, NULL, 30641, 8),
(246750, NULL, 'PTHR39668', NULL, NULL, NULL, NULL, 'HYPOTHETICAL TRANSMEMBRANE PROTEIN L6586.03-RELATED', NULL, NULL, NULL, 8),
(246751, NULL, 'PTHR31920', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING', NULL, NULL, NULL, 8),
(246752, NULL, 'PTHR46754', NULL, NULL, NULL, NULL, 'MKI67 FHA DOMAIN-INTERACTING NUCLEOLAR PHOSPHOPROTEIN', NULL, NULL, NULL, 8),
(246753, NULL, 'PTHR38768', NULL, NULL, NULL, NULL, 'UPF0502 PROTEIN YCEH', NULL, NULL, 3618, 8),
(246754, NULL, 'PTHR48313', NULL, NULL, NULL, NULL, 'TPR_REGION DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(246755, NULL, 'PTHR15380', NULL, NULL, NULL, NULL, 'CEROID-LIPOFUSCINOSIS, NEURONAL 5', NULL, NULL, 22619, 8),
(246756, NULL, 'PTHR22979', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN-RELATED', NULL, NULL, NULL, 8),
(246757, NULL, 'PTHR21680', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 9360, 8),
(246758, NULL, 'PTHR39665', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246759, NULL, 'PTHR33385', NULL, NULL, NULL, NULL, 'PROTEIN XRI1', NULL, NULL, 27385, 8),
(246760, NULL, 'PTHR31253', NULL, NULL, NULL, NULL, 'BRI3-BINDING PROTEIN', NULL, NULL, 30213, 8),
(246761, NULL, 'PTHR14145', NULL, NULL, NULL, NULL, '26S PROTESOME SUBUNIT 6', NULL, NULL, 20099, 8),
(246762, NULL, 'PTHR31258', NULL, NULL, NULL, NULL, 'KERATINOCYTE-ASSOCIATED PROTEIN 3', NULL, NULL, 15503, 8),
(246763, NULL, 'PTHR40618', NULL, NULL, NULL, NULL, 'B-ZIP TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', NULL, NULL, NULL, 8),
(246764, NULL, 'PTHR12047', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA GROUP A PROTEIN', NULL, NULL, 6195, 8),
(246765, NULL, 'PTHR16431', NULL, NULL, NULL, NULL, 'NEUROGENIC PROTEIN MASTERMIND', NULL, NULL, NULL, 8),
(246766, NULL, 'PTHR43471', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE', NULL, NULL, NULL, 8),
(246767, NULL, 'PTHR21128', NULL, NULL, NULL, NULL, 'FETAL AND ADULT TESTIS-EXPRESSED TRANSCRIPT PROTEIN', NULL, NULL, 32832, 8),
(246768, NULL, 'PTHR46713', NULL, NULL, NULL, NULL, 'F13M7.16 PROTEIN', NULL, NULL, NULL, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(246769, NULL, 'PTHR46447', NULL, NULL, NULL, NULL, 'INTERLEUKIN ENHANCER-BINDING FACTOR', NULL, NULL, NULL, 8),
(246770, NULL, 'PTHR24249', NULL, NULL, NULL, NULL, 'HISTAMINE RECEPTOR-RELATED G-PROTEIN COUPLED RECEPTOR', NULL, NULL, NULL, 8),
(246771, NULL, 'PTHR12958', NULL, NULL, NULL, NULL, 'FRIEND OF GATA2-RELATED', NULL, NULL, 31342, 8),
(246772, NULL, 'PTHR36974', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(246773, NULL, 'PTHR40659', NULL, NULL, NULL, NULL, 'NICKEL/COBALT EFFLUX SYSTEM RCNA', NULL, NULL, NULL, 8),
(246774, NULL, 'PTHR43873', NULL, NULL, NULL, NULL, 'COBYRINATE A,C-DIAMIDE SYNTHASE', NULL, NULL, 1453, 8),
(246775, NULL, 'PTHR28265', NULL, NULL, NULL, NULL, 'MAINTENANCE OF TELOMERE CAPPING PROTEIN 1', NULL, NULL, 19657, 8),
(246776, NULL, 'PTHR31154', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(246777, NULL, 'PTHR43586', NULL, NULL, NULL, NULL, 'CYSTEINE DESULFURASE', NULL, NULL, NULL, 8),
(246778, NULL, 'PTHR35076', NULL, NULL, NULL, NULL, 'TUBULIN EPSILON AND DELTA COMPLEX PROTEIN 1', NULL, NULL, 35519, 8),
(246779, NULL, 'PTHR17103', NULL, NULL, NULL, NULL, 'NEUREXOPHILIN', NULL, NULL, 10422, 8),
(246780, NULL, 'PTHR23327', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 127', NULL, NULL, NULL, 8),
(246781, NULL, 'PTHR34962', NULL, NULL, NULL, NULL, 'EMBRYO DEFECTIVE 1703-RELATED', NULL, NULL, NULL, 8),
(246782, NULL, 'PTHR34682', NULL, NULL, NULL, NULL, 'AT HOOK MOTIF-CONTAINING PROTEIN', NULL, NULL, 33991, 8),
(246783, NULL, 'PTHR47344', NULL, NULL, NULL, NULL, 'RING ZINC FINGER PROTEIN-RELATED', NULL, NULL, NULL, 8),
(246784, NULL, 'PTHR37557', NULL, NULL, NULL, NULL, '115 KDA PROTEIN IN TYPE-1 RETROTRANSPOSABLE ELEMENT R1DM-LIKE PROTEIN-RELATED-RELATED', NULL, NULL, NULL, 8),
(246785, NULL, 'PTHR34410', NULL, NULL, NULL, NULL, 'INTRON-ENCODED HOMING ENDONUCLEASE, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(246786, NULL, 'PTHR12306', NULL, NULL, NULL, NULL, 'CELL DEATH ACTIVATOR CIDE', NULL, NULL, NULL, 8),
(246787, NULL, 'PTHR41930', NULL, NULL, NULL, NULL, 'UPF0200 PROTEIN MJ1399', NULL, NULL, NULL, 8),
(246788, NULL, 'PTHR32012', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 182-RELATED', NULL, NULL, 24223, 8),
(246789, NULL, 'PTHR45619', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE PP2A-RELATED', NULL, NULL, NULL, 8),
(246790, NULL, 'PTHR42244', NULL, NULL, NULL, NULL, 'ANTITOXIN VAPB3-RELATED', NULL, NULL, 28304, 8),
(246791, NULL, 'PTHR40663', NULL, NULL, NULL, NULL, '', NULL, NULL, 33467, 8),
(246792, NULL, 'PTHR31199', NULL, NULL, NULL, NULL, 'ARPIN', NULL, NULL, 20663, 8),
(246793, NULL, 'PTHR43811', NULL, NULL, NULL, NULL, 'FKBP-TYPE PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKPA', NULL, NULL, NULL, 8),
(246794, NULL, 'PTHR35145', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', NULL, NULL, 5767, 8),
(246795, NULL, 'PTHR45374', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE TCHQD', NULL, NULL, 33912, 8),
(246796, NULL, 'PTHR45684', NULL, NULL, NULL, NULL, 'RE74312P', NULL, NULL, 2324, 8),
(246797, NULL, 'PTHR31561', NULL, NULL, NULL, NULL, '3-KETOACYL-COA SYNTHASE', NULL, NULL, 13352, 8),
(246798, NULL, 'PTHR35471', NULL, NULL, NULL, NULL, 'OS07G0223700 PROTEIN', NULL, NULL, NULL, 8),
(246799, NULL, 'PTHR35863', NULL, NULL, NULL, NULL, 'COBALT-PRECORRIN-5B C(1)-METHYLTRANSFERASE', NULL, NULL, 3670, 8),
(246800, NULL, 'PTHR46697', NULL, NULL, NULL, NULL, 'FORMIN-BINDING PROTEIN 4', NULL, NULL, NULL, 8),
(246801, NULL, 'PTHR38601', NULL, NULL, NULL, NULL, 'HYDROGENASE-4 COMPONENT E', NULL, NULL, 29070, 8),
(246802, NULL, 'PTHR21091', NULL, NULL, NULL, NULL, 'METHYLTETRAHYDROFOLATE:HOMOCYSTEINE METHYLTRANSFERASE RELATED', NULL, NULL, NULL, 8),
(246803, NULL, 'PTHR42696', NULL, NULL, NULL, NULL, 'ASPARTATE AMMONIA-LYASE', NULL, NULL, NULL, 8),
(246804, NULL, 'PTHR16950', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER SLC39A7  HISTIDINE-RICH MEMBRANE PROTEIN KE4', NULL, NULL, NULL, 8),
(246805, NULL, 'PTHR46818', NULL, NULL, NULL, NULL, 'DOMAIN-CONTAINING PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(246806, NULL, 'PTHR43685', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', NULL, NULL, NULL, 8),
(246807, NULL, 'PTHR10104', NULL, NULL, NULL, NULL, 'STATHMIN', NULL, NULL, 3445, 8),
(246808, NULL, 'PTHR23240', NULL, NULL, NULL, NULL, 'DNA CROSS-LINK REPAIR PROTEIN PSO2/SNM1-RELATED', NULL, NULL, NULL, 8),
(246809, NULL, 'PTHR47443', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASES (NAT) SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(246810, NULL, 'PTHR35008', NULL, NULL, NULL, NULL, 'BLL4482 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(246811, NULL, 'PTHR47101', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE CYTIDYLYLTRANSFERASE 5, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(246812, NULL, 'PTHR33356', NULL, NULL, NULL, NULL, 'TIP41-LIKE PROTEIN', NULL, NULL, NULL, 8),
(246813, NULL, 'PTHR17068', NULL, NULL, NULL, NULL, 'MYELOID-ASSOCIATED DIFFERENTIATION MARKER MYADM FAMILY MEMBER', NULL, NULL, NULL, 8),
(246814, NULL, 'PTHR45625', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE-RELATED', NULL, NULL, 36124, 8),
(246815, NULL, 'PTHR43305', NULL, NULL, NULL, NULL, 'FAMILY N-ACETYLTRANSFERASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G01380)-RELATED', NULL, NULL, NULL, 8),
(246816, NULL, 'PTHR43075', NULL, NULL, NULL, NULL, 'FORMATE LYASE ACTIVATING ENZYME, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G15630)-RELATED', NULL, NULL, 28952, 8),
(246817, NULL, 'PTHR11403', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT III', NULL, NULL, 20657, 8),
(246818, NULL, 'PTHR36047', NULL, NULL, NULL, NULL, 'OS01G0191000 PROTEIN', NULL, NULL, NULL, 8),
(246819, NULL, 'PTHR34780', NULL, NULL, NULL, NULL, 'OS08G0427800 PROTEIN', NULL, NULL, NULL, 8),
(246820, NULL, 'PTHR32470', NULL, NULL, NULL, NULL, 'ADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX ASSEMBLY FACTOR 2', NULL, NULL, NULL, 8),
(246821, NULL, 'PTHR45829', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL CARRIER PROTEIN RIM2', NULL, NULL, NULL, 8),
(246822, NULL, 'PTHR40257', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246823, NULL, 'PTHR30175', NULL, NULL, NULL, NULL, 'PHOSPHOTRANSFERASE SYSTEM TRANSPORT PROTEIN', NULL, NULL, NULL, 8),
(246824, NULL, 'PTHR44083', NULL, NULL, NULL, NULL, 'TOPLESS-RELATED PROTEIN 1-RELATED', NULL, NULL, 21525, 8),
(246825, NULL, 'PTHR34566', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN', NULL, NULL, NULL, 8),
(246826, NULL, 'PTHR30008', NULL, NULL, NULL, NULL, 'EXODEOXYRIBONUCLEASE 7 LARGE SUBUNIT', NULL, NULL, 2366, 8),
(246827, NULL, 'PTHR37244', NULL, NULL, NULL, NULL, 'NADP-SPECIFIC GLUTAMATE DEHYDROGENASE', NULL, NULL, NULL, 8),
(246828, NULL, 'PTHR45745', NULL, NULL, NULL, NULL, 'PHOSPHOMANNOMUTASE 45A', NULL, NULL, NULL, 8),
(246829, NULL, 'PTHR37036', NULL, NULL, NULL, NULL, '', NULL, NULL, 7856, 8),
(246830, NULL, 'PTHR45995', NULL, NULL, NULL, NULL, '', NULL, NULL, 34110, 8),
(246831, NULL, 'PTHR44133', NULL, NULL, NULL, NULL, 'CLEAVAGE STIMULATION FACTOR SUBUNIT 1', NULL, NULL, 36013, 8),
(246832, NULL, 'PTHR31339', NULL, NULL, NULL, NULL, 'PECTIN LYASE-RELATED', NULL, NULL, NULL, 8),
(246833, NULL, 'PTHR48007', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE PXC1', NULL, NULL, NULL, 8),
(246834, NULL, 'PTHR48200', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(246835, NULL, 'PTHR11627', NULL, NULL, NULL, NULL, 'FRUCTOSE-BISPHOSPHATE ALDOLASE', NULL, NULL, 6569, 8),
(246836, NULL, 'PTHR15188', NULL, NULL, NULL, NULL, 'C-X-C MOTIF CHEMOKINE 14', NULL, NULL, 27384, 8),
(246837, NULL, 'PTHR23519', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 22', NULL, NULL, NULL, 8),
(246838, NULL, 'PTHR12290', NULL, NULL, NULL, NULL, 'CORNICHON-RELATED', NULL, NULL, NULL, 8),
(246839, NULL, 'PTHR46001', NULL, NULL, NULL, NULL, 'TIAM (MAMMALIAN TUMOR INVASION AND METASTASIS FACTOR) HOMOLOG', NULL, NULL, 35162, 8),
(246840, NULL, 'PTHR13292', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 14469, 8),
(246841, NULL, 'PTHR10812', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR AP-2', NULL, NULL, 864, 8),
(246842, NULL, 'PTHR19384', NULL, NULL, NULL, NULL, 'NITRIC OXIDE SYNTHASE-RELATED', NULL, NULL, NULL, 8);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(246843, NULL, 'PTHR12143', NULL, NULL, NULL, NULL, 'PEPTIDE N-GLYCANASE  PNGASE -RELATED', NULL, NULL, NULL, 8),
(246844, NULL, 'PTHR36021', NULL, NULL, NULL, NULL, 'COREPRESSOR', NULL, NULL, NULL, 8),
(246845, NULL, 'PTHR12840', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE ASHI SUBUNIT', NULL, NULL, 13479, 8),
(246846, NULL, 'PTHR31071', NULL, NULL, NULL, NULL, 'GB|AAF24581.1', NULL, NULL, 34425, 8),
(246847, NULL, 'PTHR13683', NULL, NULL, NULL, NULL, 'ASPARTYL PROTEASES', NULL, NULL, 6342, 8),
(246848, NULL, 'PTHR47831', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR II-I REPEAT DOMAIN-CONTAINING PROTEIN 2', NULL, NULL, 33619, 8),
(246849, NULL, 'PTHR12722', NULL, NULL, NULL, NULL, 'XAP-5 PROTEIN-RELATED', NULL, NULL, 6956, 8),
(246850, NULL, 'PTHR42954', NULL, NULL, NULL, NULL, 'FE(2+) TRANSPORT PROTEIN A', NULL, NULL, NULL, 8),
(246851, NULL, 'PTHR20986', NULL, NULL, NULL, NULL, 'FMRFAMIDE-RELATED PEPTIDES', NULL, NULL, NULL, 8),
(246852, NULL, 'PTHR14465', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN H', NULL, NULL, 30931, 8),
(246853, NULL, 'PTHR37409', NULL, NULL, NULL, NULL, 'RIKEN CDNA D130052B06 GENE', NULL, NULL, NULL, 8),
(246854, NULL, 'PTHR43317', NULL, NULL, NULL, NULL, 'THERMOSPERMINE SYNTHASE ACAULIS5', NULL, NULL, NULL, 8),
(246855, NULL, 'PTHR33626', NULL, NULL, NULL, NULL, 'ZGC:158463', NULL, NULL, NULL, 8),
(246856, NULL, 'PTHR31171', NULL, NULL, NULL, NULL, 'LY6/PLAUR DOMAIN-CONTAINING PROTEIN 6', NULL, NULL, 31029, 8),
(246857, NULL, 'PTHR38436', NULL, NULL, NULL, NULL, 'POLYKETIDE CYCLASE SNOAL-LIKE DOMAIN', NULL, NULL, 8105, 8),
(246858, NULL, 'PTHR12625', NULL, NULL, NULL, NULL, 'LIPOCALIN-1 INTERACTING MEMBRANE RECEPTOR  LIMR', NULL, NULL, 6453, 8),
(246859, NULL, 'PTHR47583', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(246860, NULL, 'PTHR40380', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE-III DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(246861, NULL, 'PTHR12692', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE-RELATED', NULL, NULL, 15181, 8),
(246862, NULL, 'PTHR31288', NULL, NULL, NULL, NULL, 'O-FUCOSYLTRANSFERASE FAMILY PROTEIN', NULL, NULL, 12955, 8),
(246863, NULL, 'PTHR10966', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIA SUBUNIT 2', NULL, NULL, 3086, 8),
(246864, NULL, 'PTHR24363', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN KINASE', NULL, NULL, NULL, 8),
(246865, NULL, 'PTHR33592', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(246866, NULL, 'PTHR14781', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 23074, 8),
(246867, NULL, 'PTHR11935', NULL, NULL, NULL, NULL, 'BETA LACTAMASE DOMAIN', NULL, NULL, NULL, 8),
(246868, NULL, 'PTHR21099', NULL, NULL, NULL, NULL, 'RAD201', NULL, NULL, NULL, 8),
(246869, NULL, 'PTHR12127', NULL, NULL, NULL, NULL, 'MUCOLIPIN', NULL, NULL, 29480, 8),
(246870, NULL, 'PTHR16240', NULL, NULL, NULL, NULL, 'PROTEIN MENT', NULL, NULL, 24980, 8),
(246871, NULL, 'PTHR12365', NULL, NULL, NULL, NULL, 'SPROUTY', NULL, NULL, NULL, 8),
(246872, NULL, 'PTHR36504', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE EXPORT SYSTEM PROTEIN LPTA', NULL, NULL, NULL, 8),
(246873, NULL, 'PTHR46293', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN PROTEIN LIGASE DRIP1', NULL, NULL, 34596, 8),
(246874, NULL, 'PTHR28665', NULL, NULL, NULL, NULL, 'BEN DOMAIN-CONTAINING PROTEIN 3', NULL, NULL, 28890, 8),
(246875, NULL, 'PTHR28547', NULL, NULL, NULL, NULL, 'PROTEIN MMS22-LIKE', NULL, NULL, 34673, 8),
(246876, NULL, 'PTHR37540', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR (ACR-2), PUTATIVE-RELATED-RELATED', NULL, NULL, NULL, 8),
(246877, NULL, 'PTHR15874', NULL, NULL, NULL, NULL, 'NUCLEOLAR AND SPINDLE-ASSOCIATED PROTEIN 1', NULL, NULL, 24487, 8),
(246878, NULL, 'PTHR38452', NULL, NULL, NULL, NULL, 'UPF0756 MEMBRANE PROTEIN YEAL', NULL, NULL, 5929, 8),
(246879, NULL, 'PTHR20937', NULL, NULL, NULL, NULL, 'IP14615P', NULL, NULL, 27104, 8),
(246880, NULL, 'PTHR31439', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(246881, NULL, 'PTHR31922', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 215', NULL, NULL, 25291, 8),
(246882, NULL, 'PTHR12138', NULL, NULL, NULL, NULL, 'PRIMATE-EXPANDED PROTEIN FAMILY', NULL, NULL, NULL, 8),
(246883, NULL, 'PTHR47065', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING DOMAIN-CONTAINING PROTEIN 9', NULL, NULL, 35252, 8),
(246884, NULL, 'PTHR23064', NULL, NULL, NULL, NULL, 'TROPONIN', NULL, NULL, NULL, 8),
(246885, NULL, 'PTHR39198', NULL, NULL, NULL, NULL, 'HYPOTHETICAL MEMBRANE PROTEIN, CONSERVED', NULL, NULL, NULL, 8),
(246886, NULL, 'PTHR12450', NULL, NULL, NULL, NULL, 'DENTIN MATRIX PROTEIN 4  PROTEIN FAM20', NULL, NULL, 22485, 8),
(246887, NULL, 'PTHR23324', NULL, NULL, NULL, NULL, 'SEC14 RELATED PROTEIN', NULL, NULL, NULL, 8),
(246888, NULL, 'PTHR10829', NULL, NULL, NULL, NULL, 'CORTACTIN AND DREBRIN', NULL, NULL, NULL, 8),
(246889, NULL, 'PTHR13017', NULL, NULL, NULL, NULL, '5-FORMYLTETRAHYDROFOLATE CYCLO-LIGASE-RELATED', NULL, NULL, 3771, 8),
(246890, NULL, 'PTHR45748', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 3-PHOSPHATE 5-KINASE-RELATED', NULL, NULL, NULL, 8),
(246891, NULL, 'PTHR37303', NULL, NULL, NULL, NULL, 'EXPORTED PROTEIN-RELATED', NULL, NULL, 32820, 8),
(246892, NULL, 'PTHR32098', NULL, NULL, NULL, NULL, 'LYCOPENE BETA/EPSILON CYCLASE PROTEIN', NULL, NULL, NULL, 8),
(246893, NULL, 'PTHR21236', NULL, NULL, NULL, NULL, 'GOLGI MEMBRANE PROTEIN YIP1', NULL, NULL, 36169, 8),
(246894, NULL, 'PTHR43220', NULL, NULL, NULL, NULL, '', NULL, NULL, 34046, 8),
(246895, NULL, 'PTHR36376', NULL, NULL, NULL, NULL, 'OS09G0514700 PROTEIN', NULL, NULL, NULL, 8),
(246896, NULL, 'PTHR33217', NULL, NULL, NULL, NULL, 'TRANSPOSASE FOR INSERTION SEQUENCE ELEMENT IS1081', NULL, NULL, 1429, 8),
(246897, NULL, 'PTHR46736', NULL, NULL, NULL, NULL, 'ZF-RVT DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(246898, NULL, 'PTHR22955', NULL, NULL, NULL, NULL, 'RETROTRANSPOSON', NULL, NULL, NULL, 8),
(246899, NULL, 'PTHR39591', NULL, NULL, NULL, NULL, 'UPF0265 PROTEIN YEEX', NULL, NULL, 4689, 8),
(246900, NULL, 'PTHR48097', NULL, NULL, NULL, NULL, 'L-THREONINE ALDOLASE-RELATED', NULL, NULL, NULL, 8),
(246901, NULL, 'PTHR33625', NULL, NULL, NULL, NULL, 'OS08G0179900 PROTEIN', NULL, NULL, NULL, 8),
(246902, NULL, 'PTHR38422', NULL, NULL, NULL, NULL, 'SOMETHING ABOUT SILENCING PROTEIN 4', NULL, NULL, 30620, 8),
(246903, NULL, 'PTHR21222', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(246904, NULL, 'PTHR35483', NULL, NULL, NULL, NULL, 'NUCLEUSENVELOPE PROTEIN', NULL, NULL, NULL, 8),
(246905, NULL, 'PTHR45937', NULL, NULL, NULL, NULL, 'ASPARAGINE SYNTHETASE DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(246906, NULL, 'PTHR43418', NULL, NULL, NULL, NULL, 'MULTIFUNCTIONAL TRYPTOPHAN BIOSYNTHESIS PROTEIN-RELATED', NULL, NULL, NULL, 8),
(246907, NULL, 'PTHR35693', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(246908, NULL, 'PTHR31763', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC689766', NULL, NULL, 32540, 8),
(246909, NULL, 'PTHR43872', NULL, NULL, NULL, NULL, 'MONOOXYGENASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G02570)-RELATED', NULL, NULL, NULL, 8),
(246910, NULL, 'PTHR22765', NULL, NULL, NULL, NULL, 'RING FINGER AND PROTEASE ASSOCIATED DOMAIN-CONTAINING', NULL, NULL, NULL, 8),
(246911, NULL, 'PTHR22718', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS X', NULL, NULL, NULL, 8),
(246912, NULL, 'PTHR11822', NULL, NULL, NULL, NULL, 'NADP-SPECIFIC ISOCITRATE DEHYDROGENASE', NULL, NULL, 5480, 8),
(246913, NULL, 'PTHR30543', NULL, NULL, NULL, NULL, 'CHROMATE REDUCTASE', NULL, NULL, NULL, 8),
(246914, NULL, 'PTHR21510', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246915, NULL, 'PTHR32328', NULL, NULL, NULL, NULL, 'L-SERYL-TRNA(SEC) SELENIUM TRANSFERASE', NULL, NULL, NULL, 8),
(246916, NULL, 'PTHR33435', NULL, NULL, NULL, NULL, 'PROTEIN CBG21870-RELATED', NULL, NULL, NULL, 8),
(246917, NULL, 'PTHR33893', NULL, NULL, NULL, NULL, 'INSULIN RELATED-RELATED-RELATED', NULL, NULL, NULL, 8),
(246918, NULL, 'PTHR13500', NULL, NULL, NULL, NULL, 'NUCLEOLAR PRERIBOSOMAL-ASSOCIATED PROTEIN 1', NULL, NULL, 27420, 8);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(246919, NULL, 'PTHR23013', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR', NULL, NULL, NULL, 8),
(246920, NULL, 'PTHR12937', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING 28, ISOFORM 2  VPS28', NULL, NULL, 37, 8),
(246921, NULL, 'PTHR37408', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246922, NULL, 'PTHR11054', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONOLACTONASE', NULL, NULL, 31181, 8),
(246923, NULL, 'PTHR45790', NULL, NULL, NULL, NULL, 'SIROHEME SYNTHASE-RELATED', NULL, NULL, NULL, 8),
(246924, NULL, 'PTHR37615', NULL, NULL, NULL, NULL, 'NUCLEOPORIN NUP159-LIKE', NULL, NULL, NULL, 8),
(246925, NULL, 'PTHR33170', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(246926, NULL, 'PTHR11606', NULL, NULL, NULL, NULL, 'GLUTAMATE DEHYDROGENASE', NULL, NULL, NULL, 8),
(246927, NULL, 'PTHR21694', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(246928, NULL, 'PTHR45718', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR CUBITUS INTERRUPTUS', NULL, NULL, 34177, 8),
(246929, NULL, 'PTHR11071', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', NULL, NULL, NULL, 8),
(246930, NULL, 'PTHR31796', NULL, NULL, NULL, NULL, 'SUZ DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, 33133, 8),
(246931, NULL, 'PTHR24128', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN WARIAI', NULL, NULL, NULL, 8),
(246932, NULL, 'PTHR33776', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(246933, NULL, 'PTHR31371', NULL, NULL, NULL, NULL, 'BNAC09G50660D PROTEIN', NULL, NULL, NULL, 8),
(246934, NULL, 'PTHR12345', NULL, NULL, NULL, NULL, 'SYNTENIN RELATED', NULL, NULL, NULL, 8),
(246935, NULL, 'PTHR31683', NULL, NULL, NULL, NULL, 'PECTATE LYASE 18-RELATED', NULL, NULL, 35804, 8),
(246936, NULL, 'PTHR33083', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(246937, NULL, 'PTHR31621', NULL, NULL, NULL, NULL, 'PROTEIN DMP3', NULL, NULL, 1327, 8),
(246938, NULL, 'PTHR31634', NULL, NULL, NULL, NULL, 'BLOC-1-RELATED COMPLEX SUBUNIT 5', NULL, NULL, 19344, 8),
(246939, NULL, 'PTHR47005', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORT/DETOXIFICATION SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(246940, NULL, 'PTHR40376', NULL, NULL, NULL, NULL, 'ODONTOGENESIS ASSOCIATED PHOSPHOPROTEIN', NULL, NULL, 21817, 8),
(246941, NULL, 'PTHR22706', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(246942, NULL, 'PTHR47044', NULL, NULL, NULL, NULL, 'OS02G0276400 PROTEIN', NULL, NULL, NULL, 8),
(246943, NULL, 'PTHR35277', NULL, NULL, NULL, NULL, 'OS09G0363700 PROTEIN', NULL, NULL, NULL, 8),
(246944, NULL, 'PTHR15679', NULL, NULL, NULL, NULL, 'PCNA-ASSOCIATED FACTOR', NULL, NULL, 27226, 8),
(246945, NULL, 'PTHR42106', NULL, NULL, NULL, NULL, 'CHROMOSOME 10, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(246946, NULL, 'PTHR47128', NULL, NULL, NULL, NULL, '', NULL, NULL, 35006, 8),
(246947, NULL, 'PTHR36484', NULL, NULL, NULL, NULL, 'OS01G0558700 PROTEIN', NULL, NULL, NULL, 8),
(246948, NULL, 'PTHR11566', NULL, NULL, NULL, NULL, 'DYNAMIN', NULL, NULL, 17225, 8),
(246949, NULL, 'PTHR36783', NULL, NULL, NULL, NULL, 'THYLAKOID LUMENAL 17.9 KDA PROTEIN, CHLOROPLASTIC', NULL, NULL, 27041, 8),
(246950, NULL, 'PTHR12626', NULL, NULL, NULL, NULL, 'PROGRAMMED CELL DEATH 4', NULL, NULL, 33419, 8),
(246951, NULL, 'PTHR38007', NULL, NULL, NULL, NULL, 'CRISPR SYSTEM CMS PROTEIN CSM5', NULL, NULL, 10614, 8),
(246952, NULL, 'PTHR34834', NULL, NULL, NULL, NULL, 'SPERMATID MATURATION PROTEIN 1', NULL, NULL, NULL, 8),
(246953, NULL, 'PTHR32358', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL AND IMMUNE RESPONSE REGULATOR', NULL, NULL, 27233, 8),
(246954, NULL, 'PTHR47596', NULL, NULL, NULL, NULL, 'DVL13', NULL, NULL, NULL, 8),
(246955, NULL, 'PTHR31511', NULL, NULL, NULL, NULL, 'PROTEIN CBG23764', NULL, NULL, NULL, 8),
(246956, NULL, 'PTHR11078', NULL, NULL, NULL, NULL, 'N UTILIZATION SUBSTANCE PROTEIN B-RELATED', NULL, NULL, 11454, 8),
(246957, NULL, 'PTHR37945', NULL, NULL, NULL, NULL, 'EXTRACELLULAR TUNGSTATE BINDING PROTEIN', NULL, NULL, NULL, 8);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(246958, NULL, 'PTHR15231', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL N-ACETYLGLUCOSAMINYLTRANSFERASE SUBUNIT H', NULL, NULL, 34587, 8),
(246959, NULL, 'PTHR30582', NULL, NULL, NULL, NULL, 'L,D-TRANSPEPTIDASE', NULL, NULL, NULL, 8),
(246960, NULL, 'PTHR11003', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL, SUBFAMILY K', NULL, NULL, 3359, 8),
(246961, NULL, 'PTHR40698', NULL, NULL, NULL, NULL, 'FLAGELLA-RELATED PROTEIN E-RELATED-RELATED', NULL, NULL, NULL, 8),
(246962, NULL, 'PTHR18879', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 290 KDA', NULL, NULL, 25151, 8),
(246963, NULL, 'PTHR47384', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE CCNB1IP1 HOMOLOG', NULL, NULL, NULL, 8),
(246964, NULL, 'PTHR34475', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246965, NULL, 'PTHR43609', NULL, NULL, NULL, NULL, 'ACETYL-COA HYDROLASE', NULL, NULL, 36688, 8),
(246966, NULL, 'PTHR30400', NULL, NULL, NULL, NULL, 'MONOFUNCTIONAL BIOSYNTHETIC PEPTIDOGLYCAN TRANSGLYCOSYLASE', NULL, NULL, 13135, 8),
(246967, NULL, 'PTHR35714', NULL, NULL, NULL, NULL, 'OS02G0715300 PROTEIN', NULL, NULL, NULL, 8),
(246968, NULL, 'PTHR12962', NULL, NULL, NULL, NULL, 'CALCIUM-REGULATED HEAT STABLE PROTEIN CRHSP-24-RELATED', NULL, NULL, NULL, 8),
(246969, NULL, 'PTHR40457', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1', NULL, NULL, 3435, 8),
(246970, NULL, 'PTHR42071', NULL, NULL, NULL, NULL, 'PROTOGLOBIN DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(246971, NULL, 'PTHR42885', NULL, NULL, NULL, NULL, 'HISTIDINOL-PHOSPHATE AMINOTRANSFERASE-RELATED', NULL, NULL, NULL, 8),
(246972, NULL, 'PTHR31348', NULL, NULL, NULL, NULL, 'EID1-LIKE F-BOX PROTEIN 2-RELATED', NULL, NULL, 27779, 8),
(246973, NULL, 'PTHR45113', NULL, NULL, NULL, NULL, 'JUNCTIONAL ADHESION MOLECULE A', NULL, NULL, 37025, 8),
(246974, NULL, 'PTHR19324', NULL, NULL, NULL, NULL, 'PERFORIN-LIKE PROTEIN 1', NULL, NULL, NULL, 8),
(246975, NULL, 'PTHR38769', NULL, NULL, NULL, NULL, 'UPF0381 PROTEIN YFCZ-RELATED', NULL, NULL, 4208, 8),
(246976, NULL, 'PTHR46464', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', NULL, NULL, 34820, 8),
(246977, NULL, 'PTHR12896', NULL, NULL, NULL, NULL, 'PAX6 NEIGHBOR PROTEIN  PAXNEB', NULL, NULL, 12107, 8),
(246978, NULL, 'PTHR10835', NULL, NULL, NULL, NULL, 'SQUALENE MONOOXYGENASE', NULL, NULL, 27489, 8),
(246979, NULL, 'PTHR39957', NULL, NULL, NULL, NULL, 'AT09846P1-RELATED', NULL, NULL, NULL, 8),
(246980, NULL, 'PTHR14788', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 156', NULL, NULL, 26243, 8),
(246981, NULL, 'PTHR45734', NULL, NULL, NULL, NULL, 'TENSIN', NULL, NULL, NULL, 8),
(246982, NULL, 'PTHR33736', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN-RELATED', NULL, NULL, 35621, 8),
(246983, NULL, 'PTHR36505', NULL, NULL, NULL, NULL, 'BLR1072 PROTEIN', NULL, NULL, NULL, 8),
(246984, NULL, 'PTHR45831', NULL, NULL, NULL, NULL, 'LD24721P', NULL, NULL, NULL, 8),
(246985, NULL, 'PTHR47833', NULL, NULL, NULL, NULL, 'PHOTOSYNTHETIC NDH SUBUNIT OF LUMENAL LOCATION 4, CHLOROPLASTIC', NULL, NULL, 36728, 8),
(246986, NULL, 'PTHR43555', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLFORMYLGLYCINAMIDINE SYNTHASE SUBUNIT PURL', NULL, NULL, 2328, 8),
(246987, NULL, 'PTHR40866', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(246988, NULL, 'PTHR14913', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR TYPE 1-ASSOCIATED DEATH DOMAIN PROTEIN', NULL, NULL, 32421, 8),
(246989, NULL, 'PTHR46733', NULL, NULL, NULL, NULL, '26.5 KDA HEAT SHOCK PROTEIN, MITOCHONDRIAL', NULL, NULL, 34785, 8),
(246990, NULL, 'PTHR12993', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINYL-PHOSPHATIDYLINOSITOL DE-N-ACETYLASE-RELATED', NULL, NULL, 6108, 8),
(246991, NULL, 'PTHR34034', NULL, NULL, NULL, NULL, 'PROTEIN FAM180A-RELATED', NULL, NULL, 21800, 8),
(246992, NULL, 'PTHR45709', NULL, NULL, NULL, NULL, 'LARGE SUBUNIT GTPASE 1 HOMOLOG-RELATED', NULL, NULL, 34424, 8),
(246993, NULL, 'PTHR34666', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(246994, NULL, 'PTHR33403', NULL, NULL, NULL, NULL, 'SPR1', NULL, NULL, 27393, 8),
(246995, NULL, 'PTHR31898', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 136', NULL, NULL, 34899, 8);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(246996, NULL, 'PTHR47801', NULL, NULL, NULL, NULL, 'OS05G0145600 PROTEIN', NULL, NULL, NULL, 8),
(246997, NULL, 'PTHR30137', NULL, NULL, NULL, NULL, 'LUCIFERASE-LIKE MONOOXYGENASE', NULL, NULL, NULL, 8),
(246998, NULL, 'PTHR23292', NULL, NULL, NULL, NULL, 'LIPOPOLYSACCHARIDE-INDUCED TUMOR NECROSIS FACTOR-ALPHA FACTOR', NULL, NULL, 33441, 8),
(246999, NULL, 'PTHR39960', NULL, NULL, NULL, NULL, 'LD34147P', NULL, NULL, NULL, 8),
(247000, NULL, 'PTHR47368', NULL, NULL, NULL, NULL, 'NUMB', NULL, NULL, 20413, 8),
(247001, NULL, 'PTHR46297', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH-TYPE WITH G PATCH DOMAIN-CONTAINING PROTEIN', NULL, NULL, 35885, 8),
(247002, NULL, 'PTHR43065', NULL, NULL, NULL, NULL, 'SENSOR HISTIDINE KINASE', NULL, NULL, NULL, 8),
(247003, NULL, 'PTHR43424', NULL, NULL, NULL, NULL, 'LOCUS PUTATIVE PROTEIN 1-RELATED', NULL, NULL, NULL, 8),
(247004, NULL, 'PTHR47127', NULL, NULL, NULL, NULL, '10A19I.15', NULL, NULL, NULL, 8),
(247005, NULL, 'PTHR18937', NULL, NULL, NULL, NULL, 'STRUCTURAL MAINTENANCE OF CHROMOSOMES SMC FAMILY MEMBER', NULL, NULL, NULL, 8),
(247006, NULL, 'PTHR38794', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(247007, NULL, 'PTHR28089', NULL, NULL, NULL, NULL, 'PROTEIN ZDS1-RELATED', NULL, NULL, 31152, 8),
(247008, NULL, 'PTHR31207', NULL, NULL, NULL, NULL, 'ECA1 GAMETOGENESIS FAMILY PROTEIN (DUF784)-RELATED-RELATED', NULL, NULL, 31343, 8),
(247009, NULL, 'PTHR34978', NULL, NULL, NULL, NULL, 'POSSIBLE SENSOR-TRANSDUCER PROTEIN BLAR', NULL, NULL, NULL, 8),
(247010, NULL, 'PTHR24421', NULL, NULL, NULL, NULL, 'NITRATE/NITRITE SENSOR PROTEIN NARX-RELATED', NULL, NULL, NULL, 8),
(247011, NULL, 'PTHR35686', NULL, NULL, NULL, NULL, 'KINETOCHORE PROTEIN', NULL, NULL, NULL, 8),
(247012, NULL, 'PTHR47048', NULL, NULL, NULL, NULL, 'PROTEIN SCAF11', NULL, NULL, NULL, 8),
(247013, NULL, 'PTHR38592', NULL, NULL, NULL, NULL, 'BLL4819 PROTEIN', NULL, NULL, 12223, 8),
(247014, NULL, 'PTHR47087', NULL, NULL, NULL, NULL, 'METHIONINE S-METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(247015, NULL, 'PTHR15396', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P PROTEIN SUBUNIT P40', NULL, NULL, 17856, 8),
(247016, NULL, 'PTHR36122', NULL, NULL, NULL, NULL, 'NICOTINAMIDE RIBOSIDE TRANSPORTER PNUC', NULL, NULL, 6860, 8),
(247017, NULL, 'PTHR43150', NULL, NULL, NULL, NULL, 'HYPERKINETIC, ISOFORM M', NULL, NULL, 7198, 8),
(247018, NULL, 'PTHR31101', NULL, NULL, NULL, NULL, 'UPF0547 PROTEIN C16ORF87', NULL, NULL, 31677, 8),
(247019, NULL, 'PTHR46127', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 65', NULL, NULL, NULL, 8),
(247020, NULL, 'PTHR30536', NULL, NULL, NULL, NULL, 'ALTRONATE/GALACTARATE DEHYDRATASE', NULL, NULL, NULL, 8),
(247021, NULL, 'PTHR12598', NULL, NULL, NULL, NULL, 'COPPER HOMEOSTASIS PROTEIN CUTC', NULL, NULL, 2572, 8),
(247022, NULL, 'PTHR33154', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, ARSR FAMILY', NULL, NULL, NULL, 8),
(247023, NULL, 'PTHR46716', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 7', NULL, NULL, 18486, 8),
(247024, NULL, 'PTHR34485', NULL, NULL, NULL, NULL, 'PROLINE-RICH, LACRIMAL 1', NULL, NULL, NULL, 8),
(247025, NULL, 'PTHR46474', NULL, NULL, NULL, NULL, 'TWO PORE CALCIUM CHANNEL PROTEIN 1', NULL, NULL, 23710, 8),
(247026, NULL, 'PTHR42737', NULL, NULL, NULL, NULL, 'GLUTATHIONE REDUCTASE', NULL, NULL, NULL, 8),
(247027, NULL, 'PTHR46382', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE CYTIDYLYLTRANSFERASE', NULL, NULL, NULL, 8),
(247028, NULL, 'PTHR40076', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', NULL, NULL, 9188, 8),
(247029, NULL, 'PTHR24129', NULL, NULL, NULL, NULL, 'ANKYCORBIN', NULL, NULL, 34248, 8),
(247030, NULL, 'PTHR45749', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(247031, NULL, 'PTHR23255', NULL, NULL, NULL, NULL, 'TRANSFORMING GROWTH FACTOR-BETA RECEPTOR TYPE I AND II', NULL, NULL, 4752, 8),
(247032, NULL, 'PTHR31110', NULL, NULL, NULL, NULL, 'PESTICIDAL CRYSTAL CRY8BA PROTEIN', NULL, NULL, NULL, 8),
(247033, NULL, 'PTHR37721', NULL, NULL, NULL, NULL, 'OS05G0464200 PROTEIN', NULL, NULL, NULL, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(247034, NULL, 'PTHR43826', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATE EXCHANGER SLC37A4', NULL, NULL, NULL, 8),
(247035, NULL, 'PTHR37783', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G04315)-RELATED', NULL, NULL, NULL, 8),
(247036, NULL, 'PTHR13162', NULL, NULL, NULL, NULL, 'CCR4-NOT TRANSCRIPTION COMPLEX', NULL, NULL, 27771, 8),
(247037, NULL, 'PTHR12052', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE PROTEN 4A, 4B', NULL, NULL, 1589, 8),
(247038, NULL, 'PTHR15096', NULL, NULL, NULL, NULL, 'PROLACTIN-INDUCIBLE PROTEIN/SEMINAL VESICLE ANTIGEN', NULL, NULL, 4216, 8),
(247039, NULL, 'PTHR36707', NULL, NULL, NULL, NULL, 'T20M3.17 PROTEIN', NULL, NULL, NULL, 8),
(247040, NULL, 'PTHR11214', NULL, NULL, NULL, NULL, 'BETA-1,3-N-ACETYLGLUCOSAMINYLTRANSFERASE', NULL, NULL, 2626, 8),
(247041, NULL, 'PTHR40588', NULL, NULL, NULL, NULL, 'MRNA INTERFERASE TOXIN YAFQ', NULL, NULL, 5589, 8),
(247042, NULL, 'PTHR46010', NULL, NULL, NULL, NULL, 'PROTEIN IWS1 HOMOLOG', NULL, NULL, NULL, 8),
(247043, NULL, 'PTHR47293', NULL, NULL, NULL, NULL, 'JACALIN-RELATED LECTIN 3', NULL, NULL, NULL, 8),
(247044, NULL, 'PTHR23407', NULL, NULL, NULL, NULL, 'ATPASE INHIBITOR/5-FORMYLTETRAHYDROFOLATE CYCLO-LIGASE', NULL, NULL, NULL, 8),
(247045, NULL, 'PTHR43345', NULL, NULL, NULL, NULL, '3-ISOPROPYLMALATE DEHYDRATASE SMALL SUBUNIT 2-RELATED-RELATED', NULL, NULL, NULL, 8),
(247046, NULL, 'PTHR46205', NULL, NULL, NULL, NULL, 'LOQUACIOUS, ISOFORM B', NULL, NULL, NULL, 8),
(247047, NULL, 'PTHR21740', NULL, NULL, NULL, NULL, 'NCK-ASSOCIATED PROTEIN 5', NULL, NULL, 22771, 8),
(247048, NULL, 'PTHR47666', NULL, NULL, NULL, NULL, 'PROTEIN VASCULAR ASSOCIATED DEATH 1, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(247049, NULL, 'PTHR43199', NULL, NULL, NULL, NULL, 'GLUTATHIONE HYDROLASE', NULL, NULL, NULL, 8),
(247050, NULL, 'PTHR12566', NULL, NULL, NULL, NULL, 'CYTOPLASMIC POLYADENYLATION ELEMENT BINDING PROTEIN  CPEB', NULL, NULL, 33368, 8),
(247051, NULL, 'PTHR13468', NULL, NULL, NULL, NULL, 'DEK PROTEIN', NULL, NULL, 34927, 8),
(247052, NULL, 'PTHR47068', NULL, NULL, NULL, NULL, 'OS02G0659100 PROTEIN', NULL, NULL, NULL, 8),
(247053, NULL, 'PTHR48035', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN 1', NULL, NULL, NULL, 8),
(247054, NULL, 'PTHR32422', NULL, NULL, NULL, NULL, 'ADHERENS JUNCTION-ASSOCIATED PROTEIN 1', NULL, NULL, 32890, 8),
(247055, NULL, 'PTHR34669', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE FOLD DOMAIN-CONTAINING PROTEIN MRL7L, CHLOROPLASTIC', NULL, NULL, 34095, 8),
(247056, NULL, 'PTHR48179', NULL, NULL, NULL, NULL, 'OS08G0232201 PROTEIN', NULL, NULL, NULL, 8),
(247057, NULL, 'PTHR11849', NULL, NULL, NULL, NULL, 'ETS', NULL, NULL, 36624, 8),
(247058, NULL, 'PTHR21164', NULL, NULL, NULL, NULL, 'CHORISMATE MUTASE', NULL, NULL, 900, 8),
(247059, NULL, 'PTHR11671', NULL, NULL, NULL, NULL, 'V-TYPE ATP SYNTHASE SUBUNIT D', NULL, NULL, 3948, 8),
(247060, NULL, 'PTHR46124', NULL, NULL, NULL, NULL, 'D-AMINOACYL-TRNA DEACYLASE', NULL, NULL, NULL, 8),
(247061, NULL, 'PTHR24189', NULL, NULL, NULL, NULL, 'MYOTROPHIN', NULL, NULL, NULL, 8),
(247062, NULL, 'PTHR33433', NULL, NULL, NULL, NULL, 'FLOWERING-PROMOTING FACTOR 1-LIKE PROTEIN 1', NULL, NULL, 30632, 8),
(247063, NULL, 'PTHR24203', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', NULL, NULL, NULL, 8),
(247064, NULL, 'PTHR41910', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE 2 MEMBRANE SUBUNIT SDHC', NULL, NULL, 31985, 8),
(247065, NULL, 'PTHR14375', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 24804, 8),
(247066, NULL, 'PTHR31400', NULL, NULL, NULL, NULL, 'GUANYLYL CYCLASE DOMAIN CONTAINING PROTEIN 1 GUCD1', NULL, NULL, 16059, 8),
(247067, NULL, 'PTHR36179', NULL, NULL, NULL, NULL, 'LUD_DOM DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(247068, NULL, 'PTHR14338', NULL, NULL, NULL, NULL, 'ACTIN FILAMENT-ASSOCIATED PROTEIN 1 FAMILY MEMBER', NULL, NULL, 22056, 8),
(247069, NULL, 'PTHR14194', NULL, NULL, NULL, NULL, 'NITROGEN METABOLIC REGULATION PROTEIN NMR-RELATED', NULL, NULL, 35135, 8),
(247070, NULL, 'PTHR34197', NULL, NULL, NULL, NULL, 'OS04G0591300 PROTEIN', NULL, NULL, NULL, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(247071, NULL, 'PTHR35353', NULL, NULL, NULL, NULL, 'OSTEOCRIN', NULL, NULL, 15312, 8),
(247072, NULL, 'PTHR23102', NULL, NULL, NULL, NULL, 'CLEAVAGE AND POLYADENYLATION SPECIFICITY FACTOR SUBUNIT 4-RELATED', NULL, NULL, 34796, 8),
(247073, NULL, 'PTHR35604', NULL, NULL, NULL, NULL, 'TRANSPOSASE INSH FOR INSERTION SEQUENCE ELEMENT IS5A-RELATED', NULL, NULL, NULL, 8),
(247074, NULL, 'PTHR19241', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE TRANSPORTER', NULL, NULL, NULL, 8),
(247075, NULL, 'PTHR21584', NULL, NULL, NULL, NULL, 'DIFFERENTIAL DISPLAY AND ACTIVATED BY P53  DDA3 /G2 S PHASE EXPRESSED 1', NULL, NULL, 25036, 8),
(247076, NULL, 'PTHR34651', NULL, NULL, NULL, NULL, 'SIMILAR TO ENSANGP00000021391', NULL, NULL, 21984, 8),
(247077, NULL, 'PTHR10309', NULL, NULL, NULL, NULL, 'MANNOSE-6-PHOSPHATE ISOMERASE', NULL, NULL, 19578, 8),
(247078, NULL, 'PTHR43500', NULL, NULL, NULL, NULL, 'CYSTATHIONINE BETA-LYASE-RELATED', NULL, NULL, 3206, 8),
(247079, NULL, 'PTHR39200', NULL, NULL, NULL, NULL, 'HYPOTHETICAL EXPORTED PROTEIN', NULL, NULL, NULL, 8),
(247080, NULL, 'PTHR43020', NULL, NULL, NULL, NULL, 'CDK5 REGULATORY SUBUNIT-ASSOCIATED PROTEIN 1', NULL, NULL, NULL, 8),
(247081, NULL, 'PTHR19423', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-BINDING PROTEIN 5', NULL, NULL, 4434, 8),
(247082, NULL, 'PTHR13313', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT VIIC', NULL, NULL, 2700, 8),
(247083, NULL, 'PTHR46962', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE KIST', NULL, NULL, 30705, 8),
(247084, NULL, 'PTHR30485', NULL, NULL, NULL, NULL, 'NI/FE-HYDROGENASE 1 B-TYPE CYTOCHROME SUBUNIT', NULL, NULL, NULL, 8),
(247085, NULL, 'PTHR43146', NULL, NULL, NULL, NULL, 'CANCER-RELATED NUCLEOSIDE-TRIPHOSPHATASE', NULL, NULL, 2519, 8),
(247086, NULL, 'PTHR47793', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE COMPLEX SUBUNIT CTI6', NULL, NULL, NULL, 8),
(247087, NULL, 'PTHR44375', NULL, NULL, NULL, NULL, 'BETA-KETOACYL-ACP REDUCTASE-LIKE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(247088, NULL, 'PTHR28127', NULL, NULL, NULL, NULL, 'RIBOSOME ASSEMBLY PROTEIN 3', NULL, NULL, NULL, 8),
(247089, NULL, 'PTHR46730', NULL, NULL, NULL, NULL, 'POLYCYSTIN-1', NULL, NULL, NULL, 8),
(247090, NULL, 'PTHR34985', NULL, NULL, NULL, NULL, 'SLR0554 PROTEIN', NULL, NULL, NULL, 8),
(247091, NULL, 'PTHR26452', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR', NULL, NULL, NULL, 8),
(247092, NULL, 'PTHR22654', NULL, NULL, NULL, NULL, 'G PROTEIN PATHWAY SUPPRESSOR 2', NULL, NULL, 25049, 8),
(247093, NULL, 'PTHR14611', NULL, NULL, NULL, NULL, 'TECTONIC FAMILY MEMBER', NULL, NULL, 27631, 8),
(247094, NULL, 'PTHR28638', NULL, NULL, NULL, NULL, 'CELL CYCLE PROGRESSION PROTEIN 1', NULL, NULL, NULL, 8),
(247095, NULL, 'PTHR36884', NULL, NULL, NULL, NULL, 'FIP1[III]-LIKE PROTEIN', NULL, NULL, 35557, 8),
(247096, NULL, 'PTHR34436', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN M', NULL, NULL, 20337, 8),
(247097, NULL, 'PTHR11993', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE 49 KDA SUBUNIT', NULL, NULL, 14853, 8),
(247098, NULL, 'PTHR48160', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(247099, NULL, 'PTHR38139', NULL, NULL, NULL, NULL, 'GATE DOMAIN-CONTAINING PROTEIN', NULL, NULL, 32304, 8),
(247100, NULL, 'PTHR12601', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT  EIF-3', NULL, NULL, 23445, 8),
(247101, NULL, 'PTHR43445', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLMURAMATE--L-ALANINE LIGASE-RELATED', NULL, NULL, NULL, 8),
(247102, NULL, 'PTHR16247', NULL, NULL, NULL, NULL, 'RIKEN CDNA 9430015G10 GENE', NULL, NULL, 25601, 8),
(247103, NULL, 'PTHR35494', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT S, CHLOROPLASTIC', NULL, NULL, 18769, 8),
(247104, NULL, 'PTHR31501', NULL, NULL, NULL, NULL, 'CALCIUM RELEASE-ACTIVATED CALCIUM CHANNEL PROTEIN 1', NULL, NULL, 14433, 8),
(247105, NULL, 'PTHR24041', NULL, NULL, NULL, NULL, 'MUCIN', NULL, NULL, NULL, 8),
(247106, NULL, 'PTHR32344', NULL, NULL, NULL, NULL, 'U1-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, 29551, 8),
(247107, NULL, 'PTHR34683', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', NULL, NULL, NULL, 8);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(247108, NULL, 'PTHR34148', NULL, NULL, NULL, NULL, 'ADENOSYLCOBINAMIDE-GDP RIBAZOLETRANSFERASE', NULL, NULL, 3183, 8),
(247109, NULL, 'PTHR39180', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(247110, NULL, 'PTHR45779', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', NULL, NULL, 34918, 8),
(247111, NULL, 'PTHR47025', NULL, NULL, NULL, NULL, 'AUTOIMMUNE REGULATOR', NULL, NULL, NULL, 8),
(247112, NULL, 'PTHR33474', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(247113, NULL, 'PTHR11866', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR FAMILY 1 MEMBER', NULL, NULL, 7730, 8),
(247114, NULL, 'PTHR12465', NULL, NULL, NULL, NULL, 'UBIQUITIN SPECIFIC PROTEASE HOMOLOG 49', NULL, NULL, 14317, 8),
(247115, NULL, 'PTHR12595', NULL, NULL, NULL, NULL, 'POS9-ACTIVATING FACTOR FAP7-RELATED', NULL, NULL, 20013, 8),
(247116, NULL, 'PTHR12681', NULL, NULL, NULL, NULL, 'ZINC FINGER-CONTAINING PROTEIN P48ZNF', NULL, NULL, NULL, 8),
(247117, NULL, 'PTHR12507', NULL, NULL, NULL, NULL, 'REDUCED GROWTH PHENOTYPE 1  RGP1, YEAST -RELATED', NULL, NULL, 11807, 8),
(247118, NULL, 'PTHR22749', NULL, NULL, NULL, NULL, 'RIBOFLAVIN KINASE/FMN ADENYLYLTRANSFERASE', NULL, NULL, 16379, 8),
(247119, NULL, 'PTHR23183', NULL, NULL, NULL, NULL, 'NOP14', NULL, NULL, 7209, 8),
(247120, NULL, 'PTHR15929', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 573, 8),
(247121, NULL, 'PTHR43360', NULL, NULL, NULL, NULL, 'CARBON DIOXIDE CONCENTRATING MECHANISM PROTEIN CCMM', NULL, NULL, NULL, 8),
(247122, NULL, 'PTHR15315', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 41, 151', NULL, NULL, NULL, 8),
(247123, NULL, 'PTHR35662', NULL, NULL, NULL, NULL, 'INTERACTOR OF HORMAD1 PROTEIN 1', NULL, NULL, 25243, 8),
(247124, NULL, 'PTHR43079', NULL, NULL, NULL, NULL, 'PROBABLE CADMIUM/ZINC-TRANSPORTING ATPASE HMA1', NULL, NULL, NULL, 8),
(247125, NULL, 'PTHR15715', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 170 KDA', NULL, NULL, NULL, 8),
(247126, NULL, 'PTHR43094', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE', NULL, NULL, NULL, 8),
(247127, NULL, 'PTHR16510', NULL, NULL, NULL, NULL, 'EXTRACELLULAR MATRIX PHOSPHOGLYCOPROTEIN WITH ASARM MOTIF', NULL, NULL, 13243, 8),
(247128, NULL, 'PTHR46489', NULL, NULL, NULL, NULL, 'STEROIDOGENIC ACUTE REGULATORY PROTEIN, MITOCHONDRIAL', NULL, NULL, 22218, 8),
(247129, NULL, 'PTHR45642', NULL, NULL, NULL, NULL, 'GDSL ESTERASE/LIPASE EXL3', NULL, NULL, NULL, 8),
(247130, NULL, 'PTHR15239', NULL, NULL, NULL, NULL, 'NUCLEAR EXPORT MEDIATOR FACTOR NEMF', NULL, NULL, NULL, 8),
(247131, NULL, 'PTHR47653', NULL, NULL, NULL, NULL, 'PROTEIN BARK BEETLE', NULL, NULL, NULL, 8),
(247132, NULL, 'PTHR38036', NULL, NULL, NULL, NULL, 'UPF0250 PROTEIN YBED', NULL, NULL, 4894, 8),
(247133, NULL, 'PTHR23045', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 37A', NULL, NULL, 11562, 8),
(247134, NULL, 'PTHR11161', NULL, NULL, NULL, NULL, 'O-ACYLTRANSFERASE', NULL, NULL, NULL, 8),
(247135, NULL, 'PTHR33451', NULL, NULL, NULL, NULL, 'MALATE-2H(+)/NA(+)-LACTATE ANTIPORTER', NULL, NULL, NULL, 8),
(247136, NULL, 'PTHR24018', NULL, NULL, NULL, NULL, 'ELASTIN', NULL, NULL, 7204, 8),
(247137, NULL, 'PTHR12736', NULL, NULL, NULL, NULL, 'LANC-LIKE PROTEIN', NULL, NULL, NULL, 8),
(247138, NULL, 'PTHR32322', NULL, NULL, NULL, NULL, 'INNER MEMBRANE TRANSPORTER', NULL, NULL, NULL, 8),
(247139, NULL, 'PTHR16296', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED HYPOTHALAMUS PROTEIN HT007', NULL, NULL, 13047, 8),
(247140, NULL, 'PTHR31147', NULL, NULL, NULL, NULL, 'ACYL TRANSFERASE 4', NULL, NULL, NULL, 8),
(247141, NULL, 'PTHR47913', NULL, NULL, NULL, NULL, 'OS01G0167750 PROTEIN', NULL, NULL, 36210, 8),
(247142, NULL, 'PTHR46250', NULL, NULL, NULL, NULL, 'MYB/SANT-LIKE DNA-BINDING DOMAIN PROTEIN-RELATED', NULL, NULL, NULL, 8),
(247143, NULL, 'PTHR15528', NULL, NULL, NULL, NULL, 'PEROXISOME PROLIFERATOR ACTIVATED RECEPTOR GAMMA COACTIVATOR 1  PGC-1 -RELATED', NULL, NULL, 1358, 8),
(247144, NULL, 'PTHR14540', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 26111, 8),
(247145, NULL, 'PTHR43496', NULL, NULL, NULL, NULL, 'PROTEIN LPLB', NULL, NULL, NULL, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(247146, NULL, 'PTHR43381', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR IF-2-RELATED', NULL, NULL, 11993, 8),
(247147, NULL, 'PTHR24025', NULL, NULL, NULL, NULL, 'DESMOGLEIN FAMILY MEMBER', NULL, NULL, NULL, 8),
(247148, NULL, 'PTHR38790', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(247149, NULL, 'PTHR31200', NULL, NULL, NULL, NULL, 'INO80 COMPLEX SUBUNIT C', NULL, NULL, 23719, 8),
(247150, NULL, 'PTHR12093', NULL, NULL, NULL, NULL, 'NCK-ASSOCIATED PROTEIN 1', NULL, NULL, 17647, 8),
(247151, NULL, 'PTHR21364', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(247152, NULL, 'PTHR36699', NULL, NULL, NULL, NULL, 'LD-TRANSPEPTIDASE', NULL, NULL, NULL, 8),
(247153, NULL, 'PTHR15283', NULL, NULL, NULL, NULL, 'GREMLIN 1', NULL, NULL, NULL, 8),
(247154, NULL, 'PTHR23399', NULL, NULL, NULL, NULL, 'DEOXYNUCLEOTIDYLTRANSFERASE TERMINAL-INTERACTING PROTEIN 1', NULL, NULL, 21815, 8),
(247155, NULL, 'PTHR39952', NULL, NULL, NULL, NULL, 'FI02073P', NULL, NULL, NULL, 8),
(247156, NULL, 'PTHR32196', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN YPHD-RELATED-RELATED', NULL, NULL, NULL, 8),
(247157, NULL, 'PTHR11451', NULL, NULL, NULL, NULL, 'THREONINE-TRNA LIGASE', NULL, NULL, NULL, 8),
(247158, NULL, 'PTHR12770', NULL, NULL, NULL, NULL, 'RUS1 FAMILY PROTEIN C16ORF58', NULL, NULL, 5720, 8),
(247159, NULL, 'PTHR11686', NULL, NULL, NULL, NULL, 'GAMMA GLUTAMYL TRANSPEPTIDASE', NULL, NULL, 2662, 8),
(247160, NULL, 'PTHR21538', NULL, NULL, NULL, NULL, 'ANILLIN/RHOTEKIN  RTKN', NULL, NULL, NULL, 8),
(247161, NULL, 'PTHR22804', NULL, NULL, NULL, NULL, 'AGGRECAN/VERSICAN PROTEOGLYCAN', NULL, NULL, NULL, 8),
(247162, NULL, 'PTHR45989', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR EIF-2B SUBUNIT GAMMA', NULL, NULL, NULL, 8),
(247163, NULL, 'PTHR10165', NULL, NULL, NULL, NULL, 'LIPID PHOSPHATE PHOSPHATASE', NULL, NULL, 34955, 8),
(247164, NULL, 'PTHR33714', NULL, NULL, NULL, NULL, 'COUNTING FACTOR-ASSOCIATED PROTEIN A-RELATED', NULL, NULL, NULL, 8),
(247165, NULL, 'PTHR12774', NULL, NULL, NULL, NULL, 'PEROXISOMAL BIOGENESIS FACTOR 19', NULL, NULL, 2175, 8),
(247166, NULL, 'PTHR11276', NULL, NULL, NULL, NULL, 'DNA POLYMERASE TYPE-X FAMILY MEMBER', NULL, NULL, 15639, 8),
(247167, NULL, 'PTHR44115', NULL, NULL, NULL, NULL, 'PROTEIN CBG09704', NULL, NULL, NULL, 8),
(247168, NULL, 'PTHR15131', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RNA ACTIVATING COMPLEX, POLYPEPTIDE 1', NULL, NULL, 18308, 8),
(247169, NULL, 'PTHR15204', NULL, NULL, NULL, NULL, 'LARGE PROLINE-RICH PROTEIN BAG6', NULL, NULL, NULL, 8),
(247170, NULL, 'PTHR39461', NULL, NULL, NULL, NULL, 'LEA DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_8G04920)', NULL, NULL, NULL, 8),
(247171, NULL, 'PTHR18863', NULL, NULL, NULL, NULL, 'TSEC-2-RELATED', NULL, NULL, 29127, 8),
(247172, NULL, 'PTHR13043', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT SEC5', NULL, NULL, 26730, 8),
(247173, NULL, 'PTHR36169', NULL, NULL, NULL, NULL, 'ETHANOLAMINE UTILIZATION PROTEIN EUTQ', NULL, NULL, 9166, 8),
(247174, NULL, 'PTHR30295', NULL, NULL, NULL, NULL, 'BACTERIOFERRITIN', NULL, NULL, NULL, 8),
(247175, NULL, 'PTHR14795', NULL, NULL, NULL, NULL, 'HELICASE RELATED', NULL, NULL, NULL, 8),
(247176, NULL, 'PTHR18821', NULL, NULL, NULL, NULL, 'PROKINETICIN', NULL, NULL, 9675, 8),
(247177, NULL, 'PTHR34183', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(247178, NULL, 'PTHR36887', NULL, NULL, NULL, NULL, 'OS01G0532300 PROTEIN', NULL, NULL, NULL, 8),
(247179, NULL, 'PTHR21599', NULL, NULL, NULL, NULL, 'GLYCERATE KINASE', NULL, NULL, 5633, 8),
(247180, NULL, 'PTHR13383', NULL, NULL, NULL, NULL, 'RIBONUCLEASE H2 SUBUNIT B', NULL, NULL, 32933, 8),
(247181, NULL, 'PTHR37812', NULL, NULL, NULL, NULL, 'MU-LIKE PROPHAGE FLUMU PROTEIN C', NULL, NULL, NULL, 8),
(247182, NULL, 'PTHR35111', NULL, NULL, NULL, NULL, 'F10A5.9-RELATED', NULL, NULL, NULL, 8),
(247183, NULL, 'PTHR21101', NULL, NULL, NULL, NULL, 'RESISTIN', NULL, NULL, 12402, 8),
(247184, NULL, 'PTHR43238', NULL, NULL, NULL, NULL, 'GDP-L-FUCOSE SYNTHASE', NULL, NULL, NULL, 8),
(247185, NULL, 'PTHR13734', NULL, NULL, NULL, NULL, 'TRNA-NUCLEOTIDYLTRANSFERASE', NULL, NULL, NULL, 8);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(247186, NULL, 'PTHR19256', NULL, NULL, NULL, NULL, 'T-CELL RECEPTOR GAMMA CHAIN', NULL, NULL, NULL, 8),
(247187, NULL, 'PTHR12674', NULL, NULL, NULL, NULL, 'PREFOLDIN SUBUNIT 5', NULL, NULL, 10037, 8),
(247188, NULL, 'PTHR37541', NULL, NULL, NULL, NULL, 'SRP40_C DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(247189, NULL, 'PTHR36840', NULL, NULL, NULL, NULL, 'BLL5714 PROTEIN', NULL, NULL, 9219, 8),
(247190, NULL, 'PTHR36001', NULL, NULL, NULL, NULL, 'CTAGE FAMILY PROTEIN-RELATED', NULL, NULL, NULL, 8),
(247191, NULL, 'PTHR34387', NULL, NULL, NULL, NULL, 'SLR1258 PROTEIN', NULL, NULL, NULL, 8),
(247192, NULL, 'PTHR47876', NULL, NULL, NULL, NULL, 'OS08G0260000 PROTEIN', NULL, NULL, NULL, 8),
(247193, NULL, 'PTHR10176', NULL, NULL, NULL, NULL, 'GLYCOGEN SYNTHASE', NULL, NULL, 14033, 8),
(247194, NULL, 'PTHR22939', NULL, NULL, NULL, NULL, 'SERINE PROTEASE FAMILY S1C HTRA-RELATED', NULL, NULL, NULL, 8),
(247195, NULL, 'PTHR37174', NULL, NULL, NULL, NULL, 'FORKHEAD-ASSOCIATED DOMAIN PROTEIN', NULL, NULL, NULL, 8),
(247196, NULL, 'PTHR36720', NULL, NULL, NULL, NULL, 'TAF RNA POLYMERASE I SUBUNIT A', NULL, NULL, NULL, 8),
(247197, NULL, 'PTHR31896', NULL, NULL, NULL, NULL, 'FAMILY REGULATORY PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G14730)-RELATED', NULL, NULL, NULL, 8),
(247198, NULL, 'PTHR46261', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP B PROTEIN 4-RELATED', NULL, NULL, 22640, 8),
(247199, NULL, 'PTHR39476', NULL, NULL, NULL, NULL, 'NADH:UBIQUINONE OXIDOREDUCTASE 6.6KD SUBUNIT', NULL, NULL, NULL, 8),
(247200, NULL, 'PTHR25465', NULL, NULL, NULL, NULL, 'B-BOX DOMAIN CONTAINING', NULL, NULL, NULL, 8),
(247201, NULL, 'PTHR46266', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TT8', NULL, NULL, NULL, 8),
(247202, NULL, 'PTHR11413', NULL, NULL, NULL, NULL, 'CYSTATIN FAMILY MEMBER', NULL, NULL, 26845, 8),
(247203, NULL, 'PTHR44742', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(247204, NULL, 'PTHR33306', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED-RELATED', NULL, NULL, NULL, 8),
(247205, NULL, 'PTHR43318', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE 4,6-DEHYDRATASE', NULL, NULL, NULL, 8),
(247206, NULL, 'PTHR28584', NULL, NULL, NULL, NULL, 'FAMILY WITH SEQUENCE SIMILARITY 228 MEMBER A', NULL, NULL, 31437, 8),
(247207, NULL, 'PTHR35810', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', NULL, NULL, NULL, 8),
(247208, NULL, 'PTHR22442', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 23620, 8),
(247209, NULL, 'PTHR43519', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE HRPB', NULL, NULL, NULL, 8),
(247210, NULL, 'PTHR46278', NULL, NULL, NULL, NULL, 'DEHYDROGENASE, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(247211, NULL, 'PTHR33471', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT ZINC METALLOPROTEASE-RELATED', NULL, NULL, NULL, 8),
(247212, NULL, 'PTHR11104', NULL, NULL, NULL, NULL, 'AMINOGLYCOSIDE N3-ACETYLTRANSFERASE', NULL, NULL, 1188, 8),
(247213, NULL, 'PTHR24197', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 61', NULL, NULL, NULL, 8),
(247214, NULL, 'PTHR10211', NULL, NULL, NULL, NULL, 'DEOXYRIBODIPYRIMIDINE PHOTOLYASE', NULL, NULL, NULL, 8),
(247215, NULL, 'PTHR47635', NULL, NULL, NULL, NULL, 'CUB DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(247216, NULL, 'PTHR12091', NULL, NULL, NULL, NULL, 'MELANIN-CONCENTRATING HORMONE', NULL, NULL, 651, 8),
(247217, NULL, 'PTHR12454', NULL, NULL, NULL, NULL, 'TRIMERIC INTRACELLULAR CATION CHANNEL', NULL, NULL, 3028, 8),
(247218, NULL, 'PTHR47281', NULL, NULL, NULL, NULL, 'OS09G0557700 PROTEIN', NULL, NULL, 36923, 8),
(247219, NULL, 'PTHR37971', NULL, NULL, NULL, NULL, 'ANTIBACTERIAL FACTOR-RELATED PEPTIDE 1-RELATED', NULL, NULL, 24162, 8),
(247220, NULL, 'PTHR44858', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 6', NULL, NULL, NULL, 8),
(247221, NULL, 'PTHR47498', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 2 MEMBER L', NULL, NULL, NULL, 8),
(247222, NULL, 'PTHR36035', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE SCO2', NULL, NULL, 31913, 8),
(247223, NULL, 'PTHR46027', NULL, NULL, NULL, NULL, 'PEROXISOMAL TARGETING SIGNAL 2 RECEPTOR', NULL, NULL, 34661, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(247224, NULL, 'PTHR30592', NULL, NULL, NULL, NULL, 'FORMATE DEHYDROGENASE', NULL, NULL, 3222, 8),
(247225, NULL, 'PTHR13341', NULL, NULL, NULL, NULL, 'MIR-INTERACTING SAPOSIN-LIKE PROTEIN', NULL, NULL, 34097, 8),
(247226, NULL, 'PTHR30575', NULL, NULL, NULL, NULL, 'PEPTIDASE M20', NULL, NULL, NULL, 8),
(247227, NULL, 'PTHR46374', NULL, NULL, NULL, NULL, 'PROTEIN CBG07384', NULL, NULL, 34479, 8),
(247228, NULL, 'PTHR36377', NULL, NULL, NULL, NULL, 'DNA MISMATCH REPAIR PROTEIN', NULL, NULL, NULL, 8),
(247229, NULL, 'PTHR33986', NULL, NULL, NULL, NULL, 'OS02G0535700 PROTEIN', NULL, NULL, 14208, 8),
(247230, NULL, 'PTHR33993', NULL, NULL, NULL, NULL, 'GLYOXALASE-RELATED', NULL, NULL, NULL, 8),
(247231, NULL, 'PTHR38652', NULL, NULL, NULL, NULL, 'INTERLEUKIN-31', NULL, NULL, 25466, 8),
(247232, NULL, 'PTHR11927', NULL, NULL, NULL, NULL, 'GALACTOSIDE 2-L-FUCOSYLTRANSFERASE', NULL, NULL, 917, 8),
(247233, NULL, 'PTHR35869', NULL, NULL, NULL, NULL, 'OUTER-MEMBRANE LIPOPROTEIN CARRIER PROTEIN', NULL, NULL, 617, 8),
(247234, NULL, 'PTHR43160', NULL, NULL, NULL, NULL, 'ACONITATE HYDRATASE B', NULL, NULL, NULL, 8),
(247235, NULL, 'PTHR35538', NULL, NULL, NULL, NULL, 'LIG_CHAN-GLU_BD DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(247236, NULL, 'PTHR34538', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(247237, NULL, 'PTHR15623', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED SERINE-RICH PROTEIN 2-RELATED', NULL, NULL, 13009, 8),
(247238, NULL, 'PTHR15107', NULL, NULL, NULL, NULL, 'RETINOBLASTOMA BINDING PROTEIN 8', NULL, NULL, 31641, 8),
(247239, NULL, 'PTHR37950', NULL, NULL, NULL, NULL, '4-HYDROXYPHENYLACETATE CATABOLISM PROTEIN', NULL, NULL, 3966, 8),
(247240, NULL, 'PTHR15141', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR B POLYPEPTIDE 3', NULL, NULL, NULL, 8),
(247241, NULL, 'PTHR23129', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 15927, 8),
(247242, NULL, 'PTHR33357', NULL, NULL, NULL, NULL, 'METALLOTHIONEIN-LIKE PROTEIN 3', NULL, NULL, 34924, 8),
(247243, NULL, 'PTHR30590', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(247244, NULL, 'PTHR46058', NULL, NULL, NULL, NULL, 'PROTEIN BREVIS RADIX-LIKE 1', NULL, NULL, 34568, 8),
(247245, NULL, 'PTHR13312', NULL, NULL, NULL, NULL, 'HIV-INDUCED PROTEIN-7-LIKE PROTEASE', NULL, NULL, 29490, 8),
(247246, NULL, 'PTHR20955', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 13247, 8),
(247247, NULL, 'PTHR47686', NULL, NULL, NULL, NULL, 'SGS DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(247248, NULL, 'PTHR36530', NULL, NULL, NULL, NULL, 'INHIBITOR OF CYSTEINE PEPTIDASE', NULL, NULL, NULL, 8),
(247249, NULL, 'PTHR31805', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE KINASE, PUTATIVE (DUF1421)-RELATED', NULL, NULL, NULL, 8),
(247250, NULL, 'PTHR44080', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE COP1', NULL, NULL, 34960, 8),
(247251, NULL, 'PTHR34550', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S31, CHLOROPLASTIC', NULL, NULL, 34813, 8),
(247252, NULL, 'PTHR21456', NULL, NULL, NULL, NULL, 'FAMILY WITH SEQUENCE SIMILARITY 102', NULL, NULL, 30082, 8),
(247253, NULL, 'PTHR32254', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(247254, NULL, 'PTHR35758', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(247255, NULL, 'PTHR28202', NULL, NULL, NULL, NULL, 'ASSEMBLY FACTOR CBP4', NULL, NULL, 13497, 8),
(247256, NULL, 'PTHR14021', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER CO-CHAPERONE PROTEIN HSCB', NULL, NULL, 2252, 8),
(247257, NULL, 'PTHR11380', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID/SUPT3-RELATED', NULL, NULL, 4025, 8),
(247258, NULL, 'PTHR36131', NULL, NULL, NULL, NULL, 'KERATIN-ASSOCIATED PROTEIN 8-1', NULL, NULL, 33354, 8),
(247259, NULL, 'PTHR45085', NULL, NULL, NULL, NULL, 'F21J9.14', NULL, NULL, NULL, 8),
(247260, NULL, 'PTHR46469', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 8', NULL, NULL, 32896, 8),
(247261, NULL, 'PTHR23518', NULL, NULL, NULL, NULL, 'C-METHYLTRANSFERASE', NULL, NULL, NULL, 8);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(247262, NULL, 'PTHR43763', NULL, NULL, NULL, NULL, 'XAA-PRO AMINOPEPTIDASE 1', NULL, NULL, NULL, 8),
(247263, NULL, 'PTHR35451', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE-LIKE PROTEIN C4ORF48', NULL, NULL, 21599, 8),
(247264, NULL, 'PTHR13234', NULL, NULL, NULL, NULL, 'GAMMA-INTERFERON INDUCIBLE LYSOSOMAL THIOL REDUCTASE  GILT', NULL, NULL, 1767, 8),
(247265, NULL, 'PTHR28090', NULL, NULL, NULL, NULL, 'PROTEIN ROT1', NULL, NULL, 20640, 8),
(247266, NULL, 'PTHR21737', NULL, NULL, NULL, NULL, 'POLYGLUTAMINE BINDING PROTEIN 1/MARVEL  MEMBRANE-ASSOCIATING  DOMAIN CONTAINING 3', NULL, NULL, NULL, 8),
(247267, NULL, 'PTHR46749', NULL, NULL, NULL, NULL, 'COMPLEX III ASSEMBLY FACTOR LYRM7', NULL, NULL, NULL, 8),
(247268, NULL, 'PTHR42757', NULL, NULL, NULL, NULL, 'IGLON FAMILY OF IMMUNOGLOBULIN SUPERFAMILY-RELATED', NULL, NULL, NULL, 8),
(247269, NULL, 'PTHR12301', NULL, NULL, NULL, NULL, 'SAM-DOMAIN, SH3 AND NUCLEAR LOCALIZATION SIGNALS PROTEIN RELATED', NULL, NULL, NULL, 8),
(247270, NULL, 'PTHR47923', NULL, NULL, NULL, NULL, 'INSERTION ELEMENT IS1 1 PROTEIN INSA-RELATED', NULL, NULL, NULL, 8),
(247271, NULL, 'PTHR11632', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE 2 FLAVOPROTEIN SUBUNIT', NULL, NULL, 25504, 8),
(247272, NULL, 'PTHR15635', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN CONTAINING PROTEIN 9', NULL, NULL, 23637, 8),
(247273, NULL, 'PTHR13612', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(247274, NULL, 'PTHR37417', NULL, NULL, NULL, NULL, '67 KDA MYOSIN-CROSS-REACTIVE ANTIGEN FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_5G09970)', NULL, NULL, 8743, 8),
(247275, NULL, 'PTHR37166', NULL, NULL, NULL, NULL, 'PROTEIN FLAG', NULL, NULL, 5043, 8),
(247276, NULL, 'PTHR12874', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 48-RELATED', NULL, NULL, 36939, 8),
(247277, NULL, 'PTHR31431', NULL, NULL, NULL, NULL, 'NUCLEOPORIN NUP188 HOMOLOG', NULL, NULL, 36284, 8),
(247278, NULL, 'PTHR43021', NULL, NULL, NULL, NULL, 'NA(+)/H(+) ANTIPORTER-RELATED', NULL, NULL, NULL, 8),
(247279, NULL, 'PTHR45283', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT T, CHLOROPLASTIC', NULL, NULL, 36250, 8),
(247280, NULL, 'PTHR11581', NULL, NULL, NULL, NULL, '30S/40S RIBOSOMAL PROTEIN S4', NULL, NULL, 4627, 8),
(247281, NULL, 'PTHR42973', NULL, NULL, NULL, NULL, 'BINDING OXIDOREDUCTASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G17690)-RELATED', NULL, NULL, NULL, 8),
(247282, NULL, 'PTHR31310', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(247283, NULL, 'PTHR10664', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR-C.ELEGANS', NULL, NULL, NULL, 8),
(247284, NULL, 'PTHR22591', NULL, NULL, NULL, NULL, 'XIN', NULL, NULL, 25982, 8),
(247285, NULL, 'PTHR42909', NULL, NULL, NULL, NULL, 'ZGC:136858', NULL, NULL, NULL, 8),
(247286, NULL, 'PTHR35864', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEASE MJ0611-RELATED', NULL, NULL, NULL, 8),
(247287, NULL, 'PTHR30405', NULL, NULL, NULL, NULL, 'TRANSPOSASE', NULL, NULL, NULL, 8),
(247288, NULL, 'PTHR22546', NULL, NULL, NULL, NULL, 'PREMATURE OVARIAN FAILURE, 1B', NULL, NULL, 25032, 8),
(247289, NULL, 'PTHR15018', NULL, NULL, NULL, NULL, 'BCL-2-INTERACTING KILLER', NULL, NULL, 23188, 8),
(247290, NULL, 'PTHR24200', NULL, NULL, NULL, NULL, 'TOUCAN, ISOFORM A', NULL, NULL, NULL, 8),
(247291, NULL, 'PTHR13213', NULL, NULL, NULL, NULL, 'MYB-BINDING PROTEIN 1A FAMILY MEMBER', NULL, NULL, 6908, 8),
(247292, NULL, 'PTHR14015', NULL, NULL, NULL, NULL, 'OPIOID GROWTH FACTOR RECEPTOR  OGFR   ZETA-TYPE OPIOID RECEPTOR', NULL, NULL, 33801, 8),
(247293, NULL, 'PTHR46761', NULL, NULL, NULL, NULL, 'RAN GTPASE-ACTIVATING PROTEIN 1', NULL, NULL, 36603, 8),
(247294, NULL, 'PTHR13048', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT 3', NULL, NULL, 21463, 8),
(247295, NULL, 'PTHR10350', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP155', NULL, NULL, 7344, 8),
(247296, NULL, 'PTHR12573', NULL, NULL, NULL, NULL, 'AT09986P-RELATED', NULL, NULL, NULL, 8),
(247297, NULL, 'PTHR11588', NULL, NULL, NULL, NULL, 'TUBULIN', NULL, NULL, 1689, 8),
(247298, NULL, 'PTHR38589', NULL, NULL, NULL, NULL, 'BLR0621 PROTEIN', NULL, NULL, NULL, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(247299, NULL, 'PTHR19265', NULL, NULL, NULL, NULL, 'MEIOSIS-SPECIFIC NUCLEAR STRUCTURAL PROTEIN 1', NULL, NULL, 23157, 8),
(247300, NULL, 'PTHR46179', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', NULL, NULL, NULL, 8),
(247301, NULL, 'PTHR43359', NULL, NULL, NULL, NULL, 'FORMATE HYDROGENLYASE SUBUNIT 4', NULL, NULL, NULL, 8),
(247302, NULL, 'PTHR47845', NULL, NULL, NULL, NULL, 'NUCLEAR SPECKLE SPLICING REGULATORY PROTEIN 1 HOMOLOG', NULL, NULL, NULL, 8),
(247303, NULL, 'PTHR33541', NULL, NULL, NULL, NULL, 'PROTEIN BIG GRAIN 1-LIKE A-RELATED', NULL, NULL, 27184, 8),
(247304, NULL, 'PTHR46984', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 71', NULL, NULL, NULL, 8),
(247305, NULL, 'PTHR35568', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR DAUR', NULL, NULL, 30911, 8),
(247306, NULL, 'PTHR46868', NULL, NULL, NULL, NULL, 'FCS-LIKE ZINC FINGER 11', NULL, NULL, 36048, 8),
(247307, NULL, 'PTHR28639', NULL, NULL, NULL, NULL, 'BCL-2-BINDING COMPONENT 3', NULL, NULL, 26889, 8),
(247308, NULL, 'PTHR24135', NULL, NULL, NULL, NULL, 'SH3 AND MULTIPLE ANKYRIN REPEAT DOMAINS PROTEIN', NULL, NULL, NULL, 8),
(247309, NULL, 'PTHR37862', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA CORE COMPLEX-ASSOCIATED PROTEIN 20', NULL, NULL, NULL, 8),
(247310, NULL, 'PTHR30560', NULL, NULL, NULL, NULL, 'TRIGGER FACTOR CHAPERONE AND PEPTIDYL-PROLYL CIS/TRANS ISOMERASE', NULL, NULL, 10949, 8),
(247311, NULL, 'PTHR48031', NULL, NULL, NULL, NULL, 'SRA STEM-LOOP-INTERACTING RNA-BINDING PROTEIN, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(247312, NULL, 'PTHR10872', NULL, NULL, NULL, NULL, 'SH2B ADAPTER PROTEIN', NULL, NULL, 24598, 8),
(247313, NULL, 'PTHR46284', NULL, NULL, NULL, NULL, 'PROTEIN KINESIN LIGHT CHAIN-RELATED 3', NULL, NULL, NULL, 8),
(247314, NULL, 'PTHR38464', NULL, NULL, NULL, NULL, 'L-ARABINOSE ISOMERASE', NULL, NULL, 6372, 8),
(247315, NULL, 'PTHR31752', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER COMPONENT 1B-RELATED', NULL, NULL, NULL, 8),
(247316, NULL, 'PTHR24289', NULL, NULL, NULL, NULL, 'STEROID 17-ALPHA-HYDROXYLASE/17,20 LYASE', NULL, NULL, NULL, 8),
(247317, NULL, 'PTHR12409', NULL, NULL, NULL, NULL, 'PREFOLDIN SUBUNIT 3', NULL, NULL, 19780, 8),
(247318, NULL, 'PTHR39452', NULL, NULL, NULL, NULL, 'CHEY-P PHOSPHATASE CHEX', NULL, NULL, 32855, 8),
(247319, NULL, 'PTHR10562', NULL, NULL, NULL, NULL, 'SMALL UBIQUITIN-RELATED MODIFIER', NULL, NULL, NULL, 8),
(247320, NULL, 'PTHR12991', NULL, NULL, NULL, NULL, 'NITROGEN PERMEASE REGULATOR 2/TUMOR SUPPRESSOR CANDIDATE 4', NULL, NULL, 14161, 8),
(247321, NULL, 'PTHR10658', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL TRANSFER PROTEIN', NULL, NULL, 5023, 8),
(247322, NULL, 'PTHR43509', NULL, NULL, NULL, NULL, 'PTHR43509', NULL, NULL, NULL, 8),
(247323, NULL, 'PTHR10543', NULL, NULL, NULL, NULL, 'BETA-CAROTENE DIOXYGENASE', NULL, NULL, 4510, 8),
(247324, NULL, 'PTHR37866', NULL, NULL, NULL, NULL, 'PRE T-CELL ANTIGEN RECEPTOR ALPHA', NULL, NULL, 22009, 8),
(247325, NULL, 'PTHR13509', NULL, NULL, NULL, NULL, 'SEC61 SUBUNIT BETA', NULL, NULL, 22259, 8),
(247326, NULL, 'PTHR28585', NULL, NULL, NULL, NULL, 'TUBEROINFUNDIBULAR PEPTIDE OF 39 RESIDUES', NULL, NULL, 23039, 8),
(247327, NULL, 'PTHR15434', NULL, NULL, NULL, NULL, 'HEAT SHOCK FACTOR 2-BINDING PROTEIN', NULL, NULL, 33126, 8),
(247328, NULL, 'PTHR22588', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(247329, NULL, 'PTHR35692', NULL, NULL, NULL, NULL, 'F26F24.11', NULL, NULL, NULL, 8),
(247330, NULL, 'PTHR46967', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR BINDING PROTEIN,N-TERMINAL', NULL, NULL, NULL, 8),
(247331, NULL, 'PTHR17102', NULL, NULL, NULL, NULL, 'NEURONAL REGENERATION-RELATED PROTEIN', NULL, NULL, 23906, 8),
(247332, NULL, 'PTHR22017', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 23211, 8),
(247333, NULL, 'PTHR20856', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE I SUBUNIT 2', NULL, NULL, 11074, 8),
(247334, NULL, 'PTHR21274', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 18386, 8),
(247335, NULL, 'PTHR30151', NULL, NULL, NULL, NULL, 'ALKANE SULFONATE ABC TRANSPORTER-RELATED, MEMBRANE SUBUNIT', NULL, NULL, NULL, 8);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(247336, NULL, 'PTHR23201', NULL, NULL, NULL, NULL, 'EXTENSIN, PROLINE-RICH PROTEIN', NULL, NULL, NULL, 8),
(247337, NULL, 'PTHR47107', NULL, NULL, NULL, NULL, 'SVF1-LIKE PROTEIN YDR222W-RELATED', NULL, NULL, NULL, 8),
(247338, NULL, 'PTHR46561', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS AB (CLASS A-LIKE)-RELATED', NULL, NULL, NULL, 8),
(247339, NULL, 'PTHR30528', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(247340, NULL, 'PTHR13935', NULL, NULL, NULL, NULL, 'ACHAETE-SCUTE TRANSCRIPTION FACTOR-RELATED', NULL, NULL, 17921, 8),
(247341, NULL, 'PTHR28180', NULL, NULL, NULL, NULL, 'CONSERVED MITOCHONDRIAL PROTEIN-RELATED', NULL, NULL, NULL, 8),
(247342, NULL, 'PTHR45896', NULL, NULL, NULL, NULL, 'N-ALPHA-ACETYLTRANSFERASE 30', NULL, NULL, 34947, 8),
(247343, NULL, 'PTHR14196', NULL, NULL, NULL, NULL, 'ODD-SKIPPED - RELATED', NULL, NULL, NULL, 8),
(247344, NULL, 'PTHR37716', NULL, NULL, NULL, NULL, 'OS07G0568900 PROTEIN', NULL, NULL, NULL, 8),
(247345, NULL, 'PTHR47983', NULL, NULL, NULL, NULL, 'PTO-INTERACTING PROTEIN 1-LIKE', NULL, NULL, NULL, 8),
(247346, NULL, 'PTHR11405', NULL, NULL, NULL, NULL, 'CARBAMOYLTRANSFERASE FAMILY MEMBER', NULL, NULL, NULL, 8),
(247347, NULL, 'PTHR20931', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 32119, 8),
(247348, NULL, 'PTHR12879', NULL, NULL, NULL, NULL, 'SPHINGOLIPID DELTA 4 DESATURASE/C-4 HYDROXYLASE PROTEIN DES2', NULL, NULL, NULL, 8),
(247349, NULL, 'PTHR35169', NULL, NULL, NULL, NULL, 'FE2OG DIOXYGENASE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(247350, NULL, 'PTHR31126', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE', NULL, NULL, NULL, 8),
(247351, NULL, 'PTHR20974', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 8664, 8),
(247352, NULL, 'PTHR15923', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AND IMMUNOGLOBULIN DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(247353, NULL, 'PTHR12320', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C', NULL, NULL, 32819, 8),
(247354, NULL, 'PTHR35698', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN RHL1', NULL, NULL, 32529, 8),
(247355, NULL, 'PTHR46804', NULL, NULL, NULL, NULL, 'ADP RIBOSYLATION FACTOR LIKE GTPASE 14 EFFECTOR PROTEIN LIKE', NULL, NULL, NULL, 8),
(247356, NULL, 'PTHR22235', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 30', NULL, NULL, 26030, 8),
(247357, NULL, 'PTHR30546', NULL, NULL, NULL, NULL, 'FLAVODOXIN-RELATED PROTEIN WRBA-RELATED', NULL, NULL, NULL, 8),
(247358, NULL, 'PTHR34290', NULL, NULL, NULL, NULL, 'SI:CH73-390P7.2', NULL, NULL, 34675, 8),
(247359, NULL, 'PTHR12072', NULL, NULL, NULL, NULL, 'CWF19, CELL CYCLE CONTROL PROTEIN', NULL, NULL, 31051, 8),
(247360, NULL, 'PTHR13803', NULL, NULL, NULL, NULL, 'SEC24-RELATED PROTEIN', NULL, NULL, NULL, 8),
(247361, NULL, 'PTHR13603', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 21979, 8),
(247362, NULL, 'PTHR10539', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 13', NULL, NULL, 10065, 8),
(247363, NULL, 'PTHR10678', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 11/COP9 SIGNALOSOME COMPLEX SUBUNIT 2', NULL, NULL, NULL, 8),
(247364, NULL, 'PTHR30438', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(247365, NULL, 'PTHR24225', NULL, NULL, NULL, NULL, 'CHEMOTACTIC RECEPTOR', NULL, NULL, 4530, 8),
(247366, NULL, 'PTHR11758', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S15A', NULL, NULL, 5531, 8),
(247367, NULL, 'PTHR47089', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, PERMEASE PROTEIN', NULL, NULL, NULL, 8),
(247368, NULL, 'PTHR34394', NULL, NULL, NULL, NULL, 'SIMILAR TO RIKEN CDNA 2310022B05', NULL, NULL, NULL, 8),
(247369, NULL, 'PTHR46687', NULL, NULL, NULL, NULL, 'PROTEIN DISPATCHED HOMOLOG 3', NULL, NULL, 35522, 8),
(247370, NULL, 'PTHR30060', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(247371, NULL, 'PTHR33413', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(247372, NULL, 'PTHR43593', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(247373, NULL, 'PTHR38365', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(247374, NULL, 'PTHR24144', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 49', NULL, NULL, NULL, 8),
(247375, NULL, 'PTHR21585', NULL, NULL, NULL, NULL, 'FULL-LENGTH CDNA CLONE CS0DC025YL05 OF NEUROBLASTOMA', NULL, NULL, 26983, 8),
(247376, NULL, 'PTHR22943', NULL, NULL, NULL, NULL, '7-TRANSMEMBRANE DOMAIN RECEPTOR  C.ELEGANS', NULL, NULL, NULL, 8),
(247377, NULL, 'PTHR47708', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(247378, NULL, 'PTHR33165', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN-LIKE-RELATED', NULL, NULL, NULL, 8),
(247379, NULL, 'PTHR47809', NULL, NULL, NULL, NULL, 'DNA-BINDING BROMODOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(247380, NULL, 'PTHR28634', NULL, NULL, NULL, NULL, 'ZINC FINGER B-BOX DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, 27723, 8),
(247381, NULL, 'PTHR40849', NULL, NULL, NULL, NULL, 'C2 CALCIUM-DEPENDENT MEMBRANE TARGETING', NULL, NULL, NULL, 8),
(247382, NULL, 'PTHR11315', NULL, NULL, NULL, NULL, 'PROTEASE FAMILY C26 GAMMA-GLUTAMYL HYDROLASE', NULL, NULL, 8318, 8),
(247383, NULL, 'PTHR44307', NULL, NULL, NULL, NULL, 'PHOSPHOETHANOLAMINE METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(247384, NULL, 'PTHR14226', NULL, NULL, NULL, NULL, 'NEUROPATHY TARGET ESTERASE/SWISS CHEESE D.MELANOGASTER', NULL, NULL, NULL, 8),
(247385, NULL, 'PTHR17490', NULL, NULL, NULL, NULL, 'SUA5', NULL, NULL, NULL, 8),
(247386, NULL, 'PTHR31448', NULL, NULL, NULL, NULL, 'MYOSIN-BINDING PROTEIN 2', NULL, NULL, 27205, 8),
(247387, NULL, 'PTHR47064', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_1G08990)-RELATED', NULL, NULL, NULL, 8),
(247388, NULL, 'PTHR36017', NULL, NULL, NULL, NULL, 'EMBRYO DEFECTIVE 1381', NULL, NULL, NULL, 8),
(247389, NULL, 'PTHR22761', NULL, NULL, NULL, NULL, 'CHARGED MULTIVESICULAR BODY PROTEIN', NULL, NULL, 1313, 8),
(247390, NULL, 'PTHR32212', NULL, NULL, NULL, NULL, 'CYCLIN-LIKE F-BOX', NULL, NULL, NULL, 8),
(247391, NULL, 'PTHR28283', NULL, NULL, NULL, NULL, '3'',5''-CYCLIC-NUCLEOTIDE PHOSPHODIESTERASE 1', NULL, NULL, 6535, 8),
(247392, NULL, 'PTHR35501', NULL, NULL, NULL, NULL, 'PROTEIN YY1', NULL, NULL, NULL, 8),
(247393, NULL, 'PTHR15646', NULL, NULL, NULL, NULL, 'LINKER FOR ACTIVATION OF T-CELLS FAMILY MEMBER 2', NULL, NULL, 26842, 8),
(247394, NULL, 'PTHR47202', NULL, NULL, NULL, NULL, 'HISTIDINE-RICH GLYCOPROTEIN', NULL, NULL, NULL, 8),
(247395, NULL, 'PTHR21105', NULL, NULL, NULL, NULL, 'GH16255P', NULL, NULL, NULL, 8),
(247396, NULL, 'PTHR15588', NULL, NULL, NULL, NULL, 'LSM1', NULL, NULL, 34800, 8),
(247397, NULL, 'PTHR43663', NULL, NULL, NULL, NULL, 'CHROMATE TRANSPORT PROTEIN-RELATED', NULL, NULL, NULL, 8),
(247398, NULL, 'PTHR39429', NULL, NULL, NULL, NULL, 'LIGHT-INDEPENDENT PROTOCHLOROPHYLLIDE REDUCTASE SUBUNIT N', NULL, NULL, NULL, 8),
(247399, NULL, 'PTHR16557', NULL, NULL, NULL, NULL, 'ALKYLATED DNA REPAIR PROTEIN ALKB-RELATED', NULL, NULL, 835, 8),
(247400, NULL, 'PTHR22635', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 33043, 8),
(247401, NULL, 'PTHR44324', NULL, NULL, NULL, NULL, 'WD40 REPEAT DOMAIN 95', NULL, NULL, NULL, 8),
(247402, NULL, 'PTHR38116', NULL, NULL, NULL, NULL, 'CHROMOSOME 7, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(247403, NULL, 'PTHR30390', NULL, NULL, NULL, NULL, 'SEDOHEPTULOSE 7-PHOSPHATE ISOMERASE / DNAA INITIATOR-ASSOCIATING FACTOR FOR REPLICATION INITIATION', NULL, NULL, NULL, 8),
(247404, NULL, 'PTHR46260', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(247405, NULL, 'PTHR46333', NULL, NULL, NULL, NULL, 'CYTOKINESIS PROTEIN 3', NULL, NULL, NULL, 8),
(247406, NULL, 'PTHR43991', NULL, NULL, NULL, NULL, 'WD REPEAT PROTEIN (AFU_ORTHOLOGUE AFUA_8G05640)-RELATED', NULL, NULL, NULL, 8),
(247407, NULL, 'PTHR11014', NULL, NULL, NULL, NULL, 'PEPTIDASE M20 FAMILY MEMBER', NULL, NULL, 18102, 8),
(247408, NULL, 'PTHR10535', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASES I, II, AND III SUBUNIT RPABC1', NULL, NULL, 12210, 8),
(247409, NULL, 'PTHR31414', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN DDB_G0292058', NULL, NULL, 27247, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(247410, NULL, 'PTHR47346', NULL, NULL, NULL, NULL, 'HYDROLASES, ACTING ON ESTER BOND', NULL, NULL, NULL, 8),
(247411, NULL, 'PTHR43634', NULL, NULL, NULL, NULL, 'OW CONDUCTANCE MECHANOSENSITIVE CHANNEL', NULL, NULL, 35864, 8),
(247412, NULL, 'PTHR48106', NULL, NULL, NULL, NULL, 'QUINONE OXIDOREDUCTASE PIG3-RELATED', NULL, NULL, NULL, 8),
(247413, NULL, 'PTHR40135', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(247414, NULL, 'PTHR12911', NULL, NULL, NULL, NULL, 'SAD1/UNC-84-LIKE PROTEIN-RELATED', NULL, NULL, 36767, 8),
(247415, NULL, 'PTHR45925', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', NULL, NULL, NULL, 8),
(247416, NULL, 'PTHR36920', NULL, NULL, NULL, NULL, '', NULL, NULL, 2828, 8),
(247417, NULL, 'PTHR11242', NULL, NULL, NULL, NULL, 'ARYL HYDROCARBON RECEPTOR INTERACTING PROTEIN RELATED', NULL, NULL, 27143, 8),
(247418, NULL, 'PTHR11011', NULL, NULL, NULL, NULL, 'MALE STERILITY PROTEIN 2-RELATED', NULL, NULL, 25406, 8),
(247419, NULL, 'PTHR42085', NULL, NULL, NULL, NULL, '', NULL, NULL, 32072, 8),
(247420, NULL, 'PTHR43047', NULL, NULL, NULL, NULL, 'TWO-COMPONENT HISTIDINE PROTEIN KINASE', NULL, NULL, NULL, 8),
(247421, NULL, 'PTHR12748', NULL, NULL, NULL, NULL, 'ORIGIN RECOGNITION COMPLEX SUBUNIT 3', NULL, NULL, 20543, 8),
(247422, NULL, 'PTHR47513', NULL, NULL, NULL, NULL, 'ZINC TRANSPORTER', NULL, NULL, NULL, 8),
(247423, NULL, 'PTHR36813', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(247424, NULL, 'PTHR12618', NULL, NULL, NULL, NULL, 'PHD AND RING FINGER DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(247425, NULL, 'PTHR12147', NULL, NULL, NULL, NULL, 'METALLOPEPTIDASE M28 FAMILY MEMBER', NULL, NULL, 34696, 8),
(247426, NULL, 'PTHR34841', NULL, NULL, NULL, NULL, 'MYB-LIKE PROTEIN V', NULL, NULL, NULL, 8),
(247427, NULL, 'PTHR46116', NULL, NULL, NULL, NULL, '(E3-INDEPENDENT) E2 UBIQUITIN-CONJUGATING ENZYME', NULL, NULL, NULL, 8),
(247428, NULL, 'PTHR23101', NULL, NULL, NULL, NULL, 'RAB GDP/GTP EXCHANGE FACTOR', NULL, NULL, 35515, 8),
(247429, NULL, 'PTHR10522', NULL, NULL, NULL, NULL, 'GONADOLIBERIN', NULL, NULL, 17319, 8),
(247430, NULL, 'PTHR12948', NULL, NULL, NULL, NULL, 'NEDD8 ULTIMATE BUSTER-1  BS4 PROTEIN', NULL, NULL, 31138, 8),
(247431, NULL, 'PTHR48158', NULL, NULL, NULL, NULL, 'OS11G0453550 PROTEIN', NULL, NULL, NULL, 8),
(247432, NULL, 'PTHR34807', NULL, NULL, NULL, NULL, 'OS08G0270800 PROTEIN', NULL, NULL, NULL, 8),
(247433, NULL, 'PTHR34766', NULL, NULL, NULL, NULL, 'UPF0449 PROTEIN C19ORF25', NULL, NULL, 22691, 8),
(247434, NULL, 'PTHR37337', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING GLUTAMATE-RICH PROTEIN 1', NULL, NULL, NULL, 8),
(247435, NULL, 'PTHR12942', NULL, NULL, NULL, NULL, 'STEP II SPLICING FACTOR SLU7', NULL, NULL, 31917, 8),
(247436, NULL, 'PTHR34657', NULL, NULL, NULL, NULL, 'EMBRYO SAC DEVELOPMENT ARREST 6', NULL, NULL, NULL, 8),
(247437, NULL, 'PTHR43350', NULL, NULL, NULL, NULL, 'NAD-DEPENDENT ALCOHOL DEHYDROGENASE', NULL, NULL, NULL, 8),
(247438, NULL, 'PTHR21586', NULL, NULL, NULL, NULL, 'TIPA', NULL, NULL, NULL, 8),
(247439, NULL, 'PTHR33452', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE CATD-RELATED', NULL, NULL, NULL, 8),
(247440, NULL, 'PTHR39447', NULL, NULL, NULL, NULL, 'ALPHA-L-ARABINOFURANOSIDASE B', NULL, NULL, 29465, 8),
(247441, NULL, 'PTHR32097', NULL, NULL, NULL, NULL, 'CAMP-BINDING PROTEIN 1-RELATED', NULL, NULL, NULL, 8),
(247442, NULL, 'PTHR34571', NULL, NULL, NULL, NULL, '(S)-UREIDOGLYCINE AMINOHYDROLASE', NULL, NULL, NULL, 8),
(247443, NULL, 'PTHR35383', NULL, NULL, NULL, NULL, 'MUCIN 12EA-RELATED', NULL, NULL, NULL, 8),
(247444, NULL, 'PTHR30483', NULL, NULL, NULL, NULL, 'LEUCINE-SPECIFIC-BINDING PROTEIN', NULL, NULL, NULL, 8),
(247445, NULL, 'PTHR33085', NULL, NULL, NULL, NULL, 'OS12G0113100 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(247446, NULL, 'PTHR15633', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 34143, 8),
(247447, NULL, 'PTHR14063', NULL, NULL, NULL, NULL, 'PROTEIN LIN-7 HOMOLOG', NULL, NULL, NULL, 8),
(247448, NULL, 'PTHR46096', NULL, NULL, NULL, NULL, 'PERFORIN-1', NULL, NULL, NULL, 8);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(247449, NULL, 'PTHR13636', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 3040, 8),
(247450, NULL, 'PTHR46875', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 5', NULL, NULL, NULL, 8),
(247451, NULL, 'PTHR38602', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED', NULL, NULL, 19174, 8),
(247452, NULL, 'PTHR24061', NULL, NULL, NULL, NULL, 'CALCIUM-SENSING RECEPTOR-RELATED', NULL, NULL, 3712, 8),
(247453, NULL, 'PTHR35670', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 81', NULL, NULL, 33344, 8),
(247454, NULL, 'PTHR14356', NULL, NULL, NULL, NULL, 'INTERLEUKIN-15-RELATED', NULL, NULL, 5235, 8),
(247455, NULL, 'PTHR11955', NULL, NULL, NULL, NULL, 'FATTY ACID BINDING PROTEIN', NULL, NULL, 25838, 8),
(247456, NULL, 'PTHR32021', NULL, NULL, NULL, NULL, 'CASP-LIKE PROTEIN 5B3', NULL, NULL, 34454, 8),
(247457, NULL, 'PTHR38814', NULL, NULL, NULL, NULL, 'ENDONUCLEASE NUCS', NULL, NULL, 4591, 8),
(247458, NULL, 'PTHR13109', NULL, NULL, NULL, NULL, 'NEUROCHONDRIN', NULL, NULL, 13181, 8),
(247459, NULL, 'PTHR37293', NULL, NULL, NULL, NULL, 'PHAGE REPLICATION PROTEIN-RELATED', NULL, NULL, NULL, 8),
(247460, NULL, 'PTHR48212', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(247461, NULL, 'PTHR43570', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE', NULL, NULL, 13383, 8),
(247462, NULL, 'PTHR21717', NULL, NULL, NULL, NULL, 'TELOMERIC REPEAT BINDING PROTEIN', NULL, NULL, 25354, 8),
(247463, NULL, 'PTHR11138', NULL, NULL, NULL, NULL, 'METHIONYL-TRNA FORMYLTRANSFERASE', NULL, NULL, NULL, 8),
(247464, NULL, 'PTHR47463', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SKIP16', NULL, NULL, NULL, 8),
(247465, NULL, 'PTHR36684', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY PROTEIN COX14', NULL, NULL, 26549, 8),
(247466, NULL, 'PTHR30448', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 6056, 8),
(247467, NULL, 'PTHR46257', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE CORKSCREW', NULL, NULL, NULL, 8),
(247468, NULL, 'PTHR12847', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE  ABC  TRANSPORTER-RELATED', NULL, NULL, NULL, 8),
(247469, NULL, 'PTHR39603', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(247470, NULL, 'PTHR33390', NULL, NULL, NULL, NULL, 'STRESS UP-REGULATED NOD 19 PROTEIN', NULL, NULL, 10980, 8),
(247471, NULL, 'PTHR39523', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(247472, NULL, 'PTHR42912', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(247473, NULL, 'PTHR43779', NULL, NULL, NULL, NULL, 'DIOXYGENASE RV0097-RELATED', NULL, NULL, NULL, 8),
(247474, NULL, 'PTHR46171', NULL, NULL, NULL, NULL, 'GH10160P', NULL, NULL, NULL, 8),
(247475, NULL, 'PTHR13462', NULL, NULL, NULL, NULL, 'CALCIUM UNIPORTER PROTEIN, MITOCHONDRIAL', NULL, NULL, 33241, 8),
(247476, NULL, 'PTHR13242', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3', NULL, NULL, 15711, 8),
(247477, NULL, 'PTHR47982', NULL, NULL, NULL, NULL, 'PROLINE-RICH RECEPTOR-LIKE PROTEIN KINASE PERK4', NULL, NULL, NULL, 8),
(247478, NULL, 'PTHR34469', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REACTION CENTER PROTEIN H', NULL, NULL, 5078, 8),
(247479, NULL, 'PTHR11365', NULL, NULL, NULL, NULL, '5-OXOPROLINASE RELATED', NULL, NULL, 34167, 8),
(247480, NULL, 'PTHR32409', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM20-1-RELATED', NULL, NULL, 14437, 8),
(247481, NULL, 'PTHR47375', NULL, NULL, NULL, NULL, 'GB|AAF34833.1', NULL, NULL, 34628, 8),
(247482, NULL, 'PTHR21707', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 25800, 8),
(247483, NULL, 'PTHR33446', NULL, NULL, NULL, NULL, 'PROTEIN TONB-RELATED', NULL, NULL, NULL, 8),
(247484, NULL, 'PTHR30456', NULL, NULL, NULL, NULL, 'PYRIDOXINE 5''-PHOSPHATE SYNTHASE', NULL, NULL, 730, 8),
(247485, NULL, 'PTHR46228', NULL, NULL, NULL, NULL, 'KELCH DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(247486, NULL, 'PTHR23067', NULL, NULL, NULL, NULL, 'DOUBLE-STRANDED RNA-BINDING ZINC FINGER PROTEIN', NULL, NULL, NULL, 8),
(247487, NULL, 'PTHR14519', NULL, NULL, NULL, NULL, 'VITAMIN K EPOXIDE REDUCTASE COMPLEX, SUBUNIT 1', NULL, NULL, 36877, 8);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(247488, NULL, 'PTHR16223', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH83-RELATED', NULL, NULL, NULL, 8),
(247489, NULL, 'PTHR31137', NULL, NULL, NULL, NULL, 'PROTEIN PSIB-RELATED-RELATED', NULL, NULL, NULL, 8),
(247490, NULL, 'PTHR43411', NULL, NULL, NULL, NULL, 'ADENYLOSUCCINATE LYASE', NULL, NULL, NULL, 8),
(247491, NULL, 'PTHR12726', NULL, NULL, NULL, NULL, 'CERAMIDE GLUCOSYLTRANSFERASE', NULL, NULL, 25955, 8),
(247492, NULL, 'PTHR20922', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 9960, 8),
(247493, NULL, 'PTHR13454', NULL, NULL, NULL, NULL, 'PROTEIN MCM10 HOMOLOG', NULL, NULL, 33038, 8),
(247494, NULL, 'PTHR24231', NULL, NULL, NULL, NULL, 'PURINOCEPTOR-RELATED G-PROTEIN COUPLED RECEPTOR', NULL, NULL, NULL, 8),
(247495, NULL, 'PTHR36778', NULL, NULL, NULL, NULL, 'CADMIUM-INDUCED PROTEIN AS8', NULL, NULL, 27340, 8),
(247496, NULL, 'PTHR24339', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN EMX-RELATED', NULL, NULL, NULL, 8),
(247497, NULL, 'PTHR38052', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(247498, NULL, 'PTHR47839', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G04830)-RELATED', NULL, NULL, NULL, 8),
(247499, NULL, 'PTHR37416', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(247500, NULL, 'PTHR43895', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-DEPENDENT PROTEIN KINASE KINASE-RELATED', NULL, NULL, NULL, 8),
(247501, NULL, 'PTHR23404', NULL, NULL, NULL, NULL, 'MOLYBDOPTERIN SYNTHASE RELATED', NULL, NULL, NULL, 8),
(247502, NULL, 'PTHR12157', NULL, NULL, NULL, NULL, 'REGULATING SYNAPTIC MEMBRANE EXOCYTOSIS PROTEIN', NULL, NULL, 29103, 8),
(247503, NULL, 'PTHR31656', NULL, NULL, NULL, NULL, 'ROOT CAP DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(247504, NULL, 'PTHR38031', NULL, NULL, NULL, NULL, 'SULFUR CARRIER PROTEIN SLR0821-RELATED', NULL, NULL, NULL, 8),
(247505, NULL, 'PTHR21367', NULL, NULL, NULL, NULL, 'ARGININE-TRNA-PROTEIN TRANSFERASE 1', NULL, NULL, 23892, 8),
(247506, NULL, 'PTHR47598', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP17-2, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(247507, NULL, 'PTHR30100', NULL, NULL, NULL, NULL, 'FATTY ACID/PHOSPHOLIPID SYNTHESIS PROTEIN PLSX', NULL, NULL, 8475, 8),
(247508, NULL, 'PTHR22380', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 15', NULL, NULL, 22168, 8),
(247509, NULL, 'PTHR43229', NULL, NULL, NULL, NULL, 'NODULATION PROTEIN J', NULL, NULL, NULL, 8),
(247510, NULL, 'PTHR34954', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, 35200, 8),
(247511, NULL, 'PTHR43105', NULL, NULL, NULL, NULL, 'RESPIRATORY NITRATE REDUCTASE', NULL, NULL, NULL, 8),
(247512, NULL, 'PTHR34376', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR, KAZAL-TYPE FAMILY PROTEIN', NULL, NULL, NULL, 8),
(247513, NULL, 'PTHR15953', NULL, NULL, NULL, NULL, 'APELIN', NULL, NULL, 23080, 8),
(247514, NULL, 'PTHR19848', NULL, NULL, NULL, NULL, 'WD40 REPEAT PROTEIN', NULL, NULL, NULL, 8),
(247515, NULL, 'PTHR45945', NULL, NULL, NULL, NULL, 'REGULATOR OF G-PROTEIN SIGNALING LOCO', NULL, NULL, NULL, 8),
(247516, NULL, 'PTHR37350', NULL, NULL, NULL, NULL, 'PROTEIN GAPT', NULL, NULL, 18026, 8),
(247517, NULL, 'PTHR46015', NULL, NULL, NULL, NULL, 'ZGC:172121', NULL, NULL, NULL, 8),
(247518, NULL, 'PTHR34935', NULL, NULL, NULL, NULL, 'PROTEIN TIC110, CHLOROPLASTIC', NULL, NULL, 25974, 8),
(247519, NULL, 'PTHR33402', NULL, NULL, NULL, NULL, 'VQ MOTIF-CONTAINING PROTEIN 11-LIKE', NULL, NULL, 27279, 8),
(247520, NULL, 'PTHR46415', NULL, NULL, NULL, NULL, 'ADAPTOR PROTEIN, PHOSPHOTYROSINE INTERACTION, PH DOMAIN AND LEUCINE ZIPPER-CONTAINING 2', NULL, NULL, NULL, 8),
(247521, NULL, 'PTHR37380', NULL, NULL, NULL, NULL, 'CLE FAMILY OSCLE501 PROTEIN', NULL, NULL, NULL, 8),
(247522, NULL, 'PTHR36318', NULL, NULL, NULL, NULL, 'OS06G0581300 PROTEIN', NULL, NULL, 8486, 8),
(247523, NULL, 'PTHR37164', NULL, NULL, NULL, NULL, 'BACTERIOHEMERYTHRIN', NULL, NULL, NULL, 8),
(247524, NULL, 'PTHR48107', NULL, NULL, NULL, NULL, 'NADPH-DEPENDENT ALDEHYDE REDUCTASE-LIKE PROTEIN, CHLOROPLASTIC-RELATED', NULL, NULL, NULL, 8);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(247525, NULL, 'PTHR38826', NULL, NULL, NULL, NULL, 'RIBONUCLEASE VAPC13', NULL, NULL, NULL, 8),
(247526, NULL, 'PTHR43584', NULL, NULL, NULL, NULL, 'NUCLEOTIDYL TRANSFERASE', NULL, NULL, NULL, 8),
(247527, NULL, 'PTHR45691', NULL, NULL, NULL, NULL, 'PROTEIN DIAPHANOUS', NULL, NULL, NULL, 8),
(247528, NULL, 'PTHR46859', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE FRAGILE-X-F-ASSOCIATED PROTEIN', NULL, NULL, NULL, 8),
(247529, NULL, 'PTHR16399', NULL, NULL, NULL, NULL, 'GASDERMIN', NULL, NULL, 901, 8),
(247530, NULL, 'PTHR15127', NULL, NULL, NULL, NULL, 'HEAVYWEIGHT, ISOFORM A', NULL, NULL, NULL, 8),
(247531, NULL, 'PTHR47277', NULL, NULL, NULL, NULL, 'CHROMOBOX PROTEIN HOMOLOG 7', NULL, NULL, 34011, 8),
(247532, NULL, 'PTHR13598', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 15902, 8),
(247533, NULL, 'PTHR31124', NULL, NULL, NULL, NULL, 'APICAL MERISTEM FORMATION PROTEIN-RELATED-RELATED', NULL, NULL, NULL, 8),
(247534, NULL, 'PTHR16138', NULL, NULL, NULL, NULL, 'MYCOPHENOLIC ACID ACYL-GLUCURONIDE ESTERASE, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(247535, NULL, 'PTHR37480', NULL, NULL, NULL, NULL, 'ENOYL-[ACYL-CARRIER-PROTEIN] REDUCTASE [NADH]', NULL, NULL, 9671, 8),
(247536, NULL, 'PTHR12749', NULL, NULL, NULL, NULL, 'EXCISION REPAIR CROSS-COMPLEMENTING 1 ERCC1', NULL, NULL, 629, 8),
(247537, NULL, 'PTHR11506', NULL, NULL, NULL, NULL, 'LYSOSOME-ASSOCIATED MEMBRANE GLYCOPROTEIN', NULL, NULL, 4671, 8),
(247538, NULL, 'PTHR16529', NULL, NULL, NULL, NULL, 'CD177 ANTIGEN', NULL, NULL, NULL, 8),
(247539, NULL, 'PTHR34799', NULL, NULL, NULL, NULL, 'OS07G0656300 PROTEIN', NULL, NULL, NULL, 8),
(247540, NULL, 'PTHR14633', NULL, NULL, NULL, NULL, 'LITTLE ELONGATION COMPLEX SUBUNIT 2', NULL, NULL, NULL, 8),
(247541, NULL, 'PTHR36619', NULL, NULL, NULL, NULL, 'OS04G0208900 PROTEIN', NULL, NULL, NULL, 8),
(247542, NULL, 'PTHR16022', NULL, NULL, NULL, NULL, 'WD REPEAT DOMAIN 60', NULL, NULL, 37454, 8),
(247543, NULL, 'PTHR34463', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN', NULL, NULL, NULL, 8),
(247544, NULL, 'PTHR12563', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE', NULL, NULL, 15078, 8),
(247545, NULL, 'PTHR45187', NULL, NULL, NULL, NULL, 'RHODANESE-LIKE DOMAIN-CONTAINING PROTEIN 11, CHLOROPLASTIC', NULL, NULL, 36318, 8),
(247546, NULL, 'PTHR46515', NULL, NULL, NULL, NULL, 'TATA ELEMENT MODULATORY FACTOR TMF1', NULL, NULL, NULL, 8),
(247547, NULL, 'PTHR45954', NULL, NULL, NULL, NULL, 'LD33695P', NULL, NULL, NULL, 8),
(247548, NULL, 'PTHR46741', NULL, NULL, NULL, NULL, 'OS09G0413600 PROTEIN', NULL, NULL, NULL, 8),
(247549, NULL, 'PTHR16655', NULL, NULL, NULL, NULL, 'COCAINE AND AMPHETAMINE REGULATED TRANSCRIPT PROTEIN', NULL, NULL, 7522, 8),
(247550, NULL, 'PTHR16295', NULL, NULL, NULL, NULL, 'TRAF-TYPE ZINC FINGER PROTEIN-RELATED', NULL, NULL, NULL, 8),
(247551, NULL, 'PTHR42963', NULL, NULL, NULL, NULL, 'CHROMOSOME PARTITION PROTEIN MUKB', NULL, NULL, NULL, 8),
(247552, NULL, 'PTHR11103', NULL, NULL, NULL, NULL, 'SLR1189 PROTEIN', NULL, NULL, NULL, 8),
(247553, NULL, 'PTHR45630', NULL, NULL, NULL, NULL, 'CATION-TRANSPORTING ATPASE-RELATED', NULL, NULL, NULL, 8),
(247554, NULL, 'PTHR36264', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(247555, NULL, 'PTHR42194', NULL, NULL, NULL, NULL, 'UPF0276 PROTEIN HI_1600', NULL, NULL, 2494, 8),
(247556, NULL, 'PTHR24652', NULL, NULL, NULL, NULL, 'LOW-DENSITY LIPOPROTEIN RECEPTOR CLASS A DOMAIN-CONTAINING PROTEIN 2', NULL, NULL, NULL, 8),
(247557, NULL, 'PTHR47163', NULL, NULL, NULL, NULL, 'DDE_TNP_IS1595 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(247558, NULL, 'PTHR23209', NULL, NULL, NULL, NULL, 'A-KINASE ANCHOR PROTEIN 12', NULL, NULL, 25854, 8),
(247559, NULL, 'PTHR36101', NULL, NULL, NULL, NULL, 'ATP SYNTHASE PROTEIN 8', NULL, NULL, 12647, 8),
(247560, NULL, 'PTHR47455', NULL, NULL, NULL, NULL, 'ADENYLYL CYCLASE BETA', NULL, NULL, NULL, 8),
(247561, NULL, 'PTHR16262', NULL, NULL, NULL, NULL, 'PEROXISOME ASSEMBLY PROTEIN 26', NULL, NULL, 10912, 8),
(247562, NULL, 'PTHR11515', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN HORMONE BETA CHAIN', NULL, NULL, 3145, 8);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(247563, NULL, 'PTHR46752', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 39', NULL, NULL, NULL, 8),
(247564, NULL, 'PTHR16442', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 17', NULL, NULL, 28197, 8),
(247565, NULL, 'PTHR46492', NULL, NULL, NULL, NULL, 'DYNEIN ASSEMBLY FACTOR 4, AXONEMAL', NULL, NULL, NULL, 8),
(247566, NULL, 'PTHR46209', NULL, NULL, NULL, NULL, 'PX DOMAIN-CONTAINING PROTEIN', NULL, NULL, 35660, 8),
(247567, NULL, 'PTHR43720', NULL, NULL, NULL, NULL, '2-AMINOMUCONIC SEMIALDEHYDE DEHYDROGENASE', NULL, NULL, NULL, 8),
(247568, NULL, 'PTHR36536', NULL, NULL, NULL, NULL, 'UPF0111 PROTEIN HI_1603', NULL, NULL, 3969, 8),
(247569, NULL, 'PTHR36438', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER REPAIR PROTEIN YTFE', NULL, NULL, 11726, 8),
(247570, NULL, 'PTHR14659', NULL, NULL, NULL, NULL, 'ALPHA- AND GAMMA-ADAPTIN-BINDING PROTEIN P34', NULL, NULL, 15690, 8),
(247571, NULL, 'PTHR24096', NULL, NULL, NULL, NULL, 'LONG-CHAIN-FATTY-ACID--COA LIGASE', NULL, NULL, NULL, 8),
(247572, NULL, 'PTHR47992', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE', NULL, NULL, NULL, 8),
(247573, NULL, 'PTHR35100', NULL, NULL, NULL, NULL, 'FOLD PROTEIN', NULL, NULL, NULL, 8),
(247574, NULL, 'PTHR43414', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN MDTG', NULL, NULL, NULL, 8),
(247575, NULL, 'PTHR13447', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 28S RIBOSOMAL PROTEIN S28', NULL, NULL, 15571, 8),
(247576, NULL, 'PTHR43185', NULL, NULL, NULL, NULL, 'FERROUS IRON TRANSPORT PROTEIN B', NULL, NULL, NULL, 8),
(247577, NULL, 'PTHR31220', NULL, NULL, NULL, NULL, 'HYCCIN RELATED', NULL, NULL, 16375, 8),
(247578, NULL, 'PTHR38118', NULL, NULL, NULL, NULL, 'ANCHORED CELL WALL PROTEIN 11-RELATED', NULL, NULL, NULL, 8),
(247579, NULL, 'PTHR37727', NULL, NULL, NULL, NULL, 'ECOTROPIC VIRAL INTEGRATION SITE PROTEIN', NULL, NULL, NULL, 8),
(247580, NULL, 'PTHR33416', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN NUP1', NULL, NULL, NULL, 8),
(247581, NULL, 'PTHR44675', NULL, NULL, NULL, NULL, 'PAK1 INTERACTING PROTEIN 1', NULL, NULL, NULL, 8),
(247582, NULL, 'PTHR31223', NULL, NULL, NULL, NULL, 'LOG FAMILY PROTEIN YJL055W', NULL, NULL, NULL, 8),
(247583, NULL, 'PTHR23003', NULL, NULL, NULL, NULL, 'RNA RECOGNITION MOTIF  RRM  DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(247584, NULL, 'PTHR16487', NULL, NULL, NULL, NULL, 'PPP4R2-RELATED PROTEIN', NULL, NULL, 12066, 8),
(247585, NULL, 'PTHR33973', NULL, NULL, NULL, NULL, 'OS07G0153300 PROTEIN', NULL, NULL, 10730, 8),
(247586, NULL, 'PTHR14965', NULL, NULL, NULL, NULL, 'SI:CH73-248E21.1', NULL, NULL, NULL, 8),
(247587, NULL, 'PTHR22750', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR', NULL, NULL, NULL, 8),
(247588, NULL, 'PTHR21608', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(247589, NULL, 'PTHR42811', NULL, NULL, NULL, NULL, 'SERINE ACETYLTRANSFERASE', NULL, NULL, NULL, 8),
(247590, NULL, 'PTHR12776', NULL, NULL, NULL, NULL, 'KAZRIN-RELATED', NULL, NULL, 30529, 8),
(247591, NULL, 'PTHR34023', NULL, NULL, NULL, NULL, 'RNASE H DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(247592, NULL, 'PTHR14324', NULL, NULL, NULL, NULL, 'CONDENSIN-2 COMPLEX SUBUNIT H2', NULL, NULL, 22566, 8),
(247593, NULL, 'PTHR19304', NULL, NULL, NULL, NULL, 'CYCLIC-AMP RESPONSE ELEMENT BINDING PROTEIN', NULL, NULL, NULL, 8),
(247594, NULL, 'PTHR30446', NULL, NULL, NULL, NULL, 'RECOMBINATION PROTEIN RECR', NULL, NULL, 2576, 8),
(247595, NULL, 'PTHR46384', NULL, NULL, NULL, NULL, 'MOTILE SPERM DOMAIN-CONTAINING PROTEIN 2', NULL, NULL, NULL, 8),
(247596, NULL, 'PTHR31881', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(247597, NULL, 'PTHR46747', NULL, NULL, NULL, NULL, 'ALPHA-PROTEIN KINASE 1', NULL, NULL, 35647, 8),
(247598, NULL, 'PTHR30238', NULL, NULL, NULL, NULL, 'MEMBRANE BOUND PREDICTED REDOX MODULATOR', NULL, NULL, NULL, 8),
(247599, NULL, 'PTHR46727', NULL, NULL, NULL, NULL, 'E3 SUMO-PROTEIN LIGASE CBX4', NULL, NULL, 35508, 8),
(247600, NULL, 'PTHR23073', NULL, NULL, NULL, NULL, '26S PROTEASOME REGULATORY SUBUNIT', NULL, NULL, NULL, 8);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(247601, NULL, 'PTHR23035', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 31525, 8),
(247602, NULL, 'PTHR12435', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 35708, 8),
(247603, NULL, 'PTHR43461', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 256', NULL, NULL, 2468, 8),
(247604, NULL, 'PTHR31169', NULL, NULL, NULL, NULL, 'OS05G0300700 PROTEIN', NULL, NULL, 31230, 8),
(247605, NULL, 'PTHR35375', NULL, NULL, NULL, NULL, 'NEMATODE SPECIFIC PEPTIDE FAMILY, GROUP D', NULL, NULL, 12453, 8),
(247606, NULL, 'PTHR30009', NULL, NULL, NULL, NULL, 'CYTOCHROME C-TYPE SYNTHESIS PROTEIN AND PTS TRANSMEMBRANE COMPONENT', NULL, NULL, NULL, 8),
(247607, NULL, 'PTHR43041', NULL, NULL, NULL, NULL, 'HYDROLASE, METALLO-BETA-LACTAMASE SUPERFAMILY', NULL, NULL, NULL, 8),
(247608, NULL, 'PTHR31391', NULL, NULL, NULL, NULL, 'B3 DOMAIN-CONTAINING PROTEIN OS11G0197600-RELATED', NULL, NULL, 34547, 8),
(247609, NULL, 'PTHR37175', NULL, NULL, NULL, NULL, 'BNAA08G28800D PROTEIN', NULL, NULL, NULL, 8),
(247610, NULL, 'PTHR46603', NULL, NULL, NULL, NULL, 'ABSCISSION/NOCUT CHECKPOINT REGULATOR', NULL, NULL, NULL, 8),
(247611, NULL, 'PTHR15221', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX SUBUNIT 3', NULL, NULL, 23357, 8),
(247612, NULL, 'PTHR34611', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(247613, NULL, 'PTHR46256', NULL, NULL, NULL, NULL, 'AGAP011099-PA', NULL, NULL, NULL, 8),
(247614, NULL, 'PTHR33494', NULL, NULL, NULL, NULL, 'OS02G0793800 PROTEIN', NULL, NULL, NULL, 8),
(247615, NULL, 'PTHR28246', NULL, NULL, NULL, NULL, 'G1-SPECIFIC TRANSCRIPTIONAL REPRESSOR WHI5-RELATED', NULL, NULL, 33810, 8),
(247616, NULL, 'PTHR12665', NULL, NULL, NULL, NULL, 'ORMDL PROTEINS', NULL, NULL, 1029, 8),
(247617, NULL, 'PTHR45886', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY-RELATED-RELATED', NULL, NULL, NULL, 8),
(247618, NULL, 'PTHR45647', NULL, NULL, NULL, NULL, 'OS02G0152300 PROTEIN', NULL, NULL, NULL, 8),
(247619, NULL, 'PTHR43099', NULL, NULL, NULL, NULL, 'UPF0053 PROTEIN YRKA', NULL, NULL, NULL, 8),
(247620, NULL, 'PTHR41523', NULL, NULL, NULL, NULL, 'TWO-COMPONENT SYSTEM SENSOR PROTEIN', NULL, NULL, NULL, 8),
(247621, NULL, 'PTHR45081', NULL, NULL, NULL, NULL, 'EF HAND FAMILY PROTEIN, PUTATIVE, EXPRESSED-RELATED', NULL, NULL, NULL, 8),
(247622, NULL, 'PTHR43885', NULL, NULL, NULL, NULL, 'HALOACID DEHALOGENASE-LIKE HYDROLASE', NULL, NULL, NULL, 8),
(247623, NULL, 'PTHR47828', NULL, NULL, NULL, NULL, 'ARCHAEAL HISTONE A', NULL, NULL, NULL, 8),
(247624, NULL, 'PTHR31891', NULL, NULL, NULL, NULL, 'FORMAMIDASE C869.04-RELATED', NULL, NULL, 4535, 8),
(247625, NULL, 'PTHR24253', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEASE SERINE', NULL, NULL, NULL, 8),
(247626, NULL, 'PTHR45984', NULL, NULL, NULL, NULL, 'RNA (RNA) POLYMERASE II ASSOCIATED PROTEIN HOMOLOG', NULL, NULL, NULL, 8),
(247627, NULL, 'PTHR46399', NULL, NULL, NULL, NULL, 'B30.2/SPRY DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(247628, NULL, 'PTHR35121', NULL, NULL, NULL, NULL, 'HOMEODOMAIN PROTEIN 8, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(247629, NULL, 'PTHR37013', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_1G05950)-RELATED', NULL, NULL, NULL, 8),
(247630, NULL, 'PTHR43053', NULL, NULL, NULL, NULL, 'GLYCOSIDASE FAMILY 31', NULL, NULL, NULL, 8),
(247631, NULL, 'PTHR31490', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE', NULL, NULL, 34738, 8),
(247632, NULL, 'PTHR24353', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-DEPENDENT PROTEIN KINASE', NULL, NULL, NULL, 8),
(247633, NULL, 'PTHR34297', NULL, NULL, NULL, NULL, 'HYPOTHETICAL CYTOSOLIC PROTEIN-RELATED', NULL, NULL, 1981, 8),
(247634, NULL, 'PTHR10796', NULL, NULL, NULL, NULL, 'PATCHED-RELATED', NULL, NULL, NULL, 8),
(247635, NULL, 'PTHR13101', NULL, NULL, NULL, NULL, 'PHOSPHOMEVALONATE KINASE', NULL, NULL, 395, 8),
(247636, NULL, 'PTHR10071', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR GATA FAMILY MEMBER', NULL, NULL, 33302, 8),
(247637, NULL, 'PTHR45758', NULL, NULL, NULL, NULL, 'MITOFERRIN-1-RELATED', NULL, NULL, NULL, 8);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(247638, NULL, 'PTHR45255', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 24', NULL, NULL, 35495, 8),
(247639, NULL, 'PTHR10545', NULL, NULL, NULL, NULL, 'DIAMINE N-ACETYLTRANSFERASE', NULL, NULL, NULL, 8),
(247640, NULL, 'PTHR21407', NULL, NULL, NULL, NULL, 'RE43931P-RELATED', NULL, NULL, NULL, 8),
(247641, NULL, 'PTHR10672', NULL, NULL, NULL, NULL, 'ADDUCIN', NULL, NULL, NULL, 8),
(247642, NULL, 'PTHR18887', NULL, NULL, NULL, NULL, 'GOLGI-ASSOCIATED PROTEIN GCP360-RELATED', NULL, NULL, 25435, 8),
(247643, NULL, 'PTHR36320', NULL, NULL, NULL, NULL, 'OS04G0611300 PROTEIN', NULL, NULL, NULL, 8),
(247644, NULL, 'PTHR35294', NULL, NULL, NULL, NULL, 'UBIQUITIN-ASSOCIATED/TRANSLATION ELONGATION FACTOR EF1B PROTEIN', NULL, NULL, NULL, 8),
(247645, NULL, 'PTHR46860', NULL, NULL, NULL, NULL, 'CHROMOBOX PROTEIN HOMOLOG 2', NULL, NULL, 34735, 8),
(247646, NULL, 'PTHR42960', NULL, NULL, NULL, NULL, 'YCF46 PROTEIN', NULL, NULL, NULL, 8),
(247647, NULL, 'PTHR46194', NULL, NULL, NULL, NULL, 'PEPTIDYL-TRNA HYDROLASE PTRHD1-RELATED', NULL, NULL, 37298, 8),
(247648, NULL, 'PTHR23338', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN SM', NULL, NULL, 25914, 8),
(247649, NULL, 'PTHR14796', NULL, NULL, NULL, NULL, 'NEURENSIN 1-RELATED', NULL, NULL, 26690, 8),
(247650, NULL, 'PTHR46642', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PHOSPHATASE, SUBGROUP, CATALYTIC DOMAIN', NULL, NULL, NULL, 8),
(247651, NULL, 'PTHR10443', NULL, NULL, NULL, NULL, 'MICROSOMAL DIPEPTIDASE', NULL, NULL, 8620, 8),
(247652, NULL, 'PTHR38710', NULL, NULL, NULL, NULL, 'WITH PUTATIVE URIDYL PYROPHOSPHORYLASE-RELATED', NULL, NULL, NULL, 8),
(247653, NULL, 'PTHR47647', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN DOMAIN FAMILY 12 MEMBER B', NULL, NULL, 34363, 8),
(247654, NULL, 'PTHR16897', NULL, NULL, NULL, NULL, 'OS10G0105400 PROTEIN', NULL, NULL, NULL, 8),
(247655, NULL, 'PTHR41677', NULL, NULL, NULL, NULL, 'YALI0B19030P', NULL, NULL, NULL, 8),
(247656, NULL, 'PTHR23322', NULL, NULL, NULL, NULL, 'FAS-ASSOCIATED PROTEIN', NULL, NULL, NULL, 8),
(247657, NULL, 'PTHR47224', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 25', NULL, NULL, 34366, 8),
(247658, NULL, 'PTHR13198', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 25', NULL, NULL, 27695, 8),
(247659, NULL, 'PTHR37309', NULL, NULL, NULL, NULL, 'SLR0284 PROTEIN', NULL, NULL, 203, 8),
(247660, NULL, 'PTHR21712', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 34583, 8),
(247661, NULL, 'PTHR30015', NULL, NULL, NULL, NULL, 'MRR RESTRICTION SYSTEM PROTEIN', NULL, NULL, NULL, 8),
(247662, NULL, 'PTHR38763', NULL, NULL, NULL, NULL, 'MAJOR OUTER MEMBRANE PROLIPOPROTEIN LPP', NULL, NULL, 20264, 8),
(247663, NULL, 'PTHR45635', NULL, NULL, NULL, NULL, 'ADP,ATP CARRIER PROTEIN 1-RELATED-RELATED', NULL, NULL, 1269, 8),
(247664, NULL, 'PTHR31766', NULL, NULL, NULL, NULL, 'GLABROUS1 ENHANCER-BINDING PROTEIN-LIKE 2', NULL, NULL, 27829, 8),
(247665, NULL, 'PTHR46463', NULL, NULL, NULL, NULL, 'ZINC FINGER, RING/FYVE/PHD-TYPE', NULL, NULL, NULL, 8),
(247666, NULL, 'PTHR23534', NULL, NULL, NULL, NULL, 'MFS PERMEASE', NULL, NULL, NULL, 8),
(247667, NULL, 'PTHR14494', NULL, NULL, NULL, NULL, 'ALADIN/ADRACALIN/AAAS', NULL, NULL, 35701, 8),
(247668, NULL, 'PTHR30569', NULL, NULL, NULL, NULL, 'CYTOSINE TRANSPORTER CODB', NULL, NULL, 21959, 8),
(247669, NULL, 'PTHR42974', NULL, NULL, NULL, NULL, 'GLUTAMINE SYNTHETASE', NULL, NULL, NULL, 8),
(247670, NULL, 'PTHR35287', NULL, NULL, NULL, NULL, 'SI:ZFOS-911D5.4', NULL, NULL, NULL, 8),
(247671, NULL, 'PTHR30636', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 11216, 8),
(247672, NULL, 'PTHR17972', NULL, NULL, NULL, NULL, 'NUCLEOLAR RNA-ASSOCIATED PROTEIN', NULL, NULL, 1739, 8),
(247673, NULL, 'PTHR14255', NULL, NULL, NULL, NULL, 'CEREBLON', NULL, NULL, NULL, 8),
(247674, NULL, 'PTHR15827', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE 2-INTERACTING PROTEIN', NULL, NULL, NULL, 8),
(247675, NULL, 'PTHR47126', NULL, NULL, NULL, NULL, '5''-ADENYLYLSULFATE REDUCTASE-LIKE 7', NULL, NULL, 35710, 8),
(247676, NULL, 'PTHR42745', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(247677, NULL, 'PTHR31379', NULL, NULL, NULL, NULL, 'F-BOX C PROTEIN-RELATED-RELATED', NULL, NULL, 20223, 8),
(247678, NULL, 'PTHR34836', NULL, NULL, NULL, NULL, 'OS06G0188250 PROTEIN', NULL, NULL, NULL, 8),
(247679, NULL, 'PTHR24213', NULL, NULL, NULL, NULL, 'ACTIN-BINDING LIM PROTEIN', NULL, NULL, NULL, 8),
(247680, NULL, 'PTHR45948', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE DDB_G0269404-RELATED', NULL, NULL, NULL, 8),
(247681, NULL, 'PTHR47109', NULL, NULL, NULL, NULL, 'NUCLEOREDOXIN-LIKE PROTEIN 1', NULL, NULL, 22024, 8),
(247682, NULL, 'PTHR44525', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 27', NULL, NULL, 36671, 8),
(247683, NULL, 'PTHR45532', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 97', NULL, NULL, NULL, 8),
(247684, NULL, 'PTHR42864', NULL, NULL, NULL, NULL, 'LIGHT-INDEPENDENT PROTOCHLOROPHYLLIDE REDUCTASE IRON-SULFUR ATP-BINDING PROTEIN', NULL, NULL, 4790, 8),
(247685, NULL, 'PTHR13697', NULL, NULL, NULL, NULL, 'PHOSPHOFRUCTOKINASE', NULL, NULL, NULL, 8),
(247686, NULL, 'PTHR45947', NULL, NULL, NULL, NULL, 'SULFOQUINOVOSYL TRANSFERASE SQD2', NULL, NULL, NULL, 8),
(247687, NULL, 'PTHR44147', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE SDR FAMILY MEMBER 1', NULL, NULL, NULL, 8),
(247688, NULL, 'PTHR47751', NULL, NULL, NULL, NULL, 'SUPERFAMILY HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G16580)-RELATED', NULL, NULL, NULL, 8),
(247689, NULL, 'PTHR46263', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING PROTEIN 7', NULL, NULL, 35547, 8),
(247690, NULL, 'PTHR14024', NULL, NULL, NULL, NULL, 'PERILIPIN', NULL, NULL, NULL, 8),
(247691, NULL, 'PTHR41807', NULL, NULL, NULL, NULL, 'GLUTATHIONE TRANSFERASE 3', NULL, NULL, 32402, 8),
(247692, NULL, 'PTHR11347', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE PHOSPHODIESTERASE', NULL, NULL, NULL, 8),
(247693, NULL, 'PTHR48012', NULL, NULL, NULL, NULL, 'STERILE20-LIKE KINASE, ISOFORM B-RELATED', NULL, NULL, NULL, 8),
(247694, NULL, 'PTHR40412', NULL, NULL, NULL, NULL, 'SF-ASSEMBLIN', NULL, NULL, 7869, 8),
(247695, NULL, 'PTHR11132', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 35', NULL, NULL, NULL, 8),
(247696, NULL, 'PTHR12505', NULL, NULL, NULL, NULL, 'PHD FINGER TRANSCRIPTION FACTOR', NULL, NULL, NULL, 8),
(247697, NULL, 'PTHR47844', NULL, NULL, NULL, NULL, 'SYNTHASE CPS1, PUTATIVE (AFU_ORTHOLOGUE AFUA_7G02500)-RELATED', NULL, NULL, NULL, 8),
(247698, NULL, 'PTHR43681', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE GTPASE FZO', NULL, NULL, NULL, 8),
(247699, NULL, 'PTHR28624', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 51', NULL, NULL, 32853, 8),
(247700, NULL, 'PTHR21963', NULL, NULL, NULL, NULL, 'PF6', NULL, NULL, 25114, 8),
(247701, NULL, 'PTHR46586', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(247702, NULL, 'PTHR16301', NULL, NULL, NULL, NULL, 'IMPACT-RELATED', NULL, NULL, 21082, 8),
(247703, NULL, 'PTHR33076', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID-TRANSFER PROTEIN 2-RELATED', NULL, NULL, 5625, 8),
(247704, NULL, 'PTHR35892', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN PAGN-RELATED', NULL, NULL, NULL, 8),
(247705, NULL, 'PTHR30327', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN YQGE', NULL, NULL, 2682, 8),
(247706, NULL, 'PTHR47047', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED-RELATED', NULL, NULL, NULL, 8),
(247707, NULL, 'PTHR34788', NULL, NULL, NULL, NULL, 'F15I1.22', NULL, NULL, NULL, 8),
(247708, NULL, 'PTHR35350', NULL, NULL, NULL, NULL, 'HYPOTHETICAL LOC314168', NULL, NULL, 27291, 8),
(247709, NULL, 'PTHR23408', NULL, NULL, NULL, NULL, 'METHYLMALONYL-COA MUTASE', NULL, NULL, 7253, 8),
(247710, NULL, 'PTHR21665', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 26048, 8),
(247711, NULL, 'PTHR39940', NULL, NULL, NULL, NULL, 'PROTHORACICOTROPIC HORMONE, ISOFORM F', NULL, NULL, NULL, 8),
(247712, NULL, 'PTHR37517', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(247713, NULL, 'PTHR10629', NULL, NULL, NULL, NULL, 'CYTOSINE-SPECIFIC METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(247714, NULL, 'PTHR20905', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE-RELATED', NULL, NULL, NULL, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(247715, NULL, 'PTHR33835', NULL, NULL, NULL, NULL, 'YALI0C07656P', NULL, NULL, 24951, 8),
(247716, NULL, 'PTHR45816', NULL, NULL, NULL, NULL, 'MIR DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(247717, NULL, 'PTHR47228', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 16', NULL, NULL, 26962, 8),
(247718, NULL, 'PTHR39184', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(247719, NULL, 'PTHR12346', NULL, NULL, NULL, NULL, 'SIN3B-RELATED', NULL, NULL, 29634, 8),
(247720, NULL, 'PTHR35765', NULL, NULL, NULL, NULL, 'OS05G0569200 PROTEIN', NULL, NULL, 18738, 8),
(247721, NULL, 'PTHR23152', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE DEHYDROGENASE', NULL, NULL, 11158, 8),
(247722, NULL, 'PTHR12214', NULL, NULL, NULL, NULL, 'GC-RICH SEQUENCE DNA-BINDING FACTOR', NULL, NULL, 13154, 8),
(247723, NULL, 'PTHR13273', NULL, NULL, NULL, NULL, 'ANAMORSIN', NULL, NULL, 2358, 8),
(247724, NULL, 'PTHR12895', NULL, NULL, NULL, NULL, 'DYMECLIN', NULL, NULL, 18028, 8),
(247725, NULL, 'PTHR39322', NULL, NULL, NULL, NULL, 'ACYL-HOMOSERINE-LACTONE SYNTHASE', NULL, NULL, 3015, 8),
(247726, NULL, 'PTHR34772', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN HFQ', NULL, NULL, 831, 8),
(247727, NULL, 'PTHR43920', NULL, NULL, NULL, NULL, 'CHLORIDE INTRACELLULAR CHANNEL, ISOFORM A', NULL, NULL, NULL, 8),
(247728, NULL, 'PTHR33571', NULL, NULL, NULL, NULL, 'SSL8005 PROTEIN', NULL, NULL, NULL, 8),
(247729, NULL, 'PTHR11852', NULL, NULL, NULL, NULL, 'PLATELET-ACTIVATING FACTOR ACETYLHYDROLASE', NULL, NULL, NULL, 8),
(247730, NULL, 'PTHR12444', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(247731, NULL, 'PTHR11956', NULL, NULL, NULL, NULL, 'ARGINYL-TRNA SYNTHETASE', NULL, NULL, 34, 8),
(247732, NULL, 'PTHR36561', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(247733, NULL, 'PTHR11819', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 5', NULL, NULL, NULL, 8),
(247734, NULL, 'PTHR35410', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(247735, NULL, 'PTHR35687', NULL, NULL, NULL, NULL, 'OS07G0516700 PROTEIN', NULL, NULL, NULL, 8),
(247736, NULL, 'PTHR32488', NULL, NULL, NULL, NULL, 'UPF0746 PROTEIN DDB_G0280785-RELATED', NULL, NULL, NULL, 8),
(247737, NULL, 'PTHR32479', NULL, NULL, NULL, NULL, 'GLYCOLATE OXIDASE IRON-SULFUR SUBUNIT', NULL, NULL, NULL, 8),
(247738, NULL, 'PTHR24085', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR', NULL, NULL, NULL, 8),
(247739, NULL, 'PTHR45861', NULL, NULL, NULL, NULL, 'DNA POLYMERASE ALPHA CATALYTIC SUBUNIT', NULL, NULL, NULL, 8),
(247740, NULL, 'PTHR23110', NULL, NULL, NULL, NULL, 'BTB DOMAIN TRANSCRIPTION FACTOR', NULL, NULL, NULL, 8),
(247741, NULL, 'PTHR47860', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP17-1, CHLOROPLASTIC', NULL, NULL, 36922, 8),
(247742, NULL, 'PTHR35849', NULL, NULL, NULL, NULL, 'BLR2341 PROTEIN', NULL, NULL, NULL, 8),
(247743, NULL, 'PTHR43477', NULL, NULL, NULL, NULL, 'DIHYDROANTICAPSIN 7-DEHYDROGENASE', NULL, NULL, NULL, 8),
(247744, NULL, 'PTHR24394', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', NULL, NULL, NULL, 8),
(247745, NULL, 'PTHR46740', NULL, NULL, NULL, NULL, 'PROTEIN DYAD', NULL, NULL, 34543, 8),
(247746, NULL, 'PTHR47945', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 84A1-RELATED', NULL, NULL, NULL, 8),
(247747, NULL, 'PTHR31711', NULL, NULL, NULL, NULL, 'ARGININE AND GLUTAMATE-RICH PROTEIN 1', NULL, NULL, 27818, 8),
(247748, NULL, 'PTHR12914', NULL, NULL, NULL, NULL, 'PARTNER OF SLD5', NULL, NULL, 6456, 8),
(247749, NULL, 'PTHR22778', NULL, NULL, NULL, NULL, 'OVARIAN CANCER GENE-2 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(247750, NULL, 'PTHR47376', NULL, NULL, NULL, NULL, 'OS02G0597700 PROTEIN', NULL, NULL, NULL, 8),
(247751, NULL, 'PTHR46084', NULL, NULL, NULL, NULL, 'PROTEIN MALE DISCOVERER 2', NULL, NULL, NULL, 8),
(247752, NULL, 'PTHR23253', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4 GAMMA', NULL, NULL, 36699, 8),
(247753, NULL, 'PTHR42731', NULL, NULL, NULL, NULL, 'SLL1084 PROTEIN', NULL, NULL, NULL, 8),
(247754, NULL, 'PTHR16130', NULL, NULL, NULL, NULL, 'LYSOSOMAL COBALAMIN TRANSPORTER-RELATED', NULL, NULL, NULL, 8);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(247755, NULL, 'PTHR47493', NULL, NULL, NULL, NULL, 'OS08G0520200 PROTEIN', NULL, NULL, NULL, 8),
(247756, NULL, 'PTHR42034', NULL, NULL, NULL, NULL, 'CHROMOSOME 7, WHOLE GENOME SHOTGUN SEQUENCE-RELATED', NULL, NULL, NULL, 8),
(247757, NULL, 'PTHR42030', NULL, NULL, NULL, NULL, 'DRBM DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(247758, NULL, 'PTHR12582', NULL, NULL, NULL, NULL, 'NETRIN RECEPTOR UNC5', NULL, NULL, 32648, 8),
(247759, NULL, 'PTHR11080', NULL, NULL, NULL, NULL, 'PYRAZINAMIDASE/NICOTINAMIDASE', NULL, NULL, NULL, 8),
(247760, NULL, 'PTHR47799', NULL, NULL, NULL, NULL, 'OMEGA-AMIDASE YAFV', NULL, NULL, NULL, 8),
(247761, NULL, 'PTHR47373', NULL, NULL, NULL, NULL, 'CYSTEINE PROTEINASE INHIBITOR 2', NULL, NULL, NULL, 8),
(247762, NULL, 'PTHR11390', NULL, NULL, NULL, NULL, 'PROKARYOTIC DNA TOPOISOMERASE', NULL, NULL, 6663, 8),
(247763, NULL, 'PTHR45702', NULL, NULL, NULL, NULL, 'ADAM10/ADAM17 METALLOPEPTIDASE FAMILY MEMBER', NULL, NULL, NULL, 8),
(247764, NULL, 'PTHR16237', NULL, NULL, NULL, NULL, 'ODONTOGENIC AMELOBLAST-ASSOCIATED PROTEIN', NULL, NULL, 22364, 8),
(247765, NULL, 'PTHR47154', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR MTH-RELATED', NULL, NULL, NULL, 8),
(247766, NULL, 'PTHR35368', NULL, NULL, NULL, NULL, 'HYDROPEROXIDE REDUCTASE', NULL, NULL, NULL, 8),
(247767, NULL, 'PTHR45153', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 16', NULL, NULL, NULL, 8),
(247768, NULL, 'PTHR30558', NULL, NULL, NULL, NULL, 'EXBD MEMBRANE COMPONENT OF PMF-DRIVEN MACROMOLECULE IMPORT SYSTEM', NULL, NULL, 5220, 8),
(247769, NULL, 'PTHR15732', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 24234, 8),
(247770, NULL, 'PTHR46564', NULL, NULL, NULL, NULL, 'TRANSPOSASE', NULL, NULL, NULL, 8),
(247771, NULL, 'PTHR33918', NULL, NULL, NULL, NULL, 'OS01G0704200 PROTEIN', NULL, NULL, NULL, 8),
(247772, NULL, 'PTHR39594', NULL, NULL, NULL, NULL, 'PROTEIN YCHQ', NULL, NULL, 5810, 8),
(247773, NULL, 'PTHR28058', NULL, NULL, NULL, NULL, '37S RIBOSOMAL PROTEIN MRP51, MITOCHONDRIAL', NULL, NULL, 20327, 8),
(247774, NULL, 'PTHR48170', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(247775, NULL, 'PTHR40267', NULL, NULL, NULL, NULL, 'BLR3294 PROTEIN', NULL, NULL, 24981, 8),
(247776, NULL, 'PTHR23539', NULL, NULL, NULL, NULL, 'MFS TRANSPORTER', NULL, NULL, NULL, 8),
(247777, NULL, 'PTHR24299', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 FAMILY 1', NULL, NULL, NULL, 8),
(247778, NULL, 'PTHR33753', NULL, NULL, NULL, NULL, '1,4-BETA-D-GLUCAN CELLOBIOHYDROLASE B', NULL, NULL, 3402, 8),
(247779, NULL, 'PTHR43071', NULL, NULL, NULL, NULL, '2-AMINO-4-HYDROXY-6-HYDROXYMETHYLDIHYDROPTERIDINE PYROPHOSPHOKINASE', NULL, NULL, NULL, 8),
(247780, NULL, 'PTHR15578', NULL, NULL, NULL, NULL, 'CHROMOSOME 8 C22ORF31 HOMOLOG', NULL, NULL, 24971, 8),
(247781, NULL, 'PTHR21636', NULL, NULL, NULL, NULL, 'PROTEIN DOK-7', NULL, NULL, 28272, 8),
(247782, NULL, 'PTHR11406', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCERATE KINASE', NULL, NULL, 5397, 8),
(247783, NULL, 'PTHR35979', NULL, NULL, NULL, NULL, 'SINGLE-PASS MEMBRANE AND COILED-COIL DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, 23955, 8),
(247784, NULL, 'PTHR44991', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN SUPERFAMILY MEMBER 5', NULL, NULL, 37539, 8),
(247785, NULL, 'PTHR43863', NULL, NULL, NULL, NULL, 'HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G03140)-RELATED', NULL, NULL, NULL, 8),
(247786, NULL, 'PTHR47431', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', NULL, NULL, NULL, 8),
(247787, NULL, 'PTHR42686', NULL, NULL, NULL, NULL, 'GH17980P-RELATED', NULL, NULL, 19615, 8),
(247788, NULL, 'PTHR13451', NULL, NULL, NULL, NULL, 'CLASS II CROSSOVER JUNCTION ENDONUCLEASE MUS81', NULL, NULL, 33538, 8),
(247789, NULL, 'PTHR20982', NULL, NULL, NULL, NULL, 'RIBOSOME RECYCLING FACTOR', NULL, NULL, 2767, 8),
(247790, NULL, 'PTHR43064', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLAMINOIMIDAZOLE CARBOXYLASE-RELATED', NULL, NULL, 31481, 8),
(247791, NULL, 'PTHR33401', NULL, NULL, NULL, NULL, 'LIGHT-HARVESTING COMPLEX-LIKE PROTEIN OHP2, CHLOROPLASTIC', NULL, NULL, NULL, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(247792, NULL, 'PTHR36880', NULL, NULL, NULL, NULL, '9130008F23RIK PROTEIN', NULL, NULL, 27171, 8),
(247793, NULL, 'PTHR16194', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 16', NULL, NULL, 22184, 8),
(247794, NULL, 'PTHR41786', NULL, NULL, NULL, NULL, 'MOTILITY ACCESSORY FACTOR MAF', NULL, NULL, NULL, 8),
(247795, NULL, 'PTHR33558', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN-LIKE PROTEIN C5ORF63 HOMOLOG', NULL, NULL, NULL, 8),
(247796, NULL, 'PTHR45859', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR EIF-2B SUBUNIT BETA', NULL, NULL, NULL, 8),
(247797, NULL, 'PTHR35757', NULL, NULL, NULL, NULL, 'THERMOSOME SUBUNIT GAMMA', NULL, NULL, NULL, 8),
(247798, NULL, 'PTHR46562', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-KINASE ULK4-LIKE PROTEIN-RELATED', NULL, NULL, 34058, 8),
(247799, NULL, 'PTHR42971', NULL, NULL, NULL, NULL, 'TRNA (CYTIDINE(34)-2''-O)-METHYLTRANSFERASE', NULL, NULL, 17296, 8),
(247800, NULL, 'PTHR47283', NULL, NULL, NULL, NULL, 'ENT-KAURENE OXIDASE, CHLOROPLASTIC', NULL, NULL, 34610, 8),
(247801, NULL, 'PTHR17609', NULL, NULL, NULL, NULL, 'HMG DOMAIN-CONTAINING PROTEIN 3', NULL, NULL, 33994, 8),
(247802, NULL, 'PTHR47757', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS E (EPSILON)-RELATED', NULL, NULL, NULL, 8),
(247803, NULL, 'PTHR35130', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 16', NULL, NULL, 32408, 8),
(247804, NULL, 'PTHR20886', NULL, NULL, NULL, NULL, 'VANG-LIKE PROTEIN', NULL, NULL, 10463, 8),
(247805, NULL, 'PTHR46458', NULL, NULL, NULL, NULL, 'BLR2807 PROTEIN', NULL, NULL, NULL, 8),
(247806, NULL, 'PTHR10804', NULL, NULL, NULL, NULL, 'PROTEASE FAMILY M24  METHIONYL AMINOPEPTIDASE, AMINOPEPTIDASE P', NULL, NULL, NULL, 8),
(247807, NULL, 'PTHR14209', NULL, NULL, NULL, NULL, 'ISOAMYL ACETATE-HYDROLYZING ESTERASE 1', NULL, NULL, 36592, 8),
(247808, NULL, 'PTHR20371', NULL, NULL, NULL, NULL, 'ENOLASE-PHOSPHATASE E1', NULL, NULL, NULL, 8),
(247809, NULL, 'PTHR46897', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE PROTEIN 4', NULL, NULL, 34115, 8),
(247810, NULL, 'PTHR42100', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE 178 KDA SUBUNIT, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G04320)-RELATED', NULL, NULL, 7296, 8),
(247811, NULL, 'PTHR44144', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 9', NULL, NULL, NULL, 8),
(247812, NULL, 'PTHR11786', NULL, NULL, NULL, NULL, 'N-HYDROXYARYLAMINE O-ACETYLTRANSFERASE', NULL, NULL, 3105, 8),
(247813, NULL, 'PTHR33090', NULL, NULL, NULL, NULL, 'DUF3774 DOMAIN PROTEIN-RELATED', NULL, NULL, 21135, 8),
(247814, NULL, 'PTHR37947', NULL, NULL, NULL, NULL, 'BLL2462 PROTEIN', NULL, NULL, NULL, 8),
(247815, NULL, 'PTHR21469', NULL, NULL, NULL, NULL, 'EXOPHILIN-5', NULL, NULL, 27308, 8),
(247816, NULL, 'PTHR34809', NULL, NULL, NULL, NULL, 'MALTOSE EXCESS PROTEIN 1, CHLOROPLASTIC-RELATED', NULL, NULL, 17574, 8),
(247817, NULL, 'PTHR46406', NULL, NULL, NULL, NULL, 'NITRIC OXIDE-ASSOCIATED PROTEIN 1', NULL, NULL, NULL, 8),
(247818, NULL, 'PTHR42240', NULL, NULL, NULL, NULL, '', NULL, NULL, 3210, 8),
(247819, NULL, 'PTHR23515', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY NITRATE TRANSPORTER 2.3', NULL, NULL, 34632, 8),
(247820, NULL, 'PTHR34986', NULL, NULL, NULL, NULL, 'EVOLVED BETA-GALACTOSIDASE SUBUNIT BETA', NULL, NULL, 5090, 8),
(247821, NULL, 'PTHR14657', NULL, NULL, NULL, NULL, 'IGF-LIKE FAMILY RECEPTOR 1', NULL, NULL, 34621, 8),
(247822, NULL, 'PTHR26450', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR 56B1-RELATED', NULL, NULL, NULL, 8),
(247823, NULL, 'PTHR21465', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 469', NULL, NULL, 32818, 8),
(247824, NULL, 'PTHR14911', NULL, NULL, NULL, NULL, 'THUMP DOMAIN-CONTAINING', NULL, NULL, NULL, 8),
(247825, NULL, 'PTHR19969', NULL, NULL, NULL, NULL, 'SH2-SH3 ADAPTOR PROTEIN-RELATED', NULL, NULL, NULL, 8),
(247826, NULL, 'PTHR28574', NULL, NULL, NULL, NULL, 'RIKEN CDNA 6820408C15', NULL, NULL, 21835, 8),
(247827, NULL, 'PTHR42105', NULL, NULL, NULL, NULL, 'DIM2-ASSOCIATED PROTEIN 1', NULL, NULL, NULL, 8),
(247828, NULL, 'PTHR12125', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 6-LIKE PROTEIN', NULL, NULL, 28812, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(247829, NULL, 'PTHR47505', NULL, NULL, NULL, NULL, 'DNA UTILIZATION PROTEIN YHGH', NULL, NULL, NULL, 8),
(247830, NULL, 'PTHR46394', NULL, NULL, NULL, NULL, 'ANNEXIN', NULL, NULL, NULL, 8),
(247831, NULL, 'PTHR48017', NULL, NULL, NULL, NULL, 'OS05G0424000 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(247832, NULL, 'PTHR46189', NULL, NULL, NULL, NULL, 'LD41958P', NULL, NULL, 37310, 8),
(247833, NULL, 'PTHR21505', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(247834, NULL, 'PTHR11086', NULL, NULL, NULL, NULL, 'DEOXYCYTIDYLATE DEAMINASE-RELATED', NULL, NULL, 8141, 8),
(247835, NULL, 'PTHR46218', NULL, NULL, NULL, NULL, 'LASP', NULL, NULL, NULL, 8),
(247836, NULL, 'PTHR11835', NULL, NULL, NULL, NULL, 'DECARBOXYLATING DEHYDROGENASES-ISOCITRATE, ISOPROPYLMALATE, TARTRATE', NULL, NULL, NULL, 8),
(247837, NULL, 'PTHR32133', NULL, NULL, NULL, NULL, 'OS07G0120400 PROTEIN', NULL, NULL, NULL, 8),
(247838, NULL, 'PTHR12101', NULL, NULL, NULL, NULL, 'POPEYE DOMAIN CONTAINING PROTEIN', NULL, NULL, 4896, 8),
(247839, NULL, 'PTHR22639', NULL, NULL, NULL, NULL, 'GAG-RELATED PROTEIN', NULL, NULL, 36527, 8),
(247840, NULL, 'PTHR10571', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE--DOLICHYL-PHOSPHATE N-ACETYLGLUCOSAMINEPHOSPHOTRANSFERASE', NULL, NULL, 32459, 8),
(247841, NULL, 'PTHR46090', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 13B', NULL, NULL, NULL, 8),
(247842, NULL, 'PTHR10033', NULL, NULL, NULL, NULL, 'CALSEQUESTRIN', NULL, NULL, NULL, 8),
(247843, NULL, 'PTHR17204', NULL, NULL, NULL, NULL, 'PRE-MRNA PROCESSING PROTEIN PRP39-RELATED', NULL, NULL, NULL, 8),
(247844, NULL, 'PTHR47056', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 39', NULL, NULL, 34805, 8),
(247845, NULL, 'PTHR40101', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', NULL, NULL, NULL, 8),
(247846, NULL, 'PTHR46611', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS X-RELATED', NULL, NULL, NULL, 8),
(247847, NULL, 'PTHR40841', NULL, NULL, NULL, NULL, 'SIDEROPHORE TRIACETYLFUSARININE C ESTERASE', NULL, NULL, NULL, 8),
(247848, NULL, 'PTHR24254', NULL, NULL, NULL, NULL, 'PROTHROMBIN', NULL, NULL, NULL, 8),
(247849, NULL, 'PTHR47229', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 141', NULL, NULL, 23420, 8),
(247850, NULL, 'PTHR11106', NULL, NULL, NULL, NULL, 'GANGLIOSIDE INDUCED DIFFERENTIATION ASSOCIATED PROTEIN 2-RELATED', NULL, NULL, NULL, 8),
(247851, NULL, 'PTHR17985', NULL, NULL, NULL, NULL, 'SER/THR-RICH PROTEIN T10 IN DGCR REGION', NULL, NULL, 13230, 8),
(247852, NULL, 'PTHR43780', NULL, NULL, NULL, NULL, '1-AMINOCYCLOPROPANE-1-CARBOXYLATE DEAMINASE-RELATED', NULL, NULL, 26478, 8),
(247853, NULL, 'PTHR31778', NULL, NULL, NULL, NULL, 'BUD SITE SELECTION PROTEIN RAX2', NULL, NULL, NULL, 8),
(247854, NULL, 'PTHR46031', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(247855, NULL, 'PTHR47662', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(247856, NULL, 'PTHR14593', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 11', NULL, NULL, 27555, 8),
(247857, NULL, 'PTHR35845', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED SERINE-RICH PROTEIN 1', NULL, NULL, 21644, 8),
(247858, NULL, 'PTHR31716', NULL, NULL, NULL, NULL, 'PROTEIN FMC1 HOMOLOG', NULL, NULL, 32718, 8),
(247859, NULL, 'PTHR12395', NULL, NULL, NULL, NULL, 'DOM-3 RELATED', NULL, NULL, 28443, 8),
(247860, NULL, 'PTHR34002', NULL, NULL, NULL, NULL, 'BLR1656 PROTEIN', NULL, NULL, 1678, 8),
(247861, NULL, 'PTHR42848', NULL, NULL, NULL, NULL, '', NULL, NULL, 939, 8),
(247862, NULL, 'PTHR12022', NULL, NULL, NULL, NULL, 'UBIQUINOL-CYTOCHROME C REDUCTASE COMPLEX 14 KD PROTEIN', NULL, NULL, 3057, 8),
(247863, NULL, 'PTHR43237', NULL, NULL, NULL, NULL, 'NADP-DEPENDENT MALIC ENZYME', NULL, NULL, NULL, 8),
(247864, NULL, 'PTHR13778', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE 8 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(247865, NULL, 'PTHR21190', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(247866, NULL, 'PTHR36222', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR RV3364C', NULL, NULL, NULL, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(247867, NULL, 'PTHR35303', NULL, NULL, NULL, NULL, 'OS02G0197800 PROTEIN', NULL, NULL, NULL, 8),
(247868, NULL, 'PTHR12135', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN XP-C / RAD4', NULL, NULL, 633, 8),
(247869, NULL, 'PTHR14334', NULL, NULL, NULL, NULL, 'B-CELL ANTIGEN RECEPTOR COMPLEX-ASSOCIATED PROTEIN', NULL, NULL, 31214, 8),
(247870, NULL, 'PTHR47145', NULL, NULL, NULL, NULL, 'BPI FOLD-CONTAINING FAMILY A MEMBER 2', NULL, NULL, NULL, 8),
(247871, NULL, 'PTHR21845', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE ANCHOR PROTEIN 1', NULL, NULL, 22187, 8),
(247872, NULL, 'PTHR35593', NULL, NULL, NULL, NULL, 'LISH DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(247873, NULL, 'PTHR42706', NULL, NULL, NULL, NULL, 'FORMYLTETRAHYDROFOLATE DEFORMYLASE', NULL, NULL, 4457, 8),
(247874, NULL, 'PTHR10654', NULL, NULL, NULL, NULL, 'CAS SCAFFOLDING PROTEIN', NULL, NULL, 29610, 8),
(247875, NULL, 'PTHR34397', NULL, NULL, NULL, NULL, 'OS05G0237600 PROTEIN', NULL, NULL, NULL, 8),
(247876, NULL, 'PTHR46714', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR HAC1', NULL, NULL, 36038, 8),
(247877, NULL, 'PTHR47710', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN', NULL, NULL, 34965, 8),
(247878, NULL, 'PTHR40062', NULL, NULL, NULL, NULL, 'GTP-SENSING TRANSCRIPTIONAL PLEIOTROPIC REPRESSOR CODY', NULL, NULL, 14459, 8),
(247879, NULL, 'PTHR21566', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 3056, 8),
(247880, NULL, 'PTHR43861', NULL, NULL, NULL, NULL, 'TRANS-ACONITATE 2-METHYLTRANSFERASE-RELATED', NULL, NULL, NULL, 8),
(247881, NULL, 'PTHR28036', NULL, NULL, NULL, NULL, 'DASH COMPLEX SUBUNIT DAD2', NULL, NULL, 7720, 8),
(247882, NULL, 'PTHR14211', NULL, NULL, NULL, NULL, 'GLIOMA SUPPRESSOR CANDIDATE REGION GENE 2', NULL, NULL, 10804, 8),
(247883, NULL, 'PTHR13512', NULL, NULL, NULL, NULL, 'MEDIATOR COMPLEX SUBUNIT 28', NULL, NULL, 18509, 8),
(247884, NULL, 'PTHR42032', NULL, NULL, NULL, NULL, 'YALI0E30679P', NULL, NULL, NULL, 8),
(247885, NULL, 'PTHR43549', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN YPNP-RELATED', NULL, NULL, NULL, 8),
(247886, NULL, 'PTHR13891', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 32040, 8),
(247887, NULL, 'PTHR47750', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN SNE', NULL, NULL, 37000, 8),
(247888, NULL, 'PTHR36608', NULL, NULL, NULL, NULL, 'POLYPHENOL OXIDASE C, CHLOROPLASTIC-LIKE', NULL, NULL, NULL, 8),
(247889, NULL, 'PTHR38613', NULL, NULL, NULL, NULL, 'PROTEIN CBG03211-RELATED', NULL, NULL, NULL, 8),
(247890, NULL, 'PTHR15705', NULL, NULL, NULL, NULL, 'MCG7194, ISOFORM CRA_A', NULL, NULL, NULL, 8),
(247891, NULL, 'PTHR21431', NULL, NULL, NULL, NULL, 'PREFOLDIN SUBUNIT 6', NULL, NULL, NULL, 8),
(247892, NULL, 'PTHR13338', NULL, NULL, NULL, NULL, 'UPF0240 PROTEIN', NULL, NULL, 1686, 8),
(247893, NULL, 'PTHR40943', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', NULL, NULL, NULL, 8),
(247894, NULL, 'PTHR46718', NULL, NULL, NULL, NULL, 'ASPARTATE-SEMIALDEHYDE DEHYDROGENASE', NULL, NULL, NULL, 8),
(247895, NULL, 'PTHR11595', NULL, NULL, NULL, NULL, 'EF-HAND AND COILED-COIL DOMAIN-CONTAINING FAMILY MEMBER', NULL, NULL, NULL, 8),
(247896, NULL, 'PTHR15740', NULL, NULL, NULL, NULL, 'NEUROPROTECTIVE PEPTIDE-CONTAINING PROTEIN', NULL, NULL, 32844, 8),
(247897, NULL, 'PTHR42646', NULL, NULL, NULL, NULL, 'FLAP ENDONUCLEASE XNI', NULL, NULL, 30634, 8),
(247898, NULL, 'PTHR23227', NULL, NULL, NULL, NULL, 'BUCENTAUR RELATED', NULL, NULL, 22423, 8),
(247899, NULL, 'PTHR40254', NULL, NULL, NULL, NULL, 'BLR0577 PROTEIN', NULL, NULL, NULL, 8),
(247900, NULL, 'PTHR47902', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 119', NULL, NULL, NULL, 8),
(247901, NULL, 'PTHR15541', NULL, NULL, NULL, NULL, 'GRANULYSIN RELATED', NULL, NULL, 32997, 8),
(247902, NULL, 'PTHR47728', NULL, NULL, NULL, NULL, 'RAB GTPASE-ACTIVATING PROTEIN 1-LIKE', NULL, NULL, NULL, 8),
(247903, NULL, 'PTHR15863', NULL, NULL, NULL, NULL, 'MRN COMPLEX-INTERACTING PROTEIN', NULL, NULL, 21859, 8),
(247904, NULL, 'PTHR12461', NULL, NULL, NULL, NULL, 'HYPOXIA-INDUCIBLE FACTOR 1 ALPHA INHIBITOR-RELATED', NULL, NULL, NULL, 8);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(247905, NULL, 'PTHR31558', NULL, NULL, NULL, NULL, 'CW14 PROTEIN', NULL, NULL, NULL, 8),
(247906, NULL, 'PTHR46996', NULL, NULL, NULL, NULL, 'OS05G0488500 PROTEIN', NULL, NULL, NULL, 8),
(247907, NULL, 'PTHR47859', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(247908, NULL, 'PTHR36521', NULL, NULL, NULL, NULL, 'GEO07177P1', NULL, NULL, NULL, 8),
(247909, NULL, 'PTHR47484', NULL, NULL, NULL, NULL, 'COMPLEX 1 PROTEIN CONTAINING PROTEIN, EXPRESSED', NULL, NULL, NULL, 8),
(247910, NULL, 'PTHR14139', NULL, NULL, NULL, NULL, 'CALSYNTENIN', NULL, NULL, 26873, 8),
(247911, NULL, 'PTHR38166', NULL, NULL, NULL, NULL, 'C2H2-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(247912, NULL, 'PTHR23159', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN 2', NULL, NULL, NULL, 8),
(247913, NULL, 'PTHR43854', NULL, NULL, NULL, NULL, 'INDOLEPYRUVATE OXIDOREDUCTASE SUBUNIT IORB', NULL, NULL, NULL, 8),
(247914, NULL, 'PTHR38733', NULL, NULL, NULL, NULL, 'PROTEIN MCRC', NULL, NULL, 19883, 8),
(247915, NULL, 'PTHR11514', NULL, NULL, NULL, NULL, 'MYC', NULL, NULL, 35980, 8),
(247916, NULL, 'PTHR43462', NULL, NULL, NULL, NULL, 'ALANYL-TRNA EDITING PROTEIN', NULL, NULL, NULL, 8),
(247917, NULL, 'PTHR36916', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(247918, NULL, 'PTHR43833', NULL, NULL, NULL, NULL, 'POTASSIUM CHANNEL PROTEIN 2-RELATED-RELATED', NULL, NULL, NULL, 8),
(247919, NULL, 'PTHR12318', NULL, NULL, NULL, NULL, 'TESTOSTERONE-REGULATED PROTEIN RP2', NULL, NULL, 32585, 8),
(247920, NULL, 'PTHR47347', NULL, NULL, NULL, NULL, 'GOLGIN CANDIDATE 5', NULL, NULL, NULL, 8),
(247921, NULL, 'PTHR43114', NULL, NULL, NULL, NULL, 'ADENINE DEAMINASE', NULL, NULL, 4550, 8),
(247922, NULL, 'PTHR23535', NULL, NULL, NULL, NULL, 'SUGAR EFFLUX TRANSPORTER A-RELATED', NULL, NULL, NULL, 8),
(247923, NULL, 'PTHR41805', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(247924, NULL, 'PTHR39083', NULL, NULL, NULL, NULL, 'CYCLIC DI-GMP-BINDING PROTEIN', NULL, NULL, 14839, 8),
(247925, NULL, 'PTHR42905', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYLASE', NULL, NULL, NULL, 8),
(247926, NULL, 'PTHR47747', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P PROTEIN SUBUNIT P38-LIKE PROTEIN', NULL, NULL, NULL, 8),
(247927, NULL, 'PTHR16193', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 34268, 8),
(247928, NULL, 'PTHR47815', NULL, NULL, NULL, NULL, 'UNIVERSAL STRESS PROTEIN A FAMILY PROTEIN C25B2.10', NULL, NULL, NULL, 8),
(247929, NULL, 'PTHR46147', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE ASH1', NULL, NULL, NULL, 8),
(247930, NULL, 'PTHR28635', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE INNER EAR EXPRESSED PROTEIN', NULL, NULL, 25837, 8),
(247931, NULL, 'PTHR13217', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY G MEMBER 7', NULL, NULL, 27237, 8),
(247932, NULL, 'PTHR31052', NULL, NULL, NULL, NULL, 'COBRA-LIKE PROTEIN 7', NULL, NULL, NULL, 8),
(247933, NULL, 'PTHR36381', NULL, NULL, NULL, NULL, 'ETHYLENE-REGULATED TRANSCRIPT 2 (ERT2)', NULL, NULL, NULL, 8),
(247934, NULL, 'PTHR43088', NULL, NULL, NULL, NULL, 'SUBUNIT OF PYRUVATE:FLAVODOXIN OXIDOREDUCTASE-RELATED', NULL, NULL, NULL, 8),
(247935, NULL, 'PTHR38038', NULL, NULL, NULL, NULL, 'PENICILLIN-BINDING PROTEIN ACTIVATOR LPOA', NULL, NULL, 4819, 8),
(247936, NULL, 'PTHR35388', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(247937, NULL, 'PTHR42784', NULL, NULL, NULL, NULL, 'PYRANOSE 2-OXIDASE', NULL, NULL, NULL, 8),
(247938, NULL, 'PTHR13675', NULL, NULL, NULL, NULL, 'LYR MOTIF-CONTAINING PROTEIN 2', NULL, NULL, NULL, 8),
(247939, NULL, 'PTHR34774', NULL, NULL, NULL, NULL, 'EPHRIN-A3 PROTEIN', NULL, NULL, NULL, 8),
(247940, NULL, 'PTHR30212', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(247941, NULL, 'PTHR39420', NULL, NULL, NULL, NULL, '', NULL, NULL, 18201, 8),
(247942, NULL, 'PTHR42266', NULL, NULL, NULL, NULL, 'GIM5B PROTEIN', NULL, NULL, NULL, 8),
(247943, NULL, 'PTHR11516', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT, ALPHA SUBUNIT  BACTERIAL AND ORGANELLAR', NULL, NULL, NULL, 8);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(247944, NULL, 'PTHR45826', NULL, NULL, NULL, NULL, 'POLYAMINE TRANSPORTER PUT1', NULL, NULL, 36449, 8),
(247945, NULL, 'PTHR11236', NULL, NULL, NULL, NULL, 'AMINOBENZOATE/ANTHRANILATE SYNTHASE', NULL, NULL, 16676, 8),
(247946, NULL, 'PTHR35995', NULL, NULL, NULL, NULL, 'OS04G0690500 PROTEIN', NULL, NULL, NULL, 8),
(247947, NULL, 'PTHR21494', NULL, NULL, NULL, NULL, 'ACTIVATING SIGNAL COINTEGRATOR 1 COMPLEX SUBUNIT 2  ASC-1 COMPLEX SUBUNIT P100', NULL, NULL, NULL, 8),
(247948, NULL, 'PTHR10109', NULL, NULL, NULL, NULL, 'MATRIX GLA PROTEIN', NULL, NULL, 24753, 8),
(247949, NULL, 'PTHR42785', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE, TYPE IA, CORE', NULL, NULL, 6663, 8),
(247950, NULL, 'PTHR23072', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL GLYCAN-RELATED', NULL, NULL, 31321, 8),
(247951, NULL, 'PTHR23068', NULL, NULL, NULL, NULL, 'DNA  CYTOSINE-5- -METHYLTRANSFERASE 3-RELATED', NULL, NULL, NULL, 8),
(247952, NULL, 'PTHR13438', NULL, NULL, NULL, NULL, 'AMINOACYL TRNA SYNTHASE COMPLEX-INTERACTING MULTIFUNCTIONAL PROTEIN', NULL, NULL, 37418, 8),
(247953, NULL, 'PTHR12081', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR E2F', NULL, NULL, 17839, 8),
(247954, NULL, 'PTHR35083', NULL, NULL, NULL, NULL, 'RGD1565685 PROTEIN', NULL, NULL, 24277, 8),
(247955, NULL, 'PTHR42838', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT II', NULL, NULL, NULL, 8),
(247956, NULL, 'PTHR12591', NULL, NULL, NULL, NULL, 'GLUCOSE-6-PHOSPHATASE', NULL, NULL, NULL, 8),
(247957, NULL, 'PTHR44750', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE T1-RELATED', NULL, NULL, 36950, 8),
(247958, NULL, 'PTHR34827', NULL, NULL, NULL, NULL, 'INSULIN GROWTH FACTOR-LIKE FAMILY MEMBER 3-RELATED', NULL, NULL, 21512, 8),
(247959, NULL, 'PTHR33645', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE (DUF3754)', NULL, NULL, NULL, 8),
(247960, NULL, 'PTHR12845', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE EXCHANGE FACTOR', NULL, NULL, NULL, 8),
(247961, NULL, 'PTHR18911', NULL, NULL, NULL, NULL, 'CTCL TUMOR ANTIGEN HD-CL-01', NULL, NULL, 30542, 8),
(247962, NULL, 'PTHR23139', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN', NULL, NULL, NULL, 8),
(247963, NULL, 'PTHR46838', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 14', NULL, NULL, NULL, 8),
(247964, NULL, 'PTHR31723', NULL, NULL, NULL, NULL, 'PATHOGENESIS-RELATED FAMILY PROTEIN', NULL, NULL, NULL, 8),
(247965, NULL, 'PTHR47950', NULL, NULL, NULL, NULL, 'CYTOCHROME P450, FAMILY 76, SUBFAMILY C, POLYPEPTIDE 5-RELATED', NULL, NULL, NULL, 8),
(247966, NULL, 'PTHR33387', NULL, NULL, NULL, NULL, 'RMLC-LIKE JELLY ROLL FOLD PROTEIN', NULL, NULL, 27403, 8),
(247967, NULL, 'PTHR24114', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT FAMILY PROTEIN', NULL, NULL, NULL, 8),
(247968, NULL, 'PTHR45638', NULL, NULL, NULL, NULL, 'CYCLIC NUCLEOTIDE-GATED CATION CHANNEL SUBUNIT A', NULL, NULL, NULL, 8),
(247969, NULL, 'PTHR21514', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 32596, 8),
(247970, NULL, 'PTHR34529', NULL, NULL, NULL, NULL, 'AP-1 COMPLEX-ASSOCIATED REGULATORY PROTEIN', NULL, NULL, 23000, 8),
(247971, NULL, 'PTHR13235', NULL, NULL, NULL, NULL, 'SINGLE-STRAND SELECTIVE MONOFUNCTIONAL URACIL DNA GLYCOSYLASE', NULL, NULL, 27654, 8),
(247972, NULL, 'PTHR37385', NULL, NULL, NULL, NULL, 'PROTEIN LOW PSII ACCUMULATION 2, CHLOROPLASTIC', NULL, NULL, 32654, 8),
(247973, NULL, 'PTHR31883', NULL, NULL, NULL, NULL, 'PROTEIN FRG2-RELATED', NULL, NULL, 21449, 8),
(247974, NULL, 'PTHR34997', NULL, NULL, NULL, NULL, 'AM15', NULL, NULL, NULL, 8),
(247975, NULL, 'PTHR10855', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 12/COP9 SIGNALOSOME COMPLEX SUBUNIT 4', NULL, NULL, 27027, 8),
(247976, NULL, 'PTHR45274', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(247977, NULL, 'PTHR42073', NULL, NULL, NULL, NULL, 'MEIOTIC EXPRESSION UP-REGULATED PROTEIN 6', NULL, NULL, 28417, 8),
(247978, NULL, 'PTHR46167', NULL, NULL, NULL, NULL, 'N-LYSINE METHYLTRANSFERASE KMT5A', NULL, NULL, NULL, 8),
(247979, NULL, 'PTHR47684', NULL, NULL, NULL, NULL, 'PROTEIN TONSOKU', NULL, NULL, 34976, 8);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(247980, NULL, 'PTHR42057', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_4G00200)', NULL, NULL, NULL, 8),
(247981, NULL, 'PTHR23166', NULL, NULL, NULL, NULL, 'FILAMIN/GPBP-INTERACTING PROTEIN', NULL, NULL, NULL, 8),
(247982, NULL, 'PTHR44042', NULL, NULL, NULL, NULL, 'DUPLICATED HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN-RELATED', NULL, NULL, 34406, 8),
(247983, NULL, 'PTHR21597', NULL, NULL, NULL, NULL, 'THO2 PROTEIN', NULL, NULL, 27429, 8),
(247984, NULL, 'PTHR31037', NULL, NULL, NULL, NULL, 'RELT-LIKE PROTEIN 1-RELATED', NULL, NULL, 34530, 8),
(247985, NULL, 'PTHR32120', NULL, NULL, NULL, NULL, 'SMALL RIBOSOMAL SUBUNIT BIOGENESIS GTPASE RSGA', NULL, NULL, 7245, 8),
(247986, NULL, 'PTHR44086', NULL, NULL, NULL, NULL, 'THIOSULFATE SULFURTRANSFERASE RDL2, MITOCHONDRIAL-RELATED', NULL, NULL, NULL, 8),
(247987, NULL, 'PTHR28474', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 72', NULL, NULL, 22610, 8),
(247988, NULL, 'PTHR47514', NULL, NULL, NULL, NULL, 'TRANSKETOLASE N-TERMINAL SECTION-RELATED', NULL, NULL, NULL, 8),
(247989, NULL, 'PTHR46083', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(247990, NULL, 'PTHR11690', NULL, NULL, NULL, NULL, 'AMILORIDE-SENSITIVE SODIUM CHANNEL-RELATED', NULL, NULL, 4205, 8),
(247991, NULL, 'PTHR43198', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL TH2 PROTEIN', NULL, NULL, NULL, 8),
(247992, NULL, 'PTHR40705', NULL, NULL, NULL, NULL, 'TRNA(ILE2) 2-AGMATINYLCYTIDINE SYNTHETASE TIAS', NULL, NULL, NULL, 8),
(247993, NULL, 'PTHR36028', NULL, NULL, NULL, NULL, 'OSJNBB0050O03.8 PROTEIN', NULL, NULL, NULL, 8),
(247994, NULL, 'PTHR34810', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN BIN4', NULL, NULL, 31881, 8),
(247995, NULL, 'PTHR31514', NULL, NULL, NULL, NULL, 'MUSCULAR LMNA-INTERACTING PROTEIN MLIP', NULL, NULL, 23670, 8),
(247996, NULL, 'PTHR37217', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(247997, NULL, 'PTHR11139', NULL, NULL, NULL, NULL, 'ATAXIA TELANGIECTASIA MUTATED  ATM -RELATED', NULL, NULL, NULL, 8),
(247998, NULL, 'PTHR12360', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSCRIPTION FACTOR, X-BOX BINDING 1  NFX1', NULL, NULL, 33217, 8),
(247999, NULL, 'PTHR22527', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 25138, 8),
(248000, NULL, 'PTHR21604', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 25932, 8),
(248001, NULL, 'PTHR46723', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT AND IQ DOMAIN-CONTAINING PROTEIN 3', NULL, NULL, NULL, 8),
(248002, NULL, 'PTHR47142', NULL, NULL, NULL, NULL, 'BETA-CATENIN-INTERACTING PROTEIN 1', NULL, NULL, 34279, 8),
(248003, NULL, 'PTHR46712', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLGLYCEROPHOSPHATASE AND PROTEIN-TYROSINE PHOSPHATASE 1', NULL, NULL, 37181, 8),
(248004, NULL, 'PTHR35113', NULL, NULL, NULL, NULL, 'FERREDOXIN-THIOREDOXIN REDUCTASE CATALYTIC CHAIN, CHLOROPLASTIC', NULL, NULL, 3779, 8),
(248005, NULL, 'PTHR15955', NULL, NULL, NULL, NULL, 'RWD DOMAIN CONTAINING PROTEIN 2', NULL, NULL, 17624, 8),
(248006, NULL, 'PTHR36077', NULL, NULL, NULL, NULL, 'BNAA02G07370D PROTEIN', NULL, NULL, NULL, 8),
(248007, NULL, 'PTHR43356', NULL, NULL, NULL, NULL, 'PHOSPHATE ACETYLTRANSFERASE', NULL, NULL, NULL, 8),
(248008, NULL, 'PTHR15813', NULL, NULL, NULL, NULL, 'SORTING NEXIN-22 AND 24', NULL, NULL, NULL, 8),
(248009, NULL, 'PTHR33459', NULL, NULL, NULL, NULL, 'DD-GDCA PROTEIN', NULL, NULL, NULL, 8),
(248010, NULL, 'PTHR43228', NULL, NULL, NULL, NULL, 'TWO-COMPONENT RESPONSE REGULATOR', NULL, NULL, NULL, 8),
(248011, NULL, 'PTHR31496', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR KAN2-RELATED', NULL, NULL, 34722, 8),
(248012, NULL, 'PTHR44163', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RNA-ASSOCIATED PROTEIN 4 HOMOLOG', NULL, NULL, 37712, 8),
(248013, NULL, 'PTHR44662', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 81', NULL, NULL, NULL, 8),
(248014, NULL, 'PTHR47903', NULL, NULL, NULL, NULL, 'OS07G0636400 PROTEIN', NULL, NULL, NULL, 8),
(248015, NULL, 'PTHR10468', NULL, NULL, NULL, NULL, 'PROTEIN O-LINKED-MANNOSE BETA-1,2-N-ACETYLGLUCOSAMINYLTRANSFERASE 1/ALPHA-1,3-MANNOSYL-GLYCOPROTEIN 2-BETA-N-ACETYLGLUCOSAMINYLTRANSFERASE', NULL, NULL, NULL, 8);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(248016, NULL, 'PTHR32014', NULL, NULL, NULL, NULL, 'BCL-2-MODIFYING FACTOR', NULL, NULL, 22122, 8),
(248017, NULL, 'PTHR39465', NULL, NULL, NULL, NULL, 'DNA LIGASE D, 3''-PHOSPHOESTERASE DOMAIN', NULL, NULL, NULL, 8),
(248018, NULL, 'PTHR47921', NULL, NULL, NULL, NULL, 'PROTEIN CBG14847-RELATED', NULL, NULL, NULL, 8),
(248019, NULL, 'PTHR11568', NULL, NULL, NULL, NULL, 'HEPATOCYTE NUCLEAR FACTOR 1', NULL, NULL, 32738, 8),
(248020, NULL, 'PTHR15744', NULL, NULL, NULL, NULL, 'BLOM7', NULL, NULL, 26492, 8),
(248021, NULL, 'PTHR10783', NULL, NULL, NULL, NULL, 'XENOTROPIC AND POLYTROPIC RETROVIRUS RECEPTOR 1-RELATED', NULL, NULL, NULL, 8),
(248022, NULL, 'PTHR46569', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRAIP', NULL, NULL, NULL, 8),
(248023, NULL, 'PTHR45982', NULL, NULL, NULL, NULL, 'REGULATOR OF CHROMOSOME CONDENSATION', NULL, NULL, NULL, 8),
(248024, NULL, 'PTHR43038', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE, SUB-FAMILY H, MEMBER 1', NULL, NULL, NULL, 8),
(248025, NULL, 'PTHR30620', NULL, NULL, NULL, NULL, 'PERIPLASMIC BETA-GLUCOSIDASE-RELATED', NULL, NULL, NULL, 8),
(248026, NULL, 'PTHR23225', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', NULL, NULL, 28502, 8),
(248027, NULL, 'PTHR32278', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(248028, NULL, 'PTHR14709', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(248029, NULL, 'PTHR43132', NULL, NULL, NULL, NULL, 'ARSENICAL RESISTANCE OPERON REPRESSOR ARSR-RELATED', NULL, NULL, NULL, 8),
(248030, NULL, 'PTHR32028', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN M', NULL, NULL, 16971, 8),
(248031, NULL, 'PTHR13594', NULL, NULL, NULL, NULL, 'CENTRIOLAR COILED-COIL PROTEIN OF 110 KDA', NULL, NULL, 32623, 8),
(248032, NULL, 'PTHR31687', NULL, NULL, NULL, NULL, '', NULL, NULL, 14282, 8),
(248033, NULL, 'PTHR43080', NULL, NULL, NULL, NULL, 'CBS DOMAIN-CONTAINING PROTEIN CBSX3, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(248034, NULL, 'PTHR47345', NULL, NULL, NULL, NULL, 'CUT9-INTERACTING PROTEIN SCN1', NULL, NULL, NULL, 8),
(248035, NULL, 'PTHR22849', NULL, NULL, NULL, NULL, 'WDSAM1 PROTEIN', NULL, NULL, 34709, 8),
(248036, NULL, 'PTHR16861', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN 38', NULL, NULL, NULL, 8),
(248037, NULL, 'PTHR45822', NULL, NULL, NULL, NULL, 'FREE FATTY ACID RECEPTOR 2-RELATED', NULL, NULL, NULL, 8),
(248038, NULL, 'PTHR24390', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', NULL, NULL, NULL, 8),
(248039, NULL, 'PTHR10684', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR COACTIVATOR', NULL, NULL, 18241, 8),
(248040, NULL, 'PTHR41283', NULL, NULL, NULL, NULL, 'AMINOGLYCOSIDE PHOSPHOTRANSFERASE', NULL, NULL, NULL, 8),
(248041, NULL, 'PTHR31428', NULL, NULL, NULL, NULL, 'RGM DOMAIN FAMILY MEMBER DRAG-1', NULL, NULL, 31951, 8),
(248042, NULL, 'PTHR46615', NULL, NULL, NULL, NULL, 'ARYLSULFATASE K', NULL, NULL, NULL, 8),
(248043, NULL, 'PTHR47944', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 98A9', NULL, NULL, NULL, 8),
(248044, NULL, 'PTHR21043', NULL, NULL, NULL, NULL, 'IOJAP SUPERFAMILY ORTHOLOG', NULL, NULL, 5605, 8),
(248045, NULL, 'PTHR35486', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(248046, NULL, 'PTHR12303', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 13280, 8),
(248047, NULL, 'PTHR13061', NULL, NULL, NULL, NULL, 'DYNACTIN SUBUNIT P25', NULL, NULL, NULL, 8),
(248048, NULL, 'PTHR48073', NULL, NULL, NULL, NULL, 'O-SUCCINYLBENZOATE SYNTHASE-RELATED', NULL, NULL, NULL, 8),
(248049, NULL, 'PTHR10136', NULL, NULL, NULL, NULL, 'SECRETOGLOBIN FAMILY 1 MEMBER', NULL, NULL, 37414, 8),
(248050, NULL, 'PTHR43178', NULL, NULL, NULL, NULL, 'DIHYDROLIPOAMIDE ACETYLTRANSFERASE COMPONENT OF PYRUVATE DEHYDROGENASE COMPLEX', NULL, NULL, NULL, 8),
(248051, NULL, 'PTHR35021', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(248052, NULL, 'PTHR11579', NULL, NULL, NULL, NULL, 'PROTEIN-L-ISOASPARTATE O-METHYLTRANSFERASE', NULL, NULL, 6763, 8),
(248053, NULL, 'PTHR31579', NULL, NULL, NULL, NULL, 'OS03G0796600 PROTEIN', NULL, NULL, 6928, 8),
(248054, NULL, 'PTHR42869', NULL, NULL, NULL, NULL, 'SLL0572 PROTEIN', NULL, NULL, NULL, 8);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(248055, NULL, 'PTHR16255', NULL, NULL, NULL, NULL, 'REQUIRED FOR MEIOTIC NUCLEAR DIVISION PROTEIN 1 HOMOLOG', NULL, NULL, NULL, 8),
(248056, NULL, 'PTHR45096', NULL, NULL, NULL, NULL, 'PROTEIN NEDD1', NULL, NULL, 34663, 8),
(248057, NULL, 'PTHR47203', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(248058, NULL, 'PTHR48067', NULL, NULL, NULL, NULL, 'GPI-ANCHOR TRANSAMIDASE', NULL, NULL, 26627, 8),
(248059, NULL, 'PTHR11829', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN', NULL, NULL, NULL, 8),
(248060, NULL, 'PTHR15606', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 8/LIPOPOLYSACCHARIDE SPECIFIC RESPONSE-7-RELATED', NULL, NULL, 34412, 8),
(248061, NULL, 'PTHR11679', NULL, NULL, NULL, NULL, 'VESICLE PROTEIN SORTING-ASSOCIATED', NULL, NULL, 5203, 8),
(248062, NULL, 'PTHR42260', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(248063, NULL, 'PTHR37163', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', NULL, NULL, 10773, 8),
(248064, NULL, 'PTHR46711', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SETD2', NULL, NULL, 34945, 8),
(248065, NULL, 'PTHR34573', NULL, NULL, NULL, NULL, 'VKC DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(248066, NULL, 'PTHR21731', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 25876, 8),
(248067, NULL, 'PTHR21415', NULL, NULL, NULL, NULL, 'U7 SNRNA-ASSOCIATED SM-LIKE PROTEIN LSM11', NULL, NULL, 31559, 8),
(248068, NULL, 'PTHR19424', NULL, NULL, NULL, NULL, 'HEAT SHOCK FACTOR BINDING PROTEIN 1', NULL, NULL, 11335, 8),
(248069, NULL, 'PTHR16803', NULL, NULL, NULL, NULL, 'HIGH AFFINITY IMMUNOGLOBULIN EPSILON RECEPTOR GAMMA-SUBUNIT', NULL, NULL, 36045, 8),
(248070, NULL, 'PTHR31604', NULL, NULL, NULL, NULL, 'PROTEIN LATERAL ROOT PRIMORDIUM 1', NULL, NULL, 2236, 8),
(248071, NULL, 'PTHR47582', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', NULL, NULL, NULL, 8),
(248072, NULL, 'PTHR36380', NULL, NULL, NULL, NULL, 'BNAA03G58330D PROTEIN', NULL, NULL, 30375, 8),
(248073, NULL, 'PTHR14527', NULL, NULL, NULL, NULL, 'PROTEIN MIS12 HOMOLOG', NULL, NULL, 12928, 8),
(248074, NULL, 'PTHR36815', NULL, NULL, NULL, NULL, 'BNAC03G48760D PROTEIN', NULL, NULL, NULL, 8),
(248075, NULL, 'PTHR12975', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN  TRAPP', NULL, NULL, 24242, 8),
(248076, NULL, 'PTHR47160', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(248077, NULL, 'PTHR47115', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 183', NULL, NULL, 34130, 8),
(248078, NULL, 'PTHR44579', NULL, NULL, NULL, NULL, 'OS01G0730500 PROTEIN', NULL, NULL, NULL, 8),
(248079, NULL, 'PTHR15544', NULL, NULL, NULL, NULL, 'OSMOSIS RESPONSIVE FACTOR', NULL, NULL, NULL, 8),
(248080, NULL, 'PTHR11105', NULL, NULL, NULL, NULL, 'CITRATE LYASE SUBUNIT BETA-RELATED', NULL, NULL, 32293, 8),
(248081, NULL, 'PTHR37729', NULL, NULL, NULL, NULL, 'NEUROFILAMENT PROTEIN-LIKE PROTEIN', NULL, NULL, NULL, 8),
(248082, NULL, 'PTHR10851', NULL, NULL, NULL, NULL, 'PYRIDOXINE-5-PHOSPHATE OXIDASE', NULL, NULL, 5899, 8),
(248083, NULL, 'PTHR39385', NULL, NULL, NULL, NULL, 'PROTEIN CBG20422', NULL, NULL, NULL, 8),
(248084, NULL, 'PTHR10698', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT H', NULL, NULL, 1635, 8),
(248085, NULL, 'PTHR33644', NULL, NULL, NULL, NULL, 'U-BOX DOMAIN-CONTAINING PROTEIN 62-RELATED', NULL, NULL, NULL, 8),
(248086, NULL, 'PTHR15711', NULL, NULL, NULL, NULL, 'RAP GTPASE-ACTIVATING PROTEIN', NULL, NULL, NULL, 8),
(248087, NULL, 'PTHR48053', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT FAMILY PROTEIN, EXPRESSED', NULL, NULL, NULL, 8),
(248088, NULL, 'PTHR40732', NULL, NULL, NULL, NULL, 'UPF0218 PROTEIN TK1697', NULL, NULL, 240, 8),
(248089, NULL, 'PTHR19956', NULL, NULL, NULL, NULL, 'LAMIN TAIL DOMAIN-CONTAINING PROTEIN 2', NULL, NULL, NULL, 8),
(248090, NULL, 'PTHR28527', NULL, NULL, NULL, NULL, 'MATING-TYPE SWITCHING PROTEIN SWI2-RELATED', NULL, NULL, NULL, 8),
(248091, NULL, 'PTHR42985', NULL, NULL, NULL, NULL, 'SODIUM-COUPLED MONOCARBOXYLATE TRANSPORTER', NULL, NULL, NULL, 8),
(248092, NULL, 'PTHR35754', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT B', NULL, NULL, NULL, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(248093, NULL, 'PTHR30634', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE LOLAB LIPOPROTEIN INSERTION APPARATUS', NULL, NULL, NULL, 8),
(248094, NULL, 'PTHR36183', NULL, NULL, NULL, NULL, 'BETA-GLUCURONIDASE', NULL, NULL, NULL, 8),
(248095, NULL, 'PTHR35574', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(248096, NULL, 'PTHR45616', NULL, NULL, NULL, NULL, 'GATA-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(248097, NULL, 'PTHR14503', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOMAL PROTEIN 34 FAMILY MEMBER', NULL, NULL, 872, 8),
(248098, NULL, 'PTHR12353', NULL, NULL, NULL, NULL, 'DISKS LARGE-ASSOCIATED PROTEIN  DAP   SAP90/PSD-95-ASSOCIATED PROTEIN', NULL, NULL, 1415, 8),
(248099, NULL, 'PTHR31351', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, 27707, 8),
(248100, NULL, 'PTHR17503', NULL, NULL, NULL, NULL, 'SYNCOLLIN', NULL, NULL, 25351, 8),
(248101, NULL, 'PTHR42067', NULL, NULL, NULL, NULL, 'YALI0C15378P', NULL, NULL, NULL, 8),
(248102, NULL, 'PTHR10934', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L18', NULL, NULL, 1994, 8),
(248103, NULL, 'PTHR18978', NULL, NULL, NULL, NULL, 'GRIP-1 ASSOCIATED PROTEIN 1', NULL, NULL, 24819, 8),
(248104, NULL, 'PTHR11351', NULL, NULL, NULL, NULL, 'ACYL-COA DESATURASE', NULL, NULL, 7445, 8),
(248105, NULL, 'PTHR20208', NULL, NULL, NULL, NULL, 'STRUCTURE-SPECIFIC ENDONUCLEASE SUBUNIT SLX1', NULL, NULL, NULL, 8),
(248106, NULL, 'PTHR31409', NULL, NULL, NULL, NULL, 'WASH COMPLEX SUBUNIT 4', NULL, NULL, 25109, 8),
(248107, NULL, 'PTHR14826', NULL, NULL, NULL, NULL, 'ANGIOMOTIN', NULL, NULL, NULL, 8),
(248108, NULL, 'PTHR43149', NULL, NULL, NULL, NULL, 'ENOYL-COA HYDRATASE', NULL, NULL, 36618, 8),
(248109, NULL, 'PTHR12069', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASES III 80 KDA POLYPEPTIDE  RNA POLYMERASE III SUBUNIT 5', NULL, NULL, 4824, 8),
(248110, NULL, 'PTHR12386', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT', NULL, NULL, 3866, 8),
(248111, NULL, 'PTHR13992', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR CO-REPRESSOR RELATED  NCOR', NULL, NULL, NULL, 8),
(248112, NULL, 'PTHR24279', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(248113, NULL, 'PTHR41710', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE, FAMILY 39', NULL, NULL, 15846, 8),
(248114, NULL, 'PTHR30068', NULL, NULL, NULL, NULL, 'URONATE ISOMERASE', NULL, NULL, NULL, 8),
(248115, NULL, 'PTHR46953', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR MTH-LIKE 1-RELATED', NULL, NULL, NULL, 8),
(248116, NULL, 'PTHR33269', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE CHAIN 6', NULL, NULL, NULL, 8),
(248117, NULL, 'PTHR36485', NULL, NULL, NULL, NULL, 'OS01G0939000 PROTEIN', NULL, NULL, NULL, 8),
(248118, NULL, 'PTHR15871', NULL, NULL, NULL, NULL, 'PH DOMAIN-CONTAINING PROTEIN', NULL, NULL, 33723, 8),
(248119, NULL, 'PTHR32149', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 6 COMPLEX LOCUS PROTEIN G6C', NULL, NULL, 33300, 8),
(248120, NULL, 'PTHR28159', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX II-SPECIFIC SUBUNIT 65', NULL, NULL, 5057, 8),
(248121, NULL, 'PTHR47890', NULL, NULL, NULL, NULL, 'LD24308P', NULL, NULL, NULL, 8),
(248122, NULL, 'PTHR45933', NULL, NULL, NULL, NULL, 'PROTEIN C2-DOMAIN ABA-RELATED 4', NULL, NULL, 36027, 8),
(248123, NULL, 'PTHR46694', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN 4', NULL, NULL, 34877, 8),
(248124, NULL, 'PTHR47599', NULL, NULL, NULL, NULL, 'CELL-TO-CELL MOVEMENT PROTEIN', NULL, NULL, NULL, 8),
(248125, NULL, 'PTHR12112', NULL, NULL, NULL, NULL, 'BNIP - RELATED', NULL, NULL, NULL, 8),
(248126, NULL, 'PTHR28061', NULL, NULL, NULL, NULL, 'INO EIGHTY SUBUNIT 4', NULL, NULL, 17281, 8),
(248127, NULL, 'PTHR30604', NULL, NULL, NULL, NULL, 'PROTEIN TRANSPORT PROTEIN HOFQ', NULL, NULL, NULL, 8),
(248128, NULL, 'PTHR40072', NULL, NULL, NULL, NULL, 'MOLYBDOPTERIN-GUANINE DINUCLEOTIDE BIOSYNTHESIS ADAPTER PROTEIN-RELATED', NULL, NULL, NULL, 8),
(248129, NULL, 'PTHR34152', NULL, NULL, NULL, NULL, 'PROTEIN CBG12353-RELATED', NULL, NULL, NULL, 8),
(248130, NULL, 'PTHR24314', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LIPID TRANSFER PROTEIN-RELATED', NULL, NULL, NULL, 8);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(248131, NULL, 'PTHR32175', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE, EXPRESSED-RELATED', NULL, NULL, NULL, 8),
(248132, NULL, 'PTHR42790', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE', NULL, NULL, NULL, 8),
(248133, NULL, 'PTHR39335', NULL, NULL, NULL, NULL, 'BLL4220 PROTEIN', NULL, NULL, NULL, 8),
(248134, NULL, 'PTHR48038', NULL, NULL, NULL, NULL, 'RIBONUCLEOPROTEIN RB97D', NULL, NULL, NULL, 8),
(248135, NULL, 'PTHR31499', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR PHL11', NULL, NULL, 33640, 8),
(248136, NULL, 'PTHR12831', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIH  TFIIH , POLYPEPTIDE 3-RELATED', NULL, NULL, 922, 8),
(248137, NULL, 'PTHR14164', NULL, NULL, NULL, NULL, 'PERICENTRIOLAR MATERIAL 1-RELATED', NULL, NULL, 8068, 8),
(248138, NULL, 'PTHR10204', NULL, NULL, NULL, NULL, 'NAD P H OXIDOREDUCTASE-RELATED', NULL, NULL, NULL, 8),
(248139, NULL, 'PTHR14583', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN C19ORF57 FAMILY MEMBER', NULL, NULL, 25424, 8),
(248140, NULL, 'PTHR33312', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED KINASE REGULATOR 4-RELATED', NULL, NULL, 27136, 8),
(248141, NULL, 'PTHR37944', NULL, NULL, NULL, NULL, 'PORIN B', NULL, NULL, NULL, 8),
(248142, NULL, 'PTHR12741', NULL, NULL, NULL, NULL, 'LYST-INTERACTING PROTEIN LIP5  DOPAMINE RESPONSIVE PROTEIN DRG-1', NULL, NULL, NULL, 8),
(248143, NULL, 'PTHR35358', NULL, NULL, NULL, NULL, 'OS06G0711100 PROTEIN', NULL, NULL, NULL, 8),
(248144, NULL, 'PTHR15349', NULL, NULL, NULL, NULL, 'ENDOTHELIAL PROTEIN C RECEPTOR', NULL, NULL, 17683, 8),
(248145, NULL, 'PTHR46355', NULL, NULL, NULL, NULL, 'UPF0428 PROTEIN CXORF56', NULL, NULL, 22256, 8),
(248146, NULL, 'PTHR47696', NULL, NULL, NULL, NULL, 'THAP DOMAIN-CONTAINING PROTEIN 2', NULL, NULL, 23087, 8),
(248147, NULL, 'PTHR23305', NULL, NULL, NULL, NULL, 'OBG GTPASE FAMILY', NULL, NULL, NULL, 8),
(248148, NULL, 'PTHR16504', NULL, NULL, NULL, NULL, '5''(3'')-DEOXYRIBONUCLEOTIDASE', NULL, NULL, NULL, 8),
(248149, NULL, 'PTHR43628', NULL, NULL, NULL, NULL, 'ACTIVATOR OF C KINASE PROTEIN 1-RELATED', NULL, NULL, NULL, 8),
(248150, NULL, 'PTHR10441', NULL, NULL, NULL, NULL, 'CD8 ALPHA CHAIN', NULL, NULL, 8669, 8),
(248151, NULL, 'PTHR31184', NULL, NULL, NULL, NULL, 'HUNTINGTIN-INTERACTING PROTEIN K FAMILY MEMBER', NULL, NULL, NULL, 8),
(248152, NULL, 'PTHR33787', NULL, NULL, NULL, NULL, '', NULL, NULL, 1641, 8),
(248153, NULL, 'PTHR35711', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(248154, NULL, 'PTHR30314', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN FTSZ-RELATED', NULL, NULL, 36886, 8),
(248155, NULL, 'PTHR28040', NULL, NULL, NULL, NULL, 'PYRIDOXAMINE 5''-PHOSPHATE OXIDASE YLR456W HOMOLOG-RELATED', NULL, NULL, NULL, 8),
(248156, NULL, 'PTHR45738', NULL, NULL, NULL, NULL, 'POLYPHOSPHOINOSITIDE PHOSPHATASE', NULL, NULL, 35650, 8),
(248157, NULL, 'PTHR35082', NULL, NULL, NULL, NULL, 'BEN DOMAIN-CONTAINING PROTEIN 4', NULL, NULL, 31990, 8),
(248158, NULL, 'PTHR44984', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE NEK3', NULL, NULL, NULL, 8),
(248159, NULL, 'PTHR41252', NULL, NULL, NULL, NULL, 'BLR2505 PROTEIN', NULL, NULL, NULL, 8),
(248160, NULL, 'PTHR13647', NULL, NULL, NULL, NULL, 'INSULIN-LIKE PEPTIDE 2-RELATED', NULL, NULL, 27962, 8),
(248161, NULL, 'PTHR28366', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(248162, NULL, 'PTHR22640', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 32470, 8),
(248163, NULL, 'PTHR10579', NULL, NULL, NULL, NULL, 'CALCIUM-ACTIVATED CHLORIDE CHANNEL REGULATOR', NULL, NULL, NULL, 8),
(248164, NULL, 'PTHR19339', NULL, NULL, NULL, NULL, 'T CELL RECEPTOR ALPHA VARIABLE 39', NULL, NULL, NULL, 8),
(248165, NULL, 'PTHR47067', NULL, NULL, NULL, NULL, 'TPX2 (TARGETING PROTEIN FOR XKLP2) PROTEIN FAMILY-RELATED', NULL, NULL, 34624, 8),
(248166, NULL, 'PTHR31182', NULL, NULL, NULL, NULL, 'C2 NT-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(248167, NULL, 'PTHR31516', NULL, NULL, NULL, NULL, 'STABILIZER OF AXONEMAL MICROTUBULES 2', NULL, NULL, 29571, 8);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(248168, NULL, 'PTHR15386', NULL, NULL, NULL, NULL, 'FIBRINOGEN SILENCER-BINDING PROTEIN', NULL, NULL, 36831, 8),
(248169, NULL, 'PTHR10707', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT IV', NULL, NULL, 3000, 8),
(248170, NULL, 'PTHR37529', NULL, NULL, NULL, NULL, 'TRANSPOSASE INSG FOR INSERTION SEQUENCE ELEMENT IS4-RELATED', NULL, NULL, NULL, 8),
(248171, NULL, 'PTHR45793', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN', NULL, NULL, NULL, 8),
(248172, NULL, 'PTHR35766', NULL, NULL, NULL, NULL, 'OS08G0543600 PROTEIN', NULL, NULL, NULL, 8),
(248173, NULL, 'PTHR39412', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 46', NULL, NULL, 32580, 8),
(248174, NULL, 'PTHR11259', NULL, NULL, NULL, NULL, 'RAS-RELATED GTP BINDING RAG/GTR YEAST', NULL, NULL, 3436, 8),
(248175, NULL, 'PTHR33157', NULL, NULL, NULL, NULL, 'AUTONOMOUS TRANSPOSABLE ELEMENT EN-1 MOSAIC PROTEIN-RELATED', NULL, NULL, 30943, 8),
(248176, NULL, 'PTHR11681', NULL, NULL, NULL, NULL, 'NEUROPHYSIN', NULL, NULL, 24, 8),
(248177, NULL, 'PTHR31554', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 184', NULL, NULL, 26254, 8),
(248178, NULL, 'PTHR23043', NULL, NULL, NULL, NULL, 'HYPOXIA-INDUCIBLE FACTOR 1 ALPHA', NULL, NULL, NULL, 8),
(248179, NULL, 'PTHR44874', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 34', NULL, NULL, 34681, 8),
(248180, NULL, 'PTHR16125', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 74', NULL, NULL, 25475, 8),
(248181, NULL, 'PTHR15531', NULL, NULL, NULL, NULL, 'PROSAAS', NULL, NULL, 11229, 8),
(248182, NULL, 'PTHR28108', NULL, NULL, NULL, NULL, 'SWR1-COMPLEX PROTEIN 3', NULL, NULL, 31339, 8),
(248183, NULL, 'PTHR32487', NULL, NULL, NULL, NULL, '3-OXO-DELTA(4,5)-STEROID 5-BETA-REDUCTASE', NULL, NULL, NULL, 8),
(248184, NULL, 'PTHR35268', NULL, NULL, NULL, NULL, 'PROTEIN CCSMST1', NULL, NULL, 26557, 8),
(248185, NULL, 'PTHR47377', NULL, NULL, NULL, NULL, 'RHODANESE-LIKE DOMAIN-CONTAINING PROTEIN 4, CHLOROPLASTIC', NULL, NULL, 36303, 8),
(248186, NULL, 'PTHR28307', NULL, NULL, NULL, NULL, 'PROTEIN PAL1', NULL, NULL, 12181, 8),
(248187, NULL, 'PTHR46803', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE CHIP', NULL, NULL, 36270, 8),
(248188, NULL, 'PTHR46623', NULL, NULL, NULL, NULL, 'CARBOXYMETHYLENEBUTENOLIDASE-RELATED', NULL, NULL, NULL, 8),
(248189, NULL, 'PTHR42752', NULL, NULL, NULL, NULL, 'IMIDAZOLONEPROPIONASE', NULL, NULL, 9, 8),
(248190, NULL, 'PTHR46076', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RING1 / RING 2 FAMILY MEMBER', NULL, NULL, 34033, 8),
(248191, NULL, 'PTHR17920', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AND COILED-COIL DOMAIN-CONTAINING PROTEIN 4 TMCO4', NULL, NULL, 4328, 8),
(248192, NULL, 'PTHR37689', NULL, NULL, NULL, NULL, 'PROTEIN FDHE', NULL, NULL, 6997, 8),
(248193, NULL, 'PTHR44298', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY B MEMBER 11', NULL, NULL, NULL, 8),
(248194, NULL, 'PTHR12326', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(248195, NULL, 'PTHR47563', NULL, NULL, NULL, NULL, 'PROTEIN FMP25, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(248196, NULL, 'PTHR20956', NULL, NULL, NULL, NULL, 'HEH2P', NULL, NULL, NULL, 8),
(248197, NULL, 'PTHR34253', NULL, NULL, NULL, NULL, 'PROTEIN LLP HOMOLOG', NULL, NULL, 19482, 8),
(248198, NULL, 'PTHR38096', NULL, NULL, NULL, NULL, 'ENTEROBACTIN SYNTHASE COMPONENT D', NULL, NULL, 7048, 8),
(248199, NULL, 'PTHR19980', NULL, NULL, NULL, NULL, 'RNA CLEAVAGE STIMULATION FACTOR', NULL, NULL, 36702, 8),
(248200, NULL, 'PTHR33590', NULL, NULL, NULL, NULL, 'GLUTENIN, HIGH MOLECULAR WEIGHT SUBUNIT PW212-RELATED PROTEIN', NULL, NULL, NULL, 8),
(248201, NULL, 'PTHR15034', NULL, NULL, NULL, NULL, 'DEATH DOMAIN-CONTAINING PROTEIN CRADD', NULL, NULL, 29701, 8),
(248202, NULL, 'PTHR36832', NULL, NULL, NULL, NULL, 'SLR1174 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(248203, NULL, 'PTHR10334', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH SECRETORY PROTEIN-RELATED', NULL, NULL, 111, 8),
(248204, NULL, 'PTHR22940', NULL, NULL, NULL, NULL, 'TIMEOUT/TIMELESS-2', NULL, NULL, 36787, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(248205, NULL, 'PTHR33641', NULL, NULL, NULL, NULL, 'OS06G0133500 PROTEIN', NULL, NULL, NULL, 8),
(248206, NULL, 'PTHR36360', NULL, NULL, NULL, NULL, 'ACTIN T1-LIKE PROTEIN', NULL, NULL, NULL, 8),
(248207, NULL, 'PTHR43822', NULL, NULL, NULL, NULL, 'HOMOACONITASE, MITOCHONDRIAL-RELATED', NULL, NULL, NULL, 8),
(248208, NULL, 'PTHR34576', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED KINASE REGULATOR 6-RELATED', NULL, NULL, 34988, 8),
(248209, NULL, 'PTHR10082', NULL, NULL, NULL, NULL, 'INTEGRIN BETA SUBUNIT', NULL, NULL, 12563, 8),
(248210, NULL, 'PTHR34070', NULL, NULL, NULL, NULL, 'ARMADILLO-TYPE FOLD', NULL, NULL, NULL, 8),
(248211, NULL, 'PTHR36079', NULL, NULL, NULL, NULL, 'PROTEIN LEAFY', NULL, NULL, 6381, 8),
(248212, NULL, 'PTHR33270', NULL, NULL, NULL, NULL, 'BNAC05G50380D PROTEIN', NULL, NULL, 28790, 8),
(248213, NULL, 'PTHR21021', NULL, NULL, NULL, NULL, 'GAF/PUTATIVE CYTOSKELETAL PROTEIN', NULL, NULL, NULL, 8),
(248214, NULL, 'PTHR45991', NULL, NULL, NULL, NULL, 'PACHYTENE CHECKPOINT PROTEIN 2', NULL, NULL, 34887, 8),
(248215, NULL, 'PTHR33905', NULL, NULL, NULL, NULL, 'CST COMPLEX SUBUNIT TEN1', NULL, NULL, 23665, 8),
(248216, NULL, 'PTHR35908', NULL, NULL, NULL, NULL, 'HYPOTHETICAL FUSION PROTEIN', NULL, NULL, NULL, 8),
(248217, NULL, 'PTHR33371', NULL, NULL, NULL, NULL, 'INTERMEMBRANE PHOSPHOLIPID TRANSPORT SYSTEM BINDING PROTEIN MLAD-RELATED', NULL, NULL, NULL, 8),
(248218, NULL, 'PTHR46951', NULL, NULL, NULL, NULL, 'BED-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(248219, NULL, 'PTHR10986', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L20', NULL, NULL, 5975, 8),
(248220, NULL, 'PTHR23180', NULL, NULL, NULL, NULL, 'CENTAURIN/ARF', NULL, NULL, 37250, 8),
(248221, NULL, 'PTHR34388', NULL, NULL, NULL, NULL, 'DNA POLYMERASE III SUBUNIT DELTA', NULL, NULL, NULL, 8),
(248222, NULL, 'PTHR18868', NULL, NULL, NULL, NULL, 'OS07G0665300 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(248223, NULL, 'PTHR35572', NULL, NULL, NULL, NULL, 'PROTEIN CBG04538-RELATED', NULL, NULL, 27478, 8),
(248224, NULL, 'PTHR43110', NULL, NULL, NULL, NULL, 'THIOL PEROXIDASE', NULL, NULL, NULL, 8),
(248225, NULL, 'PTHR37486', NULL, NULL, NULL, NULL, 'STRINGENT STARVATION PROTEIN B', NULL, NULL, 10356, 8),
(248226, NULL, 'PTHR48111', NULL, NULL, NULL, NULL, 'REGULATOR OF RPOS', NULL, NULL, 33380, 8),
(248227, NULL, 'PTHR38788', NULL, NULL, NULL, NULL, 'CLR5 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(248228, NULL, 'PTHR46676', NULL, NULL, NULL, NULL, 'PROTEIN AMBP', NULL, NULL, 21785, 8),
(248229, NULL, 'PTHR33790', NULL, NULL, NULL, NULL, 'OS05G0344200 PROTEIN', NULL, NULL, 28592, 8),
(248230, NULL, 'PTHR14190', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF ACTIN MUTATIONS 2/VACUOLAR PROTEIN SORTING 52', NULL, NULL, 6764, 8),
(248231, NULL, 'PTHR15535', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 2-RELATED', NULL, NULL, NULL, 8),
(248232, NULL, 'PTHR24113', NULL, NULL, NULL, NULL, 'RAN GTPASE-ACTIVATING PROTEIN 1', NULL, NULL, NULL, 8),
(248233, NULL, 'PTHR12791', NULL, NULL, NULL, NULL, 'GOLGI SNARE BET1-RELATED', NULL, NULL, 33017, 8),
(248234, NULL, 'PTHR12436', NULL, NULL, NULL, NULL, '80 KDA MCM3-ASSOCIATED PROTEIN', NULL, NULL, 36973, 8),
(248235, NULL, 'PTHR21389', NULL, NULL, NULL, NULL, 'P53 INDUCED PROTEIN', NULL, NULL, 14160, 8),
(248236, NULL, 'PTHR46400', NULL, NULL, NULL, NULL, 'RING/U-BOX SUPERFAMILY PROTEIN', NULL, NULL, 29678, 8),
(248237, NULL, 'PTHR45892', NULL, NULL, NULL, NULL, 'AMINOACYLASE-1', NULL, NULL, NULL, 8),
(248238, NULL, 'PTHR34561', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] 1 ALPHA SUBCOMPLEX ASSEMBLY FACTOR 8', NULL, NULL, 11156, 8),
(248239, NULL, 'PTHR46039', NULL, NULL, NULL, NULL, 'SUCROSE-PHOSPHATE SYNTHASE 3-RELATED', NULL, NULL, NULL, 8),
(248240, NULL, 'PTHR15493', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 5 AND 43', NULL, NULL, NULL, 8),
(248241, NULL, 'PTHR23135', NULL, NULL, NULL, NULL, 'MUR LIGASE FAMILY MEMBER', NULL, NULL, NULL, 8),
(248242, NULL, 'PTHR39767', NULL, NULL, NULL, NULL, 'CALCIUM/CALMODULIN-BINDING MEMBRANE PROTEIN PCM4-RELATED', NULL, NULL, NULL, 8);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(248243, NULL, 'PTHR36287', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(248244, NULL, 'PTHR45453', NULL, NULL, NULL, NULL, 'PHOSPHATE REGULON SENSOR PROTEIN PHOR', NULL, NULL, NULL, 8),
(248245, NULL, 'PTHR33576', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(248246, NULL, 'PTHR45620', NULL, NULL, NULL, NULL, 'PDF RECEPTOR-LIKE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(248247, NULL, 'PTHR10744', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S11 FAMILY MEMBER', NULL, NULL, 754, 8),
(248248, NULL, 'PTHR36477', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 225', NULL, NULL, 28499, 8),
(248249, NULL, 'PTHR47166', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 831', NULL, NULL, NULL, 8),
(248250, NULL, 'PTHR46506', NULL, NULL, NULL, NULL, 'OS05G0143600 PROTEIN', NULL, NULL, NULL, 8),
(248251, NULL, 'PTHR10416', NULL, NULL, NULL, NULL, 'DNA POLYMERASE DELTA SUBUNIT 2', NULL, NULL, 14815, 8),
(248252, NULL, 'PTHR35860', NULL, NULL, NULL, NULL, 'PROTEIN FAM24B', NULL, NULL, 25946, 8),
(248253, NULL, 'PTHR10916', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L35/50S RIBOSOMAL PROTEIN L29', NULL, NULL, NULL, 8),
(248254, NULL, 'PTHR32378', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN SUBUNIT GAMMA 3', NULL, NULL, NULL, 8),
(248255, NULL, 'PTHR35248', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', NULL, NULL, 33421, 8),
(248256, NULL, 'PTHR12173', NULL, NULL, NULL, NULL, 'GDNF SUBFAMILY OF TGF-BETA FAMILY', NULL, NULL, 36991, 8),
(248257, NULL, 'PTHR11348', NULL, NULL, NULL, NULL, 'CONNECTIVE TISSUE GROWTH FACTOR-RELATED', NULL, NULL, NULL, 8),
(248258, NULL, 'PTHR21325', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE B, PLB1', NULL, NULL, 28938, 8),
(248259, NULL, 'PTHR21614', NULL, NULL, NULL, NULL, 'SHORT COILED COIL PROTEIN', NULL, NULL, 15509, 8),
(248260, NULL, 'PTHR12297', NULL, NULL, NULL, NULL, 'HYPOXIA-INDUCBILE GENE 1  HIG1 -RELATED', NULL, NULL, NULL, 8),
(248261, NULL, 'PTHR21054', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE-RELATED', NULL, NULL, NULL, 8),
(248262, NULL, 'PTHR47499', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR KAZAL-TYPE 7 SPINK7', NULL, NULL, NULL, 8),
(248263, NULL, 'PTHR47781', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L36 2', NULL, NULL, NULL, 8),
(248264, NULL, 'PTHR33988', NULL, NULL, NULL, NULL, 'ENDORIBONUCLEASE MAZF-RELATED', NULL, NULL, 6378, 8),
(248265, NULL, 'PTHR38342', NULL, NULL, NULL, NULL, 'SLR5037 PROTEIN', NULL, NULL, NULL, 8),
(248266, NULL, 'PTHR13049', NULL, NULL, NULL, NULL, 'DUF814-RELATED', NULL, NULL, 27406, 8),
(248267, NULL, 'PTHR14399', NULL, NULL, NULL, NULL, 'P53-INDUCED PROTEIN RELATED', NULL, NULL, 17553, 8),
(248268, NULL, 'PTHR43358', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASE', NULL, NULL, NULL, 8),
(248269, NULL, 'PTHR36587', NULL, NULL, NULL, NULL, 'EXPRESSION SITE-ASSOCIATED GENE 3 (ESAG3)-LIKE PROTEIN', NULL, NULL, NULL, 8),
(248270, NULL, 'PTHR46715', NULL, NULL, NULL, NULL, '1-PHOSPHATIDYLINOSITOL 3-PHOSPHATE 5-KINASE', NULL, NULL, 36281, 8),
(248271, NULL, 'PTHR36767', NULL, NULL, NULL, NULL, 'OS05G0126200 PROTEIN', NULL, NULL, NULL, 8),
(248272, NULL, 'PTHR40711', NULL, NULL, NULL, NULL, 'DERMCIDIN-RELATED', NULL, NULL, 34432, 8),
(248273, NULL, 'PTHR11739', NULL, NULL, NULL, NULL, 'CITRATE SYNTHASE', NULL, NULL, 2482, 8),
(248274, NULL, 'PTHR22599', NULL, NULL, NULL, NULL, 'MPS ONE BINDER KINASE ACTIVATOR-LIKE  MOB', NULL, NULL, 5469, 8),
(248275, NULL, 'PTHR47315', NULL, NULL, NULL, NULL, 'FIBROUS SHEATH INTERACTING PROTEIN 2', NULL, NULL, 32120, 8),
(248276, NULL, 'PTHR31193', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN C9ORF91', NULL, NULL, 26938, 8),
(248277, NULL, 'PTHR44366', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE--PEPTIDE N-ACETYLGLUCOSAMINYLTRANSFERASE 110 KDA SUBUNIT', NULL, NULL, 33197, 8),
(248278, NULL, 'PTHR46794', NULL, NULL, NULL, NULL, 'AMELOGENIN, Y ISOFORM', NULL, NULL, 1759, 8),
(248279, NULL, 'PTHR45795', NULL, NULL, NULL, NULL, 'EARLY GAMETOCYTE ENRICHED PHOSPHOPROTEIN EGXP', NULL, NULL, NULL, 8),
(248280, NULL, 'PTHR36888', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(248281, NULL, 'PTHR16266', NULL, NULL, NULL, NULL, 'WD REPEAT DOMAIN 9', NULL, NULL, NULL, 8),
(248282, NULL, 'PTHR45724', NULL, NULL, NULL, NULL, 'AQUAPORIN NIP2-1', NULL, NULL, 24028, 8),
(248283, NULL, 'PTHR47882', NULL, NULL, NULL, NULL, 'BIOGENESIS OF LYSOSOME-RELATED ORGANELLES COMPLEX 1 SUBUNIT 2', NULL, NULL, NULL, 8),
(248284, NULL, 'PTHR23163', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN-RELATED', NULL, NULL, 7859, 8),
(248285, NULL, 'PTHR46709', NULL, NULL, NULL, NULL, 'PROTEIN CBG23488-RELATED', NULL, NULL, NULL, 8),
(248286, NULL, 'PTHR42917', NULL, NULL, NULL, NULL, '2,4-DIENOYL-COA REDUCTASE', NULL, NULL, NULL, 8),
(248287, NULL, 'PTHR15233', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL PROTEOLIPID', NULL, NULL, 9299, 8),
(248288, NULL, 'PTHR36586', NULL, NULL, NULL, NULL, 'PROLINE-RICH EXTENSIN-LIKE', NULL, NULL, NULL, 8),
(248289, NULL, 'PTHR13900', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID', NULL, NULL, 31259, 8),
(248290, NULL, 'PTHR28088', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR HAA1-RELATED', NULL, NULL, NULL, 8),
(248291, NULL, 'PTHR35774', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REACTION CENTER PROTEIN M', NULL, NULL, 2262, 8),
(248292, NULL, 'PTHR21590', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 26764, 8),
(248293, NULL, 'PTHR43908', NULL, NULL, NULL, NULL, 'AT29763P-RELATED', NULL, NULL, NULL, 8),
(248294, NULL, 'PTHR21547', NULL, NULL, NULL, NULL, 'CLUSTERIN ASSOCIATED PROTEIN 1', NULL, NULL, 15518, 8),
(248295, NULL, 'PTHR42693', NULL, NULL, NULL, NULL, 'ARYLSULFATASE FAMILY MEMBER', NULL, NULL, NULL, 8),
(248296, NULL, 'PTHR16983', NULL, NULL, NULL, NULL, 'UPAR/LY6 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(248297, NULL, 'PTHR47282', NULL, NULL, NULL, NULL, 'PGC-1 AND ERR-INDUCED REGULATOR IN MUSCLE PROTEIN 1', NULL, NULL, 35204, 8),
(248298, NULL, 'PTHR30411', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(248299, NULL, 'PTHR36966', NULL, NULL, NULL, NULL, 'REP-ASSOCIATED TYROSINE TRANSPOSASE', NULL, NULL, NULL, 8),
(248300, NULL, 'PTHR13932', NULL, NULL, NULL, NULL, 'COPROPORPHYRINIGEN III OXIDASE', NULL, NULL, 29184, 8),
(248301, NULL, 'PTHR12305', NULL, NULL, NULL, NULL, 'PHOSPHATASE WITH HOMOLOGY TO TENSIN', NULL, NULL, NULL, 8),
(248302, NULL, 'PTHR39741', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', NULL, NULL, NULL, 8),
(248303, NULL, 'PTHR46105', NULL, NULL, NULL, NULL, 'AGAP004733-PA', NULL, NULL, NULL, 8),
(248304, NULL, 'PTHR47515', NULL, NULL, NULL, NULL, 'LOW CALCIUM RESPONSE LOCUS PROTEIN T', NULL, NULL, NULL, 8),
(248305, NULL, 'PTHR46259', NULL, NULL, NULL, NULL, 'ZINC FINGER CCHC-TYPE AND RNA-BINDING MOTIF-CONTAINING PROTEIN 1', NULL, NULL, 34189, 8),
(248306, NULL, 'PTHR15993', NULL, NULL, NULL, NULL, 'HEMOGEN', NULL, NULL, 30257, 8),
(248307, NULL, 'PTHR30437', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR GREA', NULL, NULL, 16389, 8),
(248308, NULL, 'PTHR11740', NULL, NULL, NULL, NULL, 'CASEIN KINASE II SUBUNIT BETA', NULL, NULL, 6522, 8),
(248309, NULL, 'PTHR28015', NULL, NULL, NULL, NULL, 'ATP SYNTHASE ASSEMBLY FACTOR FMC1, MITOCHONDRIAL', NULL, NULL, 32838, 8),
(248310, NULL, 'PTHR31128', NULL, NULL, NULL, NULL, 'PROTEIN CBR-CLEC-135-RELATED', NULL, NULL, NULL, 8),
(248311, NULL, 'PTHR43737', NULL, NULL, NULL, NULL, 'BLL7424 PROTEIN', NULL, NULL, NULL, 8),
(248312, NULL, 'PTHR31282', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 21-RELATED', NULL, NULL, 34764, 8),
(248313, NULL, 'PTHR46244', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE-PROTEIN PHOSPHOTRANSFERASE', NULL, NULL, NULL, 8),
(248314, NULL, 'PTHR28526', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT 13', NULL, NULL, NULL, 8),
(248315, NULL, 'PTHR38160', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 40', NULL, NULL, 36061, 8),
(248316, NULL, 'PTHR45888', NULL, NULL, NULL, NULL, 'HL01030P-RELATED', NULL, NULL, NULL, 8),
(248317, NULL, 'PTHR14471', NULL, NULL, NULL, NULL, 'MARCH7/10 E3 UBIQUITIN PROTEIN LIGASE FAMILY MEMBER', NULL, NULL, NULL, 8);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(248318, NULL, 'PTHR42714', NULL, NULL, NULL, NULL, 'TRNA MODIFICATION GTPASE GTPBP3', NULL, NULL, NULL, 8),
(248319, NULL, 'PTHR43495', NULL, NULL, NULL, NULL, 'GABA PERMEASE', NULL, NULL, NULL, 8),
(248320, NULL, 'PTHR24417', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE LMTK1', NULL, NULL, NULL, 8),
(248321, NULL, 'PTHR45495', NULL, NULL, NULL, NULL, 'DNAJ PROTEIN JJJ1 HOMOLOG', NULL, NULL, 36025, 8),
(248322, NULL, 'PTHR24401', NULL, NULL, NULL, NULL, 'SI:CH211-243P7.3-RELATED', NULL, NULL, NULL, 8),
(248323, NULL, 'PTHR40942', NULL, NULL, NULL, NULL, '', NULL, NULL, 6016, 8),
(248324, NULL, 'PTHR21656', NULL, NULL, NULL, NULL, 'MALE-SPECIFIC LETHAL-1 PROTEIN', NULL, NULL, 21832, 8),
(248325, NULL, 'PTHR43660', NULL, NULL, NULL, NULL, 'DIPEPTIDYL CARBOXYPEPTIDASE', NULL, NULL, 34308, 8),
(248326, NULL, 'PTHR30404', NULL, NULL, NULL, NULL, 'N-ACETYLMURAMOYL-L-ALANINE AMIDASE', NULL, NULL, NULL, 8),
(248327, NULL, 'PTHR42354', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(248328, NULL, 'PTHR37219', NULL, NULL, NULL, NULL, 'PROTEIN PALE CRESS, CHLOROPLASTIC', NULL, NULL, 113, 8),
(248329, NULL, 'PTHR41155', NULL, NULL, NULL, NULL, 'FI19525P1', NULL, NULL, NULL, 8),
(248330, NULL, 'PTHR31824', NULL, NULL, NULL, NULL, 'PROTEIN CBG17809', NULL, NULL, NULL, 8),
(248331, NULL, 'PTHR33437', NULL, NULL, NULL, NULL, 'OS06G0361200 PROTEIN', NULL, NULL, NULL, 8),
(248332, NULL, 'PTHR45510', NULL, NULL, NULL, NULL, 'RHODANESE-LIKE DOMAIN-CONTAINING PROTEIN 10', NULL, NULL, 36135, 8),
(248333, NULL, 'PTHR34920', NULL, NULL, NULL, NULL, 'B-CELL LYMPHOMA/LEUKEMIA 10', NULL, NULL, 31463, 8),
(248334, NULL, 'PTHR10332', NULL, NULL, NULL, NULL, 'EQUILIBRATIVE NUCLEOSIDE TRANSPORTER', NULL, NULL, 5749, 8),
(248335, NULL, 'PTHR39460', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(248336, NULL, 'PTHR10970', NULL, NULL, NULL, NULL, 'CLUSTERIN', NULL, NULL, 4806, 8),
(248337, NULL, 'PTHR48159', NULL, NULL, NULL, NULL, 'MULE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(248338, NULL, 'PTHR14307', NULL, NULL, NULL, NULL, 'C6ORF47 FAMILY MEMBER', NULL, NULL, 25381, 8),
(248339, NULL, 'PTHR31729', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR RAP2-1-RELATED', NULL, NULL, NULL, 8),
(248340, NULL, 'PTHR23304', NULL, NULL, NULL, NULL, 'SPOT2-RELATED', NULL, NULL, NULL, 8),
(248341, NULL, 'PTHR14885', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(248342, NULL, 'PTHR15077', NULL, NULL, NULL, NULL, 'FAS-ASSOCIATING DEATH DOMAIN-CONTAINING PROTEIN FADD', NULL, NULL, 21270, 8),
(248343, NULL, 'PTHR11586', NULL, NULL, NULL, NULL, 'TRNA-AMINOACYLATION COFACTOR ARC1 FAMILY MEMBER', NULL, NULL, NULL, 8),
(248344, NULL, 'PTHR39207', NULL, NULL, NULL, NULL, 'ALPHA-GLUCURONIDASE A', NULL, NULL, NULL, 8),
(248345, NULL, 'PTHR41373', NULL, NULL, NULL, NULL, 'DUF2156 DOMAIN-CONTAINING PROTEIN', NULL, NULL, 21153, 8),
(248346, NULL, 'PTHR33651', NULL, NULL, NULL, NULL, 'PROTEIN CBG06246', NULL, NULL, NULL, 8),
(248347, NULL, 'PTHR34386', NULL, NULL, NULL, NULL, 'GLUTAREDOXIN', NULL, NULL, NULL, 8),
(248348, NULL, 'PTHR42040', NULL, NULL, NULL, NULL, 'INNER KINETOCHORE SUBUNIT FTA4', NULL, NULL, 21763, 8),
(248349, NULL, 'PTHR39229', NULL, NULL, NULL, NULL, 'MCG1037962', NULL, NULL, NULL, 8),
(248350, NULL, 'PTHR11375', NULL, NULL, NULL, NULL, 'ACIDIC LEUCINE-RICH NUCLEAR PHOSPHOPROTEIN 32', NULL, NULL, 34345, 8),
(248351, NULL, 'PTHR38765', NULL, NULL, NULL, NULL, '', NULL, NULL, 3638, 8),
(248352, NULL, 'PTHR35017', NULL, NULL, NULL, NULL, 'PROTEIN CBG16223-RELATED', NULL, NULL, NULL, 8),
(248353, NULL, 'PTHR46649', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(248354, NULL, 'PTHR23501', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY', NULL, NULL, NULL, 8),
(248355, NULL, 'PTHR15415', NULL, NULL, NULL, NULL, 'MITOFILIN', NULL, NULL, 17918, 8),
(248356, NULL, 'PTHR22146', NULL, NULL, NULL, NULL, 'CAT EYE SYNDROME CRITICAL REGION PROTEIN 6', NULL, NULL, NULL, 8),
(248357, NULL, 'PTHR11735', NULL, NULL, NULL, NULL, 'TRNA N6-ADENOSINE THREONYLCARBAMOYLTRANSFERASE', NULL, NULL, 25, 8);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(248358, NULL, 'PTHR32286', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 6 COMPLEX LOCUS PROTEIN G6F', NULL, NULL, 26501, 8),
(248359, NULL, 'PTHR13297', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 33389, 8),
(248360, NULL, 'PTHR43805', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHORYL DIESTER PHOSPHODIESTERASE', NULL, NULL, NULL, 8),
(248361, NULL, 'PTHR11062', NULL, NULL, NULL, NULL, 'EXOSTOSIN  HEPARAN SULFATE GLYCOSYLTRANSFERASE -RELATED', NULL, NULL, 3626, 8),
(248362, NULL, 'PTHR33529', NULL, NULL, NULL, NULL, 'SLR0882 PROTEIN-RELATED', NULL, NULL, 757, 8),
(248363, NULL, 'PTHR35485', NULL, NULL, NULL, NULL, 'OS01G0888900 PROTEIN', NULL, NULL, NULL, 8),
(248364, NULL, 'PTHR24388', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', NULL, NULL, NULL, 8),
(248365, NULL, 'PTHR11545', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L13', NULL, NULL, 5885, 8),
(248366, NULL, 'PTHR38037', NULL, NULL, NULL, NULL, 'ZN_PROTEASE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(248367, NULL, 'PTHR33365', NULL, NULL, NULL, NULL, 'YALI0B05434P', NULL, NULL, 19262, 8),
(248368, NULL, 'PTHR33370', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR IF-1, CHLOROPLASTIC', NULL, NULL, 5451, 8),
(248369, NULL, 'PTHR43761', NULL, NULL, NULL, NULL, 'D-ISOMER SPECIFIC 2-HYDROXYACID DEHYDROGENASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_1G13630)', NULL, NULL, NULL, 8),
(248370, NULL, 'PTHR44085', NULL, NULL, NULL, NULL, 'SEPIAPTERIN REDUCTASE', NULL, NULL, NULL, 8),
(248371, NULL, 'PTHR28047', NULL, NULL, NULL, NULL, 'PROTEIN DCG1', NULL, NULL, NULL, 8),
(248372, NULL, 'PTHR30457', NULL, NULL, NULL, NULL, '5''-NUCLEOTIDASE SURE', NULL, NULL, 22685, 8),
(248373, NULL, 'PTHR36858', NULL, NULL, NULL, NULL, 'AMELOTIN', NULL, NULL, 24963, 8),
(248374, NULL, 'PTHR16771', NULL, NULL, NULL, NULL, '26 PROTEASOME COMPLEX SUBUNIT DSS1', NULL, NULL, 2191, 8),
(248375, NULL, 'PTHR37324', NULL, NULL, NULL, NULL, 'PTS SYSTEM GALACTITOL-SPECIFIC EIIC COMPONENT', NULL, NULL, 8194, 8),
(248376, NULL, 'PTHR13050', NULL, NULL, NULL, NULL, 'USE1-LIKE PROTEIN', NULL, NULL, 18248, 8),
(248377, NULL, 'PTHR15860', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED RING FINGER-CONTAINING PROTEIN', NULL, NULL, 34748, 8),
(248378, NULL, 'PTHR46065', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MARCH 2/3 FAMILY MEMBER', NULL, NULL, NULL, 8),
(248379, NULL, 'PTHR36461', NULL, NULL, NULL, NULL, 'COORDINATOR OF PRMT5 AND DIFFERENTIATION STIMULATOR', NULL, NULL, 24460, 8),
(248380, NULL, 'PTHR36915', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(248381, NULL, 'PTHR11749', NULL, NULL, NULL, NULL, 'RIBULOSE-5-PHOSPHATE-3-EPIMERASE', NULL, NULL, 2990, 8),
(248382, NULL, 'PTHR22808', NULL, NULL, NULL, NULL, 'NCL1 YEAST -RELATED NOL1/NOP2/FMU SUN  DOMAIN-CONTAINING', NULL, NULL, 14055, 8),
(248383, NULL, 'PTHR34405', NULL, NULL, NULL, NULL, 'CRISPR-ASSOCIATED ENDORIBONUCLEASE CAS2', NULL, NULL, 10800, 8),
(248384, NULL, 'PTHR45677', NULL, NULL, NULL, NULL, 'GLUTAMATE DECARBOXYLASE-RELATED', NULL, NULL, NULL, 8),
(248385, NULL, 'PTHR46190', NULL, NULL, NULL, NULL, 'SI:CH211-201H21.5-RELATED', NULL, NULL, NULL, 8),
(248386, NULL, 'PTHR31550', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(248387, NULL, 'PTHR28156', NULL, NULL, NULL, NULL, 'FAS1 DOMAIN-CONTAINING PROTEIN YDR262W', NULL, NULL, 31158, 8),
(248388, NULL, 'PTHR31844', NULL, NULL, NULL, NULL, 'MYELIN-ASSOCIATED NEURITE-OUTGROWTH INHIBITOR-RELATED', NULL, NULL, 26517, 8),
(248389, NULL, 'PTHR37842', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(248390, NULL, 'PTHR38743', NULL, NULL, NULL, NULL, 'SIMILAR TO GLYOXYLASE I FAMILY PROTEIN', NULL, NULL, NULL, 8),
(248391, NULL, 'PTHR22957', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER GTPASE-ACTIVATING PROTEIN', NULL, NULL, NULL, 8),
(248392, NULL, 'PTHR13471', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE-LIKE HELICAL', NULL, NULL, 11277, 8),
(248393, NULL, 'PTHR36960', NULL, NULL, NULL, NULL, 'SI:DKEY-32E6.3', NULL, NULL, NULL, 8),
(248394, NULL, 'PTHR31960', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN PP2-A15', NULL, NULL, NULL, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(248395, NULL, 'PTHR33164', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, MARR FAMILY', NULL, NULL, 33063, 8),
(248396, NULL, 'PTHR32035', NULL, NULL, NULL, NULL, 'AURORA KINASE A-INTERACTING PROTEIN', NULL, NULL, NULL, 8),
(248397, NULL, 'PTHR31276', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(248398, NULL, 'PTHR40269', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN-RELATED', NULL, NULL, 19039, 8),
(248399, NULL, 'PTHR46405', NULL, NULL, NULL, NULL, 'OS05G0141500 PROTEIN', NULL, NULL, 35976, 8),
(248400, NULL, 'PTHR19375', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 70KDA', NULL, NULL, 18743, 8),
(248401, NULL, 'PTHR33917', NULL, NULL, NULL, NULL, 'PROTEIN EXECUTER 1, CHLOROPLASTIC', NULL, NULL, 34008, 8),
(248402, NULL, 'PTHR28038', NULL, NULL, NULL, NULL, 'ADL329WP', NULL, NULL, NULL, 8),
(248403, NULL, 'PTHR12253', NULL, NULL, NULL, NULL, 'RH14732P', NULL, NULL, NULL, 8),
(248404, NULL, 'PTHR47779', NULL, NULL, NULL, NULL, 'SYNTHASE (CCG-9), PUTATIVE (AFU_ORTHOLOGUE AFUA_3G12100)-RELATED', NULL, NULL, NULL, 8),
(248405, NULL, 'PTHR10240', NULL, NULL, NULL, NULL, 'ALPHA-S1-CASEIN', NULL, NULL, 23335, 8),
(248406, NULL, 'PTHR23275', NULL, NULL, NULL, NULL, 'CABRIOLET.-RELATED', NULL, NULL, NULL, 8),
(248407, NULL, 'PTHR46082', NULL, NULL, NULL, NULL, 'ATP/GTP-BINDING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(248408, NULL, 'PTHR12335', NULL, NULL, NULL, NULL, 'TIPE PROTEIN  TEMPERATURE-INDUCED PARALYTIC E', NULL, NULL, 22206, 8),
(248409, NULL, 'PTHR41263', NULL, NULL, NULL, NULL, 'ASPARTYL-PHOSPHATE PHOSPHATASE YISI', NULL, NULL, NULL, 8),
(248410, NULL, 'PTHR40129', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(248411, NULL, 'PTHR34237', NULL, NULL, NULL, NULL, 'PAREP8-RELATED', NULL, NULL, NULL, 8),
(248412, NULL, 'PTHR12110', NULL, NULL, NULL, NULL, 'HYDROXYPYRUVATE ISOMERASE', NULL, NULL, NULL, 8),
(248413, NULL, 'PTHR31871', NULL, NULL, NULL, NULL, 'OS02G0137100 PROTEIN', NULL, NULL, 6335, 8),
(248414, NULL, 'PTHR28615', NULL, NULL, NULL, NULL, 'PAK4-INHIBITOR INKA1-RELATED', NULL, NULL, 32871, 8),
(248415, NULL, 'PTHR12270', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE-RELATED', NULL, NULL, NULL, 8),
(248416, NULL, 'PTHR45969', NULL, NULL, NULL, NULL, 'RING ZINC FINGER PROTEIN-RELATED', NULL, NULL, NULL, 8),
(248417, NULL, 'PTHR12287', NULL, NULL, NULL, NULL, 'EPIDERMAL GROWTH FACTOR RECEPTOR KINASE SUBSTRATE EPS8-RELATED PROTEIN', NULL, NULL, 27259, 8),
(248418, NULL, 'PTHR47589', NULL, NULL, NULL, NULL, 'FATTY-ACID-BINDING PROTEIN 1', NULL, NULL, 35371, 8),
(248419, NULL, 'PTHR11846', NULL, NULL, NULL, NULL, 'ADENYLOSUCCINATE SYNTHETASE', NULL, NULL, 1412, 8),
(248420, NULL, 'PTHR36935', NULL, NULL, NULL, NULL, 'PROTEIN CBG00261', NULL, NULL, NULL, 8),
(248421, NULL, 'PTHR46107', NULL, NULL, NULL, NULL, 'DUMPY: SHORTER THAN WILD-TYPE', NULL, NULL, NULL, 8),
(248422, NULL, 'PTHR30462', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(248423, NULL, 'PTHR43222', NULL, NULL, NULL, NULL, 'NUDIX HYDROLASE 23', NULL, NULL, NULL, 8),
(248424, NULL, 'PTHR30282', NULL, NULL, NULL, NULL, 'P-AMINOBENZOYL GLUTAMATE TRANSPORTER', NULL, NULL, 3219, 8),
(248425, NULL, 'PTHR13304', NULL, NULL, NULL, NULL, 'GLYCOSYLPHOSPHATIDYLINOSITOL ANCHOR ATTACHMENT 1 PROTEIN', NULL, NULL, 6664, 8),
(248426, NULL, 'PTHR43431', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE, SHORT CHAIN DEHYDROGENASE/REDUCTASE FAMILY (AFU_ORTHOLOGUE AFUA_5G14000)', NULL, NULL, NULL, 8),
(248427, NULL, 'PTHR23425', NULL, NULL, NULL, NULL, 'NUCLEOPORIN AMO1-LIKE', NULL, NULL, 8879, 8),
(248428, NULL, 'PTHR33824', NULL, NULL, NULL, NULL, 'POLYKETIDE CYCLASE/DEHYDRASE AND LIPID TRANSPORT SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(248429, NULL, 'PTHR13339', NULL, NULL, NULL, NULL, 'COP9 SIGNALOSOME COMPLEX SUBUNIT 8', NULL, NULL, 32945, 8),
(248430, NULL, 'PTHR14407', NULL, NULL, NULL, NULL, 'HERMANSKY-PUDLAK SYNDROME 4 PROTEIN  LIGHT-EAR PROTEIN-RELATED', NULL, NULL, 21901, 8),
(248431, NULL, 'PTHR37560', NULL, NULL, NULL, NULL, 'UPF0210 PROTEIN SPR0218', NULL, NULL, 2365, 8),
(248432, NULL, 'PTHR46344', NULL, NULL, NULL, NULL, 'OS02G0202900 PROTEIN', NULL, NULL, 36470, 8);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(248433, NULL, 'PTHR31997', NULL, NULL, NULL, NULL, 'AGAP003710-PA', NULL, NULL, 27115, 8),
(248434, NULL, 'PTHR38698', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, 2706, 8),
(248435, NULL, 'PTHR33507', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YBBJ', NULL, NULL, NULL, 8),
(248436, NULL, 'PTHR33740', NULL, NULL, NULL, NULL, 'GPI-ANCHORED ADHESIN-LIKE PROTEIN', NULL, NULL, NULL, 8),
(248437, NULL, 'PTHR36221', NULL, NULL, NULL, NULL, '', NULL, NULL, 4084, 8),
(248438, NULL, 'PTHR47851', NULL, NULL, NULL, NULL, 'OS06G0588700 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(248439, NULL, 'PTHR31586', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE PROTEIN 20', NULL, NULL, 14798, 8),
(248440, NULL, 'PTHR10762', NULL, NULL, NULL, NULL, 'DIPHTHAMIDE BIOSYNTHESIS PROTEIN', NULL, NULL, 15307, 8),
(248441, NULL, 'PTHR15410', NULL, NULL, NULL, NULL, 'HIRA-INTERACTING PROTEIN 3', NULL, NULL, 31097, 8),
(248442, NULL, 'PTHR11002', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', NULL, NULL, 3319, 8),
(248443, NULL, 'PTHR34121', NULL, NULL, NULL, NULL, 'MYOSIN-11', NULL, NULL, NULL, 8),
(248444, NULL, 'PTHR12905', NULL, NULL, NULL, NULL, 'METALLOPHOSPHOESTERASE', NULL, NULL, NULL, 8),
(248445, NULL, 'PTHR23285', NULL, NULL, NULL, NULL, 'RING FINGER AND KH DOMAIN CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(248446, NULL, 'PTHR47456', NULL, NULL, NULL, NULL, 'PHD-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(248447, NULL, 'PTHR42851', NULL, NULL, NULL, NULL, 'ALDOLASE-RELATED', NULL, NULL, NULL, 8),
(248448, NULL, 'PTHR22928', NULL, NULL, NULL, NULL, 'TELOMERE-ASSOCIATED PROTEIN  RIF1', NULL, NULL, 21676, 8),
(248449, NULL, 'PTHR13160', NULL, NULL, NULL, NULL, 'OLIGOSACCHARYLTRANSFERASE COMPLEX SUBUNIT OSTC', NULL, NULL, 34264, 8),
(248450, NULL, 'PTHR43386', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORT SYSTEM PERMEASE PROTEIN APPC', NULL, NULL, NULL, 8),
(248451, NULL, 'PTHR31627', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA-RELATED', NULL, NULL, NULL, 8),
(248452, NULL, 'PTHR15361', NULL, NULL, NULL, NULL, 'RAD51/NUKS-INTERACTING PROTEIN', NULL, NULL, NULL, 8),
(248453, NULL, 'PTHR31583', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(248454, NULL, 'PTHR12772', NULL, NULL, NULL, NULL, 'DNA REPLICATION COMPLEX GINS PROTEIN PSF2', NULL, NULL, 6700, 8),
(248455, NULL, 'PTHR46510', NULL, NULL, NULL, NULL, 'BROMODOMAIN ADJACENT TO ZINC FINGER DOMAIN PROTEIN 1A', NULL, NULL, NULL, 8),
(248456, NULL, 'PTHR38773', NULL, NULL, NULL, NULL, 'PROTEIN SPRT', NULL, NULL, NULL, 8),
(248457, NULL, 'PTHR15512', NULL, NULL, NULL, NULL, 'TERF1-INTERACTING NUCLEAR FACTOR 2', NULL, NULL, 32749, 8),
(248458, NULL, 'PTHR12990', NULL, NULL, NULL, NULL, 'ARMET-LIKE PROTEIN', NULL, NULL, 34730, 8),
(248459, NULL, 'PTHR31218', NULL, NULL, NULL, NULL, 'WAT1-RELATED PROTEIN', NULL, NULL, 23993, 8),
(248460, NULL, 'PTHR38418', NULL, NULL, NULL, NULL, 'SUGAR ISOMERASE, KPSF/GUTQ (AFU_ORTHOLOGUE AFUA_6G08860)', NULL, NULL, NULL, 8),
(248461, NULL, 'PTHR33697', NULL, NULL, NULL, NULL, 'T17B22.17 PROTEIN-RELATED', NULL, NULL, 34015, 8),
(248462, NULL, 'PTHR14089', NULL, NULL, NULL, NULL, 'PRE-MRNA-SPLICING FACTOR RBM22', NULL, NULL, 29758, 8),
(248463, NULL, 'PTHR38682', NULL, NULL, NULL, NULL, 'V-TYPE ATP SYNTHASE SUBUNIT C', NULL, NULL, NULL, 8),
(248464, NULL, 'PTHR37865', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 23', NULL, NULL, 25928, 8),
(248465, NULL, 'PTHR13211', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(248466, NULL, 'PTHR22946', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(248467, NULL, 'PTHR12607', NULL, NULL, NULL, NULL, 'ADENOMATOUS POLYPOSIS COLI PROTEIN FAMILY', NULL, NULL, 24988, 8),
(248468, NULL, 'PTHR18916', NULL, NULL, NULL, NULL, 'DYNACTIN 1-RELATED MICROTUBULE-BINDING', NULL, NULL, NULL, 8),
(248469, NULL, 'PTHR43309', NULL, NULL, NULL, NULL, '5-OXOPROLINASE SUBUNIT C', NULL, NULL, NULL, 8),
(248470, NULL, 'PTHR43206', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE', NULL, NULL, NULL, 8),
(248471, NULL, 'PTHR31923', NULL, NULL, NULL, NULL, 'BSD DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(248472, NULL, 'PTHR19136', NULL, NULL, NULL, NULL, 'MOLYBDENUM COFACTOR GUANYLYLTRANSFERASE', NULL, NULL, NULL, 8),
(248473, NULL, 'PTHR43137', NULL, NULL, NULL, NULL, 'DIHYDROOROTASE', NULL, NULL, 3154, 8),
(248474, NULL, 'PTHR12658', NULL, NULL, NULL, NULL, 'BETA-TUBULIN COFACTOR D', NULL, NULL, 31624, 8),
(248475, NULL, 'PTHR45865', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SHPRH FAMILY MEMBER', NULL, NULL, NULL, 8),
(248476, NULL, 'PTHR22909', NULL, NULL, NULL, NULL, 'GOLGI INTEGRAL MEMBRANE PROTEIN 4', NULL, NULL, 36382, 8),
(248477, NULL, 'PTHR37212', NULL, NULL, NULL, NULL, 'ACTIN PROTEIN 2/3 COMPLEX SUBUNIT-LIKE PROTEIN', NULL, NULL, NULL, 8),
(248478, NULL, 'PTHR12431', NULL, NULL, NULL, NULL, 'SORTING NEXIN 17 AND 27', NULL, NULL, 31618, 8),
(248479, NULL, 'PTHR10511', NULL, NULL, NULL, NULL, 'GRANULOCYTE COLONY-STIMULATING FACTOR', NULL, NULL, 24765, 8),
(248480, NULL, 'PTHR31056', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 179B', NULL, NULL, 26701, 8),
(248481, NULL, 'PTHR46277', NULL, NULL, NULL, NULL, 'OS03G0850700 PROTEIN', NULL, NULL, NULL, 8),
(248482, NULL, 'PTHR18935', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 22129, 8),
(248483, NULL, 'PTHR14428', NULL, NULL, NULL, NULL, 'NUCLEOLAR COMPLEX PROTEIN 3', NULL, NULL, 17360, 8),
(248484, NULL, 'PTHR13434', NULL, NULL, NULL, NULL, 'PROTEIN CASC3', NULL, NULL, 24878, 8),
(248485, NULL, 'PTHR47532', NULL, NULL, NULL, NULL, 'RETINAL-BINDING PROTEIN', NULL, NULL, NULL, 8),
(248486, NULL, 'PTHR12935', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 2822, 8),
(248487, NULL, 'PTHR10239', NULL, NULL, NULL, NULL, 'ISTHMIN-2', NULL, NULL, NULL, 8),
(248488, NULL, 'PTHR11032', NULL, NULL, NULL, NULL, 'SL CYTOKINE', NULL, NULL, 3603, 8),
(248489, NULL, 'PTHR13501', NULL, NULL, NULL, NULL, 'CHLOROPLAST 50S RIBOSOMAL PROTEIN L22-RELATED', NULL, NULL, 4926, 8),
(248490, NULL, 'PTHR10660', NULL, NULL, NULL, NULL, 'PROTEASOME REGULATOR PA28', NULL, NULL, 6193, 8),
(248491, NULL, 'PTHR23311', NULL, NULL, NULL, NULL, 'HEAT SHOCK REGULATED 2', NULL, NULL, NULL, 8),
(248492, NULL, 'PTHR31596', NULL, NULL, NULL, NULL, 'T-CELL ACTIVATION INHIBITOR, MITOCHONDRIAL', NULL, NULL, 24695, 8),
(248493, NULL, 'PTHR45624', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL BASIC AMINO ACIDS TRANSPORTER-RELATED', NULL, NULL, NULL, 8),
(248494, NULL, 'PTHR23521', NULL, NULL, NULL, NULL, 'TRANSPORTER MFS SUPERFAMILY', NULL, NULL, NULL, 8),
(248495, NULL, 'PTHR46914', NULL, NULL, NULL, NULL, 'BACULOVIRAL IAP REPEAT-CONTAINING PROTEIN 1', NULL, NULL, 26337, 8),
(248496, NULL, 'PTHR14744', NULL, NULL, NULL, NULL, 'N-ALPHA-ACETYLTRANSFERASE 60', NULL, NULL, 36508, 8),
(248497, NULL, 'PTHR31363', NULL, NULL, NULL, NULL, 'TRAF3-INTERACTING PROTEIN 1', NULL, NULL, 19150, 8),
(248498, NULL, 'PTHR38620', NULL, NULL, NULL, NULL, 'PROTEIN CBG07292-RELATED', NULL, NULL, NULL, 8),
(248499, NULL, 'PTHR14978', NULL, NULL, NULL, NULL, 'BETA-CATENIN-LIKE PROTEIN 1  NUCLEAR ASSOCIATED PROTEIN', NULL, NULL, 33012, 8),
(248500, NULL, 'PTHR46631', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L18A-LIKE', NULL, NULL, 34221, 8),
(248501, NULL, 'PTHR37006', NULL, NULL, NULL, NULL, 'RETROVIRAL-LIKE ASPARTIC PROTEASE 1', NULL, NULL, 33712, 8),
(248502, NULL, 'PTHR35724', NULL, NULL, NULL, NULL, 'PROTEIN CHLORORESPIRATORY REDUCTION 6, CHLOROPLASTIC', NULL, NULL, 14346, 8),
(248503, NULL, 'PTHR33924', NULL, NULL, NULL, NULL, 'CATION-TRANSPORTING ATPASE', NULL, NULL, NULL, 8),
(248504, NULL, 'PTHR19316', NULL, NULL, NULL, NULL, 'PROTEIN FOLDING REGULATOR', NULL, NULL, NULL, 8),
(248505, NULL, 'PTHR36043', NULL, NULL, NULL, NULL, '2,3-BISPHOSPHOGLYCERATE-INDEPENDENT PHOSPHOGLYCERATE MUTASE', NULL, NULL, NULL, 8),
(248506, NULL, 'PTHR46077', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TOPORS', NULL, NULL, NULL, 8),
(248507, NULL, 'PTHR34662', NULL, NULL, NULL, NULL, 'OS04G0422700 PROTEIN', NULL, NULL, NULL, 8),
(248508, NULL, 'PTHR48010', NULL, NULL, NULL, NULL, 'OS05G0588300 PROTEIN', NULL, NULL, NULL, 8),
(248509, NULL, 'PTHR31989', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 82-RELATED', NULL, NULL, NULL, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(248510, NULL, 'PTHR31882', NULL, NULL, NULL, NULL, 'TNFAIP3-INTERACTING PROTEIN COILED COIL FAMILY MEMBER', NULL, NULL, NULL, 8),
(248511, NULL, 'PTHR46316', NULL, NULL, NULL, NULL, 'SNF1-RELATED PROTEIN KINASE REGULATORY SUBUNIT BETA-1', NULL, NULL, 35275, 8),
(248512, NULL, 'PTHR23216', NULL, NULL, NULL, NULL, 'NUCLEOLAR AND COILED-BODY PHOSPHOPROTEIN 1', NULL, NULL, NULL, 8),
(248513, NULL, 'PTHR15286', NULL, NULL, NULL, NULL, 'RAS-ASSOCIATING DOMAIN CONTAINING PROTEIN', NULL, NULL, 27336, 8),
(248514, NULL, 'PTHR30544', NULL, NULL, NULL, NULL, '23S RRNA METHYLTRANSFERASE', NULL, NULL, 31157, 8),
(248515, NULL, 'PTHR36856', NULL, NULL, NULL, NULL, 'OS07G0175200 PROTEIN', NULL, NULL, NULL, 8),
(248516, NULL, 'PTHR38683', NULL, NULL, NULL, NULL, 'CHORISMATE PYRUVATE-LYASE', NULL, NULL, 4455, 8),
(248517, NULL, 'PTHR23430', NULL, NULL, NULL, NULL, 'HISTONE H2A', NULL, NULL, 1479, 8),
(248518, NULL, 'PTHR28492', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC691921', NULL, NULL, 25811, 8),
(248519, NULL, 'PTHR47209', NULL, NULL, NULL, NULL, 'OS06G0639500 PROTEIN', NULL, NULL, NULL, 8),
(248520, NULL, 'PTHR45978', NULL, NULL, NULL, NULL, 'SPX DOMAIN-CONTAINING PROTEIN 3', NULL, NULL, 25760, 8),
(248521, NULL, 'PTHR42755', NULL, NULL, NULL, NULL, '3-DEOXY-MANNO-OCTULOSONATE CYTIDYLYLTRANSFERASE', NULL, NULL, 27349, 8),
(248522, NULL, 'PTHR48174', NULL, NULL, NULL, NULL, 'DUF946 FAMILY PROTEIN', NULL, NULL, NULL, 8),
(248523, NULL, 'PTHR16514', NULL, NULL, NULL, NULL, 'LOW DENSITY LIPOPROTEIN RECEPTOR CLASS A DOMAIN-CONTAINING 4A', NULL, NULL, 37643, 8),
(248524, NULL, 'PTHR10857', NULL, NULL, NULL, NULL, 'COPINE', NULL, NULL, 36621, 8),
(248525, NULL, 'PTHR47468', NULL, NULL, NULL, NULL, 'OS08G0130000 PROTEIN', NULL, NULL, NULL, 8),
(248526, NULL, 'PTHR46094', NULL, NULL, NULL, NULL, 'INTEGRATOR COMPLEX SUBUNIT 9', NULL, NULL, 25610, 8),
(248527, NULL, 'PTHR36341', NULL, NULL, NULL, NULL, 'DUF2996 FAMILY PROTEIN', NULL, NULL, 18331, 8),
(248528, NULL, 'PTHR24072', NULL, NULL, NULL, NULL, 'RHO FAMILY GTPASE', NULL, NULL, 18, 8),
(248529, NULL, 'PTHR13069', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(248530, NULL, 'PTHR41401', NULL, NULL, NULL, NULL, 'RGD1559909', NULL, NULL, 25729, 8),
(248531, NULL, 'PTHR31017', NULL, NULL, NULL, NULL, 'LATE SECRETORY PATHWAY PROTEIN AVL9-RELATED', NULL, NULL, NULL, 8),
(248532, NULL, 'PTHR31970', NULL, NULL, NULL, NULL, '', NULL, NULL, 23954, 8),
(248533, NULL, 'PTHR23124', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(248534, NULL, 'PTHR12319', NULL, NULL, NULL, NULL, 'CYSTATIN-RELATED', NULL, NULL, NULL, 8),
(248535, NULL, 'PTHR21519', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN 8', NULL, NULL, 32696, 8),
(248536, NULL, 'PTHR38386', NULL, NULL, NULL, NULL, 'OS05G0426900 PROTEIN', NULL, NULL, NULL, 8),
(248537, NULL, 'PTHR43454', NULL, NULL, NULL, NULL, 'GLYCERALDEHYDE-3-PHOSPHATE DEHYDROGENASE', NULL, NULL, NULL, 8),
(248538, NULL, 'PTHR10738', NULL, NULL, NULL, NULL, 'PROTEIN ARGININE N-METHYLTRANSFERASE 5', NULL, NULL, 22929, 8),
(248539, NULL, 'PTHR11229', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L3', NULL, NULL, 15086, 8),
(248540, NULL, 'PTHR45918', NULL, NULL, NULL, NULL, 'ALPHA-1,3/1,6-MANNOSYLTRANSFERASE ALG2', NULL, NULL, 25070, 8),
(248541, NULL, 'PTHR28155', NULL, NULL, NULL, NULL, 'ACR243WP', NULL, NULL, NULL, 8),
(248542, NULL, 'PTHR10457', NULL, NULL, NULL, NULL, 'MEVALONATE KINASE/GALACTOKINASE', NULL, NULL, NULL, 8),
(248543, NULL, 'PTHR21588', NULL, NULL, NULL, NULL, 'COILED-COIL-HELIX-COILED-COIL-HELIX DOMAIN CONTAINING 6', NULL, NULL, NULL, 8),
(248544, NULL, 'PTHR12956', NULL, NULL, NULL, NULL, 'ALKALINE CERAMIDASE-RELATED', NULL, NULL, 3668, 8),
(248545, NULL, 'PTHR34649', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 99', NULL, NULL, 30697, 8),
(248546, NULL, 'PTHR48078', NULL, NULL, NULL, NULL, 'THREONINE DEHYDRATASE, MITOCHONDRIAL-RELATED', NULL, NULL, NULL, 8),
(248547, NULL, 'PTHR23084', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-4-PHOSPHATE 5-KINASE RELATED', NULL, NULL, NULL, 8);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(248548, NULL, 'PTHR12269', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4E TRANSPORTER', NULL, NULL, 20561, 8),
(248549, NULL, 'PTHR28206', NULL, NULL, NULL, NULL, 'NUCLEOPORIN POM152', NULL, NULL, 30688, 8),
(248550, NULL, 'PTHR36463', NULL, NULL, NULL, NULL, 'KERATINOCYTE DIFFERENTIATION-ASSOCIATED PROTEIN', NULL, NULL, 22269, 8),
(248551, NULL, 'PTHR24215', NULL, NULL, NULL, NULL, 'RHO-GTPASE-ACTIVATING PROTEIN LRG1', NULL, NULL, NULL, 8),
(248552, NULL, 'PTHR46873', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(248553, NULL, 'PTHR28029', NULL, NULL, NULL, NULL, 'PROTEIN ILM1', NULL, NULL, 19776, 8),
(248554, NULL, 'PTHR40067', NULL, NULL, NULL, NULL, 'UPF0297 PROTEIN YRZL', NULL, NULL, 14210, 8),
(248555, NULL, 'PTHR11743', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT ANION-SELECTIVE CHANNEL', NULL, NULL, 4260, 8),
(248556, NULL, 'PTHR37888', NULL, NULL, NULL, NULL, 'DNA-BINDING BROMODOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(248557, NULL, 'PTHR47451', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(248558, NULL, 'PTHR37771', NULL, NULL, NULL, NULL, 'OS02G0593400 PROTEIN', NULL, NULL, NULL, 8),
(248559, NULL, 'PTHR15312', NULL, NULL, NULL, NULL, 'PROTEIN TYROSINE PHOSPHATASE RECEPTOR TYPE C-ASSOCIATED PROTEIN', NULL, NULL, 17660, 8),
(248560, NULL, 'PTHR21555', NULL, NULL, NULL, NULL, 'SPECIFICALLY ANDROGEN-REGULATED GENE PROTEIN', NULL, NULL, 22638, 8),
(248561, NULL, 'PTHR46050', NULL, NULL, NULL, NULL, 'TPR REPEAT-CONTAINING THIOREDOXIN', NULL, NULL, 34651, 8),
(248562, NULL, 'PTHR46699', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE STN8, CHLOROPLASTIC-RELATED', NULL, NULL, NULL, 8),
(248563, NULL, 'PTHR40088', NULL, NULL, NULL, NULL, 'PECTATE LYASE (EUROFUNG)', NULL, NULL, NULL, 8),
(248564, NULL, 'PTHR16740', NULL, NULL, NULL, NULL, 'CYTOCHROME B5-RELATED PROTEIN-RELATED', NULL, NULL, NULL, 8),
(248565, NULL, 'PTHR22574', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(248566, NULL, 'PTHR22526', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 25098, 8),
(248567, NULL, 'PTHR10279', NULL, NULL, NULL, NULL, 'ORNITHINE DECARBOXYLASE ANTIZYME', NULL, NULL, 7384, 8),
(248568, NULL, 'PTHR34703', NULL, NULL, NULL, NULL, 'ANTIPORTER SUBUNIT MNHG2-RELATED', NULL, NULL, 7013, 8),
(248569, NULL, 'PTHR12161', NULL, NULL, NULL, NULL, 'IST1 FAMILY MEMBER', NULL, NULL, 2321, 8),
(248570, NULL, 'PTHR40535', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(248571, NULL, 'PTHR47319', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN KIC', NULL, NULL, 34952, 8),
(248572, NULL, 'PTHR37159', NULL, NULL, NULL, NULL, 'GH11867P', NULL, NULL, NULL, 8),
(248573, NULL, 'PTHR46508', NULL, NULL, NULL, NULL, 'PHD FINGER FAMILY PROTEIN', NULL, NULL, NULL, 8),
(248574, NULL, 'PTHR42925', NULL, NULL, NULL, NULL, 'MULTIDRUG AND TOXIN EFFLUX PROTEIN MATE FAMILY', NULL, NULL, NULL, 8),
(248575, NULL, 'PTHR11793', NULL, NULL, NULL, NULL, 'BASIC HELIX-LOOP-HELIX TRANSCRIPTION FACTOR', NULL, NULL, NULL, 8),
(248576, NULL, 'PTHR46558', NULL, NULL, NULL, NULL, 'TRACRIPTIONAL REGULATORY PROTEIN-RELATED-RELATED', NULL, NULL, NULL, 8),
(248577, NULL, 'PTHR33524', NULL, NULL, NULL, NULL, 'C5ORF35', NULL, NULL, 28921, 8),
(248578, NULL, 'PTHR45914', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR HEC3-RELATED', NULL, NULL, 34537, 8),
(248579, NULL, 'PTHR28145', NULL, NULL, NULL, NULL, '12 KDA HEAT SHOCK PROTEIN', NULL, NULL, NULL, 8),
(248580, NULL, 'PTHR31697', NULL, NULL, NULL, NULL, 'INTEGRATOR COMPLEX SUBUNIT 5', NULL, NULL, 31452, 8),
(248581, NULL, 'PTHR39079', NULL, NULL, NULL, NULL, 'FI08034P-RELATED', NULL, NULL, NULL, 8),
(248582, NULL, 'PTHR15536', NULL, NULL, NULL, NULL, 'TACHYKININ-3', NULL, NULL, 1222, 8),
(248583, NULL, 'PTHR42879', NULL, NULL, NULL, NULL, '3-OXOACYL-(ACYL-CARRIER-PROTEIN) REDUCTASE', NULL, NULL, NULL, 8),
(248584, NULL, 'PTHR41142', NULL, NULL, NULL, NULL, 'SI:DKEY-16J16.4', NULL, NULL, NULL, 8),
(248585, NULL, 'PTHR47032', NULL, NULL, NULL, NULL, 'UDP-D-XYLOSE:L-FUCOSE ALPHA-1,3-D-XYLOSYLTRANSFERASE-RELATED', NULL, NULL, NULL, 8);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(248586, NULL, 'PTHR34293', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR TRMBL2', NULL, NULL, NULL, 8),
(248587, NULL, 'PTHR41309', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(248588, NULL, 'PTHR13794', NULL, NULL, NULL, NULL, 'ENOLASE SUPERFAMILY, MANDELATE RACEMASE', NULL, NULL, NULL, 8),
(248589, NULL, 'PTHR23053', NULL, NULL, NULL, NULL, 'DLEC1  DELETED IN LUNG AND ESOPHAGEAL CANCER 1', NULL, NULL, 28900, 8),
(248590, NULL, 'PTHR36371', NULL, NULL, NULL, NULL, 'PROTEIN PLASTID TRANSCRIPTIONALLY ACTIVE 10', NULL, NULL, 35102, 8),
(248591, NULL, 'PTHR46997', NULL, NULL, NULL, NULL, 'LOW AFFINITY TRYPTOPHAN PERMEASE-RELATED', NULL, NULL, 12262, 8),
(248592, NULL, 'PTHR33676', NULL, NULL, NULL, NULL, 'COLD REGULATED PROTEIN 27', NULL, NULL, 34138, 8),
(248593, NULL, 'PTHR34570', NULL, NULL, NULL, NULL, 'OS03G0593100 PROTEIN', NULL, NULL, NULL, 8),
(248594, NULL, 'PTHR45617', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT FAMILY PROTEIN', NULL, NULL, NULL, 8),
(248595, NULL, 'PTHR40638', NULL, NULL, NULL, NULL, 'UPF0591 MEMBRANE PROTEIN C15E1.02C', NULL, NULL, NULL, 8),
(248596, NULL, 'PTHR35678', NULL, NULL, NULL, NULL, 'PROTEIN STPG4', NULL, NULL, 29406, 8),
(248597, NULL, 'PTHR13522', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 23371, 8),
(248598, NULL, 'PTHR11759', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S14/30S RIBOSOMAL PROTEIN S11', NULL, NULL, 2246, 8),
(248599, NULL, 'PTHR34147', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(248600, NULL, 'PTHR12898', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 24', NULL, NULL, 18004, 8),
(248601, NULL, 'PTHR15009', NULL, NULL, NULL, NULL, 'MUELLERIAN-INHIBITING FACTOR', NULL, NULL, 15744, 8),
(248602, NULL, 'PTHR45875', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE N6AMT1', NULL, NULL, NULL, 8),
(248603, NULL, 'PTHR35866', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(248604, NULL, 'PTHR46216', NULL, NULL, NULL, NULL, 'PROSAPOSIN RECEPTOR GPR37 FAMILY MEMBER', NULL, NULL, 6301, 8),
(248605, NULL, 'PTHR33570', NULL, NULL, NULL, NULL, '4-CARBOXYMUCONOLACTONE DECARBOXYLASE FAMILY PROTEIN', NULL, NULL, NULL, 8),
(248606, NULL, 'PTHR36480', NULL, NULL, NULL, NULL, 'OS06G0118900 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(248607, NULL, 'PTHR11500', NULL, NULL, NULL, NULL, 'BETA CASEIN', NULL, NULL, 20110, 8),
(248608, NULL, 'PTHR10006', NULL, NULL, NULL, NULL, 'MUCIN-1-RELATED', NULL, NULL, NULL, 8),
(248609, NULL, 'PTHR19971', NULL, NULL, NULL, NULL, 'SIGNAL-REGULATORY PROTEIN BETA', NULL, NULL, NULL, 8),
(248610, NULL, 'PTHR47979', NULL, NULL, NULL, NULL, 'DRAB11-RELATED', NULL, NULL, NULL, 8),
(248611, NULL, 'PTHR31921', NULL, NULL, NULL, NULL, 'PROTEIN DPCD', NULL, NULL, 25580, 8),
(248612, NULL, 'PTHR31591', NULL, NULL, NULL, NULL, 'UPF0613 PROTEIN PB24D3.06C', NULL, NULL, 7570, 8),
(248613, NULL, 'PTHR46122', NULL, NULL, NULL, NULL, 'GALACTOSE OXIDASE/KELCH REPEAT PROTEIN-RELATED', NULL, NULL, NULL, 8),
(248614, NULL, 'PTHR43123', NULL, NULL, NULL, NULL, 'POLYSACCHARIDE DEACETYLASE-RELATED', NULL, NULL, NULL, 8),
(248615, NULL, 'PTHR47952', NULL, NULL, NULL, NULL, 'TRYPTAMINE 5-HYDROXYLASE', NULL, NULL, NULL, 8),
(248616, NULL, 'PTHR43153', NULL, NULL, NULL, NULL, 'ELECTRON TRANSFER FLAVOPROTEIN ALPHA', NULL, NULL, 2127, 8),
(248617, NULL, 'PTHR40627', NULL, NULL, NULL, NULL, 'INDOLE PRENYLTRANSFERASE TDIB-RELATED', NULL, NULL, 19153, 8),
(248618, NULL, 'PTHR35292', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(248619, NULL, 'PTHR36703', NULL, NULL, NULL, NULL, 'TRIACYLGLYCEROL LIPASE-LIKE PROTEIN', NULL, NULL, NULL, 8),
(248620, NULL, 'PTHR40463', NULL, NULL, NULL, NULL, 'PH-RESPONSE REGULATOR PROTEIN PALC', NULL, NULL, 27289, 8),
(248621, NULL, 'PTHR46262', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN BINIOU', NULL, NULL, NULL, 8),
(248622, NULL, 'PTHR46812', NULL, NULL, NULL, NULL, 'CARBOXYMETHYLENEBUTENOLIDASE HOMOLOG', NULL, NULL, 35894, 8),
(248623, NULL, 'PTHR15821', NULL, NULL, NULL, NULL, 'PROTEIN MN1', NULL, NULL, 31241, 8);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(248624, NULL, 'PTHR35344', NULL, NULL, NULL, NULL, 'GAS VESICLE STRUCTURAL PROTEIN 2-RELATED', NULL, NULL, NULL, 8),
(248625, NULL, 'PTHR35131', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(248626, NULL, 'PTHR35607', NULL, NULL, NULL, NULL, 'GPI-ANCHORED PROTEIN 10', NULL, NULL, NULL, 8),
(248627, NULL, 'PTHR13582', NULL, NULL, NULL, NULL, 'M-PHASE PHOSPHOPROTEIN 6', NULL, NULL, 14732, 8),
(248628, NULL, 'PTHR28031', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN HUA1', NULL, NULL, 31221, 8),
(248629, NULL, 'PTHR31566', NULL, NULL, NULL, NULL, 'CYTOCHROME C BIOGENESIS PROTEIN CCS1, CHLOROPLASTIC', NULL, NULL, 16722, 8),
(248630, NULL, 'PTHR22504', NULL, NULL, NULL, NULL, 'REPRESSOR OF RNA POLYMERASE III TRANSCRIPTION MAF1', NULL, NULL, 12060, 8),
(248631, NULL, 'PTHR14094', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE 72', NULL, NULL, 22646, 8),
(248632, NULL, 'PTHR33146', NULL, NULL, NULL, NULL, 'ENDONUCLEASE 4', NULL, NULL, 1670, 8),
(248633, NULL, 'PTHR33398', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S20', NULL, NULL, 1788, 8),
(248634, NULL, 'PTHR46906', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN BETA-8', NULL, NULL, 34410, 8),
(248635, NULL, 'PTHR21642', NULL, NULL, NULL, NULL, 'CEREBRAL CAVERNOUS MALFORMATIONS PROTEIN 2 HOMOLOG', NULL, NULL, 22988, 8),
(248636, NULL, 'PTHR40781', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(248637, NULL, 'PTHR21392', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 33194, 8),
(248638, NULL, 'PTHR33498', NULL, NULL, NULL, NULL, 'TRANSPOSASE FOR INSERTION SEQUENCE ELEMENT IS1557', NULL, NULL, NULL, 8),
(248639, NULL, 'PTHR36950', NULL, NULL, NULL, NULL, 'PROTEIN CBG24898-RELATED', NULL, NULL, NULL, 8),
(248640, NULL, 'PTHR24413', NULL, NULL, NULL, NULL, 'SPECKLE-TYPE POZ PROTEIN', NULL, NULL, NULL, 8),
(248641, NULL, 'PTHR44927', NULL, NULL, NULL, NULL, 'FK506-BINDING PROTEIN 15', NULL, NULL, NULL, 8),
(248642, NULL, 'PTHR38978', NULL, NULL, NULL, NULL, '', NULL, NULL, 17678, 8),
(248643, NULL, 'PTHR14514', NULL, NULL, NULL, NULL, 'PKA ANCHORING PROTEIN', NULL, NULL, NULL, 8),
(248644, NULL, 'PTHR42109', NULL, NULL, NULL, NULL, 'UNPLACED GENOMIC SCAFFOLD UM_SCAF_CONTIG_1.265, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(248645, NULL, 'PTHR12294', NULL, NULL, NULL, NULL, 'EF HAND DOMAIN FAMILY A1,A2-RELATED', NULL, NULL, 27330, 8),
(248646, NULL, 'PTHR46230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(248647, NULL, 'PTHR13116', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 13475, 8),
(248648, NULL, 'PTHR11097', NULL, NULL, NULL, NULL, 'EXOSOME COMPLEX EXONUCLEASE  RIBOSOMAL RNA PROCESSING PROTEIN', NULL, NULL, NULL, 8),
(248649, NULL, 'PTHR36310', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT PROTEIN KINASE INHIBITOR SMR11', NULL, NULL, 29263, 8),
(248650, NULL, 'PTHR43141', NULL, NULL, NULL, NULL, 'CYTOCHROME BD2 SUBUNIT II', NULL, NULL, 4028, 8),
(248651, NULL, 'PTHR33514', NULL, NULL, NULL, NULL, 'PROTEIN ABCI12, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(248652, NULL, 'PTHR38102', NULL, NULL, NULL, NULL, 'PERIPLASMIC CHAPERONE SPY', NULL, NULL, NULL, 8),
(248653, NULL, 'PTHR11237', NULL, NULL, NULL, NULL, 'COENZYME Q10 BIOSYNTHESIS PROTEIN 7', NULL, NULL, 8226, 8),
(248654, NULL, 'PTHR35394', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(248655, NULL, 'PTHR33108', NULL, NULL, NULL, NULL, 'OS01G0745000 PROTEIN', NULL, NULL, 12484, 8),
(248656, NULL, 'PTHR40139', NULL, NULL, NULL, NULL, 'PROTEIN TNT', NULL, NULL, 26970, 8),
(248657, NULL, 'PTHR43797', NULL, NULL, NULL, NULL, 'HOMOCYSTEINE/CYSTEINE SYNTHASE', NULL, NULL, NULL, 8),
(248658, NULL, 'PTHR36529', NULL, NULL, NULL, NULL, 'SLL1095 PROTEIN', NULL, NULL, 16856, 8),
(248659, NULL, 'PTHR34861', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(248660, NULL, 'PTHR37296', NULL, NULL, NULL, NULL, 'CONSERVED VIRULENCE FACTOR B', NULL, NULL, 9514, 8),
(248661, NULL, 'PTHR34892', NULL, NULL, NULL, NULL, 'VACUOLAR ATP SYNTHASE CATALYTIC SUBUNIT-RELATED / V-ATPASE-RELATED / VACUOLAR PROTON PUMP-LIKE PROTEIN', NULL, NULL, NULL, 8);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(248662, NULL, 'PTHR38649', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 33', NULL, NULL, 25481, 8),
(248663, NULL, 'PTHR30580', NULL, NULL, NULL, NULL, 'PRIMOSOMAL PROTEIN N', NULL, NULL, NULL, 8),
(248664, NULL, 'PTHR23276', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 21086, 8),
(248665, NULL, 'PTHR23076', NULL, NULL, NULL, NULL, 'METALLOPROTEASE M41 FTSH', NULL, NULL, NULL, 8),
(248666, NULL, 'PTHR13690', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR POSF21-RELATED', NULL, NULL, NULL, 8),
(248667, NULL, 'PTHR34256', NULL, NULL, NULL, NULL, 'UPF0561 PROTEIN C2ORF68', NULL, NULL, 20814, 8),
(248668, NULL, 'PTHR24214', NULL, NULL, NULL, NULL, 'PDZ AND LIM DOMAIN PROTEIN ZASP', NULL, NULL, NULL, 8),
(248669, NULL, 'PTHR40706', NULL, NULL, NULL, NULL, 'RIBOFLAVIN KINASE', NULL, NULL, 27112, 8),
(248670, NULL, 'PTHR43427', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN CLC-E', NULL, NULL, NULL, 8),
(248671, NULL, 'PTHR34560', NULL, NULL, NULL, NULL, 'POLYKETIDE CYCLASE/DEHYDRASE/LIPID TRANSPORT SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(248672, NULL, 'PTHR31224', NULL, NULL, NULL, NULL, 'UNC119-BINDING PROTEIN C5ORF30', NULL, NULL, 26504, 8),
(248673, NULL, 'PTHR15601', NULL, NULL, NULL, NULL, 'STRESS ASSOCIATED ENDOPLASMIC RETICULUM PROTEIN  SERP1/RAMP4', NULL, NULL, 8492, 8),
(248674, NULL, 'PTHR46912', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP B PROTEIN 13', NULL, NULL, 36218, 8),
(248675, NULL, 'PTHR23246', NULL, NULL, NULL, NULL, 'NEW-GLUE PROTEIN', NULL, NULL, NULL, 8),
(248676, NULL, 'PTHR12581', NULL, NULL, NULL, NULL, 'HIV-1 REV BINDING PROTEIN 2, 3', NULL, NULL, 12972, 8),
(248677, NULL, 'PTHR12010', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S29', NULL, NULL, 28119, 8),
(248678, NULL, 'PTHR41532', NULL, NULL, NULL, NULL, 'FIXS PROTEIN', NULL, NULL, 3354, 8),
(248679, NULL, 'PTHR24117', NULL, NULL, NULL, NULL, 'AGAP007537-PB', NULL, NULL, NULL, 8),
(248680, NULL, 'PTHR11802', NULL, NULL, NULL, NULL, 'SERINE PROTEASE FAMILY S10 SERINE CARBOXYPEPTIDASE', NULL, NULL, 5008, 8),
(248681, NULL, 'PTHR38490', NULL, NULL, NULL, NULL, 'CYSTEINE AND TYROSINE-RICH PROTEIN 1', NULL, NULL, 17006, 8),
(248682, NULL, 'PTHR28013', NULL, NULL, NULL, NULL, 'PROTEIN DCV1-RELATED', NULL, NULL, NULL, 8),
(248683, NULL, 'PTHR38115', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(248684, NULL, 'PTHR41400', NULL, NULL, NULL, NULL, 'MGC152344 PROTEIN', NULL, NULL, NULL, 8),
(248685, NULL, 'PTHR22603', NULL, NULL, NULL, NULL, 'CHOLINE/ETHANOALAMINE KINASE', NULL, NULL, NULL, 8),
(248686, NULL, 'PTHR19288', NULL, NULL, NULL, NULL, '4-NITROPHENYLPHOSPHATASE-RELATED', NULL, NULL, NULL, 8),
(248687, NULL, 'PTHR35285', NULL, NULL, NULL, NULL, '2-C-METHYL-D-ERYTHRITOL 4-PHOSPHATE CYTIDYLYLTRANSFERASE', NULL, NULL, NULL, 8),
(248688, NULL, 'PTHR36215', NULL, NULL, NULL, NULL, 'BLL4998 PROTEIN', NULL, NULL, NULL, 8),
(248689, NULL, 'PTHR11630', NULL, NULL, NULL, NULL, 'DNA REPLICATION LICENSING FACTOR MCM FAMILY MEMBER', NULL, NULL, 22230, 8),
(248690, NULL, 'PTHR31909', NULL, NULL, NULL, NULL, 'CHROMOSOME 20 ORF85 FAMILY MEMBER', NULL, NULL, NULL, 8),
(248691, NULL, 'PTHR43866', NULL, NULL, NULL, NULL, 'MALONATE-SEMIALDEHYDE DEHYDROGENASE', NULL, NULL, 6151, 8),
(248692, NULL, 'PTHR47619', NULL, NULL, NULL, NULL, 'METALLO-HYDROLASE YYCJ-RELATED', NULL, NULL, NULL, 8),
(248693, NULL, 'PTHR15967', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 15918, 8),
(248694, NULL, 'PTHR12856', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIH-RELATED', NULL, NULL, 25569, 8),
(248695, NULL, 'PTHR46805', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN J1', NULL, NULL, NULL, 8),
(248696, NULL, 'PTHR33495', NULL, NULL, NULL, NULL, 'ANTI-SIGMA FACTOR ANTAGONIST TM_1081-RELATED-RELATED', NULL, NULL, NULL, 8),
(248697, NULL, 'PTHR34605', NULL, NULL, NULL, NULL, 'PHAGE_INTEGRASE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(248698, NULL, 'PTHR18841', NULL, NULL, NULL, NULL, 'VITELLINE MEMBRANE OUTER LAYER PROTEIN I-RELATED', NULL, NULL, 1610, 8),
(248699, NULL, 'PTHR16131', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 21442, 8);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(248700, NULL, 'PTHR28009', NULL, NULL, NULL, NULL, 'PHEROMONE ALPHA FACTOR RECEPTOR', NULL, NULL, 462, 8),
(248701, NULL, 'PTHR47718', NULL, NULL, NULL, NULL, 'OS01G0519700 PROTEIN', NULL, NULL, NULL, 8),
(248702, NULL, 'PTHR34285', NULL, NULL, NULL, NULL, 'OS08G0510800 PROTEIN', NULL, NULL, NULL, 8),
(248703, NULL, 'PTHR31322', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TM129', NULL, NULL, 19014, 8),
(248704, NULL, 'PTHR28579', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT CDC26', NULL, NULL, 20781, 8),
(248705, NULL, 'PTHR43084', NULL, NULL, NULL, NULL, 'PERSULFIDE DIOXYGENASE ETHE1', NULL, NULL, NULL, 8),
(248706, NULL, 'PTHR14247', NULL, NULL, NULL, NULL, 'BREAST CANCER ANTI-ESTROGEN RESISTANCE PROTEIN 3 HOMOLOG-LIKE PROTEIN', NULL, NULL, NULL, 8),
(248707, NULL, 'PTHR47179', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SIS3', NULL, NULL, 34750, 8),
(248708, NULL, 'PTHR21405', NULL, NULL, NULL, NULL, 'CDNA SEQUENCE BC021608', NULL, NULL, 31063, 8),
(248709, NULL, 'PTHR32089', NULL, NULL, NULL, NULL, 'METHYL-ACCEPTING CHEMOTAXIS PROTEIN MCPB', NULL, NULL, NULL, 8),
(248710, NULL, 'PTHR36049', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(248711, NULL, 'PTHR15492', NULL, NULL, NULL, NULL, 'CYCLIN D1-BINDING PROTEIN 1', NULL, NULL, 26782, 8),
(248712, NULL, 'PTHR42806', NULL, NULL, NULL, NULL, 'GLYCINE CLEAVAGE SYSTEM P-PROTEIN', NULL, NULL, 15285, 8),
(248713, NULL, 'PTHR14343', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(248714, NULL, 'PTHR36378', NULL, NULL, NULL, NULL, 'COTTON FIBER PROTEIN', NULL, NULL, NULL, 8),
(248715, NULL, 'PTHR16915', NULL, NULL, NULL, NULL, 'IMMEDIATE EARLY RESPONSE 3', NULL, NULL, 22234, 8),
(248716, NULL, 'PTHR12268', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE KCMF1', NULL, NULL, NULL, 8),
(248717, NULL, 'PTHR47159', NULL, NULL, NULL, NULL, 'PROTEIN CBG07705-RELATED', NULL, NULL, NULL, 8),
(248718, NULL, 'PTHR13718', NULL, NULL, NULL, NULL, 'RIBOSOMAL S SUBUNIT', NULL, NULL, 4574, 8),
(248719, NULL, 'PTHR35473', NULL, NULL, NULL, NULL, '1-ACYL-SN-GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE', NULL, NULL, 20173, 8),
(248720, NULL, 'PTHR22850', NULL, NULL, NULL, NULL, 'WD40 REPEAT FAMILY', NULL, NULL, NULL, 8),
(248721, NULL, 'PTHR35373', NULL, NULL, NULL, NULL, 'PROTEIN CBG16894', NULL, NULL, NULL, 8),
(248722, NULL, 'PTHR15040', NULL, NULL, NULL, NULL, 'DERMATOPONTIN-RELATED', NULL, NULL, 23640, 8),
(248723, NULL, 'PTHR23531', NULL, NULL, NULL, NULL, 'QUINOLENE RESISTANCE PROTEIN NORA', NULL, NULL, NULL, 8),
(248724, NULL, 'PTHR48098', NULL, NULL, NULL, NULL, 'ENTEROCHELIN ESTERASE-RELATED', NULL, NULL, NULL, 8),
(248725, NULL, 'PTHR44305', NULL, NULL, NULL, NULL, 'SI:DKEY-192D15.2-RELATED', NULL, NULL, NULL, 8),
(248726, NULL, 'PTHR14060', NULL, NULL, NULL, NULL, 'PROTEIN P13 MTCP-1', NULL, NULL, 4480, 8),
(248727, NULL, 'PTHR39573', NULL, NULL, NULL, NULL, 'STRESS RESPONSE KINASE A', NULL, NULL, 25255, 8),
(248728, NULL, 'PTHR34495', NULL, NULL, NULL, NULL, 'UNC-51-LIKE AUTOPHAGY-ACTIVATING KINASE 1A', NULL, NULL, NULL, 8),
(248729, NULL, 'PTHR34890', NULL, NULL, NULL, NULL, '', NULL, NULL, 16452, 8),
(248730, NULL, 'PTHR30562', NULL, NULL, NULL, NULL, 'UVRC/OXIDOREDUCTASE', NULL, NULL, NULL, 8),
(248731, NULL, 'PTHR10515', NULL, NULL, NULL, NULL, 'THYMIDINE PHOSPHORYLASE', NULL, NULL, 3573, 8),
(248732, NULL, 'PTHR47255', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR 22-RELATED', NULL, NULL, NULL, 8),
(248733, NULL, 'PTHR19325', NULL, NULL, NULL, NULL, 'COMPLEMENT COMPONENT-RELATED SUSHI DOMAIN-CONTAINING', NULL, NULL, NULL, 8),
(248734, NULL, 'PTHR33932', NULL, NULL, NULL, NULL, 'NA(+)/H(+) ANTIPORTER SUBUNIT B', NULL, NULL, NULL, 8),
(248735, NULL, 'PTHR43312', NULL, NULL, NULL, NULL, 'D-THREO-ALDOSE 1-DEHYDROGENASE', NULL, NULL, NULL, 8),
(248736, NULL, 'PTHR31477', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 44 KDA', NULL, NULL, 31014, 8),
(248737, NULL, 'PTHR23042', NULL, NULL, NULL, NULL, 'CIRCADIAN PROTEIN CLOCK/ARNT/BMAL/PAS', NULL, NULL, NULL, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(248738, NULL, 'PTHR20899', NULL, NULL, NULL, NULL, 'PIERCE HOMOLOG', NULL, NULL, 23077, 8),
(248739, NULL, 'PTHR45845', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR-RELATED', NULL, NULL, NULL, 8),
(248740, NULL, 'PTHR37155', NULL, NULL, NULL, NULL, 'MUCIN 26B', NULL, NULL, NULL, 8),
(248741, NULL, 'PTHR41967', NULL, NULL, NULL, NULL, 'FI19406P1-RELATED', NULL, NULL, NULL, 8),
(248742, NULL, 'PTHR38742', NULL, NULL, NULL, NULL, 'PROTEIN GP17', NULL, NULL, NULL, 8),
(248743, NULL, 'PTHR22917', NULL, NULL, NULL, NULL, 'HEMOPEXIN DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(248744, NULL, 'PTHR48230', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(248745, NULL, 'PTHR32308', NULL, NULL, NULL, NULL, 'LYASE BETA SUBUNIT, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G13030)-RELATED', NULL, NULL, NULL, 8),
(248746, NULL, 'PTHR13820', NULL, NULL, NULL, NULL, 'SYNUCLEIN', NULL, NULL, 2440, 8),
(248747, NULL, 'PTHR36312', NULL, NULL, NULL, NULL, 'THIONIN-LIKE PROTEIN 1', NULL, NULL, 30749, 8),
(248748, NULL, 'PTHR14379', NULL, NULL, NULL, NULL, 'LIMKAIN B  LKAP', NULL, NULL, 20417, 8),
(248749, NULL, 'PTHR35704', NULL, NULL, NULL, NULL, 'OS02G0254600 PROTEIN', NULL, NULL, NULL, 8),
(248750, NULL, 'PTHR13256', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE 9', NULL, NULL, 27831, 8),
(248751, NULL, 'PTHR42721', NULL, NULL, NULL, NULL, 'SUGAR HYDROLASE-RELATED', NULL, NULL, 36580, 8),
(248752, NULL, 'PTHR36785', NULL, NULL, NULL, NULL, 'OS05G0502500 PROTEIN', NULL, NULL, NULL, 8),
(248753, NULL, 'PTHR19282', NULL, NULL, NULL, NULL, 'TETRASPANIN', NULL, NULL, 9210, 8),
(248754, NULL, 'PTHR15944', NULL, NULL, NULL, NULL, 'FARNESYLCYSTEINE LYASE', NULL, NULL, 19672, 8),
(248755, NULL, 'PTHR42753', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOME PROTEIN L39/PROLYL-TRNA LIGASE FAMILY MEMBER', NULL, NULL, NULL, 8),
(248756, NULL, 'PTHR14112', NULL, NULL, NULL, NULL, 'SYNOVIAL SARCOMA, X MEMBER', NULL, NULL, 25839, 8),
(248757, NULL, 'PTHR36560', NULL, NULL, NULL, NULL, 'CELLULOSE-BINDING DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(248758, NULL, 'PTHR21075', NULL, NULL, NULL, NULL, 'ANAEROBIC RIBONUCLEOSIDE-TRIPHOSPHATE REDUCTASE', NULL, NULL, NULL, 8),
(248759, NULL, 'PTHR10670', NULL, NULL, NULL, NULL, 'DNA POLYMERASE EPSILON CATALYTIC SUBUNIT A', NULL, NULL, 21893, 8),
(248760, NULL, 'PTHR31647', NULL, NULL, NULL, NULL, '2-CELL-STAGE, VARIABLE GROUP, MEMBER 1-RELATED', NULL, NULL, 14492, 8),
(248761, NULL, 'PTHR16798', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA GROUP C PROTEIN FANCC', NULL, NULL, 6917, 8),
(248762, NULL, 'PTHR48050', NULL, NULL, NULL, NULL, 'STEROL 3-BETA-GLUCOSYLTRANSFERASE', NULL, NULL, NULL, 8),
(248763, NULL, 'PTHR10352', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT G', NULL, NULL, NULL, 8),
(248764, NULL, 'PTHR16195', NULL, NULL, NULL, NULL, 'ZINC FINGER CCHC DOMAIN CONTAINING PROTEIN', NULL, NULL, 36074, 8),
(248765, NULL, 'PTHR14187', NULL, NULL, NULL, NULL, 'ALPHA KINASE/ELONGATION FACTOR 2 KINASE', NULL, NULL, NULL, 8),
(248766, NULL, 'PTHR43330', NULL, NULL, NULL, NULL, 'METHIONINE AMINOPEPTIDASE', NULL, NULL, NULL, 8),
(248767, NULL, 'PTHR43292', NULL, NULL, NULL, NULL, 'ACYL-COA DEHYDROGENASE', NULL, NULL, NULL, 8),
(248768, NULL, 'PTHR45963', NULL, NULL, NULL, NULL, 'RE52028P', NULL, NULL, NULL, 8),
(248769, NULL, 'PTHR43324', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(248770, NULL, 'PTHR46656', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(248771, NULL, 'PTHR31328', NULL, NULL, NULL, NULL, 'BIOGENESIS OF LYSOSOME-RELATED ORGANELLES COMPLEX 1 SUBUNIT 6', NULL, NULL, NULL, 8),
(248772, NULL, 'PTHR35752', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR', NULL, NULL, NULL, 8),
(248773, NULL, 'PTHR13798', NULL, NULL, NULL, NULL, 'RNA BINDING MOTIF RBM PROTEIN -RELATED', NULL, NULL, NULL, 8),
(248774, NULL, 'PTHR47156', NULL, NULL, NULL, NULL, 'PROTEIN CBG20824', NULL, NULL, NULL, 8),
(248775, NULL, 'PTHR36322', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(248776, NULL, 'PTHR34502', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(248777, NULL, 'PTHR21470', NULL, NULL, NULL, NULL, 'RAB6-INTERACTING PROTEIN GORAB', NULL, NULL, 6899, 8),
(248778, NULL, 'PTHR35510', NULL, NULL, NULL, NULL, 'DBH-LIKE MONOOXYGENASE', NULL, NULL, NULL, 8),
(248779, NULL, 'PTHR46427', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND LEM DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, 32030, 8),
(248780, NULL, 'PTHR11255', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE', NULL, NULL, 30543, 8),
(248781, NULL, 'PTHR24257', NULL, NULL, NULL, NULL, 'CHYMOTRYPSIN-LIKE ELASTASE FAMILY MEMBER', NULL, NULL, NULL, 8),
(248782, NULL, 'PTHR13174', NULL, NULL, NULL, NULL, 'D-GLUCURONYL C5-EPIMERASE', NULL, NULL, 30345, 8),
(248783, NULL, 'PTHR28616', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 125', NULL, NULL, 11402, 8),
(248784, NULL, 'PTHR46525', NULL, NULL, NULL, NULL, 'EMB|CAB72159.1', NULL, NULL, NULL, 8),
(248785, NULL, 'PTHR31465', NULL, NULL, NULL, NULL, 'PROTEIN RTA1-RELATED', NULL, NULL, 1673, 8),
(248786, NULL, 'PTHR13009', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 90  HSP90  CO-CHAPERONE AHA-1', NULL, NULL, 28566, 8),
(248787, NULL, 'PTHR23277', NULL, NULL, NULL, NULL, 'NECTIN-RELATED', NULL, NULL, NULL, 8),
(248788, NULL, 'PTHR38745', NULL, NULL, NULL, NULL, 'PHOSPHATASE, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(248789, NULL, 'PTHR31239', NULL, NULL, NULL, NULL, 'NICOLIN 1', NULL, NULL, 31015, 8),
(248790, NULL, 'PTHR31636', NULL, NULL, NULL, NULL, 'OSJNBA0084A10.13 PROTEIN-RELATED', NULL, NULL, 5269, 8),
(248791, NULL, 'PTHR47701', NULL, NULL, NULL, NULL, 'PROTEIN MODIFIER OF SNC1 11', NULL, NULL, 34825, 8),
(248792, NULL, 'PTHR10902', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L35A', NULL, NULL, 3005, 8),
(248793, NULL, 'PTHR10500', NULL, NULL, NULL, NULL, 'BETA-MICROSEMINOPROTEIN', NULL, NULL, 12192, 8),
(248794, NULL, 'PTHR39555', NULL, NULL, NULL, NULL, 'FIMBRIAL ASSEMBLY PROTEIN PILO-LIKE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(248795, NULL, 'PTHR46599', NULL, NULL, NULL, NULL, 'PIGGYBAC TRANSPOSABLE ELEMENT-DERIVED PROTEIN 4', NULL, NULL, NULL, 8),
(248796, NULL, 'PTHR11414', NULL, NULL, NULL, NULL, 'CYSTATIN FAMILY MEMBER', NULL, NULL, 3404, 8),
(248797, NULL, 'PTHR16036', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND ZINC FINGER DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(248798, NULL, 'PTHR36843', NULL, NULL, NULL, NULL, 'HEME-DEPENDENT PEROXIDASE YWFI-RELATED', NULL, NULL, 9267, 8),
(248799, NULL, 'PTHR30572', NULL, NULL, NULL, NULL, 'MEMBRANE COMPONENT OF TRANSPORTER-RELATED', NULL, NULL, NULL, 8),
(248800, NULL, 'PTHR11228', NULL, NULL, NULL, NULL, 'RADICAL SAM DOMAIN PROTEIN', NULL, NULL, NULL, 8),
(248801, NULL, 'PTHR33878', NULL, NULL, NULL, NULL, 'OS08G0559000 PROTEIN', NULL, NULL, 37412, 8),
(248802, NULL, 'PTHR46436', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 76 KDA', NULL, NULL, NULL, 8),
(248803, NULL, 'PTHR11280', NULL, NULL, NULL, NULL, 'GLUCOSAMINE-6-PHOSPHATE ISOMERASE', NULL, NULL, 660, 8),
(248804, NULL, 'PTHR40620', NULL, NULL, NULL, NULL, 'RESISTANCE PROTEIN CRD2, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G04318)-RELATED', NULL, NULL, NULL, 8),
(248805, NULL, 'PTHR39666', NULL, NULL, NULL, NULL, 'RANBP2-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(248806, NULL, 'PTHR19328', NULL, NULL, NULL, NULL, 'HEDGEHOG-INTERACTING PROTEIN', NULL, NULL, NULL, 8),
(248807, NULL, 'PTHR10949', NULL, NULL, NULL, NULL, 'LIPOYL SYNTHASE', NULL, NULL, 2415, 8),
(248808, NULL, 'PTHR36570', NULL, NULL, NULL, NULL, 'DISULFIDE BOND FORMATION PROTEIN B', NULL, NULL, NULL, 8),
(248809, NULL, 'PTHR10657', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE', NULL, NULL, NULL, 8),
(248810, NULL, 'PTHR13153', NULL, NULL, NULL, NULL, 'CGTHBA PROTEIN  -14 GENE PROTEIN', NULL, NULL, 6410, 8),
(248811, NULL, 'PTHR21343', NULL, NULL, NULL, NULL, 'DETHIOBIOTIN SYNTHETASE', NULL, NULL, NULL, 8),
(248812, NULL, 'PTHR21659', NULL, NULL, NULL, NULL, 'HYDROPHOBIC PROTEIN RCI2  LOW TEMPERATURE AND SALT RESPONSIVE PROTEIN LTI6 -RELATED', NULL, NULL, 5702, 8),
(248813, NULL, 'PTHR34982', NULL, NULL, NULL, NULL, 'YOP PROTEINS TRANSLOCATION PROTEIN L', NULL, NULL, NULL, 8);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(248814, NULL, 'PTHR12372', NULL, NULL, NULL, NULL, 'PECANEX', NULL, NULL, 31367, 8),
(248815, NULL, 'PTHR32510', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 98', NULL, NULL, 24172, 8),
(248816, NULL, 'PTHR33179', NULL, NULL, NULL, NULL, 'VQ MOTIF-CONTAINING PROTEIN', NULL, NULL, 27452, 8),
(248817, NULL, 'PTHR30615', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN YJBQ-RELATED', NULL, NULL, 3185, 8),
(248818, NULL, 'PTHR34303', NULL, NULL, NULL, NULL, 'OS01G0890400 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(248819, NULL, 'PTHR12939', NULL, NULL, NULL, NULL, 'SARCOGLYCAN', NULL, NULL, 31609, 8),
(248820, NULL, 'PTHR10917', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASES I, II, AND III SUBUNIT RPABC3', NULL, NULL, 1654, 8),
(248821, NULL, 'PTHR11736', NULL, NULL, NULL, NULL, 'MELANOMA-ASSOCIATED ANTIGEN  MAGE ANTIGEN', NULL, NULL, 32081, 8),
(248822, NULL, 'PTHR46853', NULL, NULL, NULL, NULL, 'METHYLOSOME PROTEIN 50', NULL, NULL, NULL, 8),
(248823, NULL, 'PTHR38597', NULL, NULL, NULL, NULL, 'BLL3834 PROTEIN', NULL, NULL, 12337, 8),
(248824, NULL, 'PTHR36411', NULL, NULL, NULL, NULL, '', NULL, NULL, 3153, 8),
(248825, NULL, 'PTHR31613', NULL, NULL, NULL, NULL, 'AUGURIN', NULL, NULL, 24843, 8),
(248826, NULL, 'PTHR45027', NULL, NULL, NULL, NULL, 'PUTATIVE GLUTATHIONE HYDROLASE LIGHT CHAIN', NULL, NULL, NULL, 8),
(248827, NULL, 'PTHR16784', NULL, NULL, NULL, NULL, 'ENAMELIN', NULL, NULL, 18243, 8),
(248828, NULL, 'PTHR43239', NULL, NULL, NULL, NULL, 'UPF0734 PROTEIN DDB_G0273871/DDB_G0273177', NULL, NULL, NULL, 8),
(248829, NULL, 'PTHR16082', NULL, NULL, NULL, NULL, 'AP-5 COMPLEX SUBUNIT MU-1', NULL, NULL, 33773, 8),
(248830, NULL, 'PTHR34308', NULL, NULL, NULL, NULL, 'COBALAMIN BIOSYNTHESIS PROTEIN CBIB', NULL, NULL, 1037, 8),
(248831, NULL, 'PTHR47885', NULL, NULL, NULL, NULL, 'AP-5 COMPLEX SUBUNIT ZETA-1', NULL, NULL, NULL, 8),
(248832, NULL, 'PTHR41368', NULL, NULL, NULL, NULL, 'PROTEIN YGHO', NULL, NULL, 28603, 8),
(248833, NULL, 'PTHR46501', NULL, NULL, NULL, NULL, 'MYOMEGALIN', NULL, NULL, NULL, 8),
(248834, NULL, 'PTHR22722', NULL, NULL, NULL, NULL, 'LOW-DENSITY LIPOPROTEIN RECEPTOR-RELATED PROTEIN 2-RELATED', NULL, NULL, NULL, 8),
(248835, NULL, 'PTHR31227', NULL, NULL, NULL, NULL, 'PROTEIN CBG15697', NULL, NULL, NULL, 8),
(248836, NULL, 'PTHR19411', NULL, NULL, NULL, NULL, 'PROTEIN BUD31-RELATED', NULL, NULL, 4598, 8),
(248837, NULL, 'PTHR35474', NULL, NULL, NULL, NULL, 'ATP PHOSPHORIBOSYLTRANSFERASE REGULATORY SUBUNIT', NULL, NULL, 27097, 8),
(248838, NULL, 'PTHR10472', NULL, NULL, NULL, NULL, 'D-TYROSYL-TRNA TYR  DEACYLASE', NULL, NULL, 2046, 8),
(248839, NULL, 'PTHR37564', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(248840, NULL, 'PTHR11039', NULL, NULL, NULL, NULL, 'NEBULIN', NULL, NULL, NULL, 8),
(248841, NULL, 'PTHR33542', NULL, NULL, NULL, NULL, 'SIROHYDROCHLORIN FERROCHELATASE, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(248842, NULL, 'PTHR31394', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 199', NULL, NULL, 15283, 8),
(248843, NULL, 'PTHR16684', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN C', NULL, NULL, 26429, 8),
(248844, NULL, 'PTHR46308', NULL, NULL, NULL, NULL, 'MATH (MEPRIN-ASSOCIATED TRAF HOMOLOGY) DOMAIN CONTAINING', NULL, NULL, NULL, 8),
(248845, NULL, 'PTHR32166', NULL, NULL, NULL, NULL, 'OSJNBA0013A04.12 PROTEIN', NULL, NULL, NULL, 8),
(248846, NULL, 'PTHR12469', NULL, NULL, NULL, NULL, 'PROTEIN EMI5 HOMOLOG, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(248847, NULL, 'PTHR35035', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(248848, NULL, 'PTHR36115', NULL, NULL, NULL, NULL, 'PROLINE-RICH ANTIGEN HOMOLOG-RELATED', NULL, NULL, NULL, 8),
(248849, NULL, 'PTHR38465', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR MJ1563-RELATED', NULL, NULL, NULL, 8),
(248850, NULL, 'PTHR39606', NULL, NULL, NULL, NULL, 'SURFACE PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(248851, NULL, 'PTHR12979', NULL, NULL, NULL, NULL, 'CCR4-NOT TRANSCRIPTION COMPLEX SUBUNIT 10', NULL, NULL, 31341, 8),
(248852, NULL, 'PTHR21698', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(248853, NULL, 'PTHR16070', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 23521, 8),
(248854, NULL, 'PTHR21420', NULL, NULL, NULL, NULL, 'GDP-FUCOSE PROTEIN O-FUCOSYLTRANSFERASE 1', NULL, NULL, 30186, 8),
(248855, NULL, 'PTHR46211', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHORYL DIESTER PHOSPHODIESTERASE', NULL, NULL, NULL, 8),
(248856, NULL, 'PTHR39474', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', NULL, NULL, NULL, 8),
(248857, NULL, 'PTHR39074', NULL, NULL, NULL, NULL, 'AGAP007547-PA', NULL, NULL, NULL, 8),
(248858, NULL, 'PTHR48195', NULL, NULL, NULL, NULL, 'FRIEND VIRUS SUSCEPTIBILITY PROTEIN 1', NULL, NULL, NULL, 8),
(248859, NULL, 'PTHR11465', NULL, NULL, NULL, NULL, 'CATALASE', NULL, NULL, 16920, 8),
(248860, NULL, 'PTHR16821', NULL, NULL, NULL, NULL, 'FRATAXIN', NULL, NULL, 6348, 8),
(248861, NULL, 'PTHR35265', NULL, NULL, NULL, NULL, 'LEUKOSIALIN', NULL, NULL, 31388, 8),
(248862, NULL, 'PTHR10662', NULL, NULL, NULL, NULL, 'NUCLEAR RNA EXPORT FACTOR', NULL, NULL, 25561, 8),
(248863, NULL, 'PTHR24221', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE SUB-FAMILY B', NULL, NULL, 33147, 8),
(248864, NULL, 'PTHR13258', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 27362, 8),
(248865, NULL, 'PTHR46491', NULL, NULL, NULL, NULL, 'CDGSH IRON SULFUR DOMAIN PROTEIN HOMOLOG', NULL, NULL, NULL, 8),
(248866, NULL, 'PTHR46420', NULL, NULL, NULL, NULL, 'BETA-1,4-GLUCURONYLTRANSFERASE 1', NULL, NULL, 34622, 8),
(248867, NULL, 'PTHR35525', NULL, NULL, NULL, NULL, 'BLL6575 PROTEIN', NULL, NULL, 11602, 8),
(248868, NULL, 'PTHR37952', NULL, NULL, NULL, NULL, '', NULL, NULL, 7944, 8),
(248869, NULL, 'PTHR47640', NULL, NULL, NULL, NULL, 'TRNA SELENOCYSTEINE 1-ASSOCIATED PROTEIN 1-RELATED-RELATED', NULL, NULL, NULL, 8),
(248870, NULL, 'PTHR14054', NULL, NULL, NULL, NULL, 'REPETIN', NULL, NULL, 29318, 8),
(248871, NULL, 'PTHR35835', NULL, NULL, NULL, NULL, 'SEA DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(248872, NULL, 'PTHR33656', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', NULL, NULL, NULL, 8),
(248873, NULL, 'PTHR22050', NULL, NULL, NULL, NULL, 'RW1 PROTEIN HOMOLOG', NULL, NULL, 32496, 8),
(248874, NULL, 'PTHR31343', NULL, NULL, NULL, NULL, 'T15D22.8', NULL, NULL, NULL, 8),
(248875, NULL, 'PTHR13618', NULL, NULL, NULL, NULL, 'LEUCINE ZIPPER CONTAINING TRANSCRIPTION FACTOR  LZF1', NULL, NULL, 21889, 8),
(248876, NULL, 'PTHR33211', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(248877, NULL, 'PTHR16253', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 22', NULL, NULL, 36578, 8),
(248878, NULL, 'PTHR24115', NULL, NULL, NULL, NULL, 'KINESIN-RELATED', NULL, NULL, 24865, 8),
(248879, NULL, 'PTHR31365', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(248880, NULL, 'PTHR16052', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 33620, 8),
(248881, NULL, 'PTHR15489', NULL, NULL, NULL, NULL, 'CASPASE 8 ASSOCIATED PROTEIN 2', NULL, NULL, 33432, 8),
(248882, NULL, 'PTHR23362', NULL, NULL, NULL, NULL, 'L-PLASTIN-RELATED', NULL, NULL, NULL, 8),
(248883, NULL, 'PTHR33065', NULL, NULL, NULL, NULL, 'OS07G0486400 PROTEIN', NULL, NULL, NULL, 8),
(248884, NULL, 'PTHR15478', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY-LIKE DOMAIN, PQ-RICH PROTEIN', NULL, NULL, 35244, 8),
(248885, NULL, 'PTHR47881', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUBFAMILY MEMBER 4', NULL, NULL, 20083, 8),
(248886, NULL, 'PTHR23323', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN', NULL, NULL, NULL, 8),
(248887, NULL, 'PTHR43823', NULL, NULL, NULL, NULL, 'SPORULATION PROTEIN YKVU', NULL, NULL, NULL, 8),
(248888, NULL, 'PTHR35109', NULL, NULL, NULL, NULL, 'GLUTAMATE RACEMASE', NULL, NULL, NULL, 8),
(248889, NULL, 'PTHR21556', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 22754, 8),
(248890, NULL, 'PTHR38497', NULL, NULL, NULL, NULL, 'KINOCILIN', NULL, NULL, 22398, 8),
(248891, NULL, 'PTHR46737', NULL, NULL, NULL, NULL, 'OS02G0827600 PROTEIN', NULL, NULL, NULL, 8),
(248892, NULL, 'PTHR16776', NULL, NULL, NULL, NULL, 'EXTRACELLULAR MATRIX PROTEIN 1', NULL, NULL, 14292, 8);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(248893, NULL, 'PTHR13260', NULL, NULL, NULL, NULL, 'ANAPHASE PROMOTING COMPLEX SUBUNIT 4  APC4', NULL, NULL, 24434, 8),
(248894, NULL, 'PTHR47518', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS EPSILON-13-RELATED', NULL, NULL, NULL, 8),
(248895, NULL, 'PTHR32428', NULL, NULL, NULL, NULL, 'TARGET OF RAPAMYCIN COMPLEX 2 SUBUNIT BIT61-RELATED', NULL, NULL, 7564, 8),
(248896, NULL, 'PTHR33721', NULL, NULL, NULL, NULL, '', NULL, NULL, 21828, 8),
(248897, NULL, 'PTHR15169', NULL, NULL, NULL, NULL, 'DAMAGE-SPECIFIC DNA BINDING PROTEIN 2', NULL, NULL, 33974, 8),
(248898, NULL, 'PTHR37200', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', NULL, NULL, NULL, 8),
(248899, NULL, 'PTHR23508', NULL, NULL, NULL, NULL, 'CARBOXYLIC ACID TRANSPORTER PROTEIN HOMOLOG', NULL, NULL, NULL, 8),
(248900, NULL, 'PTHR43003', NULL, NULL, NULL, NULL, 'DNA-3-METHYLADENINE GLYCOSYLASE', NULL, NULL, NULL, 8),
(248901, NULL, 'PTHR38646', NULL, NULL, NULL, NULL, 'YALI0F00814P', NULL, NULL, NULL, 8),
(248902, NULL, 'PTHR10414', NULL, NULL, NULL, NULL, 'ETHANOLAMINEPHOSPHOTRANSFERASE', NULL, NULL, 9682, 8),
(248903, NULL, 'PTHR35547', NULL, NULL, NULL, NULL, 'OS06G0249350 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(248904, NULL, 'PTHR21637', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN 10-RELATED', NULL, NULL, 27334, 8),
(248905, NULL, 'PTHR12716', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIE, BETA SUBUNIT', NULL, NULL, 19642, 8),
(248906, NULL, 'PTHR46029', NULL, NULL, NULL, NULL, 'C-TERMINAL-BINDING PROTEIN', NULL, NULL, NULL, 8),
(248907, NULL, 'PTHR34484', NULL, NULL, NULL, NULL, 'OS02G0832600 PROTEIN', NULL, NULL, NULL, 8),
(248908, NULL, 'PTHR30146', NULL, NULL, NULL, NULL, 'LACI-RELATED TRANSCRIPTIONAL REPRESSOR', NULL, NULL, NULL, 8),
(248909, NULL, 'PTHR15464', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR 19', NULL, NULL, 34453, 8),
(248910, NULL, 'PTHR47769', NULL, NULL, NULL, NULL, 'WAP FOUR-DISULFIDE CORE DOMAIN PROTEIN 8', NULL, NULL, NULL, 8),
(248911, NULL, 'PTHR13060', NULL, NULL, NULL, NULL, 'SGT1 PROTEIN  HSGT1   SUPPRESSOR OF GCR2', NULL, NULL, 10735, 8),
(248912, NULL, 'PTHR31318', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN-RELATED', NULL, NULL, NULL, 8),
(248913, NULL, 'PTHR43864', NULL, NULL, NULL, NULL, 'HYPOXANTHINE/GUANINE PHOSPHORIBOSYLTRANSFERASE', NULL, NULL, NULL, 8),
(248914, NULL, 'PTHR42663', NULL, NULL, NULL, NULL, 'HYDROLASE C777.06C-RELATED-RELATED', NULL, NULL, NULL, 8),
(248915, NULL, 'PTHR35978', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN M', NULL, NULL, NULL, 8),
(248916, NULL, 'PTHR39470', NULL, NULL, NULL, NULL, 'CHROMOSOME 10, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(248917, NULL, 'PTHR22960', NULL, NULL, NULL, NULL, 'MOLYBDOPTERIN COFACTOR SYNTHESIS PROTEIN A', NULL, NULL, NULL, 8),
(248918, NULL, 'PTHR38924', NULL, NULL, NULL, NULL, 'ASPARAGINE AND ASPARTATE RICH PROTEIN 1', NULL, NULL, NULL, 8),
(248919, NULL, 'PTHR12247', NULL, NULL, NULL, NULL, 'POLYCOMB GROUP PROTEIN', NULL, NULL, NULL, 8),
(248920, NULL, 'PTHR19878', NULL, NULL, NULL, NULL, 'AUTOPHAGY PROTEIN 16-LIKE', NULL, NULL, 36801, 8),
(248921, NULL, 'PTHR31325', NULL, NULL, NULL, NULL, 'OS01G0798800 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(248922, NULL, 'PTHR46145', NULL, NULL, NULL, NULL, 'HEPARANASE', NULL, NULL, NULL, 8),
(248923, NULL, 'PTHR33417', NULL, NULL, NULL, NULL, 'G-BOX BINDING PROTEIN', NULL, NULL, NULL, 8),
(248924, NULL, 'PTHR35336', NULL, NULL, NULL, NULL, 'ADENOSYLCOBINAMIDE AMIDOHYDROLASE', NULL, NULL, NULL, 8),
(248925, NULL, 'PTHR35889', NULL, NULL, NULL, NULL, 'CYCLOINULO-OLIGOSACCHARIDE FRUCTANOTRANSFERASE-RELATED', NULL, NULL, NULL, 8),
(248926, NULL, 'PTHR45902', NULL, NULL, NULL, NULL, 'LATROPHILIN RECEPTOR-LIKE PROTEIN A', NULL, NULL, NULL, 8),
(248927, NULL, 'PTHR47421', NULL, NULL, NULL, NULL, 'GS HOMEOBOX 2', NULL, NULL, 34513, 8),
(248928, NULL, 'PTHR45804', NULL, NULL, NULL, NULL, 'SEGMENTATION PROTEIN FUSHI TARAZU-LIKE PROTEIN', NULL, NULL, NULL, 8),
(248929, NULL, 'PTHR35986', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(248930, NULL, 'PTHR16677', NULL, NULL, NULL, NULL, 'HEMATOPOIETIC PROGENITOR CELL ANTIGEN CD34', NULL, NULL, 6161, 8),
(248931, NULL, 'PTHR13145', NULL, NULL, NULL, NULL, 'SSM4 PROTEIN', NULL, NULL, NULL, 8),
(248932, NULL, 'PTHR15140', NULL, NULL, NULL, NULL, 'TUBULIN-SPECIFIC CHAPERONE E', NULL, NULL, 36833, 8),
(248933, NULL, 'PTHR36873', NULL, NULL, NULL, NULL, 'HYPOTHETICAL GENE SUPPORTED BY BC079057', NULL, NULL, 26278, 8),
(248934, NULL, 'PTHR24078', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER', NULL, NULL, NULL, 8),
(248935, NULL, 'PTHR33374', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN PROTEIN 20', NULL, NULL, 8291, 8),
(248936, NULL, 'PTHR10367', NULL, NULL, NULL, NULL, 'MRNA-CAPPING ENZYME', NULL, NULL, NULL, 8),
(248937, NULL, 'PTHR12092', NULL, NULL, NULL, NULL, 'PLECKSTRIN', NULL, NULL, NULL, 8),
(248938, NULL, 'PTHR36170', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 89 KDA', NULL, NULL, 29467, 8),
(248939, NULL, 'PTHR46363', NULL, NULL, NULL, NULL, 'DEOXYRIBONUCLEASE TATDN2-RELATED', NULL, NULL, NULL, 8),
(248940, NULL, 'PTHR35721', NULL, NULL, NULL, NULL, 'UREIDOGLYCOLATE HYDROLASE', NULL, NULL, NULL, 8),
(248941, NULL, 'PTHR22947', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', NULL, NULL, NULL, 8),
(248942, NULL, 'PTHR16002', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 248-LIKE', NULL, NULL, 28994, 8),
(248943, NULL, 'PTHR18763', NULL, NULL, NULL, NULL, 'WD-REPEAT PROTEIN 18', NULL, NULL, 36744, 8),
(248944, NULL, 'PTHR15750', NULL, NULL, NULL, NULL, 'VASOHIBIN-1-LIKE ISOFORM X2', NULL, NULL, 21847, 8),
(248945, NULL, 'PTHR38130', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(248946, NULL, 'PTHR34663', NULL, NULL, NULL, NULL, 'OS06G0637400 PROTEIN', NULL, NULL, 34023, 8),
(248947, NULL, 'PTHR45773', NULL, NULL, NULL, NULL, 'SLIT AND NTRK-LIKE PROTEIN 4-RELATED', NULL, NULL, 34906, 8),
(248948, NULL, 'PTHR45809', NULL, NULL, NULL, NULL, 'VIRAL IAP-ASSOCIATED FACTOR HOMOLOG', NULL, NULL, NULL, 8),
(248949, NULL, 'PTHR42901', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE', NULL, NULL, NULL, 8),
(248950, NULL, 'PTHR47994', NULL, NULL, NULL, NULL, 'F14D16.11-RELATED', NULL, NULL, NULL, 8),
(248951, NULL, 'PTHR12387', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 8', NULL, NULL, 2623, 8),
(248952, NULL, 'PTHR11482', NULL, NULL, NULL, NULL, 'ARGININE/DIAMINOPIMELATE/ORNITHINE DECARBOXYLASE', NULL, NULL, 6674, 8),
(248953, NULL, 'PTHR36148', NULL, NULL, NULL, NULL, '50 KDA SPICULE MATRIX PROTEIN-RELATED', NULL, NULL, NULL, 8),
(248954, NULL, 'PTHR19433', NULL, NULL, NULL, NULL, 'T-CELL RECEPTOR ALPHA CHAIN V REGION-RELATED', NULL, NULL, NULL, 8),
(248955, NULL, 'PTHR33832', NULL, NULL, NULL, NULL, 'SERINE-TYPE ENDOPEPTIDASE INHIBITOR', NULL, NULL, NULL, 8),
(248956, NULL, 'PTHR37223', NULL, NULL, NULL, NULL, 'OS08G0528601 PROTEIN', NULL, NULL, NULL, 8),
(248957, NULL, 'PTHR40112', NULL, NULL, NULL, NULL, 'H2HPP ISOMERASE', NULL, NULL, NULL, 8),
(248958, NULL, 'PTHR31368', NULL, NULL, NULL, NULL, 'DEVELOPMENT PLURPOTENCY-ASSOCIATED PROTEIN 1/5 FAMILY MEMBER', NULL, NULL, NULL, 8),
(248959, NULL, 'PTHR15573', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 160-RELATED', NULL, NULL, 36306, 8),
(248960, NULL, 'PTHR16471', NULL, NULL, NULL, NULL, 'CMT1A DUPLICATED REGION TRANSCRIPT 15 PROTEIN-LIKE PROTEIN', NULL, NULL, NULL, 8),
(248961, NULL, 'PTHR34990', NULL, NULL, NULL, NULL, 'UDP-2,3-DIACYLGLUCOSAMINE HYDROLASE-RELATED', NULL, NULL, 35352, 8),
(248962, NULL, 'PTHR45850', NULL, NULL, NULL, NULL, 'SORTING NEXIN FAMILY MEMBER', NULL, NULL, NULL, 8),
(248963, NULL, 'PTHR33443', NULL, NULL, NULL, NULL, 'ZGC:112980', NULL, NULL, NULL, 8),
(248964, NULL, 'PTHR14516', NULL, NULL, NULL, NULL, '1-PYRROLINE-5-CARBOXYLATE DEHYDROGENASE FAMILY MEMBER', NULL, NULL, NULL, 8),
(248965, NULL, 'PTHR33327', NULL, NULL, NULL, NULL, 'ENDONUCLEASE', NULL, NULL, NULL, 8),
(248966, NULL, 'PTHR31131', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(248967, NULL, 'PTHR21166', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(248968, NULL, 'PTHR47478', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(248969, NULL, 'PTHR31577', NULL, NULL, NULL, NULL, 'DEVELOPMENTAL PLURIPOTENCY-ASSOCIATED PROTEIN 3-RELATED', NULL, NULL, 25476, 8),
(248970, NULL, 'PTHR46289', NULL, NULL, NULL, NULL, '52 KDA REPRESSOR OF THE INHIBITOR OF THE PROTEIN KINASE-LIKE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(248971, NULL, 'PTHR30224', NULL, NULL, NULL, NULL, 'ELECTRON TRANSPORT PROTEIN', NULL, NULL, NULL, 8),
(248972, NULL, 'PTHR10814', NULL, NULL, NULL, NULL, 'TRANSDUCIN-LIKE ENHANCER PROTEIN', NULL, NULL, 10226, 8),
(248973, NULL, 'PTHR16216', NULL, NULL, NULL, NULL, 'DYNEIN ASSEMBLY FACTOR 5, AXONEMAL', NULL, NULL, NULL, 8),
(248974, NULL, 'PTHR48045', NULL, NULL, NULL, NULL, 'UDP-GLYCOSYLTRANSFERASE 72B1', NULL, NULL, NULL, 8),
(248975, NULL, 'PTHR11709', NULL, NULL, NULL, NULL, 'MULTI-COPPER OXIDASE', NULL, NULL, 36784, 8),
(248976, NULL, 'PTHR21831', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 27146, 8),
(248977, NULL, 'PTHR10653', NULL, NULL, NULL, NULL, 'F-ACTIN-CAPPING PROTEIN SUBUNIT ALPHA', NULL, NULL, 143, 8),
(248978, NULL, 'PTHR46283', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MARCH5', NULL, NULL, NULL, 8),
(248979, NULL, 'PTHR35614', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(248980, NULL, 'PTHR15712', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(248981, NULL, 'PTHR22781', NULL, NULL, NULL, NULL, 'DELTA ADAPTIN-RELATED', NULL, NULL, 20080, 8),
(248982, NULL, 'PTHR30492', NULL, NULL, NULL, NULL, 'METHYLGLYOXAL SYNTHASE', NULL, NULL, 5073, 8),
(248983, NULL, 'PTHR14605', NULL, NULL, NULL, NULL, 'CHST5 PROTEIN', NULL, NULL, 14622, 8),
(248984, NULL, 'PTHR39290', NULL, NULL, NULL, NULL, 'C3H1-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(248985, NULL, 'PTHR42684', NULL, NULL, NULL, NULL, 'ADENOSYLMETHIONINE-8-AMINO-7-OXONONANOATE AMINOTRANSFERASE', NULL, NULL, NULL, 8),
(248986, NULL, 'PTHR12400', NULL, NULL, NULL, NULL, 'INOSITOL POLYPHOSPHATE KINASE', NULL, NULL, 1795, 8),
(248987, NULL, 'PTHR24052', NULL, NULL, NULL, NULL, 'DELTA-RELATED', NULL, NULL, NULL, 8),
(248988, NULL, 'PTHR12757', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR INDUCED PROTEIN', NULL, NULL, 12459, 8),
(248989, NULL, 'PTHR10029', NULL, NULL, NULL, NULL, 'ACYLPHOSPHATASE', NULL, NULL, 20982, 8),
(248990, NULL, 'PTHR35372', NULL, NULL, NULL, NULL, 'ATP BINDING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(248991, NULL, 'PTHR43466', NULL, NULL, NULL, NULL, '2-OXO-4-HYDROXY-4-CARBOXY-5-UREIDOIMIDAZOLINE DECARBOXYLASE-RELATED', NULL, NULL, NULL, 8),
(248992, NULL, 'PTHR13403', NULL, NULL, NULL, NULL, 'SNURPORTIN1  RNUT1 PROTEIN   RNA, U TRANSPORTER 1', NULL, NULL, 17039, 8),
(248993, NULL, 'PTHR21262', NULL, NULL, NULL, NULL, 'GUANOSINE-3'',5''-BIS DIPHOSPHATE  3''-PYROPHOSPHOHYDROLASE', NULL, NULL, NULL, 8),
(248994, NULL, 'PTHR42820', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE REDUCTASE', NULL, NULL, NULL, 8),
(248995, NULL, 'PTHR22595', NULL, NULL, NULL, NULL, 'CHITINASE-RELATED', NULL, NULL, NULL, 8),
(248996, NULL, 'PTHR14353', NULL, NULL, NULL, NULL, 'MYRISTOYLATED ALANINE-RICH C-KINASE SUBSTRATE  MARCKS', NULL, NULL, 1309, 8),
(248997, NULL, 'PTHR31828', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1-IIGAMMA', NULL, NULL, 31723, 8),
(248998, NULL, 'PTHR30061', NULL, NULL, NULL, NULL, 'MALTOSE-BINDING PERIPLASMIC PROTEIN', NULL, NULL, NULL, 8),
(248999, NULL, 'PTHR14881', NULL, NULL, NULL, NULL, 'LISH DOMAIN-CONTAINING PROTEIN ARMC9', NULL, NULL, 29887, 8),
(249000, NULL, 'PTHR35803', NULL, NULL, NULL, NULL, 'GLUCAN 1,4-ALPHA-GLUCOSIDASE SUSB-RELATED', NULL, NULL, NULL, 8),
(249001, NULL, 'PTHR47675', NULL, NULL, NULL, NULL, 'MOLYBDOPTERIN BINDING DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_5G11210)', NULL, NULL, NULL, 8),
(249002, NULL, 'PTHR21183', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L47, MITOCHONDRIAL-RELATED', NULL, NULL, 9857, 8),
(249003, NULL, 'PTHR48241', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(249004, NULL, 'PTHR36959', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN 24, MITOCHONDRIAL', NULL, NULL, NULL, 8);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(249005, NULL, 'PTHR21610', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR A DOMAIN-CONTAINING PROTEIN 8', NULL, NULL, 27006, 8),
(249006, NULL, 'PTHR21344', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 30081, 8),
(249007, NULL, 'PTHR33271', NULL, NULL, NULL, NULL, 'OS04G0445200 PROTEIN', NULL, NULL, NULL, 8),
(249008, NULL, 'PTHR34708', NULL, NULL, NULL, NULL, 'OS07G0440000 PROTEIN', NULL, NULL, NULL, 8),
(249009, NULL, 'PTHR34552', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REACTION CENTER W PROTEIN, CHLOROPLASTIC', NULL, NULL, 13210, 8),
(249010, NULL, 'PTHR20941', NULL, NULL, NULL, NULL, 'FOLATE SYNTHESIS PROTEINS', NULL, NULL, 33701, 8),
(249011, NULL, 'PTHR40128', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(249012, NULL, 'PTHR28110', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(249013, NULL, 'PTHR38827', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(249014, NULL, 'PTHR43347', NULL, NULL, NULL, NULL, 'ACYL-COA SYNTHETASE', NULL, NULL, NULL, 8),
(249015, NULL, 'PTHR46166', NULL, NULL, NULL, NULL, 'HOMEOBOX DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(249016, NULL, 'PTHR36607', NULL, NULL, NULL, NULL, '1,2-DIHYDROXY-3-KETO-5-METHYLTHIOPENTENE DIOXYGENASE 4', NULL, NULL, NULL, 8),
(249017, NULL, 'PTHR47290', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN', NULL, NULL, 37483, 8),
(249018, NULL, 'PTHR33923', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING PROTEIN-RELATED', NULL, NULL, 35802, 8),
(249019, NULL, 'PTHR38779', NULL, NULL, NULL, NULL, 'TYPE II SECRETION SYSTEM PROTEIN I-RELATED', NULL, NULL, 5276, 8),
(249020, NULL, 'PTHR30573', NULL, NULL, NULL, NULL, 'QUINOLINATE SYNTHETASE A', NULL, NULL, 6047, 8),
(249021, NULL, 'PTHR46734', NULL, NULL, NULL, NULL, 'TELOMERIC REPEAT-BINDING FACTOR 1 TERF1', NULL, NULL, NULL, 8),
(249022, NULL, 'PTHR23155', NULL, NULL, NULL, NULL, 'DISEASE RESISTANCE PROTEIN RP', NULL, NULL, 35119, 8),
(249023, NULL, 'PTHR43056', NULL, NULL, NULL, NULL, 'PEPTIDASE S9 PROLYL OLIGOPEPTIDASE', NULL, NULL, NULL, 8),
(249024, NULL, 'PTHR23351', NULL, NULL, NULL, NULL, 'FOS TRANSCRIPTION FACTOR-RELATED', NULL, NULL, 178, 8),
(249025, NULL, 'PTHR10004', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(249026, NULL, 'PTHR37859', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 3', NULL, NULL, 31510, 8),
(249027, NULL, 'PTHR35818', NULL, NULL, NULL, NULL, 'C1ORF189', NULL, NULL, NULL, 8),
(249028, NULL, 'PTHR11938', NULL, NULL, NULL, NULL, 'FAD NADPH DEHYDROGENASE/OXIDOREDUCTASE', NULL, NULL, NULL, 8),
(249029, NULL, 'PTHR28152', NULL, NULL, NULL, NULL, 'HYDROXYACYL-THIOESTER DEHYDRATASE TYPE 2, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(249030, NULL, 'PTHR36442', NULL, NULL, NULL, NULL, 'CYCLIC-DI-AMP PHOSPHODIESTERASE PGPH', NULL, NULL, NULL, 8),
(249031, NULL, 'PTHR24365', NULL, NULL, NULL, NULL, 'TOLL-LIKE RECEPTOR', NULL, NULL, 15329, 8),
(249032, NULL, 'PTHR11985', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE DEHYDROGENASE', NULL, NULL, 5998, 8),
(249033, NULL, 'PTHR47385', NULL, NULL, NULL, NULL, 'CALPONIN', NULL, NULL, NULL, 8),
(249034, NULL, 'PTHR46007', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 12', NULL, NULL, NULL, 8),
(249035, NULL, 'PTHR12705', NULL, NULL, NULL, NULL, 'ORIGIN RECOGNITION COMPLEX SUBUNIT 5', NULL, NULL, 20690, 8),
(249036, NULL, 'PTHR43209', NULL, NULL, NULL, NULL, 'TRNA SULFURTRANSFERASE', NULL, NULL, NULL, 8),
(249037, NULL, 'PTHR38016', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', NULL, NULL, NULL, 8),
(249038, NULL, 'PTHR23138', NULL, NULL, NULL, NULL, 'RAN BINDING PROTEIN', NULL, NULL, 37255, 8),
(249039, NULL, 'PTHR13268', NULL, NULL, NULL, NULL, 'BREAST CARCINOMA AMPLIFIED SEQUENCE 3', NULL, NULL, 36703, 8),
(249040, NULL, 'PTHR47144', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING PROTEIN 12', NULL, NULL, 35039, 8),
(249041, NULL, 'PTHR23507', NULL, NULL, NULL, NULL, 'ZGC:174356', NULL, NULL, NULL, 8),
(249042, NULL, 'PTHR31198', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 84', NULL, NULL, 21789, 8);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(249043, NULL, 'PTHR36191', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(249044, NULL, 'PTHR10615', NULL, NULL, NULL, NULL, 'HISTONE ACETYLTRANSFERASE', NULL, NULL, NULL, 8),
(249045, NULL, 'PTHR12860', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE 68 KDA PROTEIN', NULL, NULL, 26153, 8),
(249046, NULL, 'PTHR31481', NULL, NULL, NULL, NULL, 'RELT-LIKE PROTEIN 2 RELL2', NULL, NULL, 35354, 8),
(249047, NULL, 'PTHR30595', NULL, NULL, NULL, NULL, 'GLPR-RELATED TRANSCRIPTIONAL REPRESSOR', NULL, NULL, NULL, 8),
(249048, NULL, 'PTHR14890', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA CORE COMPLEX-ASSOCIATED PROTEIN 100', NULL, NULL, 21527, 8),
(249049, NULL, 'PTHR48049', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', NULL, NULL, NULL, 8),
(249050, NULL, 'PTHR46272', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F1_2 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(249051, NULL, 'PTHR35558', NULL, NULL, NULL, NULL, 'SGNH_HYDRO DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(249052, NULL, 'PTHR37339', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 29', NULL, NULL, NULL, 8),
(249053, NULL, 'PTHR16015', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 51', NULL, NULL, 26476, 8),
(249054, NULL, 'PTHR16047', NULL, NULL, NULL, NULL, 'RFWD3 PROTEIN', NULL, NULL, 29450, 8),
(249055, NULL, 'PTHR30213', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 18826, 8),
(249056, NULL, 'PTHR32266', NULL, NULL, NULL, NULL, 'NICOTIANAMINE SYNTHASE 3', NULL, NULL, 4714, 8),
(249057, NULL, 'PTHR31248', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G04290)-RELATED', NULL, NULL, NULL, 8),
(249058, NULL, 'PTHR31066', NULL, NULL, NULL, NULL, 'OS05G0427100 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(249059, NULL, 'PTHR11537', NULL, NULL, NULL, NULL, 'VOLTAGE-GATED POTASSIUM CHANNEL', NULL, NULL, 23924, 8),
(249060, NULL, 'PTHR12150', NULL, NULL, NULL, NULL, 'CLASS IV SAM-BINDING METHYLTRANSFERASE-RELATED', NULL, NULL, 2209, 8),
(249061, NULL, 'PTHR23098', NULL, NULL, NULL, NULL, 'AGAP001331-PA-RELATED', NULL, NULL, 24265, 8),
(249062, NULL, 'PTHR35532', NULL, NULL, NULL, NULL, 'SIMILAR TO POLYHYDROXYALKANOATE DEPOLYMERASE', NULL, NULL, NULL, 8),
(249063, NULL, 'PTHR12882', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF TY 4', NULL, NULL, 13822, 8),
(249064, NULL, 'PTHR42877', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(249065, NULL, 'PTHR10906', NULL, NULL, NULL, NULL, 'SECY/SEC61-ALPHA FAMILY MEMBER', NULL, NULL, 58, 8),
(249066, NULL, 'PTHR20873', NULL, NULL, NULL, NULL, 'L-SERYL-TRNA(SEC) KINASE', NULL, NULL, NULL, 8),
(249067, NULL, 'PTHR45228', NULL, NULL, NULL, NULL, 'CYCLIC DI-GMP PHOSPHODIESTERASE TM_0186-RELATED', NULL, NULL, NULL, 8),
(249068, NULL, 'PTHR33840', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(249069, NULL, 'PTHR28611', NULL, NULL, NULL, NULL, 'NORRIN', NULL, NULL, 6605, 8),
(249070, NULL, 'PTHR16719', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE COPPER CHAPERONE', NULL, NULL, 1319, 8),
(249071, NULL, 'PTHR45333', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(249072, NULL, 'PTHR11076', NULL, NULL, NULL, NULL, 'DNA REPAIR POLYMERASE UMUC / TRANSFERASE FAMILY MEMBER', NULL, NULL, NULL, 8),
(249073, NULL, 'PTHR36465', NULL, NULL, NULL, NULL, 'UBIQUINOL-CYTOCHROME-C REDUCTASE COMPLEX ASSEMBLY FACTOR 3', NULL, NULL, 25961, 8),
(249074, NULL, 'PTHR10137', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT C', NULL, NULL, 1904, 8),
(249075, NULL, 'PTHR35377', NULL, NULL, NULL, NULL, 'ANTITOXIN VAPB49-RELATED-RELATED', NULL, NULL, NULL, 8),
(249076, NULL, 'PTHR47879', NULL, NULL, NULL, NULL, 'RETICULON-LIKE PROTEIN B22', NULL, NULL, 34088, 8),
(249077, NULL, 'PTHR44378', NULL, NULL, NULL, NULL, 'ACYL-ACTIVATING ENZYME 17, PEROXISOMAL-RELATED', NULL, NULL, NULL, 8),
(249078, NULL, 'PTHR13850', NULL, NULL, NULL, NULL, 'PLEIOTROPHIN FAMILY MEMBER', NULL, NULL, 4159, 8),
(249079, NULL, 'PTHR21690', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(249080, NULL, 'PTHR40459', NULL, NULL, NULL, NULL, 'CONSERVED HYPOTHETICAL ALANINE AND LEUCINE RICH PROTEIN', NULL, NULL, NULL, 8);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(249081, NULL, 'PTHR47138', NULL, NULL, NULL, NULL, 'PERILIPIN-1', NULL, NULL, 34390, 8),
(249082, NULL, 'PTHR11670', NULL, NULL, NULL, NULL, 'ACONITASE/IRON-RESPONSIVE ELEMENT FAMILY MEMBER', NULL, NULL, 3829, 8),
(249083, NULL, 'PTHR34999', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(249084, NULL, 'PTHR46781', NULL, NULL, NULL, NULL, 'ALPHA 1,4-GLYCOSYLTRANSFERASE FAMILY PROTEIN', NULL, NULL, 34823, 8),
(249085, NULL, 'PTHR10838', NULL, NULL, NULL, NULL, 'SYNAPTOGYRIN', NULL, NULL, 17567, 8),
(249086, NULL, 'PTHR35006', NULL, NULL, NULL, NULL, 'GLYOXALASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_5G14830)', NULL, NULL, NULL, 8),
(249087, NULL, 'PTHR46783', NULL, NULL, NULL, NULL, 'CYTOGLOBIN', NULL, NULL, 8611, 8),
(249088, NULL, 'PTHR13423', NULL, NULL, NULL, NULL, 'OUT AT FIRST', NULL, NULL, 25717, 8),
(249089, NULL, 'PTHR21860', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIIC TFIIIC , POLYPEPTIDE 6-RELATED', NULL, NULL, 35412, 8),
(249090, NULL, 'PTHR36826', NULL, NULL, NULL, NULL, 'PROTEIN ECM13', NULL, NULL, 27048, 8),
(249091, NULL, 'PTHR31987', NULL, NULL, NULL, NULL, 'GLUTAMINASE A-RELATED', NULL, NULL, NULL, 8),
(249092, NULL, 'PTHR10778', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 35 MEMBER B', NULL, NULL, 11953, 8),
(249093, NULL, 'PTHR14586', NULL, NULL, NULL, NULL, 'THIAMINE-TRIPHOSPHATASE', NULL, NULL, 33536, 8),
(249094, NULL, 'PTHR47275', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT I, CHLOROPLASTIC', NULL, NULL, 1857, 8),
(249095, NULL, 'PTHR37278', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 33-RELATED', NULL, NULL, NULL, 8),
(249096, NULL, 'PTHR13045', NULL, NULL, NULL, NULL, '5''-NUCLEOTIDASE', NULL, NULL, NULL, 8),
(249097, NULL, 'PTHR31679', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN PEX30-RELATED', NULL, NULL, NULL, 8),
(249098, NULL, 'PTHR45504', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(249099, NULL, 'PTHR10041', NULL, NULL, NULL, NULL, 'COLIPASE', NULL, NULL, 2227, 8),
(249100, NULL, 'PTHR47060', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN NOBOX', NULL, NULL, 34890, 8),
(249101, NULL, 'PTHR28218', NULL, NULL, NULL, NULL, 'VPS4-ASSOCIATED PROTEIN 1', NULL, NULL, 12797, 8),
(249102, NULL, 'PTHR37035', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(249103, NULL, 'PTHR37242', NULL, NULL, NULL, NULL, 'OS09G0569450 PROTEIN', NULL, NULL, NULL, 8),
(249104, NULL, 'PTHR31943', NULL, NULL, NULL, NULL, 'INTERLEUKIN-28 AND 29', NULL, NULL, 21765, 8),
(249105, NULL, 'PTHR14068', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3  EIF3 -RELATED', NULL, NULL, 7636, 8),
(249106, NULL, 'PTHR35193', NULL, NULL, NULL, NULL, 'MUCIN 13A, CELL SURFACE-ASSOCIATED-RELATED', NULL, NULL, NULL, 8),
(249107, NULL, 'PTHR35127', NULL, NULL, NULL, NULL, 'OS03G0736900 PROTEIN', NULL, NULL, NULL, 8),
(249108, NULL, 'PTHR11271', NULL, NULL, NULL, NULL, 'GUANINE DEAMINASE', NULL, NULL, NULL, 8),
(249109, NULL, 'PTHR15895', NULL, NULL, NULL, NULL, 'IMMEDIATE EARLY RESPONSE GENE', NULL, NULL, 12793, 8),
(249110, NULL, 'PTHR23355', NULL, NULL, NULL, NULL, 'RIBONUCLEASE', NULL, NULL, NULL, 8),
(249111, NULL, 'PTHR11706', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER PROTEIN FAMILY 11 MEMBER', NULL, NULL, 2110, 8),
(249112, NULL, 'PTHR36789', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(249113, NULL, 'PTHR15256', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN DGCR2/IDD', NULL, NULL, 36737, 8),
(249114, NULL, 'PTHR42840', NULL, NULL, NULL, NULL, 'NAD(P)-BINDING ROSSMANN-FOLD SUPERFAMILY PROTEIN-RELATED', NULL, NULL, NULL, 8),
(249115, NULL, 'PTHR11467', NULL, NULL, NULL, NULL, 'HISTONE H1', NULL, NULL, NULL, 8),
(249116, NULL, 'PTHR21462', NULL, NULL, NULL, NULL, 'CELL SURFACE GLYCOPROTEIN OX2 RECEPTOR PRECURSOR', NULL, NULL, 32491, 8),
(249117, NULL, 'PTHR34458', NULL, NULL, NULL, NULL, 'POLLEN OLE E 1 ALLERGEN AND EXTENSIN FAMILY PROTEIN-RELATED', NULL, NULL, 27605, 8),
(249118, NULL, 'PTHR46981', NULL, NULL, NULL, NULL, 'BIS(5''-ADENOSYL)-TRIPHOSPHATASE', NULL, NULL, NULL, 8);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(249119, NULL, 'PTHR23254', NULL, NULL, NULL, NULL, 'EIF4G DOMAIN PROTEIN', NULL, NULL, NULL, 8),
(249120, NULL, 'PTHR40422', NULL, NULL, NULL, NULL, 'TRANSLATION MACHINERY-ASSOCIATED PROTEIN 17', NULL, NULL, 30422, 8),
(249121, NULL, 'PTHR33530', NULL, NULL, NULL, NULL, 'OS01G0147100 PROTEIN', NULL, NULL, 20973, 8),
(249122, NULL, 'PTHR35103', NULL, NULL, NULL, NULL, 'OS06G0115700 PROTEIN', NULL, NULL, NULL, 8),
(249123, NULL, 'PTHR43650', NULL, NULL, NULL, NULL, 'PYROPHOSPHATE--FRUCTOSE 6-PHOSPHATE 1-PHOSPHOTRANSFERASE', NULL, NULL, NULL, 8),
(249124, NULL, 'PTHR35605', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(249125, NULL, 'PTHR12119', NULL, NULL, NULL, NULL, 'UBIQUINOL-CYTOCHROME C REDUCTASE COMPLEX UBIQUINONE-BINDING PROTEIN QP-C', NULL, NULL, 3964, 8),
(249126, NULL, 'PTHR47120', NULL, NULL, NULL, NULL, 'THAP DOMAIN-CONTAINING PROTEIN 3', NULL, NULL, 23311, 8),
(249127, NULL, 'PTHR35799', NULL, NULL, NULL, NULL, 'S-RIBOSYLHOMOCYSTEINE LYASE', NULL, NULL, 3109, 8),
(249128, NULL, 'PTHR36922', NULL, NULL, NULL, NULL, 'BLL2446 PROTEIN', NULL, NULL, 14786, 8),
(249129, NULL, 'PTHR37401', NULL, NULL, NULL, NULL, 'YALI0E18722P', NULL, NULL, NULL, 8),
(249130, NULL, 'PTHR39308', NULL, NULL, NULL, NULL, 'HEAVY PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(249131, NULL, 'PTHR38474', NULL, NULL, NULL, NULL, 'SLR0299 PROTEIN', NULL, NULL, 3287, 8),
(249132, NULL, 'PTHR31480', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL LYCOPENE CYCLASE/PHYTOENE SYNTHASE', NULL, NULL, NULL, 8),
(249133, NULL, 'PTHR12427', NULL, NULL, NULL, NULL, 'ATP SYNTHASE E CHAIN, MITOCHONDRIAL', NULL, NULL, 7861, 8),
(249134, NULL, 'PTHR48219', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 62-RELATED', NULL, NULL, NULL, 8),
(249135, NULL, 'PTHR47752', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REPRESSOR FABR', NULL, NULL, NULL, 8),
(249136, NULL, 'PTHR36302', NULL, NULL, NULL, NULL, 'BLR7088 PROTEIN', NULL, NULL, 3947, 8),
(249137, NULL, 'PTHR31441', NULL, NULL, NULL, NULL, 'FOLLICULIN FAMILY MEMBER', NULL, NULL, 19487, 8),
(249138, NULL, 'PTHR46748', NULL, NULL, NULL, NULL, 'LRRNT DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(249139, NULL, 'PTHR30548', NULL, NULL, NULL, NULL, '2-HYDROXYGLUTARYL-COA DEHYDRATASE, D-COMPONENT-RELATED', NULL, NULL, NULL, 8),
(249140, NULL, 'PTHR35352', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 150', NULL, NULL, 32179, 8),
(249141, NULL, 'PTHR10953', NULL, NULL, NULL, NULL, 'UBIQUITIN-ACTIVATING ENZYME E1', NULL, NULL, 37008, 8),
(249142, NULL, 'PTHR42986', NULL, NULL, NULL, NULL, 'BENZALDEHYDE DEHYDROGENASE YFMT', NULL, NULL, NULL, 8),
(249143, NULL, 'PTHR28014', NULL, NULL, NULL, NULL, 'NEGATIVE REGULATOR OF RAS-CAMP PATHWAY', NULL, NULL, NULL, 8),
(249144, NULL, 'PTHR43112', NULL, NULL, NULL, NULL, 'FERREDOXIN', NULL, NULL, NULL, 8),
(249145, NULL, 'PTHR46575', NULL, NULL, NULL, NULL, 'AMYLOID PROTEIN-BINDING PROTEIN 2', NULL, NULL, 35567, 8),
(249146, NULL, 'PTHR35385', NULL, NULL, NULL, NULL, 'PROTEIN B, PUTATIVE-RELATED-RELATED', NULL, NULL, NULL, 8),
(249147, NULL, 'PTHR10825', NULL, NULL, NULL, NULL, 'RING FINGER DOMAIN-CONTAINING, POLYCOMB GROUP COMPONENT', NULL, NULL, NULL, 8),
(249148, NULL, 'PTHR31666', NULL, NULL, NULL, NULL, 'PROTEIN CXORF40A-RELATED', NULL, NULL, 29841, 8),
(249149, NULL, 'PTHR35316', NULL, NULL, NULL, NULL, '28S RIBOSOMAL S34 PROTEIN', NULL, NULL, NULL, 8),
(249150, NULL, 'PTHR11252', NULL, NULL, NULL, NULL, 'POLYRIBONUCLEOTIDE NUCLEOTIDYLTRANSFERASE', NULL, NULL, 7490, 8),
(249151, NULL, 'PTHR37218', NULL, NULL, NULL, NULL, 'COILED-COIL PROTEIN', NULL, NULL, NULL, 8),
(249152, NULL, 'PTHR33434', NULL, NULL, NULL, NULL, 'DEGV DOMAIN-CONTAINING PROTEIN DR_1986-RELATED', NULL, NULL, NULL, 8),
(249153, NULL, 'PTHR21603', NULL, NULL, NULL, NULL, 'ANTIGEN KI-67-LIKE PROTEIN', NULL, NULL, NULL, 8),
(249154, NULL, 'PTHR45683', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL NICOTINAMIDE ADENINE DINUCLEOTIDE TRANSPORTER 1-RELATED-RELATED', NULL, NULL, 34892, 8),
(249155, NULL, 'PTHR36721', NULL, NULL, NULL, NULL, 'PROLINE-RICH FAMILY PROTEIN', NULL, NULL, NULL, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(249156, NULL, 'PTHR15065', NULL, NULL, NULL, NULL, 'INSULINOMA-ASSOCIATED 1', NULL, NULL, 35498, 8),
(249157, NULL, 'PTHR16551', NULL, NULL, NULL, NULL, 'AGOUTI RELATED', NULL, NULL, 1078, 8),
(249158, NULL, 'PTHR12274', NULL, NULL, NULL, NULL, 'GRANULIN', NULL, NULL, 28288, 8),
(249159, NULL, 'PTHR38705', NULL, NULL, NULL, NULL, 'PROTEIN RDS1', NULL, NULL, 28327, 8),
(249160, NULL, 'PTHR31392', NULL, NULL, NULL, NULL, 'ALPHA-1,3-MANNOSYLTRANSFERASE MNN1-RELATED', NULL, NULL, NULL, 8),
(249161, NULL, 'PTHR15858', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 17968, 8),
(249162, NULL, 'PTHR31373', NULL, NULL, NULL, NULL, 'OS06G0652100 PROTEIN', NULL, NULL, 10965, 8),
(249163, NULL, 'PTHR24327', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN', NULL, NULL, NULL, 8),
(249164, NULL, 'PTHR23282', NULL, NULL, NULL, NULL, 'APICAL ENDOSOMAL GLYCOPROTEIN PRECURSOR.', NULL, NULL, NULL, 8),
(249165, NULL, 'PTHR35573', NULL, NULL, NULL, NULL, 'PROTEIN CBG22129', NULL, NULL, NULL, 8),
(249166, NULL, 'PTHR35739', NULL, NULL, NULL, NULL, 'OS01G0861700 PROTEIN', NULL, NULL, NULL, 8),
(249167, NULL, 'PTHR23330', NULL, NULL, NULL, NULL, 'P300 TRANSCRIPTIONAL COFACTOR JMY-RELATED', NULL, NULL, NULL, 8),
(249168, NULL, 'PTHR46403', NULL, NULL, NULL, NULL, 'TP53-REGULATED INHIBITOR OF APOPTOSIS 1', NULL, NULL, 3223, 8),
(249169, NULL, 'PTHR39569', NULL, NULL, NULL, NULL, 'INORGANIC TRIPHOSPHATASE', NULL, NULL, 32252, 8),
(249170, NULL, 'PTHR31388', NULL, NULL, NULL, NULL, 'PEROXIDASE 72-RELATED', NULL, NULL, 4670, 8),
(249171, NULL, 'PTHR10590', NULL, NULL, NULL, NULL, 'SODIUM/NUCLEOSIDE COTRANSPORTER', NULL, NULL, 6228, 8),
(249172, NULL, 'PTHR39535', NULL, NULL, NULL, NULL, 'SPORULATION-DELAYING PROTEIN SDPB', NULL, NULL, NULL, 8),
(249173, NULL, 'PTHR46830', NULL, NULL, NULL, NULL, 'TRANSFERASE, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(249174, NULL, 'PTHR11205', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S7', NULL, NULL, 4569, 8),
(249175, NULL, 'PTHR15657', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 7675, 8),
(249176, NULL, 'PTHR11278', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S7', NULL, NULL, 5757, 8),
(249177, NULL, 'PTHR47051', NULL, NULL, NULL, NULL, 'NESTIN', NULL, NULL, 24355, 8),
(249178, NULL, 'PTHR42805', NULL, NULL, NULL, NULL, 'PTERIN-4-ALPHA-CARBINOLAMINE DEHYDRATASE-RELATED', NULL, NULL, NULL, 8),
(249179, NULL, 'PTHR47785', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED-RELATED', NULL, NULL, NULL, 8),
(249180, NULL, 'PTHR11717', NULL, NULL, NULL, NULL, 'LOW MOLECULAR WEIGHT PROTEIN TYROSINE PHOSPHATASE', NULL, NULL, NULL, 8),
(249181, NULL, 'PTHR21435', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 14747, 8),
(249182, NULL, 'PTHR36356', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(249183, NULL, 'PTHR38469', NULL, NULL, NULL, NULL, '', NULL, NULL, 18034, 8),
(249184, NULL, 'PTHR20997', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 13263, 8),
(249185, NULL, 'PTHR31383', NULL, NULL, NULL, NULL, 'OXIDATIVE STRESS-RESPONSE SERINE-RICH PROTEIN 1', NULL, NULL, 12396, 8),
(249186, NULL, 'PTHR14312', NULL, NULL, NULL, NULL, 'CREB/ATF BZIP TRANSCRIPTION FACTOR', NULL, NULL, NULL, 8),
(249187, NULL, 'PTHR11660', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 40 MEMBER', NULL, NULL, 12349, 8),
(249188, NULL, 'PTHR12126', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE 39 KDA SUBUNIT-RELATED', NULL, NULL, NULL, 8),
(249189, NULL, 'PTHR37850', NULL, NULL, NULL, NULL, 'STRU PROTEIN', NULL, NULL, NULL, 8),
(249190, NULL, 'PTHR45664', NULL, NULL, NULL, NULL, 'PROTEIN ZERKNUELLT 1-RELATED', NULL, NULL, NULL, 8),
(249191, NULL, 'PTHR23132', NULL, NULL, NULL, NULL, 'D-ALANINE--D-ALANINE LIGASE', NULL, NULL, NULL, 8),
(249192, NULL, 'PTHR47929', NULL, NULL, NULL, NULL, 'DYW_DEAMINASE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(249193, NULL, 'PTHR47405', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS H-RELATED', NULL, NULL, NULL, 8),
(249194, NULL, 'PTHR43115', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE SDR FAMILY MEMBER 11', NULL, NULL, NULL, 8);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(249195, NULL, 'PTHR43007', NULL, NULL, NULL, NULL, '2-PHOSPHO-L-LACTATE TRANSFERASE', NULL, NULL, 10733, 8),
(249196, NULL, 'PTHR14955', NULL, NULL, NULL, NULL, 'RETINOIC ACID INDUCED 1/TRANSCRIPTION FACTOR 20', NULL, NULL, NULL, 8),
(249197, NULL, 'PTHR36942', NULL, NULL, NULL, NULL, 'PROTEIN CBG10268', NULL, NULL, NULL, 8),
(249198, NULL, 'PTHR24134', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT-CONTAINING PROTEIN DDB_G0279043', NULL, NULL, NULL, 8),
(249199, NULL, 'PTHR42836', NULL, NULL, NULL, NULL, '7-CARBOXY-7-DEAZAGUANINE SYNTHASE', NULL, NULL, NULL, 8),
(249200, NULL, 'PTHR11967', NULL, NULL, NULL, NULL, 'ALPHA-1-ACID GLYCOPROTEIN', NULL, NULL, NULL, 8),
(249201, NULL, 'PTHR21552', NULL, NULL, NULL, NULL, 'ADULT RETINA PROTEIN', NULL, NULL, 32546, 8),
(249202, NULL, 'PTHR24338', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN MSX', NULL, NULL, NULL, 8),
(249203, NULL, 'PTHR15892', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOMAL PROTEIN L30', NULL, NULL, 1445, 8),
(249204, NULL, 'PTHR14871', NULL, NULL, NULL, NULL, 'DYNEIN REGULATORY COMPLEX PROTEIN 9', NULL, NULL, 35601, 8),
(249205, NULL, 'PTHR36347', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(249206, NULL, 'PTHR34362', NULL, NULL, NULL, NULL, 'WPP DOMAIN-CONTAINING PROTEIN 1-RELATED', NULL, NULL, 34818, 8),
(249207, NULL, 'PTHR28228', NULL, NULL, NULL, NULL, 'SECRETORY COMPONENT PROTEIN SHR3', NULL, NULL, 13314, 8),
(249208, NULL, 'PTHR34377', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(249209, NULL, 'PTHR31517', NULL, NULL, NULL, NULL, '', NULL, NULL, 4670, 8),
(249210, NULL, 'PTHR30330', NULL, NULL, NULL, NULL, 'AGSS FAMILY TRANSPORTER, SODIUM-ALANINE', NULL, NULL, 3009, 8),
(249211, NULL, 'PTHR14624', NULL, NULL, NULL, NULL, 'DFG10 PROTEIN', NULL, NULL, 31021, 8),
(249212, NULL, 'PTHR47427', NULL, NULL, NULL, NULL, 'PROTEIN STE12', NULL, NULL, NULL, 8),
(249213, NULL, 'PTHR13490', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 28S RIBOSOMAL PROTEIN S28', NULL, NULL, 27456, 8),
(249214, NULL, 'PTHR34851', NULL, NULL, NULL, NULL, 'PROTEIN CBG05235-RELATED', NULL, NULL, NULL, 8),
(249215, NULL, 'PTHR14256', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE MLRQ SUBUNIT', NULL, NULL, 14144, 8),
(249216, NULL, 'PTHR47412', NULL, NULL, NULL, NULL, 'FI01434P-RELATED', NULL, NULL, NULL, 8),
(249217, NULL, 'PTHR47312', NULL, NULL, NULL, NULL, 'MELANOMA-DERIVED GROWTH REGULATORY PROTEIN', NULL, NULL, 36816, 8),
(249218, NULL, 'PTHR45288', NULL, NULL, NULL, NULL, 'THIOREDOXIN FAMILY PROTEIN', NULL, NULL, NULL, 8),
(249219, NULL, 'PTHR31030', NULL, NULL, NULL, NULL, 'PLASMA MEMBRANE FUSION PROTEIN PRM1', NULL, NULL, 24142, 8),
(249220, NULL, 'PTHR34367', NULL, NULL, NULL, NULL, 'OS02G0734667 PROTEIN', NULL, NULL, 27616, 8),
(249221, NULL, 'PTHR47623', NULL, NULL, NULL, NULL, 'OS09G0287300 PROTEIN', NULL, NULL, NULL, 8),
(249222, NULL, 'PTHR13204', NULL, NULL, NULL, NULL, 'PTD012 PROTEIN', NULL, NULL, 7703, 8),
(249223, NULL, 'PTHR28054', NULL, NULL, NULL, NULL, 'RNA POLYMERASE I-SPECIFIC TRANSCRIPTION INITIATION FACTOR RRN10', NULL, NULL, 17080, 8),
(249224, NULL, 'PTHR22084', NULL, NULL, NULL, NULL, 'GEX INTERACTING PROTEIN PROTEIN 4', NULL, NULL, NULL, 8),
(249225, NULL, 'PTHR22893', NULL, NULL, NULL, NULL, 'NADH OXIDOREDUCTASE-RELATED', NULL, NULL, 34266, 8),
(249226, NULL, 'PTHR46435', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HECTD4-RELATED', NULL, NULL, 34331, 8),
(249227, NULL, 'PTHR32251', NULL, NULL, NULL, NULL, '3-OXO-5-ALPHA-STEROID 4-DEHYDROGENASE', NULL, NULL, 9977, 8),
(249228, NULL, 'PTHR47491', NULL, NULL, NULL, NULL, 'CAP-GLY DOMAIN LINKER', NULL, NULL, NULL, 8),
(249229, NULL, 'PTHR19872', NULL, NULL, NULL, NULL, 'UBIQUITIN LIGASE SPECIFICITY FACTOR/HREP PROTEIN', NULL, NULL, NULL, 8),
(249230, NULL, 'PTHR31230', NULL, NULL, NULL, NULL, 'MYELOID-DERIVED GROWTH FACTOR MYDGF', NULL, NULL, 20598, 8),
(249231, NULL, 'PTHR48080', NULL, NULL, NULL, NULL, 'D-GALACTONATE DEHYDRATASE-RELATED', NULL, NULL, 9814, 8),
(249232, NULL, 'PTHR46264', NULL, NULL, NULL, NULL, 'TYROSINE-TRNA LIGASE', NULL, NULL, NULL, 8);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(249233, NULL, 'PTHR44186', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(249234, NULL, 'PTHR22753', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 68', NULL, NULL, NULL, 8),
(249235, NULL, 'PTHR19919', NULL, NULL, NULL, NULL, 'WD REPEAT CONTAINING PROTEIN', NULL, NULL, 36644, 8),
(249236, NULL, 'PTHR36351', NULL, NULL, NULL, NULL, 'EMBRYO SAC DEVELOPMENT ARREST 12', NULL, NULL, NULL, 8),
(249237, NULL, 'PTHR24216', NULL, NULL, NULL, NULL, 'PAXILLIN-RELATED', NULL, NULL, NULL, 8),
(249238, NULL, 'PTHR14430', NULL, NULL, NULL, NULL, 'RABIN3-RELATED', NULL, NULL, 27628, 8),
(249239, NULL, 'PTHR31191', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN CEP126', NULL, NULL, 23034, 8),
(249240, NULL, 'PTHR40084', NULL, NULL, NULL, NULL, 'PHOSPHOHYDROLASE, PHP FAMILY', NULL, NULL, NULL, 8),
(249241, NULL, 'PTHR34688', NULL, NULL, NULL, NULL, 'CYTOCHROME C6, CHLOROPLASTIC', NULL, NULL, 16371, 8),
(249242, NULL, 'PTHR15838', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN OF 40 KDA', NULL, NULL, NULL, 8),
(249243, NULL, 'PTHR47927', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(249244, NULL, 'PTHR42859', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE', NULL, NULL, NULL, 8),
(249245, NULL, 'PTHR47459', NULL, NULL, NULL, NULL, 'KINESIN LIGHT CHAIN-RELATED', NULL, NULL, NULL, 8),
(249246, NULL, 'PTHR28284', NULL, NULL, NULL, NULL, 'NUCLEOPORIN NUP60', NULL, NULL, 16244, 8),
(249247, NULL, 'PTHR31826', NULL, NULL, NULL, NULL, 'NICALIN', NULL, NULL, 17622, 8),
(249248, NULL, 'PTHR13135', NULL, NULL, NULL, NULL, 'CYTOSOLIC RESINIFERATOXIN BINDING PROTEIN RBP-26', NULL, NULL, 32692, 8),
(249249, NULL, 'PTHR46338', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 8', NULL, NULL, 32896, 8),
(249250, NULL, 'PTHR35891', NULL, NULL, NULL, NULL, 'THIOL:DISULFIDE INTERCHANGE PROTEIN DSBA', NULL, NULL, NULL, 8),
(249251, NULL, 'PTHR31635', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(249252, NULL, 'PTHR38650', NULL, NULL, NULL, NULL, 'KITA-KYUSHU LUNG CANCER ANTIGEN 1', NULL, NULL, 24948, 8),
(249253, NULL, 'PTHR23514', NULL, NULL, NULL, NULL, 'BYPASS OF STOP CODON PROTEIN 6', NULL, NULL, NULL, 8),
(249254, NULL, 'PTHR37379', NULL, NULL, NULL, NULL, 'OS01G0220500 PROTEIN', NULL, NULL, NULL, 8),
(249255, NULL, 'PTHR16207', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 36942, 8),
(249256, NULL, 'PTHR47590', NULL, NULL, NULL, NULL, 'F-BOX/KELCH-REPEAT PROTEIN SKIP25', NULL, NULL, NULL, 8),
(249257, NULL, 'PTHR38482', NULL, NULL, NULL, NULL, '', NULL, NULL, 3905, 8),
(249258, NULL, 'PTHR34720', NULL, NULL, NULL, NULL, 'MICROCYSTIN DEPENDENT PROTEIN', NULL, NULL, NULL, 8),
(249259, NULL, 'PTHR43109', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE KINASE 7', NULL, NULL, NULL, 8),
(249260, NULL, 'PTHR16035', NULL, NULL, NULL, NULL, 'PROTEIN FAM90A1', NULL, NULL, 28402, 8),
(249261, NULL, 'PTHR34580', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(249262, NULL, 'PTHR31654', NULL, NULL, NULL, NULL, 'SECRETED BETA-GLUCOSIDASE ADG3-RELATED', NULL, NULL, NULL, 8),
(249263, NULL, 'PTHR30309', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YGIH', NULL, NULL, 6290, 8),
(249264, NULL, 'PTHR40447', NULL, NULL, NULL, NULL, 'ANAEROBIC SULFITE REDUCTASE SUBUNIT A', NULL, NULL, NULL, 8),
(249265, NULL, 'PTHR38034', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YPJD', NULL, NULL, NULL, 8),
(249266, NULL, 'PTHR44461', NULL, NULL, NULL, NULL, 'QUINONE OXIDOREDUCTASE-LIKE PROTEIN 1', NULL, NULL, 35927, 8),
(249267, NULL, 'PTHR34125', NULL, NULL, NULL, NULL, 'OS01G0762900 PROTEIN', NULL, NULL, NULL, 8),
(249268, NULL, 'PTHR31323', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE ION CHANNEL PROTEIN MSY2', NULL, NULL, NULL, 8),
(249269, NULL, 'PTHR47137', NULL, NULL, NULL, NULL, 'ERMIN', NULL, NULL, 34301, 8),
(249270, NULL, 'PTHR36885', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(249271, NULL, 'PTHR20836', NULL, NULL, NULL, NULL, 'DIHYDRODIPICOLINATE REDUCTASE', NULL, NULL, 8465, 8),
(249272, NULL, 'PTHR11125', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF TY 5', NULL, NULL, 28113, 8);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(249273, NULL, 'PTHR11767', NULL, NULL, NULL, NULL, 'INWARD RECTIFIER POTASSIUM CHANNEL', NULL, NULL, 15421, 8),
(249274, NULL, 'PTHR31001', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED TRANSCRIPTIONAL REGULATORY PROTEIN', NULL, NULL, NULL, 8),
(249275, NULL, 'PTHR36941', NULL, NULL, NULL, NULL, 'PROTEIN CBG01621-RELATED', NULL, NULL, NULL, 8),
(249276, NULL, 'PTHR46079', NULL, NULL, NULL, NULL, 'FERM DOMAIN-CONTAINING PROTEIN 4', NULL, NULL, NULL, 8),
(249277, NULL, 'PTHR35282', NULL, NULL, NULL, NULL, 'F5D14.24 PROTEIN', NULL, NULL, NULL, 8),
(249278, NULL, 'PTHR46275', NULL, NULL, NULL, NULL, 'HEPATOCYTE GROWTH FACTOR-REGULATED TYROSINE KINASE SUBSTRATE', NULL, NULL, 19524, 8),
(249279, NULL, 'PTHR39188', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED ZINC METALLOPROTEASE M50B', NULL, NULL, NULL, 8),
(249280, NULL, 'PTHR47095', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 222', NULL, NULL, 35175, 8),
(249281, NULL, 'PTHR13108', NULL, NULL, NULL, NULL, 'CONDENSIN COMPLEX SUBUNIT 2', NULL, NULL, 15305, 8),
(249282, NULL, 'PTHR10749', NULL, NULL, NULL, NULL, 'PHOSPHORYLASE B KINASE REGULATORY SUBUNIT', NULL, NULL, 12277, 8),
(249283, NULL, 'PTHR42938', NULL, NULL, NULL, NULL, 'FORMATE DEHYDROGENASE 1', NULL, NULL, NULL, 8),
(249284, NULL, 'PTHR46919', NULL, NULL, NULL, NULL, 'ZINC FINGER, C3HC4 TYPE (RING FINGER) FAMILY PROTEIN', NULL, NULL, NULL, 8),
(249285, NULL, 'PTHR15651', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING PROTEIN 8', NULL, NULL, 28914, 8),
(249286, NULL, 'PTHR38396', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(249287, NULL, 'PTHR37696', NULL, NULL, NULL, NULL, 'ADENYLOSUCCINATE SYNTHETASE-RELATED', NULL, NULL, NULL, 8),
(249288, NULL, 'PTHR32078', NULL, NULL, NULL, NULL, 'NUCLEAR PROTEIN MDM1', NULL, NULL, 23621, 8),
(249289, NULL, 'PTHR47895', NULL, NULL, NULL, NULL, 'CYSTEINE AND HISTIDINE-RICH DOMAIN-CONTAINING PROTEIN RAR1', NULL, NULL, 34213, 8),
(249290, NULL, 'PTHR37919', NULL, NULL, NULL, NULL, 'PROTEIN CBG05606', NULL, NULL, NULL, 8),
(249291, NULL, 'PTHR32285', NULL, NULL, NULL, NULL, 'PROTEIN TRICHOME BIREFRINGENCE-LIKE 9-RELATED', NULL, NULL, 25130, 8),
(249292, NULL, 'PTHR12649', NULL, NULL, NULL, NULL, 'PEPTIDYL-TRNA HYDROLASE 2', NULL, NULL, 5407, 8),
(249293, NULL, 'PTHR45765', NULL, NULL, NULL, NULL, 'METHIONINE--TRNA LIGASE', NULL, NULL, 16160, 8),
(249294, NULL, 'PTHR30109', NULL, NULL, NULL, NULL, 'HYDROXYLAMINE REDUCTASE', NULL, NULL, 2843, 8),
(249295, NULL, 'PTHR48206', NULL, NULL, NULL, NULL, 'CHLOROPLAST SENSOR KINASE, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(249296, NULL, 'PTHR48267', NULL, NULL, NULL, NULL, 'CUPREDOXIN SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(249297, NULL, 'PTHR22726', NULL, NULL, NULL, NULL, 'METALLOENDOPEPTIDASE OMA1', NULL, NULL, NULL, 8),
(249298, NULL, 'PTHR21092', NULL, NULL, NULL, NULL, 'NICASTRIN', NULL, NULL, 13277, 8),
(249299, NULL, 'PTHR43551', NULL, NULL, NULL, NULL, 'FUMARATE REDUCTASE IRON-SULFUR SUBUNIT', NULL, NULL, NULL, 8),
(249300, NULL, 'PTHR11444', NULL, NULL, NULL, NULL, 'ASPARTATEAMMONIA/ARGININOSUCCINATE/ADENYLOSUCCINATE LYASE', NULL, NULL, 3732, 8),
(249301, NULL, 'PTHR36306', NULL, NULL, NULL, NULL, 'ALPHA-AMYLASE-RELATED-RELATED', NULL, NULL, NULL, 8),
(249302, NULL, 'PTHR34811', NULL, NULL, NULL, NULL, 'MATURASE K', NULL, NULL, 5508, 8),
(249303, NULL, 'PTHR11730', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER', NULL, NULL, NULL, 8),
(249304, NULL, 'PTHR11096', NULL, NULL, NULL, NULL, 'RNA 3'' TERMINAL PHOSPHATE CYCLASE', NULL, NULL, 1177, 8),
(249305, NULL, 'PTHR12704', NULL, NULL, NULL, NULL, 'TRANS-GOLGI PROTEIN GMX33', NULL, NULL, 14477, 8),
(249306, NULL, 'PTHR34257', NULL, NULL, NULL, NULL, 'ADAPTER PROTEIN CIKS', NULL, NULL, NULL, 8),
(249307, NULL, 'PTHR10649', NULL, NULL, NULL, NULL, 'ARYL HYDROCARBON RECEPTOR', NULL, NULL, NULL, 8),
(249308, NULL, 'PTHR48132', NULL, NULL, NULL, NULL, 'ZGC:171772', NULL, NULL, NULL, 8),
(249309, NULL, 'PTHR43850', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER ATP-BINDING PROTEIN MA_4021-RELATED', NULL, NULL, NULL, 8),
(249310, NULL, 'PTHR23334', NULL, NULL, NULL, NULL, 'CCAAT/ENHANCER BINDING PROTEIN', NULL, NULL, NULL, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(249311, NULL, 'PTHR37483', NULL, NULL, NULL, NULL, 'UPF0125 PROTEIN RATB', NULL, NULL, 6402, 8),
(249312, NULL, 'PTHR21028', NULL, NULL, NULL, NULL, 'SI:CH211-156B7.4', NULL, NULL, 7134, 8),
(249313, NULL, 'PTHR37195', NULL, NULL, NULL, NULL, 'OS01G0332900 PROTEIN', NULL, NULL, NULL, 8),
(249314, NULL, 'PTHR10504', NULL, NULL, NULL, NULL, 'BACTERICIDAL PERMEABILITY-INCREASING  BPI  PROTEIN-RELATED', NULL, NULL, 25328, 8),
(249315, NULL, 'PTHR38101', NULL, NULL, NULL, NULL, 'UPF0307 PROTEIN YJGA', NULL, NULL, 3689, 8),
(249316, NULL, 'PTHR23171', NULL, NULL, NULL, NULL, 'GDOWN1', NULL, NULL, NULL, 8),
(249317, NULL, 'PTHR23005', NULL, NULL, NULL, NULL, 'RETINITIS PIGMENTOSA 1 PROTEIN', NULL, NULL, 30517, 8),
(249318, NULL, 'PTHR11636', NULL, NULL, NULL, NULL, 'POU DOMAIN', NULL, NULL, NULL, 8),
(249319, NULL, 'PTHR39434', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(249320, NULL, 'PTHR10283', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 13 MEMBER', NULL, NULL, NULL, 8),
(249321, NULL, 'PTHR11358', NULL, NULL, NULL, NULL, 'ARGINASE/AGMATINASE', NULL, NULL, 2546, 8),
(249322, NULL, 'PTHR35093', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN NMB0088-RELATED', NULL, NULL, 1199, 8),
(249323, NULL, 'PTHR22414', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 21522, 8),
(249324, NULL, 'PTHR12871', NULL, NULL, NULL, NULL, 'BETA-1,2-N-ACETYLGLUCOSAMINYLTRANSFERASE II', NULL, NULL, 1145, 8),
(249325, NULL, 'PTHR43353', NULL, NULL, NULL, NULL, 'SUCCINATE-SEMIALDEHYDE DEHYDROGENASE, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(249326, NULL, 'PTHR10671', NULL, NULL, NULL, NULL, 'EPITHELIAL MEMBRANE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(249327, NULL, 'PTHR24006', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', NULL, NULL, NULL, 8),
(249328, NULL, 'PTHR42795', NULL, NULL, NULL, NULL, 'ALANINE DEHYDROGENASE', NULL, NULL, NULL, 8),
(249329, NULL, 'PTHR46085', NULL, NULL, NULL, NULL, 'ARFGAP/RECO-RELATED', NULL, NULL, 34010, 8),
(249330, NULL, 'PTHR23281', NULL, NULL, NULL, NULL, 'MERLIN/MOESIN/EZRIN/RADIXIN', NULL, NULL, 10715, 8),
(249331, NULL, 'PTHR39196', NULL, NULL, NULL, NULL, 'PRIMOSOME, DNAD SUBUNIT', NULL, NULL, NULL, 8),
(249332, NULL, 'PTHR11964', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE SYNTHETASE', NULL, NULL, 5293, 8),
(249333, NULL, 'PTHR31332', NULL, NULL, NULL, NULL, '7-HYDROXYMETHYL CHLOROPHYLL A REDUCTASE, CHLOROPLASTIC', NULL, NULL, 36243, 8),
(249334, NULL, 'PTHR36838', NULL, NULL, NULL, NULL, 'AUXIN EFFLUX CARRIER FAMILY PROTEIN', NULL, NULL, NULL, 8),
(249335, NULL, 'PTHR43370', NULL, NULL, NULL, NULL, 'SUGAR ABC TRANSPORTER INTEGRAL MEMBRANE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(249336, NULL, 'PTHR46509', NULL, NULL, NULL, NULL, 'PHOSPHOADENOSINE PHOSPHOSULFATE REDUCTASE', NULL, NULL, NULL, 8),
(249337, NULL, 'PTHR36835', NULL, NULL, NULL, NULL, 'CYTOCHROME BO(3) UBIQUINOL OXIDASE SUBUNIT 4', NULL, NULL, NULL, 8),
(249338, NULL, 'PTHR12825', NULL, NULL, NULL, NULL, 'BNIP1-RELATED', NULL, NULL, 2698, 8),
(249339, NULL, 'PTHR31043', NULL, NULL, NULL, NULL, 'NEPHROCYSTIN-4', NULL, NULL, 23626, 8),
(249340, NULL, 'PTHR46396', NULL, NULL, NULL, NULL, 'PROTEIN O-LINKED-MANNOSE BETA-1,2-N-ACETYLGLUCOSAMINYLTRANSFERASE 1', NULL, NULL, NULL, 8),
(249341, NULL, 'PTHR36345', NULL, NULL, NULL, NULL, 'CCG-BINDING PROTEIN 1', NULL, NULL, 33779, 8),
(249342, NULL, 'PTHR44419', NULL, NULL, NULL, NULL, 'PROTOCHLOROPHYLLIDE REDUCTASE C, CHLOROPLASTIC', NULL, NULL, 1041, 8),
(249343, NULL, 'PTHR16469', NULL, NULL, NULL, NULL, 'UBIQUITIN-ASSOCIATED AND SH3 DOMAIN-CONTAINING BA-RELATED', NULL, NULL, NULL, 8),
(249344, NULL, 'PTHR10621', NULL, NULL, NULL, NULL, 'UV EXCISION REPAIR PROTEIN RAD23', NULL, NULL, NULL, 8),
(249345, NULL, 'PTHR28298', NULL, NULL, NULL, NULL, 'EISOSOME PROTEIN 1', NULL, NULL, 24572, 8),
(249346, NULL, 'PTHR12828', NULL, NULL, NULL, NULL, 'PROTEASOME MATURATION PROTEIN  UMP1', NULL, NULL, 5035, 8),
(249347, NULL, 'PTHR47482', NULL, NULL, NULL, NULL, 'OS11G0632001 PROTEIN', NULL, NULL, NULL, 8),
(249348, NULL, 'PTHR44845', NULL, NULL, NULL, NULL, 'CARRIER DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(249349, NULL, 'PTHR46091', NULL, NULL, NULL, NULL, 'BLR7054 PROTEIN', NULL, NULL, NULL, 8),
(249350, NULL, 'PTHR47317', NULL, NULL, NULL, NULL, 'PROTEIN LHCP TRANSLOCATION DEFECT', NULL, NULL, 37579, 8),
(249351, NULL, 'PTHR31890', NULL, NULL, NULL, NULL, 'PLANT INVERTASE/PECTIN METHYLESTERASE INHIBITOR SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(249352, NULL, 'PTHR34154', NULL, NULL, NULL, NULL, 'ALKALI-SENSITIVE LINKAGE PROTEIN 1', NULL, NULL, NULL, 8),
(249353, NULL, 'PTHR47049', NULL, NULL, NULL, NULL, 'PIEZO-TYPE MECHANOSENSITIVE ION CHANNEL HOMOLOG', NULL, NULL, NULL, 8),
(249354, NULL, 'PTHR40695', NULL, NULL, NULL, NULL, '4-PHOSPHOPANTOATE--BETA-ALANINE LIGASE', NULL, NULL, 5793, 8),
(249355, NULL, 'PTHR46317', NULL, NULL, NULL, NULL, 'HYDROLASE OF PHP SUPERFAMILY-RELATED PROTEIN', NULL, NULL, NULL, 8),
(249356, NULL, 'PTHR28596', NULL, NULL, NULL, NULL, 'BBSOME-INTERACTING PROTEIN 1', NULL, NULL, 22508, 8),
(249357, NULL, 'PTHR35077', NULL, NULL, NULL, NULL, 'SIMILAR TO AI661453 PROTEIN', NULL, NULL, NULL, 8),
(249358, NULL, 'PTHR35257', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 82', NULL, NULL, 23509, 8),
(249359, NULL, 'PTHR43300', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE', NULL, NULL, NULL, 8),
(249360, NULL, 'PTHR20875', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING DOMAIN-CONTAINING PROTEIN 6-RELATED', NULL, NULL, NULL, 8),
(249361, NULL, 'PTHR31669', NULL, NULL, NULL, NULL, 'PROTEIN FAR1-RELATED SEQUENCE 10-RELATED', NULL, NULL, 26161, 8),
(249362, NULL, 'PTHR37389', NULL, NULL, NULL, NULL, 'NODULIN-24', NULL, NULL, 10697, 8),
(249363, NULL, 'PTHR46192', NULL, NULL, NULL, NULL, 'BROAD-RANGE ACID PHOSPHATASE DET1', NULL, NULL, NULL, 8),
(249364, NULL, 'PTHR45161', NULL, NULL, NULL, NULL, 'CYTOSKELETON-ASSOCIATED PROTEIN 4', NULL, NULL, NULL, 8),
(249365, NULL, 'PTHR10809', NULL, NULL, NULL, NULL, 'VESICLE-ASSOCIATED MEMBRANE PROTEIN-ASSOCIATED PROTEIN', NULL, NULL, 21334, 8),
(249366, NULL, 'PTHR48130', NULL, NULL, NULL, NULL, 'OS12G0467600 PROTEIN', NULL, NULL, NULL, 8),
(249367, NULL, 'PTHR10811', NULL, NULL, NULL, NULL, 'FRINGE-RELATED', NULL, NULL, NULL, 8),
(249368, NULL, 'PTHR11426', NULL, NULL, NULL, NULL, 'HISTONE H3', NULL, NULL, 1526, 8),
(249369, NULL, 'PTHR43303', NULL, NULL, NULL, NULL, 'NADPH DEHYDROGENASE C23G7.10C-RELATED', NULL, NULL, 33714, 8),
(249370, NULL, 'PTHR34944', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM7', NULL, NULL, NULL, 8),
(249371, NULL, 'PTHR34496', NULL, NULL, NULL, NULL, 'GLCNAC TRANSFERASE-RELATED', NULL, NULL, 15074, 8),
(249372, NULL, 'PTHR43574', NULL, NULL, NULL, NULL, 'EPIMERASE-RELATED', NULL, NULL, NULL, 8),
(249373, NULL, 'PTHR31269', NULL, NULL, NULL, NULL, 'S-TYPE ANION CHANNEL SLAH3', NULL, NULL, 23733, 8),
(249374, NULL, 'PTHR47673', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(249375, NULL, 'PTHR47822', NULL, NULL, NULL, NULL, 'CARBOHYDRATE BINDING DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(249376, NULL, 'PTHR14217', NULL, NULL, NULL, NULL, 'INOSITOL-TETRAKISPHOSPHATE 1-KINASE', NULL, NULL, 12792, 8),
(249377, NULL, 'PTHR34998', NULL, NULL, NULL, NULL, 'OS04G0357400 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(249378, NULL, 'PTHR17530', NULL, NULL, NULL, NULL, 'PRO-THYROTROPIN-RELEASING HORMONE', NULL, NULL, NULL, 8),
(249379, NULL, 'PTHR18957', NULL, NULL, NULL, NULL, 'CENTLEIN', NULL, NULL, 32114, 8),
(249380, NULL, 'PTHR37787', NULL, NULL, NULL, NULL, 'BIOGENESIS OF LYSOSOME-RELATED ORGANELLES COMPLEX 1 SUBUNIT KXD1', NULL, NULL, NULL, 8),
(249381, NULL, 'PTHR34005', NULL, NULL, NULL, NULL, 'PROTEIN CBG15054-RELATED', NULL, NULL, NULL, 8),
(249382, NULL, 'PTHR12925', NULL, NULL, NULL, NULL, 'HIKESHI FAMILY MEMBER', NULL, NULL, 12708, 8),
(249383, NULL, 'PTHR30622', NULL, NULL, NULL, NULL, 'UNDECAPRENYL-DIPHOSPHATASE', NULL, NULL, 3431, 8),
(249384, NULL, 'PTHR45364', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE 9-RELATED', NULL, NULL, 17165, 8),
(249385, NULL, 'PTHR15644', NULL, NULL, NULL, NULL, 'OSTEOPETROSIS ASSOCIATED TRANSMEMBRANE PROTEIN 1', NULL, NULL, 18423, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(249386, NULL, 'PTHR28573', NULL, NULL, NULL, NULL, 'SPINDLE AND KINETOCHORE-ASSOCIATED PROTEIN 1', NULL, NULL, 13050, 8),
(249387, NULL, 'PTHR16056', NULL, NULL, NULL, NULL, 'REGULATOR OF MICROTUBULE DYNAMICS PROTEIN', NULL, NULL, NULL, 8),
(249388, NULL, 'PTHR43747', NULL, NULL, NULL, NULL, 'FAD-BINDING PROTEIN', NULL, NULL, NULL, 8),
(249389, NULL, 'PTHR37298', NULL, NULL, NULL, NULL, 'UPF0111 PROTEIN YKAA', NULL, NULL, NULL, 8),
(249390, NULL, 'PTHR11700', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S10 FAMILY MEMBER', NULL, NULL, 4264, 8),
(249391, NULL, 'PTHR36696', NULL, NULL, NULL, NULL, 'AGAP012002-PA', NULL, NULL, NULL, 8),
(249392, NULL, 'PTHR42339', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(249393, NULL, 'PTHR35321', NULL, NULL, NULL, NULL, 'OS02G0753200 PROTEIN', NULL, NULL, 27569, 8),
(249394, NULL, 'PTHR28144', NULL, NULL, NULL, NULL, 'ER MEMBRANE PROTEIN COMPLEX SUBUNIT 5', NULL, NULL, NULL, 8),
(249395, NULL, 'PTHR22999', NULL, NULL, NULL, NULL, 'PX SERINE/THREONINE KINASE  PXK', NULL, NULL, NULL, 8),
(249396, NULL, 'PTHR46452', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 3', NULL, NULL, NULL, 8),
(249397, NULL, 'PTHR47196', NULL, NULL, NULL, NULL, 'KELCH DOMAIN-CONTAINING PROTEIN 9', NULL, NULL, 35665, 8),
(249398, NULL, 'PTHR23326', NULL, NULL, NULL, NULL, 'CCR4 NOT-RELATED', NULL, NULL, 27441, 8),
(249399, NULL, 'PTHR47912', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE 4, CHLOROPLASTIC', NULL, NULL, 36736, 8),
(249400, NULL, 'PTHR43742', NULL, NULL, NULL, NULL, 'TRIMETHYLAMINE-N-OXIDE REDUCTASE', NULL, NULL, NULL, 8),
(249401, NULL, 'PTHR32208', NULL, NULL, NULL, NULL, 'SECRETED PROTEIN-RELATED', NULL, NULL, NULL, 8),
(249402, NULL, 'PTHR31680', NULL, NULL, NULL, NULL, 'LONGIFOLIA PROTEIN', NULL, NULL, 29596, 8),
(249403, NULL, 'PTHR13874', NULL, NULL, NULL, NULL, 'ENDOTHELIN', NULL, NULL, 19232, 8),
(249404, NULL, 'PTHR19924', NULL, NULL, NULL, NULL, 'UTP15 U3 SMALL NUCLEOLAR RNA-ASSOCIATED PROTEIN 15 FAMILY MEMBER', NULL, NULL, NULL, 8),
(249405, NULL, 'PTHR31649', NULL, NULL, NULL, NULL, 'AGAP009604-PA', NULL, NULL, NULL, 8),
(249406, NULL, 'PTHR13104', NULL, NULL, NULL, NULL, 'MED-6-RELATED', NULL, NULL, 6816, 8),
(249407, NULL, 'PTHR46231', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND BTB/POZ DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, 35359, 8),
(249408, NULL, 'PTHR33526', NULL, NULL, NULL, NULL, 'OS07G0123800 PROTEIN', NULL, NULL, NULL, 8),
(249409, NULL, 'PTHR11258', NULL, NULL, NULL, NULL, '2-5 OLIGOADENYLATE SYNTHETASE', NULL, NULL, NULL, 8),
(249410, NULL, 'PTHR32019', NULL, NULL, NULL, NULL, 'R3H DOMAIN-CONTAINING PROTEIN 4', NULL, NULL, 27241, 8),
(249411, NULL, 'PTHR21426', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT 8', NULL, NULL, 28131, 8),
(249412, NULL, 'PTHR37984', NULL, NULL, NULL, NULL, 'PROTEIN CBG26694', NULL, NULL, NULL, 8),
(249413, NULL, 'PTHR47333', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR C AND EGF DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(249414, NULL, 'PTHR32017', NULL, NULL, NULL, NULL, 'SPINDLE AND KINETOCHORE-ASSOCIATED PROTEIN 2', NULL, NULL, 24116, 8),
(249415, NULL, 'PTHR45772', NULL, NULL, NULL, NULL, 'CONSERVED COMPONENT OF ABC TRANSPORTER FOR NATURAL AMINO ACIDS-RELATED', NULL, NULL, NULL, 8),
(249416, NULL, 'PTHR45868', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 33-RELATED', NULL, NULL, NULL, 8),
(249417, NULL, 'PTHR14352', NULL, NULL, NULL, NULL, 'HAUS AUGMIN-LIKE COMPLEX SUBUNIT 7', NULL, NULL, 24729, 8),
(249418, NULL, 'PTHR37976', NULL, NULL, NULL, NULL, 'PROTEIN CBG16927', NULL, NULL, NULL, 8),
(249419, NULL, 'PTHR31104', NULL, NULL, NULL, NULL, 'PEPTIDE-N4-(N-ACETYL-BETA-GLUCOSAMINYL)ASPARAGINE AMIDASE A PROTEIN', NULL, NULL, 15153, 8),
(249420, NULL, 'PTHR37539', NULL, NULL, NULL, NULL, 'SECRETED PROTEIN-RELATED', NULL, NULL, 29065, 8),
(249421, NULL, 'PTHR37686', NULL, NULL, NULL, NULL, 'LD36006P', NULL, NULL, NULL, 8),
(249422, NULL, 'PTHR43649', NULL, NULL, NULL, NULL, 'ARABINOSE-BINDING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(249423, NULL, 'PTHR15462', NULL, NULL, NULL, NULL, 'SERINE PROTEASE', NULL, NULL, NULL, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(249424, NULL, 'PTHR34374', NULL, NULL, NULL, NULL, 'LARGE RIBOSOMAL RNA SUBUNIT ACCUMULATION PROTEIN YCED HOMOLOG 1, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(249425, NULL, 'PTHR46622', NULL, NULL, NULL, NULL, 'DNA-DEPENDENT METALLOPROTEASE WSS1', NULL, NULL, NULL, 8),
(249426, NULL, 'PTHR37235', NULL, NULL, NULL, NULL, 'ZINC METALLOPROTEINASE AUREOLYSIN', NULL, NULL, NULL, 8),
(249427, NULL, 'PTHR11750', NULL, NULL, NULL, NULL, 'PROTEIN N-TERMINAL AMIDASE', NULL, NULL, 31347, 8),
(249428, NULL, 'PTHR21453', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(249429, NULL, 'PTHR45952', NULL, NULL, NULL, NULL, 'ALUMINUM INDUCED PROTEIN WITH YGL AND LRDR MOTIFS', NULL, NULL, 36142, 8),
(249430, NULL, 'PTHR34120', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(249431, NULL, 'PTHR34858', NULL, NULL, NULL, NULL, 'CYSO-CYSTEINE PEPTIDASE', NULL, NULL, NULL, 8),
(249432, NULL, 'PTHR35673', NULL, NULL, NULL, NULL, 'UPF0500 PROTEIN C1ORF216', NULL, NULL, 21879, 8),
(249433, NULL, 'PTHR46134', NULL, NULL, NULL, NULL, 'DRONGO, ISOFORM F', NULL, NULL, NULL, 8),
(249434, NULL, 'PTHR31419', NULL, NULL, NULL, NULL, 'PROTEIN PIN-LIKES 2', NULL, NULL, 27410, 8),
(249435, NULL, 'PTHR46921', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 21', NULL, NULL, 15932, 8),
(249436, NULL, 'PTHR15377', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION REGULATOR 1', NULL, NULL, 35945, 8),
(249437, NULL, 'PTHR43485', NULL, NULL, NULL, NULL, 'HYDROGENASE-4 COMPONENT G', NULL, NULL, NULL, 8),
(249438, NULL, 'PTHR31069', NULL, NULL, NULL, NULL, 'OLEATE-ACTIVATED TRANSCRIPTION FACTOR 1-RELATED', NULL, NULL, NULL, 8),
(249439, NULL, 'PTHR33026', NULL, NULL, NULL, NULL, 'OS06G0360600 PROTEIN', NULL, NULL, NULL, 8),
(249440, NULL, 'PTHR14043', NULL, NULL, NULL, NULL, 'CCAAT DISPLACEMENT PROTEIN-RELATED', NULL, NULL, NULL, 8),
(249441, NULL, 'PTHR43077', NULL, NULL, NULL, NULL, 'TRANSPORT PERMEASE YVFS-RELATED', NULL, NULL, NULL, 8),
(249442, NULL, 'PTHR45994', NULL, NULL, NULL, NULL, 'FI21225P1', NULL, NULL, NULL, 8),
(249443, NULL, 'PTHR47706', NULL, NULL, NULL, NULL, 'NMRA-LIKE FAMILY PROTEIN', NULL, NULL, NULL, 8),
(249444, NULL, 'PTHR11711', NULL, NULL, NULL, NULL, 'ADP RIBOSYLATION FACTOR-RELATED', NULL, NULL, 8655, 8),
(249445, NULL, 'PTHR43809', NULL, NULL, NULL, NULL, 'NITRITE REDUCTASE (NADH) LARGE SUBUNIT', NULL, NULL, NULL, 8),
(249446, NULL, 'PTHR21180', NULL, NULL, NULL, NULL, 'ENDONUCLEASE/EXONUCLEASE/PHOSPHATASE FAMILY DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(249447, NULL, 'PTHR45907', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS J', NULL, NULL, 16809, 8),
(249448, NULL, 'PTHR13768', NULL, NULL, NULL, NULL, 'SOLUBLE NSF ATTACHMENT PROTEIN  SNAP', NULL, NULL, 6737, 8),
(249449, NULL, 'PTHR14069', NULL, NULL, NULL, NULL, 'FILENSIN', NULL, NULL, 36591, 8),
(249450, NULL, 'PTHR42760', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASES/REDUCTASES FAMILY MEMBER', NULL, NULL, NULL, 8),
(249451, NULL, 'PTHR16650', NULL, NULL, NULL, NULL, 'C21ORF13-RELATED', NULL, NULL, 25382, 8),
(249452, NULL, 'PTHR18867', NULL, NULL, NULL, NULL, 'RAD50', NULL, NULL, NULL, 8),
(249453, NULL, 'PTHR12480', NULL, NULL, NULL, NULL, 'ARGININE DEMETHYLASE AND LYSYL-HYDROXYLASE JMJD', NULL, NULL, NULL, 8),
(249454, NULL, 'PTHR10694', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE', NULL, NULL, NULL, 8),
(249455, NULL, 'PTHR22976', NULL, NULL, NULL, NULL, 'BIOTIN SYNTHASE', NULL, NULL, 2832, 8),
(249456, NULL, 'PTHR24157', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT, SAM AND BASIC LEUCINE ZIPPER DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(249457, NULL, 'PTHR28434', NULL, NULL, NULL, NULL, 'PROTEIN C3ORF33', NULL, NULL, 34209, 8),
(249458, NULL, 'PTHR47616', NULL, NULL, NULL, NULL, 'CHOLESTERYL ESTER TRANSFER PROTEIN', NULL, NULL, 20795, 8),
(249459, NULL, 'PTHR12151', NULL, NULL, NULL, NULL, 'ELECTRON TRANSPORT PROTIN SCO1/SENC FAMILY MEMBER', NULL, NULL, 3197, 8),
(249460, NULL, 'PTHR40617', NULL, NULL, NULL, NULL, 'TERPENE CYCLASE ASQC', NULL, NULL, NULL, 8);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(249461, NULL, 'PTHR36892', NULL, NULL, NULL, NULL, 'OS01G0201800 PROTEIN', NULL, NULL, NULL, 8),
(249462, NULL, 'PTHR45644', NULL, NULL, NULL, NULL, 'AAA ATPASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G12920)-RELATED-RELATED', NULL, NULL, NULL, 8),
(249463, NULL, 'PTHR46555', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE PROTEIN 4A', NULL, NULL, NULL, 8),
(249464, NULL, 'PTHR31246', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN 70-2', NULL, NULL, 12857, 8),
(249465, NULL, 'PTHR47794', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 27', NULL, NULL, NULL, 8),
(249466, NULL, 'PTHR46560', NULL, NULL, NULL, NULL, 'CYPHER, ISOFORM B', NULL, NULL, NULL, 8),
(249467, NULL, 'PTHR22922', NULL, NULL, NULL, NULL, 'GPI-ANCHORED PROTEIN P137', NULL, NULL, 25689, 8),
(249468, NULL, 'PTHR34923', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 20', NULL, NULL, 23491, 8),
(249469, NULL, 'PTHR15822', NULL, NULL, NULL, NULL, 'TRAF AND TNF RECEPTOR-ASSOCIATED PROTEIN', NULL, NULL, NULL, 8),
(249470, NULL, 'PTHR47397', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 19L', NULL, NULL, 15826, 8),
(249471, NULL, 'PTHR46301', NULL, NULL, NULL, NULL, 'F-BOX/KELCH-REPEAT PROTEIN', NULL, NULL, NULL, 8),
(249472, NULL, 'PTHR31535', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(249473, NULL, 'PTHR13630', NULL, NULL, NULL, NULL, 'GAMMA-SECRETASE-ACTIVATING PROTEIN', NULL, NULL, 23214, 8),
(249474, NULL, 'PTHR47990', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE (2OG) AND FE(II)-DEPENDENT OXYGENASE SUPERFAMILY PROTEIN-RELATED', NULL, NULL, NULL, 8),
(249475, NULL, 'PTHR45685', NULL, NULL, NULL, NULL, 'HELICASE SRCAP-RELATED', NULL, NULL, NULL, 8),
(249476, NULL, 'PTHR34009', NULL, NULL, NULL, NULL, 'PROTEIN STAR', NULL, NULL, NULL, 8),
(249477, NULL, 'PTHR36506', NULL, NULL, NULL, NULL, 'PREFLAGELLIN PEPTIDASE', NULL, NULL, NULL, 8),
(249478, NULL, 'PTHR21496', NULL, NULL, NULL, NULL, 'FERREDOXIN-RELATED', NULL, NULL, NULL, 8),
(249479, NULL, 'PTHR33783', NULL, NULL, NULL, NULL, 'PROTEIN HAIKU1', NULL, NULL, 27207, 8),
(249480, NULL, 'PTHR13008', NULL, NULL, NULL, NULL, 'MAP-KINASE ACTIVATING DEATH DOMAIN PROTEIN  MADD /DENN/AEX-3 C.ELEGANS', NULL, NULL, 28886, 8),
(249481, NULL, 'PTHR39697', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(249482, NULL, 'PTHR46655', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE ATXR3', NULL, NULL, NULL, 8),
(249483, NULL, 'PTHR31562', NULL, NULL, NULL, NULL, 'PROTEIN CBG18972', NULL, NULL, NULL, 8),
(249484, NULL, 'PTHR22809', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE-RELATED', NULL, NULL, 22478, 8),
(249485, NULL, 'PTHR36364', NULL, NULL, NULL, NULL, 'OS03G0203000 PROTEIN', NULL, NULL, NULL, 8),
(249486, NULL, 'PTHR33803', NULL, NULL, NULL, NULL, 'IS1478 TRANSPOSASE', NULL, NULL, NULL, 8),
(249487, NULL, 'PTHR39214', NULL, NULL, NULL, NULL, 'MICROBODY (PEROXISOME) BIOGENESIS PROTEIN PEROXIN 8 (EUROFUNG)', NULL, NULL, NULL, 8),
(249488, NULL, 'PTHR19212', NULL, NULL, NULL, NULL, 'LEUCINE RICH REPEAT  IN FLII  INTERACTING PROTEIN', NULL, NULL, 17769, 8),
(249489, NULL, 'PTHR33547', NULL, NULL, NULL, NULL, 'ZGC:174862', NULL, NULL, NULL, 8),
(249490, NULL, 'PTHR34787', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I REACTION CENTER SUBUNIT VI-2, CHLOROPLASTIC', NULL, NULL, 1861, 8),
(249491, NULL, 'PTHR22536', NULL, NULL, NULL, NULL, 'LUNG CANCER METASTASIS-RELATED  LCMR1  PROTEIN', NULL, NULL, 16903, 8),
(249492, NULL, 'PTHR34473', NULL, NULL, NULL, NULL, 'UPF0699 TRANSMEMBRANE PROTEIN YDBS', NULL, NULL, NULL, 8),
(249493, NULL, 'PTHR43181', NULL, NULL, NULL, NULL, '2-C-METHYL-D-ERYTHRITOL 2,4-CYCLODIPHOSPHATE SYNTHASE, CHLOROPLASTIC', NULL, NULL, 6440, 8),
(249494, NULL, 'PTHR45811', NULL, NULL, NULL, NULL, 'COPPER TRANSPORT PROTEIN FAMILY-RELATED', NULL, NULL, NULL, 8),
(249495, NULL, 'PTHR36434', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEASE YUGP-RELATED', NULL, NULL, 3961, 8),
(249496, NULL, 'PTHR35498', NULL, NULL, NULL, NULL, 'PROTEIN LOW PSII ACCUMULATION 1, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(249497, NULL, 'PTHR42775', NULL, NULL, NULL, NULL, 'PERMEASE RV2963-RELATED', NULL, NULL, NULL, 8);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(249498, NULL, 'PTHR48044', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', NULL, NULL, NULL, 8),
(249499, NULL, 'PTHR11360', NULL, NULL, NULL, NULL, 'MONOCARBOXYLATE TRANSPORTER', NULL, NULL, NULL, 8),
(249500, NULL, 'PTHR45780', NULL, NULL, NULL, NULL, 'ETHANOLAMINE-PHOSPHATE CYTIDYLYLTRANSFERASE', NULL, NULL, 36155, 8),
(249501, NULL, 'PTHR11746', NULL, NULL, NULL, NULL, 'O-METHYLTRANSFERASE', NULL, NULL, 15440, 8),
(249502, NULL, 'PTHR21087', NULL, NULL, NULL, NULL, 'SHIKIMATE KINASE', NULL, NULL, NULL, 8),
(249503, NULL, 'PTHR43851', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(249504, NULL, 'PTHR41774', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(249505, NULL, 'PTHR39159', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(249506, NULL, 'PTHR14261', NULL, NULL, NULL, NULL, 'ONCOSTATIN M', NULL, NULL, 27467, 8),
(249507, NULL, 'PTHR38147', NULL, NULL, NULL, NULL, '5-FORMAMINOIMIDAZOLE-4-CARBOXAMIDE-1-(BETA)-D-RIBOFURANOSYL 5''-MONOPHOSPHATE SYNTHETASE-RELATED', NULL, NULL, 724, 8),
(249508, NULL, 'PTHR47628', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(249509, NULL, 'PTHR46128', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL GROUP I INTRON SPLICING FACTOR CCM1', NULL, NULL, NULL, 8),
(249510, NULL, 'PTHR28659', NULL, NULL, NULL, NULL, '', NULL, NULL, 35959, 8),
(249511, NULL, 'PTHR46776', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR 4-RELATED', NULL, NULL, 35002, 8),
(249512, NULL, 'PTHR32444', NULL, NULL, NULL, NULL, 'BULB-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(249513, NULL, 'PTHR16465', NULL, NULL, NULL, NULL, 'NUCLEASE-RELATED', NULL, NULL, NULL, 8),
(249514, NULL, 'PTHR11493', NULL, NULL, NULL, NULL, 'SULFITE REDUCTASE [NADPH] SUBUNIT BETA-RELATED', NULL, NULL, 36754, 8),
(249515, NULL, 'PTHR13481', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 15738, 8),
(249516, NULL, 'PTHR47648', NULL, NULL, NULL, NULL, 'KILLER CELL LECTIN-LIKE RECEPTOR SUBFAMILY G MEMBER 1', NULL, NULL, 34773, 8),
(249517, NULL, 'PTHR12048', NULL, NULL, NULL, NULL, 'CCAAT-BINDING FACTOR-RELATED', NULL, NULL, 27092, 8),
(249518, NULL, 'PTHR28264', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 7A', NULL, NULL, NULL, 8),
(249519, NULL, 'PTHR40037', NULL, NULL, NULL, NULL, 'PHOSPHOESTERASE YJCG-RELATED', NULL, NULL, NULL, 8),
(249520, NULL, 'PTHR47365', NULL, NULL, NULL, NULL, 'PLANT PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(249521, NULL, 'PTHR43653', NULL, NULL, NULL, NULL, 'CYTOCHROME C ASSEMBLY PROTEIN-RELATED', NULL, NULL, 1, 8),
(249522, NULL, 'PTHR10465', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE GTPASE FZO1', NULL, NULL, 21701, 8),
(249523, NULL, 'PTHR28630', NULL, NULL, NULL, NULL, '', NULL, NULL, 22022, 8),
(249524, NULL, 'PTHR36386', NULL, NULL, NULL, NULL, 'OS06G0683900 PROTEIN', NULL, NULL, NULL, 8),
(249525, NULL, 'PTHR13326', NULL, NULL, NULL, NULL, 'TRNA PSEUDOURIDINE SYNTHASE D', NULL, NULL, 3207, 8),
(249526, NULL, 'PTHR22379', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4930407I10 GENE', NULL, NULL, 25919, 8),
(249527, NULL, 'PTHR30348', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN YECE', NULL, NULL, 4014, 8),
(249528, NULL, 'PTHR28666', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 240', NULL, NULL, 24956, 8),
(249529, NULL, 'PTHR34476', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT OMEGA', NULL, NULL, 2383, 8),
(249530, NULL, 'PTHR10291', NULL, NULL, NULL, NULL, 'DEHYDRODOLICHYL DIPHOSPHATE SYNTHASE FAMILY MEMBER', NULL, NULL, 3313, 8),
(249531, NULL, 'PTHR35688', NULL, NULL, NULL, NULL, 'NAD(P)-LINKED OXIDOREDUCTASE SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(249532, NULL, 'PTHR12972', NULL, NULL, NULL, NULL, 'DOWNSTREAM NEIGHBOR OF SON', NULL, NULL, 20791, 8),
(249533, NULL, 'PTHR30294', NULL, NULL, NULL, NULL, 'MEMBRANE COMPONENT OF ABC TRANSPORTER YHHJ-RELATED', NULL, NULL, NULL, 8),
(249534, NULL, 'PTHR46149', NULL, NULL, NULL, NULL, 'MIP08469P', NULL, NULL, NULL, 8),
(249535, NULL, 'PTHR30246', NULL, NULL, NULL, NULL, '2-KETO-3-DEOXY-6-PHOSPHOGLUCONATE ALDOLASE', NULL, NULL, 4580, 8),
(249536, NULL, 'PTHR30325', NULL, NULL, NULL, NULL, 'MEMBRANE COMPONENT OF ABC TRANSPORTER', NULL, NULL, NULL, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(249537, NULL, 'PTHR34531', NULL, NULL, NULL, NULL, 'ZGC:153352', NULL, NULL, NULL, 8),
(249538, NULL, 'PTHR36964', NULL, NULL, NULL, NULL, 'PROTEIN-METHIONINE-SULFOXIDE REDUCTASE HEME-BINDING SUBUNIT MSRQ', NULL, NULL, 836, 8),
(249539, NULL, 'PTHR47406', NULL, NULL, NULL, NULL, 'COAGULATION FACTOR 5/8 TYPE, C-TERMINAL', NULL, NULL, NULL, 8),
(249540, NULL, 'PTHR43469', NULL, NULL, NULL, NULL, 'DISULFIDE FORMATION PROTEIN-RELATED', NULL, NULL, 12821, 8),
(249541, NULL, 'PTHR31100', NULL, NULL, NULL, NULL, 'AT-HOOK MOTIF NUCLEAR-LOCALIZED PROTEIN 15', NULL, NULL, 9917, 8),
(249542, NULL, 'PTHR16777', NULL, NULL, NULL, NULL, 'PROTEIN ECT2', NULL, NULL, 22946, 8),
(249543, NULL, 'PTHR47260', NULL, NULL, NULL, NULL, 'UPF0644 PROTEIN PB2B4.06', NULL, NULL, NULL, 8),
(249544, NULL, 'PTHR11753', NULL, NULL, NULL, NULL, 'ADAPTOR COMPLEXES SMALL SUBUNIT FAMILY', NULL, NULL, 19129, 8),
(249545, NULL, 'PTHR47486', NULL, NULL, NULL, NULL, 'SIALYLTRANSFERASE-LIKE PROTEIN 1', NULL, NULL, 33695, 8),
(249546, NULL, 'PTHR40462', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(249547, NULL, 'PTHR43764', NULL, NULL, NULL, NULL, 'MOLYBDENUM COFACTOR BIOSYNTHESIS', NULL, NULL, NULL, 8),
(249548, NULL, 'PTHR23272', NULL, NULL, NULL, NULL, 'BED FINGER-RELATED', NULL, NULL, 37395, 8),
(249549, NULL, 'PTHR46785', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR A DOMAIN-CONTAINING PROTEIN 3B', NULL, NULL, NULL, 8),
(249550, NULL, 'PTHR47711', NULL, NULL, NULL, NULL, 'PROTEIN PLASTID TRANSCRIPTIONALLY ACTIVE 16, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(249551, NULL, 'PTHR38455', NULL, NULL, NULL, NULL, 'HYPOTHETICAL CYTOSOLIC PROTEIN', NULL, NULL, 13816, 8),
(249552, NULL, 'PTHR11219', NULL, NULL, NULL, NULL, 'TENEURIN AND N-ACETYLGLUCOSAMINE-1-PHOSPHODIESTER ALPHA-N-ACETYLGLUCOSAMINIDASE', NULL, NULL, NULL, 8),
(249553, NULL, 'PTHR23048', NULL, NULL, NULL, NULL, 'MYOSIN LIGHT CHAIN 1, 3', NULL, NULL, NULL, 8),
(249554, NULL, 'PTHR47076', NULL, NULL, NULL, NULL, 'NHL DOMAIN PROTEIN', NULL, NULL, NULL, 8),
(249555, NULL, 'PTHR34129', NULL, NULL, NULL, NULL, 'BLR1139 PROTEIN', NULL, NULL, 13563, 8),
(249556, NULL, 'PTHR31423', NULL, NULL, NULL, NULL, 'YBAK DOMAIN-CONTAINING PROTEIN', NULL, NULL, 31889, 8),
(249557, NULL, 'PTHR24016', NULL, NULL, NULL, NULL, 'CONSERVED OLIGOMERIC GOLGI COMPLEX SUBUNIT 4', NULL, NULL, NULL, 8),
(249558, NULL, 'PTHR43363', NULL, NULL, NULL, NULL, 'HYPOXANTHINE PHOSPHORIBOSYLTRANSFERASE', NULL, NULL, NULL, 8),
(249559, NULL, 'PTHR23160', NULL, NULL, NULL, NULL, 'SYNAPTONEMAL COMPLEX PROTEIN-RELATED', NULL, NULL, NULL, 8),
(249560, NULL, 'PTHR28163', NULL, NULL, NULL, NULL, 'PROTEIN PET117 HOMOLOG, MITOCHONDRIAL', NULL, NULL, 23948, 8),
(249561, NULL, 'PTHR34677', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(249562, NULL, 'PTHR37703', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L31-RELATED', NULL, NULL, NULL, 8),
(249563, NULL, 'PTHR33325', NULL, NULL, NULL, NULL, 'ZINC FINGER, CCHC-TYPE-RELATED', NULL, NULL, NULL, 8),
(249564, NULL, 'PTHR31690', NULL, NULL, NULL, NULL, 'FUCOSE MUTAROTASE', NULL, NULL, NULL, 8),
(249565, NULL, 'PTHR15152', NULL, NULL, NULL, NULL, 'CD70 ANTIGEN', NULL, NULL, 36598, 8),
(249566, NULL, 'PTHR46271', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN, PUTATIVE-RELATED', NULL, NULL, 35021, 8),
(249567, NULL, 'PTHR11487', NULL, NULL, NULL, NULL, 'THIOESTERASE', NULL, NULL, 13665, 8),
(249568, NULL, 'PTHR47788', NULL, NULL, NULL, NULL, 'POLYA POLYMERASE', NULL, NULL, NULL, 8),
(249569, NULL, 'PTHR30085', NULL, NULL, NULL, NULL, 'AMINO ACID ABC TRANSPORTER PERMEASE', NULL, NULL, NULL, 8),
(249570, NULL, 'PTHR45889', NULL, NULL, NULL, NULL, 'IG-LIKE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(249571, NULL, 'PTHR47980', NULL, NULL, NULL, NULL, 'LD44762P', NULL, NULL, NULL, 8),
(249572, NULL, 'PTHR11614', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE-RELATED', NULL, NULL, NULL, 8),
(249573, NULL, 'PTHR30106', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YEIH-RELATED', NULL, NULL, 20086, 8),
(249574, NULL, 'PTHR24155', NULL, NULL, NULL, NULL, 'OSTEOCLAST-STIMULATING FACTOR 1', NULL, NULL, NULL, 8);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(249575, NULL, 'PTHR36692', NULL, NULL, NULL, NULL, 'PROTEIN SNAKESKIN', NULL, NULL, 30648, 8),
(249576, NULL, 'PTHR19432', NULL, NULL, NULL, NULL, 'SUGAR TRANSPORTER', NULL, NULL, NULL, 8),
(249577, NULL, 'PTHR37701', NULL, NULL, NULL, NULL, 'METHYL-CPG-BINDING DOMAIN-CONTAINING PROTEIN 8', NULL, NULL, 29218, 8),
(249578, NULL, 'PTHR35444', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1700001C19 GENE', NULL, NULL, NULL, 8),
(249579, NULL, 'PTHR36931', NULL, NULL, NULL, NULL, 'UPF0153 PROTEIN YEIW', NULL, NULL, NULL, 8),
(249580, NULL, 'PTHR30588', NULL, NULL, NULL, NULL, 'BRANCHED-CHAIN AMINO ACID TRANSPORT SYSTEM 2 CARRIER PROTEIN', NULL, NULL, 3192, 8),
(249581, NULL, 'PTHR24384', NULL, NULL, NULL, NULL, 'FINGER PUTATIVE TRANSCRIPTION FACTOR FAMILY-RELATED', NULL, NULL, NULL, 8),
(249582, NULL, 'PTHR40056', NULL, NULL, NULL, NULL, 'HYPOTHETICAL CYTOSOLIC PROTEIN', NULL, NULL, 14471, 8),
(249583, NULL, 'PTHR44117', NULL, NULL, NULL, NULL, 'INTRAFLAGELLAR TRANSPORT PROTEIN 88 HOMOLOG', NULL, NULL, NULL, 8),
(249584, NULL, 'PTHR47189', NULL, NULL, NULL, NULL, 'MHC CLASS II TRANSACTIVATOR', NULL, NULL, NULL, 8),
(249585, NULL, 'PTHR30443', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN', NULL, NULL, 31449, 8),
(249586, NULL, 'PTHR14520', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOMAL PROTEIN 63', NULL, NULL, 18000, 8),
(249587, NULL, 'PTHR46442', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', NULL, NULL, 3613, 8),
(249588, NULL, 'PTHR30476', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 3556, 8),
(249589, NULL, 'PTHR46579', NULL, NULL, NULL, NULL, 'F5/8 TYPE C DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(249590, NULL, 'PTHR32060', NULL, NULL, NULL, NULL, 'TAIL-SPECIFIC PROTEASE', NULL, NULL, NULL, 8),
(249591, NULL, 'PTHR46255', NULL, NULL, NULL, NULL, 'SHORT STATURE HOMEOBOX', NULL, NULL, NULL, 8),
(249592, NULL, 'PTHR37343', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 32', NULL, NULL, 23700, 8),
(249593, NULL, 'PTHR39613', NULL, NULL, NULL, NULL, 'ANCHORED CELL WALL PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G08960)-RELATED', NULL, NULL, NULL, 8),
(249594, NULL, 'PTHR36369', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(249595, NULL, 'PTHR33186', NULL, NULL, NULL, NULL, 'OS10G0136150 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(249596, NULL, 'PTHR15045', NULL, NULL, NULL, NULL, 'FUCOSE-1-PHOSPHATE GUANYLYLTRANSFERASE', NULL, NULL, NULL, 8),
(249597, NULL, 'PTHR21668', NULL, NULL, NULL, NULL, 'EIF-1A', NULL, NULL, 624, 8),
(249598, NULL, 'PTHR48231', NULL, NULL, NULL, NULL, 'TMEM189_B_DMAIN DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(249599, NULL, 'PTHR43545', NULL, NULL, NULL, NULL, 'FORMATE DEHYDROGENASE, NITRATE-INDUCIBLE, IRON-SULFUR SUBUNIT', NULL, NULL, NULL, 8),
(249600, NULL, 'PTHR11289', NULL, NULL, NULL, NULL, 'BREAST CANCER TYPE 2 SUSCEPTIBILITY PROTEIN BRCA2', NULL, NULL, 8166, 8),
(249601, NULL, 'PTHR38655', NULL, NULL, NULL, NULL, 'SIMILAR TO RIKEN CDNA 4930524B15', NULL, NULL, 25891, 8),
(249602, NULL, 'PTHR34606', NULL, NULL, NULL, NULL, 'BON DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(249603, NULL, 'PTHR45643', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE', NULL, NULL, NULL, 8),
(249604, NULL, 'PTHR20531', NULL, NULL, NULL, NULL, 'N-ALPHA-ACETYLTRANSFERASE 40', NULL, NULL, 30077, 8),
(249605, NULL, 'PTHR14027', NULL, NULL, NULL, NULL, 'RNA POLYMERASE-ASSOCIATED PROTEIN CTR9', NULL, NULL, 25110, 8),
(249606, NULL, 'PTHR31469', NULL, NULL, NULL, NULL, 'OS07G0633600 PROTEIN', NULL, NULL, NULL, 8),
(249607, NULL, 'PTHR15285', NULL, NULL, NULL, NULL, 'NEURONATIN', NULL, NULL, 26806, 8),
(249608, NULL, 'PTHR47222', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 532-RELATED', NULL, NULL, 37523, 8),
(249609, NULL, 'PTHR18945', NULL, NULL, NULL, NULL, 'NEUROTRANSMITTER GATED ION CHANNEL', NULL, NULL, 11483, 8),
(249610, NULL, 'PTHR48175', NULL, NULL, NULL, NULL, 'OS04G0581700 PROTEIN', NULL, NULL, NULL, 8),
(249611, NULL, 'PTHR43679', NULL, NULL, NULL, NULL, 'OCTANOYLTRANSFERASE LIPM-RELATED', NULL, NULL, NULL, 8),
(249612, NULL, 'PTHR12228', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID 55 KD SUBUNIT-RELATED', NULL, NULL, 32780, 8);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(249613, NULL, 'PTHR47452', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(249614, NULL, 'PTHR13224', NULL, NULL, NULL, NULL, 'THYROID HORMONE RECEPTOR-ASSOCIATED PROTEIN-RELATED', NULL, NULL, 18953, 8),
(249615, NULL, 'PTHR13166', NULL, NULL, NULL, NULL, 'PROTEIN C6ORF149', NULL, NULL, NULL, 8),
(249616, NULL, 'PTHR36694', NULL, NULL, NULL, NULL, 'PASIFLORA 1, ISOFORM A-RELATED', NULL, NULL, NULL, 8),
(249617, NULL, 'PTHR10156', NULL, NULL, NULL, NULL, '2'',3''-CYCLIC-NUCLEOTIDE 3''-PHOSPHODIESTERASE', NULL, NULL, 8894, 8),
(249618, NULL, 'PTHR37332', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(249619, NULL, 'PTHR21532', NULL, NULL, NULL, NULL, 'PHOSPHODIESTERASE HL', NULL, NULL, 32299, 8),
(249620, NULL, 'PTHR11373', NULL, NULL, NULL, NULL, 'DEOXYNUCLEOSIDE TRIPHOSPHATE TRIPHOSPHOHYDROLASE', NULL, NULL, NULL, 8),
(249621, NULL, 'PTHR34189', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(249622, NULL, 'PTHR47490', NULL, NULL, NULL, NULL, 'PROTEIN BLISTER', NULL, NULL, 34685, 8),
(249623, NULL, 'PTHR24099', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE TRIM36-RELATED', NULL, NULL, NULL, 8),
(249624, NULL, 'PTHR13283', NULL, NULL, NULL, NULL, 'KREV INTERACTION TRAPPED 1-RELATED', NULL, NULL, NULL, 8),
(249625, NULL, 'PTHR37692', NULL, NULL, NULL, NULL, 'HYPOTHETICAL MEMBRANE SPANNING PROTEIN', NULL, NULL, 5867, 8),
(249626, NULL, 'PTHR23085', NULL, NULL, NULL, NULL, 'GH28348P', NULL, NULL, 21253, 8),
(249627, NULL, 'PTHR43434', NULL, NULL, NULL, NULL, 'PHOSPHOGLYCOLATE PHOSPHATASE', NULL, NULL, NULL, 8),
(249628, NULL, 'PTHR42853', NULL, NULL, NULL, NULL, 'ACETYL-COENZYME A CARBOXYLASE CARBOXYL TRANSFERASE SUBUNIT ALPHA', NULL, NULL, 2312, 8),
(249629, NULL, 'PTHR16290', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SMIF  DECAPPING ENZYME DCP1', NULL, NULL, 8649, 8),
(249630, NULL, 'PTHR23036', NULL, NULL, NULL, NULL, 'CYTOKINE RECEPTOR', NULL, NULL, NULL, 8),
(249631, NULL, 'PTHR36423', NULL, NULL, NULL, NULL, 'AFR070WP', NULL, NULL, 14391, 8),
(249632, NULL, 'PTHR33222', NULL, NULL, NULL, NULL, '', NULL, NULL, 31941, 8),
(249633, NULL, 'PTHR36375', NULL, NULL, NULL, NULL, 'OS05G0459300 PROTEIN', NULL, NULL, NULL, 8),
(249634, NULL, 'PTHR36749', NULL, NULL, NULL, NULL, 'F7O18.3 PROTEIN', NULL, NULL, NULL, 8),
(249635, NULL, 'PTHR33928', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE QRT3', NULL, NULL, 30959, 8),
(249636, NULL, 'PTHR22663', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 34704, 8),
(249637, NULL, 'PTHR39112', NULL, NULL, NULL, NULL, 'PROTEIN RALF-LIKE 27-RELATED', NULL, NULL, 28378, 8),
(249638, NULL, 'PTHR10574', NULL, NULL, NULL, NULL, 'NETRIN/LAMININ-RELATED', NULL, NULL, NULL, 8),
(249639, NULL, 'PTHR16484', NULL, NULL, NULL, NULL, 'PARTITIONING DEFECTIVE 3 RELATED', NULL, NULL, NULL, 8),
(249640, NULL, 'PTHR24024', NULL, NULL, NULL, NULL, 'PULMONARY SURFACTANT-ASSOCIATED PROTEIN A', NULL, NULL, NULL, 8),
(249641, NULL, 'PTHR48086', NULL, NULL, NULL, NULL, 'SODIUM/PROLINE SYMPORTER-RELATED', NULL, NULL, NULL, 8),
(249642, NULL, 'PTHR46851', NULL, NULL, NULL, NULL, 'OS01G0884500 PROTEIN', NULL, NULL, 34951, 8),
(249643, NULL, 'PTHR37312', NULL, NULL, NULL, NULL, 'MEMBRANE-BOUND ACYLTRANSFERASE YKRP-RELATED', NULL, NULL, NULL, 8),
(249644, NULL, 'PTHR15136', NULL, NULL, NULL, NULL, 'STROMAL INTERACTION MOLECULE HOMOLOG', NULL, NULL, 30800, 8),
(249645, NULL, 'PTHR35164', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(249646, NULL, 'PTHR45736', NULL, NULL, NULL, NULL, 'ZINC FINGER MYM-TYPE PROTEIN', NULL, NULL, NULL, 8),
(249647, NULL, 'PTHR14380', NULL, NULL, NULL, NULL, 'PLACENTA-SPECIFIC PROTEIN 1', NULL, NULL, 28572, 8),
(249648, NULL, 'PTHR10593', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE RIO', NULL, NULL, 25322, 8),
(249649, NULL, 'PTHR46819', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING DOMAIN-CONTAINING PROTEIN 7', NULL, NULL, NULL, 8),
(249650, NULL, 'PTHR47962', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT HELICASE LHR-RELATED-RELATED', NULL, NULL, NULL, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(249651, NULL, 'PTHR15469', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE B15 SUBUNIT', NULL, NULL, 14201, 8),
(249652, NULL, 'PTHR43768', NULL, NULL, NULL, NULL, 'TREHALOSE 6-PHOSPHATE PHOSPHATASE', NULL, NULL, 36036, 8),
(249653, NULL, 'PTHR24222', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER B FAMILY', NULL, NULL, NULL, 8),
(249654, NULL, 'PTHR15001', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN 123-RELATED', NULL, NULL, NULL, 8),
(249655, NULL, 'PTHR24040', NULL, NULL, NULL, NULL, 'LAMININ G-LIKE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(249656, NULL, 'PTHR41324', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(249657, NULL, 'PTHR13285', NULL, NULL, NULL, NULL, 'ACYLTRANSFERASE', NULL, NULL, NULL, 8),
(249658, NULL, 'PTHR47219', NULL, NULL, NULL, NULL, 'RAB GTPASE-ACTIVATING PROTEIN 1-LIKE', NULL, NULL, NULL, 8),
(249659, NULL, 'PTHR38926', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN, EXPRESSED', NULL, NULL, NULL, 8),
(249660, NULL, 'PTHR21513', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', NULL, NULL, NULL, 8),
(249661, NULL, 'PTHR35506', NULL, NULL, NULL, NULL, 'OS02G0135600 PROTEIN', NULL, NULL, NULL, 8),
(249662, NULL, 'PTHR42076', NULL, NULL, NULL, NULL, 'CYANOVIRIN-N HOMOLOG', NULL, NULL, NULL, 8),
(249663, NULL, 'PTHR36436', NULL, NULL, NULL, NULL, 'SLL5081 PROTEIN', NULL, NULL, NULL, 8),
(249664, NULL, 'PTHR35333', NULL, NULL, NULL, NULL, 'BETA-LACTAMASE', NULL, NULL, 165, 8),
(249665, NULL, 'PTHR46274', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL PHOSPHATASE', NULL, NULL, NULL, 8),
(249666, NULL, 'PTHR13275', NULL, NULL, NULL, NULL, 'YL-1 PROTEIN  TRANSCRIPTION FACTOR-LIKE 1', NULL, NULL, 7531, 8),
(249667, NULL, 'PTHR48123', NULL, NULL, NULL, NULL, 'ARL2_BIND_BART DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(249668, NULL, 'PTHR37736', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN', NULL, NULL, NULL, 8),
(249669, NULL, 'PTHR13526', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR SPT20 HOMOLOG', NULL, NULL, 20070, 8),
(249670, NULL, 'PTHR46106', NULL, NULL, NULL, NULL, 'IA-2 PROTEIN TYROSINE PHOSPHATASE, ISOFORM C', NULL, NULL, 32478, 8),
(249671, NULL, 'PTHR31815', NULL, NULL, NULL, NULL, 'AGAP005329-PA', NULL, NULL, 19163, 8),
(249672, NULL, 'PTHR23140', NULL, NULL, NULL, NULL, 'RNA PROCESSING PROTEIN LD23810P', NULL, NULL, NULL, 8),
(249673, NULL, 'PTHR39221', NULL, NULL, NULL, NULL, 'CHROMOSOME 7 OPEN READING FRAME 61', NULL, NULL, 25921, 8),
(249674, NULL, 'PTHR24145', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 11', NULL, NULL, 35589, 8),
(249675, NULL, 'PTHR15443', NULL, NULL, NULL, NULL, 'ZONA PELLUCIDA BINDING PROTEIN  SP38', NULL, NULL, 11655, 8),
(249676, NULL, 'PTHR14995', NULL, NULL, NULL, NULL, 'AMNIONLESS', NULL, NULL, 25618, 8),
(249677, NULL, 'PTHR21104', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(249678, NULL, 'PTHR37542', NULL, NULL, NULL, NULL, 'HELO DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(249679, NULL, 'PTHR45847', NULL, NULL, NULL, NULL, 'FATTY ACID AMIDE HYDROLASE', NULL, NULL, NULL, 8),
(249680, NULL, 'PTHR37726', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(249681, NULL, 'PTHR28041', NULL, NULL, NULL, NULL, '54S RIBOSOMAL PROTEIN L25, MITOCHONDRIAL', NULL, NULL, 31127, 8),
(249682, NULL, 'PTHR24403', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', NULL, NULL, NULL, 8),
(249683, NULL, 'PTHR37222', NULL, NULL, NULL, NULL, 'OS02G0718000 PROTEIN', NULL, NULL, NULL, 8),
(249684, NULL, 'PTHR48037', NULL, NULL, NULL, NULL, 'ATPASE E1', NULL, NULL, NULL, 8),
(249685, NULL, 'PTHR34455', NULL, NULL, NULL, NULL, 'OS07G0673550 PROTEIN', NULL, NULL, NULL, 8),
(249686, NULL, 'PTHR35550', NULL, NULL, NULL, NULL, '', NULL, NULL, 18058, 8),
(249687, NULL, 'PTHR35295', NULL, NULL, NULL, NULL, 'DNA LIGASE-LIKE PROTEIN', NULL, NULL, NULL, 8),
(249688, NULL, 'PTHR35107', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(249689, NULL, 'PTHR41983', NULL, NULL, NULL, NULL, 'SHORT-CHAIN FATTY ACID TRANSPORTER-RELATED', NULL, NULL, 10465, 8);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(249690, NULL, 'PTHR44169', NULL, NULL, NULL, NULL, 'NADPH-DEPENDENT 1-ACYLDIHYDROXYACETONE PHOSPHATE REDUCTASE', NULL, NULL, NULL, 8),
(249691, NULL, 'PTHR24035', NULL, NULL, NULL, NULL, 'MULTIPLE EPIDERMAL GROWTH FACTOR-LIKE DOMAINS PROTEIN', NULL, NULL, NULL, 8),
(249692, NULL, 'PTHR28039', NULL, NULL, NULL, NULL, 'CHALCONE--FLAVONONE ISOMERASE 1-RELATED', NULL, NULL, 35283, 8),
(249693, NULL, 'PTHR24026', NULL, NULL, NULL, NULL, 'FAT ATYPICAL CADHERIN-RELATED', NULL, NULL, NULL, 8),
(249694, NULL, 'PTHR12189', NULL, NULL, NULL, NULL, 'MRNA  GUANINE-7- METHYLTRANSFERASE', NULL, NULL, 28227, 8),
(249695, NULL, 'PTHR11863', NULL, NULL, NULL, NULL, 'STEROL DESATURASE', NULL, NULL, NULL, 8),
(249696, NULL, 'PTHR43421', NULL, NULL, NULL, NULL, 'METALLOPROTEASE PMBA', NULL, NULL, NULL, 8),
(249697, NULL, 'PTHR39163', NULL, NULL, NULL, NULL, 'FERREDOXIN', NULL, NULL, NULL, 8),
(249698, NULL, 'PTHR16096', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN 11', NULL, NULL, 26194, 8),
(249699, NULL, 'PTHR41747', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(249700, NULL, 'PTHR14889', NULL, NULL, NULL, NULL, 'RCG36411', NULL, NULL, 25875, 8),
(249701, NULL, 'PTHR13296', NULL, NULL, NULL, NULL, 'BCAS2 PROTEIN', NULL, NULL, 8737, 8),
(249702, NULL, 'PTHR11470', NULL, NULL, NULL, NULL, 'KAPPA CASEIN', NULL, NULL, 4056, 8),
(249703, NULL, 'PTHR13239', NULL, NULL, NULL, NULL, 'PROTEIN REQUIRED FOR HYPHAL ANASTOMOSIS  HAM-2', NULL, NULL, 27466, 8),
(249704, NULL, 'PTHR23170', NULL, NULL, NULL, NULL, 'NY-REN-58 ANTIGEN', NULL, NULL, NULL, 8),
(249705, NULL, 'PTHR36107', NULL, NULL, NULL, NULL, 'SMALL, ACID-SOLUBLE SPORE PROTEIN A', NULL, NULL, NULL, 8),
(249706, NULL, 'PTHR13673', NULL, NULL, NULL, NULL, 'ESOPHAGEAL CANCER ASSOCIATED PROTEIN', NULL, NULL, 23766, 8),
(249707, NULL, 'PTHR34948', NULL, NULL, NULL, NULL, 'OS08G0299200 PROTEIN', NULL, NULL, NULL, 8),
(249708, NULL, 'PTHR24242', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR', NULL, NULL, NULL, 8),
(249709, NULL, 'PTHR11915', NULL, NULL, NULL, NULL, 'SPECTRIN/FILAMIN RELATED CYTOSKELETAL PROTEIN', NULL, NULL, NULL, 8),
(249710, NULL, 'PTHR31702', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 33', NULL, NULL, 21675, 8),
(249711, NULL, 'PTHR34273', NULL, NULL, NULL, NULL, 'METHYLTHIORIBOSE KINASE', NULL, NULL, NULL, 8),
(249712, NULL, 'PTHR37988', NULL, NULL, NULL, NULL, 'UPF0592 MEMBRANE PROTEIN C7D4.03C', NULL, NULL, NULL, 8),
(249713, NULL, 'PTHR37291', NULL, NULL, NULL, NULL, '5-METHYLCYTOSINE-SPECIFIC RESTRICTION ENZYME B', NULL, NULL, NULL, 8),
(249714, NULL, 'PTHR36526', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 154', NULL, NULL, NULL, 8),
(249715, NULL, 'PTHR10058', NULL, NULL, NULL, NULL, 'MACROPHAGE COLONY STIMULATING FACTOR', NULL, NULL, 4075, 8),
(249716, NULL, 'PTHR48184', NULL, NULL, NULL, NULL, 'RICIN B-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(249717, NULL, 'PTHR16106', NULL, NULL, NULL, NULL, 'CHROMOSOME 4 OPEN READING FRAME 19', NULL, NULL, 25324, 8),
(249718, NULL, 'PTHR10617', NULL, NULL, NULL, NULL, 'ELECTRON TRANSFER FLAVOPROTEIN-UBIQUINONE OXIDOREDUCTASE', NULL, NULL, 27222, 8),
(249719, NULL, 'PTHR46895', NULL, NULL, NULL, NULL, 'PROTEIN CBG20548-RELATED', NULL, NULL, NULL, 8),
(249720, NULL, 'PTHR16922', NULL, NULL, NULL, NULL, 'INTERLEUKIN 11', NULL, NULL, 20822, 8),
(249721, NULL, 'PTHR13022', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT 11', NULL, NULL, 14489, 8),
(249722, NULL, 'PTHR34555', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE HEMOLYSIN-III-LIKE PROTEIN', NULL, NULL, NULL, 8),
(249723, NULL, 'PTHR39157', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(249724, NULL, 'PTHR21261', NULL, NULL, NULL, NULL, 'BEAT PROTEIN', NULL, NULL, NULL, 8),
(249725, NULL, 'PTHR30177', NULL, NULL, NULL, NULL, 'GLYCINE BETAINE/L-PROLINE TRANSPORT SYSTEM PERMEASE PROTEIN PROW', NULL, NULL, NULL, 8),
(249726, NULL, 'PTHR11199', NULL, NULL, NULL, NULL, 'STROMAL ANTIGEN', NULL, NULL, 27050, 8),
(249727, NULL, 'PTHR46347', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(249728, NULL, 'PTHR13236', NULL, NULL, NULL, NULL, 'DYNEIN 2 LIGHT INTERMEDIATE CHAIN, ISOFORM 2', NULL, NULL, 27181, 8),
(249729, NULL, 'PTHR17045', NULL, NULL, NULL, NULL, 'MELANOCYTE SPECIFIC GENE RELATED  CITED', NULL, NULL, 1905, 8),
(249730, NULL, 'PTHR47865', NULL, NULL, NULL, NULL, 'OS05G0580550 PROTEIN', NULL, NULL, NULL, 8),
(249731, NULL, 'PTHR35138', NULL, NULL, NULL, NULL, 'OS01G0225300 PROTEIN', NULL, NULL, NULL, 8),
(249732, NULL, 'PTHR39394', NULL, NULL, NULL, NULL, 'YALI0E31793P', NULL, NULL, NULL, 8),
(249733, NULL, 'PTHR10655', NULL, NULL, NULL, NULL, 'LYSOPHOSPHOLIPASE-RELATED', NULL, NULL, NULL, 8),
(249734, NULL, 'PTHR10848', NULL, NULL, NULL, NULL, 'MEIOTIC RECOMBINATION PROTEIN SPO11', NULL, NULL, 4904, 8),
(249735, NULL, 'PTHR24379', NULL, NULL, NULL, NULL, 'KRAB AND ZINC FINGER DOMAIN-CONTAINING', NULL, NULL, NULL, 8),
(249736, NULL, 'PTHR47343', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR SPT7', NULL, NULL, 28681, 8),
(249737, NULL, 'PTHR47511', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP23', NULL, NULL, 35176, 8),
(249738, NULL, 'PTHR45723', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE RIO1', NULL, NULL, NULL, 8),
(249739, NULL, 'PTHR45827', NULL, NULL, NULL, NULL, 'SORTING NEXIN', NULL, NULL, NULL, 8),
(249740, NULL, 'PTHR22952', NULL, NULL, NULL, NULL, 'CAMP-RESPONSE ELEMENT BINDING PROTEIN-RELATED', NULL, NULL, 34014, 8),
(249741, NULL, 'PTHR32195', NULL, NULL, NULL, NULL, 'OS07G0662800 PROTEIN', NULL, NULL, NULL, 8),
(249742, NULL, 'PTHR16161', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(249743, NULL, 'PTHR11319', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR-RELATED', NULL, NULL, NULL, 8),
(249744, NULL, 'PTHR47611', NULL, NULL, NULL, NULL, 'HAT DIMERISATION DOMAIN, C-TERMINAL', NULL, NULL, NULL, 8),
(249745, NULL, 'PTHR39077', NULL, NULL, NULL, NULL, 'DUF4793 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(249746, NULL, 'PTHR15069', NULL, NULL, NULL, NULL, 'PROTEASOME ASSEMBLY CHAPERONE 1', NULL, NULL, 17546, 8),
(249747, NULL, 'PTHR31973', NULL, NULL, NULL, NULL, 'POLYPROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(249748, NULL, 'PTHR43118', NULL, NULL, NULL, NULL, 'RHAMNOGALACTURONAN LYASE (EUROFUNG)', NULL, NULL, 6218, 8),
(249749, NULL, 'PTHR10665', NULL, NULL, NULL, NULL, 'RECOMBINING BINDING PROTEIN SUPPRESSOR OF HAIRLESS', NULL, NULL, 27391, 8),
(249750, NULL, 'PTHR44549', NULL, NULL, NULL, NULL, 'ENDOTHELIAL CELL-SELECTIVE ADHESION MOLECULE', NULL, NULL, 35146, 8),
(249751, NULL, 'PTHR21066', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(249752, NULL, 'PTHR28657', NULL, NULL, NULL, NULL, 'INDOLEAMINE 2,3-DIOXYGENASE', NULL, NULL, 3043, 8),
(249753, NULL, 'PTHR16222', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLGLYCOHYDROLASE', NULL, NULL, NULL, 8),
(249754, NULL, 'PTHR21231', NULL, NULL, NULL, NULL, 'XPA-BINDING PROTEIN 1-RELATED', NULL, NULL, 2944, 8),
(249755, NULL, 'PTHR24276', NULL, NULL, NULL, NULL, 'POLYSERASE-RELATED', NULL, NULL, NULL, 8),
(249756, NULL, 'PTHR16435', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 6 SPATA6', NULL, NULL, 36434, 8),
(249757, NULL, 'PTHR22696', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF26', NULL, NULL, NULL, 8),
(249758, NULL, 'PTHR46505', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE NAD-BINDING DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(249759, NULL, 'PTHR44843', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(249760, NULL, 'PTHR23133', NULL, NULL, NULL, NULL, 'IMIDAZOLEGLYCEROL-PHOSPHATE DEHYDRATASE HIS7', NULL, NULL, 4708, 8),
(249761, NULL, 'PTHR47638', NULL, NULL, NULL, NULL, 'LYSINE-SPECIFIC DEMETHYLASE 5A-LIKE', NULL, NULL, NULL, 8),
(249762, NULL, 'PTHR10394', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S8', NULL, NULL, 2062, 8),
(249763, NULL, 'PTHR36747', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY PROTEIN', NULL, NULL, NULL, 8),
(249764, NULL, 'PTHR15026', NULL, NULL, NULL, NULL, 'CALCIUM-SIGNAL MODULATING CYCLOPHILIN LIGAND  CAML', NULL, NULL, 21198, 8);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(249765, NULL, 'PTHR11824', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL BETA SUBUNIT', NULL, NULL, NULL, 8),
(249766, NULL, 'PTHR37981', NULL, NULL, NULL, NULL, 'LIPASE 2', NULL, NULL, 32775, 8),
(249767, NULL, 'PTHR22652', NULL, NULL, NULL, NULL, 'NUCLEOPORIN NUP43', NULL, NULL, NULL, 8),
(249768, NULL, 'PTHR37819', NULL, NULL, NULL, NULL, 'PROTEIN PSIE', NULL, NULL, 14330, 8),
(249769, NULL, 'PTHR10853', NULL, NULL, NULL, NULL, 'PELOTA', NULL, NULL, 5554, 8),
(249770, NULL, 'PTHR45138', NULL, NULL, NULL, NULL, 'REGULATORY COMPONENTS OF SENSORY TRANSDUCTION SYSTEM', NULL, NULL, NULL, 8),
(249771, NULL, 'PTHR37240', NULL, NULL, NULL, NULL, 'PREPROTEIN TRANSLOCASE SUBUNIT SECE1', NULL, NULL, NULL, 8),
(249772, NULL, 'PTHR46532', NULL, NULL, NULL, NULL, 'MALE FERTILITY FACTOR KL5', NULL, NULL, 23364, 8),
(249773, NULL, 'PTHR14899', NULL, NULL, NULL, NULL, 'G KINASE ANCHORING PROTEIN 1', NULL, NULL, 25309, 8),
(249774, NULL, 'PTHR38030', NULL, NULL, NULL, NULL, 'PROTOPORPHYRINOGEN IX DEHYDROGENASE [MENAQUINONE]', NULL, NULL, NULL, 8),
(249775, NULL, 'PTHR44272', NULL, NULL, NULL, NULL, 'DNAJ DOMAIN (PROKARYOTIC HEAT SHOCK PROTEIN)', NULL, NULL, NULL, 8),
(249776, NULL, 'PTHR46816', NULL, NULL, NULL, NULL, 'OS01G0273500 PROTEIN', NULL, NULL, NULL, 8),
(249777, NULL, 'PTHR43542', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(249778, NULL, 'PTHR46910', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR PDR1', NULL, NULL, NULL, 8),
(249779, NULL, 'PTHR35192', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', NULL, NULL, 31229, 8),
(249780, NULL, 'PTHR31860', NULL, NULL, NULL, NULL, 'HEAT-INDUCIBLE TRANSCRIPTION REPRESSOR (DUF639)-RELATED', NULL, NULL, NULL, 8),
(249781, NULL, 'PTHR10801', NULL, NULL, NULL, NULL, '24-DEHYDROCHOLESTEROL REDUCTASE', NULL, NULL, 27093, 8),
(249782, NULL, 'PTHR43219', NULL, NULL, NULL, NULL, 'CRISPR-ASSOCIATED ENDONUCLEASE CAS1', NULL, NULL, 14711, 8),
(249783, NULL, 'PTHR43029', NULL, NULL, NULL, NULL, 'AMMONIUM TRANSPORTER MEP2', NULL, NULL, 5244, 8),
(249784, NULL, 'PTHR41394', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER MGTE', NULL, NULL, NULL, 8),
(249785, NULL, 'PTHR13832', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 2C', NULL, NULL, 17585, 8),
(249786, NULL, 'PTHR34950', NULL, NULL, NULL, NULL, 'OS04G0457400 PROTEIN', NULL, NULL, NULL, 8),
(249787, NULL, 'PTHR36910', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(249788, NULL, 'PTHR46132', NULL, NULL, NULL, NULL, 'DIGALACTOSYLDIACYLGLYCEROL SYNTHASE 2, CHLOROPLASTIC', NULL, NULL, 35060, 8),
(249789, NULL, 'PTHR34572', NULL, NULL, NULL, NULL, 'GOLGIN FAMILY A PROTEIN', NULL, NULL, NULL, 8),
(249790, NULL, 'PTHR12002', NULL, NULL, NULL, NULL, 'CLAUDIN', NULL, NULL, 11486, 8),
(249791, NULL, 'PTHR12955', NULL, NULL, NULL, NULL, 'SARCOMA ANTIGEN NY-SAR-95-RELATED', NULL, NULL, 15750, 8),
(249792, NULL, 'PTHR14315', NULL, NULL, NULL, NULL, 'SPOT14 FAMILY MEMBER', NULL, NULL, 13250, 8),
(249793, NULL, 'PTHR11667', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(249794, NULL, 'PTHR13146', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(249795, NULL, 'PTHR14983', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 33315, 8),
(249796, NULL, 'PTHR37003', NULL, NULL, NULL, NULL, 'ENDOTOXIN_N DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, 30894, 8),
(249797, NULL, 'PTHR43648', NULL, NULL, NULL, NULL, 'ELECTRON TRANSFER FLAVOPROTEIN BETA SUBUNIT LYSINE METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(249798, NULL, 'PTHR33969', NULL, NULL, NULL, NULL, 'SEGREGATION AND CONDENSATION PROTEIN A', NULL, NULL, 6129, 8),
(249799, NULL, 'PTHR47140', NULL, NULL, NULL, NULL, 'MAP3K7 C-TERMINAL-LIKE PROTEIN', NULL, NULL, 34220, 8),
(249800, NULL, 'PTHR36774', NULL, NULL, NULL, NULL, 'INSULIN-INDUCED PROTEIN', NULL, NULL, NULL, 8),
(249801, NULL, 'PTHR43331', NULL, NULL, NULL, NULL, 'HOMOSERINE DEHYDROGENASE', NULL, NULL, NULL, 8),
(249802, NULL, 'PTHR15430', NULL, NULL, NULL, NULL, 'GLOMULIN', NULL, NULL, 18082, 8),
(249803, NULL, 'PTHR45890', NULL, NULL, NULL, NULL, 'AARF DOMAIN CONTAINING KINASE 2 (PREDICTED)', NULL, NULL, NULL, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(249804, NULL, 'PTHR12966', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE  UBIQUINONE  1 ALPHA SUBCOMPLEX SUBUNIT 13', NULL, NULL, 14050, 8),
(249805, NULL, 'PTHR31408', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC689986', NULL, NULL, 25901, 8),
(249806, NULL, 'PTHR34231', NULL, NULL, NULL, NULL, 'EXS-RELATED PROTEIN', NULL, NULL, NULL, 8),
(249807, NULL, 'PTHR24092', NULL, NULL, NULL, NULL, 'PROBABLE PHOSPHOLIPID-TRANSPORTING ATPASE', NULL, NULL, NULL, 8),
(249808, NULL, 'PTHR34938', NULL, NULL, NULL, NULL, 'PROTEIN FERTILITY RESTORER RF2, MITOCHONDRIAL', NULL, NULL, 31645, 8),
(249809, NULL, 'PTHR22797', NULL, NULL, NULL, NULL, 'CARD6/NUCLEOLAR PROTEIN 3', NULL, NULL, NULL, 8),
(249810, NULL, 'PTHR47731', NULL, NULL, NULL, NULL, 'UBIQUITIN D', NULL, NULL, 35494, 8),
(249811, NULL, 'PTHR38598', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YJCH', NULL, NULL, NULL, 8),
(249812, NULL, 'PTHR34794', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, 27168, 8),
(249813, NULL, 'PTHR37916', NULL, NULL, NULL, NULL, 'CHITIN-BINDING TYPE-4 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(249814, NULL, 'PTHR38795', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(249815, NULL, 'PTHR38636', NULL, NULL, NULL, NULL, 'PROTEIN CBG20488', NULL, NULL, NULL, 8),
(249816, NULL, 'PTHR13230', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR IIIC, POLYPEPTIDE 5', NULL, NULL, 32879, 8),
(249817, NULL, 'PTHR45967', NULL, NULL, NULL, NULL, 'G-BOX-BINDING FACTOR 3-RELATED', NULL, NULL, 36519, 8),
(249818, NULL, 'PTHR12377', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 31151, 8),
(249819, NULL, 'PTHR36519', NULL, NULL, NULL, NULL, 'FIP (FUNGUS-INDUCED PROTEIN) RELATED-RELATED', NULL, NULL, NULL, 8),
(249820, NULL, 'PTHR43413', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, ASNC FAMILY', NULL, NULL, NULL, 8),
(249821, NULL, 'PTHR24960', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM I IRON-SULFUR CENTER-RELATED', NULL, NULL, NULL, 8),
(249822, NULL, 'PTHR39072', NULL, NULL, NULL, NULL, 'RE48511P', NULL, NULL, NULL, 8),
(249823, NULL, 'PTHR17615', NULL, NULL, NULL, NULL, 'PROTEIN FAM189A', NULL, NULL, 25427, 8),
(249824, NULL, 'PTHR13291', NULL, NULL, NULL, NULL, 'JOSEPHIN 1, 2', NULL, NULL, 31005, 8),
(249825, NULL, 'PTHR35539', NULL, NULL, NULL, NULL, 'CDNA SEQUENCE BC048562', NULL, NULL, NULL, 8),
(249826, NULL, 'PTHR34848', NULL, NULL, NULL, NULL, '', NULL, NULL, 3291, 8),
(249827, NULL, 'PTHR43735', NULL, NULL, NULL, NULL, 'APOPTOSIS-INDUCING FACTOR 1', NULL, NULL, NULL, 8),
(249828, NULL, 'PTHR10201', NULL, NULL, NULL, NULL, 'MATRIX METALLOPROTEINASE', NULL, NULL, NULL, 8),
(249829, NULL, 'PTHR21258', NULL, NULL, NULL, NULL, 'DOCKING PROTEIN RELATED', NULL, NULL, NULL, 8),
(249830, NULL, 'PTHR11480', NULL, NULL, NULL, NULL, 'SAPOSIN-RELATED', NULL, NULL, NULL, 8),
(249831, NULL, 'PTHR28213', NULL, NULL, NULL, NULL, 'IMP-SPECIFIC 5''-NUCLEOTIDASE 1', NULL, NULL, 9173, 8),
(249832, NULL, 'PTHR21616', NULL, NULL, NULL, NULL, 'CENTROSOME SPINDLE POLE ASSOCIATED PROTEIN', NULL, NULL, 21686, 8),
(249833, NULL, 'PTHR47766', NULL, NULL, NULL, NULL, 'PROTEIN EFR3', NULL, NULL, 27879, 8),
(249834, NULL, 'PTHR16019', NULL, NULL, NULL, NULL, 'SYNAPSE-ASSOCIATED PROTEIN', NULL, NULL, NULL, 8),
(249835, NULL, 'PTHR43013', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA REDUCTASE', NULL, NULL, NULL, 8),
(249836, NULL, 'PTHR23257', NULL, NULL, NULL, NULL, 'SERINE-THREONINE PROTEIN KINASE', NULL, NULL, NULL, 8),
(249837, NULL, 'PTHR37844', NULL, NULL, NULL, NULL, 'SER/THR PROTEIN PHOSPHATASE SUPERFAMILY (AFU_ORTHOLOGUE AFUA_1G14840)', NULL, NULL, NULL, 8),
(249838, NULL, 'PTHR30385', NULL, NULL, NULL, NULL, 'SIGMA FACTOR F  FLAGELLAR', NULL, NULL, NULL, 8),
(249839, NULL, 'PTHR10928', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF FUSED', NULL, NULL, 1369, 8),
(249840, NULL, 'PTHR21256', NULL, NULL, NULL, NULL, 'HISTIDINOL DEHYDROGENASE  HDH', NULL, NULL, 13893, 8),
(249841, NULL, 'PTHR38654', NULL, NULL, NULL, NULL, 'BUCKY BALL-RELATED', NULL, NULL, NULL, 8),
(249842, NULL, 'PTHR31527', NULL, NULL, NULL, NULL, 'RE64534P', NULL, NULL, NULL, 8);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(249843, NULL, 'PTHR35114', NULL, NULL, NULL, NULL, 'CYTOCHROME OXIDASE COMPLEX ASSEMBLY PROTEIN', NULL, NULL, NULL, 8),
(249844, NULL, 'PTHR36779', NULL, NULL, NULL, NULL, 'OSJNBA0083N12.13 PROTEIN', NULL, NULL, NULL, 8),
(249845, NULL, 'PTHR28043', NULL, NULL, NULL, NULL, 'INCREASED RECOMBINATION CENTERS PROTEIN 6', NULL, NULL, 17940, 8),
(249846, NULL, 'PTHR23198', NULL, NULL, NULL, NULL, 'NUCLEOPORIN', NULL, NULL, 32772, 8),
(249847, NULL, 'PTHR23328', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(249848, NULL, 'PTHR46753', NULL, NULL, NULL, NULL, 'FYVE AND COILED-COIL DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(249849, NULL, 'PTHR10288', NULL, NULL, NULL, NULL, 'KH DOMAIN CONTAINING RNA BINDING PROTEIN', NULL, NULL, NULL, 8),
(249850, NULL, 'PTHR21654', NULL, NULL, NULL, NULL, 'FI21293P1', NULL, NULL, NULL, 8),
(249851, NULL, 'PTHR35800', NULL, NULL, NULL, NULL, 'PROTEIN JAG', NULL, NULL, 32671, 8),
(249852, NULL, 'PTHR13742', NULL, NULL, NULL, NULL, 'RETINOBLASTOMA-ASSOCIATED PROTEIN  RB -RELATED', NULL, NULL, 23437, 8),
(249853, NULL, 'PTHR33886', NULL, NULL, NULL, NULL, 'UNSATURATED RHAMNOGALACTURONAN HYDROLASE (EUROFUNG)', NULL, NULL, NULL, 8),
(249854, NULL, 'PTHR47167', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE TAO1-LIKE PROTEIN', NULL, NULL, NULL, 8),
(249855, NULL, 'PTHR47303', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(249856, NULL, 'PTHR21625', NULL, NULL, NULL, NULL, 'NYD-SP28 PROTEIN', NULL, NULL, 28923, 8),
(249857, NULL, 'PTHR40765', NULL, NULL, NULL, NULL, 'ESX-2 SECRETION SYSTEM ATPASE ECCB2', NULL, NULL, 2237, 8),
(249858, NULL, 'PTHR14235', NULL, NULL, NULL, NULL, 'OSTEOCALCIN', NULL, NULL, 32897, 8),
(249859, NULL, 'PTHR13266', NULL, NULL, NULL, NULL, 'PROTEASOME INHIBITOR', NULL, NULL, 35666, 8),
(249860, NULL, 'PTHR12441', NULL, NULL, NULL, NULL, 'ATP SYNTHASE COUPLING FACTOR 6, MITOCHONDRIAL', NULL, NULL, 7989, 8),
(249861, NULL, 'PTHR28469', NULL, NULL, NULL, NULL, 'ECTODYSPLASIN-A RECEPTOR-ASSOCIATED ADAPTER PROTEIN', NULL, NULL, 32862, 8),
(249862, NULL, 'PTHR23006', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(249863, NULL, 'PTHR37249', NULL, NULL, NULL, NULL, 'OS03G0206201 PROTEIN', NULL, NULL, NULL, 8),
(249864, NULL, 'PTHR45528', NULL, NULL, NULL, NULL, 'SENSOR HISTIDINE KINASE CPXA', NULL, NULL, NULL, 8),
(249865, NULL, 'PTHR11538', NULL, NULL, NULL, NULL, 'PHENYLALANYL-TRNA SYNTHETASE', NULL, NULL, NULL, 8),
(249866, NULL, 'PTHR44665', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 14', NULL, NULL, NULL, 8),
(249867, NULL, 'PTHR20583', NULL, NULL, NULL, NULL, 'TRIPLE QXXK/R MOTIF-CONTAINING PROTEIN', NULL, NULL, 22043, 8),
(249868, NULL, 'PTHR11807', NULL, NULL, NULL, NULL, 'ATPASES OF THE PP SUPERFAMILY-RELATED', NULL, NULL, NULL, 8),
(249869, NULL, 'PTHR47721', NULL, NULL, NULL, NULL, 'OS01G0235100 PROTEIN', NULL, NULL, NULL, 8),
(249870, NULL, 'PTHR21705', NULL, NULL, NULL, NULL, 'RAI16 PROTEIN-RELATED', NULL, NULL, 15606, 8),
(249871, NULL, 'PTHR30149', NULL, NULL, NULL, NULL, 'HYDROGENASE PROTEIN ASSEMBLY PROTEIN HYPD', NULL, NULL, 4570, 8),
(249872, NULL, 'PTHR47023', NULL, NULL, NULL, NULL, 'SEX PEPTIDE RECEPTOR', NULL, NULL, NULL, 8),
(249873, NULL, 'PTHR15176', NULL, NULL, NULL, NULL, 'NEPHROCYSTIN', NULL, NULL, NULL, 8),
(249874, NULL, 'PTHR10316', NULL, NULL, NULL, NULL, 'MEMBRANE ASSOCIATED GUANYLATE KINASE-RELATED', NULL, NULL, NULL, 8),
(249875, NULL, 'PTHR16166', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN  VPS13', NULL, NULL, 24690, 8),
(249876, NULL, 'PTHR48228', NULL, NULL, NULL, NULL, 'SUCCINYL-COA--D-CITRAMALATE COA-TRANSFERASE', NULL, NULL, NULL, 8),
(249877, NULL, 'PTHR46520', NULL, NULL, NULL, NULL, 'SERINE BETA-LACTAMASE-LIKE PROTEIN LACTB, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(249878, NULL, 'PTHR20837', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN-RELATED', NULL, NULL, NULL, 8),
(249879, NULL, 'PTHR35470', NULL, NULL, NULL, NULL, 'CADMIUM TOLERANT 3', NULL, NULL, NULL, 8),
(249880, NULL, 'PTHR33887', NULL, NULL, NULL, NULL, '', NULL, NULL, 33141, 8);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(249881, NULL, 'PTHR46809', NULL, NULL, NULL, NULL, 'STROMAL CELL-DERIVED FACTOR 2-LIKE PROTEIN', NULL, NULL, NULL, 8),
(249882, NULL, 'PTHR43241', NULL, NULL, NULL, NULL, 'FLAVIN REDUCTASE DOMAIN PROTEIN', NULL, NULL, NULL, 8),
(249883, NULL, 'PTHR31025', NULL, NULL, NULL, NULL, 'SI:CH211-196P9.1-RELATED', NULL, NULL, NULL, 8),
(249884, NULL, 'PTHR35440', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 36', NULL, NULL, NULL, 8),
(249885, NULL, 'PTHR43879', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER PERMEASE PROTEIN', NULL, NULL, NULL, 8),
(249886, NULL, 'PTHR20857', NULL, NULL, NULL, NULL, 'THIAMINE-PHOSPHATE PYROPHOSPHORYLASE', NULL, NULL, NULL, 8),
(249887, NULL, 'PTHR12107', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL GAMMA SUBUNIT', NULL, NULL, NULL, 8),
(249888, NULL, 'PTHR47533', NULL, NULL, NULL, NULL, 'PROTEIN CBG21859', NULL, NULL, NULL, 8),
(249889, NULL, 'PTHR36439', NULL, NULL, NULL, NULL, 'BLL4334 PROTEIN', NULL, NULL, 8832, 8),
(249890, NULL, 'PTHR16466', NULL, NULL, NULL, NULL, 'TELOMERE REPEAT-BINDING FACTOR 2-INTERACTING PROTEIN 1', NULL, NULL, 33672, 8),
(249891, NULL, 'PTHR46707', NULL, NULL, NULL, NULL, 'PROTEIN CBG07468', NULL, NULL, NULL, 8),
(249892, NULL, 'PTHR10159', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE', NULL, NULL, NULL, 8),
(249893, NULL, 'PTHR43235', NULL, NULL, NULL, NULL, 'GLUTAMINE AMIDOTRANSFERASE PB2B2.05-RELATED', NULL, NULL, 36199, 8),
(249894, NULL, 'PTHR36476', NULL, NULL, NULL, NULL, 'OREXIGENIC NEUROPEPTIDE QRFP', NULL, NULL, 26986, 8),
(249895, NULL, 'PTHR45983', NULL, NULL, NULL, NULL, 'TYROSINE PHOSPHATSE N18, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(249896, NULL, 'PTHR24055', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE', NULL, NULL, NULL, 8),
(249897, NULL, 'PTHR35524', NULL, NULL, NULL, NULL, 'ALPHA-ACETOLACTATE DECARBOXYLASE', NULL, NULL, 7486, 8),
(249898, NULL, 'PTHR38553', NULL, NULL, NULL, NULL, 'PROTEIN CBG19621', NULL, NULL, NULL, 8),
(249899, NULL, 'PTHR33880', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, 31798, 8),
(249900, NULL, 'PTHR11261', NULL, NULL, NULL, NULL, 'INTERPHOTORECEPTOR RETINOID-BINDING PROTEIN', NULL, NULL, NULL, 8),
(249901, NULL, 'PTHR37625', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE LIPOPROTEIN-RELATED', NULL, NULL, 18316, 8),
(249902, NULL, 'PTHR33258', NULL, NULL, NULL, NULL, 'TRANSPOSASE INSL FOR INSERTION SEQUENCE ELEMENT IS186A-RELATED', NULL, NULL, NULL, 8),
(249903, NULL, 'PTHR13593', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(249904, NULL, 'PTHR24326', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN', NULL, NULL, 36909, 8),
(249905, NULL, 'PTHR33967', NULL, NULL, NULL, NULL, 'RAGULATOR COMPLEX PROTEIN LAMTOR4', NULL, NULL, 10998, 8),
(249906, NULL, 'PTHR10264', NULL, NULL, NULL, NULL, 'BAND 7 PROTEIN-RELATED', NULL, NULL, 34679, 8),
(249907, NULL, 'PTHR40524', NULL, NULL, NULL, NULL, 'PEPTIDASE_C39_2 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(249908, NULL, 'PTHR45295', NULL, NULL, NULL, NULL, 'CHAPERONE PROTEIN DNAJ C76, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(249909, NULL, 'PTHR34953', NULL, NULL, NULL, NULL, 'ALPHA/BETA HYDROLASE RELATED PROTEIN', NULL, NULL, NULL, 8),
(249910, NULL, 'PTHR31770', NULL, NULL, NULL, NULL, 'CHEMOKINE-LIKE PROTEIN TAFA FAMILY MEMBER', NULL, NULL, NULL, 8),
(249911, NULL, 'PTHR13347', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(249912, NULL, 'PTHR12900', NULL, NULL, NULL, NULL, 'MITOTIC AND DNA DAMAGE CHECKPOINT PROTEIN HUS1', NULL, NULL, NULL, 8),
(249913, NULL, 'PTHR46839', NULL, NULL, NULL, NULL, 'SUSHI DOMAIN-CONTAINING PROTEIN 6', NULL, NULL, 35989, 8),
(249914, NULL, 'PTHR13191', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA PROCESSING PROTEIN 7-RELATED', NULL, NULL, 31819, 8),
(249915, NULL, 'PTHR11533', NULL, NULL, NULL, NULL, 'PROTEASE M1 ZINC METALLOPROTEASE', NULL, NULL, NULL, 8),
(249916, NULL, 'PTHR24039', NULL, NULL, NULL, NULL, 'FIBRILLIN-RELATED', NULL, NULL, NULL, 8),
(249917, NULL, 'PTHR36417', NULL, NULL, NULL, NULL, 'SELENOPROTEIN DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_1G05220)', NULL, NULL, NULL, 8);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(249918, NULL, 'PTHR40635', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(249919, NULL, 'PTHR47995', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB33-RELATED', NULL, NULL, NULL, 8),
(249920, NULL, 'PTHR24559', NULL, NULL, NULL, NULL, 'TRANSPOSON TY3-I GAG-POL POLYPROTEIN', NULL, NULL, NULL, 8),
(249921, NULL, 'PTHR47655', NULL, NULL, NULL, NULL, 'QUINIC ACID UTILIZATION ACTIVATOR', NULL, NULL, NULL, 8),
(249922, NULL, 'PTHR21497', NULL, NULL, NULL, NULL, 'UBIQUITIN LIGASE E3 ALPHA-RELATED', NULL, NULL, 32773, 8),
(249923, NULL, 'PTHR48004', NULL, NULL, NULL, NULL, 'OS01G0149700 PROTEIN', NULL, NULL, NULL, 8),
(249924, NULL, 'PTHR34296', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ACTIVATOR PROTEIN MED', NULL, NULL, NULL, 8),
(249925, NULL, 'PTHR35144', NULL, NULL, NULL, NULL, 'MEIOSIS-SPECIFIC TRANSCRIPTION FACTOR NDT80', NULL, NULL, NULL, 8),
(249926, NULL, 'PTHR35201', NULL, NULL, NULL, NULL, 'TERPENE SYNTHASE', NULL, NULL, NULL, 8),
(249927, NULL, 'PTHR35664', NULL, NULL, NULL, NULL, 'SPERMATID-SPECIFIC MANCHETTE-RELATED PROTEIN 1', NULL, NULL, 21872, 8),
(249928, NULL, 'PTHR35567', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE (AFU_ORTHOLOGUE AFUA_2G13800)', NULL, NULL, NULL, 8),
(249929, NULL, 'PTHR23335', NULL, NULL, NULL, NULL, 'CALMODULIN-BINDING TRANSCRIPTION ACTIVATOR  CAMTA', NULL, NULL, NULL, 8),
(249930, NULL, 'PTHR20932', NULL, NULL, NULL, NULL, 'LYSM AND PUTATIVE PEPTIDOGLYCAN-BINDING DOMAIN-CONTAINING PROTEIN', NULL, NULL, 35674, 8),
(249931, NULL, 'PTHR35981', NULL, NULL, NULL, NULL, 'ION TRANSPORT PEPTIDE, ISOFORM C', NULL, NULL, 25273, 8),
(249932, NULL, 'PTHR30075', NULL, NULL, NULL, NULL, 'GLYCYL-TRNA SYNTHETASE', NULL, NULL, 11369, 8),
(249933, NULL, 'PTHR42837', NULL, NULL, NULL, NULL, 'REGULATOR OF SIGMA-E PROTEASE RSEP', NULL, NULL, 5792, 8),
(249934, NULL, 'PTHR43270', NULL, NULL, NULL, NULL, 'BETA-ALA-HIS DIPEPTIDASE', NULL, NULL, NULL, 8),
(249935, NULL, 'PTHR47963', NULL, NULL, NULL, NULL, 'DEAD-BOX ATP-DEPENDENT RNA HELICASE 47, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(249936, NULL, 'PTHR20988', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 23378, 8),
(249937, NULL, 'PTHR35320', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE ATP-BINDING SUBUNIT', NULL, NULL, NULL, 8),
(249938, NULL, 'PTHR13489', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 17727, 8),
(249939, NULL, 'PTHR46784', NULL, NULL, NULL, NULL, 'KILLER CELL LECTIN-LIKE RECEPTOR SUBFAMILY B MEMBER 1', NULL, NULL, NULL, 8),
(249940, NULL, 'PTHR11673', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR 5A FAMILY MEMBER', NULL, NULL, 4219, 8),
(249941, NULL, 'PTHR42893', NULL, NULL, NULL, NULL, 'PROTEIN DETOXIFICATION 44, CHLOROPLASTIC-RELATED', NULL, NULL, 35247, 8),
(249942, NULL, 'PTHR13058', NULL, NULL, NULL, NULL, 'THREE PRIME REPAIR EXONUCLEASE 1, 2', NULL, NULL, 27934, 8),
(249943, NULL, 'PTHR19981', NULL, NULL, NULL, NULL, 'TALIN', NULL, NULL, NULL, 8),
(249944, NULL, 'PTHR12298', NULL, NULL, NULL, NULL, 'PCDC2  PROGRAMMED CELL DEATH PROTEIN 2 -RELATED', NULL, NULL, NULL, 8),
(249945, NULL, 'PTHR45496', NULL, NULL, NULL, NULL, 'CHAPERONE DNAJ-DOMAIN SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(249946, NULL, 'PTHR21493', NULL, NULL, NULL, NULL, 'CGI-141-RELATED/LIPASE CONTAINING PROTEIN', NULL, NULL, 36686, 8),
(249947, NULL, 'PTHR13527', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 32689, 8),
(249948, NULL, 'PTHR33121', NULL, NULL, NULL, NULL, 'CYCLIC DI-GMP PHOSPHODIESTERASE PDEF', NULL, NULL, NULL, 8),
(249949, NULL, 'PTHR30298', NULL, NULL, NULL, NULL, 'H REPEAT-ASSOCIATED PREDICTED TRANSPOSASE', NULL, NULL, NULL, 8),
(249950, NULL, 'PTHR46581', NULL, NULL, NULL, NULL, 'ARABINOSYLTRANSFERASE RRA3', NULL, NULL, 34357, 8),
(249951, NULL, 'PTHR33254', NULL, NULL, NULL, NULL, '4-HYDROXY-4-METHYL-2-OXOGLUTARATE ALDOLASE 3-RELATED', NULL, NULL, NULL, 8),
(249952, NULL, 'PTHR31872', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 179', NULL, NULL, 24273, 8),
(249953, NULL, 'PTHR34996', NULL, NULL, NULL, NULL, 'OS06G0327400 PROTEIN', NULL, NULL, NULL, 8),
(249954, NULL, 'PTHR45636', NULL, NULL, NULL, NULL, 'PAIRED BOX PROTEIN PAX-6-RELATED-RELATED', NULL, NULL, 36205, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(249955, NULL, 'PTHR44040', NULL, NULL, NULL, NULL, 'RETINOBLASTOMA-BINDING PROTEIN 5', NULL, NULL, 33021, 8),
(249956, NULL, 'PTHR46917', NULL, NULL, NULL, NULL, 'MORN REPEAT-CONTAINING PROTEIN 2', NULL, NULL, NULL, 8),
(249957, NULL, 'PTHR47296', NULL, NULL, NULL, NULL, 'PROTEIN TIC 40, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(249958, NULL, 'PTHR43602', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(249959, NULL, 'PTHR46521', NULL, NULL, NULL, NULL, 'SUCROSE-PHOSPHATASE 2-RELATED', NULL, NULL, NULL, 8),
(249960, NULL, 'PTHR47504', NULL, NULL, NULL, NULL, 'RIGHT ORIGIN-BINDING PROTEIN', NULL, NULL, NULL, 8),
(249961, NULL, 'PTHR13366', NULL, NULL, NULL, NULL, 'MALARIA ANTIGEN-RELATED', NULL, NULL, NULL, 8),
(249962, NULL, 'PTHR22954', NULL, NULL, NULL, NULL, 'RETROVIRAL PROTEASE-RELATED', NULL, NULL, NULL, 8),
(249963, NULL, 'PTHR15260', NULL, NULL, NULL, NULL, 'SARCOSPAN', NULL, NULL, 25075, 8),
(249964, NULL, 'PTHR38502', NULL, NULL, NULL, NULL, 'OVEREXPRESSED IN COLON CARCINOMA 1 PROTEIN', NULL, NULL, 23861, 8),
(249965, NULL, 'PTHR35751', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(249966, NULL, 'PTHR15241', NULL, NULL, NULL, NULL, 'TRANSFORMER-2-RELATED', NULL, NULL, NULL, 8),
(249967, NULL, 'PTHR31413', NULL, NULL, NULL, NULL, 'AFP HOMOLOG 2', NULL, NULL, 24331, 8),
(249968, NULL, 'PTHR37205', NULL, NULL, NULL, NULL, 'F23A5.30 PROTEIN', NULL, NULL, 32691, 8),
(249969, NULL, 'PTHR12371', NULL, NULL, NULL, NULL, 'TRANSLOCATION ASSOCIATED MEMBRANE PROTEIN', NULL, NULL, 15207, 8),
(249970, NULL, 'PTHR47811', NULL, NULL, NULL, NULL, 'TRNA PSEUDOURIDINE SYNTHASE D', NULL, NULL, NULL, 8),
(249971, NULL, 'PTHR38701', NULL, NULL, NULL, NULL, 'CHROMOSOME 8, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(249972, NULL, 'PTHR23339', NULL, NULL, NULL, NULL, 'TYROSINE SPECIFIC PROTEIN PHOSPHATASE AND DUAL SPECIFICITY PROTEIN PHOSPHATASE', NULL, NULL, NULL, 8),
(249973, NULL, 'PTHR43963', NULL, NULL, NULL, NULL, 'CARBONYL REDUCTASE 1-RELATED', NULL, NULL, NULL, 8),
(249974, NULL, 'PTHR10889', NULL, NULL, NULL, NULL, 'DEOXYRIBOSE-PHOSPHATE ALDOLASE', NULL, NULL, 8631, 8),
(249975, NULL, 'PTHR36795', NULL, NULL, NULL, NULL, 'OS01G0938400 PROTEIN', NULL, NULL, NULL, 8),
(249976, NULL, 'PTHR43202', NULL, NULL, NULL, NULL, 'NICOTINATE-NUCLEOTIDE PYROPHOSPHORYLASE', NULL, NULL, NULL, 8),
(249977, NULL, 'PTHR46227', NULL, NULL, NULL, NULL, 'GLUTAMATE RECEPTOR-INTERACTING PROTEIN GRIP', NULL, NULL, 35635, 8),
(249978, NULL, 'PTHR45959', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTION FACTOR', NULL, NULL, NULL, 8),
(249979, NULL, 'PTHR15537', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 7', NULL, NULL, NULL, 8),
(249980, NULL, 'PTHR31547', NULL, NULL, NULL, NULL, 'MULTIVESICULAR BODY SUBUNIT 12B', NULL, NULL, 27847, 8),
(249981, NULL, 'PTHR23014', NULL, NULL, NULL, NULL, 'F-BOX A PROTEIN', NULL, NULL, NULL, 8),
(249982, NULL, 'PTHR13866', NULL, NULL, NULL, NULL, 'SPARC  OSTEONECTIN', NULL, NULL, NULL, 8),
(249983, NULL, 'PTHR39319', NULL, NULL, NULL, NULL, 'SI:DKEY-256H2.1', NULL, NULL, NULL, 8),
(249984, NULL, 'PTHR14682', NULL, NULL, NULL, NULL, 'KATNB1-LIKE PROTEIN 1', NULL, NULL, 36863, 8),
(249985, NULL, 'PTHR33510', NULL, NULL, NULL, NULL, 'PROTEIN TIC 20-II, CHLOROPLASTIC', NULL, NULL, 3928, 8),
(249986, NULL, 'PTHR23241', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT  PLANTS  LEA-RELATED', NULL, NULL, NULL, 8),
(249987, NULL, 'PTHR28196', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN NET1-RELATED', NULL, NULL, 34783, 8),
(249988, NULL, 'PTHR42736', NULL, NULL, NULL, NULL, 'PROTEIN-GLUTAMINE GAMMA-GLUTAMYLTRANSFERASE', NULL, NULL, NULL, 8),
(249989, NULL, 'PTHR30185', NULL, NULL, NULL, NULL, 'CRYPTIC BETA-GLUCOSIDE BGL OPERON ANTITERMINATOR', NULL, NULL, NULL, 8),
(249990, NULL, 'PTHR22771', NULL, NULL, NULL, NULL, 'CULLIN AND GALACTOSE-BINDING DOMAIN-CONTAINING', NULL, NULL, NULL, 8),
(249991, NULL, 'PTHR36801', NULL, NULL, NULL, NULL, 'OS06G0150200 PROTEIN', NULL, NULL, NULL, 8),
(249992, NULL, 'PTHR33375', NULL, NULL, NULL, NULL, 'CHROMOSOME-PARTITIONING PROTEIN PARB-RELATED', NULL, NULL, NULL, 8);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(249993, NULL, 'PTHR10528', NULL, NULL, NULL, NULL, 'AF4/FMR2 FAMILY MEMBER', NULL, NULL, 2467, 8),
(249994, NULL, 'PTHR16476', NULL, NULL, NULL, NULL, 'FAMILY WITH SEQUENCE SIMILARITY 216 MEMBER A', NULL, NULL, 26216, 8),
(249995, NULL, 'PTHR14731', NULL, NULL, NULL, NULL, 'BRAIN AND ACUTE LEUKEMIA CYTOPLASMIC PROTEIN', NULL, NULL, 12036, 8),
(249996, NULL, 'PTHR41151', NULL, NULL, NULL, NULL, 'PARTNER OF BURSICON', NULL, NULL, 6930, 8),
(249997, NULL, 'PTHR34270', NULL, NULL, NULL, NULL, 'PROTEIN RALF-LIKE 15-RELATED', NULL, NULL, NULL, 8),
(249998, NULL, 'PTHR37437', NULL, NULL, NULL, NULL, 'LIPOCALIN-RELATED PROTEIN-RELATED', NULL, NULL, NULL, 8),
(249999, NULL, 'PTHR44379', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE WITH IRON-SULFUR SUBUNIT', NULL, NULL, NULL, 8),
(250000, NULL, 'PTHR31760', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', NULL, NULL, 1890, 8),
(250001, NULL, 'PTHR28544', NULL, NULL, NULL, NULL, 'PROTEIN FAM45A-RELATED', NULL, NULL, 36840, 8),
(250002, NULL, 'PTHR46507', NULL, NULL, NULL, NULL, 'AFADIN- AND ALPHA-ACTININ-BINDING PROTEIN', NULL, NULL, NULL, 8),
(250003, NULL, 'PTHR13372', NULL, NULL, NULL, NULL, 'GEMININ', NULL, NULL, NULL, 8),
(250004, NULL, 'PTHR37214', NULL, NULL, NULL, NULL, 'CYTOMEGALOVIRUS UL139 PROTEIN', NULL, NULL, NULL, 8),
(250005, NULL, 'PTHR47433', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 17', NULL, NULL, NULL, 8),
(250006, NULL, 'PTHR10663', NULL, NULL, NULL, NULL, 'GUANYL-NUCLEOTIDE EXCHANGE FACTOR', NULL, NULL, NULL, 8),
(250007, NULL, 'PTHR35357', NULL, NULL, NULL, NULL, 'OS02G0537100 PROTEIN', NULL, NULL, NULL, 8),
(250008, NULL, 'PTHR35000', NULL, NULL, NULL, NULL, 'MUCIN MUC17, PUTATIVE-RELATED-RELATED', NULL, NULL, NULL, 8),
(250009, NULL, 'PTHR31779', NULL, NULL, NULL, NULL, '2-NITROPROPANE DIOXYGENASE FAMILY, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G17430)-RELATED', NULL, NULL, NULL, 8),
(250010, NULL, 'PTHR13295', NULL, NULL, NULL, NULL, 'GLUTAMATE CYSTEINE LIGASE REGULATORY SUBUNIT', NULL, NULL, 25412, 8),
(250011, NULL, 'PTHR24202', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MIB2', NULL, NULL, NULL, 8),
(250012, NULL, 'PTHR23421', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE RELATED', NULL, NULL, 4092, 8),
(250013, NULL, 'PTHR15698', NULL, NULL, NULL, NULL, 'PROTEIN CBG15099', NULL, NULL, 35971, 8),
(250014, NULL, 'PTHR34850', NULL, NULL, NULL, NULL, 'PROTEIN CBG21297', NULL, NULL, NULL, 8),
(250015, NULL, 'PTHR47078', NULL, NULL, NULL, NULL, 'CYTOSKELETON-ASSOCIATED PROTEIN 2-LIKE', NULL, NULL, NULL, 8),
(250016, NULL, 'PTHR31585', NULL, NULL, NULL, NULL, 'FOLATE-BIOPTERIN TRANSPORTER 1, CHLOROPLASTIC', NULL, NULL, 27011, 8),
(250017, NULL, 'PTHR11304', NULL, NULL, NULL, NULL, 'EPHRIN', NULL, NULL, 22074, 8),
(250018, NULL, 'PTHR23203', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN', NULL, NULL, 24613, 8),
(250019, NULL, 'PTHR38640', NULL, NULL, NULL, NULL, 'GEO09659P1', NULL, NULL, NULL, 8),
(250020, NULL, 'PTHR47678', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 31', NULL, NULL, NULL, 8),
(250021, NULL, 'PTHR38480', NULL, NULL, NULL, NULL, 'SLR0254 PROTEIN', NULL, NULL, NULL, 8),
(250022, NULL, 'PTHR45715', NULL, NULL, NULL, NULL, 'ATPASE H+-TRANSPORTING V1 SUBUNIT E1A-RELATED', NULL, NULL, 5423, 8),
(250023, NULL, 'PTHR10405', NULL, NULL, NULL, NULL, 'SPINDLIN', NULL, NULL, 1073, 8),
(250024, NULL, 'PTHR34733', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(250025, NULL, 'PTHR10127', NULL, NULL, NULL, NULL, 'DISCOIDIN, CUB, EGF, LAMININ , AND ZINC METALLOPROTEASE DOMAIN CONTAINING', NULL, NULL, NULL, 8),
(250026, NULL, 'PTHR43715', NULL, NULL, NULL, NULL, 'GDP-MANNOSE 4,6-DEHYDRATASE', NULL, NULL, 5537, 8),
(250027, NULL, 'PTHR22714', NULL, NULL, NULL, NULL, 'PROTEIN CBG02446-RELATED', NULL, NULL, 27124, 8),
(250028, NULL, 'PTHR38567', NULL, NULL, NULL, NULL, '', NULL, NULL, 24972, 8),
(250029, NULL, 'PTHR15217', NULL, NULL, NULL, NULL, 'WILMS'' TUMOR 1-ASSOCIATING PROTEIN', NULL, NULL, 33927, 8),
(250030, NULL, 'PTHR34557', NULL, NULL, NULL, NULL, 'PHYTOCHROMOBILIN:FERREDOXIN OXIDOREDUCTASE, CHLOROPLASTIC', NULL, NULL, 13753, 8);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(250031, NULL, 'PTHR33865', NULL, NULL, NULL, NULL, 'PROTEIN FAM183B', NULL, NULL, 26833, 8),
(250032, NULL, 'PTHR34193', NULL, NULL, NULL, NULL, 'OS11G0199801 PROTEIN', NULL, NULL, NULL, 8),
(250033, NULL, 'PTHR41534', NULL, NULL, NULL, NULL, 'BLR3401 PROTEIN', NULL, NULL, 6824, 8),
(250034, NULL, 'PTHR31784', NULL, NULL, NULL, NULL, 'BIOGENESIS OF LYSOSOME-RELATED ORGANELLES COMPLEX 1 SUBUNIT 5', NULL, NULL, 15006, 8),
(250035, NULL, 'PTHR48246', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(250036, NULL, 'PTHR47737', NULL, NULL, NULL, NULL, 'GLYCINE BETAINE/PROLINE BETAINE TRANSPORT SYSTEM PERMEASE PROTEIN PROW', NULL, NULL, NULL, 8),
(250037, NULL, 'PTHR30302', NULL, NULL, NULL, NULL, 'HYDROGENASE 1 MATURATION PROTEASE', NULL, NULL, 3724, 8),
(250038, NULL, 'PTHR10035', NULL, NULL, NULL, NULL, 'T-CELL SURFACE GLYCOPROTEIN CD3 ZETA CHAIN', NULL, NULL, 8287, 8),
(250039, NULL, 'PTHR24150', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND MYND DOMAIN-CONTAINING PROTEIN 2', NULL, NULL, NULL, 8),
(250040, NULL, 'PTHR43478', NULL, NULL, NULL, NULL, 'NA+/H+ ANTIPORTER-RELATED', NULL, NULL, NULL, 8),
(250041, NULL, 'PTHR17630', NULL, NULL, NULL, NULL, 'DIENELACTONE HYDROLASE', NULL, NULL, NULL, 8),
(250042, NULL, 'PTHR34105', NULL, NULL, NULL, NULL, 'PROLINE-, GLUTAMIC ACID- AND LEUCINE-RICH PROTEIN 1', NULL, NULL, NULL, 8),
(250043, NULL, 'PTHR35149', NULL, NULL, NULL, NULL, 'SLL5132 PROTEIN', NULL, NULL, NULL, 8),
(250044, NULL, 'PTHR24381', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', NULL, NULL, NULL, 8),
(250045, NULL, 'PTHR10769', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S28', NULL, NULL, 4886, 8),
(250046, NULL, 'PTHR28656', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 153', NULL, NULL, 33116, 8),
(250047, NULL, 'PTHR11530', NULL, NULL, NULL, NULL, 'D-AMINO ACID OXIDASE', NULL, NULL, 15949, 8),
(250048, NULL, 'PTHR43316', NULL, NULL, NULL, NULL, 'HYDROLASE, HALOACID DELAHOGENASE-RELATED', NULL, NULL, NULL, 8),
(250049, NULL, 'PTHR30474', NULL, NULL, NULL, NULL, 'CELL CYCLE PROTEIN', NULL, NULL, 1243, 8),
(250050, NULL, 'PTHR12750', NULL, NULL, NULL, NULL, 'DIPHOSPHOINOSITOL PENTAKISPHOSPHATE KINASE', NULL, NULL, 32192, 8),
(250051, NULL, 'PTHR16453', NULL, NULL, NULL, NULL, 'WD40 DOMAIN-CONTAINING PROTEIN MIO FAMILY MEMBER', NULL, NULL, 31651, 8),
(250052, NULL, 'PTHR15758', NULL, NULL, NULL, NULL, 'BCL-2-LIKE PROTEIN 13', NULL, NULL, 36879, 8),
(250053, NULL, 'PTHR11945', NULL, NULL, NULL, NULL, 'MADS BOX PROTEIN', NULL, NULL, NULL, 8),
(250054, NULL, 'PTHR31894', NULL, NULL, NULL, NULL, 'UPF0461 PROTEIN C5ORF24', NULL, NULL, 28920, 8),
(250055, NULL, 'PTHR43588', NULL, NULL, NULL, NULL, 'COBALT-PRECORRIN-8 METHYLMUTASE', NULL, NULL, NULL, 8),
(250056, NULL, 'PTHR45807', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE HOPSCOTCH', NULL, NULL, NULL, 8),
(250057, NULL, 'PTHR36741', NULL, NULL, NULL, NULL, 'OS07G0100500 PROTEIN', NULL, NULL, NULL, 8),
(250058, NULL, 'PTHR46977', NULL, NULL, NULL, NULL, 'PROTEIN FREE1', NULL, NULL, 36913, 8),
(250059, NULL, 'PTHR45660', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SETMAR', NULL, NULL, NULL, 8),
(250060, NULL, 'PTHR46434', NULL, NULL, NULL, NULL, 'GENETIC INTERACTOR OF PROHIBITINS 3, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(250061, NULL, 'PTHR28165', NULL, NULL, NULL, NULL, 'NON-CLASSICAL EXPORT PROTEIN 2-RELATED', NULL, NULL, NULL, 8),
(250062, NULL, 'PTHR47817', NULL, NULL, NULL, NULL, 'OS04G0686300 PROTEIN', NULL, NULL, NULL, 8),
(250063, NULL, 'PTHR47442', NULL, NULL, NULL, NULL, 'MYND-TYPE ZINC FINGER PROTEIN MUB1', NULL, NULL, NULL, 8),
(250064, NULL, 'PTHR45188', NULL, NULL, NULL, NULL, 'DNAJ PROTEIN P58IPK HOMOLOG', NULL, NULL, 36466, 8),
(250065, NULL, 'PTHR47353', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE PROTEIN HCF164, CHLOROPLASTIC', NULL, NULL, 34608, 8),
(250066, NULL, 'PTHR13533', NULL, NULL, NULL, NULL, 'N-ACETYLNEURAMINATE 9-O-ACETYLTRANSFERASE', NULL, NULL, NULL, 8),
(250067, NULL, 'PTHR40744', NULL, NULL, NULL, NULL, 'SODIUM STIBOGLUCONATE RESISTANCE PROTEIN-RELATED', NULL, NULL, NULL, 8);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(250068, NULL, 'PTHR11771', NULL, NULL, NULL, NULL, 'LIPOXYGENASE', NULL, NULL, 4106, 8),
(250069, NULL, 'PTHR38624', NULL, NULL, NULL, NULL, 'PROTEIN CBG08397-RELATED', NULL, NULL, NULL, 8),
(250070, NULL, 'PTHR38793', NULL, NULL, NULL, NULL, 'SLATT_FUNGAL DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(250071, NULL, 'PTHR36753', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(250072, NULL, 'PTHR34299', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE', NULL, NULL, 4561, 8),
(250073, NULL, 'PTHR23353', NULL, NULL, NULL, NULL, 'RAB-GAP/TBC-RELATED', NULL, NULL, NULL, 8),
(250074, NULL, 'PTHR31727', NULL, NULL, NULL, NULL, 'OLEOYL-ACYL CARRIER PROTEIN THIOESTERASE 1, CHLOROPLASTIC', NULL, NULL, 35810, 8),
(250075, NULL, 'PTHR43060', NULL, NULL, NULL, NULL, '3-HYDROXYISOBUTYRATE DEHYDROGENASE-LIKE 1, MITOCHONDRIAL-RELATED', NULL, NULL, NULL, 8),
(250076, NULL, 'PTHR14207', NULL, NULL, NULL, NULL, 'STEROL ISOMERASE', NULL, NULL, 3334, 8),
(250077, NULL, 'PTHR14662', NULL, NULL, NULL, NULL, 'PARTNER AND LOCALIZER OF BRCA2', NULL, NULL, 34607, 8),
(250078, NULL, 'PTHR15111', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II SUBUNIT 5-MEDIATING PROTEIN  NNX3', NULL, NULL, NULL, 8),
(250079, NULL, 'PTHR33233', NULL, NULL, NULL, NULL, 'ENDONUCLEASE/EXONUCLEASE/PHOSPHATASE', NULL, NULL, NULL, 8),
(250080, NULL, 'PTHR11211', NULL, NULL, NULL, NULL, 'IROQUOIS-CLASS HOMEODOMAIN PROTEIN IRX', NULL, NULL, NULL, 8),
(250081, NULL, 'PTHR48036', NULL, NULL, NULL, NULL, 'SPLICING FACTOR (PAD-1), PUTATIVE (AFU_ORTHOLOGUE AFUA_1G15810)-RELATED', NULL, NULL, NULL, 8),
(250082, NULL, 'PTHR15405', NULL, NULL, NULL, NULL, 'PROLINE-RICH NUCLEAR RECEPTOR COACTIVATOR', NULL, NULL, 25523, 8),
(250083, NULL, 'PTHR38366', NULL, NULL, NULL, NULL, 'NAD-DEPENDENT PROTEIN DEACETYLASE HST1-LIKE PROTEIN', NULL, NULL, 36518, 8),
(250084, NULL, 'PTHR14403', NULL, NULL, NULL, NULL, 'RFAMIDE PEPTIDE GONADOTROPIN INHIBITORY HORMONE', NULL, NULL, 22025, 8),
(250085, NULL, 'PTHR46186', NULL, NULL, NULL, NULL, 'CYSTATIN', NULL, NULL, NULL, 8),
(250086, NULL, 'PTHR31072', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TCP4-RELATED', NULL, NULL, 5709, 8),
(250087, NULL, 'PTHR15323', NULL, NULL, NULL, NULL, 'D123 PROTEIN', NULL, NULL, 12802, 8),
(250088, NULL, 'PTHR43527', NULL, NULL, NULL, NULL, '4-DIPHOSPHOCYTIDYL-2-C-METHYL-D-ERYTHRITOL KINASE, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(250089, NULL, 'PTHR30178', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YAAH', NULL, NULL, NULL, 8),
(250090, NULL, 'PTHR35126', NULL, NULL, NULL, NULL, 'SLR0598 PROTEIN', NULL, NULL, 18452, 8),
(250091, NULL, 'PTHR43716', NULL, NULL, NULL, NULL, 'D-2-HYDROXYGLUTARATE DEHYDROGENASE, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(250092, NULL, 'PTHR45650', NULL, NULL, NULL, NULL, 'GDSL-LIKE LIPASE/ACYLHYDROLASE-RELATED', NULL, NULL, NULL, 8),
(250093, NULL, 'PTHR40124', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(250094, NULL, 'PTHR47951', NULL, NULL, NULL, NULL, 'OS08G0547900 PROTEIN', NULL, NULL, NULL, 8),
(250095, NULL, 'PTHR47454', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 224', NULL, NULL, NULL, 8),
(250096, NULL, 'PTHR35102', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE', NULL, NULL, NULL, 8),
(250097, NULL, 'PTHR21039', NULL, NULL, NULL, NULL, 'HISTIDINOL PHOSPHATASE-RELATED', NULL, NULL, 10994, 8),
(250098, NULL, 'PTHR37932', NULL, NULL, NULL, NULL, 'SMALL LYSINE-RICH PROTEIN 1', NULL, NULL, 32348, 8),
(250099, NULL, 'PTHR42679', NULL, NULL, NULL, NULL, 'S-METHYL-5''-THIOADENOSINE PHOSPHORYLASE', NULL, NULL, 5106, 8),
(250100, NULL, 'PTHR42800', NULL, NULL, NULL, NULL, 'EXOINULINASE INUD (AFU_ORTHOLOGUE AFUA_5G00480)', NULL, NULL, NULL, 8),
(250101, NULL, 'PTHR46334', NULL, NULL, NULL, NULL, 'COSTARS FAMILY PROTEIN ABRACL', NULL, NULL, 36049, 8),
(250102, NULL, 'PTHR15362', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL SYNTHASE', NULL, NULL, NULL, 8),
(250103, NULL, 'PTHR10314', NULL, NULL, NULL, NULL, 'CYSTATHIONINE BETA-SYNTHASE', NULL, NULL, NULL, 8),
(250104, NULL, 'PTHR10759', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L34', NULL, NULL, 7305, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(250105, NULL, 'PTHR37706', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(250106, NULL, 'PTHR47656', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN MIXL', NULL, NULL, 34053, 8),
(250107, NULL, 'PTHR30303', NULL, NULL, NULL, NULL, 'HYDROGENASE ISOENZYMES FORMATION PROTEIN HYPE', NULL, NULL, 13712, 8),
(250108, NULL, 'PTHR47383', NULL, NULL, NULL, NULL, 'OS03G0659800 PROTEIN', NULL, NULL, NULL, 8),
(250109, NULL, 'PTHR10784', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 6', NULL, NULL, 4654, 8),
(250110, NULL, 'PTHR36723', NULL, NULL, NULL, NULL, 'F22C12.19', NULL, NULL, NULL, 8),
(250111, NULL, 'PTHR33889', NULL, NULL, NULL, NULL, 'OS04G0681850 PROTEIN', NULL, NULL, NULL, 8),
(250112, NULL, 'PTHR33130', NULL, NULL, NULL, NULL, 'PUTATIVE (DUF1639)-RELATED', NULL, NULL, NULL, 8),
(250113, NULL, 'PTHR39585', NULL, NULL, NULL, NULL, 'FAD ASSEMBLY FACTOR SDHE', NULL, NULL, NULL, 8),
(250114, NULL, 'PTHR15948', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 89-RELATED', NULL, NULL, 17598, 8),
(250115, NULL, 'PTHR42746', NULL, NULL, NULL, NULL, 'DIADENOSINE 5'',5''''''-P1,P4-TETRAPHOSPHATE PHOSPHORYLASE', NULL, NULL, NULL, 8),
(250116, NULL, 'PTHR11850', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN TRANSCRIPTION FACTORS', NULL, NULL, NULL, 8),
(250117, NULL, 'PTHR13340', NULL, NULL, NULL, NULL, 'GATA ZINC FINGER DOMAIN-CONTAINING', NULL, NULL, 32921, 8),
(250118, NULL, 'PTHR36708', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE SUBUNIT 6, MITOCHONDRIAL', NULL, NULL, 4077, 8),
(250119, NULL, 'PTHR42911', NULL, NULL, NULL, NULL, 'MODULATOR OF FTSH PROTEASE HFLC', NULL, NULL, NULL, 8),
(250120, NULL, 'PTHR46884', NULL, NULL, NULL, NULL, 'COLLECTRIN', NULL, NULL, 35544, 8),
(250121, NULL, 'PTHR15692', NULL, NULL, NULL, NULL, 'MASTERMIND-LIKE', NULL, NULL, 36865, 8),
(250122, NULL, 'PTHR20843', NULL, NULL, NULL, NULL, 'STERILE ALPHA MOTIF DOMAIN CONTAINING PROTEIN 10', NULL, NULL, NULL, 8),
(250123, NULL, 'PTHR13269', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 16806, 8),
(250124, NULL, 'PTHR35771', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(250125, NULL, 'PTHR47549', NULL, NULL, NULL, NULL, 'GOLGI APPARATUS MEMBRANE PROTEIN TVP38-RELATED', NULL, NULL, NULL, 8),
(250126, NULL, 'PTHR47018', NULL, NULL, NULL, NULL, 'CXC DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(250127, NULL, 'PTHR11890', NULL, NULL, NULL, NULL, 'INTERLEUKIN-1 RECEPTOR FAMILY MEMBER', NULL, NULL, 17447, 8),
(250128, NULL, 'PTHR23412', NULL, NULL, NULL, NULL, 'STEREOCILIN RELATED', NULL, NULL, 23805, 8),
(250129, NULL, 'PTHR28644', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 15', NULL, NULL, 23685, 8),
(250130, NULL, 'PTHR13439', NULL, NULL, NULL, NULL, 'CT120 PROTEIN', NULL, NULL, NULL, 8),
(250131, NULL, 'PTHR10701', NULL, NULL, NULL, NULL, 'SMALL NUCLEAR RIBONUCLEOPROTEIN-ASSOCIATED PROTEIN B AND N', NULL, NULL, NULL, 8),
(250132, NULL, 'PTHR15146', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN GPR137', NULL, NULL, 24962, 8),
(250133, NULL, 'PTHR20913', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 20/GTPASE', NULL, NULL, 37514, 8),
(250134, NULL, 'PTHR11652', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S12 FAMILY MEMBER', NULL, NULL, 1086, 8),
(250135, NULL, 'PTHR23185', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 21790, 8),
(250136, NULL, 'PTHR47644', NULL, NULL, NULL, NULL, 'AGAP008221-PA', NULL, NULL, NULL, 8),
(250137, NULL, 'PTHR43369', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLGLYCINAMIDE FORMYLTRANSFERASE', NULL, NULL, NULL, 8),
(250138, NULL, 'PTHR42823', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT A, CHLOROPLASTIC', NULL, NULL, 33929, 8),
(250139, NULL, 'PTHR23295', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR COACTIVATOR 5-RELATED', NULL, NULL, NULL, 8),
(250140, NULL, 'PTHR21329', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL N-ACETYLGLUCOSAMINYLTRANSFERASE SUBUNIT Q-RELATED', NULL, NULL, 1321, 8),
(250141, NULL, 'PTHR11599', NULL, NULL, NULL, NULL, 'PROTEASOME SUBUNIT ALPHA/BETA', NULL, NULL, NULL, 8);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(250142, NULL, 'PTHR37186', NULL, NULL, NULL, NULL, 'OS06G0524500 PROTEIN', NULL, NULL, NULL, 8),
(250143, NULL, 'PTHR40855', NULL, NULL, NULL, NULL, 'DIOX_N DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(250144, NULL, 'PTHR48154', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(250145, NULL, 'PTHR48237', NULL, NULL, NULL, NULL, 'GAMMA-TUBULIN COMPLEX COMPONENT', NULL, NULL, NULL, 8),
(250146, NULL, 'PTHR13664', NULL, NULL, NULL, NULL, 'BECLIN 1-ASSOCIATED AUTOPHAGY-RELATED KEY REGULATOR', NULL, NULL, NULL, 8),
(250147, NULL, 'PTHR42779', NULL, NULL, NULL, NULL, 'PROTEIN YNJB', NULL, NULL, NULL, 8),
(250148, NULL, 'PTHR47735', NULL, NULL, NULL, NULL, 'POTASSIUM VOLTAGE-GATED CHANNEL SUBFAMILY KQT MEMBER 4', NULL, NULL, NULL, 8),
(250149, NULL, 'PTHR46777', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 13', NULL, NULL, 36140, 8),
(250150, NULL, 'PTHR28230', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, 31244, 8),
(250151, NULL, 'PTHR33358', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN WITH A DOMAIN PROTEIN', NULL, NULL, 22912, 8),
(250152, NULL, 'PTHR40034', NULL, NULL, NULL, NULL, 'BSL5891 PROTEIN', NULL, NULL, 19488, 8),
(250153, NULL, 'PTHR12149', NULL, NULL, NULL, NULL, 'FRUCTOSAMINE 3 KINASE-RELATED PROTEIN', NULL, NULL, 15430, 8),
(250154, NULL, 'PTHR15818', NULL, NULL, NULL, NULL, 'G PATCH AND KOW-CONTAINING', NULL, NULL, 34150, 8),
(250155, NULL, 'PTHR45894', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN 8A', NULL, NULL, 6153, 8),
(250156, NULL, 'PTHR12215', NULL, NULL, NULL, NULL, 'PHOSPHOPANTETHEINE TRANSFERASE', NULL, NULL, NULL, 8),
(250157, NULL, 'PTHR45943', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MYCBP2', NULL, NULL, NULL, 8),
(250158, NULL, 'PTHR46915', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE PROTEASE 4-RELATED', NULL, NULL, NULL, 8),
(250159, NULL, 'PTHR21230', NULL, NULL, NULL, NULL, 'VESICLE TRANSPORT V-SNARE PROTEIN VTI1-RELATED', NULL, NULL, NULL, 8),
(250160, NULL, 'PTHR47211', NULL, NULL, NULL, NULL, 'TRIHELIX TRANSCRIPTION FACTOR ASR3', NULL, NULL, NULL, 8),
(250161, NULL, 'PTHR42084', NULL, NULL, NULL, NULL, 'YALI0E26631P', NULL, NULL, NULL, 8),
(250162, NULL, 'PTHR39600', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(250163, NULL, 'PTHR32361', NULL, NULL, NULL, NULL, 'FERRIC/CUPRIC REDUCTASE TRANSMEMBRANE COMPONENT', NULL, NULL, NULL, 8),
(250164, NULL, 'PTHR15555', NULL, NULL, NULL, NULL, 'ZINC FINGER HIT DOMAIN CONTAINING PROTEIN 2  PROTEIN FON -RELATED', NULL, NULL, 27169, 8),
(250165, NULL, 'PTHR37326', NULL, NULL, NULL, NULL, 'BLL3975 PROTEIN', NULL, NULL, NULL, 8),
(250166, NULL, 'PTHR47626', NULL, NULL, NULL, NULL, 'STERILE ALPHA MOTIF (SAM) DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(250167, NULL, 'PTHR22826', NULL, NULL, NULL, NULL, 'RHO GUANINE EXCHANGE FACTOR-RELATED', NULL, NULL, NULL, 8),
(250168, NULL, 'PTHR45787', NULL, NULL, NULL, NULL, 'LD11652P', NULL, NULL, NULL, 8),
(250169, NULL, 'PTHR36350', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(250170, NULL, 'PTHR36940', NULL, NULL, NULL, NULL, 'PROTEIN CBG20338', NULL, NULL, NULL, 8),
(250171, NULL, 'PTHR16100', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE-INTERACTING PROTEIN FAMILY MEMBER', NULL, NULL, NULL, 8),
(250172, NULL, 'PTHR35186', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(250173, NULL, 'PTHR28620', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN V', NULL, NULL, NULL, 8),
(250174, NULL, 'PTHR45832', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SAMKA-RELATED-RELATED', NULL, NULL, NULL, 8),
(250175, NULL, 'PTHR23237', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN FAMILY A MEMBER 1  SNORNP PROTEIN GAR1', NULL, NULL, NULL, 8),
(250176, NULL, 'PTHR11232', NULL, NULL, NULL, NULL, 'PHOSPHOTYROSINE INTERACTION DOMAIN-CONTAINING FAMILY MEMBER', NULL, NULL, NULL, 8),
(250177, NULL, 'PTHR46607', NULL, NULL, NULL, NULL, 'SEC14 DOMAIN AND SPECTRIN REPEAT-CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(250178, NULL, 'PTHR21428', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 7', NULL, NULL, 13998, 8);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(250179, NULL, 'PTHR17575', NULL, NULL, NULL, NULL, 'UROCORTIN-2 AND 3', NULL, NULL, 8734, 8),
(250180, NULL, 'PTHR31247', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 198 FAMILY MEMBER', NULL, NULL, 27770, 8),
(250181, NULL, 'PTHR46028', NULL, NULL, NULL, NULL, 'KYNURENINE 3-MONOOXYGENASE', NULL, NULL, NULL, 8),
(250182, NULL, 'PTHR46566', NULL, NULL, NULL, NULL, '1-PHOSPHOFRUCTOKINASE-RELATED', NULL, NULL, NULL, 8),
(250183, NULL, 'PTHR42197', NULL, NULL, NULL, NULL, 'TRNA (CYTIDINE(56)-2''-O)-METHYLTRANSFERASE', NULL, NULL, 5635, 8),
(250184, NULL, 'PTHR42858', NULL, NULL, NULL, NULL, 'AMINOTRANSFERASE', NULL, NULL, NULL, 8),
(250185, NULL, 'PTHR15444', NULL, NULL, NULL, NULL, 'SECRETED PHOSPHOPROTEIN 24', NULL, NULL, 11826, 8),
(250186, NULL, 'PTHR36110', NULL, NULL, NULL, NULL, 'RING-CLEAVING DIOXYGENASE MHQE-RELATED', NULL, NULL, NULL, 8),
(250187, NULL, 'PTHR10606', NULL, NULL, NULL, NULL, '6-PHOSPHOFRUCTO-2-KINASE/FRUCTOSE-2,6-BISPHOSPHATASE', NULL, NULL, 982, 8),
(250188, NULL, 'PTHR43240', NULL, NULL, NULL, NULL, '1,4-DIHYDROXY-2-NAPHTHOYL-COA THIOESTERASE 1', NULL, NULL, NULL, 8),
(250189, NULL, 'PTHR10560', NULL, NULL, NULL, NULL, 'THROMBOPOIETIN', NULL, NULL, 7410, 8),
(250190, NULL, 'PTHR14418', NULL, NULL, NULL, NULL, 'CONDENSIN COMPLEX SUBUNIT 3-RELATED', NULL, NULL, 24564, 8),
(250191, NULL, 'PTHR21255', NULL, NULL, NULL, NULL, 'T-COMPLEX-ASSOCIATED-TESTIS-EXPRESSED 1/ DYNEIN LIGHT CHAIN', NULL, NULL, 5675, 8),
(250192, NULL, 'PTHR11841', NULL, NULL, NULL, NULL, 'REELIN', NULL, NULL, 18981, 8),
(250193, NULL, 'PTHR38110', NULL, NULL, NULL, NULL, 'CHROMOSOME 23, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(250194, NULL, 'PTHR15857', NULL, NULL, NULL, NULL, 'COMM DOMAIN CONTAINING PROTEIN 2', NULL, NULL, 29023, 8),
(250195, NULL, 'PTHR21266', NULL, NULL, NULL, NULL, 'IRON-SULFUR DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(250196, NULL, 'PTHR10223', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 4', NULL, NULL, NULL, 8),
(250197, NULL, 'PTHR28087', NULL, NULL, NULL, NULL, 'ATPASE SYNTHESIS PROTEIN 25, MITOCHONDRIAL', NULL, NULL, 30096, 8),
(250198, NULL, 'PTHR42756', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, MARR', NULL, NULL, NULL, 8),
(250199, NULL, 'PTHR12999', NULL, NULL, NULL, NULL, 'ZINC FINGER RAN-BINDING DOMAIN-CONTAINING PROTEIN 2 ZRANB2-RELATED', NULL, NULL, NULL, 8),
(250200, NULL, 'PTHR12867', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE-RELATED', NULL, NULL, 28354, 8),
(250201, NULL, 'PTHR24361', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED KINASE KINASE KINASE', NULL, NULL, NULL, 8),
(250202, NULL, 'PTHR47755', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN FTSX', NULL, NULL, 1910, 8),
(250203, NULL, 'PTHR10978', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE CYTOCHROME B560 SUBUNIT', NULL, NULL, 9540, 8),
(250204, NULL, 'PTHR35347', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 175', NULL, NULL, 32113, 8),
(250205, NULL, 'PTHR38106', NULL, NULL, NULL, NULL, 'RNA CHAPERONE PROQ', NULL, NULL, 16514, 8),
(250206, NULL, 'PTHR48033', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', NULL, NULL, NULL, 8),
(250207, NULL, 'PTHR31911', NULL, NULL, NULL, NULL, 'PROTEIN FAM133', NULL, NULL, 24185, 8),
(250208, NULL, 'PTHR24086', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR SUBFAMILY 5 GROUP A', NULL, NULL, 20299, 8),
(250209, NULL, 'PTHR31463', NULL, NULL, NULL, NULL, 'MACROPHAGE-EXPRESSED GENE 1 PROTEIN', NULL, NULL, 28334, 8),
(250210, NULL, 'PTHR10333', NULL, NULL, NULL, NULL, 'INHIBITOR OF GROWTH PROTEIN', NULL, NULL, 22130, 8),
(250211, NULL, 'PTHR20902', NULL, NULL, NULL, NULL, '41-2 PROTEIN ANTIGEN-RELATED', NULL, NULL, 20363, 8),
(250212, NULL, 'PTHR37962', NULL, NULL, NULL, NULL, 'MALE STERILE (3) 76CA', NULL, NULL, NULL, 8),
(250213, NULL, 'PTHR38467', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(250214, NULL, 'PTHR31742', NULL, NULL, NULL, NULL, 'RPA-INTERACTING PROTEIN RPAIN', NULL, NULL, 23711, 8),
(250215, NULL, 'PTHR45036', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE LIKE 7B', NULL, NULL, NULL, 8);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(250216, NULL, 'PTHR31485', NULL, NULL, NULL, NULL, 'PEPTIDYL SERINE ALPHA-GALACTOSYLTRANSFERASE', NULL, NULL, 35790, 8),
(250217, NULL, 'PTHR33650', NULL, NULL, NULL, NULL, 'CHLOROPLAST ENVELOPE MEMBRANE PROTEIN-RELATED', NULL, NULL, 4549, 8),
(250218, NULL, 'PTHR15977', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 46', NULL, NULL, 33391, 8),
(250219, NULL, 'PTHR40255', NULL, NULL, NULL, NULL, 'UPF0093 MEMBRANE PROTEIN SLR1790', NULL, NULL, 4201, 8),
(250220, NULL, 'PTHR19853', NULL, NULL, NULL, NULL, 'WD REPEAT CONTAINING PROTEIN 3  WDR3', NULL, NULL, NULL, 8),
(250221, NULL, 'PTHR28142', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL INNER MEMBRANE I-AAA PROTEASE SUPERCOMPLEX SUBUNIT MGR3-RELATED', NULL, NULL, 31155, 8),
(250222, NULL, 'PTHR33540', NULL, NULL, NULL, NULL, 'TRNA THREONYLCARBAMOYLADENOSINE BIOSYNTHESIS PROTEIN TSAE', NULL, NULL, NULL, 8),
(250223, NULL, 'PTHR47037', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L33, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(250224, NULL, 'PTHR36760', NULL, NULL, NULL, NULL, 'ACIDIC LEUCINE-RICH NUCLEAR PHOSPHOPROTEIN 32 FAMILY B PROTEIN', NULL, NULL, NULL, 8),
(250225, NULL, 'PTHR38760', NULL, NULL, NULL, NULL, 'ADENYLATE CYCLASE', NULL, NULL, 4922, 8),
(250226, NULL, 'PTHR10747', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR COE FAMILY MEMBER', NULL, NULL, 6444, 8),
(250227, NULL, 'PTHR42152', NULL, NULL, NULL, NULL, 'PROTEIN GDF5OS, MITOCHONDRIAL', NULL, NULL, 28203, 8),
(250228, NULL, 'PTHR34582', NULL, NULL, NULL, NULL, 'UPF0702 TRANSMEMBRANE PROTEIN YCAP', NULL, NULL, NULL, 8),
(250229, NULL, 'PTHR47212', NULL, NULL, NULL, NULL, 'ADHESIN-LIKE PROTEIN, PUTATIVE (DUF3741)-RELATED', NULL, NULL, NULL, 8),
(250230, NULL, 'PTHR44196', NULL, NULL, NULL, NULL, 'DEHYDROGENASE/REDUCTASE SDR FAMILY MEMBER 7B', NULL, NULL, NULL, 8),
(250231, NULL, 'PTHR31493', NULL, NULL, NULL, NULL, 'NAZO FAMILY MEMBER', NULL, NULL, 27544, 8),
(250232, NULL, 'PTHR43423', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER I FAMILY MEMBER 17', NULL, NULL, 3728, 8),
(250233, NULL, 'PTHR15868', NULL, NULL, NULL, NULL, 'SIMILAR TO RIKEN CDNA 6430571L13 GENE, SIMILAR TO G20 PROTEIN', NULL, NULL, 34630, 8),
(250234, NULL, 'PTHR10544', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L28', NULL, NULL, 2575, 8),
(250235, NULL, 'PTHR30164', NULL, NULL, NULL, NULL, 'MTFA PEPTIDASE', NULL, NULL, 9412, 8),
(250236, NULL, 'PTHR31471', NULL, NULL, NULL, NULL, 'OS02G0116800 PROTEIN', NULL, NULL, NULL, 8),
(250237, NULL, 'PTHR46946', NULL, NULL, NULL, NULL, 'NEURITE EXTENSION AND MIGRATION FACTOR', NULL, NULL, 34309, 8),
(250238, NULL, 'PTHR35085', NULL, NULL, NULL, NULL, 'KERATINOCYTE DIFFERENTIATION FACTOR 1', NULL, NULL, 23960, 8),
(250239, NULL, 'PTHR47931', NULL, NULL, NULL, NULL, 'OS01G0228400 PROTEIN', NULL, NULL, NULL, 8),
(250240, NULL, 'PTHR15245', NULL, NULL, NULL, NULL, 'SYMPLEKIN-RELATED', NULL, NULL, NULL, 8),
(250241, NULL, 'PTHR28208', NULL, NULL, NULL, NULL, 'PHOSPHATIDATE PHOSPHATASE APP1', NULL, NULL, NULL, 8),
(250242, NULL, 'PTHR22594', NULL, NULL, NULL, NULL, 'ASPARTYL/LYSYL-TRNA SYNTHETASE', NULL, NULL, NULL, 8),
(250243, NULL, 'PTHR36483', NULL, NULL, NULL, NULL, 'OS02G0130700 PROTEIN', NULL, NULL, NULL, 8),
(250244, NULL, 'PTHR10485', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM-17', NULL, NULL, NULL, 8),
(250245, NULL, 'PTHR35617', NULL, NULL, NULL, NULL, 'PHAGE_INTEGRASE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(250246, NULL, 'PTHR38354', NULL, NULL, NULL, NULL, 'SIGNAL PEPTIDASE COMPLEX-LIKE PROTEIN DTM1', NULL, NULL, 31264, 8),
(250247, NULL, 'PTHR32303', NULL, NULL, NULL, NULL, 'QUINOPROTEIN ALCOHOL DEHYDROGENASE (CYTOCHROME C)', NULL, NULL, NULL, 8),
(250248, NULL, 'PTHR46980', NULL, NULL, NULL, NULL, 'TRICALBIN-1-RELATED', NULL, NULL, NULL, 8),
(250249, NULL, 'PTHR35996', NULL, NULL, NULL, NULL, 'OSJNBA0038O10.25 PROTEIN', NULL, NULL, 31904, 8),
(250250, NULL, 'PTHR33927', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(250251, NULL, 'PTHR40465', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(250252, NULL, 'PTHR11723', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN INHIBITOR', NULL, NULL, 23175, 8),
(250253, NULL, 'PTHR33689', NULL, NULL, NULL, NULL, 'FAS-BINDING FACTOR 1', NULL, NULL, 27916, 8),
(250254, NULL, 'PTHR34150', NULL, NULL, NULL, NULL, 'PROTEIN CBG08832-RELATED', NULL, NULL, NULL, 8),
(250255, NULL, 'PTHR34775', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(250256, NULL, 'PTHR10261', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT GAMMA', NULL, NULL, 20053, 8),
(250257, NULL, 'PTHR36782', NULL, NULL, NULL, NULL, 'BNAC03G62080D PROTEIN', NULL, NULL, NULL, 8),
(250258, NULL, 'PTHR13067', NULL, NULL, NULL, NULL, 'CASPASE-ACTIVATED DNASE', NULL, NULL, 27052, 8),
(250259, NULL, 'PTHR34597', NULL, NULL, NULL, NULL, 'SLR1661 PROTEIN', NULL, NULL, NULL, 8),
(250260, NULL, 'PTHR21408', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-ONLY PROTEIN', NULL, NULL, 32877, 8),
(250261, NULL, 'PTHR14588', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 10', NULL, NULL, 32925, 8),
(250262, NULL, 'PTHR30305', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(250263, NULL, 'PTHR31094', NULL, NULL, NULL, NULL, 'RIKEN CDNA 2310061I04 GENE', NULL, NULL, 19056, 8),
(250264, NULL, 'PTHR21027', NULL, NULL, NULL, NULL, 'TRNA-SPLICING ENDONUCLEASE SUBUNIT SEN54', NULL, NULL, 24815, 8),
(250265, NULL, 'PTHR42865', NULL, NULL, NULL, NULL, 'PROTON/GLUTAMATE-ASPARTATE SYMPORTER', NULL, NULL, 2426, 8),
(250266, NULL, 'PTHR36593', NULL, NULL, NULL, NULL, 'EXPORTED SERINE/THREONINE PROTEIN KINASE', NULL, NULL, NULL, 8),
(250267, NULL, 'PTHR32108', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT ALPHA', NULL, NULL, NULL, 8),
(250268, NULL, 'PTHR48108', NULL, NULL, NULL, NULL, 'CBS DOMAIN-CONTAINING PROTEIN CBSX2, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(250269, NULL, 'PTHR38463', NULL, NULL, NULL, NULL, 'STRESS RESPONSE PROTEIN YSNF', NULL, NULL, NULL, 8),
(250270, NULL, 'PTHR46683', NULL, NULL, NULL, NULL, 'OROTATE PHOSPHORIBOSYLTRANSFERASE 1-RELATED', NULL, NULL, NULL, 8),
(250271, NULL, 'PTHR47031', NULL, NULL, NULL, NULL, 'SAP DNA-BINDING DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(250272, NULL, 'PTHR30094', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL GLUTATHIONYLSPERMIDINE SYNTHETASE/AMIDASE-RELATED', NULL, NULL, NULL, 8),
(250273, NULL, 'PTHR16189', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(250274, NULL, 'PTHR47141', NULL, NULL, NULL, NULL, 'CYSTATIN-F', NULL, NULL, 34490, 8),
(250275, NULL, 'PTHR36336', NULL, NULL, NULL, NULL, 'OS09G0560400 PROTEIN', NULL, NULL, NULL, 8),
(250276, NULL, 'PTHR47841', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL KINASE THETA-LIKE-RELATED', NULL, NULL, NULL, 8),
(250277, NULL, 'PTHR45671', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 25 (MITOCHONDRIAL CARRIER PHOSPHATE CARRIER), MEMBER 3, LIKE-RELATED-RELATED', NULL, NULL, 34204, 8),
(250278, NULL, 'PTHR10584', NULL, NULL, NULL, NULL, 'SUGAR KINASE', NULL, NULL, NULL, 8),
(250279, NULL, 'PTHR30419', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR YBHD', NULL, NULL, NULL, 8),
(250280, NULL, 'PTHR20515', NULL, NULL, NULL, NULL, 'BETA-DEFENSIN', NULL, NULL, NULL, 8),
(250281, NULL, 'PTHR18063', NULL, NULL, NULL, NULL, 'NF-E2 INDUCIBLE PROTEIN', NULL, NULL, 10930, 8),
(250282, NULL, 'PTHR46901', NULL, NULL, NULL, NULL, 'GH04942P', NULL, NULL, NULL, 8),
(250283, NULL, 'PTHR37478', NULL, NULL, NULL, NULL, '', NULL, NULL, 5808, 8),
(250284, NULL, 'PTHR24251', NULL, NULL, NULL, NULL, 'OVOCHYMASE-RELATED', NULL, NULL, NULL, 8),
(250285, NULL, 'PTHR36143', NULL, NULL, NULL, NULL, 'OS08G0177500 PROTEIN', NULL, NULL, NULL, 8),
(250286, NULL, 'PTHR40250', NULL, NULL, NULL, NULL, 'CHROMOSOME 11 OPEN READING FRAME 96', NULL, NULL, 26789, 8),
(250287, NULL, 'PTHR46696', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED', NULL, NULL, NULL, 8),
(250288, NULL, 'PTHR37525', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(250289, NULL, 'PTHR22929', NULL, NULL, NULL, NULL, 'RNA POLYMERASE III TRANSCRIPTION INITIATION FACTOR B', NULL, NULL, NULL, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(250290, NULL, 'PTHR12207', NULL, NULL, NULL, NULL, 'V-SET AND TRANSMEMBRANE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(250291, NULL, 'PTHR28020', NULL, NULL, NULL, NULL, 'YAP1-BINDING PROTEIN 1-RELATED', NULL, NULL, 27987, 8),
(250292, NULL, 'PTHR36896', NULL, NULL, NULL, NULL, 'OS01G0729500 PROTEIN', NULL, NULL, NULL, 8),
(250293, NULL, 'PTHR13467', NULL, NULL, NULL, NULL, 'CUE DOMAIN CONTAINING PROTEIN 1', NULL, NULL, 28262, 8),
(250294, NULL, 'PTHR15947', NULL, NULL, NULL, NULL, 'SGRF', NULL, NULL, 11147, 8),
(250295, NULL, 'PTHR31267', NULL, NULL, NULL, NULL, 'DENTIN SIALOPHOSPHOPROTEIN-LIKE PROTEIN', NULL, NULL, NULL, 8),
(250296, NULL, 'PTHR46172', NULL, NULL, NULL, NULL, 'DNA POLYMERASE EPSILON SUBUNIT 3', NULL, NULL, NULL, 8),
(250297, NULL, 'PTHR22951', NULL, NULL, NULL, NULL, 'CLATHRIN ASSEMBLY PROTEIN', NULL, NULL, 34763, 8),
(250298, NULL, 'PTHR30108', NULL, NULL, NULL, NULL, '3-OCTAPRENYL-4-HYDROXYBENZOATE CARBOXY-LYASE-RELATED', NULL, NULL, 5300, 8),
(250299, NULL, 'PTHR37846', NULL, NULL, NULL, NULL, 'YALI0B21296P', NULL, NULL, NULL, 8),
(250300, NULL, 'PTHR13074', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 8', NULL, NULL, 15776, 8),
(250301, NULL, 'PTHR30386', NULL, NULL, NULL, NULL, 'MEMBRANE FUSION SUBUNIT OF EMRAB-TOLC MULTIDRUG EFFLUX PUMP', NULL, NULL, NULL, 8),
(250302, NULL, 'PTHR38128', NULL, NULL, NULL, NULL, 'GAMETOCYTOGENESIS-IMPLICATED PROTEIN', NULL, NULL, NULL, 8),
(250303, NULL, 'PTHR15889', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOMAL PROTEIN L37', NULL, NULL, NULL, 8),
(250304, NULL, 'PTHR45418', NULL, NULL, NULL, NULL, 'CANCER/TESTIS ANTIGEN 55', NULL, NULL, NULL, 8),
(250305, NULL, 'PTHR30468', NULL, NULL, NULL, NULL, 'ALPHA-KETOGLUTARATE-DEPENDENT SULFONATE DIOXYGENASE', NULL, NULL, NULL, 8),
(250306, NULL, 'PTHR15708', NULL, NULL, NULL, NULL, 'ACTIN BUNDLING/MISSING IN METASTASIS-RELATED', NULL, NULL, 21839, 8),
(250307, NULL, 'PTHR35134', NULL, NULL, NULL, NULL, 'NUCLEOTIDASE YQFW-RELATED', NULL, NULL, NULL, 8),
(250308, NULL, 'PTHR13864', NULL, NULL, NULL, NULL, 'T-CELL ACUTE LYMPHOCYTIC LEUKEMIA/STEM CELL LEUKEMIA-RELATED', NULL, NULL, 32104, 8),
(250309, NULL, 'PTHR44981', NULL, NULL, NULL, NULL, 'PERICENTRIN-LIKE PROTEIN, ISOFORM F', NULL, NULL, 26572, 8),
(250310, NULL, 'PTHR23041', NULL, NULL, NULL, NULL, 'RING FINGER DOMAIN-CONTAINING', NULL, NULL, NULL, 8),
(250311, NULL, 'PTHR12113', NULL, NULL, NULL, NULL, 'DICKKOPF3-LIKE 3', NULL, NULL, 27335, 8),
(250312, NULL, 'PTHR47894', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR GADX', NULL, NULL, NULL, 8),
(250313, NULL, 'PTHR31472', NULL, NULL, NULL, NULL, 'OS05G0244600 PROTEIN', NULL, NULL, NULL, 8),
(250314, NULL, 'PTHR23044', NULL, NULL, NULL, NULL, '3''-5'' EXONUCLEASE ERI1-RELATED', NULL, NULL, NULL, 8),
(250315, NULL, 'PTHR47726', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT U, CHLOROPLASTIC', NULL, NULL, 35058, 8),
(250316, NULL, 'PTHR37768', NULL, NULL, NULL, NULL, 'OS06G0694800 PROTEIN', NULL, NULL, NULL, 8),
(250317, NULL, 'PTHR22776', NULL, NULL, NULL, NULL, 'MARVEL-CONTAINING POTENTIAL LIPID RAFT-ASSOCIATED PROTEIN', NULL, NULL, NULL, 8),
(250318, NULL, 'PTHR42839', NULL, NULL, NULL, NULL, 'ISOCHORISMATE SYNTHASE ENTC', NULL, NULL, NULL, 8),
(250319, NULL, 'PTHR43677', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/REDUCTASE', NULL, NULL, NULL, 8),
(250320, NULL, 'PTHR46879', NULL, NULL, NULL, NULL, 'SUSHI DOMAIN-CONTAINING PROTEIN 3', NULL, NULL, NULL, 8),
(250321, NULL, 'PTHR12443', NULL, NULL, NULL, NULL, 'TRANSLOCATION PROTEIN SEC62', NULL, NULL, 3703, 8),
(250322, NULL, 'PTHR47546', NULL, NULL, NULL, NULL, 'S15/NS1, RNA-BINDING PROTEIN', NULL, NULL, NULL, 8),
(250323, NULL, 'PTHR34364', NULL, NULL, NULL, NULL, 'WAS/WASL-INTERACTING FAMILY PROTEIN', NULL, NULL, NULL, 8),
(250324, NULL, 'PTHR47467', NULL, NULL, NULL, NULL, 'OS01G0867200 PROTEIN', NULL, NULL, NULL, 8),
(250325, NULL, 'PTHR13581', NULL, NULL, NULL, NULL, 'MRG-BINDING PROTEIN', NULL, NULL, 13274, 8),
(250326, NULL, 'PTHR35968', NULL, NULL, NULL, NULL, 'CHROMOSOME 6 C6ORF201 HOMOLOG', NULL, NULL, 22307, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(250327, NULL, 'PTHR36408', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(250328, NULL, 'PTHR24068', NULL, NULL, NULL, NULL, 'UBIQUITIN-CONJUGATING ENZYME E2', NULL, NULL, NULL, 8),
(250329, NULL, 'PTHR43801', NULL, NULL, NULL, NULL, 'NUCLEOTIDE-BINDING PROTEIN-RELATED', NULL, NULL, 5464, 8),
(250330, NULL, 'PTHR35381', NULL, NULL, NULL, NULL, 'EF-HAND DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(250331, NULL, 'PTHR31139', NULL, NULL, NULL, NULL, 'ECTOPIC P GRANULES PROTEIN 5 HOMOLOG', NULL, NULL, NULL, 8),
(250332, NULL, 'PTHR42793', NULL, NULL, NULL, NULL, 'COA BINDING DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(250333, NULL, 'PTHR42342', NULL, NULL, NULL, NULL, 'STATIONARY PHASE PROTEIN 5', NULL, NULL, 32575, 8),
(250334, NULL, 'PTHR12969', NULL, NULL, NULL, NULL, 'NGD5/OSM-6/IFT52', NULL, NULL, 31696, 8),
(250335, NULL, 'PTHR34368', NULL, NULL, NULL, NULL, 'OS01G0962200 PROTEIN', NULL, NULL, NULL, 8),
(250336, NULL, 'PTHR23546', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN', NULL, NULL, NULL, 8),
(250337, NULL, 'PTHR15617', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 32640, 8),
(250338, NULL, 'PTHR15175', NULL, NULL, NULL, NULL, 'NEUTROPHIL CYTOSOLIC FACTOR 2, NEUTROPHIL NADPH OXIDASE FACTOR 2', NULL, NULL, NULL, 8),
(250339, NULL, 'PTHR33608', NULL, NULL, NULL, NULL, 'BLL2464 PROTEIN', NULL, NULL, NULL, 8),
(250340, NULL, 'PTHR43576', NULL, NULL, NULL, NULL, 'ALPHA-L-ARABINOFURANOSIDASE C-RELATED', NULL, NULL, NULL, 8),
(250341, NULL, 'PTHR15240', NULL, NULL, NULL, NULL, 'CAVIN', NULL, NULL, 25971, 8),
(250342, NULL, 'PTHR46845', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR I', NULL, NULL, NULL, 8),
(250343, NULL, 'PTHR17388', NULL, NULL, NULL, NULL, 'SECRETOGRANIN III', NULL, NULL, 25410, 8),
(250344, NULL, 'PTHR31357', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS ALPHA-10', NULL, NULL, NULL, 8),
(250345, NULL, 'PTHR43600', NULL, NULL, NULL, NULL, 'COENZYME F420 HYDROGENASE, SUBUNIT ALPHA', NULL, NULL, NULL, 8),
(250346, NULL, 'PTHR35992', NULL, NULL, NULL, NULL, 'CYTOMATRIX PROTEIN-LIKE PROTEIN', NULL, NULL, NULL, 8),
(250347, NULL, 'PTHR43044', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(250348, NULL, 'PTHR38681', NULL, NULL, NULL, NULL, 'RETROVIRUS-RELATED POL POLYPROTEIN FROM TRANSPOSON 412-LIKE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(250349, NULL, 'PTHR46943', NULL, NULL, NULL, NULL, 'PENTRAXIN-RELATED PROTEIN PTX3', NULL, NULL, 34446, 8),
(250350, NULL, 'PTHR11732', NULL, NULL, NULL, NULL, 'ALDO/KETO REDUCTASE', NULL, NULL, NULL, 8),
(250351, NULL, 'PTHR46602', NULL, NULL, NULL, NULL, 'PROTEIN SUPPRESSOR OF GENE SILENCING 3', NULL, NULL, 34260, 8),
(250352, NULL, 'PTHR34427', NULL, NULL, NULL, NULL, 'DUF4283 DOMAIN PROTEIN', NULL, NULL, NULL, 8),
(250353, NULL, 'PTHR47220', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 25', NULL, NULL, 15550, 8),
(250354, NULL, 'PTHR24201', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(250355, NULL, 'PTHR33674', NULL, NULL, NULL, NULL, 'METHIONINE-S-OXIDE REDUCTASE', NULL, NULL, 34504, 8),
(250356, NULL, 'PTHR12997', NULL, NULL, NULL, NULL, 'TYPE I INOSITOL-1,4,5-TRISPHOSPHATE 5-PHOSPHATASE', NULL, NULL, 32482, 8),
(250357, NULL, 'PTHR11024', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN SEC13 / SEH1 FAMILY MEMBER', NULL, NULL, 29617, 8),
(250358, NULL, 'PTHR45331', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE, IRON-SULPHUR BINDING SUBUNIT-RELATED-RELATED', NULL, NULL, NULL, 8),
(250359, NULL, 'PTHR19277', NULL, NULL, NULL, NULL, 'PENTRAXIN', NULL, NULL, NULL, 8),
(250360, NULL, 'PTHR36441', NULL, NULL, NULL, NULL, 'HYPOTHETICAL CYTOSOLIC PROTEIN', NULL, NULL, 3502, 8),
(250361, NULL, 'PTHR12341', NULL, NULL, NULL, NULL, '5''->3'' EXORIBONUCLEASE', NULL, NULL, 24999, 8),
(250362, NULL, 'PTHR37713', NULL, NULL, NULL, NULL, 'OS05G0176600 PROTEIN', NULL, NULL, NULL, 8),
(250363, NULL, 'PTHR10827', NULL, NULL, NULL, NULL, 'RETICULOCALBIN', NULL, NULL, NULL, 8),
(250364, NULL, 'PTHR28388', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 237', NULL, NULL, 24530, 8);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(250365, NULL, 'PTHR16515', NULL, NULL, NULL, NULL, 'PR DOMAIN ZINC FINGER PROTEIN', NULL, NULL, NULL, 8),
(250366, NULL, 'PTHR21676', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 25578, 8),
(250367, NULL, 'PTHR31264', NULL, NULL, NULL, NULL, 'OS07G0554500 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(250368, NULL, 'PTHR37230', NULL, NULL, NULL, NULL, 'OS06G0731300 PROTEIN', NULL, NULL, NULL, 8),
(250369, NULL, 'PTHR11525', NULL, NULL, NULL, NULL, 'FARNESYL-PYROPHOSPHATE SYNTHETASE', NULL, NULL, 27869, 8),
(250370, NULL, 'PTHR47510', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(250371, NULL, 'PTHR28018', NULL, NULL, NULL, NULL, 'RESPIRATORY SUPERCOMPLEX FACTOR 2, MITOCHONDRIAL', NULL, NULL, 30364, 8),
(250372, NULL, 'PTHR34127', NULL, NULL, NULL, NULL, 'OS04G0405600 PROTEIN', NULL, NULL, 10718, 8),
(250373, NULL, 'PTHR39344', NULL, NULL, NULL, NULL, 'UPF0182 PROTEIN SLL1060', NULL, NULL, 6849, 8),
(250374, NULL, 'PTHR17571', NULL, NULL, NULL, NULL, 'URINARY PROTEIN  RUP /ACROSOMAL PROTEIN SP-10', NULL, NULL, NULL, 8),
(250375, NULL, 'PTHR31443', NULL, NULL, NULL, NULL, '', NULL, NULL, 23508, 8),
(250376, NULL, 'PTHR37610', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(250377, NULL, 'PTHR22847', NULL, NULL, NULL, NULL, 'WD40 REPEAT PROTEIN', NULL, NULL, NULL, 8),
(250378, NULL, 'PTHR39648', NULL, NULL, NULL, NULL, '6-HYDROXYMETHYL-7,8-DIHYDROPTERIN PYROPHOSPHOKINASE', NULL, NULL, 23569, 8),
(250379, NULL, 'PTHR43486', NULL, NULL, NULL, NULL, 'LIPID II FLIPPASE MURJ-RELATED', NULL, NULL, NULL, 8),
(250380, NULL, 'PTHR12864', NULL, NULL, NULL, NULL, 'RAN BINDING PROTEIN 9-RELATED', NULL, NULL, NULL, 8),
(250381, NULL, 'PTHR20917', NULL, NULL, NULL, NULL, 'PNAS-RELATED', NULL, NULL, 13183, 8),
(250382, NULL, 'PTHR12560', NULL, NULL, NULL, NULL, 'LONGEVITY ASSURANCE FACTOR 1  LAG1', NULL, NULL, 15446, 8),
(250383, NULL, 'PTHR21268', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(250384, NULL, 'PTHR23103', NULL, NULL, NULL, NULL, 'ALZHEIMER''S DISEASE BETA-AMYLOID RELATED', NULL, NULL, 7454, 8),
(250385, NULL, 'PTHR35997', NULL, NULL, NULL, NULL, 'COTTON FIBER PROTEIN-RELATED', NULL, NULL, NULL, 8),
(250386, NULL, 'PTHR47092', NULL, NULL, NULL, NULL, 'CAT EYE SYNDROME CRITICAL REGION PROTEIN 2', NULL, NULL, 22179, 8),
(250387, NULL, 'PTHR10924', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY PROTEIN-RELATED', NULL, NULL, NULL, 8),
(250388, NULL, 'PTHR31787', NULL, NULL, NULL, NULL, 'G-PROTEIN-COUPLED RECEPTOR  GPCR  FAMILY PROTEIN', NULL, NULL, NULL, 8),
(250389, NULL, 'PTHR15562', NULL, NULL, NULL, NULL, 'TP53-TARGET GENE 5 PROTEIN', NULL, NULL, 24922, 8),
(250390, NULL, 'PTHR21011', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 28S RIBOSOMAL PROTEIN S6', NULL, NULL, 5523, 8),
(250391, NULL, 'PTHR36462', NULL, NULL, NULL, NULL, 'CHROMOSOME 12 OPEN READING FRAME 71', NULL, NULL, 23197, 8),
(250392, NULL, 'PTHR40141', NULL, NULL, NULL, NULL, '3'',5''-CYCLIC-AMP PHOSPHODIESTERASE-RELATED', NULL, NULL, NULL, 8),
(250393, NULL, 'PTHR13072', NULL, NULL, NULL, NULL, 'DYNACTIN 6', NULL, NULL, 25474, 8),
(250394, NULL, 'PTHR24126', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT, PH AND SEC7 DOMAIN CONTAINING PROTEIN SECG-RELATED', NULL, NULL, NULL, 8),
(250395, NULL, 'PTHR46161', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE KINASE', NULL, NULL, NULL, 8),
(250396, NULL, 'PTHR24177', NULL, NULL, NULL, NULL, 'CASKIN', NULL, NULL, NULL, 8),
(250397, NULL, 'PTHR35355', NULL, NULL, NULL, NULL, 'PROTEIN FAM229A', NULL, NULL, 21645, 8),
(250398, NULL, 'PTHR34535', NULL, NULL, NULL, NULL, 'HYDROGENASE MATURATION FACTOR HYPA', NULL, NULL, 6785, 8),
(250399, NULL, 'PTHR37507', NULL, NULL, NULL, NULL, 'SPORULATION PROTEIN YDCC', NULL, NULL, NULL, 8),
(250400, NULL, 'PTHR37182', NULL, NULL, NULL, NULL, 'F24J8.11 PROTEIN', NULL, NULL, NULL, 8),
(250401, NULL, 'PTHR37964', NULL, NULL, NULL, NULL, 'SUPPRESSOR', NULL, NULL, NULL, 8),
(250402, NULL, 'PTHR10915', NULL, NULL, NULL, NULL, 'SYNDECAN', NULL, NULL, 2279, 8);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(250403, NULL, 'PTHR47601', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(250404, NULL, 'PTHR36150', NULL, NULL, NULL, NULL, 'DNA GYRASE INHIBITOR YACG', NULL, NULL, 1829, 8),
(250405, NULL, 'PTHR23046', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLAMINOIMIDAZOLE CARBOXYLASE CATALYTIC SUBUNIT', NULL, NULL, NULL, 8),
(250406, NULL, 'PTHR21008', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 19599, 8),
(250407, NULL, 'PTHR28453', NULL, NULL, NULL, NULL, 'PROTEIN SNORC', NULL, NULL, 24899, 8),
(250408, NULL, 'PTHR47017', NULL, NULL, NULL, NULL, 'ACYL-COA', NULL, NULL, NULL, 8),
(250409, NULL, 'PTHR36492', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(250410, NULL, 'PTHR31834', NULL, NULL, NULL, NULL, 'INITIATION-SPECIFIC ALPHA-1,6-MANNOSYLTRANSFERASE', NULL, NULL, 33055, 8),
(250411, NULL, 'PTHR14537', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE III DOMAIN-CONTAINING PROTEIN 11', NULL, NULL, 33791, 8),
(250412, NULL, 'PTHR14554', NULL, NULL, NULL, NULL, 'GENE, 49416-RELATED', NULL, NULL, 28573, 8),
(250413, NULL, 'PTHR34639', NULL, NULL, NULL, NULL, 'PROTEIN FLATTOP', NULL, NULL, 32085, 8),
(250414, NULL, 'PTHR28598', NULL, NULL, NULL, NULL, 'STAGA COMPLEX 65 SUBUNIT GAMMA', NULL, NULL, 33348, 8),
(250415, NULL, 'PTHR11220', NULL, NULL, NULL, NULL, 'HEME-BINDING PROTEIN-RELATED', NULL, NULL, 4704, 8),
(250416, NULL, 'PTHR11102', NULL, NULL, NULL, NULL, 'SEL-1-LIKE PROTEIN', NULL, NULL, NULL, 8),
(250417, NULL, 'PTHR12645', NULL, NULL, NULL, NULL, 'ALR/ERV', NULL, NULL, 27164, 8),
(250418, NULL, 'PTHR46534', NULL, NULL, NULL, NULL, 'IGGFC_BINDING DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(250419, NULL, 'PTHR13586', NULL, NULL, NULL, NULL, 'SCD6 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(250420, NULL, 'PTHR36697', NULL, NULL, NULL, NULL, 'S-ADENOSYLMETHIONINE SYNTHASE', NULL, NULL, 24691, 8),
(250421, NULL, 'PTHR44216', NULL, NULL, NULL, NULL, 'PROTEIN O-MANNOSYL-TRANSFERASE TMTC2', NULL, NULL, NULL, 8),
(250422, NULL, 'PTHR44313', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 17', NULL, NULL, NULL, 8),
(250423, NULL, 'PTHR31458', NULL, NULL, NULL, NULL, 'POLYGALACTURONASE 1 BETA-LIKE PROTEIN 2', NULL, NULL, NULL, 8),
(250424, NULL, 'PTHR11871', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE PP2A REGULATORY SUBUNIT B', NULL, NULL, 2578, 8),
(250425, NULL, 'PTHR35601', NULL, NULL, NULL, NULL, 'TOXIN RELE', NULL, NULL, NULL, 8),
(250426, NULL, 'PTHR15683', NULL, NULL, NULL, NULL, 'SCAFFOLD ATTACHMENT FACTOR B-RELATED', NULL, NULL, NULL, 8),
(250427, NULL, 'PTHR47302', NULL, NULL, NULL, NULL, 'STERILE ALPHA MOTIF DOMAIN-CONTAINING PROTEIN 3', NULL, NULL, 34205, 8),
(250428, NULL, 'PTHR43968', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(250429, NULL, 'PTHR16565', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN C-I', NULL, NULL, 3320, 8),
(250430, NULL, 'PTHR37528', NULL, NULL, NULL, NULL, 'UPF0149 PROTEIN YGFB', NULL, NULL, NULL, 8),
(250431, NULL, 'PTHR21515', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', NULL, NULL, NULL, 8),
(250432, NULL, 'PTHR47956', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 71B11-RELATED', NULL, NULL, NULL, 8),
(250433, NULL, 'PTHR22589', NULL, NULL, NULL, NULL, 'CARNITINE O-ACYLTRANSFERASE', NULL, NULL, 4356, 8),
(250434, NULL, 'PTHR15224', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE [UBIQUINONE] IRON-SULFUR PROTEIN 5', NULL, NULL, 15945, 8),
(250435, NULL, 'PTHR37225', NULL, NULL, NULL, NULL, 'OSJNBA0011F23.3 PROTEIN', NULL, NULL, NULL, 8),
(250436, NULL, 'PTHR18968', NULL, NULL, NULL, NULL, 'THIAMINE PYROPHOSPHATE ENZYMES', NULL, NULL, 34488, 8),
(250437, NULL, 'PTHR17583', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE 3-KINASE REGULATORY SUBUNIT 4', NULL, NULL, 36968, 8),
(250438, NULL, 'PTHR34136', NULL, NULL, NULL, NULL, '', NULL, NULL, 2136, 8),
(250439, NULL, 'PTHR47153', NULL, NULL, NULL, NULL, 'LACTATE UTILIZATION PROTEIN B', NULL, NULL, 7462, 8),
(250440, NULL, 'PTHR16073', NULL, NULL, NULL, NULL, 'DCR DOMAIN-CONTAINING PROTEIN', NULL, NULL, 33518, 8),
(250441, NULL, 'PTHR42201', NULL, NULL, NULL, NULL, 'TAXIS PROTEIN', NULL, NULL, 5689, 8);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(250442, NULL, 'PTHR31977', NULL, NULL, NULL, NULL, 'UPF0696 PROTEIN C11ORF68', NULL, NULL, 7582, 8),
(250443, NULL, 'PTHR15162', NULL, NULL, NULL, NULL, 'ASPARTOACYLASE', NULL, NULL, NULL, 8),
(250444, NULL, 'PTHR28622', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 7', NULL, NULL, 32726, 8),
(250445, NULL, 'PTHR43794', NULL, NULL, NULL, NULL, 'AMINOHYDROLASE SSNA-RELATED', NULL, NULL, NULL, 8),
(250446, NULL, 'PTHR31878', NULL, NULL, NULL, NULL, 'CHEMOKINE-LIKE PROTEIN TAFA-5-RELATED', NULL, NULL, 27684, 8),
(250447, NULL, 'PTHR35792', NULL, NULL, NULL, NULL, 'GENERAL STRESS PROTEIN', NULL, NULL, NULL, 8),
(250448, NULL, 'PTHR43193', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(250449, NULL, 'PTHR31598', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN D', NULL, NULL, 34032, 8),
(250450, NULL, 'PTHR45277', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(250451, NULL, 'PTHR47131', NULL, NULL, NULL, NULL, 'CATION CHANNEL SPERM-ASSOCIATED PROTEIN 3', NULL, NULL, NULL, 8),
(250452, NULL, 'PTHR34398', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(250453, NULL, 'PTHR14222', NULL, NULL, NULL, NULL, 'CONDENSIN', NULL, NULL, 25103, 8),
(250454, NULL, 'PTHR38588', NULL, NULL, NULL, NULL, 'BLL0334 PROTEIN', NULL, NULL, 9220, 8),
(250455, NULL, 'PTHR10192', NULL, NULL, NULL, NULL, 'MOLYBDOPTERIN BIOSYNTHESIS PROTEIN', NULL, NULL, 27850, 8),
(250456, NULL, 'PTHR44103', NULL, NULL, NULL, NULL, 'PROPROTEIN CONVERTASE P', NULL, NULL, NULL, 8),
(250457, NULL, 'PTHR38909', NULL, NULL, NULL, NULL, 'G PROTEIN GAMMA DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(250458, NULL, 'PTHR47870', NULL, NULL, NULL, NULL, 'CYTOCHROME C-TYPE BIOGENESIS PROTEIN CCMH', NULL, NULL, NULL, 8),
(250459, NULL, 'PTHR36810', NULL, NULL, NULL, NULL, 'BNACNNG47150D PROTEIN', NULL, NULL, NULL, 8),
(250460, NULL, 'PTHR35973', NULL, NULL, NULL, NULL, 'MAPK-INTERACTING AND SPINDLE-STABILIZING PROTEIN-LIKE', NULL, NULL, 25695, 8),
(250461, NULL, 'PTHR35010', NULL, NULL, NULL, NULL, 'BLL4672 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(250462, NULL, 'PTHR21022', NULL, NULL, NULL, NULL, 'PREPHENATE DEHYDRATASE  P PROTEIN', NULL, NULL, NULL, 8),
(250463, NULL, 'PTHR24136', NULL, NULL, NULL, NULL, 'SOWAH (DROSOPHILA) HOMOLOG', NULL, NULL, NULL, 8),
(250464, NULL, 'PTHR34590', NULL, NULL, NULL, NULL, 'OS03G0124300 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(250465, NULL, 'PTHR33077', NULL, NULL, NULL, NULL, 'PROTEIN TIFY 4A-RELATED-RELATED', NULL, NULL, 30265, 8),
(250466, NULL, 'PTHR12984', NULL, NULL, NULL, NULL, 'SCY1-RELATED S/T PROTEIN KINASE-LIKE', NULL, NULL, NULL, 8),
(250467, NULL, 'PTHR15319', NULL, NULL, NULL, NULL, 'TATA BOX-BINDING PROTEIN ASSOCIATED FACTOR RNA POLYMERASE I SUBUNIT C', NULL, NULL, 32122, 8),
(250468, NULL, 'PTHR46155', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(250469, NULL, 'PTHR37207', NULL, NULL, NULL, NULL, 'OS09G0446000 PROTEIN', NULL, NULL, NULL, 8),
(250470, NULL, 'PTHR31769', NULL, NULL, NULL, NULL, 'OS07G0462200 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(250471, NULL, 'PTHR47775', NULL, NULL, NULL, NULL, 'BUD SITE SELECTION PROTEIN 14', NULL, NULL, NULL, 8),
(250472, NULL, 'PTHR33053', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(250473, NULL, 'PTHR36898', NULL, NULL, NULL, NULL, 'OSJNBB0026I12.6 PROTEIN', NULL, NULL, NULL, 8),
(250474, NULL, 'PTHR14360', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 21965, 8),
(250475, NULL, 'PTHR10687', NULL, NULL, NULL, NULL, 'SECRETORY CARRIER-ASSOCIATED MEMBRANE PROTEIN  SCAMP', NULL, NULL, 7243, 8),
(250476, NULL, 'PTHR23162', NULL, NULL, NULL, NULL, 'OUTER DENSE FIBER OF SPERM TAILS 2', NULL, NULL, 25727, 8),
(250477, NULL, 'PTHR47496', NULL, NULL, NULL, NULL, 'CD27', NULL, NULL, NULL, 8),
(250478, NULL, 'PTHR24238', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR', NULL, NULL, NULL, 8),
(250479, NULL, 'PTHR37319', NULL, NULL, NULL, NULL, 'TRANSPOSASE', NULL, NULL, NULL, 8),
(250480, NULL, 'PTHR44013', NULL, NULL, NULL, NULL, 'ZINC-TYPE ALCOHOL DEHYDROGENASE-LIKE PROTEIN C16A3.02C', NULL, NULL, NULL, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(250481, NULL, 'PTHR21502', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN DZIP1', NULL, NULL, NULL, 8),
(250482, NULL, 'PTHR34586', NULL, NULL, NULL, NULL, 'SPERACT/SCAVENGER RECEPTOR DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(250483, NULL, 'PTHR11960', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 4E RELATED', NULL, NULL, 1244, 8),
(250484, NULL, 'PTHR15354', NULL, NULL, NULL, NULL, 'MUF1', NULL, NULL, 25593, 8),
(250485, NULL, 'PTHR48220', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(250486, NULL, 'PTHR44140', NULL, NULL, NULL, NULL, 'LD25575P', NULL, NULL, NULL, 8),
(250487, NULL, 'PTHR21373', NULL, NULL, NULL, NULL, 'GLUCOSE REPRESSIBLE PROTEIN MAK10', NULL, NULL, 6938, 8),
(250488, NULL, 'PTHR38449', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN TM_1690-RELATED', NULL, NULL, 416, 8),
(250489, NULL, 'PTHR21315', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 27030, 8),
(250490, NULL, 'PTHR48248', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(250491, NULL, 'PTHR33504', NULL, NULL, NULL, NULL, 'NADH DEHYDROGENASE (UBIQUINONE) 1 BETA SUBCOMPLEX, 4', NULL, NULL, NULL, 8),
(250492, NULL, 'PTHR14369', NULL, NULL, NULL, NULL, 'SURFEIT LOCUS PROTEIN 6', NULL, NULL, 6545, 8),
(250493, NULL, 'PTHR40143', NULL, NULL, NULL, NULL, '', NULL, NULL, 23714, 8),
(250494, NULL, 'PTHR40434', NULL, NULL, NULL, NULL, 'CUPIN_2 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(250495, NULL, 'PTHR11101', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORTER', NULL, NULL, 1371, 8),
(250496, NULL, 'PTHR11933', NULL, NULL, NULL, NULL, 'TRNA  5-METHYLAMINOMETHYL-2-THIOURIDYLATE -METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(250497, NULL, 'PTHR46201', NULL, NULL, NULL, NULL, 'PHD FINGER PROTEIN MALE MEIOCYTE DEATH 1-RELATED', NULL, NULL, NULL, 8),
(250498, NULL, 'PTHR16716', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE SUBUNIT 7B, MITOCHONDRIAL', NULL, NULL, 8968, 8),
(250499, NULL, 'PTHR47825', NULL, NULL, NULL, NULL, 'AAA_23 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(250500, NULL, 'PTHR23345', NULL, NULL, NULL, NULL, 'VITELLOGENIN-RELATED', NULL, NULL, NULL, 8),
(250501, NULL, 'PTHR44813', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE-BINDING PROTEIN 1', NULL, NULL, NULL, 8),
(250502, NULL, 'PTHR24188', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT PROTEIN', NULL, NULL, NULL, 8),
(250503, NULL, 'PTHR10052', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L18A', NULL, NULL, 21526, 8),
(250504, NULL, 'PTHR31403', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE A1-IBETA2, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(250505, NULL, 'PTHR15218', NULL, NULL, NULL, NULL, 'MD-1, MD-2 - RELATED', NULL, NULL, 32517, 8),
(250506, NULL, 'PTHR31808', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, 27095, 8),
(250507, NULL, 'PTHR43612', NULL, NULL, NULL, NULL, 'TRIFUNCTIONAL ENZYME SUBUNIT ALPHA', NULL, NULL, NULL, 8),
(250508, NULL, 'PTHR45935', NULL, NULL, NULL, NULL, 'PROTEIN ZBED8-RELATED', NULL, NULL, NULL, 8),
(250509, NULL, 'PTHR30501', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 15467, 8),
(250510, NULL, 'PTHR48056', NULL, NULL, NULL, NULL, 'LRR RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE-RELATED', NULL, NULL, NULL, 8),
(250511, NULL, 'PTHR28272', NULL, NULL, NULL, NULL, 'RIBONUCLEASES P/MRP PROTEIN SUBUNIT POP3', NULL, NULL, 12550, 8),
(250512, NULL, 'PTHR43730', NULL, NULL, NULL, NULL, 'BETA-MANNOSIDASE', NULL, NULL, NULL, 8),
(250513, NULL, 'PTHR10585', NULL, NULL, NULL, NULL, 'ER LUMEN PROTEIN RETAINING RECEPTOR', NULL, NULL, 3614, 8),
(250514, NULL, 'PTHR19991', NULL, NULL, NULL, NULL, 'L 2 01289', NULL, NULL, NULL, 8),
(250515, NULL, 'PTHR13449', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN GPR177', NULL, NULL, 10202, 8),
(250516, NULL, 'PTHR35855', NULL, NULL, NULL, NULL, 'PROTEIN CBG11437-RELATED', NULL, NULL, NULL, 8),
(250517, NULL, 'PTHR43097', NULL, NULL, NULL, NULL, 'GLUTAMINE-TRNA LIGASE', NULL, NULL, NULL, 8),
(250518, NULL, 'PTHR35707', NULL, NULL, NULL, NULL, 'OS06G0608100 PROTEIN', NULL, NULL, NULL, 8),
(250519, NULL, 'PTHR43232', NULL, NULL, NULL, NULL, 'MOLYBDENUM COFACTOR BIOSYNTHESIS PROTEIN B', NULL, NULL, 11204, 8);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(250520, NULL, 'PTHR23287', NULL, NULL, NULL, NULL, 'RUBY-EYE2-LIKE PROTEIN', NULL, NULL, NULL, 8),
(250521, NULL, 'PTHR43697', NULL, NULL, NULL, NULL, 'SERYL-TRNA SYNTHETASE', NULL, NULL, NULL, 8),
(250522, NULL, 'PTHR42111', NULL, NULL, NULL, NULL, 'YALI0D23727P', NULL, NULL, NULL, 8),
(250523, NULL, 'PTHR24058', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN KINASE', NULL, NULL, NULL, 8),
(250524, NULL, 'PTHR43410', NULL, NULL, NULL, NULL, 'NITRIC OXIDE SYNTHASE OXYGENASE', NULL, NULL, NULL, 8),
(250525, NULL, 'PTHR23316', NULL, NULL, NULL, NULL, 'IMPORTIN ALPHA', NULL, NULL, NULL, 8),
(250526, NULL, 'PTHR46433', NULL, NULL, NULL, NULL, 'ANK_REP_REGION DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(250527, NULL, 'PTHR20958', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(250528, NULL, 'PTHR14388', NULL, NULL, NULL, NULL, 'T CELL-SPECIFIC ADAPTER PROTEIN TSAD', NULL, NULL, NULL, 8),
(250529, NULL, 'PTHR18966', NULL, NULL, NULL, NULL, 'IONOTROPIC GLUTAMATE RECEPTOR', NULL, NULL, NULL, 8),
(250530, NULL, 'PTHR45729', NULL, NULL, NULL, NULL, 'RABPHILIN, ISOFORM A', NULL, NULL, 35406, 8),
(250531, NULL, 'PTHR38248', NULL, NULL, NULL, NULL, 'FUNK1 6', NULL, NULL, NULL, 8),
(250532, NULL, 'PTHR39518', NULL, NULL, NULL, NULL, 'UPF0215 PROTEIN MJ1150', NULL, NULL, 4738, 8),
(250533, NULL, 'PTHR28557', NULL, NULL, NULL, NULL, 'PROTEIN SLX4IP', NULL, NULL, 22532, 8),
(250534, NULL, 'PTHR22814', NULL, NULL, NULL, NULL, 'COPPER TRANSPORT PROTEIN ATOX1-RELATED', NULL, NULL, 34521, 8),
(250535, NULL, 'PTHR16057', NULL, NULL, NULL, NULL, 'WINS1, 2 PROTEIN', NULL, NULL, 14608, 8),
(250536, NULL, 'PTHR32499', NULL, NULL, NULL, NULL, 'FASCICLIN-LIKE ARABINOGALACTAN PROTEIN 16', NULL, NULL, 36987, 8),
(250537, NULL, 'PTHR15893', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L27', NULL, NULL, 3236, 8),
(250538, NULL, 'PTHR35365', NULL, NULL, NULL, NULL, 'LP04239P', NULL, NULL, NULL, 8),
(250539, NULL, 'PTHR23212', NULL, NULL, NULL, NULL, 'BRAIN ACID SOLUBLE PROTEIN 1', NULL, NULL, 8732, 8),
(250540, NULL, 'PTHR44394', NULL, NULL, NULL, NULL, 'BETA-ALANINE-ACTIVATING ENZYME', NULL, NULL, NULL, 8),
(250541, NULL, 'PTHR39063', NULL, NULL, NULL, NULL, 'ORAL-FACIAL-DIGITAL SYNDROME 1 PROTEIN HOMOLOG', NULL, NULL, NULL, 8),
(250542, NULL, 'PTHR23143', NULL, NULL, NULL, NULL, 'TRICHOHYALIN-RELATED', NULL, NULL, 21639, 8),
(250543, NULL, 'PTHR31866', NULL, NULL, NULL, NULL, 'GENE 4779-RELATED', NULL, NULL, 21587, 8),
(250544, NULL, 'PTHR38340', NULL, NULL, NULL, NULL, 'S-LAYER PROTEIN', NULL, NULL, NULL, 8),
(250545, NULL, 'PTHR47777', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN SEBOX', NULL, NULL, 33600, 8),
(250546, NULL, 'PTHR45874', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN ABDOMINAL-B', NULL, NULL, 33720, 8),
(250547, NULL, 'PTHR22998', NULL, NULL, NULL, NULL, 'SARM1', NULL, NULL, 32805, 8),
(250548, NULL, 'PTHR47989', NULL, NULL, NULL, NULL, 'OS01G0750732 PROTEIN', NULL, NULL, NULL, 8),
(250549, NULL, 'PTHR34987', NULL, NULL, NULL, NULL, 'C, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G02880)-RELATED', NULL, NULL, NULL, 8),
(250550, NULL, 'PTHR34278', NULL, NULL, NULL, NULL, 'PROTEIN THI031, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(250551, NULL, 'PTHR37680', NULL, NULL, NULL, NULL, 'C130050O18RIK PROTEIN', NULL, NULL, NULL, 8),
(250552, NULL, 'PTHR38479', NULL, NULL, NULL, NULL, 'LMO0824 PROTEIN', NULL, NULL, NULL, 8),
(250553, NULL, 'PTHR45713', NULL, NULL, NULL, NULL, 'FTP DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(250554, NULL, 'PTHR38634', NULL, NULL, NULL, NULL, 'PROTEIN CBG16428', NULL, NULL, NULL, 8),
(250555, NULL, 'PTHR34955', NULL, NULL, NULL, NULL, 'IGR MOTIF PROTEIN', NULL, NULL, NULL, 8),
(250556, NULL, 'PTHR10885', NULL, NULL, NULL, NULL, 'ISOPENTENYL-DIPHOSPHATE DELTA-ISOMERASE', NULL, NULL, NULL, 8),
(250557, NULL, 'PTHR45128', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE TYPE 11', NULL, NULL, NULL, 8),
(250558, NULL, 'PTHR16058', NULL, NULL, NULL, NULL, 'DOUBLE ZINC RIBBON AND ANKYRIN REPEAT-CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(250559, NULL, 'PTHR33631', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(250560, NULL, 'PTHR37445', NULL, NULL, NULL, NULL, 'PROTEIN CBG24663', NULL, NULL, NULL, 8),
(250561, NULL, 'PTHR13857', NULL, NULL, NULL, NULL, 'MRNA EDITING ENZYME', NULL, NULL, NULL, 8),
(250562, NULL, 'PTHR30195', NULL, NULL, NULL, NULL, 'TYPE I SITE-SPECIFIC DEOXYRIBONUCLEASE PROTEIN SUBUNIT M AND R', NULL, NULL, NULL, 8),
(250563, NULL, 'PTHR35819', NULL, NULL, NULL, NULL, 'PICALM INTERACTING MITOTIC REGULATOR PIMREG', NULL, NULL, 8091, 8),
(250564, NULL, 'PTHR10263', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE PROTEOLIPID SUBUNIT', NULL, NULL, NULL, 8),
(250565, NULL, 'PTHR13411', NULL, NULL, NULL, NULL, 'PLASMINOGEN RECEPTOR (KT)', NULL, NULL, 14742, 8),
(250566, NULL, 'PTHR36853', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(250567, NULL, 'PTHR35157', NULL, NULL, NULL, NULL, 'PROTEIN FAM209A', NULL, NULL, 24849, 8),
(250568, NULL, 'PTHR32401', NULL, NULL, NULL, NULL, 'CONCANAVALIN A-LIKE LECTIN FAMILY PROTEIN', NULL, NULL, NULL, 8),
(250569, NULL, 'PTHR30031', NULL, NULL, NULL, NULL, 'PHOSPHOENOLPYRUVATE CARBOXYKINASE  ATP', NULL, NULL, 5279, 8),
(250570, NULL, 'PTHR43481', NULL, NULL, NULL, NULL, 'FRUCTOSE-1-PHOSPHATE PHOSPHATASE', NULL, NULL, NULL, 8),
(250571, NULL, 'PTHR46686', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', NULL, NULL, NULL, 8),
(250572, NULL, 'PTHR39431', NULL, NULL, NULL, NULL, 'FRPA/C-RELATED PROTEIN', NULL, NULL, NULL, 8),
(250573, NULL, 'PTHR41146', NULL, NULL, NULL, NULL, 'DIURETIC HORMONE CLASS 2', NULL, NULL, 6507, 8),
(250574, NULL, 'PTHR13528', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L28, MITOCHONDRIAL', NULL, NULL, 21734, 8),
(250575, NULL, 'PTHR47139', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 9', NULL, NULL, NULL, 8),
(250576, NULL, 'PTHR13390', NULL, NULL, NULL, NULL, 'LIPASE', NULL, NULL, 15655, 8),
(250577, NULL, 'PTHR23111', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', NULL, NULL, NULL, 8),
(250578, NULL, 'PTHR37864', NULL, NULL, NULL, NULL, 'SIMILAR TO AVLV472', NULL, NULL, 22933, 8),
(250579, NULL, 'PTHR30218', NULL, NULL, NULL, NULL, 'POLYPHOSPHATE KINASE', NULL, NULL, 5349, 8),
(250580, NULL, 'PTHR11202', NULL, NULL, NULL, NULL, 'SPROUTY-RELATED, EVH1 DOMAIN-CONTAINING PROTEIN FAMILY MEMBER', NULL, NULL, NULL, 8),
(250581, NULL, 'PTHR37237', NULL, NULL, NULL, NULL, 'OS02G0567000 PROTEIN', NULL, NULL, NULL, 8),
(250582, NULL, 'PTHR23149', NULL, NULL, NULL, NULL, 'G PATCH DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(250583, NULL, 'PTHR15205', NULL, NULL, NULL, NULL, 'DEATH EFFECTOR DOMAIN-CONTAINING PROTEIN', NULL, NULL, 32390, 8),
(250584, NULL, 'PTHR17537', NULL, NULL, NULL, NULL, 'TRANSDUCER OF ERBB2  TOB', NULL, NULL, 18302, 8),
(250585, NULL, 'PTHR31521', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(250586, NULL, 'PTHR46693', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 15', NULL, NULL, NULL, 8),
(250587, NULL, 'PTHR11693', NULL, NULL, NULL, NULL, 'ATP SYNTHASE GAMMA CHAIN', NULL, NULL, 1624, 8),
(250588, NULL, 'PTHR15036', NULL, NULL, NULL, NULL, 'PIKACHURIN-LIKE PROTEIN', NULL, NULL, NULL, 8),
(250589, NULL, 'PTHR24247', NULL, NULL, NULL, NULL, '5-HYDROXYTRYPTAMINE RECEPTOR', NULL, NULL, NULL, 8),
(250590, NULL, 'PTHR46408', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER 63', NULL, NULL, NULL, 8),
(250591, NULL, 'PTHR32332', NULL, NULL, NULL, NULL, '2-NITROPROPANE DIOXYGENASE', NULL, NULL, NULL, 8),
(250592, NULL, 'PTHR40472', NULL, NULL, NULL, NULL, 'RICIN B-TYPE LECTIN DOMAIN-CONTAINING PROTEIN', NULL, NULL, 33145, 8),
(250593, NULL, 'PTHR21398', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(250594, NULL, 'PTHR14604', NULL, NULL, NULL, NULL, 'WD40 REPEAT PF20', NULL, NULL, NULL, 8),
(250595, NULL, 'PTHR13425', NULL, NULL, NULL, NULL, 'HEADCASE PROTEIN', NULL, NULL, 24281, 8),
(250596, NULL, 'PTHR47083', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 11', NULL, NULL, 34342, 8),
(250597, NULL, 'PTHR45566', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR YHJB-RELATED', NULL, NULL, NULL, 8);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(250598, NULL, 'PTHR22028', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(250599, NULL, 'PTHR15598', NULL, NULL, NULL, NULL, 'ENHANCER OF MRNA-DECAPPING PROTEIN 4', NULL, NULL, 36810, 8),
(250600, NULL, 'PTHR21052', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS ASSOCIATED 11-RELATED', NULL, NULL, 23721, 8),
(250601, NULL, 'PTHR19232', NULL, NULL, NULL, NULL, 'CENTROCORTIN FAMILY MEMBER', NULL, NULL, 21677, 8),
(250602, NULL, 'PTHR10720', NULL, NULL, NULL, NULL, 'HEME OXYGENASE', NULL, NULL, 1294, 8),
(250603, NULL, 'PTHR36440', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_8G07350)-RELATED', NULL, NULL, NULL, 8),
(250604, NULL, 'PTHR21553', NULL, NULL, NULL, NULL, 'ALMS1-RELATED', NULL, NULL, NULL, 8),
(250605, NULL, 'PTHR28229', NULL, NULL, NULL, NULL, 'TRANSLOCATION PROTEIN SEC66', NULL, NULL, 16233, 8),
(250606, NULL, 'PTHR19378', NULL, NULL, NULL, NULL, 'GOLGIN- RELATED', NULL, NULL, 24678, 8),
(250607, NULL, 'PTHR30387', NULL, NULL, NULL, NULL, 'MANNONATE DEHYDRATASE', NULL, NULL, 2373, 8),
(250608, NULL, 'PTHR34804', NULL, NULL, NULL, NULL, 'CAMP-REGULATED PHOSPHOPROTEIN 19-RELATED PROTEIN', NULL, NULL, NULL, 8),
(250609, NULL, 'PTHR46223', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE SUV39H', NULL, NULL, NULL, 8),
(250610, NULL, 'PTHR35122', NULL, NULL, NULL, NULL, 'OSJNBA0093F12.14 PROTEIN', NULL, NULL, 33214, 8),
(250611, NULL, 'PTHR33987', NULL, NULL, NULL, NULL, 'CALCINEURIN-LIKE METALLO-PHOSPHOESTERASE SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(250612, NULL, 'PTHR34035', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 47', NULL, NULL, NULL, 8),
(250613, NULL, 'PTHR47509', NULL, NULL, NULL, NULL, 'MCG1612', NULL, NULL, 27808, 8),
(250614, NULL, 'PTHR11705', NULL, NULL, NULL, NULL, 'PROTEASE FAMILY M14 CARBOXYPEPTIDASE A,B', NULL, NULL, NULL, 8),
(250615, NULL, 'PTHR37910', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(250616, NULL, 'PTHR15717', NULL, NULL, NULL, NULL, 'PROTEIN KIAA0494', NULL, NULL, 34778, 8),
(250617, NULL, 'PTHR34479', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 30', NULL, NULL, NULL, 8),
(250618, NULL, 'PTHR12263', NULL, NULL, NULL, NULL, 'VACUOLAR ATP SYNTHASE SUBUNIT H', NULL, NULL, 7688, 8),
(250619, NULL, 'PTHR33078', NULL, NULL, NULL, NULL, 'PROTEIN YCF2-RELATED', NULL, NULL, NULL, 8),
(250620, NULL, 'PTHR43435', NULL, NULL, NULL, NULL, 'RIBULOKINASE', NULL, NULL, NULL, 8),
(250621, NULL, 'PTHR10925', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE 10', NULL, NULL, 24289, 8),
(250622, NULL, 'PTHR34315', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(250623, NULL, 'PTHR36702', NULL, NULL, NULL, NULL, 'HOLLIDAY JUNCTION RESOLVASE', NULL, NULL, NULL, 8),
(250624, NULL, 'PTHR38619', NULL, NULL, NULL, NULL, 'PROTEIN CBG04644', NULL, NULL, NULL, 8),
(250625, NULL, 'PTHR32170', NULL, NULL, NULL, NULL, 'PROTEASOME ACTIVATOR COMPLEX SUBUNIT 4', NULL, NULL, 9845, 8),
(250626, NULL, 'PTHR21687', NULL, NULL, NULL, NULL, 'PLASMALEMMA VESICLE-ASSOCIATED PROTEIN', NULL, NULL, 10160, 8),
(250627, NULL, 'PTHR43670', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 26', NULL, NULL, NULL, 8),
(250628, NULL, 'PTHR15186', NULL, NULL, NULL, NULL, 'RE48077P', NULL, NULL, 14177, 8),
(250629, NULL, 'PTHR33599', NULL, NULL, NULL, NULL, 'PROTEIN IDA-LIKE 5', NULL, NULL, 27482, 8),
(250630, NULL, 'PTHR28597', NULL, NULL, NULL, NULL, 'VOLTAGE-DEPENDENT CALCIUM CHANNEL BETA SUBUNIT-ASSOCIATED REGULATORY PROTEIN', NULL, NULL, 32835, 8),
(250631, NULL, 'PTHR47080', NULL, NULL, NULL, NULL, 'CHROMOSOME 16 OPEN READING FRAME 96', NULL, NULL, NULL, 8),
(250632, NULL, 'PTHR24050', NULL, NULL, NULL, NULL, 'PA14 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(250633, NULL, 'PTHR15642', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY FACTOR 3, MITOCHONDRIAL', NULL, NULL, 30797, 8),
(250634, NULL, 'PTHR40018', NULL, NULL, NULL, NULL, '[PSI+] INDUCTION PROTEIN 2', NULL, NULL, 33966, 8),
(250635, NULL, 'PTHR33115', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(250636, NULL, 'PTHR28603', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 243', NULL, NULL, 16221, 8);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(250637, NULL, 'PTHR43658', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/REDUCTASE', NULL, NULL, NULL, 8),
(250638, NULL, 'PTHR13096', NULL, NULL, NULL, NULL, 'MINA53  MYC INDUCED NUCLEAR ANTIGEN', NULL, NULL, 30363, 8),
(250639, NULL, 'PTHR32005', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 178B-RELATED', NULL, NULL, 27338, 8),
(250640, NULL, 'PTHR45640', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN HSP-12.2-RELATED', NULL, NULL, 5462, 8),
(250641, NULL, 'PTHR46869', NULL, NULL, NULL, NULL, 'C2H2-LIKE ZINC FINGER PROTEIN', NULL, NULL, NULL, 8),
(250642, NULL, 'PTHR10907', NULL, NULL, NULL, NULL, 'REGUCALCIN', NULL, NULL, NULL, 8),
(250643, NULL, 'PTHR36469', NULL, NULL, NULL, NULL, 'DISTAL MEMBRANE-ARM ASSEMBLY COMPLEX PROTEIN 1', NULL, NULL, NULL, 8),
(250644, NULL, 'PTHR24391', NULL, NULL, NULL, NULL, 'HISTONE H4 TRANSCRIPTION FACTOR-RELATED', NULL, NULL, NULL, 8),
(250645, NULL, 'PTHR16528', NULL, NULL, NULL, NULL, 'GOLGI-ASSOCIATED PDZ AND COILED-COIL MOTIF-CONTAINING', NULL, NULL, 30640, 8),
(250646, NULL, 'PTHR46992', NULL, NULL, NULL, NULL, 'GYF DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(250647, NULL, 'PTHR45658', NULL, NULL, NULL, NULL, 'GATA TRANSCRIPTION FACTOR', NULL, NULL, NULL, 8),
(250648, NULL, 'PTHR46847', NULL, NULL, NULL, NULL, 'D-ALLOSE-BINDING PERIPLASMIC PROTEIN-RELATED', NULL, NULL, NULL, 8),
(250649, NULL, 'PTHR42889', NULL, NULL, NULL, NULL, 'BLR3681 PROTEIN', NULL, NULL, NULL, 8),
(250650, NULL, 'PTHR34653', NULL, NULL, NULL, NULL, '', NULL, NULL, 3094, 8),
(250651, NULL, 'PTHR21446', NULL, NULL, NULL, NULL, 'DUF3504 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(250652, NULL, 'PTHR36023', NULL, NULL, NULL, NULL, 'ARGOS-LIKE PROTEIN', NULL, NULL, 33067, 8),
(250653, NULL, 'PTHR13274', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOMAL PROTEIN S25', NULL, NULL, 27149, 8),
(250654, NULL, 'PTHR47904', NULL, NULL, NULL, NULL, 'NATURAL CYTOTOXICITY TRIGGERING RECEPTOR 3', NULL, NULL, 35223, 8),
(250655, NULL, 'PTHR47341', NULL, NULL, NULL, NULL, 'GATA-TYPE ZINC FINGER PROTEIN 1', NULL, NULL, NULL, 8),
(250656, NULL, 'PTHR38050', NULL, NULL, NULL, NULL, '', NULL, NULL, 35530, 8),
(250657, NULL, 'PTHR12167', NULL, NULL, NULL, NULL, 'C-TYPE NATRIURETIC PEPTIDE', NULL, NULL, NULL, 8),
(250658, NULL, 'PTHR47991', NULL, NULL, NULL, NULL, 'OXOGLUTARATE/IRON-DEPENDENT DIOXYGENASE', NULL, NULL, NULL, 8),
(250659, NULL, 'PTHR23348', NULL, NULL, NULL, NULL, 'PERIAXIN/AHNAK', NULL, NULL, NULL, 8),
(250660, NULL, 'PTHR23333', NULL, NULL, NULL, NULL, 'UBX DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(250661, NULL, 'PTHR23001', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR', NULL, NULL, 34721, 8),
(250662, NULL, 'PTHR36981', NULL, NULL, NULL, NULL, 'ZGC:195170', NULL, NULL, NULL, 8),
(250663, NULL, 'PTHR13944', NULL, NULL, NULL, NULL, 'AGAP007712-PA', NULL, NULL, NULL, 8),
(250664, NULL, 'PTHR14002', NULL, NULL, NULL, NULL, 'ENDOGLIN/TGF-BETA RECEPTOR TYPE III', NULL, NULL, NULL, 8),
(250665, NULL, 'PTHR43538', NULL, NULL, NULL, NULL, 'ALPHA-IPM SYNTHASE/HOMOCITRATE SYNTHASE', NULL, NULL, 3672, 8),
(250666, NULL, 'PTHR44390', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 41 KDA', NULL, NULL, NULL, 8),
(250667, NULL, 'PTHR24543', NULL, NULL, NULL, NULL, 'MULTICOPPER OXIDASE-RELATED', NULL, NULL, NULL, 8),
(250668, NULL, 'PTHR15586', NULL, NULL, NULL, NULL, 'LINKER FOR ACTIVATION OF T-CELLS FAMILY MEMBER 1', NULL, NULL, 7734, 8),
(250669, NULL, 'PTHR38326', NULL, NULL, NULL, NULL, 'CHROMOSOME 11 OPEN READING FRAME 97', NULL, NULL, 28866, 8),
(250670, NULL, 'PTHR17604', NULL, NULL, NULL, NULL, 'TRANSCRIPTION COFACTOR VESTIGIAL-LIKE PROTEIN 4', NULL, NULL, 21931, 8),
(250671, NULL, 'PTHR34756', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE-ASSOCIATED PROTEIN 3', NULL, NULL, 32480, 8),
(250672, NULL, 'PTHR12815', NULL, NULL, NULL, NULL, 'SORTING AND ASSEMBLY MACHINERY SAMM50 PROTEIN FAMILY MEMBER', NULL, NULL, 30432, 8),
(250673, NULL, 'PTHR34894', NULL, NULL, NULL, NULL, 'SAM-DEPENDENT METHYLTRANSFERASE RSMI, CONSERVED SITE', NULL, NULL, NULL, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(250674, NULL, 'PTHR12455', NULL, NULL, NULL, NULL, 'NUCLEOLAR COMPLEX PROTEIN 4', NULL, NULL, 23913, 8),
(250675, NULL, 'PTHR35166', NULL, NULL, NULL, NULL, 'OS05G0193700 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(250676, NULL, 'PTHR37204', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(250677, NULL, 'PTHR30115', NULL, NULL, NULL, NULL, 'NITROGEN REGULATORY PROTEIN P-II', NULL, NULL, 5890, 8),
(250678, NULL, 'PTHR38483', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(250679, NULL, 'PTHR31303', NULL, NULL, NULL, NULL, 'CTP-DEPENDENT DIACYLGLYCEROL KINASE 1', NULL, NULL, 27799, 8),
(250680, NULL, 'PTHR31286', NULL, NULL, NULL, NULL, 'GLYCINE-RICH CELL WALL STRUCTURAL PROTEIN 1.8-LIKE', NULL, NULL, NULL, 8),
(250681, NULL, 'PTHR31703', NULL, NULL, NULL, NULL, 'UPF0669 PROTEIN C6ORF120', NULL, NULL, 26239, 8),
(250682, NULL, 'PTHR31435', NULL, NULL, NULL, NULL, 'PROTEIN NATD1', NULL, NULL, 35571, 8),
(250683, NULL, 'PTHR38441', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(250684, NULL, 'PTHR37763', NULL, NULL, NULL, NULL, 'EXOSOME COMPLEX EXONUCLEASE', NULL, NULL, NULL, 8),
(250685, NULL, 'PTHR47970', NULL, NULL, NULL, NULL, 'KINESIN-LIKE PROTEIN KIF11', NULL, NULL, NULL, 8),
(250686, NULL, 'PTHR22710', NULL, NULL, NULL, NULL, 'X-RAY RADIATION RESISTANCE ASSOCIATED PROTEIN 1  XRRA1', NULL, NULL, 32019, 8),
(250687, NULL, 'PTHR32455', NULL, NULL, NULL, NULL, 'SPERM ACROSOME-ASSOCIATED PROTEIN 9', NULL, NULL, 21775, 8),
(250688, NULL, 'PTHR28649', NULL, NULL, NULL, NULL, 'PROTEIN REPRIMO-RELATED', NULL, NULL, 36659, 8),
(250689, NULL, 'PTHR30406', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORT SYSTEM PERMEASE PROTEIN', NULL, NULL, 3591, 8),
(250690, NULL, 'PTHR11827', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 12, CATION COTRANSPORTERS', NULL, NULL, 4266, 8),
(250691, NULL, 'PTHR46351', NULL, NULL, NULL, NULL, 'WOUND-INDUCED PROTEIN WIN2', NULL, NULL, 36500, 8),
(250692, NULL, 'PTHR11905', NULL, NULL, NULL, NULL, 'ADAM  A DISINTEGRIN AND METALLOPROTEASE DOMAIN', NULL, NULL, NULL, 8),
(250693, NULL, 'PTHR28080', NULL, NULL, NULL, NULL, 'PEROXISOMAL BIOGENESIS FACTOR 3', NULL, NULL, 5522, 8),
(250694, NULL, 'PTHR16092', NULL, NULL, NULL, NULL, 'SEC3/SYNTAXIN-RELATED', NULL, NULL, NULL, 8),
(250695, NULL, 'PTHR38746', NULL, NULL, NULL, NULL, 'CBM49 DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(250696, NULL, 'PTHR33408', NULL, NULL, NULL, NULL, 'TRANSPOSASE', NULL, NULL, NULL, 8),
(250697, NULL, 'PTHR33376', NULL, NULL, NULL, NULL, '', NULL, NULL, 20315, 8),
(250698, NULL, 'PTHR34269', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR B3-DOMAIN FAMILY-RELATED', NULL, NULL, NULL, 8),
(250699, NULL, 'PTHR47004', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 24', NULL, NULL, NULL, 8),
(250700, NULL, 'PTHR30618', NULL, NULL, NULL, NULL, 'NCS1 FAMILY PURINE/PYRIMIDINE TRANSPORTER', NULL, NULL, 36738, 8),
(250701, NULL, 'PTHR42897', NULL, NULL, NULL, NULL, 'PYRUVATE SYNTHASE SUBUNIT PORB', NULL, NULL, NULL, 8),
(250702, NULL, 'PTHR48135', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(250703, NULL, 'PTHR46800', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY-RELATED-RELATED', NULL, NULL, 36481, 8),
(250704, NULL, 'PTHR31293', NULL, NULL, NULL, NULL, 'RNI-LIKE SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(250705, NULL, 'PTHR17206', NULL, NULL, NULL, NULL, 'PROLACTIN-RELEASING PEPTIDE', NULL, NULL, 25025, 8),
(250706, NULL, 'PTHR43401', NULL, NULL, NULL, NULL, 'L-THREONINE 3-DEHYDROGENASE', NULL, NULL, NULL, 8),
(250707, NULL, 'PTHR12329', NULL, NULL, NULL, NULL, 'BCL2-ASSOCIATED ATHANOGENE', NULL, NULL, 29536, 8),
(250708, NULL, 'PTHR36400', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L35', NULL, NULL, NULL, 8),
(250709, NULL, 'PTHR43521', NULL, NULL, NULL, NULL, 'ALPHA-AMINOADIPIC SEMIALDEHYDE DEHYDROGENASE', NULL, NULL, 34134, 8),
(250710, NULL, 'PTHR45812', NULL, NULL, NULL, NULL, 'DNA POLYMERASE ZETA CATALYTIC SUBUNIT', NULL, NULL, 24798, 8),
(250711, NULL, 'PTHR38109', NULL, NULL, NULL, NULL, 'PROTEIN YCGL', NULL, NULL, 24202, 8);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(250712, NULL, 'PTHR40733', NULL, NULL, NULL, NULL, 'ZINC-RIBBON RNA-BINDING PROTEIN INVOLVED IN TRANSLATION-RELATED', NULL, NULL, 34971, 8),
(250713, NULL, 'PTHR12654', NULL, NULL, NULL, NULL, 'BILE ACID BETA-GLUCOSIDASE-RELATED', NULL, NULL, NULL, 8),
(250714, NULL, 'PTHR36292', NULL, NULL, NULL, NULL, 'UPF0575 PROTEIN C19ORF67', NULL, NULL, NULL, 8),
(250715, NULL, 'PTHR15002', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 348, 8),
(250716, NULL, 'PTHR36116', NULL, NULL, NULL, NULL, 'UPF0060 MEMBRANE PROTEIN YNFA', NULL, NULL, 3360, 8),
(250717, NULL, 'PTHR43473', NULL, NULL, NULL, NULL, 'MAGNESIUM-CHELATASE SUBUNIT CHLD, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(250718, NULL, 'PTHR10359', NULL, NULL, NULL, NULL, 'A/G-SPECIFIC ADENINE GLYCOSYLASE/ENDONUCLEASE III', NULL, NULL, NULL, 8),
(250719, NULL, 'PTHR36846', NULL, NULL, NULL, NULL, 'PROTEIN VIAA', NULL, NULL, NULL, 8),
(250720, NULL, 'PTHR31707', NULL, NULL, NULL, NULL, 'PECTINESTERASE', NULL, NULL, NULL, 8),
(250721, NULL, 'PTHR33648', NULL, NULL, NULL, NULL, 'EMBRYO SAC 1', NULL, NULL, NULL, 8),
(250722, NULL, 'PTHR36569', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(250723, NULL, 'PTHR46759', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 72', NULL, NULL, 35709, 8),
(250724, NULL, 'PTHR20003', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN-RELATED', NULL, NULL, NULL, 8),
(250725, NULL, 'PTHR37709', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, 8703, 8),
(250726, NULL, 'PTHR21096', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 13001, 8),
(250727, NULL, 'PTHR23026', NULL, NULL, NULL, NULL, 'NADPH NITROREDUCTASE', NULL, NULL, NULL, 8),
(250728, NULL, 'PTHR35125', NULL, NULL, NULL, NULL, 'NEURON NAVIGATOR 1-LIKE-RELATED', NULL, NULL, 33335, 8),
(250729, NULL, 'PTHR12011', NULL, NULL, NULL, NULL, 'ADHESION G-PROTEIN COUPLED RECEPTOR', NULL, NULL, NULL, 8),
(250730, NULL, 'PTHR22780', NULL, NULL, NULL, NULL, 'ADAPTIN, ALPHA/GAMMA/EPSILON', NULL, NULL, NULL, 8),
(250731, NULL, 'PTHR46522', NULL, NULL, NULL, NULL, 'CYTIDINE MONOPHOSPHATE-N-ACETYLNEURAMINIC ACID HYDROXYLASE', NULL, NULL, 24438, 8),
(250732, NULL, 'PTHR13677', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 10285, 8),
(250733, NULL, 'PTHR45980', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(250734, NULL, 'PTHR46789', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN R1', NULL, NULL, NULL, 8),
(250735, NULL, 'PTHR46811', NULL, NULL, NULL, NULL, 'COILED-COIL-HELIX-COILED-COIL-HELIX DOMAIN-CONTAINING PROTEIN 7', NULL, NULL, NULL, 8),
(250736, NULL, 'PTHR12019', NULL, NULL, NULL, NULL, 'LAMINA-ASSOCIATED POLYPEPTIDE  THYMOPOIETIN', NULL, NULL, NULL, 8),
(250737, NULL, 'PTHR46369', NULL, NULL, NULL, NULL, 'PROTEIN CELLULOSE SYNTHASE INTERACTIVE 1', NULL, NULL, 35023, 8),
(250738, NULL, 'PTHR38097', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(250739, NULL, 'PTHR24320', NULL, NULL, NULL, NULL, 'RETINOL DEHYDROGENASE', NULL, NULL, NULL, 8),
(250740, NULL, 'PTHR48052', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', NULL, NULL, NULL, 8),
(250741, NULL, 'PTHR36066', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH145', NULL, NULL, 33201, 8),
(250742, NULL, 'PTHR39964', NULL, NULL, NULL, NULL, 'UPF0292 PROTEIN TK1411', NULL, NULL, NULL, 8),
(250743, NULL, 'PTHR36945', NULL, NULL, NULL, NULL, 'HIGH INCIDENCE OF MALES (INCREASED X CHROMOSOME LOSS)-RELATED-RELATED', NULL, NULL, NULL, 8),
(250744, NULL, 'PTHR47264', NULL, NULL, NULL, NULL, 'OS01G0128800 PROTEIN', NULL, NULL, NULL, 8),
(250745, NULL, 'PTHR13085', NULL, NULL, NULL, NULL, 'MICROSOMAL SIGNAL PEPTIDASE 25 KDA SUBUNIT', NULL, NULL, 663, 8),
(250746, NULL, 'PTHR46443', NULL, NULL, NULL, NULL, 'FCS-LIKE ZINC FINGER 8', NULL, NULL, 34281, 8),
(250747, NULL, 'PTHR21579', NULL, NULL, NULL, NULL, 'PROTEIN TINCAR', NULL, NULL, NULL, 8),
(250748, NULL, 'PTHR30173', NULL, NULL, NULL, NULL, 'SIGMA 19 FACTOR', NULL, NULL, NULL, 8),
(250749, NULL, 'PTHR12493', NULL, NULL, NULL, NULL, 'CUE DOMAIN CONTAINING 2', NULL, NULL, 33036, 8),
(250750, NULL, 'PTHR47396', NULL, NULL, NULL, NULL, 'TYPE I RESTRICTION ENZYME ECOKI R PROTEIN', NULL, NULL, NULL, 8);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(250751, NULL, 'PTHR33867', NULL, NULL, NULL, NULL, 'RIBOSOME MATURATION FACTOR RIMP', NULL, NULL, 6109, 8),
(250752, NULL, 'PTHR24418', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN KINASE', NULL, NULL, NULL, 8),
(250753, NULL, 'PTHR11783', NULL, NULL, NULL, NULL, 'SULFOTRANSFERASE  SULT', NULL, NULL, NULL, 8),
(250754, NULL, 'PTHR47043', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE TRANSFERASE SUBUNIT ALG13', NULL, NULL, NULL, 8),
(250755, NULL, 'PTHR39651', NULL, NULL, NULL, NULL, 'HOLLIDAY JUNCTION RESOLVASE HJC', NULL, NULL, 7574, 8),
(250756, NULL, 'PTHR47422', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK N-TERMINAL DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(250757, NULL, 'PTHR11246', NULL, NULL, NULL, NULL, 'PRE-MRNA SPLICING FACTOR', NULL, NULL, 36566, 8),
(250758, NULL, 'PTHR34188', NULL, NULL, NULL, NULL, 'OS01G0299500 PROTEIN', NULL, NULL, NULL, 8),
(250759, NULL, 'PTHR10910', NULL, NULL, NULL, NULL, 'EUKARYOTE SPECIFIC DSRNA BINDING PROTEIN', NULL, NULL, NULL, 8),
(250760, NULL, 'PTHR47754', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS X-RELATED', NULL, NULL, NULL, 8),
(250761, NULL, 'PTHR24109', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 31', NULL, NULL, 34226, 8),
(250762, NULL, 'PTHR43762', NULL, NULL, NULL, NULL, 'L-GULONOLACTONE OXIDASE', NULL, NULL, 5181, 8),
(250763, NULL, 'PTHR28532', NULL, NULL, NULL, NULL, 'GEO13458P1', NULL, NULL, NULL, 8),
(250764, NULL, 'PTHR11473', NULL, NULL, NULL, NULL, 'AROMATIC AMINO ACID HYDROXYLASE', NULL, NULL, 193, 8),
(250765, NULL, 'PTHR34220', NULL, NULL, NULL, NULL, 'SENSOR HISTIDINE KINASE YPDA', NULL, NULL, NULL, 8),
(250766, NULL, 'PTHR12933', NULL, NULL, NULL, NULL, 'ORF PROTEIN-RELATED', NULL, NULL, 9162, 8),
(250767, NULL, 'PTHR34936', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(250768, NULL, 'PTHR10760', NULL, NULL, NULL, NULL, 'TORSIN', NULL, NULL, 10400, 8),
(250769, NULL, 'PTHR31079', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 73', NULL, NULL, 34491, 8),
(250770, NULL, 'PTHR11267', NULL, NULL, NULL, NULL, 'T-BOX PROTEIN-RELATED', NULL, NULL, 3013, 8),
(250771, NULL, 'PTHR37766', NULL, NULL, NULL, NULL, 'OS01G0897100 PROTEIN', NULL, NULL, NULL, 8),
(250772, NULL, 'PTHR12276', NULL, NULL, NULL, NULL, 'EPSIN/ENT-RELATED', NULL, NULL, NULL, 8),
(250773, NULL, 'PTHR46691', NULL, NULL, NULL, NULL, 'HIGH MOBILITY GROUP B PROTEIN 9', NULL, NULL, NULL, 8),
(250774, NULL, 'PTHR44542', NULL, NULL, NULL, NULL, 'THIOSULFATE SULFURTRANSFERASE 18', NULL, NULL, 34841, 8),
(250775, NULL, 'PTHR10994', NULL, NULL, NULL, NULL, 'RETICULON', NULL, NULL, 36936, 8),
(250776, NULL, 'PTHR47074', NULL, NULL, NULL, NULL, 'BNAC02G40300D PROTEIN', NULL, NULL, NULL, 8),
(250777, NULL, 'PTHR17901', NULL, NULL, NULL, NULL, 'MAGNESIUM-DEPENDENT PHOSPHATASE 1 MDP1', NULL, NULL, 5183, 8),
(250778, NULL, 'PTHR12483', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 31  COPPER TRANSPORTERS', NULL, NULL, 7411, 8),
(250779, NULL, 'PTHR31509', NULL, NULL, NULL, NULL, 'BPS1-LIKE PROTEIN', NULL, NULL, NULL, 8),
(250780, NULL, 'PTHR45136', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(250781, NULL, 'PTHR46362', NULL, NULL, NULL, NULL, 'GEM-ASSOCIATED PROTEIN 5', NULL, NULL, NULL, 8),
(250782, NULL, 'PTHR28546', NULL, NULL, NULL, NULL, 'NEURONAL VESICLE TRAFFICKING-ASSOCIATED PROTEIN 2-RELATED', NULL, NULL, 8438, 8),
(250783, NULL, 'PTHR11825', NULL, NULL, NULL, NULL, 'SUBGROUP IIII AMINOTRANSFERASE', NULL, NULL, 5921, 8),
(250784, NULL, 'PTHR28673', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 108', NULL, NULL, 24830, 8),
(250785, NULL, 'PTHR42024', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(250786, NULL, 'PTHR31462', NULL, NULL, NULL, NULL, 'ENDOSOMAL/LYSOSOMAL POTASSIUM CHANNEL TMEM175', NULL, NULL, NULL, 8),
(250787, NULL, 'PTHR13112', NULL, NULL, NULL, NULL, 'UPF3 REGULATOR OF NONSENSE TRANSCRIPTS-LIKE PROTEIN', NULL, NULL, 31083, 8),
(250788, NULL, 'PTHR13779', NULL, NULL, NULL, NULL, 'WERNER HELICASE-INTERACTING PROTEIN 1 FAMILY MEMBER', NULL, NULL, NULL, 8);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(250789, NULL, 'PTHR33320', NULL, NULL, NULL, NULL, 'METHIONYL-TRNA SYNTHETASE', NULL, NULL, NULL, 8),
(250790, NULL, 'PTHR31245', NULL, NULL, NULL, NULL, 'UBIQUITIN SYSTEM COMPONENT CUE PROTEIN', NULL, NULL, NULL, 8),
(250791, NULL, 'PTHR30143', NULL, NULL, NULL, NULL, 'ACID HYDRATASE', NULL, NULL, NULL, 8),
(250792, NULL, 'PTHR35828', NULL, NULL, NULL, NULL, 'OS08G0203800 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(250793, NULL, 'PTHR23320', NULL, NULL, NULL, NULL, 'MEMBRANE-SPANNING 4-DOMAINS SUBFAMILY A  MS4A -RELATED', NULL, NULL, 24111, 8),
(250794, NULL, 'PTHR46945', NULL, NULL, NULL, NULL, 'CYSTATIN-9-LIKE', NULL, NULL, 34689, 8),
(250795, NULL, 'PTHR37738', NULL, NULL, NULL, NULL, 'OS03G0209700 PROTEIN', NULL, NULL, NULL, 8),
(250796, NULL, 'PTHR30265', NULL, NULL, NULL, NULL, 'RHO-INTERACTING TRANSCRIPTION TERMINATION FACTOR NUSG', NULL, NULL, 34062, 8),
(250797, NULL, 'PTHR31399', NULL, NULL, NULL, NULL, 'DNA-DIRECTED PRIMASE / POLYMERASE PROTEIN', NULL, NULL, 36669, 8),
(250798, NULL, 'PTHR18896', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE D', NULL, NULL, 18013, 8),
(250799, NULL, 'PTHR46111', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA SMALL SUBUNIT METHYLTRANSFERASE I', NULL, NULL, 7184, 8),
(250800, NULL, 'PTHR39455', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN ZAPD', NULL, NULL, 12942, 8),
(250801, NULL, 'PTHR33728', NULL, NULL, NULL, NULL, 'CTTNBP 2 AMINO-TERMINAL-LIKE PROTEIN', NULL, NULL, NULL, 8),
(250802, NULL, 'PTHR38543', NULL, NULL, NULL, NULL, 'OS04G0465800 PROTEIN', NULL, NULL, NULL, 8),
(250803, NULL, 'PTHR23121', NULL, NULL, NULL, NULL, 'SODIUM-DEPENDENT GLUCOSE TRANSPORTER 1', NULL, NULL, NULL, 8),
(250804, NULL, 'PTHR22420', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 23582, 8),
(250805, NULL, 'PTHR48191', NULL, NULL, NULL, NULL, 'PROTEIN HHL1 CHLOROPLASTIC', NULL, NULL, 35870, 8),
(250806, NULL, 'PTHR11801', NULL, NULL, NULL, NULL, 'SIGNAL TRANSDUCER AND ACTIVATOR OF TRANSCRIPTION', NULL, NULL, 1171, 8),
(250807, NULL, 'PTHR46987', NULL, NULL, NULL, NULL, 'NEUROHYPOPHYSIAL HORMONES, N-TERMINAL DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(250808, NULL, 'PTHR43525', NULL, NULL, NULL, NULL, 'PROTEIN MALY', NULL, NULL, NULL, 8),
(250809, NULL, 'PTHR34678', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN 5, CHLOROPLASTIC', NULL, NULL, 27180, 8),
(250810, NULL, 'PTHR33594', NULL, NULL, NULL, NULL, 'SUPERFAMILY HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G03035)-RELATED', NULL, NULL, NULL, 8),
(250811, NULL, 'PTHR40087', NULL, NULL, NULL, NULL, 'PHENOLIC ACID DECARBOXYLASE PADC', NULL, NULL, 12207, 8),
(250812, NULL, 'PTHR10570', NULL, NULL, NULL, NULL, 'T-CELL SURFACE GLYCOPROTEIN CD3 GAMMA CHAIN / DELTA CHAIN', NULL, NULL, 9498, 8),
(250813, NULL, 'PTHR48142', NULL, NULL, NULL, NULL, 'PIGMENTOSA GTPASE REGULATOR-LIKE PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(250814, NULL, 'PTHR18847', NULL, NULL, NULL, NULL, '20 KD NUCLEAR CAP BINDING PROTEIN', NULL, NULL, 26524, 8),
(250815, NULL, 'PTHR40727', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REGULATOR, ENCODED NEXT TO RECA SUPERFAMILY ATPASE-RELATED', NULL, NULL, NULL, 8),
(250816, NULL, 'PTHR10278', NULL, NULL, NULL, NULL, 'CORTICOTROPIN-RELEASING FACTOR-BINDING PROTEIN', NULL, NULL, 8954, 8),
(250817, NULL, 'PTHR35503', NULL, NULL, NULL, NULL, 'OSJNBA0006M15.15 PROTEIN', NULL, NULL, NULL, 8),
(250818, NULL, 'PTHR36744', NULL, NULL, NULL, NULL, 'CYTOCHROME OXIDASE ASSEMBLY PROTEIN', NULL, NULL, NULL, 8),
(250819, NULL, 'PTHR47716', NULL, NULL, NULL, NULL, 'WUSCHEL-RELATED HOMEOBOX 4', NULL, NULL, 35106, 8),
(250820, NULL, 'PTHR46475', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN NPR3', NULL, NULL, 36404, 8),
(250821, NULL, 'PTHR35162', NULL, NULL, NULL, NULL, 'OS08G0516600 PROTEIN', NULL, NULL, NULL, 8),
(250822, NULL, 'PTHR36040', NULL, NULL, NULL, NULL, 'OS04G0188500 PROTEIN', NULL, NULL, NULL, 8),
(250823, NULL, 'PTHR34556', NULL, NULL, NULL, NULL, '', NULL, NULL, 9458, 8),
(250824, NULL, 'PTHR46846', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS W-RELATED', NULL, NULL, NULL, 8),
(250825, NULL, 'PTHR46862', NULL, NULL, NULL, NULL, 'OS07G0661900 PROTEIN', NULL, NULL, NULL, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(250826, NULL, 'PTHR35885', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(250827, NULL, 'PTHR33513', NULL, NULL, NULL, NULL, 'OS06G0523300 PROTEIN', NULL, NULL, NULL, 8),
(250828, NULL, 'PTHR46493', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP3', NULL, NULL, 34429, 8),
(250829, NULL, 'PTHR46874', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 6', NULL, NULL, NULL, 8),
(250830, NULL, 'PTHR16839', NULL, NULL, NULL, NULL, 'GALANIN', NULL, NULL, 7165, 8),
(250831, NULL, 'PTHR46894', NULL, NULL, NULL, NULL, 'TSC22 DOMAIN FAMILY PROTEIN 2', NULL, NULL, NULL, 8),
(250832, NULL, 'PTHR34702', NULL, NULL, NULL, NULL, 'NA(+)/H(+) ANTIPORTER SUBUNIT F1', NULL, NULL, 1063, 8),
(250833, NULL, 'PTHR39944', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(250834, NULL, 'PTHR28399', NULL, NULL, NULL, NULL, 'BARTTIN', NULL, NULL, 26507, 8),
(250835, NULL, 'PTHR36055', NULL, NULL, NULL, NULL, 'C2H2-LIKE ZINC FINGER PROTEIN', NULL, NULL, NULL, 8),
(250836, NULL, 'PTHR30038', NULL, NULL, NULL, NULL, 'ALDEHYDE FERREDOXIN OXIDOREDUCTASE', NULL, NULL, NULL, 8),
(250837, NULL, 'PTHR23423', NULL, NULL, NULL, NULL, 'ORGANIC SOLUTE TRANSPORTER-RELATED', NULL, NULL, 5265, 8),
(250838, NULL, 'PTHR12916', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE POLYPEPTIDE VIC-2', NULL, NULL, NULL, 8),
(250839, NULL, 'PTHR12383', NULL, NULL, NULL, NULL, 'PROTEASE FAMILY S26 MITOCHONDRIAL INNER MEMBRANE PROTEASE-RELATED', NULL, NULL, NULL, 8),
(250840, NULL, 'PTHR47688', NULL, NULL, NULL, NULL, 'NLR FAMILY CARD DOMAIN-CONTAINING PROTEIN 4', NULL, NULL, 33752, 8),
(250841, NULL, 'PTHR13450', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 39S RIBOSOMAL PROTEIN L42', NULL, NULL, 15919, 8),
(250842, NULL, 'PTHR31751', NULL, NULL, NULL, NULL, 'SI:CH211-108C17.2-RELATED-RELATED', NULL, NULL, NULL, 8),
(250843, NULL, 'PTHR46852', NULL, NULL, NULL, NULL, 'ALKALINE CERAMIDASE', NULL, NULL, 34894, 8),
(250844, NULL, 'PTHR16877', NULL, NULL, NULL, NULL, 'HEPCIDIN', NULL, NULL, 10116, 8),
(250845, NULL, 'PTHR46267', NULL, NULL, NULL, NULL, 'SINGLE MYB HISTONE 4', NULL, NULL, 34383, 8),
(250846, NULL, 'PTHR31937', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 163', NULL, NULL, 24387, 8),
(250847, NULL, 'PTHR44749', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF RPS4-RLD 1', NULL, NULL, 35739, 8),
(250848, NULL, 'PTHR14568', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE SUPERFAMILY 6 MEMBER 1/2', NULL, NULL, NULL, 8),
(250849, NULL, 'PTHR46018', NULL, NULL, NULL, NULL, 'ZINC PHOSPHODIESTERASE ELAC PROTEIN 1', NULL, NULL, NULL, 8),
(250850, NULL, 'PTHR31190', NULL, NULL, NULL, NULL, 'DNA-BINDING DOMAIN', NULL, NULL, 34758, 8),
(250851, NULL, 'PTHR45786', NULL, NULL, NULL, NULL, 'DNA BINDING PROTEIN-LIKE', NULL, NULL, NULL, 8),
(250852, NULL, 'PTHR46867', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM9-2', NULL, NULL, 18142, 8),
(250853, NULL, 'PTHR47566', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(250854, NULL, 'PTHR21567', NULL, NULL, NULL, NULL, 'CLASP', NULL, NULL, NULL, 8),
(250855, NULL, 'PTHR47734', NULL, NULL, NULL, NULL, 'T-CELL IMMUNORECEPTOR WITH IG AND ITIM DOMAINS PROTEIN, TIGIT', NULL, NULL, 35317, 8),
(250856, NULL, 'PTHR21072', NULL, NULL, NULL, NULL, 'GPI TRANSAMIDASE COMPONENT PIG-S', NULL, NULL, 19458, 8),
(250857, NULL, 'PTHR37321', NULL, NULL, NULL, NULL, 'EXPORTED PROTEIN-RELATED', NULL, NULL, NULL, 8),
(250858, NULL, 'PTHR43082', NULL, NULL, NULL, NULL, 'FERREDOXIN-LIKE', NULL, NULL, 13575, 8),
(250859, NULL, 'PTHR10145', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR SPT6', NULL, NULL, 19610, 8),
(250860, NULL, 'PTHR43046', NULL, NULL, NULL, NULL, 'GDP-MANNOSE MANNOSYL HYDROLASE', NULL, NULL, NULL, 8),
(250861, NULL, 'PTHR48137', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(250862, NULL, 'PTHR19856', NULL, NULL, NULL, NULL, 'WD-REPEATCONTAINING PROTEIN  WDR1', NULL, NULL, NULL, 8),
(250863, NULL, 'PTHR26391', NULL, NULL, NULL, NULL, 'INACTIVE TYROSINE-PROTEIN KINASE 7', NULL, NULL, NULL, 8),
(250864, NULL, 'PTHR46708', NULL, NULL, NULL, NULL, 'TENASCIN', NULL, NULL, NULL, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(250865, NULL, 'PTHR24340', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN NKX', NULL, NULL, NULL, 8),
(250866, NULL, 'PTHR47337', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(250867, NULL, 'PTHR42987', NULL, NULL, NULL, NULL, 'PEPTIDASE S49', NULL, NULL, NULL, 8),
(250868, NULL, 'PTHR43717', NULL, NULL, NULL, NULL, 'ANAEROBIC NITRIC OXIDE REDUCTASE FLAVORUBREDOXIN', NULL, NULL, NULL, 8),
(250869, NULL, 'PTHR38421', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN USGS', NULL, NULL, NULL, 8),
(250870, NULL, 'PTHR35870', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G03330)-RELATED', NULL, NULL, 22351, 8),
(250871, NULL, 'PTHR35175', NULL, NULL, NULL, NULL, '', NULL, NULL, 9615, 8),
(250872, NULL, 'PTHR37613', NULL, NULL, NULL, NULL, 'DUF4378 DOMAIN PROTEIN', NULL, NULL, NULL, 8),
(250873, NULL, 'PTHR35247', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 43', NULL, NULL, 24155, 8),
(250874, NULL, 'PTHR46012', NULL, NULL, NULL, NULL, 'IP22168P', NULL, NULL, NULL, 8),
(250875, NULL, 'PTHR47143', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL CATION CHANNEL PROTEIN PAINLESS', NULL, NULL, NULL, 8),
(250876, NULL, 'PTHR14477', NULL, NULL, NULL, NULL, 'CUB DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, 32213, 8),
(250877, NULL, 'PTHR46887', NULL, NULL, NULL, NULL, 'TANDEM C2 DOMAINS NUCLEAR PROTEIN', NULL, NULL, 25374, 8),
(250878, NULL, 'PTHR10250', NULL, NULL, NULL, NULL, 'MICROSOMAL GLUTATHIONE S-TRANSFERASE', NULL, NULL, NULL, 8),
(250879, NULL, 'PTHR36918', NULL, NULL, NULL, NULL, '', NULL, NULL, 2087, 8),
(250880, NULL, 'PTHR34380', NULL, NULL, NULL, NULL, 'BNAA03G12380D PROTEIN', NULL, NULL, NULL, 8),
(250881, NULL, 'PTHR41244', NULL, NULL, NULL, NULL, 'RHAMNAN SYNTHESIS F', NULL, NULL, 26934, 8),
(250882, NULL, 'PTHR22802', NULL, NULL, NULL, NULL, 'C-TYPE LECTIN SUPERFAMILY MEMBER', NULL, NULL, NULL, 8),
(250883, NULL, 'PTHR32039', NULL, NULL, NULL, NULL, 'MAGNESIUM-CHELATASE SUBUNIT CHLI', NULL, NULL, 34265, 8),
(250884, NULL, 'PTHR35293', NULL, NULL, NULL, NULL, 'EGG CELL-SECRETED PROTEIN 1.5', NULL, NULL, 36078, 8),
(250885, NULL, 'PTHR22601', NULL, NULL, NULL, NULL, 'ISP4 LIKE PROTEIN', NULL, NULL, 2900, 8),
(250886, NULL, 'PTHR36197', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(250887, NULL, 'PTHR20946', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 36550, 8),
(250888, NULL, 'PTHR43156', NULL, NULL, NULL, NULL, 'STAGE II SPORULATION PROTEIN E-RELATED', NULL, NULL, NULL, 8),
(250889, NULL, 'PTHR46020', NULL, NULL, NULL, NULL, 'OSJNBB0059K02.9 PROTEIN', NULL, NULL, NULL, 8),
(250890, NULL, 'PTHR31761', NULL, NULL, NULL, NULL, 'GROWTH ARREST AND DNA DAMAGE-INDUCIBLE PROTEINS-INTERACTING PROTEIN 1 GADD45GIP1', NULL, NULL, 21350, 8),
(250891, NULL, 'PTHR46994', NULL, NULL, NULL, NULL, '5''-METHYLTHIOADENOSINE/S-ADENOSYLHOMOCYSTEINE NUCLEOSIDASE 1', NULL, NULL, 36724, 8),
(250892, NULL, 'PTHR23270', NULL, NULL, NULL, NULL, 'PROGRAMMED CELL DEATH PROTEIN 11  PRE-RRNA PROCESSING PROTEIN RRP5', NULL, NULL, 36410, 8),
(250893, NULL, 'PTHR31301', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 4-RELATED', NULL, NULL, NULL, 8),
(250894, NULL, 'PTHR22959', NULL, NULL, NULL, NULL, 'PYM PROTEIN', NULL, NULL, 33343, 8),
(250895, NULL, 'PTHR44137', NULL, NULL, NULL, NULL, 'BNAC03G44070D PROTEIN', NULL, NULL, NULL, 8),
(250896, NULL, 'PTHR31118', NULL, NULL, NULL, NULL, 'CYCLASE-LIKE PROTEIN 2', NULL, NULL, 5016, 8),
(250897, NULL, 'PTHR46053', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE MARCH4-LIKE', NULL, NULL, 33525, 8),
(250898, NULL, 'PTHR42968', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING', NULL, NULL, NULL, 8),
(250899, NULL, 'PTHR21563', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 32720, 8),
(250900, NULL, 'PTHR44888', NULL, NULL, NULL, NULL, 'HEPACAM FAMILY MEMBER 2-RELATED', NULL, NULL, NULL, 8),
(250901, NULL, 'PTHR31132', NULL, NULL, NULL, NULL, 'N-LYSINE METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(250902, NULL, 'PTHR33546', NULL, NULL, NULL, NULL, 'LARGE, MULTIFUNCTIONAL SECRETED PROTEIN-RELATED', NULL, NULL, NULL, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(250903, NULL, 'PTHR35675', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC100362216', NULL, NULL, NULL, 8),
(250904, NULL, 'PTHR28234', NULL, NULL, NULL, NULL, 'NUCLEAR CONTROL OF ATPASE PROTEIN 2', NULL, NULL, 7914, 8),
(250905, NULL, 'PTHR12827', NULL, NULL, NULL, NULL, 'MEIOTIC CHECKPOINT REGULATOR TSG24 FAMILY MEMBER', NULL, NULL, 22664, 8),
(250906, NULL, 'PTHR33091', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE, EXPRESSED-RELATED', NULL, NULL, 422, 8),
(250907, NULL, 'PTHR34210', NULL, NULL, NULL, NULL, 'OS01G0252900 PROTEIN', NULL, NULL, NULL, 8),
(250908, NULL, 'PTHR47185', NULL, NULL, NULL, NULL, 'PX DOMAIN-CONTAINING PROTEIN YPR097W', NULL, NULL, NULL, 8),
(250909, NULL, 'PTHR34613', NULL, NULL, NULL, NULL, 'SLL0800 PROTEIN', NULL, NULL, NULL, 8),
(250910, NULL, 'PTHR32546', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR 158-RELATED', NULL, NULL, 35266, 8),
(250911, NULL, 'PTHR15497', NULL, NULL, NULL, NULL, '3-HYDROXYANTHRANILATE 3,4-DIOXYGENASE', NULL, NULL, 8899, 8),
(250912, NULL, 'PTHR11418', NULL, NULL, NULL, NULL, 'GLUCAGON', NULL, NULL, 8430, 8),
(250913, NULL, 'PTHR43380', NULL, NULL, NULL, NULL, '2-OXOISOVALERATE DEHYDROGENASE SUBUNIT ALPHA, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(250914, NULL, 'PTHR30447', NULL, NULL, NULL, NULL, 'FRUCTOSE-1,6-BISPHOSPHATASE CLASS 2', NULL, NULL, 7391, 8),
(250915, NULL, 'PTHR33882', NULL, NULL, NULL, NULL, 'PATHOGENIC TYPE III EFFECTOR AVIRULENCE FACTOR AVR AVRRPT-CLEAVAGE: CLEAVAGE SITE PROTEIN', NULL, NULL, NULL, 8),
(250916, NULL, 'PTHR46385', NULL, NULL, NULL, NULL, 'PAIRED MESODERM HOMEOBOX PROTEIN 1-RELATED', NULL, NULL, 34827, 8),
(250917, NULL, 'PTHR15440', NULL, NULL, NULL, NULL, 'XRP2 PROTEIN', NULL, NULL, 27242, 8),
(250918, NULL, 'PTHR11799', NULL, NULL, NULL, NULL, 'PARAOXONASE', NULL, NULL, NULL, 8),
(250919, NULL, 'PTHR22942', NULL, NULL, NULL, NULL, 'RECA/RAD51/RADA DNA STRAND-PAIRING FAMILY MEMBER', NULL, NULL, NULL, 8),
(250920, NULL, 'PTHR12702', NULL, NULL, NULL, NULL, 'SEC15', NULL, NULL, 6884, 8),
(250921, NULL, 'PTHR48250', NULL, NULL, NULL, NULL, 'CUTINASE 2-RELATED', NULL, NULL, NULL, 8),
(250922, NULL, 'PTHR46556', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY DOMAIN-CONTAINING FAMILY M MEMBER 2', NULL, NULL, NULL, 8),
(250923, NULL, 'PTHR16135', NULL, NULL, NULL, NULL, 'REPRESSOR OF YIELD OF DENV PROTEIN', NULL, NULL, 22422, 8),
(250924, NULL, 'PTHR21328', NULL, NULL, NULL, NULL, 'POLY  ADP-RIBOSE  POLYMERASE FAMILY, MEMBER  PARP', NULL, NULL, NULL, 8),
(250925, NULL, 'PTHR20992', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 11474, 8),
(250926, NULL, 'PTHR36245', NULL, NULL, NULL, NULL, 'GLYCINE-RICH PROTEIN DOT1-LIKE', NULL, NULL, NULL, 8),
(250927, NULL, 'PTHR45168', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY B MEMBER 2', NULL, NULL, 37256, 8),
(250928, NULL, 'PTHR36383', NULL, NULL, NULL, NULL, 'OS09G0529350 PROTEIN', NULL, NULL, NULL, 8),
(250929, NULL, 'PTHR34832', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN W', NULL, NULL, NULL, 8),
(250930, NULL, 'PTHR22590', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(250931, NULL, 'PTHR46177', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(250932, NULL, 'PTHR42264', NULL, NULL, NULL, NULL, 'EPHRIN_REC_LIKE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(250933, NULL, 'PTHR43511', NULL, NULL, NULL, NULL, '', NULL, NULL, 19925, 8),
(250934, NULL, 'PTHR31175', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE FAMILY PROTEIN', NULL, NULL, 6134, 8),
(250935, NULL, 'PTHR13120', NULL, NULL, NULL, NULL, 'PHD FINGER-LIKE DOMAIN-CONTAINING PROTEIN 5A', NULL, NULL, 6256, 8),
(250936, NULL, 'PTHR47672', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE SNT2', NULL, NULL, 22327, 8),
(250937, NULL, 'PTHR11751', NULL, NULL, NULL, NULL, 'ALANINE AMINOTRANSFERASE', NULL, NULL, 36780, 8),
(250938, NULL, 'PTHR20994', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 12435, 8),
(250939, NULL, 'PTHR31949', NULL, NULL, NULL, NULL, 'GASTRIC MUCIN-LIKE PROTEIN', NULL, NULL, NULL, 8),
(250940, NULL, 'PTHR40279', NULL, NULL, NULL, NULL, 'PQQC-LIKE PROTEIN', NULL, NULL, 32514, 8);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(250941, NULL, 'PTHR37079', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE ATM', NULL, NULL, 30837, 8),
(250942, NULL, 'PTHR47652', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM44', NULL, NULL, NULL, 8),
(250943, NULL, 'PTHR43561', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(250944, NULL, 'PTHR22740', NULL, NULL, NULL, NULL, 'PROTEIN KRBA1', NULL, NULL, 31637, 8),
(250945, NULL, 'PTHR43142', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE', NULL, NULL, NULL, 8),
(250946, NULL, 'PTHR15075', NULL, NULL, NULL, NULL, 'ALPHA-MANNOSIDE BETA-1,6-N-ACETYLGLUCOSAMINYLTRANSFERASE', NULL, NULL, NULL, 8),
(250947, NULL, 'PTHR34451', NULL, NULL, NULL, NULL, 'PHD FINGER FAMILY PROTEIN', NULL, NULL, NULL, 8),
(250948, NULL, 'PTHR11059', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RECN', NULL, NULL, 818, 8),
(250949, NULL, 'PTHR46570', NULL, NULL, NULL, NULL, 'TUBULIN--TYROSINE LIGASE', NULL, NULL, NULL, 8),
(250950, NULL, 'PTHR35272', NULL, NULL, NULL, NULL, 'THIOL:DISULFIDE INTERCHANGE PROTEIN DSBC-RELATED', NULL, NULL, NULL, 8),
(250951, NULL, 'PTHR38329', NULL, NULL, NULL, NULL, 'CECROPIN-A1-RELATED', NULL, NULL, 19596, 8),
(250952, NULL, 'PTHR11702', NULL, NULL, NULL, NULL, 'DEVELOPMENTALLY REGULATED GTP-BINDING PROTEIN-RELATED', NULL, NULL, 35604, 8),
(250953, NULL, 'PTHR31893', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 151 HOMOLOG', NULL, NULL, 24227, 8),
(250954, NULL, 'PTHR36135', NULL, NULL, NULL, NULL, 'FIBROUS SHEATH CABYR-BINDING PROTEIN', NULL, NULL, 34552, 8),
(250955, NULL, 'PTHR46375', NULL, NULL, NULL, NULL, 'KELCH REPEAT AND BTB DOMAIN-CONTAINING PROTEIN 13-RELATED', NULL, NULL, NULL, 8),
(250956, NULL, 'PTHR36503', NULL, NULL, NULL, NULL, 'BLR2520 PROTEIN', NULL, NULL, NULL, 8),
(250957, NULL, 'PTHR11292', NULL, NULL, NULL, NULL, 'T-CELL SURFACE GLYCOPROTEIN CD8 BETA CHAIN', NULL, NULL, 34473, 8),
(250958, NULL, 'PTHR30043', NULL, NULL, NULL, NULL, 'PHOSPHONATES TRANSPORT SYSTEM PERMEASE PROTEIN', NULL, NULL, NULL, 8),
(250959, NULL, 'PTHR39583', NULL, NULL, NULL, NULL, 'TYPE II SECRETION SYSTEM PROTEIN J-RELATED', NULL, NULL, NULL, 8),
(250960, NULL, 'PTHR21362', NULL, NULL, NULL, NULL, 'ACROSIN-BINDING PROTEIN', NULL, NULL, 14387, 8),
(250961, NULL, 'PTHR34914', NULL, NULL, NULL, NULL, 'LYMPHOCYTE EXPANSION MOLECULE', NULL, NULL, 27740, 8),
(250962, NULL, 'PTHR10218', NULL, NULL, NULL, NULL, 'GTP-BINDING PROTEIN ALPHA SUBUNIT', NULL, NULL, 5409, 8),
(250963, NULL, 'PTHR15507', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN RLF', NULL, NULL, NULL, 8),
(250964, NULL, 'PTHR43806', NULL, NULL, NULL, NULL, 'PEPTIDASE S8', NULL, NULL, NULL, 8),
(250965, NULL, 'PTHR35811', NULL, NULL, NULL, NULL, 'SLR1870 PROTEIN', NULL, NULL, NULL, 8),
(250966, NULL, 'PTHR12646', NULL, NULL, NULL, NULL, 'NOT56 - RELATED', NULL, NULL, 3271, 8),
(250967, NULL, 'PTHR34289', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (DUF819)-RELATED', NULL, NULL, 13257, 8),
(250968, NULL, 'PTHR34847', NULL, NULL, NULL, NULL, 'NODULATION PROTEIN U', NULL, NULL, NULL, 8),
(250969, NULL, 'PTHR28375', NULL, NULL, NULL, NULL, 'PROTEIN HINDERIN', NULL, NULL, 26431, 8),
(250970, NULL, 'PTHR47709', NULL, NULL, NULL, NULL, 'SHORT TRANSMEMBRANE MITOCHONDRIAL PROTEIN 1', NULL, NULL, 25896, 8),
(250971, NULL, 'PTHR46390', NULL, NULL, NULL, NULL, 'MANNOSE-1-PHOSPHATE GUANYLYLTRANSFERASE', NULL, NULL, NULL, 8),
(250972, NULL, 'PTHR43117', NULL, NULL, NULL, NULL, 'OSMOPROTECTANT IMPORT ATP-BINDING PROTEIN OSMV', NULL, NULL, NULL, 8),
(250973, NULL, 'PTHR22811', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE EMP24 DOMAIN-CONTAINING PROTEIN', NULL, NULL, 11378, 8),
(250974, NULL, 'PTHR10209', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE, 2OG-FE II  OXYGENASE FAMILY PROTEIN', NULL, NULL, NULL, 8),
(250975, NULL, 'PTHR31854', NULL, NULL, NULL, NULL, 'TUBULIN POLYGLUTAMYLASE COMPLEX SUBUNIT 2', NULL, NULL, 33297, 8),
(250976, NULL, 'PTHR12350', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE N-METHYLTRANSFERASE-RELATED', NULL, NULL, NULL, 8),
(250977, NULL, 'PTHR11200', NULL, NULL, NULL, NULL, 'INOSITOL 5-PHOSPHATASE', NULL, NULL, NULL, 8);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(250978, NULL, 'PTHR31686', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(250979, NULL, 'PTHR14359', NULL, NULL, NULL, NULL, 'HOMO-OLIGOMERIC FLAVIN CONTAINING CYS DECARBOXYLASE FAMILY', NULL, NULL, NULL, 8),
(250980, NULL, 'PTHR10134', NULL, NULL, NULL, NULL, 'CYTOCHROME B-C1 COMPLEX SUBUNIT RIESKE, MITOCHONDRIAL', NULL, NULL, 6170, 8),
(250981, NULL, 'PTHR12370', NULL, NULL, NULL, NULL, 'PHOSPHOLIPASE B-RELATED', NULL, NULL, 6306, 8),
(250982, NULL, 'PTHR15294', NULL, NULL, NULL, NULL, 'RETINOVIN-RELATED', NULL, NULL, 31666, 8),
(250983, NULL, 'PTHR22045', NULL, NULL, NULL, NULL, 'PROLINE AND SERINE-RICH PROTEIN 3', NULL, NULL, 31110, 8),
(250984, NULL, 'PTHR13408', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE III', NULL, NULL, 2101, 8),
(250985, NULL, 'PTHR12087', NULL, NULL, NULL, NULL, 'ORIGIN RECOGNITION COMPLEX SUBUNIT 4', NULL, NULL, 16053, 8),
(250986, NULL, 'PTHR10972', NULL, NULL, NULL, NULL, 'OXYSTEROL-BINDING PROTEIN-RELATED', NULL, NULL, 4244, 8),
(250987, NULL, 'PTHR33203', NULL, NULL, NULL, NULL, 'OLEOSIN', NULL, NULL, 1548, 8),
(250988, NULL, 'PTHR15811', NULL, NULL, NULL, NULL, 'MTH938 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(250989, NULL, 'PTHR32319', NULL, NULL, NULL, NULL, 'BACTERIAL HEMOLYSIN-LIKE PROTEIN', NULL, NULL, NULL, 8),
(250990, NULL, 'PTHR42964', NULL, NULL, NULL, NULL, 'ENOYL-COA HYDRATASE', NULL, NULL, NULL, 8),
(250991, NULL, 'PTHR35104', NULL, NULL, NULL, NULL, 'OS03G0807000 PROTEIN', NULL, NULL, NULL, 8),
(250992, NULL, 'PTHR48166', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(250993, NULL, 'PTHR34575', NULL, NULL, NULL, NULL, 'PROTEIN PAM68, CHLOROPLASTIC', NULL, NULL, 19978, 8),
(250994, NULL, 'PTHR38663', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(250995, NULL, 'PTHR21495', NULL, NULL, NULL, NULL, 'NUCLEOPORIN-RELATED', NULL, NULL, 3613, 8),
(250996, NULL, 'PTHR12195', NULL, NULL, NULL, NULL, 'CYTOPLASMIC FMR1-INTERACTING PROTEIN-RELATED', NULL, NULL, 6304, 8),
(250997, NULL, 'PTHR43392', NULL, NULL, NULL, NULL, 'AAA-TYPE ATPASE FAMILY PROTEIN / ANKYRIN REPEAT FAMILY PROTEIN', NULL, NULL, NULL, 8),
(250998, NULL, 'PTHR45176', NULL, NULL, NULL, NULL, 'TRANSDUCIN FAMILY PROTEIN / WD-40 REPEAT FAMILY PROTEIN-RELATED', NULL, NULL, NULL, 8),
(250999, NULL, 'PTHR46225', NULL, NULL, NULL, NULL, 'C3H4 TYPE ZINC FINGER PROTEIN', NULL, NULL, NULL, 8),
(251000, NULL, 'PTHR35502', NULL, NULL, NULL, NULL, 'PROTEIN MICROTUBULE BINDING PROTEIN 2C', NULL, NULL, 27492, 8),
(251001, NULL, 'PTHR39408', NULL, NULL, NULL, NULL, 'MUCIN-21', NULL, NULL, 27951, 8),
(251002, NULL, 'PTHR39329', NULL, NULL, NULL, NULL, 'ETHANOLAMINE AMMONIA-LYASE HEAVY CHAIN', NULL, NULL, 9112, 8),
(251003, NULL, 'PTHR14396', NULL, NULL, NULL, NULL, 'CLASPIN', NULL, NULL, 11430, 8),
(251004, NULL, 'PTHR16219', NULL, NULL, NULL, NULL, 'AUGMIN SUBUNIT 4 FAMILY MEMBER', NULL, NULL, 21875, 8),
(251005, NULL, 'PTHR13384', NULL, NULL, NULL, NULL, 'G PATCH DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(251006, NULL, 'PTHR45763', NULL, NULL, NULL, NULL, 'HYDROLASE, ALPHA/BETA FOLD FAMILY PROTEIN, EXPRESSED-RELATED', NULL, NULL, NULL, 8),
(251007, NULL, 'PTHR10732', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN S17', NULL, NULL, 1414, 8),
(251008, NULL, 'PTHR31333', NULL, NULL, NULL, NULL, 'PWWP DOMAIN-CONTAINING DNA REPAIR FACTOR 3 FAMILY MEMBER', NULL, NULL, 27697, 8),
(251009, NULL, 'PTHR30565', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(251010, NULL, 'PTHR35001', NULL, NULL, NULL, NULL, 'COLLAGEN IV NC1 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(251011, NULL, 'PTHR21677', NULL, NULL, NULL, NULL, 'CRAMPED PROTEIN', NULL, NULL, NULL, 8),
(251012, NULL, 'PTHR47363', NULL, NULL, NULL, NULL, 'GLUCOKINASE', NULL, NULL, NULL, 8),
(251013, NULL, 'PTHR36728', NULL, NULL, NULL, NULL, 'NAD(P)H-QUINONE OXIDOREDUCTASE SUBUNIT O, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(251014, NULL, 'PTHR31758', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN YLR108C', NULL, NULL, NULL, 8),
(251015, NULL, 'PTHR31503', NULL, NULL, NULL, NULL, 'VACUOLAR CALCIUM ION TRANSPORTER', NULL, NULL, 3045, 8);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(251016, NULL, 'PTHR42830', NULL, NULL, NULL, NULL, 'OSMOTICALLY INDUCIBLE FAMILY PROTEIN', NULL, NULL, NULL, 8),
(251017, NULL, 'PTHR13809', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN GAMMA SUBUNIT', NULL, NULL, 5459, 8),
(251018, NULL, 'PTHR16294', NULL, NULL, NULL, NULL, 'DYSTROBREVIN BINDING PROTEIN 1  DYSBINDIN', NULL, NULL, 10666, 8),
(251019, NULL, 'PTHR12668', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 14, 15', NULL, NULL, 6207, 8),
(251020, NULL, 'PTHR12753', NULL, NULL, NULL, NULL, 'AD-003 - RELATED', NULL, NULL, 13883, 8),
(251021, NULL, 'PTHR47986', NULL, NULL, NULL, NULL, 'OSJNBA0070M12.3 PROTEIN', NULL, NULL, NULL, 8),
(251022, NULL, 'PTHR45846', NULL, NULL, NULL, NULL, 'TRNA-DIHYDROURIDINE(47) SYNTHASE [NAD(P)(+)]-LIKE', NULL, NULL, NULL, 8),
(251023, NULL, 'PTHR47300', NULL, NULL, NULL, NULL, 'PROTEIN KASH5', NULL, NULL, 23749, 8),
(251024, NULL, 'PTHR37317', NULL, NULL, NULL, NULL, 'BLR8090 PROTEIN', NULL, NULL, NULL, 8),
(251025, NULL, 'PTHR31075', NULL, NULL, NULL, NULL, '', NULL, NULL, 31171, 8),
(251026, NULL, 'PTHR48040', NULL, NULL, NULL, NULL, 'PLEIOTROPIC DRUG RESISTANCE PROTEIN 1-LIKE ISOFORM X1', NULL, NULL, NULL, 8),
(251027, NULL, 'PTHR42727', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORT SYSTEM PERMEASE PROTEIN', NULL, NULL, NULL, 8),
(251028, NULL, 'PTHR24171', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 39-RELATED', NULL, NULL, NULL, 8),
(251029, NULL, 'PTHR43083', NULL, NULL, NULL, NULL, 'MANNAN POLYMERASE II', NULL, NULL, NULL, 8),
(251030, NULL, 'PTHR46840', NULL, NULL, NULL, NULL, 'ARMADILLO REPEAT-CONTAINING PROTEIN 1', NULL, NULL, 19473, 8),
(251031, NULL, 'PTHR47305', NULL, NULL, NULL, NULL, 'BEN DOMAIN-CONTAINING PROTEIN 2', NULL, NULL, NULL, 8),
(251032, NULL, 'PTHR23214', NULL, NULL, NULL, NULL, 'NEUROFILAMENT TRIPLET H PROTEIN', NULL, NULL, 30711, 8),
(251033, NULL, 'PTHR15087', NULL, NULL, NULL, NULL, 'PROTEIN NPAT', NULL, NULL, NULL, 8),
(251034, NULL, 'PTHR15348', NULL, NULL, NULL, NULL, 'AT-RICH INTERACTIVE DOMAIN-CONTAINING PROTEIN  ARID DOMAIN- CONTAINING PROTEIN   DEAD RINGER PROTEIN   B-CELL REGULATOR OF IGH TRANSCRIPTION   BRIGHT', NULL, NULL, 36876, 8),
(251035, NULL, 'PTHR23516', NULL, NULL, NULL, NULL, 'SAM (S-ADENOSYL METHIONINE) TRANSPORTER', NULL, NULL, 12252, 8),
(251036, NULL, 'PTHR47964', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE HOMOLOG RECG, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(251037, NULL, 'PTHR11440', NULL, NULL, NULL, NULL, 'LECITHIN-CHOLESTEROL ACYLTRANSFERASE-RELATED', NULL, NULL, NULL, 8),
(251038, NULL, 'PTHR21090', NULL, NULL, NULL, NULL, 'AROM/DEHYDROQUINATE SYNTHASE', NULL, NULL, NULL, 8),
(251039, NULL, 'PTHR40240', NULL, NULL, NULL, NULL, 'PLEXUS, ISOFORM A', NULL, NULL, NULL, 8),
(251040, NULL, 'PTHR10782', NULL, NULL, NULL, NULL, 'ZINC FINGER MIZ DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(251041, NULL, 'PTHR19444', NULL, NULL, NULL, NULL, 'UNC-93 RELATED', NULL, NULL, NULL, 8),
(251042, NULL, 'PTHR15830', NULL, NULL, NULL, NULL, 'TELOMERE LENGTH REGULATION PROTEIN TEL2 FAMILY MEMBER', NULL, NULL, NULL, 8),
(251043, NULL, 'PTHR31174', NULL, NULL, NULL, NULL, 'SEED MATURATION FAMILY PROTEIN', NULL, NULL, 35126, 8),
(251044, NULL, 'PTHR34989', NULL, NULL, NULL, NULL, 'PROTEIN HDED', NULL, NULL, NULL, 8),
(251045, NULL, 'PTHR10627', NULL, NULL, NULL, NULL, 'SCP160', NULL, NULL, NULL, 8),
(251046, NULL, 'PTHR35809', NULL, NULL, NULL, NULL, 'ARCHAETIDYLSERINE DECARBOXYLASE PROENZYME-RELATED', NULL, NULL, 29584, 8),
(251047, NULL, 'PTHR46557', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 10-RELATED', NULL, NULL, NULL, 8),
(251048, NULL, 'PTHR31730', NULL, NULL, NULL, NULL, 'OS01G0873900 PROTEIN', NULL, NULL, 35690, 8),
(251049, NULL, 'PTHR34222', NULL, NULL, NULL, NULL, 'GAG_PRE-INTEGRS DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(251050, NULL, 'PTHR13578', NULL, NULL, NULL, NULL, 'ADDITIONAL SEX COMBS LIKE PROTEIN  ASXL', NULL, NULL, 22397, 8),
(251051, NULL, 'PTHR37999', NULL, NULL, NULL, NULL, 'MUCIN-17', NULL, NULL, NULL, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(251052, NULL, 'PTHR13833', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(251053, NULL, 'PTHR30365', NULL, NULL, NULL, NULL, 'CYTOCHROME D UBIQUINOL OXIDASE', NULL, NULL, 1608, 8),
(251054, NULL, 'PTHR23357', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 27360, 8),
(251055, NULL, 'PTHR12122', NULL, NULL, NULL, NULL, 'RETINAL CONE RHODOPSIN-SENSITIVE CGMP 3'',5''-CYCLIC PHOSPHODIESTERASE GAMMA-SUBUNIT-RELATED', NULL, NULL, 5996, 8),
(251056, NULL, 'PTHR33739', NULL, NULL, NULL, NULL, 'OS07G0681500 PROTEIN', NULL, NULL, 27414, 8),
(251057, NULL, 'PTHR14387', NULL, NULL, NULL, NULL, 'THADA/DEATH RECEPTOR INTERACTING PROTEIN', NULL, NULL, NULL, 8),
(251058, NULL, 'PTHR38370', NULL, NULL, NULL, NULL, 'BETA-1,4-XYLOSIDASE', NULL, NULL, NULL, 8),
(251059, NULL, 'PTHR46002', NULL, NULL, NULL, NULL, 'EG:114D9.1 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(251060, NULL, 'PTHR40326', NULL, NULL, NULL, NULL, 'PROTEIN CBG10816', NULL, NULL, NULL, 8),
(251061, NULL, 'PTHR12137', NULL, NULL, NULL, NULL, 'CARBOHYDRATE SULFOTRANSFERASE', NULL, NULL, 12877, 8),
(251062, NULL, 'PTHR38025', NULL, NULL, NULL, NULL, 'TRP OPERON REPRESSOR', NULL, NULL, 18602, 8),
(251063, NULL, 'PTHR40688', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(251064, NULL, 'PTHR46332', NULL, NULL, NULL, NULL, 'ASPARTATE BETA-HYDROXYLASE DOMAIN-CONTAINING PROTEIN 2', NULL, NULL, NULL, 8),
(251065, NULL, 'PTHR23424', NULL, NULL, NULL, NULL, 'SERUM AMYLOID A', NULL, NULL, NULL, 8),
(251066, NULL, 'PTHR47180', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-BINDING PROTEIN GGA1-RELATED', NULL, NULL, NULL, 8),
(251067, NULL, 'PTHR38394', NULL, NULL, NULL, NULL, 'NEUROFILAMENT LIGHT PROTEIN', NULL, NULL, NULL, 8),
(251068, NULL, 'PTHR23079', NULL, NULL, NULL, NULL, 'RNA-DEPENDENT RNA POLYMERASE', NULL, NULL, 2352, 8),
(251069, NULL, 'PTHR45900', NULL, NULL, NULL, NULL, 'RECA', NULL, NULL, 7303, 8),
(251070, NULL, 'PTHR38226', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(251071, NULL, 'PTHR47108', NULL, NULL, NULL, NULL, '5-AMINO-6-(5-PHOSPHO-D-RIBITYLAMINO)URACIL PHOSPHATASE, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(251072, NULL, 'PTHR13173', NULL, NULL, NULL, NULL, 'WW DOMAIN BINDING PROTEIN 4', NULL, NULL, 27020, 8),
(251073, NULL, 'PTHR24393', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', NULL, NULL, NULL, 8),
(251074, NULL, 'PTHR32008', NULL, NULL, NULL, NULL, 'MATURIN', NULL, NULL, 25645, 8),
(251075, NULL, 'PTHR39466', NULL, NULL, NULL, NULL, 'RGS DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(251076, NULL, 'PTHR12271', NULL, NULL, NULL, NULL, 'POLY A  POLYMERASE CID  PAP -RELATED', NULL, NULL, NULL, 8),
(251077, NULL, 'PTHR28541', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 15', NULL, NULL, 27045, 8),
(251078, NULL, 'PTHR31731', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(251079, NULL, 'PTHR34984', NULL, NULL, NULL, NULL, 'CARBON STORAGE REGULATOR', NULL, NULL, 2339, 8),
(251080, NULL, 'PTHR10497', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L27', NULL, NULL, 1179, 8),
(251081, NULL, 'PTHR48069', NULL, NULL, NULL, NULL, 'DIHYDROFOLATE REDUCTASE', NULL, NULL, 11718, 8),
(251082, NULL, 'PTHR23184', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 14', NULL, NULL, 31499, 8),
(251083, NULL, 'PTHR46073', NULL, NULL, NULL, NULL, 'CHITINASE', NULL, NULL, NULL, 8),
(251084, NULL, 'PTHR46135', NULL, NULL, NULL, NULL, 'NME/NM23 FAMILY MEMBER 8', NULL, NULL, NULL, 8),
(251085, NULL, 'PTHR10971', NULL, NULL, NULL, NULL, 'MRNA EXPORT FACTOR AND BUB3', NULL, NULL, NULL, 8),
(251086, NULL, 'PTHR39165', NULL, NULL, NULL, NULL, 'IG HYPOTHETICAL 17883', NULL, NULL, NULL, 8),
(251087, NULL, 'PTHR46657', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 128 KDA', NULL, NULL, 23320, 8),
(251088, NULL, 'PTHR13417', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(251089, NULL, 'PTHR12299', NULL, NULL, NULL, NULL, 'HYALURONIC ACID-BINDING PROTEIN 4', NULL, NULL, 31139, 8),
(251090, NULL, 'PTHR12858', NULL, NULL, NULL, NULL, 'RIBOSOME BIOGENESIS PROTEIN', NULL, NULL, 33128, 8),
(251091, NULL, 'PTHR34115', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(251092, NULL, 'PTHR35579', NULL, NULL, NULL, NULL, 'CRISPR SYSTEM CMS ENDORIBONUCLEASE CSM3', NULL, NULL, NULL, 8),
(251093, NULL, 'PTHR36000', NULL, NULL, NULL, NULL, 'DEFECTIVE 1273 PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(251094, NULL, 'PTHR36299', NULL, NULL, NULL, NULL, 'AGAP008005-PA', NULL, NULL, NULL, 8),
(251095, NULL, 'PTHR33119', NULL, NULL, NULL, NULL, 'IFI3P', NULL, NULL, 22357, 8),
(251096, NULL, 'PTHR33698', NULL, NULL, NULL, NULL, 'NUCLEAR TRANSPORT FACTOR 2 (NTF2)-LIKE PROTEIN', NULL, NULL, NULL, 8),
(251097, NULL, 'PTHR33577', NULL, NULL, NULL, NULL, 'STERIGMATOCYSTIN BIOSYNTHESIS PEROXIDASE STCC-RELATED', NULL, NULL, NULL, 8),
(251098, NULL, 'PTHR11099', NULL, NULL, NULL, NULL, 'VACUOLAR SORTING PROTEIN 35', NULL, NULL, 6439, 8),
(251099, NULL, 'PTHR43248', NULL, NULL, NULL, NULL, '2-SUCCINYL-6-HYDROXY-2,4-CYCLOHEXADIENE-1-CARBOXYLATE SYNTHASE', NULL, NULL, NULL, 8),
(251100, NULL, 'PTHR21013', NULL, NULL, NULL, NULL, 'ATP SYNTHASE MITOCHONDRIAL F1 COMPLEX ASSEMBLY FACTOR 2/ATP12 PROTEIN, MITOCHONDRIAL PRECURSOR', NULL, NULL, 13982, 8),
(251101, NULL, 'PTHR43172', NULL, NULL, NULL, NULL, 'ADENYLOSUCCINATE LYASE', NULL, NULL, NULL, 8),
(251102, NULL, 'PTHR47409', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN PROPHET OF PIT-1', NULL, NULL, 36676, 8),
(251103, NULL, 'PTHR46042', NULL, NULL, NULL, NULL, 'DIPHTHINE METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(251104, NULL, 'PTHR12156', NULL, NULL, NULL, NULL, 'PLECKSTRIN HOMOLOGY-LIKE DOMAIN, FAMILY B, MEMBER 3', NULL, NULL, NULL, 8),
(251105, NULL, 'PTHR43179', NULL, NULL, NULL, NULL, 'RHAMNOSYLTRANSFERASE WBBL', NULL, NULL, NULL, 8),
(251106, NULL, 'PTHR36690', NULL, NULL, NULL, NULL, 'PROTEIN FAM237A', NULL, NULL, 27685, 8),
(251107, NULL, 'PTHR40261', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(251108, NULL, 'PTHR15135', NULL, NULL, NULL, NULL, 'STAC', NULL, NULL, 28421, 8),
(251109, NULL, 'PTHR33372', NULL, NULL, NULL, NULL, '', NULL, NULL, 19073, 8),
(251110, NULL, 'PTHR43155', NULL, NULL, NULL, NULL, 'CYCLIC DI-GMP PHOSPHODIESTERASE PA4108-RELATED', NULL, NULL, NULL, 8),
(251111, NULL, 'PTHR36688', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(251112, NULL, 'PTHR37471', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', NULL, NULL, NULL, 8),
(251113, NULL, 'PTHR32179', NULL, NULL, NULL, NULL, 'NICOTINATE-NUCLEOTIDE PYROPHOSPHORYLASE [CARBOXYLATING]', NULL, NULL, 26455, 8),
(251114, NULL, 'PTHR12924', NULL, NULL, NULL, NULL, 'TRANSLOCON-ASSOCIATED PROTEIN, ALPHA SUBUNIT', NULL, NULL, NULL, 8),
(251115, NULL, 'PTHR38546', NULL, NULL, NULL, NULL, 'DNA BINDING PROTEIN', NULL, NULL, 36712, 8),
(251116, NULL, 'PTHR28285', NULL, NULL, NULL, NULL, 'PROTEIN BIG1', NULL, NULL, 31374, 8),
(251117, NULL, 'PTHR12185', NULL, NULL, NULL, NULL, 'SID1 TRANSMEMBRANE FAMILY MEMEBER', NULL, NULL, 22696, 8),
(251118, NULL, 'PTHR36294', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 139', NULL, NULL, 32443, 8),
(251119, NULL, 'PTHR43207', NULL, NULL, NULL, NULL, 'AROGENATE DEHYDROGENASE-RELATED', NULL, NULL, 34098, 8),
(251120, NULL, 'PTHR15157', NULL, NULL, NULL, NULL, 'UV RADIATION RESISTANCE-ASSOCIATED GENE PROTEIN', NULL, NULL, NULL, 8),
(251121, NULL, 'PTHR42895', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER-BINDING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(251122, NULL, 'PTHR11178', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER SCAFFOLD PROTEIN NFU-RELATED', NULL, NULL, NULL, 8),
(251123, NULL, 'PTHR40052', NULL, NULL, NULL, NULL, 'UPF0403 PROTEIN YQIW-RELATED', NULL, NULL, 9265, 8),
(251124, NULL, 'PTHR13831', NULL, NULL, NULL, NULL, 'MEMBER OF THE HIR1 FAMILY OF WD-REPEAT PROTEINS', NULL, NULL, 26173, 8),
(251125, NULL, 'PTHR47465', NULL, NULL, NULL, NULL, 'MCG113260-RELATED-RELATED', NULL, NULL, NULL, 8),
(251126, NULL, 'PTHR15117', NULL, NULL, NULL, NULL, 'ATAXIN 7 RELATED', NULL, NULL, NULL, 8),
(251127, NULL, 'PTHR47248', NULL, NULL, NULL, NULL, 'PROTEIN CBG06772', NULL, NULL, NULL, 8),
(251128, NULL, 'PTHR34536', NULL, NULL, NULL, NULL, 'DENTIN SIALOPHOSPHOPROTEIN-LIKE PROTEIN', NULL, NULL, NULL, 8);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(251129, NULL, 'PTHR12826', NULL, NULL, NULL, NULL, 'RIBONUCLEASE Y', NULL, NULL, NULL, 8),
(251130, NULL, 'PTHR10996', NULL, NULL, NULL, NULL, '2-HYDROXYACID DEHYDROGENASE-RELATED', NULL, NULL, NULL, 8),
(251131, NULL, 'PTHR13502', NULL, NULL, NULL, NULL, 'CDC42 SMALL EFFECTOR PROTEIN HOMOLOG', NULL, NULL, 33481, 8),
(251132, NULL, 'PTHR20914', NULL, NULL, NULL, NULL, 'LY6/PLAUR DOMAIN-CONTAINING PROTEIN 8', NULL, NULL, NULL, 8),
(251133, NULL, 'PTHR35998', NULL, NULL, NULL, NULL, 'OS02G0127900 PROTEIN', NULL, NULL, NULL, 8),
(251134, NULL, 'PTHR32194', NULL, NULL, NULL, NULL, 'METALLOPROTEASE TLDD', NULL, NULL, 15644, 8),
(251135, NULL, 'PTHR43365', NULL, NULL, NULL, NULL, 'BLR7806 PROTEIN', NULL, NULL, NULL, 8),
(251136, NULL, 'PTHR12366', NULL, NULL, NULL, NULL, 'ASPARTYL/ASPARAGINYL BETA-HYDROXYLASE', NULL, NULL, 28060, 8),
(251137, NULL, 'PTHR24246', NULL, NULL, NULL, NULL, 'OLFACTORY RECEPTOR AND ADENOSINE RECEPTOR', NULL, NULL, NULL, 8),
(251138, NULL, 'PTHR36857', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 25', NULL, NULL, 21572, 8),
(251139, NULL, 'PTHR31018', NULL, NULL, NULL, NULL, 'SPORULATION-SPECIFIC PROTEIN-RELATED', NULL, NULL, NULL, 8),
(251140, NULL, 'PTHR46536', NULL, NULL, NULL, NULL, 'ARL14 EFFECTOR PROTEIN', NULL, NULL, 23428, 8),
(251141, NULL, 'PTHR41158', NULL, NULL, NULL, NULL, 'AGAP010294-PA', NULL, NULL, NULL, 8),
(251142, NULL, 'PTHR45695', NULL, NULL, NULL, NULL, 'LEUCOKININ RECEPTOR-RELATED', NULL, NULL, NULL, 8),
(251143, NULL, 'PTHR43712', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_4G14580)-RELATED', NULL, NULL, NULL, 8),
(251144, NULL, 'PTHR11654', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE TRANSPORTER-RELATED', NULL, NULL, 3533, 8),
(251145, NULL, 'PTHR36527', NULL, NULL, NULL, NULL, 'OS01G0282866 PROTEIN', NULL, NULL, NULL, 8),
(251146, NULL, 'PTHR21324', NULL, NULL, NULL, NULL, 'FASTING-INDUCIBLE INTEGRAL MEMBRANE PROTEIN TM6P1-RELATED', NULL, NULL, NULL, 8),
(251147, NULL, 'PTHR44019', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN 55', NULL, NULL, NULL, 8),
(251148, NULL, 'PTHR47669', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL TRANSFER PROTEIN SFH5', NULL, NULL, 36653, 8),
(251149, NULL, 'PTHR45970', NULL, NULL, NULL, NULL, 'AGAP004664-PA', NULL, NULL, NULL, 8),
(251150, NULL, 'PTHR34602', NULL, NULL, NULL, NULL, 'NEMATODE SPECIFIC PEPTIDE FAMILY, GROUP E-RELATED', NULL, NULL, 14372, 8),
(251151, NULL, 'PTHR31595', NULL, NULL, NULL, NULL, 'LONG-CHAIN-ALCOHOL O-FATTY-ACYLTRANSFERASE 3-RELATED', NULL, NULL, 34555, 8),
(251152, NULL, 'PTHR13254', NULL, NULL, NULL, NULL, 'GOLGI AUTOANTIGEN, GOLGIN SUBFAMILY A, 7', NULL, NULL, NULL, 8),
(251153, NULL, 'PTHR22702', NULL, NULL, NULL, NULL, 'PROTEASE-ASSOCIATED DOMAIN-CONTAINING PROTEIN', NULL, NULL, 36409, 8),
(251154, NULL, 'PTHR37484', NULL, NULL, NULL, NULL, 'ROD SHAPE-DETERMINING PROTEIN MRED', NULL, NULL, 23101, 8),
(251155, NULL, 'PTHR22834', NULL, NULL, NULL, NULL, 'NUCLEAR FUSION PROTEIN FUS2', NULL, NULL, NULL, 8),
(251156, NULL, 'PTHR14131', NULL, NULL, NULL, NULL, 'ANOSMIN', NULL, NULL, 35531, 8),
(251157, NULL, 'PTHR46191', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(251158, NULL, 'PTHR33346', NULL, NULL, NULL, NULL, 'DEHYDRIN XERO 2-RELATED', NULL, NULL, 1771, 8),
(251159, NULL, 'PTHR36481', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(251160, NULL, 'PTHR47320', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL URIDYLYLTRANSFERASE/URIDYLYL-REMOVING ENZYME', NULL, NULL, 5439, 8),
(251161, NULL, 'PTHR39966', NULL, NULL, NULL, NULL, 'BLL2471 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(251162, NULL, 'PTHR21275', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 33847, 8),
(251163, NULL, 'PTHR43436', NULL, NULL, NULL, NULL, 'ARAC-FAMILY TRANSCRIPTIONAL REGULATOR', NULL, NULL, NULL, 8),
(251164, NULL, 'PTHR43847', NULL, NULL, NULL, NULL, 'BLL3993 PROTEIN', NULL, NULL, NULL, 8),
(251165, NULL, 'PTHR39068', NULL, NULL, NULL, NULL, 'LARVAL/PUPAL CUTICLE PROTEIN H1C-LIKE PROTEIN-RELATED', NULL, NULL, 16708, 8),
(251166, NULL, 'PTHR31986', NULL, NULL, NULL, NULL, 'REGULATOR OF DRUG SENSITIVITY 2', NULL, NULL, NULL, 8);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(251167, NULL, 'PTHR28153', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(251168, NULL, 'PTHR16165', NULL, NULL, NULL, NULL, 'NXPE FAMILY MEMBER', NULL, NULL, NULL, 8),
(251169, NULL, 'PTHR47024', NULL, NULL, NULL, NULL, 'BIOFILM ABSENT ON HEAD (AFTER YERSINIA EXPOSURE)-RELATED', NULL, NULL, NULL, 8),
(251170, NULL, 'PTHR12787', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 2114, 8),
(251171, NULL, 'PTHR40628', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(251172, NULL, 'PTHR23403', NULL, NULL, NULL, NULL, 'TREHALASE', NULL, NULL, 3003, 8),
(251173, NULL, 'PTHR42673', NULL, NULL, NULL, NULL, 'MALEYLACETOACETATE ISOMERASE', NULL, NULL, NULL, 8),
(251174, NULL, 'PTHR33780', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(251175, NULL, 'PTHR31840', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 97', NULL, NULL, 16138, 8),
(251176, NULL, 'PTHR40266', NULL, NULL, NULL, NULL, 'TOXIN HIGB-1', NULL, NULL, 1009, 8),
(251177, NULL, 'PTHR46069', NULL, NULL, NULL, NULL, 'TUBULIN TYROSINE LIGASE', NULL, NULL, NULL, 8),
(251178, NULL, 'PTHR15139', NULL, NULL, NULL, NULL, 'TUBULIN FOLDING COFACTOR C', NULL, NULL, 25471, 8),
(251179, NULL, 'PTHR35269', NULL, NULL, NULL, NULL, 'SMALL VCP/P97-INTERACTING PROTEIN', NULL, NULL, 25907, 8),
(251180, NULL, 'PTHR43102', NULL, NULL, NULL, NULL, 'SLR1143 PROTEIN', NULL, NULL, NULL, 8),
(251181, NULL, 'PTHR11485', NULL, NULL, NULL, NULL, 'TRANSFERRIN', NULL, NULL, NULL, 8),
(251182, NULL, 'PTHR22898', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED GLYCOSOL TRANSFERASE-RELATED', NULL, NULL, NULL, 8),
(251183, NULL, 'PTHR43726', NULL, NULL, NULL, NULL, '3-METHYLORNITHINE SYNTHASE', NULL, NULL, 6050, 8),
(251184, NULL, 'PTHR43613', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, ATP-BINDING PROTEIN', NULL, NULL, NULL, 8),
(251185, NULL, 'PTHR37535', NULL, NULL, NULL, NULL, 'FLUG DOMAIN PROTEIN', NULL, NULL, NULL, 8),
(251186, NULL, 'PTHR31592', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 192', NULL, NULL, 24867, 8),
(251187, NULL, 'PTHR34710', NULL, NULL, NULL, NULL, 'OS03G0834100 PROTEIN', NULL, NULL, NULL, 8),
(251188, NULL, 'PTHR43678', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_2G00640)-RELATED', NULL, NULL, NULL, 8),
(251189, NULL, 'PTHR35585', NULL, NULL, NULL, NULL, 'HHE DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_4G00730)', NULL, NULL, NULL, 8),
(251190, NULL, 'PTHR31600', NULL, NULL, NULL, NULL, 'TINY MACROCYSTS PROTEIN B-RELATED', NULL, NULL, NULL, 8),
(251191, NULL, 'PTHR28060', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT J, MITOCHONDRIAL', NULL, NULL, 5525, 8),
(251192, NULL, 'PTHR33906', NULL, NULL, NULL, NULL, 'INTRAFLAGELLAR TRANSPORT PROTEIN 25 HOMOLOG', NULL, NULL, 27817, 8),
(251193, NULL, 'PTHR36020', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(251194, NULL, 'PTHR24235', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE Y RECEPTOR', NULL, NULL, NULL, 8),
(251195, NULL, 'PTHR13948', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN', NULL, NULL, NULL, 8),
(251196, NULL, 'PTHR23188', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II-ASSOCIATED FACTOR 1 HOMOLOG', NULL, NULL, 290, 8),
(251197, NULL, 'PTHR34786', NULL, NULL, NULL, NULL, 'OS09G0504900 PROTEIN', NULL, NULL, NULL, 8),
(251198, NULL, 'PTHR35789', NULL, NULL, NULL, NULL, 'SPORE GERMINATION PROTEIN B3', NULL, NULL, 13838, 8),
(251199, NULL, 'PTHR35812', NULL, NULL, NULL, NULL, 'LIPOPROTEIN', NULL, NULL, NULL, 8),
(251200, NULL, 'PTHR34857', NULL, NULL, NULL, NULL, 'SLL0384 PROTEIN', NULL, NULL, NULL, 8),
(251201, NULL, 'PTHR11929', NULL, NULL, NULL, NULL, 'ALPHA- 1,3 -FUCOSYLTRANSFERASE', NULL, NULL, 6241, 8),
(251202, NULL, 'PTHR47306', NULL, NULL, NULL, NULL, 'SI:CH211-178J18.4-RELATED', NULL, NULL, NULL, 8),
(251203, NULL, 'PTHR42764', NULL, NULL, NULL, NULL, 'PHOSPHONATES UTILIZATION ATP-BINDING PROTEIN PHNK-RELATED', NULL, NULL, NULL, 8),
(251204, NULL, 'PTHR10088', NULL, NULL, NULL, NULL, 'GLUCOKINASE REGULATORY PROTEIN', NULL, NULL, 31351, 8),
(251205, NULL, 'PTHR47556', NULL, NULL, NULL, NULL, 'SEC14P-LIKE PHOSPHATIDYLINOSITOL TRANSFER FAMILY PROTEIN', NULL, NULL, NULL, 8);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(251206, NULL, 'PTHR46886', NULL, NULL, NULL, NULL, 'INSULIN-LIKE GROWTH FACTOR II', NULL, NULL, NULL, 8),
(251207, NULL, 'PTHR42928', NULL, NULL, NULL, NULL, 'TRICARBOXYLATE-BINDING PROTEIN', NULL, NULL, 2263, 8),
(251208, NULL, 'PTHR31733', NULL, NULL, NULL, NULL, 'RIBONUCLEASE KAPPA', NULL, NULL, 24015, 8),
(251209, NULL, 'PTHR24133', NULL, NULL, NULL, NULL, 'ANKYRIN DOMAIN-CONTAINING', NULL, NULL, NULL, 8),
(251210, NULL, 'PTHR33144', NULL, NULL, NULL, NULL, 'OS10G0409366 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(251211, NULL, 'PTHR35982', NULL, NULL, NULL, NULL, 'AGAP005361-PA', NULL, NULL, NULL, 8),
(251212, NULL, 'PTHR46017', NULL, NULL, NULL, NULL, 'ALPHA-MANNOSIDASE 2C1', NULL, NULL, NULL, 8),
(251213, NULL, 'PTHR36162', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(251214, NULL, 'PTHR45633', NULL, NULL, NULL, NULL, '60 KDA HEAT SHOCK PROTEIN, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(251215, NULL, 'PTHR10462', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE-RELATED', NULL, NULL, 10493, 8),
(251216, NULL, 'PTHR42922', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORT SYSTEM PERMEASE PROTEIN PSTA', NULL, NULL, NULL, 8),
(251217, NULL, 'PTHR42850', NULL, NULL, NULL, NULL, 'METALLOPHOSPHOESTERASE', NULL, NULL, NULL, 8),
(251218, NULL, 'PTHR23136', NULL, NULL, NULL, NULL, 'TAX1-BINDING PROTEIN 3-RELATED', NULL, NULL, NULL, 8),
(251219, NULL, 'PTHR24234', NULL, NULL, NULL, NULL, 'LYSOPHOSPHATIDIC ACID RECEPTOR 5/SPHINGOSYLPHOSPHORYLCHOLINE RECEPTOR', NULL, NULL, NULL, 8),
(251220, NULL, 'PTHR33101', NULL, NULL, NULL, NULL, 'ROP GUANINE NUCLEOTIDE EXCHANGE FACTOR 1', NULL, NULL, 31906, 8),
(251221, NULL, 'PTHR42059', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(251222, NULL, 'PTHR38360', NULL, NULL, NULL, NULL, 'OS03G0120000 PROTEIN', NULL, NULL, NULL, 8),
(251223, NULL, 'PTHR36409', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(251224, NULL, 'PTHR30531', NULL, NULL, NULL, NULL, 'FLAGELLAR BIOSYNTHETIC PROTEIN FLHB', NULL, NULL, 10034, 8),
(251225, NULL, 'PTHR10556', NULL, NULL, NULL, NULL, '3-OXO-5-ALPHA-STEROID 4-DEHYDROGENASE', NULL, NULL, 33002, 8),
(251226, NULL, 'PTHR42699', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(251227, NULL, 'PTHR40012', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED PROTEIN 29', NULL, NULL, 32936, 8),
(251228, NULL, 'PTHR11133', NULL, NULL, NULL, NULL, 'SACCHAROPINE DEHYDROGENASE', NULL, NULL, NULL, 8),
(251229, NULL, 'PTHR37320', NULL, NULL, NULL, NULL, 'AG-1 BLOOD STAGE MEMBRANE PROTEIN HOMOLOGUE', NULL, NULL, NULL, 8),
(251230, NULL, 'PTHR12733', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ATP SYNTHASE B CHAIN', NULL, NULL, 9039, 8),
(251231, NULL, 'PTHR46173', NULL, NULL, NULL, NULL, 'CCA TRNA NUCLEOTIDYLTRANSFERASE 1, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(251232, NULL, 'PTHR37494', NULL, NULL, NULL, NULL, 'HEMAGGLUTININ', NULL, NULL, NULL, 8),
(251233, NULL, 'PTHR21331', NULL, NULL, NULL, NULL, 'BRCA1-ASSOCIATED ATM ACTIVATOR 1', NULL, NULL, 31466, 8),
(251234, NULL, 'PTHR31474', NULL, NULL, NULL, NULL, 'HR-LIKE LESION-INDUCER', NULL, NULL, NULL, 8),
(251235, NULL, 'PTHR43480', NULL, NULL, NULL, NULL, 'ACYL-[ACYL-CARRIER-PROTEIN]--UDP-N-ACETYLGLUCOSAMINE O-ACYLTRANSFERASE', NULL, NULL, 10746, 8),
(251236, NULL, 'PTHR16244', NULL, NULL, NULL, NULL, 'CEROID-LIPOFUSCINOSIS NEURONAL PROTEIN 6', NULL, NULL, 21605, 8),
(251237, NULL, 'PTHR16450', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 186', NULL, NULL, NULL, 8),
(251238, NULL, 'PTHR23204', NULL, NULL, NULL, NULL, 'CLEAVAGE AND POLYADENYLATION SPECIFIC FACTOR', NULL, NULL, 30784, 8),
(251239, NULL, 'PTHR40453', NULL, NULL, NULL, NULL, 'PROTEIN YOEF', NULL, NULL, 13116, 8),
(251240, NULL, 'PTHR46762', NULL, NULL, NULL, NULL, 'NUCLEOREDOXIN-LIKE PROTEIN 2', NULL, NULL, 22453, 8),
(251241, NULL, 'PTHR31340', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL GENOME MAINTENANCE EXONUCLEASE 1', NULL, NULL, NULL, 8),
(251242, NULL, 'PTHR41313', NULL, NULL, NULL, NULL, 'ADENINE-SPECIFIC METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(251243, NULL, 'PTHR21539', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 30491, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(251244, NULL, 'PTHR33681', NULL, NULL, NULL, NULL, 'BINDING PROTEIN, PUTATIVE, EXPRESSED-RELATED', NULL, NULL, NULL, 8),
(251245, NULL, 'PTHR45913', NULL, NULL, NULL, NULL, 'EPM2A-INTERACTING PROTEIN 1', NULL, NULL, 25161, 8),
(251246, NULL, 'PTHR42659', NULL, NULL, NULL, NULL, 'XANTHINE DEHYDROGENASE SUBUNIT C-RELATED', NULL, NULL, NULL, 8),
(251247, NULL, 'PTHR31648', NULL, NULL, NULL, NULL, '', NULL, NULL, 31465, 8),
(251248, NULL, 'PTHR15454', NULL, NULL, NULL, NULL, 'NISCHARIN RELATED', NULL, NULL, NULL, 8),
(251249, NULL, 'PTHR36713', NULL, NULL, NULL, NULL, 'OS09G0344700 PROTEIN', NULL, NULL, NULL, 8),
(251250, NULL, 'PTHR30435', NULL, NULL, NULL, NULL, 'FLAGELLAR PROTEIN', NULL, NULL, NULL, 8),
(251251, NULL, 'PTHR15561', NULL, NULL, NULL, NULL, 'CALCITONIN GENE-RELATED PEPTIDE-RECEPTOR COMPONENT PROTEIN', NULL, NULL, 32788, 8),
(251252, NULL, 'PTHR43831', NULL, NULL, NULL, NULL, 'ISOBUTYRYL-COA DEHYDROGENASE', NULL, NULL, NULL, 8),
(251253, NULL, 'PTHR42697', NULL, NULL, NULL, NULL, 'ENDONUCLEASE 8', NULL, NULL, NULL, 8),
(251254, NULL, 'PTHR42880', NULL, NULL, NULL, NULL, 'HOMOCITRATE SYNTHASE', NULL, NULL, NULL, 8),
(251255, NULL, 'PTHR22619', NULL, NULL, NULL, NULL, 'ZINC FINGER SWIM DOMAIN CONTAINING PROTEIN 4, 5, 6', NULL, NULL, NULL, 8),
(251256, NULL, 'PTHR22745', NULL, NULL, NULL, NULL, 'PROTHYMOSIN ALPHA', NULL, NULL, 1622, 8),
(251257, NULL, 'PTHR41271', NULL, NULL, NULL, NULL, 'DUF402 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(251258, NULL, 'PTHR46941', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 126', NULL, NULL, 34004, 8),
(251259, NULL, 'PTHR39185', NULL, NULL, NULL, NULL, 'SWARMING MOTILITY PROTEIN SWRD', NULL, NULL, 8450, 8),
(251260, NULL, 'PTHR15718', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 23494, 8),
(251261, NULL, 'PTHR34581', NULL, NULL, NULL, NULL, 'PTS SYSTEM N,N''-DIACETYLCHITOBIOSE-SPECIFIC EIIB COMPONENT', NULL, NULL, NULL, 8),
(251262, NULL, 'PTHR26392', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 7-RELATED', NULL, NULL, NULL, 8),
(251263, NULL, 'PTHR41248', NULL, NULL, NULL, NULL, 'NORD PROTEIN', NULL, NULL, NULL, 8),
(251264, NULL, 'PTHR34399', NULL, NULL, NULL, NULL, 'AVIDIN-RELATED', NULL, NULL, NULL, 8),
(251265, NULL, 'PTHR32523', NULL, NULL, NULL, NULL, 'PHYTOL KINASE 1, CHLOROPLASTIC', NULL, NULL, 27215, 8),
(251266, NULL, 'PTHR23137', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 10900, 8),
(251267, NULL, 'PTHR15463', NULL, NULL, NULL, NULL, 'AP1 GAMMA SUBUNIT BINDING PROTEIN 1', NULL, NULL, 27494, 8),
(251268, NULL, 'PTHR10680', NULL, NULL, NULL, NULL, 'PEPTIDYL-GLYCINE ALPHA-AMIDATING MONOOXYGENASE', NULL, NULL, NULL, 8),
(251269, NULL, 'PTHR38121', NULL, NULL, NULL, NULL, 'GH16 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(251270, NULL, 'PTHR34544', NULL, NULL, NULL, NULL, 'OSJNBA0006B20.18 PROTEIN', NULL, NULL, NULL, 8),
(251271, NULL, 'PTHR16133', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 39  ZINC TRANSPORTER , MEMBER 9-RELATED', NULL, NULL, 36790, 8),
(251272, NULL, 'PTHR43792', NULL, NULL, NULL, NULL, 'GNAT FAMILY, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G00765)-RELATED-RELATED', NULL, NULL, NULL, 8),
(251273, NULL, 'PTHR14453', NULL, NULL, NULL, NULL, 'PARP/ZINC FINGER CCCH TYPE DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(251274, NULL, 'PTHR46059', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDE ALPHA-2,6-SIALYLTRANSFERASE', NULL, NULL, NULL, 8),
(251275, NULL, 'PTHR36330', NULL, NULL, NULL, NULL, 'LIPASE/LIPOOXYGENASE, PLAT/LH2 FAMILY PROTEIN', NULL, NULL, NULL, 8),
(251276, NULL, 'PTHR19446', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASES', NULL, NULL, NULL, 8),
(251277, NULL, 'PTHR21366', NULL, NULL, NULL, NULL, 'GLYOXALASE FAMILY PROTEIN', NULL, NULL, NULL, 8),
(251278, NULL, 'PTHR16171', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN COMPLEMENTING XP-G CELLS-RELATED', NULL, NULL, NULL, 8),
(251279, NULL, 'PTHR24112', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT, ISOFORM F-RELATED', NULL, NULL, NULL, 8),
(251280, NULL, 'PTHR17695', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(251281, NULL, 'PTHR14317', NULL, NULL, NULL, NULL, 'SPERM PROTAMINE P3', NULL, NULL, 21622, 8),
(251282, NULL, 'PTHR36809', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(251283, NULL, 'PTHR43403', NULL, NULL, NULL, NULL, 'NAD-SPECIFIC GLUTAMATE DEHYDROGENASE', NULL, NULL, 1372, 8),
(251284, NULL, 'PTHR43756', NULL, NULL, NULL, NULL, 'CHOLINE MONOOXYGENASE, CHLOROPLASTIC', NULL, NULL, 3090, 8),
(251285, NULL, 'PTHR36798', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN 6, CHLOROPLASTIC', NULL, NULL, 19217, 8),
(251286, NULL, 'PTHR39104', NULL, NULL, NULL, NULL, 'AMINO ACID-LIGASE', NULL, NULL, NULL, 8),
(251287, NULL, 'PTHR30251', NULL, NULL, NULL, NULL, 'PILUS ASSEMBLY CHAPERONE', NULL, NULL, NULL, 8),
(251288, NULL, 'PTHR14413', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L17', NULL, NULL, 6840, 8),
(251289, NULL, 'PTHR36516', NULL, NULL, NULL, NULL, 'PROTEIN CBG04168-RELATED', NULL, NULL, NULL, 8),
(251290, NULL, 'PTHR46326', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZAT1-RELATED', NULL, NULL, 36487, 8),
(251291, NULL, 'PTHR34927', NULL, NULL, NULL, NULL, 'IQ DOMAIN-CONTAINING PROTEIN K', NULL, NULL, 34034, 8),
(251292, NULL, 'PTHR16184', NULL, NULL, NULL, NULL, 'ELONGATOR COMPLEX PROTEIN 6', NULL, NULL, 16017, 8),
(251293, NULL, 'PTHR47772', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 200', NULL, NULL, NULL, 8),
(251294, NULL, 'PTHR42808', NULL, NULL, NULL, NULL, 'HYDROXYSTEROID DEHYDROGENASE-LIKE PROTEIN 2', NULL, NULL, NULL, 8),
(251295, NULL, 'PTHR47738', NULL, NULL, NULL, NULL, 'PTS SYSTEM FRUCTOSE-LIKE EIIA COMPONENT-RELATED', NULL, NULL, NULL, 8),
(251296, NULL, 'PTHR39477', NULL, NULL, NULL, NULL, 'CHROMOSOME 8, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(251297, NULL, 'PTHR12817', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT 6B', NULL, NULL, 28944, 8),
(251298, NULL, 'PTHR44102', NULL, NULL, NULL, NULL, 'PROTEIN NPG1', NULL, NULL, 36802, 8),
(251299, NULL, 'PTHR34823', NULL, NULL, NULL, NULL, 'GLCNAC-BINDING PROTEIN A', NULL, NULL, NULL, 8),
(251300, NULL, 'PTHR11875', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC Y-ENCODED PROTEIN', NULL, NULL, 5104, 8),
(251301, NULL, 'PTHR11575', NULL, NULL, NULL, NULL, '5''-NUCLEOTIDASE-RELATED', NULL, NULL, 11469, 8),
(251302, NULL, 'PTHR43507', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE CHAIN 4', NULL, NULL, 6389, 8),
(251303, NULL, 'PTHR15341', NULL, NULL, NULL, NULL, 'SUN-COR STEROID HORMONE RECEPTOR CO-REPRESSOR', NULL, NULL, 10545, 8),
(251304, NULL, 'PTHR31580', NULL, NULL, NULL, NULL, 'FILAMENT-LIKE PLANT PROTEIN 4', NULL, NULL, NULL, 8),
(251305, NULL, 'PTHR15491', NULL, NULL, NULL, NULL, '', NULL, NULL, 22670, 8),
(251306, NULL, 'PTHR38049', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(251307, NULL, 'PTHR20959', NULL, NULL, NULL, NULL, 'TRANSPORT AND GOLGI ORGANIZATION PROTEIN 6 FAMILY MEMBER', NULL, NULL, 33869, 8),
(251308, NULL, 'PTHR42095', NULL, NULL, NULL, NULL, 'YALI0C12166P', NULL, NULL, NULL, 8),
(251309, NULL, 'PTHR24328', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN MOX', NULL, NULL, 36100, 8),
(251310, NULL, 'PTHR12059', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L23-RELATED', NULL, NULL, 11244, 8),
(251311, NULL, 'PTHR33194', NULL, NULL, NULL, NULL, 'ZINC KNUCKLE DOMAINCONTAINING PROTEIN', NULL, NULL, NULL, 8),
(251312, NULL, 'PTHR35861', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(251313, NULL, 'PTHR23547', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY DOMAIN, GENERAL SUBSTRATE TRANSPORTER', NULL, NULL, NULL, 8),
(251314, NULL, 'PTHR36309', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS) FAMILY PROTEIN', NULL, NULL, NULL, 8),
(251315, NULL, 'PTHR42307', NULL, NULL, NULL, NULL, 'PUP DEAMIDASE/DEPUPYLASE', NULL, NULL, 5285, 8),
(251316, NULL, 'PTHR33602', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN RECX FAMILY PROTEIN', NULL, NULL, 3062, 8),
(251317, NULL, 'PTHR46702', NULL, NULL, NULL, NULL, 'DNA LIGASE (DUF1666)-RELATED', NULL, NULL, NULL, 8),
(251318, NULL, 'PTHR10871', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S13/40S RIBOSOMAL PROTEIN S18', NULL, NULL, NULL, 8);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(251319, NULL, 'PTHR11043', NULL, NULL, NULL, NULL, 'ZETA-COAT PROTEIN', NULL, NULL, 27294, 8),
(251320, NULL, 'PTHR32119', NULL, NULL, NULL, NULL, 'OROTIDINE 5''-PHOSPHATE DECARBOXYLASE', NULL, NULL, NULL, 8),
(251321, NULL, 'PTHR14195', NULL, NULL, NULL, NULL, 'G PATCH DOMAIN CONTAINING PROTEIN 2', NULL, NULL, NULL, 8),
(251322, NULL, 'PTHR28216', NULL, NULL, NULL, NULL, 'DASH COMPLEX SUBUNIT DUO1', NULL, NULL, 7797, 8),
(251323, NULL, 'PTHR47521', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS E (EPSILON)-RELATED', NULL, NULL, NULL, 8),
(251324, NULL, 'PTHR43173', NULL, NULL, NULL, NULL, 'ABC1 FAMILY PROTEIN', NULL, NULL, NULL, 8),
(251325, NULL, 'PTHR42852', NULL, NULL, NULL, NULL, 'THIOL:DISULFIDE INTERCHANGE PROTEIN DSBE', NULL, NULL, NULL, 8),
(251326, NULL, 'PTHR37202', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT PROTEIN', NULL, NULL, NULL, 8),
(251327, NULL, 'PTHR28678', NULL, NULL, NULL, NULL, 'CODANIN-1', NULL, NULL, 31246, 8),
(251328, NULL, 'PTHR13396', NULL, NULL, NULL, NULL, 'NEDD4 FAMILY INTERACTING PROTEIN 1/2', NULL, NULL, 14775, 8),
(251329, NULL, 'PTHR46098', NULL, NULL, NULL, NULL, 'TRNA (CYTOSINE(38)-C(5))-METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(251330, NULL, 'PTHR33324', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(251331, NULL, 'PTHR44259', NULL, NULL, NULL, NULL, 'OS07G0183000 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(251332, NULL, 'PTHR28314', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 29', NULL, NULL, 15200, 8),
(251333, NULL, 'PTHR41339', NULL, NULL, NULL, NULL, 'LIPL48', NULL, NULL, NULL, 8),
(251334, NULL, 'PTHR21342', NULL, NULL, NULL, NULL, 'PHOSPHOPANTETHEINE ADENYLYLTRANSFERASE', NULL, NULL, NULL, 8),
(251335, NULL, 'PTHR36075', NULL, NULL, NULL, NULL, 'BNAA10G09820D PROTEIN', NULL, NULL, NULL, 8),
(251336, NULL, 'PTHR46500', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 221', NULL, NULL, 25015, 8),
(251337, NULL, 'PTHR44340', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 10', NULL, NULL, NULL, 8),
(251338, NULL, 'PTHR31792', NULL, NULL, NULL, NULL, 'VACUOLAR ATPASE ASSEMBLY INTEGRAL MEMBRANE PROTEIN VMA21', NULL, NULL, 15605, 8),
(251339, NULL, 'PTHR13547', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(251340, NULL, 'PTHR22611', NULL, NULL, NULL, NULL, 'PROTEIN NAKED CUTICLE', NULL, NULL, 33143, 8),
(251341, NULL, 'PTHR31791', NULL, NULL, NULL, NULL, 'FRIGIDA-LIKE PROTEIN 3-RELATED', NULL, NULL, NULL, 8),
(251342, NULL, 'PTHR35517', NULL, NULL, NULL, NULL, 'PROTEIN ARGININE N-METHYLTRANSFERASE SFM1', NULL, NULL, 5545, 8),
(251343, NULL, 'PTHR42146', NULL, NULL, NULL, NULL, '3'',5''-CYCLIC-NUCLEOTIDE PHOSPHODIESTERASE', NULL, NULL, NULL, 8),
(251344, NULL, 'PTHR48258', NULL, NULL, NULL, NULL, 'DUF4218 DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(251345, NULL, 'PTHR40201', NULL, NULL, NULL, NULL, 'OSMIOPHILIC BODY PROTEIN', NULL, NULL, NULL, 8),
(251346, NULL, 'PTHR28647', NULL, NULL, NULL, NULL, 'UNIQUE CARTILAGE MATRIX-ASSOCIATED PROTEIN', NULL, NULL, 24435, 8),
(251347, NULL, 'PTHR23089', NULL, NULL, NULL, NULL, 'HISTIDINE TRIAD  HIT  PROTEIN', NULL, NULL, 2385, 8),
(251348, NULL, 'PTHR13019', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 13380, 8),
(251349, NULL, 'PTHR46239', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RAD51 HOMOLOG 3 RAD51C', NULL, NULL, NULL, 8),
(251350, NULL, 'PTHR39609', NULL, NULL, NULL, NULL, 'RFEG-RELATED', NULL, NULL, NULL, 8),
(251351, NULL, 'PTHR12751', NULL, NULL, NULL, NULL, 'PHOSPHATASE AND ACTIN REGULATOR  PHACTR', NULL, NULL, NULL, 8),
(251352, NULL, 'PTHR42717', NULL, NULL, NULL, NULL, 'DIHYDROOROTASE-RELATED', NULL, NULL, 11589, 8),
(251353, NULL, 'PTHR14273', NULL, NULL, NULL, NULL, 'LYR MOTIF-CONTAINING PROTEIN 1', NULL, NULL, 27996, 8),
(251354, NULL, 'PTHR47001', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH121', NULL, NULL, 36088, 8),
(251355, NULL, 'PTHR19957', NULL, NULL, NULL, NULL, 'SYNTAXIN', NULL, NULL, 36882, 8),
(251356, NULL, 'PTHR10108', NULL, NULL, NULL, NULL, 'SAM-DEPENDENT METHYLTRANSFERASE', NULL, NULL, 2825, 8);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(251357, NULL, 'PTHR31398', NULL, NULL, NULL, NULL, 'MEIOTIC NUCLEAR DIVISION PROTEIN 1 HOMOLOG', NULL, NULL, NULL, 8),
(251358, NULL, 'PTHR21250', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 16959, 8),
(251359, NULL, 'PTHR38088', NULL, NULL, NULL, NULL, 'UCP029143 FAMILY PROTEIN', NULL, NULL, 7885, 8),
(251360, NULL, 'PTHR30337', NULL, NULL, NULL, NULL, 'COMPONENT OF ATP-DEPENDENT DSDNA EXONUCLEASE', NULL, NULL, NULL, 8),
(251361, NULL, 'PTHR34596', NULL, NULL, NULL, NULL, 'CHITOPORIN', NULL, NULL, 5166, 8),
(251362, NULL, 'PTHR45815', NULL, NULL, NULL, NULL, 'PROTEIN DISULFIDE-ISOMERASE A6', NULL, NULL, 34692, 8),
(251363, NULL, 'PTHR34477', NULL, NULL, NULL, NULL, 'UPF0213 PROTEIN YHBQ', NULL, NULL, NULL, 8),
(251364, NULL, 'PTHR47810', NULL, NULL, NULL, NULL, 'DNA LIGASE', NULL, NULL, NULL, 8),
(251365, NULL, 'PTHR13073', NULL, NULL, NULL, NULL, 'BLOC-1 COMPLEX SUBUNIT 1', NULL, NULL, 8087, 8),
(251366, NULL, 'PTHR23312', NULL, NULL, NULL, NULL, 'ARMC5  ARMADILLO REPEAT-CONTAINING -RELATED', NULL, NULL, NULL, 8),
(251367, NULL, 'PTHR33675', NULL, NULL, NULL, NULL, 'NUCLEAR RECEPTOR FAMILY 2 GROUP C PROTEIN', NULL, NULL, NULL, 8),
(251368, NULL, 'PTHR31749', NULL, NULL, NULL, NULL, 'KINETOCHORE-ASSOCIATED PROTEIN NSL1 HOMOLOG', NULL, NULL, 7741, 8),
(251369, NULL, 'PTHR30293', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN NAC-RELATED', NULL, NULL, NULL, 8),
(251370, NULL, 'PTHR34659', NULL, NULL, NULL, NULL, 'BNAA05G11610D PROTEIN', NULL, NULL, NULL, 8),
(251371, NULL, 'PTHR13161', NULL, NULL, NULL, NULL, 'SPLICING FACTOR  SUPPRESSOR OF WHITE APRICOT', NULL, NULL, 27956, 8),
(251372, NULL, 'PTHR33712', NULL, NULL, NULL, NULL, 'LIGHT-INDEPENDENT PROTOCHLOROPHYLLIDE REDUCTASE SUBUNIT B', NULL, NULL, NULL, 8),
(251373, NULL, 'PTHR11009', NULL, NULL, NULL, NULL, 'DER1-LIKE PROTEIN, DERLIN', NULL, NULL, NULL, 8),
(251374, NULL, 'PTHR13250', NULL, NULL, NULL, NULL, 'TF-1 CELL APOPTOSIS RELATED PROTEIN-15', NULL, NULL, 11132, 8),
(251375, NULL, 'PTHR33450', NULL, NULL, NULL, NULL, 'EMB|CAB67623.1-RELATED', NULL, NULL, NULL, 8),
(251376, NULL, 'PTHR43269', NULL, NULL, NULL, NULL, 'SODIUM/PROTON ANTIPORTER 1-RELATED', NULL, NULL, 34564, 8),
(251377, NULL, 'PTHR47595', NULL, NULL, NULL, NULL, 'HEAT SHOCK 70 KDA PROTEIN 14', NULL, NULL, NULL, 8),
(251378, NULL, 'PTHR12428', NULL, NULL, NULL, NULL, 'OXA1', NULL, NULL, 3041, 8),
(251379, NULL, 'PTHR13559', NULL, NULL, NULL, NULL, 'INTRACELLULAR TRAFFIC PROTEIN-RELATED', NULL, NULL, 24463, 8),
(251380, NULL, 'PTHR21560', NULL, NULL, NULL, NULL, 'VERY KIND PROTEIN', NULL, NULL, 25083, 8),
(251381, NULL, 'PTHR46019', NULL, NULL, NULL, NULL, 'BPI FOLD-CONTAINING FAMILY B MEMBER 4-RELATED', NULL, NULL, NULL, 8),
(251382, NULL, 'PTHR42809', NULL, NULL, NULL, NULL, 'FLAVODOXIN 2', NULL, NULL, NULL, 8),
(251383, NULL, 'PTHR38831', NULL, NULL, NULL, NULL, 'TYPE II SECRETION SYSTEM PROTEIN K', NULL, NULL, 2521, 8),
(251384, NULL, 'PTHR34800', NULL, NULL, NULL, NULL, 'TETRAPYRROLE-BINDING PROTEIN, CHLOROPLASTIC', NULL, NULL, 14074, 8),
(251385, NULL, 'PTHR47650', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 22', NULL, NULL, NULL, 8),
(251386, NULL, 'PTHR11659', NULL, NULL, NULL, NULL, 'GLUTAMYL-TRNA GLN  AMIDOTRANSFERASE SUBUNIT B  MITOCHONDRIAL AND PROKARYOTIC  PET112-RELATED', NULL, NULL, 7023, 8),
(251387, NULL, 'PTHR40469', NULL, NULL, NULL, NULL, 'SECRETED GLYCOSYL HYDROLASE', NULL, NULL, NULL, 8),
(251388, NULL, 'PTHR41335', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(251389, NULL, 'PTHR12784', NULL, NULL, NULL, NULL, 'STEERIN', NULL, NULL, 28307, 8),
(251390, NULL, 'PTHR15452', NULL, NULL, NULL, NULL, 'LEUKOCYTE-SPECIFIC TRANSCRIPT 1 PROTEIN', NULL, NULL, 1304, 8),
(251391, NULL, 'PTHR11805', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH PDZ-BINDING PROTEIN', NULL, NULL, 15767, 8),
(251392, NULL, 'PTHR14042', NULL, NULL, NULL, NULL, 'DOPEY-RELATED', NULL, NULL, 31048, 8),
(251393, NULL, 'PTHR37612', NULL, NULL, NULL, NULL, 'FIBROIN HEAVY CHAIN FIB-H LIKE PROTEIN', NULL, NULL, NULL, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(251394, NULL, 'PTHR47978', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(251395, NULL, 'PTHR37359', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 253', NULL, NULL, 32105, 8),
(251396, NULL, 'PTHR22981', NULL, NULL, NULL, NULL, '3-HYDROXYISOBUTYRATE DEHYDROGENASE-RELATED', NULL, NULL, NULL, 8),
(251397, NULL, 'PTHR46438', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(251398, NULL, 'PTHR35694', NULL, NULL, NULL, NULL, 'DENEDDYLASE', NULL, NULL, NULL, 8),
(251399, NULL, 'PTHR23294', NULL, NULL, NULL, NULL, 'ET TRANSLATION PRODUCT-RELATED', NULL, NULL, NULL, 8),
(251400, NULL, 'PTHR13498', NULL, NULL, NULL, NULL, 'SPERM ASSOCIATED ANTIGEN 7', NULL, NULL, 17463, 8),
(251401, NULL, 'PTHR33974', NULL, NULL, NULL, NULL, 'VASCULAR-RELATED UNKNOWN PROTEIN 1-RELATED', NULL, NULL, 32717, 8),
(251402, NULL, 'PTHR37431', NULL, NULL, NULL, NULL, 'PROTEIN CBG06927', NULL, NULL, NULL, 8),
(251403, NULL, 'PTHR47103', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(251404, NULL, 'PTHR24243', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR', NULL, NULL, NULL, 8),
(251405, NULL, 'PTHR42896', NULL, NULL, NULL, NULL, 'XYLULOSE-1,5-BISPHOSPHATE (XUBP) PHOSPHATASE', NULL, NULL, 36809, 8),
(251406, NULL, 'PTHR31259', NULL, NULL, NULL, NULL, 'ENDOSOME-ASSOCIATED TRAFFICKING REGULATOR 1', NULL, NULL, 25670, 8),
(251407, NULL, 'PTHR37836', NULL, NULL, NULL, NULL, 'LMO1036 PROTEIN', NULL, NULL, NULL, 8),
(251408, NULL, 'PTHR40053', NULL, NULL, NULL, NULL, 'SPORULATION-CONTROL PROTEIN SPO0M', NULL, NULL, 12671, 8),
(251409, NULL, 'PTHR30237', NULL, NULL, NULL, NULL, 'MURAMOYLTETRAPEPTIDE CARBOXYPEPTIDASE', NULL, NULL, 6479, 8),
(251410, NULL, 'PTHR11183', NULL, NULL, NULL, NULL, 'GLYCOGENIN SUBFAMILY MEMBER', NULL, NULL, NULL, 8),
(251411, NULL, 'PTHR13382', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL ATP SYNTHASE COUPLING FACTOR B', NULL, NULL, NULL, 8),
(251412, NULL, 'PTHR43727', NULL, NULL, NULL, NULL, 'DIAMINOPIMELATE DECARBOXYLASE', NULL, NULL, NULL, 8),
(251413, NULL, 'PTHR43644', NULL, NULL, NULL, NULL, 'NA(+)-TRANSLOCATING NADH-QUINONE REDUCTASE SUBUNIT', NULL, NULL, NULL, 8),
(251414, NULL, 'PTHR48147', NULL, NULL, NULL, NULL, 'PROTEIN CBG23787', NULL, NULL, NULL, 8),
(251415, NULL, 'PTHR35905', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(251416, NULL, 'PTHR15728', NULL, NULL, NULL, NULL, 'DEADENYLATION COMPLEX CATALYTIC SUBUNIT PAN2', NULL, NULL, NULL, 8),
(251417, NULL, 'PTHR46005', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 190', NULL, NULL, NULL, 8),
(251418, NULL, 'PTHR37577', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(251419, NULL, 'PTHR33609', NULL, NULL, NULL, NULL, 'LOW CALCIUM RESPONSE LOCUS PROTEIN S', NULL, NULL, NULL, 8),
(251420, NULL, 'PTHR46112', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE', NULL, NULL, NULL, 8),
(251421, NULL, 'PTHR13524', NULL, NULL, NULL, NULL, 'MYOTUBULARIN-RELATED', NULL, NULL, 28704, 8),
(251422, NULL, 'PTHR36939', NULL, NULL, NULL, NULL, 'PROTEIN CBG03389', NULL, NULL, NULL, 8),
(251423, NULL, 'PTHR36404', NULL, NULL, NULL, NULL, 'EMBRYO DEFECTIVE 2737', NULL, NULL, NULL, 8),
(251424, NULL, 'PTHR12433', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 25', NULL, NULL, 36789, 8),
(251425, NULL, 'PTHR16079', NULL, NULL, NULL, NULL, 'UBIQUITIN LIGASE PROTEIN CHFR', NULL, NULL, NULL, 8),
(251426, NULL, 'PTHR13334', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 28S RIBOSOMAL PROTEIN S10', NULL, NULL, 31002, 8),
(251427, NULL, 'PTHR21114', NULL, NULL, NULL, NULL, 'DVS27 PROTEIN', NULL, NULL, 22950, 8),
(251428, NULL, 'PTHR42751', NULL, NULL, NULL, NULL, 'SODIUM/HYDROGEN EXCHANGER FAMILY/TRKA DOMAIN PROTEIN', NULL, NULL, NULL, 8),
(251429, NULL, 'PTHR16441', NULL, NULL, NULL, NULL, 'FIDIPIDINE', NULL, NULL, 28011, 8),
(251430, NULL, 'PTHR33649', NULL, NULL, NULL, NULL, 'PAR1 PROTEIN', NULL, NULL, 9022, 8),
(251431, NULL, 'PTHR47019', NULL, NULL, NULL, NULL, 'LIPID II FLIPPASE MURJ', NULL, NULL, NULL, 8),
(251432, NULL, 'PTHR22617', NULL, NULL, NULL, NULL, 'CHEMOTAXIS SENSOR HISTIDINE KINASE-RELATED', NULL, NULL, 32549, 8);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(251433, NULL, 'PTHR13143', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 19', NULL, NULL, 27844, 8),
(251434, NULL, 'PTHR13316', NULL, NULL, NULL, NULL, 'ZINC FINGER, CCHC DOMAIN CONTAINING 8', NULL, NULL, NULL, 8),
(251435, NULL, 'PTHR10802', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM40', NULL, NULL, 32727, 8),
(251436, NULL, 'PTHR42077', NULL, NULL, NULL, NULL, 'YALI0F30239P', NULL, NULL, NULL, 8),
(251437, NULL, 'PTHR12752', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITOL 3-PHOSPHATE-BINDING PROTEIN', NULL, NULL, NULL, 8),
(251438, NULL, 'PTHR31158', NULL, NULL, NULL, NULL, 'DUAL OXIDASE 2', NULL, NULL, 21091, 8),
(251439, NULL, 'PTHR12951', NULL, NULL, NULL, NULL, 'RETINAL PROTEIN 4', NULL, NULL, NULL, 8),
(251440, NULL, 'PTHR22791', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(251441, NULL, 'PTHR14159', NULL, NULL, NULL, NULL, 'ATAXIN-3-RELATED', NULL, NULL, 29517, 8),
(251442, NULL, 'PTHR47432', NULL, NULL, NULL, NULL, 'CELL WALL ASSEMBLY REGULATOR SMI1', NULL, NULL, NULL, 8),
(251443, NULL, 'PTHR30097', NULL, NULL, NULL, NULL, 'CATION EFFLUX SYSTEM PROTEIN CUSB', NULL, NULL, NULL, 8),
(251444, NULL, 'PTHR20953', NULL, NULL, NULL, NULL, 'KINASE-RELATED', NULL, NULL, NULL, 8),
(251445, NULL, 'PTHR30266', NULL, NULL, NULL, NULL, 'MECHANOSENSITIVE CHANNEL MSCL', NULL, NULL, 27359, 8),
(251446, NULL, 'PTHR36716', NULL, NULL, NULL, NULL, 'F3H9.20 PROTEIN', NULL, NULL, 19755, 8),
(251447, NULL, 'PTHR39418', NULL, NULL, NULL, NULL, 'DEHYDROGENASE-RELATED', NULL, NULL, NULL, 8),
(251448, NULL, 'PTHR45589', NULL, NULL, NULL, NULL, 'WD REPEAT DOMAIN 62, ISOFORM G', NULL, NULL, NULL, 8),
(251449, NULL, 'PTHR28676', NULL, NULL, NULL, NULL, 'ALK AND LTK LIGAND 2-RELATED', NULL, NULL, 26269, 8),
(251450, NULL, 'PTHR31336', NULL, NULL, NULL, NULL, 'LIN37 HOMOLOG', NULL, NULL, 22612, 8),
(251451, NULL, 'PTHR11176', NULL, NULL, NULL, NULL, 'BOULE-RELATED', NULL, NULL, 31142, 8),
(251452, NULL, 'PTHR10064', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L22', NULL, NULL, 2675, 8),
(251453, NULL, 'PTHR47924', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(251454, NULL, 'PTHR42977', NULL, NULL, NULL, NULL, 'HYDROLASE-RELATED', NULL, NULL, NULL, 8),
(251455, NULL, 'PTHR36390', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN-LIKE PROTEIN', NULL, NULL, NULL, 8),
(251456, NULL, 'PTHR11328', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY DOMAIN-CONTAINING PROTEIN', NULL, NULL, 33062, 8),
(251457, NULL, 'PTHR35884', NULL, NULL, NULL, NULL, 'SMALL AGGREGATE FORMATION PROTEIN', NULL, NULL, 32174, 8),
(251458, NULL, 'PTHR45901', NULL, NULL, NULL, NULL, 'PROTEIN CBG12474', NULL, NULL, NULL, 8),
(251459, NULL, 'PTHR32423', NULL, NULL, NULL, NULL, 'SAP DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(251460, NULL, 'PTHR10484', NULL, NULL, NULL, NULL, 'HISTONE H4', NULL, NULL, NULL, 8),
(251461, NULL, 'PTHR14191', NULL, NULL, NULL, NULL, 'PDZ DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(251462, NULL, 'PTHR11638', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT CLP PROTEASE', NULL, NULL, NULL, 8),
(251463, NULL, 'PTHR35179', NULL, NULL, NULL, NULL, 'PROTEIN CBG02620', NULL, NULL, NULL, 8),
(251464, NULL, 'PTHR40142', NULL, NULL, NULL, NULL, 'BPI FOLD-CONTAINING FAMILY B, MEMBER 9B-RELATED', NULL, NULL, 6010, 8),
(251465, NULL, 'PTHR15989', NULL, NULL, NULL, NULL, 'VEZATIN', NULL, NULL, 24807, 8),
(251466, NULL, 'PTHR43092', NULL, NULL, NULL, NULL, 'L-CYSTEINE DESULFHYDRASE', NULL, NULL, NULL, 8),
(251467, NULL, 'PTHR47489', NULL, NULL, NULL, NULL, 'ACYL-COA N-ACYLTRANSFERASES (NAT) SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(251468, NULL, 'PTHR31489', NULL, NULL, NULL, NULL, 'LIN52 FAMILY MEMBER', NULL, NULL, 18030, 8),
(251469, NULL, 'PTHR15608', NULL, NULL, NULL, NULL, 'SPLICING FACTOR U2AF-ASSOCIATED PROTEIN 2', NULL, NULL, 584, 8),
(251470, NULL, 'PTHR35762', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(251471, NULL, 'PTHR43212', NULL, NULL, NULL, NULL, 'QUERCETIN 2,3-DIOXYGENASE', NULL, NULL, 12696, 8);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(251472, NULL, 'PTHR15137', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID', NULL, NULL, 33000, 8),
(251473, NULL, 'PTHR32020', NULL, NULL, NULL, NULL, 'LIN-8 DOMAIN CONTAINING-RELATED', NULL, NULL, 1141, 8),
(251474, NULL, 'PTHR36204', NULL, NULL, NULL, NULL, 'N-ACETYLMANNOSAMINE-6-PHOSPHATE 2-EPIMERASE-RELATED', NULL, NULL, 6524, 8),
(251475, NULL, 'PTHR43837', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S12 METHYLTHIOTRANSFERASE RIMO', NULL, NULL, 5917, 8),
(251476, NULL, 'PTHR47002', NULL, NULL, NULL, NULL, 'AQUAPORIN-LIKE', NULL, NULL, NULL, 8),
(251477, NULL, 'PTHR13123', NULL, NULL, NULL, NULL, 'LD30288P', NULL, NULL, 27793, 8),
(251478, NULL, 'PTHR12136', NULL, NULL, NULL, NULL, 'ENHANCED DISEASE RESISTANCE-RELATED', NULL, NULL, 36590, 8),
(251479, NULL, 'PTHR28672', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT 13', NULL, NULL, 8950, 8),
(251480, NULL, 'PTHR43452', NULL, NULL, NULL, NULL, 'PYRUVATE DECARBOXYLASE', NULL, NULL, 12713, 8),
(251481, NULL, 'PTHR12737', NULL, NULL, NULL, NULL, 'DIMETHYLARGININE DIMETHYLAMINOHYDROLASE', NULL, NULL, 27809, 8),
(251482, NULL, 'PTHR34203', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE, FKBM FAMILY PROTEIN', NULL, NULL, NULL, 8),
(251483, NULL, 'PTHR13190', NULL, NULL, NULL, NULL, 'AUTOPHAGY-RELATED 2, ISOFORM A', NULL, NULL, 24778, 8),
(251484, NULL, 'PTHR12651', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 9', NULL, NULL, 15885, 8),
(251485, NULL, 'PTHR43306', NULL, NULL, NULL, NULL, '7,8-DIHYDRO-6-HYDROXYMETHYLPTERIN DIMETHYLTRANSFERASE', NULL, NULL, 20458, 8),
(251486, NULL, 'PTHR30587', NULL, NULL, NULL, NULL, 'FLAGELLAR BIOSYNTHETIC PROTEIN FLIP', NULL, NULL, 5727, 8),
(251487, NULL, 'PTHR31845', NULL, NULL, NULL, NULL, 'FINGER DOMAIN PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(251488, NULL, 'PTHR47889', NULL, NULL, NULL, NULL, 'SPERMATOGENIC LEUCINE ZIPPER PROTEIN 1', NULL, NULL, 35762, 8),
(251489, NULL, 'PTHR47195', NULL, NULL, NULL, NULL, 'KELCH REPEAT AND BTB DOMAIN-CONTAINING PROTEIN 4', NULL, NULL, 35695, 8),
(251490, NULL, 'PTHR42902', NULL, NULL, NULL, NULL, 'MALATE SYNTHASE', NULL, NULL, 3851, 8),
(251491, NULL, 'PTHR47971', NULL, NULL, NULL, NULL, 'KINESIN-RELATED PROTEIN 6', NULL, NULL, NULL, 8),
(251492, NULL, 'PTHR31646', NULL, NULL, NULL, NULL, 'ALPHA-1,2-MANNOSYLTRANSFERASE MNN2', NULL, NULL, NULL, 8),
(251493, NULL, 'PTHR38008', NULL, NULL, NULL, NULL, 'HEMOLYSIN-RELATED', NULL, NULL, NULL, 8),
(251494, NULL, 'PTHR36453', NULL, NULL, NULL, NULL, 'SECRETED PROTEIN-RELATED', NULL, NULL, NULL, 8),
(251495, NULL, 'PTHR13492', NULL, NULL, NULL, NULL, 'RING FINGER PROTEIN 37', NULL, NULL, 27072, 8),
(251496, NULL, 'PTHR33331', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 162', NULL, NULL, 27757, 8),
(251497, NULL, 'PTHR34583', NULL, NULL, NULL, NULL, 'ANTIPORTER SUBUNIT MNHC2-RELATED', NULL, NULL, NULL, 8),
(251498, NULL, 'PTHR36582', NULL, NULL, NULL, NULL, 'ANTITOXIN PARD', NULL, NULL, 6361, 8),
(251499, NULL, 'PTHR23210', NULL, NULL, NULL, NULL, 'ACTIVATING TRANSCRIPTION FACTOR 7 INTERACTING PROTEIN', NULL, NULL, 22066, 8),
(251500, NULL, 'PTHR28256', NULL, NULL, NULL, NULL, 'RIBONUCLEASES P/MRP PROTEIN SUBUNIT POP7', NULL, NULL, 21413, 8),
(251501, NULL, 'PTHR14487', NULL, NULL, NULL, NULL, 'ADRENOCORTICAL DYSPLASIA PROTEIN ACD', NULL, NULL, 26706, 8),
(251502, NULL, 'PTHR46956', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE KINASE 6', NULL, NULL, 27712, 8),
(251503, NULL, 'PTHR10797', NULL, NULL, NULL, NULL, 'CCR4-NOT TRANSCRIPTION COMPLEX SUBUNIT', NULL, NULL, 27148, 8),
(251504, NULL, 'PTHR36944', NULL, NULL, NULL, NULL, 'PROTEIN CBG02791-RELATED', NULL, NULL, NULL, 8),
(251505, NULL, 'PTHR31967', NULL, NULL, NULL, NULL, 'GROUNDHOG (HEDGEHOG-LIKE FAMILY)-RELATED', NULL, NULL, NULL, 8),
(251506, NULL, 'PTHR43903', NULL, NULL, NULL, NULL, 'NEUROLIGIN', NULL, NULL, NULL, 8),
(251507, NULL, 'PTHR44733', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 22', NULL, NULL, NULL, 8),
(251508, NULL, 'PTHR38439', NULL, NULL, NULL, NULL, 'AURACYANIN-B', NULL, NULL, NULL, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(251509, NULL, 'PTHR43979', NULL, NULL, NULL, NULL, 'PRE-MRNA-PROCESSING FACTOR 17', NULL, NULL, 22875, 8),
(251510, NULL, 'PTHR10540', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT F-RELATED', NULL, NULL, NULL, 8),
(251511, NULL, 'PTHR15506', NULL, NULL, NULL, NULL, 'DOPPEL PRION', NULL, NULL, NULL, 8),
(251512, NULL, 'PTHR33207', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(251513, NULL, 'PTHR23037', NULL, NULL, NULL, NULL, 'CYTOKINE RECEPTOR', NULL, NULL, NULL, 8),
(251514, NULL, 'PTHR15123', NULL, NULL, NULL, NULL, 'SECRETED AND TRANSMEMBRANE PROTEIN 1', NULL, NULL, 31692, 8),
(251515, NULL, 'PTHR35632', NULL, NULL, NULL, NULL, 'MAJOR POLLEN ALLERGEN OLE E 6-LIKE', NULL, NULL, 13442, 8),
(251516, NULL, 'PTHR43657', NULL, NULL, NULL, NULL, 'TRYPTOPHAN RNA-BINDING ATTENUATOR PROTEIN-LIKE PROTEIN', NULL, NULL, NULL, 8),
(251517, NULL, 'PTHR14791', NULL, NULL, NULL, NULL, 'BOMB/KIRA PROTEINS', NULL, NULL, NULL, 8),
(251518, NULL, 'PTHR15305', NULL, NULL, NULL, NULL, 'MELANOMA ANTIGEN RECOGNIZED BY T-CELLS 1', NULL, NULL, 21653, 8),
(251519, NULL, 'PTHR13601', NULL, NULL, NULL, NULL, 'GAMETOGENETIN-BINDING PROTEIN 2', NULL, NULL, 21864, 8),
(251520, NULL, 'PTHR46156', NULL, NULL, NULL, NULL, 'CCCH ZINGC FINGER', NULL, NULL, NULL, 8),
(251521, NULL, 'PTHR36839', NULL, NULL, NULL, NULL, 'METALLO-BETA-LACTAMASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_5G12770)', NULL, NULL, NULL, 8),
(251522, NULL, 'PTHR30070', NULL, NULL, NULL, NULL, 'HEME EXPORTER PROTEIN B', NULL, NULL, 7263, 8),
(251523, NULL, 'PTHR21527', NULL, NULL, NULL, NULL, 'NUCLEOPORIN NUP35', NULL, NULL, 18446, 8),
(251524, NULL, 'PTHR11691', NULL, NULL, NULL, NULL, 'TYPE I INTERFERON', NULL, NULL, 5598, 8),
(251525, NULL, 'PTHR47334', NULL, NULL, NULL, NULL, 'SPLICING FACTOR PWI DOMAIN-CONTAINING PROTEIN / RNA RECOGNITION MOTIF (RRM)-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(251526, NULL, 'PTHR42060', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(251527, NULL, 'PTHR47887', NULL, NULL, NULL, NULL, 'CYSTATIN-LIKE 1', NULL, NULL, 35517, 8),
(251528, NULL, 'PTHR14650', NULL, NULL, NULL, NULL, 'PROLYL HYDROXYLASE-RELATED', NULL, NULL, 32996, 8),
(251529, NULL, 'PTHR31460', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(251530, NULL, 'PTHR10277', NULL, NULL, NULL, NULL, 'HOMOCITRATE SYNTHASE-RELATED', NULL, NULL, NULL, 8),
(251531, NULL, 'PTHR33104', NULL, NULL, NULL, NULL, 'SI:DKEY-29D5.2', NULL, NULL, NULL, 8),
(251532, NULL, 'PTHR12632', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR NF-Y ALPHA-RELATED', NULL, NULL, 2064, 8),
(251533, NULL, 'PTHR47323', NULL, NULL, NULL, NULL, 'FMRFAMIDE PEPTIDE RECEPTOR FAMILY-RELATED', NULL, NULL, NULL, 8),
(251534, NULL, 'PTHR13939', NULL, NULL, NULL, NULL, 'NICOTINAMIDE-NUCLEOTIDE AMIDOHYDROLASE PNCC', NULL, NULL, NULL, 8),
(251535, NULL, 'PTHR45986', NULL, NULL, NULL, NULL, 'ZINC FINGER MATRIN-TYPE PROTEIN 2', NULL, NULL, 31524, 8),
(251536, NULL, 'PTHR37302', NULL, NULL, NULL, NULL, 'SLR1116 PROTEIN', NULL, NULL, 2405, 8),
(251537, NULL, 'PTHR48029', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 8', NULL, NULL, NULL, 8),
(251538, NULL, 'PTHR34389', NULL, NULL, NULL, NULL, 'L-RHAMNOSE MUTAROTASE', NULL, NULL, NULL, 8),
(251539, NULL, 'PTHR31582', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS A (ALPHA)-RELATED-RELATED', NULL, NULL, NULL, 8),
(251540, NULL, 'PTHR47871', NULL, NULL, NULL, NULL, 'NAC DOMAIN-CONTAINING PROTEIN 8', NULL, NULL, NULL, 8),
(251541, NULL, 'PTHR16230', NULL, NULL, NULL, NULL, 'CAPPUCCINO', NULL, NULL, 18815, 8),
(251542, NULL, 'PTHR30273', NULL, NULL, NULL, NULL, 'PERIPLASMIC SIGNAL SENSOR AND SIGMA FACTOR ACTIVATOR FECR-RELATED', NULL, NULL, 13004, 8),
(251543, NULL, 'PTHR46680', NULL, NULL, NULL, NULL, 'NF-KAPPA-B INHIBITOR ALPHA', NULL, NULL, NULL, 8),
(251544, NULL, 'PTHR47036', NULL, NULL, NULL, NULL, 'COBALT-FACTOR III C(17)-METHYLTRANSFERASE-RELATED', NULL, NULL, NULL, 8),
(251545, NULL, 'PTHR46418', NULL, NULL, NULL, NULL, 'SRBC-64-RELATED-RELATED', NULL, NULL, NULL, 8),
(251546, NULL, 'PTHR47861', NULL, NULL, NULL, NULL, 'FKBP-TYPE PEPTIDYL-PROLYL CIS-TRANS ISOMERASE SLYD', NULL, NULL, NULL, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(251547, NULL, 'PTHR13114', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 17', NULL, NULL, 14697, 8),
(251548, NULL, 'PTHR20648', NULL, NULL, NULL, NULL, 'ELONGIN-C', NULL, NULL, 30282, 8),
(251549, NULL, 'PTHR14966', NULL, NULL, NULL, NULL, 'Z-DNA-BINDING PROTEIN 1', NULL, NULL, 37168, 8),
(251550, NULL, 'PTHR38786', NULL, NULL, NULL, NULL, 'FLAGELLAR FLIJ PROTEIN', NULL, NULL, NULL, 8),
(251551, NULL, 'PTHR44653', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 1', NULL, NULL, NULL, 8),
(251552, NULL, 'PTHR33487', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 54', NULL, NULL, NULL, 8),
(251553, NULL, 'PTHR31273', NULL, NULL, NULL, NULL, 'PHOSPHOKETOLASE-RELATED', NULL, NULL, 2786, 8),
(251554, NULL, 'PTHR36751', NULL, NULL, NULL, NULL, 'F3E22.8 PROTEIN', NULL, NULL, NULL, 8),
(251555, NULL, 'PTHR47446', NULL, NULL, NULL, NULL, 'RING-TYPE E3 UBIQUITIN TRANSFERASE', NULL, NULL, NULL, 8),
(251556, NULL, 'PTHR47439', NULL, NULL, NULL, NULL, 'LOW MOLECULAR WEIGHT PHOSPHOTYROSINE PROTEIN PHOSPHATASE-RELATED', NULL, NULL, NULL, 8),
(251557, NULL, 'PTHR22796', NULL, NULL, NULL, NULL, 'URG4-RELATED', NULL, NULL, NULL, 8),
(251558, NULL, 'PTHR11811', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONATE DEHYDROGENASE', NULL, NULL, 11177, 8),
(251559, NULL, 'PTHR44826', NULL, NULL, NULL, NULL, 'SPORE COAT PROTEIN SP85', NULL, NULL, NULL, 8),
(251560, NULL, 'PTHR13315', NULL, NULL, NULL, NULL, 'METALLO PHOSPHOESTERASE RELATED', NULL, NULL, 33660, 8),
(251561, NULL, 'PTHR43687', NULL, NULL, NULL, NULL, 'ADENYLYLSULFATE REDUCTASE, BETA SUBUNIT', NULL, NULL, NULL, 8),
(251562, NULL, 'PTHR22467', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(251563, NULL, 'PTHR15751', NULL, NULL, NULL, NULL, 'TRAFFICKING KINESIN-BINDING PROTEIN', NULL, NULL, NULL, 8),
(251564, NULL, 'PTHR21041', NULL, NULL, NULL, NULL, 'DENDRITIC CELL-SPECIFIC TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(251565, NULL, 'PTHR31611', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY NICKEL TRANSPORT PROTEIN NIC1', NULL, NULL, 3019, 8),
(251566, NULL, 'PTHR13229', NULL, NULL, NULL, NULL, 'PROTEIN KISH-A', NULL, NULL, NULL, 8),
(251567, NULL, 'PTHR47760', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR B0563.6-LIKE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(251568, NULL, 'PTHR12994', NULL, NULL, NULL, NULL, 'SECERNIN', NULL, NULL, 5995, 8),
(251569, NULL, 'PTHR34472', NULL, NULL, NULL, NULL, 'SULFUR CARRIER PROTEIN THIS', NULL, NULL, 5177, 8),
(251570, NULL, 'PTHR37271', NULL, NULL, NULL, NULL, 'KARYOGAMY PROTEIN KAR9', NULL, NULL, 17777, 8),
(251571, NULL, 'PTHR44207', NULL, NULL, NULL, NULL, 'SURFACE ANTIGEN BSPA-LIKE-RELATED', NULL, NULL, NULL, 8),
(251572, NULL, 'PTHR37018', NULL, NULL, NULL, NULL, 'CULTURE SPECIFIC PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_2G00130)-RELATED', NULL, NULL, NULL, 8),
(251573, NULL, 'PTHR13325', NULL, NULL, NULL, NULL, 'PROTEASE M50 MEMBRANE-BOUND TRANSCRIPTION FACTOR SITE 2 PROTEASE', NULL, NULL, 1173, 8),
(251574, NULL, 'PTHR46598', NULL, NULL, NULL, NULL, 'BNAC05G43320D PROTEIN', NULL, NULL, NULL, 8),
(251575, NULL, 'PTHR33913', NULL, NULL, NULL, NULL, 'ALEURONE LAYER MORPHOGENESIS PROTEIN', NULL, NULL, NULL, 8),
(251576, NULL, 'PTHR15357', NULL, NULL, NULL, NULL, 'OLFACTORY MARKER PROTEIN', NULL, NULL, 7752, 8),
(251577, NULL, 'PTHR11143', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L26 FAMILY MEMBER', NULL, NULL, 4891, 8),
(251578, NULL, 'PTHR46324', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER 43-RELATED', NULL, NULL, 35140, 8),
(251579, NULL, 'PTHR39469', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(251580, NULL, 'PTHR46321', NULL, NULL, NULL, NULL, 'KIF1-BINDING PROTEIN', NULL, NULL, NULL, 8),
(251581, NULL, 'PTHR38600', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', NULL, NULL, NULL, 8),
(251582, NULL, 'PTHR14467', NULL, NULL, NULL, NULL, 'ARV1', NULL, NULL, 7468, 8),
(251583, NULL, 'PTHR46591', NULL, NULL, NULL, NULL, 'ZINC FINGER FYVE DOMAIN-CONTAINING PROTEIN 26', NULL, NULL, 22576, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(251584, NULL, 'PTHR33741', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN DDB_G0269096-RELATED', NULL, NULL, NULL, 8),
(251585, NULL, 'PTHR22958', NULL, NULL, NULL, NULL, 'GLYCEROPHOSPHORYL DIESTER PHOSPHODIESTERASE', NULL, NULL, NULL, 8),
(251586, NULL, 'PTHR31418', NULL, NULL, NULL, NULL, 'FATTY-ACID AND RETINOL-BINDING PROTEIN 1', NULL, NULL, 14039, 8),
(251587, NULL, 'PTHR24359', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE SBK1', NULL, NULL, NULL, 8),
(251588, NULL, 'PTHR18837', NULL, NULL, NULL, NULL, 'STROMAL CELL-DERIVED FACTOR 1', NULL, NULL, 27378, 8),
(251589, NULL, 'PTHR41282', NULL, NULL, NULL, NULL, 'CONSERVED TRANSMEMBRANE PROTEIN-RELATED', NULL, NULL, 14098, 8),
(251590, NULL, 'PTHR33734', NULL, NULL, NULL, NULL, 'LYSM DOMAIN-CONTAINING GPI-ANCHORED PROTEIN 2', NULL, NULL, NULL, 8),
(251591, NULL, 'PTHR35868', NULL, NULL, NULL, NULL, '', NULL, NULL, 17930, 8),
(251592, NULL, 'PTHR47748', NULL, NULL, NULL, NULL, 'TACHYLECTIN DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(251593, NULL, 'PTHR45905', NULL, NULL, NULL, NULL, 'GOLGI-LOCALIZED, GAMMA-ADAPTIN EAR CONTAINING, ARF BINDING PROTEIN', NULL, NULL, NULL, 8),
(251594, NULL, 'PTHR36542', NULL, NULL, NULL, NULL, 'GIG2-LIKE PROTEIN DRED-RELATED', NULL, NULL, NULL, 8),
(251595, NULL, 'PTHR33210', NULL, NULL, NULL, NULL, 'PROTODERMAL FACTOR 1', NULL, NULL, 27012, 8),
(251596, NULL, 'PTHR33511', NULL, NULL, NULL, NULL, 'OS06G0632400 PROTEIN', NULL, NULL, NULL, 8),
(251597, NULL, 'PTHR15046', NULL, NULL, NULL, NULL, 'GLYCO_TRANS_2-LIKE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(251598, NULL, 'PTHR24110', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 78 KDA', NULL, NULL, NULL, 8),
(251599, NULL, 'PTHR14435', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 106', NULL, NULL, 36718, 8),
(251600, NULL, 'PTHR35526', NULL, NULL, NULL, NULL, 'ANTI-SIGMA-F FACTOR RSBW-RELATED', NULL, NULL, NULL, 8),
(251601, NULL, 'PTHR31134', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 128', NULL, NULL, 31794, 8),
(251602, NULL, 'PTHR47654', NULL, NULL, NULL, NULL, 'ZN(II)2CYS6 TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', NULL, NULL, NULL, 8),
(251603, NULL, 'PTHR22984', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE PIM', NULL, NULL, NULL, 8),
(251604, NULL, 'PTHR46750', NULL, NULL, NULL, NULL, 'KUNITZ-TYPE PROTEASE INHIBITOR 1', NULL, NULL, NULL, 8),
(251605, NULL, 'PTHR47512', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(251606, NULL, 'PTHR31449', NULL, NULL, NULL, NULL, 'UPF0598 PROTEIN C8ORF82', NULL, NULL, 24705, 8),
(251607, NULL, 'PTHR47617', NULL, NULL, NULL, NULL, 'G-PROTEIN SIGNALING MODULATOR 3', NULL, NULL, 34325, 8),
(251608, NULL, 'PTHR35794', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN DIVIVA', NULL, NULL, 2015, 8),
(251609, NULL, 'PTHR37975', NULL, NULL, NULL, NULL, 'FLYWCH ZINC FINGER TRANSCRIPTION FACTOR HOMOLOG', NULL, NULL, NULL, 8),
(251610, NULL, 'PTHR39190', NULL, NULL, NULL, NULL, 'FLAGELLAR ASSEMBLY FACTOR FLIW', NULL, NULL, 6268, 8),
(251611, NULL, 'PTHR15970', NULL, NULL, NULL, NULL, 'ELL-ASSOCIATED FACTOR EAF', NULL, NULL, 23901, 8),
(251612, NULL, 'PTHR33904', NULL, NULL, NULL, NULL, 'ESSENTIAL MCU REGULATOR, MITOCHONDRIAL', NULL, NULL, 19373, 8),
(251613, NULL, 'PTHR45722', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L35', NULL, NULL, 35792, 8),
(251614, NULL, 'PTHR46294', NULL, NULL, NULL, NULL, 'SEGMENTATION PROTEIN EVEN-SKIPPED', NULL, NULL, NULL, 8),
(251615, NULL, 'PTHR24047', NULL, NULL, NULL, NULL, 'FI01909P-RELATED', NULL, NULL, NULL, 8),
(251616, NULL, 'PTHR30289', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN YBCL-RELATED', NULL, NULL, 11363, 8),
(251617, NULL, 'PTHR43820', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY BRANCHED-CHAIN AMINO ACID TRANSPORT ATP-BINDING PROTEIN LIVF', NULL, NULL, NULL, 8),
(251618, NULL, 'PTHR11060', NULL, NULL, NULL, NULL, 'PROTEIN MEMO1', NULL, NULL, 3653, 8),
(251619, NULL, 'PTHR40626', NULL, NULL, NULL, NULL, 'MIP31509P', NULL, NULL, NULL, 8),
(251620, NULL, 'PTHR13255', NULL, NULL, NULL, NULL, 'ATAXIN-10', NULL, NULL, NULL, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(251621, NULL, 'PTHR47586', NULL, NULL, NULL, NULL, 'DIRIGENT PROTEIN', NULL, NULL, NULL, 8),
(251622, NULL, 'PTHR14221', NULL, NULL, NULL, NULL, 'WD REPEAT DOMAIN 44', NULL, NULL, 30409, 8),
(251623, NULL, 'PTHR21481', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 32544, 8),
(251624, NULL, 'PTHR36346', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(251625, NULL, 'PTHR36490', NULL, NULL, NULL, NULL, 'STRESS ENHANCED PROTEIN 2, CHLOROPLASTIC', NULL, NULL, 36628, 8),
(251626, NULL, 'PTHR38693', NULL, NULL, NULL, NULL, 'UBIQUINONE BIOSYNTHESIS PROTEIN UBIJ', NULL, NULL, 30984, 8),
(251627, NULL, 'PTHR22855', NULL, NULL, NULL, NULL, 'ACETYL, PROPIONYL, PYRUVATE, AND GLUTACONYL CARBOXYLASE-RELATED', NULL, NULL, 34920, 8),
(251628, NULL, 'PTHR12892', NULL, NULL, NULL, NULL, 'FGF RECEPTOR ACTIVATING PROTEIN 1', NULL, NULL, 33157, 8),
(251629, NULL, 'PTHR12153', NULL, NULL, NULL, NULL, 'SELENOPROTEIN O', NULL, NULL, NULL, 8),
(251630, NULL, 'PTHR32440', NULL, NULL, NULL, NULL, 'PHOSPHATASE DCR2-RELATED-RELATED', NULL, NULL, NULL, 8),
(251631, NULL, 'PTHR38753', NULL, NULL, NULL, NULL, 'SLR1441 PROTEIN', NULL, NULL, NULL, 8),
(251632, NULL, 'PTHR11528', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN 90 FAMILY MEMBER', NULL, NULL, 7377, 8),
(251633, NULL, 'PTHR21396', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L43', NULL, NULL, 30254, 8),
(251634, NULL, 'PTHR36293', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 213', NULL, NULL, 25584, 8),
(251635, NULL, 'PTHR33252', NULL, NULL, NULL, NULL, 'THIRD ORF IN TRANSPOSON ISC1160', NULL, NULL, NULL, 8),
(251636, NULL, 'PTHR33021', NULL, NULL, NULL, NULL, 'BLUE COPPER PROTEIN', NULL, NULL, 27223, 8),
(251637, NULL, 'PTHR10583', NULL, NULL, NULL, NULL, 'CHROMOGRANIN', NULL, NULL, 4237, 8),
(251638, NULL, 'PTHR43355', NULL, NULL, NULL, NULL, 'FLAVIN REDUCTASE (NADPH)', NULL, NULL, NULL, 8),
(251639, NULL, 'PTHR39231', NULL, NULL, NULL, NULL, 'HISTONE DEACETYLASE COMPLEX SUBUNIT SAP25', NULL, NULL, 26570, 8),
(251640, NULL, 'PTHR15272', NULL, NULL, NULL, NULL, 'CHROMATIN ASSEMBLY FACTOR 1 SUBUNIT A  CAF-1 SUBUNIT A', NULL, NULL, NULL, 8),
(251641, NULL, 'PTHR39217', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(251642, NULL, 'PTHR34873', NULL, NULL, NULL, NULL, 'SSR1766 PROTEIN', NULL, NULL, NULL, 8),
(251643, NULL, 'PTHR31739', NULL, NULL, NULL, NULL, 'ENT-COPALYL DIPHOSPHATE SYNTHASE, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(251644, NULL, 'PTHR33702', NULL, NULL, NULL, NULL, 'BNAA09G40010D PROTEIN', NULL, NULL, NULL, 8),
(251645, NULL, 'PTHR43624', NULL, NULL, NULL, NULL, 'ELECTRON TRANSFER FLAVOPROTEIN-QUINONE OXIDOREDUCTASE YDIS-RELATED', NULL, NULL, 27368, 8),
(251646, NULL, 'PTHR38006', NULL, NULL, NULL, NULL, 'MEIOSIS-SPECIFIC KINETOCHORE PROTEIN', NULL, NULL, 17528, 8),
(251647, NULL, 'PTHR31552', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR CLASS GAMMA', NULL, NULL, NULL, 8),
(251648, NULL, 'PTHR33384', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(251649, NULL, 'PTHR42818', NULL, NULL, NULL, NULL, 'SULFOPYRUVATE DECARBOXYLASE SUBUNIT ALPHA', NULL, NULL, NULL, 8),
(251650, NULL, 'PTHR45878', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN WIP2', NULL, NULL, 35656, 8),
(251651, NULL, 'PTHR45754', NULL, NULL, NULL, NULL, 'METHYLENETETRAHYDROFOLATE REDUCTASE', NULL, NULL, NULL, 8),
(251652, NULL, 'PTHR43617', NULL, NULL, NULL, NULL, 'L-AMINO ACID N-ACETYLTRANSFERASE', NULL, NULL, NULL, 8),
(251653, NULL, 'PTHR46767', NULL, NULL, NULL, NULL, 'LIM DOMAIN ONLY PROTEIN 7', NULL, NULL, 21786, 8),
(251654, NULL, 'PTHR12141', NULL, NULL, NULL, NULL, 'ARFAPTIN-RELATED', NULL, NULL, 25428, 8),
(251655, NULL, 'PTHR42947', NULL, NULL, NULL, NULL, 'COB--COM HETERODISULFIDE REDUCTASE SUBUNIT B 1', NULL, NULL, NULL, 8),
(251656, NULL, 'PTHR42941', NULL, NULL, NULL, NULL, 'SLL1037 PROTEIN', NULL, NULL, 13728, 8),
(251657, NULL, 'PTHR38785', NULL, NULL, NULL, NULL, 'HOMOLOG OF VIRK', NULL, NULL, 10002, 8),
(251658, NULL, 'PTHR11042', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 2-ALPHA KINASE  EIF2-ALPHA KINASE -RELATED', NULL, NULL, NULL, 8);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(251659, NULL, 'PTHR43221', NULL, NULL, NULL, NULL, 'PROTEASE HTPX', NULL, NULL, NULL, 8),
(251660, NULL, 'PTHR34542', NULL, NULL, NULL, NULL, 'OS08G0359900 PROTEIN', NULL, NULL, NULL, 8),
(251661, NULL, 'PTHR13351', NULL, NULL, NULL, NULL, 'RENIN RECEPTOR', NULL, NULL, 12667, 8),
(251662, NULL, 'PTHR46798', NULL, NULL, NULL, NULL, 'OS09G0511500 PROTEIN', NULL, NULL, 35307, 8),
(251663, NULL, 'PTHR40114', NULL, NULL, NULL, NULL, 'SLR0698 PROTEIN', NULL, NULL, 11039, 8),
(251664, NULL, 'PTHR34358', NULL, NULL, NULL, NULL, 'OS03G0411600 PROTEIN', NULL, NULL, 8247, 8),
(251665, NULL, 'PTHR31553', NULL, NULL, NULL, NULL, 'NF-KAPPA-B ESSENTIAL MODULATOR', NULL, NULL, NULL, 8),
(251666, NULL, 'PTHR24186', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT', NULL, NULL, NULL, 8),
(251667, NULL, 'PTHR12868', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE B22 SUBUNIT', NULL, NULL, 27938, 8),
(251668, NULL, 'PTHR35304', NULL, NULL, NULL, NULL, 'OS05G0120300 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(251669, NULL, 'PTHR12260', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 27228, 8),
(251670, NULL, 'PTHR43832', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(251671, NULL, 'PTHR31087', NULL, NULL, NULL, NULL, '', NULL, NULL, 2707, 8),
(251672, NULL, 'PTHR12740', NULL, NULL, NULL, NULL, 'JNK1/MAPK8-ASSOCIATED MEMBRANE PROTEIN', NULL, NULL, 12298, 8),
(251673, NULL, 'PTHR47041', NULL, NULL, NULL, NULL, 'SEC14 CYTOSOLIC FACTOR FAMILY PROTEIN / PHOSPHOGLYCERIDE TRANSFER FAMILY PROTEIN', NULL, NULL, NULL, 8),
(251674, NULL, 'PTHR23194', NULL, NULL, NULL, NULL, 'PYGOPUS', NULL, NULL, NULL, 8),
(251675, NULL, 'PTHR21119', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 30318, 8),
(251676, NULL, 'PTHR45282', NULL, NULL, NULL, NULL, 'OS03G0858400 PROTEIN', NULL, NULL, NULL, 8),
(251677, NULL, 'PTHR13117', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM MULTISPAN TRANSMEMBRANE PROTEIN-RELATED', NULL, NULL, 2712, 8),
(251678, NULL, 'PTHR24410', NULL, NULL, NULL, NULL, 'HL07962P-RELATED', NULL, NULL, NULL, 8),
(251679, NULL, 'PTHR31164', NULL, NULL, NULL, NULL, 'RAD52 MOTIF-CONTAINING PROTEIN 1', NULL, NULL, 31251, 8),
(251680, NULL, 'PTHR47172', NULL, NULL, NULL, NULL, 'OS01G0976800 PROTEIN', NULL, NULL, NULL, 8),
(251681, NULL, 'PTHR46485', NULL, NULL, NULL, NULL, 'LIM DOMAIN KINASE 1', NULL, NULL, NULL, 8),
(251682, NULL, 'PTHR20879', NULL, NULL, NULL, NULL, 'INTERLEUKIN-27 SUBUNIT ALPHA', NULL, NULL, 24833, 8),
(251683, NULL, 'PTHR10758', NULL, NULL, NULL, NULL, '26S PROTEASOME NON-ATPASE REGULATORY SUBUNIT 3/COP9 SIGNALOSOME COMPLEX SUBUNIT 3', NULL, NULL, NULL, 8),
(251684, NULL, 'PTHR34587', NULL, NULL, NULL, NULL, 'VWFA DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(251685, NULL, 'PTHR30201', NULL, NULL, NULL, NULL, 'TRIPHOSPHORIBOSYL-DEPHOSPHO-COA SYNTHASE', NULL, NULL, 3682, 8),
(251686, NULL, 'PTHR11847', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L15', NULL, NULL, 6669, 8),
(251687, NULL, 'PTHR13047', NULL, NULL, NULL, NULL, 'PRE-MRNA CLEAVAGE FACTOR IM, 25KD SUBUNIT', NULL, NULL, 20474, 8),
(251688, NULL, 'PTHR43736', NULL, NULL, NULL, NULL, 'ADP-RIBOSE PYROPHOSPHATASE', NULL, NULL, NULL, 8),
(251689, NULL, 'PTHR37423', NULL, NULL, NULL, NULL, 'SOLUBLE LYTIC MUREIN TRANSGLYCOSYLASE-RELATED', NULL, NULL, NULL, 8),
(251690, NULL, 'PTHR43512', NULL, NULL, NULL, NULL, 'TRANSLATION FACTOR GUF1-RELATED', NULL, NULL, 4538, 8),
(251691, NULL, 'PTHR22455', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 21713, 8),
(251692, NULL, 'PTHR11857', NULL, NULL, NULL, NULL, 'ODORANT BINDING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(251693, NULL, 'PTHR24111', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING PROTEIN 34', NULL, NULL, NULL, 8),
(251694, NULL, 'PTHR10132', NULL, NULL, NULL, NULL, 'ALPHA-/EPSILON-SARCOGLYCAN FAMILY MEMBER', NULL, NULL, 7581, 8),
(251695, NULL, 'PTHR15604', NULL, NULL, NULL, NULL, 'SIGNALING THRESHOLD-REGULATING TRANSMEMBRANE ADAPTER 1', NULL, NULL, 30003, 8),
(251696, NULL, 'PTHR36393', NULL, NULL, NULL, NULL, 'SULFATE ADENYLYLTRANSFERASE SUBUNIT', NULL, NULL, NULL, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(251697, NULL, 'PTHR42824', NULL, NULL, NULL, NULL, 'GLUTAMINE AMIDOTRANSFERASE', NULL, NULL, NULL, 8),
(251698, NULL, 'PTHR31404', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL GENOME MAINTENANCE PROTEIN MGM101', NULL, NULL, 8249, 8),
(251699, NULL, 'PTHR47129', NULL, NULL, NULL, NULL, 'QUINONE OXIDOREDUCTASE 2', NULL, NULL, NULL, 8),
(251700, NULL, 'PTHR33958', NULL, NULL, NULL, NULL, 'PROTEIN C8ORF37', NULL, NULL, 21731, 8),
(251701, NULL, 'PTHR46955', NULL, NULL, NULL, NULL, 'PROTEIN CBG01349-RELATED', NULL, NULL, NULL, 8),
(251702, NULL, 'PTHR11576', NULL, NULL, NULL, NULL, 'ZONA PELLUCIDA SPERM-BINDING PROTEIN 3', NULL, NULL, NULL, 8),
(251703, NULL, 'PTHR43289', NULL, NULL, NULL, NULL, 'MITOGEN-ACTIVATED PROTEIN KINASE KINASE KINASE 20-RELATED', NULL, NULL, NULL, 8),
(251704, NULL, 'PTHR23234', NULL, NULL, NULL, NULL, 'ZNF44 PROTEIN', NULL, NULL, NULL, 8),
(251705, NULL, 'PTHR46352', NULL, NULL, NULL, NULL, 'PROTEIN SENSITIVE TO PROTON RHIZOTOXICITY 1', NULL, NULL, 36719, 8),
(251706, NULL, 'PTHR42724', NULL, NULL, NULL, NULL, 'TETRAACYLDISACCHARIDE 4''-KINASE', NULL, NULL, 2245, 8),
(251707, NULL, 'PTHR43389', NULL, NULL, NULL, NULL, 'V-TYPE PROTON ATPASE SUBUNIT B', NULL, NULL, 17381, 8),
(251708, NULL, 'PTHR47085', NULL, NULL, NULL, NULL, 'ZINC FINGER MYND DOMAIN-CONTAINING PROTEIN 15', NULL, NULL, 35137, 8),
(251709, NULL, 'PTHR15364', NULL, NULL, NULL, NULL, '2''-DEOXYNUCLEOSIDE 5''-PHOSPHATE N-HYDROLASE 1', NULL, NULL, NULL, 8),
(251710, NULL, 'PTHR47199', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II STABILITY/ASSEMBLY FACTOR HCF136, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(251711, NULL, 'PTHR31362', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE STELLO1-RELATED', NULL, NULL, 2067, 8),
(251712, NULL, 'PTHR13184', NULL, NULL, NULL, NULL, '37S RIBOSOMAL PROTEIN S22', NULL, NULL, NULL, 8),
(251713, NULL, 'PTHR42198', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN', NULL, NULL, 27468, 8),
(251714, NULL, 'PTHR45681', NULL, NULL, NULL, NULL, 'POLYKETIDE SYNTHASE 44-RELATED', NULL, NULL, NULL, 8),
(251715, NULL, 'PTHR12945', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR EIF3-RELATED', NULL, NULL, 18309, 8),
(251716, NULL, 'PTHR31671', NULL, NULL, NULL, NULL, 'DIABETES AND OBESITY REGULATED, ISOFORM G', NULL, NULL, 21663, 8),
(251717, NULL, 'PTHR42052', NULL, NULL, NULL, NULL, 'ABM DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(251718, NULL, 'PTHR41775', NULL, NULL, NULL, NULL, 'SECRETED PROTEIN-RELATED', NULL, NULL, NULL, 8),
(251719, NULL, 'PTHR47062', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(251720, NULL, 'PTHR28626', NULL, NULL, NULL, NULL, 'SRR1-LIKE PROTEIN', NULL, NULL, 31414, 8),
(251721, NULL, 'PTHR42988', NULL, NULL, NULL, NULL, 'PHOSPHOHYDROLASE', NULL, NULL, NULL, 8),
(251722, NULL, 'PTHR37256', NULL, NULL, NULL, NULL, 'E1A-BINDING PROTEIN P400-LIKE', NULL, NULL, NULL, 8),
(251723, NULL, 'PTHR12266', NULL, NULL, NULL, NULL, 'NA+/CA2+ K+ INDEPENDENT EXCHANGER', NULL, NULL, NULL, 8),
(251724, NULL, 'PTHR33744', NULL, NULL, NULL, NULL, 'CARBOHYDRATE DIACID REGULATOR', NULL, NULL, NULL, 8),
(251725, NULL, 'PTHR36067', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(251726, NULL, 'PTHR46673', NULL, NULL, NULL, NULL, '4F2 CELL-SURFACE ANTIGEN HEAVY CHAIN', NULL, NULL, 34875, 8),
(251727, NULL, 'PTHR34754', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 60', NULL, NULL, 25179, 8),
(251728, NULL, 'PTHR13152', NULL, NULL, NULL, NULL, 'TFIIH, POLYPEPTIDE 4', NULL, NULL, 692, 8),
(251729, NULL, 'PTHR37367', NULL, NULL, NULL, NULL, 'CHROMOSOME 4 OPEN READING FRAME 3', NULL, NULL, 30357, 8),
(251730, NULL, 'PTHR22923', NULL, NULL, NULL, NULL, 'CEREBELLIN-RELATED', NULL, NULL, NULL, 8),
(251731, NULL, 'PTHR13947', NULL, NULL, NULL, NULL, 'GNAT FAMILY N-ACETYLTRANSFERASE', NULL, NULL, NULL, 8),
(251732, NULL, 'PTHR33981', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(251733, NULL, 'PTHR15056', NULL, NULL, NULL, NULL, 'ACTIVATOR OF APOPTOSIS HARAKIRI', NULL, NULL, 15833, 8),
(251734, NULL, 'PTHR30482', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY BRANCHED-CHAIN AMINO ACID TRANSPORT SYSTEM PERMEASE', NULL, NULL, 34864, 8);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(251735, NULL, 'PTHR34696', NULL, NULL, NULL, NULL, 'PHOSPHORIBOSYLFORMYLGLYCINAMIDINE SYNTHASE SUBUNIT PURS', NULL, NULL, 3392, 8),
(251736, NULL, 'PTHR47646', NULL, NULL, NULL, NULL, 'PDZ DOMAIN-CONTAINING PROTEIN MAGIX', NULL, NULL, 25416, 8),
(251737, NULL, 'PTHR43999', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 2', NULL, NULL, 36290, 8),
(251738, NULL, 'PTHR24089', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 25', NULL, NULL, NULL, 8),
(251739, NULL, 'PTHR11079', NULL, NULL, NULL, NULL, 'CYTOSINE DEAMINASE FAMILY MEMBER', NULL, NULL, NULL, 8),
(251740, NULL, 'PTHR37694', NULL, NULL, NULL, NULL, 'SLR8022 PROTEIN', NULL, NULL, NULL, 8),
(251741, NULL, 'PTHR48129', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L37A', NULL, NULL, NULL, 8),
(251742, NULL, 'PTHR43772', NULL, NULL, NULL, NULL, 'ENDO-1,4-BETA-XYLANASE', NULL, NULL, NULL, 8),
(251743, NULL, 'PTHR39596', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(251744, NULL, 'PTHR20973', NULL, NULL, NULL, NULL, 'NON-SMC ELEMENT 1-RELATED', NULL, NULL, 12510, 8),
(251745, NULL, 'PTHR47148', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY FACTOR 1 HOMOLOG', NULL, NULL, NULL, 8),
(251746, NULL, 'PTHR40735', NULL, NULL, NULL, NULL, 'RNA-EDITING COMPLEX PROTEIN MP42-RELATED', NULL, NULL, NULL, 8),
(251747, NULL, 'PTHR43329', NULL, NULL, NULL, NULL, 'EPOXIDE HYDROLASE', NULL, NULL, NULL, 8),
(251748, NULL, 'PTHR47868', NULL, NULL, NULL, NULL, 'OS05G0457700 PROTEIN', NULL, NULL, NULL, 8),
(251749, NULL, 'PTHR35701', NULL, NULL, NULL, NULL, 'OS11G0148400 PROTEIN', NULL, NULL, NULL, 8),
(251750, NULL, 'PTHR43249', NULL, NULL, NULL, NULL, 'UDP-N-ACETYL-2-AMINO-2-DEOXY-D-GLUCURONATE OXIDASE', NULL, NULL, NULL, 8),
(251751, NULL, 'PTHR31407', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(251752, NULL, 'PTHR11911', NULL, NULL, NULL, NULL, 'INOSINE-5-MONOPHOSPHATE DEHYDROGENASE RELATED', NULL, NULL, 1005, 8),
(251753, NULL, 'PTHR43182', NULL, NULL, NULL, NULL, 'COBALT-PRECORRIN-6B C(15)-METHYLTRANSFERASE (DECARBOXYLATING)', NULL, NULL, NULL, 8),
(251754, NULL, 'PTHR47958', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT RNA HELICASE DBP3', NULL, NULL, NULL, 8),
(251755, NULL, 'PTHR36895', NULL, NULL, NULL, NULL, '', NULL, NULL, 1727, 8),
(251756, NULL, 'PTHR35801', NULL, NULL, NULL, NULL, 'PHOSPHOSERINE PHOSPHATASE RSBX', NULL, NULL, 32593, 8),
(251757, NULL, 'PTHR21115', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(251758, NULL, 'PTHR45848', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE 12 FAMILY MEMBER', NULL, NULL, NULL, 8),
(251759, NULL, 'PTHR33484', NULL, NULL, NULL, NULL, 'BNAC07G33360D PROTEIN', NULL, NULL, NULL, 8),
(251760, NULL, 'PTHR22656', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(251761, NULL, 'PTHR28663', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 173', NULL, NULL, 33699, 8),
(251762, NULL, 'PTHR37745', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(251763, NULL, 'PTHR32073', NULL, NULL, NULL, NULL, 'GH11358P', NULL, NULL, 19777, 8),
(251764, NULL, 'PTHR12760', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN', NULL, NULL, 31016, 8),
(251765, NULL, 'PTHR11165', NULL, NULL, NULL, NULL, 'SKP1', NULL, NULL, 16788, 8),
(251766, NULL, 'PTHR33397', NULL, NULL, NULL, NULL, 'UPF0331 PROTEIN YUTE', NULL, NULL, NULL, 8),
(251767, NULL, 'PTHR12245', NULL, NULL, NULL, NULL, 'SPRY DOMAIN CONTAINING SOCS BOX PROTEIN', NULL, NULL, NULL, 8),
(251768, NULL, 'PTHR46670', NULL, NULL, NULL, NULL, 'ENDO/EXONUCLEASE/PHOSPHATASE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(251769, NULL, 'PTHR47632', NULL, NULL, NULL, NULL, 'FMRFAMIDE PEPTIDE RECEPTOR FAMILY-RELATED', NULL, NULL, NULL, 8),
(251770, NULL, 'PTHR21818', NULL, NULL, NULL, NULL, 'BC025462 PROTEIN', NULL, NULL, 25287, 8),
(251771, NULL, 'PTHR20940', NULL, NULL, NULL, NULL, 'TETRA THYMOSIN', NULL, NULL, NULL, 8),
(251772, NULL, 'PTHR43567', NULL, NULL, NULL, NULL, 'FLAVOREDOXIN-RELATED-RELATED', NULL, NULL, NULL, 8),
(251773, NULL, 'PTHR30073', NULL, NULL, NULL, NULL, 'ASPARTATE--AMMONIA LIGASE', NULL, NULL, 2212, 8);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(251774, NULL, 'PTHR34829', NULL, NULL, NULL, NULL, 'SECRETOGLOBIN FAMILY 3A MEMBER 2', NULL, NULL, 31508, 8),
(251775, NULL, 'PTHR33925', NULL, NULL, NULL, NULL, 'PLASTID DIVISION PROTEIN CDP1, CHLOROPLASTIC-RELATED', NULL, NULL, 34916, 8),
(251776, NULL, 'PTHR13046', NULL, NULL, NULL, NULL, 'PROTEASE U48 CAAX PRENYL PROTEASE RCE1', NULL, NULL, 27481, 8),
(251777, NULL, 'PTHR35322', NULL, NULL, NULL, NULL, 'PROTEIN CPR-5', NULL, NULL, 34843, 8),
(251778, NULL, 'PTHR15593', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL 3-KINASE REGULATORY SUBUNIT', NULL, NULL, 18149, 8),
(251779, NULL, 'PTHR33738', NULL, NULL, NULL, NULL, 'EMB|CAB82975.1', NULL, NULL, NULL, 8),
(251780, NULL, 'PTHR23251', NULL, NULL, NULL, NULL, 'LYSINE-RICH CEACAM1 CO-ISOLATED PROTEIN  LYRIC PROTEIN', NULL, NULL, NULL, 8),
(251781, NULL, 'PTHR46939', NULL, NULL, NULL, NULL, 'ZINC FINGER CCHC DOMAIN-CONTAINING PROTEIN 2', NULL, NULL, 34156, 8),
(251782, NULL, 'PTHR37463', NULL, NULL, NULL, NULL, 'GSL3115 PROTEIN', NULL, NULL, 20540, 8),
(251783, NULL, 'PTHR15909', NULL, NULL, NULL, NULL, '39S RIBOSOMAL PROTEIN L35, MITOCHONDRIAL', NULL, NULL, 15533, 8),
(251784, NULL, 'PTHR33087', NULL, NULL, NULL, NULL, 'OS07G0539200 PROTEIN', NULL, NULL, NULL, 8),
(251785, NULL, 'PTHR12977', NULL, NULL, NULL, NULL, 'SUPPRESSOR OF VARIEGATION 4-20-RELATED', NULL, NULL, 28805, 8),
(251786, NULL, 'PTHR47875', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP28, CHLOROPLASTIC', NULL, NULL, 34693, 8),
(251787, NULL, 'PTHR42844', NULL, NULL, NULL, NULL, 'DIHYDRONEOPTERIN ALDOLASE 1-RELATED', NULL, NULL, 10371, 8),
(251788, NULL, 'PTHR36750', NULL, NULL, NULL, NULL, 'SEC-C MOTIF PROTEIN', NULL, NULL, NULL, 8),
(251789, NULL, 'PTHR22192', NULL, NULL, NULL, NULL, 'SPERIOLIN', NULL, NULL, 21591, 8),
(251790, NULL, 'PTHR12056', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASES I, II, AND III', NULL, NULL, 28995, 8),
(251791, NULL, 'PTHR15565', NULL, NULL, NULL, NULL, 'AATF PROTEIN  APOPTOSIS ANTAGONIZING TRANSCRIPTION FACTOR', NULL, NULL, 32952, 8),
(251792, NULL, 'PTHR31637', NULL, NULL, NULL, NULL, '2,3-BISPHOSPHOGLYCERATE-INDEPENDENT PHOSPHOGLYCERATE MUTASE', NULL, NULL, 1480, 8),
(251793, NULL, 'PTHR13032', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM21', NULL, NULL, 13193, 8),
(251794, NULL, 'PTHR15021', NULL, NULL, NULL, NULL, 'DISCONNECTED-RELATED', NULL, NULL, 32264, 8),
(251795, NULL, 'PTHR42718', NULL, NULL, NULL, NULL, 'MAJOR FACILITATOR SUPERFAMILY MULTIDRUG TRANSPORTER MFSC', NULL, NULL, NULL, 8),
(251796, NULL, 'PTHR46663', NULL, NULL, NULL, NULL, 'DIGUANYLATE CYCLASE DGCT-RELATED', NULL, NULL, NULL, 8),
(251797, NULL, 'PTHR32074', NULL, NULL, NULL, NULL, 'RNA DEMETHYLASE ALKBH5', NULL, NULL, 25081, 8),
(251798, NULL, 'PTHR42199', NULL, NULL, NULL, NULL, 'UPF0212 PROTEIN MJ0068', NULL, NULL, 1875, 8),
(251799, NULL, 'PTHR22677', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 60', NULL, NULL, 33073, 8),
(251800, NULL, 'PTHR33478', NULL, NULL, NULL, NULL, 'EXTRACELLULAR METALLOPROTEINASE MEP', NULL, NULL, NULL, 8),
(251801, NULL, 'PTHR24366', NULL, NULL, NULL, NULL, 'IG(IMMUNOGLOBULIN) AND LRR(LEUCINE RICH REPEAT) DOMAINS', NULL, NULL, NULL, 8),
(251802, NULL, 'PTHR24411', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR ERYTHROID 2-RELATED FACTOR', NULL, NULL, NULL, 8),
(251803, NULL, 'PTHR42734', NULL, NULL, NULL, NULL, 'METAL TRANSPORT SYSTEM ATP-BINDING PROTEIN TM_0124-RELATED', NULL, NULL, NULL, 8),
(251804, NULL, 'PTHR31717', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN CONSTANS-LIKE 10', NULL, NULL, NULL, 8),
(251805, NULL, 'PTHR23082', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IIIC  TFIIIC , POLYPEPTIDE 3-RELATED', NULL, NULL, 33498, 8),
(251806, NULL, 'PTHR47399', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 121B', NULL, NULL, 22261, 8),
(251807, NULL, 'PTHR47461', NULL, NULL, NULL, NULL, 'PHYTOLONGIN PHYL1.2', NULL, NULL, 35159, 8),
(251808, NULL, 'PTHR13099', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE SUBUNIT B14.5B', NULL, NULL, 8037, 8);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(251809, NULL, 'PTHR32071', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATORY PROTEIN', NULL, NULL, NULL, 8),
(251810, NULL, 'PTHR12786', NULL, NULL, NULL, NULL, 'SPLICING FACTOR SF3A-RELATED', NULL, NULL, NULL, 8),
(251811, NULL, 'PTHR30465', NULL, NULL, NULL, NULL, 'INNER MEMBRANE ABC TRANSPORTER', NULL, NULL, NULL, 8),
(251812, NULL, 'PTHR15261', NULL, NULL, NULL, NULL, 'THROMBOSPONDIN-TYPE LAMININ G DOMAIN AND EAR REPEAT-CONTAINING', NULL, NULL, NULL, 8),
(251813, NULL, 'PTHR38085', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(251814, NULL, 'PTHR10555', NULL, NULL, NULL, NULL, 'SORTING NEXIN', NULL, NULL, NULL, 8),
(251815, NULL, 'PTHR36847', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(251816, NULL, 'PTHR47352', NULL, NULL, NULL, NULL, 'CLASS I PEPTIDE CHAIN RELEASE FACTOR', NULL, NULL, NULL, 8),
(251817, NULL, 'PTHR23115', NULL, NULL, NULL, NULL, 'TRANSLATION FACTOR', NULL, NULL, NULL, 8),
(251818, NULL, 'PTHR34595', NULL, NULL, NULL, NULL, 'BLR5612 PROTEIN', NULL, NULL, NULL, 8),
(251819, NULL, 'PTHR31006', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 35227, 8),
(251820, NULL, 'PTHR39176', NULL, NULL, NULL, NULL, 'PERIPLASMIC PROTEIN-RELATED', NULL, NULL, NULL, 8),
(251821, NULL, 'PTHR40082', NULL, NULL, NULL, NULL, 'BLR5956 PROTEIN', NULL, NULL, 31427, 8),
(251822, NULL, 'PTHR11019', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR NIMR', NULL, NULL, NULL, 8),
(251823, NULL, 'PTHR45521', NULL, NULL, NULL, NULL, 'TSET COMPLEX MEMBER TSTF', NULL, NULL, NULL, 8),
(251824, NULL, 'PTHR14165', NULL, NULL, NULL, NULL, 'MAJOR VAULT PROTEIN', NULL, NULL, 33270, 8),
(251825, NULL, 'PTHR47200', NULL, NULL, NULL, NULL, 'THYLAKOID LUMENAL 15 KDA PROTEIN 1, CHLOROPLASTIC', NULL, NULL, 35440, 8),
(251826, NULL, 'PTHR39948', NULL, NULL, NULL, NULL, 'GEO11419P1', NULL, NULL, NULL, 8),
(251827, NULL, 'PTHR46931', NULL, NULL, NULL, NULL, 'CRIB DOMAIN-CONTAINING PROTEIN RIC2', NULL, NULL, 33728, 8),
(251828, NULL, 'PTHR47164', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS W-RELATED', NULL, NULL, NULL, 8),
(251829, NULL, 'PTHR41814', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(251830, NULL, 'PTHR22974', NULL, NULL, NULL, NULL, 'MIXED LINEAGE PROTEIN KINASE', NULL, NULL, NULL, 8),
(251831, NULL, 'PTHR16275', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 40', NULL, NULL, 27152, 8),
(251832, NULL, 'PTHR28610', NULL, NULL, NULL, NULL, 'DRAXIN', NULL, NULL, 25252, 8),
(251833, NULL, 'PTHR48234', NULL, NULL, NULL, NULL, 'GH09231P', NULL, NULL, NULL, 8),
(251834, NULL, 'PTHR34031', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN OF 162 KDA', NULL, NULL, 32927, 8),
(251835, NULL, 'PTHR34500', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(251836, NULL, 'PTHR45641', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN (AFU_ORTHOLOGUE AFUA_6G03870)', NULL, NULL, NULL, 8),
(251837, NULL, 'PTHR16356', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AND COILED-COIL DOMAIN-CONTAINING PROTEIN 6 TMCO6', NULL, NULL, NULL, 8),
(251838, NULL, 'PTHR33701', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(251839, NULL, 'PTHR45778', NULL, NULL, NULL, NULL, 'PURPLE ACID PHOSPHATASE-RELATED', NULL, NULL, NULL, 8),
(251840, NULL, 'PTHR31236', NULL, NULL, NULL, NULL, 'BURP DOMAIN PROTEIN USPL1-LIKE', NULL, NULL, 36217, 8),
(251841, NULL, 'PTHR28653', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(251842, NULL, 'PTHR33755', NULL, NULL, NULL, NULL, 'TOXIN PARE1-RELATED', NULL, NULL, NULL, 8),
(251843, NULL, 'PTHR43095', NULL, NULL, NULL, NULL, 'SUGAR KINASE', NULL, NULL, NULL, 8),
(251844, NULL, 'PTHR12604', NULL, NULL, NULL, NULL, 'KU AUTOANTIGEN DNA HELICASE', NULL, NULL, NULL, 8),
(251845, NULL, 'PTHR38776', NULL, NULL, NULL, NULL, 'MLTA-INTERACTING PROTEIN-RELATED', NULL, NULL, 8283, 8),
(251846, NULL, 'PTHR34875', NULL, NULL, NULL, NULL, 'UPF0237 PROTEIN MJ1558', NULL, NULL, NULL, 8),
(251847, NULL, 'PTHR40446', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINE-1-PHOSPHODIESTER ALPHA-N-ACETYLGLUCOSAMINIDASE', NULL, NULL, NULL, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(251848, NULL, 'PTHR46071', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND BTB/POZ DOMAIN-CONTAINING', NULL, NULL, NULL, 8),
(251849, NULL, 'PTHR10683', NULL, NULL, NULL, NULL, 'TRANSALDOLASE', NULL, NULL, 3486, 8),
(251850, NULL, 'PTHR46453', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C-BINDING PROTEIN 1', NULL, NULL, NULL, 8),
(251851, NULL, 'PTHR35174', NULL, NULL, NULL, NULL, 'BLL7171 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(251852, NULL, 'PTHR20338', NULL, NULL, NULL, NULL, 'NUCLEAR RESPIRATORY FACTOR 1', NULL, NULL, 29377, 8),
(251853, NULL, 'PTHR47907', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(251854, NULL, 'PTHR24248', NULL, NULL, NULL, NULL, 'ADRENERGIC RECEPTOR-RELATED G-PROTEIN COUPLED RECEPTOR', NULL, NULL, NULL, 8),
(251855, NULL, 'PTHR42807', NULL, NULL, NULL, NULL, 'GLUTARYL-COA DEHYDROGENASE, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(251856, NULL, 'PTHR32301', NULL, NULL, NULL, NULL, 'COUNTIN RECEPTOR CNR3-RELATED', NULL, NULL, NULL, 8),
(251857, NULL, 'PTHR46055', NULL, NULL, NULL, NULL, 'CIRCADIAN LOCOMOTER OUTPUT CYCLES PROTEIN KAPUT', NULL, NULL, NULL, 8),
(251858, NULL, 'PTHR45697', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 2-RELATED', NULL, NULL, 36073, 8),
(251859, NULL, 'PTHR37873', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 33', NULL, NULL, 32097, 8),
(251860, NULL, 'PTHR39313', NULL, NULL, NULL, NULL, 'IM:7138239', NULL, NULL, NULL, 8),
(251861, NULL, 'PTHR45755', NULL, NULL, NULL, NULL, '', NULL, NULL, 37253, 8),
(251862, NULL, 'PTHR45655', NULL, NULL, NULL, NULL, 'GUANYLATE CYCLASE SOLUBLE SUBUNIT BETA-2', NULL, NULL, NULL, 8),
(251863, NULL, 'PTHR45744', NULL, NULL, NULL, NULL, 'TYROSINE AMINOTRANSFERASE', NULL, NULL, NULL, 8),
(251864, NULL, 'PTHR36340', NULL, NULL, NULL, NULL, 'NAD(P)H DEHYDROGENASE SUBUNIT CRR3, CHLOROPLASTIC-RELATED', NULL, NULL, 32721, 8),
(251865, NULL, 'PTHR34757', NULL, NULL, NULL, NULL, 'JUNCTIONAL PROTEIN ASSOCIATED WITH CORONARY ARTERY DISEASE', NULL, NULL, 23745, 8),
(251866, NULL, 'PTHR32338', NULL, NULL, NULL, NULL, 'N-ACETYL-GAMMA-GLUTAMYL-PHOSPHATE REDUCTASE, CHLOROPLASTIC-RELATED-RELATED', NULL, NULL, NULL, 8),
(251867, NULL, 'PTHR35559', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(251868, NULL, 'PTHR19226', NULL, NULL, NULL, NULL, 'THY-1 MEMBRANE GLYCOPROTEIN', NULL, NULL, 28004, 8),
(251869, NULL, 'PTHR12832', NULL, NULL, NULL, NULL, 'TESTIS-SPECIFIC PROTEIN PBS13  T-COMPLEX 11', NULL, NULL, 13607, 8),
(251870, NULL, 'PTHR35606', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(251871, NULL, 'PTHR12944', NULL, NULL, NULL, NULL, 'SOLUBLE LIVER ANTIGEN/LIVER PANCREAS ANTIGEN', NULL, NULL, 16850, 8),
(251872, NULL, 'PTHR47587', NULL, NULL, NULL, NULL, 'OS05G0103500 PROTEIN', NULL, NULL, NULL, 8),
(251873, NULL, 'PTHR15660', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 24790, 8),
(251874, NULL, 'PTHR45704', NULL, NULL, NULL, NULL, 'RAS-LIKE FAMILY MEMBER 11', NULL, NULL, NULL, 8),
(251875, NULL, 'PTHR48222', NULL, NULL, NULL, NULL, 'PROTEINASE INHIBITOR, PROPEPTIDE', NULL, NULL, NULL, 8),
(251876, NULL, 'PTHR13328', NULL, NULL, NULL, NULL, 'NEGATIVE ELONGATION FACTOR A  NELF-A', NULL, NULL, NULL, 8),
(251877, NULL, 'PTHR45648', NULL, NULL, NULL, NULL, 'GDSL LIPASE/ACYLHYDROLASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_4G14700)', NULL, NULL, NULL, 8),
(251878, NULL, 'PTHR30304', NULL, NULL, NULL, NULL, 'D-TAGATOSE-1,6-BISPHOSPHATE ALDOLASE', NULL, NULL, NULL, 8),
(251879, NULL, 'PTHR31353', NULL, NULL, NULL, NULL, 'FAM98', NULL, NULL, 19330, 8),
(251880, NULL, 'PTHR43408', NULL, NULL, NULL, NULL, 'FMN REDUCTASE (NADPH)', NULL, NULL, NULL, 8),
(251881, NULL, 'PTHR40077', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(251882, NULL, 'PTHR47192', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE 3-2, CHLOROPLASTIC', NULL, NULL, 35101, 8),
(251883, NULL, 'PTHR37231', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(251884, NULL, 'PTHR23193', NULL, NULL, NULL, NULL, 'NUCLEAR PORE COMPLEX PROTEIN  NUP', NULL, NULL, 23181, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(251885, NULL, 'PTHR43668', NULL, NULL, NULL, NULL, 'ALLANTOINASE', NULL, NULL, NULL, 8),
(251886, NULL, 'PTHR31691', NULL, NULL, NULL, NULL, 'ROTATIN', NULL, NULL, 25315, 8),
(251887, NULL, 'PTHR22642', NULL, NULL, NULL, NULL, 'IMIDAZOLONEPROPIONASE', NULL, NULL, NULL, 8),
(251888, NULL, 'PTHR28601', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 24', NULL, NULL, 21595, 8),
(251889, NULL, 'PTHR11477', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR S-II ZINC FINGER DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(251890, NULL, 'PTHR28336', NULL, NULL, NULL, NULL, 'BA1-643', NULL, NULL, NULL, 8),
(251891, NULL, 'PTHR23025', NULL, NULL, NULL, NULL, 'TRIACYLGLYCEROL LIPASE', NULL, NULL, NULL, 8),
(251892, NULL, 'PTHR35999', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM6 HOMOLOG', NULL, NULL, 1403, 8),
(251893, NULL, 'PTHR14732', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 27768, 8),
(251894, NULL, 'PTHR34382', NULL, NULL, NULL, NULL, 'PTS SYSTEM N,N''-DIACETYLCHITOBIOSE-SPECIFIC EIIA COMPONENT', NULL, NULL, 3212, 8),
(251895, NULL, 'PTHR28062', NULL, NULL, NULL, NULL, 'K+-H+ EXCHANGE-LIKE PROTEIN', NULL, NULL, 19278, 8),
(251896, NULL, 'PTHR11309', NULL, NULL, NULL, NULL, 'FRIZZLED', NULL, NULL, 8420, 8),
(251897, NULL, 'PTHR24419', NULL, NULL, NULL, NULL, 'INTERLEUKIN-1 RECEPTOR-ASSOCIATED KINASE', NULL, NULL, NULL, 8),
(251898, NULL, 'PTHR35404', NULL, NULL, NULL, NULL, 'TRANSPOSASE OF TN10', NULL, NULL, NULL, 8),
(251899, NULL, 'PTHR45834', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 9-RELATED', NULL, NULL, NULL, 8),
(251900, NULL, 'PTHR31026', NULL, NULL, NULL, NULL, 'ENHANCER OF UNCOORDINATION', NULL, NULL, NULL, 8),
(251901, NULL, 'PTHR43463', NULL, NULL, NULL, NULL, 'NICOTINATE-NUCLEOTIDE--DIMETHYLBENZIMIDAZOLE PHOSPHORIBOSYLTRANSFERASE', NULL, NULL, NULL, 8),
(251902, NULL, 'PTHR21695', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 27351, 8),
(251903, NULL, 'PTHR43281', NULL, NULL, NULL, NULL, 'FARNESYL DIPHOSPHATE SYNTHASE', NULL, NULL, NULL, 8),
(251904, NULL, 'PTHR33048', NULL, NULL, NULL, NULL, 'PTH11-LIKE INTEGRAL MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_5G11245)', NULL, NULL, NULL, 8),
(251905, NULL, 'PTHR46639', NULL, NULL, NULL, NULL, 'DIENCEPHALON/MESENCEPHALON HOMEOBOX PROTEIN 1', NULL, NULL, NULL, 8),
(251906, NULL, 'PTHR21523', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(251907, NULL, 'PTHR22142', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 13323, 8),
(251908, NULL, 'PTHR14969', NULL, NULL, NULL, NULL, 'SPHINGOSINE-1-PHOSPHATE PHOSPHOHYDROLASE', NULL, NULL, NULL, 8),
(251909, NULL, 'PTHR31062', NULL, NULL, NULL, NULL, 'XYLOGLUCAN ENDOTRANSGLUCOSYLASE/HYDROLASE PROTEIN 8-RELATED', NULL, NULL, 34662, 8),
(251910, NULL, 'PTHR16108', NULL, NULL, NULL, NULL, '', NULL, NULL, 21473, 8),
(251911, NULL, 'PTHR23301', NULL, NULL, NULL, NULL, 'CHITIN BINDING PERITROPHIN-A', NULL, NULL, NULL, 8),
(251912, NULL, 'PTHR46966', NULL, NULL, NULL, NULL, 'HOMEOBOX EXPRESSED IN ES CELLS 1', NULL, NULL, 35231, 8),
(251913, NULL, 'PTHR35191', NULL, NULL, NULL, NULL, 'PROPHAGE SIDE TAIL FIBER PROTEIN HOMOLOG STFQ-RELATED', NULL, NULL, NULL, 8),
(251914, NULL, 'PTHR13453', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 25547, 8),
(251915, NULL, 'PTHR13609', NULL, NULL, NULL, NULL, 'UBIQUITIN DOMAIN CONTAINING 1 PROTEIN-RELATED', NULL, NULL, 32102, 8),
(251916, NULL, 'PTHR15729', NULL, NULL, NULL, NULL, 'CDC42 GTPASE-ACTIVATING PROTEIN', NULL, NULL, NULL, 8),
(251917, NULL, 'PTHR39599', NULL, NULL, NULL, NULL, 'GPI-ANCHORED PROTEIN (EUROFUNG)-RELATED-RELATED', NULL, NULL, NULL, 8),
(251918, NULL, 'PTHR35133', NULL, NULL, NULL, NULL, 'PROTEIN EFFECTOR OF TRANSCRIPTION 2-RELATED', NULL, NULL, 31834, 8),
(251919, NULL, 'PTHR14449', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA GROUP F PROTEIN FANCF', NULL, NULL, 19193, 8),
(251920, NULL, 'PTHR28680', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN X', NULL, NULL, 15276, 8),
(251921, NULL, 'PTHR13715', NULL, NULL, NULL, NULL, 'RYANODINE RECEPTOR AND IP3 RECEPTOR', NULL, NULL, NULL, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(251922, NULL, 'PTHR38495', NULL, NULL, NULL, NULL, 'MCG11474', NULL, NULL, NULL, 8),
(251923, NULL, 'PTHR36852', NULL, NULL, NULL, NULL, '', NULL, NULL, 8150, 8),
(251924, NULL, 'PTHR13812', NULL, NULL, NULL, NULL, 'KETIMINE REDUCTASE MU-CRYSTALLIN', NULL, NULL, 5153, 8),
(251925, NULL, 'PTHR37749', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(251926, NULL, 'PTHR43439', NULL, NULL, NULL, NULL, 'PHENYLACETATE-COENZYME A LIGASE', NULL, NULL, NULL, 8),
(251927, NULL, 'PTHR47634', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(251928, NULL, 'PTHR21060', NULL, NULL, NULL, NULL, 'ACETATE KINASE', NULL, NULL, 5, 8),
(251929, NULL, 'PTHR15351', NULL, NULL, NULL, NULL, 'ERLIN (ER LIPID RAFT ASSOCIATED PROTEIN) HOMOLOG', NULL, NULL, 28135, 8),
(251930, NULL, 'PTHR11349', NULL, NULL, NULL, NULL, 'NUCLEOSIDE DIPHOSPHATE KINASE', NULL, NULL, NULL, 8),
(251931, NULL, 'PTHR39321', NULL, NULL, NULL, NULL, 'NICOTINATE-NUCLEOTIDE ADENYLYLTRANSFERASE-RELATED', NULL, NULL, NULL, 8),
(251932, NULL, 'PTHR35258', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 22', NULL, NULL, 33304, 8),
(251933, NULL, 'PTHR46538', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(251934, NULL, 'PTHR16093', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 120 FAMILY MEMBER', NULL, NULL, 34508, 8),
(251935, NULL, 'PTHR36788', NULL, NULL, NULL, NULL, 'DEFENSIN-LIKE PROTEIN 183', NULL, NULL, 27118, 8),
(251936, NULL, 'PTHR12053', NULL, NULL, NULL, NULL, 'PROTEASE FAMILY M28 PLASMA GLUTAMATE CARBOXYPEPTIDASE-RELATED', NULL, NULL, 31175, 8),
(251937, NULL, 'PTHR46817', NULL, NULL, NULL, NULL, 'PHOSPHOINOSITIDE PHOSPHATASE SAC9-RELATED', NULL, NULL, NULL, 8),
(251938, NULL, 'PTHR46072', NULL, NULL, NULL, NULL, 'AMIDASE-RELATED-RELATED', NULL, NULL, NULL, 8),
(251939, NULL, 'PTHR13027', NULL, NULL, NULL, NULL, 'SAND PROTEIN-RELATED', NULL, NULL, 5083, 8),
(251940, NULL, 'PTHR31809', NULL, NULL, NULL, NULL, 'BUD13 HOMOLOG', NULL, NULL, NULL, 8),
(251941, NULL, 'PTHR37867', NULL, NULL, NULL, NULL, 'CHROMOSOME 16 OPEN READING FRAME 86', NULL, NULL, 26519, 8),
(251942, NULL, 'PTHR42953', NULL, NULL, NULL, NULL, 'HIGH-AFFINITY ZINC UPTAKE SYSTEM PROTEIN ZNUA-RELATED', NULL, NULL, NULL, 8),
(251943, NULL, 'PTHR24376', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', NULL, NULL, NULL, 8),
(251944, NULL, 'PTHR31855', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE EXCHANGE C9ORF72', NULL, NULL, 22343, 8),
(251945, NULL, 'PTHR28055', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN 41, MITOCHONDRIAL', NULL, NULL, 15650, 8),
(251946, NULL, 'PTHR35263', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 49', NULL, NULL, 30087, 8),
(251947, NULL, 'PTHR12821', NULL, NULL, NULL, NULL, 'BYSTIN', NULL, NULL, 4202, 8),
(251948, NULL, 'PTHR46448', NULL, NULL, NULL, NULL, 'PROTEIN KINASE DOMAIN-CONTAINING PROTEIN', NULL, NULL, 34808, 8),
(251949, NULL, 'PTHR31624', NULL, NULL, NULL, NULL, 'UPF0472 PROTEIN C16ORF72', NULL, NULL, 31047, 8),
(251950, NULL, 'PTHR39399', NULL, NULL, NULL, NULL, 'PROTEIN ZPS1', NULL, NULL, 28485, 8),
(251951, NULL, 'PTHR47105', NULL, NULL, NULL, NULL, 'OS02G0173600 PROTEIN', NULL, NULL, NULL, 8),
(251952, NULL, 'PTHR34675', NULL, NULL, NULL, NULL, 'PROTEIN TRIGALACTOSYLDIACYLGLYCEROL 2, CHLOROPLASTIC', NULL, NULL, 30849, 8),
(251953, NULL, 'PTHR13282', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 9862, 8),
(251954, NULL, 'PTHR13228', NULL, NULL, NULL, NULL, 'CONSERVED OLIGOMERIC GOLGI COMPLEX COMPONENT 5', NULL, NULL, 17123, 8),
(251955, NULL, 'PTHR16485', NULL, NULL, NULL, NULL, 'MICROFIBRILLAR-ASSOCIATED PROTEIN 2', NULL, NULL, 12845, 8),
(251956, NULL, 'PTHR13886', NULL, NULL, NULL, NULL, 'JNK/SAPK-ASSOCIATED PROTEIN', NULL, NULL, 27272, 8),
(251957, NULL, 'PTHR12663', NULL, NULL, NULL, NULL, 'ANDROGEN INDUCED INHIBITOR OF PROLIFERATION  AS3  / PDS5-RELATED', NULL, NULL, 33192, 8),
(251958, NULL, 'PTHR19321', NULL, NULL, NULL, NULL, 'PROTEIN REGULATOR OF CYTOKINESIS 1 PRC1-RELATED', NULL, NULL, 252, 8);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(251959, NULL, 'PTHR36742', NULL, NULL, NULL, NULL, 'MYOSIN-G HEAVY CHAIN-LIKE PROTEIN', NULL, NULL, NULL, 8),
(251960, NULL, 'PTHR46378', NULL, NULL, NULL, NULL, 'STEROL REGULATORY ELEMENT-BINDING PROTEIN CLEAVAGE-ACTIVATING PROTEIN', NULL, NULL, 23888, 8),
(251961, NULL, 'PTHR22012', NULL, NULL, NULL, NULL, 'FIBROUS SHEATH INTERACTING PROTEIN 1', NULL, NULL, 21225, 8),
(251962, NULL, 'PTHR35971', NULL, NULL, NULL, NULL, 'SI:DKEY-31G6.6', NULL, NULL, NULL, 8),
(251963, NULL, 'PTHR38537', NULL, NULL, NULL, NULL, 'JITTERBUG, ISOFORM N', NULL, NULL, 34302, 8),
(251964, NULL, 'PTHR10424', NULL, NULL, NULL, NULL, 'VIRAL ENVELOPE PROTEIN', NULL, NULL, 13941, 8),
(251965, NULL, 'PTHR40060', NULL, NULL, NULL, NULL, 'UPF0316 PROTEIN YEBE', NULL, NULL, 14542, 8),
(251966, NULL, 'PTHR36725', NULL, NULL, NULL, NULL, 'SENESCENCE-ASSOCIATED PROTEIN AAF, CHLOROLPLASTIC', NULL, NULL, 35566, 8),
(251967, NULL, 'PTHR44420', NULL, NULL, NULL, NULL, 'GLUTATHIONE S-TRANSFERASE DHAR2-RELATED', NULL, NULL, 36256, 8),
(251968, NULL, 'PTHR23347', NULL, NULL, NULL, NULL, 'COLORECTAL MUTANT CANCER PROTEIN  MCC PROTEIN -RELATED', NULL, NULL, 31563, 8),
(251969, NULL, 'PTHR31459', NULL, NULL, NULL, NULL, '', NULL, NULL, 35534, 8),
(251970, NULL, 'PTHR22571', NULL, NULL, NULL, NULL, 'FILAGGRIN-RELATED', NULL, NULL, NULL, 8),
(251971, NULL, 'PTHR33463', NULL, NULL, NULL, NULL, 'NB-ARC DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(251972, NULL, 'PTHR47560', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(251973, NULL, 'PTHR37398', NULL, NULL, NULL, NULL, 'ENDO-BETA-1,4-MANNANASE', NULL, NULL, NULL, 8),
(251974, NULL, 'PTHR19332', NULL, NULL, NULL, NULL, 'PEROXISOMAL MEMBRANE PROTEIN PEX13', NULL, NULL, 14819, 8),
(251975, NULL, 'PTHR37959', NULL, NULL, NULL, NULL, 'PROTEIN CBG15758', NULL, NULL, NULL, 8),
(251976, NULL, 'PTHR47007', NULL, NULL, NULL, NULL, 'SUSHI DOMAIN-CONTAINING PROTEIN 4', NULL, NULL, 34563, 8),
(251977, NULL, 'PTHR13520', NULL, NULL, NULL, NULL, 'RAD50-INTERACTING PROTEIN 1 RINT-1', NULL, NULL, 10514, 8),
(251978, NULL, 'PTHR47953', NULL, NULL, NULL, NULL, 'OS08G0105600 PROTEIN', NULL, NULL, NULL, 8),
(251979, NULL, 'PTHR33187', NULL, NULL, NULL, NULL, 'WU:FI09B08', NULL, NULL, NULL, 8),
(251980, NULL, 'PTHR47270', NULL, NULL, NULL, NULL, 'PROTEIN MLP1-LIKE', NULL, NULL, NULL, 8),
(251981, NULL, 'PTHR46743', NULL, NULL, NULL, NULL, 'TEICHOIC ACIDS EXPORT ATP-BINDING PROTEIN TAGH', NULL, NULL, NULL, 8),
(251982, NULL, 'PTHR11680', NULL, NULL, NULL, NULL, 'SERINE HYDROXYMETHYLTRANSFERASE', NULL, NULL, 2430, 8),
(251983, NULL, 'PTHR45928', NULL, NULL, NULL, NULL, 'RE38146P', NULL, NULL, NULL, 8),
(251984, NULL, 'PTHR43327', NULL, NULL, NULL, NULL, 'STOMATIN-LIKE PROTEIN 2, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(251985, NULL, 'PTHR18359', NULL, NULL, NULL, NULL, 'WD-REPEAT PROTEIN-RELATED', NULL, NULL, 36634, 8),
(251986, NULL, 'PTHR35994', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, 35303, 8),
(251987, NULL, 'PTHR10395', NULL, NULL, NULL, NULL, 'URICASE AND TRANSTHYRETIN-RELATED', NULL, NULL, 16259, 8),
(251988, NULL, 'PTHR16038', NULL, NULL, NULL, NULL, 'NOP SEVEN ASSOCIATED PROTEIN 1', NULL, NULL, 29375, 8),
(251989, NULL, 'PTHR42884', NULL, NULL, NULL, NULL, 'PROPROTEIN CONVERTASE SUBTILISIN/KEXIN-RELATED', NULL, NULL, NULL, 8),
(251990, NULL, 'PTHR31904', NULL, NULL, NULL, NULL, 'BYPASS OF STOP CODON PROTEIN 5-RELATED', NULL, NULL, 27209, 8),
(251991, NULL, 'PTHR38013', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN/POLYSACCHARIDE METABOLISM', NULL, NULL, NULL, 8),
(251992, NULL, 'PTHR19877', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT I', NULL, NULL, NULL, 8),
(251993, NULL, 'PTHR21749', NULL, NULL, NULL, NULL, 'PRION-LIKE- Q/N-RICH -DOMAIN-BEARING PROTEIN PROTEIN 24', NULL, NULL, NULL, 8),
(251994, NULL, 'PTHR47612', NULL, NULL, NULL, NULL, 'TRICHOHYALIN-LIKE PROTEIN 1', NULL, NULL, 36274, 8),
(251995, NULL, 'PTHR31156', NULL, NULL, NULL, NULL, 'WBSCR19-LIKE PROTEIN', NULL, NULL, 14794, 8),
(251996, NULL, 'PTHR21340', NULL, NULL, NULL, NULL, 'DIADENOSINE 5,5-P1,P4-TETRAPHOSPHATE PYROPHOSPHOHYDROLASE MUTT', NULL, NULL, NULL, 8);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(251997, NULL, 'PTHR38167', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(251998, NULL, 'PTHR34182', NULL, NULL, NULL, NULL, 'PROTEIN-EXPORT MEMBRANE PROTEIN SECG', NULL, NULL, 3030, 8),
(251999, NULL, 'PTHR42204', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(252000, NULL, 'PTHR48205', NULL, NULL, NULL, NULL, 'OS01G0742766 PROTEIN', NULL, NULL, NULL, 8),
(252001, NULL, 'PTHR46306', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN-CONTAINING PROTEIN 9', NULL, NULL, NULL, 8),
(252002, NULL, 'PTHR12822', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 33417, 8),
(252003, NULL, 'PTHR36449', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE-RELATED', NULL, NULL, NULL, 8),
(252004, NULL, 'PTHR45934', NULL, NULL, NULL, NULL, 'FAD/NAD(P)-BINDING OXIDOREDUCTASE FAMILY PROTEIN', NULL, NULL, 36030, 8),
(252005, NULL, 'PTHR45840', NULL, NULL, NULL, NULL, 'RHOMBOID-RELATED PROTEIN', NULL, NULL, NULL, 8),
(252006, NULL, 'PTHR34686', NULL, NULL, NULL, NULL, 'MATERNAL EFFECT EMBRYO ARREST PROTEIN', NULL, NULL, NULL, 8),
(252007, NULL, 'PTHR31305', NULL, NULL, NULL, NULL, 'SNARE-ASSOCIATED PROTEIN SNAPIN', NULL, NULL, 15783, 8),
(252008, NULL, 'PTHR40734', NULL, NULL, NULL, NULL, 'TRNA-SPECIFIC ADENOSINE DEAMINASE-RELATED', NULL, NULL, 6307, 8),
(252009, NULL, 'PTHR34202', NULL, NULL, NULL, NULL, 'UPF0548 PROTEIN', NULL, NULL, NULL, 8),
(252010, NULL, 'PTHR37441', NULL, NULL, NULL, NULL, 'PROTEIN CBG16518', NULL, NULL, 28659, 8),
(252011, NULL, 'PTHR40468', NULL, NULL, NULL, NULL, 'YALI0A15257P', NULL, NULL, NULL, 8),
(252012, NULL, 'PTHR23179', NULL, NULL, NULL, NULL, 'T-CELL ACTIVATION RHO GTPASE ACTIVATING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(252013, NULL, 'PTHR31121', NULL, NULL, NULL, NULL, 'ALPHA-1,2 MANNOSYLTRANSFERASE KTR1', NULL, NULL, 2725, 8),
(252014, NULL, 'PTHR44167', NULL, NULL, NULL, NULL, 'OVARIAN-SPECIFIC SERINE/THREONINE-PROTEIN KINASE LOK-RELATED', NULL, NULL, NULL, 8),
(252015, NULL, 'PTHR31719', NULL, NULL, NULL, NULL, 'NAC TRANSCRIPTION FACTOR 56', NULL, NULL, NULL, 8),
(252016, NULL, 'PTHR12635', NULL, NULL, NULL, NULL, 'RHO-GTPASE-ACTIVATING PROTEIN 6 FAMILY MEMBER', NULL, NULL, 27035, 8),
(252017, NULL, 'PTHR16148', NULL, NULL, NULL, NULL, 'NF-KAPPA-B-REPRESSING FACTOR-RELATED', NULL, NULL, NULL, 8),
(252018, NULL, 'PTHR34369', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II 10 KDA POLYPEPTIDE, CHLOROPLASTIC', NULL, NULL, 3900, 8),
(252019, NULL, 'PTHR13281', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 12274, 8),
(252020, NULL, 'PTHR42682', NULL, NULL, NULL, NULL, 'HYDROGENASE-4 COMPONENT F', NULL, NULL, NULL, 8),
(252021, NULL, 'PTHR36313', NULL, NULL, NULL, NULL, 'ROOT MERISTEM GROWTH FACTOR 2', NULL, NULL, 32384, 8),
(252022, NULL, 'PTHR11731', NULL, NULL, NULL, NULL, 'PROTEASE FAMILY S9B,C DIPEPTIDYL-PEPTIDASE IV-RELATED', NULL, NULL, NULL, 8),
(252023, NULL, 'PTHR13267', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 277', NULL, NULL, 27455, 8),
(252024, NULL, 'PTHR14898', NULL, NULL, NULL, NULL, 'ENHANCER OF POLYCOMB', NULL, NULL, 26202, 8),
(252025, NULL, 'PTHR22768', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 10392, 8),
(252026, NULL, 'PTHR30368', NULL, NULL, NULL, NULL, 'SULFATE-BINDING PROTEIN', NULL, NULL, 3688, 8),
(252027, NULL, 'PTHR12336', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 26136, 8),
(252028, NULL, 'PTHR47826', NULL, NULL, NULL, NULL, 'OS03G0164700 PROTEIN', NULL, NULL, NULL, 8),
(252029, NULL, 'PTHR43498', NULL, NULL, NULL, NULL, 'FERREDOXIN:COB-COM HETERODISULFIDE REDUCTASE SUBUNIT A', NULL, NULL, 27365, 8),
(252030, NULL, 'PTHR42282', NULL, NULL, NULL, NULL, 'PANTOATE KINASE-RELATED', NULL, NULL, 11094, 8),
(252031, NULL, 'PTHR36061', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252032, NULL, 'PTHR19857', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL DIVISION PROTEIN 1-RELATED', NULL, NULL, NULL, 8),
(252033, NULL, 'PTHR24286', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 26', NULL, NULL, NULL, 8),
(252034, NULL, 'PTHR48196', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252035, NULL, 'PTHR36929', NULL, NULL, NULL, NULL, 'ATTACHMENT SUBUNIT, PUTATIVE-RELATED', NULL, NULL, NULL, 8);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(252036, NULL, 'PTHR37468', NULL, NULL, NULL, NULL, 'SULFATE TRANSPORTER CYSZ', NULL, NULL, NULL, 8),
(252037, NULL, 'PTHR24343', NULL, NULL, NULL, NULL, 'SERINE/THREONINE KINASE', NULL, NULL, NULL, 8),
(252038, NULL, 'PTHR35317', NULL, NULL, NULL, NULL, 'OS04G0629600 PROTEIN', NULL, NULL, NULL, 8),
(252039, NULL, 'PTHR20961', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', NULL, NULL, 139, 8),
(252040, NULL, 'PTHR45726', NULL, NULL, NULL, NULL, 'LEUKOTRIENE A-4 HYDROLASE', NULL, NULL, 23808, 8),
(252041, NULL, 'PTHR15114', NULL, NULL, NULL, NULL, 'REPLICATION PROTEIN A3', NULL, NULL, NULL, 8),
(252042, NULL, 'PTHR46101', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252043, NULL, 'PTHR46195', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 7', NULL, NULL, 35167, 8),
(252044, NULL, 'PTHR45883', NULL, NULL, NULL, NULL, 'HSC70-INTERACTING PROTEIN', NULL, NULL, NULL, 8),
(252045, NULL, 'PTHR21281', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(252046, NULL, 'PTHR40036', NULL, NULL, NULL, NULL, 'MACROCIN O-METHYLTRANSFERASE', NULL, NULL, 7863, 8),
(252047, NULL, 'PTHR45530', NULL, NULL, NULL, NULL, 'SENSORY TRANSDUCTION HISTIDINE KINASE', NULL, NULL, NULL, 8),
(252048, NULL, 'PTHR28602', NULL, NULL, NULL, NULL, 'ENDOTHELIAL CELL-SPECIFIC CHEMOTAXIS REGULATOR', NULL, NULL, 24704, 8),
(252049, NULL, 'PTHR47676', NULL, NULL, NULL, NULL, 'OS01G0225100 PROTEIN', NULL, NULL, NULL, 8),
(252050, NULL, 'PTHR43299', NULL, NULL, NULL, NULL, 'UPF0718 PROTEIN YRAQ', NULL, NULL, NULL, 8),
(252051, NULL, 'PTHR12989', NULL, NULL, NULL, NULL, 'ALPHA-1,2-GLUCOSYLTRANSFERASE ALG10', NULL, NULL, 17355, 8),
(252052, NULL, 'PTHR19372', NULL, NULL, NULL, NULL, 'SULFITE REDUCTASE', NULL, NULL, NULL, 8),
(252053, NULL, 'PTHR45740', NULL, NULL, NULL, NULL, 'POLY [ADP-RIBOSE] POLYMERASE', NULL, NULL, NULL, 8),
(252054, NULL, 'PTHR22968', NULL, NULL, NULL, NULL, 'PROTEIN KINASE C, MU', NULL, NULL, 11489, 8),
(252055, NULL, 'PTHR38828', NULL, NULL, NULL, NULL, '', NULL, NULL, 27178, 8),
(252056, NULL, 'PTHR43708', NULL, NULL, NULL, NULL, 'CONSERVED EXPRESSED OXIDOREDUCTASE (EUROFUNG)', NULL, NULL, NULL, 8),
(252057, NULL, 'PTHR24232', NULL, NULL, NULL, NULL, 'G-PROTEIN COUPLED RECEPTOR', NULL, NULL, NULL, 8),
(252058, NULL, 'PTHR12866', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE-CONJUGATING ENZYME ATG3', NULL, NULL, 93, 8),
(252059, NULL, 'PTHR34610', NULL, NULL, NULL, NULL, 'SSL7007 PROTEIN', NULL, NULL, 5568, 8),
(252060, NULL, 'PTHR37908', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(252061, NULL, 'PTHR16317', NULL, NULL, NULL, NULL, 'INTEGRIN ALPHA REPEAT DOMAIN-CONTAINING', NULL, NULL, 24210, 8),
(252062, NULL, 'PTHR47713', NULL, NULL, NULL, NULL, 'HOMEODOMAIN-LIKE SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(252063, NULL, 'PTHR34107', NULL, NULL, NULL, NULL, 'SLL0198 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(252064, NULL, 'PTHR35400', NULL, NULL, NULL, NULL, 'SLR1083 PROTEIN', NULL, NULL, NULL, 8),
(252065, NULL, 'PTHR45767', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN O', NULL, NULL, NULL, 8),
(252066, NULL, 'PTHR30371', NULL, NULL, NULL, NULL, 'SEC-INDEPENDENT PROTEIN TRANSLOCASE PROTEIN TATC', NULL, NULL, 5257, 8),
(252067, NULL, 'PTHR47165', NULL, NULL, NULL, NULL, 'OS03G0429900 PROTEIN', NULL, NULL, NULL, 8),
(252068, NULL, 'PTHR22748', NULL, NULL, NULL, NULL, 'AP ENDONUCLEASE', NULL, NULL, 4158, 8),
(252069, NULL, 'PTHR28552', NULL, NULL, NULL, NULL, 'SHADOW OF PRION PROTEIN', NULL, NULL, 21796, 8),
(252070, NULL, 'PTHR45882', NULL, NULL, NULL, NULL, 'PITUITARY HOMEOBOX HOMOLOG PTX1', NULL, NULL, NULL, 8),
(252071, NULL, 'PTHR46613', NULL, NULL, NULL, NULL, 'RADIAL SPOKE HEAD 10 HOMOLOG B-RELATED', NULL, NULL, NULL, 8),
(252072, NULL, 'PTHR47474', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE RLPH2', NULL, NULL, NULL, 8),
(252073, NULL, 'PTHR11384', NULL, NULL, NULL, NULL, 'ATP-BINDING CASSETTE, SUB-FAMILY D MEMBER', NULL, NULL, NULL, 8),
(252074, NULL, 'PTHR22741', NULL, NULL, NULL, NULL, 'P140CAP/SNIP-RELATED', NULL, NULL, NULL, 8);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(252075, NULL, 'PTHR33920', NULL, NULL, NULL, NULL, 'THIONIN-2.1-RELATED', NULL, NULL, 2130, 8),
(252076, NULL, 'PTHR46824', NULL, NULL, NULL, NULL, 'CALCIUM-BINDING PROTEIN CML48-RELATED', NULL, NULL, 34718, 8),
(252077, NULL, 'PTHR28219', NULL, NULL, NULL, NULL, 'UPF0642 PROTEIN YBL028C', NULL, NULL, NULL, 8),
(252078, NULL, 'PTHR38591', NULL, NULL, NULL, NULL, 'HYDROLASE', NULL, NULL, NULL, 8),
(252079, NULL, 'PTHR31623', NULL, NULL, NULL, NULL, 'F21J9.9', NULL, NULL, NULL, 8),
(252080, NULL, 'PTHR31136', NULL, NULL, NULL, NULL, 'DUF1338 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(252081, NULL, 'PTHR11818', NULL, NULL, NULL, NULL, 'BETA/GAMMA CRYSTALLIN', NULL, NULL, NULL, 8),
(252082, NULL, 'PTHR30504', NULL, NULL, NULL, NULL, 'GLUCANS BIOSYNTHESIS PROTEIN', NULL, NULL, 7751, 8),
(252083, NULL, 'PTHR19336', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED DUF1167', NULL, NULL, NULL, 8),
(252084, NULL, 'PTHR24049', NULL, NULL, NULL, NULL, 'CRUMBS FAMILY MEMBER', NULL, NULL, NULL, 8),
(252085, NULL, 'PTHR43918', NULL, NULL, NULL, NULL, 'ACETYLCHOLINESTERASE', NULL, NULL, NULL, 8),
(252086, NULL, 'PTHR28549', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN INTEGRAL MEMBRANE PROTEIN 1', NULL, NULL, 35203, 8),
(252087, NULL, 'PTHR42961', NULL, NULL, NULL, NULL, 'IRON-SULFUR PROTEIN NUBPL', NULL, NULL, 35248, 8),
(252088, NULL, 'PTHR12309', NULL, NULL, NULL, NULL, 'SEC61 GAMMA SUBUNIT', NULL, NULL, NULL, 8),
(252089, NULL, 'PTHR13376', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 20616, 8),
(252090, NULL, 'PTHR10619', NULL, NULL, NULL, NULL, 'F-ACTIN-CAPPING PROTEIN SUBUNIT BETA', NULL, NULL, 3177, 8),
(252091, NULL, 'PTHR30121', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEIN YJGR-RELATED', NULL, NULL, NULL, 8),
(252092, NULL, 'PTHR39085', NULL, NULL, NULL, NULL, 'SLL0924 PROTEIN', NULL, NULL, 19527, 8),
(252093, NULL, 'PTHR47026', NULL, NULL, NULL, NULL, 'PIGMENTOSA GTPASE REGULATOR-LIKE PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(252094, NULL, 'PTHR37404', NULL, NULL, NULL, NULL, 'HCG1796489', NULL, NULL, NULL, 8),
(252095, NULL, 'PTHR42208', NULL, NULL, NULL, NULL, 'HEAVY METAL TRANSPORTER-RELATED', NULL, NULL, NULL, 8),
(252096, NULL, 'PTHR13987', NULL, NULL, NULL, NULL, 'PROTEIN BEX4', NULL, NULL, 2603, 8),
(252097, NULL, 'PTHR37157', NULL, NULL, NULL, NULL, 'PRION-LIKE-(Q/N-RICH) DOMAIN-BEARING PROTEIN 25', NULL, NULL, NULL, 8),
(252098, NULL, 'PTHR45997', NULL, NULL, NULL, NULL, 'DNA LIGASE 4', NULL, NULL, 24393, 8),
(252099, NULL, 'PTHR31721', NULL, NULL, NULL, NULL, 'OS06G0710300 PROTEIN', NULL, NULL, NULL, 8),
(252100, NULL, 'PTHR24204', NULL, NULL, NULL, NULL, 'INSULIN GENE ENHANCER PROTEIN', NULL, NULL, NULL, 8),
(252101, NULL, 'PTHR33935', NULL, NULL, NULL, NULL, 'OS10G0148100 PROTEIN', NULL, NULL, NULL, 8),
(252102, NULL, 'PTHR14627', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 204', NULL, NULL, 30817, 8),
(252103, NULL, 'PTHR42088', NULL, NULL, NULL, NULL, 'YALI0F10131P', NULL, NULL, NULL, 8),
(252104, NULL, 'PTHR48214', NULL, NULL, NULL, NULL, 'ZEIN-ALPHA PMS2', NULL, NULL, NULL, 8),
(252105, NULL, 'PTHR36106', NULL, NULL, NULL, NULL, 'ANAEROBIC C4-DICARBOXYLATE TRANSPORTER DCUB', NULL, NULL, 2820, 8),
(252106, NULL, 'PTHR38149', NULL, NULL, NULL, NULL, '', NULL, NULL, 18220, 8),
(252107, NULL, 'PTHR32438', NULL, NULL, NULL, NULL, '4-ALPHA-GLUCANOTRANSFERASE DPE1, CHLOROPLASTIC/AMYLOPLASTIC', NULL, NULL, 4483, 8),
(252108, NULL, 'PTHR47570', NULL, NULL, NULL, NULL, 'ZINC ION BINDING PROTEIN', NULL, NULL, NULL, 8),
(252109, NULL, 'PTHR23526', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE TRANSPORT PROTEIN-RELATED', NULL, NULL, NULL, 8),
(252110, NULL, 'PTHR31746', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 229 FAMILY MEMBER', NULL, NULL, NULL, 8),
(252111, NULL, 'PTHR36149', NULL, NULL, NULL, NULL, 'HEAVY CHAIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(252112, NULL, 'PTHR35395', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252113, NULL, 'PTHR39608', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN (AFU_ORTHOLOGUE AFUA_5G08640)', NULL, NULL, NULL, 8);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(252114, NULL, 'PTHR33193', NULL, NULL, NULL, NULL, 'DOMAIN PROTEIN, PUTATIVE (DUF3511)-RELATED', NULL, NULL, NULL, 8),
(252115, NULL, 'PTHR11876', NULL, NULL, NULL, NULL, 'ALPHA-DEFENSIN 1', NULL, NULL, 20447, 8),
(252116, NULL, 'PTHR30455', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR NRDR', NULL, NULL, 3117, 8),
(252117, NULL, 'PTHR32176', NULL, NULL, NULL, NULL, 'XYLOSE ISOMERASE', NULL, NULL, NULL, 8),
(252118, NULL, 'PTHR48182', NULL, NULL, NULL, NULL, 'PROTEIN SERAC1', NULL, NULL, NULL, 8),
(252119, NULL, 'PTHR45981', NULL, NULL, NULL, NULL, 'LD02310P', NULL, NULL, NULL, 8),
(252120, NULL, 'PTHR13014', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 28S RIBOSOMAL PROTEIN S30/P52 PRO-APOTOTIC PROTEIN', NULL, NULL, 28652, 8),
(252121, NULL, 'PTHR42874', NULL, NULL, NULL, NULL, 'URICASE', NULL, NULL, 1405, 8),
(252122, NULL, 'PTHR15397', NULL, NULL, NULL, NULL, 'SODIUM-GLUCOSE COTRANSPORTER REGULATORY PROTEIN -RELATED', NULL, NULL, 32760, 8),
(252123, NULL, 'PTHR48243', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252124, NULL, 'PTHR36181', NULL, NULL, NULL, NULL, 'INTRON-ENCODED ENDONUCLEASE AI3-RELATED', NULL, NULL, NULL, 8),
(252125, NULL, 'PTHR37255', NULL, NULL, NULL, NULL, 'OS07G0669600 PROTEIN', NULL, NULL, NULL, 8),
(252126, NULL, 'PTHR38445', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REPRESSOR YTRA', NULL, NULL, NULL, 8),
(252127, NULL, 'PTHR48202', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(252128, NULL, 'PTHR47251', NULL, NULL, NULL, NULL, 'FINGER DOMAIN PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G04180)-RELATED', NULL, NULL, NULL, 8),
(252129, NULL, 'PTHR33971', NULL, NULL, NULL, NULL, 'OS06G0232000 PROTEIN', NULL, NULL, 31659, 8),
(252130, NULL, 'PTHR12682', NULL, NULL, NULL, NULL, 'ARCHEASE', NULL, NULL, 4639, 8),
(252131, NULL, 'PTHR43812', NULL, NULL, NULL, NULL, 'BLR2425 PROTEIN', NULL, NULL, NULL, 8),
(252132, NULL, 'PTHR43881', NULL, NULL, NULL, NULL, 'GAMMA-GLUTAMYLTRANSPEPTIDASE (AFU_ORTHOLOGUE AFUA_4G13580)', NULL, NULL, NULL, 8),
(252133, NULL, 'PTHR14482', NULL, NULL, NULL, NULL, 'CHROMOSOME 12 ORF 43 HOMOLOG', NULL, NULL, 25472, 8),
(252134, NULL, 'PTHR34404', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN, FMDB FAMILY', NULL, NULL, NULL, 8),
(252135, NULL, 'PTHR12223', NULL, NULL, NULL, NULL, 'VESICULAR MANNOSE-BINDING LECTIN', NULL, NULL, NULL, 8),
(252136, NULL, 'PTHR48016', NULL, NULL, NULL, NULL, 'MAP KINASE KINASE KINASE SSK2-RELATED-RELATED', NULL, NULL, NULL, 8),
(252137, NULL, 'PTHR48122', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN H', NULL, NULL, 31410, 8),
(252138, NULL, 'PTHR39426', NULL, NULL, NULL, NULL, 'HOMOLOGY TO DEATH-ON-CURING PROTEIN OF PHAGE P1', NULL, NULL, 6646, 8),
(252139, NULL, 'PTHR42996', NULL, NULL, NULL, NULL, 'PHOSPHATE-BINDING PROTEIN PSTS', NULL, NULL, NULL, 8),
(252140, NULL, 'PTHR35147', NULL, NULL, NULL, NULL, 'CHEMORECEPTOR GLUTAMINE DEAMIDASE CHED-RELATED', NULL, NULL, 3505, 8),
(252141, NULL, 'PTHR45615', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN, NON-MUSCLE', NULL, NULL, NULL, 8),
(252142, NULL, 'PTHR32522', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252143, NULL, 'PTHR42028', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(252144, NULL, 'PTHR13968', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN', NULL, NULL, NULL, 8),
(252145, NULL, 'PTHR11804', NULL, NULL, NULL, NULL, 'PROTEASE M3 THIMET OLIGOPEPTIDASE-RELATED', NULL, NULL, 34308, 8),
(252146, NULL, 'PTHR47249', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN 8', NULL, NULL, 36663, 8),
(252147, NULL, 'PTHR34465', NULL, NULL, NULL, NULL, 'CARBOXYL-TERMINAL HYDROLASE-LIKE PROTEIN, PUTATIVE (DUF627 AND DUF629)-RELATED', NULL, NULL, NULL, 8),
(252148, NULL, 'PTHR31234', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT (LEA) HYDROXYPROLINE-RICH GLYCOPROTEIN FAMILY', NULL, NULL, NULL, 8),
(252149, NULL, 'PTHR28293', NULL, NULL, NULL, NULL, 'NUCLEAR RIM PROTEIN 1', NULL, NULL, 19882, 8),
(252150, NULL, 'PTHR11462', NULL, NULL, NULL, NULL, 'JUN TRANSCRIPTION FACTOR-RELATED', NULL, NULL, NULL, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(252151, NULL, 'PTHR11675', NULL, NULL, NULL, NULL, 'N-ACETYLGALACTOSAMINYLTRANSFERASE', NULL, NULL, NULL, 8),
(252152, NULL, 'PTHR22655', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(252153, NULL, 'PTHR37215', NULL, NULL, NULL, NULL, 'ACYL-COA-BINDING DOMAIN PROTEIN', NULL, NULL, NULL, 8),
(252154, NULL, 'PTHR47453', NULL, NULL, NULL, NULL, 'PHOSPHOGLUCAN, WATER DIKINASE, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(252155, NULL, 'PTHR24347', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE', NULL, NULL, NULL, 8),
(252156, NULL, 'PTHR34050', NULL, NULL, NULL, NULL, '', NULL, NULL, 27577, 8),
(252157, NULL, 'PTHR13102', NULL, NULL, NULL, NULL, 'NUCLEOLAR PROTEIN 9', NULL, NULL, 27428, 8),
(252158, NULL, 'PTHR36130', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4933430I17 GENE', NULL, NULL, 23743, 8),
(252159, NULL, 'PTHR46810', NULL, NULL, NULL, NULL, 'INACTIVE POLYGLYCYLASE TTLL10', NULL, NULL, 24749, 8),
(252160, NULL, 'PTHR33281', NULL, NULL, NULL, NULL, 'UPF0187 PROTEIN YNEE', NULL, NULL, 36106, 8),
(252161, NULL, 'PTHR35132', NULL, NULL, NULL, NULL, 'SERINE/ARGININE REPETITIVE MATRIX-LIKE PROTEIN', NULL, NULL, NULL, 8),
(252162, NULL, 'PTHR11803', NULL, NULL, NULL, NULL, '2-IMINOBUTANOATE/2-IMINOPROPANOATE DEAMINASE RIDA', NULL, NULL, 11408, 8),
(252163, NULL, 'PTHR14939', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 22', NULL, NULL, NULL, 8),
(252164, NULL, 'PTHR42103', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(252165, NULL, 'PTHR13484', NULL, NULL, NULL, NULL, 'FIP1-LIKE 1 PROTEIN', NULL, NULL, NULL, 8),
(252166, NULL, 'PTHR13936', NULL, NULL, NULL, NULL, 'PROFILIN', NULL, NULL, NULL, 8),
(252167, NULL, 'PTHR23284', NULL, NULL, NULL, NULL, 'PROLACTIN REGULATORY ELEMENT BINDING PROTEIN', NULL, NULL, 35824, 8),
(252168, NULL, 'PTHR16128', NULL, NULL, NULL, NULL, 'FAD/NAD(P)-BINDING OXIDOREDUCTASE FAMILY PROTEIN', NULL, NULL, NULL, 8),
(252169, NULL, 'PTHR46546', NULL, NULL, NULL, NULL, 'SHEWANELLA-LIKE PROTEIN PHOSPHATASE 1', NULL, NULL, NULL, 8),
(252170, NULL, 'PTHR46253', NULL, NULL, NULL, NULL, 'TGF-BETA-ACTIVATED KINASE 1 AND MAP3K7-BINDING PROTEIN TAB', NULL, NULL, NULL, 8),
(252171, NULL, 'PTHR12532', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 5846, 8),
(252172, NULL, 'PTHR43374', NULL, NULL, NULL, NULL, 'FLAVIN PRENYLTRANSFERASE', NULL, NULL, 1820, 8),
(252173, NULL, 'PTHR43691', NULL, NULL, NULL, NULL, 'URIDINE PHOSPHORYLASE', NULL, NULL, NULL, 8),
(252174, NULL, 'PTHR38506', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4930544D05 GENE', NULL, NULL, 30355, 8),
(252175, NULL, 'PTHR10242', NULL, NULL, NULL, NULL, '8-OXOGUANINE DNA GLYCOSYLASE', NULL, NULL, NULL, 8),
(252176, NULL, 'PTHR43986', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-GAMMA', NULL, NULL, NULL, 8),
(252177, NULL, 'PTHR36403', NULL, NULL, NULL, NULL, 'PROTEIN COFACTOR ASSEMBLY OF COMPLEX C SUBUNIT B CCB2, CHLOROPLASTIC', NULL, NULL, 35910, 8),
(252178, NULL, 'PTHR12746', NULL, NULL, NULL, NULL, 'NONSENSE-MEDIATED MRNA DECAY PROTEIN 3', NULL, NULL, 33203, 8),
(252179, NULL, 'PTHR15964', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN B48 RECEPTOR', NULL, NULL, 23213, 8),
(252180, NULL, 'PTHR47073', NULL, NULL, NULL, NULL, 'PROTEIN ANTI-SILENCING 1', NULL, NULL, NULL, 8),
(252181, NULL, 'PTHR28625', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPHATASE 1 REGULATORY SUBUNIT 35', NULL, NULL, 28277, 8),
(252182, NULL, 'PTHR10169', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE/GYRASE', NULL, NULL, NULL, 8),
(252183, NULL, 'PTHR31985', NULL, NULL, NULL, NULL, 'ETHYLENE-RESPONSIVE TRANSCRIPTION FACTOR ERF042-RELATED', NULL, NULL, NULL, 8),
(252184, NULL, 'PTHR24170', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 27', NULL, NULL, NULL, 8),
(252185, NULL, 'PTHR28260', NULL, NULL, NULL, NULL, 'SPINDLE POLE BODY COMPONENT SPC105', NULL, NULL, 29532, 8),
(252186, NULL, 'PTHR10582', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL ION CHANNEL PROTEIN', NULL, NULL, 18530, 8),
(252187, NULL, 'PTHR35152', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(252188, NULL, 'PTHR36791', NULL, NULL, NULL, NULL, 'OS03G0363400 PROTEIN', NULL, NULL, NULL, 8),
(252189, NULL, 'PTHR14582', NULL, NULL, NULL, NULL, 'INNER KINETOCHORE SUBUNIT MAL2', NULL, NULL, 9274, 8),
(252190, NULL, 'PTHR40026', NULL, NULL, NULL, NULL, 'PROTEIN VEG', NULL, NULL, 14386, 8),
(252191, NULL, 'PTHR12414', NULL, NULL, NULL, NULL, 'GLIAL CELLS MISSING RELATED/GLIDE', NULL, NULL, 31296, 8),
(252192, NULL, 'PTHR13400', NULL, NULL, NULL, NULL, 'CHEMOKINE C-C MOTIF RECEPTOR 1', NULL, NULL, 25746, 8),
(252193, NULL, 'PTHR36139', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE SUBUNIT 5, MITOCHONDRIAL', NULL, NULL, 21755, 8),
(252194, NULL, 'PTHR11494', NULL, NULL, NULL, NULL, 'CYTOTOXIC T-LYMPHOCYTE PROTEIN', NULL, NULL, 27849, 8),
(252195, NULL, 'PTHR33116', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE ZINC-BINDING DOMAIN-CONTAINING PROTEIN-RELATED-RELATED', NULL, NULL, NULL, 8),
(252196, NULL, 'PTHR24019', NULL, NULL, NULL, NULL, 'ADIPOLIN', NULL, NULL, NULL, 8),
(252197, NULL, 'PTHR18976', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN', NULL, NULL, NULL, 8),
(252198, NULL, 'PTHR42031', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252199, NULL, 'PTHR14136', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(252200, NULL, 'PTHR12901', NULL, NULL, NULL, NULL, 'SPERM PROTEIN HOMOLOG', NULL, NULL, 36949, 8),
(252201, NULL, 'PTHR34833', NULL, NULL, NULL, NULL, 'GENE, 17359-RELATED', NULL, NULL, 21684, 8),
(252202, NULL, 'PTHR20787', NULL, NULL, NULL, NULL, 'TREACLE', NULL, NULL, 8859, 8),
(252203, NULL, 'PTHR38633', NULL, NULL, NULL, NULL, 'PROTEIN CBG15573-RELATED', NULL, NULL, NULL, 8),
(252204, NULL, 'PTHR15724', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 24776, 8),
(252205, NULL, 'PTHR12701', NULL, NULL, NULL, NULL, 'BCR-ASSOCIATED PROTEIN, BAP', NULL, NULL, 8944, 8),
(252206, NULL, 'PTHR46233', NULL, NULL, NULL, NULL, 'HYDROXYACYLGLUTATHIONE HYDROLASE GLOC', NULL, NULL, NULL, 8),
(252207, NULL, 'PTHR36949', NULL, NULL, NULL, NULL, 'PROTEIN CBR-LIN-66', NULL, NULL, NULL, 8),
(252208, NULL, 'PTHR40640', NULL, NULL, NULL, NULL, 'ANCHORED GLYCOPROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_8G04860)-RELATED', NULL, NULL, NULL, 8),
(252209, NULL, 'PTHR33228', NULL, NULL, NULL, NULL, 'PROTEIN GLUTAMINE DUMPER 4-RELATED', NULL, NULL, 28664, 8),
(252210, NULL, 'PTHR37742', NULL, NULL, NULL, NULL, 'OS01G0810200 PROTEIN', NULL, NULL, NULL, 8),
(252211, NULL, 'PTHR43264', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252212, NULL, 'PTHR47680', NULL, NULL, NULL, NULL, 'SHEWANELLA-LIKE PROTEIN PHOSPHATASE 2', NULL, NULL, NULL, 8),
(252213, NULL, 'PTHR28133', NULL, NULL, NULL, NULL, 'REQUIRED FOR RESPIRATORY GROWTH PROTEIN 7, MITOCHONDRIAL', NULL, NULL, 19833, 8),
(252214, NULL, 'PTHR12289', NULL, NULL, NULL, NULL, 'METAXIN RELATED', NULL, NULL, NULL, 8),
(252215, NULL, 'PTHR23315', NULL, NULL, NULL, NULL, 'U BOX DOMAIN-CONTAINING', NULL, NULL, NULL, 8),
(252216, NULL, 'PTHR37543', NULL, NULL, NULL, NULL, 'CCCH ZINC FINGER DNA BINDING PROTEIN (AFU_ORTHOLOGUE AFUA_5G12760)', NULL, NULL, NULL, 8),
(252217, NULL, 'PTHR36859', NULL, NULL, NULL, NULL, 'PROTEIN HIDE1', NULL, NULL, 27592, 8),
(252218, NULL, 'PTHR23243', NULL, NULL, NULL, NULL, 'SUPRABASAL-SPECIFIC PROTEIN SUPRABASIN', NULL, NULL, NULL, 8),
(252219, NULL, 'PTHR14739', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN 9', NULL, NULL, 25072, 8),
(252220, NULL, 'PTHR34994', NULL, NULL, NULL, NULL, 'PROTEIN FAM25A-RELATED', NULL, NULL, 15822, 8),
(252221, NULL, 'PTHR12804', NULL, NULL, NULL, NULL, 'MICROSOMAL SIGNAL PEPTIDASE 23 KD SUBUNIT  SPC22/23', NULL, NULL, 313, 8),
(252222, NULL, 'PTHR12802', NULL, NULL, NULL, NULL, 'SWI/SNF COMPLEX-RELATED', NULL, NULL, NULL, 8),
(252223, NULL, 'PTHR36797', NULL, NULL, NULL, NULL, 'OS01G0258600 PROTEIN', NULL, NULL, NULL, 8),
(252224, NULL, 'PTHR34144', NULL, NULL, NULL, NULL, 'CHROMOSOME 8, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, 15209, 8),
(252225, NULL, 'PTHR30203', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE CATION EFFLUX PROTEIN', NULL, NULL, NULL, 8),
(252226, NULL, 'PTHR43840', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL METAL TRANSPORTER 1-RELATED', NULL, NULL, NULL, 8);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(252227, NULL, 'PTHR47483', NULL, NULL, NULL, NULL, 'BETA-ARABINOFURANOSYLTRANSFERASE RAY1', NULL, NULL, 36216, 8),
(252228, NULL, 'PTHR40099', NULL, NULL, NULL, NULL, 'ACETOLACTATE SYNTHASE, SMALL SUBUNIT', NULL, NULL, NULL, 8),
(252229, NULL, 'PTHR23215', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN 207', NULL, NULL, NULL, 8),
(252230, NULL, 'PTHR46698', NULL, NULL, NULL, NULL, 'CROSSVEINLESS 2', NULL, NULL, NULL, 8),
(252231, NULL, 'PTHR30363', NULL, NULL, NULL, NULL, 'HTH-TYPE TRANSCRIPTIONAL REGULATOR SRLR-RELATED', NULL, NULL, NULL, 8),
(252232, NULL, 'PTHR43409', NULL, NULL, NULL, NULL, 'ANAEROBIC MAGNESIUM-PROTOPORPHYRIN IX MONOMETHYL ESTER CYCLASE-RELATED', NULL, NULL, NULL, 8),
(252233, NULL, 'PTHR31559', NULL, NULL, NULL, NULL, 'PYRIDOXAL 5''-PHOSPHATE SYNTHASE SUBUNIT SNO', NULL, NULL, 5189, 8),
(252234, NULL, 'PTHR15223', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE AGGG SUBUNIT', NULL, NULL, 23245, 8),
(252235, NULL, 'PTHR12458', NULL, NULL, NULL, NULL, 'ORF PROTEIN', NULL, NULL, 14238, 8),
(252236, NULL, 'PTHR34654', NULL, NULL, NULL, NULL, 'UPF0109 PROTEIN SCO5592', NULL, NULL, 19819, 8),
(252237, NULL, 'PTHR31847', NULL, NULL, NULL, NULL, 'PROTEIN CBG10327', NULL, NULL, NULL, 8),
(252238, NULL, 'PTHR39453', NULL, NULL, NULL, NULL, 'PHOSPHATE PROPANOYLTRANSFERASE', NULL, NULL, 8577, 8),
(252239, NULL, 'PTHR48065', NULL, NULL, NULL, NULL, 'OS10G0469600 PROTEIN', NULL, NULL, NULL, 8),
(252240, NULL, 'PTHR23247', NULL, NULL, NULL, NULL, 'NY-REN-41 ANTIGEN  L15 -RELATED', NULL, NULL, 37366, 8),
(252241, NULL, 'PTHR21358', NULL, NULL, NULL, NULL, 'PROTEIN MAELSTROM HOMOLOG', NULL, NULL, 33334, 8),
(252242, NULL, 'PTHR21015', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE--N-ACETYLMURAMYL-(PENTAPEPTIDE) PYROPHOSPHORYL-UNDECAPRENOL N-ACETYLGLUCOSAMINE TRANSFERASE 1', NULL, NULL, NULL, 8),
(252243, NULL, 'PTHR46251', NULL, NULL, NULL, NULL, 'RUN DOMAIN-CONTAINING 3 PROTEIN RUNDC3', NULL, NULL, NULL, 8),
(252244, NULL, 'PTHR35544', NULL, NULL, NULL, NULL, 'RIBOSOMAL BIOGENESIS FACTOR', NULL, NULL, 25099, 8),
(252245, NULL, 'PTHR10704', NULL, NULL, NULL, NULL, 'CARBOHYDRATE SULFOTRANSFERASE', NULL, NULL, NULL, 8),
(252246, NULL, 'PTHR14817', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 15', NULL, NULL, 28684, 8),
(252247, NULL, 'PTHR47741', NULL, NULL, NULL, NULL, 'COILED COIL DOMAIN-CONTAINING PROTEIN 8, CCDC8', NULL, NULL, 23319, 8),
(252248, NULL, 'PTHR28633', NULL, NULL, NULL, NULL, 'HERMANSKY-PUDLAK SYNDROME 3 PROTEIN', NULL, NULL, 15253, 8),
(252249, NULL, 'PTHR21199', NULL, NULL, NULL, NULL, 'COMM DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, 29261, 8),
(252250, NULL, 'PTHR21357', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(252251, NULL, 'PTHR47977', NULL, NULL, NULL, NULL, 'RAS-RELATED PROTEIN RAB', NULL, NULL, NULL, 8),
(252252, NULL, 'PTHR44943', NULL, NULL, NULL, NULL, 'CELLULOSE SYNTHASE OPERON PROTEIN C', NULL, NULL, NULL, 8),
(252253, NULL, 'PTHR47086', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', NULL, NULL, 32752, 8),
(252254, NULL, 'PTHR31956', NULL, NULL, NULL, NULL, 'NON-SPECIFIC PHOSPHOLIPASE C4-RELATED', NULL, NULL, 4828, 8),
(252255, NULL, 'PTHR48041', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 28', NULL, NULL, NULL, 8),
(252256, NULL, 'PTHR48240', NULL, NULL, NULL, NULL, 'GRF-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(252257, NULL, 'PTHR30037', NULL, NULL, NULL, NULL, 'DNA-3-METHYLADENINE GLYCOSYLASE 1', NULL, NULL, NULL, 8),
(252258, NULL, 'PTHR34468', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED FUTSCH-LIKE PROTEIN', NULL, NULL, NULL, 8),
(252259, NULL, 'PTHR36872', NULL, NULL, NULL, NULL, 'GENE 5901-RELATED', NULL, NULL, 21562, 8),
(252260, NULL, 'PTHR34001', NULL, NULL, NULL, NULL, 'BLL7405 PROTEIN', NULL, NULL, NULL, 8),
(252261, NULL, 'PTHR11909', NULL, NULL, NULL, NULL, 'CASEIN KINASE-RELATED', NULL, NULL, NULL, 8),
(252262, NULL, 'PTHR35249', NULL, NULL, NULL, NULL, 'DYNEIN REGULATORY COMPLEX SUBUNIT 7', NULL, NULL, 27965, 8),
(252263, NULL, 'PTHR36456', NULL, NULL, NULL, NULL, 'UPF0232 PROTEIN SCO3875', NULL, NULL, NULL, 8);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(252264, NULL, 'PTHR32085', NULL, NULL, NULL, NULL, 'PROTEIN CSF1', NULL, NULL, 25692, 8),
(252265, NULL, 'PTHR40460', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(252266, NULL, 'PTHR34716', NULL, NULL, NULL, NULL, 'BTB DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(252267, NULL, 'PTHR21082', NULL, NULL, NULL, NULL, 'PROTEIN INTURNED', NULL, NULL, 32965, 8),
(252268, NULL, 'PTHR34558', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(252269, NULL, 'PTHR36054', NULL, NULL, NULL, NULL, 'PROTEIN SICKLE', NULL, NULL, 32946, 8),
(252270, NULL, 'PTHR19850', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN BETA  G PROTEIN BETA', NULL, NULL, 20452, 8),
(252271, NULL, 'PTHR33525', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252272, NULL, 'PTHR14485', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 23', NULL, NULL, 35746, 8),
(252273, NULL, 'PTHR14398', NULL, NULL, NULL, NULL, 'RNA RECOGNITION RRM/RNP DOMAIN', NULL, NULL, 36637, 8),
(252274, NULL, 'PTHR12943', NULL, NULL, NULL, NULL, 'HOMOCYSTEINE-RESPONSIVE ENDOPLASMIC RETICULUM-RESIDENT UNIQUITIN-LIKE DOMAIN HERPUD PROTEIN FAMILY MEMBER', NULL, NULL, 31467, 8),
(252275, NULL, 'PTHR12941', NULL, NULL, NULL, NULL, 'ER MEMBRANE PROTEIN COMPLEX', NULL, NULL, 6245, 8),
(252276, NULL, 'PTHR34824', NULL, NULL, NULL, NULL, 'HEAT-INDUCIBLE TRANSCRIPTION REPRESSOR HRCA', NULL, NULL, 1793, 8),
(252277, NULL, 'PTHR33333', NULL, NULL, NULL, NULL, 'ERYTHROCYTE MEMBRANE PROTEIN 1-LIKE', NULL, NULL, 27084, 8),
(252278, NULL, 'PTHR13440', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 14688, 8),
(252279, NULL, 'PTHR12965', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING 54', NULL, NULL, 28948, 8),
(252280, NULL, 'PTHR43101', NULL, NULL, NULL, NULL, 'BETA-FRUCTOSIDASE', NULL, NULL, NULL, 8),
(252281, NULL, 'PTHR46133', NULL, NULL, NULL, NULL, 'BHLH TRANSCRIPTION FACTOR', NULL, NULL, 34364, 8),
(252282, NULL, 'PTHR31726', NULL, NULL, NULL, NULL, 'PROTEIN ICE2', NULL, NULL, 11343, 8),
(252283, NULL, 'PTHR43563', NULL, NULL, NULL, NULL, 'AMINE OXIDASE', NULL, NULL, NULL, 8),
(252284, NULL, 'PTHR10803', NULL, NULL, NULL, NULL, 'ARSENICAL PUMP-DRIVING ATPASE  ARSENITE-TRANSLOCATING ATPASE', NULL, NULL, 19641, 8),
(252285, NULL, 'PTHR16656', NULL, NULL, NULL, NULL, 'ALPHA-S2-CASEIN-LIKE B', NULL, NULL, 10602, 8),
(252286, NULL, 'PTHR15721', NULL, NULL, NULL, NULL, 'KIAA0586 PROTEIN', NULL, NULL, 23253, 8),
(252287, NULL, 'PTHR37461', NULL, NULL, NULL, NULL, 'ANTI-SIGMA-K FACTOR RSKA', NULL, NULL, NULL, 8),
(252288, NULL, 'PTHR12080', NULL, NULL, NULL, NULL, 'SIGNALING LYMPHOCYTIC ACTIVATION MOLECULE', NULL, NULL, NULL, 8),
(252289, NULL, 'PTHR10221', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 6', NULL, NULL, 31010, 8),
(252290, NULL, 'PTHR35500', NULL, NULL, NULL, NULL, 'OS03G0108700 PROTEIN', NULL, NULL, NULL, 8),
(252291, NULL, 'PTHR47327', NULL, NULL, NULL, NULL, 'FI18240P1-RELATED', NULL, NULL, NULL, 8),
(252292, NULL, 'PTHR15532', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252293, NULL, 'PTHR14289', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 3', NULL, NULL, NULL, 8),
(252294, NULL, 'PTHR36765', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(252295, NULL, 'PTHR13455', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR P66-RELATED', NULL, NULL, 28697, 8),
(252296, NULL, 'PTHR39730', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE 1', NULL, NULL, NULL, 8),
(252297, NULL, 'PTHR33287', NULL, NULL, NULL, NULL, 'OS03G0453550 PROTEIN', NULL, NULL, NULL, 8),
(252298, NULL, 'PTHR44200', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 7', NULL, NULL, NULL, 8),
(252299, NULL, 'PTHR36173', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252300, NULL, 'PTHR44535', NULL, NULL, NULL, NULL, 'PROTEIN CBG16200', NULL, NULL, NULL, 8),
(252301, NULL, 'PTHR21311', NULL, NULL, NULL, NULL, 'CONSERVED OLIGOMERIC GOLGI COMPLEX COMPONENT 8', NULL, NULL, 6720, 8),
(252302, NULL, 'PTHR35366', NULL, NULL, NULL, NULL, 'PROTEIN CBG18620', NULL, NULL, NULL, 8);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(252303, NULL, 'PTHR24190', NULL, NULL, NULL, NULL, 'ION_TRANS DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(252304, NULL, 'PTHR46528', NULL, NULL, NULL, NULL, 'PROTEIN SON', NULL, NULL, 6926, 8),
(252305, NULL, 'PTHR46276', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE UBR5', NULL, NULL, NULL, 8),
(252306, NULL, 'PTHR21207', NULL, NULL, NULL, NULL, 'PARKIN COREGULATED GENE PROTEIN  PARK2 COREGULATED', NULL, NULL, 16604, 8),
(252307, NULL, 'PTHR43335', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER, ATP-BINDING PROTEIN', NULL, NULL, NULL, 8),
(252308, NULL, 'PTHR21421', NULL, NULL, NULL, NULL, 'GUSTATORY RECEPTOR', NULL, NULL, 14131, 8),
(252309, NULL, 'PTHR33175', NULL, NULL, NULL, NULL, 'DNA-BINDING PROTEIN HU', NULL, NULL, 1984, 8),
(252310, NULL, 'PTHR43429', NULL, NULL, NULL, NULL, 'PYRIDINE NUCLEOTIDE-DISULFIDE OXIDOREDUCTASE DOMAIN-CONTAINING', NULL, NULL, NULL, 8),
(252311, NULL, 'PTHR43328', NULL, NULL, NULL, NULL, 'ACETYLTRANSFERASE-RELATED', NULL, NULL, NULL, 8),
(252312, NULL, 'PTHR13392', NULL, NULL, NULL, NULL, 'ATAXIN 1', NULL, NULL, 37509, 8),
(252313, NULL, 'PTHR13130', NULL, NULL, NULL, NULL, '34 KDA TRANSCRIPTIONAL CO-ACTIVATOR-RELATED', NULL, NULL, 18544, 8),
(252314, NULL, 'PTHR14119', NULL, NULL, NULL, NULL, 'HYDROLASE', NULL, NULL, NULL, 8),
(252315, NULL, 'PTHR35297', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(252316, NULL, 'PTHR14672', NULL, NULL, NULL, NULL, 'MUCIN-16', NULL, NULL, 23699, 8),
(252317, NULL, 'PTHR43268', NULL, NULL, NULL, NULL, 'THIOSULFATE SULFURTRANSFERASE/RHODANESE-LIKE DOMAIN-CONTAINING PROTEIN 2', NULL, NULL, 14722, 8),
(252318, NULL, 'PTHR31942', NULL, NULL, NULL, NULL, 'MLO-LIKE PROTEIN 1', NULL, NULL, 4998, 8),
(252319, NULL, 'PTHR45089', NULL, NULL, NULL, NULL, 'DNAJ HEAT SHOCK AMINO-TERMINAL DOMAIN PROTEIN-RELATED', NULL, NULL, NULL, 8),
(252320, NULL, 'PTHR21301', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE', NULL, NULL, NULL, 8),
(252321, NULL, 'PTHR28177', NULL, NULL, NULL, NULL, 'ALTERED INHERITANCE OF MITOCHONDRIA PROTEIN 19, MITOCHONDRIAL', NULL, NULL, 16501, 8),
(252322, NULL, 'PTHR37042', NULL, NULL, NULL, NULL, 'OUTER MEMBRANE PROTEIN RV1973', NULL, NULL, NULL, 8),
(252323, NULL, 'PTHR46092', NULL, NULL, NULL, NULL, 'HOMEOBOX PROTEIN HOX-A11-RELATED', NULL, NULL, NULL, 8),
(252324, NULL, 'PTHR16271', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 34/46 FAMILY MEMBER', NULL, NULL, 33601, 8),
(252325, NULL, 'PTHR33236', NULL, NULL, NULL, NULL, 'INTRAFLAGELLAR TRANSPORT PROTEIN 122 FAMILY PROTEIN-RELATED', NULL, NULL, NULL, 8),
(252326, NULL, 'PTHR36392', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(252327, NULL, 'PTHR37287', NULL, NULL, NULL, NULL, 'INO EIGHTY SUBUNIT 1', NULL, NULL, 27153, 8),
(252328, NULL, 'PTHR20930', NULL, NULL, NULL, NULL, 'OVARIAN CARCINOMA ANTIGEN CA125-RELATED', NULL, NULL, NULL, 8),
(252329, NULL, 'PTHR34264', NULL, NULL, NULL, NULL, 'ATP SYNTHASE SUBUNIT B, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(252330, NULL, 'PTHR45830', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS I', NULL, NULL, NULL, 8),
(252331, NULL, 'PTHR13225', NULL, NULL, NULL, NULL, 'MISEXPRESSION SUPPRESSOR OF RAS 6', NULL, NULL, 8173, 8),
(252332, NULL, 'PTHR46902', NULL, NULL, NULL, NULL, 'DOMON DOMAIN-CONTAINING PROTEIN FRRS1L', NULL, NULL, 34801, 8),
(252333, NULL, 'PTHR46942', NULL, NULL, NULL, NULL, 'SIALIC ACID-BINDING IG-LIKE LECTIN 15', NULL, NULL, 35008, 8),
(252334, NULL, 'PTHR46595', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L34', NULL, NULL, 7305, 8),
(252335, NULL, 'PTHR46900', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE NON-RECEPTOR TYPE 13', NULL, NULL, NULL, 8),
(252336, NULL, 'PTHR45693', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR TGA9', NULL, NULL, NULL, 8),
(252337, NULL, 'PTHR30231', NULL, NULL, NULL, NULL, 'DNA POLYMERASE III SUBUNIT EPSILON', NULL, NULL, NULL, 8),
(252338, NULL, 'PTHR38004', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 33', NULL, NULL, NULL, 8),
(252339, NULL, 'PTHR40470', NULL, NULL, NULL, NULL, 'PHYTANOYL-COA DIOXYGENASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_2G15850)', NULL, NULL, NULL, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(252340, NULL, 'PTHR16318', NULL, NULL, NULL, NULL, 'GAMMA-SECRETASE SUBUNIT PEN-2', NULL, NULL, 15691, 8),
(252341, NULL, 'PTHR46376', NULL, NULL, NULL, NULL, 'LEUCINE-ZIPPER-LIKE TRANSCRIPTIONAL REGULATOR 1', NULL, NULL, NULL, 8),
(252342, NULL, 'PTHR35441', NULL, NULL, NULL, NULL, 'CIRCADIAN-ASSOCIATED TRANSCRIPTIONAL REPRESSOR', NULL, NULL, 25106, 8),
(252343, NULL, 'PTHR45033', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252344, NULL, 'PTHR48024', NULL, NULL, NULL, NULL, 'GEO13361P1-RELATED', NULL, NULL, NULL, 8),
(252345, NULL, 'PTHR46466', NULL, NULL, NULL, NULL, 'GLYOXALASE DOMAIN-CONTAINING PROTEIN 4', NULL, NULL, 34650, 8),
(252346, NULL, 'PTHR35182', NULL, NULL, NULL, NULL, 'PROTEIN CBG13762', NULL, NULL, NULL, 8),
(252347, NULL, 'PTHR12785', NULL, NULL, NULL, NULL, 'SPLICING FACTOR 3B', NULL, NULL, NULL, 8),
(252348, NULL, 'PTHR41173', NULL, NULL, NULL, NULL, 'UPF0278 PROTEIN TK1425', NULL, NULL, 13186, 8),
(252349, NULL, 'PTHR21812', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 25619, 8),
(252350, NULL, 'PTHR48141', NULL, NULL, NULL, NULL, 'KINASE C, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(252351, NULL, 'PTHR36410', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(252352, NULL, 'PTHR15049', NULL, NULL, NULL, NULL, 'GLYCOSYL-PHOSPHATIDYLINOSITOL-ANCHORED MOLECULE-LIKE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(252353, NULL, 'PTHR10989', NULL, NULL, NULL, NULL, 'ANDROGEN-INDUCED PROTEIN 1-RELATED', NULL, NULL, 3564, 8),
(252354, NULL, 'PTHR13422', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 24495, 8),
(252355, NULL, 'PTHR31180', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 32824, 8),
(252356, NULL, 'PTHR34139', NULL, NULL, NULL, NULL, 'UPF0331 PROTEIN MJ0127', NULL, NULL, NULL, 8),
(252357, NULL, 'PTHR35848', NULL, NULL, NULL, NULL, 'OXALATE-BINDING PROTEIN', NULL, NULL, NULL, 8),
(252358, NULL, 'PTHR13379', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED DUF1308', NULL, NULL, NULL, 8),
(252359, NULL, 'PTHR21634', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(252360, NULL, 'PTHR33057', NULL, NULL, NULL, NULL, 'TRANSCRIPTION REPRESSOR OFP7-RELATED', NULL, NULL, 30987, 8),
(252361, NULL, 'PTHR36834', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(252362, NULL, 'PTHR39166', NULL, NULL, NULL, NULL, 'BLL1166 PROTEIN', NULL, NULL, 13523, 8),
(252363, NULL, 'PTHR37972', NULL, NULL, NULL, NULL, 'PROTEIN CBG25533', NULL, NULL, NULL, 8),
(252364, NULL, 'PTHR24009', NULL, NULL, NULL, NULL, 'RNA-BINDING (RRM/RBD/RNP MOTIFS)', NULL, NULL, NULL, 8),
(252365, NULL, 'PTHR39080', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L28', NULL, NULL, NULL, 8),
(252366, NULL, 'PTHR36118', NULL, NULL, NULL, NULL, 'ION-TRANSLOCATING OXIDOREDUCTASE COMPLEX SUBUNIT G', NULL, NULL, 4378, 8),
(252367, NULL, 'PTHR22851', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RNA  U3 SNORNA  ASSOCIATED PROTEIN', NULL, NULL, NULL, 8),
(252368, NULL, 'PTHR16320', NULL, NULL, NULL, NULL, 'SPHINGOMYELINASE FAMILY MEMBER', NULL, NULL, NULL, 8),
(252369, NULL, 'PTHR13531', NULL, NULL, NULL, NULL, 'GEO07735P1-RELATED-RELATED', NULL, NULL, 18256, 8),
(252370, NULL, 'PTHR47949', NULL, NULL, NULL, NULL, 'CYTOCHROME P450 703A2-RELATED-RELATED', NULL, NULL, NULL, 8),
(252371, NULL, 'PTHR43066', NULL, NULL, NULL, NULL, 'RHOMBOID-RELATED PROTEIN', NULL, NULL, NULL, 8),
(252372, NULL, 'PTHR10699', NULL, NULL, NULL, NULL, 'NEUROMODULIN', NULL, NULL, NULL, 8),
(252373, NULL, 'PTHR47856', NULL, NULL, NULL, NULL, 'HEAVY METAL-ASSOCIATED ISOPRENYLATED PLANT PROTEIN 20-LIKE', NULL, NULL, NULL, 8),
(252374, NULL, 'PTHR47627', NULL, NULL, NULL, NULL, 'RUBREDOXIN', NULL, NULL, NULL, 8),
(252375, NULL, 'PTHR33572', NULL, NULL, NULL, NULL, 'SPORE DEVELOPMENT REGULATOR VOSA', NULL, NULL, 19074, 8),
(252376, NULL, 'PTHR31304', NULL, NULL, NULL, NULL, 'LOB DOMAIN-CONTAINING PROTEIN 38', NULL, NULL, NULL, 8),
(252377, NULL, 'PTHR38221', NULL, NULL, NULL, NULL, 'BNAA04G14260D PROTEIN', NULL, NULL, NULL, 8),
(252378, NULL, 'PTHR11474', NULL, NULL, NULL, NULL, 'TYROSINASE FAMILY MEMBER', NULL, NULL, NULL, 8);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(252379, NULL, 'PTHR43074', NULL, NULL, NULL, NULL, 'OMEGA-3 POLYUNSATURATED FATTY ACID SYNTHASE PFAB-RELATED', NULL, NULL, NULL, 8),
(252380, NULL, 'PTHR37227', NULL, NULL, NULL, NULL, 'OS01G0219000 PROTEIN', NULL, NULL, NULL, 8),
(252381, NULL, 'PTHR15108', NULL, NULL, NULL, NULL, 'N-ACYLGLUCOSAMINE-2-EPIMERASE', NULL, NULL, NULL, 8),
(252382, NULL, 'PTHR38148', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252383, NULL, 'PTHR15663', NULL, NULL, NULL, NULL, 'COMM DOMAIN-CONTAINING PROTEIN 9', NULL, NULL, 32779, 8),
(252384, NULL, 'PTHR47359', NULL, NULL, NULL, NULL, 'PEPTIDOGLYCAN DL-ENDOPEPTIDASE CWLO', NULL, NULL, NULL, 8),
(252385, NULL, 'PTHR46989', NULL, NULL, NULL, NULL, 'USP DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(252386, NULL, 'PTHR10887', NULL, NULL, NULL, NULL, 'DNA2/NAM7 HELICASE FAMILY', NULL, NULL, 34272, 8),
(252387, NULL, 'PTHR31918', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 181', NULL, NULL, 28931, 8),
(252388, NULL, 'PTHR14296', NULL, NULL, NULL, NULL, 'REMODELING AND SPACING FACTOR 1', NULL, NULL, 25262, 8),
(252389, NULL, 'PTHR38011', NULL, NULL, NULL, NULL, 'DIHYDROFOLATE REDUCTASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_8G06820)', NULL, NULL, NULL, 8),
(252390, NULL, 'PTHR43340', NULL, NULL, NULL, NULL, 'HYPOXANTHINE-GUANINE PHOSPHORIBOSYLTRANSFERASE', NULL, NULL, NULL, 8),
(252391, NULL, 'PTHR37162', NULL, NULL, NULL, NULL, 'HAT FAMILY DIMERISATION DOMAINCONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(252392, NULL, 'PTHR38123', NULL, NULL, NULL, NULL, 'CELL WALL SERINE-THREONINE-RICH GALACTOMANNOPROTEIN MP1 (AFU_ORTHOLOGUE AFUA_4G03240)', NULL, NULL, NULL, 8),
(252393, NULL, 'PTHR39559', NULL, NULL, NULL, NULL, '', NULL, NULL, 10307, 8),
(252394, NULL, 'PTHR23105', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L7AE FAMILY MEMBER', NULL, NULL, NULL, 8),
(252395, NULL, 'PTHR35802', NULL, NULL, NULL, NULL, 'PROTEASE SYNTHASE AND SPORULATION PROTEIN PAI 2', NULL, NULL, 3680, 8),
(252396, NULL, 'PTHR36014', NULL, NULL, NULL, NULL, 'OS03G0176600 PROTEIN', NULL, NULL, NULL, 8),
(252397, NULL, 'PTHR33646', NULL, NULL, NULL, NULL, 'GB|AAF00631.1', NULL, NULL, 36432, 8),
(252398, NULL, 'PTHR33826', NULL, NULL, NULL, NULL, 'F20B24.21', NULL, NULL, NULL, 8),
(252399, NULL, 'PTHR43571', NULL, NULL, NULL, NULL, 'NADP-SPECIFIC GLUTAMATE DEHYDROGENASE 1-RELATED', NULL, NULL, NULL, 8),
(252400, NULL, 'PTHR30033', NULL, NULL, NULL, NULL, 'FLAGELLAR HOOK-ASSOCIATED PROTEIN 1', NULL, NULL, 6094, 8),
(252401, NULL, 'PTHR47823', NULL, NULL, NULL, NULL, 'ION_TRANS DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(252402, NULL, 'PTHR43040', NULL, NULL, NULL, NULL, 'RIBONUCLEASE D', NULL, NULL, NULL, 8),
(252403, NULL, 'PTHR24207', NULL, NULL, NULL, NULL, 'ZYX102 PROTEIN', NULL, NULL, NULL, 8),
(252404, NULL, 'PTHR36182', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G10930)-RELATED', NULL, NULL, NULL, 8),
(252405, NULL, 'PTHR37928', NULL, NULL, NULL, NULL, 'CFEM DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_6G14090)', NULL, NULL, NULL, 8),
(252406, NULL, 'PTHR36395', NULL, NULL, NULL, NULL, 'RING-H2 ZINC FINGER PROTEIN', NULL, NULL, NULL, 8),
(252407, NULL, 'PTHR39962', NULL, NULL, NULL, NULL, 'BLL4848 PROTEIN', NULL, NULL, NULL, 8),
(252408, NULL, 'PTHR22437', NULL, NULL, NULL, NULL, 'WINGED HELIX DOMAIN-CONTAINING PROTEIN', NULL, NULL, 27499, 8),
(252409, NULL, 'PTHR47725', NULL, NULL, NULL, NULL, 'OS03G0364000 PROTEIN', NULL, NULL, NULL, 8),
(252410, NULL, 'PTHR28583', NULL, NULL, NULL, NULL, 'ACID AMIDASE', NULL, NULL, NULL, 8),
(252411, NULL, 'PTHR33998', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252412, NULL, 'PTHR14233', NULL, NULL, NULL, NULL, 'DUF914-RELATED', NULL, NULL, NULL, 8),
(252413, NULL, 'PTHR48221', NULL, NULL, NULL, NULL, 'ACYL-COA SYNTHETASE FAMILY PROTEIN', NULL, NULL, NULL, 8),
(252414, NULL, 'PTHR35447', NULL, NULL, NULL, NULL, 'BH3-INTERACTING DOMAIN DEATH AGONIST', NULL, NULL, 10181, 8),
(252415, NULL, 'PTHR36459', NULL, NULL, NULL, NULL, 'ORF', NULL, NULL, NULL, 8),
(252416, NULL, 'PTHR13115', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(252417, NULL, 'PTHR37808', NULL, NULL, NULL, NULL, 'SPORE GERMINATION PROTEIN-LIKE PROTEIN YDZR-RELATED', NULL, NULL, 20183, 8),
(252418, NULL, 'PTHR48302', NULL, NULL, NULL, NULL, 'ULP1 PROTEASE FAMILY, C-TERMINAL CATALYTIC DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(252419, NULL, 'PTHR31046', NULL, NULL, NULL, NULL, '', NULL, NULL, 36120, 8),
(252420, NULL, 'PTHR14787', NULL, NULL, NULL, NULL, 'C10ORF188 FAMILY MEMBER', NULL, NULL, 24445, 8),
(252421, NULL, 'PTHR13475', NULL, NULL, NULL, NULL, 'NEUGRIN', NULL, NULL, 10301, 8),
(252422, NULL, 'PTHR34487', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252423, NULL, 'PTHR31616', NULL, NULL, NULL, NULL, 'TREHALASE', NULL, NULL, NULL, 8),
(252424, NULL, 'PTHR21683', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(252425, NULL, 'PTHR22597', NULL, NULL, NULL, NULL, 'POLYCOMB GROUP PROTEIN', NULL, NULL, NULL, 8),
(252426, NULL, 'PTHR35663', NULL, NULL, NULL, NULL, 'TESTIS DEVELOPMENT-RELATED PROTEIN-RELATED', NULL, NULL, NULL, 8),
(252427, NULL, 'PTHR12242', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(252428, NULL, 'PTHR21551', NULL, NULL, NULL, NULL, 'TOPOISOMERASE II-ASSOCIATED PROTEIN PAT1', NULL, NULL, 31073, 8),
(252429, NULL, 'PTHR13976', NULL, NULL, NULL, NULL, 'HETEROGENEOUS NUCLEAR RIBONUCLEOPROTEIN-RELATED', NULL, NULL, NULL, 8),
(252430, NULL, 'PTHR21020', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 32872, 8),
(252431, NULL, 'PTHR35101', NULL, NULL, NULL, NULL, 'OS02G0162600 PROTEIN', NULL, NULL, NULL, 8),
(252432, NULL, 'PTHR40763', NULL, NULL, NULL, NULL, 'MEMBRANE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(252433, NULL, 'PTHR45752', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT-CONTAINING', NULL, NULL, NULL, 8),
(252434, NULL, 'PTHR10634', NULL, NULL, NULL, NULL, 'AN1-TYPE ZINC FINGER PROTEIN', NULL, NULL, NULL, 8),
(252435, NULL, 'PTHR48277', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOMAL PROTEIN S5', NULL, NULL, NULL, 8),
(252436, NULL, 'PTHR34062', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE 21 KDA SUBUNIT, PUTATIVE (AFU_ORTHOLOGUE AFUA_4G04750)-RELATED', NULL, NULL, NULL, 8),
(252437, NULL, 'PTHR11539', NULL, NULL, NULL, NULL, 'VDJ RECOMBINATION ACTIVATING PROTEIN 1 RAG1', NULL, NULL, 17059, 8),
(252438, NULL, 'PTHR20889', NULL, NULL, NULL, NULL, 'PHOSPHATASE, ORPHAN 1, 2', NULL, NULL, 17732, 8),
(252439, NULL, 'PTHR38629', NULL, NULL, NULL, NULL, 'PROTEIN CBG12672', NULL, NULL, NULL, 8),
(252440, NULL, 'PTHR13170', NULL, NULL, NULL, NULL, 'O-GLCNACASE', NULL, NULL, NULL, 8),
(252441, NULL, 'PTHR33418', NULL, NULL, NULL, NULL, 'HELICASE-ASSOCIATED', NULL, NULL, NULL, 8),
(252442, NULL, 'PTHR35156', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 52', NULL, NULL, 26535, 8),
(252443, NULL, 'PTHR31341', NULL, NULL, NULL, NULL, 'IPT/TIG DOMAIN-CONTAINING PROTEIN-RELATED-RELATED', NULL, NULL, NULL, 8),
(252444, NULL, 'PTHR47028', NULL, NULL, NULL, NULL, 'RECEPTOR-TYPE TYROSINE-PROTEIN PHOSPHATASE O', NULL, NULL, 34151, 8),
(252445, NULL, 'PTHR47326', NULL, NULL, NULL, NULL, 'TRANSPOSABLE ELEMENT TC3 TRANSPOSASE-LIKE PROTEIN', NULL, NULL, NULL, 8),
(252446, NULL, 'PTHR15468', NULL, NULL, NULL, NULL, 'ZNF185', NULL, NULL, NULL, 8),
(252447, NULL, 'PTHR39189', NULL, NULL, NULL, NULL, 'UPF0173 METAL-DEPENDENT HYDROLASE YTKL', NULL, NULL, NULL, 8),
(252448, NULL, 'PTHR46313', NULL, NULL, NULL, NULL, '', NULL, NULL, 36523, 8),
(252449, NULL, 'PTHR14096', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN L', NULL, NULL, 8538, 8),
(252450, NULL, 'PTHR31206', NULL, NULL, NULL, NULL, 'LP10445P', NULL, NULL, 26582, 8),
(252451, NULL, 'PTHR31078', NULL, NULL, NULL, NULL, 'CILIA- AND FLAGELLA-ASSOCIATED PROTEIN 300', NULL, NULL, 23550, 8),
(252452, NULL, 'PTHR10335', NULL, NULL, NULL, NULL, 'RRNA 2-O-METHYLTRANSFERASE FIBRILLARIN', NULL, NULL, NULL, 8),
(252453, NULL, 'PTHR43969', NULL, NULL, NULL, NULL, 'GLUTATHIONE S TRANSFERASE D10, ISOFORM A-RELATED', NULL, NULL, NULL, 8),
(252454, NULL, 'PTHR35883', NULL, NULL, NULL, NULL, 'CYCLIC AMP-INDUCIBLE PROTEIN BP74-RELATED', NULL, NULL, NULL, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(252455, NULL, 'PTHR47046', NULL, NULL, NULL, NULL, 'SUCCINATE DEHYDROGENASE ASSEMBLY FACTOR 1, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(252456, NULL, 'PTHR47954', NULL, NULL, NULL, NULL, 'OS09G0275400 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(252457, NULL, 'PTHR46898', NULL, NULL, NULL, NULL, 'SENESCENCE-ASSOCIATED CARBOXYLESTERASE 101', NULL, NULL, 34993, 8),
(252458, NULL, 'PTHR31054', NULL, NULL, NULL, NULL, 'ZYGOTE ARREST PROTEIN 1-LIKE ISOFORM X1', NULL, NULL, 24168, 8),
(252459, NULL, 'PTHR14212', NULL, NULL, NULL, NULL, 'U4/U6-ASSOCIATED RNA SPLICING FACTOR-RELATED', NULL, NULL, 22729, 8),
(252460, NULL, 'PTHR46322', NULL, NULL, NULL, NULL, 'PUROMYCIN-SENSITIVE AMINOPEPTIDASE', NULL, NULL, 9560, 8),
(252461, NULL, 'PTHR33772', NULL, NULL, NULL, NULL, 'THYMUS, BRAIN AND TESTES-ASSOCIATED', NULL, NULL, 31958, 8),
(252462, NULL, 'PTHR19297', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE 14 FAMILY MEMBER', NULL, NULL, NULL, 8),
(252463, NULL, 'PTHR10290', NULL, NULL, NULL, NULL, 'DNA TOPOISOMERASE I', NULL, NULL, NULL, 8),
(252464, NULL, 'PTHR41795', NULL, NULL, NULL, NULL, 'EXOPOLYSACCHARIDE SYNTHESIS PROTEIN', NULL, NULL, 8980, 8),
(252465, NULL, 'PTHR32054', NULL, NULL, NULL, NULL, 'HEAVY CHAIN, PUTATIVE, EXPRESSED-RELATED-RELATED', NULL, NULL, NULL, 8),
(252466, NULL, 'PTHR40449', NULL, NULL, NULL, NULL, 'ETHANOLAMINE UTILIZATION PROTEIN EUTS', NULL, NULL, 13878, 8),
(252467, NULL, 'PTHR41237', NULL, NULL, NULL, NULL, '37S RIBOSOMAL PROTEIN MRP21, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(252468, NULL, 'PTHR17498', NULL, NULL, NULL, NULL, 'SEMINAL VESICLE SECRETORY PROTEIN 6-RELATED', NULL, NULL, 16084, 8),
(252469, NULL, 'PTHR40616', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252470, NULL, 'PTHR39218', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE 14 KDA SUBUNIT, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G12110)-RELATED', NULL, NULL, NULL, 8),
(252471, NULL, 'PTHR35850', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED', NULL, NULL, 7536, 8),
(252472, NULL, 'PTHR13002', NULL, NULL, NULL, NULL, 'C3ORF1 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(252473, NULL, 'PTHR39867', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252474, NULL, 'PTHR33063', NULL, NULL, NULL, NULL, 'OS02G0583500 PROTEIN', NULL, NULL, NULL, 8),
(252475, NULL, 'PTHR46202', NULL, NULL, NULL, NULL, 'DNA EXCISION REPAIR PROTEIN ERCC-8', NULL, NULL, 33835, 8),
(252476, NULL, 'PTHR32457', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252477, NULL, 'PTHR47398', NULL, NULL, NULL, NULL, 'PROLINE-RICH PROTEIN 3', NULL, NULL, 35848, 8),
(252478, NULL, 'PTHR47838', NULL, NULL, NULL, NULL, '21.7 KDA CLASS VI HEAT SHOCK PROTEIN', NULL, NULL, NULL, 8),
(252479, NULL, 'PTHR34612', NULL, NULL, NULL, NULL, 'GH131_N DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(252480, NULL, 'PTHR36836', NULL, NULL, NULL, NULL, 'COLANIC ACID BIOSYNTHESIS PROTEIN WCAK', NULL, NULL, NULL, 8),
(252481, NULL, 'PTHR36616', NULL, NULL, NULL, NULL, 'BNAC07G32700D PROTEIN', NULL, NULL, NULL, 8),
(252482, NULL, 'PTHR10237', NULL, NULL, NULL, NULL, 'DEFORMED EPIDERMAL AUTOREGULATORY FACTOR 1 HOMOLOG  SUPPRESSIN', NULL, NULL, 12071, 8),
(252483, NULL, 'PTHR46023', NULL, NULL, NULL, NULL, 'LIPASE CLASS 3 PROTEIN-LIKE', NULL, NULL, NULL, 8),
(252484, NULL, 'PTHR16267', NULL, NULL, NULL, NULL, 'BANK1/PIK3AP1 FAMILY MEMBER', NULL, NULL, NULL, 8),
(252485, NULL, 'PTHR44203', NULL, NULL, NULL, NULL, 'ETO1-RELATED', NULL, NULL, 36450, 8),
(252486, NULL, 'PTHR12317', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL O-ACYLTRANSFERASE', NULL, NULL, NULL, 8),
(252487, NULL, 'PTHR35514', NULL, NULL, NULL, NULL, 'THYLAKOID LUMENAL 15.0 KDA PROTEIN 2, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(252488, NULL, 'PTHR36897', NULL, NULL, NULL, NULL, 'OS10G0351100-LIKE PROTEIN', NULL, NULL, NULL, 8),
(252489, NULL, 'PTHR31542', NULL, NULL, NULL, NULL, '39A RIBOSOMAL PROTEIN L50, MITOCHONDRIAL', NULL, NULL, 19862, 8),
(252490, NULL, 'PTHR22884', NULL, NULL, NULL, NULL, 'SET DOMAIN PROTEINS', NULL, NULL, NULL, 8),
(252491, NULL, 'PTHR38505', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC100362176', NULL, NULL, 26500, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(252492, NULL, 'PTHR43009', NULL, NULL, NULL, NULL, 'HOMOGENTISATE SOLANESYLTRANSFERASE, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(252493, NULL, 'PTHR21191', NULL, NULL, NULL, NULL, 'AQUAPORIN', NULL, NULL, NULL, 8),
(252494, NULL, 'PTHR37329', NULL, NULL, NULL, NULL, 'KINETOCHORE PROTEIN SOS7', NULL, NULL, 31857, 8),
(252495, NULL, 'PTHR46596', NULL, NULL, NULL, NULL, 'SORTING NEXIN-4', NULL, NULL, 11282, 8),
(252496, NULL, 'PTHR24183', NULL, NULL, NULL, NULL, 'FIBRONECTIN TYPE 3 AND ANKYRIN REPEAT DOMAINS PROTEIN 1', NULL, NULL, NULL, 8),
(252497, NULL, 'PTHR47575', NULL, NULL, NULL, NULL, 'ADP-RIBOSYLATION FACTOR-LIKE PROTEIN 10', NULL, NULL, 36223, 8),
(252498, NULL, 'PTHR47197', NULL, NULL, NULL, NULL, 'PROTEIN NIRF', NULL, NULL, NULL, 8),
(252499, NULL, 'PTHR34194', NULL, NULL, NULL, NULL, 'F14J8.16 PROTEIN', NULL, NULL, NULL, 8),
(252500, NULL, 'PTHR47173', NULL, NULL, NULL, NULL, 'PROTEIN DR1 HOMOLOG', NULL, NULL, 35290, 8),
(252501, NULL, 'PTHR47121', NULL, NULL, NULL, NULL, 'THYLAKOID LUMENAL PROTEIN TL20.3, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(252502, NULL, 'PTHR31369', NULL, NULL, NULL, NULL, 'PROTEIN CBG02325-RELATED', NULL, NULL, NULL, 8),
(252503, NULL, 'PTHR13020', NULL, NULL, NULL, NULL, 'TRINUCLEOTIDE REPEAT-CONTAINING GENE 6', NULL, NULL, NULL, 8),
(252504, NULL, 'PTHR38371', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN', NULL, NULL, NULL, 8),
(252505, NULL, 'PTHR36174', NULL, NULL, NULL, NULL, 'LIPID II:GLYCINE GLYCYLTRANSFERASE', NULL, NULL, NULL, 8),
(252506, NULL, 'PTHR46535', NULL, NULL, NULL, NULL, 'NEDD4-BINDING PROTEIN 2', NULL, NULL, NULL, 8),
(252507, NULL, 'PTHR37265', NULL, NULL, NULL, NULL, 'OS01G0195300 PROTEIN', NULL, NULL, NULL, 8),
(252508, NULL, 'PTHR47146', NULL, NULL, NULL, NULL, 'OTORAPLIN', NULL, NULL, 34273, 8),
(252509, NULL, 'PTHR33318', NULL, NULL, NULL, NULL, 'ASPARTYL/GLUTAMYL-TRNA(ASN/GLN) AMIDOTRANSFERASE SUBUNIT', NULL, NULL, 27235, 8),
(252510, NULL, 'PTHR17098', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE MWFE SUBUNIT', NULL, NULL, 18190, 8),
(252511, NULL, 'PTHR33713', NULL, NULL, NULL, NULL, 'ANTITOXIN YAFN-RELATED', NULL, NULL, NULL, 8),
(252512, NULL, 'PTHR44170', NULL, NULL, NULL, NULL, 'PROTEIN SIDEKICK', NULL, NULL, NULL, 8),
(252513, NULL, 'PTHR33793', NULL, NULL, NULL, NULL, 'ALPHA-AGGLUTININ', NULL, NULL, 28270, 8),
(252514, NULL, 'PTHR11069', NULL, NULL, NULL, NULL, 'GLUCOSYLCERAMIDASE', NULL, NULL, 1500, 8),
(252515, NULL, 'PTHR38692', NULL, NULL, NULL, NULL, 'PROTEIN SMG', NULL, NULL, NULL, 8),
(252516, NULL, 'PTHR12546', NULL, NULL, NULL, NULL, 'FER-1-LIKE', NULL, NULL, 30468, 8),
(252517, NULL, 'PTHR46468', NULL, NULL, NULL, NULL, 'SENTRIN-SPECIFIC PROTEASE 8', NULL, NULL, 36312, 8),
(252518, NULL, 'PTHR13355', NULL, NULL, NULL, NULL, 'GLUCOSAMINE 6-PHOSPHATE N-ACETYLTRANSFERASE', NULL, NULL, 29276, 8),
(252519, NULL, 'PTHR35684', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252520, NULL, 'PTHR43441', NULL, NULL, NULL, NULL, 'RIBOSOMAL-PROTEIN-SERINE ACETYLTRANSFERASE', NULL, NULL, NULL, 8),
(252521, NULL, 'PTHR32134', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(252522, NULL, 'PTHR14859', NULL, NULL, NULL, NULL, 'CALCOFLUOR WHITE HYPERSENSITIVE PROTEIN PRECURSOR', NULL, NULL, NULL, 8),
(252523, NULL, 'PTHR11509', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN HORMONE ALPHA CHAIN', NULL, NULL, 5533, 8),
(252524, NULL, 'PTHR34211', NULL, NULL, NULL, NULL, 'CALCINEURIN-LIKE METALLO-PHOSPHOESTERASE SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(252525, NULL, 'PTHR46148', NULL, NULL, NULL, NULL, 'CHROMO DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(252526, NULL, 'PTHR43556', NULL, NULL, NULL, NULL, 'PEPTIDE CHAIN RELEASE FACTOR RF3', NULL, NULL, 747, 8),
(252527, NULL, 'PTHR38003', NULL, NULL, NULL, NULL, 'THYMIC STROMAL LYMPHOPOIETIN', NULL, NULL, 21844, 8),
(252528, NULL, 'PTHR32044', NULL, NULL, NULL, NULL, 'GLUCOMANNAN 4-BETA-MANNOSYLTRANSFERASE 9', NULL, NULL, NULL, 8),
(252529, NULL, 'PTHR31876', NULL, NULL, NULL, NULL, 'COV-LIKE PROTEIN 1', NULL, NULL, 4739, 8),
(252530, NULL, 'PTHR11388', NULL, NULL, NULL, NULL, 'ORGANIC ANION TRANSPORTER', NULL, NULL, 2982, 8);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(252531, NULL, 'PTHR36854', NULL, NULL, NULL, NULL, 'CHROMOSOME 9, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(252532, NULL, 'PTHR14390', NULL, NULL, NULL, NULL, 'G PATCH DOMAIN CONTAINING PROTEIN 3', NULL, NULL, 27999, 8),
(252533, NULL, 'PTHR34741', NULL, NULL, NULL, NULL, 'IMAP FAMILY MEMBER 1, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(252534, NULL, 'PTHR23182', NULL, NULL, NULL, NULL, 'BREAKPOINT CLUSTER REGION PROTEIN  BCR', NULL, NULL, 32337, 8),
(252535, NULL, 'PTHR15881', NULL, NULL, NULL, NULL, 'MARGINAL ZONE B- AND B1-CELL-SPECIFIC PROTEIN', NULL, NULL, NULL, 8),
(252536, NULL, 'PTHR23150', NULL, NULL, NULL, NULL, 'SULFATASE MODIFYING FACTOR 1, 2', NULL, NULL, NULL, 8),
(252537, NULL, 'PTHR42887', NULL, NULL, NULL, NULL, 'OS12G0638800 PROTEIN', NULL, NULL, 5055, 8),
(252538, NULL, 'PTHR35326', NULL, NULL, NULL, NULL, 'PROTEIN PSBN', NULL, NULL, 5449, 8),
(252539, NULL, 'PTHR10573', NULL, NULL, NULL, NULL, 'INTERLEUKIN-2 RECEPTOR ALPHA CHAIN', NULL, NULL, 9311, 8),
(252540, NULL, 'PTHR11523', NULL, NULL, NULL, NULL, 'SODIUM/POTASSIUM-DEPENDENT ATPASE BETA SUBUNIT', NULL, NULL, 4711, 8),
(252541, NULL, 'PTHR21077', NULL, NULL, NULL, NULL, 'EME1 PROTEIN', NULL, NULL, 33843, 8),
(252542, NULL, 'PTHR11860', NULL, NULL, NULL, NULL, 'POLYMERIC-IMMUNOGLOBULIN RECEPTOR', NULL, NULL, NULL, 8),
(252543, NULL, 'PTHR46393', NULL, NULL, NULL, NULL, 'SUSHI DOMAIN-CONTAINING PROTEIN', NULL, NULL, 14884, 8),
(252544, NULL, 'PTHR35984', NULL, NULL, NULL, NULL, 'PERIPLASMIC SERINE PROTEASE', NULL, NULL, NULL, 8),
(252545, NULL, 'PTHR10859', NULL, NULL, NULL, NULL, 'GLYCOSYL TRANSFERASE', NULL, NULL, NULL, 8),
(252546, NULL, 'PTHR31734', NULL, NULL, NULL, NULL, 'AUXIN-RESPONSIVE PROTEIN IAA17', NULL, NULL, 3679, 8),
(252547, NULL, 'PTHR13829', NULL, NULL, NULL, NULL, 'SNRNP CORE PROTEIN FAMILY MEMBER', NULL, NULL, 19567, 8),
(252548, NULL, 'PTHR35732', NULL, NULL, NULL, NULL, 'OS10G0545100 PROTEIN', NULL, NULL, NULL, 8),
(252549, NULL, 'PTHR43788', NULL, NULL, NULL, NULL, 'DNA2/NAM7 HELICASE FAMILY MEMBER', NULL, NULL, NULL, 8),
(252550, NULL, 'PTHR13196', NULL, NULL, NULL, NULL, 'DENN DOMAIN-CONTAINING', NULL, NULL, 27044, 8),
(252551, NULL, 'PTHR47806', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L3 GLUTAMINE METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(252552, NULL, 'PTHR22925', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE 43 FAMILY MEMBER', NULL, NULL, NULL, 8),
(252553, NULL, 'PTHR45803', NULL, NULL, NULL, NULL, 'SOX100B', NULL, NULL, NULL, 8),
(252554, NULL, 'PTHR47776', NULL, NULL, NULL, NULL, 'F5A8.9 PROTEIN', NULL, NULL, NULL, 8),
(252555, NULL, 'PTHR15749', NULL, NULL, NULL, NULL, 'FANCONI-ASSOCIATED NUCLEASE 1', NULL, NULL, 31674, 8),
(252556, NULL, 'PTHR33454', NULL, NULL, NULL, NULL, 'PROLAMIN PPROL 14P', NULL, NULL, 4080, 8),
(252557, NULL, 'PTHR11339', NULL, NULL, NULL, NULL, 'EXTRACELLULAR MATRIX GLYCOPROTEIN RELATED', NULL, NULL, NULL, 8),
(252558, NULL, 'PTHR40712', NULL, NULL, NULL, NULL, 'FAMILY WITH SEQUENCE SIMILARITY 153 MEMBER C-RELATED', NULL, NULL, 15581, 8),
(252559, NULL, 'PTHR46329', NULL, NULL, NULL, NULL, 'KILLER CELL LECTIN-LIKE RECEPTOR 2', NULL, NULL, NULL, 8),
(252560, NULL, 'PTHR14167', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-CONTAINING', NULL, NULL, NULL, 8),
(252561, NULL, 'PTHR23032', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 32912, 8),
(252562, NULL, 'PTHR13457', NULL, NULL, NULL, NULL, 'BAP28', NULL, NULL, 28154, 8),
(252563, NULL, 'PTHR13227', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 2A', NULL, NULL, 14547, 8),
(252564, NULL, 'PTHR13923', NULL, NULL, NULL, NULL, 'SEC31-RELATED PROTEIN', NULL, NULL, 27062, 8),
(252565, NULL, 'PTHR35695', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE ACYLTRANSFERASE, CHLOROPLASTIC', NULL, NULL, 17308, 8),
(252566, NULL, 'PTHR24176', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 31-RELATED', NULL, NULL, 35093, 8),
(252567, NULL, 'PTHR37957', NULL, NULL, NULL, NULL, 'BLR7070 PROTEIN', NULL, NULL, NULL, 8),
(252568, NULL, 'PTHR47526', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT DNA HELICASE', NULL, NULL, NULL, 8);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(252569, NULL, 'PTHR12877', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR', NULL, NULL, 27471, 8),
(252570, NULL, 'PTHR11346', NULL, NULL, NULL, NULL, 'GALECTIN', NULL, NULL, 34784, 8),
(252571, NULL, 'PTHR31790', NULL, NULL, NULL, NULL, 'OS02G0783600 PROTEIN', NULL, NULL, NULL, 8),
(252572, NULL, 'PTHR36978', NULL, NULL, NULL, NULL, 'P-LOOP CONTAINING NUCLEOTIDE TRIPHOSPHATE HYDROLASE', NULL, NULL, NULL, 8),
(252573, NULL, 'PTHR47408', NULL, NULL, NULL, NULL, 'PROTEIN CBG01304-RELATED', NULL, NULL, NULL, 8),
(252574, NULL, 'PTHR19818', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN ZIC AND GLI', NULL, NULL, NULL, 8),
(252575, NULL, 'PTHR43067', NULL, NULL, NULL, NULL, 'OLIGOPEPTIDE/DIPEPTIDE ABC TRANSPORTER, ATPASE SUBUNIT', NULL, NULL, NULL, 8),
(252576, NULL, 'PTHR31063', NULL, NULL, NULL, NULL, 'PROTEIN CBG08668', NULL, NULL, NULL, 8),
(252577, NULL, 'PTHR21292', NULL, NULL, NULL, NULL, 'EXOCYST COMPLEX COMPONENT SEC6-RELATED', NULL, NULL, 8974, 8),
(252578, NULL, 'PTHR34779', NULL, NULL, NULL, NULL, 'OS09G0542900 PROTEIN', NULL, NULL, 32417, 8),
(252579, NULL, 'PTHR37475', NULL, NULL, NULL, NULL, 'ZYGOTE-SPECIFIC CLASS V COPY B GENE PROTEIN', NULL, NULL, NULL, 8),
(252580, NULL, 'PTHR31806', NULL, NULL, NULL, NULL, 'PURINE-CYTOSINE PERMEASE FCY2-RELATED', NULL, NULL, 26502, 8),
(252581, NULL, 'PTHR31658', NULL, NULL, NULL, NULL, 'CONSERVED OLIGOMERIC GOLGI COMPLEX SUBUNIT 1', NULL, NULL, 27703, 8),
(252582, NULL, 'PTHR37016', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252583, NULL, 'PTHR47350', NULL, NULL, NULL, NULL, 'PROTEIN IWS1 HOMOLOG 1', NULL, NULL, 34990, 8),
(252584, NULL, 'PTHR13946', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE I,II,III', NULL, NULL, NULL, 8),
(252585, NULL, 'PTHR42754', NULL, NULL, NULL, NULL, 'ENDOGLUCANASE', NULL, NULL, NULL, 8),
(252586, NULL, 'PTHR12226', NULL, NULL, NULL, NULL, 'MANNOSE-P-DOLICHOL UTILIZATION DEFECT 1  LEC35 -RELATED', NULL, NULL, 15455, 8),
(252587, NULL, 'PTHR20921', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 12289, 8),
(252588, NULL, 'PTHR11088', NULL, NULL, NULL, NULL, 'TRNA DIMETHYLALLYLTRANSFERASE', NULL, NULL, 28115, 8),
(252589, NULL, 'PTHR47362', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A THIOESTERASE THEM5', NULL, NULL, NULL, 8),
(252590, NULL, 'PTHR23057', NULL, NULL, NULL, NULL, 'JUXTAPOSED WITH ANOTHER ZINC FINGER PROTEIN 1', NULL, NULL, NULL, 8),
(252591, NULL, 'PTHR24348', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE UNC-51-RELATED', NULL, NULL, 36081, 8),
(252592, NULL, 'PTHR45088', NULL, NULL, NULL, NULL, 'OSJNBA0022H21.17 PROTEIN', NULL, NULL, NULL, 8),
(252593, NULL, 'PTHR36414', NULL, NULL, NULL, NULL, 'PROTEIN SUR7', NULL, NULL, NULL, 8),
(252594, NULL, 'PTHR46738', NULL, NULL, NULL, NULL, 'UBIQUITIN-ASSOCIATED DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(252595, NULL, 'PTHR33677', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REPRESSOR FRMR-RELATED', NULL, NULL, 2043, 8),
(252596, NULL, 'PTHR47765', NULL, NULL, NULL, NULL, '3''-5'' EXONUCLEASE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(252597, NULL, 'PTHR11140', NULL, NULL, NULL, NULL, 'PRE-MRNA SPLICING FACTOR PRP8', NULL, NULL, 26301, 8),
(252598, NULL, 'PTHR48145', NULL, NULL, NULL, NULL, 'NUCLEAR ENVELOPE-ASSOCIATED PROTEIN 1', NULL, NULL, NULL, 8),
(252599, NULL, 'PTHR46829', NULL, NULL, NULL, NULL, 'STERILE ALPHA MOTIF DOMAIN-CONTAINING PROTEIN 15', NULL, NULL, NULL, 8),
(252600, NULL, 'PTHR42206', NULL, NULL, NULL, NULL, 'METAL-DEPENDENT HYDROLASE-RELATED', NULL, NULL, 11045, 8),
(252601, NULL, 'PTHR38446', NULL, NULL, NULL, NULL, 'BLL0914 PROTEIN', NULL, NULL, 12461, 8),
(252602, NULL, 'PTHR43070', NULL, NULL, NULL, NULL, '', NULL, NULL, 10436, 8),
(252603, NULL, 'PTHR31376', NULL, NULL, NULL, NULL, 'OS09G0467300 PROTEIN-RELATED', NULL, NULL, 23828, 8),
(252604, NULL, 'PTHR35307', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(252605, NULL, 'PTHR10870', NULL, NULL, NULL, NULL, 'CELL CYCLE CHECKPOINT PROTEIN RAD1', NULL, NULL, 141, 8),
(252606, NULL, 'PTHR22461', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 23860, 8);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(252607, NULL, 'PTHR36528', NULL, NULL, NULL, NULL, 'CRISPR SYSTEM SINGLE-STRAND-SPECIFIC DEOXYRIBONUCLEASE CAS10/CSM1 (SUBTYPE III-A)', NULL, NULL, NULL, 8),
(252608, NULL, 'PTHR13238', NULL, NULL, NULL, NULL, 'PROTEIN C21ORF59', NULL, NULL, 17512, 8),
(252609, NULL, 'PTHR14327', NULL, NULL, NULL, NULL, 'CATION CHANNEL SPERM-ASSOCIATED PROTEIN SUBUNIT GAMMA', NULL, NULL, 21770, 8),
(252610, NULL, 'PTHR40070', NULL, NULL, NULL, NULL, 'UPF0478 PROTEIN YTXG', NULL, NULL, NULL, 8),
(252611, NULL, 'PTHR11040', NULL, NULL, NULL, NULL, 'ZINC/IRON TRANSPORTER', NULL, NULL, NULL, 8),
(252612, NULL, 'PTHR35040', NULL, NULL, NULL, NULL, '', NULL, NULL, 20207, 8),
(252613, NULL, 'PTHR15503', NULL, NULL, NULL, NULL, 'LDOC1 RELATED', NULL, NULL, 21685, 8),
(252614, NULL, 'PTHR10269', NULL, NULL, NULL, NULL, 'GDNF RECEPTOR ALPHA', NULL, NULL, 5387, 8),
(252615, NULL, 'PTHR38491', NULL, NULL, NULL, NULL, 'REGULATOR OF HEMOGLOBINIZATION AND ERYTHROID CELL EXPANSION PROTEIN', NULL, NULL, 26907, 8),
(252616, NULL, 'PTHR47150', NULL, NULL, NULL, NULL, 'OS12G0169200 PROTEIN', NULL, NULL, NULL, 8),
(252617, NULL, 'PTHR47415', NULL, NULL, NULL, NULL, 'PROTEIN FAM47B', NULL, NULL, NULL, 8),
(252618, NULL, 'PTHR15486', NULL, NULL, NULL, NULL, 'ANCIENT UBIQUITOUS PROTEIN', NULL, NULL, NULL, 8),
(252619, NULL, 'PTHR47234', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252620, NULL, 'PTHR43661', NULL, NULL, NULL, NULL, 'D-XYLONATE DEHYDRATASE', NULL, NULL, NULL, 8),
(252621, NULL, 'PTHR17608', NULL, NULL, NULL, NULL, 'GENETIC SUPPRESSOR ELEMENT 1', NULL, NULL, 36394, 8),
(252622, NULL, 'PTHR34876', NULL, NULL, NULL, NULL, '', NULL, NULL, 19678, 8),
(252623, NULL, 'PTHR43035', NULL, NULL, NULL, NULL, 'FATTY ACID REPRESSION MUTANT PROTEIN 2-RELATED', NULL, NULL, 30881, 8),
(252624, NULL, 'PTHR22920', NULL, NULL, NULL, NULL, 'MAJOR SPERM PROTEIN', NULL, NULL, NULL, 8),
(252625, NULL, 'PTHR34964', NULL, NULL, NULL, NULL, 'MEMBRANE LIPOPROTEIN-RELATED', NULL, NULL, NULL, 8),
(252626, NULL, 'PTHR16288', NULL, NULL, NULL, NULL, 'WD40 REPEAT PROTEIN 4', NULL, NULL, 25369, 8),
(252627, NULL, 'PTHR31266', NULL, NULL, NULL, NULL, 'TRAF-INTERACTING PROTEIN WITH FHA DOMAIN-CONTAINING PROTEIN A FAMILY MEMBER', NULL, NULL, 31475, 8),
(252628, NULL, 'PTHR34932', NULL, NULL, NULL, NULL, 'TRPL TRANSLOCATION DEFECT PROTEIN 14', NULL, NULL, NULL, 8),
(252629, NULL, 'PTHR36851', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', NULL, NULL, NULL, 8),
(252630, NULL, 'PTHR31161', NULL, NULL, NULL, NULL, 'PROTEIN GRAVITROPIC IN THE LIGHT 1', NULL, NULL, 31076, 8),
(252631, NULL, 'PTHR33288', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252632, NULL, 'PTHR31533', NULL, NULL, NULL, NULL, 'GPI-ANCHORED PROTEIN LLG1-RELATED-RELATED', NULL, NULL, 27160, 8),
(252633, NULL, 'PTHR20765', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 43 MEMBER 3-RELATED', NULL, NULL, 22387, 8),
(252634, NULL, 'PTHR10788', NULL, NULL, NULL, NULL, 'TREHALOSE-6-PHOSPHATE SYNTHASE', NULL, NULL, 4078, 8),
(252635, NULL, 'PTHR34351', NULL, NULL, NULL, NULL, 'SLR1927 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(252636, NULL, 'PTHR45621', NULL, NULL, NULL, NULL, 'OS01G0588500 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(252637, NULL, 'PTHR22744', NULL, NULL, NULL, NULL, 'HELIX LOOP HELIX PROTEIN 21-RELATED', NULL, NULL, NULL, 8),
(252638, NULL, 'PTHR43705', NULL, NULL, NULL, NULL, 'HYDROXYACYLGLUTATHIONE HYDROLASE', NULL, NULL, NULL, 8),
(252639, NULL, 'PTHR45858', NULL, NULL, NULL, NULL, 'FERM DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(252640, NULL, 'PTHR36730', NULL, NULL, NULL, NULL, 'OS03G0210700 PROTEIN', NULL, NULL, NULL, 8),
(252641, NULL, 'PTHR14162', NULL, NULL, NULL, NULL, 'MUCOSAL ADDRESSIN CELL ADHESION MOLECULE-1', NULL, NULL, 29670, 8),
(252642, NULL, 'PTHR47699', NULL, NULL, NULL, NULL, 'SNARE ASSOCIATED GOLGI PROTEIN FAMILY', NULL, NULL, NULL, 8),
(252643, NULL, 'PTHR14409', NULL, NULL, NULL, NULL, 'MANNOSIDASE, BETA A, LYSOSOMAL-LIKE, MANBAL PROTEIN', NULL, NULL, 1959, 8),
(252644, NULL, 'PTHR35015', NULL, NULL, NULL, NULL, 'PROTEIN CBR-OSM-7-RELATED', NULL, NULL, NULL, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(252645, NULL, 'PTHR11669', NULL, NULL, NULL, NULL, 'REPLICATION FACTOR C / DNA POLYMERASE III GAMMA-TAU SUBUNIT', NULL, NULL, NULL, 8),
(252646, NULL, 'PTHR21663', NULL, NULL, NULL, NULL, 'HYPOTHETICAL HEAT DOMAIN-CONTAINING', NULL, NULL, 31679, 8),
(252647, NULL, 'PTHR12234', NULL, NULL, NULL, NULL, 'FORMIMINOTRANSFERASE-CYCLODEAMINASE', NULL, NULL, NULL, 8),
(252648, NULL, 'PTHR24138', NULL, NULL, NULL, NULL, 'INTRACELLLAR PHOSPHOLIPASE A FAMILY', NULL, NULL, NULL, 8),
(252649, NULL, 'PTHR42957', NULL, NULL, NULL, NULL, 'HELICASE MJ1565-RELATED', NULL, NULL, NULL, 8),
(252650, NULL, 'PTHR47088', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS W', NULL, NULL, NULL, 8),
(252651, NULL, 'PTHR37439', NULL, NULL, NULL, NULL, 'PROTEIN CBG25991-RELATED', NULL, NULL, NULL, 8),
(252652, NULL, 'PTHR47242', NULL, NULL, NULL, NULL, 'TRAF-LIKE FAMILY PROTEIN', NULL, NULL, NULL, 8),
(252653, NULL, 'PTHR24141', NULL, NULL, NULL, NULL, '2-5A-DEPENDENT RIBONUCLEASE', NULL, NULL, NULL, 8),
(252654, NULL, 'PTHR30041', NULL, NULL, NULL, NULL, 'ARSENATE REDUCTASE', NULL, NULL, 1555, 8),
(252655, NULL, 'PTHR23538', NULL, NULL, NULL, NULL, '44.5 KD BACTERIOCHLOROPHYLL SYNTHASE SUBUNIT', NULL, NULL, 23212, 8),
(252656, NULL, 'PTHR24044', NULL, NULL, NULL, NULL, 'NOTCH LIGAND FAMILY MEMBER', NULL, NULL, NULL, 8),
(252657, NULL, 'PTHR48127', NULL, NULL, NULL, NULL, 'GRF-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(252658, NULL, 'PTHR20544', NULL, NULL, NULL, NULL, 'CENTROSOMAL PROTEIN CEP135', NULL, NULL, NULL, 8),
(252659, NULL, 'PTHR43476', NULL, NULL, NULL, NULL, '3-(3-HYDROXY-PHENYL)PROPIONATE/3-HYDROXYCINNAMIC ACID HYDROXYLASE', NULL, NULL, NULL, 8),
(252660, NULL, 'PTHR34191', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT PROTEIN (LEA) FAMILY PROTEIN', NULL, NULL, 27261, 8),
(252661, NULL, 'PTHR21759', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(252662, NULL, 'PTHR10927', NULL, NULL, NULL, NULL, 'RIBOSOME MATURATION PROTEIN SBDS', NULL, NULL, 27725, 8),
(252663, NULL, 'PTHR15911', NULL, NULL, NULL, NULL, 'WW DOMAIN-CONTAINING ADAPTER PROTEIN WITH COILED-COIL', NULL, NULL, 31684, 8),
(252664, NULL, 'PTHR46439', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH MOTOR NEURON 1 PROTEIN', NULL, NULL, NULL, 8),
(252665, NULL, 'PTHR45926', NULL, NULL, NULL, NULL, 'OSJNBA0053K19.4 PROTEIN', NULL, NULL, NULL, 8),
(252666, NULL, 'PTHR33841', NULL, NULL, NULL, NULL, 'DNA METHYLTRANSFERASE YEEA-RELATED', NULL, NULL, NULL, 8),
(252667, NULL, 'PTHR14066', NULL, NULL, NULL, NULL, 'ATRIAL NATRIURETIC FACTOR PRECURSOR', NULL, NULL, NULL, 8),
(252668, NULL, 'PTHR13252', NULL, NULL, NULL, NULL, 'F-BOX ONLY PROTEIN 28', NULL, NULL, 30021, 8),
(252669, NULL, 'PTHR10241', NULL, NULL, NULL, NULL, 'LETHAL 2  GIANT LARVAE PROTEIN', NULL, NULL, NULL, 8),
(252670, NULL, 'PTHR34072', NULL, NULL, NULL, NULL, 'ENZYMATIC POLYPROTEIN-RELATED', NULL, NULL, NULL, 8),
(252671, NULL, 'PTHR43952', NULL, NULL, NULL, NULL, 'MYB FAMILY TRANSCRIPTION FACTOR-RELATED', NULL, NULL, 36390, 8),
(252672, NULL, 'PTHR16160', NULL, NULL, NULL, NULL, 'FERMITIN 2-RELATED', NULL, NULL, 30724, 8),
(252673, NULL, 'PTHR33257', NULL, NULL, NULL, NULL, 'OS05G0165500 PROTEIN', NULL, NULL, NULL, 8),
(252674, NULL, 'PTHR23291', NULL, NULL, NULL, NULL, 'BAX INHIBITOR-RELATED', NULL, NULL, 11199, 8),
(252675, NULL, 'PTHR14095', NULL, NULL, NULL, NULL, 'PHOSPHATASE 2A REGULATORY SUBUNIT-RELATED', NULL, NULL, NULL, 8),
(252676, NULL, 'PTHR35361', NULL, NULL, NULL, NULL, 'OS08G0443700 PROTEIN', NULL, NULL, NULL, 8),
(252677, NULL, 'PTHR14927', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 29351, 8),
(252678, NULL, 'PTHR43278', NULL, NULL, NULL, NULL, 'NAD(P)H-DEPENDENT FMN-CONTAINING OXIDOREDUCTASE YWQN-RELATED', NULL, NULL, NULL, 8),
(252679, NULL, 'PTHR15605', NULL, NULL, NULL, NULL, 'KINESIN-ASSOCIATED PROTEINS', NULL, NULL, 12849, 8),
(252680, NULL, 'PTHR33444', NULL, NULL, NULL, NULL, 'SI:DKEY-19B23.12-RELATED', NULL, NULL, 27343, 8),
(252681, NULL, 'PTHR31327', NULL, NULL, NULL, NULL, 'SPERM MEIOSIS PDZ DOMAIN CONTAINING PROTEINS-RELATED', NULL, NULL, 27600, 8); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(252682, NULL, 'PTHR35329', NULL, NULL, NULL, NULL, 'CHITIN SYNTHASE EXPORT CHAPERONE', NULL, NULL, 20612, 8),
(252683, NULL, 'PTHR13693', NULL, NULL, NULL, NULL, 'CLASS II AMINOTRANSFERASE/8-AMINO-7-OXONONANOATE SYNTHASE', NULL, NULL, NULL, 8),
(252684, NULL, 'PTHR44533', NULL, NULL, NULL, NULL, 'DEAD/H RNA HELICASE, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(252685, NULL, 'PTHR15829', NULL, NULL, NULL, NULL, 'PROTEIN KINASE PKN/PRK1, EFFECTOR', NULL, NULL, 24799, 8),
(252686, NULL, 'PTHR33627', NULL, NULL, NULL, NULL, 'TRANSPOSASE', NULL, NULL, 33050, 8),
(252687, NULL, 'PTHR15599', NULL, NULL, NULL, NULL, 'RTDR1', NULL, NULL, NULL, 8),
(252688, NULL, 'PTHR22760', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', NULL, NULL, 2796, 8),
(252689, NULL, 'PTHR32222', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN U', NULL, NULL, NULL, 8),
(252690, NULL, 'PTHR31841', NULL, NULL, NULL, NULL, 'PROTEIN FAM72A-RELATED', NULL, NULL, 24340, 8),
(252691, NULL, 'PTHR36837', NULL, NULL, NULL, NULL, 'POLY(3-HYDROXYALKANOATE) POLYMERASE SUBUNIT PHAC', NULL, NULL, NULL, 8),
(252692, NULL, 'PTHR38364', NULL, NULL, NULL, NULL, 'OSJNBA0022H21.9 PROTEIN', NULL, NULL, NULL, 8),
(252693, NULL, 'PTHR30250', NULL, NULL, NULL, NULL, 'PST FAMILY PREDICTED COLANIC ACID TRANSPORTER', NULL, NULL, NULL, 8),
(252694, NULL, 'PTHR23306', NULL, NULL, NULL, NULL, 'TUMOR SUSCEPTIBILITY GENE 101 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(252695, NULL, 'PTHR10031', NULL, NULL, NULL, NULL, 'ATP SYNTHASE LIPID-BINDING PROTEIN, MITOCHONDRIAL', NULL, NULL, 6579, 8),
(252696, NULL, 'PTHR23414', NULL, NULL, NULL, NULL, 'ADRENOMEDULLIN, ADM', NULL, NULL, NULL, 8),
(252697, NULL, 'PTHR35844', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252698, NULL, 'PTHR13813', NULL, NULL, NULL, NULL, 'GLYCOPHORIN', NULL, NULL, 1317, 8),
(252699, NULL, 'PTHR34322', NULL, NULL, NULL, NULL, 'TRANSPOSASE, Y1_TNP DOMAIN-CONTAINING', NULL, NULL, NULL, 8),
(252700, NULL, 'PTHR15000', NULL, NULL, NULL, NULL, 'ERYTHROID DIFFERENTIATION-RELATED FACTOR 1', NULL, NULL, NULL, 8),
(252701, NULL, 'PTHR12114', NULL, NULL, NULL, NULL, 'PARVIN', NULL, NULL, 26785, 8),
(252702, NULL, 'PTHR34759', NULL, NULL, NULL, NULL, 'SPERMATOGENESIS-ASSOCIATED PROTEIN 48', NULL, NULL, 23572, 8),
(252703, NULL, 'PTHR21736', NULL, NULL, NULL, NULL, 'VERNALIZATION-INSENSITIVE PROTEIN 3', NULL, NULL, 1929, 8),
(252704, NULL, 'PTHR14047', NULL, NULL, NULL, NULL, 'P ANTIGEN FAMILY MEMBER 5-RELATED', NULL, NULL, 14240, 8),
(252705, NULL, 'PTHR36732', NULL, NULL, NULL, NULL, 'GLYCINE RICH PROTEIN 9-RELATED', NULL, NULL, NULL, 8),
(252706, NULL, 'PTHR43773', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER MGTE', NULL, NULL, 1848, 8),
(252707, NULL, 'PTHR24399', NULL, NULL, NULL, NULL, 'ZINC FINGER AND BTB DOMAIN-CONTAINING', NULL, NULL, NULL, 8),
(252708, NULL, 'PTHR15404', NULL, NULL, NULL, NULL, 'PROTEIN AF1Q', NULL, NULL, 25734, 8),
(252709, NULL, 'PTHR27001', NULL, NULL, NULL, NULL, 'OS01G0253100 PROTEIN', NULL, NULL, 37226, 8),
(252710, NULL, 'PTHR43195', NULL, NULL, NULL, NULL, 'TRANSKETOLASE', NULL, NULL, NULL, 8),
(252711, NULL, 'PTHR43002', NULL, NULL, NULL, NULL, 'GLYCOGEN DEBRANCHING ENZYME', NULL, NULL, NULL, 8),
(252712, NULL, 'PTHR45911', NULL, NULL, NULL, NULL, 'C2 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(252713, NULL, 'PTHR12213', NULL, NULL, NULL, NULL, 'CORRINOID ADENOSYLTRANSFERASE', NULL, NULL, 26821, 8),
(252714, NULL, 'PTHR39232', NULL, NULL, NULL, NULL, 'TESTIS-EXPRESSED PROTEIN 50', NULL, NULL, 30699, 8),
(252715, NULL, 'PTHR33508', NULL, NULL, NULL, NULL, 'UPF0056 MEMBRANE PROTEIN YHCE', NULL, NULL, 4895, 8),
(252716, NULL, 'PTHR39967', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252717, NULL, 'PTHR21504', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 31084, 8),
(252718, NULL, 'PTHR34348', NULL, NULL, NULL, NULL, 'SURFEIT LOCUS PROTEIN 2', NULL, NULL, NULL, 8),
(252719, NULL, 'PTHR37487', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(252720, NULL, 'PTHR44500', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 12', NULL, NULL, 25938, 8);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(252721, NULL, 'PTHR13844', NULL, NULL, NULL, NULL, 'SWI/SNF-RELATED MATRIX-ASSOCIATED ACTIN-DEPENDENT REGULATOR OF CHROMATIN SUBFAMILY D', NULL, NULL, NULL, 8),
(252722, NULL, 'PTHR19269', NULL, NULL, NULL, NULL, 'TROPOMYOSIN', NULL, NULL, NULL, 8),
(252723, NULL, 'PTHR28641', NULL, NULL, NULL, NULL, '', NULL, NULL, 27434, 8),
(252724, NULL, 'PTHR15398', NULL, NULL, NULL, NULL, 'BROMODOMAIN-CONTAINING PROTEIN 8', NULL, NULL, NULL, 8),
(252725, NULL, 'PTHR31958', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 127', NULL, NULL, 10554, 8),
(252726, NULL, 'PTHR18952', NULL, NULL, NULL, NULL, 'CARBONIC ANHYDRASE', NULL, NULL, 16442, 8),
(252727, NULL, 'PTHR35516', NULL, NULL, NULL, NULL, 'CYTOCHROME B6-F COMPLEX SUBUNIT 5', NULL, NULL, 1800, 8),
(252728, NULL, 'PTHR34375', NULL, NULL, NULL, NULL, 'GATA ZINC FINGER PROTEIN-RELATED', NULL, NULL, NULL, 8),
(252729, NULL, 'PTHR16502', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 31189, 8),
(252730, NULL, 'PTHR12790', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR IA  RRN3', NULL, NULL, 4096, 8),
(252731, NULL, 'PTHR43860', NULL, NULL, NULL, NULL, 'BETAINE ALDEHYDE DEHYDROGENASE', NULL, NULL, NULL, 8),
(252732, NULL, 'PTHR10668', NULL, NULL, NULL, NULL, 'PHYTOENE DEHYDROGENASE', NULL, NULL, NULL, 8),
(252733, NULL, 'PTHR33064', NULL, NULL, NULL, NULL, 'POL PROTEIN', NULL, NULL, NULL, 8),
(252734, NULL, 'PTHR16110', NULL, NULL, NULL, NULL, 'TBC1 DOMAIN FAMILY MEMBER 19', NULL, NULL, 36975, 8),
(252735, NULL, 'PTHR12718', NULL, NULL, NULL, NULL, 'CELL CYCLE CONTROL PROTEIN CWF15', NULL, NULL, 5966, 8),
(252736, NULL, 'PTHR13288', NULL, NULL, NULL, NULL, 'SPLICING FACTOR 45 SPF45', NULL, NULL, 31390, 8),
(252737, NULL, 'PTHR22145', NULL, NULL, NULL, NULL, 'SI:CH211-266K22.6', NULL, NULL, 26356, 8),
(252738, NULL, 'PTHR47201', NULL, NULL, NULL, NULL, 'BNAC09G30780D PROTEIN', NULL, NULL, 33961, 8),
(252739, NULL, 'PTHR22715', NULL, NULL, NULL, NULL, 'TRANSFORMING GROWTH FACTOR BETA REGULATED GENE 1', NULL, NULL, 31810, 8),
(252740, NULL, 'PTHR33962', NULL, NULL, NULL, NULL, 'RECQ-MEDIATED GENOME INSTABILITY PROTEIN 2 RMI2', NULL, NULL, 23241, 8),
(252741, NULL, 'PTHR35274', NULL, NULL, NULL, NULL, 'E6-LIKE PROTEIN', NULL, NULL, 27158, 8),
(252742, NULL, 'PTHR31757', NULL, NULL, NULL, NULL, 'SLL0781 PROTEIN', NULL, NULL, 13291, 8),
(252743, NULL, 'PTHR31965', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 42', NULL, NULL, 27316, 8),
(252744, NULL, 'PTHR34371', NULL, NULL, NULL, NULL, 'OS01G0551000 PROTEIN', NULL, NULL, NULL, 8),
(252745, NULL, 'PTHR35020', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINE-INDUCED PROTEIN 1', NULL, NULL, 20226, 8),
(252746, NULL, 'PTHR46514', NULL, NULL, NULL, NULL, 'AMPHIPHYSIN', NULL, NULL, NULL, 8),
(252747, NULL, 'PTHR35552', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 8', NULL, NULL, 32489, 8),
(252748, NULL, 'PTHR18921', NULL, NULL, NULL, NULL, 'MYOSIN HEAVY CHAIN - RELATED', NULL, NULL, NULL, 8),
(252749, NULL, 'PTHR12907', NULL, NULL, NULL, NULL, 'EGL NINE HOMOLOG-RELATED', NULL, NULL, NULL, 8),
(252750, NULL, 'PTHR34805', NULL, NULL, NULL, NULL, 'PROTEIN MODIFIER OF SNC1 1', NULL, NULL, 32098, 8),
(252751, NULL, 'PTHR36682', NULL, NULL, NULL, NULL, 'RAB15 EFFECTOR PROTEIN', NULL, NULL, 25061, 8),
(252752, NULL, 'PTHR46330', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 10B', NULL, NULL, NULL, 8),
(252753, NULL, 'PTHR31317', NULL, NULL, NULL, NULL, 'OS08G0163500 PROTEIN', NULL, NULL, 9107, 8),
(252754, NULL, 'PTHR35180', NULL, NULL, NULL, NULL, 'PROTEIN CBG06219', NULL, NULL, NULL, 8),
(252755, NULL, 'PTHR31201', NULL, NULL, NULL, NULL, 'OS01G0585100 PROTEIN', NULL, NULL, 17545, 8),
(252756, NULL, 'PTHR31928', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, 8951, 8),
(252757, NULL, 'PTHR10253', NULL, NULL, NULL, NULL, 'POLYCOMB PROTEIN', NULL, NULL, NULL, 8),
(252758, NULL, 'PTHR13141', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 242', NULL, NULL, 13064, 8),
(252759, NULL, 'PTHR36709', NULL, NULL, NULL, NULL, 'OS02G0604100 PROTEIN', NULL, NULL, NULL, 8);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(252760, NULL, 'PTHR36794', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(252761, NULL, 'PTHR35305', NULL, NULL, NULL, NULL, 'FAD-BINDING PROTEIN', NULL, NULL, NULL, 8),
(252762, NULL, 'PTHR36175', NULL, NULL, NULL, NULL, 'CYANOPHYCINASE', NULL, NULL, NULL, 8),
(252763, NULL, 'PTHR46608', NULL, NULL, NULL, NULL, 'T-CELL IMMUNOGLOBULIN AND MUCIN DOMAIN-CONTAINING PROTEIN 4', NULL, NULL, NULL, 8),
(252764, NULL, 'PTHR12547', NULL, NULL, NULL, NULL, 'CCCH ZINC FINGER/TIS11-RELATED', NULL, NULL, 36295, 8),
(252765, NULL, 'PTHR37290', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN YIAA-RELATED', NULL, NULL, 29660, 8),
(252766, NULL, 'PTHR41161', NULL, NULL, NULL, NULL, 'PROTEIN NCBP2AS2', NULL, NULL, 36997, 8),
(252767, NULL, 'PTHR28604', NULL, NULL, NULL, NULL, '', NULL, NULL, 27213, 8),
(252768, NULL, 'PTHR34409', NULL, NULL, NULL, NULL, 'SET DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(252769, NULL, 'PTHR46224', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT FAMILY PROTEIN', NULL, NULL, NULL, 8),
(252770, NULL, 'PTHR28204', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL DISTRIBUTION AND MORPHOLOGY PROTEIN 12', NULL, NULL, 25465, 8),
(252771, NULL, 'PTHR31548', NULL, NULL, NULL, NULL, 'CLARIN', NULL, NULL, 25683, 8),
(252772, NULL, 'PTHR23401', NULL, NULL, NULL, NULL, 'CYCLIN DEPENDANT KINASE-5 ACTIVATOR', NULL, NULL, 1653, 8),
(252773, NULL, 'PTHR43416', NULL, NULL, NULL, NULL, 'DIHYDROLIPOYLLYSINE-RESIDUE SUCCINYLTRANSFERASE COMPONENT OF 2-OXOGLUTARATE DEHYDROGENASE COMPLEX, MITOCHONDRIAL-RELATED', NULL, NULL, NULL, 8),
(252774, NULL, 'PTHR43470', NULL, NULL, NULL, NULL, 'PHOSPHATE TRANSPORT SYSTEM PERMEASE PROTEIN PSTA-RELATED', NULL, NULL, NULL, 8),
(252775, NULL, 'PTHR22812', NULL, NULL, NULL, NULL, 'CHROMOBOX PROTEIN', NULL, NULL, NULL, 8),
(252776, NULL, 'PTHR31786', NULL, NULL, NULL, NULL, 'FANCONI ANEMIA CORE COMPLEX-ASSOCIATED PROTEIN 24', NULL, NULL, 23129, 8),
(252777, NULL, 'PTHR37356', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 239', NULL, NULL, 26307, 8),
(252778, NULL, 'PTHR48099', NULL, NULL, NULL, NULL, 'C-1-TETRAHYDROFOLATE SYNTHASE, CYTOPLASMIC-RELATED', NULL, NULL, NULL, 8),
(252779, NULL, 'PTHR47458', NULL, NULL, NULL, NULL, 'SMAD/FHA DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(252780, NULL, 'PTHR46154', NULL, NULL, NULL, NULL, '', NULL, NULL, 25095, 8),
(252781, NULL, 'PTHR33492', NULL, NULL, NULL, NULL, 'OSJNBA0043A12.37 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(252782, NULL, 'PTHR45895', NULL, NULL, NULL, NULL, 'INTEGRASE CATALYTIC DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(252783, NULL, 'PTHR34697', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLGLYCEROL LYSYLTRANSFERASE', NULL, NULL, NULL, 8),
(252784, NULL, 'PTHR12824', NULL, NULL, NULL, NULL, 'GROUP XII SECRETORY PHOSPHOLIPASE A2 FAMILY MEMBER', NULL, NULL, 9752, 8),
(252785, NULL, 'PTHR30087', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(252786, NULL, 'PTHR36045', NULL, NULL, NULL, NULL, 'OS04G0558500 PROTEIN', NULL, NULL, NULL, 8),
(252787, NULL, 'PTHR16089', NULL, NULL, NULL, NULL, 'REST COREPRESSOR  COREST  PROTEIN-RELATED', NULL, NULL, NULL, 8),
(252788, NULL, 'PTHR34117', NULL, NULL, NULL, NULL, 'STYLE CELL-CYCLE INHIBITOR 1', NULL, NULL, 34914, 8),
(252789, NULL, 'PTHR40131', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252790, NULL, 'PTHR24007', NULL, NULL, NULL, NULL, 'BRCA1-ASSOCIATED PROTEIN', NULL, NULL, NULL, 8),
(252791, NULL, 'PTHR34146', NULL, NULL, NULL, NULL, 'POLYNUCLEOTIDYL TRANSFERASE, RIBONUCLEASE H-LIKE SUPERFAMILY PROTEIN-RELATED', NULL, NULL, NULL, 8),
(252792, NULL, 'PTHR47006', NULL, NULL, NULL, NULL, 'STAR-RELATED LIPID TRANSFER PROTEIN 4', NULL, NULL, 35292, 8),
(252793, NULL, 'PTHR45922', NULL, NULL, NULL, NULL, 'CLEAVAGE AND POLYADENYLATION SPECIFICITY FACTOR SUBUNIT 2', NULL, NULL, 25761, 8),
(252794, NULL, 'PTHR15264', NULL, NULL, NULL, NULL, 'PROGRAMMED CELL DEATH PROTEIN 1', NULL, NULL, 36632, 8),
(252795, NULL, 'PTHR14693', NULL, NULL, NULL, NULL, 'RIKEN CDNA 1700018B08', NULL, NULL, 23448, 8),
(252796, NULL, 'PTHR10492', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(252797, NULL, 'PTHR47307', NULL, NULL, NULL, NULL, 'GLUTATHIONE-REGULATED POTASSIUM-EFFLUX SYSTEM ANCILLARY PROTEIN KEFG', NULL, NULL, NULL, 8),
(252798, NULL, 'PTHR11430', NULL, NULL, NULL, NULL, 'LIPOCALIN', NULL, NULL, 6057, 8),
(252799, NULL, 'PTHR19302', NULL, NULL, NULL, NULL, 'GAMMA TUBULIN COMPLEX PROTEIN', NULL, NULL, 6505, 8),
(252800, NULL, 'PTHR21540', NULL, NULL, NULL, NULL, 'RING FINGER AND SWIM DOMAIN-CONTAINING PROTEIN 2', NULL, NULL, 31220, 8),
(252801, NULL, 'PTHR35073', NULL, NULL, NULL, NULL, 'OTOSPIRALIN', NULL, NULL, 22689, 8),
(252802, NULL, 'PTHR15574', NULL, NULL, NULL, NULL, 'WD REPEAT DOMAIN-CONTAINING FAMILY', NULL, NULL, 36711, 8),
(252803, NULL, 'PTHR38568', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252804, NULL, 'PTHR36388', NULL, NULL, NULL, NULL, 'OS02G0469000 PROTEIN', NULL, NULL, NULL, 8),
(252805, NULL, 'PTHR10153', NULL, NULL, NULL, NULL, 'SMALL CONDUCTANCE CALCIUM-ACTIVATED POTASSIUM CHANNEL', NULL, NULL, 8648, 8),
(252806, NULL, 'PTHR31416', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 125', NULL, NULL, 23858, 8),
(252807, NULL, 'PTHR10984', NULL, NULL, NULL, NULL, 'ENDOPLASMIC RETICULUM-GOLGI INTERMEDIATE COMPARTMENT PROTEIN', NULL, NULL, 36379, 8),
(252808, NULL, 'PTHR35250', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 4', NULL, NULL, 21730, 8),
(252809, NULL, 'PTHR39069', NULL, NULL, NULL, NULL, 'ECDYSONE-INDUCIBLE GENE E1, ISOFORM A', NULL, NULL, NULL, 8),
(252810, NULL, 'PTHR46589', NULL, NULL, NULL, NULL, 'APOPTOTIC CHROMATIN CONDENSATION INDUCER IN THE NUCLEUS', NULL, NULL, NULL, 8),
(252811, NULL, 'PTHR45904', NULL, NULL, NULL, NULL, 'TRNA (URACIL-5-)-METHYLTRANSFERASE', NULL, NULL, 37106, 8),
(252812, NULL, 'PTHR15954', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 11871, 8),
(252813, NULL, 'PTHR39401', NULL, NULL, NULL, NULL, 'SNOAL-LIKE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(252814, NULL, 'PTHR15451', NULL, NULL, NULL, NULL, 'ERGOSTEROL BIOSYNTHETIC PROTEIN 28-RELATED', NULL, NULL, 6261, 8),
(252815, NULL, 'PTHR31576', NULL, NULL, NULL, NULL, 'TATA BOX-BINDING PROTEIN-ASSOCIATED FACTOR RNA POLYMERASE I SUBUNIT B', NULL, NULL, 29509, 8),
(252816, NULL, 'PTHR35041', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 1', NULL, NULL, NULL, 8),
(252817, NULL, 'PTHR31315', NULL, NULL, NULL, NULL, 'PROTEIN SIP5', NULL, NULL, 27447, 8),
(252818, NULL, 'PTHR10547', NULL, NULL, NULL, NULL, 'SEMENOGELIN/SEMINAL VESICLE SECRETORY PROTEIN', NULL, NULL, NULL, 8),
(252819, NULL, 'PTHR37466', NULL, NULL, NULL, NULL, 'SLR1628 PROTEIN', NULL, NULL, 17398, 8),
(252820, NULL, 'PTHR21622', NULL, NULL, NULL, NULL, 'COILED-COIL-HELIX-COILED-COIL-HELIX DOMAIN CONTAINING 4', NULL, NULL, 33026, 8),
(252821, NULL, 'PTHR20968', NULL, NULL, NULL, NULL, 'ILGF DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(252822, NULL, 'PTHR11689', NULL, NULL, NULL, NULL, 'CHLORIDE CHANNEL PROTEIN CLC FAMILY MEMBER', NULL, NULL, NULL, 8),
(252823, NULL, 'PTHR47862', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE FKBP18, CHLOROPLASTIC', NULL, NULL, 33960, 8),
(252824, NULL, 'PTHR37955', NULL, NULL, NULL, NULL, 'TELLURITE RESISTANCE PROTEIN TEHA', NULL, NULL, NULL, 8),
(252825, NULL, 'PTHR20844', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION, SUBUNIT 9', NULL, NULL, 32534, 8),
(252826, NULL, 'PTHR33044', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL INHIBITOR/LIPID-TRANSFER PROTEIN/SEED STORAGE 2S ALBUMIN SUPERFAMILY PROTEIN-RELATED', NULL, NULL, 34049, 8),
(252827, NULL, 'PTHR23078', NULL, NULL, NULL, NULL, 'VESICULAR-FUSION PROTEIN NSF', NULL, NULL, 33301, 8),
(252828, NULL, 'PTHR21468', NULL, NULL, NULL, NULL, 'HSD9', NULL, NULL, 24108, 8),
(252829, NULL, 'PTHR11227', NULL, NULL, NULL, NULL, 'WD-REPEAT PROTEIN INTERACTING WITH PHOSPHOINOSIDES  WIPI -RELATED', NULL, NULL, NULL, 8),
(252830, NULL, 'PTHR14647', NULL, NULL, NULL, NULL, 'GALACTOSE-3-O-SULFOTRANSFERASE', NULL, NULL, 12033, 8),
(252831, NULL, 'PTHR38478', NULL, NULL, NULL, NULL, 'PEPTIDASE M1A AND M12B', NULL, NULL, NULL, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(252832, NULL, 'PTHR12913', NULL, NULL, NULL, NULL, 'UNR PROTEIN  N-RAS UPSTREAM GENE PROTEIN', NULL, NULL, NULL, 8),
(252833, NULL, 'PTHR12277', NULL, NULL, NULL, NULL, 'ALPHA/BETA HYDROLASE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(252834, NULL, 'PTHR12558', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE 16,23,27', NULL, NULL, NULL, 8),
(252835, NULL, 'PTHR17486', NULL, NULL, NULL, NULL, 'SPERMATID NUCLEAR TRANSITION PROTEIN 1', NULL, NULL, 2207, 8),
(252836, NULL, 'PTHR34373', NULL, NULL, NULL, NULL, 'SHUGOSHIN 2', NULL, NULL, 34804, 8),
(252837, NULL, 'PTHR45013', NULL, NULL, NULL, NULL, 'NACHT DOMAIN- AND WD REPEAT-CONTAINING PROTEIN 1', NULL, NULL, 36825, 8),
(252838, NULL, 'PTHR47418', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(252839, NULL, 'PTHR47878', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE FAD/NAD(P)-BINDING DOMAIN PROTEIN', NULL, NULL, NULL, 8),
(252840, NULL, 'PTHR45932', NULL, NULL, NULL, NULL, 'PATELLIN-1', NULL, NULL, 36156, 8),
(252841, NULL, 'PTHR39234', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 210', NULL, NULL, 25678, 8),
(252842, NULL, 'PTHR28154', NULL, NULL, NULL, NULL, 'CELL WALL SYNTHESIS PROTEIN KNH1-RELATED', NULL, NULL, 35727, 8),
(252843, NULL, 'PTHR36374', NULL, NULL, NULL, NULL, 'OS01G0969000 PROTEIN', NULL, NULL, NULL, 8),
(252844, NULL, 'PTHR47877', NULL, NULL, NULL, NULL, 'LATE EMBRYOGENESIS ABUNDANT DOMAIN-CONTAINING PROTEIN / LEA DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(252845, NULL, 'PTHR43748', NULL, NULL, NULL, NULL, 'RIBOSE-5-PHOSPHATE ISOMERASE 3, CHLOROPLASTIC-RELATED', NULL, NULL, NULL, 8),
(252846, NULL, 'PTHR28593', NULL, NULL, NULL, NULL, 'METEORIN-LIKE PROTEIN', NULL, NULL, NULL, 8),
(252847, NULL, 'PTHR28049', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN YOR223W', NULL, NULL, 36713, 8),
(252848, NULL, 'PTHR15190', NULL, NULL, NULL, NULL, 'BONE MARROW STROMAL ANTIGEN 2', NULL, NULL, 26828, 8),
(252849, NULL, 'PTHR43422', NULL, NULL, NULL, NULL, 'THIAMINE THIAZOLE SYNTHASE', NULL, NULL, NULL, 8),
(252850, NULL, 'PTHR14957', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE-CONJUGATING ENZYME ATG10', NULL, NULL, NULL, 8),
(252851, NULL, 'PTHR12810', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 28S RIBOSOMAL PROTEIN S29', NULL, NULL, 15629, 8),
(252852, NULL, 'PTHR40370', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(252853, NULL, 'PTHR16186', NULL, NULL, NULL, NULL, 'SIGNAL-TRANSDUCING ADAPTOR PROTEIN-RELATED', NULL, NULL, 28104, 8),
(252854, NULL, 'PTHR15243', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE 19', NULL, NULL, 20694, 8),
(252855, NULL, 'PTHR34768', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 89', NULL, NULL, 33824, 8),
(252856, NULL, 'PTHR31027', NULL, NULL, NULL, NULL, 'NUCLEAR SEGREGATION PROTEIN BFR1', NULL, NULL, 32552, 8),
(252857, NULL, 'PTHR24303', NULL, NULL, NULL, NULL, 'HEME-BINDING MONOOXYGENASE FAMILY', NULL, NULL, NULL, 8),
(252858, NULL, 'PTHR42833', NULL, NULL, NULL, NULL, 'URIDYLATE KINASE', NULL, NULL, NULL, 8),
(252859, NULL, 'PTHR23263', NULL, NULL, NULL, NULL, 'SMALL PROLINE-RICH PROTEIN', NULL, NULL, NULL, 8),
(252860, NULL, 'PTHR33429', NULL, NULL, NULL, NULL, 'OS02G0708000 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(252861, NULL, 'PTHR34366', NULL, NULL, NULL, NULL, 'OS07G0289901 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(252862, NULL, 'PTHR45838', NULL, NULL, NULL, NULL, 'HISTONE-LYSINE-N-METHYLTRANSFERASE 2 KMT2 FAMILY MEMBER', NULL, NULL, NULL, 8),
(252863, NULL, 'PTHR33604', NULL, NULL, NULL, NULL, 'OSJNBA0004B13.7 PROTEIN', NULL, NULL, NULL, 8),
(252864, NULL, 'PTHR45783', NULL, NULL, NULL, NULL, 'KINESIN LIGHT CHAIN', NULL, NULL, NULL, 8),
(252865, NULL, 'PTHR36768', NULL, NULL, NULL, NULL, 'ATP-DEPENDENT HELICASE/DEOXYRIBONUCLEASE SUBUNIT B', NULL, NULL, NULL, 8),
(252866, NULL, 'PTHR12169', NULL, NULL, NULL, NULL, 'ATPASE N2B', NULL, NULL, 2579, 8),
(252867, NULL, 'PTHR11552', NULL, NULL, NULL, NULL, 'GLUCOSE-METHANOL-CHOLINE  GMC  OXIDOREDUCTASE', NULL, NULL, 13573, 8),
(252868, NULL, 'PTHR12083', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL POLYNUCLEOTIDE PHOSPHATASE/KINASE', NULL, NULL, NULL, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(252869, NULL, 'PTHR22648', NULL, NULL, NULL, NULL, 'TRANSCRIPTION TERMINATION FACTOR NUSA', NULL, NULL, 23601, 8),
(252870, NULL, 'PTHR30221', NULL, NULL, NULL, NULL, 'SMALL-CONDUCTANCE MECHANOSENSITIVE CHANNEL', NULL, NULL, 37027, 8),
(252871, NULL, 'PTHR42774', NULL, NULL, NULL, NULL, 'PHOSPHOTRANSFERASE SYSTEM TRANSPORT PROTEIN', NULL, NULL, NULL, 8),
(252872, NULL, 'PTHR21196', NULL, NULL, NULL, NULL, 'U7 SNRNA-ASSOCIATED SM-LIKE PROTEIN LSM10', NULL, NULL, NULL, 8),
(252873, NULL, 'PTHR47553', NULL, NULL, NULL, NULL, 'MYOSIN-11', NULL, NULL, NULL, 8),
(252874, NULL, 'PTHR16830', NULL, NULL, NULL, NULL, 'SH2 CONTAINING ADAPTOR PRAM-1 RELATED', NULL, NULL, 34741, 8),
(252875, NULL, 'PTHR10369', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L36A/L44', NULL, NULL, 5586, 8),
(252876, NULL, 'PTHR21545', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MLR1/2', NULL, NULL, NULL, 8),
(252877, NULL, 'PTHR42648', NULL, NULL, NULL, NULL, 'TRANSPOSASE, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(252878, NULL, 'PTHR48084', NULL, NULL, NULL, NULL, '2-OXOGLUTARATE OXIDOREDUCTASE SUBUNIT KORB-RELATED', NULL, NULL, NULL, 8),
(252879, NULL, 'PTHR14402', NULL, NULL, NULL, NULL, 'RECEPTOR TRANSPORTING PROTEIN', NULL, NULL, 25167, 8),
(252880, NULL, 'PTHR33799', NULL, NULL, NULL, NULL, 'PTS PERMEASE-RELATED-RELATED', NULL, NULL, NULL, 8),
(252881, NULL, 'PTHR11437', NULL, NULL, NULL, NULL, 'RIBONUCLEASE', NULL, NULL, 3396, 8),
(252882, NULL, 'PTHR33623', NULL, NULL, NULL, NULL, 'OS04G0572500 PROTEIN', NULL, NULL, NULL, 8),
(252883, NULL, 'PTHR36917', NULL, NULL, NULL, NULL, 'INTRACELLULAR SEPTATION PROTEIN A-RELATED', NULL, NULL, 1137, 8),
(252884, NULL, 'PTHR34801', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(252885, NULL, 'PTHR46035', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 4', NULL, NULL, NULL, 8),
(252886, NULL, 'PTHR31908', NULL, NULL, NULL, NULL, 'PROTEIN CROWDED NUCLEI 4', NULL, NULL, 28864, 8),
(252887, NULL, 'PTHR47934', NULL, NULL, NULL, NULL, 'PENTATRICOPEPTIDE REPEAT-CONTAINING PROTEIN PET309, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(252888, NULL, 'PTHR33624', NULL, NULL, NULL, NULL, 'SIGMA FACTOR BINDING PROTEIN 1, CHLOROPLASTIC', NULL, NULL, 33998, 8),
(252889, NULL, 'PTHR48194', NULL, NULL, NULL, NULL, 'FINGER PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(252890, NULL, 'PTHR42945', NULL, NULL, NULL, NULL, 'HISTIDINE BIOSYNTHESIS BIFUNCTIONAL PROTEIN', NULL, NULL, NULL, 8),
(252891, NULL, 'PTHR28608', NULL, NULL, NULL, NULL, 'INTEGRATOR COMPLEX SUBUNIT 2', NULL, NULL, 26710, 8),
(252892, NULL, 'PTHR11008', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(252893, NULL, 'PTHR33344', NULL, NULL, NULL, NULL, 'OS02G0761600 PROTEIN', NULL, NULL, NULL, 8),
(252894, NULL, 'PTHR25464', NULL, NULL, NULL, NULL, 'TRIPARTITE MOTIF-CONTAINING PROTEIN 2-LIKE PROTEIN', NULL, NULL, NULL, 8),
(252895, NULL, 'PTHR13195', NULL, NULL, NULL, NULL, 'PSEUDOURIDINE SYNTHASE-RELATED', NULL, NULL, 32701, 8),
(252896, NULL, 'PTHR11364', NULL, NULL, NULL, NULL, 'THIOSULFATE SULFERTANSFERASE', NULL, NULL, 36752, 8),
(252897, NULL, 'PTHR47310', NULL, NULL, NULL, NULL, 'PROTEIN FLUORESCENT IN BLUE LIGHT, CHLOROPLASTIC', NULL, NULL, 34656, 8),
(252898, NULL, 'PTHR31077', NULL, NULL, NULL, NULL, 'U4/U6.U5 SMALL NUCLEAR RIBONUCLEOPROTEIN 27 KDA PROTEIN', NULL, NULL, NULL, 8),
(252899, NULL, 'PTHR19960', NULL, NULL, NULL, NULL, 'TEKTIN', NULL, NULL, 6657, 8),
(252900, NULL, 'PTHR16470', NULL, NULL, NULL, NULL, 'UBIQUITIN DOMAIN-CONTAINING PROTEIN UBFD1', NULL, NULL, 32605, 8),
(252901, NULL, 'PTHR36062', NULL, NULL, NULL, NULL, 'OS01G0687300 PROTEIN', NULL, NULL, 31685, 8),
(252902, NULL, 'PTHR13247', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT PROTEIN 11  TPR REPEAT PROTEIN 11', NULL, NULL, 16418, 8),
(252903, NULL, 'PTHR38434', NULL, NULL, NULL, NULL, 'BLL2549 PROTEIN', NULL, NULL, 19863, 8),
(252904, NULL, 'PTHR12162', NULL, NULL, NULL, NULL, 'NIBRIN-RELATED', NULL, NULL, 31698, 8),
(252905, NULL, 'PTHR12697', NULL, NULL, NULL, NULL, 'PBS LYASE HEAT-LIKE PROTEIN', NULL, NULL, NULL, 8);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(252906, NULL, 'PTHR14224', NULL, NULL, NULL, NULL, 'SIMILAR TO PREFERENTIALLY EXPRESSED ANTIGEN IN MELANOMA-LIKE 3', NULL, NULL, NULL, 8),
(252907, NULL, 'PTHR47322', NULL, NULL, NULL, NULL, 'SUSC HOMOLOG-RELATED', NULL, NULL, NULL, 8),
(252908, NULL, 'PTHR31235', NULL, NULL, NULL, NULL, 'PEROXIDASE 25-RELATED', NULL, NULL, 4670, 8),
(252909, NULL, 'PTHR47216', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252910, NULL, 'PTHR36219', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252911, NULL, 'PTHR36766', NULL, NULL, NULL, NULL, 'PLANT BROAD-SPECTRUM MILDEW RESISTANCE PROTEIN RPW8', NULL, NULL, 32716, 8),
(252912, NULL, 'PTHR42944', NULL, NULL, NULL, NULL, 'ADENINE DNA GLYCOSYLASE', NULL, NULL, 36472, 8),
(252913, NULL, 'PTHR37711', NULL, NULL, NULL, NULL, 'OS01G0908400 PROTEIN', NULL, NULL, NULL, 8),
(252914, NULL, 'PTHR42998', NULL, NULL, NULL, NULL, 'TYPE I RESTRICTION ENZYME HINDVIIP M PROTEIN-RELATED', NULL, NULL, NULL, 8),
(252915, NULL, 'PTHR37169', NULL, NULL, NULL, NULL, 'CRISPR SYSTEM ENDORIBONUCLEASE CSX1-RELATED', NULL, NULL, NULL, 8),
(252916, NULL, 'PTHR47448', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY MITOGEN-ACTIVATED PROTEIN KINASE KINASE DSOR1-LIKE PROTEIN', NULL, NULL, NULL, 8),
(252917, NULL, 'PTHR38846', NULL, NULL, NULL, NULL, 'C3H1-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(252918, NULL, 'PTHR45458', NULL, NULL, NULL, NULL, 'SHORT-CHAIN DEHYDROGENASE/REDUCTASE SDR', NULL, NULL, NULL, 8),
(252919, NULL, 'PTHR46722', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM7 HOMOLOG', NULL, NULL, NULL, 8),
(252920, NULL, 'PTHR22419', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 172', NULL, NULL, 23758, 8),
(252921, NULL, 'PTHR10794', NULL, NULL, NULL, NULL, 'ABHYDROLASE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(252922, NULL, 'PTHR10083', NULL, NULL, NULL, NULL, 'KUNITZ-TYPE PROTEASE INHIBITOR-RELATED', NULL, NULL, NULL, 8),
(252923, NULL, 'PTHR13367', NULL, NULL, NULL, NULL, 'UBIQUITIN THIOESTERASE', NULL, NULL, NULL, 8),
(252924, NULL, 'PTHR13906', NULL, NULL, NULL, NULL, 'PORCUPINE', NULL, NULL, NULL, 8),
(252925, NULL, 'PTHR43197', NULL, NULL, NULL, NULL, 'UTP--GLUCOSE-1-PHOSPHATE URIDYLYLTRANSFERASE', NULL, NULL, 4867, 8),
(252926, NULL, 'PTHR14344', NULL, NULL, NULL, NULL, 'WD REPEAT PROTEIN', NULL, NULL, NULL, 8),
(252927, NULL, 'PTHR31663', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 3', NULL, NULL, 31423, 8),
(252928, NULL, 'PTHR34980', NULL, NULL, NULL, NULL, 'INNER MEMBRANE PROTEIN-RELATED-RELATED', NULL, NULL, 13161, 8),
(252929, NULL, 'PTHR23219', NULL, NULL, NULL, NULL, 'TYROSINE-PROTEIN PHOSPHATASE C15H7.3-RELATED', NULL, NULL, NULL, 8),
(252930, NULL, 'PTHR12794', NULL, NULL, NULL, NULL, 'GEMIN2', NULL, NULL, NULL, 8),
(252931, NULL, 'PTHR15073', NULL, NULL, NULL, NULL, 'MICROTUBULE-ASSOCIATED PROTEIN', NULL, NULL, NULL, 8),
(252932, NULL, 'PTHR20987', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(252933, NULL, 'PTHR48020', NULL, NULL, NULL, NULL, 'PROTON MYO-INOSITOL COTRANSPORTER', NULL, NULL, NULL, 8),
(252934, NULL, 'PTHR10513', NULL, NULL, NULL, NULL, 'DEOXYNUCLEOSIDE KINASE', NULL, NULL, NULL, 8),
(252935, NULL, 'PTHR47578', NULL, NULL, NULL, NULL, 'THIOREDOXIN-LIKE PROTEIN CDSP32, CHLOROPLASTIC', NULL, NULL, 36026, 8),
(252936, NULL, 'PTHR45860', NULL, NULL, NULL, NULL, 'TRANSLATION INITIATION FACTOR EIF-2B SUBUNIT ALPHA', NULL, NULL, NULL, 8),
(252937, NULL, 'PTHR31978', NULL, NULL, NULL, NULL, 'INTRAFLAGELLAR TRANSPORT PROTEIN 20 HOMOLOG', NULL, NULL, 24511, 8),
(252938, NULL, 'PTHR15742', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(252939, NULL, 'PTHR35709', NULL, NULL, NULL, NULL, 'PROTEIN PROTON GRADIENT REGULATION 5, CHLOROPLASTIC', NULL, NULL, 27401, 8),
(252940, NULL, 'PTHR43379', NULL, NULL, NULL, NULL, 'CYSTATHIONINE GAMMA-SYNTHASE', NULL, NULL, 35172, 8),
(252941, NULL, 'PTHR31225', NULL, NULL, NULL, NULL, 'OS04G0344100 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(252942, NULL, 'PTHR46690', NULL, NULL, NULL, NULL, 'CYTOCHROME C OXIDASE ASSEMBLY FACTOR 6 HOMOLOG', NULL, NULL, 34609, 8);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(252943, NULL, 'PTHR39161', NULL, NULL, NULL, NULL, 'ADAPTER PROTEIN MECA', NULL, NULL, 12898, 8),
(252944, NULL, 'PTHR23074', NULL, NULL, NULL, NULL, 'AAA DOMAIN-CONTAINING', NULL, NULL, NULL, 8),
(252945, NULL, 'PTHR30471', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN RADC', NULL, NULL, 3412, 8),
(252946, NULL, 'PTHR47500', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING DOMAIN-CONTAINING PROTEIN', NULL, NULL, 34544, 8),
(252947, NULL, 'PTHR21704', NULL, NULL, NULL, NULL, 'NIPPED-B-LIKE PROTEIN  DELANGIN  SCC2-RELATED', NULL, NULL, 27185, 8),
(252948, NULL, 'PTHR14580', NULL, NULL, NULL, NULL, 'MULTIPLE MYELOMA TUMOR-ASSOCIATED PROTEIN 2 FAMILY MEMBER', NULL, NULL, 32502, 8),
(252949, NULL, 'PTHR42058', NULL, NULL, NULL, NULL, 'G_PROTEIN_RECEP_F2_4 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(252950, NULL, 'PTHR46938', NULL, NULL, NULL, NULL, 'DISCOIDIN-1 SUBUNIT A-RELATED-RELATED', NULL, NULL, NULL, 8),
(252951, NULL, 'PTHR14206', NULL, NULL, NULL, NULL, 'BRAIN-SPECIFIC ANGIOGENESIS INHIBITOR 1-ASSOCIATED PROTEIN 2', NULL, NULL, 25162, 8),
(252952, NULL, 'PTHR12479', NULL, NULL, NULL, NULL, 'LYSOSOMAL-ASSOCIATED TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(252953, NULL, 'PTHR23208', NULL, NULL, NULL, NULL, 'LYSOZYME PROTEIN', NULL, NULL, NULL, 8),
(252954, NULL, 'PTHR47700', NULL, NULL, NULL, NULL, 'V CHITINASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_6G13720)-RELATED', NULL, NULL, NULL, 8),
(252955, NULL, 'PTHR37455', NULL, NULL, NULL, NULL, 'GENE, 27021-RELATED', NULL, NULL, 25679, 8),
(252956, NULL, 'PTHR43724', NULL, NULL, NULL, NULL, 'PYRUVATE SYNTHASE SUBUNIT PORD', NULL, NULL, NULL, 8),
(252957, NULL, 'PTHR47125', NULL, NULL, NULL, NULL, 'ADENINE NUCLEOTIDE ALPHA HYDROLASES-LIKE SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(252958, NULL, 'PTHR47588', NULL, NULL, NULL, NULL, 'CHALCONE--FLAVONONE ISOMERASE 3-RELATED', NULL, NULL, 34788, 8),
(252959, NULL, 'PTHR21824', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 22472, 8),
(252960, NULL, 'PTHR21700', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 5860, 8),
(252961, NULL, 'PTHR43718', NULL, NULL, NULL, NULL, 'LON PROTEASE', NULL, NULL, 24616, 8),
(252962, NULL, 'PTHR32261', NULL, NULL, NULL, NULL, 'CALCIUM HOMEOSTASIS MODULATOR PROTEIN', NULL, NULL, 25750, 8),
(252963, NULL, 'PTHR34504', NULL, NULL, NULL, NULL, 'ANTITOXIN HICB', NULL, NULL, NULL, 8),
(252964, NULL, 'PTHR39529', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252965, NULL, 'PTHR30035', NULL, NULL, NULL, NULL, 'LIPOPROTEIN VACJ-RELATED', NULL, NULL, 3927, 8),
(252966, NULL, 'PTHR12928', NULL, NULL, NULL, NULL, 'FRG1 PROTEIN', NULL, NULL, 9432, 8),
(252967, NULL, 'PTHR46911', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252968, NULL, 'PTHR46471', NULL, NULL, NULL, NULL, 'CHITIN DEACETYLASE', NULL, NULL, NULL, 8),
(252969, NULL, 'PTHR43135', NULL, NULL, NULL, NULL, 'ALPHA-D-RIBOSE 1-METHYLPHOSPHONATE 5-TRIPHOSPHATE DIPHOSPHATASE', NULL, NULL, NULL, 8),
(252970, NULL, 'PTHR21228', NULL, NULL, NULL, NULL, 'FAST LEU-RICH DOMAIN-CONTAINING', NULL, NULL, NULL, 8),
(252971, NULL, 'PTHR43488', NULL, NULL, NULL, NULL, 'GLUTAMATE-PYRUVATE AMINOTRANSFERASE ALAA', NULL, NULL, NULL, 8),
(252972, NULL, 'PTHR47097', NULL, NULL, NULL, NULL, 'HEAT SHOCK PROTEIN BETA-3', NULL, NULL, 32291, 8),
(252973, NULL, 'PTHR40274', NULL, NULL, NULL, NULL, 'VIRGINIAMYCIN B LYASE', NULL, NULL, NULL, 8),
(252974, NULL, 'PTHR38119', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252975, NULL, 'PTHR43739', NULL, NULL, NULL, NULL, 'XYLOGLUCANASE (EUROFUNG)', NULL, NULL, NULL, 8),
(252976, NULL, 'PTHR15343', NULL, NULL, NULL, NULL, 'CD7', NULL, NULL, 27302, 8),
(252977, NULL, 'PTHR11129', NULL, NULL, NULL, NULL, 'PROTEIN FARNESYLTRANSFERASE ALPHA SUBUNIT/RAB GERANYLGERANYL TRANSFERASE ALPHA SUBUNIT', NULL, NULL, NULL, 8),
(252978, NULL, 'PTHR35472', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(252979, NULL, 'PTHR12693', NULL, NULL, NULL, NULL, 'MENIN', NULL, NULL, 1459, 8),
(252980, NULL, 'PTHR30027', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA SMALL SUBUNIT METHYLTRANSFERASE E', NULL, NULL, 2492, 8);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(252981, NULL, 'PTHR31948', NULL, NULL, NULL, NULL, 'ZINC-FINGER HOMEODOMAIN PROTEIN 2', NULL, NULL, NULL, 8),
(252982, NULL, 'PTHR31113', NULL, NULL, NULL, NULL, 'UPF0496 PROTEIN 3-RELATED', NULL, NULL, 1190, 8),
(252983, NULL, 'PTHR33107', NULL, NULL, NULL, NULL, 'KUNITZ TRYPSIN INHIBITOR 2', NULL, NULL, 305, 8),
(252984, NULL, 'PTHR28642', NULL, NULL, NULL, NULL, 'MEIOSIS 1 ARREST PROTEIN', NULL, NULL, 29833, 8),
(252985, NULL, 'PTHR28650', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-GLYCAN BIOSYNTHESIS CLASS X PROTEIN', NULL, NULL, 31178, 8),
(252986, NULL, 'PTHR21142', NULL, NULL, NULL, NULL, 'SARCOGLYCANS', NULL, NULL, 25195, 8),
(252987, NULL, 'PTHR46103', NULL, NULL, NULL, NULL, 'RRNA METHYLTRANSFERASE 1, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(252988, NULL, 'PTHR47094', NULL, NULL, NULL, NULL, 'ELFLESS, ISOFORM B', NULL, NULL, NULL, 8),
(252989, NULL, 'PTHR45841', NULL, NULL, NULL, NULL, 'MRNA TURNOVER PROTEIN 4 MRTO4', NULL, NULL, NULL, 8),
(252990, NULL, 'PTHR34837', NULL, NULL, NULL, NULL, 'OS05G0595500 PROTEIN', NULL, NULL, NULL, 8),
(252991, NULL, 'PTHR46628', NULL, NULL, NULL, NULL, 'PIRNA BIOGENESIS PROTEIN EXD1', NULL, NULL, NULL, 8),
(252992, NULL, 'PTHR31578', NULL, NULL, NULL, NULL, 'PROTEIN CBG21223-RELATED', NULL, NULL, 15025, 8),
(252993, NULL, 'PTHR12172', NULL, NULL, NULL, NULL, 'CELL CYCLE CHECKPOINT PROTEIN RAD17', NULL, NULL, 798, 8),
(252994, NULL, 'PTHR36870', NULL, NULL, NULL, NULL, 'C17ORF78 ISOFORM 2', NULL, NULL, 26207, 8),
(252995, NULL, 'PTHR23268', NULL, NULL, NULL, NULL, 'T-CELL RECEPTOR BETA CHAIN', NULL, NULL, NULL, 8),
(252996, NULL, 'PTHR10005', NULL, NULL, NULL, NULL, 'SKI ONCOGENE-RELATED', NULL, NULL, 16763, 8),
(252997, NULL, 'PTHR11337', NULL, NULL, NULL, NULL, 'MUCIN/PORIMIN', NULL, NULL, 4312, 8),
(252998, NULL, 'PTHR47464', NULL, NULL, NULL, NULL, 'MACOILIN', NULL, NULL, NULL, 8),
(252999, NULL, 'PTHR30023', NULL, NULL, NULL, NULL, 'D-ALANYL-D-ALANINE CARBOXYPEPTIDASE', NULL, NULL, 6756, 8),
(253000, NULL, 'PTHR17611', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 25703, 8),
(253001, NULL, 'PTHR11431', NULL, NULL, NULL, NULL, 'FERRITIN', NULL, NULL, 6240, 8),
(253002, NULL, 'PTHR46273', NULL, NULL, NULL, NULL, 'MYOSUPPRESSIN RECEPTOR 1, ISOFORM B-RELATED', NULL, NULL, NULL, 8),
(253003, NULL, 'PTHR45872', NULL, NULL, NULL, NULL, 'RHO GUANINE NUCLEOTIDE EXCHANGE FACTOR 2, ISOFORM D', NULL, NULL, NULL, 8),
(253004, NULL, 'PTHR42821', NULL, NULL, NULL, NULL, 'CATALASE', NULL, NULL, 816, 8),
(253005, NULL, 'PTHR42732', NULL, NULL, NULL, NULL, 'BETA-GALACTOSIDASE', NULL, NULL, NULL, 8),
(253006, NULL, 'PTHR40044', NULL, NULL, NULL, NULL, 'INTEGRAL MEMBRANE PROTEIN-RELATED', NULL, NULL, 9317, 8),
(253007, NULL, 'PTHR15153', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR LIGAND SUPERFAMILY MEMBER 9', NULL, NULL, 37020, 8),
(253008, NULL, 'PTHR22650', NULL, NULL, NULL, NULL, 'GLYCOPROTEIN IB BETA', NULL, NULL, NULL, 8),
(253009, NULL, 'PTHR21215', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(253010, NULL, 'PTHR35527', NULL, NULL, NULL, NULL, 'CHOLOYLGLYCINE HYDROLASE', NULL, NULL, NULL, 8),
(253011, NULL, 'PTHR43793', NULL, NULL, NULL, NULL, 'FAD SYNTHASE', NULL, NULL, NULL, 8),
(253012, NULL, 'PTHR13789', NULL, NULL, NULL, NULL, 'MONOOXYGENASE', NULL, NULL, NULL, 8),
(253013, NULL, 'PTHR36938', NULL, NULL, NULL, NULL, 'PROTEIN CBG26935', NULL, NULL, NULL, 8),
(253014, NULL, 'PTHR37012', NULL, NULL, NULL, NULL, 'B-ZIP TRANSCRIPTION FACTOR (EUROFUNG)-RELATED', NULL, NULL, NULL, 8),
(253015, NULL, 'PTHR34352', NULL, NULL, NULL, NULL, 'PROTEIN YHFA', NULL, NULL, NULL, 8),
(253016, NULL, 'PTHR13800', NULL, NULL, NULL, NULL, 'TRANSIENT RECEPTOR POTENTIAL CATION CHANNEL, SUBFAMILY M, MEMBER 6', NULL, NULL, NULL, 8),
(253017, NULL, 'PTHR31482', NULL, NULL, NULL, NULL, 'ESTS AU081301(E20138)', NULL, NULL, NULL, 8),
(253018, NULL, 'PTHR12430', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM20', NULL, NULL, 5326, 8),
(253019, NULL, 'PTHR36073', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253020, NULL, 'PTHR37572', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(253021, NULL, 'PTHR30124', NULL, NULL, NULL, NULL, 'MEMBRANE-BOUND LYTIC MUREIN TRANSGLYCOSYLASE A', NULL, NULL, 24413, 8),
(253022, NULL, 'PTHR39337', NULL, NULL, NULL, NULL, 'BLR5642 PROTEIN', NULL, NULL, NULL, 8),
(253023, NULL, 'PTHR47239', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253024, NULL, 'PTHR12246', NULL, NULL, NULL, NULL, 'PALMITOYLTRANSFERASE ZDHHC16', NULL, NULL, 27433, 8),
(253025, NULL, 'PTHR40055', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR YGIV-RELATED', NULL, NULL, NULL, 8),
(253026, NULL, 'PTHR20878', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT CONTAINING PROTEIN 25', NULL, NULL, 32941, 8),
(253027, NULL, 'PTHR15172', NULL, NULL, NULL, NULL, 'GALACTOCEREBROSIDASE', NULL, NULL, 2292, 8),
(253028, NULL, 'PTHR14134', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RAD18', NULL, NULL, 27298, 8),
(253029, NULL, 'PTHR37250', NULL, NULL, NULL, NULL, 'OS05G0496000 PROTEIN', NULL, NULL, NULL, 8),
(253030, NULL, 'PTHR12763', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(253031, NULL, 'PTHR30269', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN YFCA', NULL, NULL, NULL, 8),
(253032, NULL, 'PTHR43357', NULL, NULL, NULL, NULL, 'INNER MEMBRANE ABC TRANSPORTER PERMEASE PROTEIN YDCV', NULL, NULL, NULL, 8),
(253033, NULL, 'PTHR34871', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253034, NULL, 'PTHR35838', NULL, NULL, NULL, NULL, 'CHROMOSOME 21, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(253035, NULL, 'PTHR30288', NULL, NULL, NULL, NULL, 'FLAGELLAR CAP/ASSEMBLY PROTEIN FLID', NULL, NULL, 31077, 8),
(253036, NULL, 'PTHR13293', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 8422, 8),
(253037, NULL, 'PTHR11991', NULL, NULL, NULL, NULL, 'TRANSLATIONALLY CONTROLLED TUMOR PROTEIN-RELATED', NULL, NULL, 13732, 8),
(253038, NULL, 'PTHR47284', NULL, NULL, NULL, NULL, 'FATTY-ACID-BINDING PROTEIN 2', NULL, NULL, NULL, 8),
(253039, NULL, 'PTHR46872', NULL, NULL, NULL, NULL, 'DNA BINDING PROTEIN', NULL, NULL, NULL, 8),
(253040, NULL, 'PTHR24071', NULL, NULL, NULL, NULL, 'RAN GTPASE', NULL, NULL, 1350, 8),
(253041, NULL, 'PTHR37257', NULL, NULL, NULL, NULL, 'PROTEIN PLASTID TRANSCRIPTIONALLY ACTIVE 7', NULL, NULL, 30464, 8),
(253042, NULL, 'PTHR34853', NULL, NULL, NULL, NULL, '', NULL, NULL, 4112, 8),
(253043, NULL, 'PTHR38113', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253044, NULL, 'PTHR23019', NULL, NULL, NULL, NULL, 'NUCLEAR PORE MEMBRANE GLYCOPROTEIN GP210-RELATED', NULL, NULL, 34900, 8),
(253045, NULL, 'PTHR10438', NULL, NULL, NULL, NULL, 'THIOREDOXIN', NULL, NULL, NULL, 8),
(253046, NULL, 'PTHR11468', NULL, NULL, NULL, NULL, 'GLYCOGEN PHOSPHORYLASE', NULL, NULL, 4517, 8),
(253047, NULL, 'PTHR36726', NULL, NULL, NULL, NULL, 'CLAVATA3/ESR (CLE)-RELATED PROTEIN 45', NULL, NULL, 30970, 8),
(253048, NULL, 'PTHR12771', NULL, NULL, NULL, NULL, 'ENGULFMENT AND CELL MOTILITY', NULL, NULL, NULL, 8),
(253049, NULL, 'PTHR23522', NULL, NULL, NULL, NULL, 'BLL5896 PROTEIN', NULL, NULL, NULL, 8),
(253050, NULL, 'PTHR14592', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED FAM3', NULL, NULL, 32816, 8),
(253051, NULL, 'PTHR34553', NULL, NULL, NULL, NULL, 'OS05G0597400 PROTEIN', NULL, NULL, NULL, 8),
(253052, NULL, 'PTHR42983', NULL, NULL, NULL, NULL, 'DINITROGENASE IRON-MOLYBDENUM COFACTOR PROTEIN-RELATED', NULL, NULL, NULL, 8),
(253053, NULL, 'PTHR47835', NULL, NULL, NULL, NULL, 'HFM1, ATP DEPENDENT DNA HELICASE HOMOLOG', NULL, NULL, NULL, 8),
(253054, NULL, 'PTHR36497', NULL, NULL, NULL, NULL, 'PROTEIN CBG17883', NULL, NULL, NULL, 8),
(253055, NULL, 'PTHR33143', NULL, NULL, NULL, NULL, 'F16F4.1 PROTEIN-RELATED', NULL, NULL, 27154, 8),
(253056, NULL, 'PTHR35708', NULL, NULL, NULL, NULL, 'GB|AAD25831.1', NULL, NULL, NULL, 8),
(253057, NULL, 'PTHR32004', NULL, NULL, NULL, NULL, 'TRNA LIGASE', NULL, NULL, NULL, 8),
(253058, NULL, 'PTHR34192', NULL, NULL, NULL, NULL, 'PLASTOCYANIN MAJOR ISOFORM, CHLOROPLASTIC-RELATED', NULL, NULL, NULL, 8),
(253059, NULL, 'PTHR34265', NULL, NULL, NULL, NULL, 'TYPE III PANTOTHENATE KINASE', NULL, NULL, 2249, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(253060, NULL, 'PTHR14336', NULL, NULL, NULL, NULL, 'TANDEM PH DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(253061, NULL, 'PTHR47547', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253062, NULL, 'PTHR37489', NULL, NULL, NULL, NULL, '', NULL, NULL, 19688, 8),
(253063, NULL, 'PTHR46184', NULL, NULL, NULL, NULL, 'UNCONVENTIONAL MYOSIN-IXB-LIKE PROTEIN', NULL, NULL, NULL, 8),
(253064, NULL, 'PTHR13245', NULL, NULL, NULL, NULL, 'RRP15-LIKE PROTEIN', NULL, NULL, 14241, 8),
(253065, NULL, 'PTHR44472', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 4-RELATED', NULL, NULL, NULL, 8),
(253066, NULL, 'PTHR12606', NULL, NULL, NULL, NULL, 'SENTRIN/SUMO-SPECIFIC PROTEASE', NULL, NULL, NULL, 8),
(253067, NULL, 'PTHR37943', NULL, NULL, NULL, NULL, 'PROTEIN VES', NULL, NULL, 7586, 8),
(253068, NULL, 'PTHR46063', NULL, NULL, NULL, NULL, 'KELCH DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(253069, NULL, 'PTHR31109', NULL, NULL, NULL, NULL, 'PROTEIN FAM207A', NULL, NULL, NULL, 8),
(253070, NULL, 'PTHR23428', NULL, NULL, NULL, NULL, 'HISTONE H2B', NULL, NULL, 5842, 8),
(253071, NULL, 'PTHR47113', NULL, NULL, NULL, NULL, 'LD09343P', NULL, NULL, NULL, 8),
(253072, NULL, 'PTHR22667', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(253073, NULL, 'PTHR14000', NULL, NULL, NULL, NULL, 'FINGER CCCH DOMAIN PROTEIN, PUTATIVE (DUF3755)-RELATED', NULL, NULL, NULL, 8),
(253074, NULL, 'PTHR32158', NULL, NULL, NULL, NULL, 'RING-TYPE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(253075, NULL, 'PTHR37465', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253076, NULL, 'PTHR33929', NULL, NULL, NULL, NULL, 'MEMBRANE-ASSOCIATED KINASE REGULATOR 2-RELATED', NULL, NULL, 27325, 8),
(253077, NULL, 'PTHR42647', NULL, NULL, NULL, NULL, 'SBP (S-RIBONUCLEASE BINDING PROTEIN) FAMILY PROTEIN', NULL, NULL, 19730, 8),
(253078, NULL, 'PTHR15910', NULL, NULL, NULL, NULL, 'ARCHAEMETZINCIN', NULL, NULL, 11824, 8),
(253079, NULL, 'PTHR46567', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 12', NULL, NULL, NULL, 8),
(253080, NULL, 'PTHR46206', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', NULL, NULL, NULL, 8),
(253081, NULL, 'PTHR38492', NULL, NULL, NULL, NULL, 'ADROPIN', NULL, NULL, 7294, 8),
(253082, NULL, 'PTHR10460', NULL, NULL, NULL, NULL, 'ABL INTERACTOR FAMILY MEMBER', NULL, NULL, 25665, 8),
(253083, NULL, 'PTHR42856', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A THIOESTERASE PAAI', NULL, NULL, NULL, 8),
(253084, NULL, 'PTHR40066', NULL, NULL, NULL, NULL, 'UPF0473 PROTEIN CBO2561/CLC_2432', NULL, NULL, 12287, 8),
(253085, NULL, 'PTHR21198', NULL, NULL, NULL, NULL, 'GLUTAMATE RACEMASE', NULL, NULL, NULL, 8),
(253086, NULL, 'PTHR46342', NULL, NULL, NULL, NULL, 'ALPHA-CATULIN', NULL, NULL, 22381, 8),
(253087, NULL, 'PTHR22774', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 21698, 8),
(253088, NULL, 'PTHR19836', NULL, NULL, NULL, NULL, '30S RIBOSOMAL PROTEIN S14', NULL, NULL, 1478, 8),
(253089, NULL, 'PTHR34790', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II CORE COMPLEX PROTEINS PSBY, CHLOROPLASTIC', NULL, NULL, 33430, 8),
(253090, NULL, 'PTHR24414', NULL, NULL, NULL, NULL, 'F-BOX/KELCH-REPEAT PROTEIN SKIP4', NULL, NULL, NULL, 8),
(253091, NULL, 'PTHR18866', NULL, NULL, NULL, NULL, 'CARBOXYLASE:PYRUVATE/ACETYL-COA/PROPIONYL-COA CARBOXYLASE', NULL, NULL, NULL, 8),
(253092, NULL, 'PTHR14382', NULL, NULL, NULL, NULL, 'MDM2-BINDING PROTEIN', NULL, NULL, 32815, 8),
(253093, NULL, 'PTHR35276', NULL, NULL, NULL, NULL, 'S-ADENOSYL-L-METHIONINE-DEPENDENT METHYLTRANSFERASES SUPERFAMILY PROTEIN', NULL, NULL, 9578, 8),
(253094, NULL, 'PTHR31424', NULL, NULL, NULL, NULL, 'PROTEIN CBG23806', NULL, NULL, NULL, 8),
(253095, NULL, 'PTHR45869', NULL, NULL, NULL, NULL, 'C-REACTIVE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(253096, NULL, 'PTHR46985', NULL, NULL, NULL, NULL, 'NACHT, LRR AND PYD DOMAINS-CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(253097, NULL, 'PTHR32481', NULL, NULL, NULL, NULL, 'AMINOPEPTIDASE', NULL, NULL, NULL, 8),
(253098, NULL, 'PTHR15079', NULL, NULL, NULL, NULL, 'MYD88', NULL, NULL, 16313, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(253099, NULL, 'PTHR37857', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 273', NULL, NULL, 23346, 8),
(253100, NULL, 'PTHR47795', NULL, NULL, NULL, NULL, 'UBIQUITIN AND WLM DOMAIN-CONTAINING METALLOPROTEASE SPCC1442.07C', NULL, NULL, NULL, 8),
(253101, NULL, 'PTHR33221', NULL, NULL, NULL, NULL, 'WINGED HELIX-TURN-HELIX TRANSCRIPTIONAL REGULATOR, RRF2 FAMILY', NULL, NULL, 304, 8),
(253102, NULL, 'PTHR43261', NULL, NULL, NULL, NULL, 'TRANSLATION ELONGATION FACTOR G-RELATED', NULL, NULL, NULL, 8),
(253103, NULL, 'PTHR30619', NULL, NULL, NULL, NULL, 'DNA INTERNALIZATION/COMPETENCE PROTEIN COMEC/REC2', NULL, NULL, NULL, 8),
(253104, NULL, 'PTHR10682', NULL, NULL, NULL, NULL, 'POLY A  POLYMERASE', NULL, NULL, NULL, 8),
(253105, NULL, 'PTHR36216', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR, TRMB', NULL, NULL, NULL, 8),
(253106, NULL, 'PTHR47029', NULL, NULL, NULL, NULL, 'FOUR AND A HALF LIM DOMAINS PROTEIN 1', NULL, NULL, 34270, 8),
(253107, NULL, 'PTHR46855', NULL, NULL, NULL, NULL, 'OSJNBB0038F03.10 PROTEIN', NULL, NULL, 34200, 8),
(253108, NULL, 'PTHR14140', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE UHRF-RELATED', NULL, NULL, 34901, 8),
(253109, NULL, 'PTHR21711', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL INNER MEMBRANE PROTEASE', NULL, NULL, 18119, 8),
(253110, NULL, 'PTHR34464', NULL, NULL, NULL, NULL, 'OS09G0376300 PROTEIN', NULL, NULL, NULL, 8),
(253111, NULL, 'PTHR19307', NULL, NULL, NULL, NULL, 'TUMOR PROTEIN D52', NULL, NULL, 5335, 8),
(253112, NULL, 'PTHR39624', NULL, NULL, NULL, NULL, 'PROTEIN INVOLVED IN RIMO-MEDIATED BETA-METHYLTHIOLATION OF RIBOSOMAL PROTEIN S12 YCAO', NULL, NULL, NULL, 8),
(253113, NULL, 'PTHR43399', NULL, NULL, NULL, NULL, 'SUBTILISIN-RELATED', NULL, NULL, NULL, 8),
(253114, NULL, 'PTHR46837', NULL, NULL, NULL, NULL, 'PROTEIN MLN51 HOMOLOG', NULL, NULL, 34798, 8),
(253115, NULL, 'PTHR47476', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253116, NULL, 'PTHR43642', NULL, NULL, NULL, NULL, 'HYBRID SIGNAL TRANSDUCTION HISTIDINE KINASE G', NULL, NULL, NULL, 8),
(253117, NULL, 'PTHR37987', NULL, NULL, NULL, NULL, 'CHROMOSOME 9, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(253118, NULL, 'PTHR39110', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(253119, NULL, 'PTHR37419', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE TOXIN HIPA', NULL, NULL, NULL, 8),
(253120, NULL, 'PTHR33177', NULL, NULL, NULL, NULL, 'PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(253121, NULL, 'PTHR42280', NULL, NULL, NULL, NULL, 'CITG FAMILY PROTEIN', NULL, NULL, NULL, 8),
(253122, NULL, 'PTHR24169', NULL, NULL, NULL, NULL, 'NUCLEAR FACTOR NF-KAPPA-B PROTEIN', NULL, NULL, 6971, 8),
(253123, NULL, 'PTHR15119', NULL, NULL, NULL, NULL, 'SECRETOGRANIN II', NULL, NULL, 32127, 8),
(253124, NULL, 'PTHR35324', NULL, NULL, NULL, NULL, 'BNAA08G03750D PROTEIN', NULL, NULL, NULL, 8),
(253125, NULL, 'PTHR21038', NULL, NULL, NULL, NULL, '40-2-3 PROTEIN-RELATED', NULL, NULL, 13401, 8),
(253126, NULL, 'PTHR34817', NULL, NULL, NULL, NULL, '', NULL, NULL, 18326, 8),
(253127, NULL, 'PTHR34699', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253128, NULL, 'PTHR41695', NULL, NULL, NULL, NULL, '1,4-ALPHA-GLUCAN BRANCHING ENZYME RV3031-RELATED', NULL, NULL, 27659, 8),
(253129, NULL, 'PTHR35720', NULL, NULL, NULL, NULL, 'PROTEIN PLASTID TRANSCRIPTIONALLY ACTIVE 12, CHLOROPLASTIC', NULL, NULL, 29638, 8),
(253130, NULL, 'PTHR43869', NULL, NULL, NULL, NULL, 'GLYCINE BETAINE/PROLINE BETAINE TRANSPORT SYSTEM ATP-BINDING PROTEIN PROV', NULL, NULL, NULL, 8),
(253131, NULL, 'PTHR12636', NULL, NULL, NULL, NULL, 'NEP1/MRA1', NULL, NULL, 5319, 8),
(253132, NULL, 'PTHR21244', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 28S RIBOSOMAL PROTEIN S24', NULL, NULL, 22743, 8),
(253133, NULL, 'PTHR38894', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253134, NULL, 'PTHR38643', NULL, NULL, NULL, NULL, 'PURINE NUCLEOSIDE PERMEASE C285.05-RELATED', NULL, NULL, 9034, 8),
(253135, NULL, 'PTHR37400', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253136, NULL, 'PTHR47435', NULL, NULL, NULL, NULL, 'KELCH REPEAT PROTEIN (AFU_ORTHOLOGUE AFUA_5G12780)', NULL, NULL, NULL, 8);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(253137, NULL, 'PTHR46377', NULL, NULL, NULL, NULL, 'DUAL SPECIFICITY PROTEIN PHOSPHATASE 19', NULL, NULL, NULL, 8),
(253138, NULL, 'PTHR43759', NULL, NULL, NULL, NULL, 'TREHALOSE TRANSPORT SYSTEM PERMEASE PROTEIN SUGA', NULL, NULL, NULL, 8),
(253139, NULL, 'PTHR31532', NULL, NULL, NULL, NULL, 'BIORIENTATION OF CHROMOSOMES IN CELL DIVISION 1 FAMILY MEMBER', NULL, NULL, 22604, 8),
(253140, NULL, 'PTHR36687', NULL, NULL, NULL, NULL, '', NULL, NULL, 34351, 8),
(253141, NULL, 'PTHR43190', NULL, NULL, NULL, NULL, 'N-ACETYL-D-GLUCOSAMINE KINASE', NULL, NULL, NULL, 8),
(253142, NULL, 'PTHR34970', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER A FAMILY PROTEIN', NULL, NULL, NULL, 8),
(253143, NULL, 'PTHR47178', NULL, NULL, NULL, NULL, 'MONOOXYGENASE, FAD-BINDING', NULL, NULL, NULL, 8),
(253144, NULL, 'PTHR13052', NULL, NULL, NULL, NULL, 'NFRKB-RELATED', NULL, NULL, 22484, 8),
(253145, NULL, 'PTHR23382', NULL, NULL, NULL, NULL, 'MALATE DEHYDROGENASE', NULL, NULL, 1965, 8),
(253146, NULL, 'PTHR47328', NULL, NULL, NULL, NULL, '', NULL, NULL, 32794, 8),
(253147, NULL, 'PTHR12473', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 33070, 8),
(253148, NULL, 'PTHR37708', NULL, NULL, NULL, NULL, 'HOMEOBOX HOX-B3-LIKE PROTEIN', NULL, NULL, NULL, 8),
(253149, NULL, 'PTHR46480', NULL, NULL, NULL, NULL, 'F20B24.22', NULL, NULL, 24500, 8),
(253150, NULL, 'PTHR37917', NULL, NULL, NULL, NULL, 'PROTEIN CBG03580', NULL, NULL, NULL, 8),
(253151, NULL, 'PTHR46745', NULL, NULL, NULL, NULL, 'TSC22 DOMAIN FAMILY PROTEIN 1', NULL, NULL, NULL, 8),
(253152, NULL, 'PTHR36963', NULL, NULL, NULL, NULL, 'HELICASE', NULL, NULL, NULL, 8),
(253153, NULL, 'PTHR36161', NULL, NULL, NULL, NULL, 'PROTEIN CBG06377-RELATED', NULL, NULL, NULL, 8),
(253154, NULL, 'PTHR10695', NULL, NULL, NULL, NULL, 'DEPHOSPHO-COA KINASE-RELATED', NULL, NULL, NULL, 8),
(253155, NULL, 'PTHR12745', NULL, NULL, NULL, NULL, 'SUPPRESSION OF TUMORIGENICITY 7', NULL, NULL, 4585, 8),
(253156, NULL, 'PTHR32465', NULL, NULL, NULL, NULL, 'BARDET-BIEDL SYNDROME 2 PROTEIN', NULL, NULL, 19423, 8),
(253157, NULL, 'PTHR40515', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253158, NULL, 'PTHR31361', NULL, NULL, NULL, NULL, 'BETA-GLUCAN SYNTHESIS-ASSOCIATED PROTEIN KRE6-RELATED', NULL, NULL, 2702, 8),
(253159, NULL, 'PTHR33912', NULL, NULL, NULL, NULL, 'OS01G0939400 PROTEIN', NULL, NULL, 27746, 8),
(253160, NULL, 'PTHR30469', NULL, NULL, NULL, NULL, 'MULTIDRUG RESISTANCE PROTEIN MDTA', NULL, NULL, NULL, 8),
(253161, NULL, 'PTHR33992', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P PROTEIN COMPONENT', NULL, NULL, 3569, 8),
(253162, NULL, 'PTHR16234', NULL, NULL, NULL, NULL, 'SIMILAR TO HYPOTHETICAL PROTEIN FLJ20508', NULL, NULL, 26530, 8),
(253163, NULL, 'PTHR12732', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED PROTEASOME COMPONENT REGION PCI-CONTAINING', NULL, NULL, 34238, 8),
(253164, NULL, 'PTHR30486', NULL, NULL, NULL, NULL, 'TWITCHING MOTILITY PROTEIN PILT', NULL, NULL, NULL, 8),
(253165, NULL, 'PTHR13414', NULL, NULL, NULL, NULL, 'HUEL-CATION TRANSPORTER', NULL, NULL, 27854, 8),
(253166, NULL, 'PTHR35296', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(253167, NULL, 'PTHR37357', NULL, NULL, NULL, NULL, 'IZUMO SPERM-EGG FUSION PROTEIN 4', NULL, NULL, NULL, 8),
(253168, NULL, 'PTHR36700', NULL, NULL, NULL, NULL, 'CRISPR SYSTEM CMR SUBUNIT CMR4', NULL, NULL, 9198, 8),
(253169, NULL, 'PTHR47428', NULL, NULL, NULL, NULL, 'REGULATORY PROTEIN MIG1-RELATED', NULL, NULL, NULL, 8),
(253170, NULL, 'PTHR48164', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE SUBUNIT 4', NULL, NULL, NULL, 8),
(253171, NULL, 'PTHR35283', NULL, NULL, NULL, NULL, 'T12C22.21 PROTEIN', NULL, NULL, NULL, 8),
(253172, NULL, 'PTHR43226', NULL, NULL, NULL, NULL, 'XAA-PRO AMINOPEPTIDASE 3', NULL, NULL, NULL, 8),
(253173, NULL, 'PTHR33388', NULL, NULL, NULL, NULL, 'OS01G0212500 PROTEIN', NULL, NULL, 28673, 8),
(253174, NULL, 'PTHR12412', NULL, NULL, NULL, NULL, 'CAP BINDING PROTEIN', NULL, NULL, 25698, 8),
(253175, NULL, 'PTHR21646', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', NULL, NULL, NULL, 8);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(253176, NULL, 'PTHR35788', NULL, NULL, NULL, NULL, 'EXPORTED PROTEIN-RELATED', NULL, NULL, NULL, 8),
(253177, NULL, 'PTHR45942', NULL, NULL, NULL, NULL, 'PROTEIN PHOSPATASE 3 REGULATORY SUBUNIT B ALPHA ISOFORM TYPE 1', NULL, NULL, 11921, 8),
(253178, NULL, 'PTHR43845', NULL, NULL, NULL, NULL, 'BLR5969 PROTEIN', NULL, NULL, NULL, 8),
(253179, NULL, 'PTHR22914', NULL, NULL, NULL, NULL, 'CHITIN SYNTHASE', NULL, NULL, 4322, 8),
(253180, NULL, 'PTHR28637', NULL, NULL, NULL, NULL, 'DNA REPLICATION FACTOR CDT1', NULL, NULL, 34862, 8),
(253181, NULL, 'PTHR13335', NULL, NULL, NULL, NULL, 'TARGET OF RAPAMYCIN COMPLEX 2 SUBUNIT MAPKAP1', NULL, NULL, 13870, 8),
(253182, NULL, 'PTHR37251', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT RECEPTOR SUBUNIT TOM5 HOMOLOG', NULL, NULL, 40, 8),
(253183, NULL, 'PTHR46417', NULL, NULL, NULL, NULL, 'TRNA (GUANINE-N(1)-)-METHYLTRANSFERASE', NULL, NULL, 2522, 8),
(253184, NULL, 'PTHR21206', NULL, NULL, NULL, NULL, 'SLD5 PROTEIN', NULL, NULL, 14206, 8),
(253185, NULL, 'PTHR15367', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE III', NULL, NULL, 21219, 8),
(253186, NULL, 'PTHR31934', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(253187, NULL, 'PTHR11934', NULL, NULL, NULL, NULL, 'RIBOSE-5-PHOSPHATE ISOMERASE', NULL, NULL, 5031, 8),
(253188, NULL, 'PTHR33706', NULL, NULL, NULL, NULL, 'MORN VARIANT REPEAT PROTEIN', NULL, NULL, NULL, 8),
(253189, NULL, 'PTHR13516', NULL, NULL, NULL, NULL, 'RIBONUCLEASE P SUBUNIT P25', NULL, NULL, NULL, 8),
(253190, NULL, 'PTHR39615', NULL, NULL, NULL, NULL, 'YALI0E17897P', NULL, NULL, 23036, 8),
(253191, NULL, 'PTHR43450', NULL, NULL, NULL, NULL, 'ASPARTYL-TRNA SYNTHETASE', NULL, NULL, 1987, 8),
(253192, NULL, 'PTHR42039', NULL, NULL, NULL, NULL, 'PUTATIVE (AFU_ORTHOLOGUE AFUA_3G02940)-RELATED', NULL, NULL, 30631, 8),
(253193, NULL, 'PTHR37165', NULL, NULL, NULL, NULL, 'PEPTIDASE U56 FAMILY', NULL, NULL, NULL, 8),
(253194, NULL, 'PTHR22576', NULL, NULL, NULL, NULL, 'MUCOSA ASSOCIATED LYMPHOID TISSUE LYMPHOMA TRANSLOCATION PROTEIN 1/PARACASPASE', NULL, NULL, NULL, 8),
(253195, NULL, 'PTHR40690', NULL, NULL, NULL, NULL, 'GLL3100 PROTEIN', NULL, NULL, 10905, 8),
(253196, NULL, 'PTHR38816', NULL, NULL, NULL, NULL, 'EXOSOME SUBUNIT, DUF54 FAMILY-RELATED', NULL, NULL, NULL, 8),
(253197, NULL, 'PTHR33362', NULL, NULL, NULL, NULL, 'SIALIC ACID TRAP TRANSPORTER PERMEASE PROTEIN SIAT-RELATED', NULL, NULL, 3010, 8),
(253198, NULL, 'PTHR12313', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE RNF5-RELATED', NULL, NULL, 35744, 8),
(253199, NULL, 'PTHR13680', NULL, NULL, NULL, NULL, 'CDGSH IRON-SULFUR DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, 36657, 8),
(253200, NULL, 'PTHR33795', NULL, NULL, NULL, NULL, 'INSERTION ELEMENT IS150 PROTEIN INSJ', NULL, NULL, NULL, 8),
(253201, NULL, 'PTHR30518', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 2434, 8),
(253202, NULL, 'PTHR13615', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE-LIKE 1', NULL, NULL, NULL, 8),
(253203, NULL, 'PTHR38825', NULL, NULL, NULL, NULL, 'LYSINE EXPORTER PROTEIN (LYSE/YGGA)', NULL, NULL, NULL, 8),
(253204, NULL, 'PTHR36120', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253205, NULL, 'PTHR31342', NULL, NULL, NULL, NULL, 'PROTEIN CHUP1, CHLOROPLASTIC', NULL, NULL, 27791, 8),
(253206, NULL, 'PTHR36689', NULL, NULL, NULL, NULL, 'COLORECTAL CANCER-ASSOCIATED PROTEIN 2', NULL, NULL, 34400, 8),
(253207, NULL, 'PTHR19290', NULL, NULL, NULL, NULL, 'BASIC HELIX-LOOP-HELIX PROTEIN NEUROGENIN-RELATED', NULL, NULL, NULL, 8),
(253208, NULL, 'PTHR41813', NULL, NULL, NULL, NULL, 'REGULATOR PAB1642, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G11955)-RELATED', NULL, NULL, NULL, 8),
(253209, NULL, 'PTHR24404', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', NULL, NULL, NULL, 8),
(253210, NULL, 'PTHR11064', NULL, NULL, NULL, NULL, 'CCAAT-BINDING TRANSCRIPTION FACTOR-RELATED', NULL, NULL, 22722, 8),
(253211, NULL, 'PTHR15880', NULL, NULL, NULL, NULL, 'ASPARTATE-RICH PROTEIN 1', NULL, NULL, 35535, 8),
(253212, NULL, 'PTHR46516', NULL, NULL, NULL, NULL, 'TRNA-SPECIFIC ADENOSINE DEAMINASE 1', NULL, NULL, NULL, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(253213, NULL, 'PTHR46237', NULL, NULL, NULL, NULL, 'CYTOCHROME B5 REDUCTASE 4 FAMILY MEMBER', NULL, NULL, NULL, 8),
(253214, NULL, 'PTHR47911', NULL, NULL, NULL, NULL, 'HYDROXYPROLINE-RICH GLYCOPROTEIN-LIKE', NULL, NULL, NULL, 8),
(253215, NULL, 'PTHR33831', NULL, NULL, NULL, NULL, 'GPI-ANCHORED PROTEIN', NULL, NULL, 27613, 8),
(253216, NULL, 'PTHR10353', NULL, NULL, NULL, NULL, 'GLYCOSYL HYDROLASE', NULL, NULL, 7273, 8),
(253217, NULL, 'PTHR31360', NULL, NULL, NULL, NULL, '', NULL, NULL, 9398, 8),
(253218, NULL, 'PTHR47168', NULL, NULL, NULL, NULL, 'RING ZINC FINGER DOMAIN SUPERFAMILY PROTEIN-RELATED', NULL, NULL, NULL, 8),
(253219, NULL, 'PTHR15182', NULL, NULL, NULL, NULL, 'A-KINASE ANCHOR PROTEIN 5-RELATED', NULL, NULL, 37011, 8),
(253220, NULL, 'PTHR45719', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', NULL, NULL, 36029, 8),
(253221, NULL, 'PTHR15159', NULL, NULL, NULL, NULL, 'NEUROSECRETORY PROTEIN VGF', NULL, NULL, 25514, 8),
(253222, NULL, 'PTHR35480', NULL, NULL, NULL, NULL, 'MATERNAL EFFECT EMBRYO ARREST 22', NULL, NULL, NULL, 8),
(253223, NULL, 'PTHR45881', NULL, NULL, NULL, NULL, 'CHECKPOINT SUPPRESSOR 1-LIKE, ISOFORM A-RELATED', NULL, NULL, NULL, 8),
(253224, NULL, 'PTHR46108', NULL, NULL, NULL, NULL, 'BLUE CHEESE', NULL, NULL, NULL, 8),
(253225, NULL, 'PTHR11318', NULL, NULL, NULL, NULL, 'GUANYLIN FAMILY MEMBER', NULL, NULL, 4544, 8),
(253226, NULL, 'PTHR22961', NULL, NULL, NULL, NULL, 'SER/THR PROTEIN KINASE-TRB', NULL, NULL, 12238, 8),
(253227, NULL, 'PTHR46367', NULL, NULL, NULL, NULL, 'ATAXIN-7-LIKE PROTEIN 3', NULL, NULL, NULL, 8),
(253228, NULL, 'PTHR10614', NULL, NULL, NULL, NULL, 'INSULIN RECEPTOR SUBSTRATE', NULL, NULL, 32522, 8),
(253229, NULL, 'PTHR46162', NULL, NULL, NULL, NULL, 'TRAF-LIKE FAMILY PROTEIN', NULL, NULL, NULL, 8),
(253230, NULL, 'PTHR33938', NULL, NULL, NULL, NULL, 'FERULOYL ESTERASE B-RELATED', NULL, NULL, 11197, 8),
(253231, NULL, 'PTHR36509', NULL, NULL, NULL, NULL, 'BLL3101 PROTEIN', NULL, NULL, NULL, 8),
(253232, NULL, 'PTHR23086', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLINOSITOL-4-PHOSPHATE 5-KINASE', NULL, NULL, 16069, 8),
(253233, NULL, 'PTHR45808', NULL, NULL, NULL, NULL, 'RHO GTPASE-ACTIVATING PROTEIN 68F', NULL, NULL, NULL, 8),
(253234, NULL, 'PTHR15594', NULL, NULL, NULL, NULL, 'PODOCALYXIN-LIKE PROTEIN 2', NULL, NULL, 36904, 8),
(253235, NULL, 'PTHR13357', NULL, NULL, NULL, NULL, 'SH3 ADAPTER PROTEIN SPIN90  NCK INTERACTING PROTEIN WITH SH3 DOMAIN', NULL, NULL, 23479, 8),
(253236, NULL, 'PTHR30545', NULL, NULL, NULL, NULL, 'SUGAR FERMENTATION STIMULATION PROTEIN A', NULL, NULL, 11383, 8),
(253237, NULL, 'PTHR10775', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(253238, NULL, 'PTHR34947', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(253239, NULL, 'PTHR12170', NULL, NULL, NULL, NULL, 'MACROPHAGE ERYTHROBLAST ATTACHER-RELATED', NULL, NULL, 35901, 8),
(253240, NULL, 'PTHR17573', NULL, NULL, NULL, NULL, 'UROPLAKIN II', NULL, NULL, 8384, 8),
(253241, NULL, 'PTHR46088', NULL, NULL, NULL, NULL, 'TUBULIN--TYROSINE LIGASE-LIKE PROTEIN 12', NULL, NULL, 24762, 8),
(253242, NULL, 'PTHR47899', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 171', NULL, NULL, 30802, 8),
(253243, NULL, 'PTHR10373', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR 7 FAMILY MEMBER', NULL, NULL, 15217, 8),
(253244, NULL, 'PTHR37948', NULL, NULL, NULL, NULL, 'ZGC:113208', NULL, NULL, NULL, 8),
(253245, NULL, 'PTHR36467', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 207', NULL, NULL, 28739, 8),
(253246, NULL, 'PTHR21016', NULL, NULL, NULL, NULL, 'BETA-AMYLOID BINDING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(253247, NULL, 'PTHR24160', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT DOMAIN-CONTAINING PROTEIN 53', NULL, NULL, 36230, 8),
(253248, NULL, 'PTHR34339', NULL, NULL, NULL, NULL, 'STIMULATOR OF INTERFERON GENES PROTEIN', NULL, NULL, 26786, 8),
(253249, NULL, 'PTHR31625', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253250, NULL, 'PTHR23158', NULL, NULL, NULL, NULL, 'MELANOMA INHIBITORY ACTIVITY-RELATED', NULL, NULL, NULL, 8);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(253251, NULL, 'PTHR34383', NULL, NULL, NULL, NULL, 'POLYPHOSPHATE:AMP PHOSPHOTRANSFERASE-RELATED', NULL, NULL, NULL, 8),
(253252, NULL, 'PTHR12424', NULL, NULL, NULL, NULL, 'TWEETY-RELATED', NULL, NULL, 5875, 8),
(253253, NULL, 'PTHR28086', NULL, NULL, NULL, NULL, 'UPF0662 PROTEIN YPL260W', NULL, NULL, 19585, 8),
(253254, NULL, 'PTHR42091', NULL, NULL, NULL, NULL, 'CONSERVED GLYCINE-RICH PROTEIN (AFU_ORTHOLOGUE AFUA_7G02440)', NULL, NULL, NULL, 8),
(253255, NULL, 'PTHR15143', NULL, NULL, NULL, NULL, 'TELETHONIN', NULL, NULL, 17650, 8),
(253256, NULL, 'PTHR36214', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253257, NULL, 'PTHR39410', NULL, NULL, NULL, NULL, 'RIKEN CDNA 4930558K02 GENE', NULL, NULL, 26221, 8),
(253258, NULL, 'PTHR35261', NULL, NULL, NULL, NULL, 'ORGANELLAR PROTEIN, PUTATIVE-RELATED-RELATED', NULL, NULL, NULL, 8),
(253259, NULL, 'PTHR13604', NULL, NULL, NULL, NULL, 'DC12-RELATED', NULL, NULL, 6091, 8),
(253260, NULL, 'PTHR47480', NULL, NULL, NULL, NULL, 'EG45-LIKE DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(253261, NULL, 'PTHR47858', NULL, NULL, NULL, NULL, 'HALOACID DEHALOGENASE-LIKE HYDROLASE (HAD) SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(253262, NULL, 'PTHR46109', NULL, NULL, NULL, NULL, 'PROTEIN LIN-28', NULL, NULL, NULL, 8),
(253263, NULL, 'PTHR10869', NULL, NULL, NULL, NULL, 'PROLYL 4-HYDROXYLASE ALPHA SUBUNIT', NULL, NULL, 34557, 8),
(253264, NULL, 'PTHR43750', NULL, NULL, NULL, NULL, 'UDP-GLUCOSE 6-DEHYDROGENASE TUAD', NULL, NULL, NULL, 8),
(253265, NULL, 'PTHR47576', NULL, NULL, NULL, NULL, 'BRCT DOMAIN DNA REPAIR PROTEIN-RELATED', NULL, NULL, NULL, 8),
(253266, NULL, 'PTHR46552', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE CHAIN 2', NULL, NULL, NULL, 8),
(253267, NULL, 'PTHR23249', NULL, NULL, NULL, NULL, 'TRAFFICKING PROTEIN PARTICLE COMPLEX SUBUNIT', NULL, NULL, 6532, 8),
(253268, NULL, 'PTHR39199', NULL, NULL, NULL, NULL, 'BLR5128 PROTEIN', NULL, NULL, NULL, 8),
(253269, NULL, 'PTHR38594', NULL, NULL, NULL, NULL, 'PEP-DEPENDENT DIHYDROXYACETONE KINASE, PHOSPHORYL DONOR SUBUNIT DHAM', NULL, NULL, 27415, 8),
(253270, NULL, 'PTHR47330', NULL, NULL, NULL, NULL, 'POLY(U)-BINDING-SPLICING FACTOR PUF60-B-RELATED', NULL, NULL, NULL, 8),
(253271, NULL, 'PTHR43453', NULL, NULL, NULL, NULL, 'RRNA METHYLASE-LIKE', NULL, NULL, 29863, 8),
(253272, NULL, 'PTHR43111', NULL, NULL, NULL, NULL, 'ALDEHYDE DEHYDROGENASE B-RELATED', NULL, NULL, NULL, 8),
(253273, NULL, 'PTHR39169', NULL, NULL, NULL, NULL, '', NULL, NULL, 13153, 8),
(253274, NULL, 'PTHR30525', NULL, NULL, NULL, NULL, '1-DEOXY-D-XYLULOSE 5-PHOSPHATE REDUCTOISOMERASE', NULL, NULL, 3142, 8),
(253275, NULL, 'PTHR15688', NULL, NULL, NULL, NULL, 'KINETOCHORE-ASSOCIATED PROTEIN 1', NULL, NULL, NULL, 8),
(253276, NULL, 'PTHR35370', NULL, NULL, NULL, NULL, 'CYTOPLASMIC PROTEIN-RELATED-RELATED', NULL, NULL, 7743, 8),
(253277, NULL, 'PTHR12096', NULL, NULL, NULL, NULL, 'NUCLEAR PROTEIN SKIP-RELATED', NULL, NULL, 18513, 8),
(253278, NULL, 'PTHR13476', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 7252, 8),
(253279, NULL, 'PTHR46644', NULL, NULL, NULL, NULL, 'DNA REPAIR PROTEIN XRCC2', NULL, NULL, 25192, 8),
(253280, NULL, 'PTHR47633', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN', NULL, NULL, NULL, 8),
(253281, NULL, 'PTHR10656', NULL, NULL, NULL, NULL, 'CELL FATE DETERMINING PROTEIN MAB21-RELATED', NULL, NULL, NULL, 8),
(253282, NULL, 'PTHR15859', NULL, NULL, NULL, NULL, 'SETA BINDING PROTEIN 1', NULL, NULL, NULL, 8),
(253283, NULL, 'PTHR35899', NULL, NULL, NULL, NULL, 'PAPAIN FAMILY CYSTEINE PROTEASE DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(253284, NULL, 'PTHR43246', NULL, NULL, NULL, NULL, 'PEPTIDYL-PROLYL CIS-TRANS ISOMERASE CYP38, CHLOROPLASTIC', NULL, NULL, 36302, 8),
(253285, NULL, 'PTHR21143', NULL, NULL, NULL, NULL, 'INVERTEBRATE GUSTATORY RECEPTOR', NULL, NULL, 11023, 8),
(253286, NULL, 'PTHR43795', NULL, NULL, NULL, NULL, 'BIFUNCTIONAL ASPARTATE AMINOTRANSFERASE AND GLUTAMATE/ASPARTATE-PREPHENATE AMINOTRANSFERASE-RELATED', NULL, NULL, NULL, 8),
(253287, NULL, 'PTHR32031', NULL, NULL, NULL, NULL, 'FNIP REPEAT-CONTAINING PROTEIN-RELATED-RELATED', NULL, NULL, NULL, 8);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(253288, NULL, 'PTHR37817', NULL, NULL, NULL, NULL, 'N-ACETYLTRANSFERASE EIS', NULL, NULL, NULL, 8),
(253289, NULL, 'PTHR10745', NULL, NULL, NULL, NULL, 'GLYCYL-TRNA SYNTHETASE/DNA POLYMERASE SUBUNIT GAMMA-2', NULL, NULL, 23392, 8),
(253290, NULL, 'PTHR12838', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RNA-ASSOCIATED PROTEIN 11', NULL, NULL, 162, 8),
(253291, NULL, 'PTHR37861', NULL, NULL, NULL, NULL, 'PROLINE-RICH ACIDIC PROTEIN 1', NULL, NULL, 24746, 8),
(253292, NULL, 'PTHR16201', NULL, NULL, NULL, NULL, 'SEVEN TRANSMEMBRANE PROTEIN 1-RELATED', NULL, NULL, NULL, 8),
(253293, NULL, 'PTHR13487', NULL, NULL, NULL, NULL, 'SERINE PROTEASE INHIBITOR', NULL, NULL, 27326, 8),
(253294, NULL, 'PTHR19964', NULL, NULL, NULL, NULL, 'MULTIPLE PDZ DOMAIN PROTEIN', NULL, NULL, NULL, 8),
(253295, NULL, 'PTHR41317', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253296, NULL, 'PTHR20950', NULL, NULL, NULL, NULL, 'GALANIN-RELATED PEPTIDE', NULL, NULL, 32767, 8),
(253297, NULL, 'PTHR34007', NULL, NULL, NULL, NULL, 'AEROLYSIN-LIKE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(253298, NULL, 'PTHR21272', NULL, NULL, NULL, NULL, 'CATABOLIC 3-DEHYDROQUINASE', NULL, NULL, 4460, 8),
(253299, NULL, 'PTHR40031', NULL, NULL, NULL, NULL, 'HYPOTHETICAL MEMBRANE SPANNING PROTEIN', NULL, NULL, NULL, 8),
(253300, NULL, 'PTHR36025', NULL, NULL, NULL, NULL, 'DIHYDROOROTATE DEHYDROGENASE (DUF3598)', NULL, NULL, NULL, 8),
(253301, NULL, 'PTHR35505', NULL, NULL, NULL, NULL, 'OS01G0600300 PROTEIN', NULL, NULL, NULL, 8),
(253302, NULL, 'PTHR16196', NULL, NULL, NULL, NULL, 'CELL CYCLE CONTROL PROTEIN CWF25', NULL, NULL, NULL, 8),
(253303, NULL, 'PTHR11332', NULL, NULL, NULL, NULL, 'SECRETOGLOBIN FAMILY 1D', NULL, NULL, NULL, 8),
(253304, NULL, 'PTHR13710', NULL, NULL, NULL, NULL, 'DNA HELICASE RECQ FAMILY MEMBER', NULL, NULL, NULL, 8),
(253305, NULL, 'PTHR43591', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE', NULL, NULL, NULL, 8),
(253306, NULL, 'PTHR47729', NULL, NULL, NULL, NULL, 'SERINE PEPTIDASE INHIBITOR, KAZAL TYPE 2, TANDEM DUPLICATE 1-RELATED', NULL, NULL, NULL, 8),
(253307, NULL, 'PTHR31998', NULL, NULL, NULL, NULL, 'K(+)-INSENSITIVE PYROPHOSPHATE-ENERGIZED PROTON PUMP', NULL, NULL, 2515, 8),
(253308, NULL, 'PTHR30460', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 37071, 8),
(253309, NULL, 'PTHR13369', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(253310, NULL, 'PTHR10285', NULL, NULL, NULL, NULL, 'URIDINE KINASE', NULL, NULL, NULL, 8),
(253311, NULL, 'PTHR22852', NULL, NULL, NULL, NULL, 'LETHAL 2 DENTICLELESS PROTEIN  RETINOIC ACID-REGULATED NUCLEAR MATRIX-ASSOCIATED PROTEIN', NULL, NULL, NULL, 8),
(253312, NULL, 'PTHR33994', NULL, NULL, NULL, NULL, 'OS04G0515000 PROTEIN', NULL, NULL, NULL, 8),
(253313, NULL, 'PTHR34287', NULL, NULL, NULL, NULL, 'OS06G0551500 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(253314, NULL, 'PTHR10445', NULL, NULL, NULL, NULL, 'GENERAL TRANSCRIPTION FACTOR IIF SUBUNIT 2', NULL, NULL, 3335, 8),
(253315, NULL, 'PTHR10139', NULL, NULL, NULL, NULL, 'DOUBLE-STRAND BREAK REPAIR PROTEIN MRE11', NULL, NULL, NULL, 8),
(253316, NULL, 'PTHR15458', NULL, NULL, NULL, NULL, 'PHOSPHATIDYLETHANOLAMINE N-METHYLTRANSFERASE', NULL, NULL, 23961, 8),
(253317, NULL, 'PTHR37397', NULL, NULL, NULL, NULL, 'SI:CH211-183D21.1', NULL, NULL, NULL, 8),
(253318, NULL, 'PTHR47663', NULL, NULL, NULL, NULL, 'XYLANOLYTIC TRANSCRIPTIONAL ACTIVATOR XLNR-RELATED', NULL, NULL, NULL, 8),
(253319, NULL, 'PTHR31936', NULL, NULL, NULL, NULL, 'PROTEIN CBG18744', NULL, NULL, NULL, 8),
(253320, NULL, 'PTHR31296', NULL, NULL, NULL, NULL, 'UPF0565 PROTEIN C2ORF69', NULL, NULL, 20847, 8),
(253321, NULL, 'PTHR13270', NULL, NULL, NULL, NULL, 'PROTEIN C20ORF116-RELATED', NULL, NULL, NULL, 8),
(253322, NULL, 'PTHR46389', NULL, NULL, NULL, NULL, 'POLYCOMB GROUP PROTEIN PC', NULL, NULL, NULL, 8),
(253323, NULL, 'PTHR16265', NULL, NULL, NULL, NULL, 'PTB-CONTAINING, CUBILIN AND LRP1-INTERACTING PROTEIN', NULL, NULL, 28070, 8),
(253324, NULL, 'PTHR14869', NULL, NULL, NULL, NULL, 'MYC TARGET PROTEIN 1', NULL, NULL, 21917, 8);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(253325, NULL, 'PTHR45460', NULL, NULL, NULL, NULL, 'SIMILAR TO CYSTEINE PROTEINASE', NULL, NULL, NULL, 8),
(253326, NULL, 'PTHR10868', NULL, NULL, NULL, NULL, 'SIGMA 1-TYPE OPIOID RECEPTOR-RELATED', NULL, NULL, 2012, 8),
(253327, NULL, 'PTHR34956', NULL, NULL, NULL, NULL, 'OS05G0397300 PROTEIN', NULL, NULL, NULL, 8),
(253328, NULL, 'PTHR38020', NULL, NULL, NULL, NULL, 'UROPORPHYRINOGEN-III SYNTHASE', NULL, NULL, NULL, 8),
(253329, NULL, 'PTHR34831', NULL, NULL, NULL, NULL, 'MIGRATION AND INVASION-INHIBITORY PROTEIN', NULL, NULL, 25666, 8),
(253330, NULL, 'PTHR40045', NULL, NULL, NULL, NULL, 'YCGG FAMILY PROTEIN', NULL, NULL, 7934, 8),
(253331, NULL, 'PTHR10677', NULL, NULL, NULL, NULL, 'UBIQUILIN', NULL, NULL, 9304, 8),
(253332, NULL, 'PTHR48008', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR-LIKE PROTEIN KINASE IMK3-RELATED', NULL, NULL, NULL, 8),
(253333, NULL, 'PTHR30001', NULL, NULL, NULL, NULL, 'RIBONUCLEASE', NULL, NULL, 2525, 8),
(253334, NULL, 'PTHR46877', NULL, NULL, NULL, NULL, 'EPH RECEPTOR A5', NULL, NULL, NULL, 8),
(253335, NULL, 'PTHR42929', NULL, NULL, NULL, NULL, 'INNER MEMBRANE ABC TRANSPORTER PERMEASE PROTEIN YDCU-RELATED-RELATED', NULL, NULL, NULL, 8),
(253336, NULL, 'PTHR46883', NULL, NULL, NULL, NULL, 'BARDET-BIEDL SYNDROME 12 PROTEIN', NULL, NULL, 35742, 8),
(253337, NULL, 'PTHR10569', NULL, NULL, NULL, NULL, 'GLYCOGEN DEBRANCHING ENZYME', NULL, NULL, 9026, 8),
(253338, NULL, 'PTHR36540', NULL, NULL, NULL, NULL, 'PYRIMIDINE/PURINE NUCLEOSIDE PHOSPHORYLASE', NULL, NULL, 11528, 8),
(253339, NULL, 'PTHR11157', NULL, NULL, NULL, NULL, 'FATTY ACID ACYL TRANSFERASE-RELATED', NULL, NULL, 5196, 8),
(253340, NULL, 'PTHR10370', NULL, NULL, NULL, NULL, 'ERYTHROPOIETIN', NULL, NULL, 7148, 8),
(253341, NULL, 'PTHR21422', NULL, NULL, NULL, NULL, 'RAB3 GTPASE-ACTIVATING PROTEIN CATALYTIC SUBUNIT', NULL, NULL, 37134, 8),
(253342, NULL, 'PTHR15128', NULL, NULL, NULL, NULL, 'TAL1  SCL  INTERRUPTING LOCUS', NULL, NULL, 25889, 8),
(253343, NULL, 'PTHR32370', NULL, NULL, NULL, NULL, 'OS12G0117600 PROTEIN', NULL, NULL, 35345, 8),
(253344, NULL, 'PTHR35717', NULL, NULL, NULL, NULL, 'OS05G0156200 PROTEIN', NULL, NULL, NULL, 8),
(253345, NULL, 'PTHR48090', NULL, NULL, NULL, NULL, 'UNDECAPRENYL-PHOSPHATE 4-DEOXY-4-FORMAMIDO-L-ARABINOSE TRANSFERASE-RELATED', NULL, NULL, NULL, 8),
(253346, NULL, 'PTHR16088', NULL, NULL, NULL, NULL, 'YY1 ASSOCIATED PROTEIN-RELATED', NULL, NULL, NULL, 8),
(253347, NULL, 'PTHR33205', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253348, NULL, 'PTHR38811', NULL, NULL, NULL, NULL, '', NULL, NULL, 4994, 8),
(253349, NULL, 'PTHR35393', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(253350, NULL, 'PTHR15035', NULL, NULL, NULL, NULL, 'CORTICOLIBERIN/UROCORTIN', NULL, NULL, 844, 8),
(253351, NULL, 'PTHR35980', NULL, NULL, NULL, NULL, 'NEUROPEPTIDE CCHAMIDE-1-RELATED', NULL, NULL, 33445, 8),
(253352, NULL, 'PTHR48213', NULL, NULL, NULL, NULL, 'VID27-LIKE PROTEIN', NULL, NULL, NULL, 8),
(253353, NULL, 'PTHR47440', NULL, NULL, NULL, NULL, 'RIKEN CDNA A430078G23 GENE', NULL, NULL, NULL, 8),
(253354, NULL, 'PTHR31831', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC689065', NULL, NULL, 24794, 8),
(253355, NULL, 'PTHR31780', NULL, NULL, NULL, NULL, 'STRESS RESPONSE PROTEIN NST1-RELATED', NULL, NULL, NULL, 8),
(253356, NULL, 'PTHR45898', NULL, NULL, NULL, NULL, 'TOM1-LIKE PROTEIN', NULL, NULL, 36422, 8),
(253357, NULL, 'PTHR39186', NULL, NULL, NULL, NULL, 'DUF2071 FAMILY PROTEIN', NULL, NULL, 16818, 8),
(253358, NULL, 'PTHR24127', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND EF-HAND DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, NULL, 8),
(253359, NULL, 'PTHR34390', NULL, NULL, NULL, NULL, 'UPF0442 PROTEIN YJJB-RELATED', NULL, NULL, NULL, 8),
(253360, NULL, 'PTHR13169', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE PROTEIN 3  HCG-1 PROTEIN', NULL, NULL, 27036, 8),
(253361, NULL, 'PTHR12707', NULL, NULL, NULL, NULL, 'PINN', NULL, NULL, 31294, 8),
(253362, NULL, 'PTHR15192', NULL, NULL, NULL, NULL, 'PROTEIN CBG05349', NULL, NULL, 25235, 8);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(253363, NULL, 'PTHR12814', NULL, NULL, NULL, NULL, 'RNA-BINDING PROTEIN NOB1', NULL, NULL, 30259, 8),
(253364, NULL, 'PTHR16236', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 160', NULL, NULL, 22242, 8),
(253365, NULL, 'PTHR38488', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE 9.5 KDA SUBUNIT, PUTATIVE (AFU_ORTHOLOGUE AFUA_5G08980)-RELATED', NULL, NULL, 27323, 8),
(253366, NULL, 'PTHR34284', NULL, NULL, NULL, NULL, 'FG-GAP REPEAT-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(253367, NULL, 'PTHR47314', NULL, NULL, NULL, NULL, 'MALTOSE/MALTODEXTRIN TRANSPORT SYSTEM PERMEASE PROTEIN MALF', NULL, NULL, NULL, 8),
(253368, NULL, 'PTHR43000', NULL, NULL, NULL, NULL, 'DTDP-D-GLUCOSE 4,6-DEHYDRATASE-RELATED', NULL, NULL, NULL, 8),
(253369, NULL, 'PTHR13192', NULL, NULL, NULL, NULL, 'MY011 PROTEIN', NULL, NULL, 15572, 8),
(253370, NULL, 'PTHR34065', NULL, NULL, NULL, NULL, 'CELL DIVISION CONTROL PROTEIN 14', NULL, NULL, 12954, 8),
(253371, NULL, 'PTHR47430', NULL, NULL, NULL, NULL, 'GB|AAC33480.1', NULL, NULL, NULL, 8),
(253372, NULL, 'PTHR47170', NULL, NULL, NULL, NULL, 'MALONYL-COA ACP TRANSACYLASE, ACP-BINDING', NULL, NULL, NULL, 8),
(253373, NULL, 'PTHR22794', NULL, NULL, NULL, NULL, 'THAP DOMAIN PROTEIN 11', NULL, NULL, NULL, 8),
(253374, NULL, 'PTHR36802', NULL, NULL, NULL, NULL, 'OS02G0815400 PROTEIN', NULL, NULL, NULL, 8),
(253375, NULL, 'PTHR36117', NULL, NULL, NULL, NULL, '4-HYDROXYPHENYLACETATE 3-MONOOXYGENASE-RELATED', NULL, NULL, 1914, 8),
(253376, NULL, 'PTHR11489', NULL, NULL, NULL, NULL, '40S RIBOSOMAL PROTEIN SA', NULL, NULL, 3620, 8),
(253377, NULL, 'PTHR37444', NULL, NULL, NULL, NULL, 'PROTEIN CBG24900-RELATED', NULL, NULL, NULL, 8),
(253378, NULL, 'PTHR10105', NULL, NULL, NULL, NULL, 'SELENOPROTEIN P', NULL, NULL, 29745, 8),
(253379, NULL, 'PTHR48068', NULL, NULL, NULL, NULL, 'TAF9 RNA POLYMERASE II, TATA BOX-BINDING PROTEIN (TBP)-ASSOCIATED FACTOR', NULL, NULL, NULL, 8),
(253380, NULL, 'PTHR24030', NULL, NULL, NULL, NULL, 'PROTEIN CMSS1', NULL, NULL, 21641, 8),
(253381, NULL, 'PTHR34543', NULL, NULL, NULL, NULL, 'PROTEIN ABA DEFICIENT 4, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(253382, NULL, 'PTHR36867', NULL, NULL, NULL, NULL, 'MCG131172, ISOFORM CRA_A', NULL, NULL, NULL, 8),
(253383, NULL, 'PTHR47378', NULL, NULL, NULL, NULL, 'DIVINYL CHLOROPHYLLIDE A 8-VINYL-REDUCTASE, CHLOROPLASTIC', NULL, NULL, 36336, 8),
(253384, NULL, 'PTHR37433', NULL, NULL, NULL, NULL, 'PROTEIN CBG25136-RELATED', NULL, NULL, NULL, 8),
(253385, NULL, 'PTHR28026', NULL, NULL, NULL, NULL, 'DUF962 DOMAIN PROTEIN (AFU_ORTHOLOGUE AFUA_8G05310)', NULL, NULL, 13663, 8),
(253386, NULL, 'PTHR10226', NULL, NULL, NULL, NULL, 'A KINASE ANCHOR PROTEIN', NULL, NULL, 7916, 8),
(253387, NULL, 'PTHR46074', NULL, NULL, NULL, NULL, 'CYSTEINE-RICH PROTEIN CRIP FAMILY MEMBER', NULL, NULL, NULL, 8),
(253388, NULL, 'PTHR13344', NULL, NULL, NULL, NULL, 'NADH-UBIQUINONE OXIDOREDUCTASE', NULL, NULL, 20100, 8),
(253389, NULL, 'PTHR45753', NULL, NULL, NULL, NULL, 'ORNITHINE CARBAMOYLTRANSFERASE, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(253390, NULL, 'PTHR47081', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253391, NULL, 'PTHR47204', NULL, NULL, NULL, NULL, 'OS02G0168900 PROTEIN', NULL, NULL, NULL, 8),
(253392, NULL, 'PTHR12683', NULL, NULL, NULL, NULL, 'CDK-ACTIVATING KINASE ASSEMBLY FACTOR MAT1', NULL, NULL, NULL, 8),
(253393, NULL, 'PTHR14649', NULL, NULL, NULL, NULL, 'ZINC FINGER C2HC DOMAIN-CONTAINING PROTEIN 1C', NULL, NULL, 25490, 8),
(253394, NULL, 'PTHR42720', NULL, NULL, NULL, NULL, 'GLYCEROL-3-PHOSPHATE DEHYDROGENASE', NULL, NULL, NULL, 8),
(253395, NULL, 'PTHR22602', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 34312, 8),
(253396, NULL, 'PTHR46880', NULL, NULL, NULL, NULL, 'RAS-ASSOCIATING DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(253397, NULL, 'PTHR21089', NULL, NULL, NULL, NULL, 'SHIKIMATE DEHYDROGENASE', NULL, NULL, 14737, 8),
(253398, NULL, 'PTHR31251', NULL, NULL, NULL, NULL, 'SQUAMOSA PROMOTER-BINDING-LIKE PROTEIN 4', NULL, NULL, 36195, 8),
(253399, NULL, 'PTHR13707', NULL, NULL, NULL, NULL, 'KETOACID-COENZYME A TRANSFERASE', NULL, NULL, 2966, 8);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(253400, NULL, 'PTHR46952', NULL, NULL, NULL, NULL, 'SERPENTINE RECEPTOR, CLASS X-RELATED', NULL, NULL, NULL, 8),
(253401, NULL, 'PTHR46398', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(253402, NULL, 'PTHR16982', NULL, NULL, NULL, NULL, 'LYMPHOCYTE ANTIGEN 6D', NULL, NULL, 36182, 8),
(253403, NULL, 'PTHR39550', NULL, NULL, NULL, NULL, 'SLL0658 PROTEIN', NULL, NULL, NULL, 8),
(253404, NULL, 'PTHR44974', NULL, NULL, NULL, NULL, 'V-SET AND IMMUNOGLOBULIN DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, 25606, 8),
(253405, NULL, 'PTHR35529', NULL, NULL, NULL, NULL, 'MANGANESE EFFLUX PUMP MNTP-RELATED', NULL, NULL, 3411, 8),
(253406, NULL, 'PTHR45792', NULL, NULL, NULL, NULL, 'DIACYLGLYCEROL LIPASE HOMOLOG-RELATED', NULL, NULL, NULL, 8),
(253407, NULL, 'PTHR43223', NULL, NULL, NULL, NULL, 'ALKYL/ARYL-SULFATASE', NULL, NULL, NULL, 8),
(253408, NULL, 'PTHR19338', NULL, NULL, NULL, NULL, 'TRANSLOCASE OF INNER MITOCHONDRIAL MEMBRANE 13 HOMOLOG', NULL, NULL, 33303, 8),
(253409, NULL, 'PTHR10912', NULL, NULL, NULL, NULL, 'ADP-RIBOSYL CYCLASE', NULL, NULL, 1761, 8),
(253410, NULL, 'PTHR35772', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II REACTION CENTER PROTEIN I', NULL, NULL, 1606, 8),
(253411, NULL, 'PTHR47880', NULL, NULL, NULL, NULL, 'OS05G0353300 PROTEIN', NULL, NULL, NULL, 8),
(253412, NULL, 'PTHR37835', NULL, NULL, NULL, NULL, 'ALPHA-CLOSTRIPAIN', NULL, NULL, 10283, 8),
(253413, NULL, 'PTHR12133', NULL, NULL, NULL, NULL, 'TRNA (ADENINE(58)-N(1))-METHYLTRANSFERASE', NULL, NULL, 11881, 8),
(253414, NULL, 'PTHR31366', NULL, NULL, NULL, NULL, 'UPF0739 PROTEIN C1ORF74', NULL, NULL, 25908, 8),
(253415, NULL, 'PTHR40622', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253416, NULL, 'PTHR33055', NULL, NULL, NULL, NULL, 'TRANSPOSASE FOR INSERTION SEQUENCE ELEMENT IS1111A', NULL, NULL, NULL, 8),
(253417, NULL, 'PTHR48079', NULL, NULL, NULL, NULL, 'PROTEIN YEEZ', NULL, NULL, NULL, 8),
(253418, NULL, 'PTHR24074', NULL, NULL, NULL, NULL, 'CO-CHAPERONE PROTEIN DJLA', NULL, NULL, NULL, 8),
(253419, NULL, 'PTHR48287', NULL, NULL, NULL, NULL, 'ARM REPEAT SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(253420, NULL, 'PTHR16200', NULL, NULL, NULL, NULL, 'RING ZINC FINGER', NULL, NULL, NULL, 8),
(253421, NULL, 'PTHR12834', NULL, NULL, NULL, NULL, 'SIGNAL RECOGNITION PARTICLE 9 KDA PROTEIN', NULL, NULL, 27262, 8),
(253422, NULL, 'PTHR46620', NULL, NULL, NULL, NULL, 'J DOMAIN-CONTAINING PROTEIN SPF31', NULL, NULL, NULL, 8),
(253423, NULL, 'PTHR37426', NULL, NULL, NULL, NULL, 'RIBOSOMAL RNA LARGE SUBUNIT METHYLTRANSFERASE J', NULL, NULL, 4868, 8),
(253424, NULL, 'PTHR39654', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253425, NULL, 'PTHR31564', NULL, NULL, NULL, NULL, 'ANAPHASE-PROMOTING COMPLEX SUBUNIT 16', NULL, NULL, 25810, 8),
(253426, NULL, 'PTHR24219', NULL, NULL, NULL, NULL, 'LIM DOMAIN-CONTAINING PROTEIN JUB', NULL, NULL, NULL, 8),
(253427, NULL, 'PTHR15726', NULL, NULL, NULL, NULL, 'RAB11-FAMILY INTERACTING PROTEIN', NULL, NULL, NULL, 8),
(253428, NULL, 'PTHR33777', NULL, NULL, NULL, NULL, 'UPF0045 PROTEIN ECM15', NULL, NULL, NULL, 8),
(253429, NULL, 'PTHR21014', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 18290, 8),
(253430, NULL, 'PTHR36937', NULL, NULL, NULL, NULL, 'PROTEIN CBG20935-RELATED', NULL, NULL, NULL, 8),
(253431, NULL, 'PTHR11639', NULL, NULL, NULL, NULL, 'S100 CALCIUM-BINDING PROTEIN', NULL, NULL, NULL, 8),
(253432, NULL, 'PTHR13473', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RIBOSOMAL PROTEIN L48', NULL, NULL, 25777, 8),
(253433, NULL, 'PTHR46392', NULL, NULL, NULL, NULL, 'DUAL SERINE/THREONINE AND TYROSINE PROTEIN KINASE', NULL, NULL, NULL, 8),
(253434, NULL, 'PTHR43701', NULL, NULL, NULL, NULL, 'MEMBRANE TRANSPORTER PROTEIN MJ0441-RELATED', NULL, NULL, NULL, 8),
(253435, NULL, 'PTHR43319', NULL, NULL, NULL, NULL, 'BETA-LACTAMASE-RELATED', NULL, NULL, NULL, 8),
(253436, NULL, 'PTHR19918', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE 20  CDC20   FIZZY -RELATED', NULL, NULL, 27276, 8),
(253437, NULL, 'PTHR36812', NULL, NULL, NULL, NULL, 'NEUROFILAMENT TRIPLET M PROTEIN-LIKE PROTEIN', NULL, NULL, NULL, 8);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(253438, NULL, 'PTHR31189', NULL, NULL, NULL, NULL, 'OS03G0336100 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(253439, NULL, 'PTHR15581', NULL, NULL, NULL, NULL, 'CENTROMERE PROTEIN R', NULL, NULL, 1718, 8),
(253440, NULL, 'PTHR13416', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 13189, 8),
(253441, NULL, 'PTHR37685', NULL, NULL, NULL, NULL, 'GEO11136P1-RELATED', NULL, NULL, 24133, 8),
(253442, NULL, 'PTHR43126', NULL, NULL, NULL, NULL, 'D-ALANYL-D-ALANINE DIPEPTIDASE', NULL, NULL, NULL, 8),
(253443, NULL, 'PTHR36303', NULL, NULL, NULL, NULL, '2'',3''-CYCLIC-NUCLEOTIDE 2''-PHOSPHODIESTERASE', NULL, NULL, 11412, 8),
(253444, NULL, 'PTHR23267', NULL, NULL, NULL, NULL, 'IMMUNOGLOBULIN LIGHT CHAIN', NULL, NULL, NULL, 8),
(253445, NULL, 'PTHR34153', NULL, NULL, NULL, NULL, 'SI:CH211-262H13.3-RELATED-RELATED', NULL, NULL, NULL, 8),
(253446, NULL, 'PTHR15739', NULL, NULL, NULL, NULL, 'ZINC FINGER PROTEIN', NULL, NULL, NULL, 8),
(253447, NULL, 'PTHR31993', NULL, NULL, NULL, NULL, 'UBA-LIKE DOMAIN-CONTAINING PROTEIN 2', NULL, NULL, 27225, 8),
(253448, NULL, 'PTHR46258', NULL, NULL, NULL, NULL, 'LONGIN DOMAIN-CONTAINING PROTEIN', NULL, NULL, 35672, 8),
(253449, NULL, 'PTHR33309', NULL, NULL, NULL, NULL, 'KERATIN, ULTRA HIGH-SULFUR MATRIX PROTEIN-LIKE', NULL, NULL, NULL, 8),
(253450, NULL, 'PTHR42862', NULL, NULL, NULL, NULL, 'DELTA-1-PYRROLINE-5-CARBOXYLATE DEHYDROGENASE 1, ISOFORM A-RELATED', NULL, NULL, NULL, 8),
(253451, NULL, 'PTHR34700', NULL, NULL, NULL, NULL, 'POTASSIUM BINDING PROTEIN KBP', NULL, NULL, NULL, 8),
(253452, NULL, 'PTHR10345', NULL, NULL, NULL, NULL, 'BONE SIALOPROTEIN 2', NULL, NULL, 8920, 8),
(253453, NULL, 'PTHR24292', NULL, NULL, NULL, NULL, 'CYTOCHROME P450', NULL, NULL, NULL, 8),
(253454, NULL, 'PTHR13452', NULL, NULL, NULL, NULL, 'THUMP DOMAIN CONTAINING PROTEIN 1-RELATED', NULL, NULL, 33466, 8),
(253455, NULL, 'PTHR33392', NULL, NULL, NULL, NULL, 'POLYISOPRENYL-TEICHOIC ACID--PEPTIDOGLYCAN TEICHOIC ACID TRANSFERASE TAGU', NULL, NULL, NULL, 8),
(253456, NULL, 'PTHR30050', NULL, NULL, NULL, NULL, 'CHROMOSOMAL REPLICATION INITIATOR PROTEIN DNAA', NULL, NULL, NULL, 8),
(253457, NULL, 'PTHR31021', NULL, NULL, NULL, NULL, 'ADENOMATOSIS POLYPOSIS COLI DOWN-REGULATED 1', NULL, NULL, 34063, 8),
(253458, NULL, 'PTHR12517', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN 13B', NULL, NULL, 33375, 8),
(253459, NULL, 'PTHR21345', NULL, NULL, NULL, NULL, 'SPIRE', NULL, NULL, 25277, 8),
(253460, NULL, 'PTHR21139', NULL, NULL, NULL, NULL, 'TRIOSEPHOSPHATE ISOMERASE', NULL, NULL, 4335, 8),
(253461, NULL, 'PTHR46302', NULL, NULL, NULL, NULL, 'DOUBLECORTIN DOMAIN-CONTAINING PROTEIN 1', NULL, NULL, 34867, 8),
(253462, NULL, 'PTHR10947', NULL, NULL, NULL, NULL, 'PHENYLALANYL-TRNA SYNTHETASE BETA CHAIN AND LEUCINE-RICH REPEAT-CONTAINING PROTEIN 47', NULL, NULL, 34247, 8),
(253463, NULL, 'PTHR31422', NULL, NULL, NULL, NULL, 'BNAANNG28530D PROTEIN', NULL, NULL, NULL, 8),
(253464, NULL, 'PTHR47965', NULL, NULL, NULL, NULL, 'ASPARTYL PROTEASE-RELATED', NULL, NULL, 6342, 8),
(253465, NULL, 'PTHR18905', NULL, NULL, NULL, NULL, 'NINEIN', NULL, NULL, NULL, 8),
(253466, NULL, 'PTHR30600', NULL, NULL, NULL, NULL, 'CYTOCHROME C PEROXIDASE-RELATED', NULL, NULL, NULL, 8),
(253467, NULL, 'PTHR12334', NULL, NULL, NULL, NULL, 'BAG FAMILY MOLECULAR CHAPERONE REGULATOR 2', NULL, NULL, 27522, 8),
(253468, NULL, 'PTHR31479', NULL, NULL, NULL, NULL, 'ALPHA/BETA-HYDROLASES SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(253469, NULL, 'PTHR34266', NULL, NULL, NULL, NULL, 'THIAZOLE SYNTHASE', NULL, NULL, 7821, 8),
(253470, NULL, 'PTHR38103', NULL, NULL, NULL, NULL, 'RECOMBINATION-ASSOCIATED PROTEIN RDGC', NULL, NULL, 2379, 8),
(253471, NULL, 'PTHR47829', NULL, NULL, NULL, NULL, 'HYDROLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_1G12880)-RELATED', NULL, NULL, NULL, 8),
(253472, NULL, 'PTHR14038', NULL, NULL, NULL, NULL, 'BAT2  HLA-B-ASSOCIATED TRANSCRIPT 2', NULL, NULL, 29315, 8),
(253473, NULL, 'PTHR13769', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN B', NULL, NULL, NULL, 8),
(253474, NULL, 'PTHR43467', NULL, NULL, NULL, NULL, 'COBALT-PRECORRIN-2 C(20)-METHYLTRANSFERASE', NULL, NULL, NULL, 8);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(253475, NULL, 'PTHR14679', NULL, NULL, NULL, NULL, 'GEM-ASSOCIATED PROTEIN 7', NULL, NULL, 19995, 8),
(253476, NULL, 'PTHR21419', NULL, NULL, NULL, NULL, '', NULL, NULL, 36431, 8),
(253477, NULL, 'PTHR11505', NULL, NULL, NULL, NULL, 'L1 TRANSPOSABLE ELEMENT-RELATED', NULL, NULL, 3721, 8),
(253478, NULL, 'PTHR11707', NULL, NULL, NULL, NULL, 'L-ASPARAGINASE', NULL, NULL, NULL, 8),
(253479, NULL, 'PTHR36722', NULL, NULL, NULL, NULL, 'TYPE 2 DNA TOPOISOMERASE 6 SUBUNIT B-LIKE', NULL, NULL, 3815, 8),
(253480, NULL, 'PTHR31889', NULL, NULL, NULL, NULL, 'FUCOSYLTRANSFERASE 2-RELATED', NULL, NULL, 1924, 8),
(253481, NULL, 'PTHR15835', NULL, NULL, NULL, NULL, 'NUCLEAR-INTERACTING PARTNER OF ALK', NULL, NULL, NULL, 8),
(253482, NULL, 'PTHR34033', NULL, NULL, NULL, NULL, 'AP-5 COMPLEX SUBUNIT BETA-1', NULL, NULL, 32208, 8),
(253483, NULL, 'PTHR45632', NULL, NULL, NULL, NULL, 'LD33804P', NULL, NULL, NULL, 8),
(253484, NULL, 'PTHR47225', NULL, NULL, NULL, NULL, 'EF-HAND CALCIUM-BINDING DOMAIN-CONTAINING PROTEIN 12', NULL, NULL, 35226, 8),
(253485, NULL, 'PTHR42834', NULL, NULL, NULL, NULL, 'ENDONUCLEASE/EXONUCLEASE/PHOSPHATASE FAMILY PROTEIN (AFU_ORTHOLOGUE AFUA_3G09210)', NULL, NULL, NULL, 8),
(253486, NULL, 'PTHR44157', NULL, NULL, NULL, NULL, 'DNAJ HOMOLOG SUBFAMILY C MEMBER 11', NULL, NULL, NULL, 8),
(253487, NULL, 'PTHR12891', NULL, NULL, NULL, NULL, 'DNA REPAIR/TRANSCRIPTION PROTEIN MET18/MMS19', NULL, NULL, 27269, 8),
(253488, NULL, 'PTHR39649', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L40E', NULL, NULL, 16292, 8),
(253489, NULL, 'PTHR36482', NULL, NULL, NULL, NULL, 'OSJNBA0024J22.15 PROTEIN', NULL, NULL, NULL, 8),
(253490, NULL, 'PTHR12352', NULL, NULL, NULL, NULL, 'SECRETED MODULAR CALCIUM-BINDING PROTEIN', NULL, NULL, NULL, 8),
(253491, NULL, 'PTHR12232', NULL, NULL, NULL, NULL, 'SH3 DOMAIN-BINDING GLUTAMIC ACID-RICH-LIKE PROTEIN', NULL, NULL, NULL, 8),
(253492, NULL, 'PTHR42680', NULL, NULL, NULL, NULL, 'DCTP DEAMINASE', NULL, NULL, NULL, 8),
(253493, NULL, 'PTHR37418', NULL, NULL, NULL, NULL, '3-KETO-5-AMINOHEXANOATE CLEAVAGE ENZYME-RELATED', NULL, NULL, 13093, 8),
(253494, NULL, 'PTHR32096', NULL, NULL, NULL, NULL, 'WRKY TRANSCRIPTION FACTOR 30-RELATED-RELATED', NULL, NULL, 34764, 8),
(253495, NULL, 'PTHR24121', NULL, NULL, NULL, NULL, 'NO MECHANORECEPTOR POTENTIAL C, ISOFORM D-RELATED', NULL, NULL, NULL, 8),
(253496, NULL, 'PTHR31492', NULL, NULL, NULL, NULL, 'M CELL-TYPE AGGLUTINATION PROTEIN MAM3-RELATED', NULL, NULL, NULL, 8),
(253497, NULL, 'PTHR45523', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(253498, NULL, 'PTHR20898', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(253499, NULL, 'PTHR45813', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253500, NULL, 'PTHR37178', NULL, NULL, NULL, NULL, 'PLANT/PROTEIN', NULL, NULL, NULL, 8),
(253501, NULL, 'PTHR12730', NULL, NULL, NULL, NULL, 'HSDA/SDA1-RELATED', NULL, NULL, 24044, 8),
(253502, NULL, 'PTHR48055', NULL, NULL, NULL, NULL, 'LEUCINE-RICH REPEAT RECEPTOR PROTEIN KINASE EMS1', NULL, NULL, NULL, 8),
(253503, NULL, 'PTHR21534', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 24284, 8),
(253504, NULL, 'PTHR39647', NULL, NULL, NULL, NULL, 'ELONGATION FACTOR 1-BETA', NULL, NULL, 1782, 8),
(253505, NULL, 'PTHR35442', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 249', NULL, NULL, 25880, 8),
(253506, NULL, 'PTHR46929', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(253507, NULL, 'PTHR46430', NULL, NULL, NULL, NULL, 'PROTEIN SKT5-RELATED', NULL, NULL, NULL, 8),
(253508, NULL, 'PTHR35814', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253509, NULL, 'PTHR31622', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 218', NULL, NULL, 24057, 8),
(253510, NULL, 'PTHR33828', NULL, NULL, NULL, NULL, 'OS05G0596200 PROTEIN', NULL, NULL, NULL, 8),
(253511, NULL, 'PTHR34226', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253512, NULL, 'PTHR23051', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 35, MEMBER F5', NULL, NULL, NULL, 8);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(253513, NULL, 'PTHR36344', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253514, NULL, 'PTHR21516', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(253515, NULL, 'PTHR35773', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253516, NULL, 'PTHR36060', NULL, NULL, NULL, NULL, 'OS02G0272400 PROTEIN', NULL, NULL, NULL, 8),
(253517, NULL, 'PTHR42078', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253518, NULL, 'PTHR46404', NULL, NULL, NULL, NULL, 'DNA POLYMERASE IOTA', NULL, NULL, NULL, 8),
(253519, NULL, 'PTHR42989', NULL, NULL, NULL, NULL, 'HYDROGENASE-4 COMPONENT I', NULL, NULL, NULL, 8),
(253520, NULL, 'PTHR12888', NULL, NULL, NULL, NULL, 'PEROXISOME ASSEMBLY PROTEIN 12  PEROXIN-12', NULL, NULL, 17520, 8),
(253521, NULL, 'PTHR17463', NULL, NULL, NULL, NULL, 'SCRAPIE-RESPONSIVE PROTEIN 1 SCRG1', NULL, NULL, 25442, 8),
(253522, NULL, 'PTHR23288', NULL, NULL, NULL, NULL, 'OCCLUDIN AND RNA POLYMERASE II ELONGATION FACTOR ELL', NULL, NULL, 25817, 8),
(253523, NULL, 'PTHR31384', NULL, NULL, NULL, NULL, 'AUXIN RESPONSE FACTOR 4-RELATED', NULL, NULL, 34826, 8),
(253524, NULL, 'PTHR10114', NULL, NULL, NULL, NULL, '60S RIBOSOMAL PROTEIN L36', NULL, NULL, 5592, 8),
(253525, NULL, 'PTHR10527', NULL, NULL, NULL, NULL, 'IMPORTIN BETA', NULL, NULL, 29382, 8),
(253526, NULL, 'PTHR42934', NULL, NULL, NULL, NULL, 'GLYCOLATE OXIDASE SUBUNIT GLCD', NULL, NULL, NULL, 8),
(253527, NULL, 'PTHR14694', NULL, NULL, NULL, NULL, 'CALCIUM-RESPONSIVE TRANSCRIPTION FACTOR', NULL, NULL, 24740, 8),
(253528, NULL, 'PTHR10418', NULL, NULL, NULL, NULL, 'SECURIN-3', NULL, NULL, 5746, 8),
(253529, NULL, 'PTHR33326', NULL, NULL, NULL, NULL, 'OS05G0543800 PROTEIN', NULL, NULL, NULL, 8),
(253530, NULL, 'PTHR14274', NULL, NULL, NULL, NULL, 'SMALL INTEGRAL MEMBRANE PROTEIN 8', NULL, NULL, 25714, 8),
(253531, NULL, 'PTHR15211', NULL, NULL, NULL, NULL, 'GLUCOSE-DEPENDENT INSULINOTROPIC POLYPEPTIDE', NULL, NULL, 32992, 8),
(253532, NULL, 'PTHR15840', NULL, NULL, NULL, NULL, 'CGI-121 FAMILY MEMBER', NULL, NULL, 14227, 8),
(253533, NULL, 'PTHR46193', NULL, NULL, NULL, NULL, '6-PHOSPHOGLUCONATE PHOSPHATASE', NULL, NULL, NULL, 8),
(253534, NULL, 'PTHR17378', NULL, NULL, NULL, NULL, 'SECRETIN', NULL, NULL, 18038, 8),
(253535, NULL, 'PTHR10491', NULL, NULL, NULL, NULL, 'DTDP-4-DEHYDRORHAMNOSE REDUCTASE', NULL, NULL, 75, 8),
(253536, NULL, 'PTHR35270', NULL, NULL, NULL, NULL, 'FUSELESS, ISOFORM A', NULL, NULL, 22137, 8),
(253537, NULL, 'PTHR37820', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN DIVIB', NULL, NULL, NULL, 8),
(253538, NULL, 'PTHR12555', NULL, NULL, NULL, NULL, 'UBIQUITIN FUSION DEGRADATON PROTEIN 1', NULL, NULL, 7025, 8),
(253539, NULL, 'PTHR48019', NULL, NULL, NULL, NULL, 'SERUM RESPONSE FACTOR HOMOLOG', NULL, NULL, NULL, 8),
(253540, NULL, 'PTHR42883', NULL, NULL, NULL, NULL, 'GLUCOSE-1-PHOSPHATE THYMIDYLTRANSFERASE', NULL, NULL, NULL, 8),
(253541, NULL, 'PTHR46720', NULL, NULL, NULL, NULL, 'HYDROXYLASE, PUTATIVE (AFU_ORTHOLOGUE AFUA_3G01460)-RELATED', NULL, NULL, NULL, 8),
(253542, NULL, 'PTHR43684', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253543, NULL, 'PTHR10960', NULL, NULL, NULL, NULL, 'V D J RECOMBINATION-ACTIVATING PROTEIN 2', NULL, NULL, 4770, 8),
(253544, NULL, 'PTHR21600', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL RNA PSEUDOURIDINE SYNTHASE', NULL, NULL, NULL, 8),
(253545, NULL, 'PTHR31874', NULL, NULL, NULL, NULL, 'CCT MOTIF FAMILY PROTEIN, EXPRESSED', NULL, NULL, NULL, 8),
(253546, NULL, 'PTHR12688', NULL, NULL, NULL, NULL, 'DYNEIN LIGHT INTERMEDIATE CHAIN', NULL, NULL, 12095, 8),
(253547, NULL, 'PTHR43638', NULL, NULL, NULL, NULL, 'OXIDOREDUCTASE, ALDO/KETO REDUCTASE FAMILY PROTEIN', NULL, NULL, NULL, 8),
(253548, NULL, 'PTHR16795', NULL, NULL, NULL, NULL, 'LIMBIN/ELLIS-VAN CREVELD PROTEIN', NULL, NULL, 23185, 8),
(253549, NULL, 'PTHR20993', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(253550, NULL, 'PTHR12589', NULL, NULL, NULL, NULL, 'PYRUVOYL TETRAHYDROBIOPTERIN SYNTHASE', NULL, NULL, 26, 8),
(253551, NULL, 'PTHR35602', NULL, NULL, NULL, NULL, 'ESTERASE YQIA-RELATED', NULL, NULL, 7817, 8);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(253552, NULL, 'PTHR30478', NULL, NULL, NULL, NULL, 'DNA POLYMERASE III SUBUNIT BETA', NULL, NULL, 4499, 8),
(253553, NULL, 'PTHR38389', NULL, NULL, NULL, NULL, 'DNA-DIRECTED RNA POLYMERASE SUBUNIT BETA', NULL, NULL, NULL, 8),
(253554, NULL, 'PTHR45029', NULL, NULL, NULL, NULL, 'CARBOXYLIC ESTER HYDROLASE-RELATED', NULL, NULL, 34451, 8),
(253555, NULL, 'PTHR46982', NULL, NULL, NULL, NULL, 'CITRATE/OXOGLUTARATE CARRIER PROTEIN', NULL, NULL, NULL, 8),
(253556, NULL, 'PTHR43842', NULL, NULL, NULL, NULL, 'PROPIONYL-COA CARBOXYLASE BETA CHAIN', NULL, NULL, NULL, 8),
(253557, NULL, 'PTHR10157', NULL, NULL, NULL, NULL, 'DOPAMINE BETA HYDROXYLASE RELATED', NULL, NULL, 3250, 8),
(253558, NULL, 'PTHR46164', NULL, NULL, NULL, NULL, 'ATF6, ISOFORM C', NULL, NULL, NULL, 8),
(253559, NULL, 'PTHR47967', NULL, NULL, NULL, NULL, 'OS07G0603500 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(253560, NULL, 'PTHR37750', NULL, NULL, NULL, NULL, 'COX19-LIKE CHCH FAMILY PROTEIN', NULL, NULL, NULL, 8),
(253561, NULL, 'PTHR44791', NULL, NULL, NULL, NULL, 'TELOMERASE PROTEIN COMPONENT 1 TEP1', NULL, NULL, NULL, 8),
(253562, NULL, 'PTHR42115', NULL, NULL, NULL, NULL, 'BETA-SYNTHASE (BETA-THIONASE), PUTATIVE (AFU_ORTHOLOGUE AFUA_3G08420)-RELATED', NULL, NULL, NULL, 8),
(253563, NULL, 'PTHR15681', NULL, NULL, NULL, NULL, 'MAD2L1-BINDING PROTEIN', NULL, NULL, 9218, 8),
(253564, NULL, 'PTHR16736', NULL, NULL, NULL, NULL, 'CORTEXIN-1-RELATED', NULL, NULL, 11969, 8),
(253565, NULL, 'PTHR16277', NULL, NULL, NULL, NULL, 'CELL DIVISION CYCLE ASSOCIATED PROTEIN 4/SERTA DOMAIN-CONTAINING PROTEIN 2', NULL, NULL, NULL, 8),
(253566, NULL, 'PTHR15936', NULL, NULL, NULL, NULL, 'GUANINE NUCLEOTIDE-BINDING PROTEIN G I /G S /G O  GAMMA-13 SUBUNIT', NULL, NULL, 32865, 8),
(253567, NULL, 'PTHR47855', NULL, NULL, NULL, NULL, 'OS01G0525701 PROTEIN', NULL, NULL, NULL, 8),
(253568, NULL, 'PTHR46918', NULL, NULL, NULL, NULL, 'SYNAPTONEMAL COMPLEX PROTEIN 1', NULL, NULL, 13849, 8),
(253569, NULL, 'PTHR31835', NULL, NULL, NULL, NULL, 'URIDINE DIPHOSPHATE GLUCOSE PYROPHOSPHATASE', NULL, NULL, NULL, 8),
(253570, NULL, 'PTHR47082', NULL, NULL, NULL, NULL, 'KERATIN-LIKE PROTEIN KRT222', NULL, NULL, NULL, 8),
(253571, NULL, 'PTHR43709', NULL, NULL, NULL, NULL, 'ACONITATE ISOMERASE-RELATED', NULL, NULL, 3782, 8),
(253572, NULL, 'PTHR11589', NULL, NULL, NULL, NULL, 'NERVE GROWTH FACTOR  NGF -RELATED', NULL, NULL, 18556, 8),
(253573, NULL, 'PTHR46549', NULL, NULL, NULL, NULL, 'MACPF DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(253574, NULL, 'PTHR46871', NULL, NULL, NULL, NULL, 'BROMO-ADJACENT HOMOLOGY (BAH) DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(253575, NULL, 'PTHR15074', NULL, NULL, NULL, NULL, 'METHYL-CPG-BINDING PROTEIN', NULL, NULL, 36510, 8),
(253576, NULL, 'PTHR35460', NULL, NULL, NULL, NULL, 'TRNA LIGASE 1', NULL, NULL, 32320, 8),
(253577, NULL, 'PTHR36740', NULL, NULL, NULL, NULL, 'PRC DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(253578, NULL, 'PTHR15736', NULL, NULL, NULL, NULL, 'PROTEIN FAM131B-RELATED', NULL, NULL, 25621, 8),
(253579, NULL, 'PTHR30607', NULL, NULL, NULL, NULL, 'POTASSIUM-TRANSPORTING ATPASE A CHAIN', NULL, NULL, 2414, 8),
(253580, NULL, 'PTHR48015', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN KINASE TAO', NULL, NULL, NULL, 8),
(253581, NULL, 'PTHR27002', NULL, NULL, NULL, NULL, 'RECEPTOR-LIKE SERINE/THREONINE-PROTEIN KINASE SD1-8', NULL, NULL, NULL, 8),
(253582, NULL, 'PTHR13556', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL ADAPTER 3-RELATED', NULL, NULL, 15942, 8),
(253583, NULL, 'PTHR28570', NULL, NULL, NULL, NULL, 'ASPARTYL AMINOPEPTIDASE', NULL, NULL, 4387, 8),
(253584, NULL, 'PTHR22100', NULL, NULL, NULL, NULL, 'WINGS APART-LIKE PROTEIN HOMOLOG', NULL, NULL, 32195, 8),
(253585, NULL, 'PTHR43800', NULL, NULL, NULL, NULL, 'PEPTIDYL-LYSINE N-ACETYLTRANSFERASE YJAB', NULL, NULL, NULL, 8),
(253586, NULL, 'PTHR16209', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253587, NULL, 'PTHR31662', NULL, NULL, NULL, NULL, 'BNAANNG10740D PROTEIN-RELATED', NULL, NULL, 2635, 8),
(253588, NULL, 'PTHR23500', NULL, NULL, NULL, NULL, 'SOLUTE CARRIER FAMILY 2, FACILITATED GLUCOSE TRANSPORTER', NULL, NULL, 35904, 8);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(253589, NULL, 'PTHR14932', NULL, NULL, NULL, NULL, 'RAS GTPASE-RELATED', NULL, NULL, 29033, 8),
(253590, NULL, 'PTHR14491', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(253591, NULL, 'PTHR21621', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN S6 MODIFICATION PROTEIN', NULL, NULL, NULL, 8),
(253592, NULL, 'PTHR48095', NULL, NULL, NULL, NULL, 'PYRUVATE CARBOXYLASE SUBUNIT A', NULL, NULL, NULL, 8),
(253593, NULL, 'PTHR37183', NULL, NULL, NULL, NULL, 'PLANT THIONIN FAMILY PROTEIN', NULL, NULL, NULL, 8),
(253594, NULL, 'PTHR36464', NULL, NULL, NULL, NULL, 'PROTEIN BEAN1', NULL, NULL, 33211, 8),
(253595, NULL, 'PTHR13962', NULL, NULL, NULL, NULL, 'FORKHEAD BOX PROTEIN N3-LIKE PROTEIN-RELATED', NULL, NULL, NULL, 8),
(253596, NULL, 'PTHR36359', NULL, NULL, NULL, NULL, 'PROTEIN RESISTANCE TO PHYTOPHTHORA 1, CHLOROPLASTIC', NULL, NULL, 35401, 8),
(253597, NULL, 'PTHR30389', NULL, NULL, NULL, NULL, 'FUMARATE HYDRATASE-RELATED', NULL, NULL, NULL, 8),
(253598, NULL, 'PTHR31262', NULL, NULL, NULL, NULL, 'RIBULOSE BISPHOSPHATE CARBOXYLASE SMALL CHAIN 1, CHLOROPLASTIC', NULL, NULL, 24793, 8),
(253599, NULL, 'PTHR32026', NULL, NULL, NULL, NULL, 'METHYLTRANSFERASE-LIKE PROTEIN 24', NULL, NULL, 26754, 8),
(253600, NULL, 'PTHR35580', NULL, NULL, NULL, NULL, 'CELL SURFACE GLYCOPROTEIN (S-LAYER PROTEIN)-LIKE PROTEIN', NULL, NULL, NULL, 8),
(253601, NULL, 'PTHR38782', NULL, NULL, NULL, NULL, '', NULL, NULL, 1838, 8),
(253602, NULL, 'PTHR42210', NULL, NULL, NULL, NULL, 'DNA POLYMERASE II LARGE SUBUNIT', NULL, NULL, 7416, 8),
(253603, NULL, 'PTHR24027', NULL, NULL, NULL, NULL, 'CADHERIN-23', NULL, NULL, 28034, 8),
(253604, NULL, 'PTHR37860', NULL, NULL, NULL, NULL, 'AGAP008810-PA', NULL, NULL, NULL, 8),
(253605, NULL, 'PTHR34229', NULL, NULL, NULL, NULL, 'METAL TRANSPORT PROTEIN HI_1621-RELATED', NULL, NULL, NULL, 8),
(253606, NULL, 'PTHR33910', NULL, NULL, NULL, NULL, 'PROTEIN TRANSLOCASE SUBUNIT SECE', NULL, NULL, 5805, 8),
(253607, NULL, 'PTHR47136', NULL, NULL, NULL, NULL, 'SYNEMIN', NULL, NULL, 23838, 8),
(253608, NULL, 'PTHR14508', NULL, NULL, NULL, NULL, 'SNRPN UPSTREAM READING FRAME PROTEIN, SNURF', NULL, NULL, 13581, 8),
(253609, NULL, 'PTHR13539', NULL, NULL, NULL, NULL, 'CALMODULIN-LYSINE N-METHYLTRANSFERASE', NULL, NULL, 23118, 8),
(253610, NULL, 'PTHR34283', NULL, NULL, NULL, NULL, 'PROTEIN RESPONSE TO LOW SULFUR 1', NULL, NULL, 32784, 8),
(253611, NULL, 'PTHR47243', NULL, NULL, NULL, NULL, 'SIALOADHESIN', NULL, NULL, NULL, 8),
(253612, NULL, 'PTHR22734', NULL, NULL, NULL, NULL, 'U3 SMALL NUCLEOLAR RIBONUCLEOPROTEIN PROTEIN IMP4', NULL, NULL, 34166, 8),
(253613, NULL, 'PTHR10805', NULL, NULL, NULL, NULL, 'COATOMER SUBUNIT EPSILON', NULL, NULL, 3687, 8),
(253614, NULL, 'PTHR43880', NULL, NULL, NULL, NULL, 'ALCOHOL DEHYDROGENASE', NULL, NULL, NULL, 8),
(253615, NULL, 'PTHR14432', NULL, NULL, NULL, NULL, 'PROSAPIP2 PROTEIN/5-AZACYTIDINE INDUCED GENE 2', NULL, NULL, NULL, 8),
(253616, NULL, 'PTHR28066', NULL, NULL, NULL, NULL, '37S RIBOSOMAL PROTEIN MRP10, MITOCHONDRIAL', NULL, NULL, 16458, 8),
(253617, NULL, 'PTHR34983', NULL, NULL, NULL, NULL, 'ARABINOGALACTAN ENDO-BETA-1,4-GALACTANASE A', NULL, NULL, 10618, 8),
(253618, NULL, 'PTHR17554', NULL, NULL, NULL, NULL, 'TYRO PROTEIN TYROSINE KINASE-BINDING PROTEIN', NULL, NULL, 25223, 8),
(253619, NULL, 'PTHR33862', NULL, NULL, NULL, NULL, 'OROFACIAL CLEFT 1 CANDIDATE GENE 1 PROTEIN', NULL, NULL, 25216, 8),
(253620, NULL, 'PTHR36881', NULL, NULL, NULL, NULL, 'DERMOKINE', NULL, NULL, 33870, 8),
(253621, NULL, 'PTHR23537', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253622, NULL, 'PTHR31507', NULL, NULL, NULL, NULL, 'PROTEIN CBG15923', NULL, NULL, NULL, 8),
(253623, NULL, 'PTHR22596', NULL, NULL, NULL, NULL, 'TRYPSIN-LIKE PROTEASE PROTEIN 6', NULL, NULL, NULL, 8),
(253624, NULL, 'PTHR13142', NULL, NULL, NULL, NULL, 'INNER CENTROMERE PROTEIN', NULL, NULL, 27663, 8),
(253625, NULL, 'PTHR43582', NULL, NULL, NULL, NULL, 'LINEARMYCIN RESISTANCE ATP-BINDING PROTEIN LNRL', NULL, NULL, NULL, 8),
(253626, NULL, 'PTHR46771', NULL, NULL, NULL, NULL, 'DETERIN', NULL, NULL, NULL, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(253627, NULL, 'PTHR46922', NULL, NULL, NULL, NULL, 'DHHA1 DOMAIN PROTEIN', NULL, NULL, NULL, 8),
(253628, NULL, 'PTHR11534', NULL, NULL, NULL, NULL, 'MYOGENIC FACTOR', NULL, NULL, 27634, 8),
(253629, NULL, 'PTHR37015', NULL, NULL, NULL, NULL, 'REVERSE TRANSCRIPTASE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(253630, NULL, 'PTHR47356', NULL, NULL, NULL, NULL, 'FAD-DEPENDENT MONOOXYGENASE ASQG-RELATED', NULL, NULL, NULL, 8),
(253631, NULL, 'PTHR39081', NULL, NULL, NULL, NULL, 'MUT7-C DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(253632, NULL, 'PTHR14269', NULL, NULL, NULL, NULL, 'CDP-DIACYLGLYCEROL--GLYCEROL-3-PHOSPHATE 3-PHOSPHATIDYLTRANSFERASE-RELATED', NULL, NULL, NULL, 8),
(253633, NULL, 'PTHR17469', NULL, NULL, NULL, NULL, 'SPERM SPECIFIC ANTIGEN 2-RELATED', NULL, NULL, 34792, 8),
(253634, NULL, 'PTHR40704', NULL, NULL, NULL, NULL, 'TRANSCRIPTION ELONGATION FACTOR SPT4', NULL, NULL, 744, 8),
(253635, NULL, 'PTHR14759', NULL, NULL, NULL, NULL, 'STOP PROTEIN', NULL, NULL, 3049, 8),
(253636, NULL, 'PTHR36063', NULL, NULL, NULL, NULL, 'ARABIDOPSIS THALIANA GENOMIC DNA, CHROMOSOME 5, P1 CLONE:MOK16', NULL, NULL, NULL, 8),
(253637, NULL, 'PTHR43266', NULL, NULL, NULL, NULL, 'MACROLIDE-EFFLUX PROTEIN', NULL, NULL, NULL, 8),
(253638, NULL, 'PTHR43783', NULL, NULL, NULL, NULL, 'UDP-N-ACETYLGLUCOSAMINE 1-CARBOXYVINYLTRANSFERASE', NULL, NULL, NULL, 8),
(253639, NULL, 'PTHR46200', NULL, NULL, NULL, NULL, 'GATOR COMPLEX PROTEIN WDR24', NULL, NULL, 31898, 8),
(253640, NULL, 'PTHR11808', NULL, NULL, NULL, NULL, 'TRANS-SULFURATION ENZYME FAMILY MEMBER', NULL, NULL, 877, 8),
(253641, NULL, 'PTHR34137', NULL, NULL, NULL, NULL, 'EXODEOXYRIBONUCLEASE 7 SMALL SUBUNIT', NULL, NULL, 2204, 8),
(253642, NULL, 'PTHR42535', NULL, NULL, NULL, NULL, 'OOKINETE PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(253643, NULL, 'PTHR46908', NULL, NULL, NULL, NULL, 'CUBILIN-LIKE PROTEIN', NULL, NULL, NULL, 8),
(253644, NULL, 'PTHR48071', NULL, NULL, NULL, NULL, 'SRCR DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(253645, NULL, 'PTHR38496', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE AND COILED-COIL DOMAIN-CONTAINING PROTEIN 2', NULL, NULL, 26302, 8),
(253646, NULL, 'PTHR47354', NULL, NULL, NULL, NULL, 'NADH OXIDOREDUCTASE HCR', NULL, NULL, NULL, 8),
(253647, NULL, 'PTHR31111', NULL, NULL, NULL, NULL, 'BNAA05G37150D PROTEIN-RELATED', NULL, NULL, NULL, 8),
(253648, NULL, 'PTHR15756', NULL, NULL, NULL, NULL, 'LR8/HCA112', NULL, NULL, 13894, 8),
(253649, NULL, 'PTHR46654', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE HECTD3', NULL, NULL, 37759, 8),
(253650, NULL, 'PTHR33449', NULL, NULL, NULL, NULL, 'NUCLEOID-ASSOCIATED PROTEIN YBAB', NULL, NULL, 5991, 8),
(253651, NULL, 'PTHR31186', NULL, NULL, NULL, NULL, 'MODULATOR OF SMOOTHENED PROTEIN', NULL, NULL, 32578, 8),
(253652, NULL, 'PTHR47942', NULL, NULL, NULL, NULL, 'TETRATRICOPEPTIDE REPEAT (TPR)-LIKE SUPERFAMILY PROTEIN-RELATED', NULL, NULL, NULL, 8),
(253653, NULL, 'PTHR16674', NULL, NULL, NULL, NULL, 'B-LYMPHOCYTE ANTIGEN CD19', NULL, NULL, 36562, 8),
(253654, NULL, 'PTHR47161', NULL, NULL, NULL, NULL, 'LYMPHOID-SPECIFIC HELICASE', NULL, NULL, NULL, 8),
(253655, NULL, 'PTHR40780', NULL, NULL, NULL, NULL, 'DUF3669 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(253656, NULL, 'PTHR31152', NULL, NULL, NULL, NULL, 'PLAC8 FAMILY PROTEIN', NULL, NULL, NULL, 8),
(253657, NULL, 'PTHR37520', NULL, NULL, NULL, NULL, 'INTRON-ENCODED DNA ENDONUCLEASE AI2A-RELATED', NULL, NULL, NULL, 8),
(253658, NULL, 'PTHR48048', NULL, NULL, NULL, NULL, 'GLYCOSYLTRANSFERASE', NULL, NULL, NULL, 8),
(253659, NULL, 'PTHR47519', NULL, NULL, NULL, NULL, 'NUCLEAR HORMONE RECEPTOR FAMILY MEMBER NHR-31-RELATED', NULL, NULL, NULL, 8),
(253660, NULL, 'PTHR11476', NULL, NULL, NULL, NULL, 'HISTIDYL-TRNA SYNTHETASE', NULL, NULL, NULL, 8),
(253661, NULL, 'PTHR46825', NULL, NULL, NULL, NULL, 'D-ALANYL-D-ALANINE-CARBOXYPEPTIDASE/ENDOPEPTIDASE AMPH', NULL, NULL, NULL, 8),
(253662, NULL, 'PTHR40657', NULL, NULL, NULL, NULL, 'HYPOTHETICAL PROTEIN LOC681367', NULL, NULL, 33811, 8),
(253663, NULL, 'PTHR36379', NULL, NULL, NULL, NULL, 'PROTEIN PRD1', NULL, NULL, 35010, 8);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(253664, NULL, 'PTHR42845', NULL, NULL, NULL, NULL, 'COENZYME F420-REDUCING HYDROGENASE, GAMMA SUBUNIT', NULL, NULL, NULL, 8),
(253665, NULL, 'PTHR21242', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 10', NULL, NULL, 6013, 8),
(253666, NULL, 'PTHR13265', NULL, NULL, NULL, NULL, 'THO COMPLEX SUBUNIT 1', NULL, NULL, 19997, 8),
(253667, NULL, 'PTHR10055', NULL, NULL, NULL, NULL, 'TRYPTOPHANYL-TRNA SYNTHETASE', NULL, NULL, NULL, 8),
(253668, NULL, 'PTHR12254', NULL, NULL, NULL, NULL, 'ENHANCER OF SPLIT MALPHA PROTEIN', NULL, NULL, 24239, 8),
(253669, NULL, 'PTHR36681', NULL, NULL, NULL, NULL, 'NUCLEAR GTPASE, GERMINAL CENTER-ASSOCIATED, TANDEM DUPLICATE 3', NULL, NULL, NULL, 8),
(253670, NULL, 'PTHR20893', NULL, NULL, NULL, NULL, 'LD08641P', NULL, NULL, NULL, 8),
(253671, NULL, 'PTHR47999', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYB8-RELATED-RELATED', NULL, NULL, NULL, 8),
(253672, NULL, 'PTHR21085', NULL, NULL, NULL, NULL, 'CHORISMATE SYNTHASE', NULL, NULL, 6508, 8),
(253673, NULL, 'PTHR42101', NULL, NULL, NULL, NULL, 'CHROMOSOME 16, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(253674, NULL, 'PTHR34940', NULL, NULL, NULL, NULL, 'PHOTOSYSTEM II 5 KDA PROTEIN, CHLOROPLASTIC', NULL, NULL, 27377, 8),
(253675, NULL, 'PTHR42993', NULL, NULL, NULL, NULL, 'MAOC-LIKE DEHYDRATASE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(253676, NULL, 'PTHR21017', NULL, NULL, NULL, NULL, 'NIPSNAP-RELATED', NULL, NULL, NULL, 8),
(253677, NULL, 'PTHR30579', NULL, NULL, NULL, NULL, 'TRANSCRIPTIONAL REGULATOR', NULL, NULL, NULL, 8),
(253678, NULL, 'PTHR12187', NULL, NULL, NULL, NULL, 'AGAP000124-PA', NULL, NULL, 29475, 8),
(253679, NULL, 'PTHR38357', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(253680, NULL, 'PTHR46300', NULL, NULL, NULL, NULL, 'P450, PUTATIVE (EUROFUNG)-RELATED-RELATED', NULL, NULL, NULL, 8),
(253681, NULL, 'PTHR13375', NULL, NULL, NULL, NULL, 'FMS INTERACTING PROTEIN', NULL, NULL, 18010, 8),
(253682, NULL, 'PTHR19944', NULL, NULL, NULL, NULL, 'MHC CLASS II-RELATED', NULL, NULL, NULL, 8),
(253683, NULL, 'PTHR37723', NULL, NULL, NULL, NULL, 'PROTEIN FAR-RED ELONGATED HYPOCOTYL 1', NULL, NULL, 32010, 8),
(253684, NULL, 'PTHR41536', NULL, NULL, NULL, NULL, 'PKHD-TYPE HYDROXYLASE YBIX', NULL, NULL, 16393, 8),
(253685, NULL, 'PTHR16099', NULL, NULL, NULL, NULL, '8-OXO-DGTP DIPHOSPHATES NUDT15', NULL, NULL, NULL, 8),
(253686, NULL, 'PTHR10878', NULL, NULL, NULL, NULL, 'SEGMENT POLARITY PROTEIN DISHEVELLED', NULL, NULL, 8181, 8),
(253687, NULL, 'PTHR46582', NULL, NULL, NULL, NULL, 'ZINC FINGER CCCH DOMAIN-CONTAINING PROTEIN 18', NULL, NULL, NULL, 8),
(253688, NULL, 'PTHR12894', NULL, NULL, NULL, NULL, 'CNH DOMAIN CONTAINING', NULL, NULL, 25059, 8),
(253689, NULL, 'PTHR46950', NULL, NULL, NULL, NULL, 'MAGNESIUM TRANSPORTER CORA-LIKE FAMILY PROTEIN', NULL, NULL, NULL, 8),
(253690, NULL, 'PTHR37199', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN', NULL, NULL, NULL, 8),
(253691, NULL, 'PTHR22845', NULL, NULL, NULL, NULL, 'APOPTOTIC PROTEASE-ACTIVATING FACTOR 1', NULL, NULL, NULL, 8),
(253692, NULL, 'PTHR11764', NULL, NULL, NULL, NULL, 'TERPENE CYCLASE/MUTASE FAMILY MEMBER', NULL, NULL, 20195, 8),
(253693, NULL, 'PTHR14303', NULL, NULL, NULL, NULL, 'DNA POLYMERASE DELTA SUBUNIT 4', NULL, NULL, 6274, 8),
(253694, NULL, 'PTHR21524', NULL, NULL, NULL, NULL, 'SPECTRIN REPEAT CONTAINING NUCLEAR ENVELOPE PROTEIN 2', NULL, NULL, 31177, 8),
(253695, NULL, 'PTHR30074', NULL, NULL, NULL, NULL, 'FORMATE DEHYDROGENASE, NITRATE-INDUCIBLE, CYTOCHROME B556 FDN  SUBUNIT', NULL, NULL, NULL, 8),
(253696, NULL, 'PTHR14845', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING 166', NULL, NULL, NULL, 8),
(253697, NULL, 'PTHR10257', NULL, NULL, NULL, NULL, 'SERINE/THREONINE PROTEIN PHOSPHATASE 2A  PP2A  REGULATORY SUBUNIT B', NULL, NULL, 1650, 8),
(253698, NULL, 'PTHR12196', NULL, NULL, NULL, NULL, 'DOMAIN OF UNKNOWN FUNCTION 71  DUF71 -CONTAINING PROTEIN', NULL, NULL, 24567, 8),
(253699, NULL, 'PTHR45639', NULL, NULL, NULL, NULL, 'HSC70CB, ISOFORM G-RELATED', NULL, NULL, NULL, 8);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(253700, NULL, 'PTHR38477', NULL, NULL, NULL, NULL, 'HYPOTHETICAL EXPORTED PROTEIN', NULL, NULL, 18348, 8),
(253701, NULL, 'PTHR10763', NULL, NULL, NULL, NULL, 'CELL DIVISION CONTROL PROTEIN 6-RELATED', NULL, NULL, NULL, 8),
(253702, NULL, 'PTHR43058', NULL, NULL, NULL, NULL, 'SLR0655 PROTEIN', NULL, NULL, NULL, 8),
(253703, NULL, 'PTHR43151', NULL, NULL, NULL, NULL, 'FEOA FAMILY PROTEIN', NULL, NULL, NULL, 8),
(253704, NULL, 'PTHR45823', NULL, NULL, NULL, NULL, 'T-SNARE COILED-COIL HOMOLOGY DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(253705, NULL, 'PTHR31655', NULL, NULL, NULL, NULL, '', NULL, NULL, 25983, 8),
(253706, NULL, 'PTHR39381', NULL, NULL, NULL, NULL, 'PROTEIN CBG14825-RELATED', NULL, NULL, NULL, 8),
(253707, NULL, 'PTHR47309', NULL, NULL, NULL, NULL, 'T-CELL SURFACE GLYCOPROTEIN CD5', NULL, NULL, 435, 8),
(253708, NULL, 'PTHR13513', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE UBR7', NULL, NULL, 31570, 8),
(253709, NULL, 'PTHR10845', NULL, NULL, NULL, NULL, 'REGULATOR OF G PROTEIN SIGNALING', NULL, NULL, NULL, 8),
(253710, NULL, 'PTHR13149', NULL, NULL, NULL, NULL, 'VACUOLAR PROTEIN SORTING-ASSOCIATED PROTEIN VPS25', NULL, NULL, 13279, 8),
(253711, NULL, 'PTHR46854', NULL, NULL, NULL, NULL, '5''-ADENYLYLSULFATE REDUCTASE-LIKE 4-RELATED', NULL, NULL, 36066, 8),
(253712, NULL, 'PTHR36038', NULL, NULL, NULL, NULL, 'OS06G0102750 PROTEIN', NULL, NULL, NULL, 8),
(253713, NULL, 'PTHR22443', NULL, NULL, NULL, NULL, 'NON-SPECIFIC LETHAL 1, ISOFORM M', NULL, NULL, 25115, 8),
(253714, NULL, 'PTHR35311', NULL, NULL, NULL, NULL, 'KINETOCHORE-ASSOCIATED PROTEIN KNL-2 HOMOLOG', NULL, NULL, NULL, 8),
(253715, NULL, 'PTHR10317', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 SUBUNIT E', NULL, NULL, 19550, 8),
(253716, NULL, 'PTHR22910', NULL, NULL, NULL, NULL, 'PROTEIN MGARP', NULL, NULL, 26396, 8),
(253717, NULL, 'PTHR23352', NULL, NULL, NULL, NULL, 'NEURAL PROLIFERATION DIFFERENTIATION AND CONTROL PROTEIN-1  NPDC-1 PROTEIN', NULL, NULL, 10613, 8),
(253718, NULL, 'PTHR11861', NULL, NULL, NULL, NULL, 'MELANOCYTE PROTEIN PMEL 17-RELATED', NULL, NULL, 36323, 8),
(253719, NULL, 'PTHR42886', NULL, NULL, NULL, NULL, 'RE40534P-RELATED', NULL, NULL, NULL, 8),
(253720, NULL, 'PTHR40682', NULL, NULL, NULL, NULL, 'F5/8 TYPE C DOMAIN CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(253721, NULL, 'PTHR34214', NULL, NULL, NULL, NULL, '', NULL, NULL, 1853, 8),
(253722, NULL, 'PTHR14122', NULL, NULL, NULL, NULL, 'GHRELIN PRECURSOR', NULL, NULL, 77, 8),
(253723, NULL, 'PTHR36535', NULL, NULL, NULL, NULL, 'YALI0E30327P', NULL, NULL, NULL, 8),
(253724, NULL, 'PTHR44129', NULL, NULL, NULL, NULL, 'WD REPEAT-CONTAINING PROTEIN POP1', NULL, NULL, NULL, 8),
(253725, NULL, 'PTHR43640', NULL, NULL, NULL, NULL, 'OS07G0260300 PROTEIN', NULL, NULL, NULL, 8),
(253726, NULL, 'PTHR12765', NULL, NULL, NULL, NULL, 'RED PROTEIN  IK FACTOR   CYTOKINE IK', NULL, NULL, 33341, 8),
(253727, NULL, 'PTHR32345', NULL, NULL, NULL, NULL, 'MYB-RELATED TRANSCRIPTION FACTOR, PARTNER OF PROFILIN', NULL, NULL, NULL, 8),
(253728, NULL, 'PTHR21049', NULL, NULL, NULL, NULL, 'RIBOPHORIN I', NULL, NULL, 734, 8),
(253729, NULL, 'PTHR34937', NULL, NULL, NULL, NULL, 'OS08G0559800 PROTEIN', NULL, NULL, 31812, 8),
(253730, NULL, 'PTHR10410', NULL, NULL, NULL, NULL, 'EUKARYOTIC TRANSLATION INITIATION FACTOR 3 -RELATED', NULL, NULL, NULL, 8),
(253731, NULL, 'PTHR42997', NULL, NULL, NULL, NULL, 'HIT FAMILY HYDROLASE', NULL, NULL, NULL, 8),
(253732, NULL, 'PTHR31974', NULL, NULL, NULL, NULL, 'BIOGENESIS OF LYSOSOME-RELATED ORGANELLES COMPLEX 1 SUBUNIT 3', NULL, NULL, 15538, 8),
(253733, NULL, 'PTHR33921', NULL, NULL, NULL, NULL, 'CALVIN CYCLE PROTEIN CP12-2, CHLOROPLASTIC', NULL, NULL, 27477, 8),
(253734, NULL, 'PTHR39683', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN TB16.3', NULL, NULL, NULL, 8),
(253735, NULL, 'PTHR43595', NULL, NULL, NULL, NULL, '37S RIBOSOMAL PROTEIN S26, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(253736, NULL, 'PTHR31668', NULL, NULL, NULL, NULL, 'GLUCOSE TRANSPORT TRANSCRIPTION REGULATOR RGT1-RELATED-RELATED', NULL, NULL, NULL, 8);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(253737, NULL, 'PTHR35987', NULL, NULL, NULL, NULL, 'PROTEIN PLASTID REDOX INSENSITIVE 2, CHLOROPLASTIC-RELATED', NULL, NULL, 33299, 8),
(253738, NULL, 'PTHR36739', NULL, NULL, NULL, NULL, 'D-TAGATOSE-1,6-BISPHOSPHATE ALDOLASE SUBUNIT', NULL, NULL, NULL, 8),
(253739, NULL, 'PTHR13872', NULL, NULL, NULL, NULL, 'DOLICHYL-DIPHOSPHOOLIGOSACCHARIDE--PROTEIN GLYCOSYLTRANSFERASE SUBUNIT', NULL, NULL, 1341, 8),
(253740, NULL, 'PTHR33767', NULL, NULL, NULL, NULL, '', NULL, NULL, 32300, 8),
(253741, NULL, 'PTHR46633', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR MYC/MYB-RELATED', NULL, NULL, NULL, 8),
(253742, NULL, 'PTHR31107', NULL, NULL, NULL, NULL, 'APOPTOGENIC PROTEIN 1, MITOCHONDRIAL', NULL, NULL, 19203, 8),
(253743, NULL, 'PTHR34601', NULL, NULL, NULL, NULL, 'NEMATODE SPECIFIC PEPTIDE FAMILY, GROUP B', NULL, NULL, NULL, 8),
(253744, NULL, 'PTHR31981', NULL, NULL, NULL, NULL, 'GLYCOSYLATED LYSOSOMAL MEMBRANE PROTEIN', NULL, NULL, 26257, 8),
(253745, NULL, 'PTHR36911', NULL, NULL, NULL, NULL, 'LIM ZINC-BINDING DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(253746, NULL, 'PTHR34151', NULL, NULL, NULL, NULL, 'PROTEIN CBG24195', NULL, NULL, NULL, 8),
(253747, NULL, 'PTHR19842', NULL, NULL, NULL, NULL, 'G BETA-LIKE PROTEIN GBL', NULL, NULL, 31933, 8),
(253748, NULL, 'PTHR42687', NULL, NULL, NULL, NULL, 'L-THREONINE 3-DEHYDROGENASE', NULL, NULL, NULL, 8),
(253749, NULL, 'PTHR45797', NULL, NULL, NULL, NULL, 'RAD54-LIKE', NULL, NULL, 36166, 8),
(253750, NULL, 'PTHR22669', NULL, NULL, NULL, NULL, 'DELTA/SERRATE/LAG-2 DOMAIN PROTEIN', NULL, NULL, 32519, 8),
(253751, NULL, 'PTHR36970', NULL, NULL, NULL, NULL, 'UNNAMED PRODUCT', NULL, NULL, NULL, 8),
(253752, NULL, 'PTHR46141', NULL, NULL, NULL, NULL, 'SODIUM LEAK CHANNEL NON-SELECTIVE PROTEIN', NULL, NULL, 24400, 8),
(253753, NULL, 'PTHR21393', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL 28S RIBOSOMAL PROTEIN S27', NULL, NULL, 19652, 8),
(253754, NULL, 'PTHR28286', NULL, NULL, NULL, NULL, '', NULL, NULL, 6977, 8),
(253755, NULL, 'PTHR31587', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN (DUF2215)', NULL, NULL, NULL, 8),
(253756, NULL, 'PTHR34524', NULL, NULL, NULL, NULL, 'CALCYPHOSIN', NULL, NULL, NULL, 8),
(253757, NULL, 'PTHR21341', NULL, NULL, NULL, NULL, 'PROTAMINE-2', NULL, NULL, 5604, 8),
(253758, NULL, 'PTHR48042', NULL, NULL, NULL, NULL, 'ABC TRANSPORTER G FAMILY MEMBER 11', NULL, NULL, NULL, 8),
(253759, NULL, 'PTHR39643', NULL, NULL, NULL, NULL, 'CCA-ADDING ENZYME', NULL, NULL, 673, 8),
(253760, NULL, 'PTHR36007', NULL, NULL, NULL, NULL, 'TRANSPORT PROTEIN-RELATED', NULL, NULL, 919, 8),
(253761, NULL, 'PTHR12857', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 14018, 8),
(253762, NULL, 'PTHR36288', NULL, NULL, NULL, NULL, 'SIMILAR TO RIKEN CDNA A930018P22', NULL, NULL, 27314, 8),
(253763, NULL, 'PTHR37773', NULL, NULL, NULL, NULL, '', NULL, NULL, 34835, 8),
(253764, NULL, 'PTHR47836', NULL, NULL, NULL, NULL, 'PROTEIN CBG09520-RELATED', NULL, NULL, NULL, 8),
(253765, NULL, 'PTHR22805', NULL, NULL, NULL, NULL, 'WDR41-RELATED', NULL, NULL, 31978, 8),
(253766, NULL, 'PTHR42888', NULL, NULL, NULL, NULL, '50S RIBOSOMAL PROTEIN L36, CHLOROPLASTIC', NULL, NULL, 6769, 8),
(253767, NULL, 'PTHR24075', NULL, NULL, NULL, NULL, 'SEC63 DOMAIN-CONTAINING', NULL, NULL, NULL, 8),
(253768, NULL, 'PTHR12875', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 4907, 8),
(253769, NULL, 'PTHR47695', NULL, NULL, NULL, NULL, 'PID DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(253770, NULL, 'PTHR37725', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253771, NULL, 'PTHR43457', NULL, NULL, NULL, NULL, 'NITROGENASE MOLYBDENUM-IRON PROTEIN ALPHA CHAIN', NULL, NULL, 10939, 8),
(253772, NULL, 'PTHR35769', NULL, NULL, NULL, NULL, 'CALCINEURIN-LIKE METALLO-PHOSPHOESTERASE SUPERFAMILY PROTEIN', NULL, NULL, 22548, 8),
(253773, NULL, 'PTHR36729', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(253774, NULL, 'PTHR12348', NULL, NULL, NULL, NULL, 'TSC22', NULL, NULL, NULL, 8),
(253775, NULL, 'PTHR19920', NULL, NULL, NULL, NULL, 'WD40 PROTEIN CIAO1', NULL, NULL, 25935, 8);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(253776, NULL, 'PTHR38940', NULL, NULL, NULL, NULL, 'PLUS3 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(253777, NULL, 'PTHR21032', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 27091, 8),
(253778, NULL, 'PTHR22933', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(253779, NULL, 'PTHR45819', NULL, NULL, NULL, NULL, 'CENTAURIN-GAMMA-1A', NULL, NULL, NULL, 8),
(253780, NULL, 'PTHR42749', NULL, NULL, NULL, NULL, 'CELL SHAPE-DETERMINING PROTEIN MREB', NULL, NULL, NULL, 8),
(253781, NULL, 'PTHR10292', NULL, NULL, NULL, NULL, 'CLATHRIN HEAVY CHAIN RELATED', NULL, NULL, NULL, 8),
(253782, NULL, 'PTHR36558', NULL, NULL, NULL, NULL, 'GLR1098 PROTEIN', NULL, NULL, NULL, 8),
(253783, NULL, 'PTHR38925', NULL, NULL, NULL, NULL, 'PROTEIN, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(253784, NULL, 'PTHR47808', NULL, NULL, NULL, NULL, 'INNER NUCLEAR MEMBRANE PROTEIN HEH2-RELATED', NULL, NULL, 36828, 8),
(253785, NULL, 'PTHR46379', NULL, NULL, NULL, NULL, 'ZINC FINGER MYND DOMAIN-CONTAINING', NULL, NULL, NULL, 8),
(253786, NULL, 'PTHR45876', NULL, NULL, NULL, NULL, 'FI04035P', NULL, NULL, NULL, 8),
(253787, NULL, 'PTHR46157', NULL, NULL, NULL, NULL, 'K(+) EFFLUX ANTIPORTER 3, CHLOROPLASTIC', NULL, NULL, NULL, 8),
(253788, NULL, 'PTHR40202', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253789, NULL, 'PTHR33322', NULL, NULL, NULL, NULL, 'BAG DOMAIN CONTAINING PROTEIN, EXPRESSED', NULL, NULL, 27682, 8),
(253790, NULL, 'PTHR30071', NULL, NULL, NULL, NULL, 'HEME EXPORTER PROTEIN C', NULL, NULL, 36741, 8),
(253791, NULL, 'PTHR47441', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253792, NULL, 'PTHR11245', NULL, NULL, NULL, NULL, 'STANNIOCALCIN', NULL, NULL, 834, 8),
(253793, NULL, 'PTHR11792', NULL, NULL, NULL, NULL, 'ARRESTIN', NULL, NULL, 3860, 8),
(253794, NULL, 'PTHR23222', NULL, NULL, NULL, NULL, 'PROHIBITIN', NULL, NULL, 1539, 8),
(253795, NULL, 'PTHR38572', NULL, NULL, NULL, NULL, 'BCDNA.GH07269-RELATED', NULL, NULL, NULL, 8),
(253796, NULL, 'PTHR31285', NULL, NULL, NULL, NULL, 'NICOTINAMIDE MONONUCLEOTIDE ADENYLYLTRANSFERASE', NULL, NULL, NULL, 8),
(253797, NULL, 'PTHR42188', NULL, NULL, NULL, NULL, '23S RRNA-SPECIFIC ENDONUCLEASE VAPC20', NULL, NULL, 33319, 8),
(253798, NULL, 'PTHR45818', NULL, NULL, NULL, NULL, 'PROTEIN VAV', NULL, NULL, NULL, 8),
(253799, NULL, 'PTHR31053', NULL, NULL, NULL, NULL, 'MAGNESIUM-PROTOPORPHYRIN IX MONOMETHYL ESTER [OXIDATIVE] CYCLASE, CHLOROPLASTIC', NULL, NULL, 8937, 8),
(253800, NULL, 'PTHR12264', NULL, NULL, NULL, NULL, 'TRANSCRIPTION INITIATION FACTOR TFIID SUBUNIT 12', NULL, NULL, 31443, 8),
(253801, NULL, 'PTHR34415', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253802, NULL, 'PTHR36777', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(253803, NULL, 'PTHR15416', NULL, NULL, NULL, NULL, 'CAMP-DEPENDENT PROTEIN KINASE INHIBITOR/PKI', NULL, NULL, 4249, 8),
(253804, NULL, 'PTHR11806', NULL, NULL, NULL, NULL, 'GLUCOSE INHIBITED DIVISION PROTEIN A', NULL, NULL, 6000, 8),
(253805, NULL, 'PTHR38426', NULL, NULL, NULL, NULL, 'MAINTENANCE OF TELOMERE CAPPING PROTEIN 4', NULL, NULL, 32462, 8),
(253806, NULL, 'PTHR23195', NULL, NULL, NULL, NULL, 'YEATS DOMAIN', NULL, NULL, 1202, 8),
(253807, NULL, 'PTHR46381', NULL, NULL, NULL, NULL, 'MKPA PROTEIN', NULL, NULL, NULL, 8),
(253808, NULL, 'PTHR34644', NULL, NULL, NULL, NULL, 'SINGLE-PASS MEMBRANE AND COILED-COIL DOMAIN-CONTAINING PROTEIN 4', NULL, NULL, 24203, 8),
(253809, NULL, 'PTHR23010', NULL, NULL, NULL, NULL, 'MIDNOLIN', NULL, NULL, 33161, 8),
(253810, NULL, 'PTHR47134', NULL, NULL, NULL, NULL, 'TUMOR NECROSIS FACTOR RECEPTOR SUPERFAMILY MEMBER 11A', NULL, NULL, NULL, 8),
(253811, NULL, 'PTHR33018', NULL, NULL, NULL, NULL, 'OS10G0338966 PROTEIN-RELATED', NULL, NULL, NULL, 8),
(253812, NULL, 'PTHR45580', NULL, NULL, NULL, NULL, 'PROTEIN CBG05369', NULL, NULL, NULL, 8),
(253813, NULL, 'PTHR46299', NULL, NULL, NULL, NULL, 'VON WILLEBRAND FACTOR A DOMAIN-CONTAINING PROTEIN 5B2-RELATED', NULL, NULL, NULL, 8),
(253814, NULL, 'PTHR42715', NULL, NULL, NULL, NULL, 'BETA-GLUCOSIDASE', NULL, NULL, NULL, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(253815, NULL, 'PTHR35824', NULL, NULL, NULL, NULL, 'MEMBRANE-ANCHORED JUNCTION PROTEIN MAJIN', NULL, NULL, 21632, 8),
(253816, NULL, 'PTHR14225', NULL, NULL, NULL, NULL, 'APOLIPOPROTEIN C-III', NULL, NULL, 8551, 8),
(253817, NULL, 'PTHR13056', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, 17423, 8),
(253818, NULL, 'PTHR34239', NULL, NULL, NULL, NULL, 'APPLE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(253819, NULL, 'PTHR30158', NULL, NULL, NULL, NULL, 'ACRA/E-RELATED COMPONENT OF DRUG EFFLUX TRANSPORTER', NULL, NULL, NULL, 8),
(253820, NULL, 'PTHR46665', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR BHLH041-RELATED-RELATED', NULL, NULL, 35841, 8),
(253821, NULL, 'PTHR36701', NULL, NULL, NULL, NULL, 'EPOXYQUEUOSINE REDUCTASE QUEH', NULL, NULL, 6275, 8),
(253822, NULL, 'PTHR33933', NULL, NULL, NULL, NULL, 'NUCLEOTIDYLTRANSFERASE', NULL, NULL, NULL, 8),
(253823, NULL, 'PTHR35540', NULL, NULL, NULL, NULL, 'IZUMO SPERM-EGG FUSION PROTEIN 1', NULL, NULL, 26094, 8),
(253824, NULL, 'PTHR48177', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 189', NULL, NULL, NULL, 8),
(253825, NULL, 'PTHR21051', NULL, NULL, NULL, NULL, 'CAMP-RESPONSIVE ELEMENT-BINDING PROTEIN-LIKE 2', NULL, NULL, 27419, 8),
(253826, NULL, 'PTHR13139', NULL, NULL, NULL, NULL, 'RING FINGER AND CCCH-TYPE ZINC FINGER DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(253827, NULL, 'PTHR23262', NULL, NULL, NULL, NULL, 'KERATIN ASSOCIATED PROTEIN', NULL, NULL, 885, 8),
(253828, NULL, 'PTHR42256', NULL, NULL, NULL, NULL, 'OXOGLUTARATE/IRON-DEPENDENT DIOXYGENASE', NULL, NULL, NULL, 8),
(253829, NULL, 'PTHR43982', NULL, NULL, NULL, NULL, 'UBIQUITIN CARBOXYL-TERMINAL HYDROLASE', NULL, NULL, 36116, 8),
(253830, NULL, 'PTHR37019', NULL, NULL, NULL, NULL, 'CHROMOSOME 1, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(253831, NULL, 'PTHR41683', NULL, NULL, NULL, NULL, 'MUCIN-7', NULL, NULL, 27623, 8),
(253832, NULL, 'PTHR35087', NULL, NULL, NULL, NULL, 'SIMILAR TO HYPOTHETICAL PROTEIN FLJ40298', NULL, NULL, 21782, 8),
(253833, NULL, 'PTHR46388', NULL, NULL, NULL, NULL, 'NHL REPEAT-CONTAINING PROTEIN 2', NULL, NULL, NULL, 8),
(253834, NULL, 'PTHR10411', NULL, NULL, NULL, NULL, 'GROWTH ARREST AND DNA DAMAGE-INDUCIBLE PROTEIN GADD45', NULL, NULL, 14887, 8),
(253835, NULL, 'PTHR47245', NULL, NULL, NULL, NULL, 'PEPTIDYLPROLYL ISOMERASE', NULL, NULL, NULL, 8),
(253836, NULL, 'PTHR47291', NULL, NULL, NULL, NULL, 'PEPTIDE UPSTREAM PROTEIN', NULL, NULL, NULL, 8),
(253837, NULL, 'PTHR23238', NULL, NULL, NULL, NULL, 'RNA BINDING PROTEIN', NULL, NULL, 28599, 8),
(253838, NULL, 'PTHR46114', NULL, NULL, NULL, NULL, 'APPLE DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(253839, NULL, 'PTHR34466', NULL, NULL, NULL, NULL, 'OS11G0129800 PROTEIN', NULL, NULL, NULL, 8),
(253840, NULL, 'PTHR46026', NULL, NULL, NULL, NULL, 'RHO-TYPE GUANINE NUCLEOTIDE EXCHANGE FACTOR, ISOFORM F', NULL, NULL, NULL, 8),
(253841, NULL, 'PTHR48103', NULL, NULL, NULL, NULL, 'MIDASIN-RELATED', NULL, NULL, NULL, 8),
(253842, NULL, 'PTHR32256', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253843, NULL, 'PTHR35349', NULL, NULL, NULL, NULL, 'DYNACTIN-ASSOCIATED PROTEIN', NULL, NULL, NULL, 8),
(253844, NULL, 'PTHR21141', NULL, NULL, NULL, NULL, '60S ACIDIC RIBOSOMAL PROTEIN FAMILY MEMBER', NULL, NULL, 35221, 8),
(253845, NULL, 'PTHR35972', NULL, NULL, NULL, NULL, 'SINGLE-PASS MEMBRANE AND COILED-COIL DOMAIN-CONTAINING PROTEIN 3', NULL, NULL, 27089, 8),
(253846, NULL, 'PTHR33476', NULL, NULL, NULL, NULL, 'EMB|CAB62613.1', NULL, NULL, 27248, 8),
(253847, NULL, 'PTHR12548', NULL, NULL, NULL, NULL, 'TRANSCRIPTION FACTOR DP', NULL, NULL, 17693, 8),
(253848, NULL, 'PTHR12045', NULL, NULL, NULL, NULL, 'ALLANTOICASE', NULL, NULL, 4645, 8),
(253849, NULL, 'PTHR12552', NULL, NULL, NULL, NULL, 'OLIGOPHRENIN 1', NULL, NULL, NULL, 8),
(253850, NULL, 'PTHR37392', NULL, NULL, NULL, NULL, 'OS09G0556800 PROTEIN', NULL, NULL, NULL, 8),
(253851, NULL, 'PTHR37826', NULL, NULL, NULL, NULL, 'FLOTILLIN BAND_7_5 DOMAIN PROTEIN', NULL, NULL, NULL, 8),
(253852, NULL, 'PTHR37718', NULL, NULL, NULL, NULL, 'BNAC03G61340D PROTEIN', NULL, NULL, NULL, 8);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(253853, NULL, 'PTHR10151', NULL, NULL, NULL, NULL, 'ECTONUCLEOTIDE PYROPHOSPHATASE/PHOSPHODIESTERASE', NULL, NULL, NULL, 8),
(253854, NULL, 'PTHR31196', NULL, NULL, NULL, NULL, 'RNA POLYMERASE II NUCLEAR LOCALIZATION PROTEIN SLC7A6OS-RELATED', NULL, NULL, 31055, 8),
(253855, NULL, 'PTHR22752', NULL, NULL, NULL, NULL, 'G PROTEIN-COUPLED RECEPTOR', NULL, NULL, NULL, 8),
(253856, NULL, 'PTHR45950', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN ATHB-14', NULL, NULL, 36198, 8),
(253857, NULL, 'PTHR37459', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253858, NULL, 'PTHR36855', NULL, NULL, NULL, NULL, 'CHROMOSOME 10, WHOLE GENOME SHOTGUN SEQUENCE', NULL, NULL, NULL, 8),
(253859, NULL, 'PTHR19970', NULL, NULL, NULL, NULL, 'RIBOSOMAL PROTEIN L39E', NULL, NULL, NULL, 8),
(253860, NULL, 'PTHR23226', NULL, NULL, NULL, NULL, 'ZINC FINGER AND SCAN DOMAIN-CONTAINING', NULL, NULL, NULL, 8),
(253861, NULL, 'PTHR35834', NULL, NULL, NULL, NULL, 'ARMADILLO-TYPE FOLD PROTEIN-RELATED', NULL, NULL, NULL, 8),
(253862, NULL, 'PTHR10190', NULL, NULL, NULL, NULL, 'EYES ABSENT', NULL, NULL, 25918, 8),
(253863, NULL, 'PTHR33936', NULL, NULL, NULL, NULL, 'PROTEIN CBG17840', NULL, NULL, NULL, 8),
(253864, NULL, 'PTHR45785', NULL, NULL, NULL, NULL, 'COMPLEMENT FACTOR H-RELATED', NULL, NULL, NULL, 8),
(253865, NULL, 'PTHR43050', NULL, NULL, NULL, NULL, 'SERINE / THREONINE RACEMASE FAMILY MEMBER', NULL, NULL, NULL, 8),
(253866, NULL, 'PTHR46249', NULL, NULL, NULL, NULL, 'CCHC-TYPE DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(253867, NULL, 'PTHR21404', NULL, NULL, NULL, NULL, 'HEN1', NULL, NULL, 22132, 8),
(253868, NULL, 'PTHR43271', NULL, NULL, NULL, NULL, 'BLL2771 PROTEIN', NULL, NULL, NULL, 8),
(253869, NULL, 'PTHR43825', NULL, NULL, NULL, NULL, 'PYRUVATE DEHYDROGENASE E1 COMPONENT', NULL, NULL, NULL, 8),
(253870, NULL, 'PTHR43364', NULL, NULL, NULL, NULL, 'NADH-SPECIFIC METHYLGLYOXAL REDUCTASE-RELATED', NULL, NULL, NULL, 8),
(253871, NULL, 'PTHR38075', NULL, NULL, NULL, NULL, 'DUF4139 DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(253872, NULL, 'PTHR36698', NULL, NULL, NULL, NULL, 'BLL5892 PROTEIN', NULL, NULL, NULL, 8),
(253873, NULL, 'PTHR42643', NULL, NULL, NULL, NULL, 'IONOTROPIC RECEPTOR 20A-RELATED', NULL, NULL, NULL, 8),
(253874, NULL, 'PTHR46778', NULL, NULL, NULL, NULL, 'CYCLIN-DEPENDENT KINASE INHIBITOR 1-RELATED', NULL, NULL, 23590, 8),
(253875, NULL, 'PTHR47520', NULL, NULL, NULL, NULL, 'CX DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(253876, NULL, 'PTHR10380', NULL, NULL, NULL, NULL, 'CUTICLE PROTEIN', NULL, NULL, NULL, 8),
(253877, NULL, 'PTHR42002', NULL, NULL, NULL, NULL, 'ANAEROBIC C4-DICARBOXYLATE TRANSPORTER DCUC-RELATED', NULL, NULL, 2937, 8),
(253878, NULL, 'PTHR31797', NULL, NULL, NULL, NULL, 'EXTRACELLULAR MATRIX PROTEIN A-RELATED', NULL, NULL, NULL, 8),
(253879, NULL, 'PTHR35787', NULL, NULL, NULL, NULL, 'GLYCEROL UPTAKE OPERON ANTITERMINATOR REGULATORY PROTEIN', NULL, NULL, 2242, 8),
(253880, NULL, 'PTHR21706', NULL, NULL, NULL, NULL, 'TRANSMEMBRANE PROTEIN 65', NULL, NULL, 19245, 8),
(253881, NULL, 'PTHR47090', NULL, NULL, NULL, NULL, 'PROTEIN EDS1-RELATED', NULL, NULL, 36732, 8),
(253882, NULL, 'PTHR11644', NULL, NULL, NULL, NULL, 'CYTIDINE DEAMINASE', NULL, NULL, NULL, 8),
(253883, NULL, 'PTHR33168', NULL, NULL, NULL, NULL, 'STRESS INDUCED PROTEIN-RELATED', NULL, NULL, NULL, 8),
(253884, NULL, 'PTHR46668', NULL, NULL, NULL, NULL, 'BTB/POZ DOMAIN AND ANKYRIN REPEAT-CONTAINING PROTEIN NH5.2', NULL, NULL, 34335, 8),
(253885, NULL, 'PTHR43011', NULL, NULL, NULL, NULL, 'IRON-SULFUR CLUSTER ASSEMBLY 2 HOMOLOG, MITOCHONDRIAL', NULL, NULL, NULL, 8),
(253886, NULL, 'PTHR31737', NULL, NULL, NULL, NULL, 'PROTEIN TOS1', NULL, NULL, NULL, 8),
(253887, NULL, 'PTHR41259', NULL, NULL, NULL, NULL, 'DOUBLE-STRAND BREAK REPAIR RAD50 ATPASE, PUTATIVE-RELATED', NULL, NULL, NULL, 8),
(253888, NULL, 'PTHR24178', NULL, NULL, NULL, NULL, 'MOLTING PROTEIN MLT-4', NULL, NULL, NULL, 8),
(253889, NULL, 'PTHR36758', NULL, NULL, NULL, NULL, 'OS01G0342800 PROTEIN', NULL, NULL, NULL, 8);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(253890, NULL, 'PTHR34992', NULL, NULL, NULL, NULL, 'HYPHAL ANASTAMOSIS-7 PROTEIN', NULL, NULL, 34106, 8),
(253891, NULL, 'PTHR11760', NULL, NULL, NULL, NULL, '30S/40S RIBOSOMAL PROTEIN S3', NULL, NULL, NULL, 8),
(253892, NULL, 'PTHR31162', NULL, NULL, NULL, NULL, 'MALIC ACID TRANSPORT PROTEIN-RELATED', NULL, NULL, 23887, 8),
(253893, NULL, 'PTHR12897', NULL, NULL, NULL, NULL, 'COLON CANCER-ASSOCIATED PROTEIN MIC1', NULL, NULL, 27503, 8),
(253894, NULL, 'PTHR31632', NULL, NULL, NULL, NULL, 'IRON TRANSPORTER FTH1', NULL, NULL, 1593, 8),
(253895, NULL, 'PTHR43108', NULL, NULL, NULL, NULL, 'N-ACETYLGLUCOSAMINE-6-SULFATASE FAMILY MEMBER', NULL, NULL, NULL, 8),
(253896, NULL, 'PTHR43124', NULL, NULL, NULL, NULL, 'PURINE EFFLUX PUMP PBUE', NULL, NULL, NULL, 8),
(253897, NULL, 'PTHR21146', NULL, NULL, NULL, NULL, 'MEF2B PROTEIN', NULL, NULL, 14661, 8),
(253898, NULL, 'PTHR48167', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(253899, NULL, 'PTHR35584', NULL, NULL, NULL, NULL, 'FLAGELLAR ASSOCIATED PROTEIN', NULL, NULL, NULL, 8),
(253900, NULL, 'PTHR12085', NULL, NULL, NULL, NULL, 'SERINE/THREONINE-PROTEIN PHOSPHATASE 2A REGULATORY SUBUNIT B'''' SUBUNIT GAMMA', NULL, NULL, 31489, 8),
(253901, NULL, 'PTHR37479', NULL, NULL, NULL, NULL, 'CELL DIVISION PROTEIN FTSL', NULL, NULL, 11308, 8),
(253902, NULL, 'PTHR43025', NULL, NULL, NULL, NULL, 'MONOGALACTOSYLDIACYLGLYCEROL SYNTHASE', NULL, NULL, NULL, 8),
(253903, NULL, 'PTHR14326', NULL, NULL, NULL, NULL, 'TARGETING PROTEIN FOR XKLP2', NULL, NULL, 11608, 8),
(253904, NULL, 'PTHR34267', NULL, NULL, NULL, NULL, 'OS11G0161033 PROTEIN', NULL, NULL, 9428, 8),
(253905, NULL, 'PTHR28083', NULL, NULL, NULL, NULL, 'GOOD FOR FULL DBP5 ACTIVITY PROTEIN 2', NULL, NULL, 30105, 8),
(253906, NULL, 'PTHR47118', NULL, NULL, NULL, NULL, 'CYTOTOXIC AND REGULATORY T-CELL MOLECULE', NULL, NULL, NULL, 8),
(253907, NULL, 'PTHR36140', NULL, NULL, NULL, NULL, 'F-BOX DOMAIN-CONTAINING PROTEIN-RELATED', NULL, NULL, NULL, 8),
(253908, NULL, 'PTHR34789', NULL, NULL, NULL, NULL, 'EXPRESSED PROTEIN', NULL, NULL, NULL, 8),
(253909, NULL, 'PTHR14454', NULL, NULL, NULL, NULL, 'GRB2-ASSOCIATED AND REGULATOR OF MAPK PROTEIN FAMILY MEMBER', NULL, NULL, NULL, 8),
(253910, NULL, 'PTHR43778', NULL, NULL, NULL, NULL, 'PYRUVATE CARBOXYLASE', NULL, NULL, NULL, 8),
(253911, NULL, 'PTHR40288', NULL, NULL, NULL, NULL, 'PROTEIN CBG16535-RELATED', NULL, NULL, NULL, 8),
(253912, NULL, 'PTHR13172', NULL, NULL, NULL, NULL, 'MITOCHONDRIAL IMPORT INNER MEMBRANE TRANSLOCASE SUBUNIT TIM9B', NULL, NULL, NULL, 8),
(253913, NULL, 'PTHR31914', NULL, NULL, NULL, NULL, 'PROTEIN FAM163A', NULL, NULL, 32047, 8),
(253914, NULL, 'PTHR14389', NULL, NULL, NULL, NULL, 'SI:CH1073-475A24.1', NULL, NULL, NULL, 8),
(253915, NULL, 'PTHR22306', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(253916, NULL, 'PTHR11412', NULL, NULL, NULL, NULL, 'MACROGLOBULIN / COMPLEMENT', NULL, NULL, NULL, 8),
(253917, NULL, 'PTHR39515', NULL, NULL, NULL, NULL, 'CONSERVED PROTEIN', NULL, NULL, NULL, 8),
(253918, NULL, 'PTHR45985', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253919, NULL, 'PTHR13546', NULL, NULL, NULL, NULL, 'RE60986P', NULL, NULL, 15929, 8),
(253920, NULL, 'PTHR13066', NULL, NULL, NULL, NULL, 'BASIC LEUCINE ZIPPER NUCLEAR FACTOR 1 BLZF1  PROTEIN', NULL, NULL, 23842, 8),
(253921, NULL, 'PTHR16046', NULL, NULL, NULL, NULL, 'SMC5-SMC6 COMPLEX LOCALIZATION FACTOR 2', NULL, NULL, 23067, 8),
(253922, NULL, 'PTHR12917', NULL, NULL, NULL, NULL, 'ASPARTYL PROTEASE DDI-RELATED', NULL, NULL, NULL, 8),
(253923, NULL, 'PTHR17224', NULL, NULL, NULL, NULL, 'PEPTIDYL-TRNA HYDROLASE', NULL, NULL, 2443, 8),
(253924, NULL, 'PTHR15710', NULL, NULL, NULL, NULL, 'E3 UBIQUITIN-PROTEIN LIGASE PRAJA', NULL, NULL, NULL, 8),
(253925, NULL, 'PTHR12258', NULL, NULL, NULL, NULL, 'JANUS-A/JANUS-B', NULL, NULL, 1290, 8),
(253926, NULL, 'PTHR30570', NULL, NULL, NULL, NULL, 'PERIPLASMIC PHOSPHATE BINDING COMPONENT OF PHOSPHATE ABC TRANSPORTER', NULL, NULL, NULL, 8),
(253927, NULL, 'PTHR31002', NULL, NULL, NULL, NULL, 'SERIPAUPERIN', NULL, NULL, NULL, 8);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(253928, NULL, 'PTHR14974', NULL, NULL, NULL, NULL, 'SIMILAR TO RIKEN CDNA 1700025G04 GENE', NULL, NULL, 24374, 8),
(253929, NULL, 'PTHR14815', NULL, NULL, NULL, NULL, 'DDB1- AND CUL4-ASSOCIATED FACTOR 17', NULL, NULL, 26256, 8),
(253930, NULL, 'PTHR46170', NULL, NULL, NULL, NULL, 'GATOR COMPLEX PROTEIN WDR59', NULL, NULL, NULL, 8),
(253931, NULL, 'PTHR16001', NULL, NULL, NULL, NULL, 'ECTO-NOX DISULFIDE-THIOL EXCHANGER', NULL, NULL, 30580, 8),
(253932, NULL, 'PTHR40081', NULL, NULL, NULL, NULL, 'CONCANAVALIN A-LIKE LECTIN/GLUCANASE', NULL, NULL, 36353, 8),
(253933, NULL, 'PTHR34629', NULL, NULL, NULL, NULL, 'PROLINE-RICH EXTENSIN-LIKE PROTEIN EPR1', NULL, NULL, NULL, 8),
(253934, NULL, 'PTHR47102', NULL, NULL, NULL, NULL, 'PROTEIN BNI1', NULL, NULL, NULL, 8),
(253935, NULL, 'PTHR36746', NULL, NULL, NULL, NULL, 'BNAC04G51760D PROTEIN', NULL, NULL, NULL, 8),
(253936, NULL, 'PTHR37360', NULL, NULL, NULL, NULL, 'FRAGILE X MENTAL RETARDATION 1 NEIGHBOR PROTEIN', NULL, NULL, NULL, 8),
(253937, NULL, 'PTHR34038', NULL, NULL, NULL, NULL, 'ATP SYNTHASE MEMBRANE SUBUNIT DAPIT, MITOCHONDRIAL', NULL, NULL, 10063, 8),
(253938, NULL, 'PTHR46905', NULL, NULL, NULL, NULL, 'RING-H2 FINGER PROTEIN ATL78', NULL, NULL, 36181, 8),
(253939, NULL, 'PTHR28270', NULL, NULL, NULL, NULL, 'MEDIATOR OF RNA POLYMERASE II TRANSCRIPTION SUBUNIT 19', NULL, NULL, 7940, 8),
(253940, NULL, 'PTHR47371', NULL, NULL, NULL, NULL, 'LIPOTEICHOIC ACID SYNTHASE', NULL, NULL, NULL, 8),
(253941, NULL, 'PTHR35613', NULL, NULL, NULL, NULL, '', NULL, NULL, NULL, 8),
(253942, NULL, 'PTHR46881', NULL, NULL, NULL, NULL, 'PALMDELPHIN', NULL, NULL, NULL, 8),
(253943, NULL, 'PTHR31996', NULL, NULL, NULL, NULL, 'COILED-COIL DOMAIN-CONTAINING PROTEIN 115', NULL, NULL, 27648, 8),
(253944, NULL, 'PTHR45544', NULL, NULL, NULL, NULL, 'THIOSULFATE:GLUTATHIONE SULFURTRANSFERASE', NULL, NULL, 37534, 8),
(253945, NULL, 'PTHR32116', NULL, NULL, NULL, NULL, 'GALACTURONOSYLTRANSFERASE 4-RELATED', NULL, NULL, 24671, 8),
(253946, NULL, 'PTHR46226', NULL, NULL, NULL, NULL, 'CRAL-TRIO DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(253947, NULL, 'PTHR20858', NULL, NULL, NULL, NULL, 'PHOSPHOMETHYLPYRIMIDINE KINASE', NULL, NULL, 35643, 8),
(253948, NULL, 'PTHR46165', NULL, NULL, NULL, NULL, 'SET AND MYND DOMAIN-CONTAINING PROTEIN 4', NULL, NULL, NULL, 8),
(253949, NULL, 'PTHR44520', NULL, NULL, NULL, NULL, 'RESPONSE REGULATOR RCP1-RELATED', NULL, NULL, NULL, 8),
(253950, NULL, 'PTHR31013', NULL, NULL, NULL, NULL, 'THAUMATIN FAMILY PROTEIN-RELATED', NULL, NULL, NULL, 8),
(253951, NULL, 'PTHR23151', NULL, NULL, NULL, NULL, 'DIHYDROLIPOAMIDE ACETYL/SUCCINYL-TRANSFERASE-RELATED', NULL, NULL, 37336, 8),
(253952, NULL, 'PTHR35743', NULL, NULL, NULL, NULL, 'NODULIN HOMEOBOX', NULL, NULL, 30567, 8),
(253953, NULL, 'PTHR35598', NULL, NULL, NULL, NULL, 'ENDOTOXIN_N DOMAIN-CONTAINING PROTEIN', NULL, NULL, NULL, 8),
(253954, NULL, 'PTHR43605', NULL, NULL, NULL, NULL, 'ACYL-COENZYME A SYNTHETASE', NULL, NULL, NULL, 8),
(253955, NULL, 'PTHR47905', NULL, NULL, NULL, NULL, 'UBIQUITIN-LIKE PROTEIN 4B', NULL, NULL, 34747, 8),
(253956, NULL, 'PTHR43734', NULL, NULL, NULL, NULL, 'PHYTOENE DESATURASE', NULL, NULL, NULL, 8),
(253957, NULL, 'PTHR47149', NULL, NULL, NULL, NULL, 'F-BOX PROTEIN RMF', NULL, NULL, NULL, 8),
(253958, NULL, 'PTHR13890', NULL, NULL, NULL, NULL, 'RNA SPLICING PROTEIN MRS2, MITOCHONDRIAL', NULL, NULL, 32588, 8),
(253959, NULL, 'PTHR16461', NULL, NULL, NULL, NULL, 'TOLL-INTERACTING PROTEIN', NULL, NULL, NULL, 8),
(253960, NULL, 'PTHR11442', NULL, NULL, NULL, NULL, 'HEMOGLOBIN FAMILY MEMBER', NULL, NULL, NULL, 8),
(253961, NULL, 'PTHR43552', NULL, NULL, NULL, NULL, 'DIAMINOBUTYRATE--2-OXOGLUTARATE AMINOTRANSFERASE', NULL, NULL, 2466, 8),
(253962, NULL, 'PTHR45654', NULL, NULL, NULL, NULL, 'HOMEOBOX-LEUCINE ZIPPER PROTEIN MERISTEM L1', NULL, NULL, 34922, 8),
(253963, NULL, 'PTHR21298', NULL, NULL, NULL, NULL, 'UNCHARACTERIZED', NULL, NULL, NULL, 8),
(253964, NULL, 'PTHR20966', NULL, NULL, NULL, NULL, 'ANKYRIN REPEAT AND SOCS BOX PROTEIN 17', NULL, NULL, 32649, 8);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(253965, NULL, 'PTHR47693', NULL, NULL, NULL, NULL, 'BZIP TRANSCRIPTION FACTOR RISBZ3-RELATED', NULL, NULL, 35481, 8),
(253966, NULL, 'PTHR28124', NULL, NULL, NULL, NULL, 'DNA REPLICATION REGULATOR SLD2', NULL, NULL, 31004, 8),
(253967, NULL, 'PTHR47863', NULL, NULL, NULL, NULL, 'RING/FYVE/PHD ZINC FINGER SUPERFAMILY PROTEIN', NULL, NULL, NULL, 8),
(253968, NULL, 'PTHR36710', NULL, NULL, NULL, NULL, 'PECTINESTERASE INHIBITOR-LIKE', NULL, NULL, NULL, 8),
(253969, NULL, 'PTHR13087', NULL, NULL, NULL, NULL, 'NF-KAPPA B ACTIVATING PROTEIN', NULL, NULL, 28145, 8),
(253970, NULL, 'PTHR36752', NULL, NULL, NULL, NULL, 'OS12G0405700 PROTEIN', NULL, NULL, 10380, 8),
(253971, NULL, 'PTHR28097', NULL, NULL, NULL, NULL, 'PHEROMONE A FACTOR RECEPTOR', NULL, NULL, 6260, 8),
(253972, NULL, 'PTHR19300', NULL, NULL, NULL, NULL, 'BETA-1,4-GALACTOSYLTRANSFERASE', NULL, NULL, 3033, 8),
(253973, NULL, 'PF19796', NULL, NULL, 'Family of unknown function (DUF6280)', NULL, 'DUF6280', NULL, NULL, 37375, 9),
(253974, NULL, 'PF03403', NULL, NULL, 'Platelet-activating factor acetylhydrolase, isoform II', NULL, 'PAF-AH_p_II', NULL, NULL, 2194, 9),
(253975, NULL, 'PF11707', NULL, NULL, 'Ribosome 60S biogenesis N-terminal', NULL, 'Npa1', NULL, NULL, 19325, 9),
(253976, NULL, 'PF16999', NULL, NULL, 'Vacuolar (H+)-ATPase G subunit', NULL, 'V-ATPase_G_2', NULL, NULL, NULL, 9),
(253977, NULL, 'PF03972', NULL, NULL, 'MmgE/PrpD N-terminal domain', NULL, 'MmgE_PrpD', NULL, NULL, 36051, 9),
(253978, NULL, 'PF09632', NULL, NULL, 'Rac1-binding domain', NULL, 'Rac1', NULL, NULL, 17504, 9),
(253979, NULL, 'PF01223', NULL, NULL, 'DNA/RNA non-specific endonuclease', NULL, 'Endonuclease_NS', NULL, NULL, 3052, 9),
(253980, NULL, 'PF18026', NULL, NULL, 'Endo/exonuclease (EXOG) C-terminal domain', NULL, 'Exog_C', NULL, NULL, 29200, 9),
(253981, NULL, 'PF15657', NULL, NULL, 'HNH/Endo VII superfamily nuclease toxins', NULL, 'Tox-HNH-EHHH', NULL, NULL, 25396, 9),
(253982, NULL, 'PF16326', NULL, NULL, 'ABC transporter C-terminal domain', NULL, 'ABC_tran_CTD', NULL, NULL, 23898, 9),
(253983, NULL, 'PF16958', NULL, NULL, 'Pre-mRNA-splicing factor PRP9 N-terminus', NULL, 'PRP9_N', NULL, NULL, 22115, 9),
(253984, NULL, 'PF08810', NULL, NULL, 'Kinase associated protein B', NULL, 'KapB', NULL, NULL, 13253, 9),
(253985, NULL, 'PF13425', NULL, NULL, 'O-antigen ligase like membrane protein', NULL, 'O-antigen_lig', NULL, NULL, NULL, 9),
(253986, NULL, 'PF03475', NULL, NULL, '3-alpha domain', NULL, '3-alpha', NULL, NULL, 4742, 9),
(253987, NULL, 'PF07614', NULL, NULL, 'Protein of unknown function (DUF1577)', NULL, 'DUF1577', NULL, NULL, 13920, 9),
(253988, NULL, 'PF13131', NULL, NULL, 'Protein of unknown function (DUF3951)', NULL, 'DUF3951', NULL, NULL, 25559, 9),
(253989, NULL, 'PF04227', NULL, NULL, 'Indigoidine synthase A like protein', NULL, 'Indigoidine_A', NULL, NULL, 5832, 9),
(253990, NULL, 'PF00212', NULL, NULL, 'Atrial natriuretic peptide', NULL, 'ANP', NULL, NULL, 5674, 9),
(253991, NULL, 'PF02175', NULL, NULL, 'Serpentine type 7TM GPCR chemoreceptor Srb', NULL, '7TM_GPCR_Srb', NULL, NULL, 5672, 9),
(253992, NULL, 'PF05733', NULL, NULL, 'Tenuivirus/Phlebovirus nucleocapsid protein', NULL, 'Tenui_N', NULL, NULL, 9651, 9),
(253993, NULL, 'PF04391', NULL, NULL, 'Protein of unknown function (DUF533)', NULL, 'DUF533', NULL, NULL, 10137, 9),
(253994, NULL, 'PF13540', NULL, NULL, 'Regulator of chromosome condensation (RCC1) repeat', NULL, 'RCC1_2', NULL, NULL, NULL, 9),
(253995, NULL, 'PF17590', NULL, NULL, 'Family of unknown function (DUF5488)', NULL, 'DUF5488', NULL, NULL, 18650, 9),
(253996, NULL, 'PF10667', NULL, NULL, 'Protein of unknown function (DUF2486)', NULL, 'DUF2486', NULL, NULL, 14726, 9),
(253997, NULL, 'PF17500', NULL, NULL, 'Colicin-K immunity', NULL, 'CKI', NULL, NULL, 30171, 9),
(253998, NULL, 'PF17603', NULL, NULL, 'Family of unknown function (DUF5499)', NULL, 'DUF5499', NULL, NULL, 32001, 9),
(253999, NULL, 'PF00705', NULL, NULL, 'Proliferating cell nuclear antigen, N-terminal domain', NULL, 'PCNA_N', NULL, NULL, 17369, 9),
(254000, NULL, 'PF02983', NULL, NULL, 'Alpha-lytic protease prodomain', NULL, 'Pro_Al_protease', NULL, NULL, 3530, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(254001, NULL, 'PF15782', NULL, NULL, 'GREB1 N-terminal region', NULL, 'GREB1', NULL, NULL, 34027, 9),
(254002, NULL, 'PF01553', NULL, NULL, 'Acyltransferase', NULL, 'Acyltransferase', NULL, NULL, 1094, 9),
(254003, NULL, 'PF06304', NULL, NULL, 'Protein of unknown function (DUF1048)', NULL, 'DUF1048', NULL, NULL, 7998, 9),
(254004, NULL, 'PF11182', NULL, NULL, 'Alginate O-acetyl transferase AlgF', NULL, 'AlgF', NULL, NULL, 18164, 9),
(254005, NULL, 'PF19180', NULL, NULL, 'Family of unknown function (DUF5862)', NULL, 'DUF5862', NULL, NULL, 35044, 9),
(254006, NULL, 'PF10818', NULL, NULL, 'secA translation cis-regulator SecM, small type', NULL, 'SecM_small', NULL, NULL, 20045, 9),
(254007, NULL, 'PF00992', NULL, NULL, 'Troponin', NULL, 'Troponin', NULL, NULL, 2151, 9),
(254008, NULL, 'PF01481', NULL, NULL, 'Arterivirus nucleocapsid protein', NULL, 'Arteri_nucleo', NULL, NULL, 881, 9),
(254009, NULL, 'PF00808', NULL, NULL, 'Histone-like transcription factor (CBF/NF-Y) and archaeal histone', NULL, 'CBFD_NFYB_HMF', NULL, NULL, 7229, 9),
(254010, NULL, 'PF04053', NULL, NULL, 'Coatomer WD associated region', NULL, 'Coatomer_WDAD', NULL, NULL, 2172, 9),
(254011, NULL, 'PF01431', NULL, NULL, 'Peptidase family M13', NULL, 'Peptidase_M13', NULL, NULL, 9470, 9),
(254012, NULL, 'PF06904', NULL, NULL, 'Extensin-like protein C-terminus', NULL, 'Extensin-like_C', NULL, NULL, 11906, 9),
(254013, NULL, 'PF14627', NULL, NULL, 'Domain of unknown function (DUF4453)', NULL, 'DUF4453', NULL, NULL, 23337, 9),
(254014, NULL, 'PF13694', NULL, NULL, 'Sec63/Sec62 complex-interacting family', NULL, 'Hph', NULL, NULL, 24965, 9),
(254015, NULL, 'PF14312', NULL, NULL, 'FG-GAP repeat', NULL, 'FG-GAP_2', NULL, NULL, 13796, 9),
(254016, NULL, 'PF10260', NULL, NULL, 'Uncharacterized conserved domain (SAYSvFN)', NULL, 'SAYSvFN', NULL, NULL, 15980, 9),
(254017, NULL, 'PF12482', NULL, NULL, 'Phage integrase protein', NULL, 'DUF3701', NULL, NULL, 20916, 9),
(254018, NULL, 'PF02439', NULL, NULL, 'Adenovirus E3 region protein CR2', NULL, 'Adeno_E3_CR2', NULL, NULL, 6251, 9),
(254019, NULL, 'PF15967', NULL, NULL, 'Nucleoporin FG repeated region', NULL, 'Nucleoporin_FG2', NULL, NULL, NULL, 9),
(254020, NULL, 'PF03928', NULL, NULL, 'Haem degrading protein HbpS-like', NULL, 'HbpS-like', NULL, NULL, 2506, 9),
(254021, NULL, 'PF06678', NULL, NULL, 'Protein of unknown function (DUF1179)', NULL, 'DUF1179', NULL, NULL, 10499, 9),
(254022, NULL, 'PF10853', NULL, NULL, 'Protein of unknown function (DUF2650)', NULL, 'DUF2650', NULL, NULL, 14596, 9),
(254023, NULL, 'PF01558', NULL, NULL, 'Pyruvate ferredoxin/flavodoxin oxidoreductase', NULL, 'POR', NULL, NULL, 9033, 9),
(254024, NULL, 'PF06465', NULL, NULL, 'CHD subfamily II, DUF1087', NULL, 'DUF1087', NULL, NULL, 9226, 9),
(254025, NULL, 'PF20352', NULL, NULL, 'Family of unknown function (DUF6647)', NULL, 'DUF6647', NULL, NULL, 33506, 9),
(254026, NULL, 'PF20609', NULL, NULL, 'Putative adhesive domain (group 17)', NULL, 'pAdhesive_17', NULL, NULL, 33770, 9),
(254027, NULL, 'PF05215', NULL, NULL, 'Spiralin domain', NULL, 'Spiralin', NULL, NULL, 3405, 9),
(254028, NULL, 'PF00552', NULL, NULL, 'Integrase DNA binding domain', NULL, 'IN_DBD_C', NULL, NULL, 1278, 9),
(254029, NULL, 'PF17384', NULL, NULL, 'RimP C-terminal SH3 domain', NULL, 'DUF150_C', NULL, NULL, 23500, 9),
(254030, NULL, 'PF15571', NULL, NULL, 'Immunity protein 44', NULL, 'Imm44', NULL, NULL, 25108, 9),
(254031, NULL, 'PF19420', NULL, NULL, 'N,N dimethylarginine dimethylhydrolase, eukaryotic', NULL, 'DDAH_eukar', NULL, NULL, NULL, 9),
(254032, NULL, 'PF11350', NULL, NULL, 'Protein of unknown function (DUF3152)', NULL, 'DUF3152', NULL, NULL, 16622, 9),
(254033, NULL, 'PF00799', NULL, NULL, 'Geminivirus Rep catalytic domain', NULL, 'Gemini_AL1', NULL, NULL, 14783, 9),
(254034, NULL, 'PF07393', NULL, NULL, 'Exocyst complex component Sec10', NULL, 'Sec10', NULL, NULL, 8145, 9),
(254035, NULL, 'PF12475', NULL, NULL, 'Amdovirus non-structural protein', NULL, 'Amdo_NSP', NULL, NULL, 15588, 9),
(254036, NULL, 'PF17793', NULL, NULL, 'ANC1 homology domain (AHD)', NULL, 'AHD', NULL, NULL, 27540, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(254037, NULL, 'PF09117', NULL, NULL, 'MiAMP1', NULL, 'MiAMP1', NULL, NULL, 10535, 9),
(254038, NULL, 'PF07611', NULL, NULL, 'Protein of unknown function (DUF1574)', NULL, 'DUF1574', NULL, NULL, 13639, 9),
(254039, NULL, 'PF14962', NULL, NULL, 'Mitochondria Localisation Sequence', NULL, 'AIF-MLS', NULL, NULL, 22289, 9),
(254040, NULL, 'PF06328', NULL, NULL, 'Ig-like C2-type domain', NULL, 'Lep_receptor_Ig', NULL, NULL, 10212, 9),
(254041, NULL, 'PF17102', NULL, NULL, 'Stealth protein CR3, conserved region 3', NULL, 'Stealth_CR3', NULL, NULL, 4960, 9),
(254042, NULL, 'PF10767', NULL, NULL, 'Protein of unknown function (DUF2593)', NULL, 'DUF2593', NULL, NULL, 20840, 9),
(254043, NULL, 'PF07267', NULL, NULL, 'Nucleopolyhedrovirus capsid protein P87', NULL, 'Nucleo_P87', NULL, NULL, 14384, 9),
(254044, NULL, 'PF10522', NULL, NULL, 'RII binding domain', NULL, 'RII_binding_1', NULL, NULL, 21241, 9),
(254045, NULL, 'PF13248', NULL, NULL, 'zinc-ribbon domain', NULL, 'zf-ribbon_3', NULL, NULL, NULL, 9),
(254046, NULL, 'PF06596', NULL, NULL, 'Photosystem II reaction centre X protein (PsbX)', NULL, 'PsbX', NULL, NULL, 9730, 9),
(254047, NULL, 'PF20052', NULL, NULL, 'GTPase-associated protein 1, C-terminal domain', NULL, 'GAP1-C', NULL, NULL, NULL, 9),
(254048, NULL, 'PF04394', NULL, NULL, 'Protein of unknown function, DUF536', NULL, 'DUF536', NULL, NULL, 10249, 9),
(254049, NULL, 'PF15067', NULL, NULL, 'FAM124 family', NULL, 'FAM124', NULL, NULL, 36775, 9),
(254050, NULL, 'PF02429', NULL, NULL, 'Peridinin-chlorophyll A binding protein', NULL, 'PCP', NULL, NULL, 4163, 9),
(254051, NULL, 'PF06684', NULL, NULL, 'Amino acid synthesis', NULL, 'AA_synth', NULL, NULL, 626, 9),
(254052, NULL, 'PF17600', NULL, NULL, 'Family of unknown function (DUF5496)', NULL, 'DUF5496', NULL, NULL, 32460, 9),
(254053, NULL, 'PF15499', NULL, NULL, 'Ubiquitin-specific peptidase-like, SUMO isopeptidase', NULL, 'Peptidase_C98', NULL, NULL, 24117, 9),
(254054, NULL, 'PF19549', NULL, NULL, 'Family of unknown function (DUF6072)', NULL, 'DUF6072', NULL, NULL, 34162, 9),
(254055, NULL, 'PF00449', NULL, NULL, 'Urease alpha-subunit, N-terminal domain', NULL, 'Urease_alpha', NULL, NULL, 8500, 9),
(254056, NULL, 'PF13578', NULL, NULL, 'Methyltransferase domain', NULL, 'Methyltransf_24', NULL, NULL, NULL, 9),
(254057, NULL, 'PF19626', NULL, NULL, 'Family of unknown function (DUF6131)', NULL, 'DUF6131', NULL, NULL, 37037, 9),
(254058, NULL, 'PF16621', NULL, NULL, 'SH3 terminal domain of 2nd SH3 on Neutrophil cytosol factor 1', NULL, 'NECFESHC', NULL, NULL, 22371, 9),
(254059, NULL, 'PF05052', NULL, NULL, 'MerE protein', NULL, 'MerE', NULL, NULL, 1388, 9),
(254060, NULL, 'PF07827', NULL, NULL, 'KNTase C-terminal domain', NULL, 'KNTase_C', NULL, NULL, 11819, 9),
(254061, NULL, 'PF18138', NULL, NULL, 'Bacterial HORMA domain family 1', NULL, 'bacHORMA_1', NULL, NULL, 28509, 9),
(254062, NULL, 'PF19280', NULL, NULL, 'Ceramide kinase C-terminal domain', NULL, 'CERK_C', NULL, NULL, 35920, 9),
(254063, NULL, 'PF15560', NULL, NULL, 'Immunity protein 12', NULL, 'Imm12', NULL, NULL, 25041, 9),
(254064, NULL, 'PF06208', NULL, NULL, 'Borna disease virus G protein', NULL, 'BDV_G', NULL, NULL, 14417, 9),
(254065, NULL, 'PF09296', NULL, NULL, 'NADH pyrophosphatase-like rudimentary NUDIX domain', NULL, 'NUDIX-like', NULL, NULL, 14287, 9),
(254066, NULL, 'PF10458', NULL, NULL, 'Valyl tRNA synthetase tRNA binding arm', NULL, 'Val_tRNA-synt_C', NULL, NULL, 18222, 9),
(254067, NULL, 'PF11760', NULL, NULL, 'Cobalamin synthesis G N-terminal', NULL, 'CbiG_N', NULL, NULL, 19327, 9),
(254068, NULL, 'PF19285', NULL, NULL, 'Neuromedin-U receptor 2, C-terminal', NULL, 'NmU-R2_C_term', NULL, NULL, 36421, 9),
(254069, NULL, 'PF02394', NULL, NULL, 'Interleukin-1 propeptide', NULL, 'IL1_propep', NULL, NULL, 6354, 9),
(254070, NULL, 'PF14363', NULL, NULL, 'Domain associated at C-terminal with AAA', NULL, 'AAA_assoc', NULL, NULL, 22133, 9),
(254071, NULL, 'PF05262', NULL, NULL, 'Borrelia P83/100 protein', NULL, 'Borrelia_P83', NULL, NULL, 3264, 9),
(254072, NULL, 'PF06293', NULL, NULL, 'Lipopolysaccharide kinase (Kdo/WaaP) family', NULL, 'Kdo', NULL, NULL, NULL, 9);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(254073, NULL, 'PF04017', NULL, NULL, 'Domain of unknown function (DUF366)', NULL, 'DUF366', NULL, NULL, 57, 9),
(254074, NULL, 'PF19234', NULL, NULL, 'Family of unknown function (DUF5887)', NULL, 'DUF5887', NULL, NULL, 35772, 9),
(254075, NULL, 'PF15556', NULL, NULL, 'ZW10 interactor', NULL, 'Zwint', NULL, NULL, 25371, 9),
(254076, NULL, 'PF09154', NULL, NULL, 'Alpha-amylase C-terminal', NULL, 'Alpha-amy_C_pro', NULL, NULL, 12440, 9),
(254077, NULL, 'PF13768', NULL, NULL, 'von Willebrand factor type A domain', NULL, 'VWA_3', NULL, NULL, 2425, 9),
(254078, NULL, 'PF14457', NULL, NULL, 'Prokaryotic E2 family A', NULL, 'Prok-E2_A', NULL, NULL, 25218, 9),
(254079, NULL, 'PF07877', NULL, NULL, 'Protein of unknown function (DUF1661)', NULL, 'DUF1661', NULL, NULL, 14299, 9),
(254080, NULL, 'PF14583', NULL, NULL, 'Oligogalacturonate lyase', NULL, 'Pectate_lyase22', NULL, NULL, 24422, 9),
(254081, NULL, 'PF03902', NULL, NULL, 'Gal4-like dimerisation domain', NULL, 'Gal4_dimer', NULL, NULL, 2616, 9),
(254082, NULL, 'PF14079', NULL, NULL, 'Domain of unknown function (DUF4260)', NULL, 'DUF4260', NULL, NULL, 22681, 9),
(254083, NULL, 'PF16962', NULL, NULL, 'Putative ABC exporter', NULL, 'ABC_export', NULL, NULL, 22497, 9),
(254084, NULL, 'PF19719', NULL, NULL, 'Family of unknown function (DUF6213)', NULL, 'DUF6213', NULL, NULL, 37125, 9),
(254085, NULL, 'PF13492', NULL, NULL, 'GAF domain', NULL, 'GAF_3', NULL, NULL, 112, 9),
(254086, NULL, 'PF13671', NULL, NULL, 'AAA domain', NULL, 'AAA_33', NULL, NULL, NULL, 9),
(254087, NULL, 'PF04768', NULL, NULL, 'NAT, N-acetyltransferase, of N-acetylglutamate synthase', NULL, 'NAT', NULL, NULL, 3669, 9),
(254088, NULL, 'PF05077', NULL, NULL, 'Protein of unknown function (DUF678)', NULL, 'DUF678', NULL, NULL, 1337, 9),
(254089, NULL, 'PF16724', NULL, NULL, 'T4-like virus Myoviridae tail sheath stabiliser', NULL, 'T4-gp15_tss', NULL, NULL, 23458, 9),
(254090, NULL, 'PF03032', NULL, NULL, 'Frog skin active peptide family signal and propeptide', NULL, 'FSAP_sig_propep', NULL, NULL, 4975, 9),
(254091, NULL, 'PF15906', NULL, NULL, 'Zinc-finger of nitric oxide synthase-interacting protein', NULL, 'zf-NOSIP', NULL, NULL, 22247, 9),
(254092, NULL, 'PF13485', NULL, NULL, 'Peptidase MA superfamily', NULL, 'Peptidase_MA_2', NULL, NULL, 27347, 9),
(254093, NULL, 'PF09269', NULL, NULL, 'Domain of unknown function (DUF1967)', NULL, 'DUF1967', NULL, NULL, 13354, 9),
(254094, NULL, 'PF16283', NULL, NULL, 'Domain of unknown function (DUF4929)', NULL, 'DUF4929', NULL, NULL, 21771, 9),
(254095, NULL, 'PF18036', NULL, NULL, 'Ubiquitin-like domain', NULL, 'Ubiquitin_4', NULL, NULL, 31548, 9),
(254096, NULL, 'PF00456', NULL, NULL, 'Transketolase, thiamine diphosphate binding domain', NULL, 'Transketolase_N', NULL, NULL, 902, 9),
(254097, NULL, 'PF19301', NULL, NULL, 'LigXa C-terminal domain like', NULL, 'LigXa_C', NULL, NULL, 34271, 9),
(254098, NULL, 'PF09186', NULL, NULL, 'Domain of unknown function (DUF1949)', NULL, 'DUF1949', NULL, NULL, 12344, 9),
(254099, NULL, 'PF00207', NULL, NULL, 'Alpha-2-macroglobulin family', NULL, 'A2M', NULL, NULL, 5160, 9),
(254100, NULL, 'PF05094', NULL, NULL, 'Late expression factor 9 (LEF-9)', NULL, 'LEF-9', NULL, NULL, 2337, 9),
(254101, NULL, 'PF10800', NULL, NULL, 'Protein of unknown function (DUF2528)', NULL, 'DUF2528', NULL, NULL, 13053, 9),
(254102, NULL, 'PF03225', NULL, NULL, 'Viral heat shock protein Hsp90 homologue', NULL, 'Viral_Hsp90', NULL, NULL, 1558, 9),
(254103, NULL, 'PF13126', NULL, NULL, 'Protein of unknown function (DUF3975)', NULL, 'DUF3975', NULL, NULL, 25726, 9),
(254104, NULL, 'PF17122', NULL, NULL, 'Zinc-finger', NULL, 'zf-C3H2C3', NULL, NULL, 4043, 9),
(254105, NULL, 'PF03671', NULL, NULL, 'Ubiquitin fold modifier 1 protein', NULL, 'Ufm1', NULL, NULL, 6620, 9),
(254106, NULL, 'PF04754', NULL, NULL, 'Putative transposase, YhgA-like', NULL, 'Transposase_31', NULL, NULL, 3605, 9),
(254107, NULL, 'PF16445', NULL, NULL, 'Domain of unknown function (DUF5042)', NULL, 'DUF5042', NULL, NULL, 26996, 9),
(254108, NULL, 'PF04435', NULL, NULL, 'Domain of unknown function (DUF545)', NULL, 'SPK', NULL, NULL, 114, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(254109, NULL, 'PF06366', NULL, NULL, 'Flagellar protein FlhE', NULL, 'FlhE', NULL, NULL, 8229, 9),
(254110, NULL, 'PF19739', NULL, NULL, 'Family of unknown function (DUF6228)', NULL, 'DUF6228', NULL, NULL, 37440, 9),
(254111, NULL, 'PF00533', NULL, NULL, 'BRCA1 C Terminus (BRCT) domain', NULL, 'BRCT', NULL, NULL, 7483, 9),
(254112, NULL, 'PF10629', NULL, NULL, 'Protein of unknown function (DUF2475)', NULL, 'DUF2475', NULL, NULL, 20726, 9),
(254113, NULL, 'PF14550', NULL, NULL, 'Putative phage serine protease XkdF', NULL, 'Peptidase_S78_2', NULL, NULL, 24198, 9),
(254114, NULL, 'PF14400', NULL, NULL, 'Inactive transglutaminase fused to 7 transmembrane helices', NULL, 'Transglut_i_TM', NULL, NULL, 24493, 9),
(254115, NULL, 'PF16113', NULL, NULL, 'Enoyl-CoA hydratase/isomerase', NULL, 'ECH_2', NULL, NULL, 35943, 9),
(254116, NULL, 'PF18982', NULL, NULL, 'Family of unknown function (DUF5716)', NULL, 'DUF5716', NULL, NULL, 35415, 9),
(254117, NULL, 'PF04139', NULL, NULL, 'Rad9', NULL, 'Rad9', NULL, NULL, 7317, 9),
(254118, NULL, 'PF18971', NULL, NULL, 'CagA protein', NULL, 'CagA_N', NULL, NULL, 36543, 9),
(254119, NULL, 'PF09481', NULL, NULL, 'CRISPR-associated protein Cse1 (CRISPR_cse1)', NULL, 'CRISPR_Cse1', NULL, NULL, 11060, 9),
(254120, NULL, 'PF20432', NULL, NULL, 'Antitoxin Xre-like helix-turn-helix domain', NULL, 'Xre-like-HTH', NULL, NULL, 36915, 9),
(254121, NULL, 'PF05007', NULL, NULL, 'Mannosyltransferase (PIG-M)', NULL, 'Mannosyl_trans', NULL, NULL, 1133, 9),
(254122, NULL, 'PF00403', NULL, NULL, 'Heavy-metal-associated domain', NULL, 'HMA', NULL, NULL, 10473, 9),
(254123, NULL, 'PF07237', NULL, NULL, 'Protein of unknown function (DUF1428)', NULL, 'DUF1428', NULL, NULL, 14218, 9),
(254124, NULL, 'PF16580', NULL, NULL, 'C-terminal tail of astrovirus capsid projection or spike', NULL, 'Astro_capsid_p2', NULL, NULL, 26263, 9),
(254125, NULL, 'PF01551', NULL, NULL, 'Peptidase family M23', NULL, 'Peptidase_M23', NULL, NULL, 9374, 9),
(254126, NULL, 'PF06315', NULL, NULL, 'Isocitrate dehydrogenase kinase/phosphatase (AceK) kinase domain', NULL, 'AceK_kinase', NULL, NULL, 33921, 9),
(254127, NULL, 'PF13835', NULL, NULL, 'Domain of unknown function (DUF4194)', NULL, 'DUF4194', NULL, NULL, 22160, 9),
(254128, NULL, 'PF14571', NULL, NULL, 'Stress-induced protein Di19, C-terminal', NULL, 'Di19_C', NULL, NULL, 24409, 9),
(254129, NULL, 'PF00767', NULL, NULL, 'Potyvirus coat protein', NULL, 'Poty_coat', NULL, NULL, 5264, 9),
(254130, NULL, 'PF01414', NULL, NULL, 'Delta serrate ligand', NULL, 'DSL', NULL, NULL, 3456, 9),
(254131, NULL, 'PF12119', NULL, NULL, 'Protein of unknown function (DUF3581)', NULL, 'DUF3581', NULL, NULL, 20498, 9),
(254132, NULL, 'PF09052', NULL, NULL, 'SipA N-terminal domain', NULL, 'SipA', NULL, NULL, 9534, 9),
(254133, NULL, 'PF15100', NULL, NULL, 'TMEM187 protein family', NULL, 'TMEM187', NULL, NULL, 26780, 9),
(254134, NULL, 'PF16890', NULL, NULL, 'Domain of unknown function (DUF5083)', NULL, 'DUF5083', NULL, NULL, 22590, 9),
(254135, NULL, 'PF05115', NULL, NULL, 'Cytochrome B6-F complex subunit VI (PetL)', NULL, 'PetL', NULL, NULL, 2476, 9),
(254136, NULL, 'PF14506', NULL, NULL, 'CppA N-terminal', NULL, 'CppA_N', NULL, NULL, 21711, 9),
(254137, NULL, 'PF07905', NULL, NULL, 'Purine catabolism regulatory protein-like family', NULL, 'PucR', NULL, NULL, 13024, 9),
(254138, NULL, 'PF05038', NULL, NULL, 'Cytochrome Cytochrome b558 alpha-subunit', NULL, 'Cytochrom_B558a', NULL, NULL, 1155, 9),
(254139, NULL, 'PF10874', NULL, NULL, 'Protein of unknown function (DUF2746)', NULL, 'DUF2746', NULL, NULL, 16575, 9),
(254140, NULL, 'PF06018', NULL, NULL, 'CodY GAF-like domain', NULL, 'CodY', NULL, NULL, 8709, 9),
(254141, NULL, 'PF13205', NULL, NULL, 'Bacterial Ig-like domain', NULL, 'Big_5', NULL, NULL, 22396, 9),
(254142, NULL, 'PF06040', NULL, NULL, 'Adenovirus E3 protein', NULL, 'Adeno_E3', NULL, NULL, 13515, 9),
(254143, NULL, 'PF00107', NULL, NULL, 'Zinc-binding dehydrogenase', NULL, 'ADH_zinc_N', NULL, NULL, 9105, 9),
(254144, NULL, 'PF05991', NULL, NULL, 'YacP-like NYN domain', NULL, 'NYN_YacP', NULL, NULL, 7571, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(254145, NULL, 'PF08637', NULL, NULL, 'ATP synthase regulation protein NCA2', NULL, 'NCA2', NULL, NULL, 7914, 9),
(254146, NULL, 'PF09869', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2096)', NULL, 'DUF2096', NULL, NULL, 20137, 9),
(254147, NULL, 'PF10976', NULL, NULL, 'Protein of unknown function (DUF2790)', NULL, 'DUF2790', NULL, NULL, 17966, 9),
(254148, NULL, 'PF10041', NULL, NULL, 'Uncharacterized conserved protein (DUF2277)', NULL, 'DUF2277', NULL, NULL, 18297, 9),
(254149, NULL, 'PF02155', NULL, NULL, 'Glucocorticoid receptor', NULL, 'GCR', NULL, NULL, 3324, 9),
(254150, NULL, 'PF03088', NULL, NULL, 'Strictosidine synthase', NULL, 'Str_synth', NULL, NULL, 13864, 9),
(254151, NULL, 'PF19231', NULL, NULL, 'Family of unknown function (DUF5884)', NULL, 'DUF5884', NULL, NULL, 35617, 9),
(254152, NULL, 'PF15283', NULL, NULL, 'Domain of unknown function (DUF4595) with porin-like fold', NULL, 'DUF4595', NULL, NULL, 25397, 9),
(254153, NULL, 'PF12061', NULL, NULL, 'Late blight resistance protein R1', NULL, 'NB-LRR', NULL, NULL, 19759, 9),
(254154, NULL, 'PF15149', NULL, NULL, 'Cation channel sperm-associated protein subunit beta protein family', NULL, 'CATSPERB', NULL, NULL, 23219, 9),
(254155, NULL, 'PF20254', NULL, NULL, 'Domain of unknown function (DUF6605)', NULL, 'DUF6605', NULL, NULL, 37719, 9),
(254156, NULL, 'PF00230', NULL, NULL, 'Major intrinsic protein', NULL, 'MIP', NULL, NULL, 4930, 9),
(254157, NULL, 'PF04860', NULL, NULL, 'Phage portal protein', NULL, 'Phage_portal', NULL, NULL, 5818, 9),
(254158, NULL, 'PF00739', NULL, NULL, 'Trans-activation protein X', NULL, 'X', NULL, NULL, 4489, 9),
(254159, NULL, 'PF07873', NULL, NULL, 'YabP family', NULL, 'YabP', NULL, NULL, 15741, 9),
(254160, NULL, 'PF03835', NULL, NULL, 'Rad4 transglutaminase-like domain', NULL, 'Rad4', NULL, NULL, 17726, 9),
(254161, NULL, 'PF11774', NULL, NULL, 'Lsr2', NULL, 'Lsr2', NULL, NULL, 22188, 9),
(254162, NULL, 'PF08967', NULL, NULL, 'Domain of unknown function (DUF1884)', NULL, 'DUF1884', NULL, NULL, 7529, 9),
(254163, NULL, 'PF13085', NULL, NULL, '2Fe-2S iron-sulfur cluster binding domain', NULL, 'Fer2_3', NULL, NULL, 23553, 9),
(254164, NULL, 'PF03055', NULL, NULL, 'Retinal pigment epithelial membrane protein', NULL, 'RPE65', NULL, NULL, 4510, 9),
(254165, NULL, 'PF16418', NULL, NULL, 'CCR4-NOT transcription complex subunit 1 HEAT repeat', NULL, 'CNOT1_HEAT', NULL, NULL, 23558, 9),
(254166, NULL, 'PF13466', NULL, NULL, 'STAS domain', NULL, 'STAS_2', NULL, NULL, 2727, 9),
(254167, NULL, 'PF00752', NULL, NULL, 'XPG N-terminal domain', NULL, 'XPG_N', NULL, NULL, 2851, 9),
(254168, NULL, 'PF04262', NULL, NULL, 'Glutamate-cysteine ligase', NULL, 'Glu_cys_ligase', NULL, NULL, 5599, 9),
(254169, NULL, 'PF06162', NULL, NULL, 'Putative pyroglutamyl peptidase PgaPase_1', NULL, 'PgaPase_1', NULL, NULL, 9024, 9),
(254170, NULL, 'PF19186', NULL, NULL, 'Family of unknown function (DUF5868)', NULL, 'DUF5868', NULL, NULL, 35293, 9),
(254171, NULL, 'PF03213', NULL, NULL, 'Poxvirus P35 protein', NULL, 'Pox_P35', NULL, NULL, 1532, 9),
(254172, NULL, 'PF04041', NULL, NULL, 'beta-1,4-mannooligosaccharide phosphorylase', NULL, 'Glyco_hydro_130', NULL, NULL, 574, 9),
(254173, NULL, 'PF07713', NULL, NULL, 'Protein of unknown function (DUF1604)', NULL, 'DUF1604', NULL, NULL, 10525, 9),
(254174, NULL, 'PF08235', NULL, NULL, 'LNS2 (Lipin/Ned1/Smp2)', NULL, 'LNS2', NULL, NULL, 17279, 9),
(254175, NULL, 'PF08975', NULL, NULL, 'Domain of unknown function (DUF1868)', NULL, '2H-phosphodiest', NULL, NULL, 8667, 9),
(254176, NULL, 'PF16885', NULL, NULL, 'Voltage-gated calcium channel subunit alpha, C-term', NULL, 'CAC1F_C', NULL, NULL, 24818, 9),
(254177, NULL, 'PF11460', NULL, NULL, 'Protein of unknown function (DUF3007)', NULL, 'DUF3007', NULL, NULL, 18540, 9),
(254178, NULL, 'PF06695', NULL, NULL, 'Putative small multi-drug export protein', NULL, 'Sm_multidrug_ex', NULL, NULL, 919, 9),
(254179, NULL, 'PF12377', NULL, NULL, 'Duffy binding protein N terminal', NULL, 'DuffyBP_N', NULL, NULL, 15427, 9),
(254180, NULL, 'PF15750', NULL, NULL, 'Ubiquitin-binding zinc-finger', NULL, 'UBZ_FAAP20', NULL, NULL, 25116, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(254181, NULL, 'PF07038', NULL, NULL, 'Circovirus 2, anti-apoptotic ORF4', NULL, 'Circovir2_Orf4', NULL, NULL, 12308, 9),
(254182, NULL, 'PF19760', NULL, NULL, 'Family of unknown function (DUF6247)', NULL, 'DUF6247', NULL, NULL, 37287, 9),
(254183, NULL, 'PF05600', NULL, NULL, 'CDK5 regulatory subunit-associated protein 3', NULL, 'CDK5RAP3', NULL, NULL, 12006, 9),
(254184, NULL, 'PF03818', NULL, NULL, 'Malonate/sodium symporter MadM subunit', NULL, 'MadM', NULL, NULL, 20819, 9),
(254185, NULL, 'PF16030', NULL, NULL, 'Serine protease gd N-terminus', NULL, 'GD_N', NULL, NULL, 22867, 9),
(254186, NULL, 'PF08437', NULL, NULL, 'Glycosyl transferase family 8 C-terminal', NULL, 'Glyco_transf_8C', NULL, NULL, 11716, 9),
(254187, NULL, 'PF12940', NULL, NULL, 'Recombination-activation protein 1 (RAG1), recombinase', NULL, 'RAG1', NULL, NULL, 17059, 9),
(254188, NULL, 'PF03302', NULL, NULL, 'Giardia variant-specific surface protein', NULL, 'VSP', NULL, NULL, 7314, 9),
(254189, NULL, 'PF10285', NULL, NULL, 'Luciferase catalytic domain', NULL, 'Luciferase_cat', NULL, NULL, 19097, 9),
(254190, NULL, 'PF16649', NULL, NULL, 'Interleukin 23 subunit alpha', NULL, 'IL23', NULL, NULL, 11147, 9),
(254191, NULL, 'PF05713', NULL, NULL, 'Bacterial mobilisation protein (MobC)', NULL, 'MobC', NULL, NULL, 13382, 9),
(254192, NULL, 'PF02613', NULL, NULL, 'Nitrate reductase delta subunit', NULL, 'Nitrate_red_del', NULL, NULL, 16310, 9),
(254193, NULL, 'PF04843', NULL, NULL, 'Herpesvirus tegument protein, N-terminal conserved region', NULL, 'Herpes_teg_N', NULL, NULL, 5006, 9),
(254194, NULL, 'PF01166', NULL, NULL, 'TSC-22/dip/bun family', NULL, 'TSC22', NULL, NULL, 5606, 9),
(254195, NULL, 'PF13686', NULL, NULL, 'DsrE/DsrF/DrsH-like family', NULL, 'DrsE_2', NULL, NULL, 21733, 9),
(254196, NULL, 'PF16486', NULL, NULL, 'N-terminal domain of argonaute', NULL, 'ArgoN', NULL, NULL, 21826, 9),
(254197, NULL, 'PF02965', NULL, NULL, 'Vitamin B12 dependent methionine synthase, activation domain', NULL, 'Met_synt_B12', NULL, NULL, 3880, 9),
(254198, NULL, 'PF12803', NULL, NULL, 'mRNA (guanine-7-)methyltransferase (G-7-MTase)', NULL, 'G-7-MTase', NULL, NULL, 22272, 9),
(254199, NULL, 'PF15500', NULL, NULL, 'Putative RNase-like toxin, toxin_1', NULL, 'Ntox1', NULL, NULL, 23753, 9),
(254200, NULL, 'PF04475', NULL, NULL, 'Protein of unknown function (DUF555)', NULL, 'DUF555', NULL, NULL, 1875, 9),
(254201, NULL, 'PF09221', NULL, NULL, 'Bacteriocin class IId cyclical uberolysin-like', NULL, 'Bacteriocin_IId', NULL, NULL, 17804, 9),
(254202, NULL, 'PF12621', NULL, NULL, 'Extracellular tail, of 10TM putative phosphate transporter', NULL, 'PHM7_ext', NULL, NULL, 21222, 9),
(254203, NULL, 'PF00838', NULL, NULL, 'Translationally controlled tumour protein', NULL, 'TCTP', NULL, NULL, 13732, 9),
(254204, NULL, 'PF10029', NULL, NULL, 'Predicted periplasmic protein (DUF2271)', NULL, 'DUF2271', NULL, NULL, 9965, 9),
(254205, NULL, 'PF20493', NULL, NULL, 'Fungal WD-like', NULL, 'WD-like_fungi', NULL, NULL, 33760, 9),
(254206, NULL, 'PF08603', NULL, NULL, 'Adenylate cyclase associated (CAP) C terminal', NULL, 'CAP_C', NULL, NULL, 17963, 9),
(254207, NULL, 'PF14514', NULL, NULL, 'Tetracyclin repressor-like, C-terminal domain', NULL, 'TetR_C_9', NULL, NULL, 10516, 9),
(254208, NULL, 'PF06271', NULL, NULL, 'RDD family', NULL, 'RDD', NULL, NULL, 9032, 9),
(254209, NULL, 'PF17419', NULL, NULL, 'Methylamine utilization protein MauJ', NULL, 'MauJ', NULL, NULL, 33189, 9),
(254210, NULL, 'PF02071', NULL, NULL, 'Aromatic-di-Alanine (AdAR) repeat', NULL, 'NSF', NULL, NULL, NULL, 9),
(254211, NULL, 'PF06139', NULL, NULL, 'BphX-like', NULL, 'BphX', NULL, NULL, 14390, 9),
(254212, NULL, 'PF18516', NULL, NULL, 'RuvC nuclease domain', NULL, 'RuvC_1', NULL, NULL, 32829, 9),
(254213, NULL, 'PF18686', NULL, NULL, 'Family of unknown function (DUF5636)', NULL, 'DUF5636', NULL, NULL, 28101, 9),
(254214, NULL, 'PF18921', NULL, NULL, 'Cyanophycin synthase-like N-terminal domain', NULL, 'Cyanophycin_syn', NULL, NULL, 35788, 9),
(254215, NULL, 'PF05842', NULL, NULL, 'Euplotes octocarinatus mating pheromone protein', NULL, 'Euplotes_phero', NULL, NULL, 14295, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(254216, NULL, 'PF12456', NULL, NULL, 'Inositol phosphatase', NULL, 'hSac2', NULL, NULL, 20848, 9),
(254217, NULL, 'PF06314', NULL, NULL, 'Acetoacetate decarboxylase (ADC)', NULL, 'ADC', NULL, NULL, 10138, 9),
(254218, NULL, 'PF18502', NULL, NULL, '54S ribosomal protein L8 C-terminal domain', NULL, 'Mrpl_C', NULL, NULL, 32335, 9),
(254219, NULL, 'PF19522', NULL, NULL, 'Family of unknown function (DUF6052)', NULL, 'DUF6052', NULL, NULL, 37204, 9),
(254220, NULL, 'PF12559', NULL, NULL, 'Serine endopeptidase inhibitors', NULL, 'Inhibitor_I10', NULL, NULL, 21343, 9),
(254221, NULL, 'PF04265', NULL, NULL, 'Thiamin pyrophosphokinase, vitamin B1 binding domain', NULL, 'TPK_B1_binding', NULL, NULL, 5550, 9),
(254222, NULL, 'PF10573', NULL, NULL, 'Uncharacterised protein family UPF0561', NULL, 'UPF0561', NULL, NULL, 20814, 9),
(254223, NULL, 'PF15872', NULL, NULL, 'Serine-rich and transmembrane domain-containing protein 1', NULL, 'SRTM1', NULL, NULL, 23689, 9),
(254224, NULL, 'PF00275', NULL, NULL, 'EPSP synthase (3-phosphoshikimate 1-carboxyvinyltransferase)', NULL, 'EPSP_synthase', NULL, NULL, 4743, 9),
(254225, NULL, 'PF15367', NULL, NULL, 'Calcium-binding and spermatid-specific protein 1', NULL, 'CABS1', NULL, NULL, 22498, 9),
(254226, NULL, 'PF17781', NULL, NULL, 'RPN1 N-terminal domain', NULL, 'RPN1_RPN2_N', NULL, NULL, 32202, 9),
(254227, NULL, 'PF14162', NULL, NULL, 'YozD-like protein', NULL, 'YozD', NULL, NULL, 23956, 9),
(254228, NULL, 'PF04165', NULL, NULL, 'Protein of unknown function (DUF401)', NULL, 'DUF401', NULL, NULL, 7372, 9),
(254229, NULL, 'PF05450', NULL, NULL, 'Nicastrin', NULL, 'Nicastrin', NULL, NULL, NULL, 9),
(254230, NULL, 'PF07642', NULL, NULL, 'Putative beta-barrel porin-2, OmpL-like. bbp2', NULL, 'BBP2', NULL, NULL, 12514, 9),
(254231, NULL, 'PF18682', NULL, NULL, 'Pilin A4', NULL, 'PilA4', NULL, NULL, 28368, 9),
(254232, NULL, 'PF02432', NULL, NULL, 'Fimbrial, major and minor subunit', NULL, 'Fimbrial_K88', NULL, NULL, 6334, 9),
(254233, NULL, 'PF18717', NULL, NULL, 'CxC4 like cysteine cluster associated with KDZ transposases', NULL, 'CxC4', NULL, NULL, 28434, 9),
(254234, NULL, 'PF11229', NULL, NULL, 'Focadhesin', NULL, 'Focadhesin', NULL, NULL, 18188, 9),
(254235, NULL, 'PF06751', NULL, NULL, 'Ethanolamine ammonia lyase large subunit (EutB)', NULL, 'EutB', NULL, NULL, 9112, 9),
(254236, NULL, 'PF17597', NULL, NULL, 'Family of unknown function (DUF5493)', NULL, 'DUF5493', NULL, NULL, 19310, 9),
(254237, NULL, 'PF17609', NULL, NULL, 'Family of unknown function', NULL, 'HCMV_UL124', NULL, NULL, 18986, 9),
(254238, NULL, 'PF12165', NULL, NULL, 'Alfin', NULL, 'Alfin', NULL, NULL, 20282, 9),
(254239, NULL, 'PF13854', NULL, NULL, 'Kelch motif', NULL, 'Kelch_5', NULL, NULL, NULL, 9),
(254240, NULL, 'PF18137', NULL, NULL, 'Origin recognition complex winged helix C-terminal', NULL, 'ORC_WH_C', NULL, NULL, 32655, 9),
(254241, NULL, 'PF16947', NULL, NULL, 'N-terminal region of 4Fe-4S ferredoxin iron-sulfur binding', NULL, 'Ferredoxin_N', NULL, NULL, 25657, 9),
(254242, NULL, 'PF16197', NULL, NULL, 'Ketoacyl-synthetase C-terminal extension', NULL, 'KAsynt_C_assoc', NULL, NULL, 21778, 9),
(254243, NULL, 'PF10048', NULL, NULL, 'Predicted integral membrane protein (DUF2282)', NULL, 'DUF2282', NULL, NULL, 18431, 9),
(254244, NULL, 'PF06080', NULL, NULL, 'Protein of unknown function (DUF938)', NULL, 'DUF938', NULL, NULL, 8664, 9),
(254245, NULL, 'PF17169', NULL, NULL, 'MIT domain of nuclear receptor-binding factor 2', NULL, 'NRBF2_MIT', NULL, NULL, 27126, 9),
(254246, NULL, 'PF02371', NULL, NULL, 'Transposase IS116/IS110/IS902 family', NULL, 'Transposase_20', NULL, NULL, 4283, 9),
(254247, NULL, 'PF03464', NULL, NULL, 'eRF1 domain 2', NULL, 'eRF1_2', NULL, NULL, 7159, 9),
(254248, NULL, 'PF12485', NULL, NULL, 'Lymphocyte signaling adaptor protein', NULL, 'SLY', NULL, NULL, 15281, 9),
(254249, NULL, 'PF19183', NULL, NULL, 'Family of unknown function (DUF5865)', NULL, 'DUF5865', NULL, NULL, 35404, 9),
(254250, NULL, 'PF18422', NULL, NULL, 'Tumor necrosis factor receptor member 16 trans-membrane domain', NULL, 'TNFR_16_TM', NULL, NULL, 30397, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(254251, NULL, 'PF01036', NULL, NULL, 'Bacteriorhodopsin-like protein', NULL, 'Bac_rhodopsin', NULL, NULL, 6977, 9),
(254252, NULL, 'PF16178', NULL, NULL, 'Dimerisation domain of Ca+-activated chloride-channel, anoctamin', NULL, 'Anoct_dimer', NULL, NULL, 21662, 9),
(254253, NULL, 'PF01476', NULL, NULL, 'LysM domain', NULL, 'LysM', NULL, NULL, 8452, 9),
(254254, NULL, 'PF08807', NULL, NULL, 'Bacterial domain of unknown function (DUF1798)', NULL, 'DUF1798', NULL, NULL, 13192, 9),
(254255, NULL, 'PF10896', NULL, NULL, 'Protein of unknown function (DUF2714)', NULL, 'DUF2714', NULL, NULL, 17943, 9),
(254256, NULL, 'PF15507', NULL, NULL, 'Domain of unknown function (DUF4649)', NULL, 'DUF4649', NULL, NULL, 25930, 9),
(254257, NULL, 'PF04678', NULL, NULL, 'Mitochondrial calcium uniporter', NULL, 'MCU', NULL, NULL, 3406, 9),
(254258, NULL, 'PF09415', NULL, NULL, 'CENP-S associating Centromere protein X', NULL, 'CENP-X', NULL, NULL, 15276, 9),
(254259, NULL, 'PF01691', NULL, NULL, 'Adenovirus E1B 19K protein / small t-antigen', NULL, 'Adeno_E1B_19K', NULL, NULL, 6817, 9),
(254260, NULL, 'PF18159', NULL, NULL, 'SMODS-associating 4TM effector domain', NULL, 'S_4TM', NULL, NULL, NULL, 9),
(254261, NULL, 'PF04189', NULL, NULL, 'Gcd10p family', NULL, 'Gcd10p', NULL, NULL, 18309, 9),
(254262, NULL, 'PF06411', NULL, NULL, 'HdeA/HdeB family', NULL, 'HdeA', NULL, NULL, 10252, 9),
(254263, NULL, 'PF17310', NULL, NULL, 'Family of unknown function (DUF5357)', NULL, 'DUF5357', NULL, NULL, 19929, 9),
(254264, NULL, 'PF00771', NULL, NULL, 'FHIPEP family', NULL, 'FHIPEP', NULL, NULL, 3422, 9),
(254265, NULL, 'PF05439', NULL, NULL, 'Jumping translocation breakpoint protein (JTB)', NULL, 'JTB', NULL, NULL, 12940, 9),
(254266, NULL, 'PF12541', NULL, NULL, 'Protein of unknown function (DUF3737)', NULL, 'DUF3737', NULL, NULL, 21379, 9),
(254267, NULL, 'PF13931', NULL, NULL, 'Kinesin-associated microtubule-binding', NULL, 'Microtub_bind', NULL, NULL, 23142, 9),
(254268, NULL, 'PF11298', NULL, NULL, 'Protein of unknown function (DUF3099)', NULL, 'DUF3099', NULL, NULL, 18238, 9),
(254269, NULL, 'PF03120', NULL, NULL, 'NAD-dependent DNA ligase OB-fold domain', NULL, 'DNA_ligase_OB', NULL, NULL, 2658, 9),
(254270, NULL, 'PF03357', NULL, NULL, 'Snf7', NULL, 'Snf7', NULL, NULL, 1313, 9),
(254271, NULL, 'PF14299', NULL, NULL, 'Phloem protein 2', NULL, 'PP2', NULL, NULL, 21938, 9),
(254272, NULL, 'PF10654', NULL, NULL, 'Protein of unknown function (DUF2481)', NULL, 'DUF2481', NULL, NULL, 14656, 9),
(254273, NULL, 'PF20082', NULL, NULL, 'Family of unknown function (DUF6476)', NULL, 'DUF6476', NULL, NULL, 37251, 9),
(254274, NULL, 'PF04949', NULL, NULL, 'Transcriptional activator', NULL, 'Transcrip_act', NULL, NULL, 6899, 9),
(254275, NULL, 'PF11743', NULL, NULL, 'Protein of unknown function (DUF3301)', NULL, 'DUF3301', NULL, NULL, 19383, 9),
(254276, NULL, 'PF10886', NULL, NULL, 'Protein of unknown function (DUF2685)', NULL, 'DUF2685', NULL, NULL, 22006, 9),
(254277, NULL, 'PF01403', NULL, NULL, 'Sema domain', NULL, 'Sema', NULL, NULL, 5095, 9),
(254278, NULL, 'PF02551', NULL, NULL, 'Acyl-CoA thioesterase', NULL, 'Acyl_CoA_thio', NULL, NULL, 24915, 9),
(254279, NULL, 'PF15088', NULL, NULL, 'NADH dehydrogenase [ubiquinone] 1 subunit C1, mitochondrial', NULL, 'NADH_dh_m_C1', NULL, NULL, 25168, 9),
(254280, NULL, 'PF00786', NULL, NULL, 'P21-Rho-binding domain', NULL, 'PBD', NULL, NULL, 2548, 9),
(254281, NULL, 'PF14382', NULL, NULL, 'Exosome complex exonuclease RRP4 N-terminal region', NULL, 'ECR1_N', NULL, NULL, 26428, 9),
(254282, NULL, 'PF01129', NULL, NULL, 'NAD:arginine ADP-ribosyltransferase', NULL, 'ART', NULL, NULL, 6541, 9),
(254283, NULL, 'PF19004', NULL, NULL, 'Family of unknown function (DUF5733)', NULL, 'DUF5733', NULL, NULL, 35434, 9),
(254284, NULL, 'PF06752', NULL, NULL, 'Enhancer of Polycomb C-terminus', NULL, 'E_Pc_C', NULL, NULL, 1716, 9),
(254285, NULL, 'PF00545', NULL, NULL, 'ribonuclease', NULL, 'Ribonuclease', NULL, NULL, 2973, 9),
(254286, NULL, 'PF19830', NULL, NULL, 'Family of unknown function (DUF6311)', NULL, 'DUF6311', NULL, NULL, 37703, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(254287, NULL, 'PF02803', NULL, NULL, 'Thiolase, C-terminal domain', NULL, 'Thiolase_C', NULL, NULL, 19157, 9),
(254288, NULL, 'PF16961', NULL, NULL, 'Putative OmpA-OmpF-like porin family', NULL, 'OmpA_like', NULL, NULL, 22061, 9),
(254289, NULL, 'PF08432', NULL, NULL, 'AAA-ATPase Vps4-associated protein 1', NULL, 'Vfa1', NULL, NULL, 12797, 9),
(254290, NULL, 'PF19992', NULL, NULL, 'Family of unknown function (DUF6427)', NULL, 'DUF6427', NULL, NULL, 34186, 9),
(254291, NULL, 'PF08127', NULL, NULL, 'Peptidase family C1 propeptide', NULL, 'Propeptide_C1', NULL, NULL, 9488, 9),
(254292, NULL, 'PF19391', NULL, NULL, 'Family of unknown function (DUF5966)', NULL, 'DUF5966', NULL, NULL, 36817, 9),
(254293, NULL, 'PF06864', NULL, NULL, 'Pilin accessory protein (PilO)', NULL, 'PAP_PilO', NULL, NULL, 11944, 9),
(254294, NULL, 'PF04568', NULL, NULL, 'Mitochondrial ATPase inhibitor, IATP', NULL, 'IATP', NULL, NULL, 189, 9),
(254295, NULL, 'PF07503', NULL, NULL, 'HypF finger', NULL, 'zf-HYPF', NULL, NULL, 11223, 9),
(254296, NULL, 'PF04930', NULL, NULL, 'FUN14 family', NULL, 'FUN14', NULL, NULL, 6874, 9),
(254297, NULL, 'PF10205', NULL, NULL, 'Predicted coiled-coil domain-containing protein', NULL, 'KLRAQ', NULL, NULL, 15880, 9),
(254298, NULL, 'PF09807', NULL, NULL, 'Elongation complex protein 6', NULL, 'ELP6', NULL, NULL, 16017, 9),
(254299, NULL, 'PF17775', NULL, NULL, 'UPF0225 domain', NULL, 'UPF0225', NULL, NULL, NULL, 9),
(254300, NULL, 'PF06152', NULL, NULL, 'Phage minor capsid protein 2', NULL, 'Phage_min_cap2', NULL, NULL, 14255, 9),
(254301, NULL, 'PF08601', NULL, NULL, 'Transcription factor PAP1', NULL, 'PAP1', NULL, NULL, 17682, 9),
(254302, NULL, 'PF17812', NULL, NULL, 'RET Cadherin like domain 3', NULL, 'RET_CLD3', NULL, NULL, 28214, 9),
(254303, NULL, 'PF18804', NULL, NULL, 'CxC3 like cysteine cluster associated with KDZ transposases', NULL, 'CxC3', NULL, NULL, 28621, 9),
(254304, NULL, 'PF11813', NULL, NULL, 'Protein of unknown function (DUF3334)', NULL, 'DUF3334', NULL, NULL, 24814, 9),
(254305, NULL, 'PF01485', NULL, NULL, 'IBR domain, a half RING-finger domain', NULL, 'IBR', NULL, NULL, 5613, 9),
(254306, NULL, 'PF04582', NULL, NULL, 'Reovirus sigma C capsid protein C-terminal domain', NULL, 'Reo_sigmaC', NULL, NULL, 410, 9),
(254307, NULL, 'PF12622', NULL, NULL, 'mRNA biogenesis factor', NULL, 'NpwBP', NULL, NULL, NULL, 9),
(254308, NULL, 'PF07944', NULL, NULL, 'Beta-L-arabinofuranosidase, GH127', NULL, 'Glyco_hydro_127', NULL, NULL, 12494, 9),
(254309, NULL, 'PF06374', NULL, NULL, 'NADH-ubiquinone oxidoreductase subunit b14.5b (NDUFC2)', NULL, 'NDUF_C2', NULL, NULL, 8037, 9),
(254310, NULL, 'PF12868', NULL, NULL, 'Domain of unknwon function (DUF3824)', NULL, 'DUF3824', NULL, NULL, 26979, 9),
(254311, NULL, 'PF18696', NULL, NULL, 'Synaptotagmin-like, mitochondrial and lipid-binding domain', NULL, 'SMP_C2CD2L', NULL, NULL, 33290, 9),
(254312, NULL, 'PF20062', NULL, NULL, 'Family of unknown function (DUF6461)', NULL, 'DUF6461', NULL, NULL, 36396, 9),
(254313, NULL, 'PF08882', NULL, NULL, 'Acetone carboxylase gamma subunit', NULL, 'Acetone_carb_G', NULL, NULL, 21381, 9),
(254314, NULL, 'PF15035', NULL, NULL, 'Ciliary rootlet component, centrosome cohesion', NULL, 'Rootletin', NULL, NULL, NULL, 9),
(254315, NULL, 'PF04481', NULL, NULL, 'Protein of unknown function (DUF561)', NULL, 'DUF561', NULL, NULL, 1727, 9),
(254316, NULL, 'PF17995', NULL, NULL, 'Endo-alpha-N-acetylgalactosaminidase N-terminal', NULL, 'GH101_N', NULL, NULL, 27783, 9),
(254317, NULL, 'PF06493', NULL, NULL, 'Protein of unknown function (DUF1096)', NULL, 'DUF1096', NULL, NULL, 9012, 9),
(254318, NULL, 'PF04447', NULL, NULL, 'dATP/dGTP pyrophosphohydrolase', NULL, 'dATP-dGTP_PPHyd', NULL, NULL, 10573, 9),
(254319, NULL, 'PF03715', NULL, NULL, 'Noc2p family', NULL, 'Noc2', NULL, NULL, 6039, 9),
(254320, NULL, 'PF19685', NULL, NULL, 'Family of unknown function (DUF6187)', NULL, 'DUF6187', NULL, NULL, 37382, 9),
(254321, NULL, 'PF19818', NULL, NULL, 'Family of unknown function (DUF6301)', NULL, 'DUF6301', NULL, NULL, 37257, 9);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(254322, NULL, 'PF00163', NULL, NULL, 'Ribosomal protein S4/S9 N-terminal domain', NULL, 'Ribosomal_S4', NULL, NULL, 4109, 9),
(254323, NULL, 'PF04655', NULL, NULL, 'Aminoglycoside/hydroxyurea antibiotic resistance kinase', NULL, 'APH_6_hur', NULL, NULL, 2859, 9),
(254324, NULL, 'PF11891', NULL, NULL, 'Protein RETICULATA-related', NULL, 'RETICULATA-like', NULL, NULL, 19676, 9),
(254325, NULL, 'PF20012', NULL, NULL, 'GTPase-associated protein 1, N-terminal domain type 1', NULL, 'GAP1-N1', NULL, NULL, NULL, 9),
(254326, NULL, 'PF16024', NULL, NULL, 'Domain of unknown function (DUF4785)', NULL, 'DUF4785', NULL, NULL, 23727, 9),
(254327, NULL, 'PF02444', NULL, NULL, 'Hepatitis E virus ORF-2 (Putative capsid protein)', NULL, 'HEV_ORF1', NULL, NULL, 4267, 9),
(254328, NULL, 'PF11223', NULL, NULL, 'SPP41, DUF3020', NULL, 'DUF3020', NULL, NULL, 18315, 9),
(254329, NULL, 'PF14153', NULL, NULL, 'Spore coat protein CotO', NULL, 'Spore_coat_CotO', NULL, NULL, 26237, 9),
(254330, NULL, 'PF08593', NULL, NULL, 'Domain of unknown function', NULL, 'DUF1773', NULL, NULL, 17929, 9),
(254331, NULL, 'PF11546', NULL, NULL, 'Staphylococcal complement inhibitor SCIN', NULL, 'CompInhib_SCIN', NULL, NULL, 18619, 9),
(254332, NULL, 'PF12612', NULL, NULL, 'Tubulin folding cofactor D C terminal', NULL, 'TFCD_C', NULL, NULL, 16497, 9),
(254333, NULL, 'PF06460', NULL, NULL, 'Coronavirus 2''-O-methyltransferase', NULL, 'CoV_Methyltr_2', NULL, NULL, 9021, 9),
(254334, NULL, 'PF06630', NULL, NULL, 'Enterobacterial exodeoxyribonuclease VIII', NULL, 'Exonuc_VIII', NULL, NULL, 8379, 9),
(254335, NULL, 'PF09205', NULL, NULL, 'Domain of unknown function (DUF1955)', NULL, 'DUF1955', NULL, NULL, 12042, 9),
(254336, NULL, 'PF12983', NULL, NULL, 'Protein of unknown function (DUF3867)', NULL, 'DUF3867', NULL, NULL, 20642, 9),
(254337, NULL, 'PF10992', NULL, NULL, 'Epiplasmin protein', NULL, 'Epiplasmin', NULL, NULL, 17841, 9),
(254338, NULL, 'PF08743', NULL, NULL, 'Nse4 C-terminal', NULL, 'Nse4_C', NULL, NULL, 13223, 9),
(254339, NULL, 'PF02480', NULL, NULL, 'Alphaherpesvirus glycoprotein E', NULL, 'Herpes_gE', NULL, NULL, 5003, 9),
(254340, NULL, 'PF04720', NULL, NULL, 'PDDEXK-like family of unknown function', NULL, 'PDDEXK_6', NULL, NULL, 6928, 9),
(254341, NULL, 'PF08759', NULL, NULL, 'Glycosyltransferase GT-D fold', NULL, 'GT-D', NULL, NULL, 13318, 9),
(254342, NULL, 'PF13423', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, 'UCH_1', NULL, NULL, 21914, 9),
(254343, NULL, 'PF16957', NULL, NULL, 'Malonate decarboxylase, alpha subunit, transporter', NULL, 'Mal_decarbox_Al', NULL, NULL, 4876, 9),
(254344, NULL, 'PF18766', NULL, NULL, 'SWI2/SNF2 ATPase', NULL, 'SWI2_SNF2', NULL, NULL, 28555, 9),
(254345, NULL, 'PF05572', NULL, NULL, 'Pregnancy-associated plasma protein-A', NULL, 'Peptidase_M43', NULL, NULL, 12111, 9),
(254346, NULL, 'PF13377', NULL, NULL, 'Periplasmic binding protein-like domain', NULL, 'Peripla_BP_3', NULL, NULL, 37763, 9),
(254347, NULL, 'PF02680', NULL, NULL, 'Uncharacterized ArCR, COG1888', NULL, 'DUF211', NULL, NULL, 3210, 9),
(254348, NULL, 'PF09175', NULL, NULL, 'Vitellinogen, beta-sheet shell', NULL, 'Vit_b-sht_shell', NULL, NULL, 12331, 9),
(254349, NULL, 'PF09260', NULL, NULL, 'Alpha-amylase, domain C', NULL, 'A_amylase_dom_C', NULL, NULL, 13464, 9),
(254350, NULL, 'PF17043', NULL, NULL, 'Mating type protein 1-1-2 of unknown function', NULL, 'MAT1-1-2', NULL, NULL, 26953, 9),
(254351, NULL, 'PF15997', NULL, NULL, 'Domain of unknown function (DUF4772)', NULL, 'DUF4772', NULL, NULL, 25688, 9),
(254352, NULL, 'PF19650', NULL, NULL, 'Family of unknown function (DUF6153)', NULL, 'DUF6153', NULL, NULL, 37232, 9),
(254353, NULL, 'PF02667', NULL, NULL, 'Short chain fatty acid transporter', NULL, 'SCFA_trans', NULL, NULL, 10465, 9),
(254354, NULL, 'PF00583', NULL, NULL, 'Acetyltransferase (GNAT) family', NULL, 'Acetyltransf_1', NULL, NULL, 1841, 9),
(254355, NULL, 'PF00381', NULL, NULL, 'PTS HPr component phosphorylation site', NULL, 'PTS-HPr', NULL, NULL, 3439, 9),
(254356, NULL, 'PF10145', NULL, NULL, 'Phage-related minor tail protein', NULL, 'PhageMin_Tail', NULL, NULL, 2023, 9);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(254357, NULL, 'PF19942', NULL, NULL, 'Family of unknown function (DUF6404)', NULL, 'DUF6404', NULL, NULL, 36279, 9),
(254358, NULL, 'PF05080', NULL, NULL, 'Protein of unknown function (DUF681)', NULL, 'DUF681', NULL, NULL, 1142, 9),
(254359, NULL, 'PF11848', NULL, NULL, 'Domain of unknown function (DUF3368)', NULL, 'DUF3368', NULL, NULL, 19453, 9),
(254360, NULL, 'PF17571', NULL, NULL, 'Family of unknown function (DUF5477)', NULL, 'DUF5477', NULL, NULL, 16929, 9),
(254361, NULL, 'PF03286', NULL, NULL, 'Pox virus Ag35 surface protein', NULL, 'Pox_Ag35', NULL, NULL, 2505, 9),
(254362, NULL, 'PF06966', NULL, NULL, 'Protein of unknown function (DUF1295)', NULL, 'DUF1295', NULL, NULL, 9977, 9),
(254363, NULL, 'PF01244', NULL, NULL, 'Membrane dipeptidase (Peptidase family M19)', NULL, 'Peptidase_M19', NULL, NULL, 8620, 9),
(254364, NULL, 'PF09202', NULL, NULL, 'Rio2, N-terminal', NULL, 'Rio2_N', NULL, NULL, 12224, 9),
(254365, NULL, 'PF08142', NULL, NULL, 'AARP2CN (NUC121) domain', NULL, 'AARP2CN', NULL, NULL, 18857, 9),
(254366, NULL, 'PF01000', NULL, NULL, 'RNA polymerase Rpb3/RpoA insert domain', NULL, 'RNA_pol_A_bac', NULL, NULL, 9594, 9),
(254367, NULL, 'PF11263', NULL, NULL, 'Borrelia burgdorferi attachment protein P66', NULL, 'Attachment_P66', NULL, NULL, 14745, 9),
(254368, NULL, 'PF13503', NULL, NULL, 'Domain of unknown function (DUF4123)', NULL, 'DUF4123', NULL, NULL, 22395, 9),
(254369, NULL, 'PF04434', NULL, NULL, 'SWIM zinc finger', NULL, 'SWIM', NULL, NULL, 10705, 9),
(254370, NULL, 'PF16625', NULL, NULL, 'Unstructured linking region I-set and fnIII on Brother of CDO', NULL, 'ISET-FN3_linker', NULL, NULL, NULL, 9),
(254371, NULL, 'PF01467', NULL, NULL, 'Cytidylyltransferase-like', NULL, 'CTP_transf_like', NULL, NULL, 4469, 9),
(254372, NULL, 'PF00191', NULL, NULL, 'Annexin', NULL, 'Annexin', NULL, NULL, 9057, 9),
(254373, NULL, 'PF16241', NULL, NULL, 'Domain of unknown function (DUF4900)', NULL, 'DUF4900', NULL, NULL, 24187, 9),
(254374, NULL, 'PF02487', NULL, NULL, 'CLN3 protein', NULL, 'CLN3', NULL, NULL, 6043, 9),
(254375, NULL, 'PF11431', NULL, NULL, 'Membrane transport protein MerF', NULL, 'Transport_MerF', NULL, NULL, 15258, 9),
(254376, NULL, 'PF16787', NULL, NULL, 'Centromere DNA-binding protein complex CBF3 subunit, domain 2', NULL, 'NDC10_II', NULL, NULL, 26531, 9),
(254377, NULL, 'PF17909', NULL, NULL, 'Htr2 transmembrane domain', NULL, 'Htr2', NULL, NULL, 27936, 9),
(254378, NULL, 'PF19122', NULL, NULL, 'Family of unknown function (DUF5806)', NULL, 'DUF5806', NULL, NULL, 35983, 9),
(254379, NULL, 'PF18411', NULL, NULL, 'Annexin-like domain', NULL, 'Annexin_like', NULL, NULL, 28308, 9),
(254380, NULL, 'PF18526', NULL, NULL, 'Thymine dioxygenase JBP1 DNA-binding domain', NULL, 'DB_JBP1', NULL, NULL, 29289, 9),
(254381, NULL, 'PF18745', NULL, NULL, 'Secreted Novel AID/APOBEC-like Deaminase 2', NULL, 'SNAD2', NULL, NULL, NULL, 9),
(254382, NULL, 'PF06532', NULL, NULL, 'Negative regulator of sigma F', NULL, 'NrsF', NULL, NULL, 9207, 9),
(254383, NULL, 'PF08534', NULL, NULL, 'Redoxin', NULL, 'Redoxin', NULL, NULL, 7649, 9),
(254384, NULL, 'PF04099', NULL, NULL, 'Sybindin-like family', NULL, 'Sybindin', NULL, NULL, 6532, 9),
(254385, NULL, 'PF05134', NULL, NULL, 'Type II secretion system (T2SS), protein L', NULL, 'T2SSL', NULL, NULL, 8569, 9),
(254386, NULL, 'PF19503', NULL, NULL, 'Family of unknown function (DUF6037)', NULL, 'DUF6037', NULL, NULL, 36604, 9),
(254387, NULL, 'PF20611', NULL, NULL, 'Family of unknown function (DUF6801)', NULL, 'DUF6801', NULL, NULL, 37589, 9),
(254388, NULL, 'PF05570', NULL, NULL, 'Circovirus protein of unknown function (DUF765)', NULL, 'DUF765', NULL, NULL, 12416, 9),
(254389, NULL, 'PF13288', NULL, NULL, 'DXP reductoisomerase C-terminal domain', NULL, 'DXPR_C', NULL, NULL, 26711, 9),
(254390, NULL, 'PF13514', NULL, NULL, 'AAA domain', NULL, 'AAA_27', NULL, NULL, 32770, 9),
(254391, NULL, 'PF15389', NULL, NULL, 'Domain of unknown function (DUF4612)', NULL, 'DUF4612', NULL, NULL, 24374, 9),
(254392, NULL, 'PF12938', NULL, NULL, 'M domain of GW182', NULL, 'M_domain', NULL, NULL, 22635, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(254393, NULL, 'PF13494', NULL, NULL, 'Domain of unknown function, B. Theta Gene description (DUF4119)', NULL, 'DUF4119', NULL, NULL, 21190, 9),
(254394, NULL, 'PF15386', NULL, NULL, 'Drosophila Tantalus-like', NULL, 'Tantalus', NULL, NULL, 21553, 9),
(254395, NULL, 'PF09866', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2093)', NULL, 'DUF2093', NULL, NULL, 16969, 9),
(254396, NULL, 'PF18145', NULL, NULL, 'SMODS-associated and fused to various effectors sensor domain', NULL, 'SAVED', NULL, NULL, 32269, 9),
(254397, NULL, 'PF17796', NULL, NULL, 'Major Vault Protein repeat domain', NULL, 'Vault_4', NULL, NULL, 29413, 9),
(254398, NULL, 'PF20389', NULL, NULL, 'Family of unknown function (DUF6684)', NULL, 'DUF6684', NULL, NULL, 37593, 9),
(254399, NULL, 'PF02831', NULL, NULL, 'gpW', NULL, 'gpW', NULL, NULL, 2991, 9),
(254400, NULL, 'PF08493', NULL, NULL, 'Aflatoxin regulatory protein', NULL, 'AflR', NULL, NULL, 13652, 9),
(254401, NULL, 'PF11767', NULL, NULL, 'Histone lysine methyltransferase SET associated', NULL, 'SET_assoc', NULL, NULL, 13884, 9),
(254402, NULL, 'PF08107', NULL, NULL, 'Pleurocidin family', NULL, 'Antimicrobial12', NULL, NULL, 12990, 9),
(254403, NULL, 'PF13295', NULL, NULL, 'Domain of unknown function (DUF4077)', NULL, 'DUF4077', NULL, NULL, 25608, 9),
(254404, NULL, 'PF18851', NULL, NULL, 'Bacterial archaeo-eukaryotic release factor family 8', NULL, 'baeRF_family8', NULL, NULL, 32309, 9),
(254405, NULL, 'PF17164', NULL, NULL, 'Domain of unknown function (DUF5122) beta-propeller', NULL, 'DUF5122', NULL, NULL, 9053, 9),
(254406, NULL, 'PF13107', NULL, NULL, 'Protein of unknown function (DUF3964)', NULL, 'DUF3964', NULL, NULL, 22803, 9),
(254407, NULL, 'PF01774', NULL, NULL, 'UreD urease accessory protein', NULL, 'UreD', NULL, NULL, 2770, 9),
(254408, NULL, 'PF02994', NULL, NULL, 'L1 transposable element RBD-like domain', NULL, 'Transposase_22', NULL, NULL, 35860, 9),
(254409, NULL, 'PF08746', NULL, NULL, 'RING-like domain', NULL, 'zf-RING-like', NULL, NULL, 13488, 9),
(254410, NULL, 'PF07133', NULL, NULL, 'Merozoite surface protein (SPAM)', NULL, 'Merozoite_SPAM', NULL, NULL, 10971, 9),
(254411, NULL, 'PF18471', NULL, NULL, 'Ribosomal L27 protein C-terminal domain', NULL, 'Ribosomal_L27_C', NULL, NULL, 29458, 9),
(254412, NULL, 'PF11429', NULL, NULL, 'Colicin D', NULL, 'Colicin_D', NULL, NULL, 22910, 9),
(254413, NULL, 'PF17585', NULL, NULL, 'Accessory recombination function protein', NULL, 'Phage_Arf', NULL, NULL, 20780, 9),
(254414, NULL, 'PF07183', NULL, NULL, 'Protein of unknown function (DUF1403)', NULL, 'DUF1403', NULL, NULL, 13409, 9),
(254415, NULL, 'PF16800', NULL, NULL, 'IseA DL-endopeptidase inhibitor', NULL, 'Endopep_inhib', NULL, NULL, 22410, 9),
(254416, NULL, 'PF10589', NULL, NULL, 'NADH-ubiquinone oxidoreductase-F iron-sulfur binding region', NULL, 'NADH_4Fe-4S', NULL, NULL, 20468, 9),
(254417, NULL, 'PF12807', NULL, NULL, 'Translation initiation factor eIF3 subunit 135', NULL, 'eIF3_p135', NULL, NULL, 27667, 9),
(254418, NULL, 'PF19742', NULL, NULL, 'Family of unknown function (DUF6231)', NULL, 'DUF6231', NULL, NULL, 37398, 9),
(254419, NULL, 'PF18960', NULL, NULL, 'Family of unknown function (DUF5702)', NULL, 'DUF5702', NULL, NULL, 34649, 9),
(254420, NULL, 'PF11486', NULL, NULL, 'Protein of unknown function (DUF3212)', NULL, 'DUF3212', NULL, NULL, 18641, 9),
(254421, NULL, 'PF00587', NULL, NULL, 'tRNA synthetase class II core domain (G, H, P, S and T)', NULL, 'tRNA-synt_2b', NULL, NULL, 6257, 9),
(254422, NULL, 'PF11190', NULL, NULL, 'Protein of unknown function (DUF2976)', NULL, 'DUF2976', NULL, NULL, 18244, 9),
(254423, NULL, 'PF03557', NULL, NULL, 'Bunyavirus glycoprotein G1', NULL, 'Bunya_G1', NULL, NULL, 4947, 9),
(254424, NULL, 'PF14397', NULL, NULL, 'Sugar-transfer associated ATP-grasp', NULL, 'ATPgrasp_ST', NULL, NULL, 32714, 9),
(254425, NULL, 'PF19358', NULL, NULL, 'Family of unknown function (DUF5935)', NULL, 'DUF5935', NULL, NULL, 36871, 9),
(254426, NULL, 'PF08423', NULL, NULL, 'Rad51', NULL, 'Rad51', NULL, NULL, 11179, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(254427, NULL, 'PF00310', NULL, NULL, 'Glutamine amidotransferases class-II', NULL, 'GATase_2', NULL, NULL, 18854, 9),
(254428, NULL, 'PF02121', NULL, NULL, 'Phosphatidylinositol transfer protein', NULL, 'IP_trans', NULL, NULL, 5023, 9),
(254429, NULL, 'PF14874', NULL, NULL, 'Flagellar-associated PapD-like', NULL, 'PapD-like', NULL, NULL, NULL, 9),
(254430, NULL, 'PF16255', NULL, NULL, 'GDSL-like Lipase/Acylhydrolase', NULL, 'Lipase_GDSL_lke', NULL, NULL, 23878, 9),
(254431, NULL, 'PF06687', NULL, NULL, 'SUR7/PalI family', NULL, 'SUR7', NULL, NULL, 898, 9),
(254432, NULL, 'PF19179', NULL, NULL, 'E3 ubiquitin-protein ligase TTC3/DZIP3 domain', NULL, 'TTC3_DZIP3_dom', NULL, NULL, 34991, 9),
(254433, NULL, 'PF07291', NULL, NULL, 'Methylamine utilisation protein MauE', NULL, 'MauE', NULL, NULL, 14152, 9),
(254434, NULL, 'PF07481', NULL, NULL, 'Domain of Unknown Function (DUF1521)', NULL, 'DUF1521', NULL, NULL, 11442, 9),
(254435, NULL, 'PF18242', NULL, NULL, 'Legionella ubiquitin-specific protease A domain', NULL, 'LupA', NULL, NULL, 29433, 9),
(254436, NULL, 'PF02915', NULL, NULL, 'Rubrerythrin', NULL, 'Rubrerythrin', NULL, NULL, 2686, 9),
(254437, NULL, 'PF07337', NULL, NULL, 'DC-EC Repeat', NULL, 'CagY_M', NULL, NULL, 11752, 9),
(254438, NULL, 'PF17624', NULL, NULL, 'Family of unknown function', NULL, 'US30', NULL, NULL, 17420, 9),
(254439, NULL, 'PF19255', NULL, NULL, 'Family of unknown function (DUF5902)', NULL, 'DUF5902', NULL, NULL, 37072, 9),
(254440, NULL, 'PF07833', NULL, NULL, 'Copper amine oxidase N-terminal domain', NULL, 'Cu_amine_oxidN1', NULL, NULL, 12221, 9),
(254441, NULL, 'PF13113', NULL, NULL, 'Protein of unknown function (DUF3970)', NULL, 'DUF3970', NULL, NULL, 22760, 9),
(254442, NULL, 'PF19898', NULL, NULL, 'Domain of unknown function (DUF6371)', NULL, 'DUF6371', NULL, NULL, 36692, 9),
(254443, NULL, 'PF04459', NULL, NULL, 'Protein of unknown function (DUF512)', NULL, 'DUF512', NULL, NULL, 3993, 9),
(254444, NULL, 'PF09247', NULL, NULL, 'TATA box-binding protein binding', NULL, 'TBP-binding', NULL, NULL, 6322, 9),
(254445, NULL, 'PF15874', NULL, NULL, 'Putative Interleukin 2 receptor, gamma chain', NULL, 'Il2rg', NULL, NULL, 33141, 9),
(254446, NULL, 'PF13563', NULL, NULL, '2''-5'' RNA ligase superfamily', NULL, '2_5_RNA_ligase2', NULL, NULL, NULL, 9),
(254447, NULL, 'PF09533', NULL, NULL, 'Predicted lipoprotein of unknown function (DUF2380)', NULL, 'DUF2380', NULL, NULL, 11978, 9),
(254448, NULL, 'PF20267', NULL, NULL, 'GREB1 C-terminal region', NULL, 'GREB1_C', NULL, NULL, 34365, 9),
(254449, NULL, 'PF02096', NULL, NULL, '60Kd inner membrane protein', NULL, '60KD_IMP', NULL, NULL, 3041, 9),
(254450, NULL, 'PF02957', NULL, NULL, 'TT viral ORF2', NULL, 'TT_ORF2', NULL, NULL, 1967, 9),
(254451, NULL, 'PF15248', NULL, NULL, 'Domain of unknown function (DUF4587)', NULL, 'DUF4587', NULL, NULL, 23288, 9),
(254452, NULL, 'PF18658', NULL, NULL, 'Spin-doc zinc-finger', NULL, 'zf-C2H2_12', NULL, NULL, 28006, 9),
(254453, NULL, 'PF00530', NULL, NULL, 'Scavenger receptor cysteine-rich domain', NULL, 'SRCR', NULL, NULL, 1378, 9),
(254454, NULL, 'PF13387', NULL, NULL, 'Domain of unknown function (DUF4105)', NULL, 'DUF4105', NULL, NULL, 22783, 9),
(254455, NULL, 'PF14269', NULL, NULL, 'Arylsulfotransferase (ASST)', NULL, 'Arylsulfotran_2', NULL, NULL, 33200, 9),
(254456, NULL, 'PF18737', NULL, NULL, 'MAE_28990/MAE_18760-like HEPN', NULL, 'HEPN_MAE_28990', NULL, NULL, 28298, 9),
(254457, NULL, 'PF00790', NULL, NULL, 'VHS domain', NULL, 'VHS', NULL, NULL, 2068, 9),
(254458, NULL, 'PF09720', NULL, NULL, 'Putative addiction module component', NULL, 'Unstab_antitox', NULL, NULL, 9230, 9),
(254459, NULL, 'PF00929', NULL, NULL, 'Exonuclease', NULL, 'RNase_T', NULL, NULL, 5532, 9),
(254460, NULL, 'PF09070', NULL, NULL, 'PFU (PLAA family ubiquitin binding)', NULL, 'PFU', NULL, NULL, 9705, 9),
(254461, NULL, 'PF20054', NULL, NULL, 'Trypanosoma Tc-38 (p38) protein', NULL, 'Tc-38', NULL, NULL, 35632, 9),
(254462, NULL, 'PF11694', NULL, NULL, 'Protein of unknown function (DUF3290)', NULL, 'DUF3290', NULL, NULL, 19085, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(254463, NULL, 'PF06656', NULL, NULL, 'Tenuivirus PVC2 protein', NULL, 'Tenui_PVC2', NULL, NULL, 10451, 9),
(254464, NULL, 'PF16997', NULL, NULL, 'Wap1 domain', NULL, 'Wap1', NULL, NULL, 24145, 9),
(254465, NULL, 'PF01487', NULL, NULL, 'Type I 3-dehydroquinase', NULL, 'DHquinase_I', NULL, NULL, 6658, 9),
(254466, NULL, 'PF08549', NULL, NULL, 'SWI/SNF and RSC complexes subunit Ssr4 N-terminal', NULL, 'SWI-SNF_Ssr4_N', NULL, NULL, 9988, 9),
(254467, NULL, 'PF18230', NULL, NULL, 'Glycosyl hydrolases family 38 C-terminal sub-domain', NULL, 'Glyc_hyd_38C_2', NULL, NULL, 30766, 9),
(254468, NULL, 'PF09334', NULL, NULL, 'tRNA synthetases class I (M)', NULL, 'tRNA-synt_1g', NULL, NULL, 7017, 9),
(254469, NULL, 'PF04494', NULL, NULL, 'WD40 associated region in TFIID subunit, NTD2 domain', NULL, 'TFIID_NTD2', NULL, NULL, 1676, 9),
(254470, NULL, 'PF00711', NULL, NULL, 'Beta defensin', NULL, 'Defensin_beta', NULL, NULL, 4296, 9),
(254471, NULL, 'PF02982', NULL, NULL, 'Scytalone dehydratase', NULL, 'Scytalone_dh', NULL, NULL, 3760, 9),
(254472, NULL, 'PF06202', NULL, NULL, 'Amylo-alpha-1,6-glucosidase', NULL, 'GDE_C', NULL, NULL, 22183, 9),
(254473, NULL, 'PF17710', NULL, NULL, 'Family of unknown function (DUF5555)', NULL, 'DUF5555', NULL, NULL, 32059, 9),
(254474, NULL, 'PF13338', NULL, NULL, 'Transcriptional regulator, AbiEi antitoxin', NULL, 'AbiEi_4', NULL, NULL, 26327, 9),
(254475, NULL, 'PF08353', NULL, NULL, 'MurT ligase C-terminal', NULL, 'MurT_C', NULL, NULL, 12657, 9),
(254476, NULL, 'PF19029', NULL, NULL, 'DUF883 C-terminal glycine zipper region', NULL, 'DUF883_C', NULL, NULL, 35869, 9),
(254477, NULL, 'PF05906', NULL, NULL, 'Herpesvirus-7 repeat of unknown function (DUF865)', NULL, 'DUF865', NULL, NULL, NULL, 9),
(254478, NULL, 'PF05728', NULL, NULL, 'Uncharacterised protein family (UPF0227)', NULL, 'UPF0227', NULL, NULL, 7817, 9),
(254479, NULL, 'PF11119', NULL, NULL, 'Protein of unknown function (DUF2633)', NULL, 'DUF2633', NULL, NULL, 16346, 9),
(254480, NULL, 'PF03451', NULL, NULL, 'HELP motif', NULL, 'HELP', NULL, NULL, 10858, 9),
(254481, NULL, 'PF13256', NULL, NULL, 'Domain of unknown function (DUF4047)', NULL, 'DUF4047', NULL, NULL, 22809, 9),
(254482, NULL, 'PF18262', NULL, NULL, 'Phe-tRNA synthetase beta subunit B1 domain', NULL, 'PhetRS_B1', NULL, NULL, 28806, 9),
(254483, NULL, 'PF15973', NULL, NULL, 'Domain of unknown function (DUF4766)', NULL, 'DUF4766', NULL, NULL, 25972, 9),
(254484, NULL, 'PF16816', NULL, NULL, 'DotD protein', NULL, 'DotD', NULL, NULL, 22039, 9),
(254485, NULL, 'PF01679', NULL, NULL, 'Proteolipid membrane potential modulator', NULL, 'Pmp3', NULL, NULL, 5702, 9),
(254486, NULL, 'PF05107', NULL, NULL, 'CRISPR-associated protein Cas7', NULL, 'Cas_Cas7', NULL, NULL, 6331, 9),
(254487, NULL, 'PF08533', NULL, NULL, 'Beta-galactosidase C-terminal domain', NULL, 'Glyco_hydro_42C', NULL, NULL, 7701, 9),
(254488, NULL, 'PF17334', NULL, NULL, 'Minor curli fiber component A', NULL, 'CsgA', NULL, NULL, 19134, 9),
(254489, NULL, 'PF11055', NULL, NULL, 'Glucose signalling factor 2', NULL, 'Gsf2', NULL, NULL, 17253, 9),
(254490, NULL, 'PF15905', NULL, NULL, 'Hyaluronan mediated motility receptor N-terminal', NULL, 'HMMR_N', NULL, NULL, NULL, 9),
(254491, NULL, 'PF00726', NULL, NULL, 'Interleukin 10', NULL, 'IL10', NULL, NULL, 18925, 9),
(254492, NULL, 'PF17082', NULL, NULL, 'Spindle Pole Component 29', NULL, 'Spc29', NULL, NULL, 24351, 9),
(254493, NULL, 'PF11503', NULL, NULL, 'Protein of unknown function (DUF3215)', NULL, 'DUF3215', NULL, NULL, 18846, 9),
(254494, NULL, 'PF15290', NULL, NULL, 'Golgi-localised syntaxin-1-binding clamp', NULL, 'Syntaphilin', NULL, NULL, 23791, 9),
(254495, NULL, 'PF01037', NULL, NULL, 'Lrp/AsnC ligand binding domain', NULL, 'AsnC_trans_reg', NULL, NULL, 14782, 9),
(254496, NULL, 'PF05657', NULL, NULL, 'Protein of unknown function (DUF806)', NULL, 'DUF806', NULL, NULL, 13109, 9),
(254497, NULL, 'PF13601', NULL, NULL, 'Winged helix DNA-binding domain', NULL, 'HTH_34', NULL, NULL, 21561, 9),
(254498, NULL, 'PF14854', NULL, NULL, 'Leucine rich adaptor protein', NULL, 'LURAP', NULL, NULL, 28647, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(254499, NULL, 'PF17185', NULL, NULL, 'NlpE C-terminal OB domain', NULL, 'NlpE_C', NULL, NULL, 32323, 9),
(254500, NULL, 'PF00158', NULL, NULL, 'Sigma-54 interaction domain', NULL, 'Sigma54_activat', NULL, NULL, 5401, 9),
(254501, NULL, 'PF11076', NULL, NULL, 'Putative inner membrane protein YbhQ', NULL, 'YbhQ', NULL, NULL, 17888, 9),
(254502, NULL, 'PF04489', NULL, NULL, 'Protein of unknown function (DUF570)', NULL, 'DUF570', NULL, NULL, 1605, 9),
(254503, NULL, 'PF12460', NULL, NULL, 'RNAPII transcription regulator C-terminal', NULL, 'MMS19_C', NULL, NULL, 22079, 9),
(254504, NULL, 'PF20457', NULL, NULL, 'Family of unknown function (DUF6710)', NULL, 'DUF6710', NULL, NULL, 37516, 9),
(254505, NULL, 'PF15682', NULL, NULL, 'Musculoskeletal, temporally activated-embryonic nuclear protein 1', NULL, 'Mustang', NULL, NULL, 22541, 9),
(254506, NULL, 'PF13250', NULL, NULL, 'Domain of unknown function (DUF4041)', NULL, 'DUF4041', NULL, NULL, 23345, 9),
(254507, NULL, 'PF20056', NULL, NULL, 'Family of unknown function (DUF6455)', NULL, 'DUF6455', NULL, NULL, 36357, 9),
(254508, NULL, 'PF16906', NULL, NULL, 'Ribosomal proteins L26 eukaryotic, L24P archaeal', NULL, 'Ribosomal_L26', NULL, NULL, 4891, 9),
(254509, NULL, 'PF18567', NULL, NULL, 'Toll/interleukin-1 receptor domain', NULL, 'TIR_3', NULL, NULL, 29373, 9),
(254510, NULL, 'PF19174', NULL, NULL, 'Family of unknown function (DUF5856)', NULL, 'DUF5856', NULL, NULL, 34133, 9),
(254511, NULL, 'PF05578', NULL, NULL, 'Pestivirus NS3 polyprotein peptidase S31', NULL, 'Peptidase_S31', NULL, NULL, 4533, 9),
(254512, NULL, 'PF17113', NULL, NULL, 'Regulatory signalling modulator protein AmpE', NULL, 'AmpE', NULL, NULL, 26050, 9),
(254513, NULL, 'PF01617', NULL, NULL, 'Surface antigen', NULL, 'Surface_Ag_2', NULL, NULL, 1508, 9),
(254514, NULL, 'PF19904', NULL, NULL, 'Domain of unknown function (DUF6377)', NULL, 'DUF6377', NULL, NULL, 36502, 9),
(254515, NULL, 'PF04161', NULL, NULL, 'Arv1-like family', NULL, 'Arv1', NULL, NULL, 7468, 9),
(254516, NULL, 'PF12412', NULL, NULL, 'Protein of unknown function (DUF3667)', NULL, 'DUF3667', NULL, NULL, 20760, 9),
(254517, NULL, 'PF14953', NULL, NULL, 'Domain of unknown function (DUF4504)', NULL, 'DUF4504', NULL, NULL, 25908, 9),
(254518, NULL, 'PF07293', NULL, NULL, 'Protein of unknown function (DUF1450)', NULL, 'DUF1450', NULL, NULL, 14279, 9),
(254519, NULL, 'PF04801', NULL, NULL, 'RPC5 protein', NULL, 'RPC5', NULL, NULL, 4824, 9),
(254520, NULL, 'PF12137', NULL, NULL, 'RNA polymerase recycling family C-terminal', NULL, 'RapA_C', NULL, NULL, 14694, 9),
(254521, NULL, 'PF09109', NULL, NULL, 'Switch protein XOL-1, GHMP-like', NULL, 'Xol-1_GHMP-like', NULL, NULL, 10737, 9),
(254522, NULL, 'PF12417', NULL, NULL, 'Zinc finger protein', NULL, 'DUF3669', NULL, NULL, 20709, 9),
(254523, NULL, 'PF14660', NULL, NULL, 'Domain of unknown function (DUF4458)', NULL, 'DUF4458', NULL, NULL, 24059, 9),
(254524, NULL, 'PF17264', NULL, NULL, 'Family of unknown function (DUF5330)', NULL, 'DUF5330', NULL, NULL, 18950, 9),
(254525, NULL, 'PF13943', NULL, NULL, 'WPP domain', NULL, 'WPP', NULL, NULL, 23026, 9),
(254526, NULL, 'PF16908', NULL, NULL, 'Vacuolar sorting-associated protein 13, N-terminal', NULL, 'VPS13', NULL, NULL, 21934, 9),
(254527, NULL, 'PF06831', NULL, NULL, 'Formamidopyrimidine-DNA glycosylase H2TH domain', NULL, 'H2TH', NULL, NULL, 7264, 9),
(254528, NULL, 'PF12294', NULL, NULL, 'Protein of unknown function (DUF3626)', NULL, 'DUF3626', NULL, NULL, 20817, 9),
(254529, NULL, 'PF01196', NULL, NULL, 'Ribosomal protein L17', NULL, 'Ribosomal_L17', NULL, NULL, 6840, 9),
(254530, NULL, 'PF06200', NULL, NULL, 'tify domain', NULL, 'tify', NULL, NULL, 9041, 9),
(254531, NULL, 'PF04983', NULL, NULL, 'RNA polymerase Rpb1, domain 3', NULL, 'RNA_pol_Rpb1_3', NULL, NULL, 6586, 9),
(254532, NULL, 'PF09419', NULL, NULL, 'Mitochondrial PGP phosphatase', NULL, 'PGP_phosphatase', NULL, NULL, 26513, 9),
(254533, NULL, 'PF12164', NULL, NULL, 'Stage V sporulation protein AA', NULL, 'SporV_AA', NULL, NULL, 20162, 9),
(254534, NULL, 'PF04111', NULL, NULL, 'Apg6 BARA domain', NULL, 'APG6', NULL, NULL, 27966, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(254535, NULL, 'PF14289', NULL, NULL, 'Domain of unknown function (DUF4369)', NULL, 'DUF4369', NULL, NULL, 21991, 9),
(254536, NULL, 'PF08520', NULL, NULL, 'Fungal protein of unknown function (DUF1748)', NULL, 'DUF1748', NULL, NULL, 14239, 9),
(254537, NULL, 'PF19277', NULL, NULL, 'Glycerol-3-phosphate acyltransferase C-terminal region', NULL, 'GPAT_C', NULL, NULL, 35524, 9),
(254538, NULL, 'PF17650', NULL, NULL, 'RACo linker region', NULL, 'RACo_linker', NULL, NULL, 27923, 9),
(254539, NULL, 'PF02135', NULL, NULL, 'TAZ zinc finger', NULL, 'zf-TAZ', NULL, NULL, 3995, 9),
(254540, NULL, 'PF10474', NULL, NULL, 'Protein of unknown function C-terminus (DUF2451)', NULL, 'DUF2451', NULL, NULL, 18392, 9),
(254541, NULL, 'PF14134', NULL, NULL, 'Domain of unknown function (DUF4301)', NULL, 'DUF4301', NULL, NULL, 26482, 9),
(254542, NULL, 'PF07455', NULL, NULL, 'Phage polarity suppression protein (Psu)', NULL, 'Psu', NULL, NULL, 8564, 9),
(254543, NULL, 'PF15763', NULL, NULL, 'Regulator of human erythroid cell expansion (RHEX)', NULL, 'DUF4692', NULL, NULL, 26907, 9),
(254544, NULL, 'PF10244', NULL, NULL, 'Mitochondrial ribosomal subunit', NULL, 'MRP-L51', NULL, NULL, 15834, 9),
(254545, NULL, 'PF01686', NULL, NULL, 'Adenovirus penton base protein', NULL, 'Adeno_Penton_B', NULL, NULL, 1516, 9),
(254546, NULL, 'PF07268', NULL, NULL, 'Exported protein precursor (EppA/BapA)', NULL, 'EppA_BapA', NULL, NULL, 14479, 9),
(254547, NULL, 'PF15693', NULL, NULL, 'Mediator complex subunit 26 C-terminal', NULL, 'Med26_C', NULL, NULL, 25525, 9),
(254548, NULL, 'PF06154', NULL, NULL, 'CbeA_antitoxin, type IV, cytoskeleton bundling-enhancing factor A', NULL, 'CbeA_antitoxin', NULL, NULL, 14497, 9),
(254549, NULL, 'PF19038', NULL, NULL, 'Third Longin domain of FUZ, MON1 and HPS1', NULL, 'Fuz_longin_3', NULL, NULL, 34819, 9),
(254550, NULL, 'PF05406', NULL, NULL, 'WGR domain', NULL, 'WGR', NULL, NULL, 7662, 9),
(254551, NULL, 'PF17851', NULL, NULL, 'Beta xylosidase C-terminal Concanavalin A-like domain', NULL, 'GH43_C2', NULL, NULL, 29850, 9),
(254552, NULL, 'PF01005', NULL, NULL, 'Flavivirus non-structural protein NS2A', NULL, 'Flavi_NS2A', NULL, NULL, 4737, 9),
(254553, NULL, 'PF09462', NULL, NULL, 'Mus7/MMS22 family', NULL, 'Mus7', NULL, NULL, 15598, 9),
(254554, NULL, 'PF16181', NULL, NULL, 'RelB transactivation domain', NULL, 'RelB_transactiv', NULL, NULL, 21777, 9),
(254555, NULL, 'PF17349', NULL, NULL, 'Family of unknown function (DUF5378)', NULL, 'DUF5378', NULL, NULL, 32620, 9),
(254556, NULL, 'PF03796', NULL, NULL, 'DnaB-like helicase C terminal domain', NULL, 'DnaB_C', NULL, NULL, 1492, 9),
(254557, NULL, 'PF10793', NULL, NULL, 'Gloverin-like protein', NULL, 'Gloverin', NULL, NULL, 20711, 9),
(254558, NULL, 'PF15580', NULL, NULL, 'Immunity protein 53', NULL, 'Imm53', NULL, NULL, 22972, 9),
(254559, NULL, 'PF01363', NULL, NULL, 'FYVE zinc finger', NULL, 'FYVE', NULL, NULL, 705, 9),
(254560, NULL, 'PF02786', NULL, NULL, 'Carbamoyl-phosphate synthase L chain, ATP binding domain', NULL, 'CPSase_L_D2', NULL, NULL, 782, 9),
(254561, NULL, 'PF15735', NULL, NULL, 'Domain of unknown function (DUF4683)', NULL, 'DUF4683', NULL, NULL, 22047, 9),
(254562, NULL, 'PF19404', NULL, NULL, 'Family of unknown function (DUF5977)', NULL, 'DUF5977', NULL, NULL, 36819, 9),
(254563, NULL, 'PF11880', NULL, NULL, 'Domain of unknown function (DUF3400)', NULL, 'DUF3400', NULL, NULL, 19722, 9),
(254564, NULL, 'PF16782', NULL, NULL, 'Nucleotide exchange factor SIL1', NULL, 'SIL1', NULL, NULL, 26566, 9),
(254565, NULL, 'PF08875', NULL, NULL, 'Domain of unknown function (DUF1833)', NULL, 'DUF1833', NULL, NULL, 14136, 9),
(254566, NULL, 'PF12217', NULL, NULL, 'Catalytic beta propeller domain of bacteriophage endosialidase', NULL, 'End_beta_propel', NULL, NULL, 26529, 9),
(254567, NULL, 'PF06241', NULL, NULL, 'Castor and Pollux, part of voltage-gated ion channel', NULL, 'Castor_Poll_mid', NULL, NULL, 9141, 9),
(254568, NULL, 'PF16029', NULL, NULL, 'Domain of unknown function (DUF4787)', NULL, 'DUF4787', NULL, NULL, 26350, 9),
(254569, NULL, 'PF20605', NULL, NULL, 'Antitoxin-like ribbon-helix-helix', NULL, 'Antitox_RHH', NULL, NULL, 33959, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(254570, NULL, 'PF05182', NULL, NULL, 'Fip1 motif', NULL, 'Fip1', NULL, NULL, 2121, 9),
(254571, NULL, 'PF07926', NULL, NULL, 'TPR/MLP1/MLP2-like protein', NULL, 'TPR_MLP1_2', NULL, NULL, 8069, 9),
(254572, NULL, 'PF12703', NULL, NULL, 'Toxin of toxin-antitoxin type 1 system', NULL, 'ptaRNA1_toxin', NULL, NULL, 13558, 9),
(254573, NULL, 'PF09898', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2125)', NULL, 'DUF2125', NULL, NULL, 16839, 9),
(254574, NULL, 'PF10307', NULL, NULL, 'HAD domain family 1 in Swiss Army Knife RNA repair proteins', NULL, 'HAD_SAK_1', NULL, NULL, 19532, 9),
(254575, NULL, 'PF19656', NULL, NULL, 'Family of unknown function (DUF6159)', NULL, 'DUF6159', NULL, NULL, 37066, 9),
(254576, NULL, 'PF11292', NULL, NULL, 'Protein of unknown function (DUF3093)', NULL, 'DUF3093', NULL, NULL, 18012, 9),
(254577, NULL, 'PF03277', NULL, NULL, 'Herpesvirus UL4 family', NULL, 'Herpes_UL4', NULL, NULL, 2729, 9),
(254578, NULL, 'PF07452', NULL, NULL, 'CHRD domain', NULL, 'CHRD', NULL, NULL, 12460, 9),
(254579, NULL, 'PF12323', NULL, NULL, 'Helix-turn-helix domain', NULL, 'HTH_OrfB_IS605', NULL, NULL, 15829, 9),
(254580, NULL, 'PF17495', NULL, NULL, 'Vpr-like OrfA', NULL, 'OrfA', NULL, NULL, 21172, 9),
(254581, NULL, 'PF02974', NULL, NULL, 'Protease inhibitor Inh', NULL, 'Inh', NULL, NULL, 15127, 9),
(254582, NULL, 'PF19441', NULL, NULL, 'Astrotactin 1/2 N-terminal', NULL, 'ASTN_1_2_N', NULL, NULL, 34320, 9),
(254583, NULL, 'PF17155', NULL, NULL, 'Gammaproteobacterial periplasmic sensor domain', NULL, 'GAPES1', NULL, NULL, 30658, 9),
(254584, NULL, 'PF11842', NULL, NULL, 'Domain of unknown function (DUF3362)', NULL, 'DUF3362', NULL, NULL, 21656, 9),
(254585, NULL, 'PF12641', NULL, NULL, 'Flavodoxin domain', NULL, 'Flavodoxin_3', NULL, NULL, 1968, 9),
(254586, NULL, 'PF12364', NULL, NULL, 'Protein of unknown function (DUF3648)', NULL, 'DUF3648', NULL, NULL, 20580, 9),
(254587, NULL, 'PF11383', NULL, NULL, 'Protein of unknown function (DUF3187)', NULL, 'DUF3187', NULL, NULL, 18755, 9),
(254588, NULL, 'PF16661', NULL, NULL, 'Metallo-beta-lactamase superfamily domain', NULL, 'Lactamase_B_6', NULL, NULL, 2148, 9),
(254589, NULL, 'PF16877', NULL, NULL, 'Domain of unknown function (DUF5078)', NULL, 'DUF5078', NULL, NULL, 24414, 9),
(254590, NULL, 'PF17240', NULL, NULL, 'Family of unknown function (DUF5313)', NULL, 'DUF5313', NULL, NULL, 20244, 9),
(254591, NULL, 'PF05526', NULL, NULL, 'Rhodococcus equi virulence-associated protein', NULL, 'R_equi_Vir', NULL, NULL, 13873, 9),
(254592, NULL, 'PF18730', NULL, NULL, 'Cthe_2314-like HEPN', NULL, 'HEPN_Cthe2314', NULL, NULL, 29180, 9),
(254593, NULL, 'PF19985', NULL, NULL, 'Family of unknown function (DUF6421)', NULL, 'DUF6421', NULL, NULL, 37626, 9),
(254594, NULL, 'PF18690', NULL, NULL, 'Family of unknown function (DUF5639)', NULL, 'DUF5639', NULL, NULL, 29024, 9),
(254595, NULL, 'PF02933', NULL, NULL, 'Cell division protein 48 (CDC48), domain 2', NULL, 'CDC48_2', NULL, NULL, 2925, 9),
(254596, NULL, 'PF10730', NULL, NULL, 'Protein of unknown function (DUF2521)', NULL, 'DUF2521', NULL, NULL, 20710, 9),
(254597, NULL, 'PF01704', NULL, NULL, 'UTP--glucose-1-phosphate uridylyltransferase', NULL, 'UDPGP', NULL, NULL, 2504, 9),
(254598, NULL, 'PF11979', NULL, NULL, 'Domain of unknown function (DUF3480)', NULL, 'DUF3480', NULL, NULL, 16358, 9),
(254599, NULL, 'PF10046', NULL, NULL, 'Biogenesis of lysosome-related organelles complex-1 subunit 2', NULL, 'BLOC1_2', NULL, NULL, 19991, 9),
(254600, NULL, 'PF13596', NULL, NULL, 'PAS domain', NULL, 'PAS_10', NULL, NULL, NULL, 9),
(254601, NULL, 'PF16092', NULL, NULL, 'Cilia- and flagella-associated protein 61, N-terminal domain', NULL, 'CFAP61_N', NULL, NULL, 26132, 9),
(254602, NULL, 'PF13066', NULL, NULL, 'Protein of unknown function (DUF3929)', NULL, 'DUF3929', NULL, NULL, 21368, 9),
(254603, NULL, 'PF16576', NULL, NULL, 'Barrel-sandwich domain of CusB or HlyD membrane-fusion', NULL, 'HlyD_D23', NULL, NULL, 25037, 9),
(254604, NULL, 'PF13024', NULL, NULL, 'Protein of unknown function (DUF3884)', NULL, 'DUF3884', NULL, NULL, 22255, 9);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(254605, NULL, 'PF17095', NULL, NULL, 'Spectrin-binding region of Ca2+-Calmodulin', NULL, 'CAMSAP_CC1', NULL, NULL, 24167, 9),
(254606, NULL, 'PF05845', NULL, NULL, 'Bacterial phosphonate metabolism protein (PhnH)', NULL, 'PhnH', NULL, NULL, 12173, 9),
(254607, NULL, 'PF13962', NULL, NULL, 'Domain of unknown function', NULL, 'PGG', NULL, NULL, 25989, 9),
(254608, NULL, 'PF08207', NULL, NULL, 'Elongation factor P (EF-P) KOW-like domain', NULL, 'EFP_N', NULL, NULL, 17175, 9),
(254609, NULL, 'PF11838', NULL, NULL, 'ERAP1-like C-terminal domain', NULL, 'ERAP1_C', NULL, NULL, 21606, 9),
(254610, NULL, 'PF06472', NULL, NULL, 'ABC transporter transmembrane region 2', NULL, 'ABC_membrane_2', NULL, NULL, 12367, 9),
(254611, NULL, 'PF14915', NULL, NULL, 'CCDC144C protein coiled-coil region', NULL, 'CCDC144C', NULL, NULL, 28517, 9),
(254612, NULL, 'PF11454', NULL, NULL, 'Protein of unknown function (DUF3016)', NULL, 'DUF3016', NULL, NULL, 18971, 9),
(254613, NULL, 'PF07976', NULL, NULL, 'Phenol hydroxylase, C-terminal dimerisation domain', NULL, 'Phe_hydrox_dim', NULL, NULL, 8469, 9),
(254614, NULL, 'PF13605', NULL, NULL, 'Domain of unknown function (DUF4141)', NULL, 'DUF4141', NULL, NULL, 22452, 9),
(254615, NULL, 'PF17201', NULL, NULL, 'Cache 3/Cache 2 fusion domain', NULL, 'Cache_3-Cache_2', NULL, NULL, 27388, 9),
(254616, NULL, 'PF11341', NULL, NULL, 'Protein of unknown function (DUF3143)', NULL, 'DUF3143', NULL, NULL, 18738, 9),
(254617, NULL, 'PF06979', NULL, NULL, 'TMEM70/TMEM186/TMEM223 protein family', NULL, 'TMEM70', NULL, NULL, 35893, 9),
(254618, NULL, 'PF04512', NULL, NULL, 'Baculovirus polyhedron envelope protein, PEP, N terminus', NULL, 'Baculo_PEP_N', NULL, NULL, 2528, 9),
(254619, NULL, 'PF13242', NULL, NULL, 'HAD-hyrolase-like', NULL, 'Hydrolase_like', NULL, NULL, NULL, 9),
(254620, NULL, 'PF19171', NULL, NULL, 'Family of unknown function (DUF5853)', NULL, 'DUF5853', NULL, NULL, 34562, 9),
(254621, NULL, 'PF03386', NULL, NULL, 'Early nodulin 93 ENOD93 protein', NULL, 'ENOD93', NULL, NULL, 2357, 9),
(254622, NULL, 'PF03454', NULL, NULL, 'MoeA C-terminal region (domain IV)', NULL, 'MoeA_C', NULL, NULL, 10752, 9),
(254623, NULL, 'PF10595', NULL, NULL, 'Uncharacterised protein family UPF0564', NULL, 'UPF0564', NULL, NULL, 20442, 9),
(254624, NULL, 'PF02207', NULL, NULL, 'Putative zinc finger in N-recognin (UBR box)', NULL, 'zf-UBR', NULL, NULL, 1655, 9),
(254625, NULL, 'PF11718', NULL, NULL, 'Pre-mRNA 3''-end-processing endonuclease polyadenylation factor C-term', NULL, 'CPSF73-100_C', NULL, NULL, 19332, 9),
(254626, NULL, 'PF20340', NULL, NULL, 'Family of unknown function (DUF6635)', NULL, 'DUF6635', NULL, NULL, 33560, 9),
(254627, NULL, 'PF14381', NULL, NULL, 'Ethylene-responsive protein kinase Le-CTR1', NULL, 'EDR1', NULL, NULL, NULL, 9),
(254628, NULL, 'PF15314', NULL, NULL, 'Proline-rich acidic protein 1, pregnancy-specific uterine', NULL, 'PRAP', NULL, NULL, 24746, 9),
(254629, NULL, 'PF13328', NULL, NULL, 'HD domain', NULL, 'HD_4', NULL, NULL, NULL, 9),
(254630, NULL, 'PF09895', NULL, NULL, 'RecB-family nuclease (DUF2122)', NULL, 'DUF2122', NULL, NULL, 16789, 9),
(254631, NULL, 'PF17748', NULL, NULL, 'VID27 N-terminal region', NULL, 'VID27_N', NULL, NULL, 27709, 9),
(254632, NULL, 'PF11344', NULL, NULL, 'Protein of unknown function (DUF3146)', NULL, 'DUF3146', NULL, NULL, 18560, 9),
(254633, NULL, 'PF10350', NULL, NULL, 'THADA/TRM732, DUF2428', NULL, 'DUF2428', NULL, NULL, 17018, 9),
(254634, NULL, 'PF02425', NULL, NULL, 'Paralytic/GBP/PSP peptide', NULL, 'GBP_PSP', NULL, NULL, 5472, 9),
(254635, NULL, 'PF12438', NULL, NULL, 'Protein of unknown function (DUF3679)', NULL, 'DUF3679', NULL, NULL, 20380, 9),
(254636, NULL, 'PF12843', NULL, NULL, 'Putative quorum-sensing-regulated virulence factor', NULL, 'QSregVF_b', NULL, NULL, 24944, 9),
(254637, NULL, 'PF13682', NULL, NULL, 'Chemoreceptor zinc-binding domain', NULL, 'CZB', NULL, NULL, 23164, 9),
(254638, NULL, 'PF01528', NULL, NULL, 'Herpesvirus glycoprotein M', NULL, 'Herpes_glycop', NULL, NULL, 4600, 9),
(254639, NULL, 'PF19998', NULL, NULL, 'FtsH ternary system domain X1', NULL, 'fvmX1', NULL, NULL, 36122, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(254640, NULL, 'PF02258', NULL, NULL, 'Shiga-like toxin beta subunit', NULL, 'SLT_beta', NULL, NULL, 1541, 9),
(254641, NULL, 'PF12791', NULL, NULL, 'Anti-sigma factor N-terminus', NULL, 'RsgI_N', NULL, NULL, 24152, 9),
(254642, NULL, 'PF16448', NULL, NULL, 'LapD/MoxY periplasmic domain', NULL, 'LapD_MoxY_N', NULL, NULL, 26925, 9),
(254643, NULL, 'PF06288', NULL, NULL, 'Protein of unknown function (DUF1040)', NULL, 'DUF1040', NULL, NULL, 8442, 9),
(254644, NULL, 'PF08949', NULL, NULL, 'Bacteriophage PRD1, spike protein P5, C-terminal', NULL, 'PRD1_P5_C', NULL, NULL, 7755, 9),
(254645, NULL, 'PF17274', NULL, NULL, 'Family of unknown function (DUF5339)', NULL, 'DUF5339', NULL, NULL, 19077, 9),
(254646, NULL, 'PF12896', NULL, NULL, 'Anaphase-promoting complex, cyclosome, subunit 4', NULL, 'ANAPC4', NULL, NULL, 24381, 9),
(254647, NULL, 'PF07809', NULL, NULL, 'RTP801 C-terminal region', NULL, 'RTP801_C', NULL, NULL, 7860, 9),
(254648, NULL, 'PF16791', NULL, NULL, 'Connexin 40 C-terminal domain', NULL, 'Connexin40_C', NULL, NULL, 26735, 9),
(254649, NULL, 'PF20518', NULL, NULL, 'Anaphase-promoting complex subunit 1 middle domain', NULL, 'Apc1_MidN', NULL, NULL, 36647, 9),
(254650, NULL, 'PF15247', NULL, NULL, 'Histone RNA hairpin-binding protein RNA-binding domain', NULL, 'SLBP_RNA_bind', NULL, NULL, 23704, 9),
(254651, NULL, 'PF16315', NULL, NULL, 'Domain of unknown function (DUF4955)', NULL, 'DUF4955', NULL, NULL, 25871, 9),
(254652, NULL, 'PF12842', NULL, NULL, 'CCR4-Not complex, Not1 subunit, domain of unknown function DUF3819', NULL, 'DUF3819', NULL, NULL, 21633, 9),
(254653, NULL, 'PF09270', NULL, NULL, 'Beta-trefoil DNA-binding domain', NULL, 'BTD', NULL, NULL, 13273, 9),
(254654, NULL, 'PF11618', NULL, NULL, 'First C2 domain of RPGR-interacting protein 1', NULL, 'C2-C2_1', NULL, NULL, 18578, 9),
(254655, NULL, 'PF06435', NULL, NULL, 'Repeat of unknown function (DUF1079)', NULL, 'DUF1079', NULL, NULL, 10408, 9),
(254656, NULL, 'PF07534', NULL, NULL, 'TLD', NULL, 'TLD', NULL, NULL, 329, 9),
(254657, NULL, 'PF00793', NULL, NULL, 'DAHP synthetase I family', NULL, 'DAHP_synth_1', NULL, NULL, 11131, 9),
(254658, NULL, 'PF12970', NULL, NULL, 'Domain of Unknown Function with PDB structure (DUF3858)', NULL, 'DUF3858', NULL, NULL, 26210, 9),
(254659, NULL, 'PF17770', NULL, NULL, 'Ribonuclease J C-terminal domain', NULL, 'RNase_J_C', NULL, NULL, 30456, 9),
(254660, NULL, 'PF12430', NULL, NULL, 'Abscisic acid G-protein coupled receptor', NULL, 'ABA_GPCR', NULL, NULL, 23162, 9),
(254661, NULL, 'PF00254', NULL, NULL, 'FKBP-type peptidyl-prolyl cis-trans isomerase', NULL, 'FKBP_C', NULL, NULL, 1232, 9),
(254662, NULL, 'PF12563', NULL, NULL, 'Hemolytic toxin N terminal', NULL, 'Hemolysin_N', NULL, NULL, 21056, 9),
(254663, NULL, 'PF16728', NULL, NULL, 'Domain of unknown function (DUF5066)', NULL, 'DUF5066', NULL, NULL, 22942, 9),
(254664, NULL, 'PF07127', NULL, NULL, 'Late nodulin protein', NULL, 'Nodulin_late', NULL, NULL, 13177, 9),
(254665, NULL, 'PF20270', NULL, NULL, 'CASPASE and TPR Repeat-Associated C-terminal domain', NULL, 'CATRA-C', NULL, NULL, 37547, 9),
(254666, NULL, 'PF08119', NULL, NULL, 'Scorpion acidic alpha-KTx toxin family', NULL, 'Toxin_31', NULL, NULL, 10091, 9),
(254667, NULL, 'PF12660', NULL, NULL, 'Putative zinc-finger of transcription factor IIIC complex', NULL, 'zf-TFIIIC', NULL, NULL, 19484, 9),
(254668, NULL, 'PF10891', NULL, NULL, 'Protein of unknown function (DUF2719)', NULL, 'DUF2719', NULL, NULL, 12512, 9),
(254669, NULL, 'PF11881', NULL, NULL, 'C-terminal domain of SPAR protein', NULL, 'SPAR_C', NULL, NULL, 19693, 9),
(254670, NULL, 'PF13855', NULL, NULL, 'Leucine rich repeat', NULL, 'LRR_8', NULL, NULL, 5227, 9),
(254671, NULL, 'PF11449', NULL, NULL, 'Putative, 10TM heavy-metal exporter', NULL, 'ArsP_2', NULL, NULL, 18636, 9),
(254672, NULL, 'PF18336', NULL, NULL, 'Fragile X mental retardation Tudor domain', NULL, 'Tudor_FRX1', NULL, NULL, 30573, 9),
(254673, NULL, 'PF06681', NULL, NULL, 'Protein of unknown function (DUF1182)', NULL, 'DUF1182', NULL, NULL, 8007, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(254674, NULL, 'PF08349', NULL, NULL, 'Protein of unknown function (DUF1722)', NULL, 'DUF1722', NULL, NULL, 12820, 9),
(254675, NULL, 'PF18521', NULL, NULL, 'Transactivation domain 2', NULL, 'TAD2', NULL, NULL, 27885, 9),
(254676, NULL, 'PF18566', NULL, NULL, 'Linalool dehydratase/isomerase', NULL, 'Ldi', NULL, NULL, 30268, 9),
(254677, NULL, 'PF08225', NULL, NULL, 'Pseudin antimicrobial peptide', NULL, 'Antimicrobial19', NULL, NULL, 8642, 9),
(254678, NULL, 'PF18644', NULL, NULL, 'Phage integrase SAM-like domain', NULL, 'Phage_int_SAM_6', NULL, NULL, 29216, 9),
(254679, NULL, 'PF16209', NULL, NULL, 'Phospholipid-translocating ATPase N-terminal', NULL, 'PhoLip_ATPase_N', NULL, NULL, 21744, 9),
(254680, NULL, 'PF02170', NULL, NULL, 'PAZ domain', NULL, 'PAZ', NULL, NULL, 1158, 9),
(254681, NULL, 'PF18175', NULL, NULL, 'CCDC81-like prokaryotic HU domain 2', NULL, 'HU-CCDC81_bac_2', NULL, NULL, 29211, 9),
(254682, NULL, 'PF20201', NULL, NULL, 'Family of unknown function (DUF6563)', NULL, 'DUF6563', NULL, NULL, 37321, 9),
(254683, NULL, 'PF13654', NULL, NULL, 'LonB-like, AAA domain', NULL, 'AAA_32', NULL, NULL, 30130, 9),
(254684, NULL, 'PF18681', NULL, NULL, 'Family of unknown function (DUF5634)', NULL, 'DUF5634', NULL, NULL, 27932, 9),
(254685, NULL, 'PF19438', NULL, NULL, 'LIN9 C-terminal', NULL, 'LIN9_C', NULL, NULL, 37205, 9),
(254686, NULL, 'PF06519', NULL, NULL, 'TolA C-terminal', NULL, 'TolA', NULL, NULL, 14216, 9),
(254687, NULL, 'PF09690', NULL, NULL, 'Plasmodium yoelii subtelomeric region (PYST-C1)', NULL, 'PYST-C1', NULL, NULL, 6216, 9),
(254688, NULL, 'PF13924', NULL, NULL, 'Lipocalin-like domain', NULL, 'Lipocalin_5', NULL, NULL, 22924, 9),
(254689, NULL, 'PF14984', NULL, NULL, 'CD24 protein', NULL, 'CD24', NULL, NULL, 21640, 9),
(254690, NULL, 'PF11719', NULL, NULL, 'DNA replication and checkpoint protein', NULL, 'Drc1-Sld2', NULL, NULL, 15438, 9),
(254691, NULL, 'PF08827', NULL, NULL, 'Domain of unknown function (DUF1805)', NULL, 'DUF1805', NULL, NULL, 14470, 9),
(254692, NULL, 'PF00636', NULL, NULL, 'Ribonuclease III domain', NULL, 'Ribonuclease_3', NULL, NULL, 80, 9),
(254693, NULL, 'PF04335', NULL, NULL, 'VirB8 protein', NULL, 'VirB8', NULL, NULL, 3781, 9),
(254694, NULL, 'PF15817', NULL, NULL, 'Transmembrane protein 40 family', NULL, 'TMEM40', NULL, NULL, 21473, 9),
(254695, NULL, 'PF20311', NULL, NULL, 'Family of unknown function (DUF6607)', NULL, 'DUF6607', NULL, NULL, 37164, 9),
(254696, NULL, 'PF10827', NULL, NULL, 'Protein of unknown function (DUF2552)', NULL, 'DUF2552', NULL, NULL, 13707, 9),
(254697, NULL, 'PF11629', NULL, NULL, 'C terminal SARAH domain of Mst1', NULL, 'Mst1_SARAH', NULL, NULL, 20682, 9),
(254698, NULL, 'PF10328', NULL, NULL, 'Serpentine type 7TM GPCR chemoreceptor Srx', NULL, '7TM_GPCR_Srx', NULL, NULL, 17116, 9),
(254699, NULL, 'PF08190', NULL, NULL, 'PIH1 N-terminal domain', NULL, 'PIH1', NULL, NULL, 12176, 9),
(254700, NULL, 'PF14230', NULL, NULL, 'Domain of unknown function (DUF4333)', NULL, 'DUF4333', NULL, NULL, 24813, 9),
(254701, NULL, 'PF10079', NULL, NULL, 'Bacillithiol biosynthesis BshC', NULL, 'BshC', NULL, NULL, 9674, 9),
(254702, NULL, 'PF04536', NULL, NULL, 'TPM domain', NULL, 'TPM_phosphatase', NULL, NULL, 2950, 9),
(254703, NULL, 'PF16224', NULL, NULL, 'DOmain of unknown function (DUF4883)', NULL, 'DUF4883', NULL, NULL, 26364, 9),
(254704, NULL, 'PF19631', NULL, NULL, 'Trypsin-co-occurring domain 2', NULL, 'Trypco2', NULL, NULL, 34328, 9),
(254705, NULL, 'PF17869', NULL, NULL, 'Anosmin cysteine rich domain', NULL, 'Cys_box', NULL, NULL, 28981, 9),
(254706, NULL, 'PF09763', NULL, NULL, 'Exocyst complex component Sec3', NULL, 'Sec3_C', NULL, NULL, 18118, 9),
(254707, NULL, 'PF07316', NULL, NULL, 'Protein of unknown function (DUF1463)', NULL, 'DUF1463', NULL, NULL, 8424, 9),
(254708, NULL, 'PF03976', NULL, NULL, 'Polyphosphate kinase 2 (PPK2)', NULL, 'PPK2', NULL, NULL, 16062, 9),
(254709, NULL, 'PF16097', NULL, NULL, 'Fragile X-related 1 protein C-terminal region 3', NULL, 'FXR_C3', NULL, NULL, 22545, 9),
(254710, NULL, 'PF14709', NULL, NULL, 'double strand RNA binding domain from DEAD END PROTEIN 1', NULL, 'DND1_DSRM', NULL, NULL, NULL, 9);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(254711, NULL, 'PF20051', NULL, NULL, 'Family of unknown function (DUF6453)', NULL, 'DUF6453', NULL, NULL, 34040, 9),
(254712, NULL, 'PF04350', NULL, NULL, 'Pilus assembly protein, PilO', NULL, 'PilO', NULL, NULL, 4958, 9),
(254713, NULL, 'PF11564', NULL, NULL, 'Restriction endonuclease BpuJI - N terminal', NULL, 'BpuJI_N', NULL, NULL, 15391, 9),
(254714, NULL, 'PF11256', NULL, NULL, 'Protein of unknown function (DUF3055)', NULL, 'DUF3055', NULL, NULL, 18240, 9),
(254715, NULL, 'PF05594', NULL, NULL, 'Haemagglutinin repeat', NULL, 'Fil_haemagg', NULL, NULL, 14164, 9),
(254716, NULL, 'PF10345', NULL, NULL, 'Cohesin loading factor', NULL, 'Cohesin_load', NULL, NULL, 17380, 9),
(254717, NULL, 'PF06068', NULL, NULL, 'TIP49 P-loop domain', NULL, 'TIP49', NULL, NULL, 8644, 9),
(254718, NULL, 'PF13813', NULL, NULL, 'Membrane bound O-acyl transferase family', NULL, 'MBOAT_2', NULL, NULL, 21949, 9),
(254719, NULL, 'PF20150', NULL, NULL, '2EXR family', NULL, '2EXR', NULL, NULL, 36489, 9),
(254720, NULL, 'PF06399', NULL, NULL, 'GTP cyclohydrolase I feedback regulatory protein (GFRP)', NULL, 'GFRP', NULL, NULL, 7959, 9),
(254721, NULL, 'PF14419', NULL, NULL, 'AF2226-like SPOUT RNA Methylase fused to THUMP', NULL, 'SPOUT_MTase_2', NULL, NULL, 24415, 9),
(254722, NULL, 'PF13953', NULL, NULL, 'PapC C-terminal domain', NULL, 'PapC_C', NULL, NULL, 23784, 9),
(254723, NULL, 'PF04293', NULL, NULL, 'SpoVR like protein', NULL, 'SpoVR', NULL, NULL, 3677, 9),
(254724, NULL, 'PF00348', NULL, NULL, 'Polyprenyl synthetase', NULL, 'polyprenyl_synt', NULL, NULL, 2916, 9),
(254725, NULL, 'PF01684', NULL, NULL, 'ET module', NULL, 'ET', NULL, NULL, 1751, 9),
(254726, NULL, 'PF17532', NULL, NULL, 'Family of unknown function (DUF5451)', NULL, 'DUF5451', NULL, NULL, 15091, 9),
(254727, NULL, 'PF07919', NULL, NULL, 'Gryzun, putative trafficking through Golgi', NULL, 'Gryzun', NULL, NULL, 13456, 9),
(254728, NULL, 'PF15927', NULL, NULL, 'Cancer susceptibility candidate 1 N-terminus', NULL, 'Casc1_N', NULL, NULL, 25725, 9),
(254729, NULL, 'PF01597', NULL, NULL, 'Glycine cleavage H-protein', NULL, 'GCV_H', NULL, NULL, 31378, 9),
(254730, NULL, 'PF08684', NULL, NULL, 'DNA mimic ocr', NULL, 'ocr', NULL, NULL, 11495, 9),
(254731, NULL, 'PF08155', NULL, NULL, 'NOGCT (NUC087) domain', NULL, 'NOGCT', NULL, NULL, 11755, 9),
(254732, NULL, 'PF05463', NULL, NULL, 'Sclerostin (SOST)', NULL, 'Sclerostin', NULL, NULL, 13777, 9),
(254733, NULL, 'PF02287', NULL, NULL, 'Dehydratase small subunit', NULL, 'Dehydratase_SU', NULL, NULL, 3318, 9),
(254734, NULL, 'PF11994', NULL, NULL, 'Protein of unknown function (DUF3489)', NULL, 'DUF3489', NULL, NULL, 19536, 9),
(254735, NULL, 'PF18932', NULL, NULL, 'Family of unknown function (DUF5681)', NULL, 'DUF5681', NULL, NULL, 34061, 9),
(254736, NULL, 'PF07019', NULL, NULL, 'EMC6', NULL, 'EMC6', NULL, NULL, 24305, 9),
(254737, NULL, 'PF09756', NULL, NULL, 'DDRGK domain', NULL, 'DDRGK', NULL, NULL, 18418, 9),
(254738, NULL, 'PF16569', NULL, NULL, 'Gram-positive pilin backbone subunit 2, Cna-B-like domain', NULL, 'GramPos_pilinBB', NULL, NULL, 25219, 9),
(254739, NULL, 'PF07936', NULL, NULL, 'Potassium-channel blocking toxin', NULL, 'Defensin_4', NULL, NULL, 13477, 9),
(254740, NULL, 'PF17529', NULL, NULL, 'Family of unknown function (DUF5450)', NULL, 'DUF5450', NULL, NULL, 28110, 9),
(254741, NULL, 'PF02298', NULL, NULL, 'Plastocyanin-like domain', NULL, 'Cu_bind_like', NULL, NULL, 2699, 9),
(254742, NULL, 'PF07699', NULL, NULL, 'Tyrosine-protein kinase ephrin type A/B receptor-like', NULL, 'Ephrin_rec_like', NULL, NULL, 10671, 9),
(254743, NULL, 'PF02548', NULL, NULL, 'Ketopantoate hydroxymethyltransferase', NULL, 'Pantoate_transf', NULL, NULL, 2403, 9),
(254744, NULL, 'PF03206', NULL, NULL, 'Nitrogen fixation protein NifW', NULL, 'NifW', NULL, NULL, 349, 9),
(254745, NULL, 'PF16520', NULL, NULL, 'ssRNA-binding matrix protein of Bornaviridae', NULL, 'BDV_M', NULL, NULL, 23203, 9),
(254746, NULL, 'PF01025', NULL, NULL, 'GrpE', NULL, 'GrpE', NULL, NULL, 3633, 9),
(254747, NULL, 'PF07861', NULL, NULL, 'WisP family N-Terminal Region', NULL, 'WND', NULL, NULL, 12764, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(254748, NULL, 'PF09827', NULL, NULL, 'CRISPR associated protein Cas2', NULL, 'CRISPR_Cas2', NULL, NULL, 19216, 9),
(254749, NULL, 'PF17942', NULL, NULL, 'Morc6 ribosomal protein S5 domain 2-like', NULL, 'Morc6_S5', NULL, NULL, 28291, 9),
(254750, NULL, 'PF07391', NULL, NULL, 'NPR nonapeptide repeat (2 copies)', NULL, 'NPR', NULL, NULL, 11580, 9),
(254751, NULL, 'PF11830', NULL, NULL, 'Domain of unknown function (DUF3350)', NULL, 'DUF3350', NULL, NULL, 19088, 9),
(254752, NULL, 'PF04994', NULL, NULL, 'TfoX C-terminal domain', NULL, 'TfoX_C', NULL, NULL, 7332, 9),
(254753, NULL, 'PF16439', NULL, NULL, 'Domain of unknown function (DUF5036)', NULL, 'DUF5036', NULL, NULL, 24207, 9),
(254754, NULL, 'PF08602', NULL, NULL, 'Mgr1-like, i-AAA protease complex subunit', NULL, 'Mgr1', NULL, NULL, 17753, 9),
(254755, NULL, 'PF16596', NULL, NULL, 'Disordered region downstream of MFMR', NULL, 'MFMR_assoc', NULL, NULL, NULL, 9),
(254756, NULL, 'PF11315', NULL, NULL, 'Mediator complex subunit 30', NULL, 'Med30', NULL, NULL, 15460, 9),
(254757, NULL, 'PF13648', NULL, NULL, 'Lipocalin-like domain', NULL, 'Lipocalin_4', NULL, NULL, 22924, 9),
(254758, NULL, 'PF14578', NULL, NULL, 'Elongation factor Tu domain 4', NULL, 'GTP_EFTU_D4', NULL, NULL, 23475, 9),
(254759, NULL, 'PF04945', NULL, NULL, 'YHS domain', NULL, 'YHS', NULL, NULL, 6698, 9),
(254760, NULL, 'PF18728', NULL, NULL, 'AbiV', NULL, 'HEPN_AbiV', NULL, NULL, 21678, 9),
(254761, NULL, 'PF18011', NULL, NULL, 'C-terminal domain found in long catalases', NULL, 'Catalase_C', NULL, NULL, 29999, 9),
(254762, NULL, 'PF13314', NULL, NULL, 'Domain of unknown function (DUF4083)', NULL, 'DUF4083', NULL, NULL, 22828, 9),
(254763, NULL, 'PF07900', NULL, NULL, 'Protein of unknown function (DUF1670)', NULL, 'DUF1670', NULL, NULL, 12244, 9),
(254764, NULL, 'PF08909', NULL, NULL, 'Domain of unknown function (DUF1854)', NULL, 'DUF1854', NULL, NULL, 7543, 9),
(254765, NULL, 'PF08028', NULL, NULL, 'Acyl-CoA dehydrogenase, C-terminal domain', NULL, 'Acyl-CoA_dh_2', NULL, NULL, 18871, 9),
(254766, NULL, 'PF04562', NULL, NULL, 'Dictyostelium spore coat protein, N terminus', NULL, 'Dicty_spore_N', NULL, NULL, 2119, 9),
(254767, NULL, 'PF11402', NULL, NULL, 'Antifungal protein', NULL, 'Antifungal_prot', NULL, NULL, 16643, 9),
(254768, NULL, 'PF18464', NULL, NULL, 'Proprotein convertase subtilisin-like/kexin type 9 C-terminal domain', NULL, 'PCSK9_C2', NULL, NULL, 28852, 9),
(254769, NULL, 'PF17670', NULL, NULL, 'Family of unknown function (DUF5530)', NULL, 'DUF5530', NULL, NULL, 32540, 9),
(254770, NULL, 'PF01682', NULL, NULL, 'DB module', NULL, 'DB', NULL, NULL, 1889, 9),
(254771, NULL, 'PF02770', NULL, NULL, 'Acyl-CoA dehydrogenase, middle domain', NULL, 'Acyl-CoA_dh_M', NULL, NULL, 2829, 9),
(254772, NULL, 'PF05032', NULL, NULL, 'Spo12 family', NULL, 'Spo12', NULL, NULL, 1433, 9),
(254773, NULL, 'PF13915', NULL, NULL, 'Domain of unknown function (DUF4210)', NULL, 'DUF4210', NULL, NULL, 23013, 9),
(254774, NULL, 'PF01310', NULL, NULL, 'Adenovirus hexon associated protein, protein VIII', NULL, 'Adeno_PVIII', NULL, NULL, 4227, 9),
(254775, NULL, 'PF16173', NULL, NULL, 'Domain of unknown function (DUF4874)', NULL, 'DUF4874', NULL, NULL, 26357, 9),
(254776, NULL, 'PF15046', NULL, NULL, 'Protein of unknown function (DUF4532)', NULL, 'DUF4532', NULL, NULL, 26535, 9),
(254777, NULL, 'PF00078', NULL, NULL, 'Reverse transcriptase (RNA-dependent DNA polymerase)', NULL, 'RVT_1', NULL, NULL, 6625, 9),
(254778, NULL, 'PF03981', NULL, NULL, 'Ubiquinol-cytochrome C chaperone', NULL, 'Ubiq_cyt_C_chap', NULL, NULL, 15488, 9),
(254779, NULL, 'PF09557', NULL, NULL, 'Domain of unknown function (DUF2382)', NULL, 'DUF2382', NULL, NULL, 16548, 9),
(254780, NULL, 'PF07906', NULL, NULL, 'ShET2 enterotoxin, N-terminal region', NULL, 'Toxin_15', NULL, NULL, 7654, 9),
(254781, NULL, 'PF15830', NULL, NULL, 'Domain of unknown function (DUF4712)', NULL, 'DUF4712', NULL, NULL, 26446, 9),
(254782, NULL, 'PF09107', NULL, NULL, 'Elongation factor SelB, winged helix', NULL, 'SelB-wing_3', NULL, NULL, 10693, 9);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(254783, NULL, 'PF17125', NULL, NULL, 'N-terminal domain of 16S rRNA methyltransferase RsmF', NULL, 'Methyltr_RsmF_N', NULL, NULL, 26137, 9),
(254784, NULL, 'PF05678', NULL, NULL, 'VQ motif', NULL, 'VQ', NULL, NULL, 7810, 9),
(254785, NULL, 'PF08467', NULL, NULL, 'Luteovirus RNA polymerase P1-P2/replicase', NULL, 'Luteo_P1-P2', NULL, NULL, 13989, 9),
(254786, NULL, 'PF17135', NULL, NULL, 'Ribosomal protein 60S L18 and 50S L18e', NULL, 'Ribosomal_L18', NULL, NULL, 15313, 9),
(254787, NULL, 'PF03707', NULL, NULL, 'Bacterial signalling protein N terminal repeat', NULL, 'MHYT', NULL, NULL, 5914, 9),
(254788, NULL, 'PF03327', NULL, NULL, 'Herpesvirus capsid shell protein VP19C', NULL, 'Herpes_VP19C', NULL, NULL, 769, 9),
(254789, NULL, 'PF15521', NULL, NULL, 'Novel toxin 11', NULL, 'Ntox11', NULL, NULL, 23911, 9),
(254790, NULL, 'PF10460', NULL, NULL, 'Peptidase M30', NULL, 'Peptidase_M30', NULL, NULL, 18428, 9),
(254791, NULL, 'PF17680', NULL, NULL, 'FlgO protein', NULL, 'FlgO', NULL, NULL, 28567, 9),
(254792, NULL, 'PF02960', NULL, NULL, 'K1 glycoprotein', NULL, 'K1', NULL, NULL, 1502, 9),
(254793, NULL, 'PF11672', NULL, NULL, 'zinc-finger-containing domain', NULL, 'DUF3268', NULL, NULL, 19069, 9),
(254794, NULL, 'PF01387', NULL, NULL, 'Synuclein', NULL, 'Synuclein', NULL, NULL, 2440, 9),
(254795, NULL, 'PF04253', NULL, NULL, 'Transferrin receptor-like dimerisation domain', NULL, 'TFR_dimer', NULL, NULL, 5547, 9),
(254796, NULL, 'PF06033', NULL, NULL, 'Nucleopolyhedrovirus protein of unknown function (DUF918)', NULL, 'DUF918', NULL, NULL, 13794, 9),
(254797, NULL, 'PF15864', NULL, NULL, 'Protein glycosylation ligase', NULL, 'PglL_A', NULL, NULL, 23976, 9),
(254798, NULL, 'PF01169', NULL, NULL, 'Uncharacterized protein family UPF0016', NULL, 'UPF0016', NULL, NULL, 3321, 9),
(254799, NULL, 'PF17535', NULL, NULL, 'Family of unknown function (DUF5454)', NULL, 'DUF5454', NULL, NULL, 15136, 9),
(254800, NULL, 'PF14393', NULL, NULL, 'Domain of unknown function (DUF4422)', NULL, 'DUF4422', NULL, NULL, 26188, 9),
(254801, NULL, 'PF17003', NULL, NULL, 'Putative actin-like family', NULL, 'Actin_micro', NULL, NULL, 24119, 9),
(254802, NULL, 'PF09015', NULL, NULL, 'NgoMIV restriction enzyme', NULL, 'NgoMIV_restric', NULL, NULL, 9695, 9),
(254803, NULL, 'PF09492', NULL, NULL, 'Pectic acid lyase', NULL, 'Pec_lyase', NULL, NULL, 12505, 9),
(254804, NULL, 'PF11515', NULL, NULL, 'Mouse development and cellular proliferation protein Cullin-7', NULL, 'Cul7', NULL, NULL, 15339, 9),
(254805, NULL, 'PF01014', NULL, NULL, 'Uricase', NULL, 'Uricase', NULL, NULL, 1405, 9),
(254806, NULL, 'PF11195', NULL, NULL, 'Protein of unknown function (DUF2829)', NULL, 'DUF2829', NULL, NULL, 18491, 9),
(254807, NULL, 'PF06308', NULL, NULL, '23S rRNA methylastransferase leader peptide (ErmCL)', NULL, 'ErmC', NULL, NULL, 8319, 9),
(254808, NULL, 'PF04440', NULL, NULL, 'Dysbindin (Dystrobrevin binding protein 1)', NULL, 'Dysbindin', NULL, NULL, 10666, 9),
(254809, NULL, 'PF08745', NULL, NULL, 'PINc domain ribonuclease', NULL, 'PIN_5', NULL, NULL, 13186, 9),
(254810, NULL, 'PF12361', NULL, NULL, 'Duffy-antigen binding protein', NULL, 'DBP', NULL, NULL, 15011, 9),
(254811, NULL, 'PF18947', NULL, NULL, 'HAMP domain', NULL, 'HAMP_2', NULL, NULL, 1355, 9),
(254812, NULL, 'PF17077', NULL, NULL, 'Mitotic spindle associated protein SHE1', NULL, 'Msap1', NULL, NULL, 23776, 9),
(254813, NULL, 'PF04565', NULL, NULL, 'RNA polymerase Rpb2, domain 3', NULL, 'RNA_pol_Rpb2_3', NULL, NULL, 68, 9),
(254814, NULL, 'PF08558', NULL, NULL, 'Telomere repeat binding factor (TRF)', NULL, 'TRF', NULL, NULL, 9840, 9),
(254815, NULL, 'PF03509', NULL, NULL, 'Gap junction alpha-8 protein (Cx50)', NULL, 'Connexin50', NULL, NULL, 6172, 9),
(254816, NULL, 'PF14207', NULL, NULL, 'DpnD/PcfM-like protein', NULL, 'DpnD-PcfM', NULL, NULL, 24003, 9),
(254817, NULL, 'PF17844', NULL, NULL, 'Bacterial SCP ortholog', NULL, 'SCP_3', NULL, NULL, 30324, 9),
(254818, NULL, 'PF10403', NULL, NULL, 'Rad4 beta-hairpin domain 1', NULL, 'BHD_1', NULL, NULL, 17670, 9),
(254819, NULL, 'PF09701', NULL, NULL, 'CRISPR-associated protein (Cas_Cmr5)', NULL, 'Cas_Cmr5', NULL, NULL, 10942, 9);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(254820, NULL, 'PF10266', NULL, NULL, 'Hereditary spastic paraplegia protein strumpellin', NULL, 'Strumpellin', NULL, NULL, 16515, 9),
(254821, NULL, 'PF20279', NULL, NULL, 'C-terminal domain 12 of the ABC-three component (ABC-3C) systems', NULL, 'CTD12', NULL, NULL, 34174, 9),
(254822, NULL, 'PF11729', NULL, NULL, 'nodavirus capsid protein', NULL, 'Capsid-VNN', NULL, NULL, 20047, 9),
(254823, NULL, 'PF07715', NULL, NULL, 'TonB-dependent Receptor Plug Domain', NULL, 'Plug', NULL, NULL, 13328, 9),
(254824, NULL, 'PF19394', NULL, NULL, 'Family of unknown function (DUF5969)', NULL, 'DUF5969', NULL, NULL, 36795, 9),
(254825, NULL, 'PF00955', NULL, NULL, 'HCO3- transporter family', NULL, 'HCO3_cotransp', NULL, NULL, 8071, 9),
(254826, NULL, 'PF07448', NULL, NULL, 'Secreted phosphoprotein 24 (Spp-24) cystatin-like domain', NULL, 'Spp-24', NULL, NULL, 11826, 9),
(254827, NULL, 'PF14880', NULL, NULL, 'Cytochrome oxidase c assembly', NULL, 'COX14', NULL, NULL, 26549, 9),
(254828, NULL, 'PF11952', NULL, NULL, 'XRN-Two Binding Domain, XTBD', NULL, 'XTBD', NULL, NULL, 19528, 9),
(254829, NULL, 'PF10651', NULL, NULL, 'BppU N-terminal domain', NULL, 'BppU_N', NULL, NULL, 14549, 9),
(254830, NULL, 'PF07645', NULL, NULL, 'Calcium-binding EGF domain', NULL, 'EGF_CA', NULL, NULL, 4350, 9),
(254831, NULL, 'PF20065', NULL, NULL, 'Family of unknown function (DUF6464)', NULL, 'DUF6464', NULL, NULL, 37400, 9),
(254832, NULL, 'PF00180', NULL, NULL, 'Isocitrate/isopropylmalate dehydrogenase', NULL, 'Iso_dh', NULL, NULL, 12312, 9),
(254833, NULL, 'PF02203', NULL, NULL, 'Tar ligand binding domain homologue', NULL, 'TarH', NULL, NULL, 2649, 9),
(254834, NULL, 'PF02570', NULL, NULL, 'Precorrin-8X methylmutase', NULL, 'CbiC', NULL, NULL, 2108, 9),
(254835, NULL, 'PF05358', NULL, NULL, 'DicB protein', NULL, 'DicB', NULL, NULL, 5415, 9),
(254836, NULL, 'PF02038', NULL, NULL, 'ATP1G1/PLM/MAT8 family', NULL, 'ATP1G1_PLM_MAT8', NULL, NULL, 653, 9),
(254837, NULL, 'PF08111', NULL, NULL, 'Pea-VEAacid family', NULL, 'Pea-VEAacid', NULL, NULL, 9417, 9),
(254838, NULL, 'PF10567', NULL, NULL, 'RNA-recognition motif', NULL, 'Nab6_mRNP_bdg', NULL, NULL, 20502, 9),
(254839, NULL, 'PF02975', NULL, NULL, 'Methylamine dehydrogenase, L chain', NULL, 'Me-amine-dh_L', NULL, NULL, 7444, 9),
(254840, NULL, 'PF03492', NULL, NULL, 'SAM dependent carboxyl methyltransferase', NULL, 'Methyltransf_7', NULL, NULL, 5490, 9),
(254841, NULL, 'PF15621', NULL, NULL, 'Proline-rich submaxillary gland androgen-regulated family', NULL, 'PROL5-SMR', NULL, NULL, 22633, 9),
(254842, NULL, 'PF04157', NULL, NULL, 'EAP30/Vps36 family', NULL, 'EAP30', NULL, NULL, 27837, 9),
(254843, NULL, 'PF11275', NULL, NULL, 'Protein of unknown function (DUF3077)', NULL, 'DUF3077', NULL, NULL, 18029, 9),
(254844, NULL, 'PF11797', NULL, NULL, 'Protein of unknown function C-terminal (DUF3324)', NULL, 'DUF3324', NULL, NULL, 19082, 9),
(254845, NULL, 'PF18310', NULL, NULL, 'Domain of unknown function (DUF5605)', NULL, 'DUF5605', NULL, NULL, 30477, 9),
(254846, NULL, 'PF20078', NULL, NULL, 'Domain of unknown function (DUF6473)', NULL, 'DUF6473', NULL, NULL, 35981, 9),
(254847, NULL, 'PF00386', NULL, NULL, 'C1q domain', NULL, 'C1q', NULL, NULL, 2032, 9),
(254848, NULL, 'PF02021', NULL, NULL, 'Uncharacterised protein family UPF0102', NULL, 'UPF0102', NULL, NULL, 6225, 9),
(254849, NULL, 'PF18058', NULL, NULL, 'SbsC C-terminal domain', NULL, 'SbsC_C', NULL, NULL, 29396, 9),
(254850, NULL, 'PF04056', NULL, NULL, 'Ssl1-like', NULL, 'Ssl1', NULL, NULL, 1393, 9),
(254851, NULL, 'PF08384', NULL, NULL, 'Pro-opiomelanocortin, N-terminal region', NULL, 'NPP', NULL, NULL, 11868, 9),
(254852, NULL, 'PF19644', NULL, NULL, 'Family of unknown function (DUF6147)', NULL, 'DUF6147', NULL, NULL, 37377, 9),
(254853, NULL, 'PF20343', NULL, NULL, 'Family of unknown function (DUF6638)', NULL, 'DUF6638', NULL, NULL, 33989, 9),
(254854, NULL, 'PF09002', NULL, NULL, 'Domain of unknown function (DUF1887)', NULL, 'DUF1887', NULL, NULL, 8803, 9),
(254855, NULL, 'PF05525', NULL, NULL, 'Branched-chain amino acid transport protein', NULL, 'Branch_AA_trans', NULL, NULL, 3192, 9);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(254856, NULL, 'PF08000', NULL, NULL, 'Bacterial PH domain', NULL, 'bPH_1', NULL, NULL, 8875, 9),
(254857, NULL, 'PF15691', NULL, NULL, 'Protein phosphatase 1 regulatory subunit 32', NULL, 'PPP1R32', NULL, NULL, 24514, 9),
(254858, NULL, 'PF00924', NULL, NULL, 'Mechanosensitive ion channel', NULL, 'MS_channel', NULL, NULL, 2322, 9),
(254859, NULL, 'PF20503', NULL, NULL, 'Family of unknown function (DUF6730)', NULL, 'DUF6730', NULL, NULL, 33610, 9),
(254860, NULL, 'PF13347', NULL, NULL, 'MFS/sugar transport protein', NULL, 'MFS_2', NULL, NULL, NULL, 9),
(254861, NULL, 'PF16309', NULL, NULL, 'Domian of unknown function (DUF4951)', NULL, 'DUF4951', NULL, NULL, 25674, 9),
(254862, NULL, 'PF05400', NULL, NULL, 'Flagellar protein FliT', NULL, 'FliT', NULL, NULL, 14410, 9),
(254863, NULL, 'PF13481', NULL, NULL, 'AAA domain', NULL, 'AAA_25', NULL, NULL, NULL, 9),
(254864, NULL, 'PF04896', NULL, NULL, 'Ammonia monooxygenase/methane monooxygenase, subunit C', NULL, 'AmoC', NULL, NULL, 5812, 9),
(254865, NULL, 'PF06628', NULL, NULL, 'Catalase-related immune-responsive', NULL, 'Catalase-rel', NULL, NULL, 8079, 9),
(254866, NULL, 'PF13676', NULL, NULL, 'TIR domain', NULL, 'TIR_2', NULL, NULL, 1854, 9),
(254867, NULL, 'PF10590', NULL, NULL, 'Pyridoxine 5''-phosphate oxidase C-terminal dimerisation region', NULL, 'PNP_phzG_C', NULL, NULL, 20085, 9),
(254868, NULL, 'PF14928', NULL, NULL, 'Short tail fibre protein receptor-binding domain', NULL, 'S_tail_recep_bd', NULL, NULL, 24912, 9),
(254869, NULL, 'PF12511', NULL, NULL, 'Protein of unknown function (DUF3716)', NULL, 'DUF3716', NULL, NULL, 21386, 9),
(254870, NULL, 'PF07851', NULL, NULL, 'TMPIT-like protein', NULL, 'TMPIT', NULL, NULL, 7594, 9),
(254871, NULL, 'PF01048', NULL, NULL, 'Phosphorylase superfamily', NULL, 'PNP_UDP_1', NULL, NULL, 134, 9),
(254872, NULL, 'PF13362', NULL, NULL, 'Toprim domain', NULL, 'Toprim_3', NULL, NULL, 11269, 9),
(254873, NULL, 'PF03361', NULL, NULL, 'Herpes virus intermediate/early protein 2/3', NULL, 'Herpes_IE2_3', NULL, NULL, 1458, 9),
(254874, NULL, 'PF09738', NULL, NULL, 'LRRFIP family', NULL, 'LRRFIP', NULL, NULL, 17769, 9),
(254875, NULL, 'PF15922', NULL, NULL, 'YjeJ-like', NULL, 'YjeJ', NULL, NULL, 25931, 9),
(254876, NULL, 'PF01030', NULL, NULL, 'Receptor L domain', NULL, 'Recep_L_domain', NULL, NULL, 6976, 9),
(254877, NULL, 'PF15177', NULL, NULL, 'Interleukin-28A', NULL, 'IL28A', NULL, NULL, 21765, 9),
(254878, NULL, 'PF18623', NULL, NULL, 'TnsE C-terminal domain', NULL, 'TnsE_C', NULL, NULL, 30585, 9),
(254879, NULL, 'PF12590', NULL, NULL, 'Acyl-ATP thioesterase', NULL, 'Acyl-thio_N', NULL, NULL, 19658, 9),
(254880, NULL, 'PF07902', NULL, NULL, 'gp58-like protein', NULL, 'Gp58', NULL, NULL, 13235, 9),
(254881, NULL, 'PF00804', NULL, NULL, 'Syntaxin', NULL, 'Syntaxin', NULL, NULL, 1071, 9),
(254882, NULL, 'PF01220', NULL, NULL, 'Dehydroquinase class II', NULL, 'DHquinase_II', NULL, NULL, 4460, 9),
(254883, NULL, 'PF08366', NULL, NULL, 'LLGL2', NULL, 'LLGL', NULL, NULL, 11555, 9),
(254884, NULL, 'PF11702', NULL, NULL, 'Protein of unknown function (DUF3295)', NULL, 'DUF3295', NULL, NULL, 19486, 9),
(254885, NULL, 'PF08643', NULL, NULL, 'Fungal family of unknown function (DUF1776)', NULL, 'DUF1776', NULL, NULL, 7806, 9),
(254886, NULL, 'PF11804', NULL, NULL, 'Protein of unknown function (DUF3325)', NULL, 'DUF3325', NULL, NULL, 19337, 9),
(254887, NULL, 'PF09508', NULL, NULL, 'Lacto-N-biose phosphorylase N-terminal TIM barrel domain', NULL, 'Lact_bio_phlase', NULL, NULL, 7223, 9),
(254888, NULL, 'PF14253', NULL, NULL, 'Bacteriophage abortive infection AbiH', NULL, 'AbiH', NULL, NULL, 23145, 9),
(254889, NULL, 'PF04593', NULL, NULL, 'Selenoprotein P, C terminal region', NULL, 'SelP_C', NULL, NULL, 770, 9),
(254890, NULL, 'PF18637', NULL, NULL, 'Aldos-2-ulose dehydratase/isomerase (AUDH) Cupin domain', NULL, 'AUDH_Cupin', NULL, NULL, 32201, 9),
(254891, NULL, 'PF03504', NULL, NULL, 'Chlamydia cysteine-rich outer membrane protein 6', NULL, 'Chlam_OMP6', NULL, NULL, 6499, 9),
(254892, NULL, 'PF05793', NULL, NULL, 'Transcription initiation factor IIF, alpha subunit (TFIIF-alpha)', NULL, 'TFIIF_alpha', NULL, NULL, 13641, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(254893, NULL, 'PF14613', NULL, NULL, 'Protein of unknown function (DUF4449)', NULL, 'DUF4449', NULL, NULL, 26394, 9),
(254894, NULL, 'PF09235', NULL, NULL, 'Ste50p, sterile alpha motif', NULL, 'SAM_Ste50p', NULL, NULL, 13070, 9),
(254895, NULL, 'PF16018', NULL, NULL, 'Anillin N-terminus', NULL, 'Anillin_N', NULL, NULL, 22773, 9),
(254896, NULL, 'PF15491', NULL, NULL, 'CST, telomere maintenance, complex subunit CTC1', NULL, 'CTC1_2', NULL, NULL, 26516, 9),
(254897, NULL, 'PF03208', NULL, NULL, 'PRA1 family protein', NULL, 'PRA1', NULL, NULL, 90, 9),
(254898, NULL, 'PF14729', NULL, NULL, 'Domain of unknown function with cystatin-like fold (DUF4467)', NULL, 'DUF4467', NULL, NULL, 23282, 9),
(254899, NULL, 'PF15508', NULL, NULL, 'beta subunit of N-acylethanolamine-hydrolyzing acid amidase', NULL, 'NAAA-beta', NULL, NULL, 23717, 9),
(254900, NULL, 'PF13752', NULL, NULL, 'Domain of unknown function (DUF4165)', NULL, 'DUF4165', NULL, NULL, 22123, 9),
(254901, NULL, 'PF11738', NULL, NULL, 'Protein of unknown function (DUF3298)', NULL, 'DUF3298', NULL, NULL, 19124, 9),
(254902, NULL, 'PF13164', NULL, NULL, 'Diedel', NULL, 'Diedel', NULL, NULL, 22816, 9),
(254903, NULL, 'PF15301', NULL, NULL, 'SLAIN motif-containing family', NULL, 'SLAIN', NULL, NULL, 25150, 9),
(254904, NULL, 'PF12890', NULL, NULL, 'Dihydro-orotase-like', NULL, 'DHOase', NULL, NULL, 23560, 9),
(254905, NULL, 'PF15002', NULL, NULL, 'ERK and JNK pathways, inhibitor', NULL, 'ERK-JNK_inhib', NULL, NULL, 25788, 9),
(254906, NULL, 'PF15094', NULL, NULL, 'Domain of unknown function (DUF4556)', NULL, 'DUF4556', NULL, NULL, 24190, 9),
(254907, NULL, 'PF19577', NULL, NULL, 'DcaP outer membrane protein', NULL, 'DcaP', NULL, NULL, 36101, 9),
(254908, NULL, 'PF04587', NULL, NULL, 'ADP-specific Phosphofructokinase/Glucokinase conserved region', NULL, 'ADP_PFK_GK', NULL, NULL, 147, 9),
(254909, NULL, 'PF14137', NULL, NULL, 'Domain of unknown function (DUF4304)', NULL, 'DUF4304', NULL, NULL, 26290, 9),
(254910, NULL, 'PF18562', NULL, NULL, 'Cysteine-Rich Interdomain Region 1 gamma', NULL, 'CIDR1_gamma', NULL, NULL, 29015, 9),
(254911, NULL, 'PF12668', NULL, NULL, 'Protein of unknown function (DUF3791)', NULL, 'DUF3791', NULL, NULL, 20140, 9),
(254912, NULL, 'PF01577', NULL, NULL, 'Potyvirus P1 protease', NULL, 'Peptidase_S30', NULL, NULL, 1873, 9),
(254913, NULL, 'PF12722', NULL, NULL, 'High-temperature-induced dauer-formation protein', NULL, 'Hid1', NULL, NULL, 24444, 9),
(254914, NULL, 'PF11671', NULL, NULL, 'Complementary sex determiner protein', NULL, 'Apis_Csd', NULL, NULL, 15263, 9),
(254915, NULL, 'PF04333', NULL, NULL, 'MlaA lipoprotein', NULL, 'MlaA', NULL, NULL, 3927, 9),
(254916, NULL, 'PF17423', NULL, NULL, 'Swarming motility protein', NULL, 'SwrA', NULL, NULL, 14756, 9),
(254917, NULL, 'PF03729', NULL, NULL, 'Short repeat of unknown function (DUF308)', NULL, 'DUF308', NULL, NULL, 5906, 9),
(254918, NULL, 'PF09016', NULL, NULL, 'Pas factor saposin fold', NULL, 'Pas_Saposin', NULL, NULL, 9787, 9),
(254919, NULL, 'PF12518', NULL, NULL, 'Protein of unknown function', NULL, 'DUF3721', NULL, NULL, 21373, 9),
(254920, NULL, 'PF16368', NULL, NULL, 'Cytoplasmic polyadenylation element-binding protein 1 N-terminus', NULL, 'CEBP1_N', NULL, NULL, 23580, 9),
(254921, NULL, 'PF08670', NULL, NULL, 'MEKHLA domain', NULL, 'MEKHLA', NULL, NULL, 7777, 9),
(254922, NULL, 'PF08764', NULL, NULL, 'Staphylococcus aureus coagulase', NULL, 'Coagulase', NULL, NULL, 13242, 9),
(254923, NULL, 'PF15697', NULL, NULL, 'Domain of unknown function (DUF4666)', NULL, 'DUF4666', NULL, NULL, 25592, 9),
(254924, NULL, 'PF14414', NULL, NULL, 'A nuclease of the HNH/ENDO VII superfamily with conserved WHH', NULL, 'WHH', NULL, NULL, 25488, 9),
(254925, NULL, 'PF11134', NULL, NULL, 'Phage stabilisation protein', NULL, 'Phage_stabilise', NULL, NULL, 15299, 9),
(254926, NULL, 'PF02076', NULL, NULL, 'Pheromone A receptor', NULL, 'STE3', NULL, NULL, 6260, 9),
(254927, NULL, 'PF20053', NULL, NULL, 'Wolframin cysteine-rich domain', NULL, 'WC-rich', NULL, NULL, 35752, 9),
(254928, NULL, 'PF06097', NULL, NULL, 'Bacterial protein of unknown function (DUF945)', NULL, 'DUF945', NULL, NULL, 8665, 9);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(254929, NULL, 'PF13375', NULL, NULL, 'RnfC Barrel sandwich hybrid domain', NULL, 'RnfC_N', NULL, NULL, 26665, 9),
(254930, NULL, 'PF10824', NULL, NULL, 'Excreted virulence factor EspC, type VII ESX diderm', NULL, 'T7SS_ESX_EspC', NULL, NULL, 16158, 9),
(254931, NULL, 'PF15258', NULL, NULL, 'Protein family of FAM222A', NULL, 'FAM222A', NULL, NULL, 23521, 9),
(254932, NULL, 'PF02206', NULL, NULL, 'Domain of unknown function', NULL, 'WSN', NULL, NULL, 2804, 9),
(254933, NULL, 'PF19653', NULL, NULL, 'Family of unknown function (DUF6156)', NULL, 'DUF6156', NULL, NULL, 37043, 9),
(254934, NULL, 'PF11090', NULL, NULL, 'Bacteriophage T7, probable scaffold protein Gp13', NULL, 'Phage_T7_Gp13', NULL, NULL, 20832, 9),
(254935, NULL, 'PF00498', NULL, NULL, 'FHA domain', NULL, 'FHA', NULL, NULL, 4899, 9),
(254936, NULL, 'PF05698', NULL, NULL, 'Bacterial trigger factor protein (TF) C-terminus', NULL, 'Trigger_C', NULL, NULL, 7679, 9),
(254937, NULL, 'PF05651', NULL, NULL, 'Putative sugar diacid recognition', NULL, 'Diacid_rec', NULL, NULL, 14324, 9),
(254938, NULL, 'PF08316', NULL, NULL, 'Pal1 cell morphology protein', NULL, 'Pal1', NULL, NULL, 12181, 9),
(254939, NULL, 'PF04516', NULL, NULL, 'CP2 transcription factor', NULL, 'CP2', NULL, NULL, 2678, 9),
(254940, NULL, 'PF11488', NULL, NULL, 'Transcriptional regulatory protein LGE1', NULL, 'Lge1', NULL, NULL, NULL, 9),
(254941, NULL, 'PF13642', NULL, NULL, 'protein structure with unknown function', NULL, 'DUF4144', NULL, NULL, 23046, 9),
(254942, NULL, 'PF01880', NULL, NULL, 'Desulfoferrodoxin', NULL, 'Desulfoferrodox', NULL, NULL, 3681, 9),
(254943, NULL, 'PF04732', NULL, NULL, 'Intermediate filament head (DNA binding) region', NULL, 'Filament_head', NULL, NULL, 3737, 9),
(254944, NULL, 'PF00729', NULL, NULL, 'Viral coat protein (S domain)', NULL, 'Viral_coat', NULL, NULL, 408, 9),
(254945, NULL, 'PF09362', NULL, NULL, 'Domain of unknown function (DUF1996)', NULL, 'DUF1996', NULL, NULL, 14809, 9),
(254946, NULL, 'PF11295', NULL, NULL, 'Protein of unknown function (DUF3096)', NULL, 'DUF3096', NULL, NULL, 18155, 9),
(254947, NULL, 'PF00488', NULL, NULL, 'MutS domain V', NULL, 'MutS_V', NULL, NULL, 4830, 9),
(254948, NULL, 'PF01731', NULL, NULL, 'Arylesterase', NULL, 'Arylesterase', NULL, NULL, 2567, 9),
(254949, NULL, 'PF19001', NULL, NULL, 'Family of unknown function (DUF5730)', NULL, 'DUF5730', NULL, NULL, 35619, 9),
(254950, NULL, 'PF01514', NULL, NULL, 'Secretory protein of YscJ/FliF family', NULL, 'YscJ_FliF', NULL, NULL, 11428, 9),
(254951, NULL, 'PF19041', NULL, NULL, 'Nuclear cap binding complex subunit CBP30', NULL, 'CBP30', NULL, NULL, 34316, 9),
(254952, NULL, 'PF03181', NULL, NULL, 'BURP domain', NULL, 'BURP', NULL, NULL, 7494, 9),
(254953, NULL, 'PF05199', NULL, NULL, 'GMC oxidoreductase', NULL, 'GMC_oxred_C', NULL, NULL, 3165, 9),
(254954, NULL, 'PF15816', NULL, NULL, 'Transmembrane protein 82', NULL, 'TMEM82', NULL, NULL, 23509, 9),
(254955, NULL, 'PF07466', NULL, NULL, 'Protein of unknown function (DUF1517)', NULL, 'DUF1517', NULL, NULL, 12387, 9),
(254956, NULL, 'PF17741', NULL, NULL, 'Family of unknown function (DUF5578)', NULL, 'DUF5578', NULL, NULL, 29488, 9),
(254957, NULL, 'PF19676', NULL, NULL, 'Family of unknown function (DUF6178)', NULL, 'DUF6178', NULL, NULL, 36054, 9),
(254958, NULL, 'PF02797', NULL, NULL, 'Chalcone and stilbene synthases, C-terminal domain', NULL, 'Chal_sti_synt_C', NULL, NULL, 12241, 9),
(254959, NULL, 'PF06637', NULL, NULL, 'PV-1 protein (PLVAP)', NULL, 'PV-1', NULL, NULL, 10160, 9),
(254960, NULL, 'PF17432', NULL, NULL, 'Domain of unknown function (DUF3458_C) ARM repeats', NULL, 'DUF3458_C', NULL, NULL, 26720, 9),
(254961, NULL, 'PF14252', NULL, NULL, 'Domain of unknown function (DUF4347)', NULL, 'DUF4347', NULL, NULL, 26424, 9),
(254962, NULL, 'PF07226', NULL, NULL, 'Protein of unknown function (DUF1422)', NULL, 'DUF1422', NULL, NULL, 14309, 9),
(254963, NULL, 'PF08355', NULL, NULL, 'EF hand associated', NULL, 'EF_assoc_1', NULL, NULL, 12601, 9),
(254964, NULL, 'PF00986', NULL, NULL, 'DNA gyrase B subunit, carboxyl terminus', NULL, 'DNA_gyraseB_C', NULL, NULL, 339, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(254965, NULL, 'PF11941', NULL, NULL, 'Domain of unknown function (DUF3459)', NULL, 'DUF3459', NULL, NULL, 16033, 9),
(254966, NULL, 'PF02079', NULL, NULL, 'Nuclear transition protein 1', NULL, 'TP1', NULL, NULL, 2207, 9),
(254967, NULL, 'PF11824', NULL, NULL, 'Protein of unknown function (DUF3344)', NULL, 'DUF3344', NULL, NULL, 19078, 9),
(254968, NULL, 'PF02621', NULL, NULL, 'Menaquinone biosynthesis', NULL, 'VitK2_biosynth', NULL, NULL, 2869, 9),
(254969, NULL, 'PF16514', NULL, NULL, 'putative NADH-ubiquinone oxidoreductase chain E', NULL, 'NADH-UOR_E', NULL, NULL, 23467, 9),
(254970, NULL, 'PF03732', NULL, NULL, 'Retrotransposon gag protein', NULL, 'Retrotrans_gag', NULL, NULL, 4652, 9),
(254971, NULL, 'PF18672', NULL, NULL, 'N-terminal PilZ-like domain PilZN1', NULL, 'PilZN1', NULL, NULL, 28181, 9),
(254972, NULL, 'PF09535', NULL, NULL, 'Protein of unknown function (Gmx_para_CXXCG)', NULL, 'Gmx_para_CXXCG', NULL, NULL, 11574, 9),
(254973, NULL, 'PF14108', NULL, NULL, 'ABA DEFICIENT 4-like', NULL, 'ABA4-like', NULL, NULL, 22314, 9),
(254974, NULL, 'PF06955', NULL, NULL, 'Xyloglucan endo-transglycosylase (XET) C-terminus', NULL, 'XET_C', NULL, NULL, 9929, 9),
(254975, NULL, 'PF13137', NULL, NULL, 'Protein of unknown function (DUF3983)', NULL, 'DUF3983', NULL, NULL, 22153, 9),
(254976, NULL, 'PF16436', NULL, NULL, 'Domain of unknown function (DUF5033)', NULL, 'DUF5033', NULL, NULL, 24177, 9),
(254977, NULL, 'PF15911', NULL, NULL, 'WD domain, G-beta repeat', NULL, 'WD40_3', NULL, NULL, 33323, 9),
(254978, NULL, 'PF03726', NULL, NULL, 'Polyribonucleotide nucleotidyltransferase, RNA binding domain', NULL, 'PNPase', NULL, NULL, 9175, 9),
(254979, NULL, 'PF06054', NULL, NULL, 'Competence protein CoiA-like family', NULL, 'CoiA', NULL, NULL, 8854, 9),
(254980, NULL, 'PF19889', NULL, NULL, 'Domain of unknown function (DUF6362)', NULL, 'DUF6362', NULL, NULL, 36611, 9),
(254981, NULL, 'PF03797', NULL, NULL, 'Autotransporter beta-domain', NULL, 'Autotransporter', NULL, NULL, 1528, 9),
(254982, NULL, 'PF07626', NULL, NULL, 'Protein of unknown function (DUF1587)', NULL, 'PSD3', NULL, NULL, 12864, 9),
(254983, NULL, 'PF09145', NULL, NULL, 'Ubiquitin-associated', NULL, 'Ubiq-assoc', NULL, NULL, 10896, 9),
(254984, NULL, 'PF09556', NULL, NULL, 'HaeIII restriction endonuclease', NULL, 'RE_HaeIII', NULL, NULL, 16681, 9),
(254985, NULL, 'PF15876', NULL, NULL, 'Domain of unknown function (DUF4732)', NULL, 'DUF4732', NULL, NULL, 23823, 9),
(254986, NULL, 'PF06261', NULL, NULL, 'Actinobacillus actinomycetemcomitans leukotoxin activator LktC', NULL, 'LktC', NULL, NULL, 14319, 9),
(254987, NULL, 'PF19779', NULL, NULL, 'Family of unknown function (DUF6264)', NULL, 'DUF6264', NULL, NULL, 37402, 9),
(254988, NULL, 'PF02084', NULL, NULL, 'Bindin', NULL, 'Bindin', NULL, NULL, 4065, 9),
(254989, NULL, 'PF14319', NULL, NULL, 'Transposase zinc-binding domain', NULL, 'Zn_Tnp_IS91', NULL, NULL, 26698, 9),
(254990, NULL, 'PF07311', NULL, NULL, 'Dodecin', NULL, 'Dodecin', NULL, NULL, 8377, 9),
(254991, NULL, 'PF03009', NULL, NULL, 'Glycerophosphoryl diester phosphodiesterase family', NULL, 'GDPD', NULL, NULL, 21882, 9),
(254992, NULL, 'PF15359', NULL, NULL, 'Carnitine deficiency-associated protein 3', NULL, 'CDV3', NULL, NULL, 22044, 9),
(254993, NULL, 'PF19261', NULL, NULL, 'Domain of unknown function (DUF5904)', NULL, 'DUF5904', NULL, NULL, 32968, 9),
(254994, NULL, 'PF03630', NULL, NULL, 'Fumble', NULL, 'Fumble', NULL, NULL, 784, 9),
(254995, NULL, 'PF17100', NULL, NULL, 'N-terminal domain of NWD NACHT-NTPase', NULL, 'NACHT_N', NULL, NULL, 7452, 9),
(254996, NULL, 'PF13699', NULL, NULL, 'Domain of unknown function (DUF4157)', NULL, 'DUF4157', NULL, NULL, 23025, 9),
(254997, NULL, 'PF15152', NULL, NULL, 'Kisspeptin', NULL, 'Kisspeptin', NULL, NULL, 18947, 9),
(254998, NULL, 'PF02698', NULL, NULL, 'DUF218 domain', NULL, 'DUF218', NULL, NULL, 3294, 9),
(254999, NULL, 'PF09573', NULL, NULL, 'TaqI restriction endonuclease', NULL, 'RE_TaqI', NULL, NULL, 16982, 9),
(255000, NULL, 'PF00944', NULL, NULL, 'Alphavirus core protein', NULL, 'Peptidase_S3', NULL, NULL, 3051, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(255001, NULL, 'PF11281', NULL, NULL, 'Protein of unknown function (DUF3083)', NULL, 'DUF3083', NULL, NULL, 18458, 9),
(255002, NULL, 'PF00505', NULL, NULL, 'HMG (high mobility group) box', NULL, 'HMG_box', NULL, NULL, 6233, 9),
(255003, NULL, 'PF16834', NULL, NULL, 'Shu complex component Csm2, DNA-binding', NULL, 'CSM2', NULL, NULL, 21935, 9),
(255004, NULL, 'PF11319', NULL, NULL, 'Type VI secretion system VasI, EvfG, VC_A0118', NULL, 'VasI', NULL, NULL, 18406, 9),
(255005, NULL, 'PF02485', NULL, NULL, 'Core-2/I-Branching enzyme', NULL, 'Branch', NULL, NULL, 5386, 9),
(255006, NULL, 'PF08449', NULL, NULL, 'UAA transporter family', NULL, 'UAA', NULL, NULL, 11953, 9),
(255007, NULL, 'PF04849', NULL, NULL, 'HAP1 N-terminal conserved region', NULL, 'HAP1_N', NULL, NULL, 5332, 9),
(255008, NULL, 'PF03303', NULL, NULL, 'WTF protein', NULL, 'WTF', NULL, NULL, 627, 9),
(255009, NULL, 'PF13287', NULL, NULL, 'Fn3 associated', NULL, 'Fn3_assoc', NULL, NULL, 26618, 9),
(255010, NULL, 'PF14442', NULL, NULL, 'Bd3614-like deaminase N-terminal', NULL, 'Bd3614_N', NULL, NULL, 24354, 9),
(255011, NULL, 'PF08883', NULL, NULL, 'Dopa 4,5-dioxygenase family', NULL, 'DOPA_dioxygen', NULL, NULL, 14391, 9),
(255012, NULL, 'PF15656', NULL, NULL, 'Toxin with a H, D/N and C signature', NULL, 'Tox-HDC', NULL, NULL, 24769, 9),
(255013, NULL, 'PF07869', NULL, NULL, 'Protein of unknown function (DUF1656)', NULL, 'DUF1656', NULL, NULL, 14186, 9),
(255014, NULL, 'PF13122', NULL, NULL, 'Protein of unknown function (DUF3977)', NULL, 'DUF3977', NULL, NULL, 25860, 9),
(255015, NULL, 'PF08691', NULL, NULL, 'DNA repair proteins Nse5 and Nse6', NULL, 'Nse5', NULL, NULL, 11796, 9),
(255016, NULL, 'PF10971', NULL, NULL, 'Protein of unknown function (DUF2773)', NULL, 'DUF2773', NULL, NULL, 24376, 9),
(255017, NULL, 'PF02293', NULL, NULL, 'AmiS/UreI family transporter', NULL, 'AmiS_UreI', NULL, NULL, 2096, 9),
(255018, NULL, 'PF14907', NULL, NULL, 'Uncharacterised nucleotidyltransferase', NULL, 'NTP_transf_5', NULL, NULL, 28574, 9),
(255019, NULL, 'PF08664', NULL, NULL, 'YcbB domain', NULL, 'YcbB', NULL, NULL, 7919, 9),
(255020, NULL, 'PF16770', NULL, NULL, 'Regulator of Ty1 transposition protein 107 BRCT domain', NULL, 'RTT107_BRCT_5', NULL, NULL, 7483, 9),
(255021, NULL, 'PF03284', NULL, NULL, 'Phenazine biosynthesis protein A/B', NULL, 'PHZA_PHZB', NULL, NULL, 2836, 9),
(255022, NULL, 'PF17184', NULL, NULL, 'Rit1 N-terminal domain', NULL, 'Rit1_C', NULL, NULL, 32110, 9),
(255023, NULL, 'PF08723', NULL, NULL, 'Gag protein p15', NULL, 'Gag_p15', NULL, NULL, 11790, 9),
(255024, NULL, 'PF10294', NULL, NULL, 'Lysine methyltransferase', NULL, 'Methyltransf_16', NULL, NULL, 16800, 9),
(255025, NULL, 'PF06570', NULL, NULL, 'Protein of unknown function (DUF1129)', NULL, 'DUF1129', NULL, NULL, 10318, 9),
(255026, NULL, 'PF04004', NULL, NULL, 'Leo1-like protein', NULL, 'Leo1', NULL, NULL, 156, 9),
(255027, NULL, 'PF10036', NULL, NULL, 'RNA transcription, translation and transport factor protein', NULL, 'RLL', NULL, NULL, 19539, 9),
(255028, NULL, 'PF04780', NULL, NULL, 'Protein of unknown function (DUF629)', NULL, 'DUF629', NULL, NULL, 4248, 9),
(255029, NULL, 'PF20059', NULL, NULL, 'Domain of unknown function (DUF6458)', NULL, 'DUF6458', NULL, NULL, 36430, 9),
(255030, NULL, 'PF04425', NULL, NULL, 'Bul1 N terminus', NULL, 'Bul1_N', NULL, NULL, 10611, 9),
(255031, NULL, 'PF13253', NULL, NULL, 'Protein of unknown function (DUF4044)', NULL, 'DUF4044', NULL, NULL, 25737, 9),
(255032, NULL, 'PF15244', NULL, NULL, 'Spermatogenesis-associated protein 7, or HSD3', NULL, 'HSD3', NULL, NULL, 26155, 9),
(255033, NULL, 'PF13477', NULL, NULL, 'Glycosyl transferase 4-like', NULL, 'Glyco_trans_4_2', NULL, NULL, 24508, 9),
(255034, NULL, 'PF14199', NULL, NULL, 'Domain of unknown function (DUF4317)', NULL, 'DUF4317', NULL, NULL, 26329, 9),
(255035, NULL, 'PF13782', NULL, NULL, 'Stage V sporulation protein AB', NULL, 'SpoVAB', NULL, NULL, 13541, 9),
(255036, NULL, 'PF05474', NULL, NULL, 'Semenogelin', NULL, 'Semenogelin', NULL, NULL, 13537, 9),
(255037, NULL, 'PF05680', NULL, NULL, 'ATP synthase E chain', NULL, 'ATP-synt_E', NULL, NULL, 7861, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(255038, NULL, 'PF04080', NULL, NULL, 'Per1-like family', NULL, 'Per1', NULL, NULL, 6118, 9),
(255039, NULL, 'PF11960', NULL, NULL, 'Domain of unknown function (DUF3474)', NULL, 'DUF3474', NULL, NULL, 19647, 9),
(255040, NULL, 'PF05232', NULL, NULL, 'Chlorhexidine efflux transporter', NULL, 'BTP', NULL, NULL, 3091, 9),
(255041, NULL, 'PF11705', NULL, NULL, 'DNA-directed RNA polymerase III subunit Rpc31', NULL, 'RNA_pol_3_Rpc31', NULL, NULL, 21219, 9),
(255042, NULL, 'PF16742', NULL, NULL, 'N-terminus of interleukin 17 receptor D', NULL, 'IL17R_D_N', NULL, NULL, 22715, 9),
(255043, NULL, 'PF08638', NULL, NULL, 'Mediator complex subunit MED14', NULL, 'Med14', NULL, NULL, 7580, 9),
(255044, NULL, 'PF01957', NULL, NULL, 'NfeD-like C-terminal, partner-binding', NULL, 'NfeD', NULL, NULL, 4672, 9),
(255045, NULL, 'PF09286', NULL, NULL, 'Pro-kumamolisin, activation domain', NULL, 'Pro-kuma_activ', NULL, NULL, 14162, 9),
(255046, NULL, 'PF02446', NULL, NULL, '4-alpha-glucanotransferase', NULL, 'Glyco_hydro_77', NULL, NULL, 4483, 9),
(255047, NULL, 'PF19236', NULL, NULL, 'ADAMTS cysteine-rich domain', NULL, 'ADAMTS_CR_3', NULL, NULL, 37109, 9),
(255048, NULL, 'PF16517', NULL, NULL, 'Novel Ras effector 1 C-terminal SARAH (Sav/Rassf/Hpo) domain', NULL, 'Nore1-SARAH', NULL, NULL, 12078, 9),
(255049, NULL, 'PF18436', NULL, NULL, 'Helical box domain of E3 ubiquitin-protein ligase HECW1', NULL, 'HECW1_helix', NULL, NULL, 31594, 9),
(255050, NULL, 'PF04277', NULL, NULL, 'Oxaloacetate decarboxylase, gamma chain', NULL, 'OAD_gamma', NULL, NULL, 6583, 9),
(255051, NULL, 'PF14147', NULL, NULL, 'Sporulation protein YhaL', NULL, 'Spore_YhaL', NULL, NULL, 26246, 9),
(255052, NULL, 'PF11818', NULL, NULL, 'C-terminal domain of tail specific protease (DUF3340)', NULL, 'DUF3340', NULL, NULL, 14593, 9),
(255053, NULL, 'PF17245', NULL, NULL, 'Cell division control protein 24, OB domain 2', NULL, 'CDC24_OB2', NULL, NULL, 8724, 9),
(255054, NULL, 'PF16379', NULL, NULL, 'Domain of unknown function (DUF4989)', NULL, 'DUF4989', NULL, NULL, 22428, 9),
(255055, NULL, 'PF01790', NULL, NULL, 'Prolipoprotein diacylglyceryl transferase', NULL, 'LGT', NULL, NULL, 3232, 9),
(255056, NULL, 'PF01877', NULL, NULL, 'RNA binding', NULL, 'RNA_binding', NULL, NULL, 3797, 9),
(255057, NULL, 'PF05413', NULL, NULL, 'Putative closterovirus papain-like endopeptidase', NULL, 'Peptidase_C34', NULL, NULL, 12052, 9),
(255058, NULL, 'PF18089', NULL, NULL, 'DAPG hydrolase PhiG domain', NULL, 'DAPG_hydrolase', NULL, NULL, 29814, 9),
(255059, NULL, 'PF18401', NULL, NULL, 'Thioredoxin-like domain', NULL, 'Thioredoxin_13', NULL, NULL, 28538, 9),
(255060, NULL, 'PF15265', NULL, NULL, 'FAM196 family', NULL, 'FAM196', NULL, NULL, 23638, 9),
(255061, NULL, 'PF01426', NULL, NULL, 'BAH domain', NULL, 'BAH', NULL, NULL, 1219, 9),
(255062, NULL, 'PF10354', NULL, NULL, 'rRNA (uridine-N3-)-methyltransferase BTM5-like', NULL, 'BMT5-like', NULL, NULL, 17015, 9),
(255063, NULL, 'PF12301', NULL, NULL, 'CD99 antigen like protein 2', NULL, 'CD99L2', NULL, NULL, 20659, 9),
(255064, NULL, 'PF15196', NULL, NULL, 'Activator of apoptosis harakiri', NULL, 'Harakiri', NULL, NULL, 15833, 9),
(255065, NULL, 'PF15370', NULL, NULL, 'NOP protein chaperone 1', NULL, 'NOPCHAP1', NULL, NULL, 23159, 9),
(255066, NULL, 'PF02108', NULL, NULL, 'Flagellar assembly protein FliH', NULL, 'FliH', NULL, NULL, 16884, 9),
(255067, NULL, 'PF01359', NULL, NULL, 'Transposase (partial DDE domain)', NULL, 'Transposase_1', NULL, NULL, 4047, 9),
(255068, NULL, 'PF16868', NULL, NULL, 'NMT1-like family', NULL, 'NMT1_3', NULL, NULL, 13728, 9),
(255069, NULL, 'PF10009', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2252)', NULL, 'DUF2252', NULL, NULL, 17231, 9),
(255070, NULL, 'PF17410', NULL, NULL, 'Subtelomeric Variable Open Reading frame', NULL, 'Stevor', NULL, NULL, 5968, 9),
(255071, NULL, 'PF00598', NULL, NULL, 'Influenza Matrix protein (M1)', NULL, 'Flu_M1', NULL, NULL, 5176, 9),
(255072, NULL, 'PF11802', NULL, NULL, 'Centromere-associated protein K', NULL, 'CENP-K', NULL, NULL, 14696, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(255073, NULL, 'PF04181', NULL, NULL, 'Rtr1/RPAP2 family', NULL, 'RPAP2_Rtr1', NULL, NULL, 4792, 9),
(255074, NULL, 'PF16095', NULL, NULL, 'C-terminal of Roc, COR, domain', NULL, 'COR', NULL, NULL, 23967, 9),
(255075, NULL, 'PF09092', NULL, NULL, 'Lyase, N terminal', NULL, 'Lyase_N', NULL, NULL, 10785, 9),
(255076, NULL, 'PF20418', NULL, NULL, 'Alphaherpesvirus glycoprotein E N-terminal', NULL, 'Herpes_gE_N', NULL, NULL, 37707, 9),
(255077, NULL, 'PF06870', NULL, NULL, 'A49-like RNA polymerase I associated factor', NULL, 'RNA_pol_I_A49', NULL, NULL, 11941, 9),
(255078, NULL, 'PF11432', NULL, NULL, 'Protein of unknown function (DUF3197)', NULL, 'DUF3197', NULL, NULL, 22515, 9),
(255079, NULL, 'PF19142', NULL, NULL, 'Family of unknown function (DUF5825)', NULL, 'DUF5825', NULL, NULL, 34179, 9),
(255080, NULL, 'PF12558', NULL, NULL, 'ATP-binding cassette cobalt transporter', NULL, 'DUF3744', NULL, NULL, 21132, 9),
(255081, NULL, 'PF14029', NULL, NULL, 'Protein of unknown function (DUF4244)', NULL, 'DUF4244', NULL, NULL, 22359, 9),
(255082, NULL, 'PF04822', NULL, NULL, 'Takusan', NULL, 'Takusan', NULL, NULL, 4756, 9),
(255083, NULL, 'PF06233', NULL, NULL, 'Usg-like family', NULL, 'Usg', NULL, NULL, 14440, 9),
(255084, NULL, 'PF08796', NULL, NULL, 'Protein of unknown function (DUF1797)', NULL, 'DUF1797', NULL, NULL, 13112, 9),
(255085, NULL, 'PF02210', NULL, NULL, 'Laminin G domain', NULL, 'Laminin_G_2', NULL, NULL, 3322, 9),
(255086, NULL, 'PF04395', NULL, NULL, 'Poxvirus B22R protein', NULL, 'Poxvirus_B22R', NULL, NULL, 10458, 9),
(255087, NULL, 'PF00586', NULL, NULL, 'AIR synthase related protein, N-terminal domain', NULL, 'AIRS', NULL, NULL, 11715, 9),
(255088, NULL, 'PF02813', NULL, NULL, 'Retroviral M domain', NULL, 'Retro_M', NULL, NULL, 586, 9),
(255089, NULL, 'PF11030', NULL, NULL, 'Nucleocapsid protein N', NULL, 'Nucleocapsid-N', NULL, NULL, 19406, 9),
(255090, NULL, 'PF05467', NULL, NULL, 'Herpesvirus glycoprotein U47', NULL, 'Herpes_U47', NULL, NULL, 14291, 9),
(255091, NULL, 'PF12000', NULL, NULL, 'Glycosyl transferase family 4 group', NULL, 'Glyco_trans_4_3', NULL, NULL, 16698, 9),
(255092, NULL, 'PF01200', NULL, NULL, 'Ribosomal protein S28e', NULL, 'Ribosomal_S28e', NULL, NULL, 4886, 9),
(255093, NULL, 'PF07042', NULL, NULL, 'TrfA protein', NULL, 'TrfA', NULL, NULL, 9865, 9),
(255094, NULL, 'PF12560', NULL, NULL, 'RAG1 importin binding', NULL, 'RAG1_imp_bd', NULL, NULL, 30996, 9),
(255095, NULL, 'PF04954', NULL, NULL, 'Siderophore-interacting protein', NULL, 'SIP', NULL, NULL, 6526, 9),
(255096, NULL, 'PF15716', NULL, NULL, 'Domain of unknown function (DUF4672)', NULL, 'DUF4672', NULL, NULL, 23714, 9),
(255097, NULL, 'PF16923', NULL, NULL, 'Glycosyl hydrolase family 63 N-terminal domain', NULL, 'Glyco_hydro_63N', NULL, NULL, 25092, 9),
(255098, NULL, 'PF11565', NULL, NULL, 'Alpha helical Porin B', NULL, 'PorB', NULL, NULL, 19904, 9),
(255099, NULL, 'PF01098', NULL, NULL, 'Cell cycle protein', NULL, 'FTSW_RODA_SPOVE', NULL, NULL, 1243, 9),
(255100, NULL, 'PF20386', NULL, NULL, 'Family of unknown function (DUF6681)', NULL, 'DUF6681', NULL, NULL, 37696, 9),
(255101, NULL, 'PF04724', NULL, NULL, 'Glycosyltransferase family 17', NULL, 'Glyco_transf_17', NULL, NULL, 3674, 9),
(255102, NULL, 'PF14691', NULL, NULL, 'Dihydroprymidine dehydrogenase domain II, 4Fe-4S cluster', NULL, 'Fer4_20', NULL, NULL, 23100, 9),
(255103, NULL, 'PF13921', NULL, NULL, 'Myb-like DNA-binding domain', NULL, 'Myb_DNA-bind_6', NULL, NULL, NULL, 9),
(255104, NULL, 'PF15569', NULL, NULL, 'Immunity protein 40', NULL, 'Imm40', NULL, NULL, 25247, 9),
(255105, NULL, 'PF18563', NULL, NULL, 'TubC N-terminal docking domain', NULL, 'TubC_N', NULL, NULL, 29774, 9),
(255106, NULL, 'PF17365', NULL, NULL, 'Family of unknown function (DUF5390)', NULL, 'DUF5390', NULL, NULL, 29821, 9),
(255107, NULL, 'PF09863', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2090)', NULL, 'DUF2090', NULL, NULL, 16817, 9),
(255108, NULL, 'PF14797', NULL, NULL, 'Serine-rich region of AP3B1, clathrin-adaptor complex', NULL, 'SEEEED', NULL, NULL, 24647, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(255109, NULL, 'PF18739', NULL, NULL, 'Apea-like HEPN', NULL, 'HEPN_Apea', NULL, NULL, 30288, 9),
(255110, NULL, 'PF06779', NULL, NULL, 'Uncharacterised MFS-type transporter YbfB', NULL, 'MFS_4', NULL, NULL, 9253, 9),
(255111, NULL, 'PF11052', NULL, NULL, 'Trans-sialidase of Trypanosoma hydrophobic C-terminal', NULL, 'Tr-sialidase_C', NULL, NULL, 17701, 9),
(255112, NULL, 'PF19682', NULL, NULL, 'Family of unknown function (DUF6184)', NULL, 'DUF6184', NULL, NULL, 37112, 9),
(255113, NULL, 'PF19630', NULL, NULL, 'Domain of unknown function (DUF6134)', NULL, 'DUF6134', NULL, NULL, 34347, 9),
(255114, NULL, 'PF03967', NULL, NULL, 'Photosynthetic reaction centre, H-chain N-terminal region', NULL, 'PRCH', NULL, NULL, 12702, 9),
(255115, NULL, 'PF08459', NULL, NULL, 'UvrC RNAse H endonuclease domain', NULL, 'UvrC_RNaseH_dom', NULL, NULL, 1277, 9),
(255116, NULL, 'PF07954', NULL, NULL, 'Protein of unknown function (DUF1689)', NULL, 'DUF1689', NULL, NULL, 14086, 9),
(255117, NULL, 'PF19842', NULL, NULL, 'YqeC protein', NULL, 'YqeC', NULL, NULL, 15952, 9),
(255118, NULL, 'PF06440', NULL, NULL, 'DNA polymerase III, theta subunit', NULL, 'DNA_pol3_theta', NULL, NULL, 6164, 9),
(255119, NULL, 'PF01044', NULL, NULL, 'Vinculin family', NULL, 'Vinculin', NULL, NULL, 2918, 9),
(255120, NULL, 'PF05542', NULL, NULL, 'Protein of unknown function (DUF760)', NULL, 'DUF760', NULL, NULL, 12168, 9),
(255121, NULL, 'PF19355', NULL, NULL, 'Family of unknown function (DUF5932)', NULL, 'DUF5932', NULL, NULL, 36944, 9),
(255122, NULL, 'PF10965', NULL, NULL, 'Protein of unknown function (DUF2767)', NULL, 'DUF2767', NULL, NULL, 24458, 9),
(255123, NULL, 'PF07636', NULL, NULL, 'PSRT', NULL, 'PSRT', NULL, NULL, 12639, 9),
(255124, NULL, 'PF07863', NULL, NULL, 'Homologues of TraJ from Bacteroides conjugative transposon', NULL, 'CtnDOT_TraJ', NULL, NULL, 13351, 9),
(255125, NULL, 'PF04431', NULL, NULL, 'Pectate lyase, N terminus', NULL, 'Pec_lyase_N', NULL, NULL, 10720, 9),
(255126, NULL, 'PF14565', NULL, NULL, 'Interleukin 22 IL-10-related T-cell-derived-inducible factor', NULL, 'IL22', NULL, NULL, 19682, 9),
(255127, NULL, 'PF14721', NULL, NULL, 'Apoptosis-inducing factor, mitochondrion-associated, C-term', NULL, 'AIF_C', NULL, NULL, 21951, 9),
(255128, NULL, 'PF17681', NULL, NULL, 'Gamma tubulin complex component N-terminal', NULL, 'GCP_N_terminal', NULL, NULL, 29599, 9),
(255129, NULL, 'PF03954', NULL, NULL, 'Hepatic lectin, N-terminal domain', NULL, 'Lectin_N', NULL, NULL, NULL, 9),
(255130, NULL, 'PF03837', NULL, NULL, 'RecT family', NULL, 'RecT', NULL, NULL, 8207, 9),
(255131, NULL, 'PF07494', NULL, NULL, 'Two component regulator propeller', NULL, 'Reg_prop', NULL, NULL, 11018, 9),
(255132, NULL, 'PF00623', NULL, NULL, 'RNA polymerase Rpb1, domain 2', NULL, 'RNA_pol_Rpb1_2', NULL, NULL, 3504, 9),
(255133, NULL, 'PF17747', NULL, NULL, 'VID27 PH-like domain', NULL, 'VID27_PH', NULL, NULL, 28497, 9),
(255134, NULL, 'PF01636', NULL, NULL, 'Phosphotransferase enzyme family', NULL, 'APH', NULL, NULL, 1645, 9),
(255135, NULL, 'PF08700', NULL, NULL, 'Vps51/Vps67', NULL, 'Vps51', NULL, NULL, NULL, 9),
(255136, NULL, 'PF16331', NULL, NULL, 'TolA binding protein trimerisation', NULL, 'TolA_bind_tri', NULL, NULL, 24515, 9),
(255137, NULL, 'PF17713', NULL, NULL, 'Family of unknown function (DUF5558)', NULL, 'DUF5558', NULL, NULL, 28983, 9),
(255138, NULL, 'PF07401', NULL, NULL, 'Bovine Lentivirus VIF protein', NULL, 'Lenti_VIF_2', NULL, NULL, 8059, 9),
(255139, NULL, 'PF15398', NULL, NULL, 'Domain of unknown function (DUF4619)', NULL, 'DUF4619', NULL, NULL, 21586, 9),
(255140, NULL, 'PF06602', NULL, NULL, 'Myotubularin-like phosphatase domain', NULL, 'Myotub-related', NULL, NULL, 8413, 9),
(255141, NULL, 'PF03031', NULL, NULL, 'NLI interacting factor-like phosphatase', NULL, 'NIF', NULL, NULL, 4145, 9),
(255142, NULL, 'PF20465', NULL, NULL, 'MmeI, helicase spacer domain', NULL, 'MmeI_hel', NULL, NULL, 36557, 9),
(255143, NULL, 'PF10183', NULL, NULL, 'ESSS subunit of NADH:ubiquinone oxidoreductase (complex I)', NULL, 'ESSS', NULL, NULL, 14649, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(255144, NULL, 'PF18907', NULL, NULL, 'Family of unknown function (DUF5662)', NULL, 'DUF5662', NULL, NULL, 35562, 9),
(255145, NULL, 'PF07030', NULL, NULL, 'Bacteriophage Mu, Gp36', NULL, 'Phage_Mu_Gp36', NULL, NULL, 12044, 9),
(255146, NULL, 'PF07163', NULL, NULL, 'Pex26 protein', NULL, 'Pex26', NULL, NULL, 10912, 9),
(255147, NULL, 'PF09502', NULL, NULL, 'Bacterial type III secretion protein (HrpB4)', NULL, 'HrpB4', NULL, NULL, 11458, 9),
(255148, NULL, 'PF12980', NULL, NULL, 'Domain of Unknown Function with PDB structure (DUF3864)', NULL, 'DUF3864', NULL, NULL, 26692, 9),
(255149, NULL, 'PF19477', NULL, NULL, 'Family of unknown function (DUF6014)', NULL, 'DUF6014', NULL, NULL, 36763, 9),
(255150, NULL, 'PF20161', NULL, NULL, 'VpsR domain', NULL, 'VpsR', NULL, NULL, 37067, 9),
(255151, NULL, 'PF04065', NULL, NULL, 'Not1 N-terminal domain, CCR4-Not complex component', NULL, 'Not3', NULL, NULL, 1436, 9),
(255152, NULL, 'PF15541', NULL, NULL, 'Bacterial toxin 4', NULL, 'Ntox4', NULL, NULL, 25256, 9),
(255153, NULL, 'PF19601', NULL, NULL, 'Family of unknown function (DUF6106)', NULL, 'DUF6106', NULL, NULL, 36729, 9),
(255154, NULL, 'PF01578', NULL, NULL, 'Cytochrome C assembly protein', NULL, 'Cytochrom_C_asm', NULL, NULL, 1770, 9),
(255155, NULL, 'PF18713', NULL, NULL, 'Domain of unknown function (DUF5645)', NULL, 'DUF5645', NULL, NULL, 30439, 9),
(255156, NULL, 'PF14887', NULL, NULL, 'HMG (high mobility group) box 5', NULL, 'HMG_box_5', NULL, NULL, 26827, 9),
(255157, NULL, 'PF11892', NULL, NULL, 'Domain of unknown function (DUF3412)', NULL, 'DUF3412', NULL, NULL, 19986, 9),
(255158, NULL, 'PF06925', NULL, NULL, 'Monogalactosyldiacylglycerol (MGDG) synthase', NULL, 'MGDG_synth', NULL, NULL, 11557, 9),
(255159, NULL, 'PF09886', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2113)', NULL, 'DUF2113', NULL, NULL, 21383, 9),
(255160, NULL, 'PF11367', NULL, NULL, 'Protein of unknown function (DUF3168)', NULL, 'DUF3168', NULL, NULL, 18657, 9),
(255161, NULL, 'PF13157', NULL, NULL, 'Endospore appendages', NULL, 'Enas', NULL, NULL, 22588, 9),
(255162, NULL, 'PF05452', NULL, NULL, 'Clavanin', NULL, 'Clavanin', NULL, NULL, 11756, 9),
(255163, NULL, 'PF18746', NULL, NULL, 'Alpha-glutamyl/putrescinyl thymine pyrophosphorylase clade 3', NULL, 'aGPT-Pplase3', NULL, NULL, 29727, 9),
(255164, NULL, 'PF20444', NULL, NULL, 'Family of unknown function (DUF6703)', NULL, 'DUF6703', NULL, NULL, 37588, 9),
(255165, NULL, 'PF05473', NULL, NULL, 'UL45 protein, carbohydrate-binding C-type lectin-like', NULL, 'UL45', NULL, NULL, NULL, 9),
(255166, NULL, 'PF10184', NULL, NULL, 'Uncharacterized conserved protein (DUF2358)', NULL, 'DUF2358', NULL, NULL, 19056, 9),
(255167, NULL, 'PF17885', NULL, NULL, 'Styrene monooxygenase A putative substrate binding domain', NULL, 'Smoa_sbd', NULL, NULL, 30264, 9),
(255168, NULL, 'PF10904', NULL, NULL, 'Protein of unknown function (DUF2694)', NULL, 'DUF2694', NULL, NULL, 23644, 9),
(255169, NULL, 'PF10359', NULL, NULL, 'RNA pol II promoter Fmp27 protein domain', NULL, 'Fmp27_WPPW', NULL, NULL, 17262, 9),
(255170, NULL, 'PF13750', NULL, NULL, 'Bacterial Ig-like domain (group 3)', NULL, 'Big_3_3', NULL, NULL, 20342, 9),
(255171, NULL, 'PF00508', NULL, NULL, 'E2 (early) protein, N terminal', NULL, 'PPV_E2_N', NULL, NULL, 4308, 9),
(255172, NULL, 'PF11379', NULL, NULL, 'Protein of unknown function (DUF3182)', NULL, 'DUF3182', NULL, NULL, 18833, 9),
(255173, NULL, 'PF01018', NULL, NULL, 'GTP1/OBG', NULL, 'GTP1_OBG', NULL, NULL, 10148, 9),
(255174, NULL, 'PF12770', NULL, NULL, 'CHAT domain', NULL, 'CHAT', NULL, NULL, 22854, 9),
(255175, NULL, 'PF11973', NULL, NULL, 'NQRA C-terminal domain', NULL, 'NQRA_SLBB', NULL, NULL, 16945, 9),
(255176, NULL, 'PF11905', NULL, NULL, 'Domain of unknown function (DUF3425)', NULL, 'DUF3425', NULL, NULL, 19562, 9),
(255177, NULL, 'PF04503', NULL, NULL, 'Single-stranded DNA binding protein, SSDP', NULL, 'SSDP', NULL, NULL, NULL, 9),
(255178, NULL, 'PF11335', NULL, NULL, 'Protein of unknown function (DUF3137)', NULL, 'DUF3137', NULL, NULL, 18496, 9); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(255179, NULL, 'PF03488', NULL, NULL, 'Nematode insulin-related peptide beta type', NULL, 'Ins_beta', NULL, NULL, 2776, 9),
(255180, NULL, 'PF10550', NULL, NULL, 'Conantokin toxin', NULL, 'Toxin_36', NULL, NULL, 12673, 9),
(255181, NULL, 'PF12853', NULL, NULL, 'C-terminal of NADH-ubiquinone oxidoreductase 21 kDa subunit', NULL, 'NADH_u_ox_C', NULL, NULL, 26464, 9),
(255182, NULL, 'PF05160', NULL, NULL, 'DSS1/SEM1 family', NULL, 'DSS1_SEM1', NULL, NULL, 2191, 9),
(255183, NULL, 'PF20535', NULL, NULL, 'Family of unknown function (DUF6750)', NULL, 'DUF6750', NULL, NULL, 33755, 9),
(255184, NULL, 'PF14001', NULL, NULL, 'YdfZ protein', NULL, 'YdfZ', NULL, NULL, 17733, 9),
(255185, NULL, 'PF12345', NULL, NULL, 'Protein of unknown function (DUF3641)', NULL, 'DUF3641', NULL, NULL, 24523, 9),
(255186, NULL, 'PF20447', NULL, NULL, 'Family of unknown function (DUF6704)', NULL, 'DUF6704', NULL, NULL, 37631, 9),
(255187, NULL, 'PF02541', NULL, NULL, 'Ppx/GppA phosphatase family', NULL, 'Ppx-GppA', NULL, NULL, 1667, 9),
(255188, NULL, 'PF18280', NULL, NULL, 'Aminoglycoside adenyltransferase C-terminal domain', NULL, 'AadA_C', NULL, NULL, 31921, 9),
(255189, NULL, 'PF00272', NULL, NULL, 'Cecropin family', NULL, 'Cecropin', NULL, NULL, 4606, 9),
(255190, NULL, 'PF12799', NULL, NULL, 'Leucine Rich repeats (2 copies)', NULL, 'LRR_4', NULL, NULL, 25626, 9),
(255191, NULL, 'PF12867', NULL, NULL, 'DinB superfamily', NULL, 'DinB_2', NULL, NULL, 23880, 9),
(255192, NULL, 'PF17907', NULL, NULL, 'AWS domain', NULL, 'AWS', NULL, NULL, 375, 9),
(255193, NULL, 'PF02236', NULL, NULL, 'Viral DNA-binding protein, all alpha domain', NULL, 'Viral_DNA_bi', NULL, NULL, 1816, 9),
(255194, NULL, 'PF09332', NULL, NULL, 'Mcm10 replication factor', NULL, 'Mcm10', NULL, NULL, 14480, 9),
(255195, NULL, 'PF10809', NULL, NULL, 'Protein of unknown function (DUF2732)', NULL, 'DUF2732', NULL, NULL, 18675, 9),
(255196, NULL, 'PF04375', NULL, NULL, 'HemX, putative uroporphyrinogen-III C-methyltransferase', NULL, 'HemX', NULL, NULL, 4893, 9),
(255197, NULL, 'PF04921', NULL, NULL, 'XAP5, circadian clock regulator', NULL, 'XAP5', NULL, NULL, 6956, 9),
(255198, NULL, 'PF20334', NULL, NULL, 'Family of unknown function (DUF6629)', NULL, 'DUF6629', NULL, NULL, 37005, 9),
(255199, NULL, 'PF04046', NULL, NULL, 'PSP', NULL, 'PSP', NULL, NULL, 8, 9),
(255200, NULL, 'PF13538', NULL, NULL, 'UvrD-like helicase C-terminal domain', NULL, 'UvrD_C_2', NULL, NULL, 26744, 9),
(255201, NULL, 'PF19605', NULL, NULL, 'Family of unknown function (DUF6110)', NULL, 'DUF6110', NULL, NULL, 36829, 9),
(255202, NULL, 'PF00114', NULL, NULL, 'Pilin (bacterial filament)', NULL, 'Pilin', NULL, NULL, 2065, 9),
(255203, NULL, 'PF04544', NULL, NULL, 'Herpesvirus egress protein UL20', NULL, 'Herpes_UL20', NULL, NULL, 2057, 9),
(255204, NULL, 'PF07574', NULL, NULL, 'Nse1 non-SMC component of SMC5-6 complex', NULL, 'SMC_Nse1', NULL, NULL, 12510, 9),
(255205, NULL, 'PF01541', NULL, NULL, 'GIY-YIG catalytic domain', NULL, 'GIY-YIG', NULL, NULL, 808, 9),
(255206, NULL, 'PF05348', NULL, NULL, 'Proteasome maturation factor UMP1', NULL, 'UMP1', NULL, NULL, 5035, 9),
(255207, NULL, 'PF16106', NULL, NULL, 'Domain of unknown function (DUF4824)', NULL, 'DUF4824', NULL, NULL, 22332, 9),
(255208, NULL, 'PF01228', NULL, NULL, 'Glycine radical', NULL, 'Gly_radical', NULL, NULL, 2122, 9),
(255209, NULL, 'PF18796', NULL, NULL, 'Large polyvalent protein-associated domain 1', NULL, 'LPD1', NULL, NULL, 29619, 9),
(255210, NULL, 'PF18033', NULL, NULL, 'SpuA C-terminal', NULL, 'SpuA_C', NULL, NULL, 29147, 9),
(255211, NULL, 'PF16251', NULL, NULL, 'Betacoronavirus nucleic acid-binding (NAB)', NULL, 'bCoV_NAB', NULL, NULL, 23900, 9),
(255212, NULL, 'PF05347', NULL, NULL, 'Complex 1 protein (LYR family)', NULL, 'Complex1_LYR', NULL, NULL, 5026, 9),
(255213, NULL, 'PF12768', NULL, NULL, 'Cortical protein marker for cell polarity', NULL, 'Rax2', NULL, NULL, NULL, 9),
(255214, NULL, 'PF14813', NULL, NULL, 'NADH dehydrogenase 1 beta subcomplex subunit 2', NULL, 'NADH_B2', NULL, NULL, 23245, 9),
(255215, NULL, 'PF06956', NULL, NULL, 'Regulator of RNA terminal phosphate cyclase', NULL, 'RtcR', NULL, NULL, 12411, 9);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(255216, NULL, 'PF05324', NULL, NULL, 'Sperm antigen HE2', NULL, 'Sperm_Ag_HE2', NULL, NULL, 4099, 9),
(255217, NULL, 'PF16878', NULL, NULL, 'Transcriptional regulator, SIX1, N-terminal SD domain', NULL, 'SIX1_SD', NULL, NULL, 24397, 9),
(255218, NULL, 'PF18160', NULL, NULL, 'SMODS and SLOG-associating 2TM effector domain family 5', NULL, 'SLATT_5', NULL, NULL, 28544, 9),
(255219, NULL, 'PF17280', NULL, NULL, 'Family of unknown function (DUF5345)', NULL, 'DUF5345', NULL, NULL, 28243, 9),
(255220, NULL, 'PF10272', NULL, NULL, 'Putative transmembrane protein precursor', NULL, 'Tmpp129', NULL, NULL, 19014, 9),
(255221, NULL, 'PF09703', NULL, NULL, 'CRISPR-associated protein (Cas_Csa4)', NULL, 'Cas_Csa4', NULL, NULL, 4011, 9),
(255222, NULL, 'PF10978', NULL, NULL, 'Protein of unknown function (DUF2785)', NULL, 'DUF2785', NULL, NULL, 17521, 9),
(255223, NULL, 'PF11750', NULL, NULL, 'Protein of unknown function (DUF3307)', NULL, 'DUF3307', NULL, NULL, 19071, 9),
(255224, NULL, 'PF09440', NULL, NULL, 'eIF3 subunit 6 N terminal domain', NULL, 'eIF3_N', NULL, NULL, 15736, 9),
(255225, NULL, 'PF09310', NULL, NULL, 'POU domain, class 2, associating factor 1', NULL, 'PD-C2-AF1', NULL, NULL, 14027, 9),
(255226, NULL, 'PF04214', NULL, NULL, 'Protein of unknown function, DUF', NULL, 'DUF411', NULL, NULL, 5353, 9),
(255227, NULL, 'PF08354', NULL, NULL, 'Domain of unknown function (DUF1729)', NULL, 'DUF1729', NULL, NULL, 12865, 9),
(255228, NULL, 'PF19474', NULL, NULL, 'Family of unknown function (DUF6011)', NULL, 'DUF6011', NULL, NULL, 36992, 9),
(255229, NULL, 'PF15289', NULL, NULL, 'Regulatory factor X-associated C-terminal binding domain', NULL, 'RFXA_RFXANK_bdg', NULL, NULL, 24990, 9),
(255230, NULL, 'PF01771', NULL, NULL, 'Viral alkaline exonuclease', NULL, 'Viral_alk_exo', NULL, NULL, 29425, 9),
(255231, NULL, 'PF06876', NULL, NULL, 'Plant self-incompatibility response (SCRL) protein', NULL, 'SCRL', NULL, NULL, 9486, 9),
(255232, NULL, 'PF14398', NULL, NULL, 'YheC/D like ATP-grasp', NULL, 'ATPgrasp_YheCD', NULL, NULL, 22127, 9),
(255233, NULL, 'PF04028', NULL, NULL, 'Domain of unknown function (DUF374)', NULL, 'DUF374', NULL, NULL, 415, 9),
(255234, NULL, 'PF18976', NULL, NULL, 'Family of unknown function (DUF5712)', NULL, 'DUF5712', NULL, NULL, 35178, 9),
(255235, NULL, 'PF00500', NULL, NULL, 'L1 (late) protein', NULL, 'Late_protein_L1', NULL, NULL, 239, 9),
(255236, NULL, 'PF01905', NULL, NULL, 'CRISPR-associated negative auto-regulator DevR/Csa2', NULL, 'DevR', NULL, NULL, 10997, 9),
(255237, NULL, 'PF19822', NULL, NULL, 'Family of unknown function (DUF6304)', NULL, 'DUF6304', NULL, NULL, 37216, 9),
(255238, NULL, 'PF02194', NULL, NULL, 'PXA domain', NULL, 'PXA', NULL, NULL, 2701, 9),
(255239, NULL, 'PF10277', NULL, NULL, 'Frag1/DRAM/Sfk1 family', NULL, 'Frag1', NULL, NULL, 16646, 9),
(255240, NULL, 'PF14846', NULL, NULL, 'Domain of unknown function (DUF4485)', NULL, 'DUF4485', NULL, NULL, 21692, 9),
(255241, NULL, 'PF06115', NULL, NULL, 'Domain of unknown function (DUF956)', NULL, 'DUF956', NULL, NULL, 8956, 9),
(255242, NULL, 'PF10529', NULL, NULL, 'Histidine-rich Calcium-binding repeat region', NULL, 'Hist_rich_Ca-bd', NULL, NULL, 19305, 9),
(255243, NULL, 'PF18929', NULL, NULL, 'Family of unknown function (DUF5678)', NULL, 'DUF5678', NULL, NULL, 35558, 9),
(255244, NULL, 'PF04525', NULL, NULL, 'LURP-one-related', NULL, 'LOR', NULL, NULL, 2707, 9),
(255245, NULL, 'PF19669', NULL, NULL, 'Family of unknown function (DUF6172)', NULL, 'DUF6172', NULL, NULL, 37194, 9),
(255246, NULL, 'PF14345', NULL, NULL, 'GDYXXLXY protein', NULL, 'GDYXXLXY', NULL, NULL, 24308, 9),
(255247, NULL, 'PF00608', NULL, NULL, 'Adenoviral fibre protein (repeat/shaft region)', NULL, 'Adeno_shaft', NULL, NULL, 28, 9),
(255248, NULL, 'PF09617', NULL, NULL, 'CRISPR-associated protein GSU0053 (Cas_GSU0053)', NULL, 'Cas_GSU0053', NULL, NULL, 11278, 9),
(255249, NULL, 'PF12317', NULL, NULL, 'Intraflagellar transport complex B protein 46 C terminal', NULL, 'IFT46_B_C', NULL, NULL, 20616, 9),
(255250, NULL, 'PF20242', NULL, NULL, 'Emfourin', NULL, 'Emfourin', NULL, NULL, NULL, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(255251, NULL, 'PF04765', NULL, NULL, 'Protein of unknown function (DUF616)', NULL, 'DUF616', NULL, NULL, 3668, 9),
(255252, NULL, 'PF00172', NULL, NULL, 'Fungal Zn(2)-Cys(6) binuclear cluster domain', NULL, 'Zn_clus', NULL, NULL, 2419, 9),
(255253, NULL, 'PF20042', NULL, NULL, 'Family of unknown function (DUF6444)', NULL, 'DUF6444', NULL, NULL, 34253, 9),
(255254, NULL, 'PF12343', NULL, NULL, 'DeaD helicase C-terminal disordered region', NULL, 'DeaD_C', NULL, NULL, 15363, 9),
(255255, NULL, 'PF17702', NULL, NULL, 'Family of unknown function (DUF5548)', NULL, 'DUF5548', NULL, NULL, 29901, 9),
(255256, NULL, 'PF01798', NULL, NULL, 'snoRNA binding domain, fibrillarin', NULL, 'Nop', NULL, NULL, 2917, 9),
(255257, NULL, 'PF01251', NULL, NULL, 'Ribosomal protein S7e', NULL, 'Ribosomal_S7e', NULL, NULL, 5757, 9),
(255258, NULL, 'PF13373', NULL, NULL, 'DSC E3 ubiquitin ligase complex subunit 3, C-terminal domain', NULL, 'Dsc3_C', NULL, NULL, 22237, 9),
(255259, NULL, 'PF13484', NULL, NULL, '4Fe-4S double cluster binding domain', NULL, 'Fer4_16', NULL, NULL, NULL, 9),
(255260, NULL, 'PF19073', NULL, NULL, 'Family of unknown function (DUF5769)', NULL, 'DUF5769', NULL, NULL, 35426, 9),
(255261, NULL, 'PF08286', NULL, NULL, 'Spc24 subunit of Ndc80', NULL, 'Spc24', NULL, NULL, 13323, 9),
(255262, NULL, 'PF12496', NULL, NULL, 'Bcl2-/adenovirus E1B nineteen kDa-interacting protein 2', NULL, 'BNIP2', NULL, NULL, 21264, 9),
(255263, NULL, 'PF11426', NULL, NULL, 'Tn7 transposition regulator TnsC', NULL, 'Tn7_TnsC_Int', NULL, NULL, 18718, 9),
(255264, NULL, 'PF13741', NULL, NULL, 'Mitochondrial ribosomal protein S25', NULL, 'MRP-S25', NULL, NULL, 17703, 9),
(255265, NULL, 'PF08929', NULL, NULL, 'Domain of unknown function (DUF1911)', NULL, 'DUF1911', NULL, NULL, 7949, 9),
(255266, NULL, 'PF15629', NULL, NULL, 'Permuted single zf-CXXC unit', NULL, 'Perm-CXXC', NULL, NULL, 25348, 9),
(255267, NULL, 'PF08679', NULL, NULL, 'Dissimilatory sulfite reductase D (DsrD)', NULL, 'DsrD', NULL, NULL, 11002, 9),
(255268, NULL, 'PF19870', NULL, NULL, 'Family of unknown function (DUF6343)', NULL, 'DUF6343', NULL, NULL, 36887, 9),
(255269, NULL, 'PF07966', NULL, NULL, 'A1 Propeptide', NULL, 'A1_Propeptide', NULL, NULL, 12422, 9),
(255270, NULL, 'PF15376', NULL, NULL, 'Domain of unknown function (DUF4603)', NULL, 'DUF4603', NULL, NULL, 25703, 9),
(255271, NULL, 'PF19846', NULL, NULL, 'Domain of unknown function (DUF6321)', NULL, 'DUF6321', NULL, NULL, 37692, 9),
(255272, NULL, 'PF07796', NULL, NULL, 'Protein of unknown function (DUF1638)', NULL, 'DUF1638', NULL, NULL, 14463, 9),
(255273, NULL, 'PF13277', NULL, NULL, 'YmdB-like protein', NULL, 'YmdB', NULL, NULL, 11412, 9),
(255274, NULL, 'PF17955', NULL, NULL, 'Cas6b N-terminal domain', NULL, 'Cas6b_N', NULL, NULL, 30899, 9),
(255275, NULL, 'PF09340', NULL, NULL, 'Histone acetyltransferase subunit NuA4', NULL, 'NuA4', NULL, NULL, 7252, 9),
(255276, NULL, 'PF14911', NULL, NULL, 'S-phase genomic integrity recombination mediator, C-terminal', NULL, 'MMS22L_C', NULL, NULL, 24593, 9),
(255277, NULL, 'PF18494', NULL, NULL, 'Pullulanase Ins domain', NULL, 'Pullulanase_Ins', NULL, NULL, 28676, 9),
(255278, NULL, 'PF19327', NULL, NULL, 'Ap4A phosphorylase N-terminal domain', NULL, 'Ap4A_phos_N', NULL, NULL, 36358, 9),
(255279, NULL, 'PF08977', NULL, NULL, 'Bypass of Forespore C, N terminal', NULL, 'BOFC_N', NULL, NULL, 8934, 9),
(255280, NULL, 'PF17015', NULL, NULL, 'Domain of unknown function (DUF5094)', NULL, 'DUF5094', NULL, NULL, 22509, 9),
(255281, NULL, 'PF05715', NULL, NULL, 'Piccolo Zn-finger', NULL, 'zf-piccolo', NULL, NULL, 7847, 9),
(255282, NULL, 'PF00624', NULL, NULL, 'Flocculin repeat', NULL, 'Flocculin', NULL, NULL, 6909, 9),
(255283, NULL, 'PF06052', NULL, NULL, '3-hydroxyanthranilic acid dioxygenase', NULL, '3-HAO', NULL, NULL, 8899, 9),
(255284, NULL, 'PF06746', NULL, NULL, 'Protein of unknown function (DUF1216)', NULL, 'DUF1216', NULL, NULL, 1515, 9),
(255285, NULL, 'PF16910', NULL, NULL, 'Repeating coiled region of VPS13', NULL, 'VPS13_mid_rpt', NULL, NULL, 26712, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(255286, NULL, 'PF09101', NULL, NULL, 'Exotoxin A binding', NULL, 'Exotox-A_bind', NULL, NULL, 10605, 9),
(255287, NULL, 'PF13645', NULL, NULL, 'L,D-transpeptidase catalytic domain', NULL, 'YkuD_2', NULL, NULL, 18348, 9),
(255288, NULL, 'PF12946', NULL, NULL, 'MSP1 EGF domain 1', NULL, 'EGF_MSP1_1', NULL, NULL, 1631, 9),
(255289, NULL, 'PF12904', NULL, NULL, 'Putative collagen-binding domain of a collagenase', NULL, 'Collagen_bind_2', NULL, NULL, 19043, 9),
(255290, NULL, 'PF05277', NULL, NULL, 'Protein of unknown function (DUF726)', NULL, 'DUF726', NULL, NULL, 4328, 9),
(255291, NULL, 'PF00022', NULL, NULL, 'Actin', NULL, 'Actin', NULL, NULL, 749, 9),
(255292, NULL, 'PF10592', NULL, NULL, 'AIPR protein', NULL, 'AIPR', NULL, NULL, 20510, 9),
(255293, NULL, 'PF19295', NULL, NULL, 'SufBD protein N-terminal region', NULL, 'SufBD_N', NULL, NULL, 36020, 9),
(255294, NULL, 'PF20187', NULL, NULL, 'Family of unknown function (DUF6550)', NULL, 'DUF6550', NULL, NULL, 37019, 9),
(255295, NULL, 'PF01222', NULL, NULL, 'Ergosterol biosynthesis ERG4/ERG24 family', NULL, 'ERG4_ERG24', NULL, NULL, 1028, 9),
(255296, NULL, 'PF08680', NULL, NULL, 'TATA-box binding', NULL, 'DUF1779', NULL, NULL, 11317, 9),
(255297, NULL, 'PF10920', NULL, NULL, 'Protein of unknown function (DUF2705)', NULL, 'DUF2705', NULL, NULL, 9324, 9),
(255298, NULL, 'PF13054', NULL, NULL, 'Protein of unknown function (DUF3915)', NULL, 'DUF3915', NULL, NULL, 22720, 9),
(255299, NULL, 'PF01293', NULL, NULL, 'Phosphoenolpyruvate carboxykinase', NULL, 'PEPCK_ATP', NULL, NULL, 5279, 9),
(255300, NULL, 'PF11517', NULL, NULL, 'Nuclear abundant poly(A) RNA-bind protein 2 (Nab2)', NULL, 'Nab2', NULL, NULL, 16756, 9),
(255301, NULL, 'PF11133', NULL, NULL, 'Head fiber protein', NULL, 'Phage_head_fibr', NULL, NULL, 16878, 9),
(255302, NULL, 'PF09287', NULL, NULL, 'CEP-1, DNA binding', NULL, 'CEP1-DNA_bind', NULL, NULL, 14491, 9),
(255303, NULL, 'PF06296', NULL, NULL, 'RelE toxin of RelE / RelB toxin-antitoxin system', NULL, 'RelE', NULL, NULL, 8466, 9),
(255304, NULL, 'PF00812', NULL, NULL, 'Ephrin', NULL, 'Ephrin', NULL, NULL, 3139, 9),
(255305, NULL, 'PF02902', NULL, NULL, 'Ulp1 protease family, C-terminal catalytic domain', NULL, 'Peptidase_C48', NULL, NULL, 1497, 9),
(255306, NULL, 'PF16516', NULL, NULL, 'Leucine zipper of domain CC2 of NEMO, NF-kappa-B essential modulator', NULL, 'CC2-LZ', NULL, NULL, 23007, 9),
(255307, NULL, 'PF15996', NULL, NULL, 'Arginine/serine-rich protein PNISR', NULL, 'PNISR', NULL, NULL, 24531, 9),
(255308, NULL, 'PF07242', NULL, NULL, 'Protein of unknown function (DUF1430)', NULL, 'DUF1430', NULL, NULL, 483, 9),
(255309, NULL, 'PF15096', NULL, NULL, 'G6B family', NULL, 'G6B', NULL, NULL, 26577, 9),
(255310, NULL, 'PF16114', NULL, NULL, 'ATP citrate lyase citrate-binding', NULL, 'Citrate_bind', NULL, NULL, 23884, 9),
(255311, NULL, 'PF17051', NULL, NULL, 'Cytochrome C oxidase assembly factor 2', NULL, 'COA2', NULL, NULL, 26766, 9),
(255312, NULL, 'PF08696', NULL, NULL, 'DNA replication factor Dna2', NULL, 'Dna2', NULL, NULL, 11947, 9),
(255313, NULL, 'PF17893', NULL, NULL, 'CRISPR-associated endonuclease Cas9 beta-hairpin domain', NULL, 'Cas9_b_hairpin', NULL, NULL, 32486, 9),
(255314, NULL, 'PF12825', NULL, NULL, 'Domain of unknown function in PX-proteins (DUF3818)', NULL, 'DUF3818', NULL, NULL, 21647, 9),
(255315, NULL, 'PF08376', NULL, NULL, 'Nitrate and nitrite sensing', NULL, 'NIT', NULL, NULL, 11901, 9),
(255316, NULL, 'PF04796', NULL, NULL, 'Plasmid encoded RepA protein', NULL, 'RepA_C', NULL, NULL, 4669, 9),
(255317, NULL, 'PF09882', NULL, NULL, 'Predicted membrane protein (DUF2109)', NULL, 'DUF2109', NULL, NULL, 19433, 9),
(255318, NULL, 'PF15818', NULL, NULL, 'Coiled-coil domain-containing protein 73 family', NULL, 'CCDC73', NULL, NULL, 23514, 9),
(255319, NULL, 'PF14144', NULL, NULL, 'Seed dormancy control', NULL, 'DOG1', NULL, NULL, 26272, 9),
(255320, NULL, 'PF05881', NULL, NULL, '2'',3''-cyclic nucleotide 3''-phosphodiesterase (CNP or CNPase)', NULL, 'CNPase', NULL, NULL, 8894, 9),
(255321, NULL, 'PF11283', NULL, NULL, 'Protein of unknown function (DUF3084)', NULL, 'DUF3084', NULL, NULL, 18357, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(255322, NULL, 'PF12261', NULL, NULL, 'Thermostable hemolysin', NULL, 'T_hemolysin', NULL, NULL, 20416, 9),
(255323, NULL, 'PF13393', NULL, NULL, 'Histidyl-tRNA synthetase', NULL, 'tRNA-synt_His', NULL, NULL, 30065, 9),
(255324, NULL, 'PF05625', NULL, NULL, 'PAXNEB protein', NULL, 'PAXNEB', NULL, NULL, 12107, 9),
(255325, NULL, 'PF18788', NULL, NULL, 'Defence against restriction A N-terminal', NULL, 'DarA_N', NULL, NULL, 28782, 9),
(255326, NULL, 'PF07848', NULL, NULL, 'PaaX-like protein', NULL, 'PaaX', NULL, NULL, 13058, 9),
(255327, NULL, 'PF00406', NULL, NULL, 'Adenylate kinase', NULL, 'ADK', NULL, NULL, NULL, 9),
(255328, NULL, 'PF03147', NULL, NULL, 'Ferredoxin-fold anticodon binding domain', NULL, 'FDX-ACB', NULL, NULL, 7470, 9),
(255329, NULL, 'PF17914', NULL, NULL, 'HopA1 effector protein family', NULL, 'HopA1', NULL, NULL, 28309, 9),
(255330, NULL, 'PF14156', NULL, NULL, 'Antirepressor AbbA', NULL, 'AbbA_antirepres', NULL, NULL, 26388, 9),
(255331, NULL, 'PF08752', NULL, NULL, 'Coatomer gamma subunit appendage platform subdomain', NULL, 'COP-gamma_platf', NULL, NULL, 14250, 9),
(255332, NULL, 'PF14003', NULL, NULL, 'YlbE-like protein', NULL, 'YlbE', NULL, NULL, 26469, 9),
(255333, NULL, 'PF02568', NULL, NULL, 'Thiamine biosynthesis protein (ThiI)', NULL, 'ThiI', NULL, NULL, 18719, 9),
(255334, NULL, 'PF12437', NULL, NULL, 'Glutamine synthetase type III N terminal', NULL, 'GSIII_N', NULL, NULL, 20831, 9),
(255335, NULL, 'PF03244', NULL, NULL, 'Photosystem I reaction centre subunit VI', NULL, 'PSI_PsaH', NULL, NULL, 1861, 9),
(255336, NULL, 'PF05957', NULL, NULL, 'DUF883 N-terminal domain', NULL, 'DUF883', NULL, NULL, 35548, 9),
(255337, NULL, 'PF07786', NULL, NULL, 'Heparan-alpha-glucosaminide N-acetyltransferase, catalytic', NULL, 'HGSNAT_cat', NULL, NULL, 13167, 9),
(255338, NULL, 'PF11857', NULL, NULL, 'Domain of unknown function (DUF3377)', NULL, 'DUF3377', NULL, NULL, 19411, 9),
(255339, NULL, 'PF01523', NULL, NULL, 'PmbA/TldA metallopeptidase domain 1', NULL, 'PmbA_TldD', NULL, NULL, 777, 9),
(255340, NULL, 'PF00282', NULL, NULL, 'Pyridoxal-dependent decarboxylase conserved domain', NULL, 'Pyridoxal_deC', NULL, NULL, 1442, 9),
(255341, NULL, 'PF09779', NULL, NULL, 'Ima1 N-terminal domain', NULL, 'Ima1_N', NULL, NULL, 16469, 9),
(255342, NULL, 'PF10747', NULL, NULL, 'Sporulation inhibitor of replication protein SirA', NULL, 'SirA', NULL, NULL, 20318, 9),
(255343, NULL, 'PF04776', NULL, NULL, 'Protein MS5', NULL, 'protein_MS5', NULL, NULL, 6639, 9),
(255344, NULL, 'PF19136', NULL, NULL, 'Family of unknown function (DUF5819)', NULL, 'DUF5819', NULL, NULL, 34460, 9),
(255345, NULL, 'PF04240', NULL, NULL, 'Carotenoid biosynthesis protein', NULL, 'Caroten_synth', NULL, NULL, 5701, 9),
(255346, NULL, 'PF06773', NULL, NULL, 'Bim protein N-terminus', NULL, 'Bim_N', NULL, NULL, 12198, 9),
(255347, NULL, 'PF09257', NULL, NULL, 'BCMA, TALL-1 binding', NULL, 'BCMA-Tall_bind', NULL, NULL, 13120, 9),
(255348, NULL, 'PF13280', NULL, NULL, 'WYL domain', NULL, 'WYL', NULL, NULL, 26625, 9),
(255349, NULL, 'PF07654', NULL, NULL, 'Immunoglobulin C1-set domain', NULL, 'C1-set', NULL, NULL, 17, 9),
(255350, NULL, 'PF02114', NULL, NULL, 'Phosducin', NULL, 'Phosducin', NULL, NULL, 13647, 9),
(255351, NULL, 'PF14922', NULL, NULL, 'Protein of unknown function', NULL, 'FWWh', NULL, NULL, 23503, 9),
(255352, NULL, 'PF02420', NULL, NULL, 'Insect antifreeze protein repeat', NULL, 'AFP', NULL, NULL, 5172, 9),
(255353, NULL, 'PF16875', NULL, NULL, 'Glycosyl hydrolase family 36 N-terminal domain', NULL, 'Glyco_hydro_36N', NULL, NULL, 24322, 9),
(255354, NULL, 'PF13589', NULL, NULL, 'Histidine kinase-, DNA gyrase B-, and HSP90-like ATPase', NULL, 'HATPase_c_3', NULL, NULL, NULL, 9),
(255355, NULL, 'PF20531', NULL, NULL, 'Family of unknown function (DUF6746)', NULL, 'DUF6746', NULL, NULL, 33569, 9),
(255356, NULL, 'PF05071', NULL, NULL, 'NADH ubiquinone oxidoreductase subunit NDUFA12', NULL, 'NDUFA12', NULL, NULL, 1209, 9),
(255357, NULL, 'PF07263', NULL, NULL, 'Dentin matrix protein 1 (DMP1)', NULL, 'DMP1', NULL, NULL, 14026, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(255358, NULL, 'PF02954', NULL, NULL, 'Bacterial regulatory protein, Fis family', NULL, 'HTH_8', NULL, NULL, 103, 9),
(255359, NULL, 'PF08767', NULL, NULL, 'CRM1 C terminal', NULL, 'CRM1_C', NULL, NULL, 13108, 9),
(255360, NULL, 'PF03609', NULL, NULL, 'PTS system sorbose-specific iic component', NULL, 'EII-Sor', NULL, NULL, 3076, 9),
(255361, NULL, 'PF15550', NULL, NULL, 'Draxin', NULL, 'Draxin', NULL, NULL, 25252, 9),
(255362, NULL, 'PF18164', NULL, NULL, 'GNAT-like C-terminal domain', NULL, 'GNAT_C', NULL, NULL, 29963, 9),
(255363, NULL, 'PF20286', NULL, NULL, 'Divergent Family B DNA polymerase', NULL, 'divDNApol', NULL, NULL, 37542, 9),
(255364, NULL, 'PF13146', NULL, NULL, 'TRL-like protein family', NULL, 'TRL', NULL, NULL, 22034, 9),
(255365, NULL, 'PF12022', NULL, NULL, 'COG complex component, COG2, C-terminal', NULL, 'COG2_C', NULL, NULL, 26576, 9),
(255366, NULL, 'PF19598', NULL, NULL, 'Family of unknown function (DUF6103)', NULL, 'DUF6103', NULL, NULL, 36834, 9),
(255367, NULL, 'PF16054', NULL, NULL, 'Transmembrane protein family 72', NULL, 'TMEM72', NULL, NULL, 22610, 9),
(255368, NULL, 'PF13774', NULL, NULL, 'Regulated-SNARE-like domain', NULL, 'Longin', NULL, NULL, 5394, 9),
(255369, NULL, 'PF18899', NULL, NULL, 'Domain of unknown function (DUF5655)', NULL, 'DUF5655', NULL, NULL, 34434, 9),
(255370, NULL, 'PF06850', NULL, NULL, 'PHB de-polymerase C-terminus', NULL, 'PHB_depo_C', NULL, NULL, 11134, 9),
(255371, NULL, 'PF09346', NULL, NULL, 'SMI1 / KNR4 family (SUKH-1)', NULL, 'SMI1_KNR4', NULL, NULL, 14903, 9),
(255372, NULL, 'PF08003', NULL, NULL, 'Protein of unknown function (DUF1698)', NULL, 'Methyltransf_9', NULL, NULL, 26882, 9),
(255373, NULL, 'PF15519', NULL, NULL, 'linker between RRM2 and RRM3 domains in RBM39 protein', NULL, 'RBM39linker', NULL, NULL, 23600, 9),
(255374, NULL, 'PF02719', NULL, NULL, 'Polysaccharide biosynthesis protein', NULL, 'Polysacc_synt_2', NULL, NULL, 4257, 9),
(255375, NULL, 'PF16611', NULL, NULL, 'Unstructured region between RBD and GoLoco', NULL, 'RGS12_us2', NULL, NULL, NULL, 9),
(255376, NULL, 'PF03307', NULL, NULL, 'Adenovirus 15.3kD protein in E3 region', NULL, 'Adeno_E3_15_3', NULL, NULL, 679, 9),
(255377, NULL, 'PF00727', NULL, NULL, 'Interleukin 4', NULL, 'IL4', NULL, NULL, 6343, 9),
(255378, NULL, 'PF12574', NULL, NULL, '120 KDa Rickettsia surface antigen', NULL, '120_Rick_ant', NULL, NULL, 14515, 9),
(255379, NULL, 'PF19835', NULL, NULL, 'Putative endonuclease segE, GIY-YIG domain', NULL, 'SegE_GIY-YIG', NULL, NULL, 36451, 9),
(255380, NULL, 'PF18648', NULL, NULL, 'Tse2 ADP-ribosyltransferase toxins', NULL, 'ADPRTs_Tse2', NULL, NULL, 29397, 9),
(255381, NULL, 'PF19824', NULL, NULL, 'Small, acid-soluble spore protein Tlp', NULL, 'Tlp', NULL, NULL, 14912, 9),
(255382, NULL, 'PF20076', NULL, NULL, 'Domain of unknown function (DUF6472)', NULL, 'DUF6472', NULL, NULL, 35662, 9),
(255383, NULL, 'PF05456', NULL, NULL, 'Eukaryotic translation initiation factor 4E binding protein (EIF4EBP)', NULL, 'eIF_4EBP', NULL, NULL, 14006, 9),
(255384, NULL, 'PF04411', NULL, NULL, 'PD-(D/E)XK nuclease superfamily', NULL, 'PDDEXK_7', NULL, NULL, 10170, 9),
(255385, NULL, 'PF02984', NULL, NULL, 'Cyclin, C-terminal domain', NULL, 'Cyclin_C', NULL, NULL, 5287, 9),
(255386, NULL, 'PF11035', NULL, NULL, 'Small nuclear RNA activating complex (SNAPc), subunit 2', NULL, 'SNAPC2', NULL, NULL, 17898, 9),
(255387, NULL, 'PF06398', NULL, NULL, 'Integral peroxisomal membrane peroxin', NULL, 'Pex24p', NULL, NULL, 10308, 9),
(255388, NULL, 'PF19330', NULL, NULL, 'Delta and Notch-like EGF-related receptor C-terminus', NULL, 'DNER_C', NULL, NULL, 34373, 9),
(255389, NULL, 'PF19876', NULL, NULL, 'Family of unknown function (DUF6349)', NULL, 'DUF6349', NULL, NULL, 36513, 9),
(255390, NULL, 'PF03822', NULL, NULL, 'NAF domain', NULL, 'NAF', NULL, NULL, 980, 9),
(255391, NULL, 'PF09778', NULL, NULL, 'Guanylylate cyclase', NULL, 'Guanylate_cyc_2', NULL, NULL, 16059, 9),
(255392, NULL, 'PF15110', NULL, NULL, 'TMEM141 protein family', NULL, 'TMEM141', NULL, NULL, 23420, 9),
(255393, NULL, 'PF11875', NULL, NULL, 'DnaJ-like protein C11, C-terminal', NULL, 'DnaJ-like_C11_C', NULL, NULL, 26680, 9);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(255394, NULL, 'PF00134', NULL, NULL, 'Cyclin, N-terminal domain', NULL, 'Cyclin_N', NULL, NULL, 1845, 9),
(255395, NULL, 'PF01547', NULL, NULL, 'Bacterial extracellular solute-binding protein', NULL, 'SBP_bac_1', NULL, NULL, 2880, 9),
(255396, NULL, 'PF03185', NULL, NULL, 'Calcium-activated potassium channel, beta subunit', NULL, 'CaKB', NULL, NULL, 6199, 9),
(255397, NULL, 'PF17405', NULL, NULL, 'Nrap protein nucleotidyltransferase domain 4', NULL, 'Nrap_D4', NULL, NULL, 30843, 9),
(255398, NULL, 'PF18465', NULL, NULL, 'Rieske 3Fe-4S', NULL, 'Rieske_3', NULL, NULL, 29587, 9),
(255399, NULL, 'PF05588', NULL, NULL, 'Clostridium botulinum HA-17 domain', NULL, 'Botulinum_HA-17', NULL, NULL, NULL, 9),
(255400, NULL, 'PF13534', NULL, NULL, '4Fe-4S dicluster domain', NULL, 'Fer4_17', NULL, NULL, NULL, 9),
(255401, NULL, 'PF05556', NULL, NULL, 'Calcineurin-binding protein (Calsarcin)', NULL, 'Calsarcin', NULL, NULL, 8726, 9),
(255402, NULL, 'PF09889', NULL, NULL, 'Uncharacterized protein containing a Zn-ribbon (DUF2116)', NULL, 'DUF2116', NULL, NULL, 19274, 9),
(255403, NULL, 'PF19133', NULL, NULL, 'Family of unknown function (DUF5816)', NULL, 'DUF5816', NULL, NULL, 34081, 9),
(255404, NULL, 'PF19665', NULL, NULL, 'Family of unknown function (DUF6168)', NULL, 'DUF6168', NULL, NULL, 37174, 9),
(255405, NULL, 'PF01924', NULL, NULL, 'Hydrogenase formation hypA family', NULL, 'HypD', NULL, NULL, 4570, 9),
(255406, NULL, 'PF17706', NULL, NULL, 'Family of unknown function (DUF5552)', NULL, 'DUF5552', NULL, NULL, 29752, 9),
(255407, NULL, 'PF14590', NULL, NULL, 'Domain of unknown function (DUF4447)', NULL, 'DUF4447', NULL, NULL, 23455, 9),
(255408, NULL, 'PF10783', NULL, NULL, 'Protein of unknown function (DUF2599)', NULL, 'DUF2599', NULL, NULL, 20969, 9),
(255409, NULL, 'PF02006', NULL, NULL, 'Phosphopantothenate/pantothenate synthetase', NULL, 'PPS_PS', NULL, NULL, 5793, 9),
(255410, NULL, 'PF19519', NULL, NULL, 'Family of unknown function (DUF6051)', NULL, 'DUF6051', NULL, NULL, 37428, 9),
(255411, NULL, 'PF18707', NULL, NULL, 'Interleukin-2 receptor subunit beta N-terminal domain 1', NULL, 'IL2RB_N1', NULL, NULL, 29272, 9),
(255412, NULL, 'PF09140', NULL, NULL, 'ATPase MipZ', NULL, 'MipZ', NULL, NULL, 10917, 9),
(255413, NULL, 'PF16531', NULL, NULL, 'Centriolar protein SAS N-terminal', NULL, 'SAS-6_N', NULL, NULL, 24211, 9),
(255414, NULL, 'PF17581', NULL, NULL, 'Family of unknown function (DUF5483)', NULL, 'DUF5483', NULL, NULL, 30635, 9),
(255415, NULL, 'PF08005', NULL, NULL, 'PHR domain', NULL, 'PHR', NULL, NULL, 12230, 9),
(255416, NULL, 'PF06814', NULL, NULL, 'Lung seven transmembrane receptor', NULL, 'Lung_7-TM_R', NULL, NULL, 10852, 9),
(255417, NULL, 'PF08819', NULL, NULL, 'Domain of unknown function (DUF1802)', NULL, 'DUF1802', NULL, NULL, 14448, 9),
(255418, NULL, 'PF01842', NULL, NULL, 'ACT domain', NULL, 'ACT', NULL, NULL, 6111, 9),
(255419, NULL, 'PF02602', NULL, NULL, 'Uroporphyrinogen-III synthase HemD', NULL, 'HEM4', NULL, NULL, 2003, 9),
(255420, NULL, 'PF03135', NULL, NULL, 'CagE, TrbE, VirB family, component of type IV transporter system', NULL, 'CagE_TrbE_VirB', NULL, NULL, 20557, 9),
(255421, NULL, 'PF11332', NULL, NULL, 'Protein of unknown function (DUF3134)', NULL, 'DUF3134', NULL, NULL, 18407, 9),
(255422, NULL, 'PF10574', NULL, NULL, 'Arp2/3-interacting proteins Arpin', NULL, 'UPF0552', NULL, NULL, 20663, 9),
(255423, NULL, 'PF12731', NULL, NULL, 'Mating-type protein beta 1', NULL, 'Mating_N', NULL, NULL, 22792, 9),
(255424, NULL, 'PF01391', NULL, NULL, 'Collagen triple helix repeat (20 copies)', NULL, 'Collagen', NULL, NULL, 7171, 9),
(255425, NULL, 'PF10707', NULL, NULL, 'PhoP regulatory network protein YrbL', NULL, 'YrbL-PhoP_reg', NULL, NULL, 20812, 9),
(255426, NULL, 'PF00016', NULL, NULL, 'Ribulose bisphosphate carboxylase large chain, catalytic domain', NULL, 'RuBisCO_large', NULL, NULL, 3836, 9),
(255427, NULL, 'PF03079', NULL, NULL, 'ARD/ARD'' family', NULL, 'ARD', NULL, NULL, 4735, 9),
(255428, NULL, 'PF20470', NULL, NULL, 'Helix-turn-helix domain', NULL, 'HTH_61', NULL, NULL, 34173, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(255429, NULL, 'PF18871', NULL, NULL, 'HEPN/Toprim N-terminal domain 1', NULL, 'HEPN_Toprim_N', NULL, NULL, 29905, 9),
(255430, NULL, 'PF00712', NULL, NULL, 'DNA polymerase III beta subunit, N-terminal domain', NULL, 'DNA_pol3_beta', NULL, NULL, 17406, 9),
(255431, NULL, 'PF14819', NULL, NULL, 'Nitrile reductase, 7-cyano-7-deazaguanine-reductase N-term', NULL, 'QueF_N', NULL, NULL, 25814, 9),
(255432, NULL, 'PF07573', NULL, NULL, 'Nitrogen regulatory protein AreA N terminus', NULL, 'AreA_N', NULL, NULL, 13656, 9),
(255433, NULL, 'PF13395', NULL, NULL, 'HNH endonuclease', NULL, 'HNH_4', NULL, NULL, 848, 9),
(255434, NULL, 'PF15294', NULL, NULL, 'Leucine zipper', NULL, 'Leu_zip', NULL, NULL, 22779, 9),
(255435, NULL, 'PF01374', NULL, NULL, 'Glycosyl hydrolase family 46', NULL, 'Glyco_hydro_46', NULL, NULL, 6621, 9),
(255436, NULL, 'PF11152', NULL, NULL, 'Cofactor assembly of complex C subunit B, CCB2/CCB4', NULL, 'CCB2_CCB4', NULL, NULL, 17652, 9),
(255437, NULL, 'PF02746', NULL, NULL, 'Mandelate racemase / muconate lactonizing enzyme, N-terminal domain', NULL, 'MR_MLE_N', NULL, NULL, 11733, 9),
(255438, NULL, 'PF18990', NULL, NULL, 'Family of unknown function (DUF5723)', NULL, 'DUF5723', NULL, NULL, 35539, 9),
(255439, NULL, 'PF14564', NULL, NULL, 'Membrane binding', NULL, 'Membrane_bind', NULL, NULL, 21485, 9),
(255440, NULL, 'PF09017', NULL, NULL, 'Microbial transglutaminase', NULL, 'Transglut_prok', NULL, NULL, 9575, 9),
(255441, NULL, 'PF16412', NULL, NULL, 'Domain of unknown function (DUF5020)', NULL, 'DUF5020', NULL, NULL, NULL, 9),
(255442, NULL, 'PF03167', NULL, NULL, 'Uracil DNA glycosylase superfamily', NULL, 'UDG', NULL, NULL, 7100, 9),
(255443, NULL, 'PF10476', NULL, NULL, 'Protein of unknown function C-terminus (DUF2448)', NULL, 'DUF2448', NULL, NULL, 20970, 9),
(255444, NULL, 'PF13511', NULL, NULL, 'Domain of unknown function (DUF4124)', NULL, 'DUF4124', NULL, NULL, 22290, 9),
(255445, NULL, 'PF20245', NULL, NULL, 'Family of unknown function (DUF6600)', NULL, 'DUF6600', NULL, NULL, 37513, 9),
(255446, NULL, 'PF06221', NULL, NULL, 'Putative zinc finger motif, C2HC5-type', NULL, 'zf-C2HC5', NULL, NULL, 14224, 9),
(255447, NULL, 'PF14569', NULL, NULL, 'Zinc-binding RING-finger', NULL, 'zf-UDP', NULL, NULL, 24494, 9),
(255448, NULL, 'PF01600', NULL, NULL, 'Coronavirus spike glycoprotein S1', NULL, 'CoV_S1', NULL, NULL, 1887, 9),
(255449, NULL, 'PF17723', NULL, NULL, 'Ribbon-Helix-Helix transcriptional regulator family', NULL, 'RHH_8', NULL, NULL, 29145, 9),
(255450, NULL, 'PF07336', NULL, NULL, 'Putative stress-induced transcription regulator', NULL, 'ABATE', NULL, NULL, 11602, 9),
(255451, NULL, 'PF01259', NULL, NULL, 'SAICAR synthetase', NULL, 'SAICAR_synt', NULL, NULL, 22083, 9),
(255452, NULL, 'PF02349', NULL, NULL, 'Major surface glycoprotein', NULL, 'MSG', NULL, NULL, 4321, 9),
(255453, NULL, 'PF17998', NULL, NULL, 'Cell surface antigen I/II C2 terminal domain', NULL, 'AgI_II_C2', NULL, NULL, 23290, 9),
(255454, NULL, 'PF17922', NULL, NULL, 'Tetracyclin repressor-like, C-terminal domain', NULL, 'TetR_C_17', NULL, NULL, 30818, 9),
(255455, NULL, 'PF08846', NULL, NULL, 'Domain of unknown function (DUF1816)', NULL, 'DUF1816', NULL, NULL, 14289, 9),
(255456, NULL, 'PF10161', NULL, NULL, 'Putative mitochondrial precursor protein', NULL, 'DDDD', NULL, NULL, 19373, 9),
(255457, NULL, 'PF20032', NULL, NULL, 'ADYC domain', NULL, 'ADYC', NULL, NULL, 35588, 9),
(255458, NULL, 'PF07866', NULL, NULL, 'Protein of unknown function (DUF1653)', NULL, 'DUF1653', NULL, NULL, 16628, 9),
(255459, NULL, 'PF07078', NULL, NULL, 'Forty-two-three protein', NULL, 'FYTT', NULL, NULL, NULL, 9),
(255460, NULL, 'PF06748', NULL, NULL, 'Protein of unknown function (DUF1217)', NULL, 'DUF1217', NULL, NULL, 9240, 9),
(255461, NULL, 'PF10108', NULL, NULL, 'Predicted 3''-5'' exonuclease related to the exonuclease domain of PolB', NULL, 'DNA_pol_B_exo2', NULL, NULL, 19979, 9),
(255462, NULL, 'PF11083', NULL, NULL, 'Lantibiotic streptin immunity protein', NULL, 'Streptin-Immun', NULL, NULL, 15065, 9),
(255463, NULL, 'PF00159', NULL, NULL, 'Pancreatic hormone peptide', NULL, 'Hormone_3', NULL, NULL, 2149, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(255464, NULL, 'PF12176', NULL, NULL, 'Methanol-cobalamin methyltransferase B subunit', NULL, 'MtaB', NULL, NULL, 16081, 9),
(255465, NULL, 'PF20368', NULL, NULL, 'Family of unknown function (DUF6663)', NULL, 'DUF6663', NULL, NULL, 33785, 9),
(255466, NULL, 'PF07380', NULL, NULL, 'Pneumovirus M2 protein', NULL, 'Pneumo_M2', NULL, NULL, 8042, 9),
(255467, NULL, 'PF20406', NULL, NULL, 'Kinase suppressor RAS 1 N-terminal helical hairpin', NULL, 'SAM_KSR1_N', NULL, NULL, 37699, 9),
(255468, NULL, 'PF01327', NULL, NULL, 'Polypeptide deformylase', NULL, 'Pep_deformylase', NULL, NULL, 6229, 9),
(255469, NULL, 'PF09681', NULL, NULL, 'N-terminal phage replisome organiser (Phage_rep_org_N)', NULL, 'Phage_rep_org_N', NULL, NULL, 5289, 9),
(255470, NULL, 'PF09845', NULL, NULL, 'Zn-ribbon containing protein', NULL, 'DUF2072', NULL, NULL, 16946, 9),
(255471, NULL, 'PF17687', NULL, NULL, 'Family of unknown function (DUF5535)', NULL, 'DUF5535', NULL, NULL, 28912, 9),
(255472, NULL, 'PF14412', NULL, NULL, 'A nuclease family of the HNH/ENDO VII superfamily with conserved AHH', NULL, 'AHH', NULL, NULL, 23696, 9),
(255473, NULL, 'PF10462', NULL, NULL, 'Peptidase M66', NULL, 'Peptidase_M66', NULL, NULL, NULL, 9),
(255474, NULL, 'PF07224', NULL, NULL, 'Chlorophyllase', NULL, 'Chlorophyllase', NULL, NULL, 18103, 9),
(255475, NULL, 'PF00523', NULL, NULL, 'Fusion glycoprotein F0', NULL, 'Fusion_gly', NULL, NULL, 3733, 9),
(255476, NULL, 'PF18740', NULL, NULL, 'EC042_2821-lke REase', NULL, 'EC042_2821', NULL, NULL, NULL, 9),
(255477, NULL, 'PF09084', NULL, NULL, 'NMT1/THI5 like', NULL, 'NMT1', NULL, NULL, 9869, 9),
(255478, NULL, 'PF11155', NULL, NULL, 'Domain of unknown function (DUF2935)', NULL, 'DUF2935', NULL, NULL, 17749, 9),
(255479, NULL, 'PF03176', NULL, NULL, 'MMPL family', NULL, 'MMPL', NULL, NULL, 7241, 9),
(255480, NULL, 'PF04221', NULL, NULL, 'RelB antitoxin', NULL, 'RelB', NULL, NULL, 5328, 9),
(255481, NULL, 'PF09689', NULL, NULL, 'Plasmodium yoelii repeat (PY_rept_46)', NULL, 'PY_rept_46', NULL, NULL, 35553, 9),
(255482, NULL, 'PF13068', NULL, NULL, 'Protein of unknown function (DUF3932)', NULL, 'DUF3932', NULL, NULL, 21282, 9),
(255483, NULL, 'PF03920', NULL, NULL, 'Groucho/TLE N-terminal Q-rich domain', NULL, 'TLE_N', NULL, NULL, 2753, 9),
(255484, NULL, 'PF06306', NULL, NULL, 'Beta-1,4-N-acetylgalactosaminyltransferase (CgtA)', NULL, 'CgtA', NULL, NULL, 10464, 9),
(255485, NULL, 'PF12568', NULL, NULL, 'Acetyltransferase (GNAT) domain, PanZ', NULL, 'PanZ', NULL, NULL, 31717, 9),
(255486, NULL, 'PF13585', NULL, NULL, 'CHU_C Type IX secretion signal domain', NULL, 'CHU_C', NULL, NULL, NULL, 9),
(255487, NULL, 'PF20377', NULL, NULL, 'Family of unknown function (DUF6672)', NULL, 'DUF6672', NULL, NULL, 37354, 9),
(255488, NULL, 'PF01781', NULL, NULL, 'Ribosomal L38e protein family', NULL, 'Ribosomal_L38e', NULL, NULL, 2923, 9),
(255489, NULL, 'PF07615', NULL, NULL, 'YKOF-related Family', NULL, 'Ykof', NULL, NULL, 12979, 9),
(255490, NULL, 'PF14517', NULL, NULL, 'Tachylectin', NULL, 'Tachylectin', NULL, NULL, 15638, 9),
(255491, NULL, 'PF01968', NULL, NULL, 'Hydantoinase/oxoprolinase', NULL, 'Hydantoinase_A', NULL, NULL, 4827, 9),
(255492, NULL, 'PF03442', NULL, NULL, 'Carbohydrate binding domain X2', NULL, 'CBM_X2', NULL, NULL, 10898, 9),
(255493, NULL, 'PF03352', NULL, NULL, 'Methyladenine glycosylase', NULL, 'Adenine_glyco', NULL, NULL, 1346, 9),
(255494, NULL, 'PF10866', NULL, NULL, 'Protein of unknown function (DUF2704)', NULL, 'DUF2704', NULL, NULL, 16609, 9),
(255495, NULL, 'PF15142', NULL, NULL, 'INCA1', NULL, 'INCA1', NULL, NULL, 24850, 9),
(255496, NULL, 'PF19198', NULL, NULL, 'RsaA N-terminal domain', NULL, 'RsaA_NTD', NULL, NULL, NULL, 9),
(255497, NULL, 'PF00444', NULL, NULL, 'Ribosomal protein L36', NULL, 'Ribosomal_L36', NULL, NULL, 6769, 9),
(255498, NULL, 'PF07370', NULL, NULL, 'Protein of unknown function (DUF1489)', NULL, 'DUF1489', NULL, NULL, 7714, 9),
(255499, NULL, 'PF10467', NULL, NULL, 'Peptidase inhibitor clitocypin', NULL, 'Inhibitor_I48', NULL, NULL, 18129, 9),
(255500, NULL, 'PF12465', NULL, NULL, 'Proteasome beta subunits C terminal', NULL, 'Pr_beta_C', NULL, NULL, 22286, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(255501, NULL, 'PF10111', NULL, NULL, 'Glycosyltransferase like family 2', NULL, 'Glyco_tranf_2_2', NULL, NULL, 19838, 9),
(255502, NULL, 'PF17333', NULL, NULL, 'Beta defensin 136', NULL, 'DEFB136', NULL, NULL, 15872, 9),
(255503, NULL, 'PF00123', NULL, NULL, 'Peptide hormone', NULL, 'Hormone_2', NULL, NULL, 5895, 9),
(255504, NULL, 'PF18409', NULL, NULL, 'Polo-like Kinase 4 Polo Box 2', NULL, 'Plk4_PB2', NULL, NULL, 28109, 9),
(255505, NULL, 'PF08901', NULL, NULL, 'Protein of unknown function (DUF1847)', NULL, 'DUF1847', NULL, NULL, 7889, 9),
(255506, NULL, 'PF00102', NULL, NULL, 'Protein-tyrosine phosphatase', NULL, 'Y_phosphatase', NULL, NULL, 820, 9),
(255507, NULL, 'PF01067', NULL, NULL, 'Calpain large subunit, domain III', NULL, 'Calpain_III', NULL, NULL, 16790, 9),
(255508, NULL, 'PF15503', NULL, NULL, 'Protein phosphatase 1 regulatory subunit 35 C-terminus', NULL, 'PPP1R35_C', NULL, NULL, 23790, 9),
(255509, NULL, 'PF10163', NULL, NULL, 'Transcription factor e(y)2', NULL, 'EnY2', NULL, NULL, 19015, 9),
(255510, NULL, 'PF13102', NULL, NULL, 'Phage integrase SAM-like domain', NULL, 'Phage_int_SAM_5', NULL, NULL, 23252, 9),
(255511, NULL, 'PF14122', NULL, NULL, 'YokU-like protein, putative antitoxin', NULL, 'YokU', NULL, NULL, 14995, 9),
(255512, NULL, 'PF08210', NULL, NULL, 'APOBEC-like N-terminal domain', NULL, 'APOBEC_N', NULL, NULL, 8798, 9),
(255513, NULL, 'PF19373', NULL, NULL, 'Family of unknown function (DUF5948)', NULL, 'DUF5948', NULL, NULL, 36962, 9),
(255514, NULL, 'PF09953', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2187)', NULL, 'DUF2187', NULL, NULL, 17024, 9),
(255515, NULL, 'PF06126', NULL, NULL, 'Herpesvirus Latent membrane protein 2', NULL, 'Herpes_LAMP2', NULL, NULL, 13831, 9),
(255516, NULL, 'PF17024', NULL, NULL, 'Putative DMAP1-like', NULL, 'DMAP1_like', NULL, NULL, 22700, 9),
(255517, NULL, 'PF09998', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2239)', NULL, 'DUF2239', NULL, NULL, 17219, 9),
(255518, NULL, 'PF15042', NULL, NULL, 'Late cornified envelope-like proline-rich protein 1', NULL, 'LELP1', NULL, NULL, 21798, 9),
(255519, NULL, 'PF08766', NULL, NULL, 'DEK C terminal domain', NULL, 'DEK_C', NULL, NULL, 13133, 9),
(255520, NULL, 'PF06229', NULL, NULL, 'FRG1-like domain', NULL, 'FRG1', NULL, NULL, 9432, 9),
(255521, NULL, 'PF05006', NULL, NULL, 'Per os infectivity factor 3', NULL, 'PIF3', NULL, NULL, 1432, 9),
(255522, NULL, 'PF17672', NULL, NULL, 'Fertilisation-influencing membrane protein', NULL, 'FIMP', NULL, NULL, 32942, 9),
(255523, NULL, 'PF09680', NULL, NULL, 'Family of unknown function', NULL, 'YjcZ_2', NULL, NULL, 8371, 9),
(255524, NULL, 'PF08855', NULL, NULL, 'Domain of unknown function (DUF1825)', NULL, 'DUF1825', NULL, NULL, 14129, 9),
(255525, NULL, 'PF10962', NULL, NULL, 'Protein of unknown function (DUF2764)', NULL, 'DUF2764', NULL, NULL, 24321, 9),
(255526, NULL, 'PF12424', NULL, NULL, 'Plasma membrane calcium transporter ATPase C terminal', NULL, 'ATP_Ca_trans_C', NULL, NULL, 20751, 9),
(255527, NULL, 'PF08665', NULL, NULL, 'PglZ domain', NULL, 'PglZ', NULL, NULL, 7583, 9),
(255528, NULL, 'PF05305', NULL, NULL, 'Protein of unknown function (DUF732)', NULL, 'DUF732', NULL, NULL, 4470, 9),
(255529, NULL, 'PF05910', NULL, NULL, 'Plant protein of unknown function (DUF868)', NULL, 'DUF868', NULL, NULL, 14418, 9),
(255530, NULL, 'PF08117', NULL, NULL, 'Ptu family', NULL, 'Toxin_30', NULL, NULL, 11664, 9),
(255531, NULL, 'PF08131', NULL, NULL, 'Defensin-like peptide family', NULL, 'Defensin_3', NULL, NULL, 8958, 9),
(255532, NULL, 'PF14630', NULL, NULL, 'Origin recognition complex (ORC) subunit 5 C-terminus', NULL, 'ORC5_C', NULL, NULL, 20690, 9),
(255533, NULL, 'PF11623', NULL, NULL, 'NAD(P)H dehydrogenase subunit S', NULL, 'NdhS', NULL, NULL, 18769, 9),
(255534, NULL, 'PF18326', NULL, NULL, 'RFX5 N-terminal domain', NULL, 'RFX5_N', NULL, NULL, 32198, 9),
(255535, NULL, 'PF14042', NULL, NULL, 'Domain of unknown function (DUF4247)', NULL, 'DUF4247', NULL, NULL, 22139, 9),
(255536, NULL, 'PF16433', NULL, NULL, 'Domain of unknown function (DUF5030)', NULL, 'DUF5030', NULL, NULL, 24024, 9);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(255537, NULL, 'PF07171', NULL, NULL, 'MlrC C-terminus', NULL, 'MlrC_C', NULL, NULL, 10857, 9),
(255538, NULL, 'PF02334', NULL, NULL, 'Replication terminator protein', NULL, 'RTP', NULL, NULL, 5028, 9),
(255539, NULL, 'PF08595', NULL, NULL, 'RXT2-like, N-terminal', NULL, 'RXT2_N', NULL, NULL, 17575, 9),
(255540, NULL, 'PF19264', NULL, NULL, 'Repeat of unknown function (DUF5907)', NULL, 'DUF5907', NULL, NULL, 36374, 9),
(255541, NULL, 'PF04906', NULL, NULL, 'Tweety', NULL, 'Tweety', NULL, NULL, 5875, 9),
(255542, NULL, 'PF13793', NULL, NULL, 'N-terminal domain of ribose phosphate pyrophosphokinase', NULL, 'Pribosyltran_N', NULL, NULL, 24540, 9),
(255543, NULL, 'PF14652', NULL, NULL, 'Domain of unknown function (DUF4457)', NULL, 'DUF4457', NULL, NULL, 25691, 9),
(255544, NULL, 'PF06275', NULL, NULL, 'Protein of unknown function (DUF1031)', NULL, 'DUF1031', NULL, NULL, 14451, 9),
(255545, NULL, 'PF17014', NULL, NULL, 'Putative Mad3/BUB1 like region 1 protein', NULL, 'Mad3_BUB1_I_2', NULL, NULL, 22530, 9),
(255546, NULL, 'PF09629', NULL, NULL, 'YorP protein', NULL, 'YorP', NULL, NULL, 15926, 9),
(255547, NULL, 'PF14567', NULL, NULL, 'SMI1-KNR4 cell-wall', NULL, 'SUKH_5', NULL, NULL, NULL, 9),
(255548, NULL, 'PF07578', NULL, NULL, 'Lipid A Biosynthesis N-terminal domain', NULL, 'LAB_N', NULL, NULL, 12873, 9),
(255549, NULL, 'PF11713', NULL, NULL, 'Peptidase C80 family', NULL, 'Peptidase_C80', NULL, NULL, 14874, 9),
(255550, NULL, 'PF02900', NULL, NULL, 'Catalytic LigB subunit of aromatic ring-opening dioxygenase', NULL, 'LigB', NULL, NULL, 2844, 9),
(255551, NULL, 'PF08228', NULL, NULL, 'RNase P subunit Pop3', NULL, 'RNase_P_pop3', NULL, NULL, 12550, 9),
(255552, NULL, 'PF12358', NULL, NULL, 'Protein of unknown function (DUF3644)', NULL, 'DUF3644', NULL, NULL, 20732, 9),
(255553, NULL, 'PF19771', NULL, NULL, 'Family of unknown function (DUF6257)', NULL, 'DUF6257', NULL, NULL, 37471, 9),
(255554, NULL, 'PF09404', NULL, NULL, 'KICSTOR complex C12orf66 like', NULL, 'C12orf66_like', NULL, NULL, 14927, 9),
(255555, NULL, 'PF05501', NULL, NULL, 'Domain of unknown function (DUF755)', NULL, 'DUF755', NULL, NULL, 12318, 9),
(255556, NULL, 'PF05198', NULL, NULL, 'Translation initiation factor IF-3, N-terminal domain', NULL, 'IF3_N', NULL, NULL, 17144, 9),
(255557, NULL, 'PF14480', NULL, NULL, 'DNA polymerase III polC-type N-terminus I', NULL, 'DNA_pol3_a_NI', NULL, NULL, 26145, 9),
(255558, NULL, 'PF11642', NULL, NULL, 'Mite allergen Blo t 5', NULL, 'Blo-t-5', NULL, NULL, 20324, 9),
(255559, NULL, 'PF19097', NULL, NULL, 'Snu56-like U1 small nuclear ribonucleoprotein component', NULL, 'Snu56_snRNP', NULL, NULL, 35399, 9),
(255560, NULL, 'PF09821', NULL, NULL, 'C-terminal AAA-associated domain', NULL, 'AAA_assoc_C', NULL, NULL, 16355, 9),
(255561, NULL, 'PF02995', NULL, NULL, 'Protein of unknown function (DUF229)', NULL, 'DUF229', NULL, NULL, 3986, 9),
(255562, NULL, 'PF17660', NULL, NULL, 'Bacterial tandem repeat domain 1', NULL, 'BTRD1', NULL, NULL, NULL, 9),
(255563, NULL, 'PF08699', NULL, NULL, 'Argonaute linker 1 domain', NULL, 'ArgoL1', NULL, NULL, 11503, 9),
(255564, NULL, 'PF17304', NULL, NULL, 'Family of unknown function (DUF5353)', NULL, 'DUF5353', NULL, NULL, 30862, 9),
(255565, NULL, 'PF02416', NULL, NULL, 'mttA/Hcf106 family', NULL, 'TatA_B_E', NULL, NULL, 4195, 9),
(255566, NULL, 'PF03703', NULL, NULL, 'Bacterial PH domain', NULL, 'bPH_2', NULL, NULL, 5149, 9),
(255567, NULL, 'PF05309', NULL, NULL, 'TraE protein', NULL, 'TraE', NULL, NULL, 4187, 9),
(255568, NULL, 'PF12661', NULL, NULL, 'Human growth factor-like EGF', NULL, 'hEGF', NULL, NULL, 10409, 9),
(255569, NULL, 'PF01252', NULL, NULL, 'Signal peptidase (SPase) II', NULL, 'Peptidase_A8', NULL, NULL, 4162, 9),
(255570, NULL, 'PF04788', NULL, NULL, 'Protein of unknown function (DUF620)', NULL, 'DUF620', NULL, NULL, 4906, 9),
(255571, NULL, 'PF03394', NULL, NULL, 'Poxvirus E8 protein', NULL, 'Pox_E8', NULL, NULL, 2165, 9),
(255572, NULL, 'PF15495', NULL, NULL, 'Major fimbrial subunit protein type IV, Fimbrillin, C-terminal', NULL, 'Fimbrillin_C', NULL, NULL, 23893, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(255573, NULL, 'PF15528', NULL, NULL, 'Bacterial toxin 23', NULL, 'Ntox23', NULL, NULL, 23725, 9),
(255574, NULL, 'PF03821', NULL, NULL, 'Golgi 4-transmembrane spanning transporter', NULL, 'Mtp', NULL, NULL, 3369, 9),
(255575, NULL, 'PF03843', NULL, NULL, 'Outer membrane lipoprotein Slp family', NULL, 'Slp', NULL, NULL, 2884, 9),
(255576, NULL, 'PF01857', NULL, NULL, 'Retinoblastoma-associated protein B domain', NULL, 'RB_B', NULL, NULL, 3932, 9),
(255577, NULL, 'PF00700', NULL, NULL, 'Bacterial flagellin C-terminal helical region', NULL, 'Flagellin_C', NULL, NULL, 36838, 9),
(255578, NULL, 'PF13271', NULL, NULL, 'Domain of unknown function (DUF4062)', NULL, 'DUF4062', NULL, NULL, 22551, 9),
(255579, NULL, 'PF01917', NULL, NULL, 'Archaebacterial flagellin', NULL, 'Arch_flagellin', NULL, NULL, 4964, 9),
(255580, NULL, 'PF17338', NULL, NULL, 'Gene product 88', NULL, 'GP88', NULL, NULL, 20641, 9),
(255581, NULL, 'PF03756', NULL, NULL, 'A-factor biosynthesis hotdog domain', NULL, 'AfsA', NULL, NULL, 988, 9),
(255582, NULL, 'PF14067', NULL, NULL, 'LssY C-terminus', NULL, 'LssY_C', NULL, NULL, 23072, 9),
(255583, NULL, 'PF15072', NULL, NULL, 'Homologous recombination OB-fold protein', NULL, 'HROB', NULL, NULL, 24412, 9),
(255584, NULL, 'PF19020', NULL, NULL, 'Ta1207 family', NULL, 'Ta1207', NULL, NULL, 35663, 9),
(255585, NULL, 'PF19910', NULL, NULL, 'Domain of unknown function (DUF6383)', NULL, 'DUF6383', NULL, NULL, 36900, 9),
(255586, NULL, 'PF00046', NULL, NULL, 'Homeodomain', NULL, 'Homeodomain', NULL, NULL, 7496, 9),
(255587, NULL, 'PF02419', NULL, NULL, 'PsbL protein', NULL, 'PsbL', NULL, NULL, 4419, 9),
(255588, NULL, 'PF18008', NULL, NULL, 'Replication initiator protein A C-terminal domain', NULL, 'Bac_RepA_C', NULL, NULL, 28937, 9),
(255589, NULL, 'PF19433', NULL, NULL, 'Neuron-derived Neurotrophic Factor C-terminal', NULL, 'NDNF_C', NULL, NULL, 34393, 9),
(255590, NULL, 'PF14951', NULL, NULL, 'Domain of unknown function (DUF4503)', NULL, 'DUF4503', NULL, NULL, 23671, 9),
(255591, NULL, 'PF17258', NULL, NULL, 'Family of unknown function (DUF5324)', NULL, 'DUF5324', NULL, NULL, 18683, 9),
(255592, NULL, 'PF01764', NULL, NULL, 'Lipase (class 3)', NULL, 'Lipase_3', NULL, NULL, 6596, 9),
(255593, NULL, 'PF12798', NULL, NULL, '4Fe-4S binding domain', NULL, 'Fer4_3', NULL, NULL, 12567, 9),
(255594, NULL, 'PF16480', NULL, NULL, 'Domain of unknown function (DUF5057)', NULL, 'DUF5057', NULL, NULL, 18041, 9),
(255595, NULL, 'PF02015', NULL, NULL, 'Glycosyl hydrolase family 45', NULL, 'Glyco_hydro_45', NULL, NULL, 4762, 9),
(255596, NULL, 'PF14155', NULL, NULL, 'Domain of unknown function (DUF4307)', NULL, 'DUF4307', NULL, NULL, 26060, 9),
(255597, NULL, 'PF14547', NULL, NULL, 'Hydrophobic seed protein', NULL, 'Hydrophob_seed', NULL, NULL, 24147, 9),
(255598, NULL, 'PF00382', NULL, NULL, 'Transcription factor TFIIB repeat', NULL, 'TFIIB', NULL, NULL, 8487, 9),
(255599, NULL, 'PF15659', NULL, NULL, 'JAB-like toxin  1', NULL, 'Toxin-JAB1', NULL, NULL, 23796, 9),
(255600, NULL, 'PF17000', NULL, NULL, 'Accessory secretory protein Sec, Asp5', NULL, 'Asp5', NULL, NULL, 24496, 9),
(255601, NULL, 'PF05566', NULL, NULL, 'Orthopoxvirus interleukin 18 binding protein', NULL, 'Pox_vIL-18BP', NULL, NULL, 13765, 9),
(255602, NULL, 'PF06560', NULL, NULL, 'Glucose-6-phosphate isomerase (GPI)', NULL, 'GPI', NULL, NULL, 8035, 9),
(255603, NULL, 'PF19810', NULL, NULL, 'Family of unknown function (DUF6293)', NULL, 'DUF6293', NULL, NULL, 37286, 9),
(255604, NULL, 'PF07721', NULL, NULL, 'Tetratricopeptide repeat', NULL, 'TPR_4', NULL, NULL, 8893, 9),
(255605, NULL, 'PF13857', NULL, NULL, 'Ankyrin repeats (many copies)', NULL, 'Ank_5', NULL, NULL, 1485, 9),
(255606, NULL, 'PF15212', NULL, NULL, 'Spermatogenesis-associated protein 19, mitochondrial', NULL, 'SPATA19', NULL, NULL, 23648, 9),
(255607, NULL, 'PF04197', NULL, NULL, 'Birnavirus RNA dependent RNA polymerase (VP1), palm domain', NULL, 'Birna_RdRp_palm', NULL, NULL, 418, 9),
(255608, NULL, 'PF05416', NULL, NULL, 'Southampton virus-type processing peptidase', NULL, 'Peptidase_C37', NULL, NULL, 3146, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(255609, NULL, 'PF11260', NULL, NULL, 'Major ampullate spidroin 1 and 2', NULL, 'Spidroin_MaSp', NULL, NULL, 14567, 9),
(255610, NULL, 'PF18777', NULL, NULL, 'Chromosome region maintenance or exportin repeat', NULL, 'CRM1_repeat', NULL, NULL, 28631, 9),
(255611, NULL, 'PF17093', NULL, NULL, 'Penicillin-binding protein N-terminus', NULL, 'PBP_N', NULL, NULL, 24358, 9),
(255612, NULL, 'PF10754', NULL, NULL, 'Protein of unknown function (DUF2569)', NULL, 'DUF2569', NULL, NULL, 20135, 9),
(255613, NULL, 'PF18148', NULL, NULL, 'Regulator of G-protein signalling DHEX domain', NULL, 'RGS_DHEX', NULL, NULL, 28541, 9),
(255614, NULL, 'PF02322', NULL, NULL, 'Cytochrome bd terminal oxidase subunit II', NULL, 'Cyt_bd_oxida_II', NULL, NULL, 4028, 9),
(255615, NULL, 'PF05167', NULL, NULL, 'Uncharacterised ACR (DUF711)', NULL, 'DUF711', NULL, NULL, 2365, 9),
(255616, NULL, 'PF12664', NULL, NULL, 'Protein of unknown function (DUF3789)', NULL, 'DUF3789', NULL, NULL, 24876, 9),
(255617, NULL, 'PF01992', NULL, NULL, 'ATP synthase (C/AC39) subunit', NULL, 'vATP-synt_AC39', NULL, NULL, 5433, 9),
(255618, NULL, 'PF19512', NULL, NULL, 'Domain of unknown function (DUF6046)', NULL, 'DUF6046', NULL, NULL, 37396, 9),
(255619, NULL, 'PF06324', NULL, NULL, 'Pigment-dispersing hormone (PDH)', NULL, 'Pigment_DH', NULL, NULL, 8039, 9),
(255620, NULL, 'PF19100', NULL, NULL, 'Family of unknown function (DUF5787)', NULL, 'DUF5787', NULL, NULL, 34487, 9),
(255621, NULL, 'PF17232', NULL, NULL, 'Elicitor peptide 1-7', NULL, 'Pep1_7', NULL, NULL, 20015, 9),
(255622, NULL, 'PF00730', NULL, NULL, 'HhH-GPD superfamily base excision DNA repair protein', NULL, 'HhH-GPD', NULL, NULL, 3330, 9),
(255623, NULL, 'PF10639', NULL, NULL, 'Putative transmembrane family 234', NULL, 'TMEM234', NULL, NULL, 20968, 9),
(255624, NULL, 'PF17517', NULL, NULL, 'IgGFc binding protein', NULL, 'IgGFc_binding', NULL, NULL, 15887, 9),
(255625, NULL, 'PF04662', NULL, NULL, 'Luteovirus P0 protein', NULL, 'Luteo_PO', NULL, NULL, 2524, 9),
(255626, NULL, 'PF05889', NULL, NULL, 'O-phosphoseryl-tRNA(Sec) selenium transferase, SepSecS', NULL, 'SepSecS', NULL, NULL, 13984, 9),
(255627, NULL, 'PF03604', NULL, NULL, 'DNA directed RNA polymerase, 7 kDa subunit', NULL, 'DNA_RNApol_7kD', NULL, NULL, 961, 9),
(255628, NULL, 'PF17198', NULL, NULL, 'Spirocyclase AveC-like', NULL, 'AveC_like', NULL, NULL, 31500, 9),
(255629, NULL, 'PF05992', NULL, NULL, 'SbmA/BacA-like family', NULL, 'SbmA_BacA', NULL, NULL, 13841, 9),
(255630, NULL, 'PF11523', NULL, NULL, 'Protein of unknown function (DUF3223)', NULL, 'DUF3223', NULL, NULL, NULL, 9),
(255631, NULL, 'PF14961', NULL, NULL, 'Broad-minded protein', NULL, 'BROMI', NULL, NULL, 26162, 9),
(255632, NULL, 'PF03141', NULL, NULL, 'Putative S-adenosyl-L-methionine-dependent methyltransferase', NULL, 'Methyltransf_29', NULL, NULL, 2825, 9),
(255633, NULL, 'PF04722', NULL, NULL, 'Ssu72-like protein', NULL, 'Ssu72', NULL, NULL, 3861, 9),
(255634, NULL, 'PF03436', NULL, NULL, 'Domain of unknown function (DUF281)', NULL, 'DUF281', NULL, NULL, 10988, 9),
(255635, NULL, 'PF09948', NULL, NULL, 'Predicted metal-binding integral membrane protein (DUF2182)', NULL, 'DUF2182', NULL, NULL, 17471, 9),
(255636, NULL, 'PF13464', NULL, NULL, 'Domain of unknown function (DUF4115)', NULL, 'DUF4115', NULL, NULL, 22983, 9),
(255637, NULL, 'PF00028', NULL, NULL, 'Cadherin domain', NULL, 'Cadherin', NULL, NULL, 1262, 9),
(255638, NULL, 'PF18784', NULL, NULL, 'CRM1 / Exportin repeat 2', NULL, 'CRM1_repeat_2', NULL, NULL, 29051, 9),
(255639, NULL, 'PF18372', NULL, NULL, 'Integrin beta epidermal growth factor like domain 1', NULL, 'I-EGF_1', NULL, NULL, 28139, 9),
(255640, NULL, 'PF10117', NULL, NULL, 'McrBC 5-methylcytosine restriction system component', NULL, 'McrBC', NULL, NULL, 19883, 9),
(255641, NULL, 'PF13371', NULL, NULL, 'Tetratricopeptide repeat', NULL, 'TPR_9', NULL, NULL, NULL, 9),
(255642, NULL, 'PF11819', NULL, NULL, 'Cytohesin Ubiquitin Protein Inducing Domain', NULL, 'CUPID', NULL, NULL, 19127, 9),
(255643, NULL, 'PF07500', NULL, NULL, 'Transcription factor S-II (TFIIS), central domain', NULL, 'TFIIS_M', NULL, NULL, 648, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(255644, NULL, 'PF18592', NULL, NULL, 'Tho1/MOS11 C-terminal domain', NULL, 'Tho1_MOS11_C', NULL, NULL, 29390, 9),
(255645, NULL, 'PF06705', NULL, NULL, 'SF-assemblin/beta giardin', NULL, 'SF-assemblin', NULL, NULL, 7869, 9),
(255646, NULL, 'PF06651', NULL, NULL, 'Protein of unknown function (DUF1163)', NULL, 'DUF1163', NULL, NULL, 10440, 9),
(255647, NULL, 'PF17926', NULL, NULL, 'Tetracyclin repressor-like, C-terminal domain', NULL, 'TetR_C_21', NULL, NULL, 29860, 9),
(255648, NULL, 'PF18271', NULL, NULL, 'Glycoside hydrolase 131 catalytic N-terminal domain', NULL, 'GH131_N', NULL, NULL, 30000, 9),
(255649, NULL, 'PF05634', NULL, NULL, 'APO RNA-binding', NULL, 'APO_RNA-bind', NULL, NULL, 15604, 9),
(255650, NULL, 'PF06456', NULL, NULL, 'Arfaptin-like domain', NULL, 'Arfaptin', NULL, NULL, 10372, 9),
(255651, NULL, 'PF07343', NULL, NULL, 'Protein of unknown function (DUF1475)', NULL, 'DUF1475', NULL, NULL, 8486, 9),
(255652, NULL, 'PF13602', NULL, NULL, 'Zinc-binding dehydrogenase', NULL, 'ADH_zinc_N_2', NULL, NULL, NULL, 9),
(255653, NULL, 'PF20431', NULL, NULL, 'E motif', NULL, 'E_motif', NULL, NULL, 33786, 9),
(255654, NULL, 'PF15255', NULL, NULL, 'WASH complex subunit CAP-Z interacting, central region', NULL, 'CAP-ZIP_m', NULL, NULL, 23651, 9),
(255655, NULL, 'PF17181', NULL, NULL, 'Epidermal patterning factor proteins', NULL, 'EPF', NULL, NULL, NULL, 9),
(255656, NULL, 'PF06005', NULL, NULL, 'Cell division protein ZapB', NULL, 'ZapB', NULL, NULL, 13952, 9),
(255657, NULL, 'PF10675', NULL, NULL, 'Protein of unknown function (DUF2489)', NULL, 'DUF2489', NULL, NULL, 20146, 9),
(255658, NULL, 'PF00466', NULL, NULL, 'Ribosomal protein L10', NULL, 'Ribosomal_L10', NULL, NULL, 4424, 9),
(255659, NULL, 'PF14804', NULL, NULL, 'Jag N-terminus', NULL, 'Jag_N', NULL, NULL, 22159, 9),
(255660, NULL, 'PF05688', NULL, NULL, 'Bacterial Immunoglobulin-like 21', NULL, 'BIg21', NULL, NULL, 13034, 9),
(255661, NULL, 'PF09149', NULL, NULL, 'Domain of unknown function (DUF1935)', NULL, 'DUF1935', NULL, NULL, 10779, 9),
(255662, NULL, 'PF00467', NULL, NULL, 'KOW motif', NULL, 'KOW', NULL, NULL, 5911, 9),
(255663, NULL, 'PF09284', NULL, NULL, 'Rhamnogalacturonan lyase B, N-terminal', NULL, 'RhgB_N', NULL, NULL, 13694, 9),
(255664, NULL, 'PF10763', NULL, NULL, 'Protein of unknown function (DUF2584)', NULL, 'DUF2584', NULL, NULL, 20309, 9),
(255665, NULL, 'PF06737', NULL, NULL, 'Transglycosylase-like domain', NULL, 'Transglycosylas', NULL, NULL, 8490, 9),
(255666, NULL, 'PF07478', NULL, NULL, 'D-ala D-ala ligase C-terminus', NULL, 'Dala_Dala_lig_C', NULL, NULL, 11088, 9),
(255667, NULL, 'PF09317', NULL, NULL, 'Acyl-CoA dehydrogenase, C-terminal, bacterial type', NULL, 'ACDH_C', NULL, NULL, 14128, 9),
(255668, NULL, 'PF03676', NULL, NULL, 'Phagosome assembly factor 1', NULL, 'PHAF1', NULL, NULL, 6319, 9),
(255669, NULL, 'PF08960', NULL, NULL, 'STIV B116-like', NULL, 'STIV_B116-like', NULL, NULL, 8978, 9),
(255670, NULL, 'PF00563', NULL, NULL, 'EAL domain', NULL, 'EAL', NULL, NULL, 5479, 9),
(255671, NULL, 'PF04665', NULL, NULL, 'Poxvirus A32 protein', NULL, 'Pox_A32', NULL, NULL, 3284, 9),
(255672, NULL, 'PF13554', NULL, NULL, 'Bacteriophage related domain of unknown function', NULL, 'DUF4128', NULL, NULL, 22373, 9),
(255673, NULL, 'PF07419', NULL, NULL, 'PilM', NULL, 'PilM', NULL, NULL, 8402, 9),
(255674, NULL, 'PF15582', NULL, NULL, 'Immunity protein 65', NULL, 'Imm65', NULL, NULL, 24605, 9),
(255675, NULL, 'PF07651', NULL, NULL, 'ANTH domain', NULL, 'ANTH', NULL, NULL, 13818, 9),
(255676, NULL, 'PF16721', NULL, NULL, 'Zinc-finger like, probable DNA-binding', NULL, 'zf-H3C2', NULL, NULL, 31160, 9),
(255677, NULL, 'PF04345', NULL, NULL, 'Chorismate lyase', NULL, 'Chor_lyase', NULL, NULL, 4455, 9),
(255678, NULL, 'PF20492', NULL, NULL, 'Ezrin/radixin/moesin, alpha-helical domain', NULL, 'ERM_helical', NULL, NULL, 36993, 9),
(255679, NULL, 'PF04531', NULL, NULL, 'Bacteriophage holin', NULL, 'Phage_holin_1', NULL, NULL, 6173, 9),
(255680, NULL, 'PF00200', NULL, NULL, 'Disintegrin', NULL, 'Disintegrin', NULL, NULL, 3118, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(255681, NULL, 'PF02450', NULL, NULL, 'Lecithin:cholesterol acyltransferase', NULL, 'LCAT', NULL, NULL, 4450, 9),
(255682, NULL, 'PF11009', NULL, NULL, 'Protein of unknown function (DUF2847)', NULL, 'DUF2847', NULL, NULL, 16482, 9),
(255683, NULL, 'PF20373', NULL, NULL, 'Family of unknown function (DUF6668)', NULL, 'DUF6668', NULL, NULL, 33626, 9),
(255684, NULL, 'PF04943', NULL, NULL, 'Poxvirus F11 protein', NULL, 'Pox_F11', NULL, NULL, 6743, 9),
(255685, NULL, 'PF13378', NULL, NULL, 'Enolase C-terminal domain-like', NULL, 'MR_MLE_C', NULL, NULL, 24745, 9),
(255686, NULL, 'PF05618', NULL, NULL, 'Putative ATP-dependant zinc protease', NULL, 'Zn_protease', NULL, NULL, 12147, 9),
(255687, NULL, 'PF09622', NULL, NULL, 'Putative integral membrane protein (DUF2391)', NULL, 'DUF2391', NULL, NULL, 21747, 9),
(255688, NULL, 'PF18407', NULL, NULL, 'GCN5-related N-acetyltransferase like domain', NULL, 'GNAT_like', NULL, NULL, 28795, 9),
(255689, NULL, 'PF14790', NULL, NULL, 'Tetrahydrodipicolinate N-succinyltransferase N-terminal', NULL, 'THDPS_N', NULL, NULL, NULL, 9),
(255690, NULL, 'PF06500', NULL, NULL, 'Esterase FrsA-like', NULL, 'FrsA-like', NULL, NULL, 12200, 9),
(255691, NULL, 'PF18028', NULL, NULL, 'Zmiz1 N-terminal tetratricopeptide repeat domain', NULL, 'Zmiz1_N', NULL, NULL, 29328, 9),
(255692, NULL, 'PF04576', NULL, NULL, 'Zein-binding', NULL, 'Zein-binding', NULL, NULL, 427, 9),
(255693, NULL, 'PF17960', NULL, NULL, 'TIG domain', NULL, 'TIG_plexin', NULL, NULL, 31053, 9),
(255694, NULL, 'PF11069', NULL, NULL, 'Cilia- and flagella-associated protein 298', NULL, 'CFAP298', NULL, NULL, 17512, 9),
(255695, NULL, 'PF08230', NULL, NULL, 'CW_7 repeat', NULL, 'CW_7', NULL, NULL, 8866, 9),
(255696, NULL, 'PF11438', NULL, NULL, '36-mer N-terminal peptide of the N protein (N36)', NULL, 'N36', NULL, NULL, 15582, 9),
(255697, NULL, 'PF15120', NULL, NULL, 'Sperm acrosome-associated protein 9', NULL, 'SPACA9', NULL, NULL, 21775, 9),
(255698, NULL, 'PF20285', NULL, NULL, 'C-terminal domain 9 of the ABC-three component (ABC-3C) systems', NULL, 'CTD9', NULL, NULL, 34198, 9),
(255699, NULL, 'PF02749', NULL, NULL, 'Quinolinate phosphoribosyl transferase, N-terminal domain', NULL, 'QRPTase_N', NULL, NULL, 21195, 9),
(255700, NULL, 'PF08847', NULL, NULL, 'Chlororespiratory reduction 6', NULL, 'Crr6', NULL, NULL, 14346, 9),
(255701, NULL, 'PF11966', NULL, NULL, 'SSURE domain', NULL, 'SSURE', NULL, NULL, 15487, 9),
(255702, NULL, 'PF14635', NULL, NULL, 'Helix-hairpin-helix motif', NULL, 'HHH_7', NULL, NULL, 21722, 9),
(255703, NULL, 'PF03559', NULL, NULL, 'NDP-hexose 2,3-dehydratase', NULL, 'Hexose_dehydrat', NULL, NULL, 5422, 9),
(255704, NULL, 'PF14856', NULL, NULL, 'Pathogen effector; putative necrosis-inducing factor', NULL, 'Hce2', NULL, NULL, 26534, 9),
(255705, NULL, 'PF02627', NULL, NULL, 'Carboxymuconolactone decarboxylase family', NULL, 'CMD', NULL, NULL, 6203, 9),
(255706, NULL, 'PF12047', NULL, NULL, 'Cytosine specific DNA methyltransferase replication foci domain', NULL, 'DNMT1-RFD', NULL, NULL, 16940, 9),
(255707, NULL, 'PF03645', NULL, NULL, 'Tctex-1 family', NULL, 'Tctex-1', NULL, NULL, 5675, 9),
(255708, NULL, 'PF18005', NULL, NULL, 'eIF3 subunit M, C-terminal helix', NULL, 'eIF3m_C_helix', NULL, NULL, 28986, 9),
(255709, NULL, 'PF18397', NULL, NULL, 'IQBAL scaffold dimerization domain', NULL, 'IKBKB_SDD', NULL, NULL, 28802, 9),
(255710, NULL, 'PF18539', NULL, NULL, 'Domain of unknown function (DUF5625)', NULL, 'DUF5625', NULL, NULL, 29448, 9),
(255711, NULL, 'PF19703', NULL, NULL, 'Family of unknown function (DUF6201)', NULL, 'DUF6201', NULL, NULL, 36001, 9),
(255712, NULL, 'PF03133', NULL, NULL, 'Tubulin-tyrosine ligase family', NULL, 'TTL', NULL, NULL, 4887, 9),
(255713, NULL, 'PF07185', NULL, NULL, 'Protein of unknown function (DUF1404)', NULL, 'DUF1404', NULL, NULL, 13258, 9),
(255714, NULL, 'PF17834', NULL, NULL, 'Beta-sandwich domain in beta galactosidase', NULL, 'GHD', NULL, NULL, 29002, 9),
(255715, NULL, 'PF05247', NULL, NULL, 'Flagellar transcriptional activator (FlhD)', NULL, 'FlhD', NULL, NULL, 10349, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(255716, NULL, 'PF19104', NULL, NULL, 'Family of unknown function (DUF5791)', NULL, 'DUF5791', NULL, NULL, 35669, 9),
(255717, NULL, 'PF04570', NULL, NULL, 'zinc-finger of the FCS-type, C2-C2', NULL, 'zf-FLZ', NULL, NULL, 49, 9),
(255718, NULL, 'PF11150', NULL, NULL, 'Protein of unknown function (DUF2927)', NULL, 'DUF2927', NULL, NULL, 17980, 9),
(255719, NULL, 'PF07069', NULL, NULL, 'Porcine reproductive and respiratory syndrome virus 2b', NULL, 'PRRSV_2b', NULL, NULL, 12565, 9),
(255720, NULL, 'PF04869', NULL, NULL, 'Uso1 / p115 like vesicle tethering protein, head region', NULL, 'Uso1_p115_head', NULL, NULL, 5543, 9),
(255721, NULL, 'PF06640', NULL, NULL, 'P protein C-terminus', NULL, 'P_C', NULL, NULL, 8396, 9),
(255722, NULL, 'PF19635', NULL, NULL, 'Family of unknown function (DUF6138)', NULL, 'DUF6138', NULL, NULL, 37276, 9),
(255723, NULL, 'PF02195', NULL, NULL, 'ParB/Sulfiredoxin domain', NULL, 'ParBc', NULL, NULL, 1600, 9),
(255724, NULL, 'PF17658', NULL, NULL, 'Family of unknown function (DUF5520)', NULL, 'DUF5520', NULL, NULL, 27808, 9),
(255725, NULL, 'PF19470', NULL, NULL, 'Family of unknown function (DUF6007)', NULL, 'DUF6007', NULL, NULL, 36908, 9),
(255726, NULL, 'PF03701', NULL, NULL, 'Uncharacterised protein family (UPF0181)', NULL, 'UPF0181', NULL, NULL, 6023, 9),
(255727, NULL, 'PF08583', NULL, NULL, 'Cytochrome c oxidase biogenesis protein Cmc1 like', NULL, 'Cmc1', NULL, NULL, 17810, 9),
(255728, NULL, 'PF01824', NULL, NULL, 'MatK/TrnK amino terminal region', NULL, 'MatK_N', NULL, NULL, 26796, 9),
(255729, NULL, 'PF02969', NULL, NULL, 'TATA box binding protein associated factor (TAF)', NULL, 'TAF', NULL, NULL, 4037, 9),
(255730, NULL, 'PF06682', NULL, NULL, 'SOCE-associated regulatory factor of calcium homoeostasis', NULL, 'SARAF', NULL, NULL, 573, 9),
(255731, NULL, 'PF05567', NULL, NULL, 'Neisseria PilC beta-propeller domain', NULL, 'Neisseria_PilC', NULL, NULL, 13214, 9),
(255732, NULL, 'PF06621', NULL, NULL, 'Single-minded protein C-terminus', NULL, 'SIM_C', NULL, NULL, 8327, 9),
(255733, NULL, 'PF00145', NULL, NULL, 'C-5 cytosine-specific DNA methylase', NULL, 'DNA_methylase', NULL, NULL, 5274, 9),
(255734, NULL, 'PF07823', NULL, NULL, 'Cyclic phosphodiesterase-like protein', NULL, 'CPDase', NULL, NULL, 13018, 9),
(255735, NULL, 'PF04207', NULL, NULL, 'Tetrahydromethanopterin S-methyltransferase, subunit D', NULL, 'MtrD', NULL, NULL, 5976, 9),
(255736, NULL, 'PF20561', NULL, NULL, 'Domain of unknown function (DUF6771)', NULL, 'DUF6771', NULL, NULL, 37081, 9),
(255737, NULL, 'PF15393', NULL, NULL, 'Domain of unknown function (DUF4615)', NULL, 'DUF4615', NULL, NULL, 26291, 9),
(255738, NULL, 'PF16539', NULL, NULL, 'Flagellar assembly protein T, middle domain', NULL, 'FlgT_M', NULL, NULL, 25102, 9),
(255739, NULL, 'PF20287', NULL, NULL, 'SH3 fold domain associated with phage DNA polymerases', NULL, 'SH3DP', NULL, NULL, 34310, 9),
(255740, NULL, 'PF08885', NULL, NULL, 'GSCFA family', NULL, 'GSCFA', NULL, NULL, 14100, 9),
(255741, NULL, 'PF09243', NULL, NULL, 'Mitochondrial small ribosomal subunit Rsm22', NULL, 'Rsm22', NULL, NULL, 13248, 9),
(255742, NULL, 'PF14296', NULL, NULL, 'O-antigen polysaccharide polymerase Wzy', NULL, 'O-ag_pol_Wzy', NULL, NULL, 26538, 9),
(255743, NULL, 'PF03658', NULL, NULL, 'RnfH family Ubiquitin', NULL, 'Ub-RnfH', NULL, NULL, 6402, 9),
(255744, NULL, 'PF16740', NULL, NULL, 'Spindle and kinetochore-associated protein 2', NULL, 'SKA2', NULL, NULL, 30361, 9),
(255745, NULL, 'PF06487', NULL, NULL, 'Sin3 associated polypeptide p18 (SAP18)', NULL, 'SAP18', NULL, NULL, 12001, 9),
(255746, NULL, 'PF16111', NULL, NULL, 'Domain of unknown function (DUF4829)', NULL, 'DUF4829', NULL, NULL, 23734, 9),
(255747, NULL, 'PF06478', NULL, NULL, 'Coronavirus RNA-dependent RNA polymerase, N-terminal', NULL, 'CoV_RPol_N', NULL, NULL, 9056, 9),
(255748, NULL, 'PF20614', NULL, NULL, 'Homologues of viral RNAse III, found in viruses infecting fungi', NULL, 'Mycovirus_RNAse', NULL, NULL, 33783, 9),
(255749, NULL, 'PF20227', NULL, NULL, 'Family of unknown function (DUF6586)', NULL, 'DUF6586', NULL, NULL, 37596, 9);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(255750, NULL, 'PF12911', NULL, NULL, 'N-terminal TM domain of oligopeptide transport permease C', NULL, 'OppC_N', NULL, NULL, 24279, 9),
(255751, NULL, 'PF18614', NULL, NULL, 'RNase II-type exonuclease C-terminal S1 domain', NULL, 'RNase_II_C_S1', NULL, NULL, 27926, 9),
(255752, NULL, 'PF00754', NULL, NULL, 'F5/8 type C domain', NULL, 'F5_F8_type_C', NULL, NULL, 4934, 9),
(255753, NULL, 'PF04131', NULL, NULL, 'Putative N-acetylmannosamine-6-phosphate epimerase', NULL, 'NanE', NULL, NULL, 6524, 9),
(255754, NULL, 'PF16806', NULL, NULL, 'Antiactivator protein ExsD', NULL, 'ExsD', NULL, NULL, 22266, 9),
(255755, NULL, 'PF08740', NULL, NULL, 'BCS1 N terminal', NULL, 'BCS1_N', NULL, NULL, 11603, 9),
(255756, NULL, 'PF02697', NULL, NULL, 'Putative antitoxin', NULL, 'VAPB_antitox', NULL, NULL, 3198, 9),
(255757, NULL, 'PF18117', NULL, NULL, 'Enhanced disease susceptibility 1 protein EP domain', NULL, 'EDS1_EP', NULL, NULL, 29497, 9),
(255758, NULL, 'PF02104', NULL, NULL, 'SURF1 family', NULL, 'SURF1', NULL, NULL, 7455, 9),
(255759, NULL, 'PF09077', NULL, NULL, 'Mu B transposition protein, C terminal', NULL, 'Phage-MuB_C', NULL, NULL, 6024, 9),
(255760, NULL, 'PF14834', NULL, NULL, 'Glutathione S-transferase, C-terminal domain', NULL, 'GST_C_4', NULL, NULL, 367, 9),
(255761, NULL, 'PF14577', NULL, NULL, 'Sieve element occlusion C-terminus', NULL, 'SEO_C', NULL, NULL, 24157, 9),
(255762, NULL, 'PF20430', NULL, NULL, 'E+ motif', NULL, 'Eplus_motif', NULL, NULL, 33822, 9),
(255763, NULL, 'PF07227', NULL, NULL, 'PHD - plant homeodomain finger protein', NULL, 'PHD_Oberon', NULL, NULL, 22931, 9),
(255764, NULL, 'PF18984', NULL, NULL, 'Family of unknown function (DUF5717)N-terminal', NULL, 'DUF5717_N', NULL, NULL, 35875, 9),
(255765, NULL, 'PF04269', NULL, NULL, 'Protein of unknown function, DUF440', NULL, 'DUF440', NULL, NULL, 5843, 9),
(255766, NULL, 'PF10401', NULL, NULL, 'Interferon-regulatory factor 3', NULL, 'IRF-3', NULL, NULL, 17397, 9),
(255767, NULL, 'PF19417', NULL, NULL, 'RNase LS, bacterial toxin N-terminal', NULL, 'RnlA_toxin_N', NULL, NULL, 36277, 9),
(255768, NULL, 'PF00424', NULL, NULL, 'REV protein (anti-repression trans-activator protein)', NULL, 'REV', NULL, NULL, 5802, 9),
(255769, NULL, 'PF12808', NULL, NULL, 'Micro-tubular organiser Mto1 C-term Mto2-binding region', NULL, 'Mto2_bdg', NULL, NULL, 26299, 9),
(255770, NULL, 'PF16264', NULL, NULL, 'SatD family (SatD)', NULL, 'SatD', NULL, NULL, 21953, 9),
(255771, NULL, 'PF18743', NULL, NULL, 'REase_AHJR-like', NULL, 'AHJR-like', NULL, NULL, 33170, 9),
(255772, NULL, 'PF05901', NULL, NULL, 'Excalibur calcium-binding domain', NULL, 'Excalibur', NULL, NULL, 14325, 9),
(255773, NULL, 'PF01588', NULL, NULL, 'Putative tRNA binding domain', NULL, 'tRNA_bind', NULL, NULL, 1796, 9),
(255774, NULL, 'PF05653', NULL, NULL, 'Magnesium transporter NIPA', NULL, 'Mg_trans_NIPA', NULL, NULL, 13255, 9),
(255775, NULL, 'PF18873', NULL, NULL, 'Sgo0707 N-terminal domain', NULL, 'Sgo0707_N1', NULL, NULL, 34847, 9),
(255776, NULL, 'PF15907', NULL, NULL, 'Integrin-alpha FG-GAP repeat-containing protein 2', NULL, 'Itfg2', NULL, NULL, 24210, 9),
(255777, NULL, 'PF10091', NULL, NULL, 'Putative glucoamylase', NULL, 'Glycoamylase', NULL, NULL, 19655, 9),
(255778, NULL, 'PF15940', NULL, NULL, 'Family of unknown function', NULL, 'YjcB', NULL, NULL, 17646, 9),
(255779, NULL, 'PF17439', NULL, NULL, 'Family of unknown function (DUF5418)', NULL, 'DUF5418', NULL, NULL, 32157, 9),
(255780, NULL, 'PF11646', NULL, NULL, 'Protein of unknown function DUF3258', NULL, 'DUF3258', NULL, NULL, 18664, 9),
(255781, NULL, 'PF08782', NULL, NULL, 'c-SKI Smad4 binding domain', NULL, 'c-SKI_SMAD_bind', NULL, NULL, 13216, 9),
(255782, NULL, 'PF14924', NULL, NULL, 'Protein of unknown function (DUF4497)', NULL, 'DUF4497', NULL, NULL, NULL, 9),
(255783, NULL, 'PF07028', NULL, NULL, 'Protein of unknown function (DUF1319)', NULL, 'DUF1319', NULL, NULL, 9689, 9),
(255784, NULL, 'PF10343', NULL, NULL, 'Potential Queuosine, Q, salvage protein family', NULL, 'Q_salvage', NULL, NULL, 17086, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(255785, NULL, 'PF12640', NULL, NULL, 'UPF0489 domain', NULL, 'UPF0489', NULL, NULL, 8173, 9),
(255786, NULL, 'PF17428', NULL, NULL, 'Family of unknown function (DUF5412)', NULL, 'DUF5412', NULL, NULL, 28651, 9),
(255787, NULL, 'PF18569', NULL, NULL, 'Thioredoxin-like domain', NULL, 'Thioredoxin_16', NULL, NULL, 29663, 9),
(255788, NULL, 'PF17735', NULL, NULL, 'Biofilm surface layer A', NULL, 'BslA', NULL, NULL, 5669, 9),
(255789, NULL, 'PF12998', NULL, NULL, 'Inhibitor of growth proteins N-terminal histone-binding', NULL, 'ING', NULL, NULL, 22447, 9),
(255790, NULL, 'PF19336', NULL, NULL, 'Domain of unknown function (DUF5921)', NULL, 'DUF5921', NULL, NULL, 34326, 9),
(255791, NULL, 'PF07857', NULL, NULL, 'Transmembrane family, TMEM144 of transporters', NULL, 'TMEM144', NULL, NULL, 14385, 9),
(255792, NULL, 'PF09063', NULL, NULL, 'Phage PP7 coat protein', NULL, 'Phage_coat', NULL, NULL, 9848, 9),
(255793, NULL, 'PF01539', NULL, NULL, 'Hepatitis C virus envelope glycoprotein E1', NULL, 'HCV_env', NULL, NULL, 526, 9),
(255794, NULL, 'PF00258', NULL, NULL, 'Flavodoxin', NULL, 'Flavodoxin_1', NULL, NULL, 1968, 9),
(255795, NULL, 'PF09545', NULL, NULL, 'AccI restriction endonuclease', NULL, 'RE_AccI', NULL, NULL, 16804, 9),
(255796, NULL, 'PF09050', NULL, NULL, 'Stannin unstructured linker', NULL, 'SNN_linker', NULL, NULL, 9703, 9),
(255797, NULL, 'PF15400', NULL, NULL, 'Testis-expressed sequence 33 protein family', NULL, 'TEX33', NULL, NULL, 21675, 9),
(255798, NULL, 'PF00748', NULL, NULL, 'Calpain inhibitor', NULL, 'Calpain_inhib', NULL, NULL, 1119, 9),
(255799, NULL, 'PF00769', NULL, NULL, 'Ezrin/radixin/moesin family C terminal', NULL, 'ERM_C', NULL, NULL, 10623, 9),
(255800, NULL, 'PF20540', NULL, NULL, 'Family of unknown function (DUF6755)', NULL, 'DUF6755', NULL, NULL, 33918, 9),
(255801, NULL, 'PF01580', NULL, NULL, 'FtsK/SpoIIIE family', NULL, 'FtsK_SpoIIIE', NULL, NULL, 1835, 9),
(255802, NULL, 'PF10302', NULL, NULL, 'DSC E3 ubiquitin ligase complex subunit 3, ubiquitin-like domain', NULL, 'Dsc3_N', NULL, NULL, 16744, 9),
(255803, NULL, 'PF13118', NULL, NULL, 'Protein of unknown function (DUF3972)', NULL, 'DUF3972', NULL, NULL, 25897, 9),
(255804, NULL, 'PF10571', NULL, NULL, 'Uncharacterised protein family UPF0547', NULL, 'UPF0547', NULL, NULL, 20683, 9),
(255805, NULL, 'PF04550', NULL, NULL, 'Phage holin family 2', NULL, 'Phage_holin_3_2', NULL, NULL, 2254, 9),
(255806, NULL, 'PF18733', NULL, NULL, 'LA2681-like HEPN', NULL, 'HEPN_LA2681', NULL, NULL, 32255, 9),
(255807, NULL, 'PF19855', NULL, NULL, 'Family of unknown function (DUF6330)', NULL, 'DUF6330', NULL, NULL, 37693, 9),
(255808, NULL, 'PF04109', NULL, NULL, 'Autophagy protein ATG9', NULL, 'ATG9', NULL, NULL, 6846, 9),
(255809, NULL, 'PF07552', NULL, NULL, 'Spore Coat Protein X and V domain', NULL, 'Coat_X', NULL, NULL, 13912, 9),
(255810, NULL, 'PF03506', NULL, NULL, 'Influenza C non-structural protein (NS1)', NULL, 'Flu_C_NS1', NULL, NULL, 6316, 9),
(255811, NULL, 'PF14783', NULL, NULL, 'Ciliary BBSome complex subunit 2, middle region', NULL, 'BBS2_Mid', NULL, NULL, 21717, 9),
(255812, NULL, 'PF17392', NULL, NULL, 'Urocanase C-terminal domain', NULL, 'Urocanase_C', NULL, NULL, 15824, 9),
(255813, NULL, 'PF01060', NULL, NULL, 'Transthyretin-like family', NULL, 'TTR-52', NULL, NULL, 5860, 9),
(255814, NULL, 'PF18821', NULL, NULL, 'Large polyvalent protein-associated domain 7', NULL, 'LPD7', NULL, NULL, 28611, 9),
(255815, NULL, 'PF00803', NULL, NULL, '3A/RNA2 movement protein family', NULL, '3A', NULL, NULL, 5681, 9),
(255816, NULL, 'PF07188', NULL, NULL, 'Kaposi''s sarcoma-associated herpesvirus (KSHV) K8 protein', NULL, 'KSHV_K8', NULL, NULL, 10513, 9),
(255817, NULL, 'PF17683', NULL, NULL, 'TFIIF, beta subunit N-terminus', NULL, 'TFIIF_beta_N', NULL, NULL, 27587, 9),
(255818, NULL, 'PF08507', NULL, NULL, 'COPI associated protein', NULL, 'COPI_assoc', NULL, NULL, 14254, 9),
(255819, NULL, 'PF16895', NULL, NULL, 'Domain of unknown function (DUF5085)', NULL, 'DUF5085', NULL, NULL, 22746, 9),
(255820, NULL, 'PF14690', NULL, NULL, 'zinc-finger of transposase IS204/IS1001/IS1096/IS1165', NULL, 'zf-ISL3', NULL, NULL, 21892, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(255821, NULL, 'PF13552', NULL, NULL, 'Protein of unknown function (DUF4127)', NULL, 'DUF4127', NULL, NULL, 22069, 9),
(255822, NULL, 'PF14833', NULL, NULL, 'NAD-binding of NADP-dependent 3-hydroxyisobutyrate dehydrogenase', NULL, 'NAD_binding_11', NULL, NULL, 24313, 9),
(255823, NULL, 'PF03035', NULL, NULL, 'Calicivirus putative RNA polymerase/capsid protein', NULL, 'RNA_capsid', NULL, NULL, 4788, 9),
(255824, NULL, 'PF14268', NULL, NULL, 'YoaP-like', NULL, 'YoaP', NULL, NULL, 24845, 9),
(255825, NULL, 'PF18653', NULL, NULL, 'Arcadin 1', NULL, 'Arcadin_1', NULL, NULL, 32171, 9),
(255826, NULL, 'PF12642', NULL, NULL, 'Conjugative transposon protein TcpC', NULL, 'TpcC', NULL, NULL, 10533, 9),
(255827, NULL, 'PF20526', NULL, NULL, 'Domain of unknown function (DUF6741)', NULL, 'DUF6741', NULL, NULL, 33887, 9),
(255828, NULL, 'PF07061', NULL, NULL, 'Swi5', NULL, 'Swi5', NULL, NULL, 9669, 9),
(255829, NULL, 'PF15279', NULL, NULL, 'Sine oculis-binding protein', NULL, 'SOBP', NULL, NULL, 24839, 9),
(255830, NULL, 'PF04379', NULL, NULL, 'ApaG domain', NULL, 'DUF525', NULL, NULL, 2182, 9),
(255831, NULL, 'PF14064', NULL, NULL, 'HmuY protein', NULL, 'HmuY', NULL, NULL, 24505, 9),
(255832, NULL, 'PF17519', NULL, NULL, 'Family of unknown function (DUF5444)', NULL, 'DUF5444', NULL, NULL, 20703, 9),
(255833, NULL, 'PF19194', NULL, NULL, 'Family of unknown function (DUF5869)', NULL, 'DUF5869', NULL, NULL, 35954, 9),
(255834, NULL, 'PF07891', NULL, NULL, 'Protein of unknown function (DUF1666)', NULL, 'DUF1666', NULL, NULL, 12477, 9),
(255835, NULL, 'PF11174', NULL, NULL, 'Protein of unknown function (DUF2970)', NULL, 'DUF2970', NULL, NULL, 18460, 9),
(255836, NULL, 'PF04836', NULL, NULL, 'Interferon-related protein conserved region', NULL, 'IFRD_C', NULL, NULL, 4999, 9),
(255837, NULL, 'PF09370', NULL, NULL, 'Phosphoenolpyruvate hydrolase-like', NULL, 'PEP_hydrolase', NULL, NULL, 10468, 9),
(255838, NULL, 'PF15766', NULL, NULL, 'Domain of unknown function (DUF4695)', NULL, 'DUF4695', NULL, NULL, 26789, 9),
(255839, NULL, 'PF18609', NULL, NULL, 'Exuperantia SAM-like domain', NULL, 'SAM_Exu', NULL, NULL, 29094, 9),
(255840, NULL, 'PF14543', NULL, NULL, 'Xylanase inhibitor N-terminal', NULL, 'TAXi_N', NULL, NULL, 25065, 9),
(255841, NULL, 'PF16931', NULL, NULL, 'Putative phage holin', NULL, 'Phage_holin_8', NULL, NULL, 21531, 9),
(255842, NULL, 'PF13018', NULL, NULL, 'Extended Signal Peptide of Type V secretion system', NULL, 'ESPR', NULL, NULL, 26382, 9),
(255843, NULL, 'PF18140', NULL, NULL, 'Propionyl-coenzyme A carboxylase BT domain', NULL, 'PCC_BT', NULL, NULL, 29303, 9),
(255844, NULL, 'PF06123', NULL, NULL, 'Inner membrane protein CreD', NULL, 'CreD', NULL, NULL, 8821, 9),
(255845, NULL, 'PF02270', NULL, NULL, 'TFIIF, beta subunit HTH domain', NULL, 'TFIIF_beta', NULL, NULL, 32441, 9),
(255846, NULL, 'PF07459', NULL, NULL, 'CTX phage RstB protein', NULL, 'CTX_RstB', NULL, NULL, 8656, 9),
(255847, NULL, 'PF19787', NULL, NULL, 'Family of unknown function (DUF6271)', NULL, 'DUF6271', NULL, NULL, 37063, 9),
(255848, NULL, 'PF01560', NULL, NULL, 'Hepatitis C virus non-structural protein E2/NS1', NULL, 'HCV_NS1', NULL, NULL, 826, 9),
(255849, NULL, 'PF15203', NULL, NULL, 'TMEM95 family', NULL, 'TMEM95', NULL, NULL, 24696, 9),
(255850, NULL, 'PF17237', NULL, NULL, 'ERMES regulator 1', NULL, 'Emr1', NULL, NULL, 20108, 9),
(255851, NULL, 'PF11268', NULL, NULL, 'Protein of unknown function (DUF3071)', NULL, 'DUF3071', NULL, NULL, 18490, 9),
(255852, NULL, 'PF11883', NULL, NULL, 'Domain of unknown function (DUF3403)', NULL, 'DUF3403', NULL, NULL, 19982, 9),
(255853, NULL, 'PF11502', NULL, NULL, 'B-cell lymphoma 9 protein', NULL, 'BCL9', NULL, NULL, 7288, 9),
(255854, NULL, 'PF06371', NULL, NULL, 'Diaphanous GTPase-binding Domain', NULL, 'Drf_GBD', NULL, NULL, 10312, 9),
(255855, NULL, 'PF04337', NULL, NULL, 'Protein of unknown function, DUF480', NULL, 'DUF480', NULL, NULL, 3618, 9),
(255856, NULL, 'PF02126', NULL, NULL, 'Phosphotriesterase family', NULL, 'PTE', NULL, NULL, 5123, 9),
(255857, NULL, 'PF01778', NULL, NULL, 'Ribosomal L28e protein family', NULL, 'Ribosomal_L28e', NULL, NULL, 26598, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(255858, NULL, 'PF08478', NULL, NULL, 'POTRA domain, FtsQ-type', NULL, 'POTRA_1', NULL, NULL, 13502, 9),
(255859, NULL, 'PF01607', NULL, NULL, 'Chitin binding Peritrophin-A domain', NULL, 'CBM_14', NULL, NULL, 1623, 9),
(255860, NULL, 'PF14875', NULL, NULL, 'N-term cysteine-rich ER, FAM69', NULL, 'PIP49_N', NULL, NULL, 26993, 9),
(255861, NULL, 'PF20436', NULL, NULL, 'Archaeal LonB, AAA+ ATPase LID domain', NULL, 'LonB_AAA-LID', NULL, NULL, 36723, 9),
(255862, NULL, 'PF15171', NULL, NULL, 'Neuropeptide secretory protein family, NPQ, spexin', NULL, 'Spexin', NULL, NULL, 21682, 9),
(255863, NULL, 'PF15590', NULL, NULL, 'Immunity protein 27', NULL, 'Imm27', NULL, NULL, 24586, 9),
(255864, NULL, 'PF04167', NULL, NULL, 'Protein of unknown function (DUF402)', NULL, 'DUF402', NULL, NULL, 7279, 9),
(255865, NULL, 'PF04388', NULL, NULL, 'Hamartin protein', NULL, 'Hamartin', NULL, NULL, 10164, 9),
(255866, NULL, 'PF10849', NULL, NULL, 'Protein of unknown function (DUF2654)', NULL, 'DUF2654', NULL, NULL, 14875, 9),
(255867, NULL, 'PF03546', NULL, NULL, 'Treacher Collins syndrome protein Treacle', NULL, 'Treacle', NULL, NULL, 846, 9),
(255868, NULL, 'PF16710', NULL, NULL, 'N-terminal N1 domain of Vibrio phage CTXphi pIII', NULL, 'CTXphi_pIII-N1', NULL, NULL, 24475, 9),
(255869, NULL, 'PF05373', NULL, NULL, 'L-proline 3-hydroxylase, C-terminal', NULL, 'Pro_3_hydrox_C', NULL, NULL, 5165, 9),
(255870, NULL, 'PF13145', NULL, NULL, 'PPIC-type PPIASE domain', NULL, 'Rotamase_2', NULL, NULL, 4912, 9),
(255871, NULL, 'PF04634', NULL, NULL, 'Protein of unknown function, DUF600', NULL, 'DUF600', NULL, NULL, 2190, 9),
(255872, NULL, 'PF02471', NULL, NULL, 'Borrelia outer surface protein E', NULL, 'OspE', NULL, NULL, 6438, 9),
(255873, NULL, 'PF14202', NULL, NULL, 'Transposon-encoded protein TnpW', NULL, 'TnpW', NULL, NULL, 25789, 9),
(255874, NULL, 'PF03764', NULL, NULL, 'Elongation factor G, domain IV', NULL, 'EFG_IV', NULL, NULL, 1765, 9),
(255875, NULL, 'PF15552', NULL, NULL, 'Domain of unknown function (DUF4657)', NULL, 'DUF4657', NULL, NULL, 23501, 9),
(255876, NULL, 'PF13591', NULL, NULL, 'MerR HTH family regulatory protein', NULL, 'MerR_2', NULL, NULL, NULL, 9),
(255877, NULL, 'PF17859', NULL, NULL, 'Pelovaterin', NULL, 'Pelovaterin', NULL, NULL, 29819, 9),
(255878, NULL, 'PF07313', NULL, NULL, 'Protein of unknown function (DUF1460)', NULL, 'DUF1460', NULL, NULL, 11521, 9),
(255879, NULL, 'PF18256', NULL, NULL, 'Co-chaperone HscB tetracysteine metal binding motif', NULL, 'HscB_4_cys', NULL, NULL, 28028, 9),
(255880, NULL, 'PF20095', NULL, NULL, 'Domain of unknown function (DUF6485)', NULL, 'DUF6485', NULL, NULL, NULL, 9),
(255881, NULL, 'PF13442', NULL, NULL, 'Cytochrome C oxidase, cbb3-type, subunit III', NULL, 'Cytochrome_CBB3', NULL, NULL, 6205, 9),
(255882, NULL, 'PF16605', NULL, NULL, 'LSM-interacting associated unstructured', NULL, 'LSM_int_assoc', NULL, NULL, NULL, 9),
(255883, NULL, 'PF03301', NULL, NULL, 'Tryptophan 2,3-dioxygenase', NULL, 'Trp_dioxygenase', NULL, NULL, 852, 9),
(255884, NULL, 'PF01116', NULL, NULL, 'Fructose-bisphosphate aldolase class-II', NULL, 'F_bP_aldolase', NULL, NULL, 6927, 9),
(255885, NULL, 'PF02348', NULL, NULL, 'Cytidylyltransferase', NULL, 'CTP_transf_3', NULL, NULL, 4273, 9),
(255886, NULL, 'PF03793', NULL, NULL, 'PASTA domain', NULL, 'PASTA', NULL, NULL, 1695, 9),
(255887, NULL, 'PF10133', NULL, NULL, 'CO dehydrogenase accessory protein CooT', NULL, 'CooT', NULL, NULL, 14985, 9),
(255888, NULL, 'PF05521', NULL, NULL, 'Phage head-tail joining protein', NULL, 'Phage_H_T_join', NULL, NULL, 12153, 9),
(255889, NULL, 'PF05738', NULL, NULL, 'Cna protein B-type domain', NULL, 'Cna_B', NULL, NULL, 12010, 9),
(255890, NULL, 'PF09603', NULL, NULL, 'Fibrobacter succinogenes major domain (Fib_succ_major)', NULL, 'Fib_succ_major', NULL, NULL, 14481, 9),
(255891, NULL, 'PF05292', NULL, NULL, 'Malonyl-CoA decarboxylase C-terminal domain', NULL, 'MCD', NULL, NULL, 4368, 9),
(255892, NULL, 'PF12120', NULL, NULL, 'Rifampin ADP-ribosyl transferase', NULL, 'Arr-ms', NULL, NULL, 20354, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(255893, NULL, 'PF14958', NULL, NULL, 'ATPase PAAT-like', NULL, 'PAAT-like', NULL, NULL, 24445, 9),
(255894, NULL, 'PF00651', NULL, NULL, 'BTB/POZ domain', NULL, 'BTB', NULL, NULL, 1884, 9),
(255895, NULL, 'PF14365', NULL, NULL, 'Neprosin activation peptide', NULL, 'Neprosin_AP', NULL, NULL, 26047, 9),
(255896, NULL, 'PF16648', NULL, NULL, 'Unstructured region on Calpain-3', NULL, 'Calpain_u2', NULL, NULL, NULL, 9),
(255897, NULL, 'PF14524', NULL, NULL, 'Wzt C-terminal domain', NULL, 'Wzt_C', NULL, NULL, 25864, 9),
(255898, NULL, 'PF04089', NULL, NULL, 'BRICHOS domain', NULL, 'BRICHOS', NULL, NULL, 471, 9),
(255899, NULL, 'PF18199', NULL, NULL, 'Dynein heavy chain C-terminal domain', NULL, 'Dynein_C', NULL, NULL, 30127, 9),
(255900, NULL, 'PF07000', NULL, NULL, 'Protein of unknown function (DUF1308)', NULL, 'DUF1308', NULL, NULL, 9731, 9),
(255901, NULL, 'PF05758', NULL, NULL, 'Ycf1', NULL, 'Ycf1', NULL, NULL, 7685, 9),
(255902, NULL, 'PF02896', NULL, NULL, 'PEP-utilising enzyme, PEP-binding domain', NULL, 'PEP-utilizers_C', NULL, NULL, 1672, 9),
(255903, NULL, 'PF10750', NULL, NULL, 'Protein of unknown function (DUF2536)', NULL, 'DUF2536', NULL, NULL, 20269, 9),
(255904, NULL, 'PF11943', NULL, NULL, 'Protein of unknown function (DUF3460)', NULL, 'DUF3460', NULL, NULL, 19792, 9),
(255905, NULL, 'PF16546', NULL, NULL, 'Homodimerisation domain of SGTA', NULL, 'SGTA_dimer', NULL, NULL, 26779, 9),
(255906, NULL, 'PF04266', NULL, NULL, 'ASCH domain', NULL, 'ASCH', NULL, NULL, 5601, 9),
(255907, NULL, 'PF14426', NULL, NULL, 'Immunity protein Imm2', NULL, 'Imm2', NULL, NULL, 24554, 9),
(255908, NULL, 'PF05648', NULL, NULL, 'Peroxisomal biogenesis factor 11 (PEX11)', NULL, 'PEX11', NULL, NULL, 12194, 9),
(255909, NULL, 'PF10507', NULL, NULL, 'Transmembrane protein 65', NULL, 'TMEM65', NULL, NULL, 19245, 9),
(255910, NULL, 'PF14865', NULL, NULL, 'Macin', NULL, 'Macin', NULL, NULL, 26630, 9),
(255911, NULL, 'PF17863', NULL, NULL, 'AAA lid domain', NULL, 'AAA_lid_2', NULL, NULL, 29885, 9),
(255912, NULL, 'PF06971', NULL, NULL, 'Putative DNA-binding protein N-terminus', NULL, 'Put_DNA-bind_N', NULL, NULL, 12080, 9),
(255913, NULL, 'PF16371', NULL, NULL, 'N terminal of Calcineurin-like phosphoesterase', NULL, 'MetallophosN', NULL, NULL, 26013, 9),
(255914, NULL, 'PF10143', NULL, NULL, '2,3-bisphosphoglycerate-independent phosphoglycerate mutase', NULL, 'PhosphMutase', NULL, NULL, 7075, 9),
(255915, NULL, 'PF02657', NULL, NULL, 'Fe-S metabolism associated domain', NULL, 'SufE', NULL, NULL, 3029, 9),
(255916, NULL, 'PF12271', NULL, NULL, 'Chitin synthase export chaperone', NULL, 'Chs7', NULL, NULL, 20612, 9),
(255917, NULL, 'PF18362', NULL, NULL, 'Tri-helix bundle domain', NULL, 'THB', NULL, NULL, 32958, 9),
(255918, NULL, 'PF00321', NULL, NULL, 'Plant thionin', NULL, 'Thionin', NULL, NULL, 2130, 9),
(255919, NULL, 'PF01532', NULL, NULL, 'Glycosyl hydrolase family 47', NULL, 'Glyco_hydro_47', NULL, NULL, 6619, 9),
(255920, NULL, 'PF01540', NULL, NULL, 'Adhesin lipoprotein', NULL, 'Lipoprotein_7', NULL, NULL, 578, 9),
(255921, NULL, 'PF09359', NULL, NULL, 'VTC domain', NULL, 'VTC', NULL, NULL, 14934, 9),
(255922, NULL, 'PF08727', NULL, NULL, 'Poliovirus 3A protein like', NULL, 'P3A', NULL, NULL, 11994, 9),
(255923, NULL, 'PF12887', NULL, NULL, 'SICA extracellular alpha domain', NULL, 'SICA_alpha', NULL, NULL, 13061, 9),
(255924, NULL, 'PF05693', NULL, NULL, 'Glycogen synthase', NULL, 'Glycogen_syn', NULL, NULL, 14033, 9),
(255925, NULL, 'PF10691', NULL, NULL, 'Protein of unknown function (DUF2497)', NULL, 'DUF2497', NULL, NULL, 20887, 9),
(255926, NULL, 'PF13049', NULL, NULL, 'Protein of unknown function (DUF3910)', NULL, 'DUF3910', NULL, NULL, 22725, 9),
(255927, NULL, 'PF17430', NULL, NULL, 'Uncharacterized YqgC-like', NULL, 'YqgC', NULL, NULL, 12695, 9),
(255928, NULL, 'PF07602', NULL, NULL, 'Protein of unknown function (DUF1565)', NULL, 'DUF1565', NULL, NULL, 13926, 9),
(255929, NULL, 'PF11078', NULL, NULL, 'Optomotor-blind protein N-terminal region', NULL, 'Optomotor-blind', NULL, NULL, 15101, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(255930, NULL, 'PF05353', NULL, NULL, 'Delta Atracotoxin', NULL, 'Atracotoxin', NULL, NULL, 5383, 9),
(255931, NULL, 'PF15995', NULL, NULL, 'Domain of unknown function (DUF4771)', NULL, 'DUF4771', NULL, NULL, 24547, 9),
(255932, NULL, 'PF08830', NULL, NULL, 'Protein of unknown function (DUF1806)', NULL, 'DUF1806', NULL, NULL, 14005, 9),
(255933, NULL, 'PF20450', NULL, NULL, 'Papillomavirus E1, DNA-binding domain', NULL, 'PPV_E1_DBD', NULL, NULL, 34201, 9),
(255934, NULL, 'PF02158', NULL, NULL, 'Neuregulin intracellular region', NULL, 'Neuregulin', NULL, NULL, 322, 9),
(255935, NULL, 'PF08087', NULL, NULL, 'Conotoxin O-superfamily', NULL, 'Toxin_18', NULL, NULL, 9559, 9),
(255936, NULL, 'PF12314', NULL, NULL, 'Inner membrane complex protein', NULL, 'IMCp', NULL, NULL, 20746, 9),
(255937, NULL, 'PF16567', NULL, NULL, 'Pathogenicity island component CagD', NULL, 'CagD', NULL, NULL, 25338, 9),
(255938, NULL, 'PF04782', NULL, NULL, 'Protein of unknown function (DUF632)', NULL, 'DUF632', NULL, NULL, 4945, 9),
(255939, NULL, 'PF03936', NULL, NULL, 'Terpene synthase family, metal binding domain', NULL, 'Terpene_synth_C', NULL, NULL, 2907, 9),
(255940, NULL, 'PF16348', NULL, NULL, 'Coronavirus replicase NSP4, C-terminal', NULL, 'CoV_NSP4_C', NULL, NULL, 22378, 9),
(255941, NULL, 'PF08313', NULL, NULL, 'SCA7, zinc-binding domain', NULL, 'SCA7', NULL, NULL, 12761, 9),
(255942, NULL, 'PF05980', NULL, NULL, 'Toxin 7', NULL, 'Toxin_7', NULL, NULL, NULL, 9),
(255943, NULL, 'PF18924', NULL, NULL, 'Protein of unknown function (DUF5674)', NULL, 'DUF5674', NULL, NULL, 35774, 9),
(255944, NULL, 'PF12033', NULL, NULL, 'Protein of unknown function (DUF3519)', NULL, 'DUF3519', NULL, NULL, 19864, 9),
(255945, NULL, 'PF00714', NULL, NULL, 'Interferon gamma', NULL, 'IFN-gamma', NULL, NULL, 1035, 9),
(255946, NULL, 'PF09288', NULL, NULL, 'Fungal ubiquitin-associated domain', NULL, 'UBA_3', NULL, NULL, 14388, 9),
(255947, NULL, 'PF19967', NULL, NULL, 'vWA-MoxR associated protein middle region (VMAP-M) 5', NULL, 'VMAP-M5', NULL, NULL, 35982, 9),
(255948, NULL, 'PF10166', NULL, NULL, 'Uncharacterised conserved protein (DUF2368)', NULL, 'DUF2368', NULL, NULL, 14742, 9),
(255949, NULL, 'PF03652', NULL, NULL, 'Holliday junction resolvase', NULL, 'RuvX', NULL, NULL, 11163, 9),
(255950, NULL, 'PF11917', NULL, NULL, 'Protein of unknown function (DUF3435)', NULL, 'DUF3435', NULL, NULL, 19908, 9),
(255951, NULL, 'PF15975', NULL, NULL, 'Flotillin', NULL, 'Flot', NULL, NULL, 25630, 9),
(255952, NULL, 'PF07424', NULL, NULL, 'TrbM', NULL, 'TrbM', NULL, NULL, 8765, 9),
(255953, NULL, 'PF01579', NULL, NULL, 'Domain of unknown function (DUF19)', NULL, 'DUF19', NULL, NULL, 1832, 9),
(255954, NULL, 'PF13483', NULL, NULL, 'Beta-lactamase superfamily domain', NULL, 'Lactamase_B_3', NULL, NULL, NULL, 9),
(255955, NULL, 'PF09496', NULL, NULL, 'Cenp-O kinetochore centromere component', NULL, 'CENP-O', NULL, NULL, 9274, 9),
(255956, NULL, 'PF07506', NULL, NULL, 'RepB plasmid partitioning protein', NULL, 'RepB', NULL, NULL, 11295, 9),
(255957, NULL, 'PF18112', NULL, NULL, 'Autophagy receptor zinc finger-C2H2 domain', NULL, 'Zn-C2H2_12', NULL, NULL, 30161, 9),
(255958, NULL, 'PF18177', NULL, NULL, 'La HTH in kinetoplastid DICER domain', NULL, 'La_HTH_kDCL', NULL, NULL, 27292, 9),
(255959, NULL, 'PF10858', NULL, NULL, 'Protein of unknown function (DUF2659)', NULL, 'DUF2659', NULL, NULL, 16461, 9),
(255960, NULL, 'PF10912', NULL, NULL, 'Protein of unknown function (DUF2700)', NULL, 'DUF2700', NULL, NULL, 13928, 9),
(255961, NULL, 'PF20424', NULL, NULL, 'PilZN3 domain', NULL, 'PilZN3', NULL, NULL, 33713, 9),
(255962, NULL, 'PF09619', NULL, NULL, 'Type III secretion system lipoprotein chaperone (YscW)', NULL, 'YscW', NULL, NULL, 33377, 9),
(255963, NULL, 'PF12869', NULL, NULL, 'tRNA_anti-like', NULL, 'tRNA_anti-like', NULL, NULL, 22113, 9),
(255964, NULL, 'PF10873', NULL, NULL, 'Cysteine and tyrosine-rich protein 1', NULL, 'CYYR1', NULL, NULL, 17006, 9),
(255965, NULL, 'PF20089', NULL, NULL, 'Family of unknown function (DUF6481)', NULL, 'DUF6481', NULL, NULL, 37133, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(255966, NULL, 'PF18109', NULL, NULL, 'Ferredoxin I 4Fe-4S cluster domain', NULL, 'Fer4_24', NULL, NULL, NULL, 9),
(255967, NULL, 'PF11645', NULL, NULL, 'PD-(D/E)XK endonuclease', NULL, 'PDDEXK_5', NULL, NULL, 18685, 9),
(255968, NULL, 'PF20364', NULL, NULL, 'Family of unknown function (DUF6659)', NULL, 'DUF6659', NULL, NULL, 33940, 9),
(255969, NULL, 'PF19395', NULL, NULL, 'Family of unknown function (DUF5970)', NULL, 'DUF5970', NULL, NULL, 36697, 9),
(255970, NULL, 'PF09970', NULL, NULL, 'Nucleotidyl transferase of unknown function (DUF2204)', NULL, 'DUF2204', NULL, NULL, 17211, 9),
(255971, NULL, 'PF14759', NULL, NULL, 'Reductase C-terminal', NULL, 'Reductase_C', NULL, NULL, 21337, 9),
(255972, NULL, 'PF17592', NULL, NULL, 'Family of unknown function (DUF5489)', NULL, 'DUF5489', NULL, NULL, 18594, 9),
(255973, NULL, 'PF07679', NULL, NULL, 'Immunoglobulin I-set domain', NULL, 'I-set', NULL, NULL, 18841, 9),
(255974, NULL, 'PF03646', NULL, NULL, 'FlaG protein', NULL, 'FlaG', NULL, NULL, 5043, 9),
(255975, NULL, 'PF12250', NULL, NULL, 'Arabinofuranosyltransferase N terminal', NULL, 'AftA_N', NULL, NULL, 15728, 9),
(255976, NULL, 'PF13036', NULL, NULL, 'Peptidoglycan-synthase activator LpoB', NULL, 'LpoB', NULL, NULL, 14414, 9),
(255977, NULL, 'PF02113', NULL, NULL, 'D-Ala-D-Ala carboxypeptidase 3 (S13) family', NULL, 'Peptidase_S13', NULL, NULL, 6756, 9),
(255978, NULL, 'PF12759', NULL, NULL, 'InsA C-terminal domain', NULL, 'HTH_Tnp_IS1', NULL, NULL, 26688, 9),
(255979, NULL, 'PF19081', NULL, NULL, 'Ig-like domain CHU_C associated', NULL, 'Ig_7', NULL, NULL, 35605, 9),
(255980, NULL, 'PF07464', NULL, NULL, 'Apolipophorin-III precursor (apoLp-III)', NULL, 'ApoLp-III', NULL, NULL, 8539, 9),
(255981, NULL, 'PF07075', NULL, NULL, 'Protein of unknown function (DUF1343)', NULL, 'DUF1343', NULL, NULL, 8610, 9),
(255982, NULL, 'PF00430', NULL, NULL, 'ATP synthase B/B'' CF(0)', NULL, 'ATP-synt_B', NULL, NULL, 1150, 9),
(255983, NULL, 'PF03550', NULL, NULL, 'Outer membrane lipoprotein LolB', NULL, 'LolB', NULL, NULL, 577, 9),
(255984, NULL, 'PF10736', NULL, NULL, 'Protein of unknown function (DUF2627)', NULL, 'DUF2527', NULL, NULL, 19685, 9),
(255985, NULL, 'PF03549', NULL, NULL, 'Translocated intimin receptor (Tir) intimin-binding domain', NULL, 'Tir_receptor_M', NULL, NULL, 7399, 9),
(255986, NULL, 'PF05966', NULL, NULL, 'Chordopoxvirus A33R protein', NULL, 'Chordopox_A33R', NULL, NULL, 12664, 9),
(255987, NULL, 'PF09468', NULL, NULL, 'Ydr279p protein family (RNase H2 complex component) wHTH domain', NULL, 'RNase_H2-Ydr279', NULL, NULL, 15737, 9),
(255988, NULL, 'PF16970', NULL, NULL, 'Type-1 fimbrial protein, A', NULL, 'FimA', NULL, NULL, 31245, 9),
(255989, NULL, 'PF04417', NULL, NULL, 'Protein of unknown function (DUF501)', NULL, 'DUF501', NULL, NULL, 10773, 9),
(255990, NULL, 'PF16227', NULL, NULL, 'Domain of unknown function (DUF4886)', NULL, 'DUF4886', NULL, NULL, 26144, 9),
(255991, NULL, 'PF00241', NULL, NULL, 'Cofilin/tropomyosin-type actin-binding protein', NULL, 'Cofilin_ADF', NULL, NULL, 5363, 9),
(255992, NULL, 'PF08809', NULL, NULL, 'Phage related hypothetical protein (DUF1799)', NULL, 'DUF1799', NULL, NULL, 13158, 9),
(255993, NULL, 'PF13407', NULL, NULL, 'Periplasmic binding protein domain', NULL, 'Peripla_BP_4', NULL, NULL, 25694, 9),
(255994, NULL, 'PF05076', NULL, NULL, 'Suppressor of fused protein (SUFU)', NULL, 'SUFU', NULL, NULL, 14572, 9),
(255995, NULL, 'PF12995', NULL, NULL, 'Domain of unknown function, E. rectale Gene description (DUF3879)', NULL, 'DUF3879', NULL, NULL, 24939, 9),
(255996, NULL, 'PF08084', NULL, NULL, 'PROCT (NUC072) domain', NULL, 'PROCT', NULL, NULL, 12399, 9),
(255997, NULL, 'PF10022', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2264)', NULL, 'DUF2264', NULL, NULL, 19358, 9),
(255998, NULL, 'PF20260', NULL, NULL, 'RNA methyltransferase PUA domain', NULL, 'PUA_4', NULL, NULL, 36965, 9),
(255999, NULL, 'PF04596', NULL, NULL, 'Poxvirus protein F15', NULL, 'Pox_F15', NULL, NULL, 544, 9),
(256000, NULL, 'PF02277', NULL, NULL, 'Phosphoribosyltransferase', NULL, 'DBI_PRT', NULL, NULL, 1646, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(256001, NULL, 'PF17159', NULL, NULL, 'Membrane-associated sensor domain', NULL, 'MASE3', NULL, NULL, 31093, 9),
(256002, NULL, 'PF19565', NULL, NULL, 'Family of unknown function (DUF6087)', NULL, 'DUF6087', NULL, NULL, 34197, 9),
(256003, NULL, 'PF16009', NULL, NULL, 'Domain of unknown function (DUF4779)', NULL, 'DUF4779', NULL, NULL, 21759, 9),
(256004, NULL, 'PF17263', NULL, NULL, 'Family of unknown function (DUF5329)', NULL, 'DUF5329', NULL, NULL, 28482, 9),
(256005, NULL, 'PF20277', NULL, NULL, 'C-terminal domain 11 of the ABC-three component (ABC-3C) systems', NULL, 'CTD11', NULL, NULL, 34356, 9),
(256006, NULL, 'PF13911', NULL, NULL, 'AhpC/TSA antioxidant enzyme', NULL, 'AhpC-TSA_2', NULL, NULL, 22022, 9),
(256007, NULL, 'PF06796', NULL, NULL, 'Periplasmic nitrate reductase protein NapE', NULL, 'NapE', NULL, NULL, 9277, 9),
(256008, NULL, 'PF15455', NULL, NULL, 'Proline-rich 19', NULL, 'Pro-rich_19', NULL, NULL, 23338, 9),
(256009, NULL, 'PF04146', NULL, NULL, 'YT521-B-like domain', NULL, 'YTH', NULL, NULL, 7422, 9),
(256010, NULL, 'PF02579', NULL, NULL, 'Dinitrogenase iron-molybdenum cofactor', NULL, 'Nitro_FeMo-Co', NULL, NULL, 2159, 9),
(256011, NULL, 'PF17133', NULL, NULL, 'Domain of unknown function (DUF5108)', NULL, 'DUF5108', NULL, NULL, 30376, 9),
(256012, NULL, 'PF08172', NULL, NULL, 'CASP C terminal', NULL, 'CASP_C', NULL, NULL, 11858, 9),
(256013, NULL, 'PF12971', NULL, NULL, 'Alpha-N-acetylglucosaminidase (NAGLU) N-terminal domain', NULL, 'NAGLU_N', NULL, NULL, 13824, 9),
(256014, NULL, 'PF05539', NULL, NULL, 'Pneumovirinae attachment membrane glycoprotein G', NULL, 'Pneumo_att_G', NULL, NULL, 12326, 9),
(256015, NULL, 'PF18158', NULL, NULL, 'Adaptive response protein AidB N-terminal domain', NULL, 'AidB_N', NULL, NULL, 29278, 9),
(256016, NULL, 'PF11606', NULL, NULL, 'Family 31 carbohydrate binding protein', NULL, 'AlcCBM31', NULL, NULL, 15107, 9),
(256017, NULL, 'PF06837', NULL, NULL, 'Fijivirus P9-2 protein', NULL, 'Fijivirus_P9-2', NULL, NULL, 11136, 9),
(256018, NULL, 'PF12239', NULL, NULL, 'Protein of unknown function (DUF3605)', NULL, 'DUF3605', NULL, NULL, 20226, 9),
(256019, NULL, 'PF08588', NULL, NULL, 'Protein of unknown function (DUF1769)', NULL, 'DUF1769', NULL, NULL, 17820, 9),
(256020, NULL, 'PF03851', NULL, NULL, 'UV-endonuclease UvdE', NULL, 'UvdE', NULL, NULL, 532, 9),
(256021, NULL, 'PF06093', NULL, NULL, 'Spt4/RpoE2 zinc finger', NULL, 'Spt4', NULL, NULL, 17345, 9),
(256022, NULL, 'PF14428', NULL, NULL, 'Double-stranded DNA deaminase toxin A', NULL, 'DddA-like', NULL, NULL, 26340, 9),
(256023, NULL, 'PF18178', NULL, NULL, 'TIR- and PNP-associating SLOG family', NULL, 'TPALS', NULL, NULL, 29220, 9),
(256024, NULL, 'PF13177', NULL, NULL, 'DNA polymerase III, delta subunit', NULL, 'DNA_pol3_delta2', NULL, NULL, NULL, 9),
(256025, NULL, 'PF02202', NULL, NULL, 'Tachykinin family', NULL, 'Tachykinin', NULL, NULL, 609, 9),
(256026, NULL, 'PF08715', NULL, NULL, 'Coronavirus papain-like peptidase', NULL, 'CoV_peptidase', NULL, NULL, 18949, 9),
(256027, NULL, 'PF13031', NULL, NULL, 'Protein of unknown function (DUF3892)', NULL, 'DUF3892', NULL, NULL, 22862, 9),
(256028, NULL, 'PF07540', NULL, NULL, 'Nucleolar complex-associated protein', NULL, 'NOC3p', NULL, NULL, 12999, 9),
(256029, NULL, 'PF15930', NULL, NULL, 'Domain of unknown function', NULL, 'YdiH', NULL, NULL, 25532, 9),
(256030, NULL, 'PF06323', NULL, NULL, 'Phage antitermination protein Q', NULL, 'Phage_antiter_Q', NULL, NULL, 10014, 9),
(256031, NULL, 'PF13219', NULL, NULL, 'Protein of unknown function (DUF4027)', NULL, 'DUF4027', NULL, NULL, 22762, 9),
(256032, NULL, 'PF09272', NULL, NULL, 'Hepsin, SRCR domain', NULL, 'Hepsin-SRCR', NULL, NULL, 13446, 9),
(256033, NULL, 'PF18156', NULL, NULL, 'pPIWI_RE three-gene island domain Y', NULL, 'pPIWI_RE_Y', NULL, NULL, 29251, 9),
(256034, NULL, 'PF02495', NULL, NULL, 'Triple gene block 3', NULL, 'TGBp3', NULL, NULL, 5417, 9),
(256035, NULL, 'PF11587', NULL, NULL, 'Major prion protein bPrPp - N terminal', NULL, 'Prion_bPrPp', NULL, NULL, 25588, 9),
(256036, NULL, 'PF05932', NULL, NULL, 'Tir chaperone protein (CesT) family', NULL, 'CesT', NULL, NULL, 7815, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(256037, NULL, 'PF12118', NULL, NULL, 'SprA-related family', NULL, 'SprA-related', NULL, NULL, 20210, 9),
(256038, NULL, 'PF07444', NULL, NULL, 'Ycf66 protein N-terminus', NULL, 'Ycf66_N', NULL, NULL, 8693, 9),
(256039, NULL, 'PF13501', NULL, NULL, 'Sulfur oxidation protein SoxY', NULL, 'SoxY', NULL, NULL, 26606, 9),
(256040, NULL, 'PF08277', NULL, NULL, 'PAN-like domain', NULL, 'PAN_3', NULL, NULL, 288, 9),
(256041, NULL, 'PF17586', NULL, NULL, 'Family of unknown function (DUF5485)', NULL, 'DUF5485', NULL, NULL, 28390, 9),
(256042, NULL, 'PF06276', NULL, NULL, 'Ferric iron reductase FhuF-like transporter', NULL, 'FhuF', NULL, NULL, 17457, 9),
(256043, NULL, 'PF03334', NULL, NULL, 'Na+/H+ antiporter subunit', NULL, 'PhaG_MnhG_YufB', NULL, NULL, 7013, 9),
(256044, NULL, 'PF15934', NULL, NULL, 'Yuri gagarin', NULL, 'Yuri_gagarin', NULL, NULL, 25741, 9),
(256045, NULL, 'PF12101', NULL, NULL, 'Protein of unknown function (DUF3577)', NULL, 'DUF3577', NULL, NULL, 20487, 9),
(256046, NULL, 'PF05959', NULL, NULL, 'Nucleopolyhedrovirus protein of unknown function (DUF884)', NULL, 'DUF884', NULL, NULL, 12897, 9),
(256047, NULL, 'PF04158', NULL, NULL, 'Sof1-like domain', NULL, 'Sof1', NULL, NULL, 7136, 9),
(256048, NULL, 'PF13077', NULL, NULL, 'Protein of unknown function (DUF3909)', NULL, 'DUF3909', NULL, NULL, 22915, 9),
(256049, NULL, 'PF18456', NULL, NULL, 'Diiron non-heme beta-hydroxylase N-terminal domain', NULL, 'CmlA_N', NULL, NULL, 28908, 9),
(256050, NULL, 'PF03775', NULL, NULL, 'Septum formation inhibitor MinC, C-terminal domain', NULL, 'MinC_C', NULL, NULL, 1511, 9),
(256051, NULL, 'PF08168', NULL, NULL, 'NUC205 domain', NULL, 'NUC205', NULL, NULL, 9234, 9),
(256052, NULL, 'PF05270', NULL, NULL, 'Alpha-L-arabinofuranosidase B (ABFB) domain', NULL, 'AbfB', NULL, NULL, 4235, 9),
(256053, NULL, 'PF08994', NULL, NULL, 'T4 gene Gp59 loader of gp41 DNA helicase C-term', NULL, 'T4_Gp59_C', NULL, NULL, 8668, 9),
(256054, NULL, 'PF04917', NULL, NULL, 'Bacterial shufflon protein, N-terminal constant region', NULL, 'Shufflon_N', NULL, NULL, 6452, 9),
(256055, NULL, 'PF11143', NULL, NULL, 'Protein of unknown function (DUF2919)', NULL, 'DUF2919', NULL, NULL, 17933, 9),
(256056, NULL, 'PF12254', NULL, NULL, 'DNA polymerase alpha subunit p180 N terminal', NULL, 'DNA_pol_alpha_N', NULL, NULL, 6082, 9),
(256057, NULL, 'PF15410', NULL, NULL, 'Pleckstrin homology domain', NULL, 'PH_9', NULL, NULL, 29605, 9),
(256058, NULL, 'PF00385', NULL, NULL, 'Chromo (CHRromatin Organisation MOdifier) domain', NULL, 'Chromo', NULL, NULL, 16615, 9),
(256059, NULL, 'PF19007', NULL, NULL, 'Family of unknown function (DUF5736)', NULL, 'DUF5736', NULL, NULL, 35743, 9),
(256060, NULL, 'PF11085', NULL, NULL, 'Conserved membrane protein YqhR', NULL, 'YqhR', NULL, NULL, 26963, 9),
(256061, NULL, 'PF07562', NULL, NULL, 'Nine Cysteines Domain of family 3 GPCR', NULL, 'NCD3G', NULL, NULL, 12872, 9),
(256062, NULL, 'PF17010', NULL, NULL, 'Domain of unknown function (DUF5092)', NULL, 'DUF5092', NULL, NULL, 22050, 9),
(256063, NULL, 'PF20115', NULL, NULL, 'Family of unknown function (DUF6505)', NULL, 'DUF6505', NULL, NULL, 35880, 9),
(256064, NULL, 'PF20501', NULL, NULL, 'MBH, subunit E', NULL, 'MbhE', NULL, NULL, 33862, 9),
(256065, NULL, 'PF10956', NULL, NULL, 'Protein of unknown function (DUF2756)', NULL, 'DUF2756', NULL, NULL, 13713, 9),
(256066, NULL, 'PF13413', NULL, NULL, 'Helix-turn-helix domain', NULL, 'HTH_25', NULL, NULL, NULL, 9),
(256067, NULL, 'PF15662', NULL, NULL, 'Spermatogenesis-associated protein 3 family', NULL, 'SPATA3', NULL, NULL, 21851, 9),
(256068, NULL, 'PF16992', NULL, NULL, 'DNA-directed RNA polymerase, subunit G', NULL, 'RNA_pol_RpbG', NULL, NULL, 24403, 9),
(256069, NULL, 'PF13644', NULL, NULL, 'DKNYY family', NULL, 'DKNYY', NULL, NULL, 24228, 9),
(256070, NULL, 'PF10112', NULL, NULL, '5-bromo-4-chloroindolyl phosphate hydrolysis protein', NULL, 'Halogen_Hydrol', NULL, NULL, 18115, 9),
(256071, NULL, 'PF06629', NULL, NULL, 'MltA-interacting protein MipA', NULL, 'MipA', NULL, NULL, 8283, 9),
(256072, NULL, 'PF14433', NULL, NULL, 'SUKH-3 immunity protein', NULL, 'SUKH-3', NULL, NULL, 24338, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(256073, NULL, 'PF14662', NULL, NULL, 'Coiled-coil region of CCDC155 or KASH', NULL, 'KASH_CCD', NULL, NULL, 23568, 9),
(256074, NULL, 'PF01700', NULL, NULL, 'Orbivirus VP3 (T2) protein', NULL, 'Orbi_VP3', NULL, NULL, 1627, 9),
(256075, NULL, 'PF06877', NULL, NULL, 'Regulator of ribonuclease activity B', NULL, 'RraB', NULL, NULL, 11661, 9),
(256076, NULL, 'PF19465', NULL, NULL, 'Family of unknown function (DUF6002)', NULL, 'DUF6002', NULL, NULL, 36862, 9),
(256077, NULL, 'PF02993', NULL, NULL, 'Minor capsid protein VI', NULL, 'MCPVI', NULL, NULL, 3699, 9),
(256078, NULL, 'PF04370', NULL, NULL, 'Domain of unknown function (DUF508)', NULL, 'DUF508', NULL, NULL, 4618, 9),
(256079, NULL, 'PF02798', NULL, NULL, 'Glutathione S-transferase, N-terminal domain', NULL, 'GST_N', NULL, NULL, 978, 9),
(256080, NULL, 'PF06727', NULL, NULL, 'Protein of unknown function (DUF1207)', NULL, 'DUF1207', NULL, NULL, 1674, 9),
(256081, NULL, 'PF15059', NULL, NULL, 'Speriolin C-terminus', NULL, 'Speriolin_C', NULL, NULL, 26480, 9),
(256082, NULL, 'PF15281', NULL, NULL, 'Consortin C-terminus', NULL, 'Consortin_C', NULL, NULL, 21877, 9),
(256083, NULL, 'PF10480', NULL, NULL, 'Beta-1 integrin binding protein', NULL, 'ICAP-1_inte_bdg', NULL, NULL, 18395, 9),
(256084, NULL, 'PF03146', NULL, NULL, 'Agrin NtA domain', NULL, 'NtA', NULL, NULL, 7142, 9),
(256085, NULL, 'PF19040', NULL, NULL, 'SGNH domain (fused to AT3 domains)', NULL, 'SGNH', NULL, NULL, 34516, 9),
(256086, NULL, 'PF01915', NULL, NULL, 'Glycosyl hydrolase family 3 C-terminal domain', NULL, 'Glyco_hydro_3_C', NULL, NULL, 4731, 9),
(256087, NULL, 'PF07334', NULL, NULL, 'Interferon-induced 35 kDa protein (IFP 35) N-terminus', NULL, 'IFP_35_N', NULL, NULL, 8136, 9),
(256088, NULL, 'PF09467', NULL, NULL, 'Hypothetical protein Yopt', NULL, 'Yopt', NULL, NULL, 15372, 9),
(256089, NULL, 'PF14132', NULL, NULL, 'Domain of unknown function (DUF4299)', NULL, 'DUF4299', NULL, NULL, 26392, 9),
(256090, NULL, 'PF09558', NULL, NULL, 'Protein of unknown function (DUF2375)', NULL, 'DUF2375', NULL, NULL, 11355, 9),
(256091, NULL, 'PF15190', NULL, NULL, 'Transmembrane protein 251', NULL, 'TMEM251', NULL, NULL, 23869, 9),
(256092, NULL, 'PF07340', NULL, NULL, 'Cytomegalovirus IE1 protein', NULL, 'Herpes_IE1', NULL, NULL, 11985, 9),
(256093, NULL, 'PF03762', NULL, NULL, 'Vitelline membrane outer layer protein I (VOMI)', NULL, 'VOMI', NULL, NULL, 1610, 9),
(256094, NULL, 'PF13625', NULL, NULL, 'Helicase conserved C-terminal domain', NULL, 'Helicase_C_3', NULL, NULL, 21840, 9),
(256095, NULL, 'PF18186', NULL, NULL, 'SMODS and SLOG-associating 2TM effector domain family 4', NULL, 'SLATT_4', NULL, NULL, 29239, 9),
(256096, NULL, 'PF05731', NULL, NULL, 'TROVE domain', NULL, 'TROVE', NULL, NULL, 13855, 9),
(256097, NULL, 'PF04580', NULL, NULL, 'Chordopoxvirinae D3 protein', NULL, 'Pox_D3', NULL, NULL, 437, 9),
(256098, NULL, 'PF08042', NULL, NULL, 'PqqA family', NULL, 'PqqA', NULL, NULL, 11585, 9),
(256099, NULL, 'PF13268', NULL, NULL, 'Protein of unknown function (DUF4059)', NULL, 'DUF4059', NULL, NULL, 22526, 9),
(256100, NULL, 'PF01278', NULL, NULL, 'Omptin family', NULL, 'Omptin', NULL, NULL, 2728, 9),
(256101, NULL, 'PF01801', NULL, NULL, 'Cytomegalovirus glycoprotein L', NULL, 'Cytomega_gL', NULL, NULL, 2630, 9),
(256102, NULL, 'PF03214', NULL, NULL, 'Reversibly glycosylated polypeptide', NULL, 'RGP', NULL, NULL, 27113, 9),
(256103, NULL, 'PF05674', NULL, NULL, 'Baculovirus protein of unknown function (DUF816)', NULL, 'DUF816', NULL, NULL, 13164, 9),
(256104, NULL, 'PF17919', NULL, NULL, 'RNase H-like domain found in reverse transcriptase', NULL, 'RT_RNaseH_2', NULL, NULL, 30329, 9),
(256105, NULL, 'PF15136', NULL, NULL, 'Uncharacterised protein family UPF0449', NULL, 'UPF0449', NULL, NULL, 22691, 9),
(256106, NULL, 'PF03965', NULL, NULL, 'Penicillinase repressor', NULL, 'Penicillinase_R', NULL, NULL, 2883, 9),
(256107, NULL, 'PF07943', NULL, NULL, 'Penicillin-binding protein 5, C-terminal domain', NULL, 'PBP5_C', NULL, NULL, 13355, 9),
(256108, NULL, 'PF07308', NULL, NULL, 'Protein of unknown function (DUF1456)', NULL, 'DUF1456', NULL, NULL, 8260, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(256109, NULL, 'PF09238', NULL, NULL, 'Interleukin-4 receptor alpha chain, N-terminal', NULL, 'IL4Ra_N', NULL, NULL, 13432, 9),
(256110, NULL, 'PF18628', NULL, NULL, 'Viral coat protein P2 N-terminal domain', NULL, 'P2_N', NULL, NULL, 29492, 9),
(256111, NULL, 'PF04239', NULL, NULL, 'Protein of unknown function (DUF421)', NULL, 'DUF421', NULL, NULL, 5804, 9),
(256112, NULL, 'PF18911', NULL, NULL, 'PKD domain', NULL, 'PKD_4', NULL, NULL, NULL, 9),
(256113, NULL, 'PF15023', NULL, NULL, 'Protein of unknown function (DUF4523)', NULL, 'DUF4523', NULL, NULL, 22307, 9),
(256114, NULL, 'PF14090', NULL, NULL, 'Helix-turn-helix domain', NULL, 'HTH_39', NULL, NULL, NULL, 9),
(256115, NULL, 'PF09631', NULL, NULL, 'Sen15 protein', NULL, 'Sen15', NULL, NULL, 15634, 9),
(256116, NULL, 'PF05063', NULL, NULL, 'MT-A70', NULL, 'MT-A70', NULL, NULL, 1076, 9),
(256117, NULL, 'PF11851', NULL, NULL, 'Domain of unknown function (DUF3371)', NULL, 'DUF3371', NULL, NULL, 19279, 9),
(256118, NULL, 'PF04003', NULL, NULL, 'Dip2/Utp12 Family', NULL, 'Utp12', NULL, NULL, 409, 9),
(256119, NULL, 'PF05538', NULL, NULL, 'Campylobacter major outer membrane protein', NULL, 'Campylo_MOMP', NULL, NULL, 8997, 9),
(256120, NULL, 'PF11896', NULL, NULL, 'Alpha-1,4-glucan:maltose-1-phosphate maltosyltransferase, domain N/S', NULL, 'GlgE_dom_N_S', NULL, NULL, 19692, 9),
(256121, NULL, 'PF05479', NULL, NULL, 'Photosystem I reaction centre subunit N (PSAN or PSI-N)', NULL, 'PsaN', NULL, NULL, 13736, 9),
(256122, NULL, 'PF01183', NULL, NULL, 'Glycosyl hydrolases family 25', NULL, 'Glyco_hydro_25', NULL, NULL, 5032, 9),
(256123, NULL, 'PF14700', NULL, NULL, 'DNA-directed RNA polymerase N-terminal', NULL, 'RPOL_N', NULL, NULL, 21890, 9),
(256124, NULL, 'PF16334', NULL, NULL, 'Domain of unknown function (DUF4964)', NULL, 'DUF4964', NULL, NULL, 23897, 9),
(256125, NULL, 'PF13577', NULL, NULL, 'SnoaL-like domain', NULL, 'SnoaL_4', NULL, NULL, 33283, 9),
(256126, NULL, 'PF06525', NULL, NULL, 'Sulfocyanin (SoxE) domain', NULL, 'SoxE', NULL, NULL, NULL, 9),
(256127, NULL, 'PF09210', NULL, NULL, '1,4-alpha-glucan branching enzyme, C-terminal', NULL, 'BE_C', NULL, NULL, 12284, 9),
(256128, NULL, 'PF00038', NULL, NULL, 'Intermediate filament protein', NULL, 'Filament', NULL, NULL, 27398, 9),
(256129, NULL, 'PF16788', NULL, NULL, 'ATF-interacting protein binding domain', NULL, 'ATF7IP_BD', NULL, NULL, 26644, 9),
(256130, NULL, 'PF03730', NULL, NULL, 'Ku70/Ku80 C-terminal arm', NULL, 'Ku_C', NULL, NULL, 4079, 9),
(256131, NULL, 'PF17482', NULL, NULL, 'Phage tail sheath C-terminal domain', NULL, 'Phage_sheath_1C', NULL, NULL, 20801, 9),
(256132, NULL, 'PF07348', NULL, NULL, 'Syd protein (SUKH-2)', NULL, 'Syd', NULL, NULL, 8418, 9),
(256133, NULL, 'PF12146', NULL, NULL, 'Serine aminopeptidase, S33', NULL, 'Hydrolase_4', NULL, NULL, 16659, 9),
(256134, NULL, 'PF16403', NULL, NULL, 'Domain of unknown function (DUF5011)', NULL, 'DUF5011', NULL, NULL, 23618, 9),
(256135, NULL, 'PF14559', NULL, NULL, 'Tetratricopeptide repeat', NULL, 'TPR_19', NULL, NULL, NULL, 9),
(256136, NULL, 'PF07286', NULL, NULL, 'D-glutamate cyclase', NULL, 'D-Glu_cyclase', NULL, NULL, 14341, 9),
(256137, NULL, 'PF16876', NULL, NULL, 'Lipin/Ned1/Smp2 multi-domain protein middle domain', NULL, 'Lipin_mid', NULL, NULL, 24373, 9),
(256138, NULL, 'PF20479', NULL, NULL, 'TMEM128 protein', NULL, 'TMEM128', NULL, NULL, 31794, 9),
(256139, NULL, 'PF02008', NULL, NULL, 'CXXC zinc finger domain', NULL, 'zf-CXXC', NULL, NULL, 5579, 9),
(256140, NULL, 'PF08043', NULL, NULL, 'Xin repeat', NULL, 'Xin', NULL, NULL, 12629, 9),
(256141, NULL, 'PF03644', NULL, NULL, 'Glycosyl hydrolase family 85', NULL, 'Glyco_hydro_85', NULL, NULL, 6872, 9),
(256142, NULL, 'PF05055', NULL, NULL, 'Protein of unknown function (DUF677)', NULL, 'DUF677', NULL, NULL, 1190, 9),
(256143, NULL, 'PF01762', NULL, NULL, 'Galactosyltransferase', NULL, 'Galactosyl_T', NULL, NULL, 2626, 9),
(256144, NULL, 'PF07437', NULL, NULL, 'YfaZ precursor', NULL, 'YfaZ', NULL, NULL, 8962, 9),
(256145, NULL, 'PF12031', NULL, NULL, 'SWI/SNF-like complex subunit BAF250/Osa', NULL, 'BAF250_C', NULL, NULL, 30463, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(256146, NULL, 'PF03904', NULL, NULL, 'Domain of unknown function (DUF334)', NULL, 'DUF334', NULL, NULL, 2741, 9),
(256147, NULL, 'PF16056', NULL, NULL, 'Domain of unknown function (DUF4799)', NULL, 'DUF4799', NULL, NULL, 22921, 9),
(256148, NULL, 'PF09836', NULL, NULL, 'Putative DNA-binding domain', NULL, 'DUF2063', NULL, NULL, 16948, 9),
(256149, NULL, 'PF04461', NULL, NULL, 'Protein of unknown function (DUF520)', NULL, 'DUF520', NULL, NULL, 3556, 9),
(256150, NULL, 'PF15509', NULL, NULL, 'Domain of unknown function (DUF4650)', NULL, 'DUF4650', NULL, NULL, 24954, 9),
(256151, NULL, 'PF06109', NULL, NULL, 'Haemolysin E (HlyE)', NULL, 'HlyE', NULL, NULL, 23908, 9),
(256152, NULL, 'PF06401', NULL, NULL, 'Alpha-2-macroglobulin RAP, C-terminal domain', NULL, 'Alpha-2-MRAP_C', NULL, NULL, 10270, 9),
(256153, NULL, 'PF14306', NULL, NULL, 'PUA-like domain', NULL, 'PUA_2', NULL, NULL, 26908, 9),
(256154, NULL, 'PF09532', NULL, NULL, 'FDF domain', NULL, 'FDF', NULL, NULL, 16713, 9),
(256155, NULL, 'PF16206', NULL, NULL, 'C-terminal region of Mon2 protein', NULL, 'Mon2_C', NULL, NULL, 21564, 9),
(256156, NULL, 'PF04188', NULL, NULL, 'Mannosyltransferase (PIG-V)', NULL, 'Mannosyl_trans2', NULL, NULL, 4812, 9),
(256157, NULL, 'PF12954', NULL, NULL, 'Protein of unknown function (DUF3843)', NULL, 'DUF3843', NULL, NULL, 20941, 9),
(256158, NULL, 'PF09042', NULL, NULL, 'Titin Z', NULL, 'Titin_Z', NULL, NULL, 9591, 9),
(256159, NULL, 'PF06096', NULL, NULL, 'Baculoviridae 8.2 KDa protein', NULL, 'Baculo_8kDa', NULL, NULL, 13587, 9),
(256160, NULL, 'PF17820', NULL, NULL, 'PDZ domain', NULL, 'PDZ_6', NULL, NULL, 29983, 9),
(256161, NULL, 'PF19423', NULL, NULL, 'E3 ubiquitin-protein ligase UBR4 N-terminal', NULL, 'E3_UBR4_N', NULL, NULL, 36365, 9),
(256162, NULL, 'PF19206', NULL, NULL, 'Family of unknown function (DUF5878)', NULL, 'DUF5878', NULL, NULL, 35794, 9),
(256163, NULL, 'PF07680', NULL, NULL, 'TQO small subunit DoxA', NULL, 'DoxA', NULL, NULL, 10565, 9),
(256164, NULL, 'PF18522', NULL, NULL, 'Domain of unknown function (DUF5620)', NULL, 'DUF5620', NULL, NULL, 28600, 9),
(256165, NULL, 'PF06170', NULL, NULL, 'Protein of unknown function (DUF983)', NULL, 'DUF983', NULL, NULL, 14316, 9),
(256166, NULL, 'PF08937', NULL, NULL, 'MTH538 TIR-like domain (DUF1863)', NULL, 'DUF1863', NULL, NULL, 7671, 9),
(256167, NULL, 'PF11029', NULL, NULL, 'DAZ associated protein 2 (DAZAP2)', NULL, 'DAZAP2', NULL, NULL, 16918, 9),
(256168, NULL, 'PF02463', NULL, NULL, 'RecF/RecN/SMC N terminal domain', NULL, 'SMC_N', NULL, NULL, 5048, 9),
(256169, NULL, 'PF11476', NULL, NULL, 'Toxoplasma gondii micronemal protein 1 TgMIC1', NULL, 'TgMIC1', NULL, NULL, 9906, 9),
(256170, NULL, 'PF11594', NULL, NULL, 'Mediator complex subunit 28', NULL, 'Med28', NULL, NULL, NULL, 9),
(256171, NULL, 'PF03247', NULL, NULL, 'Prothymosin/parathymosin family', NULL, 'Prothymosin', NULL, NULL, 1622, 9),
(256172, NULL, 'PF02796', NULL, NULL, 'Helix-turn-helix domain of resolvase', NULL, 'HTH_7', NULL, NULL, 10075, 9),
(256173, NULL, 'PF10323', NULL, NULL, 'Serpentine type 7TM GPCR chemoreceptor Srv', NULL, '7TM_GPCR_Srv', NULL, NULL, 17095, 9),
(256174, NULL, 'PF00101', NULL, NULL, 'Ribulose bisphosphate carboxylase, small chain', NULL, 'RuBisCO_small', NULL, NULL, 3362, 9),
(256175, NULL, 'PF06578', NULL, NULL, 'YOP proteins translocation protein K (YscK)', NULL, 'YscK', NULL, NULL, 9328, 9),
(256176, NULL, 'PF09605', NULL, NULL, 'Hypothetical bacterial integral membrane protein (Trep_Strep)', NULL, 'Trep_Strep', NULL, NULL, 11997, 9),
(256177, NULL, 'PF03038', NULL, NULL, 'UL95 family', NULL, 'Herpes_UL95', NULL, NULL, 4521, 9),
(256178, NULL, 'PF07289', NULL, NULL, 'Bardet-Biedl syndrome 5 protein', NULL, 'BBL5', NULL, NULL, 1164, 9),
(256179, NULL, 'PF16236', NULL, NULL, 'Domain of unknown function (DUF4895)', NULL, 'DUF4895', NULL, NULL, 25644, 9),
(256180, NULL, 'PF10334', NULL, NULL, 'Aromatic acid exporter family member 2', NULL, 'ArAE_2', NULL, NULL, 19566, 9),
(256181, NULL, 'PF12159', NULL, NULL, 'Protein of unknown function (DUF3593)', NULL, 'DUF3593', NULL, NULL, 20173, 9); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(256182, NULL, 'PF11245', NULL, NULL, 'Protein of unknown function (DUF2544)', NULL, 'DUF2544', NULL, NULL, 18197, 9),
(256183, NULL, 'PF11910', NULL, NULL, 'Cyanobacterial and plant NDH-1 subunit O', NULL, 'NdhO', NULL, NULL, 14777, 9),
(256184, NULL, 'PF20481', NULL, NULL, 'Domain of unknown function (DUF6721)', NULL, 'DUF6721', NULL, NULL, 33611, 9),
(256185, NULL, 'PF14308', NULL, NULL, 'X-domain of DnaJ-containing', NULL, 'DnaJ-X', NULL, NULL, 26808, 9),
(256186, NULL, 'PF10339', NULL, NULL, 'Yeast-specific zinc responsive', NULL, 'Vel1p', NULL, NULL, 17404, 9),
(256187, NULL, 'PF17067', NULL, NULL, 'Ribosomal protein S31e', NULL, 'RPS31', NULL, NULL, 23938, 9),
(256188, NULL, 'PF08629', NULL, NULL, 'PDE8 phosphodiesterase', NULL, 'PDE8', NULL, NULL, 14284, 9),
(256189, NULL, 'PF07430', NULL, NULL, 'Phloem filament protein PP1 cystatin-like domain', NULL, 'PP1', NULL, NULL, 8561, 9),
(256190, NULL, 'PF06623', NULL, NULL, 'MHC_I C-terminus', NULL, 'MHC_I_C', NULL, NULL, 8070, 9),
(256191, NULL, 'PF16913', NULL, NULL, 'Purine nucleobase transmembrane transport', NULL, 'PUNUT', NULL, NULL, NULL, 9),
(256192, NULL, 'PF19701', NULL, NULL, 'Family of unknown function (DUF6199)', NULL, 'DUF6199', NULL, NULL, 36227, 9),
(256193, NULL, 'PF18203', NULL, NULL, 'IPTL-CTERM motif', NULL, 'IPTL-CTERM', NULL, NULL, 23224, 9),
(256194, NULL, 'PF17253', NULL, NULL, 'Family of unknown function (DUF5320)', NULL, 'DUF5320', NULL, NULL, 8760, 9),
(256195, NULL, 'PF13327', NULL, NULL, 'Type III secretion system subunit', NULL, 'T3SS_LEE_assoc', NULL, NULL, 25702, 9),
(256196, NULL, 'PF18470', NULL, NULL, 'Cas9 alpha-helical lobe domain', NULL, 'Cas9_a', NULL, NULL, 32350, 9),
(256197, NULL, 'PF15208', NULL, NULL, 'Rab15 effector', NULL, 'Rab15_effector', NULL, NULL, 25061, 9),
(256198, NULL, 'PF02260', NULL, NULL, 'FATC domain', NULL, 'FATC', NULL, NULL, 1879, 9),
(256199, NULL, 'PF11697', NULL, NULL, 'Protein of unknown function (DUF3293)', NULL, 'DUF3293', NULL, NULL, 19175, 9),
(256200, NULL, 'PF11514', NULL, NULL, 'Protein of unknown function (DUF3219)', NULL, 'DUF3219', NULL, NULL, 18623, 9),
(256201, NULL, 'PF17778', NULL, NULL, 'Beta-lactamase associated winged helix domain', NULL, 'BLACT_WH', NULL, NULL, 29771, 9),
(256202, NULL, 'PF07694', NULL, NULL, '5TMR of 5TMR-LYT', NULL, '5TM-5TMR_LYT', NULL, NULL, 9679, 9),
(256203, NULL, 'PF11202', NULL, NULL, 'Phosphoribosyl transferase (PRTase)', NULL, 'PRTase_1', NULL, NULL, 10686, 9),
(256204, NULL, 'PF10531', NULL, NULL, 'SLBB domain', NULL, 'SLBB', NULL, NULL, 19141, 9),
(256205, NULL, 'PF16387', NULL, NULL, 'Domain of unknown function', NULL, 'DUF4996', NULL, NULL, 22238, 9),
(256206, NULL, 'PF01138', NULL, NULL, '3'' exoribonuclease family, domain 1', NULL, 'RNase_PH', NULL, NULL, 805, 9),
(256207, NULL, 'PF07034', NULL, NULL, 'Origin recognition complex (ORC) subunit 3 N-terminus', NULL, 'ORC3_N', NULL, NULL, 37247, 9),
(256208, NULL, 'PF12102', NULL, NULL, 'MrcB-like, N-terminal domain', NULL, 'MrcB_N', NULL, NULL, 20406, 9),
(256209, NULL, 'PF09321', NULL, NULL, 'Domain of unknown function (DUF1978)', NULL, 'DUF1978', NULL, NULL, 14225, 9),
(256210, NULL, 'PF00342', NULL, NULL, 'Phosphoglucose isomerase', NULL, 'PGI', NULL, NULL, 3021, 9),
(256211, NULL, 'PF01671', NULL, NULL, 'African swine fever virus multigene family 360 protein', NULL, 'ASFV_360', NULL, NULL, 1590, 9),
(256212, NULL, 'PF15720', NULL, NULL, 'Domain of unknown function (DUF4675)', NULL, 'DUF4675', NULL, NULL, NULL, 9),
(256213, NULL, 'PF10681', NULL, NULL, 'Chaperone for protein-folding within the ER, fungal', NULL, 'Rot1', NULL, NULL, 20640, 9),
(256214, NULL, 'PF11873', NULL, NULL, 'Membrane-bound lytic murein transglycosylase C, N-terminal domain', NULL, 'Mltc_N', NULL, NULL, 21866, 9),
(256215, NULL, 'PF05268', NULL, NULL, 'Phage tail fibre adhesin Gp38', NULL, 'GP38', NULL, NULL, 4270, 9),
(256216, NULL, 'PF12687', NULL, NULL, 'Protein of unknown function (DUF3801)', NULL, 'DUF3801', NULL, NULL, 20361, 9),
(256217, NULL, 'PF10250', NULL, NULL, 'GDP-fucose protein O-fucosyltransferase', NULL, 'O-FucT', NULL, NULL, 15612, 9);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(256218, NULL, 'PF11650', NULL, NULL, 'P22 tail accessory factor', NULL, 'P22_Tail-4', NULL, NULL, 19329, 9),
(256219, NULL, 'PF00463', NULL, NULL, 'Isocitrate lyase family', NULL, 'ICL', NULL, NULL, 3922, 9),
(256220, NULL, 'PF05686', NULL, NULL, 'Glycosyl transferase family 90', NULL, 'Glyco_transf_90', NULL, NULL, 1004, 9),
(256221, NULL, 'PF12487', NULL, NULL, 'Protein of unknown function (DUF3703)', NULL, 'DUF3703', NULL, NULL, 21488, 9),
(256222, NULL, 'PF15122', NULL, NULL, 'TMEM206 protein family', NULL, 'TMEM206', NULL, NULL, 26435, 9),
(256223, NULL, 'PF17267', NULL, NULL, 'Family of unknown function (DUF5333)', NULL, 'DUF5333', NULL, NULL, 19684, 9),
(256224, NULL, 'PF06368', NULL, NULL, 'Methylaspartate mutase E chain (MutE)', NULL, 'Met_asp_mut_E', NULL, NULL, 5556, 9),
(256225, NULL, 'PF07063', NULL, NULL, 'Domain of unknown function (DUF1338)', NULL, 'DUF1338', NULL, NULL, 12816, 9),
(256226, NULL, 'PF10291', NULL, NULL, 'Muniscin C-terminal mu homology domain', NULL, 'muHD', NULL, NULL, 19450, 9),
(256227, NULL, 'PF05470', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit 8 N-terminus', NULL, 'eIF-3c_N', NULL, NULL, 7517, 9),
(256228, NULL, 'PF10206', NULL, NULL, 'Mitochondrial F1F0-ATP synthase, subunit f', NULL, 'WRW', NULL, NULL, 15579, 9),
(256229, NULL, 'PF05735', NULL, NULL, 'Thrombospondin C-terminal region', NULL, 'TSP_C', NULL, NULL, 13778, 9),
(256230, NULL, 'PF02156', NULL, NULL, 'Glycosyl hydrolase family 26', NULL, 'Glyco_hydro_26', NULL, NULL, 14586, 9),
(256231, NULL, 'PF11480', NULL, NULL, 'Colicin-E5 Imm protein', NULL, 'ImmE5', NULL, NULL, 13945, 9),
(256232, NULL, 'PF01871', NULL, NULL, 'AMMECR1', NULL, 'AMMECR1', NULL, NULL, 3664, 9),
(256233, NULL, 'PF03398', NULL, NULL, 'Regulator of Vps4 activity in the MVB pathway', NULL, 'Ist1', NULL, NULL, 2321, 9),
(256234, NULL, 'PF11316', NULL, NULL, 'Putative rhamnosyl transferase', NULL, 'Rhamno_transf', NULL, NULL, 18347, 9),
(256235, NULL, 'PF11567', NULL, NULL, 'Plasmodium falciparum UIS3 membrane protein', NULL, 'PfUIS3', NULL, NULL, 18764, 9),
(256236, NULL, 'PF00092', NULL, NULL, 'von Willebrand factor type A domain', NULL, 'VWA', NULL, NULL, 2425, 9),
(256237, NULL, 'PF06338', NULL, NULL, 'ComK protein', NULL, 'ComK', NULL, NULL, 10129, 9),
(256238, NULL, 'PF16424', NULL, NULL, 'Domain of unknown function (DUF5021)', NULL, 'DUF5021', NULL, NULL, 24497, 9),
(256239, NULL, 'PF05935', NULL, NULL, 'Arylsulfotransferase (ASST)', NULL, 'Arylsulfotrans', NULL, NULL, 7913, 9),
(256240, NULL, 'PF11712', NULL, NULL, 'Endoplasmic reticulum-based factor for assembly of V-ATPase', NULL, 'Vma12', NULL, NULL, 15283, 9),
(256241, NULL, 'PF18735', NULL, NULL, 'RiboL-PSP-HEPN', NULL, 'HEPN_RiboL-PSP', NULL, NULL, 29856, 9),
(256242, NULL, 'PF06369', NULL, NULL, 'Sea anemone cytotoxic protein', NULL, 'Anemone_cytotox', NULL, NULL, 7931, 9),
(256243, NULL, 'PF19901', NULL, NULL, 'Family of unknown function (DUF6374)', NULL, 'DUF6374', NULL, NULL, 36571, 9),
(256244, NULL, 'PF11769', NULL, NULL, 'Protein of unknown function (DUF3313)', NULL, 'DUF3313', NULL, NULL, 19137, 9),
(256245, NULL, 'PF13657', NULL, NULL, 'HipA N-terminal domain', NULL, 'Couple_hipA', NULL, NULL, 21238, 9),
(256246, NULL, 'PF15690', NULL, NULL, 'Nuclear receptor-interacting protein 1 repression 4', NULL, 'NRIP1_repr_4', NULL, NULL, 26445, 9),
(256247, NULL, 'PF08017', NULL, NULL, 'Fibrinogen binding protein', NULL, 'Fibrinogen_BP', NULL, NULL, 11633, 9),
(256248, NULL, 'PF15838', NULL, NULL, 'LLLL and CFNLAS motif-containing protein 1', NULL, 'LLCFC1', NULL, NULL, 25985, 9),
(256249, NULL, 'PF18952', NULL, NULL, 'Family of unknown function (DUF5696)', NULL, 'DUF5696', NULL, NULL, 34295, 9),
(256250, NULL, 'PF16798', NULL, NULL, 'Domain of unknown function (DUF5069)', NULL, 'DUF5069', NULL, NULL, 24196, 9),
(256251, NULL, 'PF11132', NULL, NULL, 'Transcriptional regulator protein (SplA)', NULL, 'SplA', NULL, NULL, 2861, 9),
(256252, NULL, 'PF18968', NULL, NULL, 'Family of unknown function (DUF5707)', NULL, 'DUF5707', NULL, NULL, 35428, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(256253, NULL, 'PF12963', NULL, NULL, 'Protein of unknown function (DUF3852)', NULL, 'DUF3852', NULL, NULL, 26880, 9),
(256254, NULL, 'PF00697', NULL, NULL, 'N-(5''phosphoribosyl)anthranilate (PRA) isomerase', NULL, 'PRAI', NULL, NULL, 2448, 9),
(256255, NULL, 'PF03457', NULL, NULL, 'Helicase associated domain', NULL, 'HA', NULL, NULL, 10512, 9),
(256256, NULL, 'PF10674', NULL, NULL, 'Protein of unknown function (DUF2488)', NULL, 'Ycf54', NULL, NULL, 20182, 9),
(256257, NULL, 'PF01321', NULL, NULL, 'Creatinase/Prolidase N-terminal domain', NULL, 'Creatinase_N', NULL, NULL, 5687, 9),
(256258, NULL, 'PF18654', NULL, NULL, 'LegC3 N-terminal coiled-coil domain', NULL, 'LegC3_N', NULL, NULL, 29195, 9),
(256259, NULL, 'PF19945', NULL, NULL, 'Family of unknown function (DUF6407)', NULL, 'DUF6407', NULL, NULL, 37056, 9),
(256260, NULL, 'PF19801', NULL, NULL, 'Family of unknown function (DUF6284)', NULL, 'DUF6284', NULL, NULL, 37038, 9),
(256261, NULL, 'PF19971', NULL, NULL, 'Ternary complex associated domain 2', NULL, 'TCAD2', NULL, NULL, 36239, 9),
(256262, NULL, 'PF09022', NULL, NULL, 'Staphostatin A', NULL, 'Staphostatin_A', NULL, NULL, 9836, 9),
(256263, NULL, 'PF03162', NULL, NULL, 'Tyrosine phosphatase family', NULL, 'Y_phosphatase2', NULL, NULL, 7466, 9),
(256264, NULL, 'PF12610', NULL, NULL, 'Suppressor of cytokine signalling', NULL, 'SOCS', NULL, NULL, 21138, 9),
(256265, NULL, 'PF09095', NULL, NULL, 'Alpha-amylase/4-alpha-glucanotransferase, C-terminal', NULL, 'AmyA-gluTrfs_C', NULL, NULL, 10952, 9),
(256266, NULL, 'PF07934', NULL, NULL, '8-oxoguanine DNA glycosylase, N-terminal domain', NULL, 'OGG_N', NULL, NULL, 13046, 9),
(256267, NULL, 'PF13557', NULL, NULL, 'Putative MetA-pathway of phenol degradation', NULL, 'Phenol_MetA_deg', NULL, NULL, 24973, 9),
(256268, NULL, 'PF11170', NULL, NULL, 'Protein of unknown function (DUF2957)', NULL, 'DUF2957', NULL, NULL, 18196, 9),
(256269, NULL, 'PF15834', NULL, NULL, 'Testis highly expressed protein 4', NULL, 'THEG4', NULL, NULL, 25555, 9),
(256270, NULL, 'PF19961', NULL, NULL, 'Effector-associated domain 8', NULL, 'EAD8', NULL, NULL, 35611, 9),
(256271, NULL, 'PF19304', NULL, NULL, 'D-3-phosphoglycerate dehydrogenase intervening domain', NULL, 'PGDH_inter', NULL, NULL, 36417, 9),
(256272, NULL, 'PF02082', NULL, NULL, 'Iron-dependent Transcriptional regulator', NULL, 'Rrf2', NULL, NULL, 304, 9),
(256273, NULL, 'PF19714', NULL, NULL, 'Family of unknown function (DUF6209)', NULL, 'DUF6209', NULL, NULL, 37288, 9),
(256274, NULL, 'PF15807', NULL, NULL, 'Membrane-associated protein 117 kDa, PDZK1-interacting protein 1', NULL, 'MAP17', NULL, NULL, 25865, 9),
(256275, NULL, 'PF05194', NULL, NULL, 'UreE urease accessory protein, C-terminal domain', NULL, 'UreE_C', NULL, NULL, 3080, 9),
(256276, NULL, 'PF15664', NULL, NULL, 'Transmembrane protein 252 family', NULL, 'TMEM252', NULL, NULL, 4694, 9),
(256277, NULL, 'PF16066', NULL, NULL, 'Domain of unknown function (DUF4808)', NULL, 'DUF4808', NULL, NULL, 24303, 9),
(256278, NULL, 'PF09623', NULL, NULL, 'CRISPR-associated protein NE0113 (Cas_NE0113)', NULL, 'Cas_NE0113', NULL, NULL, 17853, 9),
(256279, NULL, 'PF11081', NULL, NULL, 'Adenovirus L4-33K/L4-22K', NULL, 'Adeno_L433K_22K', NULL, NULL, 17773, 9),
(256280, NULL, 'PF17825', NULL, NULL, 'Family of unknown function (DUF5587)', NULL, 'DUF5587', NULL, NULL, 33832, 9),
(256281, NULL, 'PF08070', NULL, NULL, 'DTHCT (NUC029) region', NULL, 'DTHCT', NULL, NULL, 8905, 9),
(256282, NULL, 'PF19177', NULL, NULL, 'Family of unknown function (DUF5859)', NULL, 'DUF5859', NULL, NULL, 35648, 9),
(256283, NULL, 'PF00643', NULL, NULL, 'B-box zinc finger', NULL, 'zf-B_box', NULL, NULL, 595, 9),
(256284, NULL, 'PF17332', NULL, NULL, 'Family of unknown function (DUF5592)', NULL, 'DUF5592', NULL, NULL, 19650, 9),
(256285, NULL, 'PF09636', NULL, NULL, 'XkdW protein', NULL, 'XkdW', NULL, NULL, 17745, 9),
(256286, NULL, 'PF05541', NULL, NULL, 'Entomopoxvirus spheroidin protein', NULL, 'Spheroidin', NULL, NULL, 13830, 9),
(256287, NULL, 'PF12899', NULL, NULL, 'Alkaline and neutral invertase', NULL, 'Glyco_hydro_100', NULL, NULL, 19204, 9);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(256288, NULL, 'PF01817', NULL, NULL, 'Chorismate mutase type II', NULL, 'CM_2', NULL, NULL, 3840, 9),
(256289, NULL, 'PF19674', NULL, NULL, 'Family of unknown function (DUF6177)', NULL, 'DUF6177', NULL, NULL, 37266, 9),
(256290, NULL, 'PF06937', NULL, NULL, 'EURL protein', NULL, 'EURL', NULL, NULL, 11629, 9),
(256291, NULL, 'PF08435', NULL, NULL, 'Calicivirus coat protein C-terminal', NULL, 'Calici_coat_C', NULL, NULL, 12933, 9),
(256292, NULL, 'PF06004', NULL, NULL, 'Bacterial protein of unknown function (DUF903)', NULL, 'DUF903', NULL, NULL, 8161, 9),
(256293, NULL, 'PF00601', NULL, NULL, 'Influenza non-structural protein (NS2)', NULL, 'Flu_NS2', NULL, NULL, 3159, 9),
(256294, NULL, 'PF04118', NULL, NULL, 'Dopey, N-terminal', NULL, 'Dopey_N', NULL, NULL, 6542, 9),
(256295, NULL, 'PF19028', NULL, NULL, 'Spondin-like TSP1 domain', NULL, 'TSP1_spondin', NULL, NULL, 37521, 9),
(256296, NULL, 'PF20522', NULL, NULL, 'Domain of unknown function (DUF6737)', NULL, 'DUF6737', NULL, NULL, 33866, 9),
(256297, NULL, 'PF15014', NULL, NULL, 'Ceroid-lipofuscinosis neuronal protein 5', NULL, 'CLN5', NULL, NULL, 22619, 9),
(256298, NULL, 'PF09281', NULL, NULL, 'Taq polymerase, exonuclease', NULL, 'Taq-exonuc', NULL, NULL, 13618, 9),
(256299, NULL, 'PF16779', NULL, NULL, 'DNA-mimic protein', NULL, 'DMP12', NULL, NULL, 23802, 9),
(256300, NULL, 'PF20124', NULL, NULL, 'Family of unknown function (DUF6514)', NULL, 'DUF6514', NULL, NULL, 18525, 9),
(256301, NULL, 'PF05453', NULL, NULL, 'BmTXKS1/BmP02 toxin family', NULL, 'Toxin_6', NULL, NULL, 7945, 9),
(256302, NULL, 'PF05557', NULL, NULL, 'Mitotic checkpoint protein', NULL, 'MAD', NULL, NULL, 12649, 9),
(256303, NULL, 'PF16364', NULL, NULL, 'Cell surface antigen C-terminus', NULL, 'Antigen_C', NULL, NULL, 23518, 9),
(256304, NULL, 'PF16518', NULL, NULL, 'T3SS negative regulator,GrlR', NULL, 'GrlR', NULL, NULL, 23283, 9),
(256305, NULL, 'PF02637', NULL, NULL, 'GatB domain', NULL, 'GatB_Yqey', NULL, NULL, 16568, 9),
(256306, NULL, 'PF07590', NULL, NULL, 'Protein of unknown function (DUF1556)', NULL, 'DUF1556', NULL, NULL, 13671, 9),
(256307, NULL, 'PF14062', NULL, NULL, 'Domain of unknown function (DUF4253)', NULL, 'DUF4253', NULL, NULL, 22858, 9),
(256308, NULL, 'PF06643', NULL, NULL, 'Protein of unknown function (DUF1158)', NULL, 'DUF1158', NULL, NULL, 8473, 9),
(256309, NULL, 'PF06810', NULL, NULL, 'Phage minor structural protein GP20', NULL, 'Phage_GP20', NULL, NULL, 10503, 9),
(256310, NULL, 'PF19827', NULL, NULL, 'Family of unknown function (DUF6308)', NULL, 'DUF6308', NULL, NULL, 37528, 9),
(256311, NULL, 'PF17570', NULL, NULL, 'Bacteriophage T7-like, protein 6.7', NULL, 'T7-like_gp67', NULL, NULL, 13891, 9),
(256312, NULL, 'PF14905', NULL, NULL, 'Outer membrane protein beta-barrel family', NULL, 'OMP_b-brl_3', NULL, NULL, 30963, 9),
(256313, NULL, 'PF17467', NULL, NULL, 'Viral Protein E7', NULL, 'E7R', NULL, NULL, 15975, 9),
(256314, NULL, 'PF04675', NULL, NULL, 'DNA ligase N terminus', NULL, 'DNA_ligase_A_N', NULL, NULL, 12566, 9),
(256315, NULL, 'PF18426', NULL, NULL, 'Tle cognate immunity protein 4 C-terminal domain', NULL, 'Tli4_C', NULL, NULL, 29193, 9),
(256316, NULL, 'PF03999', NULL, NULL, 'Microtubule associated protein (MAP65/ASE1 family)', NULL, 'MAP65_ASE1', NULL, NULL, NULL, 9),
(256317, NULL, 'PF12596', NULL, NULL, '87kDa Transposase', NULL, 'Tnp_P_element_C', NULL, NULL, 21410, 9),
(256318, NULL, 'PF06237', NULL, NULL, 'Protein of unknown function (DUF1011)', NULL, 'DUF1011', NULL, NULL, 14242, 9),
(256319, NULL, 'PF01678', NULL, NULL, 'Diaminopimelate epimerase', NULL, 'DAP_epimerase', NULL, NULL, 11041, 9),
(256320, NULL, 'PF11709', NULL, NULL, 'Mitochondrial ribosomal protein subunit', NULL, 'Mit_ribos_Mrp51', NULL, NULL, 20327, 9),
(256321, NULL, 'PF16726', NULL, NULL, 'Inositol polyphosphate 5-phosphatase clathrin binding domain', NULL, 'OCRL_clath_bd', NULL, NULL, 23154, 9),
(256322, NULL, 'PF20473', NULL, NULL, 'MmeI, DNA-methyltransferase domain', NULL, 'MmeI_Mtase', NULL, NULL, 33687, 9),
(256323, NULL, 'PF02205', NULL, NULL, 'WH2 motif', NULL, 'WH2', NULL, NULL, 1510, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(256324, NULL, 'PF12788', NULL, NULL, 'YmaF family', NULL, 'YmaF', NULL, NULL, 22885, 9),
(256325, NULL, 'PF15101', NULL, NULL, 'Telomere-associated protein TERB2', NULL, 'TERB2', NULL, NULL, 26851, 9),
(256326, NULL, 'PF01273', NULL, NULL, 'LBP / BPI / CETP family, N-terminal domain', NULL, 'LBP_BPI_CETP', NULL, NULL, 19207, 9),
(256327, NULL, 'PF07973', NULL, NULL, 'Threonyl and Alanyl tRNA synthetase second additional domain', NULL, 'tRNA_SAD', NULL, NULL, 8233, 9),
(256328, NULL, 'PF15318', NULL, NULL, 'Putative Bcl-2 like protein of testis', NULL, 'Bclt', NULL, NULL, 24645, 9),
(256329, NULL, 'PF10810', NULL, NULL, 'Protein of unknown function (DUF2545)', NULL, 'DUF2545', NULL, NULL, 24684, 9),
(256330, NULL, 'PF14347', NULL, NULL, 'Domain of unknown function (DUF4399)', NULL, 'DUF4399', NULL, NULL, 26410, 9),
(256331, NULL, 'PF08868', NULL, NULL, 'YugN-like family', NULL, 'YugN', NULL, NULL, 14401, 9),
(256332, NULL, 'PF09559', NULL, NULL, 'Cas6 Crispr', NULL, 'Cas6', NULL, NULL, 8772, 9),
(256333, NULL, 'PF18624', NULL, NULL, 'CDI immunity protein', NULL, 'CdiI_4', NULL, NULL, 29402, 9),
(256334, NULL, 'PF11920', NULL, NULL, 'Protein of unknown function (DUF3438)', NULL, 'DUF3438', NULL, NULL, 19910, 9),
(256335, NULL, 'PF18432', NULL, NULL, 'Extracellular Cadherin domain', NULL, 'ECD', NULL, NULL, 28596, 9),
(256336, NULL, 'PF17217', NULL, NULL, 'UPA domain', NULL, 'UPA', NULL, NULL, 28153, 9),
(256337, NULL, 'PF12273', NULL, NULL, 'Chitin synthesis regulation, resistance to Congo red', NULL, 'RCR', NULL, NULL, 20837, 9),
(256338, NULL, 'PF04102', NULL, NULL, 'SlyX', NULL, 'SlyX', NULL, NULL, 6627, 9),
(256339, NULL, 'PF05498', NULL, NULL, 'Rapid ALkalinization Factor (RALF)', NULL, 'RALF', NULL, NULL, 13725, 9),
(256340, NULL, 'PF06055', NULL, NULL, 'Exopolysaccharide synthesis, ExoD', NULL, 'ExoD', NULL, NULL, 8980, 9),
(256341, NULL, 'PF18561', NULL, NULL, 'Endoribonuclease Regnase 1/ ZC3H12 C-terminal domain', NULL, 'Regnase_1_C', NULL, NULL, 28889, 9),
(256342, NULL, 'PF19016', NULL, NULL, 'Domain of unknown function (DUF5745)', NULL, 'DUF5745', NULL, NULL, 35882, 9),
(256343, NULL, 'PF11027', NULL, NULL, 'Protein of unknown function (DUF2615)', NULL, 'DUF2615', NULL, NULL, 21465, 9),
(256344, NULL, 'PF00593', NULL, NULL, 'TonB dependent receptor', NULL, 'TonB_dep_Rec', NULL, NULL, 5811, 9),
(256345, NULL, 'PF10443', NULL, NULL, 'RNA12 protein', NULL, 'RNA12', NULL, NULL, 20478, 9),
(256346, NULL, 'PF10991', NULL, NULL, 'Protein of unknown function (DUF2815)', NULL, 'DUF2815', NULL, NULL, 16591, 9),
(256347, NULL, 'PF19708', NULL, NULL, 'Family of unknown function (DUF6205)', NULL, 'DUF6205', NULL, NULL, 36044, 9),
(256348, NULL, 'PF04030', NULL, NULL, 'D-arabinono-1,4-lactone oxidase', NULL, 'ALO', NULL, NULL, 404, 9),
(256349, NULL, 'PF04948', NULL, NULL, 'Poxvirus A51 protein', NULL, 'Pox_A51', NULL, NULL, 6958, 9),
(256350, NULL, 'PF06120', NULL, NULL, 'Tail length tape measure protein', NULL, 'Phage_HK97_TLTM', NULL, NULL, 13670, 9),
(256351, NULL, 'PF06301', NULL, NULL, 'Bacteriophage lambda Kil protein', NULL, 'Lambda_Kil', NULL, NULL, 10421, 9),
(256352, NULL, 'PF03092', NULL, NULL, 'BT1 family', NULL, 'BT1', NULL, NULL, 27011, 9),
(256353, NULL, 'PF20603', NULL, NULL, 'Bacterial hydrolase', NULL, 'Bact_hydrolase', NULL, NULL, 33523, 9),
(256354, NULL, 'PF17594', NULL, NULL, 'Phage Tail fiber assembly helper gene product 57', NULL, 'GP57', NULL, NULL, 13532, 9),
(256355, NULL, 'PF12575', NULL, NULL, 'Poxvirus entry protein complex L1 and I2', NULL, 'Pox_EPC_I2-L1', NULL, NULL, 9935, 9),
(256356, NULL, 'PF18196', NULL, NULL, 'Chromodomain helicase DNA-binding domain 1', NULL, 'Cdh1_DBD_1', NULL, NULL, 28749, 9),
(256357, NULL, 'PF00994', NULL, NULL, 'Probable molybdopterin binding domain', NULL, 'MoCF_biosynth', NULL, NULL, 6278, 9),
(256358, NULL, 'PF08253', NULL, NULL, 'Erm Leader peptide', NULL, 'Leader_Erm', NULL, NULL, 17403, 9),
(256359, NULL, 'PF14566', NULL, NULL, 'Inositol hexakisphosphate', NULL, 'PTPlike_phytase', NULL, NULL, NULL, 9),
(256360, NULL, 'PF12243', NULL, NULL, 'CTD kinase subunit gamma CTK3', NULL, 'CTK3', NULL, NULL, 13846, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(256361, NULL, 'PF03687', NULL, NULL, 'Uncharacterised protein family (UPF0164)', NULL, 'UPF0164', NULL, NULL, 6302, 9),
(256362, NULL, 'PF11531', NULL, NULL, 'Coactivator-associated arginine methyltransferase 1 N terminal', NULL, 'CARM1', NULL, NULL, 14779, 9),
(256363, NULL, 'PF13536', NULL, NULL, 'Putative multidrug resistance efflux transporter', NULL, 'EmrE', NULL, NULL, 26788, 9),
(256364, NULL, 'PF13983', NULL, NULL, 'YsaB-like lipoprotein', NULL, 'YsaB', NULL, NULL, 22684, 9),
(256365, NULL, 'PF16032', NULL, NULL, 'Domain of unknown function (DUF4788)', NULL, 'DUF4788', NULL, NULL, 22550, 9),
(256366, NULL, 'PF03028', NULL, NULL, 'Dynein heavy chain region D6 P-loop domain', NULL, 'Dynein_heavy', NULL, NULL, 4379, 9),
(256367, NULL, 'PF03977', NULL, NULL, 'Na+-transporting oxaloacetate decarboxylase beta subunit', NULL, 'OAD_beta', NULL, NULL, 3717, 9),
(256368, NULL, 'PF16468', NULL, NULL, 'Domain of unknown function (DUF5049)', NULL, 'DUF5049', NULL, NULL, 22319, 9),
(256369, NULL, 'PF19188', NULL, NULL, 'Adhesion GPCR B N-terminal region', NULL, 'AGRB_N', NULL, NULL, 35680, 9),
(256370, NULL, 'PF04022', NULL, NULL, 'Staphylocoagulase repeat', NULL, 'Staphylcoagulse', NULL, NULL, 3215, 9),
(256371, NULL, 'PF00152', NULL, NULL, 'tRNA synthetases class II (D, K and N)', NULL, 'tRNA-synt_2', NULL, NULL, 5230, 9),
(256372, NULL, 'PF06384', NULL, NULL, 'Beta-catenin-interacting protein ICAT', NULL, 'ICAT', NULL, NULL, 8054, 9),
(256373, NULL, 'PF11816', NULL, NULL, 'Domain of unknown function (DUF3337)', NULL, 'DUF3337', NULL, NULL, 19441, 9),
(256374, NULL, 'PF08029', NULL, NULL, 'HisG, C-terminal domain', NULL, 'HisG_C', NULL, NULL, 18579, 9),
(256375, NULL, 'PF08702', NULL, NULL, 'Fibrinogen alpha/beta chain family', NULL, 'Fib_alpha', NULL, NULL, 13256, 9),
(256376, NULL, 'PF02085', NULL, NULL, 'Class III cytochrome C family', NULL, 'Cytochrom_CIII', NULL, NULL, 14810, 9),
(256377, NULL, 'PF03326', NULL, NULL, 'Herpesvirus transcription activation factor (transactivator)', NULL, 'Herpes_TAF50', NULL, NULL, 634, 9),
(256378, NULL, 'PF04683', NULL, NULL, 'Proteasome complex subunit Rpn13 ubiquitin receptor', NULL, 'Proteasom_Rpn13', NULL, NULL, 36188, 9),
(256379, NULL, 'PF10319', NULL, NULL, 'Serpentine type 7TM GPCR chemoreceptor Srj', NULL, '7TM_GPCR_Srj', NULL, NULL, 16809, 9),
(256380, NULL, 'PF12535', NULL, NULL, 'Hydrolase of X-linked nucleoside diphosphate N terminal', NULL, 'Nudix_N', NULL, NULL, NULL, 9),
(256381, NULL, 'PF08722', NULL, NULL, 'TnsA-like endonuclease N terminal', NULL, 'Tn7_TnsA-like_N', NULL, NULL, 11767, 9),
(256382, NULL, 'PF13011', NULL, NULL, 'leucine-zipper of insertion element IS481', NULL, 'LZ_Tnp_IS481', NULL, NULL, 21869, 9),
(256383, NULL, 'PF10832', NULL, NULL, 'Protein of unknown function (DUF2559)', NULL, 'DUF2559', NULL, NULL, 16490, 9),
(256384, NULL, 'PF01258', NULL, NULL, 'Prokaryotic dksA/traR C4-type zinc finger', NULL, 'zf-dskA_traR', NULL, NULL, 391, 9),
(256385, NULL, 'PF20545', NULL, NULL, 'Domain of unknown function (DUF6759)', NULL, 'DUF6759', NULL, NULL, 33715, 9),
(256386, NULL, 'PF14802', NULL, NULL, 'TMEM192 family', NULL, 'TMEM192', NULL, NULL, 24867, 9),
(256387, NULL, 'PF12114', NULL, NULL, 'Period protein 2/3C-terminal region', NULL, 'Period_C', NULL, NULL, 14961, 9),
(256388, NULL, 'PF14104', NULL, NULL, 'Domain of unknown function (DUF4277)', NULL, 'DUF4277', NULL, NULL, 22055, 9),
(256389, NULL, 'PF15639', NULL, NULL, 'Metallopeptidase toxin 3', NULL, 'Tox-MPTase3', NULL, NULL, 24544, 9),
(256390, NULL, 'PF01343', NULL, NULL, 'Peptidase family S49', NULL, 'Peptidase_S49', NULL, NULL, 1030, 9),
(256391, NULL, 'PF12403', NULL, NULL, 'Paired-box protein 2 C terminal', NULL, 'Pax2_C', NULL, NULL, 20720, 9),
(256392, NULL, 'PF19150', NULL, NULL, 'Family of unknown function (DUF5832)', NULL, 'DUF5832', NULL, NULL, 34184, 9),
(256393, NULL, 'PF19382', NULL, NULL, 'Family of unknown function (DUF5957)', NULL, 'DUF5957', NULL, NULL, 36956, 9),
(256394, NULL, 'PF09832', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2059)', NULL, 'DUF2059', NULL, NULL, 16506, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(256395, NULL, 'PF16482', NULL, NULL, 'Staufen C-terminal domain', NULL, 'Staufen_C', NULL, NULL, 18478, 9),
(256396, NULL, 'PF05545', NULL, NULL, 'Cbb3-type cytochrome oxidase component FixQ', NULL, 'FixQ', NULL, NULL, 14030, 9),
(256397, NULL, 'PF04427', NULL, NULL, 'Brix domain', NULL, 'Brix', NULL, NULL, 338, 9),
(256398, NULL, 'PF03081', NULL, NULL, 'Exo70 exocyst complex subunit', NULL, 'Exo70', NULL, NULL, 34022, 9),
(256399, NULL, 'PF12145', NULL, NULL, 'Eukaryotic Mediator 12 subunit domain', NULL, 'Med12-LCEWAV', NULL, NULL, 20114, 9),
(256400, NULL, 'PF01741', NULL, NULL, 'Large-conductance mechanosensitive channel, MscL', NULL, 'MscL', NULL, NULL, 27359, 9),
(256401, NULL, 'PF17476', NULL, NULL, 'Clostridial binary toxin B/anthrax toxin PA domain 3', NULL, 'Binary_toxB_3', NULL, NULL, 18736, 9),
(256402, NULL, 'PF03800', NULL, NULL, 'Nuf2 family', NULL, 'Nuf2', NULL, NULL, 1897, 9),
(256403, NULL, 'PF18365', NULL, NULL, 'Phosphoinositide phosphatase C-terminal domain', NULL, 'PI_PP_C', NULL, NULL, 28887, 9),
(256404, NULL, 'PF02999', NULL, NULL, 'Borrelia orf-D family', NULL, 'Borrelia_orfD', NULL, NULL, 3553, 9),
(256405, NULL, 'PF01419', NULL, NULL, 'Jacalin-like lectin domain', NULL, 'Jacalin', NULL, NULL, 945, 9),
(256406, NULL, 'PF12489', NULL, NULL, 'Nuclear coactivator', NULL, 'ARA70', NULL, NULL, 21269, 9),
(256407, NULL, 'PF06201', NULL, NULL, 'PITH domain', NULL, 'PITH', NULL, NULL, 9167, 9),
(256408, NULL, 'PF07240', NULL, NULL, 'Stress-inducible humoral factor Turandot', NULL, 'Turandot', NULL, NULL, 11407, 9),
(256409, NULL, 'PF17668', NULL, NULL, 'Acetyltransferase (GNAT) domain', NULL, 'Acetyltransf_17', NULL, NULL, 29268, 9),
(256410, NULL, 'PF10647', NULL, NULL, 'Lipoprotein LpqB beta-propeller domain', NULL, 'Gmad1', NULL, NULL, 14976, 9),
(256411, NULL, 'PF11596', NULL, NULL, 'Protein of unknown function (DUF3246)', NULL, 'DUF3246', NULL, NULL, 18750, 9),
(256412, NULL, 'PF16359', NULL, NULL, 'RcsD-ABL domain', NULL, 'RcsD_ABL', NULL, NULL, 25417, 9),
(256413, NULL, 'PF06965', NULL, NULL, 'Na+/H+ antiporter 1', NULL, 'Na_H_antiport_1', NULL, NULL, 2613, 9),
(256414, NULL, 'PF14745', NULL, NULL, 'WASH complex subunit 4, N-terminal', NULL, 'WASH-4_N', NULL, NULL, 21819, 9),
(256415, NULL, 'PF14787', NULL, NULL, 'GAG-polyprotein viral zinc-finger', NULL, 'zf-CCHC_5', NULL, NULL, NULL, 9),
(256416, NULL, 'PF07747', NULL, NULL, 'MTH865-like family', NULL, 'MTH865', NULL, NULL, 12789, 9),
(256417, NULL, 'PF19581', NULL, NULL, 'Glyoxalase superfamily protein', NULL, 'Glyoxalase_7', NULL, NULL, 647, 9),
(256418, NULL, 'PF08974', NULL, NULL, 'Domain of unknown function (DUF1877)', NULL, 'DUF1877', NULL, NULL, 8763, 9),
(256419, NULL, 'PF09745', NULL, NULL, 'Nuclear speckle splicing regulatory protein 1, N-terminal', NULL, 'NSRP1_N', NULL, NULL, 16239, 9),
(256420, NULL, 'PF13282', NULL, NULL, 'Domain of unknown function (DUF4070)', NULL, 'DUF4070', NULL, NULL, 25769, 9),
(256421, NULL, 'PF14728', NULL, NULL, 'PTHB1 C-terminus', NULL, 'PHTB1_C', NULL, NULL, 23207, 9),
(256422, NULL, 'PF20210', NULL, NULL, 'Laa1/Sip1/HEATR5 HEAT repeat region', NULL, 'Laa1_Sip1_HTR5', NULL, NULL, 36858, 9),
(256423, NULL, 'PF08009', NULL, NULL, 'CDP-alcohol phosphatidyltransferase 2', NULL, 'CDP-OH_P_tran_2', NULL, NULL, 9649, 9),
(256424, NULL, 'PF04275', NULL, NULL, 'Phosphomevalonate kinase', NULL, 'P-mevalo_kinase', NULL, NULL, 395, 9),
(256425, NULL, 'PF03477', NULL, NULL, 'ATP cone domain', NULL, 'ATP-cone', NULL, NULL, 4223, 9),
(256426, NULL, 'PF05517', NULL, NULL, 'p25-alpha', NULL, 'p25-alpha', NULL, NULL, 7504, 9),
(256427, NULL, 'PF05401', NULL, NULL, 'Nodulation protein S (NodS)', NULL, 'NodS', NULL, NULL, 13466, 9),
(256428, NULL, 'PF00213', NULL, NULL, 'ATP synthase delta (OSCP) subunit', NULL, 'OSCP', NULL, NULL, 3968, 9),
(256429, NULL, 'PF05540', NULL, NULL, 'Serpulina hyodysenteriae variable surface protein', NULL, 'Serpulina_VSP', NULL, NULL, 13745, 9),
(256430, NULL, 'PF12395', NULL, NULL, 'Protein of unknown function', NULL, 'DUF3658', NULL, NULL, 20787, 9),
(256431, NULL, 'PF17989', NULL, NULL, 'Actin like proteins N terminal domain', NULL, 'ALP_N', NULL, NULL, 31595, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(256432, NULL, 'PF14758', NULL, NULL, 'Non-essential region of nsp2 of arterivirus polyprotein', NULL, 'NSP2_assoc', NULL, NULL, 22185, 9),
(256433, NULL, 'PF03439', NULL, NULL, 'Early transcription elongation factor of RNA pol II, NGN section', NULL, 'Spt5-NGN', NULL, NULL, 10546, 9),
(256434, NULL, 'PF15227', NULL, NULL, 'zinc finger of C3HC4-type, RING', NULL, 'zf-C3HC4_4', NULL, NULL, NULL, 9),
(256435, NULL, 'PF07108', NULL, NULL, 'PipA protein', NULL, 'PipA', NULL, NULL, 10574, 9),
(256436, NULL, 'PF17537', NULL, NULL, 'Family of unknown function (DUF5455)', NULL, 'DUF5455', NULL, NULL, 33595, 9),
(256437, NULL, 'PF08744', NULL, NULL, 'Plant transcription factor NOZZLE', NULL, 'NOZZLE', NULL, NULL, 13041, 9),
(256438, NULL, 'PF20190', NULL, NULL, 'Family of unknown function (DUF6553)', NULL, 'DUF6553', NULL, NULL, 37172, 9),
(256439, NULL, 'PF16936', NULL, NULL, 'Putative holin', NULL, 'Holin_9', NULL, NULL, 25042, 9),
(256440, NULL, 'PF02295', NULL, NULL, 'Adenosine deaminase z-alpha domain', NULL, 'z-alpha', NULL, NULL, 36645, 9),
(256441, NULL, 'PF02514', NULL, NULL, 'CobN/Magnesium Chelatase', NULL, 'CobN-Mg_chel', NULL, NULL, 6086, 9),
(256442, NULL, 'PF01266', NULL, NULL, 'FAD dependent oxidoreductase', NULL, 'DAO', NULL, NULL, 2723, 9),
(256443, NULL, 'PF03474', NULL, NULL, 'DMRTA motif', NULL, 'DMA', NULL, NULL, 4723, 9),
(256444, NULL, 'PF06434', NULL, NULL, 'Aconitate hydratase 2 N-terminus', NULL, 'Aconitase_2_N', NULL, NULL, 9978, 9),
(256445, NULL, 'PF17504', NULL, NULL, 'Family of unknown function (DUF5436)', NULL, 'DUF5436', NULL, NULL, 12953, 9),
(256446, NULL, 'PF18172', NULL, NULL, 'LepB GAP domain N-terminal subdomain', NULL, 'LepB_GAP_N', NULL, NULL, 29844, 9),
(256447, NULL, 'PF17168', NULL, NULL, 'Domain of unknown function (DUF5127)', NULL, 'DUF5127', NULL, NULL, 32882, 9),
(256448, NULL, 'PF14327', NULL, NULL, 'Hinge domain of cleavage stimulation factor subunit 2', NULL, 'CSTF2_hinge', NULL, NULL, 22222, 9),
(256449, NULL, 'PF14139', NULL, NULL, 'YpzG-like protein', NULL, 'YpzG', NULL, NULL, 26071, 9),
(256450, NULL, 'PF09094', NULL, NULL, 'Alpha-amylase/4-alpha-glucanotransferase, middle domain', NULL, 'AmyA-A_glucT_m', NULL, NULL, 10508, 9),
(256451, NULL, 'PF18754', NULL, NULL, 'Nucleotide modification associated domain 3', NULL, 'Nmad3', NULL, NULL, 28672, 9),
(256452, NULL, 'PF02016', NULL, NULL, 'LD-carboxypeptidase N-terminal domain', NULL, 'Peptidase_S66', NULL, NULL, 32412, 9),
(256453, NULL, 'PF04947', NULL, NULL, 'Poxvirus Late Transcription Factor VLTF3 like', NULL, 'Pox_VLTF3', NULL, NULL, 6937, 9),
(256454, NULL, 'PF09762', NULL, NULL, 'CCDC93, coiled-coil domain', NULL, 'CCDC93_CC', NULL, NULL, 18435, 9),
(256455, NULL, 'PF14561', NULL, NULL, 'Tetratricopeptide repeat', NULL, 'TPR_20', NULL, NULL, NULL, 9),
(256456, NULL, 'PF01806', NULL, NULL, 'Paramyxovirinae P phosphoprotein C-terminal region', NULL, 'Paramyxo_P', NULL, NULL, 3757, 9),
(256457, NULL, 'PF09466', NULL, NULL, 'Hypothetical protein Yqai', NULL, 'Yqai', NULL, NULL, 21035, 9),
(256458, NULL, 'PF19080', NULL, NULL, 'Family of unknown function (DUF5772)', NULL, 'DUF5772', NULL, NULL, 35077, 9),
(256459, NULL, 'PF14898', NULL, NULL, 'Domain of unknown function (DUF4491)', NULL, 'DUF4491', NULL, NULL, 25778, 9),
(256460, NULL, 'PF08104', NULL, NULL, 'Ponericin L family', NULL, 'Antimicrobial_9', NULL, NULL, 12672, 9),
(256461, NULL, 'PF15702', NULL, NULL, 'Hermansky-Pudlak syndrome 6 protein N-terminal domain', NULL, 'HPS6', NULL, NULL, 33792, 9),
(256462, NULL, 'PF08333', NULL, NULL, 'Protein of unknown function (DUF1725)', NULL, 'DUF1725', NULL, NULL, 12753, 9),
(256463, NULL, 'PF09398', NULL, NULL, 'FOP N terminal dimerisation domain', NULL, 'FOP_dimer', NULL, NULL, 15960, 9),
(256464, NULL, 'PF09414', NULL, NULL, 'RNA ligase', NULL, 'RNA_ligase', NULL, NULL, 19468, 9),
(256465, NULL, 'PF02959', NULL, NULL, 'HTLV Tax', NULL, 'Tax', NULL, NULL, 1559, 9),
(256466, NULL, 'PF14639', NULL, NULL, 'Holliday-junction resolvase-like of SPT6', NULL, 'YqgF', NULL, NULL, 22839, 9),
(256467, NULL, 'PF14908', NULL, NULL, 'CCDC81 eukaryotic HU domain 1', NULL, 'HU-CCDC81_euk_1', NULL, NULL, 23824, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(256468, NULL, 'PF11317', NULL, NULL, 'Protein of unknown function (DUF3119)', NULL, 'DUF3119', NULL, NULL, 18058, 9),
(256469, NULL, 'PF03091', NULL, NULL, 'CutA1 divalent ion tolerance protein', NULL, 'CutA1', NULL, NULL, 4969, 9),
(256470, NULL, 'PF14438', NULL, NULL, 'Ataxin 2 SM domain', NULL, 'SM-ATX', NULL, NULL, 24267, 9),
(256471, NULL, 'PF17347', NULL, NULL, 'Family of unknown function (DUF5377)', NULL, 'DUF5377', NULL, NULL, 32639, 9),
(256472, NULL, 'PF19456', NULL, NULL, 'MobI protein', NULL, 'MobI', NULL, NULL, 34255, 9),
(256473, NULL, 'PF16397', NULL, NULL, 'Domain of unknown function (DUF5006)', NULL, 'DUF5006', NULL, NULL, 26178, 9),
(256474, NULL, 'PF08129', NULL, NULL, 'Alpha/beta enterocin family', NULL, 'Antimicrobial17', NULL, NULL, 11862, 9),
(256475, NULL, 'PF03122', NULL, NULL, 'Herpes virus major capsid protein', NULL, 'Herpes_MCP', NULL, NULL, 332, 9),
(256476, NULL, 'PF00135', NULL, NULL, 'Carboxylesterase family', NULL, 'COesterase', NULL, NULL, 5148, 9),
(256477, NULL, 'PF16266', NULL, NULL, 'Domain of unknown function (DUF4919)', NULL, 'DUF4919', NULL, NULL, 21999, 9),
(256478, NULL, 'PF00859', NULL, NULL, 'CTF/NF-I family transcription modulation region', NULL, 'CTF_NFI', NULL, NULL, 6645, 9),
(256479, NULL, 'PF07526', NULL, NULL, 'Associated with HOX', NULL, 'POX', NULL, NULL, 194, 9),
(256480, NULL, 'PF10757', NULL, NULL, 'Biofilm formation regulator YbaJ', NULL, 'YbaJ', NULL, NULL, 20297, 9),
(256481, NULL, 'PF12604', NULL, NULL, 'Tail fibre protein gp37 C terminal', NULL, 'gp37_C', NULL, NULL, 21476, 9),
(256482, NULL, 'PF05334', NULL, NULL, 'Protein of unknown function (DUF719)', NULL, 'DUF719', NULL, NULL, 4177, 9),
(256483, NULL, 'PF15073', NULL, NULL, 'Spermatogenesis-associated protein 48', NULL, 'SPATA48', NULL, NULL, 23572, 9),
(256484, NULL, 'PF17832', NULL, NULL, 'Pre-PUA-like domain', NULL, 'Pre-PUA', NULL, NULL, 29340, 9),
(256485, NULL, 'PF14228', NULL, NULL, 'Cell morphogenesis central region', NULL, 'MOR2-PAG1_mid', NULL, NULL, 26511, 9),
(256486, NULL, 'PF15974', NULL, NULL, 'Cadherin C-terminal cytoplasmic tail, catenin-binding region', NULL, 'Cadherin_tail', NULL, NULL, 25749, 9),
(256487, NULL, 'PF01935', NULL, NULL, 'Helicase HerA, central domain', NULL, 'DUF87', NULL, NULL, 4826, 9),
(256488, NULL, 'PF03400', NULL, NULL, 'IS1 transposase', NULL, 'DDE_Tnp_IS1', NULL, NULL, 2244, 9),
(256489, NULL, 'PF20196', NULL, NULL, 'Family of unknown function (DUF6559)', NULL, 'DUF6559', NULL, NULL, 37496, 9),
(256490, NULL, 'PF17401', NULL, NULL, 'Family of unknown function (DUF5407)', NULL, 'DUF5407', NULL, NULL, 30964, 9),
(256491, NULL, 'PF11624', NULL, NULL, 'MHC class I-like protein M157', NULL, 'M157', NULL, NULL, 15416, 9),
(256492, NULL, 'PF12133', NULL, NULL, 'Betacoronavirus NS6 protein', NULL, 'bCoV_NS6', NULL, NULL, 16503, 9),
(256493, NULL, 'PF18369', NULL, NULL, 'Polyketide synthase dimerisation element domain', NULL, 'PKS_DE', NULL, NULL, 30462, 9),
(256494, NULL, 'PF18264', NULL, NULL, 'CXC domain', NULL, 'preSET_CXC', NULL, NULL, 29224, 9),
(256495, NULL, 'PF07165', NULL, NULL, 'Protein of unknown function (DUF1397)', NULL, 'DUF1397', NULL, NULL, 13263, 9),
(256496, NULL, 'PF15474', NULL, NULL, 'Meiotically up-regulated gene family', NULL, 'MU117', NULL, NULL, 26971, 9),
(256497, NULL, 'PF18201', NULL, NULL, 'PIH1 CS-like domain', NULL, 'PIH1_CS', NULL, NULL, 29091, 9),
(256498, NULL, 'PF04893', NULL, NULL, 'Yip1 domain', NULL, 'Yip1', NULL, NULL, 5984, 9),
(256499, NULL, 'PF08314', NULL, NULL, 'Secretory pathway protein Sec39', NULL, 'Sec39', NULL, NULL, 12678, 9),
(256500, NULL, 'PF09460', NULL, NULL, 'Saf-pilin pilus formation protein', NULL, 'Saf-Nte_pilin', NULL, NULL, 15214, 9),
(256501, NULL, 'PF01370', NULL, NULL, 'NAD dependent epimerase/dehydratase family', NULL, 'Epimerase', NULL, NULL, 3014, 9),
(256502, NULL, 'PF14235', NULL, NULL, 'Domain of unknown function (DUF4337)', NULL, 'DUF4337', NULL, NULL, 23183, 9),
(256503, NULL, 'PF17717', NULL, NULL, 'Family of unknown function (DUF5562)', NULL, 'DUF5562', NULL, NULL, 31418, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(256504, NULL, 'PF05983', NULL, NULL, 'MED7 protein', NULL, 'Med7', NULL, NULL, 13998, 9),
(256505, NULL, 'PF14815', NULL, NULL, 'NUDIX domain', NULL, 'NUDIX_4', NULL, NULL, 25685, 9),
(256506, NULL, 'PF07501', NULL, NULL, 'G5 domain', NULL, 'G5', NULL, NULL, 11020, 9),
(256507, NULL, 'PF00112', NULL, NULL, 'Papain family cysteine protease', NULL, 'Peptidase_C1', NULL, NULL, 5565, 9),
(256508, NULL, 'PF20172', NULL, NULL, 'Domain of unknown function (DUF6538)', NULL, 'DUF6538', NULL, NULL, 37035, 9),
(256509, NULL, 'PF15448', NULL, NULL, 'N-terminal segments of P. falciparum erythrocyte membrane protein', NULL, 'NTS_2', NULL, NULL, 22372, 9),
(256510, NULL, 'PF18330', NULL, NULL, 'Ligase Pab1020 C-terminal region', NULL, 'Lig_C', NULL, NULL, 29740, 9),
(256511, NULL, 'PF11989', NULL, NULL, 'Retrograde transport protein Dsl1 C terminal', NULL, 'Dsl1_C', NULL, NULL, 19640, 9),
(256512, NULL, 'PF13637', NULL, NULL, 'Ankyrin repeats (many copies)', NULL, 'Ank_4', NULL, NULL, 1485, 9),
(256513, NULL, 'PF04548', NULL, NULL, 'AIG1 family', NULL, 'AIG1', NULL, NULL, 2215, 9),
(256514, NULL, 'PF04226', NULL, NULL, 'Transglycosylase associated protein', NULL, 'Transgly_assoc', NULL, NULL, 5742, 9),
(256515, NULL, 'PF14657', NULL, NULL, 'Arm DNA-binding domain', NULL, 'Arm-DNA-bind_4', NULL, NULL, 26825, 9),
(256516, NULL, 'PF11218', NULL, NULL, 'Protein of unknown function (DUF3011)', NULL, 'DUF3011', NULL, NULL, 18327, 9),
(256517, NULL, 'PF05908', NULL, NULL, 'Poly-gamma-glutamate hydrolase', NULL, 'Gamma_PGA_hydro', NULL, NULL, 14373, 9),
(256518, NULL, 'PF07737', NULL, NULL, 'Anthrax toxin lethal factor, N- and C-terminal domain', NULL, 'ATLF', NULL, NULL, 8946, 9),
(256519, NULL, 'PF09136', NULL, NULL, 'Glucodextranase, domain B', NULL, 'Glucodextran_B', NULL, NULL, NULL, 9),
(256520, NULL, 'PF06906', NULL, NULL, 'Protein of unknown function (DUF1272)', NULL, 'DUF1272', NULL, NULL, 9805, 9),
(256521, NULL, 'PF14974', NULL, NULL, 'Protein C10', NULL, 'P_C10', NULL, NULL, 25987, 9),
(256522, NULL, 'PF05499', NULL, NULL, 'DNA methyltransferase 1-associated protein 1 (DMAP1)', NULL, 'DMAP1', NULL, NULL, 12276, 9),
(256523, NULL, 'PF18520', NULL, NULL, 'Spindle pole body component 110 C-terminal domain', NULL, 'Spc110_C', NULL, NULL, 31771, 9),
(256524, NULL, 'PF12743', NULL, NULL, 'Oestrogen-type nuclear receptor final C-terminal', NULL, 'ESR1_C', NULL, NULL, 7694, 9),
(256525, NULL, 'PF05360', NULL, NULL, 'yiaA/B two helix domain', NULL, 'YiaAB', NULL, NULL, 5086, 9),
(256526, NULL, 'PF15516', NULL, NULL, 'BpuSI N-terminal domain', NULL, 'BpuSI_N', NULL, NULL, 23856, 9),
(256527, NULL, 'PF16544', NULL, NULL, 'Homodimerisation region of STAR domain protein', NULL, 'STAR_dimer', NULL, NULL, 21987, 9),
(256528, NULL, 'PF07140', NULL, NULL, 'Interferon gamma receptor (IFNGR1)', NULL, 'IFNGR1', NULL, NULL, 15182, 9),
(256529, NULL, 'PF17158', NULL, NULL, 'Membrane-associated sensor, integral membrane domain', NULL, 'MASE4', NULL, NULL, 31442, 9),
(256530, NULL, 'PF18944', NULL, NULL, 'Family of unknown function (DUF5691)', NULL, 'DUF5691', NULL, NULL, 35771, 9),
(256531, NULL, 'PF07533', NULL, NULL, 'BRK domain', NULL, 'BRK', NULL, NULL, 41, 9),
(256532, NULL, 'PF01040', NULL, NULL, 'UbiA prenyltransferase family', NULL, 'UbiA', NULL, NULL, 5571, 9),
(256533, NULL, 'PF00232', NULL, NULL, 'Glycosyl hydrolase family 1', NULL, 'Glyco_hydro_1', NULL, NULL, 7273, 9),
(256534, NULL, 'PF01987', NULL, NULL, 'Mitochondrial biogenesis AIM24', NULL, 'AIM24', NULL, NULL, 5448, 9),
(256535, NULL, 'PF03188', NULL, NULL, 'Eukaryotic cytochrome b561', NULL, 'Cytochrom_B561', NULL, NULL, 1136, 9),
(256536, NULL, 'PF14782', NULL, NULL, 'Ciliary BBSome complex subunit 2, C-terminal', NULL, 'BBS2_C', NULL, NULL, 21812, 9),
(256537, NULL, 'PF18072', NULL, NULL, 'Formylglycinamide ribonucleotide amidotransferase linker domain', NULL, 'FGAR-AT_linker', NULL, NULL, 29569, 9),
(256538, NULL, 'PF19764', NULL, NULL, 'Family of unknown function (DUF6251)', NULL, 'DUF6251', NULL, NULL, 37489, 9),
(256539, NULL, 'PF05746', NULL, NULL, 'DALR anticodon binding domain', NULL, 'DALR_1', NULL, NULL, 7600, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(256540, NULL, 'PF20213', NULL, NULL, 'Family of unknown function (DUF6573)', NULL, 'DUF6573', NULL, NULL, 37553, 9),
(256541, NULL, 'PF20039', NULL, NULL, 'Family of unknown function (DUF6441)', NULL, 'DUF6441', NULL, NULL, 34413, 9),
(256542, NULL, 'PF14395', NULL, NULL, 'Phage phiEco32-like COOH.NH2 ligase-type 2', NULL, 'COOH-NH2_lig', NULL, NULL, 24797, 9),
(256543, NULL, 'PF00391', NULL, NULL, 'PEP-utilising enzyme, mobile domain', NULL, 'PEP-utilizers', NULL, NULL, 9523, 9),
(256544, NULL, 'PF18101', NULL, NULL, 'Pan3 Pseudokinase domain', NULL, 'Pan3_PK', NULL, NULL, 29750, 9),
(256545, NULL, 'PF00603', NULL, NULL, 'Influenza RNA-dependent RNA polymerase subunit PA', NULL, 'Flu_PA', NULL, NULL, 2060, 9),
(256546, NULL, 'PF14624', NULL, NULL, 'VWA / Hh  protein intein-like', NULL, 'Vwaint', NULL, NULL, 22125, 9),
(256547, NULL, 'PF18836', NULL, NULL, 'YdcK Beta solenoid repeat', NULL, 'B_solenoid_ydck', NULL, NULL, 32159, 9),
(256548, NULL, 'PF08339', NULL, NULL, 'RTX C-terminal domain', NULL, 'RTX_C', NULL, NULL, 12645, 9),
(256549, NULL, 'PF14007', NULL, NULL, 'YtpI-like protein', NULL, 'YtpI', NULL, NULL, 26374, 9),
(256550, NULL, 'PF10445', NULL, NULL, 'Protein of unknown function (DUF2456)', NULL, 'DUF2456', NULL, NULL, 20151, 9),
(256551, NULL, 'PF11929', NULL, NULL, 'Domain of unknown function (DUF3447)', NULL, 'DUF3447', NULL, NULL, 20891, 9),
(256552, NULL, 'PF03408', NULL, NULL, 'Foamy virus envelope protein', NULL, 'Foamy_virus_ENV', NULL, NULL, 2009, 9),
(256553, NULL, 'PF03879', NULL, NULL, 'Cgr1 family', NULL, 'Cgr1', NULL, NULL, 1705, 9),
(256554, NULL, 'PF04334', NULL, NULL, 'Protein of unknown function (DUF478)', NULL, 'DUF478', NULL, NULL, 3889, 9),
(256555, NULL, 'PF19792', NULL, NULL, 'Family of unknown function (DUF6276)', NULL, 'DUF6276', NULL, NULL, 37466, 9),
(256556, NULL, 'PF04392', NULL, NULL, 'ABC transporter substrate binding protein', NULL, 'ABC_sub_bind', NULL, NULL, 10094, 9),
(256557, NULL, 'PF14513', NULL, NULL, 'Diacylglycerol kinase N-terminus', NULL, 'DAG_kinase_N', NULL, NULL, 23439, 9),
(256558, NULL, 'PF01399', NULL, NULL, 'PCI domain', NULL, 'PCI', NULL, NULL, 6531, 9),
(256559, NULL, 'PF03153', NULL, NULL, 'Transcription factor IIA, alpha/beta subunit', NULL, 'TFIIA', NULL, NULL, 7318, 9),
(256560, NULL, 'PF13222', NULL, NULL, 'Protein of unknown function (DUF4030)', NULL, 'DUF4030', NULL, NULL, 22824, 9),
(256561, NULL, 'PF06182', NULL, NULL, 'ABC-2 family transporter protein', NULL, 'ABC2_membrane_6', NULL, NULL, 9111, 9),
(256562, NULL, 'PF08498', NULL, NULL, 'Sterol methyltransferase C-terminal', NULL, 'Sterol_MT_C', NULL, NULL, 13697, 9),
(256563, NULL, 'PF09932', NULL, NULL, 'Uncharacterized conserved protein (DUF2164)', NULL, 'DUF2164', NULL, NULL, 17235, 9),
(256564, NULL, 'PF18060', NULL, NULL, 'F actin bundling C terminal', NULL, 'F_actin_bund_C', NULL, NULL, 29306, 9),
(256565, NULL, 'PF00337', NULL, NULL, 'Galactoside-binding lectin', NULL, 'Gal-bind_lectin', NULL, NULL, 2387, 9),
(256566, NULL, 'PF13105', NULL, NULL, 'Protein of unknown function (DUF3959)', NULL, 'DUF3959', NULL, NULL, 22835, 9),
(256567, NULL, 'PF00709', NULL, NULL, 'Adenylosuccinate synthetase', NULL, 'Adenylsucc_synt', NULL, NULL, 1412, 9),
(256568, NULL, 'PF10300', NULL, NULL, 'Iml2/Tetratricopeptide repeat protein 39', NULL, 'Iml2-TPR_39', NULL, NULL, 16687, 9),
(256569, NULL, 'PF12543', NULL, NULL, 'Protein of unknown function (DUF3738)', NULL, 'DUF3738', NULL, NULL, 19289, 9),
(256570, NULL, 'PF10171', NULL, NULL, 'Translocase of the Inner Mitochondrial membrane 29', NULL, 'Tim29', NULL, NULL, 14747, 9),
(256571, NULL, 'PF06016', NULL, NULL, 'Reovirus core-spike protein lambda-2 (L2)', NULL, 'Reovirus_L2', NULL, NULL, 8589, 9),
(256572, NULL, 'PF17860', NULL, NULL, 'RK-1-like defensin', NULL, 'Defensin_RK-1', NULL, NULL, 28157, 9),
(256573, NULL, 'PF12073', NULL, NULL, 'Protein of unknown function (DUF3553)', NULL, 'DUF3553', NULL, NULL, 20073, 9),
(256574, NULL, 'PF19000', NULL, NULL, 'Family of unknown function (DUF5729)', NULL, 'DUF5729', NULL, NULL, 35142, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(256575, NULL, 'PF19495', NULL, NULL, 'Family of unknown function (DUF6030)', NULL, 'DUF6030', NULL, NULL, 36642, 9),
(256576, NULL, 'PF04014', NULL, NULL, 'Antidote-toxin recognition MazE, bacterial antitoxin', NULL, 'MazE_antitoxin', NULL, NULL, 46, 9),
(256577, NULL, 'PF04545', NULL, NULL, 'Sigma-70, region 4', NULL, 'Sigma70_r4', NULL, NULL, 2185, 9),
(256578, NULL, 'PF14161', NULL, NULL, 'Centrosome-associated N terminus', NULL, 'FAM110_N', NULL, NULL, 25040, 9),
(256579, NULL, 'PF18437', NULL, NULL, 'Nup54 C-terminal interacting domain', NULL, 'Nup54_C', NULL, NULL, 28563, 9),
(256580, NULL, 'PF00011', NULL, NULL, 'Hsp20/alpha crystallin family', NULL, 'HSP20', NULL, NULL, 5084, 9),
(256581, NULL, 'PF14960', NULL, NULL, 'ATP synthase regulation', NULL, 'ATP_synth_reg', NULL, NULL, 10063, 9),
(256582, NULL, 'PF16880', NULL, NULL, 'N-terminal EH-domain containing protein', NULL, 'EHD_N', NULL, NULL, 24335, 9),
(256583, NULL, 'PF03576', NULL, NULL, 'Peptidase family S58', NULL, 'Peptidase_S58', NULL, NULL, 5684, 9),
(256584, NULL, 'PF03158', NULL, NULL, 'Multigene family 530 protein', NULL, 'DUF249', NULL, NULL, 7158, 9),
(256585, NULL, 'PF03353', NULL, NULL, 'Ras-mediated vulval-induction antagonist', NULL, 'Lin-8', NULL, NULL, 1141, 9),
(256586, NULL, 'PF08966', NULL, NULL, 'Domain of unknown function (DUF1882)', NULL, 'DUF1882', NULL, NULL, 8675, 9),
(256587, NULL, 'PF03949', NULL, NULL, 'Malic enzyme, NAD binding domain', NULL, 'Malic_M', NULL, NULL, 13027, 9),
(256588, NULL, 'PF17879', NULL, NULL, 'DNA ligase C-terminal domain', NULL, 'DNA_ligase_C', NULL, NULL, 29548, 9),
(256589, NULL, 'PF19271', NULL, NULL, 'Nis1 family', NULL, 'Nis1', NULL, NULL, 35803, 9),
(256590, NULL, 'PF11872', NULL, NULL, 'Protein of unknown function (DUF3392)', NULL, 'DUF3392', NULL, NULL, 19079, 9),
(256591, NULL, 'PF14096', NULL, NULL, 'Domain of unknown function (DUF4274)', NULL, 'DUF4274', NULL, NULL, 22925, 9),
(256592, NULL, 'PF15180', NULL, NULL, 'Neuropeptides B and W', NULL, 'NPBW', NULL, NULL, 8721, 9),
(256593, NULL, 'PF17002', NULL, NULL, 'Domain of unknown function (DUF5089)', NULL, 'DUF5089', NULL, NULL, 24076, 9),
(256594, NULL, 'PF10588', NULL, NULL, 'NADH-ubiquinone oxidoreductase-G iron-sulfur binding region', NULL, 'NADH-G_4Fe-4S_3', NULL, NULL, 20170, 9),
(256595, NULL, 'PF02898', NULL, NULL, 'Nitric oxide synthase, oxygenase domain', NULL, 'NO_synthase', NULL, NULL, 950, 9),
(256596, NULL, 'PF07490', NULL, NULL, 'Translocated intimin receptor (Tir) N-terminus', NULL, 'Tir_receptor_N', NULL, NULL, 16347, 9),
(256597, NULL, 'PF14505', NULL, NULL, 'Domain of unknown function (DUF4438)', NULL, 'DUF4438', NULL, NULL, 26817, 9),
(256598, NULL, 'PF08156', NULL, NULL, 'NOP5NT (NUC127) domain', NULL, 'NOP5NT', NULL, NULL, 11697, 9),
(256599, NULL, 'PF10410', NULL, NULL, 'DnaB-helicase binding domain of primase', NULL, 'DnaB_bind', NULL, NULL, 17487, 9),
(256600, NULL, 'PF13521', NULL, NULL, 'AAA domain', NULL, 'AAA_28', NULL, NULL, 31800, 9),
(256601, NULL, 'PF03339', NULL, NULL, 'Poxvirus L3/FP4 protein', NULL, 'Pox_L3_FP4', NULL, NULL, 645, 9),
(256602, NULL, 'PF17905', NULL, NULL, 'GLD-3 KH domain 5', NULL, 'KH_10', NULL, NULL, 29496, 9),
(256603, NULL, 'PF10987', NULL, NULL, 'Protein of unknown function (DUF2806)', NULL, 'DUF2806', NULL, NULL, 17676, 9),
(256604, NULL, 'PF06841', NULL, NULL, 'T4-like virus tail tube protein gp19', NULL, 'Phage_T4_gp19', NULL, NULL, 9323, 9),
(256605, NULL, 'PF04479', NULL, NULL, 'RTA1 like protein', NULL, 'RTA1', NULL, NULL, 1673, 9),
(256606, NULL, 'PF12223', NULL, NULL, 'Protein of unknown function (DUF3602)', NULL, 'DUF3602', NULL, NULL, 20286, 9),
(256607, NULL, 'PF17364', NULL, NULL, 'Family of unknown function (DUF5389)', NULL, 'DUF5389', NULL, NULL, 29620, 9),
(256608, NULL, 'PF04794', NULL, NULL, 'YdjC-like protein', NULL, 'YdjC', NULL, NULL, 4777, 9),
(256609, NULL, 'PF09524', NULL, NULL, 'Conserved phage C-terminus (Phg_2220_C)', NULL, 'Phg_2220_C', NULL, NULL, 11987, 9),
(256610, NULL, 'PF11580', NULL, NULL, 'Protein of unknown function (DUF3239)', NULL, 'DUF3239', NULL, NULL, 18597, 9);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(256611, NULL, 'PF10178', NULL, NULL, 'Proteasome assembly chaperone 3', NULL, 'PAC3', NULL, NULL, 19112, 9),
(256612, NULL, 'PF19767', NULL, NULL, 'Family of unknown function (DUF6254)', NULL, 'DUF6254', NULL, NULL, 37422, 9),
(256613, NULL, 'PF01989', NULL, NULL, 'Aconitase X swivel domain', NULL, 'AcnX_swivel_put', NULL, NULL, 5461, 9),
(256614, NULL, 'PF08121', NULL, NULL, 'Waglerin family', NULL, 'Toxin_33', NULL, NULL, 10080, 9),
(256615, NULL, 'PF12060', NULL, NULL, 'Domain of unknown function (DUF3541)', NULL, 'DUF3541', NULL, NULL, 19879, 9),
(256616, NULL, 'PF05755', NULL, NULL, 'Rubber elongation factor protein (REF)', NULL, 'REF', NULL, NULL, 13887, 9),
(256617, NULL, 'PF11419', NULL, NULL, 'Protein of unknown function (DUF3194)', NULL, 'DUF3194', NULL, NULL, 24241, 9),
(256618, NULL, 'PF02363', NULL, NULL, 'Cysteine rich repeat', NULL, 'C_tripleX', NULL, NULL, 4491, 9),
(256619, NULL, 'PF07916', NULL, NULL, 'TraG-like protein, N-terminal region', NULL, 'TraG_N', NULL, NULL, 8036, 9),
(256620, NULL, 'PF15403', NULL, NULL, 'HiaBD2_N domain of Trimeric autotransporter adhesin (GIN)', NULL, 'HiaBD2', NULL, NULL, 26288, 9),
(256621, NULL, 'PF06484', NULL, NULL, 'Teneurin Intracellular Region', NULL, 'Ten_N', NULL, NULL, 9191, 9),
(256622, NULL, 'PF02049', NULL, NULL, 'Flagellar hook-basal body complex protein FliE', NULL, 'FliE', NULL, NULL, 3094, 9),
(256623, NULL, 'PF19190', NULL, NULL, 'Viral BACON domain', NULL, 'BACON_2', NULL, NULL, 23915, 9),
(256624, NULL, 'PF11369', NULL, NULL, 'Protein of unknown function (DUF3160)', NULL, 'DUF3160', NULL, NULL, 16767, 9),
(256625, NULL, 'PF07862', NULL, NULL, 'Nif11 domain', NULL, 'Nif11', NULL, NULL, 13326, 9),
(256626, NULL, 'PF07180', NULL, NULL, 'CaiF/GrlA transcriptional regulator', NULL, 'CaiF_GrlA', NULL, NULL, 19826, 9),
(256627, NULL, 'PF13358', NULL, NULL, 'DDE superfamily endonuclease', NULL, 'DDE_3', NULL, NULL, 28636, 9),
(256628, NULL, 'PF14361', NULL, NULL, 'RsbT co-antagonist protein rsbRD N-terminal domain', NULL, 'RsbRD_N', NULL, NULL, 22303, 9),
(256629, NULL, 'PF19418', NULL, NULL, 'DEPDC5 protein C-terminal region', NULL, 'DEPDC5_CTD', NULL, NULL, 36307, 9),
(256630, NULL, 'PF10185', NULL, NULL, 'Chaperone for wingless signalling and trafficking of LDL receptor', NULL, 'Mesd', NULL, NULL, 14636, 9),
(256631, NULL, 'PF03343', NULL, NULL, 'SART-1 family', NULL, 'SART-1', NULL, NULL, 640, 9),
(256632, NULL, 'PF18832', NULL, NULL, 'Large polyvalent protein-associated domain 18', NULL, 'LPD18', NULL, NULL, 29140, 9),
(256633, NULL, 'PF09345', NULL, NULL, 'SiaC family regulatory phosphoprotein', NULL, 'SiaC', NULL, NULL, 14896, 9),
(256634, NULL, 'PF10075', NULL, NULL, 'CSN8/PSMD8/EIF3K family', NULL, 'CSN8_PSD8_EIF3K', NULL, NULL, 27376, 9),
(256635, NULL, 'PF14218', NULL, NULL, 'Circadian oscillating protein COP23', NULL, 'COP23', NULL, NULL, 26484, 9),
(256636, NULL, 'PF19852', NULL, NULL, 'Family of unknown function (DUF6327)', NULL, 'DUF6327', NULL, NULL, 37615, 9),
(256637, NULL, 'PF19159', NULL, NULL, 'Family of unknown function (DUF5841)', NULL, 'DUF5841', NULL, NULL, 34749, 9),
(256638, NULL, 'PF01980', NULL, NULL, 'tRNA-methyltransferase O', NULL, 'TrmO', NULL, NULL, 15800, 9),
(256639, NULL, 'PF13179', NULL, NULL, 'Family of unknown function (DUF4006)', NULL, 'DUF4006', NULL, NULL, 22795, 9),
(256640, NULL, 'PF16416', NULL, NULL, 'ARM-like repeat domain, GUN4-N terminal', NULL, 'GUN4_N', NULL, NULL, 23628, 9),
(256641, NULL, 'PF19067', NULL, NULL, 'Family of unknown function (DUF5763)', NULL, 'DUF5763', NULL, NULL, 35182, 9),
(256642, NULL, 'PF07344', NULL, NULL, 'Amastin surface glycoprotein', NULL, 'Amastin', NULL, NULL, 8109, 9),
(256643, NULL, 'PF11329', NULL, NULL, 'Protein of unknown function (DUF3131)', NULL, 'DUF3131', NULL, NULL, 18459, 9),
(256644, NULL, 'PF19839', NULL, NULL, 'Ribbon-helix-helix protein', NULL, 'RHH_9', NULL, NULL, 36161, 9),
(256645, NULL, 'PF11233', NULL, NULL, 'Protein of unknown function (DUF3035)', NULL, 'DUF3035', NULL, NULL, 18163, 9),
(256646, NULL, 'PF03237', NULL, NULL, 'Terminase large subunit, T4likevirus-type, N-terminal', NULL, 'Terminase_6N', NULL, NULL, NULL, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(256647, NULL, 'PF10875', NULL, NULL, 'Protein of unknown function (DUF2670)', NULL, 'DUF2670', NULL, NULL, 16735, 9),
(256648, NULL, 'PF07950', NULL, NULL, 'MDM10-complementing protein 1, transmembrane domain', NULL, 'MCP1_TM', NULL, NULL, 14063, 9),
(256649, NULL, 'PF01217', NULL, NULL, 'Clathrin adaptor complex small chain', NULL, 'Clat_adaptor_s', NULL, NULL, 17239, 9),
(256650, NULL, 'PF02838', NULL, NULL, 'Glycosyl hydrolase family 20, domain 2', NULL, 'Glyco_hydro_20b', NULL, NULL, 7441, 9),
(256651, NULL, 'PF05743', NULL, NULL, 'UEV domain', NULL, 'UEV', NULL, NULL, 7525, 9),
(256652, NULL, 'PF00302', NULL, NULL, 'Chloramphenicol acetyltransferase', NULL, 'CAT', NULL, NULL, 3287, 9),
(256653, NULL, 'PF04925', NULL, NULL, 'SHQ1 protein', NULL, 'SHQ1', NULL, NULL, 6622, 9),
(256654, NULL, 'PF19836', NULL, NULL, 'Family of unknown function (DUF6315)', NULL, 'DUF6315', NULL, NULL, 37447, 9),
(256655, NULL, 'PF02141', NULL, NULL, 'DENN (AEX-3) domain', NULL, 'DENN', NULL, NULL, 1098, 9),
(256656, NULL, 'PF16733', NULL, NULL, 'Rhomboid N-terminal domain', NULL, 'NRho', NULL, NULL, 24478, 9),
(256657, NULL, 'PF03752', NULL, NULL, 'Short repeats of unknown function', NULL, 'ALF', NULL, NULL, 555, 9),
(256658, NULL, 'PF18141', NULL, NULL, 'RNA helicase UPF1, 1B domain', NULL, 'UPF1_1B_dom', NULL, NULL, 29283, 9),
(256659, NULL, 'PF15106', NULL, NULL, 'TMEM156 protein family', NULL, 'TMEM156', NULL, NULL, 26243, 9),
(256660, NULL, 'PF13451', NULL, NULL, 'Probable zinc-ribbon domain', NULL, 'zf-trcl', NULL, NULL, 25650, 9),
(256661, NULL, 'PF14923', NULL, NULL, 'Coiled-coil protein 142', NULL, 'CCDC142', NULL, NULL, 24318, 9),
(256662, NULL, 'PF02201', NULL, NULL, 'SWIB/MDM2 domain', NULL, 'SWIB', NULL, NULL, 1503, 9),
(256663, NULL, 'PF14130', NULL, NULL, 'Cap4 dsDNA endonuclease', NULL, 'Cap4_nuclease', NULL, NULL, 26122, 9),
(256664, NULL, 'PF03388', NULL, NULL, 'Legume-like lectin family', NULL, 'Lectin_leg-like', NULL, NULL, 2445, 9),
(256665, NULL, 'PF01627', NULL, NULL, 'Hpt domain', NULL, 'Hpt', NULL, NULL, 7469, 9),
(256666, NULL, 'PF00380', NULL, NULL, 'Ribosomal protein S9/S16', NULL, 'Ribosomal_S9', NULL, NULL, 6788, 9),
(256667, NULL, 'PF03957', NULL, NULL, 'Jun-like transcription factor', NULL, 'Jun', NULL, NULL, 2858, 9),
(256668, NULL, 'PF06213', NULL, NULL, 'Cobalamin biosynthesis protein CobT', NULL, 'CobT', NULL, NULL, 115, 9),
(256669, NULL, 'PF17296', NULL, NULL, 'Arenavirus cap snatching domain', NULL, 'ArenaCapSnatch', NULL, NULL, 21162, 9),
(256670, NULL, 'PF20193', NULL, NULL, 'Family of unknown function (DUF6556)', NULL, 'DUF6556', NULL, NULL, 37348, 9),
(256671, NULL, 'PF14300', NULL, NULL, 'Domain of unknown function (DUF4375)', NULL, 'DUF4375', NULL, NULL, 21925, 9),
(256672, NULL, 'PF00169', NULL, NULL, 'PH domain', NULL, 'PH', NULL, NULL, 1423, 9),
(256673, NULL, 'PF10023', NULL, NULL, 'Putative aminopeptidase', NULL, 'Aminopep', NULL, NULL, 12352, 9),
(256674, NULL, 'PF10742', NULL, NULL, 'Protein of unknown function (DUF2555)', NULL, 'DUF2555', NULL, NULL, 19623, 9),
(256675, NULL, 'PF16664', NULL, NULL, 'Unstructured on SH3 and cysteine-rich domain-containing protein 2', NULL, 'STAC2_u1', NULL, NULL, NULL, 9),
(256676, NULL, 'PF00039', NULL, NULL, 'Fibronectin type I domain', NULL, 'fn1', NULL, NULL, 3709, 9),
(256677, NULL, 'PF13867', NULL, NULL, 'Sin3 binding region of histone deacetylase complex subunit SAP30', NULL, 'SAP30_Sin3_bdg', NULL, NULL, 24565, 9),
(256678, NULL, 'PF05382', NULL, NULL, 'Bacteriophage peptidoglycan hydrolase', NULL, 'Amidase_5', NULL, NULL, 5468, 9),
(256679, NULL, 'PF10094', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2332)', NULL, 'DUF2332', NULL, NULL, 9908, 9),
(256680, NULL, 'PF19216', NULL, NULL, 'Coronavirus replicase NSP15, middle domain', NULL, 'CoV_NSP15_M', NULL, NULL, 35816, 9),
(256681, NULL, 'PF16674', NULL, NULL, 'N-terminal of ubiquitin carboxyl-terminal hydrolase 37', NULL, 'UCH_N', NULL, NULL, 26240, 9),
(256682, NULL, 'PF02682', NULL, NULL, 'Carboxyltransferase domain, subdomain C and D', NULL, 'CT_C_D', NULL, NULL, 6066, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(256683, NULL, 'PF12521', NULL, NULL, 'Protein of unknown function (DUF3724)', NULL, 'DUF3724', NULL, NULL, 16263, 9),
(256684, NULL, 'PF11108', NULL, NULL, 'Viral glycoprotein L', NULL, 'Phage_glycop_gL', NULL, NULL, 13783, 9),
(256685, NULL, 'PF19921', NULL, NULL, 'MoxR-vWA-beta-propeller ternary system domain bpX5', NULL, 'bpX5', NULL, NULL, 37054, 9),
(256686, NULL, 'PF20410', NULL, NULL, 'Domain of unknown function (DUF6696)', NULL, 'DUF6696', NULL, NULL, 37583, 9),
(256687, NULL, 'PF13593', NULL, NULL, 'SBF-like CPA transporter family (DUF4137)', NULL, 'SBF_like', NULL, NULL, 16378, 9),
(256688, NULL, 'PF15780', NULL, NULL, 'Abnormal spindle-like microcephaly-assoc''d, ASPM-SPD-2-Hydin', NULL, 'ASH', NULL, NULL, 26349, 9),
(256689, NULL, 'PF02935', NULL, NULL, 'Cytochrome c oxidase subunit VIIc', NULL, 'COX7C', NULL, NULL, 2700, 9),
(256690, NULL, 'PF01261', NULL, NULL, 'Xylose isomerase-like TIM barrel', NULL, 'AP_endonuc_2', NULL, NULL, 10754, 9),
(256691, NULL, 'PF11726', NULL, NULL, 'Inovirus Gp2', NULL, 'Inovirus_Gp2', NULL, NULL, NULL, 9),
(256692, NULL, 'PF19089', NULL, NULL, 'Membrane bound beta barrel domain (DUF5777)', NULL, 'DUF5777', NULL, NULL, 36574, 9),
(256693, NULL, 'PF00542', NULL, NULL, 'Ribosomal protein L7/L12 C-terminal domain', NULL, 'Ribosomal_L12', NULL, NULL, 10292, 9),
(256694, NULL, 'PF08719', NULL, NULL, 'NADAR domain', NULL, 'NADAR', NULL, NULL, 12703, 9),
(256695, NULL, 'PF15661', NULL, NULL, 'C6orf222, uncharacterised family', NULL, 'CF222', NULL, NULL, 4879, 9),
(256696, NULL, 'PF08904', NULL, NULL, 'EipB-like', NULL, 'EipB_like', NULL, NULL, 7787, 9),
(256697, NULL, 'PF08884', NULL, NULL, 'Flagellin D3 domain', NULL, 'Flagellin_D3', NULL, NULL, 14246, 9),
(256698, NULL, 'PF20257', NULL, NULL, 'SAM hydroxide adenosyltransferase C-terminal domain', NULL, 'SAM_HAT_C', NULL, NULL, 37659, 9),
(256699, NULL, 'PF00252', NULL, NULL, 'Ribosomal protein L16p/L10e', NULL, 'Ribosomal_L16', NULL, NULL, 11696, 9),
(256700, NULL, 'PF02493', NULL, NULL, 'MORN repeat', NULL, 'MORN', NULL, NULL, 5365, 9),
(256701, NULL, 'PF15567', NULL, NULL, 'Immunity protein 35', NULL, 'Imm35', NULL, NULL, 25414, 9),
(256702, NULL, 'PF07826', NULL, NULL, 'IMP cyclohydrolase-like protein', NULL, 'IMP_cyclohyd', NULL, NULL, 20850, 9),
(256703, NULL, 'PF09168', NULL, NULL, 'X-Prolyl dipeptidyl aminopeptidase PepX, N-terminal', NULL, 'PepX_N', NULL, NULL, 12098, 9),
(256704, NULL, 'PF19894', NULL, NULL, 'Family of unknown function (DUF6367)', NULL, 'DUF6367', NULL, NULL, 36572, 9),
(256705, NULL, 'PF18556', NULL, NULL, 'Bacterial Tetracyclin repressor,  C-terminal domain', NULL, 'TetR_C_35', NULL, NULL, 31908, 9),
(256706, NULL, 'PF04988', NULL, NULL, 'A-kinase anchoring protein 95 (AKAP95)', NULL, 'AKAP95', NULL, NULL, 7044, 9),
(256707, NULL, 'PF15323', NULL, NULL, 'Developmental protein', NULL, 'Ashwin', NULL, NULL, 26579, 9),
(256708, NULL, 'PF04518', NULL, NULL, 'Effector from type III secretion system', NULL, 'Effector_1', NULL, NULL, 2839, 9),
(256709, NULL, 'PF00881', NULL, NULL, 'Nitroreductase family', NULL, 'Nitroreductase', NULL, NULL, 23472, 9),
(256710, NULL, 'PF04261', NULL, NULL, 'Dyp-type peroxidase family', NULL, 'Dyp_perox', NULL, NULL, 4616, 9),
(256711, NULL, 'PF04941', NULL, NULL, 'Late expression factor 8 (LEF-8)', NULL, 'LEF-8', NULL, NULL, 6862, 9),
(256712, NULL, 'PF04210', NULL, NULL, 'Tetrahydromethanopterin S-methyltransferase, subunit G', NULL, 'MtrG', NULL, NULL, 6881, 9),
(256713, NULL, 'PF19302', NULL, NULL, 'Domain of unknown function (DUF5915)', NULL, 'DUF5915', NULL, NULL, NULL, 9),
(256714, NULL, 'PF00265', NULL, NULL, 'Thymidine kinase', NULL, 'TK', NULL, NULL, 198, 9),
(256715, NULL, 'PF06116', NULL, NULL, 'Transcriptional activator RinB', NULL, 'RinB', NULL, NULL, 13520, 9),
(256716, NULL, 'PF13062', NULL, NULL, 'Protein of unknown function (DUF3924)', NULL, 'DUF3924', NULL, NULL, 22688, 9),
(256717, NULL, 'PF20491', NULL, NULL, 'Ermin', NULL, 'Ermin', NULL, NULL, 34301, 9),
(256718, NULL, 'PF01947', NULL, NULL, 'Chorismate pyruvate-lyase Rv2949c-like', NULL, 'Rv2949c-like', NULL, NULL, 4905, 9);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(256719, NULL, 'PF12698', NULL, NULL, 'ABC-2 family transporter protein', NULL, 'ABC2_membrane_3', NULL, NULL, NULL, 9),
(256720, NULL, 'PF09289', NULL, NULL, 'Follistatin/Osteonectin-like EGF domain', NULL, 'FOLN', NULL, NULL, 14420, 9),
(256721, NULL, 'PF13343', NULL, NULL, 'Bacterial extracellular solute-binding protein', NULL, 'SBP_bac_6', NULL, NULL, NULL, 9),
(256722, NULL, 'PF15669', NULL, NULL, 'Coiled-coil domain-containing protein 24 family', NULL, 'CCDC24', NULL, NULL, 21595, 9),
(256723, NULL, 'PF12931', NULL, NULL, 'Sec23-binding domain of Sec16', NULL, 'Sec16_C', NULL, NULL, 20303, 9),
(256724, NULL, 'PF15407', NULL, NULL, 'Sporulation protein family 7', NULL, 'Spo7_2_N', NULL, NULL, 26607, 9),
(256725, NULL, 'PF07232', NULL, NULL, 'Putative rep protein (DUF1424)', NULL, 'DUF1424', NULL, NULL, 14158, 9),
(256726, NULL, 'PF11042', NULL, NULL, 'Protein of unknown function (DUF2750)', NULL, 'DUF2750', NULL, NULL, 17651, 9),
(256727, NULL, 'PF20237', NULL, NULL, 'Family of unknown function (DUF6594)', NULL, 'DUF6594', NULL, NULL, 37517, 9),
(256728, NULL, 'PF02142', NULL, NULL, 'MGS-like domain', NULL, 'MGS', NULL, NULL, 8426, 9),
(256729, NULL, 'PF18692', NULL, NULL, 'Family of unknown function (DUF5640)', NULL, 'DUF5640', NULL, NULL, 28583, 9),
(256730, NULL, 'PF18379', NULL, NULL, 'FERM F1 ubiquitin-like domain', NULL, 'FERM_F1', NULL, NULL, 28623, 9),
(256731, NULL, 'PF12876', NULL, NULL, 'Sugar-binding cellulase-like', NULL, 'Cellulase-like', NULL, NULL, 23505, 9),
(256732, NULL, 'PF14836', NULL, NULL, 'Ubiquitin-like domain', NULL, 'Ubiquitin_3', NULL, NULL, 25182, 9),
(256733, NULL, 'PF08079', NULL, NULL, 'Ribosomal L30 N-terminal domain', NULL, 'Ribosomal_L30_N', NULL, NULL, 12217, 9),
(256734, NULL, 'PF03255', NULL, NULL, 'Acetyl co-enzyme A carboxylase carboxyltransferase alpha subunit', NULL, 'ACCA', NULL, NULL, 2312, 9),
(256735, NULL, 'PF07111', NULL, NULL, 'Alpha helical coiled-coil rod protein (HCR)', NULL, 'HCR', NULL, NULL, 13415, 9),
(256736, NULL, 'PF03131', NULL, NULL, 'bZIP Maf transcription factor', NULL, 'bZIP_Maf', NULL, NULL, 4033, 9),
(256737, NULL, 'PF10102', NULL, NULL, 'Domain of unknown function (DUF2341)', NULL, 'DUF2341', NULL, NULL, 18307, 9),
(256738, NULL, 'PF00305', NULL, NULL, 'Lipoxygenase', NULL, 'Lipoxygenase', NULL, NULL, 7731, 9),
(256739, NULL, 'PF15924', NULL, NULL, 'ALG11 mannosyltransferase N-terminus', NULL, 'ALG11_N', NULL, NULL, 22711, 9),
(256740, NULL, 'PF17050', NULL, NULL, 'Altered inheritance of mitochondria 5', NULL, 'AIM5', NULL, NULL, 26726, 9),
(256741, NULL, 'PF17899', NULL, NULL, 'Peptidase M61 N-terminal domain', NULL, 'Peptidase_M61_N', NULL, NULL, 28961, 9),
(256742, NULL, 'PF02567', NULL, NULL, 'Phenazine biosynthesis-like protein', NULL, 'PhzC-PhzF', NULL, NULL, 2059, 9),
(256743, NULL, 'PF17206', NULL, NULL, 'SeqA protein N-terminal domain', NULL, 'SeqA_N', NULL, NULL, 28957, 9),
(256744, NULL, 'PF20009', NULL, NULL, 'GEVED domain', NULL, 'GEVED', NULL, NULL, 35956, 9),
(256745, NULL, 'PF17512', NULL, NULL, 'Metapneumovirus Small hydrophobic protein', NULL, 'Sh_2', NULL, NULL, 17477, 9),
(256746, NULL, 'PF01187', NULL, NULL, 'Macrophage migration inhibitory factor (MIF)', NULL, 'MIF', NULL, NULL, 3434, 9),
(256747, NULL, 'PF14018', NULL, NULL, 'Domain of unknown function (DUF4234)', NULL, 'DUF4234', NULL, NULL, 22490, 9),
(256748, NULL, 'PF14258', NULL, NULL, 'Domain of unknown function (DUF4350)', NULL, 'DUF4350', NULL, NULL, 24641, 9),
(256749, NULL, 'PF12249', NULL, NULL, 'Arabinofuranosyltransferase A C terminal', NULL, 'AftA_C', NULL, NULL, 15961, 9),
(256750, NULL, 'PF15686', NULL, NULL, 'Lysine-rich CEACAM1 co-isolated protein family', NULL, 'LYRIC', NULL, NULL, 24334, 9),
(256751, NULL, 'PF20144', NULL, NULL, 'TIG domain', NULL, 'TIG_SUH', NULL, NULL, 27760, 9),
(256752, NULL, 'PF04280', NULL, NULL, 'Tim44-like domain', NULL, 'Tim44', NULL, NULL, 5695, 9),
(256753, NULL, 'PF05837', NULL, NULL, 'Centromere protein H (CENP-H)', NULL, 'CENP-H', NULL, NULL, 8754, 9),
(256754, NULL, 'PF00408', NULL, NULL, 'Phosphoglucomutase/phosphomannomutase, C-terminal domain', NULL, 'PGM_PMM_IV', NULL, NULL, 5517, 9);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(256755, NULL, 'PF05053', NULL, NULL, 'Menin', NULL, 'Menin', NULL, NULL, 1459, 9),
(256756, NULL, 'PF07731', NULL, NULL, 'Multicopper oxidase', NULL, 'Cu-oxidase_2', NULL, NULL, 8137, 9),
(256757, NULL, 'PF12624', NULL, NULL, 'N-terminal region of Chorein or VPS13', NULL, 'Chorein_N', NULL, NULL, 24842, 9),
(256758, NULL, 'PF18277', NULL, NULL, 'AbrB C-terminal domain', NULL, 'AbrB_C', NULL, NULL, 28881, 9),
(256759, NULL, 'PF20619', NULL, NULL, 'Family of unknown function (DUF6804)', NULL, 'DUF6804', NULL, NULL, 37506, 9),
(256760, NULL, 'PF06496', NULL, NULL, 'Protein of unknown function (DUF1097)', NULL, 'DUF1097', NULL, NULL, 9108, 9),
(256761, NULL, 'PF11779', NULL, NULL, 'Small subunit of serine palmitoyltransferase-like', NULL, 'SPT_ssu-like', NULL, NULL, 24805, 9),
(256762, NULL, 'PF20219', NULL, NULL, 'Family of unknown function (DUF6579)', NULL, 'DUF6579', NULL, NULL, 37660, 9),
(256763, NULL, 'PF16676', NULL, NULL, 'Transactivation domain of FOXO protein family', NULL, 'FOXO-TAD', NULL, NULL, 26245, 9),
(256764, NULL, 'PF06476', NULL, NULL, 'Protein of unknown function (DUF1090)', NULL, 'DUF1090', NULL, NULL, 9086, 9),
(256765, NULL, 'PF09862', NULL, NULL, 'Protein of unknown function (DUF2089)', NULL, 'DUF2089', NULL, NULL, 16685, 9),
(256766, NULL, 'PF04887', NULL, NULL, 'Poxvirus M2 protein', NULL, 'Pox_M2', NULL, NULL, 5902, 9),
(256767, NULL, 'PF15082', NULL, NULL, 'Domain of unknown function (DUF4549)', NULL, 'DUF4549', NULL, NULL, 26212, 9),
(256768, NULL, 'PF13537', NULL, NULL, 'Glutamine amidotransferase domain', NULL, 'GATase_7', NULL, NULL, 18854, 9),
(256769, NULL, 'PF14206', NULL, NULL, 'Cysteine-rich CPCC', NULL, 'Cys_rich_CPCC', NULL, NULL, 24670, 9),
(256770, NULL, 'PF12001', NULL, NULL, 'Domain of unknown function (DUF3496)', NULL, 'DUF3496', NULL, NULL, 19870, 9),
(256771, NULL, 'PF11070', NULL, NULL, 'Protein of unknown function (DUF2871)', NULL, 'DUF2871', NULL, NULL, 17766, 9),
(256772, NULL, 'PF03636', NULL, NULL, 'Glycosyl hydrolase family 65, N-terminal domain', NULL, 'Glyco_hydro_65N', NULL, NULL, 5268, 9),
(256773, NULL, 'PF00691', NULL, NULL, 'OmpA family', NULL, 'OmpA', NULL, NULL, 1786, 9),
(256774, NULL, 'PF08332', NULL, NULL, 'Calcium/calmodulin dependent protein kinase II association domain', NULL, 'CaMKII_AD', NULL, NULL, 12790, 9),
(256775, NULL, 'PF18150', NULL, NULL, 'Domain of unknown function (DUF5600)', NULL, 'DUF5600', NULL, NULL, 28814, 9),
(256776, NULL, 'PF02273', NULL, NULL, 'Acyl transferase', NULL, 'Acyl_transf_2', NULL, NULL, 1549, 9),
(256777, NULL, 'PF05544', NULL, NULL, 'Proline racemase', NULL, 'Pro_racemase', NULL, NULL, 13600, 9),
(256778, NULL, 'PF02918', NULL, NULL, 'Pertussis toxin, subunit 2 and 3, C-terminal domain', NULL, 'Pertussis_S2S3', NULL, NULL, 17630, 9),
(256779, NULL, 'PF09666', NULL, NULL, 'Sororin protein', NULL, 'Sororin', NULL, NULL, 15913, 9),
(256780, NULL, 'PF04787', NULL, NULL, 'Late protein H7', NULL, 'Pox_H7', NULL, NULL, 4834, 9),
(256781, NULL, 'PF06017', NULL, NULL, 'Unconventional myosin tail, actin- and lipid-binding', NULL, 'Myosin_TH1', NULL, NULL, 7555, 9),
(256782, NULL, 'PF12786', NULL, NULL, 'GB virus C genotype envelope', NULL, 'GBV-C_env', NULL, NULL, 22172, 9),
(256783, NULL, 'PF00757', NULL, NULL, 'Furin-like cysteine rich region', NULL, 'Furin-like', NULL, NULL, 11388, 9),
(256784, NULL, 'PF13785', NULL, NULL, 'Domain of unknown function (DUF4178)', NULL, 'DUF4178', NULL, NULL, 23010, 9),
(256785, NULL, 'PF16042', NULL, NULL, 'Domain of unknown function (DUF4794)', NULL, 'DUF4794', NULL, NULL, 25781, 9),
(256786, NULL, 'PF13044', NULL, NULL, 'Fusion glycoprotein F0, Isavirus', NULL, 'Fusion_F0', NULL, NULL, 21084, 9),
(256787, NULL, 'PF17223', NULL, NULL, 'Cuticle protein CPCFC', NULL, 'CPCFC', NULL, NULL, 30496, 9),
(256788, NULL, 'PF09656', NULL, NULL, 'Putative transmembrane protein (PGPGW)', NULL, 'PGPGW', NULL, NULL, 17708, 9),
(256789, NULL, 'PF12393', NULL, NULL, 'Dr family adhesin', NULL, 'Dr_adhesin', NULL, NULL, 15848, 9),
(256790, NULL, 'PF03514', NULL, NULL, 'GRAS domain family', NULL, 'GRAS', NULL, NULL, 5269, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(256791, NULL, 'PF08816', NULL, NULL, 'Inhibitor of vertebrate lysozyme (Ivy)', NULL, 'Ivy', NULL, NULL, NULL, 9),
(256792, NULL, 'PF13519', NULL, NULL, 'von Willebrand factor type A domain', NULL, 'VWA_2', NULL, NULL, 2425, 9),
(256793, NULL, 'PF20423', NULL, NULL, 'Isocitrate dehydrogenase kinase/phosphatase (AceK), regulatory domain', NULL, 'AceK_regulatory', NULL, NULL, 35533, 9),
(256794, NULL, 'PF17693', NULL, NULL, 'Family of unknown function (DUF5539)', NULL, 'DUF5539', NULL, NULL, 28041, 9),
(256795, NULL, 'PF18021', NULL, NULL, 'Agglutinin C-terminal', NULL, 'Agglutinin_C', NULL, NULL, 31894, 9),
(256796, NULL, 'PF14835', NULL, NULL, 'zf-RING of BARD1-type protein', NULL, 'zf-RING_6', NULL, NULL, 28584, 9),
(256797, NULL, 'PF00931', NULL, NULL, 'NB-ARC domain', NULL, 'NB-ARC', NULL, NULL, 1344, 9),
(256798, NULL, 'PF18410', NULL, NULL, 'Basic tilted helix bundle domain', NULL, 'BTHB', NULL, NULL, 29034, 9),
(256799, NULL, 'PF03263', NULL, NULL, 'Cucumovirus protein 2B', NULL, 'Cucumo_2B', NULL, NULL, 1802, 9),
(256800, NULL, 'PF05835', NULL, NULL, 'Synaphin protein', NULL, 'Synaphin', NULL, NULL, 13850, 9),
(256801, NULL, 'PF11455', NULL, NULL, 'Antitoxin MazE-like', NULL, 'MazE-like', NULL, NULL, 18514, 9),
(256802, NULL, 'PF13491', NULL, NULL, '4TM region of DNA translocase FtsK/SpoIIIE', NULL, 'FtsK_4TM', NULL, NULL, 22600, 9),
(256803, NULL, 'PF10537', NULL, NULL, 'ATP-utilising chromatin assembly and remodelling N-terminal', NULL, 'WAC_Acf1_DNA_bd', NULL, NULL, 7632, 9),
(256804, NULL, 'PF16460', NULL, NULL, 'Phage tail tube, TTP, lambda-like', NULL, 'Phage_TTP_11', NULL, NULL, 22320, 9),
(256805, NULL, 'PF00477', NULL, NULL, 'Small hydrophilic plant seed protein', NULL, 'LEA_5', NULL, NULL, 29703, 9),
(256806, NULL, 'PF15225', NULL, NULL, 'Interleukin 32', NULL, 'IL32', NULL, NULL, 25457, 9),
(256807, NULL, 'PF06309', NULL, NULL, 'Torsin', NULL, 'Torsin', NULL, NULL, 10400, 9),
(256808, NULL, 'PF09935', NULL, NULL, 'Protein of unknown function (DUF2167)', NULL, 'DUF2167', NULL, NULL, 17494, 9),
(256809, NULL, 'PF02217', NULL, NULL, 'Origin of replication binding protein', NULL, 'T_Ag_DNA_bind', NULL, NULL, 1992, 9),
(256810, NULL, 'PF16146', NULL, NULL, 'Domain of unknown function (DUF4854)', NULL, 'DUF4854', NULL, NULL, 22556, 9),
(256811, NULL, 'PF01846', NULL, NULL, 'FF domain', NULL, 'FF', NULL, NULL, 3694, 9),
(256812, NULL, 'PF11220', NULL, NULL, 'Protein of unknown function (DUF3015)', NULL, 'DUF3015', NULL, NULL, 18494, 9),
(256813, NULL, 'PF20580', NULL, NULL, 'Domain of unknown function (DUF6784)', NULL, 'DUF6784', NULL, NULL, 37085, 9),
(256814, NULL, 'PF13391', NULL, NULL, 'HNH endonuclease', NULL, 'HNH_2', NULL, NULL, 848, 9),
(256815, NULL, 'PF17048', NULL, NULL, 'Neutral/alkaline non-lysosomal ceramidase, C-terminal', NULL, 'Ceramidse_alk_C', NULL, NULL, 21665, 9),
(256816, NULL, 'PF07302', NULL, NULL, 'AroM protein', NULL, 'AroM', NULL, NULL, 11895, 9),
(256817, NULL, 'PF11401', NULL, NULL, 'Tetrabrachion', NULL, 'Tetrabrachion', NULL, NULL, 18772, 9),
(256818, NULL, 'PF13290', NULL, NULL, 'Chitobiase/beta-hexosaminidase C-terminal domain', NULL, 'CHB_HEX_C_1', NULL, NULL, NULL, 9),
(256819, NULL, 'PF17634', NULL, NULL, 'Gene product 67', NULL, 'GP67', NULL, NULL, 14635, 9),
(256820, NULL, 'PF16186', NULL, NULL, 'Atypical Arm repeat', NULL, 'Arm_3', NULL, NULL, 25494, 9),
(256821, NULL, 'PF06134', NULL, NULL, 'L-rhamnose isomerase (RhaA)', NULL, 'RhaA', NULL, NULL, 13924, 9),
(256822, NULL, 'PF19064', NULL, NULL, 'Family of unknown function (DUF5760)', NULL, 'DUF5760', NULL, NULL, 35922, 9),
(256823, NULL, 'PF19114', NULL, NULL, 'EsV-1-7 cysteine-rich motif', NULL, 'EsV_1_7_cys', NULL, NULL, 35994, 9),
(256824, NULL, 'PF03840', NULL, NULL, 'Preprotein translocase SecG subunit', NULL, 'SecG', NULL, NULL, 3030, 9),
(256825, NULL, 'PF00312', NULL, NULL, 'Ribosomal protein S15', NULL, 'Ribosomal_S15', NULL, NULL, 5694, 9),
(256826, NULL, 'PF17588', NULL, NULL, 'Family of unknown function (DUF5486)', NULL, 'DUF5486', NULL, NULL, 28425, 9),
(256827, NULL, 'PF18019', NULL, NULL, 'HD domain', NULL, 'HD_6', NULL, NULL, 6120, 9);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(256828, NULL, 'PF04601', NULL, NULL, 'Domain of unknown function (DUF569)', NULL, 'DUF569', NULL, NULL, 686, 9),
(256829, NULL, 'PF13569', NULL, NULL, 'Domain of unknown function (DUF4132)', NULL, 'DUF4132', NULL, NULL, 22223, 9),
(256830, NULL, 'PF02232', NULL, NULL, 'Alpha trans-inducing protein (Alpha-TIF)', NULL, 'Alpha_TIF', NULL, NULL, 1852, 9),
(256831, NULL, 'PF03591', NULL, NULL, 'AzlC protein', NULL, 'AzlC', NULL, NULL, 12766, 9),
(256832, NULL, 'PF08272', NULL, NULL, 'Topoisomerase I zinc-ribbon-like', NULL, 'Topo_Zn_Ribbon', NULL, NULL, 13228, 9),
(256833, NULL, 'PF07619', NULL, NULL, 'Protein of unknown function (DUF1581)', NULL, 'DUF1581', NULL, NULL, 16507, 9),
(256834, NULL, 'PF09926', NULL, NULL, 'Uncharacterized small protein (DUF2158)', NULL, 'DUF2158', NULL, NULL, 19108, 9),
(256835, NULL, 'PF12088', NULL, NULL, 'Protein of unknown function (DUF3565)', NULL, 'DUF3565', NULL, NULL, 20304, 9),
(256836, NULL, 'PF05189', NULL, NULL, 'RNA 3''-terminal phosphate cyclase (RTC), insert domain', NULL, 'RTC_insert', NULL, NULL, 8108, 9),
(256837, NULL, 'PF15755', NULL, NULL, 'Domain of unknown function (DUF4689)', NULL, 'DUF4689', NULL, NULL, 24767, 9),
(256838, NULL, 'PF04996', NULL, NULL, 'Succinylarginine dihydrolase', NULL, 'AstB', NULL, NULL, 394, 9),
(256839, NULL, 'PF07225', NULL, NULL, 'NADH-ubiquinone oxidoreductase B15 subunit (NDUFB4)', NULL, 'NDUF_B4', NULL, NULL, 14201, 9),
(256840, NULL, 'PF10176', NULL, NULL, 'Protein of unknown function (DUF2370)', NULL, 'DUF2370', NULL, NULL, 14775, 9),
(256841, NULL, 'PF10438', NULL, NULL, 'Cyclo-malto-dextrinase C-terminal domain', NULL, 'Cyc-maltodext_C', NULL, NULL, 18113, 9),
(256842, NULL, 'PF14058', NULL, NULL, 'PcfK-like protein', NULL, 'PcfK', NULL, NULL, 24298, 9),
(256843, NULL, 'PF19882', NULL, NULL, 'Family of unknown function (DUF6355)', NULL, 'DUF6355', NULL, NULL, 36553, 9),
(256844, NULL, 'PF07559', NULL, NULL, 'Flagellar basal body protein FlaE', NULL, 'FlaE', NULL, NULL, 12887, 9),
(256845, NULL, 'PF06890', NULL, NULL, 'Bacteriophage Mu Gp45 spike protein', NULL, 'Phage_Mu_Gp45', NULL, NULL, 9875, 9),
(256846, NULL, 'PF06107', NULL, NULL, 'Bacterial protein of unknown function (DUF951)', NULL, 'DUF951', NULL, NULL, 13816, 9),
(256847, NULL, 'PF09871', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2098)', NULL, 'DUF2098', NULL, NULL, 19427, 9),
(256848, NULL, 'PF00946', NULL, NULL, 'Mononegavirales RNA dependent RNA polymerase', NULL, 'Mononeg_RNA_pol', NULL, NULL, 13444, 9),
(256849, NULL, 'PF15484', NULL, NULL, 'Domain of unknown function (DUF4642)', NULL, 'DUF4642', NULL, NULL, 21829, 9),
(256850, NULL, 'PF06676', NULL, NULL, 'Protein of unknown function (DUF1178)', NULL, 'DUF1178', NULL, NULL, 10333, 9),
(256851, NULL, 'PF16987', NULL, NULL, 'KIX domain', NULL, 'KIX_2', NULL, NULL, 30272, 9),
(256852, NULL, 'PF03689', NULL, NULL, 'Nepovirus coat protein, N-terminal domain', NULL, 'Nepo_coat_N', NULL, NULL, 5092, 9),
(256853, NULL, 'PF12143', NULL, NULL, 'Protein of unknown function (DUF_B2219)', NULL, 'PPO1_KFDV', NULL, NULL, 16740, 9),
(256854, NULL, 'PF00949', NULL, NULL, 'Peptidase S7, Flavivirus NS3 serine protease', NULL, 'Peptidase_S7', NULL, NULL, 4185, 9),
(256855, NULL, 'PF03882', NULL, NULL, 'MukF winged-helix domain', NULL, 'KicB', NULL, NULL, 31709, 9),
(256856, NULL, 'PF05185', NULL, NULL, 'PRMT5 arginine-N-methyltransferase', NULL, 'PRMT5', NULL, NULL, 14104, 9),
(256857, NULL, 'PF17858', NULL, NULL, 'Platypus intermediate defensin-like peptide', NULL, 'Defensin_int', NULL, NULL, NULL, 9),
(256858, NULL, 'PF05520', NULL, NULL, 'Citrus tristeza virus P18 protein', NULL, 'Citrus_P18', NULL, NULL, 11518, 9),
(256859, NULL, 'PF07202', NULL, NULL, 'T-complex protein 10 C-terminus', NULL, 'Tcp10_C', NULL, NULL, 14498, 9),
(256860, NULL, 'PF07689', NULL, NULL, 'KaiB domain', NULL, 'KaiB', NULL, NULL, 10807, 9),
(256861, NULL, 'PF18395', NULL, NULL, 'Cas3 C-terminal domain', NULL, 'Cas3_C', NULL, NULL, 29476, 9),
(256862, NULL, 'PF06009', NULL, NULL, 'Laminin Domain II', NULL, 'Laminin_II', NULL, NULL, 8135, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(256863, NULL, 'PF14853', NULL, NULL, 'Fis1 C-terminal tetratricopeptide repeat', NULL, 'Fis1_TPR_C', NULL, NULL, 25945, 9),
(256864, NULL, 'PF13929', NULL, NULL, 'mRNA stabilisation', NULL, 'mRNA_stabil', NULL, NULL, 21637, 9),
(256865, NULL, 'PF06652', NULL, NULL, 'Methuselah N-terminus', NULL, 'Methuselah_N', NULL, NULL, 8052, 9),
(256866, NULL, 'PF07799', NULL, NULL, 'Protein of unknown function (DUF1643)', NULL, 'DUF1643', NULL, NULL, 14244, 9),
(256867, NULL, 'PF08931', NULL, NULL, 'Receptor-binding protein of phage tail base-plate Siphoviridae, head', NULL, 'Caudo_bapla_RBP', NULL, NULL, 7799, 9),
(256868, NULL, 'PF02001', NULL, NULL, 'Protein of unknown function  DUF134', NULL, 'DUF134', NULL, NULL, 5808, 9),
(256869, NULL, 'PF06852', NULL, NULL, 'Protein of unknown function (DUF1248)', NULL, 'DUF1248', NULL, NULL, 11481, 9),
(256870, NULL, 'PF15253', NULL, NULL, 'SCL-interrupting locus protein N-terminus', NULL, 'STIL_N', NULL, NULL, 25889, 9),
(256871, NULL, 'PF17341', NULL, NULL, 'Family of unknown function (DUF5371)', NULL, 'DUF5371', NULL, NULL, 11831, 9),
(256872, NULL, 'PF06448', NULL, NULL, 'Domain of Unknown Function (DUF1081)', NULL, 'DUF1081', NULL, NULL, 9358, 9),
(256873, NULL, 'PF09626', NULL, NULL, 'Dihaem cytochrome c', NULL, 'DHC', NULL, NULL, 15694, 9),
(256874, NULL, 'PF06862', NULL, NULL, 'Utp25, U3 small nucleolar RNA-associated SSU processome protein 25', NULL, 'UTP25', NULL, NULL, 9162, 9),
(256875, NULL, 'PF04016', NULL, NULL, 'Putative heavy-metal chelation', NULL, 'DUF364', NULL, NULL, 129, 9),
(256876, NULL, 'PF06246', NULL, NULL, 'Isy1-like splicing family', NULL, 'Isy1', NULL, NULL, 14329, 9),
(256877, NULL, 'PF19807', NULL, NULL, 'Family of unknown function (DUF6290)', NULL, 'DUF6290', NULL, NULL, 37154, 9),
(256878, NULL, 'PF06450', NULL, NULL, 'Bacterial Na+/H+ antiporter B (NhaB)', NULL, 'NhaB', NULL, NULL, 2742, 9),
(256879, NULL, 'PF03253', NULL, NULL, 'Urea transporter', NULL, 'UT', NULL, NULL, 1856, 9),
(256880, NULL, 'PF03443', NULL, NULL, 'Auxiliary Activity family 9 (formerly GH61)', NULL, 'AA9', NULL, NULL, 10816, 9),
(256881, NULL, 'PF10528', NULL, NULL, 'GLEYA domain', NULL, 'GLEYA', NULL, NULL, 20957, 9),
(256882, NULL, 'PF17431', NULL, NULL, 'Uncharacterized YmpT-like', NULL, 'YpmT', NULL, NULL, 28689, 9),
(256883, NULL, 'PF14163', NULL, NULL, 'Super-infection exclusion protein B', NULL, 'SieB', NULL, NULL, 24597, 9),
(256884, NULL, 'PF01749', NULL, NULL, 'Importin beta binding domain', NULL, 'IBB', NULL, NULL, 2791, 9),
(256885, NULL, 'PF02861', NULL, NULL, 'Clp amino terminal domain, pathogenicity island component', NULL, 'Clp_N', NULL, NULL, 2648, 9),
(256886, NULL, 'PF13232', NULL, NULL, 'Complex1_LYR-like', NULL, 'Complex1_LYR_1', NULL, NULL, 5026, 9),
(256887, NULL, 'PF03937', NULL, NULL, 'Flavinator of succinate dehydrogenase', NULL, 'Sdh5', NULL, NULL, 2660, 9),
(256888, NULL, 'PF06461', NULL, NULL, 'CHD subfamily II, SANT-like domain', NULL, 'CHDII_SANT-like', NULL, NULL, 9243, 9),
(256889, NULL, 'PF16215', NULL, NULL, 'Protein of unknown function (DUF4876)', NULL, 'DUF4876', NULL, NULL, 26119, 9),
(256890, NULL, 'PF20328', NULL, NULL, 'Family of unknown function (DUF6623)', NULL, 'DUF6623', NULL, NULL, 37200, 9),
(256891, NULL, 'PF10834', NULL, NULL, 'Protein of unknown function (DUF2560)', NULL, 'DUF2560', NULL, NULL, 16264, 9),
(256892, NULL, 'PF04446', NULL, NULL, 'tRNAHis guanylyltransferase', NULL, 'Thg1', NULL, NULL, 24130, 9),
(256893, NULL, 'PF13125', NULL, NULL, 'Protein of unknown function (DUF3958)', NULL, 'DUF3958', NULL, NULL, 25840, 9),
(256894, NULL, 'PF17079', NULL, NULL, 'Male-specific protein scotti', NULL, 'SOTI', NULL, NULL, 23992, 9),
(256895, NULL, 'PF00005', NULL, NULL, 'ABC transporter', NULL, 'ABC_tran', NULL, NULL, 5360, 9),
(256896, NULL, 'PF16635', NULL, NULL, 'Unstructured region on APC between SAMP and APC_crr', NULL, 'APC_u14', NULL, NULL, NULL, 9),
(256897, NULL, 'PF05690', NULL, NULL, 'Thiazole biosynthesis protein ThiG', NULL, 'ThiG', NULL, NULL, 25551, 9),
(256898, NULL, 'PF13901', NULL, NULL, 'Putative zinc-RING and/or ribbon', NULL, 'zf-RING_9', NULL, NULL, 23140, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(256899, NULL, 'PF19024', NULL, NULL, 'Family of unknown function (DUF5750)', NULL, 'DUF5750', NULL, NULL, 34793, 9),
(256900, NULL, 'PF01967', NULL, NULL, 'MoaC family', NULL, 'MoaC', NULL, NULL, 4665, 9),
(256901, NULL, 'PF10454', NULL, NULL, 'Protein of unknown function (DUF2458)', NULL, 'DUF2458', NULL, NULL, 20995, 9),
(256902, NULL, 'PF13386', NULL, NULL, 'Cytochrome C biogenesis protein transmembrane region', NULL, 'DsbD_2', NULL, NULL, 30674, 9),
(256903, NULL, 'PF09495', NULL, NULL, 'Protein of unknown function (DUF2462)', NULL, 'DUF2462', NULL, NULL, 15825, 9),
(256904, NULL, 'PF18779', NULL, NULL, 'Capping Ribonuclease inhibitor Leucine Rich Repeat', NULL, 'LRR_RI_capping', NULL, NULL, 29192, 9),
(256905, NULL, 'PF20048', NULL, NULL, 'Domain of unknown function (DUF6450)', NULL, 'DUF6450', NULL, NULL, 34103, 9),
(256906, NULL, 'PF18575', NULL, NULL, 'HAMP N-terminal domain 3', NULL, 'HAMP_N3', NULL, NULL, 29275, 9),
(256907, NULL, 'PF18586', NULL, NULL, 'Chromatin remodeling factor Mit1 C-terminal Zn finger 1', NULL, 'zf-CCCH_7', NULL, NULL, 29333, 9),
(256908, NULL, 'PF10232', NULL, NULL, 'Mediator of RNA polymerase II transcription complex subunit 8', NULL, 'Med8', NULL, NULL, 15776, 9),
(256909, NULL, 'PF10561', NULL, NULL, 'C2orf69', NULL, 'C2orf69', NULL, NULL, 20847, 9),
(256910, NULL, 'PF19453', NULL, NULL, 'Family of unknown function (DUF5991)', NULL, 'DUF5991', NULL, NULL, 36969, 9),
(256911, NULL, 'PF02901', NULL, NULL, 'Pyruvate formate lyase-like', NULL, 'PFL-like', NULL, NULL, 2761, 9),
(256912, NULL, 'PF00871', NULL, NULL, 'Acetokinase family', NULL, 'Acetate_kinase', NULL, NULL, 5, 9),
(256913, NULL, 'PF12064', NULL, NULL, 'Protein kinase C-binding protein 1', NULL, 'DUF3544', NULL, NULL, 19620, 9),
(256914, NULL, 'PF03456', NULL, NULL, 'uDENN domain', NULL, 'uDENN', NULL, NULL, 10835, 9),
(256915, NULL, 'PF06209', NULL, NULL, 'Cofactor of BRCA1 (COBRA1)', NULL, 'COBRA1', NULL, NULL, 9307, 9),
(256916, NULL, 'PF10817', NULL, NULL, 'Protein of unknown function (DUF2563)', NULL, 'DUF2563', NULL, NULL, 16163, 9),
(256917, NULL, 'PF11095', NULL, NULL, 'Gem-associated protein 7 (Gemin7)', NULL, 'Gemin7', NULL, NULL, 19995, 9),
(256918, NULL, 'PF12738', NULL, NULL, 'twin BRCT domain', NULL, 'PTCB-BRCT', NULL, NULL, 7483, 9),
(256919, NULL, 'PF04608', NULL, NULL, 'Phosphatidylglycerophosphatase A', NULL, 'PgpA', NULL, NULL, 1129, 9),
(256920, NULL, 'PF00426', NULL, NULL, 'Outer Capsid protein VP4 (Hemagglutinin) Concanavalin-like domain', NULL, 'VP4_haemagglut', NULL, NULL, 6869, 9),
(256921, NULL, 'PF00023', NULL, NULL, 'Ankyrin repeat', NULL, 'Ank', NULL, NULL, 1485, 9),
(256922, NULL, 'PF09768', NULL, NULL, 'Peptidase M76 family', NULL, 'Peptidase_M76', NULL, NULL, 18119, 9),
(256923, NULL, 'PF01881', NULL, NULL, 'CRISPR associated protein Cas6, C-terminal', NULL, 'Cas_Cas6_C', NULL, NULL, 10582, 9),
(256924, NULL, 'PF07741', NULL, NULL, 'Brf1-like TBP-binding domain', NULL, 'BRF1', NULL, NULL, 10822, 9),
(256925, NULL, 'PF10315', NULL, NULL, 'Altered inheritance of mitochondria protein 19', NULL, 'Aim19', NULL, NULL, 16501, 9),
(256926, NULL, 'PF13630', NULL, NULL, 'SdpI/YfhL protein family', NULL, 'SdpI', NULL, NULL, 24087, 9),
(256927, NULL, 'PF11399', NULL, NULL, 'Protein of unknown function (DUF3192)', NULL, 'DUF3192', NULL, NULL, 18550, 9),
(256928, NULL, 'PF12221', NULL, NULL, 'Bacterial membrane protein N terminal', NULL, 'HflK_N', NULL, NULL, 15585, 9),
(256929, NULL, 'PF05073', NULL, NULL, 'Baculovirus P24 capsid protein', NULL, 'Baculo_p24', NULL, NULL, 1381, 9),
(256930, NULL, 'PF20579', NULL, NULL, 'LapA domain', NULL, 'LapA', NULL, NULL, 37640, 9),
(256931, NULL, 'PF14456', NULL, NULL, 'Alpha-helical domain 2', NULL, 'alpha-hel2', NULL, NULL, 15231, 9),
(256932, NULL, 'PF00108', NULL, NULL, 'Thiolase, N-terminal domain', NULL, 'Thiolase_N', NULL, NULL, 19359, 9),
(256933, NULL, 'PF18227', NULL, NULL, 'LepB GAP domain C-terminal subdomain', NULL, 'LepB_GAP_C', NULL, NULL, 27881, 9),
(256934, NULL, 'PF01969', NULL, NULL, 'Nickel insertion protein', NULL, 'Ni_insertion', NULL, NULL, 6495, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(256935, NULL, 'PF09372', NULL, NULL, 'PRANC domain', NULL, 'PRANC', NULL, NULL, 8103, 9),
(256936, NULL, 'PF02940', NULL, NULL, 'mRNA capping enzyme, beta chain', NULL, 'mRNA_triPase', NULL, NULL, 3532, 9),
(256937, NULL, 'PF16076', NULL, NULL, 'Acyltransferase C-terminus', NULL, 'Acyltransf_C', NULL, NULL, 24166, 9),
(256938, NULL, 'PF13419', NULL, NULL, 'Haloacid dehalogenase-like hydrolase', NULL, 'HAD_2', NULL, NULL, 29696, 9),
(256939, NULL, 'PF16940', NULL, NULL, 'Chloroplast envelope transporter', NULL, 'Tic110', NULL, NULL, 25974, 9),
(256940, NULL, 'PF03968', NULL, NULL, 'LptA/(LptD N-terminal domain) LPS transport protein', NULL, 'LptD_N', NULL, NULL, 2743, 9),
(256941, NULL, 'PF06442', NULL, NULL, 'R67 dihydrofolate reductase', NULL, 'DHFR_2', NULL, NULL, 9600, 9),
(256942, NULL, 'PF16027', NULL, NULL, 'Domain of unknown function (DUF4786)', NULL, 'DUF4786', NULL, NULL, 23804, 9),
(256943, NULL, 'PF18385', NULL, NULL, 'T-lymphoma invasion and metastasis CC-Ex domain', NULL, 'Tiam_CC_Ex', NULL, NULL, 28188, 9),
(256944, NULL, 'PF10491', NULL, NULL, 'NLS-binding and DNA-binding and dimerisation domains of Nrf1', NULL, 'Nrf1_DNA-bind', NULL, NULL, 18123, 9),
(256945, NULL, 'PF20303', NULL, NULL, 'YEATS-Like-Associating Three TM', NULL, 'YLATT', NULL, NULL, 33983, 9),
(256946, NULL, 'PF01497', NULL, NULL, 'Periplasmic binding protein', NULL, 'Peripla_BP_2', NULL, NULL, 690, 9),
(256947, NULL, 'PF06470', NULL, NULL, 'SMC proteins Flexible Hinge Domain', NULL, 'SMC_hinge', NULL, NULL, 7628, 9),
(256948, NULL, 'PF08741', NULL, NULL, 'YwhD family', NULL, 'YwhD', NULL, NULL, 11764, 9),
(256949, NULL, 'PF10031', NULL, NULL, 'Small integral membrane protein (DUF2273)', NULL, 'DUF2273', NULL, NULL, 18304, 9),
(256950, NULL, 'PF12556', NULL, NULL, 'Cobaltochelatase CobS subunit N terminal', NULL, 'CobS_N', NULL, NULL, 25549, 9),
(256951, NULL, 'PF05761', NULL, NULL, '5'' nucleotidase family', NULL, '5_nucleotid', NULL, NULL, 7587, 9),
(256952, NULL, 'PF14632', NULL, NULL, 'Acidic N-terminal SPT6', NULL, 'SPT6_acidic', NULL, NULL, 23109, 9),
(256953, NULL, 'PF00797', NULL, NULL, 'N-acetyltransferase', NULL, 'Acetyltransf_2', NULL, NULL, 3105, 9),
(256954, NULL, 'PF02705', NULL, NULL, 'K+ potassium transporter', NULL, 'K_trans', NULL, NULL, 3007, 9),
(256955, NULL, 'PF07131', NULL, NULL, 'Protein of unknown function (DUF1382)', NULL, 'DUF1382', NULL, NULL, 13196, 9),
(256956, NULL, 'PF15739', NULL, NULL, 'Translin-associated factor X-interacting N-terminus', NULL, 'TSNAXIP1_N', NULL, NULL, 22165, 9),
(256957, NULL, 'PF01026', NULL, NULL, 'TatD related DNase', NULL, 'TatD_DNase', NULL, NULL, 1636, 9),
(256958, NULL, 'PF13588', NULL, NULL, 'Type I restriction enzyme R protein N terminus (HSDR_N)', NULL, 'HSDR_N_2', NULL, NULL, 26884, 9),
(256959, NULL, 'PF16719', NULL, NULL, 'SAWADEE domain', NULL, 'SAWADEE', NULL, NULL, 23478, 9),
(256960, NULL, 'PF08539', NULL, NULL, 'HbrB-like', NULL, 'HbrB', NULL, NULL, 7564, 9),
(256961, NULL, 'PF15956', NULL, NULL, 'Domain of unknown function (DUF4760)', NULL, 'DUF4760', NULL, NULL, 26383, 9),
(256962, NULL, 'PF07304', NULL, NULL, 'Steroid receptor RNA activator (SRA1)', NULL, 'SRA1', NULL, NULL, 14181, 9),
(256963, NULL, 'PF08359', NULL, NULL, 'YsiA-like protein, C-terminal region', NULL, 'TetR_C_4', NULL, NULL, 12558, 9),
(256964, NULL, 'PF10287', NULL, NULL, 'Cell wall protein YJL171C/Tos1, C-terminal', NULL, 'YJL171C_Tos1_C', NULL, NULL, 19306, 9),
(256965, NULL, 'PF05643', NULL, NULL, 'Putative bacterial lipoprotein (DUF799)', NULL, 'DUF799', NULL, NULL, 12650, 9),
(256966, NULL, 'PF05916', NULL, NULL, 'GINS complex protein', NULL, 'Sld5', NULL, NULL, 15409, 9),
(256967, NULL, 'PF19804', NULL, NULL, 'Domain of unknown function (DUF6287)', NULL, 'DUF6287', NULL, NULL, 37474, 9),
(256968, NULL, 'PF03922', NULL, NULL, 'OmpW family', NULL, 'OmpW', NULL, NULL, 2828, 9),
(256969, NULL, 'PF15271', NULL, NULL, 'Spindle pole body component BBP1, Mps2-binding protein', NULL, 'BBP1_N', NULL, NULL, 23539, 9),
(256970, NULL, 'PF10963', NULL, NULL, 'Phage tail assembly chaperone', NULL, 'Phage_TAC_10', NULL, NULL, 22134, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(256971, NULL, 'PF17732', NULL, NULL, 'Family of unknown function (DUF5571)', NULL, 'DUF5571', NULL, NULL, 29097, 9),
(256972, NULL, 'PF06165', NULL, NULL, 'Glycosyltransferase family 36', NULL, 'Glyco_transf_36', NULL, NULL, 9088, 9),
(256973, NULL, 'PF04890', NULL, NULL, 'Family of unknown function (DUF648)', NULL, 'DUF648', NULL, NULL, 5634, 9),
(256974, NULL, 'PF13841', NULL, NULL, 'Beta defensin', NULL, 'Defensin_beta_2', NULL, NULL, 24545, 9),
(256975, NULL, 'PF11348', NULL, NULL, 'Protein of unknown function (DUF3150)', NULL, 'DUF3150', NULL, NULL, 18729, 9),
(256976, NULL, 'PF19126', NULL, NULL, 'Family of unknown function (DUF5810)', NULL, 'DUF5810', NULL, NULL, 35538, 9),
(256977, NULL, 'PF11216', NULL, NULL, 'Protein of unknown function (DUF3012)', NULL, 'DUF3012', NULL, NULL, 18371, 9),
(256978, NULL, 'PF20154', NULL, NULL, 'Apolipoprotein N-acyltransferase N-terminal domain', NULL, 'LNT_N', NULL, NULL, 33886, 9),
(256979, NULL, 'PF11949', NULL, NULL, 'Protein of unknown function (DUF3466)', NULL, 'DUF3466', NULL, NULL, 16369, 9),
(256980, NULL, 'PF05405', NULL, NULL, 'Mitochondrial ATP synthase B chain precursor (ATP-synt_B)', NULL, 'Mt_ATP-synt_B', NULL, NULL, 13441, 9),
(256981, NULL, 'PF05873', NULL, NULL, 'ATP synthase D chain, mitochondrial (ATP5H)', NULL, 'Mt_ATP-synt_D', NULL, NULL, 13045, 9),
(256982, NULL, 'PF14932', NULL, NULL, 'HAUS augmin-like complex subunit 3', NULL, 'HAUS-augmin3', NULL, NULL, 26031, 9),
(256983, NULL, 'PF19401', NULL, NULL, 'Family of unknown function (DUF5976)', NULL, 'DUF5976', NULL, NULL, 36911, 9),
(256984, NULL, 'PF11137', NULL, NULL, 'Protein of unknown function (DUF2909)', NULL, 'DUF2909', NULL, NULL, 17669, 9),
(256985, NULL, 'PF19990', NULL, NULL, 'Family of unknown function (DUF6426)', NULL, 'DUF6426', NULL, NULL, 37723, 9),
(256986, NULL, 'PF02267', NULL, NULL, 'ADP-ribosyl cyclase', NULL, 'Rib_hydrolayse', NULL, NULL, 1761, 9),
(256987, NULL, 'PF15040', NULL, NULL, 'Humanin family', NULL, 'Humanin', NULL, NULL, 23441, 9),
(256988, NULL, 'PF09839', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2066)', NULL, 'DUF2066', NULL, NULL, 16696, 9),
(256989, NULL, 'PF18274', NULL, NULL, 'Vacuolar ATPase Subunit I N-terminal proximal lobe', NULL, 'V_ATPase_prox', NULL, NULL, 29445, 9),
(256990, NULL, 'PF10872', NULL, NULL, 'Protein of unknown function (DUF2740)', NULL, 'DUF2740', NULL, NULL, 15496, 9),
(256991, NULL, 'PF20035', NULL, NULL, 'Family of unknown function (DUF6439)', NULL, 'DUF6439', NULL, NULL, 37445, 9),
(256992, NULL, 'PF17754', NULL, NULL, 'MftR C-terminal domain', NULL, 'TetR_C_14', NULL, NULL, 29354, 9),
(256993, NULL, 'PF19758', NULL, NULL, 'Family of unknown function (DUF6245)', NULL, 'DUF6245', NULL, NULL, 37451, 9),
(256994, NULL, 'PF20497', NULL, NULL, 'SWI/SNF and RSC complexes subunit Ssr4 C-terminal', NULL, 'SWI-SNF_Ssr4_C', NULL, NULL, 33582, 9),
(256995, NULL, 'PF20127', NULL, NULL, 'Family of unknown function (DUF6517)', NULL, 'DUF6517', NULL, NULL, 35653, 9),
(256996, NULL, 'PF19936', NULL, NULL, 'Family of unknown function (DUF6399)', NULL, 'DUF6399', NULL, NULL, 36477, 9),
(256997, NULL, 'PF09986', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2225)', NULL, 'DUF2225', NULL, NULL, 17216, 9),
(256998, NULL, 'PF07817', NULL, NULL, 'GLE1-like protein', NULL, 'GLE1', NULL, NULL, 14366, 9),
(256999, NULL, 'PF04195', NULL, NULL, 'Putative gypsy type transposon', NULL, 'Transposase_28', NULL, NULL, NULL, 9),
(257000, NULL, 'PF05426', NULL, NULL, 'Alginate lyase', NULL, 'Alginate_lyase', NULL, NULL, 7665, 9),
(257001, NULL, 'PF14687', NULL, NULL, 'Domain of unknown function (DUF4460)', NULL, 'DUF4460', NULL, NULL, 23889, 9),
(257002, NULL, 'PF07820', NULL, NULL, 'TraC-like protein', NULL, 'TraC', NULL, NULL, 8086, 9),
(257003, NULL, 'PF19389', NULL, NULL, 'Family of unknown function (DUF5964)', NULL, 'DUF5964', NULL, NULL, 36807, 9),
(257004, NULL, 'PF04914', NULL, NULL, 'DltD protein', NULL, 'DltD', NULL, NULL, 6475, 9),
(257005, NULL, 'PF06265', NULL, NULL, 'Putative antitoxin YutD-like', NULL, 'YutD-like', NULL, NULL, 14476, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(257006, NULL, 'PF13928', NULL, NULL, 'Flocculin type 3 repeat', NULL, 'Flocculin_t3', NULL, NULL, 23415, 9),
(257007, NULL, 'PF09449', NULL, NULL, 'Domain of unknown function (DUF2020)', NULL, 'DUF2020', NULL, NULL, 15348, 9),
(257008, NULL, 'PF17608', NULL, NULL, 'Family of unknown function (DUF5504)', NULL, 'DUF5504', NULL, NULL, 19564, 9),
(257009, NULL, 'PF14223', NULL, NULL, 'gag-polypeptide of LTR copia-type', NULL, 'Retrotran_gag_2', NULL, NULL, NULL, 9),
(257010, NULL, 'PF10780', NULL, NULL, '39S ribosomal protein L53/MRP-L53', NULL, 'MRP_L53', NULL, NULL, 20778, 9),
(257011, NULL, 'PF18708', NULL, NULL, 'MapZ extracellular C-terminal domain 2', NULL, 'MapZ_C2', NULL, NULL, 31514, 9),
(257012, NULL, 'PF18958', NULL, NULL, 'Putative zinc dependent peptidase (DUF5700)', NULL, 'DUF5700', NULL, NULL, 35859, 9),
(257013, NULL, 'PF17902', NULL, NULL, 'SH3 domain', NULL, 'SH3_10', NULL, NULL, 30718, 9),
(257014, NULL, 'PF05772', NULL, NULL, 'NinB protein', NULL, 'NinB', NULL, NULL, 13117, 9),
(257015, NULL, 'PF08926', NULL, NULL, 'Domain of unknown function (DUF1908)', NULL, 'DUF1908', NULL, NULL, 7697, 9),
(257016, NULL, 'PF05956', NULL, NULL, 'APC basic domain', NULL, 'APC_basic', NULL, NULL, 12555, 9),
(257017, NULL, 'PF10450', NULL, NULL, 'POC1 chaperone', NULL, 'POC1', NULL, NULL, 20965, 9),
(257018, NULL, 'PF11326', NULL, NULL, 'Protein of unknown function (DUF3128)', NULL, 'DUF3128', NULL, NULL, 18409, 9),
(257019, NULL, 'PF12444', NULL, NULL, 'Sox developmental protein N terminal', NULL, 'Sox_N', NULL, NULL, 20764, 9),
(257020, NULL, 'PF02755', NULL, NULL, 'RPEL repeat', NULL, 'RPEL', NULL, NULL, 763, 9),
(257021, NULL, 'PF08955', NULL, NULL, 'BofC C-terminal domain', NULL, 'BofC_C', NULL, NULL, 7514, 9),
(257022, NULL, 'PF10951', NULL, NULL, 'Protein of unknown function (DUF2776)', NULL, 'DUF2776', NULL, NULL, 17989, 9),
(257023, NULL, 'PF14596', NULL, NULL, 'STAT6 C-terminal', NULL, 'STAT6_C', NULL, NULL, 21958, 9),
(257024, NULL, 'PF06753', NULL, NULL, 'Bradykinin', NULL, 'Bradykinin', NULL, NULL, 1504, 9),
(257025, NULL, 'PF08776', NULL, NULL, 'VASP tetramerisation domain', NULL, 'VASP_tetra', NULL, NULL, 13373, 9),
(257026, NULL, 'PF15645', NULL, NULL, 'Dermonecrotoxin of the Papain-like fold', NULL, 'Tox-PLDMTX', NULL, NULL, 24985, 9),
(257027, NULL, 'PF10015', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2258)', NULL, 'DUF2258', NULL, NULL, 20706, 9),
(257028, NULL, 'PF00779', NULL, NULL, 'BTK motif', NULL, 'BTK', NULL, NULL, 5094, 9),
(257029, NULL, 'PF15010', NULL, NULL, 'Putative cell signalling', NULL, 'FAM131', NULL, NULL, 25621, 9),
(257030, NULL, 'PF01926', NULL, NULL, '50S ribosome-binding GTPase', NULL, 'MMR_HSR1', NULL, NULL, 2562, 9),
(257031, NULL, 'PF06713', NULL, NULL, 'Bacterial PH domain', NULL, 'bPH_4', NULL, NULL, 1710, 9),
(257032, NULL, 'PF06954', NULL, NULL, 'Resistin', NULL, 'Resistin', NULL, NULL, 12402, 9),
(257033, NULL, 'PF16716', NULL, NULL, 'Bone marrow stromal antigen 2', NULL, 'BST2', NULL, NULL, 26828, 9),
(257034, NULL, 'PF06195', NULL, NULL, 'Protein of unknown function (DUF996)', NULL, 'DUF996', NULL, NULL, 9286, 9),
(257035, NULL, 'PF01982', NULL, NULL, 'Domain of unknown function DUF120', NULL, 'CTP-dep_RFKase', NULL, NULL, 16588, 9),
(257036, NULL, 'PF01566', NULL, NULL, 'Natural resistance-associated macrophage protein', NULL, 'Nramp', NULL, NULL, 2110, 9),
(257037, NULL, 'PF01175', NULL, NULL, 'Urocanase Rossmann-like domain', NULL, 'Urocanase', NULL, NULL, 28936, 9),
(257038, NULL, 'PF01289', NULL, NULL, 'Thiol-activated cytolysin', NULL, 'Thiol_cytolysin', NULL, NULL, 4318, 9),
(257039, NULL, 'PF17027', NULL, NULL, 'Histone-fold protein', NULL, 'Bromo_TP_like', NULL, NULL, 22870, 9),
(257040, NULL, 'PF12103', NULL, NULL, 'Surface lipoprotein of Spirochaetales order', NULL, 'Lipl32', NULL, NULL, 20395, 9),
(257041, NULL, 'PF11079', NULL, NULL, 'Bacterial protein YqhG of unknown function', NULL, 'YqhG', NULL, NULL, 26869, 9),
(257042, NULL, 'PF00835', NULL, NULL, 'SNAP-25 family', NULL, 'SNAP-25', NULL, NULL, 3266, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(257043, NULL, 'PF18425', NULL, NULL, 'Csp protease B prodomain', NULL, 'CspB_prodomain', NULL, NULL, 29357, 9),
(257044, NULL, 'PF04610', NULL, NULL, 'TrbL/VirB6 plasmid conjugal transfer protein', NULL, 'TrbL', NULL, NULL, 1332, 9),
(257045, NULL, 'PF16060', NULL, NULL, 'Domain of unknown function (DUF4802)', NULL, 'DUF4802', NULL, NULL, 23527, 9),
(257046, NULL, 'PF03785', NULL, NULL, 'Peptidase family C25, C terminal ig-like domain', NULL, 'Peptidase_C25_C', NULL, NULL, 1644, 9),
(257047, NULL, 'PF04423', NULL, NULL, 'Rad50 zinc hook motif', NULL, 'Rad50_zn_hook', NULL, NULL, 7970, 9),
(257048, NULL, 'PF13825', NULL, NULL, 'Paramyxovirus structural protein V/P N-terminus', NULL, 'Paramyxo_P_V_N', NULL, NULL, 21905, 9),
(257049, NULL, 'PF06830', NULL, NULL, 'Root cap', NULL, 'Root_cap', NULL, NULL, 11478, 9),
(257050, NULL, 'PF07474', NULL, NULL, 'G2F domain', NULL, 'G2F', NULL, NULL, 1394, 9),
(257051, NULL, 'PF16583', NULL, NULL, 'Zinc-regulated secreted antivirulence protein C-terminal domain', NULL, 'ZirS_C', NULL, NULL, 24479, 9),
(257052, NULL, 'PF19554', NULL, NULL, 'Family of unknown function (DUF6077)', NULL, 'DUF6077', NULL, NULL, 34117, 9),
(257053, NULL, 'PF19978', NULL, NULL, 'Tail virion protein G7P', NULL, 'Inovirus_G7P_2', NULL, NULL, 35839, 9),
(257054, NULL, 'PF07129', NULL, NULL, 'Protein of unknown function (DUF1381)', NULL, 'DUF1381', NULL, NULL, 13122, 9),
(257055, NULL, 'PF18322', NULL, NULL, 'Serine protease Clip domain PPAF-2', NULL, 'CLIP_1', NULL, NULL, 29762, 9),
(257056, NULL, 'PF19734', NULL, NULL, 'Family of unknown function (DUF6224)', NULL, 'DUF6224', NULL, NULL, 34114, 9),
(257057, NULL, 'PF07509', NULL, NULL, 'Protein of unknown function (DUF1523)', NULL, 'DUF1523', NULL, NULL, 11356, 9),
(257058, NULL, 'PF10621', NULL, NULL, 'F420H2 dehydrogenase subunit FpoO', NULL, 'FpoO', NULL, NULL, 8110, 9),
(257059, NULL, 'PF14859', NULL, NULL, 'Colicin M', NULL, 'Colicin_M', NULL, NULL, 25201, 9),
(257060, NULL, 'PF01081', NULL, NULL, 'KDPG and KHG aldolase', NULL, 'Aldolase', NULL, NULL, 4580, 9),
(257061, NULL, 'PF14902', NULL, NULL, 'Domain of unknown function (DUF4494)', NULL, 'DUF4494', NULL, NULL, 25755, 9),
(257062, NULL, 'PF18619', NULL, NULL, 'GPCR-Autoproteolysis-INducing (GAIN) subdomain A', NULL, 'GAIN_A', NULL, NULL, 29415, 9),
(257063, NULL, 'PF20552', NULL, NULL, 'Recombinase-like helix-turn-helix domain', NULL, 'HTH_62', NULL, NULL, 37536, 9),
(257064, NULL, 'PF19337', NULL, NULL, 'BMP and activin membrane-bound inhibitor homolog C-terminus', NULL, 'BAMBI_C', NULL, NULL, 34240, 9),
(257065, NULL, 'PF06066', NULL, NULL, 'SepZ', NULL, 'SepZ', NULL, NULL, 13589, 9),
(257066, NULL, 'PF11472', NULL, NULL, 'Protein of unknown function (DUF3206)', NULL, 'DUF3206', NULL, NULL, 18803, 9),
(257067, NULL, 'PF17275', NULL, NULL, 'Family of unknown function (DUF5340)', NULL, 'DUF5340', NULL, NULL, 15369, 9),
(257068, NULL, 'PF19864', NULL, NULL, 'Radical SAM proteins, N-terminal', NULL, 'Radical_SAM_N2', NULL, NULL, 36445, 9),
(257069, NULL, 'PF10660', NULL, NULL, 'Iron-containing outer mitochondrial membrane protein N-terminus', NULL, 'MitoNEET_N', NULL, NULL, 20231, 9),
(257070, NULL, 'PF17221', NULL, NULL, 'COMMD1 N-terminal domain', NULL, 'COMMD1_N', NULL, NULL, 30307, 9),
(257071, NULL, 'PF00778', NULL, NULL, 'DIX domain', NULL, 'DIX', NULL, NULL, 1275, 9),
(257072, NULL, 'PF03628', NULL, NULL, 'PapG chaperone-binding domain', NULL, 'PapG_C', NULL, NULL, 5402, 9),
(257073, NULL, 'PF14465', NULL, NULL, 'NFRKB Winged Helix-like', NULL, 'NFRKB_winged', NULL, NULL, 25599, 9),
(257074, NULL, 'PF04064', NULL, NULL, 'Domain of unknown function (DUF384)', NULL, 'DUF384', NULL, NULL, 1469, 9),
(257075, NULL, 'PF06599', NULL, NULL, 'Protein of unknown function (DUF1139)', NULL, 'DUF1139', NULL, NULL, 9515, 9),
(257076, NULL, 'PF06583', NULL, NULL, 'Neogenin C-terminus', NULL, 'Neogenin_C', NULL, NULL, 8023, 9),
(257077, NULL, 'PF20184', NULL, NULL, 'Family of unknown function (DUF6547)', NULL, 'DUF6547', NULL, NULL, 37464, 9),
(257078, NULL, 'PF15568', NULL, NULL, 'Immunity protein 39', NULL, 'Imm39', NULL, NULL, 25089, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(257079, NULL, 'PF18467', NULL, NULL, 'Domain of unknown function (DUF5613)', NULL, 'DUF5613', NULL, NULL, 27443, 9),
(257080, NULL, 'PF19843', NULL, NULL, 'Family of unknown function (DUF6318)', NULL, 'DUF6318', NULL, NULL, 37766, 9),
(257081, NULL, 'PF13067', NULL, NULL, 'Protein of unknown function (DUF3930)', NULL, 'DUF3930', NULL, NULL, 21075, 9),
(257082, NULL, 'PF18613', NULL, NULL, 'Tyrosine kinase receptor A trans-membrane domain', NULL, 'TrkA_TMD', NULL, NULL, 27681, 9),
(257083, NULL, 'PF01160', NULL, NULL, 'Vertebrate endogenous opioids neuropeptide', NULL, 'Opiods_neuropep', NULL, NULL, 1075, 9),
(257084, NULL, 'PF03186', NULL, NULL, 'CobD/Cbib protein', NULL, 'CobD_Cbib', NULL, NULL, 1037, 9),
(257085, NULL, 'PF06483', NULL, NULL, 'Chitinase C', NULL, 'ChiC', NULL, NULL, 9327, 9),
(257086, NULL, 'PF20403', NULL, NULL, 'Family of unknown function (DUF6693)', NULL, 'DUF6693', NULL, NULL, 37646, 9),
(257087, NULL, 'PF13512', NULL, NULL, 'Tetratricopeptide repeat', NULL, 'TPR_18', NULL, NULL, NULL, 9),
(257088, NULL, 'PF01340', NULL, NULL, 'Met Apo-repressor, MetJ', NULL, 'MetJ', NULL, NULL, 1487, 9),
(257089, NULL, 'PF20553', NULL, NULL, 'Putative O-methyltransferase', NULL, 'Methyltransf_35', NULL, NULL, 37559, 9),
(257090, NULL, 'PF01721', NULL, NULL, 'Class II bacteriocin', NULL, 'Bacteriocin_II', NULL, NULL, 2978, 9),
(257091, NULL, 'PF16889', NULL, NULL, 'Heparinase II/III N-terminus', NULL, 'Hepar_II_III_N', NULL, NULL, 22674, 9),
(257092, NULL, 'PF12382', NULL, NULL, 'Retrotransposon peptidase', NULL, 'Peptidase_A2_2', NULL, NULL, 8792, 9),
(257093, NULL, 'PF08915', NULL, NULL, 'Archaea-specific editing domain of threonyl-tRNA synthetase', NULL, 'tRNA-Thr_ED', NULL, NULL, 7612, 9),
(257094, NULL, 'PF18545', NULL, NULL, 'Halobacterial output domain 1', NULL, 'HalOD1', NULL, NULL, 27981, 9),
(257095, NULL, 'PF08681', NULL, NULL, 'Protein of unknown function (DUF1778)', NULL, 'DUF1778', NULL, NULL, 11427, 9),
(257096, NULL, 'PF20337', NULL, NULL, 'Family of unknown function (DUF6632)', NULL, 'DUF6632', NULL, NULL, 33658, 9),
(257097, NULL, 'PF19303', NULL, NULL, 'Anticodon binding domain of methionyl tRNA ligase', NULL, 'Anticodon_3', NULL, NULL, 30693, 9),
(257098, NULL, 'PF02923', NULL, NULL, 'Restriction endonuclease BamHI', NULL, 'BamHI', NULL, NULL, 2744, 9),
(257099, NULL, 'PF04727', NULL, NULL, 'ELMO/CED-12 family', NULL, 'ELMO_CED12', NULL, NULL, 3870, 9),
(257100, NULL, 'PF19507', NULL, NULL, 'Family of unknown function (DUF6041)', NULL, 'DUF6041', NULL, NULL, 36793, 9),
(257101, NULL, 'PF13318', NULL, NULL, '1-carboxybiuret hydrolase subunit AtzG-like', NULL, 'AtzG-like', NULL, NULL, 22574, 9),
(257102, NULL, 'PF12215', NULL, NULL, 'beta-glucosidase 2, glycosyl-hydrolase family 116 N-term', NULL, 'Glyco_hydr_116N', NULL, NULL, 26820, 9),
(257103, NULL, 'PF14669', NULL, NULL, 'Putative aspartate racemase', NULL, 'Asp_Glu_race_2', NULL, NULL, 26660, 9),
(257104, NULL, 'PF09995', NULL, NULL, 'ER-bound oxygenase mpaB/B''/Rubber oxygenase, catalytic domain', NULL, 'MPAB_Lcp_cat', NULL, NULL, 17324, 9),
(257105, NULL, 'PF11338', NULL, NULL, 'Protein of unknown function (DUF3140)', NULL, 'DUF3140', NULL, NULL, 18853, 9),
(257106, NULL, 'PF01247', NULL, NULL, 'Ribosomal protein L35Ae', NULL, 'Ribosomal_L35Ae', NULL, NULL, 3005, 9),
(257107, NULL, 'PF09814', NULL, NULL, 'HECT-like Ubiquitin-conjugating enzyme (E2)-binding', NULL, 'HECT_2', NULL, NULL, 18165, 9),
(257108, NULL, 'PF00362', NULL, NULL, 'Integrin beta chain VWA domain', NULL, 'Integrin_beta', NULL, NULL, 6445, 9),
(257109, NULL, 'PF16118', NULL, NULL, 'Domain of unknown function (DUF4834)', NULL, 'DUF4834', NULL, NULL, 26189, 9),
(257110, NULL, 'PF12581', NULL, NULL, 'Protein of unknown function (DUF3756)', NULL, 'DUF3756', NULL, NULL, 21446, 9),
(257111, NULL, 'PF17939', NULL, NULL, 'Tetracyclin repressor-like, C-terminal domain', NULL, 'TetR_C_30', NULL, NULL, 30300, 9),
(257112, NULL, 'PF01728', NULL, NULL, 'FtsJ-like methyltransferase', NULL, 'FtsJ', NULL, NULL, 5776, 9),
(257113, NULL, 'PF19168', NULL, NULL, 'Family of unknown function (DUF5850)', NULL, 'DUF5850', NULL, NULL, 34995, 9);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(257114, NULL, 'PF19435', NULL, NULL, 'Integrator complex subunit 14, beta-barrel domain', NULL, 'IntS14_b-barrel', NULL, NULL, 34155, 9),
(257115, NULL, 'PF13151', NULL, NULL, 'Protein of unknown function (DUF3990)', NULL, 'DUF3990', NULL, NULL, 22903, 9),
(257116, NULL, 'PF15015', NULL, NULL, 'Spermatogenesis-associated, N-terminal', NULL, 'NYD-SP12_N', NULL, NULL, 26962, 9),
(257117, NULL, 'PF02189', NULL, NULL, 'Immunoreceptor tyrosine-based activation motif', NULL, 'ITAM', NULL, NULL, 1495, 9),
(257118, NULL, 'PF11792', NULL, NULL, 'Baculoviridae late expression factor 5 C-terminal domain', NULL, 'Baculo_LEF5_C', NULL, NULL, 19436, 9),
(257119, NULL, 'PF08528', NULL, NULL, 'Whi5 like', NULL, 'Whi5', NULL, NULL, 7874, 9),
(257120, NULL, 'PF11360', NULL, NULL, 'Protein of unknown function (DUF3110)', NULL, 'DUF3110', NULL, NULL, 18571, 9),
(257121, NULL, 'PF14383', NULL, NULL, 'DUF761-associated sequence motif', NULL, 'VARLMGL', NULL, NULL, 21799, 9),
(257122, NULL, 'PF00959', NULL, NULL, 'Phage lysozyme', NULL, 'Phage_lysozyme', NULL, NULL, 5883, 9),
(257123, NULL, 'PF04179', NULL, NULL, 'Rit1 DUSP-like domain', NULL, 'Init_tRNA_PT', NULL, NULL, 32484, 9),
(257124, NULL, 'PF07306', NULL, NULL, 'Protein of unknown function (DUF1455)', NULL, 'DUF1455', NULL, NULL, 7830, 9),
(257125, NULL, 'PF19256', NULL, NULL, 'LAIKA domain', NULL, 'LAIKA', NULL, NULL, 35756, 9),
(257126, NULL, 'PF15117', NULL, NULL, 'Uncharacterised protein family UPF0697', NULL, 'UPF0697', NULL, NULL, 26417, 9),
(257127, NULL, 'PF17853', NULL, NULL, 'GGDEF-like domain', NULL, 'GGDEF_2', NULL, NULL, 29831, 9),
(257128, NULL, 'PF15585', NULL, NULL, 'Immunity protein 7', NULL, 'Imm7', NULL, NULL, 24663, 9),
(257129, NULL, 'PF07998', NULL, NULL, 'Peptidase family M54', NULL, 'Peptidase_M54', NULL, NULL, 11824, 9),
(257130, NULL, 'PF11309', NULL, NULL, 'Protein of unknown function (DUF3112)', NULL, 'DUF3112', NULL, NULL, 18475, 9),
(257131, NULL, 'PF05819', NULL, NULL, 'NolX protein', NULL, 'NolX', NULL, NULL, 13025, 9),
(257132, NULL, 'PF10500', NULL, NULL, 'Nuclear RNA-splicing-associated protein', NULL, 'SR-25', NULL, NULL, 19081, 9),
(257133, NULL, 'PF16558', NULL, NULL, 'Amino-terminal Zinc-binding domain of ubiquitin ligase E3A', NULL, 'AZUL', NULL, NULL, 26475, 9),
(257134, NULL, 'PF07742', NULL, NULL, 'BTG family', NULL, 'BTG', NULL, NULL, 1263, 9),
(257135, NULL, 'PF10830', NULL, NULL, 'Protein of unknown function (DUF2553)', NULL, 'DUF2553', NULL, NULL, 18704, 9),
(257136, NULL, 'PF15399', NULL, NULL, 'Domain of unknown function (DUF4620)', NULL, 'DUF4620', NULL, NULL, 25548, 9),
(257137, NULL, 'PF06129', NULL, NULL, 'Chordopoxvirus G3 protein', NULL, 'Chordopox_G3', NULL, NULL, 8791, 9),
(257138, NULL, 'PF08397', NULL, NULL, 'IRSp53/MIM homology domain', NULL, 'IMD', NULL, NULL, 11010, 9),
(257139, NULL, 'PF04966', NULL, NULL, 'Carbohydrate-selective porin, OprB family', NULL, 'OprB', NULL, NULL, 6554, 9),
(257140, NULL, 'PF06747', NULL, NULL, 'CHCH domain', NULL, 'CHCH', NULL, NULL, 9077, 9),
(257141, NULL, 'PF19568', NULL, NULL, 'Sporulation stage III, protein AA', NULL, 'Spore_III_AA', NULL, NULL, 34269, 9),
(257142, NULL, 'PF17177', NULL, NULL, 'Pentacotripeptide-repeat region of PRORP', NULL, 'PPR_long', NULL, NULL, 29392, 9),
(257143, NULL, 'PF07638', NULL, NULL, 'ECF sigma factor', NULL, 'Sigma70_ECF', NULL, NULL, 12636, 9),
(257144, NULL, 'PF12366', NULL, NULL, 'Cancer susceptibility candidate 1 C-terminal', NULL, 'Casc1_C', NULL, NULL, 20869, 9),
(257145, NULL, 'PF14734', NULL, NULL, 'Domain of unknown function (DUF4469) with IG-like fold', NULL, 'DUF4469', NULL, NULL, 21627, 9),
(257146, NULL, 'PF16149', NULL, NULL, 'Domain of unknown function (DUF4857)', NULL, 'DUF4857', NULL, NULL, 22552, 9),
(257147, NULL, 'PF04103', NULL, NULL, 'CD20-like family', NULL, 'CD20', NULL, NULL, 6649, 9),
(257148, NULL, 'PF14542', NULL, NULL, 'GCN5-related N-acetyl-transferase', NULL, 'Acetyltransf_CG', NULL, NULL, 23854, 9),
(257149, NULL, 'PF03683', NULL, NULL, 'Uncharacterised protein family (UPF0175)', NULL, 'UPF0175', NULL, NULL, 6125, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(257150, NULL, 'PF10455', NULL, NULL, 'Bin/amphiphysin/Rvs domain for vesicular trafficking', NULL, 'BAR_2', NULL, NULL, 20834, 9),
(257151, NULL, 'PF10954', NULL, NULL, 'Protein of unknown function (DUF2755)', NULL, 'DUF2755', NULL, NULL, 19234, 9),
(257152, NULL, 'PF18356', NULL, NULL, 'Domain of unknown function (DUF5608)', NULL, 'DUF5608', NULL, NULL, 29665, 9),
(257153, NULL, 'PF16170', NULL, NULL, 'Domain of unknown function (DUF4873)', NULL, 'DUF4873', NULL, NULL, 24236, 9),
(257154, NULL, 'PF20105', NULL, NULL, 'Family of unknown function (DUF6495)', NULL, 'DUF6495', NULL, NULL, 35817, 9),
(257155, NULL, 'PF13216', NULL, NULL, 'Protein of unknown function (DUF4024)', NULL, 'DUF4024', NULL, NULL, 22616, 9),
(257156, NULL, 'PF02289', NULL, NULL, 'Cyclohydrolase (MCH)', NULL, 'MCH', NULL, NULL, 2202, 9),
(257157, NULL, 'PF02478', NULL, NULL, 'Pneumovirus phosphoprotein', NULL, 'Pneumo_phosprot', NULL, NULL, 6269, 9),
(257158, NULL, 'PF19610', NULL, NULL, 'Family of unknown function (DUF6115)', NULL, 'DUF6115', NULL, NULL, 37184, 9),
(257159, NULL, 'PF05913', NULL, NULL, '6-phospho-N-acetylmuramidase, C-terminal', NULL, 'MupG_C', NULL, NULL, 34064, 9),
(257160, NULL, 'PF10080', NULL, NULL, 'Membrane iron-sulfur containing protein FtrD-like', NULL, 'FtrD-like', NULL, NULL, 18296, 9),
(257161, NULL, 'PF17472', NULL, NULL, 'Family of unknown function (DUF5425)', NULL, 'DUF5425', NULL, NULL, 18937, 9),
(257162, NULL, 'PF01382', NULL, NULL, 'Avidin family', NULL, 'Avidin', NULL, NULL, 552, 9),
(257163, NULL, 'PF11192', NULL, NULL, 'Protein of unknown function (DUF2977)', NULL, 'DUF2977', NULL, NULL, 18194, 9),
(257164, NULL, 'PF03059', NULL, NULL, 'Nicotianamine synthase protein', NULL, 'NAS', NULL, NULL, 4714, 9),
(257165, NULL, 'PF01480', NULL, NULL, 'PWI domain', NULL, 'PWI', NULL, NULL, 868, 9),
(257166, NULL, 'PF16131', NULL, NULL, 'Torus domain', NULL, 'Torus', NULL, NULL, 23082, 9),
(257167, NULL, 'PF10190', NULL, NULL, 'Putative transmembrane protein 170', NULL, 'Tmemb_170', NULL, NULL, 14571, 9),
(257168, NULL, 'PF03594', NULL, NULL, 'Benzoate membrane transport protein', NULL, 'BenE', NULL, NULL, 3429, 9),
(257169, NULL, 'PF16790', NULL, NULL, 'Bacteriophage clamp loader A subunit', NULL, 'Phage_clamp_A', NULL, NULL, 26767, 9),
(257170, NULL, 'PF10720', NULL, NULL, 'Protein of unknown function (DUF2515)', NULL, 'DUF2515', NULL, NULL, 20723, 9),
(257171, NULL, 'PF16843', NULL, NULL, 'Binding domain to Get4 on Get5, Golgi to ER traffic protein', NULL, 'Get5_bdg', NULL, NULL, 24258, 9),
(257172, NULL, 'PF19981', NULL, NULL, 'Family of unknown function (DUF6417)', NULL, 'DUF6417', NULL, NULL, NULL, 9),
(257173, NULL, 'PF01368', NULL, NULL, 'DHH family', NULL, 'DHH', NULL, NULL, 5241, 9),
(257174, NULL, 'PF08252', NULL, NULL, 'arg-2/CPA1 leader peptide', NULL, 'Leader_CPA1', NULL, NULL, 17208, 9),
(257175, NULL, 'PF16819', NULL, NULL, 'Domain of unknown function (DUF5074)', NULL, 'DUF5074', NULL, NULL, 22191, 9),
(257176, NULL, 'PF13728', NULL, NULL, 'F plasmid transfer operon protein', NULL, 'TraF', NULL, NULL, 32638, 9),
(257177, NULL, 'PF01282', NULL, NULL, 'Ribosomal protein S24e', NULL, 'Ribosomal_S24e', NULL, NULL, 2417, 9),
(257178, NULL, 'PF04381', NULL, NULL, 'Putative exonuclease, RdgC', NULL, 'RdgC', NULL, NULL, 2379, 9),
(257179, NULL, 'PF11938', NULL, NULL, 'TLR4 regulator and MIR-interacting MSAP', NULL, 'DUF3456', NULL, NULL, 19898, 9),
(257180, NULL, 'PF06344', NULL, NULL, 'Parechovirus Genome-linked protein', NULL, 'Parecho_VpG', NULL, NULL, 8339, 9),
(257181, NULL, 'PF08573', NULL, NULL, 'DNA endonuclease activator SAE2/CtIP C-terminus', NULL, 'SAE2', NULL, NULL, 17912, 9),
(257182, NULL, 'PF00049', NULL, NULL, 'Insulin/IGF/Relaxin family', NULL, 'Insulin', NULL, NULL, 11550, 9),
(257183, NULL, 'PF09913', NULL, NULL, 'Predicted membrane protein (DUF2142)', NULL, 'DUF2142', NULL, NULL, 17270, 9),
(257184, NULL, 'PF04670', NULL, NULL, 'Gtr1/RagA G protein conserved region', NULL, 'Gtr1_RagA', NULL, NULL, 3436, 9),
(257185, NULL, 'PF08221', NULL, NULL, 'RNA polymerase III subunit RPC82 helix-turn-helix domain', NULL, 'HTH_9', NULL, NULL, 17326, 9);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(257186, NULL, 'PF00253', NULL, NULL, 'Ribosomal protein S14p/S29e', NULL, 'Ribosomal_S14', NULL, NULL, 1478, 9),
(257187, NULL, 'PF12505', NULL, NULL, 'Protein of unknown function (DUF3712)', NULL, 'DUF3712', NULL, NULL, 21214, 9),
(257188, NULL, 'PF01226', NULL, NULL, 'Formate/nitrite transporter', NULL, 'Form_Nir_trans', NULL, NULL, 525, 9),
(257189, NULL, 'PF02320', NULL, NULL, 'Ubiquinol-cytochrome C reductase hinge protein', NULL, 'UCR_hinge', NULL, NULL, 15531, 9),
(257190, NULL, 'PF10221', NULL, NULL, 'Cell cycle and development regulator Mat89Bb', NULL, 'Mat89Bb', NULL, NULL, 15750, 9),
(257191, NULL, 'PF12429', NULL, NULL, 'Protein of unknown function (DUF3676)', NULL, 'DUF3676', NULL, NULL, 20507, 9),
(257192, NULL, 'PF05739', NULL, NULL, 'SNARE domain', NULL, 'SNARE', NULL, NULL, 6695, 9),
(257193, NULL, 'PF12127', NULL, NULL, 'Flotillin-like protein FloA', NULL, 'FloA', NULL, NULL, 16489, 9),
(257194, NULL, 'PF14588', NULL, NULL, 'YjgF/chorismate_mutase-like, putative endoribonuclease', NULL, 'YjgF_endoribonc', NULL, NULL, 7917, 9),
(257195, NULL, 'PF00704', NULL, NULL, 'Glycosyl hydrolases family 18', NULL, 'Glyco_hydro_18', NULL, NULL, 1461, 9),
(257196, NULL, 'PF06593', NULL, NULL, 'Raspberry bushy dwarf virus coat protein', NULL, 'RBDV_coat', NULL, NULL, 9492, 9),
(257197, NULL, 'PF01997', NULL, NULL, 'Translin family', NULL, 'Translin', NULL, NULL, 5858, 9),
(257198, NULL, 'PF07465', NULL, NULL, 'Photosystem I protein M (PsaM)', NULL, 'PsaM', NULL, NULL, 8858, 9),
(257199, NULL, 'PF20419', NULL, NULL, 'Family of unknown function (DUF6701)', NULL, 'DUF6701', NULL, NULL, 37665, 9),
(257200, NULL, 'PF02542', NULL, NULL, 'YgbB family', NULL, 'YgbB', NULL, NULL, 6440, 9),
(257201, NULL, 'PF16805', NULL, NULL, 'Phage late-transcription coactivator', NULL, 'Trans_coact', NULL, NULL, 22105, 9),
(257202, NULL, 'PF20175', NULL, NULL, 'Tra1 HEAT repeat central region', NULL, 'Tra1_central', NULL, NULL, 33630, 9),
(257203, NULL, 'PF03713', NULL, NULL, 'Domain of unknown function (DUF305)', NULL, 'DUF305', NULL, NULL, 5331, 9),
(257204, NULL, 'PF08983', NULL, NULL, 'Vasopressin V1 receptor, C-terminal', NULL, 'V1R_C', NULL, NULL, 8621, 9),
(257205, NULL, 'PF02437', NULL, NULL, 'SKI/SNO/DAC family', NULL, 'Ski_Sno', NULL, NULL, 6136, 9),
(257206, NULL, 'PF19339', NULL, NULL, 'Protein angel homolog 2 N-terminal', NULL, 'ANGEL2_N', NULL, NULL, 34165, 9),
(257207, NULL, 'PF03484', NULL, NULL, 'tRNA synthetase B5 domain', NULL, 'B5', NULL, NULL, 4285, 9),
(257208, NULL, 'PF11759', NULL, NULL, 'Keratin-associated matrix', NULL, 'KRTAP', NULL, NULL, 19186, 9),
(257209, NULL, 'PF13138', NULL, NULL, 'Protein of unknown function (DUF3982)', NULL, 'DUF3982', NULL, NULL, 22436, 9),
(257210, NULL, 'PF15299', NULL, NULL, 'Amyotrophic lateral sclerosis 2 chromosomal region candidate gene 8', NULL, 'ALS2CR8', NULL, NULL, 24740, 9),
(257211, NULL, 'PF17530', NULL, NULL, 'Non-structural protein NS3', NULL, 'NS3', NULL, NULL, 15425, 9),
(257212, NULL, 'PF02992', NULL, NULL, 'Transposase family tnp2', NULL, 'Transposase_21', NULL, NULL, 3770, 9),
(257213, NULL, 'PF07852', NULL, NULL, 'Protein of unknown function (DUF1642)', NULL, 'DUF1642', NULL, NULL, 12185, 9),
(257214, NULL, 'PF11679', NULL, NULL, 'Protein of unknown function (DUF3275)', NULL, 'DUF3275', NULL, NULL, 19345, 9),
(257215, NULL, 'PF20136', NULL, NULL, 'Family of unknown function (DUF6526)', NULL, 'DUF6526', NULL, NULL, 36191, 9),
(257216, NULL, 'PF07204', NULL, NULL, 'Orthoreovirus membrane fusion protein p10', NULL, 'Orthoreo_P10', NULL, NULL, 14082, 9),
(257217, NULL, 'PF13927', NULL, NULL, 'Immunoglobulin domain', NULL, 'Ig_3', NULL, NULL, NULL, 9),
(257218, NULL, 'PF16754', NULL, NULL, 'Bacterial toxin homologue of phage lysozyme, C-term', NULL, 'Pesticin', NULL, NULL, 25992, 9),
(257219, NULL, 'PF15305', NULL, NULL, 'Intraflagellar transport protein 43', NULL, 'IFT43', NULL, NULL, 24932, 9),
(257220, NULL, 'PF12435', NULL, NULL, 'Protein of unknown function (DUF3678)', NULL, 'DUF3678', NULL, NULL, 20880, 9),
(257221, NULL, 'PF18288', NULL, NULL, 'Fumarylacetoacetase N-terminal domain 2', NULL, 'FAA_hydro_N_2', NULL, NULL, 28919, 9);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(257222, NULL, 'PF18833', NULL, NULL, 'Tetratricopeptide repeat', NULL, 'TPR_22', NULL, NULL, 28876, 9),
(257223, NULL, 'PF00283', NULL, NULL, 'Cytochrome b559, alpha (gene psbE) and beta (gene psbF)subunits', NULL, 'Cytochrom_B559', NULL, NULL, 11642, 9),
(257224, NULL, 'PF11786', NULL, NULL, 'Aft1 HRA domain', NULL, 'Aft1_HRA', NULL, NULL, 19410, 9),
(257225, NULL, 'PF19398', NULL, NULL, 'Family of unknown function (DUF5973)', NULL, 'DUF5973', NULL, NULL, 36619, 9),
(257226, NULL, 'PF04960', NULL, NULL, 'Glutaminase', NULL, 'Glutaminase', NULL, NULL, 13674, 9),
(257227, NULL, 'PF15734', NULL, NULL, 'Migration and invasion-inhibitory', NULL, 'MIIP', NULL, NULL, 25666, 9),
(257228, NULL, 'PF19492', NULL, NULL, 'Family of unknown function (DUF6027)', NULL, 'DUF6027', NULL, NULL, 36530, 9),
(257229, NULL, 'PF06257', NULL, NULL, 'Biofilm formation stimulator VEG', NULL, 'VEG', NULL, NULL, 14386, 9),
(257230, NULL, 'PF10448', NULL, NULL, '20S proteasome chaperone assembly proteins 3 and 4', NULL, 'POC3_POC4', NULL, NULL, 20089, 9),
(257231, NULL, 'PF07017', NULL, NULL, 'Antimicrobial peptide resistance and lipid A acylation protein PagP', NULL, 'PagP', NULL, NULL, 12022, 9),
(257232, NULL, 'PF14574', NULL, NULL, 'C-terminal domain of RACo the ASKHA domain', NULL, 'RACo_C_ter', NULL, NULL, 24176, 9),
(257233, NULL, 'PF15779', NULL, NULL, 'Leucine-rich repeat-containing protein 37 family', NULL, 'LRRC37', NULL, NULL, 22414, 9),
(257234, NULL, 'PF05903', NULL, NULL, 'PPPDE putative peptidase domain', NULL, 'Peptidase_C97', NULL, NULL, 13814, 9),
(257235, NULL, 'PF07824', NULL, NULL, 'Type III secretion chaperone domain', NULL, 'Chaperone_III', NULL, NULL, 18792, 9),
(257236, NULL, 'PF13040', NULL, NULL, 'Fur-regulated basic protein B', NULL, 'Fur_reg_FbpB', NULL, NULL, 22594, 9),
(257237, NULL, 'PF19192', NULL, NULL, 'Response receiver domain', NULL, 'Response_reg_2', NULL, NULL, 35356, 9),
(257238, NULL, 'PF09215', NULL, NULL, 'Bacteriophage T4, Gp8', NULL, 'Phage-Gp8', NULL, NULL, 12669, 9),
(257239, NULL, 'PF12844', NULL, NULL, 'Helix-turn-helix domain', NULL, 'HTH_19', NULL, NULL, 2217, 9),
(257240, NULL, 'PF18233', NULL, NULL, 'Cdc13 OB4 dimerization domain', NULL, 'Cdc13_OB4_dimer', NULL, NULL, 28020, 9),
(257241, NULL, 'PF06156', NULL, NULL, 'Initiation control protein YabA', NULL, 'YabA', NULL, NULL, 9232, 9),
(257242, NULL, 'PF16616', NULL, NULL, 'Unstructured region on Polyhomeotic-like protein 1 and 2', NULL, 'PHC2_SAM_assoc', NULL, NULL, NULL, 9),
(257243, NULL, 'PF05320', NULL, NULL, 'Poxvirus DNA-directed RNA polymerase 19 kDa subunit', NULL, 'Pox_RNA_Pol_19', NULL, NULL, 4357, 9),
(257244, NULL, 'PF16006', NULL, NULL, 'Nucleolar and spindle-associated protein', NULL, 'NUSAP', NULL, NULL, 24487, 9),
(257245, NULL, 'PF09802', NULL, NULL, 'Preprotein translocase subunit Sec66', NULL, 'Sec66', NULL, NULL, 16233, 9),
(257246, NULL, 'PF15183', NULL, NULL, 'Melanocortin-2 receptor accessory protein family', NULL, 'MRAP', NULL, NULL, 23114, 9),
(257247, NULL, 'PF09734', NULL, NULL, 'RNA polymerase III transcription factor (TF)IIIC subunit HTH domain', NULL, 'Tau95', NULL, NULL, 17965, 9),
(257248, NULL, 'PF01621', NULL, NULL, 'Cell fusion glycoprotein K', NULL, 'Fusion_gly_K', NULL, NULL, 1818, 9),
(257249, NULL, 'PF02183', NULL, NULL, 'Homeobox associated leucine zipper', NULL, 'HALZ', NULL, NULL, 1383, 9),
(257250, NULL, 'PF10241', NULL, NULL, 'Uncharacterized conserved protein', NULL, 'KxDL', NULL, NULL, 15628, 9),
(257251, NULL, 'PF10188', NULL, NULL, 'Organic solute transport protein 1', NULL, 'Oscp1', NULL, NULL, 14612, 9),
(257252, NULL, 'PF16897', NULL, NULL, 'C-terminal region of MMR_HSR1 domain', NULL, 'MMR_HSR1_Xtn', NULL, NULL, 22894, 9),
(257253, NULL, 'PF18954', NULL, NULL, 'Family of unknown function (DUF5697)', NULL, 'DUF5697', NULL, NULL, 34392, 9),
(257254, NULL, 'PF06995', NULL, NULL, 'Phage P2 GpU', NULL, 'Phage_P2_GpU', NULL, NULL, 12418, 9),
(257255, NULL, 'PF07977', NULL, NULL, 'FabA-like domain', NULL, 'FabA', NULL, NULL, 18899, 9),
(257256, NULL, 'PF13161', NULL, NULL, 'Protein of unknown function (DUF3996)', NULL, 'DUF3996', NULL, NULL, 15304, 9);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(257257, NULL, 'PF14959', NULL, NULL, 'gamma-Secretase-activating protein C-term', NULL, 'GSAP-16', NULL, NULL, 21743, 9),
(257258, NULL, 'PF05455', NULL, NULL, 'GvpH', NULL, 'GvpH', NULL, NULL, 14335, 9),
(257259, NULL, 'PF01070', NULL, NULL, 'FMN-dependent dehydrogenase', NULL, 'FMN_dh', NULL, NULL, 1302, 9),
(257260, NULL, 'PF07696', NULL, NULL, '7TMR-DISM extracellular 2', NULL, '7TMR-DISMED2', NULL, NULL, 9898, 9),
(257261, NULL, 'PF07912', NULL, NULL, 'ERp29, N-terminal domain', NULL, 'ERp29_N', NULL, NULL, 13336, 9),
(257262, NULL, 'PF00227', NULL, NULL, 'Proteasome subunit', NULL, 'Proteasome', NULL, NULL, 2377, 9),
(257263, NULL, 'PF12092', NULL, NULL, 'Protein of unknown function (DUF3568)', NULL, 'DUF3568', NULL, NULL, 20457, 9),
(257264, NULL, 'PF06239', NULL, NULL, 'Evolutionarily conserved signalling intermediate in Toll pathway', NULL, 'ECSIT', NULL, NULL, 35435, 9),
(257265, NULL, 'PF03382', NULL, NULL, 'Mycoplasma protein of unknown function, DUF285', NULL, 'DUF285', NULL, NULL, 2308, 9),
(257266, NULL, 'PF05968', NULL, NULL, 'Bacillus PapR protein', NULL, 'Bacillus_PapR', NULL, NULL, 12915, 9),
(257267, NULL, 'PF15219', NULL, NULL, 'Testis-expressed 12', NULL, 'TEX12', NULL, NULL, 21788, 9),
(257268, NULL, 'PF04805', NULL, NULL, 'E10-like protein conserved region', NULL, 'Pox_E10', NULL, NULL, 4865, 9),
(257269, NULL, 'PF13586', NULL, NULL, 'Transposase DDE domain', NULL, 'DDE_Tnp_1_2', NULL, NULL, 24235, 9),
(257270, NULL, 'PF03973', NULL, NULL, 'Triabin', NULL, 'Triabin', NULL, NULL, 2513, 9),
(257271, NULL, 'PF09916', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2145)', NULL, 'DUF2145', NULL, NULL, 12300, 9),
(257272, NULL, 'PF17833', NULL, NULL, 'UPF0113 Pre-PUA domain', NULL, 'UPF0113_N', NULL, NULL, 27542, 9),
(257273, NULL, 'PF13763', NULL, NULL, 'Domain of unknown function (DUF4167)', NULL, 'DUF4167', NULL, NULL, 22273, 9),
(257274, NULL, 'PF04340', NULL, NULL, 'Protein of unknown function, DUF484', NULL, 'DUF484', NULL, NULL, 3638, 9),
(257275, NULL, 'PF04881', NULL, NULL, 'Adenovirus GP19K', NULL, 'Adeno_GP19K', NULL, NULL, 5609, 9),
(257276, NULL, 'PF07253', NULL, NULL, 'Gypsy protein', NULL, 'Gypsy', NULL, NULL, 14473, 9),
(257277, NULL, 'PF17971', NULL, NULL, 'Leukemia inhibitory factor receptor D2 domain', NULL, 'LIFR_D2', NULL, NULL, 29177, 9),
(257278, NULL, 'PF16833', NULL, NULL, 'Erythroid krueppel-like transcription factor, transactivation 2', NULL, 'EKLF_TAD2', NULL, NULL, 21694, 9),
(257279, NULL, 'PF13330', NULL, NULL, 'Mucin-2 protein WxxW repeating region', NULL, 'Mucin2_WxxW', NULL, NULL, 26270, 9),
(257280, NULL, 'PF20139', NULL, NULL, 'Family of unknown function (DUF6529)', NULL, 'DUF6529', NULL, NULL, 37342, 9),
(257281, NULL, 'PF16853', NULL, NULL, 'Cell division control protein 13 N-terminus', NULL, 'CDC13_N', NULL, NULL, 22797, 9),
(257282, NULL, 'PF02594', NULL, NULL, 'Uncharacterised ACR, YggU family COG1872', NULL, 'DUF167', NULL, NULL, 2129, 9),
(257283, NULL, 'PF11301', NULL, NULL, 'Protein of unknown function (DUF3103)', NULL, 'DUF3103', NULL, NULL, 18268, 9),
(257284, NULL, 'PF14321', NULL, NULL, 'Domain of unknown function (DUF4382)', NULL, 'DUF4382', NULL, NULL, 26164, 9),
(257285, NULL, 'PF16986', NULL, NULL, 'Heavy-metal resistance protein CzcE', NULL, 'CzcE', NULL, NULL, 24433, 9),
(257286, NULL, 'PF20513', NULL, NULL, 'Prokaryotic ubiquitin-like protein UBact', NULL, 'UBact', NULL, NULL, 27313, 9),
(257287, NULL, 'PF07022', NULL, NULL, 'Bacteriophage CI repressor helix-turn-helix domain', NULL, 'Phage_CI_repr', NULL, NULL, 9953, 9),
(257288, NULL, 'PF11621', NULL, NULL, 'C3 binding domain 4 of IgG-bind protein SBI', NULL, 'Sbi-IV', NULL, NULL, 18760, 9),
(257289, NULL, 'PF18350', NULL, NULL, 'Restriction endonuclease SH3 domain', NULL, 'SH3_17', NULL, NULL, 27856, 9),
(257290, NULL, 'PF03907', NULL, NULL, 'Spo7-like protein', NULL, 'Spo7', NULL, NULL, 2882, 9),
(257291, NULL, 'PF04219', NULL, NULL, 'Protein of unknown function, DUF', NULL, 'DUF413', NULL, NULL, 5185, 9),
(257292, NULL, 'PF16568', NULL, NULL, 'Tyrosine-rich domain of Sam68', NULL, 'Sam68-YY', NULL, NULL, 25356, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(257293, NULL, 'PF17470', NULL, NULL, 'Phage gene product 45.2', NULL, 'Gp45_2', NULL, NULL, 18615, 9),
(257294, NULL, 'PF17890', NULL, NULL, 'Peptidoglycan hydrolase LytB WW-like domain', NULL, 'WW_like', NULL, NULL, 28311, 9),
(257295, NULL, 'PF00178', NULL, NULL, 'Ets-domain', NULL, 'Ets', NULL, NULL, 6517, 9),
(257296, NULL, 'PF04793', NULL, NULL, 'BRRF1-like protein', NULL, 'Herpes_BBRF1', NULL, NULL, 4537, 9),
(257297, NULL, 'PF17278', NULL, NULL, 'Family of unknown function (DUF5343)', NULL, 'DUF5343', NULL, NULL, 28332, 9),
(257298, NULL, 'PF10174', NULL, NULL, 'RIM-binding protein of the cytomatrix active zone', NULL, 'Cast', NULL, NULL, 14740, 9),
(257299, NULL, 'PF00125', NULL, NULL, 'Core histone H2A/H2B/H3/H4', NULL, 'Histone', NULL, NULL, 56, 9),
(257300, NULL, 'PF17782', NULL, NULL, 'DprA winged helix domain', NULL, 'DprA_WH', NULL, NULL, 30938, 9),
(257301, NULL, 'PF10868', NULL, NULL, 'Cysteine-rich antifungal protein 2, defensin-like', NULL, 'Defensin_like', NULL, NULL, 16523, 9),
(257302, NULL, 'PF03660', NULL, NULL, 'PHF5-like protein', NULL, 'PHF5', NULL, NULL, 6256, 9),
(257303, NULL, 'PF13545', NULL, NULL, 'Crp-like helix-turn-helix domain', NULL, 'HTH_Crp_2', NULL, NULL, 11789, 9),
(257304, NULL, 'PF16556', NULL, NULL, 'Interleukin-17 receptor, fibronectin-III-like domain 1', NULL, 'IL17R_fnIII_D1', NULL, NULL, 26315, 9),
(257305, NULL, 'PF10749', NULL, NULL, 'Protein of unknown function (DUF2534)', NULL, 'DUF2534', NULL, NULL, 20198, 9),
(257306, NULL, 'PF18627', NULL, NULL, 'Peptidoglycan GlcNAc deacetylase N-terminal domain', NULL, 'PgdA_N', NULL, NULL, 29009, 9),
(257307, NULL, 'PF06708', NULL, NULL, 'Protein of unknown function (DUF1195)', NULL, 'DUF1195', NULL, NULL, 8247, 9),
(257308, NULL, 'PF10358', NULL, NULL, 'N-terminal C2 in EEIG1 and EHBP1 proteins', NULL, 'NT-C2', NULL, NULL, 17298, 9),
(257309, NULL, 'PF11763', NULL, NULL, 'Cell-wall adhesin ligand-binding C-terminal', NULL, 'DIPSY', NULL, NULL, 19214, 9),
(257310, NULL, 'PF15828', NULL, NULL, 'Domain of unknown function (DUF4710)', NULL, 'DUF4710', NULL, NULL, 26326, 9),
(257311, NULL, 'PF14060', NULL, NULL, 'Domain of unknown function (DUF4252)', NULL, 'DUF4252', NULL, NULL, 22948, 9),
(257312, NULL, 'PF18632', NULL, NULL, 'Family of unknown function (DUF5630)', NULL, 'DUF5630', NULL, NULL, 29048, 9),
(257313, NULL, 'PF08831', NULL, NULL, 'Class II MHC-associated invariant chain trimerisation domain', NULL, 'MHCassoc_trimer', NULL, NULL, 12813, 9),
(257314, NULL, 'PF12534', NULL, NULL, 'Pannexin-like TM region of LRRC8', NULL, 'Pannexin_like', NULL, NULL, 15327, 9),
(257315, NULL, 'PF19449', NULL, NULL, 'Family of unknown function (DUF5987)', NULL, 'DUF5987', NULL, NULL, 36930, 9),
(257316, NULL, 'PF03586', NULL, NULL, 'Herpesvirus UL36 tegument protein', NULL, 'Herpes_UL36', NULL, NULL, 6536, 9),
(257317, NULL, 'PF09336', NULL, NULL, 'Vps4 C terminal oligomerisation domain', NULL, 'Vps4_C', NULL, NULL, 7203, 9),
(257318, NULL, 'PF10326', NULL, NULL, 'Serpentine type 7TM GPCR chemoreceptor Str', NULL, '7TM_GPCR_Str', NULL, NULL, 17500, 9),
(257319, NULL, 'PF09726', NULL, NULL, 'Macoilin family', NULL, 'Macoilin', NULL, NULL, 17909, 9),
(257320, NULL, 'PF10505', NULL, NULL, 'NMDA receptor-regulated gene protein 2 C-terminus', NULL, 'NARG2_C', NULL, NULL, 19183, 9),
(257321, NULL, 'PF09273', NULL, NULL, 'Rubisco LSMT substrate-binding', NULL, 'Rubis-subs-bind', NULL, NULL, 13249, 9),
(257322, NULL, 'PF05036', NULL, NULL, 'SPOR domain', NULL, 'SPOR', NULL, NULL, 1456, 9),
(257323, NULL, 'PF09718', NULL, NULL, 'Lambda phage tail tape-measure protein (Tape_meas_lam_C)', NULL, 'Tape_meas_lam_C', NULL, NULL, 6528, 9),
(257324, NULL, 'PF11463', NULL, NULL, 'R.HinP1I restriction endonuclease', NULL, 'R-HINP1I', NULL, NULL, 18312, 9),
(257325, NULL, 'PF00912', NULL, NULL, 'Transglycosylase', NULL, 'Transgly', NULL, NULL, 697, 9),
(257326, NULL, 'PF12428', NULL, NULL, 'Protein of unknown function (DUF3675)', NULL, 'DUF3675', NULL, NULL, 20974, 9),
(257327, NULL, 'PF14081', NULL, NULL, 'Domain of unknown function (DUF4262)', NULL, 'DUF4262', NULL, NULL, 22865, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(257328, NULL, 'PF06598', NULL, NULL, 'Chlorovirus glycoprotein repeat', NULL, 'Chlorovi_GP_rpt', NULL, NULL, 8290, 9),
(257329, NULL, 'PF03169', NULL, NULL, 'OPT oligopeptide transporter protein', NULL, 'OPT', NULL, NULL, 4137, 9),
(257330, NULL, 'PF10011', NULL, NULL, 'Predicted membrane protein (DUF2254)', NULL, 'DUF2254', NULL, NULL, 17220, 9),
(257331, NULL, 'PF03534', NULL, NULL, 'Salmonella virulence plasmid 65kDa B protein', NULL, 'SpvB', NULL, NULL, 3312, 9),
(257332, NULL, 'PF16247', NULL, NULL, 'Domain of unknown function (DUF4904)', NULL, 'DUF4904', NULL, NULL, 24456, 9),
(257333, NULL, 'PF08182', NULL, NULL, 'Pedibin/Hym-346 family', NULL, 'Pedibin', NULL, NULL, NULL, 9),
(257334, NULL, 'PF03437', NULL, NULL, 'BtpA family', NULL, 'BtpA', NULL, NULL, 7446, 9),
(257335, NULL, 'PF13529', NULL, NULL, 'Peptidase_C39 like family', NULL, 'Peptidase_C39_2', NULL, NULL, 33541, 9),
(257336, NULL, 'PF06577', NULL, NULL, 'Envelope integrity protein A', NULL, 'EipA', NULL, NULL, 7663, 9),
(257337, NULL, 'PF12181', NULL, NULL, 'DNA binding domain of the motility gene repressor (MogR)', NULL, 'MogR_DNAbind', NULL, NULL, 15036, 9),
(257338, NULL, 'PF13852', NULL, NULL, 'Protein of unknown function (DUF4197)', NULL, 'DUF4197', NULL, NULL, 23004, 9),
(257339, NULL, 'PF11269', NULL, NULL, 'Protein of unknown function (DUF3069)', NULL, 'DUF3069', NULL, NULL, 18429, 9),
(257340, NULL, 'PF00006', NULL, NULL, 'ATP synthase alpha/beta family, nucleotide-binding domain', NULL, 'ATP-synt_ab', NULL, NULL, 2597, 9),
(257341, NULL, 'PF00735', NULL, NULL, 'Septin', NULL, 'Septin', NULL, NULL, 26874, 9),
(257342, NULL, 'PF14967', NULL, NULL, 'FAM70 protein', NULL, 'FAM70', NULL, NULL, 21828, 9),
(257343, NULL, 'PF19541', NULL, NULL, 'Family of unknown function (DUF6065)', NULL, 'DUF6065', NULL, NULL, 36378, 9),
(257344, NULL, 'PF12682', NULL, NULL, 'Flavodoxin', NULL, 'Flavodoxin_4', NULL, NULL, 1968, 9),
(257345, NULL, 'PF13379', NULL, NULL, 'NMT1-like family', NULL, 'NMT1_2', NULL, NULL, NULL, 9),
(257346, NULL, 'PF15108', NULL, NULL, 'Voltage-dependent calcium channel gamma-like subunit protein family', NULL, 'TMEM37', NULL, NULL, 26001, 9),
(257347, NULL, 'PF14261', NULL, NULL, 'Domain of unknown function (DUF4351)', NULL, 'DUF4351', NULL, NULL, 26296, 9),
(257348, NULL, 'PF04402', NULL, NULL, 'Protein of unknown function (DUF541)', NULL, 'SIMPL', NULL, NULL, 10443, 9),
(257349, NULL, 'PF10802', NULL, NULL, 'Protein of unknown function (DUF2540)', NULL, 'DUF2540', NULL, NULL, 13019, 9),
(257350, NULL, 'PF12310', NULL, NULL, 'Transcription factor protein N terminal', NULL, 'Elf-1_N', NULL, NULL, 20624, 9),
(257351, NULL, 'PF03306', NULL, NULL, 'Alpha-acetolactate decarboxylase', NULL, 'AAL_decarboxy', NULL, NULL, 7486, 9),
(257352, NULL, 'PF19444', NULL, NULL, 'MTP large subunit, lipid-binding domain', NULL, 'MTP_lip_bd', NULL, NULL, 34158, 9),
(257353, NULL, 'PF19813', NULL, NULL, 'Family of unknown function (DUF6296)', NULL, 'DUF6296', NULL, NULL, 37042, 9),
(257354, NULL, 'PF04193', NULL, NULL, 'PQ loop repeat', NULL, 'PQ-loop', NULL, NULL, 1019, 9),
(257355, NULL, 'PF18783', NULL, NULL, 'Isopullulanase beta-solenoid repeat', NULL, 'IPU_b_solenoid', NULL, NULL, 29308, 9),
(257356, NULL, 'PF11755', NULL, NULL, 'Protein of unknown function (DUF3311)', NULL, 'DUF3311', NULL, NULL, 19488, 9),
(257357, NULL, 'PF01328', NULL, NULL, 'Peroxidase, family 2', NULL, 'Peroxidase_2', NULL, NULL, 3936, 9),
(257358, NULL, 'PF05018', NULL, NULL, 'CFA20 domain', NULL, 'CFA20_dom', NULL, NULL, 1011, 9),
(257359, NULL, 'PF04840', NULL, NULL, 'Vps16, C-terminal region', NULL, 'Vps16_C', NULL, NULL, 4772, 9),
(257360, NULL, 'PF05342', NULL, NULL, 'M26 IgA1-specific Metallo-endopeptidase N-terminal region', NULL, 'Peptidase_M26_N', NULL, NULL, 5380, 9),
(257361, NULL, 'PF17191', NULL, NULL, 'RecG wedge domain', NULL, 'RecG_wedge', NULL, NULL, 33465, 9),
(257362, NULL, 'PF19885', NULL, NULL, 'Family of unknown function (DUF6358)', NULL, 'DUF6358', NULL, NULL, 36710, 9),
(257363, NULL, 'PF10135', NULL, NULL, 'Rod binding protein', NULL, 'Rod-binding', NULL, NULL, 14889, 9);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(257364, NULL, 'PF13858', NULL, NULL, 'Protein of unknown function (DUF4199)', NULL, 'DUF4199', NULL, NULL, 23473, 9),
(257365, NULL, 'PF10734', NULL, NULL, 'Protein of unknown function (DUF2523)', NULL, 'DUF2523', NULL, NULL, 21251, 9),
(257366, NULL, 'PF02830', NULL, NULL, 'V4R domain', NULL, 'V4R', NULL, NULL, 1543, 9),
(257367, NULL, 'PF03114', NULL, NULL, 'BAR domain', NULL, 'BAR', NULL, NULL, 2866, 9),
(257368, NULL, 'PF12662', NULL, NULL, 'Complement Clr-like EGF-like', NULL, 'cEGF', NULL, NULL, 22308, 9),
(257369, NULL, 'PF12180', NULL, NULL, 'TSG101 and ALIX binding domain of CEP55', NULL, 'EABR', NULL, NULL, 20322, 9),
(257370, NULL, 'PF11118', NULL, NULL, 'Protein of unknown function (DUF2627)', NULL, 'DUF2627', NULL, NULL, 18888, 9),
(257371, NULL, 'PF17357', NULL, NULL, 'Facilitor Of iron transport 1 and 2', NULL, 'FIT1_2', NULL, NULL, 9699, 9),
(257372, NULL, 'PF16623', NULL, NULL, 'Unstructured linker region between on GAS7 protein', NULL, 'WW_FCH_linker', NULL, NULL, NULL, 9),
(257373, NULL, 'PF03924', NULL, NULL, 'CHASE domain', NULL, 'CHASE', NULL, NULL, 11026, 9),
(257374, NULL, 'PF04977', NULL, NULL, 'Septum formation initiator', NULL, 'DivIC', NULL, NULL, 6615, 9),
(257375, NULL, 'PF11749', NULL, NULL, 'Protein of unknown function (DUF3305)', NULL, 'DUF3305', NULL, NULL, 19371, 9),
(257376, NULL, 'PF04445', NULL, NULL, 'Putative SAM-dependent methyltransferase', NULL, 'SAM_MT', NULL, NULL, 10595, 9),
(257377, NULL, 'PF04817', NULL, NULL, 'Umbravirus long distance movement (LDM) family', NULL, 'Umbravirus_LDM', NULL, NULL, 4602, 9),
(257378, NULL, 'PF05584', NULL, NULL, 'Sulfolobus plasmid regulatory protein', NULL, 'Sulfolobus_pRN', NULL, NULL, 13650, 9),
(257379, NULL, 'PF09275', NULL, NULL, 'Pertussis toxin S4 subunit', NULL, 'Pertus-S4-tox', NULL, NULL, 13105, 9),
(257380, NULL, 'PF08542', NULL, NULL, 'Replication factor C C-terminal domain', NULL, 'Rep_fac_C', NULL, NULL, 7757, 9),
(257381, NULL, 'PF19891', NULL, NULL, 'Family of unknown function (DUF6364)', NULL, 'DUF6364', NULL, NULL, 36920, 9),
(257382, NULL, 'PF20572', NULL, NULL, 'Family of unknown function (DUF6781)', NULL, 'DUF6781', NULL, NULL, 37280, 9),
(257383, NULL, 'PF03103', NULL, NULL, 'Domain of unknown function (DUF243)', NULL, 'DUF243', NULL, NULL, 2606, 9),
(257384, NULL, 'PF17779', NULL, NULL, 'NOD2 winged helix domain', NULL, 'NOD2_WH', NULL, NULL, 28838, 9),
(257385, NULL, 'PF18210', NULL, NULL, 'Knl1 RWD C-terminal domain', NULL, 'Knl1_RWD_C', NULL, NULL, 32953, 9),
(257386, NULL, 'PF16369', NULL, NULL, 'C-terminal lipocalin-like domain', NULL, 'GH43_C', NULL, NULL, 23728, 9),
(257387, NULL, 'PF18548', NULL, NULL, 'Metanogen output domain 2', NULL, 'MetOD2', NULL, NULL, 27751, 9),
(257388, NULL, 'PF07058', NULL, NULL, 'Microtubule-associated protein 70', NULL, 'MAP70', NULL, NULL, 12857, 9),
(257389, NULL, 'PF01034', NULL, NULL, 'Syndecan domain', NULL, 'Syndecan', NULL, NULL, 26323, 9),
(257390, NULL, 'PF01439', NULL, NULL, 'Metallothionein', NULL, 'Metallothio_2', NULL, NULL, 4692, 9),
(257391, NULL, 'PF03727', NULL, NULL, 'Hexokinase', NULL, 'Hexokinase_2', NULL, NULL, 16654, 9),
(257392, NULL, 'PF04356', NULL, NULL, 'Protein of unknown function (DUF489)', NULL, 'DUF489', NULL, NULL, 4581, 9),
(257393, NULL, 'PF04942', NULL, NULL, 'CC domain', NULL, 'CC', NULL, NULL, 6804, 9),
(257394, NULL, 'PF15946', NULL, NULL, 'Domain of unknown function (DUF4754)', NULL, 'DUF4754', NULL, NULL, 25248, 9),
(257395, NULL, 'PF00288', NULL, NULL, 'GHMP kinases N terminal domain', NULL, 'GHMP_kinases_N', NULL, NULL, 11436, 9),
(257396, NULL, 'PF09153', NULL, NULL, 'Methylated DNA-protein cysteine methyltransferase, N-terminal', NULL, 'MGMT_N', NULL, NULL, 10969, 9),
(257397, NULL, 'PF16455', NULL, NULL, 'Ubiquitin-binding domain', NULL, 'UBD', NULL, NULL, 22468, 9),
(257398, NULL, 'PF11382', NULL, NULL, 'Copper transport outer membrane protein, MctB', NULL, 'MctB', NULL, NULL, 18611, 9),
(257399, NULL, 'PF18555', NULL, NULL, 'MobL relaxases', NULL, 'MobL', NULL, NULL, 28589, 9),
(257400, NULL, 'PF13624', NULL, NULL, 'SurA N-terminal domain', NULL, 'SurA_N_3', NULL, NULL, NULL, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(257401, NULL, 'PF01384', NULL, NULL, 'Phosphate transporter family', NULL, 'PHO4', NULL, NULL, 1371, 9),
(257402, NULL, 'PF15564', NULL, NULL, 'Immunity protein 25', NULL, 'Imm25', NULL, NULL, 25365, 9),
(257403, NULL, 'PF00083', NULL, NULL, 'Sugar (and other) transporter', NULL, 'Sugar_tr', NULL, NULL, 5741, 9),
(257404, NULL, 'PF09574', NULL, NULL, 'Protein  of unknown function (Duf2374)', NULL, 'DUF2374', NULL, NULL, 8658, 9),
(257405, NULL, 'PF07235', NULL, NULL, 'Protein of unknown function (DUF1427)', NULL, 'DUF1427', NULL, NULL, 14261, 9),
(257406, NULL, 'PF11854', NULL, NULL, 'Putative outer membrane beta-barrel porin, MtrB/PioB', NULL, 'MtrB_PioB', NULL, NULL, 17926, 9),
(257407, NULL, 'PF20252', NULL, NULL, 'BIG2 C-terminal domain', NULL, 'BIG2_C', NULL, NULL, 37762, 9),
(257408, NULL, 'PF02696', NULL, NULL, 'Protein adenylyltransferase SelO', NULL, 'SelO', NULL, NULL, 3081, 9),
(257409, NULL, 'PF11436', NULL, NULL, 'Protein of unknown function (DUF3199)', NULL, 'DUF3199', NULL, NULL, 7388, 9),
(257410, NULL, 'PF09328', NULL, NULL, 'Domain of unknown function (DUF1984)', NULL, 'Phytochelatin_C', NULL, NULL, 14090, 9),
(257411, NULL, 'PF19137', NULL, NULL, 'Family of unknown function (DUF5820)', NULL, 'DUF5820', NULL, NULL, 34450, 9),
(257412, NULL, 'PF02048', NULL, NULL, 'Heat-stable enterotoxin ST', NULL, 'Enterotoxin_ST', NULL, NULL, 5612, 9),
(257413, NULL, 'PF08400', NULL, NULL, 'Prophage tail fibre N-terminal', NULL, 'phage_tail_N', NULL, NULL, 11243, 9),
(257414, NULL, 'PF15259', NULL, NULL, 'G-2 and S-phase expressed 1', NULL, 'GTSE1_N', NULL, NULL, 22341, 9),
(257415, NULL, 'PF19526', NULL, NULL, 'S-layer protein Slr4', NULL, 'Slr4', NULL, NULL, 36095, 9),
(257416, NULL, 'PF11604', NULL, NULL, 'Copper binding periplasmic protein CusF', NULL, 'CusF_Ec', NULL, NULL, 18886, 9),
(257417, NULL, 'PF18130', NULL, NULL, 'ATP-grasp N-terminal domain', NULL, 'ATPgrasp_N', NULL, NULL, 29857, 9),
(257418, NULL, 'PF04517', NULL, NULL, 'Microvirus lysis protein (E), C terminus', NULL, 'Microvir_lysis', NULL, NULL, 2808, 9),
(257419, NULL, 'PF10151', NULL, NULL, 'TMEM214, C-terminal, caspase 4 activator', NULL, 'TMEM214', NULL, NULL, 14701, 9),
(257420, NULL, 'PF12329', NULL, NULL, 'TATA element modulatory factor 1 DNA binding', NULL, 'TMF_DNA_bd', NULL, NULL, 20678, 9),
(257421, NULL, 'PF05102', NULL, NULL, 'holin, BlyA family', NULL, 'Holin_BlyA', NULL, NULL, 6466, 9),
(257422, NULL, 'PF15144', NULL, NULL, 'Domain of unknown function (DUF4576)', NULL, 'DUF4576', NULL, NULL, 22933, 9),
(257423, NULL, 'PF13320', NULL, NULL, 'Domain of unknown function (DUF4091)', NULL, 'DUF4091', NULL, NULL, 23382, 9),
(257424, NULL, 'PF12859', NULL, NULL, 'Anaphase-promoting complex subunit 1 WD40 beta-propeller domain', NULL, 'ANAPC1', NULL, NULL, 22664, 9),
(257425, NULL, 'PF20412', NULL, NULL, 'RALGAPB N-terminal domain', NULL, 'RALGAPB_N', NULL, NULL, 34188, 9),
(257426, NULL, 'PF01593', NULL, NULL, 'Flavin containing amine oxidoreductase', NULL, 'Amino_oxidase', NULL, NULL, 6831, 9),
(257427, NULL, 'PF02057', NULL, NULL, 'Glycosyl hydrolase family 59', NULL, 'Glyco_hydro_59', NULL, NULL, 2292, 9),
(257428, NULL, 'PF02515', NULL, NULL, 'CoA-transferase family III', NULL, 'CoA_transf_3', NULL, NULL, 1184, 9),
(257429, NULL, 'PF13047', NULL, NULL, 'Protein of unknown function (DUF3907)', NULL, 'DUF3907', NULL, NULL, 22994, 9),
(257430, NULL, 'PF09165', NULL, NULL, 'Ubiquinol-cytochrome c reductase 8 kDa, N-terminal', NULL, 'Ubiq-Cytc-red_N', NULL, NULL, 12423, 9),
(257431, NULL, 'PF06073', NULL, NULL, 'Bacterial protein of unknown function (DUF934)', NULL, 'DUF934', NULL, NULL, 7545, 9),
(257432, NULL, 'PF19579', NULL, NULL, 'Bacteriodetes cell division protein (FtsL-like)', NULL, 'FtsL_2', NULL, NULL, 36474, 9),
(257433, NULL, 'PF11660', NULL, NULL, 'Protein of unknown function (DUF3262)', NULL, 'DUF3262', NULL, NULL, 18731, 9),
(257434, NULL, 'PF08243', NULL, NULL, 'SPT2 chromatin protein', NULL, 'SPT2', NULL, NULL, 13088, 9),
(257435, NULL, 'PF11214', NULL, NULL, 'Mediator complex subunit 2', NULL, 'Med2', NULL, NULL, 15106, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(257436, NULL, 'PF05141', NULL, NULL, 'Pyoverdine/dityrosine biosynthesis protein', NULL, 'DIT1_PvcA', NULL, NULL, 2364, 9),
(257437, NULL, 'PF18217', NULL, NULL, 'Zap1 zinc finger 2', NULL, 'Zap1_zf2', NULL, NULL, 32032, 9),
(257438, NULL, 'PF13213', NULL, NULL, 'Protein of unknown function (DUF4021)', NULL, 'DUF4021', NULL, NULL, 22873, 9),
(257439, NULL, 'PF13445', NULL, NULL, 'RING-type zinc-finger', NULL, 'zf-RING_UBOX', NULL, NULL, 24361, 9),
(257440, NULL, 'PF12847', NULL, NULL, 'Methyltransferase domain', NULL, 'Methyltransf_18', NULL, NULL, NULL, 9),
(257441, NULL, 'PF14939', NULL, NULL, 'DDB1-and CUL4-substrate receptor 15, WD repeat', NULL, 'DCAF15_WD40', NULL, NULL, 26115, 9),
(257442, NULL, 'PF05802', NULL, NULL, 'Enterobacterial EspB protein', NULL, 'EspB', NULL, NULL, 14059, 9),
(257443, NULL, 'PF09194', NULL, NULL, 'Restriction endonuclease BsobI', NULL, 'Endonuc-BsobI', NULL, NULL, 12464, 9),
(257444, NULL, 'PF00465', NULL, NULL, 'Iron-containing alcohol dehydrogenase', NULL, 'Fe-ADH', NULL, NULL, 3114, 9),
(257445, NULL, 'PF06767', NULL, NULL, 'Sif protein', NULL, 'Sif', NULL, NULL, 9251, 9),
(257446, NULL, 'PF00318', NULL, NULL, 'Ribosomal protein S2', NULL, 'Ribosomal_S2', NULL, NULL, 4059, 9),
(257447, NULL, 'PF07247', NULL, NULL, 'Alcohol acetyltransferase', NULL, 'AATase', NULL, NULL, 11411, 9),
(257448, NULL, 'PF13551', NULL, NULL, 'Winged helix-turn helix', NULL, 'HTH_29', NULL, NULL, NULL, 9),
(257449, NULL, 'PF13988', NULL, NULL, 'Protein of unknown function (DUF4225)', NULL, 'DUF4225', NULL, NULL, 22455, 9),
(257450, NULL, 'PF18294', NULL, NULL, 'Peptidase S41 N-terminal domain', NULL, 'Pept_S41_N', NULL, NULL, 30575, 9),
(257451, NULL, 'PF02754', NULL, NULL, 'Cysteine-rich domain', NULL, 'CCG', NULL, NULL, 709, 9),
(257452, NULL, 'PF11866', NULL, NULL, 'Protein of unknown function (DUF3386)', NULL, 'DUF3386', NULL, NULL, 19472, 9),
(257453, NULL, 'PF06764', NULL, NULL, 'Protein of unknown function (DUF1223)', NULL, 'DUF1223', NULL, NULL, 9109, 9),
(257454, NULL, 'PF03688', NULL, NULL, 'Nepovirus coat protein, C-terminal domain', NULL, 'Nepo_coat_C', NULL, NULL, 5391, 9),
(257455, NULL, 'PF09819', NULL, NULL, 'ABC-type cobalt transport system, permease component', NULL, 'ABC_cobalt', NULL, NULL, 21301, 9),
(257456, NULL, 'PF13711', NULL, NULL, 'Domain of unknown function (DUF4160)', NULL, 'DUF4160', NULL, NULL, 22180, 9),
(257457, NULL, 'PF19057', NULL, NULL, 'PH domain', NULL, 'PH_19', NULL, NULL, NULL, 9),
(257458, NULL, 'PF11692', NULL, NULL, 'Protein of unknown function (DUF3289)', NULL, 'DUF3289', NULL, NULL, 20770, 9),
(257459, NULL, 'PF02895', NULL, NULL, 'Signal transducing histidine kinase, homodimeric domain', NULL, 'H-kinase_dim', NULL, NULL, 1509, 9),
(257460, NULL, 'PF15843', NULL, NULL, 'Domain of unknown function (DUF4719)', NULL, 'DUF4719', NULL, NULL, 26500, 9),
(257461, NULL, 'PF04300', NULL, NULL, 'F-box associated region', NULL, 'FBA', NULL, NULL, 3584, 9),
(257462, NULL, 'PF08517', NULL, NULL, 'Ataxin-1 and HBP1 module (AXH)', NULL, 'AXH', NULL, NULL, 1481, 9),
(257463, NULL, 'PF15184', NULL, NULL, 'Mitochondrial import receptor subunit TOM6 homolog', NULL, 'TOM6p', NULL, NULL, 21977, 9),
(257464, NULL, 'PF04324', NULL, NULL, 'BFD-like [2Fe-2S] binding domain', NULL, 'Fer2_BFD', NULL, NULL, 3804, 9),
(257465, NULL, 'PF16953', NULL, NULL, 'Protein-only RNase P', NULL, 'PRORP', NULL, NULL, 22496, 9),
(257466, NULL, 'PF07248', NULL, NULL, 'Protein of unknown function (DUF1431)', NULL, 'DUF1431', NULL, NULL, 1054, 9),
(257467, NULL, 'PF17480', NULL, NULL, 'AlphaC N-terminal domain 2', NULL, 'AlphaC_N2', NULL, NULL, 9830, 9),
(257468, NULL, 'PF17194', NULL, NULL, 'Transcriptional regulator, AbiEi antitoxin N-terminal domain', NULL, 'AbiEi_3_N', NULL, NULL, 33442, 9),
(257469, NULL, 'PF09173', NULL, NULL, 'Initiation factor eIF2 gamma, C terminal', NULL, 'eIF2_C', NULL, NULL, 12005, 9),
(257470, NULL, 'PF17112', NULL, NULL, 'Mitochondrial import receptor subunit Tom6, fungal', NULL, 'Tom6', NULL, NULL, 20325, 9),
(257471, NULL, 'PF18814', NULL, NULL, 'phage-Barnase-EndoU-ColicinE5/D-RelE like nuclease5', NULL, 'PBECR5', NULL, NULL, 29116, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(257472, NULL, 'PF07967', NULL, NULL, 'C3HC zinc finger-like', NULL, 'zf-C3HC', NULL, NULL, 8232, 9),
(257473, NULL, 'PF15287', NULL, NULL, 'KRBA1 family repeat', NULL, 'KRBA1', NULL, NULL, 24661, 9),
(257474, NULL, 'PF11175', NULL, NULL, 'Protein of unknown function (DUF2961)', NULL, 'DUF2961', NULL, NULL, 18289, 9),
(257475, NULL, 'PF03684', NULL, NULL, 'Uncharacterised protein family (UPF0179)', NULL, 'UPF0179', NULL, NULL, 6355, 9),
(257476, NULL, 'PF15382', NULL, NULL, 'Domain of unknown function (DUF4609)', NULL, 'DUF4609', NULL, NULL, 25481, 9),
(257477, NULL, 'PF00087', NULL, NULL, 'Snake toxin and toxin-like protein', NULL, 'Toxin_TOLIP', NULL, NULL, 30296, 9),
(257478, NULL, 'PF17175', NULL, NULL, 'Modulator of levamisole receptor-1', NULL, 'MOLO1', NULL, NULL, 31462, 9),
(257479, NULL, 'PF11107', NULL, NULL, 'Fanconi anemia group F protein (FANCF)', NULL, 'FANCF', NULL, NULL, 19193, 9),
(257480, NULL, 'PF01696', NULL, NULL, 'Adenovirus EB1 55K protein / large t-antigen', NULL, 'Adeno_E1B_55K', NULL, NULL, 1565, 9),
(257481, NULL, 'PF18388', NULL, NULL, 'Atg29 N-terminal domain', NULL, 'ATG29_N', NULL, NULL, 28358, 9),
(257482, NULL, 'PF12577', NULL, NULL, 'PPAR gamma N-terminal region', NULL, 'PPARgamma_N', NULL, NULL, 16502, 9),
(257483, NULL, 'PF17739', NULL, NULL, 'Family of unknown function (DUF5576)', NULL, 'DUF5576', NULL, NULL, 30495, 9),
(257484, NULL, 'PF10129', NULL, NULL, 'OpgC protein', NULL, 'OpgC_C', NULL, NULL, 12223, 9),
(257485, NULL, 'PF10306', NULL, NULL, 'Hypothetical protein FLILHELTA', NULL, 'FLILHELTA', NULL, NULL, 19661, 9),
(257486, NULL, 'PF12977', NULL, NULL, 'Domain of Unknown Function with PDB structure (DUF3861)', NULL, 'DUF3861', NULL, NULL, 22655, 9),
(257487, NULL, 'PF14779', NULL, NULL, 'Ciliary BBSome complex subunit 1', NULL, 'BBS1', NULL, NULL, 26250, 9),
(257488, NULL, 'PF00037', NULL, NULL, '4Fe-4S binding domain', NULL, 'Fer4', NULL, NULL, 12567, 9),
(257489, NULL, 'PF01435', NULL, NULL, 'Peptidase family M48', NULL, 'Peptidase_M48', NULL, NULL, 4474, 9),
(257490, NULL, 'PF04314', NULL, NULL, 'Copper chaperone PCu(A)C', NULL, 'PCuAC', NULL, NULL, 3947, 9),
(257491, NULL, 'PF06138', NULL, NULL, 'Chordopoxvirus E11 protein', NULL, 'Chordopox_E11', NULL, NULL, 10159, 9),
(257492, NULL, 'PF08561', NULL, NULL, 'Mitochondrial ribosomal protein L37', NULL, 'Ribosomal_L37', NULL, NULL, 9804, 9),
(257493, NULL, 'PF07978', NULL, NULL, 'NIPSNAP', NULL, 'NIPSNAP', NULL, NULL, 9242, 9),
(257494, NULL, 'PF09824', NULL, NULL, 'ArsR transcriptional regulator', NULL, 'ArsR', NULL, NULL, 11284, 9),
(257495, NULL, 'PF05303', NULL, NULL, 'GSKIP domain', NULL, 'GSKIP_dom', NULL, NULL, 4209, 9),
(257496, NULL, 'PF08495', NULL, NULL, 'FIST N domain', NULL, 'FIST', NULL, NULL, 13752, 9),
(257497, NULL, 'PF18292', NULL, NULL, 'Zinc transporter ZIP4 domain', NULL, 'ZIP4_domain', NULL, NULL, 28613, 9),
(257498, NULL, 'PF09864', NULL, NULL, 'Membrane-bound lysozyme-inhibitor of c-type lysozyme', NULL, 'MliC', NULL, NULL, 16769, 9),
(257499, NULL, 'PF10549', NULL, NULL, 'ORF11CD3 domain', NULL, 'ORF11CD3', NULL, NULL, 20750, 9),
(257500, NULL, 'PF12870', NULL, NULL, 'Domain of unknown function (DUF4878)', NULL, 'DUF4878', NULL, NULL, 20382, 9),
(257501, NULL, 'PF20268', NULL, NULL, 'SBDS protein, C-terminal domain', NULL, 'SBDS_C', NULL, NULL, 37130, 9),
(257502, NULL, 'PF05095', NULL, NULL, 'Protein of unknown function (DUF687)', NULL, 'DUF687', NULL, NULL, 2034, 9),
(257503, NULL, 'PF06825', NULL, NULL, 'Heat shock factor binding protein 1', NULL, 'HSBP1', NULL, NULL, 11335, 9),
(257504, NULL, 'PF05109', NULL, NULL, 'Herpes virus major outer envelope glycoprotein (BLLF1)', NULL, 'Herpes_BLLF1', NULL, NULL, 2495, 9),
(257505, NULL, 'PF03030', NULL, NULL, 'Inorganic H+ pyrophosphatase', NULL, 'H_PPase', NULL, NULL, 2515, 9),
(257506, NULL, 'PF12582', NULL, NULL, 'Protein of unknown function (DUF3757)', NULL, 'DUF3757', NULL, NULL, 21229, 9),
(257507, NULL, 'PF09184', NULL, NULL, 'PPP4R2', NULL, 'PPP4R2', NULL, NULL, 12066, 9),
(257508, NULL, 'PF03321', NULL, NULL, 'GH3 auxin-responsive promoter', NULL, 'GH3', NULL, NULL, 637, 9);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(257509, NULL, 'PF03043', NULL, NULL, 'Herpesvirus UL87 family', NULL, 'Herpes_UL87', NULL, NULL, 4847, 9),
(257510, NULL, 'PF04066', NULL, NULL, 'Multiple resistance and pH regulation protein F (MrpF / PhaF)', NULL, 'MrpF_PhaF', NULL, NULL, 1063, 9),
(257511, NULL, 'PF10836', NULL, NULL, 'Protein of unknown function (DUF2574)', NULL, 'DUF2574', NULL, NULL, 19587, 9),
(257512, NULL, 'PF14738', NULL, NULL, 'Cilia- and flagella-associated protein 91', NULL, 'CFAP91', NULL, NULL, 22084, 9),
(257513, NULL, 'PF01232', NULL, NULL, 'Mannitol dehydrogenase Rossmann domain', NULL, 'Mannitol_dh', NULL, NULL, 12616, 9),
(257514, NULL, 'PF07443', NULL, NULL, 'HepA-related protein (HARP)', NULL, 'HARP', NULL, NULL, 8660, 9),
(257515, NULL, 'PF10598', NULL, NULL, 'RNA recognition motif of the spliceosomal PrP8', NULL, 'RRM_4', NULL, NULL, 20175, 9),
(257516, NULL, 'PF01581', NULL, NULL, 'FMRFamide related peptide family', NULL, 'FARP', NULL, NULL, 1785, 9),
(257517, NULL, 'PF05883', NULL, NULL, 'Baculovirus U-box/Ring-like domain', NULL, 'Baculo_RING', NULL, NULL, 13757, 9),
(257518, NULL, 'PF00653', NULL, NULL, 'Inhibitor of Apoptosis domain', NULL, 'BIR', NULL, NULL, 2021, 9),
(257519, NULL, 'PF15713', NULL, NULL, 'Protein tyrosine phosphatase receptor type C-associated', NULL, 'PTPRCAP', NULL, NULL, 17660, 9),
(257520, NULL, 'PF02043', NULL, NULL, 'Bacteriochlorophyll C binding protein', NULL, 'Bac_chlorC', NULL, NULL, 3398, 9),
(257521, NULL, 'PF09923', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2155)', NULL, 'DUF2155', NULL, NULL, 19448, 9),
(257522, NULL, 'PF05660', NULL, NULL, 'Coxiella burnetii protein of unknown function (DUF807)', NULL, 'DUF807', NULL, NULL, 13427, 9),
(257523, NULL, 'PF07288', NULL, NULL, 'RNA polymerase epsilon subunit', NULL, 'RpoY', NULL, NULL, 14252, 9),
(257524, NULL, 'PF18057', NULL, NULL, 'Domain of unknown function (DUF5594)', NULL, 'DUF5594', NULL, NULL, 28505, 9),
(257525, NULL, 'PF20315', NULL, NULL, 'Family of unknown function (DUF6611)', NULL, 'DUF6611', NULL, NULL, 37319, 9),
(257526, NULL, 'PF14357', NULL, NULL, 'Domain of unknown function (DUF4404)', NULL, 'DUF4404', NULL, NULL, 26021, 9),
(257527, NULL, 'PF20472', NULL, NULL, 'PD-(D/E)XK nuclease superfamily domain', NULL, 'PDDEXK_11', NULL, NULL, 33555, 9),
(257528, NULL, 'PF08592', NULL, NULL, 'Anthrone oxygenase', NULL, 'Anthrone_oxy', NULL, NULL, 17844, 9),
(257529, NULL, 'PF15309', NULL, NULL, 'ALMS motif', NULL, 'ALMS_motif', NULL, NULL, 24575, 9),
(257530, NULL, 'PF16965', NULL, NULL, 'Ceramide synthase regulator', NULL, 'CSG2', NULL, NULL, 22176, 9),
(257531, NULL, 'PF02019', NULL, NULL, 'WIF domain', NULL, 'WIF', NULL, NULL, 3678, 9),
(257532, NULL, 'PF01167', NULL, NULL, 'Tub family', NULL, 'Tub', NULL, NULL, 2061, 9),
(257533, NULL, 'PF05507', NULL, NULL, 'Microfibril-associated glycoprotein (MAGP)', NULL, 'MAGP', NULL, NULL, 12845, 9),
(257534, NULL, 'PF05894', NULL, NULL, 'Podovirus DNA encapsidation protein (Gp16)', NULL, 'Podovirus_Gp16', NULL, NULL, 12479, 9),
(257535, NULL, 'PF13101', NULL, NULL, 'Protein of unknown function (DUF3945)', NULL, 'DUF3945', NULL, NULL, 22232, 9),
(257536, NULL, 'PF09159', NULL, NULL, 'Mitochondrial resolvase Ydc2 / RNA splicing MRS1', NULL, 'Ydc2-catalyt', NULL, NULL, 12050, 9),
(257537, NULL, 'PF18463', NULL, NULL, 'Proprotein convertase subtilisin-like/kexin type 9 C-terminal domain', NULL, 'PCSK9_C3', NULL, NULL, 28545, 9),
(257538, NULL, 'PF08303', NULL, NULL, 'tRNA ligase kinase domain', NULL, 'tRNA_lig_kinase', NULL, NULL, 9440, 9),
(257539, NULL, 'PF07388', NULL, NULL, 'Alpha-2,8-polysialyltransferase (POLYST)', NULL, 'A-2_8-polyST', NULL, NULL, 11963, 9),
(257540, NULL, 'PF13672', NULL, NULL, 'Protein phosphatase 2C', NULL, 'PP2C_2', NULL, NULL, NULL, 9),
(257541, NULL, 'PF09962', NULL, NULL, 'Uncharacterized conserved protein (DUF2196)', NULL, 'DUF2196', NULL, NULL, 19280, 9),
(257542, NULL, 'PF14795', NULL, NULL, 'Leucine-tRNA synthetase-specific domain', NULL, 'Leucyl-specific', NULL, NULL, 18482, 9),
(257543, NULL, 'PF03042', NULL, NULL, 'Birnavirus VP5 protein', NULL, 'Birna_VP5', NULL, NULL, 4520, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(257544, NULL, 'PF06595', NULL, NULL, 'Borna disease virus P24 protein', NULL, 'BDV_P24', NULL, NULL, 9121, 9),
(257545, NULL, 'PF18374', NULL, NULL, 'Enolase N-terminal domain-like', NULL, 'Enolase_like_N', NULL, NULL, 29725, 9),
(257546, NULL, 'PF03569', NULL, NULL, 'Peptidase family C8', NULL, 'Peptidase_C8', NULL, NULL, 5491, 9),
(257547, NULL, 'PF13285', NULL, NULL, 'Domain of unknown function (DUF4073)', NULL, 'DUF4073', NULL, NULL, 22446, 9),
(257548, NULL, 'PF04173', NULL, NULL, 'TQO small subunit DoxD', NULL, 'DoxD', NULL, NULL, 4989, 9),
(257549, NULL, 'PF10355', NULL, NULL, 'Protein of unknown function (Ytp1)', NULL, 'Ytp1', NULL, NULL, 19694, 9),
(257550, NULL, 'PF01521', NULL, NULL, 'Iron-sulphur cluster biosynthesis', NULL, 'Fe-S_biosyn', NULL, NULL, 4541, 9),
(257551, NULL, 'PF04798', NULL, NULL, 'Baculovirus 19 kDa protein conserved region', NULL, 'Baculo_19', NULL, NULL, 4942, 9),
(257552, NULL, 'PF15700', NULL, NULL, 'Domain of unknown function (DUF4667)', NULL, 'DUF4667', NULL, NULL, 26910, 9),
(257553, NULL, 'PF17262', NULL, NULL, 'Cas6b C-terminal domain', NULL, 'Cas6b_C', NULL, NULL, 18927, 9),
(257554, NULL, 'PF08146', NULL, NULL, 'BP28CT (NUC211) domain', NULL, 'BP28CT', NULL, NULL, 11779, 9),
(257555, NULL, 'PF11365', NULL, NULL, 'Protein SOGA', NULL, 'SOGA', NULL, NULL, 25997, 9),
(257556, NULL, 'PF00389', NULL, NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase, catalytic domain', NULL, '2-Hacid_dh', NULL, NULL, 10488, 9),
(257557, NULL, 'PF06985', NULL, NULL, 'Heterokaryon incompatibility protein (HET)', NULL, 'HET', NULL, NULL, 9826, 9),
(257558, NULL, 'PF03013', NULL, NULL, 'Pyrimidine dimer DNA glycosylase', NULL, 'Pyr_excise', NULL, NULL, 3625, 9),
(257559, NULL, 'PF05025', NULL, NULL, 'RbsD / FucU transport protein family', NULL, 'RbsD_FucU', NULL, NULL, 1006, 9),
(257560, NULL, 'PF15575', NULL, NULL, 'Immunity protein 49', NULL, 'Imm49', NULL, NULL, 25234, 9),
(257561, NULL, 'PF19416', NULL, NULL, 'Astrovirus VPg protein', NULL, 'Astro_VPg', NULL, NULL, 36301, 9),
(257562, NULL, 'PF01676', NULL, NULL, 'Metalloenzyme superfamily', NULL, 'Metalloenzyme', NULL, NULL, 11008, 9),
(257563, NULL, 'PF16272', NULL, NULL, 'Domain of unknown function (DUF4925)', NULL, 'DUF4925', NULL, NULL, 21667, 9),
(257564, NULL, 'PF15553', NULL, NULL, 'Testis-expressed protein 19', NULL, 'TEX19', NULL, NULL, 25125, 9),
(257565, NULL, 'PF08979', NULL, NULL, 'Domain of unknown function (DUF1894)', NULL, 'DUF1894', NULL, NULL, 10864, 9),
(257566, NULL, 'PF18128', NULL, NULL, 'Hydrogen maturase F dimerization domain', NULL, 'HydF_dimer', NULL, NULL, 29852, 9),
(257567, NULL, 'PF05951', NULL, NULL, 'Bacterial protein of unknown function (DUF882)', NULL, 'Peptidase_M15_2', NULL, NULL, 7609, 9),
(257568, NULL, 'PF11626', NULL, NULL, 'TRF2-interacting telomeric protein/Rap1 - C terminal domain', NULL, 'Rap1_C', NULL, NULL, 18834, 9),
(257569, NULL, 'PF01254', NULL, NULL, 'Nuclear transition protein 2', NULL, 'TP2', NULL, NULL, 3572, 9),
(257570, NULL, 'PF16449', NULL, NULL, 'Fimbrillin MatB', NULL, 'MatB', NULL, NULL, 16488, 9),
(257571, NULL, 'PF14374', NULL, NULL, '60S ribosomal protein L4 C-terminal domain', NULL, 'Ribos_L4_asso_C', NULL, NULL, 22035, 9),
(257572, NULL, 'PF08152', NULL, NULL, 'GUCT (NUC152) domain', NULL, 'GUCT', NULL, NULL, 9118, 9),
(257573, NULL, 'PF06367', NULL, NULL, 'Diaphanous FH3 Domain', NULL, 'Drf_FH3', NULL, NULL, 10084, 9),
(257574, NULL, 'PF08462', NULL, NULL, 'Carmovirus coat protein', NULL, 'Carmo_coat_C', NULL, NULL, 13627, 9),
(257575, NULL, 'PF13998', NULL, NULL, 'MgrB protein', NULL, 'MgrB', NULL, NULL, 14910, 9),
(257576, NULL, 'PF06337', NULL, NULL, 'DUSP domain', NULL, 'DUSP', NULL, NULL, 1168, 9),
(257577, NULL, 'PF06379', NULL, NULL, 'L-rhamnose-proton symport protein (RhaT)', NULL, 'RhaT', NULL, NULL, 2986, 9),
(257578, NULL, 'PF09971', NULL, NULL, 'Predicted membrane protein (DUF2206)', NULL, 'DUF2206', NULL, NULL, 17158, 9),
(257579, NULL, 'PF00250', NULL, NULL, 'Forkhead domain', NULL, 'Forkhead', NULL, NULL, 3039, 9),
(257580, NULL, 'PF14392', NULL, NULL, 'Zinc knuckle', NULL, 'zf-CCHC_4', NULL, NULL, 24319, 9);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(257581, NULL, 'PF04870', NULL, NULL, 'Moulting cycle', NULL, 'Moulting_cycle', NULL, NULL, 5852, 9),
(257582, NULL, 'PF17864', NULL, NULL, 'RuvB AAA lid domain', NULL, 'AAA_lid_4', NULL, NULL, 30070, 9),
(257583, NULL, 'PF03180', NULL, NULL, 'NlpA lipoprotein', NULL, 'Lipoprotein_9', NULL, NULL, 7183, 9),
(257584, NULL, 'PF02241', NULL, NULL, 'Methyl-coenzyme M reductase beta subunit, C-terminal domain', NULL, 'MCR_beta', NULL, NULL, 16968, 9),
(257585, NULL, 'PF20181', NULL, NULL, 'Family of unknown function (DUF6544)', NULL, 'DUF6544', NULL, NULL, 37249, 9),
(257586, NULL, 'PF12635', NULL, NULL, 'Protein of unknown function (DUF3780)', NULL, 'DUF3780', NULL, NULL, 20516, 9),
(257587, NULL, 'PF09157', NULL, NULL, 'Pseudouridine synthase II TruB, C-terminal', NULL, 'TruB-C_2', NULL, NULL, 12272, 9),
(257588, NULL, 'PF14818', NULL, NULL, 'Domain of unknown function (DUF4482)', NULL, 'DUF4482', NULL, NULL, 25927, 9),
(257589, NULL, 'PF09891', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2118)', NULL, 'DUF2118', NULL, NULL, 19053, 9),
(257590, NULL, 'PF17019', NULL, NULL, 'Domain of unknown function (DUF5096)', NULL, 'DUF5096', NULL, NULL, 22947, 9),
(257591, NULL, 'PF10547', NULL, NULL, 'P22_AR N-terminal domain', NULL, 'P22_AR_N', NULL, NULL, 20796, 9),
(257592, NULL, 'PF14892', NULL, NULL, 'Domain of unknown function (DUF4490)', NULL, 'DUF4490', NULL, NULL, 23077, 9),
(257593, NULL, 'PF07790', NULL, NULL, 'Archaeal Type IV pilin, N-terminal', NULL, 'Pilin_N', NULL, NULL, 12030, 9),
(257594, NULL, 'PF17632', NULL, NULL, 'Family of unknown function (DUF5513)', NULL, 'DUF5513', NULL, NULL, 21496, 9),
(257595, NULL, 'PF19781', NULL, NULL, 'Family of unknown function (DUF6266)', NULL, 'DUF6266', NULL, NULL, 37335, 9),
(257596, NULL, 'PF08707', NULL, NULL, 'Primase C terminal 2 (PriCT-2)', NULL, 'PriCT_2', NULL, NULL, 11617, 9),
(257597, NULL, 'PF15932', NULL, NULL, 'Domain of unknown function (DUF4748)', NULL, 'DUF4748', NULL, NULL, 25890, 9),
(257598, NULL, 'PF20224', NULL, NULL, 'Family of unknown function (DUF6583)', NULL, 'DUF6583', NULL, NULL, 37635, 9),
(257599, NULL, 'PF01595', NULL, NULL, 'Cyclin M transmembrane N-terminal domain', NULL, 'CNNM', NULL, NULL, 1706, 9),
(257600, NULL, 'PF12623', NULL, NULL, 'RNA repair, ligase-Pnkp-associating, region of Hen1', NULL, 'Hen1_L', NULL, NULL, 17894, 9),
(257601, NULL, 'PF01630', NULL, NULL, 'Hyaluronidase', NULL, 'Glyco_hydro_56', NULL, NULL, 13551, 9),
(257602, NULL, 'PF03742', NULL, NULL, 'PetN', NULL, 'PetN', NULL, NULL, 940, 9),
(257603, NULL, 'PF17073', NULL, NULL, 'Two-component-system connector protein', NULL, 'SafA', NULL, NULL, 23965, 9),
(257604, NULL, 'PF05710', NULL, NULL, 'Coiled coil', NULL, 'Coiled', NULL, NULL, 12023, 9),
(257605, NULL, 'PF11038', NULL, NULL, 'Dispersed gene family protein 1 of Trypanosoma cruzi region 5', NULL, 'DGF-1_5', NULL, NULL, 17558, 9),
(257606, NULL, 'PF12861', NULL, NULL, 'Anaphase-promoting complex subunit 11 RING-H2 finger', NULL, 'zf-ANAPC11', NULL, NULL, 22992, 9),
(257607, NULL, 'PF18239', NULL, NULL, 'Hemagglutinin I', NULL, 'HA1', NULL, NULL, 32668, 9),
(257608, NULL, 'PF05091', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit 7 (eIF-3)', NULL, 'eIF-3_zeta', NULL, NULL, 2197, 9),
(257609, NULL, 'PF01479', NULL, NULL, 'S4 domain', NULL, 'S4', NULL, NULL, 6765, 9),
(257610, NULL, 'PF17868', NULL, NULL, 'AAA lid domain', NULL, 'AAA_lid_8', NULL, NULL, 29662, 9),
(257611, NULL, 'PF16871', NULL, NULL, 'Domain of unknown function (DUF5077)', NULL, 'DUF5077', NULL, NULL, 24392, 9),
(257612, NULL, 'PF16461', NULL, NULL, 'Lambda phage tail tube protein, TTP', NULL, 'Phage_TTP_12', NULL, NULL, 22152, 9),
(257613, NULL, 'PF18805', NULL, NULL, 'Leucine-rich repeat', NULL, 'LRR_10', NULL, NULL, 29256, 9),
(257614, NULL, 'PF09196', NULL, NULL, 'Domain of unknown function (DUF1953)', NULL, 'DUF1953', NULL, NULL, 12182, 9),
(257615, NULL, 'PF13237', NULL, NULL, '4Fe-4S dicluster domain', NULL, 'Fer4_10', NULL, NULL, 12567, 9),
(257616, NULL, 'PF01465', NULL, NULL, 'GRIP domain', NULL, 'GRIP', NULL, NULL, 672, 9);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(257617, NULL, 'PF06416', NULL, NULL, 'Effector protein NleG', NULL, 'T3SS_NleG', NULL, NULL, 10173, 9),
(257618, NULL, 'PF17049', NULL, NULL, 'ATPase expression protein 1', NULL, 'AEP1', NULL, NULL, 26512, 9),
(257619, NULL, 'PF16863', NULL, NULL, 'N-terminal barrel of NtMGAM and CtMGAM, maltase-glucoamylase', NULL, 'NtCtMGAM_N', NULL, NULL, 25906, 9),
(257620, NULL, 'PF18265', NULL, NULL, 'Nas2 N_terminal domain', NULL, 'Nas2_N', NULL, NULL, 29270, 9),
(257621, NULL, 'PF09253', NULL, NULL, 'Pollen allergen Ole e 6', NULL, 'Ole_e_6', NULL, NULL, 13442, 9),
(257622, NULL, 'PF19130', NULL, NULL, 'Family of unknown function (DUF5813)', NULL, 'DUF5813', NULL, NULL, 34112, 9),
(257623, NULL, 'PF00221', NULL, NULL, 'Aromatic amino acid lyase', NULL, 'Lyase_aromatic', NULL, NULL, 2427, 9),
(257624, NULL, 'PF19690', NULL, NULL, 'Family of unknown function (DUF6191)', NULL, 'DUF6191', NULL, NULL, 33733, 9),
(257625, NULL, 'PF15054', NULL, NULL, 'Domain of unknown function (DUF4535)', NULL, 'DUF4535', NULL, NULL, 25896, 9),
(257626, NULL, 'PF08606', NULL, NULL, 'Prp19/Pso4-like', NULL, 'Prp19', NULL, NULL, 17625, 9),
(257627, NULL, 'PF07052', NULL, NULL, 'Hepatocellular carcinoma-associated antigen 59', NULL, 'Hep_59', NULL, NULL, 9590, 9),
(257628, NULL, 'PF11568', NULL, NULL, 'Mediator complex subunit 29', NULL, 'Med29', NULL, NULL, 15200, 9),
(257629, NULL, 'PF19746', NULL, NULL, 'Family of unknown function (DUF6233)', NULL, 'DUF6233', NULL, NULL, 37390, 9),
(257630, NULL, 'PF14540', NULL, NULL, 'Nucleotidyltransferase-like', NULL, 'NTF-like', NULL, NULL, 23672, 9),
(257631, NULL, 'PF08821', NULL, NULL, 'CGGC domain', NULL, 'CGGC', NULL, NULL, 14266, 9),
(257632, NULL, 'PF01616', NULL, NULL, 'Orbivirus NS3', NULL, 'Orbi_NS3', NULL, NULL, 1640, 9),
(257633, NULL, 'PF00644', NULL, NULL, 'Poly(ADP-ribose) polymerase catalytic domain', NULL, 'PARP', NULL, NULL, 11770, 9),
(257634, NULL, 'PF00969', NULL, NULL, 'Class II histocompatibility antigen, beta domain', NULL, 'MHC_II_beta', NULL, NULL, 4755, 9),
(257635, NULL, 'PF12084', NULL, NULL, 'Protein of unknown function (DUF3561)', NULL, 'DUF3561', NULL, NULL, 16718, 9),
(257636, NULL, 'PF16176', NULL, NULL, 'T-box transcription factor-associated', NULL, 'T-box_assoc', NULL, NULL, 23299, 9),
(257637, NULL, 'PF17807', NULL, NULL, 'Variant UBP zinc finger', NULL, 'zf-UBP_var', NULL, NULL, 30877, 9),
(257638, NULL, 'PF00927', NULL, NULL, 'Transglutaminase family, C-terminal ig like domain', NULL, 'Transglut_C', NULL, NULL, 8502, 9),
(257639, NULL, 'PF18585', NULL, NULL, 'Chromatin remodeling factor Mit1 C-terminal Zn finger 2', NULL, 'zf-CCCH_6', NULL, NULL, 29158, 9),
(257640, NULL, 'PF13448', NULL, NULL, 'Domain of unknown function (DUF4114)', NULL, 'DUF4114', NULL, NULL, 22677, 9),
(257641, NULL, 'PF01157', NULL, NULL, 'Ribosomal protein L21e', NULL, 'Ribosomal_L21e', NULL, NULL, 1342, 9),
(257642, NULL, 'PF01197', NULL, NULL, 'Ribosomal protein L31', NULL, 'Ribosomal_L31', NULL, NULL, 5403, 9),
(257643, NULL, 'PF00747', NULL, NULL, 'ssDNA binding protein', NULL, 'Viral_DNA_bp', NULL, NULL, 5704, 9),
(257644, NULL, 'PF02926', NULL, NULL, 'THUMP domain', NULL, 'THUMP', NULL, NULL, 1542, 9),
(257645, NULL, 'PF19979', NULL, NULL, 'Family of unknown function (DUF6415)', NULL, 'DUF6415', NULL, NULL, 37658, 9),
(257646, NULL, 'PF01351', NULL, NULL, 'Ribonuclease HII', NULL, 'RNase_HII', NULL, NULL, 21554, 9),
(257647, NULL, 'PF06813', NULL, NULL, 'Nodulin-like', NULL, 'Nodulin-like', NULL, NULL, 9326, 9),
(257648, NULL, 'PF12689', NULL, NULL, 'Acid Phosphatase', NULL, 'Acid_PPase', NULL, NULL, 5183, 9),
(257649, NULL, 'PF18880', NULL, NULL, 'Uracil-DNA glycosylase inhibitor', NULL, 'UDI', NULL, NULL, 35108, 9),
(257650, NULL, 'PF01488', NULL, NULL, 'Shikimate / quinate 5-dehydrogenase', NULL, 'Shikimate_DH', NULL, NULL, 10496, 9),
(257651, NULL, 'PF19218', NULL, NULL, 'Coronavirus replicase NSP3, C-terminal', NULL, 'CoV_NSP3_C', NULL, NULL, 35912, 9),
(257652, NULL, 'PF17012', NULL, NULL, 'Domain of unknown function (DUF5091)', NULL, 'DUF5091', NULL, NULL, 22658, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(257653, NULL, 'PF09661', NULL, NULL, 'Protein of unknown function (DUF2398)', NULL, 'DUF2398', NULL, NULL, 10234, 9),
(257654, NULL, 'PF00010', NULL, NULL, 'Helix-loop-helix DNA-binding domain', NULL, 'HLH', NULL, NULL, 8133, 9),
(257655, NULL, 'PF15530', NULL, NULL, 'Bacterial toxin 25', NULL, 'Ntox25', NULL, NULL, 23729, 9),
(257656, NULL, 'PF12459', NULL, NULL, 'D-Ala-teichoic acid biosynthesis protein', NULL, 'DUF3687', NULL, NULL, 15169, 9),
(257657, NULL, 'PF03983', NULL, NULL, 'SLA1 homology domain 1, SHD1', NULL, 'SHD1', NULL, NULL, 433, 9),
(257658, NULL, 'PF07100', NULL, NULL, 'Anabaena sensory rhodopsin transducer', NULL, 'ASRT', NULL, NULL, 13433, 9),
(257659, NULL, 'PF18999', NULL, NULL, 'Family of unknown function (DUF5728)', NULL, 'DUF5728', NULL, NULL, 35306, 9),
(257660, NULL, 'PF00432', NULL, NULL, 'Prenyltransferase and squalene oxidase repeat', NULL, 'Prenyltrans', NULL, NULL, 2231, 9),
(257661, NULL, 'PF20259', NULL, NULL, 'tRNA methyl transferase PRC-barrel domain', NULL, 'tRNA_Me_trans_M', NULL, NULL, 34391, 9),
(257662, NULL, 'PF19334', NULL, NULL, 'Domain of unknown function (DUF5920)', NULL, 'DUF5920', NULL, NULL, 34100, 9),
(257663, NULL, 'PF07600', NULL, NULL, 'Protein of unknown function (DUF1564)', NULL, 'DUF1564', NULL, NULL, 13917, 9),
(257664, NULL, 'PF15547', NULL, NULL, 'Steroid receptor-associated and regulated protein', NULL, 'C1ORF64', NULL, NULL, 25912, 9),
(257665, NULL, 'PF01395', NULL, NULL, 'PBP/GOBP family', NULL, 'PBP_GOBP', NULL, NULL, 10317, 9),
(257666, NULL, 'PF17083', NULL, NULL, 'Nucleolar protein Swm2', NULL, 'Swm2', NULL, NULL, 24455, 9),
(257667, NULL, 'PF01697', NULL, NULL, 'Glycosyltransferase family 92', NULL, 'Glyco_transf_92', NULL, NULL, 7248, 9),
(257668, NULL, 'PF03746', NULL, NULL, 'LamB/YcsF family', NULL, 'LamB_YcsF', NULL, NULL, 616, 9),
(257669, NULL, 'PF05398', NULL, NULL, 'PufQ cytochrome subunit', NULL, 'PufQ', NULL, NULL, 13714, 9),
(257670, NULL, 'PF11607', NULL, NULL, 'Protein of unknown function (DUF3247)', NULL, 'DUF3247', NULL, NULL, 18536, 9),
(257671, NULL, 'PF18544', NULL, NULL, 'Polo box domain', NULL, 'Polo_box_3', NULL, NULL, 28420, 9),
(257672, NULL, 'PF11533', NULL, NULL, 'Protein of unknown function (DUF3225)', NULL, 'DUF3225', NULL, NULL, 24270, 9),
(257673, NULL, 'PF11990', NULL, NULL, 'Protein of unknown function (DUF3487)', NULL, 'DUF3487', NULL, NULL, 19601, 9),
(257674, NULL, 'PF10946', NULL, NULL, 'Protein of unknown function DUF2625', NULL, 'DUF2625', NULL, NULL, 17836, 9),
(257675, NULL, 'PF08771', NULL, NULL, 'FKBP12-rapamycin binding domain', NULL, 'FRB_dom', NULL, NULL, 6014, 9),
(257676, NULL, 'PF14796', NULL, NULL, 'Clathrin-adaptor complex-3 beta-1 subunit C-terminal', NULL, 'AP3B1_C', NULL, NULL, 24620, 9),
(257677, NULL, 'PF03171', NULL, NULL, '2OG-Fe(II) oxygenase superfamily', NULL, '2OG-FeII_Oxy', NULL, NULL, 36348, 9),
(257678, NULL, 'PF01831', NULL, NULL, 'Peptidase C16 family', NULL, 'Peptidase_C16', NULL, NULL, 3895, 9),
(257679, NULL, 'PF14871', NULL, NULL, 'Hypothetical glycosyl hydrolase 6', NULL, 'GHL6', NULL, NULL, 22451, 9),
(257680, NULL, 'PF00223', NULL, NULL, 'Photosystem I psaA/psaB protein', NULL, 'PsaA_PsaB', NULL, NULL, 2036, 9),
(257681, NULL, 'PF13487', NULL, NULL, 'HD domain', NULL, 'HD_5', NULL, NULL, NULL, 9),
(257682, NULL, 'PF01977', NULL, NULL, '3-octaprenyl-4-hydroxybenzoate carboxy-lyase', NULL, 'UbiD', NULL, NULL, 5300, 9),
(257683, NULL, 'PF17889', NULL, NULL, 'NLRC4 helical domain', NULL, 'NLRC4_HD', NULL, NULL, 27823, 9),
(257684, NULL, 'PF00412', NULL, NULL, 'LIM domain', NULL, 'LIM', NULL, NULL, 4789, 9),
(257685, NULL, 'PF19784', NULL, NULL, 'Family of unknown function (DUF6269)', NULL, 'DUF6269', NULL, NULL, 37485, 9),
(257686, NULL, 'PF05485', NULL, NULL, 'THAP domain', NULL, 'THAP', NULL, NULL, 1288, 9),
(257687, NULL, 'PF07124', NULL, NULL, 'Phytoreovirus outer capsid protein P8', NULL, 'Phytoreo_P8', NULL, NULL, 13321, 9),
(257688, NULL, 'PF03765', NULL, NULL, 'CRAL/TRIO, N-terminal domain', NULL, 'CRAL_TRIO_N', NULL, NULL, 10040, 9),
(257689, NULL, 'PF02675', NULL, NULL, 'S-adenosylmethionine decarboxylase', NULL, 'AdoMet_dc', NULL, NULL, 3195, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(257690, NULL, 'PF07987', NULL, NULL, 'Domain of unkown function (DUF1775)', NULL, 'DUF1775', NULL, NULL, 12861, 9),
(257691, NULL, 'PF11536', NULL, NULL, 'Protein of unknown function (DUF3226)', NULL, 'DUF3226', NULL, NULL, 24100, 9),
(257692, NULL, 'PF20036', NULL, NULL, 'Major capsid protein 13-like', NULL, 'Gp13-like', NULL, NULL, 35659, 9),
(257693, NULL, 'PF00299', NULL, NULL, 'Squash family serine protease inhibitor', NULL, 'Squash', NULL, NULL, 6742, 9),
(257694, NULL, 'PF00780', NULL, NULL, 'CNH domain', NULL, 'CNH', NULL, NULL, 1114, 9),
(257695, NULL, 'PF05783', NULL, NULL, 'Dynein light intermediate chain (DLIC)', NULL, 'DLIC', NULL, NULL, 17305, 9),
(257696, NULL, 'PF06392', NULL, NULL, 'Acid shock protein repeat', NULL, 'Asr', NULL, NULL, 8005, 9),
(257697, NULL, 'PF03896', NULL, NULL, 'Translocon-associated protein (TRAP), alpha subunit', NULL, 'TRAP_alpha', NULL, NULL, 2805, 9),
(257698, NULL, 'PF02161', NULL, NULL, 'Progesterone receptor', NULL, 'Prog_receptor', NULL, NULL, 3560, 9),
(257699, NULL, 'PF10741', NULL, NULL, 'Type II secretion system (T2SS), protein M subtype b', NULL, 'T2SSM_b', NULL, NULL, 8819, 9),
(257700, NULL, 'PF09883', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2110)', NULL, 'DUF2110', NULL, NULL, 21062, 9),
(257701, NULL, 'PF20169', NULL, NULL, 'Family of unknown function (DUF6537)', NULL, 'DUF6537', NULL, NULL, 37227, 9),
(257702, NULL, 'PF07858', NULL, NULL, 'Limonene-1,2-epoxide hydrolase catalytic domain', NULL, 'LEH', NULL, NULL, 18839, 9),
(257703, NULL, 'PF11034', NULL, NULL, 'Glucose-repressible protein Grg1', NULL, 'Grg1', NULL, NULL, 12687, 9),
(257704, NULL, 'PF04191', NULL, NULL, 'Phospholipid methyltransferase', NULL, 'PEMT', NULL, NULL, 4992, 9),
(257705, NULL, 'PF06609', NULL, NULL, 'Fungal trichothecene efflux pump (TRI12)', NULL, 'TRI12', NULL, NULL, 8099, 9),
(257706, NULL, 'PF05297', NULL, NULL, 'Herpesvirus latent membrane protein 1 (LMP1)', NULL, 'Herpes_LMP1', NULL, NULL, 4436, 9),
(257707, NULL, 'PF10583', NULL, NULL, 'Involucrin of squamous epithelia N-terminus', NULL, 'Involucrin_N', NULL, NULL, 19212, 9),
(257708, NULL, 'PF20221', NULL, NULL, 'Family of unknown function (DUF6580)', NULL, 'DUF6580', NULL, NULL, 37522, 9),
(257709, NULL, 'PF04364', NULL, NULL, 'DNA polymerase III chi subunit, HolC', NULL, 'DNA_pol3_chi', NULL, NULL, 4647, 9),
(257710, NULL, 'PF03544', NULL, NULL, 'Gram-negative bacterial TonB protein C-terminal', NULL, 'TonB_C', NULL, NULL, 30855, 9),
(257711, NULL, 'PF17947', NULL, NULL, 'Four helical bundle domain', NULL, '4HB', NULL, NULL, 27635, 9),
(257712, NULL, 'PF00314', NULL, NULL, 'Thaumatin family', NULL, 'Thaumatin', NULL, NULL, 2232, 9),
(257713, NULL, 'PF16495', NULL, NULL, 'SWIRM-associated region 1', NULL, 'SWIRM-assoc_1', NULL, NULL, 24121, 9),
(257714, NULL, 'PF11126', NULL, NULL, 'Transcriptional regulator DsbA', NULL, 'Phage_DsbA', NULL, NULL, 19033, 9),
(257715, NULL, 'PF10677', NULL, NULL, 'Protein of unknown function (DUF2490)', NULL, 'DUF2490', NULL, NULL, 20353, 9),
(257716, NULL, 'PF10709', NULL, NULL, 'Protein of unknown function (DUF2511)', NULL, 'DUF2511', NULL, NULL, 20505, 9),
(257717, NULL, 'PF11701', NULL, NULL, 'Myosin-binding striated muscle assembly central', NULL, 'UNC45-central', NULL, NULL, 19416, 9),
(257718, NULL, 'PF11180', NULL, NULL, 'Protein of unknown function (DUF2968)', NULL, 'DUF2968', NULL, NULL, 18358, 9),
(257719, NULL, 'PF10840', NULL, NULL, 'Protein of unknown function (DUF2645)', NULL, 'DUF2645', NULL, NULL, 14881, 9),
(257720, NULL, 'PF17760', NULL, NULL, 'UvrA interaction domain', NULL, 'UvrA_inter', NULL, NULL, 28972, 9),
(257721, NULL, 'PF06802', NULL, NULL, 'Protein of unknown function (DUF1231)', NULL, 'DUF1231', NULL, NULL, 10972, 9),
(257722, NULL, 'PF09039', NULL, NULL, 'Mu DNA binding, I gamma subdomain', NULL, 'HTH_Tnp_Mu_2', NULL, NULL, 9767, 9),
(257723, NULL, 'PF05381', NULL, NULL, 'Tymovirus endopeptidase', NULL, 'Peptidase_C21', NULL, NULL, 5270, 9),
(257724, NULL, 'PF08454', NULL, NULL, 'RyR and IP3R Homology associated', NULL, 'RIH_assoc', NULL, NULL, 12325, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(257725, NULL, 'PF11077', NULL, NULL, 'Protein of unknown function (DUF2616)', NULL, 'DUF2616', NULL, NULL, 13789, 9),
(257726, NULL, 'PF19270', NULL, NULL, 'F-box only protein C-terminal region', NULL, 'FBO_C', NULL, NULL, 35595, 9),
(257727, NULL, 'PF05727', NULL, NULL, 'Uncharacterised protein family (UPF0228)', NULL, 'UPF0228', NULL, NULL, 7710, 9),
(257728, NULL, 'PF01928', NULL, NULL, 'CYTH domain', NULL, 'CYTH', NULL, NULL, 16550, 9),
(257729, NULL, 'PF07756', NULL, NULL, 'Protein of unknown function (DUF1612)', NULL, 'DUF1612', NULL, NULL, 10904, 9),
(257730, NULL, 'PF11364', NULL, NULL, 'Protein of unknown function (DUF3165)', NULL, 'DUF3165', NULL, NULL, 18902, 9),
(257731, NULL, 'PF09225', NULL, NULL, 'Restriction endonuclease PvuII', NULL, 'Endonuc-PvuII', NULL, NULL, 13036, 9),
(257732, NULL, 'PF13610', NULL, NULL, 'DDE domain', NULL, 'DDE_Tnp_IS240', NULL, NULL, 24006, 9),
(257733, NULL, 'PF00345', NULL, NULL, 'Pili and flagellar-assembly chaperone, PapD N-terminal domain', NULL, 'PapD_N', NULL, NULL, 11250, 9),
(257734, NULL, 'PF09917', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2147)', NULL, 'DUF2147', NULL, NULL, 19483, 9),
(257735, NULL, 'PF12441', NULL, NULL, 'CopG antitoxin of type II toxin-antitoxin system', NULL, 'CopG_antitoxin', NULL, NULL, 20620, 9),
(257736, NULL, 'PF15496', NULL, NULL, 'Domain of unknown function (DUF4646)', NULL, 'DUF4646', NULL, NULL, 23872, 9),
(257737, NULL, 'PF01635', NULL, NULL, 'Coronavirus M matrix/glycoprotein', NULL, 'CoV_M', NULL, NULL, 1683, 9),
(257738, NULL, 'PF09201', NULL, NULL, 'SRX, signal recognition particle receptor alpha subunit', NULL, 'SRX', NULL, NULL, 12363, 9),
(257739, NULL, 'PF19582', NULL, NULL, 'Solute-binding protein AdeT 1/2', NULL, 'AdeT1_2', NULL, NULL, 37248, 9),
(257740, NULL, 'PF04630', NULL, NULL, 'Phage tail tube protein', NULL, 'Phage_TTP_1', NULL, NULL, 2331, 9),
(257741, NULL, 'PF00607', NULL, NULL, 'gag protein p24 N-terminal domain', NULL, 'Gag_p24', NULL, NULL, 6775, 9),
(257742, NULL, 'PF03857', NULL, NULL, 'Colicin immunity protein', NULL, 'Colicin_im', NULL, NULL, 1903, 9),
(257743, NULL, 'PF10395', NULL, NULL, 'Utp8 family', NULL, 'Utp8', NULL, NULL, 20364, 9),
(257744, NULL, 'PF16859', NULL, NULL, 'Tetracyclin repressor-like, C-terminal domain', NULL, 'TetR_C_11', NULL, NULL, 10516, 9),
(257745, NULL, 'PF03064', NULL, NULL, 'HSV U79 / HCMV P34', NULL, 'U79_P34', NULL, NULL, 2531, 9),
(257746, NULL, 'PF08362', NULL, NULL, 'YcdC-like protein, C-terminal region', NULL, 'TetR_C_3', NULL, NULL, 13233, 9),
(257747, NULL, 'PF11389', NULL, NULL, 'Leptospira porin protein OmpL1', NULL, 'Porin_OmpL1', NULL, NULL, 15220, 9),
(257748, NULL, 'PF20349', NULL, NULL, 'Family of unknown function (DUF6644)', NULL, 'DUF6644', NULL, NULL, 33812, 9),
(257749, NULL, 'PF20426', NULL, NULL, 'Neurobeachin beta propeller domain', NULL, 'NBCH_WD40', NULL, NULL, 33907, 9),
(257750, NULL, 'PF01130', NULL, NULL, 'CD36 family', NULL, 'CD36', NULL, NULL, 270, 9),
(257751, NULL, 'PF02036', NULL, NULL, 'SCP-2 sterol transfer family', NULL, 'SCP2', NULL, NULL, 251, 9),
(257752, NULL, 'PF06094', NULL, NULL, 'Gamma-glutamyl cyclotransferase, AIG2-like', NULL, 'GGACT', NULL, NULL, 13569, 9),
(257753, NULL, 'PF09764', NULL, NULL, 'N-terminal glutamine amidase', NULL, 'Nt_Gln_amidase', NULL, NULL, 8613, 9),
(257754, NULL, 'PF03258', NULL, NULL, 'Baculovirus FP protein', NULL, 'Baculo_FP', NULL, NULL, 1728, 9),
(257755, NULL, 'PF16075', NULL, NULL, 'Domain of unknown function (DUF4815)', NULL, 'DUF4815', NULL, NULL, 24027, 9),
(257756, NULL, 'PF13872', NULL, NULL, 'P-loop containing NTP hydrolase pore-1', NULL, 'AAA_34', NULL, NULL, 32857, 9),
(257757, NULL, 'PF05265', NULL, NULL, 'Protein of unknown function (DUF723)', NULL, 'DUF723', NULL, NULL, 4255, 9),
(257758, NULL, 'PF14934', NULL, NULL, 'Transmembrane protein 254', NULL, 'TMEM254', NULL, NULL, 24803, 9),
(257759, NULL, 'PF02393', NULL, NULL, 'US22 like', NULL, 'US22', NULL, NULL, 4415, 9),
(257760, NULL, 'PF04054', NULL, NULL, 'CCR4-Not complex component, Not1', NULL, 'Not1', NULL, NULL, 1205, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(257761, NULL, 'PF13978', NULL, NULL, 'Protein of unknown function (DUF4223)', NULL, 'DUF4223', NULL, NULL, 22118, 9),
(257762, NULL, 'PF03959', NULL, NULL, 'Serine hydrolase (FSH1)', NULL, 'FSH1', NULL, NULL, 2690, 9),
(257763, NULL, 'PF04577', NULL, NULL, 'Glycosyltransferase 61', NULL, 'Glyco_transf_61', NULL, NULL, 139, 9),
(257764, NULL, 'PF08997', NULL, NULL, 'Ubiquinol-cytochrome C reductase complex, 6.4kD protein', NULL, 'UCR_6-4kD', NULL, NULL, 8534, 9),
(257765, NULL, 'PF10732', NULL, NULL, 'Protein of unknown function (DUF2524)', NULL, 'DUF2524', NULL, NULL, 21022, 9),
(257766, NULL, 'PF17751', NULL, NULL, 'SKICH domain', NULL, 'SKICH', NULL, NULL, 30582, 9),
(257767, NULL, 'PF05701', NULL, NULL, 'Weak chloroplast movement under blue light', NULL, 'WEMBL', NULL, NULL, 13443, 9),
(257768, NULL, 'PF07352', NULL, NULL, 'Bacteriophage Mu Gam like protein', NULL, 'Phage_Mu_Gam', NULL, NULL, 8456, 9),
(257769, NULL, 'PF10496', NULL, NULL, 'SNARE-complex protein Syntaxin-18 N-terminus', NULL, 'Syntaxin-18_N', NULL, NULL, 19394, 9),
(257770, NULL, 'PF02985', NULL, NULL, 'HEAT repeat', NULL, 'HEAT', NULL, NULL, 4571, 9),
(257771, NULL, 'PF10657', NULL, NULL, 'Photosystem P840 reaction centre protein PscD', NULL, 'RC-P840_PscD', NULL, NULL, 20127, 9),
(257772, NULL, 'PF11053', NULL, NULL, 'Terminase DNA packaging enzyme', NULL, 'DNA_Packaging', NULL, NULL, 19805, 9),
(257773, NULL, 'PF16627', NULL, NULL, 'Unstructured region between BRX_N and BRX domain', NULL, 'BRX_assoc', NULL, NULL, NULL, 9),
(257774, NULL, 'PF03165', NULL, NULL, 'MH1 domain', NULL, 'MH1', NULL, NULL, 503, 9),
(257775, NULL, 'PF20028', NULL, NULL, 'vWA-MoxR associated protein C-terminal domain', NULL, 'VMAP-C', NULL, NULL, 37399, 9),
(257776, NULL, 'PF01913', NULL, NULL, 'Formylmethanofuran-tetrahydromethanopterin formyltransferase', NULL, 'FTR', NULL, NULL, 16593, 9),
(257777, NULL, 'PF07325', NULL, NULL, 'Curtovirus V2 protein', NULL, 'Curto_V2', NULL, NULL, 8182, 9),
(257778, NULL, 'PF19499', NULL, NULL, 'Family of unknown function (DUF6034)', NULL, 'DUF6034', NULL, NULL, 36940, 9),
(257779, NULL, 'PF07496', NULL, NULL, 'CW-type Zinc Finger', NULL, 'zf-CW', NULL, NULL, 11360, 9),
(257780, NULL, 'PF03881', NULL, NULL, 'Fructosamine kinase', NULL, 'Fructosamin_kin', NULL, NULL, 15430, 9),
(257781, NULL, 'PF06761', NULL, NULL, 'Intracellular multiplication and human macrophage-killing', NULL, 'IcmF-related', NULL, NULL, 1880, 9),
(257782, NULL, 'PF12793', NULL, NULL, 'Sugar transport-related sRNA regulator N-term', NULL, 'SgrR_N', NULL, NULL, 26244, 9),
(257783, NULL, 'PF16552', NULL, NULL, 'D-ornithine 4,5-aminomutase alpha-subunit', NULL, 'OAM_alpha', NULL, NULL, 9750, 9),
(257784, NULL, 'PF08013', NULL, NULL, 'D-tagatose-1,6-bisphosphate aldolase subunit GatZ/KbaZ-like', NULL, 'GatZ_KbaZ-like', NULL, NULL, 12329, 9),
(257785, NULL, 'PF16214', NULL, NULL, 'Adenylyl cyclase N-terminal extracellular and transmembrane region', NULL, 'AC_N', NULL, NULL, 21902, 9),
(257786, NULL, 'PF05284', NULL, NULL, 'Protein of unknown function (DUF736)', NULL, 'DUF736', NULL, NULL, 4479, 9),
(257787, NULL, 'PF04061', NULL, NULL, 'ORMDL family', NULL, 'ORMDL', NULL, NULL, 1029, 9),
(257788, NULL, 'PF00631', NULL, NULL, 'GGL domain', NULL, 'G-gamma', NULL, NULL, 7554, 9),
(257789, NULL, 'PF02600', NULL, NULL, 'Disulfide bond formation protein DsbB', NULL, 'DsbB', NULL, NULL, 2200, 9),
(257790, NULL, 'PF09785', NULL, NULL, 'Prp31 C terminal domain', NULL, 'Prp31_C', NULL, NULL, 18080, 9),
(257791, NULL, 'PF00751', NULL, NULL, 'DM DNA binding domain', NULL, 'DM', NULL, NULL, 100, 9),
(257792, NULL, 'PF13860', NULL, NULL, 'FlgD Ig-like domain', NULL, 'FlgD_ig', NULL, NULL, 24386, 9),
(257793, NULL, 'PF06563', NULL, NULL, 'Protein of unknown function (DUF1125)', NULL, 'DUF1125', NULL, NULL, 9413, 9),
(257794, NULL, 'PF15557', NULL, NULL, 'CAF1 complex subunit p150, region binding to PCNA', NULL, 'CAF1-p150_N', NULL, NULL, 25341, 9),
(257795, NULL, 'PF01231', NULL, NULL, 'Indoleamine 2,3-dioxygenase', NULL, 'IDO', NULL, NULL, 3043, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(257796, NULL, 'PF02090', NULL, NULL, 'Salmonella surface presentation of antigen gene type M protein', NULL, 'SPAM', NULL, NULL, 6768, 9),
(257797, NULL, 'PF18866', NULL, NULL, 'CxC7 like cysteine cluster associated with KDZ transposases', NULL, 'CxC7', NULL, NULL, 29118, 9),
(257798, NULL, 'PF16976', NULL, NULL, 'Flp pilus assembly protein RcpC/CpaB', NULL, 'RcpC', NULL, NULL, 26807, 9),
(257799, NULL, 'PF04939', NULL, NULL, 'Ribosome biogenesis regulatory protein (RRS1)', NULL, 'RRS1', NULL, NULL, 6833, 9),
(257800, NULL, 'PF09182', NULL, NULL, 'Bacterial purine repressor, N-terminal', NULL, 'PuR_N', NULL, NULL, 12489, 9),
(257801, NULL, 'PF16155', NULL, NULL, 'Domain of unknown function (DUF4863)', NULL, 'DUF4863', NULL, NULL, 26393, 9),
(257802, NULL, 'PF09999', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2240)', NULL, 'DUF2240', NULL, NULL, 17209, 9),
(257803, NULL, 'PF00485', NULL, NULL, 'Phosphoribulokinase / Uridine kinase family', NULL, 'PRK', NULL, NULL, 2581, 9),
(257804, NULL, 'PF15725', NULL, NULL, 'Renal cancer differentiation gene 1 protein', NULL, 'RCDG1', NULL, NULL, 26086, 9),
(257805, NULL, 'PF01874', NULL, NULL, 'ATP:dephospho-CoA triphosphoribosyl transferase', NULL, 'CitG', NULL, NULL, 3682, 9),
(257806, NULL, 'PF07422', NULL, NULL, 'Sexual stage antigen s48/45 domain', NULL, 's48_45', NULL, NULL, 11613, 9),
(257807, NULL, 'PF07517', NULL, NULL, 'SecA DEAD-like domain', NULL, 'SecA_DEAD', NULL, NULL, 11242, 9),
(257808, NULL, 'PF11525', NULL, NULL, 'Copper resistance protein K', NULL, 'CopK', NULL, NULL, 18963, 9),
(257809, NULL, 'PF11478', NULL, NULL, 'Antimicrobial chitin binding protein tachystatin B', NULL, 'Tachystatin_B', NULL, NULL, 14917, 9),
(257810, NULL, 'PF15949', NULL, NULL, 'Domain of unknown function (DUF4757)', NULL, 'DUF4757', NULL, NULL, 22054, 9),
(257811, NULL, 'PF12841', NULL, NULL, 'YvrJ protein family', NULL, 'YvrJ', NULL, NULL, 22483, 9),
(257812, NULL, 'PF00647', NULL, NULL, 'Elongation factor 1 gamma, conserved domain', NULL, 'EF1G', NULL, NULL, 5107, 9),
(257813, NULL, 'PF01559', NULL, NULL, 'Zein seed storage protein', NULL, 'Zein', NULL, NULL, 981, 9),
(257814, NULL, 'PF01653', NULL, NULL, 'NAD-dependent DNA ligase adenylation domain', NULL, 'DNA_ligase_aden', NULL, NULL, 12700, 9),
(257815, NULL, 'PF03995', NULL, NULL, 'Peptidase inhibitor family I36', NULL, 'Inhibitor_I36', NULL, NULL, NULL, 9),
(257816, NULL, 'PF04229', NULL, NULL, 'GrpB protein', NULL, 'GrpB', NULL, NULL, 5933, 9),
(257817, NULL, 'PF19873', NULL, NULL, 'Family of unknown function (DUF6346)', NULL, 'DUF6346', NULL, NULL, 36972, 9),
(257818, NULL, 'PF02903', NULL, NULL, 'Alpha amylase, N-terminal ig-like domain', NULL, 'Alpha-amylase_N', NULL, NULL, 2608, 9),
(257819, NULL, 'PF08116', NULL, NULL, 'PhTx neurotoxin family', NULL, 'Toxin_29', NULL, NULL, 10042, 9),
(257820, NULL, 'PF14794', NULL, NULL, 'Domain of unknown function (DUF4479)', NULL, 'DUF4479', NULL, NULL, 25641, 9),
(257821, NULL, 'PF06497', NULL, NULL, 'Baculovirus Ac102', NULL, 'Baculo_Ac102', NULL, NULL, 9192, 9),
(257822, NULL, 'PF00363', NULL, NULL, 'Casein', NULL, 'Casein', NULL, NULL, 5347, 9),
(257823, NULL, 'PF08167', NULL, NULL, 'rRNA processing/ribosome biogenesis', NULL, 'RIX1', NULL, NULL, 9457, 9),
(257824, NULL, 'PF10098', NULL, NULL, 'Uncharacterised protein conserved in bacteria (DUF2336)', NULL, 'DUF2336', NULL, NULL, 19915, 9),
(257825, NULL, 'PF14443', NULL, NULL, 'DBC1', NULL, 'DBC1', NULL, NULL, 21715, 9),
(257826, NULL, 'PF19647', NULL, NULL, 'Family of unknown function (DUF6150)', NULL, 'DUF6150', NULL, NULL, 37173, 9),
(257827, NULL, 'PF19408', NULL, NULL, 'PKD-like domain', NULL, 'PKD_6', NULL, NULL, 37156, 9),
(257828, NULL, 'PF04260', NULL, NULL, 'Protein of unknown function (DUF436)', NULL, 'DUF436', NULL, NULL, 4776, 9),
(257829, NULL, 'PF05187', NULL, NULL, 'Electron transfer flavoprotein-ubiquinone oxidoreductase, 4Fe-4S', NULL, 'ETF_QO', NULL, NULL, NULL, 9),
(257830, NULL, 'PF08381', NULL, NULL, 'Transcription factor regulating root and shoot growth via Pin3', NULL, 'BRX', NULL, NULL, 11946, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(257831, NULL, 'PF20248', NULL, NULL, 'Family of unknown function (DUF6603)', NULL, 'DUF6603', NULL, NULL, 37531, 9),
(257832, NULL, 'PF02130', NULL, NULL, 'Endoribonuclease YbeY', NULL, 'YbeY', NULL, NULL, 2117, 9),
(257833, NULL, 'PF17317', NULL, NULL, 'Mating hormone A-factor 1&2', NULL, 'MFA1_2', NULL, NULL, 31511, 9),
(257834, NULL, 'PF05858', NULL, NULL, 'Bovine immunodeficiency virus surface protein (SU)', NULL, 'BIV_Env', NULL, NULL, 8719, 9),
(257835, NULL, 'PF10198', NULL, NULL, 'Histone acetyltransferases subunit 3', NULL, 'Ada3', NULL, NULL, 15942, 9),
(257836, NULL, 'PF09314', NULL, NULL, 'Domain of unknown function (DUF1972)', NULL, 'DUF1972', NULL, NULL, 14472, 9),
(257837, NULL, 'PF13269', NULL, NULL, 'Protein of unknown function (DUF4060)', NULL, 'DUF4060', NULL, NULL, 22758, 9),
(257838, NULL, 'PF01237', NULL, NULL, 'Oxysterol-binding protein', NULL, 'Oxysterol_BP', NULL, NULL, 4244, 9),
(257839, NULL, 'PF04873', NULL, NULL, 'Ethylene insensitive 3', NULL, 'EIN3', NULL, NULL, 5580, 9),
(257840, NULL, 'PF02758', NULL, NULL, 'PAAD/DAPIN/Pyrin domain', NULL, 'PYRIN', NULL, NULL, 996, 9),
(257841, NULL, 'PF19712', NULL, NULL, 'Acylglycerol kinase C-terminal', NULL, 'AGK_C', NULL, NULL, 37389, 9),
(257842, NULL, 'PF11280', NULL, NULL, 'Protein of unknown function (DUF3081)', NULL, 'DUF3081', NULL, NULL, 18136, 9),
(257843, NULL, 'PF11997', NULL, NULL, 'Domain of unknown function (DUF3492)', NULL, 'DUF3492', NULL, NULL, 16682, 9),
(257844, NULL, 'PF14742', NULL, NULL, 'N-terminal domain of (some) glycogen debranching enzymes', NULL, 'GDE_N_bis', NULL, NULL, 23198, 9),
(257845, NULL, 'PF01437', NULL, NULL, 'Plexin repeat', NULL, 'PSI', NULL, NULL, 376, 9),
(257846, NULL, 'PF07806', NULL, NULL, 'Nodule-specific GRP repeat', NULL, 'Nod_GRP', NULL, NULL, 12977, 9),
(257847, NULL, 'PF10376', NULL, NULL, 'Double-strand recombination repair protein', NULL, 'Mei5', NULL, NULL, 21393, 9),
(257848, NULL, 'PF12589', NULL, NULL, 'Methyltransferase involved in Williams-Beuren syndrome', NULL, 'WBS_methylT', NULL, NULL, 21044, 9),
(257849, NULL, 'PF08345', NULL, NULL, 'Flagellar M-ring protein C-terminal', NULL, 'YscJ_FliF_C', NULL, NULL, 12853, 9),
(257850, NULL, 'PF13758', NULL, NULL, 'Prefoldin subunit', NULL, 'Prefoldin_3', NULL, NULL, 33657, 9),
(257851, NULL, 'PF04224', NULL, NULL, 'Protein of unknown function, DUF417', NULL, 'DUF417', NULL, NULL, 5769, 9),
(257852, NULL, 'PF18887', NULL, NULL, 'MBG domain', NULL, 'MBG_3', NULL, NULL, 35270, 9),
(257853, NULL, 'PF04957', NULL, NULL, 'Ribosome modulation factor', NULL, 'RMF', NULL, NULL, 6606, 9),
(257854, NULL, 'PF08918', NULL, NULL, 'PhoQ Sensor', NULL, 'PhoQ_Sensor', NULL, NULL, 7902, 9),
(257855, NULL, 'PF10471', NULL, NULL, 'Anaphase-promoting complex APC subunit CDC26', NULL, 'ANAPC_CDC26', NULL, NULL, 20781, 9),
(257856, NULL, 'PF11895', NULL, NULL, 'Fungal peroxidase extension region', NULL, 'Peroxidase_ext', NULL, NULL, 26708, 9),
(257857, NULL, 'PF12036', NULL, NULL, 'Protein of unknown function (DUF3522)', NULL, 'DUF3522', NULL, NULL, 19739, 9),
(257858, NULL, 'PF13124', NULL, NULL, 'Protein of unknown function (DUF3963)', NULL, 'DUF3963', NULL, NULL, 25736, 9),
(257859, NULL, 'PF15444', NULL, NULL, 'Transmembrane protein 247', NULL, 'TMEM247', NULL, NULL, 26876, 9),
(257860, NULL, 'PF13522', NULL, NULL, 'Glutamine amidotransferase domain', NULL, 'GATase_6', NULL, NULL, NULL, 9),
(257861, NULL, 'PF09848', NULL, NULL, 'Schlafen group 3, DNA/RNA helicase domain', NULL, 'DUF2075', NULL, NULL, 16811, 9),
(257862, NULL, 'PF18000', NULL, NULL, 'Type 2 DNA topoisomerase 6 subunit B C-terminal domain', NULL, 'Top6b_C', NULL, NULL, 27665, 9),
(257863, NULL, 'PF09177', NULL, NULL, 'Syntaxin 6, N-terminal', NULL, 'Syntaxin-6_N', NULL, NULL, 12167, 9),
(257864, NULL, 'PF12446', NULL, NULL, 'Protein of unknown function (DUF3682)', NULL, 'DUF3682', NULL, NULL, 20563, 9),
(257865, NULL, 'PF07181', NULL, NULL, 'VirC2 protein', NULL, 'VirC2', NULL, NULL, 13410, 9),
(257866, NULL, 'PF11158', NULL, NULL, 'Protein of unknown function (DUF2938)', NULL, 'DUF2938', NULL, NULL, 17809, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(257867, NULL, 'PF16813', NULL, NULL, 'CRISPR-associated protein Csn2 subfamily St', NULL, 'Cas_St_Csn2', NULL, NULL, 22059, 9),
(257868, NULL, 'PF08499', NULL, NULL, '3''5''-cyclic nucleotide phosphodiesterase N-terminal', NULL, 'PDEase_I_N', NULL, NULL, 13611, 9),
(257869, NULL, 'PF10365', NULL, NULL, 'Domain of unknown function (DUF2436)', NULL, 'DUF2436', NULL, NULL, 20466, 9),
(257870, NULL, 'PF07215', NULL, NULL, 'Protein of unknown function (DUF1419)', NULL, 'DUF1419', NULL, NULL, 14236, 9),
(257871, NULL, 'PF11374', NULL, NULL, 'Protein of unknown function (DUF3176)', NULL, 'DUF3176', NULL, NULL, 18806, 9),
(257872, NULL, 'PF00957', NULL, NULL, 'Synaptobrevin', NULL, 'Synaptobrevin', NULL, NULL, 35715, 9),
(257873, NULL, 'PF01833', NULL, NULL, 'IPT/TIG domain', NULL, 'TIG', NULL, NULL, 6185, 9),
(257874, NULL, 'PF14879', NULL, NULL, 'Domain of unknown function (DUF4489)', NULL, 'DUF4489', NULL, NULL, 24107, 9),
(257875, NULL, 'PF11066', NULL, NULL, 'Protein of unknown function (DUF2867)', NULL, 'DUF2867', NULL, NULL, 17618, 9),
(257876, NULL, 'PF20086', NULL, NULL, 'Family of unknown function (DUF6478)', NULL, 'DUF6478', NULL, NULL, 37091, 9),
(257877, NULL, 'PF07097', NULL, NULL, 'Protein of unknown function (DUF1359)', NULL, 'DUF1359', NULL, NULL, 10802, 9),
(257878, NULL, 'PF05940', NULL, NULL, 'NnrS protein', NULL, 'NnrS', NULL, NULL, 7537, 9),
(257879, NULL, 'PF06180', NULL, NULL, 'Cobalt chelatase (CbiK)', NULL, 'CbiK', NULL, NULL, 9102, 9),
(257880, NULL, 'PF16864', NULL, NULL, 'Dimerisation domain', NULL, 'Dimerisation2', NULL, NULL, 24088, 9),
(257881, NULL, 'PF08894', NULL, NULL, 'Protein of unknown function (DUF1838)', NULL, 'DUF1838', NULL, NULL, 7727, 9),
(257882, NULL, 'PF06235', NULL, NULL, 'NADH dehydrogenase subunit 4L (NAD4L)', NULL, 'NAD4L', NULL, NULL, 14178, 9),
(257883, NULL, 'PF13801', NULL, NULL, 'Heavy-metal resistance', NULL, 'Metal_resist', NULL, NULL, 24069, 9),
(257884, NULL, 'PF13996', NULL, NULL, 'YobH-like protein', NULL, 'YobH', NULL, NULL, 26165, 9),
(257885, NULL, 'PF13944', NULL, NULL, 'Calycin-like beta-barrel domain', NULL, 'Calycin_like', NULL, NULL, 22924, 9),
(257886, NULL, 'PF19589', NULL, NULL, 'Family of unknown function (DUF6095)', NULL, 'DUF6095', NULL, NULL, 36903, 9),
(257887, NULL, 'PF13757', NULL, NULL, 'Vault protein inter-alpha-trypsin domain', NULL, 'VIT_2', NULL, NULL, 13773, 9),
(257888, NULL, 'PF06166', NULL, NULL, 'Protein of unknown function (DUF979)', NULL, 'DUF979', NULL, NULL, 14025, 9),
(257889, NULL, 'PF09771', NULL, NULL, 'Transmembrane protein 188', NULL, 'Tmemb_18A', NULL, NULL, 18214, 9),
(257890, NULL, 'PF19939', NULL, NULL, 'Family of unknown function (DUF6401)', NULL, 'DUF6401', NULL, NULL, 36059, 9),
(257891, NULL, 'PF05275', NULL, NULL, 'Copper resistance protein B precursor (CopB)', NULL, 'CopB', NULL, NULL, 4485, 9),
(257892, NULL, 'PF06459', NULL, NULL, 'Ryanodine Receptor TM 4-6', NULL, 'RR_TM4-6', NULL, NULL, 9445, 9),
(257893, NULL, 'PF08962', NULL, NULL, 'Rv2632c-like', NULL, 'Rv2632c-like', NULL, NULL, 8831, 9),
(257894, NULL, 'PF04651', NULL, NULL, 'Poxvirus A12 protein', NULL, 'Pox_A12', NULL, NULL, 2803, 9),
(257895, NULL, 'PF02127', NULL, NULL, 'Aminopeptidase I zinc metalloprotease (M18)', NULL, 'Peptidase_M18', NULL, NULL, 4387, 9),
(257896, NULL, 'PF08018', NULL, NULL, 'Frog antimicrobial peptide', NULL, 'Antimicrobial_1', NULL, NULL, 12531, 9),
(257897, NULL, 'PF03663', NULL, NULL, 'Glycosyl hydrolase family 76', NULL, 'Glyco_hydro_76', NULL, NULL, 6996, 9),
(257898, NULL, 'PF02788', NULL, NULL, 'Ribulose bisphosphate carboxylase large chain, N-terminal domain', NULL, 'RuBisCO_large_N', NULL, NULL, 17550, 9),
(257899, NULL, 'PF15336', NULL, NULL, 'Autism susceptibility gene 2 protein', NULL, 'Auts2', NULL, NULL, 15715, 9),
(257900, NULL, 'PF01708', NULL, NULL, 'Geminivirus putative movement protein', NULL, 'Gemini_mov', NULL, NULL, 2680, 9),
(257901, NULL, 'PF09950', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2184)', NULL, 'DUF2184', NULL, NULL, 17668, 9),
(257902, NULL, 'PF04011', NULL, NULL, 'LemA family', NULL, 'LemA', NULL, NULL, 318, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(257903, NULL, 'PF04000', NULL, NULL, 'Sas10/Utp3/C1D family', NULL, 'Sas10_Utp3', NULL, NULL, 145, 9),
(257904, NULL, 'PF19317', NULL, NULL, 'Gag protein p24 C-terminal domain', NULL, 'Gag_p24_C', NULL, NULL, 35555, 9),
(257905, NULL, 'PF16801', NULL, NULL, 'Dimerisation domain of Male-specific-Lethal 1', NULL, 'MSL1_dimer', NULL, NULL, 22305, 9),
(257906, NULL, 'PF09580', NULL, NULL, 'Sporulation lipoprotein YhcN/YlaJ (Spore_YhcN_YlaJ)', NULL, 'Spore_YhcN_YlaJ', NULL, NULL, 16711, 9),
(257907, NULL, 'PF00639', NULL, NULL, 'PPIC-type PPIASE domain', NULL, 'Rotamase', NULL, NULL, 4912, 9),
(257908, NULL, 'PF08529', NULL, NULL, 'NusA N-terminal domain', NULL, 'NusA_N', NULL, NULL, 7702, 9),
(257909, NULL, 'PF05202', NULL, NULL, 'Recombinase Flp protein', NULL, 'Flp_C', NULL, NULL, 2687, 9),
(257910, NULL, 'PF13354', NULL, NULL, 'Beta-lactamase enzyme family', NULL, 'Beta-lactamase2', NULL, NULL, 34909, 9),
(257911, NULL, 'PF17096', NULL, NULL, 'Altered inheritance of mitochondria protein 3', NULL, 'AIM3', NULL, NULL, 24049, 9),
(257912, NULL, 'PF06524', NULL, NULL, 'NOA36 protein', NULL, 'NOA36', NULL, NULL, 14142, 9),
(257913, NULL, 'PF07588', NULL, NULL, 'Protein of unknown function (DUF1554)', NULL, 'DUF1554', NULL, NULL, 13580, 9),
(257914, NULL, 'PF06090', NULL, NULL, 'Inositol-pentakisphosphate 2-kinase', NULL, 'Ins_P5_2-kin', NULL, NULL, 13731, 9),
(257915, NULL, 'PF02988', NULL, NULL, 'Phospholipase A2 inhibitor', NULL, 'PLA2_inh', NULL, NULL, 1697, 9),
(257916, NULL, 'PF07067', NULL, NULL, 'Protein of unknown function (DUF1340)', NULL, 'DUF1340', NULL, NULL, 12721, 9),
(257917, NULL, 'PF14741', NULL, NULL, 'N-terminal glycosyl-hydrolase-114-associated domain', NULL, 'GH114_assoc', NULL, NULL, NULL, 9),
(257918, NULL, 'PF19816', NULL, NULL, 'Family of unknown function (DUF6299)', NULL, 'DUF6299', NULL, NULL, 37393, 9),
(257919, NULL, 'PF03909', NULL, NULL, 'BSD domain', NULL, 'BSD', NULL, NULL, 2915, 9),
(257920, NULL, 'PF16762', NULL, NULL, 'Ribbon-helix-helix domain', NULL, 'RHH_6', NULL, NULL, 22716, 9),
(257921, NULL, 'PF10546', NULL, NULL, 'P63C domain', NULL, 'P63C', NULL, NULL, 20681, 9),
(257922, NULL, 'PF11836', NULL, NULL, 'Phage tail tube protein, GTA-gp10', NULL, 'Phage_TAC_11', NULL, NULL, 19050, 9),
(257923, NULL, 'PF17920', NULL, NULL, 'Tetracyclin repressor-like, C-terminal domain', NULL, 'TetR_C_16', NULL, NULL, 29777, 9),
(257924, NULL, 'PF02643', NULL, NULL, 'Uncharacterized ACR, COG1430', NULL, 'DUF192', NULL, NULL, 6037, 9),
(257925, NULL, 'PF19675', NULL, NULL, 'Origin recognition complex subunit 3 insertion domain', NULL, 'ORC3_ins', NULL, NULL, 37058, 9),
(257926, NULL, 'PF15344', NULL, NULL, 'FAM217 family', NULL, 'FAM217', NULL, NULL, 26356, 9),
(257927, NULL, 'PF06084', NULL, NULL, 'Cytomegalovirus TRL10 protein', NULL, 'Cytomega_TRL10', NULL, NULL, 13953, 9),
(257928, NULL, 'PF15643', NULL, NULL, 'Papain fold toxin 2', NULL, 'Tox-PL-2', NULL, NULL, 24977, 9),
(257929, NULL, 'PF16678', NULL, NULL, 'HOIP UBA domain pair', NULL, 'HOIP-UBA', NULL, NULL, 26358, 9),
(257930, NULL, 'PF16465', NULL, NULL, 'Domain of unknown function (DUF5046)', NULL, 'DUF5046', NULL, NULL, 21601, 9),
(257931, NULL, 'PF16203', NULL, NULL, 'ERCC3/RAD25/XPB C-terminal helicase', NULL, 'ERCC3_RAD25_C', NULL, NULL, 26168, 9),
(257932, NULL, 'PF17651', NULL, NULL, 'RACo middle region', NULL, 'Raco_middle', NULL, NULL, 30214, 9),
(257933, NULL, 'PF12072', NULL, NULL, 'RNase Y N-terminal region', NULL, 'RNase_Y_N', NULL, NULL, 16565, 9),
(257934, NULL, 'PF14171', NULL, NULL, 'Toxin SpoIISA, type II toxin-antitoxin system', NULL, 'SpoIISA_toxin', NULL, NULL, 24417, 9),
(257935, NULL, 'PF11969', NULL, NULL, 'Scavenger mRNA decapping enzyme C-term binding', NULL, 'DcpS_C', NULL, NULL, NULL, 9),
(257936, NULL, 'PF13712', NULL, NULL, 'Glycosyltransferase like family', NULL, 'Glyco_tranf_2_5', NULL, NULL, NULL, 9),
(257937, NULL, 'PF18012', NULL, NULL, 'PH domain', NULL, 'PH_17', NULL, NULL, 30664, 9),
(257938, NULL, 'PF10610', NULL, NULL, 'Thin aggregative fimbriae synthesis protein', NULL, 'Tafi-CsgC', NULL, NULL, 10118, 9);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(257939, NULL, 'PF01951', NULL, NULL, 'Archease protein family (MTH1598/TM1083)', NULL, 'Archease', NULL, NULL, 16421, 9),
(257940, NULL, 'PF11183', NULL, NULL, 'Polymyxin resistance protein PmrD', NULL, 'PmrD', NULL, NULL, 34898, 9),
(257941, NULL, 'PF16239', NULL, NULL, 'Domain of unknown function (DUF4898)', NULL, 'DUF4898', NULL, NULL, 24390, 9),
(257942, NULL, 'PF16195', NULL, NULL, 'SUMO-activating enzyme subunit 2 C-terminus', NULL, 'UBA2_C', NULL, NULL, 22144, 9),
(257943, NULL, 'PF13039', NULL, NULL, 'Protein of unknown function (DUF3900)', NULL, 'DUF3900', NULL, NULL, 22653, 9),
(257944, NULL, 'PF17774', NULL, NULL, 'Putative RNA-binding domain in YlmH', NULL, 'YlmH_RBD', NULL, NULL, 27589, 9),
(257945, NULL, 'PF04682', NULL, NULL, 'Herpesvirus BTRF1 protein conserved region', NULL, 'Herpes_BTRF1', NULL, NULL, 3166, 9),
(257946, NULL, 'PF19039', NULL, NULL, 'ASK kinase PH domain', NULL, 'ASK_PH', NULL, NULL, 34545, 9),
(257947, NULL, 'PF04867', NULL, NULL, 'Protein of unknown function (DUF643)', NULL, 'DUF643', NULL, NULL, 5648, 9),
(257948, NULL, 'PF10495', NULL, NULL, 'Pericentrin-AKAP-450 domain of centrosomal targeting protein', NULL, 'PACT_coil_coil', NULL, NULL, 19058, 9),
(257949, NULL, 'PF02337', NULL, NULL, 'Retroviral GAG p10 protein', NULL, 'Gag_p10', NULL, NULL, 4150, 9),
(257950, NULL, 'PF08037', NULL, NULL, 'Attractin family', NULL, 'Attractin', NULL, NULL, 12932, 9),
(257951, NULL, 'PF09470', NULL, NULL, 'Telethonin protein', NULL, 'Telethonin', NULL, NULL, 17650, 9),
(257952, NULL, 'PF11359', NULL, NULL, 'Glycoprotein UL132', NULL, 'gpUL132', NULL, NULL, 15469, 9),
(257953, NULL, 'PF06992', NULL, NULL, 'Replication protein P', NULL, 'Phage_lambda_P', NULL, NULL, 12354, 9),
(257954, NULL, 'PF19013', NULL, NULL, 'Family of unknown function (DUF5742)', NULL, 'DUF5742', NULL, NULL, 35576, 9),
(257955, NULL, 'PF02426', NULL, NULL, 'Muconolactone delta-isomerase', NULL, 'MIase', NULL, NULL, 26510, 9),
(257956, NULL, 'PF05380', NULL, NULL, 'Pao retrotransposon peptidase', NULL, 'Peptidase_A17', NULL, NULL, 5252, 9),
(257957, NULL, 'PF04386', NULL, NULL, 'Stringent starvation protein B', NULL, 'SspB', NULL, NULL, 10356, 9),
(257958, NULL, 'PF15822', NULL, NULL, 'MAPK-interacting and spindle-stabilising protein-like', NULL, 'MISS', NULL, NULL, 25695, 9),
(257959, NULL, 'PF18847', NULL, NULL, 'Large polyvalent protein associated domain 29', NULL, 'LPD29', NULL, NULL, 29949, 9),
(257960, NULL, 'PF05251', NULL, NULL, 'Oligosaccharyltransferase subunit 5', NULL, 'Ost5', NULL, NULL, 3040, 9),
(257961, NULL, 'PF11022', NULL, NULL, 'ATP synthase subunit K', NULL, 'ATP19', NULL, NULL, 17519, 9),
(257962, NULL, 'PF19877', NULL, NULL, 'Family of unknown function (DUF6350)', NULL, 'DUF6350', NULL, NULL, 36764, 9),
(257963, NULL, 'PF12871', NULL, NULL, 'Pre-mRNA-splicing factor 38-associated hydrophilic C-term', NULL, 'PRP38_assoc', NULL, NULL, 20237, 9),
(257964, NULL, 'PF13663', NULL, NULL, 'Domain of unknown function (DUF4148)', NULL, 'DUF4148', NULL, NULL, 22491, 9),
(257965, NULL, 'PF03958', NULL, NULL, 'Bacterial type II/III secretion system short domain', NULL, 'Secretin_N', NULL, NULL, 2644, 9),
(257966, NULL, 'PF04857', NULL, NULL, 'CAF1 family ribonuclease', NULL, 'CAF1', NULL, NULL, 5744, 9),
(257967, NULL, 'PF11036', NULL, NULL, 'Virulence promoting factor', NULL, 'YqgB', NULL, NULL, 17994, 9),
(257968, NULL, 'PF07162', NULL, NULL, 'Ciliary basal body-associated, B9 protein', NULL, 'B9-C2', NULL, NULL, 10891, 9),
(257969, NULL, 'PF16636', NULL, NULL, 'Unstructured region on APC between APC_crr regions 5 and 6', NULL, 'APC_u15', NULL, NULL, NULL, 9),
(257970, NULL, 'PF14140', NULL, NULL, 'YpzI-like protein', NULL, 'YpzI', NULL, NULL, 26391, 9),
(257971, NULL, 'PF00901', NULL, NULL, 'Orbivirus outer capsid protein VP5', NULL, 'Orbi_VP5', NULL, NULL, 1969, 9),
(257972, NULL, 'PF12760', NULL, NULL, 'Transposase zinc-ribbon domain', NULL, 'Zn_Tnp_IS1595', NULL, NULL, 24453, 9),
(257973, NULL, 'PF19273', NULL, NULL, 'Exportin-5 family', NULL, 'Exportin-5', NULL, NULL, 34740, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(257974, NULL, 'PF04286', NULL, NULL, 'Protein of unknown function (DUF445)', NULL, 'DUF445', NULL, NULL, 5622, 9),
(257975, NULL, 'PF02685', NULL, NULL, 'Glucokinase', NULL, 'Glucokinase', NULL, NULL, 3388, 9),
(257976, NULL, 'PF17817', NULL, NULL, 'PDZ domain', NULL, 'PDZ_5', NULL, NULL, 28413, 9),
(257977, NULL, 'PF00266', NULL, NULL, 'Aminotransferase class-V', NULL, 'Aminotran_5', NULL, NULL, 1175, 9),
(257978, NULL, 'PF19146', NULL, NULL, 'Family of unknown function (DUF5828)', NULL, 'DUF5828', NULL, NULL, 34025, 9),
(257979, NULL, 'PF07371', NULL, NULL, 'Protein of unknown function (DUF1490)', NULL, 'DUF1490', NULL, NULL, 8234, 9),
(257980, NULL, 'PF03699', NULL, NULL, 'Uncharacterised protein family (UPF0182)', NULL, 'UPF0182', NULL, NULL, 6849, 9),
(257981, NULL, 'PF15578', NULL, NULL, 'Domain of unknown function (DUF4662)', NULL, 'DUF4662', NULL, NULL, 24971, 9),
(257982, NULL, 'PF15741', NULL, NULL, 'Ligand-dependent nuclear receptor-interacting factor 1', NULL, 'LRIF1', NULL, NULL, 21442, 9),
(257983, NULL, 'PF09006', NULL, NULL, 'Lung surfactant protein D coiled-coil trimerisation', NULL, 'Surfac_D-trimer', NULL, NULL, 8794, 9),
(257984, NULL, 'PF01469', NULL, NULL, 'Pentapeptide repeats (8 copies)', NULL, 'Pentapeptide_2', NULL, NULL, 7213, 9),
(257985, NULL, 'PF05568', NULL, NULL, 'African swine fever virus J13L protein', NULL, 'ASFV_J13L', NULL, NULL, 7845, 9),
(257986, NULL, 'PF07635', NULL, NULL, 'Planctomycete cytochrome C', NULL, 'PSCyt1', NULL, NULL, 13637, 9),
(257987, NULL, 'PF15884', NULL, NULL, 'MICOS complex subunit MIC13, QIL1', NULL, 'QIL1', NULL, NULL, 24093, 9),
(257988, NULL, 'PF02886', NULL, NULL, 'LBP / BPI / CETP family, C-terminal domain', NULL, 'LBP_BPI_CETP_C', NULL, NULL, 1966, 9),
(257989, NULL, 'PF05466', NULL, NULL, 'Brain acid soluble protein 1 (BASP1 protein)', NULL, 'BASP1', NULL, NULL, 8732, 9),
(257990, NULL, 'PF13954', NULL, NULL, 'PapC N-terminal domain', NULL, 'PapC_N', NULL, NULL, 21669, 9),
(257991, NULL, 'PF00633', NULL, NULL, 'Helix-hairpin-helix motif', NULL, 'HHH', NULL, NULL, 6894, 9),
(257992, NULL, 'PF16660', NULL, NULL, 'PHD finger protein 20-like protein 1', NULL, 'PHD20L1_u1', NULL, NULL, NULL, 9),
(257993, NULL, 'PF08914', NULL, NULL, 'Rap1 Myb domain', NULL, 'Myb_DNA-bind_2', NULL, NULL, 7828, 9),
(257994, NULL, 'PF08224', NULL, NULL, 'Domain of unknown function (DUF1719)', NULL, 'DUF1719', NULL, NULL, 17382, 9),
(257995, NULL, 'PF12638', NULL, NULL, 'Staygreen protein', NULL, 'Staygreen', NULL, NULL, 26617, 9),
(257996, NULL, 'PF01381', NULL, NULL, 'Helix-turn-helix', NULL, 'HTH_3', NULL, NULL, 2217, 9),
(257997, NULL, 'PF16975', NULL, NULL, 'Ly6/PLAUR domain-containing protein 6, Lypd6', NULL, 'UPAR_LY6_2', NULL, NULL, NULL, 9),
(257998, NULL, 'PF16907', NULL, NULL, 'Proline rich region of Caskin proteins', NULL, 'Caskin-Pro-rich', NULL, NULL, NULL, 9),
(257999, NULL, 'PF15881', NULL, NULL, 'Domain of unknown function (DUF4734)', NULL, 'DUF4734', NULL, NULL, 25920, 9),
(258000, NULL, 'PF11304', NULL, NULL, 'Protein of unknown function (DUF3106)', NULL, 'DUF3106', NULL, NULL, 18434, 9),
(258001, NULL, 'PF00358', NULL, NULL, 'phosphoenolpyruvate-dependent sugar phosphotransferase system, EIIA 1', NULL, 'PTS_EIIA_1', NULL, NULL, 1944, 9),
(258002, NULL, 'PF04832', NULL, NULL, 'SOUL heme-binding protein', NULL, 'SOUL', NULL, NULL, 4704, 9),
(258003, NULL, 'PF06871', NULL, NULL, 'TraH_2', NULL, 'TraH_2', NULL, NULL, 9043, 9),
(258004, NULL, 'PF17244', NULL, NULL, 'Cell division control protein 24, OB domain 3', NULL, 'CDC24_OB3', NULL, NULL, 8678, 9),
(258005, NULL, 'PF00297', NULL, NULL, 'Ribosomal protein L3', NULL, 'Ribosomal_L3', NULL, NULL, 5632, 9),
(258006, NULL, 'PF13742', NULL, NULL, 'OB-fold nucleic acid binding domain', NULL, 'tRNA_anti_2', NULL, NULL, 24139, 9),
(258007, NULL, 'PF17445', NULL, NULL, 'Mating factor A1', NULL, 'Mfa1', NULL, NULL, 27985, 9),
(258008, NULL, 'PF06333', NULL, NULL, 'Mediator complex subunit 13 C-terminal domain', NULL, 'Med13_C', NULL, NULL, 8008, 9),
(258009, NULL, 'PF14355', NULL, NULL, 'Abortive infection C-terminus', NULL, 'Abi_C', NULL, NULL, 23272, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(258010, NULL, 'PF00519', NULL, NULL, 'Papillomavirus helicase', NULL, 'PPV_E1_C', NULL, NULL, 1366, 9),
(258011, NULL, 'PF05178', NULL, NULL, 'KRI1-like family', NULL, 'Kri1', NULL, NULL, 19491, 9),
(258012, NULL, 'PF07807', NULL, NULL, 'RED-like protein C-terminal region', NULL, 'RED_C', NULL, NULL, 12732, 9),
(258013, NULL, 'PF09343', NULL, NULL, 'Conserved hypothetical protein 2217 (DUF2460)', NULL, 'DUF2460', NULL, NULL, 11929, 9),
(258014, NULL, 'PF02963', NULL, NULL, 'Restriction endonuclease EcoRI', NULL, 'EcoRI', NULL, NULL, 3902, 9),
(258015, NULL, 'PF05884', NULL, NULL, 'Interactor of ZYG-11', NULL, 'ZYG-11_interact', NULL, NULL, 13602, 9),
(258016, NULL, 'PF20305', NULL, NULL, 'prokaryotic YEATS domain', NULL, 'pYEATS', NULL, NULL, 33957, 9),
(258017, NULL, 'PF13595', NULL, NULL, 'Domain of unknown function (DUF4138)', NULL, 'DUF4138', NULL, NULL, 21364, 9),
(258018, NULL, 'PF06413', NULL, NULL, 'Neugrin', NULL, 'Neugrin', NULL, NULL, 10301, 9),
(258019, NULL, 'PF08579', NULL, NULL, 'Mitochondrial ribonuclease P subunit (RPM2)', NULL, 'RPM2', NULL, NULL, 17540, 9),
(258020, NULL, 'PF01843', NULL, NULL, 'DIL domain', NULL, 'DIL', NULL, NULL, 3661, 9),
(258021, NULL, 'PF19050', NULL, NULL, 'PhoD related phosphatase', NULL, 'PhoD_2', NULL, NULL, 35131, 9),
(258022, NULL, 'PF15396', NULL, NULL, 'Protein Family FAM60A', NULL, 'FAM60A', NULL, NULL, 24495, 9),
(258023, NULL, 'PF10842', NULL, NULL, 'Protein of unknown function (DUF2642)', NULL, 'DUF2642', NULL, NULL, 18676, 9),
(258024, NULL, 'PF20133', NULL, NULL, 'Protein HHL1-like', NULL, 'HHL1-like', NULL, NULL, 35870, 9),
(258025, NULL, 'PF02441', NULL, NULL, 'Flavoprotein', NULL, 'Flavoprotein', NULL, NULL, 4044, 9),
(258026, NULL, 'PF20102', NULL, NULL, 'Family of unknown function (DUF6492)', NULL, 'DUF6492', NULL, NULL, 37111, 9),
(258027, NULL, 'PF00486', NULL, NULL, 'Transcriptional regulatory protein, C terminal', NULL, 'Trans_reg_C', NULL, NULL, 4108, 9),
(258028, NULL, 'PF15231', NULL, NULL, 'Variable charge X/Y family', NULL, 'VCX_VCY', NULL, NULL, 24847, 9),
(258029, NULL, 'PF17875', NULL, NULL, 'RPA43 OB domain in RNA Pol I', NULL, 'RPA43_OB', NULL, NULL, 28996, 9),
(258030, NULL, 'PF10557', NULL, NULL, 'Cullin protein neddylation domain', NULL, 'Cullin_Nedd8', NULL, NULL, 19309, 9),
(258031, NULL, 'PF01736', NULL, NULL, 'Polyomavirus agnoprotein', NULL, 'Polyoma_agno', NULL, NULL, 2989, 9),
(258032, NULL, 'PF06258', NULL, NULL, 'Mitochondrial fission ELM1', NULL, 'Mito_fiss_Elm1', NULL, NULL, 14208, 9),
(258033, NULL, 'PF05776', NULL, NULL, 'Papillomavirus E5A protein', NULL, 'Papilloma_E5A', NULL, NULL, 12498, 9),
(258034, NULL, 'PF09080', NULL, NULL, 'K cyclin, C terminal', NULL, 'K-cyclin_vir_C', NULL, NULL, 9982, 9),
(258035, NULL, 'PF05256', NULL, NULL, 'Uncharacterised protein family (UPF0223)', NULL, 'UPF0223', NULL, NULL, 3143, 9),
(258036, NULL, 'PF11827', NULL, NULL, 'Protein of unknown function (DUF3347)', NULL, 'DUF3347', NULL, NULL, 19338, 9),
(258037, NULL, 'PF11473', NULL, NULL, 'RNA binding protein B2', NULL, 'B2', NULL, NULL, 22019, 9),
(258038, NULL, 'PF03022', NULL, NULL, 'Major royal jelly protein', NULL, 'MRJP', NULL, NULL, 19326, 9),
(258039, NULL, 'PF11181', NULL, NULL, 'Heat induced stress protein YflT domain', NULL, 'YflT', NULL, NULL, 24457, 9),
(258040, NULL, 'PF09791', NULL, NULL, 'Oxidoreductase-like protein, N-terminal', NULL, 'Oxidored-like', NULL, NULL, 18283, 9),
(258041, NULL, 'PF17036', NULL, NULL, 'Cellulose biosynthesis protein BcsS', NULL, 'CBP_BcsS', NULL, NULL, 22693, 9),
(258042, NULL, 'PF10109', NULL, NULL, 'Phage tail assembly chaperone proteins, E, or 41 or 14', NULL, 'Phage_TAC_7', NULL, NULL, 19752, 9),
(258043, NULL, 'PF18124', NULL, NULL, 'Kindlin-2 N-terminal domain', NULL, 'Kindlin_2_N', NULL, NULL, 29372, 9),
(258044, NULL, 'PF15644', NULL, NULL, 'Papain fold toxin 1, glutamine deamidase', NULL, 'Gln_amidase', NULL, NULL, 24983, 9),
(258045, NULL, 'PF18884', NULL, NULL, 'Bacterial TSP3 repeat', NULL, 'TSP3_bac', NULL, NULL, NULL, 9),
(258046, NULL, 'PF02053', NULL, NULL, 'Gene 66 (IR5) protein', NULL, 'Gene66', NULL, NULL, 3599, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(258047, NULL, 'PF15064', NULL, NULL, 'Cation channel sperm-associated protein subunit gamma', NULL, 'CATSPERG', NULL, NULL, 21770, 9),
(258048, NULL, 'PF15532', NULL, NULL, 'Bacterial toxin 30', NULL, 'Ntox30', NULL, NULL, 23835, 9),
(258049, NULL, 'PF01364', NULL, NULL, 'Peptidase family C25', NULL, 'Peptidase_C25', NULL, NULL, 3440, 9),
(258050, NULL, 'PF10189', NULL, NULL, 'Integrator complex subunit 3 N-terminal', NULL, 'Ints3_N', NULL, NULL, 14854, 9),
(258051, NULL, 'PF17290', NULL, NULL, 'Arenavirus nucleocapsid C-terminal domain', NULL, 'Arena_ncap_C', NULL, NULL, 28595, 9),
(258052, NULL, 'PF05421', NULL, NULL, 'Protein of unknown function (DUF751)', NULL, 'DUF751', NULL, NULL, 12270, 9),
(258053, NULL, 'PF13641', NULL, NULL, 'Glycosyltransferase like family 2', NULL, 'Glyco_tranf_2_3', NULL, NULL, NULL, 9),
(258054, NULL, 'PF14287', NULL, NULL, 'Domain of unknown function (DUF4368)', NULL, 'DUF4368', NULL, NULL, 21724, 9),
(258055, NULL, 'PF03347', NULL, NULL, 'Vibrio thermostable direct hemolysin', NULL, 'TDH', NULL, NULL, 537, 9),
(258056, NULL, 'PF08532', NULL, NULL, 'Beta-galactosidase trimerisation domain', NULL, 'Glyco_hydro_42M', NULL, NULL, 7518, 9),
(258057, NULL, 'PF01109', NULL, NULL, 'Granulocyte-macrophage colony-stimulating factor', NULL, 'GM_CSF', NULL, NULL, 6701, 9),
(258058, NULL, 'PF09422', NULL, NULL, 'WTX protein', NULL, 'WTX', NULL, NULL, 15530, 9),
(258059, NULL, 'PF16845', NULL, NULL, 'Aspartic acid proteinase inhibitor', NULL, 'SQAPI', NULL, NULL, 2507, 9),
(258060, NULL, 'PF20439', NULL, NULL, 'Sporulation stage IV protein A, C-terminal', NULL, 'SpoIVA_C', NULL, NULL, 33914, 9),
(258061, NULL, 'PF03483', NULL, NULL, 'B3/4 domain', NULL, 'B3_4', NULL, NULL, 4057, 9),
(258062, NULL, 'PF14301', NULL, NULL, 'Domain of unknown function (DUF4376)', NULL, 'DUF4376', NULL, NULL, 26214, 9),
(258063, NULL, 'PF11574', NULL, NULL, 'Resuscitation-promoting factor Rpf1, C-terminal', NULL, 'Rpf1_C', NULL, NULL, 18746, 9),
(258064, NULL, 'PF19376', NULL, NULL, 'Family of unknown function (DUF5951)', NULL, 'DUF5951', NULL, NULL, 36639, 9),
(258065, NULL, 'PF15894', NULL, NULL, 'Inhibitor of glucose uptake transporter SgrT', NULL, 'SgrT', NULL, NULL, 23875, 9),
(258066, NULL, 'PF04656', NULL, NULL, 'Pox virus E6 protein', NULL, 'Pox_E6', NULL, NULL, 2955, 9),
(258067, NULL, 'PF15335', NULL, NULL, 'Caspase activity and apoptosis inhibitor 1', NULL, 'CAAP1', NULL, NULL, 30515, 9),
(258068, NULL, 'PF17962', NULL, NULL, 'Bacterial macroglobulin domain 6', NULL, 'bMG6', NULL, NULL, 29876, 9),
(258069, NULL, 'PF06428', NULL, NULL, 'GDP/GTP exchange factor Sec2p', NULL, 'Sec2p', NULL, NULL, 9255, 9),
(258070, NULL, 'PF20460', NULL, NULL, 'Family of unknown function (DUF6713)', NULL, 'DUF6713', NULL, NULL, 37606, 9),
(258071, NULL, 'PF19569', NULL, NULL, 'START-like superfamily domain', NULL, 'START_2', NULL, NULL, 34333, 9),
(258072, NULL, 'PF03505', NULL, NULL, 'Clostridium enterotoxin', NULL, 'Clenterotox', NULL, NULL, 6059, 9),
(258073, NULL, 'PF03690', NULL, NULL, 'Uncharacterised protein family (UPF0160)', NULL, 'UPF0160', NULL, NULL, 2711, 9),
(258074, NULL, 'PF19214', NULL, NULL, 'Coronavirus spike glycoprotein S2, intravirion', NULL, 'CoV_S2_C', NULL, NULL, 34676, 9),
(258075, NULL, 'PF11806', NULL, NULL, 'Enterochelin esterase, N-terminal', NULL, 'Enterochelin_N', NULL, NULL, 19220, 9),
(258076, NULL, 'PF17323', NULL, NULL, 'Trans-membrane regulatory protein ToxS', NULL, 'ToxS', NULL, NULL, 31708, 9),
(258077, NULL, 'PF08630', NULL, NULL, 'Dfp1/Him1, central region', NULL, 'Dfp1_Him1_M', NULL, NULL, 14032, 9),
(258078, NULL, 'PF14500', NULL, NULL, 'Dos2-interacting transcription regulator of RNA-Pol-II', NULL, 'MMS19_N', NULL, NULL, 23246, 9),
(258079, NULL, 'PF18179', NULL, NULL, 'SMODS- and Ubiquitin system-associated 2TM effector domain', NULL, 'SUa-2TM', NULL, NULL, 29822, 9),
(258080, NULL, 'PF02250', NULL, NULL, '35kD major secreted virus protein', NULL, 'Orthopox_35kD', NULL, NULL, 1869, 9),
(258081, NULL, 'PF19638', NULL, NULL, 'Family of unknown function (DUF6141)', NULL, 'DUF6141', NULL, NULL, 37268, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(258082, NULL, 'PF01513', NULL, NULL, 'ATP-NAD kinase N-terminal domain', NULL, 'NAD_kinase', NULL, NULL, 815, 9),
(258083, NULL, 'PF04452', NULL, NULL, 'RNA methyltransferase domain', NULL, 'Methyltrans_RNA', NULL, NULL, 37768, 9),
(258084, NULL, 'PF15480', NULL, NULL, 'Domain of unknown function (DUF4640)', NULL, 'DUF4640', NULL, NULL, 23197, 9),
(258085, NULL, 'PF10325', NULL, NULL, 'Serpentine type 7TM GPCR chemoreceptor Srz', NULL, '7TM_GPCR_Srz', NULL, NULL, 19975, 9),
(258086, NULL, 'PF03711', NULL, NULL, 'Orn/Lys/Arg decarboxylase, C-terminal domain', NULL, 'OKR_DC_1_C', NULL, NULL, 9609, 9),
(258087, NULL, 'PF16901', NULL, NULL, 'C-terminal domain of alpha-glycerophosphate oxidase', NULL, 'DAO_C', NULL, NULL, 22805, 9),
(258088, NULL, 'PF08705', NULL, NULL, 'Gag protein p6', NULL, 'Gag_p6', NULL, NULL, 11650, 9),
(258089, NULL, 'PF01555', NULL, NULL, 'DNA methylase', NULL, 'N6_N4_Mtase', NULL, NULL, 6655, 9),
(258090, NULL, 'PF04471', NULL, NULL, 'Restriction endonuclease', NULL, 'Mrr_cat', NULL, NULL, 1468, 9),
(258091, NULL, 'PF17188', NULL, NULL, 'MucB/RseB C-terminal domain', NULL, 'MucB_RseB_C', NULL, NULL, 31805, 9),
(258092, NULL, 'PF08365', NULL, NULL, 'Insulin-like growth factor II E-peptide', NULL, 'IGF2_C', NULL, NULL, 11855, 9),
(258093, NULL, 'PF02219', NULL, NULL, 'Methylenetetrahydrofolate reductase', NULL, 'MTHFR', NULL, NULL, 1784, 9),
(258094, NULL, 'PF03435', NULL, NULL, 'Saccharopine dehydrogenase NADP binding domain', NULL, 'Sacchrp_dh_NADP', NULL, NULL, 10095, 9),
(258095, NULL, 'PF12355', NULL, NULL, 'Down syndrome cell adhesion molecule C terminal', NULL, 'Dscam_C', NULL, NULL, 15390, 9),
(258096, NULL, 'PF13130', NULL, NULL, 'Domain of unknown function (DUF3952)', NULL, 'DUF3952', NULL, NULL, 25600, 9),
(258097, NULL, 'PF09693', NULL, NULL, 'Phage uncharacterised protein (Phage_XkdX)', NULL, 'Phage_XkdX', NULL, NULL, 5338, 9),
(258098, NULL, 'PF15724', NULL, NULL, 'TMEM119 family', NULL, 'TMEM119', NULL, NULL, 25028, 9),
(258099, NULL, 'PF15745', NULL, NULL, 'AP-1 complex-associated regulatory protein', NULL, 'AP1AR', NULL, NULL, 23000, 9),
(258100, NULL, 'PF18474', NULL, NULL, 'Family of unknown function (DUF5614)', NULL, 'DUF5614', NULL, NULL, 28736, 9),
(258101, NULL, 'PF15483', NULL, NULL, 'Domain of unknown function (DUF4641)', NULL, 'DUF4641', NULL, NULL, 21587, 9),
(258102, NULL, 'PF17566', NULL, NULL, 'Family of unknown function (DUF5472)', NULL, 'DUF5472', NULL, NULL, 31113, 9),
(258103, NULL, 'PF05004', NULL, NULL, 'Interferon-related developmental regulator (IFRD)', NULL, 'IFRD', NULL, NULL, 1438, 9),
(258104, NULL, 'PF07516', NULL, NULL, 'SecA Wing and Scaffold domain', NULL, 'SecA_SW', NULL, NULL, 11105, 9),
(258105, NULL, 'PF10515', NULL, NULL, 'Beta-amyloid precursor protein C-terminus', NULL, 'APP_amyloid', NULL, NULL, 19020, 9),
(258106, NULL, 'PF01405', NULL, NULL, 'Photosystem II reaction centre T protein', NULL, 'PsbT', NULL, NULL, 3153, 9),
(258107, NULL, 'PF08154', NULL, NULL, 'NLE (NUC135) domain', NULL, 'NLE', NULL, NULL, 11682, 9),
(258108, NULL, 'PF03942', NULL, NULL, 'DTW domain', NULL, 'DTW', NULL, NULL, 2738, 9),
(258109, NULL, 'PF17167', NULL, NULL, 'Glycosyl hydrolase 36 superfamily, catalytic domain', NULL, 'Glyco_hydro_36', NULL, NULL, 32513, 9),
(258110, NULL, 'PF09552', NULL, NULL, 'BstXI restriction endonuclease', NULL, 'RE_BstXI', NULL, NULL, 15358, 9),
(258111, NULL, 'PF08985', NULL, NULL, 'DP-EP family', NULL, 'DP-EP', NULL, NULL, 8603, 9),
(258112, NULL, 'PF18988', NULL, NULL, 'Family of unknown function (DUF5721)', NULL, 'DUF5721', NULL, NULL, 36427, 9),
(258113, NULL, 'PF10303', NULL, NULL, 'Protein of unknown function (DUF2408)', NULL, 'DUF2408', NULL, NULL, 19585, 9),
(258114, NULL, 'PF15804', NULL, NULL, 'Coiled-coil domain-containing protein 168', NULL, 'CCDC168_N', NULL, NULL, 26211, 9),
(258115, NULL, 'PF00257', NULL, NULL, 'Dehydrin', NULL, 'Dehydrin', NULL, NULL, 1771, 9),
(258116, NULL, 'PF08986', NULL, NULL, 'Domain of unknown function (DUF1889)', NULL, 'DUF1889', NULL, NULL, 8885, 9),
(258117, NULL, 'PF10035', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2179)', NULL, 'DUF2179', NULL, NULL, 19580, 9);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(258118, NULL, 'PF19604', NULL, NULL, 'Family of unknown function (DUF6109)', NULL, 'DUF6109', NULL, NULL, 36559, 9),
(258119, NULL, 'PF09075', NULL, NULL, 'Heat-stable enterotoxin B, secretory', NULL, 'STb_secrete', NULL, NULL, 9927, 9),
(258120, NULL, 'PF16705', NULL, NULL, 'NUDIX, or N-terminal NPxY motif-rich,  region of KRIT', NULL, 'NUDIX_5', NULL, NULL, 23341, 9),
(258121, NULL, 'PF00743', NULL, NULL, 'Flavin-binding monooxygenase-like', NULL, 'FMO-like', NULL, NULL, 20358, 9),
(258122, NULL, 'PF18243', NULL, NULL, 'Metal-independent restriction enzyme BfiI DNA binding domain', NULL, 'BfiI_DBD', NULL, NULL, 28213, 9),
(258123, NULL, 'PF04940', NULL, NULL, 'Sensors of blue-light using FAD', NULL, 'BLUF', NULL, NULL, 6906, 9),
(258124, NULL, 'PF18869', NULL, NULL, 'RnaseLS-like HEPN', NULL, 'HEPN_RnaseLS', NULL, NULL, 27673, 9),
(258125, NULL, 'PF01291', NULL, NULL, 'LIF / OSM family', NULL, 'LIF_OSM', NULL, NULL, 5266, 9),
(258126, NULL, 'PF05784', NULL, NULL, 'Betaherpesvirus UL82/83 protein N terminus', NULL, 'Herpes_UL82_83', NULL, NULL, 12509, 9),
(258127, NULL, 'PF03276', NULL, NULL, 'Spumavirus gag protein', NULL, 'Gag_spuma', NULL, NULL, 2668, 9),
(258128, NULL, 'PF14406', NULL, NULL, 'Ribosomally synthesized peptide in Bacteroidetes', NULL, 'Bacteroid_pep', NULL, NULL, 24137, 9),
(258129, NULL, 'PF15223', NULL, NULL, 'Elongin BC and Polycomb repressive complex 2-associated protein', NULL, 'EPOP', NULL, NULL, 24229, 9),
(258130, NULL, 'PF17447', NULL, NULL, 'Uncharacterized YkpC-like', NULL, 'YkpC', NULL, NULL, 33077, 9),
(258131, NULL, 'PF02931', NULL, NULL, 'Neurotransmitter-gated ion-channel ligand binding domain', NULL, 'Neur_chan_LBD', NULL, NULL, 11405, 9),
(258132, NULL, 'PF08103', NULL, NULL, 'Uperin family', NULL, 'Antimicrobial_8', NULL, NULL, 12836, 9),
(258133, NULL, 'PF08662', NULL, NULL, 'Eukaryotic translation initiation factor eIF2A', NULL, 'eIF2A', NULL, NULL, 18733, 9),
(258134, NULL, 'PF14410', NULL, NULL, 'HNH/ENDO VII superfamily nuclease with conserved GHE residues', NULL, 'GH-E', NULL, NULL, 22443, 9),
(258135, NULL, 'PF16122', NULL, NULL, '40S ribosomal protein SA C-terminus', NULL, '40S_SA_C', NULL, NULL, 25379, 9),
(258136, NULL, 'PF16188', NULL, NULL, 'C-terminal region of peptidase_M24', NULL, 'Peptidase_M24_C', NULL, NULL, 25375, 9),
(258137, NULL, 'PF08095', NULL, NULL, 'Hefutoxin family', NULL, 'Toxin_25', NULL, NULL, 9950, 9),
(258138, NULL, 'PF03556', NULL, NULL, 'Cullin binding', NULL, 'Cullin_binding', NULL, NULL, 5221, 9),
(258139, NULL, 'PF04574', NULL, NULL, 'Protein of unknown function (DUF592)', NULL, 'DUF592', NULL, NULL, 474, 9),
(258140, NULL, 'PF06667', NULL, NULL, 'Phage shock protein B', NULL, 'PspB', NULL, NULL, 10430, 9),
(258141, NULL, 'PF05927', NULL, NULL, 'Penaeidin', NULL, 'Penaeidin', NULL, NULL, 12826, 9),
(258142, NULL, 'PF11870', NULL, NULL, 'Lactate utilisation protein B, C-terminal', NULL, 'LutB_C', NULL, NULL, 21921, 9),
(258143, NULL, 'PF11608', NULL, NULL, 'MARF1, RNA recognition motif 1', NULL, 'MARF1_RRM1', NULL, NULL, 5930, 9),
(258144, NULL, 'PF08046', NULL, NULL, 'IlvGEDA operon leader peptide', NULL, 'IlvGEDA_leader', NULL, NULL, 9203, 9),
(258145, NULL, 'PF12341', NULL, NULL, 'Minichromosome loss protein, Mcl1, middle region', NULL, 'Mcl1_mid', NULL, NULL, 20992, 9),
(258146, NULL, 'PF19217', NULL, NULL, 'Coronavirus replicase NSP4, N-terminal', NULL, 'CoV_NSP4_N', NULL, NULL, 35416, 9),
(258147, NULL, 'PF12172', NULL, NULL, 'Rubredoxin-like zinc ribbon domain (DUF35_N)', NULL, 'DUF35_N', NULL, NULL, 20392, 9),
(258148, NULL, 'PF16956', NULL, NULL, 'Putative general bacterial porin', NULL, 'Porin_7', NULL, NULL, 22459, 9),
(258149, NULL, 'PF11409', NULL, NULL, 'Smad anchor for receptor activation (SARA)', NULL, 'SARA', NULL, NULL, 22048, 9),
(258150, NULL, 'PF11923', NULL, NULL, 'NFACT protein C-terminal domain', NULL, 'NFACT-C', NULL, NULL, 19505, 9),
(258151, NULL, 'PF01944', NULL, NULL, 'Stage II sporulation protein M', NULL, 'SpoIIM', NULL, NULL, 4766, 9),
(258152, NULL, 'PF08492', NULL, NULL, 'SRP72 RNA-binding domain', NULL, 'SRP72', NULL, NULL, 13918, 9); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(258153, NULL, 'PF18617', NULL, NULL, 'Nucleoporin Nup214 phenylalanine-glycine (FG) domain', NULL, 'Nup214_FG', NULL, NULL, 30327, 9),
(258154, NULL, 'PF02817', NULL, NULL, 'e3 binding domain', NULL, 'E3_binding', NULL, NULL, 2758, 9),
(258155, NULL, 'PF13482', NULL, NULL, 'RNase_H superfamily', NULL, 'RNase_H_2', NULL, NULL, 25005, 9),
(258156, NULL, 'PF04538', NULL, NULL, 'Brain expressed X-linked like family', NULL, 'BEX', NULL, NULL, 15250, 9),
(258157, NULL, 'PF12631', NULL, NULL, 'MnmE helical domain', NULL, 'MnmE_helical', NULL, NULL, 25868, 9),
(258158, NULL, 'PF20616', NULL, NULL, 'Capsule biosynthesis GfcC, N-terminal', NULL, 'Caps_syn_GfcC_N', NULL, NULL, 33995, 9),
(258159, NULL, 'PF12918', NULL, NULL, 'TcdB toxin N-terminal helical domain', NULL, 'TcdB_N', NULL, NULL, 23532, 9),
(258160, NULL, 'PF19212', NULL, NULL, 'Coronavirus replicase NSP2, C-terminal', NULL, 'CoV_NSP2_C', NULL, NULL, 36031, 9),
(258161, NULL, 'PF16373', NULL, NULL, 'Domain of unknown function', NULL, 'DUF4985', NULL, NULL, 26138, 9),
(258162, NULL, 'PF13609', NULL, NULL, 'Gram-negative porin', NULL, 'Porin_4', NULL, NULL, 27372, 9),
(258163, NULL, 'PF02178', NULL, NULL, 'AT hook motif', NULL, 'AT_hook', NULL, NULL, 14566, 9),
(258164, NULL, 'PF18023', NULL, NULL, 'BDBT FKBP like N-terminal', NULL, 'FKBP_N_2', NULL, NULL, 27572, 9),
(258165, NULL, 'PF13675', NULL, NULL, 'Type IV pili methyl-accepting chemotaxis transducer N-term', NULL, 'PilJ', NULL, NULL, 24526, 9),
(258166, NULL, 'PF15347', NULL, NULL, 'Phosphoprotein associated with glycosphingolipid-enriched', NULL, 'PAG', NULL, NULL, 22376, 9),
(258167, NULL, 'PF11253', NULL, NULL, 'Protein of unknown function (DUF3052)', NULL, 'DUF3052', NULL, NULL, 18084, 9),
(258168, NULL, 'PF17839', NULL, NULL, 'C-terminal domain of cyclic nucleotide phosphodiesterase', NULL, 'CNP_C_terminal', NULL, NULL, 28416, 9),
(258169, NULL, 'PF02477', NULL, NULL, 'Nucleocapsid N protein', NULL, 'Nairo_nucleo', NULL, NULL, 6167, 9),
(258170, NULL, 'PF18067', NULL, NULL, 'Lipase C-terminal domain', NULL, 'Lipase_C', NULL, NULL, 27573, 9),
(258171, NULL, 'PF18771', NULL, NULL, 'APOBEC3', NULL, 'APOBEC3', NULL, NULL, 29595, 9),
(258172, NULL, 'PF17563', NULL, NULL, 'Cupiennin', NULL, 'Cu', NULL, NULL, 21395, 9),
(258173, NULL, 'PF20592', NULL, NULL, 'Putative adhesin domain (group 10)', NULL, 'pAdhesive_10', NULL, NULL, 35622, 9),
(258174, NULL, 'PF05239', NULL, NULL, 'PRC-barrel domain', NULL, 'PRC', NULL, NULL, 26281, 9),
(258175, NULL, 'PF04409', NULL, NULL, 'Protein of unknown function (DUF530)', NULL, 'DUF530', NULL, NULL, 10115, 9),
(258176, NULL, 'PF11049', NULL, NULL, 'Glycoprotein K1 of Kaposi''s sarcoma-associated herpes virus', NULL, 'KSHV_K1', NULL, NULL, 15471, 9),
(258177, NULL, 'PF11708', NULL, NULL, 'Pre-mRNA splicing Prp18-interacting factor', NULL, 'Slu7', NULL, NULL, 19251, 9),
(258178, NULL, 'PF15964', NULL, NULL, 'Centrosomal colon cancer autoantigen protein family', NULL, 'CCCAP', NULL, NULL, 26740, 9),
(258179, NULL, 'PF10678', NULL, NULL, 'Protein of unknown function (DUF2492)', NULL, 'DUF2492', NULL, NULL, 20138, 9),
(258180, NULL, 'PF16842', NULL, NULL, 'Occluded RNA-recognition motif', NULL, 'RRM_occluded', NULL, NULL, 24074, 9),
(258181, NULL, 'PF07813', NULL, NULL, 'LTXXQ motif family protein', NULL, 'LTXXQ', NULL, NULL, 13251, 9),
(258182, NULL, 'PF18920', NULL, NULL, 'Domain of unknown function (DUF5671)', NULL, 'DUF5671', NULL, NULL, 34144, 9),
(258183, NULL, 'PF01799', NULL, NULL, '[2Fe-2S] binding domain', NULL, 'Fer2_2', NULL, NULL, 5574, 9),
(258184, NULL, 'PF07104', NULL, NULL, 'Protein of unknown function (DUF1366)', NULL, 'DUF1366', NULL, NULL, 13083, 9),
(258185, NULL, 'PF02172', NULL, NULL, 'KIX domain', NULL, 'KIX', NULL, NULL, 1110, 9),
(258186, NULL, 'PF06688', NULL, NULL, 'Protein of unknown function (DUF1187)', NULL, 'DUF1187', NULL, NULL, 758, 9),
(258187, NULL, 'PF07143', NULL, NULL, 'CrtC N-terminal lipocalin domain', NULL, 'CrtC', NULL, NULL, 10653, 9),
(258188, NULL, 'PF13660', NULL, NULL, 'Domain of unknown function (DUF4147)', NULL, 'DUF4147', NULL, NULL, 23033, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(258189, NULL, 'PF07047', NULL, NULL, 'Optic atrophy 3 protein (OPA3)', NULL, 'OPA3', NULL, NULL, 9704, 9),
(258190, NULL, 'PF17876', NULL, NULL, 'Cold shock domain', NULL, 'CSD2', NULL, NULL, 27834, 9),
(258191, NULL, 'PF07792', NULL, NULL, 'Docking domain of Afi1 for Arf3 in vesicle trafficking', NULL, 'Afi1', NULL, NULL, 12405, 9),
(258192, NULL, 'PF15355', NULL, NULL, 'Stretch-responsive small skeletal muscle X protein, Chisel', NULL, 'Chisel', NULL, NULL, 26494, 9),
(258193, NULL, 'PF15602', NULL, NULL, 'Immunity protein 71', NULL, 'Imm71', NULL, NULL, 24640, 9),
(258194, NULL, 'PF09377', NULL, NULL, 'SBDS protein, domain II', NULL, 'SBDS_domain_II', NULL, NULL, 14578, 9),
(258195, NULL, 'PF11863', NULL, NULL, 'Protein of unknown function (DUF3383)', NULL, 'DUF3383', NULL, NULL, 19032, 9),
(258196, NULL, 'PF07396', NULL, NULL, 'Phosphate-selective porin O and P', NULL, 'Porin_O_P', NULL, NULL, 11996, 9),
(258197, NULL, 'PF05428', NULL, NULL, 'Corticotropin-releasing factor binding protein (CRF-BP)', NULL, 'CRF-BP', NULL, NULL, 8954, 9),
(258198, NULL, 'PF15192', NULL, NULL, 'TMEM213 family', NULL, 'TMEM213', NULL, NULL, 25584, 9),
(258199, NULL, 'PF03381', NULL, NULL, 'LEM3 (ligand-effect modulator 3) family / CDC50 family', NULL, 'CDC50', NULL, NULL, 2479, 9),
(258200, NULL, 'PF04390', NULL, NULL, 'Lipopolysaccharide-assembly', NULL, 'LptE', NULL, NULL, 10385, 9),
(258201, NULL, 'PF11191', NULL, NULL, 'Protein of unknown function (DUF2782)', NULL, 'DUF2782', NULL, NULL, 18049, 9),
(258202, NULL, 'PF10636', NULL, NULL, 'Hemin uptake protein hemP', NULL, 'hemP', NULL, NULL, 20279, 9),
(258203, NULL, 'PF00537', NULL, NULL, 'Scorpion toxin-like domain', NULL, 'Toxin_3', NULL, NULL, 1259, 9),
(258204, NULL, 'PF07174', NULL, NULL, 'Fibronectin-attachment protein (FAP)', NULL, 'FAP', NULL, NULL, 10711, 9),
(258205, NULL, 'PF13684', NULL, NULL, 'Dihydroxyacetone kinase family', NULL, 'Dak1_2', NULL, NULL, 29046, 9),
(258206, NULL, 'PF10415', NULL, NULL, 'Fumarase C C-terminus', NULL, 'FumaraseC_C', NULL, NULL, 16951, 9),
(258207, NULL, 'PF06554', NULL, NULL, 'Olfactory marker protein', NULL, 'Olfactory_mark', NULL, NULL, 7752, 9),
(258208, NULL, 'PF12207', NULL, NULL, 'Domain of unknown function (DUF3600)', NULL, 'DUF3600', NULL, NULL, 20220, 9),
(258209, NULL, 'PF00876', NULL, NULL, 'Innexin', NULL, 'Innexin', NULL, NULL, 3193, 9),
(258210, NULL, 'PF01573', NULL, NULL, 'Bromovirus movement protein', NULL, 'Bromo_MP', NULL, NULL, 681, 9),
(258211, NULL, 'PF20173', NULL, NULL, 'Family of unknown function (DUF6539)', NULL, 'DUF6539', NULL, NULL, 35749, 9),
(258212, NULL, 'PF20578', NULL, NULL, 'Atrophied bacterial Ig domain', NULL, 'aBig_2', NULL, NULL, 37765, 9),
(258213, NULL, 'PF02598', NULL, NULL, 'Putative RNA methyltransferase', NULL, 'Methyltrn_RNA_3', NULL, NULL, 2209, 9),
(258214, NULL, 'PF02947', NULL, NULL, 'flt3 ligand', NULL, 'Flt3_lig', NULL, NULL, 3603, 9),
(258215, NULL, 'PF09904', NULL, NULL, 'Winged helix-turn helix', NULL, 'HTH_43', NULL, NULL, 21034, 9),
(258216, NULL, 'PF08799', NULL, NULL, 'pre-mRNA processing factor 4 (PRP4) like', NULL, 'PRP4', NULL, NULL, 13229, 9),
(258217, NULL, 'PF12683', NULL, NULL, 'Protein of unknown function (DUF3798)', NULL, 'DUF3798', NULL, NULL, 20332, 9),
(258218, NULL, 'PF11578', NULL, NULL, 'Protein of unknown function (DUF3237)', NULL, 'DUF3237', NULL, NULL, NULL, 9),
(258219, NULL, 'PF00550', NULL, NULL, 'Phosphopantetheine attachment site', NULL, 'PP-binding', NULL, NULL, 6159, 9),
(258220, NULL, 'PF06929', NULL, NULL, 'Rotavirus VP3 protein', NULL, 'Rotavirus_VP3', NULL, NULL, 10967, 9),
(258221, NULL, 'PF04371', NULL, NULL, 'Porphyromonas-type peptidyl-arginine deiminase', NULL, 'PAD_porph', NULL, NULL, 4864, 9),
(258222, NULL, 'PF00887', NULL, NULL, 'Acyl CoA binding protein', NULL, 'ACBP', NULL, NULL, 5595, 9),
(258223, NULL, 'PF12076', NULL, NULL, 'WAX2 C-terminal domain', NULL, 'Wax2_C', NULL, NULL, 20302, 9),
(258224, NULL, 'PF06666', NULL, NULL, 'Protein of unknown function (DUF1173)', NULL, 'DUF1173', NULL, NULL, 10413, 9);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(258225, NULL, 'PF01509', NULL, NULL, 'TruB family pseudouridylate synthase (N terminal domain)', NULL, 'TruB_N', NULL, NULL, 897, 9),
(258226, NULL, 'PF10173', NULL, NULL, 'Mitochondrial K+-H+ exchange-related', NULL, 'Mit_KHE1', NULL, NULL, 19278, 9),
(258227, NULL, 'PF07134', NULL, NULL, 'Autographa californica nuclear polyhedrosis virus (AcMNPV), Orf18', NULL, 'AcMNPV_Orf18', NULL, NULL, 10913, 9),
(258228, NULL, 'PF11498', NULL, NULL, 'Transcriptional activator LAG-3', NULL, 'Activator_LAG-3', NULL, NULL, 18696, 9),
(258229, NULL, 'PF05410', NULL, NULL, 'Porcine arterivirus-type cysteine proteinase alpha', NULL, 'Peptidase_C31', NULL, NULL, 12188, 9),
(258230, NULL, 'PF10193', NULL, NULL, 'Telomere length regulation protein', NULL, 'Telomere_reg-2', NULL, NULL, 15962, 9),
(258231, NULL, 'PF08808', NULL, NULL, 'RES domain', NULL, 'RES', NULL, NULL, 13026, 9),
(258232, NULL, 'PF06794', NULL, NULL, 'Uncharacterised protein family (UPF0270)', NULL, 'UPF0270', NULL, NULL, 9268, 9),
(258233, NULL, 'PF05164', NULL, NULL, 'Cell division protein ZapA', NULL, 'ZapA', NULL, NULL, 2498, 9),
(258234, NULL, 'PF08391', NULL, NULL, 'Ly49-like protein, N-terminal region', NULL, 'Ly49', NULL, NULL, 11479, 9),
(258235, NULL, 'PF16063', NULL, NULL, 'Domain of unknown function (DUF4805)', NULL, 'DUF4805', NULL, NULL, 23768, 9),
(258236, NULL, 'PF19058', NULL, NULL, 'Family of unknown function (DUF5754)', NULL, 'DUF5754', NULL, NULL, 35972, 9),
(258237, NULL, 'PF08987', NULL, NULL, 'Protein of unknown function (DUF1892)', NULL, 'DUF1892', NULL, NULL, 8722, 9),
(258238, NULL, 'PF19608', NULL, NULL, 'Family of unknown function (DUF6113)', NULL, 'DUF6113', NULL, NULL, 36625, 9),
(258239, NULL, 'PF04310', NULL, NULL, 'MukB N-terminal', NULL, 'MukB', NULL, NULL, 3894, 9),
(258240, NULL, 'PF18668', NULL, NULL, 'Tail spike TSP1/Gp66 receptor binding N-terminal domain', NULL, 'Tail_spike_N', NULL, NULL, 28612, 9),
(258241, NULL, 'PF01407', NULL, NULL, 'Geminivirus AL3 protein', NULL, 'Gemini_AL3', NULL, NULL, 4871, 9),
(258242, NULL, 'PF00448', NULL, NULL, 'SRP54-type protein, GTPase domain', NULL, 'SRP54', NULL, NULL, 260, 9),
(258243, NULL, 'PF00541', NULL, NULL, 'Adenoviral fibre protein (knob domain)', NULL, 'Adeno_knob', NULL, NULL, 406, 9),
(258244, NULL, 'PF09719', NULL, NULL, 'Putative redox-active protein (C_GCAxxG_C_C)', NULL, 'C_GCAxxG_C_C', NULL, NULL, 4046, 9),
(258245, NULL, 'PF15727', NULL, NULL, 'Domain of unknown function (DUF4678)', NULL, 'DUF4678', NULL, NULL, 26486, 9),
(258246, NULL, 'PF05724', NULL, NULL, 'Thiopurine S-methyltransferase (TPMT)', NULL, 'TPMT', NULL, NULL, 13519, 9),
(258247, NULL, 'PF17993', NULL, NULL, 'Haemagglutinin 70 C-terminal domain', NULL, 'HA70_C', NULL, NULL, 31765, 9),
(258248, NULL, 'PF00502', NULL, NULL, 'Phycobilisome protein', NULL, 'Phycobilisome', NULL, NULL, 13506, 9),
(258249, NULL, 'PF16610', NULL, NULL, 'Unstructured region between two PDZ domains on Dlg5', NULL, 'dbPDZ_assoc', NULL, NULL, NULL, 9),
(258250, NULL, 'PF20564', NULL, NULL, 'Family of unknown function (DUF6774)', NULL, 'DUF6774', NULL, NULL, 37113, 9),
(258251, NULL, 'PF01548', NULL, NULL, 'Transposase', NULL, 'DEDD_Tnp_IS110', NULL, NULL, 547, 9),
(258252, NULL, 'PF03152', NULL, NULL, 'Ubiquitin fusion degradation protein UFD1', NULL, 'UFD1', NULL, NULL, 7025, 9),
(258253, NULL, 'PF05106', NULL, NULL, 'Phage holin family (Lysis protein S)', NULL, 'Phage_holin_3_1', NULL, NULL, 6131, 9),
(258254, NULL, 'PF03283', NULL, NULL, 'Pectinacetylesterase', NULL, 'PAE', NULL, NULL, 2898, 9),
(258255, NULL, 'PF06267', NULL, NULL, 'Family of unknown function (DUF1028)', NULL, 'DUF1028', NULL, NULL, 9396, 9),
(258256, NULL, 'PF10394', NULL, NULL, 'Histone acetyl transferase HAT1 N-terminus', NULL, 'Hat1_N', NULL, NULL, 17178, 9),
(258257, NULL, 'PF19927', NULL, NULL, 'Family of unknown function (DUF6390)', NULL, 'DUF6390', NULL, NULL, 36364, 9),
(258258, NULL, 'PF10106', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2345)', NULL, 'DUF2345', NULL, NULL, 18203, 9),
(258259, NULL, 'PF20098', NULL, NULL, 'Family of unknown function (DUF6488)', NULL, 'DUF6488', NULL, NULL, 37407, 9);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(258260, NULL, 'PF15633', NULL, NULL, 'HYD1 signature containing ADP-ribosyltransferase', NULL, 'Tox-ART-HYD1', NULL, NULL, 25131, 9),
(258261, NULL, 'PF09162', NULL, NULL, 'Tap, RNA-binding', NULL, 'Tap-RNA_bind', NULL, NULL, 12391, 9),
(258262, NULL, 'PF09553', NULL, NULL, 'Eco47II restriction endonuclease', NULL, 'RE_Eco47II', NULL, NULL, 16816, 9),
(258263, NULL, 'PF17938', NULL, NULL, 'Tetracyclin repressor-like, C-terminal domain', NULL, 'TetR_C_29', NULL, NULL, 29935, 9),
(258264, NULL, 'PF15861', NULL, NULL, 'Partial cleavage stimulation factor domain', NULL, 'partial_CstF', NULL, NULL, 25528, 9),
(258265, NULL, 'PF01344', NULL, NULL, 'Kelch motif', NULL, 'Kelch_1', NULL, NULL, 1361, 9),
(258266, NULL, 'PF10533', NULL, NULL, 'Plant zinc cluster domain', NULL, 'Plant_zn_clust', NULL, NULL, 20686, 9),
(258267, NULL, 'PF07761', NULL, NULL, 'Protein of unknown function (DUF1617)', NULL, 'DUF1617', NULL, NULL, 10960, 9),
(258268, NULL, 'PF11771', NULL, NULL, 'Protein of unknown function (DUF3314)', NULL, 'DUF3314', NULL, NULL, 19271, 9),
(258269, NULL, 'PF13868', NULL, NULL, 'Trichohyalin-plectin-homology domain', NULL, 'TPH', NULL, NULL, 35057, 9),
(258270, NULL, 'PF08299', NULL, NULL, 'Bacterial dnaA protein helix-turn-helix', NULL, 'Bac_DnaA_C', NULL, NULL, 8706, 9),
(258271, NULL, 'PF07021', NULL, NULL, 'Methionine biosynthesis protein MetW', NULL, 'MetW', NULL, NULL, 9589, 9),
(258272, NULL, 'PF06388', NULL, NULL, 'Protein of unknown function (DUF1075)', NULL, 'DUF1075', NULL, NULL, 8463, 9),
(258273, NULL, 'PF16700', NULL, NULL, 'Synphilin-1 alpha-Synuclein-binding domain', NULL, 'SNCAIP_SNCA_bd', NULL, NULL, 23216, 9),
(258274, NULL, 'PF00558', NULL, NULL, 'Vpu protein', NULL, 'Vpu', NULL, NULL, 7289, 9),
(258275, NULL, 'PF15274', NULL, NULL, 'Muscular LMNA-interacting protein', NULL, 'MLIP', NULL, NULL, 23670, 9),
(258276, NULL, 'PF11777', NULL, NULL, 'Protein of unknown function (DUF3316)', NULL, 'DUF3316', NULL, NULL, 16289, 9),
(258277, NULL, 'PF13888', NULL, NULL, 'Myelin gene regulatory factor C-terminal domain 2', NULL, 'MRF_C2', NULL, NULL, 24649, 9),
(258278, NULL, 'PF03878', NULL, NULL, 'YIF1', NULL, 'YIF1', NULL, NULL, 1594, 9),
(258279, NULL, 'PF08718', NULL, NULL, 'Glycolipid transfer protein (GLTP)', NULL, 'GLTP', NULL, NULL, 11965, 9),
(258280, NULL, 'PF12177', NULL, NULL, 'Prohormone convertase enzyme', NULL, 'Proho_convert', NULL, NULL, 20275, 9),
(258281, NULL, 'PF15155', NULL, NULL, 'MORF4 family-associated protein1', NULL, 'MRFAP1', NULL, NULL, 21994, 9),
(258282, NULL, 'PF03801', NULL, NULL, 'HEC/Ndc80p family', NULL, 'Ndc80_HEC', NULL, NULL, 1512, 9),
(258283, NULL, 'PF16115', NULL, NULL, 'Domain of unknown function (DUF4831)', NULL, 'DUF4831', NULL, NULL, 26438, 9),
(258284, NULL, 'PF16112', NULL, NULL, 'Domain of unknown function (DUF4830)', NULL, 'DUF4830', NULL, NULL, 23740, 9),
(258285, NULL, 'PF11946', NULL, NULL, 'Domain of unknown function (DUF3463)', NULL, 'DUF3463', NULL, NULL, 16175, 9),
(258286, NULL, 'PF13830', NULL, NULL, 'Domain of unknown function (DUF4192)', NULL, 'DUF4192', NULL, NULL, 22425, 9),
(258287, NULL, 'PF19290', NULL, NULL, 'PmbA/TldA metallopeptidase central domain', NULL, 'PmbA_TldD_M', NULL, NULL, 36177, 9),
(258288, NULL, 'PF02291', NULL, NULL, 'Transcription initiation factor IID, 31kD subunit', NULL, 'TFIID-31kDa', NULL, NULL, 1930, 9),
(258289, NULL, 'PF09835', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2062)', NULL, 'DUF2062', NULL, NULL, 16957, 9),
(258290, NULL, 'PF01884', NULL, NULL, 'PcrB family', NULL, 'PcrB', NULL, NULL, 7128, 9),
(258291, NULL, 'PF11955', NULL, NULL, 'Plant organelle RNA recognition domain', NULL, 'PORR', NULL, NULL, 15356, 9),
(258292, NULL, 'PF15676', NULL, NULL, 'Six6 opposite strand transcript 1 family', NULL, 'S6OS1', NULL, NULL, 25628, 9),
(258293, NULL, 'PF20358', NULL, NULL, 'Family of unknown function (DUF6653)', NULL, 'DUF6653', NULL, NULL, 33852, 9),
(258294, NULL, 'PF18828', NULL, NULL, 'Large polyvalent-protein-associated domain 15', NULL, 'LPD15', NULL, NULL, 27678, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(258295, NULL, 'PF16847', NULL, NULL, 'Avirulence AvrPtoB, BAK1-binding domain', NULL, 'AvrPtoB_bdg', NULL, NULL, 22806, 9),
(258296, NULL, 'PF17765', NULL, NULL, 'MmyB-like transcription regulator ligand binding domain', NULL, 'MLTR_LBD', NULL, NULL, 30216, 9),
(258297, NULL, 'PF11538', NULL, NULL, 'Snurportin1', NULL, 'Snurportin1', NULL, NULL, 25710, 9),
(258298, NULL, 'PF04034', NULL, NULL, 'Ribosome biogenesis protein, C-terminal', NULL, 'Ribo_biogen_C', NULL, NULL, 664, 9),
(258299, NULL, 'PF09816', NULL, NULL, 'RNA polymerase II transcription elongation factor', NULL, 'EAF', NULL, NULL, 18369, 9),
(258300, NULL, 'PF09696', NULL, NULL, 'Ctf8', NULL, 'Ctf8', NULL, NULL, 16078, 9),
(258301, NULL, 'PF00761', NULL, NULL, 'Polyomavirus coat protein', NULL, 'Polyoma_coat2', NULL, NULL, 1250, 9),
(258302, NULL, 'PF13384', NULL, NULL, 'Homeodomain-like domain', NULL, 'HTH_23', NULL, NULL, NULL, 9),
(258303, NULL, 'PF06977', NULL, NULL, 'SdiA-regulated', NULL, 'SdiA-regulated', NULL, NULL, 12392, 9),
(258304, NULL, 'PF14840', NULL, NULL, 'Processivity clamp loader gamma complex DNA pol III C-term', NULL, 'DNA_pol3_delt_C', NULL, NULL, 22342, 9),
(258305, NULL, 'PF12810', NULL, NULL, 'Glycine rich protein', NULL, 'Gly_rich', NULL, NULL, NULL, 9),
(258306, NULL, 'PF10475', NULL, NULL, 'Vacuolar-sorting protein 54, of GARP complex', NULL, 'Vps54_N', NULL, NULL, 18140, 9),
(258307, NULL, 'PF15083', NULL, NULL, 'Colipase-like', NULL, 'Colipase-like', NULL, NULL, 2227, 9),
(258308, NULL, 'PF19755', NULL, NULL, 'Domain of unknown function (DUF6242)', NULL, 'DUF6242', NULL, NULL, 37148, 9),
(258309, NULL, 'PF00301', NULL, NULL, 'Rubredoxin', NULL, 'Rubredoxin', NULL, NULL, 15274, 9),
(258310, NULL, 'PF12381', NULL, NULL, 'Tungro spherical virus-type peptidase', NULL, 'Peptidase_C3G', NULL, NULL, 22299, 9),
(258311, NULL, 'PF00170', NULL, NULL, 'bZIP transcription factor', NULL, 'bZIP_1', NULL, NULL, 4006, 9),
(258312, NULL, 'PF11736', NULL, NULL, 'Protein of unknown function (DUF3299)', NULL, 'DUF3299', NULL, NULL, 19346, 9),
(258313, NULL, 'PF18015', NULL, NULL, 'Acetyltransferase (GNAT) domain', NULL, 'Acetyltransf_19', NULL, NULL, 27756, 9),
(258314, NULL, 'PF17552', NULL, NULL, 'Family of unknown function (DUF5464)', NULL, 'DUF5464', NULL, NULL, 32977, 9),
(258315, NULL, 'PF03749', NULL, NULL, 'Sugar fermentation stimulation protein RE domain', NULL, 'SfsA', NULL, NULL, 27859, 9),
(258316, NULL, 'PF11540', NULL, NULL, 'Cytoplasmic dynein 1 intermediate chain 2', NULL, 'Dynein_IC2', NULL, NULL, 24542, 9),
(258317, NULL, 'PF06531', NULL, NULL, 'Protein of unknown function (DUF1108)', NULL, 'DUF1108', NULL, NULL, 9123, 9),
(258318, NULL, 'PF13883', NULL, NULL, 'Pyridoxamine 5''-phosphate oxidase', NULL, 'Pyrid_oxidase_2', NULL, NULL, NULL, 9),
(258319, NULL, 'PF16002', NULL, NULL, 'Headcase protein', NULL, 'Headcase', NULL, NULL, 25647, 9),
(258320, NULL, 'PF19617', NULL, NULL, 'Family of unknown function (DUF6122)', NULL, 'DUF6122', NULL, NULL, 37179, 9),
(258321, NULL, 'PF04090', NULL, NULL, 'RNA polymerase I specific initiation factor', NULL, 'RNA_pol_I_TF', NULL, NULL, 6550, 9),
(258322, NULL, 'PF00074', NULL, NULL, 'Pancreatic ribonuclease', NULL, 'RnaseA', NULL, NULL, 16390, 9),
(258323, NULL, 'PF03989', NULL, NULL, 'DNA gyrase C-terminal domain, beta-propeller', NULL, 'DNA_gyraseA_C', NULL, NULL, 2464, 9),
(258324, NULL, 'PF01269', NULL, NULL, 'Fibrillarin', NULL, 'Fibrillarin', NULL, NULL, 6978, 9),
(258325, NULL, 'PF07856', NULL, NULL, 'Mediator of CRAC channel activity', NULL, 'Orai-1', NULL, NULL, 14433, 9),
(258326, NULL, 'PF03872', NULL, NULL, 'Anti sigma-E protein RseA, N-terminal domain', NULL, 'RseA_N', NULL, NULL, 1525, 9),
(258327, NULL, 'PF07246', NULL, NULL, 'Phlebovirus nonstructural protein NS-M', NULL, 'Phlebovirus_NSM', NULL, NULL, 14015, 9),
(258328, NULL, 'PF05119', NULL, NULL, 'Phage terminase, small subunit', NULL, 'Terminase_4', NULL, NULL, 6689, 9),
(258329, NULL, 'PF05638', NULL, NULL, 'Type VI secretion system effector, Hcp', NULL, 'T6SS_HCP', NULL, NULL, 12716, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(258330, NULL, 'PF03292', NULL, NULL, 'Poxvirus P4B major core protein', NULL, 'Pox_P4B', NULL, NULL, 908, 9),
(258331, NULL, 'PF10408', NULL, NULL, 'Ubiquitin elongating factor core', NULL, 'Ufd2P_core', NULL, NULL, 17197, 9),
(258332, NULL, 'PF11398', NULL, NULL, 'Protein of unknown function (DUF2813)', NULL, 'DUF2813', NULL, NULL, 16883, 9),
(258333, NULL, 'PF04320', NULL, NULL, 'YggL 50S ribosome-binding protein', NULL, 'YggL_50S_bp', NULL, NULL, 3654, 9),
(258334, NULL, 'PF16026', NULL, NULL, 'Mitochondria-eating protein', NULL, 'MIEAP', NULL, NULL, 23894, 9),
(258335, NULL, 'PF07411', NULL, NULL, 'Domain of unknown function (DUF1508)', NULL, 'DUF1508', NULL, NULL, 11524, 9),
(258336, NULL, 'PF11005', NULL, NULL, 'Protein of unknown function (DUF2844)', NULL, 'DUF2844', NULL, NULL, 17919, 9),
(258337, NULL, 'PF04549', NULL, NULL, 'CD47 transmembrane region', NULL, 'CD47', NULL, NULL, 12819, 9),
(258338, NULL, 'PF15769', NULL, NULL, 'Domain of unknown function (DUF4698)', NULL, 'DUF4698', NULL, NULL, 25179, 9),
(258339, NULL, 'PF18891', NULL, NULL, 'FANCL UBC-like domain 3', NULL, 'FANCL_d3', NULL, NULL, 35289, 9),
(258340, NULL, 'PF19960', NULL, NULL, 'Effector-associated domain 7', NULL, 'EAD7', NULL, NULL, 37460, 9),
(258341, NULL, 'PF08628', NULL, NULL, 'Sorting nexin C terminal', NULL, 'Nexin_C', NULL, NULL, 14318, 9),
(258342, NULL, 'PF15487', NULL, NULL, 'FAM220 family', NULL, 'FAM220', NULL, NULL, 25629, 9),
(258343, NULL, 'PF04450', NULL, NULL, 'Peptidase of plants and bacteria', NULL, 'BSP', NULL, NULL, 10724, 9),
(258344, NULL, 'PF15877', NULL, NULL, 'Transmembrane protein family 232', NULL, 'TMEM232', NULL, NULL, 23516, 9),
(258345, NULL, 'PF06634', NULL, NULL, 'Protein of unknown function (DUF1156)', NULL, 'DUF1156', NULL, NULL, 10222, 9),
(258346, NULL, 'PF19457', NULL, NULL, 'Family of unknown function (DUF5994)', NULL, 'DUF5994', NULL, NULL, 36791, 9),
(258347, NULL, 'PF02847', NULL, NULL, 'MA3 domain', NULL, 'MA3', NULL, NULL, 6411, 9),
(258348, NULL, 'PF17964', NULL, NULL, 'Bacterial Ig domain', NULL, 'Big_10', NULL, NULL, 29063, 9),
(258349, NULL, 'PF04522', NULL, NULL, 'Broad bean mottle virus, Gp1, N-terminal', NULL, 'BBMV_Gp1_N', NULL, NULL, 2979, 9),
(258350, NULL, 'PF01868', NULL, NULL, 'Ribonuclease P/MRP, subunit p29', NULL, 'RNase_P-MRP_p29', NULL, NULL, 3554, 9),
(258351, NULL, 'PF16613', NULL, NULL, 'Unstructured region of RGS12', NULL, 'RGS12_us1', NULL, NULL, NULL, 9),
(258352, NULL, 'PF04827', NULL, NULL, 'Plant transposon protein', NULL, 'Plant_tran', NULL, NULL, 4968, 9),
(258353, NULL, 'PF06957', NULL, NULL, 'Coatomer (COPI) alpha subunit C-terminus', NULL, 'COPI_C', NULL, NULL, 9737, 9),
(258354, NULL, 'PF15139', NULL, NULL, 'Domain of unknown function (DUF4572)', NULL, 'DUF4572', NULL, NULL, 23002, 9),
(258355, NULL, 'PF08626', NULL, NULL, 'Transport protein Trs120 or TRAPPC9, TRAPP II complex subunit', NULL, 'TRAPPC9-Trs120', NULL, NULL, 14488, 9),
(258356, NULL, 'PF08906', NULL, NULL, 'Domain of unknown function (DUF1851)', NULL, 'DUF1851', NULL, NULL, 7849, 9),
(258357, NULL, 'PF09548', NULL, NULL, 'Stage III sporulation protein AB (spore_III_AB)', NULL, 'Spore_III_AB', NULL, NULL, 8799, 9),
(258358, NULL, 'PF15963', NULL, NULL, 'Myb DNA-binding like', NULL, 'Myb_DNA-bind_7', NULL, NULL, 33427, 9),
(258359, NULL, 'PF17542', NULL, NULL, 'Uncharacterized RP853', NULL, 'RP853', NULL, NULL, 13529, 9),
(258360, NULL, 'PF16694', NULL, NULL, 'Cytochrome P460', NULL, 'Cytochrome_P460', NULL, NULL, 23422, 9),
(258361, NULL, 'PF00111', NULL, NULL, '2Fe-2S iron-sulfur cluster binding domain', NULL, 'Fer2', NULL, NULL, 2014, 9),
(258362, NULL, 'PF14461', NULL, NULL, 'Prokaryotic E2 family B', NULL, 'Prok-E2_B', NULL, NULL, 21661, 9),
(258363, NULL, 'PF06947', NULL, NULL, 'Protein of unknown function (DUF1290)', NULL, 'DUF1290', NULL, NULL, 11665, 9),
(258364, NULL, 'PF17785', NULL, NULL, 'PUA-like domain', NULL, 'PUA_3', NULL, NULL, 29561, 9),
(258365, NULL, 'PF05675', NULL, NULL, 'Protein of unknown function (DUF817)', NULL, 'DUF817', NULL, NULL, 13032, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(258366, NULL, 'PF14165', NULL, NULL, 'YtzH-like protein', NULL, 'YtzH', NULL, NULL, 23929, 9),
(258367, NULL, 'PF19793', NULL, NULL, 'Family of unknown function (DUF6277)', NULL, 'DUF6277', NULL, NULL, 37157, 9),
(258368, NULL, 'PF20591', NULL, NULL, 'Domain of unknown function (DUF6792)', NULL, 'DUF6792', NULL, NULL, 37386, 9),
(258369, NULL, 'PF12269', NULL, NULL, 'CpG binding protein C-terminal domain', NULL, 'CpG_bind_C', NULL, NULL, 20509, 9),
(258370, NULL, 'PF04162', NULL, NULL, 'Gyrovirus capsid protein (VP1)', NULL, 'Gyro_capsid', NULL, NULL, 7499, 9),
(258371, NULL, 'PF13016', NULL, NULL, 'Cys-rich Gliadin N-terminal', NULL, 'Gliadin', NULL, NULL, 11347, 9),
(258372, NULL, 'PF14152', NULL, NULL, 'YfhE-like protein', NULL, 'YfhE', NULL, NULL, 26167, 9),
(258373, NULL, 'PF13939', NULL, NULL, 'Toxin TisB, type I toxin-antitoxin system', NULL, 'TisB_toxin', NULL, NULL, 21831, 9),
(258374, NULL, 'PF17326', NULL, NULL, 'Family of unknown function (DUF5365)', NULL, 'DUF5365', NULL, NULL, 19511, 9),
(258375, NULL, 'PF19593', NULL, NULL, 'Family of unknown function (DUF6098)', NULL, 'DUF6098', NULL, NULL, 36895, 9),
(258376, NULL, 'PF05509', NULL, NULL, 'TraY domain', NULL, 'TraY', NULL, NULL, 7579, 9),
(258377, NULL, 'PF16870', NULL, NULL, '2-oxoglutarate dehydrogenase C-terminal', NULL, 'OxoGdeHyase_C', NULL, NULL, 24371, 9),
(258378, NULL, 'PF18076', NULL, NULL, 'Formylglycinamide ribonucleotide amidotransferase N-terminal', NULL, 'FGAR-AT_N', NULL, NULL, 28147, 9),
(258379, NULL, 'PF19049', NULL, NULL, 'SidE DUB domain', NULL, 'SidE_DUB', NULL, NULL, 35240, 9),
(258380, NULL, 'PF04377', NULL, NULL, 'Arginine-tRNA-protein transferase, C terminus', NULL, 'ATE_C', NULL, NULL, 4831, 9),
(258381, NULL, 'PF20490', NULL, NULL, 'Secretoglobin 3A', NULL, 'SCGB3A', NULL, NULL, 31508, 9),
(258382, NULL, 'PF08657', NULL, NULL, 'DASH complex subunit Spc34', NULL, 'DASH_Spc34', NULL, NULL, 7829, 9),
(258383, NULL, 'PF03783', NULL, NULL, 'Curli production assembly/transport component CsgG', NULL, 'CsgG', NULL, NULL, 1734, 9),
(258384, NULL, 'PF18010', NULL, NULL, 'Cry35Ab1 HTH C-terminal domain', NULL, 'HTH_49', NULL, NULL, 28123, 9),
(258385, NULL, 'PF14773', NULL, NULL, 'Helicase-associated putative binding domain, C-terminal', NULL, 'VIGSSK', NULL, NULL, 21670, 9),
(258386, NULL, 'PF05459', NULL, NULL, 'Herpesvirus transcriptional regulator family', NULL, 'Herpes_UL69', NULL, NULL, 12607, 9),
(258387, NULL, 'PF19521', NULL, NULL, 'Anaphase-promoting complex subunit 1 N-terminal', NULL, 'Apc1_N', NULL, NULL, NULL, 9),
(258388, NULL, 'PF00361', NULL, NULL, 'Proton-conducting membrane transporter', NULL, 'Proton_antipo_M', NULL, NULL, 3308, 9),
(258389, NULL, 'PF05112', NULL, NULL, 'Baculovirus P47 protein', NULL, 'Baculo_p47', NULL, NULL, 2490, 9),
(258390, NULL, 'PF11356', NULL, NULL, 'Type II secretion system protein C', NULL, 'T2SSC', NULL, NULL, 23958, 9),
(258391, NULL, 'PF06528', NULL, NULL, 'Phage P2 GpE', NULL, 'Phage_P2_GpE', NULL, NULL, 9370, 9),
(258392, NULL, 'PF07345', NULL, NULL, 'ATPase inhibitor subunit zeta', NULL, 'DUF1476', NULL, NULL, 8261, 9),
(258393, NULL, 'PF08081', NULL, NULL, 'RBM1CTR (NUC064) family', NULL, 'RBM1CTR', NULL, NULL, 9878, 9),
(258394, NULL, 'PF09783', NULL, NULL, 'Vacuolar import and degradation protein', NULL, 'Vac_ImportDeg', NULL, NULL, 16472, 9),
(258395, NULL, 'PF02819', NULL, NULL, 'Spider toxin', NULL, 'Toxin_9', NULL, NULL, 2750, 9),
(258396, NULL, 'PF13311', NULL, NULL, 'Protein of unknown function (DUF4080)', NULL, 'DUF4080', NULL, NULL, 25723, 9),
(258397, NULL, 'PF17450', NULL, NULL, 'Alpha galactosidase A C-terminal beta sandwich domain', NULL, 'Melibiase_2_C', NULL, NULL, 9983, 9),
(258398, NULL, 'PF16370', NULL, NULL, 'C terminal of Calcineurin-like phosphoesterase', NULL, 'MetallophosC', NULL, NULL, 26407, 9),
(258399, NULL, 'PF17750', NULL, NULL, 'Reovirus sigma C capsid protein triple beta spiral', NULL, 'Reo_sigmaC_M', NULL, NULL, 29408, 9),
(258400, NULL, 'PF17593', NULL, NULL, 'Family of unknown function (DUF5490)', NULL, 'DUF5490', NULL, NULL, 13856, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(258401, NULL, 'PF00497', NULL, NULL, 'Bacterial extracellular solute-binding proteins, family 3', NULL, 'SBP_bac_3', NULL, NULL, 3186, 9),
(258402, NULL, 'PF19723', NULL, NULL, 'Family of unknown function (DUF6216)', NULL, 'DUF6216', NULL, NULL, 37351, 9),
(258403, NULL, 'PF04664', NULL, NULL, 'Opioid growth factor receptor (OGFr) conserved region', NULL, 'OGFr_N', NULL, NULL, 3126, 9),
(258404, NULL, 'PF13969', NULL, NULL, 'Pab87 octamerisation domain', NULL, 'Pab87_oct', NULL, NULL, 25399, 9),
(258405, NULL, 'PF19923', NULL, NULL, 'Family of unknown function (DUF6386)', NULL, 'DUF6386', NULL, NULL, 37059, 9),
(258406, NULL, 'PF04486', NULL, NULL, 'SchA/CurD like domain', NULL, 'SchA_CurD', NULL, NULL, 1923, 9),
(258407, NULL, 'PF19329', NULL, NULL, 'BTB/POZ domain-containing protein KCTD11/21 C-terminus', NULL, 'KCTD11_21_C', NULL, NULL, 36499, 9),
(258408, NULL, 'PF20118', NULL, NULL, 'Family of unknown function (DUF6508)', NULL, 'DUF6508', NULL, NULL, 34648, 9),
(258409, NULL, 'PF03863', NULL, NULL, 'Phage maturation protein', NULL, 'Phage_mat-A', NULL, NULL, 1652, 9),
(258410, NULL, 'PF09093', NULL, NULL, 'Lyase, catalytic', NULL, 'Lyase_catalyt', NULL, NULL, 10714, 9),
(258411, NULL, 'PF07271', NULL, NULL, 'Cytadhesin P30/P32', NULL, 'Cytadhesin_P30', NULL, NULL, 14189, 9),
(258412, NULL, 'PF01221', NULL, NULL, 'Dynein light chain type 1', NULL, 'Dynein_light', NULL, NULL, 463, 9),
(258413, NULL, 'PF04241', NULL, NULL, 'Protein of unknown function (DUF423)', NULL, 'DUF423', NULL, NULL, 2468, 9),
(258414, NULL, 'PF09251', NULL, NULL, 'Salmonella phage P22 tail-spike', NULL, 'PhageP22-tail', NULL, NULL, 13481, 9),
(258415, NULL, 'PF13885', NULL, NULL, 'Keratin, high sulfur B2 protein', NULL, 'Keratin_B2_2', NULL, NULL, 885, 9),
(258416, NULL, 'PF10934', NULL, NULL, 'Protein of unknown function (DUF2634)', NULL, 'DUF2634', NULL, NULL, 20782, 9),
(258417, NULL, 'PF01543', NULL, NULL, 'Hepatitis C virus capsid protein', NULL, 'HCV_capsid', NULL, NULL, 674, 9),
(258418, NULL, 'PF01978', NULL, NULL, 'Sugar-specific transcriptional regulator TrmB', NULL, 'TrmB', NULL, NULL, 5259, 9),
(258419, NULL, 'PF05750', NULL, NULL, 'Rubella capsid protein', NULL, 'Rubella_Capsid', NULL, NULL, 13900, 9),
(258420, NULL, 'PF05954', NULL, NULL, 'Phage tail baseplate hub (GPD)', NULL, 'Phage_GPD', NULL, NULL, NULL, 9),
(258421, NULL, 'PF02442', NULL, NULL, 'Lipid membrane protein of large eukaryotic DNA viruses', NULL, 'L1R_F9L', NULL, NULL, 6485, 9),
(258422, NULL, 'PF10797', NULL, NULL, 'Protein of unknown function', NULL, 'YhfT', NULL, NULL, 20994, 9),
(258423, NULL, 'PF17320', NULL, NULL, 'Family of unknown function (DUF5363)', NULL, 'DUF5363', NULL, NULL, 31849, 9),
(258424, NULL, 'PF18933', NULL, NULL, 'PsbP-like protein', NULL, 'PsbP_2', NULL, NULL, NULL, 9),
(258425, NULL, 'PF07070', NULL, NULL, 'SpoOM protein', NULL, 'Spo0M', NULL, NULL, 12671, 9),
(258426, NULL, 'PF18715', NULL, NULL, 'Phage spike trimer', NULL, 'Phage_spike', NULL, NULL, 27626, 9),
(258427, NULL, 'PF16258', NULL, NULL, 'Domain of unknown function (DUF4912)', NULL, 'DUF4912', NULL, NULL, 21551, 9),
(258428, NULL, 'PF04858', NULL, NULL, 'TH1 protein', NULL, 'TH1', NULL, NULL, 5784, 9),
(258429, NULL, 'PF18074', NULL, NULL, 'Primosomal protein N C-terminal domain', NULL, 'PriA_C', NULL, NULL, 30266, 9),
(258430, NULL, 'PF19246', NULL, NULL, 'Family of unknown function (DUF5894)', NULL, 'DUF5894', NULL, NULL, 35732, 9),
(258431, NULL, 'PF13315', NULL, NULL, 'Protein of unknown function (DUF4085)', NULL, 'DUF4085', NULL, NULL, 22625, 9),
(258432, NULL, 'PF18970', NULL, NULL, 'Family of unknown function (DUF5709)', NULL, 'DUF5709', NULL, NULL, 35147, 9),
(258433, NULL, 'PF18285', NULL, NULL, 'Tetracycline repressor LuxT C-terminal domain', NULL, 'LuxT_C', NULL, NULL, NULL, 9),
(258434, NULL, 'PF17120', NULL, NULL, 'RING/Ubox like zinc-binding domain', NULL, 'zf-RING_16', NULL, NULL, NULL, 9),
(258435, NULL, 'PF06176', NULL, NULL, 'Lipopolysaccharide core biosynthesis protein (WaaY)', NULL, 'WaaY', NULL, NULL, 14021, 9),
(258436, NULL, 'PF07495', NULL, NULL, 'Y_Y_Y domain', NULL, 'Y_Y_Y', NULL, NULL, 11048, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(258437, NULL, 'PF20204', NULL, NULL, 'Domain of unknown function (DUF6566)', NULL, 'DUF6566', NULL, NULL, 37306, 9),
(258438, NULL, 'PF05138', NULL, NULL, 'Phenylacetic acid catabolic protein', NULL, 'PaaA_PaaC', NULL, NULL, 2135, 9),
(258439, NULL, 'PF14194', NULL, NULL, 'Cysteine-rich VLP', NULL, 'Cys_rich_VLP', NULL, NULL, 24296, 9),
(258440, NULL, 'PF02661', NULL, NULL, 'Fic/DOC family', NULL, 'Fic', NULL, NULL, 3452, 9),
(258441, NULL, 'PF12399', NULL, NULL, 'Branched-chain amino acid ATP-binding cassette transporter', NULL, 'BCA_ABC_TP_C', NULL, NULL, 25443, 9),
(258442, NULL, 'PF18226', NULL, NULL, 'LasR-specific antiactivator QslA chain E', NULL, 'QslA_E', NULL, NULL, 28339, 9),
(258443, NULL, 'PF08245', NULL, NULL, 'Mur ligase middle domain', NULL, 'Mur_ligase_M', NULL, NULL, 12114, 9),
(258444, NULL, 'PF10204', NULL, NULL, 'Dual oxidase maturation factor', NULL, 'DuoxA', NULL, NULL, 21091, 9),
(258445, NULL, 'PF07777', NULL, NULL, 'G-box binding protein MFMR', NULL, 'MFMR', NULL, NULL, 13422, 9),
(258446, NULL, 'PF15660', NULL, NULL, 'Putative Immunity protein 75', NULL, 'Imm75', NULL, NULL, 25312, 9),
(258447, NULL, 'PF07156', NULL, NULL, 'Prenylcysteine lyase', NULL, 'Prenylcys_lyase', NULL, NULL, 10670, 9),
(258448, NULL, 'PF05418', NULL, NULL, 'Apovitellenin I (Apo-VLDL-II)', NULL, 'Apo-VLDL-II', NULL, NULL, 8782, 9),
(258449, NULL, 'PF15695', NULL, NULL, 'Rec (regulator of expression encoded by corf) of HERV-K-113', NULL, 'HERV-K_REC', NULL, NULL, NULL, 9),
(258450, NULL, 'PF02200', NULL, NULL, 'STE like transcription factor', NULL, 'STE', NULL, NULL, 2665, 9),
(258451, NULL, 'PF15641', NULL, NULL, 'Metallopeptidase toxin 5', NULL, 'Tox-MPTase5', NULL, NULL, 24882, 9),
(258452, NULL, 'PF05435', NULL, NULL, 'Phi-29 DNA terminal protein GP3', NULL, 'Phi-29_GP3', NULL, NULL, 12256, 9),
(258453, NULL, 'PF07554', NULL, NULL, 'FIVAR domain', NULL, 'FIVAR', NULL, NULL, NULL, 9),
(258454, NULL, 'PF00547', NULL, NULL, 'Urease, gamma subunit', NULL, 'Urease_gamma', NULL, NULL, 5051, 9),
(258455, NULL, 'PF18378', NULL, NULL, 'Nuclear pore protein NUP188 C-terminal domain', NULL, 'Nup188_C', NULL, NULL, 30447, 9),
(258456, NULL, 'PF04899', NULL, NULL, 'MbeD/MobD like', NULL, 'MbeD_MobD', NULL, NULL, 5978, 9),
(258457, NULL, 'PF10175', NULL, NULL, 'M-phase phosphoprotein 6', NULL, 'MPP6', NULL, NULL, 14732, 9),
(258458, NULL, 'PF11879', NULL, NULL, 'Domain of unknown function (DUF3399)', NULL, 'DUF3399', NULL, NULL, 26997, 9),
(258459, NULL, 'PF01695', NULL, NULL, 'IstB-like ATP binding protein', NULL, 'IstB_IS21', NULL, NULL, 1533, 9),
(258460, NULL, 'PF12532', NULL, NULL, 'Protein of unknown function (DUF3732)', NULL, 'DUF3732', NULL, NULL, 21452, 9),
(258461, NULL, 'PF13134', NULL, NULL, 'Protein of unknown function (DUF3948)', NULL, 'DUF3948', NULL, NULL, 25713, 9),
(258462, NULL, 'PF00802', NULL, NULL, 'Pneumovirus attachment glycoprotein G', NULL, 'Glycoprotein_G', NULL, NULL, 3460, 9),
(258463, NULL, 'PF09144', NULL, NULL, 'Yersinia pseudo-tuberculosis mitogen', NULL, 'YpM', NULL, NULL, 10631, 9),
(258464, NULL, 'PF07690', NULL, NULL, 'Major Facilitator Superfamily', NULL, 'MFS_1', NULL, NULL, 10778, 9),
(258465, NULL, 'PF13127', NULL, NULL, 'Protein of unknown function (DUF3955)', NULL, 'DUF3955', NULL, NULL, 25910, 9),
(258466, NULL, 'PF12398', NULL, NULL, 'Receptor serine/threonine kinase', NULL, 'DUF3660', NULL, NULL, 20635, 9),
(258467, NULL, 'PF20319', NULL, NULL, 'Family of unknown function (DUF6614)', NULL, 'DUF6614', NULL, NULL, 37046, 9),
(258468, NULL, 'PF11550', NULL, NULL, 'Intracellular growth locus C protein', NULL, 'IglC', NULL, NULL, 15267, 9),
(258469, NULL, 'PF16981', NULL, NULL, 'chi-Conotoxin or t superfamily', NULL, 'Chi-conotoxin', NULL, NULL, 23795, 9),
(258470, NULL, 'PF05087', NULL, NULL, 'Rotavirus VP2 protein', NULL, 'Rota_VP2', NULL, NULL, 1174, 9),
(258471, NULL, 'PF09781', NULL, NULL, 'NADH:ubiquinone oxidoreductase, NDUFB5/SGDH subunit', NULL, 'NDUF_B5', NULL, NULL, 18017, 9),
(258472, NULL, 'PF00418', NULL, NULL, 'Tau and MAP protein, tubulin-binding repeat', NULL, 'Tubulin-binding', NULL, NULL, 2304, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(258473, NULL, 'PF05298', NULL, NULL, 'Bombinin', NULL, 'Bombinin', NULL, NULL, 4231, 9),
(258474, NULL, 'PF12196', NULL, NULL, 'FHA Ki67 binding domain of hNIFK', NULL, 'hNIFK_binding', NULL, NULL, 15328, 9),
(258475, NULL, 'PF04774', NULL, NULL, 'Hyaluronan / mRNA binding family', NULL, 'HABP4_PAI-RBP1', NULL, NULL, 3574, 9),
(258476, NULL, 'PF07522', NULL, NULL, 'DNA repair metallo-beta-lactamase', NULL, 'DRMBL', NULL, NULL, 11292, 9),
(258477, NULL, 'PF12619', NULL, NULL, 'Mini-chromosome maintenance protein 2', NULL, 'MCM2_N', NULL, NULL, 5456, 9),
(258478, NULL, 'PF20516', NULL, NULL, 'PD-(D/E)XK nuclease superfamily', NULL, 'PDDEXK_12', NULL, NULL, 37423, 9),
(258479, NULL, 'PF07842', NULL, NULL, 'GC-rich sequence DNA-binding factor-like protein', NULL, 'GCFC', NULL, NULL, 14555, 9),
(258480, NULL, 'PF17149', NULL, NULL, 'Periplasmic sensor domain found in signal transduction proteins', NULL, 'CHASE5', NULL, NULL, 29416, 9),
(258481, NULL, 'PF01882', NULL, NULL, 'Protein of unknown function DUF58', NULL, 'DUF58', NULL, NULL, 5597, 9),
(258482, NULL, 'PF10579', NULL, NULL, 'Rapsyn N-terminal myristoylation and linker region', NULL, 'Rapsyn_N', NULL, NULL, 19293, 9),
(258483, NULL, 'PF01552', NULL, NULL, 'Picornavirus 2B protein', NULL, 'Pico_P2B', NULL, NULL, 797, 9),
(258484, NULL, 'PF12302', NULL, NULL, 'Protein of unknown function (DUF3629)', NULL, 'DUF3629', NULL, NULL, 20680, 9),
(258485, NULL, 'PF02914', NULL, NULL, 'Bacteriophage Mu transposase', NULL, 'DDE_2', NULL, NULL, 2815, 9),
(258486, NULL, 'PF09939', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2171)', NULL, 'DUF2171', NULL, NULL, 17217, 9),
(258487, NULL, 'PF19613', NULL, NULL, 'Family of unknown function (DUF6118)', NULL, 'DUF6118', NULL, NULL, 37146, 9),
(258488, NULL, 'PF14335', NULL, NULL, 'Domain of unknown function (DUF4391)', NULL, 'DUF4391', NULL, NULL, 26152, 9),
(258489, NULL, 'PF01389', NULL, NULL, 'OmpA-like transmembrane domain', NULL, 'OmpA_membrane', NULL, NULL, 5855, 9),
(258490, NULL, 'PF12308', NULL, NULL, 'Neurogenesis glycoprotein', NULL, 'Noelin-1', NULL, NULL, 20728, 9),
(258491, NULL, 'PF04208', NULL, NULL, 'Tetrahydromethanopterin S-methyltransferase, subunit A', NULL, 'MtrA', NULL, NULL, 26699, 9),
(258492, NULL, 'PF05480', NULL, NULL, 'Phenol-soluble modulin beta protein', NULL, 'PSMbeta', NULL, NULL, 13955, 9),
(258493, NULL, 'PF02946', NULL, NULL, 'GTF2I-like repeat', NULL, 'GTF2I', NULL, NULL, 3855, 9),
(258494, NULL, 'PF01925', NULL, NULL, 'Sulfite exporter TauE/SafE', NULL, 'TauE', NULL, NULL, 4592, 9),
(258495, NULL, 'PF06133', NULL, NULL, 'Control of competence regulator ComK, YlbF/YmcA', NULL, 'Com_YlbF', NULL, NULL, 8957, 9),
(258496, NULL, 'PF12493', NULL, NULL, 'Protein of unknown function (DUF3709)', NULL, 'DUF3709', NULL, NULL, 21003, 9),
(258497, NULL, 'PF16855', NULL, NULL, 'Small outer capsid protein', NULL, 'Soc', NULL, NULL, 22663, 9),
(258498, NULL, 'PF18446', NULL, NULL, 'Domain of unknown function (DUF5611)', NULL, 'DUF5611', NULL, NULL, 27988, 9),
(258499, NULL, 'PF09096', NULL, NULL, 'Baseplate structural protein, domain 2', NULL, 'Phage-tail_2', NULL, NULL, 10740, 9),
(258500, NULL, 'PF19487', NULL, NULL, 'Family of unknown function (DUF6023)', NULL, 'DUF6023', NULL, NULL, 36995, 9),
(258501, NULL, 'PF19562', NULL, NULL, 'Family of unknown function (DUF6084)', NULL, 'DUF6084', NULL, NULL, 34258, 9),
(258502, NULL, 'PF04483', NULL, NULL, 'Protein of unknown function (DUF565)', NULL, 'DUF565', NULL, NULL, 1641, 9),
(258503, NULL, 'PF14764', NULL, NULL, 'AP-5 complex subunit, vesicle trafficking', NULL, 'SPG48', NULL, NULL, 23798, 9),
(258504, NULL, 'PF13902', NULL, NULL, 'R3H-associated N-terminal domain', NULL, 'R3H-assoc', NULL, NULL, 21740, 9),
(258505, NULL, 'PF16709', NULL, NULL, 'Ig domain of plant-specific actin-binding protein', NULL, 'SCAB-Ig', NULL, NULL, NULL, 9),
(258506, NULL, 'PF01825', NULL, NULL, 'GPCR proteolysis site, GPS, motif', NULL, 'GPS', NULL, NULL, 3639, 9),
(258507, NULL, 'PF04117', NULL, NULL, 'Mpv17 / PMP22 family', NULL, 'Mpv17_PMP22', NULL, NULL, 6998, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(258508, NULL, 'PF15185', NULL, NULL, 'Bcl-2-modifying factor, apoptosis', NULL, 'BMF', NULL, NULL, 22122, 9),
(258509, NULL, 'PF02709', NULL, NULL, 'N-terminal domain of galactosyltransferase', NULL, 'Glyco_transf_7C', NULL, NULL, 23697, 9),
(258510, NULL, 'PF08181', NULL, NULL, 'DegQ (SacQ) family', NULL, 'DegQ', NULL, NULL, 8887, 9),
(258511, NULL, 'PF06053', NULL, NULL, 'Domain of unknown function (DUF929)', NULL, 'DUF929', NULL, NULL, 13572, 9),
(258512, NULL, 'PF14919', NULL, NULL, 'MDM2-binding', NULL, 'MTBP_mid', NULL, NULL, 23608, 9),
(258513, NULL, 'PF19988', NULL, NULL, 'Family of unknown function (DUF6424)', NULL, 'DUF6424', NULL, NULL, 37532, 9),
(258514, NULL, 'PF13265', NULL, NULL, 'Protein of unknown function (DUF4056)', NULL, 'DUF4056', NULL, NULL, 22888, 9),
(258515, NULL, 'PF08546', NULL, NULL, 'Ketopantoate reductase PanE/ApbA C terminal', NULL, 'ApbA_C', NULL, NULL, 7818, 9),
(258516, NULL, 'PF12902', NULL, NULL, 'Ferritin-like', NULL, 'Ferritin-like', NULL, NULL, 22135, 9),
(258517, NULL, 'PF19063', NULL, NULL, 'Family of unknown function (DUF5759)', NULL, 'DUF5759', NULL, NULL, 35932, 9),
(258518, NULL, 'PF06899', NULL, NULL, 'WzyE protein, O-antigen assembly polymerase', NULL, 'WzyE', NULL, NULL, 9273, 9),
(258519, NULL, 'PF08367', NULL, NULL, 'Peptidase M16C associated', NULL, 'M16C_assoc', NULL, NULL, 11853, 9),
(258520, NULL, 'PF14751', NULL, NULL, 'Domain of unknown function (DUF4474)', NULL, 'DUF4474', NULL, NULL, 26707, 9),
(258521, NULL, 'PF01889', NULL, NULL, 'Membrane protein of unknown function DUF63', NULL, 'DUF63', NULL, NULL, 3848, 9),
(258522, NULL, 'PF18384', NULL, NULL, 'Unkempt Zinc finger domain 1 (Znf1)', NULL, 'zf_CCCH_5', NULL, NULL, 27731, 9),
(258523, NULL, 'PF04620', NULL, NULL, 'Flagellar filament outer layer protein Flaa', NULL, 'FlaA', NULL, NULL, 2188, 9),
(258524, NULL, 'PF02324', NULL, NULL, 'Glycosyl hydrolase family 70', NULL, 'Glyco_hydro_70', NULL, NULL, 4149, 9),
(258525, NULL, 'PF08863', NULL, NULL, 'YolD-like protein', NULL, 'YolD', NULL, NULL, 14191, 9),
(258526, NULL, 'PF01350', NULL, NULL, 'Flavivirus non-structural protein NS4A', NULL, 'Flavi_NS4A', NULL, NULL, 6648, 9),
(258527, NULL, 'PF18750', NULL, NULL, 'Secreted Novel AID/APOBEC-like Deaminase 4', NULL, 'SNAD4', NULL, NULL, NULL, 9),
(258528, NULL, 'PF08247', NULL, NULL, 'ENOD40 protein', NULL, 'ENOD40', NULL, NULL, 17496, 9),
(258529, NULL, 'PF00081', NULL, NULL, 'Iron/manganese superoxide dismutases, alpha-hairpin domain', NULL, 'Sod_Fe_N', NULL, NULL, 17461, 9),
(258530, NULL, 'PF10311', NULL, NULL, 'Increased loss of mitochondrial DNA protein 1', NULL, 'Ilm1', NULL, NULL, 19776, 9),
(258531, NULL, 'PF10859', NULL, NULL, 'Protein of unknown function (DUF2660)', NULL, 'DUF2660', NULL, NULL, 16448, 9),
(258532, NULL, 'PF12330', NULL, NULL, 'Haspin like kinase domain', NULL, 'Haspin_kinase', NULL, NULL, NULL, 9),
(258533, NULL, 'PF09403', NULL, NULL, 'Adhesion protein FadA', NULL, 'FadA', NULL, NULL, 14856, 9),
(258534, NULL, 'PF12957', NULL, NULL, 'Domain of unknown function (DUF3846)', NULL, 'DUF3846', NULL, NULL, 21742, 9),
(258535, NULL, 'PF17234', NULL, NULL, 'Mitochondrial peculiar membrane protein 1', NULL, 'MPM1', NULL, NULL, 20431, 9),
(258536, NULL, 'PF09595', NULL, NULL, 'Metaviral_G glycoprotein', NULL, 'Metaviral_G', NULL, NULL, 15992, 9),
(258537, NULL, 'PF17375', NULL, NULL, 'Family of unknown function (DUF5397)', NULL, 'DUF5397', NULL, NULL, 29732, 9),
(258538, NULL, 'PF18376', NULL, NULL, 'Mevalonate 5-diphosphate decarboxylase C-terminal domain', NULL, 'MDD_C', NULL, NULL, 30865, 9),
(258539, NULL, 'PF05225', NULL, NULL, 'helix-turn-helix, Psq domain', NULL, 'HTH_psq', NULL, NULL, 3423, 9),
(258540, NULL, 'PF17826', NULL, NULL, 'Family of unknown function (DUF5588)', NULL, 'DUF5588', NULL, NULL, 29031, 9),
(258541, NULL, 'PF03861', NULL, NULL, 'ANTAR domain', NULL, 'ANTAR', NULL, NULL, 1537, 9),
(258542, NULL, 'PF20008', NULL, NULL, 'Domain of unknown function (DUF6429)', NULL, 'DUF6429', NULL, NULL, 35649, 9),
(258543, NULL, 'PF12298', NULL, NULL, 'Eukaryotic mitochondrial regulator protein', NULL, 'Bot1p', NULL, NULL, NULL, 9);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(258544, NULL, 'PF06866', NULL, NULL, 'Protein of unknown function (DUF1256)', NULL, 'DUF1256', NULL, NULL, 11708, 9),
(258545, NULL, 'PF04134', NULL, NULL, 'DCC1-like thiol-disulfide oxidoreductase', NULL, 'DCC1-like', NULL, NULL, 6771, 9),
(258546, NULL, 'PF09654', NULL, NULL, 'Protein of unknown function (DUF2396)', NULL, 'DUF2396', NULL, NULL, 10214, 9),
(258547, NULL, 'PF02582', NULL, NULL, 'RMND1/Sif2-Sif3/Mrx10, DUF155', NULL, 'DUF155', NULL, NULL, 2035, 9),
(258548, NULL, 'PF16557', NULL, NULL, 'CUT1-like DNA-binding domain of SATB', NULL, 'CUTL', NULL, NULL, 26191, 9),
(258549, NULL, 'PF03495', NULL, NULL, 'Clostridial binary toxin B/anthrax toxin PA Ca-binding domain', NULL, 'Binary_toxB', NULL, NULL, 27706, 9),
(258550, NULL, 'PF12707', NULL, NULL, 'Protein of unknown function (DUF3804)', NULL, 'DUF3804', NULL, NULL, 24907, 9),
(258551, NULL, 'PF18853', NULL, NULL, 'Large polyvalent protein associated domain 37', NULL, 'LPD37', NULL, NULL, 28915, 9),
(258552, NULL, 'PF14861', NULL, NULL, 'Plant antimicrobial peptide', NULL, 'Antimicrobial21', NULL, NULL, 26518, 9),
(258553, NULL, 'PF04995', NULL, NULL, 'Heme exporter protein D (CcmD)', NULL, 'CcmD', NULL, NULL, 7328, 9),
(258554, NULL, 'PF05206', NULL, NULL, 'Methyltransferase TRM13', NULL, 'TRM13', NULL, NULL, 3022, 9),
(258555, NULL, 'PF05610', NULL, NULL, 'Protein of unknown function (DUF779)', NULL, 'DUF779', NULL, NULL, 12047, 9),
(258556, NULL, 'PF12449', NULL, NULL, 'Protein of unknown function (DUF3684)', NULL, 'DUF3684', NULL, NULL, 20935, 9),
(258557, NULL, 'PF02601', NULL, NULL, 'Exonuclease VII, large subunit', NULL, 'Exonuc_VII_L', NULL, NULL, 19348, 9),
(258558, NULL, 'PF10055', NULL, NULL, 'Uncharacterized small protein (DUF2292)', NULL, 'DUF2292', NULL, NULL, 18271, 9),
(258559, NULL, 'PF12989', NULL, NULL, 'Domain of unknown function, B. Theta Gene description (DUF3873)', NULL, 'DUF3873', NULL, NULL, 23327, 9),
(258560, NULL, 'PF05529', NULL, NULL, 'Bap31/Bap29 transmembrane region', NULL, 'Bap31', NULL, NULL, 28637, 9),
(258561, NULL, 'PF01483', NULL, NULL, 'Proprotein convertase P-domain', NULL, 'P_proprotein', NULL, NULL, 5511, 9),
(258562, NULL, 'PF11087', NULL, NULL, 'PRD1 phage membrane DNA delivery', NULL, 'PRD1_DD', NULL, NULL, 12847, 9),
(258563, NULL, 'PF18862', NULL, NULL, 'ApeA N-terminal domain 1', NULL, 'ApeA_NTD1', NULL, NULL, 29089, 9),
(258564, NULL, 'PF01287', NULL, NULL, 'Eukaryotic elongation factor 5A hypusine, DNA-binding OB fold', NULL, 'eIF-5a', NULL, NULL, 17742, 9),
(258565, NULL, 'PF06060', NULL, NULL, 'Pre-pro-megakaryocyte potentiating factor precursor (Mesothelin)', NULL, 'Mesothelin', NULL, NULL, 8916, 9),
(258566, NULL, 'PF20085', NULL, NULL, 'Protein-glutamine gamma-glutamyltransferase', NULL, 'TGL', NULL, NULL, 20565, 9),
(258567, NULL, 'PF20586', NULL, NULL, 'Family of unknown function (DUF6788)', NULL, 'DUF6788', NULL, NULL, 37242, 9),
(258568, NULL, 'PF11586', NULL, NULL, 'Protein of unknown function (DUF3242)', NULL, 'DUF3242', NULL, NULL, 18502, 9),
(258569, NULL, 'PF16319', NULL, NULL, 'Domain of unknown function (DUF4958)', NULL, 'DUF4958', NULL, NULL, 25288, 9),
(258570, NULL, 'PF04740', NULL, NULL, 'LXG domain of WXG superfamily', NULL, 'LXG', NULL, NULL, 3883, 9),
(258571, NULL, 'PF15074', NULL, NULL, 'Domain of unknown function (DUF4541)', NULL, 'DUF4541', NULL, NULL, 23339, 9),
(258572, NULL, 'PF14677', NULL, NULL, 'FANCI solenoid 3', NULL, 'FANCI_S3', NULL, NULL, 26999, 9),
(258573, NULL, 'PF03012', NULL, NULL, 'Phosphoprotein', NULL, 'PP_M1', NULL, NULL, 5343, 9),
(258574, NULL, 'PF09128', NULL, NULL, 'Regulator of G protein signalling-like domain', NULL, 'RGS-like', NULL, NULL, 10996, 9),
(258575, NULL, 'PF18809', NULL, NULL, 'phage-Barnase-EndoU-ColicinE5/D-RelE like nuclease1', NULL, 'PBECR1', NULL, NULL, 29405, 9),
(258576, NULL, 'PF19347', NULL, NULL, 'Domain of unknown function (DUF5925)', NULL, 'DUF5925', NULL, NULL, 36961, 9),
(258577, NULL, 'PF10565', NULL, NULL, 'N-methyl D-aspartate receptor 2B3 C-terminus', NULL, 'NMDAR2_C', NULL, NULL, 20828, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(258578, NULL, 'PF12571', NULL, NULL, 'Phage tail-collar fibre protein', NULL, 'DUF3751', NULL, NULL, 21351, 9),
(258579, NULL, 'PF15679', NULL, NULL, 'Domain of unknown function (DUF4665)', NULL, 'DUF4665', NULL, NULL, 25099, 9),
(258580, NULL, 'PF03482', NULL, NULL, 'sic protein repeat', NULL, 'SIC', NULL, NULL, 541, 9),
(258581, NULL, 'PF19125', NULL, NULL, 'Family of unknown function (DUF5809)', NULL, 'DUF5809', NULL, NULL, 35782, 9),
(258582, NULL, 'PF18487', NULL, NULL, 'Thrombospondin type 1 repeat', NULL, 'TSR', NULL, NULL, NULL, 9),
(258583, NULL, 'PF09229', NULL, NULL, 'Activator of Hsp90 ATPase, N-terminal', NULL, 'Aha1_N', NULL, NULL, 13052, 9),
(258584, NULL, 'PF04598', NULL, NULL, 'Gasdermin pore forming domain', NULL, 'Gasdermin', NULL, NULL, 27536, 9),
(258585, NULL, 'PF08942', NULL, NULL, 'Domain of unknown function (DUF1919)', NULL, 'DUF1919', NULL, NULL, 7767, 9),
(258586, NULL, 'PF09208', NULL, NULL, 'Restriction endonuclease MspI', NULL, 'Endonuc-MspI', NULL, NULL, 12366, 9),
(258587, NULL, 'PF15953', NULL, NULL, 'Putative propanediol utilisation', NULL, 'PDU_like', NULL, NULL, 21652, 9),
(258588, NULL, 'PF05085', NULL, NULL, 'Protein of unknown function (DUF685)', NULL, 'DUF685', NULL, NULL, 1140, 9),
(258589, NULL, 'PF05907', NULL, NULL, 'CXXC motif containing zinc binding protein, eukaryotic', NULL, 'CXXC_Zn-b_euk', NULL, NULL, 14018, 9),
(258590, NULL, 'PF10843', NULL, NULL, 'Respiratory growth induced protein 1', NULL, 'RGI1', NULL, NULL, 14557, 9),
(258591, NULL, 'PF14671', NULL, NULL, 'Dual specificity protein phosphatase, N-terminal half', NULL, 'DSPn', NULL, NULL, 21762, 9),
(258592, NULL, 'PF07228', NULL, NULL, 'Stage II sporulation protein E (SpoIIE)', NULL, 'SpoIIE', NULL, NULL, 2124, 9),
(258593, NULL, 'PF16872', NULL, NULL, 'Putative phage abortive infection protein', NULL, 'putAbiC', NULL, NULL, 24148, 9),
(258594, NULL, 'PF19529', NULL, NULL, 'Family of unknown function (DUF6057)', NULL, 'DUF6057', NULL, NULL, 36018, 9),
(258595, NULL, 'PF07090', NULL, NULL, 'Putative glutamine amidotransferase', NULL, 'GATase1_like', NULL, NULL, 10914, 9),
(258596, NULL, 'PF15288', NULL, NULL, 'Zinc knuckle', NULL, 'zf-CCHC_6', NULL, NULL, 30164, 9),
(258597, NULL, 'PF00686', NULL, NULL, 'Starch binding domain', NULL, 'CBM_20', NULL, NULL, 1274, 9),
(258598, NULL, 'PF10857', NULL, NULL, 'Protein of unknown function (DUF2701)', NULL, 'DUF2701', NULL, NULL, 16463, 9),
(258599, NULL, 'PF16208', NULL, NULL, 'Keratin type II head', NULL, 'Keratin_2_head', NULL, NULL, 23674, 9),
(258600, NULL, 'PF08123', NULL, NULL, 'Histone methylation protein DOT1', NULL, 'DOT1', NULL, NULL, 22662, 9),
(258601, NULL, 'PF11845', NULL, NULL, 'Protein of unknown function (DUF3365)', NULL, 'DUF3365', NULL, NULL, 19023, 9),
(258602, NULL, 'PF16615', NULL, NULL, 'Unstructured region one on RhoGEF 6 and 7', NULL, 'RhoGEF67_u1', NULL, NULL, NULL, 9),
(258603, NULL, 'PF00728', NULL, NULL, 'Glycosyl hydrolase family 20, catalytic domain', NULL, 'Glyco_hydro_20', NULL, NULL, 7118, 9),
(258604, NULL, 'PF08447', NULL, NULL, 'PAS fold', NULL, 'PAS_3', NULL, NULL, 11922, 9),
(258605, NULL, 'PF17161', NULL, NULL, 'Domain of unknown function (DUF5123)', NULL, 'DUF5123', NULL, NULL, 31417, 9),
(258606, NULL, 'PF05495', NULL, NULL, 'CHY zinc finger', NULL, 'zf-CHY', NULL, NULL, 7851, 9),
(258607, NULL, 'PF17612', NULL, NULL, 'Family of unknown function (DUF5507)', NULL, 'DUF5507', NULL, NULL, 19290, 9),
(258608, NULL, 'PF15146', NULL, NULL, 'Fanconi anemia-associated', NULL, 'FANCAA', NULL, NULL, 21527, 9),
(258609, NULL, 'PF16869', NULL, NULL, 'Condensin II complex subunit CAP-H2 or CNDH2, mid domain', NULL, 'CNDH2_M', NULL, NULL, 24327, 9),
(258610, NULL, 'PF06622', NULL, NULL, 'SepQ protein', NULL, 'SepQ', NULL, NULL, 10102, 9),
(258611, NULL, 'PF12122', NULL, NULL, 'Cytoplasmic N-terminal domain of rhomboid serine protease', NULL, 'Rhomboid_N', NULL, NULL, 16619, 9),
(258612, NULL, 'PF14820', NULL, NULL, 'Small proline-rich 2', NULL, 'SPRR2', NULL, NULL, 25579, 9),
(258613, NULL, 'PF20548', NULL, NULL, 'Family of unknown function (DUF6762)', NULL, 'DUF6762', NULL, NULL, 33545, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(258614, NULL, 'PF11492', NULL, NULL, 'Cricket paralysis virus, VP4', NULL, 'Dicistro_VP4', NULL, NULL, 22326, 9),
(258615, NULL, 'PF00948', NULL, NULL, 'Flavivirus non-structural Protein NS1', NULL, 'Flavi_NS1', NULL, NULL, 1345, 9),
(258616, NULL, 'PF09032', NULL, NULL, 'Siah interacting protein, N terminal', NULL, 'Siah-Interact_N', NULL, NULL, 9930, 9),
(258617, NULL, 'PF03289', NULL, NULL, 'Poxvirus protein I1', NULL, 'Pox_I1', NULL, NULL, 766, 9),
(258618, NULL, 'PF06130', NULL, NULL, 'Phosphate propanoyltransferase', NULL, 'PTAC', NULL, NULL, 8577, 9),
(258619, NULL, 'PF04015', NULL, NULL, 'Domain of unknown function (DUF362)', NULL, 'DUF362', NULL, NULL, 330, 9),
(258620, NULL, 'PF12939', NULL, NULL, 'Domain of unknown function (DUF3837)', NULL, 'DUF3837', NULL, NULL, 21433, 9),
(258621, NULL, 'PF03224', NULL, NULL, 'V-ATPase subunit H', NULL, 'V-ATPase_H_N', NULL, NULL, 1635, 9),
(258622, NULL, 'PF16158', NULL, NULL, 'Ig-like domain from next to BRCA1 gene', NULL, 'N_BRCA1_IG', NULL, NULL, 24171, 9),
(258623, NULL, 'PF02829', NULL, NULL, '3H domain', NULL, '3H', NULL, NULL, 2784, 9),
(258624, NULL, 'PF20478', NULL, NULL, 'P2X purinoreceptor 7 intracellular domain', NULL, 'P2RX7_C', NULL, NULL, 37682, 9),
(258625, NULL, 'PF09695', NULL, NULL, 'Bacterial protein of unknown function (YtfJ_HI0045)', NULL, 'YtfJ_HI0045', NULL, NULL, 6533, 9),
(258626, NULL, 'PF20309', NULL, NULL, 'Deoxyribohydrolase (DRHyd) domain of the ASK signalosome', NULL, 'DRHyd-ASK', NULL, NULL, 37685, 9),
(258627, NULL, 'PF17460', NULL, NULL, 'Uncharacterized protein RP854', NULL, 'RP854', NULL, NULL, 13702, 9),
(258628, NULL, 'PF16363', NULL, NULL, 'GDP-mannose 4,6 dehydratase', NULL, 'GDP_Man_Dehyd', NULL, NULL, 12608, 9),
(258629, NULL, 'PF18142', NULL, NULL, 'SMODS and SLOG-associating 2TM effector domain', NULL, 'SLATT_fungal', NULL, NULL, 30286, 9),
(258630, NULL, 'PF20216', NULL, NULL, 'Family of unknown function (DUF6576)', NULL, 'DUF6576', NULL, NULL, 37515, 9),
(258631, NULL, 'PF01263', NULL, NULL, 'Aldose 1-epimerase', NULL, 'Aldose_epim', NULL, NULL, 7221, 9),
(258632, NULL, 'PF13453', NULL, NULL, 'Transcription factor zinc-finger', NULL, 'zf-TFIIB', NULL, NULL, 21912, 9),
(258633, NULL, 'PF09342', NULL, NULL, 'Domain of unknown function (DUF1986)', NULL, 'DUF1986', NULL, NULL, 7032, 9),
(258634, NULL, 'PF16848', NULL, NULL, 'Substrate of the Dot/Icm secretion system, putative', NULL, 'SoDot-IcmSS', NULL, NULL, 22826, 9),
(258635, NULL, 'PF14471', NULL, NULL, 'Domain of unknown function (DUF4428)', NULL, 'DUF4428', NULL, NULL, 25984, 9),
(258636, NULL, 'PF11683', NULL, NULL, 'Protein of unknown function (DUF3278)', NULL, 'DUF3278', NULL, NULL, 19379, 9),
(258637, NULL, 'PF04842', NULL, NULL, 'Plant protein of unknown function (DUF639)', NULL, 'DUF639', NULL, NULL, 5038, 9),
(258638, NULL, 'PF05302', NULL, NULL, 'Protein of unknown function (DUF720)', NULL, 'DUF720', NULL, NULL, 4184, 9),
(258639, NULL, 'PF08500', NULL, NULL, 'Tombusvirus p33', NULL, 'Tombus_P33', NULL, NULL, 13791, 9),
(258640, NULL, 'PF01863', NULL, NULL, 'YgjP-like, metallopeptidase domain', NULL, 'YgjP-like', NULL, NULL, 3805, 9),
(258641, NULL, 'PF08161', NULL, NULL, 'NUC173 domain', NULL, 'NUC173', NULL, NULL, 11771, 9),
(258642, NULL, 'PF01738', NULL, NULL, 'Dienelactone hydrolase family', NULL, 'DLH', NULL, NULL, 6772, 9),
(258643, NULL, 'PF08083', NULL, NULL, 'PROCN (NUC071) domain', NULL, 'PROCN', NULL, NULL, 9382, 9),
(258644, NULL, 'PF16699', NULL, NULL, 'Cleavage stimulation factor subunit 1, dimerisation domain', NULL, 'CSTF1_dimer', NULL, NULL, 23334, 9),
(258645, NULL, 'PF01191', NULL, NULL, 'RNA polymerase Rpb5, C-terminal domain', NULL, 'RNA_pol_Rpb5_C', NULL, NULL, 6866, 9),
(258646, NULL, 'PF17071', NULL, NULL, 'Outer capsid protein VP7', NULL, 'Capsid_VP7', NULL, NULL, 23647, 9),
(258647, NULL, 'PF18207', NULL, NULL, 'Leukemia inhibitory factor receptor N-terminal domain', NULL, 'LIFR_N', NULL, NULL, 33085, 9),
(258648, NULL, 'PF05590', NULL, NULL, 'Xylella fastidiosa protein of unknown function (DUF769)', NULL, 'DUF769', NULL, NULL, 12260, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(258649, NULL, 'PF16046', NULL, NULL, 'FAM76 protein', NULL, 'FAM76', NULL, NULL, 22837, 9),
(258650, NULL, 'PF12297', NULL, NULL, 'Ellis van Creveld protein 2 like protein', NULL, 'EVC2_like', NULL, NULL, 20906, 9),
(258651, NULL, 'PF00096', NULL, NULL, 'Zinc finger, C2H2 type', NULL, 'zf-C2H2', NULL, NULL, 13910, 9),
(258652, NULL, 'PF10748', NULL, NULL, 'DNA utilization proteins HofP', NULL, 'HofP', NULL, NULL, 20160, 9),
(258653, NULL, 'PF04492', NULL, NULL, 'Bacteriophage replication protein O', NULL, 'Phage_rep_O', NULL, NULL, 6974, 9),
(258654, NULL, 'PF17666', NULL, NULL, 'Family of unknown function (DUF5528)', NULL, 'DUF5528', NULL, NULL, 29959, 9),
(258655, NULL, 'PF14493', NULL, NULL, 'Helix-turn-helix domain', NULL, 'HTH_40', NULL, NULL, 23108, 9),
(258656, NULL, 'PF13132', NULL, NULL, 'Domain of unknown function (DUF3950)', NULL, 'DUF3950', NULL, NULL, 25609, 9),
(258657, NULL, 'PF12015', NULL, NULL, 'Bud3, N-terminal', NULL, 'Bud3_N', NULL, NULL, 19989, 9),
(258658, NULL, 'PF02377', NULL, NULL, 'Dishevelled specific domain', NULL, 'Dishevelled', NULL, NULL, 4288, 9),
(258659, NULL, 'PF02448', NULL, NULL, 'L71 family', NULL, 'L71', NULL, NULL, 6422, 9),
(258660, NULL, 'PF02424', NULL, NULL, 'ApbE family', NULL, 'ApbE', NULL, NULL, 21855, 9),
(258661, NULL, 'PF03207', NULL, NULL, 'Borrelia outer surface protein D (OspD)', NULL, 'OspD', NULL, NULL, 73, 9),
(258662, NULL, 'PF11047', NULL, NULL, 'Salmonella outer protein D', NULL, 'SopD', NULL, NULL, 17431, 9),
(258663, NULL, 'PF07161', NULL, NULL, 'LppX_LprAFG lipoprotein', NULL, 'LppX_LprAFG', NULL, NULL, 13457, 9),
(258664, NULL, 'PF15466', NULL, NULL, 'Domain of unknown function (DUF4635)', NULL, 'DUF4635', NULL, NULL, 25928, 9),
(258665, NULL, 'PF00708', NULL, NULL, 'Acylphosphatase', NULL, 'Acylphosphatase', NULL, NULL, 4473, 9),
(258666, NULL, 'PF16618', NULL, NULL, 'Linker region between SH3 and WW domains on ARHGAP12', NULL, 'SH3-WW_linker', NULL, NULL, NULL, 9),
(258667, NULL, 'PF11144', NULL, NULL, 'Protein of unknown function (DUF2920)', NULL, 'DUF2920', NULL, NULL, 14537, 9),
(258668, NULL, 'PF16137', NULL, NULL, 'Domain of unknown function (DUF4845)', NULL, 'DUF4845', NULL, NULL, 26014, 9),
(258669, NULL, 'PF13942', NULL, NULL, 'YfhG lipoprotein', NULL, 'Lipoprotein_20', NULL, NULL, 23244, 9),
(258670, NULL, 'PF00841', NULL, NULL, 'Sperm histone P2', NULL, 'Protamine_P2', NULL, NULL, 5604, 9),
(258671, NULL, 'PF18119', NULL, NULL, 'RIG-I receptor C-terminal domain', NULL, 'RIG-I_C', NULL, NULL, 29383, 9),
(258672, NULL, 'PF19868', NULL, NULL, 'Family of unknown function (DUF6341)', NULL, 'DUF6341', NULL, NULL, 36971, 9),
(258673, NULL, 'PF15418', NULL, NULL, 'Domain of unknown function (DUF4625)', NULL, 'DUF4625', NULL, NULL, 21841, 9),
(258674, NULL, 'PF18452', NULL, NULL, 'Immunoglobulin domain', NULL, 'Ig_6', NULL, NULL, 30431, 9),
(258675, NULL, 'PF18824', NULL, NULL, 'Large polyvalent protein-associated domain 11', NULL, 'LPD11', NULL, NULL, 29280, 9),
(258676, NULL, 'PF01683', NULL, NULL, 'EB module', NULL, 'EB', NULL, NULL, 10023, 9),
(258677, NULL, 'PF03128', NULL, NULL, 'CXCXC repeat', NULL, 'CXCXC', NULL, NULL, 2787, 9),
(258678, NULL, 'PF04799', NULL, NULL, 'fzo-like conserved region', NULL, 'Fzo_mitofusin', NULL, NULL, 4836, 9),
(258679, NULL, 'PF12553', NULL, NULL, 'Protein of unknown function (DUF3742)', NULL, 'DUF3742', NULL, NULL, 21285, 9),
(258680, NULL, 'PF18529', NULL, NULL, 'Mitochondrial membrane-anchored proteins', NULL, 'MIX', NULL, NULL, 27593, 9),
(258681, NULL, 'PF11741', NULL, NULL, 'AMIN domain', NULL, 'AMIN', NULL, NULL, 19288, 9),
(258682, NULL, 'PF00732', NULL, NULL, 'GMC oxidoreductase', NULL, 'GMC_oxred_N', NULL, NULL, 3867, 9),
(258683, NULL, 'PF10160', NULL, NULL, 'Predicted membrane protein', NULL, 'Tmemb_40', NULL, NULL, 19167, 9),
(258684, NULL, 'PF07148', NULL, NULL, 'Maltose operon periplasmic protein precursor (MalM)', NULL, 'MalM', NULL, NULL, 10837, 9),
(258685, NULL, 'PF05355', NULL, NULL, 'Apolipoprotein C-II', NULL, 'Apo-CII', NULL, NULL, 5318, 9),
(258686, NULL, 'PF04950', NULL, NULL, '40S ribosome biogenesis protein Tsr1 and BMS1 C-terminal', NULL, 'RIBIOP_C', NULL, NULL, 6684, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(258687, NULL, 'PF05717', NULL, NULL, 'IS66 Orf2 like protein', NULL, 'TnpB_IS66', NULL, NULL, 7713, 9),
(258688, NULL, 'PF04770', NULL, NULL, 'ZF-HD protein dimerisation region', NULL, 'ZF-HD_dimer', NULL, NULL, 6857, 9),
(258689, NULL, 'PF10473', NULL, NULL, 'Leucine-rich repeats of kinetochore protein Cenp-F/LEK1', NULL, 'CENP-F_leu_zip', NULL, NULL, 18450, 9),
(258690, NULL, 'PF15332', NULL, NULL, 'Lck-interacting transmembrane adapter 1', NULL, 'LIME1', NULL, NULL, 21764, 9),
(258691, NULL, 'PF14232', NULL, NULL, 'Domain of unknown function (DUF4334)', NULL, 'DUF4334', NULL, NULL, 23265, 9),
(258692, NULL, 'PF19743', NULL, NULL, 'ASTN1/2 EGF-like and Fn(III) domains', NULL, 'ASTN1_2_EGF_Fn', NULL, NULL, 34550, 9),
(258693, NULL, 'PF08091', NULL, NULL, 'Spider insecticidal peptide', NULL, 'Toxin_21', NULL, NULL, 9543, 9),
(258694, NULL, 'PF06394', NULL, NULL, 'Pepsin inhibitor-3-like repeated domain', NULL, 'Pepsin-I3', NULL, NULL, 10377, 9),
(258695, NULL, 'PF11068', NULL, NULL, 'YlqD protein', NULL, 'YlqD', NULL, NULL, 17709, 9),
(258696, NULL, 'PF05851', NULL, NULL, 'Lentivirus virion infectivity factor (VIF)', NULL, 'Lentivirus_VIF', NULL, NULL, 12731, 9),
(258697, NULL, 'PF13955', NULL, NULL, 'Toxin Fst, type I toxin-antitoxin system', NULL, 'Fst_toxin', NULL, NULL, 21573, 9),
(258698, NULL, 'PF15251', NULL, NULL, 'Domain of unknown function (DUF4588)', NULL, 'DUF4588', NULL, NULL, 26810, 9),
(258699, NULL, 'PF08870', NULL, NULL, 'DNA sulphur modification protein DndE', NULL, 'DndE', NULL, NULL, 14028, 9),
(258700, NULL, 'PF19426', NULL, NULL, 'Mesoderm induction early response protein 1/3 C-terminal', NULL, 'MIER1_3_C', NULL, NULL, 36079, 9),
(258701, NULL, 'PF08396', NULL, NULL, 'Spider toxin omega agatoxin/Tx1 family', NULL, 'Toxin_34', NULL, NULL, 11097, 9),
(258702, NULL, 'PF06545', NULL, NULL, 'Protein of unknown function (DUF1116)', NULL, 'DUF1116', NULL, NULL, 9259, 9),
(258703, NULL, 'PF08309', NULL, NULL, 'LVIVD repeat', NULL, 'LVIVD', NULL, NULL, 17725, 9),
(258704, NULL, 'PF03542', NULL, NULL, 'Tuberin', NULL, 'Tuberin', NULL, NULL, 14727, 9),
(258705, NULL, 'PF11570', NULL, NULL, 'Coiled-coil receptor-binding R-domain of colicin E2', NULL, 'E2R135', NULL, NULL, 23152, 9),
(258706, NULL, 'PF07560', NULL, NULL, 'Domain of Unknown Function (DUF1539)', NULL, 'DUF1539', NULL, NULL, 13827, 9),
(258707, NULL, 'PF09748', NULL, NULL, 'Transcription factor subunit Med10 of Mediator complex', NULL, 'Med10', NULL, NULL, 18493, 9),
(258708, NULL, 'PF00577', NULL, NULL, 'Outer membrane usher protein', NULL, 'Usher', NULL, NULL, 6736, 9),
(258709, NULL, 'PF08062', NULL, NULL, 'P120R (NUC006) repeat', NULL, 'P120R', NULL, NULL, 9045, 9),
(258710, NULL, 'PF10542', NULL, NULL, 'Vitelline membrane cysteine-rich region', NULL, 'Vitelline_membr', NULL, NULL, 7823, 9),
(258711, NULL, 'PF12463', NULL, NULL, 'Protein of unknown function (DUF3689)', NULL, 'DUF3689', NULL, NULL, 20756, 9),
(258712, NULL, 'PF11811', NULL, NULL, 'Domain of unknown function (DUF3331)', NULL, 'DUF3331', NULL, NULL, 19357, 9),
(258713, NULL, 'PF20282', NULL, NULL, 'C-terminal domain 6 of the ABC-three component (ABC-3C) systems', NULL, 'CTD6', NULL, NULL, 34407, 9),
(258714, NULL, 'PF14557', NULL, NULL, 'Putative AphA-like transcriptional regulator', NULL, 'AphA_like', NULL, NULL, 26681, 9),
(258715, NULL, 'PF17436', NULL, NULL, 'Family of unknown function (DUF5415)', NULL, 'DUF5415', NULL, NULL, 27394, 9),
(258716, NULL, 'PF15003', NULL, NULL, 'HAUS augmin-like complex subunit 2', NULL, 'HAUS2', NULL, NULL, 21937, 9),
(258717, NULL, 'PF01073', NULL, NULL, '3-beta hydroxysteroid dehydrogenase/isomerase family', NULL, '3Beta_HSD', NULL, NULL, 5657, 9),
(258718, NULL, 'PF14685', NULL, NULL, 'Tricorn protease PDZ domain', NULL, 'Tricorn_PDZ', NULL, NULL, 21521, 9),
(258719, NULL, 'PF14828', NULL, NULL, 'Amnionless', NULL, 'Amnionless', NULL, NULL, 25618, 9),
(258720, NULL, 'PF05615', NULL, NULL, 'Tho complex subunit 7', NULL, 'THOC7', NULL, NULL, 12029, 9),
(258721, NULL, 'PF00116', NULL, NULL, 'Cytochrome C oxidase subunit II, periplasmic domain', NULL, 'COX2', NULL, NULL, 6856, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(258722, NULL, 'PF10050', NULL, NULL, 'Predicted metal-binding protein (DUF2284)', NULL, 'DUF2284', NULL, NULL, 19846, 9),
(258723, NULL, 'PF12158', NULL, NULL, 'Protein of unknown function (DUF3592)', NULL, 'DUF3592', NULL, NULL, 20449, 9),
(258724, NULL, 'PF03640', NULL, NULL, 'Secreted repeat of unknown function', NULL, 'Lipoprotein_15', NULL, NULL, 5471, 9),
(258725, NULL, 'PF04838', NULL, NULL, 'Baculoviridae late expression factor 5', NULL, 'Baculo_LEF5', NULL, NULL, 4661, 9),
(258726, NULL, 'PF14092', NULL, NULL, 'Domain of unknown function (DUF4270)', NULL, 'DUF4270', NULL, NULL, 22668, 9),
(258727, NULL, 'PF03254', NULL, NULL, 'Xyloglucan fucosyltransferase', NULL, 'XG_FTase', NULL, NULL, 1924, 9),
(258728, NULL, 'PF18107', NULL, NULL, 'Fission yeast centromere protein N-terminal domain', NULL, 'HTH_ABP1_N', NULL, NULL, 28832, 9),
(258729, NULL, 'PF01519', NULL, NULL, 'Protein of unknown function DUF16', NULL, 'DUF16', NULL, NULL, 5795, 9),
(258730, NULL, 'PF10591', NULL, NULL, 'Secreted protein acidic and rich in cysteine Ca binding region', NULL, 'SPARC_Ca_bdg', NULL, NULL, 20348, 9),
(258731, NULL, 'PF19919', NULL, NULL, 'MoxR-vWA-beta-propeller ternary system domain bpX3', NULL, 'bpX3', NULL, NULL, 37283, 9),
(258732, NULL, 'PF05636', NULL, NULL, 'HIGH Nucleotidyl Transferase', NULL, 'HIGH_NTase1', NULL, NULL, 12772, 9),
(258733, NULL, 'PF19932', NULL, NULL, 'Family of unknown function (DUF6395)', NULL, 'DUF6395', NULL, NULL, 36340, 9),
(258734, NULL, 'PF06362', NULL, NULL, 'Protein of unknown function (DUF1067)', NULL, 'DUF1067', NULL, NULL, 8063, 9),
(258735, NULL, 'PF00494', NULL, NULL, 'Squalene/phytoene synthase', NULL, 'SQS_PSY', NULL, NULL, 5146, 9),
(258736, NULL, 'PF05614', NULL, NULL, 'Circovirus ORF3', NULL, 'Circovir_ORF3', NULL, NULL, 12434, 9),
(258737, NULL, 'PF05915', NULL, NULL, 'Transmembrane proteins 230/134', NULL, 'TMEM_230_134', NULL, NULL, 14374, 9),
(258738, NULL, 'PF08551', NULL, NULL, 'Eukaryotic integral membrane protein (DUF1751)', NULL, 'DUF1751', NULL, NULL, 9552, 9),
(258739, NULL, 'PF14634', NULL, NULL, 'zinc-RING finger domain', NULL, 'zf-RING_5', NULL, NULL, 4043, 9),
(258740, NULL, 'PF11479', NULL, NULL, 'RNA silencing suppressor P21 C-terminal domain', NULL, 'Suppressor_P21', NULL, NULL, 18700, 9),
(258741, NULL, 'PF12326', NULL, NULL, 'N-glycosylation protein', NULL, 'EOS1', NULL, NULL, 15057, 9),
(258742, NULL, 'PF08321', NULL, NULL, 'PPP5 TPR repeat region', NULL, 'PPP5', NULL, NULL, 12918, 9),
(258743, NULL, 'PF18352', NULL, NULL, 'Phage protein Gp138 N-terminal domain', NULL, 'Gp138_N', NULL, NULL, 29518, 9),
(258744, NULL, 'PF03545', NULL, NULL, 'Yersinia virulence determinant (YopE)', NULL, 'YopE', NULL, NULL, 12236, 9),
(258745, NULL, 'PF14254', NULL, NULL, 'Domain of unknown function (DUF4348)', NULL, 'DUF4348', NULL, NULL, 26058, 9),
(258746, NULL, 'PF09874', NULL, NULL, 'Predicted membrane protein (DUF2101)', NULL, 'DUF2101', NULL, NULL, 16847, 9),
(258747, NULL, 'PF14257', NULL, NULL, 'Domain of unknown function (DUF4349)', NULL, 'DUF4349', NULL, NULL, 24657, 9),
(258748, NULL, 'PF12676', NULL, NULL, 'Protein of unknown function (DUF3796)', NULL, 'DUF3796', NULL, NULL, 20006, 9),
(258749, NULL, 'PF01151', NULL, NULL, 'GNS1/SUR4 family', NULL, 'ELO', NULL, NULL, 5196, 9),
(258750, NULL, 'PF09341', NULL, NULL, 'Transcription factor Pcc1', NULL, 'Pcc1', NULL, NULL, 7214, 9),
(258751, NULL, 'PF16841', NULL, NULL, 'Ca-dependent carbohydrate-binding module xylan-binding', NULL, 'CBM60', NULL, NULL, 24156, 9),
(258752, NULL, 'PF19385', NULL, NULL, 'Family of unknown function (DUF5960)', NULL, 'DUF5960', NULL, NULL, 36826, 9),
(258753, NULL, 'PF03368', NULL, NULL, 'Dicer dimerisation domain', NULL, 'Dicer_dimer', NULL, NULL, NULL, 9),
(258754, NULL, 'PF16732', NULL, NULL, 'Type IV minor pilin ComP, DNA uptake sequence receptor', NULL, 'ComP_DUS', NULL, NULL, 24323, 9),
(258755, NULL, 'PF15543', NULL, NULL, 'Bacterial toxin 5', NULL, 'Ntox5', NULL, NULL, 22444, 9),
(258756, NULL, 'PF18240', NULL, NULL, 'Photosystem II Psb31 protein', NULL, 'PSII_Pbs31', NULL, NULL, 29273, 9); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(258757, NULL, 'PF03943', NULL, NULL, 'TAP C-terminal domain', NULL, 'TAP_C', NULL, NULL, 2768, 9),
(258758, NULL, 'PF03369', NULL, NULL, 'Herpesvirus UL3 protein', NULL, 'Herpes_UL3', NULL, NULL, 2429, 9),
(258759, NULL, 'PF00698', NULL, NULL, 'Acyl transferase domain', NULL, 'Acyl_transf_1', NULL, NULL, 9362, 9),
(258760, NULL, 'PF12659', NULL, NULL, 'Telomere capping C-terminal wHTH', NULL, 'Stn1_C', NULL, NULL, 20188, 9),
(258761, NULL, 'PF16508', NULL, NULL, 'Second BRCT domain on Nijmegen syndrome breakage protein', NULL, 'NIBRIN_BRCT_II', NULL, NULL, 25027, 9),
(258762, NULL, 'PF00476', NULL, NULL, 'DNA polymerase family A', NULL, 'DNA_pol_A', NULL, NULL, 1069, 9),
(258763, NULL, 'PF14479', NULL, NULL, 'Prion-inhibition and propagation', NULL, 'HeLo', NULL, NULL, 23011, 9),
(258764, NULL, 'PF05859', NULL, NULL, 'Mis12 protein', NULL, 'Mis12', NULL, NULL, 12928, 9),
(258765, NULL, 'PF16500', NULL, NULL, 'Cyclin-A N-terminal APC/C binding region', NULL, 'Cyclin_N2', NULL, NULL, 24432, 9),
(258766, NULL, 'PF11094', NULL, NULL, 'Membrane-associated tegument protein', NULL, 'UL11', NULL, NULL, 22096, 9),
(258767, NULL, 'PF09818', NULL, NULL, 'ATPase of the ABC class', NULL, 'ABC_ATPase', NULL, NULL, 34159, 9),
(258768, NULL, 'PF16630', NULL, NULL, 'Unstructured region on APC between 1st and 2nd catenin-bdg motifs', NULL, 'APC_u5', NULL, NULL, NULL, 9),
(258769, NULL, 'PF16941', NULL, NULL, 'Putative cyclodextrin porin', NULL, 'CymA', NULL, NULL, 25857, 9),
(258770, NULL, 'PF16943', NULL, NULL, 'Cag pathogenicity island, type IV secretory system', NULL, 'T4SS_CagC', NULL, NULL, 25929, 9),
(258771, NULL, 'PF17499', NULL, NULL, 'Ant venom peptides', NULL, 'Pilosulin', NULL, NULL, NULL, 9),
(258772, NULL, 'PF00781', NULL, NULL, 'Diacylglycerol kinase catalytic domain', NULL, 'DAGK_cat', NULL, NULL, 4477, 9),
(258773, NULL, 'PF17344', NULL, NULL, 'Family of unknown function (DUF5374)', NULL, 'DUF5374', NULL, NULL, 19999, 9),
(258774, NULL, 'PF06284', NULL, NULL, 'Cytomegalovirus UL84 protein', NULL, 'Cytomega_UL84', NULL, NULL, 9472, 9),
(258775, NULL, 'PF14073', NULL, NULL, 'Centrosome localisation domain of Cep57', NULL, 'Cep57_CLD', NULL, NULL, 23434, 9),
(258776, NULL, 'PF02607', NULL, NULL, 'B12 binding domain', NULL, 'B12-binding_2', NULL, NULL, 2256, 9),
(258777, NULL, 'PF04813', NULL, NULL, 'Hepatocyte nuclear factor 1 (HNF-1), alpha isoform C terminus', NULL, 'HNF-1A_C', NULL, NULL, 4754, 9),
(258778, NULL, 'PF14707', NULL, NULL, 'C-terminal region of aryl-sulfatase', NULL, 'Sulfatase_C', NULL, NULL, NULL, 9),
(258779, NULL, 'PF12775', NULL, NULL, 'P-loop containing dynein motor region', NULL, 'AAA_7', NULL, NULL, NULL, 9),
(258780, NULL, 'PF03089', NULL, NULL, 'Recombination activating protein 2', NULL, 'RAG2', NULL, NULL, 4770, 9),
(258781, NULL, 'PF01740', NULL, NULL, 'STAS domain', NULL, 'STAS', NULL, NULL, 2727, 9),
(258782, NULL, 'PF06044', NULL, NULL, 'Dam-replacing family', NULL, 'DpnI', NULL, NULL, 8654, 9),
(258783, NULL, 'PF12315', NULL, NULL, 'Protein DA1', NULL, 'DA1-like', NULL, NULL, 20669, 9),
(258784, NULL, 'PF01292', NULL, NULL, 'Prokaryotic cytochrome b561', NULL, 'Ni_hydr_CYTB', NULL, NULL, 10563, 9),
(258785, NULL, 'PF16218', NULL, NULL, 'Peptidase family C101', NULL, 'Peptidase_C101', NULL, NULL, 15517, 9),
(258786, NULL, 'PF09546', NULL, NULL, 'Stage III sporulation protein AE (spore_III_AE)', NULL, 'Spore_III_AE', NULL, NULL, 8686, 9),
(258787, NULL, 'PF18915', NULL, NULL, 'Domain of unknown function (DUF5667)', NULL, 'DUF5667', NULL, NULL, 34175, 9),
(258788, NULL, 'PF19251', NULL, NULL, 'Family of unknown function (DUF5899)', NULL, 'DUF5899', NULL, NULL, 35697, 9),
(258789, NULL, 'PF17904', NULL, NULL, 'FMRP KH0 domain', NULL, 'KH_9', NULL, NULL, 27993, 9),
(258790, NULL, 'PF19800', NULL, NULL, 'Family of unknown function (DUF6283)', NULL, 'DUF6283', NULL, NULL, 37477, 9),
(258791, NULL, 'PF05014', NULL, NULL, 'Nucleoside 2-deoxyribosyltransferase', NULL, 'Nuc_deoxyrib_tr', NULL, NULL, 1359, 9),
(258792, NULL, 'PF17915', NULL, NULL, 'Reverse gyrase zinc finger', NULL, 'zf_Rg', NULL, NULL, 27946, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(258793, NULL, 'PF01004', NULL, NULL, 'Flavivirus envelope glycoprotein M', NULL, 'Flavi_M', NULL, NULL, 2710, 9),
(258794, NULL, 'PF16407', NULL, NULL, 'PKD-like family', NULL, 'PKD_2', NULL, NULL, 23702, 9),
(258795, NULL, 'PF17944', NULL, NULL, 'Arginine decarboxylase C-terminal helical extension', NULL, 'Arg_decarbox_C', NULL, NULL, 28825, 9),
(258796, NULL, 'PF13141', NULL, NULL, 'Protein of unknown function (DUF3979)', NULL, 'DUF3979', NULL, NULL, 22295, 9),
(258797, NULL, 'PF17360', NULL, NULL, 'Family of unknown function (DUF5386)', NULL, 'DUF5386', NULL, NULL, 29547, 9),
(258798, NULL, 'PF14041', NULL, NULL, 'LppP/LprE lipoprotein', NULL, 'Lipoprotein_21', NULL, NULL, 22340, 9),
(258799, NULL, 'PF05699', NULL, NULL, 'hAT family C-terminal dimerisation region', NULL, 'Dimer_Tnp_hAT', NULL, NULL, 7961, 9),
(258800, NULL, 'PF14682', NULL, NULL, 'Sporulation initiation phospho-transferase B, C-terminal', NULL, 'SPOB_ab', NULL, NULL, 11493, 9),
(258801, NULL, 'PF19622', NULL, NULL, 'Family of unknown function (DUF6127)', NULL, 'DUF6127', NULL, NULL, 37360, 9),
(258802, NULL, 'PF08877', NULL, NULL, 'MepB-like', NULL, 'MepB-like', NULL, NULL, 10679, 9),
(258803, NULL, 'PF15128', NULL, NULL, 'T-cell leukemia translocation-altered', NULL, 'T_cell_tran_alt', NULL, NULL, 17548, 9),
(258804, NULL, 'PF19948', NULL, NULL, 'Family of unknown function (DUF6410)', NULL, 'DUF6410', NULL, NULL, 37406, 9),
(258805, NULL, 'PF07734', NULL, NULL, 'F-box associated', NULL, 'FBA_1', NULL, NULL, 4, 9),
(258806, NULL, 'PF03112', NULL, NULL, 'Uncharacterized protein family (ORF7) DUF', NULL, 'DUF244', NULL, NULL, 4717, 9),
(258807, NULL, 'PF13321', NULL, NULL, 'Domain of unknown function (DUF4084)', NULL, 'DUF4084', NULL, NULL, 23459, 9),
(258808, NULL, 'PF12226', NULL, NULL, 'Turkey astrovirus capsid protein', NULL, 'Astro_capsid_p', NULL, NULL, 20105, 9),
(258809, NULL, 'PF05226', NULL, NULL, 'CHASE2 domain', NULL, 'CHASE2', NULL, NULL, 3249, 9),
(258810, NULL, 'PF19751', NULL, NULL, 'Family of unknown function (DUF6238)', NULL, 'DUF6238', NULL, NULL, 37439, 9),
(258811, NULL, 'PF00021', NULL, NULL, 'u-PAR/Ly-6 domain', NULL, 'UPAR_LY6', NULL, NULL, 9146, 9),
(258812, NULL, 'PF17284', NULL, NULL, 'Spermidine synthase tetramerisation domain', NULL, 'Spermine_synt_N', NULL, NULL, 28247, 9),
(258813, NULL, 'PF16874', NULL, NULL, 'Glycosyl hydrolase family 36 C-terminal domain', NULL, 'Glyco_hydro_36C', NULL, NULL, 24192, 9),
(258814, NULL, 'PF17783', NULL, NULL, 'CvfB-like winged helix domain', NULL, 'CvfB_WH', NULL, NULL, 27786, 9),
(258815, NULL, 'PF06059', NULL, NULL, 'Domain of Unknown Function (DUF930)', NULL, 'DUF930', NULL, NULL, 13780, 9),
(258816, NULL, 'PF01769', NULL, NULL, 'Divalent cation transporter', NULL, 'MgtE', NULL, NULL, 1991, 9),
(258817, NULL, 'PF17931', NULL, NULL, 'Tetracyclin repressor-like, C-terminal domain', NULL, 'TetR_C_23', NULL, NULL, 30029, 9),
(258818, NULL, 'PF07456', NULL, NULL, 'Heptaprenyl diphosphate synthase component I', NULL, 'Hpre_diP_synt_I', NULL, NULL, 12161, 9),
(258819, NULL, 'PF19195', NULL, NULL, 'Family of unknown function (DUF5870)', NULL, 'DUF5870', NULL, NULL, 35578, 9),
(258820, NULL, 'PF11553', NULL, NULL, 'Protein of unknown function (DUF3231)', NULL, 'DUF3231', NULL, NULL, 18787, 9),
(258821, NULL, 'PF06745', NULL, NULL, 'KaiC', NULL, 'ATPase', NULL, NULL, 12048, 9),
(258822, NULL, 'PF18232', NULL, NULL, 'Chalcone isomerase N-terminal domain', NULL, 'Chalcone_N', NULL, NULL, 31734, 9),
(258823, NULL, 'PF17490', NULL, NULL, 'L1 transposable element dsRBD-like domain', NULL, 'Tnp_22_dsRBD', NULL, NULL, 31195, 9),
(258824, NULL, 'PF13274', NULL, NULL, 'Protein of unknown function (DUF4065)', NULL, 'DUF4065', NULL, NULL, 25892, 9),
(258825, NULL, 'PF05289', NULL, NULL, 'Borrelia hemolysin accessory protein', NULL, 'BLYB', NULL, NULL, 4140, 9),
(258826, NULL, 'PF05408', NULL, NULL, 'Foot-and-mouth virus L-proteinase', NULL, 'Peptidase_C28', NULL, NULL, 12229, 9),
(258827, NULL, 'PF04992', NULL, NULL, 'RNA polymerase Rpb1, domain 6', NULL, 'RNA_pol_Rpb1_6', NULL, NULL, 7174, 9);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(258828, NULL, 'PF17587', NULL, NULL, 'Discriminator of mRNA degradation', NULL, 'Dmd', NULL, NULL, 28330, 9),
(258829, NULL, 'PF13720', NULL, NULL, 'Udp N-acetylglucosamine O-acyltransferase; Domain 2', NULL, 'Acetyltransf_11', NULL, NULL, 24631, 9),
(258830, NULL, 'PF12241', NULL, NULL, 'Trans-2-enoyl-CoA reductase catalytic region', NULL, 'Enoyl_reductase', NULL, NULL, 21388, 9),
(258831, NULL, 'PF07768', NULL, NULL, 'PVL ORF-50-like family', NULL, 'PVL_ORF50', NULL, NULL, 10709, 9),
(258832, NULL, 'PF19412', NULL, NULL, 'Domain of unknown function (DUF5982)', NULL, 'DUF5982', NULL, NULL, 36808, 9),
(258833, NULL, 'PF12252', NULL, NULL, 'SidE phosphodiesterase (PDE) domain', NULL, 'SidE_PDE', NULL, NULL, 15029, 9),
(258834, NULL, 'PF00118', NULL, NULL, 'TCP-1/cpn60 chaperonin family', NULL, 'Cpn60_TCP1', NULL, NULL, 2607, 9),
(258835, NULL, 'PF09135', NULL, NULL, 'Alb1', NULL, 'Alb1', NULL, NULL, 17009, 9),
(258836, NULL, 'PF12024', NULL, NULL, 'Domain of unknown function (DUF3512)', NULL, 'DUF3512', NULL, NULL, 20000, 9),
(258837, NULL, 'PF03468', NULL, NULL, 'XS domain', NULL, 'XS', NULL, NULL, 6435, 9),
(258838, NULL, 'PF15007', NULL, NULL, 'Centrosomal spindle body, CEP44', NULL, 'CEP44', NULL, NULL, 26678, 9),
(258839, NULL, 'PF04731', NULL, NULL, 'Caudal like protein activation region', NULL, 'Caudal_act', NULL, NULL, 3938, 9),
(258840, NULL, 'PF04809', NULL, NULL, 'HupH hydrogenase expression protein, C-terminal conserved region', NULL, 'HupH_C', NULL, NULL, 4531, 9),
(258841, NULL, 'PF15421', NULL, NULL, 'Putative polysaccharide deacetylase', NULL, 'Polysacc_deac_3', NULL, NULL, 22147, 9),
(258842, NULL, 'PF08392', NULL, NULL, 'FAE1/Type III polyketide synthase-like protein', NULL, 'FAE1_CUT1_RppA', NULL, NULL, 11384, 9),
(258843, NULL, 'PF02511', NULL, NULL, 'Thymidylate synthase complementing protein', NULL, 'Thy1', NULL, NULL, 1196, 9),
(258844, NULL, 'PF09214', NULL, NULL, 'Bacteriophage Prd1, adsorption protein P2', NULL, 'Prd1-P2', NULL, NULL, 12521, 9),
(258845, NULL, 'PF09498', NULL, NULL, 'Protein of unknown function (DUF2388)', NULL, 'DUF2388', NULL, NULL, 10660, 9),
(258846, NULL, 'PF06505', NULL, NULL, 'Activator of aromatic catabolism', NULL, 'XylR_N', NULL, NULL, 12319, 9),
(258847, NULL, 'PF18398', NULL, NULL, 'Clip-domain serine protease homolog masquerade', NULL, 'CLIP_SPH_mas', NULL, NULL, 27504, 9),
(258848, NULL, 'PF00506', NULL, NULL, 'Influenza virus nucleoprotein', NULL, 'Flu_NP', NULL, NULL, 1126, 9),
(258849, NULL, 'PF03895', NULL, NULL, 'YadA-like membrane anchor domain', NULL, 'YadA_anchor', NULL, NULL, 2566, 9),
(258850, NULL, 'PF04637', NULL, NULL, 'Herpesvirus phosphoprotein 85 (HHV6-7 U14/HCMV UL25)', NULL, 'Herpes_pp85', NULL, NULL, 2792, 9),
(258851, NULL, 'PF19491', NULL, NULL, 'Family of unknown function (DUF6026)', NULL, 'DUF6026', NULL, NULL, 36912, 9),
(258852, NULL, 'PF08724', NULL, NULL, 'Rep protein catalytic domain like', NULL, 'Rep_N', NULL, NULL, 11728, 9),
(258853, NULL, 'PF01554', NULL, NULL, 'MatE', NULL, 'MatE', NULL, NULL, 549, 9),
(258854, NULL, 'PF12028', NULL, NULL, 'Protein of unknown function (DUF3515)', NULL, 'DUF3515', NULL, NULL, 19822, 9),
(258855, NULL, 'PF14568', NULL, NULL, 'SMI1-KNR4 cell-wall', NULL, 'SUKH_6', NULL, NULL, NULL, 9),
(258856, NULL, 'PF17151', NULL, NULL, 'Periplasmic sensor domain', NULL, 'CHASE7', NULL, NULL, 29027, 9),
(258857, NULL, 'PF12797', NULL, NULL, '4Fe-4S binding domain', NULL, 'Fer4_2', NULL, NULL, 12567, 9),
(258858, NULL, 'PF13408', NULL, NULL, 'Recombinase zinc beta ribbon domain', NULL, 'Zn_ribbon_recom', NULL, NULL, 24131, 9),
(258859, NULL, 'PF16647', NULL, NULL, 'Granulocyte colony-stimulating factor', NULL, 'GCSF', NULL, NULL, 27460, 9),
(258860, NULL, 'PF12421', NULL, NULL, 'Fibronectin type III protein', NULL, 'DUF3672', NULL, NULL, 15381, 9),
(258861, NULL, 'PF18635', NULL, NULL, 'Epithelial cell adhesion molecule N-terminal domain', NULL, 'EpCAM_N', NULL, NULL, 30126, 9),
(258862, NULL, 'PF20280', NULL, NULL, 'C-terminal domain 4 of the ABC-three component (ABC-3C) systems', NULL, 'CTD4', NULL, NULL, 34094, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(258863, NULL, 'PF02821', NULL, NULL, 'Staphylokinase/Streptokinase family', NULL, 'Staphylokinase', NULL, NULL, 1920, 9),
(258864, NULL, 'PF20269', NULL, NULL, 'CASPASE and TPR Repeat-Associated N-terminal domain', NULL, 'CATRA-N', NULL, NULL, 37720, 9),
(258865, NULL, 'PF16494', NULL, NULL, 'C-terminal extension of sodium/calcium exchanger domain', NULL, 'Na_Ca_ex_C', NULL, NULL, 24404, 9),
(258866, NULL, 'PF05278', NULL, NULL, 'Arabidopsis phospholipase-like protein (PEARLI 4)', NULL, 'PEARLI-4', NULL, NULL, 4472, 9),
(258867, NULL, 'PF07272', NULL, NULL, 'Orthoreovirus P17 protein', NULL, 'Orthoreo_P17', NULL, NULL, 14076, 9),
(258868, NULL, 'PF09448', NULL, NULL, 'Methylmuconolactone methyl-isomerase', NULL, 'MmlI', NULL, NULL, 15442, 9),
(258869, NULL, 'PF18583', NULL, NULL, 'Aminoarabinose transferase C-terminal domain', NULL, 'Arnt_C', NULL, NULL, 32244, 9),
(258870, NULL, 'PF15298', NULL, NULL, 'AJAP1/PANP C-terminus', NULL, 'AJAP1_PANP_C', NULL, NULL, 26666, 9),
(258871, NULL, 'PF17871', NULL, NULL, 'AAA lid domain', NULL, 'AAA_lid_9', NULL, NULL, 30615, 9),
(258872, NULL, 'PF00443', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase', NULL, 'UCH', NULL, NULL, 7304, 9),
(258873, NULL, 'PF09801', NULL, NULL, 'Integral membrane protein S linking to the trans Golgi network', NULL, 'SYS1', NULL, NULL, 18134, 9),
(258874, NULL, 'PF04728', NULL, NULL, 'Lipoprotein leucine-zipper', NULL, 'LPP', NULL, NULL, 3955, 9),
(258875, NULL, 'PF18651', NULL, NULL, 'Surface adhesin CshA non-repetitive domain 2', NULL, 'CshA_NR2', NULL, NULL, 28093, 9),
(258876, NULL, 'PF06419', NULL, NULL, 'Conserved oligomeric complex COG6', NULL, 'COG6', NULL, NULL, 10337, 9),
(258877, NULL, 'PF12723', NULL, NULL, 'Protein of unknown function (DUF3809)', NULL, 'DUF3809', NULL, NULL, 20692, 9),
(258878, NULL, 'PF05811', NULL, NULL, 'Eukaryotic protein of unknown function (DUF842)', NULL, 'DUF842', NULL, NULL, 13001, 9),
(258879, NULL, 'PF01503', NULL, NULL, 'Phosphoribosyl-ATP pyrophosphohydrolase', NULL, 'PRA-PH', NULL, NULL, 15412, 9),
(258880, NULL, 'PF08294', NULL, NULL, 'TIM21', NULL, 'TIM21', NULL, NULL, 13193, 9),
(258881, NULL, 'PF14946', NULL, NULL, 'Domain of unknown function (DUF4501)', NULL, 'DUF4501', NULL, NULL, 25601, 9),
(258882, NULL, 'PF09954', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2188)', NULL, 'DUF2188', NULL, NULL, 17129, 9),
(258883, NULL, 'PF17804', NULL, NULL, 'Tail specific protease N-terminal domain', NULL, 'TSP_NTD', NULL, NULL, 27532, 9),
(258884, NULL, 'PF11242', NULL, NULL, 'Protein of unknown function (DUF2774)', NULL, 'DUF2774', NULL, NULL, 18433, 9),
(258885, NULL, 'PF07692', NULL, NULL, 'Low iron-inducible periplasmic protein', NULL, 'Fea1', NULL, NULL, 10946, 9),
(258886, NULL, 'PF12796', NULL, NULL, 'Ankyrin repeats (3 copies)', NULL, 'Ank_2', NULL, NULL, 1485, 9),
(258887, NULL, 'PF10658', NULL, NULL, 'Protein of unknown function (DUF2484)', NULL, 'DUF2484', NULL, NULL, 14602, 9),
(258888, NULL, 'PF15130', NULL, NULL, 'Domain of unknown function (DUF4566)', NULL, 'DUF4566', NULL, NULL, 23302, 9),
(258889, NULL, 'PF05825', NULL, NULL, 'Beta-microseminoprotein (PSP-94)', NULL, 'PSP94', NULL, NULL, 12192, 9),
(258890, NULL, 'PF07822', NULL, NULL, 'Neurotoxin B-IV-like protein', NULL, 'Toxin_13', NULL, NULL, 12643, 9),
(258891, NULL, 'PF12477', NULL, NULL, 'Sex factor F TraW protein N terminal', NULL, 'TraW_N', NULL, NULL, 25646, 9),
(258892, NULL, 'PF07791', NULL, NULL, 'Protein of unknown function (DUF1629)', NULL, 'DUF1629', NULL, NULL, 13264, 9),
(258893, NULL, 'PF12522', NULL, NULL, 'Cytomegalovirus glycoprotein N terminal', NULL, 'UL73_N', NULL, NULL, 14733, 9),
(258894, NULL, 'PF16007', NULL, NULL, 'Domain of unknown function (DUF4777)', NULL, 'DUF4777', NULL, NULL, 21910, 9),
(258895, NULL, 'PF02937', NULL, NULL, 'Cytochrome c oxidase subunit VIc', NULL, 'COX6C', NULL, NULL, 10612, 9),
(258896, NULL, 'PF09013', NULL, NULL, 'YopH, N-terminal', NULL, 'YopH_N', NULL, NULL, 8855, 9),
(258897, NULL, 'PF11318', NULL, NULL, 'Protein of unknown function (DUF3120)', NULL, 'DUF3120', NULL, NULL, 18323, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(258898, NULL, 'PF06089', NULL, NULL, 'L-asparaginase II', NULL, 'Asparaginase_II', NULL, NULL, 8841, 9),
(258899, NULL, 'PF02752', NULL, NULL, 'Arrestin (or S-antigen), C-terminal domain', NULL, 'Arrestin_C', NULL, NULL, 9460, 9),
(258900, NULL, 'PF19672', NULL, NULL, 'Family of unknown function (DUF6175)', NULL, 'DUF6175', NULL, NULL, 37044, 9),
(258901, NULL, 'PF10374', NULL, NULL, 'Telomerase activating protein Est1', NULL, 'EST1', NULL, NULL, 17475, 9),
(258902, NULL, 'PF18197', NULL, NULL, 'Domain of unknown function (DUF5602)', NULL, 'DUF5602', NULL, NULL, 32351, 9),
(258903, NULL, 'PF14904', NULL, NULL, 'Family of unknown function', NULL, 'FAM86', NULL, NULL, 24766, 9),
(258904, NULL, 'PF19045', NULL, NULL, 'Ligase-CoA domain', NULL, 'Ligase_CoA_2', NULL, NULL, 35112, 9),
(258905, NULL, 'PF00109', NULL, NULL, 'Beta-ketoacyl synthase, N-terminal domain', NULL, 'ketoacyl-synt', NULL, NULL, 12760, 9),
(258906, NULL, 'PF08147', NULL, NULL, 'DBP10CT (NUC160) domain', NULL, 'DBP10CT', NULL, NULL, 8615, 9),
(258907, NULL, 'PF09911', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2140)', NULL, 'DUF2140', NULL, NULL, 17346, 9),
(258908, NULL, 'PF12508', NULL, NULL, 'Conjugative transposon, TraM', NULL, 'Transposon_TraM', NULL, NULL, 21009, 9),
(258909, NULL, 'PF20291', NULL, NULL, 'ABC-three component (ABC-3C) system Middle Component 5', NULL, 'MC5', NULL, NULL, 33913, 9),
(258910, NULL, 'PF05127', NULL, NULL, 'Helicase', NULL, 'Helicase_RecD', NULL, NULL, 2223, 9),
(258911, NULL, 'PF08465', NULL, NULL, 'Thymidine kinase from Herpesvirus C-terminal', NULL, 'Herpes_TK_C', NULL, NULL, 13967, 9),
(258912, NULL, 'PF14970', NULL, NULL, 'Tubulin epsilon and delta complex protein 1', NULL, 'TEDC1', NULL, NULL, 24787, 9),
(258913, NULL, 'PF00376', NULL, NULL, 'MerR family regulatory protein', NULL, 'MerR', NULL, NULL, 5889, 9),
(258914, NULL, 'PF17034', NULL, NULL, 'Zinc-ribbon like family', NULL, 'zinc_ribbon_16', NULL, NULL, 22575, 9),
(258915, NULL, 'PF09170', NULL, NULL, 'CST, complex subunit STN1, C terminal', NULL, 'STN1_2', NULL, NULL, 12448, 9),
(258916, NULL, 'PF11128', NULL, NULL, 'Plant viral coat protein nucleocapsid', NULL, 'Nucleocap_ssRNA', NULL, NULL, 17824, 9),
(258917, NULL, 'PF14186', NULL, NULL, 'Axin interactor dorsalisation-associated protein, C-terminal', NULL, 'Aida_C2', NULL, NULL, 23881, 9),
(258918, NULL, 'PF10333', NULL, NULL, 'GPI-Mannosyltransferase II co-activator', NULL, 'Pga1', NULL, NULL, 17041, 9),
(258919, NULL, 'PF04026', NULL, NULL, 'SpoVG', NULL, 'SpoVG', NULL, NULL, 447, 9),
(258920, NULL, 'PF03903', NULL, NULL, 'Phage T4 tail fibre', NULL, 'Phage_T4_gp36', NULL, NULL, 2737, 9),
(258921, NULL, 'PF08879', NULL, NULL, 'WRC', NULL, 'WRC', NULL, NULL, 14293, 9),
(258922, NULL, 'PF10103', NULL, NULL, 'Zincin-like metallopeptidase', NULL, 'Zincin_2', NULL, NULL, 18201, 9),
(258923, NULL, 'PF02033', NULL, NULL, 'Ribosome-binding factor A', NULL, 'RBFA', NULL, NULL, 4857, 9),
(258924, NULL, 'PF06868', NULL, NULL, 'Protein of unknown function (DUF1257)', NULL, 'DUF1257', NULL, NULL, 11857, 9),
(258925, NULL, 'PF17697', NULL, NULL, 'Family of unknown function (DUF5543)', NULL, 'DUF5543', NULL, NULL, 30242, 9),
(258926, NULL, 'PF12856', NULL, NULL, 'Anaphase-promoting complex subunit 9', NULL, 'ANAPC9', NULL, NULL, 11007, 9),
(258927, NULL, 'PF11867', NULL, NULL, 'Domain of unknown function (DUF3387)', NULL, 'DUF3387', NULL, NULL, 19041, 9),
(258928, NULL, 'PF16120', NULL, NULL, 'Domain of unknown function (DUF4836)', NULL, 'DUF4836', NULL, NULL, 26135, 9),
(258929, NULL, 'PF11512', NULL, NULL, 'Agrobacterium tumefaciens protein Atu4866', NULL, 'Atu4866', NULL, NULL, 15720, 9),
(258930, NULL, 'PF10997', NULL, NULL, 'Alternate to MurJ', NULL, 'Amj', NULL, NULL, 17996, 9),
(258931, NULL, 'PF16715', NULL, NULL, 'Cyclodipeptide synthase', NULL, 'CDPS', NULL, NULL, 25388, 9),
(258932, NULL, 'PF19307', NULL, NULL, 'Phage capsid-like protein', NULL, 'PCLP', NULL, NULL, 36003, 9),
(258933, NULL, 'PF01272', NULL, NULL, 'Transcription elongation factor, GreA/GreB, C-term', NULL, 'GreA_GreB', NULL, NULL, 3344, 9);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(258934, NULL, 'PF19982', NULL, NULL, 'Family of unknown function (DUF6418)', NULL, 'DUF6418', NULL, NULL, 37652, 9),
(258935, NULL, 'PF13136', NULL, NULL, 'Protein of unknown function (DUF3984)', NULL, 'DUF3984', NULL, NULL, 22353, 9),
(258936, NULL, 'PF19815', NULL, NULL, 'Family of unknown function (DUF6298)', NULL, 'DUF6298', NULL, NULL, 37214, 9),
(258937, NULL, 'PF01841', NULL, NULL, 'Transglutaminase-like superfamily', NULL, 'Transglut_core', NULL, NULL, 6751, 9),
(258938, NULL, 'PF12335', NULL, NULL, 'Myotubularin protein', NULL, 'SBF2', NULL, NULL, 20823, 9),
(258939, NULL, 'PF09983', NULL, NULL, 'Uncharacterized protein conserved in bacteria C-term(DUF2220)', NULL, 'DUF2220', NULL, NULL, 23001, 9),
(258940, NULL, 'PF15957', NULL, NULL, 'Commissureless', NULL, 'Comm', NULL, NULL, 26402, 9),
(258941, NULL, 'PF15181', NULL, NULL, 'Spermatid-specific manchette-related protein 1', NULL, 'SMRP1', NULL, NULL, 21872, 9),
(258942, NULL, 'PF18676', NULL, NULL, 'MBG domain (YGX type)', NULL, 'MBG_2', NULL, NULL, 29136, 9),
(258943, NULL, 'PF10948', NULL, NULL, 'Protein of unknown function (DUF2635)', NULL, 'DUF2635', NULL, NULL, 22442, 9),
(258944, NULL, 'PF03387', NULL, NULL, 'Herpesvirus UL46 protein', NULL, 'Herpes_UL46', NULL, NULL, 2406, 9),
(258945, NULL, 'PF14554', NULL, NULL, 'VEGF heparin-binding domain', NULL, 'VEGF_C', NULL, NULL, 24021, 9),
(258946, NULL, 'PF01991', NULL, NULL, 'ATP synthase (E/31 kDa) subunit', NULL, 'vATP-synt_E', NULL, NULL, 5423, 9),
(258947, NULL, 'PF20119', NULL, NULL, 'Family of unknown function (DUF6509)', NULL, 'DUF6509', NULL, NULL, 35921, 9),
(258948, NULL, 'PF08412', NULL, NULL, 'Ion transport protein N-terminal', NULL, 'Ion_trans_N', NULL, NULL, 11232, 9),
(258949, NULL, 'PF11448', NULL, NULL, 'Protein of unknown function (DUF3005)', NULL, 'DUF3005', NULL, NULL, 18609, 9),
(258950, NULL, 'PF01502', NULL, NULL, 'Phosphoribosyl-AMP cyclohydrolase', NULL, 'PRA-CH', NULL, NULL, 524, 9),
(258951, NULL, 'PF13497', NULL, NULL, 'Domain of unknown function (DUF4121)', NULL, 'DUF4121', NULL, NULL, 21167, 9),
(258952, NULL, 'PF05562', NULL, NULL, 'Cold acclimation protein WCOR413', NULL, 'WCOR413', NULL, NULL, 7773, 9),
(258953, NULL, 'PF15085', NULL, NULL, 'Neuropeptide FF', NULL, 'NPFF', NULL, NULL, 5067, 9),
(258954, NULL, 'PF07020', NULL, NULL, 'Orthopoxvirus C10L protein', NULL, 'Orthopox_C10L', NULL, NULL, 12380, 9),
(258955, NULL, 'PF09751', NULL, NULL, 'Nuclear protein Es2', NULL, 'Es2', NULL, NULL, 18254, 9),
(258956, NULL, 'PF14035', NULL, NULL, 'YlzJ-like protein', NULL, 'YlzJ', NULL, NULL, 26387, 9),
(258957, NULL, 'PF18893', NULL, NULL, 'Family of unknown function (DUF5652)', NULL, 'DUF5652', NULL, NULL, 34343, 9),
(258958, NULL, 'PF02775', NULL, NULL, 'Thiamine pyrophosphate enzyme, C-terminal TPP binding domain', NULL, 'TPP_enzyme_C', NULL, NULL, 10839, 9),
(258959, NULL, 'PF05797', NULL, NULL, 'Yeast trans-acting factor (REP1/REP2)', NULL, 'Rep_4', NULL, NULL, 7599, 9),
(258960, NULL, 'PF08853', NULL, NULL, 'Domain of unknown function (DUF1823)', NULL, 'DUF1823', NULL, NULL, 14407, 9),
(258961, NULL, 'PF14298', NULL, NULL, 'Domain of unknown function (DUF4374)', NULL, 'DUF4374', NULL, NULL, 21680, 9),
(258962, NULL, 'PF18509', NULL, NULL, 'Magnetochrome domain', NULL, 'MCR', NULL, NULL, 27716, 9),
(258963, NULL, 'PF09892', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2119)', NULL, 'DUF2119', NULL, NULL, 19386, 9),
(258964, NULL, 'PF13704', NULL, NULL, 'Glycosyl transferase family 2', NULL, 'Glyco_tranf_2_4', NULL, NULL, NULL, 9),
(258965, NULL, 'PF11025', NULL, NULL, 'Glycoprotein GP40 of Cryptosporidium', NULL, 'GP40', NULL, NULL, 15031, 9),
(258966, NULL, 'PF16944', NULL, NULL, 'Fungal potassium channel', NULL, 'KCH', NULL, NULL, 25556, 9),
(258967, NULL, 'PF14164', NULL, NULL, 'YqzH-like protein', NULL, 'YqzH', NULL, NULL, 23867, 9),
(258968, NULL, 'PF00817', NULL, NULL, 'impB/mucB/samB family', NULL, 'IMS', NULL, NULL, 1246, 9),
(258969, NULL, 'PF11122', NULL, NULL, 'Inner spore coat protein D', NULL, 'Spore-coat_CotD', NULL, NULL, 12728, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(258970, NULL, 'PF12266', NULL, NULL, 'Protein of unknown function (DUF3613)', NULL, 'DUF3613', NULL, NULL, 20371, 9),
(258971, NULL, 'PF14373', NULL, NULL, 'Superinfection immunity protein', NULL, 'Imm_superinfect', NULL, NULL, 21215, 9),
(258972, NULL, 'PF12836', NULL, NULL, 'Helix-hairpin-helix motif', NULL, 'HHH_3', NULL, NULL, NULL, 9),
(258973, NULL, 'PF01249', NULL, NULL, 'Ribosomal protein S21e', NULL, 'Ribosomal_S21e', NULL, NULL, 2160, 9),
(258974, NULL, 'PF14193', NULL, NULL, 'Domain of unknown function (DUF4315)', NULL, 'DUF4315', NULL, NULL, 26009, 9),
(258975, NULL, 'PF01199', NULL, NULL, 'Ribosomal protein L34e', NULL, 'Ribosomal_L34e', NULL, NULL, 7305, 9),
(258976, NULL, 'PF04218', NULL, NULL, 'CENP-B N-terminal DNA-binding domain', NULL, 'CENP-B_N', NULL, NULL, 3423, 9),
(258977, NULL, 'PF01773', NULL, NULL, 'Na+ dependent nucleoside transporter N-terminus', NULL, 'Nucleos_tra2_N', NULL, NULL, 5132, 9),
(258978, NULL, 'PF05790', NULL, NULL, 'Immunoglobulin C2-set domain', NULL, 'C2-set', NULL, NULL, 8862, 9),
(258979, NULL, 'PF08259', NULL, NULL, 'Periviscerokinin family', NULL, 'Periviscerokin', NULL, NULL, 12263, 9),
(258980, NULL, 'PF10412', NULL, NULL, 'Type IV secretion-system coupling protein DNA-binding domain', NULL, 'TrwB_AAD_bind', NULL, NULL, 17490, 9),
(258981, NULL, 'PF11215', NULL, NULL, 'Protein of unknown function (DUF3010)', NULL, 'DUF3010', NULL, NULL, 18126, 9),
(258982, NULL, 'PF05975', NULL, NULL, 'Bacterial ABC transporter protein EcsB', NULL, 'EcsB', NULL, NULL, 7966, 9),
(258983, NULL, 'PF11569', NULL, NULL, 'Homeodomain leucine-zipper encoding, Homez', NULL, 'Homez', NULL, NULL, 23891, 9),
(258984, NULL, 'PF00197', NULL, NULL, 'Trypsin and protease inhibitor', NULL, 'Kunitz_legume', NULL, NULL, 305, 9),
(258985, NULL, 'PF17298', NULL, NULL, 'Family of unknown function (DUF5349)', NULL, 'DUF5349', NULL, NULL, 28177, 9),
(258986, NULL, 'PF07989', NULL, NULL, 'Centrosomin N-terminal motif 1', NULL, 'Cnn_1N', NULL, NULL, 8128, 9),
(258987, NULL, 'PF14020', NULL, NULL, 'Protein of unknown function (DUF4236)', NULL, 'DUF4236', NULL, NULL, 22215, 9),
(258988, NULL, 'PF05866', NULL, NULL, 'Endodeoxyribonuclease RusA', NULL, 'RusA', NULL, NULL, 13825, 9),
(258989, NULL, 'PF15022', NULL, NULL, 'Protein of unknown function (DUF4522)', NULL, 'DUF4522', NULL, NULL, 22339, 9),
(258990, NULL, 'PF16324', NULL, NULL, 'Domain of unknown function (DUF4960)', NULL, 'DUF4960', NULL, NULL, 21720, 9),
(258991, NULL, 'PF09551', NULL, NULL, 'Stage II sporulation protein R (spore_II_R)', NULL, 'Spore_II_R', NULL, NULL, 9071, 9),
(258992, NULL, 'PF18763', NULL, NULL, 'ddrB-like ParB superfamily domain', NULL, 'ddrB-ParB', NULL, NULL, 29441, 9),
(258993, NULL, 'PF19462', NULL, NULL, 'Family of unknown function (DUF5999)', NULL, 'DUF5999', NULL, NULL, 36853, 9),
(258994, NULL, 'PF12187', NULL, NULL, 'Viral/Archaeal nuclease', NULL, 'VirArc_Nuclease', NULL, NULL, 20203, 9),
(258995, NULL, 'PF12684', NULL, NULL, 'PDDEXK-like domain of unknown function (DUF3799)', NULL, 'DUF3799', NULL, NULL, 26676, 9),
(258996, NULL, 'PF11471', NULL, NULL, 'Maltoporin periplasmic N-terminal extension', NULL, 'Sugarporin_N', NULL, NULL, 18563, 9),
(258997, NULL, 'PF06707', NULL, NULL, 'Protein of unknown function (DUF1194)', NULL, 'DUF1194', NULL, NULL, 8152, 9),
(258998, NULL, 'PF12932', NULL, NULL, 'Vesicle coat trafficking protein Sec16 mid-region', NULL, 'Sec16', NULL, NULL, 24568, 9),
(258999, NULL, 'PF17946', NULL, NULL, 'RecC C-terminal domain', NULL, 'RecC_C', NULL, NULL, 29292, 9),
(259000, NULL, 'PF20617', NULL, NULL, 'Family of unknown function (DUF6803)', NULL, 'DUF6803', NULL, NULL, 37767, 9),
(259001, NULL, 'PF03222', NULL, NULL, 'Tryptophan/tyrosine permease family', NULL, 'Trp_Tyr_perm', NULL, NULL, 7736, 9),
(259002, NULL, 'PF08508', NULL, NULL, 'Fungal domain of unknown function (DUF1746)', NULL, 'DUF1746', NULL, NULL, 14431, 9),
(259003, NULL, 'PF07434', NULL, NULL, 'CblD like pilus biogenesis initiator', NULL, 'CblD', NULL, NULL, 11542, 9),
(259004, NULL, 'PF15293', NULL, NULL, 'Nuclear fragile X mental retardation-interacting protein 2', NULL, 'NUFIP2', NULL, NULL, 22225, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(259005, NULL, 'PF02544', NULL, NULL, '3-oxo-5-alpha-steroid 4-dehydrogenase', NULL, 'Steroid_dh', NULL, NULL, 1474, 9),
(259006, NULL, 'PF02588', NULL, NULL, 'Uncharacterised 5xTM membrane BCR, YitT family COG1284', NULL, 'YitT_membrane', NULL, NULL, 2411, 9),
(259007, NULL, 'PF09141', NULL, NULL, 'Talin, middle domain', NULL, 'Talin_middle', NULL, NULL, 10806, 9),
(259008, NULL, 'PF17768', NULL, NULL, 'RecJ OB domain', NULL, 'RecJ_OB', NULL, NULL, 28759, 9),
(259009, NULL, 'PF13619', NULL, NULL, 'KTSC domain', NULL, 'KTSC', NULL, NULL, 22457, 9),
(259010, NULL, 'PF16553', NULL, NULL, 'BCORL-PCGF1-binding domain', NULL, 'PUFD', NULL, NULL, 26543, 9),
(259011, NULL, 'PF13405', NULL, NULL, 'EF-hand domain', NULL, 'EF-hand_6', NULL, NULL, 1368, 9),
(259012, NULL, 'PF14560', NULL, NULL, 'Ubiquitin-like domain', NULL, 'Ubiquitin_2', NULL, NULL, 4344, 9),
(259013, NULL, 'PF18211', NULL, NULL, 'Csm1 subunit domain B', NULL, 'Csm1_B', NULL, NULL, 29120, 9),
(259014, NULL, 'PF05301', NULL, NULL, 'GNAT acetyltransferase, Mec-17', NULL, 'Acetyltransf_16', NULL, NULL, 4497, 9),
(259015, NULL, 'PF17744', NULL, NULL, 'Family of unknown function (DUF5581)', NULL, 'DUF5581', NULL, NULL, 33791, 9),
(259016, NULL, 'PF19103', NULL, NULL, 'Family of unknown function (DUF5790)', NULL, 'DUF5790', NULL, NULL, 35967, 9),
(259017, NULL, 'PF06816', NULL, NULL, 'NOTCH protein', NULL, 'NOD', NULL, NULL, 9262, 9),
(259018, NULL, 'PF05432', NULL, NULL, 'Bone sialoprotein II (BSP-II)', NULL, 'BSP_II', NULL, NULL, 8920, 9),
(259019, NULL, 'PF09113', NULL, NULL, 'Peptide-N-glycosidase F, C terminal', NULL, 'N-glycanase_C', NULL, NULL, 10524, 9),
(259020, NULL, 'PF12838', NULL, NULL, '4Fe-4S dicluster domain', NULL, 'Fer4_7', NULL, NULL, 12567, 9),
(259021, NULL, 'PF14654', NULL, NULL, 'Mucin, catalytic, TM and cytoplasmic tail region', NULL, 'Epiglycanin_C', NULL, NULL, 26104, 9),
(259022, NULL, 'PF02411', NULL, NULL, 'MerT mercuric transport protein', NULL, 'MerT', NULL, NULL, 5215, 9),
(259023, NULL, 'PF18460', NULL, NULL, 'Heterocyst differentiation regulator C-terminal Hood domain', NULL, 'HetR_C', NULL, NULL, 29125, 9),
(259024, NULL, 'PF00956', NULL, NULL, 'Nucleosome assembly protein (NAP)', NULL, 'NAP', NULL, NULL, 5104, 9),
(259025, NULL, 'PF17936', NULL, NULL, 'Bacterial Ig domain', NULL, 'Big_6', NULL, NULL, 29613, 9),
(259026, NULL, 'PF04736', NULL, NULL, 'Eclosion hormone', NULL, 'Eclosion', NULL, NULL, 3803, 9),
(259027, NULL, 'PF05238', NULL, NULL, 'Kinetochore protein CHL4 like', NULL, 'CENP-N', NULL, NULL, 3418, 9),
(259028, NULL, 'PF08479', NULL, NULL, 'POTRA domain, ShlB-type', NULL, 'POTRA_2', NULL, NULL, 13617, 9),
(259029, NULL, 'PF00054', NULL, NULL, 'Laminin G domain', NULL, 'Laminin_G_1', NULL, NULL, 3322, 9),
(259030, NULL, 'PF14744', NULL, NULL, 'WASH complex subunit 7', NULL, 'WASH-7_mid', NULL, NULL, 26724, 9),
(259031, NULL, 'PF14349', NULL, NULL, 'Motility related/secretion protein', NULL, 'SprA_N', NULL, NULL, 24841, 9),
(259032, NULL, 'PF07209', NULL, NULL, 'Protein of unknown function (DUF1415)', NULL, 'DUF1415', NULL, NULL, 14017, 9),
(259033, NULL, 'PF00567', NULL, NULL, 'Tudor domain', NULL, 'TUDOR', NULL, NULL, 7274, 9),
(259034, NULL, 'PF17406', NULL, NULL, 'Nrap protein PAP/OAS1-like domain 5', NULL, 'Nrap_D5', NULL, NULL, 9813, 9),
(259035, NULL, 'PF01768', NULL, NULL, 'Birnavirus VP4 protein', NULL, 'Birna_VP4', NULL, NULL, 22476, 9),
(259036, NULL, 'PF17606', NULL, NULL, 'Family of unknown function (DUF5502)', NULL, 'DUF5502', NULL, NULL, 20306, 9),
(259037, NULL, 'PF13629', NULL, NULL, 'Pilus formation protein N terminal region', NULL, 'T2SS-T3SS_pil_N', NULL, NULL, 21646, 9),
(259038, NULL, 'PF09488', NULL, NULL, 'Mannosyl-3-phosphoglycerate synthase (osmo_MPGsynth)', NULL, 'Osmo_MPGsynth', NULL, NULL, 12794, 9),
(259039, NULL, 'PF10164', NULL, NULL, 'Brain protein I3', NULL, 'BRI3', NULL, NULL, 14573, 9),
(259040, NULL, 'PF10280', NULL, NULL, 'Mediator complex protein', NULL, 'Med11', NULL, NULL, 16633, 9),
(259041, NULL, 'PF06873', NULL, NULL, 'Cell surface immobilisation antigen SerH', NULL, 'SerH', NULL, NULL, 11802, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(259042, NULL, 'PF12751', NULL, NULL, 'Vacuolar segregation subunit 7', NULL, 'Vac7', NULL, NULL, 12155, 9),
(259043, NULL, 'PF03268', NULL, NULL, 'Caenorhabditis protein of unknown function, DUF267', NULL, 'DUF267', NULL, NULL, 2824, 9),
(259044, NULL, 'PF15517', NULL, NULL, 'TBP-interacting protein N-terminus', NULL, 'TBPIP_N', NULL, NULL, 23773, 9),
(259045, NULL, 'PF03196', NULL, NULL, 'Protein of unknown function, DUF261', NULL, 'DUF261', NULL, NULL, 7383, 9),
(259046, NULL, 'PF01324', NULL, NULL, 'Diphtheria toxin, R domain', NULL, 'Diphtheria_R', NULL, NULL, 21142, 9),
(259047, NULL, 'PF08416', NULL, NULL, 'Phosphotyrosine-binding domain', NULL, 'PTB', NULL, NULL, 11221, 9),
(259048, NULL, 'PF13541', NULL, NULL, 'Subunit ChlI of Mg-chelatase', NULL, 'ChlI', NULL, NULL, NULL, 9),
(259049, NULL, 'PF14111', NULL, NULL, 'Domain of unknown function (DUF4283)', NULL, 'DUF4283', NULL, NULL, 23060, 9),
(259050, NULL, 'PF15460', NULL, NULL, 'Something about silencing, SAS, complex subunit 4', NULL, 'SAS4', NULL, NULL, 26994, 9),
(259051, NULL, 'PF06916', NULL, NULL, 'FAM210A/B-like domain', NULL, 'FAM210A-B_dom', NULL, NULL, 11867, 9),
(259052, NULL, 'PF19489', NULL, NULL, 'Transglycosylase SLT domain', NULL, 'SLT_4', NULL, NULL, 36064, 9),
(259053, NULL, 'PF07930', NULL, NULL, 'D-aminopeptidase, domain B', NULL, 'DAP_B', NULL, NULL, 12345, 9),
(259054, NULL, 'PF14340', NULL, NULL, 'Domain of unknown function (DUF4395)', NULL, 'DUF4395', NULL, NULL, 26026, 9),
(259055, NULL, 'PF01520', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, 'Amidase_3', NULL, NULL, 604, 9),
(259056, NULL, 'PF10434', NULL, NULL, 'Monopolin complex protein MAM1', NULL, 'MAM1', NULL, NULL, 20115, 9),
(259057, NULL, 'PF12779', NULL, NULL, 'WXXGXW repeat (2 copies)', NULL, 'WXXGXW', NULL, NULL, 24170, 9),
(259058, NULL, 'PF10292', NULL, NULL, 'Serpentine type 7TM GPCR receptor class ab chemoreceptor', NULL, '7TM_GPCR_Srab', NULL, NULL, 16780, 9),
(259059, NULL, 'PF02595', NULL, NULL, 'Glycerate kinase family', NULL, 'Gly_kinase', NULL, NULL, 5633, 9),
(259060, NULL, 'PF06242', NULL, NULL, 'Transcriptional cell cycle regulator TrcR', NULL, 'TrcR', NULL, NULL, 9229, 9),
(259061, NULL, 'PF03433', NULL, NULL, 'EspA-like secreted protein', NULL, 'EspA', NULL, NULL, 10404, 9),
(259062, NULL, 'PF04086', NULL, NULL, 'Signal recognition particle, alpha subunit, N-terminal', NULL, 'SRP-alpha_N', NULL, NULL, 6007, 9),
(259063, NULL, 'PF20003', NULL, NULL, 'FtsH ternary system domain X5', NULL, 'fvmX5', NULL, NULL, 35559, 9),
(259064, NULL, 'PF07335', NULL, NULL, 'Fungal chitosanase of glycosyl hydrolase group 75', NULL, 'Glyco_hydro_75', NULL, NULL, 8049, 9),
(259065, NULL, 'PF02743', NULL, NULL, 'Cache domain', NULL, 'dCache_1', NULL, NULL, 33408, 9),
(259066, NULL, 'PF19588', NULL, NULL, 'Saxitoxin biosynthesis operon protein SxtJ', NULL, 'SxtJ', NULL, NULL, 36460, 9),
(259067, NULL, 'PF01058', NULL, NULL, 'NADH ubiquinone oxidoreductase, 20 Kd subunit', NULL, 'Oxidored_q6', NULL, NULL, 10414, 9),
(259068, NULL, 'PF12160', NULL, NULL, 'Fibrinogen alpha C domain', NULL, 'Fibrinogen_aC', NULL, NULL, 20201, 9),
(259069, NULL, 'PF07591', NULL, NULL, 'Pretoxin HINT domain', NULL, 'PT-HINT', NULL, NULL, NULL, 9),
(259070, NULL, 'PF10835', NULL, NULL, 'Protein of unknown function (DUF2573)', NULL, 'DUF2573', NULL, NULL, 19667, 9),
(259071, NULL, 'PF11944', NULL, NULL, 'Protein of unknown function (DUF3461)', NULL, 'DUF3461', NULL, NULL, 14994, 9),
(259072, NULL, 'PF20197', NULL, NULL, 'Family of unknown function (DUF6560)', NULL, 'DUF6560', NULL, NULL, 37282, 9),
(259073, NULL, 'PF17894', NULL, NULL, 'Topo homolgy domain in CRISPR-associated endonuclease Cas9', NULL, 'Cas9_Topo', NULL, NULL, 29179, 9),
(259074, NULL, 'PF04368', NULL, NULL, 'Protein of unknown function (DUF507)', NULL, 'DUF507', NULL, NULL, 4725, 9),
(259075, NULL, 'PF03023', NULL, NULL, 'Lipid II flippase MurJ', NULL, 'MurJ', NULL, NULL, 3910, 9),
(259076, NULL, 'PF08002', NULL, NULL, 'Protein of unknown function (DUF1697)', NULL, 'DUF1697', NULL, NULL, 8832, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(259077, NULL, 'PF15492', NULL, NULL, 'Neuroblastoma-amplified sequence, N terminal', NULL, 'Nbas_N', NULL, NULL, 23612, 9),
(259078, NULL, 'PF13796', NULL, NULL, 'Putative sensor', NULL, 'Sensor', NULL, NULL, 24443, 9),
(259079, NULL, 'PF00160', NULL, NULL, 'Cyclophilin type peptidyl-prolyl cis-trans isomerase/CLD', NULL, 'Pro_isomerase', NULL, NULL, 5233, 9),
(259080, NULL, 'PF08866', NULL, NULL, 'Putative amino acid metabolism', NULL, 'DUF1831', NULL, NULL, 14350, 9),
(259081, NULL, 'PF10248', NULL, NULL, 'Myelodysplasia-myeloid leukemia factor 1-interacting protein', NULL, 'Mlf1IP', NULL, NULL, 15893, 9),
(259082, NULL, 'PF17293', NULL, NULL, 'Arm DNA-binding domain', NULL, 'Arm-DNA-bind_5', NULL, NULL, 14628, 9),
(259083, NULL, 'PF00455', NULL, NULL, 'DeoR C terminal sensor domain', NULL, 'DeoRC', NULL, NULL, 11515, 9),
(259084, NULL, 'PF11026', NULL, NULL, 'Protein of unknown function (DUF2721)', NULL, 'DUF2721', NULL, NULL, 17640, 9),
(259085, NULL, 'PF19856', NULL, NULL, 'Family of unknown function (DUF6331)', NULL, 'DUF6331', NULL, NULL, 37577, 9),
(259086, NULL, 'PF14592', NULL, NULL, 'Chondroitinase B', NULL, 'Chondroitinas_B', NULL, NULL, 33851, 9),
(259087, NULL, 'PF01213', NULL, NULL, 'Adenylate cyclase associated (CAP) N terminal', NULL, 'CAP_N', NULL, NULL, 7347, 9),
(259088, NULL, 'PF10518', NULL, NULL, 'TAT (twin-arginine translocation) pathway signal sequence', NULL, 'TAT_signal', NULL, NULL, 19451, 9),
(259089, NULL, 'PF10949', NULL, NULL, 'Protein of unknown function (DUF2777)', NULL, 'DUF2777', NULL, NULL, 24140, 9),
(259090, NULL, 'PF15596', NULL, NULL, 'Immunity protein 57', NULL, 'Imm57', NULL, NULL, 24888, 9),
(259091, NULL, 'PF00750', NULL, NULL, 'tRNA synthetases class I (R)', NULL, 'tRNA-synt_1d', NULL, NULL, 28799, 9),
(259092, NULL, 'PF18068', NULL, NULL, 'Npun R1517', NULL, 'Npun_R1517', NULL, NULL, 29296, 9),
(259093, NULL, 'PF12907', NULL, NULL, 'Zinc-binding', NULL, 'zf-met2', NULL, NULL, 33049, 9),
(259094, NULL, 'PF01633', NULL, NULL, 'Choline/ethanolamine kinase', NULL, 'Choline_kinase', NULL, NULL, NULL, 9),
(259095, NULL, 'PF13926', NULL, NULL, 'Domain of unknown function (DUF4211)', NULL, 'DUF4211', NULL, NULL, 22288, 9),
(259096, NULL, 'PF17466', NULL, NULL, 'Family of unknown function', NULL, 'NinD', NULL, NULL, 15597, 9),
(259097, NULL, 'PF20308', NULL, NULL, 'Tetratricopeptide Repeats-Sensor', NULL, 'TPR-S', NULL, NULL, 37745, 9),
(259098, NULL, 'PF00590', NULL, NULL, 'Tetrapyrrole (Corrin/Porphyrin) Methylases', NULL, 'TP_methylase', NULL, NULL, 177, 9),
(259099, NULL, 'PF05726', NULL, NULL, 'Pirin C-terminal cupin domain', NULL, 'Pirin_C', NULL, NULL, 12249, 9),
(259100, NULL, 'PF08688', NULL, NULL, 'Apx/Shroom domain ASD1', NULL, 'ASD1', NULL, NULL, 11100, 9),
(259101, NULL, 'PF02093', NULL, NULL, 'Gag P30 core shell protein', NULL, 'Gag_p30', NULL, NULL, 64, 9),
(259102, NULL, 'PF02365', NULL, NULL, 'No apical meristem (NAM) protein', NULL, 'NAM', NULL, NULL, 5280, 9),
(259103, NULL, 'PF00794', NULL, NULL, 'PI3-kinase family, ras-binding domain', NULL, 'PI3K_rbd', NULL, NULL, 185, 9),
(259104, NULL, 'PF03338', NULL, NULL, 'Poxvirus J1 protein', NULL, 'Pox_J1', NULL, NULL, 924, 9),
(259105, NULL, 'PF00916', NULL, NULL, 'Sulfate permease family', NULL, 'Sulfate_transp', NULL, NULL, 8508, 9),
(259106, NULL, 'PF06943', NULL, NULL, 'LSD1 zinc finger', NULL, 'zf-LSD1', NULL, NULL, 4923, 9),
(259107, NULL, 'PF05445', NULL, NULL, 'Poxvirus serine/threonine protein kinase', NULL, 'Pox_ser-thr_kin', NULL, NULL, 13545, 9),
(259108, NULL, 'PF14323', NULL, NULL, 'GxGYxYP putative glycoside hydrolase C-terminal domain', NULL, 'GxGYxYP_C', NULL, NULL, 24217, 9),
(259109, NULL, 'PF14701', NULL, NULL, 'Glycogen debranching enzyme, glucanotransferase domain', NULL, 'hDGE_amylase', NULL, NULL, 22311, 9),
(259110, NULL, 'PF15609', NULL, NULL, 'Phosphoribosyl transferase', NULL, 'PRTase_2', NULL, NULL, 30719, 9),
(259111, NULL, 'PF10353', NULL, NULL, 'Protein of unknown function (DUF2430)', NULL, 'DUF2430', NULL, NULL, 17088, 9),
(259112, NULL, 'PF12148', NULL, NULL, 'Tandem tudor domain within UHRF1', NULL, 'TTD', NULL, NULL, 20206, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(259113, NULL, 'PF06742', NULL, NULL, 'Protein of unknown function (DUF1214)', NULL, 'DUF1214', NULL, NULL, 9124, 9),
(259114, NULL, 'PF11668', NULL, NULL, 'HCMV glycoprotein pUL130', NULL, 'Gp_UL130', NULL, NULL, 15199, 9),
(259115, NULL, 'PF08034', NULL, NULL, 'Trematode eggshell synthesis protein', NULL, 'TES', NULL, NULL, 9914, 9),
(259116, NULL, 'PF20367', NULL, NULL, 'Family of unknown function (DUF6662)', NULL, 'DUF6662', NULL, NULL, 33919, 9),
(259117, NULL, 'PF04433', NULL, NULL, 'SWIRM domain', NULL, 'SWIRM', NULL, NULL, 10951, 9),
(259118, NULL, 'PF05929', NULL, NULL, 'Phage capsid scaffolding protein (GPO) serine peptidase', NULL, 'Phage_GPO', NULL, NULL, 12885, 9),
(259119, NULL, 'PF16065', NULL, NULL, 'Domain of unknown function (DUF4807)', NULL, 'DUF4807', NULL, NULL, 24042, 9),
(259120, NULL, 'PF13839', NULL, NULL, 'GDSL/SGNH-like Acyl-Esterase family found in Pmr5 and Cas1p', NULL, 'PC-Esterase', NULL, NULL, 23429, 9),
(259121, NULL, 'PF02653', NULL, NULL, 'Branched-chain amino acid transport system / permease component', NULL, 'BPD_transp_2', NULL, NULL, 4132, 9),
(259122, NULL, 'PF09066', NULL, NULL, 'Beta2-adaptin appendage, C-terminal sub-domain', NULL, 'B2-adapt-app_C', NULL, NULL, 9706, 9),
(259123, NULL, 'PF07693', NULL, NULL, 'KAP family P-loop domain', NULL, 'KAP_NTPase', NULL, NULL, 10982, 9),
(259124, NULL, 'PF06295', NULL, NULL, 'Protein of unknown function (DUF1043)', NULL, 'DUF1043', NULL, NULL, 8391, 9),
(259125, NULL, 'PF01253', NULL, NULL, 'Translation initiation factor SUI1', NULL, 'SUI1', NULL, NULL, 4275, 9),
(259126, NULL, 'PF03525', NULL, NULL, 'Meiotic recombination protein Rec7 N-terminal domain', NULL, 'Meiotic_rec114', NULL, NULL, 5483, 9),
(259127, NULL, 'PF18883', NULL, NULL, 'Autochaperone Domain Type 1', NULL, 'AC_1', NULL, NULL, 37183, 9),
(259128, NULL, 'PF05072', NULL, NULL, 'Herpesvirus UL43 protein', NULL, 'Herpes_UL43', NULL, NULL, 1087, 9),
(259129, NULL, 'PF15405', NULL, NULL, 'Pleckstrin homology domain', NULL, 'PH_5', NULL, NULL, 30315, 9),
(259130, NULL, 'PF18699', NULL, NULL, 'Mitoribosomal protein mL52', NULL, 'MRPL52', NULL, NULL, 11273, 9),
(259131, NULL, 'PF20528', NULL, NULL, 'Domain of unknown function (DUF6743)', NULL, 'DUF6743', NULL, NULL, 33725, 9),
(259132, NULL, 'PF01648', NULL, NULL, '4''-phosphopantetheinyl transferase superfamily', NULL, 'ACPS', NULL, NULL, 7607, 9),
(259133, NULL, 'PF04883', NULL, NULL, 'Bacteriophage HK97-gp10, putative tail-component', NULL, 'HK97-gp10_like', NULL, NULL, 6150, 9),
(259134, NULL, 'PF05547', NULL, NULL, 'Immune inhibitor A peptidase M6', NULL, 'Peptidase_M6', NULL, NULL, 12231, 9),
(259135, NULL, 'PF19219', NULL, NULL, 'Coronavirus replicase NSP15, N-terminal oligomerisation', NULL, 'CoV_NSP15_N', NULL, NULL, 35373, 9),
(259136, NULL, 'PF14158', NULL, NULL, 'YndJ-like protein', NULL, 'YndJ', NULL, NULL, 26479, 9),
(259137, NULL, 'PF00996', NULL, NULL, 'GDP dissociation inhibitor', NULL, 'GDI', NULL, NULL, 19834, 9),
(259138, NULL, 'PF07341', NULL, NULL, 'Protein of unknown function (DUF1473)', NULL, 'DUF1473', NULL, NULL, 8129, 9),
(259139, NULL, 'PF08246', NULL, NULL, 'Cathepsin propeptide inhibitor domain (I29)', NULL, 'Inhibitor_I29', NULL, NULL, 17416, 9),
(259140, NULL, 'PF04206', NULL, NULL, 'Tetrahydromethanopterin S-methyltransferase, subunit E', NULL, 'MtrE', NULL, NULL, 5908, 9),
(259141, NULL, 'PF05062', NULL, NULL, 'RICH domain', NULL, 'RICH', NULL, NULL, 1121, 9),
(259142, NULL, 'PF06590', NULL, NULL, 'PerB protein', NULL, 'PerB', NULL, NULL, 9302, 9),
(259143, NULL, 'PF07637', NULL, NULL, 'Protein of unknown function (DUF1595)', NULL, 'PSD5', NULL, NULL, 10338, 9),
(259144, NULL, 'PF12671', NULL, NULL, 'Putative amidase domain', NULL, 'Amidase_6', NULL, NULL, 20899, 9),
(259145, NULL, 'PF11861', NULL, NULL, 'Domain of unknown function (DUF3381)', NULL, 'DUF3381', NULL, NULL, 21593, 9),
(259146, NULL, 'PF13046', NULL, NULL, 'Protein of unknown function (DUF3906)', NULL, 'DUF3906', NULL, NULL, 22502, 9),
(259147, NULL, 'PF17694', NULL, NULL, 'Family of unknown function (DUF5540)', NULL, 'DUF5540', NULL, NULL, 27674, 9);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(259148, NULL, 'PF10986', NULL, NULL, 'Protein of unknown function (DUF2796)', NULL, 'DUF2796', NULL, NULL, 17781, 9),
(259149, NULL, 'PF09014', NULL, NULL, 'Beta-2-glycoprotein-1 fifth domain', NULL, 'Sushi_2', NULL, NULL, 9720, 9),
(259150, NULL, 'PF00084', NULL, NULL, 'Sushi repeat (SCR repeat)', NULL, 'Sushi', NULL, NULL, 6503, 9),
(259151, NULL, 'PF18550', NULL, NULL, 'Nitrososphaera output domain 2', NULL, 'NitrOD2', NULL, NULL, 29186, 9),
(259152, NULL, 'PF14673', NULL, NULL, 'Domain of unknown function (DUF4459)', NULL, 'DUF4459', NULL, NULL, 23841, 9),
(259153, NULL, 'PF20177', NULL, NULL, 'Domain of unknown function (DUF6542)', NULL, 'DUF6542', NULL, NULL, 37016, 9),
(259154, NULL, 'PF08833', NULL, NULL, 'Axin beta-catenin binding motif', NULL, 'Axin_b-cat_bind', NULL, NULL, 14233, 9),
(259155, NULL, 'PF19087', NULL, NULL, 'Domain of unknown function (DUF5776)', NULL, 'DUF5776', NULL, NULL, 34866, 9),
(259156, NULL, 'PF08597', NULL, NULL, 'Translation initiation factor eIF3 subunit', NULL, 'eIF3_subunit', NULL, NULL, 17868, 9),
(259157, NULL, 'PF16808', NULL, NULL, 'Coiled-coil N-terminus of cGMP-dependent protein kinase', NULL, 'PKcGMP_CC', NULL, NULL, 22454, 9),
(259158, NULL, 'PF20452', NULL, NULL, 'Calmodulin binding protein C-terminal domain', NULL, 'Calmod_bind_C', NULL, NULL, 34286, 9),
(259159, NULL, 'PF19397', NULL, NULL, 'Family of unknown function (DUF5972)', NULL, 'DUF5972', NULL, NULL, 36662, 9),
(259160, NULL, 'PF02913', NULL, NULL, 'FAD linked oxidases, C-terminal domain', NULL, 'FAD-oxidase_C', NULL, NULL, 1703, 9),
(259161, NULL, 'PF01657', NULL, NULL, 'Salt stress response/antifungal', NULL, 'Stress-antifung', NULL, NULL, 6005, 9),
(259162, NULL, 'PF04454', NULL, NULL, 'Encapsulating protein for peroxidase', NULL, 'Linocin_M18', NULL, NULL, 3610, 9),
(259163, NULL, 'PF04120', NULL, NULL, 'Low affinity iron permease', NULL, 'Iron_permease', NULL, NULL, 6914, 9),
(259164, NULL, 'PF19725', NULL, NULL, 'DNA-directed RNA polymerase III subunit RPC5 C-terminal', NULL, 'RPC5_C', NULL, NULL, 36203, 9),
(259165, NULL, 'PF01404', NULL, NULL, 'Ephrin receptor ligand binding domain', NULL, 'Ephrin_lbd', NULL, NULL, 1425, 9),
(259166, NULL, 'PF08801', NULL, NULL, 'Nup133 N terminal like', NULL, 'Nucleoporin_N', NULL, NULL, 13092, 9),
(259167, NULL, 'PF13346', NULL, NULL, 'ABC-2 family transporter protein', NULL, 'ABC2_membrane_5', NULL, NULL, 22852, 9),
(259168, NULL, 'PF16119', NULL, NULL, 'Domain of unknown function (DUF4835)', NULL, 'DUF4835', NULL, NULL, 26232, 9),
(259169, NULL, 'PF00174', NULL, NULL, 'Oxidoreductase molybdopterin binding domain', NULL, 'Oxidored_molyb', NULL, NULL, 5716, 9),
(259170, NULL, 'PF09921', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2153)', NULL, 'DUF2153', NULL, NULL, 9803, 9),
(259171, NULL, 'PF01212', NULL, NULL, 'Beta-eliminating lyase', NULL, 'Beta_elim_lyase', NULL, NULL, 11225, 9),
(259172, NULL, 'PF12340', NULL, NULL, 'Protein of unknown function (DUF3638)', NULL, 'DUF3638', NULL, NULL, 20945, 9),
(259173, NULL, 'PF01830', NULL, NULL, 'Peptidase C7 family', NULL, 'Peptidase_C7', NULL, NULL, 3949, 9),
(259174, NULL, 'PF16991', NULL, NULL, 'Sir4 SID domain', NULL, 'SIR4_SID', NULL, NULL, 24092, 9),
(259175, NULL, 'PF10269', NULL, NULL, 'Transmembrane Fragile-X-F protein', NULL, 'Tmemb_185A', NULL, NULL, 16810, 9),
(259176, NULL, 'PF19200', NULL, NULL, '6-phospho-N-acetylmuramidase, N-terminal', NULL, 'MupG_N', NULL, NULL, 37551, 9),
(259177, NULL, 'PF19152', NULL, NULL, 'Family of unknown function (DUF5834)', NULL, 'DUF5834', NULL, NULL, 34760, 9),
(259178, NULL, 'PF18868', NULL, NULL, 'Zinc finger C2H2-type, 3 repeats', NULL, 'zf-C2H2_3rep', NULL, NULL, 28222, 9),
(259179, NULL, 'PF17059', NULL, NULL, 'MgtA leader peptide', NULL, 'MGTL', NULL, NULL, 26277, 9),
(259180, NULL, 'PF17039', NULL, NULL, 'Fucosyltransferase, N-terminal', NULL, 'Glyco_tran_10_N', NULL, NULL, 22673, 9),
(259181, NULL, 'PF16477', NULL, NULL, 'Domain of unknown function (DUF5054)', NULL, 'DUF5054', NULL, NULL, 18443, 9),
(259182, NULL, 'PF03787', NULL, NULL, 'RAMP superfamily', NULL, 'RAMPs', NULL, NULL, 1822, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(259183, NULL, 'PF16256', NULL, NULL, 'Domain of unknown function (DUF4911)', NULL, 'DUF4911', NULL, NULL, 21748, 9),
(259184, NULL, 'PF10083', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2321)', NULL, 'DUF2321', NULL, NULL, 16824, 9),
(259185, NULL, 'PF19506', NULL, NULL, 'Family of unknown function (DUF6040)', NULL, 'DUF6040', NULL, NULL, 36633, 9),
(259186, NULL, 'PF07276', NULL, NULL, 'Apopolysialoglycoprotein (PSGP)', NULL, 'PSGP', NULL, NULL, 14413, 9),
(259187, NULL, 'PF20228', NULL, NULL, 'Family of unknown function (DUF6587)', NULL, 'DUF6587', NULL, NULL, 37748, 9),
(259188, NULL, 'PF01386', NULL, NULL, 'Ribosomal L25p family', NULL, 'Ribosomal_L25p', NULL, NULL, 24747, 9),
(259189, NULL, 'PF15594', NULL, NULL, 'Immunity protein 50', NULL, 'Imm50', NULL, NULL, 24940, 9),
(259190, NULL, 'PF02383', NULL, NULL, 'SacI homology domain', NULL, 'Syja_N', NULL, NULL, 4583, 9),
(259191, NULL, 'PF02976', NULL, NULL, 'DNA mismatch repair enzyme MutH', NULL, 'MutH', NULL, NULL, 13646, 9),
(259192, NULL, 'PF11444', NULL, NULL, 'Protein of unknown function (DUF2895)', NULL, 'DUF2895', NULL, NULL, 18752, 9),
(259193, NULL, 'PF08815', NULL, NULL, 'Nuclear receptor coactivator', NULL, 'Nuc_rec_co-act', NULL, NULL, 13017, 9),
(259194, NULL, 'PF19821', NULL, NULL, 'Phage capsid protein', NULL, 'Phage_capsid_2', NULL, NULL, 37495, 9),
(259195, NULL, 'PF14877', NULL, NULL, 'Mitochondrial translation initiation factor', NULL, 'mIF3', NULL, NULL, 21750, 9),
(259196, NULL, 'PF09876', NULL, NULL, 'Predicted metal-binding protein (DUF2103)', NULL, 'DUF2103', NULL, NULL, 16984, 9),
(259197, NULL, 'PF13433', NULL, NULL, 'Periplasmic binding protein domain', NULL, 'Peripla_BP_5', NULL, NULL, NULL, 9),
(259198, NULL, 'PF13713', NULL, NULL, 'Transcription factor BRX N-terminal domain', NULL, 'BRX_N', NULL, NULL, 23534, 9),
(259199, NULL, 'PF09806', NULL, NULL, 'Cyclin-dependent kinase 2-associated protein', NULL, 'CDK2AP', NULL, NULL, 16056, 9),
(259200, NULL, 'PF19025', NULL, NULL, 'Family of unknown function (DUF5751)', NULL, 'DUF5751', NULL, NULL, 34525, 9),
(259201, NULL, 'PF00895', NULL, NULL, 'ATP synthase protein 8', NULL, 'ATP-synt_8', NULL, NULL, 6758, 9),
(259202, NULL, 'PF00277', NULL, NULL, 'Serum amyloid A protein', NULL, 'SAA', NULL, NULL, 3847, 9),
(259203, NULL, 'PF08238', NULL, NULL, 'Sel1 repeat', NULL, 'Sel1', NULL, NULL, 1060, 9),
(259204, NULL, 'PF20371', NULL, NULL, 'Family of unknown function (DUF6666)', NULL, 'DUF6666', NULL, NULL, 33740, 9),
(259205, NULL, 'PF14766', NULL, NULL, 'Replication protein A interacting N-terminal', NULL, 'RPA_interact_N', NULL, NULL, 23669, 9),
(259206, NULL, 'PF14718', NULL, NULL, 'Soluble lytic murein transglycosylase L domain', NULL, 'SLT_L', NULL, NULL, 13421, 9),
(259207, NULL, 'PF14817', NULL, NULL, 'HAUS augmin-like complex subunit 5', NULL, 'HAUS5', NULL, NULL, 25853, 9),
(259208, NULL, 'PF17536', NULL, NULL, 'Matrix and Matrix long proteins N-terminal', NULL, 'Mx_ML', NULL, NULL, 15288, 9),
(259209, NULL, 'PF04009', NULL, NULL, 'Protein of unknown function (DUF356)', NULL, 'DUF356', NULL, NULL, 106, 9),
(259210, NULL, 'PF08144', NULL, NULL, 'CPL (NUC119) domain', NULL, 'CPL', NULL, NULL, 11566, 9),
(259211, NULL, 'PF11602', NULL, NULL, 'ATPase P4 of dsRNA bacteriophage phi-12', NULL, 'NTPase_P4', NULL, NULL, 15532, 9),
(259212, NULL, 'PF16048', NULL, NULL, 'Frog antimicrobial peptide', NULL, 'Antimicrobial23', NULL, NULL, 22785, 9),
(259213, NULL, 'PF05022', NULL, NULL, 'SRP40, C-terminal domain', NULL, 'SRP40_C', NULL, NULL, 1283, 9),
(259214, NULL, 'PF15610', NULL, NULL, 'PRTase ComF-like', NULL, 'PRTase_3', NULL, NULL, 24881, 9),
(259215, NULL, 'PF17424', NULL, NULL, 'Family of unknown function (DUF5411)', NULL, 'DUF5411', NULL, NULL, 14933, 9),
(259216, NULL, 'PF07703', NULL, NULL, 'Alpha-2-macroglobulin bait region domain', NULL, 'A2M_BRD', NULL, NULL, 9666, 9),
(259217, NULL, 'PF13863', NULL, NULL, 'Domain of unknown function (DUF4200)', NULL, 'DUF4200', NULL, NULL, 23247, 9),
(259218, NULL, 'PF08832', NULL, NULL, 'Steroid receptor coactivator', NULL, 'SRC-1', NULL, NULL, 14146, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(259219, NULL, 'PF15958', NULL, NULL, 'Domain of unknown function (DUF4761)', NULL, 'DUF4761', NULL, NULL, 26992, 9),
(259220, NULL, 'PF18570', NULL, NULL, 'NUP57/Nup54 C-terminal domain', NULL, 'Nup54_57_C', NULL, NULL, NULL, 9),
(259221, NULL, 'PF04929', NULL, NULL, 'Herpes DNA replication accessory factor', NULL, 'Herpes_DNAp_acc', NULL, NULL, 6721, 9),
(259222, NULL, 'PF12108', NULL, NULL, 'Splicing factor SF3a60 binding domain', NULL, 'SF3a60_bindingd', NULL, NULL, 20158, 9),
(259223, NULL, 'PF05484', NULL, NULL, 'LRV protein FeS4 cluster', NULL, 'LRV_FeS', NULL, NULL, 12969, 9),
(259224, NULL, 'PF08635', NULL, NULL, 'Putative oxidoreductase C terminal domain', NULL, 'ox_reductase_C', NULL, NULL, 7822, 9),
(259225, NULL, 'PF02069', NULL, NULL, 'Prokaryotic metallothionein', NULL, 'Metallothio_Pro', NULL, NULL, 6847, 9),
(259226, NULL, 'PF00976', NULL, NULL, 'Corticotropin ACTH domain', NULL, 'ACTH_domain', NULL, NULL, 12572, 9),
(259227, NULL, 'PF01124', NULL, NULL, 'MAPEG family', NULL, 'MAPEG', NULL, NULL, 1254, 9),
(259228, NULL, 'PF04059', NULL, NULL, 'RNA recognition motif 2', NULL, 'RRM_2', NULL, NULL, 1097, 9),
(259229, NULL, 'PF09885', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2112)', NULL, 'DUF2112', NULL, NULL, 12814, 9),
(259230, NULL, 'PF09192', NULL, NULL, 'Actin-fragmin kinase, catalytic', NULL, 'Act-Frag_cataly', NULL, NULL, 12358, 9),
(259231, NULL, 'PF20380', NULL, NULL, 'Family of unknown function (DUF6675)', NULL, 'DUF6675', NULL, NULL, 37115, 9),
(259232, NULL, 'PF07561', NULL, NULL, 'Domain of Unknown Function (DUF1540)', NULL, 'DUF1540', NULL, NULL, 13597, 9),
(259233, NULL, 'PF04467', NULL, NULL, 'Protein of unknown function (DUF483)', NULL, 'DUF483', NULL, NULL, 3951, 9),
(259234, NULL, 'PF20416', NULL, NULL, 'Domain of unknown function (DUF6700)', NULL, 'DUF6700', NULL, NULL, 37650, 9),
(259235, NULL, 'PF01379', NULL, NULL, 'Porphobilinogen deaminase, dipyromethane cofactor binding domain', NULL, 'Porphobil_deam', NULL, NULL, 15673, 9),
(259236, NULL, 'PF18703', NULL, NULL, 'MALT1 Ig-like domain', NULL, 'MALT1_Ig', NULL, NULL, 28982, 9),
(259237, NULL, 'PF11462', NULL, NULL, 'Protein of unknown function (DUF3203)', NULL, 'DUF3203', NULL, NULL, 18831, 9),
(259238, NULL, 'PF17562', NULL, NULL, 'Styelin', NULL, 'Styelin', NULL, NULL, 31875, 9),
(259239, NULL, 'PF03533', NULL, NULL, 'SPO11 homologue', NULL, 'SPO11_like', NULL, NULL, 1704, 9),
(259240, NULL, 'PF08689', NULL, NULL, 'Mediator complex subunit Med5', NULL, 'Med5', NULL, NULL, 11037, 9),
(259241, NULL, 'PF14549', NULL, NULL, 'DNA-binding transcriptional regulator Cro', NULL, 'P22_Cro', NULL, NULL, NULL, 9),
(259242, NULL, 'PF01690', NULL, NULL, 'Potato leaf roll virus readthrough protein', NULL, 'PLRV_ORF5', NULL, NULL, 6670, 9),
(259243, NULL, 'PF03473', NULL, NULL, 'MOSC domain', NULL, 'MOSC', NULL, NULL, 5411, 9),
(259244, NULL, 'PF06150', NULL, NULL, 'ChaB', NULL, 'ChaB', NULL, NULL, 14328, 9),
(259245, NULL, 'PF01190', NULL, NULL, 'Pollen protein Ole e 1 like', NULL, 'Pollen_Ole_e_1', NULL, NULL, NULL, 9),
(259246, NULL, 'PF09409', NULL, NULL, 'PUB domain', NULL, 'PUB', NULL, NULL, 15876, 9),
(259247, NULL, 'PF10762', NULL, NULL, 'Protein of unknown function (DUF2583)', NULL, 'DUF2583', NULL, NULL, 20133, 9),
(259248, NULL, 'PF11893', NULL, NULL, 'Domain of unknown function (DUF3413)', NULL, 'DUF3413', NULL, NULL, 26757, 9),
(259249, NULL, 'PF12295', NULL, NULL, 'Symplekin tight junction protein C terminal', NULL, 'Symplekin_C', NULL, NULL, 20876, 9),
(259250, NULL, 'PF12161', NULL, NULL, 'HsdM N-terminal domain', NULL, 'HsdM_N', NULL, NULL, 17195, 9),
(259251, NULL, 'PF17166', NULL, NULL, 'Domain of unknown function (DUF5126)', NULL, 'DUF5126', NULL, NULL, 32553, 9),
(259252, NULL, 'PF15752', NULL, NULL, 'Domain of unknown function (DUF4688)', NULL, 'DUF4688', NULL, NULL, 25350, 9),
(259253, NULL, 'PF17388', NULL, NULL, 'Mycobacteriophage tail assembly protein', NULL, 'GP24_25', NULL, NULL, 13620, 9),
(259254, NULL, 'PF13526', NULL, NULL, 'Protein of unknown function (DUF4125)', NULL, 'DUF4125', NULL, NULL, 21594, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(259255, NULL, 'PF10372', NULL, NULL, 'Bacterial membrane-spanning protein N-terminus', NULL, 'YojJ', NULL, NULL, 17150, 9),
(259256, NULL, 'PF18542', NULL, NULL, 'Transcription factor IIB C-terminal module 1', NULL, 'TFIIB_C_1', NULL, NULL, 28840, 9),
(259257, NULL, 'PF08934', NULL, NULL, 'Rb C-terminal domain', NULL, 'Rb_C', NULL, NULL, 7943, 9),
(259258, NULL, 'PF00677', NULL, NULL, 'Lumazine binding domain', NULL, 'Lum_binding', NULL, NULL, 25254, 9),
(259259, NULL, 'PF00934', NULL, NULL, 'PE family', NULL, 'PE', NULL, NULL, 2910, 9),
(259260, NULL, 'PF01809', NULL, NULL, 'Putative membrane protein insertion efficiency factor', NULL, 'YidD', NULL, NULL, 3956, 9),
(259261, NULL, 'PF09254', NULL, NULL, 'FokI, cleavage domain', NULL, 'FokI_cleav_dom', NULL, NULL, 13104, 9),
(259262, NULL, 'PF09567', NULL, NULL, 'MamI restriction endonuclease', NULL, 'RE_MamI', NULL, NULL, 16601, 9),
(259263, NULL, 'PF02347', NULL, NULL, 'Glycine cleavage system P-protein', NULL, 'GDC-P', NULL, NULL, 19057, 9),
(259264, NULL, 'PF19880', NULL, NULL, 'Family of unknown function (DUF6353)', NULL, 'DUF6353', NULL, NULL, 36773, 9),
(259265, NULL, 'PF05039', NULL, NULL, 'Agouti protein', NULL, 'Agouti', NULL, NULL, 1078, 9),
(259266, NULL, 'PF15812', NULL, NULL, 'Melanoregulin', NULL, 'MREG', NULL, NULL, 24124, 9),
(259267, NULL, 'PF19161', NULL, NULL, 'Family of unknown function (DUF5843)', NULL, 'DUF5843', NULL, NULL, 34717, 9),
(259268, NULL, 'PF20074', NULL, NULL, 'Family of unknown function (DUF6470)', NULL, 'DUF6470', NULL, NULL, 35944, 9),
(259269, NULL, 'PF14702', NULL, NULL, 'Central domain of human glycogen debranching enzyme', NULL, 'hGDE_central', NULL, NULL, 22440, 9),
(259270, NULL, 'PF03605', NULL, NULL, 'Anaerobic c4-dicarboxylate membrane transporter', NULL, 'DcuA_DcuB', NULL, NULL, 2820, 9),
(259271, NULL, 'PF05705', NULL, NULL, 'Eukaryotic protein of unknown function (DUF829)', NULL, 'DUF829', NULL, NULL, 13437, 9),
(259272, NULL, 'PF13530', NULL, NULL, 'Sterol carrier protein domain', NULL, 'SCP2_2', NULL, NULL, 23538, 9),
(259273, NULL, 'PF01242', NULL, NULL, '6-pyruvoyl tetrahydropterin synthase', NULL, 'PTPS', NULL, NULL, 26, 9),
(259274, NULL, 'PF00833', NULL, NULL, 'Ribosomal S17', NULL, 'Ribosomal_S17e', NULL, NULL, 1414, 9),
(259275, NULL, 'PF04952', NULL, NULL, 'Succinylglutamate desuccinylase / Aspartoacylase family', NULL, 'AstE_AspA', NULL, NULL, 6589, 9),
(259276, NULL, 'PF07999', NULL, NULL, 'Retrotransposon hot spot protein, P-loop domain', NULL, 'RHSP', NULL, NULL, 37099, 9),
(259277, NULL, 'PF04233', NULL, NULL, 'Phage Mu protein F like protein', NULL, 'Phage_Mu_F', NULL, NULL, 357, 9),
(259278, NULL, 'PF07194', NULL, NULL, 'P2 response regulator binding domain', NULL, 'P2', NULL, NULL, 10537, 9),
(259279, NULL, 'PF05575', NULL, NULL, 'Vibrio cholerae RfbT protein', NULL, 'V_cholerae_RfbT', NULL, NULL, 7993, 9),
(259280, NULL, 'PF03179', NULL, NULL, 'Vacuolar (H+)-ATPase G subunit', NULL, 'V-ATPase_G', NULL, NULL, 7438, 9),
(259281, NULL, 'PF01707', NULL, NULL, 'Peptidase family C9', NULL, 'Peptidase_C9', NULL, NULL, 2873, 9),
(259282, NULL, 'PF01524', NULL, NULL, 'Geminivirus V2 protein', NULL, 'Gemini_V2', NULL, NULL, 842, 9),
(259283, NULL, 'PF10267', NULL, NULL, 'Predicted transmembrane and coiled-coil 2 protein', NULL, 'Tmemb_cc2', NULL, NULL, 16943, 9),
(259284, NULL, 'PF17733', NULL, NULL, 'Family of unknown function (DUF5572)', NULL, 'DUF5572', NULL, NULL, NULL, 9),
(259285, NULL, 'PF09480', NULL, NULL, 'Type III secretion system protein PrgH-EprH (PrgH)', NULL, 'PrgH', NULL, NULL, 15739, 9),
(259286, NULL, 'PF06381', NULL, NULL, 'Protein of unknown function (DUF1073)', NULL, 'DUF1073', NULL, NULL, 21708, 9),
(259287, NULL, 'PF13668', NULL, NULL, 'Ferritin-like domain', NULL, 'Ferritin_2', NULL, NULL, NULL, 9),
(259288, NULL, 'PF10877', NULL, NULL, 'Protein of unknown function (DUF2671)', NULL, 'DUF2671', NULL, NULL, 16927, 9),
(259289, NULL, 'PF09478', NULL, NULL, 'Carbohydrate binding domain CBM49', NULL, 'CBM49', NULL, NULL, 15617, 9),
(259290, NULL, 'PF11222', NULL, NULL, 'Protein of unknown function (DUF3017)', NULL, 'DUF3017', NULL, NULL, 18402, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(259291, NULL, 'PF00281', NULL, NULL, 'Ribosomal protein L5', NULL, 'Ribosomal_L5', NULL, NULL, 25245, 9),
(259292, NULL, 'PF00606', NULL, NULL, 'Herpesvirus Glycoprotein B ectodomain', NULL, 'Glycoprotein_B', NULL, NULL, NULL, 9),
(259293, NULL, 'PF04204', NULL, NULL, 'Homoserine O-succinyltransferase', NULL, 'HTS', NULL, NULL, 30160, 9),
(259294, NULL, 'PF11043', NULL, NULL, 'Bacteriophage P22, anti-RecBCD protein 2', NULL, 'Anti-RecBCD_p2', NULL, NULL, 20491, 9),
(259295, NULL, 'PF13400', NULL, NULL, 'Putative Flp pilus-assembly TadE/G-like', NULL, 'Tad', NULL, NULL, 26213, 9),
(259296, NULL, 'PF10502', NULL, NULL, 'Signal peptidase, peptidase S26', NULL, 'Peptidase_S26', NULL, NULL, 19307, 9),
(259297, NULL, 'PF01779', NULL, NULL, 'Ribosomal L29e protein family', NULL, 'Ribosomal_L29e', NULL, NULL, 2994, 9),
(259298, NULL, 'PF08248', NULL, NULL, 'Tryptophyllin-3 skin active peptide', NULL, 'Tryp_FSAP', NULL, NULL, 13396, 9),
(259299, NULL, 'PF06919', NULL, NULL, 'Phage Gp30.7 protein', NULL, 'Phage_T4_Gp30_7', NULL, NULL, 11973, 9),
(259300, NULL, 'PF14053', NULL, NULL, 'Domain of unknown function (DUF4248)', NULL, 'DUF4248', NULL, NULL, 22001, 9),
(259301, NULL, 'PF19283', NULL, NULL, 'Acylamino-acid-releasing enzyme, N-terminal domain', NULL, 'APEH_N', NULL, NULL, 37388, 9),
(259302, NULL, 'PF13426', NULL, NULL, 'PAS domain', NULL, 'PAS_9', NULL, NULL, 3787, 9),
(259303, NULL, 'PF07338', NULL, NULL, 'YdgH/BhsA/McbA-like domain', NULL, 'YdgH_BhsA-like', NULL, NULL, 11640, 9),
(259304, NULL, 'PF12872', NULL, NULL, 'OST-HTH/LOTUS domain', NULL, 'OST-HTH', NULL, NULL, 23128, 9),
(259305, NULL, 'PF03011', NULL, NULL, 'PFEMP1 DBL domain', NULL, 'PFEMP', NULL, NULL, 3648, 9),
(259306, NULL, 'PF06067', NULL, NULL, 'Domain of unknown function (DUF932)', NULL, 'DUF932', NULL, NULL, 23970, 9),
(259307, NULL, 'PF05577', NULL, NULL, 'Serine carboxypeptidase S28', NULL, 'Peptidase_S28', NULL, NULL, 12285, 9),
(259308, NULL, 'PF08097', NULL, NULL, 'Conotoxin T-superfamily', NULL, 'Toxin_26', NULL, NULL, 10426, 9),
(259309, NULL, 'PF05049', NULL, NULL, 'Interferon-inducible GTPase (IIGP)', NULL, 'IIGP', NULL, NULL, 1147, 9),
(259310, NULL, 'PF08519', NULL, NULL, 'Replication factor RFC1 C terminal domain', NULL, 'RFC1', NULL, NULL, 14405, 9),
(259311, NULL, 'PF18111', NULL, NULL, 'Retinitis pigmentosa G-protein regulator interacting C-terminal', NULL, 'RPGR1_C', NULL, NULL, 28605, 9),
(259312, NULL, 'PF19823', NULL, NULL, 'Domain of unknown function (DUF6305)', NULL, 'DUF6305', NULL, NULL, 37258, 9),
(259313, NULL, 'PF00215', NULL, NULL, 'Orotidine 5''-phosphate decarboxylase / HUMPS family', NULL, 'OMPdecase', NULL, NULL, 3413, 9),
(259314, NULL, 'PF16622', NULL, NULL, 'zinc-finger C2H2-type', NULL, 'zf-C2H2_11', NULL, NULL, 30201, 9),
(259315, NULL, 'PF09240', NULL, NULL, 'Interleukin-6 receptor alpha chain, binding', NULL, 'IL6Ra-bind', NULL, NULL, 13381, 9),
(259316, NULL, 'PF01918', NULL, NULL, 'Alba', NULL, 'Alba', NULL, NULL, 4875, 9),
(259317, NULL, 'PF17305', NULL, NULL, 'Family of unknown function (DUF5354)', NULL, 'DUF5354', NULL, NULL, 31538, 9),
(259318, NULL, 'PF16332', NULL, NULL, 'Domain of unknown function (DUF4962)', NULL, 'DUF4962', NULL, NULL, 24630, 9),
(259319, NULL, 'PF19082', NULL, NULL, 'Family of unknown function (DUF5773)', NULL, 'DUF5773', NULL, NULL, 35114, 9),
(259320, NULL, 'PF19473', NULL, NULL, 'Family of unknown function (DUF6010)', NULL, 'DUF6010', NULL, NULL, 36805, 9),
(259321, NULL, 'PF05402', NULL, NULL, 'Coenzyme PQQ synthesis protein D (PqqD)', NULL, 'PqqD', NULL, NULL, 13547, 9),
(259322, NULL, 'PF15616', NULL, NULL, 'TerY-C metal binding domain', NULL, 'TerY_C', NULL, NULL, 26805, 9),
(259323, NULL, 'PF01533', NULL, NULL, 'Tospovirus nucleocapsid protein', NULL, 'Tospo_nucleocap', NULL, NULL, 796, 9),
(259324, NULL, 'PF11157', NULL, NULL, 'Protein of unknown function (DUF2937)', NULL, 'DUF2937', NULL, NULL, 16491, 9),
(259325, NULL, 'PF09397', NULL, NULL, 'Ftsk gamma domain', NULL, 'FtsK_gamma', NULL, NULL, 14576, 9),
(259326, NULL, 'PF12387', NULL, NULL, 'Pestivirus NS2 peptidase', NULL, 'Peptidase_C74', NULL, NULL, 20930, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(259327, NULL, 'PF01849', NULL, NULL, 'NAC domain', NULL, 'NAC', NULL, NULL, 3518, 9),
(259328, NULL, 'PF02635', NULL, NULL, 'DsrE/DsrF-like family', NULL, 'DrsE', NULL, NULL, 3243, 9),
(259329, NULL, 'PF16426', NULL, NULL, 'Domain of unknown function (DUF5023)', NULL, 'DUF5023', NULL, NULL, 24391, 9),
(259330, NULL, 'PF00132', NULL, NULL, 'Bacterial transferase hexapeptide (six repeats)', NULL, 'Hexapep', NULL, NULL, 6394, 9),
(259331, NULL, 'PF05304', NULL, NULL, 'Protein of unknown function (DUF728)', NULL, 'DUF728', NULL, NULL, 4204, 9),
(259332, NULL, 'PF11211', NULL, NULL, 'Protein of unknown function (DUF2997)', NULL, 'DUF2997', NULL, NULL, 18186, 9),
(259333, NULL, 'PF19079', NULL, NULL, 'Collagen-flanked surface repeat', NULL, 'CFSR', NULL, NULL, 21017, 9),
(259334, NULL, 'PF16134', NULL, NULL, 'THO complex subunit 2 N-terminus', NULL, 'THOC2_N', NULL, NULL, 23324, 9),
(259335, NULL, 'PF11496', NULL, NULL, 'Class II histone deacetylase complex subunits 2 and 3', NULL, 'HDA2-3', NULL, NULL, 15219, 9),
(259336, NULL, 'PF06806', NULL, NULL, 'Putative excisionase (DUF1233)', NULL, 'DUF1233', NULL, NULL, 10872, 9),
(259337, NULL, 'PF08567', NULL, NULL, 'TFIIH p62 subunit, N-terminal domain', NULL, 'PH_TFIIH', NULL, NULL, 9678, 9),
(259338, NULL, 'PF11197', NULL, NULL, 'Protein of unknown function (DUF2835)', NULL, 'DUF2835', NULL, NULL, 18328, 9),
(259339, NULL, 'PF03853', NULL, NULL, 'YjeF-related protein N-terminus', NULL, 'YjeF_N', NULL, NULL, 7325, 9),
(259340, NULL, 'PF07151', NULL, NULL, 'Protein of unknown function (DUF1391)', NULL, 'DUF1391', NULL, NULL, 13218, 9),
(259341, NULL, 'PF11762', NULL, NULL, 'L-arabinose isomerase C-terminal domain', NULL, 'Arabinose_Iso_C', NULL, NULL, 21041, 9),
(259342, NULL, 'PF14270', NULL, NULL, 'Domain of unknown function (DUF4358)', NULL, 'DUF4358', NULL, NULL, 24687, 9),
(259343, NULL, 'PF19543', NULL, NULL, 'Family of unknown function (DUF6067)', NULL, 'DUF6067', NULL, NULL, 36492, 9),
(259344, NULL, 'PF08329', NULL, NULL, 'Chitinase A, N-terminal domain', NULL, 'ChitinaseA_N', NULL, NULL, 12899, 9),
(259345, NULL, 'PF12017', NULL, NULL, 'Transposase protein', NULL, 'Tnp_P_element', NULL, NULL, 19923, 9),
(259346, NULL, 'PF16059', NULL, NULL, 'MGA, conserved domain', NULL, 'MGA_dom', NULL, NULL, 23686, 9),
(259347, NULL, 'PF14655', NULL, NULL, 'Rab3 GTPase-activating protein regulatory subunit N-terminus', NULL, 'RAB3GAP2_N', NULL, NULL, 22445, 9),
(259348, NULL, 'PF18095', NULL, NULL, 'UPF0242 C-terminal PAS-like domain', NULL, 'PAS_12', NULL, NULL, 27994, 9),
(259349, NULL, 'PF02892', NULL, NULL, 'BED zinc finger', NULL, 'zf-BED', NULL, NULL, 1334, 9),
(259350, NULL, 'PF15969', NULL, NULL, 'Intracellular sensor of Lambda phage, Abi component', NULL, 'RexA', NULL, NULL, 25978, 9),
(259351, NULL, 'PF09249', NULL, NULL, 'tRNA nucleotidyltransferase, second domain', NULL, 'tRNA_NucTransf2', NULL, NULL, 13204, 9),
(259352, NULL, 'PF09979', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2213)', NULL, 'DUF2213', NULL, NULL, 17137, 9),
(259353, NULL, 'PF18801', NULL, NULL, 'response regulator aspartate phosphatase H, N terminal', NULL, 'RapH_N', NULL, NULL, NULL, 9),
(259354, NULL, 'PF03117', NULL, NULL, 'UL49 family', NULL, 'Herpes_UL49_1', NULL, NULL, 4734, 9),
(259355, NULL, 'PF03935', NULL, NULL, 'Beta-glucan synthesis-associated protein SKN1/KRE6/Sbg1', NULL, 'SKN1_KRE6_Sbg1', NULL, NULL, 2702, 9),
(259356, NULL, 'PF07897', NULL, NULL, 'Ethylene-responsive binding factor-associated repression', NULL, 'EAR', NULL, NULL, 14464, 9),
(259357, NULL, 'PF13083', NULL, NULL, 'KH domain', NULL, 'KH_4', NULL, NULL, NULL, 9),
(259358, NULL, 'PF17289', NULL, NULL, 'Terminase RNaseH-like domain', NULL, 'Terminase_6C', NULL, NULL, 18204, 9),
(259359, NULL, 'PF00528', NULL, NULL, 'Binding-protein-dependent transport system inner membrane component', NULL, 'BPD_transp_1', NULL, NULL, 5588, 9),
(259360, NULL, 'PF03391', NULL, NULL, 'Nepovirus coat protein, central domain', NULL, 'Nepo_coat', NULL, NULL, 2384, 9),
(259361, NULL, 'PF08880', NULL, NULL, 'QLQ', NULL, 'QLQ', NULL, NULL, 14200, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(259362, NULL, 'PF08066', NULL, NULL, 'PMC2NT (NUC016) domain', NULL, 'PMC2NT', NULL, NULL, 9421, 9),
(259363, NULL, 'PF00551', NULL, NULL, 'Formyl transferase', NULL, 'Formyl_trans_N', NULL, NULL, 6078, 9),
(259364, NULL, 'PF06433', NULL, NULL, 'Methylamine dehydrogenase heavy chain (MADH)', NULL, 'Me-amine-dh_H', NULL, NULL, 9322, 9),
(259365, NULL, 'PF01119', NULL, NULL, 'DNA mismatch repair protein, C-terminal domain', NULL, 'DNA_mis_repair', NULL, NULL, 7173, 9),
(259366, NULL, 'PF20537', NULL, NULL, 'Domain of unknown function (DUF6752)', NULL, 'DUF6752', NULL, NULL, 33678, 9),
(259367, NULL, 'PF16187', NULL, NULL, 'Middle or third domain of peptidase_M16', NULL, 'Peptidase_M16_M', NULL, NULL, 21660, 9),
(259368, NULL, 'PF09628', NULL, NULL, 'YvfG protein', NULL, 'YvfG', NULL, NULL, 15987, 9),
(259369, NULL, 'PF11337', NULL, NULL, 'Protein of unknown function (DUF3139)', NULL, 'DUF3139', NULL, NULL, 18069, 9),
(259370, NULL, 'PF09399', NULL, NULL, 'Betacoronavirus lipid binding protein', NULL, 'bCoV_lipid_BD', NULL, NULL, 14626, 9),
(259371, NULL, 'PF09531', NULL, NULL, 'Nucleoporin protein Ndc1-Nup', NULL, 'Ndc1_Nup', NULL, NULL, 16806, 9),
(259372, NULL, 'PF14615', NULL, NULL, 'Ribosome-assembly protein 3', NULL, 'Rsa3', NULL, NULL, 23656, 9),
(259373, NULL, 'PF00407', NULL, NULL, 'Pathogenesis-related protein Bet v 1 family', NULL, 'Bet_v_1', NULL, NULL, 4348, 9),
(259374, NULL, 'PF10659', NULL, NULL, 'Trypanosome variant surface glycoprotein C-terminal domain', NULL, 'Trypan_glycop_C', NULL, NULL, 20422, 9),
(259375, NULL, 'PF01024', NULL, NULL, 'Colicin pore forming domain', NULL, 'Colicin', NULL, NULL, 4747, 9),
(259376, NULL, 'PF05168', NULL, NULL, 'HEPN domain', NULL, 'HEPN', NULL, NULL, 2497, 9),
(259377, NULL, 'PF06832', NULL, NULL, 'Penicillin-Binding Protein C-terminus Family', NULL, 'BiPBP_C', NULL, NULL, 11222, 9),
(259378, NULL, 'PF17923', NULL, NULL, 'Tetracyclin repressor-like, C-terminal domain', NULL, 'TetR_C_18', NULL, NULL, 29029, 9),
(259379, NULL, 'PF19611', NULL, NULL, 'Family of unknown function (DUF6116)', NULL, 'DUF6116', NULL, NULL, 37478, 9),
(259380, NULL, 'PF10993', NULL, NULL, 'Protein of unknown function (DUF2818)', NULL, 'DUF2818', NULL, NULL, 21134, 9),
(259381, NULL, 'PF16883', NULL, NULL, 'Domain of unknown function (DUF5080)', NULL, 'DUF5080', NULL, NULL, 24204, 9),
(259382, NULL, 'PF11123', NULL, NULL, 'DNA packaging protein', NULL, 'DNA_Packaging_2', NULL, NULL, 22196, 9),
(259383, NULL, 'PF13217', NULL, NULL, 'Protein of unknown function (DUF4025)', NULL, 'DUF4025', NULL, NULL, 22706, 9),
(259384, NULL, 'PF02120', NULL, NULL, 'Flagellar hook-length control protein FliK', NULL, 'Flg_hook', NULL, NULL, 15395, 9),
(259385, NULL, 'PF14579', NULL, NULL, 'Helix-hairpin-helix motif', NULL, 'HHH_6', NULL, NULL, 23163, 9),
(259386, NULL, 'PF15300', NULL, NULL, 'INTS6/SAGE1/DDX26B/CT45 C-terminus', NULL, 'INT_SG_DDX_CT_C', NULL, NULL, 24801, 9),
(259387, NULL, 'PF14947', NULL, NULL, 'Winged helix-turn-helix', NULL, 'HTH_45', NULL, NULL, 31760, 9),
(259388, NULL, 'PF01436', NULL, NULL, 'NHL repeat', NULL, 'NHL', NULL, NULL, 2376, 9),
(259389, NULL, 'PF13909', NULL, NULL, 'C2H2-type zinc-finger domain', NULL, 'zf-H2C2_5', NULL, NULL, NULL, 9),
(259390, NULL, 'PF15079', NULL, NULL, 'Testis-specific protein 35', NULL, 'Tsc35', NULL, NULL, 23995, 9),
(259391, NULL, 'PF00217', NULL, NULL, 'ATP:guanido phosphotransferase, C-terminal catalytic domain', NULL, 'ATP-gua_Ptrans', NULL, NULL, 15799, 9),
(259392, NULL, 'PF01963', NULL, NULL, 'TraB/PrgY/gumN family', NULL, 'TraB_PrgY_gumN', NULL, NULL, 4578, 9),
(259393, NULL, 'PF03944', NULL, NULL, 'delta endotoxin', NULL, 'Endotoxin_C', NULL, NULL, 2774, 9),
(259394, NULL, 'PF19560', NULL, NULL, 'Family of unknown function (DUF6082)', NULL, 'DUF6082', NULL, NULL, 34324, 9),
(259395, NULL, 'PF09713', NULL, NULL, 'Plant protein 1589 of unknown function (A_thal_3526)', NULL, 'A_thal_3526', NULL, NULL, 6335, 9),
(259396, NULL, 'PF18992', NULL, NULL, 'Family of unknown function (DUF5725)', NULL, 'DUF5725', NULL, NULL, 35319, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(259397, NULL, 'PF05315', NULL, NULL, 'ICEA Protein', NULL, 'ICEA', NULL, NULL, 4176, 9),
(259398, NULL, 'PF06108', NULL, NULL, 'Protein of unknown function (DUF952)', NULL, 'DUF952', NULL, NULL, 13563, 9),
(259399, NULL, 'PF13221', NULL, NULL, 'Protein of unknown function (DUF4029)', NULL, 'DUF4029', NULL, NULL, 22547, 9),
(259400, NULL, 'PF02806', NULL, NULL, 'Alpha amylase, C-terminal all-beta domain', NULL, 'Alpha-amylase_C', NULL, NULL, 2588, 9),
(259401, NULL, 'PF17686', NULL, NULL, 'Family of unknown function (DUF5534)', NULL, 'DUF5534', NULL, NULL, 33329, 9),
(259402, NULL, 'PF10017', NULL, NULL, 'Histidine-specific methyltransferase, SAM-dependent', NULL, 'Methyltransf_33', NULL, NULL, 19508, 9),
(259403, NULL, 'PF03930', NULL, NULL, 'Recombinase Flp protein N-terminus', NULL, 'Flp_N', NULL, NULL, 16539, 9),
(259404, NULL, 'PF16193', NULL, NULL, 'AAA C-terminal domain', NULL, 'AAA_assoc_2', NULL, NULL, 25134, 9),
(259405, NULL, 'PF18182', NULL, NULL, 'minimal CRISPR polymerase domain', NULL, 'mCpol', NULL, NULL, 29288, 9),
(259406, NULL, 'PF00453', NULL, NULL, 'Ribosomal protein L20', NULL, 'Ribosomal_L20', NULL, NULL, 5975, 9),
(259407, NULL, 'PF04784', NULL, NULL, 'Protein of unknown function, DUF547', NULL, 'DUF547', NULL, NULL, 4706, 9),
(259408, NULL, 'PF05974', NULL, NULL, 'Domain of unknown function (DUF892)', NULL, 'DUF892', NULL, NULL, 7826, 9),
(259409, NULL, 'PF10192', NULL, NULL, 'Rhodopsin-like GPCR transmembrane domain', NULL, 'GpcrRhopsn4', NULL, NULL, 15640, 9),
(259410, NULL, 'PF01065', NULL, NULL, 'Hexon, adenovirus major coat protein, N-terminal domain', NULL, 'Adeno_hexon', NULL, NULL, 11055, 9),
(259411, NULL, 'PF11040', NULL, NULL, 'Dispersed gene family protein 1 of Trypanosoma cruzi C-terminus', NULL, 'DGF-1_C', NULL, NULL, 15035, 9),
(259412, NULL, 'PF09435', NULL, NULL, 'Fungal protein of unknown function (DUF2015)', NULL, 'DUF2015', NULL, NULL, 15278, 9),
(259413, NULL, 'PF09102', NULL, NULL, 'Exotoxin A, targeting', NULL, 'Exotox-A_target', NULL, NULL, 10890, 9),
(259414, NULL, 'PF09373', NULL, NULL, 'Pseudomurein-binding repeat', NULL, 'PMBR', NULL, NULL, 14954, 9),
(259415, NULL, 'PF02457', NULL, NULL, 'DisA bacterial checkpoint controller nucleotide-binding', NULL, 'DAC', NULL, NULL, 4168, 9),
(259416, NULL, 'PF20514', NULL, NULL, 'ROXA-like winged helix', NULL, 'ROXA-like_wH', NULL, NULL, 35705, 9),
(259417, NULL, 'PF03735', NULL, NULL, 'ENT domain', NULL, 'ENT', NULL, NULL, 879, 9),
(259418, NULL, 'PF13239', NULL, NULL, '2TM domain', NULL, '2TM', NULL, NULL, 22861, 9),
(259419, NULL, 'PF17980', NULL, NULL, 'Cysteine rich ADD domain in DNMT3', NULL, 'ADD_DNMT3', NULL, NULL, 27333, 9),
(259420, NULL, 'PF19847', NULL, NULL, 'Family of unknown function (DUF6322)', NULL, 'DUF6322', NULL, NULL, 37678, 9),
(259421, NULL, 'PF20324', NULL, NULL, 'Family of unknown function (DUF6619)', NULL, 'DUF6619', NULL, NULL, 37498, 9),
(259422, NULL, 'PF01634', NULL, NULL, 'ATP phosphoribosyltransferase', NULL, 'HisG', NULL, NULL, 13700, 9),
(259423, NULL, 'PF08390', NULL, NULL, 'TRAM1-like protein', NULL, 'TRAM1', NULL, NULL, 11461, 9),
(259424, NULL, 'PF03694', NULL, NULL, 'Erg28 like protein', NULL, 'Erg28', NULL, NULL, 6261, 9),
(259425, NULL, 'PF09069', NULL, NULL, 'EF-hand', NULL, 'EF-hand_3', NULL, NULL, 9859, 9),
(259426, NULL, 'PF07015', NULL, NULL, 'VirC1 protein', NULL, 'VirC1', NULL, NULL, 12369, 9),
(259427, NULL, 'PF19042', NULL, NULL, 'Nuclear cap binding complex subunit CBP110', NULL, 'CBP110', NULL, NULL, 34305, 9),
(259428, NULL, 'PF07421', NULL, NULL, 'Neurotensin/neuromedin N precursor', NULL, 'Pro-NT_NN', NULL, NULL, 5158, 9),
(259429, NULL, 'PF12967', NULL, NULL, 'Domain of Unknown Function with PDB structure (DUF3855)', NULL, 'DUF3855', NULL, NULL, 22745, 9),
(259430, NULL, 'PF05970', NULL, NULL, 'PIF1-like helicase', NULL, 'PIF1', NULL, NULL, 7882, 9),
(259431, NULL, 'PF11285', NULL, NULL, 'Protein of unknown function (DUF3086)', NULL, 'DUF3086', NULL, NULL, 18210, 9),
(259432, NULL, 'PF16963', NULL, NULL, 'PelD GGDEF domain', NULL, 'PelD_GGDEF', NULL, NULL, 22292, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(259433, NULL, 'PF16669', NULL, NULL, 'Tetratricopeptide repeat protein 5 OB fold domain', NULL, 'TTC5_OB', NULL, NULL, 26186, 9),
(259434, NULL, 'PF15722', NULL, NULL, 'FAM153 family', NULL, 'FAM153', NULL, NULL, 15581, 9),
(259435, NULL, 'PF15163', NULL, NULL, 'Meiosis-expressed', NULL, 'Meiosis_expr', NULL, NULL, 17679, 9),
(259436, NULL, 'PF00086', NULL, NULL, 'Thyroglobulin type-1 repeat', NULL, 'Thyroglobulin_1', NULL, NULL, 6911, 9),
(259437, NULL, 'PF15050', NULL, NULL, 'SCIMP protein', NULL, 'SCIMP', NULL, NULL, 21604, 9),
(259438, NULL, 'PF14696', NULL, NULL, 'Hydroxyphenylpyruvate dioxygenase, HPPD, N-terminal', NULL, 'Glyoxalase_5', NULL, NULL, NULL, 9),
(259439, NULL, 'PF02423', NULL, NULL, 'Ornithine cyclodeaminase/mu-crystallin family', NULL, 'OCD_Mu_crystall', NULL, NULL, 5153, 9),
(259440, NULL, 'PF05608', NULL, NULL, 'Protein of unknown function (DUF778)', NULL, 'DUF778', NULL, NULL, 12289, 9),
(259441, NULL, 'PF20113', NULL, NULL, 'Family of unknown function (DUF6503)', NULL, 'DUF6503', NULL, NULL, 37127, 9),
(259442, NULL, 'PF08388', NULL, NULL, 'Group II intron, maturase-specific domain', NULL, 'GIIM', NULL, NULL, 11917, 9),
(259443, NULL, 'PF20188', NULL, NULL, 'Family of unknown function (DUF6551)', NULL, 'DUF6551', NULL, NULL, 37376, 9),
(259444, NULL, 'PF02938', NULL, NULL, 'GAD domain', NULL, 'GAD', NULL, NULL, 23390, 9),
(259445, NULL, 'PF07718', NULL, NULL, 'Coatomer beta C-terminal region', NULL, 'Coatamer_beta_C', NULL, NULL, 8275, 9),
(259446, NULL, 'PF18219', NULL, NULL, 'SidC N-terminal domain', NULL, 'SidC_N', NULL, NULL, 29429, 9),
(259447, NULL, 'PF20408', NULL, NULL, 'Alpha/beta hydrolase domain', NULL, 'Abhydrolase_11', NULL, NULL, 37671, 9),
(259448, NULL, 'PF19065', NULL, NULL, 'Family of unknown function (DUF5761)', NULL, 'DUF5761', NULL, NULL, 35378, 9),
(259449, NULL, 'PF05609', NULL, NULL, 'Lamina-associated polypeptide 1, AAA+ activator domain', NULL, 'LAP1_C', NULL, NULL, 33690, 9),
(259450, NULL, 'PF13021', NULL, NULL, 'Domain of unknown function (DUF3885)', NULL, 'DUF3885', NULL, NULL, 22203, 9),
(259451, NULL, 'PF10483', NULL, NULL, 'Elongator subunit Iki1', NULL, 'Elong_Iki1', NULL, NULL, 18250, 9),
(259452, NULL, 'PF19841', NULL, NULL, 'Gliding motility associated protein GldN', NULL, 'GldN', NULL, NULL, 14709, 9),
(259453, NULL, 'PF01755', NULL, NULL, 'Glycosyltransferase family 25 (LPS biosynthesis protein)', NULL, 'Glyco_transf_25', NULL, NULL, 2867, 9),
(259454, NULL, 'PF11146', NULL, NULL, 'Protein of unknown function (DUF2905)', NULL, 'DUF2905', NULL, NULL, 17515, 9),
(259455, NULL, 'PF06021', NULL, NULL, 'Aralkyl acyl-CoA:amino acid N-acyltransferase', NULL, 'Gly_acyl_tr_N', NULL, NULL, 9201, 9),
(259456, NULL, 'PF10618', NULL, NULL, 'Phage tail tube protein', NULL, 'Tail_tube', NULL, NULL, 20471, 9),
(259457, NULL, 'PF20434', NULL, NULL, 'BD-FAE', NULL, 'BD-FAE', NULL, NULL, NULL, 9),
(259458, NULL, 'PF02078', NULL, NULL, 'Synapsin, N-terminal domain', NULL, 'Synapsin', NULL, NULL, 20574, 9),
(259459, NULL, 'PF09963', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2197)', NULL, 'DUF2197', NULL, NULL, 19136, 9),
(259460, NULL, 'PF01338', NULL, NULL, 'Bacillus thuringiensis toxin', NULL, 'Bac_thur_toxin', NULL, NULL, 3071, 9),
(259461, NULL, 'PF04814', NULL, NULL, 'Hepatocyte nuclear factor 1 (HNF-1), N terminus', NULL, 'HNF-1_N', NULL, NULL, 4573, 9),
(259462, NULL, 'PF05767', NULL, NULL, 'Poxvirus virion envelope protein A14', NULL, 'Pox_A14', NULL, NULL, 12401, 9),
(259463, NULL, 'PF19974', NULL, NULL, 'Ternary complex associated domain 9', NULL, 'TCAD9', NULL, NULL, 35688, 9),
(259464, NULL, 'PF04920', NULL, NULL, 'Beet necrotic yellow vein virus, p31', NULL, 'BNYVV_p31', NULL, NULL, 6744, 9),
(259465, NULL, 'PF00384', NULL, NULL, 'Molybdopterin oxidoreductase', NULL, 'Molybdopterin', NULL, NULL, 1091, 9),
(259466, NULL, 'PF18152', NULL, NULL, 'DAHP synthase ferredoxin-like domain', NULL, 'DAHP_snth_FXD', NULL, NULL, 28967, 9),
(259467, NULL, 'PF00749', NULL, NULL, 'tRNA synthetases class I (E and Q), catalytic domain', NULL, 'tRNA-synt_1c', NULL, NULL, 16364, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(259468, NULL, 'PF18351', NULL, NULL, 'Fungal Argonaute N-terminal domain', NULL, 'Ago_N_1', NULL, NULL, 29191, 9),
(259469, NULL, 'PF20400', NULL, NULL, 'BAR-like domain', NULL, 'BAR_4', NULL, NULL, 37558, 9),
(259470, NULL, 'PF13580', NULL, NULL, 'SIS domain', NULL, 'SIS_2', NULL, NULL, 7474, 9),
(259471, NULL, 'PF14776', NULL, NULL, 'Cation-channel complex subunit UNC-79', NULL, 'UNC-79', NULL, NULL, NULL, 9),
(259472, NULL, 'PF08716', NULL, NULL, 'Coronavirus replicase NSP7', NULL, 'CoV_NSP7', NULL, NULL, 11943, 9),
(259473, NULL, 'PF08730', NULL, NULL, 'Rad33', NULL, 'Rad33', NULL, NULL, 11740, 9),
(259474, NULL, 'PF03613', NULL, NULL, 'PTS system mannose/fructose/sorbose family IID component', NULL, 'EIID-AGA', NULL, NULL, 3008, 9),
(259475, NULL, 'PF09825', NULL, NULL, 'Biotin-protein ligase, N terminal', NULL, 'BPL_N', NULL, NULL, 18264, 9),
(259476, NULL, 'PF07109', NULL, NULL, 'Magnesium-protoporphyrin IX methyltransferase C-terminus', NULL, 'Mg-por_mtran_C', NULL, NULL, 7766, 9),
(259477, NULL, 'PF18795', NULL, NULL, 'DNA mismatch repair protein HSM3, N terminal domain', NULL, 'HSM3_N', NULL, NULL, 29739, 9),
(259478, NULL, 'PF06249', NULL, NULL, 'Ethanolamine utilisation protein EutQ', NULL, 'EutQ', NULL, NULL, 9166, 9),
(259479, NULL, 'PF14277', NULL, NULL, 'Domain of unknown function (DUF4364)', NULL, 'DUF4364', NULL, NULL, 21501, 9),
(259480, NULL, 'PF18896', NULL, NULL, 'Lysozyme like domain', NULL, 'SLT_3', NULL, NULL, 35035, 9),
(259481, NULL, 'PF20233', NULL, NULL, 'Family of unknown function (DUF6590)', NULL, 'DUF6590', NULL, NULL, 37525, 9),
(259482, NULL, 'PF00982', NULL, NULL, 'Glycosyltransferase family 20', NULL, 'Glyco_transf_20', NULL, NULL, 4078, 9),
(259483, NULL, 'PF09562', NULL, NULL, 'LlaMI restriction endonuclease', NULL, 'RE_LlaMI', NULL, NULL, 16563, 9),
(259484, NULL, 'PF12265', NULL, NULL, 'Histone-binding protein RBBP4 or subunit C of CAF1 complex', NULL, 'CAF1C_H4-bd', NULL, NULL, 20463, 9),
(259485, NULL, 'PF11011', NULL, NULL, 'Protein of unknown function (DUF2849)', NULL, 'DUF2849', NULL, NULL, 17823, 9),
(259486, NULL, 'PF11416', NULL, NULL, 'Syntaxin-5 N-terminal, Sly1p-binding domain', NULL, 'Syntaxin-5_N', NULL, NULL, 18898, 9),
(259487, NULL, 'PF13945', NULL, NULL, 'Salt tolerance down-regulator', NULL, 'NST1', NULL, NULL, 23173, 9),
(259488, NULL, 'PF09740', NULL, NULL, 'Uncharacterized conserved protein (DUF2043)', NULL, 'DUF2043', NULL, NULL, 16290, 9),
(259489, NULL, 'PF11073', NULL, NULL, 'Rift valley fever virus non structural protein (NSs) like', NULL, 'NSs', NULL, NULL, 33364, 9),
(259490, NULL, 'PF17653', NULL, NULL, 'Family of unknown function (DUF5522)', NULL, 'DUF5522', NULL, NULL, 29281, 9),
(259491, NULL, 'PF13421', NULL, NULL, 'SPFH domain-Band 7 family', NULL, 'Band_7_1', NULL, NULL, 29144, 9),
(259492, NULL, 'PF01408', NULL, NULL, 'Oxidoreductase family, NAD-binding Rossmann fold', NULL, 'GFO_IDH_MocA', NULL, NULL, 3776, 9),
(259493, NULL, 'PF02678', NULL, NULL, 'Pirin', NULL, 'Pirin', NULL, NULL, 3182, 9),
(259494, NULL, 'PF12864', NULL, NULL, 'Protein of unknown function (DUF3822)', NULL, 'DUF3822', NULL, NULL, 21426, 9),
(259495, NULL, 'PF10383', NULL, NULL, 'Transcription-silencing protein Clr2', NULL, 'Clr2', NULL, NULL, 20171, 9),
(259496, NULL, 'PF01186', NULL, NULL, 'Lysyl oxidase', NULL, 'Lysyl_oxidase', NULL, NULL, 3414, 9),
(259497, NULL, 'PF01365', NULL, NULL, 'RIH domain', NULL, 'RYDR_ITPR', NULL, NULL, 6604, 9),
(259498, NULL, 'PF10398', NULL, NULL, 'Protein of unknown function (DUF2443)', NULL, 'DUF2443', NULL, NULL, 17304, 9),
(259499, NULL, 'PF08312', NULL, NULL, 'cwf21 domain', NULL, 'cwf21', NULL, NULL, 8725, 9),
(259500, NULL, 'PF07435', NULL, NULL, 'YycH protein', NULL, 'YycH', NULL, NULL, 8531, 9),
(259501, NULL, 'PF13509', NULL, NULL, 'S1 domain', NULL, 'S1_2', NULL, NULL, 27141, 9),
(259502, NULL, 'PF15374', NULL, NULL, 'Coiled-coil domain-containing protein 71L', NULL, 'CCDC71L', NULL, NULL, 24356, 9),
(259503, NULL, 'PF02563', NULL, NULL, 'Polysaccharide biosynthesis/export protein', NULL, 'Poly_export', NULL, NULL, 6208, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(259504, NULL, 'PF11858', NULL, NULL, 'Domain of unknown function (DUF3378)', NULL, 'DUF3378', NULL, NULL, 21535, 9),
(259505, NULL, 'PF04327', NULL, NULL, 'Cysteine protease Prp', NULL, 'Peptidase_Prp', NULL, NULL, 3544, 9),
(259506, NULL, 'PF13038', NULL, NULL, 'Domain of unknown function (DUF3899)', NULL, 'DUF3899', NULL, NULL, 22535, 9),
(259507, NULL, 'PF08244', NULL, NULL, 'Glycosyl hydrolases family 32 C terminal', NULL, 'Glyco_hydro_32C', NULL, NULL, 17206, 9),
(259508, NULL, 'PF11826', NULL, NULL, 'Protein of unknown function (DUF3346)', NULL, 'DUF3346', NULL, NULL, 19415, 9),
(259509, NULL, 'PF13831', NULL, NULL, 'PHD-finger', NULL, 'PHD_2', NULL, NULL, NULL, 9),
(259510, NULL, 'PF03620', NULL, NULL, 'IBV 3C protein', NULL, 'IBV_3C', NULL, NULL, 5485, 9),
(259511, NULL, 'PF08031', NULL, NULL, 'Berberine and berberine like', NULL, 'BBE', NULL, NULL, 11983, 9),
(259512, NULL, 'PF15631', NULL, NULL, 'NTF2 fold immunity protein', NULL, 'Imm-NTF2-2', NULL, NULL, 25026, 9),
(259513, NULL, 'PF06644', NULL, NULL, 'ATP11 protein', NULL, 'ATP11', NULL, NULL, 8122, 9),
(259514, NULL, 'PF12096', NULL, NULL, 'Protein of unknown function (DUF3572)', NULL, 'DUF3572', NULL, NULL, 20174, 9),
(259515, NULL, 'PF16248', NULL, NULL, 'Domain of unknown function (DUF4905)', NULL, 'DUF4905', NULL, NULL, 23810, 9),
(259516, NULL, 'PF17791', NULL, NULL, 'Macroglobulin domain MG3', NULL, 'MG3', NULL, NULL, 30331, 9),
(259517, NULL, 'PF03459', NULL, NULL, 'TOBE domain', NULL, 'TOBE', NULL, NULL, 10753, 9),
(259518, NULL, 'PF17497', NULL, NULL, 'Family of unknown function (DUF5432)', NULL, 'DUF5432', NULL, NULL, 21499, 9),
(259519, NULL, 'PF13759', NULL, NULL, 'Putative 2OG-Fe(II) oxygenase', NULL, '2OG-FeII_Oxy_5', NULL, NULL, 12996, 9),
(259520, NULL, 'PF00919', NULL, NULL, 'Uncharacterized protein family UPF0004', NULL, 'UPF0004', NULL, NULL, 8095, 9),
(259521, NULL, 'PF17257', NULL, NULL, 'Family of unknown function (DUF5323)', NULL, 'DUF5323', NULL, NULL, 19217, 9),
(259522, NULL, 'PF00813', NULL, NULL, 'FliP family', NULL, 'FliP', NULL, NULL, 5727, 9),
(259523, NULL, 'PF01001', NULL, NULL, 'Hepatitis C virus non-structural protein NS4b', NULL, 'HCV_NS4b', NULL, NULL, 5562, 9),
(259524, NULL, 'PF10910', NULL, NULL, 'Protein of unknown function (DUF2744)', NULL, 'DUF2744', NULL, NULL, 17863, 9),
(259525, NULL, 'PF05890', NULL, NULL, 'Eukaryotic rRNA processing protein EBP2', NULL, 'Ebp2', NULL, NULL, 14441, 9),
(259526, NULL, 'PF16350', NULL, NULL, 'FAD dependent oxidoreductase central domain', NULL, 'FAO_M', NULL, NULL, 22280, 9),
(259527, NULL, 'PF09826', NULL, NULL, 'Beta propeller domain', NULL, 'Beta_propel', NULL, NULL, 18457, 9),
(259528, NULL, 'PF01692', NULL, NULL, 'Paramyxovirus non-structural protein C', NULL, 'Paramyxo_C', NULL, NULL, 1535, 9),
(259529, NULL, 'PF17329', NULL, NULL, 'Family of unknown function (DUF5367)', NULL, 'DUF5367', NULL, NULL, 20126, 9),
(259530, NULL, 'PF13581', NULL, NULL, 'Histidine kinase-like ATPase domain', NULL, 'HATPase_c_2', NULL, NULL, 52, 9),
(259531, NULL, 'PF19840', NULL, NULL, 'Family of unknown function (DUF6317)', NULL, 'DUF6317', NULL, NULL, 36496, 9),
(259532, NULL, 'PF16329', NULL, NULL, 'Pestivirus envelope glycoprotein E2', NULL, 'Pestivirus_E2', NULL, NULL, 24964, 9),
(259533, NULL, 'PF17582', NULL, NULL, 'Cytomegalovirus UL20', NULL, 'UL20', NULL, NULL, 30661, 9),
(259534, NULL, 'PF18849', NULL, NULL, 'Bacterial archaeo-eukaryotic release factor family 7', NULL, 'baeRF_family7', NULL, NULL, 32240, 9),
(259535, NULL, 'PF14311', NULL, NULL, 'Probable Zinc-ribbon domain', NULL, 'DUF4379', NULL, NULL, 26042, 9),
(259536, NULL, 'PF19806', NULL, NULL, 'Family of unknown function (DUF6289)', NULL, 'DUF6289', NULL, NULL, 37169, 9),
(259537, NULL, 'PF15322', NULL, NULL, 'Protein missing in infertile sperm 1, putative', NULL, 'PMSI1', NULL, NULL, 24980, 9),
(259538, NULL, 'PF17420', NULL, NULL, 'Superinfection exclusion gene product 17', NULL, 'GP17', NULL, NULL, 20866, 9),
(259539, NULL, 'PF12832', NULL, NULL, 'MFS_1 like family', NULL, 'MFS_1_like', NULL, NULL, 22629, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(259540, NULL, 'PF06972', NULL, NULL, 'GBF-interacting protein 1 N-terminal', NULL, 'GIP1_N', NULL, NULL, 12362, 9),
(259541, NULL, 'PF13486', NULL, NULL, 'Reductive dehalogenase subunit', NULL, 'Dehalogenase', NULL, NULL, 23737, 9),
(259542, NULL, 'PF00032', NULL, NULL, 'Cytochrome b(C-terminal)/b6/petD', NULL, 'Cytochrom_B_C', NULL, NULL, 5662, 9),
(259543, NULL, 'PF15647', NULL, NULL, 'Restriction endonuclease fold toxin 3', NULL, 'Tox-REase-3', NULL, NULL, 24644, 9),
(259544, NULL, 'PF06573', NULL, NULL, 'Churchill protein', NULL, 'Churchill', NULL, NULL, 9078, 9),
(259545, NULL, 'PF15637', NULL, NULL, 'HNH/Endo VII superfamily nuclease toxin with a HHH motif', NULL, 'Tox-HNH-HHH', NULL, NULL, 25020, 9),
(259546, NULL, 'PF02065', NULL, NULL, 'Melibiase', NULL, 'Melibiase', NULL, NULL, NULL, 9),
(259547, NULL, 'PF06501', NULL, NULL, 'Human herpesvirus U55 protein', NULL, 'Herpes_U55', NULL, NULL, 9150, 9),
(259548, NULL, 'PF02676', NULL, NULL, 'Methyltransferase TYW3', NULL, 'TYW3', NULL, NULL, 6263, 9),
(259549, NULL, 'PF04257', NULL, NULL, 'Exodeoxyribonuclease V, gamma subunit', NULL, 'Exonuc_V_gamma', NULL, NULL, NULL, 9),
(259550, NULL, 'PF14803', NULL, NULL, 'Nudix N-terminal', NULL, 'Nudix_N_2', NULL, NULL, 24928, 9),
(259551, NULL, 'PF01011', NULL, NULL, 'PQQ enzyme repeat', NULL, 'PQQ', NULL, NULL, 6324, 9),
(259552, NULL, 'PF14824', NULL, NULL, 'Sirohaem biosynthesis protein central', NULL, 'Sirohm_synth_M', NULL, NULL, 26783, 9),
(259553, NULL, 'PF16589', NULL, NULL, 'BRCT domain, a BRCA1 C-terminus domain', NULL, 'BRCT_2', NULL, NULL, 7483, 9),
(259554, NULL, 'PF16571', NULL, NULL, 'FBP C-terminal treble-clef zinc-finger', NULL, 'FBP_C', NULL, NULL, 25163, 9),
(259555, NULL, 'PF00856', NULL, NULL, 'SET domain', NULL, 'SET', NULL, NULL, 2465, 9),
(259556, NULL, 'PF08748', NULL, NULL, 'Phage tail assembly chaperone', NULL, 'Phage_TAC_4', NULL, NULL, 13226, 9),
(259557, NULL, 'PF15910', NULL, NULL, 'ICOS V-set domain', NULL, 'V-set_2', NULL, NULL, 18504, 9),
(259558, NULL, 'PF07981', NULL, NULL, 'Plasmodium repeat_MYXSPDY', NULL, 'Plasmod_MYXSPDY', NULL, NULL, 9194, 9),
(259559, NULL, 'PF10234', NULL, NULL, 'Clusterin-associated protein-1', NULL, 'Cluap1', NULL, NULL, 15518, 9),
(259560, NULL, 'PF04200', NULL, NULL, 'Lipoprotein associated domain', NULL, 'Lipoprotein_17', NULL, NULL, 5004, 9),
(259561, NULL, 'PF06853', NULL, NULL, 'Protein of unknown function (DUF1249)', NULL, 'DUF1249', NULL, NULL, 11500, 9),
(259562, NULL, 'PF07962', NULL, NULL, 'Replication Fork Protection Component Swi3', NULL, 'Swi3', NULL, NULL, 7891, 9),
(259563, NULL, 'PF13707', NULL, NULL, 'RloB-like protein', NULL, 'RloB', NULL, NULL, 22825, 9),
(259564, NULL, 'PF19766', NULL, NULL, 'Family of unknown function (DUF6253)', NULL, 'DUF6253', NULL, NULL, 37211, 9),
(259565, NULL, 'PF12371', NULL, NULL, 'Transmembrane protein 131-like N-terminal', NULL, 'TMEM131_like_N', NULL, NULL, 20807, 9),
(259566, NULL, 'PF12679', NULL, NULL, 'ABC-2 family transporter protein', NULL, 'ABC2_membrane_2', NULL, NULL, 26901, 9),
(259567, NULL, 'PF14490', NULL, NULL, 'Helix-hairpin-helix containing domain', NULL, 'HHH_4', NULL, NULL, 26157, 9),
(259568, NULL, 'PF20128', NULL, NULL, 'Family of unknown function (DUF6518)', NULL, 'DUF6518', NULL, NULL, 35763, 9),
(259569, NULL, 'PF00311', NULL, NULL, 'Phosphoenolpyruvate carboxylase', NULL, 'PEPcase', NULL, NULL, 15264, 9),
(259570, NULL, 'PF07408', NULL, NULL, 'Protein of unknown function (DUF1507)', NULL, 'DUF1507', NULL, NULL, 8315, 9),
(259571, NULL, 'PF11982', NULL, NULL, 'Domain of unknown function (DUF3483)', NULL, 'DUF3483', NULL, NULL, 19602, 9),
(259572, NULL, 'PF04641', NULL, NULL, 'Rtf2 RING-finger', NULL, 'Rtf2', NULL, NULL, NULL, 9),
(259573, NULL, 'PF08663', NULL, NULL, 'HalX domain', NULL, 'HalX', NULL, NULL, 7678, 9),
(259574, NULL, 'PF10807', NULL, NULL, 'Protein of unknown function (DUF2541)', NULL, 'DUF2541', NULL, NULL, 21148, 9),
(259575, NULL, 'PF03524', NULL, NULL, 'Conjugal transfer protein', NULL, 'CagX', NULL, NULL, 8501, 9),
(259576, NULL, 'PF10778', NULL, NULL, 'Halocarboxylic acid dehydrogenase DehI', NULL, 'DehI', NULL, NULL, 20649, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(259577, NULL, 'PF12699', NULL, NULL, 'phiKZ-like phage internal head proteins', NULL, 'phiKZ_IP', NULL, NULL, 22177, 9),
(259578, NULL, 'PF14829', NULL, NULL, 'Glycerol-3-phosphate acyltransferase N-terminal', NULL, 'GPAT_N', NULL, NULL, 15643, 9),
(259579, NULL, 'PF01031', NULL, NULL, 'Dynamin central region', NULL, 'Dynamin_M', NULL, NULL, 4638, 9),
(259580, NULL, 'PF06475', NULL, NULL, 'Putative glycolipid-binding', NULL, 'Glycolipid_bind', NULL, NULL, 9068, 9),
(259581, NULL, 'PF01973', NULL, NULL, '6-hydroxymethylpterin diphosphokinase MptE-like', NULL, 'MptE-like', NULL, NULL, 4605, 9),
(259582, NULL, 'PF17961', NULL, NULL, 'Bacterial Ig domain', NULL, 'Big_8', NULL, NULL, 28968, 9),
(259583, NULL, 'PF10964', NULL, NULL, 'Protein of unknown function (DUF2766)', NULL, 'DUF2766', NULL, NULL, 19196, 9),
(259584, NULL, 'PF17799', NULL, NULL, 'Rrp7 RRM-like N-terminal domain', NULL, 'RRM_Rrp7', NULL, NULL, 31991, 9),
(259585, NULL, 'PF00205', NULL, NULL, 'Thiamine pyrophosphate enzyme, central domain', NULL, 'TPP_enzyme_M', NULL, NULL, 7955, 9),
(259586, NULL, 'PF09163', NULL, NULL, 'Formate dehydrogenase N, transmembrane', NULL, 'Form-deh_trans', NULL, NULL, 12247, 9),
(259587, NULL, 'PF11876', NULL, NULL, 'Protein of unknown function (DUF3396)', NULL, 'DUF3396', NULL, NULL, 19179, 9),
(259588, NULL, 'PF15285', NULL, NULL, 'Beclin-1 BH3 domain, Bcl-2-interacting', NULL, 'BH3', NULL, NULL, 24806, 9),
(259589, NULL, 'PF09212', NULL, NULL, 'Carbohydrate binding module 27', NULL, 'CBM27', NULL, NULL, 12067, 9),
(259590, NULL, 'PF03335', NULL, NULL, 'Phage tail fibre repeat', NULL, 'Phage_fiber', NULL, NULL, 819, 9),
(259591, NULL, 'PF08256', NULL, NULL, 'Aurein-like antibiotic peptide', NULL, 'Antimicrobial20', NULL, NULL, 8606, 9),
(259592, NULL, 'PF09038', NULL, NULL, 'Tumour suppressor p53-binding protein-1 Tudor', NULL, '53-BP1_Tudor', NULL, NULL, 9964, 9),
(259593, NULL, 'PF15981', NULL, NULL, 'Envelope glycoprotein GP 5 of equine arteritis virus', NULL, 'EAV_GP5', NULL, NULL, 19789, 9),
(259594, NULL, 'PF17443', NULL, NULL, 'Uncharacterized protein pXO2-72', NULL, 'pXO2-72', NULL, NULL, 21332, 9),
(259595, NULL, 'PF19602', NULL, NULL, 'Family of unknown function (DUF6107)', NULL, 'DUF6107', NULL, NULL, 36927, 9),
(259596, NULL, 'PF00364', NULL, NULL, 'Biotin-requiring enzyme', NULL, 'Biotin_lipoyl', NULL, NULL, 2971, 9),
(259597, NULL, 'PF00733', NULL, NULL, 'Asparagine synthase', NULL, 'Asn_synthase', NULL, NULL, 2281, 9),
(259598, NULL, 'PF05235', NULL, NULL, 'CHAD domain', NULL, 'CHAD', NULL, NULL, 3387, 9),
(259599, NULL, 'PF13293', NULL, NULL, 'Domain of unknown function (DUF4074)', NULL, 'DUF4074', NULL, NULL, 25585, 9),
(259600, NULL, 'PF17416', NULL, NULL, 'Herpesvirus Glycoprotein B', NULL, 'Glycoprot_B_PH1', NULL, NULL, 33360, 9),
(259601, NULL, 'PF14221', NULL, NULL, 'Domain of unknown function (DUF4330)', NULL, 'DUF4330', NULL, NULL, 26422, 9),
(259602, NULL, 'PF20236', NULL, NULL, 'Family of unknown function (DUF6593)', NULL, 'DUF6593', NULL, NULL, 37681, 9),
(259603, NULL, 'PF13154', NULL, NULL, 'Protein of unknown function (DUF3991)', NULL, 'DUF3991', NULL, NULL, 22712, 9),
(259604, NULL, 'PF15328', NULL, NULL, 'Putative GRINL1B complex locus protein 2', NULL, 'GCOM2', NULL, NULL, 26114, 9),
(259605, NULL, 'PF16300', NULL, NULL, 'Type of WD40 repeat', NULL, 'WD40_4', NULL, NULL, NULL, 9),
(259606, NULL, 'PF02794', NULL, NULL, 'RTX toxin acyltransferase family', NULL, 'HlyC', NULL, NULL, 513, 9),
(259607, NULL, 'PF11601', NULL, NULL, 'Shal-type voltage-gated potassium channels, N-terminal', NULL, 'Shal-type', NULL, NULL, 18978, 9),
(259608, NULL, 'PF02102', NULL, NULL, 'Deuterolysin metalloprotease (M35) family', NULL, 'Peptidase_M35', NULL, NULL, 6678, 9),
(259609, NULL, 'PF13309', NULL, NULL, 'HTH domain', NULL, 'HTH_22', NULL, NULL, 30985, 9),
(259610, NULL, 'PF00679', NULL, NULL, 'Elongation factor G C-terminus', NULL, 'EFG_C', NULL, NULL, 3508, 9),
(259611, NULL, 'PF13301', NULL, NULL, 'Protein of unknown function (DUF4079)', NULL, 'DUF4079', NULL, NULL, 22265, 9);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(259612, NULL, 'PF08753', NULL, NULL, 'NikR C terminal nickel binding domain', NULL, 'NikR_C', NULL, NULL, 13287, 9),
(259613, NULL, 'PF18618', NULL, NULL, 'HP0268', NULL, 'HP0268', NULL, NULL, 29001, 9),
(259614, NULL, 'PF06124', NULL, NULL, 'Staphylococcal protein of unknown function (DUF960)', NULL, 'DUF960', NULL, NULL, 13754, 9),
(259615, NULL, 'PF17539', NULL, NULL, 'Family of unknown function (DUF5456)', NULL, 'DUF5456', NULL, NULL, 33576, 9),
(259616, NULL, 'PF11791', NULL, NULL, 'Aconitate B N-terminal domain', NULL, 'Aconitase_B_N', NULL, NULL, 8428, 9),
(259617, NULL, 'PF01899', NULL, NULL, 'Na+/H+ ion antiporter subunit', NULL, 'MNHE', NULL, NULL, 4372, 9),
(259618, NULL, 'PF03205', NULL, NULL, 'Molybdopterin guanine dinucleotide synthesis protein B', NULL, 'MobB', NULL, NULL, 7330, 9),
(259619, NULL, 'PF02538', NULL, NULL, 'Hydantoinase B/oxoprolinase', NULL, 'Hydantoinase_B', NULL, NULL, 1819, 9),
(259620, NULL, 'PF17719', NULL, NULL, 'Family of unknown function (DUF5564)', NULL, 'DUF5564', NULL, NULL, 28573, 9),
(259621, NULL, 'PF17755', NULL, NULL, 'UvrA DNA-binding domain', NULL, 'UvrA_DNA-bind', NULL, NULL, 30066, 9),
(259622, NULL, 'PF10235', NULL, NULL, 'Microtubule-associated protein CRIPT', NULL, 'Cript', NULL, NULL, 15767, 9),
(259623, NULL, 'PF18272', NULL, NULL, 'single-stranded DNA binding TraI N-terminal subdomain', NULL, 'ssDNA_TraI_N', NULL, NULL, 28797, 9),
(259624, NULL, 'PF04795', NULL, NULL, 'PAPA-1-like conserved region', NULL, 'PAPA-1', NULL, NULL, 4524, 9),
(259625, NULL, 'PF19879', NULL, NULL, 'Family of unknown function (DUF6352)', NULL, 'DUF6352', NULL, NULL, 36575, 9),
(259626, NULL, 'PF04741', NULL, NULL, 'InvH outer membrane lipoprotein', NULL, 'InvH', NULL, NULL, 3735, 9),
(259627, NULL, 'PF19220', NULL, NULL, 'Crescentin protein', NULL, 'Crescentin', NULL, NULL, 35360, 9),
(259628, NULL, 'PF00975', NULL, NULL, 'Thioesterase domain', NULL, 'Thioesterase', NULL, NULL, 1149, 9),
(259629, NULL, 'PF17224', NULL, NULL, 'Domain of unknown function (DUF5300)', NULL, 'DUF5300', NULL, NULL, 30395, 9),
(259630, NULL, 'PF19471', NULL, NULL, 'Family of unknown function (DUF6008)', NULL, 'DUF6008', NULL, NULL, 36874, 9),
(259631, NULL, 'PF10509', NULL, NULL, 'Galactokinase galactose-binding signature', NULL, 'GalKase_gal_bdg', NULL, NULL, 19397, 9),
(259632, NULL, 'PF16082', NULL, NULL, 'Bacteriophage holin family, superfamily II-like', NULL, 'Phage_holin_2_4', NULL, NULL, 22832, 9),
(259633, NULL, 'PF00370', NULL, NULL, 'FGGY family of carbohydrate kinases, N-terminal domain', NULL, 'FGGY_N', NULL, NULL, 21125, 9),
(259634, NULL, 'PF08829', NULL, NULL, 'Alpha C protein N terminal', NULL, 'AlphaC_N', NULL, NULL, 14139, 9),
(259635, NULL, 'PF19300', NULL, NULL, 'Binding-prot-dependent transport system membrane comp, N-term', NULL, 'BPD_transp_1_N', NULL, NULL, 34065, 9),
(259636, NULL, 'PF12386', NULL, NULL, 'Pseudomurein endo-isopeptidase Pei', NULL, 'Peptidase_C71', NULL, NULL, 20860, 9),
(259637, NULL, 'PF13074', NULL, NULL, 'Protein of unknown function (DUF3938)', NULL, 'DUF3938', NULL, NULL, 22761, 9),
(259638, NULL, 'PF04344', NULL, NULL, 'Chemotaxis phosphatase, CheZ', NULL, 'CheZ', NULL, NULL, 4433, 9),
(259639, NULL, 'PF10852', NULL, NULL, 'Protein of unknown function (DUF2651)', NULL, 'DUF2651', NULL, NULL, 19093, 9),
(259640, NULL, 'PF18615', NULL, NULL, 'Short myomegalin-like EB1 binding proteins, N-terminal domain', NULL, 'SMYLE_N', NULL, NULL, 29337, 9),
(259641, NULL, 'PF18389', NULL, NULL, 'TrmO C-terminal domain', NULL, 'TrmO_C', NULL, NULL, 29150, 9),
(259642, NULL, 'PF20145', NULL, NULL, 'ARMET, N-terminal', NULL, 'ARMET_N', NULL, NULL, 36433, 9),
(259643, NULL, 'PF18738', NULL, NULL, 'DZIP3/ hRUL138-like HEPN', NULL, 'HEPN_DZIP3', NULL, NULL, 29362, 9),
(259644, NULL, 'PF04811', NULL, NULL, 'Sec23/Sec24 trunk domain', NULL, 'Sec23_trunk', NULL, NULL, 4505, 9),
(259645, NULL, 'PF09936', NULL, NULL, 'SAM-dependent RNA methyltransferase', NULL, 'Methyltrn_RNA_4', NULL, NULL, 19224, 9),
(259646, NULL, 'PF01392', NULL, NULL, 'Fz domain', NULL, 'Fz', NULL, NULL, 18804, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(259647, NULL, 'PF04834', NULL, NULL, 'Early E3 14.5 kDa protein', NULL, 'Adeno_E3_14_5', NULL, NULL, 6087, 9),
(259648, NULL, 'PF10026', NULL, NULL, 'Predicted Zn-dependent protease (DUF2268)', NULL, 'DUF2268', NULL, NULL, 17995, 9),
(259649, NULL, 'PF02122', NULL, NULL, 'Peptidase S39', NULL, 'Peptidase_S39', NULL, NULL, 6679, 9),
(259650, NULL, 'PF02245', NULL, NULL, 'Methylpurine-DNA glycosylase (MPG)', NULL, 'Pur_DNA_glyco', NULL, NULL, 2693, 9),
(259651, NULL, 'PF01584', NULL, NULL, 'CheW-like domain', NULL, 'CheW', NULL, NULL, 1677, 9),
(259652, NULL, 'PF05595', NULL, NULL, 'Domain of unknown function (DUF771)', NULL, 'DUF771', NULL, NULL, 12109, 9),
(259653, NULL, 'PF05617', NULL, NULL, 'Prolamin-like', NULL, 'Prolamin_like', NULL, NULL, 12091, 9),
(259654, NULL, 'PF15836', NULL, NULL, 'SSTK-interacting protein, TSSK6-activating co-chaperone protein', NULL, 'SSTK-IP', NULL, NULL, 25502, 9),
(259655, NULL, 'PF07681', NULL, NULL, 'DoxX', NULL, 'DoxX', NULL, NULL, 22645, 9),
(259656, NULL, 'PF11267', NULL, NULL, 'Domain of unknown function (DUF3067)', NULL, 'DUF3067', NULL, NULL, 18452, 9),
(259657, NULL, 'PF12230', NULL, NULL, 'Pre-mRNA splicing factor PRP21 like protein', NULL, 'PRP21_like_P', NULL, NULL, 20124, 9),
(259658, NULL, 'PF20585', NULL, NULL, 'Putative pectate lyase-like adhesive domain', NULL, 'Pectate_lyase_5', NULL, NULL, 33515, 9),
(259659, NULL, 'PF01542', NULL, NULL, 'Hepatitis C virus core protein', NULL, 'HCV_core', NULL, NULL, 806, 9),
(259660, NULL, 'PF13240', NULL, NULL, 'zinc-ribbon domain', NULL, 'zinc_ribbon_2', NULL, NULL, 26747, 9),
(259661, NULL, 'PF18301', NULL, NULL, 'pre ATP-grasp 3 domain', NULL, 'preATP-grasp_3', NULL, NULL, 32078, 9),
(259662, NULL, 'PF16435', NULL, NULL, 'Domain of unknown function (DUF5032)', NULL, 'DUF5032', NULL, NULL, 24476, 9),
(259663, NULL, 'PF08982', NULL, NULL, 'Acetylaranotin biosynthesis cluster protein L', NULL, 'AtaL', NULL, NULL, 8570, 9),
(259664, NULL, 'PF16162', NULL, NULL, 'Domain of unknown function (DUF4868)', NULL, 'DUF4868', NULL, NULL, 22595, 9),
(259665, NULL, 'PF15915', NULL, NULL, 'GAF and HTH_10 associated domain', NULL, 'BAT', NULL, NULL, 24436, 9),
(259666, NULL, 'PF07059', NULL, NULL, 'Protein ENHANCED DISEASE RESISTANCE 2, C-terminal', NULL, 'EDR2_C', NULL, NULL, 12906, 9),
(259667, NULL, 'PF18898', NULL, NULL, 'Family of unknown function (DUF5654)', NULL, 'DUF5654', NULL, NULL, 35550, 9),
(259668, NULL, 'PF20208', NULL, NULL, 'Family of unknown function (DUF6569)', NULL, 'DUF6569', NULL, NULL, 37190, 9),
(259669, NULL, 'PF18673', NULL, NULL, 'interleukin receptor mimic protein A', NULL, 'IrmA', NULL, NULL, 28710, 9),
(259670, NULL, 'PF20413', NULL, NULL, 'Kiaa1109 N-terminal region', NULL, 'Kiaa1109_N', NULL, NULL, NULL, 9),
(259671, NULL, 'PF07026', NULL, NULL, 'Protein of unknown function (DUF1317)', NULL, 'DUF1317', NULL, NULL, 12390, 9),
(259672, NULL, 'PF09198', NULL, NULL, 'Bacteriophage T4 beta-glucosyltransferase', NULL, 'T4-Gluco-transf', NULL, NULL, 12062, 9),
(259673, NULL, 'PF01753', NULL, NULL, 'MYND finger', NULL, 'zf-MYND', NULL, NULL, 6032, 9),
(259674, NULL, 'PF12359', NULL, NULL, 'Protein of unknown function (DUF3645)', NULL, 'DUF3645', NULL, NULL, 20913, 9),
(259675, NULL, 'PF18225', NULL, NULL, 'Sensor histidine kinase (AbfS) sensor domain', NULL, 'AbfS_sensor', NULL, NULL, 28811, 9),
(259676, NULL, 'PF19886', NULL, NULL, 'Domain of unknown function (DUF6359)', NULL, 'DUF6359', NULL, NULL, 36938, 9),
(259677, NULL, 'PF13332', NULL, NULL, 'Hemagglutinin repeat', NULL, 'Fil_haemagg_2', NULL, NULL, 26359, 9),
(259678, NULL, 'PF20571', NULL, NULL, 'Domain of unknown function (DUF6780)', NULL, 'DUF6780', NULL, NULL, 37259, 9),
(259679, NULL, 'PF14633', NULL, NULL, 'SH2 domain', NULL, 'SH2_2', NULL, NULL, 18227, 9),
(259680, NULL, 'PF06167', NULL, NULL, 'Glucose-regulated metallo-peptidase M90', NULL, 'Peptidase_M90', NULL, NULL, 9412, 9),
(259681, NULL, 'PF18636', NULL, NULL, 'Mitochondrial morphogenesis protein SLD7 N-terminal domain', NULL, 'Sld7_N', NULL, NULL, 30275, 9),
(259682, NULL, 'PF10182', NULL, NULL, 'Flo11 domain', NULL, 'Flo11', NULL, NULL, 19384, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(259683, NULL, 'PF19011', NULL, NULL, 'Family of unknown function (DUF5740)', NULL, 'DUF5740', NULL, NULL, 35692, 9),
(259684, NULL, 'PF07682', NULL, NULL, 'Sulphur oxygenase reductase', NULL, 'SOR', NULL, NULL, 10523, 9),
(259685, NULL, 'PF14777', NULL, NULL, 'Cilia BBSome complex subunit 10', NULL, 'BBIP10', NULL, NULL, 22508, 9),
(259686, NULL, 'PF17895', NULL, NULL, 'Giardia Dicer N-terminal domain', NULL, 'Dicer_N', NULL, NULL, 29761, 9),
(259687, NULL, 'PF10972', NULL, NULL, 'Peptidoglycan-binding protein, CsiV', NULL, 'CsiV', NULL, NULL, 17530, 9),
(259688, NULL, 'PF17281', NULL, NULL, 'Family of unknown function (DUF5346)', NULL, 'DUF5346', NULL, NULL, 15047, 9),
(259689, NULL, 'PF16766', NULL, NULL, 'Binding region of GANP to ENY2', NULL, 'CID_GANP', NULL, NULL, 22404, 9),
(259690, NULL, 'PF10033', NULL, NULL, 'Autophagy-related protein 13', NULL, 'ATG13', NULL, NULL, 18117, 9),
(259691, NULL, 'PF08652', NULL, NULL, 'RAI1 like PD-(D/E)XK nuclease', NULL, 'RAI1', NULL, NULL, 7637, 9),
(259692, NULL, 'PF18842', NULL, NULL, 'Large polyvalent protein associated domain 26', NULL, 'LPD26', NULL, NULL, 29486, 9),
(259693, NULL, 'PF15451', NULL, NULL, 'Domain of unknown function (DUF4632)', NULL, 'DUF4632', NULL, NULL, 23801, 9),
(259694, NULL, 'PF20225', NULL, NULL, 'Family of unknown function (DUF6584)', NULL, 'DUF6584', NULL, NULL, 37741, 9),
(259695, NULL, 'PF13121', NULL, NULL, 'Domain of unknown function (DUF3976)', NULL, 'DUF3976', NULL, NULL, 25844, 9),
(259696, NULL, 'PF13340', NULL, NULL, 'Putative transposase of IS4/5 family (DUF4096)', NULL, 'DUF4096', NULL, NULL, 26015, 9),
(259697, NULL, 'PF02171', NULL, NULL, 'Piwi domain', NULL, 'Piwi', NULL, NULL, 1545, 9),
(259698, NULL, 'PF05285', NULL, NULL, 'SDA1', NULL, 'SDA1', NULL, NULL, 4024, 9),
(259699, NULL, 'PF04378', NULL, NULL, 'Ribosomal RNA large subunit methyltransferase D, RlmJ', NULL, 'RsmJ', NULL, NULL, 4868, 9),
(259700, NULL, 'PF07529', NULL, NULL, 'HSA domain', NULL, 'HSA', NULL, NULL, 9069, 9),
(259701, NULL, 'PF08939', NULL, NULL, 'Domain of unknown function (DUF1917)', NULL, 'DUF1917', NULL, NULL, 7582, 9),
(259702, NULL, 'PF01820', NULL, NULL, 'D-ala D-ala ligase N-terminus', NULL, 'Dala_Dala_lig_N', NULL, NULL, 9628, 9),
(259703, NULL, 'PF04410', NULL, NULL, 'Gar1/Naf1 RNA binding region', NULL, 'Gar1', NULL, NULL, 10058, 9),
(259704, NULL, 'PF13773', NULL, NULL, 'Domain of unknown function (DUF4170)', NULL, 'DUF4170', NULL, NULL, 23008, 9),
(259705, NULL, 'PF17106', NULL, NULL, 'Sigma domain on NACHT-NTPases', NULL, 'NACHT_sigma', NULL, NULL, 2704, 9),
(259706, NULL, 'PF16560', NULL, NULL, 'Putative mobile pathogenicity island', NULL, 'SAPI', NULL, NULL, 26467, 9),
(259707, NULL, 'PF19745', NULL, NULL, 'Alpha-(1,6)-fucosyltransferase N- and catalytic domains', NULL, 'FUT8_N_cat', NULL, NULL, 37359, 9),
(259708, NULL, 'PF00365', NULL, NULL, 'Phosphofructokinase', NULL, 'PFK', NULL, NULL, 2904, 9),
(259709, NULL, 'PF04263', NULL, NULL, 'Thiamin pyrophosphokinase, catalytic domain', NULL, 'TPK_catalytic', NULL, NULL, 5938, 9),
(259710, NULL, 'PF08562', NULL, NULL, 'Crisp', NULL, 'Crisp', NULL, NULL, 9711, 9),
(259711, NULL, 'PF00181', NULL, NULL, 'Ribosomal Proteins L2, RNA binding domain', NULL, 'Ribosomal_L2', NULL, NULL, 16796, 9),
(259712, NULL, 'PF07176', NULL, NULL, 'Alpha/beta hydrolase of unknown function (DUF1400)', NULL, 'DUF1400', NULL, NULL, 10845, 9),
(259713, NULL, 'PF13399', NULL, NULL, 'LytR cell envelope-related transcriptional attenuator', NULL, 'LytR_C', NULL, NULL, 24510, 9),
(259714, NULL, 'PF14331', NULL, NULL, 'IcmF-related N-terminal domain', NULL, 'IcmF-related_N', NULL, NULL, 22254, 9),
(259715, NULL, 'PF06445', NULL, NULL, 'GyrI-like small molecule binding domain', NULL, 'GyrI-like', NULL, NULL, 25722, 9),
(259716, NULL, 'PF19970', NULL, NULL, 'vWA-MoxR associated protein middle region (VMAP-M) 9', NULL, 'VMAP-M9', NULL, NULL, 35896, 9),
(259717, NULL, 'PF14694', NULL, NULL, 'Lines N-terminus', NULL, 'LINES_N', NULL, NULL, 22221, 9),
(259718, NULL, 'PF11699', NULL, NULL, 'Mif2/CENP-C like', NULL, 'CENP-C_C', NULL, NULL, 22065, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(259719, NULL, 'PF02274', NULL, NULL, 'Arginine deiminase', NULL, 'ADI', NULL, NULL, NULL, 9),
(259720, NULL, 'PF13617', NULL, NULL, 'YnbE-like lipoprotein', NULL, 'Lipoprotein_19', NULL, NULL, 23300, 9),
(259721, NULL, 'PF19964', NULL, NULL, 'Effector-associated domain 11', NULL, 'EAD11', NULL, NULL, 37013, 9),
(259722, NULL, 'PF19414', NULL, NULL, 'Astrovirus p19 protein', NULL, 'Astro_p19', NULL, NULL, 36190, 9),
(259723, NULL, 'PF02958', NULL, NULL, 'Ecdysteroid kinase-like family', NULL, 'EcKL', NULL, NULL, 1902, 9),
(259724, NULL, 'PF02475', NULL, NULL, 'Met-10+ like-protein', NULL, 'Met_10', NULL, NULL, 21609, 9),
(259725, NULL, 'PF11106', NULL, NULL, 'Exopolysaccharide production protein YjbE', NULL, 'YjbE', NULL, NULL, 25638, 9),
(259726, NULL, 'PF09677', NULL, NULL, 'Type-F conjugative transfer system protein (TrbI_Ftype)', NULL, 'TrbI_Ftype', NULL, NULL, 13759, 9),
(259727, NULL, 'PF01812', NULL, NULL, '5-formyltetrahydrofolate cyclo-ligase family', NULL, '5-FTHF_cyc-lig', NULL, NULL, 3771, 9),
(259728, NULL, 'PF10791', NULL, NULL, 'Mitochondrial F1-F0 ATP synthase subunit F of fungi', NULL, 'F1F0-ATPsyn_F', NULL, NULL, 20520, 9),
(259729, NULL, 'PF16346', NULL, NULL, 'Domain of unknown function (DUF4975)', NULL, 'DUF4975', NULL, NULL, 21960, 9),
(259730, NULL, 'PF11002', NULL, NULL, 'RFPL defining motif (RDM)', NULL, 'RDM', NULL, NULL, 16864, 9),
(259731, NULL, 'PF12912', NULL, NULL, 'NLPC_P60 stabilising domain, N term', NULL, 'N_NLPC_P60', NULL, NULL, 23242, 9),
(259732, NULL, 'PF00088', NULL, NULL, 'Trefoil (P-type) domain', NULL, 'Trefoil', NULL, NULL, 5964, 9),
(259733, NULL, 'PF04316', NULL, NULL, 'Anti-sigma-28 factor, FlgM', NULL, 'FlgM', NULL, NULL, 23641, 9),
(259734, NULL, 'PF18825', NULL, NULL, 'Large polyvalent protein-associated domain 13', NULL, 'LPD13', NULL, NULL, 32521, 9),
(259735, NULL, 'PF19976', NULL, NULL, 'GTPase-associated adaptor domain', NULL, 'GAAD', NULL, NULL, 37065, 9),
(259736, NULL, 'PF07520', NULL, NULL, 'Virulence factor SrfB', NULL, 'SrfB', NULL, NULL, 10177, 9),
(259737, NULL, 'PF12663', NULL, NULL, 'Protein of unknown function (DUF3788)', NULL, 'DUF3788', NULL, NULL, 20227, 9),
(259738, NULL, 'PF15839', NULL, NULL, 'Testis-expressed sequence 29 protein', NULL, 'TEX29', NULL, NULL, 25535, 9),
(259739, NULL, 'PF14050', NULL, NULL, 'N-terminal conserved domain of Nudc.', NULL, 'Nudc_N', NULL, NULL, 23088, 9),
(259740, NULL, 'PF16663', NULL, NULL, 'Unstructured region on MAGI', NULL, 'MAGI_u1', NULL, NULL, NULL, 9),
(259741, NULL, 'PF18798', NULL, NULL, 'Large polyvalent protein-associated domain 3', NULL, 'LPD3', NULL, NULL, 32048, 9),
(259742, NULL, 'PF14389', NULL, NULL, 'Leucine-zipper of ternary complex factor MIP1', NULL, 'Lzipper-MIP1', NULL, NULL, 22277, 9),
(259743, NULL, 'PF07829', NULL, NULL, 'Alpha-A conotoxin PIVA-like protein', NULL, 'Toxin_14', NULL, NULL, 12783, 9),
(259744, NULL, 'PF11516', NULL, NULL, 'Protein of unknown function (DUF3120)', NULL, 'DUF3220', NULL, NULL, 18624, 9),
(259745, NULL, 'PF09477', NULL, NULL, 'Bacterial type II secretion system chaperone protein (type_III_yscG)', NULL, 'Type_III_YscG', NULL, NULL, 18889, 9),
(259746, NULL, 'PF12105', NULL, NULL, 'SpoU, rRNA methylase, C-terminal', NULL, 'SpoU_methylas_C', NULL, NULL, 14724, 9),
(259747, NULL, 'PF16077', NULL, NULL, 'Spaetzle', NULL, 'Spaetzle', NULL, NULL, 24271, 9),
(259748, NULL, 'PF14181', NULL, NULL, 'YqfQ-like protein', NULL, 'YqfQ', NULL, NULL, 24023, 9),
(259749, NULL, 'PF03467', NULL, NULL, 'Smg-4/UPF3 family', NULL, 'Smg4_UPF3', NULL, NULL, 10940, 9),
(259750, NULL, 'PF10441', NULL, NULL, 'Urb2/Npa2 family', NULL, 'Urb2', NULL, NULL, 20155, 9),
(259751, NULL, 'PF02747', NULL, NULL, 'Proliferating cell nuclear antigen, C-terminal domain', NULL, 'PCNA_C', NULL, NULL, 17407, 9),
(259752, NULL, 'PF07695', NULL, NULL, '7TM diverse intracellular signalling', NULL, '7TMR-DISM_7TM', NULL, NULL, 9876, 9),
(259753, NULL, 'PF12501', NULL, NULL, 'Phosphate ATP-binding cassette transporter', NULL, 'DUF3708', NULL, NULL, 21466, 9),
(259754, NULL, 'PF03119', NULL, NULL, 'NAD-dependent DNA ligase C4 zinc finger domain', NULL, 'DNA_ligase_ZBD', NULL, NULL, 2838, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(259755, NULL, 'PF13334', NULL, NULL, 'Domain of unknown function (DUF4094)', NULL, 'DUF4094', NULL, NULL, 25663, 9),
(259756, NULL, 'PF17502', NULL, NULL, 'Family of unknown function (DUF5434)', NULL, 'DUF5434', NULL, NULL, 32149, 9),
(259757, NULL, 'PF04159', NULL, NULL, 'NB glycoprotein', NULL, 'NB', NULL, NULL, 7187, 9),
(259758, NULL, 'PF12830', NULL, NULL, 'Sister chromatid cohesion C-terminus', NULL, 'Nipped-B_C', NULL, NULL, 22968, 9),
(259759, NULL, 'PF05378', NULL, NULL, 'Hydantoinase/oxoprolinase N-terminal region', NULL, 'Hydant_A_N', NULL, NULL, 5354, 9),
(259760, NULL, 'PF07555', NULL, NULL, 'beta-N-acetylglucosaminidase', NULL, 'NAGidase', NULL, NULL, 12522, 9),
(259761, NULL, 'PF03768', NULL, NULL, 'Attacin, N-terminal region', NULL, 'Attacin_N', NULL, NULL, 1614, 9),
(259762, NULL, 'PF18400', NULL, NULL, 'Thioredoxin-like domain', NULL, 'Thioredoxin_12', NULL, NULL, 28662, 9),
(259763, NULL, 'PF18633', NULL, NULL, 'Zinc-finger antiviral protein (ZAP) zinc finger domain 3', NULL, 'zf-CCCH_8', NULL, NULL, 28748, 9),
(259764, NULL, 'PF18756', NULL, NULL, 'Nucleotide modification associated domain 4', NULL, 'Nmad4', NULL, NULL, 31638, 9),
(259765, NULL, 'PF01611', NULL, NULL, 'Filovirus glycoprotein', NULL, 'Filo_glycop', NULL, NULL, 1752, 9),
(259766, NULL, 'PF18928', NULL, NULL, 'Family of unknown function (DUF5677)', NULL, 'DUF5677', NULL, NULL, 35833, 9),
(259767, NULL, 'PF07415', NULL, NULL, 'Gammaherpesvirus latent membrane protein (LMP2) protein', NULL, 'Herpes_LMP2', NULL, NULL, 11990, 9),
(259768, NULL, 'PF11901', NULL, NULL, 'Protein of unknown function (DUF3421)', NULL, 'DUF3421', NULL, NULL, 1482, 9),
(259769, NULL, 'PF19627', NULL, NULL, 'Activity-dependent neuroprotector homeobox protein N-terminal', NULL, 'ADNP_N', NULL, NULL, 34476, 9),
(259770, NULL, 'PF15377', NULL, NULL, 'Domain of unknown function (DUF4604)', NULL, 'DUF4604', NULL, NULL, 23092, 9),
(259771, NULL, 'PF00626', NULL, NULL, 'Gelsolin repeat', NULL, 'Gelsolin', NULL, NULL, 81, 9),
(259772, NULL, 'PF03300', NULL, NULL, 'Tenuivirus non-structural, movement protein NS4', NULL, 'Tenui_NS4', NULL, NULL, 781, 9),
(259773, NULL, 'PF17246', NULL, NULL, 'Cell division control protein 24, OB domain 1', NULL, 'CDC24_OB1', NULL, NULL, 8567, 9),
(259774, NULL, 'PF18208', NULL, NULL, 'Nicking enzyme C-terminal middle helical domain', NULL, 'NES_C_h', NULL, NULL, 32137, 9),
(259775, NULL, 'PF04408', NULL, NULL, 'Helicase associated domain (HA2)', NULL, 'HA2', NULL, NULL, 10395, 9),
(259776, NULL, 'PF06347', NULL, NULL, 'Bacterial SH3 domain', NULL, 'SH3_4', NULL, NULL, 10423, 9),
(259777, NULL, 'PF13196', NULL, NULL, 'Protein of unknown function (DUF4012)', NULL, 'DUF4012', NULL, NULL, 22170, 9),
(259778, NULL, 'PF04455', NULL, NULL, 'LOR/SDH bifunctional enzyme conserved region', NULL, 'Saccharop_dh_N', NULL, NULL, 3663, 9),
(259779, NULL, 'PF16729', NULL, NULL, 'Domain of unknown function (DUF5067)', NULL, 'DUF5067', NULL, NULL, 22578, 9),
(259780, NULL, 'PF08383', NULL, NULL, 'Maf N-terminal region', NULL, 'Maf_N', NULL, NULL, 11502, 9),
(259781, NULL, 'PF15731', NULL, NULL, 'Antitoxin component of bacterial toxin-antitoxin system, MqsA', NULL, 'MqsA_antitoxin', NULL, NULL, 22142, 9),
(259782, NULL, 'PF18345', NULL, NULL, 'Zinc finger domain', NULL, 'zf_CCCH_4', NULL, NULL, NULL, 9),
(259783, NULL, 'PF18856', NULL, NULL, 'Bacterial archaeo-eukaryotic release factor family 12', NULL, 'baeRF_family12', NULL, NULL, 29259, 9),
(259784, NULL, 'PF09445', NULL, NULL, 'RNA cap guanine-N2 methyltransferase', NULL, 'Methyltransf_15', NULL, NULL, 15651, 9),
(259785, NULL, 'PF08758', NULL, NULL, 'Cadherin prodomain like', NULL, 'Cadherin_pro', NULL, NULL, 13169, 9),
(259786, NULL, 'PF00654', NULL, NULL, 'Voltage gated chloride channel', NULL, 'Voltage_CLC', NULL, NULL, 4090, 9),
(259787, NULL, 'PF12650', NULL, NULL, 'Domain of unknown function (DUF3784)', NULL, 'DUF3784', NULL, NULL, 16000, 9),
(259788, NULL, 'PF14317', NULL, NULL, 'YcxB-like protein', NULL, 'YcxB', NULL, NULL, 22756, 9),
(259789, NULL, 'PF18431', NULL, NULL, 'Bacterial CdiA-CT RNAse A domain', NULL, 'RNAse_A_bac', NULL, NULL, 30852, 9); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(259790, NULL, 'PF17098', NULL, NULL, 'WTAP/Mum2p family', NULL, 'Wtap', NULL, NULL, 33927, 9),
(259791, NULL, 'PF14674', NULL, NULL, 'FANCI solenoid 1 cap', NULL, 'FANCI_S1-cap', NULL, NULL, 26689, 9),
(259792, NULL, 'PF16796', NULL, NULL, 'Microtubule binding', NULL, 'Microtub_bd', NULL, NULL, 24369, 9),
(259793, NULL, 'PF10682', NULL, NULL, 'Glycoprotein of human cytomegalovirus HHV-5', NULL, 'UL40', NULL, NULL, 20644, 9),
(259794, NULL, 'PF08163', NULL, NULL, 'DNA-dependent protein kinase catalytic subunit, CC3', NULL, 'DNAPKcs_CC3', NULL, NULL, 9246, 9),
(259795, NULL, 'PF09040', NULL, NULL, 'Gastric H+/K+-ATPase, N terminal domain', NULL, 'H-K_ATPase_N', NULL, NULL, 9647, 9),
(259796, NULL, 'PF15174', NULL, NULL, 'Prion-related protein testis-specific', NULL, 'PRNT', NULL, NULL, 21970, 9),
(259797, NULL, 'PF00908', NULL, NULL, 'dTDP-4-dehydrorhamnose 3,5-epimerase', NULL, 'dTDP_sugar_isom', NULL, NULL, 353, 9),
(259798, NULL, 'PF15459', NULL, NULL, '60S ribosome biogenesis protein Rrp14', NULL, 'RRP14', NULL, NULL, 26813, 9),
(259799, NULL, 'PF17953', NULL, NULL, 'CRISPR Csm4 C-terminal domain', NULL, 'Csm4_C', NULL, NULL, 29330, 9),
(259800, NULL, 'PF05695', NULL, NULL, 'Plant protein of unknown function (DUF825)', NULL, 'DUF825', NULL, NULL, 13173, 9),
(259801, NULL, 'PF11013', NULL, NULL, 'Protein of unknown function (DUF2851)', NULL, 'DUF2851', NULL, NULL, 17955, 9),
(259802, NULL, 'PF12749', NULL, NULL, 'Eukaryotic metallothionein', NULL, 'Metallothio_Euk', NULL, NULL, NULL, 9),
(259803, NULL, 'PF03536', NULL, NULL, 'Salmonella virulence-associated 28kDa protein', NULL, 'VRP3', NULL, NULL, 6020, 9),
(259804, NULL, 'PF01510', NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase', NULL, 'Amidase_2', NULL, NULL, 994, 9),
(259805, NULL, 'PF11363', NULL, NULL, 'Protein of unknown function (DUF3164)', NULL, 'DUF3164', NULL, NULL, 18924, 9),
(259806, NULL, 'PF11665', NULL, NULL, 'Protein of unknown function (DUF3265)', NULL, 'DUF3265', NULL, NULL, 19412, 9),
(259807, NULL, 'PF01022', NULL, NULL, 'Bacterial regulatory protein, arsR family', NULL, 'HTH_5', NULL, NULL, 4484, 9),
(259808, NULL, 'PF18878', NULL, NULL, 'PPE-PPW subfamily C-terminal region', NULL, 'PPE-PPW', NULL, NULL, 35791, 9),
(259809, NULL, 'PF13178', NULL, NULL, 'Protein of unknown function (DUF4005)', NULL, 'DUF4005', NULL, NULL, 22812, 9),
(259810, NULL, 'PF11511', NULL, NULL, 'Intrinsic membrane protein PufX', NULL, 'RhodobacterPufX', NULL, NULL, 13766, 9),
(259811, NULL, 'PF06594', NULL, NULL, 'Haemolysin-type calcium binding protein related domain', NULL, 'HCBP_related', NULL, NULL, 8324, 9),
(259812, NULL, 'PF04961', NULL, NULL, 'Formiminotransferase-cyclodeaminase', NULL, 'FTCD_C', NULL, NULL, 6875, 9),
(259813, NULL, 'PF09469', NULL, NULL, 'Cordon-bleu ubiquitin-like domain', NULL, 'Cobl', NULL, NULL, 15795, 9),
(259814, NULL, 'PF11912', NULL, NULL, 'Counting factor-associated protein A/B/C', NULL, 'CfaA_B_C', NULL, NULL, 19980, 9),
(259815, NULL, 'PF13009', NULL, NULL, 'Putative integrase', NULL, 'Integrase_2', NULL, NULL, 19419, 9),
(259816, NULL, 'PF07055', NULL, NULL, 'Enoyl reductase FAD binding domain', NULL, 'Eno-Rase_FAD_bd', NULL, NULL, 25966, 9),
(259817, NULL, 'PF17736', NULL, NULL, 'C17orf99 Ig domain', NULL, 'Ig_C17orf99', NULL, NULL, 33298, 9),
(259818, NULL, 'PF17249', NULL, NULL, 'Family of unknown function (DUF5318)', NULL, 'DUF5318', NULL, NULL, 18613, 9),
(259819, NULL, 'PF07173', NULL, NULL, 'Glycine-rich domain-containing protein-like', NULL, 'GRDP-like', NULL, NULL, 13439, 9),
(259820, NULL, 'PF07256', NULL, NULL, 'Protein of unknown function (DUF1435)', NULL, 'DUF1435', NULL, NULL, 14112, 9),
(259821, NULL, 'PF17992', NULL, NULL, 'Agarase CBM like domain', NULL, 'Agarase_CBM', NULL, NULL, 28344, 9),
(259822, NULL, 'PF05345', NULL, NULL, 'Putative Ig domain', NULL, 'He_PIG', NULL, NULL, NULL, 9),
(259823, NULL, 'PF17819', NULL, NULL, 'Family of unknown function (DUF5582)', NULL, 'DUF5582', NULL, NULL, 28813, 9),
(259824, NULL, 'PF14520', NULL, NULL, 'Helix-hairpin-helix domain', NULL, 'HHH_5', NULL, NULL, NULL, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(259825, NULL, 'PF19455', NULL, NULL, 'Family of unknown function (DUF5993)', NULL, 'DUF5993', NULL, NULL, 36601, 9),
(259826, NULL, 'PF17250', NULL, NULL, 'NADH-ubiquinone oxidoreductase 11 kDa subunit', NULL, 'NDUFB11', NULL, NULL, 8703, 9),
(259827, NULL, 'PF16658', NULL, NULL, 'Class II release factor RF3, C-terminal domain', NULL, 'RF3_C', NULL, NULL, 23927, 9),
(259828, NULL, 'PF11614', NULL, NULL, 'IG-like fold at C-terminal of FixG, putative oxidoreductase', NULL, 'FixG_C', NULL, NULL, 22844, 9),
(259829, NULL, 'PF00706', NULL, NULL, 'Anenome neurotoxin', NULL, 'Toxin_4', NULL, NULL, NULL, 9),
(259830, NULL, 'PF00648', NULL, NULL, 'Calpain family cysteine protease', NULL, 'Peptidase_C2', NULL, NULL, 2051, 9),
(259831, NULL, 'PF12877', NULL, NULL, 'Domain of unknown function (DUF3827)', NULL, 'DUF3827', NULL, NULL, 26764, 9),
(259832, NULL, 'PF20041', NULL, NULL, 'Domain of unknown function (DUF6443)', NULL, 'DUF6443', NULL, NULL, 34003, 9),
(259833, NULL, 'PF05763', NULL, NULL, 'Protein of unknown function (DUF835)', NULL, 'DUF835', NULL, NULL, 13349, 9),
(259834, NULL, 'PF17771', NULL, NULL, 'ADAMTS cysteine-rich domain 2', NULL, 'ADAMTS_CR_2', NULL, NULL, 29975, 9),
(259835, NULL, 'PF10092', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2330)', NULL, 'DUF2330', NULL, NULL, 19590, 9),
(259836, NULL, 'PF16470', NULL, NULL, 'Peptidase S8 pro-domain', NULL, 'S8_pro-domain', NULL, NULL, 21542, 9),
(259837, NULL, 'PF05213', NULL, NULL, 'Coronavirus NS2A protein', NULL, 'Corona_NS2A', NULL, NULL, 27107, 9),
(259838, NULL, 'PF09930', NULL, NULL, 'Predicted transporter (DUF2162)', NULL, 'DUF2162', NULL, NULL, 14510, 9),
(259839, NULL, 'PF11167', NULL, NULL, 'Protein of unknown function (DUF2953)', NULL, 'DUF2953', NULL, NULL, 18305, 9),
(259840, NULL, 'PF10975', NULL, NULL, 'Protein of unknown function (DUF2802)', NULL, 'DUF2802', NULL, NULL, 17694, 9),
(259841, NULL, 'PF11833', NULL, NULL, 'Protein CHAPERONE-LIKE PROTEIN OF POR1-like', NULL, 'CPP1-like', NULL, NULL, 19073, 9),
(259842, NULL, 'PF08113', NULL, NULL, 'Cytochrome c oxidase subunit IIa family', NULL, 'CoxIIa', NULL, NULL, 8646, 9),
(259843, NULL, 'PF08402', NULL, NULL, 'TOBE domain', NULL, 'TOBE_2', NULL, NULL, 11394, 9),
(259844, NULL, 'PF14322', NULL, NULL, 'Starch-binding associating with outer membrane', NULL, 'SusD-like_3', NULL, NULL, 18391, 9),
(259845, NULL, 'PF17547', NULL, NULL, 'Family of unknown function (DUF5462)', NULL, 'DUF5462', NULL, NULL, 20351, 9),
(259846, NULL, 'PF05217', NULL, NULL, 'STOP protein', NULL, 'STOP', NULL, NULL, NULL, 9),
(259847, NULL, 'PF11725', NULL, NULL, 'AvrE-family Type-III effector proteins (T3Es)', NULL, 'AvrE_T3Es', NULL, NULL, 16932, 9),
(259848, NULL, 'PF19984', NULL, NULL, 'Family of unknown function (DUF6420)', NULL, 'DUF6420', NULL, NULL, 37526, 9),
(259849, NULL, 'PF07508', NULL, NULL, 'Recombinase', NULL, 'Recombinase', NULL, NULL, 11082, 9),
(259850, NULL, 'PF00642', NULL, NULL, 'Zinc finger C-x8-C-x5-C-x3-H type (and similar)', NULL, 'zf-CCCH', NULL, NULL, 5631, 9),
(259851, NULL, 'PF01140', NULL, NULL, 'Matrix protein (MA), p15', NULL, 'Gag_MA', NULL, NULL, 4740, 9),
(259852, NULL, 'PF13065', NULL, NULL, 'Protein of unknown function (DUF3928)', NULL, 'DUF3928', NULL, NULL, 21067, 9),
(259853, NULL, 'PF09789', NULL, NULL, 'Coiled-coil domain-containing protein 149-A', NULL, 'CC149', NULL, NULL, 18229, 9),
(259854, NULL, 'PF16497', NULL, NULL, 'MHC-I family domain', NULL, 'MHC_I_3', NULL, NULL, 12526, 9),
(259855, NULL, 'PF05395', NULL, NULL, 'Protein phosphatase inhibitor 1/DARPP-32', NULL, 'DARPP-32', NULL, NULL, 12053, 9),
(259856, NULL, 'PF01475', NULL, NULL, 'Ferric uptake regulator family', NULL, 'FUR', NULL, NULL, 550, 9),
(259857, NULL, 'PF18726', NULL, NULL, 'SAV_6107-like HEPN', NULL, 'HEPN_SAV_6107', NULL, NULL, 32266, 9),
(259858, NULL, 'PF10552', NULL, NULL, 'ORF6C domain', NULL, 'ORF6C', NULL, NULL, 20725, 9),
(259859, NULL, 'PF19170', NULL, NULL, 'Family of unknown function (DUF5852)', NULL, 'DUF5852', NULL, NULL, 34431, 9),
(259860, NULL, 'PF20333', NULL, NULL, 'Family of unknown function (DUF6628)', NULL, 'DUF6628', NULL, NULL, 37141, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(259861, NULL, 'PF08033', NULL, NULL, 'Sec23/Sec24 beta-sandwich domain', NULL, 'Sec23_BS', NULL, NULL, 12268, 9),
(259862, NULL, 'PF09058', NULL, NULL, 'L27_1', NULL, 'L27_1', NULL, NULL, 9626, 9),
(259863, NULL, 'PF19429', NULL, NULL, 'Evasins Class A', NULL, 'EVA_Class_A', NULL, NULL, 37060, 9),
(259864, NULL, 'PF13307', NULL, NULL, 'Helicase C-terminal domain', NULL, 'Helicase_C_2', NULL, NULL, 195, 9),
(259865, NULL, 'PF03874', NULL, NULL, 'RNA polymerase Rpb4', NULL, 'RNA_pol_Rpb4', NULL, NULL, 1722, 9),
(259866, NULL, 'PF14692', NULL, NULL, 'Domain of unknown function (DUF4462)', NULL, 'DUF4462', NULL, NULL, 23682, 9),
(259867, NULL, 'PF07473', NULL, NULL, 'Spasmodic peptide gm9a; conotoxin from Conus species', NULL, 'Toxin_11', NULL, NULL, 8600, 9),
(259868, NULL, 'PF04085', NULL, NULL, 'rod shape-determining protein MreC', NULL, 'MreC', NULL, NULL, 6189, 9),
(259869, NULL, 'PF10777', NULL, NULL, 'Inner membrane protein YlaC', NULL, 'YlaC', NULL, NULL, 20838, 9),
(259870, NULL, 'PF01076', NULL, NULL, 'Plasmid recombination enzyme', NULL, 'Mob_Pre', NULL, NULL, 3048, 9),
(259871, NULL, 'PF14775', NULL, NULL, 'Sperm tail C-terminal domain', NULL, 'NYD-SP28_assoc', NULL, NULL, 26657, 9),
(259872, NULL, 'PF17975', NULL, NULL, 'Ribonucleotide reductase alpha domain', NULL, 'RNR_Alpha', NULL, NULL, 28933, 9),
(259873, NULL, 'PF15982', NULL, NULL, 'N-terminal cysteine-rich region of Transmembrane protein 135', NULL, 'TMEM135_C_rich', NULL, NULL, 25795, 9),
(259874, NULL, 'PF15526', NULL, NULL, 'Novel toxin 21', NULL, 'Ntox21', NULL, NULL, 21846, 9),
(259875, NULL, 'PF11433', NULL, NULL, 'Protein of unknown function (DUF3198)', NULL, 'DUF3198', NULL, NULL, 24025, 9),
(259876, NULL, 'PF15632', NULL, NULL, 'ATP-grasp in the biosynthetic pathway with Ter operon', NULL, 'ATPgrasp_Ter', NULL, NULL, NULL, 9),
(259877, NULL, 'PF17756', NULL, NULL, 'RET Cadherin like domain 1', NULL, 'RET_CLD1', NULL, NULL, 28548, 9),
(259878, NULL, 'PF11772', NULL, NULL, 'DNA-directed RNA polymerase subunit beta', NULL, 'EpuA', NULL, NULL, 22140, 9),
(259879, NULL, 'PF04451', NULL, NULL, 'Large eukaryotic DNA virus major capsid protein', NULL, 'Capsid_NCLDV', NULL, NULL, 10791, 9),
(259880, NULL, 'PF15441', NULL, NULL, 'RhoGEF 5/35 N-terminal disordered region', NULL, 'ARHGEF5_35', NULL, NULL, 26946, 9),
(259881, NULL, 'PF06251', NULL, NULL, 'Capsule biosynthesis GfcC C-terminal', NULL, 'Caps_syn_GfcC_C', NULL, NULL, 9491, 9),
(259882, NULL, 'PF01152', NULL, NULL, 'Bacterial-like globin', NULL, 'Bac_globin', NULL, NULL, 6363, 9),
(259883, NULL, 'PF08619', NULL, NULL, 'Alkali metal cation/H+ antiporter Nha1 C terminus', NULL, 'Nha1_C', NULL, NULL, 14049, 9),
(259884, NULL, 'PF17429', NULL, NULL, 'Gene product 70', NULL, 'GP70', NULL, NULL, 28932, 9),
(259885, NULL, 'PF00951', NULL, NULL, 'Arterivirus GL envelope glycoprotein', NULL, 'Arteri_Gl', NULL, NULL, 499, 9),
(259886, NULL, 'PF04365', NULL, NULL, 'Ribonuclease toxin, BrnT, of type II toxin-antitoxin system', NULL, 'BrnT_toxin', NULL, NULL, 4902, 9),
(259887, NULL, 'PF12813', NULL, NULL, 'XPG domain containing', NULL, 'XPG_I_2', NULL, NULL, 33410, 9),
(259888, NULL, 'PF06819', NULL, NULL, 'Archaeal Peptidase A24 C-terminal Domain', NULL, 'Arc_PepC', NULL, NULL, 10741, 9),
(259889, NULL, 'PF03810', NULL, NULL, 'Importin-beta N-terminal domain', NULL, 'IBN_N', NULL, NULL, 3367, 9),
(259890, NULL, 'PF11501', NULL, NULL, 'Betacoronavirus replicase NSP1', NULL, 'bCoV_NSP1', NULL, NULL, 18777, 9),
(259891, NULL, 'PF05946', NULL, NULL, 'Toxin-coregulated pilus subunit TcpA', NULL, 'TcpA', NULL, NULL, 7708, 9),
(259892, NULL, 'PF08069', NULL, NULL, 'Ribosomal S13/S15 N-terminal domain', NULL, 'Ribosomal_S13_N', NULL, NULL, 9756, 9),
(259893, NULL, 'PF11808', NULL, NULL, 'Phosphate regulon sensor protein PhoR', NULL, 'PhoR', NULL, NULL, 19396, 9),
(259894, NULL, 'PF20496', NULL, NULL, 'Double strand break localizing Dbl7', NULL, 'Dbl7', NULL, NULL, 33799, 9),
(259895, NULL, 'PF03130', NULL, NULL, 'PBS lyase HEAT-like repeat', NULL, 'HEAT_PBS', NULL, NULL, 2502, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(259896, NULL, 'PF18712', NULL, NULL, 'Family of unknown function (DUF5644)', NULL, 'DUF5644', NULL, NULL, 29539, 9),
(259897, NULL, 'PF12512', NULL, NULL, 'Protein of unknown function (DUF3717)', NULL, 'DUF3717', NULL, NULL, 21230, 9),
(259898, NULL, 'PF17560', NULL, NULL, 'Aphid Megourins', NULL, 'Megourin', NULL, NULL, 21220, 9),
(259899, NULL, 'PF06671', NULL, NULL, 'Repeat of unknown function (DUF1174)', NULL, 'DUF1174', NULL, NULL, 10259, 9),
(259900, NULL, 'PF04236', NULL, NULL, 'Tc5 transposase C-terminal domain', NULL, 'Transp_Tc5_C', NULL, NULL, 5900, 9),
(259901, NULL, 'PF06547', NULL, NULL, 'Protein of unknown function (DUF1117)', NULL, 'DUF1117', NULL, NULL, 14493, 9),
(259902, NULL, 'PF09972', NULL, NULL, 'Predicted membrane protein (DUF2207)', NULL, 'DUF2207', NULL, NULL, 17146, 9),
(259903, NULL, 'PF10404', NULL, NULL, 'Rad4 beta-hairpin domain 2', NULL, 'BHD_2', NULL, NULL, 17506, 9),
(259904, NULL, 'PF02557', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase', NULL, 'VanY', NULL, NULL, 2195, 9),
(259905, NULL, 'PF04955', NULL, NULL, 'HupE / UreJ protein', NULL, 'HupE_UreJ', NULL, NULL, 6643, 9),
(259906, NULL, 'PF20094', NULL, NULL, 'GWxTD domain', NULL, 'GWxTD_dom', NULL, NULL, 25215, 9),
(259907, NULL, 'PF08386', NULL, NULL, 'TAP-like protein', NULL, 'Abhydrolase_4', NULL, NULL, 11618, 9),
(259908, NULL, 'PF01586', NULL, NULL, 'Myogenic Basic domain', NULL, 'Basic', NULL, NULL, 1985, 9),
(259909, NULL, 'PF10790', NULL, NULL, 'Protein of Unknown function (DUF2604)', NULL, 'DUF2604', NULL, NULL, 20833, 9),
(259910, NULL, 'PF11796', NULL, NULL, 'Protein of unknown function N-terminus (DUF3323)', NULL, 'DUF3323', NULL, NULL, 21585, 9),
(259911, NULL, 'PF14213', NULL, NULL, 'STAS-like domain of unknown function (DUF4325)', NULL, 'DUF4325', NULL, NULL, 26451, 9),
(259912, NULL, 'PF20342', NULL, NULL, 'Family of unknown function (DUF6637)', NULL, 'DUF6637', NULL, NULL, 33826, 9),
(259913, NULL, 'PF06357', NULL, NULL, 'Omega-atracotoxin', NULL, 'Omega-toxin', NULL, NULL, 8314, 9),
(259914, NULL, 'PF14413', NULL, NULL, 'Thg1 C terminal domain', NULL, 'Thg1C', NULL, NULL, 24013, 9),
(259915, NULL, 'PF16654', NULL, NULL, 'Diaminopimelic acid dehydrogenase C-terminal domain', NULL, 'DAPDH_C', NULL, NULL, 22830, 9),
(259916, NULL, 'PF14246', NULL, NULL, 'AefR-like transcriptional repressor, C-terminal domain', NULL, 'TetR_C_7', NULL, NULL, 27496, 9),
(259917, NULL, 'PF10399', NULL, NULL, 'Ubiquitinol-cytochrome C reductase Fe-S subunit TAT signal', NULL, 'UCR_Fe-S_N', NULL, NULL, 17352, 9),
(259918, NULL, 'PF08269', NULL, NULL, 'Cache domain', NULL, 'dCache_2', NULL, NULL, 719, 9),
(259919, NULL, 'PF16265', NULL, NULL, 'Domain of unknown function (DUF4918)', NULL, 'DUF4918', NULL, NULL, 21536, 9),
(259920, NULL, 'PF13892', NULL, NULL, 'DNA-binding domain', NULL, 'DBINO', NULL, NULL, 20699, 9),
(259921, NULL, 'PF11023', NULL, NULL, 'Zinc-ribbon containing domain', NULL, 'DUF2614', NULL, NULL, 14664, 9),
(259922, NULL, 'PF11311', NULL, NULL, 'Protein of unknown function (DUF3114)', NULL, 'DUF3114', NULL, NULL, 18255, 9),
(259923, NULL, 'PF00878', NULL, NULL, 'Cation-independent mannose-6-phosphate receptor repeat', NULL, 'CIMR', NULL, NULL, 5988, 9),
(259924, NULL, 'PF02998', NULL, NULL, 'Lentiviral Tat protein', NULL, 'Lentiviral_Tat', NULL, NULL, 3864, 9),
(259925, NULL, 'PF11673', NULL, NULL, 'Protein of unknown function (DUF3269)', NULL, 'DUF3269', NULL, NULL, 19169, 9),
(259926, NULL, 'PF00845', NULL, NULL, 'Geminivirus BL1 movement protein', NULL, 'Gemini_BL1', NULL, NULL, 3746, 9),
(259927, NULL, 'PF07868', NULL, NULL, 'Protein of unknown function (DUF1655)', NULL, 'DUF1655', NULL, NULL, 14073, 9),
(259928, NULL, 'PF17272', NULL, NULL, 'Family of unknown function (DUF5337)', NULL, 'DUF5337', NULL, NULL, 20254, 9),
(259929, NULL, 'PF15613', NULL, NULL, 'Williams-Beuren syndrome DDT (WSD), D-TOX E motif', NULL, 'WSD', NULL, NULL, 24810, 9),
(259930, NULL, 'PF17742', NULL, NULL, 'Family of unknown function (DUF5579)', NULL, 'DUF5579', NULL, NULL, 2273, 9),
(259931, NULL, 'PF19354', NULL, NULL, 'Family of unknown function (DUF5931)', NULL, 'DUF5931', NULL, NULL, 36835, 9);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(259932, NULL, 'PF05691', NULL, NULL, 'Raffinose synthase or seed imbibition protein Sip1', NULL, 'Raffinose_syn', NULL, NULL, 13843, 9),
(259933, NULL, 'PF15898', NULL, NULL, 'cGMP-dependent protein kinase interacting domain', NULL, 'PRKG1_interact', NULL, NULL, 25851, 9),
(259934, NULL, 'PF08940', NULL, NULL, 'Domain of unknown function (DUF1918)', NULL, 'DUF1918', NULL, NULL, 7873, 9),
(259935, NULL, 'PF05184', NULL, NULL, 'Saposin-like type B, region 1', NULL, 'SapB_1', NULL, NULL, 3221, 9),
(259936, NULL, 'PF06351', NULL, NULL, 'Allene oxide cyclase', NULL, 'Allene_ox_cyc', NULL, NULL, 8288, 9),
(259937, NULL, 'PF18679', NULL, NULL, 'ThcOx helix turn helix domain', NULL, 'HTH_57', NULL, NULL, 28172, 9),
(259938, NULL, 'PF08784', NULL, NULL, 'Replication protein A C terminal', NULL, 'RPA_C', NULL, NULL, 13493, 9),
(259939, NULL, 'PF10417', NULL, NULL, 'C-terminal domain of 1-Cys peroxiredoxin', NULL, '1-cysPrx_C', NULL, NULL, 17361, 9),
(259940, NULL, 'PF03869', NULL, NULL, 'Arc-like DNA binding domain', NULL, 'Arc', NULL, NULL, 1916, 9),
(259941, NULL, 'PF13853', NULL, NULL, 'Olfactory receptor', NULL, '7tm_4', NULL, NULL, 6952, 9),
(259942, NULL, 'PF04420', NULL, NULL, 'CHD5-like protein', NULL, 'CHD5', NULL, NULL, 26918, 9),
(259943, NULL, 'PF15137', NULL, NULL, 'Domain of unknown function (DUF4571)', NULL, 'DUF4571', NULL, NULL, 21547, 9),
(259944, NULL, 'PF09860', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2087)', NULL, 'DUF2087', NULL, NULL, 16944, 9),
(259945, NULL, 'PF17720', NULL, NULL, 'Family of unknown function (DUF5565)', NULL, 'DUF5565', NULL, NULL, 28719, 9),
(259946, NULL, 'PF19679', NULL, NULL, 'Family of unknown function (DUF6181)', NULL, 'DUF6181', NULL, NULL, 36035, 9),
(259947, NULL, 'PF14944', NULL, NULL, 'Tongue Cancer Chemotherapy Resistant Protein 1', NULL, 'TCRP1', NULL, NULL, 26517, 9),
(259948, NULL, 'PF14862', NULL, NULL, 'Big defensin', NULL, 'Defensin_big', NULL, NULL, 25177, 9),
(259949, NULL, 'PF05709', NULL, NULL, 'Phage tail protein', NULL, 'Sipho_tail', NULL, NULL, 13577, 9),
(259950, NULL, 'PF07196', NULL, NULL, 'Flagellin hook IN motif', NULL, 'Flagellin_IN', NULL, NULL, 10923, 9),
(259951, NULL, 'PF11669', NULL, NULL, 'WW domain-binding protein 1', NULL, 'WBP-1', NULL, NULL, 19378, 9),
(259952, NULL, 'PF11972', NULL, NULL, 'HTH DNA binding domain', NULL, 'HTH_13', NULL, NULL, 15347, 9),
(259953, NULL, 'PF03960', NULL, NULL, 'ArsC family', NULL, 'ArsC', NULL, NULL, 1555, 9),
(259954, NULL, 'PF09894', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2121)', NULL, 'DUF2121', NULL, NULL, 21479, 9),
(259955, NULL, 'PF19135', NULL, NULL, 'Protein of unknown function (DUF5818)', NULL, 'DUF5818', NULL, NULL, 34178, 9),
(259956, NULL, 'PF14339', NULL, NULL, 'Domain of unknown function (DUF4394)', NULL, 'DUF4394', NULL, NULL, 26141, 9),
(259957, NULL, 'PF12892', NULL, NULL, 'Spy0128-like isopeptide containing domain', NULL, 'FctA', NULL, NULL, 15726, 9),
(259958, NULL, 'PF07686', NULL, NULL, 'Immunoglobulin V-set domain', NULL, 'V-set', NULL, NULL, 18504, 9),
(259959, NULL, 'PF06721', NULL, NULL, 'Protein of unknown function (DUF1204)', NULL, 'DUF1204', NULL, NULL, 1666, 9),
(259960, NULL, 'PF04307', NULL, NULL, 'LexA-binding, inner membrane-associated putative hydrolase', NULL, 'YdjM', NULL, NULL, 3898, 9),
(259961, NULL, 'PF04645', NULL, NULL, 'Protein of unknown function, DUF603', NULL, 'DUF603', NULL, NULL, 2554, 9),
(259962, NULL, 'PF07278', NULL, NULL, 'Protein of unknown function (DUF1441)', NULL, 'DUF1441', NULL, NULL, 14423, 9),
(259963, NULL, 'PF18461', NULL, NULL, 'Atypical caspase recruitment domain', NULL, 'Atypical_Card', NULL, NULL, 28683, 9),
(259964, NULL, 'PF08900', NULL, NULL, 'Transcriptional regulator AcaB', NULL, 'AcaB', NULL, NULL, 7705, 9),
(259965, NULL, 'PF11742', NULL, NULL, 'Protein of unknown function (DUF3302)', NULL, 'DUF3302', NULL, NULL, 10580, 9),
(259966, NULL, 'PF11942', NULL, NULL, 'Spt5 transcription elongation factor, acidic N-terminal', NULL, 'Spt5_N', NULL, NULL, 16058, 9),
(259967, NULL, 'PF00446', NULL, NULL, 'Gonadotropin-releasing hormone', NULL, 'GnRH', NULL, NULL, 2140, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(259968, NULL, 'PF04934', NULL, NULL, 'MED6 mediator sub complex component', NULL, 'Med6', NULL, NULL, 6816, 9),
(259969, NULL, 'PF12597', NULL, NULL, 'Cytochrome c oxidase assembly protein COX20', NULL, 'Cox20', NULL, NULL, 14798, 9),
(259970, NULL, 'PF01650', NULL, NULL, 'Peptidase C13 family', NULL, 'Peptidase_C13', NULL, NULL, 1162, 9),
(259971, NULL, 'PF15044', NULL, NULL, 'Mitochondrial function, CLU-N-term', NULL, 'CLU_N', NULL, NULL, 26556, 9),
(259972, NULL, 'PF14753', NULL, NULL, 'Protein FAM221A/B', NULL, 'FAM221', NULL, NULL, 24395, 9),
(259973, NULL, 'PF20379', NULL, NULL, 'Family of unknown function (DUF6674)', NULL, 'DUF6674', NULL, NULL, 37031, 9),
(259974, NULL, 'PF13469', NULL, NULL, 'Sulfotransferase family', NULL, 'Sulfotransfer_3', NULL, NULL, NULL, 9),
(259975, NULL, 'PF12580', NULL, NULL, 'Tripeptidyl peptidase II', NULL, 'TPPII', NULL, NULL, 21184, 9),
(259976, NULL, 'PF06336', NULL, NULL, 'Coronavirus 5a protein', NULL, 'Corona_5a', NULL, NULL, 8441, 9),
(259977, NULL, 'PF14247', NULL, NULL, 'Putative metallopeptidase', NULL, 'DUF4344', NULL, NULL, 24664, 9),
(259978, NULL, 'PF00122', NULL, NULL, 'E1-E2 ATPase', NULL, 'E1-E2_ATPase', NULL, NULL, NULL, 9),
(259979, NULL, 'PF11956', NULL, NULL, 'Ankyrin-G binding motif of KCNQ2-3', NULL, 'KCNQC3-Ank-G_bd', NULL, NULL, 14650, 9),
(259980, NULL, 'PF19341', NULL, NULL, 'Beta-1,3-galactosyltransferase 2 N-terminus', NULL, 'B3GALT2_N', NULL, NULL, 36436, 9),
(259981, NULL, 'PF00296', NULL, NULL, 'Luciferase-like monooxygenase', NULL, 'Bac_luciferase', NULL, NULL, 8872, 9),
(259982, NULL, 'PF01283', NULL, NULL, 'Ribosomal protein S26e', NULL, 'Ribosomal_S26e', NULL, NULL, 4610, 9),
(259983, NULL, 'PF01975', NULL, NULL, 'Survival protein SurE', NULL, 'SurE', NULL, NULL, 5037, 9),
(259984, NULL, 'PF14004', NULL, NULL, 'Protein of unknown function (DUF4227)', NULL, 'DUF4227', NULL, NULL, 22355, 9),
(259985, NULL, 'PF01105', NULL, NULL, 'emp24/gp25L/p24 family/GOLD', NULL, 'EMP24_GP25L', NULL, NULL, 7905, 9),
(259986, NULL, 'PF16595', NULL, NULL, 'PAM-interacting domain of CRISPR-associated endonuclease Cas9', NULL, 'Cas9_PI', NULL, NULL, 26751, 9),
(259987, NULL, 'PF04693', NULL, NULL, 'Archaeal putative transposase ISC1217', NULL, 'DDE_Tnp_2', NULL, NULL, 3187, 9),
(259988, NULL, 'PF09537', NULL, NULL, 'Domain of unknown function (DUF2383)', NULL, 'DUF2383', NULL, NULL, 16683, 9),
(259989, NULL, 'PF11207', NULL, NULL, 'Protein of unknown function (DUF2989)', NULL, 'DUF2989', NULL, NULL, 18444, 9),
(259990, NULL, 'PF12136', NULL, NULL, 'RNA polymerase Rpo13 subunit HTH domain', NULL, 'RNA_pol_Rpo13', NULL, NULL, 20339, 9),
(259991, NULL, 'PF07991', NULL, NULL, 'Acetohydroxy acid isomeroreductase, NADPH-binding domain', NULL, 'IlvN', NULL, NULL, 18638, 9),
(259992, NULL, 'PF00823', NULL, NULL, 'PPE family', NULL, 'PPE', NULL, NULL, 2947, 9),
(259993, NULL, 'PF02144', NULL, NULL, 'Repair protein Rad1/Rec1/Rad17', NULL, 'Rad1', NULL, NULL, 141, 9),
(259994, NULL, 'PF07903', NULL, NULL, 'PaRep2a protein', NULL, 'PaRep2a', NULL, NULL, 12582, 9),
(259995, NULL, 'PF11346', NULL, NULL, 'Protein of unknown function (DUF3149)', NULL, 'DUF3149', NULL, NULL, 18561, 9),
(259996, NULL, 'PF18552', NULL, NULL, 'PheRS DNA binding domain 1', NULL, 'PheRS_DBD1', NULL, NULL, 29384, 9),
(259997, NULL, 'PF18886', NULL, NULL, 'Repeats of unknown function (DUF5649)', NULL, 'DUF5649', NULL, NULL, 34035, 9),
(259998, NULL, 'PF18503', NULL, NULL, '26S proteasome subunit RPN6 C-terminal helix domain', NULL, 'RPN6_C_helix', NULL, NULL, 28280, 9),
(259999, NULL, 'PF04110', NULL, NULL, 'Ubiquitin-like autophagy protein Apg12', NULL, 'APG12', NULL, NULL, 7000, 9),
(260000, NULL, 'PF04439', NULL, NULL, 'Streptomycin adenylyltransferase', NULL, 'Adenyl_transf', NULL, NULL, 10566, 9),
(260001, NULL, 'PF12483', NULL, NULL, 'E3 Ubiquitin ligase', NULL, 'GIDE', NULL, NULL, 20747, 9),
(260002, NULL, 'PF07876', NULL, NULL, 'Stress responsive A/B Barrel Domain', NULL, 'Dabb', NULL, NULL, 18948, 9),
(260003, NULL, 'PF12923', NULL, NULL, 'Ribosomal RNA-processing protein 7 (RRP7) C-terminal domain', NULL, 'RRP7', NULL, NULL, 24599, 9);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(260004, NULL, 'PF03189', NULL, NULL, 'Otopetrin', NULL, 'Otopetrin', NULL, NULL, 7020, 9),
(260005, NULL, 'PF06526', NULL, NULL, 'Protein of unknown function (DUF1107)', NULL, 'DUF1107', NULL, NULL, 9337, 9),
(260006, NULL, 'PF09712', NULL, NULL, 'Poly(R)-hydroxyalkanoic acid synthase subunit (PHA_synth_III_E)', NULL, 'PHA_synth_III_E', NULL, NULL, 10950, 9),
(260007, NULL, 'PF01243', NULL, NULL, 'Pyridoxamine 5''-phosphate oxidase', NULL, 'Putative_PNPOx', NULL, NULL, 10328, 9),
(260008, NULL, 'PF05366', NULL, NULL, 'Sarcolipin', NULL, 'Sarcolipin', NULL, NULL, 5231, 9),
(260009, NULL, 'PF08101', NULL, NULL, 'Meiotically up-regulated protein Msb1/Mug8 domain', NULL, 'Msb1-Mug8_dom', NULL, NULL, 11525, 9),
(260010, NULL, 'PF00889', NULL, NULL, 'Elongation factor TS', NULL, 'EF_TS', NULL, NULL, 9129, 9),
(260011, NULL, 'PF07184', NULL, NULL, 'Citrus tristeza virus P33 protein', NULL, 'CTV_P33', NULL, NULL, 10847, 9),
(260012, NULL, 'PF15031', NULL, NULL, 'Domain of unknown function (DUF4528)', NULL, 'DUF4528', NULL, NULL, 21984, 9),
(260013, NULL, 'PF19113', NULL, NULL, 'Family of unknown function (DUF5799)', NULL, 'DUF5799', NULL, NULL, 35724, 9),
(260014, NULL, 'PF18630', NULL, NULL, 'Peptidase M60 C-terminal domain', NULL, 'Peptidase_M60_C', NULL, NULL, 30907, 9),
(260015, NULL, 'PF05098', NULL, NULL, 'Late expression factor 4 (LEF-4)', NULL, 'LEF-4', NULL, NULL, 2072, 9),
(260016, NULL, 'PF04729', NULL, NULL, 'ASF1 like histone chaperone', NULL, 'ASF1_hist_chap', NULL, NULL, 3583, 9),
(260017, NULL, 'PF06968', NULL, NULL, 'Biotin and Thiamin Synthesis associated domain', NULL, 'BATS', NULL, NULL, 9809, 9),
(260018, NULL, 'PF08647', NULL, NULL, 'BRE1 E3 ubiquitin ligase', NULL, 'BRE1', NULL, NULL, NULL, 9),
(260019, NULL, 'PF19262', NULL, NULL, 'Family of unknown function (DUF5905)', NULL, 'DUF5905', NULL, NULL, 35916, 9),
(260020, NULL, 'PF02596', NULL, NULL, 'Uncharacterised ArCR, COG2043', NULL, 'DUF169', NULL, NULL, 6476, 9),
(260021, NULL, 'PF13111', NULL, NULL, 'pPIWI_RE module N-terminal domain', NULL, 'pPIWI_RE_X', NULL, NULL, 22523, 9),
(260022, NULL, 'PF03950', NULL, NULL, 'tRNA synthetases class I (E and Q), anti-codon binding domain', NULL, 'tRNA-synt_1c_C', NULL, NULL, 16208, 9),
(260023, NULL, 'PF04075', NULL, NULL, 'F420H(2)-dependent quinone reductase', NULL, 'F420H2_quin_red', NULL, NULL, 5683, 9),
(260024, NULL, 'PF15129', NULL, NULL, 'FAM150 family', NULL, 'FAM150', NULL, NULL, 26269, 9),
(260025, NULL, 'PF03666', NULL, NULL, 'Nitrogen Permease regulator of amino acid transport activity 3', NULL, 'NPR3', NULL, NULL, 6410, 9),
(260026, NULL, 'PF17540', NULL, NULL, 'Family of unknown function (DUF5457)', NULL, 'DUF5457', NULL, NULL, 33820, 9),
(260027, NULL, 'PF13478', NULL, NULL, 'XdhC Rossmann domain', NULL, 'XdhC_C', NULL, NULL, 24756, 9),
(260028, NULL, 'PF19699', NULL, NULL, 'Calsyntenin C-terminal', NULL, 'CLSTN_C', NULL, NULL, 36395, 9),
(260029, NULL, 'PF07468', NULL, NULL, 'Agglutinin domain', NULL, 'Agglutinin', NULL, NULL, 9887, 9),
(260030, NULL, 'PF12130', NULL, NULL, 'Bivalent Mical/EHBP Rab binding domain', NULL, 'bMERB_dom', NULL, NULL, 14611, 9),
(260031, NULL, 'PF03155', NULL, NULL, 'ALG6, ALG8 glycosyltransferase family', NULL, 'Alg6_Alg8', NULL, NULL, 7099, 9),
(260032, NULL, 'PF03639', NULL, NULL, 'Glycosyl hydrolase family 81 N-terminal domain', NULL, 'Glyco_hydro_81', NULL, NULL, 27733, 9),
(260033, NULL, 'PF08082', NULL, NULL, 'PRO8NT (NUC069), PrP8 N-terminal domain', NULL, 'PRO8NT', NULL, NULL, 9013, 9),
(260034, NULL, 'PF15802', NULL, NULL, 'DDB1- and CUL4-associated factor 17', NULL, 'DCAF17', NULL, NULL, 26256, 9),
(260035, NULL, 'PF08334', NULL, NULL, 'Type II secretion system (T2SS), protein G', NULL, 'T2SSG', NULL, NULL, 12881, 9),
(260036, NULL, 'PF02801', NULL, NULL, 'Beta-ketoacyl synthase, C-terminal domain', NULL, 'Ketoacyl-synt_C', NULL, NULL, 12971, 9),
(260037, NULL, 'PF00050', NULL, NULL, 'Kazal-type serine protease inhibitor domain', NULL, 'Kazal_1', NULL, NULL, 6489, 9),
(260038, NULL, 'PF02823', NULL, NULL, 'ATP synthase, Delta/Epsilon chain, beta-sandwich domain', NULL, 'ATP-synt_DE_N', NULL, NULL, 21223, 9);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(260039, NULL, 'PF16496', NULL, NULL, 'SWIRM-associated domain at the N-terminal', NULL, 'SWIRM-assoc_2', NULL, NULL, 24440, 9),
(260040, NULL, 'PF10411', NULL, NULL, 'Disulfide bond isomerase protein N-terminus', NULL, 'DsbC_N', NULL, NULL, 14708, 9),
(260041, NULL, 'PF20474', NULL, NULL, 'PHL domain', NULL, 'PHL', NULL, NULL, 33965, 9),
(260042, NULL, 'PF10493', NULL, NULL, 'Rough deal protein C-terminal region', NULL, 'Rod_C', NULL, NULL, 19016, 9),
(260043, NULL, 'PF15084', NULL, NULL, 'Domain of unknown function (DUF4550)', NULL, 'DUF4550', NULL, NULL, 23788, 9),
(260044, NULL, 'PF17030', NULL, NULL, 'Putative beta-lactamase-like family', NULL, 'Beta_lactamase3', NULL, NULL, 22609, 9),
(260045, NULL, 'PF02408', NULL, NULL, 'CUB-like domain', NULL, 'CUB_2', NULL, NULL, 4463, 9),
(260046, NULL, 'PF06857', NULL, NULL, 'Malonate decarboxylase delta subunit (MdcD)', NULL, 'ACP', NULL, NULL, 16411, 9),
(260047, NULL, 'PF06861', NULL, NULL, 'BALF1 protein', NULL, 'BALF1', NULL, NULL, 9067, 9),
(260048, NULL, 'PF19445', NULL, NULL, 'C-terminal region of eIF3h', NULL, 'eIF3h_C', NULL, NULL, 34122, 9),
(260049, NULL, 'PF02955', NULL, NULL, 'Prokaryotic glutathione synthetase, ATP-grasp domain', NULL, 'GSH-S_ATP', NULL, NULL, 3784, 9),
(260050, NULL, 'PF10414', NULL, NULL, 'Sirohaem synthase dimerisation region', NULL, 'CysG_dimeriser', NULL, NULL, 17349, 9),
(260051, NULL, 'PF08525', NULL, NULL, 'Opacity-associated protein A N-terminal motif', NULL, 'OapA_N', NULL, NULL, 7696, 9),
(260052, NULL, 'PF12614', NULL, NULL, 'Ribosome recycling factor', NULL, 'RRF_GI', NULL, NULL, 21484, 9),
(260053, NULL, 'PF03571', NULL, NULL, 'Peptidase family M49', NULL, 'Peptidase_M49', NULL, NULL, 33183, 9),
(260054, NULL, 'PF04476', NULL, NULL, '4-HFC-P synthase', NULL, '4HFCP_synth', NULL, NULL, 1913, 9),
(260055, NULL, 'PF05627', NULL, NULL, 'Cleavage site for pathogenic type III effector avirulence factor Avr', NULL, 'AvrRpt-cleavage', NULL, NULL, 13012, 9),
(260056, NULL, 'PF09213', NULL, NULL, 'M3', NULL, 'M3', NULL, NULL, 12432, 9),
(260057, NULL, 'PF02524', NULL, NULL, 'KID repeat', NULL, 'KID', NULL, NULL, 4290, 9),
(260058, NULL, 'PF18286', NULL, NULL, 'Type III secretion system ExsE', NULL, 'T3SS_ExsE', NULL, NULL, 33172, 9),
(260059, NULL, 'PF06658', NULL, NULL, 'Protein of unknown function (DUF1168)', NULL, 'DUF1168', NULL, NULL, 10167, 9),
(260060, NULL, 'PF00685', NULL, NULL, 'Sulfotransferase domain', NULL, 'Sulfotransfer_1', NULL, NULL, 3350, 9),
(260061, NULL, 'PF09803', NULL, NULL, 'Pet100', NULL, 'Pet100', NULL, NULL, 16470, 9),
(260062, NULL, 'PF11958', NULL, NULL, 'Domain of unknown function (DUF3472)', NULL, 'DUF3472', NULL, NULL, 19531, 9),
(260063, NULL, 'PF13636', NULL, NULL, 'RNA-binding PUA-like domain of methyltransferase RsmF', NULL, 'Methyltranf_PUA', NULL, NULL, 24952, 9),
(260064, NULL, 'PF03595', NULL, NULL, 'Voltage-dependent anion channel', NULL, 'SLAC1', NULL, NULL, 3134, 9),
(260065, NULL, 'PF02805', NULL, NULL, 'Metal binding domain of Ada', NULL, 'Ada_Zn_binding', NULL, NULL, 930, 9),
(260066, NULL, 'PF14099', NULL, NULL, 'Polysaccharide lyase', NULL, 'Polysacc_lyase', NULL, NULL, 22346, 9),
(260067, NULL, 'PF08669', NULL, NULL, 'Glycine cleavage T-protein C-terminal barrel domain', NULL, 'GCV_T_C', NULL, NULL, 7936, 9),
(260068, NULL, 'PF14778', NULL, NULL, 'Odorant response abnormal 4-like', NULL, 'ODR4-like', NULL, NULL, 25925, 9),
(260069, NULL, 'PF09823', NULL, NULL, 'Domain of unknown function (DUF2357)', NULL, 'DUF2357', NULL, NULL, 16130, 9),
(260070, NULL, 'PF14396', NULL, NULL, 'Cystic fibrosis TM conductance regulator (CFTR), regulator domain', NULL, 'CFTR_R', NULL, NULL, 24136, 9),
(260071, NULL, 'PF05770', NULL, NULL, 'Inositol 1,3,4-trisphosphate 5/6-kinase ATP-grasp domain', NULL, 'Ins134_P3_kin', NULL, NULL, 28688, 9),
(260072, NULL, 'PF03429', NULL, NULL, 'Major surface protein 1B', NULL, 'MSP1b', NULL, NULL, 10391, 9),
(260073, NULL, 'PF12740', NULL, NULL, 'Chlorophyllase enzyme', NULL, 'Chlorophyllase2', NULL, NULL, 28834, 9),
(260074, NULL, 'PF14332', NULL, NULL, 'Domain of unknown function (DUF4388)', NULL, 'DUF4388', NULL, NULL, 26462, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(260075, NULL, 'PF20555', NULL, NULL, 'Domain of unknown function (DUF6767)', NULL, 'DUF6767', NULL, NULL, 37061, 9),
(260076, NULL, 'PF17983', NULL, NULL, 'Trypsin inhibitors 1,2 and 3', NULL, 'Tryp_inh', NULL, NULL, 32076, 9),
(260077, NULL, 'PF15236', NULL, NULL, 'Coiled-coil domain-containing protein 66', NULL, 'CCDC66', NULL, NULL, 27190, 9),
(260078, NULL, 'PF16780', NULL, NULL, 'AIMP2 lysyl-tRNA synthetase binding domain', NULL, 'AIMP2_LysRS_bd', NULL, NULL, 26868, 9),
(260079, NULL, 'PF16955', NULL, NULL, 'Ferrous iron uptake permease, iron-lead transporter', NULL, 'OFeT_1', NULL, NULL, 22347, 9),
(260080, NULL, 'PF02818', NULL, NULL, 'PPAK motif', NULL, 'PPAK', NULL, NULL, 2520, 9),
(260081, NULL, 'PF14488', NULL, NULL, 'Domain of unknown function (DUF4434)', NULL, 'DUF4434', NULL, NULL, 25712, 9),
(260082, NULL, 'PF08972', NULL, NULL, 'Domain of unknown function (DUF1902)', NULL, 'DUF1902', NULL, NULL, 8927, 9),
(260083, NULL, 'PF11388', NULL, NULL, 'Phagosome trafficking protein DotA', NULL, 'DotA', NULL, NULL, 18800, 9),
(260084, NULL, 'PF08785', NULL, NULL, 'Ku C terminal domain like', NULL, 'Ku_PK_bind', NULL, NULL, 13478, 9),
(260085, NULL, 'PF17057', NULL, NULL, 'Poxviridae B3 protein', NULL, 'B3R', NULL, NULL, 22565, 9),
(260086, NULL, 'PF11102', NULL, NULL, 'Group 4 capsule polysaccharide lipoprotein gfcB, YjbF', NULL, 'YjbF', NULL, NULL, 17614, 9),
(260087, NULL, 'PF07595', NULL, NULL, 'Planctomycete extracellular', NULL, 'Planc_extracel', NULL, NULL, 12528, 9),
(260088, NULL, 'PF03418', NULL, NULL, 'Germination protease', NULL, 'Peptidase_A25', NULL, NULL, 10123, 9),
(260089, NULL, 'PF12087', NULL, NULL, 'Protein of unknown function (DUF3564)', NULL, 'DUF3564', NULL, NULL, 20476, 9),
(260090, NULL, 'PF07632', NULL, NULL, 'Protein of unknown function (DUF1593)', NULL, 'DUF1593', NULL, NULL, 12924, 9),
(260091, NULL, 'PF06463', NULL, NULL, 'Molybdenum Cofactor Synthesis C', NULL, 'Mob_synth_C', NULL, NULL, 10314, 9),
(260092, NULL, 'PF11276', NULL, NULL, 'Protein of unknown function (DUF3078)', NULL, 'DUF3078', NULL, NULL, 18116, 9),
(260093, NULL, 'PF13231', NULL, NULL, 'Dolichyl-phosphate-mannose-protein mannosyltransferase', NULL, 'PMT_2', NULL, NULL, 29236, 9),
(260094, NULL, 'PF19363', NULL, NULL, 'Family of unknown function (DUF5939)', NULL, 'DUF5939', NULL, NULL, 36849, 9),
(260095, NULL, 'PF05276', NULL, NULL, 'SH3 domain-binding protein 5 (SH3BP5)', NULL, 'SH3BP5', NULL, NULL, 4434, 9),
(260096, NULL, 'PF11294', NULL, NULL, 'Protein of unknown function (DUF3095)', NULL, 'DUF3095', NULL, NULL, 18273, 9),
(260097, NULL, 'PF06194', NULL, NULL, 'Phage Conserved Open Reading Frame 51', NULL, 'Phage_Orf51', NULL, NULL, 14409, 9),
(260098, NULL, 'PF08406', NULL, NULL, 'CbbQ/NirQ/NorQ C-terminal', NULL, 'CbbQ_C', NULL, NULL, 11345, 9),
(260099, NULL, 'PF01322', NULL, NULL, 'Cytochrome C''', NULL, 'Cytochrom_C_2', NULL, NULL, 6004, 9),
(260100, NULL, 'PF00522', NULL, NULL, 'VPR/VPX protein', NULL, 'VPR', NULL, NULL, 2929, 9),
(260101, NULL, 'PF18386', NULL, NULL, 'Roquin II domain', NULL, 'ROQ_II', NULL, NULL, 29460, 9),
(260102, NULL, 'PF07423', NULL, NULL, 'Domain of unknown function (DUF1510)', NULL, 'DUF1510', NULL, NULL, 8945, 9),
(260103, NULL, 'PF03121', NULL, NULL, 'Herpesviridae UL52/UL70 DNA primase', NULL, 'Herpes_UL52', NULL, NULL, NULL, 9),
(260104, NULL, 'PF04923', NULL, NULL, 'Ninjurin', NULL, 'Ninjurin', NULL, NULL, 6560, 9),
(260105, NULL, 'PF16383', NULL, NULL, 'Domain of unknown function', NULL, 'DUF4992', NULL, NULL, 22431, 9),
(260106, NULL, 'PF12220', NULL, NULL, 'U1 small nuclear ribonucleoprotein of 70kDa MW N terminal', NULL, 'U1snRNP70_N', NULL, NULL, 20290, 9),
(260107, NULL, 'PF08671', NULL, NULL, 'Anti-repressor SinI', NULL, 'SinI', NULL, NULL, 8114, 9),
(260108, NULL, 'PF02181', NULL, NULL, 'Formin Homology 2 Domain', NULL, 'FH2', NULL, NULL, 7162, 9),
(260109, NULL, 'PF00576', NULL, NULL, 'HIUase/Transthyretin family', NULL, 'Transthyretin', NULL, NULL, 16259, 9),
(260110, NULL, 'PF13972', NULL, NULL, 'Bacterial transcriptional repressor', NULL, 'TetR', NULL, NULL, 25046, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(260111, NULL, 'PF00225', NULL, NULL, 'Kinesin motor domain', NULL, 'Kinesin', NULL, NULL, 3230, 9),
(260112, NULL, 'PF07710', NULL, NULL, 'P53 tetramerisation motif', NULL, 'P53_tetramer', NULL, NULL, 8218, 9),
(260113, NULL, 'PF16276', NULL, NULL, 'Nucleophosmin C-terminal domain', NULL, 'NPM1-C', NULL, NULL, 21509, 9),
(260114, NULL, 'PF08460', NULL, NULL, 'Bacterial SH3 domain', NULL, 'SH3_5', NULL, NULL, 1397, 9),
(260115, NULL, 'PF03966', NULL, NULL, 'Trm112p-like protein', NULL, 'Trm112p', NULL, NULL, 2573, 9),
(260116, NULL, 'PF10406', NULL, NULL, 'Transcription factor TFIID complex subunit 8 C-term', NULL, 'TAF8_C', NULL, NULL, 17312, 9),
(260117, NULL, 'PF02083', NULL, NULL, 'Urotensin II', NULL, 'Urotensin_II', NULL, NULL, 6267, 9),
(260118, NULL, 'PF07598', NULL, NULL, 'Protein of unknown function (DUF1561)', NULL, 'DUF1561', NULL, NULL, 13946, 9),
(260119, NULL, 'PF16772', NULL, NULL, 'Telomeric repeat-binding factor 2 Rap1-binding motif', NULL, 'TERF2_RBM', NULL, NULL, 22217, 9),
(260120, NULL, 'PF05454', NULL, NULL, 'Dystroglycan (Dystrophin-associated glycoprotein 1)', NULL, 'DAG1', NULL, NULL, 12128, 9),
(260121, NULL, 'PF10442', NULL, NULL, 'FIST C domain', NULL, 'FIST_C', NULL, NULL, 18276, 9),
(260122, NULL, 'PF10792', NULL, NULL, 'Protein of unknown function (DUF2605)', NULL, 'DUF2605', NULL, NULL, 20633, 9),
(260123, NULL, 'PF16367', NULL, NULL, 'RNA recognition motif', NULL, 'RRM_7', NULL, NULL, 5671, 9),
(260124, NULL, 'PF03241', NULL, NULL, '4-hydroxyphenylacetate 3-hydroxylase C terminal', NULL, 'HpaB', NULL, NULL, 25191, 9),
(260125, NULL, 'PF11681', NULL, NULL, 'Bacteriophage KPP10, Structural protein ORF10', NULL, 'KPP10_Orf10', NULL, NULL, 19010, 9),
(260126, NULL, 'PF20483', NULL, NULL, 'Flavivirus RNA-directed RNA polymerase, thumb domain', NULL, 'Flavi_NS5_thumb', NULL, NULL, 33958, 9),
(260127, NULL, 'PF06739', NULL, NULL, 'Beta-propeller repeat', NULL, 'SBBP', NULL, NULL, 8494, 9),
(260128, NULL, 'PF07406', NULL, NULL, 'NICE-3 protein', NULL, 'NICE-3', NULL, NULL, 11949, 9),
(260129, NULL, 'PF15501', NULL, NULL, 'Nuclear protein MDM1', NULL, 'MDM1', NULL, NULL, 23621, 9),
(260130, NULL, 'PF06855', NULL, NULL, 'YozE SAM-like fold', NULL, 'YozE_SAM_like', NULL, NULL, 15968, 9),
(260131, NULL, 'PF01393', NULL, NULL, 'Chromo shadow domain', NULL, 'Chromo_shadow', NULL, NULL, 683, 9),
(260132, NULL, 'PF09174', NULL, NULL, 'Maf1 regulator', NULL, 'Maf1', NULL, NULL, 12060, 9),
(260133, NULL, 'PF04775', NULL, NULL, 'Acyl-CoA thioester hydrolase/BAAT N-terminal region', NULL, 'Bile_Hydr_Trans', NULL, NULL, 3892, 9),
(260134, NULL, 'PF07810', NULL, NULL, 'TMC domain', NULL, 'TMC', NULL, NULL, 12606, 9),
(260135, NULL, 'PF14582', NULL, NULL, 'Metallophosphoesterase, calcineurin superfamily', NULL, 'Metallophos_3', NULL, NULL, 23438, 9),
(260136, NULL, 'PF06157', NULL, NULL, 'Protein of unknown function (DUF973)', NULL, 'DUF973', NULL, NULL, 14048, 9),
(260137, NULL, 'PF18195', NULL, NULL, 'GatD N-terminal domain', NULL, 'GatD_N', NULL, NULL, 27739, 9),
(260138, NULL, 'PF17727', NULL, NULL, 'CtsR C-terminal dimerization domain', NULL, 'CtsR_C', NULL, NULL, 29773, 9),
(260139, NULL, 'PF13987', NULL, NULL, 'YedD-like protein', NULL, 'YedD', NULL, NULL, 22611, 9),
(260140, NULL, 'PF13614', NULL, NULL, 'AAA domain', NULL, 'AAA_31', NULL, NULL, 24164, 9),
(260141, NULL, 'PF11020', NULL, NULL, 'Domain of unknown function (DUF2610)', NULL, 'DUF2610', NULL, NULL, 17885, 9),
(260142, NULL, 'PF18611', NULL, NULL, 'IL-3 receptor alpha chain N-terminal domain', NULL, 'IL3Ra_N', NULL, NULL, 28558, 9),
(260143, NULL, 'PF19431', NULL, NULL, 'MEKK4 N-terminal', NULL, 'MEKK4_N', NULL, NULL, 37441, 9),
(260144, NULL, 'PF13880', NULL, NULL, 'ESCO1/2 acetyl-transferase', NULL, 'Acetyltransf_13', NULL, NULL, 23153, 9),
(260145, NULL, 'PF16730', NULL, NULL, 'DnaG-primase C-terminal, helicase-binding domain', NULL, 'DnaGprimase_HBD', NULL, NULL, 22555, 9),
(260146, NULL, 'PF07222', NULL, NULL, 'Proacrosin binding protein sp32', NULL, 'PBP_sp32', NULL, NULL, 14387, 9),
(260147, NULL, 'PF15992', NULL, NULL, 'Domain of unknown function (DUF4769)', NULL, 'DUF4769', NULL, NULL, 24546, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(260148, NULL, 'PF14526', NULL, NULL, 'Integron-associated effector binding protein', NULL, 'Cass2', NULL, NULL, 25770, 9),
(260149, NULL, 'PF09602', NULL, NULL, 'Polyhydroxyalkanoic acid inclusion protein (PhaP_Bmeg)', NULL, 'PhaP_Bmeg', NULL, NULL, 11660, 9),
(260150, NULL, 'PF03249', NULL, NULL, 'Type specific antigen', NULL, 'TSA', NULL, NULL, 1742, 9),
(260151, NULL, 'PF13918', NULL, NULL, 'PLD-like domain', NULL, 'PLDc_3', NULL, NULL, 22015, 9),
(260152, NULL, 'PF10803', NULL, NULL, 'Spore germination GerPB', NULL, 'GerPB', NULL, NULL, 13298, 9),
(260153, NULL, 'PF17214', NULL, NULL, 'KH domain', NULL, 'KH_7', NULL, NULL, 31965, 9),
(260154, NULL, 'PF03414', NULL, NULL, 'Glycosyltransferase family 6', NULL, 'Glyco_transf_6', NULL, NULL, 10493, 9),
(260155, NULL, 'PF19863', NULL, NULL, 'Family of unknown function (DUF6337)', NULL, 'DUF6337', NULL, NULL, 36901, 9),
(260156, NULL, 'PF15879', NULL, NULL, 'NADH-ubiquinone oxidoreductase MWFE subunit', NULL, 'MWFE', NULL, NULL, 18190, 9),
(260157, NULL, 'PF05058', NULL, NULL, 'ActA Protein', NULL, 'ActA', NULL, NULL, 1043, 9),
(260158, NULL, 'PF01042', NULL, NULL, 'Endoribonuclease L-PSP', NULL, 'Ribonuc_L-PSP', NULL, NULL, 11408, 9),
(260159, NULL, 'PF17794', NULL, NULL, 'Major Vault Protein repeat domain', NULL, 'Vault_2', NULL, NULL, 29355, 9),
(260160, NULL, 'PF04591', NULL, NULL, 'Protein of unknown function, DUF596', NULL, 'DUF596', NULL, NULL, 597, 9),
(260161, NULL, 'PF05205', NULL, NULL, 'COMPASS (Complex proteins associated with Set1p) component shg1', NULL, 'COMPASS-Shg1', NULL, NULL, NULL, 9),
(260162, NULL, 'PF16037', NULL, NULL, 'Domain of unknown function (DUF4790)', NULL, 'DUF4790', NULL, NULL, 25577, 9),
(260163, NULL, 'PF19686', NULL, NULL, 'Family of unknown function (DUF6188)', NULL, 'DUF6188', NULL, NULL, 37264, 9),
(260164, NULL, 'PF18551', NULL, NULL, 'Thaumarchaeal output domain 1', NULL, 'TackOD1', NULL, NULL, 27539, 9),
(260165, NULL, 'PF05872', NULL, NULL, 'Helicase HerA-like C-terminal', NULL, 'HerA_C', NULL, NULL, 29121, 9),
(260166, NULL, 'PF09051', NULL, NULL, 'Stannin cytoplasmic', NULL, 'SNN_cytoplasm', NULL, NULL, 9517, 9),
(260167, NULL, 'PF09578', NULL, NULL, 'Spore cortex protein YabQ (Spore_YabQ)', NULL, 'Spore_YabQ', NULL, NULL, 16792, 9),
(260168, NULL, 'PF05193', NULL, NULL, 'Peptidase M16 inactive domain', NULL, 'Peptidase_M16_C', NULL, NULL, 3083, 9),
(260169, NULL, 'PF16199', NULL, NULL, 'Radical_SAM C-terminal domain', NULL, 'Radical_SAM_C', NULL, NULL, 26175, 9),
(260170, NULL, 'PF13296', NULL, NULL, 'Putative type VI secretion system Rhs element Vgr', NULL, 'T6SS_Vgr', NULL, NULL, 21523, 9),
(260171, NULL, 'PF03324', NULL, NULL, 'Herpesvirus DNA helicase/primase complex associated protein', NULL, 'Herpes_HEPA', NULL, NULL, 553, 9),
(260172, NULL, 'PF08625', NULL, NULL, 'Utp13 specific WD40 associated domain', NULL, 'Utp13', NULL, NULL, 14166, 9),
(260173, NULL, 'PF07098', NULL, NULL, 'Protein of unknown function (DUF1360)', NULL, 'DUF1360', NULL, NULL, 10863, 9),
(260174, NULL, 'PF12993', NULL, NULL, 'Domain of unknown function, E. rectale Gene description (DUF3877)', NULL, 'DUF3877', NULL, NULL, 24959, 9),
(260175, NULL, 'PF10796', NULL, NULL, 'Sigma-S stabilisation anti-adaptor protein', NULL, 'Anti-adapt_IraP', NULL, NULL, 20585, 9),
(260176, NULL, 'PF04859', NULL, NULL, 'Plant protein of unknown function (DUF641)', NULL, 'DUF641', NULL, NULL, 5989, 9),
(260177, NULL, 'PF01062', NULL, NULL, 'Bestrophin, RFP-TM, chloride channel', NULL, 'Bestrophin', NULL, NULL, 15021, 9),
(260178, NULL, 'PF15790', NULL, NULL, 'E1A-binding protein p400, N-terminal', NULL, 'EP400_N', NULL, NULL, 23868, 9),
(260179, NULL, 'PF02888', NULL, NULL, 'Calmodulin binding domain', NULL, 'CaMBD', NULL, NULL, 2785, 9),
(260180, NULL, 'PF08581', NULL, NULL, 'Tup N-terminal', NULL, 'Tup_N', NULL, NULL, 17835, 9),
(260181, NULL, 'PF09805', NULL, NULL, 'Nucleolar protein 12 (25kDa)', NULL, 'Nop25', NULL, NULL, 18089, 9),
(260182, NULL, 'PF19935', NULL, NULL, 'Domain of unknown function (DUF6398)', NULL, 'DUF6398', NULL, NULL, 36063, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(260183, NULL, 'PF10924', NULL, NULL, 'Protein of unknown function (DUF2711)', NULL, 'DUF2711', NULL, NULL, 20405, 9),
(260184, NULL, 'PF01933', NULL, NULL, '2-phospho-L-lactate transferase CofD', NULL, 'CofD', NULL, NULL, 5786, 9),
(260185, NULL, 'PF12570', NULL, NULL, 'Protein of unknown function (DUF3750)', NULL, 'DUF3750', NULL, NULL, 21445, 9),
(260186, NULL, 'PF13302', NULL, NULL, 'Acetyltransferase (GNAT) domain', NULL, 'Acetyltransf_3', NULL, NULL, 1841, 9),
(260187, NULL, 'PF17165', NULL, NULL, 'Domain of unknown function (DUF5121)', NULL, 'DUF5121', NULL, NULL, 32876, 9),
(260188, NULL, 'PF12827', NULL, NULL, 'Peroxisomal biogenesis protein family', NULL, 'Peroxin-22', NULL, NULL, 23839, 9),
(260189, NULL, 'PF17292', NULL, NULL, 'POB3-like N-terminal PH domain', NULL, 'POB3_N', NULL, NULL, 31420, 9),
(260190, NULL, 'PF00274', NULL, NULL, 'Fructose-bisphosphate aldolase class-I', NULL, 'Glycolytic', NULL, NULL, 6569, 9),
(260191, NULL, 'PF07005', NULL, NULL, 'Sugar-binding N-terminal domain', NULL, 'SBD_N', NULL, NULL, 9555, 9),
(260192, NULL, 'PF19952', NULL, NULL, 'Family of unknown function (DUF6414)', NULL, 'DUF6414', NULL, NULL, 33875, 9),
(260193, NULL, 'PF02854', NULL, NULL, 'MIF4G domain', NULL, 'MIF4G', NULL, NULL, 4100, 9),
(260194, NULL, 'PF14841', NULL, NULL, 'FliG middle domain', NULL, 'FliG_M', NULL, NULL, 22101, 9),
(260195, NULL, 'PF15016', NULL, NULL, 'Domain of unknown function (DUF4520)', NULL, 'DUF4520', NULL, NULL, 23979, 9),
(260196, NULL, 'PF18080', NULL, NULL, 'Galactose mutarotase-like fold domain', NULL, 'Gal_mutarotas_3', NULL, NULL, 28458, 9),
(260197, NULL, 'PF05230', NULL, NULL, 'MASE2 domain', NULL, 'MASE2', NULL, NULL, 3290, 9),
(260198, NULL, 'PF10006', NULL, NULL, 'Uncharacterized conserved protein (DUF2249)', NULL, 'DUF2249', NULL, NULL, 17458, 9),
(260199, NULL, 'PF04715', NULL, NULL, 'Anthranilate synthase component I, N terminal region', NULL, 'Anth_synt_I_N', NULL, NULL, 3587, 9),
(260200, NULL, 'PF11800', NULL, NULL, 'Replication protein C C-terminal region', NULL, 'RP-C_C', NULL, NULL, 19219, 9),
(260201, NULL, 'PF12701', NULL, NULL, 'Scd6-like Sm domain', NULL, 'LSM14', NULL, NULL, 23373, 9),
(260202, NULL, 'PF16303', NULL, NULL, 'Domain of unknown function (DUF4945)', NULL, 'DUF4945', NULL, NULL, 25520, 9),
(260203, NULL, 'PF14737', NULL, NULL, 'Domain of unknown function (DUF4470)', NULL, 'DUF4470', NULL, NULL, 24251, 9),
(260204, NULL, 'PF20275', NULL, NULL, 'C-terminal domain 10 of the ABC-three component (ABC-3C) systems', NULL, 'CTD10', NULL, NULL, 34361, 9),
(260205, NULL, 'PF07458', NULL, NULL, 'Sperm protein associated with nucleus, mapped to X chromosome', NULL, 'SPAN-X', NULL, NULL, 8879, 9),
(260206, NULL, 'PF03154', NULL, NULL, 'Atrophin-1 family', NULL, 'Atrophin-1', NULL, NULL, 6814, 9),
(260207, NULL, 'PF20072', NULL, NULL, 'Domain of unknown function (DUF6468)', NULL, 'DUF6468', NULL, NULL, 35884, 9),
(260208, NULL, 'PF06032', NULL, NULL, 'Protein of unknown function (DUF917)', NULL, 'DUF917', NULL, NULL, 8607, 9),
(260209, NULL, 'PF10772', NULL, NULL, 'Bacteriophage HP1, Orf24', NULL, 'Phage_HP1_Orf24', NULL, NULL, 20810, 9),
(260210, NULL, 'PF09072', NULL, NULL, 'Translation machinery associated TMA7', NULL, 'TMA7', NULL, NULL, 9521, 9),
(260211, NULL, 'PF02116', NULL, NULL, 'Fungal pheromone mating factor STE2 GPCR', NULL, 'STE2', NULL, NULL, 462, 9),
(260212, NULL, 'PF08374', NULL, NULL, 'Protocadherin', NULL, 'Protocadherin', NULL, NULL, 11627, 9),
(260213, NULL, 'PF14600', NULL, NULL, 'Cellulose-binding domain', NULL, 'CBM_5_12_2', NULL, NULL, 21913, 9),
(260214, NULL, 'PF19250', NULL, NULL, 'Family of unknown function (DUF5898)', NULL, 'DUF5898', NULL, NULL, 35935, 9),
(260215, NULL, 'PF13784', NULL, NULL, 'Fic/DOC family N-terminal', NULL, 'Fic_N', NULL, NULL, 23105, 9),
(260216, NULL, 'PF04763', NULL, NULL, 'Protein of unknown function (DUF562)', NULL, 'DUF562', NULL, NULL, 3911, 9),
(260217, NULL, 'PF12039', NULL, NULL, 'Protein of unknown function (DUF3525)', NULL, 'DUF3525', NULL, NULL, 19900, 9),
(260218, NULL, 'PF03664', NULL, NULL, 'Glycosyl hydrolase family 62', NULL, 'Glyco_hydro_62', NULL, NULL, 6321, 9); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(260219, NULL, 'PF15058', NULL, NULL, 'Speriolin N terminus', NULL, 'Speriolin_N', NULL, NULL, 26146, 9),
(260220, NULL, 'PF02239', NULL, NULL, 'Cytochrome D1 heme domain', NULL, 'Cytochrom_D1', NULL, NULL, NULL, 9),
(260221, NULL, 'PF05419', NULL, NULL, 'GUN4-like', NULL, 'GUN4', NULL, NULL, 14074, 9),
(260222, NULL, 'PF04346', NULL, NULL, 'Ethanolamine utilisation protein, EutH', NULL, 'EutH', NULL, NULL, 4901, 9),
(260223, NULL, 'PF19832', NULL, NULL, 'Family of unknown function (DUF6313)', NULL, 'DUF6313', NULL, NULL, 37569, 9),
(260224, NULL, 'PF12008', NULL, NULL, 'Type I restriction and modification enzyme - subunit R C terminal', NULL, 'EcoR124_C', NULL, NULL, 16651, 9),
(260225, NULL, 'PF12888', NULL, NULL, 'Lipid-binding putative hydrolase', NULL, 'Lipid_bd', NULL, NULL, 23519, 9),
(260226, NULL, 'PF04615', NULL, NULL, 'Utp14 protein', NULL, 'Utp14', NULL, NULL, NULL, 9),
(260227, NULL, 'PF08552', NULL, NULL, 'Inositolphosphorylceramide synthase subunit Kei1', NULL, 'Kei1', NULL, NULL, 9727, 9),
(260228, NULL, 'PF10870', NULL, NULL, 'Protein of unknown function (DUF2729)', NULL, 'DUF2729', NULL, NULL, 16965, 9),
(260229, NULL, 'PF04095', NULL, NULL, 'Nicotinate phosphoribosyltransferase (NAPRTase) family', NULL, 'NAPRTase', NULL, NULL, 29629, 9),
(260230, NULL, 'PF11392', NULL, NULL, 'Protein of unknown function (DUF2877)', NULL, 'DUF2877', NULL, NULL, 18775, 9),
(260231, NULL, 'PF16023', NULL, NULL, 'DUF4784 WD40-like domain', NULL, 'DUF4784', NULL, NULL, 23836, 9),
(260232, NULL, 'PF13646', NULL, NULL, 'HEAT repeats', NULL, 'HEAT_2', NULL, NULL, NULL, 9),
(260233, NULL, 'PF00035', NULL, NULL, 'Double-stranded RNA binding motif', NULL, 'dsrm', NULL, NULL, 12874, 9),
(260234, NULL, 'PF05838', NULL, NULL, 'Glycosyl hydrolase 108', NULL, 'Glyco_hydro_108', NULL, NULL, 13091, 9),
(260235, NULL, 'PF08405', NULL, NULL, 'Viral polyprotein N-terminal', NULL, 'Calici_PP_N', NULL, NULL, 11348, 9),
(260236, NULL, 'PF15684', NULL, NULL, 'Active regulator of SIRT1, or 40S ribosomal protein S19-binding 1', NULL, 'AROS', NULL, NULL, 19697, 9),
(260237, NULL, 'PF00029', NULL, NULL, 'Connexin', NULL, 'Connexin', NULL, NULL, 8254, 9),
(260238, NULL, 'PF07277', NULL, NULL, 'SapC', NULL, 'SapC', NULL, NULL, 11891, 9),
(260239, NULL, 'PF03908', NULL, NULL, 'Sec20', NULL, 'Sec20', NULL, NULL, 2698, 9),
(260240, NULL, 'PF00487', NULL, NULL, 'Fatty acid desaturase', NULL, 'FA_desaturase', NULL, NULL, 6876, 9),
(260241, NULL, 'PF09115', NULL, NULL, 'DNA polymerase III, delta subunit, C terminal', NULL, 'DNApol3-delta_C', NULL, NULL, 10795, 9),
(260242, NULL, 'PF04825', NULL, NULL, 'N terminus of Rad21 / Rec8 like protein', NULL, 'Rad21_Rec8_N', NULL, NULL, 4808, 9),
(260243, NULL, 'PF16341', NULL, NULL, 'Domain of unknown function (DUF4971)', NULL, 'DUF4971', NULL, NULL, 21700, 9),
(260244, NULL, 'PF05001', NULL, NULL, 'RNA polymerase Rpb1 C-terminal repeat', NULL, 'RNA_pol_Rpb1_R', NULL, NULL, 3926, 9),
(260245, NULL, 'PF12336', NULL, NULL, 'SOX transcription factor', NULL, 'SOXp', NULL, NULL, 20803, 9),
(260246, NULL, 'PF03584', NULL, NULL, 'Herpesvirus ICP4-like protein N-terminal region', NULL, 'Herpes_ICP4_N', NULL, NULL, 6965, 9),
(260247, NULL, 'PF12763', NULL, NULL, 'Cytoskeletal-regulatory complex EF hand', NULL, 'EF-hand_4', NULL, NULL, 1264, 9),
(260248, NULL, 'PF19308', NULL, NULL, 'CRISPR Cas6 N-terminal domain', NULL, 'CRISPR_Cas6_N', NULL, NULL, NULL, 9),
(260249, NULL, 'PF20217', NULL, NULL, 'Family of unknown function (DUF6577)', NULL, 'DUF6577', NULL, NULL, 37519, 9),
(260250, NULL, 'PF10038', NULL, NULL, 'Protein of unknown function (DUF2274)', NULL, 'DUF2274', NULL, NULL, 18337, 9),
(260251, NULL, 'PF04990', NULL, NULL, 'RNA polymerase Rpb1, domain 7', NULL, 'RNA_pol_Rpb1_7', NULL, NULL, 7124, 9),
(260252, NULL, 'PF02133', NULL, NULL, 'Permease for cytosine/purines, uracil, thiamine, allantoin', NULL, 'Transp_cyt_pur', NULL, NULL, 2181, 9),
(260253, NULL, 'PF02534', NULL, NULL, 'Type IV secretory system Conjugative DNA transfer', NULL, 'T4SS-DNA_transf', NULL, NULL, 1768, 9),
(260254, NULL, 'PF05153', NULL, NULL, 'Myo-inositol oxygenase', NULL, 'MIOX', NULL, NULL, 2318, 9);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(260255, NULL, 'PF19480', NULL, NULL, 'Domain of unknown function (DUF6016)', NULL, 'DUF6016', NULL, NULL, 36980, 9),
(260256, NULL, 'PF00400', NULL, NULL, 'WD domain, G-beta repeat', NULL, 'WD40', NULL, NULL, 3012, 9),
(260257, NULL, 'PF13454', NULL, NULL, 'FAD-NAD(P)-binding', NULL, 'NAD_binding_9', NULL, NULL, 29064, 9),
(260258, NULL, 'PF08164', NULL, NULL, 'Apoptosis-antagonizing transcription factor, C-terminal', NULL, 'TRAUB', NULL, NULL, 9582, 9),
(260259, NULL, 'PF10728', NULL, NULL, 'Domain of unknown function (DUF2520)', NULL, 'DUF2520', NULL, NULL, 14606, 9),
(260260, NULL, 'PF06188', NULL, NULL, 'HrpE/YscL/FliH and V-type ATPase subunit E', NULL, 'HrpE', NULL, NULL, 14169, 9),
(260261, NULL, 'PF12201', NULL, NULL, 'Bcl2-interacting killer, BH3-domain containing', NULL, 'bcl-2I13', NULL, NULL, 23188, 9),
(260262, NULL, 'PF14425', NULL, NULL, 'Immunity protein Imm3', NULL, 'Imm3', NULL, NULL, 24851, 9),
(260263, NULL, 'PF18184', NULL, NULL, 'SMODS and SLOG-associating 2TM effector domain 3', NULL, 'SLATT_3', NULL, NULL, 28519, 9),
(260264, NULL, 'PF06720', NULL, NULL, 'Bacteriophage phi-29 early protein GP16.7', NULL, 'Phi-29_GP16_7', NULL, NULL, 1753, 9),
(260265, NULL, 'PF09929', NULL, NULL, 'Putative PD-(D/E)XK phosphodiesterase (DUF2161)', NULL, 'DUF2161', NULL, NULL, 17364, 9),
(260266, NULL, 'PF18308', NULL, NULL, 'N-terminal extension of GAT domain', NULL, 'GGA_N-GAT', NULL, NULL, 28598, 9),
(260267, NULL, 'PF18541', NULL, NULL, 'RuvC endonuclease subdomain 3', NULL, 'RuvC_III', NULL, NULL, 29016, 9),
(260268, NULL, 'PF13778', NULL, NULL, 'Domain of unknown function (DUF4174)', NULL, 'DUF4174', NULL, NULL, 23394, 9),
(260269, NULL, 'PF14695', NULL, NULL, 'Lines C-terminus', NULL, 'LINES_C', NULL, NULL, 21956, 9),
(260270, NULL, 'PF05972', NULL, NULL, 'APC 15 residue motif', NULL, 'APC_15aa', NULL, NULL, 12656, 9),
(260271, NULL, 'PF07592', NULL, NULL, 'Rhodopirellula transposase DDE domain', NULL, 'DDE_Tnp_ISAZ013', NULL, NULL, 12842, 9),
(260272, NULL, 'PF08198', NULL, NULL, 'Thymopoietin protein', NULL, 'Thymopoietin', NULL, NULL, 5232, 9),
(260273, NULL, 'PF14353', NULL, NULL, 'CpXC protein', NULL, 'CpXC', NULL, NULL, 24809, 9),
(260274, NULL, 'PF13709', NULL, NULL, 'Domain of unknown function (DUF4159)', NULL, 'DUF4159', NULL, NULL, 23261, 9),
(260275, NULL, 'PF18267', NULL, NULL, 'Rubredoxin NAD+ reductase C-terminal domain', NULL, 'Rubredoxin_C', NULL, NULL, 30381, 9),
(260276, NULL, 'PF09309', NULL, NULL, 'FCP1, C-terminal', NULL, 'FCP1_C', NULL, NULL, 14132, 9),
(260277, NULL, 'PF19711', NULL, NULL, 'Family of unknown function (DUF6207)', NULL, 'DUF6207', NULL, NULL, 37225, 9),
(260278, NULL, 'PF19789', NULL, NULL, 'Family of unknown function (DUF6273)', NULL, 'DUF6273', NULL, NULL, 37330, 9),
(260279, NULL, 'PF02240', NULL, NULL, 'Methyl-coenzyme M reductase gamma subunit', NULL, 'MCR_gamma', NULL, NULL, 2912, 9),
(260280, NULL, 'PF10871', NULL, NULL, 'Protein of unknown function (DUF2748)', NULL, 'DUF2748', NULL, NULL, 13835, 9),
(260281, NULL, 'PF00420', NULL, NULL, 'NADH-ubiquinone/plastoquinone oxidoreductase chain 4L', NULL, 'Oxidored_q2', NULL, NULL, 33039, 9),
(260282, NULL, 'PF12240', NULL, NULL, 'Angiomotin C terminal', NULL, 'Angiomotin_C', NULL, NULL, 6128, 9),
(260283, NULL, 'PF02056', NULL, NULL, 'Family 4 glycosyl hydrolase', NULL, 'Glyco_hydro_4', NULL, NULL, 2142, 9),
(260284, NULL, 'PF15036', NULL, NULL, 'Interleukin 34', NULL, 'IL34', NULL, NULL, 20277, 9),
(260285, NULL, 'PF16844', NULL, NULL, 'Dinitrogenase iron-molybdenum cofactor, N-terminal', NULL, 'DIMCO_N', NULL, NULL, 22786, 9),
(260286, NULL, 'PF13402', NULL, NULL, 'Peptidase M60, enhancin and enhancin-like', NULL, 'Peptidase_M60', NULL, NULL, 25137, 9),
(260287, NULL, 'PF14647', NULL, NULL, 'FAM91 N-terminus', NULL, 'FAM91_N', NULL, NULL, 23402, 9),
(260288, NULL, 'PF05752', NULL, NULL, 'Calicivirus minor structural protein', NULL, 'Calici_MSP', NULL, NULL, 8867, 9),
(260289, NULL, 'PF06024', NULL, NULL, 'Orf78 (ac78)', NULL, 'Orf78', NULL, NULL, 13907, 9),
(260290, NULL, 'PF10159', NULL, NULL, 'Multiple myeloma tumor-associated', NULL, 'MMtag', NULL, NULL, 14507, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(260291, NULL, 'PF14468', NULL, NULL, 'Protein of unknown function (DUF4427)', NULL, 'DUF4427', NULL, NULL, 25743, 9),
(260292, NULL, 'PF16389', NULL, NULL, 'Domain of unknown function', NULL, 'DUF4998', NULL, NULL, NULL, 9),
(260293, NULL, 'PF07621', NULL, NULL, 'Protein of unknown function (DUF1582)', NULL, 'DUF1582', NULL, NULL, 13574, 9),
(260294, NULL, 'PF08180', NULL, NULL, 'B melanoma antigen family', NULL, 'BAGE', NULL, NULL, 12617, 9),
(260295, NULL, 'PF13364', NULL, NULL, 'Beta-galactosidase jelly roll domain', NULL, 'BetaGal_dom4_5', NULL, NULL, 25943, 9),
(260296, NULL, 'PF13467', NULL, NULL, 'Ribbon-helix-helix domain', NULL, 'RHH_4', NULL, NULL, 24098, 9),
(260297, NULL, 'PF19258', NULL, NULL, 'KxYKxGKxW signal peptide', NULL, 'KxYKxGKxW_sig', NULL, NULL, 15493, 9),
(260298, NULL, 'PF16036', NULL, NULL, 'Chalcone isomerase-like', NULL, 'Chalcone_3', NULL, NULL, 10041, 9),
(260299, NULL, 'PF11720', NULL, NULL, 'Peptidase inhibitor I78 family', NULL, 'Inhibitor_I78', NULL, NULL, 19361, 9),
(260300, NULL, 'PF07684', NULL, NULL, 'NOTCH protein', NULL, 'NODP', NULL, NULL, 10798, 9),
(260301, NULL, 'PF10751', NULL, NULL, 'Protein of unknown function (DUF2535)', NULL, 'DUF2535', NULL, NULL, 20012, 9),
(260302, NULL, 'PF13693', NULL, NULL, 'Winged helix-turn-helix DNA-binding', NULL, 'HTH_35', NULL, NULL, 31574, 9),
(260303, NULL, 'PF18936', NULL, NULL, 'Family of unknown function (DUF5684)', NULL, 'DUF5684', NULL, NULL, 34428, 9),
(260304, NULL, 'PF05820', NULL, NULL, 'Baculoviridae AC81', NULL, 'Ac81', NULL, NULL, 13461, 9),
(260305, NULL, 'PF01995', NULL, NULL, 'NrpR regulatory domains NRD1 and 2', NULL, 'NRD1_2', NULL, NULL, 5972, 9),
(260306, NULL, 'PF16915', NULL, NULL, 'Annelid erythrocruorin linker subunit C-terminus', NULL, 'Eryth_link_C', NULL, NULL, 25212, 9),
(260307, NULL, 'PF16570', NULL, NULL, 'Gram-positive pilin backbone subunit 3, Cna-B-like domain', NULL, 'GramPos_pilinD3', NULL, NULL, 25441, 9),
(260308, NULL, 'PF19905', NULL, NULL, 'Domain of unknown function (DUF6378)', NULL, 'DUF6378', NULL, NULL, 36640, 9),
(260309, NULL, 'PF01176', NULL, NULL, 'Translation initiation factor 1A / IF-1', NULL, 'eIF-1a', NULL, NULL, 11367, 9),
(260310, NULL, 'PF19924', NULL, NULL, 'Family of unknown function (DUF6387)', NULL, 'DUF6387', NULL, NULL, 37344, 9),
(260311, NULL, 'PF09351', NULL, NULL, 'Domain of unknown function (DUF1993)', NULL, 'DUF1993', NULL, NULL, 14786, 9),
(260312, NULL, 'PF04491', NULL, NULL, 'Poxvirus T4 protein, N terminus', NULL, 'Pox_T4_N', NULL, NULL, 1801, 9),
(260313, NULL, 'PF18998', NULL, NULL, 'Divergent InlB B-repeat domain', NULL, 'Flg_new_2', NULL, NULL, 34904, 9),
(260314, NULL, 'PF03251', NULL, NULL, 'Tymovirus 45/70Kd protein', NULL, 'Tymo_45kd_70kd', NULL, NULL, 1849, 9),
(260315, NULL, 'PF03635', NULL, NULL, 'Vacuolar protein sorting-associated protein 35', NULL, 'Vps35', NULL, NULL, 6439, 9),
(260316, NULL, 'PF01823', NULL, NULL, 'MAC/Perforin domain', NULL, 'MACPF', NULL, NULL, 20714, 9),
(260317, NULL, 'PF20563', NULL, NULL, 'Family of unknown function (DUF6773)', NULL, 'DUF6773', NULL, NULL, 37497, 9),
(260318, NULL, 'PF03291', NULL, NULL, 'mRNA capping enzyme', NULL, 'Pox_MCEL', NULL, NULL, 562, 9),
(260319, NULL, 'PF20058', NULL, NULL, 'Domain of unknown function (DUF6457)', NULL, 'DUF6457', NULL, NULL, 37182, 9),
(260320, NULL, 'PF19654', NULL, NULL, 'Family of unknown function (DUF6157)', NULL, 'DUF6157', NULL, NULL, 37457, 9),
(260321, NULL, 'PF15065', NULL, NULL, 'Lysosomal transcription factor, NCU-G1', NULL, 'NCU-G1', NULL, NULL, 26257, 9),
(260322, NULL, 'PF01137', NULL, NULL, 'RNA 3''-terminal phosphate cyclase', NULL, 'RTC', NULL, NULL, 16931, 9),
(260323, NULL, 'PF19496', NULL, NULL, 'Family of unknown function (DUF6031)', NULL, 'DUF6031', NULL, NULL, 36504, 9),
(260324, NULL, 'PF02283', NULL, NULL, 'Cobinamide kinase / cobinamide phosphate guanyltransferase', NULL, 'CobU', NULL, NULL, 3291, 9),
(260325, NULL, 'PF04283', NULL, NULL, 'Chemotaxis signal transduction system protein F from archaea', NULL, 'CheF-arch', NULL, NULL, 5689, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(260326, NULL, 'PF20203', NULL, NULL, 'Domain of unknown function (DUF6565)', NULL, 'DUF6565', NULL, NULL, 37381, 9),
(260327, NULL, 'PF12982', NULL, NULL, 'Protein of unknown function (DUF3866)', NULL, 'DUF3866', NULL, NULL, 22701, 9),
(260328, NULL, 'PF18473', NULL, NULL, 'Urease subunit beta-alpha linker domain', NULL, 'Urease_linker', NULL, NULL, 33309, 9),
(260329, NULL, 'PF07136', NULL, NULL, 'Protein of unknown function (DUF1385)', NULL, 'DUF1385', NULL, NULL, 10966, 9),
(260330, NULL, 'PF11074', NULL, NULL, 'Domain of unknown function(DUF2779)', NULL, 'DUF2779', NULL, NULL, 17905, 9),
(260331, NULL, 'PF08010', NULL, NULL, 'Bacteriophage protein GP30.3', NULL, 'Phage_30_3', NULL, NULL, 9002, 9),
(260332, NULL, 'PF13568', NULL, NULL, 'Outer membrane protein beta-barrel domain', NULL, 'OMP_b-brl_2', NULL, NULL, 24345, 9),
(260333, NULL, 'PF19749', NULL, NULL, 'Family of unknown function (DUF6236)', NULL, 'DUF6236', NULL, NULL, 37364, 9),
(260334, NULL, 'PF03349', NULL, NULL, 'Outer membrane protein transport protein (OMPP1/FadL/TodX)', NULL, 'Toluene_X', NULL, NULL, 1199, 9),
(260335, NULL, 'PF05431', NULL, NULL, 'Insecticidal Crystal Toxin, P42', NULL, 'Toxin_10', NULL, NULL, 7709, 9),
(260336, NULL, 'PF08535', NULL, NULL, 'KorB domain', NULL, 'KorB', NULL, NULL, 7707, 9),
(260337, NULL, 'PF11372', NULL, NULL, 'Domain of unknown function (DUF3173)', NULL, 'DUF3173', NULL, NULL, 18770, 9),
(260338, NULL, 'PF16152', NULL, NULL, 'Domain of unknown function (DUF4860)', NULL, 'DUF4860', NULL, NULL, 26454, 9),
(260339, NULL, 'PF09185', NULL, NULL, 'Domain of unknown function (DUF1948)', NULL, 'DUF1948', NULL, NULL, 12196, 9),
(260340, NULL, 'PF12126', NULL, NULL, 'Protein of unknown function (DUF3583)', NULL, 'DUF3583', NULL, NULL, 20180, 9),
(260341, NULL, 'PF11221', NULL, NULL, 'Subunit 21 of Mediator complex', NULL, 'Med21', NULL, NULL, 18176, 9),
(260342, NULL, 'PF13603', NULL, NULL, 'Leucyl-tRNA synthetase, Domain 2', NULL, 'tRNA-synt_1_2', NULL, NULL, 24650, 9),
(260343, NULL, 'PF14539', NULL, NULL, 'Domain of unknown function (DUF4442)', NULL, 'DUF4442', NULL, NULL, 23794, 9),
(260344, NULL, 'PF17886', NULL, NULL, 'HSP20-like domain found in ArsA', NULL, 'ArsA_HSP20', NULL, NULL, 28398, 9),
(260345, NULL, 'PF06432', NULL, NULL, 'Phosphatidylinositol N-acetylglucosaminyltransferase', NULL, 'GPI2', NULL, NULL, 9048, 9),
(260346, NULL, 'PF08166', NULL, NULL, 'NUC202 domain', NULL, 'NUC202', NULL, NULL, 12381, 9),
(260347, NULL, 'PF04096', NULL, NULL, 'Nucleoporin autopeptidase', NULL, 'Nucleoporin2', NULL, NULL, 6903, 9),
(260348, NULL, 'PF14378', NULL, NULL, 'PAP2 superfamily', NULL, 'PAP2_3', NULL, NULL, 22145, 9),
(260349, NULL, 'PF19257', NULL, NULL, 'BURAN domain', NULL, 'BURAN', NULL, NULL, 35019, 9),
(260350, NULL, 'PF00493', NULL, NULL, 'MCM P-loop domain', NULL, 'MCM', NULL, NULL, 1088, 9),
(260351, NULL, 'PF13876', NULL, NULL, 'Phage protein (N4 Gp49/phage Sf6 gene 66) family', NULL, 'Phage_gp49_66', NULL, NULL, 23316, 9),
(260352, NULL, 'PF08302', NULL, NULL, 'Fungal tRNA ligase phosphodiesterase domain', NULL, 'tRNA_lig_CPD', NULL, NULL, 8789, 9),
(260353, NULL, 'PF10826', NULL, NULL, 'Protein of unknown function (DUF2551)', NULL, 'DUF2551', NULL, NULL, 20274, 9),
(260354, NULL, 'PF13246', NULL, NULL, 'Cation transport ATPase (P-type)', NULL, 'Cation_ATPase', NULL, NULL, NULL, 9),
(260355, NULL, 'PF07802', NULL, NULL, 'GCK domain', NULL, 'GCK', NULL, NULL, 13379, 9),
(260356, NULL, 'PF14851', NULL, NULL, 'FAM176 family', NULL, 'FAM176', NULL, NULL, 28591, 9),
(260357, NULL, 'PF20568', NULL, NULL, 'Domain of unknown function (DUF6777)', NULL, 'DUF6777', NULL, NULL, 37343, 9),
(260358, NULL, 'PF03233', NULL, NULL, 'Aphid transmission protein', NULL, 'Cauli_AT', NULL, NULL, 1524, 9),
(260359, NULL, 'PF11408', NULL, NULL, 'Sgs1 RecQ helicase', NULL, 'Helicase_Sgs1', NULL, NULL, 17358, 9),
(260360, NULL, 'PF15107', NULL, NULL, 'FAM216B protein family', NULL, 'FAM216B', NULL, NULL, 26216, 9),
(260361, NULL, 'PF00100', NULL, NULL, 'Zona pellucida-like domain', NULL, 'Zona_pellucida', NULL, NULL, 6041, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(260362, NULL, 'PF02919', NULL, NULL, 'Eukaryotic DNA topoisomerase I, DNA binding fragment', NULL, 'Topoisom_I_N', NULL, NULL, 12201, 9),
(260363, NULL, 'PF18501', NULL, NULL, 'Alpha helical recognition lobe domain', NULL, 'REC1', NULL, NULL, 28772, 9),
(260364, NULL, 'PF13450', NULL, NULL, 'NAD(P)-binding Rossmann-like domain', NULL, 'NAD_binding_8', NULL, NULL, NULL, 9),
(260365, NULL, 'PF15158', NULL, NULL, 'Domain of unknown function (DUF4579)', NULL, 'DUF4579', NULL, NULL, 25880, 9),
(260366, NULL, 'PF15692', NULL, NULL, 'NF-kappa-B-activating protein', NULL, 'NKAP', NULL, NULL, NULL, 9),
(260367, NULL, 'PF20304', NULL, NULL, 'Small protein from certain CxC ATPase-based DNA modification systems', NULL, 'Sp-CxC', NULL, NULL, 33947, 9),
(260368, NULL, 'PF03781', NULL, NULL, 'Sulfatase-modifying factor enzyme 1', NULL, 'FGE-sulfatase', NULL, NULL, 1544, 9),
(260369, NULL, 'PF08658', NULL, NULL, 'Rad54 N terminal', NULL, 'Rad54_N', NULL, NULL, 7616, 9),
(260370, NULL, 'PF02404', NULL, NULL, 'Stem cell factor', NULL, 'SCF', NULL, NULL, 5303, 9),
(260371, NULL, 'PF11649', NULL, NULL, 'Virus neck protein', NULL, 'T4_neck-protein', NULL, NULL, 18643, 9),
(260372, NULL, 'PF10014', NULL, NULL, '2OG-Fe dioxygenase', NULL, '2OG-Fe_Oxy_2', NULL, NULL, 17112, 9),
(260373, NULL, 'PF10240', NULL, NULL, 'Multivesicular body subunit 12', NULL, 'DUF2464', NULL, NULL, 19333, 9),
(260374, NULL, 'PF14798', NULL, NULL, 'Calcium homeostasis modulator', NULL, 'Ca_hom_mod', NULL, NULL, 25750, 9),
(260375, NULL, 'PF15796', NULL, NULL, 'KELK-motif containing domain of MRCK Ser/Thr protein kinase', NULL, 'KELK', NULL, NULL, 23526, 9),
(260376, NULL, 'PF16028', NULL, NULL, 'Solute carrier family 3 member 2 N-terminus', NULL, 'SLC3A2_N', NULL, NULL, 23718, 9),
(260377, NULL, 'PF00571', NULL, NULL, 'CBS domain', NULL, 'CBS', NULL, NULL, 3944, 9),
(260378, NULL, 'PF02713', NULL, NULL, 'Domain of unknown function DUF220', NULL, 'DUF220', NULL, NULL, 3481, 9),
(260379, NULL, 'PF10007', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2250)', NULL, 'DUF2250', NULL, NULL, 19728, 9),
(260380, NULL, 'PF17524', NULL, NULL, 'Anti-sigma factor CnrY', NULL, 'CnrY', NULL, NULL, 28451, 9),
(260381, NULL, 'PF11782', NULL, NULL, 'Protein of unknown function (DUF3319)', NULL, 'DUF3319', NULL, NULL, 19259, 9),
(260382, NULL, 'PF18424', NULL, NULL, 'Alpha-Dystroglycan N-terminal domain 2', NULL, 'a_DG1_N2', NULL, NULL, 30013, 9),
(260383, NULL, 'PF03862', NULL, NULL, 'SpoVAC/SpoVAEB sporulation membrane protein', NULL, 'SpoVAC_SpoVAEB', NULL, NULL, 1957, 9),
(260384, NULL, 'PF01702', NULL, NULL, 'Queuine tRNA-ribosyltransferase', NULL, 'TGT', NULL, NULL, 2876, 9),
(260385, NULL, 'PF19775', NULL, NULL, 'Family of unknown function (DUF6261)', NULL, 'DUF6261', NULL, NULL, 37346, 9),
(260386, NULL, 'PF20015', NULL, NULL, 'vWA-MoxR associated protein middle region (VMAP-M) 12', NULL, 'VMAP-M12', NULL, NULL, NULL, 9),
(260387, NULL, 'PF07212', NULL, NULL, 'Hyaluronidase protein (HylP)', NULL, 'Hyaluronidase_1', NULL, NULL, 14285, 9),
(260388, NULL, 'PF01447', NULL, NULL, 'Thermolysin metallopeptidase, catalytic domain', NULL, 'Peptidase_M4', NULL, NULL, 8112, 9),
(260389, NULL, 'PF15116', NULL, NULL, 'CAMPATH-1 antigen', NULL, 'CD52', NULL, NULL, 23974, 9),
(260390, NULL, 'PF03265', NULL, NULL, 'Deoxyribonuclease II', NULL, 'DNase_II', NULL, NULL, 2627, 9),
(260391, NULL, 'PF13532', NULL, NULL, '2OG-Fe(II) oxygenase superfamily', NULL, '2OG-FeII_Oxy_2', NULL, NULL, 26093, 9),
(260392, NULL, 'PF18523', NULL, NULL, 'Sld3 N-terminal domain', NULL, 'Sld3_N', NULL, NULL, 29210, 9),
(260393, NULL, 'PF03033', NULL, NULL, 'Glycosyltransferase family 28 N-terminal domain', NULL, 'Glyco_transf_28', NULL, NULL, 4582, 9),
(260394, NULL, 'PF07685', NULL, NULL, 'CobB/CobQ-like glutamine amidotransferase domain', NULL, 'GATase_3', NULL, NULL, 10767, 9),
(260395, NULL, 'PF01641', NULL, NULL, 'SelR domain', NULL, 'SelR', NULL, NULL, 1901, 9),
(260396, NULL, 'PF15431', NULL, NULL, 'Transmembrane protein 190', NULL, 'TMEM190', NULL, NULL, 21968, 9);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(260397, NULL, 'PF18527', NULL, NULL, 'STT3/PglB C-terminal beta-barrel domain', NULL, 'STT3_PglB_C', NULL, NULL, 30703, 9),
(260398, NULL, 'PF13967', NULL, NULL, 'Late exocytosis, associated with Golgi transport', NULL, 'RSN1_TM', NULL, NULL, 22702, 9),
(260399, NULL, 'PF20394', NULL, NULL, 'Family of unknown function (DUF6688)', NULL, 'DUF6688', NULL, NULL, 37537, 9),
(260400, NULL, 'PF20211', NULL, NULL, 'Family of unknown function (DUF6571)', NULL, 'DUF6571', NULL, NULL, 37142, 9),
(260401, NULL, 'PF00629', NULL, NULL, 'MAM domain, meprin/A5/mu', NULL, 'MAM', NULL, NULL, 3140, 9),
(260402, NULL, 'PF15038', NULL, NULL, 'Jiraiya', NULL, 'Jiraiya', NULL, NULL, 26797, 9),
(260403, NULL, 'PF15584', NULL, NULL, 'Immunity protein 72', NULL, 'Imm72', NULL, NULL, 24550, 9),
(260404, NULL, 'PF17846', NULL, NULL, 'Xrn1 helical domain', NULL, 'XRN_M', NULL, NULL, 30385, 9),
(260405, NULL, 'PF03543', NULL, NULL, 'Yersinia/Haemophilus virulence surface antigen', NULL, 'Peptidase_C58', NULL, NULL, 6045, 9),
(260406, NULL, 'PF20475', NULL, NULL, 'Family of unknown function (DUF6717)', NULL, 'DUF6717', NULL, NULL, 37585, 9),
(260407, NULL, 'PF01821', NULL, NULL, 'Anaphylotoxin-like domain', NULL, 'ANATO', NULL, NULL, 2547, 9),
(260408, NULL, 'PF10587', NULL, NULL, 'Eukaryotic elongation factor 1 beta central acidic region', NULL, 'EF-1_beta_acid', NULL, NULL, 9437, 9),
(260409, NULL, 'PF14810', NULL, NULL, 'Patch-forming domain C2 of tRNA-guanine transglycosylase', NULL, 'TGT_C2', NULL, NULL, 24737, 9),
(260410, NULL, 'PF01742', NULL, NULL, 'Clostridial neurotoxin zinc protease', NULL, 'Peptidase_M27', NULL, NULL, 4153, 9),
(260411, NULL, 'PF09820', NULL, NULL, 'Predicted AAA-ATPase', NULL, 'AAA-ATPase_like', NULL, NULL, 16432, 9),
(260412, NULL, 'PF14142', NULL, NULL, 'YrzO-like protein', NULL, 'YrzO', NULL, NULL, 26200, 9),
(260413, NULL, 'PF08184', NULL, NULL, 'Cuticle protein 7 isoform family', NULL, 'Cuticle_2', NULL, NULL, 8641, 9),
(260414, NULL, 'PF18680', NULL, NULL, 'Plasmodium host cell traversal SPECT1', NULL, 'SPECT1', NULL, NULL, 32143, 9),
(260415, NULL, 'PF00699', NULL, NULL, 'Urease beta subunit', NULL, 'Urease_beta', NULL, NULL, 2157, 9),
(260416, NULL, 'PF05364', NULL, NULL, 'Salmonella type III secretion SopE effector N-terminus', NULL, 'SecIII_SopE_N', NULL, NULL, 8961, 9),
(260417, NULL, 'PF03760', NULL, NULL, 'Late embryogenesis abundant (LEA) group 1', NULL, 'LEA_1', NULL, NULL, 761, 9),
(260418, NULL, 'PF14641', NULL, NULL, 'Helix-turn-helix DNA-binding domain of SPT6', NULL, 'HTH_44', NULL, NULL, 23120, 9),
(260419, NULL, 'PF08170', NULL, NULL, 'POPLD (NUC188) domain', NULL, 'POPLD', NULL, NULL, 9339, 9),
(260420, NULL, 'PF06568', NULL, NULL, 'Domain of unknown function (DUF1127)', NULL, 'DUF1127', NULL, NULL, 9448, 9),
(260421, NULL, 'PF07142', NULL, NULL, 'Repeat of unknown function (DUF1388)', NULL, 'DUF1388', NULL, NULL, 10926, 9),
(260422, NULL, 'PF02248', NULL, NULL, 'Small coat protein', NULL, 'Como_SCP', NULL, NULL, 1798, 9),
(260423, NULL, 'PF00056', NULL, NULL, 'lactate/malate dehydrogenase, NAD binding domain', NULL, 'Ldh_1_N', NULL, NULL, 2247, 9),
(260424, NULL, 'PF02870', NULL, NULL, '6-O-methylguanine DNA methyltransferase, ribonuclease-like domain', NULL, 'Methyltransf_1N', NULL, NULL, 12356, 9),
(260425, NULL, 'PF04237', NULL, NULL, 'YjbR', NULL, 'YjbR', NULL, NULL, 5767, 9),
(260426, NULL, 'PF10237', NULL, NULL, 'Probable N6-adenine methyltransferase', NULL, 'N6-adenineMlase', NULL, NULL, 29054, 9),
(260427, NULL, 'PF01012', NULL, NULL, 'Electron transfer flavoprotein domain', NULL, 'ETF', NULL, NULL, 13087, 9),
(260428, NULL, 'PF08266', NULL, NULL, 'Cadherin-like', NULL, 'Cadherin_2', NULL, NULL, 8773, 9),
(260429, NULL, 'PF18048', NULL, NULL, 'TNF receptor-associated factor 6 zinc finger 2', NULL, 'TRAF6_Z2', NULL, NULL, 29704, 9),
(260430, NULL, 'PF00890', NULL, NULL, 'FAD binding domain', NULL, 'FAD_binding_2', NULL, NULL, 7261, 9),
(260431, NULL, 'PF08608', NULL, NULL, 'Wyosine base formation', NULL, 'Wyosine_form', NULL, NULL, 14326, 9),
(260432, NULL, 'PF07040', NULL, NULL, 'Protein of unknown function (DUF1326)', NULL, 'DUF1326', NULL, NULL, 12351, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(260433, NULL, 'PF18125', NULL, NULL, 'RlmM ferredoxin-like domain', NULL, 'RlmM_FDX', NULL, NULL, 28387, 9),
(260434, NULL, 'PF09454', NULL, NULL, 'Vps23 core domain', NULL, 'Vps23_core', NULL, NULL, 2718, 9),
(260435, NULL, 'PF04578', NULL, NULL, 'Protein of unknown function, DUF594', NULL, 'DUF594', NULL, NULL, 478, 9),
(260436, NULL, 'PF17485', NULL, NULL, 'Satellite RNA 48 kDa protein', NULL, 'SatRNA_48', NULL, NULL, 15892, 9),
(260437, NULL, 'PF18827', NULL, NULL, 'Large polyvalent protein-associated domain 14', NULL, 'LPD14', NULL, NULL, 32344, 9),
(260438, NULL, 'PF06268', NULL, NULL, 'Fascin domain', NULL, 'Fascin', NULL, NULL, 20465, 9),
(260439, NULL, 'PF11776', NULL, NULL, 'Nickel/cobalt transporter regulator', NULL, 'RcnB', NULL, NULL, 21833, 9),
(260440, NULL, 'PF09868', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2095)', NULL, 'DUF2095', NULL, NULL, 16840, 9),
(260441, NULL, 'PF07281', NULL, NULL, 'Insulin-induced protein (INSIG)', NULL, 'INSIG', NULL, NULL, 24846, 9),
(260442, NULL, 'PF12644', NULL, NULL, 'Protein of unknown function (DUF3782)', NULL, 'DUF3782', NULL, NULL, 14569, 9),
(260443, NULL, 'PF17064', NULL, NULL, 'Sleepless protein', NULL, 'QVR', NULL, NULL, 26139, 9),
(260444, NULL, 'PF08231', NULL, NULL, 'SYF2 splicing factor', NULL, 'SYF2', NULL, NULL, 13445, 9),
(260445, NULL, 'PF00666', NULL, NULL, 'Cathelicidin', NULL, 'Cathelicidins', NULL, NULL, NULL, 9),
(260446, NULL, 'PF13173', NULL, NULL, 'AAA domain', NULL, 'AAA_14', NULL, NULL, 30487, 9),
(260447, NULL, 'PF17213', NULL, NULL, 'Hydin Adenylate kinase-like domain', NULL, 'Hydin_ADK', NULL, NULL, 31689, 9),
(260448, NULL, 'PF10713', NULL, NULL, 'Protein of unknown function (DUF2509)', NULL, 'DUF2509', NULL, NULL, 20813, 9),
(260449, NULL, 'PF09857', NULL, NULL, 'Putative toxin of bacterial toxin-antitoxin pair', NULL, 'YjhX_toxin', NULL, NULL, 16757, 9),
(260450, NULL, 'PF05987', NULL, NULL, 'Bacterial protein of unknown function (DUF898)', NULL, 'DUF898', NULL, NULL, 7793, 9),
(260451, NULL, 'PF07647', NULL, NULL, 'SAM domain (Sterile alpha motif)', NULL, 'SAM_2', NULL, NULL, 5007, 9),
(260452, NULL, 'PF11522', NULL, NULL, 'Yeast phosphatidylinositol-4-OH kinase Pik1', NULL, 'Pik1', NULL, NULL, 18930, 9),
(260453, NULL, 'PF17583', NULL, NULL, 'Family of unknown function (DUF5484)', NULL, 'DUF5484', NULL, NULL, 30803, 9),
(260454, NULL, 'PF19694', NULL, NULL, 'Family of unknown function (DUF6194)', NULL, 'DUF6194', NULL, NULL, 36174, 9),
(260455, NULL, 'PF20353', NULL, NULL, 'Family of unknown function (DUF6648)', NULL, 'DUF6648', NULL, NULL, 33625, 9),
(260456, NULL, 'PF04905', NULL, NULL, 'NAB conserved region 2 (NCD2)', NULL, 'NCD2', NULL, NULL, 5754, 9),
(260457, NULL, 'PF16398', NULL, NULL, 'Domain of unknown function (DUF5007)', NULL, 'DUF5007', NULL, NULL, 23610, 9),
(260458, NULL, 'PF00958', NULL, NULL, 'GMP synthase C terminal domain', NULL, 'GMP_synt_C', NULL, NULL, 3100, 9),
(260459, NULL, 'PF11704', NULL, NULL, 'Vesicle coat protein involved in Golgi to plasma membrane transport', NULL, 'Folliculin', NULL, NULL, 33439, 9),
(260460, NULL, 'PF03704', NULL, NULL, 'Bacterial transcriptional activator domain', NULL, 'BTAD', NULL, NULL, 4334, 9),
(260461, NULL, 'PF10820', NULL, NULL, 'Protein of unknown function (DUF2543)', NULL, 'DUF2543', NULL, NULL, 19070, 9),
(260462, NULL, 'PF19314', NULL, NULL, 'Family of unknown function (DUF5917)', NULL, 'DUF5917', NULL, NULL, 37438, 9),
(260463, NULL, 'PF17116', NULL, NULL, 'Domain of unknown function (DUF5103)', NULL, 'DUF5103', NULL, NULL, 26320, 9),
(260464, NULL, 'PF17104', NULL, NULL, 'Domain of unknown function (DUF5102)', NULL, 'DUF5102', NULL, NULL, 2706, 9),
(260465, NULL, 'PF10752', NULL, NULL, 'Protein of unknown function (DUF2533)', NULL, 'DUF2533', NULL, NULL, 20066, 9),
(260466, NULL, 'PF09139', NULL, NULL, 'Phosphatidate cytidylyltransferase, mitochondrial', NULL, 'Tam41_Mmp37', NULL, NULL, 10870, 9),
(260467, NULL, 'PF11682', NULL, NULL, 'Probable zinc-ribbon', NULL, 'zinc_ribbon_11', NULL, NULL, 19143, 9),
(260468, NULL, 'PF18129', NULL, NULL, 'Xrn1 SH3-like domain', NULL, 'SH3_12', NULL, NULL, 29435, 9);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(260469, NULL, 'PF09456', NULL, NULL, 'RcsC Alpha-Beta-Loop (ABL)', NULL, 'RcsC', NULL, NULL, 15573, 9),
(260470, NULL, 'PF10230', NULL, NULL, 'Lipid-droplet associated hydrolase', NULL, 'LIDHydrolase', NULL, NULL, 15655, 9),
(260471, NULL, 'PF09074', NULL, NULL, 'Mer2', NULL, 'Mer2', NULL, NULL, 9570, 9),
(260472, NULL, 'PF11252', NULL, NULL, 'Protein of unknown function (DUF3051)', NULL, 'DUF3051', NULL, NULL, 18236, 9),
(260473, NULL, 'PF12173', NULL, NULL, 'Bacteriocin class IIc cyclic gassericin A-like', NULL, 'BacteriocIIc_cy', NULL, NULL, 15794, 9),
(260474, NULL, 'PF16078', NULL, NULL, '2-oxoglutarate dehydrogenase N-terminus', NULL, '2-oxogl_dehyd_N', NULL, NULL, 23548, 9),
(260475, NULL, 'PF12357', NULL, NULL, 'Phospholipase D C terminal', NULL, 'PLD_C', NULL, NULL, 3841, 9),
(260476, NULL, 'PF03151', NULL, NULL, 'Triose-phosphate Transporter family', NULL, 'TPT', NULL, NULL, 7180, 9),
(260477, NULL, 'PF08078', NULL, NULL, 'PsaX family', NULL, 'PsaX', NULL, NULL, 12261, 9),
(260478, NULL, 'PF00491', NULL, NULL, 'Arginase family', NULL, 'Arginase', NULL, NULL, 2546, 9),
(260479, NULL, 'PF00858', NULL, NULL, 'Amiloride-sensitive sodium channel', NULL, 'ASC', NULL, NULL, 4205, 9),
(260480, NULL, 'PF02296', NULL, NULL, 'Alpha adaptin AP2, C-terminal domain', NULL, 'Alpha_adaptin_C', NULL, NULL, 1995, 9),
(260481, NULL, 'PF18997', NULL, NULL, 'Family of unknown function (DUF5727)', NULL, 'DUF5727', NULL, NULL, 35250, 9),
(260482, NULL, 'PF11821', NULL, NULL, 'Alternative complex III, ActD subunit', NULL, 'ActD', NULL, NULL, 19398, 9),
(260483, NULL, 'PF09741', NULL, NULL, 'Uncharacterized conserved protein (DUF2045)', NULL, 'DUF2045', NULL, NULL, 17825, 9),
(260484, NULL, 'PF04127', NULL, NULL, 'DNA / pantothenate metabolism flavoprotein', NULL, 'DFP', NULL, NULL, 84, 9),
(260485, NULL, 'PF03618', NULL, NULL, 'Kinase/pyrophosphorylase', NULL, 'Kinase-PPPase', NULL, NULL, 5152, 9),
(260486, NULL, 'PF08545', NULL, NULL, '3-Oxoacyl-[acyl-carrier-protein (ACP)] synthase III', NULL, 'ACP_syn_III', NULL, NULL, 7650, 9),
(260487, NULL, 'PF19328', NULL, NULL, '2,4-diaminopentanoate dehydrogenase C-terminal domain', NULL, 'DAP_DH_C', NULL, NULL, 34368, 9),
(260488, NULL, 'PF10313', NULL, NULL, 'Uncharacterised protein domain (DUF2415)', NULL, 'DUF2415', NULL, NULL, 16890, 9),
(260489, NULL, 'PF18931', NULL, NULL, 'Domain of unknown function (DUF5680)', NULL, 'DUF5680', NULL, NULL, 35579, 9),
(260490, NULL, 'PF05963', NULL, NULL, 'Cytomegalovirus US3 protein', NULL, 'Cytomega_US3', NULL, NULL, 12750, 9),
(260491, NULL, 'PF00473', NULL, NULL, 'Corticotropin-releasing factor family', NULL, 'CRF', NULL, NULL, 3913, 9),
(260492, NULL, 'PF14439', NULL, NULL, 'Bd3614-like deaminase', NULL, 'Bd3614-deam', NULL, NULL, 24348, 9),
(260493, NULL, 'PF04706', NULL, NULL, 'Dickkopf N-terminal cysteine-rich region', NULL, 'Dickkopf_N', NULL, NULL, 3858, 9),
(260494, NULL, 'PF01948', NULL, NULL, 'Aspartate carbamoyltransferase regulatory chain, allosteric domain', NULL, 'PyrI', NULL, NULL, 20761, 9),
(260495, NULL, 'PF11549', NULL, NULL, 'Protein transport protein SEC31', NULL, 'Sec31', NULL, NULL, 18901, 9),
(260496, NULL, 'PF00472', NULL, NULL, 'RF-1 domain', NULL, 'RF-1', NULL, NULL, 47, 9),
(260497, NULL, 'PF19240', NULL, NULL, 'Family of unknown function (DUF5890)', NULL, 'DUF5890', NULL, NULL, 35691, 9),
(260498, NULL, 'PF11551', NULL, NULL, 'Outer membrane protein Omp28', NULL, 'Omp28', NULL, NULL, 18842, 9),
(260499, NULL, 'PF15680', NULL, NULL, 'Orofacial cleft 1 candidate gene 1 protein', NULL, 'OFCC1', NULL, NULL, 25216, 9),
(260500, NULL, 'PF01443', NULL, NULL, 'Viral (Superfamily 1) RNA helicase', NULL, 'Viral_helicase1', NULL, NULL, 24465, 9),
(260501, NULL, 'PF07119', NULL, NULL, 'Protein of unknown function (DUF1375)', NULL, 'DUF1375', NULL, NULL, 10667, 9),
(260502, NULL, 'PF16888', NULL, NULL, 'Domain of unknown function (DUF5082)', NULL, 'DUF5082', NULL, NULL, 22710, 9),
(260503, NULL, 'PF18922', NULL, NULL, 'Protein of unknown function (DUF5672)', NULL, 'DUF5672', NULL, NULL, 34360, 9);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(260504, NULL, 'PF11225', NULL, NULL, 'Protein of unknown function (DUF3024)', NULL, 'DUF3024', NULL, NULL, 18124, 9),
(260505, NULL, 'PF19269', NULL, NULL, 'Anticodon binding domain', NULL, 'Anticodon_2', NULL, NULL, 37073, 9),
(260506, NULL, 'PF09089', NULL, NULL, 'Phage short tail fibre protein gp12, middle domain', NULL, 'gp12-short_mid', NULL, NULL, 10703, 9),
(260507, NULL, 'PF15352', NULL, NULL, 'Susceptibility to monomelic amyotrophy', NULL, 'K1377', NULL, NULL, 23034, 9),
(260508, NULL, 'PF10123', NULL, NULL, 'Mu-like prophage I protein', NULL, 'Mu-like_Pro', NULL, NULL, 12745, 9),
(260509, NULL, 'PF10686', NULL, NULL, 'YspA, cpYpsA-related SLOG family', NULL, 'YAcAr', NULL, NULL, 20753, 9),
(260510, NULL, 'PF14805', NULL, NULL, 'Tetrahydrodipicolinate N-succinyltransferase N-terminal', NULL, 'THDPS_N_2', NULL, NULL, 11444, 9),
(260511, NULL, 'PF19010', NULL, NULL, 'Family of unknown function (DUF5739)', NULL, 'DUF5739', NULL, NULL, 35677, 9),
(260512, NULL, 'PF00892', NULL, NULL, 'EamA-like transporter family', NULL, 'EamA', NULL, NULL, 5774, 9),
(260513, NULL, 'PF12257', NULL, NULL, 'Vacuolar membrane-associated protein Iml1', NULL, 'IML1', NULL, NULL, 26304, 9),
(260514, NULL, 'PF12617', NULL, NULL, 'Iron-Sulfur binding protein C terminal', NULL, 'LdpA_C', NULL, NULL, 15368, 9),
(260515, NULL, 'PF02812', NULL, NULL, 'Glu/Leu/Phe/Val dehydrogenase, dimerisation domain', NULL, 'ELFV_dehydrog_N', NULL, NULL, 2696, 9),
(260516, NULL, 'PF13875', NULL, NULL, 'Domain of unknown function (DUF4202)', NULL, 'DUF4202', NULL, NULL, 23260, 9),
(260517, NULL, 'PF15846', NULL, NULL, 'Domain of unknown function (DUF4720)', NULL, 'DUF4720', NULL, NULL, 26113, 9),
(260518, NULL, 'PF18390', NULL, NULL, 'Glycogen debranching enzyme C-terminal domain', NULL, 'GlgX_C', NULL, NULL, 28608, 9),
(260519, NULL, 'PF08899', NULL, NULL, 'Domain of unknown function (DUF1844)', NULL, 'DUF1844', NULL, NULL, 7910, 9),
(260520, NULL, 'PF02335', NULL, NULL, 'Cytochrome c552', NULL, 'Cytochrom_C552', NULL, NULL, 4438, 9),
(260521, NULL, 'PF15160', NULL, NULL, 'Spermatogenesis-associated serine-rich protein 1', NULL, 'SASRP1', NULL, NULL, 21644, 9),
(260522, NULL, 'PF05591', NULL, NULL, 'Type VI secretion system, VipA, VC_A0107 or Hcp2', NULL, 'T6SS_VipA', NULL, NULL, 7536, 9),
(260523, NULL, 'PF06407', NULL, NULL, 'Borna disease virus P40 protein', NULL, 'BDV_P40', NULL, NULL, 8421, 9),
(260524, NULL, 'PF12128', NULL, NULL, 'Protein of unknown function (DUF3584)', NULL, 'DUF3584', NULL, NULL, 20473, 9),
(260525, NULL, 'PF12826', NULL, NULL, 'Helix-hairpin-helix motif', NULL, 'HHH_2', NULL, NULL, 30974, 9),
(260526, NULL, 'PF20414', NULL, NULL, 'Family of unknown function (DUF6698)', NULL, 'DUF6698', NULL, NULL, 37705, 9),
(260527, NULL, 'PF03018', NULL, NULL, 'Dirigent-like protein', NULL, 'Dirigent', NULL, NULL, 3613, 9),
(260528, NULL, 'PF19388', NULL, NULL, 'Family of unknown function (DUF5963)', NULL, 'DUF5963', NULL, NULL, 36990, 9),
(260529, NULL, 'PF05411', NULL, NULL, 'Equine arteritis virus putative proteinase', NULL, 'Peptidase_C32', NULL, NULL, 21631, 9),
(260530, NULL, 'PF00034', NULL, NULL, 'Cytochrome c', NULL, 'Cytochrom_C', NULL, NULL, 6205, 9),
(260531, NULL, 'PF03308', NULL, NULL, 'Methylmalonyl Co-A mutase-associated GTPase MeaB', NULL, 'MeaB', NULL, NULL, NULL, 9),
(260532, NULL, 'PF02774', NULL, NULL, 'Semialdehyde dehydrogenase, dimerisation domain', NULL, 'Semialdhyde_dhC', NULL, NULL, 10403, 9),
(260533, NULL, 'PF00873', NULL, NULL, 'AcrB/AcrD/AcrF family', NULL, 'ACR_tran', NULL, NULL, 2816, 9),
(260534, NULL, 'PF06728', NULL, NULL, 'GPI transamidase subunit PIG-U', NULL, 'PIG-U', NULL, NULL, NULL, 9),
(260535, NULL, 'PF12883', NULL, NULL, 'Protein of unknown function (DUF3828)', NULL, 'DUF3828', NULL, NULL, 13303, 9),
(260536, NULL, 'PF16375', NULL, NULL, 'Domain of unknown function', NULL, 'DUF4986', NULL, NULL, 26148, 9),
(260537, NULL, 'PF03144', NULL, NULL, 'Elongation factor Tu domain 2', NULL, 'GTP_EFTU_D2', NULL, NULL, 2654, 9),
(260538, NULL, 'PF05365', NULL, NULL, 'Ubiquinol-cytochrome C reductase, UQCRX/QCR9 like', NULL, 'UCR_UQCRX_QCR9', NULL, NULL, 5029, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(260539, NULL, 'PF06518', NULL, NULL, 'Protein of unknown function (DUF1104)', NULL, 'DUF1104', NULL, NULL, 9155, 9),
(260540, NULL, 'PF04306', NULL, NULL, 'Protein of unknown function (DUF456)', NULL, 'DUF456', NULL, NULL, 3747, 9),
(260541, NULL, 'PF07477', NULL, NULL, 'Glycosyl hydrolase family 67 C-terminus', NULL, 'Glyco_hydro_67C', NULL, NULL, 11027, 9),
(260542, NULL, 'PF11739', NULL, NULL, 'Dicarboxylate transport', NULL, 'DctA-YdbH', NULL, NULL, 19237, 9),
(260543, NULL, 'PF13189', NULL, NULL, 'Cytidylate kinase-like family', NULL, 'Cytidylate_kin2', NULL, NULL, NULL, 9),
(260544, NULL, 'PF04400', NULL, NULL, '(Na+)-NQR maturation NqrM', NULL, 'NqrM', NULL, NULL, 10174, 9),
(260545, NULL, 'PF15781', NULL, NULL, 'ParE-like toxin of type II bacterial toxin-antitoxin system', NULL, 'ParE-like_toxin', NULL, NULL, 23912, 9),
(260546, NULL, 'PF16202', NULL, NULL, 'N-terminal region of Bloom syndrome protein', NULL, 'BLM_N', NULL, NULL, 26448, 9),
(260547, NULL, 'PF07773', NULL, NULL, 'Tectonic domain DUF1619', NULL, 'TCTN_DUF1619', NULL, NULL, 10794, 9),
(260548, NULL, 'PF17510', NULL, NULL, 'Gene product 44', NULL, 'GP44', NULL, NULL, 17460, 9),
(260549, NULL, 'PF09008', NULL, NULL, 'Head binding', NULL, 'Head_binding', NULL, NULL, 6352, 9),
(260550, NULL, 'PF16234', NULL, NULL, 'Domain of unknown function (DUF4892)', NULL, 'DUF4892', NULL, NULL, 25676, 9),
(260551, NULL, 'PF01302', NULL, NULL, 'CAP-Gly domain', NULL, 'CAP_GLY', NULL, NULL, 3027, 9),
(260552, NULL, 'PF12520', NULL, NULL, 'Protein of unknown function (DUF3723)', NULL, 'DUF3723', NULL, NULL, 21415, 9),
(260553, NULL, 'PF09465', NULL, NULL, 'Lamin-B receptor of TUDOR domain', NULL, 'LBR_tudor', NULL, NULL, 15868, 9),
(260554, NULL, 'PF13056', NULL, NULL, 'Protein of unknown function (DUF3918)', NULL, 'DUF3918', NULL, NULL, 22510, 9),
(260555, NULL, 'PF03962', NULL, NULL, 'Mnd1 HTH domain', NULL, 'Mnd1', NULL, NULL, 27521, 9),
(260556, NULL, 'PF03692', NULL, NULL, 'Putative zinc- or iron-chelating domain', NULL, 'CxxCxxCC', NULL, NULL, 6323, 9),
(260557, NULL, 'PF03947', NULL, NULL, 'Ribosomal Proteins L2, C-terminal domain', NULL, 'Ribosomal_L2_C', NULL, NULL, 16785, 9),
(260558, NULL, 'PF13507', NULL, NULL, 'CobB/CobQ-like glutamine amidotransferase domain', NULL, 'GATase_5', NULL, NULL, NULL, 9),
(260559, NULL, 'PF19583', NULL, NULL, 'ODP family beta lactamase', NULL, 'ODP', NULL, NULL, 34387, 9),
(260560, NULL, 'PF09111', NULL, NULL, 'SLIDE', NULL, 'SLIDE', NULL, NULL, 10630, 9),
(260561, NULL, 'PF14570', NULL, NULL, 'RING/Ubox like zinc-binding domain', NULL, 'zf-RING_4', NULL, NULL, NULL, 9),
(260562, NULL, 'PF16608', NULL, NULL, 'TNRC6-PABC binding domain', NULL, 'TNRC6-PABC_bdg', NULL, NULL, 24459, 9),
(260563, NULL, 'PF15966', NULL, NULL, 'F-box', NULL, 'F-box_4', NULL, NULL, 4804, 9),
(260564, NULL, 'PF09293', NULL, NULL, 'T4 RNase H, C terminal', NULL, 'RNaseH_C', NULL, NULL, 27130, 9),
(260565, NULL, 'PF11841', NULL, NULL, 'ELMO, armadillo-like helical domain', NULL, 'ELMO_ARM', NULL, NULL, 21845, 9),
(260566, NULL, 'PF13933', NULL, NULL, 'Putative peptidase family', NULL, 'HRXXH', NULL, NULL, 26823, 9),
(260567, NULL, 'PF13398', NULL, NULL, 'Peptidase M50B-like', NULL, 'Peptidase_M50B', NULL, NULL, NULL, 9),
(260568, NULL, 'PF19119', NULL, NULL, 'Family of unknown function (DUF5803)', NULL, 'DUF5803', NULL, NULL, 36393, 9),
(260569, NULL, 'PF19969', NULL, NULL, 'vWA-MoxR associated protein middle region (VMAP-M) 8', NULL, 'VMAP-M8', NULL, NULL, 35741, 9),
(260570, NULL, 'PF05234', NULL, NULL, 'UAF complex subunit Rrn10', NULL, 'UAF_Rrn10', NULL, NULL, 17080, 9),
(260571, NULL, 'PF03520', NULL, NULL, 'KCNQ voltage-gated potassium channel', NULL, 'KCNQ_channel', NULL, NULL, 7876, 9),
(260572, NULL, 'PF16058', NULL, NULL, 'Mucin-like', NULL, 'Mucin-like', NULL, NULL, 23180, 9),
(260573, NULL, 'PF11248', NULL, NULL, 'Protein of unknown function (DUF3046)', NULL, 'DUF3046', NULL, NULL, 18451, 9),
(260574, NULL, 'PF12182', NULL, NULL, 'Bacterial lipoprotein', NULL, 'DUF3642', NULL, NULL, 14623, 9),
(260575, NULL, 'PF03912', NULL, NULL, 'Psb28 protein', NULL, 'Psb28', NULL, NULL, 2611, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(260576, NULL, 'PF15195', NULL, NULL, 'TMEM210 family', NULL, 'TMEM210', NULL, NULL, 25678, 9),
(260577, NULL, 'PF12721', NULL, NULL, 'RIP homotypic interaction motif', NULL, 'RHIM', NULL, NULL, 22463, 9),
(260578, NULL, 'PF19128', NULL, NULL, 'Family of unknown function (DUF5811)', NULL, 'DUF5811', NULL, NULL, 35554, 9),
(260579, NULL, 'PF20351', NULL, NULL, 'Family of unknown function (DUF6646)', NULL, 'DUF6646', NULL, NULL, 33853, 9),
(260580, NULL, 'PF18320', NULL, NULL, 'Csc2 Crispr', NULL, 'Csc2', NULL, NULL, 15841, 9),
(260581, NULL, 'PF10784', NULL, NULL, 'Plasmid stability protein', NULL, 'Plasmid_stab_B', NULL, NULL, 20963, 9),
(260582, NULL, 'PF17193', NULL, NULL, 'MukF C-terminal domain', NULL, 'MukF_C', NULL, NULL, 31702, 9),
(260583, NULL, 'PF00330', NULL, NULL, 'Aconitase family (aconitate hydratase)', NULL, 'Aconitase', NULL, NULL, 4217, 9),
(260584, NULL, 'PF20593', NULL, NULL, 'Family of unknown function (DUF6793)', NULL, 'DUF6793', NULL, NULL, 37425, 9),
(260585, NULL, 'PF16286', NULL, NULL, 'Domain of unknown function (DUF4932)', NULL, 'DUF4932', NULL, NULL, 21603, 9),
(260586, NULL, 'PF01274', NULL, NULL, 'Malate synthase', NULL, 'Malate_synthase', NULL, NULL, 6273, 9),
(260587, NULL, 'PF19941', NULL, NULL, 'Family of unknown function (DUF6403)', NULL, 'DUF6403', NULL, NULL, 36221, 9),
(260588, NULL, 'PF01816', NULL, NULL, 'Leucine rich repeat variant', NULL, 'LRV', NULL, NULL, 4053, 9),
(260589, NULL, 'PF16127', NULL, NULL, 'Domain of unknown function (DUF4839)', NULL, 'DUF4839', NULL, NULL, 25175, 9),
(260590, NULL, 'PF03552', NULL, NULL, 'Cellulose synthase', NULL, 'Cellulose_synt', NULL, NULL, 4118, 9),
(260591, NULL, 'PF18287', NULL, NULL, 'Integron Cassette Protein Hfx_Cass5', NULL, 'Hfx_Cass5', NULL, NULL, 29301, 9),
(260592, NULL, 'PF10211', NULL, NULL, 'Axonemal dynein light chain', NULL, 'Ax_dynein_light', NULL, NULL, 15540, 9),
(260593, NULL, 'PF20464', NULL, NULL, 'MmeI, N-terminal domain', NULL, 'MmeI_N', NULL, NULL, 33761, 9),
(260594, NULL, 'PF00079', NULL, NULL, 'Serpin (serine protease inhibitor)', NULL, 'Serpin', NULL, NULL, 16863, 9),
(260595, NULL, 'PF18498', NULL, NULL, 'Domain of unknown function (DUF5618)', NULL, 'DUF5618', NULL, NULL, 28721, 9),
(260596, NULL, 'PF15176', NULL, NULL, 'Leucine-rich repeat family 19 TM domain', NULL, 'LRR19-TM', NULL, NULL, NULL, 9),
(260597, NULL, 'PF03480', NULL, NULL, 'Bacterial extracellular solute-binding protein, family 7', NULL, 'DctP', NULL, NULL, 20315, 9),
(260598, NULL, 'PF03248', NULL, NULL, 'Rer1 family', NULL, 'Rer1', NULL, NULL, 1588, 9),
(260599, NULL, 'PF10233', NULL, NULL, 'Uncharacterized conserved protein CG6151-P', NULL, 'Cg6151-P', NULL, NULL, 15660, 9),
(260600, NULL, 'PF10676', NULL, NULL, 'Spore germination protein gerPA/gerPF', NULL, 'gerPA', NULL, NULL, 20183, 9),
(260601, NULL, 'PF17107', NULL, NULL, 'N-terminal domain on NACHT_NTPase and P-loop NTPases', NULL, 'SesA', NULL, NULL, 2872, 9),
(260602, NULL, 'PF11166', NULL, NULL, 'Protein of unknown function (DUF2951)', NULL, 'DUF2951', NULL, NULL, 18125, 9),
(260603, NULL, 'PF17645', NULL, NULL, 'Arylmalonate decarboxylase', NULL, 'Amdase', NULL, NULL, 24981, 9),
(260604, NULL, 'PF10685', NULL, NULL, 'Stress-induced bacterial acidophilic repeat motif', NULL, 'KGG', NULL, NULL, 20570, 9),
(260605, NULL, 'PF04815', NULL, NULL, 'Sec23/Sec24 helical domain', NULL, 'Sec23_helical', NULL, NULL, 4744, 9),
(260606, NULL, 'PF02132', NULL, NULL, 'RecR protein', NULL, 'RecR', NULL, NULL, 14830, 9),
(260607, NULL, 'PF18787', NULL, NULL, 'CRM1 / Exportin repeat 3', NULL, 'CRM1_repeat_3', NULL, NULL, 27888, 9),
(260608, NULL, 'PF06983', NULL, NULL, '3-demethylubiquinone-9 3-methyltransferase', NULL, '3-dmu-9_3-mt', NULL, NULL, 26569, 9),
(260609, NULL, 'PF02724', NULL, NULL, 'CDC45-like protein', NULL, 'CDC45', NULL, NULL, 4342, 9),
(260610, NULL, 'PF00580', NULL, NULL, 'UvrD/REP helicase N-terminal domain', NULL, 'UvrD-helicase', NULL, NULL, 9452, 9),
(260611, NULL, 'PF01810', NULL, NULL, 'LysE type translocator', NULL, 'LysE', NULL, NULL, 1116, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(260612, NULL, 'PF10999', NULL, NULL, 'Protein of unknown function (DUF2839)', NULL, 'DUF2839', NULL, NULL, 17814, 9),
(260613, NULL, 'PF08150', NULL, NULL, 'FerB (NUC096) domain', NULL, 'FerB', NULL, NULL, 9019, 9),
(260614, NULL, 'PF02840', NULL, NULL, 'Prp18 domain', NULL, 'Prp18', NULL, NULL, 1557, 9),
(260615, NULL, 'PF16774', NULL, NULL, 'Baseplate protein', NULL, 'Baseplate', NULL, NULL, 23687, 9),
(260616, NULL, 'PF01499', NULL, NULL, 'Herpesvirus UL25 family', NULL, 'Herpes_UL25', NULL, NULL, 854, 9),
(260617, NULL, 'PF17646', NULL, NULL, 'Closterovirus 1a polyprotein central region', NULL, 'Zemlya', NULL, NULL, 28761, 9),
(260618, NULL, 'PF13337', NULL, NULL, 'Lon-like protease BrxL-like, ATPase domain', NULL, 'BrxL_ATPase', NULL, NULL, 13212, 9),
(260619, NULL, 'PF04681', NULL, NULL, 'Blastomyces yeast-phase-specific protein', NULL, 'Bys1', NULL, NULL, 3430, 9),
(260620, NULL, 'PF13417', NULL, NULL, 'Glutathione S-transferase, N-terminal domain', NULL, 'GST_N_3', NULL, NULL, 978, 9),
(260621, NULL, 'PF16485', NULL, NULL, 'Protealysin propeptide', NULL, 'PLN_propep', NULL, NULL, 21944, 9),
(260622, NULL, 'PF19895', NULL, NULL, 'Family of unknown function (DUF6368)', NULL, 'DUF6368', NULL, NULL, 36870, 9),
(260623, NULL, 'PF03685', NULL, NULL, 'Uncharacterised protein family (UPF0147)', NULL, 'UPF0147', NULL, NULL, 6315, 9),
(260624, NULL, 'PF07056', NULL, NULL, 'Protein of unknown function (DUF1335)', NULL, 'DUF1335', NULL, NULL, 12640, 9),
(260625, NULL, 'PF19956', NULL, NULL, 'Effector-associated domain 2', NULL, 'EAD2', NULL, NULL, 35773, 9),
(260626, NULL, 'PF07403', NULL, NULL, 'Protein of unknown function (DUF1505)', NULL, 'DUF1505', NULL, NULL, 8051, 9),
(260627, NULL, 'PF13952', NULL, NULL, 'Domain of unknown function (DUF4216)', NULL, 'DUF4216', NULL, NULL, 22430, 9),
(260628, NULL, 'PF00359', NULL, NULL, 'Phosphoenolpyruvate-dependent sugar phosphotransferase system, EIIA 2', NULL, 'PTS_EIIA_2', NULL, NULL, 5869, 9),
(260629, NULL, 'PF15788', NULL, NULL, 'Domain of unknown function (DUF4705)', NULL, 'DUF4705', NULL, NULL, 23506, 9),
(260630, NULL, 'PF16464', NULL, NULL, 'Domain of unknown function (DUF5045)', NULL, 'DUF5045', NULL, NULL, 21838, 9),
(260631, NULL, 'PF14091', NULL, NULL, 'Domain of unknown function (DUF4269)', NULL, 'DUF4269', NULL, NULL, 22661, 9),
(260632, NULL, 'PF18249', NULL, NULL, 'Calcium binding protein SSO6904', NULL, 'Ca_bind_SSO6904', NULL, NULL, 27910, 9),
(260633, NULL, 'PF16969', NULL, NULL, 'RNA-binding signal recognition particle 68', NULL, 'SRP68', NULL, NULL, 26153, 9),
(260634, NULL, 'PF00670', NULL, NULL, 'S-adenosyl-L-homocysteine hydrolase, NAD binding domain', NULL, 'AdoHcyase_NAD', NULL, NULL, 7164, 9),
(260635, NULL, 'PF05161', NULL, NULL, 'MOFRL family', NULL, 'MOFRL', NULL, NULL, 2178, 9),
(260636, NULL, 'PF15419', NULL, NULL, 'Leukemia NUP98 fusion partner 1', NULL, 'LNP1', NULL, NULL, 26319, 9),
(260637, NULL, 'PF01104', NULL, NULL, 'Bunyavirus non-structural protein NS-s', NULL, 'Bunya_NS-S', NULL, NULL, 6618, 9),
(260638, NULL, 'PF04847', NULL, NULL, 'Calcipressin', NULL, 'Calcipressin', NULL, NULL, 5412, 9),
(260639, NULL, 'PF08439', NULL, NULL, 'Oligopeptidase F', NULL, 'Peptidase_M3_N', NULL, NULL, 11811, 9),
(260640, NULL, 'PF10683', NULL, NULL, 'Hermes transposase DNA-binding domain', NULL, 'DBD_Tnp_Hermes', NULL, NULL, 21202, 9),
(260641, NULL, 'PF06780', NULL, NULL, 'Erp protein C-terminus', NULL, 'Erp_C', NULL, NULL, 1571, 9),
(260642, NULL, 'PF19446', NULL, NULL, 'Family of unknown function (DUF5984)', NULL, 'DUF5984', NULL, NULL, 36957, 9),
(260643, NULL, 'PF11595', NULL, NULL, 'Protein of unknown function (DUF3245)', NULL, 'DUF3245', NULL, NULL, 18897, 9),
(260644, NULL, 'PF16632', NULL, NULL, 'C-terminal region of Caskin', NULL, 'Caskin-tail', NULL, NULL, 25883, 9),
(260645, NULL, 'PF01059', NULL, NULL, 'NADH-ubiquinone oxidoreductase chain 4, amino terminus', NULL, 'Oxidored_q5_N', NULL, NULL, 4822, 9),
(260646, NULL, 'PF16225', NULL, NULL, 'Domain of unknown function (DUF4884)', NULL, 'DUF4884', NULL, NULL, 26110, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(260647, NULL, 'PF10988', NULL, NULL, 'Putative auto-transporter adhesin, head GIN domain', NULL, 'DUF2807', NULL, NULL, 17962, 9),
(260648, NULL, 'PF03447', NULL, NULL, 'Homoserine dehydrogenase, NAD binding domain', NULL, 'NAD_binding_3', NULL, NULL, 10810, 9),
(260649, NULL, 'PF07613', NULL, NULL, 'Protein of unknown function (DUF1576)', NULL, 'DUF1576', NULL, NULL, 13578, 9),
(260650, NULL, 'PF08183', NULL, NULL, 'Stage V sporulation protein family', NULL, 'SpoV', NULL, NULL, 9587, 9),
(260651, NULL, 'PF13339', NULL, NULL, 'Apoptosis antagonizing transcription factor', NULL, 'AATF-Che1', NULL, NULL, 26208, 9),
(260652, NULL, 'PF13651', NULL, NULL, 'Adenine-specific methyltransferase EcoRI', NULL, 'EcoRI_methylase', NULL, NULL, 25597, 9),
(260653, NULL, 'PF14621', NULL, NULL, 'RFX5 DNA-binding domain', NULL, 'RFX5_DNA_bdg', NULL, NULL, 26909, 9),
(260654, NULL, 'PF18786', NULL, NULL, 'Importin 13 repeat', NULL, 'Importin_rep_2', NULL, NULL, 29123, 9),
(260655, NULL, 'PF08632', NULL, NULL, 'Activator of mitotic machinery Cdc14 phosphatase activation C-term', NULL, 'Zds_C', NULL, NULL, 14381, 9),
(260656, NULL, 'PF13896', NULL, NULL, 'Glycosyl-transferase for dystroglycan', NULL, 'Glyco_transf_49', NULL, NULL, NULL, 9),
(260657, NULL, 'PF17414', NULL, NULL, 'MatP C-terminal ribbon-helix-helix domain', NULL, 'MatP_C', NULL, NULL, 9588, 9),
(260658, NULL, 'PF12279', NULL, NULL, 'Protein of unknown function (DUF3619)', NULL, 'DUF3619', NULL, NULL, 20685, 9),
(260659, NULL, 'PF18251', NULL, NULL, 'Fungal defensin Copsin', NULL, 'Defensin_5', NULL, NULL, 29010, 9),
(260660, NULL, 'PF15119', NULL, NULL, 'Apolipoprotein C4', NULL, 'APOC4', NULL, NULL, 25544, 9),
(260661, NULL, 'PF12079', NULL, NULL, 'Protein of unknown function (DUF3558)', NULL, 'DUF3558', NULL, NULL, 24744, 9),
(260662, NULL, 'PF02491', NULL, NULL, 'SHS2 domain inserted in FTSA', NULL, 'SHS2_FTSA', NULL, NULL, 6312, 9),
(260663, NULL, 'PF00199', NULL, NULL, 'Catalase', NULL, 'Catalase', NULL, NULL, 12342, 9),
(260664, NULL, 'PF08429', NULL, NULL, 'PLU-1-like protein', NULL, 'PLU-1', NULL, NULL, 12592, 9),
(260665, NULL, 'PF18834', NULL, NULL, 'Large polyvalent protein associated domain 22', NULL, 'LPD22', NULL, NULL, 28469, 9),
(260666, NULL, 'PF10461', NULL, NULL, 'Peptidase S68', NULL, 'Peptidase_S68', NULL, NULL, 18100, 9),
(260667, NULL, 'PF10429', NULL, NULL, 'Nuclear pore RNA shuttling protein Mtr2', NULL, 'Mtr2', NULL, NULL, 18485, 9),
(260668, NULL, 'PF12134', NULL, NULL, 'PRP8 domain IV core', NULL, 'PRP8_domainIV', NULL, NULL, 20495, 9),
(260669, NULL, 'PF10101', NULL, NULL, 'Predicted membrane protein (DUF2339)', NULL, 'DUF2339', NULL, NULL, 19863, 9),
(260670, NULL, 'PF08485', NULL, NULL, 'Polysaccharide biosynthesis protein C-terminal', NULL, 'Polysacc_syn_2C', NULL, NULL, 13564, 9),
(260671, NULL, 'PF11728', NULL, NULL, 'Putative aromatic acid exporter C-terminal domain', NULL, 'ArAE_1_C', NULL, NULL, 15295, 9),
(260672, NULL, 'PF17097', NULL, NULL, 'Spindle pole body component', NULL, 'Kre28', NULL, NULL, 23577, 9),
(260673, NULL, 'PF17805', NULL, NULL, 'AsnC-like ligand binding domain', NULL, 'AsnC_trans_reg2', NULL, NULL, 31793, 9),
(260674, NULL, 'PF08735', NULL, NULL, 'Putative pyruvate format-lyase activating enzyme (DUF1786)', NULL, 'DUF1786', NULL, NULL, 11849, 9),
(260675, NULL, 'PF04506', NULL, NULL, 'Rft protein', NULL, 'Rft-1', NULL, NULL, 2712, 9),
(260676, NULL, 'PF04744', NULL, NULL, 'Monooxygenase subunit B protein', NULL, 'Monooxygenase_B', NULL, NULL, 3916, 9),
(260677, NULL, 'PF20258', NULL, NULL, 'Aminomethyltransferase beta-barrel domain', NULL, 'tRNA_Me_trans_C', NULL, NULL, 36605, 9),
(260678, NULL, 'PF04864', NULL, NULL, 'Allinase', NULL, 'Alliinase_C', NULL, NULL, 5882, 9),
(260679, NULL, 'PF20598', NULL, NULL, 'Domain of unknown function (DUF6795)', NULL, 'DUF6795', NULL, NULL, 37634, 9),
(260680, NULL, 'PF16739', NULL, NULL, 'Caspase recruitment domain', NULL, 'CARD_2', NULL, NULL, 22974, 9),
(260681, NULL, 'PF06546', NULL, NULL, 'Vertebrate heat shock transcription factor', NULL, 'Vert_HS_TF', NULL, NULL, 14392, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(260682, NULL, 'PF10439', NULL, NULL, 'Bacteriocin class II with double-glycine leader peptide', NULL, 'Bacteriocin_IIc', NULL, NULL, 18492, 9),
(260683, NULL, 'PF04129', NULL, NULL, 'Vps52 / Sac2 family', NULL, 'Vps52', NULL, NULL, 6764, 9),
(260684, NULL, 'PF16652', NULL, NULL, 'Pleckstrin homology domain', NULL, 'PH_13', NULL, NULL, 1423, 9),
(260685, NULL, 'PF02354', NULL, NULL, 'Latrophilin Cytoplasmic C-terminal region', NULL, 'Latrophilin', NULL, NULL, 4086, 9),
(260686, NULL, 'PF10422', NULL, NULL, 'Monopolin complex subunit LRS4', NULL, 'LRS4', NULL, NULL, 21326, 9),
(260687, NULL, 'PF12540', NULL, NULL, 'Protein of unknown function (DUF3736)', NULL, 'DUF3736', NULL, NULL, 21071, 9),
(260688, NULL, 'PF18429', NULL, NULL, 'Domain of unknown function (DUF5609)', NULL, 'DUF5609', NULL, NULL, 29499, 9),
(260689, NULL, 'PF19663', NULL, NULL, 'Family of unknown function (DUF6166)', NULL, 'DUF6166', NULL, NULL, 37307, 9),
(260690, NULL, 'PF14402', NULL, NULL, '7 transmembrane helices usually fused to an inactive transglutaminase', NULL, '7TM_transglut', NULL, NULL, 24010, 9),
(260691, NULL, 'PF12814', NULL, NULL, 'Meiotic cell cortex C-terminal pleckstrin homology', NULL, 'Mcp5_PH', NULL, NULL, 23930, 9),
(260692, NULL, 'PF13020', NULL, NULL, 'Protein NO VEIN, C-terminal', NULL, 'NOV_C', NULL, NULL, 22013, 9),
(260693, NULL, 'PF04912', NULL, NULL, 'Dynamitin', NULL, 'Dynamitin', NULL, NULL, 25453, 9),
(260694, NULL, 'PF05720', NULL, NULL, 'Cell-cell adhesion domain', NULL, 'Dicty_CAD', NULL, NULL, 14382, 9),
(260695, NULL, 'PF15980', NULL, NULL, 'Putative Competence protein ComGF', NULL, 'ComGF', NULL, NULL, 17827, 9),
(260696, NULL, 'PF17154', NULL, NULL, 'Gammaproteobacterial periplasmic sensor domain', NULL, 'GAPES3', NULL, NULL, 30602, 9),
(260697, NULL, 'PF14280', NULL, NULL, 'Domain of unknown function (DUF4365)', NULL, 'DUF4365', NULL, NULL, 21787, 9),
(260698, NULL, 'PF13007', NULL, NULL, 'Transposase C of IS166 homeodomain', NULL, 'LZ_Tnp_IS66', NULL, NULL, 22553, 9),
(260699, NULL, 'PF14572', NULL, NULL, 'Phosphoribosyl synthetase-associated domain', NULL, 'Pribosyl_synth', NULL, NULL, 231, 9),
(260700, NULL, 'PF15457', NULL, NULL, 'Type III T3SS secreted effector HopW1-1/HopPmaA', NULL, 'HopW1-1', NULL, NULL, 24772, 9),
(260701, NULL, 'PF04325', NULL, NULL, 'Protein of unknown function (DUF465)', NULL, 'DUF465', NULL, NULL, 3857, 9),
(260702, NULL, 'PF06486', NULL, NULL, 'Protein of unknown function (DUF1093)', NULL, 'DUF1093', NULL, NULL, 363, 9),
(260703, NULL, 'PF10498', NULL, NULL, 'Intra-flagellar transport protein 57', NULL, 'IFT57', NULL, NULL, 19381, 9),
(260704, NULL, 'PF09446', NULL, NULL, 'VMA21-like domain', NULL, 'VMA21', NULL, NULL, 15605, 9),
(260705, NULL, 'PF16541', NULL, NULL, 'Alternaria alternata allergen 1', NULL, 'AltA1', NULL, NULL, 25058, 9),
(260706, NULL, 'PF01215', NULL, NULL, 'Cytochrome c oxidase subunit Vb', NULL, 'COX5B', NULL, NULL, 5450, 9),
(260707, NULL, 'PF06926', NULL, NULL, 'Putative replisome organiser protein C-terminus', NULL, 'Rep_Org_C', NULL, NULL, 11848, 9),
(260708, NULL, 'PF08544', NULL, NULL, 'GHMP kinases C terminal', NULL, 'GHMP_kinases_C', NULL, NULL, 7670, 9),
(260709, NULL, 'PF19790', NULL, NULL, 'Family of unknown function (DUF6274)', NULL, 'DUF6274', NULL, NULL, 37323, 9),
(260710, NULL, 'PF09453', NULL, NULL, 'HIRA B motif', NULL, 'HIRA_B', NULL, NULL, 15576, 9),
(260711, NULL, 'PF15043', NULL, NULL, 'CB1 cannabinoid receptor-interacting protein 1', NULL, 'CNRIP1', NULL, NULL, 26950, 9),
(260712, NULL, 'PF17599', NULL, NULL, 'Family of unknown function (DUF5495)', NULL, 'DUF5495', NULL, NULL, 20077, 9),
(260713, NULL, 'PF11598', NULL, NULL, 'Cartilage oligomeric matrix protein', NULL, 'COMP', NULL, NULL, 21491, 9),
(260714, NULL, 'PF18268', NULL, NULL, 'Hit1 C-terminal', NULL, 'Hit1_C', NULL, NULL, 27538, 9),
(260715, NULL, 'PF12322', NULL, NULL, 'T4 bacteriophage base plate protein', NULL, 'T4_baseplate', NULL, NULL, 22338, 9),
(260716, NULL, 'PF19903', NULL, NULL, 'Family of unknown function (DUF6376)', NULL, 'DUF6376', NULL, NULL, 36800, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(260717, NULL, 'PF07624', NULL, NULL, 'Protein of unknown function (DUF1585)', NULL, 'PSD2', NULL, NULL, 13527, 9),
(260718, NULL, 'PF12442', NULL, NULL, 'Protein of unknown function (DUF3681)', NULL, 'DUF3681', NULL, NULL, 20973, 9),
(260719, NULL, 'PF08711', NULL, NULL, 'TFIIS helical bundle-like domain', NULL, 'Med26', NULL, NULL, 2622, 9),
(260720, NULL, 'PF09670', NULL, NULL, 'CRISPR-associated protein (Cas_Cas02710)', NULL, 'Cas_Cas02710', NULL, NULL, NULL, 9),
(260721, NULL, 'PF20624', NULL, NULL, 'DMRT5, DMB domain', NULL, 'DMRT5_DMB', NULL, NULL, 33669, 9),
(260722, NULL, 'PF14544', NULL, NULL, 'Domain of unknown function (DUF4443)', NULL, 'DUF4443', NULL, NULL, 23943, 9),
(260723, NULL, 'PF17575', NULL, NULL, 'Family of unknown function (DUF5479)', NULL, 'DUF5479', NULL, NULL, 30871, 9),
(260724, NULL, 'PF00818', NULL, NULL, 'Ice nucleation protein repeat', NULL, 'Ice_nucleation', NULL, NULL, 4622, 9),
(260725, NULL, 'PF04707', NULL, NULL, 'PRELI-like family', NULL, 'PRELI', NULL, NULL, 3519, 9),
(260726, NULL, 'PF10781', NULL, NULL, 'Dextransucrase DSRB', NULL, 'DSRB', NULL, NULL, 20591, 9),
(260727, NULL, 'PF15361', NULL, NULL, 'Resistance to inhibitors of cholinesterase homologue 3', NULL, 'RIC3', NULL, NULL, 22052, 9),
(260728, NULL, 'PF16852', NULL, NULL, 'Herpes viral adaptor-to-host cellular mRNA binding domain', NULL, 'HHV-1_VABD', NULL, NULL, 22900, 9),
(260729, NULL, 'PF01168', NULL, NULL, 'Alanine racemase, N-terminal domain', NULL, 'Ala_racemase_N', NULL, NULL, 5213, 9),
(260730, NULL, 'PF15360', NULL, NULL, 'APJ endogenous ligand', NULL, 'Apelin', NULL, NULL, 23080, 9),
(260731, NULL, 'PF16311', NULL, NULL, 'Transmembrane protein 100', NULL, 'TMEM100', NULL, NULL, 25672, 9),
(260732, NULL, 'PF15555', NULL, NULL, 'Domain of unknown function (DUF4658)', NULL, 'DUF4658', NULL, NULL, 24929, 9),
(260733, NULL, 'PF18167', NULL, NULL, 'SMODS-associated NUDIX domain', NULL, 'Sa_NUDIX', NULL, NULL, 32381, 9),
(260734, NULL, 'PF11794', NULL, NULL, '4-hydroxyphenylacetate 3-hydroxylase N terminal', NULL, 'HpaB_N', NULL, NULL, 21357, 9),
(260735, NULL, 'PF08690', NULL, NULL, 'GET complex subunit GET2', NULL, 'GET2', NULL, NULL, 21659, 9),
(260736, NULL, 'PF04413', NULL, NULL, '3-Deoxy-D-manno-octulosonic-acid transferase (kdotransferase)', NULL, 'Glycos_transf_N', NULL, NULL, 10261, 9),
(260737, NULL, 'PF02732', NULL, NULL, 'ERCC4 domain', NULL, 'ERCC4', NULL, NULL, 10492, 9),
(260738, NULL, 'PF20122', NULL, NULL, 'Family of unknown function (DUF6512)', NULL, 'DUF6512', NULL, NULL, 35995, 9),
(260739, NULL, 'PF08363', NULL, NULL, 'Glucan-binding protein C', NULL, 'GbpC', NULL, NULL, 11738, 9),
(260740, NULL, 'PF09549', NULL, NULL, 'Bpu10I restriction endonuclease', NULL, 'RE_Bpu10I', NULL, NULL, 15227, 9),
(260741, NULL, 'PF12210', NULL, NULL, 'Hepatocyte growth factor-regulated tyrosine kinase substrate', NULL, 'Hrs_helical', NULL, NULL, 4182, 9),
(260742, NULL, 'PF17026', NULL, NULL, 'Putative ribonucleoprotein zinc-finger pf C4 type', NULL, 'zf-RRPl_C4', NULL, NULL, 22741, 9),
(260743, NULL, 'PF14119', NULL, NULL, 'Domain of unknown function (DUF4288)', NULL, 'DUF4288', NULL, NULL, 24783, 9),
(260744, NULL, 'PF03938', NULL, NULL, 'Outer membrane protein (OmpH-like)', NULL, 'OmpH', NULL, NULL, 2735, 9),
(260745, NULL, 'PF19479', NULL, NULL, 'Family of unknown function (DUF6015)', NULL, 'DUF6015', NULL, NULL, 36656, 9),
(260746, NULL, 'PF05033', NULL, NULL, 'Pre-SET motif', NULL, 'Pre-SET', NULL, NULL, 1187, 9),
(260747, NULL, 'PF13245', NULL, NULL, 'AAA domain', NULL, 'AAA_19', NULL, NULL, NULL, 9),
(260748, NULL, 'PF10602', NULL, NULL, '26S proteasome subunit RPN7', NULL, 'RPN7', NULL, NULL, 36585, 9),
(260749, NULL, 'PF14021', NULL, NULL, 'Tuberculosis necrotizing toxin', NULL, 'TNT', NULL, NULL, 22089, 9),
(260750, NULL, 'PF19574', NULL, NULL, 'Outer membrane lipoprotein carrier protein LolA-like', NULL, 'LolA_3', NULL, NULL, 617, 9),
(260751, NULL, 'PF20220', NULL, NULL, 'ABC toxin N-terminal region', NULL, 'ABC_toxin_N', NULL, NULL, 33969, 9),
(260752, NULL, 'PF13079', NULL, NULL, 'Protein of unknown function (DUF3916)', NULL, 'DUF3916', NULL, NULL, 22571, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(260753, NULL, 'PF15075', NULL, NULL, 'Domain of unknown function (DUF4542)', NULL, 'DUF4542', NULL, NULL, 23761, 9),
(260754, NULL, 'PF19837', NULL, NULL, 'Domain of unknown function (DUF6316)', NULL, 'DUF6316', NULL, NULL, 37304, 9),
(260755, NULL, 'PF16506', NULL, NULL, 'Putative virion glycoprotein of insect viruses', NULL, 'DiSB-ORF2_chro', NULL, NULL, 25104, 9),
(260756, NULL, 'PF07904', NULL, NULL, 'Chromatin modification-related protein EAF7', NULL, 'Eaf7', NULL, NULL, 13274, 9),
(260757, NULL, 'PF12781', NULL, NULL, 'ATP-binding dynein motor region', NULL, 'AAA_9', NULL, NULL, 28656, 9),
(260758, NULL, 'PF08311', NULL, NULL, 'Mad3/BUB1 homology region 1', NULL, 'Mad3_BUB1_I', NULL, NULL, 17779, 9),
(260759, NULL, 'PF13702', NULL, NULL, 'Lysozyme-like', NULL, 'Lysozyme_like', NULL, NULL, NULL, 9),
(260760, NULL, 'PF20033', NULL, NULL, 'Domain of unknown function (DUF6438)', NULL, 'DUF6438', NULL, NULL, 36459, 9),
(260761, NULL, 'PF19943', NULL, NULL, 'Family of unknown function (DUF6405)', NULL, 'DUF6405', NULL, NULL, 36041, 9),
(260762, NULL, 'PF10154', NULL, NULL, 'Uncharacterised conserved protein (DUF2362)', NULL, 'DUF2362', NULL, NULL, 14950, 9),
(260763, NULL, 'PF18710', NULL, NULL, 'ComR tetratricopeptide', NULL, 'ComR_TPR', NULL, NULL, 29042, 9),
(260764, NULL, 'PF08444', NULL, NULL, 'Aralkyl acyl-CoA:amino acid N-acyltransferase, C-terminal region', NULL, 'Gly_acyl_tr_C', NULL, NULL, 11572, 9),
(260765, NULL, 'PF18872', NULL, NULL, 'Daz repeat', NULL, 'Daz', NULL, NULL, 35501, 9),
(260766, NULL, 'PF15004', NULL, NULL, 'Myeloma-overexpressed-like', NULL, 'MYEOV2', NULL, NULL, 23160, 9),
(260767, NULL, 'PF01719', NULL, NULL, 'Plasmid replication protein', NULL, 'Rep_2', NULL, NULL, 2590, 9),
(260768, NULL, 'PF00849', NULL, NULL, 'RNA pseudouridylate synthase', NULL, 'PseudoU_synth_2', NULL, NULL, 11240, 9),
(260769, NULL, 'PF17763', NULL, NULL, 'Glutaminase/Asparaginase C-terminal domain', NULL, 'Asparaginase_C', NULL, NULL, 27672, 9),
(260770, NULL, 'PF13443', NULL, NULL, 'Cro/C1-type HTH DNA-binding domain', NULL, 'HTH_26', NULL, NULL, 2217, 9),
(260771, NULL, 'PF00925', NULL, NULL, 'GTP cyclohydrolase II', NULL, 'GTP_cyclohydro2', NULL, NULL, 18120, 9),
(260772, NULL, 'PF11582', NULL, NULL, 'Protein of unknown function (DUF3240)', NULL, 'DUF3240', NULL, NULL, 18768, 9),
(260773, NULL, 'PF05031', NULL, NULL, 'Iron Transport-associated domain', NULL, 'NEAT', NULL, NULL, 1008, 9),
(260774, NULL, 'PF10444', NULL, NULL, 'Nbl1 / Borealin N terminal', NULL, 'Nbl1_Borealin_N', NULL, NULL, 20255, 9),
(260775, NULL, 'PF16776', NULL, NULL, 'Type II inositol 1,4,5-trisphosphate 5-phosphatase PH domain', NULL, 'INPP5B_PH', NULL, NULL, 23634, 9),
(260776, NULL, 'PF07701', NULL, NULL, 'Heme NO binding associated', NULL, 'HNOBA', NULL, NULL, 10739, 9),
(260777, NULL, 'PF15068', NULL, NULL, 'FAM101 family', NULL, 'FAM101', NULL, NULL, 22271, 9),
(260778, NULL, 'PF01858', NULL, NULL, 'Retinoblastoma-associated protein A domain', NULL, 'RB_A', NULL, NULL, 3791, 9),
(260779, NULL, 'PF13513', NULL, NULL, 'HEAT-like repeat', NULL, 'HEAT_EZ', NULL, NULL, NULL, 9),
(260780, NULL, 'PF12139', NULL, NULL, 'Adenosine-5''-phosphosulfate reductase beta subunit', NULL, 'APS-reductase_C', NULL, NULL, 16672, 9),
(260781, NULL, 'PF12984', NULL, NULL, 'Domain of unknown function, B. Theta Gene description (DUF3868)', NULL, 'DUF3868', NULL, NULL, 22986, 9),
(260782, NULL, 'PF12670', NULL, NULL, 'Protein of unknown function (DUF3792)', NULL, 'DUF3792', NULL, NULL, 11215, 9),
(260783, NULL, 'PF05645', NULL, NULL, 'RNA polymerase III subunit RPC82', NULL, 'RNA_pol_Rpc82', NULL, NULL, 13684, 9),
(260784, NULL, 'PF12280', NULL, NULL, 'Brain specific membrane anchored protein', NULL, 'BSMAP', NULL, NULL, 20788, 9),
(260785, NULL, 'PF01504', NULL, NULL, 'Phosphatidylinositol-4-phosphate 5-Kinase', NULL, 'PIP5K', NULL, NULL, 614, 9),
(260786, NULL, 'PF03718', NULL, NULL, 'Glycosyl hydrolase family 49', NULL, 'Glyco_hydro_49', NULL, NULL, 5155, 9),
(260787, NULL, 'PF03617', NULL, NULL, 'IBV 3A protein', NULL, 'IBV_3A', NULL, NULL, 5062, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(260788, NULL, 'PF05515', NULL, NULL, 'Viral nucleic acid binding', NULL, 'Viral_NABP', NULL, NULL, 7568, 9),
(260789, NULL, 'PF00504', NULL, NULL, 'Chlorophyll A-B binding protein', NULL, 'Chloroa_b-bind', NULL, NULL, 17470, 9),
(260790, NULL, 'PF01202', NULL, NULL, 'Shikimate kinase', NULL, 'SKI', NULL, NULL, 21608, 9),
(260791, NULL, 'PF06297', NULL, NULL, 'PET Domain', NULL, 'PET', NULL, NULL, 10240, 9),
(260792, NULL, 'PF08203', NULL, NULL, 'Yeast RNA polymerase I subunit RPA14', NULL, 'RNA_polI_A14', NULL, NULL, 12597, 9),
(260793, NULL, 'PF08440', NULL, NULL, 'Potyviridae polyprotein', NULL, 'Poty_PP', NULL, NULL, 11939, 9),
(260794, NULL, 'PF07110', NULL, NULL, 'EthD domain', NULL, 'EthD', NULL, NULL, 13130, 9),
(260795, NULL, 'PF11250', NULL, NULL, 'Fantastic Four meristem regulator', NULL, 'FAF', NULL, NULL, 35410, 9),
(260796, NULL, 'PF19189', NULL, NULL, 'Mtf2 family', NULL, 'Mtf2', NULL, NULL, 35969, 9),
(260797, NULL, 'PF09027', NULL, NULL, 'GTPase binding', NULL, 'GTPase_binding', NULL, NULL, 9692, 9),
(260798, NULL, 'PF02199', NULL, NULL, 'Saposin A-type domain', NULL, 'SapA', NULL, NULL, 1591, 9),
(260799, NULL, 'PF17174', NULL, NULL, 'Domain of unknown function (DUF5130)', NULL, 'DUF5130', NULL, NULL, 31434, 9),
(260800, NULL, 'PF15306', NULL, NULL, 'LIN37', NULL, 'LIN37', NULL, NULL, 22612, 9),
(260801, NULL, 'PF19551', NULL, NULL, 'Family of unknown function (DUF6074)', NULL, 'DUF6074', NULL, NULL, 34037, 9),
(260802, NULL, 'PF12961', NULL, NULL, 'Domain of unknown function (DUF3850)', NULL, 'DUF3850', NULL, NULL, 30994, 9),
(260803, NULL, 'PF17569', NULL, NULL, 'Family of unknown function (DUF5475)', NULL, 'DUF5475', NULL, NULL, 13904, 9),
(260804, NULL, 'PF09804', NULL, NULL, 'DENN domain-containing protein 11', NULL, 'DENND11', NULL, NULL, 16384, 9),
(260805, NULL, 'PF13815', NULL, NULL, 'Iguana/Dzip1-like DAZ-interacting protein N-terminal', NULL, 'Dzip-like_N', NULL, NULL, 26609, 9),
(260806, NULL, 'PF18034', NULL, NULL, 'Bacterial Glycosyl hydrolase family 3 C-terminal domain', NULL, 'Bac_GH3_C', NULL, NULL, 29993, 9),
(260807, NULL, 'PF00684', NULL, NULL, 'DnaJ central domain', NULL, 'DnaJ_CXXCXGXG', NULL, NULL, 188, 9),
(260808, NULL, 'PF07407', NULL, NULL, 'Seadornavirus VP6 protein', NULL, 'Seadorna_VP6', NULL, NULL, 8104, 9),
(260809, NULL, 'PF20140', NULL, NULL, 'Family of unknown function (DUF6530)', NULL, 'DUF6530', NULL, NULL, 34533, 9),
(260810, NULL, 'PF09945', NULL, NULL, 'Predicted membrane protein (DUF2177)', NULL, 'DUF2177', NULL, NULL, 17075, 9),
(260811, NULL, 'PF10881', NULL, NULL, 'Protein of unknown function (DUF2726)', NULL, 'DUF2726', NULL, NULL, 22070, 9),
(260812, NULL, 'PF05629', NULL, NULL, 'Nanovirus component 8 (C8) protein', NULL, 'Nanovirus_C8', NULL, NULL, 13201, 9),
(260813, NULL, 'PF12023', NULL, NULL, 'Domain of unknown function (DUF3511)', NULL, 'DUF3511', NULL, NULL, 19831, 9),
(260814, NULL, 'PF19242', NULL, NULL, 'Putative zinc finger protein', NULL, 'Zn_finger_prot', NULL, NULL, 35766, 9),
(260815, NULL, 'PF00675', NULL, NULL, 'Insulinase (Peptidase family M16)', NULL, 'Peptidase_M16', NULL, NULL, 11658, 9),
(260816, NULL, 'PF04738', NULL, NULL, 'Lantibiotic dehydratase, N terminus', NULL, 'Lant_dehydr_N', NULL, NULL, 3710, 9),
(260817, NULL, 'PF10815', NULL, NULL, 'ComZ', NULL, 'ComZ', NULL, NULL, 26537, 9),
(260818, NULL, 'PF17109', NULL, NULL, 'fungal STAND N-terminal Goodbye domain', NULL, 'Goodbye', NULL, NULL, 2518, 9),
(260819, NULL, 'PF18687', NULL, NULL, 'Family of unknown function (DUF5637)', NULL, 'DUF5637', NULL, NULL, 29590, 9),
(260820, NULL, 'PF04130', NULL, NULL, 'Gamma tubulin complex component C-terminal', NULL, 'GCP_C_terminal', NULL, NULL, 27738, 9),
(260821, NULL, 'PF08530', NULL, NULL, 'X-Pro dipeptidyl-peptidase C-terminal non-catalytic domain', NULL, 'PepX_C', NULL, NULL, 7875, 9),
(260822, NULL, 'PF08265', NULL, NULL, 'YL1 nuclear protein C-terminal domain', NULL, 'YL1_C', NULL, NULL, 13490, 9),
(260823, NULL, 'PF03325', NULL, NULL, 'Herpesvirus polymerase accessory protein', NULL, 'Herpes_PAP', NULL, NULL, 891, 9);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(260824, NULL, 'PF03849', NULL, NULL, 'Transcription factor Tfb2', NULL, 'Tfb2', NULL, NULL, 692, 9),
(260825, NULL, 'PF04660', NULL, NULL, 'Nanovirus coat protein', NULL, 'Nanovirus_coat', NULL, NULL, 2655, 9),
(260826, NULL, 'PF06385', NULL, NULL, 'Baculovirus LEF-11 protein', NULL, 'Baculo_LEF-11', NULL, NULL, 8482, 9),
(260827, NULL, 'PF12040', NULL, NULL, 'Domain of unknown function (DUF3526)', NULL, 'DUF3526', NULL, NULL, 19769, 9),
(260828, NULL, 'PF12913', NULL, NULL, 'SH3 domain (SH3b1 type)', NULL, 'SH3_6', NULL, NULL, 33185, 9),
(260829, NULL, 'PF05769', NULL, NULL, 'SIKE family', NULL, 'SIKE', NULL, NULL, 13275, 9),
(260830, NULL, 'PF19048', NULL, NULL, 'SidE mono-ADP-ribosyltransferase domain', NULL, 'SidE_mART', NULL, NULL, 35009, 9),
(260831, NULL, 'PF05831', NULL, NULL, 'GAGE protein', NULL, 'GAGE', NULL, NULL, 26330, 9),
(260832, NULL, 'PF00421', NULL, NULL, 'Photosystem II protein', NULL, 'PSII', NULL, NULL, 3129, 9),
(260833, NULL, 'PF19095', NULL, NULL, 'Family of unknown function (DUF5783)', NULL, 'DUF5783', NULL, NULL, 35196, 9),
(260834, NULL, 'PF13974', NULL, NULL, 'YebO-like protein', NULL, 'YebO', NULL, NULL, 22657, 9),
(260835, NULL, 'PF15546', NULL, NULL, 'Domain of unknown function (DUF4653)', NULL, 'DUF4653', NULL, NULL, 21879, 9),
(260836, NULL, 'PF17415', NULL, NULL, 'NigD-like C-terminal beta sandwich domain', NULL, 'NigD_C', NULL, NULL, 9742, 9),
(260837, NULL, 'PF12046', NULL, NULL, 'Cofactor assembly of complex C subunit B', NULL, 'CCB1', NULL, NULL, 19714, 9),
(260838, NULL, 'PF18327', NULL, NULL, 'Proline utilization A proline dehydrogenase N-terminal domain', NULL, 'PRODH', NULL, NULL, 29304, 9),
(260839, NULL, 'PF08518', NULL, NULL, 'Spa2 homology domain (SHD) of GIT', NULL, 'GIT_SHD', NULL, NULL, 14347, 9),
(260840, NULL, 'PF11554', NULL, NULL, 'Protein of unknown function (DUF3232)', NULL, 'DUF3232', NULL, NULL, 18626, 9),
(260841, NULL, 'PF06453', NULL, NULL, 'Type II heat-labile enterotoxin , B subunit (LT-IIB)', NULL, 'LT-IIB', NULL, NULL, 10073, 9),
(260842, NULL, 'PF14608', NULL, NULL, 'RNA-binding, Nab2-type zinc finger', NULL, 'zf-CCCH_2', NULL, NULL, NULL, 9),
(260843, NULL, 'PF02991', NULL, NULL, 'Autophagy protein Atg8 ubiquitin like', NULL, 'ATG8', NULL, NULL, 3849, 9),
(260844, NULL, 'PF07384', NULL, NULL, 'Protein of unknown function (DUF1497)', NULL, 'DUF1497', NULL, NULL, 8106, 9),
(260845, NULL, 'PF01456', NULL, NULL, 'Mucin-like glycoprotein', NULL, 'Mucin', NULL, NULL, 5751, 9),
(260846, NULL, 'PF03166', NULL, NULL, 'MH2 domain', NULL, 'MH2', NULL, NULL, 1602, 9),
(260847, NULL, 'PF02505', NULL, NULL, 'Methyl-coenzyme M reductase operon protein D', NULL, 'MCR_D', NULL, NULL, 4089, 9),
(260848, NULL, 'PF10187', NULL, NULL, 'FAM192A/Fyv6, N-terminal domain', NULL, 'FAM192A_Fyv6_N', NULL, NULL, 14902, 9),
(260849, NULL, 'PF17379', NULL, NULL, 'Family of unknown function (DUF5400)', NULL, 'DUF5400', NULL, NULL, 30533, 9),
(260850, NULL, 'PF16392', NULL, NULL, 'Ig-like domain', NULL, 'DUF5001', NULL, NULL, 26226, 9),
(260851, NULL, 'PF19380', NULL, NULL, 'Family of unknown function (DUF5955)', NULL, 'DUF5955', NULL, NULL, 36854, 9),
(260852, NULL, 'PF11963', NULL, NULL, 'Betacoronavirus, lineage A, NSP1', NULL, 'B-CoV_A_NSP1', NULL, NULL, 16405, 9),
(260853, NULL, 'PF07763', NULL, NULL, 'FEZ-like protein', NULL, 'FEZ', NULL, NULL, 10765, 9),
(260854, NULL, 'PF16172', NULL, NULL, 'DOCK N-terminus', NULL, 'DOCK_N', NULL, NULL, 26365, 9),
(260855, NULL, 'PF18734', NULL, NULL, 'AbiU2', NULL, 'HEPN_AbiU2', NULL, NULL, 28383, 9),
(260856, NULL, 'PF10782', NULL, NULL, 'Zinc-finger', NULL, 'zf-C2HCIx2C', NULL, NULL, 20583, 9),
(260857, NULL, 'PF18533', NULL, NULL, 'Domain of unknown function (DUF5622)', NULL, 'DUF5622', NULL, NULL, 28333, 9),
(260858, NULL, 'PF02462', NULL, NULL, 'Opacity family porin protein', NULL, 'Opacity', NULL, NULL, 5454, 9),
(260859, NULL, 'PF06933', NULL, NULL, 'Special lobe-specific silk protein SSP160', NULL, 'SSP160', NULL, NULL, 11836, 9),
(260860, NULL, 'PF00240', NULL, NULL, 'Ubiquitin family', NULL, 'ubiquitin', NULL, NULL, 4344, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(260861, NULL, 'PF12666', NULL, NULL, 'PrgI family protein', NULL, 'PrgI', NULL, NULL, 22382, 9),
(260862, NULL, 'PF13811', NULL, NULL, 'Domain of unknown function (DUF4186)', NULL, 'DUF4186', NULL, NULL, 19899, 9),
(260863, NULL, 'PF00855', NULL, NULL, 'PWWP domain', NULL, 'PWWP', NULL, NULL, 927, 9),
(260864, NULL, 'PF11744', NULL, NULL, 'Aluminium activated malate transporter', NULL, 'ALMT', NULL, NULL, 14583, 9),
(260865, NULL, 'PF12538', NULL, NULL, 'DNA transporter', NULL, 'FtsK_SpoIIIE_N', NULL, NULL, 21021, 9),
(260866, NULL, 'PF09083', NULL, NULL, 'Domain of unknown function (DUF1923)', NULL, 'DUF1923', NULL, NULL, 9683, 9),
(260867, NULL, 'PF08414', NULL, NULL, 'Respiratory burst NADPH oxidase', NULL, 'NADPH_Ox', NULL, NULL, 11165, 9),
(260868, NULL, 'PF09124', NULL, NULL, 'T4 recombination endonuclease VII, dimerisation', NULL, 'Endonuc-dimeris', NULL, NULL, 10909, 9),
(260869, NULL, 'PF18659', NULL, NULL, 'Cell-traversal protein for ookinetes and sporozoites', NULL, 'CelTOS', NULL, NULL, 29081, 9),
(260870, NULL, 'PF00061', NULL, NULL, 'Lipocalin / cytosolic fatty-acid binding protein family', NULL, 'Lipocalin', NULL, NULL, 5799, 9),
(260871, NULL, 'PF18629', NULL, NULL, 'Family of unknown function (DUF5629)', NULL, 'DUF5629', NULL, NULL, 28885, 9),
(260872, NULL, 'PF10869', NULL, NULL, 'Protein of unknown function (DUF2666)', NULL, 'DUF2666', NULL, NULL, 16942, 9),
(260873, NULL, 'PF14644', NULL, NULL, 'Domain of unknown function (DUF4456)', NULL, 'DUF4456', NULL, NULL, 23208, 9),
(260874, NULL, 'PF13416', NULL, NULL, 'Bacterial extracellular solute-binding protein', NULL, 'SBP_bac_8', NULL, NULL, 2880, 9),
(260875, NULL, 'PF18235', NULL, NULL, 'Oligosaccharyltransferase Peripheral 2 domain', NULL, 'OST_P2', NULL, NULL, 28997, 9),
(260876, NULL, 'PF11404', NULL, NULL, 'Potassium voltage-gated channel', NULL, 'Potassium_chann', NULL, NULL, 18500, 9),
(260877, NULL, 'PF03643', NULL, NULL, 'Vacuolar protein sorting-associated protein 26', NULL, 'Vps26', NULL, NULL, 23683, 9),
(260878, NULL, 'PF06079', NULL, NULL, 'Apyrase', NULL, 'Apyrase', NULL, NULL, NULL, 9),
(260879, NULL, 'PF15976', NULL, NULL, 'CS1-pili formation C-terminal', NULL, 'CooC_C', NULL, NULL, 25779, 9),
(260880, NULL, 'PF11414', NULL, NULL, 'Adenomatous polyposis coli tumour suppressor protein', NULL, 'Suppressor_APC', NULL, NULL, NULL, 9),
(260881, NULL, 'PF14052', NULL, NULL, 'Capsule assembly protein Wzi', NULL, 'Caps_assemb_Wzi', NULL, NULL, 26605, 9),
(260882, NULL, 'PF05287', NULL, NULL, 'PMG protein', NULL, 'PMG', NULL, NULL, 4055, 9),
(260883, NULL, 'PF10400', NULL, NULL, 'Virulence activator alpha C-term', NULL, 'Vir_act_alpha_C', NULL, NULL, 8401, 9),
(260884, NULL, 'PF04397', NULL, NULL, 'LytTr DNA-binding domain', NULL, 'LytTR', NULL, NULL, 10161, 9),
(260885, NULL, 'PF01204', NULL, NULL, 'Trehalase', NULL, 'Trehalase', NULL, NULL, 3003, 9),
(260886, NULL, 'PF15837', NULL, NULL, 'Domain of unknown function (DUF4716)', NULL, 'DUF4716', NULL, NULL, 25798, 9),
(260887, NULL, 'PF11886', NULL, NULL, 'Translocase of chloroplast 159/132, membrane anchor domain', NULL, 'TOC159_MAD', NULL, NULL, 8776, 9),
(260888, NULL, 'PF01314', NULL, NULL, 'Aldehyde ferredoxin oxidoreductase, domains 2 & 3', NULL, 'AFOR_C', NULL, NULL, 1096, 9),
(260889, NULL, 'PF10925', NULL, NULL, 'Protein of unknown function (DUF2680)', NULL, 'DUF2680', NULL, NULL, 24244, 9),
(260890, NULL, 'PF04024', NULL, NULL, 'PspC domain', NULL, 'PspC', NULL, NULL, 494, 9),
(260891, NULL, 'PF06462', NULL, NULL, 'Propeller', NULL, 'Hyd_WA', NULL, NULL, 1427, 9),
(260892, NULL, 'PF20027', NULL, NULL, 'Family of unknown function (DUF6435)', NULL, 'DUF6435', NULL, NULL, 35990, 9),
(260893, NULL, 'PF05860', NULL, NULL, 'TPS secretion domain', NULL, 'TPS', NULL, NULL, 14010, 9),
(260894, NULL, 'PF06232', NULL, NULL, 'Embryo-specific protein 3, (ATS3)', NULL, 'ATS3', NULL, NULL, 9287, 9),
(260895, NULL, 'PF15024', NULL, NULL, 'Glycosyltransferase family 18', NULL, 'Glyco_transf_18', NULL, NULL, 25634, 9),
(260896, NULL, 'PF06552', NULL, NULL, 'Plant specific mitochondrial import receptor subunit TOM20', NULL, 'TOM20_plant', NULL, NULL, NULL, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(260897, NULL, 'PF01663', NULL, NULL, 'Type I phosphodiesterase / nucleotide pyrophosphatase', NULL, 'Phosphodiest', NULL, NULL, 1567, 9),
(260898, NULL, 'PF09731', NULL, NULL, 'Mitochondrial inner membrane protein', NULL, 'Mitofilin', NULL, NULL, 17918, 9),
(260899, NULL, 'PF15291', NULL, NULL, 'Dermcidin, antibiotic peptide', NULL, 'Dermcidin', NULL, NULL, 21614, 9),
(260900, NULL, 'PF11788', NULL, NULL, '39S mitochondrial ribosomal protein L46', NULL, 'MRP-L46', NULL, NULL, 19240, 9),
(260901, NULL, 'PF16818', NULL, NULL, 'Protein SLM4', NULL, 'SLM4', NULL, NULL, 19446, 9),
(260902, NULL, 'PF06888', NULL, NULL, 'Putative Phosphatase', NULL, 'Put_Phosphatase', NULL, NULL, 17732, 9),
(260903, NULL, 'PF19950', NULL, NULL, 'Family of unknown function (DUF6412)', NULL, 'DUF6412', NULL, NULL, 36373, 9),
(260904, NULL, 'PF08800', NULL, NULL, 'VirE N-terminal domain', NULL, 'VirE_N', NULL, NULL, 13365, 9),
(260905, NULL, 'PF12885', NULL, NULL, 'Transducer of regulated CREB activity middle domain', NULL, 'TORC_M', NULL, NULL, 23834, 9),
(260906, NULL, 'PF16129', NULL, NULL, 'Domain of unknown function (DUF4841)', NULL, 'DUF4841', NULL, NULL, 25299, 9),
(260907, NULL, 'PF19361', NULL, NULL, 'Family of unknown function (DUF5937)', NULL, 'DUF5937', NULL, NULL, 36565, 9),
(260908, NULL, 'PF14279', NULL, NULL, 'HNH endonuclease', NULL, 'HNH_5', NULL, NULL, 26508, 9),
(260909, NULL, 'PF17400', NULL, NULL, 'Family of unknown function (DUF5406)', NULL, 'DUF5406', NULL, NULL, 14700, 9),
(260910, NULL, 'PF04691', NULL, NULL, 'Apolipoprotein C-I (ApoC-1)', NULL, 'ApoC-I', NULL, NULL, 3320, 9),
(260911, NULL, 'PF09152', NULL, NULL, 'Domain of unknown function (DUF1937)', NULL, 'DUF1937', NULL, NULL, 10553, 9),
(260912, NULL, 'PF01335', NULL, NULL, 'Death effector domain', NULL, 'DED', NULL, NULL, 4371, 9),
(260913, NULL, 'PF09646', NULL, NULL, 'Gp37 protein', NULL, 'Gp37', NULL, NULL, 15836, 9),
(260914, NULL, 'PF11543', NULL, NULL, 'Nuclear pore localisation protein NPL4', NULL, 'UN_NPL4', NULL, NULL, 24855, 9),
(260915, NULL, 'PF11548', NULL, NULL, 'Protein-tyrosine phosphatase receptor IA-2', NULL, 'Receptor_IA-2', NULL, NULL, 18532, 9),
(260916, NULL, 'PF17463', NULL, NULL, 'Gene product 79', NULL, 'GP79', NULL, NULL, 32464, 9),
(260917, NULL, 'PF04666', NULL, NULL, 'N-Acetylglucosaminyltransferase-IV (GnT-IV) conserved region', NULL, 'Glyco_transf_54', NULL, NULL, NULL, 9),
(260918, NULL, 'PF16759', NULL, NULL, 'DNA ligase 3 BRCT domain', NULL, 'LIG3_BRCT', NULL, NULL, 22596, 9),
(260919, NULL, 'PF09405', NULL, NULL, 'CASC3/Barentsz eIF4AIII binding', NULL, 'Btz', NULL, NULL, 15087, 9),
(260920, NULL, 'PF20232', NULL, NULL, 'C-terminal domain of Type VI secretion system FHA protein', NULL, 'T6SS_FHA_C', NULL, NULL, 37628, 9),
(260921, NULL, 'PF11031', NULL, NULL, 'Bacteriophage T holin', NULL, 'Phage_holin_T', NULL, NULL, 15513, 9),
(260922, NULL, 'PF04757', NULL, NULL, 'Pex2 / Pex12 amino terminal region', NULL, 'Pex2_Pex12', NULL, NULL, 3528, 9),
(260923, NULL, 'PF10155', NULL, NULL, 'CCR4-NOT transcription complex subunit 11', NULL, 'CNOT11', NULL, NULL, 14787, 9),
(260924, NULL, 'PF05370', NULL, NULL, 'Domain of unknown function (DUF749)', NULL, 'DUF749', NULL, NULL, 5199, 9),
(260925, NULL, 'PF14343', NULL, NULL, 'PrcB C-terminal', NULL, 'PrcB_C', NULL, NULL, 22045, 9),
(260926, NULL, 'PF14705', NULL, NULL, 'Costars', NULL, 'Costars', NULL, NULL, 22494, 9),
(260927, NULL, 'PF07395', NULL, NULL, 'Mig-14', NULL, 'Mig-14', NULL, NULL, 8305, 9),
(260928, NULL, 'PF15029', NULL, NULL, 'Transmembrane protein 174', NULL, 'TMEM174', NULL, NULL, 22004, 9),
(260929, NULL, 'PF06363', NULL, NULL, 'Picornaviridae P3A protein', NULL, 'Picorna_P3A', NULL, NULL, 8268, 9),
(260930, NULL, 'PF15593', NULL, NULL, 'Immunity protein 42', NULL, 'Imm42', NULL, NULL, 24941, 9),
(260931, NULL, 'PF19377', NULL, NULL, 'Family of unknown function (DUF5952)', NULL, 'DUF5952', NULL, NULL, 36749, 9),
(260932, NULL, 'PF01239', NULL, NULL, 'Protein prenyltransferase alpha subunit repeat', NULL, 'PPTA', NULL, NULL, 5009, 9),
(260933, NULL, 'PF00220', NULL, NULL, 'Neurohypophysial hormones, N-terminal Domain', NULL, 'Hormone_4', NULL, NULL, 21384, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(260934, NULL, 'PF00637', NULL, NULL, 'Region in Clathrin and VPS', NULL, 'Clathrin', NULL, NULL, 5639, 9),
(260935, NULL, 'PF08278', NULL, NULL, 'DNA primase DnaG DnaB-binding', NULL, 'DnaG_DnaB_bind', NULL, NULL, 8982, 9),
(260936, NULL, 'PF10833', NULL, NULL, 'Protein of unknown function (DUF2572)', NULL, 'DUF2572', NULL, NULL, 16005, 9),
(260937, NULL, 'PF14927', NULL, NULL, 'Neurensin', NULL, 'Neurensin', NULL, NULL, NULL, 9),
(260938, NULL, 'PF17655', NULL, NULL, 'Inward rectifier potassium channel C-terminal domain', NULL, 'IRK_C', NULL, NULL, 30131, 9),
(260939, NULL, 'PF03461', NULL, NULL, 'TRCF domain', NULL, 'TRCF', NULL, NULL, 10743, 9),
(260940, NULL, 'PF03065', NULL, NULL, 'Glycosyl hydrolase family 57', NULL, 'Glyco_hydro_57', NULL, NULL, 4767, 9),
(260941, NULL, 'PF12595', NULL, NULL, 'Rhomboid serine protease', NULL, 'Rhomboid_SP', NULL, NULL, 21146, 9),
(260942, NULL, 'PF18303', NULL, NULL, 'SAVED-fused 2TM effector domain', NULL, 'Saf_2TM', NULL, NULL, 28926, 9),
(260943, NULL, 'PF01473', NULL, NULL, 'Putative cell wall binding repeat', NULL, 'Choline_bind_1', NULL, NULL, 20480, 9),
(260944, NULL, 'PF06889', NULL, NULL, 'Protein of unknown function (DUF1266)', NULL, 'DUF1266', NULL, NULL, 11677, 9),
(260945, NULL, 'PF11844', NULL, NULL, 'Domain of unknown function (DUF3364)', NULL, 'DUF3364', NULL, NULL, 21802, 9),
(260946, NULL, 'PF14638', NULL, NULL, 'Folliculin-interacting protein C-terminus', NULL, 'FNIP_C', NULL, NULL, 23440, 9),
(260947, NULL, 'PF17437', NULL, NULL, 'Family of unknown function (DUF5416)', NULL, 'DUF5416', NULL, NULL, 27444, 9),
(260948, NULL, 'PF16927', NULL, NULL, 'N-terminal 7TM region of histidine kinase', NULL, 'HisKA_7TM', NULL, NULL, 25186, 9),
(260949, NULL, 'PF19249', NULL, NULL, 'Family of unknown function (DUF5897)', NULL, 'DUF5897', NULL, NULL, 37092, 9),
(260950, NULL, 'PF18663', NULL, NULL, 'Pallilysin beta barrel domain', NULL, 'Pallilysin', NULL, NULL, 28399, 9),
(260951, NULL, 'PF07182', NULL, NULL, 'Protein of unknown function (DUF1402)', NULL, 'DUF1402', NULL, NULL, 13039, 9),
(260952, NULL, 'PF18442', NULL, NULL, 'E3 gp78 Ube2g2-binding region (G2BR)', NULL, 'G2BR', NULL, NULL, 28360, 9),
(260953, NULL, 'PF01512', NULL, NULL, 'Respiratory-chain NADH dehydrogenase 51 Kd subunit', NULL, 'Complex1_51K', NULL, NULL, 7684, 9),
(260954, NULL, 'PF04999', NULL, NULL, 'Cell division protein FtsL', NULL, 'FtsL', NULL, NULL, 11308, 9),
(260955, NULL, 'PF09294', NULL, NULL, 'Interferon-alpha/beta receptor, fibronectin type III', NULL, 'Interfer-bind', NULL, NULL, 14147, 9),
(260956, NULL, 'PF15599', NULL, NULL, 'Immunity protein 63', NULL, 'Imm63', NULL, NULL, 24974, 9),
(260957, NULL, 'PF17967', NULL, NULL, 'Pullulanase N2 domain', NULL, 'Pullulanase_N2', NULL, NULL, 28554, 9),
(260958, NULL, 'PF03080', NULL, NULL, 'Neprosin', NULL, 'Neprosin', NULL, NULL, 4884, 9),
(260959, NULL, 'PF10955', NULL, NULL, 'Anti-sigma-F factor Fin', NULL, 'Fin', NULL, NULL, 12947, 9),
(260960, NULL, 'PF01787', NULL, NULL, 'Ilarvirus coat protein', NULL, 'Ilar_coat', NULL, NULL, 2790, 9),
(260961, NULL, 'PF07717', NULL, NULL, 'Oligonucleotide/oligosaccharide-binding (OB)-fold', NULL, 'OB_NTP_bind', NULL, NULL, 8183, 9),
(260962, NULL, 'PF01990', NULL, NULL, 'ATP synthase (F/14-kDa) subunit', NULL, 'ATP-synt_F', NULL, NULL, 787, 9),
(260963, NULL, 'PF11916', NULL, NULL, 'Vacuolar protein 14 C-terminal Fig4p binding', NULL, 'Vac14_Fig4_bd', NULL, NULL, 19530, 9),
(260964, NULL, 'PF12467', NULL, NULL, 'Cucumber mosaic virus 1a protein family', NULL, 'CMV_1a', NULL, NULL, 14851, 9),
(260965, NULL, 'PF13226', NULL, NULL, 'Domain of unknown function (DUF4034)', NULL, 'DUF4034', NULL, NULL, 22587, 9),
(260966, NULL, 'PF16822', NULL, NULL, 'SGNH hydrolase-like domain, acetyltransferase AlgX', NULL, 'ALGX', NULL, NULL, 22037, 9),
(260967, NULL, 'PF05042', NULL, NULL, 'Caleosin related protein', NULL, 'Caleosin', NULL, NULL, 1390, 9),
(260968, NULL, 'PF02305', NULL, NULL, 'Capsid protein (F protein)', NULL, 'Phage_F', NULL, NULL, 6169, 9),
(260969, NULL, 'PF03980', NULL, NULL, 'Nnf1', NULL, 'Nnf1', NULL, NULL, 396, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(260970, NULL, 'PF15902', NULL, NULL, 'Sortilin, neurotensin receptor 3,', NULL, 'Sortilin-Vps10', NULL, NULL, 25616, 9),
(260971, NULL, 'PF00906', NULL, NULL, 'Hepatitis core antigen', NULL, 'Hepatitis_core', NULL, NULL, 1316, 9),
(260972, NULL, 'PF04632', NULL, NULL, 'Fusaric acid resistance protein family', NULL, 'FUSC', NULL, NULL, 2469, 9),
(260973, NULL, 'PF10392', NULL, NULL, 'Golgi transport complex subunit 5', NULL, 'COG5', NULL, NULL, 17123, 9),
(260974, NULL, 'PF16668', NULL, NULL, 'Adhesin from Campylobacter', NULL, 'JLPA', NULL, NULL, 26223, 9),
(260975, NULL, 'PF18114', NULL, NULL, 'Suv3 helical N-terminal domain', NULL, 'Suv3_N', NULL, NULL, 29414, 9),
(260976, NULL, 'PF13434', NULL, NULL, 'L-lysine 6-monooxygenase/L-ornithine 5-monooxygenase', NULL, 'Lys_Orn_oxgnase', NULL, NULL, 21981, 9),
(260977, NULL, 'PF14665', NULL, NULL, 'Rapamycin-insensitive companion of mTOR, phosphorylation-site', NULL, 'RICTOR_phospho', NULL, NULL, 21814, 9),
(260978, NULL, 'PF04245', NULL, NULL, '37-kD nucleoid-associated bacterial protein', NULL, 'NA37', NULL, NULL, 5821, 9),
(260979, NULL, 'PF19027', NULL, NULL, 'Family of unknown function (DUF5752)', NULL, 'DUF5752', NULL, NULL, 34981, 9),
(260980, NULL, 'PF06112', NULL, NULL, 'Gammaherpesvirus capsid protein', NULL, 'Herpes_capsid', NULL, NULL, 13638, 9),
(260981, NULL, 'PF07883', NULL, NULL, 'Cupin domain', NULL, 'Cupin_2', NULL, NULL, 18691, 9),
(260982, NULL, 'PF07957', NULL, NULL, 'Protein of unknown function (DUF3294)', NULL, 'DUF3294', NULL, NULL, 7624, 9),
(260983, NULL, 'PF16964', NULL, NULL, 'Putative tight adherence pilin protein F', NULL, 'TadF', NULL, NULL, 22401, 9),
(260984, NULL, 'PF15465', NULL, NULL, 'Domain of unknown function (DUF4634)', NULL, 'DUF4634', NULL, NULL, 24315, 9),
(260985, NULL, 'PF08064', NULL, NULL, 'UME (NUC010) domain', NULL, 'UME', NULL, NULL, 12375, 9),
(260986, NULL, 'PF02497', NULL, NULL, 'Arterivirus glycoprotein', NULL, 'Arteri_GP4', NULL, NULL, 5463, 9),
(260987, NULL, 'PF09728', NULL, NULL, 'Myosin-like coiled-coil protein', NULL, 'Taxilin', NULL, NULL, 21110, 9),
(260988, NULL, 'PF08106', NULL, NULL, 'Formaecin family', NULL, 'Antimicrobial11', NULL, NULL, 12644, 9),
(260989, NULL, 'PF16405', NULL, NULL, 'Domain of unknown function (DUF5013)', NULL, 'DUF5013', NULL, NULL, 23963, 9),
(260990, NULL, 'PF02333', NULL, NULL, 'Phytase', NULL, 'Phytase', NULL, NULL, 5481, 9),
(260991, NULL, 'PF13847', NULL, NULL, 'Methyltransferase domain', NULL, 'Methyltransf_31', NULL, NULL, 24658, 9),
(260992, NULL, 'PF00130', NULL, NULL, 'Phorbol esters/diacylglycerol binding domain (C1 domain)', NULL, 'C1_1', NULL, NULL, 5392, 9),
(260993, NULL, 'PF00628', NULL, NULL, 'PHD-finger', NULL, 'PHD', NULL, NULL, 14680, 9),
(260994, NULL, 'PF12411', NULL, NULL, 'Choline sulfatase enzyme C terminal', NULL, 'Choline_sulf_C', NULL, NULL, 25849, 9),
(260995, NULL, 'PF00317', NULL, NULL, 'Ribonucleotide reductase, all-alpha domain', NULL, 'Ribonuc_red_lgN', NULL, NULL, 9072, 9),
(260996, NULL, 'PF01093', NULL, NULL, 'Clusterin', NULL, 'Clusterin', NULL, NULL, 4806, 9),
(260997, NULL, 'PF12142', NULL, NULL, 'Polyphenol oxidase middle domain', NULL, 'PPO1_DWL', NULL, NULL, 16524, 9),
(260998, NULL, 'PF17103', NULL, NULL, 'Stealth protein CR4, conserved region 4', NULL, 'Stealth_CR4', NULL, NULL, 2646, 9),
(260999, NULL, 'PF07412', NULL, NULL, 'Geminin', NULL, 'Geminin', NULL, NULL, 14552, 9),
(261000, NULL, 'PF18890', NULL, NULL, 'FANCL UBC-like domain 2', NULL, 'FANCL_d2', NULL, NULL, 34714, 9),
(261001, NULL, 'PF04807', NULL, NULL, 'Geminivirus AC4/5 conserved region', NULL, 'Gemini_AC4_5', NULL, NULL, 4603, 9),
(261002, NULL, 'PF04609', NULL, NULL, 'Methyl-coenzyme M reductase operon protein C', NULL, 'MCR_C', NULL, NULL, 22959, 9),
(261003, NULL, 'PF14371', NULL, NULL, 'Domain of unknown function (DUF4412)', NULL, 'DUF4412', NULL, NULL, 26179, 9),
(261004, NULL, 'PF18660', NULL, NULL, 'Tsi6', NULL, 'Tsi6', NULL, NULL, 29447, 9),
(261005, NULL, 'PF17798', NULL, NULL, 'TRIF N-terminal domain', NULL, 'TRIF-NTD', NULL, NULL, 32392, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(261006, NULL, 'PF17509', NULL, NULL, 'Family of unknown function (DUF5440)', NULL, 'DUF5440', NULL, NULL, 20397, 9),
(261007, NULL, 'PF08216', NULL, NULL, 'Catenin-beta-like, Arm-motif containing nuclear', NULL, 'CTNNBL', NULL, NULL, 17023, 9),
(261008, NULL, 'PF08071', NULL, NULL, 'RS4NT (NUC023) domain', NULL, 'RS4NT', NULL, NULL, 11782, 9),
(261009, NULL, 'PF01114', NULL, NULL, 'Colipase, N-terminal domain', NULL, 'Colipase', NULL, NULL, 18376, 9),
(261010, NULL, 'PF14576', NULL, NULL, 'Sieve element occlusion N-terminus', NULL, 'SEO_N', NULL, NULL, 24344, 9),
(261011, NULL, 'PF11443', NULL, NULL, 'Domain of unknown function (DUF2828)', NULL, 'DUF2828', NULL, NULL, 10965, 9),
(261012, NULL, 'PF18504', NULL, NULL, 'Csm1 N-terminal domain', NULL, 'Csm1_N', NULL, NULL, 30433, 9),
(261013, NULL, 'PF12944', NULL, NULL, 'Hepatitis A virus viral protein VP', NULL, 'HAV_VP', NULL, NULL, 22301, 9),
(261014, NULL, 'PF03371', NULL, NULL, 'PRP38 family', NULL, 'PRP38', NULL, NULL, 2049, 9),
(261015, NULL, 'PF14607', NULL, NULL, 'N-terminus of Esterase_SGNH_hydro-type', NULL, 'GxDLY', NULL, NULL, 21592, 9),
(261016, NULL, 'PF09035', NULL, NULL, 'Excisionase from transposon Tn916', NULL, 'Tn916-Xis', NULL, NULL, 9632, 9),
(261017, NULL, 'PF12431', NULL, NULL, 'Transcriptional regulator', NULL, 'CitT', NULL, NULL, 22000, 9),
(261018, NULL, 'PF19989', NULL, NULL, 'Family of unknown function (DUF6425)', NULL, 'DUF6425', NULL, NULL, 37501, 9),
(261019, NULL, 'PF08907', NULL, NULL, 'Domain of unknown function (DUF1853)', NULL, 'DUF1853', NULL, NULL, 7877, 9),
(261020, NULL, 'PF16143', NULL, NULL, 'Domain of unknown function (DUF4851)', NULL, 'DUF4851', NULL, NULL, 22573, 9),
(261021, NULL, 'PF00965', NULL, NULL, 'Tissue inhibitor of metalloproteinase', NULL, 'TIMP', NULL, NULL, 4440, 9),
(261022, NULL, 'PF05451', NULL, NULL, 'Phytoreovirus nonstructural protein Pns10/11', NULL, 'Phytoreo_Pns', NULL, NULL, 12377, 9),
(261023, NULL, 'PF15200', NULL, NULL, 'Keratinocyte differentiation-associated', NULL, 'KRTDAP', NULL, NULL, 22269, 9),
(261024, NULL, 'PF15917', NULL, NULL, 'Piezo', NULL, 'PIEZO', NULL, NULL, 21268, 9),
(261025, NULL, 'PF01158', NULL, NULL, 'Ribosomal protein L36e', NULL, 'Ribosomal_L36e', NULL, NULL, 5592, 9),
(261026, NULL, 'PF14324', NULL, NULL, 'PINIT domain', NULL, 'PINIT', NULL, NULL, 18421, 9),
(261027, NULL, 'PF02095', NULL, NULL, 'Extensin-like protein repeat', NULL, 'Extensin_1', NULL, NULL, 4107, 9),
(261028, NULL, 'PF16390', NULL, NULL, 'Domain of unknown function', NULL, 'DUF4999', NULL, NULL, 22331, 9),
(261029, NULL, 'PF18236', NULL, NULL, 'Argonaute N domain', NULL, 'AGO_N', NULL, NULL, 28846, 9),
(261030, NULL, 'PF19518', NULL, NULL, 'p190RhoGAP, pG1 and pG2 domains', NULL, 'RhoGAP_pG1_pG2', NULL, NULL, 36110, 9),
(261031, NULL, 'PF00862', NULL, NULL, 'Sucrose synthase', NULL, 'Sucrose_synth', NULL, NULL, 293, 9),
(261032, NULL, 'PF09486', NULL, NULL, 'Bacterial type III secretion protein (HrpB7)', NULL, 'HrpB7', NULL, NULL, 11186, 9),
(261033, NULL, 'PF10909', NULL, NULL, 'Protein of unknown function (DUF2682)', NULL, 'DUF2682', NULL, NULL, 26049, 9),
(261034, NULL, 'PF05227', NULL, NULL, 'CHASE3 domain', NULL, 'CHASE3', NULL, NULL, 3409, 9),
(261035, NULL, 'PF15369', NULL, NULL, 'Uncharacterised protein KIAA1328', NULL, 'KIAA1328', NULL, NULL, 26431, 9),
(261036, NULL, 'PF06429', NULL, NULL, 'Flagellar basal body rod FlgEFG protein C-terminal', NULL, 'Flg_bbr_C', NULL, NULL, 7623, 9),
(261037, NULL, 'PF13730', NULL, NULL, 'Helix-turn-helix domain', NULL, 'HTH_36', NULL, NULL, NULL, 9),
(261038, NULL, 'PF08404', NULL, NULL, 'Baculoviridae P74 N-terminal', NULL, 'Baculo_p74_N', NULL, NULL, 11344, 9),
(261039, NULL, 'PF00148', NULL, NULL, 'Nitrogenase component 1 type Oxidoreductase', NULL, 'Oxidored_nitro', NULL, NULL, 5696, 9),
(261040, NULL, 'PF16591', NULL, NULL, 'Helical bimodular sensor domain', NULL, 'HBM', NULL, NULL, 24201, 9),
(261041, NULL, 'PF11644', NULL, NULL, 'Protein of unknown function (DUF3256)', NULL, 'DUF3256', NULL, NULL, 18705, 9),
(261042, NULL, 'PF02550', NULL, NULL, 'Acetyl-CoA hydrolase/transferase N-terminal domain', NULL, 'AcetylCoA_hydro', NULL, NULL, 2420, 9);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(261043, NULL, 'PF14314', NULL, NULL, 'Virus-capping methyltransferase', NULL, 'Methyltrans_Mon', NULL, NULL, 33487, 9),
(261044, NULL, 'PF03900', NULL, NULL, 'Porphobilinogen deaminase, C-terminal domain', NULL, 'Porphobil_deamC', NULL, NULL, 15603, 9),
(261045, NULL, 'PF05637', NULL, NULL, 'galactosyl transferase GMA12/MNN10 family', NULL, 'Glyco_transf_34', NULL, NULL, 14197, 9),
(261046, NULL, 'PF14825', NULL, NULL, 'Cilia- and flagella-associated protein 77', NULL, 'CFAP77', NULL, NULL, 25581, 9),
(261047, NULL, 'PF16502', NULL, NULL, 'Domain of unknown function (DUF5059)', NULL, 'DUF5059', NULL, NULL, 24295, 9),
(261048, NULL, 'PF10899', NULL, NULL, 'Putative abortive phage resistance protein AbiGi, antitoxin', NULL, 'AbiGi', NULL, NULL, 17680, 9),
(261049, NULL, 'PF11785', NULL, NULL, 'Aft1 osmotic stress response (OSM) domain', NULL, 'Aft1_OSA', NULL, NULL, 14891, 9),
(261050, NULL, 'PF20153', NULL, NULL, 'Family of unknown function (DUF6535)', NULL, 'DUF6535', NULL, NULL, 37237, 9),
(261051, NULL, 'PF02815', NULL, NULL, 'MIR domain', NULL, 'MIR', NULL, NULL, 13509, 9),
(261052, NULL, 'PF04749', NULL, NULL, 'PLAC8 family', NULL, 'PLAC8', NULL, NULL, 6654, 9),
(261053, NULL, 'PF07885', NULL, NULL, 'Ion channel', NULL, 'Ion_trans_2', NULL, NULL, 18701, 9),
(261054, NULL, 'PF05065', NULL, NULL, 'Phage capsid family', NULL, 'Phage_capsid', NULL, NULL, 21899, 9),
(261055, NULL, 'PF15456', NULL, NULL, 'Up-regulated During Septation', NULL, 'Uds1', NULL, NULL, 26647, 9),
(261056, NULL, 'PF15711', NULL, NULL, 'Interleukin-like EMT inducer', NULL, 'ILEI', NULL, NULL, 33356, 9),
(261057, NULL, 'PF02964', NULL, NULL, 'Methane monooxygenase, hydrolase gamma chain', NULL, 'MeMO_Hyd_G', NULL, NULL, 3540, 9),
(261058, NULL, 'PF05934', NULL, NULL, 'Mid-1-related chloride channel (MCLC)', NULL, 'MCLC', NULL, NULL, 12701, 9),
(261059, NULL, 'PF19918', NULL, NULL, 'MoxR-vWA-beta-propeller ternary system domain bpX2', NULL, 'bpX2', NULL, NULL, 37105, 9),
(261060, NULL, 'PF14916', NULL, NULL, 'Coiled-coil domain of unknown function', NULL, 'CCDC92', NULL, NULL, 28615, 9),
(261061, NULL, 'PF01229', NULL, NULL, 'Glycosyl hydrolases family 39', NULL, 'Glyco_hydro_39', NULL, NULL, 6735, 9),
(261062, NULL, 'PF04369', NULL, NULL, 'Lactococcin-like family', NULL, 'Lactococcin', NULL, NULL, 4951, 9),
(261063, NULL, 'PF17553', NULL, NULL, 'Family of unknown function (DUF5465)', NULL, 'DUF5465', NULL, NULL, 31642, 9),
(261064, NULL, 'PF09129', NULL, NULL, 'Cholesterol oxidase, substrate-binding', NULL, 'Chol_subst-bind', NULL, NULL, 10712, 9),
(261065, NULL, 'PF17708', NULL, NULL, 'Gasdermin PUB domain', NULL, 'Gasdermin_C', NULL, NULL, 29237, 9),
(261066, NULL, 'PF04312', NULL, NULL, 'Protein of unknown function (DUF460)', NULL, 'DUF460', NULL, NULL, 3726, 9),
(261067, NULL, 'PF19618', NULL, NULL, 'Family of unknown function (DUF6123)', NULL, 'DUF6123', NULL, NULL, 37479, 9),
(261068, NULL, 'PF10065', NULL, NULL, 'Uncharacterized conserved protein (DUF2303)', NULL, 'DUF2303', NULL, NULL, 19976, 9),
(261069, NULL, 'PF18547', NULL, NULL, 'Halobacterial output domain 2', NULL, 'HalOD2', NULL, NULL, 29310, 9),
(261070, NULL, 'PF05383', NULL, NULL, 'La domain', NULL, 'La', NULL, NULL, 1268, 9),
(261071, NULL, 'PF01794', NULL, NULL, 'Ferric reductase like transmembrane component', NULL, 'Ferric_reduct', NULL, NULL, 8425, 9),
(261072, NULL, 'PF19379', NULL, NULL, 'Family of unknown function (DUF5954)', NULL, 'DUF5954', NULL, NULL, 36555, 9),
(261073, NULL, 'PF08963', NULL, NULL, 'Protein of unknown function (DUF1878)', NULL, 'DUF1878', NULL, NULL, 8783, 9),
(261074, NULL, 'PF20097', NULL, NULL, 'Domain of unknown function (DUF6487)', NULL, 'DUF6487', NULL, NULL, 37241, 9),
(261075, NULL, 'PF18905', NULL, NULL, 'Protein of unknown function (DUF5661)', NULL, 'DUF5661', NULL, NULL, 35651, 9),
(261076, NULL, 'PF00347', NULL, NULL, 'Ribosomal protein L6', NULL, 'Ribosomal_L6', NULL, NULL, 17767, 9),
(261077, NULL, 'PF12593', NULL, NULL, 'Microcystin synthetase C terminal', NULL, 'McyA_C', NULL, NULL, 16434, 9),
(261078, NULL, 'PF11021', NULL, NULL, 'Protein of unknown function (DUF2613)', NULL, 'DUF2613', NULL, NULL, 16342, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(261079, NULL, 'PF12494', NULL, NULL, 'Protein of unknown function (DUF3695)', NULL, 'DUF3695', NULL, NULL, 21468, 9),
(261080, NULL, 'PF12006', NULL, NULL, 'Protein of unknown function (DUF3500)', NULL, 'DUF3500', NULL, NULL, 19688, 9),
(261081, NULL, 'PF18656', NULL, NULL, 'Family of unknown function (DUF5633)', NULL, 'DUF5633', NULL, NULL, 33373, 9),
(261082, NULL, 'PF15878', NULL, NULL, 'Domain of unknown function (DUF4733)', NULL, 'DUF4733', NULL, NULL, 23987, 9),
(261083, NULL, 'PF05397', NULL, NULL, 'Mediator complex subunit 15', NULL, 'Med15_fungi', NULL, NULL, 14185, 9),
(261084, NULL, 'PF12175', NULL, NULL, 'White spot syndrome virus structural envelope protein VP', NULL, 'WSS_VP', NULL, NULL, 20258, 9),
(261085, NULL, 'PF12509', NULL, NULL, 'Protein of unknown function (DUF3715)', NULL, 'DUF3715', NULL, NULL, 21057, 9),
(261086, NULL, 'PF15726', NULL, NULL, 'Domain of unknown function (DUF4677)', NULL, 'DUF4677', NULL, NULL, 26254, 9),
(261087, NULL, 'PF05350', NULL, NULL, 'Glycogen synthase kinase-3 binding', NULL, 'GSK-3_bind', NULL, NULL, 5102, 9),
(261088, NULL, 'PF07355', NULL, NULL, 'Glycine/sarcosine/betaine reductase selenoprotein B (GRDB)', NULL, 'GRDB', NULL, NULL, 4010, 9),
(261089, NULL, 'PF16768', NULL, NULL, 'Nucleoporin homology of Germinal-centre associated nuclear protein', NULL, 'NupH_GANP', NULL, NULL, 22028, 9),
(261090, NULL, 'PF17358', NULL, NULL, 'Family of unknown function (DUF5384)', NULL, 'DUF5384', NULL, NULL, 19194, 9),
(261091, NULL, 'PF07197', NULL, NULL, 'Protein of unknown function (DUF1409)', NULL, 'DUF1409', NULL, NULL, 10809, 9),
(261092, NULL, 'PF19724', NULL, NULL, 'Family of unknown function (DUF6217)', NULL, 'DUF6217', NULL, NULL, 37419, 9),
(261093, NULL, 'PF00106', NULL, NULL, 'short chain dehydrogenase', NULL, 'adh_short', NULL, NULL, 6085, 9),
(261094, NULL, 'PF09679', NULL, NULL, 'Type-F conjugative transfer system pilin chaperone (TraQ)', NULL, 'TraQ', NULL, NULL, 13892, 9),
(261095, NULL, 'PF06725', NULL, NULL, '3D domain', NULL, '3D', NULL, NULL, 8111, 9),
(261096, NULL, 'PF08953', NULL, NULL, 'Domain of unknown function (DUF1899)', NULL, 'DUF1899', NULL, NULL, 7535, 9),
(261097, NULL, 'PF00214', NULL, NULL, 'Calcitonin / CGRP / IAPP family', NULL, 'Calc_CGRP_IAPP', NULL, NULL, 17078, 9),
(261098, NULL, 'PF18198', NULL, NULL, 'Dynein heavy chain AAA lid domain', NULL, 'AAA_lid_11', NULL, NULL, 29871, 9),
(261099, NULL, 'PF11450', NULL, NULL, 'Protein of unknwon function (DUF3008)', NULL, 'DUF3008', NULL, NULL, 18830, 9),
(261100, NULL, 'PF03802', NULL, NULL, 'Apo-citrate lyase phosphoribosyl-dephospho-CoA transferase', NULL, 'CitX', NULL, NULL, 1586, 9),
(261101, NULL, 'PF05510', NULL, NULL, 'Sarcoglycan alpha/epsilon', NULL, 'Sarcoglycan_2', NULL, NULL, 7581, 9),
(261102, NULL, 'PF17372', NULL, NULL, 'Family of unknown function (DUF5394)', NULL, 'DUF5394', NULL, NULL, 13795, 9),
(261103, NULL, 'PF04979', NULL, NULL, 'Protein phosphatase inhibitor 2 (IPP-2)', NULL, 'IPP-2', NULL, NULL, 6671, 9),
(261104, NULL, 'PF19342', NULL, NULL, 'MGP3 C-terminal domain', NULL, 'MGP3_C', NULL, NULL, 36367, 9),
(261105, NULL, 'PF03280', NULL, NULL, 'Proteobacterial lipase chaperone protein', NULL, 'Lipase_chap', NULL, NULL, 2868, 9),
(261106, NULL, 'PF07836', NULL, NULL, 'DmpG-like communication domain', NULL, 'DmpG_comm', NULL, NULL, 13195, 9),
(261107, NULL, 'PF00538', NULL, NULL, 'linker histone H1 and H5 family', NULL, 'Linker_histone', NULL, NULL, 5977, 9),
(261108, NULL, 'PF11656', NULL, NULL, 'YjbD family (DUF3811)', NULL, 'DUF3811', NULL, NULL, 19331, 9),
(261109, NULL, 'PF20507', NULL, NULL, 'Family of unknown function (DUF6733)', NULL, 'DUF6733', NULL, NULL, 33707, 9),
(261110, NULL, 'PF01418', NULL, NULL, 'Helix-turn-helix domain, rpiR family', NULL, 'HTH_6', NULL, NULL, 989, 9),
(261111, NULL, 'PF18443', NULL, NULL, 'Tle cognate immunity protein 4 N-terminal domain', NULL, 'Tli4_N', NULL, NULL, 28801, 9),
(261112, NULL, 'PF18974', NULL, NULL, 'Domain of unknown function (DUF5710)', NULL, 'DUF5710', NULL, NULL, 35267, 9),
(261113, NULL, 'PF00540', NULL, NULL, 'gag gene protein p17 (matrix protein)', NULL, 'Gag_p17', NULL, NULL, 3662, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(261114, NULL, 'PF15486', NULL, NULL, 'Domain of unknown function (DUF4644)', NULL, 'DUF4644', NULL, NULL, 25407, 9),
(261115, NULL, 'PF02319', NULL, NULL, 'E2F/DP family winged-helix DNA-binding domain', NULL, 'E2F_TDP', NULL, NULL, 4128, 9),
(261116, NULL, 'PF05443', NULL, NULL, 'ROS/MUCR transcriptional regulator protein', NULL, 'ROS_MUCR', NULL, NULL, 13525, 9),
(261117, NULL, 'PF18165', NULL, NULL, 'Predicted pPIWI-associating nuclease', NULL, 'pP_pnuc_1', NULL, NULL, 27487, 9),
(261118, NULL, 'PF02807', NULL, NULL, 'ATP:guanido phosphotransferase, N-terminal domain', NULL, 'ATP-gua_PtransN', NULL, NULL, 15811, 9),
(261119, NULL, 'PF05694', NULL, NULL, '56kDa selenium binding protein (SBP56)', NULL, 'SBP56', NULL, NULL, 13664, 9),
(261120, NULL, 'PF05488', NULL, NULL, 'PAAR motif', NULL, 'PAAR_motif', NULL, NULL, 12251, 9),
(261121, NULL, 'PF12889', NULL, NULL, 'Protein of unknown function (DUF3829)', NULL, 'DUF3829', NULL, NULL, 13686, 9),
(261122, NULL, 'PF20437', NULL, NULL, 'Lon-like LonC helical domain', NULL, 'LonC_helical', NULL, NULL, 33571, 9),
(261123, NULL, 'PF16423', NULL, NULL, 'Transcription factor COE1 helix-loop-helix domain', NULL, 'COE1_HLH', NULL, NULL, 24461, 9),
(261124, NULL, 'PF20256', NULL, NULL, 'Molybdopterin cofactor-binding domain', NULL, 'MoCoBD_2', NULL, NULL, 37552, 9),
(261125, NULL, 'PF16814', NULL, NULL, 'Read-through domain', NULL, 'Read-through', NULL, NULL, 22464, 9),
(261126, NULL, 'PF01819', NULL, NULL, 'Levivirus coat protein', NULL, 'Levi_coat', NULL, NULL, 3650, 9),
(261127, NULL, 'PF15213', NULL, NULL, 'CMT1A duplicated region transcript 4 protein', NULL, 'CDRT4', NULL, NULL, 21726, 9),
(261128, NULL, 'PF19750', NULL, NULL, 'Family of unknown function (DUF6237)', NULL, 'DUF6237', NULL, NULL, 37076, 9),
(261129, NULL, 'PF14938', NULL, NULL, 'Soluble NSF attachment protein, SNAP', NULL, 'SNAP', NULL, NULL, NULL, 9),
(261130, NULL, 'PF00188', NULL, NULL, 'Cysteine-rich secretory protein family', NULL, 'CAP', NULL, NULL, 9125, 9),
(261131, NULL, 'PF08338', NULL, NULL, 'Domain of unknown function (DUF1731)', NULL, 'DUF1731', NULL, NULL, 12799, 9),
(261132, NULL, 'PF02558', NULL, NULL, 'Ketopantoate reductase PanE/ApbA', NULL, 'ApbA', NULL, NULL, 13503, 9),
(261133, NULL, 'PF14648', NULL, NULL, 'FAM91 C-terminus', NULL, 'FAM91_C', NULL, NULL, 23436, 9),
(261134, NULL, 'PF08067', NULL, NULL, 'ROKNT (NUC014) domain', NULL, 'ROKNT', NULL, NULL, 12139, 9),
(261135, NULL, 'PF18914', NULL, NULL, 'Domain of unknown function (DUF5666)', NULL, 'DUF5666', NULL, NULL, 35846, 9),
(261136, NULL, 'PF03057', NULL, NULL, 'DUF236 repeat', NULL, 'DUF236', NULL, NULL, 4615, 9),
(261137, NULL, 'PF15658', NULL, NULL, 'Latrotoxin C-terminal domain', NULL, 'Latrotoxin_C', NULL, NULL, 25436, 9),
(261138, NULL, 'PF07898', NULL, NULL, 'Protein of unknown function (DUF1676)', NULL, 'DUF1676', NULL, NULL, 14153, 9),
(261139, NULL, 'PF00036', NULL, NULL, 'EF hand', NULL, 'EF-hand_1', NULL, NULL, 1368, 9),
(261140, NULL, 'PF00669', NULL, NULL, 'Bacterial flagellin N-terminal helical region', NULL, 'Flagellin_N', NULL, NULL, 1435, 9),
(261141, NULL, 'PF12503', NULL, NULL, 'Cucumber mosaic virus 1a protein C terminal', NULL, 'CMV_1a_C', NULL, NULL, 21061, 9),
(261142, NULL, 'PF04717', NULL, NULL, 'Type VI secretion system/phage-baseplate injector OB domain', NULL, 'Phage_base_V', NULL, NULL, 53, 9),
(261143, NULL, 'PF13459', NULL, NULL, '4Fe-4S single cluster domain', NULL, 'Fer4_15', NULL, NULL, NULL, 9),
(261144, NULL, 'PF05097', NULL, NULL, 'Protein of unknown function (DUF688)', NULL, 'DUF688', NULL, NULL, 2126, 9),
(261145, NULL, 'PF07767', NULL, NULL, 'Nop53 (60S ribosomal biogenesis)', NULL, 'Nop53', NULL, NULL, 10804, 9),
(261146, NULL, 'PF20612', NULL, NULL, 'SHOCT domain', NULL, 'SHOCT_2', NULL, NULL, 37527, 9),
(261147, NULL, 'PF04797', NULL, NULL, 'Herpesvirus dUTPase protein', NULL, 'Herpes_ORF11', NULL, NULL, 4659, 9),
(261148, NULL, 'PF06001', NULL, NULL, 'CREB-binding protein/p300, atypical RING domain', NULL, 'RING_CBP-p300', NULL, NULL, 7892, 9),
(261149, NULL, 'PF15292', NULL, NULL, 'Treslin N-terminus', NULL, 'Treslin_N', NULL, NULL, 22394, 9); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(261150, NULL, 'PF15687', NULL, NULL, 'Nuclear receptor-interacting protein 1 repression 1', NULL, 'NRIP1_repr_1', NULL, NULL, 26019, 9),
(261151, NULL, 'PF01802', NULL, NULL, 'Herpesvirus VP23 like capsid protein', NULL, 'Herpes_V23', NULL, NULL, 2760, 9),
(261152, NULL, 'PF04295', NULL, NULL, 'D-galactarate dehydratase / Altronate hydrolase, C terminus', NULL, 'GD_AH_C', NULL, NULL, 3581, 9),
(261153, NULL, 'PF12426', NULL, NULL, 'RNA dependent RNA polymerase', NULL, 'DUF3674', NULL, NULL, 22175, 9),
(261154, NULL, 'PF10738', NULL, NULL, 'Probable lipoprotein LpqN', NULL, 'Lpp-LpqN', NULL, NULL, 19669, 9),
(261155, NULL, 'PF15356', NULL, NULL, 'Psoriasis susceptibility locus 2', NULL, 'SPR1', NULL, NULL, 26453, 9),
(261156, NULL, 'PF03377', NULL, NULL, 'TAL effector repeat', NULL, 'TAL_effector', NULL, NULL, 2272, 9),
(261157, NULL, 'PF05216', NULL, NULL, 'UNC-50 family', NULL, 'UNC-50', NULL, NULL, 3346, 9),
(261158, NULL, 'PF18780', NULL, NULL, 'Homing endonuclease associated repeat', NULL, 'HNH_repeat', NULL, NULL, 28343, 9),
(261159, NULL, 'PF19294', NULL, NULL, 'Diadenylate cyclase, N-terminal', NULL, 'DACZ_N', NULL, NULL, 36286, 9),
(261160, NULL, 'PF11693', NULL, NULL, 'Protein of unknown function (DUF2990)', NULL, 'DUF2990', NULL, NULL, 19456, 9),
(261161, NULL, 'PF08100', NULL, NULL, 'Dimerisation domain', NULL, 'Dimerisation', NULL, NULL, 11976, 9),
(261162, NULL, 'PF09224', NULL, NULL, 'Domain of unknown function (DUF1961)', NULL, 'DUF1961', NULL, NULL, 13073, 9),
(261163, NULL, 'PF16856', NULL, NULL, 'Cell division control protein 4 dimerisation domain', NULL, 'CDC4_D', NULL, NULL, 22630, 9),
(261164, NULL, 'PF04499', NULL, NULL, 'SIT4 phosphatase-associated protein', NULL, 'SAPS', NULL, NULL, 2827, 9),
(261165, NULL, 'PF02522', NULL, NULL, 'Aminoglycoside 3-N-acetyltransferase', NULL, 'Antibiotic_NAT', NULL, NULL, 1188, 9),
(261166, NULL, 'PF05791', NULL, NULL, 'Bacillus haemolytic enterotoxin (HBL)', NULL, 'Bacillus_HBL', NULL, NULL, 8729, 9),
(261167, NULL, 'PF13374', NULL, NULL, 'Tetratricopeptide repeat', NULL, 'TPR_10', NULL, NULL, NULL, 9),
(261168, NULL, 'PF16472', NULL, NULL, 'Domain of unknown function (DUF5050)', NULL, 'DUF5050', NULL, NULL, 18138, 9),
(261169, NULL, 'PF14415', NULL, NULL, 'Domain of unknown function (DUF4424)', NULL, 'DUF4424', NULL, NULL, 26423, 9),
(261170, NULL, 'PF19322', NULL, NULL, 'E3 ubiquitin-protein ligase RKP N-terminus', NULL, 'RKP_N', NULL, NULL, 34018, 9),
(261171, NULL, 'PF05024', NULL, NULL, 'N-acetylglucosaminyl transferase component (Gpi1)', NULL, 'Gpi1', NULL, NULL, 1321, 9),
(261172, NULL, 'PF04539', NULL, NULL, 'Sigma-70 region 3', NULL, 'Sigma70_r3', NULL, NULL, 2831, 9),
(261173, NULL, 'PF18829', NULL, NULL, 'Importin repeat 6', NULL, 'Importin_rep_6', NULL, NULL, 29110, 9),
(261174, NULL, 'PF10895', NULL, NULL, 'Domain of unknown function (DUF2715)', NULL, 'DUF2715', NULL, NULL, 24871, 9),
(261175, NULL, 'PF14996', NULL, NULL, 'Retinal Maintenance', NULL, 'RMP', NULL, NULL, 21731, 9),
(261176, NULL, 'PF16809', NULL, NULL, 'NleF caspase inhibitor', NULL, 'NleF_casp_inhib', NULL, NULL, 22157, 9),
(261177, NULL, 'PF10717', NULL, NULL, 'Occlusion-derived virus envelope protein ODV-E18', NULL, 'ODV-E18', NULL, NULL, 20749, 9),
(261178, NULL, 'PF12744', NULL, NULL, 'Autophagy protein Atg19, Atg8-binding', NULL, 'ATG19', NULL, NULL, 26231, 9),
(261179, NULL, 'PF16945', NULL, NULL, 'Putative lactococcus lactis phage r1t holin', NULL, 'Phage_r1t_holin', NULL, NULL, 12726, 9),
(261180, NULL, 'PF12085', NULL, NULL, 'Protein of unknown function (DUF3562)', NULL, 'DUF3562', NULL, NULL, 20347, 9),
(261181, NULL, 'PF08153', NULL, NULL, 'NGP1NT (NUC091) domain', NULL, 'NGP1NT', NULL, NULL, 11839, 9),
(261182, NULL, 'PF12021', NULL, NULL, 'Protein of unknown function (DUF3509)', NULL, 'DUF3509', NULL, NULL, 19865, 9),
(261183, NULL, 'PF01376', NULL, NULL, 'Heat-labile enterotoxin beta chain', NULL, 'Enterotoxin_b', NULL, NULL, 4300, 9),
(261184, NULL, 'PF07547', NULL, NULL, 'RSD-2 N-terminal domain', NULL, 'RSD-2', NULL, NULL, 12688, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(261185, NULL, 'PF13072', NULL, NULL, 'Mother cell inhibitor of FtsZ', NULL, 'MciZ', NULL, NULL, 21325, 9),
(261186, NULL, 'PF13907', NULL, NULL, 'Domain of unknown function (DUF4208)', NULL, 'DUF4208', NULL, NULL, 23289, 9),
(261187, NULL, 'PF17625', NULL, NULL, 'Family of unknown function (DUF5509)', NULL, 'DUF5509', NULL, NULL, 17072, 9),
(261188, NULL, 'PF06716', NULL, NULL, 'Movement protein p6', NULL, 'MP_p6', NULL, NULL, 1575, 9),
(261189, NULL, 'PF14882', NULL, NULL, 'Integrase repeat unit', NULL, 'INT_rpt', NULL, NULL, 22736, 9),
(261190, NULL, 'PF00979', NULL, NULL, 'Reovirus outer capsid protein, Sigma 3', NULL, 'Reovirus_cap', NULL, NULL, 1803, 9),
(261191, NULL, 'PF02498', NULL, NULL, 'BRO family, N-terminal domain', NULL, 'Bro-N', NULL, NULL, 6156, 9),
(261192, NULL, 'PF02508', NULL, NULL, 'Rnf-Nqr subunit, membrane protein', NULL, 'Rnf-Nqr', NULL, NULL, 1320, 9),
(261193, NULL, 'PF19933', NULL, NULL, 'Domain of unknown function (DUF6396)', NULL, 'DUF6396', NULL, NULL, 33579, 9),
(261194, NULL, 'PF02166', NULL, NULL, 'Androgen receptor', NULL, 'Androgen_recep', NULL, NULL, 2484, 9),
(261195, NULL, 'PF09900', NULL, NULL, 'Predicted membrane protein (DUF2127)', NULL, 'DUF2127', NULL, NULL, 15303, 9),
(261196, NULL, 'PF10693', NULL, NULL, 'Protein of unknown function (DUF2499)', NULL, 'DUF2499', NULL, NULL, 20610, 9),
(261197, NULL, 'PF18685', NULL, NULL, 'Family of unknown function (DUF5635)', NULL, 'DUF5635', NULL, NULL, 28191, 9),
(261198, NULL, 'PF04183', NULL, NULL, 'IucA / IucC family', NULL, 'IucA_IucC', NULL, NULL, 4794, 9),
(261199, NULL, 'PF07476', NULL, NULL, 'Methylaspartate ammonia-lyase C-terminus', NULL, 'MAAL_C', NULL, NULL, 16904, 9),
(261200, NULL, 'PF09855', NULL, NULL, 'Nucleic-acid-binding protein containing Zn-ribbon domain (DUF2082)', NULL, 'zinc_ribbon_13', NULL, NULL, 16688, 9),
(261201, NULL, 'PF07818', NULL, NULL, 'HCNGP-like protein', NULL, 'HCNGP', NULL, NULL, 11844, 9),
(261202, NULL, 'PF14497', NULL, NULL, 'Glutathione S-transferase, C-terminal domain', NULL, 'GST_C_3', NULL, NULL, 964, 9),
(261203, NULL, 'PF07708', NULL, NULL, 'Tash protein PEST motif', NULL, 'Tash_PEST', NULL, NULL, 10659, 9),
(261204, NULL, 'PF14531', NULL, NULL, 'Kinase-like', NULL, 'Kinase-like', NULL, NULL, 24396, 9),
(261205, NULL, 'PF04010', NULL, NULL, 'Protein of unknown function (DUF357)', NULL, 'DUF357', NULL, NULL, 17154, 9),
(261206, NULL, 'PF14809', NULL, NULL, 'C1 domain of tRNA-guanine transglycosylase dimerisation', NULL, 'TGT_C1', NULL, NULL, 26192, 9),
(261207, NULL, 'PF10737', NULL, NULL, 'Spore germination protein GerPC', NULL, 'GerPC', NULL, NULL, 19740, 9),
(261208, NULL, 'PF17862', NULL, NULL, 'AAA+ lid domain', NULL, 'AAA_lid_3', NULL, NULL, 30479, 9),
(261209, NULL, 'PF06791', NULL, NULL, 'Prophage tail length tape measure protein', NULL, 'TMP_2', NULL, NULL, 1948, 9),
(261210, NULL, 'PF19386', NULL, NULL, 'Family of unknown function (DUF5961)', NULL, 'DUF5961', NULL, NULL, 36832, 9),
(261211, NULL, 'PF18514', NULL, NULL, 'Get5 C-terminal domain', NULL, 'Get5_C', NULL, NULL, 27606, 9),
(261212, NULL, 'PF04349', NULL, NULL, 'Periplasmic glucan biosynthesis protein, MdoG', NULL, 'MdoG', NULL, NULL, 4758, 9),
(261213, NULL, 'PF00875', NULL, NULL, 'DNA photolyase', NULL, 'DNA_photolyase', NULL, NULL, 2797, 9),
(261214, NULL, 'PF07287', NULL, NULL, 'Acyclic terpene utilisation family protein AtuA', NULL, 'AtuA', NULL, NULL, 11531, 9),
(261215, NULL, 'PF09526', NULL, NULL, 'Probable metal-binding protein (DUF2387)', NULL, 'DUF2387', NULL, NULL, 10244, 9),
(261216, NULL, 'PF05377', NULL, NULL, 'Flagella accessory protein C (FlaC)', NULL, 'FlaC_arch', NULL, NULL, 10140, 9),
(261217, NULL, 'PF17954', NULL, NULL, 'Quercetinase C-terminal cupin domain', NULL, 'Pirin_C_2', NULL, NULL, 30524, 9),
(261218, NULL, 'PF07318', NULL, NULL, 'Protein of unknown function (DUF1464)', NULL, 'DUF1464', NULL, NULL, 8101, 9),
(261219, NULL, 'PF19926', NULL, NULL, 'Family of unknown function (DUF6389)', NULL, 'DUF6389', NULL, NULL, 36292, 9),
(261220, NULL, 'PF16020', NULL, NULL, 'Deltamethrin resistance', NULL, 'Deltameth_res', NULL, NULL, 22717, 9); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(261221, NULL, 'PF16737', NULL, NULL, 'PHD finger protein 12 MRG binding domain', NULL, 'PHF12_MRG_bd', NULL, NULL, 22821, 9),
(261222, NULL, 'PF05990', NULL, NULL, 'Alpha/beta hydrolase of unknown function (DUF900)', NULL, 'DUF900', NULL, NULL, 7664, 9),
(261223, NULL, 'PF07922', NULL, NULL, 'Glycosyltransferase family 52', NULL, 'Glyco_transf_52', NULL, NULL, 11968, 9),
(261224, NULL, 'PF11355', NULL, NULL, 'Protein of unknown function (DUF3157)', NULL, 'DUF3157', NULL, NULL, 18785, 9),
(261225, NULL, 'PF11839', NULL, NULL, 'Alanine-zipper, major outer membrane lipoprotein', NULL, 'Alanine_zipper', NULL, NULL, 19151, 9),
(261226, NULL, 'PF04303', NULL, NULL, 'PrpF protein', NULL, 'PrpF', NULL, NULL, 3782, 9),
(261227, NULL, 'PF10056', NULL, NULL, 'Uncharacterized conserved protein (DUF2293)', NULL, 'DUF2293', NULL, NULL, 18090, 9),
(261228, NULL, 'PF12274', NULL, NULL, 'Protein of unknown function (DUF3615)', NULL, 'DUF3615', NULL, NULL, 20824, 9),
(261229, NULL, 'PF05800', NULL, NULL, 'Gas vesicle synthesis protein GvpO', NULL, 'GvpO', NULL, NULL, 14345, 9),
(261230, NULL, 'PF01931', NULL, NULL, 'Protein of unknown function DUF84', NULL, 'NTPase_I-T', NULL, NULL, 21070, 9),
(261231, NULL, 'PF20443', NULL, NULL, 'Lamina-associated polypeptide 1, N-terminal', NULL, 'LAP1_N', NULL, NULL, 33729, 9),
(261232, NULL, 'PF18607', NULL, NULL, 'ParA helix turn helix domain', NULL, 'HTH_54', NULL, NULL, 29846, 9),
(261233, NULL, 'PF09353', NULL, NULL, 'Domain of unknown function (DUF1995)', NULL, 'DUF1995', NULL, NULL, 14665, 9),
(261234, NULL, 'PF19773', NULL, NULL, 'Domain of unknown function (DUF6259)', NULL, 'DUF6259', NULL, NULL, 37095, 9),
(261235, NULL, 'PF15908', NULL, NULL, 'Hyaluronan mediated motility receptor C-terminal', NULL, 'HMMR_C', NULL, NULL, 24254, 9),
(261236, NULL, 'PF02304', NULL, NULL, 'Scaffold protein B', NULL, 'Phage_B', NULL, NULL, 6385, 9),
(261237, NULL, 'PF03553', NULL, NULL, 'Na+/H+ antiporter family', NULL, 'Na_H_antiporter', NULL, NULL, 9395, 9),
(261238, NULL, 'PF18370', NULL, NULL, 'Rhamnogalacturonan I lyases beta-sheet domain', NULL, 'RGI_lyase', NULL, NULL, 30330, 9),
(261239, NULL, 'PF05580', NULL, NULL, 'SpoIVB peptidase S55', NULL, 'Peptidase_S55', NULL, NULL, 12309, 9),
(261240, NULL, 'PF18126', NULL, NULL, 'Mitochondrial ribosomal protein mL59', NULL, 'Mitoc_mL59', NULL, NULL, 27562, 9),
(261241, NULL, 'PF18017', NULL, NULL, 'SAM domain (Sterile alpha motif)', NULL, 'SAM_4', NULL, NULL, NULL, 9),
(261242, NULL, 'PF14127', NULL, NULL, 'Domain of unknown function (DUF4294)', NULL, 'DUF4294', NULL, NULL, 24792, 9),
(261243, NULL, 'PF13995', NULL, NULL, 'YebF-like protein', NULL, 'YebF', NULL, NULL, 22682, 9),
(261244, NULL, 'PF15218', NULL, NULL, 'Spermatogenesis-associated protein 25', NULL, 'SPATA25', NULL, NULL, 21572, 9),
(261245, NULL, 'PF02614', NULL, NULL, 'Glucuronate isomerase', NULL, 'UxaC', NULL, NULL, 2027, 9),
(261246, NULL, 'PF09104', NULL, NULL, 'BRCA2, oligonucleotide/oligosaccharide-binding, domain 3', NULL, 'BRCA-2_OB3', NULL, NULL, 10970, 9),
(261247, NULL, 'PF06838', NULL, NULL, 'Methionine gamma-lyase', NULL, 'Met_gamma_lyase', NULL, NULL, 11015, 9),
(261248, NULL, 'PF08772', NULL, NULL, 'Nin one binding (NOB1) Zn-ribbon like', NULL, 'NOB1_Zn_bind', NULL, NULL, 13357, 9),
(261249, NULL, 'PF16130', NULL, NULL, 'Domain of unknown function (DUF4842)', NULL, 'DUF4842', NULL, NULL, 23079, 9),
(261250, NULL, 'PF17321', NULL, NULL, 'Vacuole-related protein 17', NULL, 'Vac17', NULL, NULL, 31961, 9),
(261251, NULL, 'PF00810', NULL, NULL, 'ER lumen protein retaining receptor', NULL, 'ER_lumen_recept', NULL, NULL, 3614, 9),
(261252, NULL, 'PF07231', NULL, NULL, 'Hs1pro-1 N-terminus', NULL, 'Hs1pro-1_N', NULL, NULL, 14150, 9),
(261253, NULL, 'PF18014', NULL, NULL, 'Acetyltransferase (GNAT) domain', NULL, 'Acetyltransf_18', NULL, NULL, 29307, 9),
(261254, NULL, 'PF17584', NULL, NULL, 'Bacillus competence protein S', NULL, 'ComS', NULL, NULL, 19778, 9),
(261255, NULL, 'PF19596', NULL, NULL, 'Family of unknown function (DUF6101)', NULL, 'DUF6101', NULL, NULL, 36690, 9);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(261256, NULL, 'PF18155', NULL, NULL, 'pPIWI RE three-gene island domain Z', NULL, 'pPIWI_RE_Z', NULL, NULL, NULL, 9),
(261257, NULL, 'PF06212', NULL, NULL, 'GRIM-19 protein', NULL, 'GRIM-19', NULL, NULL, 14050, 9),
(261258, NULL, 'PF09062', NULL, NULL, 'PI-PfuI Endonuclease subdomain', NULL, 'Endonuc_subdom', NULL, NULL, 9873, 9),
(261259, NULL, 'PF17963', NULL, NULL, 'Bacterial Ig domain', NULL, 'Big_9', NULL, NULL, NULL, 9),
(261260, NULL, 'PF04270', NULL, NULL, 'Streptococcal histidine triad protein', NULL, 'Strep_his_triad', NULL, NULL, 3604, 9),
(261261, NULL, 'PF01463', NULL, NULL, 'Leucine rich repeat C-terminal domain', NULL, 'LRRCT', NULL, NULL, 5745, 9),
(261262, NULL, 'PF17386', NULL, NULL, 'Lacto-N-biose phosphorylase C-terminal domain', NULL, 'LBP_C', NULL, NULL, 30526, 9),
(261263, NULL, 'PF02609', NULL, NULL, 'Exonuclease VII small subunit', NULL, 'Exonuc_VII_S', NULL, NULL, 2204, 9),
(261264, NULL, 'PF15747', NULL, NULL, 'Domain of unknown function (DUF4687)', NULL, 'DUF4687', NULL, NULL, 25263, 9),
(261265, NULL, 'PF20489', NULL, NULL, 'Birnavirus RNA dependent RNA polymerase (VP1), C-terminal', NULL, 'Birna_RdRp_C', NULL, NULL, 34056, 9),
(261266, NULL, 'PF00722', NULL, NULL, 'Glycosyl hydrolases family 16', NULL, 'Glyco_hydro_16', NULL, NULL, 3868, 9),
(261267, NULL, 'PF19009', NULL, NULL, 'Family of unknown function (DUF5738)', NULL, 'DUF5738', NULL, NULL, 35161, 9),
(261268, NULL, 'PF09396', NULL, NULL, 'Thrombin light chain', NULL, 'Thrombin_light', NULL, NULL, 15510, 9),
(261269, NULL, 'PF02169', NULL, NULL, 'LPP20 lipoprotein', NULL, 'LPP20', NULL, NULL, 13615, 9),
(261270, NULL, 'PF08292', NULL, NULL, 'RNA polymerase III subunit Rpc25', NULL, 'RNA_pol_Rbc25', NULL, NULL, 12742, 9),
(261271, NULL, 'PF17546', NULL, NULL, 'Beta defensin 50', NULL, 'Defb50', NULL, NULL, 20109, 9),
(261272, NULL, 'PF08196', NULL, NULL, 'UL2 protein', NULL, 'UL2', NULL, NULL, 13400, 9),
(261273, NULL, 'PF08337', NULL, NULL, 'Plexin cytoplasmic RasGAP domain', NULL, 'Plexin_cytopl', NULL, NULL, 12699, 9),
(261274, NULL, 'PF18596', NULL, NULL, 'Sld7 C-terminal domain', NULL, 'Sld7_C', NULL, NULL, 30366, 9),
(261275, NULL, 'PF18879', NULL, NULL, 'EspA/EspE family', NULL, 'EspA_EspE', NULL, NULL, 35056, 9),
(261276, NULL, 'PF17032', NULL, NULL, 'zinc-ribbon family', NULL, 'zinc_ribbon_15', NULL, NULL, 22698, 9),
(261277, NULL, 'PF14719', NULL, NULL, 'Phosphotyrosine interaction domain (PTB/PID)', NULL, 'PID_2', NULL, NULL, 1395, 9),
(261278, NULL, 'PF15840', NULL, NULL, 'ADP-ribosylation factor-like protein 17', NULL, 'ARL17', NULL, NULL, 25732, 9),
(261279, NULL, 'PF03634', NULL, NULL, 'TCP family transcription factor', NULL, 'TCP', NULL, NULL, 7382, 9),
(261280, NULL, 'PF15262', NULL, NULL, 'Domain of unknown function (DUF4592)', NULL, 'DUF4592', NULL, NULL, 23902, 9),
(261281, NULL, 'PF04831', NULL, NULL, 'Popeye protein conserved region', NULL, 'Popeye', NULL, NULL, 4896, 9),
(261282, NULL, 'PF01909', NULL, NULL, 'Nucleotidyltransferase domain', NULL, 'NTP_transf_2', NULL, NULL, 6955, 9),
(261283, NULL, 'PF07039', NULL, NULL, 'SGF29 tudor-like domain', NULL, 'DUF1325', NULL, NULL, 9895, 9),
(261284, NULL, 'PF10646', NULL, NULL, 'Sporulation and spore germination', NULL, 'Germane', NULL, NULL, 20307, 9),
(261285, NULL, 'PF15246', NULL, NULL, 'Nck-associated protein 5, Peripheral clock protein', NULL, 'NCKAP5', NULL, NULL, 22210, 9),
(261286, NULL, 'PF04242', NULL, NULL, 'Protein of unknown function (DUF424)', NULL, 'DUF424', NULL, NULL, 5797, 9),
(261287, NULL, 'PF12106', NULL, NULL, 'Colicin E5 ribonuclease domain', NULL, 'Colicin_E5', NULL, NULL, 20148, 9),
(261288, NULL, 'PF12875', NULL, NULL, 'Protein of unknown function (DUF3826)', NULL, 'DUF3826', NULL, NULL, 8960, 9),
(261289, NULL, 'PF16760', NULL, NULL, 'Starch/carbohydrate-binding module (family 53)', NULL, 'CBM53', NULL, NULL, 10355, 9),
(261290, NULL, 'PF20362', NULL, NULL, 'Family of unknown function (DUF6657)', NULL, 'DUF6657', NULL, NULL, 33726, 9),
(261291, NULL, 'PF03603', NULL, NULL, 'DNA polymerase III psi subunit', NULL, 'DNA_III_psi', NULL, NULL, 2362, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(261292, NULL, 'PF14498', NULL, NULL, 'Glycosyl hydrolase family 65, N-terminal domain', NULL, 'Glyco_hyd_65N_2', NULL, NULL, 21510, 9),
(261293, NULL, 'PF19482', NULL, NULL, 'Family of unknown function (DUF6018)', NULL, 'DUF6018', NULL, NULL, 36630, 9),
(261294, NULL, 'PF18517', NULL, NULL, 'Leucine zipper with capping helix domain', NULL, 'LZ3wCH', NULL, NULL, 27748, 9),
(261295, NULL, 'PF18215', NULL, NULL, 'Histone chaperone Rtt106 N-terminal domain', NULL, 'Rtt106_N', NULL, NULL, 28221, 9),
(261296, NULL, 'PF09977', NULL, NULL, 'Putative Tad-like Flp pilus-assembly', NULL, 'Tad_C', NULL, NULL, 17133, 9),
(261297, NULL, 'PF07152', NULL, NULL, 'YaeQ protein', NULL, 'YaeQ', NULL, NULL, 13416, 9),
(261298, NULL, 'PF00676', NULL, NULL, 'Dehydrogenase E1 component', NULL, 'E1_dh', NULL, NULL, 2391, 9),
(261299, NULL, 'PF08022', NULL, NULL, 'FAD-binding domain', NULL, 'FAD_binding_8', NULL, NULL, 18672, 9),
(261300, NULL, 'PF09012', NULL, NULL, 'FeoC like transcriptional regulator', NULL, 'FeoC', NULL, NULL, 8809, 9),
(261301, NULL, 'PF15655', NULL, NULL, 'NTF2 fold immunity protein', NULL, 'Imm-NTF2', NULL, NULL, 25286, 9),
(261302, NULL, 'PF15545', NULL, NULL, 'Bacterial toxin 8', NULL, 'Ntox8', NULL, NULL, 25124, 9),
(261303, NULL, 'PF04648', NULL, NULL, 'Yeast mating factor alpha hormone', NULL, 'MF_alpha', NULL, NULL, 2849, 9),
(261304, NULL, 'PF09858', NULL, NULL, 'Predicted membrane protein (DUF2085)', NULL, 'DUF2085', NULL, NULL, 19477, 9),
(261305, NULL, 'PF10721', NULL, NULL, 'Protein of unknown function (DUF2514)', NULL, 'DUF2514', NULL, NULL, 20996, 9),
(261306, NULL, 'PF08335', NULL, NULL, 'GlnD PII-uridylyltransferase', NULL, 'GlnD_UR_UTase', NULL, NULL, 12675, 9),
(261307, NULL, 'PF09665', NULL, NULL, 'Type II restriction endonuclease (RE_Alw26IDE)', NULL, 'RE_Alw26IDE', NULL, NULL, 9501, 9),
(261308, NULL, 'PF00758', NULL, NULL, 'Erythropoietin/thrombopoietin', NULL, 'EPO_TPO', NULL, NULL, 2006, 9),
(261309, NULL, 'PF01303', NULL, NULL, 'Egg lysin (Sperm-lysin)', NULL, 'Egg_lysin', NULL, NULL, 6543, 9),
(261310, NULL, 'PF06421', NULL, NULL, 'GTP-binding protein LepA C-terminus', NULL, 'LepA_C', NULL, NULL, 17889, 9),
(261311, NULL, 'PF12708', NULL, NULL, 'Pectate lyase superfamily protein', NULL, 'Pectate_lyase_3', NULL, NULL, 24860, 9),
(261312, NULL, 'PF08344', NULL, NULL, 'Transient receptor ion channel II', NULL, 'TRP_2', NULL, NULL, 12660, 9),
(261313, NULL, 'PF19949', NULL, NULL, 'Family of unknown function (DUF6411)', NULL, 'DUF6411', NULL, NULL, 37234, 9),
(261314, NULL, 'PF09331', NULL, NULL, 'Domain of unknown function (DUF1985)', NULL, 'DUF1985', NULL, NULL, 14019, 9),
(261315, NULL, 'PF13139', NULL, NULL, 'Domain of unknown function (DUF3981)', NULL, 'DUF3981', NULL, NULL, 22466, 9),
(261316, NULL, 'PF16031', NULL, NULL, 'TonB polyproline region', NULL, 'TonB_N', NULL, NULL, NULL, 9),
(261317, NULL, 'PF14575', NULL, NULL, 'Ephrin type-A receptor 2 transmembrane domain', NULL, 'EphA2_TM', NULL, NULL, 24411, 9),
(261318, NULL, 'PF00560', NULL, NULL, 'Leucine Rich Repeat', NULL, 'LRR_1', NULL, NULL, 5227, 9),
(261319, NULL, 'PF04625', NULL, NULL, 'DEC-1 protein, N-terminal region', NULL, 'DEC-1_N', NULL, NULL, 2026, 9),
(261320, NULL, 'PF04978', NULL, NULL, 'Protein of unknown function (DUF664)', NULL, 'DUF664', NULL, NULL, 6662, 9),
(261321, NULL, 'PF00555', NULL, NULL, 'delta endotoxin', NULL, 'Endotoxin_M', NULL, NULL, 1211, 9),
(261322, NULL, 'PF05712', NULL, NULL, 'MRG', NULL, 'MRG', NULL, NULL, 24527, 9),
(261323, NULL, 'PF13117', NULL, NULL, 'Cag pathogenicity island protein Cag12', NULL, 'Cag12', NULL, NULL, 25655, 9),
(261324, NULL, 'PF10213', NULL, NULL, 'Mitochondrial ribosomal subunit protein', NULL, 'MRP-S28', NULL, NULL, 15678, 9),
(261325, NULL, 'PF13174', NULL, NULL, 'Tetratricopeptide repeat', NULL, 'TPR_6', NULL, NULL, 20936, 9),
(261326, NULL, 'PF16939', NULL, NULL, 'Putative porin', NULL, 'Porin_6', NULL, NULL, 25536, 9),
(261327, NULL, 'PF18273', NULL, NULL, 'Type III R-M EcoP15I C-terminal domain', NULL, 'T3RM_EcoP15I_C', NULL, NULL, 29802, 9);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(261328, NULL, 'PF11537', NULL, NULL, 'Nitrosopumilus output domain 5', NULL, 'NitrOD5', NULL, NULL, 18689, 9),
(261329, NULL, 'PF12958', NULL, NULL, 'Protein of unknown function (DUF3847)', NULL, 'DUF3847', NULL, NULL, 20677, 9),
(261330, NULL, 'PF04252', NULL, NULL, 'Predicted SAM-dependent RNA methyltransferase', NULL, 'RNA_Me_trans', NULL, NULL, 5545, 9),
(261331, NULL, 'PF07735', NULL, NULL, 'F-box associated', NULL, 'FBA_2', NULL, NULL, 13476, 9),
(261332, NULL, 'PF11353', NULL, NULL, 'Protein of unknown function (DUF3153)', NULL, 'DUF3153', NULL, NULL, 18589, 9),
(261333, NULL, 'PF04583', NULL, NULL, 'Baculoviridae p74 conserved region', NULL, 'Baculo_p74', NULL, NULL, 215, 9),
(261334, NULL, 'PF08315', NULL, NULL, 'cwf18 pre-mRNA splicing factor', NULL, 'cwf18', NULL, NULL, 8912, 9),
(261335, NULL, 'PF04304', NULL, NULL, 'Protein of unknown function (DUF454)', NULL, 'DUF454', NULL, NULL, 3520, 9),
(261336, NULL, 'PF04697', NULL, NULL, 'pinin/SDK conserved region', NULL, 'Pinin_SDK_N', NULL, NULL, 3169, 9),
(261337, NULL, 'PF19912', NULL, NULL, 'Domain of unknown function (DUF6385)', NULL, 'DUF6385', NULL, NULL, 36520, 9),
(261338, NULL, 'PF09151', NULL, NULL, 'Domain of unknown function (DUF1936)', NULL, 'DUF1936', NULL, NULL, 10728, 9),
(261339, NULL, 'PF02737', NULL, NULL, '3-hydroxyacyl-CoA dehydrogenase, NAD binding domain', NULL, '3HCDH_N', NULL, NULL, 11392, 9),
(261340, NULL, 'PF05941', NULL, NULL, 'Chordopoxvirus A20R protein', NULL, 'Chordopox_A20R', NULL, NULL, 7980, 9),
(261341, NULL, 'PF03531', NULL, NULL, 'Structure-specific recognition protein (SSRP1)', NULL, 'SSrecog', NULL, NULL, 26917, 9),
(261342, NULL, 'PF13689', NULL, NULL, 'YfiR/HmsC-like', NULL, 'DUF4154', NULL, NULL, 23014, 9),
(261343, NULL, 'PF01567', NULL, NULL, 'Hantavirus glycoprotein G1', NULL, 'Hanta_G1', NULL, NULL, 991, 9),
(261344, NULL, 'PF08036', NULL, NULL, 'Diapausin family of antimicrobial peptide', NULL, 'Antimicrobial_6', NULL, NULL, NULL, 9),
(261345, NULL, 'PF06279', NULL, NULL, 'Protein of unknown function (DUF1033)', NULL, 'DUF1033', NULL, NULL, 9014, 9),
(261346, NULL, 'PF19702', NULL, NULL, 'Family of unknown function (DUF6200)', NULL, 'DUF6200', NULL, NULL, 36386, 9),
(261347, NULL, 'PF02040', NULL, NULL, 'Arsenical pump membrane protein', NULL, 'ArsB', NULL, NULL, 4458, 9),
(261348, NULL, 'PF08857', NULL, NULL, 'Putative ParB-like nuclease', NULL, 'ParBc_2', NULL, NULL, 14170, 9),
(261349, NULL, 'PF13264', NULL, NULL, 'Domain of unknown function (DUF4055)', NULL, 'DUF4055', NULL, NULL, 22652, 9),
(261350, NULL, 'PF16347', NULL, NULL, 'Domain of unknown function (DUF4976)', NULL, 'DUF4976', NULL, NULL, 21746, 9),
(261351, NULL, 'PF19263', NULL, NULL, 'Family of unknown function (DUF5906)', NULL, 'DUF5906', NULL, NULL, 35818, 9),
(261352, NULL, 'PF08378', NULL, NULL, 'Nuclease-related domain', NULL, 'NERD', NULL, NULL, 12490, 9),
(261353, NULL, 'PF13415', NULL, NULL, 'Galactose oxidase, central domain', NULL, 'Kelch_3', NULL, NULL, NULL, 9),
(261354, NULL, 'PF13474', NULL, NULL, 'SnoaL-like domain', NULL, 'SnoaL_3', NULL, NULL, 33283, 9),
(261355, NULL, 'PF20378', NULL, NULL, 'Family of unknown function (DUF6673)', NULL, 'DUF6673', NULL, NULL, 37030, 9),
(261356, NULL, 'PF16287', NULL, NULL, 'Domain of unknown function (DUF4933)', NULL, 'DUF4933', NULL, NULL, 21506, 9),
(261357, NULL, 'PF01268', NULL, NULL, 'Formate--tetrahydrofolate ligase', NULL, 'FTHFS', NULL, NULL, 5667, 9),
(261358, NULL, 'PF16802', NULL, NULL, 'Domain of unknown function (DUF5070)', NULL, 'DUF5070', NULL, NULL, 22027, 9),
(261359, NULL, 'PF14511', NULL, NULL, 'Type II restriction endonuclease EcoO109I', NULL, 'RE_EcoO109I', NULL, NULL, 21567, 9),
(261360, NULL, 'PF18096', NULL, NULL, 'THUMP domain-like', NULL, 'Thump_like', NULL, NULL, 29534, 9),
(261361, NULL, 'PF10332', NULL, NULL, 'Protein of unknown function (DUF2418)', NULL, 'DUF2418', NULL, NULL, 19882, 9),
(261362, NULL, 'PF15733', NULL, NULL, 'Domain of unknown function (DUF4682)', NULL, 'DUF4682', NULL, NULL, 26862, 9),
(261363, NULL, 'PF15436', NULL, NULL, 'Plasminogen-binding protein pgbA N-terminal', NULL, 'PGBA_N', NULL, NULL, 26061, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(261364, NULL, 'PF16643', NULL, NULL, 'Unstructured region on cNMP-binding protein', NULL, 'cNMPbd_u2', NULL, NULL, NULL, 9),
(261365, NULL, 'PF18667', NULL, NULL, 'Baseplate upper protein immunoglobulin like domain', NULL, 'BppU_IgG', NULL, NULL, 29525, 9),
(261366, NULL, 'PF05536', NULL, NULL, 'Neurochondrin', NULL, 'Neurochondrin', NULL, NULL, 13181, 9),
(261367, NULL, 'PF04050', NULL, NULL, 'Up-frameshift suppressor 2', NULL, 'Upf2', NULL, NULL, 1498, 9),
(261368, NULL, 'PF01612', NULL, NULL, '3''-5'' exonuclease', NULL, 'DNA_pol_A_exo1', NULL, NULL, 6979, 9),
(261369, NULL, 'PF06749', NULL, NULL, 'Protein of unknown function (DUF1218)', NULL, 'DUF1218', NULL, NULL, 1891, 9),
(261370, NULL, 'PF20399', NULL, NULL, 'PH domain', NULL, 'PH_20', NULL, NULL, 37564, 9),
(261371, NULL, 'PF11926', NULL, NULL, 'Domain of unknown function (DUF3444)', NULL, 'DUF3444', NULL, NULL, 26905, 9),
(261372, NULL, 'PF14326', NULL, NULL, 'Domain of unknown function (DUF4384)', NULL, 'DUF4384', NULL, NULL, 26169, 9),
(261373, NULL, 'PF05781', NULL, NULL, 'MRVI1 protein', NULL, 'MRVI1', NULL, NULL, 12602, 9),
(261374, NULL, 'PF06317', NULL, NULL, 'Arenavirus RNA polymerase', NULL, 'Arena_RNA_pol', NULL, NULL, 10282, 9),
(261375, NULL, 'PF09994', NULL, NULL, 'Uncharacterized alpha/beta hydrolase domain (DUF2235)', NULL, 'DUF2235', NULL, NULL, 17057, 9),
(261376, NULL, 'PF07963', NULL, NULL, 'Prokaryotic N-terminal methylation motif', NULL, 'N_methyl', NULL, NULL, 13342, 9),
(261377, NULL, 'PF15923', NULL, NULL, 'Domain of unknown function (DUF4745)', NULL, 'DUF4745', NULL, NULL, 22549, 9),
(261378, NULL, 'PF17647', NULL, NULL, 'Family of unknown function (DUF5518)', NULL, 'DUF5518', NULL, NULL, 27683, 9),
(261379, NULL, 'PF11560', NULL, NULL, 'Lamina-associated polypeptide 2 alpha', NULL, 'LAP2alpha', NULL, NULL, 18922, 9),
(261380, NULL, 'PF03227', NULL, NULL, 'Gamma interferon inducible lysosomal thiol reductase (GILT)', NULL, 'GILT', NULL, NULL, 1767, 9),
(261381, NULL, 'PF09910', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2139)', NULL, 'DUF2139', NULL, NULL, 20190, 9),
(261382, NULL, 'PF17117', NULL, NULL, 'Domain of unknown function (DUF5104)', NULL, 'DUF5104', NULL, NULL, 26072, 9),
(261383, NULL, 'PF08369', NULL, NULL, 'Proto-chlorophyllide reductase 57 kD subunit', NULL, 'PCP_red', NULL, NULL, 11763, 9),
(261384, NULL, 'PF11251', NULL, NULL, 'Protein of unknown function (DUF3050)', NULL, 'DUF3050', NULL, NULL, 23845, 9),
(261385, NULL, 'PF18098', NULL, NULL, '26S proteasome regulatory subunit RPN5 C-terminal domain', NULL, 'RPN5_C', NULL, NULL, 32363, 9),
(261386, NULL, 'PF15230', NULL, NULL, 'Serine/arginine repetitive matrix protein C-terminus', NULL, 'SRRM_C', NULL, NULL, 26147, 9),
(261387, NULL, 'PF19528', NULL, NULL, 'Family of unknown function (DUF6056)', NULL, 'DUF6056', NULL, NULL, 37453, 9),
(261388, NULL, 'PF11039', NULL, NULL, 'Protein of unknown function (DUF2824)', NULL, 'DUF2824', NULL, NULL, 16003, 9),
(261389, NULL, 'PF05902', NULL, NULL, '4.1 protein C-terminal domain (CTD)', NULL, '4_1_CTD', NULL, NULL, 7526, 9),
(261390, NULL, 'PF00516', NULL, NULL, 'Envelope glycoprotein GP120', NULL, 'GP120', NULL, NULL, 3886, 9),
(261391, NULL, 'PF02572', NULL, NULL, 'ATP:corrinoid adenosyltransferase BtuR/CobO/CobP', NULL, 'CobA_CobO_BtuR', NULL, NULL, 6293, 9),
(261392, NULL, 'PF12183', NULL, NULL, 'Restriction endonuclease NotI', NULL, 'NotI', NULL, NULL, 20134, 9),
(261393, NULL, 'PF06679', NULL, NULL, 'Protein of unknown function (DUF1180)', NULL, 'DUF1180', NULL, NULL, 10009, 9),
(261394, NULL, 'PF18508', NULL, NULL, 'Zinc finger domain', NULL, 'zf_C2H2_13', NULL, NULL, 29683, 9),
(261395, NULL, 'PF14881', NULL, NULL, 'Tubulin domain', NULL, 'Tubulin_3', NULL, NULL, 26940, 9),
(261396, NULL, 'PF09758', NULL, NULL, 'Uncharacterised conserved protein', NULL, 'FPL', NULL, NULL, 18498, 9),
(261397, NULL, 'PF15243', NULL, NULL, 'Anaphase-promoting complex subunit 15', NULL, 'ANAPC15', NULL, NULL, 25098, 9),
(261398, NULL, 'PF19917', NULL, NULL, 'MoxR-vWA-beta-propeller ternary system domain bpX1', NULL, 'bpX1', NULL, NULL, 37357, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(261399, NULL, 'PF01290', NULL, NULL, 'Thymosin beta-4 family', NULL, 'Thymosin', NULL, NULL, 1377, 9),
(261400, NULL, 'PF16161', NULL, NULL, 'Domain of unknown function (DUF4867)', NULL, 'DUF4867', NULL, NULL, 22954, 9),
(261401, NULL, 'PF14337', NULL, NULL, 'Abortive infection alpha', NULL, 'Abi_alpha', NULL, NULL, 26442, 9),
(261402, NULL, 'PF16280', NULL, NULL, 'Domain of unknown function (DUF4928)', NULL, 'DUF4928', NULL, NULL, 21972, 9),
(261403, NULL, 'PF12833', NULL, NULL, 'Helix-turn-helix domain', NULL, 'HTH_18', NULL, NULL, 13648, 9),
(261404, NULL, 'PF10317', NULL, NULL, 'Serpentine type 7TM GPCR chemoreceptor Srd', NULL, '7TM_GPCR_Srd', NULL, NULL, 16854, 9),
(261405, NULL, 'PF13204', NULL, NULL, 'Protein of unknown function (DUF4038)', NULL, 'DUF4038', NULL, NULL, 23134, 9),
(261406, NULL, 'PF01208', NULL, NULL, 'Uroporphyrinogen decarboxylase (URO-D)', NULL, 'URO-D', NULL, NULL, 1252, 9),
(261407, NULL, 'PF04322', NULL, NULL, 'Protein of unknown function (DUF473)', NULL, 'DUF473', NULL, NULL, 3877, 9),
(261408, NULL, 'PF17788', NULL, NULL, 'HypF Kae1-like domain', NULL, 'HypF_C', NULL, NULL, 29788, 9),
(261409, NULL, 'PF02791', NULL, NULL, 'DDT domain', NULL, 'DDT', NULL, NULL, 14516, 9),
(261410, NULL, 'PF10812', NULL, NULL, 'Protein of unknown function (DUF2561)', NULL, 'DUF2561', NULL, NULL, 23607, 9),
(261411, NULL, 'PF10274', NULL, NULL, 'Parkin co-regulated protein', NULL, 'ParcG', NULL, NULL, 16604, 9),
(261412, NULL, 'PF01189', NULL, NULL, '16S rRNA methyltransferase RsmB/F', NULL, 'Methyltr_RsmB-F', NULL, NULL, 3297, 9),
(261413, NULL, 'PF15810', NULL, NULL, 'Coiled-coil domain-containing protein 117', NULL, 'CCDC117', NULL, NULL, 25564, 9),
(261414, NULL, 'PF09676', NULL, NULL, 'Type IV conjugative transfer system lipoprotein (TraV)', NULL, 'TraV', NULL, NULL, 13739, 9),
(261415, NULL, 'PF10596', NULL, NULL, 'U6-snRNA interacting domain of PrP8', NULL, 'U6-snRNA_bdg', NULL, NULL, 20177, 9),
(261416, NULL, 'PF20569', NULL, NULL, 'Family of unknown function (DUF6778)', NULL, 'DUF6778', NULL, NULL, 37316, 9),
(261417, NULL, 'PF12353', NULL, NULL, 'Eukaryotic translation initiation factor 3 subunit G', NULL, 'eIF3g', NULL, NULL, 123, 9),
(261418, NULL, 'PF19488', NULL, NULL, 'Family of unknown function (DUF6024)', NULL, 'DUF6024', NULL, NULL, 36680, 9),
(261419, NULL, 'PF08443', NULL, NULL, 'RimK-like ATP-grasp domain', NULL, 'RimK', NULL, NULL, 11693, 9),
(261420, NULL, 'PF13664', NULL, NULL, 'Domain of unknown function (DUF4149)', NULL, 'DUF4149', NULL, NULL, 22405, 9),
(261421, NULL, 'PF19144', NULL, NULL, 'Family of unknown function (DUF5826)', NULL, 'DUF5826', NULL, NULL, 34292, 9),
(261422, NULL, 'PF06048', NULL, NULL, 'Domain of unknown function (DUF927)', NULL, 'DUF927', NULL, NULL, 13819, 9),
(261423, NULL, 'PF10936', NULL, NULL, 'Protein of unknown function DUF2617', NULL, 'DUF2617', NULL, NULL, 24030, 9),
(261424, NULL, 'PF14282', NULL, NULL, 'FlxA-like protein', NULL, 'FlxA', NULL, NULL, 24485, 9),
(261425, NULL, 'PF08293', NULL, NULL, 'Mitochondrial ribosomal subunit S27', NULL, 'MRP-S33', NULL, NULL, 12028, 9),
(261426, NULL, 'PF11371', NULL, NULL, 'Protein of unknown function (DUF3172)', NULL, 'DUF3172', NULL, NULL, 18985, 9),
(261427, NULL, 'PF08418', NULL, NULL, 'DNA polymerase alpha subunit B N-terminal', NULL, 'Pol_alpha_B_N', NULL, NULL, 11146, 9),
(261428, NULL, 'PF11961', NULL, NULL, 'Domain of unknown function (DUF3475)', NULL, 'DUF3475', NULL, NULL, 19841, 9),
(261429, NULL, 'PF09236', NULL, NULL, 'Alpha-haemoglobin stabilising protein', NULL, 'AHSP', NULL, NULL, 13234, 9),
(261430, NULL, 'PF17974', NULL, NULL, 'Galactose-binding domain-like', NULL, 'GalBD_like', NULL, NULL, 27778, 9),
(261431, NULL, 'PF19534', NULL, NULL, 'Family of unknown function (DUF6059)', NULL, 'DUF6059', NULL, NULL, 37430, 9),
(261432, NULL, 'PF09067', NULL, NULL, 'Erythropoietin receptor, ligand binding', NULL, 'EpoR_lig-bind', NULL, NULL, 9620, 9),
(261433, NULL, 'PF13656', NULL, NULL, 'RNA polymerase Rpb3/Rpb11 dimerisation domain', NULL, 'RNA_pol_L_2', NULL, NULL, 9640, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(261434, NULL, 'PF12350', NULL, NULL, 'CTD kinase subunit gamma CTK3 C-terminus', NULL, 'CTK3_C', NULL, NULL, 13799, 9),
(261435, NULL, 'PF14532', NULL, NULL, 'Sigma-54 interaction domain', NULL, 'Sigma54_activ_2', NULL, NULL, 5401, 9),
(261436, NULL, 'PF15307', NULL, NULL, 'Sperm acrosome-associated protein 7', NULL, 'SPACA7', NULL, NULL, 24802, 9),
(261437, NULL, 'PF09685', NULL, NULL, 'Domain of unknown function (DUF4870)', NULL, 'DUF4870', NULL, NULL, 17631, 9),
(261438, NULL, 'PF09382', NULL, NULL, 'RQC domain', NULL, 'RQC', NULL, NULL, 15627, 9),
(261439, NULL, 'PF00285', NULL, NULL, 'Citrate synthase, C-terminal domain', NULL, 'Citrate_synt', NULL, NULL, 2482, 9),
(261440, NULL, 'PF02100', NULL, NULL, 'Ornithine decarboxylase antizyme', NULL, 'ODC_AZ', NULL, NULL, 7384, 9),
(261441, NULL, 'PF00844', NULL, NULL, 'Geminivirus coat protein/nuclear export factor BR1 family', NULL, 'Gemini_coat', NULL, NULL, 4727, 9),
(261442, NULL, 'PF15685', NULL, NULL, 'Gametogenetin', NULL, 'GGN', NULL, NULL, 25349, 9),
(261443, NULL, 'PF20096', NULL, NULL, 'Family of unknown function (DUF6486)', NULL, 'DUF6486', NULL, NULL, 33844, 9),
(261444, NULL, 'PF04116', NULL, NULL, 'Fatty acid hydroxylase', NULL, 'FA_hydroxylase', NULL, NULL, 2347, 9),
(261445, NULL, 'PF12448', NULL, NULL, 'Kinesin associated protein', NULL, 'Milton', NULL, NULL, 20586, 9),
(261446, NULL, 'PF15939', NULL, NULL, 'Putative antitoxin of bacterial toxin-antitoxin system', NULL, 'YmcE_antitoxin', NULL, NULL, 24777, 9),
(261447, NULL, 'PF13476', NULL, NULL, 'AAA domain', NULL, 'AAA_23', NULL, NULL, 31660, 9),
(261448, NULL, 'PF02950', NULL, NULL, 'Conotoxin', NULL, 'Conotoxin', NULL, NULL, 3999, 9),
(261449, NULL, 'PF12928', NULL, NULL, 'tRNA-splicing endonuclease subunit sen54 N-term', NULL, 'tRNA_int_end_N2', NULL, NULL, 24513, 9),
(261450, NULL, 'PF06022', NULL, NULL, 'Plasmodium variant antigen protein Cir/Yir/Bir', NULL, 'Cir_Bir_Yir', NULL, NULL, 6130, 9),
(261451, NULL, 'PF04073', NULL, NULL, 'Aminoacyl-tRNA editing domain', NULL, 'tRNA_edit', NULL, NULL, 6286, 9),
(261452, NULL, 'PF07383', NULL, NULL, 'Protein of unknown function (DUF1496)', NULL, 'DUF1496', NULL, NULL, 8061, 9),
(261453, NULL, 'PF03847', NULL, NULL, 'Transcription initiation factor TFIID subunit A', NULL, 'TFIID_20kDa', NULL, NULL, 2961, 9),
(261454, NULL, 'PF13573', NULL, NULL, 'SprB repeat', NULL, 'SprB', NULL, NULL, 24266, 9),
(261455, NULL, 'PF06738', NULL, NULL, 'Putative threonine/serine exporter', NULL, 'ThrE', NULL, NULL, 8328, 9),
(261456, NULL, 'PF12643', NULL, NULL, 'MazG-like family', NULL, 'MazG-like', NULL, NULL, 25950, 9),
(261457, NULL, 'PF09367', NULL, NULL, 'CpeS-like protein', NULL, 'CpeS', NULL, NULL, 14729, 9),
(261458, NULL, 'PF11981', NULL, NULL, 'Domain of unknown function (DUF3482)', NULL, 'DUF3482', NULL, NULL, 19932, 9),
(261459, NULL, 'PF20546', NULL, NULL, 'Family of unknown function (DUF6760)', NULL, 'DUF6760', NULL, NULL, 33979, 9),
(261460, NULL, 'PF13096', NULL, NULL, 'CENP-A-nucleosome distal (CAD) centromere subunit, CENP-P', NULL, 'CENP-P', NULL, NULL, 23731, 9),
(261461, NULL, 'PF19566', NULL, NULL, 'Sorting nexin 8/Mvp1 BAR domain', NULL, 'Snx8_BAR_dom', NULL, NULL, 34458, 9),
(261462, NULL, 'PF19575', NULL, NULL, 'Helix-turn-helix domain', NULL, 'HTH_58', NULL, NULL, 36457, 9),
(261463, NULL, 'PF00239', NULL, NULL, 'Resolvase, N terminal domain', NULL, 'Resolvase', NULL, NULL, 10360, 9),
(261464, NULL, 'PF06062', NULL, NULL, 'Uncharacterised protein family (UPF0231)', NULL, 'UPF0231', NULL, NULL, 764, 9),
(261465, NULL, 'PF01348', NULL, NULL, 'Type II intron maturase', NULL, 'Intron_maturas2', NULL, NULL, 24917, 9),
(261466, NULL, 'PF01311', NULL, NULL, 'Bacterial export proteins, family 1', NULL, 'Bac_export_1', NULL, NULL, 4685, 9),
(261467, NULL, 'PF12548', NULL, NULL, 'Sulfatase protein', NULL, 'DUF3740', NULL, NULL, 26653, 9),
(261468, NULL, 'PF19999', NULL, NULL, 'FtsH ternary system domain X3', NULL, 'fvmX3', NULL, NULL, 35897, 9),
(261469, NULL, 'PF13238', NULL, NULL, 'AAA domain', NULL, 'AAA_18', NULL, NULL, NULL, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(261470, NULL, 'PF15852', NULL, NULL, 'Domain of unknown function (DUF4724)', NULL, 'DUF4724', NULL, NULL, 25664, 9),
(261471, NULL, 'PF13894', NULL, NULL, 'C2H2-type zinc finger', NULL, 'zf-C2H2_4', NULL, NULL, NULL, 9),
(261472, NULL, 'PF05537', NULL, NULL, 'Borrelia burgdorferi protein of unknown function (DUF759)', NULL, 'DUF759', NULL, NULL, 12123, 9),
(261473, NULL, 'PF09893', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2120)', NULL, 'DUF2120', NULL, NULL, 11320, 9),
(261474, NULL, 'PF12517', NULL, NULL, 'Protein of unknown function (DUF3720)', NULL, 'DUF3720', NULL, NULL, 21010, 9),
(261475, NULL, 'PF04894', NULL, NULL, 'Archaeal Nre, N-terminal', NULL, 'Nre_N', NULL, NULL, 5560, 9),
(261476, NULL, 'PF00613', NULL, NULL, 'Phosphoinositide 3-kinase family, accessory domain (PIK domain)', NULL, 'PI3Ka', NULL, NULL, 2267, 9),
(261477, NULL, 'PF02042', NULL, NULL, 'RWP-RK domain', NULL, 'RWP-RK', NULL, NULL, 23, 9),
(261478, NULL, 'PF15179', NULL, NULL, 'Myc target protein 1', NULL, 'Myc_target_1', NULL, NULL, 21917, 9),
(261479, NULL, 'PF18765', NULL, NULL, 'Polymerase beta, Nucleotidyltransferase', NULL, 'Polbeta', NULL, NULL, 30314, 9),
(261480, NULL, 'PF14248', NULL, NULL, 'Domain of unknown function (DUF4345)', NULL, 'DUF4345', NULL, NULL, 26219, 9),
(261481, NULL, 'PF12840', NULL, NULL, 'Helix-turn-helix domain', NULL, 'HTH_20', NULL, NULL, NULL, 9),
(261482, NULL, 'PF04826', NULL, NULL, 'Armadillo-like', NULL, 'Arm_2', NULL, NULL, 4716, 9),
(261483, NULL, 'PF11885', NULL, NULL, 'Protein of unknown function (DUF3405)', NULL, 'DUF3405', NULL, NULL, 19767, 9),
(261484, NULL, 'PF12077', NULL, NULL, 'Transmembrane protein of unknown function (DUF3556)', NULL, 'DUF3556', NULL, NULL, 20300, 9),
(261485, NULL, 'PF15970', NULL, NULL, 'HicB_like antitoxin of bacterial toxin-antitoxin system', NULL, 'HicB-like_2', NULL, NULL, 21008, 9),
(261486, NULL, 'PF03723', NULL, NULL, 'Hemocyanin, ig-like domain', NULL, 'Hemocyanin_C', NULL, NULL, 5339, 9),
(261487, NULL, 'PF10672', NULL, NULL, 'S-adenosylmethionine-dependent methyltransferase', NULL, 'Methyltrans_SAM', NULL, NULL, 20166, 9),
(261488, NULL, 'PF20325', NULL, NULL, 'Family of unknown function (DUF6620)', NULL, 'DUF6620', NULL, NULL, 37041, 9),
(261489, NULL, 'PF13148', NULL, NULL, 'Protein of unknown function (DUF3987)', NULL, 'DUF3987', NULL, NULL, 22938, 9),
(261490, NULL, 'PF17496', NULL, NULL, 'Family of unknown function (DUF5431)', NULL, 'DUF5431', NULL, NULL, 21287, 9),
(261491, NULL, 'PF08446', NULL, NULL, 'PAS fold', NULL, 'PAS_2', NULL, NULL, 11812, 9),
(261492, NULL, 'PF18016', NULL, NULL, 'SAM domain (Sterile alpha motif)', NULL, 'SAM_3', NULL, NULL, 30380, 9),
(261493, NULL, 'PF15668', NULL, NULL, 'Domain of unknown function (DUF4663)', NULL, 'DUF4663', NULL, NULL, 21562, 9),
(261494, NULL, 'PF04025', NULL, NULL, 'Domain of unknown function (DUF370)', NULL, 'DUF370', NULL, NULL, 416, 9),
(261495, NULL, 'PF05103', NULL, NULL, 'DivIVA protein', NULL, 'DivIVA', NULL, NULL, 2015, 9),
(261496, NULL, 'PF10066', NULL, NULL, 'Uncharacterized conserved protein (DUF2304)', NULL, 'DUF2304', NULL, NULL, 19774, 9),
(261497, NULL, 'PF17351', NULL, NULL, 'Family of unknown function (DUF5380)', NULL, 'DUF5380', NULL, NULL, 19608, 9),
(261498, NULL, 'PF06601', NULL, NULL, 'Orthopoxvirus F6 protein', NULL, 'Orthopox_F6', NULL, NULL, 9531, 9),
(261499, NULL, 'PF08213', NULL, NULL, 'Mitochondrial mRNA-processing protein COX24, C-terminal', NULL, 'COX24_C', NULL, NULL, 17391, 9),
(261500, NULL, 'PF08249', NULL, NULL, 'Mastoparan protein', NULL, 'Mastoparan', NULL, NULL, 17671, 9),
(261501, NULL, 'PF15210', NULL, NULL, 'Surfactant-associated protein 2', NULL, 'SFTA2', NULL, NULL, 22374, 9),
(261502, NULL, 'PF08188', NULL, NULL, 'Spermatozal protamine family', NULL, 'Protamine_3', NULL, NULL, 9010, 9),
(261503, NULL, 'PF08613', NULL, NULL, 'Cyclin', NULL, 'Cyclin', NULL, NULL, 14364, 9),
(261504, NULL, 'PF08001', NULL, NULL, 'CMV US', NULL, 'CMV_US', NULL, NULL, 12588, 9),
(261505, NULL, 'PF09811', NULL, NULL, 'Essential protein Yae1, N terminal', NULL, 'Yae1_N', NULL, NULL, 18185, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(261506, NULL, 'PF03854', NULL, NULL, 'P-11 zinc finger', NULL, 'zf-P11', NULL, NULL, 2726, 9),
(261507, NULL, 'PF06777', NULL, NULL, 'Helical and beta-bridge domain', NULL, 'HBB', NULL, NULL, 9195, 9),
(261508, NULL, 'PF08453', NULL, NULL, 'Peptidase family M9 N-terminal', NULL, 'Peptidase_M9_N', NULL, NULL, 12186, 9),
(261509, NULL, 'PF16084', NULL, NULL, 'LydA-holin antagonist', NULL, 'LydB', NULL, NULL, 22876, 9),
(261510, NULL, 'PF14342', NULL, NULL, 'Domain of unknown function (DUF4396)', NULL, 'DUF4396', NULL, NULL, 26368, 9),
(261511, NULL, 'PF02834', NULL, NULL, 'LigT like Phosphoesterase', NULL, 'LigT_PEase', NULL, NULL, 9763, 9),
(261512, NULL, 'PF07470', NULL, NULL, 'Glycosyl Hydrolase Family 88', NULL, 'Glyco_hydro_88', NULL, NULL, 12925, 9),
(261513, NULL, 'PF12733', NULL, NULL, 'Cadherin-like beta sandwich domain', NULL, 'Cadherin-like', NULL, NULL, 23115, 9),
(261514, NULL, 'PF02929', NULL, NULL, 'Beta galactosidase small chain', NULL, 'Bgal_small_N', NULL, NULL, 572, 9),
(261515, NULL, 'PF08133', NULL, NULL, 'Anticodon nuclease activator family', NULL, 'Nuclease_act', NULL, NULL, 9221, 9),
(261516, NULL, 'PF06211', NULL, NULL, 'BMP and activin membrane-bound inhibitor (BAMBI) N-terminal domain', NULL, 'BAMBI', NULL, NULL, 34404, 9),
(261517, NULL, 'PF05871', NULL, NULL, 'ESCRT-II complex subunit', NULL, 'ESCRT-II', NULL, NULL, 13279, 9),
(261518, NULL, 'PF11911', NULL, NULL, 'Protein of unknown function (DUF3429)', NULL, 'DUF3429', NULL, NULL, 19817, 9),
(261519, NULL, 'PF18031', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolases', NULL, 'UCH_C', NULL, NULL, 30332, 9),
(261520, NULL, 'PF06441', NULL, NULL, 'Epoxide hydrolase N terminus', NULL, 'EHN', NULL, NULL, 10025, 9),
(261521, NULL, 'PF14581', NULL, NULL, 'SseB protein C-terminal domain', NULL, 'SseB_C', NULL, NULL, 24200, 9),
(261522, NULL, 'PF15353', NULL, NULL, 'Headcase protein family homologue', NULL, 'HECA', NULL, NULL, 24281, 9),
(261523, NULL, 'PF07041', NULL, NULL, 'Protein of unknown function (DUF1327)', NULL, 'DUF1327', NULL, NULL, 12496, 9),
(261524, NULL, 'PF18772', NULL, NULL, 'APOBEC2', NULL, 'APOBEC2', NULL, NULL, NULL, 9),
(261525, NULL, 'PF06244', NULL, NULL, 'Coiled-coil domain-containing protein 124 /Oxs1', NULL, 'Ccdc124', NULL, NULL, 9360, 9),
(261526, NULL, 'PF19693', NULL, NULL, 'Phenol-soluble modulin delta protein', NULL, 'PSMdelta', NULL, NULL, 36455, 9),
(261527, NULL, 'PF12190', NULL, NULL, 'Fungal protease inhibitor', NULL, 'amfpi-1', NULL, NULL, 15310, 9),
(261528, NULL, 'PF16391', NULL, NULL, 'Domain of unknown function', NULL, 'DUF5000', NULL, NULL, 26059, 9),
(261529, NULL, 'PF04072', NULL, NULL, 'Leucine carboxyl methyltransferase', NULL, 'LCM', NULL, NULL, 6197, 9),
(261530, NULL, 'PF08045', NULL, NULL, 'Cell division control protein 14, SIN component', NULL, 'CDC14', NULL, NULL, 12954, 9),
(261531, NULL, 'PF13947', NULL, NULL, 'Wall-associated receptor kinase galacturonan-binding', NULL, 'GUB_WAK_bind', NULL, NULL, 23481, 9),
(261532, NULL, 'PF08114', NULL, NULL, 'ATPase proteolipid family', NULL, 'PMP1_2', NULL, NULL, 9238, 9),
(261533, NULL, 'PF09133', NULL, NULL, 'SANTA (SANT Associated)', NULL, 'SANTA', NULL, NULL, 10915, 9),
(261534, NULL, 'PF08717', NULL, NULL, 'Coronavirus replicase NSP8', NULL, 'CoV_NSP8', NULL, NULL, 11972, 9),
(261535, NULL, 'PF08787', NULL, NULL, 'Alginate lyase', NULL, 'Alginate_lyase2', NULL, NULL, 13028, 9),
(261536, NULL, 'PF12975', NULL, NULL, 'Domain of unknown function (DUF3859)', NULL, 'DUF3859', NULL, NULL, 26691, 9),
(261537, NULL, 'PF09918', NULL, NULL, 'Uncharacterized protein containing a ferredoxin domain (DUF2148)', NULL, 'DUF2148', NULL, NULL, 19365, 9),
(261538, NULL, 'PF12260', NULL, NULL, 'Protein-kinase domain of FAM69', NULL, 'PIP49_C', NULL, NULL, 20260, 9),
(261539, NULL, 'PF06859', NULL, NULL, 'Bicoid-interacting protein 3 (Bin3)', NULL, 'Bin3', NULL, NULL, 9340, 9),
(261540, NULL, 'PF04723', NULL, NULL, 'Glycine reductase complex selenoprotein A', NULL, 'GRDA', NULL, NULL, 3806, 9),
(261541, NULL, 'PF10538', NULL, NULL, 'Hantavirus ITAM motif', NULL, 'ITAM_Cys-rich', NULL, NULL, 11567, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(261542, NULL, 'PF13091', NULL, NULL, 'PLD-like domain', NULL, 'PLDc_2', NULL, NULL, 21861, 9),
(261543, NULL, 'PF08964', NULL, NULL, 'Beta/Gamma crystallin', NULL, 'Crystall_3', NULL, NULL, 8520, 9),
(261544, NULL, 'PF05412', NULL, NULL, 'Equine arterivirus Nsp2-type cysteine proteinase', NULL, 'Peptidase_C33', NULL, NULL, 12180, 9),
(261545, NULL, 'PF09957', NULL, NULL, 'Bacterial antitoxin of type II TA system, VapB', NULL, 'VapB_antitoxin', NULL, NULL, 19083, 9),
(261546, NULL, 'PF15476', NULL, NULL, 'Histone deacetylase complex subunit SAP25', NULL, 'SAP25', NULL, NULL, 26570, 9),
(261547, NULL, 'PF04823', NULL, NULL, 'Herpesvirus UL49 tegument protein', NULL, 'Herpes_UL49_2', NULL, NULL, 4663, 9),
(261548, NULL, 'PF09743', NULL, NULL, 'E3 UFM1-protein ligase 1', NULL, 'E3_UFM1_ligase', NULL, NULL, 16399, 9),
(261549, NULL, 'PF03901', NULL, NULL, 'Alg9-like mannosyltransferase family', NULL, 'Glyco_transf_22', NULL, NULL, 2796, 9),
(261550, NULL, 'PF06692', NULL, NULL, 'Melon necrotic spot virus P7B protein', NULL, 'MNSV_P7B', NULL, NULL, 920, 9),
(261551, NULL, 'PF12422', NULL, NULL, 'Condensin II non structural maintenance of chromosomes subunit', NULL, 'Condensin2nSMC', NULL, NULL, 10284, 9),
(261552, NULL, 'PF15502', NULL, NULL, 'M-phase-specific PLK1-interacting protein', NULL, 'MPLKIP', NULL, NULL, 23480, 9),
(261553, NULL, 'PF10599', NULL, NULL, 'Retro-transposon transporting motif', NULL, 'Nup_retrotrp_bd', NULL, NULL, 20661, 9),
(261554, NULL, 'PF13294', NULL, NULL, 'Domain of unknown function (DUF4075)', NULL, 'DUF4075', NULL, NULL, 25513, 9),
(261555, NULL, 'PF04285', NULL, NULL, 'Protein of unknown function (DUF444)', NULL, 'DUF444', NULL, NULL, 2418, 9),
(261556, NULL, 'PF08379', NULL, NULL, 'Bacterial transglutaminase-like N-terminal region', NULL, 'Bact_transglu_N', NULL, NULL, 11873, 9),
(261557, NULL, 'PF10242', NULL, NULL, 'Lipoma HMGIC fusion partner-like protein', NULL, 'L_HMGIC_fpl', NULL, NULL, 15529, 9),
(261558, NULL, 'PF11084', NULL, NULL, 'Protein of unknown function (DUF2621)', NULL, 'DUF2621', NULL, NULL, 17947, 9),
(261559, NULL, 'PF18530', NULL, NULL, 'Swi6 N-terminal domain', NULL, 'Swi6_N', NULL, NULL, 29041, 9),
(261560, NULL, 'PF05787', NULL, NULL, 'Bacterial protein of unknown function (DUF839)', NULL, 'DUF839', NULL, NULL, 13111, 9),
(261561, NULL, 'PF09678', NULL, NULL, 'Cytochrome c oxidase caa3 assembly factor (Caa3_CtaG)', NULL, 'Caa3_CtaG', NULL, NULL, 17832, 9),
(261562, NULL, 'PF10296', NULL, NULL, 'Maintenance of mitochondrial morphology protein 1', NULL, 'MMM1', NULL, NULL, 16738, 9),
(261563, NULL, 'PF02067', NULL, NULL, 'Metallothionein family 5', NULL, 'Metallothio_5', NULL, NULL, 225, 9),
(261564, NULL, 'PF06025', NULL, NULL, 'Domain of Unknown Function (DUF913)', NULL, 'DUF913', NULL, NULL, 8822, 9),
(261565, NULL, 'PF00998', NULL, NULL, 'Viral RNA dependent RNA polymerase', NULL, 'RdRP_3', NULL, NULL, 5398, 9),
(261566, NULL, 'PF07347', NULL, NULL, 'NADH:ubiquinone oxidoreductase subunit B14.5a (Complex I-B14.5a)', NULL, 'CI-B14_5a', NULL, NULL, 8470, 9),
(261567, NULL, 'PF15678', NULL, NULL, 'Centriole duplication and mitotic chromosome congression', NULL, 'SPICE', NULL, NULL, 25445, 9),
(261568, NULL, 'PF16510', NULL, NULL, 'Phage P22-like portal protein', NULL, 'P22_portal', NULL, NULL, 25413, 9),
(261569, NULL, 'PF00184', NULL, NULL, 'Neurohypophysial hormones, C-terminal Domain', NULL, 'Hormone_5', NULL, NULL, 24, 9),
(261570, NULL, 'PF02784', NULL, NULL, 'Pyridoxal-dependent decarboxylase, pyridoxal binding domain', NULL, 'Orn_Arg_deC_N', NULL, NULL, 17234, 9),
(261571, NULL, 'PF05029', NULL, NULL, 'Timeless PAB domain', NULL, 'TIMELESS_C', NULL, NULL, 1339, 9),
(261572, NULL, 'PF11100', NULL, NULL, 'Conjugal transfer protein TrbE', NULL, 'TrbE', NULL, NULL, 16866, 9),
(261573, NULL, 'PF06967', NULL, NULL, 'Mo-dependent nitrogenase C-terminus', NULL, 'Mo-nitro_C', NULL, NULL, 12407, 9),
(261574, NULL, 'PF14431', NULL, NULL, 'YwqJ-like deaminase', NULL, 'YwqJ-deaminase', NULL, NULL, 24316, 9),
(261575, NULL, 'PF01563', NULL, NULL, 'Alphavirus E3 glycoprotein', NULL, 'Alpha_E3_glycop', NULL, NULL, 605, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(261576, NULL, 'PF09587', NULL, NULL, 'Bacterial capsule synthesis protein PGA_cap', NULL, 'PGA_cap', NULL, NULL, 16886, 9),
(261577, NULL, 'PF10652', NULL, NULL, 'Protein of unknown function (DUF2480)', NULL, 'DUF2480', NULL, NULL, 14599, 9),
(261578, NULL, 'PF01529', NULL, NULL, 'DHHC palmitoyltransferase', NULL, 'DHHC', NULL, NULL, 3458, 9),
(261579, NULL, 'PF15608', NULL, NULL, 'PELOTA RNA binding domain', NULL, 'PELOTA_1', NULL, NULL, 22866, 9),
(261580, NULL, 'PF19353', NULL, NULL, 'Family of unknown function (DUF5930)', NULL, 'DUF5930', NULL, NULL, 36579, 9),
(261581, NULL, 'PF18496', NULL, NULL, 'Collagenase G catalytic helper subdomain', NULL, 'ColG_sub', NULL, NULL, 29335, 9),
(261582, NULL, 'PF04018', NULL, NULL, 'Domain of unknown function (DUF368)', NULL, 'DUF368', NULL, NULL, 246, 9),
(261583, NULL, 'PF02874', NULL, NULL, 'ATP synthase alpha/beta family, beta-barrel domain', NULL, 'ATP-synt_ab_N', NULL, NULL, 1680, 9),
(261584, NULL, 'PF14118', NULL, NULL, 'YfzA-like protein', NULL, 'YfzA', NULL, NULL, 24031, 9),
(261585, NULL, 'PF08760', NULL, NULL, 'Domain of unknown function (DUF1793)', NULL, 'DUF1793', NULL, NULL, 13330, 9),
(261586, NULL, 'PF11747', NULL, NULL, 'Killing trait', NULL, 'RebB', NULL, NULL, 15146, 9),
(261587, NULL, 'PF01277', NULL, NULL, 'Oleosin', NULL, 'Oleosin', NULL, NULL, 1548, 9),
(261588, NULL, 'PF04104', NULL, NULL, 'Eukaryotic and archaeal DNA primase, large subunit', NULL, 'DNA_primase_lrg', NULL, NULL, 6887, 9),
(261589, NULL, 'PF06680', NULL, NULL, 'Protein of unknown function (DUF1181)', NULL, 'DUF1181', NULL, NULL, 10134, 9),
(261590, NULL, 'PF20508', NULL, NULL, 'Family of unknown function (DUF6734)', NULL, 'DUF6734', NULL, NULL, 33671, 9),
(261591, NULL, 'PF04387', NULL, NULL, 'Protein tyrosine phosphatase-like protein, PTPLA', NULL, 'PTPLA', NULL, NULL, 10293, 9),
(261592, NULL, 'PF04466', NULL, NULL, 'Phage terminase large subunit', NULL, 'Terminase_3', NULL, NULL, 16666, 9),
(261593, NULL, 'PF13286', NULL, NULL, 'Phosphohydrolase-associated domain', NULL, 'HD_assoc', NULL, NULL, 26864, 9),
(261594, NULL, 'PF15527', NULL, NULL, 'Bacterial toxin 22', NULL, 'Ntox22', NULL, NULL, 23936, 9),
(261595, NULL, 'PF09390', NULL, NULL, 'Protein of unknown function (DUF1999)', NULL, 'DUF1999', NULL, NULL, 15813, 9),
(261596, NULL, 'PF00231', NULL, NULL, 'ATP synthase', NULL, 'ATP-synt', NULL, NULL, 1624, 9),
(261597, NULL, 'PF12236', NULL, NULL, 'Bacteriophage head to tail connecting protein', NULL, 'Head-tail_con', NULL, NULL, 14848, 9),
(261598, NULL, 'PF00447', NULL, NULL, 'HSF-type DNA-binding', NULL, 'HSF_DNA-bind', NULL, NULL, 689, 9),
(261599, NULL, 'PF00863', NULL, NULL, 'Peptidase family C4', NULL, 'Peptidase_C4', NULL, NULL, 3075, 9),
(261600, NULL, 'PF06034', NULL, NULL, 'Nucleopolyhedrovirus protein of unknown function (DUF919)', NULL, 'DUF919', NULL, NULL, 13933, 9),
(261601, NULL, 'PF02704', NULL, NULL, 'Gibberellin regulated protein', NULL, 'GASA', NULL, NULL, 3376, 9),
(261602, NULL, 'PF19774', NULL, NULL, 'Family of unknown function (DUF6260)', NULL, 'DUF6260', NULL, NULL, 37086, 9),
(261603, NULL, 'PF09909', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2138)', NULL, 'DUF2138', NULL, NULL, 17435, 9),
(261604, NULL, 'PF11734', NULL, NULL, 'TilS substrate C-terminal domain', NULL, 'TilS_C', NULL, NULL, 9843, 9),
(261605, NULL, 'PF13380', NULL, NULL, 'CoA binding domain', NULL, 'CoA_binding_2', NULL, NULL, 3353, 9),
(261606, NULL, 'PF14334', NULL, NULL, 'Domain of unknown function (DUF4390)', NULL, 'DUF4390', NULL, NULL, 26384, 9),
(261607, NULL, 'PF00638', NULL, NULL, 'RanBP1 domain', NULL, 'Ran_BP1', NULL, NULL, 1949, 9),
(261608, NULL, 'PF09134', NULL, NULL, 'Invasin, domain 3', NULL, 'Invasin_D3', NULL, NULL, 10813, 9),
(261609, NULL, 'PF00080', NULL, NULL, 'Copper/zinc superoxide dismutase (SODC)', NULL, 'Sod_Cu', NULL, NULL, 3239, 9),
(261610, NULL, 'PF09608', NULL, NULL, 'Putative transmembrane protein (Alph_Pro_TM)', NULL, 'Alph_Pro_TM', NULL, NULL, 16786, 9),
(261611, NULL, 'PF18073', NULL, NULL, 'Rubredoxin metal binding domain', NULL, 'Rubredoxin_2', NULL, NULL, 28634, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(261612, NULL, 'PF05274', NULL, NULL, 'Occlusion-derived virus envelope protein E25', NULL, 'Baculo_E25', NULL, NULL, 4236, 9),
(261613, NULL, 'PF01043', NULL, NULL, 'SecA preprotein cross-linking domain', NULL, 'SecA_PP_bind', NULL, NULL, 9839, 9),
(261614, NULL, 'PF13109', NULL, NULL, 'AsmA-like C-terminal region', NULL, 'AsmA_1', NULL, NULL, 30504, 9),
(261615, NULL, 'PF07655', NULL, NULL, 'Secretin N-terminal domain', NULL, 'Secretin_N_2', NULL, NULL, 12838, 9),
(261616, NULL, 'PF03193', NULL, NULL, 'RsgA GTPase', NULL, 'RsgA_GTPase', NULL, NULL, 5304, 9),
(261617, NULL, 'PF05596', NULL, NULL, 'Taeniidae antigen', NULL, 'Taeniidae_ag', NULL, NULL, 13513, 9),
(261618, NULL, 'PF07951', NULL, NULL, 'Clostridium neurotoxin, C-terminal receptor binding', NULL, 'Toxin_R_bind_C', NULL, NULL, 18989, 9),
(261619, NULL, 'PF12704', NULL, NULL, 'MacB-like periplasmic core domain', NULL, 'MacB_PCD', NULL, NULL, 23413, 9),
(261620, NULL, 'PF09992', NULL, NULL, 'Phosphodiester glycosidase', NULL, 'NAGPA', NULL, NULL, 17218, 9),
(261621, NULL, 'PF02920', NULL, NULL, 'DNA binding domain of tn916 integrase', NULL, 'Integrase_DNA', NULL, NULL, 2946, 9),
(261622, NULL, 'PF12016', NULL, NULL, 'Stonin 2', NULL, 'Stonin2_N', NULL, NULL, 14838, 9),
(261623, NULL, 'PF14941', NULL, NULL, 'Transcriptional regulator, Out at first', NULL, 'OAF', NULL, NULL, 25717, 9),
(261624, NULL, 'PF09635', NULL, NULL, 'MetRS-N binding domain', NULL, 'MetRS-N', NULL, NULL, 17237, 9),
(261625, NULL, 'PF11345', NULL, NULL, 'Protein of unknown function (DUF3147)', NULL, 'DUF3147', NULL, NULL, 18850, 9),
(261626, NULL, 'PF08703', NULL, NULL, 'PLC-beta C terminal', NULL, 'PLC-beta_C', NULL, NULL, 11869, 9),
(261627, NULL, 'PF12470', NULL, NULL, 'Suppressor of Fused Gli/Ci N terminal binding domain', NULL, 'SUFU_C', NULL, NULL, 26952, 9),
(261628, NULL, 'PF15955', NULL, NULL, 'Cuticle protein', NULL, 'Cuticle_4', NULL, NULL, 26136, 9),
(261629, NULL, 'PF16536', NULL, NULL, 'PNKP adenylyltransferase domain, C-terminal region', NULL, 'PNKP-ligase_C', NULL, NULL, 24077, 9),
(261630, NULL, 'PF16645', NULL, NULL, 'Unstructured region on Pneumococcal histidine triad protein', NULL, 'PHtD_u1', NULL, NULL, NULL, 9),
(261631, NULL, 'PF14501', NULL, NULL, 'GHKL domain', NULL, 'HATPase_c_5', NULL, NULL, 21995, 9),
(261632, NULL, 'PF19603', NULL, NULL, 'Family of unknown function (DUF6108)', NULL, 'DUF6108', NULL, NULL, 36943, 9),
(261633, NULL, 'PF01201', NULL, NULL, 'Ribosomal protein S8e', NULL, 'Ribosomal_S8e', NULL, NULL, 21430, 9),
(261634, NULL, 'PF13012', NULL, NULL, 'Maintenance of mitochondrial structure and function', NULL, 'MitMem_reg', NULL, NULL, 21687, 9),
(261635, NULL, 'PF09279', NULL, NULL, 'Phosphoinositide-specific phospholipase C, efhand-like', NULL, 'EF-hand_like', NULL, NULL, 13635, 9),
(261636, NULL, 'PF03404', NULL, NULL, 'Mo-co oxidoreductase dimerisation domain', NULL, 'Mo-co_dimer', NULL, NULL, 2077, 9),
(261637, NULL, 'PF03406', NULL, NULL, 'Phage tail fibre repeat', NULL, 'Phage_fiber_2', NULL, NULL, 2010, 9),
(261638, NULL, 'PF13209', NULL, NULL, 'Protein of unknown function (DUF4017)', NULL, 'DUF4017', NULL, NULL, 22544, 9),
(261639, NULL, 'PF15729', NULL, NULL, 'Amyotrophic lateral sclerosis 2 candidate 11', NULL, 'ALS2CR11', NULL, NULL, 26048, 9),
(261640, NULL, 'PF19977', NULL, NULL, 'xRRM domain', NULL, 'xRRM', NULL, NULL, 37070, 9),
(261641, NULL, 'PF06723', NULL, NULL, 'MreB/Mbl protein', NULL, 'MreB_Mbl', NULL, NULL, NULL, 9),
(261642, NULL, 'PF12601', NULL, NULL, 'Rubivirus non-structural protein', NULL, 'Rubi_NSP_C', NULL, NULL, 21129, 9),
(261643, NULL, 'PF18816', NULL, NULL, 'Importin repeat', NULL, 'Importin_rep_5', NULL, NULL, 27961, 9),
(261644, NULL, 'PF11633', NULL, NULL, 'Betacoronavirus single-stranded poly(A) binding domain', NULL, 'bCoV_SUD_M', NULL, NULL, 22380, 9),
(261645, NULL, 'PF05778', NULL, NULL, 'Apolipoprotein CIII (Apo-CIII)', NULL, 'Apo-CIII', NULL, NULL, 8551, 9),
(261646, NULL, 'PF05993', NULL, NULL, 'Reovirus major virion structural protein Mu-1/Mu-1C (M2)', NULL, 'Reovirus_M2', NULL, NULL, 7854, 9);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(261647, NULL, 'PF01776', NULL, NULL, 'Ribosomal L22e protein family', NULL, 'Ribosomal_L22e', NULL, NULL, 2675, 9),
(261648, NULL, 'PF12693', NULL, NULL, 'GspL periplasmic domain', NULL, 'GspL_C', NULL, NULL, 24611, 9),
(261649, NULL, 'PF18937', NULL, NULL, 'Family of unknown function (DUF5685)', NULL, 'DUF5685', NULL, NULL, 34332, 9),
(261650, NULL, 'PF11482', NULL, NULL, 'Protein of unknown function (DUF3208)', NULL, 'DUF3208', NULL, NULL, 18610, 9),
(261651, NULL, 'PF13523', NULL, NULL, 'Acetyltransferase (GNAT) domain', NULL, 'Acetyltransf_8', NULL, NULL, NULL, 9),
(261652, NULL, 'PF20202', NULL, NULL, 'Domain of unknown function (DUF6564)', NULL, 'DUF6564', NULL, NULL, 37045, 9),
(261653, NULL, 'PF16884', NULL, NULL, 'N-terminal domain of oxidoreductase', NULL, 'ADH_N_2', NULL, NULL, 30084, 9),
(261654, NULL, 'PF06567', NULL, NULL, 'Neural chondroitin sulphate proteoglycan cytoplasmic domain', NULL, 'Neural_ProG_Cyt', NULL, NULL, 9152, 9),
(261655, NULL, 'PF18053', NULL, NULL, 'DNA gyrase B subunit insert domain', NULL, 'GyrB_insert', NULL, NULL, 29105, 9),
(261656, NULL, 'PF16861', NULL, NULL, 'Carbamoyltransferase C-terminus', NULL, 'Carbam_trans_C', NULL, NULL, 25759, 9),
(261657, NULL, 'PF17814', NULL, NULL, 'LisH-like dimerisation domain', NULL, 'LisH_TPL', NULL, NULL, NULL, 9),
(261658, NULL, 'PF00903', NULL, NULL, 'Glyoxalase/Bleomycin resistance protein/Dioxygenase superfamily', NULL, 'Glyoxalase', NULL, NULL, 5313, 9),
(261659, NULL, 'PF10139', NULL, NULL, 'Putative bacterial virulence factor', NULL, 'Virul_Fac', NULL, NULL, 18908, 9),
(261660, NULL, 'PF18064', NULL, NULL, 'Centromere-binding protein ParB C-terminal', NULL, 'ParB_C', NULL, NULL, 32918, 9),
(261661, NULL, 'PF06215', NULL, NULL, 'Infectious salmon anaemia virus haemagglutinin', NULL, 'ISAV_HA', NULL, NULL, 9211, 9),
(261662, NULL, 'PF15245', NULL, NULL, 'Transcription cofactor vestigial-like protein 4', NULL, 'VGLL4', NULL, NULL, 21931, 9),
(261663, NULL, 'PF13184', NULL, NULL, 'NusA-like KH domain', NULL, 'KH_5', NULL, NULL, 25808, 9),
(261664, NULL, 'PF20289', NULL, NULL, 'ABC-three component (ABC-3C) system Middle Component 1', NULL, 'MComp1', NULL, NULL, 34381, 9),
(261665, NULL, 'PF20306', NULL, NULL, 'Small protein found in certain Dnd DNA modification systems', NULL, 'Sp-DndD', NULL, NULL, 37687, 9),
(261666, NULL, 'PF09227', NULL, NULL, 'Bubble protein', NULL, 'Bubble', NULL, NULL, 13393, 9),
(261667, NULL, 'PF20088', NULL, NULL, 'Family of unknown function (DUF6480)', NULL, 'DUF6480', NULL, NULL, 37178, 9),
(261668, NULL, 'PF03979', NULL, NULL, 'Sigma-70 factor, region 1.1', NULL, 'Sigma70_r1_1', NULL, NULL, 400, 9),
(261669, NULL, 'PF11995', NULL, NULL, 'Domain of unknown function (DUF3490)', NULL, 'DUF3490', NULL, NULL, 19779, 9),
(261670, NULL, 'PF17099', NULL, NULL, 'Tryptophan transporter TrpP', NULL, 'TrpP', NULL, NULL, 4972, 9),
(261671, NULL, 'PF20435', NULL, NULL, 'Meiosis-specific protein ASY3-like', NULL, 'ASY3-like', NULL, NULL, 33762, 9),
(261672, NULL, 'PF15863', NULL, NULL, 'Extended EGL-27 and MTA1 homology domain', NULL, 'EELM2', NULL, NULL, 23849, 9),
(261673, NULL, 'PF05108', NULL, NULL, 'Type VII secretion system ESX-1, transport TM domain B', NULL, 'T7SS_ESX1_EccB', NULL, NULL, 2237, 9),
(261674, NULL, 'PF10356', NULL, NULL, 'Protein of unknown function (DUF2034)', NULL, 'DUF2034', NULL, NULL, 19833, 9),
(261675, NULL, 'PF06350', NULL, NULL, 'Hormone-sensitive lipase (HSL) N-terminus', NULL, 'HSL_N', NULL, NULL, 10305, 9),
(261676, NULL, 'PF01780', NULL, NULL, 'Ribosomal L37ae protein family', NULL, 'Ribosomal_L37ae', NULL, NULL, 2773, 9),
(261677, NULL, 'PF17937', NULL, NULL, 'Tetracyclin repressor-like, C-terminal domain', NULL, 'TetR_C_28', NULL, NULL, 30619, 9),
(261678, NULL, 'PF04232', NULL, NULL, 'Stage V sporulation protein S (SpoVS)', NULL, 'SpoVS', NULL, NULL, 5987, 9),
(261679, NULL, 'PF16793', NULL, NULL, 'RepB DNA-primase from phage plasmid', NULL, 'RepB_primase', NULL, NULL, 31198, 9),
(261680, NULL, 'PF17324', NULL, NULL, 'BLOC-1 interactor 1', NULL, 'BLI1', NULL, NULL, 21025, 9);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(261681, NULL, 'PF09056', NULL, NULL, 'Prokaryotic phospholipase A2', NULL, 'Phospholip_A2_3', NULL, NULL, 9637, 9),
(261682, NULL, 'PF10623', NULL, NULL, 'Plasmid conjugative transfer protein PilI', NULL, 'PilI', NULL, NULL, 20628, 9),
(261683, NULL, 'PF06437', NULL, NULL, 'IMP-specific 5''-nucleotidase', NULL, 'ISN1', NULL, NULL, 9173, 9),
(261684, NULL, 'PF10430', NULL, NULL, 'Tie-2 Ig-like domain 1', NULL, 'Ig_Tie2_1', NULL, NULL, 9372, 9),
(261685, NULL, 'PF15873', NULL, NULL, 'Domain of unknown function (DUF4730)', NULL, 'DUF4730', NULL, NULL, 23676, 9),
(261686, NULL, 'PF12307', NULL, NULL, 'Protein of unknown function (DUF3631)', NULL, 'DUF3631', NULL, NULL, 20934, 9),
(261687, NULL, 'PF17297', NULL, NULL, 'Phosphoenolpyruvate carboxykinase N-terminal domain', NULL, 'PEPCK_N', NULL, NULL, 32015, 9),
(261688, NULL, 'PF20344', NULL, NULL, 'Family of unknown function (DUF6639)', NULL, 'DUF6639', NULL, NULL, 33659, 9),
(261689, NULL, 'PF11778', NULL, NULL, 'Septation initiation', NULL, 'SID', NULL, NULL, 19452, 9),
(261690, NULL, 'PF03290', NULL, NULL, 'Vaccinia virus I7 processing peptidase', NULL, 'Peptidase_C57', NULL, NULL, 516, 9),
(261691, NULL, 'PF08125', NULL, NULL, 'Mannitol dehydrogenase C-terminal domain', NULL, 'Mannitol_dh_C', NULL, NULL, 18574, 9),
(261692, NULL, 'PF19498', NULL, NULL, 'Protein of unknown function (DUF6033)', NULL, 'DUF6033', NULL, NULL, 36551, 9),
(261693, NULL, 'PF03137', NULL, NULL, 'Organic Anion Transporter Polypeptide (OATP) family', NULL, 'OATP', NULL, NULL, 2982, 9),
(261694, NULL, 'PF17282', NULL, NULL, 'Family of unknown function (DUF5347)', NULL, 'DUF5347', NULL, NULL, 15984, 9),
(261695, NULL, 'PF12476', NULL, NULL, 'Protein of unknown function (DUF3696)', NULL, 'DUF3696', NULL, NULL, 16367, 9),
(261696, NULL, 'PF20121', NULL, NULL, 'Family of unknown function (DUF6511)', NULL, 'DUF6511', NULL, NULL, 34780, 9),
(261697, NULL, 'PF02167', NULL, NULL, 'Cytochrome C1 family', NULL, 'Cytochrom_C1', NULL, NULL, 6349, 9),
(261698, NULL, 'PF04456', NULL, NULL, 'Protein of unknown function (DUF503)', NULL, 'DUF503', NULL, NULL, 3502, 9),
(261699, NULL, 'PF07740', NULL, NULL, 'Ion channel inhibitory toxin', NULL, 'Toxin_12', NULL, NULL, 10593, 9),
(261700, NULL, 'PF20020', NULL, NULL, 'Domain of unknown function (DUF6431)', NULL, 'DUF6431', NULL, NULL, 35823, 9),
(261701, NULL, 'PF17515', NULL, NULL, 'Cypovirus polyhedrin', NULL, 'CPV_Polyhedrin', NULL, NULL, 16190, 9),
(261702, NULL, 'PF10893', NULL, NULL, 'Bacteriophage 186, Fil', NULL, 'Phage_186_Fil', NULL, NULL, 17822, 9),
(261703, NULL, 'PF06396', NULL, NULL, 'Angiotensin II, type I receptor-associated protein (AGTRAP)', NULL, 'AGTRAP', NULL, NULL, 8027, 9),
(261704, NULL, 'PF06608', NULL, NULL, 'Protein of unknown function (DUF1143)', NULL, 'DUF1143', NULL, NULL, 9616, 9),
(261705, NULL, 'PF12783', NULL, NULL, 'Guanine nucleotide exchange factor in Golgi transport N-terminal', NULL, 'Sec7_N', NULL, NULL, 26025, 9),
(261706, NULL, 'PF02566', NULL, NULL, 'OsmC-like protein', NULL, 'OsmC', NULL, NULL, 2356, 9),
(261707, NULL, 'PF10293', NULL, NULL, 'Domain of unknown function (DUF2405)', NULL, 'DUF2405', NULL, NULL, 16857, 9),
(261708, NULL, 'PF19424', NULL, NULL, 'Protein UNC80 central region', NULL, 'UNC80', NULL, NULL, 34224, 9),
(261709, NULL, 'PF07969', NULL, NULL, 'Amidohydrolase family', NULL, 'Amidohydro_3', NULL, NULL, 18982, 9),
(261710, NULL, 'PF07739', NULL, NULL, 'TipAS antibiotic-recognition domain', NULL, 'TipAS', NULL, NULL, 7870, 9),
(261711, NULL, 'PF03969', NULL, NULL, 'AFG1-like ATPase', NULL, 'AFG1_ATPase', NULL, NULL, 2579, 9),
(261712, NULL, 'PF02351', NULL, NULL, 'GDNF/GAS1 domain', NULL, 'GDNF', NULL, NULL, 14474, 9),
(261713, NULL, 'PF10025', NULL, NULL, 'Uncharacterized conserved protein (DUF2267)', NULL, 'DUF2267', NULL, NULL, 17875, 9),
(261714, NULL, 'PF02430', NULL, NULL, 'Apical membrane antigen 1', NULL, 'AMA-1', NULL, NULL, 3240, 9),
(261715, NULL, 'PF11748', NULL, NULL, 'Protein of unknown function (DUF3306)', NULL, 'DUF3306', NULL, NULL, 19048, 9),
(261716, NULL, 'PF14929', NULL, NULL, 'TAF RNA Polymerase I subunit A', NULL, 'TAF1_subA', NULL, NULL, 28506, 9);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(261717, NULL, 'PF17247', NULL, NULL, 'Family of unknown function (DUF5316)', NULL, 'DUF5316', NULL, NULL, 18976, 9),
(261718, NULL, 'PF19037', NULL, NULL, 'Second Longin domain of FUZ, MON1 and HPS1', NULL, 'Fuz_longin_2', NULL, NULL, 34935, 9),
(261719, NULL, 'PF18582', NULL, NULL, 'Hydrazine synthase alpha subunit middle domain', NULL, 'HZS_alpha', NULL, NULL, 27776, 9),
(261720, NULL, 'PF19544', NULL, NULL, 'Family of unknown function (DUF6068)', NULL, 'DUF6068', NULL, NULL, 36159, 9),
(261721, NULL, 'PF03317', NULL, NULL, 'ELF protein', NULL, 'ELF', NULL, NULL, 759, 9),
(261722, NULL, 'PF16406', NULL, NULL, 'Domain of unknown function (DUF5014)', NULL, 'DUF5014', NULL, NULL, 23701, 9),
(261723, NULL, 'PF09158', NULL, NULL, 'Bacteriophage T4 MotA, C-terminal', NULL, 'MotCF', NULL, NULL, 12045, 9),
(261724, NULL, 'PF06305', NULL, NULL, 'Lipopolysaccharide assembly protein A domain', NULL, 'LapA_dom', NULL, NULL, 10089, 9),
(261725, NULL, 'PF13229', NULL, NULL, 'Right handed beta helix region', NULL, 'Beta_helix', NULL, NULL, 33271, 9),
(261726, NULL, 'PF19505', NULL, NULL, 'Family of unknown function (DUF6039)', NULL, 'DUF6039', NULL, NULL, 36726, 9),
(261727, NULL, 'PF09651', NULL, NULL, 'CRISPR-associated protein (Cas_APE2256)', NULL, 'Cas_APE2256', NULL, NULL, 9429, 9),
(261728, NULL, 'PF10839', NULL, NULL, 'Protein of unknown function (DUF2647)', NULL, 'DUF2647', NULL, NULL, 16452, 9),
(261729, NULL, 'PF01325', NULL, NULL, 'Iron dependent repressor, N-terminal DNA binding domain', NULL, 'Fe_dep_repress', NULL, NULL, 16714, 9),
(261730, NULL, 'PF12968', NULL, NULL, 'Domain of Unknown Function (DUF3856)', NULL, 'DUF3856', NULL, NULL, 21736, 9),
(261731, NULL, 'PF05002', NULL, NULL, 'SGS domain', NULL, 'SGS', NULL, NULL, 1249, 9),
(261732, NULL, 'PF06210', NULL, NULL, 'Protein of unknown function (DUF1003)', NULL, 'DUF1003', NULL, NULL, 9206, 9),
(261733, NULL, 'PF09850', NULL, NULL, 'Type VI secretion system protein DotU', NULL, 'DotU', NULL, NULL, 18145, 9),
(261734, NULL, 'PF12625', NULL, NULL, 'Arabinose-binding domain of AraC transcription regulator, N-term', NULL, 'Arabinose_bd', NULL, NULL, 26727, 9),
(261735, NULL, 'PF05971', NULL, NULL, 'RNA methyltransferase', NULL, 'Methyltransf_10', NULL, NULL, 7633, 9),
(261736, NULL, 'PF12486', NULL, NULL, 'Type VI secretion system, EvfB, or VasL', NULL, 'VasL', NULL, NULL, 15322, 9),
(261737, NULL, 'PF17438', NULL, NULL, 'Family of unknown function (DUF5417)', NULL, 'DUF5417', NULL, NULL, 27321, 9),
(261738, NULL, 'PF05384', NULL, NULL, 'Sensor protein DegS', NULL, 'DegS', NULL, NULL, 14249, 9),
(261739, NULL, 'PF11894', NULL, NULL, 'Nuclear pore complex scaffold, nucleoporins 186/192/205', NULL, 'Nup192', NULL, NULL, 19513, 9),
(261740, NULL, 'PF17656', NULL, NULL, 'FlgA N-terminal domain', NULL, 'ChapFlgA_N', NULL, NULL, 29457, 9),
(261741, NULL, 'PF05181', NULL, NULL, 'XPA protein C-terminus', NULL, 'XPA_C', NULL, NULL, 16558, 9),
(261742, NULL, 'PF20226', NULL, NULL, 'Family of unknown function (DUF6585)', NULL, 'DUF6585', NULL, NULL, 37548, 9),
(261743, NULL, 'PF16175', NULL, NULL, 'Domain of unknown function (DUF4875)', NULL, 'DUF4875', NULL, NULL, 23354, 9),
(261744, NULL, 'PF02041', NULL, NULL, 'Auxin binding protein', NULL, 'Auxin_BP', NULL, NULL, 5698, 9),
(261745, NULL, 'PF13279', NULL, NULL, 'Thioesterase-like superfamily', NULL, '4HBT_2', NULL, NULL, NULL, 9),
(261746, NULL, 'PF00713', NULL, NULL, 'Hirudin', NULL, 'Hirudin', NULL, NULL, 6656, 9),
(261747, NULL, 'PF08048', NULL, NULL, 'Tap RepA1 leader peptide', NULL, 'RepA1_leader', NULL, NULL, 9546, 9),
(261748, NULL, 'PF18450', NULL, NULL, 'Zinc Finger domain', NULL, 'zf_C2H2_6', NULL, NULL, 29348, 9),
(261749, NULL, 'PF10821', NULL, NULL, 'Protein of unknown function (DUF2567)', NULL, 'DUF2567', NULL, NULL, 17661, 9),
(261750, NULL, 'PF09884', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2111)', NULL, 'DUF2111', NULL, NULL, 10990, 9),
(261751, NULL, 'PF00821', NULL, NULL, 'Phosphoenolpyruvate carboxykinase C-terminal P-loop domain', NULL, 'PEPCK_GTP', NULL, NULL, 18773, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(261752, NULL, 'PF09938', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2170)', NULL, 'DUF2170', NULL, NULL, 19435, 9),
(261753, NULL, 'PF17041', NULL, NULL, 'E domain', NULL, 'SasG_E', NULL, NULL, 22945, 9),
(261754, NULL, 'PF07299', NULL, NULL, 'Elongation factor G-binding protein, N-terminal', NULL, 'EF-G-binding_N', NULL, NULL, 11556, 9),
(261755, NULL, 'PF16628', NULL, NULL, 'Unstructured region on maltose acetyltransferase', NULL, 'Mac_assoc', NULL, NULL, NULL, 9),
(261756, NULL, 'PF19436', NULL, NULL, 'ACS/CODH beta subunit C-terminal', NULL, 'ACS_CODH_B_C', NULL, NULL, 36180, 9),
(261757, NULL, 'PF11931', NULL, NULL, 'SF3a60/Prp9 C-terminal', NULL, 'SF3a60_Prp9_C', NULL, NULL, 26648, 9),
(261758, NULL, 'PF16088', NULL, NULL, 'BLOC-1-related complex sub-unit 7', NULL, 'BORCS7', NULL, NULL, 26419, 9),
(261759, NULL, 'PF15387', NULL, NULL, 'Domain of unknown function (DUF4611)', NULL, 'DUF4611', NULL, NULL, 25537, 9),
(261760, NULL, 'PF14518', NULL, NULL, 'Iron-containing redox enzyme', NULL, 'Haem_oxygenas_2', NULL, NULL, NULL, 9),
(261761, NULL, 'PF16511', NULL, NULL, 'N-terminal or F0 domain of Talin-head FERM', NULL, 'FERM_f0', NULL, NULL, 23184, 9),
(261762, NULL, 'PF03724', NULL, NULL, 'META domain', NULL, 'META', NULL, NULL, 5308, 9),
(261763, NULL, 'PF09974', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2209)', NULL, 'DUF2209', NULL, NULL, 11145, 9),
(261764, NULL, 'PF19636', NULL, NULL, 'Family of unknown function (DUF6139)', NULL, 'DUF6139', NULL, NULL, 37139, 9),
(261765, NULL, 'PF04313', NULL, NULL, 'Type I restriction enzyme R protein N terminus (HSDR_N)', NULL, 'HSDR_N', NULL, NULL, 3876, 9),
(261766, NULL, 'PF14263', NULL, NULL, 'Domain of unknown function (DUF4354)', NULL, 'DUF4354', NULL, NULL, 26066, 9),
(261767, NULL, 'PF14375', NULL, NULL, 'Cysteine-rich CWC', NULL, 'Cys_rich_CWC', NULL, NULL, 26514, 9),
(261768, NULL, 'PF03984', NULL, NULL, 'Repeat of unknown function (DUF346)', NULL, 'DUF346', NULL, NULL, 389, 9),
(261769, NULL, 'PF17286', NULL, NULL, 'PRMT5 oligomerisation domain', NULL, 'PRMT5_C', NULL, NULL, 28345, 9),
(261770, NULL, 'PF00659', NULL, NULL, 'POLO box duplicated region', NULL, 'POLO_box', NULL, NULL, 4067, 9),
(261771, NULL, 'PF10998', NULL, NULL, 'Protein of unknown function (DUF2838)', NULL, 'DUF2838', NULL, NULL, 17545, 9),
(261772, NULL, 'PF02561', NULL, NULL, 'Flagellar protein FliS', NULL, 'FliS', NULL, NULL, 2413, 9),
(261773, NULL, 'PF02022', NULL, NULL, 'Integrase Zinc binding domain', NULL, 'Integrase_Zn', NULL, NULL, 3600, 9),
(261774, NULL, 'PF16899', NULL, NULL, 'Cyclin C-terminal domain', NULL, 'Cyclin_C_2', NULL, NULL, 22957, 9),
(261775, NULL, 'PF17265', NULL, NULL, 'Family of unknown function (DUF5331)', NULL, 'DUF5331', NULL, NULL, 19510, 9),
(261776, NULL, 'PF11975', NULL, NULL, 'Family 4 glycosyl hydrolase C-terminal domain', NULL, 'Glyco_hydro_4C', NULL, NULL, 16765, 9),
(261777, NULL, 'PF12163', NULL, NULL, 'DNA replication regulator', NULL, 'HobA', NULL, NULL, 15306, 9),
(261778, NULL, 'PF09965', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2199)', NULL, 'DUF2199', NULL, NULL, 17091, 9),
(261779, NULL, 'PF02631', NULL, NULL, 'RecX family', NULL, 'RecX', NULL, NULL, 3062, 9),
(261780, NULL, 'PF11831', NULL, NULL, 'pre-mRNA splicing factor component', NULL, 'Myb_Cef', NULL, NULL, 19376, 9),
(261781, NULL, 'PF18991', NULL, NULL, 'Family of unknown function (DUF5724)', NULL, 'DUF5724', NULL, NULL, 35821, 9),
(261782, NULL, 'PF00043', NULL, NULL, 'Glutathione S-transferase, C-terminal domain', NULL, 'GST_C', NULL, NULL, 964, 9),
(261783, NULL, 'PF20562', NULL, NULL, 'Domain of unknown function (DUF6772)', NULL, 'DUF6772', NULL, NULL, 37152, 9),
(261784, NULL, 'PF11185', NULL, NULL, 'Protein of unknown function (DUF2971)', NULL, 'DUF2971', NULL, NULL, 18267, 9),
(261785, NULL, 'PF02681', NULL, NULL, 'Divergent PAP2 family', NULL, 'DUF212', NULL, NULL, 6294, 9),
(261786, NULL, 'PF18306', NULL, NULL, 'SLOG cluster4 family', NULL, 'LDcluster4', NULL, NULL, 28666, 9),
(261787, NULL, 'PF20468', NULL, NULL, 'Hermansky-Pudlak syndrome 6 protein C-terminal domain', NULL, 'HPS6_C', NULL, NULL, 33798, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(261788, NULL, 'PF13022', NULL, NULL, 'Helix-turn-helix of insertion element transposase', NULL, 'HTH_Tnp_1_2', NULL, NULL, 22008, 9),
(261789, NULL, 'PF12952', NULL, NULL, 'Domain of unknown function (DUF3841)', NULL, 'DUF3841', NULL, NULL, 21267, 9),
(261790, NULL, 'PF20001', NULL, NULL, 'Family of unknown function (DUF6428)', NULL, 'DUF6428', NULL, NULL, 36232, 9),
(261791, NULL, 'PF19371', NULL, NULL, 'Family of unknown function (DUF5946)', NULL, 'DUF5946', NULL, NULL, 36815, 9),
(261792, NULL, 'PF01875', NULL, NULL, 'Memo-like protein', NULL, 'Memo', NULL, NULL, 3653, 9),
(261793, NULL, 'PF01413', NULL, NULL, 'C-terminal tandem repeated domain in type 4 procollagen', NULL, 'C4', NULL, NULL, 6626, 9),
(261794, NULL, 'PF05131', NULL, NULL, 'Pep3/Vps18/deep orange family', NULL, 'Pep3_Vps18', NULL, NULL, 2063, 9),
(261795, NULL, 'PF02302', NULL, NULL, 'PTS system, Lactose/Cellobiose specific IIB subunit', NULL, 'PTS_IIB', NULL, NULL, 6276, 9),
(261796, NULL, 'PF02673', NULL, NULL, 'Bacitracin resistance protein BacA', NULL, 'BacA', NULL, NULL, 3431, 9),
(261797, NULL, 'PF06403', NULL, NULL, 'Lamprin', NULL, 'Lamprin', NULL, NULL, 8338, 9),
(261798, NULL, 'PF10361', NULL, NULL, 'Protein of unknown function (DUF2434)', NULL, 'DUF2434', NULL, NULL, 20267, 9),
(261799, NULL, 'PF12829', NULL, NULL, 'Transcriptional regulation of mitochondrial recombination', NULL, 'Mhr1', NULL, NULL, 13866, 9),
(261800, NULL, 'PF01966', NULL, NULL, 'HD domain', NULL, 'HD', NULL, NULL, 1789, 9),
(261801, NULL, 'PF09704', NULL, NULL, 'CRISPR-associated protein (Cas_Cas5)', NULL, 'Cas_Cas5d', NULL, NULL, 15056, 9),
(261802, NULL, 'PF04006', NULL, NULL, 'Mpp10 protein', NULL, 'Mpp10', NULL, NULL, 7149, 9),
(261803, NULL, 'PF17294', NULL, NULL, 'Uncharacterised lipoprotein family', NULL, 'Lipoprotein_22', NULL, NULL, 28254, 9),
(261804, NULL, 'PF19311', NULL, NULL, 'KELAA motif', NULL, 'KELAA', NULL, NULL, 33597, 9),
(261805, NULL, 'PF16049', NULL, NULL, 'Frog antimicrobial peptide', NULL, 'Antimicrobial24', NULL, NULL, 21341, 9),
(261806, NULL, 'PF10775', NULL, NULL, 'ATP synthase complex subunit h', NULL, 'ATP_sub_h', NULL, NULL, 20926, 9),
(261807, NULL, 'PF00055', NULL, NULL, 'Laminin N-terminal (Domain VI)', NULL, 'Laminin_N', NULL, NULL, 7497, 9),
(261808, NULL, 'PF11064', NULL, NULL, 'Protein of unknown function (DUF2865)', NULL, 'DUF2865', NULL, NULL, 17705, 9),
(261809, NULL, 'PF19012', NULL, NULL, 'Family of unknown function (DUF5741)', NULL, 'DUF5741', NULL, NULL, 35968, 9),
(261810, NULL, 'PF04414', NULL, NULL, 'D-aminoacyl-tRNA deacylase', NULL, 'tRNA_deacylase', NULL, NULL, 10559, 9),
(261811, NULL, 'PF05171', NULL, NULL, 'Haemin-degrading HemS.ChuX domain', NULL, 'HemS', NULL, NULL, 2180, 9),
(261812, NULL, 'PF14508', NULL, NULL, 'Glycosyl-hydrolase 97 N-terminal', NULL, 'GH97_N', NULL, NULL, 23489, 9),
(261813, NULL, 'PF17661', NULL, NULL, 'Family of unknown function (DUF5523)', NULL, 'DUF5523', NULL, NULL, 30370, 9),
(261814, NULL, 'PF13726', NULL, NULL, 'Na+-H+ antiporter family', NULL, 'Na_H_antiport_2', NULL, NULL, 21924, 9),
(261815, NULL, 'PF13546', NULL, NULL, 'DDE superfamily endonuclease', NULL, 'DDE_5', NULL, NULL, 32625, 9),
(261816, NULL, 'PF06970', NULL, NULL, 'Replication initiator protein A (RepA) N-terminus', NULL, 'RepA_N', NULL, NULL, 9800, 9),
(261817, NULL, 'PF11918', NULL, NULL, 'N-terminal domain of Peptidase_S41 in eukaryotic IRBP', NULL, 'Peptidase_S41_N', NULL, NULL, NULL, 9),
(261818, NULL, 'PF02836', NULL, NULL, 'Glycosyl hydrolases family 2, TIM barrel domain', NULL, 'Glyco_hydro_2_C', NULL, NULL, 2891, 9),
(261819, NULL, 'PF04679', NULL, NULL, 'ATP dependent DNA ligase C terminal region', NULL, 'DNA_ligase_A_C', NULL, NULL, 12973, 9),
(261820, NULL, 'PF10684', NULL, NULL, 'Putative biofilm-dependent modulation protein', NULL, 'BDM', NULL, NULL, 20946, 9),
(261821, NULL, 'PF17704', NULL, NULL, 'Family of unknown function (DUF5550)', NULL, 'DUF5550', NULL, NULL, 31012, 9),
(261822, NULL, 'PF08693', NULL, NULL, 'SKG6 family', NULL, 'SKG6', NULL, NULL, 11866, 9),
(261823, NULL, 'PF03737', NULL, NULL, 'Aldolase/RraA', NULL, 'RraA-like', NULL, NULL, 951, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(261824, NULL, 'PF05266', NULL, NULL, 'Protein of unknown function (DUF724)', NULL, 'DUF724', NULL, NULL, 4161, 9),
(261825, NULL, 'PF05753', NULL, NULL, 'Translocon-associated protein beta (TRAPB)', NULL, 'TRAP_beta', NULL, NULL, NULL, 9),
(261826, NULL, 'PF20081', NULL, NULL, 'Domain of unknown function (DUF6475)', NULL, 'DUF6475', NULL, NULL, 35652, 9),
(261827, NULL, 'PF08817', NULL, NULL, 'WXG100 protein secretion system (Wss), protein YukD', NULL, 'YukD', NULL, NULL, 2890, 9),
(261828, NULL, 'PF08947', NULL, NULL, 'BPS (Between PH and SH2)', NULL, 'BPS', NULL, NULL, 7519, 9),
(261829, NULL, 'PF20178', NULL, NULL, 'Family of unknown function (DUF6543)', NULL, 'DUF6543', NULL, NULL, 37269, 9),
(261830, NULL, 'PF15931', NULL, NULL, 'Domain of unknown function (DUF4747)', NULL, 'DUF4747', NULL, NULL, 25771, 9),
(261831, NULL, 'PF18135', NULL, NULL, 'Type ISP C-terminal specificity domain', NULL, 'Type_ISP_C', NULL, NULL, 30107, 9),
(261832, NULL, 'PF08893', NULL, NULL, 'Domain of unknown function (DUF1839)', NULL, 'DUF1839', NULL, NULL, 7645, 9),
(261833, NULL, 'PF17633', NULL, NULL, 'Family of unknown function (DUF5514)', NULL, 'DUF5514', NULL, NULL, 14524, 9),
(261834, NULL, 'PF17448', NULL, NULL, 'Uncharacterized YqaH-like', NULL, 'YqaH', NULL, NULL, 19250, 9),
(261835, NULL, 'PF00926', NULL, NULL, '3,4-dihydroxy-2-butanone 4-phosphate synthase', NULL, 'DHBP_synthase', NULL, NULL, 6525, 9),
(261836, NULL, 'PF03512', NULL, NULL, 'Glycosyl hydrolase family 52', NULL, 'Glyco_hydro_52', NULL, NULL, 137, 9),
(261837, NULL, 'PF08239', NULL, NULL, 'Bacterial SH3 domain', NULL, 'SH3_3', NULL, NULL, 1397, 9),
(261838, NULL, 'PF08318', NULL, NULL, 'COG4 transport protein', NULL, 'COG4', NULL, NULL, 8769, 9),
(261839, NULL, 'PF00707', NULL, NULL, 'Translation initiation factor IF-3, C-terminal domain', NULL, 'IF3_C', NULL, NULL, 17127, 9),
(261840, NULL, 'PF19878', NULL, NULL, 'Tannase-like family of unknown function (DUF6351)', NULL, 'DUF6351', NULL, NULL, 37291, 9),
(261841, NULL, 'PF19178', NULL, NULL, 'Family of unknown function (DUF5860)', NULL, 'DUF5860', NULL, NULL, 35890, 9),
(261842, NULL, 'PF01506', NULL, NULL, 'Hepatitis C virus non-structural 5a protein membrane anchor', NULL, 'HCV_NS5a', NULL, NULL, 5668, 9),
(261843, NULL, 'PF10671', NULL, NULL, 'Toxin co-regulated pilus biosynthesis protein Q', NULL, 'TcpQ', NULL, NULL, 14734, 9),
(261844, NULL, 'PF07956', NULL, NULL, 'Protein of Unknown function (DUF1690)', NULL, 'DUF1690', NULL, NULL, 14053, 9),
(261845, NULL, 'PF00458', NULL, NULL, 'WHEP-TRS domain', NULL, 'WHEP-TRS', NULL, NULL, 3767, 9),
(261846, NULL, 'PF08370', NULL, NULL, 'Plant PDR ABC transporter associated', NULL, 'PDR_assoc', NULL, NULL, 11758, 9),
(261847, NULL, 'PF14735', NULL, NULL, 'HAUS augmin-like complex subunit 4', NULL, 'HAUS4', NULL, NULL, 21875, 9),
(261848, NULL, 'PF14121', NULL, NULL, 'Putative porin', NULL, 'Porin_10', NULL, NULL, 24879, 9),
(261849, NULL, 'PF05414', NULL, NULL, 'Viral domain of unknown function (DUF1717)', NULL, 'DUF1717', NULL, NULL, 12493, 9),
(261850, NULL, 'PF13289', NULL, NULL, 'SIR2-like domain', NULL, 'SIR2_2', NULL, NULL, 30857, 9),
(261851, NULL, 'PF14173', NULL, NULL, 'ComG operon protein 7', NULL, 'ComGG', NULL, NULL, 19702, 9),
(261852, NULL, 'PF08004', NULL, NULL, 'Protein of unknown function (DUF1699)', NULL, 'DUF1699', NULL, NULL, 8638, 9),
(261853, NULL, 'PF05824', NULL, NULL, 'Pro-melanin-concentrating hormone (Pro-MCH)', NULL, 'Pro-MCH', NULL, NULL, 651, 9),
(261854, NULL, 'PF07955', NULL, NULL, 'Protein of unknown function (DUF1687)', NULL, 'DUF1687', NULL, NULL, 13140, 9),
(261855, NULL, 'PF06361', NULL, NULL, 'Rice tungro bacilliform virus P12 protein', NULL, 'RTBV_P12', NULL, NULL, 8301, 9),
(261856, NULL, 'PF00278', NULL, NULL, 'Pyridoxal-dependent decarboxylase, C-terminal sheet domain', NULL, 'Orn_DAP_Arg_deC', NULL, NULL, 17334, 9),
(261857, NULL, 'PF19968', NULL, NULL, 'vWA-MoxR associated protein middle region (VMAP-M) 7', NULL, 'VMAP-M7', NULL, NULL, 35637, 9),
(261858, NULL, 'PF14842', NULL, NULL, 'FliG N-terminal domain', NULL, 'FliG_N', NULL, NULL, 23062, 9); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(261859, NULL, 'PF17928', NULL, NULL, 'Tetracyclin repressor-like, C-terminal domain', NULL, 'TetR_C_22', NULL, NULL, 30305, 9),
(261860, NULL, 'PF08484', NULL, NULL, 'C-methyltransferase C-terminal domain', NULL, 'Methyltransf_14', NULL, NULL, 13559, 9),
(261861, NULL, 'PF17035', NULL, NULL, 'Bromodomain extra-terminal - transcription regulation', NULL, 'BET', NULL, NULL, 26118, 9),
(261862, NULL, 'PF06105', NULL, NULL, 'Aph-1 protein', NULL, 'Aph-1', NULL, NULL, 13625, 9),
(261863, NULL, 'PF13797', NULL, NULL, 'Post-transcriptional regulator', NULL, 'Post_transc_reg', NULL, NULL, 24312, 9),
(261864, NULL, 'PF12914', NULL, NULL, 'SH3 domain of SH3b2 type', NULL, 'SH3_7', NULL, NULL, 26614, 9),
(261865, NULL, 'PF06106', NULL, NULL, 'S. aureus uracil DNA glycosylase inhibitor', NULL, 'SAUGI', NULL, NULL, 13852, 9),
(261866, NULL, 'PF10894', NULL, NULL, 'Protein of unknown function (DUF2689)', NULL, 'DUF2689', NULL, NULL, 23957, 9),
(261867, NULL, 'PF00882', NULL, NULL, 'Zinc dependent phospholipase C', NULL, 'Zn_dep_PLPC', NULL, NULL, 23144, 9),
(261868, NULL, 'PF13312', NULL, NULL, 'Domain of unknown function (DUF4081)', NULL, 'DUF4081', NULL, NULL, 25527, 9),
(261869, NULL, 'PF20415', NULL, NULL, 'Family of unknown function (DUF6699)', NULL, 'DUF6699', NULL, NULL, 37661, 9),
(261870, NULL, 'PF07845', NULL, NULL, 'Protein of unknown function (DUF1636)', NULL, 'DUF1636', NULL, NULL, 12115, 9),
(261871, NULL, 'PF06605', NULL, NULL, 'Prophage endopeptidase tail', NULL, 'Prophage_tail', NULL, NULL, 8282, 9),
(261872, NULL, 'PF20429', NULL, NULL, 'RNA-binding protein Tab2/Atab2, C terminal', NULL, 'Tab2-like_C', NULL, NULL, 33793, 9),
(261873, NULL, 'PF13470', NULL, NULL, 'PIN domain', NULL, 'PIN_3', NULL, NULL, 3820, 9),
(261874, NULL, 'PF09267', NULL, NULL, 'Dictyostelium STAT, coiled coil', NULL, 'Dict-STAT-coil', NULL, NULL, 13307, 9),
(261875, NULL, 'PF12591', NULL, NULL, 'Protein of unknown function (DUF3762)', NULL, 'DUF3762', NULL, NULL, 21117, 9),
(261876, NULL, 'PF15848', NULL, NULL, 'Odontogenesis associated phosphoprotein', NULL, 'ODAPH', NULL, NULL, 21817, 9),
(261877, NULL, 'PF18213', NULL, NULL, 'SUB1 protease Prodomain ProdP9', NULL, 'SUB1_ProdP9', NULL, NULL, 29456, 9),
(261878, NULL, 'PF16599', NULL, NULL, 'Unstructured linker region on PTN13 protein between PDZ', NULL, 'PTN13_u3', NULL, NULL, NULL, 9),
(261879, NULL, 'PF12766', NULL, NULL, 'Pyridoxamine 5''-phosphate oxidase', NULL, 'Pyridox_oxase_2', NULL, NULL, 23964, 9),
(261880, NULL, 'PF10970', NULL, NULL, 'Spore germination protein GerPE', NULL, 'GerPE', NULL, NULL, 24418, 9),
(261881, NULL, 'PF02927', NULL, NULL, 'Cellulase N-terminal ig-like domain', NULL, 'CelD_N', NULL, NULL, 2534, 9),
(261882, NULL, 'PF08175', NULL, NULL, 'Small acid-soluble spore protein O family', NULL, 'SspO', NULL, NULL, NULL, 9),
(261883, NULL, 'PF17795', NULL, NULL, 'Major Vault Protein Repeat domain', NULL, 'Vault_3', NULL, NULL, 28667, 9),
(261884, NULL, 'PF18341', NULL, NULL, 'PSA endolysin C-terminal cell wall binding domain', NULL, 'PSA_CBD', NULL, NULL, 29391, 9),
(261885, NULL, 'PF09078', NULL, NULL, 'CheY binding', NULL, 'CheY-binding', NULL, NULL, 9999, 9),
(261886, NULL, 'PF07425', NULL, NULL, 'Pardaxin', NULL, 'Pardaxin', NULL, NULL, 8738, 9),
(261887, NULL, 'PF15595', NULL, NULL, 'Immunity protein 51', NULL, 'Imm51', NULL, NULL, 24665, 9),
(261888, NULL, 'PF15799', NULL, NULL, 'Coiled-coil domain-containing protein 48', NULL, 'CCD48', NULL, NULL, 25447, 9),
(261889, NULL, 'PF19741', NULL, NULL, 'Family of unknown function (DUF6230)', NULL, 'DUF6230', NULL, NULL, 37047, 9),
(261890, NULL, 'PF13276', NULL, NULL, 'HTH-like domain', NULL, 'HTH_21', NULL, NULL, 23959, 9),
(261891, NULL, 'PF19241', NULL, NULL, 'Family of unknown function (DUF5891)', NULL, 'DUF5891', NULL, NULL, 37295, 9),
(261892, NULL, 'PF19831', NULL, NULL, 'Family of unknown function (DUF6312)', NULL, 'DUF6312', NULL, NULL, 37672, 9),
(261893, NULL, 'PF00413', NULL, NULL, 'Matrixin', NULL, 'Peptidase_M10', NULL, NULL, 4041, 9),
(261894, NULL, 'PF15063', NULL, NULL, 'Thyroid cancer protein 1', NULL, 'TC1', NULL, NULL, 19668, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(261895, NULL, 'PF15099', NULL, NULL, 'Phosphoinositide-interacting protein family', NULL, 'PIRT', NULL, NULL, 26613, 9),
(261896, NULL, 'PF13073', NULL, NULL, 'Protein of unknown function (DUF3937)', NULL, 'DUF3937', NULL, NULL, 22636, 9),
(261897, NULL, 'PF03318', NULL, NULL, 'Clostridium epsilon toxin ETX/Bacillus mosquitocidal toxin MTX2', NULL, 'ETX_MTX2', NULL, NULL, 829, 9),
(261898, NULL, 'PF05394', NULL, NULL, 'Avirulence protein', NULL, 'AvrB_AvrC', NULL, NULL, 13613, 9),
(261899, NULL, 'PF15998', NULL, NULL, 'Domain of unknown function (DUF4773)', NULL, 'DUF4773', NULL, NULL, 25590, 9),
(261900, NULL, 'PF20057', NULL, NULL, 'Domain of unknown function (DUF6456)', NULL, 'DUF6456', NULL, NULL, 36438, 9),
(261901, NULL, 'PF15278', NULL, NULL, 'Sec3 exocyst complex subunit', NULL, 'Sec3_C_2', NULL, NULL, 22437, 9),
(261902, NULL, 'PF15365', NULL, NULL, 'Proline-rich nuclear receptor coactivator motif', NULL, 'PNRC', NULL, NULL, NULL, 9),
(261903, NULL, 'PF13414', NULL, NULL, 'TPR repeat', NULL, 'TPR_11', NULL, NULL, NULL, 9),
(261904, NULL, 'PF16679', NULL, NULL, 'DNA replication factor Cdt1 C-terminal domain', NULL, 'CDT1_C', NULL, NULL, 25019, 9),
(261905, NULL, 'PF07195', NULL, NULL, 'Flagellar hook-associated protein 2 C-terminus', NULL, 'FliD_C', NULL, NULL, 10770, 9),
(261906, NULL, 'PF20425', NULL, NULL, 'Neurobeachin alpha solenoid region', NULL, 'Neurobeachin', NULL, NULL, 33561, 9),
(261907, NULL, 'PF02101', NULL, NULL, 'Ocular albinism type 1 protein', NULL, 'Ocular_alb', NULL, NULL, 6144, 9),
(261908, NULL, 'PF11878', NULL, NULL, 'Dedicator of cytokinesis C/D, N terminal', NULL, 'DOCK_C-D_N', NULL, NULL, 19630, 9),
(261909, NULL, 'PF15069', NULL, NULL, 'FAM163 family', NULL, 'FAM163', NULL, NULL, 26054, 9),
(261910, NULL, 'PF05196', NULL, NULL, 'PTN/MK heparin-binding protein family, N-terminal domain', NULL, 'PTN_MK_N', NULL, NULL, 16312, 9),
(261911, NULL, 'PF04093', NULL, NULL, 'rod shape-determining protein MreD', NULL, 'MreD', NULL, NULL, 6855, 9),
(261912, NULL, 'PF03390', NULL, NULL, '2-hydroxycarboxylate transporter family', NULL, '2HCT', NULL, NULL, 3141, 9),
(261913, NULL, 'PF08063', NULL, NULL, 'PADR1 (NUC008) domain', NULL, 'PADR1', NULL, NULL, 12445, 9),
(261914, NULL, 'PF06467', NULL, NULL, 'MYM-type Zinc finger with FCS sequence motif', NULL, 'zf-FCS', NULL, NULL, 10242, 9),
(261915, NULL, 'PF17018', NULL, NULL, 'Spore wall protein', NULL, 'MICSWaP', NULL, NULL, 22874, 9),
(261916, NULL, 'PF20401', NULL, NULL, 'Rhomboid-like protein', NULL, 'Rhomboid_2', NULL, NULL, 33615, 9),
(261917, NULL, 'PF00187', NULL, NULL, 'Chitin recognition protein', NULL, 'Chitin_bind_1', NULL, NULL, 3245, 9),
(261918, NULL, 'PF03831', NULL, NULL, 'PhnA domain', NULL, 'YjdM', NULL, NULL, 11135, 9),
(261919, NULL, 'PF13881', NULL, NULL, 'Ubiquitin-2 like Rad60 SUMO-like', NULL, 'Rad60-SLD_2', NULL, NULL, 33264, 9),
(261920, NULL, 'PF18768', NULL, NULL, 'RNPP family C-terminal domain', NULL, 'RNPP_C', NULL, NULL, 29090, 9),
(261921, NULL, 'PF13255', NULL, NULL, 'Protein of unknown function (DUF4046)', NULL, 'DUF4046', NULL, NULL, 22764, 9),
(261922, NULL, 'PF17233', NULL, NULL, 'Family of unknown function (DUF5308)', NULL, 'DUF5308', NULL, NULL, 20104, 9),
(261923, NULL, 'PF18248', NULL, NULL, 'RalF C-terminal Sec-7 capping domain', NULL, 'RalF_SCD', NULL, NULL, 27749, 9),
(261924, NULL, 'PF18222', NULL, NULL, 'PilN biogenesis protein dimerization domain', NULL, 'PilN_bio_d', NULL, NULL, 32287, 9),
(261925, NULL, 'PF20387', NULL, NULL, 'Family of unknown function (DUF6682)', NULL, 'DUF6682', NULL, NULL, 37663, 9),
(261926, NULL, 'PF16294', NULL, NULL, 'RNSP1-SAP18 binding (RSB) motif', NULL, 'RSB_motif', NULL, NULL, 21853, 9),
(261927, NULL, 'PF09100', NULL, NULL, 'Quinohemoprotein amine dehydrogenase, alpha subunit domain IV', NULL, 'Qn_am_d_aIV', NULL, NULL, 10506, 9),
(261928, NULL, 'PF16586', NULL, NULL, 'Domain of unknown function (DUF5060)', NULL, 'DUF5060', NULL, NULL, 24039, 9),
(261929, NULL, 'PF15060', NULL, NULL, 'Differentiation and proliferation regulator', NULL, 'PPDFL', NULL, NULL, 24017, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(261930, NULL, 'PF04421', NULL, NULL, 'Mss4 protein', NULL, 'Mss4', NULL, NULL, 10774, 9),
(261931, NULL, 'PF19887', NULL, NULL, 'Family of unknown function (DUF6360)', NULL, 'DUF6360', NULL, NULL, 36648, 9),
(261932, NULL, 'PF12919', NULL, NULL, 'TcdA/TcdB catalytic glycosyltransferase domain', NULL, 'TcdA_TcdB', NULL, NULL, 23847, 9),
(261933, NULL, 'PF15371', NULL, NULL, 'Domain of unknown function (DUF4599)', NULL, 'DUF4599', NULL, NULL, 24215, 9),
(261934, NULL, 'PF05623', NULL, NULL, 'Protein of unknown function (DUF789)', NULL, 'DUF789', NULL, NULL, 12086, 9),
(261935, NULL, 'PF17927', NULL, NULL, 'Inositol 1,3,4-trisphosphate 5/6-kinase pre-ATP-grasp domain', NULL, 'Ins134_P3_kin_N', NULL, NULL, 30732, 9),
(261936, NULL, 'PF04222', NULL, NULL, 'Protein of unknown function (DUF416)', NULL, 'DUF416', NULL, NULL, 5053, 9),
(261937, NULL, 'PF05817', NULL, NULL, 'Oligosaccharyltransferase subunit Ribophorin II', NULL, 'Ribophorin_II', NULL, NULL, 13779, 9),
(261938, NULL, 'PF10508', NULL, NULL, 'Proteasome non-ATPase 26S subunit', NULL, 'Proteasom_PSMB', NULL, NULL, 19351, 9),
(261939, NULL, 'PF06491', NULL, NULL, 'Disulphide isomerase', NULL, 'Disulph_isomer', NULL, NULL, 9265, 9),
(261940, NULL, 'PF07765', NULL, NULL, 'KIP1-like protein', NULL, 'KIP1', NULL, NULL, 10616, 9),
(261941, NULL, 'PF11968', NULL, NULL, '25S rRNA (adenine(2142)-N(1))-methyltransferase, Bmt2', NULL, 'Bmt2', NULL, NULL, 19599, 9),
(261942, NULL, 'PF12225', NULL, NULL, 'Methylene-tetrahydrofolate reductase C terminal', NULL, 'DUF5981', NULL, NULL, 20184, 9),
(261943, NULL, 'PF05642', NULL, NULL, 'Sporozoite P67 surface antigen', NULL, 'Sporozoite_P67', NULL, NULL, 13760, 9),
(261944, NULL, 'PF02700', NULL, NULL, 'Phosphoribosylformylglycinamidine (FGAM) synthase', NULL, 'PurS', NULL, NULL, 3392, 9),
(261945, NULL, 'PF04646', NULL, NULL, 'Protein of unknown function, DUF604', NULL, 'DUF604', NULL, NULL, 2881, 9),
(261946, NULL, 'PF18725', NULL, NULL, 'SAV2148-like HEPN', NULL, 'HEPN_SAV2148', NULL, NULL, 29611, 9),
(261947, NULL, 'PF03816', NULL, NULL, 'LytR_cpsA_psr family', NULL, 'LytR_cpsA_psr', NULL, NULL, 7467, 9),
(261948, NULL, 'PF07312', NULL, NULL, 'Protein of unknown function (DUF1459)', NULL, 'DUF1459', NULL, NULL, 8006, 9),
(261949, NULL, 'PF08720', NULL, NULL, 'Influenza C hemagglutinin stalk', NULL, 'Hema_stalk', NULL, NULL, 11882, 9),
(261950, NULL, 'PF10338', NULL, NULL, 'Protein of unknown function (DUF2423)', NULL, 'DUF2423', NULL, NULL, 17118, 9),
(261951, NULL, 'PF17058', NULL, NULL, 'Mitochondrial biogenesis regulation protein 1', NULL, 'MBR1', NULL, NULL, 21976, 9),
(261952, NULL, 'PF18420', NULL, NULL, 'CSN4/RPN5/eIF3a helix turn helix domain', NULL, 'CSN4_RPN5_eIF3a', NULL, NULL, 29951, 9),
(261953, NULL, 'PF00621', NULL, NULL, 'RhoGEF domain', NULL, 'RhoGEF', NULL, NULL, 3790, 9),
(261954, NULL, 'PF20091', NULL, NULL, 'Alpha/beta hydrolase domain', NULL, 'Abhydrolase_10', NULL, NULL, 35618, 9),
(261955, NULL, 'PF18205', NULL, NULL, 'VPDSG-CTERM motif', NULL, 'VPDSG-CTERM', NULL, NULL, 15332, 9),
(261956, NULL, 'PF13923', NULL, NULL, 'Zinc finger, C3HC4 type (RING finger)', NULL, 'zf-C3HC4_2', NULL, NULL, NULL, 9),
(261957, NULL, 'PF12735', NULL, NULL, 'TRAPP trafficking subunit Trs65', NULL, 'Trs65', NULL, NULL, 5057, 9),
(261958, NULL, 'PF10543', NULL, NULL, 'ORF6N domain', NULL, 'ORF6N', NULL, NULL, 20518, 9),
(261959, NULL, 'PF14558', NULL, NULL, 'ML-like domain', NULL, 'TRP_N', NULL, NULL, 21926, 9),
(261960, NULL, 'PF18405', NULL, NULL, 'Mitochondrial SLC25 homolog', NULL, 'SLC25_like', NULL, NULL, 29235, 9),
(261961, NULL, 'PF02417', NULL, NULL, 'Chromate transporter', NULL, 'Chromate_transp', NULL, NULL, 6077, 9),
(261962, NULL, 'PF00952', NULL, NULL, 'Bunyavirus nucleocapsid (N) protein', NULL, 'Bunya_nucleocap', NULL, NULL, 4373, 9),
(261963, NULL, 'PF10040', NULL, NULL, 'CRISPR-associated endoribonuclease Cas6', NULL, 'CRISPR_Cas6', NULL, NULL, 19828, 9),
(261964, NULL, 'PF03705', NULL, NULL, 'CheR methyltransferase, all-alpha domain', NULL, 'CheR_N', NULL, NULL, 16542, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(261965, NULL, 'PF15588', NULL, NULL, 'Immunity protein 10', NULL, 'Imm10', NULL, NULL, 24632, 9),
(261966, NULL, 'PF10759', NULL, NULL, 'Bacterial proteasome activator', NULL, 'BPA', NULL, NULL, 20142, 9),
(261967, NULL, 'PF10945', NULL, NULL, 'Cellulose biosynthesis protein BcsR', NULL, 'CBP_BcsR', NULL, NULL, 24056, 9),
(261968, NULL, 'PF15157', NULL, NULL, 'Fusion protein IQCJ-SCHIP1 with IQ-like motif', NULL, 'IQCJ-SCHIP1', NULL, NULL, 26241, 9),
(261969, NULL, 'PF08524', NULL, NULL, 'rRNA processing', NULL, 'rRNA_processing', NULL, NULL, 7675, 9),
(261970, NULL, 'PF02472', NULL, NULL, 'Biopolymer transport protein ExbD/TolR', NULL, 'ExbD', NULL, NULL, 5220, 9),
(261971, NULL, 'PF08352', NULL, NULL, 'Oligopeptide/dipeptide transporter, C-terminal region', NULL, 'oligo_HPY', NULL, NULL, 12957, 9),
(261972, NULL, 'PF16892', NULL, NULL, 'Chitin biosynthesis protein CHS5 N-terminus', NULL, 'CHS5_N', NULL, NULL, 22699, 9),
(261973, NULL, 'PF17688', NULL, NULL, 'Family of unknown function (DUF5536)', NULL, 'DUF5536', NULL, NULL, 30355, 9),
(261974, NULL, 'PF10488', NULL, NULL, 'Phosphatase-1 catalytic subunit binding region', NULL, 'PP1c_bdg', NULL, NULL, 18239, 9),
(261975, NULL, 'PF07860', NULL, NULL, 'WisP family C-Terminal Region', NULL, 'CCD', NULL, NULL, 13371, 9),
(261976, NULL, 'PF09849', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2076)', NULL, 'DUF2076', NULL, NULL, 16686, 9),
(261977, NULL, 'PF14710', NULL, NULL, 'Respiratory nitrate reductase alpha N-terminal', NULL, 'Nitr_red_alph_N', NULL, NULL, 21966, 9),
(261978, NULL, 'PF09583', NULL, NULL, 'Phage shock protein G (Phageshock_PspG)', NULL, 'Phageshock_PspG', NULL, NULL, 9760, 9),
(261979, NULL, 'PF01946', NULL, NULL, 'Thi4 family', NULL, 'Thi4', NULL, NULL, NULL, 9),
(261980, NULL, 'PF16918', NULL, NULL, 'Protein kinase G tetratricopeptide repeat', NULL, 'PknG_TPR', NULL, NULL, 25112, 9),
(261981, NULL, 'PF07938', NULL, NULL, 'Fungal fucose-specific lectin', NULL, 'Fungal_lectin', NULL, NULL, 14264, 9),
(261982, NULL, 'PF02571', NULL, NULL, 'Precorrin-6x reductase CbiJ/CobK', NULL, 'CbiJ', NULL, NULL, 2052, 9),
(261983, NULL, 'PF15191', NULL, NULL, 'Synaptonemal complex central element protein 3', NULL, 'Synaptonemal_3', NULL, NULL, 21950, 9),
(261984, NULL, 'PF00416', NULL, NULL, 'Ribosomal protein S13/S18', NULL, 'Ribosomal_S13', NULL, NULL, 4401, 9),
(261985, NULL, 'PF02711', NULL, NULL, 'E4 protein', NULL, 'Pap_E4', NULL, NULL, 3224, 9),
(261986, NULL, 'PF17576', NULL, NULL, 'Family of unknown function (DUF5480)', NULL, 'DUF5480', NULL, NULL, 30932, 9),
(261987, NULL, 'PF20462', NULL, NULL, 'Domain of unknown function (DUF6715)', NULL, 'DUF6715', NULL, NULL, 37738, 9),
(261988, NULL, 'PF07309', NULL, NULL, 'Flagellar protein FlaF', NULL, 'FlaF', NULL, NULL, 11670, 9),
(261989, NULL, 'PF08178', NULL, NULL, 'GnsA/GnsB toxin of bacterial toxin-antitoxin system', NULL, 'GnsAB_toxin', NULL, NULL, 9066, 9),
(261990, NULL, 'PF11869', NULL, NULL, 'Protein of unknown function (DUF3389)', NULL, 'DUF3389', NULL, NULL, 19158, 9),
(261991, NULL, 'PF15944', NULL, NULL, 'Domain of unknown function (DUF4752)', NULL, 'DUF4752', NULL, NULL, 24984, 9),
(261992, NULL, 'PF05057', NULL, NULL, 'Putative serine esterase (DUF676)', NULL, 'DUF676', NULL, NULL, 1331, 9),
(261993, NULL, 'PF05269', NULL, NULL, 'Bacteriophage CII protein', NULL, 'Phage_CII', NULL, NULL, 4018, 9),
(261994, NULL, 'PF17306', NULL, NULL, 'Family of unknown function (DUF5355)', NULL, 'DUF5355', NULL, NULL, 31820, 9),
(261995, NULL, 'PF05805', NULL, NULL, 'L6 membrane protein', NULL, 'L6_membrane', NULL, NULL, 12584, 9),
(261996, NULL, 'PF07754', NULL, NULL, 'Small zinc finger protein HVO_2753-like, Zn-binding pocket', NULL, 'HVO_2753_ZBP', NULL, NULL, 10522, 9),
(261997, NULL, 'PF19628', NULL, NULL, 'Family of unknown function (DUF6132)', NULL, 'DUF6132', NULL, NULL, 34445, 9),
(261998, NULL, 'PF00860', NULL, NULL, 'Permease family', NULL, 'Xan_ur_permease', NULL, NULL, 11443, 9),
(261999, NULL, 'PF17605', NULL, NULL, 'Family of unknown function (DUF5501)', NULL, 'DUF5501', NULL, NULL, 20486, 9);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(262000, NULL, 'PF08074', NULL, NULL, 'CHDCT2 (NUC038) domain', NULL, 'CHDCT2', NULL, NULL, 11668, 9),
(262001, NULL, 'PF03016', NULL, NULL, 'Exostosin family', NULL, 'Exostosin', NULL, NULL, 33119, 9),
(262002, NULL, 'PF02355', NULL, NULL, 'Protein export membrane protein', NULL, 'SecD_SecF', NULL, NULL, 14574, 9),
(262003, NULL, 'PF07676', NULL, NULL, 'WD40-like Beta Propeller Repeat', NULL, 'PD40', NULL, NULL, 10883, 9),
(262004, NULL, 'PF14215', NULL, NULL, 'bHLH-MYC and R2R3-MYB transcription factors N-terminal', NULL, 'bHLH-MYC_N', NULL, NULL, 25957, 9),
(262005, NULL, 'PF12229', NULL, NULL, 'Putative peptidoglycan binding domain', NULL, 'PG_binding_4', NULL, NULL, 20253, 9),
(262006, NULL, 'PF10335', NULL, NULL, 'Putative nucleotidyltransferase substrate binding domain', NULL, 'DUF294_C', NULL, NULL, 19582, 9),
(262007, NULL, 'PF17115', NULL, NULL, 'N-terminal domain of toast_rack, DUF2154', NULL, 'Toast_rack_N', NULL, NULL, 26336, 9),
(262008, NULL, 'PF05511', NULL, NULL, 'Mitochondrial ATP synthase coupling factor 6', NULL, 'ATP-synt_F6', NULL, NULL, 7989, 9),
(262009, NULL, 'PF19003', NULL, NULL, 'Family of unknown function (DUF5732)', NULL, 'DUF5732', NULL, NULL, 35318, 9),
(262010, NULL, 'PF14437', NULL, NULL, 'MafB19-like deaminase', NULL, 'MafB19-deam', NULL, NULL, 25323, 9),
(262011, NULL, 'PF05207', NULL, NULL, 'CSL zinc finger', NULL, 'zf-CSL', NULL, NULL, 3433, 9),
(262012, NULL, 'PF20209', NULL, NULL, 'Domain of unknown function (DUF6570)', NULL, 'DUF6570', NULL, NULL, 37147, 9),
(262013, NULL, 'PF03691', NULL, NULL, 'Uncharacterised protein family (UPF0167)', NULL, 'UPF0167', NULL, NULL, 6481, 9),
(262014, NULL, 'PF03097', NULL, NULL, 'BRO1-like domain', NULL, 'BRO1', NULL, NULL, 4977, 9),
(262015, NULL, 'PF00368', NULL, NULL, 'Hydroxymethylglutaryl-coenzyme A reductase', NULL, 'HMG-CoA_red', NULL, NULL, 235, 9),
(262016, NULL, 'PF16362', NULL, NULL, 'YaiA protein', NULL, 'YaiA', NULL, NULL, 25319, 9),
(262017, NULL, 'PF13168', NULL, NULL, 'Poxvirus B22R protein C-terminal', NULL, 'Poxvirus_B22R_C', NULL, NULL, 22233, 9),
(262018, NULL, 'PF16022', NULL, NULL, 'Domain of unknown function (DUF4783)', NULL, 'DUF4783', NULL, NULL, 23813, 9),
(262019, NULL, 'PF12074', NULL, NULL, 'Generalcontrol nonderepressible 1 (Gcn1) N-terminal', NULL, 'Gcn1_N', NULL, NULL, 16936, 9),
(262020, NULL, 'PF02470', NULL, NULL, 'MlaD protein', NULL, 'MlaD', NULL, NULL, 5474, 9),
(262021, NULL, 'PF03479', NULL, NULL, 'Plants and Prokaryotes Conserved (PCC) domain', NULL, 'PCC', NULL, NULL, 5145, 9),
(262022, NULL, 'PF12525', NULL, NULL, 'Protein of unknown function (DUF3726)', NULL, 'DUF3726', NULL, NULL, 21261, 9),
(262023, NULL, 'PF16533', NULL, NULL, 'STIM1 Orai1-activating region', NULL, 'SOAR', NULL, NULL, 24084, 9),
(262024, NULL, 'PF20500', NULL, NULL, 'DNA-PKcs, N-terminal', NULL, 'DNA-PKcs_N', NULL, NULL, 36695, 9),
(262025, NULL, 'PF05425', NULL, NULL, 'Copper resistance protein D', NULL, 'CopD', NULL, NULL, 12473, 9),
(262026, NULL, 'PF09512', NULL, NULL, 'Thiamine-precursor transporter protein (ThiW)', NULL, 'ThiW', NULL, NULL, 10433, 9),
(262027, NULL, 'PF11557', NULL, NULL, 'Solitary outer membrane autotransporter beta-barrel domain', NULL, 'Omp_AT', NULL, NULL, 18744, 9),
(262028, NULL, 'PF13976', NULL, NULL, 'GAG-pre-integrase domain', NULL, 'gag_pre-integrs', NULL, NULL, 22695, 9),
(262029, NULL, 'PF01241', NULL, NULL, 'Photosystem I psaG / psaK', NULL, 'PSI_PSAK', NULL, NULL, 5845, 9),
(262030, NULL, 'PF12002', NULL, NULL, 'MgsA AAA+ ATPase C terminal', NULL, 'MgsA_C', NULL, NULL, 19878, 9),
(262031, NULL, 'PF09928', NULL, NULL, 'Predicted small integral membrane protein (DUF2160)', NULL, 'DUF2160', NULL, NULL, 17432, 9),
(262032, NULL, 'PF15472', NULL, NULL, 'Domain of unknown function (DUF4638)', NULL, 'DUF4638', NULL, NULL, 26763, 9),
(262033, NULL, 'PF17086', NULL, NULL, 'Small capsid protein of Herpesviridae', NULL, 'HV_small_capsid', NULL, NULL, 24426, 9),
(262034, NULL, 'PF15378', NULL, NULL, 'Domain of unknown function (DUF4605)', NULL, 'DUF4605', NULL, NULL, 24070, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(262035, NULL, 'PF10501', NULL, NULL, 'Ribosomal subunit 39S', NULL, 'Ribosomal_L50', NULL, NULL, 19862, 9),
(262036, NULL, 'PF11012', NULL, NULL, 'Protein of unknown function (DUF2850)', NULL, 'DUF2850', NULL, NULL, 17569, 9),
(262037, NULL, 'PF04083', NULL, NULL, 'Partial alpha/beta-hydrolase lipase region', NULL, 'Abhydro_lipase', NULL, NULL, 2082, 9),
(262038, NULL, 'PF02330', NULL, NULL, 'Mitochondrial glycoprotein', NULL, 'MAM33', NULL, NULL, 5254, 9),
(262039, NULL, 'PF06575', NULL, NULL, 'Protein of unknown function (DUF1132)', NULL, 'DUF1132', NULL, NULL, 9020, 9),
(262040, NULL, 'PF04854', NULL, NULL, 'Protein of unknown function, DUF624', NULL, 'DUF624', NULL, NULL, 5962, 9),
(262041, NULL, 'PF03378', NULL, NULL, 'CAS/CSE protein, C-terminus', NULL, 'CAS_CSE1', NULL, NULL, 2016, 9),
(262042, NULL, 'PF15030', NULL, NULL, 'Protein of unknown function (DUF4527)', NULL, 'DUF4527', NULL, NULL, 22032, 9),
(262043, NULL, 'PF01369', NULL, NULL, 'Sec7 domain', NULL, 'Sec7', NULL, NULL, 3401, 9),
(262044, NULL, 'PF10887', NULL, NULL, 'Protein of unknown function (DUF2686)', NULL, 'DUF2686', NULL, NULL, 17602, 9),
(262045, NULL, 'PF13115', NULL, NULL, 'YtkA-like', NULL, 'YtkA', NULL, NULL, 26852, 9),
(262046, NULL, 'PF19957', NULL, NULL, 'Effector-associated domain 5', NULL, 'EAD5', NULL, NULL, 35862, 9),
(262047, NULL, 'PF19324', NULL, NULL, 'LETM1 domain-containing protein LETM2 N-terminus', NULL, 'LETM2_N', NULL, NULL, 34232, 9),
(262048, NULL, 'PF17743', NULL, NULL, 'Family of unknown function (DUF5580)', NULL, 'DUF5580', NULL, NULL, 28916, 9),
(262049, NULL, 'PF18490', NULL, NULL, 'tRNA-binding domain', NULL, 'tRNA_bind_4', NULL, NULL, 29069, 9),
(262050, NULL, 'PF09028', NULL, NULL, 'Mac 1', NULL, 'Mac-1', NULL, NULL, 9623, 9),
(262051, NULL, 'PF11381', NULL, NULL, 'Protein of unknown function (DUF3185)', NULL, 'DUF3185', NULL, NULL, 18555, 9),
(262052, NULL, 'PF07546', NULL, NULL, 'EMI domain', NULL, 'EMI', NULL, NULL, 12641, 9),
(262053, NULL, 'PF00354', NULL, NULL, 'Pentaxin family', NULL, 'Pentaxin', NULL, NULL, 3338, 9),
(262054, NULL, 'PF04607', NULL, NULL, 'Region found in RelA / SpoT proteins', NULL, 'RelA_SpoT', NULL, NULL, 753, 9),
(262055, NULL, 'PF03614', NULL, NULL, 'Repressor of phase-1 flagellin', NULL, 'Flag1_repress', NULL, NULL, 6143, 9),
(262056, NULL, 'PF18423', NULL, NULL, 'Zinc binding domain', NULL, 'zf_CopZ', NULL, NULL, 32434, 9),
(262057, NULL, 'PF18693', NULL, NULL, 'TRAM domain', NULL, 'TRAM_2', NULL, NULL, 30338, 9),
(262058, NULL, 'PF19525', NULL, NULL, 'Ets1 N-terminal flanking region of Ets domain', NULL, 'Ets1_N_flank', NULL, NULL, 36485, 9),
(262059, NULL, 'PF11837', NULL, NULL, 'Beta-fructofuranosidase, N-terminal domain', NULL, 'INV_N', NULL, NULL, 19140, 9),
(262060, NULL, 'PF15542', NULL, NULL, 'Bacterial toxin 50', NULL, 'Ntox50', NULL, NULL, 25269, 9),
(262061, NULL, 'PF05257', NULL, NULL, 'CHAP domain', NULL, 'CHAP', NULL, NULL, 3251, 9),
(262062, NULL, 'PF10223', NULL, NULL, 'Uncharacterized conserved protein (DUF2181)', NULL, 'DUF2181', NULL, NULL, 15730, 9),
(262063, NULL, 'PF17132', NULL, NULL, 'alpha-L-rhamnosidase', NULL, 'Glyco_hydro_106', NULL, NULL, NULL, 9),
(262064, NULL, 'PF10768', NULL, NULL, 'Class II flagellar assembly regulator', NULL, 'FliX', NULL, NULL, 20888, 9),
(262065, NULL, 'PF10236', NULL, NULL, 'Mitochondrial ribosomal death-associated protein 3', NULL, 'DAP3', NULL, NULL, 15629, 9),
(262066, NULL, 'PF18854', NULL, NULL, 'Bacterial archaeo-eukaryotic release factor family 10', NULL, 'baeRF_family10', NULL, NULL, 29404, 9),
(262067, NULL, 'PF07368', NULL, NULL, 'Protein of unknown function (DUF1487)', NULL, 'DUF1487', NULL, NULL, 8386, 9),
(262068, NULL, 'PF09401', NULL, NULL, 'Coronavirus RNA synthesis protein NSP10', NULL, 'CoV_NSP10', NULL, NULL, 15877, 9),
(262069, NULL, 'PF18453', NULL, NULL, 'Oligomerization domain of C4b-binding protein alpha', NULL, 'C4bp_oligo', NULL, NULL, 27794, 9),
(262070, NULL, 'PF19319', NULL, NULL, 'Domain of unknown function (DUF5919)', NULL, 'DUF5919', NULL, NULL, 36448, 9),
(262071, NULL, 'PF20022', NULL, NULL, 'vWA-MoxR associated protein middle region 19', NULL, 'VMAP-M19', NULL, NULL, 35948, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(262072, NULL, 'PF00117', NULL, NULL, 'Glutamine amidotransferase class-I', NULL, 'GATase', NULL, NULL, 18747, 9),
(262073, NULL, 'PF04186', NULL, NULL, 'FxsA cytoplasmic membrane protein', NULL, 'FxsA', NULL, NULL, 4678, 9),
(262074, NULL, 'PF11427', NULL, NULL, 'Tc3 transposase', NULL, 'HTH_Tnp_Tc3_1', NULL, NULL, 21505, 9),
(262075, NULL, 'PF18626', NULL, NULL, 'Glutaminase', NULL, 'Gln_deamidase_2', NULL, NULL, 30473, 9),
(262076, NULL, 'PF09491', NULL, NULL, 'AlwI restriction endonuclease', NULL, 'RE_AlwI', NULL, NULL, 15346, 9),
(262077, NULL, 'PF04177', NULL, NULL, 'TAP42-like family', NULL, 'TAP42', NULL, NULL, 4543, 9),
(262078, NULL, 'PF05392', NULL, NULL, 'Cytochrome C oxidase chain VIIB', NULL, 'COX7B', NULL, NULL, 8968, 9),
(262079, NULL, 'PF08991', NULL, NULL, 'Mature-T-Cell Proliferation I type', NULL, 'MTCP1', NULL, NULL, 21971, 9),
(262080, NULL, 'PF18778', NULL, NULL, 'Novel AID APOBEC clade 1', NULL, 'NAD1', NULL, NULL, NULL, 9),
(262081, NULL, 'PF19447', NULL, NULL, 'Family of unknown function (DUF5985)', NULL, 'DUF5985', NULL, NULL, 36583, 9),
(262082, NULL, 'PF13496', NULL, NULL, 'Domain of unknown function (DUF4120)', NULL, 'DUF4120', NULL, NULL, 21327, 9),
(262083, NULL, 'PF00531', NULL, NULL, 'Death domain', NULL, 'Death', NULL, NULL, 5848, 9),
(262084, NULL, 'PF04725', NULL, NULL, 'Photosystem II 10 kDa polypeptide PsbR', NULL, 'PsbR', NULL, NULL, 3900, 9),
(262085, NULL, 'PF08295', NULL, NULL, 'Sin3 family co-repressor', NULL, 'Sin3_corepress', NULL, NULL, 17014, 9),
(262086, NULL, 'PF04281', NULL, NULL, 'Mitochondrial import receptor subunit Tom22', NULL, 'Tom22', NULL, NULL, 3708, 9),
(262087, NULL, 'PF13528', NULL, NULL, 'Glycosyl transferase family 1', NULL, 'Glyco_trans_1_3', NULL, NULL, NULL, 9),
(262088, NULL, 'PF04493', NULL, NULL, 'Endonuclease V', NULL, 'Endonuclease_5', NULL, NULL, 1950, 9),
(262089, NULL, 'PF05870', NULL, NULL, 'Phenolic acid decarboxylase (PAD)', NULL, 'PA_decarbox', NULL, NULL, 12207, 9),
(262090, NULL, 'PF06377', NULL, NULL, 'Adipokinetic hormone', NULL, 'Adipokin_hormo', NULL, NULL, 10500, 9),
(262091, NULL, 'PF13570', NULL, NULL, 'PQQ-like domain', NULL, 'PQQ_3', NULL, NULL, 6324, 9),
(262092, NULL, 'PF17101', NULL, NULL, 'Stealth protein CR1, conserved region 1', NULL, 'Stealth_CR1', NULL, NULL, 7235, 9),
(262093, NULL, 'PF06934', NULL, NULL, 'Fatty acid cis/trans isomerase (CTI)', NULL, 'CTI', NULL, NULL, 9791, 9),
(262094, NULL, 'PF06556', NULL, NULL, 'IAP-like protein p27 C-terminus', NULL, 'ASFV_p27', NULL, NULL, 14268, 9),
(262095, NULL, 'PF04902', NULL, NULL, 'Conserved region in Nab1', NULL, 'Nab1', NULL, NULL, 5813, 9),
(262096, NULL, 'PF15789', NULL, NULL, 'Hyphally regulated cell wall GPI-anchored protein 1', NULL, 'Hyr1', NULL, NULL, 23844, 9),
(262097, NULL, 'PF01805', NULL, NULL, 'Surp module', NULL, 'Surp', NULL, NULL, 2928, 9),
(262098, NULL, 'PF05546', NULL, NULL, 'She9 / Mdm33 family', NULL, 'She9_MDM33', NULL, NULL, 13949, 9),
(262099, NULL, 'PF07001', NULL, NULL, 'BAT2 N-terminus', NULL, 'BAT2_N', NULL, NULL, 12130, 9),
(262100, NULL, 'PF10318', NULL, NULL, 'Serpentine type 7TM GPCR chemoreceptor Srh', NULL, '7TM_GPCR_Srh', NULL, NULL, 16736, 9),
(262101, NULL, 'PF15960', NULL, NULL, 'Domain of unknown function (DUF4763)', NULL, 'DUF4763', NULL, NULL, 26858, 9),
(262102, NULL, 'PF19306', NULL, NULL, 'Helicase Lhr winged helix domain', NULL, 'Lhr_WH', NULL, NULL, 36107, 9),
(262103, NULL, 'PF12030', NULL, NULL, 'Domain of unknown function (DUF3517)', NULL, 'DUF3517', NULL, NULL, 19781, 9),
(262104, NULL, 'PF00617', NULL, NULL, 'RasGEF domain', NULL, 'RasGEF', NULL, NULL, 2167, 9),
(262105, NULL, 'PF06793', NULL, NULL, 'Uncharacterised protein family (UPF0262)', NULL, 'UPF0262', NULL, NULL, 7804, 9),
(262106, NULL, 'PF02255', NULL, NULL, 'PTS system, Lactose/Cellobiose specific IIA subunit', NULL, 'PTS_IIA', NULL, NULL, 3212, 9),
(262107, NULL, 'PF11721', NULL, NULL, 'Malectin domain', NULL, 'Malectin', NULL, NULL, 19296, 9),
(262108, NULL, 'PF01255', NULL, NULL, 'Putative undecaprenyl diphosphate synthase', NULL, 'Prenyltransf', NULL, NULL, 3313, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(262109, NULL, 'PF03812', NULL, NULL, '2-keto-3-deoxygluconate permease', NULL, 'KdgT', NULL, NULL, 3442, 9),
(262110, NULL, 'PF09610', NULL, NULL, 'Mycoplasma virulence signal region (Myco_arth_vir_N)', NULL, 'Myco_arth_vir_N', NULL, NULL, 11778, 9),
(262111, NULL, 'PF14159', NULL, NULL, 'CAAD domains of cyanobacterial aminoacyl-tRNA synthetase', NULL, 'CAAD', NULL, NULL, 23321, 9),
(262112, NULL, 'PF18447', NULL, NULL, 'Fibronectin type III domain', NULL, 'FN3_7', NULL, NULL, 29055, 9),
(262113, NULL, 'PF06439', NULL, NULL, '3-keto-disaccharide hydrolase', NULL, '3keto-disac_hyd', NULL, NULL, 10487, 9),
(262114, NULL, 'PF00738', NULL, NULL, 'Polyhedrin', NULL, 'Polyhedrin', NULL, NULL, 4791, 9),
(262115, NULL, 'PF12054', NULL, NULL, 'Domain of unknown function (DUF3535)', NULL, 'DUF3535', NULL, NULL, 16578, 9),
(262116, NULL, 'PF06075', NULL, NULL, 'Plant protein of unknown function (DUF936)', NULL, 'DUF936', NULL, NULL, 8951, 9),
(262117, NULL, 'PF06334', NULL, NULL, 'Orthopoxvirus A47 protein', NULL, 'Orthopox_A47', NULL, NULL, 8333, 9),
(262118, NULL, 'PF08708', NULL, NULL, 'Primase C terminal 1 (PriCT-1)', NULL, 'PriCT_1', NULL, NULL, 11545, 9),
(262119, NULL, 'PF11576', NULL, NULL, 'FeGP cofactor biosynthesis protein HcgB, guanylyltransferase', NULL, 'HcgB', NULL, NULL, 10937, 9),
(262120, NULL, 'PF15432', NULL, NULL, 'Accessory Sec secretory system ASP3', NULL, 'Sec-ASP3', NULL, NULL, 15687, 9),
(262121, NULL, 'PF04366', NULL, NULL, 'Las17-binding protein actin regulator', NULL, 'Ysc84', NULL, NULL, 4539, 9),
(262122, NULL, 'PF08701', NULL, NULL, 'GNL3L/Grn1 putative GTPase', NULL, 'GN3L_Grn1', NULL, NULL, 11575, 9),
(262123, NULL, 'PF11056', NULL, NULL, 'Recombination, repair and ssDNA binding protein UvsY', NULL, 'UvsY', NULL, NULL, 17674, 9),
(262124, NULL, 'PF10703', NULL, NULL, 'MoaF N-terminal domain', NULL, 'MoaF', NULL, NULL, 1486, 9),
(262125, NULL, 'PF10512', NULL, NULL, 'Cell division cycle-associated protein 8', NULL, 'Borealin', NULL, NULL, 37690, 9),
(262126, NULL, 'PF08844', NULL, NULL, 'Domain of unknown function (DUF1815)', NULL, 'DUF1815', NULL, NULL, 14496, 9),
(262127, NULL, 'PF06714', NULL, NULL, 'Gp5 N-terminal OB domain', NULL, 'Gp5_OB', NULL, NULL, 1719, 9),
(262128, NULL, 'PF05762', NULL, NULL, 'VWA domain containing CoxE-like protein', NULL, 'VWA_CoxE', NULL, NULL, 7719, 9),
(262129, NULL, 'PF16361', NULL, NULL, 'N-terminal of Subtilase family', NULL, 'Peptidase_S8_N', NULL, NULL, 25129, 9),
(262130, NULL, 'PF13690', NULL, NULL, 'Chemotaxis phosphatase CheX', NULL, 'CheX', NULL, NULL, 25562, 9),
(262131, NULL, 'PF03269', NULL, NULL, 'Caenorhabditis protein of unknown function, DUF268', NULL, 'DUF268', NULL, NULL, 2939, 9),
(262132, NULL, 'PF17131', NULL, NULL, 'Outer membrane lipoprotein-sorting protein', NULL, 'LolA_like', NULL, NULL, 27734, 9),
(262133, NULL, 'PF01422', NULL, NULL, 'NF-X1 type zinc finger', NULL, 'zf-NF-X1', NULL, NULL, 3044, 9),
(262134, NULL, 'PF02925', NULL, NULL, 'Bacteriophage scaffolding protein D', NULL, 'gpD', NULL, NULL, 2987, 9),
(262135, NULL, 'PF17861', NULL, NULL, 'Laterosporulin defensin-like peptide', NULL, 'Laterosporulin', NULL, NULL, 30470, 9),
(262136, NULL, 'PF02591', NULL, NULL, 'C4-type zinc ribbon domain', NULL, 'zf-RING_7', NULL, NULL, 6001, 9),
(262137, NULL, 'PF06815', NULL, NULL, 'Reverse transcriptase connection domain', NULL, 'RVT_connect', NULL, NULL, 9463, 9),
(262138, NULL, 'PF15710', NULL, NULL, 'Break repair meiotic recombinase recruitment factor 1', NULL, 'Brme1', NULL, NULL, 25424, 9),
(262139, NULL, 'PF09246', NULL, NULL, 'PHAT', NULL, 'PHAT', NULL, NULL, 13302, 9),
(262140, NULL, 'PF17383', NULL, NULL, 'Uncharacterized KorC regulated protein A', NULL, 'kleA_kleC', NULL, NULL, 29896, 9),
(262141, NULL, 'PF15620', NULL, NULL, 'Centromere assembly component CENP-C middle DNMT3B-binding region', NULL, 'CENP-C_mid', NULL, NULL, 25149, 9),
(262142, NULL, 'PF08773', NULL, NULL, 'Cathepsin C exclusion domain', NULL, 'CathepsinC_exc', NULL, NULL, 13240, 9),
(262143, NULL, 'PF01458', NULL, NULL, 'SUF system FeS cluster assembly, SufBD', NULL, 'SUFBD', NULL, NULL, 346, 9);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(262144, NULL, 'PF12602', NULL, NULL, 'Fertility inhibition protein N terminal', NULL, 'FinO_N', NULL, NULL, 15081, 9),
(262145, NULL, 'PF16752', NULL, NULL, 'Tubulin-specific chaperone C N-terminal domain', NULL, 'TBCC_N', NULL, NULL, 25613, 9),
(262146, NULL, 'PF10769', NULL, NULL, 'Protein of unknown function (DUF2594)', NULL, 'DUF2594', NULL, NULL, 20691, 9),
(262147, NULL, 'PF14145', NULL, NULL, 'YrhK-like protein', NULL, 'YrhK', NULL, NULL, 26103, 9),
(262148, NULL, 'PF06071', NULL, NULL, 'Protein of unknown function (DUF933)', NULL, 'YchF-GTPase_C', NULL, NULL, 11410, 9),
(262149, NULL, 'PF06722', NULL, NULL, 'Protein of unknown function (DUF1205)', NULL, 'DUF1205', NULL, NULL, 8238, 9),
(262150, NULL, 'PF09291', NULL, NULL, 'Domain of unknown function (DUF1968)', NULL, 'DUF1968', NULL, NULL, 14269, 9),
(262151, NULL, 'PF14038', NULL, NULL, 'YqzE-like protein', NULL, 'YqzE', NULL, NULL, 24128, 9),
(262152, NULL, 'PF14420', NULL, NULL, 'Clr5 domain', NULL, 'Clr5', NULL, NULL, 24717, 9),
(262153, NULL, 'PF09147', NULL, NULL, 'Carbapenam-3-carboxylate synthase, N-terminal', NULL, 'CarA_N', NULL, NULL, 10562, 9),
(262154, NULL, 'PF17330', NULL, NULL, 'SWR1 chromatin-remodelling complex, sub-unit Swc7', NULL, 'SWC7', NULL, NULL, 17736, 9),
(262155, NULL, 'PF13798', NULL, NULL, 'Protein of unknown function with PCYCGC motif', NULL, 'PCYCGC', NULL, NULL, 24110, 9),
(262156, NULL, 'PF08737', NULL, NULL, 'Rgp1', NULL, 'Rgp1', NULL, NULL, 11807, 9),
(262157, NULL, 'PF03855', NULL, NULL, 'M-factor', NULL, 'M-factor', NULL, NULL, 1698, 9),
(262158, NULL, 'PF04284', NULL, NULL, 'Protein of unknown function (DUF441)', NULL, 'DUF441', NULL, NULL, 5929, 9),
(262159, NULL, 'PF09223', NULL, NULL, 'ZinT (YodA) periplasmic lipocalin-like zinc-recruitment', NULL, 'ZinT', NULL, NULL, 13042, 9),
(262160, NULL, 'PF11210', NULL, NULL, 'Protein of unknown function (DUF2996)', NULL, 'DUF2996', NULL, NULL, 18331, 9),
(262161, NULL, 'PF10601', NULL, NULL, 'LITAF-like zinc ribbon domain', NULL, 'zf-LITAF-like', NULL, NULL, 1034, 9),
(262162, NULL, 'PF12906', NULL, NULL, 'RING-variant domain', NULL, 'RINGv', NULL, NULL, 9214, 9),
(262163, NULL, 'PF13163', NULL, NULL, 'Protein of unknown function (DUF3999)', NULL, 'DUF3999', NULL, NULL, 22918, 9),
(262164, NULL, 'PF14054', NULL, NULL, 'Domain of unknown function (DUF4249)', NULL, 'DUF4249', NULL, NULL, 22094, 9),
(262165, NULL, 'PF14484', NULL, NULL, 'Fish-specific NACHT associated domain', NULL, 'FISNA', NULL, NULL, 22435, 9),
(262166, NULL, 'PF05291', NULL, NULL, 'Bystin', NULL, 'Bystin', NULL, NULL, 4202, 9),
(262167, NULL, 'PF10200', NULL, NULL, 'NADH:ubiquinone oxidoreductase, NDUFS5-15kDa', NULL, 'Ndufs5', NULL, NULL, 15945, 9),
(262168, NULL, 'PF11196', NULL, NULL, 'Protein of unknown function DUF2834', NULL, 'DUF2834', NULL, NULL, 18456, 9),
(262169, NULL, 'PF02173', NULL, NULL, 'pKID domain', NULL, 'pKID', NULL, NULL, 4345, 9),
(262170, NULL, 'PF09633', NULL, NULL, 'Protein of unknown function (DUF2023)', NULL, 'DUF2023', NULL, NULL, 15748, 9),
(262171, NULL, 'PF11336', NULL, NULL, 'Protein of unknown function (DUF3138)', NULL, 'DUF3138', NULL, NULL, 18183, 9),
(262172, NULL, 'PF18406', NULL, NULL, 'Ferredoxin-like domain in Api92-like protein', NULL, 'DUF1281_C', NULL, NULL, 30607, 9),
(262173, NULL, 'PF03859', NULL, NULL, 'CG-1 domain', NULL, 'CG-1', NULL, NULL, 1663, 9),
(262174, NULL, 'PF10341', NULL, NULL, 'Shelterin complex subunit, TPP1/ACD', NULL, 'TPP1', NULL, NULL, 17083, 9),
(262175, NULL, 'PF12468', NULL, NULL, 'Type III secretion system leucine rich repeat protein', NULL, 'TTSSLRR', NULL, NULL, 18143, 9),
(262176, NULL, 'PF18364', NULL, NULL, 'Molybdopterin oxidoreductase N-terminal domain', NULL, 'Molybdopterin_N', NULL, NULL, 29646, 9),
(262177, NULL, 'PF00336', NULL, NULL, 'DNA polymerase (viral) C-terminal domain', NULL, 'DNA_pol_viral_C', NULL, NULL, 6026, 9),
(262178, NULL, 'PF09529', NULL, NULL, 'Integral membrane protein (intg_mem_TP0381)', NULL, 'Intg_mem_TP0381', NULL, NULL, 11759, 9),
(262179, NULL, 'PF09047', NULL, NULL, 'MEF2 binding', NULL, 'MEF2_binding', NULL, NULL, 9922, 9);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(262180, NULL, 'PF13590', NULL, NULL, 'Domain of unknown function (DUF4136)', NULL, 'DUF4136', NULL, NULL, 22375, 9),
(262181, NULL, 'PF07929', NULL, NULL, 'Plasmid pRiA4b ORF-3-like protein', NULL, 'PRiA4_ORF3', NULL, NULL, 13452, 9),
(262182, NULL, 'PF12379', NULL, NULL, 'Betacoronavirus replicase NSP3, N-terminal', NULL, 'bCoV_NSP3_N', NULL, NULL, 22093, 9),
(262183, NULL, 'PF10426', NULL, NULL, 'Recombination-activating protein 1 zinc-finger domain', NULL, 'zf-RAG1', NULL, NULL, 18211, 9),
(262184, NULL, 'PF06046', NULL, NULL, 'Exocyst complex component Sec6', NULL, 'Sec6', NULL, NULL, 8974, 9),
(262185, NULL, 'PF18105', NULL, NULL, 'PGM1 C-terminal domain', NULL, 'PGM1_C', NULL, NULL, 29400, 9),
(262186, NULL, 'PF19472', NULL, NULL, 'Family of unknown function (DUF6009)', NULL, 'DUF6009', NULL, NULL, 36544, 9),
(262187, NULL, 'PF19845', NULL, NULL, 'Family of unknown function (DUF6320)', NULL, 'DUF6320', NULL, NULL, 37769, 9),
(262188, NULL, 'PF16820', NULL, NULL, 'PKD-like domain', NULL, 'PKD_3', NULL, NULL, 30485, 9),
(262189, NULL, 'PF02050', NULL, NULL, 'Flagellar FliJ protein', NULL, 'FliJ', NULL, NULL, 12981, 9),
(262190, NULL, 'PF08762', NULL, NULL, 'CRPV capsid protein like', NULL, 'CRPV_capsid', NULL, NULL, 13168, 9),
(262191, NULL, 'PF20290', NULL, NULL, 'ABC-three component (ABC-3C) system Middle Component 4', NULL, 'MC4', NULL, NULL, 33674, 9),
(262192, NULL, 'PF08076', NULL, NULL, 'Tetracycline resistance determinant leader peptide', NULL, 'TetM_leader', NULL, NULL, 12433, 9),
(262193, NULL, 'PF19897', NULL, NULL, 'Family of unknown function (DUF6370)', NULL, 'DUF6370', NULL, NULL, 36892, 9),
(262194, NULL, 'PF03294', NULL, NULL, 'RNA polymerase-associated transcription specificity factor, Rap94', NULL, 'Pox_Rap94', NULL, NULL, 959, 9),
(262195, NULL, 'PF09497', NULL, NULL, 'Transcription mediator complex subunit Med12', NULL, 'Med12', NULL, NULL, 15787, 9),
(262196, NULL, 'PF05086', NULL, NULL, 'Dictyostelium (Slime Mold) REP protein', NULL, 'Dicty_REP', NULL, NULL, 1099, 9),
(262197, NULL, 'PF00834', NULL, NULL, 'Ribulose-phosphate 3 epimerase family', NULL, 'Ribul_P_3_epim', NULL, NULL, 2990, 9),
(262198, NULL, 'PF04244', NULL, NULL, 'Deoxyribodipyrimidine photo-lyase-related protein', NULL, 'DPRP', NULL, NULL, 5880, 9),
(262199, NULL, 'PF09365', NULL, NULL, 'Conserved hypothetical protein (DUF2461)', NULL, 'DUF2461', NULL, NULL, 12502, 9),
(262200, NULL, 'PF10456', NULL, NULL, 'WASP-binding domain of Sorting nexin protein', NULL, 'BAR_3_WASP_bdg', NULL, NULL, 18182, 9),
(262201, NULL, 'PF04153', NULL, NULL, 'NOT2 / NOT3 / NOT5 family', NULL, 'NOT2_3_5', NULL, NULL, 7378, 9),
(262202, NULL, 'PF07558', NULL, NULL, 'Shugoshin N-terminal coiled-coil region', NULL, 'Shugoshin_N', NULL, NULL, 12508, 9),
(262203, NULL, 'PF07947', NULL, NULL, 'YhhN family', NULL, 'YhhN', NULL, NULL, 12959, 9),
(262204, NULL, 'PF14595', NULL, NULL, 'Thioredoxin', NULL, 'Thioredoxin_9', NULL, NULL, NULL, 9),
(262205, NULL, 'PF00017', NULL, NULL, 'SH2 domain', NULL, 'SH2', NULL, NULL, 3268, 9),
(262206, NULL, 'PF03333', NULL, NULL, 'Adhesin biosynthesis transcription regulatory protein', NULL, 'PapB', NULL, NULL, 5286, 9),
(262207, NULL, 'PF09688', NULL, NULL, 'Protein of unknown function (Wx5_PLAF3D7)', NULL, 'Wx5_PLAF3D7', NULL, NULL, 6920, 9),
(262208, NULL, 'PF17711', NULL, NULL, 'Family of unknown function (DUF5556)', NULL, 'DUF5556', NULL, NULL, 28527, 9),
(262209, NULL, 'PF15707', NULL, NULL, 'Mitochondrial coiled-coil domain protein 1', NULL, 'MCCD1', NULL, NULL, 25246, 9),
(262210, NULL, 'PF11136', NULL, NULL, 'Protein of unknown function (DUF2889)', NULL, 'DUF2889', NULL, NULL, 17658, 9),
(262211, NULL, 'PF14436', NULL, NULL, 'Bacterial EndoU nuclease', NULL, 'EndoU_bacteria', NULL, NULL, 26729, 9),
(262212, NULL, 'PF18574', NULL, NULL, 'C2HC Zing finger domain', NULL, 'zf_C2HC_14', NULL, NULL, 15248, 9),
(262213, NULL, 'PF02011', NULL, NULL, 'Glycosyl hydrolase family 48', NULL, 'Glyco_hydro_48', NULL, NULL, 5982, 9),
(262214, NULL, 'PF16086', NULL, NULL, 'Domain of unknown function (DUF4816)', NULL, 'DUF4816', NULL, NULL, 23978, 9);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(262215, NULL, 'PF20584', NULL, NULL, 'Family of unknown function (DUF6787)', NULL, 'DUF6787', NULL, NULL, 37012, 9),
(262216, NULL, 'PF02686', NULL, NULL, 'Glu-tRNAGln amidotransferase C subunit', NULL, 'Glu-tRNAGln', NULL, NULL, 3098, 9),
(262217, NULL, 'PF07046', NULL, NULL, 'Cytoplasmic repetitive antigen (CRA) like repeat', NULL, 'CRA_rpt', NULL, NULL, 12282, 9),
(262218, NULL, 'PF12234', NULL, NULL, 'RAVE protein 1 C terminal', NULL, 'Rav1p_C', NULL, NULL, 20030, 9),
(262219, NULL, 'PF07755', NULL, NULL, 'Domain of unknown function (DUF1611_C) P-loop domain', NULL, 'DUF1611', NULL, NULL, 27891, 9),
(262220, NULL, 'PF00787', NULL, NULL, 'PX domain', NULL, 'PX', NULL, NULL, 3227, 9),
(262221, NULL, 'PF18515', NULL, NULL, 'Rh5 coiled-coil domain', NULL, 'Rh5', NULL, NULL, 30339, 9),
(262222, NULL, 'PF18665', NULL, NULL, 'Tetracyclin repressor-like, C-terminal domain', NULL, 'TetR_C_37', NULL, NULL, 30044, 9),
(262223, NULL, 'PF18444', NULL, NULL, 'RNA recognition motif', NULL, 'RRM_9', NULL, NULL, 28200, 9),
(262224, NULL, 'PF12420', NULL, NULL, 'Protein of unknown function', NULL, 'DUF3671', NULL, NULL, 20879, 9),
(262225, NULL, 'PF04668', NULL, NULL, 'Twisted gastrulation (Tsg) protein conserved region', NULL, 'Tsg', NULL, NULL, 3151, 9),
(262226, NULL, 'PF11271', NULL, NULL, 'Porin PorA', NULL, 'PorA', NULL, NULL, 18144, 9),
(262227, NULL, 'PF11757', NULL, NULL, 'Suppressor of RNA silencing P21-like N-terminal domain', NULL, 'RSS_P20', NULL, NULL, 19292, 9),
(262228, NULL, 'PF15372', NULL, NULL, 'Domain of unknown function (DUF4600)', NULL, 'DUF4600', NULL, NULL, 23594, 9),
(262229, NULL, 'PF08860', NULL, NULL, 'Domain of unknown function (DUF1827)', NULL, 'DUF1827', NULL, NULL, 14051, 9),
(262230, NULL, 'PF03590', NULL, NULL, 'Aspartate-ammonia ligase', NULL, 'AsnA', NULL, NULL, 2212, 9),
(262231, NULL, 'PF12324', NULL, NULL, 'Helix-turn-helix domain of alkylmercury lyase', NULL, 'HTH_15', NULL, NULL, 12404, 9),
(262232, NULL, 'PF01531', NULL, NULL, 'Glycosyl transferase family 11', NULL, 'Glyco_transf_11', NULL, NULL, 917, 9),
(262233, NULL, 'PF19043', NULL, NULL, 'Nuclear cap binding complex subunit CBP66', NULL, 'CBP66', NULL, NULL, 34967, 9),
(262234, NULL, 'PF14192', NULL, NULL, 'Domain of unknown function (DUF4314)', NULL, 'DUF4314', NULL, NULL, 26027, 9),
(262235, NULL, 'PF07946', NULL, NULL, 'PAT complex subunit CCDC47', NULL, 'CCDC47', NULL, NULL, 13372, 9),
(262236, NULL, 'PF09030', NULL, NULL, 'Creb binding', NULL, 'Creb_binding', NULL, NULL, 12235, 9),
(262237, NULL, 'PF03860', NULL, NULL, 'Domain of Unknown Function (DUF326)', NULL, 'DUF326', NULL, NULL, 1766, 9),
(262238, NULL, 'PF19732', NULL, NULL, 'Stage II sporulation protein E N-terminal', NULL, 'SpoIIE_N', NULL, NULL, 34071, 9),
(262239, NULL, 'PF05475', NULL, NULL, 'Pgp3 C-terminal domain', NULL, 'Chlam_vir', NULL, NULL, 32094, 9),
(262240, NULL, 'PF17028', NULL, NULL, '8TM Microsporidial transmembrane domain', NULL, '8TM_micro', NULL, NULL, 22941, 9),
(262241, NULL, 'PF06975', NULL, NULL, 'Protein of unknown function (DUF1299)', NULL, 'DUF1299', NULL, NULL, 9811, 9),
(262242, NULL, 'PF12052', NULL, NULL, 'Voltage gated calcium channel subunit beta domain 4Aa N terminal', NULL, 'VGCC_beta4Aa_N', NULL, NULL, 34411, 9),
(262243, NULL, 'PF15866', NULL, NULL, 'Domain of unknown function (DUF4729)', NULL, 'DUF4729', NULL, NULL, 24380, 9),
(262244, NULL, 'PF11868', NULL, NULL, 'Protein of unknown function (DUF3388)', NULL, 'DUF3388', NULL, NULL, 24529, 9),
(262245, NULL, 'PF18270', NULL, NULL, 'Virulence factor Evf', NULL, 'Evf', NULL, NULL, 29564, 9),
(262246, NULL, 'PF01039', NULL, NULL, 'Carboxyl transferase domain', NULL, 'Carboxyl_trans', NULL, NULL, 19465, 9),
(262247, NULL, 'PF03497', NULL, NULL, 'Anthrax toxin LF subunit', NULL, 'Anthrax_toxA', NULL, NULL, 4620, 9),
(262248, NULL, 'PF05145', NULL, NULL, 'Transition state regulatory protein AbrB', NULL, 'AbrB', NULL, NULL, 2422, 9),
(262249, NULL, 'PF10058', NULL, NULL, 'Predicted integral membrane zinc-ribbon metal-binding protein', NULL, 'zinc_ribbon_10', NULL, NULL, 19589, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(262250, NULL, 'PF05593', NULL, NULL, 'RHS Repeat', NULL, 'RHS_repeat', NULL, NULL, 23058, 9),
(262251, NULL, 'PF08023', NULL, NULL, 'Frog antimicrobial peptide', NULL, 'Antimicrobial_2', NULL, NULL, 12904, 9),
(262252, NULL, 'PF05722', NULL, NULL, 'Ustilago B locus mating-type protein', NULL, 'Ustilago_mating', NULL, NULL, 7723, 9),
(262253, NULL, 'PF11265', NULL, NULL, 'Mediator complex subunit 25 von Willebrand factor type A', NULL, 'Med25_VWA', NULL, NULL, 18318, 9),
(262254, NULL, 'PF01614', NULL, NULL, 'Bacterial transcriptional regulator', NULL, 'IclR', NULL, NULL, 12488, 9),
(262255, NULL, 'PF06730', NULL, NULL, 'FAM92 protein', NULL, 'FAM92', NULL, NULL, 1712, 9),
(262256, NULL, 'PF00880', NULL, NULL, 'Nebulin repeat', NULL, 'Nebulin', NULL, NULL, 3188, 9),
(262257, NULL, 'PF05504', NULL, NULL, 'Spore germination B3/ GerAC like, C-terminal', NULL, 'Spore_GerAC', NULL, NULL, NULL, 9),
(262258, NULL, 'PF14780', NULL, NULL, 'Domain of unknown function (DUF4477)', NULL, 'DUF4477', NULL, NULL, 24442, 9),
(262259, NULL, 'PF16998', NULL, NULL, '17 kDa outer membrane surface antigen', NULL, '17kDa_Anti_2', NULL, NULL, 23410, 9),
(262260, NULL, 'PF16764', NULL, NULL, 'Sharpin PH domain', NULL, 'Sharpin_PH', NULL, NULL, 22124, 9),
(262261, NULL, 'PF13562', NULL, NULL, 'Sugar nucleotidyl transferase', NULL, 'NTP_transf_4', NULL, NULL, 18472, 9),
(262262, NULL, 'PF16736', NULL, NULL, 'Single Cache-like', NULL, 'sCache_like', NULL, NULL, 22683, 9),
(262263, NULL, 'PF03270', NULL, NULL, 'Protein of unknown function, DUF269', NULL, 'DUF269', NULL, NULL, 2782, 9),
(262264, NULL, 'PF10008', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2251)', NULL, 'DUF2251', NULL, NULL, 9772, 9),
(262265, NULL, 'PF09594', NULL, NULL, 'Glycosyltransferase family 87', NULL, 'GT87', NULL, NULL, 15502, 9),
(262266, NULL, 'PF07940', NULL, NULL, 'Heparinase II/III-like protein', NULL, 'Hepar_II_III', NULL, NULL, 11897, 9),
(262267, NULL, 'PF01477', NULL, NULL, 'PLAT/LH2 domain', NULL, 'PLAT', NULL, NULL, 2447, 9),
(262268, NULL, 'PF17322', NULL, NULL, 'Family of unknown function (DUF5364)', NULL, 'DUF5364', NULL, NULL, 15784, 9),
(262269, NULL, 'PF19862', NULL, NULL, 'Family of unknown function (DUF6336)', NULL, 'DUF6336', NULL, NULL, 37617, 9),
(262270, NULL, 'PF06613', NULL, NULL, 'KorB C-terminal beta-barrel domain', NULL, 'KorB_C', NULL, NULL, 8394, 9),
(262271, NULL, 'PF08134', NULL, NULL, 'cIII protein family', NULL, 'cIII', NULL, NULL, 12451, 9),
(262272, NULL, 'PF08262', NULL, NULL, 'Leucophaea maderae tachykinin-related peptide', NULL, 'Lem_TRP', NULL, NULL, 17327, 9),
(262273, NULL, 'PF17689', NULL, NULL, 'Arabinosyltransferase concanavalin like domain', NULL, 'Arabino_trans_N', NULL, NULL, 27633, 9),
(262274, NULL, 'PF13779', NULL, NULL, 'Domain of unknown function (DUF4175)', NULL, 'DUF4175', NULL, NULL, 11701, 9),
(262275, NULL, 'PF12267', NULL, NULL, 'Protein of unknown function (DUF3614)', NULL, 'DUF3614', NULL, NULL, 20169, 9),
(262276, NULL, 'PF02884', NULL, NULL, 'Polysaccharide lyase family 8, C-terminal beta-sandwich domain', NULL, 'Lyase_8_C', NULL, NULL, 1619, 9),
(262277, NULL, 'PF08565', NULL, NULL, 'Cdc37 Hsp90 binding domain', NULL, 'CDC37_M', NULL, NULL, 9802, 9),
(262278, NULL, 'PF14112', NULL, NULL, 'Immunity protein 22', NULL, 'DUF4284', NULL, NULL, 23020, 9),
(262279, NULL, 'PF02025', NULL, NULL, 'Interleukin 5', NULL, 'IL5', NULL, NULL, 1866, 9),
(262280, NULL, 'PF19335', NULL, NULL, 'Heavy metal binding domain', NULL, 'HMBD', NULL, NULL, 36179, 9),
(262281, NULL, 'PF07362', NULL, NULL, 'Post-segregation antitoxin CcdA', NULL, 'CcdA', NULL, NULL, 8201, 9),
(262282, NULL, 'PF11859', NULL, NULL, 'Protein of unknown function (DUF3379)', NULL, 'DUF3379', NULL, NULL, 19258, 9),
(262283, NULL, 'PF11640', NULL, NULL, 'Telomere-length maintenance and DNA damage repair', NULL, 'TAN', NULL, NULL, 18863, 9),
(262284, NULL, 'PF07453', NULL, NULL, 'NUMOD1 domain', NULL, 'NUMOD1', NULL, NULL, 12136, 9),
(262285, NULL, 'PF00062', NULL, NULL, 'C-type lysozyme/alpha-lactalbumin family', NULL, 'Lys', NULL, NULL, 4337, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(262286, NULL, 'PF04986', NULL, NULL, 'Putative transposase', NULL, 'Y2_Tnp', NULL, NULL, 6733, 9),
(262287, NULL, 'PF17328', NULL, NULL, 'Family of unknown function (DUF5366)', NULL, 'DUF5366', NULL, NULL, 31756, 9),
(262288, NULL, 'PF04751', NULL, NULL, 'Protein of unknown function (DUF615)', NULL, 'DUF615', NULL, NULL, 3689, 9),
(262289, NULL, 'PF09658', NULL, NULL, 'CRISPR-associated protein (Cas_Csx9)', NULL, 'Cas_Csx9', NULL, NULL, 10344, 9),
(262290, NULL, 'PF13019', NULL, NULL, 'Silencing defective 2 N-terminal ubiquitin domain', NULL, 'Sde2_N_Ubi', NULL, NULL, 26363, 9),
(262291, NULL, 'PF15831', NULL, NULL, 'Domain of unknown function (DUF4713)', NULL, 'DUF4713', NULL, NULL, 26206, 9),
(262292, NULL, 'PF06144', NULL, NULL, 'DNA polymerase III, delta subunit', NULL, 'DNA_pol3_delta', NULL, NULL, 9003, 9),
(262293, NULL, 'PF17726', NULL, NULL, 'Dam-replacing HTH domain', NULL, 'DpnI_C', NULL, NULL, 29173, 9),
(262294, NULL, 'PF01960', NULL, NULL, 'ArgJ family', NULL, 'ArgJ', NULL, NULL, 4625, 9),
(262295, NULL, 'PF18885', NULL, NULL, 'Repeat of unknown function (DUF5648)', NULL, 'DUF5648', NULL, NULL, 34235, 9),
(262296, NULL, 'PF00796', NULL, NULL, 'Photosystem I reaction centre subunit VIII', NULL, 'PSI_8', NULL, NULL, 104, 9),
(262297, NULL, 'PF20271', NULL, NULL, 'CATRA-Associated Small Protein', NULL, 'CATASP', NULL, NULL, 33711, 9),
(262298, NULL, 'PF06781', NULL, NULL, 'Cell division protein CrgA', NULL, 'CrgA', NULL, NULL, 1597, 9),
(262299, NULL, 'PF17994', NULL, NULL, 'Galactofuranosyltransferase 2 N-terminal', NULL, 'Glft2_N', NULL, NULL, 27546, 9),
(262300, NULL, 'PF04908', NULL, NULL, 'SH3-binding, glutamic acid-rich protein', NULL, 'SH3BGR', NULL, NULL, 5868, 9),
(262301, NULL, 'PF20199', NULL, NULL, 'Replication initiator protein, pSAM2', NULL, 'RepSA', NULL, NULL, 34227, 9),
(262302, NULL, 'PF05192', NULL, NULL, 'MutS domain III', NULL, 'MutS_III', NULL, NULL, 1396, 9),
(262303, NULL, 'PF02080', NULL, NULL, 'TrkA-C domain', NULL, 'TrkA_C', NULL, NULL, 2591, 9),
(262304, NULL, 'PF04192', NULL, NULL, 'Utp21 specific WD40 associated putative domain', NULL, 'Utp21', NULL, NULL, 4546, 9),
(262305, NULL, 'PF09204', NULL, NULL, 'Bacterial self-protective colicin-like immunity', NULL, 'Colicin_immun', NULL, NULL, 12471, 9),
(262306, NULL, 'PF14649', NULL, NULL, 'Spatacsin C-terminus', NULL, 'Spatacsin_C', NULL, NULL, 23127, 9),
(262307, NULL, 'PF12141', NULL, NULL, 'Beta-mannosyltransferases', NULL, 'BMT', NULL, NULL, 20252, 9),
(262308, NULL, 'PF16815', NULL, NULL, 'Protein HRI1', NULL, 'HRI1', NULL, NULL, 22119, 9),
(262309, NULL, 'PF02547', NULL, NULL, 'Queuosine biosynthesis protein', NULL, 'Queuosine_synth', NULL, NULL, 6366, 9),
(262310, NULL, 'PF05224', NULL, NULL, 'NDT80 / PhoG like DNA-binding  family', NULL, 'NDT80_PhoG', NULL, NULL, 12127, 9),
(262311, NULL, 'PF08925', NULL, NULL, 'Domain of Unknown Function (DUF1907)', NULL, 'DUF1907', NULL, NULL, 7703, 9),
(262312, NULL, 'PF17613', NULL, NULL, 'Modifier of transcription', NULL, 'motB', NULL, NULL, 19230, 9),
(262313, NULL, 'PF15815', NULL, NULL, 'E3 ubiquitin-protein ligase makorin, C-terminal', NULL, 'MKRN1_C', NULL, NULL, 23604, 9),
(262314, NULL, 'PF02458', NULL, NULL, 'Transferase family', NULL, 'Transferase', NULL, NULL, NULL, 9),
(262315, NULL, 'PF12423', NULL, NULL, 'Kinesin protein 1B', NULL, 'KIF1B', NULL, NULL, 20856, 9),
(262316, NULL, 'PF17199', NULL, NULL, 'Protein of unknown function (DUF5136)', NULL, 'DUF5136', NULL, NULL, 37510, 9),
(262317, NULL, 'PF08560', NULL, NULL, 'Protein of unknown function (DUF1757)', NULL, 'DUF1757', NULL, NULL, 9595, 9),
(262318, NULL, 'PF14629', NULL, NULL, 'Origin recognition complex (ORC) subunit 4 C-terminus', NULL, 'ORC4_C', NULL, NULL, 21779, 9),
(262319, NULL, 'PF18848', NULL, NULL, 'Bacterial archaeo-eukaryotic release factor family 6', NULL, 'baeRF_family6', NULL, NULL, 27895, 9),
(262320, NULL, 'PF00932', NULL, NULL, 'Lamin Tail Domain', NULL, 'LTD', NULL, NULL, 243, 9),
(262321, NULL, 'PF07924', NULL, NULL, 'Nuclease A inhibitor-like protein', NULL, 'NuiA', NULL, NULL, 12880, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(262322, NULL, 'PF17852', NULL, NULL, 'Dynein heavy chain AAA lid domain', NULL, 'Dynein_AAA_lid', NULL, NULL, 29985, 9),
(262323, NULL, 'PF07808', NULL, NULL, 'RED-like protein N-terminal region', NULL, 'RED_N', NULL, NULL, 7809, 9),
(262324, NULL, 'PF03607', NULL, NULL, 'Doublecortin', NULL, 'DCX', NULL, NULL, 6945, 9),
(262325, NULL, 'PF04485', NULL, NULL, 'Phycobilisome degradation protein nblA', NULL, 'NblA', NULL, NULL, 1701, 9),
(262326, NULL, 'PF06809', NULL, NULL, 'Neural proliferation differentiation control-1 protein (NPDC1)', NULL, 'NPDC1', NULL, NULL, 10613, 9),
(262327, NULL, 'PF17721', NULL, NULL, 'Family of unknown function (DUF5566)', NULL, 'DUF5566', NULL, NULL, 32891, 9),
(262328, NULL, 'PF01294', NULL, NULL, 'Ribosomal protein L13e', NULL, 'Ribosomal_L13e', NULL, NULL, 6863, 9),
(262329, NULL, 'PF09947', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2180)', NULL, 'DUF2180', NULL, NULL, 15005, 9),
(262330, NULL, 'PF15791', NULL, NULL, 'Doublesex-and mab-3-related transcription factor C1 and C2', NULL, 'DMRT-like', NULL, NULL, 23633, 9),
(262331, NULL, 'PF04649', NULL, NULL, 'Mycoplasma hyorhinis VlpA repeat', NULL, 'VlpA_repeat', NULL, NULL, 2633, 9),
(262332, NULL, 'PF18578', NULL, NULL, 'Rubisco accumulation factor 1 alpha helical domain', NULL, 'Raf1_N', NULL, NULL, 29044, 9),
(262333, NULL, 'PF00295', NULL, NULL, 'Glycosyl hydrolases family 28', NULL, 'Glyco_hydro_28', NULL, NULL, 3730, 9),
(262334, NULL, 'PF15824', NULL, NULL, 'Spermatogenesis-associated protein 9', NULL, 'SPATA9', NULL, NULL, 26620, 9),
(262335, NULL, 'PF07016', NULL, NULL, 'Cysteine-rich acidic integral membrane protein precursor', NULL, 'CRAM_rpt', NULL, NULL, 12232, 9),
(262336, NULL, 'PF04520', NULL, NULL, 'Senescence regulator', NULL, 'Senescence_reg', NULL, NULL, 2550, 9),
(262337, NULL, 'PF16355', NULL, NULL, 'Domain of unknown function (DUF4982)', NULL, 'DUF4982', NULL, NULL, 25123, 9),
(262338, NULL, 'PF07527', NULL, NULL, 'Hairy Orange', NULL, 'Hairy_orange', NULL, NULL, 1404, 9),
(262339, NULL, 'PF06114', NULL, NULL, 'IrrE N-terminal-like domain', NULL, 'Peptidase_M78', NULL, NULL, 8923, 9),
(262340, NULL, 'PF13037', NULL, NULL, 'Domain of unknown function (DUF3898)', NULL, 'DUF3898', NULL, NULL, 22789, 9),
(262341, NULL, 'PF13090', NULL, NULL, 'Polyphosphate kinase C-terminal domain 2', NULL, 'PP_kinase_C', NULL, NULL, 21532, 9),
(262342, NULL, 'PF05667', NULL, NULL, 'Coiled-coil domain-containing protein 22', NULL, 'CCDC22', NULL, NULL, 13316, 9),
(262343, NULL, 'PF12497', NULL, NULL, 'Estrogen receptor beta', NULL, 'ERbeta_N', NULL, NULL, 15319, 9),
(262344, NULL, 'PF15891', NULL, NULL, 'Nucleoside 2-deoxyribosyltransferase like', NULL, 'Nuc_deoxyri_tr2', NULL, NULL, 33142, 9),
(262345, NULL, 'PF18631', NULL, NULL, 'Cucumopine synthase C-terminal helical bundle domain', NULL, 'Cucumopine_C', NULL, NULL, 31843, 9),
(262346, NULL, 'PF20234', NULL, NULL, 'Family of unknown function (DUF6591)', NULL, 'DUF6591', NULL, NULL, 37610, 9),
(262347, NULL, 'PF12933', NULL, NULL, 'FTO catalytic domain', NULL, 'FTO_NTD', NULL, NULL, 22804, 9),
(262348, NULL, 'PF14789', NULL, NULL, 'Tetrahydrodipicolinate N-succinyltransferase middle', NULL, 'THDPS_M', NULL, NULL, 22296, 9),
(262349, NULL, 'PF07112', NULL, NULL, 'Protein of unknown function (DUF1368)', NULL, 'DUF1368', NULL, NULL, 10750, 9),
(262350, NULL, 'PF07223', NULL, NULL, 'UBA-like domain (DUF1421)', NULL, 'DUF1421', NULL, NULL, 10851, 9),
(262351, NULL, 'PF18793', NULL, NULL, 'Nitrous oxide reductase propeller repeat 2', NULL, 'nos_propeller_2', NULL, NULL, 28550, 9),
(262352, NULL, 'PF15131', NULL, NULL, 'Domain of unknown function (DUF4567)', NULL, 'DUF4567', NULL, NULL, 23423, 9),
(262353, NULL, 'PF06231', NULL, NULL, 'Protein of unknown function (DUF1010)', NULL, 'DUF1010', NULL, NULL, 9250, 9),
(262354, NULL, 'PF10774', NULL, NULL, 'Domain of unknown function (DUF4226)', NULL, 'DUF4226', NULL, NULL, 20907, 9),
(262355, NULL, 'PF07221', NULL, NULL, 'N-acylglucosamine 2-epimerase (GlcNAc 2-epimerase)', NULL, 'GlcNAc_2-epim', NULL, NULL, 10755, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(262356, NULL, 'PF14489', NULL, NULL, 'QueF-like protein', NULL, 'QueF', NULL, NULL, 26591, 9),
(262357, NULL, 'PF15772', NULL, NULL, 'UPF0688 family', NULL, 'UPF0688', NULL, NULL, 25010, 9),
(262358, NULL, 'PF04888', NULL, NULL, 'Secretion system effector C (SseC) like family', NULL, 'SseC', NULL, NULL, 5965, 9),
(262359, NULL, 'PF13230', NULL, NULL, 'Glutamine amidotransferases class-II', NULL, 'GATase_4', NULL, NULL, 26527, 9),
(262360, NULL, 'PF02769', NULL, NULL, 'AIR synthase related protein, C-terminal domain', NULL, 'AIRS_C', NULL, NULL, 9000, 9),
(262361, NULL, 'PF07255', NULL, NULL, 'Benyvirus 14KDa protein', NULL, 'Benyvirus_14KDa', NULL, NULL, 14337, 9),
(262362, NULL, 'PF08563', NULL, NULL, 'P53 transactivation motif', NULL, 'P53_TAD', NULL, NULL, 9538, 9),
(262363, NULL, 'PF04714', NULL, NULL, 'BCL7, N-terminal conserver region', NULL, 'BCL_N', NULL, NULL, 3954, 9),
(262364, NULL, 'PF05132', NULL, NULL, 'RNA polymerase III RPC4', NULL, 'RNA_pol_Rpc4', NULL, NULL, 2101, 9),
(262365, NULL, 'PF12413', NULL, NULL, 'Homeobox protein distal-less-like N terminal', NULL, 'DLL_N', NULL, NULL, 20769, 9),
(262366, NULL, 'PF11639', NULL, NULL, 'REDY-like protein HapK', NULL, 'HapK', NULL, NULL, 18740, 9),
(262367, NULL, 'PF15757', NULL, NULL, 'Amelotin', NULL, 'Amelotin', NULL, NULL, 24963, 9),
(262368, NULL, 'PF19120', NULL, NULL, 'Family of unknown function (DUF5804)', NULL, 'DUF5804', NULL, NULL, 35745, 9),
(262369, NULL, 'PF13028', NULL, NULL, 'Protein of unknown function (DUF3889)', NULL, 'DUF3889', NULL, NULL, 22181, 9),
(262370, NULL, 'PF10224', NULL, NULL, 'Short coiled-coil protein', NULL, 'DUF2205', NULL, NULL, 15509, 9),
(262371, NULL, 'PF04719', NULL, NULL, 'hTAFII28-like protein conserved region', NULL, 'TAFII28', NULL, NULL, 3810, 9),
(262372, NULL, 'PF13254', NULL, NULL, 'Domain of unknown function (DUF4045)', NULL, 'DUF4045', NULL, NULL, 22884, 9),
(262373, NULL, 'PF14143', NULL, NULL, 'YrhC-like protein', NULL, 'YrhC', NULL, NULL, 26108, 9),
(262374, NULL, 'PF17308', NULL, NULL, 'Pro-corazonin', NULL, 'Corazonin', NULL, NULL, 17817, 9),
(262375, NULL, 'PF10425', NULL, NULL, 'C-terminus of bacterial fibrinogen-binding adhesin', NULL, 'SdrG_C_C', NULL, NULL, 12585, 9),
(262376, NULL, 'PF10960', NULL, NULL, 'BhlA holin family', NULL, 'Holin_BhlA', NULL, NULL, 22064, 9),
(262377, NULL, 'PF12018', NULL, NULL, 'Domain of unknown function', NULL, 'FAP206', NULL, NULL, 19857, 9),
(262378, NULL, 'PF13873', NULL, NULL, 'Myb/SANT-like DNA-binding domain', NULL, 'Myb_DNA-bind_5', NULL, NULL, 23336, 9),
(262379, NULL, 'PF16051', NULL, NULL, 'Domain of unknown function (DUF4797)', NULL, 'DUF4797', NULL, NULL, 22686, 9),
(262380, NULL, 'PF18718', NULL, NULL, 'CxC5 like cysteine cluster associated with KDZ transposases', NULL, 'CxC5', NULL, NULL, 30351, 9),
(262381, NULL, 'PF00030', NULL, NULL, 'Beta/Gamma crystallin', NULL, 'Crystall', NULL, NULL, 2093, 9),
(262382, NULL, 'PF09735', NULL, NULL, 'Nck-associated protein 1', NULL, 'Nckap1', NULL, NULL, 17647, 9),
(262383, NULL, 'PF12168', NULL, NULL, 'DNA polymerase III subunits tau domain IV DnaB-binding', NULL, 'DNA_pol3_tau_4', NULL, NULL, 20194, 9),
(262384, NULL, 'PF12228', NULL, NULL, 'Protein of unknown function (DUF3604)', NULL, 'DUF3604', NULL, NULL, 20197, 9),
(262385, NULL, 'PF01638', NULL, NULL, 'HxlR-like helix-turn-helix', NULL, 'HxlR', NULL, NULL, 1576, 9),
(262386, NULL, 'PF11415', NULL, NULL, 'Antifungal peptide termicin', NULL, 'Toxin_37', NULL, NULL, 25801, 9),
(262387, NULL, 'PF15337', NULL, NULL, 'Vascular protein family Vasculin-like 1', NULL, 'Vasculin', NULL, NULL, 21876, 9),
(262388, NULL, 'PF15681', NULL, NULL, 'Lymphocyte activation family X', NULL, 'LAX', NULL, NULL, 25478, 9),
(262389, NULL, 'PF17712', NULL, NULL, 'Family of unknown function (DUF5557)', NULL, 'DUF5557', NULL, NULL, 28521, 9),
(262390, NULL, 'PF09001', NULL, NULL, 'Domain of unknown function (DUF1890)', NULL, 'DUF1890', NULL, NULL, 10552, 9),
(262391, NULL, 'PF17307', NULL, NULL, 'Small integral membrane protein 3', NULL, 'Smim3', NULL, NULL, 31510, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(262392, NULL, 'PF14178', NULL, NULL, 'YppF-like protein', NULL, 'YppF', NULL, NULL, 24064, 9),
(262393, NULL, 'PF18025', NULL, NULL, 'Alpha-(1,3)-fucosyltransferase FucT N-terminal domain', NULL, 'FucT_N', NULL, NULL, 28954, 9),
(262394, NULL, 'PF05331', NULL, NULL, 'Protein of unknown function (DUF742)', NULL, 'DUF742', NULL, NULL, 4084, 9),
(262395, NULL, 'PF17797', NULL, NULL, 'RL domain', NULL, 'RL', NULL, NULL, 29174, 9),
(262396, NULL, 'PF01929', NULL, NULL, 'Ribosomal protein L14', NULL, 'Ribosomal_L14e', NULL, NULL, 4955, 9),
(262397, NULL, 'PF12188', NULL, NULL, 'Signal transducer and activator of transcription 2 C terminal', NULL, 'STAT2_C', NULL, NULL, 17181, 9),
(262398, NULL, 'PF01357', NULL, NULL, 'Expansin C-terminal domain', NULL, 'Expansin_C', NULL, NULL, 128, 9),
(262399, NULL, 'PF18930', NULL, NULL, 'Domain of unknown function (DUF5679)', NULL, 'DUF5679', NULL, NULL, 35215, 9),
(262400, NULL, 'PF13064', NULL, NULL, 'Protein of unknown function (DUF3927)', NULL, 'DUF3927', NULL, NULL, 21389, 9),
(262401, NULL, 'PF03309', NULL, NULL, 'Type III pantothenate kinase', NULL, 'Pan_kinase', NULL, NULL, 2249, 9),
(262402, NULL, 'PF06974', NULL, NULL, 'WS/DGAT C-terminal domain', NULL, 'WS_DGAT_C', NULL, NULL, 12275, 9),
(262403, NULL, 'PF09604', NULL, NULL, 'F subunit of K+-transporting ATPase (Potass_KdpF)', NULL, 'Potass_KdpF', NULL, NULL, 11804, 9),
(262404, NULL, 'PF19402', NULL, NULL, 'Lanthionine-containing peptide SapB precursor RamS', NULL, 'RamS', NULL, NULL, 36197, 9),
(262405, NULL, 'PF09484', NULL, NULL, 'CRISPR-associated protein TM1802 (cas_TM1802)', NULL, 'Cas_TM1802', NULL, NULL, 11185, 9),
(262406, NULL, 'PF11109', NULL, NULL, 'Orexigenic neuropeptide Qrfp/P518', NULL, 'RFamide_26RFa', NULL, NULL, 26986, 9),
(262407, NULL, 'PF01074', NULL, NULL, 'Glycosyl hydrolases family 38 N-terminal domain', NULL, 'Glyco_hydro_38N', NULL, NULL, 5564, 9),
(262408, NULL, 'PF12447', NULL, NULL, 'Protein of unknown function (DUF3683)', NULL, 'DUF3683', NULL, NULL, 20611, 9),
(262409, NULL, 'PF08917', NULL, NULL, 'Transforming growth factor beta receptor 2 ectodomain', NULL, 'ecTbetaR2', NULL, NULL, 7778, 9),
(262410, NULL, 'PF19814', NULL, NULL, 'Family of unknown function (DUF6297)', NULL, 'DUF6297', NULL, NULL, 37327, 9),
(262411, NULL, 'PF05047', NULL, NULL, 'Mitochondrial ribosomal protein L51 / S25 / CI-B8 domain', NULL, 'L51_S25_CI-B8', NULL, NULL, 1146, 9),
(262412, NULL, 'PF05130', NULL, NULL, 'FlgN protein', NULL, 'FlgN', NULL, NULL, 2355, 9),
(262413, NULL, 'PF05362', NULL, NULL, 'Lon protease (S16) C-terminal proteolytic domain', NULL, 'Lon_C', NULL, NULL, 8565, 9),
(262414, NULL, 'PF11046', NULL, NULL, 'Transcriptional repressor of hyc and hyp operons', NULL, 'HycA_repressor', NULL, NULL, 17831, 9),
(262415, NULL, 'PF03786', NULL, NULL, 'D-mannonate dehydratase (UxuA)', NULL, 'UxuA', NULL, NULL, 2373, 9),
(262416, NULL, 'PF06585', NULL, NULL, 'Haemolymph juvenile hormone binding protein (JHBP)', NULL, 'JHBP', NULL, NULL, 8192, 9),
(262417, NULL, 'PF03528', NULL, NULL, 'Rabaptin', NULL, 'Rabaptin', NULL, NULL, 14895, 9),
(262418, NULL, 'PF06397', NULL, NULL, 'Desulfoferrodoxin, N-terminal domain', NULL, 'Desulfoferrod_N', NULL, NULL, 7250, 9),
(262419, NULL, 'PF09230', NULL, NULL, 'DNA fragmentation factor 40 kDa', NULL, 'DFF40', NULL, NULL, 13114, 9),
(262420, NULL, 'PF01131', NULL, NULL, 'DNA topoisomerase', NULL, 'Topoisom_bac', NULL, NULL, 10698, 9),
(262421, NULL, 'PF17381', NULL, NULL, 'Seminal vesicle secretory proteins 4/5/6', NULL, 'Svs_4_5_6', NULL, NULL, 16084, 9),
(262422, NULL, 'PF11057', NULL, NULL, 'Cortexin of kidney', NULL, 'Cortexin', NULL, NULL, 11969, 9),
(262423, NULL, 'PF15326', NULL, NULL, 'Testis expressed sequence 15', NULL, 'TEX15', NULL, NULL, 22438, 9),
(262424, NULL, 'PF11588', NULL, NULL, 'Protein of unknown function (DUF3243)', NULL, 'DUF3243', NULL, NULL, 18919, 9),
(262425, NULL, 'PF12419', NULL, NULL, 'SNF2 Helicase protein', NULL, 'DUF3670', NULL, NULL, 20674, 9),
(262426, NULL, 'PF13571', NULL, NULL, 'Domain of unknown function (DUF4133)', NULL, 'DUF4133', NULL, NULL, 22201, 9);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(262427, NULL, 'PF19645', NULL, NULL, 'Family of unknown function (DUF6148)', NULL, 'DUF6148', NULL, NULL, 37120, 9),
(262428, NULL, 'PF08768', NULL, NULL, 'THAP4-like, heme-binding beta-barrel domain', NULL, 'THAP4_heme-bd', NULL, NULL, 13451, 9),
(262429, NULL, 'PF18858', NULL, NULL, 'Large polyvalent protein associated domain 39', NULL, 'LPD39', NULL, NULL, 29574, 9),
(262430, NULL, 'PF13771', NULL, NULL, 'PHD-like zinc-binding domain', NULL, 'zf-HC5HC2H', NULL, NULL, NULL, 9),
(262431, NULL, 'PF12222', NULL, NULL, 'Peptide N-acetyl-beta-D-glucosaminyl asparaginase amidase A', NULL, 'PNGaseA', NULL, NULL, 15153, 9),
(262432, NULL, 'PF09955', NULL, NULL, 'Predicted integral membrane protein (DUF2189)', NULL, 'DUF2189', NULL, NULL, 17244, 9),
(262433, NULL, 'PF14469', NULL, NULL, '28 kDa A-kinase anchor', NULL, 'AKAP28', NULL, NULL, 21848, 9),
(262434, NULL, 'PF15095', NULL, NULL, 'Interleukin 33', NULL, 'IL33', NULL, NULL, 22950, 9),
(262435, NULL, 'PF18154', NULL, NULL, 'REase associating with pPIWI_RE', NULL, 'pPIWI_RE_REase', NULL, NULL, 32133, 9),
(262436, NULL, 'PF12242', NULL, NULL, 'NAD(P)H binding domain of trans-2-enoyl-CoA reductase', NULL, 'Eno-Rase_NADH_b', NULL, NULL, 9671, 9),
(262437, NULL, 'PF15104', NULL, NULL, 'Domain of unknown function (DUF4558)', NULL, 'DUF4558', NULL, NULL, 26273, 9),
(262438, NULL, 'PF16458', NULL, NULL, 'Beta-prism lectin', NULL, 'Beta-prism_lec', NULL, NULL, 22460, 9),
(262439, NULL, 'PF10130', NULL, NULL, 'PIN domain', NULL, 'PIN_2', NULL, NULL, 3820, 9),
(262440, NULL, 'PF03364', NULL, NULL, 'Polyketide cyclase / dehydrase and lipid transport', NULL, 'Polyketide_cyc', NULL, NULL, 1198, 9),
(262441, NULL, 'PF17973', NULL, NULL, 'Bacterial Alpha-2-macroglobulin MG10 domain', NULL, 'bMG10', NULL, NULL, 29874, 9),
(262442, NULL, 'PF03656', NULL, NULL, 'Pam16', NULL, 'Pam16', NULL, NULL, NULL, 9),
(262443, NULL, 'PF17734', NULL, NULL, 'Spermatogenesis-associated protein 46', NULL, 'Spt46', NULL, NULL, 33028, 9),
(262444, NULL, 'PF06706', NULL, NULL, 'Citrus tristeza virus 6-kDa protein', NULL, 'CTV_P6', NULL, NULL, 1917, 9),
(262445, NULL, 'PF14885', NULL, NULL, 'Hypothetical glycosyl hydrolase family 15', NULL, 'GHL15', NULL, NULL, 25939, 9),
(262446, NULL, 'PF11420', NULL, NULL, 'Bacteriocin subtilosin A', NULL, 'Subtilosin_A', NULL, NULL, 18506, 9),
(262447, NULL, 'PF15240', NULL, NULL, 'Proline-rich protein', NULL, 'Pro-rich', NULL, NULL, 24613, 9),
(262448, NULL, 'PF20137', NULL, NULL, 'Family of unknown function (DUF6527)', NULL, 'DUF6527', NULL, NULL, 35805, 9),
(262449, NULL, 'PF18018', NULL, NULL, 'DNA polymerase delta subunit OB-fold domain', NULL, 'DNA_pol_D_N', NULL, NULL, 27972, 9),
(262450, NULL, 'PF13734', NULL, NULL, 'Spi protease inhibitor', NULL, 'Inhibitor_I69', NULL, NULL, 25940, 9),
(262451, NULL, 'PF01057', NULL, NULL, 'Parvovirus non-structural protein NS1', NULL, 'Parvo_NS1', NULL, NULL, 1007, 9),
(262452, NULL, 'PF05796', NULL, NULL, 'Chordopoxvirus protein G2', NULL, 'Chordopox_G2', NULL, NULL, 8848, 9),
(262453, NULL, 'PF06566', NULL, NULL, 'Chondroitin sulphate attachment domain', NULL, 'Chon_Sulph_att', NULL, NULL, 8280, 9),
(262454, NULL, 'PF09759', NULL, NULL, 'Spinocerebellar ataxia type 10 protein domain', NULL, 'Atx10homo_assoc', NULL, NULL, 18400, 9),
(262455, NULL, 'PF06287', NULL, NULL, 'Protein of unknown function (DUF1039)', NULL, 'DUF1039', NULL, NULL, 9450, 9),
(262456, NULL, 'PF04060', NULL, NULL, 'Putative Fe-S cluster', NULL, 'FeS', NULL, NULL, 1068, 9),
(262457, NULL, 'PF20575', NULL, NULL, 'Helix-turn-helix domain', NULL, 'HTH_63', NULL, NULL, 33742, 9),
(262458, NULL, 'PF08571', NULL, NULL, 'Yos1-like', NULL, 'Yos1', NULL, NULL, 17968, 9),
(262459, NULL, 'PF19490', NULL, NULL, 'Family of unknown function (DUF6025)', NULL, 'DUF6025', NULL, NULL, 36864, 9),
(262460, NULL, 'PF13210', NULL, NULL, 'Domain of unknown function (DUF4018)', NULL, 'DUF4018', NULL, NULL, 22976, 9),
(262461, NULL, 'PF11446', NULL, NULL, 'Protein of unknown function (DUF2897)', NULL, 'DUF2897', NULL, NULL, 18811, 9),
(262462, NULL, 'PF14240', NULL, NULL, 'YHYH protein', NULL, 'YHYH', NULL, NULL, 23040, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(262463, NULL, 'PF14010', NULL, NULL, 'Phosphoenolpyruvate carboxylase', NULL, 'PEPcase_2', NULL, NULL, 1687, 9),
(262464, NULL, 'PF07262', NULL, NULL, 'CDI immunity protein', NULL, 'CdiI', NULL, NULL, 14400, 9),
(262465, NULL, 'PF12567', NULL, NULL, 'Leukocyte receptor CD45', NULL, 'CD45', NULL, NULL, 20320, 9),
(262466, NULL, 'PF02361', NULL, NULL, 'Cobalt transport protein', NULL, 'CbiQ', NULL, NULL, 4488, 9),
(262467, NULL, 'PF00682', NULL, NULL, 'HMGL-like', NULL, 'HMGL-like', NULL, NULL, 4733, 9),
(262468, NULL, 'PF07207', NULL, NULL, 'Light regulated protein Lir1', NULL, 'Lir1', NULL, NULL, 14425, 9),
(262469, NULL, 'PF19782', NULL, NULL, 'Family of unknown function (DUF6267)', NULL, 'DUF6267', NULL, NULL, 37314, 9),
(262470, NULL, 'PF16444', NULL, NULL, 'Domain of unknown function (DUF5041)', NULL, 'DUF5041', NULL, NULL, 24075, 9),
(262471, NULL, 'PF16587', NULL, NULL, '17 kDa common-antigen outer membrane protein', NULL, 'DUF5061', NULL, NULL, 24306, 9),
(262472, NULL, 'PF00045', NULL, NULL, 'Hemopexin', NULL, 'Hemopexin', NULL, NULL, 21178, 9),
(262473, NULL, 'PF14310', NULL, NULL, 'Fibronectin type III-like domain', NULL, 'Fn3-like', NULL, NULL, 26773, 9),
(262474, NULL, 'PF08357', NULL, NULL, 'SEFIR domain', NULL, 'SEFIR', NULL, NULL, 12507, 9),
(262475, NULL, 'PF17828', NULL, NULL, 'N-terminal domain in fatty acid synthase subunit beta', NULL, 'FAS_N', NULL, NULL, 29222, 9),
(262476, NULL, 'PF18377', NULL, NULL, 'FERM F2 acyl-CoA binding protein-like domain', NULL, 'FERM_F2', NULL, NULL, 29816, 9),
(262477, NULL, 'PF17528', NULL, NULL, 'Histidine decarboxylase maturation protein HdcB', NULL, 'HdcB', NULL, NULL, 28043, 9),
(262478, NULL, 'PF14260', NULL, NULL, 'C4-type zinc-finger of DNA polymerase delta', NULL, 'zf-C4pol', NULL, NULL, 24674, 9),
(262479, NULL, 'PF06772', NULL, NULL, 'Bacterial low temperature requirement A protein (LtrA)', NULL, 'LtrA', NULL, NULL, 9219, 9),
(262480, NULL, 'PF10405', NULL, NULL, 'Rad4 beta-hairpin domain 3', NULL, 'BHD_3', NULL, NULL, 19887, 9),
(262481, NULL, 'PF06610', NULL, NULL, 'L-alanine exporter', NULL, 'AlaE', NULL, NULL, 8094, 9),
(262482, NULL, 'PF11638', NULL, NULL, 'DnaA N-terminal domain', NULL, 'DnaA_N', NULL, NULL, 13682, 9),
(262483, NULL, 'PF06576', NULL, NULL, 'Protein of unknown function (DUF1133)', NULL, 'DUF1133', NULL, NULL, 8248, 9),
(262484, NULL, 'PF08661', NULL, NULL, 'Replication factor A protein 3', NULL, 'Rep_fac-A_3', NULL, NULL, 7938, 9),
(262485, NULL, 'PF15636', NULL, NULL, 'GHH signature containing HNH/Endo VII superfamily nuclease toxin', NULL, 'Tox-GHH', NULL, NULL, 25043, 9),
(262486, NULL, 'PF17208', NULL, NULL, 'RNA binding Region', NULL, 'RBR', NULL, NULL, 32666, 9),
(262487, NULL, 'PF20570', NULL, NULL, 'Domain of unknown function (DUF6779)', NULL, 'DUF6779', NULL, NULL, 37024, 9),
(262488, NULL, 'PF00357', NULL, NULL, 'Integrin alpha cytoplasmic region', NULL, 'Integrin_alpha', NULL, NULL, 7566, 9),
(262489, NULL, 'PF10141', NULL, NULL, 'Single-strand DNA-specific exonuclease, C terminal domain', NULL, 'ssDNA-exonuc_C', NULL, NULL, 19197, 9),
(262490, NULL, 'PF00469', NULL, NULL, 'Negative factor, (F-Protein) or Nef', NULL, 'F-protein', NULL, NULL, 3382, 9),
(262491, NULL, 'PF06672', NULL, NULL, 'Protein of unknown function (DUF1175)', NULL, 'DUF1175', NULL, NULL, 10010, 9),
(262492, NULL, 'PF15913', NULL, NULL, 'Furin-like repeat, cysteine-rich', NULL, 'Furin-like_2', NULL, NULL, 35294, 9),
(262493, NULL, 'PF05116', NULL, NULL, 'Sucrose-6F-phosphate phosphohydrolase', NULL, 'S6PP', NULL, NULL, 5943, 9),
(262494, NULL, 'PF15206', NULL, NULL, 'FAM209 family', NULL, 'FAM209', NULL, NULL, 24849, 9),
(262495, NULL, 'PF17789', NULL, NULL, 'Macroglobulin domain MG4', NULL, 'MG4', NULL, NULL, 32207, 9),
(262496, NULL, 'PF03610', NULL, NULL, 'PTS system fructose IIA component', NULL, 'EIIA-man', NULL, NULL, 3085, 9),
(262497, NULL, 'PF15411', NULL, NULL, 'Pleckstrin homology domain', NULL, 'PH_10', NULL, NULL, NULL, 9),
(262498, NULL, 'PF17273', NULL, NULL, 'Family of unknown function (DUF5338)', NULL, 'DUF5338', NULL, NULL, 15499, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(262499, NULL, 'PF04701', NULL, NULL, 'Pox virus D2 protein', NULL, 'Pox_D2', NULL, NULL, 3478, 9),
(262500, NULL, 'PF11561', NULL, NULL, 'Single strand annealing-weakened 1', NULL, 'Saw1', NULL, NULL, 18659, 9),
(262501, NULL, 'PF11208', NULL, NULL, 'Protein of unknown function (DUF2992)', NULL, 'DUF2992', NULL, NULL, 15113, 9),
(262502, NULL, 'PF18055', NULL, NULL, '26S proteasome regulatory subunit RPN6 N-terminal domain', NULL, 'RPN6_N', NULL, NULL, 28503, 9),
(262503, NULL, 'PF08085', NULL, NULL, 'Entericidin EcnA/B family', NULL, 'Entericidin', NULL, NULL, 9145, 9),
(262504, NULL, 'PF13197', NULL, NULL, 'Protein of unknown function (DUF4013)', NULL, 'DUF4013', NULL, NULL, 22236, 9),
(262505, NULL, 'PF14432', NULL, NULL, 'DYW family of nucleic acid deaminases', NULL, 'DYW_deaminase', NULL, NULL, 25204, 9),
(262506, NULL, 'PF15379', NULL, NULL, 'Domain of unknown function (DUF4606)', NULL, 'DUF4606', NULL, NULL, 25297, 9),
(262507, NULL, 'PF06466', NULL, NULL, 'PCAF (P300/CBP-associated factor) N-terminal domain', NULL, 'PCAF_N', NULL, NULL, 9190, 9),
(262508, NULL, 'PF15260', NULL, NULL, 'Protein family FAM219A', NULL, 'FAM219A', NULL, NULL, 23975, 9),
(262509, NULL, 'PF03659', NULL, NULL, 'Glycosyl hydrolase family 71', NULL, 'Glyco_hydro_71', NULL, NULL, 6811, 9),
(262510, NULL, 'PF19888', NULL, NULL, 'Family of unknown function (DUF6361)', NULL, 'DUF6361', NULL, NULL, 36977, 9),
(262511, NULL, 'PF04560', NULL, NULL, 'RNA polymerase Rpb2, domain 7', NULL, 'RNA_pol_Rpb2_7', NULL, NULL, 2230, 9),
(262512, NULL, 'PF05139', NULL, NULL, 'Erythromycin esterase', NULL, 'Erythro_esteras', NULL, NULL, 2450, 9),
(262513, NULL, 'PF04886', NULL, NULL, 'PT repeat', NULL, 'PT', NULL, NULL, 5650, 9),
(262514, NULL, 'PF09378', NULL, NULL, 'HAS barrel domain', NULL, 'HAS-barrel', NULL, NULL, 14778, 9),
(262515, NULL, 'PF19233', NULL, NULL, 'Family of unknown function (DUF5886)', NULL, 'DUF5886', NULL, NULL, 35634, 9),
(262516, NULL, 'PF04534', NULL, NULL, 'Herpesvirus UL56 protein', NULL, 'Herpes_UL56', NULL, NULL, 2570, 9),
(262517, NULL, 'PF17949', NULL, NULL, 'FANCM pseudonuclease domain', NULL, 'PND', NULL, NULL, 28216, 9),
(262518, NULL, 'PF05528', NULL, NULL, 'Accessory protein 5b, avian coronavirus', NULL, 'Acc5b_avian_CoV', NULL, NULL, 12267, 9),
(262519, NULL, 'PF08874', NULL, NULL, 'Domain of unknown function (DUF1835)', NULL, 'DUF1835', NULL, NULL, 14079, 9),
(262520, NULL, 'PF04250', NULL, NULL, 'Protein of unknown function (DUF429)', NULL, 'DUF429', NULL, NULL, 5934, 9),
(262521, NULL, 'PF09601', NULL, NULL, 'Protein of unknown function (DUF2459)', NULL, 'DUF2459', NULL, NULL, 11909, 9),
(262522, NULL, 'PF17046', NULL, NULL, 'SesB domain on fungal death-pathway protein', NULL, 'Ses_B', NULL, NULL, 26685, 9),
(262523, NULL, 'PF17811', NULL, NULL, 'Jumonji helical domain', NULL, 'JHD', NULL, NULL, 28675, 9),
(262524, NULL, 'PF03150', NULL, NULL, 'Di-haem cytochrome c peroxidase', NULL, 'CCP_MauG', NULL, NULL, 7297, 9),
(262525, NULL, 'PF07484', NULL, NULL, 'Phage Tail Collar Domain', NULL, 'Collar', NULL, NULL, 10856, 9),
(262526, NULL, 'PF08197', NULL, NULL, 'pORF2a truncated protein', NULL, 'TT_ORF2a', NULL, NULL, 13299, 9),
(262527, NULL, 'PF11795', NULL, NULL, 'Uncharacterized protein conserved in bacteria N-term (DUF3322)', NULL, 'DUF3322', NULL, NULL, 24864, 9),
(262528, NULL, 'PF11846', NULL, NULL, 'Virulence factor membrane-bound polymerase, C-terminal', NULL, 'Wzy_C_2', NULL, NULL, 19238, 9),
(262529, NULL, 'PF17006', NULL, NULL, 'Domain of unknown function (DUF5087)', NULL, 'DUF5087', NULL, NULL, 24377, 9),
(262530, NULL, 'PF18297', NULL, NULL, 'NFACT protein RNA binding domain', NULL, 'NFACT-R_2', NULL, NULL, NULL, 9),
(262531, NULL, 'PF17622', NULL, NULL, 'Viral unique long protein 16', NULL, 'UL16', NULL, NULL, 17482, 9),
(262532, NULL, 'PF02863', NULL, NULL, 'Arginine repressor, C-terminal domain', NULL, 'Arg_repressor_C', NULL, NULL, 20972, 9),
(262533, NULL, 'PF18557', NULL, NULL, 'Anti-sigma factor NepR', NULL, 'NepR', NULL, NULL, 29778, 9),
(262534, NULL, 'PF07519', NULL, NULL, 'Tannase and feruloyl esterase', NULL, 'Tannase', NULL, NULL, 11197, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(262535, NULL, 'PF10125', NULL, NULL, 'NADH dehydrogenase I, subunit N related protein', NULL, 'NADHdeh_related', NULL, NULL, 19796, 9),
(262536, NULL, 'PF11019', NULL, NULL, 'Protein of unknown function (DUF2608)', NULL, 'DUF2608', NULL, NULL, 16129, 9),
(262537, NULL, 'PF11616', NULL, NULL, 'WD repeat binding protein EZH2', NULL, 'EZH2_WD-Binding', NULL, NULL, 18666, 9),
(262538, NULL, 'PF02251', NULL, NULL, 'Proteasome activator pa28 alpha subunit', NULL, 'PA28_alpha', NULL, NULL, 3089, 9),
(262539, NULL, 'PF01985', NULL, NULL, 'CRS1 / YhbY (CRM) domain', NULL, 'CRS1_YhbY', NULL, NULL, 4467, 9),
(262540, NULL, 'PF14850', NULL, NULL, 'DNA-binding domain of Proline dehydrogenase', NULL, 'Pro_dh-DNA_bdg', NULL, NULL, 18742, 9),
(262541, NULL, 'PF11939', NULL, NULL, '[NiFe]-hydrogenase assembly, chaperone, HybE', NULL, 'NiFe-hyd_HybE', NULL, NULL, 18468, 9),
(262542, NULL, 'PF12461', NULL, NULL, 'Spiroplasma phage ORF1-like family', NULL, 'DUF3688', NULL, NULL, 20627, 9),
(262543, NULL, 'PF19002', NULL, NULL, 'Family of unknown function (DUF5731)', NULL, 'DUF5731', NULL, NULL, 35736, 9),
(262544, NULL, 'PF16135', NULL, NULL, 'Tify domain binding domain', NULL, 'TDBD', NULL, NULL, 26343, 9),
(262545, NULL, 'PF10391', NULL, NULL, 'Fingers domain of DNA polymerase lambda', NULL, 'DNA_pol_lambd_f', NULL, NULL, 14922, 9),
(262546, NULL, 'PF08393', NULL, NULL, 'Dynein heavy chain, N-terminal region 2', NULL, 'DHC_N2', NULL, NULL, 11358, 9),
(262547, NULL, 'PF13030', NULL, NULL, 'Protein of unknown function (DUF3891)', NULL, 'DUF3891', NULL, NULL, 22121, 9),
(262548, NULL, 'PF06891', NULL, NULL, 'P2 phage tail completion protein R (GpR)', NULL, 'P2_Phage_GpR', NULL, NULL, 11727, 9),
(262549, NULL, 'PF02885', NULL, NULL, 'Glycosyl transferase family, helical bundle domain', NULL, 'Glycos_trans_3N', NULL, NULL, 15985, 9),
(262550, NULL, 'PF17242', NULL, NULL, 'Disordered region of unknown function (DUF5315)', NULL, 'DUF5315', NULL, NULL, NULL, 9),
(262551, NULL, 'PF10606', NULL, NULL, 'Homer-binding domain of metabotropic glutamate receptor', NULL, 'GluR_Homer-bdg', NULL, NULL, 20404, 9),
(262552, NULL, 'PF07910', NULL, NULL, 'Peptidase family C78', NULL, 'Peptidase_C78', NULL, NULL, 14135, 9),
(262553, NULL, 'PF13564', NULL, NULL, 'DoxX-like family', NULL, 'DoxX_2', NULL, NULL, 22645, 9),
(262554, NULL, 'PF01930', NULL, NULL, 'Domain of unknown function DUF83', NULL, 'Cas_Cas4', NULL, NULL, 20461, 9),
(262555, NULL, 'PF10347', NULL, NULL, 'RNA pol II promoter Fmp27 protein domain', NULL, 'Fmp27_GFWDK', NULL, NULL, 17476, 9),
(262556, NULL, 'PF12678', NULL, NULL, 'RING-H2 zinc finger domain', NULL, 'zf-rbx1', NULL, NULL, 15359, 9),
(262557, NULL, 'PF18106', NULL, NULL, 'Rolling Circle replication initiation protein N-terminal domain', NULL, 'Rol_Rep_N', NULL, NULL, 29017, 9),
(262558, NULL, 'PF14157', NULL, NULL, 'YmzC-like protein', NULL, 'YmzC', NULL, NULL, 26348, 9),
(262559, NULL, 'PF02229', NULL, NULL, 'Transcriptional Coactivator p15 (PC4)', NULL, 'PC4', NULL, NULL, 1932, 9),
(262560, NULL, 'PF06406', NULL, NULL, 'StbA protein', NULL, 'StbA', NULL, NULL, 8374, 9),
(262561, NULL, 'PF08202', NULL, NULL, 'Mis12-Mtw1 protein family', NULL, 'MIS13', NULL, NULL, 12154, 9),
(262562, NULL, 'PF08208', NULL, NULL, 'DNA-directed RNA polymerase I subunit RPA34.5', NULL, 'RNA_polI_A34', NULL, NULL, 12855, 9),
(262563, NULL, 'PF03842', NULL, NULL, 'Silicon transporter', NULL, 'Silic_transp', NULL, NULL, 3416, 9),
(262564, NULL, 'PF13859', NULL, NULL, 'BNR repeat-like domain', NULL, 'BNR_3', NULL, NULL, 9464, 9),
(262565, NULL, 'PF13455', NULL, NULL, 'Meiotically up-regulated gene 113', NULL, 'MUG113', NULL, NULL, NULL, 9),
(262566, NULL, 'PF05374', NULL, NULL, 'Mu-Conotoxin', NULL, 'Mu-conotoxin', NULL, NULL, 5352, 9),
(262567, NULL, 'PF08792', NULL, NULL, 'A2L zinc ribbon domain', NULL, 'A2L_zn_ribbon', NULL, NULL, 13162, 9),
(262568, NULL, 'PF10625', NULL, NULL, 'Universal stress protein B (UspB)', NULL, 'UspB', NULL, NULL, 20372, 9),
(262569, NULL, 'PF06935', NULL, NULL, 'Protein of unknown function (DUF1284)', NULL, 'DUF1284', NULL, NULL, 11989, 9);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(262570, NULL, 'PF05375', NULL, NULL, 'Pacifastin inhibitor (LCMII)', NULL, 'Pacifastin_I', NULL, NULL, 5135, 9),
(262571, NULL, 'PF19437', NULL, NULL, 'VCIP135 N-terminal', NULL, 'VCIP135_N', NULL, NULL, 36398, 9),
(262572, NULL, 'PF05757', NULL, NULL, 'Oxygen evolving enhancer protein 3 (PsbQ)', NULL, 'PsbQ', NULL, NULL, 13546, 9),
(262573, NULL, 'PF02308', NULL, NULL, 'MgtC family', NULL, 'MgtC', NULL, NULL, 4094, 9),
(262574, NULL, 'PF03754', NULL, NULL, 'B3 domain-containing protein At2g31720-like', NULL, 'At2g31720-like', NULL, NULL, 986, 9),
(262575, NULL, 'PF01920', NULL, NULL, 'Prefoldin subunit', NULL, 'Prefoldin_2', NULL, NULL, 4962, 9),
(262576, NULL, 'PF11395', NULL, NULL, 'Betacoronavirus NS7B protein', NULL, 'bCoV_NS7B', NULL, NULL, 18837, 9),
(262577, NULL, 'PF18290', NULL, NULL, 'Nudix hydrolase domain', NULL, 'Nudix_hydro', NULL, NULL, 28049, 9),
(262578, NULL, 'PF18588', NULL, NULL, 'Polysaccharide biosynthesis enzyme WcbI', NULL, 'WcbI', NULL, NULL, 29900, 9),
(262579, NULL, 'PF08946', NULL, NULL, 'Osmosensory transporter coiled coil', NULL, 'Osmo_CC', NULL, NULL, 7667, 9),
(262580, NULL, 'PF15808', NULL, NULL, 'BCL-6 co-repressor, non-ankyrin-repeat region', NULL, 'BCOR', NULL, NULL, 25762, 9),
(262581, NULL, 'PF16414', NULL, NULL, 'Niemann-Pick C1 N terminus', NULL, 'NPC1_N', NULL, NULL, 23627, 9),
(262582, NULL, 'PF14271', NULL, NULL, 'Domain of unknown function (DUF4359)', NULL, 'DUF4359', NULL, NULL, 26183, 9),
(262583, NULL, 'PF13313', NULL, NULL, 'Domain of unknown function (DUF4082)', NULL, 'DUF4082', NULL, NULL, 22880, 9),
(262584, NULL, 'PF01101', NULL, NULL, 'HMG14 and HMG17', NULL, 'HMG14_17', NULL, NULL, 2748, 9),
(262585, NULL, 'PF15368', NULL, NULL, 'Spermatogenesis family BioT2', NULL, 'BioT2', NULL, NULL, 26036, 9),
(262586, NULL, 'PF09034', NULL, NULL, 'TRADD, N-terminal domain', NULL, 'TRADD_N', NULL, NULL, 6346, 9),
(262587, NULL, 'PF03337', NULL, NULL, 'Poxvirus F12L protein', NULL, 'Pox_F12L', NULL, NULL, 726, 9),
(262588, NULL, 'PF16358', NULL, NULL, 'RcsF lipoprotein', NULL, 'RcsF', NULL, NULL, 25261, 9),
(262589, NULL, 'PF17248', NULL, NULL, 'Family of unknown function (DUF5317)', NULL, 'DUF5317', NULL, NULL, 18673, 9),
(262590, NULL, 'PF18038', NULL, NULL, 'FERM N-terminal domain', NULL, 'FERM_N_2', NULL, NULL, 29260, 9),
(262591, NULL, 'PF14522', NULL, NULL, 'Cytochrome c7 and related cytochrome c', NULL, 'Cytochrome_C7', NULL, NULL, 23206, 9),
(262592, NULL, 'PF07548', NULL, NULL, 'Chlamydia polymorphic membrane protein middle domain', NULL, 'ChlamPMP_M', NULL, NULL, 13692, 9),
(262593, NULL, 'PF08888', NULL, NULL, 'HopJ type III effector protein', NULL, 'HopJ', NULL, NULL, 14344, 9),
(262594, NULL, 'PF19520', NULL, NULL, 'Dipeptidyl peptidase 8 and 9 N-terminal', NULL, 'Dpp_8_9_N', NULL, NULL, 36137, 9),
(262595, NULL, 'PF04507', NULL, NULL, 'Csa1 family', NULL, 'DUF576', NULL, NULL, 2953, 9),
(262596, NULL, 'PF04588', NULL, NULL, 'Hypoxia induced protein conserved region', NULL, 'HIG_1_N', NULL, NULL, 292, 9),
(262597, NULL, 'PF04755', NULL, NULL, 'PAP_fibrillin', NULL, 'PAP_fibrillin', NULL, NULL, 3522, 9),
(262598, NULL, 'PF14082', NULL, NULL, 'Domain of unknown function (DUF4263)', NULL, 'DUF4263', NULL, NULL, 22833, 9),
(262599, NULL, 'PF13489', NULL, NULL, 'Methyltransferase domain', NULL, 'Methyltransf_23', NULL, NULL, NULL, 9),
(262600, NULL, 'PF15598', NULL, NULL, 'Immunity protein 61', NULL, 'Imm61', NULL, NULL, 24829, 9),
(262601, NULL, 'PF12385', NULL, NULL, 'Papain-like cysteine protease AvrRpt2', NULL, 'Peptidase_C70', NULL, NULL, 20693, 9),
(262602, NULL, 'PF00544', NULL, NULL, 'Pectate lyase', NULL, 'Pectate_lyase_4', NULL, NULL, 5434, 9),
(262603, NULL, 'PF15611', NULL, NULL, 'EH_Signature domain', NULL, 'EH_Signature', NULL, NULL, 24880, 9),
(262604, NULL, 'PF00352', NULL, NULL, 'Transcription factor TFIID (or TATA-binding protein, TBP)', NULL, 'TBP', NULL, NULL, 4552, 9),
(262605, NULL, 'PF18438', NULL, NULL, 'Glycosyl hydrolases family 38 C-terminal domain 1', NULL, 'Glyco_hydro_38', NULL, NULL, 29345, 9),
(262606, NULL, 'PF19074', NULL, NULL, 'Family of unknown function (DUF5770)', NULL, 'DUF5770', NULL, NULL, 35377, 9); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(262607, NULL, 'PF09815', NULL, NULL, 'XK-related protein', NULL, 'XK-related', NULL, NULL, 16103, 9),
(262608, NULL, 'PF10114', NULL, NULL, 'Sensory domain found in PocR', NULL, 'PocR', NULL, NULL, 18354, 9),
(262609, NULL, 'PF10534', NULL, NULL, 'Connector enhancer of kinase suppressor of ras', NULL, 'CRIC_ras_sig', NULL, NULL, 18101, 9),
(262610, NULL, 'PF01561', NULL, NULL, 'Hantavirus/Nairovirus glycoprotein G2', NULL, 'Hanta_G2', NULL, NULL, 649, 9),
(262611, NULL, 'PF11386', NULL, NULL, 'Vitelline envelope receptor for lysin', NULL, 'VERL', NULL, NULL, 18829, 9),
(262612, NULL, 'PF00584', NULL, NULL, 'SecE/Sec61-gamma subunits of protein translocation complex', NULL, 'SecE', NULL, NULL, 2105, 9),
(262613, NULL, 'PF10044', NULL, NULL, 'Retinal tissue protein', NULL, 'LIN52', NULL, NULL, 18030, 9),
(262614, NULL, 'PF18606', NULL, NULL, 'Zap  helix turn helix N-terminal domain', NULL, 'HTH_53', NULL, NULL, 29439, 9),
(262615, NULL, 'PF12197', NULL, NULL, 'Bacillus cereus group antimicrobial protein', NULL, 'lci', NULL, NULL, 14657, 9),
(262616, NULL, 'PF13938', NULL, NULL, 'Putative heavy-metal chelation', NULL, 'DUF4213', NULL, NULL, 23126, 9),
(262617, NULL, 'PF10113', NULL, NULL, 'FeGP cofactor biosynthesis protein, fibrillarin family', NULL, 'Fibrillarin_2', NULL, NULL, 21059, 9),
(262618, NULL, 'PF04404', NULL, NULL, 'ERF superfamily', NULL, 'ERF', NULL, NULL, 10211, 9),
(262619, NULL, 'PF05336', NULL, NULL, 'L-rhamnose mutarotase', NULL, 'rhaM', NULL, NULL, 4194, 9),
(262620, NULL, 'PF03564', NULL, NULL, 'Protein of unknown function (DUF1759)', NULL, 'DUF1759', NULL, NULL, 5017, 9),
(262621, NULL, 'PF10938', NULL, NULL, 'YfdX protein', NULL, 'YfdX', NULL, NULL, 17689, 9),
(262622, NULL, 'PF00399', NULL, NULL, 'Yeast PIR protein repeat', NULL, 'PIR', NULL, NULL, 4442, 9),
(262623, NULL, 'PF07353', NULL, NULL, 'Uroplakin II', NULL, 'Uroplakin_II', NULL, NULL, 8384, 9),
(262624, NULL, 'PF00993', NULL, NULL, 'Class II histocompatibility antigen, alpha domain', NULL, 'MHC_II_alpha', NULL, NULL, 362, 9),
(262625, NULL, 'PF07781', NULL, NULL, 'Reovirus minor core protein Mu-2', NULL, 'Reovirus_Mu2', NULL, NULL, 12562, 9),
(262626, NULL, 'PF12199', NULL, NULL, 'Extracellular fibrinogen binding protein C terminal', NULL, 'efb-c', NULL, NULL, 15195, 9),
(262627, NULL, 'PF11902', NULL, NULL, 'Protein of unknown function (DUF3422)', NULL, 'DUF3422', NULL, NULL, 19985, 9),
(262628, NULL, 'PF13649', NULL, NULL, 'Methyltransferase domain', NULL, 'Methyltransf_25', NULL, NULL, 30412, 9),
(262629, NULL, 'PF05673', NULL, NULL, 'Protein of unknown function (DUF815)', NULL, 'DUF815', NULL, NULL, 13333, 9),
(262630, NULL, 'PF10908', NULL, NULL, 'Protein of unknown function (DUF2778)', NULL, 'DUF2778', NULL, NULL, 17590, 9),
(262631, NULL, 'PF04501', NULL, NULL, 'Baculovirus major capsid protein VP39', NULL, 'Baculo_VP39', NULL, NULL, 2921, 9),
(262632, NULL, 'PF08695', NULL, NULL, 'Cytochrome oxidase complex assembly protein 1', NULL, 'Coa1', NULL, NULL, 11601, 9),
(262633, NULL, 'PF10532', NULL, NULL, 'Plant specific N-all beta domain', NULL, 'Plant_all_beta', NULL, NULL, 19218, 9),
(262634, NULL, 'PF18843', NULL, NULL, 'Large polyvalent protein associated domain 28', NULL, 'LPD28', NULL, NULL, 29099, 9),
(262635, NULL, 'PF20453', NULL, NULL, 'Family of unknown function (DUF6707)', NULL, 'DUF6707', NULL, NULL, 37504, 9),
(262636, NULL, 'PF18266', NULL, NULL, 'Nicastrin small lobe', NULL, 'Ncstrn_small', NULL, NULL, 28826, 9),
(262637, NULL, 'PF02119', NULL, NULL, 'Flagellar P-ring protein', NULL, 'FlgI', NULL, NULL, 3457, 9),
(262638, NULL, 'PF04835', NULL, NULL, 'A9 protein conserved region', NULL, 'Pox_A9', NULL, NULL, 4918, 9),
(262639, NULL, 'PF20335', NULL, NULL, 'Family of unknown function (DUF6630)', NULL, 'DUF6630', NULL, NULL, 33738, 9),
(262640, NULL, 'PF01345', NULL, NULL, 'Domain of unknown function DUF11', NULL, 'DUF11', NULL, NULL, 3026, 9),
(262641, NULL, 'PF02177', NULL, NULL, 'Amyloid A4 N-terminal heparin-binding', NULL, 'APP_N', NULL, NULL, 12741, 9),
(262642, NULL, 'PF08709', NULL, NULL, 'Inositol 1,4,5-trisphosphate/ryanodine receptor', NULL, 'Ins145_P3_rec', NULL, NULL, 11899, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(262643, NULL, 'PF02502', NULL, NULL, 'Ribose/Galactose Isomerase', NULL, 'LacAB_rpiB', NULL, NULL, 6482, 9),
(262644, NULL, 'PF03190', NULL, NULL, 'Protein of unknown function, DUF255', NULL, 'Thioredox_DsbH', NULL, NULL, 7076, 9),
(262645, NULL, 'PF14724', NULL, NULL, 'Mitochondrial-associated sphingomyelin phosphodiesterase', NULL, 'mit_SMPDase', NULL, NULL, 14081, 9),
(262646, NULL, 'PF09727', NULL, NULL, 'Cortactin-binding protein-2', NULL, 'CortBP2', NULL, NULL, 17690, 9),
(262647, NULL, 'PF13292', NULL, NULL, '1-deoxy-D-xylulose-5-phosphate synthase', NULL, 'DXP_synthase_N', NULL, NULL, 786, 9),
(262648, NULL, 'PF07048', NULL, NULL, 'Protein of unknown function (DUF1331)', NULL, 'DUF1331', NULL, NULL, 12763, 9),
(262649, NULL, 'PF00897', NULL, NULL, 'Orbivirus inner capsid protein VP7', NULL, 'Orbi_VP7', NULL, NULL, 4252, 9),
(262650, NULL, 'PF14460', NULL, NULL, 'Prokaryotic E2 family D', NULL, 'Prok-E2_D', NULL, NULL, 21693, 9),
(262651, NULL, 'PF08864', NULL, NULL, 'UPF0302 domain', NULL, 'UPF0302', NULL, NULL, 14036, 9),
(262652, NULL, 'PF19619', NULL, NULL, 'Family of unknown function (DUF6124)', NULL, 'DUF6124', NULL, NULL, NULL, 9),
(262653, NULL, 'PF14920', NULL, NULL, 'MDM2-binding', NULL, 'MTBP_C', NULL, NULL, 23646, 9),
(262654, NULL, 'PF14774', NULL, NULL, 'FAM177 family', NULL, 'FAM177', NULL, NULL, 26582, 9),
(262655, NULL, 'PF01758', NULL, NULL, 'Sodium Bile acid symporter family', NULL, 'SBF', NULL, NULL, 5493, 9),
(262656, NULL, 'PF20049', NULL, NULL, 'Domain of unknown function (DUF6451)', NULL, 'DUF6451', NULL, NULL, 34041, 9),
(262657, NULL, 'PF02247', NULL, NULL, 'Large coat protein', NULL, 'Como_LCP', NULL, NULL, 1883, 9),
(262658, NULL, 'PF01850', NULL, NULL, 'PIN domain', NULL, 'PIN', NULL, NULL, 3820, 9),
(262659, NULL, 'PF08599', NULL, NULL, 'DNA damage repair protein Nbs1', NULL, 'Nbs1_C', NULL, NULL, 17653, 9),
(262660, NULL, 'PF16671', NULL, NULL, 'Actin cross-linking domain', NULL, 'ACD', NULL, NULL, 26493, 9),
(262661, NULL, 'PF18855', NULL, NULL, 'Bacterial archaeo-eukaryotic release factor family 11', NULL, 'baeRF_family11', NULL, NULL, 30255, 9),
(262662, NULL, 'PF10136', NULL, NULL, 'Site-specific recombinase', NULL, 'SpecificRecomb', NULL, NULL, 14691, 9),
(262663, NULL, 'PF05403', NULL, NULL, 'Plasmodium histidine-rich protein (HRPII/III)', NULL, 'Plasmodium_HRP', NULL, NULL, 12283, 9),
(262664, NULL, 'PF16795', NULL, NULL, 'Archaeal phage integrase', NULL, 'Phage_integr_3', NULL, NULL, 24002, 9),
(262665, NULL, 'PF10554', NULL, NULL, 'Ash protein family', NULL, 'Phage_ASH', NULL, NULL, 20622, 9),
(262666, NULL, 'PF14618', NULL, NULL, 'Domain of unknown function (DUF4452)', NULL, 'DUF4452', NULL, NULL, 23036, 9),
(262667, NULL, 'PF07840', NULL, NULL, 'FadR C-terminal domain', NULL, 'FadR_C', NULL, NULL, 24752, 9),
(262668, NULL, 'PF20273', NULL, NULL, 'Domain observed between E2 and E1 domains', NULL, 'E2-E1mid', NULL, NULL, 34076, 9),
(262669, NULL, 'PF07068', NULL, NULL, 'Major capsid protein Gp23', NULL, 'Gp23', NULL, NULL, 9713, 9),
(262670, NULL, 'PF13719', NULL, NULL, 'zinc-ribbon domain', NULL, 'zinc_ribbon_5', NULL, NULL, 10710, 9),
(262671, NULL, 'PF02414', NULL, NULL, 'Borrelia ORF-A', NULL, 'Borrelia_orfA', NULL, NULL, 5312, 9),
(262672, NULL, 'PF08742', NULL, NULL, 'C8 domain', NULL, 'C8', NULL, NULL, 12393, 9),
(262673, NULL, 'PF07357', NULL, NULL, 'Dinitrogenase reductase ADP-ribosyltransferase (DRAT)', NULL, 'DRAT', NULL, NULL, 8281, 9),
(262674, NULL, 'PF04272', NULL, NULL, 'Phospholamban', NULL, 'Phospholamban', NULL, NULL, 1257, 9),
(262675, NULL, 'PF06012', NULL, NULL, 'Domain of Unknown Function (DUF908)', NULL, 'DUF908', NULL, NULL, 8414, 9),
(262676, NULL, 'PF01681', NULL, NULL, 'C6 domain', NULL, 'C6', NULL, NULL, 1764, 9),
(262677, NULL, 'PF03632', NULL, NULL, 'Glycosyl hydrolase family 65 central catalytic domain', NULL, 'Glyco_hydro_65m', NULL, NULL, 5089, 9),
(262678, NULL, 'PF08200', NULL, NULL, 'Bacteriophage 1.1 Protein', NULL, 'Phage_1_1', NULL, NULL, 12421, 9),
(262679, NULL, 'PF11843', NULL, NULL, 'Protein of unknown function (DUF3363)', NULL, 'DUF3363', NULL, NULL, 19165, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(262680, NULL, 'PF19595', NULL, NULL, 'Family of unknown function (DUF6100)', NULL, 'DUF6100', NULL, NULL, 36932, 9),
(262681, NULL, 'PF03462', NULL, NULL, 'PCRF domain', NULL, 'PCRF', NULL, NULL, 7375, 9),
(262682, NULL, 'PF09639', NULL, NULL, 'YjcQ protein', NULL, 'YjcQ', NULL, NULL, 15515, 9),
(262683, NULL, 'PF08923', NULL, NULL, 'Mitogen-activated protein kinase kinase 1 interacting', NULL, 'MAPKK1_Int', NULL, NULL, 7513, 9),
(262684, NULL, 'PF07382', NULL, NULL, 'Histone H1-like nucleoprotein HC2', NULL, 'HC2', NULL, NULL, 8231, 9),
(262685, NULL, 'PF19757', NULL, NULL, 'Family of unknown function (DUF6244)', NULL, 'DUF6244', NULL, NULL, 37315, 9),
(262686, NULL, 'PF07716', NULL, NULL, 'Basic region leucine zipper', NULL, 'bZIP_2', NULL, NULL, 4006, 9),
(262687, NULL, 'PF13808', NULL, NULL, 'DDE_Tnp_1-associated', NULL, 'DDE_Tnp_1_assoc', NULL, NULL, 21895, 9),
(262688, NULL, 'PF19222', NULL, NULL, 'Nodavirus Vmethyltransferase', NULL, 'Noda_Vmethyltr', NULL, NULL, 35151, 9),
(262689, NULL, 'PF15151', NULL, NULL, 'Response gene to complement 32 protein family', NULL, 'RGCC', NULL, NULL, 21563, 9),
(262690, NULL, 'PF04911', NULL, NULL, 'ATP synthase j chain', NULL, 'ATP-synt_J', NULL, NULL, 5525, 9),
(262691, NULL, 'PF17969', NULL, NULL, 'L,D-transpeptidase C-terminal domain', NULL, 'Ldt_C', NULL, NULL, 29944, 9),
(262692, NULL, 'PF06649', NULL, NULL, 'Protein of unknown function (DUF1161)', NULL, 'DUF1161', NULL, NULL, 8187, 9),
(262693, NULL, 'PF11445', NULL, NULL, 'Protein of unknown function (DUF2894)', NULL, 'DUF2894', NULL, NULL, 18614, 9),
(262694, NULL, 'PF13982', NULL, NULL, 'YbfN-like lipoprotein', NULL, 'YbfN', NULL, NULL, 22849, 9),
(262695, NULL, 'PF16581', NULL, NULL, 'Cytidyltransferase-related C-terminal region', NULL, 'HIGH_NTase1_ass', NULL, NULL, 26069, 9),
(262696, NULL, 'PF06701', NULL, NULL, 'Mib_herc2', NULL, 'MIB_HERC2', NULL, NULL, 8433, 9),
(262697, NULL, 'PF08515', NULL, NULL, 'Transforming growth factor beta type I GS-motif', NULL, 'TGF_beta_GS', NULL, NULL, 496, 9),
(262698, NULL, 'PF08466', NULL, NULL, 'Inward rectifier potassium channel N-terminal', NULL, 'IRK_N', NULL, NULL, 13931, 9),
(262699, NULL, 'PF04389', NULL, NULL, 'Peptidase family M28', NULL, 'Peptidase_M28', NULL, NULL, 10077, 9),
(262700, NULL, 'PF16144', NULL, NULL, 'Domain of unknown function (DUF4852)', NULL, 'DUF4852', NULL, NULL, 22971, 9),
(262701, NULL, 'PF00091', NULL, NULL, 'Tubulin/FtsZ family, GTPase domain', NULL, 'Tubulin', NULL, NULL, 7222, 9),
(262702, NULL, 'PF09786', NULL, NULL, 'Cytochrome B561, N terminal', NULL, 'CytochromB561_N', NULL, NULL, 18054, 9),
(262703, NULL, 'PF16935', NULL, NULL, 'Putative Holin-like Toxin (Hol-Tox)', NULL, 'Hol_Tox', NULL, NULL, 25009, 9),
(262704, NULL, 'PF02310', NULL, NULL, 'B12 binding domain', NULL, 'B12-binding', NULL, NULL, 10096, 9),
(262705, NULL, 'PF03948', NULL, NULL, 'Ribosomal protein L9, C-terminal domain', NULL, 'Ribosomal_L9_C', NULL, NULL, 18545, 9),
(262706, NULL, 'PF07147', NULL, NULL, 'Mitochondrial 28S ribosomal protein S30 (PDCD9)', NULL, 'PDCD9', NULL, NULL, 10668, 9),
(262707, NULL, 'PF00058', NULL, NULL, 'Low-density lipoprotein receptor repeat class B', NULL, 'Ldl_recept_b', NULL, NULL, 7219, 9),
(262708, NULL, 'PF00496', NULL, NULL, 'Bacterial extracellular solute-binding proteins, family 5 Middle', NULL, 'SBP_bac_5', NULL, NULL, 171, 9),
(262709, NULL, 'PF18661', NULL, NULL, 'Avirulence Effector AvrLm4-7', NULL, 'AvrLm4-7', NULL, NULL, 32343, 9),
(262710, NULL, 'PF12874', NULL, NULL, 'Zinc-finger of C2H2 type', NULL, 'zf-met', NULL, NULL, NULL, 9),
(262711, NULL, 'PF03095', NULL, NULL, 'Phosphotyrosyl phosphate activator (PTPA) protein', NULL, 'PTPA', NULL, NULL, 4863, 9),
(262712, NULL, 'PF04376', NULL, NULL, 'Arginine-tRNA-protein transferase, N terminus', NULL, 'ATE_N', NULL, NULL, 4820, 9),
(262713, NULL, 'PF04984', NULL, NULL, 'Phage tail sheath protein subtilisin-like domain', NULL, 'Phage_sheath_1', NULL, NULL, 30893, 9),
(262714, NULL, 'PF11200', NULL, NULL, 'Protein of unknown function (DUF2981)', NULL, 'DUF2981', NULL, NULL, 18306, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(262715, NULL, 'PF14285', NULL, NULL, 'Domain of unknown function (DUF4367)', NULL, 'DUF4367', NULL, NULL, 21550, 9),
(262716, NULL, 'PF18212', NULL, NULL, 'ZNRF-3 Ectodomain', NULL, 'ZNRF_3_ecto', NULL, NULL, 27762, 9),
(262717, NULL, 'PF01984', NULL, NULL, 'Double-stranded DNA-binding domain', NULL, 'dsDNA_bind', NULL, NULL, 5290, 9),
(262718, NULL, 'PF04523', NULL, NULL, 'Herpes virus tegument protein U30', NULL, 'Herpes_U30', NULL, NULL, 2560, 9),
(262719, NULL, 'PF07539', NULL, NULL, 'Down-regulated in metastasis', NULL, 'DRIM', NULL, NULL, 13640, 9),
(262720, NULL, 'PF14602', NULL, NULL, 'Hexapeptide repeat of succinyl-transferase', NULL, 'Hexapep_2', NULL, NULL, 6394, 9),
(262721, NULL, 'PF16606', NULL, NULL, 'Unstructured conserved, between two C2H2-type zinc-fingers', NULL, 'zf-C2H2_assoc', NULL, NULL, NULL, 9),
(262722, NULL, 'PF08631', NULL, NULL, 'Meiosis protein SPO22/ZIP4 like', NULL, 'SPO22', NULL, NULL, 14037, 9),
(262723, NULL, 'PF14049', NULL, NULL, 'Dppa2/4 conserved region in higher vertebrates', NULL, 'Dppa2_A', NULL, NULL, 25784, 9),
(262724, NULL, 'PF02415', NULL, NULL, 'Chlamydia polymorphic membrane protein (Chlamydia_PMP) repeat', NULL, 'Chlam_PMP', NULL, NULL, 4211, 9),
(262725, NULL, 'PF05491', NULL, NULL, 'RuvB C-terminal winged helix domain', NULL, 'RuvB_C', NULL, NULL, 13517, 9),
(262726, NULL, 'PF13908', NULL, NULL, 'Wnt and FGF inhibitory regulator', NULL, 'Shisa', NULL, NULL, 26629, 9),
(262727, NULL, 'PF04599', NULL, NULL, 'Poxvirus G5 protein', NULL, 'Pox_G5', NULL, NULL, 557, 9),
(262728, NULL, 'PF09528', NULL, NULL, 'Ehrlichia tandem repeat (Ehrlichia_rpt)', NULL, 'Ehrlichia_rpt', NULL, NULL, 16510, 9),
(262729, NULL, 'PF13856', NULL, NULL, 'ATP-binding sugar transporter from pro-phage', NULL, 'Gifsy-2', NULL, NULL, 24701, 9),
(262730, NULL, 'PF02391', NULL, NULL, 'MoaE protein', NULL, 'MoaE', NULL, NULL, 4313, 9),
(262731, NULL, 'PF00331', NULL, NULL, 'Glycosyl hydrolase family 10', NULL, 'Glyco_hydro_10', NULL, NULL, 3006, 9),
(262732, NULL, 'PF00335', NULL, NULL, 'Tetraspanin family', NULL, 'Tetraspanin', NULL, NULL, 9210, 9),
(262733, NULL, 'PF07746', NULL, NULL, 'Aromatic-ring-opening dioxygenase LigAB, LigA subunit', NULL, 'LigA', NULL, NULL, 12548, 9),
(262734, NULL, 'PF06686', NULL, NULL, 'Stage III sporulation protein AC/AD protein family', NULL, 'SpoIIIAC', NULL, NULL, 24079, 9),
(262735, NULL, 'PF06732', NULL, NULL, 'Pescadillo N-terminus', NULL, 'Pescadillo_N', NULL, NULL, 8253, 9),
(262736, NULL, 'PF20370', NULL, NULL, 'Family of unknown function (DUF6665)', NULL, 'DUF6665', NULL, NULL, 33540, 9),
(262737, NULL, 'PF07837', NULL, NULL, 'Formiminotransferase domain, N-terminal subdomain', NULL, 'FTCD_N', NULL, NULL, 13420, 9),
(262738, NULL, 'PF13300', NULL, NULL, 'Domain of unknown function (DUF4078)', NULL, 'DUF4078', NULL, NULL, 22293, 9),
(262739, NULL, 'PF14379', NULL, NULL, 'MYB-CC type transfactor, LHEQLE motif', NULL, 'Myb_CC_LHEQLE', NULL, NULL, 22270, 9),
(262740, NULL, 'PF15013', NULL, NULL, 'CCSMST1 family', NULL, 'CCSMST1', NULL, NULL, 26557, 9),
(262741, NULL, 'PF07841', NULL, NULL, 'DM4/DM12 family', NULL, 'DM4_12', NULL, NULL, 1124, 9),
(262742, NULL, 'PF20186', NULL, NULL, 'Family of unknown function (DUF6549)', NULL, 'DUF6549', NULL, NULL, 37094, 9),
(262743, NULL, 'PF02710', NULL, NULL, 'Hemagglutinin domain of haemagglutinin-esterase-fusion glycoprotein', NULL, 'Hema_HEFG', NULL, NULL, 3384, 9),
(262744, NULL, 'PF03848', NULL, NULL, 'Tellurite resistance protein TehB', NULL, 'TehB', NULL, NULL, 9333, 9),
(262745, NULL, 'PF04828', NULL, NULL, 'Glutathione-dependent formaldehyde-activating enzyme', NULL, 'GFA', NULL, NULL, 4910, 9),
(262746, NULL, 'PF06380', NULL, NULL, 'Protein of unknown function (DUF1072)', NULL, 'DUF1072', NULL, NULL, 8363, 9),
(262747, NULL, 'PF02091', NULL, NULL, 'Glycyl-tRNA synthetase alpha subunit', NULL, 'tRNA-synt_2e', NULL, NULL, 6021, 9),
(262748, NULL, 'PF06222', NULL, NULL, 'Phage tail assembly chaperone', NULL, 'Phage_TAC_1', NULL, NULL, 9363, 9),
(262749, NULL, 'PF14391', NULL, NULL, 'Domain of unknown function (DUF4421)', NULL, 'DUF4421', NULL, NULL, 26038, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(262750, NULL, 'PF12462', NULL, NULL, 'DNA helicase IV / RNA helicase N terminal', NULL, 'Helicase_IV_N', NULL, NULL, 20600, 9),
(262751, NULL, 'PF10420', NULL, NULL, 'Cytokine interleukin-12p40 C-terminus', NULL, 'IL12p40_C', NULL, NULL, 18157, 9),
(262752, NULL, 'PF02702', NULL, NULL, 'Osmosensitive K+ channel His kinase sensor domain', NULL, 'KdpD', NULL, NULL, 3397, 9),
(262753, NULL, 'PF02282', NULL, NULL, 'DNA polymerase processivity factor (UL42)', NULL, 'Herpes_UL42', NULL, NULL, 1554, 9),
(262754, NULL, 'PF12862', NULL, NULL, 'Anaphase-promoting complex subunit 5', NULL, 'ANAPC5', NULL, NULL, 23081, 9),
(262755, NULL, 'PF05652', NULL, NULL, 'Scavenger mRNA decapping enzyme (DcpS) N-terminal', NULL, 'DcpS', NULL, NULL, 14311, 9),
(262756, NULL, 'PF01372', NULL, NULL, 'Melittin', NULL, 'Melittin', NULL, NULL, 1112, 9),
(262757, NULL, 'PF15138', NULL, NULL, 'Syncollin', NULL, 'Syncollin', NULL, NULL, 25351, 9),
(262758, NULL, 'PF20004', NULL, NULL, 'FtsH ternary system domain X6', NULL, 'fvmX6', NULL, NULL, 35811, 9),
(262759, NULL, 'PF10731', NULL, NULL, 'Thrombin inhibitor from mosquito', NULL, 'Anophelin', NULL, NULL, 14663, 9),
(262760, NULL, 'PF01701', NULL, NULL, 'Photosystem I reaction centre subunit IX / PsaJ', NULL, 'PSI_PsaJ', NULL, NULL, 1612, 9),
(262761, NULL, 'PF04758', NULL, NULL, 'Ribosomal protein S30', NULL, 'Ribosomal_S30', NULL, NULL, 3697, 9),
(262762, NULL, 'PF11700', NULL, NULL, 'Vacuole effluxer Atg22 like', NULL, 'ATG22', NULL, NULL, 21073, 9),
(262763, NULL, 'PF02632', NULL, NULL, 'BioY family', NULL, 'BioY', NULL, NULL, 3487, 9),
(262764, NULL, 'PF08340', NULL, NULL, 'Domain of unknown function (DUF1732)', NULL, 'DUF1732', NULL, NULL, 12663, 9),
(262765, NULL, 'PF13144', NULL, NULL, 'Chaperone for flagella basal body P-ring formation', NULL, 'ChapFlgA', NULL, NULL, 15900, 9),
(262766, NULL, 'PF12124', NULL, NULL, 'Betacoronavirus SUD-C domain', NULL, 'bCoV_SUD_C', NULL, NULL, 16879, 9),
(262767, NULL, 'PF05343', NULL, NULL, 'M42 glutamyl aminopeptidase', NULL, 'Peptidase_M42', NULL, NULL, 5178, 9),
(262768, NULL, 'PF04603', NULL, NULL, 'Ran-interacting Mog1 protein', NULL, 'Mog1', NULL, NULL, 636, 9),
(262769, NULL, 'PF12576', NULL, NULL, 'Protein of unknown function (DUF3754)', NULL, 'DUF3754', NULL, NULL, 21329, 9),
(262770, NULL, 'PF00410', NULL, NULL, 'Ribosomal protein S8', NULL, 'Ribosomal_S8', NULL, NULL, 5531, 9),
(262771, NULL, 'PF14135', NULL, NULL, 'Domain of unknown function (DUF4302)', NULL, 'DUF4302', NULL, NULL, 26029, 9),
(262772, NULL, 'PF02535', NULL, NULL, 'ZIP Zinc transporter', NULL, 'Zip', NULL, NULL, 1906, 9),
(262773, NULL, 'PF09248', NULL, NULL, 'Domain of unknown function (DUF1965)', NULL, 'DUF1965', NULL, NULL, 13312, 9),
(262774, NULL, 'PF16773', NULL, NULL, 'Lactococcus phage single-stranded DNA binding protein', NULL, 'Phage_SSB', NULL, NULL, 23602, 9),
(262775, NULL, 'PF07706', NULL, NULL, 'Aminotransferase ubiquitination site', NULL, 'TAT_ubiq', NULL, NULL, 8781, 9),
(262776, NULL, 'PF14987', NULL, NULL, 'NADH dehydrogenase 1 alpha subcomplex subunit 3', NULL, 'NADHdh_A3', NULL, NULL, 23357, 9),
(262777, NULL, 'PF13833', NULL, NULL, 'EF-hand domain pair', NULL, 'EF-hand_8', NULL, NULL, 1368, 9),
(262778, NULL, 'PF12109', NULL, NULL, 'CXCR4 Chemokine receptor N terminal', NULL, 'CXCR4_N', NULL, NULL, 14752, 9),
(262779, NULL, 'PF05792', NULL, NULL, 'Candida agglutinin-like (ALS)', NULL, 'Candida_ALS', NULL, NULL, 8910, 9),
(262780, NULL, 'PF14237', NULL, NULL, 'GYF domain 2', NULL, 'GYF_2', NULL, NULL, 24904, 9),
(262781, NULL, 'PF04967', NULL, NULL, 'HTH DNA binding domain', NULL, 'HTH_10', NULL, NULL, 6631, 9),
(262782, NULL, 'PF06636', NULL, NULL, 'Protein of unknown function (DUF1157)', NULL, 'DUF1157', NULL, NULL, 8189, 9),
(262783, NULL, 'PF15034', NULL, NULL, 'KRTAP type 7 family', NULL, 'KRTAP7', NULL, NULL, 17596, 9),
(262784, NULL, 'PF06886', NULL, NULL, 'Targeting protein for Xklp2 (TPX2) domain', NULL, 'TPX2', NULL, NULL, 24906, 9),
(262785, NULL, 'PF14659', NULL, NULL, 'Phage integrase, N-terminal SAM-like domain', NULL, 'Phage_int_SAM_3', NULL, NULL, 1799, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(262786, NULL, 'PF15941', NULL, NULL, 'FidL-like putative membrane protein', NULL, 'FidL_like', NULL, NULL, 24570, 9),
(262787, NULL, 'PF00940', NULL, NULL, 'DNA-dependent RNA polymerase', NULL, 'RNA_pol', NULL, NULL, NULL, 9),
(262788, NULL, 'PF10545', NULL, NULL, 'Alcohol dehydrogenase transcription factor Myb/SANT-like', NULL, 'MADF_DNA_bdg', NULL, NULL, 200, 9),
(262789, NULL, 'PF19680', NULL, NULL, 'Family of unknown function (DUF6182)', NULL, 'DUF6182', NULL, NULL, 36447, 9),
(262790, NULL, 'PF08417', NULL, NULL, 'Pheophorbide a oxygenase', NULL, 'PaO', NULL, NULL, 11349, 9),
(262791, NULL, 'PF09618', NULL, NULL, 'CRISPR-associated protein (Cas_Csy4)', NULL, 'Cas_Csy4', NULL, NULL, 11056, 9),
(262792, NULL, 'PF13119', NULL, NULL, 'Domain of unknown function (DUF3973)', NULL, 'DUF3973', NULL, NULL, 25624, 9),
(262793, NULL, 'PF17007', NULL, NULL, 'HTH-like', NULL, 'HTH_micro', NULL, NULL, 24490, 9),
(262794, NULL, 'PF03767', NULL, NULL, 'HAD superfamily, subfamily IIIB (Acid phosphatase)', NULL, 'Acid_phosphat_B', NULL, NULL, 1952, 9),
(262795, NULL, 'PF16696', NULL, NULL, 'Zinc finger FYVE domain-containing protein 21 C-terminus', NULL, 'ZFYVE21_C', NULL, NULL, 23098, 9),
(262796, NULL, 'PF02107', NULL, NULL, 'Flagellar L-ring protein', NULL, 'FlgH', NULL, NULL, 5637, 9),
(262797, NULL, 'PF08285', NULL, NULL, 'Dolichol-phosphate mannosyltransferase subunit 3 (DPM3)', NULL, 'DPM3', NULL, NULL, 17010, 9),
(262798, NULL, 'PF20538', NULL, NULL, 'Family of unknown function (DUF6753)', NULL, 'DUF6753', NULL, NULL, 33693, 9),
(262799, NULL, 'PF07505', NULL, NULL, 'Protein of unknown function (DUF5131)', NULL, 'DUF5131', NULL, NULL, 11460, 9),
(262800, NULL, 'PF09007', NULL, NULL, 'EBP50, C-terminal', NULL, 'EBP50_C', NULL, NULL, 8510, 9),
(262801, NULL, 'PF16831', NULL, NULL, 'CS6 fimbrial subunits A and B, Coli surface antigen 6', NULL, 'CssAB', NULL, NULL, 22143, 9),
(262802, NULL, 'PF09964', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2198)', NULL, 'DUF2198', NULL, NULL, 19588, 9),
(262803, NULL, 'PF15653', NULL, NULL, 'URI fold toxin 2', NULL, 'Tox-URI2', NULL, NULL, 24703, 9),
(262804, NULL, 'PF18649', NULL, NULL, 'EcpB C-terminal domain', NULL, 'EcpB_C', NULL, NULL, 28187, 9),
(262805, NULL, 'PF01767', NULL, NULL, 'Birnavirus VP3 protein', NULL, 'Birna_VP3', NULL, NULL, 2892, 9),
(262806, NULL, 'PF13877', NULL, NULL, 'Potential Monad-binding region of RPAP3', NULL, 'RPAP3_C', NULL, NULL, 25596, 9),
(262807, NULL, 'PF17446', NULL, NULL, 'Late transcription unit A', NULL, 'LtuA', NULL, NULL, 33345, 9),
(262808, NULL, 'PF14611', NULL, NULL, 'Mitochondrial inner-membrane-bound regulator', NULL, 'SLS', NULL, NULL, 21836, 9),
(262809, NULL, 'PF17399', NULL, NULL, 'Domain of unknown function (DUF5405)', NULL, 'DUF5405', NULL, NULL, 16156, 9),
(262810, NULL, 'PF17055', NULL, NULL, 'Viral matrix protein M2', NULL, 'VMR2', NULL, NULL, 26896, 9),
(262811, NULL, 'PF10084', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2322)', NULL, 'DUF2322', NULL, NULL, 21165, 9),
(262812, NULL, 'PF04119', NULL, NULL, 'Heat shock protein 9/12', NULL, 'HSP9_HSP12', NULL, NULL, 6835, 9),
(262813, NULL, 'PF05246', NULL, NULL, 'Protein of unknown function (DUF735)', NULL, 'DUF735', NULL, NULL, 3099, 9),
(262814, NULL, 'PF01103', NULL, NULL, 'Omp85 superfamily domain', NULL, 'Omp85', NULL, NULL, 1756, 9),
(262815, NULL, 'PF12289', NULL, NULL, 'Rotavirus VP1 C-terminal domain', NULL, 'Rotavirus_VP1', NULL, NULL, 20910, 9),
(262816, NULL, 'PF14636', NULL, NULL, 'Folliculin-interacting protein N-terminus', NULL, 'FNIP_N', NULL, NULL, 23024, 9),
(262817, NULL, 'PF03380', NULL, NULL, 'Caenorhabditis protein of unknown function, DUF282', NULL, 'DUF282', NULL, NULL, 2351, 9),
(262818, NULL, 'PF09444', NULL, NULL, 'MRC1-like domain', NULL, 'MRC1', NULL, NULL, 15341, 9),
(262819, NULL, 'PF05142', NULL, NULL, 'Domain of unknown function (DUF702)', NULL, 'DUF702', NULL, NULL, NULL, 9),
(262820, NULL, 'PF03405', NULL, NULL, 'Fatty acid desaturase', NULL, 'FA_desaturase_2', NULL, NULL, 2203, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(262821, NULL, 'PF07589', NULL, NULL, 'PEP-CTERM motif', NULL, 'PEP-CTERM', NULL, NULL, 9500, 9),
(262822, NULL, 'PF00588', NULL, NULL, 'SpoU rRNA Methylase family', NULL, 'SpoU_methylase', NULL, NULL, 5854, 9),
(262823, NULL, 'PF04480', NULL, NULL, 'Protein of unknown function (DUF559)', NULL, 'DUF559', NULL, NULL, 1979, 9),
(262824, NULL, 'PF16250', NULL, NULL, 'Domain of unknown function (DUF4907)', NULL, 'DUF4907', NULL, NULL, 23879, 9),
(262825, NULL, 'PF15430', NULL, NULL, 'Single domain von Willebrand factor type C', NULL, 'SVWC', NULL, NULL, 26432, 9),
(262826, NULL, 'PF10124', NULL, NULL, 'Mu-like prophage major head subunit gpT', NULL, 'Mu-like_gpT', NULL, NULL, 18023, 9),
(262827, NULL, 'PF04676', NULL, NULL, 'Protein similar to CwfJ C-terminus 2', NULL, 'CwfJ_C_2', NULL, NULL, 3305, 9),
(262828, NULL, 'PF07736', NULL, NULL, 'Chorismate mutase type I', NULL, 'CM_1', NULL, NULL, 900, 9),
(262829, NULL, 'PF19036', NULL, NULL, 'First Longin domain of FUZ, MON1 and HPS1', NULL, 'Fuz_longin_1', NULL, NULL, 34724, 9),
(262830, NULL, 'PF08852', NULL, NULL, 'Protein of unknown function (DUF1822)', NULL, 'DUF1822', NULL, NULL, 14220, 9),
(262831, NULL, 'PF08873', NULL, NULL, 'Bacteriophage Mu, Gp37', NULL, 'Phage_Mu_Gp37', NULL, NULL, 14167, 9),
(262832, NULL, 'PF08088', NULL, NULL, 'Conotoxin I-superfamily', NULL, 'Toxin_19', NULL, NULL, 9747, 9),
(262833, NULL, 'PF07812', NULL, NULL, 'TfuA-like protein', NULL, 'TfuA', NULL, NULL, 7735, 9),
(262834, NULL, 'PF07870', NULL, NULL, 'Protein of unknown function (DUF1657)', NULL, 'DUF1657', NULL, NULL, 14442, 9),
(262835, NULL, 'PF11259', NULL, NULL, 'Protein of unknown function (DUF3060)', NULL, 'DUF3060', NULL, NULL, 18345, 9),
(262836, NULL, 'PF12069', NULL, NULL, 'Protein of unknown function (DUF3549)', NULL, 'DUF3549', NULL, NULL, 19787, 9),
(262837, NULL, 'PF00316', NULL, NULL, 'Fructose-1-6-bisphosphatase, N-terminal domain', NULL, 'FBPase', NULL, NULL, 27034, 9),
(262838, NULL, 'PF07460', NULL, NULL, 'NUMOD3 motif', NULL, 'NUMOD3', NULL, NULL, 729, 9),
(262839, NULL, 'PF10990', NULL, NULL, 'Protein of unknown function (DUF2809)', NULL, 'DUF2809', NULL, NULL, 17748, 9),
(262840, NULL, 'PF19169', NULL, NULL, 'Family of unknown function (DUF5851)', NULL, 'DUF5851', NULL, NULL, 34710, 9),
(262841, NULL, 'PF19370', NULL, NULL, 'Family of unknown function (DUF5945)', NULL, 'DUF5945', NULL, NULL, 36885, 9),
(262842, NULL, 'PF06187', NULL, NULL, 'Protein of unknown function (DUF993)', NULL, 'DUF993', NULL, NULL, 14428, 9),
(262843, NULL, 'PF19162', NULL, NULL, 'Family of unknown function (DUF5844)', NULL, 'DUF5844', NULL, NULL, 34469, 9),
(262844, NULL, 'PF17956', NULL, NULL, 'Nicotinate phosphoribosyltransferase C-terminal domain', NULL, 'NAPRTase_C', NULL, NULL, 30405, 9),
(262845, NULL, 'PF01194', NULL, NULL, 'RNA polymerases N / 8 kDa subunit', NULL, 'RNA_pol_N', NULL, NULL, 593, 9),
(262846, NULL, 'PF09386', NULL, NULL, 'Antitoxin ParD', NULL, 'ParD', NULL, NULL, 6361, 9),
(262847, NULL, 'PF18132', NULL, NULL, 'Tyosinase C-terminal domain', NULL, 'Tyosinase_C', NULL, NULL, 30100, 9),
(262848, NULL, 'PF20050', NULL, NULL, 'Family of unknown function (DUF6452)', NULL, 'DUF6452', NULL, NULL, 34386, 9),
(262849, NULL, 'PF13989', NULL, NULL, 'YejG-like protein', NULL, 'YejG', NULL, NULL, 21256, 9),
(262850, NULL, 'PF09797', NULL, NULL, 'N-acetyltransferase B complex (NatB) non catalytic subunit', NULL, 'NatB_MDM20', NULL, NULL, 18253, 9),
(262851, NULL, 'PF14421', NULL, NULL, 'A distinct subfamily of CDD/CDA-like deaminases', NULL, 'LmjF365940-deam', NULL, NULL, 26044, 9),
(262852, NULL, 'PF11691', NULL, NULL, 'Protein of unknown function (DUF3288)', NULL, 'DUF3288', NULL, NULL, 19316, 9),
(262853, NULL, 'PF07646', NULL, NULL, 'Kelch motif', NULL, 'Kelch_2', NULL, NULL, 12543, 9),
(262854, NULL, 'PF20007', NULL, NULL, 'FtsH ternary system-associated peptide', NULL, 'fvmRadSAM-pep', NULL, NULL, 35941, 9),
(262855, NULL, 'PF03359', NULL, NULL, 'Guanylate-kinase-associated protein (GKAP) protein', NULL, 'GKAP', NULL, NULL, 1415, 9),
(262856, NULL, 'PF08557', NULL, NULL, 'Sphingolipid Delta4-desaturase (DES)', NULL, 'Lipid_DES', NULL, NULL, 9820, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(262857, NULL, 'PF09121', NULL, NULL, 'Tower', NULL, 'Tower', NULL, NULL, 10850, 9),
(262858, NULL, 'PF17696', NULL, NULL, 'Family of unknown function (DUF5542)', NULL, 'DUF5542', NULL, NULL, 30357, 9),
(262859, NULL, 'PF11927', NULL, NULL, 'Protein of unknown function (DUF3445)', NULL, 'DUF3445', NULL, NULL, 19772, 9),
(262860, NULL, 'PF15787', NULL, NULL, 'Neurobeachin/BDCP, DUF4704 alpha solenoid region', NULL, 'DUF4704', NULL, NULL, 23919, 9),
(262861, NULL, 'PF15380', NULL, NULL, 'Domain of unknown function (DUF4607)', NULL, 'DUF4607', NULL, NULL, 24120, 9),
(262862, NULL, 'PF11810', NULL, NULL, 'Domain of unknown function (DUF3332)', NULL, 'DUF3332', NULL, NULL, 19110, 9),
(262863, NULL, 'PF00328', NULL, NULL, 'Histidine phosphatase superfamily (branch 2)', NULL, 'His_Phos_2', NULL, NULL, 4229, 9),
(262864, NULL, 'PF13218', NULL, NULL, 'Protein of unknown function (DUF4026)', NULL, 'DUF4026', NULL, NULL, 22651, 9),
(262865, NULL, 'PF14234', NULL, NULL, 'Domain of unknown function (DUF4336)', NULL, 'DUF4336', NULL, NULL, 24951, 9),
(262866, NULL, 'PF15775', NULL, NULL, 'Domain of unknown function (DUF4703)', NULL, 'DUF4703', NULL, NULL, 25921, 9),
(262867, NULL, 'PF12526', NULL, NULL, 'Protein of unknown function (DUF3729)', NULL, 'DUF3729', NULL, NULL, 21203, 9),
(262868, NULL, 'PF17356', NULL, NULL, 'Phage-like element PBSX protein XtrA', NULL, 'PBSX_XtrA', NULL, NULL, 32379, 9),
(262869, NULL, 'PF12231', NULL, NULL, 'Rap1-interacting factor 1 N terminal', NULL, 'Rif1_N', NULL, NULL, 20087, 9),
(262870, NULL, 'PF05437', NULL, NULL, 'Branched-chain amino acid transport protein (AzlD)', NULL, 'AzlD', NULL, NULL, 8889, 9),
(262871, NULL, 'PF02603', NULL, NULL, 'HPr Serine kinase N terminus', NULL, 'Hpr_kinase_N', NULL, NULL, 9793, 9),
(262872, NULL, 'PF17568', NULL, NULL, 'Family of unknown function (DUF5474)', NULL, 'DUF5474', NULL, NULL, 12824, 9),
(262873, NULL, 'PF14012', NULL, NULL, 'Protein of unknown function (DUF4229)', NULL, 'DUF4229', NULL, NULL, 22449, 9),
(262874, NULL, 'PF18664', NULL, NULL, 'CdiA C-terminal tRNase domain', NULL, 'CdiA_C_tRNase', NULL, NULL, 30880, 9),
(262875, NULL, 'PF09859', NULL, NULL, 'Oxygenase, catalysing oxidative methylation of damaged DNA', NULL, 'Oxygenase-NA', NULL, NULL, 16546, 9),
(262876, NULL, 'PF04098', NULL, NULL, 'Rad52/22 family double-strand break repair protein', NULL, 'Rad52_Rad22', NULL, NULL, 29911, 9),
(262877, NULL, 'PF09613', NULL, NULL, 'Bacterial type III secretion protein (HrpB1_HrpK)', NULL, 'HrpB1_HrpK', NULL, NULL, 11449, 9),
(262878, NULL, 'PF15303', NULL, NULL, 'E3 ubiquitin-protein ligase Arkadia N-terminus', NULL, 'RNF111_N', NULL, NULL, 24578, 9),
(262879, NULL, 'PF11328', NULL, NULL, 'Protein of unknown function (DUF3130', NULL, 'DUF3130', NULL, NULL, 18325, 9),
(262880, NULL, 'PF00452', NULL, NULL, 'Apoptosis regulator proteins, Bcl-2 family', NULL, 'Bcl-2', NULL, NULL, 36785, 9),
(262881, NULL, 'PF08053', NULL, NULL, 'Tryptophanase operon leader peptide', NULL, 'Tna_leader', NULL, NULL, 9526, 9),
(262882, NULL, 'PF00401', NULL, NULL, 'ATP synthase, Delta/Epsilon chain, long alpha-helix domain', NULL, 'ATP-synt_DE', NULL, NULL, 21232, 9),
(262883, NULL, 'PF11422', NULL, NULL, 'Initiator binding protein 39 kDa', NULL, 'IBP39', NULL, NULL, 12018, 9),
(262884, NULL, 'PF01535', NULL, NULL, 'PPR repeat', NULL, 'PPR', NULL, NULL, 5826, 9),
(262885, NULL, 'PF08455', NULL, NULL, 'Bacterial SNF2 helicase associated', NULL, 'SNF2_assoc', NULL, NULL, 12457, 9),
(262886, NULL, 'PF19031', NULL, NULL, 'First Longin domain of INTU, CCZ1 and HPS4', NULL, 'Intu_longin_1', NULL, NULL, 35892, 9),
(262887, NULL, 'PF19704', NULL, NULL, 'DNA-PKcs, CC5', NULL, 'DNAPKcs_CC5', NULL, NULL, 33544, 9),
(262888, NULL, 'PF20112', NULL, NULL, 'Family of unknown function (DUF6502)', NULL, 'DUF6502', NULL, NULL, 37387, 9),
(262889, NULL, 'PF07585', NULL, NULL, 'Putative beta barrel porin-7 (BBP7)', NULL, 'BBP7', NULL, NULL, 13526, 9),
(262890, NULL, 'PF12780', NULL, NULL, 'P-loop containing dynein motor region D4', NULL, 'AAA_8', NULL, NULL, 26886, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(262891, NULL, 'PF12053', NULL, NULL, 'N-terminal of Par3 and HAL proteins', NULL, 'Par3_HAL_N_term', NULL, NULL, 19547, 9),
(262892, NULL, 'PF02636', NULL, NULL, 'Putative S-adenosyl-L-methionine-dependent methyltransferase', NULL, 'Methyltransf_28', NULL, NULL, 6299, 9),
(262893, NULL, 'PF05647', NULL, NULL, 'Tandem-repeating region of mucin, epiglycanin-like', NULL, 'Epiglycanin_TR', NULL, NULL, 13236, 9),
(262894, NULL, 'PF05896', NULL, NULL, 'Na(+)-translocating NADH-quinone reductase subunit A (NQRA)', NULL, 'NQRA', NULL, NULL, 13060, 9),
(262895, NULL, 'PF05258', NULL, NULL, 'Dna[CI] antecedent, DciA', NULL, 'DciA', NULL, NULL, 3298, 9),
(262896, NULL, 'PF12562', NULL, NULL, 'Protein of unknown function (DUF3746)', NULL, 'DUF3746', NULL, NULL, 21150, 9),
(262897, NULL, 'PF05099', NULL, NULL, 'Tellurite resistance protein TerB', NULL, 'TerB', NULL, NULL, 2251, 9),
(262898, NULL, 'PF05369', NULL, NULL, 'Monomethylamine methyltransferase MtmB', NULL, 'MtmB', NULL, NULL, 5005, 9),
(262899, NULL, 'PF13135', NULL, NULL, 'Protein of unknown function (DUF3947)', NULL, 'DUF3947', NULL, NULL, 22312, 9),
(262900, NULL, 'PF19733', NULL, NULL, 'Family of unknown function (DUF6223)', NULL, 'DUF6223', NULL, NULL, 34350, 9),
(262901, NULL, 'PF12630', NULL, NULL, 'Poxvirus poly(A) polymerase N-terminal domain', NULL, 'Pox_polyA_pol_N', NULL, NULL, 22081, 9),
(262902, NULL, 'PF10536', NULL, NULL, 'Plant mobile domain', NULL, 'PMD', NULL, NULL, 19403, 9),
(262903, NULL, 'PF14598', NULL, NULL, 'PAS domain', NULL, 'PAS_11', NULL, NULL, NULL, 9),
(262904, NULL, 'PF15622', NULL, NULL, 'Kinetochore assembly subunit CENP-C N-terminal', NULL, 'CENP_C_N', NULL, NULL, 25311, 9),
(262905, NULL, 'PF13181', NULL, NULL, 'Tetratricopeptide repeat', NULL, 'TPR_8', NULL, NULL, 20936, 9),
(262906, NULL, 'PF08714', NULL, NULL, 'Formaldehyde-activating enzyme (Fae)', NULL, 'Fae', NULL, NULL, 11825, 9),
(262907, NULL, 'PF16004', NULL, NULL, '116 kDa U5 small nuclear ribonucleoprotein component N-terminus', NULL, 'EFTUD2', NULL, NULL, 26915, 9),
(262908, NULL, 'PF14940', NULL, NULL, 'Transmembrane 219', NULL, 'TMEM219', NULL, NULL, 33813, 9),
(262909, NULL, 'PF16701', NULL, NULL, 'Adenylate cyclase regulatory domain', NULL, 'Ad_Cy_reg', NULL, NULL, 23443, 9),
(262910, NULL, 'PF11877', NULL, NULL, 'Protein of unknown function (DUF3397)', NULL, 'DUF3397', NULL, NULL, 24681, 9),
(262911, NULL, 'PF11970', NULL, NULL, 'G protein-coupled glucose receptor regulating Gpa2 C-term', NULL, 'GPR_Gpa2_C', NULL, NULL, 15735, 9),
(262912, NULL, 'PF06082', NULL, NULL, 'Exopolysaccharide biosynthesis protein YbjH', NULL, 'YjbH', NULL, NULL, 8940, 9),
(262913, NULL, 'PF17442', NULL, NULL, 'Functional domain of U62 and UL91 proteins', NULL, 'U62_UL91', NULL, NULL, 27440, 9),
(262914, NULL, 'PF13447', NULL, NULL, 'Seven times multi-haem cytochrome CxxCH', NULL, 'Multi-haem_cyto', NULL, NULL, NULL, 9),
(262915, NULL, 'PF03259', NULL, NULL, 'Roadblock/LC7 domain', NULL, 'Robl_LC7', NULL, NULL, 1900, 9),
(262916, NULL, 'PF06911', NULL, NULL, 'Senescence domain', NULL, 'Senescence', NULL, NULL, 11671, 9),
(262917, NULL, 'PF14325', NULL, NULL, 'Domain of unknown function (DUF4383)', NULL, 'DUF4383', NULL, NULL, 26143, 9),
(262918, NULL, 'PF18815', NULL, NULL, 'Bacterial antifreeze protein repeat', NULL, 'AFP_2', NULL, NULL, NULL, 9),
(262919, NULL, 'PF15103', NULL, NULL, 'G0/G1 switch protein 2', NULL, 'G0-G1_switch_2', NULL, NULL, 15032, 9),
(262920, NULL, 'PF10252', NULL, NULL, 'Casein kinase substrate phosphoprotein PP28', NULL, 'PP28', NULL, NULL, 15669, 9),
(262921, NULL, 'PF12071', NULL, NULL, 'Protein of unknown function (DUF3551)', NULL, 'DUF3551', NULL, NULL, 19771, 9),
(262922, NULL, 'PF13383', NULL, NULL, 'Methyltransferase domain', NULL, 'Methyltransf_22', NULL, NULL, 24658, 9),
(262923, NULL, 'PF14876', NULL, NULL, 'Respiratory growth transcriptional regulator', NULL, 'RSF', NULL, NULL, 21834, 9),
(262924, NULL, 'PF09494', NULL, NULL, 'Slx4 endonuclease', NULL, 'Slx4', NULL, NULL, 15478, 9),
(262925, NULL, 'PF20104', NULL, NULL, 'Family of unknown function (DUF6494)', NULL, 'DUF6494', NULL, NULL, 35623, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(262926, NULL, 'PF08035', NULL, NULL, 'Opioids neuropeptide', NULL, 'Op_neuropeptide', NULL, NULL, 12530, 9),
(262927, NULL, 'PF05008', NULL, NULL, 'Vesicle transport v-SNARE protein N-terminus', NULL, 'V-SNARE', NULL, NULL, 1267, 9),
(262928, NULL, 'PF05104', NULL, NULL, 'Ribosome receptor lysine/proline rich region', NULL, 'Rib_recp_KP_reg', NULL, NULL, 2076, 9),
(262929, NULL, 'PF10511', NULL, NULL, 'Trappin protein transglutaminase binding domain', NULL, 'Cementoin', NULL, NULL, 19462, 9),
(262930, NULL, 'PF14986', NULL, NULL, 'Domain of unknown function (DUF4514)', NULL, 'DUF4514', NULL, NULL, 23346, 9),
(262931, NULL, 'PF06086', NULL, NULL, 'Orthopoxvirus A26L/A30L protein', NULL, 'Pox_A30L_A26L', NULL, NULL, 13741, 9),
(262932, NULL, 'PF20454', NULL, NULL, 'Terminase large subunit gpA, endonuclease domain', NULL, 'GpA_nuclease', NULL, NULL, 35556, 9),
(262933, NULL, 'PF19055', NULL, NULL, 'ABC-2 type transporter', NULL, 'ABC2_membrane_7', NULL, NULL, 35489, 9),
(262934, NULL, 'PF20026', NULL, NULL, 'Domain of unknown function (DUF6434)', NULL, 'DUF6434', NULL, NULL, 36429, 9),
(262935, NULL, 'PF00864', NULL, NULL, 'ATP P2X receptor', NULL, 'P2X_receptor', NULL, NULL, NULL, 9),
(262936, NULL, 'PF04762', NULL, NULL, 'IKI3 family', NULL, 'IKI3', NULL, NULL, 3521, 9),
(262937, NULL, 'PF15164', NULL, NULL, 'Williams-Beuren syndrome chromosomal region 28 protein homologue', NULL, 'WBS28', NULL, NULL, 21806, 9),
(262938, NULL, 'PF09842', NULL, NULL, 'Predicted membrane protein (DUF2069)', NULL, 'DUF2069', NULL, NULL, 16569, 9),
(262939, NULL, 'PF11627', NULL, NULL, 'Nuclear factor hnRNPA1', NULL, 'HnRNPA1', NULL, NULL, 18703, 9),
(262940, NULL, 'PF12894', NULL, NULL, 'Anaphase-promoting complex subunit 4 WD40 domain', NULL, 'ANAPC4_WD40', NULL, NULL, 22189, 9),
(262941, NULL, 'PF16938', NULL, NULL, 'Putative phage holin Dp-1', NULL, 'Phage_holin_Dp1', NULL, NULL, 25917, 9),
(262942, NULL, 'PF06530', NULL, NULL, 'Phage antitermination protein Q', NULL, 'Phage_antitermQ', NULL, NULL, 14217, 9),
(262943, NULL, 'PF09984', NULL, NULL, 'Single cache domain 4', NULL, 'sCache_4', NULL, NULL, 19715, 9),
(262944, NULL, 'PF03070', NULL, NULL, 'TENA/THI-4/PQQC family', NULL, 'TENA_THI-4', NULL, NULL, 4805, 9),
(262945, NULL, 'PF17327', NULL, NULL, 'Acyl homoserine lactone synthase', NULL, 'AHL_synthase', NULL, NULL, 15979, 9),
(262946, NULL, 'PF11302', NULL, NULL, 'Protein of unknown function (DUF3104)', NULL, 'DUF3104', NULL, NULL, 18404, 9),
(262947, NULL, 'PF17226', NULL, NULL, 'MTA R1 domain', NULL, 'MTA_R1', NULL, NULL, 20375, 9),
(262948, NULL, 'PF12750', NULL, NULL, 'Maff2 family', NULL, 'Maff2', NULL, NULL, 9786, 9),
(262949, NULL, 'PF14487', NULL, NULL, 'ssDNA thymidine ADP-ribosyltransferase, DarT', NULL, 'DarT', NULL, NULL, 22276, 9),
(262950, NULL, 'PF15406', NULL, NULL, 'Pleckstrin homology domain', NULL, 'PH_6', NULL, NULL, 33082, 9),
(262951, NULL, 'PF14245', NULL, NULL, 'Type IV pilin PilA', NULL, 'Pilin_PilA', NULL, NULL, 23940, 9),
(262952, NULL, 'PF14997', NULL, NULL, 'CECR6/TMEM121 family', NULL, 'CECR6_TMEM121', NULL, NULL, 22197, 9),
(262953, NULL, 'PF01163', NULL, NULL, 'RIO1 family', NULL, 'RIO1', NULL, NULL, NULL, 9),
(262954, NULL, 'PF02783', NULL, NULL, 'Methyl-coenzyme M reductase beta subunit, N-terminal domain', NULL, 'MCR_beta_N', NULL, NULL, 16551, 9),
(262955, NULL, 'PF01333', NULL, NULL, 'Apocytochrome F, C-terminal', NULL, 'Apocytochr_F_C', NULL, NULL, 6398, 9),
(262956, NULL, 'PF00731', NULL, NULL, 'AIR carboxylase', NULL, 'AIRC', NULL, NULL, 3785, 9),
(262957, NULL, 'PF01672', NULL, NULL, 'Putative plasmid partition protein', NULL, 'Plasmid_parti', NULL, NULL, 1863, 9),
(262958, NULL, 'PF11249', NULL, NULL, 'Protein of unknown function (DUF3047)', NULL, 'DUF3047', NULL, NULL, 18207, 9),
(262959, NULL, 'PF04968', NULL, NULL, 'CHORD', NULL, 'CHORD', NULL, NULL, 6807, 9),
(262960, NULL, 'PF02722', NULL, NULL, 'Major Outer Sheath Protein C-terminal domain', NULL, 'MOSP_C', NULL, NULL, 4135, 9),
(262961, NULL, 'PF14435', NULL, NULL, 'SUKH-4 immunity protein', NULL, 'SUKH-4', NULL, NULL, 24406, 9);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(262962, NULL, 'PF07596', NULL, NULL, 'Protein of unknown function (DUF1559)', NULL, 'SBP_bac_10', NULL, NULL, 13704, 9),
(262963, NULL, 'PF19671', NULL, NULL, 'Family of unknown function (DUF6174)', NULL, 'DUF6174', NULL, NULL, 37370, 9),
(262964, NULL, 'PF01307', NULL, NULL, 'Plant viral movement protein', NULL, 'Plant_vir_prot', NULL, NULL, 2079, 9),
(262965, NULL, 'PF09956', NULL, NULL, 'Uncharacterized conserved protein (DUF2190)', NULL, 'DUF2190', NULL, NULL, 10924, 9),
(262966, NULL, 'PF16459', NULL, NULL, 'Phage tail assembly chaperone, TAC', NULL, 'Phage_TAC_13', NULL, NULL, 22399, 9),
(262967, NULL, 'PF05931', NULL, NULL, 'Staphylococcal AgrD protein', NULL, 'AgrD', NULL, NULL, 12733, 9),
(262968, NULL, 'PF12513', NULL, NULL, 'Mitochondrial degradasome RNA helicase subunit C terminal', NULL, 'SUV3_C', NULL, NULL, 21462, 9),
(262969, NULL, 'PF13361', NULL, NULL, 'UvrD-like helicase C-terminal domain', NULL, 'UvrD_C', NULL, NULL, 9187, 9),
(262970, NULL, 'PF05697', NULL, NULL, 'Bacterial trigger factor protein (TF)', NULL, 'Trigger_N', NULL, NULL, 7558, 9),
(262971, NULL, 'PF04674', NULL, NULL, 'Phosphate-induced protein 1 conserved region', NULL, 'Phi_1', NULL, NULL, 3325, 9),
(262972, NULL, 'PF11243', NULL, NULL, 'Protein of unknown function (DUF3045)', NULL, 'DUF3045', NULL, NULL, 18279, 9),
(262973, NULL, 'PF18200', NULL, NULL, 'Bacterial Ig-like domain', NULL, 'Big_11', NULL, NULL, 29912, 9),
(262974, NULL, 'PF04985', NULL, NULL, 'Phage tail tube protein FII', NULL, 'Phage_tube', NULL, NULL, 6699, 9),
(262975, NULL, 'PF10989', NULL, NULL, 'Protein of unknown function (DUF2808)', NULL, 'DUF2808', NULL, NULL, 17945, 9),
(262976, NULL, 'PF03865', NULL, NULL, 'Haemolysin secretion/activation protein ShlB/FhaC/HecB', NULL, 'ShlB', NULL, NULL, 1886, 9),
(262977, NULL, 'PF06504', NULL, NULL, 'Replication protein C (RepC)', NULL, 'RepC', NULL, NULL, 12245, 9),
(262978, NULL, 'PF03710', NULL, NULL, 'Glutamate-ammonia ligase adenylyltransferase', NULL, 'GlnE', NULL, NULL, 5488, 9),
(262979, NULL, 'PF17999', NULL, NULL, 'Pullulanase N1-terminal domain', NULL, 'PulA_N1', NULL, NULL, 27828, 9),
(262980, NULL, 'PF13899', NULL, NULL, 'Thioredoxin-like', NULL, 'Thioredoxin_7', NULL, NULL, NULL, 9),
(262981, NULL, 'PF15256', NULL, NULL, 'SPATIAL', NULL, 'SPATIAL', NULL, NULL, 31958, 9),
(262982, NULL, 'PF04868', NULL, NULL, 'Retinal cGMP phosphodiesterase, gamma subunit', NULL, 'PDE6_gamma', NULL, NULL, 5996, 9),
(262983, NULL, 'PF19662', NULL, NULL, 'Family of unknown function (DUF6165)', NULL, 'DUF6165', NULL, NULL, 37192, 9),
(262984, NULL, 'PF13120', NULL, NULL, 'Domain of unknown function (DUF3974)', NULL, 'DUF3974', NULL, NULL, 25944, 9),
(262985, NULL, 'PF14749', NULL, NULL, 'Acyl-coenzyme A oxidase N-terminal', NULL, 'Acyl-CoA_ox_N', NULL, NULL, 26824, 9),
(262986, NULL, 'PF15264', NULL, NULL, 'Tumour suppressing sub-chromosomal transferable candidate 4', NULL, 'TSSC4', NULL, NULL, 23552, 9),
(262987, NULL, 'PF19293', NULL, NULL, 'CdaA N-terminal transmembrane domain', NULL, 'CdaA_N', NULL, NULL, 36196, 9),
(262988, NULL, 'PF15450', NULL, NULL, 'Coiled-coil domain-containing protein 154', NULL, 'CCDC154', NULL, NULL, 23511, 9),
(262989, NULL, 'PF17987', NULL, NULL, 'Phosphoethanolamine N-methyltransferase 2 N-terminal', NULL, 'PMT2_N', NULL, NULL, 31808, 9),
(262990, NULL, 'PF14070', NULL, NULL, 'Putative motility protein', NULL, 'YjfB_motility', NULL, NULL, 23393, 9),
(262991, NULL, 'PF18705', NULL, NULL, 'Family of unknown function (DUF5643)', NULL, 'DUF5643', NULL, NULL, 28786, 9),
(262992, NULL, 'PF00971', NULL, NULL, 'EIAV coat protein, gp90', NULL, 'EIAV_GP90', NULL, NULL, 2257, 9),
(262993, NULL, 'PF17087', NULL, NULL, 'Herpesvirus US34A protein family', NULL, 'HHV-5_US34A', NULL, NULL, 24486, 9),
(262994, NULL, 'PF01943', NULL, NULL, 'Polysaccharide biosynthesis protein', NULL, 'Polysacc_synt', NULL, NULL, 4753, 9),
(262995, NULL, 'PF05128', NULL, NULL, 'Domain of unknown function (DUF697)', NULL, 'DUF697', NULL, NULL, 15269, 9),
(262996, NULL, 'PF17598', NULL, NULL, 'Family of unknown function (DUF5494)', NULL, 'DUF5494', NULL, NULL, 19005, 9);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(262997, NULL, 'PF11286', NULL, NULL, 'Protein of unknown function (DUF3087)', NULL, 'DUF3087', NULL, NULL, 18461, 9),
(262998, NULL, 'PF17147', NULL, NULL, 'Pyruvate:ferredoxin oxidoreductase core domain II', NULL, 'PFOR_II', NULL, NULL, 29113, 9),
(262999, NULL, 'PF18027', NULL, NULL, 'Cytosolic carboxypeptidase N-terminal domain', NULL, 'Pepdidase_M14_N', NULL, NULL, 27715, 9),
(263000, NULL, 'PF20466', NULL, NULL, 'MmeI, target recognition domain', NULL, 'MmeI_TRD', NULL, NULL, 33543, 9),
(263001, NULL, 'PF04748', NULL, NULL, 'Divergent polysaccharide deacetylase', NULL, 'Polysacc_deac_2', NULL, NULL, 3953, 9),
(263002, NULL, 'PF18283', NULL, NULL, 'Carbohydrate binding module 77', NULL, 'CBM77', NULL, NULL, 29485, 9),
(263003, NULL, 'PF10158', NULL, NULL, 'Tumour suppressor protein', NULL, 'LOH1CR12', NULL, NULL, 19344, 9),
(263004, NULL, 'PF05914', NULL, NULL, 'RIB43A', NULL, 'RIB43A', NULL, NULL, 13716, 9),
(263005, NULL, 'PF11033', NULL, NULL, 'Competence protein J (ComJ)', NULL, 'ComJ', NULL, NULL, 19592, 9),
(263006, NULL, 'PF18822', NULL, NULL, 'CdvA-like coiled-coil domain', NULL, 'CdvA', NULL, NULL, 30415, 9),
(263007, NULL, 'PF01900', NULL, NULL, 'Rpp14/Pop5 family', NULL, 'RNase_P_Rpp14', NULL, NULL, 4097, 9),
(263008, NULL, 'PF10436', NULL, NULL, 'Mitochondrial branched-chain alpha-ketoacid dehydrogenase kinase', NULL, 'BCDHK_Adom3', NULL, NULL, 16554, 9),
(263009, NULL, 'PF04652', NULL, NULL, 'Vta1 like', NULL, 'Vta1', NULL, NULL, 33112, 9),
(263010, NULL, 'PF05122', NULL, NULL, 'Mobile element transfer protein', NULL, 'SpdB', NULL, NULL, 2327, 9),
(263011, NULL, 'PF06662', NULL, NULL, 'D-glucuronyl C5-epimerase C-terminus', NULL, 'C5-epim_C', NULL, NULL, 8389, 9),
(263012, NULL, 'PF16366', NULL, NULL, 'Cytoplasmic polyadenylation element-binding protein ZZ domain', NULL, 'CEBP_ZZ', NULL, NULL, 23570, 9),
(263013, NULL, 'PF02223', NULL, NULL, 'Thymidylate kinase', NULL, 'Thymidylate_kin', NULL, NULL, 33081, 9),
(263014, NULL, 'PF08124', NULL, NULL, 'Polysaccharide lyase family 8, N terminal alpha-helical domain', NULL, 'Lyase_8_N', NULL, NULL, 11591, 9),
(263015, NULL, 'PF02740', NULL, NULL, 'Colipase, C-terminal domain', NULL, 'Colipase_C', NULL, NULL, 18018, 9),
(263016, NULL, 'PF18850', NULL, NULL, 'Large polyvalent protein associated domain 30', NULL, 'LPD30', NULL, NULL, 28292, 9),
(263017, NULL, 'PF12820', NULL, NULL, 'Serine-rich domain associated with BRCT', NULL, 'BRCT_assoc', NULL, NULL, 17610, 9),
(263018, NULL, 'PF03376', NULL, NULL, 'Adenovirus E3B protein', NULL, 'Adeno_E3B', NULL, NULL, 2139, 9),
(263019, NULL, 'PF18295', NULL, NULL, 'M17 aminopeptidase N-terminal domain 2', NULL, 'Pdase_M17_N2', NULL, NULL, 30037, 9),
(263020, NULL, 'PF11630', NULL, NULL, 'Anti-lipopolysaccharide factor/Scygonadin', NULL, 'Anti-LPS-SCYG', NULL, NULL, 24588, 9),
(263021, NULL, 'PF03682', NULL, NULL, 'Uncharacterised protein family (UPF0158)', NULL, 'UPF0158', NULL, NULL, 6081, 9),
(263022, NULL, 'PF14889', NULL, NULL, 'Penicillin-binding protein Tp47 domain a', NULL, 'PBP-Tp47_a', NULL, NULL, 26554, 9),
(263023, NULL, 'PF08475', NULL, NULL, 'Viral capsid protein 91 N-terminal', NULL, 'Baculo_VP91_N', NULL, NULL, 13614, 9),
(263024, NULL, 'PF03139', NULL, NULL, 'Vanadium/alternative nitrogenase delta subunit', NULL, 'AnfG_VnfG', NULL, NULL, 5074, 9),
(263025, NULL, 'PF12402', NULL, NULL, 'NocA-like zinc-finger protein 1', NULL, 'nlz1', NULL, NULL, 20985, 9),
(263026, NULL, 'PF13153', NULL, NULL, 'Protein of unknown function (DUF3985)', NULL, 'DUF3985', NULL, NULL, 22593, 9),
(263027, NULL, 'PF08600', NULL, NULL, 'Rsm1-like', NULL, 'Rsm1', NULL, NULL, 17641, 9),
(263028, NULL, 'PF13410', NULL, NULL, 'Glutathione S-transferase, C-terminal domain', NULL, 'GST_C_2', NULL, NULL, NULL, 9),
(263029, NULL, 'PF00883', NULL, NULL, 'Cytosol aminopeptidase family, catalytic domain', NULL, 'Peptidase_M17', NULL, NULL, 311, 9),
(263030, NULL, 'PF06589', NULL, NULL, 'Circumsporozoite-related antigen (CRA)', NULL, 'CRA', NULL, NULL, NULL, 9),
(263031, NULL, 'PF08640', NULL, NULL, 'U3 small nucleolar RNA-associated protein 6', NULL, 'U3_assoc_6', NULL, NULL, 7894, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(263032, NULL, 'PF05988', NULL, NULL, 'Bacterial protein of unknown function (DUF899)', NULL, 'DUF899', NULL, NULL, 7754, 9),
(263033, NULL, 'PF08241', NULL, NULL, 'Methyltransferase domain', NULL, 'Methyltransf_11', NULL, NULL, 12281, 9),
(263034, NULL, 'PF11131', NULL, NULL, 'Rap-phr extracellular signalling', NULL, 'PhrC_PhrF', NULL, NULL, 21664, 9),
(263035, NULL, 'PF17815', NULL, NULL, 'PDZ domain', NULL, 'PDZ_3', NULL, NULL, 29687, 9),
(263036, NULL, 'PF04305', NULL, NULL, 'Protein of unknown function (DUF455)', NULL, 'DUF455', NULL, NULL, 3637, 9),
(263037, NULL, 'PF19695', NULL, NULL, 'Family of unknown function (DUF6195)', NULL, 'DUF6195', NULL, NULL, 36461, 9),
(263038, NULL, 'PF07965', NULL, NULL, 'Integrin beta tail domain', NULL, 'Integrin_B_tail', NULL, NULL, 13098, 9),
(263039, NULL, 'PF03566', NULL, NULL, 'Peptidase family A21', NULL, 'Peptidase_A21', NULL, NULL, 5345, 9),
(263040, NULL, 'PF05344', NULL, NULL, 'Domain of Unknown Function (DUF746)', NULL, 'DUF746', NULL, NULL, 5197, 9),
(263041, NULL, 'PF01066', NULL, NULL, 'CDP-alcohol phosphatidyltransferase', NULL, 'CDP-OH_P_transf', NULL, NULL, 6617, 9),
(263042, NULL, 'PF10620', NULL, NULL, 'Phosphoribosyl-dephospho-CoA transferase MdcG', NULL, 'MdcG', NULL, NULL, 14713, 9),
(263043, NULL, 'PF13677', NULL, NULL, 'Membrane MotB of proton-channel complex MotA/MotB', NULL, 'MotB_plug', NULL, NULL, 24622, 9),
(263044, NULL, 'PF17454', NULL, NULL, 'Honey bee toxin', NULL, 'Bee_toxin', NULL, NULL, 14594, 9),
(263045, NULL, 'PF07672', NULL, NULL, 'Mycoplasma MFS transporter', NULL, 'MFS_Mycoplasma', NULL, NULL, 10936, 9),
(263046, NULL, 'PF02238', NULL, NULL, 'Cytochrome c oxidase subunit VII', NULL, 'COX7a', NULL, NULL, 29830, 9),
(263047, NULL, 'PF12816', NULL, NULL, 'Golgi CORVET complex core vacuolar protein 8', NULL, 'Vps8', NULL, NULL, 24873, 9),
(263048, NULL, 'PF14100', NULL, NULL, 'Family of unknown function (DUF6807)', NULL, 'DUF6807', NULL, NULL, 26552, 9),
(263049, NULL, 'PF12045', NULL, NULL, 'Protein of unknown function (DUF3528)', NULL, 'DUF3528', NULL, NULL, 19911, 9),
(263050, NULL, 'PF19552', NULL, NULL, 'Family of unknown function (DUF6075)', NULL, 'DUF6075', NULL, NULL, 34218, 9),
(263051, NULL, 'PF02285', NULL, NULL, 'Cytochrome oxidase c subunit VIII', NULL, 'COX8', NULL, NULL, 3042, 9),
(263052, NULL, 'PF17628', NULL, NULL, 'Inclusion membrane protein D', NULL, 'IncD', NULL, NULL, 8357, 9),
(263053, NULL, 'PF04696', NULL, NULL, 'pinin/SDK/memA/ protein conserved region', NULL, 'Pinin_SDK_memA', NULL, NULL, 3127, 9),
(263054, NULL, 'PF18500', NULL, NULL, 'CadC C-terminal domain 1', NULL, 'CadC_C1', NULL, NULL, 28082, 9),
(263055, NULL, 'PF00468', NULL, NULL, 'Ribosomal protein L34', NULL, 'Ribosomal_L34', NULL, NULL, 872, 9),
(263056, NULL, 'PF08687', NULL, NULL, 'Apx/Shroom domain ASD2', NULL, 'ASD2', NULL, NULL, 11451, 9),
(263057, NULL, 'PF19913', NULL, NULL, 'Wolframin C-terminal OB-fold domain', NULL, 'WCOB', NULL, NULL, 35852, 9),
(263058, NULL, 'PF16532', NULL, NULL, 'Sf6-type phage tail needle knob or tip of some Caudovirales', NULL, 'Phage_tail_NK', NULL, NULL, 24451, 9),
(263059, NULL, 'PF07712', NULL, NULL, 'Stress up-regulated Nod 19', NULL, 'SURNod19', NULL, NULL, 10980, 9),
(263060, NULL, 'PF00672', NULL, NULL, 'HAMP domain', NULL, 'HAMP', NULL, NULL, 1355, 9),
(263061, NULL, 'PF03982', NULL, NULL, 'Diacylglycerol acyltransferase', NULL, 'DAGAT', NULL, NULL, 124, 9),
(263062, NULL, 'PF04802', NULL, NULL, 'Phosphatase 4 regulatory subunit 3', NULL, 'PP4R3', NULL, NULL, 4607, 9),
(263063, NULL, 'PF11483', NULL, NULL, 'Protein of unknown function (DUF3209)', NULL, 'DUF3209', NULL, NULL, 18942, 9),
(263064, NULL, 'PF16559', NULL, NULL, 'GIT coiled-coil Rho guanine nucleotide exchange factor', NULL, 'GIT_CC', NULL, NULL, 26233, 9),
(263065, NULL, 'PF17017', NULL, NULL, 'Aberrant zinc-finger', NULL, 'zf-C2H2_aberr', NULL, NULL, 22721, 9),
(263066, NULL, 'PF19313', NULL, NULL, 'Domain of unknown function (DUF5916)', NULL, 'DUF5916', NULL, NULL, 33757, 9),
(263067, NULL, 'PF16008', NULL, NULL, 'Domain of unknown function (DUF4778)', NULL, 'DUF4778', NULL, NULL, 21916, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(263068, NULL, 'PF14074', NULL, NULL, 'Protein of unknown function (DUF4257)', NULL, 'DUF4257', NULL, NULL, 22538, 9),
(263069, NULL, 'PF16221', NULL, NULL, 'winged helix-turn-helix', NULL, 'HTH_47', NULL, NULL, 26106, 9),
(263070, NULL, 'PF16427', NULL, NULL, 'Domain of unknown function (DUF5024)', NULL, 'DUF5024', NULL, NULL, 24286, 9),
(263071, NULL, 'PF13171', NULL, NULL, 'Protein of unknown function (DUF4004)', NULL, 'DUF4004', NULL, NULL, 22527, 9),
(263072, NULL, 'PF06818', NULL, NULL, 'Fez1', NULL, 'Fez1', NULL, NULL, NULL, 9),
(263073, NULL, 'PF11099', NULL, NULL, 'Apoptosis regulator M11L like', NULL, 'M11L', NULL, NULL, 15408, 9),
(263074, NULL, 'PF14714', NULL, NULL, 'KH-domain-like of EngA bacterial GTPase enzymes, C-terminal', NULL, 'KH_dom-like', NULL, NULL, 23215, 9),
(263075, NULL, 'PF18393', NULL, NULL, 'MotY N-terminal domain', NULL, 'MotY_N', NULL, NULL, 30930, 9),
(263076, NULL, 'PF02728', NULL, NULL, 'Copper amine oxidase, N3 domain', NULL, 'Cu_amine_oxidN3', NULL, NULL, 12856, 9),
(263077, NULL, 'PF13556', NULL, NULL, 'PucR C-terminal helix-turn-helix domain', NULL, 'HTH_30', NULL, NULL, 24603, 9),
(263078, NULL, 'PF15001', NULL, NULL, 'AP-5 complex subunit sigma-1', NULL, 'AP-5_subunit_s1', NULL, NULL, 23344, 9),
(263079, NULL, 'PF15008', NULL, NULL, 'Domain of unknown function (DUF4518)', NULL, 'DUF4518', NULL, NULL, 24247, 9),
(263080, NULL, 'PF13325', NULL, NULL, 'N-terminal region of micro-spherule protein', NULL, 'MCRS_N', NULL, NULL, 25960, 9),
(263081, NULL, 'PF12287', NULL, NULL, 'Cytoplasmic activation/proliferation-associated protein-1 C term', NULL, 'Caprin-1_C', NULL, NULL, 20670, 9),
(263082, NULL, 'PF01862', NULL, NULL, 'Pyruvoyl-dependent arginine decarboxylase (PvlArgDC)', NULL, 'PvlArgDC', NULL, NULL, 3752, 9),
(263083, NULL, 'PF14045', NULL, NULL, 'YIEGIA protein', NULL, 'YIEGIA', NULL, NULL, 23043, 9),
(263084, NULL, 'PF14873', NULL, NULL, 'N-terminal domain of BNR-repeat neuraminidase', NULL, 'BNR_assoc_N', NULL, NULL, 25947, 9),
(263085, NULL, 'PF00204', NULL, NULL, 'DNA gyrase B', NULL, 'DNA_gyraseB', NULL, NULL, 11087, 9),
(263086, NULL, 'PF12812', NULL, NULL, 'PDZ-like domain', NULL, 'PDZ_1', NULL, NULL, 23453, 9),
(263087, NULL, 'PF18983', NULL, NULL, 'Family of unknown function (DUF5717)C-terminal', NULL, 'DUF5717', NULL, NULL, 35449, 9),
(263088, NULL, 'PF17225', NULL, NULL, 'Domain of unknown function (DUF5300)', NULL, 'DUF5301', NULL, NULL, 30352, 9),
(263089, NULL, 'PF19396', NULL, NULL, 'Family of unknown function (DUF5971)', NULL, 'DUF5971', NULL, NULL, 36948, 9),
(263090, NULL, 'PF10309', NULL, NULL, 'Nuclear cap-binding protein subunit 3', NULL, 'NCBP3', NULL, NULL, 16848, 9),
(263091, NULL, 'PF12959', NULL, NULL, 'Protein of unknown function (DUF3848)', NULL, 'DUF3848', NULL, NULL, 23275, 9),
(263092, NULL, 'PF16598', NULL, NULL, 'Linker region of enhancer of mRNA-decapping protein 3', NULL, 'Edc3_linker', NULL, NULL, NULL, 9),
(263093, NULL, 'PF15785', NULL, NULL, 'Serine/threonine-protein kinase smg-1', NULL, 'SMG1', NULL, NULL, 23748, 9),
(263094, NULL, 'PF10931', NULL, NULL, 'Protein of unknown function (DUF2735)', NULL, 'DUF2735', NULL, NULL, 17789, 9),
(263095, NULL, 'PF01077', NULL, NULL, 'Nitrite and sulphite reductase 4Fe-4S domain', NULL, 'NIR_SIR', NULL, NULL, 2561, 9),
(263096, NULL, 'PF00478', NULL, NULL, 'IMP dehydrogenase / GMP reductase domain', NULL, 'IMPDH', NULL, NULL, 2031, 9),
(263097, NULL, 'PF07483', NULL, NULL, 'Tryptophan-rich Synechocystis species C-terminal domain', NULL, 'W_rich_C', NULL, NULL, 11247, 9),
(263098, NULL, 'PF03510', NULL, NULL, '2C endopeptidase (C24) cysteine protease family', NULL, 'Peptidase_C24', NULL, NULL, 4608, 9),
(263099, NULL, 'PF05533', NULL, NULL, 'Beet yellows virus-type papain-like endopeptidase C42', NULL, 'Peptidase_C42', NULL, NULL, 12142, 9),
(263100, NULL, 'PF14593', NULL, NULL, 'PH domain', NULL, 'PH_3', NULL, NULL, 27769, 9),
(263101, NULL, 'PF14645', NULL, NULL, 'Chibby family', NULL, 'Chibby', NULL, NULL, 21978, 9),
(263102, NULL, 'PF07937', NULL, NULL, 'Protein of unknown function (DUF1686)', NULL, 'DUF1686', NULL, NULL, 14199, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(263103, NULL, 'PF08145', NULL, NULL, 'BOP1NT (NUC169) domain', NULL, 'BOP1NT', NULL, NULL, 11744, 9),
(263104, NULL, 'PF17426', NULL, NULL, 'Putative Gamma DNA binding protein G5P', NULL, 'Putative_G5P', NULL, NULL, 29710, 9),
(263105, NULL, 'PF03319', NULL, NULL, 'Ethanolamine utilisation protein EutN/carboxysome', NULL, 'EutN_CcmL', NULL, NULL, 778, 9),
(263106, NULL, 'PF13191', NULL, NULL, 'AAA ATPase domain', NULL, 'AAA_16', NULL, NULL, 30605, 9),
(263107, NULL, 'PF13553', NULL, NULL, 'Function to find', NULL, 'FIIND', NULL, NULL, 25721, 9),
(263108, NULL, 'PF11768', NULL, NULL, 'WD repeat-containing and planar cell polarity effector protein Fritz', NULL, 'Frtz', NULL, NULL, 24607, 9),
(263109, NULL, 'PF12290', NULL, NULL, 'Protein of unknown function (DUF3802)', NULL, 'DUF3802', NULL, NULL, 14676, 9),
(263110, NULL, 'PF08976', NULL, NULL, 'EF-hand domain', NULL, 'EF-hand_11', NULL, NULL, 8833, 9),
(263111, NULL, 'PF02910', NULL, NULL, 'Fumarate reductase flavoprotein C-term', NULL, 'Succ_DH_flav_C', NULL, NULL, 8029, 9),
(263112, NULL, 'PF18488', NULL, NULL, 'WYL domain', NULL, 'WYL_3', NULL, NULL, 28456, 9),
(263113, NULL, 'PF01545', NULL, NULL, 'Cation efflux family', NULL, 'Cation_efflux', NULL, NULL, 691, 9),
(263114, NULL, 'PF04213', NULL, NULL, 'Htaa', NULL, 'HtaA', NULL, NULL, 5302, 9),
(263115, NULL, 'PF11177', NULL, NULL, 'Protein of unknown function (DUF2964)', NULL, 'DUF2964', NULL, NULL, 18246, 9),
(263116, NULL, 'PF02876', NULL, NULL, 'Staphylococcal/Streptococcal toxin, beta-grasp domain', NULL, 'Stap_Strp_tox_C', NULL, NULL, 10279, 9),
(263117, NULL, 'PF03956', NULL, NULL, 'Lysine exporter LysO', NULL, 'Lys_export', NULL, NULL, 2736, 9),
(263118, NULL, 'PF10472', NULL, NULL, 'eIF2-alpha phosphatase phosphorylation constitutive repressor', NULL, 'CReP_N', NULL, NULL, 18216, 9),
(263119, NULL, 'PF00464', NULL, NULL, 'Serine hydroxymethyltransferase', NULL, 'SHMT', NULL, NULL, 33130, 9),
(263120, NULL, 'PF05173', NULL, NULL, 'Dihydrodipicolinate reductase, C-terminus', NULL, 'DapB_C', NULL, NULL, 16874, 9),
(263121, NULL, 'PF01903', NULL, NULL, 'CbiX', NULL, 'CbiX', NULL, NULL, 4295, 9),
(263122, NULL, 'PF03420', NULL, NULL, 'Prohead core protein serine protease', NULL, 'Peptidase_S77', NULL, NULL, 10342, 9),
(263123, NULL, 'PF16339', NULL, NULL, 'Domain of unknown function (DUF4969)', NULL, 'DUF4969', NULL, NULL, 22085, 9),
(263124, NULL, 'PF19427', NULL, NULL, 'Protein inscuteable C-terminal', NULL, 'Insc_C', NULL, NULL, 37365, 9),
(263125, NULL, 'PF11044', NULL, NULL, 'Plectrovirus spv1-c74 ORF 12 transmembrane protein', NULL, 'TMEMspv1-c74-12', NULL, NULL, NULL, 9),
(263126, NULL, 'PF13394', NULL, NULL, '4Fe-4S single cluster domain', NULL, 'Fer4_14', NULL, NULL, NULL, 9),
(263127, NULL, 'PF16619', NULL, NULL, 'Unstructured region C-term to UIM in Ataxin3', NULL, 'SUIM_assoc', NULL, NULL, NULL, 9),
(263128, NULL, 'PF03577', NULL, NULL, 'Peptidase family C69', NULL, 'Peptidase_C69', NULL, NULL, 5995, 9),
(263129, NULL, 'PF04029', NULL, NULL, '2-phosphosulpholactate phosphatase', NULL, '2-ph_phosp', NULL, NULL, 11431, 9),
(263130, NULL, 'PF08878', NULL, NULL, 'HamA', NULL, 'HamA', NULL, NULL, 14320, 9),
(263131, NULL, 'PF07441', NULL, NULL, 'SigmaK-factor processing regulatory protein BofA', NULL, 'BofA', NULL, NULL, 8588, 9),
(263132, NULL, 'PF15268', NULL, NULL, 'Dapper', NULL, 'Dapper', NULL, NULL, 16297, 9),
(263133, NULL, 'PF00851', NULL, NULL, 'Helper component proteinase', NULL, 'Peptidase_C6', NULL, NULL, 6119, 9),
(263134, NULL, 'PF02031', NULL, NULL, 'Streptomyces extracellular neutral proteinase (M7) family', NULL, 'Peptidase_M7', NULL, NULL, 2679, 9),
(263135, NULL, 'PF13055', NULL, NULL, 'Protein of unknown function (DUF3917)', NULL, 'DUF3917', NULL, NULL, 22927, 9),
(263136, NULL, 'PF15362', NULL, NULL, 'Enamelin', NULL, 'Enamelin', NULL, NULL, 18243, 9),
(263137, NULL, 'PF08610', NULL, NULL, 'Peroxisomal membrane protein (Pex16)', NULL, 'Pex16', NULL, NULL, 14397, 9),
(263138, NULL, 'PF12384', NULL, NULL, 'Ty3 transposon peptidase', NULL, 'Peptidase_A2B', NULL, NULL, 9377, 9); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(263139, NULL, 'PF00650', NULL, NULL, 'CRAL/TRIO domain', NULL, 'CRAL_TRIO', NULL, NULL, 6774, 9),
(263140, NULL, 'PF07076', NULL, NULL, 'Protein of unknown function (DUF1344)', NULL, 'DUF1344', NULL, NULL, 13334, 9),
(263141, NULL, 'PF05714', NULL, NULL, 'Borrelia Bbcrasp-1 domain containing protein', NULL, 'PFam54_60', NULL, NULL, 8575, 9),
(263142, NULL, 'PF13936', NULL, NULL, 'Helix-turn-helix domain', NULL, 'HTH_38', NULL, NULL, 23097, 9),
(263143, NULL, 'PF04211', NULL, NULL, 'Tetrahydromethanopterin S-methyltransferase, subunit C', NULL, 'MtrC', NULL, NULL, 6628, 9),
(263144, NULL, 'PF19527', NULL, NULL, 'Family of unknown function (DUF6055)', NULL, 'DUF6055', NULL, NULL, 37296, 9),
(263145, NULL, 'PF03470', NULL, NULL, 'XS zinc finger domain', NULL, 'zf-XS', NULL, NULL, 6160, 9),
(263146, NULL, 'PF12400', NULL, NULL, 'STIMATE family', NULL, 'STIMATE', NULL, NULL, 20696, 9),
(263147, NULL, 'PF06513', NULL, NULL, 'Repeat of unknown function (DUF1103)', NULL, 'DUF1103', NULL, NULL, 9475, 9),
(263148, NULL, 'PF14077', NULL, NULL, 'Alternative WD40 repeat motif', NULL, 'WD40_alt', NULL, NULL, 25677, 9),
(263149, NULL, 'PF01518', NULL, NULL, 'Sigma NS protein', NULL, 'PolyG_pol', NULL, NULL, 628, 9),
(263150, NULL, 'PF18524', NULL, NULL, 'High potential iron-sulfur protein like', NULL, 'HPIP_like', NULL, NULL, 27657, 9),
(263151, NULL, 'PF03323', NULL, NULL, 'Bacillus/Clostridium GerA spore germination protein', NULL, 'GerA', NULL, NULL, 904, 9),
(263152, NULL, 'PF19504', NULL, NULL, 'Family of unknown function (DUF6038)', NULL, 'DUF6038', NULL, NULL, 36739, 9),
(263153, NULL, 'PF00142', NULL, NULL, '4Fe-4S iron sulfur cluster binding proteins, NifH/frxC family', NULL, 'Fer4_NifH', NULL, NULL, 4790, 9),
(263154, NULL, 'PF13403', NULL, NULL, 'Hint domain', NULL, 'Hint_2', NULL, NULL, 21737, 9),
(263155, NULL, 'PF14370', NULL, NULL, 'C-terminal topoisomerase domain', NULL, 'Topo_C_assoc', NULL, NULL, 24437, 9),
(263156, NULL, 'PF06300', NULL, NULL, 'Tsp45I type II restriction enzyme', NULL, 'Tsp45I', NULL, NULL, 10106, 9),
(263157, NULL, 'PF05056', NULL, NULL, 'Protein of unknown function (DUF674)', NULL, 'DUF674', NULL, NULL, 1125, 9),
(263158, NULL, 'PF15351', NULL, NULL, 'Junctional protein associated with coronary artery disease', NULL, 'JCAD', NULL, NULL, 23745, 9),
(263159, NULL, 'PF20369', NULL, NULL, 'Family of unknown function (DUF6664)', NULL, 'DUF6664', NULL, NULL, 33638, 9),
(263160, NULL, 'PF12742', NULL, NULL, 'Gryzun, putative Golgi trafficking', NULL, 'Gryzun-like', NULL, NULL, 25039, 9),
(263161, NULL, 'PF13029', NULL, NULL, 'Domain of unknown function (DUF3890)', NULL, 'DUF3890', NULL, NULL, 22370, 9),
(263162, NULL, 'PF11442', NULL, NULL, 'Protein of unknown function (DUF2826)', NULL, 'DUF2826', NULL, NULL, 18512, 9),
(263163, NULL, 'PF17749', NULL, NULL, 'Microtubule-binding protein MIP-T3 C-terminal region', NULL, 'MIP-T3_C', NULL, NULL, 30337, 9),
(263164, NULL, 'PF02165', NULL, NULL, 'Wilm''s tumour protein', NULL, 'WT1', NULL, NULL, 3150, 9),
(263165, NULL, 'PF08024', NULL, NULL, 'Ant antimicrobial peptide', NULL, 'Antimicrobial_4', NULL, NULL, 12516, 9),
(263166, NULL, 'PF13780', NULL, NULL, 'Domain of unknown function (DUF4176)', NULL, 'DUF4176', NULL, NULL, 23466, 9),
(263167, NULL, 'PF10819', NULL, NULL, 'Protein of unknown function (DUF2564)', NULL, 'DUF2564', NULL, NULL, 19421, 9),
(263168, NULL, 'PF16566', NULL, NULL, 'Cell-cycle alteration and expression-elevated protein in tumour', NULL, 'CREPT', NULL, NULL, 25390, 9),
(263169, NULL, 'PF05854', NULL, NULL, 'Non-histone chromosomal protein MC1', NULL, 'MC1', NULL, NULL, 12827, 9),
(263170, NULL, 'PF03069', NULL, NULL, 'Acetamidase/Formamidase family', NULL, 'FmdA_AmdA', NULL, NULL, 4535, 9),
(263171, NULL, 'PF12029', NULL, NULL, 'Domain of unknown function (DUF3516)', NULL, 'DUF3516', NULL, NULL, 19677, 9),
(263172, NULL, 'PF01478', NULL, NULL, 'Type IV leader peptidase family', NULL, 'Peptidase_A24', NULL, NULL, 3856, 9),
(263173, NULL, 'PF00554', NULL, NULL, 'Rel homology DNA-binding domain', NULL, 'RHD_DNA_bind', NULL, NULL, 7711, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(263174, NULL, 'PF02844', NULL, NULL, 'Phosphoribosylglycinamide synthetase, N domain', NULL, 'GARS_N', NULL, NULL, 14603, 9),
(263175, NULL, 'PF18820', NULL, NULL, 'Bdellovibrio Beta-sandwich', NULL, 'BD_b_sandwich', NULL, NULL, 29169, 9),
(263176, NULL, 'PF17659', NULL, NULL, 'Family of unknown function (DUF5521)', NULL, 'DUF5521', NULL, NULL, 32018, 9),
(263177, NULL, 'PF20166', NULL, NULL, 'ATG4, F-type LIR motif', NULL, 'ATG4_LIR', NULL, NULL, 35593, 9),
(263178, NULL, 'PF12152', NULL, NULL, 'Eukaryotic translation initiation factor 4G1', NULL, 'eIF_4G1', NULL, NULL, 17089, 9),
(263179, NULL, 'PF11437', NULL, NULL, 'Vanadium-binding protein 2', NULL, 'Vanabin-2', NULL, NULL, 18965, 9),
(263180, NULL, 'PF04231', NULL, NULL, 'Endonuclease I', NULL, 'Endonuclease_1', NULL, NULL, 5912, 9),
(263181, NULL, 'PF10386', NULL, NULL, 'Protein of unknown function (DUF2441)', NULL, 'DUF2441', NULL, NULL, 20043, 9),
(263182, NULL, 'PF13095', NULL, NULL, 'Kinetochore Sim4 complex subunit FTA2', NULL, 'FTA2', NULL, NULL, 22268, 9),
(263183, NULL, 'PF09441', NULL, NULL, 'ARS binding protein 2', NULL, 'Abp2', NULL, NULL, 15383, 9),
(263184, NULL, 'PF13786', NULL, NULL, 'Domain of unknown function (DUF4179)', NULL, 'DUF4179', NULL, NULL, 22120, 9),
(263185, NULL, 'PF13243', NULL, NULL, 'Squalene-hopene cyclase C-terminal domain', NULL, 'SQHop_cyclase_C', NULL, NULL, 26977, 9),
(263186, NULL, 'PF14594', NULL, NULL, 'Siphovirus ReqiPepy6 Gp37-like protein', NULL, 'Sipho_Gp37', NULL, NULL, 25047, 9),
(263187, NULL, 'PF11168', NULL, NULL, 'Protein of unknown function (DUF2955)', NULL, 'DUF2955', NULL, NULL, 14789, 9),
(263188, NULL, 'PF15109', NULL, NULL, 'TMEM125 protein family', NULL, 'TMEM125', NULL, NULL, 23858, 9),
(263189, NULL, 'PF10555', NULL, NULL, 'Phospho-N-acetylmuramoyl-pentapeptide-transferase signature 1', NULL, 'MraY_sig1', NULL, NULL, 9441, 9),
(263190, NULL, 'PF13099', NULL, NULL, 'Domain of unknown function (DUF3944)', NULL, 'DUF3944', NULL, NULL, 22224, 9),
(263191, NULL, 'PF04644', NULL, NULL, 'Motilin/ghrelin', NULL, 'Motilin_ghrelin', NULL, NULL, 2841, 9),
(263192, NULL, 'PF09750', NULL, NULL, 'Alternative splicing regulator', NULL, 'DRY_EERY', NULL, NULL, 18174, 9),
(263193, NULL, 'PF17921', NULL, NULL, 'Integrase zinc binding domain', NULL, 'Integrase_H2C2', NULL, NULL, 29861, 9),
(263194, NULL, 'PF16934', NULL, NULL, 'Two-component Enterococcus faecalis cytolysin (EFC)', NULL, 'Mersacidin', NULL, NULL, 23692, 9),
(263195, NULL, 'PF14350', NULL, NULL, 'Beta protein', NULL, 'Beta_protein', NULL, NULL, 24721, 9),
(263196, NULL, 'PF19513', NULL, NULL, 'Family of unknown function (DUF6047)', NULL, 'DUF6047', NULL, NULL, 37417, 9),
(263197, NULL, 'PF13550', NULL, NULL, 'Putative phage tail protein', NULL, 'Phage-tail_3', NULL, NULL, 24101, 9),
(263198, NULL, 'PF02123', NULL, NULL, 'Viral RNA-directed RNA-polymerase', NULL, 'RdRP_4', NULL, NULL, 4365, 9),
(263199, NULL, 'PF18383', NULL, NULL, 'Intraflagellar transport 81 calponin homology domain', NULL, 'IFT81_CH', NULL, NULL, 28523, 9),
(263200, NULL, 'PF02186', NULL, NULL, 'TFIIE beta subunit core domain', NULL, 'TFIIE_beta', NULL, NULL, 1581, 9),
(263201, NULL, 'PF06506', NULL, NULL, 'Propionate catabolism activator', NULL, 'PrpR_N', NULL, NULL, 12099, 9),
(263202, NULL, 'PF07801', NULL, NULL, 'Protein of unknown function (DUF1647)', NULL, 'DUF1647', NULL, NULL, 14171, 9),
(263203, NULL, 'PF12455', NULL, NULL, 'Dynein associated protein', NULL, 'Dynactin', NULL, NULL, 20735, 9),
(263204, NULL, 'PF19587', NULL, NULL, 'Uncharacterised methyltransferase family (DUF6094)', NULL, 'DUF6094', NULL, NULL, 36918, 9),
(263205, NULL, 'PF15402', NULL, NULL, 'MELT motif', NULL, 'MELT_2', NULL, NULL, NULL, 9),
(263206, NULL, 'PF00688', NULL, NULL, 'TGF-beta propeptide', NULL, 'TGFb_propeptide', NULL, NULL, 1229, 9),
(263207, NULL, 'PF16564', NULL, NULL, 'p55-binding region of Methyl-CpG-binding domain proteins MBD', NULL, 'MBDa', NULL, NULL, 24051, 9),
(263208, NULL, 'PF06950', NULL, NULL, 'Protein of unknown function (DUF1293)', NULL, 'DUF1293', NULL, NULL, 12426, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(263209, NULL, 'PF18736', NULL, NULL, 'HEPN pEK499 p136', NULL, 'pEK499_p136', NULL, NULL, 30041, 9),
(263210, NULL, 'PF03228', NULL, NULL, 'Adenoviral core protein VII', NULL, 'Adeno_VII', NULL, NULL, 1881, 9),
(263211, NULL, 'PF09648', NULL, NULL, 'YycI protein', NULL, 'YycI', NULL, NULL, 15864, 9),
(263212, NULL, 'PF16057', NULL, NULL, 'Domain of unknown function (DUF4800)', NULL, 'DUF4800', NULL, NULL, NULL, 9),
(263213, NULL, 'PF00989', NULL, NULL, 'PAS fold', NULL, 'PAS', NULL, NULL, 11898, 9),
(263214, NULL, 'PF12078', NULL, NULL, 'Domain of unknown function (DUF3557)', NULL, 'DUF3557', NULL, NULL, 20223, 9),
(263215, NULL, 'PF05671', NULL, NULL, 'GETHR pentapeptide repeat (5 copies)', NULL, 'GETHR', NULL, NULL, 14340, 9),
(263216, NULL, 'PF07543', NULL, NULL, 'Protein trafficking PGA2', NULL, 'PGA2', NULL, NULL, 13934, 9),
(263217, NULL, 'PF08881', NULL, NULL, 'CVNH domain', NULL, 'CVNH', NULL, NULL, 9270, 9),
(263218, NULL, 'PF17396', NULL, NULL, 'Domain of unknown function (DUF1611_N) Rossmann-like domain', NULL, 'DUF1611_N', NULL, NULL, 16394, 9),
(263219, NULL, 'PF01318', NULL, NULL, 'Bromovirus coat protein', NULL, 'Bromo_coat', NULL, NULL, 2402, 9),
(263220, NULL, 'PF06253', NULL, NULL, 'Trimethylamine methyltransferase (MTTB)', NULL, 'MTTB', NULL, NULL, 9092, 9),
(263221, NULL, 'PF09920', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2150)', NULL, 'DUF2150', NULL, NULL, 11226, 9),
(263222, NULL, 'PF07752', NULL, NULL, 'S-layer protein', NULL, 'S-layer', NULL, NULL, 6607, 9),
(263223, NULL, 'PF10322', NULL, NULL, 'Serpentine type 7TM GPCR chemoreceptor Sru', NULL, '7TM_GPCR_Sru', NULL, NULL, 3426, 9),
(263224, NULL, 'PF09207', NULL, NULL, 'Yeast killer toxin', NULL, 'Yeast-kill-tox', NULL, NULL, 12428, 9),
(263225, NULL, 'PF05228', NULL, NULL, 'CHASE4 domain', NULL, 'CHASE4', NULL, NULL, 3216, 9),
(263226, NULL, 'PF16153', NULL, NULL, 'Domain of unknown function (DUF4861)', NULL, 'DUF4861', NULL, NULL, 26367, 9),
(263227, NULL, 'PF12367', NULL, NULL, 'Pyruvate ferredoxin oxidoreductase beta subunit C terminal', NULL, 'PFO_beta_C', NULL, NULL, 26658, 9),
(263228, NULL, 'PF12615', NULL, NULL, 'F sex factor protein N terminal', NULL, 'TraD_N', NULL, NULL, 15362, 9),
(263229, NULL, 'PF16799', NULL, NULL, 'C-terminal membrane-localisation domain of ion-channel, VCN1', NULL, 'VGPC1_C', NULL, NULL, 22148, 9),
(263230, NULL, 'PF06787', NULL, NULL, 'FeGP cofactor biosynthesis protein HcgF', NULL, 'HcgF', NULL, NULL, 1773, 9),
(263231, NULL, 'PF11361', NULL, NULL, 'Protein of unknown function (DUF3159)', NULL, 'DUF3159', NULL, NULL, 17572, 9),
(263232, NULL, 'PF08672', NULL, NULL, 'Anaphase promoting complex (APC) subunit 2', NULL, 'ANAPC2', NULL, NULL, 11182, 9),
(263233, NULL, 'PF15358', NULL, NULL, 'Testis-specific serine kinase substrate', NULL, 'TSKS', NULL, NULL, 22102, 9),
(263234, NULL, 'PF20218', NULL, NULL, 'Family of unknown function (DUF6578)', NULL, 'DUF6578', NULL, NULL, 37694, 9),
(263235, NULL, 'PF01568', NULL, NULL, 'Molydopterin dinucleotide binding domain', NULL, 'Molydop_binding', NULL, NULL, 1356, 9),
(263236, NULL, 'PF04097', NULL, NULL, 'Nup93/Nic96', NULL, 'Nic96', NULL, NULL, 6712, 9),
(263237, NULL, 'PF09071', NULL, NULL, 'Alpha-amylase, C terminal', NULL, 'Alpha-amyl_C', NULL, NULL, 9655, 9),
(263238, NULL, 'PF11610', NULL, NULL, 'Scaffold protein Ste5, Fus3-binding region', NULL, 'Ste5', NULL, NULL, 18880, 9),
(263239, NULL, 'PF13322', NULL, NULL, 'Domain of unknown function (DUF4092)', NULL, 'DUF4092', NULL, NULL, 22469, 9),
(263240, NULL, 'PF15435', NULL, NULL, 'UNC119-binding protein C5orf30 homologue', NULL, 'UNC119_bdg', NULL, NULL, 26504, 9),
(263241, NULL, 'PF02620', NULL, NULL, 'Large ribosomal RNA subunit accumulation protein YceD', NULL, 'YceD', NULL, NULL, 6492, 9),
(263242, NULL, 'PF15746', NULL, NULL, 'TMEM215 family', NULL, 'TMEM215', NULL, NULL, 25291, 9),
(263243, NULL, 'PF07092', NULL, NULL, 'Protein of unknown function (DUF1356)', NULL, 'DUF1356', NULL, NULL, 13426, 9),
(263244, NULL, 'PF00454', NULL, NULL, 'Phosphatidylinositol 3- and 4-kinase', NULL, 'PI3_PI4_kinase', NULL, NULL, 4860, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(263245, NULL, 'PF20326', NULL, NULL, 'Family of unknown function (DUF6621)', NULL, 'DUF6621', NULL, NULL, 37488, 9),
(263246, NULL, 'PF03939', NULL, NULL, 'Ribosomal protein L23, N-terminal domain', NULL, 'Ribosomal_L23eN', NULL, NULL, 2667, 9),
(263247, NULL, 'PF07141', NULL, NULL, 'Putative bacteriophage terminase small subunit', NULL, 'Phage_term_sma', NULL, NULL, 10650, 9),
(263248, NULL, 'PF18223', NULL, NULL, 'Pili PilJ C-terminal domain', NULL, 'PilJ_C', NULL, NULL, 31801, 9),
(263249, NULL, 'PF18909', NULL, NULL, 'dATP/dGTP diphosphohydrolase, N-terminal', NULL, 'dGTP_diPhyd_N', NULL, NULL, 35368, 9),
(263250, NULL, 'PF14504', NULL, NULL, 'CAP-associated N-terminal', NULL, 'CAP_assoc_N', NULL, NULL, 24831, 9),
(263251, NULL, 'PF19153', NULL, NULL, 'Family of unknown function (DUF5835)', NULL, 'DUF5835', NULL, NULL, 34433, 9),
(263252, NULL, 'PF10679', NULL, NULL, 'Protein of unknown function (DUF2491)', NULL, 'DUF2491', NULL, NULL, 20097, 9),
(263253, NULL, 'PF15153', NULL, NULL, 'Cytokine-like protein 1', NULL, 'CYTL1', NULL, NULL, 21578, 9),
(263254, NULL, 'PF18399', NULL, NULL, 'Clip-domain serine protease homolog Scarface', NULL, 'CLIP_SPH_Scar', NULL, NULL, 27942, 9),
(263255, NULL, 'PF02124', NULL, NULL, 'Marek''s disease glycoprotein A', NULL, 'Marek_A', NULL, NULL, 1023, 9),
(263256, NULL, 'PF19717', NULL, NULL, 'Family of unknown function (DUF6212)', NULL, 'DUF6212', NULL, NULL, 37285, 9),
(263257, NULL, 'PF08674', NULL, NULL, 'Acetylcholinesterase tetramerisation domain', NULL, 'AChE_tetra', NULL, NULL, 11311, 9),
(263258, NULL, 'PF03422', NULL, NULL, 'Carbohydrate binding module (family 6)', NULL, 'CBM_6', NULL, NULL, 10191, 9),
(263259, NULL, 'PF18094', NULL, NULL, 'DNA polymerase beta N-terminal domain', NULL, 'DNA_pol_B_N', NULL, NULL, NULL, 9),
(263260, NULL, 'PF03078', NULL, NULL, 'ATHILA ORF-1 family', NULL, 'ATHILA', NULL, NULL, 4853, 9),
(263261, NULL, 'PF06670', NULL, NULL, 'Microneme protein Etmic-2', NULL, 'Etmic-2', NULL, NULL, 10330, 9),
(263262, NULL, 'PF05997', NULL, NULL, 'Nucleolar protein,Nop52', NULL, 'Nop52', NULL, NULL, 7880, 9),
(263263, NULL, 'PF17822', NULL, NULL, 'Armadillo-like helical domain-containing protein 2', NULL, 'ARMH2', NULL, NULL, 27364, 9),
(263264, NULL, 'PF20361', NULL, NULL, 'Family of unknown function (DUF6656)', NULL, 'DUF6656', NULL, NULL, 33977, 9),
(263265, NULL, 'PF02387', NULL, NULL, 'IncFII RepA protein family', NULL, 'IncFII_repA', NULL, NULL, 5052, 9),
(263266, NULL, 'PF09090', NULL, NULL, 'MIF4G like', NULL, 'MIF4G_like_2', NULL, NULL, 10745, 9),
(263267, NULL, 'PF10231', NULL, NULL, 'Cytochrome c oxidase assembly factor 8', NULL, 'COA8', NULL, NULL, 19203, 9),
(263268, NULL, 'PF13662', NULL, NULL, 'Toprim domain', NULL, 'Toprim_4', NULL, NULL, 11269, 9),
(263269, NULL, 'PF00193', NULL, NULL, 'Extracellular link domain', NULL, 'Xlink', NULL, NULL, 5528, 9),
(263270, NULL, 'PF13437', NULL, NULL, 'HlyD family secretion protein', NULL, 'HlyD_3', NULL, NULL, NULL, 9),
(263271, NULL, 'PF01267', NULL, NULL, 'F-actin capping protein alpha subunit', NULL, 'F-actin_cap_A', NULL, NULL, 143, 9),
(263272, NULL, 'PF01706', NULL, NULL, 'FliG C-terminal domain', NULL, 'FliG_C', NULL, NULL, 15931, 9),
(263273, NULL, 'PF20467', NULL, NULL, 'MmeI, C-terminal domain', NULL, 'MmeI_C', NULL, NULL, 33546, 9),
(263274, NULL, 'PF05204', NULL, NULL, 'Homing endonuclease', NULL, 'Hom_end', NULL, NULL, 3286, 9),
(263275, NULL, 'PF13555', NULL, NULL, 'P-loop containing region of AAA domain', NULL, 'AAA_29', NULL, NULL, NULL, 9),
(263276, NULL, 'PF20141', NULL, NULL, 'Brassinosteroid receptor island domain', NULL, 'Island', NULL, NULL, 35575, 9),
(263277, NULL, 'PF20529', NULL, NULL, 'Family of unknown function (DUF6744)', NULL, 'DUF6744', NULL, NULL, 33716, 9),
(263278, NULL, 'PF17620', NULL, NULL, 'Family of unknown function', NULL, 'ORF45', NULL, NULL, 28294, 9),
(263279, NULL, 'PF03220', NULL, NULL, 'Tombusvirus P19 core protein', NULL, 'Tombus_P19', NULL, NULL, 1562, 9),
(263280, NULL, 'PF04212', NULL, NULL, 'MIT (microtubule interacting and transport) domain', NULL, 'MIT', NULL, NULL, 5229, 9); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(263281, NULL, 'PF11362', NULL, NULL, 'Protein of unknown function (DUF3161)', NULL, 'DUF3161', NULL, NULL, NULL, 9),
(263282, NULL, 'PF01375', NULL, NULL, 'Heat-labile enterotoxin alpha chain', NULL, 'Enterotoxin_a', NULL, NULL, 2338, 9),
(263283, NULL, 'PF06936', NULL, NULL, 'Selenoprotein S (SelS)', NULL, 'Selenoprotein_S', NULL, NULL, 11918, 9),
(263284, NULL, 'PF02045', NULL, NULL, 'CCAAT-binding transcription factor (CBF-B/NF-YA) subunit B', NULL, 'CBFB_NFYA', NULL, NULL, 2064, 9),
(263285, NULL, 'PF18549', NULL, NULL, 'Nitrosopumilus output domain 1', NULL, 'NitrOD1', NULL, NULL, 28839, 9),
(263286, NULL, 'PF15127', NULL, NULL, 'Small membrane A-kinase anchor protein', NULL, 'SmAKAP', NULL, NULL, 24029, 9),
(263287, NULL, 'PF20613', NULL, NULL, 'HipA-like kinase', NULL, 'HipA_2', NULL, NULL, 34231, 9),
(263288, NULL, 'PF08505', NULL, NULL, 'Mitochondrial Myo2 receptor-related protein', NULL, 'MMR1', NULL, NULL, 13844, 9),
(263289, NULL, 'PF12121', NULL, NULL, 'Dermaseptin', NULL, 'DD_K', NULL, NULL, 16827, 9),
(263290, NULL, 'PF20152', NULL, NULL, 'Family of unknown function (DUF6534)', NULL, 'DUF6534', NULL, NULL, 37442, 9),
(263291, NULL, 'PF03486', NULL, NULL, 'HI0933-like protein', NULL, 'HI0933_like', NULL, NULL, NULL, 9),
(263292, NULL, 'PF04752', NULL, NULL, 'ChaC-like protein', NULL, 'ChaC', NULL, NULL, 3878, 9),
(263293, NULL, 'PF09725', NULL, NULL, 'Folate-sensitive fragile site protein Fra10Ac1', NULL, 'Fra10Ac1', NULL, NULL, 17509, 9),
(263294, NULL, 'PF19288', NULL, NULL, 'CofH/MqnC C-terminal region', NULL, 'CofH_C', NULL, NULL, 36423, 9),
(263295, NULL, 'PF04671', NULL, NULL, 'Erythrocyte membrane-associated giant protein antigen 332', NULL, 'Ag332', NULL, NULL, 3018, 9),
(263296, NULL, 'PF04969', NULL, NULL, 'CS domain', NULL, 'CS', NULL, NULL, 6502, 9),
(263297, NULL, 'PF01829', NULL, NULL, 'Peptidase A6 family', NULL, 'Peptidase_A6', NULL, NULL, 6644, 9),
(263298, NULL, 'PF09442', NULL, NULL, 'Domain of unknown function (DUF2018)', NULL, 'DUF2018', NULL, NULL, 15123, 9),
(263299, NULL, 'PF12025', NULL, NULL, 'Phage protein C', NULL, 'Phage_C', NULL, NULL, 21111, 9),
(263300, NULL, 'PF14860', NULL, NULL, 'DrrA phosphatidylinositol 4-phosphate binding domain', NULL, 'DrrA_P4M', NULL, NULL, 25050, 9),
(263301, NULL, 'PF03886', NULL, NULL, 'ABC-type transport auxiliary lipoprotein component', NULL, 'ABC_trans_aux', NULL, NULL, 1844, 9),
(263302, NULL, 'PF18246', NULL, NULL, 'Oligosaccharyltransferase Insert domain', NULL, 'OST_IS', NULL, NULL, 29621, 9),
(263303, NULL, 'PF01885', NULL, NULL, 'RNA 2''-phosphotransferase, Tpt1 / KptA family', NULL, 'PTS_2-RNA', NULL, NULL, 3912, 9),
(263304, NULL, 'PF09443', NULL, NULL, 'Cripto_Frl-1_Cryptic (CFC)', NULL, 'CFC', NULL, NULL, 15831, 9),
(263305, NULL, 'PF19034', NULL, NULL, 'RNase LS, bacterial toxin DBD domain', NULL, 'RnlA-toxin_DBD', NULL, NULL, 37188, 9),
(263306, NULL, 'PF04405', NULL, NULL, 'Domain of Unknown function (DUF542)', NULL, 'ScdA_N', NULL, NULL, 11726, 9),
(263307, NULL, 'PF08218', NULL, NULL, 'Citrate lyase ligase C-terminal domain', NULL, 'Citrate_ly_lig', NULL, NULL, 8850, 9),
(263308, NULL, 'PF17780', NULL, NULL, 'OCRE domain', NULL, 'OCRE', NULL, NULL, 30121, 9),
(263309, NULL, 'PF10039', NULL, NULL, 'Predicted integral membrane protein (DUF2275)', NULL, 'DUF2275', NULL, NULL, 18162, 9),
(263310, NULL, 'PF17722', NULL, NULL, 'Intraflagellar transport-associated protein', NULL, 'IFTAP', NULL, NULL, 27346, 9),
(263311, NULL, 'PF03134', NULL, NULL, 'TB2/DP1, HVA22 family', NULL, 'TB2_DP1_HVA22', NULL, NULL, 5147, 9),
(263312, NULL, 'PF16478', NULL, NULL, 'Domain of unknown function (DUF5055)', NULL, 'DUF5055', NULL, NULL, 18202, 9),
(263313, NULL, 'PF19369', NULL, NULL, 'Family of unknown function (DUF5944)', NULL, 'DUF5944', NULL, NULL, 36765, 9),
(263314, NULL, 'PF05582', NULL, NULL, 'YabG peptidase U57', NULL, 'Peptidase_U57', NULL, NULL, 12124, 9),
(263315, NULL, 'PF03197', NULL, NULL, 'Bacteriophage FRD2 protein', NULL, 'FRD2', NULL, NULL, 159, 9),
(263316, NULL, 'PF16573', NULL, NULL, 'N-terminal beta-sandwich domain of polyadenylation factor', NULL, 'CLP1_N', NULL, NULL, 25055, 9); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(263317, NULL, 'PF13342', NULL, NULL, 'C-terminal repeat of topoisomerase', NULL, 'Toprim_Crpt', NULL, NULL, 24718, 9),
(263318, NULL, 'PF10142', NULL, NULL, 'PhoPQ-activated pathogenicity-related protein', NULL, 'PhoPQ_related', NULL, NULL, 9989, 9),
(263319, NULL, 'PF15394', NULL, NULL, 'Domain of unknown function (DUF4616)', NULL, 'DUF4616', NULL, NULL, 24804, 9),
(263320, NULL, 'PF18122', NULL, NULL, 'Anaphase-promoting complex sub unit 1 C-terminal domain', NULL, 'APC1_C', NULL, NULL, 29244, 9),
(263321, NULL, 'PF12611', NULL, NULL, 'Putative flagellar', NULL, 'Flagellar_put', NULL, NULL, 18955, 9),
(263322, NULL, 'PF08151', NULL, NULL, 'FerI (NUC094) domain', NULL, 'FerI', NULL, NULL, 11776, 9),
(263323, NULL, 'PF01916', NULL, NULL, 'Deoxyhypusine synthase', NULL, 'DS', NULL, NULL, 4674, 9),
(263324, NULL, 'PF20482', NULL, NULL, 'Family of unknown function (DUF6722)', NULL, 'DUF6722', NULL, NULL, 33670, 9),
(263325, NULL, 'PF16882', NULL, NULL, 'Domain of unknown function (DUF5079)', NULL, 'DUF5079', NULL, NULL, 24382, 9),
(263326, NULL, 'PF05067', NULL, NULL, 'Manganese containing catalase', NULL, 'Mn_catalase', NULL, NULL, 1001, 9),
(263327, NULL, 'PF09707', NULL, NULL, 'CRISPR-associated protein (Cas_Cas2CT1978)', NULL, 'Cas_Cas2CT1978', NULL, NULL, 10992, 9),
(263328, NULL, 'PF15638', NULL, NULL, 'Metallopeptidase toxin 2', NULL, 'Tox-MPTase2', NULL, NULL, 25018, 9),
(263329, NULL, 'PF12960', NULL, NULL, 'Protein of unknown function (DUF3849)', NULL, 'DUF3849', NULL, NULL, 23256, 9),
(263330, NULL, 'PF18975', NULL, NULL, 'Family of unknown function (DUF5711)', NULL, 'DUF5711', NULL, NULL, 35255, 9),
(263331, NULL, 'PF06049', NULL, NULL, 'Coagulation Factor V LSPD Repeat', NULL, 'LSPR', NULL, NULL, 13958, 9),
(263332, NULL, 'PF13822', NULL, NULL, 'Acyl-CoA carboxylase epsilon subunit', NULL, 'ACC_epsilon', NULL, NULL, 26738, 9),
(263333, NULL, 'PF19896', NULL, NULL, 'Family of unknown function (DUF6369)', NULL, 'DUF6369', NULL, NULL, 36933, 9),
(263334, NULL, 'PF10181', NULL, NULL, 'GPI-GlcNAc transferase complex, PIG-H component', NULL, 'PIG-H', NULL, NULL, 14686, 9),
(263335, NULL, 'PF13236', NULL, NULL, 'Clustered mitochondria', NULL, 'CLU', NULL, NULL, 22615, 9),
(263336, NULL, 'PF04135', NULL, NULL, 'Nucleolar RNA-binding protein, Nop10p family', NULL, 'Nop10p', NULL, NULL, 6821, 9),
(263337, NULL, 'PF12007', NULL, NULL, 'Protein of unknown function (DUF3501)', NULL, 'DUF3501', NULL, NULL, 19754, 9),
(263338, NULL, 'PF17160', NULL, NULL, 'Domain of unknown function (DUF5124)', NULL, 'DUF5124', NULL, NULL, 31123, 9),
(263339, NULL, 'PF20274', NULL, NULL, 'Cyclic-phosphate processing Receiver domain', NULL, 'cREC_REC', NULL, NULL, 33858, 9),
(263340, NULL, 'PF04733', NULL, NULL, 'Coatomer epsilon subunit', NULL, 'Coatomer_E', NULL, NULL, NULL, 9),
(263341, NULL, 'PF03096', NULL, NULL, 'Ndr family', NULL, 'Ndr', NULL, NULL, 2615, 9),
(263342, NULL, 'PF05523', NULL, NULL, 'WxcM-like, C-terminal', NULL, 'FdtA', NULL, NULL, 7515, 9),
(263343, NULL, 'PF05472', NULL, NULL, 'DNA replication terminus site-binding protein (Ter protein)', NULL, 'Ter', NULL, NULL, 7866, 9),
(263344, NULL, 'PF18188', NULL, NULL, 'Prim-pol 4', NULL, 'PPL4', NULL, NULL, 27017, 9),
(263345, NULL, 'PF09691', NULL, NULL, 'Type II secretion system pilotin lipoprotein (PulS_OutS)', NULL, 'T2SS_PulS_OutS', NULL, NULL, 17634, 9),
(263346, NULL, 'PF13799', NULL, NULL, 'Domain of unknown function (DUF4183)', NULL, 'DUF4183', NULL, NULL, 23032, 9),
(263347, NULL, 'PF17988', NULL, NULL, 'VEGFR-2 Transmembrane domain', NULL, 'VEGFR-2_TMD', NULL, NULL, 29482, 9),
(263348, NULL, 'PF01171', NULL, NULL, 'PP-loop family', NULL, 'ATP_bind_3', NULL, NULL, 10130, 9),
(263349, NULL, 'PF14348', NULL, NULL, 'Domain of unknown function (DUF4400)', NULL, 'DUF4400', NULL, NULL, 15786, 9),
(263350, NULL, 'PF02075', NULL, NULL, 'Crossover junction endodeoxyribonuclease RuvC', NULL, 'RuvC', NULL, NULL, 5021, 9),
(263351, NULL, 'PF04533', NULL, NULL, 'Herpes virus U44 protein', NULL, 'Herpes_U44', NULL, NULL, 2569, 9),
(263352, NULL, 'PF17047', NULL, NULL, 'Synaptotagmin-like mitochondrial-lipid-binding domain', NULL, 'SMP_LBD', NULL, NULL, 32383, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(263353, NULL, 'PF07024', NULL, NULL, 'ImpE protein', NULL, 'ImpE', NULL, NULL, 10352, 9),
(263354, NULL, 'PF13870', NULL, NULL, 'Domain of unknown function (DUF4201)', NULL, 'DUF4201', NULL, NULL, 23277, 9),
(263355, NULL, 'PF03202', NULL, NULL, 'Putative mycoplasma lipoprotein, C-terminal region', NULL, 'Lipoprotein_10', NULL, NULL, 310, 9),
(263356, NULL, 'PF14019', NULL, NULL, 'Protein of unknown function (DUF4235)', NULL, 'DUF4235', NULL, NULL, 22003, 9),
(263357, NULL, 'PF02723', NULL, NULL, 'Coronavirus small envelope protein E', NULL, 'CoV_E', NULL, NULL, 4239, 9),
(263358, NULL, 'PF12692', NULL, NULL, 'S-adenosyl-L-methionine methyltransferase', NULL, 'Methyltransf_17', NULL, NULL, 24936, 9),
(263359, NULL, 'PF03066', NULL, NULL, 'Nucleoplasmin/nucleophosmin domain', NULL, 'Nucleoplasmin', NULL, NULL, 12359, 9),
(263360, NULL, 'PF16159', NULL, NULL, 'FOXP coiled-coil domain', NULL, 'FOXP-CC', NULL, NULL, 24188, 9),
(263361, NULL, 'PF03621', NULL, NULL, 'MbtH-like protein', NULL, 'MbtH', NULL, NULL, 4081, 9),
(263362, NULL, 'PF04002', NULL, NULL, 'RadC-like JAB domain', NULL, 'RadC', NULL, NULL, 23757, 9),
(263363, NULL, 'PF19410', NULL, NULL, 'Family of unknown function (DUF5980)', NULL, 'DUF5980', NULL, NULL, 36851, 9),
(263364, NULL, 'PF05379', NULL, NULL, 'Carlavirus endopeptidase', NULL, 'Peptidase_C23', NULL, NULL, 5251, 9),
(263365, NULL, 'PF19362', NULL, NULL, 'Family of unknown function (DUF5938)', NULL, 'DUF5938', NULL, NULL, 36564, 9),
(263366, NULL, 'PF14154', NULL, NULL, 'Domain of unknown function (DUF4306)', NULL, 'DUF4306', NULL, NULL, 26181, 9),
(263367, NULL, 'PF08678', NULL, NULL, 'Rsbr N terminal', NULL, 'Rsbr_N', NULL, NULL, 11339, 9),
(263368, NULL, 'PF04367', NULL, NULL, 'Protein of unknown function (DUF502)', NULL, 'DUF502', NULL, NULL, 4739, 9),
(263369, NULL, 'PF10902', NULL, NULL, 'WYL_2, Sm-like SH3 beta-barrel fold', NULL, 'WYL_2', NULL, NULL, 22036, 9),
(263370, NULL, 'PF19207', NULL, NULL, 'Family of unknown function (DUF5879)', NULL, 'DUF5879', NULL, NULL, 34962, 9),
(263371, NULL, 'PF02017', NULL, NULL, 'CIDE-N domain', NULL, 'CIDE-N', NULL, NULL, 6264, 9),
(263372, NULL, 'PF14407', NULL, NULL, 'Ribosomally synthesized peptide prototyped by Frankia Franean1_4349.', NULL, 'Frankia_peptide', NULL, NULL, 26547, 9),
(263373, NULL, 'PF19403', NULL, NULL, 'Prealbumin-like fold domain', NULL, 'SpaA_2', NULL, NULL, 36170, 9),
(263374, NULL, 'PF17644', NULL, NULL, 'Core domain of 30K viral movement proteins', NULL, '30K_MP_core', NULL, NULL, 29176, 9),
(263375, NULL, 'PF12917', NULL, NULL, '5''-deoxynucleotidase YfbR-like', NULL, 'YfbR-like', NULL, NULL, NULL, 9),
(263376, NULL, 'PF07258', NULL, NULL, 'COMM domain', NULL, 'COMM_domain', NULL, NULL, 2800, 9),
(263377, NULL, 'PF09108', NULL, NULL, 'Switch protein XOL-1, N-terminal', NULL, 'Xol-1_N', NULL, NULL, 10606, 9),
(263378, NULL, 'PF06507', NULL, NULL, 'Auxin response factor', NULL, 'Auxin_resp', NULL, NULL, 12360, 9),
(263379, NULL, 'PF20521', NULL, NULL, 'Family of unknown function (DUF6736)', NULL, 'DUF6736', NULL, NULL, 33578, 9),
(263380, NULL, 'PF12757', NULL, NULL, 'Eisosome protein 1', NULL, 'Eisosome1', NULL, NULL, 24572, 9),
(263381, NULL, 'PF13535', NULL, NULL, 'ATP-grasp domain', NULL, 'ATP-grasp_4', NULL, NULL, NULL, 9),
(263382, NULL, 'PF03372', NULL, NULL, 'Endonuclease/Exonuclease/phosphatase family', NULL, 'Exo_endo_phos', NULL, NULL, 7323, 9),
(263383, NULL, 'PF10191', NULL, NULL, 'Golgi complex component 7 (COG7)', NULL, 'COG7', NULL, NULL, 14671, 9),
(263384, NULL, 'PF09374', NULL, NULL, 'Predicted Peptidoglycan domain', NULL, 'PG_binding_3', NULL, NULL, 14684, 9),
(263385, NULL, 'PF11080', NULL, NULL, 'Endoribonuclease GhoS', NULL, 'GhoS', NULL, NULL, 16941, 9),
(263386, NULL, 'PF09303', NULL, NULL, 'KCNMB2, ball and chain domain', NULL, 'KcnmB2_inactiv', NULL, NULL, 14256, 9),
(263387, NULL, 'PF03098', NULL, NULL, 'Animal haem peroxidase', NULL, 'An_peroxidase', NULL, NULL, 17272, 9),
(263388, NULL, 'PF18419', NULL, NULL, 'ATP-grasp-like domain', NULL, 'ATP-grasp_6', NULL, NULL, 27650, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(263389, NULL, 'PF03090', NULL, NULL, 'Replicase family', NULL, 'Replicase', NULL, NULL, 4973, 9),
(263390, NULL, 'PF02990', NULL, NULL, 'Endomembrane protein 70', NULL, 'EMP70', NULL, NULL, 3822, 9),
(263391, NULL, 'PF10650', NULL, NULL, 'Putative zinc-finger domain', NULL, 'zf-C3H1', NULL, NULL, 20331, 9),
(263392, NULL, 'PF19238', NULL, NULL, 'Radical SAM-like domain', NULL, 'Radical_SAM_2', NULL, NULL, 37062, 9),
(263393, NULL, 'PF13081', NULL, NULL, 'Domain of unknown function (DUF3941)', NULL, 'DUF3941', NULL, NULL, 22559, 9),
(263394, NULL, 'PF01133', NULL, NULL, 'Enhancer of rudimentary', NULL, 'ER', NULL, NULL, 6842, 9),
(263395, NULL, 'PF07775', NULL, NULL, 'PaRep2b protein', NULL, 'PaRep2b', NULL, NULL, 10637, 9),
(263396, NULL, 'PF16507', NULL, NULL, 'Proteasome-substrate-size regulator, mid region', NULL, 'BLM10_mid', NULL, NULL, 25085, 9),
(263397, NULL, 'PF00194', NULL, NULL, 'Eukaryotic-type carbonic anhydrase', NULL, 'Carb_anhydrase', NULL, NULL, 2404, 9),
(263398, NULL, 'PF02649', NULL, NULL, 'Type I GTP cyclohydrolase folE2', NULL, 'GCHY-1', NULL, NULL, 3453, 9),
(263399, NULL, 'PF06149', NULL, NULL, 'Protein of unknown function (DUF969)', NULL, 'DUF969', NULL, NULL, 9330, 9),
(263400, NULL, 'PF03084', NULL, NULL, 'Reoviral Sigma1/Sigma2 family', NULL, 'Sigma_1_2', NULL, NULL, 4779, 9),
(263401, NULL, 'PF02970', NULL, NULL, 'Tubulin binding cofactor A', NULL, 'TBCA', NULL, NULL, 3984, 9),
(263402, NULL, 'PF19387', NULL, NULL, 'Family of unknown function (DUF5962)', NULL, 'DUF5962', NULL, NULL, 36538, 9),
(263403, NULL, 'PF17342', NULL, NULL, 'Family of unknown function (DUF5372)', NULL, 'DUF5372', NULL, NULL, 32590, 9),
(263404, NULL, 'PF14670', NULL, NULL, 'Coagulation Factor Xa inhibitory site', NULL, 'FXa_inhibition', NULL, NULL, NULL, 9),
(263405, NULL, 'PF07398', NULL, NULL, 'MDMPI C-terminal domain', NULL, 'MDMPI_C', NULL, NULL, 11847, 9),
(263406, NULL, 'PF14838', NULL, NULL, 'Integrator complex subunit 5 C-terminus', NULL, 'INTS5_C', NULL, NULL, 26913, 9),
(263407, NULL, 'PF16786', NULL, NULL, 'Recombination enhancement, RecA-dependent nuclease', NULL, 'RecA_dep_nuc', NULL, NULL, 26936, 9),
(263408, NULL, 'PF05137', NULL, NULL, 'Fimbrial assembly protein (PilN)', NULL, 'PilN', NULL, NULL, 2234, 9),
(263409, NULL, 'PF08540', NULL, NULL, 'Hydroxymethylglutaryl-coenzyme A synthase C terminal', NULL, 'HMG_CoA_synt_C', NULL, NULL, 7608, 9),
(263410, NULL, 'PF07789', NULL, NULL, 'Protein of unknown function (DUF1627)', NULL, 'DUF1627', NULL, NULL, 13107, 9),
(263411, NULL, 'PF06076', NULL, NULL, 'Orthopoxvirus F14 protein', NULL, 'Orthopox_F14', NULL, NULL, 13594, 9),
(263412, NULL, 'PF02507', NULL, NULL, 'Photosystem I reaction centre subunit III', NULL, 'PSI_PsaF', NULL, NULL, 1272, 9),
(263413, NULL, 'PF00168', NULL, NULL, 'C2 domain', NULL, 'C2', NULL, NULL, 2719, 9),
(263414, NULL, 'PF12929', NULL, NULL, 'Stretch-activated Ca2+-permeable channel component', NULL, 'Mid1', NULL, NULL, 24779, 9),
(263415, NULL, 'PF03209', NULL, NULL, 'PUCC protein', NULL, 'PUCC', NULL, NULL, 423, 9),
(263416, NULL, 'PF11528', NULL, NULL, 'Protein of unknown function (DUF3224)', NULL, 'DUF3224', NULL, NULL, 18538, 9),
(263417, NULL, 'PF18166', NULL, NULL, 'Predicted pPIWI-associating nuclease', NULL, 'pP_pnuc_2', NULL, NULL, 30108, 9),
(263418, NULL, 'PF19620', NULL, NULL, 'Family of unknown function (DUF6125)', NULL, 'DUF6125', NULL, NULL, NULL, 9),
(263419, NULL, 'PF04143', NULL, NULL, 'Sulphur transport', NULL, 'Sulf_transp', NULL, NULL, 7315, 9),
(263420, NULL, 'PF12300', NULL, NULL, 'ATP-dependent RNA helicase RhlB', NULL, 'RhlB', NULL, NULL, 20984, 9),
(263421, NULL, 'PF02748', NULL, NULL, 'Aspartate carbamoyltransferase regulatory chain, metal binding domain', NULL, 'PyrI_C', NULL, NULL, 20872, 9),
(263422, NULL, 'PF13140', NULL, NULL, 'Domain of unknown function (DUF3980)', NULL, 'DUF3980', NULL, NULL, 22315, 9),
(263423, NULL, 'PF15194', NULL, NULL, 'TMEM191C family', NULL, 'TMEM191C', NULL, NULL, 21900, 9),
(263424, NULL, 'PF18967', NULL, NULL, 'Family of unknown function (DUF5706)', NULL, 'DUF5706', NULL, NULL, 35258, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(263425, NULL, 'PF04422', NULL, NULL, 'Coenzyme F420 hydrogenase/dehydrogenase, beta subunit N-term', NULL, 'FrhB_FdhB_N', NULL, NULL, 10805, 9),
(263426, NULL, 'PF12259', NULL, NULL, 'Baculovirus F protein', NULL, 'Baculo_F', NULL, NULL, 20028, 9),
(263427, NULL, 'PF18338', NULL, NULL, 'Lower baseplate protein N-terminal domain', NULL, 'BppL_N', NULL, NULL, 28732, 9),
(263428, NULL, 'PF13422', NULL, NULL, 'Domain of unknown function (DUF4110)', NULL, 'DUF4110', NULL, NULL, 22877, 9),
(263429, NULL, 'PF06386', NULL, NULL, 'Gas vesicle synthesis protein GvpL/GvpF', NULL, 'GvpL_GvpF', NULL, NULL, 8150, 9),
(263430, NULL, 'PF12992', NULL, NULL, 'Domain of unknown function, B. Theta Gene description (DUF3876)', NULL, 'DUF3876', NULL, NULL, 24052, 9),
(263431, NULL, 'PF06313', NULL, NULL, 'Drosophila ACP53EA protein', NULL, 'ACP53EA', NULL, NULL, 8479, 9),
(263432, NULL, 'PF15312', NULL, NULL, 'Junctional sarcoplasmic reticulum protein', NULL, 'JSRP', NULL, NULL, 25094, 9),
(263433, NULL, 'PF14220', NULL, NULL, 'Domain of unknown function (DUF4329)', NULL, 'DUF4329', NULL, NULL, 26055, 9),
(263434, NULL, 'PF15485', NULL, NULL, 'Domain of unknown function (DUF4643)', NULL, 'DUF4643', NULL, NULL, 23783, 9),
(263435, NULL, 'PF17152', NULL, NULL, 'Periplasmic sensor domain', NULL, 'CHASE8', NULL, NULL, 29394, 9),
(263436, NULL, 'PF11421', NULL, NULL, 'ATP synthase F1 beta subunit', NULL, 'Synthase_beta', NULL, NULL, 14860, 9),
(263437, NULL, 'PF04509', NULL, NULL, 'CheC-like family', NULL, 'CheC', NULL, NULL, 2669, 9),
(263438, NULL, 'PF16302', NULL, NULL, 'Domain of unknown function (DUF4944)', NULL, 'DUF4944', NULL, NULL, 25730, 9),
(263439, NULL, 'PF19096', NULL, NULL, 'Family of unknown function (DUF5784)', NULL, 'DUF5784', NULL, NULL, 35461, 9),
(263440, NULL, 'PF06355', NULL, NULL, 'Aegerolysin', NULL, 'Aegerolysin', NULL, NULL, 8336, 9),
(263441, NULL, 'PF12555', NULL, NULL, 'Thiamine pyrophosphokinase C terminal', NULL, 'TPPK_C', NULL, NULL, 21136, 9),
(263442, NULL, 'PF05938', NULL, NULL, 'Plant self-incompatibility protein S1', NULL, 'Self-incomp_S1', NULL, NULL, 7674, 9),
(263443, NULL, 'PF01019', NULL, NULL, 'Gamma-glutamyltranspeptidase', NULL, 'G_glu_transpept', NULL, NULL, NULL, 9),
(263444, NULL, 'PF07728', NULL, NULL, 'AAA domain (dynein-related subfamily)', NULL, 'AAA_5', NULL, NULL, 8030, 9),
(263445, NULL, 'PF06173', NULL, NULL, 'Protein of unknown function (DUF986)', NULL, 'DUF986', NULL, NULL, 14342, 9),
(263446, NULL, 'PF11615', NULL, NULL, 'CCR4-associated factor 4', NULL, 'Caf4', NULL, NULL, 18537, 9),
(263447, NULL, 'PF02707', NULL, NULL, 'Major Outer Sheath Protein N-terminal region', NULL, 'MOSP_N', NULL, NULL, 3170, 9),
(263448, NULL, 'PF10755', NULL, NULL, 'Protein of unknown function (DUF2585)', NULL, 'DUF2585', NULL, NULL, 20232, 9),
(263449, NULL, 'PF02275', NULL, NULL, 'Linear amide C-N hydrolases, choloylglycine hydrolase family', NULL, 'CBAH', NULL, NULL, 23926, 9),
(263450, NULL, 'PF08426', NULL, NULL, 'ICE2', NULL, 'ICE2', NULL, NULL, 11343, 9),
(263451, NULL, 'PF02734', NULL, NULL, 'DAK2 domain', NULL, 'Dak2', NULL, NULL, 979, 9),
(263452, NULL, 'PF19559', NULL, NULL, 'Family of unknown function (DUF6081)', NULL, 'DUF6081', NULL, NULL, 34038, 9),
(263453, NULL, 'PF09324', NULL, NULL, 'Domain of unknown function (DUF1981)', NULL, 'DUF1981', NULL, NULL, 14243, 9),
(263454, NULL, 'PF17891', NULL, NULL, 'Mu-like prophage FluMu N-terminal domain', NULL, 'FluMu_N', NULL, NULL, 30026, 9),
(263455, NULL, 'PF01142', NULL, NULL, 'tRNA pseudouridine synthase D (TruD)', NULL, 'TruD', NULL, NULL, 3207, 9),
(263456, NULL, 'PF12351', NULL, NULL, 'Ca2+ regulator and membrane fusion protein Fig1', NULL, 'Fig1', NULL, NULL, 29695, 9),
(263457, NULL, 'PF01765', NULL, NULL, 'Ribosome recycling factor', NULL, 'RRF', NULL, NULL, 14604, 9),
(263458, NULL, 'PF09407', NULL, NULL, 'AbiEi antitoxin C-terminal domain', NULL, 'AbiEi_1', NULL, NULL, 15012, 9),
(263459, NULL, 'PF11354', NULL, NULL, 'Protein of unknown function (DUF3156)', NULL, 'DUF3156', NULL, NULL, 18939, 9),
(263460, NULL, 'PF14141', NULL, NULL, 'YqzM-like protein', NULL, 'YqzM', NULL, NULL, 26129, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(263461, NULL, 'PF14858', NULL, NULL, 'Cilia- and flagella-associated protein 54', NULL, 'CFAP54_N', NULL, NULL, 23116, 9),
(263462, NULL, 'PF18180', NULL, NULL, 'SLOG cluster3 family', NULL, 'LD_cluster3', NULL, NULL, 28871, 9),
(263463, NULL, 'PF03478', NULL, NULL, 'Protein of unknown function (DUF295)', NULL, 'DUF295', NULL, NULL, 5296, 9),
(263464, NULL, 'PF14785', NULL, NULL, 'Maltose transport system permease protein MalF P2 domain', NULL, 'MalF_P2', NULL, NULL, 21712, 9),
(263465, NULL, 'PF19925', NULL, NULL, 'Family of unknown function (DUF6388)', NULL, 'DUF6388', NULL, NULL, 36008, 9),
(263466, NULL, 'PF20073', NULL, NULL, 'Domain of unknown function (DUF6469)', NULL, 'DUF6469', NULL, NULL, 35717, 9),
(263467, NULL, 'PF10593', NULL, NULL, 'Z1 domain', NULL, 'Z1', NULL, NULL, 8043, 9),
(263468, NULL, 'PF12852', NULL, NULL, 'Cupin', NULL, 'Cupin_6', NULL, NULL, 21738, 9),
(263469, NULL, 'PF19248', NULL, NULL, 'Family of unknown function (DUF5896)', NULL, 'DUF5896', NULL, NULL, 35886, 9),
(263470, NULL, 'PF01610', NULL, NULL, 'Transposase', NULL, 'DDE_Tnp_ISL3', NULL, NULL, 1633, 9),
(263471, NULL, 'PF13299', NULL, NULL, 'Cleavage and polyadenylation factor 2 C-terminal', NULL, 'CPSF100_C', NULL, NULL, 22162, 9),
(263472, NULL, 'PF01086', NULL, NULL, 'Clathrin light chain', NULL, 'Clathrin_lg_ch', NULL, NULL, 3001, 9),
(263473, NULL, 'PF01180', NULL, NULL, 'Dihydroorotate dehydrogenase', NULL, 'DHO_dh', NULL, NULL, 4512, 9),
(263474, NULL, 'PF16217', NULL, NULL, 'Peptidase M64 N-terminus', NULL, 'M64_N', NULL, NULL, 26292, 9),
(263475, NULL, 'PF17703', NULL, NULL, 'Family of unknown function (DUF5549)', NULL, 'DUF5549', NULL, NULL, 31910, 9),
(263476, NULL, 'PF10451', NULL, NULL, 'Telomere regulation protein Stn1', NULL, 'Stn1', NULL, NULL, 20924, 9),
(263477, NULL, 'PF16104', NULL, NULL, 'Formyl peptide receptor-like 1 inhibitory protein', NULL, 'FPRL1_inhibitor', NULL, NULL, 18960, 9),
(263478, NULL, 'PF14936', NULL, NULL, 'Tumour protein p53-inducible protein 11', NULL, 'p53-inducible11', NULL, NULL, 26521, 9),
(263479, NULL, 'PF15331', NULL, NULL, 'Cellular tumour antigen p53-inducible 5', NULL, 'TP53IP5', NULL, NULL, 24922, 9),
(263480, NULL, 'PF16279', NULL, NULL, 'Domain of unknown function (DUF4927)', NULL, 'DUF4927', NULL, NULL, 21544, 9),
(263481, NULL, 'PF09788', NULL, NULL, 'Transmembrane protein 55A', NULL, 'Tmemb_55A', NULL, NULL, 18290, 9),
(263482, NULL, 'PF05486', NULL, NULL, 'Signal recognition particle 9 kDa protein (SRP9)', NULL, 'SRP9-21', NULL, NULL, 33494, 9),
(263483, NULL, 'PF09716', NULL, NULL, 'Malarial early transcribed membrane protein (ETRAMP)', NULL, 'ETRAMP', NULL, NULL, 5954, 9),
(263484, NULL, 'PF12414', NULL, NULL, 'Calcitonin gene-related peptide regulator C terminal', NULL, 'Fox-1_C', NULL, NULL, 24297, 9),
(263485, NULL, 'PF19934', NULL, NULL, 'Family of unknown function (DUF6397)', NULL, 'DUF6397', NULL, NULL, 36402, 9),
(263486, NULL, 'PF08734', NULL, NULL, 'GYD domain', NULL, 'GYD', NULL, NULL, 11611, 9),
(263487, NULL, 'PF06481', NULL, NULL, 'COX Aromatic Rich Motif', NULL, 'COX_ARM', NULL, NULL, 12314, 9),
(263488, NULL, 'PF19709', NULL, NULL, 'Family of unknown function (DUF6206)', NULL, 'DUF6206', NULL, NULL, 36102, 9),
(263489, NULL, 'PF07854', NULL, NULL, 'Protein of unknown function (DUF1646)', NULL, 'DUF1646', NULL, NULL, 14111, 9),
(263490, NULL, 'PF06427', NULL, NULL, 'UDP-glucose:Glycoprotein Glucosyltransferase', NULL, 'UDP-g_GGTase', NULL, NULL, 8499, 9),
(263491, NULL, 'PF09687', NULL, NULL, 'Plasmodium RESA N-terminal', NULL, 'PRESAN', NULL, NULL, 17991, 9),
(263492, NULL, 'PF14219', NULL, NULL, 'Domain of unknown function (DUF4328)', NULL, 'DUF4328', NULL, NULL, 23374, 9),
(263493, NULL, 'PF15123', NULL, NULL, 'Domain of unknown function (DUF4562)', NULL, 'DUF4562', NULL, NULL, 21684, 9),
(263494, NULL, 'PF13755', NULL, NULL, 'Sensor N-terminal transmembrane domain', NULL, 'Sensor_TM1', NULL, NULL, 23432, 9),
(263495, NULL, 'PF10805', NULL, NULL, 'Protein of unknown function (DUF2730)', NULL, 'DUF2730', NULL, NULL, 19990, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(263496, NULL, 'PF17837', NULL, NULL, '4''-phosphopantetheinyl transferase N-terminal domain', NULL, '4PPT_N', NULL, NULL, 29353, 9),
(263497, NULL, 'PF12835', NULL, NULL, 'Integrase', NULL, 'Integrase_1', NULL, NULL, 21576, 9),
(263498, NULL, 'PF14894', NULL, NULL, 'Lsm C-terminal', NULL, 'Lsm_C', NULL, NULL, 26865, 9),
(263499, NULL, 'PF02488', NULL, NULL, 'Merozoite Antigen', NULL, 'EMA', NULL, NULL, 5170, 9),
(263500, NULL, 'PF11007', NULL, NULL, 'Spore coat associated protein JA (CotJA)', NULL, 'CotJA', NULL, NULL, 19459, 9),
(263501, NULL, 'PF15893', NULL, NULL, 'Domain of unknown function (DUF4739)', NULL, 'DUF4739', NULL, NULL, 23617, 9),
(263502, NULL, 'PF14369', NULL, NULL, 'zinc-ribbon', NULL, 'zinc_ribbon_9', NULL, NULL, 32842, 9),
(263503, NULL, 'PF19871', NULL, NULL, 'Family of unknown function (DUF6344)', NULL, 'DUF6344', NULL, NULL, 36524, 9),
(263504, NULL, 'PF08587', NULL, NULL, 'Ubiquitin associated domain (UBA)', NULL, 'UBA_2', NULL, NULL, 17562, 9),
(263505, NULL, 'PF14226', NULL, NULL, 'non-haem dioxygenase in morphine synthesis N-terminal', NULL, 'DIOX_N', NULL, NULL, 25627, 9),
(263506, NULL, 'PF14160', NULL, NULL, 'Centrosome-associated C terminus', NULL, 'FAM110_C', NULL, NULL, 25154, 9),
(263507, NULL, 'PF09591', NULL, NULL, 'Protein of unknown function (DUF2463)', NULL, 'DUF2463', NULL, NULL, 16964, 9),
(263508, NULL, 'PF14912', NULL, NULL, 'Testicular haploid expressed repeat', NULL, 'THEG', NULL, NULL, 1237, 9),
(263509, NULL, 'PF05223', NULL, NULL, 'NTF2-like N-terminal transpeptidase domain', NULL, 'MecA_N', NULL, NULL, 3174, 9),
(263510, NULL, 'PF00404', NULL, NULL, 'Dockerin type I domain', NULL, 'Dockerin_1', NULL, NULL, 5420, 9),
(263511, NULL, 'PF16128', NULL, NULL, 'Domain of unknown function (DUF4840)', NULL, 'DUF4840', NULL, NULL, 25007, 9),
(263512, NULL, 'PF06273', NULL, NULL, 'Plant specific eukaryotic initiation factor 4B', NULL, 'eIF-4B', NULL, NULL, 9142, 9),
(263513, NULL, 'PF11393', NULL, NULL, 'Type-IV b secretion system, inner-membrane complex component', NULL, 'T4BSS_DotI_IcmL', NULL, NULL, 15377, 9),
(263514, NULL, 'PF03061', NULL, NULL, 'Thioesterase superfamily', NULL, '4HBT', NULL, NULL, 2424, 9),
(263515, NULL, 'PF18075', NULL, NULL, 'FtsX extracellular domain', NULL, 'FtsX_ECD', NULL, NULL, 28860, 9),
(263516, NULL, 'PF19428', NULL, NULL, 'Semaphorin 4F C-terminal', NULL, 'Sema4F_C', NULL, NULL, 37055, 9),
(263517, NULL, 'PF17457', NULL, NULL, 'Family of unknown function (DUF5420)', NULL, 'DUF5420', NULL, NULL, 14928, 9),
(263518, NULL, 'PF13842', NULL, NULL, 'DDE_Tnp_1-like zinc-ribbon', NULL, 'Tnp_zf-ribbon_2', NULL, NULL, 26520, 9),
(263519, NULL, 'PF10648', NULL, NULL, 'Immunoglobulin-like domain of bacterial spore germination', NULL, 'Gmad2', NULL, NULL, 14689, 9),
(263520, NULL, 'PF05867', NULL, NULL, 'Protein of unknown function (DUF851)', NULL, 'DUF851', NULL, NULL, 13008, 9),
(263521, NULL, 'PF20530', NULL, NULL, 'Domain of unknown function (DUF6745)', NULL, 'DUF6745', NULL, NULL, 33548, 9),
(263522, NULL, 'PF01793', NULL, NULL, 'Glycolipid 2-alpha-mannosyltransferase', NULL, 'Glyco_transf_15', NULL, NULL, 2725, 9),
(263523, NULL, 'PF04321', NULL, NULL, 'RmlD substrate binding domain', NULL, 'RmlD_sub_bind', NULL, NULL, 24653, 9),
(263524, NULL, 'PF14459', NULL, NULL, 'Prokaryotic E2 family C', NULL, 'Prok-E2_C', NULL, NULL, 25497, 9),
(263525, NULL, 'PF04604', NULL, NULL, 'Type-A lantibiotic', NULL, 'L_biotic_typeA', NULL, NULL, 847, 9),
(263526, NULL, 'PF14839', NULL, NULL, 'DOR family', NULL, 'DOR', NULL, NULL, 21663, 9),
(263527, NULL, 'PF19481', NULL, NULL, 'Family of unknown function (DUF6017)', NULL, 'DUF6017', NULL, NULL, 36844, 9),
(263528, NULL, 'PF04419', NULL, NULL, '4F5 protein related disordered region', NULL, '4F5', NULL, NULL, 10644, 9),
(263529, NULL, 'PF12857', NULL, NULL, 'TOBE-like domain', NULL, 'TOBE_3', NULL, NULL, 19493, 9),
(263530, NULL, 'PF16044', NULL, NULL, 'Domain of unknown function (DUF4796)', NULL, 'DUF4796', NULL, NULL, 25861, 9),
(263531, NULL, 'PF06512', NULL, NULL, 'Sodium ion transport-associated', NULL, 'Na_trans_assoc', NULL, NULL, 12475, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(263532, NULL, 'PF04837', NULL, NULL, 'MbeB-like, N-term conserved region', NULL, 'MbeB_N', NULL, NULL, 4935, 9),
(263533, NULL, 'PF10694', NULL, NULL, 'Protein of unknown function (DUF2500)', NULL, 'DUF2500', NULL, NULL, 20675, 9),
(263534, NULL, 'PF08736', NULL, NULL, 'FERM adjacent (FA)', NULL, 'FA', NULL, NULL, 11768, 9),
(263535, NULL, 'PF01084', NULL, NULL, 'Ribosomal protein S18', NULL, 'Ribosomal_S18', NULL, NULL, 5190, 9),
(263536, NULL, 'PF11508', NULL, NULL, 'Protein of unknown function (DUF3218)', NULL, 'DUF3218', NULL, NULL, 18734, 9),
(263537, NULL, 'PF00173', NULL, NULL, 'Cytochrome b5-like Heme/Steroid binding domain', NULL, 'Cyt-b5', NULL, NULL, 1047, 9),
(263538, NULL, 'PF09237', NULL, NULL, 'GAGA factor', NULL, 'GAGA', NULL, NULL, 13397, 9),
(263539, NULL, 'PF03616', NULL, NULL, 'Sodium/glutamate symporter', NULL, 'Glt_symporter', NULL, NULL, 7406, 9),
(263540, NULL, 'PF09082', NULL, NULL, 'Domain of unknown function (DUF1922)', NULL, 'DUF1922', NULL, NULL, 9541, 9),
(263541, NULL, 'PF01271', NULL, NULL, 'Granin (chromogranin or secretogranin)', NULL, 'Granin', NULL, NULL, 4567, 9),
(263542, NULL, 'PF19432', NULL, NULL, 'DNAJ protein RME-8 N-terminal', NULL, 'RME-8_N', NULL, NULL, 34304, 9),
(263543, NULL, 'PF01643', NULL, NULL, 'Acyl-ACP thioesterase', NULL, 'Acyl-ACP_TE', NULL, NULL, 5814, 9),
(263544, NULL, 'PF07800', NULL, NULL, 'Protein of unknown function (DUF1644)', NULL, 'DUF1644', NULL, NULL, 12376, 9),
(263545, NULL, 'PF14115', NULL, NULL, 'YuzL-like protein', NULL, 'YuzL', NULL, NULL, 24022, 9),
(263546, NULL, 'PF06311', NULL, NULL, 'NUMB domain', NULL, 'NumbF', NULL, NULL, 10351, 9),
(263547, NULL, 'PF08305', NULL, NULL, 'NPCBM/NEW2 domain', NULL, 'NPCBM', NULL, NULL, 12077, 9),
(263548, NULL, 'PF14333', NULL, NULL, 'Domain of unknown function (DUF4389)', NULL, 'DUF4389', NULL, NULL, 26461, 9),
(263549, NULL, 'PF00428', NULL, NULL, '60s Acidic ribosomal protein', NULL, 'Ribosomal_60s', NULL, NULL, NULL, 9),
(263550, NULL, 'PF15688', NULL, NULL, 'Nuclear receptor-interacting protein 1 repression 2', NULL, 'NRIP1_repr_2', NULL, NULL, 26170, 9),
(263551, NULL, 'PF09381', NULL, NULL, 'Outer membrane protein G (OmpG)', NULL, 'Porin_OmpG', NULL, NULL, 15703, 9),
(263552, NULL, 'PF11407', NULL, NULL, 'Type II restriction enzyme MunI', NULL, 'RestrictionMunI', NULL, NULL, 16862, 9),
(263553, NULL, 'PF12831', NULL, NULL, 'FAD dependent oxidoreductase', NULL, 'FAD_oxidored', NULL, NULL, NULL, 9),
(263554, NULL, 'PF05059', NULL, NULL, 'Orbivirus VP4 core protein', NULL, 'Orbi_VP4', NULL, NULL, 1328, 9),
(263555, NULL, 'PF01450', NULL, NULL, 'Acetohydroxy acid isomeroreductase, catalytic domain', NULL, 'IlvC', NULL, NULL, 5659, 9),
(263556, NULL, 'PF13227', NULL, NULL, 'Protein of unknown function (DUF4035)', NULL, 'DUF4035', NULL, NULL, 22601, 9),
(263557, NULL, 'PF14445', NULL, NULL, 'Prokaryotic RING finger family 2', NULL, 'Prok-RING_2', NULL, NULL, 25230, 9),
(263558, NULL, 'PF16105', NULL, NULL, 'Domain of unknown function (DUF4823)', NULL, 'DUF4823', NULL, NULL, 22086, 9),
(263559, NULL, 'PF17136', NULL, NULL, 'Ribosomal proteins 50S L24/mitochondrial 39S L24', NULL, 'ribosomal_L24', NULL, NULL, 2995, 9),
(263560, NULL, 'PF16098', NULL, NULL, 'Fragile X-related mental retardation protein C-terminal region 2', NULL, 'FXMR_C2', NULL, NULL, 22329, 9),
(263561, NULL, 'PF09452', NULL, NULL, 'ESCRT-I subunit Mvb12', NULL, 'Mvb12', NULL, NULL, 15549, 9),
(263562, NULL, 'PF17657', NULL, NULL, 'Bacterial DNA polymerase III alpha subunit finger domain', NULL, 'DNA_pol3_finger', NULL, NULL, 28928, 9),
(263563, NULL, 'PF03554', NULL, NULL, 'UL73 viral envelope glycoprotein', NULL, 'Herpes_UL73', NULL, NULL, 6551, 9),
(263564, NULL, 'PF04100', NULL, NULL, 'Vps53-like, N-terminal', NULL, 'Vps53_N', NULL, NULL, 6709, 9),
(263565, NULL, 'PF13005', NULL, NULL, 'zinc-finger binding domain of transposase IS66', NULL, 'zf-IS66', NULL, NULL, 22703, 9),
(263566, NULL, 'PF09131', NULL, NULL, 'Bacillus thuringiensis delta-Endotoxin, middle domain', NULL, 'Endotoxin_mid', NULL, NULL, 10688, 9); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(263567, NULL, 'PF14103', NULL, NULL, 'Domain of unknown function (DUF4276)', NULL, 'DUF4276', NULL, NULL, 22283, 9),
(263568, NULL, 'PF17427', NULL, NULL, 'Phage Single-stranded DNA-binding protein', NULL, 'Phi29_Phage_SSB', NULL, NULL, 28880, 9),
(263569, NULL, 'PF09505', NULL, NULL, 'Dimethylamine methyltransferase (Dimeth_PyL)', NULL, 'Dimeth_Pyl', NULL, NULL, 10092, 9),
(263570, NULL, 'PF09018', NULL, NULL, 'P3 major capsid protein', NULL, 'Phage_Capsid_P3', NULL, NULL, 9728, 9),
(263571, NULL, 'PF19953', NULL, NULL, 'Effector Associated Constant Component 1', NULL, 'EACC1', NULL, NULL, 35962, 9),
(263572, NULL, 'PF17752', NULL, NULL, 'Burkholderia lethal factor 1', NULL, 'BLF1', NULL, NULL, 27754, 9),
(263573, NULL, 'PF00972', NULL, NULL, 'Flavivirus RNA-directed RNA polymerase, fingers and palm domains', NULL, 'Flavi_NS5', NULL, NULL, 3843, 9),
(263574, NULL, 'PF04910', NULL, NULL, 'Transcriptional repressor TCF25', NULL, 'Tcf25', NULL, NULL, 5527, 9),
(263575, NULL, 'PF08105', NULL, NULL, 'Metchnikowin family', NULL, 'Antimicrobial10', NULL, NULL, 12961, 9),
(263576, NULL, 'PF12700', NULL, NULL, 'HlyD family secretion protein', NULL, 'HlyD_2', NULL, NULL, 26834, 9),
(263577, NULL, 'PF00762', NULL, NULL, 'Ferrochelatase', NULL, 'Ferrochelatase', NULL, NULL, 2295, 9),
(263578, NULL, 'PF00051', NULL, NULL, 'Kringle domain', NULL, 'Kringle', NULL, NULL, 1643, 9),
(263579, NULL, 'PF02212', NULL, NULL, 'Dynamin GTPase effector domain', NULL, 'GED', NULL, NULL, 1682, 9),
(263580, NULL, 'PF02889', NULL, NULL, 'Sec63 Brl domain', NULL, 'Sec63', NULL, NULL, 2886, 9),
(263581, NULL, 'PF16488', NULL, NULL, 'Argonaute linker 2 domain', NULL, 'ArgoL2', NULL, NULL, 21597, 9),
(263582, NULL, 'PF06533', NULL, NULL, 'Protein of unknown function (DUF1110)', NULL, 'DUF1110', NULL, NULL, 14327, 9),
(263583, NULL, 'PF12674', NULL, NULL, 'Putative zinc ribbon domain', NULL, 'Zn_ribbon_2', NULL, NULL, 25959, 9),
(263584, NULL, 'PF07542', NULL, NULL, 'ATP12 chaperone protein', NULL, 'ATP12', NULL, NULL, 13982, 9),
(263585, NULL, 'PF12282', NULL, NULL, 'Histidine kinase PdtaS, GAF domain', NULL, 'PdtaS_GAF', NULL, NULL, 20534, 9),
(263586, NULL, 'PF14720', NULL, NULL, 'NiFe/NiFeSe hydrogenase small subunit C-terminal', NULL, 'NiFe_hyd_SSU_C', NULL, NULL, 25651, 9),
(263587, NULL, 'PF08073', NULL, NULL, 'CHDNT (NUC034) domain', NULL, 'CHDNT', NULL, NULL, 11606, 9),
(263588, NULL, 'PF00070', NULL, NULL, 'Pyridine nucleotide-disulphide oxidoreductase', NULL, 'Pyr_redox', NULL, NULL, 27253, 9),
(263589, NULL, 'PF09640', NULL, NULL, 'Domain of unknown function (DUF2027)', NULL, 'DUF2027', NULL, NULL, 15704, 9),
(263590, NULL, 'PF02652', NULL, NULL, 'L-lactate permease', NULL, 'Lactate_perm', NULL, NULL, 3157, 9),
(263591, NULL, 'PF15860', NULL, NULL, 'Domain of unknown function (DUF4728)', NULL, 'DUF4728', NULL, NULL, 25704, 9),
(263592, NULL, 'PF02268', NULL, NULL, 'Transcription initiation factor IIA, gamma subunit, helical domain', NULL, 'TFIIA_gamma_N', NULL, NULL, 14072, 9),
(263593, NULL, 'PF05768', NULL, NULL, 'Glutaredoxin-like domain (DUF836)', NULL, 'Glrx-like', NULL, NULL, 13208, 9),
(263594, NULL, 'PF07296', NULL, NULL, 'TraP protein', NULL, 'TraP', NULL, NULL, 14251, 9),
(263595, NULL, 'PF07317', NULL, NULL, 'Flagellar regulator YcgR, PilZN domain', NULL, 'PilZN', NULL, NULL, 8355, 9),
(263596, NULL, 'PF11993', NULL, NULL, 'Ribosomal S4P (gammaproteobacterial)', NULL, 'Ribosomal_S4Pg', NULL, NULL, 19515, 9),
(263597, NULL, 'PF18510', NULL, NULL, 'Nuclease domain', NULL, 'NUC', NULL, NULL, 33261, 9),
(263598, NULL, 'PF05683', NULL, NULL, 'Fumarase C-terminus', NULL, 'Fumerase_C', NULL, NULL, 2922, 9),
(263599, NULL, 'PF18483', NULL, NULL, 'Bacterial lectin', NULL, 'Bact_lectin', NULL, NULL, NULL, 9),
(263600, NULL, 'PF00543', NULL, NULL, 'Nitrogen regulatory protein P-II', NULL, 'P-II', NULL, NULL, 5890, 9),
(263601, NULL, 'PF20554', NULL, NULL, 'Domain of unknown function (DUF6766)', NULL, 'DUF6766', NULL, NULL, 37490, 9),
(263602, NULL, 'PF09565', NULL, NULL, 'NgoFVII restriction endonuclease', NULL, 'RE_NgoFVII', NULL, NULL, 16889, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(263603, NULL, 'PF17753', NULL, NULL, 'Ig-fold domain', NULL, 'Ig_mannosidase', NULL, NULL, 29853, 9),
(263604, NULL, 'PF19464', NULL, NULL, 'Family of unknown function (DUF6001)', NULL, 'DUF6001', NULL, NULL, 36581, 9),
(263605, NULL, 'PF01412', NULL, NULL, 'Putative GTPase activating protein for Arf', NULL, 'ArfGap', NULL, NULL, 1120, 9),
(263606, NULL, 'PF06882', NULL, NULL, 'Protein of unknown function (DUF1263)', NULL, 'DUF1263', NULL, NULL, 9416, 9),
(263607, NULL, 'PF14126', NULL, NULL, 'Domain of unknown function (DUF4293)', NULL, 'DUF4293', NULL, NULL, 24582, 9),
(263608, NULL, 'PF19791', NULL, NULL, 'Family of unknown function (DUF6275)', NULL, 'DUF6275', NULL, NULL, 37176, 9),
(263609, NULL, 'PF12041', NULL, NULL, 'Transcriptional regulator DELLA protein N terminal', NULL, 'DELLA', NULL, NULL, 19634, 9),
(263610, NULL, 'PF06949', NULL, NULL, 'Protein of unknown function (DUF1292)', NULL, 'DUF1292', NULL, NULL, 12287, 9),
(263611, NULL, 'PF12762', NULL, NULL, 'ISXO2-like transposase domain', NULL, 'DDE_Tnp_IS1595', NULL, NULL, 24178, 9),
(263612, NULL, 'PF08306', NULL, NULL, 'Glycosyl hydrolase family 98', NULL, 'Glyco_hydro_98M', NULL, NULL, 17007, 9),
(263613, NULL, 'PF02608', NULL, NULL, 'ABC transporter substrate-binding protein PnrA-like', NULL, 'Bmp', NULL, NULL, 2073, 9),
(263614, NULL, 'PF20495', NULL, NULL, 'Family of unknown function (DUF6727)', NULL, 'DUF6727', NULL, NULL, 33970, 9),
(263615, NULL, 'PF04829', NULL, NULL, 'Pre-toxin domain with VENN motif', NULL, 'PT-VENN', NULL, NULL, 4818, 9),
(263616, NULL, 'PF07889', NULL, NULL, 'Protein of unknown function (DUF1664)', NULL, 'DUF1664', NULL, NULL, 14351, 9),
(263617, NULL, 'PF11953', NULL, NULL, 'Domain of unknown function (DUF3470)', NULL, 'DUF3470', NULL, NULL, 16302, 9),
(263618, NULL, 'PF12821', NULL, NULL, 'Threonine/Serine exporter, ThrE', NULL, 'ThrE_2', NULL, NULL, 24596, 9),
(263619, NULL, 'PF02115', NULL, NULL, 'RHO protein GDP dissociation inhibitor', NULL, 'Rho_GDI', NULL, NULL, 4782, 9),
(263620, NULL, 'PF17173', NULL, NULL, 'Domain of unknown function (DUF5129)', NULL, 'DUF5129', NULL, NULL, 31494, 9),
(263621, NULL, 'PF07779', NULL, NULL, '10 TM Acyl Transferase domain found in Cas1p', NULL, 'Cas1_AcylT', NULL, NULL, 13408, 9),
(263622, NULL, 'PF08270', NULL, NULL, 'M protein trans-acting positive regulator (MGA) PRD domain', NULL, 'PRD_Mga', NULL, NULL, 12903, 9),
(263623, NULL, 'PF09642', NULL, NULL, 'YonK protein', NULL, 'YonK', NULL, NULL, 15806, 9),
(263624, NULL, 'PF01008', NULL, NULL, 'Initiation factor 2 subunit family', NULL, 'IF-2B', NULL, NULL, 6921, 9),
(263625, NULL, 'PF05702', NULL, NULL, 'Herpesvirus UL49.5 envelope/tegument protein', NULL, 'Herpes_UL49_5', NULL, NULL, 14308, 9),
(263626, NULL, 'PF12195', NULL, NULL, 'Beta barrel domain of bacteriophage endosialidase', NULL, 'End_beta_barrel', NULL, NULL, 26890, 9),
(263627, NULL, 'PF10047', NULL, NULL, 'Protein of unknown function (DUF2281)', NULL, 'DUF2281', NULL, NULL, 18436, 9),
(263628, NULL, 'PF10363', NULL, NULL, 'Required for nuclear transport of RNA pol II C-terminus 1', NULL, 'RTP1_C1', NULL, NULL, 17338, 9),
(263629, NULL, 'PF11213', NULL, NULL, 'Protein of unknown function (DUF3006)', NULL, 'DUF3006', NULL, NULL, 18225, 9),
(263630, NULL, 'PF15049', NULL, NULL, 'Protein of unknown function (DUF4534)', NULL, 'DUF4534', NULL, NULL, 25791, 9),
(263631, NULL, 'PF08783', NULL, NULL, 'DWNN domain', NULL, 'DWNN', NULL, NULL, 13455, 9),
(263632, NULL, 'PF10239', NULL, NULL, 'Protein of unknown function (DUF2465)', NULL, 'DUF2465', NULL, NULL, 19330, 9),
(263633, NULL, 'PF20195', NULL, NULL, 'Family of unknown function (DUF6558)', NULL, 'DUF6558', NULL, NULL, 37149, 9),
(263634, NULL, 'PF01027', NULL, NULL, 'Inhibitor of apoptosis-promoting Bax1', NULL, 'Bax1-I', NULL, NULL, 11199, 9),
(263635, NULL, 'PF11526', NULL, NULL, 'Subunit of cleavage factor IA Pcf11', NULL, 'CFIA_Pcf11', NULL, NULL, 18573, 9),
(263636, NULL, 'PF17053', NULL, NULL, 'Genetic interactor of prohibitin 5', NULL, 'GEP5', NULL, NULL, 26928, 9),
(263637, NULL, 'PF00052', NULL, NULL, 'Laminin B (Domain IV)', NULL, 'Laminin_B', NULL, NULL, 2870, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(263638, NULL, 'PF19535', NULL, NULL, 'Family of unknown function (DUF6060)', NULL, 'DUF6060', NULL, NULL, 37433, 9),
(263639, NULL, 'PF15777', NULL, NULL, 'Tryptophan RNA-binding attenuator protein inhibitory protein', NULL, 'Anti-TRAP', NULL, NULL, 25344, 9),
(263640, NULL, 'PF07057', NULL, NULL, 'DNA helicase TraI', NULL, 'TraI', NULL, NULL, 12535, 9),
(263641, NULL, 'PF14812', NULL, NULL, 'Transmembrane domain of transglycosylase PBP1 at N-terminal', NULL, 'PBP1_TM', NULL, NULL, 26154, 9),
(263642, NULL, 'PF15778', NULL, NULL, 'UNC80 N-terminal', NULL, 'UNC80_N', NULL, NULL, 26398, 9),
(263643, NULL, 'PF12237', NULL, NULL, 'Phosphorylated CTD interacting factor 1 WW domain', NULL, 'PCIF1_WW', NULL, NULL, 20409, 9),
(263644, NULL, 'PF06452', NULL, NULL, 'Carbohydrate family 9 binding domain-like', NULL, 'CBM9_1', NULL, NULL, 10267, 9),
(263645, NULL, 'PF07915', NULL, NULL, 'Glucosidase II beta subunit-like protein', NULL, 'PRKCSH', NULL, NULL, 13286, 9),
(263646, NULL, 'PF08118', NULL, NULL, 'Yeast mitochondrial distribution and morphology (MDM) proteins', NULL, 'MDM31_MDM32', NULL, NULL, 9404, 9),
(263647, NULL, 'PF18342', NULL, NULL, 'Endo-beta-N-acetylglucosaminidase LytB WW domain', NULL, 'LytB_WW', NULL, NULL, 28962, 9),
(263648, NULL, 'PF19951', NULL, NULL, 'Family of unknown function (DUF6413)', NULL, 'DUF6413', NULL, NULL, 33631, 9),
(263649, NULL, 'PF17373', NULL, NULL, 'Family of unknown function (DUF5395)', NULL, 'DUF5395', NULL, NULL, 19930, 9),
(263650, NULL, 'PF16677', NULL, NULL, 'DNA-packaging protein gp3', NULL, 'GP3_package', NULL, NULL, 26078, 9),
(263651, NULL, 'PF02346', NULL, NULL, 'Chordopoxvirus multifunctional envelope protein A27', NULL, 'Vac_Fusion', NULL, NULL, 5316, 9),
(263652, NULL, 'PF17640', NULL, NULL, 'Uncharacterized UL17', NULL, 'UL17', NULL, NULL, 19299, 9),
(263653, NULL, 'PF14852', NULL, NULL, 'Fis1 N-terminal tetratricopeptide repeat', NULL, 'Fis1_TPR_N', NULL, NULL, 25858, 9),
(263654, NULL, 'PF01161', NULL, NULL, 'Phosphatidylethanolamine-binding protein', NULL, 'PBP', NULL, NULL, 7742, 9),
(263655, NULL, 'PF07229', NULL, NULL, 'VirE2', NULL, 'VirE2', NULL, NULL, 14097, 9),
(263656, NULL, 'PF07524', NULL, NULL, 'Bromodomain associated', NULL, 'Bromo_TP', NULL, NULL, 182, 9),
(263657, NULL, 'PF07074', NULL, NULL, 'Translocon-associated protein, gamma subunit (TRAP-gamma)', NULL, 'TRAP-gamma', NULL, NULL, 12815, 9),
(263658, NULL, 'PF00067', NULL, NULL, 'Cytochrome P450', NULL, 'p450', NULL, NULL, 1203, 9),
(263659, NULL, 'PF18892', NULL, NULL, 'Family of unknown function (DUF5651)', NULL, 'DUF5651', NULL, NULL, 34294, 9),
(263660, NULL, 'PF09684', NULL, NULL, 'Phage tail protein (Tail_P2_I)', NULL, 'Tail_P2_I', NULL, NULL, 366, 9),
(263661, NULL, 'PF12086', NULL, NULL, 'Protein of unknown function (DUF3563)', NULL, 'DUF3563', NULL, NULL, 20039, 9),
(263662, NULL, 'PF01538', NULL, NULL, 'Hepatitis C virus non-structural protein NS2', NULL, 'HCV_NS2', NULL, NULL, 998, 9),
(263663, NULL, 'PF02340', NULL, NULL, 'PRRSV putative envelope protein', NULL, 'PRRSV_Env', NULL, NULL, 5129, 9),
(263664, NULL, 'PF02703', NULL, NULL, 'Early E1A protein', NULL, 'Adeno_E1A', NULL, NULL, 7838, 9),
(263665, NULL, 'PF16821', NULL, NULL, 'C protein from hendra and measles viruses', NULL, 'C_Hendra', NULL, NULL, 22393, 9),
(263666, NULL, 'PF13412', NULL, NULL, 'Winged helix-turn-helix DNA-binding', NULL, 'HTH_24', NULL, NULL, NULL, 9),
(263667, NULL, 'PF09607', NULL, NULL, 'Brinker DNA-binding domain', NULL, 'BrkDBD', NULL, NULL, 15972, 9),
(263668, NULL, 'PF13304', NULL, NULL, 'AAA domain, putative AbiEii toxin, Type IV TA system', NULL, 'AAA_21', NULL, NULL, 7026, 9),
(263669, NULL, 'PF17393', NULL, NULL, 'Family of unknown function (DUF5402)', NULL, 'DUF5402', NULL, NULL, 19855, 9),
(263670, NULL, 'PF05630', NULL, NULL, 'Necrosis inducing protein (NPP1)', NULL, 'NPP1', NULL, NULL, 13440, 9),
(263671, NULL, 'PF09455', NULL, NULL, 'CRISPR-associated (Cas) DxTHG family', NULL, 'Cas_DxTHG', NULL, NULL, 15861, 9),
(263672, NULL, 'PF10081', NULL, NULL, 'Alpha/beta-hydrolase family', NULL, 'Abhydrolase_9', NULL, NULL, 25224, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(263673, NULL, 'PF04636', NULL, NULL, 'PA26 p53-induced protein (sestrin)', NULL, 'PA26', NULL, NULL, 2118, 9),
(263674, NULL, 'PF15076', NULL, NULL, 'Domain of unknown function (DUF4543)', NULL, 'DUF4543', NULL, NULL, 23953, 9),
(263675, NULL, 'PF11976', NULL, NULL, 'Ubiquitin-2 like Rad60 SUMO-like', NULL, 'Rad60-SLD', NULL, NULL, 16980, 9),
(263676, NULL, 'PF13166', NULL, NULL, 'AAA domain', NULL, 'AAA_13', NULL, NULL, 26585, 9),
(263677, NULL, 'PF14449', NULL, NULL, 'Pre-toxin TG', NULL, 'PT-TG', NULL, NULL, 22637, 9),
(263678, NULL, 'PF19748', NULL, NULL, 'Family of unknown function (DUF6235)', NULL, 'DUF6235', NULL, NULL, 37426, 9),
(263679, NULL, 'PF00962', NULL, NULL, 'Adenosine deaminase', NULL, 'A_deaminase', NULL, NULL, 7095, 9),
(263680, NULL, 'PF02879', NULL, NULL, 'Phosphoglucomutase/phosphomannomutase, alpha/beta/alpha domain II', NULL, 'PGM_PMM_II', NULL, NULL, 5700, 9),
(263681, NULL, 'PF05810', NULL, NULL, 'NinF protein', NULL, 'NinF', NULL, NULL, 13182, 9),
(263682, NULL, 'PF00658', NULL, NULL, 'Poly-adenylate binding protein, unique domain', NULL, 'PABP', NULL, NULL, 4619, 9),
(263683, NULL, 'PF17060', NULL, NULL, 'Monopolar spindle protein 2', NULL, 'MPS2', NULL, NULL, 26004, 9),
(263684, NULL, 'PF00720', NULL, NULL, 'Subtilisin inhibitor-like', NULL, 'SSI', NULL, NULL, 16778, 9),
(263685, NULL, 'PF15592', NULL, NULL, 'Immunity protein 41', NULL, 'Imm41', NULL, NULL, 24660, 9),
(263686, NULL, 'PF15113', NULL, NULL, 'TMEM117 protein family', NULL, 'TMEM117', NULL, NULL, 26489, 9),
(263687, NULL, 'PF08194', NULL, NULL, 'DIM protein', NULL, 'DIM', NULL, NULL, 8806, 9),
(263688, NULL, 'PF15597', NULL, NULL, 'Immunity protein 59', NULL, 'Imm59', NULL, NULL, 24594, 9),
(263689, NULL, 'PF12178', NULL, NULL, 'Chromosome passenger complex (CPC) protein INCENP N terminal', NULL, 'INCENP_N', NULL, NULL, 20132, 9),
(263690, NULL, 'PF09952', NULL, NULL, 'Transcriptional regulator, AbiEi antitoxin, Type IV TA system', NULL, 'AbiEi_2', NULL, NULL, 19457, 9),
(263691, NULL, 'PF07426', NULL, NULL, 'Dynactin subunit p22', NULL, 'Dynactin_p22', NULL, NULL, 8777, 9),
(263692, NULL, 'PF00346', NULL, NULL, 'Respiratory-chain NADH dehydrogenase, 49 Kd subunit', NULL, 'Complex1_49kDa', NULL, NULL, 1349, 9),
(263693, NULL, 'PF09659', NULL, NULL, 'CRISPR-associated protein (Cas_Csm6)', NULL, 'Cas_Csm6', NULL, NULL, 10146, 9),
(263694, NULL, 'PF18361', NULL, NULL, 'Single stranded DNA-binding protein ss DNA binding domain', NULL, 'ssDBP_DBD', NULL, NULL, 31606, 9),
(263695, NULL, 'PF07013', NULL, NULL, 'Protein of unknown function (DUF1314)', NULL, 'DUF1314', NULL, NULL, 9636, 9),
(263696, NULL, 'PF09937', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2169)', NULL, 'DUF2169', NULL, NULL, 17003, 9),
(263697, NULL, 'PF01172', NULL, NULL, 'Shwachman-Bodian-Diamond syndrome (SBDS) protein', NULL, 'SBDS', NULL, NULL, 12730, 9),
(263698, NULL, 'PF02081', NULL, NULL, 'Tryptophan RNA-binding attenuator protein', NULL, 'TrpBP', NULL, NULL, 10246, 9),
(263699, NULL, 'PF02952', NULL, NULL, 'L-fucose isomerase, C-terminal domain', NULL, 'Fucose_iso_C', NULL, NULL, 7196, 9),
(263700, NULL, 'PF19854', NULL, NULL, 'Family of unknown function (DUF6329)', NULL, 'DUF6329', NULL, NULL, 37568, 9),
(263701, NULL, 'PF09085', NULL, NULL, 'Adhesion molecule, immunoglobulin-like', NULL, 'Adhes-Ig_like', NULL, NULL, 9829, 9),
(263702, NULL, 'PF20130', NULL, NULL, 'Family of unknown function (DUF6520)', NULL, 'DUF6520', NULL, NULL, 35899, 9),
(263703, NULL, 'PF11758', NULL, NULL, 'Aureocin-like type II bacteriocin', NULL, 'Bacteriocin_IIi', NULL, NULL, 15788, 9),
(263704, NULL, 'PF06694', NULL, NULL, 'Plant nuclear matrix protein 1 (NMP1)', NULL, 'Plant_NMP1', NULL, NULL, 8151, 9),
(263705, NULL, 'PF04927', NULL, NULL, 'Seed maturation protein', NULL, 'SMP', NULL, NULL, 6602, 9),
(263706, NULL, 'PF20433', NULL, NULL, 'PKAT, KLD domain', NULL, 'PKAT_KLD', NULL, NULL, 34452, 9),
(263707, NULL, 'PF09769', NULL, NULL, 'Apolipoprotein O', NULL, 'ApoO', NULL, NULL, 18437, 9),
(263708, NULL, 'PF14242', NULL, NULL, 'Domain of unknown function (DUF4342)', NULL, 'DUF4342', NULL, NULL, 24821, 9);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(263709, NULL, 'PF12339', NULL, NULL, 'DNA-J related protein', NULL, 'DNAJ_related', NULL, NULL, 15051, 9),
(263710, NULL, 'PF02072', NULL, NULL, 'Prepro-orexin', NULL, 'Orexin', NULL, NULL, 3130, 9),
(263711, NULL, 'PF04348', NULL, NULL, 'LppC putative lipoprotein', NULL, 'LppC', NULL, NULL, 4819, 9),
(263712, NULL, 'PF08501', NULL, NULL, 'Shikimate dehydrogenase substrate binding domain', NULL, 'Shikimate_dh_N', NULL, NULL, 13874, 9),
(263713, NULL, 'PF05386', NULL, NULL, 'TEP1 N-terminal domain', NULL, 'TEP1_N', NULL, NULL, 13636, 9),
(263714, NULL, 'PF10153', NULL, NULL, 'rRNA-processing protein Efg1', NULL, 'Efg1', NULL, NULL, 14763, 9),
(263715, NULL, 'PF08621', NULL, NULL, 'RPAP1-like, N-terminal', NULL, 'RPAP1_N', NULL, NULL, 14071, 9),
(263716, NULL, 'PF06339', NULL, NULL, 'Ectoine synthase', NULL, 'Ectoine_synth', NULL, NULL, 10136, 9),
(263717, NULL, 'PF16321', NULL, NULL, 'Sigma 54 modulation/S30EA ribosomal protein C terminus', NULL, 'Ribosom_S30AE_C', NULL, NULL, 25419, 9),
(263718, NULL, 'PF03929', NULL, NULL, 'PepSY-associated TM region', NULL, 'PepSY_TM', NULL, NULL, 2965, 9),
(263719, NULL, 'PF13370', NULL, NULL, '4Fe-4S single cluster domain of Ferredoxin I', NULL, 'Fer4_13', NULL, NULL, NULL, 9),
(263720, NULL, 'PF07985', NULL, NULL, 'SRR1 domain', NULL, 'SRR1', NULL, NULL, 8302, 9),
(263721, NULL, 'PF17137', NULL, NULL, 'Domain of unknown function (DUF5110)', NULL, 'DUF5110', NULL, NULL, 30241, 9),
(263722, NULL, 'PF05163', NULL, NULL, 'DinB family', NULL, 'DinB', NULL, NULL, 2405, 9),
(263723, NULL, 'PF13869', NULL, NULL, 'Nucleotide hydrolase', NULL, 'NUDIX_2', NULL, NULL, 20474, 9),
(263724, NULL, 'PF17554', NULL, NULL, 'Family of unknown function (DUF5466)', NULL, 'DUF5466', NULL, NULL, 32695, 9),
(263725, NULL, 'PF14563', NULL, NULL, 'Domain of unknown function (DUF4444)', NULL, 'DUF4444', NULL, NULL, 24429, 9),
(263726, NULL, 'PF06319', NULL, NULL, 'DNA repair protein MmcB-like', NULL, 'MmcB-like', NULL, NULL, 8304, 9),
(263727, NULL, 'PF06353', NULL, NULL, 'Protein of unknown function (DUF1062)', NULL, 'DUF1062', NULL, NULL, 8474, 9),
(263728, NULL, 'PF10388', NULL, NULL, 'EAL-domain associated signalling protein domain', NULL, 'YkuI_C', NULL, NULL, 20434, 9),
(263729, NULL, 'PF03870', NULL, NULL, 'RNA polymerase Rpb8', NULL, 'RNA_pol_Rpb8', NULL, NULL, 1654, 9),
(263730, NULL, 'PF02191', NULL, NULL, 'Olfactomedin-like domain', NULL, 'OLF', NULL, NULL, 1595, 9),
(263731, NULL, 'PF08790', NULL, NULL, 'LYAR-type C2HC zinc finger', NULL, 'zf-LYAR', NULL, NULL, 13369, 9),
(263732, NULL, 'PF11985', NULL, NULL, 'Bacteriophage Mu, Gp27', NULL, 'Phage_Mu_Gp27', NULL, NULL, 19839, 9),
(263733, NULL, 'PF14643', NULL, NULL, 'Domain of unknown function (DUF4455)', NULL, 'DUF4455', NULL, NULL, 23329, 9),
(263734, NULL, 'PF12318', NULL, NULL, 'Membrane bound FAD containing D-sorbitol dehydrogenase', NULL, 'FAD-SLDH', NULL, NULL, 1385, 9),
(263735, NULL, 'PF20164', NULL, NULL, 'GspA/SrpA SigLec-like domain', NULL, 'GspA_SrpA_N', NULL, NULL, 33727, 9),
(263736, NULL, 'PF07190', NULL, NULL, 'Protein of unknown function (DUF1406)', NULL, 'DUF1406', NULL, NULL, 10762, 9),
(263737, NULL, 'PF06153', NULL, NULL, 'Cyclic-di-AMP receptor', NULL, 'CdAMP_rec', NULL, NULL, 9217, 9),
(263738, NULL, 'PF15284', NULL, NULL, 'Phage-encoded virulence factor', NULL, 'PAGK', NULL, NULL, 23578, 9),
(263739, NULL, 'PF04879', NULL, NULL, 'Molybdopterin oxidoreductase Fe4S4 domain', NULL, 'Molybdop_Fe4S4', NULL, NULL, 5874, 9),
(263740, NULL, 'PF13897', NULL, NULL, 'Golgi-dynamics membrane-trafficking', NULL, 'GOLD_2', NULL, NULL, 7905, 9),
(263741, NULL, 'PF15706', NULL, NULL, 'Mature oligodendrocyte transmembrane protein, TMEM132D, C-term', NULL, 'TMEM132D_C', NULL, NULL, 24293, 9),
(263742, NULL, 'PF08511', NULL, NULL, 'COQ9', NULL, 'COQ9', NULL, NULL, 14333, 9),
(263743, NULL, 'PF19572', NULL, NULL, 'Type IX secretion system protein PorV', NULL, 'PorV', NULL, NULL, 36076, 9),
(263744, NULL, 'PF18318', NULL, NULL, 'Glutamine synthetase C-terminal domain', NULL, 'Gln-synt_C-ter', NULL, NULL, 27581, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(263745, NULL, 'PF02581', NULL, NULL, 'Thiamine monophosphate synthase', NULL, 'TMP-TENI', NULL, NULL, 15149, 9),
(263746, NULL, 'PF11320', NULL, NULL, 'Protein of unknown function (DUF3122)', NULL, 'DUF3122', NULL, NULL, 18045, 9),
(263747, NULL, 'PF18599', NULL, NULL, 'Limiting CO2-inducible proteins B/C beta carbonyic anhydrases', NULL, 'LCIB_C_CA', NULL, NULL, 28274, 9),
(263748, NULL, 'PF10107', NULL, NULL, 'Endonuclease related to archaeal Holliday junction resolvase', NULL, 'Endonuc_Holl', NULL, NULL, 19558, 9),
(263749, NULL, 'PF02044', NULL, NULL, 'Bombesin-like peptide', NULL, 'Bombesin', NULL, NULL, 76, 9),
(263750, NULL, 'PF14503', NULL, NULL, 'YhfZ C-terminal domain', NULL, 'YhfZ_C', NULL, NULL, 21998, 9),
(263751, NULL, 'PF16505', NULL, NULL, 'P4 movement protein of Emaravirus, and the 30K superfamily', NULL, 'Emaravirus_P4', NULL, NULL, 25164, 9),
(263752, NULL, 'PF10494', NULL, NULL, 'Serine-threonine protein kinase 19', NULL, 'Stk19', NULL, NULL, 20694, 9),
(263753, NULL, 'PF02827', NULL, NULL, 'cAMP-dependent protein kinase inhibitor', NULL, 'PKI', NULL, NULL, 4249, 9),
(263754, NULL, 'PF07210', NULL, NULL, 'Protein of unknown function (DUF1416)', NULL, 'DUF1416', NULL, NULL, 10919, 9),
(263755, NULL, 'PF13397', NULL, NULL, 'RNA polymerase-binding protein', NULL, 'RbpA', NULL, NULL, 22768, 9),
(263756, NULL, 'PF19338', NULL, NULL, 'Neutrophin-3 N-terminus', NULL, 'NTF3_N', NULL, NULL, 34287, 9),
(263757, NULL, 'PF14896', NULL, NULL, 'EmbC C-terminal domain', NULL, 'Arabino_trans_C', NULL, NULL, 26105, 9),
(263758, NULL, 'PF19440', NULL, NULL, 'Tetratricopeptide repeat protein 7 N-terminal', NULL, 'TTC7_N', NULL, NULL, 36342, 9),
(263759, NULL, 'PF17371', NULL, NULL, 'Family of unknown function (DUF5393)', NULL, 'DUF5393', NULL, NULL, 19574, 9),
(263760, NULL, 'PF18953', NULL, NULL, 'SAP domain-containing new25', NULL, 'SAP_new25', NULL, NULL, NULL, 9),
(263761, NULL, 'PF00120', NULL, NULL, 'Glutamine synthetase, catalytic domain', NULL, 'Gln-synt_C', NULL, NULL, 7238, 9),
(263762, NULL, 'PF03971', NULL, NULL, 'Monomeric isocitrate dehydrogenase', NULL, 'IDH', NULL, NULL, 7114, 9),
(263763, NULL, 'PF17759', NULL, NULL, 'Phenylalanyl tRNA synthetase beta chain CLM domain', NULL, 'tRNA_synthFbeta', NULL, NULL, 30822, 9),
(263764, NULL, 'PF15689', NULL, NULL, 'Nuclear receptor-interacting protein 1 repression 3', NULL, 'NRIP1_repr_3', NULL, NULL, 26477, 9),
(263765, NULL, 'PF03627', NULL, NULL, 'PapG carbohydrate binding domain', NULL, 'PapG_N', NULL, NULL, 5309, 9),
(263766, NULL, 'PF08747', NULL, NULL, 'BREX protein BrxB', NULL, 'BrxB', NULL, NULL, 13062, 9),
(263767, NULL, 'PF18354', NULL, NULL, 'CarS bacterial SH3 domain', NULL, 'SH3_18', NULL, NULL, 29159, 9),
(263768, NULL, 'PF01010', NULL, NULL, 'NADH-dehyrogenase subunit F, TMs, (complex I) C-terminus', NULL, 'Proton_antipo_C', NULL, NULL, 5427, 9),
(263769, NULL, 'PF15242', NULL, NULL, 'Family of FAM53', NULL, 'FAM53', NULL, NULL, 26107, 9),
(263770, NULL, 'PF15373', NULL, NULL, 'Domain of unknown function (DUF4601)', NULL, 'DUF4601', NULL, NULL, 23789, 9),
(263771, NULL, 'PF01941', NULL, NULL, 'S-adenosylmethionine synthetase (AdoMet synthetase)', NULL, 'AdoMet_Synthase', NULL, NULL, 24691, 9),
(263772, NULL, 'PF03931', NULL, NULL, 'Skp1 family, tetramerisation domain', NULL, 'Skp1_POZ', NULL, NULL, 10449, 9),
(263773, NULL, 'PF15469', NULL, NULL, 'Exocyst complex component Sec5', NULL, 'Sec5', NULL, NULL, 33236, 9),
(263774, NULL, 'PF08093', NULL, NULL, 'Magi 5 toxic peptide family', NULL, 'Toxin_23', NULL, NULL, 9660, 9),
(263775, NULL, 'PF00604', NULL, NULL, 'Influenza RNA-dependent RNA polymerase subunit PB2', NULL, 'Flu_PB2', NULL, NULL, 3480, 9),
(263776, NULL, 'PF01297', NULL, NULL, 'Zinc-uptake complex component A periplasmic', NULL, 'ZnuA', NULL, NULL, 10111, 9),
(263777, NULL, 'PF11303', NULL, NULL, 'Protein of unknown function (DUF3105)', NULL, 'DUF3105', NULL, NULL, 18221, 9),
(263778, NULL, 'PF20103', NULL, NULL, 'Family of unknown function (DUF6493)', NULL, 'DUF6493', NULL, NULL, 35698, 9),
(263779, NULL, 'PF07504', NULL, NULL, 'Fungalysin/Thermolysin Propeptide Motif', NULL, 'FTP', NULL, NULL, 11257, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(263780, NULL, 'PF15220', NULL, NULL, 'Hypoxia-inducible lipid droplet-associated', NULL, 'HILPDA', NULL, NULL, 25342, 9),
(263781, NULL, 'PF18621', NULL, NULL, 'Family of unknown function (DUF5628)', NULL, 'DUF5628', NULL, NULL, 29784, 9),
(263782, NULL, 'PF02297', NULL, NULL, 'Cytochrome oxidase c subunit VIb', NULL, 'COX6B', NULL, NULL, 2128, 9),
(263783, NULL, 'PF14586', NULL, NULL, 'Class I Histocompatibility antigen, NKG2D ligand, domains 1 and 2', NULL, 'MHC_I_2', NULL, NULL, 21112, 9),
(263784, NULL, 'PF15464', NULL, NULL, 'Domain of unknown function (DUF4633)', NULL, 'DUF4633', NULL, NULL, 24794, 9),
(263785, NULL, 'PF00438', NULL, NULL, 'S-adenosylmethionine synthetase, N-terminal domain', NULL, 'S-AdoMet_synt_N', NULL, NULL, 16910, 9),
(263786, NULL, 'PF15392', NULL, NULL, 'Joubert syndrome-associated', NULL, 'Joubert', NULL, NULL, 22891, 9),
(263787, NULL, 'PF19378', NULL, NULL, 'Family of unknown function (DUF5953)', NULL, 'DUF5953', NULL, NULL, 36722, 9),
(263788, NULL, 'PF20251', NULL, NULL, 'Bacterial Ig-like domain', NULL, 'Big_14', NULL, NULL, 37641, 9),
(263789, NULL, 'PF13807', NULL, NULL, 'G-rich domain on putative tyrosine kinase', NULL, 'GNVR', NULL, NULL, 21725, 9),
(263790, NULL, 'PF03558', NULL, NULL, 'TBSV core protein P21/P22', NULL, 'TBSV_P22', NULL, NULL, 5572, 9),
(263791, NULL, 'PF10466', NULL, NULL, 'Saccharopepsin inhibitor I34', NULL, 'Inhibitor_I34', NULL, NULL, 18014, 9),
(263792, NULL, 'PF14684', NULL, NULL, 'Tricorn protease C1 domain', NULL, 'Tricorn_C1', NULL, NULL, 26903, 9),
(263793, NULL, 'PF07106', NULL, NULL, 'TBPIP/Hop2 winged helix domain', NULL, 'TBPIP', NULL, NULL, 10892, 9),
(263794, NULL, 'PF15276', NULL, NULL, 'Protein phosphatase 1 binding', NULL, 'PP1_bind', NULL, NULL, 23690, 9),
(263795, NULL, 'PF07462', NULL, NULL, 'Merozoite surface protein 1 (MSP1) C-terminus', NULL, 'MSP1_C', NULL, NULL, 12172, 9),
(263796, NULL, 'PF12613', NULL, NULL, 'Flagellin structural protein', NULL, 'FliC_SP', NULL, NULL, 16070, 9),
(263797, NULL, 'PF17635', NULL, NULL, 'Betacoronavirus uncharacterised protein 14 (SARS-CoV-2 like)', NULL, 'bCoV_Orf14', NULL, NULL, 14556, 9),
(263798, NULL, 'PF04951', NULL, NULL, 'D-aminopeptidase', NULL, 'Peptidase_M55', NULL, NULL, 6717, 9),
(263799, NULL, 'PF20604', NULL, NULL, 'Domain of unknown function (DUF6798)', NULL, 'DUF6798', NULL, NULL, 37679, 9),
(263800, NULL, 'PF04510', NULL, NULL, 'Family of unknown function (DUF577)', NULL, 'DUF577', NULL, NULL, 2752, 9),
(263801, NULL, 'PF05066', NULL, NULL, 'HB1, ASXL, restriction endonuclease HTH domain', NULL, 'HARE-HTH', NULL, NULL, 1379, 9),
(263802, NULL, 'PF02179', NULL, NULL, 'BAG domain', NULL, 'BAG', NULL, NULL, 1471, 9),
(263803, NULL, 'PF02145', NULL, NULL, 'Rap/ran-GAP', NULL, 'Rap_GAP', NULL, NULL, 856, 9),
(263804, NULL, 'PF12976', NULL, NULL, 'Domain of Unknown Function with PDB structure (DUF3860)', NULL, 'DUF3860', NULL, NULL, 26803, 9),
(263805, NULL, 'PF01658', NULL, NULL, 'Myo-inositol-1-phosphate synthase', NULL, 'Inos-1-P_synth', NULL, NULL, 14154, 9),
(263806, NULL, 'PF17816', NULL, NULL, 'PDZ domain', NULL, 'PDZ_4', NULL, NULL, 28969, 9),
(263807, NULL, 'PF05051', NULL, NULL, 'Cytochrome C oxidase copper chaperone (COX17)', NULL, 'COX17', NULL, NULL, 1319, 9),
(263808, NULL, 'PF05272', NULL, NULL, 'Virulence-associated protein E', NULL, 'VirE', NULL, NULL, 4465, 9),
(263809, NULL, 'PF07282', NULL, NULL, 'Putative transposase DNA-binding domain', NULL, 'OrfB_Zn_ribbon', NULL, NULL, 2320, 9),
(263810, NULL, 'PF13621', NULL, NULL, 'Cupin-like domain', NULL, 'Cupin_8', NULL, NULL, 30138, 9),
(263811, NULL, 'PF05589', NULL, NULL, 'Protein of unknown function (DUF768)', NULL, 'DUF768', NULL, NULL, 12082, 9),
(263812, NULL, 'PF06715', NULL, NULL, 'Gp5 C-terminal repeat (3 copies)', NULL, 'Gp5_C', NULL, NULL, 8273, 9),
(263813, NULL, 'PF00548', NULL, NULL, '3C cysteine protease (picornain 3C)', NULL, 'Peptidase_C3', NULL, NULL, 3543, 9),
(263814, NULL, 'PF06569', NULL, NULL, 'Protein of unknown function (DUF1128)', NULL, 'DUF1128', NULL, NULL, 9415, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(263815, NULL, 'PF10468', NULL, NULL, 'Carboxypeptidase inhibitor I68', NULL, 'Inhibitor_I68', NULL, NULL, 18353, 9),
(263816, NULL, 'PF16171', NULL, NULL, 'Centromere kinetochore component CENP-T N-terminus', NULL, 'CENP-T_N', NULL, NULL, 26332, 9),
(263817, NULL, 'PF09943', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2175)', NULL, 'DUF2175', NULL, NULL, 17087, 9),
(263818, NULL, 'PF14730', NULL, NULL, 'Domain of unknown function (DUF4468) with TBP-like fold', NULL, 'DUF4468', NULL, NULL, 21962, 9),
(263819, NULL, 'PF08317', NULL, NULL, 'Spc7 kinetochore protein', NULL, 'Spc7', NULL, NULL, 13175, 9),
(263820, NULL, 'PF12637', NULL, NULL, 'TSCPD domain', NULL, 'TSCPD', NULL, NULL, 26830, 9),
(263821, NULL, 'PF19448', NULL, NULL, 'Family of unknown function (DUF5986)', NULL, 'DUF5986', NULL, NULL, 36856, 9),
(263822, NULL, 'PF15498', NULL, NULL, 'Nephrin and CD2AP-binding protein, Dendrin', NULL, 'Dendrin', NULL, NULL, 23325, 9),
(263823, NULL, 'PF01709', NULL, NULL, 'Transcriptional regulator', NULL, 'Transcrip_reg', NULL, NULL, 5846, 9),
(263824, NULL, 'PF04958', NULL, NULL, 'Arginine N-succinyltransferase beta subunit', NULL, 'AstA', NULL, NULL, 6868, 9),
(263825, NULL, 'PF02574', NULL, NULL, 'Homocysteine S-methyltransferase', NULL, 'S-methyl_trans', NULL, NULL, 2089, 9),
(263826, NULL, 'PF18485', NULL, NULL, 'Glutathione S-transferase, N-terminal domain', NULL, 'GST_N_5', NULL, NULL, 30825, 9),
(263827, NULL, 'PF20476', NULL, NULL, 'Family of unknown function (DUF6718)', NULL, 'DUF6718', NULL, NULL, 37561, 9),
(263828, NULL, 'PF12080', NULL, NULL, 'GldM C-terminal domain', NULL, 'GldM_C', NULL, NULL, 16825, 9),
(263829, NULL, 'PF12656', NULL, NULL, 'G-patch domain', NULL, 'G-patch_2', NULL, NULL, 22385, 9),
(263830, NULL, 'PF04051', NULL, NULL, 'Transport protein particle (TRAPP) component', NULL, 'TRAPP', NULL, NULL, 1448, 9),
(263831, NULL, 'PF03305', NULL, NULL, 'Mycoplasma MG185/MG260 protein', NULL, 'Lipoprotein_X', NULL, NULL, 837, 9),
(263832, NULL, 'PF05282', NULL, NULL, 'AAR2 protein', NULL, 'AAR2', NULL, NULL, 4228, 9),
(263833, NULL, 'PF09459', NULL, NULL, 'Ethylbenzene dehydrogenase', NULL, 'EB_dh', NULL, NULL, 15707, 9),
(263834, NULL, 'PF19531', NULL, NULL, 'Family of unknown function (DUF6058)', NULL, 'DUF6058', NULL, NULL, 36070, 9),
(263835, NULL, 'PF13592', NULL, NULL, 'Winged helix-turn helix', NULL, 'HTH_33', NULL, NULL, 24341, 9),
(263836, NULL, 'PF15774', NULL, NULL, 'Domain of unknown function (DUF4702)', NULL, 'DUF4702', NULL, NULL, 25862, 9),
(263837, NULL, 'PF06603', NULL, NULL, 'UpxZ family of transcription anti-terminator antagonists', NULL, 'UpxZ', NULL, NULL, 8265, 9),
(263838, NULL, 'PF04071', NULL, NULL, 'Cysteine-rich small domain', NULL, 'zf-like', NULL, NULL, 6192, 9),
(263839, NULL, 'PF15222', NULL, NULL, 'Kidney androgen-regulated', NULL, 'KAR', NULL, NULL, 25398, 9),
(263840, NULL, 'PF08007', NULL, NULL, 'JmjC domain', NULL, 'JmjC_2', NULL, NULL, 4389, 9),
(263841, NULL, 'PF16001', NULL, NULL, 'Domain of unknown function (DUF4775)', NULL, 'DUF4775', NULL, NULL, 25964, 9),
(263842, NULL, 'PF16320', NULL, NULL, 'Ribosomal protein L7/L12 dimerisation domain', NULL, 'Ribosomal_L12_N', NULL, NULL, 8908, 9),
(263843, NULL, 'PF05917', NULL, NULL, 'Helicobacter pylori protein of unknown function (DUF874)', NULL, 'DUF874', NULL, NULL, 14378, 9),
(263844, NULL, 'PF03755', NULL, NULL, 'YicC-like family, N-terminal region', NULL, 'YicC_N', NULL, NULL, 12561, 9),
(263845, NULL, 'PF20599', NULL, NULL, 'Family of unknown function (DUF6796)', NULL, 'DUF6796', NULL, NULL, 37710, 9),
(263846, NULL, 'PF09729', NULL, NULL, 'Gti1/Pac2 family', NULL, 'Gti1_Pac2', NULL, NULL, 16417, 9),
(263847, NULL, 'PF05299', NULL, NULL, 'M61 glycyl aminopeptidase', NULL, 'Peptidase_M61', NULL, NULL, 4214, 9),
(263848, NULL, 'PF15121', NULL, NULL, 'TMEM71 protein family', NULL, 'TMEM71', NULL, NULL, 25325, 9),
(263849, NULL, 'PF20090', NULL, NULL, 'Family of unknown function (DUF6482)', NULL, 'DUF6482', NULL, NULL, 37493, 9),
(263850, NULL, 'PF08786', NULL, NULL, 'DcrB', NULL, 'DcrB', NULL, NULL, 13363, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(263851, NULL, 'PF14083', NULL, NULL, 'PGDYG protein', NULL, 'PGDYG', NULL, NULL, 24979, 9),
(263852, NULL, 'PF00332', NULL, NULL, 'Glycosyl hydrolases family 17', NULL, 'Glyco_hydro_17', NULL, NULL, 5879, 9),
(263853, NULL, 'PF01453', NULL, NULL, 'D-mannose binding lectin', NULL, 'B_lectin', NULL, NULL, 3016, 9),
(263854, NULL, 'PF10073', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2312)', NULL, 'DUF2312', NULL, NULL, 34470, 9),
(263855, NULL, 'PF03650', NULL, NULL, 'Mitochondrial pyruvate carriers', NULL, 'MPC', NULL, NULL, 5541, 9),
(263856, NULL, 'PF17627', NULL, NULL, 'Inclusion membrane protein E', NULL, 'IncE', NULL, NULL, 8016, 9),
(263857, NULL, 'PF16920', NULL, NULL, 'Leucine rich repeat C-terminal motif', NULL, 'LRRCT_2', NULL, NULL, 25178, 9),
(263858, NULL, 'PF17577', NULL, NULL, 'ECORI-T site', NULL, 'ETM', NULL, NULL, 30995, 9),
(263859, NULL, 'PF13431', NULL, NULL, 'Tetratricopeptide repeat', NULL, 'TPR_17', NULL, NULL, NULL, 9),
(263860, NULL, 'PF14056', NULL, NULL, 'Domain of unknown function (DUF4250)', NULL, 'DUF4250', NULL, NULL, 22872, 9),
(263861, NULL, 'PF16904', NULL, NULL, 'Phosphoribosylformylglycinamidine synthase II C-terminus', NULL, 'PurL_C', NULL, NULL, 21857, 9),
(263862, NULL, 'PF20301', NULL, NULL, 'Predicted novel nucleotide synthetase', NULL, 'pNTSase1', NULL, NULL, 36989, 9),
(263863, NULL, 'PF02110', NULL, NULL, 'Hydroxyethylthiazole kinase family', NULL, 'HK', NULL, NULL, 6810, 9),
(263864, NULL, 'PF05219', NULL, NULL, 'DREV methyltransferase', NULL, 'DREV', NULL, NULL, 3479, 9),
(263865, NULL, 'PF16693', NULL, NULL, 'Inner membrane component of T3SS, periplasmic domain', NULL, 'Yop-YscD_ppl', NULL, NULL, 23398, 9),
(263866, NULL, 'PF17239', NULL, NULL, 'Family of unknown function (DUF5312)', NULL, 'DUF5312', NULL, NULL, 20423, 9),
(263867, NULL, 'PF05635', NULL, NULL, '23S rRNA-intervening sequence protein', NULL, '23S_rRNA_IVP', NULL, NULL, 10099, 9),
(263868, NULL, 'PF06673', NULL, NULL, 'Lactococcus lactis bacteriophage major capsid protein', NULL, 'L_lactis_ph-MCP', NULL, NULL, 10441, 9),
(263869, NULL, 'PF01624', NULL, NULL, 'MutS domain I', NULL, 'MutS_I', NULL, NULL, 1335, 9),
(263870, NULL, 'PF05248', NULL, NULL, 'Adenovirus E3A', NULL, 'Adeno_E3A', NULL, NULL, 3064, 9),
(263871, NULL, 'PF02945', NULL, NULL, 'Recombination endonuclease VII', NULL, 'Endonuclease_7', NULL, NULL, 3622, 9),
(263872, NULL, 'PF15829', NULL, NULL, 'Domain of unknown function (DUF4711)', NULL, 'DUF4711', NULL, NULL, 26207, 9),
(263873, NULL, 'PF07230', NULL, NULL, 'Bacteriophage T4-like portal protein (Gp20)', NULL, 'Portal_Gp20', NULL, NULL, 10597, 9),
(263874, NULL, 'PF17874', NULL, NULL, 'MalT-like TPR region', NULL, 'TPR_MalT', NULL, NULL, 30919, 9),
(263875, NULL, 'PF11423', NULL, NULL, 'Regulatory protein Mnt', NULL, 'Repressor_Mnt', NULL, NULL, 22204, 9),
(263876, NULL, 'PF14265', NULL, NULL, 'Domain of unknown function (DUF4355)', NULL, 'DUF4355', NULL, NULL, 26333, 9),
(263877, NULL, 'PF02814', NULL, NULL, 'UreE urease accessory protein, N-terminal domain', NULL, 'UreE_N', NULL, NULL, 576, 9),
(263878, NULL, 'PF16126', NULL, NULL, 'Domain of unknown function (DUF4838)', NULL, 'DUF4838', NULL, NULL, 25209, 9),
(263879, NULL, 'PF04878', NULL, NULL, 'Baculovirus P48 protein', NULL, 'Baculo_p48', NULL, NULL, 5759, 9),
(263880, NULL, 'PF15844', NULL, NULL, 'Transmembrane and coiled-coil domain-containing protein 2', NULL, 'TMCCDC2', NULL, NULL, 26302, 9),
(263881, NULL, 'PF12333', NULL, NULL, 'Rix1 complex component involved in 60S ribosome maturation', NULL, 'Ipi1_N', NULL, NULL, 21042, 9),
(263882, NULL, 'PF12834', NULL, NULL, 'Phage integrase, N-terminal', NULL, 'Phage_int_SAM_2', NULL, NULL, 21650, 9),
(263883, NULL, 'PF09155', NULL, NULL, 'Domain of unknown function (DUF1940)', NULL, 'DUF1940', NULL, NULL, 12353, 9),
(263884, NULL, 'PF17391', NULL, NULL, 'Urocanase N-terminal domain', NULL, 'Urocanase_N', NULL, NULL, 14823, 9),
(263885, NULL, 'PF20006', NULL, NULL, 'YukD-like N-terminal domain', NULL, 'fvmYukDl_N', NULL, NULL, 35667, 9);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(263886, NULL, 'PF04710', NULL, NULL, 'Pellino', NULL, 'Pellino', NULL, NULL, 3534, 9),
(263887, NULL, 'PF12979', NULL, NULL, 'Domain of Unknown Function with PDB structure (DUF3863)', NULL, 'DUF3863', NULL, NULL, 26594, 9),
(263888, NULL, 'PF19696', NULL, NULL, 'Family of unknown function (DUF6196)', NULL, 'DUF6196', NULL, NULL, 36229, 9),
(263889, NULL, 'PF20244', NULL, NULL, 'Family of unknown function (DUF6599)', NULL, 'DUF6599', NULL, NULL, 37667, 9),
(263890, NULL, 'PF14913', NULL, NULL, 'DPCD protein family', NULL, 'DPCD', NULL, NULL, 25580, 9),
(263891, NULL, 'PF15057', NULL, NULL, 'Domain of unknown function (DUF4537)', NULL, 'DUF4537', NULL, NULL, 22495, 9),
(263892, NULL, 'PF12113', NULL, NULL, 'SVM protein signal sequence', NULL, 'SVM_signal', NULL, NULL, 20493, 9),
(263893, NULL, 'PF09940', NULL, NULL, 'Domain of unknown function (DUF2172)', NULL, 'DUF2172', NULL, NULL, 23972, 9),
(263894, NULL, 'PF17965', NULL, NULL, 'Mucin binding domain', NULL, 'MucBP_2', NULL, NULL, 30285, 9),
(263895, NULL, 'PF06197', NULL, NULL, 'Protein of unknown function (DUF998)', NULL, 'DUF998', NULL, NULL, 14430, 9),
(263896, NULL, 'PF09025', NULL, NULL, 'YopR, type III needle-polymerisation regulator', NULL, 'T3SS_needle_reg', NULL, NULL, 18884, 9),
(263897, NULL, 'PF11300', NULL, NULL, 'Protein of unknown function (DUF3102)', NULL, 'DUF3102', NULL, NULL, 18135, 9),
(263898, NULL, 'PF20100', NULL, NULL, 'Family of unknown function (DUF6490)', NULL, 'DUF6490', NULL, NULL, 37217, 9),
(263899, NULL, 'PF09355', NULL, NULL, 'Phage protein Gp19/Gp15/Gp42', NULL, 'Phage_Gp19', NULL, NULL, 14723, 9),
(263900, NULL, 'PF17374', NULL, NULL, 'Family of unknown function (DUF5396)', NULL, 'DUF5396', NULL, NULL, 19718, 9),
(263901, NULL, 'PF20021', NULL, NULL, 'vWA-MoxR associated protein middle region (VMAP-M) 18', NULL, 'VMAP-M18', NULL, NULL, NULL, 9),
(263902, NULL, 'PF15773', NULL, NULL, 'Dynein axonemal-associated protein 1', NULL, 'DAAP1', NULL, NULL, 25757, 9),
(263903, NULL, 'PF17564', NULL, NULL, 'Family of unknown function (DUF5470)', NULL, 'DUF5470', NULL, NULL, 21330, 9),
(263904, NULL, 'PF11135', NULL, NULL, 'Protein of unknown function (DUF2888)', NULL, 'DUF2888', NULL, NULL, 16867, 9),
(263905, NULL, 'PF17523', NULL, NULL, 'MinK-related peptide, potassium channel accessory sub-unit protein 4', NULL, 'MPS-4', NULL, NULL, 19968, 9),
(263906, NULL, 'PF02509', NULL, NULL, 'Rotavirus non-structural protein 35', NULL, 'Rota_NS35', NULL, NULL, 1299, 9),
(263907, NULL, 'PF05670', NULL, NULL, 'NFACT protein RNA binding domain', NULL, 'NFACT-R_1', NULL, NULL, 13313, 9),
(263908, NULL, 'PF14762', NULL, NULL, 'Hermansky-Pudlak syndrome 3, middle region', NULL, 'HPS3_Mid', NULL, NULL, 23946, 9),
(263909, NULL, 'PF00338', NULL, NULL, 'Ribosomal protein S10p/S20e', NULL, 'Ribosomal_S10', NULL, NULL, 25515, 9),
(263910, NULL, 'PF03880', NULL, NULL, 'DbpA RNA binding domain', NULL, 'DbpA', NULL, NULL, 1885, 9),
(263911, NULL, 'PF11006', NULL, NULL, 'Protein of unknown function (DUF2845)', NULL, 'DUF2845', NULL, NULL, 17784, 9),
(263912, NULL, 'PF07285', NULL, NULL, 'Protein of unknown function (DUF1444)', NULL, 'DUF1444', NULL, NULL, 11501, 9),
(263913, NULL, 'PF16639', NULL, NULL, 'Apocytochrome F, N-terminal', NULL, 'Apocytochr_F_N', NULL, NULL, 21217, 9),
(263914, NULL, 'PF11412', NULL, NULL, 'Disulphide bond corrector protein DsbC', NULL, 'DsbC', NULL, NULL, 24908, 9),
(263915, NULL, 'PF20182', NULL, NULL, 'Family of unknown function (DUF6545)', NULL, 'DUF6545', NULL, NULL, 37119, 9),
(263916, NULL, 'PF20265', NULL, NULL, 'ATPase, RavA, LARA domain', NULL, 'LARA_dom', NULL, NULL, 34329, 9),
(263917, NULL, 'PF15198', NULL, NULL, 'Dexamethasone-induced', NULL, 'Dexa_ind', NULL, NULL, 18781, 9),
(263918, NULL, 'PF04005', NULL, NULL, 'Hus1-like protein', NULL, 'Hus1', NULL, NULL, 388, 9),
(263919, NULL, 'PF14120', NULL, NULL, 'YhzD-like protein', NULL, 'YhzD', NULL, NULL, 23575, 9),
(263920, NULL, 'PF11731', NULL, NULL, 'Pathogenicity locus', NULL, 'Cdd1', NULL, NULL, 19022, 9),
(263921, NULL, 'PF03082', NULL, NULL, 'Male accessory gland secretory protein', NULL, 'MAGSP', NULL, NULL, 4568, 9);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(263922, NULL, 'PF06616', NULL, NULL, 'BsuBI/PstI restriction endonuclease domain', NULL, 'BsuBI_PstI_RE', NULL, NULL, 9574, 9),
(263923, NULL, 'PF02052', NULL, NULL, 'Gallidermin', NULL, 'Gallidermin', NULL, NULL, 2674, 9),
(263924, NULL, 'PF13142', NULL, NULL, 'Domain of unknown function (DUF3960)', NULL, 'DUF3960', NULL, NULL, 22207, 9),
(263925, NULL, 'PF15811', NULL, NULL, 'Small VCP/p97-interacting protein', NULL, 'SVIP', NULL, NULL, 25907, 9),
(263926, NULL, 'PF03661', NULL, NULL, 'Transmembrane protein 33/Nucleoporin POM33', NULL, 'TMEM33_Pom33', NULL, NULL, 6224, 9),
(263927, NULL, 'PF08260', NULL, NULL, 'Insect kinin peptide', NULL, 'Kinin', NULL, NULL, 17038, 9),
(263928, NULL, 'PF15115', NULL, NULL, 'Domain of unknown function with conserved HDNR motif', NULL, 'HDNR', NULL, NULL, 26075, 9),
(263929, NULL, 'PF10276', NULL, NULL, 'Zinc-finger domain', NULL, 'zf-CHCC', NULL, NULL, 16972, 9),
(263930, NULL, 'PF10282', NULL, NULL, 'Lactonase, 7-bladed beta-propeller', NULL, 'Lactonase', NULL, NULL, 16913, 9),
(263931, NULL, 'PF13882', NULL, NULL, 'Bravo-like intracellular region', NULL, 'Bravo_FIGEY', NULL, NULL, 25924, 9),
(263932, NULL, 'PF18875', NULL, NULL, 'AF4 interaction motif', NULL, 'AF4_int', NULL, NULL, 35017, 9),
(263933, NULL, 'PF10628', NULL, NULL, 'Outer spore coat protein E (CotE)', NULL, 'CotE', NULL, NULL, 20826, 9),
(263934, NULL, 'PF01424', NULL, NULL, 'R3H domain', NULL, 'R3H', NULL, NULL, 7141, 9),
(263935, NULL, 'PF02501', NULL, NULL, 'Type II secretion system (T2SS), protein I', NULL, 'T2SSI', NULL, NULL, 5137, 9),
(263936, NULL, 'PF07486', NULL, NULL, 'Cell Wall Hydrolase', NULL, 'Hydrolase_2', NULL, NULL, 11192, 9),
(263937, NULL, 'PF09363', NULL, NULL, 'XFP C-terminal domain', NULL, 'XFP_C', NULL, NULL, 14749, 9),
(263938, NULL, 'PF11756', NULL, NULL, 'Nitrous oxide-stimulated promoter', NULL, 'YgbA_NO', NULL, NULL, 21425, 9),
(263939, NULL, 'PF15890', NULL, NULL, 'Putative zinc-binding metallo-peptidase', NULL, 'Peptidase_Mx1', NULL, NULL, 25244, 9),
(263940, NULL, 'PF18147', NULL, NULL, 'Suv3 C-terminal domain 1', NULL, 'Suv3_C_1', NULL, NULL, 28581, 9),
(263941, NULL, 'PF10034', NULL, NULL, 'Q-cell neuroblast polarisation', NULL, 'Dpy19', NULL, NULL, 18059, 9),
(263942, NULL, 'PF03264', NULL, NULL, 'NapC/NirT cytochrome c family, N-terminal region', NULL, 'Cytochrom_NNT', NULL, NULL, 7201, 9),
(263943, NULL, 'PF10393', NULL, NULL, 'Trimeric coiled-coil oligomerisation domain of matrilin', NULL, 'Matrilin_ccoil', NULL, NULL, 17077, 9),
(263944, NULL, 'PF00059', NULL, NULL, 'Lectin C-type domain', NULL, 'Lectin_C', NULL, NULL, 179, 9),
(263945, NULL, 'PF13170', NULL, NULL, 'Protein of unknown function (DUF4003)', NULL, 'DUF4003', NULL, NULL, 22895, 9),
(263946, NULL, 'PF03759', NULL, NULL, 'PRONE (Plant-specific Rop nucleotide exchanger)', NULL, 'PRONE', NULL, NULL, 859, 9),
(263947, NULL, 'PF06270', NULL, NULL, 'Protein of unknown function (DUF1030)', NULL, 'DUF1030', NULL, NULL, 14270, 9),
(263948, NULL, 'PF17212', NULL, NULL, 'Tail tubular protein', NULL, 'Tube', NULL, NULL, 31767, 9),
(263949, NULL, 'PF19127', NULL, NULL, 'Choline-binding repeat', NULL, 'Choline_bind_3', NULL, NULL, 20480, 9),
(263950, NULL, 'PF19753', NULL, NULL, 'Family of unknown function (DUF6240)', NULL, 'DUF6240', NULL, NULL, 37034, 9),
(263951, NULL, 'PF06027', NULL, NULL, 'Solute carrier family 35', NULL, 'SLC35F', NULL, NULL, 13668, 9),
(263952, NULL, 'PF07628', NULL, NULL, 'Protein of unknown function (DUF1589)', NULL, 'DUF1589', NULL, NULL, 14937, 9),
(263953, NULL, 'PF19442', NULL, NULL, 'Cysteine-rich motor neuron 1 protein C-terminal', NULL, 'CRIM1_C', NULL, NULL, 34444, 9),
(263954, NULL, 'PF18462', NULL, NULL, 'Domain of unknown function (DUF5612)', NULL, 'DUF5612', NULL, NULL, 27506, 9),
(263955, NULL, 'PF19321', NULL, NULL, 'BTB/POZ domain-containing protein KCTD18 C-terminus', NULL, 'KCTD18_C', NULL, NULL, 37326, 9),
(263956, NULL, 'PF19829', NULL, NULL, 'Family of unknown function (DUF6310)', NULL, 'DUF6310', NULL, NULL, 37541, 9),
(263957, NULL, 'PF08261', NULL, NULL, 'Carcinustatin peptide', NULL, 'Carcinustatin', NULL, NULL, NULL, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(263958, NULL, 'PF02098', NULL, NULL, 'Tick histamine binding protein', NULL, 'His_binding', NULL, NULL, 6790, 9),
(263959, NULL, 'PF14222', NULL, NULL, 'Cell morphogenesis N-terminal', NULL, 'MOR2-PAG1_N', NULL, NULL, 25828, 9),
(263960, NULL, 'PF13749', NULL, NULL, 'Putative ATP-dependent DNA helicase recG C-terminal', NULL, 'HATPase_c_4', NULL, NULL, 24491, 9),
(263961, NULL, 'PF03029', NULL, NULL, 'Conserved hypothetical ATP binding protein', NULL, 'ATP_bind_1', NULL, NULL, 2944, 9),
(263962, NULL, 'PF05016', NULL, NULL, 'ParE toxin of type II toxin-antitoxin system, parDE', NULL, 'ParE_toxin', NULL, NULL, 1111, 9),
(263963, NULL, 'PF06620', NULL, NULL, 'Protein of unknown function (DUF1150)', NULL, 'DUF1150', NULL, NULL, 10364, 9),
(263964, NULL, 'PF06833', NULL, NULL, 'Malonate decarboxylase gamma subunit (MdcE)', NULL, 'MdcE', NULL, NULL, NULL, 9),
(263965, NULL, 'PF11798', NULL, NULL, 'IMS family HHH motif', NULL, 'IMS_HHH', NULL, NULL, 7393, 9),
(263966, NULL, 'PF17001', NULL, NULL, 'Type III secretion basal body protein I, YscI, HrpB, PscI', NULL, 'T3SS_basalb_I', NULL, NULL, 12765, 9),
(263967, NULL, 'PF02254', NULL, NULL, 'TrkA-N domain', NULL, 'TrkA_N', NULL, NULL, 1978, 9),
(263968, NULL, 'PF03379', NULL, NULL, 'CcmB protein', NULL, 'CcmB', NULL, NULL, 7263, 9),
(263969, NULL, 'PF15150', NULL, NULL, 'Phorbol-12-myristate-13-acetate-induced', NULL, 'PMAIP1', NULL, NULL, 12233, 9),
(263970, NULL, 'PF16922', NULL, NULL, 'DNA replication complex GINS protein SLD5 C-terminus', NULL, 'SLD5_C', NULL, NULL, 25048, 9),
(263971, NULL, 'PF16959', NULL, NULL, 'Renal amino acid transporter', NULL, 'Collectrin', NULL, NULL, 22416, 9),
(263972, NULL, 'PF10245', NULL, NULL, 'Mitochondrial 28S ribosomal protein S22', NULL, 'MRP-S22', NULL, NULL, 15758, 9),
(263973, NULL, 'PF14167', NULL, NULL, 'YfkD-like protein', NULL, 'YfkD', NULL, NULL, 24095, 9),
(263974, NULL, 'PF09499', NULL, NULL, 'ApaLI-like restriction endonuclease', NULL, 'RE_ApaLI', NULL, NULL, 15577, 9),
(263975, NULL, 'PF05092', NULL, NULL, 'Per os infectivity', NULL, 'PIF', NULL, NULL, 2112, 9),
(263976, NULL, 'PF02725', NULL, NULL, 'Non-structural protein C', NULL, 'Paramyxo_NS_C', NULL, NULL, 4070, 9),
(263977, NULL, 'PF19637', NULL, NULL, 'Family of unknown function (DUF6140)', NULL, 'DUF6140', NULL, NULL, 37137, 9),
(263978, NULL, 'PF02264', NULL, NULL, 'LamB porin', NULL, 'LamB', NULL, NULL, 3069, 9),
(263979, NULL, 'PF10137', NULL, NULL, 'Predicted nucleotide-binding protein containing TIR-like domain', NULL, 'TIR-like', NULL, NULL, 14908, 9),
(263980, NULL, 'PF17729', NULL, NULL, 'Family of unknown function (DUF5569)', NULL, 'DUF5569', NULL, NULL, 31183, 9),
(263981, NULL, 'PF07009', NULL, NULL, 'NusG domain II', NULL, 'NusG_II', NULL, NULL, 18581, 9),
(263982, NULL, 'PF11459', NULL, NULL, 'Transcriptional regulator, AbiEi antitoxin, Type IV TA system', NULL, 'AbiEi_3', NULL, NULL, 18708, 9),
(263983, NULL, 'PF16689', NULL, NULL, 'Coiled-coil N-terminus of APC, dimerisation domain', NULL, 'APC_N_CC', NULL, NULL, 25904, 9),
(263984, NULL, 'PF16756', NULL, NULL, 'Partner and localizer of BRCA2 WD40 domain', NULL, 'PALB2_WD40', NULL, NULL, 22584, 9),
(263985, NULL, 'PF11003', NULL, NULL, 'Protein of unknown function (DUF2842)', NULL, 'DUF2842', NULL, NULL, 17819, 9),
(263986, NULL, 'PF10220', NULL, NULL, 'Smg8_Smg9', NULL, 'Smg8_Smg9', NULL, NULL, 15780, 9),
(263987, NULL, 'PF16720', NULL, NULL, 'Albumin I chain a', NULL, 'Albumin_I_a', NULL, NULL, 23307, 9),
(263988, NULL, 'PF02953', NULL, NULL, 'Tim10/DDP family zinc finger', NULL, 'zf-Tim10_DDP', NULL, NULL, 3783, 9),
(263989, NULL, 'PF04497', NULL, NULL, 'Poxviridae protein', NULL, 'Pox_E2-like', NULL, NULL, 18086, 9),
(263990, NULL, 'PF11653', NULL, NULL, 'Bacteriophage T7 virion assembly protein', NULL, 'VirionAssem_T7', NULL, NULL, 8787, 9),
(263991, NULL, 'PF05939', NULL, NULL, 'Phage minor tail protein', NULL, 'Phage_min_tail', NULL, NULL, 7617, 9),
(263992, NULL, 'PF04070', NULL, NULL, 'Domain of unknown function (DUF378)', NULL, 'DUF378', NULL, NULL, 6310, 9);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(263993, NULL, 'PF10284', NULL, NULL, 'Luciferase helical bundle domain', NULL, 'Luciferase_3H', NULL, NULL, 21137, 9),
(263994, NULL, 'PF13714', NULL, NULL, 'Phosphoenolpyruvate phosphomutase', NULL, 'PEP_mutase', NULL, NULL, NULL, 9),
(263995, NULL, 'PF16988', NULL, NULL, 'Vacuolar protein sorting 36 NZF-N zinc-finger domain', NULL, 'Vps36-NZF-N', NULL, NULL, 24160, 9),
(263996, NULL, 'PF12443', NULL, NULL, 'AT-hook-containing transcription factor', NULL, 'AKNA', NULL, NULL, 20884, 9),
(263997, NULL, 'PF06172', NULL, NULL, 'Cupin superfamily (DUF985)', NULL, 'Cupin_5', NULL, NULL, 14377, 9),
(263998, NULL, 'PF12305', NULL, NULL, 'Protein of unknown function (DUF3630)', NULL, 'DUF3630', NULL, NULL, 20862, 9),
(263999, NULL, 'PF13263', NULL, NULL, 'PHP-associated', NULL, 'PHP_C', NULL, NULL, NULL, 9),
(264000, NULL, 'PF11357', NULL, NULL, 'Cell cycle regulatory protein', NULL, 'Spy1', NULL, NULL, 14794, 9),
(264001, NULL, 'PF06131', NULL, NULL, 'Schizosaccharomyces pombe repeat of unknown function (DUF963)', NULL, 'DUF963', NULL, NULL, 13676, 9),
(264002, NULL, 'PF05663', NULL, NULL, 'Protein of unknown function (DUF809)', NULL, 'DUF809', NULL, NULL, 13043, 9),
(264003, NULL, 'PF04810', NULL, NULL, 'Sec23/Sec24 zinc finger', NULL, 'zf-Sec23_Sec24', NULL, NULL, 4816, 9),
(264004, NULL, 'PF01732', NULL, NULL, 'Mycoplasma peptidase (DUF31)', NULL, 'Mycop_pep_DUF31', NULL, NULL, 15862, 9),
(264005, NULL, 'PF13848', NULL, NULL, 'Thioredoxin-like domain', NULL, 'Thioredoxin_6', NULL, NULL, NULL, 9),
(264006, NULL, 'PF14183', NULL, NULL, 'YwpF-like protein', NULL, 'YwpF', NULL, NULL, 24245, 9),
(264007, NULL, 'PF18959', NULL, NULL, 'Family of unknown function (DUF5701)', NULL, 'DUF5701', NULL, NULL, 34957, 9),
(264008, NULL, 'PF14284', NULL, NULL, 'PcfJ-like protein', NULL, 'PcfJ', NULL, NULL, 22534, 9),
(264009, NULL, 'PF02013', NULL, NULL, 'Cellulose or protein binding domain', NULL, 'CBM_10', NULL, NULL, 5623, 9),
(264010, NULL, 'PF18163', NULL, NULL, 'SLOG cluster2', NULL, 'LD_cluster2', NULL, NULL, 28845, 9),
(264011, NULL, 'PF11628', NULL, NULL, 'T-cell surface glycoprotein CD3 zeta chain', NULL, 'TCR_zetazeta', NULL, NULL, 18569, 9),
(264012, NULL, 'PF19756', NULL, NULL, 'Family of unknown function (DUF6243)', NULL, 'DUF6243', NULL, NULL, 37329, 9),
(264013, NULL, 'PF07847', NULL, NULL, 'PCO_ADO', NULL, 'PCO_ADO', NULL, NULL, 12040, 9),
(264014, NULL, 'PF07126', NULL, NULL, 'Cell-division protein ZapC', NULL, 'ZapC', NULL, NULL, 13197, 9),
(264015, NULL, 'PF13851', NULL, NULL, 'Growth-arrest specific micro-tubule binding', NULL, 'GAS', NULL, NULL, 24723, 9),
(264016, NULL, 'PF19958', NULL, NULL, 'Effector-associated domain 6', NULL, 'EAD6', NULL, NULL, 35871, 9),
(264017, NULL, 'PF03602', NULL, NULL, 'Conserved hypothetical protein 95', NULL, 'Cons_hypoth95', NULL, NULL, NULL, 9),
(264018, NULL, 'PF09568', NULL, NULL, 'MjaI restriction endonuclease', NULL, 'RE_MjaI', NULL, NULL, 16710, 9),
(264019, NULL, 'PF09946', NULL, NULL, 'Predicted membrane protein (DUF2178)', NULL, 'DUF2178', NULL, NULL, 19429, 9),
(264020, NULL, 'PF20151', NULL, NULL, 'Family of unknown function (DUF6533)', NULL, 'DUF6533', NULL, NULL, 37461, 9),
(264021, NULL, 'PF10304', NULL, NULL, 'Required for nuclear transport of RNA pol II C-terminus 2', NULL, 'RTP1_C2', NULL, NULL, 16855, 9),
(264022, NULL, 'PF14359', NULL, NULL, 'Domain of unknown function (DUF4406)', NULL, 'DUF4406', NULL, NULL, 26322, 9),
(264023, NULL, 'PF08704', NULL, NULL, 'tRNA methyltransferase complex GCD14 subunit', NULL, 'GCD14', NULL, NULL, 11881, 9),
(264024, NULL, 'PF05372', NULL, NULL, 'Delta lysin family', NULL, 'Delta_lysin', NULL, NULL, 5187, 9),
(264025, NULL, 'PF10813', NULL, NULL, 'Herpesvirus UL11 homologue', NULL, 'Herpesvir_UL11', NULL, NULL, 22361, 9),
(264026, NULL, 'PF16165', NULL, NULL, 'Ferlin C-terminus', NULL, 'Ferlin_C', NULL, NULL, 22617, 9),
(264027, NULL, 'PF10490', NULL, NULL, 'Rb-binding domain of kinetochore protein Cenp-F/LEK1', NULL, 'CENP-F_C_Rb_bdg', NULL, NULL, 19745, 9),
(264028, NULL, 'PF02436', NULL, NULL, 'Conserved carboxylase domain', NULL, 'PYC_OADA', NULL, NULL, 4192, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(264029, NULL, 'PF18077', NULL, NULL, 'Domain of unknown function (DUF5595)', NULL, 'DUF5595', NULL, NULL, 28442, 9),
(264030, NULL, 'PF09348', NULL, NULL, 'Domain of unknown function (DUF1990)', NULL, 'DUF1990', NULL, NULL, 14551, 9),
(264031, NULL, 'PF05295', NULL, NULL, 'Luciferase/LBP N-terminal domain', NULL, 'Luciferase_N', NULL, NULL, 4301, 9),
(264032, NULL, 'PF14309', NULL, NULL, 'Domain of unknown function (DUF4378)', NULL, 'DUF4378', NULL, NULL, 26023, 9),
(264033, NULL, 'PF18454', NULL, NULL, 'Major tropism determinant N-terminal domain', NULL, 'Mtd_N', NULL, NULL, 29109, 9),
(264034, NULL, 'PF01006', NULL, NULL, 'Hepatitis C virus non-structural protein NS4a', NULL, 'HCV_NS4a', NULL, NULL, 6608, 9),
(264035, NULL, 'PF15390', NULL, NULL, 'WD repeat and coiled-coil-containing protein family', NULL, 'WDCP', NULL, NULL, 24732, 9),
(264036, NULL, 'PF15880', NULL, NULL, 'NADH dehydrogenase [ubiquinone] flavoprotein 3, mitochondrial', NULL, 'NDUFV3', NULL, NULL, 25438, 9),
(264037, NULL, 'PF02150', NULL, NULL, 'RNA polymerases M/15 Kd subunit', NULL, 'RNA_POL_M_15KD', NULL, NULL, 3296, 9),
(264038, NULL, 'PF13057', NULL, NULL, 'Protein of unknown function (DUF3919)', NULL, 'DUF3919', NULL, NULL, 22883, 9),
(264039, NULL, 'PF00866', NULL, NULL, 'Ring hydroxylating beta subunit', NULL, 'Ring_hydroxyl_B', NULL, NULL, 6824, 9),
(264040, NULL, 'PF18669', NULL, NULL, 'Trimeric autotransporter adhesin Trp ring domain', NULL, 'Trp_ring', NULL, NULL, 27507, 9),
(264041, NULL, 'PF13993', NULL, NULL, 'YccJ-like protein', NULL, 'YccJ', NULL, NULL, 22676, 9),
(264042, NULL, 'PF13723', NULL, NULL, 'Beta-ketoacyl synthase, N-terminal domain', NULL, 'Ketoacyl-synt_2', NULL, NULL, 12760, 9),
(264043, NULL, 'PF02435', NULL, NULL, 'Levansucrase/Invertase', NULL, 'Glyco_hydro_68', NULL, NULL, 6448, 9),
(264044, NULL, 'PF13356', NULL, NULL, 'Arm DNA-binding domain', NULL, 'Arm-DNA-bind_3', NULL, NULL, 26312, 9),
(264045, NULL, 'PF04027', NULL, NULL, 'Domain of unknown function (DUF371)', NULL, 'DUF371', NULL, NULL, 492, 9),
(264046, NULL, 'PF07249', NULL, NULL, 'Cerato-platanin', NULL, 'Cerato-platanin', NULL, NULL, 11492, 9),
(264047, NULL, 'PF02987', NULL, NULL, 'Late embryogenesis abundant protein', NULL, 'LEA_4', NULL, NULL, 3658, 9),
(264048, NULL, 'PF01828', NULL, NULL, 'Peptidase A4 family', NULL, 'Peptidase_A4', NULL, NULL, 4604, 9),
(264049, NULL, 'PF03686', NULL, NULL, 'Uncharacterised protein family (UPF0146)', NULL, 'UPF0146', NULL, NULL, 6191, 9),
(264050, NULL, 'PF12331', NULL, NULL, 'Protein of unknown function (DUF3636)', NULL, 'DUF3636', NULL, NULL, 20883, 9),
(264051, NULL, 'PF14229', NULL, NULL, 'Domain of unknown function (DUF4332)', NULL, 'DUF4332', NULL, NULL, 23404, 9),
(264052, NULL, 'PF15162', NULL, NULL, 'Protein SPO16 homolog', NULL, 'SCRE', NULL, NULL, 25901, 9),
(264053, NULL, 'PF14098', NULL, NULL, 'Small, acid-soluble spore protein I', NULL, 'SSPI', NULL, NULL, 14562, 9),
(264054, NULL, 'PF14957', NULL, NULL, 'Cdc42 effector', NULL, 'BORG_CEP', NULL, NULL, 21020, 9),
(264055, NULL, 'PF18300', NULL, NULL, 'Domain of unknown function (DUF5604)', NULL, 'DUF5604', NULL, NULL, 33188, 9),
(264056, NULL, 'PF01665', NULL, NULL, 'Rotavirus non-structural protein NSP3', NULL, 'Rota_NSP3', NULL, NULL, 5638, 9),
(264057, NULL, 'PF08214', NULL, NULL, 'Histone acetylation protein', NULL, 'HAT_KAT11', NULL, NULL, 17050, 9),
(264058, NULL, 'PF03215', NULL, NULL, 'Rad17 P-loop domain', NULL, 'Rad17', NULL, NULL, NULL, 9),
(264059, NULL, 'PF03833', NULL, NULL, 'DNA polymerase II large subunit DP2', NULL, 'PolC_DP2', NULL, NULL, 9275, 9),
(264060, NULL, 'PF20402', NULL, NULL, 'Domain of unknown function (DUF6692)', NULL, 'DUF6692', NULL, NULL, 37576, 9),
(264061, NULL, 'PF05937', NULL, NULL, 'EB-1 Binding Domain', NULL, 'EB1_binding', NULL, NULL, 12578, 9),
(264062, NULL, 'PF06223', NULL, NULL, 'Minor tail protein T', NULL, 'Phage_tail_T', NULL, NULL, 14288, 9),
(264063, NULL, 'PF06840', NULL, NULL, 'Protein of unknown function (DUF1241)', NULL, 'DUF1241', NULL, NULL, NULL, 9),
(264064, NULL, 'PF17887', NULL, NULL, 'Jak1 pleckstrin homology-like domain', NULL, 'Jak1_Phl', NULL, NULL, 29423, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(264065, NULL, 'PF12627', NULL, NULL, 'Probable RNA and SrmB- binding site of polymerase A', NULL, 'PolyA_pol_RNAbd', NULL, NULL, 21780, 9),
(264066, NULL, 'PF14800', NULL, NULL, 'Domain of unknown function (DUF4481)', NULL, 'DUF4481', NULL, NULL, 26938, 9),
(264067, NULL, 'PF17849', NULL, NULL, 'Dis3-like cold-shock domain 2 (CSD2)', NULL, 'OB_Dis3', NULL, NULL, 30034, 9),
(264068, NULL, 'PF18382', NULL, NULL, 'Formin N-terminal GTPase-binding domain', NULL, 'Formin_GBD_N', NULL, NULL, 29056, 9),
(264069, NULL, 'PF15601', NULL, NULL, 'Immunity protein 70', NULL, 'Imm70', NULL, NULL, 21985, 9),
(264070, NULL, 'PF13015', NULL, NULL, 'Glucosidase II beta subunit-like protein', NULL, 'PRKCSH_1', NULL, NULL, 28126, 9),
(264071, NULL, 'PF12811', NULL, NULL, 'Bax inhibitor 1 like', NULL, 'BaxI_1', NULL, NULL, 14098, 9),
(264072, NULL, 'PF03836', NULL, NULL, 'RasGAP C-terminus', NULL, 'RasGAP_C', NULL, NULL, 5509, 9),
(264073, NULL, 'PF05191', NULL, NULL, 'Adenylate kinase, active site lid', NULL, 'ADK_lid', NULL, NULL, 3292, 9),
(264074, NULL, 'PF13201', NULL, NULL, 'Putative carbohydrate metabolism domain', NULL, 'PCMD', NULL, NULL, 22486, 9),
(264075, NULL, 'PF13937', NULL, NULL, 'Domain of unknown function (DUF4212)', NULL, 'DUF4212', NULL, NULL, 18372, 9),
(264076, NULL, 'PF16099', NULL, NULL, 'Recq-mediated genome instability protein 1, C-terminal OB-fold', NULL, 'RMI1_C', NULL, NULL, 22274, 9),
(264077, NULL, 'PF05267', NULL, NULL, 'Protein of unknown function (DUF725)', NULL, 'DUF725', NULL, NULL, 4189, 9),
(264078, NULL, 'PF08456', NULL, NULL, 'Viral methyltransferase C-terminal', NULL, 'Vmethyltransf_C', NULL, NULL, 12253, 9),
(264079, NULL, 'PF09520', NULL, NULL, 'Type II restriction endonuclease, TdeIII', NULL, 'RE_TdeIII', NULL, NULL, 16881, 9),
(264080, NULL, 'PF06584', NULL, NULL, 'DIRP', NULL, 'DIRP', NULL, NULL, 30207, 9),
(264081, NULL, 'PF12458', NULL, NULL, 'ATPase involved in DNA repair', NULL, 'DUF3686', NULL, NULL, 14577, 9),
(264082, NULL, 'PF00339', NULL, NULL, 'Arrestin (or S-antigen), N-terminal domain', NULL, 'Arrestin_N', NULL, NULL, 9060, 9),
(264083, NULL, 'PF17516', NULL, NULL, 'ProQ C-terminal domain', NULL, 'ProQ_C', NULL, NULL, 15997, 9),
(264084, NULL, 'PF00872', NULL, NULL, 'Transposase, Mutator family', NULL, 'Transposase_mut', NULL, NULL, 1429, 9),
(264085, NULL, 'PF03772', NULL, NULL, 'Competence protein', NULL, 'Competence', NULL, NULL, 7400, 9),
(264086, NULL, 'PF03195', NULL, NULL, 'Lateral organ boundaries (LOB) domain', NULL, 'LOB', NULL, NULL, 7247, 9),
(264087, NULL, 'PF19215', NULL, NULL, 'Coronavirus replicase NSP15, uridylate-specific endoribonuclease', NULL, 'CoV_NSP15_C', NULL, NULL, 35411, 9),
(264088, NULL, 'PF17075', NULL, NULL, 'Regular of rDNA transcription protein 14', NULL, 'RRT14', NULL, NULL, 23809, 9),
(264089, NULL, 'PF11513', NULL, NULL, 'Thermoplasma acidophilum protein TA0956', NULL, 'TA0956', NULL, NULL, 18954, 9),
(264090, NULL, 'PF13080', NULL, NULL, 'Protein of unknown function (DUF3926)', NULL, 'DUF3926', NULL, NULL, 22964, 9),
(264091, NULL, 'PF05013', NULL, NULL, 'N-formylglutamate amidohydrolase', NULL, 'FGase', NULL, NULL, 1227, 9),
(264092, NULL, 'PF14030', NULL, NULL, 'Protein of unknown function (DUF4245)', NULL, 'DUF4245', NULL, NULL, 22345, 9),
(264093, NULL, 'PF19759', NULL, NULL, 'Family of unknown function (DUF6246)', NULL, 'DUF6246', NULL, NULL, 37208, 9),
(264094, NULL, 'PF11101', NULL, NULL, 'Protein of unknown function (DUF2884)', NULL, 'DUF2884', NULL, NULL, 17916, 9),
(264095, NULL, 'PF20135', NULL, NULL, 'Family of unknown function (DUF6525)', NULL, 'DUF6525', NULL, NULL, 35946, 9),
(264096, NULL, 'PF16688', NULL, NULL, 'Replicase polyprotein N-term from Coronavirus nsp1', NULL, 'CNV-Replicase_N', NULL, NULL, 25687, 9),
(264097, NULL, 'PF03720', NULL, NULL, 'UDP-glucose/GDP-mannose dehydrogenase family, UDP binding domain', NULL, 'UDPG_MGDP_dh_C', NULL, NULL, 8527, 9),
(264098, NULL, 'PF06143', NULL, NULL, 'Baculovirus 11 kDa family', NULL, 'Baculo_11_kDa', NULL, NULL, 14011, 9),
(264099, NULL, 'PF12389', NULL, NULL, 'Camelysin metallo-endopeptidase', NULL, 'Peptidase_M73', NULL, NULL, 20898, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(264100, NULL, 'PF07305', NULL, NULL, 'Protein of unknown function (DUF1454)', NULL, 'DUF1454', NULL, NULL, 7947, 9),
(264101, NULL, 'PF08242', NULL, NULL, 'Methyltransferase domain', NULL, 'Methyltransf_12', NULL, NULL, 12372, 9),
(264102, NULL, 'PF12639', NULL, NULL, 'DNase/tRNase domain of colicin-like bacteriocin', NULL, 'Colicin-DNase', NULL, NULL, NULL, 9),
(264103, NULL, 'PF09211', NULL, NULL, 'Domain of unknown function (DUF1958)', NULL, 'DUF1958', NULL, NULL, 12088, 9),
(264104, NULL, 'PF10917', NULL, NULL, 'Fungus-induced protein', NULL, 'Fungus-induced', NULL, NULL, 23736, 9),
(264105, NULL, 'PF03299', NULL, NULL, 'Transcription factor AP-2', NULL, 'TF_AP-2', NULL, NULL, 11385, 9),
(264106, NULL, 'PF17558', NULL, NULL, 'Androgenic gland hormone', NULL, 'AGH', NULL, NULL, 20626, 9),
(264107, NULL, 'PF06495', NULL, NULL, 'Fruit fly transformer protein', NULL, 'Transformer', NULL, NULL, 12293, 9),
(264108, NULL, 'PF10704', NULL, NULL, 'Protein of unknown function (DUF2508)', NULL, 'DUF2508', NULL, NULL, 20830, 9),
(264109, NULL, 'PF19844', NULL, NULL, 'Family of unknown function (DUF6319)', NULL, 'DUF6319', NULL, NULL, 37746, 9),
(264110, NULL, 'PF02382', NULL, NULL, 'N-terminal domain in RTX protein', NULL, 'RTX', NULL, NULL, 14523, 9),
(264111, NULL, 'PF02763', NULL, NULL, 'Diphtheria toxin, C domain', NULL, 'Diphtheria_C', NULL, NULL, 21460, 9),
(264112, NULL, 'PF08943', NULL, NULL, 'CsiD', NULL, 'CsiD', NULL, NULL, 7932, 9),
(264113, NULL, 'PF09523', NULL, NULL, 'Protein of unknown function (DUF2390)', NULL, 'DUF2390', NULL, NULL, 10956, 9),
(264114, NULL, 'PF12189', NULL, NULL, 'Single-strand DNA-binding protein', NULL, 'VirE1', NULL, NULL, 20116, 9),
(264115, NULL, 'PF11424', NULL, NULL, 'Protein of unknown function (DUF3195)', NULL, 'DUF3195', NULL, NULL, 18601, 9),
(264116, NULL, 'PF17481', NULL, NULL, 'Phage tail sheath protein beta-sandwich domain', NULL, 'Phage_sheath_1N', NULL, NULL, 9825, 9),
(264117, NULL, 'PF05700', NULL, NULL, 'Breast carcinoma amplified sequence 2 (BCAS2)', NULL, 'BCAS2', NULL, NULL, 8737, 9),
(264118, NULL, 'PF07409', NULL, NULL, 'Phage protein GP46', NULL, 'GP46', NULL, NULL, 11878, 9),
(264119, NULL, 'PF07709', NULL, NULL, 'Seven Residue Repeat', NULL, 'SRR', NULL, NULL, 8015, 9),
(264120, NULL, 'PF03918', NULL, NULL, 'Cytochrome C biogenesis protein', NULL, 'CcmH', NULL, NULL, 2771, 9),
(264121, NULL, 'PF13559', NULL, NULL, 'Domain of unknown function (DUF4129)', NULL, 'DUF4129', NULL, NULL, 22078, 9),
(264122, NULL, 'PF05211', NULL, NULL, 'Neuraminyllactose-binding hemagglutinin precursor (NLBH)', NULL, 'NLBH', NULL, NULL, 3148, 9),
(264123, NULL, 'PF07650', NULL, NULL, 'KH domain', NULL, 'KH_2', NULL, NULL, 967, 9),
(264124, NULL, 'PF10261', NULL, NULL, 'Inositol phospholipid synthesis and fat-storage-inducing TM', NULL, 'Scs3p', NULL, NULL, 15927, 9),
(264125, NULL, 'PF20158', NULL, NULL, 'Cas5fv helical domain', NULL, 'Cas5fv_helical', NULL, NULL, 35978, 9),
(264126, NULL, 'PF10016', NULL, NULL, 'Predicted secreted protein (DUF2259)', NULL, 'DUF2259', NULL, NULL, 17128, 9),
(264127, NULL, 'PF02311', NULL, NULL, 'AraC-like ligand binding domain', NULL, 'AraC_binding', NULL, NULL, 3537, 9),
(264128, NULL, 'PF08778', NULL, NULL, 'HIF-1 alpha C terminal transactivation domain', NULL, 'HIF-1a_CTAD', NULL, NULL, 13389, 9),
(264129, NULL, 'PF11957', NULL, NULL, 'THO complex subunit 1 transcription elongation factor', NULL, 'efThoc1', NULL, NULL, 19997, 9),
(264130, NULL, 'PF04458', NULL, NULL, 'Protein of unknown function (DUF505)', NULL, 'DUF505', NULL, NULL, 3774, 9),
(264131, NULL, 'PF06254', NULL, NULL, 'Putative bacterial toxin ydaT', NULL, 'YdaT_toxin', NULL, NULL, 14247, 9),
(264132, NULL, 'PF04359', NULL, NULL, 'Protein of unknown function (DUF493)', NULL, 'DUF493', NULL, NULL, 4894, 9),
(264133, NULL, 'PF19553', NULL, NULL, 'Family of unknown function (DUF6076)', NULL, 'DUF6076', NULL, NULL, 34299, 9),
(264134, NULL, 'PF04688', NULL, NULL, 'SPP1 phage holin', NULL, 'Holin_SPP1', NULL, NULL, 6359, 9),
(264135, NULL, 'PF09172', NULL, NULL, 'Vitellinogen, open beta-sheet', NULL, 'Vit_open_b-sht', NULL, NULL, 12087, 9);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(264136, NULL, 'PF03045', NULL, NULL, 'DAN domain', NULL, 'DAN', NULL, NULL, 2559, 9),
(264137, NULL, 'PF02768', NULL, NULL, 'DNA polymerase III beta subunit, C-terminal domain', NULL, 'DNA_pol3_beta_3', NULL, NULL, 17134, 9),
(264138, NULL, 'PF12038', NULL, NULL, 'Domain of unknown function (DUF3524)', NULL, 'DUF3524', NULL, NULL, 14776, 9),
(264139, NULL, 'PF00195', NULL, NULL, 'Chalcone and stilbene synthases, N-terminal domain', NULL, 'Chal_sti_synt_N', NULL, NULL, 2198, 9),
(264140, NULL, 'PF11959', NULL, NULL, 'Domain of unknown function (DUF3473)', NULL, 'DUF3473', NULL, NULL, 16133, 9),
(264141, NULL, 'PF03083', NULL, NULL, 'Sugar efflux transporter for intercellular exchange', NULL, 'MtN3_slv', NULL, NULL, 4527, 9),
(264142, NULL, 'PF07379', NULL, NULL, 'Protein of unknown function (DUF1494)', NULL, 'DUF1494', NULL, NULL, 8235, 9),
(264143, NULL, 'PF17486', NULL, NULL, 'Cystine knot toxins', NULL, 'Cys_Knot_tox', NULL, NULL, 15722, 9),
(264144, NULL, 'PF18698', NULL, NULL, 'Histidine kinase sensor domain', NULL, 'HisK_sensor', NULL, NULL, 30941, 9),
(264145, NULL, 'PF19570', NULL, NULL, 'Family of unknown function (DUF6088)', NULL, 'DUF6088', NULL, NULL, 34219, 9),
(264146, NULL, 'PF18537', NULL, NULL, 'Carbon monoxide dehydrogenase subunit alpha N-terminal domain', NULL, 'CODH_A_N', NULL, NULL, 29185, 9),
(264147, NULL, 'PF19430', NULL, NULL, 'TBC1 domain family member 23 C-terminal', NULL, 'TBC1D23_C', NULL, NULL, 37277, 9),
(264148, NULL, 'PF20185', NULL, NULL, 'Family of unknown function (DUF6548)', NULL, 'DUF6548', NULL, NULL, 37185, 9),
(264149, NULL, 'PF01353', NULL, NULL, 'Green fluorescent protein', NULL, 'GFP', NULL, NULL, 11341, 9),
(264150, NULL, 'PF14553', NULL, NULL, 'YqbF, hypothetical protein domain', NULL, 'YqbF', NULL, NULL, 24253, 9),
(264151, NULL, 'PF07795', NULL, NULL, 'Protein of unknown function (DUF1635)', NULL, 'DUF1635', NULL, NULL, 12296, 9),
(264152, NULL, 'PF04342', NULL, NULL, 'Putative member of DMT superfamily (DUF486)', NULL, 'DMT_6', NULL, NULL, 3905, 9),
(264153, NULL, 'PF07392', NULL, NULL, 'Cyclin-dependent kinase inhibitor 2a p19Arf N-terminus', NULL, 'P19Arf_N', NULL, NULL, 11793, 9),
(264154, NULL, 'PF07764', NULL, NULL, 'Omega Transcriptional Repressor', NULL, 'Omega_Repress', NULL, NULL, 10934, 9),
(264155, NULL, 'PF10222', NULL, NULL, 'Uncharacterized conserved protein (DUF2152)', NULL, 'DUF2152', NULL, NULL, 19391, 9),
(264156, NULL, 'PF16741', NULL, NULL, 'mRNA-decapping enzyme C-terminus', NULL, 'mRNA_decap_C', NULL, NULL, 22845, 9),
(264157, NULL, 'PF09722', NULL, NULL, 'Antitoxin Xre/MbcA/ParS C-terminal toxin-binding domain', NULL, 'Xre_MbcA_ParS_C', NULL, NULL, 21582, 9),
(264158, NULL, 'PF10630', NULL, NULL, 'Protein of unknown function (DUF2476)', NULL, 'DUF2476', NULL, NULL, 20594, 9),
(264159, NULL, 'PF10916', NULL, NULL, 'Protein of unknown function (DUF2712)', NULL, 'DUF2712', NULL, NULL, 18724, 9),
(264160, NULL, 'PF14148', NULL, NULL, 'YhdB-like protein', NULL, 'YhdB', NULL, NULL, 26331, 9),
(264161, NULL, 'PF02063', NULL, NULL, 'MARCKS family', NULL, 'MARCKS', NULL, NULL, 1309, 9),
(264162, NULL, 'PF06056', NULL, NULL, 'Putative ATPase subunit of terminase (gpP-like)', NULL, 'Terminase_5', NULL, NULL, 8625, 9),
(264163, NULL, 'PF15624', NULL, NULL, 'Kinetochore CENP-C fungal homologue, Mif2, N-terminal', NULL, 'Mif2_N', NULL, NULL, 25340, 9),
(264164, NULL, 'PF10209', NULL, NULL, 'Uncharacterized conserved protein (DUF2340)', NULL, 'DUF2340', NULL, NULL, 19042, 9),
(264165, NULL, 'PF04069', NULL, NULL, 'Substrate binding domain of ABC-type glycine betaine transport system', NULL, 'OpuAC', NULL, NULL, 6200, 9),
(264166, NULL, 'PF11312', NULL, NULL, 'Putative SAM-dependent methyltransferase', NULL, 'Methyltransf_34', NULL, NULL, 18249, 9),
(264167, NULL, 'PF08609', NULL, NULL, 'Nucleotide exchange factor Fes1', NULL, 'Fes1', NULL, NULL, 14365, 9),
(264168, NULL, 'PF03722', NULL, NULL, 'Hemocyanin, all-alpha domain', NULL, 'Hemocyanin_N', NULL, NULL, 5452, 9),
(264169, NULL, 'PF07622', NULL, NULL, 'Protein of unknown function (DUF1583) C domain', NULL, 'DUF1583', NULL, NULL, 13805, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(264170, NULL, 'PF18258', NULL, NULL, 'Interleukin-4 inducing immunoglobulin-binding domain', NULL, 'IL4_i_Ig', NULL, NULL, 29791, 9),
(264171, NULL, 'PF15914', NULL, NULL, 'FAM193 family C-terminal', NULL, 'FAM193_C', NULL, NULL, 24467, 9),
(264172, NULL, 'PF10510', NULL, NULL, 'Phosphatidylinositol-glycan biosynthesis class S protein', NULL, 'PIG-S', NULL, NULL, 19458, 9),
(264173, NULL, 'PF16035', NULL, NULL, 'Chalcone isomerase like', NULL, 'Chalcone_2', NULL, NULL, 10041, 9),
(264174, NULL, 'PF07297', NULL, NULL, 'Dolichol phosphate-mannose biosynthesis regulatory protein (DPM2)', NULL, 'DPM2', NULL, NULL, 14060, 9),
(264175, NULL, 'PF08463', NULL, NULL, 'EcoEI R protein C-terminal', NULL, 'EcoEI_R_C', NULL, NULL, 13691, 9),
(264176, NULL, 'PF04311', NULL, NULL, 'Protein of unknown function (DUF459)', NULL, 'DUF459', NULL, NULL, 3647, 9),
(264177, NULL, 'PF08047', NULL, NULL, 'Histidine operon leader peptide', NULL, 'His_leader', NULL, NULL, 9062, 9),
(264178, NULL, 'PF14454', NULL, NULL, 'Prokaryotic Ubiquitin', NULL, 'Prok_Ub', NULL, NULL, 25240, 9),
(264179, NULL, 'PF01279', NULL, NULL, 'Parathyroid hormone family', NULL, 'Parathyroid', NULL, NULL, 6344, 9),
(264180, NULL, 'PF08258', NULL, NULL, 'WWamide peptide', NULL, 'WWamide', NULL, NULL, NULL, 9),
(264181, NULL, 'PF03637', NULL, NULL, 'Mob1/phocein family', NULL, 'Mob1_phocein', NULL, NULL, 5469, 9),
(264182, NULL, 'PF07275', NULL, NULL, 'Antirestriction protein (ArdA)', NULL, 'ArdA', NULL, NULL, 14066, 9),
(264183, NULL, 'PF11217', NULL, NULL, 'Protein of unknown function (DUF3013)', NULL, 'DUF3013', NULL, NULL, 18396, 9),
(264184, NULL, 'PF15522', NULL, NULL, 'Novel toxin 14', NULL, 'Ntox14', NULL, NULL, 23781, 9),
(264185, NULL, 'PF16528', NULL, NULL, 'Exocyst component 84 C-terminal', NULL, 'Exo84_C', NULL, NULL, 25181, 9),
(264186, NULL, 'PF02660', NULL, NULL, 'Glycerol-3-phosphate acyltransferase', NULL, 'G3P_acyltransf', NULL, NULL, 6290, 9),
(264187, NULL, 'PF12669', NULL, NULL, 'FeoB-associated Cys-rich membrane protein', NULL, 'FeoB_associated', NULL, NULL, NULL, 9),
(264188, NULL, 'PF13363', NULL, NULL, 'Beta-galactosidase, domain 3', NULL, 'BetaGal_dom3', NULL, NULL, 22419, 9),
(264189, NULL, 'PF03411', NULL, NULL, 'Penicillin-insensitive murein endopeptidase', NULL, 'Peptidase_M74', NULL, NULL, 10450, 9),
(264190, NULL, 'PF02058', NULL, NULL, 'Guanylin precursor', NULL, 'Guanylin', NULL, NULL, 4544, 9),
(264191, NULL, 'PF04806', NULL, NULL, 'EspF protein repeat', NULL, 'EspF', NULL, NULL, 4757, 9),
(264192, NULL, 'PF12083', NULL, NULL, 'Domain of unknown function (DUF3560)', NULL, 'DUF3560', NULL, NULL, 20017, 9),
(264193, NULL, 'PF16310', NULL, NULL, 'Domian of unknown function (DUF4952)', NULL, 'DUF4952', NULL, NULL, 25884, 9),
(264194, NULL, 'PF16322', NULL, NULL, 'Tubby N-terminal', NULL, 'Tub_N', NULL, NULL, 7259, 9),
(264195, NULL, 'PF15813', NULL, NULL, 'Domain of unknown function (DUF4708)', NULL, 'DUF4708', NULL, NULL, 23779, 9),
(264196, NULL, 'PF07479', NULL, NULL, 'NAD-dependent glycerol-3-phosphate dehydrogenase C-terminus', NULL, 'NAD_Gly3P_dh_C', NULL, NULL, 10276, 9),
(264197, NULL, 'PF01613', NULL, NULL, 'Flavin reductase like domain', NULL, 'Flavin_Reduct', NULL, NULL, 1941, 9),
(264198, NULL, 'PF17801', NULL, NULL, 'Alpha galactosidase C-terminal beta sandwich domain', NULL, 'Melibiase_C', NULL, NULL, 30218, 9),
(264199, NULL, 'PF20167', NULL, NULL, 'Putative plant transposon protein', NULL, 'Transposase_32', NULL, NULL, 37317, 9),
(264200, NULL, 'PF10506', NULL, NULL, 'PDZ domain of MCC-2 bdg protein for Usher syndrome', NULL, 'MCC-bdg_PDZ', NULL, NULL, 19201, 9),
(264201, NULL, 'PF08591', NULL, NULL, 'Ribonucleotide reductase inhibitor', NULL, 'RNR_inhib', NULL, NULL, 17871, 9),
(264202, NULL, 'PF16804', NULL, NULL, 'Domain of unknown function (DUF5071)', NULL, 'DUF5071', NULL, NULL, 22073, 9),
(264203, NULL, 'PF14599', NULL, NULL, 'Zinc-ribbon', NULL, 'zinc_ribbon_6', NULL, NULL, 33805, 9),
(264204, NULL, 'PF01445', NULL, NULL, 'Viral small hydrophobic protein', NULL, 'SH', NULL, NULL, 6295, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(264205, NULL, 'PF19332', NULL, NULL, 'E3 ubiquitin-protein ligase RNF180 C-terminus', NULL, 'RNF180_C', NULL, NULL, 37009, 9),
(264206, NULL, 'PF01108', NULL, NULL, 'Tissue factor', NULL, 'Tissue_fac', NULL, NULL, 7389, 9),
(264207, NULL, 'PF02233', NULL, NULL, 'NAD(P) transhydrogenase beta subunit', NULL, 'PNTB', NULL, NULL, 25363, 9),
(264208, NULL, 'PF00075', NULL, NULL, 'RNase H', NULL, 'RNase_H', NULL, NULL, 285, 9),
(264209, NULL, 'PF15409', NULL, NULL, 'Pleckstrin homology domain', NULL, 'PH_8', NULL, NULL, 29654, 9),
(264210, NULL, 'PF00557', NULL, NULL, 'Metallopeptidase family M24', NULL, 'Peptidase_M24', NULL, NULL, 3310, 9),
(264211, NULL, 'PF18758', NULL, NULL, 'Kyakuja-Dileera-Zisupton transposase', NULL, 'KDZ', NULL, NULL, 31969, 9),
(264212, NULL, 'PF09634', NULL, NULL, 'Protein of unknown function (DUF2025)', NULL, 'DUF2025', NULL, NULL, 14921, 9),
(264213, NULL, 'PF07722', NULL, NULL, 'Peptidase C26', NULL, 'Peptidase_C26', NULL, NULL, 10916, 9),
(264214, NULL, 'PF04201', NULL, NULL, 'Tumour protein D52 family', NULL, 'TPD52', NULL, NULL, 5335, 9),
(264215, NULL, 'PF00920', NULL, NULL, 'Dehydratase family', NULL, 'ILVD_EDD', NULL, NULL, 5963, 9),
(264216, NULL, 'PF13874', NULL, NULL, 'Nucleoporin complex subunit 54', NULL, 'Nup54', NULL, NULL, 24261, 9),
(264217, NULL, 'PF01618', NULL, NULL, 'MotA/TolQ/ExbB proton channel family', NULL, 'MotA_ExbB', NULL, NULL, 6008, 9),
(264218, NULL, 'PF17901', NULL, NULL, 'EF-hand fold domain', NULL, 'EF-hand_12', NULL, NULL, 29748, 9),
(264219, NULL, 'PF14968', NULL, NULL, 'Coiled coil protein 84', NULL, 'CCDC84', NULL, NULL, 21789, 9),
(264220, NULL, 'PF15414', NULL, NULL, 'Protein of unknown function (DUF4621)', NULL, 'DUF4621', NULL, NULL, 24033, 9),
(264221, NULL, 'PF03951', NULL, NULL, 'Glutamine synthetase, beta-Grasp domain', NULL, 'Gln-synt_N', NULL, NULL, 7182, 9),
(264222, NULL, 'PF03975', NULL, NULL, 'CheD chemotactic sensory transduction', NULL, 'CheD', NULL, NULL, 3505, 9),
(264223, NULL, 'PF18151', NULL, NULL, 'Domain of unknown function (DUF5601)', NULL, 'DUF5601', NULL, NULL, 30748, 9),
(264224, NULL, 'PF11996', NULL, NULL, 'Protein of unknown function (DUF3491)', NULL, 'DUF3491', NULL, NULL, 19747, 9),
(264225, NULL, 'PF20461', NULL, NULL, 'Family of unknown function (DUF6714)', NULL, 'DUF6714', NULL, NULL, 37571, 9),
(264226, NULL, 'PF10208', NULL, NULL, 'ARMET, C-terminal', NULL, 'ARMET_C', NULL, NULL, 15904, 9),
(264227, NULL, 'PF20581', NULL, NULL, 'Family of unknown function (DUF6785)', NULL, 'DUF6785', NULL, NULL, 37349, 9),
(264228, NULL, 'PF06804', NULL, NULL, 'NlpB/DapX lipoprotein', NULL, 'Lipoprotein_18', NULL, NULL, 9040, 9),
(264229, NULL, 'PF15909', NULL, NULL, 'C2H2-type zinc ribbon', NULL, 'zf-C2H2_8', NULL, NULL, 24472, 9),
(264230, NULL, 'PF04803', NULL, NULL, 'Cor1/Xlr/Xmr conserved region', NULL, 'Cor1', NULL, NULL, 4987, 9),
(264231, NULL, 'PF03964', NULL, NULL, 'Chorion family 2', NULL, 'Chorion_2', NULL, NULL, 2759, 9),
(264232, NULL, 'PF05782', NULL, NULL, 'Extracellular matrix protein 1 (ECM1)', NULL, 'ECM1', NULL, NULL, 14292, 9),
(264233, NULL, 'PF14385', NULL, NULL, 'Domain of unknown function (DUF4416)', NULL, 'DUF4416', NULL, NULL, 26010, 9),
(264234, NULL, 'PF04597', NULL, NULL, 'Ribophorin I', NULL, 'Ribophorin_I', NULL, NULL, 734, 9),
(264235, NULL, 'PF06262', NULL, NULL, 'Zincin-like metallopeptidase', NULL, 'Zincin_1', NULL, NULL, 9154, 9),
(264236, NULL, 'PF02670', NULL, NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase', NULL, 'DXP_reductoisom', NULL, NULL, 9347, 9),
(264237, NULL, 'PF04465', NULL, NULL, 'Protein of unknown function (DUF499)', NULL, 'DUF499', NULL, NULL, 3594, 9),
(264238, NULL, 'PF14172', NULL, NULL, 'Domain of unknown function (DUF4309)', NULL, 'DUF4309', NULL, NULL, 26080, 9),
(264239, NULL, 'PF13013', NULL, NULL, 'F-box-like domain', NULL, 'F-box-like_2', NULL, NULL, 4804, 9),
(264240, NULL, 'PF16298', NULL, NULL, 'Domain of unknown function (DUF4940)', NULL, 'DUF4940', NULL, NULL, 25812, 9),
(264241, NULL, 'PF16857', NULL, NULL, 'RNA polymerase inhibitor', NULL, 'RNA_pol_inhib', NULL, NULL, 21160, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(264242, NULL, 'PF02809', NULL, NULL, 'Ubiquitin interaction motif', NULL, 'UIM', NULL, NULL, 4073, 9),
(264243, NULL, 'PF20071', NULL, NULL, 'Family of unknown function (DUF6467)', NULL, 'DUF6467', NULL, NULL, 35780, 9),
(264244, NULL, 'PF06920', NULL, NULL, 'DHR-2, Lobe A', NULL, 'DHR-2_Lobe_A', NULL, NULL, 33880, 9),
(264245, NULL, 'PF06633', NULL, NULL, 'Protein of unknown function (DUF1155)', NULL, 'DUF1155', NULL, NULL, 10264, 9),
(264246, NULL, 'PF17619', NULL, NULL, 'Secreted clade V proteins', NULL, 'SCVP', NULL, NULL, 28050, 9),
(264247, NULL, 'PF01433', NULL, NULL, 'Peptidase family M1 domain', NULL, 'Peptidase_M1', NULL, NULL, 8808, 9),
(264248, NULL, 'PF07700', NULL, NULL, 'Haem-NO-binding', NULL, 'HNOB', NULL, NULL, 10826, 9),
(264249, NULL, 'PF00387', NULL, NULL, 'Phosphatidylinositol-specific phospholipase C, Y domain', NULL, 'PI-PLC-Y', NULL, NULL, 3438, 9),
(264250, NULL, 'PF07035', NULL, NULL, 'Colon cancer-associated protein Mic1-like', NULL, 'Mic1', NULL, NULL, 12038, 9),
(264251, NULL, 'PF20109', NULL, NULL, 'Family of unknown function (DUF6499)', NULL, 'DUF6499', NULL, NULL, 36414, 9),
(264252, NULL, 'PF03516', NULL, NULL, 'Filaggrin', NULL, 'Filaggrin', NULL, NULL, 3203, 9),
(264253, NULL, 'PF15827', NULL, NULL, 'UPF0730 unknown protein family', NULL, 'UPF0730', NULL, NULL, 25802, 9),
(264254, NULL, 'PF20266', NULL, NULL, 'Mab-21 protein HhH/H2TH-like domain', NULL, 'Mab-21_C', NULL, NULL, 34069, 9),
(264255, NULL, 'PF00902', NULL, NULL, 'Sec-independent protein translocase protein (TatC)', NULL, 'TatC', NULL, NULL, 5257, 9),
(264256, NULL, 'PF03562', NULL, NULL, 'MltA specific insert domain', NULL, 'MltA', NULL, NULL, 5267, 9),
(264257, NULL, 'PF12055', NULL, NULL, 'Domain of unknown function (DUF3536)', NULL, 'DUF3536', NULL, NULL, 19680, 9),
(264258, NULL, 'PF18086', NULL, NULL, 'Diphosphoinositol pentakisphosphate kinase 2 N-terminal domain', NULL, 'PPIP5K2_N', NULL, NULL, 27469, 9),
(264259, NULL, 'PF19720', NULL, NULL, 'Family of unknown function (DUF6214)', NULL, 'DUF6214', NULL, NULL, 37029, 9),
(264260, NULL, 'PF01184', NULL, NULL, 'GPR1/FUN34/yaaH family', NULL, 'Gpr1_Fun34_YaaH', NULL, NULL, 6839, 9),
(264261, NULL, 'PF10067', NULL, NULL, 'Predicted membrane protein (DUF2306)', NULL, 'DUF2306', NULL, NULL, 18324, 9),
(264262, NULL, 'PF08781', NULL, NULL, 'Transcription factor DP', NULL, 'DP', NULL, NULL, 13311, 9),
(264263, NULL, 'PF16718', NULL, NULL, 'Immunity factor for SPN', NULL, 'IFS', NULL, NULL, 23380, 9),
(264264, NULL, 'PF19938', NULL, NULL, 'Family of unknown function (DUF6400)', NULL, 'DUF6400', NULL, NULL, 36339, 9),
(264265, NULL, 'PF04049', NULL, NULL, 'Anaphase promoting complex subunit 8 / Cdc23', NULL, 'ANAPC8', NULL, NULL, 1365, 9),
(264266, NULL, 'PF17114', NULL, NULL, 'Gef2-related medial cortical node protein Nod1', NULL, 'Nod1', NULL, NULL, 21515, 9),
(264267, NULL, 'PF16823', NULL, NULL, 'Atypical PilZ domain, cyclic di-GMP receptor', NULL, 'tPilZ', NULL, NULL, 25586, 9),
(264268, NULL, 'PF00350', NULL, NULL, 'Dynamin family', NULL, 'Dynamin_N', NULL, NULL, 36595, 9),
(264269, NULL, 'PF11934', NULL, NULL, 'Domain of unknown function (DUF3452)', NULL, 'DUF3452', NULL, NULL, 26972, 9),
(264270, NULL, 'PF00245', NULL, NULL, 'Alkaline phosphatase', NULL, 'Alk_phosphatase', NULL, NULL, 2005, 9),
(264271, NULL, 'PF03297', NULL, NULL, 'S25 ribosomal protein', NULL, 'Ribosomal_S25', NULL, NULL, 773, 9),
(264272, NULL, 'PF04928', NULL, NULL, 'Poly(A) polymerase central domain', NULL, 'PAP_central', NULL, NULL, 6739, 9),
(264273, NULL, 'PF13764', NULL, NULL, 'E3 ubiquitin-protein ligase UBR4', NULL, 'E3_UbLigase_R4', NULL, NULL, 23524, 9),
(264274, NULL, 'PF09010', NULL, NULL, 'Anti-Sigma Factor A', NULL, 'AsiA', NULL, NULL, 8684, 9),
(264275, NULL, 'PF11413', NULL, NULL, 'Hypoxia-inducible factor-1', NULL, 'HIF-1', NULL, NULL, 18572, 9),
(264276, NULL, 'PF04684', NULL, NULL, 'BAF1 / ABF1 chromatin reorganising factor', NULL, 'BAF1_ABF1', NULL, NULL, 3036, 9),
(264277, NULL, 'PF16072', NULL, NULL, 'Domain of unknown function (DUF4813)', NULL, 'DUF4813', NULL, NULL, 24256, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(264278, NULL, 'PF17377', NULL, NULL, 'Family of unknown function (DUF5399)', NULL, 'DUF5399', NULL, NULL, 16125, 9),
(264279, NULL, 'PF10517', NULL, NULL, 'Electron transfer DM13', NULL, 'DM13', NULL, NULL, 19302, 9),
(264280, NULL, 'PF17483', NULL, NULL, 'C-lobe handle domain of Tf-binding protein B', NULL, 'TbpB_C', NULL, NULL, 15971, 9),
(264281, NULL, 'PF01797', NULL, NULL, 'Transposase IS200 like', NULL, 'Y1_Tnp', NULL, NULL, 2933, 9),
(264282, NULL, 'PF05795', NULL, NULL, 'Plasmodium vivax Vir protein', NULL, 'Plasmodium_Vir', NULL, NULL, 12234, 9),
(264283, NULL, 'PF03073', NULL, NULL, 'TspO/MBR family', NULL, 'TspO_MBR', NULL, NULL, 4649, 9),
(264284, NULL, 'PF16657', NULL, NULL, 'Maltogenic Amylase, C-terminal domain', NULL, 'Malt_amylase_C', NULL, NULL, 22582, 9),
(264285, NULL, 'PF17567', NULL, NULL, 'Family of unknown function (DUF5473)', NULL, 'DUF5473', NULL, NULL, 31379, 9),
(264286, NULL, 'PF08559', NULL, NULL, 'Cut8, nuclear proteasome tether protein', NULL, 'Cut8', NULL, NULL, 9685, 9),
(264287, NULL, 'PF08984', NULL, NULL, 'Domain of unknown function (DUF1858)', NULL, 'DUF1858', NULL, NULL, 8757, 9),
(264288, NULL, 'PF16638', NULL, NULL, 'Unstructured region on methyltransferase between zinc-fingers', NULL, 'Tristanin_u2', NULL, NULL, NULL, 9),
(264289, NULL, 'PF09547', NULL, NULL, 'Stage IV sporulation protein A, ATPase domain', NULL, 'SpoIVA_ATPase', NULL, NULL, 34171, 9),
(264290, NULL, 'PF06146', NULL, NULL, 'Phosphate-starvation-inducible E family', NULL, 'PsiE', NULL, NULL, 14758, 9),
(264291, NULL, 'PF07683', NULL, NULL, 'Cobalamin synthesis protein cobW C-terminal domain', NULL, 'CobW_C', NULL, NULL, 10685, 9),
(264292, NULL, 'PF10360', NULL, NULL, 'Protein of unknown function (DUF2433)', NULL, 'DUF2433', NULL, NULL, 20026, 9),
(264293, NULL, 'PF02739', NULL, NULL, '5''-3'' exonuclease, N-terminal resolvase-like domain', NULL, '5_3_exonuc_N', NULL, NULL, 15506, 9),
(264294, NULL, 'PF03596', NULL, NULL, 'Cadmium resistance transporter', NULL, 'Cad', NULL, NULL, 3421, 9),
(264295, NULL, 'PF10733', NULL, NULL, 'Protein of unknown function (DUF2525)', NULL, 'DUF2525', NULL, NULL, 21113, 9),
(264296, NULL, 'PF16154', NULL, NULL, 'Domain of unknown function (DUF4862)', NULL, 'DUF4862', NULL, NULL, 26309, 9),
(264297, NULL, 'PF20594', NULL, NULL, 'Domain of unknown function (DUF6794)', NULL, 'DUF6794', NULL, NULL, 37427, 9),
(264298, NULL, 'PF02023', NULL, NULL, 'SCAN domain', NULL, 'SCAN', NULL, NULL, 1239, 9),
(264299, NULL, 'PF06412', NULL, NULL, 'Conjugal transfer protein TraD', NULL, 'TraD', NULL, NULL, 8142, 9),
(264300, NULL, 'PF00820', NULL, NULL, 'Borrelia lipoprotein', NULL, 'Lipoprotein_1', NULL, NULL, 4330, 9),
(264301, NULL, 'PF12583', NULL, NULL, 'Tripeptidyl peptidase II N terminal', NULL, 'TPPII_N', NULL, NULL, 21154, 9),
(264302, NULL, 'PF01855', NULL, NULL, 'Pyruvate flavodoxin/ferredoxin oxidoreductase, thiamine diP-bdg', NULL, 'POR_N', NULL, NULL, 5721, 9),
(264303, NULL, 'PF04622', NULL, NULL, 'ERG2 and Sigma1 receptor like protein', NULL, 'ERG2_Sigma1R', NULL, NULL, 2012, 9),
(264304, NULL, 'PF00002', NULL, NULL, '7 transmembrane receptor (Secretin family)', NULL, '7tm_2', NULL, NULL, 172, 9),
(264305, NULL, 'PF11591', NULL, NULL, 'Ferredoxin chloroplastic transit peptide', NULL, '2Fe-2S_Ferredox', NULL, NULL, 15986, 9),
(264306, NULL, 'PF01295', NULL, NULL, 'Adenylate cyclase, class-I', NULL, 'Adenylate_cycl', NULL, NULL, 4922, 9),
(264307, NULL, 'PF09081', NULL, NULL, 'Glucan 1,4-alpha-maltotetraohydrolase, domain C', NULL, 'AMT4_dom_C', NULL, NULL, 9894, 9),
(264308, NULL, 'PF12881', NULL, NULL, 'NUT protein', NULL, 'NUT', NULL, NULL, 24679, 9),
(264309, NULL, 'PF19731', NULL, NULL, 'Family of unknown function (DUF6222)', NULL, 'DUF6222', NULL, NULL, 37049, 9),
(264310, NULL, 'PF02109', NULL, NULL, 'DAD family', NULL, 'DAD', NULL, NULL, 29, 9),
(264311, NULL, 'PF01674', NULL, NULL, 'Lipase (class 2)', NULL, 'Lipase_2', NULL, NULL, 6046, 9),
(264312, NULL, 'PF00341', NULL, NULL, 'PDGF/VEGF domain', NULL, 'PDGF', NULL, NULL, 2821, 9),
(264313, NULL, 'PF20348', NULL, NULL, 'Family of unknown function (DUF6643)', NULL, 'DUF6643', NULL, NULL, 33964, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(264314, NULL, 'PF10892', NULL, NULL, 'Protein of unknown function (DUF2688)', NULL, 'DUF2688', NULL, NULL, 23762, 9),
(264315, NULL, 'PF03110', NULL, NULL, 'SBP domain', NULL, 'SBP', NULL, NULL, 4825, 9),
(264316, NULL, 'PF02338', NULL, NULL, 'OTU-like cysteine protease', NULL, 'OTU', NULL, NULL, 4490, 9),
(264317, NULL, 'PF07065', NULL, NULL, 'D123', NULL, 'D123', NULL, NULL, 12802, 9),
(264318, NULL, 'PF09870', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2097)', NULL, 'DUF2097', NULL, NULL, 19242, 9),
(264319, NULL, 'PF06283', NULL, NULL, 'Trehalose utilisation', NULL, 'ThuA', NULL, NULL, 24050, 9),
(264320, NULL, 'PF06755', NULL, NULL, 'CbtA_toxin of type IV toxin-antitoxin system', NULL, 'CbtA_toxin', NULL, NULL, 1668, 9),
(264321, NULL, 'PF17146', NULL, NULL, 'PIN domain of ribonuclease', NULL, 'PIN_6', NULL, NULL, 32970, 9),
(264322, NULL, 'PF15475', NULL, NULL, 'Transmembrane protein C12orf23, UPF0444', NULL, 'UPF0444', NULL, NULL, 23508, 9),
(264323, NULL, 'PF17452', NULL, NULL, 'Uncharacterized YnfE-like', NULL, 'YnfE', NULL, NULL, 20292, 9),
(264324, NULL, 'PF17746', NULL, NULL, 'SfsA N-terminal OB domain', NULL, 'SfsA_N', NULL, NULL, 29579, 9),
(264325, NULL, 'PF08115', NULL, NULL, 'SFI toxin family', NULL, 'Toxin_28', NULL, NULL, 10290, 9),
(264326, NULL, 'PF20060', NULL, NULL, 'Family of unknown function (DUF6459)', NULL, 'DUF6459', NULL, NULL, 36334, 9),
(264327, NULL, 'PF09226', NULL, NULL, 'Restriction endonuclease HincII', NULL, 'Endonuc-HincII', NULL, NULL, 13418, 9),
(264328, NULL, 'PF07958', NULL, NULL, 'Protein of unknown function (DUF1688)', NULL, 'DUF1688', NULL, NULL, 14282, 9),
(264329, NULL, 'PF09271', NULL, NULL, 'LAG1, DNA binding', NULL, 'LAG1-DNAbind', NULL, NULL, 13094, 9),
(264330, NULL, 'PF16304', NULL, NULL, 'Domain of unknown function (DUF4946)', NULL, 'DUF4946', NULL, NULL, 25786, 9),
(264331, NULL, 'PF18337', NULL, NULL, 'RapA N-terminal Tudor like domain', NULL, 'Tudor_RapA', NULL, NULL, 27727, 9),
(264332, NULL, 'PF14784', NULL, NULL, 'C-terminal domain of the ECSIT protein', NULL, 'ECSIT_C', NULL, NULL, 21945, 9),
(264333, NULL, 'PF00425', NULL, NULL, 'chorismate binding enzyme', NULL, 'Chorismate_bind', NULL, NULL, 18432, 9),
(264334, NULL, 'PF11487', NULL, NULL, 'Type II restriction enzyme SfiI', NULL, 'RestrictionSfiI', NULL, NULL, 18890, 9),
(264335, NULL, 'PF02401', NULL, NULL, 'LytB protein', NULL, 'LYTB', NULL, NULL, 5344, 9),
(264336, NULL, 'PF00289', NULL, NULL, 'Biotin carboxylase, N-terminal domain', NULL, 'Biotin_carb_N', NULL, NULL, 742, 9),
(264337, NULL, 'PF00375', NULL, NULL, 'Sodium:dicarboxylate symporter family', NULL, 'SDF', NULL, NULL, 2426, 9),
(264338, NULL, 'PF07487', NULL, NULL, 'SopE GEF domain', NULL, 'SopE_GEF', NULL, NULL, 7921, 9),
(264339, NULL, 'PF07099', NULL, NULL, 'Protein of unknown function (DUF1361)', NULL, 'DUF1361', NULL, NULL, 13285, 9),
(264340, NULL, 'PF08140', NULL, NULL, 'Crustacean cuticle protein repeat', NULL, 'Cuticle_1', NULL, NULL, 8847, 9),
(264341, NULL, 'PF17589', NULL, NULL, 'Family of unknown function (DUF5487)', NULL, 'DUF5487', NULL, NULL, 12818, 9),
(264342, NULL, 'PF10096', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2334)', NULL, 'DUF2334', NULL, NULL, 18378, 9),
(264343, NULL, 'PF12942', NULL, NULL, 'Archaeal ammonia monooxygenase subunit A (AmoA)', NULL, 'Archaeal_AmoA', NULL, NULL, 24521, 9),
(264344, NULL, 'PF01400', NULL, NULL, 'Astacin (Peptidase family M12A)', NULL, 'Astacin', NULL, NULL, 4051, 9),
(264345, NULL, 'PF12519', NULL, NULL, 'Mitochondrial distribution and morphology protein 10', NULL, 'MDM10', NULL, NULL, 23916, 9),
(264346, NULL, 'PF08898', NULL, NULL, 'Domain of unknown function (DUF1843)', NULL, 'DUF1843', NULL, NULL, 7987, 9),
(264347, NULL, 'PF14027', NULL, NULL, 'Questin oxidase-like', NULL, 'Questin_oxidase', NULL, NULL, 22351, 9),
(264348, NULL, 'PF13895', NULL, NULL, 'Immunoglobulin domain', NULL, 'Ig_2', NULL, NULL, 401, 9),
(264349, NULL, 'PF00703', NULL, NULL, 'Glycosyl hydrolases family 2', NULL, 'Glyco_hydro_2', NULL, NULL, 2751, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(264350, NULL, 'PF05026', NULL, NULL, 'Dcp2, box A domain', NULL, 'DCP2', NULL, NULL, 1144, 9),
(264351, NULL, 'PF07160', NULL, NULL, 'Spindle and kinetochore-associated protein 1', NULL, 'SKA1', NULL, NULL, 13050, 9),
(264352, NULL, 'PF07997', NULL, NULL, 'Protein of unknown function (DUF1694)', NULL, 'DUF1694', NULL, NULL, 8715, 9),
(264353, NULL, 'PF06905', NULL, NULL, 'Fas apoptotic inhibitory molecule (FAIM1)', NULL, 'FAIM1', NULL, NULL, 9549, 9),
(264354, NULL, 'PF17841', NULL, NULL, 'BID domain of Bartonella effector protein (Bep)', NULL, 'Bep_C_terminal', NULL, NULL, 29882, 9),
(264355, NULL, 'PF19375', NULL, NULL, 'Family of unknown function (DUF5950)', NULL, 'DUF5950', NULL, NULL, 36594, 9),
(264356, NULL, 'PF12089', NULL, NULL, 'Transmembrane domain of unknown function (DUF3566)', NULL, 'DUF3566', NULL, NULL, 20040, 9),
(264357, NULL, 'PF18097', NULL, NULL, 'Vta1 C-terminal domain', NULL, 'Vta1_C', NULL, NULL, 28553, 9),
(264358, NULL, 'PF01425', NULL, NULL, 'Amidase', NULL, 'Amidase', NULL, NULL, 16111, 9),
(264359, NULL, 'PF00481', NULL, NULL, 'Protein phosphatase 2C', NULL, 'PP2C', NULL, NULL, 2124, 9),
(264360, NULL, 'PF00064', NULL, NULL, 'Neuraminidase', NULL, 'Neur', NULL, NULL, 4359, 9),
(264361, NULL, 'PF11494', NULL, NULL, 'Ta0938', NULL, 'Ta0938', NULL, NULL, 18998, 9),
(264362, NULL, 'PF07374', NULL, NULL, 'Protein of unknown function (DUF1492)', NULL, 'DUF1492', NULL, NULL, 11957, 9),
(264363, NULL, 'PF20307', NULL, NULL, 'Divergent DnaB-like ATPase', NULL, 'divDNAB', NULL, NULL, 37732, 9),
(264364, NULL, 'PF05716', NULL, NULL, 'A-kinase anchor protein 110 kDa (AKAP 110)', NULL, 'AKAP_110', NULL, NULL, 15724, 9),
(264365, NULL, 'PF18289', NULL, NULL, 'CCDC81 eukaryotic HU domain 2', NULL, 'HU-CCDC81_euk_2', NULL, NULL, 28496, 9),
(264366, NULL, 'PF07175', NULL, NULL, 'Osteoregulin', NULL, 'Osteoregulin', NULL, NULL, 13243, 9),
(264367, NULL, 'PF19018', NULL, NULL, 'Vanin C-terminal domain', NULL, 'Vanin_C', NULL, NULL, 35513, 9),
(264368, NULL, 'PF13262', NULL, NULL, 'Protein of unknown function (DUF4054)', NULL, 'DUF4054', NULL, NULL, 22881, 9),
(264369, NULL, 'PF18704', NULL, NULL, 'Chromatin organization modifier domain 2', NULL, 'Chromo_2', NULL, NULL, 31280, 9),
(264370, NULL, 'PF19514', NULL, NULL, 'MobC-like protein', NULL, 'MobC_2', NULL, NULL, 36208, 9),
(264371, NULL, 'PF14637', NULL, NULL, 'Folliculin-interacting protein middle domain', NULL, 'FNIP_M', NULL, NULL, 23056, 9),
(264372, NULL, 'PF09471', NULL, NULL, 'IgA Peptidase M64', NULL, 'Peptidase_M64', NULL, NULL, 15837, 9),
(264373, NULL, 'PF17488', NULL, NULL, 'Herpesvirus glycoprotein H C-terminal domain', NULL, 'Herpes_glycoH_C', NULL, NULL, 9562, 9),
(264374, NULL, 'PF06516', NULL, NULL, 'Purine nucleoside permease (NUP)', NULL, 'NUP', NULL, NULL, 9034, 9),
(264375, NULL, 'PF08992', NULL, NULL, 'Quinohemoprotein amine dehydrogenase, gamma subunit', NULL, 'QH-AmDH_gamma', NULL, NULL, 8705, 9),
(264376, NULL, 'PF04614', NULL, NULL, 'Pex19 protein family', NULL, 'Pex19', NULL, NULL, 2175, 9),
(264377, NULL, 'PF10520', NULL, NULL, 'Lipid desaturase domain', NULL, 'Lipid_desat', NULL, NULL, 19172, 9),
(264378, NULL, 'PF06699', NULL, NULL, 'GPI biosynthesis protein family Pig-F', NULL, 'PIG-F', NULL, NULL, 865, 9),
(264379, NULL, 'PF06901', NULL, NULL, 'RTX iron-regulated protein FrpC', NULL, 'FrpC', NULL, NULL, 9646, 9),
(264380, NULL, 'PF11988', NULL, NULL, 'Retrograde transport protein Dsl1 N terminal', NULL, 'Dsl1_N', NULL, NULL, 19893, 9),
(264381, NULL, 'PF06880', NULL, NULL, 'Protein of unknown function (DUF1262)', NULL, 'DUF1262', NULL, NULL, 9117, 9),
(264382, NULL, 'PF14910', NULL, NULL, 'S-phase genomic integrity recombination mediator, N-terminal', NULL, 'MMS22L_N', NULL, NULL, 24921, 9),
(264383, NULL, 'PF12212', NULL, NULL, 'PAZ domain', NULL, 'PAZ_2', NULL, NULL, 18088, 9),
(264384, NULL, 'PF10605', NULL, NULL, '3HB-oligomer hydrolase (3HBOH)', NULL, '3HBOH', NULL, NULL, 17594, 9),
(264385, NULL, 'PF18962', NULL, NULL, 'Secretion system C-terminal sorting domain', NULL, 'Por_Secre_tail', NULL, NULL, 23496, 9); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(264386, NULL, 'PF02269', NULL, NULL, 'Transcription initiation factor IID, 18kD subunit', NULL, 'TFIID-18kDa', NULL, NULL, 4025, 9),
(264387, NULL, 'PF11224', NULL, NULL, 'Protein of unknown function (DUF3023)', NULL, 'DUF3023', NULL, NULL, 18448, 9),
(264388, NULL, 'PF14552', NULL, NULL, 'Tautomerase enzyme', NULL, 'Tautomerase_2', NULL, NULL, 33435, 9),
(264389, NULL, 'PF08596', NULL, NULL, 'Lethal giant larvae(Lgl) like, C-terminal', NULL, 'Lgl_C', NULL, NULL, 17544, 9),
(264390, NULL, 'PF11065', NULL, NULL, 'Protein of unknown function (DUF2866)', NULL, 'DUF2866', NULL, NULL, 17592, 9),
(264391, NULL, 'PF03366', NULL, NULL, 'YEATS family', NULL, 'YEATS', NULL, NULL, 1202, 9),
(264392, NULL, 'PF11690', NULL, NULL, 'Protein of unknown function (DUF3287)', NULL, 'DUF3287', NULL, NULL, 19494, 9),
(264393, NULL, 'PF09711', NULL, NULL, 'CRISPR-associated protein (Cas_Csn2)', NULL, 'Cas_Csn2', NULL, NULL, 10713, 9),
(264394, NULL, 'PF16079', NULL, NULL, 'Phage holin family Hol44, in holin superfamily V', NULL, 'Phage_holin_5_2', NULL, NULL, 23829, 9),
(264395, NULL, 'PF14496', NULL, NULL, 'C-terminal novel E3 ligase, LRR-interacting', NULL, 'NEL', NULL, NULL, 23003, 9),
(264396, NULL, 'PF13905', NULL, NULL, 'Thioredoxin-like', NULL, 'Thioredoxin_8', NULL, NULL, 7704, 9),
(264397, NULL, 'PF19890', NULL, NULL, 'Domain of unknown function (DUF6363)', NULL, 'DUF6363', NULL, NULL, 36914, 9),
(264398, NULL, 'PF19052', NULL, NULL, 'BMP/retinoic acid-inducible neural-specific protein', NULL, 'BRINP', NULL, NULL, 31363, 9),
(264399, NULL, 'PF09663', NULL, NULL, 'Amidohydrolase ring-opening protein (Amido_AtzD_TrzD)', NULL, 'Amido_AtzD_TrzD', NULL, NULL, 14274, 9),
(264400, NULL, 'PF18430', NULL, NULL, 'Putative DNA-binding domain', NULL, 'DBD_HTH', NULL, NULL, 29324, 9),
(264401, NULL, 'PF19649', NULL, NULL, 'Family of unknown function (DUF6152)', NULL, 'DUF6152', NULL, NULL, 37032, 9),
(264402, NULL, 'PF00484', NULL, NULL, 'Carbonic anhydrase', NULL, 'Pro_CA', NULL, NULL, 3319, 9),
(264403, NULL, 'PF12406', NULL, NULL, 'Surface protein', NULL, 'DUF3664', NULL, NULL, 20988, 9),
(264404, NULL, 'PF13365', NULL, NULL, 'Trypsin-like peptidase domain', NULL, 'Trypsin_2', NULL, NULL, NULL, 9),
(264405, NULL, 'PF05493', NULL, NULL, 'ATP synthase subunit H', NULL, 'ATP_synt_H', NULL, NULL, 7688, 9),
(264406, NULL, 'PF06247', NULL, NULL, 'Pvs28 EGF domain', NULL, 'Plasmod_Pvs28', NULL, NULL, 9199, 9),
(264407, NULL, 'PF04885', NULL, NULL, 'Stigma-specific protein, Stig1', NULL, 'Stig1', NULL, NULL, 5643, 9),
(264408, NULL, 'PF00518', NULL, NULL, 'Early Protein (E6)', NULL, 'E6', NULL, NULL, 2348, 9),
(264409, NULL, 'PF02162', NULL, NULL, 'XYPPX repeat (two copies)', NULL, 'XYPPX', NULL, NULL, 1027, 9),
(264410, NULL, 'PF06856', NULL, NULL, 'Autographa californica nuclear polyhedrosis virus (AcMNPV), Orf17', NULL, 'AcMNPV_Orf17', NULL, NULL, 11488, 9),
(264411, NULL, 'PF09132', NULL, NULL, 'BmKX', NULL, 'BmKX', NULL, NULL, 10907, 9),
(264412, NULL, 'PF12044', NULL, NULL, 'Putative peptidase family', NULL, 'Metallopep', NULL, NULL, 19616, 9),
(264413, NULL, 'PF04042', NULL, NULL, 'DNA polymerase alpha/epsilon subunit B', NULL, 'DNA_pol_E_B', NULL, NULL, 970, 9),
(264414, NULL, 'PF18852', NULL, NULL, 'Large polyvalent protein associated domain 34', NULL, 'LPD34', NULL, NULL, 28100, 9),
(264415, NULL, 'PF06854', NULL, NULL, 'Bacteriophage Gp15 protein', NULL, 'Phage_Gp15', NULL, NULL, 11180, 9),
(264416, NULL, 'PF03702', NULL, NULL, 'Anhydro-N-acetylmuramic acid kinase', NULL, 'AnmK', NULL, NULL, 6303, 9),
(264417, NULL, 'PF05774', NULL, NULL, 'Herpesvirus helicase-primase complex component', NULL, 'Herpes_heli_pri', NULL, NULL, 12740, 9),
(264418, NULL, 'PF20390', NULL, NULL, 'Family of unknown function (DUF6685)', NULL, 'DUF6685', NULL, NULL, 37691, 9),
(264419, NULL, 'PF14748', NULL, NULL, 'Pyrroline-5-carboxylate reductase dimerisation', NULL, 'P5CR_dimer', NULL, NULL, 24062, 9),
(264420, NULL, 'PF13667', NULL, NULL, 'ThiC-associated domain', NULL, 'ThiC-associated', NULL, NULL, 24968, 9),
(264421, NULL, 'PF01156', NULL, NULL, 'Inosine-uridine preferring nucleoside hydrolase', NULL, 'IU_nuc_hydro', NULL, NULL, 4261, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(264422, NULL, 'PF17935', NULL, NULL, 'Tetracyclin repressor-like, C-terminal domain', NULL, 'TetR_C_27', NULL, NULL, 30284, 9),
(264423, NULL, 'PF10624', NULL, NULL, 'Plasmid conjugative transfer entry exclusion protein TraS', NULL, 'TraS', NULL, NULL, 20741, 9),
(264424, NULL, 'PF16356', NULL, NULL, 'Domain of unknown function (DUF4983)', NULL, 'DUF4983', NULL, NULL, 25439, 9),
(264425, NULL, 'PF09931', NULL, NULL, 'Uncharacterized conserved protein (DUF2163)', NULL, 'DUF2163', NULL, NULL, 19297, 9),
(264426, NULL, 'PF09919', NULL, NULL, 'Uncharacterized conserved protein (DUF2149)', NULL, 'DUF2149', NULL, NULL, 17331, 9),
(264427, NULL, 'PF09988', NULL, NULL, 'Uncharacterized metal-binding protein (DUF2227)', NULL, 'DUF2227', NULL, NULL, 19527, 9),
(264428, NULL, 'PF19274', NULL, NULL, 'PI4-kinase N-terminal region', NULL, 'PI4K_N', NULL, NULL, 37236, 9),
(264429, NULL, 'PF12801', NULL, NULL, '4Fe-4S binding domain', NULL, 'Fer4_5', NULL, NULL, 12567, 9),
(264430, NULL, 'PF15425', NULL, NULL, 'Domain of unknown function (DUF4627)', NULL, 'DUF4627', NULL, NULL, 24259, 9),
(264431, NULL, 'PF12695', NULL, NULL, 'Alpha/beta hydrolase family', NULL, 'Abhydrolase_5', NULL, NULL, 24918, 9),
(264432, NULL, 'PF04363', NULL, NULL, 'Protein of unknown function (DUF496)', NULL, 'DUF496', NULL, NULL, 4689, 9),
(264433, NULL, 'PF00356', NULL, NULL, 'Bacterial regulatory proteins, lacI family', NULL, 'LacI', NULL, NULL, 411, 9),
(264434, NULL, 'PF15819', NULL, NULL, 'Fin bud initiation factor homologue', NULL, 'Fibin', NULL, NULL, 24310, 9),
(264435, NULL, 'PF19678', NULL, NULL, 'Family of unknown function (DUF6180)', NULL, 'DUF6180', NULL, NULL, 36128, 9),
(264436, NULL, 'PF12755', NULL, NULL, 'Vacuolar 14 Fab1-binding region', NULL, 'Vac14_Fab1_bd', NULL, NULL, NULL, 9),
(264437, NULL, 'PF19497', NULL, NULL, 'Family of unknown function (DUF6032)', NULL, 'DUF6032', NULL, NULL, 36667, 9),
(264438, NULL, 'PF02800', NULL, NULL, 'Glyceraldehyde 3-phosphate dehydrogenase, C-terminal domain', NULL, 'Gp_dh_C', NULL, NULL, 18534, 9),
(264439, NULL, 'PF19454', NULL, NULL, 'Family of unknown function (DUF5992)', NULL, 'DUF5992', NULL, NULL, 36582, 9),
(264440, NULL, 'PF06635', NULL, NULL, 'Type 3 secretion system stator protein', NULL, 'T3SS_SCTL', NULL, NULL, 8276, 9),
(264441, NULL, 'PF19352', NULL, NULL, 'Tetracyclin repressor-like, C-terminal domain', NULL, 'TetR_C_38', NULL, NULL, 10516, 9),
(264442, NULL, 'PF20038', NULL, NULL, 'Helix-turn-helix domain', NULL, 'HTH_59', NULL, NULL, 35781, 9),
(264443, NULL, 'PF17123', NULL, NULL, 'RING-like zinc finger', NULL, 'zf-RING_11', NULL, NULL, 4043, 9),
(264444, NULL, 'PF07234', NULL, NULL, 'Movement and RNA silencing protein', NULL, 'Babuvirus_MP', NULL, NULL, 14349, 9),
(264445, NULL, 'PF07732', NULL, NULL, 'Multicopper oxidase', NULL, 'Cu-oxidase_3', NULL, NULL, 8266, 9),
(264446, NULL, 'PF09822', NULL, NULL, 'ABC-type uncharacterized transport system', NULL, 'ABC_transp_aux', NULL, NULL, 18275, 9),
(264447, NULL, 'PF12348', NULL, NULL, 'CLASP N terminal', NULL, 'CLASP_N', NULL, NULL, 24471, 9),
(264448, NULL, 'PF04043', NULL, NULL, 'Plant invertase/pectin methylesterase inhibitor', NULL, 'PMEI', NULL, NULL, 6731, 9),
(264449, NULL, 'PF18004', NULL, NULL, '26S proteasome regulatory subunit RPN2 C-terminal domain', NULL, 'RPN2_C', NULL, NULL, 27822, 9),
(264450, NULL, 'PF05543', NULL, NULL, 'Staphopain peptidase C47', NULL, 'Peptidase_C47', NULL, NULL, 12483, 9),
(264451, NULL, 'PF17029', NULL, NULL, 'Domain of unknown function (DUF5100)', NULL, 'DUF5100', NULL, NULL, 22810, 9),
(264452, NULL, 'PF03351', NULL, NULL, 'DOMON domain', NULL, 'DOMON', NULL, NULL, NULL, 9),
(264453, NULL, 'PF18650', NULL, NULL, 'Immunomodulating metalloprotease N-terminal domain', NULL, 'IMPa_N_2', NULL, NULL, 28081, 9),
(264454, NULL, 'PF00943', NULL, NULL, 'Alphavirus E2 glycoprotein', NULL, 'Alpha_E2_glycop', NULL, NULL, 3468, 9),
(264455, NULL, 'PF07420', NULL, NULL, 'Protein of unknown function (DUF1509)', NULL, 'DUF1509', NULL, NULL, 11746, 9),
(264456, NULL, 'PF05212', NULL, NULL, 'Protein of unknown function (DUF707)', NULL, 'DUF707', NULL, NULL, 3228, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(264457, NULL, 'PF10688', NULL, NULL, 'Bacterial inner membrane protein', NULL, 'Imp-YgjV', NULL, NULL, 20671, 9),
(264458, NULL, 'PF19118', NULL, NULL, 'Family of unknown function (DUF5802)', NULL, 'DUF5802', NULL, NULL, 36213, 9),
(264459, NULL, 'PF14072', NULL, NULL, 'DNA-sulfur modification-associated', NULL, 'DndB', NULL, NULL, 16577, 9),
(264460, NULL, 'PF02261', NULL, NULL, 'Aspartate decarboxylase', NULL, 'Asp_decarbox', NULL, NULL, 1642, 9),
(264461, NULL, 'PF17054', NULL, NULL, 'Microtubule-Associated protein Jupiter', NULL, 'JUPITER', NULL, NULL, 29775, 9),
(264462, NULL, 'PF11205', NULL, NULL, 'Protein of unknown function (DUF2987)', NULL, 'DUF2987', NULL, NULL, 18031, 9),
(264463, NULL, 'PF14476', NULL, NULL, 'Petal formation-expressed', NULL, 'Chloroplast_duf', NULL, NULL, 22912, 9),
(264464, NULL, 'PF17309', NULL, NULL, 'Family of unknown function (DUF5356)', NULL, 'DUF5356', NULL, NULL, 16813, 9),
(264465, NULL, 'PF13753', NULL, NULL, 'Putative flagellar system-associated repeat', NULL, 'SWM_repeat', NULL, NULL, 26565, 9),
(264466, NULL, 'PF14185', NULL, NULL, 'Antitoxin SpoIISB, type II toxin-antitoxin system', NULL, 'SpoIISB_antitox', NULL, NULL, 21688, 9),
(264467, NULL, 'PF11347', NULL, NULL, 'Protein of unknown function (DUF3148)', NULL, 'DUF3148', NULL, NULL, 18570, 9),
(264468, NULL, 'PF08512', NULL, NULL, 'Histone chaperone Rttp106-like', NULL, 'Rtt106', NULL, NULL, 14101, 9),
(264469, NULL, 'PF11631', NULL, NULL, 'Protein of unknown function (DUF3255)', NULL, 'DUF3255', NULL, NULL, 18679, 9),
(264470, NULL, 'PF03866', NULL, NULL, 'Hydrophobic abundant protein (HAP)', NULL, 'HAP', NULL, NULL, 1839, 9),
(264471, NULL, 'PF08297', NULL, NULL, 'U3 snoRNA associated', NULL, 'U3_snoRNA_assoc', NULL, NULL, 13065, 9),
(264472, NULL, 'PF01861', NULL, NULL, 'Branched-chain polyamine synthase A C-terminal domain', NULL, 'BpsA_C', NULL, NULL, 3764, 9),
(264473, NULL, 'PF13211', NULL, NULL, 'Protein of unknown function (DUF4019)', NULL, 'DUF4019', NULL, NULL, 22730, 9),
(264474, NULL, 'PF00431', NULL, NULL, 'CUB domain', NULL, 'CUB', NULL, NULL, 3339, 9),
(264475, NULL, 'PF12206', NULL, NULL, 'Domain of unknown function (DUF3599)', NULL, 'DUF3599', NULL, NULL, 21539, 9),
(264476, NULL, 'PF09698', NULL, NULL, 'Geobacter CxxxxCH...CXXCH motif (GSu_C4xC__C2xCH)', NULL, 'GSu_C4xC__C2xCH', NULL, NULL, 4049, 9),
(264477, NULL, 'PF19287', NULL, NULL, 'Family of unknown function (DUF5910)', NULL, 'DUF5910', NULL, NULL, 37057, 9),
(264478, NULL, 'PF07565', NULL, NULL, 'Band 3 cytoplasmic domain', NULL, 'Band_3_cyto', NULL, NULL, 8597, 9),
(264479, NULL, 'PF19225', NULL, NULL, 'Spo16 protein', NULL, 'Spo16', NULL, NULL, 35991, 9),
(264480, NULL, 'PF17023', NULL, NULL, 'Domain of unknown function (DUF5098)', NULL, 'DUF5098', NULL, NULL, 22978, 9),
(264481, NULL, 'PF08291', NULL, NULL, 'Peptidase M15', NULL, 'Peptidase_M15_3', NULL, NULL, 12305, 9),
(264482, NULL, 'PF09907', NULL, NULL, 'HigB_toxin, RelE-like toxic component of a toxin-antitoxin system', NULL, 'HigB_toxin', NULL, NULL, 17156, 9),
(264483, NULL, 'PF12500', NULL, NULL, 'TRSP domain C terminus to PRTase_2', NULL, 'TRSP', NULL, NULL, 16076, 9),
(264484, NULL, 'PF09599', NULL, NULL, 'Salmonella-Shigella invasin protein C (IpaC_SipC)', NULL, 'IpaC_SipC', NULL, NULL, 197, 9),
(264485, NULL, 'PF00219', NULL, NULL, 'Insulin-like growth factor binding protein', NULL, 'IGFBP', NULL, NULL, 4626, 9),
(264486, NULL, 'PF00622', NULL, NULL, 'SPRY domain', NULL, 'SPRY', NULL, NULL, 6285, 9),
(264487, NULL, 'PF11590', NULL, NULL, 'DNA polymerase catalytic subunit Pol', NULL, 'DNAPolymera_Pol', NULL, NULL, 18883, 9),
(264488, NULL, 'PF13169', NULL, NULL, 'Poxvirus B22R protein N-terminal', NULL, 'Poxvirus_B22R_N', NULL, NULL, 22117, 9),
(264489, NULL, 'PF03887', NULL, NULL, 'YfbU domain', NULL, 'YfbU', NULL, NULL, 1556, 9),
(264490, NULL, 'PF07948', NULL, NULL, 'Nairovirus M polyprotein-like', NULL, 'Nairovirus_M', NULL, NULL, 12752, 9),
(264491, NULL, 'PF17189', NULL, NULL, 'Glycosyl hydrolase family 30 beta sandwich domain', NULL, 'Glyco_hydro_30C', NULL, NULL, 32261, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(264492, NULL, 'PF20455', NULL, NULL, 'Family of unknown function (DUF6708)', NULL, 'DUF6708', NULL, NULL, 37618, 9),
(264493, NULL, 'PF15938', NULL, NULL, 'Domain of unknown function (DUF4750)', NULL, 'DUF4750', NULL, NULL, 25589, 9),
(264494, NULL, 'PF18604', NULL, NULL, 'Pre ATP-grasp domain', NULL, 'PreAtp-grasp', NULL, NULL, 28899, 9),
(264495, NULL, 'PF14344', NULL, NULL, 'Domain of unknown function (DUF4397)', NULL, 'DUF4397', NULL, NULL, 26083, 9),
(264496, NULL, 'PF20567', NULL, NULL, 'Family of unknown function (DUF6776)', NULL, 'DUF6776', NULL, NULL, 37465, 9),
(264497, NULL, 'PF08205', NULL, NULL, 'CD80-like C2-set immunoglobulin domain', NULL, 'C2-set_2', NULL, NULL, 8759, 9),
(264498, NULL, 'PF04778', NULL, NULL, 'LMP repeated region', NULL, 'LMP', NULL, NULL, 4338, 9),
(264499, NULL, 'PF08598', NULL, NULL, 'Sds3-like', NULL, 'Sds3', NULL, NULL, 17533, 9),
(264500, NULL, 'PF03529', NULL, NULL, 'Otx1 transcription factor', NULL, 'TF_Otx', NULL, NULL, 17899, 9),
(264501, NULL, 'PF14470', NULL, NULL, 'Bacterial PH domain', NULL, 'bPH_3', NULL, NULL, 33066, 9),
(264502, NULL, 'PF09515', NULL, NULL, 'Thiamine transporter protein (Thia_YuaJ)', NULL, 'Thia_YuaJ', NULL, NULL, 10203, 9),
(264503, NULL, 'PF06458', NULL, NULL, 'MucBP domain', NULL, 'MucBP', NULL, NULL, 9169, 9),
(264504, NULL, 'PF12174', NULL, NULL, 'RCD1-SRO-TAF4 (RST) plant domain', NULL, 'RST', NULL, NULL, 20076, 9),
(264505, NULL, 'PF03487', NULL, NULL, 'Interleukin-13', NULL, 'IL13', NULL, NULL, 19691, 9),
(264506, NULL, 'PF12891', NULL, NULL, 'Glycoside hydrolase family 44', NULL, 'Glyco_hydro_44', NULL, NULL, 18753, 9),
(264507, NULL, 'PF16960', NULL, NULL, 'Haemoglobin-haptoglobin utilisation, porphyrin transporter', NULL, 'HpuA', NULL, NULL, 22212, 9),
(264508, NULL, 'PF10568', NULL, NULL, 'Outer mitochondrial membrane transport complex protein', NULL, 'Tom37', NULL, NULL, 19390, 9),
(264509, NULL, 'PF17910', NULL, NULL, 'FeoB cytosolic helical domain', NULL, 'FeoB_Cyto', NULL, NULL, 28796, 9),
(264510, NULL, 'PF17982', NULL, NULL, 'NSD Cys-His rich domain', NULL, 'C5HCH', NULL, NULL, 29339, 9),
(264511, NULL, 'PF15199', NULL, NULL, 'D-amino acid oxidase activator', NULL, 'DAOA', NULL, NULL, 24669, 9),
(264512, NULL, 'PF09103', NULL, NULL, 'BRCA2, oligonucleotide/oligosaccharide-binding, domain 1', NULL, 'BRCA-2_OB1', NULL, NULL, 10757, 9),
(264513, NULL, 'PF11983', NULL, NULL, 'Cell division protein FtsA, C-terminal', NULL, 'FtsA_C', NULL, NULL, 19736, 9),
(264514, NULL, 'PF18062', NULL, NULL, 'Restriction endonuclease AspBHI N-terminal', NULL, 'RE_AspBHI_N', NULL, NULL, 30393, 9),
(264515, NULL, 'PF06186', NULL, NULL, 'Protein of unknown function (DUF992)', NULL, 'DUF992', NULL, NULL, 14253, 9),
(264516, NULL, 'PF15017', NULL, NULL, 'Putative WW-binding domain and destruction box', NULL, 'WRNPLPNID', NULL, NULL, 29366, 9),
(264517, NULL, 'PF13640', NULL, NULL, '2OG-Fe(II) oxygenase superfamily', NULL, '2OG-FeII_Oxy_3', NULL, NULL, 35877, 9),
(264518, NULL, 'PF06572', NULL, NULL, 'Protein of unknown function (DUF1131)', NULL, 'DUF1131', NULL, NULL, 7729, 9),
(264519, NULL, 'PF19783', NULL, NULL, 'Domain of unknown function (DUF6268)', NULL, 'DUF6268', NULL, NULL, 37484, 9),
(264520, NULL, 'PF00930', NULL, NULL, 'Dipeptidyl peptidase IV (DPP IV) N-terminal region', NULL, 'DPPIV_N', NULL, NULL, 5255, 9),
(264521, NULL, 'PF16755', NULL, NULL, 'Nucleoporin or Nuclear pore complex subunit NUP214=Nup159', NULL, 'NUP214', NULL, NULL, 31042, 9),
(264522, NULL, 'PF18927', NULL, NULL, 'Glycosyl-4,4''-diaponeurosporenoate acyltransferase', NULL, 'CrtO', NULL, NULL, 35012, 9),
(264523, NULL, 'PF04052', NULL, NULL, 'TolB amino-terminal domain', NULL, 'TolB_N', NULL, NULL, 1014, 9),
(264524, NULL, 'PF10147', NULL, NULL, 'Growth arrest and DNA-damage-inducible proteins-interacting protein 1', NULL, 'CR6_interact', NULL, NULL, 21350, 9),
(264525, NULL, 'PF18808', NULL, NULL, 'Importin repeat', NULL, 'Importin_rep_4', NULL, NULL, 29826, 9),
(264526, NULL, 'PF10513', NULL, NULL, 'Enhancer of polycomb-like', NULL, 'EPL1', NULL, NULL, 19313, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(264527, NULL, 'PF08988', NULL, NULL, 'Type III secretion system, cytoplasmic E component of needle', NULL, 'T3SS_needle_E', NULL, NULL, 12630, 9),
(264528, NULL, 'PF13458', NULL, NULL, 'Periplasmic binding protein', NULL, 'Peripla_BP_6', NULL, NULL, 24975, 9),
(264529, NULL, 'PF16512', NULL, NULL, 'p190-A and -B Rho GAPs FF domain', NULL, 'RhoGAP-FF1', NULL, NULL, 25184, 9),
(264530, NULL, 'PF03313', NULL, NULL, 'Serine dehydratase alpha chain', NULL, 'SDH_alpha', NULL, NULL, 7316, 9),
(264531, NULL, 'PF10004', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2247)', NULL, 'DUF2247', NULL, NULL, 19125, 9),
(264532, NULL, 'PF00503', NULL, NULL, 'G-protein alpha subunit', NULL, 'G-alpha', NULL, NULL, 5409, 9),
(264533, NULL, 'PF04756', NULL, NULL, 'OST3 / OST6 family, transporter family', NULL, 'OST3_OST6', NULL, NULL, 15181, 9),
(264534, NULL, 'PF06800', NULL, NULL, 'Sugar transport protein', NULL, 'Sugar_transport', NULL, NULL, 9271, 9),
(264535, NULL, 'PF15561', NULL, NULL, 'Immunity protein 15', NULL, 'Imm15', NULL, NULL, 23384, 9),
(264536, NULL, 'PF01155', NULL, NULL, 'Hydrogenase/urease nickel incorporation, metallochaperone, hypA', NULL, 'HypA', NULL, NULL, 6785, 9),
(264537, NULL, 'PF01420', NULL, NULL, 'Type I restriction modification DNA specificity domain', NULL, 'Methylase_S', NULL, NULL, 3852, 9),
(264538, NULL, 'PF01628', NULL, NULL, 'HrcA protein C terminal domain', NULL, 'HrcA', NULL, NULL, 15042, 9),
(264539, NULL, 'PF17511', NULL, NULL, 'Mobilization protein B', NULL, 'Mobilization_B', NULL, NULL, 19577, 9),
(264540, NULL, 'PF07118', NULL, NULL, 'Protein of unknown function (DUF1374)', NULL, 'DUF1374', NULL, NULL, 13345, 9),
(264541, NULL, 'PF18955', NULL, NULL, 'Domain of unknown function (DUF5698)', NULL, 'DUF5698', NULL, NULL, 35549, 9),
(264542, NULL, 'PF05852', NULL, NULL, 'Gammaherpesvirus protein of unknown function (DUF848)', NULL, 'DUF848', NULL, NULL, 13020, 9),
(264543, NULL, 'PF17873', NULL, NULL, 'Replicase polyprotein 1ab', NULL, 'Rep_1B', NULL, NULL, 28723, 9),
(264544, NULL, 'PF14739', NULL, NULL, 'Domain of unknown function (DUF4472)', NULL, 'DUF4472', NULL, NULL, 21502, 9),
(264545, NULL, 'PF15918', NULL, NULL, 'Domain of unknown function (DUF4744)', NULL, 'DUF4744', NULL, NULL, 21272, 9),
(264546, NULL, 'PF17866', NULL, NULL, 'AAA lid domain', NULL, 'AAA_lid_6', NULL, NULL, 30211, 9),
(264547, NULL, 'PF10907', NULL, NULL, 'Protein of unknown function (DUF2749)', NULL, 'DUF2749', NULL, NULL, 24624, 9),
(264548, NULL, 'PF06894', NULL, NULL, 'Bacteriophage lambda tail assembly chaperone, TAC, protein G', NULL, 'Phage_TAC_2', NULL, NULL, 5395, 9),
(264549, NULL, 'PF17241', NULL, NULL, 'Ty5 Gag N-terminal region', NULL, 'Retrotran_gag_4', NULL, NULL, 20092, 9),
(264550, NULL, 'PF18334', NULL, NULL, 'Exoribonuclease Xrn1 D2/D3 domain', NULL, 'XRN1_D2_D3', NULL, NULL, 28898, 9),
(264551, NULL, 'PF04705', NULL, NULL, 'Thiostrepton-resistance methylase, N terminus', NULL, 'TSNR_N', NULL, NULL, 3444, 9),
(264552, NULL, 'PF11115', NULL, NULL, 'Protein of unknown function (DUF2623)', NULL, 'DUF2623', NULL, NULL, 16192, 9),
(264553, NULL, 'PF19267', NULL, NULL, 'Contractile injection system spike tip protein', NULL, 'CIS_spike_tip', NULL, NULL, 34389, 9),
(264554, NULL, 'PF02530', NULL, NULL, 'Porin subfamily', NULL, 'Porin_2', NULL, NULL, 6122, 9),
(264555, NULL, 'PF04248', NULL, NULL, 'Domain of unknown function (DUF427)', NULL, 'NTP_transf_9', NULL, NULL, 5838, 9),
(264556, NULL, 'PF14722', NULL, NULL, 'Ki-ras-induced actin-interacting protein-IP3R-interacting domain', NULL, 'KRAP_IP3R_bind', NULL, NULL, 21804, 9),
(264557, NULL, 'PF07244', NULL, NULL, 'Surface antigen variable number repeat', NULL, 'POTRA', NULL, NULL, 11173, 9),
(264558, NULL, 'PF08604', NULL, NULL, 'Nucleoporin Nup153-like', NULL, 'Nup153', NULL, NULL, 17502, 9),
(264559, NULL, 'PF02303', NULL, NULL, 'Helix-destabilising protein', NULL, 'Phage_DNA_bind', NULL, NULL, 6386, 9),
(264560, NULL, 'PF00190', NULL, NULL, 'Cupin', NULL, 'Cupin_1', NULL, NULL, 2717, 9),
(264561, NULL, 'PF10256', NULL, NULL, 'Golgin subfamily A member 7/ERF4 family', NULL, 'Erf4', NULL, NULL, 15995, 9);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(264562, NULL, 'PF14781', NULL, NULL, 'Ciliary BBSome complex subunit 2, N-terminal', NULL, 'BBS2_N', NULL, NULL, 21776, 9),
(264563, NULL, 'PF13208', NULL, NULL, 'TerB N-terminal domain', NULL, 'TerB_N', NULL, NULL, 25668, 9),
(264564, NULL, 'PF05899', NULL, NULL, 'EutQ-like cupin domain', NULL, 'Cupin_3', NULL, NULL, 13733, 9),
(264565, NULL, 'PF12767', NULL, NULL, 'Transcriptional regulator of RNA polII, SAGA, subunit', NULL, 'SAGA-Tad1', NULL, NULL, 10296, 9),
(264566, NULL, 'PF08032', NULL, NULL, 'RNA 2''-O ribose methyltransferase substrate binding', NULL, 'SpoU_sub_bind', NULL, NULL, 18757, 9),
(264567, NULL, 'PF13871', NULL, NULL, 'C-terminal domain on Strawberry notch homologue', NULL, 'Helicase_C_4', NULL, NULL, 22675, 9),
(264568, NULL, 'PF01423', NULL, NULL, 'LSM domain', NULL, 'LSM', NULL, NULL, 1109, 9),
(264569, NULL, 'PF05502', NULL, NULL, 'Dynactin p62 family', NULL, 'Dynactin_p62', NULL, NULL, 14257, 9),
(264570, NULL, 'PF14683', NULL, NULL, 'Polysaccharide lyase family 4, domain III', NULL, 'CBM-like', NULL, NULL, 21611, 9),
(264571, NULL, 'PF05079', NULL, NULL, 'Protein of unknown function (DUF680)', NULL, 'DUF680', NULL, NULL, 1258, 9),
(264572, NULL, 'PF14313', NULL, NULL, 'N-terminal region of Paramyxovirinae phosphoprotein (P)', NULL, 'Soyouz_module', NULL, NULL, 22108, 9),
(264573, NULL, 'PF17366', NULL, NULL, 'A-agglutinin-binding subunit Aga2', NULL, 'AGA2', NULL, NULL, 7137, 9),
(264574, NULL, 'PF05110', NULL, NULL, 'AF-4 proto-oncoprotein N-terminal region', NULL, 'AF-4', NULL, NULL, NULL, 9),
(264575, NULL, 'PF05633', NULL, NULL, 'Protein ROH1-like', NULL, 'ROH1-like', NULL, NULL, 12900, 9),
(264576, NULL, 'PF10516', NULL, NULL, 'SHNi-TPR', NULL, 'SHNi-TPR', NULL, NULL, 19161, 9),
(264577, NULL, 'PF10616', NULL, NULL, 'Protein of unknown function (DUF2471)', NULL, 'DUF2471', NULL, NULL, 20745, 9),
(264578, NULL, 'PF16016', NULL, NULL, 'VAD1 Analog of StAR-related lipid transfer domain', NULL, 'VASt', NULL, NULL, 22784, 9),
(264579, NULL, 'PF01534', NULL, NULL, 'Frizzled/Smoothened family membrane region', NULL, 'Frizzled', NULL, NULL, 5949, 9),
(264580, NULL, 'PF03738', NULL, NULL, 'Glutathionylspermidine synthase preATP-grasp', NULL, 'GSP_synth', NULL, NULL, 502, 9),
(264581, NULL, 'PF02629', NULL, NULL, 'CoA binding domain', NULL, 'CoA_binding', NULL, NULL, 3353, 9),
(264582, NULL, 'PF05458', NULL, NULL, 'Cd27 binding protein (Siva)', NULL, 'Siva', NULL, NULL, 11380, 9),
(264583, NULL, 'PF14801', NULL, NULL, 'tRNA methyltransferase complex GCD14 subunit N-term', NULL, 'GCD14_N', NULL, NULL, NULL, 9),
(264584, NULL, 'PF00526', NULL, NULL, 'Dictyostelium (slime mold) repeat', NULL, 'Dicty_CTDC', NULL, NULL, 3110, 9),
(264585, NULL, 'PF12378', NULL, NULL, 'Mycoplasma adhesin P1, N-terminal', NULL, 'P1_N', NULL, NULL, 20947, 9),
(264586, NULL, 'PF00615', NULL, NULL, 'Regulator of G protein signaling domain', NULL, 'RGS', NULL, NULL, 11395, 9),
(264587, NULL, 'PF12705', NULL, NULL, 'PD-(D/E)XK nuclease superfamily', NULL, 'PDDEXK_1', NULL, NULL, 31912, 9),
(264588, NULL, 'PF19861', NULL, NULL, 'Family of unknown function (DUF6335)', NULL, 'DUF6335', NULL, NULL, 37734, 9),
(264589, NULL, 'PF12153', NULL, NULL, 'LPS binding domain of CAP18 (C terminal)', NULL, 'CAP18_C', NULL, NULL, 17199, 9),
(264590, NULL, 'PF16929', NULL, NULL, 'Accessory Sec system GspB-transporter', NULL, 'Asp2', NULL, NULL, 15881, 9),
(264591, NULL, 'PF18451', NULL, NULL, 'Contact-dependent growth inhibition CdiA C-terminal domain', NULL, 'CdiA_C', NULL, NULL, 27230, 9),
(264592, NULL, 'PF03535', NULL, NULL, 'Paxillin family', NULL, 'Paxillin', NULL, NULL, NULL, 9),
(264593, NULL, 'PF14973', NULL, NULL, 'TERF1-interacting nuclear factor 2 N-terminus', NULL, 'TINF2_N', NULL, NULL, 23323, 9),
(264594, NULL, 'PF15286', NULL, NULL, 'Apoptosis regulator M11, B cell 2 leukaemia/lymphoma like', NULL, 'Bcl-2_3', NULL, NULL, 23555, 9),
(264595, NULL, 'PF14616', NULL, NULL, 'Transcription regulator Rua1, C-terminal', NULL, 'Rua1_C', NULL, NULL, 23797, 9),
(264596, NULL, 'PF08930', NULL, NULL, 'Domain of unknown function (DUF1912)', NULL, 'DUF1912', NULL, NULL, 7798, 9);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(264597, NULL, 'PF07252', NULL, NULL, 'Protein of unknown function (DUF1433)', NULL, 'DUF1433', NULL, NULL, 14188, 9),
(264598, NULL, 'PF18312', NULL, NULL, 'Copper resistance protein ScsC N-terminal domain', NULL, 'ScsC_N', NULL, NULL, 29047, 9),
(264599, NULL, 'PF11274', NULL, NULL, 'Protein of unknown function (DUF3074)', NULL, 'DUF3074', NULL, NULL, 24402, 9),
(264600, NULL, 'PF13284', NULL, NULL, 'Domain of unknown function (DUF4072)', NULL, 'DUF4072', NULL, NULL, 22205, 9),
(264601, NULL, 'PF16204', NULL, NULL, 'BDHCT-box associated domain on Bloom syndrome protein', NULL, 'BDHCT_assoc', NULL, NULL, 26099, 9),
(264602, NULL, 'PF06199', NULL, NULL, 'Phage tail tube protein', NULL, 'Phage_tail_2', NULL, NULL, 13562, 9),
(264603, NULL, 'PF19129', NULL, NULL, 'Family of unknown function (DUF5812)', NULL, 'DUF5812', NULL, NULL, 34024, 9),
(264604, NULL, 'PF14116', NULL, NULL, 'YyzF-like protein', NULL, 'YyzF', NULL, NULL, 24053, 9),
(264605, NULL, 'PF10484', NULL, NULL, 'Mitochondrial ribosomal protein S23', NULL, 'MRP-S23', NULL, NULL, 16099, 9),
(264606, NULL, 'PF14992', NULL, NULL, 'TMCO5 family', NULL, 'TMCO5', NULL, NULL, 22020, 9),
(264607, NULL, 'PF00423', NULL, NULL, 'Haemagglutinin-neuraminidase', NULL, 'HN', NULL, NULL, 6561, 9),
(264608, NULL, 'PF01637', NULL, NULL, 'ATPase domain predominantly from Archaea', NULL, 'ATPase_2', NULL, NULL, 10476, 9),
(264609, NULL, 'PF02197', NULL, NULL, 'Regulatory subunit of type II PKA R-subunit', NULL, 'RIIa', NULL, NULL, 1715, 9),
(264610, NULL, 'PF11928', NULL, NULL, 'Early growth response N-terminal domain', NULL, 'DUF3446', NULL, NULL, 19663, 9),
(264611, NULL, 'PF12415', NULL, NULL, 'Poxvirus DNA dependent RNA polymerase', NULL, 'rpo132', NULL, NULL, 22167, 9),
(264612, NULL, 'PF00532', NULL, NULL, 'Periplasmic binding proteins and sugar binding domain of LacI family', NULL, 'Peripla_BP_1', NULL, NULL, 3092, 9),
(264613, NULL, 'PF19893', NULL, NULL, 'Family of unknown function (DUF6366)', NULL, 'DUF6366', NULL, NULL, 36953, 9),
(264614, NULL, 'PF01619', NULL, NULL, 'Proline dehydrogenase', NULL, 'Pro_dh', NULL, NULL, 5724, 9),
(264615, NULL, 'PF15740', NULL, NULL, 'Protein phosphatase 1 regulatory subunit 26 N-terminus', NULL, 'PPP1R26_N', NULL, NULL, 22665, 9),
(264616, NULL, 'PF16148', NULL, NULL, 'Domain of unknown function (DUF4856)', NULL, 'DUF4856', NULL, NULL, 22896, 9),
(264617, NULL, 'PF00429', NULL, NULL, 'ENV polyprotein (coat polyprotein)', NULL, 'TLV_coat', NULL, NULL, 13941, 9),
(264618, NULL, 'PF15554', NULL, NULL, 'FSIP1 family', NULL, 'FSIP1', NULL, NULL, 21225, 9),
(264619, NULL, 'PF09394', NULL, NULL, 'Chagasin family peptidase inhibitor I42', NULL, 'Inhibitor_I42', NULL, NULL, 15733, 9),
(264620, NULL, 'PF12227', NULL, NULL, 'Protein of unknown function (DUF3603)', NULL, 'DUF3603', NULL, NULL, 14548, 9),
(264621, NULL, 'PF05736', NULL, NULL, 'OprF membrane domain', NULL, 'OprF', NULL, NULL, 12037, 9),
(264622, NULL, 'PF13622', NULL, NULL, 'Thioesterase-like superfamily', NULL, '4HBT_3', NULL, NULL, NULL, 9),
(264623, NULL, 'PF20171', NULL, NULL, 'Glucose-6-phosphate dehydrogenase subunit C-terminal domain', NULL, 'OpcA_G6PD_C', NULL, NULL, 37657, 9),
(264624, NULL, 'PF20295', NULL, NULL, 'ABC-three component (ABC-3C) system Middle Component 8', NULL, 'MC8', NULL, NULL, 34121, 9),
(264625, NULL, 'PF11410', NULL, NULL, 'Antifungal peptide', NULL, 'Antifungal_pept', NULL, NULL, 9828, 9),
(264626, NULL, 'PF12211', NULL, NULL, 'Low molecular weight S layer protein N terminal', NULL, 'LMWSLP_N', NULL, NULL, 15490, 9),
(264627, NULL, 'PF18709', NULL, NULL, 'Dynamin-like helical domain', NULL, 'DLP_helical', NULL, NULL, 27930, 9),
(264628, NULL, 'PF12948', NULL, NULL, 'MSP7-like protein C-terminal domain', NULL, 'MSP7_C', NULL, NULL, 23708, 9),
(264629, NULL, 'PF14606', NULL, NULL, 'GDSL-like Lipase/Acylhydrolase family', NULL, 'Lipase_GDSL_3', NULL, NULL, 17735, 9),
(264630, NULL, 'PF07095', NULL, NULL, 'Intracellular growth attenuator protein IgaA', NULL, 'IgaA', NULL, NULL, 10953, 9),
(264631, NULL, 'PF11507', NULL, NULL, 'Ebola virus-specific transcription factor VP30', NULL, 'Transcript_VP30', NULL, NULL, 9719, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(264632, NULL, 'PF09973', NULL, NULL, 'Predicted membrane protein (DUF2208)', NULL, 'DUF2208', NULL, NULL, 9952, 9),
(264633, NULL, 'PF02922', NULL, NULL, 'Carbohydrate-binding module 48 (Isoamylase N-terminal domain)', NULL, 'CBM_48', NULL, NULL, 2523, 9),
(264634, NULL, 'PF08891', NULL, NULL, 'YfcL protein', NULL, 'YfcL', NULL, NULL, 7641, 9),
(264635, NULL, 'PF15145', NULL, NULL, 'Domain of unknown function (DUF4577)', NULL, 'DUF4577', NULL, NULL, 24688, 9),
(264636, NULL, 'PF08398', NULL, NULL, 'Phospholipase A2-like domain', NULL, 'Phospholip_A2_4', NULL, NULL, 11053, 9),
(264637, NULL, 'PF04048', NULL, NULL, 'Sec8 exocyst complex component specific domain', NULL, 'Sec8_exocyst', NULL, NULL, 1108, 9),
(264638, NULL, 'PF13059', NULL, NULL, 'Protein of unknown function (DUF3992)', NULL, 'DUF3922', NULL, NULL, 22641, 9),
(264639, NULL, 'PF19838', NULL, NULL, 'LptD protein', NULL, 'LptD_2', NULL, NULL, 36254, 9),
(264640, NULL, 'PF08837', NULL, NULL, 'Protein of unknown function (DUF1810)', NULL, 'DUF1810', NULL, NULL, 14468, 9),
(264641, NULL, 'PF10911', NULL, NULL, 'Bacteriophage T7-like gene 6.5', NULL, 'T7-like_Y65', NULL, NULL, 12755, 9),
(264642, NULL, 'PF12616', NULL, NULL, 'Protein of unknown function (DUF3775)', NULL, 'DUF3775', NULL, NULL, 21408, 9),
(264643, NULL, 'PF03392', NULL, NULL, 'Insect pheromone-binding family, A10/OS-D', NULL, 'OS-D', NULL, NULL, 2222, 9),
(264644, NULL, 'PF10000', NULL, NULL, 'ACT domain', NULL, 'ACT_3', NULL, NULL, 17026, 9),
(264645, NULL, 'PF11636', NULL, NULL, 'Troponin I residues 1-32', NULL, 'Troponin-I_N', NULL, NULL, 18655, 9),
(264646, NULL, 'PF18565', NULL, NULL, 'Glycoside hydrolase family 2 C-terminal domain 5', NULL, 'Glyco_hydro2_C5', NULL, NULL, 27876, 9),
(264647, NULL, 'PF20030', NULL, NULL, 'MoxR domain in the MoxR-vWA-beta-propeller ternary systems', NULL, 'bpMoxR', NULL, NULL, 35610, 9),
(264648, NULL, 'PF04399', NULL, NULL, 'Glutaredoxin 2, C terminal domain', NULL, 'Glutaredoxin2_C', NULL, NULL, 10332, 9),
(264649, NULL, 'PF03350', NULL, NULL, 'Uncharacterized protein family, UPF0114', NULL, 'UPF0114', NULL, NULL, 7343, 9),
(264650, NULL, 'PF08627', NULL, NULL, 'CRT-like, chloroquine-resistance transporter-like', NULL, 'CRT-like', NULL, NULL, 14203, 9),
(264651, NULL, 'PF17614', NULL, NULL, 'Viral CC-type chemokine', NULL, 'FPV060', NULL, NULL, 19892, 9),
(264652, NULL, 'PF14294', NULL, NULL, 'Domain of unknown function (DUF4372)', NULL, 'DUF4372', NULL, NULL, 21518, 9),
(264653, NULL, 'PF07928', NULL, NULL, 'Vps54-like protein', NULL, 'Vps54', NULL, NULL, 12916, 9),
(264654, NULL, 'PF03721', NULL, NULL, 'UDP-glucose/GDP-mannose dehydrogenase family, NAD binding domain', NULL, 'UDPG_MGDP_dh_N', NULL, NULL, 3485, 9),
(264655, NULL, 'PF04178', NULL, NULL, 'Got1/Sft2-like family', NULL, 'Got1', NULL, NULL, 4613, 9),
(264656, NULL, 'PF07846', NULL, NULL, 'Metallothionein family', NULL, 'Metallothio_Cad', NULL, NULL, 11734, 9),
(264657, NULL, 'PF13233', NULL, NULL, 'Complex1_LYR-like', NULL, 'Complex1_LYR_2', NULL, NULL, NULL, 9),
(264658, NULL, 'PF01486', NULL, NULL, 'K-box region', NULL, 'K-box', NULL, NULL, 748, 9),
(264659, NULL, 'PF03743', NULL, NULL, 'Bacterial conjugation TrbI-like protein', NULL, 'TrbI', NULL, NULL, 522, 9),
(264660, NULL, 'PF20336', NULL, NULL, 'Family of unknown function (DUF6631)', NULL, 'DUF6631', NULL, NULL, 33905, 9),
(264661, NULL, 'PF10577', NULL, NULL, 'Uncharacterised protein family UPF0560', NULL, 'UPF0560', NULL, NULL, 20981, 9),
(264662, NULL, 'PF13984', NULL, NULL, 'MsyB protein', NULL, 'MsyB', NULL, NULL, 22737, 9),
(264663, NULL, 'PF02760', NULL, NULL, 'HIN-200/IF120x domain', NULL, 'HIN', NULL, NULL, 875, 9),
(264664, NULL, 'PF02204', NULL, NULL, 'Vacuolar sorting protein 9 (VPS9) domain', NULL, 'VPS9', NULL, NULL, 1850, 9),
(264665, NULL, 'PF19780', NULL, NULL, 'Domain of unknown function (DUF6265)', NULL, 'DUF6265', NULL, NULL, 37308, 9),
(264666, NULL, 'PF16982', NULL, NULL, 'Putative Flagellin, Flp1-like, domain', NULL, 'Flp1_like', NULL, NULL, 23852, 9),
(264667, NULL, 'PF12569', NULL, NULL, 'N-terminal acetyltransferase A, auxiliary subunit', NULL, 'NatA_aux_su', NULL, NULL, 16679, 9);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(264668, NULL, 'PF11092', NULL, NULL, 'Neuronal protein 3.1 (p311)', NULL, 'Alveol-reg_P311', NULL, NULL, 23906, 9),
(264669, NULL, 'PF04444', NULL, NULL, 'Catechol dioxygenase N terminus', NULL, 'Dioxygenase_N', NULL, NULL, 10665, 9),
(264670, NULL, 'PF17491', NULL, NULL, 'Spider Toxins mu-diguetoxin-1 a, b and c', NULL, 'm_DGTX_Dc1a_b_c', NULL, NULL, 31135, 9),
(264671, NULL, 'PF14799', NULL, NULL, 'FAM195 family', NULL, 'FAM195', NULL, NULL, 24609, 9),
(264672, NULL, 'PF02531', NULL, NULL, 'PsaD', NULL, 'PsaD', NULL, NULL, 1691, 9),
(264673, NULL, 'PF16952', NULL, NULL, 'Glutamine synthetase N-terminal domain', NULL, 'Gln-synt_N_2', NULL, NULL, 7182, 9),
(264674, NULL, 'PF11764', NULL, NULL, 'COMPASS (Complex proteins associated with Set1p) component N', NULL, 'N-SET', NULL, NULL, 18260, 9),
(264675, NULL, 'PF16554', NULL, NULL, 'Dimerisation domain of d-ornithine 4,5-aminomutase', NULL, 'OAM_dimer', NULL, NULL, 21649, 9),
(264676, NULL, 'PF10722', NULL, NULL, 'Putative bacterial sensory transduction regulator', NULL, 'YbjN', NULL, NULL, 20964, 9),
(264677, NULL, 'PF09195', NULL, NULL, 'Restriction endonuclease BglII', NULL, 'Endonuc-BglII', NULL, NULL, 12203, 9),
(264678, NULL, 'PF17287', NULL, NULL, 'POTRA domain', NULL, 'POTRA_3', NULL, NULL, 28500, 9),
(264679, NULL, 'PF01594', NULL, NULL, 'AI-2E family transporter', NULL, 'AI-2E_transport', NULL, NULL, 1977, 9),
(264680, NULL, 'PF00746', NULL, NULL, 'LPXTG cell wall anchor motif', NULL, 'Gram_pos_anchor', NULL, NULL, 18280, 9),
(264681, NULL, 'PF19278', NULL, NULL, 'Hydantoinase/oxoprolinase C-terminal domain', NULL, 'Hydant_A_C', NULL, NULL, NULL, 9),
(264682, NULL, 'PF15204', NULL, NULL, 'Kita-kyushu lung cancer antigen 1', NULL, 'KKLCAg1', NULL, NULL, 24948, 9),
(264683, NULL, 'PF18882', NULL, NULL, 'Family of unknown function (DUF5647)', NULL, 'DUF5647', NULL, NULL, 34084, 9),
(264684, NULL, 'PF02140', NULL, NULL, 'Galactose binding lectin domain', NULL, 'Gal_Lectin', NULL, NULL, 247, 9),
(264685, NULL, 'PF07085', NULL, NULL, 'DRTGG domain', NULL, 'DRTGG', NULL, NULL, 10781, 9),
(264686, NULL, 'PF10378', NULL, NULL, 'Putative RRM domain', NULL, 'RRM', NULL, NULL, 20407, 9),
(264687, NULL, 'PF10612', NULL, NULL, 'Spore coat protein Z', NULL, 'Spore-coat_CotZ', NULL, NULL, 20241, 9),
(264688, NULL, 'PF07219', NULL, NULL, 'HemY protein N-terminus', NULL, 'HemY_N', NULL, NULL, 10979, 9),
(264689, NULL, 'PF02405', NULL, NULL, 'Permease MlaE', NULL, 'MlaE', NULL, NULL, 22267, 9),
(264690, NULL, 'PF03109', NULL, NULL, 'ABC1 atypical kinase-like domain', NULL, 'ABC1', NULL, NULL, 2670, 9),
(264691, NULL, 'PF16307', NULL, NULL, 'Domain of unknown function (DUF4949)', NULL, 'DUF4949', NULL, NULL, 25550, 9),
(264692, NULL, 'PF05840', NULL, NULL, 'Bacteriophage replication gene A protein (GPA)', NULL, 'Phage_GPA', NULL, NULL, 12265, 9),
(264693, NULL, 'PF12507', NULL, NULL, 'Human Cytomegalovirus UL139 protein', NULL, 'HCMV_UL139', NULL, NULL, 15483, 9),
(264694, NULL, 'PF04063', NULL, NULL, 'Domain of unknown function (DUF383)', NULL, 'DUF383', NULL, NULL, 1324, 9),
(264695, NULL, 'PF02979', NULL, NULL, 'Nitrile hydratase, alpha chain', NULL, 'NHase_alpha', NULL, NULL, 3512, 9),
(264696, NULL, 'PF17718', NULL, NULL, 'Family of unknown function (DUF5563)', NULL, 'DUF5563', NULL, NULL, 30088, 9),
(264697, NULL, 'PF20129', NULL, NULL, 'Family of unknown function (DUF6519)', NULL, 'DUF6519', NULL, NULL, 35616, 9),
(264698, NULL, 'PF12095', NULL, NULL, 'Protein CHLORORESPIRATORY REDUCTION 7', NULL, 'CRR7', NULL, NULL, 20033, 9),
(264699, NULL, 'PF05962', NULL, NULL, 'HutD', NULL, 'HutD', NULL, NULL, 7586, 9),
(264700, NULL, 'PF16714', NULL, NULL, 'Tyrosyl-tRNA synthetase C-terminal domain', NULL, 'TyrRSs_C', NULL, NULL, 23391, 9),
(264701, NULL, 'PF10413', NULL, NULL, 'Amino terminal of the G-protein receptor rhodopsin', NULL, 'Rhodopsin_N', NULL, NULL, 17155, 9),
(264702, NULL, 'PF17362', NULL, NULL, 'Family of unknown function', NULL, 'pXO2-34', NULL, NULL, 19643, 9),
(264703, NULL, 'PF11793', NULL, NULL, 'FANCL C-terminal domain', NULL, 'FANCL_C', NULL, NULL, 24625, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(264704, NULL, 'PF06393', NULL, NULL, 'BH3 interacting domain (BID)', NULL, 'BID', NULL, NULL, 10181, 9),
(264705, NULL, 'PF15205', NULL, NULL, 'Placenta-specific protein 9', NULL, 'PLAC9', NULL, NULL, 24857, 9),
(264706, NULL, 'PF06248', NULL, NULL, 'Centromere/kinetochore Zw10', NULL, 'Zw10', NULL, NULL, 14034, 9),
(264707, NULL, 'PF01083', NULL, NULL, 'Cutinase', NULL, 'Cutinase', NULL, NULL, 3972, 9),
(264708, NULL, 'PF05833', NULL, NULL, 'NFACT N-terminal and middle domains', NULL, 'NFACT_N', NULL, NULL, NULL, 9),
(264709, NULL, 'PF06946', NULL, NULL, 'Bacteriophage A118-like holin, Hol118', NULL, 'Phage_holin_5_1', NULL, NULL, 11579, 9),
(264710, NULL, 'PF04078', NULL, NULL, 'Cell differentiation family, Rcd1-like', NULL, 'Rcd1', NULL, NULL, NULL, 9),
(264711, NULL, 'PF16902', NULL, NULL, 'FokI, D3 domain', NULL, 'FokI_D3', NULL, NULL, 22733, 9),
(264712, NULL, 'PF04611', NULL, NULL, 'Mating type protein A alpha Y mating type dependent binding region', NULL, 'AalphaY_MDB', NULL, NULL, 1226, 9),
(264713, NULL, 'PF07128', NULL, NULL, 'Protein of unknown function (DUF1380)', NULL, 'DUF1380', NULL, NULL, 13178, 9),
(264714, NULL, 'PF15754', NULL, NULL, 'Sperm equatorial segment protein 1', NULL, 'SPESP1', NULL, NULL, 25936, 9),
(264715, NULL, 'PF18183', NULL, NULL, 'SMODS and SLOG-associating 2TM effector domain 2', NULL, 'SLATT_2', NULL, NULL, 28369, 9),
(264716, NULL, 'PF06536', NULL, NULL, 'Avian adenovirus fibre, N-terminal', NULL, 'Av_adeno_fibre', NULL, NULL, 14338, 9),
(264717, NULL, 'PF06887', NULL, NULL, 'Protein of unknown function (DUF1265)', NULL, 'DUF1265', NULL, NULL, 11610, 9),
(264718, NULL, 'PF16723', NULL, NULL, 'Domain of unknown function (DUF5065)', NULL, 'DUF5065', NULL, NULL, 23347, 9),
(264719, NULL, 'PF01337', NULL, NULL, 'Barstar (barnase inhibitor)', NULL, 'Barstar', NULL, NULL, 5739, 9),
(264720, NULL, 'PF10903', NULL, NULL, 'Protein of unknown function (DUF2691)', NULL, 'DUF2691', NULL, NULL, 18938, 9),
(264721, NULL, 'PF12194', NULL, NULL, 'Protein kinase Fus3-binding', NULL, 'Ste5_C', NULL, NULL, 18416, 9),
(264722, NULL, 'PF00334', NULL, NULL, 'Nucleoside diphosphate kinase', NULL, 'NDK', NULL, NULL, 28480, 9),
(264723, NULL, 'PF03062', NULL, NULL, 'MBOAT, membrane-bound O-acyltransferase family', NULL, 'MBOAT', NULL, NULL, 4931, 9),
(264724, NULL, 'PF19768', NULL, NULL, 'Family of unknown function (DUF6255)', NULL, 'DUF6255', NULL, NULL, 37373, 9),
(264725, NULL, 'PF17363', NULL, NULL, 'Family of unknown function (DUF5388)', NULL, 'DUF5388', NULL, NULL, 32176, 9),
(264726, NULL, 'PF06776', NULL, NULL, 'Invasion associated locus B (IalB) protein', NULL, 'IalB', NULL, NULL, 9329, 9),
(264727, NULL, 'PF14356', NULL, NULL, 'Domain of unknown function (DUF4403)', NULL, 'DUF4403', NULL, NULL, 26412, 9),
(264728, NULL, 'PF17128', NULL, NULL, 'Domain of unknown function (DUF5107)', NULL, 'DUF5107', NULL, NULL, 27765, 9),
(264729, NULL, 'PF03963', NULL, NULL, 'Flagellar hook capping protein - N-terminal region', NULL, 'FlgD', NULL, NULL, 2754, 9),
(264730, NULL, 'PF08971', NULL, NULL, 'Glycogen synthesis protein', NULL, 'GlgS', NULL, NULL, 8748, 9),
(264731, NULL, 'PF12325', NULL, NULL, 'TATA element modulatory factor 1 TATA binding', NULL, 'TMF_TATA_bd', NULL, NULL, 20818, 9),
(264732, NULL, 'PF08120', NULL, NULL, 'Tamulustoxin family', NULL, 'Toxin_32', NULL, NULL, 10302, 9),
(264733, NULL, 'PF20345', NULL, NULL, 'Family of unknown function (DUF6640)', NULL, 'DUF6640', NULL, NULL, 33898, 9),
(264734, NULL, 'PF01234', NULL, NULL, 'NNMT/PNMT/TEMT family', NULL, 'NNMT_PNMT_TEMT', NULL, NULL, 3408, 9),
(264735, NULL, 'PF03178', NULL, NULL, 'CPSF A subunit region', NULL, 'CPSF_A', NULL, NULL, 7228, 9),
(264736, NULL, 'PF12737', NULL, NULL, 'C-terminal domain of homeodomain 1', NULL, 'Mating_C', NULL, NULL, 24488, 9),
(264737, NULL, 'PF05261', NULL, NULL, 'TraM protein, DNA-binding', NULL, 'Tra_M', NULL, NULL, 3488, 9),
(264738, NULL, 'PF10558', NULL, NULL, 'Mitochondrial 18 KDa protein (MTP18)', NULL, 'MTP18', NULL, NULL, 19263, 9),
(264739, NULL, 'PF03815', NULL, NULL, 'LCCL domain', NULL, 'LCCL', NULL, NULL, 965, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(264740, NULL, 'PF07321', NULL, NULL, 'Type III secretion protein YscO', NULL, 'YscO', NULL, NULL, 8480, 9),
(264741, NULL, 'PF08274', NULL, NULL, 'PhnA Zinc-Ribbon', NULL, 'YjdM_Zn_Ribbon', NULL, NULL, 11111, 9),
(264742, NULL, 'PF15708', NULL, NULL, 'Proline-rich protein family 20', NULL, 'PRR20', NULL, NULL, 25405, 9),
(264743, NULL, 'PF07927', NULL, NULL, 'HicA toxin of bacterial toxin-antitoxin,', NULL, 'HicA_toxin', NULL, NULL, 8350, 9),
(264744, NULL, 'PF17715', NULL, NULL, 'Family of unknown function (DUF5560)', NULL, 'DUF5560', NULL, NULL, 32259, 9),
(264745, NULL, 'PF18349', NULL, NULL, 'PAZ domain', NULL, 'PAZ_4', NULL, NULL, 29992, 9),
(264746, NULL, 'PF20339', NULL, NULL, 'Family of unknown function (DUF6634)', NULL, 'DUF6634', NULL, NULL, 33747, 9),
(264747, NULL, 'PF16163', NULL, NULL, 'Domain of unknown function (DUF4869)', NULL, 'DUF4869', NULL, NULL, 22767, 9),
(264748, NULL, 'PF07553', NULL, NULL, 'Host cell surface-exposed lipoprotein', NULL, 'Lipoprotein_Ltp', NULL, NULL, 13957, 9),
(264749, NULL, 'PF08713', NULL, NULL, 'DNA alkylation repair enzyme', NULL, 'DNA_alkylation', NULL, NULL, 11569, 9),
(264750, NULL, 'PF17709', NULL, NULL, 'Family of unknown function (DUF5554)', NULL, 'DUF5554', NULL, NULL, 32591, 9),
(264751, NULL, 'PF11530', NULL, NULL, 'Minor type IV pilin, PilX', NULL, 'Pilin_PilX', NULL, NULL, 21948, 9),
(264752, NULL, 'PF17408', NULL, NULL, 'Malonyl-CoA decarboxylase N-terminal domain', NULL, 'MCD_N', NULL, NULL, 9519, 9),
(264753, NULL, 'PF03795', NULL, NULL, 'YCII-related domain', NULL, 'YCII', NULL, NULL, 2000, 9),
(264754, NULL, 'PF10562', NULL, NULL, 'Calmodulin-binding domain C0 of NMDA receptor NR1 subunit', NULL, 'CaM_bdg_C0', NULL, NULL, 20614, 9),
(264755, NULL, 'PF01214', NULL, NULL, 'Casein kinase II regulatory subunit', NULL, 'CK_II_beta', NULL, NULL, 6522, 9),
(264756, NULL, 'PF13572', NULL, NULL, 'Domain of unknown function (DUF4134)', NULL, 'DUF4134', NULL, NULL, 22304, 9),
(264757, NULL, 'PF17757', NULL, NULL, 'UvrB interaction domain', NULL, 'UvrB_inter', NULL, NULL, 29849, 9),
(264758, NULL, 'PF06390', NULL, NULL, 'Neuroendocrine-specific golgi protein P55 (NESP55)', NULL, 'NESP55', NULL, NULL, 8066, 9),
(264759, NULL, 'PF10883', NULL, NULL, 'Protein of unknown function (DUF2681)', NULL, 'DUF2681', NULL, NULL, 19354, 9),
(264760, NULL, 'PF05021', NULL, NULL, 'NPL4 family', NULL, 'NPL4', NULL, NULL, 1214, 9),
(264761, NULL, 'PF14032', NULL, NULL, 'PknH-like extracellular domain', NULL, 'PknH_C', NULL, NULL, 25708, 9),
(264762, NULL, 'PF06580', NULL, NULL, 'Histidine kinase', NULL, 'His_kinase', NULL, NULL, 8004, 9),
(264763, NULL, 'PF17197', NULL, NULL, 'Domain of unknown function (DUF5134)', NULL, 'DUF5134', NULL, NULL, 31491, 9),
(264764, NULL, 'PF17216', NULL, NULL, 'Rrp44-like cold shock domain', NULL, 'Rrp44_CSD1', NULL, NULL, 31930, 9),
(264765, NULL, 'PF17222', NULL, NULL, 'Viral cysteine endopeptidase C107', NULL, 'Peptidase_C107', NULL, NULL, 30210, 9),
(264766, NULL, 'PF00445', NULL, NULL, 'Ribonuclease T2 family', NULL, 'Ribonuclease_T2', NULL, NULL, 5024, 9),
(264767, NULL, 'PF10497', NULL, NULL, 'Zinc-finger domain of monoamine-oxidase A repressor R1', NULL, 'zf-4CXXC_R1', NULL, NULL, 20578, 9),
(264768, NULL, 'PF18315', NULL, NULL, 'Integron cassette protein VCH_CASS1 chain', NULL, 'VCH_CASS14', NULL, NULL, 31721, 9),
(264769, NULL, 'PF02209', NULL, NULL, 'Villin headpiece domain', NULL, 'VHP', NULL, NULL, 1700, 9),
(264770, NULL, 'PF02701', NULL, NULL, 'Dof domain, zinc finger', NULL, 'zf-Dof', NULL, NULL, 3304, 9),
(264771, NULL, 'PF15308', NULL, NULL, 'CEP170 C-terminus', NULL, 'CEP170_C', NULL, NULL, 24868, 9),
(264772, NULL, 'PF06786', NULL, NULL, 'Uncharacterised protein family (UPF0253)', NULL, 'UPF0253', NULL, NULL, 1928, 9),
(264773, NULL, 'PF20316', NULL, NULL, 'Family of unknown function (DUF6612)', NULL, 'DUF6612', NULL, NULL, 37300, 9),
(264774, NULL, 'PF07875', NULL, NULL, 'Coat F domain', NULL, 'Coat_F', NULL, NULL, 12103, 9),
(264775, NULL, 'PF01298', NULL, NULL, 'C-lobe and N-lobe beta barrels of Tf-binding protein B', NULL, 'TbpB_B_D', NULL, NULL, 3131, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(264776, NULL, 'PF09474', NULL, NULL, 'Type III secretion system YscX (type_III_YscX)', NULL, 'Type_III_YscX', NULL, NULL, 12575, 9),
(264777, NULL, 'PF03198', NULL, NULL, 'Glucanosyltransferase', NULL, 'Glyco_hydro_72', NULL, NULL, 344, 9),
(264778, NULL, 'PF19044', NULL, NULL, 'TraG P-loop domain', NULL, 'P-loop_TraG', NULL, NULL, 34836, 9),
(264779, NULL, 'PF02059', NULL, NULL, 'Interleukin-3', NULL, 'IL3', NULL, NULL, 1048, 9),
(264780, NULL, 'PF17503', NULL, NULL, 'Family of unknown function (DUF5435)', NULL, 'DUF5435', NULL, NULL, 32234, 9),
(264781, NULL, 'PF18469', NULL, NULL, 'Pleckstrin homology domain', NULL, 'PH_18', NULL, NULL, 28990, 9),
(264782, NULL, 'PF00355', NULL, NULL, 'Rieske [2Fe-2S] domain', NULL, 'Rieske', NULL, NULL, 20630, 9),
(264783, NULL, 'PF03085', NULL, NULL, 'Rhoptry-associated protein 1 (RAP-1)', NULL, 'RAP-1', NULL, NULL, 4508, 9),
(264784, NULL, 'PF01159', NULL, NULL, 'Ribosomal protein L6e', NULL, 'Ribosomal_L6e', NULL, NULL, 3066, 9),
(264785, NULL, 'PF08497', NULL, NULL, 'Radical SAM N-terminal', NULL, 'Radical_SAM_N', NULL, NULL, 13705, 9),
(264786, NULL, 'PF20138', NULL, NULL, 'Family of unknown function (DUF6528)', NULL, 'DUF6528', NULL, NULL, 35565, 9),
(264787, NULL, 'PF11010', NULL, NULL, 'Protein of unknown function (DUF2848)', NULL, 'DUF2848', NULL, NULL, 17774, 9),
(264788, NULL, 'PF04695', NULL, NULL, 'Pex14 N-terminal domain', NULL, 'Pex14_N', NULL, NULL, 3272, 9),
(264789, NULL, 'PF13225', NULL, NULL, 'Beta-carotene isomerase D27-like, C-terminal', NULL, 'D27-like_C', NULL, NULL, 22727, 9),
(264790, NULL, 'PF12603', NULL, NULL, 'Protein of unknown function (DUF3770)', NULL, 'DUF3770', NULL, NULL, 16484, 9),
(264791, NULL, 'PF09368', NULL, NULL, 'Sas10 C-terminal domain', NULL, 'Sas10', NULL, NULL, 14584, 9),
(264792, NULL, 'PF04138', NULL, NULL, 'GtrA-like protein', NULL, 'GtrA', NULL, NULL, 7181, 9),
(264793, NULL, 'PF11874', NULL, NULL, 'Domain of unknown function (DUF3394)', NULL, 'DUF3394', NULL, NULL, 19261, 9),
(264794, NULL, 'PF12155', NULL, NULL, 'NADH dehydrogenase subunit 2 N-terminal', NULL, 'NADHdh-2_N', NULL, NULL, 17415, 9),
(264795, NULL, 'PF20397', NULL, NULL, 'Family of unknown function (DUF6690)', NULL, 'DUF6690', NULL, NULL, 37683, 9),
(264796, NULL, 'PF12765', NULL, NULL, 'HEAT repeat associated with sister chromatid cohesion', NULL, 'Cohesin_HEAT', NULL, NULL, 23179, 9),
(264797, NULL, 'PF15045', NULL, NULL, 'Clathrin-binding box of Aftiphilin, vesicle trafficking', NULL, 'Clathrin_bdg', NULL, NULL, 26662, 9),
(264798, NULL, 'PF07714', NULL, NULL, 'Protein tyrosine and serine/threonine kinase', NULL, 'PK_Tyr_Ser-Thr', NULL, NULL, 792, 9),
(264799, NULL, 'PF07203', NULL, NULL, 'Protein of unknown function (DUF1412)', NULL, 'DUF1412', NULL, NULL, 14372, 9),
(264800, NULL, 'PF10828', NULL, NULL, 'Protein of unknown function (DUF2570)', NULL, 'DUF2570', NULL, NULL, 16231, 9),
(264801, NULL, 'PF17314', NULL, NULL, 'Family of unknown function (DUF5360)', NULL, 'DUF5360', NULL, NULL, 19512, 9),
(264802, NULL, 'PF03243', NULL, NULL, 'Alkylmercury lyase', NULL, 'MerB', NULL, NULL, 1675, 9),
(264803, NULL, 'PF15870', NULL, NULL, 'ElonginA binding-protein 1', NULL, 'EloA-BP1', NULL, NULL, 25953, 9),
(264804, NULL, 'PF09160', NULL, NULL, 'FimH, mannose binding', NULL, 'FimH_man-bind', NULL, NULL, 12279, 9),
(264805, NULL, 'PF13925', NULL, NULL, 'con80 domain of Katanin', NULL, 'Katanin_con80', NULL, NULL, 23273, 9),
(264806, NULL, 'PF06014', NULL, NULL, 'Bacterial protein of unknown function (DUF910)', NULL, 'DUF910', NULL, NULL, 13898, 9),
(264807, NULL, 'PF13652', NULL, NULL, 'Putative quorum-sensing-regulated virulence factor', NULL, 'QSregVF', NULL, NULL, 21728, 9),
(264808, NULL, 'PF09489', NULL, NULL, 'Probable cobalt transporter subunit (CbtB)', NULL, 'CbtB', NULL, NULL, 12927, 9),
(264809, NULL, 'PF14672', NULL, NULL, 'Late cornified envelope', NULL, 'LCE', NULL, NULL, 26987, 9),
(264810, NULL, 'PF08450', NULL, NULL, 'SMP-30/Gluconolactonase/LRE-like region', NULL, 'SGL', NULL, NULL, 11854, 9),
(264811, NULL, 'PF08471', NULL, NULL, 'Class II vitamin B12-dependent ribonucleotide reductase', NULL, 'Ribonuc_red_2_N', NULL, NULL, 13530, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(264812, NULL, 'PF07439', NULL, NULL, 'Protein of unknown function (DUF1515)', NULL, 'DUF1515', NULL, NULL, 11719, 9),
(264813, NULL, 'PF02352', NULL, NULL, 'Decorin binding protein', NULL, 'Decorin_bind', NULL, NULL, 4009, 9),
(264814, NULL, 'PF06260', NULL, NULL, 'Protein of unknown function (DUF1024)', NULL, 'DUF1024', NULL, NULL, 14176, 9),
(264815, NULL, 'PF01901', NULL, NULL, 'Putative O-antigen polymerase', NULL, 'O_anti_polymase', NULL, NULL, 4178, 9),
(264816, NULL, 'PF06207', NULL, NULL, 'Protein of unknown function (DUF1002)', NULL, 'DUF1002', NULL, NULL, 14331, 9),
(264817, NULL, 'PF17777', NULL, NULL, 'Insertion domain in 60S ribosomal protein L10P', NULL, 'RL10P_insert', NULL, NULL, 28008, 9),
(264818, NULL, 'PF18506', NULL, NULL, 'RelB Antitoxin alpha helical domain', NULL, 'RelB_N', NULL, NULL, NULL, 9),
(264819, NULL, 'PF10739', NULL, NULL, 'Protein of unknown function (DUF2550)', NULL, 'DUF2550', NULL, NULL, 19673, 9),
(264820, NULL, 'PF16087', NULL, NULL, 'Helix-turn-helix domain (DUF4817)', NULL, 'DUF4817', NULL, NULL, 23504, 9),
(264821, NULL, 'PF10013', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2256)', NULL, 'DUF2256', NULL, NULL, 20540, 9),
(264822, NULL, 'PF20405', NULL, NULL, 'Family of unknown function (DUF6695)', NULL, 'DUF6695', NULL, NULL, 37505, 9),
(264823, NULL, 'PF03245', NULL, NULL, 'Bacteriophage Rz lysis protein', NULL, 'Phage_lysis', NULL, NULL, 1592, 9),
(264824, NULL, 'PF02097', NULL, NULL, 'Filoviridae VP35', NULL, 'Filo_VP35', NULL, NULL, 6557, 9),
(264825, NULL, 'PF04142', NULL, NULL, 'Nucleotide-sugar transporter', NULL, 'Nuc_sug_transp', NULL, NULL, 7432, 9),
(264826, NULL, 'PF08924', NULL, NULL, 'Domain of unknown function (DUF1906)', NULL, 'DUF1906', NULL, NULL, 7615, 9),
(264827, NULL, 'PF03540', NULL, NULL, 'Transcription initiation factor TFIID 23-30kDa subunit', NULL, 'TFIID_30kDa', NULL, NULL, 6013, 9),
(264828, NULL, 'PF15646', NULL, NULL, 'Restriction endonuclease fold toxin 2', NULL, 'Tox-REase-2', NULL, NULL, 24856, 9),
(264829, NULL, 'PF03734', NULL, NULL, 'L,D-transpeptidase catalytic domain', NULL, 'YkuD', NULL, NULL, 670, 9),
(264830, NULL, 'PF16850', NULL, NULL, 'Peptidase inhibitor I66', NULL, 'Inhibitor_I66', NULL, NULL, 22936, 9),
(264831, NULL, 'PF12233', NULL, NULL, 'Human adult T cell leukemia/lymphoma virus protein', NULL, 'p12I', NULL, NULL, 15095, 9),
(264832, NULL, 'PF12457', NULL, NULL, 'Tuftelin interacting protein N terminal', NULL, 'TIP_N', NULL, NULL, 20928, 9),
(264833, NULL, 'PF16277', NULL, NULL, 'Domain of unknown function (DUF4926)', NULL, 'DUF4926', NULL, NULL, 21793, 9),
(264834, NULL, 'PF10669', NULL, NULL, 'Protein gp23 (Bacteriophage A118)', NULL, 'Phage_Gp23', NULL, NULL, 14960, 9),
(264835, NULL, 'PF17464', NULL, NULL, 'Non-structural protein 11 and 12', NULL, 'Pns11_12', NULL, NULL, 32358, 9),
(264836, NULL, 'PF03143', NULL, NULL, 'Elongation factor Tu C-terminal domain', NULL, 'GTP_EFTU_D3', NULL, NULL, 2945, 9),
(264837, NULL, 'PF09501', NULL, NULL, 'Probable sporulation protein (Bac_small_yrzI)', NULL, 'Bac_small_YrzI', NULL, NULL, 10189, 9),
(264838, NULL, 'PF02226', NULL, NULL, 'Picornavirus coat protein (VP4)', NULL, 'Pico_P1A', NULL, NULL, 2697, 9),
(264839, NULL, 'PF06259', NULL, NULL, 'Alpha/beta hydrolase', NULL, 'Abhydrolase_8', NULL, NULL, 9097, 9),
(264840, NULL, 'PF00715', NULL, NULL, 'Interleukin 2', NULL, 'IL2', NULL, NULL, 3542, 9),
(264841, NULL, 'PF14217', NULL, NULL, 'Domain of unknown function (DUF4327)', NULL, 'DUF4327', NULL, NULL, 26121, 9),
(264842, NULL, 'PF07983', NULL, NULL, 'X8 domain', NULL, 'X8', NULL, NULL, 8169, 9),
(264843, NULL, 'PF11935', NULL, NULL, 'Symplekin/PTA1 N-terminal', NULL, 'SYMPK_PTA1_N', NULL, NULL, 26815, 9),
(264844, NULL, 'PF17845', NULL, NULL, 'FbpC C-terminal regulatory nucleotide binding domain', NULL, 'FbpC_C_terminal', NULL, NULL, 29003, 9),
(264845, NULL, 'PF07086', NULL, NULL, 'Jagunal, ER re-organisation during oogenesis', NULL, 'Jagunal', NULL, NULL, 13247, 9),
(264846, NULL, 'PF05064', NULL, NULL, 'Nsp1-like C-terminal region', NULL, 'Nsp1_C', NULL, NULL, 1466, 9);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(264847, NULL, 'PF03385', NULL, NULL, 'STELLO glycosyltransferases', NULL, 'STELLO', NULL, NULL, 2067, 9),
(264848, NULL, 'PF16233', NULL, NULL, 'Domain of unknown function (DUF4893)', NULL, 'DUF4893', NULL, NULL, 25631, 9),
(264849, NULL, 'PF02905', NULL, NULL, 'Epstein Barr virus nuclear antigen-1, DNA-binding domain', NULL, 'EBV-NA1', NULL, NULL, 2599, 9),
(264850, NULL, 'PF14658', NULL, NULL, 'EF-hand domain', NULL, 'EF-hand_9', NULL, NULL, 31095, 9),
(264851, NULL, 'PF10690', NULL, NULL, 'Myticin pre-proprotein from the mussel', NULL, 'Myticin-prepro', NULL, NULL, 20539, 9),
(264852, NULL, 'PF00990', NULL, NULL, 'Diguanylate cyclase, GGDEF domain', NULL, 'GGDEF', NULL, NULL, 1794, 9),
(264853, NULL, 'PF06074', NULL, NULL, 'Protein of unknown function (DUF935)', NULL, 'DUF935', NULL, NULL, 13645, 9),
(264854, NULL, 'PF02317', NULL, NULL, 'NAD/NADP octopine/nopaline dehydrogenase, alpha-helical domain', NULL, 'Octopine_DH', NULL, NULL, 5321, 9),
(264855, NULL, 'PF03987', NULL, NULL, 'Autophagocytosis associated protein, active-site domain', NULL, 'Autophagy_act_C', NULL, NULL, 93, 9),
(264856, NULL, 'PF15282', NULL, NULL, 'BMP-2-inducible protein kinase C-terminus', NULL, 'BMP2K_C', NULL, NULL, 21884, 9),
(264857, NULL, 'PF01411', NULL, NULL, 'tRNA synthetases class II (A)', NULL, 'tRNA-synt_2c', NULL, NULL, 7985, 9),
(264858, NULL, 'PF13748', NULL, NULL, 'ABC transporter transmembrane region', NULL, 'ABC_membrane_3', NULL, NULL, 12367, 9),
(264859, NULL, 'PF06521', NULL, NULL, 'PAR1 protein', NULL, 'PAR1', NULL, NULL, 9022, 9),
(264860, NULL, 'PF14057', NULL, NULL, 'GGGtGRT protein', NULL, 'GGGtGRT', NULL, NULL, 22747, 9),
(264861, NULL, 'PF05255', NULL, NULL, 'Uncharacterised protein family (UPF0220)', NULL, 'UPF0220', NULL, NULL, 3065, 9),
(264862, NULL, 'PF13805', NULL, NULL, 'Eisosome component PIL1', NULL, 'Pil1', NULL, NULL, 21697, 9),
(264863, NULL, 'PF15703', NULL, NULL, 'Linker for activation of T-cells family member 2', NULL, 'LAT2', NULL, NULL, 26842, 9),
(264864, NULL, 'PF07911', NULL, NULL, 'Protein of unknown function (DUF1677)', NULL, 'DUF1677', NULL, NULL, 12484, 9),
(264865, NULL, 'PF05876', NULL, NULL, 'Phage terminase large subunit gpA, ATPase domain', NULL, 'GpA_ATPase', NULL, NULL, 37611, 9),
(264866, NULL, 'PF08895', NULL, NULL, 'Domain of unknown function (DUF1840)', NULL, 'DUF1840', NULL, NULL, 7717, 9),
(264867, NULL, 'PF01660', NULL, NULL, 'Viral methyltransferase', NULL, 'Vmethyltransf', NULL, NULL, 1531, 9),
(264868, NULL, 'PF02597', NULL, NULL, 'ThiS family', NULL, 'ThiS', NULL, NULL, 6123, 9),
(264869, NULL, 'PF10027', NULL, NULL, 'Predicted integral membrane protein (DUF2269)', NULL, 'DUF2269', NULL, NULL, 17637, 9),
(264870, NULL, 'PF02129', NULL, NULL, 'X-Pro dipeptidyl-peptidase (S15 family)', NULL, 'Peptidase_S15', NULL, NULL, 4890, 9),
(264871, NULL, 'PF09847', NULL, NULL, 'Membrane protein of 12 TMs', NULL, '12TM_1', NULL, NULL, 16976, 9),
(264872, NULL, 'PF04137', NULL, NULL, 'Endoplasmic Reticulum Oxidoreductin 1 (ERO1)', NULL, 'ERO1', NULL, NULL, 6565, 9),
(264873, NULL, 'PF04001', NULL, NULL, 'Transcription factor Vhr1', NULL, 'Vhr1', NULL, NULL, 321, 9),
(264874, NULL, 'PF06827', NULL, NULL, 'Zinc finger found in FPG and IleRS', NULL, 'zf-FPG_IleRS', NULL, NULL, 9385, 9),
(264875, NULL, 'PF16249', NULL, NULL, 'Domain of unknown function (DUF4906)', NULL, 'DUF4906', NULL, NULL, 23581, 9),
(264876, NULL, 'PF04633', NULL, NULL, 'Herpesvirus BMRF2 protein', NULL, 'Herpes_BMRF2', NULL, NULL, 2297, 9),
(264877, NULL, 'PF19272', NULL, NULL, 'Acid sphingomyelin phosphodiesterase C-terminal region', NULL, 'ASMase_C', NULL, NULL, 35934, 9),
(264878, NULL, 'PF00710', NULL, NULL, 'Asparaginase, N-terminal', NULL, 'Asparaginase', NULL, NULL, 24689, 9),
(264879, NULL, 'PF10127', NULL, NULL, 'RNA repair pathway DNA polymerase beta family', NULL, 'RlaP', NULL, NULL, 18326, 9),
(264880, NULL, 'PF00377', NULL, NULL, 'Prion/Doppel alpha-helical domain', NULL, 'Prion', NULL, NULL, 15819, 9),
(264881, NULL, 'PF09614', NULL, NULL, 'CRISPR-associated protein (Cas_Csy2)', NULL, 'Cas_Csy2', NULL, NULL, 11327, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(264882, NULL, 'PF10283', NULL, NULL, 'PBZ domain', NULL, 'zf-CCHH', NULL, NULL, 16584, 9),
(264883, NULL, 'PF06290', NULL, NULL, 'Plasmid SOS inhibition protein (PsiB)', NULL, 'PsiB', NULL, NULL, 8335, 9),
(264884, NULL, 'PF14689', NULL, NULL, 'Sensor_kinase_SpoOB-type, alpha-helical domain', NULL, 'SPOB_a', NULL, NULL, 31433, 9),
(264885, NULL, 'PF08290', NULL, NULL, 'Hepatitis core protein, putative zinc finger', NULL, 'Hep_core_N', NULL, NULL, 17125, 9),
(264886, NULL, 'PF10953', NULL, NULL, 'Protein of unknown function (DUF2754)', NULL, 'DUF2754', NULL, NULL, 21248, 9),
(264887, NULL, 'PF15324', NULL, NULL, 'Hedgehog signalling target', NULL, 'TALPID3', NULL, NULL, 23253, 9),
(264888, NULL, 'PF00025', NULL, NULL, 'ADP-ribosylation factor family', NULL, 'Arf', NULL, NULL, 2330, 9),
(264889, NULL, 'PF17985', NULL, NULL, 'SipA vinculin binding site', NULL, 'SipA_VBS', NULL, NULL, 28526, 9),
(264890, NULL, 'PF14453', NULL, NULL, 'ThiS-like ubiquitin', NULL, 'ThiS-like', NULL, NULL, 26440, 9),
(264891, NULL, 'PF16440', NULL, NULL, 'Domain of unknown function (DUF5037)', NULL, 'DUF5037', NULL, NULL, 24477, 9),
(264892, NULL, 'PF20207', NULL, NULL, 'Family of unknown function (DUF6568)', NULL, 'DUF6568', NULL, NULL, 37383, 9),
(264893, NULL, 'PF00276', NULL, NULL, 'Ribosomal protein L23', NULL, 'Ribosomal_L23', NULL, NULL, 11244, 9),
(264894, NULL, 'PF16243', NULL, NULL, 'Sm_like domain', NULL, 'Sm_like', NULL, NULL, 24085, 9),
(264895, NULL, 'PF18595', NULL, NULL, 'Nuf2, DHR10-like domain', NULL, 'Nuf2_DHR10-like', NULL, NULL, 29231, 9),
(264896, NULL, 'PF13816', NULL, NULL, 'Haem-containing dehydratase', NULL, 'Dehydratase_hem', NULL, NULL, 23814, 9),
(264897, NULL, 'PF06754', NULL, NULL, 'Phosphonate metabolism protein PhnG', NULL, 'PhnG', NULL, NULL, 1507, 9),
(264898, NULL, 'PF14584', NULL, NULL, 'Protein of unknown function (DUF4446)', NULL, 'DUF4446', NULL, NULL, 25620, 9),
(264899, NULL, 'PF06743', NULL, NULL, 'FAST kinase-like protein, subdomain 1', NULL, 'FAST_1', NULL, NULL, 9212, 9),
(264900, NULL, 'PF08822', NULL, NULL, 'Protein of unknown function (DUF1804)', NULL, 'DUF1804', NULL, NULL, 14069, 9),
(264901, NULL, 'PF14750', NULL, NULL, 'Integrator complex subunit 2', NULL, 'INTS2', NULL, NULL, 26710, 9),
(264902, NULL, 'PF13499', NULL, NULL, 'EF-hand domain pair', NULL, 'EF-hand_7', NULL, NULL, 1368, 9),
(264903, NULL, 'PF20106', NULL, NULL, 'Family of unknown function (DUF6496)', NULL, 'DUF6496', NULL, NULL, 34311, 9),
(264904, NULL, 'PF06769', NULL, NULL, 'YoeB-like toxin of bacterial type II toxin-antitoxin system', NULL, 'YoeB_toxin', NULL, NULL, 1696, 9),
(264905, NULL, 'PF12654', NULL, NULL, 'Domain of unknown function (DUF3786)', NULL, 'DUF3786', NULL, NULL, 20217, 9),
(264906, NULL, 'PF01813', NULL, NULL, 'ATP synthase subunit D', NULL, 'ATP-synt_D', NULL, NULL, 3948, 9),
(264907, NULL, 'PF08401', NULL, NULL, 'N-terminal domain of anti-restriction factor ArdC', NULL, 'ArdcN', NULL, NULL, 11157, 9),
(264908, NULL, 'PF17948', NULL, NULL, 'DnaT DNA-binding domain', NULL, 'DnaT', NULL, NULL, 27718, 9),
(264909, NULL, 'PF12255', NULL, NULL, 'Insecticide toxin TcdB middle/C-terminal region', NULL, 'TcdB_toxin_midC', NULL, NULL, 20007, 9),
(264910, NULL, 'PF01397', NULL, NULL, 'Terpene synthase, N-terminal domain', NULL, 'Terpene_synth', NULL, NULL, 4451, 9),
(264911, NULL, 'PF18830', NULL, NULL, 'Large polyvalent protein-associated domain 16', NULL, 'LPD16', NULL, NULL, 27565, 9),
(264912, NULL, 'PF05729', NULL, NULL, 'NACHT domain', NULL, 'NACHT', NULL, NULL, 296, 9),
(264913, NULL, 'PF11469', NULL, NULL, 'Ribonuclease III', NULL, 'Ribonucleas_3_2', NULL, NULL, 18783, 9),
(264914, NULL, 'PF00634', NULL, NULL, 'BRCA2 repeat', NULL, 'BRCA2', NULL, NULL, 1417, 9),
(264915, NULL, 'PF15439', NULL, NULL, 'Neuronal tyrosine-phosphorylated phosphoinositide-3-kinase adapter', NULL, 'NYAP_N', NULL, NULL, 33272, 9),
(264916, NULL, 'PF11852', NULL, NULL, 'Alpha-1,6-glucosidases, pullulanase-type, C-terminal', NULL, 'Pullul_strch_C', NULL, NULL, 21760, 9),
(264917, NULL, 'PF15539', NULL, NULL, 'CAF1 complex subunit p150, region binding to CAF1-p60 at C-term', NULL, 'CAF1-p150_C2', NULL, NULL, 25415, 9); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(264918, NULL, 'PF10708', NULL, NULL, 'Protein of unknown function (DUF2510)', NULL, 'DUF2510', NULL, NULL, 14816, 9),
(264919, NULL, 'PF12516', NULL, NULL, 'Protein of unknown function (DUF3719)', NULL, 'DUF3719', NULL, NULL, 21249, 9),
(264920, NULL, 'PF18355', NULL, NULL, 'Domain of unknown function (DUF5607)', NULL, 'DUF5607', NULL, NULL, 29679, 9),
(264921, NULL, 'PF06858', NULL, NULL, 'Nucleolar GTP-binding protein 1 (NOG1)', NULL, 'NOG1', NULL, NULL, 9094, 9),
(264922, NULL, 'PF18826', NULL, NULL, 'Bacteroidetes VLRF1 release factor', NULL, 'bVLRF1', NULL, NULL, 28741, 9),
(264923, NULL, 'PF00104', NULL, NULL, 'Ligand-binding domain of nuclear hormone receptor', NULL, 'Hormone_recep', NULL, NULL, 5738, 9),
(264924, NULL, 'PF12739', NULL, NULL, 'ER-Golgi trafficking TRAPP I complex 85 kDa subunit', NULL, 'TRAPPC-Trs85', NULL, NULL, 24242, 9),
(264925, NULL, 'PF13843', NULL, NULL, 'Transposase IS4', NULL, 'DDE_Tnp_1_7', NULL, NULL, 23631, 9),
(264926, NULL, 'PF15615', NULL, NULL, 'TerB-C domain', NULL, 'TerB_C', NULL, NULL, 25456, 9),
(264927, NULL, 'PF01087', NULL, NULL, 'Galactose-1-phosphate uridyl transferase, N-terminal domain', NULL, 'GalP_UDP_transf', NULL, NULL, 5856, 9),
(264928, NULL, 'PF03910', NULL, NULL, 'Adenovirus minor core protein PV', NULL, 'Adeno_PV', NULL, NULL, 2936, 9),
(264929, NULL, 'PF04353', NULL, NULL, 'Regulator of RNA polymerase sigma(70) subunit, Rsd/AlgQ', NULL, 'Rsd_AlgQ', NULL, NULL, 4803, 9),
(264930, NULL, 'PF04629', NULL, NULL, 'Islet cell autoantigen ICA69, C-terminal domain', NULL, 'ICA69', NULL, NULL, 2485, 9),
(264931, NULL, 'PF09333', NULL, NULL, 'Autophagy-related protein C terminal domain', NULL, 'ATG_C', NULL, NULL, 7313, 9),
(264932, NULL, 'PF10787', NULL, NULL, 'Uncharacterised protein from bacillus cereus group', NULL, 'YfmQ', NULL, NULL, 20542, 9),
(264933, NULL, 'PF13887', NULL, NULL, 'Myelin regulatory factor ICA domain', NULL, 'MYRF_ICA', NULL, NULL, 26696, 9),
(264934, NULL, 'PF18427', NULL, NULL, 'DD-reactivating factor swiveling domain', NULL, 'DDR_swiveling', NULL, NULL, 27950, 9),
(264935, NULL, 'PF13291', NULL, NULL, 'ACT domain', NULL, 'ACT_4', NULL, NULL, 6111, 9),
(264936, NULL, 'PF17621', NULL, NULL, 'Family of unknown function (DUF5508)', NULL, 'DUF5508', NULL, NULL, 17055, 9),
(264937, NULL, 'PF19138', NULL, NULL, 'Family of unknown function (DUF5821)', NULL, 'DUF5821', NULL, NULL, 34321, 9),
(264938, NULL, 'PF07442', NULL, NULL, 'Ponericin', NULL, 'Ponericin', NULL, NULL, 8766, 9),
(264939, NULL, 'PF04362', NULL, NULL, 'Bacterial Fe(2+) trafficking', NULL, 'Iron_traffic', NULL, NULL, 4621, 9),
(264940, NULL, 'PF10804', NULL, NULL, 'Protein of unknown function (DUF2538)', NULL, 'DUF2538', NULL, NULL, 24905, 9),
(264941, NULL, 'PF04558', NULL, NULL, 'Glutaminyl-tRNA synthetase, non-specific RNA binding region part 1', NULL, 'tRNA_synt_1c_R1', NULL, NULL, 2224, 9),
(264942, NULL, 'PF03599', NULL, NULL, 'CO dehydrogenase/acetyl-CoA synthase delta subunit', NULL, 'CdhD', NULL, NULL, 9411, 9),
(264943, NULL, 'PF07970', NULL, NULL, 'Endoplasmic reticulum vesicle transporter', NULL, 'COPIIcoated_ERV', NULL, NULL, 8267, 9),
(264944, NULL, 'PF16157', NULL, NULL, 'Domain of unknown function (DUF4865)', NULL, 'DUF4865', NULL, NULL, 24045, 9),
(264945, NULL, 'PF09475', NULL, NULL, 'Dot/Icm secretion system protein (dot_icm_IcmQ)', NULL, 'Dot_icm_IcmQ', NULL, NULL, 18791, 9),
(264946, NULL, 'PF02943', NULL, NULL, 'Ferredoxin thioredoxin reductase catalytic beta chain', NULL, 'FeThRed_B', NULL, NULL, 3779, 9),
(264947, NULL, 'PF05332', NULL, NULL, 'Vesivirus VP2 protein', NULL, 'Vesi_VP2', NULL, NULL, 4317, 9),
(264948, NULL, 'PF06775', NULL, NULL, 'Putative adipose-regulatory protein (Seipin)', NULL, 'Seipin', NULL, NULL, 1775, 9),
(264949, NULL, 'PF09218', NULL, NULL, 'Domain of unknown function (DUF1959)', NULL, 'DUF1959', NULL, NULL, 11203, 9),
(264950, NULL, 'PF14080', NULL, NULL, 'Domain of unknown function (DUF4261)', NULL, 'DUF4261', NULL, NULL, 22897, 9),
(264951, NULL, 'PF11937', NULL, NULL, 'Protein of unknown function (DUF3455)', NULL, 'DUF3455', NULL, NULL, 19966, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(264952, NULL, 'PF17084', NULL, NULL, 'Topoisomerase I damage affected protein 11', NULL, 'TDA11', NULL, NULL, 24197, 9),
(264953, NULL, 'PF14424', NULL, NULL, 'The  BURPS668_1122 family of deaminases', NULL, 'Toxin-deaminase', NULL, NULL, 26599, 9),
(264954, NULL, 'PF18755', NULL, NULL, 'Restriction Enzyme Adenine Methylase Associated', NULL, 'RAMA', NULL, NULL, 32141, 9),
(264955, NULL, 'PF12094', NULL, NULL, 'Protein of unknown function (DUF3570)', NULL, 'DUF3570', NULL, NULL, 20168, 9),
(264956, NULL, 'PF08945', NULL, NULL, 'Bcl-x interacting, BH3 domain', NULL, 'Bclx_interact', NULL, NULL, 7789, 9),
(264957, NULL, 'PF18943', NULL, NULL, 'Family of unknown function (DUF5690)', NULL, 'DUF5690', NULL, NULL, 35620, 9),
(264958, NULL, 'PF16411', NULL, NULL, 'Outer membrane protein SusF_SusE', NULL, 'SusF_SusE', NULL, NULL, 23615, 9),
(264959, NULL, 'PF06812', NULL, NULL, 'ImpA, N-terminal, type VI secretion system', NULL, 'ImpA_N', NULL, NULL, 9149, 9),
(264960, NULL, 'PF06823', NULL, NULL, 'Protein of unknown function (DUF1236)', NULL, 'DUF1236', NULL, NULL, 11472, 9),
(264961, NULL, 'PF15904', NULL, NULL, 'LKB1 serine/threonine kinase interacting protein 1', NULL, 'LIP1', NULL, NULL, 25923, 9),
(264962, NULL, 'PF06820', NULL, NULL, 'Putative prophage tail fibre C-terminus', NULL, 'Phage_fiber_C', NULL, NULL, 10983, 9),
(264963, NULL, 'PF13599', NULL, NULL, 'Pentapeptide repeats (9 copies)', NULL, 'Pentapeptide_4', NULL, NULL, 5366, 9),
(264964, NULL, 'PF05785', NULL, NULL, 'Rho-activating domain of cytotoxic necrotizing factor', NULL, 'CNF1', NULL, NULL, 8767, 9),
(264965, NULL, 'PF00071', NULL, NULL, 'Ras family', NULL, 'Ras', NULL, NULL, 4843, 9),
(264966, NULL, 'PF09264', NULL, NULL, 'Vibrio cholerae sialidase, lectin insertion', NULL, 'Sial-lect-inser', NULL, NULL, 13370, 9),
(264967, NULL, 'PF15182', NULL, NULL, 'Otospiralin', NULL, 'OTOS', NULL, NULL, 22689, 9),
(264968, NULL, 'PF03226', NULL, NULL, 'Yippee zinc-binding/DNA-binding /Mis18, centromere assembly', NULL, 'Yippee-Mis18', NULL, NULL, 1648, 9),
(264969, NULL, 'PF10649', NULL, NULL, 'Protein of unknown function (DUF2478)', NULL, 'DUF2478', NULL, NULL, 14617, 9),
(264970, NULL, 'PF14516', NULL, NULL, 'AAA-like domain', NULL, 'AAA_35', NULL, NULL, NULL, 9),
(264971, NULL, 'PF15009', NULL, NULL, 'Transmembrane protein 173', NULL, 'TMEM173', NULL, NULL, 26786, 9),
(264972, NULL, 'PF05084', NULL, NULL, 'Granule antigen protein (GRA6)', NULL, 'GRA6', NULL, NULL, 6436, 9),
(264973, NULL, 'PF14631', NULL, NULL, 'Fanconi anaemia protein FancD2 nuclease', NULL, 'FancD2', NULL, NULL, 25524, 9),
(264974, NULL, 'PF06041', NULL, NULL, 'Bacterial protein of unknown function (DUF924)', NULL, 'DUF924', NULL, NULL, 8965, 9),
(264975, NULL, 'PF08624', NULL, NULL, 'Chromatin remodelling complex Rsc7/Swp82 subunit', NULL, 'CRC_subunit', NULL, NULL, 14432, 9),
(264976, NULL, 'PF14605', NULL, NULL, 'Nup53/35/40-type RNA recognition motif', NULL, 'Nup35_RRM_2', NULL, NULL, NULL, 9),
(264977, NULL, 'PF10278', NULL, NULL, 'Mediator of RNA pol II transcription subunit 19', NULL, 'Med19', NULL, NULL, 16903, 9),
(264978, NULL, 'PF16487', NULL, NULL, 'Mid domain of argonaute', NULL, 'ArgoMid', NULL, NULL, 21503, 9),
(264979, NULL, 'PF17847', NULL, NULL, 'Glucose ABC transporter C-terminal domain', NULL, 'GlcV_C_terminal', NULL, NULL, 32566, 9),
(264980, NULL, 'PF02459', NULL, NULL, 'Adenoviral DNA terminal protein', NULL, 'Adeno_terminal', NULL, NULL, 5404, 9),
(264981, NULL, 'PF16698', NULL, NULL, 'Membrane-proximal domain, switch, for ADAM17', NULL, 'ADAM17_MPD', NULL, NULL, 23106, 9),
(264982, NULL, 'PF18253', NULL, NULL, 'Hsp70-interacting protein N N-terminal domain', NULL, 'HipN', NULL, NULL, 5555, 9),
(264983, NULL, 'PF19209', NULL, NULL, 'Coronavirus spike glycoprotein S1, C-terminal', NULL, 'CoV_S1_C', NULL, NULL, 35496, 9),
(264984, NULL, 'PF04747', NULL, NULL, 'Protein of unknown function, DUF612', NULL, 'DUF612', NULL, NULL, 3631, 9),
(264985, NULL, 'PF06174', NULL, NULL, 'Protein of unknown function (DUF987)', NULL, 'DUF987', NULL, NULL, 14155, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(264986, NULL, 'PF00665', NULL, NULL, 'Integrase core domain', NULL, 'rve', NULL, NULL, 5041, 9),
(264987, NULL, 'PF03014', NULL, NULL, 'Structural protein 2', NULL, 'SP2', NULL, NULL, 3704, 9),
(264988, NULL, 'PF10243', NULL, NULL, 'Microtubule-binding protein MIP-T3 CH-like domain', NULL, 'MIP-T3', NULL, NULL, 27720, 9),
(264989, NULL, 'PF00723', NULL, NULL, 'Glycosyl hydrolases family 15', NULL, 'Glyco_hydro_15', NULL, NULL, 10367, 9),
(264990, NULL, 'PF13411', NULL, NULL, 'MerR HTH family regulatory protein', NULL, 'MerR_1', NULL, NULL, 5889, 9),
(264991, NULL, 'PF03274', NULL, NULL, 'Foamy virus BEL 1/2 protein', NULL, 'Foamy_BEL', NULL, NULL, 2503, 9),
(264992, NULL, 'PF19909', NULL, NULL, 'Domain of unknown function (DUF6382)', NULL, 'DUF6382', NULL, NULL, 36533, 9),
(264993, NULL, 'PF17094', NULL, NULL, 'Uncharacterised protein family (UPF0715)', NULL, 'UPF0715', NULL, NULL, 24385, 9),
(264994, NULL, 'PF07385', NULL, NULL, 'D-lyxose isomerase', NULL, 'Lyx_isomer', NULL, NULL, 11729, 9),
(264995, NULL, 'PF14763', NULL, NULL, 'Hermansky-Pudlak syndrome 3, C-terminal', NULL, 'HPS3_C', NULL, NULL, 26677, 9),
(264996, NULL, 'PF04884', NULL, NULL, 'Vitamin B6 photo-protection and homoeostasis', NULL, 'UVB_sens_prot', NULL, NULL, 5720, 9),
(264997, NULL, 'PF04039', NULL, NULL, 'Domain related to MnhB subunit of Na+/H+ antiporter', NULL, 'MnhB', NULL, NULL, 655, 9),
(264998, NULL, 'PF18408', NULL, NULL, 'C2H2 Hakai zinc finger domain', NULL, 'zf_Hakai', NULL, NULL, 29300, 9),
(264999, NULL, 'PF06896', NULL, NULL, 'Phage tail assembly chaperone proteins, TAC', NULL, 'Phage_TAC_3', NULL, NULL, 11538, 9),
(265000, NULL, 'PF19223', NULL, NULL, 'Chroparavirus methyltransferase', NULL, 'Chropara_Vmeth', NULL, NULL, 34728, 9),
(265001, NULL, 'PF19881', NULL, NULL, 'Family of unknown function (DUF6354)', NULL, 'DUF6354', NULL, NULL, 36982, 9),
(265002, NULL, 'PF03776', NULL, NULL, 'Septum formation topological specificity factor MinE', NULL, 'MinE', NULL, NULL, 1808, 9),
(265003, NULL, 'PF02543', NULL, NULL, 'Carbamoyltransferase N-terminus', NULL, 'Carbam_trans_N', NULL, NULL, 2189, 9),
(265004, NULL, 'PF05832', NULL, NULL, 'Eukaryotic protein of unknown function (DUF846)', NULL, 'DUF846', NULL, NULL, 13380, 9),
(265005, NULL, 'PF18348', NULL, NULL, 'Bacterial dipeptidyl-peptidase Sh3 domain', NULL, 'SH3_16', NULL, NULL, 29267, 9),
(265006, NULL, 'PF14329', NULL, NULL, 'Domain of unknown function (DUF4386)', NULL, 'DUF4386', NULL, NULL, 26360, 9),
(265007, NULL, 'PF09925', NULL, NULL, 'Predicted membrane protein (DUF2157)', NULL, 'DUF2157', NULL, NULL, 17238, 9),
(265008, NULL, 'PF18066', NULL, NULL, 'Phage ABA sandwich domain', NULL, 'Phage_ABA_S', NULL, NULL, 29505, 9),
(265009, NULL, 'PF09620', NULL, NULL, 'CRISPR-associated protein (Cas_csx3)', NULL, 'Cas_csx3', NULL, NULL, 9344, 9),
(265010, NULL, 'PF09428', NULL, NULL, 'Fungal protein of unknown function (DUF2011)', NULL, 'DUF2011', NULL, NULL, 15232, 9),
(265011, NULL, 'PF13162', NULL, NULL, 'Protein of unknown function (DUF3997)', NULL, 'DUF3997', NULL, NULL, 22543, 9),
(265012, NULL, 'PF07191', NULL, NULL, 'zinc-ribbons', NULL, 'zinc-ribbons_6', NULL, NULL, 10927, 9),
(265013, NULL, 'PF09242', NULL, NULL, 'Flavocytochrome c sulphide dehydrogenase, flavin-binding', NULL, 'FCSD-flav_bind', NULL, NULL, 13151, 9),
(265014, NULL, 'PF15835', NULL, NULL, 'Domain of unknown function (DUF4715)', NULL, 'DUF4715', NULL, NULL, 25570, 9),
(265015, NULL, 'PF00185', NULL, NULL, 'Aspartate/ornithine carbamoyltransferase, Asp/Orn binding domain', NULL, 'OTCace', NULL, NULL, 10358, 9),
(265016, NULL, 'PF01331', NULL, NULL, 'mRNA capping enzyme, catalytic domain', NULL, 'mRNA_cap_enzyme', NULL, NULL, 7077, 9),
(265017, NULL, 'PF00211', NULL, NULL, 'Adenylate and Guanylate cyclase catalytic domain', NULL, 'Guanylate_cyc', NULL, NULL, 1287, 9),
(265018, NULL, 'PF17038', NULL, NULL, 'Cellulose biosynthesis protein BcsN', NULL, 'CBP_BcsN', NULL, NULL, 22503, 9),
(265019, NULL, 'PF10514', NULL, NULL, 'Pro-apoptotic Bcl-2 protein, BAD', NULL, 'Bcl-2_BAD', NULL, NULL, 20646, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(265020, NULL, 'PF10729', NULL, NULL, 'Cell division activator CedA', NULL, 'CedA', NULL, NULL, 20549, 9),
(265021, NULL, 'PF13620', NULL, NULL, 'Carboxypeptidase regulatory-like domain', NULL, 'CarboxypepD_reg', NULL, NULL, NULL, 9),
(265022, NULL, 'PF15640', NULL, NULL, 'Metallopeptidase toxin 4', NULL, 'Tox-MPTase4', NULL, NULL, 24942, 9),
(265023, NULL, 'PF00450', NULL, NULL, 'Serine carboxypeptidase', NULL, 'Peptidase_S10', NULL, NULL, 5008, 9),
(265024, NULL, 'PF09166', NULL, NULL, 'Biliverdin reductase, catalytic', NULL, 'Biliv-reduc_cat', NULL, NULL, 12179, 9),
(265025, NULL, 'PF13751', NULL, NULL, 'Transposase DDE domain', NULL, 'DDE_Tnp_1_6', NULL, NULL, 24235, 9),
(265026, NULL, 'PF15037', NULL, NULL, 'Interleukin-17 receptor extracellular region', NULL, 'IL17_R_N', NULL, NULL, 22298, 9),
(265027, NULL, 'PF17091', NULL, NULL, 'Inovirus G7P protein', NULL, 'Inovirus_G7P_1', NULL, NULL, 24307, 9),
(265028, NULL, 'PF19062', NULL, NULL, 'Family of unknown function (DUF5758)', NULL, 'DUF5758', NULL, NULL, 35493, 9),
(265029, NULL, 'PF10409', NULL, NULL, 'C2 domain of PTEN tumour-suppressor protein', NULL, 'PTEN_C2', NULL, NULL, 9091, 9),
(265030, NULL, 'PF15566', NULL, NULL, 'Immunity protein 32', NULL, 'Imm32', NULL, NULL, 25069, 9),
(265031, NULL, 'PF02403', NULL, NULL, 'Seryl-tRNA synthetase N-terminal domain', NULL, 'Seryl_tRNA_N', NULL, NULL, 13129, 9),
(265032, NULL, 'PF02778', NULL, NULL, 'tRNA intron endonuclease, N-terminal domain', NULL, 'tRNA_int_endo_N', NULL, NULL, 1611, 9),
(265033, NULL, 'PF19799', NULL, NULL, 'Family of unknown function (DUF6282)', NULL, 'DUF6282', NULL, NULL, 37462, 9),
(265034, NULL, 'PF14752', NULL, NULL, 'Retinol binding protein receptor', NULL, 'RBP_receptor', NULL, NULL, NULL, 9),
(265035, NULL, 'PF09232', NULL, NULL, 'Caenorhabditis elegans Her-1', NULL, 'Caenor_Her-1', NULL, NULL, 13317, 9),
(265036, NULL, 'PF12288', NULL, NULL, 'Carboxysome shell peptide mid-region', NULL, 'CsoS2_M', NULL, NULL, 14929, 9),
(265037, NULL, 'PF10745', NULL, NULL, 'Protein of unknown function (DUF2530)', NULL, 'DUF2530', NULL, NULL, 19886, 9),
(265038, NULL, 'PF03940', NULL, NULL, 'Male specific sperm protein', NULL, 'MSSP', NULL, NULL, 2605, 9),
(265039, NULL, 'PF15959', NULL, NULL, 'Domain of unknown function (DUF4762)', NULL, 'DUF4762', NULL, NULL, 26558, 9),
(265040, NULL, 'PF13820', NULL, NULL, 'Putative nucleic acid-binding region', NULL, 'Nucleic_acid_bd', NULL, NULL, 26755, 9),
(265041, NULL, 'PF17119', NULL, NULL, 'Mitochondrial protein up-regulated during meiosis', NULL, 'MMU163', NULL, NULL, 26068, 9),
(265042, NULL, 'PF09570', NULL, NULL, 'SinI restriction endonuclease', NULL, 'RE_SinI', NULL, NULL, 16949, 9),
(265043, NULL, 'PF15006', NULL, NULL, 'Domain of unknown function (DUF4517)', NULL, 'DUF4517', NULL, NULL, 22016, 9),
(265044, NULL, 'PF12773', NULL, NULL, 'Double zinc ribbon', NULL, 'DZR', NULL, NULL, 25922, 9),
(265045, NULL, 'PF15574', NULL, NULL, 'Immunity protein 48', NULL, 'Imm48', NULL, NULL, 25423, 9),
(265046, NULL, 'PF01498', NULL, NULL, 'Transposase', NULL, 'HTH_Tnp_Tc3_2', NULL, NULL, 860, 9),
(265047, NULL, 'PF04643', NULL, NULL, 'Motilin/ghrelin-associated peptide', NULL, 'Motilin_assoc', NULL, NULL, 2688, 9),
(265048, NULL, 'PF08774', NULL, NULL, 'VRR-NUC domain', NULL, 'VRR_NUC', NULL, NULL, 13149, 9),
(265049, NULL, 'PF12283', NULL, NULL, 'Bacteriophage protein K', NULL, 'Protein_K', NULL, NULL, 14879, 9),
(265050, NULL, 'PF12714', NULL, NULL, 'TILa domain', NULL, 'TILa', NULL, NULL, 23278, 9),
(265051, NULL, 'PF17458', NULL, NULL, 'Family of unknown function (DUF5421)', NULL, 'DUF5421', NULL, NULL, 21369, 9),
(265052, NULL, 'PF04160', NULL, NULL, 'Orf-X protein', NULL, 'Borrelia_orfX', NULL, NULL, 7031, 9),
(265053, NULL, 'PF16837', NULL, NULL, 'Pre-mRNA-splicing factor SF3A3, of SF3a complex, Prp9', NULL, 'SF3A3', NULL, NULL, 26120, 9),
(265054, NULL, 'PF01950', NULL, NULL, 'Fructose-1,6-bisphosphatase', NULL, 'FBPase_3', NULL, NULL, 4556, 9),
(265055, NULL, 'PF02590', NULL, NULL, 'Predicted SPOUT methyltransferase', NULL, 'SPOUT_MTase', NULL, NULL, 4425, 9);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(265056, NULL, 'PF01544', NULL, NULL, 'CorA-like Mg2+ transporter protein', NULL, 'CorA', NULL, NULL, 799, 9),
(265057, NULL, 'PF04013', NULL, NULL, 'Putative SAM-dependent RNA methyltransferase', NULL, 'Methyltrn_RNA_2', NULL, NULL, 202, 9),
(265058, NULL, 'PF02751', NULL, NULL, 'Transcription initiation factor IIA, gamma subunit', NULL, 'TFIIA_gamma_C', NULL, NULL, 14453, 9),
(265059, NULL, 'PF13655', NULL, NULL, 'N-terminal domain of reverse transcriptase', NULL, 'RVT_N', NULL, NULL, 24161, 9),
(265060, NULL, 'PF10270', NULL, NULL, 'Membrane magnesium transporter', NULL, 'MMgT', NULL, NULL, 14953, 9),
(265061, NULL, 'PF05725', NULL, NULL, 'FNIP Repeat', NULL, 'FNIP', NULL, NULL, 14234, 9),
(265062, NULL, 'PF16274', NULL, NULL, 'Qua1 domain', NULL, 'Qua1', NULL, NULL, 21546, 9),
(265063, NULL, 'PF02517', NULL, NULL, 'Type II CAAX prenyl endopeptidase Rce1-like', NULL, 'Rce1-like', NULL, NULL, 1070, 9),
(265064, NULL, 'PF07485', NULL, NULL, 'Domain of Unknown Function (DUF1259)', NULL, 'DUF1529', NULL, NULL, 11044, 9),
(265065, NULL, 'PF12618', NULL, NULL, 'Protein of unknown function (DUF3776)', NULL, 'DUF3776', NULL, NULL, 21362, 9),
(265066, NULL, 'PF13106', NULL, NULL, 'Domain of unknown function (DUF3961)', NULL, 'DUF3961', NULL, NULL, 22666, 9),
(265067, NULL, 'PF09650', NULL, NULL, 'Putative polyhydroxyalkanoic acid system protein (PHA_gran_rgn)', NULL, 'PHA_gran_rgn', NULL, NULL, 9183, 9),
(265068, NULL, 'PF13427', NULL, NULL, 'Domain of unknown function (DUF4111)', NULL, 'DUF4111', NULL, NULL, 22847, 9),
(265069, NULL, 'PF06750', NULL, NULL, 'Bacterial Peptidase A24 N-terminal domain', NULL, 'DiS_P_DiS', NULL, NULL, 9180, 9),
(265070, NULL, 'PF01664', NULL, NULL, 'Reovirus viral attachment protein sigma 1', NULL, 'Reo_sigma1', NULL, NULL, 1790, 9),
(265071, NULL, 'PF03453', NULL, NULL, 'MoeA N-terminal region (domain I and II)', NULL, 'MoeA_N', NULL, NULL, 10799, 9),
(265072, NULL, 'PF09130', NULL, NULL, 'Domain of unknown function (DUF1932)', NULL, 'DUF1932', NULL, NULL, 8177, 9),
(265073, NULL, 'PF14450', NULL, NULL, 'Cell division protein FtsA', NULL, 'FtsA', NULL, NULL, NULL, 9),
(265074, NULL, 'PF12718', NULL, NULL, 'Tropomyosin like', NULL, 'Tropomyosin_1', NULL, NULL, 5646, 9),
(265075, NULL, 'PF07254', NULL, NULL, 'Membrane-bound toxin component of toxin-antitoxin system', NULL, 'Cpta_toxin', NULL, NULL, 14358, 9),
(265076, NULL, 'PF12646', NULL, NULL, 'Domain of unknown function (DUF3783)', NULL, 'DUF3783', NULL, NULL, 19377, 9),
(265077, NULL, 'PF18857', NULL, NULL, 'Large polyvalent protein associated domain 38', NULL, 'LPD38', NULL, NULL, 27486, 9),
(265078, NULL, 'PF13886', NULL, NULL, 'Domain of unknown function (DUF4203)', NULL, 'DUF4203', NULL, NULL, 23035, 9),
(265079, NULL, 'PF11321', NULL, NULL, 'Protein of unknown function (DUF3123)', NULL, 'DUF3123', NULL, NULL, 18106, 9),
(265080, NULL, 'PF17219', NULL, NULL, 'Yaf2/RYBP C-terminal binding motif', NULL, 'YAF2_RYBP', NULL, NULL, 31408, 9),
(265081, NULL, 'PF17063', NULL, NULL, 'Phenol-soluble modulin alpha peptide family', NULL, 'PSMalpha', NULL, NULL, 26399, 9),
(265082, NULL, 'PF06586', NULL, NULL, 'TraK protein', NULL, 'TraK', NULL, NULL, 8078, 9),
(265083, NULL, 'PF03203', NULL, NULL, 'MerC mercury resistance protein', NULL, 'MerC', NULL, NULL, 6, 9),
(265084, NULL, 'PF07206', NULL, NULL, 'Baculovirus late expression factor 10 (LEF-10)', NULL, 'Baculo_LEF-10', NULL, NULL, 14232, 9),
(265085, NULL, 'PF12157', NULL, NULL, 'Protein of unknown function (DUF3591)', NULL, 'DUF3591', NULL, NULL, 16831, 9),
(265086, NULL, 'PF00164', NULL, NULL, 'Ribosomal protein S12/S23', NULL, 'Ribosom_S12_S23', NULL, NULL, 1086, 9),
(265087, NULL, 'PF16047', NULL, NULL, 'Frog antimicrobial peptide', NULL, 'Antimicrobial22', NULL, NULL, 22244, 9),
(265088, NULL, 'PF01698', NULL, NULL, 'Floricaula / Leafy protein SAM domain', NULL, 'SAM_LFY', NULL, NULL, 29156, 9),
(265089, NULL, 'PF14573', NULL, NULL, 'Acyl-carrier', NULL, 'PP-binding_2', NULL, NULL, 6159, 9),
(265090, NULL, 'PF09810', NULL, NULL, 'Exonuclease V - a 5'' deoxyribonuclease', NULL, 'Exo5', NULL, NULL, 18167, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(265091, NULL, 'PF11597', NULL, NULL, 'Mediator complex subunit 13 N-terminal', NULL, 'Med13_N', NULL, NULL, 18835, 9),
(265092, NULL, 'PF07995', NULL, NULL, 'Glucose / Sorbosone dehydrogenase', NULL, 'GSDH', NULL, NULL, 8390, 9),
(265093, NULL, 'PF19296', NULL, NULL, 'RelA/SpoT, AH and RIS domains', NULL, 'RelA_AH_RIS', NULL, NULL, 37254, 9),
(265094, NULL, 'PF03036', NULL, NULL, 'Perilipin family', NULL, 'Perilipin', NULL, NULL, 4523, 9),
(265095, NULL, 'PF11014', NULL, NULL, 'Protein of unknown function (DUF2852)', NULL, 'DUF2852', NULL, NULL, 17730, 9),
(265096, NULL, 'PF10942', NULL, NULL, 'Protein of unknown function (DUF2619)', NULL, 'DUF2619', NULL, NULL, 19659, 9),
(265097, NULL, 'PF06734', NULL, NULL, 'UL97', NULL, 'UL97', NULL, NULL, 8366, 9),
(265098, NULL, 'PF13033', NULL, NULL, 'Protein of unknown function (DUF3894)', NULL, 'DUF3894', NULL, NULL, 22966, 9),
(265099, NULL, 'PF12063', NULL, NULL, 'Domain of unknown function (DUF3543)', NULL, 'DUF3543', NULL, NULL, 16977, 9),
(265100, NULL, 'PF14972', NULL, NULL, 'Mitochondrial morphogenesis regulator', NULL, 'Mito_morph_reg', NULL, NULL, 25686, 9),
(265101, NULL, 'PF04528', NULL, NULL, 'Adenovirus early E4 34 kDa protein conserved region', NULL, 'Adeno_E4_34', NULL, NULL, 2812, 9),
(265102, NULL, 'PF16682', NULL, NULL, 'CXC domain of E3 ubiquitin-protein ligase MSL2', NULL, 'MSL2-CXC', NULL, NULL, 25426, 9),
(265103, NULL, 'PF06423', NULL, NULL, 'GWT1', NULL, 'GWT1', NULL, NULL, 8303, 9),
(265104, NULL, 'PF14411', NULL, NULL, 'A nuclease of the HNH/ENDO VII superfamily with conserved LHH', NULL, 'LHH', NULL, NULL, 22390, 9),
(265105, NULL, 'PF19191', NULL, NULL, 'HEF_HK domain', NULL, 'HEF_HK', NULL, NULL, 35629, 9),
(265106, NULL, 'PF06964', NULL, NULL, 'Alpha-L-arabinofuranosidase C-terminal domain', NULL, 'Alpha-L-AF_C', NULL, NULL, 9733, 9),
(265107, NULL, 'PF20323', NULL, NULL, 'Family of unknown function (DUF6618)', NULL, 'DUF6618', NULL, NULL, 37114, 9),
(265108, NULL, 'PF20427', NULL, NULL, 'Nuclear speckle splicing regulatory protein 1, RS-like domain', NULL, 'NRP1_C', NULL, NULL, 33807, 9),
(265109, NULL, 'PF05000', NULL, NULL, 'RNA polymerase Rpb1, domain 4', NULL, 'RNA_pol_Rpb1_4', NULL, NULL, 271, 9),
(265110, NULL, 'PF15619', NULL, NULL, 'Ciliary protein causing Leber congenital amaurosis disease', NULL, 'Lebercilin', NULL, NULL, 25448, 9),
(265111, NULL, 'PF09048', NULL, NULL, 'Cro', NULL, 'Cro', NULL, NULL, 4026, 9),
(265112, NULL, 'PF10258', NULL, NULL, 'Phosphorylated adapter RNA export protein, RNA-binding domain', NULL, 'PHAX_RNA-bd', NULL, NULL, 15974, 9),
(265113, NULL, 'PF15666', NULL, NULL, 'Germinal center-associated lymphoma', NULL, 'HGAL', NULL, NULL, 25567, 9),
(265114, NULL, 'PF02301', NULL, NULL, 'HORMA domain', NULL, 'HORMA', NULL, NULL, 6186, 9),
(265115, NULL, 'PF04108', NULL, NULL, 'Autophagy protein ATG17-like domain', NULL, 'ATG17_like', NULL, NULL, 37480, 9),
(265116, NULL, 'PF10128', NULL, NULL, 'Glucose-6-phosphate dehydrogenase subunit N-terminal domain', NULL, 'OpcA_G6PD_assem', NULL, NULL, 37715, 9),
(265117, NULL, 'PF06986', NULL, NULL, 'Type-1V conjugative transfer system mating pair stabilisation', NULL, 'TraN', NULL, NULL, 13566, 9),
(265118, NULL, 'PF16617', NULL, NULL, 'Intersectin and clathrin adaptor AP2 binding region', NULL, 'INTAP', NULL, NULL, 22018, 9),
(265119, NULL, 'PF15901', NULL, NULL, 'Sortilin, neurotensin receptor 3, C-terminal', NULL, 'Sortilin_C', NULL, NULL, 25742, 9),
(265120, NULL, 'PF19546', NULL, NULL, 'Family of unknown function (DUF6070)', NULL, 'DUF6070', NULL, NULL, 36497, 9),
(265121, NULL, 'PF07006', NULL, NULL, 'Protein of unknown function (DUF1310)', NULL, 'DUF1310', NULL, NULL, 9617, 9),
(265122, NULL, 'PF10921', NULL, NULL, 'Protein of unknown function (DUF2710)', NULL, 'DUF2710', NULL, NULL, 9319, 9),
(265123, NULL, 'PF16246', NULL, NULL, 'Domain of unknown function (DUF4903)', NULL, 'DUF4903', NULL, NULL, 24492, 9),
(265124, NULL, 'PF07150', NULL, NULL, 'Protein of unknown function (DUF1390)', NULL, 'DUF1390', NULL, NULL, 13300, 9),
(265125, NULL, 'PF10724', NULL, NULL, 'Protein of unknown function (DUF2516)', NULL, 'DUF2516', NULL, NULL, 20927, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(265126, NULL, 'PF14698', NULL, NULL, 'Argininosuccinate lyase C-terminal', NULL, 'ASL_C2', NULL, NULL, 21952, 9),
(265127, NULL, 'PF16745', NULL, NULL, 'RsgA N-terminal domain', NULL, 'RsgA_N', NULL, NULL, 22902, 9),
(265128, NULL, 'PF06006', NULL, NULL, 'Bacterial protein of unknown function (DUF905)', NULL, 'DUF905', NULL, NULL, 13560, 9),
(265129, NULL, 'PF02455', NULL, NULL, 'Hexon-associated protein (IIIa)', NULL, 'Hex_IIIa', NULL, NULL, 6451, 9),
(265130, NULL, 'PF05924', NULL, NULL, 'SAMP Motif', NULL, 'SAMP', NULL, NULL, 12685, 9),
(265131, NULL, 'PF05188', NULL, NULL, 'MutS domain II', NULL, 'MutS_II', NULL, NULL, 3464, 9),
(265132, NULL, 'PF00069', NULL, NULL, 'Protein kinase domain', NULL, 'Pkinase', NULL, NULL, 3595, 9),
(265133, NULL, 'PF13220', NULL, NULL, 'Protein of unknown function (DUF4028)', NULL, 'DUF4028', NULL, NULL, 22939, 9),
(265134, NULL, 'PF09059', NULL, NULL, 'TyeA', NULL, 'TyeA', NULL, NULL, 9888, 9),
(265135, NULL, 'PF18391', NULL, NULL, 'CHIP N-terminal tetratricopeptide repeat domain', NULL, 'CHIP_TPR_N', NULL, NULL, 29586, 9),
(265136, NULL, 'PF11727', NULL, NULL, 'Invariant surface glycoprotein', NULL, 'ISG65-75', NULL, NULL, 15069, 9),
(265137, NULL, 'PF13500', NULL, NULL, 'AAA domain', NULL, 'AAA_26', NULL, NULL, NULL, 9),
(265138, NULL, 'PF14732', NULL, NULL, 'Ubiquitin/SUMO-activating enzyme ubiquitin-like domain', NULL, 'UAE_UbL', NULL, NULL, 23280, 9),
(265139, NULL, 'PF17677', NULL, NULL, 'Glycosyl hydrolases family 38 C-terminal beta sandwich domain', NULL, 'Glyco_hydro38C2', NULL, NULL, 28658, 9),
(265140, NULL, 'PF07727', NULL, NULL, 'Reverse transcriptase (RNA-dependent DNA polymerase)', NULL, 'RVT_2', NULL, NULL, 18651, 9),
(265141, NULL, 'PF09798', NULL, NULL, 'DNA damage checkpoint protein', NULL, 'LCD1', NULL, NULL, 16024, 9),
(265142, NULL, 'PF15715', NULL, NULL, 'PCNA-associated factor histone like domain', NULL, 'PAF', NULL, NULL, 23554, 9),
(265143, NULL, 'PF08605', NULL, NULL, 'Fungal Rad9-like Rad53-binding', NULL, 'Rad9_Rad53_bind', NULL, NULL, 17950, 9),
(265144, NULL, 'PF02221', NULL, NULL, 'ML domain', NULL, 'E1_DerP2_DerF2', NULL, NULL, 1996, 9),
(265145, NULL, 'PF04735', NULL, NULL, 'Baculovirus DNA helicase', NULL, 'Baculo_helicase', NULL, NULL, 3952, 9),
(265146, NULL, 'PF08547', NULL, NULL, 'Complex I intermediate-associated protein 30 (CIA30)', NULL, 'CIA30', NULL, NULL, 9907, 9),
(265147, NULL, 'PF10503', NULL, NULL, 'Esterase PHB depolymerase', NULL, 'Esterase_PHB', NULL, NULL, 10586, 9),
(265148, NULL, 'PF01724', NULL, NULL, 'Domain of unknown function DUF29', NULL, 'DUF29', NULL, NULL, 2721, 9),
(265149, NULL, 'PF16946', NULL, NULL, 'OMPG-porin 1 family', NULL, 'Porin_OmpG_1_2', NULL, NULL, 25829, 9),
(265150, NULL, 'PF02521', NULL, NULL, 'Putative outer membrane protein', NULL, 'HP_OMP_2', NULL, NULL, 1089, 9),
(265151, NULL, 'PF16479', NULL, NULL, 'Domain of unknown function (DUF5056)', NULL, 'DUF5056', NULL, NULL, 26252, 9),
(265152, NULL, 'PF18480', NULL, NULL, 'Domain of unknown function (DUF5615)', NULL, 'DUF5615', NULL, NULL, 29869, 9),
(265153, NULL, 'PF13198', NULL, NULL, 'Protein of unknown function (DUF4014)', NULL, 'DUF4014', NULL, NULL, 22182, 9),
(265154, NULL, 'PF20067', NULL, NULL, 'Strictosidine synthase-like, N-terminal', NULL, 'SSL_N', NULL, NULL, NULL, 9),
(265155, NULL, 'PF13175', NULL, NULL, 'AAA ATPase domain', NULL, 'AAA_15', NULL, NULL, 30270, 9),
(265156, NULL, 'PF19805', NULL, NULL, 'Family of unknown function (DUF6288)', NULL, 'DUF6288', NULL, NULL, 37494, 9),
(265157, NULL, 'PF08933', NULL, NULL, 'Domain of unknown function (DUF1864)', NULL, 'DUF1864', NULL, NULL, 7795, 9),
(265158, NULL, 'PF19716', NULL, NULL, 'Family of unknown function (DUF6211)', NULL, 'DUF6211', NULL, NULL, 37096, 9),
(265159, NULL, 'PF04871', NULL, NULL, 'Uso1 / p115 like vesicle tethering protein, C terminal region', NULL, 'Uso1_p115_C', NULL, NULL, 5956, 9),
(265160, NULL, 'PF14538', NULL, NULL, 'Raptor N-terminal CASPase like domain', NULL, 'Raptor_N', NULL, NULL, 23576, 9),
(265161, NULL, 'PF14009', NULL, NULL, 'PADRE domain', NULL, 'PADRE', NULL, NULL, 22328, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(265162, NULL, 'PF19501', NULL, NULL, 'YetA-like protein', NULL, 'YetA', NULL, NULL, 36353, 9),
(265163, NULL, 'PF09577', NULL, NULL, 'Sporulation protein YpjB (SpoYpjB)', NULL, 'Spore_YpjB', NULL, NULL, 10695, 9),
(265164, NULL, 'PF01955', NULL, NULL, 'Adenosylcobinamide amidohydrolase', NULL, 'CbiZ', NULL, NULL, 4888, 9),
(265165, NULL, 'PF07663', NULL, NULL, 'Sorbitol phosphotransferase enzyme II C-terminus', NULL, 'EIIBC-GUT_C', NULL, NULL, 10539, 9),
(265166, NULL, 'PF13305', NULL, NULL, 'Tetracyclin repressor-like, C-terminal domain', NULL, 'TetR_C_33', NULL, NULL, 25758, 9),
(265167, NULL, 'PF16540', NULL, NULL, 'Arf6-interacting domain of mitotic kinesin-like protein 1', NULL, 'MKLP1_Arf_bdg', NULL, NULL, 25370, 9),
(265168, NULL, 'PF20080', NULL, NULL, 'ALTTAQ repeat', NULL, 'ALTTAQ_rpt', NULL, NULL, 35671, 9),
(265169, NULL, 'PF06574', NULL, NULL, 'FAD synthetase', NULL, 'FAD_syn', NULL, NULL, 13358, 9),
(265170, NULL, 'PF09856', NULL, NULL, 'Short-chain fatty acyl coenzyme A regulators', NULL, 'ScfRs', NULL, NULL, 16737, 9),
(265171, NULL, 'PF19066', NULL, NULL, 'Family of unknown function (DUF5762)', NULL, 'DUF5762', NULL, NULL, 35091, 9),
(265172, NULL, 'PF15296', NULL, NULL, 'Codanin-1 C-terminus', NULL, 'Codanin-1_C', NULL, NULL, 24874, 9),
(265173, NULL, 'PF18176', NULL, NULL, 'KptA in kinetoplastid DICER domain', NULL, 'KptA_kDCL', NULL, NULL, 27620, 9),
(265174, NULL, 'PF05407', NULL, NULL, 'Rubella virus endopeptidase', NULL, 'Peptidase_C27', NULL, NULL, 12121, 9),
(265175, NULL, 'PF13092', NULL, NULL, 'Kinetochore complex Sim4 subunit Fta1', NULL, 'CENP-L', NULL, NULL, 21761, 9),
(265176, NULL, 'PF14733', NULL, NULL, 'AP2-coincident C-terminal', NULL, 'ACDC', NULL, NULL, 23047, 9),
(265177, NULL, 'PF19305', NULL, NULL, 'MmgE/PrpD C-terminal domain', NULL, 'MmgE_PrpD_C', NULL, NULL, 36271, 9),
(265178, NULL, 'PF01023', NULL, NULL, 'S-100/ICaBP type calcium binding domain', NULL, 'S_100', NULL, NULL, 13194, 9),
(265179, NULL, 'PF00333', NULL, NULL, 'Ribosomal protein S5, N-terminal domain', NULL, 'Ribosomal_S5', NULL, NULL, 18612, 9),
(265180, NULL, 'PF09732', NULL, NULL, 'Cactus-binding C-terminus of cactin protein', NULL, 'CactinC_cactus', NULL, NULL, 17794, 9),
(265181, NULL, 'PF08993', NULL, NULL, 'T4 gene Gp59 loader of gp41 DNA helicase', NULL, 'T4_Gp59_N', NULL, NULL, 8680, 9),
(265182, NULL, 'PF20357', NULL, NULL, 'Family of unknown function (DUF6652)', NULL, 'DUF6652', NULL, NULL, 33911, 9),
(265183, NULL, 'PF08824', NULL, NULL, 'Serine rich protein interaction domain', NULL, 'Serine_rich', NULL, NULL, 14412, 9),
(265184, NULL, 'PF09834', NULL, NULL, 'Predicted membrane protein (DUF2061)', NULL, 'DUF2061', NULL, NULL, 16947, 9),
(265185, NULL, 'PF07279', NULL, NULL, 'Protein of unknown function (DUF1442)', NULL, 'DUF1442', NULL, NULL, 14278, 9),
(265186, NULL, 'PF05592', NULL, NULL, 'Bacterial alpha-L-rhamnosidase concanavalin-like domain', NULL, 'Bac_rhamnosid', NULL, NULL, 7887, 9),
(265187, NULL, 'PF06069', NULL, NULL, 'PerC transcriptional activator', NULL, 'PerC', NULL, NULL, 24561, 9),
(265188, NULL, 'PF05846', NULL, NULL, 'Chordopoxvirus A15 protein', NULL, 'Chordopox_A15', NULL, NULL, 8824, 9),
(265189, NULL, 'PF10994', NULL, NULL, 'Protein of unknown function (DUF2817)', NULL, 'DUF2817', NULL, NULL, 17879, 9),
(265190, NULL, 'PF04235', NULL, NULL, 'Protein of unknown function (DUF418)', NULL, 'DUF418', NULL, NULL, 5708, 9),
(265191, NULL, 'PF06923', NULL, NULL, 'Glucitol operon activator protein (GutM)', NULL, 'GutM', NULL, NULL, 11730, 9),
(265192, NULL, 'PF08858', NULL, NULL, 'IDEAL domain', NULL, 'IDEAL', NULL, NULL, 14214, 9),
(265193, NULL, 'PF19542', NULL, NULL, 'Family of unknown function (DUF6066)', NULL, 'DUF6066', NULL, NULL, 36067, 9),
(265194, NULL, 'PF03739', NULL, NULL, 'Lipopolysaccharide export system permease LptF/LptG', NULL, 'LptF_LptG', NULL, NULL, 757, 9),
(265195, NULL, 'PF16483', NULL, NULL, 'Beta-1,3-glucanase', NULL, 'Glyco_hydro_64', NULL, NULL, 17969, 9),
(265196, NULL, 'PF02313', NULL, NULL, 'Fumarate reductase subunit D', NULL, 'Fumarate_red_D', NULL, NULL, 5171, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(265197, NULL, 'PF15032', NULL, NULL, 'Protein of unknown function (DUF4529)', NULL, 'DUF4529', NULL, NULL, 22321, 9),
(265198, NULL, 'PF14767', NULL, NULL, 'Replication protein A interacting middle', NULL, 'RPA_interact_M', NULL, NULL, 23885, 9),
(265199, NULL, 'PF09671', NULL, NULL, 'Spore coat protein (Spore_GerQ)', NULL, 'Spore_GerQ', NULL, NULL, 14183, 9),
(265200, NULL, 'PF07581', NULL, NULL, 'The GLUG motif', NULL, 'Glug', NULL, NULL, 12652, 9),
(265201, NULL, 'PF20264', NULL, NULL, 'DUF4784 N-terminal Ig-like domain', NULL, 'DUF4784_N', NULL, NULL, 37676, 9),
(265202, NULL, 'PF09507', NULL, NULL, 'DNA polymerase subunit Cdc27', NULL, 'CDC27', NULL, NULL, 15546, 9),
(265203, NULL, 'PF14963', NULL, NULL, 'Get2-like', NULL, 'Get2_like', NULL, NULL, 21198, 9),
(265204, NULL, 'PF15719', NULL, NULL, 'Domain of unknown function (DUF4674)', NULL, 'DUF4674', NULL, NULL, 26541, 9),
(265205, NULL, 'PF00014', NULL, NULL, 'Kunitz/Bovine pancreatic trypsin inhibitor domain', NULL, 'Kunitz_BPTI', NULL, NULL, 481, 9),
(265206, NULL, 'PF12363', NULL, NULL, 'Phage tail assembly chaperone protein, TAC', NULL, 'Phage_TAC_12', NULL, NULL, 22399, 9),
(265207, NULL, 'PF02679', NULL, NULL, '(2R)-phospho-3-sulfolactate synthase (ComA)', NULL, 'ComA', NULL, NULL, 3363, 9),
(265208, NULL, 'PF15148', NULL, NULL, 'Apolipoprotein F', NULL, 'Apolipo_F', NULL, NULL, 25872, 9),
(265209, NULL, 'PF11086', NULL, NULL, 'Protein of unknown function (DUF2878)', NULL, 'DUF2878', NULL, NULL, 17982, 9),
(265210, NULL, 'PF19590', NULL, NULL, 'TrbL/VirB6 plasmid conjugal transfer like protein', NULL, 'TrbL_3', NULL, NULL, 33697, 9),
(265211, NULL, 'PF15383', NULL, NULL, 'Transmembrane protein 237', NULL, 'TMEM237', NULL, NULL, 24530, 9),
(265212, NULL, 'PF16282', NULL, NULL, 'SANT/Myb-like domain of DAMP1', NULL, 'SANT_DAMP1_like', NULL, NULL, 21721, 9),
(265213, NULL, 'PF10273', NULL, NULL, 'Pre-rRNA-processing protein TSR2', NULL, 'WGG', NULL, NULL, 16959, 9),
(265214, NULL, 'PF01102', NULL, NULL, 'Glycophorin A', NULL, 'Glycophorin_A', NULL, NULL, NULL, 9),
(265215, NULL, 'PF11871', NULL, NULL, 'Domain of unknown function (DUF3391)', NULL, 'DUF3391', NULL, NULL, 19499, 9),
(265216, NULL, 'PF01454', NULL, NULL, 'MAGE homology domain', NULL, 'MAGE', NULL, NULL, 88, 9),
(265217, NULL, 'PF08438', NULL, NULL, 'GTPase of unknown function C-terminal', NULL, 'MMR_HSR1_C', NULL, NULL, 11791, 9),
(265218, NULL, 'PF09875', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2102)', NULL, 'DUF2102', NULL, NULL, 10608, 9),
(265219, NULL, 'PF14646', NULL, NULL, 'MYCBP-associated protein family', NULL, 'MYCBPAP', NULL, NULL, 21596, 9),
(265220, NULL, 'PF02368', NULL, NULL, 'Bacterial Ig-like domain (group 2)', NULL, 'Big_2', NULL, NULL, 4199, 9),
(265221, NULL, 'PF15897', NULL, NULL, 'Domain of unknown function (DUF4741)', NULL, 'DUF4741', NULL, NULL, 25529, 9),
(265222, NULL, 'PF00773', NULL, NULL, 'RNB domain', NULL, 'RNB', NULL, NULL, 2300, 9),
(265223, NULL, 'PF05930', NULL, NULL, 'Prophage CP4-57 regulatory protein (AlpA)', NULL, 'Phage_AlpA', NULL, NULL, 7673, 9),
(265224, NULL, 'PF16744', NULL, NULL, 'KIAA1045 RING finger', NULL, 'zf-RING_15', NULL, NULL, 22958, 9),
(265225, NULL, 'PF09176', NULL, NULL, 'Methylene-tetrahydromethanopterin dehydrogenase, N-terminal', NULL, 'Mpt_N', NULL, NULL, 12120, 9),
(265226, NULL, 'PF12672', NULL, NULL, 'Protein of unknown function (DUF3793)', NULL, 'DUF3793', NULL, NULL, 24937, 9),
(265227, NULL, 'PF03600', NULL, NULL, 'Citrate transporter', NULL, 'CitMHS', NULL, NULL, 3301, 9),
(265228, NULL, 'PF10974', NULL, NULL, 'Protein of unknown function (DUF2804)', NULL, 'DUF2804', NULL, NULL, 17930, 9),
(265229, NULL, 'PF11611', NULL, NULL, 'Domain of unknown function (DUF4352)', NULL, 'DUF4352', NULL, NULL, 25772, 9),
(265230, NULL, 'PF18299', NULL, NULL, 'ATP-grasp domain, R2K clade family 2', NULL, 'R2K_2', NULL, NULL, 29459, 9),
(265231, NULL, 'PF01205', NULL, NULL, 'Uncharacterized protein family UPF0029', NULL, 'UPF0029', NULL, NULL, 6474, 9),
(265232, NULL, 'PF08510', NULL, NULL, 'PIG-P', NULL, 'PIG-P', NULL, NULL, 14126, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(265233, NULL, 'PF05351', NULL, NULL, 'GMP-PDE, delta subunit', NULL, 'GMP_PDE_delta', NULL, NULL, 5200, 9),
(265234, NULL, 'PF17211', NULL, NULL, 'VHL box domain', NULL, 'VHL_C', NULL, NULL, 11623, 9),
(265235, NULL, 'PF17477', NULL, NULL, 'Rotavirus VP4 membrane interaction domain', NULL, 'Rota_VP4_MID', NULL, NULL, 18849, 9),
(265236, NULL, 'PF00063', NULL, NULL, 'Myosin head (motor domain)', NULL, 'Myosin_head', NULL, NULL, 3265, 9),
(265237, NULL, 'PF00807', NULL, NULL, 'Apidaecin', NULL, 'Apidaecin', NULL, NULL, 4114, 9),
(265238, NULL, 'PF16750', NULL, NULL, 'Sensor domain of 2-component histidine kinase', NULL, 'HK_sensor', NULL, NULL, 26397, 9),
(265239, NULL, 'PF13195', NULL, NULL, 'Protein of unknown function (DUF4011)', NULL, 'DUF4011', NULL, NULL, 22383, 9),
(265240, NULL, 'PF06218', NULL, NULL, 'Nitrogen permease regulator 2', NULL, 'NPR2', NULL, NULL, 14161, 9),
(265241, NULL, 'PF05865', NULL, NULL, 'Cypovirus polyhedrin protein', NULL, 'Cypo_polyhedrin', NULL, NULL, 12187, 9),
(265242, NULL, 'PF06193', NULL, NULL, 'Orthopoxvirus A5L protein-like', NULL, 'Orthopox_A5L', NULL, NULL, 9325, 9),
(265243, NULL, 'PF02761', NULL, NULL, 'CBL proto-oncogene N-terminus, EF hand-like domain', NULL, 'Cbl_N2', NULL, NULL, 14118, 9),
(265244, NULL, 'PF18587', NULL, NULL, 'PTX/LNS-Like (PLL) domain', NULL, 'PLL', NULL, NULL, 28023, 9),
(265245, NULL, 'PF06847', NULL, NULL, 'Archaeal Peptidase A24 C-terminus Type II', NULL, 'Arc_PepC_II', NULL, NULL, 11133, 9),
(265246, NULL, 'PF07205', NULL, NULL, 'Domain of unknown function (DUF1413)', NULL, 'DUF1413', NULL, NULL, 10901, 9),
(265247, NULL, 'PF08452', NULL, NULL, 'DNA polymerase family B exonuclease domain, N-terminal', NULL, 'DNAP_B_exo_N', NULL, NULL, 12446, 9),
(265248, NULL, 'PF17389', NULL, NULL, 'Bacterial alpha-L-rhamnosidase 6 hairpin glycosidase domain', NULL, 'Bac_rhamnosid6H', NULL, NULL, 14990, 9),
(265249, NULL, 'PF08572', NULL, NULL, 'pre-mRNA processing factor 3 (PRP3)', NULL, 'PRP3', NULL, NULL, 17564, 9),
(265250, NULL, 'PF16642', NULL, NULL, 'Unstructured region on Potassium channel subunit alpha KvLQT2', NULL, 'KCNQ2_u3', NULL, NULL, NULL, 9),
(265251, NULL, 'PF13075', NULL, NULL, 'Protein of unknown function (DUF3939)', NULL, 'DUF3939', NULL, NULL, 22907, 9),
(265252, NULL, 'PF03852', NULL, NULL, 'DNA mismatch endonuclease Vsr', NULL, 'Vsr', NULL, NULL, 971, 9),
(265253, NULL, 'PF08486', NULL, NULL, 'Stage II sporulation protein', NULL, 'SpoIID', NULL, NULL, 13836, 9),
(265254, NULL, 'PF14101', NULL, NULL, 'Domain of unknown function (DUF4275)', NULL, 'DUF4275', NULL, NULL, 22091, 9),
(265255, NULL, 'PF07432', NULL, NULL, 'Histone H1-like protein Hc1', NULL, 'Hc1', NULL, NULL, 11992, 9),
(265256, NULL, 'PF19658', NULL, NULL, 'Family of unknown function (DUF6161)', NULL, 'DUF6161', NULL, NULL, 37028, 9),
(265257, NULL, 'PF04152', NULL, NULL, 'Mre11 DNA-binding presumed domain', NULL, 'Mre11_DNA_bind', NULL, NULL, 7037, 9),
(265258, NULL, 'PF02286', NULL, NULL, 'Dehydratase large subunit', NULL, 'Dehydratase_LU', NULL, NULL, 2370, 9),
(265259, NULL, 'PF02916', NULL, NULL, 'DNA polymerase processivity factor', NULL, 'DNA_PPF', NULL, NULL, 2819, 9),
(265260, NULL, 'PF15295', NULL, NULL, 'Coiled-coil domain-containing protein 50  N-terminus', NULL, 'CCDC50_N', NULL, NULL, 24950, 9),
(265261, NULL, 'PF20542', NULL, NULL, 'Family of unknown function (DUF6757)', NULL, 'DUF6757', NULL, NULL, 33882, 9),
(265262, NULL, 'PF03532', NULL, NULL, 'OMS28 porin', NULL, 'OMS28_porin', NULL, NULL, 89, 9),
(265263, NULL, 'PF10203', NULL, NULL, 'Cytochrome c oxidase assembly protein PET191', NULL, 'Pet191_N', NULL, NULL, 19276, 9),
(265264, NULL, 'PF13565', NULL, NULL, 'Homeodomain-like domain', NULL, 'HTH_32', NULL, NULL, NULL, 9),
(265265, NULL, 'PF04168', NULL, NULL, 'A predicted alpha-helical domain with a conserved ER motif.', NULL, 'Alpha-E', NULL, NULL, 7088, 9),
(265266, NULL, 'PF02518', NULL, NULL, 'Histidine kinase-, DNA gyrase B-, and HSP90-like ATPase', NULL, 'HATPase_c', NULL, NULL, 52, 9),
(265267, NULL, 'PF13665', NULL, NULL, 'Toxin PAAR-like domain', NULL, 'Tox-PAAR-like', NULL, NULL, 22082, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(265268, NULL, 'PF09922', NULL, NULL, 'Cell wall-active antibiotics response 4TMS YvqF', NULL, 'DUF2154', NULL, NULL, 23512, 9),
(265269, NULL, 'PF18314', NULL, NULL, 'Fatty acid synthase type I helical domain', NULL, 'FAS_I_H', NULL, NULL, 29608, 9),
(265270, NULL, 'PF15649', NULL, NULL, 'Restriction endonuclease fold toxin 7', NULL, 'Tox-REase-7', NULL, NULL, 24875, 9),
(265271, NULL, 'PF02606', NULL, NULL, 'Tetraacyldisaccharide-1-P 4''-kinase', NULL, 'LpxK', NULL, NULL, 2245, 9),
(265272, NULL, 'PF16749', NULL, NULL, 'Arterivirus nonstructural protein 7 alpha', NULL, 'Arteri_nsp7a', NULL, NULL, 26403, 9),
(265273, NULL, 'PF03071', NULL, NULL, 'GNT-I family', NULL, 'GNT-I', NULL, NULL, 2807, 9),
(265274, NULL, 'PF02883', NULL, NULL, 'Adaptin C-terminal domain', NULL, 'Alpha_adaptinC2', NULL, NULL, 7062, 9),
(265275, NULL, 'PF12110', NULL, NULL, 'Nuclear protein 96', NULL, 'Nup96', NULL, NULL, 20044, 9),
(265276, NULL, 'PF05186', NULL, NULL, 'Dpy-30 motif', NULL, 'Dpy-30', NULL, NULL, 3121, 9),
(265277, NULL, 'PF10385', NULL, NULL, 'RNA polymerase beta subunit external 1 domain', NULL, 'RNA_pol_Rpb2_45', NULL, NULL, 17047, 9),
(265278, NULL, 'PF10847', NULL, NULL, 'Protein of unknown function (DUF2656)', NULL, 'DUF2656', NULL, NULL, 19645, 9),
(265279, NULL, 'PF20017', NULL, NULL, 'vWA-MoxR associated protein middle region (VMAP-M) 15', NULL, 'VMAP-M15', NULL, NULL, NULL, 9),
(265280, NULL, 'PF00980', NULL, NULL, 'Rotavirus major capsid protein VP6', NULL, 'Rota_Capsid_VP6', NULL, NULL, 2134, 9),
(265281, NULL, 'PF04403', NULL, NULL, 'Paraquat-inducible protein A', NULL, 'PqiA', NULL, NULL, 10156, 9),
(265282, NULL, 'PF03389', NULL, NULL, 'MobA/MobL family', NULL, 'MobA_MobL', NULL, NULL, 2177, 9),
(265283, NULL, 'PF13981', NULL, NULL, 'SopA-like central domain', NULL, 'SopA', NULL, NULL, 22919, 9),
(265284, NULL, 'PF01136', NULL, NULL, 'Peptidase family U32', NULL, 'Peptidase_U32', NULL, NULL, 5981, 9),
(265285, NULL, 'PF14711', NULL, NULL, 'Respiratory nitrate reductase beta C-terminal', NULL, 'Nitr_red_bet_C', NULL, NULL, 21577, 9),
(265286, NULL, 'PF11418', NULL, NULL, 'Phi29 scaffolding protein', NULL, 'Scaffolding_pro', NULL, NULL, 22075, 9),
(265287, NULL, 'PF09861', NULL, NULL, 'Lactate racemase N-terminal domain', NULL, 'Lar_N', NULL, NULL, 16981, 9),
(265288, NULL, 'PF14362', NULL, NULL, 'Domain of unknown function (DUF4407)', NULL, 'DUF4407', NULL, NULL, 26133, 9),
(265289, NULL, 'PF14125', NULL, NULL, 'Domain of unknown function (DUF4292)', NULL, 'DUF4292', NULL, NULL, 24571, 9),
(265290, NULL, 'PF12863', NULL, NULL, 'Domain of unknown function (DUF3821)', NULL, 'DUF3821', NULL, NULL, 10306, 9),
(265291, NULL, 'PF04384', NULL, NULL, 'Iron-sulphur cluster assembly', NULL, 'Fe-S_assembly', NULL, NULL, 10235, 9),
(265292, NULL, 'PF10806', NULL, NULL, 'SAM35, subunit of SAM coomplex', NULL, 'SAM35', NULL, NULL, 17576, 9),
(265293, NULL, 'PF15971', NULL, NULL, 'DolP-mannose mannosyltransferase', NULL, 'Mannosyl_trans4', NULL, NULL, 25900, 9),
(265294, NULL, 'PF20230', NULL, NULL, 'Family of unknown function (DUF6588)', NULL, 'DUF6588', NULL, NULL, 37613, 9),
(265295, NULL, 'PF20235', NULL, NULL, 'Family of unknown function (DUF6592)', NULL, 'DUF6592', NULL, NULL, 37731, 9),
(265296, NULL, 'PF13228', NULL, NULL, 'Domain of unknown function (DUF4037)', NULL, 'DUF4037', NULL, NULL, 22501, 9),
(265297, NULL, 'PF19809', NULL, NULL, 'Family of unknown function (DUF6292)', NULL, 'DUF6292', NULL, NULL, 37210, 9),
(265298, NULL, 'PF19022', NULL, NULL, 'Family of unknown function (DUF5748)', NULL, 'DUF5748', NULL, NULL, 36000, 9),
(265299, NULL, 'PF05349', NULL, NULL, 'GATA-type transcription activator, N-terminal', NULL, 'GATA-N', NULL, NULL, 5379, 9),
(265300, NULL, 'PF11124', NULL, NULL, 'Inorganic phosphate transporter chaperone Pho86', NULL, 'Pho86', NULL, NULL, 20247, 9),
(265301, NULL, 'PF11441', NULL, NULL, 'Pilot protein MxiM', NULL, 'MxiM', NULL, NULL, 18867, 9),
(265302, NULL, 'PF05478', NULL, NULL, 'Prominin', NULL, 'Prominin', NULL, NULL, 13550, 9),
(265303, NULL, 'PF13695', NULL, NULL, 'Zinc-binding domain', NULL, 'zf-3CxxC', NULL, NULL, 24012, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(265304, NULL, 'PF07330', NULL, NULL, 'Protein of unknown function (DUF1467)', NULL, 'DUF1467', NULL, NULL, 8172, 9),
(265305, NULL, 'PF14071', NULL, NULL, 'Putative coat protein', NULL, 'YlbD_coat', NULL, NULL, 21658, 9),
(265306, NULL, 'PF04973', NULL, NULL, 'Nicotinamide mononucleotide transporter', NULL, 'NMN_transporter', NULL, NULL, 6860, 9),
(265307, NULL, 'PF18776', NULL, NULL, 'Hexapeptide repeat including loop', NULL, 'Hexapep_loop', NULL, NULL, 28462, 9),
(265308, NULL, 'PF16093', NULL, NULL, 'Proteasome assembly chaperone 4', NULL, 'PAC4', NULL, NULL, 26297, 9),
(265309, NULL, 'PF18600', NULL, NULL, 'MCSS domain', NULL, 'Ezh2_MCSS', NULL, NULL, 27742, 9),
(265310, NULL, 'PF12392', NULL, NULL, 'Collagenase', NULL, 'DUF3656', NULL, NULL, 14513, 9),
(265311, NULL, 'PF16043', NULL, NULL, 'Domain of unknown function (DUF4795)', NULL, 'DUF4795', NULL, NULL, 25949, 9),
(265312, NULL, 'PF16968', NULL, NULL, 'Pilus assembly protein TadZ N-terminal', NULL, 'TadZ_N', NULL, NULL, 22099, 9),
(265313, NULL, 'PF03295', NULL, NULL, 'Poxvirus trans-activator protein A1 C-terminal', NULL, 'Pox_TAA1', NULL, NULL, 953, 9),
(265314, NULL, 'PF05942', NULL, NULL, 'Archaeal PaREP1/PaREP8 family', NULL, 'PaREP1', NULL, NULL, 7693, 9),
(265315, NULL, 'PF16995', NULL, NULL, 'Transmembrane region of lysyl-tRNA synthetase', NULL, 'tRNA-synt_2_TM', NULL, NULL, 24367, 9),
(265316, NULL, 'PF19158', NULL, NULL, 'Family of unknown function (DUF5840)', NULL, 'DUF5840', NULL, NULL, 26271, 9),
(265317, NULL, 'PF14717', NULL, NULL, 'Domain of unknown function (DUF4465)', NULL, 'DUF4465', NULL, NULL, 21729, 9),
(265318, NULL, 'PF19794', NULL, NULL, 'Family of unknown function (DUF6278)', NULL, 'DUF6278', NULL, NULL, 37270, 9),
(265319, NULL, 'PF19612', NULL, NULL, 'Family of unknown function (DUF6117)', NULL, 'DUF6117', NULL, NULL, 37023, 9),
(265320, NULL, 'PF12498', NULL, NULL, 'Basic leucine-zipper C terminal', NULL, 'bZIP_C', NULL, NULL, 14692, 9),
(265321, NULL, 'PF07648', NULL, NULL, 'Kazal-type serine protease inhibitor domain', NULL, 'Kazal_2', NULL, NULL, 6489, 9),
(265322, NULL, 'PF14316', NULL, NULL, 'Domain of unknown function (DUF4381)', NULL, 'DUF4381', NULL, NULL, 26116, 9),
(265323, NULL, 'PF17489', NULL, NULL, 'L1 transposable element trimerization domain', NULL, 'Tnp_22_trimer', NULL, NULL, 10083, 9),
(265324, NULL, 'PF15589', NULL, NULL, 'Immunity protein 21', NULL, 'Imm21', NULL, NULL, 24822, 9),
(265325, NULL, 'PF10344', NULL, NULL, 'Mitochondrial protein from FMP27', NULL, 'Fmp27', NULL, NULL, 17164, 9),
(265326, NULL, 'PF05037', NULL, NULL, 'Protein of unknown function (DUF669)', NULL, 'DUF669', NULL, NULL, 1031, 9),
(265327, NULL, 'PF15732', NULL, NULL, 'Domain of unknown function (DUF4681)', NULL, 'DUF4681', NULL, NULL, 25764, 9),
(265328, NULL, 'PF06826', NULL, NULL, 'Predicted Permease Membrane Region', NULL, 'Asp-Al_Ex', NULL, NULL, 6725, 9),
(265329, NULL, 'PF12550', NULL, NULL, 'Transcriptional activator of glycolytic enzymes', NULL, 'GCR1_C', NULL, NULL, 21279, 9),
(265330, NULL, 'PF19276', NULL, NULL, 'HD associated region', NULL, 'HD_assoc_2', NULL, NULL, 37118, 9),
(265331, NULL, 'PF19688', NULL, NULL, 'Family of unknown function (DUF6189)', NULL, 'DUF6189', NULL, NULL, 37371, 9),
(265332, NULL, 'PF13708', NULL, NULL, 'Domain of unknown function (DUF4942)', NULL, 'DUF4942', NULL, NULL, 21710, 9),
(265333, NULL, 'PF19765', NULL, NULL, 'Family of unknown function (DUF6252)', NULL, 'DUF6252', NULL, NULL, 37039, 9),
(265334, NULL, 'PF02672', NULL, NULL, 'CP12 domain', NULL, 'CP12', NULL, NULL, NULL, 9),
(265335, NULL, 'PF07850', NULL, NULL, 'Renin receptor-like protein', NULL, 'Renin_r', NULL, NULL, 12667, 9),
(265336, NULL, 'PF00868', NULL, NULL, 'Transglutaminase family', NULL, 'Transglut_N', NULL, NULL, 4102, 9),
(265337, NULL, 'PF01326', NULL, NULL, 'Pyruvate phosphate dikinase, AMP/ATP-binding domain', NULL, 'PPDK_N', NULL, NULL, 250, 9),
(265338, NULL, 'PF12320', NULL, NULL, 'Type 5 capsule protein repressor C-terminal domain', NULL, 'SbcD_C', NULL, NULL, 25173, 9),
(265339, NULL, 'PF11634', NULL, NULL, 'Nuclease inhibitor from bacteriophage T4', NULL, 'IPI_T4', NULL, NULL, 22391, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(265340, NULL, 'PF11977', NULL, NULL, 'Zc3h12a-like Ribonuclease NYN domain', NULL, 'RNase_Zc3h12a', NULL, NULL, 19572, 9),
(265341, NULL, 'PF15916', NULL, NULL, 'Domain of unknown function (DUF4743)', NULL, 'DUF4743', NULL, NULL, 21363, 9),
(265342, NULL, 'PF15672', NULL, NULL, 'Cell-membrane associated Mucin15', NULL, 'Mucin15', NULL, NULL, 25347, 9),
(265343, NULL, 'PF02510', NULL, NULL, 'Surface presentation of antigens protein', NULL, 'SPAN', NULL, NULL, 6401, 9),
(265344, NULL, 'PF11733', NULL, NULL, 'Non-capsid protein NP1', NULL, 'NP1-WLL', NULL, NULL, 15476, 9),
(265345, NULL, 'PF07138', NULL, NULL, 'Baculovirus protein AC11', NULL, 'AcMNPV_AC11', NULL, NULL, 13190, 9),
(265346, NULL, 'PF03107', NULL, NULL, 'C1 domain', NULL, 'C1_2', NULL, NULL, 2594, 9),
(265347, NULL, 'PF13190', NULL, NULL, 'PDGLE domain', NULL, 'PDGLE', NULL, NULL, 23084, 9),
(265348, NULL, 'PF02136', NULL, NULL, 'Nuclear transport factor 2 (NTF2) domain', NULL, 'NTF2', NULL, NULL, 1216, 9),
(265349, NULL, 'PF03994', NULL, NULL, 'Domain of Unknown Function (DUF350)', NULL, 'DUF350', NULL, NULL, 154, 9),
(265350, NULL, 'PF06534', NULL, NULL, 'Repulsive guidance molecule (RGM) C-terminus', NULL, 'RGM_C', NULL, NULL, 9473, 9),
(265351, NULL, 'PF20484', NULL, NULL, 'Family of unknown function (DUF6723)', NULL, 'DUF6723', NULL, NULL, 33788, 9),
(265352, NULL, 'PF05030', NULL, NULL, 'SSXT protein (N-terminal region)', NULL, 'SSXT', NULL, NULL, 1161, 9),
(265353, NULL, 'PF13224', NULL, NULL, 'Domain of unknown function (DUF4032)', NULL, 'DUF4032', NULL, NULL, 22631, 9),
(265354, NULL, 'PF20327', NULL, NULL, 'Family of unknown function (DUF6622)', NULL, 'DUF6622', NULL, NULL, 37036, 9),
(265355, NULL, 'PF06581', NULL, NULL, 'Mad1 and Cdc20-bound-Mad2 binding', NULL, 'p31comet', NULL, NULL, 9218, 9),
(265356, NULL, 'PF14288', NULL, NULL, '1,3-beta-glucan synthase subunit FKS1, domain-1', NULL, 'FKS1_dom1', NULL, NULL, 26583, 9),
(265357, NULL, 'PF05868', NULL, NULL, 'Rotavirus major outer capsid protein VP7', NULL, 'Rotavirus_VP7', NULL, NULL, 13871, 9),
(265358, NULL, 'PF08973', NULL, NULL, 'Domain of unknown function (DUF1893)', NULL, 'TM1506', NULL, NULL, 8592, 9),
(265359, NULL, 'PF11184', NULL, NULL, 'Protein of unknown function (DUF2969)', NULL, 'DUF2969', NULL, NULL, 18293, 9),
(265360, NULL, 'PF05154', NULL, NULL, 'TM2 domain', NULL, 'TM2', NULL, NULL, 2341, 9),
(265361, NULL, 'PF08428', NULL, NULL, 'Rib domain', NULL, 'Rib', NULL, NULL, NULL, 9),
(265362, NULL, 'PF11754', NULL, NULL, 'Velvet factor', NULL, 'Velvet', NULL, NULL, 27074, 9),
(265363, NULL, 'PF14886', NULL, NULL, 'FAM183A and FAM183B related', NULL, 'FAM183', NULL, NULL, 26833, 9),
(265364, NULL, 'PF00090', NULL, NULL, 'Thrombospondin type 1 domain', NULL, 'TSP_1', NULL, NULL, 4898, 9),
(265365, NULL, 'PF04298', NULL, NULL, 'Putative neutral zinc metallopeptidase', NULL, 'Zn_peptidase_2', NULL, NULL, 3961, 9),
(265366, NULL, 'PF15968', NULL, NULL, 'Membrane-anchored ion channel, Abi component', NULL, 'RexB', NULL, NULL, 25965, 9),
(265367, NULL, 'PF10831', NULL, NULL, 'Protein of unknown function (DUF2556)', NULL, 'DUF2556', NULL, NULL, 16433, 9),
(265368, NULL, 'PF05483', NULL, NULL, 'Synaptonemal complex protein 1 (SCP-1)', NULL, 'SCP-1', NULL, NULL, 13849, 9),
(265369, NULL, 'PF17848', NULL, NULL, 'Acetyl-coA carboxylase zinc finger domain', NULL, 'zf-ACC', NULL, NULL, 31086, 9),
(265370, NULL, 'PF17802', NULL, NULL, 'Prealbumin-like fold domain', NULL, 'SpaA', NULL, NULL, 28978, 9),
(265371, NULL, 'PF17639', NULL, NULL, 'Family of unknown function (DUF5517)', NULL, 'DUF5517', NULL, NULL, 20055, 9),
(265372, NULL, 'PF11913', NULL, NULL, 'Protein of unknown function (DUF3431)', NULL, 'DUF3431', NULL, NULL, 19563, 9),
(265373, NULL, 'PF19407', NULL, NULL, 'Domain of unknown function (DUF5979)', NULL, 'DUF5979', NULL, NULL, 36756, 9),
(265374, NULL, 'PF07510', NULL, NULL, 'Protein of unknown function (DUF1524)', NULL, 'DUF1524', NULL, NULL, 11422, 9),
(265375, NULL, 'PF06140', NULL, NULL, 'Interferon-induced 6-16 family', NULL, 'Ifi-6-16', NULL, NULL, 14300, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(265376, NULL, 'PF06952', NULL, NULL, 'PsiA protein', NULL, 'PsiA', NULL, NULL, 12499, 9),
(265377, NULL, 'PF15051', NULL, NULL, 'FAM198 protein', NULL, 'FAM198', NULL, NULL, 26968, 9),
(265378, NULL, 'PF18433', NULL, NULL, 'Domain of unknown function (DUF5610)', NULL, 'DUF5610', NULL, NULL, 29728, 9),
(265379, NULL, 'PF08300', NULL, NULL, 'Hepatitis C virus non-structural 5a zinc finger domain', NULL, 'HCV_NS5a_1a', NULL, NULL, 17139, 9),
(265380, NULL, 'PF18459', NULL, NULL, 'Proprotein convertase subtilisin-like/kexin type 9 C-terminal domain', NULL, 'PCSK9_C1', NULL, NULL, 29134, 9),
(265381, NULL, 'PF08995', NULL, NULL, 'Necrosis inducing protein-1', NULL, 'NIP_1', NULL, NULL, 8805, 9),
(265382, NULL, 'PF08176', NULL, NULL, 'Small acid-soluble spore protein K family', NULL, 'SspK', NULL, NULL, 9770, 9),
(265383, NULL, 'PF09190', NULL, NULL, 'DALR domain', NULL, 'DALR_2', NULL, NULL, 12273, 9),
(265384, NULL, 'PF12097', NULL, NULL, 'Protein of unknown function (DUF3573)', NULL, 'DUF3573', NULL, NULL, 20266, 9),
(265385, NULL, 'PF09123', NULL, NULL, 'Domain of unknown function (DUF1931)', NULL, 'DUF1931', NULL, NULL, 10999, 9),
(265386, NULL, 'PF11169', NULL, NULL, 'Protein of unknown function (DUF2956)', NULL, 'DUF2956', NULL, NULL, 18259, 9),
(265387, NULL, 'PF17951', NULL, NULL, 'Fatty acid synthase meander beta sheet domain', NULL, 'FAS_meander', NULL, NULL, 33095, 9),
(265388, NULL, 'PF05563', NULL, NULL, 'Salmonella plasmid virulence protein SpvD', NULL, 'SpvD', NULL, NULL, 13655, 9),
(265389, NULL, 'PF14276', NULL, NULL, 'Domain of unknown function (DUF4363)', NULL, 'DUF4363', NULL, NULL, 21904, 9),
(265390, NULL, 'PF11674', NULL, NULL, 'Protein of unknown function (DUF3270)', NULL, 'DUF3270', NULL, NULL, 19170, 9),
(265391, NULL, 'PF08026', NULL, NULL, 'Bee antimicrobial peptide', NULL, 'Antimicrobial_5', NULL, NULL, 12658, 9),
(265392, NULL, 'PF05925', NULL, NULL, 'Enterobacterial virulence protein IpgD', NULL, 'IpgD', NULL, NULL, 6221, 9),
(265393, NULL, 'PF15712', NULL, NULL, 'NPAT C terminus', NULL, 'NPAT_C', NULL, NULL, 25034, 9),
(265394, NULL, 'PF02249', NULL, NULL, 'Methyl-coenzyme M reductase alpha subunit, C-terminal domain', NULL, 'MCR_alpha', NULL, NULL, 9837, 9),
(265395, NULL, 'PF08651', NULL, NULL, 'DASH complex subunit Duo1', NULL, 'DASH_Duo1', NULL, NULL, 7797, 9),
(265396, NULL, 'PF12014', NULL, NULL, 'Cyclin D1 binding domain', NULL, 'Cyclin_D1_bind', NULL, NULL, NULL, 9),
(265397, NULL, 'PF08336', NULL, NULL, 'Prolyl 4-Hydroxylase alpha-subunit, N-terminal region', NULL, 'P4Ha_N', NULL, NULL, 12907, 9),
(265398, NULL, 'PF20509', NULL, NULL, 'Family of unknown function (DUF6735)', NULL, 'DUF6735', NULL, NULL, 33686, 9),
(265399, NULL, 'PF09593', NULL, NULL, 'Beta-satellite pathogenicity beta C1 protein', NULL, 'Pathogen_betaC1', NULL, NULL, 15814, 9),
(265400, NULL, 'PF20417', NULL, NULL, 'Gemin6 C-terminal domain', NULL, 'Gemin6_C', NULL, NULL, 34016, 9),
(265401, NULL, 'PF08623', NULL, NULL, 'TATA-binding protein interacting (TIP20)', NULL, 'TIP120', NULL, NULL, 14174, 9),
(265402, NULL, 'PF15565', NULL, NULL, 'Immunity protein 30', NULL, 'Imm30', NULL, NULL, 25017, 9),
(265403, NULL, 'PF08952', NULL, NULL, 'Domain of unknown function (DUF1866)', NULL, 'DUF1866', NULL, NULL, 7920, 9),
(265404, NULL, 'PF07544', NULL, NULL, 'RNA polymerase II transcription mediator complex subunit 9', NULL, 'Med9', NULL, NULL, 13727, 9),
(265405, NULL, 'PF18942', NULL, NULL, 'Family of unknown function (DUF5689)', NULL, 'DUF5689', NULL, NULL, 35719, 9),
(265406, NULL, 'PF15169', NULL, NULL, 'Cytochrome b-245 chaperone 1 / Eros', NULL, 'Cybc1_Eros', NULL, NULL, 26193, 9),
(265407, NULL, 'PF11105', NULL, NULL, 'Arthropod cardioacceleratory peptide 2a', NULL, 'CCAP', NULL, NULL, 20288, 9),
(265408, NULL, 'PF00985', NULL, NULL, 'Merozoite Surface Antigen 2 (MSA-2) family', NULL, 'MSA_2', NULL, NULL, 1578, 9),
(265409, NULL, 'PF10368', NULL, NULL, 'Putative cell-wall binding lipoprotein', NULL, 'YkyA', NULL, NULL, 17017, 9),
(265410, NULL, 'PF18581', NULL, NULL, 'Synaptonemal complex 2 armadillo-repeat-like domain', NULL, 'SYCP2_ARLD', NULL, NULL, 30437, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(265411, NULL, 'PF06217', NULL, NULL, 'GAGA binding protein-like family', NULL, 'GAGA_bind', NULL, NULL, 9353, 9),
(265412, NULL, 'PF05751', NULL, NULL, 'FixH', NULL, 'FixH', NULL, NULL, 14265, 9),
(265413, NULL, 'PF18087', NULL, NULL, 'Rubisco Assembly chaperone C-terminal domain', NULL, 'RuBisCo_chap_C', NULL, NULL, 32870, 9),
(265414, NULL, 'PF01847', NULL, NULL, 'VHL beta domain', NULL, 'VHL', NULL, NULL, 12097, 9),
(265415, NULL, 'PF10584', NULL, NULL, 'Proteasome subunit A N-terminal signature', NULL, 'Proteasome_A_N', NULL, NULL, 6529, 9),
(265416, NULL, 'PF00891', NULL, NULL, 'O-methyltransferase domain', NULL, 'Methyltransf_2', NULL, NULL, 1189, 9),
(265417, NULL, 'PF01904', NULL, NULL, 'Protein of unknown function DUF72', NULL, 'DUF72', NULL, NULL, 4014, 9),
(265418, NULL, 'PF19149', NULL, NULL, 'Family of unknown function (DUF5831)', NULL, 'DUF5831', NULL, NULL, 34499, 9),
(265419, NULL, 'PF02699', NULL, NULL, 'Preprotein translocase subunit', NULL, 'YajC', NULL, NULL, 3067, 9),
(265420, NULL, 'PF17520', NULL, NULL, 'Family of unknown function (DUF5445)', NULL, 'DUF5445', NULL, NULL, 12738, 9),
(265421, NULL, 'PF08089', NULL, NULL, 'Huwentoxin-II family', NULL, 'Toxin_20', NULL, NULL, 9700, 9),
(265422, NULL, 'PF17279', NULL, NULL, 'Family of unknown function (DUF5344)', NULL, 'DUF5344', NULL, NULL, 37727, 9),
(265423, NULL, 'PF08068', NULL, NULL, 'DKCLD (NUC011) domain', NULL, 'DKCLD', NULL, NULL, 11732, 9),
(265424, NULL, 'PF18458', NULL, NULL, 'Xeroderma pigmentosum group B helicase damage recognition domain', NULL, 'XPB_DRD', NULL, NULL, 27867, 9),
(265425, NULL, 'PF01677', NULL, NULL, 'Herpesvirus UL7 like', NULL, 'Herpes_UL7', NULL, NULL, 1574, 9),
(265426, NULL, 'PF20126', NULL, NULL, 'Family of unknown function (DUF6516)', NULL, 'DUF6516', NULL, NULL, 35929, 9),
(265427, NULL, 'PF17179', NULL, NULL, '4Fe-4S dicluster domain', NULL, 'Fer4_22', NULL, NULL, 12567, 9),
(265428, NULL, 'PF05326', NULL, NULL, 'Seminal vesicle autoantigen (SVA)', NULL, 'SVA', NULL, NULL, 4216, 9),
(265429, NULL, 'PF06230', NULL, NULL, 'LpxI C-terminal domain', NULL, 'LpxI_C', NULL, NULL, 9426, 9),
(265430, NULL, 'PF12093', NULL, NULL, 'Betacoronavirus NS8 protein', NULL, 'bCoV_NS8', NULL, NULL, 14932, 9),
(265431, NULL, 'PF13045', NULL, NULL, 'Protein of unknown function (DUF3905)', NULL, 'DUF3905', NULL, NULL, 22757, 9),
(265432, NULL, 'PF18989', NULL, NULL, 'Family of unknown function (DUF5722)', NULL, 'DUF5722', NULL, NULL, 34215, 9),
(265433, NULL, 'PF04418', NULL, NULL, 'Domain of unknown function (DUF543)', NULL, 'DUF543', NULL, NULL, 10510, 9),
(265434, NULL, 'PF11862', NULL, NULL, 'Domain of unknown function (DUF3382)', NULL, 'DUF3382', NULL, NULL, 19185, 9),
(265435, NULL, 'PF16064', NULL, NULL, 'Domain of unknown function (DUF4806)', NULL, 'DUF4806', NULL, NULL, 24014, 9),
(265436, NULL, 'PF20411', NULL, NULL, 'Domain of unknown function (DUF6697)', NULL, 'DUF6697', NULL, NULL, 37625, 9),
(265437, NULL, 'PF03530', NULL, NULL, 'Calcium-activated SK potassium channel', NULL, 'SK_channel', NULL, NULL, 8648, 9),
(265438, NULL, 'PF13912', NULL, NULL, 'C2H2-type zinc finger', NULL, 'zf-C2H2_6', NULL, NULL, NULL, 9),
(265439, NULL, 'PF12020', NULL, NULL, 'TAFA family', NULL, 'TAFA', NULL, NULL, 14637, 9),
(265440, NULL, 'PF06851', NULL, NULL, 'Protein of unknown function (DUF1247)', NULL, 'DUF1247', NULL, NULL, 11420, 9),
(265441, NULL, 'PF13531', NULL, NULL, 'Bacterial extracellular solute-binding protein', NULL, 'SBP_bac_11', NULL, NULL, NULL, 9),
(265442, NULL, 'PF16985', NULL, NULL, 'Domain of unknown function (DUF5086)', NULL, 'DUF5086', NULL, NULL, 24250, 9),
(265443, NULL, 'PF09354', NULL, NULL, 'HNF3 C-terminal domain', NULL, 'HNF_C', NULL, NULL, 14707, 9),
(265444, NULL, 'PF04360', NULL, NULL, 'Serglycin', NULL, 'Serglycin', NULL, NULL, 4880, 9),
(265445, NULL, 'PF00973', NULL, NULL, 'Paramyxovirus nucleocapsid protein', NULL, 'Paramyxo_ncap', NULL, NULL, 4529, 9),
(265446, NULL, 'PF08350', NULL, NULL, 'Methanogenesis regulatory protein FilR1, middle domain', NULL, 'FilR1_middle', NULL, NULL, 12642, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(265447, NULL, 'PF12924', NULL, NULL, 'Copper-binding of amyloid precursor, CuBD', NULL, 'APP_Cu_bd', NULL, NULL, 13405, 9),
(265448, NULL, 'PF19154', NULL, NULL, 'Family of unknown function (DUF5836)', NULL, 'DUF5836', NULL, NULL, 34713, 9),
(265449, NULL, 'PF00759', NULL, NULL, 'Glycosyl hydrolase family 9', NULL, 'Glyco_hydro_9', NULL, NULL, 3383, 9),
(265450, NULL, 'PF05639', NULL, NULL, 'Pup-like protein', NULL, 'Pup', NULL, NULL, 12747, 9),
(265451, NULL, 'PF19367', NULL, NULL, 'Domain of unknown function (DUF5943)', NULL, 'DUF5943', NULL, NULL, 36735, 9),
(265452, NULL, 'PF19670', NULL, NULL, 'Family of unknown function (DUF6173)', NULL, 'DUF6173', NULL, NULL, 37320, 9),
(265453, NULL, 'PF13781', NULL, NULL, 'DoxX-like family', NULL, 'DoxX_3', NULL, NULL, 24621, 9),
(265454, NULL, 'PF15882', NULL, NULL, 'Domain of unknown function (DUF4735)', NULL, 'DUF4735', NULL, NULL, 25902, 9),
(265455, NULL, 'PF01144', NULL, NULL, 'Coenzyme A transferase', NULL, 'CoA_trans', NULL, NULL, 2966, 9),
(265456, NULL, 'PF05367', NULL, NULL, 'Phage endonuclease I', NULL, 'Phage_endo_I', NULL, NULL, 5322, 9),
(265457, NULL, 'PF18149', NULL, NULL, 'N-terminal helicase PWI domain', NULL, 'Helicase_PWI', NULL, NULL, 28586, 9),
(265458, NULL, 'PF18912', NULL, NULL, 'Double zinc ribbon domain', NULL, 'DZR_2', NULL, NULL, 35905, 9),
(265459, NULL, 'PF14318', NULL, NULL, 'Mononegavirales mRNA-capping region V', NULL, 'Mononeg_mRNAcap', NULL, NULL, 26693, 9),
(265460, NULL, 'PF17924', NULL, NULL, 'Tetracyclin repressor-like, C-terminal domain', NULL, 'TetR_C_19', NULL, NULL, NULL, 9),
(265461, NULL, 'PF00591', NULL, NULL, 'Glycosyl transferase family, a/b domain', NULL, 'Glycos_transf_3', NULL, NULL, 4147, 9),
(265462, NULL, 'PF11327', NULL, NULL, 'Egh16-like virulence factor', NULL, 'Egh16-like', NULL, NULL, 18430, 9),
(265463, NULL, 'PF00309', NULL, NULL, 'Sigma-54 factor, Activator interacting domain (AID)', NULL, 'Sigma54_AID', NULL, NULL, 4668, 9),
(265464, NULL, 'PF06128', NULL, NULL, 'Shigella flexneri OspC protein', NULL, 'Shigella_OspC', NULL, NULL, 8643, 9),
(265465, NULL, 'PF15862', NULL, NULL, 'Coilin N-terminus', NULL, 'Coilin_N', NULL, NULL, 25768, 9),
(265466, NULL, 'PF03725', NULL, NULL, '3'' exoribonuclease family, domain 2', NULL, 'RNase_PH_C', NULL, NULL, 9401, 9),
(265467, NULL, 'PF16396', NULL, NULL, 'Domain of unknown function (DUF5005)', NULL, 'DUF5005', NULL, NULL, 26456, 9),
(265468, NULL, 'PF17153', NULL, NULL, 'Periplasmic sensor domain, extracellular', NULL, 'CHASE9', NULL, NULL, 30816, 9),
(265469, NULL, 'PF17551', NULL, NULL, 'Family of unknown function (DUF5463)', NULL, 'DUF5463', NULL, NULL, 32736, 9),
(265470, NULL, 'PF18134', NULL, NULL, 'Adenylyl/Guanylyl and SMODS C-terminal sensor domain', NULL, 'AGS_C', NULL, NULL, 27763, 9),
(265471, NULL, 'PF14231', NULL, NULL, 'GXWXG protein', NULL, 'GXWXG', NULL, NULL, 21791, 9),
(265472, NULL, 'PF18260', NULL, NULL, 'Nuclear polyadenylated RNA-binding 2 protein CCCH zinc finger 1', NULL, 'Nab2p_Zf1', NULL, NULL, 29572, 9),
(265473, NULL, 'PF18343', NULL, NULL, 'Dda helicase SH3 domain', NULL, 'SH3_14', NULL, NULL, 28858, 9),
(265474, NULL, 'PF10600', NULL, NULL, 'PDZ-associated domain of NMDA receptors', NULL, 'PDZ_assoc', NULL, NULL, 20499, 9),
(265475, NULL, 'PF00894', NULL, NULL, 'Luteovirus coat protein', NULL, 'Luteo_coat', NULL, NULL, 6114, 9),
(265476, NULL, 'PF17821', NULL, NULL, 'Family of unknown function (DUF5583)', NULL, 'DUF5583', NULL, NULL, 28325, 9),
(265477, NULL, 'PF15612', NULL, NULL, 'WSTF, HB1, Itc1p, MBD9 motif 1', NULL, 'WHIM1', NULL, NULL, 24675, 9),
(265478, NULL, 'PF16743', NULL, NULL, 'Periplasmic lysozyme inhibitor of I-type lysozyme', NULL, 'PliI', NULL, NULL, 22856, 9),
(265479, NULL, 'PF18346', NULL, NULL, 'Mind bomb SH3 repeat domain', NULL, 'SH3_15', NULL, NULL, 32188, 9),
(265480, NULL, 'PF15489', NULL, NULL, 'CST, telomere maintenance, complex subunit CTC1', NULL, 'CTC1', NULL, NULL, 25815, 9),
(265481, NULL, 'PF09447', NULL, NULL, 'Cnl2/NKP2 family protein', NULL, 'Cnl2_NKP2', NULL, NULL, 15187, 9);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(265482, NULL, 'PF05760', NULL, NULL, 'Immediate early response protein (IER)', NULL, 'IER', NULL, NULL, 12793, 9),
(265483, NULL, 'PF08102', NULL, NULL, 'Scorpion antimicrobial peptide', NULL, 'Antimicrobial_7', NULL, NULL, 12968, 9),
(265484, NULL, 'PF05100', NULL, NULL, 'Phage minor tail protein L', NULL, 'Phage_tail_L', NULL, NULL, 6201, 9),
(265485, NULL, 'PF18047', NULL, NULL, 'PatG Domain', NULL, 'PatG_D', NULL, NULL, 27666, 9),
(265486, NULL, 'PF07599', NULL, NULL, 'Protein of unknown function (DUF1563)', NULL, 'DUF1563', NULL, NULL, 13579, 9),
(265487, NULL, 'PF18985', NULL, NULL, 'Family of unknown function (DUF5718)', NULL, 'DUF5718', NULL, NULL, 35999, 9),
(265488, NULL, 'PF06834', NULL, NULL, 'TraU protein', NULL, 'TraU', NULL, NULL, 11255, 9),
(265489, NULL, 'PF02516', NULL, NULL, 'Oligosaccharyl transferase STT3 subunit', NULL, 'STT3', NULL, NULL, 1341, 9),
(265490, NULL, 'PF09597', NULL, NULL, 'IGR protein motif', NULL, 'IGR', NULL, NULL, 16922, 9),
(265491, NULL, 'PF11919', NULL, NULL, 'Domain of unknown function (DUF3437)', NULL, 'DUF3437', NULL, NULL, 19856, 9),
(265492, NULL, 'PF11801', NULL, NULL, 'Tom37 C-terminal domain', NULL, 'Tom37_C', NULL, NULL, 12603, 9),
(265493, NULL, 'PF06372', NULL, NULL, 'Gemin6 Sm-like domain', NULL, 'Gemin6', NULL, NULL, 34443, 9),
(265494, NULL, 'PF08229', NULL, NULL, 'ER membrane protein SH3', NULL, 'SHR3_chaperone', NULL, NULL, 13314, 9),
(265495, NULL, 'PF03336', NULL, NULL, 'Poxvirus C4/C10 protein', NULL, 'Pox_C4_C10', NULL, NULL, 914, 9),
(265496, NULL, 'PF05043', NULL, NULL, 'Mga helix-turn-helix domain', NULL, 'Mga', NULL, NULL, 1295, 9),
(265497, NULL, 'PF16167', NULL, NULL, 'Domain of unknown function (DUF4871)', NULL, 'DUF4871', NULL, NULL, 24206, 9),
(265498, NULL, 'PF17411', NULL, NULL, 'Type II site-specific deoxyribonuclease', NULL, 'SmaI', NULL, NULL, NULL, 9),
(265499, NULL, 'PF08331', NULL, NULL, 'Epoxyqueuosine reductase QueG, DUF1730', NULL, 'QueG_DUF1730', NULL, NULL, 12791, 9),
(265500, NULL, 'PF11980', NULL, NULL, 'C-terminal domain of neuropilin glycoprotein', NULL, 'DUF3481', NULL, NULL, 16479, 9),
(265501, NULL, 'PF01796', NULL, NULL, 'DUF35 OB-fold domain, acyl-CoA-associated', NULL, 'OB_aCoA_assoc', NULL, NULL, 5514, 9),
(265502, NULL, 'PF03649', NULL, NULL, 'Uncharacterised protein family (UPF0014)', NULL, 'UPF0014', NULL, NULL, 11253, 9),
(265503, NULL, 'PF16597', NULL, NULL, 'Thyroglobulin_1 repeat associated disordered domain', NULL, 'Thyroglob_assoc', NULL, NULL, NULL, 9),
(265504, NULL, 'PF20014', NULL, NULL, 'GTPase-associated protein 1, middle domain', NULL, 'GAP1-M', NULL, NULL, 35654, 9),
(265505, NULL, 'PF12019', NULL, NULL, 'Type II transport protein GspH', NULL, 'GspH', NULL, NULL, 21367, 9),
(265506, NULL, 'PF03867', NULL, NULL, 'Fushi tarazu (FTZ), N-terminal region', NULL, 'FTZ', NULL, NULL, 1708, 9),
(265507, NULL, 'PF01603', NULL, NULL, 'Protein phosphatase 2A regulatory B subunit (B56 family)', NULL, 'B56', NULL, NULL, 1650, 9),
(265508, NULL, 'PF15929', NULL, NULL, 'Myofilin', NULL, 'Myofilin', NULL, NULL, 25894, 9),
(265509, NULL, 'PF04426', NULL, NULL, 'Bul1 C terminus', NULL, 'Bul1_C', NULL, NULL, 17311, 9),
(265510, NULL, 'PF04287', NULL, NULL, 'tRNA pseudouridine synthase C', NULL, 'DUF446', NULL, NULL, 15859, 9),
(265511, NULL, 'PF07093', NULL, NULL, 'SGT1 protein', NULL, 'SGT1', NULL, NULL, 10735, 9),
(265512, NULL, 'PF00304', NULL, NULL, 'Gamma-thionin family', NULL, 'Gamma-thionin', NULL, NULL, NULL, 9),
(265513, NULL, 'PF02665', NULL, NULL, 'Nitrate reductase gamma subunit', NULL, 'Nitrate_red_gam', NULL, NULL, 8529, 9),
(265514, NULL, 'PF17808', NULL, NULL, 'Fn3-like domain from Purple Acid Phosphatase', NULL, 'fn3_PAP', NULL, NULL, 28022, 9),
(265515, NULL, 'PF18823', NULL, NULL, 'Inorganic Pyrophosphatase', NULL, 'InPase', NULL, NULL, 30977, 9),
(265516, NULL, 'PF08148', NULL, NULL, 'DSHCT (NUC185) domain', NULL, 'DSHCT', NULL, NULL, 11724, 9),
(265517, NULL, 'PF00569', NULL, NULL, 'Zinc finger, ZZ type', NULL, 'ZZ', NULL, NULL, 4349, 9),
(265518, NULL, 'PF08527', NULL, NULL, 'Protein-arginine deiminase (PAD) middle domain', NULL, 'PAD_M', NULL, NULL, 7956, 9); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(265519, NULL, 'PF01358', NULL, NULL, 'Poly A polymerase regulatory subunit', NULL, 'PARP_regulatory', NULL, NULL, 1732, 9),
(265520, NULL, 'PF07923', NULL, NULL, 'N1221-like protein', NULL, 'N1221', NULL, NULL, 11739, 9),
(265521, NULL, 'PF13244', NULL, NULL, 'MBH, subunit D', NULL, 'MbhD', NULL, NULL, 22014, 9),
(265522, NULL, 'PF15935', NULL, NULL, 'RNase LS, bacterial toxin', NULL, 'RnlA_toxin', NULL, NULL, 25553, 9),
(265523, NULL, 'PF20288', NULL, NULL, 'ABC-three component (ABC-3C) system Middle Component 2', NULL, 'MC2', NULL, NULL, 34228, 9),
(265524, NULL, 'PF01914', NULL, NULL, 'MarC family integral membrane protein', NULL, 'MarC', NULL, NULL, 4895, 9),
(265525, NULL, 'PF11809', NULL, NULL, 'Domain of unknown function (DUF3330)', NULL, 'DUF3330', NULL, NULL, 19388, 9),
(265526, NULL, 'PF02583', NULL, NULL, 'Metal-sensitive transcriptional repressor', NULL, 'Trns_repr_metal', NULL, NULL, 2043, 9),
(265527, NULL, 'PF06321', NULL, NULL, 'Major fimbrial subunit protein (FimA)', NULL, 'P_gingi_FimA', NULL, NULL, 23780, 9),
(265528, NULL, 'PF05586', NULL, NULL, 'Anthrax receptor C-terminus region', NULL, 'Ant_C', NULL, NULL, 7659, 9),
(265529, NULL, 'PF12804', NULL, NULL, 'MobA-like NTP transferase domain', NULL, 'NTP_transf_3', NULL, NULL, 25598, 9),
(265530, NULL, 'PF12930', NULL, NULL, 'Family of unknown function (DUF3836)', NULL, 'DUF3836', NULL, NULL, 24507, 9),
(265531, NULL, 'PF08941', NULL, NULL, 'USP8 interacting', NULL, 'USP8_interact', NULL, NULL, 7676, 9),
(265532, NULL, 'PF05151', NULL, NULL, 'Photosystem II reaction centre M protein (PsbM)', NULL, 'PsbM', NULL, NULL, 2262, 9),
(265533, NULL, 'PF10396', NULL, NULL, 'GTP-binding protein TrmE N-terminus', NULL, 'TrmE_N', NULL, NULL, 14705, 9),
(265534, NULL, 'PF18252', NULL, NULL, 'Copper(I)-binding protein CorA', NULL, 'Cu_bind_CorA', NULL, NULL, 29163, 9),
(265535, NULL, 'PF06057', NULL, NULL, 'Bacterial virulence protein (VirJ)', NULL, 'VirJ', NULL, NULL, 8636, 9),
(265536, NULL, 'PF04613', NULL, NULL, 'UDP-3-O-[3-hydroxymyristoyl] glucosamine N-acyltransferase, LpxD', NULL, 'LpxD', NULL, NULL, 19922, 9),
(265537, NULL, 'PF05129', NULL, NULL, 'Transcription elongation factor Elf1 like', NULL, 'Elf1', NULL, NULL, 2340, 9),
(265538, NULL, 'PF11278', NULL, NULL, 'Protein of unknown function (DUF3079)', NULL, 'DUF3079', NULL, NULL, 18112, 9),
(265539, NULL, 'PF12466', NULL, NULL, 'Glutamate dehydrogenase N terminal', NULL, 'GDH_N', NULL, NULL, 25519, 9),
(265540, NULL, 'PF01878', NULL, NULL, 'EVE domain', NULL, 'EVE', NULL, NULL, 3854, 9),
(265541, NULL, 'PF01248', NULL, NULL, 'Ribosomal protein L7Ae/L30e/S12e/Gadd45 family', NULL, 'Ribosomal_L7Ae', NULL, NULL, 907, 9),
(265542, NULL, 'PF18662', NULL, NULL, 'Cch helix turn helix domain', NULL, 'HTH_56', NULL, NULL, 27941, 9),
(265543, NULL, 'PF06400', NULL, NULL, 'Alpha-2-macroglobulin RAP, N-terminal domain', NULL, 'Alpha-2-MRAP_N', NULL, NULL, 6488, 9),
(265544, NULL, 'PF15936', NULL, NULL, 'Domain of unknown function (DUF4749)', NULL, 'DUF4749', NULL, NULL, 25799, 9),
(265545, NULL, 'PF07631', NULL, NULL, 'Protein of unknown function (DUF1592)', NULL, 'PSD4', NULL, NULL, 10186, 9),
(265546, NULL, 'PF16538', NULL, NULL, 'Flagellar assembly protein T, C-terminal domain', NULL, 'FlgT_C', NULL, NULL, 25495, 9),
(265547, NULL, 'PF04962', NULL, NULL, 'KduI/IolB family', NULL, 'KduI', NULL, NULL, 18895, 9),
(265548, NULL, 'PF07618', NULL, NULL, 'Protein of unknown function (DUF1580)', NULL, 'DUF1580', NULL, NULL, 13872, 9),
(265549, NULL, 'PF01316', NULL, NULL, 'Arginine repressor, DNA binding domain', NULL, 'Arg_repressor', NULL, NULL, 20773, 9),
(265550, NULL, 'PF13439', NULL, NULL, 'Glycosyltransferase Family 4', NULL, 'Glyco_transf_4', NULL, NULL, 24508, 9),
(265551, NULL, 'PF18070', NULL, NULL, 'CRISPR-Cas9 PI domain', NULL, 'Cas9_PI2', NULL, NULL, 27016, 9),
(265552, NULL, 'PF11299', NULL, NULL, 'Protein of unknown function (DUF3100)', NULL, 'DUF3100', NULL, NULL, 18300, 9),
(265553, NULL, 'PF05240', NULL, NULL, 'APOBEC-like C-terminal domain', NULL, 'APOBEC_C', NULL, NULL, NULL, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(265554, NULL, 'PF17313', NULL, NULL, 'Family of unknown function (DUF5359)', NULL, 'DUF5359', NULL, NULL, 31974, 9),
(265555, NULL, 'PF00286', NULL, NULL, 'Viral coat protein', NULL, 'Flexi_CP', NULL, NULL, 2879, 9),
(265556, NULL, 'PF07576', NULL, NULL, 'BRCA1-associated protein 2', NULL, 'BRAP2', NULL, NULL, 13538, 9),
(265557, NULL, 'PF16942', NULL, NULL, 'Putative cyclic bacteriocin', NULL, 'CclA_1', NULL, NULL, 25962, 9),
(265558, NULL, 'PF15512', NULL, NULL, 'Chromatin assembly factor complex 1 subunit p60, C-terminal', NULL, 'CAF-1_p60_C', NULL, NULL, 23774, 9),
(265559, NULL, 'PF04216', NULL, NULL, 'Protein involved in formate dehydrogenase formation', NULL, 'FdhE', NULL, NULL, 6997, 9),
(265560, NULL, 'PF02899', NULL, NULL, 'Phage integrase, N-terminal SAM-like domain', NULL, 'Phage_int_SAM_1', NULL, NULL, 1799, 9),
(265561, NULL, 'PF18558', NULL, NULL, 'Helix-turn-helix domain', NULL, 'HTH_51', NULL, NULL, 28917, 9),
(265562, NULL, 'PF10214', NULL, NULL, 'RNA polymerase I-specific transcription-initiation factor', NULL, 'Rrn6', NULL, NULL, 15916, 9),
(265563, NULL, 'PF12491', NULL, NULL, 'Apolipoprotein B100 C terminal', NULL, 'ApoB100_C', NULL, NULL, 21023, 9),
(265564, NULL, 'PF01150', NULL, NULL, 'GDA1/CD39 (nucleoside phosphatase) family', NULL, 'GDA1_CD39', NULL, NULL, 4996, 9),
(265565, NULL, 'PF14302', NULL, NULL, 'Domain of unknown function (DUF4377)', NULL, 'DUF4377', NULL, NULL, 26465, 9),
(265566, NULL, 'PF18081', NULL, NULL, 'Fanconi anemia-associated nuclease SAP domain', NULL, 'FANC_SAP', NULL, NULL, 27795, 9),
(265567, NULL, 'PF13729', NULL, NULL, 'F plasmid transfer operon, TraF, protein', NULL, 'TraF_2', NULL, NULL, 21732, 9),
(265568, NULL, 'PF15675', NULL, NULL, 'CLLAC-motif containing domain', NULL, 'CLLAC', NULL, NULL, 25740, 9),
(265569, NULL, 'PF20120', NULL, NULL, 'Family of unknown function (DUF6510)', NULL, 'DUF6510', NULL, NULL, 34969, 9),
(265570, NULL, 'PF13298', NULL, NULL, 'DNA polymerase Ligase (LigD)', NULL, 'LigD_N', NULL, NULL, 14439, 9),
(265571, NULL, 'PF16811', NULL, NULL, 'TRAP transporter T-component', NULL, 'TAtT', NULL, NULL, 22026, 9),
(265572, NULL, 'PF17673', NULL, NULL, 'Family of unknown function (DUF5532)', NULL, 'DUF5532', NULL, NULL, 27231, 9),
(265573, NULL, 'PF01207', NULL, NULL, 'Dihydrouridine synthase (Dus)', NULL, 'Dus', NULL, NULL, 29349, 9),
(265574, NULL, 'PF07270', NULL, NULL, 'Protein of unknown function (DUF1438)', NULL, 'DUF1438', NULL, NULL, 14492, 9),
(265575, NULL, 'PF03410', NULL, NULL, 'Metallopeptidase from vaccinia pox', NULL, 'Peptidase_M44', NULL, NULL, 10090, 9),
(265576, NULL, 'PF07273', NULL, NULL, 'Protein of unknown function (DUF1439)', NULL, 'DUF1439', NULL, NULL, 11504, 9),
(265577, NULL, 'PF13449', NULL, NULL, 'Esterase-like activity of phytase', NULL, 'Phytase-like', NULL, NULL, 24248, 9),
(265578, NULL, 'PF11909', NULL, NULL, 'NADH-quinone oxidoreductase cyanobacterial subunit N', NULL, 'NdhN', NULL, NULL, 21380, 9),
(265579, NULL, 'PF13200', NULL, NULL, 'Putative glycosyl hydrolase domain', NULL, 'DUF4015', NULL, NULL, 23085, 9),
(265580, NULL, 'PF07507', NULL, NULL, 'WavE lipopolysaccharide synthesis', NULL, 'WavE', NULL, NULL, 11080, 9),
(265581, NULL, 'PF16160', NULL, NULL, 'Domain of unknown function (DUF4866)', NULL, 'DUF4866', NULL, NULL, 22678, 9),
(265582, NULL, 'PF19983', NULL, NULL, 'Family of unknown function (DUF6419)', NULL, 'DUF6419', NULL, NULL, 37644, 9),
(265583, NULL, 'PF00842', NULL, NULL, 'Alanine racemase, C-terminal domain', NULL, 'Ala_racemase_C', NULL, NULL, 10319, 9),
(265584, NULL, 'PF10099', NULL, NULL, 'Anti-sigma-K factor rskA', NULL, 'RskA', NULL, NULL, 18473, 9),
(265585, NULL, 'PF19312', NULL, NULL, 'NtrY N-terminal region', NULL, 'NtrY_N', NULL, NULL, 33942, 9),
(265586, NULL, 'PF03508', NULL, NULL, 'Gap junction alpha-1 protein (Cx43)', NULL, 'Connexin43', NULL, NULL, 18706, 9),
(265587, NULL, 'PF03670', NULL, NULL, 'Uncharacterised protein family (UPF0184)', NULL, 'UPF0184', NULL, NULL, NULL, 9),
(265588, NULL, 'PF04122', NULL, NULL, 'ell wall binding domain 2 (CWB2)', NULL, 'CW_binding_2', NULL, NULL, 6578, 9);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(265589, NULL, 'PF17835', NULL, NULL, 'NOG1 N-terminal helical domain', NULL, 'NOG1_N', NULL, NULL, 29570, 9),
(265590, NULL, 'PF02089', NULL, NULL, 'Palmitoyl protein thioesterase', NULL, 'Palm_thioest', NULL, NULL, NULL, 9),
(265591, NULL, 'PF10100', NULL, NULL, 'Staphylopine dehydrogenase', NULL, 'Staph_opine_DH', NULL, NULL, 17870, 9),
(265592, NULL, 'PF06085', NULL, NULL, 'Lipoprotein Rz1 precursor', NULL, 'Rz1', NULL, NULL, 8746, 9),
(265593, NULL, 'PF01804', NULL, NULL, 'Penicillin amidase', NULL, 'Penicil_amidase', NULL, NULL, 3777, 9),
(265594, NULL, 'PF13618', NULL, NULL, 'Gluconate 2-dehydrogenase subunit 3', NULL, 'Gluconate_2-dh3', NULL, NULL, 24909, 9),
(265595, NULL, 'PF17930', NULL, NULL, 'LpxI N-terminal domain', NULL, 'LpxI_N', NULL, NULL, 29677, 9),
(265596, NULL, 'PF02276', NULL, NULL, 'Photosynthetic reaction centre cytochrome C subunit', NULL, 'CytoC_RC', NULL, NULL, 3356, 9),
(265597, NULL, 'PF17761', NULL, NULL, 'DUF1016 N-terminal domain', NULL, 'DUF1016_N', NULL, NULL, 29751, 9),
(265598, NULL, 'PF08325', NULL, NULL, 'WLM domain', NULL, 'WLM', NULL, NULL, 12593, 9),
(265599, NULL, 'PF13275', NULL, NULL, 'S4 domain', NULL, 'S4_2', NULL, NULL, NULL, 9),
(265600, NULL, 'PF17378', NULL, NULL, 'Meiotic recombination protein REC104', NULL, 'REC104', NULL, NULL, 30628, 9),
(265601, NULL, 'PF19208', NULL, NULL, 'Family of unknown function (DUF5880)', NULL, 'DUF5880', NULL, NULL, 35217, 9),
(265602, NULL, 'PF00137', NULL, NULL, 'ATP synthase subunit C', NULL, 'ATP-synt_C', NULL, NULL, 6634, 9),
(265603, NULL, 'PF06969', NULL, NULL, 'HemN C-terminal domain', NULL, 'HemN_C', NULL, NULL, 9629, 9),
(265604, NULL, 'PF07748', NULL, NULL, 'Glycosyl hydrolases family 38 C-terminal domain', NULL, 'Glyco_hydro_38C', NULL, NULL, 10777, 9),
(265605, NULL, 'PF08448', NULL, NULL, 'PAS fold', NULL, 'PAS_4', NULL, NULL, 11530, 9),
(265606, NULL, 'PF18298', NULL, NULL, 'NusG additional domain', NULL, 'NusG_add', NULL, NULL, 27948, 9),
(265607, NULL, 'PF02018', NULL, NULL, 'Carbohydrate binding domain', NULL, 'CBM_4_9', NULL, NULL, 3743, 9),
(265608, NULL, 'PF03116', NULL, NULL, 'NQR2, RnfD, RnfE family', NULL, 'NQR2_RnfD_RnfE', NULL, NULL, 4511, 9),
(265609, NULL, 'PF02585', NULL, NULL, 'GlcNAc-PI de-N-acetylase', NULL, 'PIG-L', NULL, NULL, 6108, 9),
(265610, NULL, 'PF18421', NULL, NULL, 'Peptidase family M23 N-terminal domain', NULL, 'Peptidase_M23_N', NULL, NULL, 27567, 9),
(265611, NULL, 'PF03511', NULL, NULL, 'Fanconi anaemia group A protein', NULL, 'Fanconi_A', NULL, NULL, 6195, 9),
(265612, NULL, 'PF04299', NULL, NULL, 'Putative FMN-binding domain', NULL, 'FMN_bind_2', NULL, NULL, 3680, 9),
(265613, NULL, 'PF14864', NULL, NULL, 'Alkyl sulfatase C-terminal', NULL, 'Alkyl_sulf_C', NULL, NULL, 26790, 9),
(265614, NULL, 'PF17550', NULL, NULL, 'Family of unknown function', NULL, 'PsaF', NULL, NULL, 32551, 9),
(265615, NULL, 'PF17616', NULL, NULL, 'Viral unique short region 6', NULL, 'US6', NULL, NULL, 28150, 9),
(265616, NULL, 'PF18360', NULL, NULL, 'Heterogeneous nuclear ribonucleoprotein Q acidic domain', NULL, 'hnRNP_Q_AcD', NULL, NULL, 29627, 9),
(265617, NULL, 'PF05280', NULL, NULL, 'Flagellar transcriptional activator (FlhC)', NULL, 'FlhC', NULL, NULL, 4127, 9),
(265618, NULL, 'PF00816', NULL, NULL, 'H-NS histone family', NULL, 'Histone_HNS', NULL, NULL, 4251, 9),
(265619, NULL, 'PF06141', NULL, NULL, 'Phage minor tail protein U', NULL, 'Phage_tail_U', NULL, NULL, 14312, 9),
(265620, NULL, 'PF06789', NULL, NULL, 'MINAR1 C-terminal domain', NULL, 'MINAR1_C', NULL, NULL, 1846, 9),
(265621, NULL, 'PF16182', NULL, NULL, 'Putative adherens-junction anchoring region of AbLIM', NULL, 'AbLIM_anchor', NULL, NULL, 21803, 9),
(265622, NULL, 'PF00139', NULL, NULL, 'Legume lectin domain', NULL, 'Lectin_legB', NULL, NULL, 2265, 9),
(265623, NULL, 'PF00393', NULL, NULL, '6-phosphogluconate dehydrogenase, C-terminal domain', NULL, '6PGD', NULL, NULL, 10322, 9),
(265624, NULL, 'PF02428', NULL, NULL, 'Potato type II proteinase inhibitor family', NULL, 'Prot_inhib_II', NULL, NULL, 6486, 9),
(265625, NULL, 'PF10165', NULL, NULL, 'Guanine nucleotide exchange factor synembryn', NULL, 'Ric8', NULL, NULL, 14630, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(265626, NULL, 'PF04246', NULL, NULL, 'Positive regulator of sigma(E), RseC/MucC', NULL, 'RseC_MucC', NULL, NULL, NULL, 9),
(265627, NULL, 'PF08143', NULL, NULL, 'CBFNT (NUC161) domain', NULL, 'CBFNT', NULL, NULL, 11783, 9),
(265628, NULL, 'PF15604', NULL, NULL, 'Novel toxin 15', NULL, 'Ntox15', NULL, NULL, 24853, 9),
(265629, NULL, 'PF11050', NULL, NULL, 'Virus envelope protein E26', NULL, 'Viral_env_E26', NULL, NULL, 17595, 9),
(265630, NULL, 'PF15511', NULL, NULL, 'Centromere kinetochore component CENP-T histone fold', NULL, 'CENP-T_C', NULL, NULL, 31037, 9),
(265631, NULL, 'PF08090', NULL, NULL, 'Heat stable E.coli enterotoxin 1', NULL, 'Enterotoxin_HS1', NULL, NULL, 9357, 9),
(265632, NULL, 'PF14743', NULL, NULL, 'DNA ligase OB-like domain', NULL, 'DNA_ligase_OB_2', NULL, NULL, 26637, 9),
(265633, NULL, 'PF09285', NULL, NULL, 'Elongation factor P, C-terminal', NULL, 'Elong-fact-P_C', NULL, NULL, 13812, 9),
(265634, NULL, 'PF13769', NULL, NULL, 'Virulence factor', NULL, 'Virulence_fact', NULL, NULL, 25658, 9),
(265635, NULL, 'PF05684', NULL, NULL, 'Protein of unknown function (DUF819)', NULL, 'DUF819', NULL, NULL, 13257, 9),
(265636, NULL, 'PF17611', NULL, NULL, 'Family of unknown function (DUF5506)', NULL, 'DUF5506', NULL, NULL, 19195, 9),
(265637, NULL, 'PF19351', NULL, NULL, 'Domain of unknown function (DUF5929)', NULL, 'DUF5929', NULL, NULL, 36818, 9),
(265638, NULL, 'PF06471', NULL, NULL, 'Coronavirus proofreading exoribonuclease', NULL, 'CoV_ExoN', NULL, NULL, 9308, 9),
(265639, NULL, 'PF00047', NULL, NULL, 'Immunoglobulin domain', NULL, 'ig', NULL, NULL, 8346, 9),
(265640, NULL, 'PF11186', NULL, NULL, 'Protein of unknown function (DUF2972)', NULL, 'DUF2972', NULL, NULL, 18122, 9),
(265641, NULL, 'PF20512', NULL, NULL, 'Phosphomannose isomerase type I, helical insertion domain', NULL, 'PMI_typeI_hel', NULL, NULL, 35459, 9),
(265642, NULL, 'PF07413', NULL, NULL, 'Betaherpesvirus immediate-early glycoprotein UL37', NULL, 'Herpes_UL37_2', NULL, NULL, 11823, 9),
(265643, NULL, 'PF13864', NULL, NULL, 'Calmodulin-binding', NULL, 'Enkurin', NULL, NULL, 24091, 9),
(265644, NULL, 'PF06007', NULL, NULL, 'Phosphonate metabolism protein PhnJ', NULL, 'PhnJ', NULL, NULL, 8263, 9),
(265645, NULL, 'PF16141', NULL, NULL, 'Putative glycoside hydrolase Family 18, chitinase_18', NULL, 'DUF4849', NULL, NULL, 22864, 9),
(265646, NULL, 'PF10032', NULL, NULL, 'Phosphate transport (Pho88)', NULL, 'Pho88', NULL, NULL, 12529, 9),
(265647, NULL, 'PF04282', NULL, NULL, 'Family of unknown function (DUF438)', NULL, 'DUF438', NULL, NULL, 5936, 9),
(265648, NULL, 'PF05136', NULL, NULL, 'Phage portal protein, lambda family', NULL, 'Phage_portal_2', NULL, NULL, 6793, 9),
(265649, NULL, 'PF04082', NULL, NULL, 'Fungal specific transcription factor domain', NULL, 'Fungal_trans', NULL, NULL, 6212, 9),
(265650, NULL, 'PF20596', NULL, NULL, 'Putative adhesive domain (group 11)', NULL, 'pAdhesive_11', NULL, NULL, 33990, 9),
(265651, NULL, 'PF02336', NULL, NULL, 'Capsid protein VP4', NULL, 'Denso_VP4', NULL, NULL, 5022, 9),
(265652, NULL, 'PF09408', NULL, NULL, 'Betacoronavirus spike glycoprotein S1, receptor binding', NULL, 'bCoV_S1_RBD', NULL, NULL, 15297, 9),
(265653, NULL, 'PF16971', NULL, NULL, 'Rough colony protein B, tight adherence - tad - subunit', NULL, 'RcpB', NULL, NULL, 22198, 9),
(265654, NULL, 'PF17522', NULL, NULL, 'Family of unknown function (DUF5446)', NULL, 'DUF5446', NULL, NULL, 19188, 9),
(265655, NULL, 'PF07372', NULL, NULL, 'Protein of unknown function (DUF1491)', NULL, 'DUF1491', NULL, NULL, 8415, 9),
(265656, NULL, 'PF05821', NULL, NULL, 'NADH-ubiquinone oxidoreductase ASHI subunit (CI-ASHI or NDUFB8)', NULL, 'NDUF_B8', NULL, NULL, 13479, 9),
(265657, NULL, 'PF07832', NULL, NULL, 'Cfr10I/Bse634I restriction endonuclease', NULL, 'Bse634I', NULL, NULL, 13081, 9),
(265658, NULL, 'PF17525', NULL, NULL, 'Family of unknown function (DUF5447)', NULL, 'DUF5447', NULL, NULL, 28202, 9),
(265659, NULL, 'PF04734', NULL, NULL, 'Neutral/alkaline non-lysosomal ceramidase, N-terminal', NULL, 'Ceramidase_alk', NULL, NULL, 24143, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(265660, NULL, 'PF05009', NULL, NULL, 'Epstein-Barr virus nuclear antigen 3 (EBNA-3)', NULL, 'EBV-NA3', NULL, NULL, 1143, 9),
(265661, NULL, 'PF19872', NULL, NULL, 'Family of unknown function (DUF6345)', NULL, 'DUF6345', NULL, NULL, 36655, 9),
(265662, NULL, 'PF05089', NULL, NULL, 'Alpha-N-acetylglucosaminidase (NAGLU) tim-barrel domain', NULL, 'NAGLU', NULL, NULL, 26444, 9),
(265663, NULL, 'PF06148', NULL, NULL, 'COG (conserved oligomeric Golgi) complex component, COG2', NULL, 'COG2', NULL, NULL, 26961, 9),
(265664, NULL, 'PF10613', NULL, NULL, 'Ligated ion channel L-glutamate- and glycine-binding site', NULL, 'Lig_chan-Glu_bd', NULL, NULL, 20436, 9),
(265665, NULL, 'PF17312', NULL, NULL, 'Bacteriocin helveticin-J', NULL, 'Helveticin_J', NULL, NULL, 31828, 9),
(265666, NULL, 'PF09425', NULL, NULL, 'Jas motif', NULL, 'Jas_motif', NULL, NULL, 21309, 9),
(265667, NULL, 'PF14233', NULL, NULL, 'Domain of unknown function (DUF4335)', NULL, 'DUF4335', NULL, NULL, 23285, 9),
(265668, NULL, 'PF00805', NULL, NULL, 'Pentapeptide repeats (8 copies)', NULL, 'Pentapeptide', NULL, NULL, 5366, 9),
(265669, NULL, 'PF01193', NULL, NULL, 'RNA polymerase Rpb3/Rpb11 dimerisation domain', NULL, 'RNA_pol_L', NULL, NULL, 9816, 9),
(265670, NULL, 'PF04166', NULL, NULL, 'Pyridoxal phosphate biosynthetic protein PdxA', NULL, 'PdxA', NULL, NULL, 11328, 9),
(265671, NULL, 'PF16824', NULL, NULL, 'C-terminal carbohydrate-binding module', NULL, 'CBM_26', NULL, NULL, 25754, 9),
(265672, NULL, 'PF05313', NULL, NULL, 'Poxvirus P21 membrane protein', NULL, 'Pox_P21', NULL, NULL, 4362, 9),
(265673, NULL, 'PF19667', NULL, NULL, 'Family of unknown function (DUF6170)', NULL, 'DUF6170', NULL, NULL, 37486, 9),
(265674, NULL, 'PF17695', NULL, NULL, 'Family of unknown function (DUF5541)', NULL, 'DUF5541', NULL, NULL, 29249, 9),
(265675, NULL, 'PF17918', NULL, NULL, 'Tetracyclin repressor-like, C-terminal domain', NULL, 'TetR_C_15', NULL, NULL, 30244, 9),
(265676, NULL, 'PF06430', NULL, NULL, 'Lactococcus lactis RepB C-terminus', NULL, 'L_lactis_RepB_C', NULL, NULL, 7562, 9),
(265677, NULL, 'PF04626', NULL, NULL, 'Dec-1 protein, C terminal region', NULL, 'DEC-1_C', NULL, NULL, 2491, 9),
(265678, NULL, 'PF11058', NULL, NULL, 'Antirestriction protein Ral', NULL, 'Ral', NULL, NULL, 17390, 9),
(265679, NULL, 'PF14727', NULL, NULL, 'PTHB1 N-terminus', NULL, 'PHTB1_N', NULL, NULL, 23221, 9),
(265680, NULL, 'PF19740', NULL, NULL, 'Family of unknown function (DUF6229)', NULL, 'DUF6229', NULL, NULL, 37209, 9),
(265681, NULL, 'PF01177', NULL, NULL, 'Asp/Glu/Hydantoin racemase', NULL, 'Asp_Glu_race', NULL, NULL, 8429, 9),
(265682, NULL, 'PF14040', NULL, NULL, 'Deoxyribonuclease NucA/NucB', NULL, 'DNase_NucA_NucB', NULL, NULL, 26988, 9),
(265683, NULL, 'PF14278', NULL, NULL, 'Transcriptional regulator C-terminal region', NULL, 'TetR_C_8', NULL, NULL, 33031, 9),
(265684, NULL, 'PF01667', NULL, NULL, 'Ribosomal protein S27', NULL, 'Ribosomal_S27e', NULL, NULL, 5666, 9),
(265685, NULL, 'PF18903', NULL, NULL, 'Domain of unknown function (DUF5659)', NULL, 'DUF5659', NULL, NULL, 35678, 9),
(265686, NULL, 'PF15761', NULL, NULL, 'Immortalisation up-regulated protein', NULL, 'IMUP', NULL, NULL, 22071, 9),
(265687, NULL, 'PF05912', NULL, NULL, 'Caenorhabditis elegans protein of unknown function (DUF870)', NULL, 'DUF870', NULL, NULL, 14173, 9),
(265688, NULL, 'PF03026', NULL, NULL, 'Influenza C virus M1 protein', NULL, 'CM1', NULL, NULL, 3700, 9),
(265689, NULL, 'PF16492', NULL, NULL, 'Cadherin cytoplasmic C-terminal', NULL, 'Cadherin_C_2', NULL, NULL, 22871, 9),
(265690, NULL, 'PF13006', NULL, NULL, 'Insertion element 4 transposase N-terminal', NULL, 'Nterm_IS4', NULL, NULL, 22886, 9),
(265691, NULL, 'PF18678', NULL, NULL, 'Allene oxide cyclase barrel like domain', NULL, 'AOC_like', NULL, NULL, 29389, 9),
(265692, NULL, 'PF06159', NULL, NULL, 'Protein of unknown function (DUF974)', NULL, 'DUF974', NULL, NULL, 9007, 9),
(265693, NULL, 'PF14793', NULL, NULL, 'Pyrimidine/purine nucleotide 5''-monophosphate nucleosidases', NULL, 'DUF4478', NULL, NULL, 21617, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(265694, NULL, 'PF16317', NULL, NULL, 'Glycosyl hydrolase family 99', NULL, 'Glyco_hydro_99', NULL, NULL, 21625, 9),
(265695, NULL, 'PF09068', NULL, NULL, 'EF hand', NULL, 'EF-hand_2', NULL, NULL, 9798, 9),
(265696, NULL, 'PF04938', NULL, NULL, 'Survival motor neuron (SMN) interacting protein 1 (SIP1)', NULL, 'SIP1', NULL, NULL, 18036, 9),
(265697, NULL, 'PF06996', NULL, NULL, 'Type VI secretion, TssG', NULL, 'T6SS_TssG', NULL, NULL, 9807, 9),
(265698, NULL, 'PF12502', NULL, NULL, 'Protein of unknown function (DUF3710)', NULL, 'DUF3710', NULL, NULL, 21310, 9),
(265699, NULL, 'PF16238', NULL, NULL, 'Domain of unknown function (DUF4897)', NULL, 'DUF4897', NULL, NULL, 24180, 9),
(265700, NULL, 'PF18689', NULL, NULL, 'Primase X', NULL, 'PriX', NULL, NULL, 32881, 9),
(265701, NULL, 'PF08236', NULL, NULL, 'SRI (Set2 Rpb1 interacting) domain', NULL, 'SRI', NULL, NULL, 13340, 9),
(265702, NULL, 'PF19026', NULL, NULL, 'HYPK UBA domain', NULL, 'HYPK_UBA', NULL, NULL, 35851, 9),
(265703, NULL, 'PF10879', NULL, NULL, 'Protein of unknown function (DUF2674)', NULL, 'DUF2674', NULL, NULL, 20321, 9),
(265704, NULL, 'PF06553', NULL, NULL, 'BNIP3', NULL, 'BNIP3', NULL, NULL, 14177, 9),
(265705, NULL, 'PF13804', NULL, NULL, 'Retro-transcribing viruses envelope glycoprotein', NULL, 'HERV-K_env_2', NULL, NULL, 24559, 9),
(265706, NULL, 'PF09220', NULL, NULL, 'L-A virus, major coat protein', NULL, 'LA-virus_coat', NULL, NULL, 13237, 9),
(265707, NULL, 'PF17898', NULL, NULL, 'Spore germination GerD central core domain', NULL, 'GerD', NULL, NULL, 29035, 9),
(265708, NULL, 'PF17932', NULL, NULL, 'Tetracyclin repressor-like, C-terminal domain', NULL, 'TetR_C_24', NULL, NULL, 29336, 9),
(265709, NULL, 'PF16318', NULL, NULL, 'Domain of unknown function (DUF4957)', NULL, 'DUF4957', NULL, NULL, 25143, 9),
(265710, NULL, 'PF19340', NULL, NULL, 'Gamma-tubulin complex component 6 N-terminus', NULL, 'GCP6_N', NULL, NULL, 36282, 9),
(265711, NULL, 'PF17896', NULL, NULL, 'Non-structural protein 2, gammacoronavirus', NULL, 'NSP2_gammaCoV', NULL, NULL, 29214, 9),
(265712, NULL, 'PF15478', NULL, NULL, 'Family of unknown function with LKAAEAR motif', NULL, 'LKAAEAR', NULL, NULL, 25885, 9),
(265713, NULL, 'PF04225', NULL, NULL, 'Opacity-associated protein A LysM-like domain', NULL, 'OapA', NULL, NULL, 5530, 9),
(265714, NULL, 'PF05708', NULL, NULL, 'Permuted papain-like amidase enzyme, YaeF/YiiX, C92 family', NULL, 'Peptidase_C92', NULL, NULL, 21666, 9),
(265715, NULL, 'PF07724', NULL, NULL, 'AAA domain (Cdc48 subfamily)', NULL, 'AAA_2', NULL, NULL, 7026, 9),
(265716, NULL, 'PF11625', NULL, NULL, 'Protein of unknown function (DUF3253)', NULL, 'DUF3253', NULL, NULL, 18756, 9),
(265717, NULL, 'PF12373', NULL, NULL, 'Major surface glycoprotein 2 C terminal', NULL, 'Msg2_C', NULL, NULL, 15428, 9),
(265718, NULL, 'PF11140', NULL, NULL, 'Protein of unknown function (DUF2913)', NULL, 'DUF2913', NULL, NULL, 17902, 9),
(265719, NULL, 'PF17138', NULL, NULL, 'Domain of unknown function (DUF5111)', NULL, 'DUF5111', NULL, NULL, 30410, 9),
(265720, NULL, 'PF09116', NULL, NULL, 'gp45 sliding clamp, C terminal', NULL, 'gp45-slide_C', NULL, NULL, 10624, 9),
(265721, NULL, 'PF13108', NULL, NULL, 'Protein of unknown function (DUF3969)', NULL, 'DUF3969', NULL, NULL, 22962, 9),
(265722, NULL, 'PF07105', NULL, NULL, 'Protein of unknown function (DUF1367)', NULL, 'DUF1367', NULL, NULL, 13297, 9),
(265723, NULL, 'PF13004', NULL, NULL, 'Putative binding domain, N-terminal', NULL, 'BACON', NULL, NULL, 23915, 9),
(265724, NULL, 'PF03985', NULL, NULL, 'Paf1', NULL, 'Paf1', NULL, NULL, 290, 9),
(265725, NULL, 'PF05083', NULL, NULL, 'LST-1 protein', NULL, 'LST1', NULL, NULL, 1304, 9),
(265726, NULL, 'PF03820', NULL, NULL, 'Sideroflexins', NULL, 'SFXNs', NULL, NULL, 3167, 9),
(265727, NULL, 'PF00131', NULL, NULL, 'Metallothionein', NULL, 'Metallothio', NULL, NULL, 163, 9),
(265728, NULL, 'PF01265', NULL, NULL, 'Cytochrome c/c1 heme lyase', NULL, 'Cyto_heme_lyase', NULL, NULL, 6567, 9),
(265729, NULL, 'PF17685', NULL, NULL, 'Family of unknown function (DUF5533)', NULL, 'DUF5533', NULL, NULL, 28602, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(265730, NULL, 'PF04623', NULL, NULL, 'Adenovirus E1B protein N-terminus', NULL, 'Adeno_E1B_55K_N', NULL, NULL, 2307, 9),
(265731, NULL, 'PF19561', NULL, NULL, 'Family of unknown function (DUF6083)', NULL, 'DUF6083', NULL, NULL, 34319, 9),
(265732, NULL, 'PF01939', NULL, NULL, 'Endonuclease NucS', NULL, 'NucS', NULL, NULL, 4591, 9),
(265733, NULL, 'PF11716', NULL, NULL, 'Mycothiol maleylpyruvate isomerase N-terminal domain', NULL, 'MDMPI_N', NULL, NULL, 22302, 9),
(265734, NULL, 'PF14597', NULL, NULL, 'Metallo-beta-lactamase superfamily', NULL, 'Lactamase_B_5', NULL, NULL, NULL, 9),
(265735, NULL, 'PF18413', NULL, NULL, 'Neuraminidase-like domain', NULL, 'Neuraminidase', NULL, NULL, 28580, 9),
(265736, NULL, 'PF02733', NULL, NULL, 'Dak1 domain', NULL, 'Dak1', NULL, NULL, 750, 9),
(265737, NULL, 'PF13063', NULL, NULL, 'Protein of unknown function (DUF3925)', NULL, 'DUF3925', NULL, NULL, 21196, 9),
(265738, NULL, 'PF09323', NULL, NULL, 'Domain of unknown function (DUF1980)', NULL, 'DUF1980', NULL, NULL, 14075, 9),
(265739, NULL, 'PF13273', NULL, NULL, 'Protein of unknown function (DUF4064)', NULL, 'DUF4064', NULL, NULL, 25582, 9),
(265740, NULL, 'PF11159', NULL, NULL, 'Protein of unknown function (DUF2939)', NULL, 'DUF2939', NULL, NULL, 17957, 9),
(265741, NULL, 'PF09770', NULL, NULL, 'Topoisomerase II-associated protein PAT1', NULL, 'PAT1', NULL, NULL, 18148, 9),
(265742, NULL, 'PF20294', NULL, NULL, 'KTSC and Metallopeptidase N-terminal fusion domain', NULL, 'KMPT-N', NULL, NULL, 33551, 9),
(265743, NULL, 'PF19071', NULL, NULL, 'Family of unknown function (DUF5767)', NULL, 'DUF5767', NULL, NULL, 35808, 9),
(265744, NULL, 'PF18414', NULL, NULL, 'C2H2 type zinc-finger', NULL, 'zf_C2H2_10', NULL, NULL, NULL, 9),
(265745, NULL, 'PF10416', NULL, NULL, 'Transcription-initiator DNA-binding domain IBD', NULL, 'IBD', NULL, NULL, 20445, 9),
(265746, NULL, 'PF15805', NULL, NULL, 'Acidic C-terminal region of sodium channel modifier 1 SCNM1', NULL, 'SCNM1_acidic', NULL, NULL, 26197, 9),
(265747, NULL, 'PF02569', NULL, NULL, 'Pantoate-beta-alanine ligase', NULL, 'Pantoate_ligase', NULL, NULL, 2187, 9),
(265748, NULL, 'PF11666', NULL, NULL, 'Protein of unknown function (DUF2933)', NULL, 'DUF2933', NULL, NULL, 19120, 9),
(265749, NULL, 'PF11752', NULL, NULL, 'Protein of unknown function (DUF3309)', NULL, 'DUF3309', NULL, NULL, 19184, 9),
(265750, NULL, 'PF17004', NULL, NULL, 'Putative TPR-like repeat', NULL, 'SRP_TPR_like', NULL, NULL, 24282, 9),
(265751, NULL, 'PF07798', NULL, NULL, 'Coiled-coil domain-containing protein 90-like', NULL, 'CCDC90-like', NULL, NULL, 21965, 9),
(265752, NULL, 'PF16601', NULL, NULL, 'Rabosyn-5 repeating NPF sequence-motif', NULL, 'NPF', NULL, NULL, NULL, 9),
(265753, NULL, 'PF01761', NULL, NULL, '3-dehydroquinate synthase', NULL, 'DHQ_synthase', NULL, NULL, 24910, 9),
(265754, NULL, 'PF05891', NULL, NULL, 'AdoMet dependent proline di-methyltransferase', NULL, 'Methyltransf_PK', NULL, NULL, 13883, 9),
(265755, NULL, 'PF14255', NULL, NULL, 'Cysteine-rich CPXCG', NULL, 'Cys_rich_CPXG', NULL, NULL, 25675, 9),
(265756, NULL, 'PF08686', NULL, NULL, 'PLAC (protease and lacunin) domain', NULL, 'PLAC', NULL, NULL, 5477, 9),
(265757, NULL, 'PF08789', NULL, NULL, 'PBCV-specific basic adaptor domain', NULL, 'PBCV_basic_adap', NULL, NULL, 13449, 9),
(265758, NULL, 'PF06184', NULL, NULL, 'Potexvirus coat protein', NULL, 'Potex_coat', NULL, NULL, 9120, 9),
(265759, NULL, 'PF12246', NULL, NULL, 'Temperature dependent protein affecting M2 dsRNA replication', NULL, 'MKT1_C', NULL, NULL, 20046, 9),
(265760, NULL, 'PF15869', NULL, NULL, 'TolB-like 6-blade propeller-like', NULL, 'TolB_like', NULL, NULL, NULL, 9),
(265761, NULL, 'PF10298', NULL, NULL, 'WhiA N-terminal LAGLIDADG-like domain', NULL, 'WhiA_N', NULL, NULL, 21255, 9),
(265762, NULL, 'PF16924', NULL, NULL, 'Dipicolinate synthase subunit A N-terminal domain', NULL, 'DpaA_N', NULL, NULL, 25329, 9),
(265763, NULL, 'PF07326', NULL, NULL, 'Regulator of chromosome segregation 1', NULL, 'RCS1', NULL, NULL, 8091, 9),
(265764, NULL, 'PF05177', NULL, NULL, 'RCSD region', NULL, 'RCSD', NULL, NULL, 2428, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(265765, NULL, 'PF07982', NULL, NULL, 'Herpes UL74 glycoproteins', NULL, 'Herpes_UL74', NULL, NULL, 9399, 9),
(265766, NULL, 'PF16145', NULL, NULL, 'Domain of unknown function (DUF4853)', NULL, 'DUF4853', NULL, NULL, 22791, 9),
(265767, NULL, 'PF08961', NULL, NULL, 'Nuclear receptor-binding factor 2, autophagy regulator', NULL, 'NRBF2', NULL, NULL, 8749, 9),
(265768, NULL, 'PF09543', NULL, NULL, 'Protein of unknown function (DUF2379)', NULL, 'DUF2379', NULL, NULL, 11837, 9),
(265769, NULL, 'PF02182', NULL, NULL, 'SAD/SRA domain', NULL, 'SAD_SRA', NULL, NULL, 1260, 9),
(265770, NULL, 'PF15021', NULL, NULL, 'Protein of unknown function (DUF4521)', NULL, 'DUF4521', NULL, NULL, 22493, 9),
(265771, NULL, 'PF12115', NULL, NULL, 'Salivary protein of 15kDa inhibits CD4+ T cell activation', NULL, 'Salp15', NULL, NULL, 20185, 9),
(265772, NULL, 'PF01668', NULL, NULL, 'SmpB protein', NULL, 'SmpB', NULL, NULL, 2703, 9),
(265773, NULL, 'PF09384', NULL, NULL, 'UTP15 C terminal', NULL, 'UTP15_C', NULL, NULL, 15867, 9),
(265774, NULL, 'PF13032', NULL, NULL, 'RNaseH domain of pPIWI_RE', NULL, 'RNaseH_pPIWI_RE', NULL, NULL, 22563, 9),
(265775, NULL, 'PF19047', NULL, NULL, 'HOOK domain', NULL, 'HOOK_N', NULL, NULL, 35474, 9),
(265776, NULL, 'PF14351', NULL, NULL, 'Domain of unknown function (DUF4401)', NULL, 'DUF4401', NULL, NULL, 26366, 9),
(265777, NULL, 'PF06375', NULL, NULL, 'AP-3 complex subunit delta-1', NULL, 'AP3D1', NULL, NULL, 10114, 9),
(265778, NULL, 'PF17118', NULL, NULL, 'Domain of unknown function (DUF5105)', NULL, 'DUF5105', NULL, NULL, 26035, 9),
(265779, NULL, 'PF13097', NULL, NULL, 'CENP-A nucleosome associated complex (NAC) subunit', NULL, 'CENP-U', NULL, NULL, 22424, 9),
(265780, NULL, 'PF16068', NULL, NULL, 'Domain of unknown function (DUF4810)', NULL, 'DUF4810', NULL, NULL, 11333, 9),
(265781, NULL, 'PF18284', NULL, NULL, 'DNA methylase N-terminal domain', NULL, 'DNA_meth_N', NULL, NULL, 29463, 9),
(265782, NULL, 'PF12010', NULL, NULL, 'Domain of unknown function (DUF3502)', NULL, 'DUF3502', NULL, NULL, 16673, 9),
(265783, NULL, 'PF12658', NULL, NULL, 'Telomere capping, CST complex subunit', NULL, 'Ten1', NULL, NULL, 20809, 9),
(265784, NULL, 'PF01339', NULL, NULL, 'CheB methylesterase', NULL, 'CheB_methylest', NULL, NULL, 3971, 9),
(265785, NULL, 'PF15718', NULL, NULL, 'Protein moonraker', NULL, 'MNR', NULL, NULL, 24234, 9),
(265786, NULL, 'PF01747', NULL, NULL, 'ATP-sulfurylase', NULL, 'ATP-sulfurylase', NULL, NULL, 26532, 9),
(265787, NULL, 'PF08267', NULL, NULL, 'Cobalamin-independent synthase, N-terminal domain', NULL, 'Meth_synt_1', NULL, NULL, 12264, 9),
(265788, NULL, 'PF19145', NULL, NULL, 'Family of unknown function (DUF5827)', NULL, 'DUF5827', NULL, NULL, 34403, 9),
(265789, NULL, 'PF19937', NULL, NULL, 'Gliding motility-associated protein GldC-like', NULL, 'GldC-like', NULL, NULL, 18200, 9),
(265790, NULL, 'PF17836', NULL, NULL, 'PglD N-terminal domain', NULL, 'PglD_N', NULL, NULL, 30250, 9),
(265791, NULL, 'PF05283', NULL, NULL, 'Multi-glycosylated core protein 24 (MGC-24), sialomucin', NULL, 'MGC-24', NULL, NULL, 4312, 9),
(265792, NULL, 'PF09086', NULL, NULL, 'Domain of unknown function (DUF1924)', NULL, 'DUF1924', NULL, NULL, 9765, 9),
(265793, NULL, 'PF20046', NULL, NULL, 'Family of unknown function (DUF6448)', NULL, 'DUF6448', NULL, NULL, 34157, 9),
(265794, NULL, 'PF06632', NULL, NULL, 'DNA double-strand break repair and V(D)J recombination protein XRCC4', NULL, 'XRCC4', NULL, NULL, 8464, 9),
(265795, NULL, 'PF11593', NULL, NULL, 'Mediator complex subunit 3 fungal', NULL, 'Med3', NULL, NULL, 14822, 9),
(265796, NULL, 'PF08050', NULL, NULL, 'Tetracycline resistance leader peptide', NULL, 'Tet_res_leader', NULL, NULL, 9618, 9),
(265797, NULL, 'PF12572', NULL, NULL, 'Protein of unknown function (DUF3752)', NULL, 'DUF3752', NULL, NULL, 21024, 9),
(265798, NULL, 'PF03074', NULL, NULL, 'Glutamate-cysteine ligase', NULL, 'GCS', NULL, NULL, 4856, 9),
(265799, NULL, 'PF05496', NULL, NULL, 'Holliday junction DNA helicase RuvB P-loop domain', NULL, 'RuvB_N', NULL, NULL, 13997, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(265800, NULL, 'PF06303', NULL, NULL, 'MatP N-terminal domain', NULL, 'MatP', NULL, NULL, 27804, 9),
(265801, NULL, 'PF02099', NULL, NULL, 'Josephin', NULL, 'Josephin', NULL, NULL, 10439, 9),
(265802, NULL, 'PF02822', NULL, NULL, 'Antistasin family', NULL, 'Antistasin', NULL, NULL, 1961, 9),
(265803, NULL, 'PF07523', NULL, NULL, 'Bacterial Ig-like domain (group 3)', NULL, 'Big_3', NULL, NULL, 20342, 9),
(265804, NULL, 'PF06169', NULL, NULL, 'Protein of unknown function (DUF982)', NULL, 'DUF982', NULL, NULL, 9249, 9),
(265805, NULL, 'PF13838', NULL, NULL, 'Clathrin-H-link', NULL, 'Clathrin_H_link', NULL, NULL, NULL, 9),
(265806, NULL, 'PF06942', NULL, NULL, 'GlpM protein', NULL, 'GlpM', NULL, NULL, 11513, 9),
(265807, NULL, 'PF07333', NULL, NULL, 'S locus-related glycoprotein 1 binding pollen coat protein (SLR1-BP)', NULL, 'SLR1-BP', NULL, NULL, 11936, 9),
(265808, NULL, 'PF08222', NULL, NULL, 'CodY helix-turn-helix domain', NULL, 'HTH_CodY', NULL, NULL, 17177, 9),
(265809, NULL, 'PF12966', NULL, NULL, 'N-ATPase, AtpR subunit', NULL, 'AtpR', NULL, NULL, 15713, 9),
(265810, NULL, 'PF12677', NULL, NULL, 'Domain of unknown function (DUF3797)', NULL, 'DUF3797', NULL, NULL, 20408, 9),
(265811, NULL, 'PF15786', NULL, NULL, 'PET assembly of cytochrome c oxidase, mitochondrial', NULL, 'PET117', NULL, NULL, 23948, 9),
(265812, NULL, 'PF13241', NULL, NULL, 'Putative NAD(P)-binding', NULL, 'NAD_binding_7', NULL, NULL, NULL, 9),
(265813, NULL, 'PF17081', NULL, NULL, 'Suppressor of PMA 1-7 protein', NULL, 'SOP4', NULL, NULL, 23654, 9),
(265814, NULL, 'PF18380', NULL, NULL, 'Holliday junction resolvase Gen1 C-terminal domain', NULL, 'GEN1_C', NULL, NULL, 28773, 9),
(265815, NULL, 'PF18534', NULL, NULL, 'Helical bundle domain', NULL, 'HBD', NULL, NULL, 30178, 9),
(265816, NULL, 'PF01148', NULL, NULL, 'Cytidylyltransferase family', NULL, 'CTP_transf_1', NULL, NULL, NULL, 9),
(265817, NULL, 'PF00683', NULL, NULL, 'TB domain', NULL, 'TB', NULL, NULL, 12674, 9),
(265818, NULL, 'PF14293', NULL, NULL, 'YWFCY protein', NULL, 'YWFCY', NULL, NULL, 25635, 9),
(265819, NULL, 'PF03537', NULL, NULL, 'Glycoside-hydrolase family GH114', NULL, 'Glyco_hydro_114', NULL, NULL, 5292, 9),
(265820, NULL, 'PF07429', NULL, NULL, '4-alpha-L-fucosyltransferase glycosyl transferase group 56', NULL, 'Glyco_transf_56', NULL, NULL, 8844, 9),
(265821, NULL, 'PF16973', NULL, NULL, 'Flagellar motor switch protein FliN N-terminal', NULL, 'FliN_N', NULL, NULL, 26568, 9),
(265822, NULL, 'PF09600', NULL, NULL, 'Cyd operon protein YbgE (Cyd_oper_YbgE)', NULL, 'Cyd_oper_YbgE', NULL, NULL, 13661, 9),
(265823, NULL, 'PF00249', NULL, NULL, 'Myb-like DNA-binding domain', NULL, 'Myb_DNA-binding', NULL, NULL, 4393, 9),
(265824, NULL, 'PF07054', NULL, NULL, 'Pericardin like repeat', NULL, 'Pericardin_rpt', NULL, NULL, 12976, 9),
(265825, NULL, 'PF19558', NULL, NULL, 'Family of unknown function (DUF6080)', NULL, 'DUF6080', NULL, NULL, 34468, 9),
(265826, NULL, 'PF10271', NULL, NULL, 'Putative transmembrane protein', NULL, 'Tmp39', NULL, NULL, 16587, 9),
(265827, NULL, 'PF02512', NULL, NULL, 'Virulence determinant', NULL, 'UK', NULL, NULL, 1305, 9),
(265828, NULL, 'PF14943', NULL, NULL, 'Mitochondrial ribosome subunit S26', NULL, 'MRP-S26', NULL, NULL, 22993, 9),
(265829, NULL, 'PF08841', NULL, NULL, 'Diol dehydratase reactivase ATPase-like domain', NULL, 'DDR', NULL, NULL, 21827, 9),
(265830, NULL, 'PF17792', NULL, NULL, 'ThiD2 family', NULL, 'ThiD2', NULL, NULL, 29438, 9),
(265831, NULL, 'PF11825', NULL, NULL, 'Nuclear/hormone receptor activator site AF-1', NULL, 'Nuc_recep-AF1', NULL, NULL, 19209, 9),
(265832, NULL, 'PF10379', NULL, NULL, 'Virulence protein nec1', NULL, 'nec1', NULL, NULL, 20459, 9),
(265833, NULL, 'PF02464', NULL, NULL, 'Competence-damaged protein', NULL, 'CinA', NULL, NULL, 6429, 9),
(265834, NULL, 'PF11113', NULL, NULL, 'Head assembly gene product', NULL, 'Phage_head_chap', NULL, NULL, 15196, 9),
(265835, NULL, 'PF18296', NULL, NULL, 'MID domain of medPIWI', NULL, 'MID_MedPIWI', NULL, NULL, 29512, 9),
(265836, NULL, 'PF02828', NULL, NULL, 'L27 domain', NULL, 'L27', NULL, NULL, 12470, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(265837, NULL, 'PF15071', NULL, NULL, 'Transmembrane family 220, helix', NULL, 'TMEM220', NULL, NULL, 26142, 9),
(265838, NULL, 'PF05666', NULL, NULL, 'Fels-1 Prophage Protein-like', NULL, 'Fels1', NULL, NULL, 14456, 9),
(265839, NULL, 'PF11592', NULL, NULL, 'Central core of the bacterial effector protein AvrPto', NULL, 'AvrPto', NULL, NULL, 20986, 9),
(265840, NULL, 'PF04989', NULL, NULL, 'Cephalosporin hydroxylase', NULL, 'CmcI', NULL, NULL, 7021, 9),
(265841, NULL, 'PF11458', NULL, NULL, 'Membrane-integrating protein Mistic', NULL, 'Mistic', NULL, NULL, 16784, 9),
(265842, NULL, 'PF08721', NULL, NULL, 'TnsA endonuclease C terminal', NULL, 'Tn7_Tnp_TnsA_C', NULL, NULL, 11773, 9),
(265843, NULL, 'PF10788', NULL, NULL, 'Protein of unknown function (DUF2603)', NULL, 'DUF2603', NULL, NULL, 20697, 9),
(265844, NULL, 'PF14367', NULL, NULL, 'Domain of unknown function (DUF4411)', NULL, 'DUF4411', NULL, NULL, 16087, 9),
(265845, NULL, 'PF16351', NULL, NULL, 'Domain of unknown function (DUF4979)', NULL, 'DUF4979', NULL, NULL, 22488, 9),
(265846, NULL, 'PF19533', NULL, NULL, 'Rab3 GTPase-activating protein catalytic subunit C-terminal', NULL, 'Rab3-GAP_cat_C', NULL, NULL, 36114, 9),
(265847, NULL, 'PF08283', NULL, NULL, 'Geminivirus rep protein central domain', NULL, 'Gemini_AL1_M', NULL, NULL, 14512, 9),
(265848, NULL, 'PF15395', NULL, NULL, 'Domain of unknown function (DUF4617)', NULL, 'DUF4617', NULL, NULL, 25932, 9),
(265849, NULL, 'PF20547', NULL, NULL, 'Family of unknown function (DUF6761)', NULL, 'DUF6761', NULL, NULL, 33547, 9),
(265850, NULL, 'PF00988', NULL, NULL, 'Carbamoyl-phosphate synthase small chain, CPSase domain', NULL, 'CPSase_sm_chain', NULL, NULL, 5122, 9),
(265851, NULL, 'PF15544', NULL, NULL, 'Bacterial toxin 6', NULL, 'Ntox6', NULL, NULL, 22386, 9),
(265852, NULL, 'PF14620', NULL, NULL, 'YpeB sporulation', NULL, 'YPEB', NULL, NULL, 10722, 9),
(265853, NULL, 'PF10316', NULL, NULL, 'Serpentine type 7TM GPCR chemoreceptor Srbc', NULL, '7TM_GPCR_Srbc', NULL, NULL, 16595, 9),
(265854, NULL, 'PF17679', NULL, NULL, 'gp37/Dip protein', NULL, 'Dip', NULL, NULL, 32515, 9),
(265855, NULL, 'PF09794', NULL, NULL, 'Transport protein Avl9', NULL, 'Avl9', NULL, NULL, 8100, 9),
(265856, NULL, 'PF15226', NULL, NULL, 'HCF-1 beta-propeller-interacting protein family', NULL, 'HPIP', NULL, NULL, 21540, 9),
(265857, NULL, 'PF06101', NULL, NULL, 'Vacuolar protein sorting-associated protein 62', NULL, 'Vps62', NULL, NULL, 13903, 9),
(265858, NULL, 'PF07804', NULL, NULL, 'HipA-like C-terminal domain', NULL, 'HipA_C', NULL, NULL, 13206, 9),
(265859, NULL, 'PF17080', NULL, NULL, 'Multidrug Resistance efflux pump', NULL, 'SepA', NULL, NULL, 23655, 9),
(265860, NULL, 'PF07404', NULL, NULL, 'Telomere-binding protein beta subunit (TEBP beta)', NULL, 'TEBP_beta', NULL, NULL, 11794, 9),
(265861, NULL, 'PF12824', NULL, NULL, 'Mitochondrial ribosomal protein subunit L20', NULL, 'MRP-L20', NULL, NULL, NULL, 9),
(265862, NULL, 'PF11467', NULL, NULL, 'Lens epithelium-derived growth factor (LEDGF)', NULL, 'LEDGF', NULL, NULL, 18694, 9),
(265863, NULL, 'PF01410', NULL, NULL, 'Fibrillar collagen C-terminal domain', NULL, 'COLFI', NULL, NULL, 4698, 9),
(265864, NULL, 'PF02756', NULL, NULL, 'GYR motif', NULL, 'GYR', NULL, NULL, 704, 9),
(265865, NULL, 'PF08346', NULL, NULL, 'AntA/AntB antirepressor', NULL, 'AntA', NULL, NULL, 12902, 9),
(265866, NULL, 'PF11491', NULL, NULL, 'Protein of unknown function (DUF3213)', NULL, 'DUF3213', NULL, NULL, 18598, 9),
(265867, NULL, 'PF20310', NULL, NULL, 'Transposon related HTH domain protein', NULL, 'HTH_Tnp_2', NULL, NULL, 34237, 9),
(265868, NULL, 'PF13185', NULL, NULL, 'GAF domain', NULL, 'GAF_2', NULL, NULL, 112, 9),
(265869, NULL, 'PF15349', NULL, NULL, 'DDB1- and CUL4-associated factor 16', NULL, 'DCA16', NULL, NULL, 22184, 9),
(265870, NULL, 'PF12945', NULL, NULL, 'Flagellar protein YcgR', NULL, 'PilZNR', NULL, NULL, 8355, 9),
(265871, NULL, 'PF15506', NULL, NULL, 'OCC1 family', NULL, 'OCC1', NULL, NULL, 23861, 9),
(265872, NULL, 'PF15482', NULL, NULL, 'Coiled-coil domain-containing glutamate-rich protein family 1', NULL, 'CCER1', NULL, NULL, 23614, 9);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(265873, NULL, 'PF08288', NULL, NULL, 'PIGA (GPI anchor biosynthesis)', NULL, 'PIGA', NULL, NULL, 12328, 9),
(265874, NULL, 'PF03669', NULL, NULL, 'PAT complex subunit Asterix', NULL, 'ASTER', NULL, NULL, 6377, 9),
(265875, NULL, 'PF02972', NULL, NULL, 'Phycoerythrin, alpha/beta chain', NULL, 'Phycoerythr_ab', NULL, NULL, 3850, 9),
(265876, NULL, 'PF19298', NULL, NULL, '3-Ketosteroid 9alpha-hydroxylase C-terminal domain', NULL, 'KshA_C', NULL, NULL, 34113, 9),
(265877, NULL, 'PF10168', NULL, NULL, 'Nuclear pore component', NULL, 'Nup88', NULL, NULL, 14870, 9),
(265878, NULL, 'PF07886', NULL, NULL, 'BA14K-like protein', NULL, 'BA14K', NULL, NULL, 13487, 9),
(265879, NULL, 'PF12192', NULL, NULL, 'Fungal calcium binding protein', NULL, 'CBP', NULL, NULL, 20326, 9),
(265880, NULL, 'PF02066', NULL, NULL, 'Metallothionein family 11', NULL, 'Metallothio_11', NULL, NULL, 4611, 9),
(265881, NULL, 'PF20428', NULL, NULL, 'Sey1 three-helix bundle domain', NULL, 'Sey1_3HB', NULL, NULL, 33846, 9),
(265882, NULL, 'PF17062', NULL, NULL, 'Outer spore wall 5', NULL, 'Osw5', NULL, NULL, 26003, 9),
(265883, NULL, 'PF01589', NULL, NULL, 'Alphavirus E1 glycoprotein', NULL, 'Alpha_E1_glycop', NULL, NULL, 1997, 9),
(265884, NULL, 'PF18001', NULL, NULL, 'Interleukin-13 receptor subunit alpha Ig-like domain', NULL, 'Il13Ra_Ig', NULL, NULL, 27721, 9),
(265885, NULL, 'PF05020', NULL, NULL, 'NPL4 family, putative zinc binding region', NULL, 'zf-NPL4', NULL, NULL, 1050, 9),
(265886, NULL, 'PF14945', NULL, NULL, 'Normal lung function maintenance, Low in Lung Cancer 1 protein', NULL, 'LLC1', NULL, NULL, 19783, 9),
(265887, NULL, 'PF01402', NULL, NULL, 'Ribbon-helix-helix protein, copG family', NULL, 'RHH_1', NULL, NULL, 5117, 9),
(265888, NULL, 'PF09426', NULL, NULL, 'Vacuolar R-SNARE Nyv1, longin domain', NULL, 'Nyv1_longin', NULL, NULL, 15551, 9),
(265889, NULL, 'PF10932', NULL, NULL, 'Protein of unknown function (DUF2783)', NULL, 'DUF2783', NULL, NULL, 17887, 9),
(265890, NULL, 'PF00721', NULL, NULL, 'Virus coat protein (TMV like)', NULL, 'TMV_coat', NULL, NULL, 2047, 9),
(265891, NULL, 'PF15497', NULL, NULL, 'snRNA-activating protein complex subunit 19, SNAPc subunit 19', NULL, 'SNAPC5', NULL, NULL, 23818, 9),
(265892, NULL, 'PF09361', NULL, NULL, 'Phasin protein', NULL, 'Phasin_2', NULL, NULL, 14564, 9),
(265893, NULL, 'PF00602', NULL, NULL, 'Influenza RNA-dependent RNA polymerase subunit PB1', NULL, 'Flu_PB1', NULL, NULL, 3385, 9),
(265894, NULL, 'PF00261', NULL, NULL, 'Tropomyosin', NULL, 'Tropomyosin', NULL, NULL, 5646, 9),
(265895, NULL, 'PF11954', NULL, NULL, 'Domain of unknown function (DUF3471)', NULL, 'DUF3471', NULL, NULL, 19867, 9),
(265896, NULL, 'PF15903', NULL, NULL, 'Filopodia upregulated, FAM65', NULL, 'PL48', NULL, NULL, 25763, 9),
(265897, NULL, 'PF19869', NULL, NULL, 'Family of unknown function (DUF6342)', NULL, 'DUF6342', NULL, NULL, 36783, 9),
(265898, NULL, 'PF00915', NULL, NULL, 'Calicivirus coat protein', NULL, 'Calici_coat', NULL, NULL, 949, 9),
(265899, NULL, 'PF00068', NULL, NULL, 'Phospholipase A2', NULL, 'Phospholip_A2_1', NULL, NULL, 10230, 9),
(265900, NULL, 'PF02917', NULL, NULL, 'Pertussis toxin, subunit 1', NULL, 'Pertussis_S1', NULL, NULL, 4447, 9),
(265901, NULL, 'PF12774', NULL, NULL, 'Hydrolytic ATP binding site of dynein motor region', NULL, 'AAA_6', NULL, NULL, 31779, 9),
(265902, NULL, 'PF01751', NULL, NULL, 'Toprim domain', NULL, 'Toprim', NULL, NULL, 11269, 9),
(265903, NULL, 'PF12854', NULL, NULL, 'PPR repeat', NULL, 'PPR_1', NULL, NULL, 5826, 9),
(265904, NULL, 'PF17343', NULL, NULL, 'Family of unknown function (DUF5373)', NULL, 'DUF5373', NULL, NULL, 9794, 9),
(265905, NULL, 'PF09274', NULL, NULL, 'ParG', NULL, 'ParG', NULL, NULL, 13126, 9),
(265906, NULL, 'PF13970', NULL, NULL, 'Domain of unknown function (DUF4221)', NULL, 'DUF4221', NULL, NULL, 22174, 9),
(265907, NULL, 'PF13579', NULL, NULL, 'Glycosyl transferase 4-like domain', NULL, 'Glyco_trans_4_4', NULL, NULL, 24508, 9),
(265908, NULL, 'PF04112', NULL, NULL, 'Mak10 subunit, NatC N(alpha)-terminal acetyltransferase', NULL, 'Mak10', NULL, NULL, 6938, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(265909, NULL, 'PF04690', NULL, NULL, 'YABBY protein', NULL, 'YABBY', NULL, NULL, 3055, 9),
(265910, NULL, 'PF04488', NULL, NULL, 'Glycosyltransferase sugar-binding region containing DXD motif', NULL, 'Gly_transf_sug', NULL, NULL, 1858, 9),
(265911, NULL, 'PF05949', NULL, NULL, 'Bacterial protein of unknown function (DUF881)', NULL, 'DUF881', NULL, NULL, 7538, 9),
(265912, NULL, 'PF11289', NULL, NULL, 'Betacoronavirus viroporin', NULL, 'bCoV_viroporin', NULL, NULL, 22407, 9),
(265913, NULL, 'PF01752', NULL, NULL, 'Collagenase', NULL, 'Peptidase_M9', NULL, NULL, 497, 9),
(265914, NULL, 'PF12533', NULL, NULL, 'Neuronal helix-loop-helix transcription factor', NULL, 'Neuro_bHLH', NULL, NULL, 16170, 9),
(265915, NULL, 'PF15605', NULL, NULL, 'Bacterial toxin 28', NULL, 'Ntox28', NULL, NULL, 24532, 9),
(265916, NULL, 'PF13520', NULL, NULL, 'Amino acid permease', NULL, 'AA_permease_2', NULL, NULL, 5722, 9),
(265917, NULL, 'PF18994', NULL, NULL, 'Prophage endopeptidase tail N-terminal domain', NULL, 'Prophage_tailD1', NULL, NULL, 35573, 9),
(265918, NULL, 'PF12884', NULL, NULL, 'Transducer of regulated CREB activity, N terminus', NULL, 'TORC_N', NULL, NULL, 23622, 9),
(265919, NULL, 'PF01549', NULL, NULL, 'ShK domain-like', NULL, 'ShK', NULL, NULL, 327, 9),
(265920, NULL, 'PF05279', NULL, NULL, 'Aspartyl beta-hydroxylase N-terminal region', NULL, 'Asp-B-Hydro_N', NULL, NULL, 4087, 9),
(265921, NULL, 'PF15548', NULL, NULL, 'Domain of unknown function (DUF4655)', NULL, 'DUF4655', NULL, NULL, 24473, 9),
(265922, NULL, 'PF07766', NULL, NULL, 'LETM1-like, RBD', NULL, 'LETM1_RBD', NULL, NULL, 29182, 9),
(265923, NULL, 'PF06522', NULL, NULL, 'NADH-ubiquinone reductase complex 1 MLRQ subunit', NULL, 'B12D', NULL, NULL, 14144, 9),
(265924, NULL, 'PF09989', NULL, NULL, 'CoA enzyme activase uncharacterised domain (DUF2229)', NULL, 'DUF2229', NULL, NULL, 17131, 9),
(265925, NULL, 'PF17402', NULL, NULL, 'Family of unknown function (DUF5408)', NULL, 'DUF5408', NULL, NULL, 30717, 9),
(265926, NULL, 'PF16860', NULL, NULL, 'CHCH-CHCH-like Cx9C, IMS import disulfide relay-system,', NULL, 'CX9C', NULL, NULL, 25785, 9),
(265927, NULL, 'PF20597', NULL, NULL, 'Putative Ice-binding-like adhesive domain', NULL, 'pAdhesive_15', NULL, NULL, 26800, 9),
(265928, NULL, 'PF08897', NULL, NULL, 'Domain of unknown function (DUF1841)', NULL, 'DUF1841', NULL, NULL, 7833, 9),
(265929, NULL, 'PF16670', NULL, NULL, 'Phosphoinositide phospholipase C, Ca2+-dependent', NULL, 'PI-PLC-C1', NULL, NULL, 26342, 9),
(265930, NULL, 'PF12123', NULL, NULL, 'PlyG Cell wall binding domain', NULL, 'CBD_PlyG', NULL, NULL, 20136, 9),
(265931, NULL, 'PF09674', NULL, NULL, 'Protein of unknown function (DUF2400)', NULL, 'DUF2400', NULL, NULL, 13524, 9),
(265932, NULL, 'PF16080', NULL, NULL, 'Bacteriophage holin family HP1', NULL, 'Phage_holin_2_3', NULL, NULL, 22504, 9),
(265933, NULL, 'PF05777', NULL, NULL, 'Drosophila accessory gland-specific peptide 26Ab (Acp26Ab)', NULL, 'Acp26Ab', NULL, NULL, 7680, 9),
(265934, NULL, 'PF15413', NULL, NULL, 'Pleckstrin homology domain', NULL, 'PH_11', NULL, NULL, NULL, 9),
(265935, NULL, 'PF05114', NULL, NULL, 'Protein of unknown function (DUF692)', NULL, 'DUF692', NULL, NULL, 2494, 9),
(265936, NULL, 'PF18634', NULL, NULL, 'RXLR phytopathogen effector protein WY-domain', NULL, 'RXLR_WY', NULL, NULL, 28225, 9),
(265937, NULL, 'PF16996', NULL, NULL, 'Accessory secretory protein Sec Asp4', NULL, 'Asp4', NULL, NULL, 24469, 9),
(265938, NULL, 'PF11655', NULL, NULL, 'Protein of unknown function (DUF2589)', NULL, 'DUF2589', NULL, NULL, 24755, 9),
(265939, NULL, 'PF11004', NULL, NULL, '3-deoxy-D-manno-oct-2-ulosonic acid (Kdo) hydroxylase', NULL, 'Kdo_hydroxy', NULL, NULL, 17552, 9),
(265940, NULL, 'PF17045', NULL, NULL, 'Centrosomal protein of 63 kDa', NULL, 'CEP63', NULL, NULL, 26603, 9),
(265941, NULL, 'PF17790', NULL, NULL, 'Macroglobulin domain MG1', NULL, 'MG1', NULL, NULL, 29988, 9),
(265942, NULL, 'PF19931', NULL, NULL, 'Family of unknown function (DUF6394)', NULL, 'DUF6394', NULL, NULL, 33902, 9),
(265943, NULL, 'PF14404', NULL, NULL, 'Ribosomally synthesized peptide in Streptomyces species', NULL, 'Strep_pep', NULL, NULL, 25031, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(265944, NULL, 'PF09379', NULL, NULL, 'FERM N-terminal domain', NULL, 'FERM_N', NULL, NULL, 14806, 9),
(265945, NULL, 'PF13973', NULL, NULL, 'Domain of unknown function (DUF4222)', NULL, 'DUF4222', NULL, NULL, 22282, 9),
(265946, NULL, 'PF07208', NULL, NULL, 'Protein of unknown function (DUF1414)', NULL, 'DUF1414', NULL, NULL, 14258, 9),
(265947, NULL, 'PF05922', NULL, NULL, 'Peptidase inhibitor I9', NULL, 'Inhibitor_I9', NULL, NULL, 7974, 9),
(265948, NULL, 'PF18445', NULL, NULL, 'PR zinc knuckle motif', NULL, 'zf_PR_Knuckle', NULL, NULL, 29071, 9),
(265949, NULL, 'PF00910', NULL, NULL, 'RNA helicase', NULL, 'RNA_helicase', NULL, NULL, 5861, 9),
(265950, NULL, 'PF01230', NULL, NULL, 'HIT domain', NULL, 'HIT', NULL, NULL, 9054, 9),
(265951, NULL, 'PF16288', NULL, NULL, 'Domain of unknown function (DUF4934)', NULL, 'DUF4934', NULL, NULL, 21634, 9),
(265952, NULL, 'PF15237', NULL, NULL, 'PTRF/SDPR family', NULL, 'PTRF_SDPR', NULL, NULL, 25971, 9),
(265953, NULL, 'PF11198', NULL, NULL, 'Protein of unknown function (DUF2857)', NULL, 'DUF2857', NULL, NULL, 18294, 9),
(265954, NULL, 'PF07880', NULL, NULL, 'Bacteriophage T4 gp9/10-like protein', NULL, 'T4_gp9_10', NULL, NULL, 9920, 9),
(265955, NULL, 'PF14899', NULL, NULL, 'Domain of unknown function (DUF4492)', NULL, 'DUF4492', NULL, NULL, 25887, 9),
(265956, NULL, 'PF10463', NULL, NULL, 'Peptidase U49', NULL, 'Peptidase_U49', NULL, NULL, 18415, 9),
(265957, NULL, 'PF16905', NULL, NULL, 'Voltage-dependent L-type calcium channel, IQ-associated', NULL, 'GPHH', NULL, NULL, 21897, 9),
(265958, NULL, 'PF02092', NULL, NULL, 'Glycyl-tRNA synthetase beta subunit', NULL, 'tRNA_synt_2f', NULL, NULL, 8398, 9),
(265959, NULL, 'PF10310', NULL, NULL, 'Family of unknown function (DUF5427)', NULL, 'DUF5427', NULL, NULL, 19657, 9),
(265960, NULL, 'PF12376', NULL, NULL, 'Protein of unknown function (DUF3654)', NULL, 'DUF3654', NULL, NULL, 20647, 9),
(265961, NULL, 'PF03673', NULL, NULL, 'Uncharacterised protein family (UPF0128)', NULL, 'UPF0128', NULL, NULL, 4110, 9),
(265962, NULL, 'PF18185', NULL, NULL, 'Sir2- and TIR-associating SLOG family', NULL, 'STALD', NULL, NULL, 29068, 9),
(265963, NULL, 'PF13767', NULL, NULL, 'Domain of unknown function (DUF4168)', NULL, 'DUF4168', NULL, NULL, 22354, 9),
(265964, NULL, 'PF19975', NULL, NULL, 'Double-GTPase 1', NULL, 'DO-GTPase1', NULL, NULL, 35784, 9),
(265965, NULL, 'PF15758', NULL, NULL, 'Histidine-rich carboxyl terminus protein 1', NULL, 'HRCT1', NULL, NULL, 24742, 9),
(265966, NULL, 'PF02077', NULL, NULL, 'SURF4 family', NULL, 'SURF4', NULL, NULL, 7423, 9),
(265967, NULL, 'PF01893', NULL, NULL, 'Uncharacterised protein family UPF0058', NULL, 'UPF0058', NULL, NULL, 3531, 9),
(265968, NULL, 'PF04703', NULL, NULL, 'FaeA-like protein', NULL, 'FaeA', NULL, NULL, 3343, 9),
(265969, NULL, 'PF07774', NULL, NULL, 'ER membrane protein complex subunit 1, C-terminal', NULL, 'EMC1_C', NULL, NULL, 10812, 9),
(265970, NULL, 'PF09191', NULL, NULL, 'CD4, extracellular', NULL, 'CD4-extracel', NULL, NULL, 12436, 9),
(265971, NULL, 'PF16919', NULL, NULL, 'Protein kinase G rubredoxin domain', NULL, 'PknG_rubred', NULL, NULL, 25016, 9),
(265972, NULL, 'PF20117', NULL, NULL, 'Family of unknown function (DUF6507)', NULL, 'DUF6507', NULL, NULL, 35700, 9),
(265973, NULL, 'PF00741', NULL, NULL, 'Gas vesicle protein', NULL, 'Gas_vesicle', NULL, NULL, 3707, 9),
(265974, NULL, 'PF01923', NULL, NULL, 'Cobalamin adenosyltransferase', NULL, 'Cob_adeno_trans', NULL, NULL, 9444, 9),
(265975, NULL, 'PF10199', NULL, NULL, 'Alpha and gamma adaptin binding protein p34', NULL, 'Adaptin_binding', NULL, NULL, NULL, 9),
(265976, NULL, 'PF15091', NULL, NULL, 'Domain of unknown function (DUF4554)', NULL, 'DUF4554', NULL, NULL, 23549, 9),
(265977, NULL, 'PF03054', NULL, NULL, 'tRNA methyl transferase HUP domain', NULL, 'tRNA_Me_trans', NULL, NULL, NULL, 9),
(265978, NULL, 'PF16886', NULL, NULL, 'ATPsynthase alpha/beta subunit N-term extension', NULL, 'ATP-synt_ab_Xtn', NULL, NULL, 22887, 9),
(265979, NULL, 'PF03803', NULL, NULL, 'Scramblase', NULL, 'Scramblase', NULL, NULL, 1733, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(265980, NULL, 'PF03978', NULL, NULL, 'Borrelia burgdorferi REV protein', NULL, 'Borrelia_REV', NULL, NULL, 132, 9),
(265981, NULL, 'PF17145', NULL, NULL, 'Domain of unknown function (DUF5119)', NULL, 'DUF5119', NULL, NULL, 32531, 9),
(265982, NULL, 'PF17631', NULL, NULL, 'Family of unknown function (DUF5512)', NULL, 'DUF5512', NULL, NULL, 21481, 9),
(265983, NULL, 'PF07769', NULL, NULL, 'psiF repeat', NULL, 'PsiF_repeat', NULL, NULL, 10797, 9),
(265984, NULL, 'PF04764', NULL, NULL, 'Protein of unknown function (DUF613)', NULL, 'DUF613', NULL, NULL, 3983, 9),
(265985, NULL, 'PF18375', NULL, NULL, 'CDH1/2 SANT-Helical linker 1', NULL, 'CDH1_2_SANT_HL1', NULL, NULL, 29388, 9),
(265986, NULL, 'PF12081', NULL, NULL, 'GldM N-terminal domain', NULL, 'GldM_N', NULL, NULL, 16996, 9),
(265987, NULL, 'PF07839', NULL, NULL, 'Plant calmodulin-binding domain', NULL, 'CaM_binding', NULL, NULL, 13425, 9),
(265988, NULL, 'PF19747', NULL, NULL, 'Family of unknown function (DUF6234)', NULL, 'DUF6234', NULL, NULL, 37215, 9),
(265989, NULL, 'PF05506', NULL, NULL, 'Bacterial phospholipase C, C-terminal domain', NULL, 'PLipase_C_C', NULL, NULL, 12476, 9),
(265990, NULL, 'PF11950', NULL, NULL, 'Protein of unknown function (DUF3467)', NULL, 'DUF3467', NULL, NULL, 19934, 9),
(265991, NULL, 'PF15579', NULL, NULL, 'Immunity protein 52', NULL, 'Imm52', NULL, NULL, 24673, 9),
(265992, NULL, 'PF19691', NULL, NULL, 'Family of unknown function (DUF6192)', NULL, 'DUF6192', NULL, NULL, 36465, 9),
(265993, NULL, 'PF08636', NULL, NULL, 'ER protein Pkr1', NULL, 'Pkr1', NULL, NULL, 7840, 9),
(265994, NULL, 'PF11922', NULL, NULL, 'Domain of unknown function (DUF3440)', NULL, 'DUF3440', NULL, NULL, 19664, 9),
(265995, NULL, 'PF12048', NULL, NULL, 'Protein of unknown function (DUF3530)', NULL, 'DUF3530', NULL, NULL, 14560, 9),
(265996, NULL, 'PF17355', NULL, NULL, 'Family of unknown function (DUF5383)', NULL, 'DUF5383', NULL, NULL, 18595, 9),
(265997, NULL, 'PF17838', NULL, NULL, 'PH domain', NULL, 'PH_16', NULL, NULL, 31281, 9),
(265998, NULL, 'PF11226', NULL, NULL, 'Protein of unknown function (DUF3022)', NULL, 'DUF3022', NULL, NULL, 18001, 9),
(265999, NULL, 'PF02520', NULL, NULL, 'SXP/RAL-2 family protein Ani s 5-like, metal-binding domain', NULL, 'ANIS5_cation-bd', NULL, NULL, 1191, 9),
(266000, NULL, 'PF20318', NULL, NULL, 'Family of unknown function (DUF6613)', NULL, 'DUF6613', NULL, NULL, 37131, 9),
(266001, NULL, 'PF02730', NULL, NULL, 'Aldehyde ferredoxin oxidoreductase, N-terminal domain', NULL, 'AFOR_N', NULL, NULL, 12722, 9),
(266002, NULL, 'PF01870', NULL, NULL, 'Archaeal holliday junction resolvase (hjc)', NULL, 'Hjc', NULL, NULL, 3807, 9),
(266003, NULL, 'PF00167', NULL, NULL, 'Fibroblast growth factor', NULL, 'FGF', NULL, NULL, 5967, 9),
(266004, NULL, 'PF02580', NULL, NULL, 'D-Tyr-tRNA(Tyr) deacylase', NULL, 'Tyr_Deacylase', NULL, NULL, 2046, 9),
(266005, NULL, 'PF15820', NULL, NULL, 'Endothelial cell-specific chemotaxis regulator', NULL, 'ECSCR', NULL, NULL, 24704, 9),
(266006, NULL, 'PF02622', NULL, NULL, 'Uncharacterized ACR, COG1678', NULL, 'DUF179', NULL, NULL, 2682, 9),
(266007, NULL, 'PF19621', NULL, NULL, 'Family of unknown function (DUF6126)', NULL, 'DUF6126', NULL, NULL, 37379, 9),
(266008, NULL, 'PF08922', NULL, NULL, 'Domain of unknown function (DUF1905)', NULL, 'DUF1905', NULL, NULL, 7906, 9),
(266009, NULL, 'PF12920', NULL, NULL, 'TcdA/TcdB pore forming domain', NULL, 'TcdA_TcdB_pore', NULL, NULL, 20825, 9),
(266010, NULL, 'PF07214', NULL, NULL, 'Protein of unknown function (DUF1418)', NULL, 'DUF1418', NULL, NULL, 10789, 9),
(266011, NULL, 'PF14731', NULL, NULL, 'Staphopain proregion', NULL, 'Staphopain_pro', NULL, NULL, 23419, 9),
(266012, NULL, 'PF12058', NULL, NULL, 'Protein of unknown function (DUF3539)', NULL, 'DUF3539', NULL, NULL, 19962, 9),
(266013, NULL, 'PF06110', NULL, NULL, 'Eukaryotic protein of unknown function (DUF953)', NULL, 'DUF953', NULL, NULL, 8971, 9),
(266014, NULL, 'PF11474', NULL, NULL, 'Telomerase reverse transcriptase TEN domain', NULL, 'N-Term_TEN', NULL, NULL, NULL, 9);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(266015, NULL, 'PF09364', NULL, NULL, 'XFP N-terminal domain', NULL, 'XFP_N', NULL, NULL, 14820, 9),
(266016, NULL, 'PF04561', NULL, NULL, 'RNA polymerase Rpb2, domain 2', NULL, 'RNA_pol_Rpb2_2', NULL, NULL, 2473, 9),
(266017, NULL, 'PF05703', NULL, NULL, 'Auxin canalisation', NULL, 'Auxin_canalis', NULL, NULL, 13367, 9),
(266018, NULL, 'PF19500', NULL, NULL, 'Family of unknown function (DUF6035)', NULL, 'DUF6035', NULL, NULL, 36705, 9),
(266019, NULL, 'PF07475', NULL, NULL, 'HPr Serine kinase C-terminal domain', NULL, 'Hpr_kinase_C', NULL, NULL, 11475, 9),
(266020, NULL, 'PF15052', NULL, NULL, 'TMEM169 protein family', NULL, 'TMEM169', NULL, NULL, 26276, 9),
(266021, NULL, 'PF09329', NULL, NULL, 'Primase zinc finger', NULL, 'zf-primase', NULL, NULL, 14077, 9),
(266022, NULL, 'PF20281', NULL, NULL, 'C-terminal domain 5 of the ABC-three component (ABC-3C) systems', NULL, 'CTD5', NULL, NULL, 37688, 9),
(266023, NULL, 'PF06898', NULL, NULL, 'Putative stage IV sporulation protein YqfD', NULL, 'YqfD', NULL, NULL, 9446, 9),
(266024, NULL, 'PF16374', NULL, NULL, 'Cycle inhibiting factor (CIF)', NULL, 'CIF', NULL, NULL, 26198, 9),
(266025, NULL, 'PF19853', NULL, NULL, 'Family of unknown function (DUF6328)', NULL, 'DUF6328', NULL, NULL, 37733, 9),
(266026, NULL, 'PF04790', NULL, NULL, 'Sarcoglycan complex subunit protein', NULL, 'Sarcoglycan_1', NULL, NULL, 4555, 9),
(266027, NULL, 'PF01448', NULL, NULL, 'ELM2 domain', NULL, 'ELM2', NULL, NULL, 3106, 9),
(266028, NULL, 'PF01666', NULL, NULL, 'DX module', NULL, 'DX', NULL, NULL, 1893, 9),
(266029, NULL, 'PF09297', NULL, NULL, 'NADH pyrophosphatase zinc ribbon domain', NULL, 'zf-NADH-PPase', NULL, NULL, 14306, 9),
(266030, NULL, 'PF05368', NULL, NULL, 'NmrA-like family', NULL, 'NmrA', NULL, NULL, 5069, 9),
(266031, NULL, 'PF17916', NULL, NULL, 'LIM interaction domain (LID)', NULL, 'LID', NULL, NULL, 29076, 9),
(266032, NULL, 'PF02545', NULL, NULL, 'Maf-like protein', NULL, 'Maf', NULL, NULL, 2141, 9),
(266033, NULL, 'PF12921', NULL, NULL, 'Mitochondrial ATPase expression', NULL, 'ATP13', NULL, NULL, 24558, 9),
(266034, NULL, 'PF20194', NULL, NULL, 'Family of unknown function (DUF6557)', NULL, 'DUF6557', NULL, NULL, 37080, 9),
(266035, NULL, 'PF15723', NULL, NULL, 'Motility quorum-sensing regulator, toxin of MqsA', NULL, 'MqsR_toxin', NULL, NULL, 25157, 9),
(266036, NULL, 'PF09843', NULL, NULL, 'Predicted membrane protein (DUF2070)', NULL, 'DUF2070', NULL, NULL, 19350, 9),
(266037, NULL, 'PF03312', NULL, NULL, 'Protein of unknown function (DUF272)', NULL, 'DUF272', NULL, NULL, 925, 9),
(266038, NULL, 'PF16422', NULL, NULL, 'Transcription factor COE1 DNA-binding domain', NULL, 'COE1_DBD', NULL, NULL, 24019, 9),
(266039, NULL, 'PF10785', NULL, NULL, 'NADH-ubiquinone oxidoreductase complex I, 21 kDa subunit', NULL, 'NADH-u_ox-rdase', NULL, NULL, 20909, 9),
(266040, NULL, 'PF19227', NULL, NULL, 'Salyut domain', NULL, 'Salyut', NULL, NULL, 35704, 9),
(266041, NULL, 'PF07358', NULL, NULL, 'Protein of unknown function (DUF1482)', NULL, 'DUF1482', NULL, NULL, 8033, 9),
(266042, NULL, 'PF11088', NULL, NULL, 'Glycoprotein encoding membrane proteins RL5A and RL6', NULL, 'RL11D', NULL, NULL, 22053, 9),
(266043, NULL, 'PF00171', NULL, NULL, 'Aldehyde dehydrogenase family', NULL, 'Aldedh', NULL, NULL, 9708, 9),
(266044, NULL, 'PF03126', NULL, NULL, 'Plus-3 domain', NULL, 'Plus-3', NULL, NULL, 4630, 9),
(266045, NULL, 'PF05960', NULL, NULL, 'Bacterial protein of unknown function (DUF885)', NULL, 'DUF885', NULL, NULL, 7635, 9),
(266046, NULL, 'PF15607', NULL, NULL, 'Bacterial toxin 44', NULL, 'Ntox44', NULL, NULL, 24503, 9),
(266047, NULL, 'PF15583', NULL, NULL, 'Immunity protein 68', NULL, 'Imm68', NULL, NULL, 26721, 9),
(266048, NULL, 'PF01994', NULL, NULL, 'tRNA ribose 2''-O-methyltransferase, aTrm56', NULL, 'Trm56', NULL, NULL, 5635, 9),
(266049, NULL, 'PF03113', NULL, NULL, 'Respiratory synctial virus non-structural protein NS2', NULL, 'RSV_NS2', NULL, NULL, 4829, 9),
(266050, NULL, 'PF05438', NULL, NULL, 'Thyrotropin-releasing hormone (TRH)', NULL, 'TRH', NULL, NULL, 13939, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(266051, NULL, 'PF12828', NULL, NULL, 'PX-associated', NULL, 'PXB', NULL, NULL, 21616, 9),
(266052, NULL, 'PF10186', NULL, NULL, 'Vacuolar sorting 38 and autophagy-related subunit 14', NULL, 'ATG14', NULL, NULL, 19474, 9),
(266053, NULL, 'PF19486', NULL, NULL, 'Family of unknown function (DUF6022)', NULL, 'DUF6022', NULL, NULL, 36774, 9),
(266054, NULL, 'PF20087', NULL, NULL, 'Family of unknown function (DUF6479)', NULL, 'DUF6479', NULL, NULL, 37374, 9),
(266055, NULL, 'PF19439', NULL, NULL, 'CLEC16A C-terminal', NULL, 'CLEC16A_C', NULL, NULL, 37411, 9),
(266056, NULL, 'PF19857', NULL, NULL, 'Family of unknown function (DUF6332)', NULL, 'DUF6332', NULL, NULL, 37503, 9),
(266057, NULL, 'PF12068', NULL, NULL, 'Rab-binding domain (RBD)', NULL, 'PH_RBD', NULL, NULL, 19946, 9),
(266058, NULL, 'PF03002', NULL, NULL, 'Somatostatin/Cortistatin family', NULL, 'Somatostatin', NULL, NULL, 13932, 9),
(266059, NULL, 'PF20366', NULL, NULL, 'Family of unknown function (DUF6661)', NULL, 'DUF6661', NULL, NULL, 33764, 9),
(266060, NULL, 'PF16301', NULL, NULL, 'Domain of unknown function (DUF4943)', NULL, 'DUF4943', NULL, NULL, 25511, 9),
(266061, NULL, 'PF17361', NULL, NULL, 'Family of unknown function (DUF5387)', NULL, 'DUF5387', NULL, NULL, 27179, 9),
(266062, NULL, 'PF14985', NULL, NULL, 'TM140 protein family', NULL, 'TM140', NULL, NULL, 21528, 9),
(266063, NULL, 'PF02816', NULL, NULL, 'Alpha-kinase family', NULL, 'Alpha_kinase', NULL, NULL, 2823, 9),
(266064, NULL, 'PF07394', NULL, NULL, 'Protein of unknown function (DUF1501)', NULL, 'DUF1501', NULL, NULL, 11745, 9),
(266065, NULL, 'PF17186', NULL, NULL, 'Lipocalin-like domain', NULL, 'Lipocalin_9', NULL, NULL, NULL, 9),
(266066, NULL, 'PF12193', NULL, NULL, 'Sulfolobus virus coat protein C terminal', NULL, 'Sulf_coat_C', NULL, NULL, 20156, 9),
(266067, NULL, 'PF14509', NULL, NULL, 'Glycosyl-hydrolase 97 C-terminal, oligomerisation', NULL, 'GH97_C', NULL, NULL, 23377, 9),
(266068, NULL, 'PF11139', NULL, NULL, 'Sap, sulfolipid-1-addressing protein', NULL, 'SfLAP', NULL, NULL, 17793, 9),
(266069, NULL, 'PF07988', NULL, NULL, 'LMSTEN motif', NULL, 'LMSTEN', NULL, NULL, 10241, 9),
(266070, NULL, 'PF11853', NULL, NULL, 'Protein of unknown function (DUF3373)', NULL, 'DUF3373', NULL, NULL, 19257, 9),
(266071, NULL, 'PF04712', NULL, NULL, 'Radial spokehead-like protein', NULL, 'Radial_spoke', NULL, NULL, 3641, 9),
(266072, NULL, 'PF02453', NULL, NULL, 'Reticulon', NULL, 'Reticulon', NULL, NULL, 4105, 9),
(266073, NULL, 'PF05687', NULL, NULL, 'BES1/BZR1 plant transcription factor, N-terminal', NULL, 'BES1_N', NULL, NULL, 13048, 9),
(266074, NULL, 'PF15420', NULL, NULL, 'Alpha/beta-hydrolase family N-terminus', NULL, 'Abhydrolase_9_N', NULL, NULL, 25455, 9),
(266075, NULL, 'PF18181', NULL, NULL, 'SMODS and SLOG-associating 2TM effector domain 1', NULL, 'SLATT_1', NULL, NULL, 33167, 9),
(266076, NULL, 'PF09749', NULL, NULL, 'Uncharacterised conserved protein', NULL, 'HVSL', NULL, NULL, 23371, 9),
(266077, NULL, 'PF19422', NULL, NULL, 'Ariadne domain', NULL, 'Ariadne', NULL, NULL, 36347, 9),
(266078, NULL, 'PF07192', NULL, NULL, 'SNURF/RPN4 protein', NULL, 'SNURF', NULL, NULL, 13581, 9),
(266079, NULL, 'PF14149', NULL, NULL, 'YhfH-like protein', NULL, 'YhfH', NULL, NULL, 26126, 9),
(266080, NULL, 'PF00076', NULL, NULL, 'RNA recognition motif. (a.k.a. RRM, RBD, or RNP domain)', NULL, 'RRM_1', NULL, NULL, 5671, 9),
(266081, NULL, 'PF13806', NULL, NULL, 'Rieske-like [2Fe-2S] domain', NULL, 'Rieske_2', NULL, NULL, 9884, 9),
(266082, NULL, 'PF16213', NULL, NULL, 'Dimerisation and cyclophilin-binding domain of Mon2', NULL, 'DCB', NULL, NULL, 21856, 9),
(266083, NULL, 'PF15463', NULL, NULL, 'Extracellular mutant protein 11', NULL, 'ECM11', NULL, NULL, 26818, 9),
(266084, NULL, 'PF03601', NULL, NULL, 'Conserved hypothetical protein 698', NULL, 'Cons_hypoth698', NULL, NULL, 20086, 9),
(266085, NULL, 'PF10262', NULL, NULL, 'Rdx family', NULL, 'Rdx', NULL, NULL, 8837, 9),
(266086, NULL, 'PF14390', NULL, NULL, 'Putative  PD-(D/E)XK family member, (DUF4420)', NULL, 'DUF4420', NULL, NULL, 26466, 9);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(266087, NULL, 'PF00539', NULL, NULL, 'Transactivating regulatory protein (Tat)', NULL, 'Tat', NULL, NULL, 4441, 9),
(266088, NULL, 'PF20445', NULL, NULL, 'Retrotransposon hot spot proteins N-terminal', NULL, 'RHS_N', NULL, NULL, 33986, 9),
(266089, NULL, 'PF07397', NULL, NULL, 'Repeat of unknown function (DUF1502)', NULL, 'DUF1502', NULL, NULL, 11570, 9),
(266090, NULL, 'PF02562', NULL, NULL, 'PhoH-like protein', NULL, 'PhoH', NULL, NULL, 2213, 9),
(266091, NULL, 'PF14214', NULL, NULL, 'Helitron helicase-like domain at N-terminus', NULL, 'Helitron_like_N', NULL, NULL, 26470, 9),
(266092, NULL, 'PF12369', NULL, NULL, 'Gonadotropin hormone receptor transmembrane region', NULL, 'GnHR_trans', NULL, NULL, 3511, 9),
(266093, NULL, 'PF04385', NULL, NULL, 'Domain of unknown function, DUF529', NULL, 'FAINT', NULL, NULL, 10113, 9),
(266094, NULL, 'PF14848', NULL, NULL, 'DNA-binding domain', NULL, 'HU-DNA_bdg', NULL, NULL, NULL, 9),
(266095, NULL, 'PF14979', NULL, NULL, 'Transmembrane 52', NULL, 'TMEM52', NULL, NULL, NULL, 9),
(266096, NULL, 'PF12997', NULL, NULL, 'Domain of unknown function, E. rectale Gene description (DUF3881)', NULL, 'DUF3881', NULL, NULL, 24781, 9),
(266097, NULL, 'PF16967', NULL, NULL, 'E-set like domain', NULL, 'TcfC', NULL, NULL, 21568, 9),
(266098, NULL, 'PF06984', NULL, NULL, 'Mitochondrial 39-S ribosomal protein L47 (MRP-L47)', NULL, 'MRP-L47', NULL, NULL, 9857, 9),
(266099, NULL, 'PF08820', NULL, NULL, 'Domain of unknown function (DUF1803)', NULL, 'DUF1803', NULL, NULL, 14192, 9),
(266100, NULL, 'PF19111', NULL, NULL, 'Family of unknown function (DUF5798)', NULL, 'DUF5798', NULL, NULL, 35872, 9),
(266101, NULL, 'PF06102', NULL, NULL, 'rRNA biogenesis protein RRP36', NULL, 'RRP36', NULL, NULL, 13847, 9),
(266102, NULL, 'PF07738', NULL, NULL, 'Sad1 / UNC-like C-terminal', NULL, 'Sad1_UNC', NULL, NULL, 7983, 9),
(266103, NULL, 'PF03421', NULL, NULL, 'YopJ Serine/Threonine acetyltransferase', NULL, 'Acetyltransf_14', NULL, NULL, 10131, 9),
(266104, NULL, 'PF06565', NULL, NULL, 'DM10 domain', NULL, 'DM10_dom', NULL, NULL, 1440, 9),
(266105, NULL, 'PF19247', NULL, NULL, 'Family of unknown function (DUF5895)', NULL, 'DUF5895', NULL, NULL, 35909, 9),
(266106, NULL, 'PF14952', NULL, NULL, 'Putative treble-clef, zinc-finger, Zn-binding', NULL, 'zf-tcix', NULL, NULL, 21996, 9),
(266107, NULL, 'PF05773', NULL, NULL, 'RWD domain', NULL, 'RWD', NULL, NULL, 268, 9),
(266108, NULL, 'PF12495', NULL, NULL, 'Vegetative insecticide protein 3A N terminal', NULL, 'Vip3A_N', NULL, NULL, 21027, 9),
(266109, NULL, 'PF01974', NULL, NULL, 'tRNA intron endonuclease, catalytic C-terminal domain', NULL, 'tRNA_int_endo', NULL, NULL, 1867, 9),
(266110, NULL, 'PF19075', NULL, NULL, 'Family of unknown function (DUF5771)', NULL, 'DUF5771', NULL, NULL, 35199, 9),
(266111, NULL, 'PF03580', NULL, NULL, 'Herpesvirus UL14-like protein', NULL, 'Herpes_UL14', NULL, NULL, 5045, 9),
(266112, NULL, 'PF03235', NULL, NULL, 'Protein of unknown function DUF262', NULL, 'DUF262', NULL, NULL, 1665, 9),
(266113, NULL, 'PF08876', NULL, NULL, 'Domain of unknown function (DUF1836)', NULL, 'DUF1836', NULL, NULL, 14471, 9),
(266114, NULL, 'PF01680', NULL, NULL, 'SOR/SNZ family', NULL, 'SOR_SNZ', NULL, NULL, 27920, 9),
(266115, NULL, 'PF20499', NULL, NULL, 'Domain of unknown function (DUF6729)', NULL, 'DUF6729', NULL, NULL, 33570, 9),
(266116, NULL, 'PF16900', NULL, NULL, 'Replication protein A OB domain', NULL, 'REPA_OB_2', NULL, NULL, 22977, 9),
(266117, NULL, 'PF17435', NULL, NULL, 'Family of unknown function (DUF5414)', NULL, 'DUF5414', NULL, NULL, 27001, 9),
(266118, NULL, 'PF12238', NULL, NULL, 'Merozoite surface antigen 2c', NULL, 'MSA-2c', NULL, NULL, 15124, 9),
(266119, NULL, 'PF15333', NULL, NULL, 'TATA box-binding protein-associated factor 1D', NULL, 'TAF1D', NULL, NULL, 25053, 9),
(266120, NULL, 'PF08803', NULL, NULL, 'Putative mono-oxygenase ydhR', NULL, 'ydhR', NULL, NULL, 13153, 9),
(266121, NULL, 'PF20278', NULL, NULL, 'C-terminal domain 2 of the ABC-three component (ABC-3C) systems', NULL, 'CTD2', NULL, NULL, 34153, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(266122, NULL, 'PF05999', NULL, NULL, 'Herpesvirus U5-like family', NULL, 'Herpes_U5', NULL, NULL, 7524, 9),
(266123, NULL, 'PF08323', NULL, NULL, 'Starch synthase catalytic domain', NULL, 'Glyco_transf_5', NULL, NULL, 12634, 9),
(266124, NULL, 'PF14843', NULL, NULL, 'Growth factor receptor domain IV', NULL, 'GF_recep_IV', NULL, NULL, 22219, 9),
(266125, NULL, 'PF11766', NULL, NULL, 'Cell-wall agglutinin N-terminal ligand-sugar binding', NULL, 'Candida_ALS_N', NULL, NULL, 21311, 9),
(266126, NULL, 'PF19346', NULL, NULL, 'Family of unknown function (DUF5924)', NULL, 'DUF5924', NULL, NULL, 36811, 9),
(266127, NULL, 'PF00937', NULL, NULL, 'Coronavirus nucleocapsid', NULL, 'CoV_nucleocap', NULL, NULL, 1067, 9),
(266128, NULL, 'PF16893', NULL, NULL, 'Fibronectin type III domain', NULL, 'fn3_2', NULL, NULL, 22985, 9),
(266129, NULL, 'PF00015', NULL, NULL, 'Methyl-accepting chemotaxis protein (MCP) signalling domain', NULL, 'MCPsignal', NULL, NULL, 1580, 9),
(266130, NULL, 'PF11732', NULL, NULL, 'Transcription- and export-related complex subunit', NULL, 'Thoc2', NULL, NULL, 19146, 9),
(266131, NULL, 'PF02384', NULL, NULL, 'N-6 DNA Methylase', NULL, 'N6_Mtase', NULL, NULL, 4093, 9),
(266132, NULL, 'PF03917', NULL, NULL, 'Eukaryotic glutathione synthase, ATP binding domain', NULL, 'GSH_synth_ATP', NULL, NULL, 2539, 9),
(266133, NULL, 'PF11110', NULL, NULL, 'Baseplate hub distal subunit', NULL, 'Phage_hub_GP28', NULL, NULL, 22005, 9),
(266134, NULL, 'PF14678', NULL, NULL, 'FANCI solenoid 4', NULL, 'FANCI_S4', NULL, NULL, 26679, 9),
(266135, NULL, 'PF02674', NULL, NULL, 'Colicin V production protein', NULL, 'Colicin_V', NULL, NULL, 3061, 9),
(266136, NULL, 'PF07993', NULL, NULL, 'Male sterility protein', NULL, 'NAD_binding_4', NULL, NULL, 18732, 9),
(266137, NULL, 'PF13917', NULL, NULL, 'Zinc knuckle', NULL, 'zf-CCHC_3', NULL, NULL, NULL, 9),
(266138, NULL, 'PF18486', NULL, NULL, 'PNGase/UBA- or UBX-containing domain', NULL, 'PUB_1', NULL, NULL, 28433, 9),
(266139, NULL, 'PF01646', NULL, NULL, 'Herpes virus proteins UL24 and UL76', NULL, 'Herpes_UL24', NULL, NULL, 1530, 9),
(266140, NULL, 'PF06252', NULL, NULL, 'Bacteriophage Mu, GemA protein', NULL, 'GemA', NULL, NULL, 14275, 9),
(266141, NULL, 'PF20198', NULL, NULL, 'Family of unknown function (DUF6561)', NULL, 'DUF6561', NULL, NULL, 37470, 9),
(266142, NULL, 'PF17141', NULL, NULL, 'Domain of unknown function (DUF5114)', NULL, 'DUF5114', NULL, NULL, 32939, 9),
(266143, NULL, 'PF13001', NULL, NULL, 'Proteasome stabiliser', NULL, 'Ecm29', NULL, NULL, 23161, 9),
(266144, NULL, 'PF16829', NULL, NULL, 'Avirulence protein ATR13, RxLR effector', NULL, 'ATR13', NULL, NULL, 22360, 9),
(266145, NULL, 'PF01262', NULL, NULL, 'Alanine dehydrogenase/PNT, C-terminal domain', NULL, 'AlaDh_PNT_C', NULL, NULL, 1261, 9),
(266146, NULL, 'PF15062', NULL, NULL, 'Haemopoietic lineage transmembrane helix', NULL, 'ARL6IP6', NULL, NULL, 26457, 9),
(266147, NULL, 'PF02489', NULL, NULL, 'Herpesvirus glycoprotein H main domain', NULL, 'Herpes_glycop_H', NULL, NULL, NULL, 9),
(266148, NULL, 'PF09660', NULL, NULL, 'Protein of unknown function (DUF2397)', NULL, 'DUF2397', NULL, NULL, 10410, 9),
(266149, NULL, 'PF12434', NULL, NULL, 'Malate dehydrogenase enzyme', NULL, 'Malate_DH', NULL, NULL, 26737, 9),
(266150, NULL, 'PF00870', NULL, NULL, 'P53 DNA-binding domain', NULL, 'P53', NULL, NULL, 11561, 9),
(266151, NULL, 'PF01275', NULL, NULL, 'Myelin proteolipid protein (PLP or lipophilin)', NULL, 'Myelin_PLP', NULL, NULL, 5237, 9),
(266152, NULL, 'PF03677', NULL, NULL, 'Uncharacterised protein family (UPF0137)', NULL, 'UPF0137', NULL, NULL, 6084, 9),
(266153, NULL, 'PF19108', NULL, NULL, 'Family of unknown function (DUF5795)', NULL, 'DUF5795', NULL, NULL, 35552, 9),
(266154, NULL, 'PF15417', NULL, NULL, 'Domain of unknown function (DUF4624)', NULL, 'DUF4624', NULL, NULL, 24541, 9),
(266155, NULL, 'PF06988', NULL, NULL, 'NifT/FixU protein', NULL, 'NifT', NULL, NULL, 12159, 9),
(266156, NULL, 'PF12125', NULL, NULL, 'D domain of beta-TrCP', NULL, 'Beta-TrCP_D', NULL, NULL, 20425, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(266157, NULL, 'PF13824', NULL, NULL, 'Zinc-finger of mitochondrial splicing suppressor 51', NULL, 'zf-Mss51', NULL, NULL, 26801, 9),
(266158, NULL, 'PF02198', NULL, NULL, 'Sterile alpha motif (SAM)/Pointed domain', NULL, 'SAM_PNT', NULL, NULL, 2975, 9),
(266159, NULL, 'PF11358', NULL, NULL, 'Protein of unknown function (DUF3158)', NULL, 'DUF3158', NULL, NULL, 18860, 9),
(266160, NULL, 'PF12321', NULL, NULL, 'Protein of unknown function (DUF3634)', NULL, 'DUF3634', NULL, NULL, 20967, 9),
(266161, NULL, 'PF14502', NULL, NULL, 'Helix-turn-helix domain', NULL, 'HTH_41', NULL, NULL, 30500, 9),
(266162, NULL, 'PF14109', NULL, NULL, 'GldH lipoprotein', NULL, 'GldH_lipo', NULL, NULL, 17588, 9),
(266163, NULL, 'PF14995', NULL, NULL, 'Transmembrane protein', NULL, 'TMEM107', NULL, NULL, 26941, 9),
(266164, NULL, 'PF13539', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase', NULL, 'Peptidase_M15_4', NULL, NULL, 27023, 9),
(266165, NULL, 'PF10387', NULL, NULL, 'Protein of unknown function (DUF2442)', NULL, 'DUF2442', NULL, NULL, 20411, 9),
(266166, NULL, 'PF18162', NULL, NULL, 'Arc C-lobe', NULL, 'Arc_C', NULL, NULL, 29151, 9),
(266167, NULL, 'PF15504', NULL, NULL, 'Domain of unknown function (DUF4647)', NULL, 'DUF4647', NULL, NULL, 23743, 9),
(266168, NULL, 'PF05933', NULL, NULL, 'Fungal ATP synthase protein 8 (A6L)', NULL, 'Fun_ATP-synt_8', NULL, NULL, 12647, 9),
(266169, NULL, 'PF18973', NULL, NULL, 'Putative Chitin binding like', NULL, 'CBL', NULL, NULL, 35789, 9),
(266170, NULL, 'PF10530', NULL, NULL, 'Toxin with inhibitor cystine knot ICK or Knottin scaffold', NULL, 'Toxin_35', NULL, NULL, 19235, 9),
(266171, NULL, 'PF14933', NULL, NULL, 'CEP19-like protein', NULL, 'CEP19', NULL, NULL, 23914, 9),
(266172, NULL, 'PF05148', NULL, NULL, 'Hypothetical methyltransferase', NULL, 'Methyltransf_8', NULL, NULL, 2114, 9),
(266173, NULL, 'PF05448', NULL, NULL, 'Acetyl xylan esterase (AXE1)', NULL, 'AXE1', NULL, NULL, 7646, 9),
(266174, NULL, 'PF02921', NULL, NULL, 'Ubiquinol cytochrome reductase transmembrane region', NULL, 'UCR_TM', NULL, NULL, 2864, 9),
(266175, NULL, 'PF08279', NULL, NULL, 'HTH domain', NULL, 'HTH_11', NULL, NULL, 17021, 9),
(266176, NULL, 'PF03423', NULL, NULL, 'Carbohydrate binding domain (family 25)', NULL, 'CBM_25', NULL, NULL, 10355, 9),
(266177, NULL, 'PF04007', NULL, NULL, 'Protein of unknown function (DUF354)', NULL, 'DUF354', NULL, NULL, 434, 9),
(266178, NULL, 'PF02617', NULL, NULL, 'ATP-dependent Clp protease adaptor protein ClpS', NULL, 'ClpS', NULL, NULL, 6379, 9),
(266179, NULL, 'PF05023', NULL, NULL, 'Phytochelatin synthase', NULL, 'Phytochelatin', NULL, NULL, 1451, 9),
(266180, NULL, 'PF19463', NULL, NULL, 'Family of unknown function (DUF6000)', NULL, 'DUF6000', NULL, NULL, 36704, 9),
(266181, NULL, 'PF20077', NULL, NULL, 'CcmD family protein', NULL, 'CcmD_alt', NULL, NULL, NULL, 9),
(266182, NULL, 'PF19461', NULL, NULL, 'Family of unknown function (DUF5998)', NULL, 'DUF5998', NULL, NULL, 36664, 9),
(266183, NULL, 'PF07179', NULL, NULL, 'SseB protein N-terminal domain', NULL, 'SseB', NULL, NULL, 13268, 9),
(266184, NULL, 'PF10397', NULL, NULL, 'Adenylosuccinate lyase C-terminus', NULL, 'ADSL_C', NULL, NULL, 17193, 9),
(266185, NULL, 'PF02364', NULL, NULL, '1,3-beta-glucan synthase component', NULL, 'Glucan_synthase', NULL, NULL, 5356, 9),
(266186, NULL, 'PF10357', NULL, NULL, 'Domain of Kin17 curved DNA-binding protein', NULL, 'Kin17_mid', NULL, NULL, 17367, 9),
(266187, NULL, 'PF09209', NULL, NULL, 'HTH-type transcriptional dual regulator CecR, C-terminal domain', NULL, 'CecR_C', NULL, NULL, 12132, 9),
(266188, NULL, 'PF01380', NULL, NULL, 'SIS domain', NULL, 'SIS', NULL, NULL, 7474, 9),
(266189, NULL, 'PF08096', NULL, NULL, 'Bombolitin family', NULL, 'Bombolitin', NULL, NULL, 12545, 9),
(266190, NULL, 'PF09969', NULL, NULL, 'Uncharacterized conserved protein (DUF2203)', NULL, 'DUF2203', NULL, NULL, 17377, 9),
(266191, NULL, 'PF12368', NULL, NULL, 'Rhodanase C-terminal', NULL, 'Rhodanese_C', NULL, NULL, 20922, 9),
(266192, NULL, 'PF09982', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2219)', NULL, 'DUF2219', NULL, NULL, 17002, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(266193, NULL, 'PF06690', NULL, NULL, 'FeGP cofactor biosynthesis protein, methyltransferase HcgC', NULL, 'HcgC', NULL, NULL, 894, 9),
(266194, NULL, 'PF09302', NULL, NULL, 'XLF-Cernunnos, XRcc4-like factor, NHEJ component', NULL, 'XLF', NULL, NULL, 14421, 9),
(266195, NULL, 'PF04502', NULL, NULL, 'Saf4/Yju2 protein', NULL, 'Saf4_Yju2', NULL, NULL, 2664, 9),
(266196, NULL, 'PF03961', NULL, NULL, 'Flagellar Assembly Protein A beta solenoid domain', NULL, 'FapA', NULL, NULL, 35845, 9),
(266197, NULL, 'PF15434', NULL, NULL, 'Family 104', NULL, 'FAM104', NULL, NULL, 26826, 9),
(266198, NULL, 'PF14205', NULL, NULL, 'Cysteine-rich KTR', NULL, 'Cys_rich_KTR', NULL, NULL, 24300, 9),
(266199, NULL, 'PF00374', NULL, NULL, 'Nickel-dependent hydrogenase', NULL, 'NiFeSe_Hases', NULL, NULL, 6305, 9),
(266200, NULL, 'PF08227', NULL, NULL, 'DASH complex subunit Hsk3 like', NULL, 'DASH_Hsk3', NULL, NULL, 17191, 9),
(266201, NULL, 'PF13879', NULL, NULL, 'Hemingway/CFA97', NULL, 'Hmw_CFAP97', NULL, NULL, 26580, 9),
(266202, NULL, 'PF10563', NULL, NULL, 'Delta carbonic anhydrase', NULL, 'CA_like', NULL, NULL, 20870, 9),
(266203, NULL, 'PF12837', NULL, NULL, '4Fe-4S binding domain', NULL, 'Fer4_6', NULL, NULL, 12567, 9),
(266204, NULL, 'PF15186', NULL, NULL, 'Testis-expressed sequence 13 protein family', NULL, 'TEX13', NULL, NULL, 22413, 9),
(266205, NULL, 'PF02753', NULL, NULL, 'Pili assembly chaperone PapD, C-terminal domain', NULL, 'PapD_C', NULL, NULL, 11001, 9),
(266206, NULL, 'PF13549', NULL, NULL, 'ATP-grasp domain', NULL, 'ATP-grasp_5', NULL, NULL, NULL, 9),
(266207, NULL, 'PF20215', NULL, NULL, 'Family of unknown function (DUF6575)', NULL, 'DUF6575', NULL, NULL, 37582, 9),
(266208, NULL, 'PF16838', NULL, NULL, 'Caudoviral major tail protein N-terminus', NULL, 'Caud_tail_N', NULL, NULL, 26344, 9),
(266209, NULL, 'PF09004', NULL, NULL, 'Alkylated DNA repair protein alkB homolog 8, N-terminal', NULL, 'ALKBH8_N', NULL, NULL, 8863, 9),
(266210, NULL, 'PF11148', NULL, NULL, 'Protein of unknown function (DUF2922)', NULL, 'DUF2922', NULL, NULL, 17518, 9),
(266211, NULL, 'PF17665', NULL, NULL, 'Family of unknown function (DUF5527)', NULL, 'DUF5527', NULL, NULL, 31079, 9),
(266212, NULL, 'PF03067', NULL, NULL, 'Lytic polysaccharide mono-oxygenase, cellulose-degrading', NULL, 'LPMO_10', NULL, NULL, 4680, 9),
(266213, NULL, 'PF11145', NULL, NULL, 'Protein of unknown function (DUF2921)', NULL, 'DUF2921', NULL, NULL, 17896, 9),
(266214, NULL, 'PF07201', NULL, NULL, 'HrpJ-like domain', NULL, 'HrpJ', NULL, NULL, 10674, 9),
(266215, NULL, 'PF12546', NULL, NULL, 'Blue/Ultraviolet sensing protein C terminal', NULL, 'Cryptochrome_C', NULL, NULL, 14748, 9),
(266216, NULL, 'PF18269', NULL, NULL, 'T3SS EscN ATPase C-terminal domain', NULL, 'T3SS_ATPase_C', NULL, NULL, 27957, 9),
(266217, NULL, 'PF14610', NULL, NULL, 'Ykl077w/Psg1 (Pma1 Stabilization in Golgi)', NULL, 'Psg1', NULL, NULL, 23996, 9),
(266218, NULL, 'PF15865', NULL, NULL, 'Fanconi anaemia group A protein N terminus', NULL, 'Fanconi_A_N', NULL, NULL, 24278, 9),
(266219, NULL, 'PF02727', NULL, NULL, 'Copper amine oxidase, N2 domain', NULL, 'Cu_amine_oxidN2', NULL, NULL, 12909, 9),
(266220, NULL, 'PF10673', NULL, NULL, 'Protein of unknown function (DUF2487)', NULL, 'DUF2487', NULL, NULL, 20295, 9),
(266221, NULL, 'PF13112', NULL, NULL, 'Protein of unknown function (DUF3965)', NULL, 'DUF3965', NULL, NULL, 22980, 9),
(266222, NULL, 'PF17295', NULL, NULL, 'Domain of unknown function (DUF5348)', NULL, 'DUF5348', NULL, NULL, 28324, 9),
(266223, NULL, 'PF00044', NULL, NULL, 'Glyceraldehyde 3-phosphate dehydrogenase, NAD binding domain', NULL, 'Gp_dh_N', NULL, NULL, 18716, 9),
(266224, NULL, 'PF13803', NULL, NULL, 'Domain of unknown function (DUF4184)', NULL, 'DUF4184', NULL, NULL, 23201, 9),
(266225, NULL, 'PF03633', NULL, NULL, 'Glycosyl hydrolase family 65, C-terminal domain', NULL, 'Glyco_hydro_65C', NULL, NULL, 6719, 9),
(266226, NULL, 'PF13975', NULL, NULL, 'gag-polyprotein putative aspartyl protease', NULL, 'gag-asp_proteas', NULL, NULL, NULL, 9),
(266227, NULL, 'PF18996', NULL, NULL, 'Family of unknown function (DUF5726)', NULL, 'DUF5726', NULL, NULL, 35053, 9);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(266228, NULL, 'PF19710', NULL, NULL, 'PIK3 catalytic subunit gamma adaptor-binding domain', NULL, 'PIK3CG_ABD', NULL, NULL, 36012, 9),
(266229, NULL, 'PF03003', NULL, NULL, 'Pox virus entry-fusion-complex G9/A16', NULL, 'Pox_G9-A16', NULL, NULL, 3842, 9),
(266230, NULL, 'PF08395', NULL, NULL, '7tm Chemosensory receptor', NULL, '7tm_7', NULL, NULL, 11023, 9),
(266231, NULL, 'PF18749', NULL, NULL, 'Secreted Novel AID/APOBEC-like Deaminase 3', NULL, 'SNAD3', NULL, NULL, 29462, 9),
(266232, NULL, 'PF16103', NULL, NULL, 'Domain of unknown function (DUF4822)', NULL, 'DUF4822', NULL, NULL, 23070, 9),
(266233, NULL, 'PF14491', NULL, NULL, 'Protein of unknown function (DUF4435)', NULL, 'DUF4435', NULL, NULL, 23425, 9),
(266234, NULL, 'PF04964', NULL, NULL, 'Flp/Fap pilin component', NULL, 'Flp_Fap', NULL, NULL, 6910, 9),
(266235, NULL, 'PF20250', NULL, NULL, 'Flagellar Assembly Protein A N-terminal region', NULL, 'FapA_N', NULL, NULL, 37598, 9),
(266236, NULL, 'PF20420', NULL, NULL, 'Domain of unknown function (DUF6702)', NULL, 'DUF6702', NULL, NULL, 37647, 9),
(266237, NULL, 'PF09767', NULL, NULL, 'Predicted membrane protein (DUF2053)', NULL, 'DUF2053', NULL, NULL, 18212, 9),
(266238, NULL, 'PF16751', NULL, NULL, 'Anti-sigma-D factor RsdA to sigma factor binding region', NULL, 'RsdA_SigD_bd', NULL, NULL, 26293, 9),
(266239, NULL, 'PF17469', NULL, NULL, 'Gp68-like predicted RNA polymerase component', NULL, 'GP68', NULL, NULL, 19000, 9),
(266240, NULL, 'PF08442', NULL, NULL, 'ATP-grasp domain', NULL, 'ATP-grasp_2', NULL, NULL, 11519, 9),
(266241, NULL, 'PF20601', NULL, NULL, 'Domain of unknown function (DUF6797)', NULL, 'DUF6797', NULL, NULL, 37680, 9),
(266242, NULL, 'PF11951', NULL, NULL, 'Fungal specific transcription factor domain', NULL, 'Fungal_trans_2', NULL, NULL, 19912, 9),
(266243, NULL, 'PF05612', NULL, NULL, 'Leg1', NULL, 'Leg1', NULL, NULL, 12105, 9),
(266244, NULL, 'PF05028', NULL, NULL, 'Poly (ADP-ribose) glycohydrolase (PARG)', NULL, 'PARG_cat', NULL, NULL, 36891, 9),
(266245, NULL, 'PF12860', NULL, NULL, 'PAS fold', NULL, 'PAS_7', NULL, NULL, NULL, 9),
(266246, NULL, 'PF02074', NULL, NULL, 'Carboxypeptidase Taq (M32) metallopeptidase', NULL, 'Peptidase_M32', NULL, NULL, 438, 9),
(266247, NULL, 'PF04496', NULL, NULL, 'Herpesvirus UL35 family', NULL, 'Herpes_UL35', NULL, NULL, 2530, 9),
(266248, NULL, 'PF03281', NULL, NULL, 'Mab-21 protein nucleotidyltransferase domain', NULL, 'Mab-21', NULL, NULL, 33797, 9),
(266249, NULL, 'PF08526', NULL, NULL, 'Protein-arginine deiminase (PAD) N-terminal domain', NULL, 'PAD_N', NULL, NULL, 7862, 9),
(266250, NULL, 'PF11165', NULL, NULL, 'Protein of unknown function (DUF2949)', NULL, 'DUF2949', NULL, NULL, 18081, 9),
(266251, NULL, 'PF09991', NULL, NULL, 'Predicted membrane protein (DUF2232)', NULL, 'DUF2232', NULL, NULL, 17249, 9),
(266252, NULL, 'PF00536', NULL, NULL, 'SAM domain (Sterile alpha motif)', NULL, 'SAM_1', NULL, NULL, 5007, 9),
(266253, NULL, 'PF19955', NULL, NULL, 'Effector-associated domain 1', NULL, 'EAD1', NULL, NULL, 35987, 9),
(266254, NULL, 'PF00801', NULL, NULL, 'PKD domain', NULL, 'PKD', NULL, NULL, 5730, 9),
(266255, NULL, 'PF08310', NULL, NULL, 'LGFP repeat', NULL, 'LGFP', NULL, NULL, 17226, 9),
(266256, NULL, 'PF13058', NULL, NULL, 'Protein of unknown function (DUF3920)', NULL, 'DUF3920', NULL, NULL, 22692, 9),
(266257, NULL, 'PF14931', NULL, NULL, 'Intraflagellar transport complex B, subunit 20', NULL, 'IFT20', NULL, NULL, 24511, 9),
(266258, NULL, 'PF13669', NULL, NULL, 'Glyoxalase/Bleomycin resistance protein/Dioxygenase superfamily', NULL, 'Glyoxalase_4', NULL, NULL, NULL, 9),
(266259, NULL, 'PF20025', NULL, NULL, 'Family of unknown function (DUF6433)', NULL, 'DUF6433', NULL, NULL, 35755, 9),
(266260, NULL, 'PF02086', NULL, NULL, 'D12 class N6 adenine-specific DNA methyltransferase', NULL, 'MethyltransfD12', NULL, NULL, 11638, 9),
(266261, NULL, 'PF08641', NULL, NULL, 'Kinetochore protein Mis14 like', NULL, 'Mis14', NULL, NULL, 7741, 9),
(266262, NULL, 'PF16226', NULL, NULL, 'Domain of unknown function (DUF4885)', NULL, 'DUF4885', NULL, NULL, 26303, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(266263, NULL, 'PF03341', NULL, NULL, 'Poxvirus mRNA capping enzyme, small subunit', NULL, 'Pox_mRNA-cap', NULL, NULL, 762, 9),
(266264, NULL, 'PF09902', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2129)', NULL, 'DUF2129', NULL, NULL, 17645, 9),
(266265, NULL, 'PF06817', NULL, NULL, 'Reverse transcriptase thumb domain', NULL, 'RVT_thumb', NULL, NULL, 9294, 9),
(266266, NULL, 'PF08268', NULL, NULL, 'F-box associated domain', NULL, 'FBA_3', NULL, NULL, 17066, 9),
(266267, NULL, 'PF00950', NULL, NULL, 'ABC 3 transport family', NULL, 'ABC-3', NULL, NULL, 3115, 9),
(266268, NULL, 'PF08281', NULL, NULL, 'Sigma-70, region 4', NULL, 'Sigma70_r4_2', NULL, NULL, 13402, 9),
(266269, NULL, 'PF18333', NULL, NULL, 'Non-canonical single-stranded DNA-binding domain', NULL, 'ssDNA_DBD', NULL, NULL, NULL, 9),
(266270, NULL, 'PF02962', NULL, NULL, '5-carboxymethyl-2-hydroxymuconate isomerase', NULL, 'CHMI', NULL, NULL, 3966, 9),
(266271, NULL, 'PF10867', NULL, NULL, 'Protein of unknown function (DUF2664)', NULL, 'DUF2664', NULL, NULL, 16844, 9),
(266272, NULL, 'PF14832', NULL, NULL, 'Putative oxalocrotonate tautomerase enzyme', NULL, 'Tautomerase_3', NULL, NULL, 24986, 9),
(266273, NULL, 'PF11539', NULL, NULL, 'Protein of unknown function (DUF3228)', NULL, 'DUF3228', NULL, NULL, 18681, 9),
(266274, NULL, 'PF02410', NULL, NULL, 'Ribosomal silencing factor during starvation', NULL, 'RsfS', NULL, NULL, NULL, 9),
(266275, NULL, 'PF04851', NULL, NULL, 'Type III restriction enzyme, res subunit', NULL, 'ResIII', NULL, NULL, 5773, 9),
(266276, NULL, 'PF00840', NULL, NULL, 'Glycosyl hydrolase family 7', NULL, 'Glyco_hydro_7', NULL, NULL, 3402, 9),
(266277, NULL, 'PF09483', NULL, NULL, 'Type III secretion protein (HpaP)', NULL, 'HpaP', NULL, NULL, 11029, 9),
(266278, NULL, 'PF02372', NULL, NULL, 'Interleukin 15', NULL, 'IL15', NULL, NULL, 5235, 9),
(266279, NULL, 'PF17908', NULL, NULL, 'APAF-1 helical domain', NULL, 'APAF1_C', NULL, NULL, 30435, 9),
(266280, NULL, 'PF08356', NULL, NULL, 'EF hand associated', NULL, 'EF_assoc_2', NULL, NULL, 12780, 9),
(266281, NULL, 'PF17740', NULL, NULL, 'Family of unknown function (DUF5577)', NULL, 'DUF5577', NULL, NULL, 30297, 9),
(266282, NULL, 'PF03100', NULL, NULL, 'CcmE', NULL, 'CcmE', NULL, NULL, 4950, 9),
(266283, NULL, 'PF14475', NULL, NULL, 'Sec1-binding region of Mso1', NULL, 'Mso1_Sec1_bdg', NULL, NULL, 26064, 9),
(266284, NULL, 'PF02278', NULL, NULL, 'Polysaccharide lyase family 8, super-sandwich domain', NULL, 'Lyase_8', NULL, NULL, 1860, 9),
(266285, NULL, 'PF16434', NULL, NULL, 'Domain of unknown function (DUF5031)', NULL, 'DUF5031', NULL, NULL, 24173, 9),
(266286, NULL, 'PF19828', NULL, NULL, 'Family of unknown function (DUF6309)', NULL, 'DUF6309', NULL, NULL, 37630, 9),
(266287, NULL, 'PF20438', NULL, NULL, 'Stage IV sporulation protein A, middle domain', NULL, 'SpoIVA_middle', NULL, NULL, 33916, 9),
(266288, NULL, 'PF14088', NULL, NULL, 'Domain of unknown function (DUF4268)', NULL, 'DUF4268', NULL, NULL, 22669, 9),
(266289, NULL, 'PF14262', NULL, NULL, 'Carbohydrate-binding domain-containing protein Cthe_2159', NULL, 'Cthe_2159', NULL, NULL, 26324, 9),
(266290, NULL, 'PF09536', NULL, NULL, 'Protein of unknown function (DUF2378)', NULL, 'DUF2378', NULL, NULL, 11870, 9),
(266291, NULL, 'PF13462', NULL, NULL, 'Thioredoxin', NULL, 'Thioredoxin_4', NULL, NULL, 7704, 9),
(266292, NULL, 'PF16498', NULL, NULL, 'SWIRM-associated domain at the C-terminal', NULL, 'SWIRM-assoc_3', NULL, NULL, 24067, 9),
(266293, NULL, 'PF05183', NULL, NULL, 'RNA dependent RNA polymerase', NULL, 'RdRP', NULL, NULL, 2352, 9),
(266294, NULL, 'PF14059', NULL, NULL, 'Domain of unknown function (DUF4251)', NULL, 'DUF4251', NULL, NULL, 22650, 9),
(266295, NULL, 'PF05208', NULL, NULL, 'ALG3 protein', NULL, 'ALG3', NULL, NULL, 3271, 9),
(266296, NULL, 'PF03256', NULL, NULL, 'Anaphase-promoting complex, subunit 10 (APC10)', NULL, 'ANAPC10', NULL, NULL, 1898, 9),
(266297, NULL, 'PF05015', NULL, NULL, 'RelE-like toxin of type II toxin-antitoxin system HigB', NULL, 'HigB-like_toxin', NULL, NULL, 1009, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(266298, NULL, 'PF12474', NULL, NULL, 'Polo kinase kinase', NULL, 'PKK', NULL, NULL, 20631, 9),
(266299, NULL, 'PF18046', NULL, NULL, 'FKBP26_C-terminal', NULL, 'FKBP26_C', NULL, NULL, 32038, 9),
(266300, NULL, 'PF06061', NULL, NULL, 'Baculoviridae ME53', NULL, 'Baculo_ME53', NULL, NULL, 8663, 9),
(266301, NULL, 'PF07867', NULL, NULL, 'Protein of unknown function (DUF1654)', NULL, 'DUF1654', NULL, NULL, 14280, 9),
(266302, NULL, 'PF12286', NULL, NULL, 'Protein of unknown function (DUF3622)', NULL, 'DUF3622', NULL, NULL, 20517, 9),
(266303, NULL, 'PF03210', NULL, NULL, 'Paramyxovirus P/V phosphoprotein C-terminal', NULL, 'Paramyx_P_V_C', NULL, NULL, 295, 9),
(266304, NULL, 'PF09840', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2067)', NULL, 'DUF2067', NULL, NULL, 19424, 9),
(266305, NULL, 'PF14372', NULL, NULL, 'Domain of unknown function (DUF4413)', NULL, 'DUF4413', NULL, NULL, 26065, 9),
(266306, NULL, 'PF20363', NULL, NULL, 'Family of unknown function (DUF6658)', NULL, 'DUF6658', NULL, NULL, 33530, 9),
(266307, NULL, 'PF11041', NULL, NULL, 'Protein of unknown function (DUF2612)', NULL, 'DUF2612', NULL, NULL, 17970, 9),
(266308, NULL, 'PF04535', NULL, NULL, 'Casparian strip membrane protein domain', NULL, 'CASP_dom', NULL, NULL, 2489, 9),
(266309, NULL, 'PF00216', NULL, NULL, 'Bacterial DNA-binding protein', NULL, 'Bac_DNA_binding', NULL, NULL, 1984, 9),
(266310, NULL, 'PF05696', NULL, NULL, 'Protein of unknown function (DUF826)', NULL, 'DUF826', NULL, NULL, 13375, 9),
(266311, NULL, 'PF15952', NULL, NULL, 'Enhancer of split M4 family', NULL, 'ESM4', NULL, NULL, 24239, 9),
(266312, NULL, 'PF15674', NULL, NULL, 'Coiled-coil domain-containing protein 23', NULL, 'CCDC23', NULL, NULL, 25568, 9),
(266313, NULL, 'PF06657', NULL, NULL, 'Centrosome microtubule-binding domain of Cep57', NULL, 'Cep57_MT_bd', NULL, NULL, 22240, 9),
(266314, NULL, 'PF06900', NULL, NULL, 'Protein of unknown function (DUF1270)', NULL, 'DUF1270', NULL, NULL, 11507, 9),
(266315, NULL, 'PF08273', NULL, NULL, 'Zinc-binding domain of primase-helicase', NULL, 'Prim_Zn_Ribbon', NULL, NULL, 12901, 9),
(266316, NULL, 'PF08611', NULL, NULL, 'Fungal protein of unknown function (DUF1774)', NULL, 'DUF1774', NULL, NULL, 14406, 9),
(266317, NULL, 'PF05995', NULL, NULL, 'Cysteine dioxygenase type I', NULL, 'CDO_I', NULL, NULL, 7640, 9),
(266318, NULL, 'PF02325', NULL, NULL, 'YGGT family', NULL, 'YGGT', NULL, NULL, 5263, 9),
(266319, NULL, 'PF11703', NULL, NULL, 'UPF0506', NULL, 'UPF0506', NULL, NULL, 19492, 9),
(266320, NULL, 'PF15202', NULL, NULL, 'Adipogenin', NULL, 'Adipogenin', NULL, NULL, 24796, 9),
(266321, NULL, 'PF18002', NULL, NULL, 'T6 antigen Ig like domain', NULL, 'T6_Ig_like', NULL, NULL, 29155, 9),
(266322, NULL, 'PF14625', NULL, NULL, 'Lustrin, cysteine-rich repeated domain', NULL, 'Lustrin_cystein', NULL, NULL, 21943, 9),
(266323, NULL, 'PF15794', NULL, NULL, 'Coiled-coil domain-containing protein 106', NULL, 'CCDC106', NULL, NULL, 23832, 9),
(266324, NULL, 'PF01601', NULL, NULL, 'Coronavirus spike glycoprotein S2', NULL, 'CoV_S2', NULL, NULL, 1661, 9),
(266325, NULL, 'PF07027', NULL, NULL, 'Protein of unknown function (DUF1318)', NULL, 'DUF1318', NULL, NULL, 8878, 9),
(266326, NULL, 'PF01441', NULL, NULL, 'Lipoprotein', NULL, 'Lipoprotein_6', NULL, NULL, 4325, 9),
(266327, NULL, 'PF05121', NULL, NULL, 'Gas vesicle protein K', NULL, 'GvpK', NULL, NULL, 2092, 9),
(266328, NULL, 'PF06527', NULL, NULL, 'TniQ', NULL, 'TniQ', NULL, NULL, 9085, 9),
(266329, NULL, 'PF03328', NULL, NULL, 'HpcH/HpaI aldolase/citrate lyase family', NULL, 'HpcH_HpaI', NULL, NULL, 732, 9),
(266330, NULL, 'PF19718', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase 47 C-terminal', NULL, 'USP47_C', NULL, NULL, 37322, 9),
(266331, NULL, 'PF14591', NULL, NULL, 'AF0941-like', NULL, 'AF0941-like', NULL, NULL, 12556, 9),
(266332, NULL, 'PF02771', NULL, NULL, 'Acyl-CoA dehydrogenase, N-terminal domain', NULL, 'Acyl-CoA_dh_N', NULL, NULL, 11148, 9),
(266333, NULL, 'PF07327', NULL, NULL, 'Neuroparsin', NULL, 'Neuroparsin', NULL, NULL, 11801, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(266334, NULL, 'PF00806', NULL, NULL, 'Pumilio-family RNA binding repeat', NULL, 'PUF', NULL, NULL, 2315, 9),
(266335, NULL, 'PF08538', NULL, NULL, 'Protein of unknown function (DUF1749)', NULL, 'DUF1749', NULL, NULL, 7570, 9),
(266336, NULL, 'PF12347', NULL, NULL, 'Holliday junction regulator protein family C-terminal repeat', NULL, 'HJURP_C', NULL, NULL, 20658, 9),
(266337, NULL, 'PF07366', NULL, NULL, 'SnoaL-like polyketide cyclase', NULL, 'SnoaL', NULL, NULL, 8105, 9),
(266338, NULL, 'PF11850', NULL, NULL, 'Protein of unknown function (DUF3370)', NULL, 'DUF3370', NULL, NULL, 19314, 9),
(266339, NULL, 'PF02575', NULL, NULL, 'YbaB/EbfC DNA-binding family', NULL, 'YbaB_DNA_bd', NULL, NULL, 5991, 9),
(266340, NULL, 'PF16826', NULL, NULL, 'Domain of unknown function (DUF5076)', NULL, 'DUF5076', NULL, NULL, 25968, 9),
(266341, NULL, 'PF03538', NULL, NULL, 'Salmonella virulence plasmid 28.1kDa A protein', NULL, 'VRP1', NULL, NULL, 19086, 9),
(266342, NULL, 'PF19102', NULL, NULL, 'Family of unknown function (DUF5789)', NULL, 'DUF5789', NULL, NULL, 34082, 9),
(266343, NULL, 'PF01471', NULL, NULL, 'Putative peptidoglycan binding domain', NULL, 'PG_binding_1', NULL, NULL, 713, 9),
(266344, NULL, 'PF06799', NULL, NULL, 'Conserved in the green lineage and diatoms 27', NULL, 'CGLD27-like', NULL, NULL, 1853, 9),
(266345, NULL, 'PF11051', NULL, NULL, 'Mannosyltransferase putative', NULL, 'Mannosyl_trans3', NULL, NULL, 17093, 9),
(266346, NULL, 'PF10696', NULL, NULL, 'Protein of unknown function (DUF2501)', NULL, 'DUF2501', NULL, NULL, 20608, 9),
(266347, NULL, 'PF07942', NULL, NULL, 'Carnosine N-methyltransferase', NULL, 'CARME', NULL, NULL, 13280, 9),
(266348, NULL, 'PF10380', NULL, NULL, 'Transcription factor CRF1', NULL, 'CRF1', NULL, NULL, 20067, 9),
(266349, NULL, 'PF05548', NULL, NULL, 'Gametolysin peptidase M11', NULL, 'Peptidase_M11', NULL, NULL, 12110, 9),
(266350, NULL, 'PF17617', NULL, NULL, 'Viral unique short region 10', NULL, 'US10', NULL, NULL, 28014, 9),
(266351, NULL, 'PF02513', NULL, NULL, 'Spin/Ssty Family', NULL, 'Spin-Ssty', NULL, NULL, 1073, 9),
(266352, NULL, 'PF05481', NULL, NULL, 'Mycobacterium 19 kDa lipoprotein antigen', NULL, 'Myco_19_kDa', NULL, NULL, 13384, 9),
(266353, NULL, 'PF20620', NULL, NULL, 'Family of unknown function (DUF6805)', NULL, 'DUF6805', NULL, NULL, 37736, 9),
(266354, NULL, 'PF10966', NULL, NULL, 'Protein of unknown function (DUF2768)', NULL, 'DUF2768', NULL, NULL, 12596, 9),
(266355, NULL, 'PF14239', NULL, NULL, 'RRXRR protein', NULL, 'RRXRR', NULL, NULL, 23182, 9),
(266356, NULL, 'PF08793', NULL, NULL, '2-cysteine adaptor domain', NULL, '2C_adapt', NULL, NULL, 13353, 9),
(266357, NULL, 'PF18489', NULL, NULL, 'Alpha helical domain', NULL, 'Alpha_Helical', NULL, NULL, 28958, 9),
(266358, NULL, 'PF14866', NULL, NULL, 'Potassium channel toxin', NULL, 'Toxin_38', NULL, NULL, 26891, 9),
(266359, NULL, 'PF20241', NULL, NULL, 'Domain of unknown function (DUF6598)', NULL, 'DUF6598', NULL, NULL, 37670, 9),
(266360, NULL, 'PF07677', NULL, NULL, 'A-macroglobulin receptor binding domain', NULL, 'A2M_recep', NULL, NULL, 12486, 9),
(266361, NULL, 'PF09958', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2192)', NULL, 'DUF2192', NULL, NULL, 17169, 9),
(266362, NULL, 'PF13261', NULL, NULL, 'Protein of unknown function (DUF4052)', NULL, 'DUF4052', NULL, NULL, 22790, 9),
(266363, NULL, 'PF04783', NULL, NULL, 'Protein of unknown function (DUF630)', NULL, 'DUF630', NULL, NULL, 4833, 9),
(266364, NULL, 'PF03548', NULL, NULL, 'Outer membrane lipoprotein carrier protein LolA', NULL, 'LolA', NULL, NULL, 617, 9),
(266365, NULL, 'PF13203', NULL, NULL, 'Putative metallopeptidase domain', NULL, 'DUF2201_N', NULL, NULL, 26284, 9),
(266366, NULL, 'PF10523', NULL, NULL, 'BEN domain', NULL, 'BEN', NULL, NULL, 20443, 9),
(266367, NULL, 'PF12208', NULL, NULL, 'Domain of unknown function (DUF3601)', NULL, 'DUF3601', NULL, NULL, 20029, 9),
(266368, NULL, 'PF16229', NULL, NULL, 'Domain of unknown function (DUF4888)', NULL, 'DUF4888', NULL, NULL, 26017, 9),
(266369, NULL, 'PF07691', NULL, NULL, 'PA14 domain', NULL, 'PA14', NULL, NULL, 10963, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(266370, NULL, 'PF13281', NULL, NULL, 'MAP3K TRAFs-binding domain', NULL, 'MAP3K_TRAF_bd', NULL, NULL, 22163, 9),
(266371, NULL, 'PF05140', NULL, NULL, 'ResB-like family', NULL, 'ResB', NULL, NULL, 2290, 9),
(266372, NULL, 'PF17800', NULL, NULL, 'Nucleoplasmin-like domain', NULL, 'NPL', NULL, NULL, 30423, 9),
(266373, NULL, 'PF17192', NULL, NULL, 'MukF middle domain', NULL, 'MukF_M', NULL, NULL, 31844, 9),
(266374, NULL, 'PF00008', NULL, NULL, 'EGF-like domain', NULL, 'EGF', NULL, NULL, 3525, 9),
(266375, NULL, 'PF11888', NULL, NULL, 'Protein of unknown function (DUF3408)', NULL, 'DUF3408', NULL, NULL, 19731, 9),
(266376, NULL, 'PF01783', NULL, NULL, 'Ribosomal L32p protein family', NULL, 'Ribosomal_L32p', NULL, NULL, 2512, 9),
(266377, NULL, 'PF02906', NULL, NULL, 'Iron only hydrogenase large subunit, C-terminal domain', NULL, 'Fe_hyd_lg_C', NULL, NULL, 1972, 9),
(266378, NULL, 'PF13430', NULL, NULL, 'Domain of unknown function (DUF4112)', NULL, 'DUF4112', NULL, NULL, 22932, 9),
(266379, NULL, 'PF08580', NULL, NULL, 'Yeast cortical protein KAR9', NULL, 'KAR9', NULL, NULL, 17777, 9),
(266380, NULL, 'PF11820', NULL, NULL, 'Protein of unknown function (DUF3339)', NULL, 'DUF3339', NULL, NULL, 19362, 9),
(266381, NULL, 'PF19825', NULL, NULL, 'Domain of unknown function (DUF6306)', NULL, 'DUF6306', NULL, NULL, 37100, 9),
(266382, NULL, 'PF15989', NULL, NULL, 'Domain of unknown function (DUF4768)', NULL, 'DUF4768', NULL, NULL, 25516, 9),
(266383, NULL, 'PF11751', NULL, NULL, 'Type IX secretion system membrane protein PorP/SprF', NULL, 'PorP_SprF', NULL, NULL, 16721, 9),
(266384, NULL, 'PF02887', NULL, NULL, 'Pyruvate kinase, alpha/beta domain', NULL, 'PK_C', NULL, NULL, 5551, 9),
(266385, NULL, 'PF05327', NULL, NULL, 'RNA polymerase I specific transcription initiation factor RRN3', NULL, 'RRN3', NULL, NULL, 4096, 9),
(266386, NULL, 'PF07077', NULL, NULL, 'Protein of unknown function (DUF1345)', NULL, 'DUF1345', NULL, NULL, 13454, 9),
(266387, NULL, 'PF20375', NULL, NULL, 'Family of unknown function (DUF6670)', NULL, 'DUF6670', NULL, NULL, 33648, 9),
(266388, NULL, 'PF00165', NULL, NULL, 'Bacterial regulatory helix-turn-helix proteins, AraC family', NULL, 'HTH_AraC', NULL, NULL, 13648, 9),
(266389, NULL, 'PF20560', NULL, NULL, 'Motility protein A N-terminal', NULL, 'MotA_N', NULL, NULL, 33982, 9),
(266390, NULL, 'PF05534', NULL, NULL, 'HicB family', NULL, 'HicB', NULL, NULL, 12638, 9),
(266391, NULL, 'PF05158', NULL, NULL, 'RNA polymerase Rpc34 subunit', NULL, 'RNA_pol_Rpc34', NULL, NULL, 2219, 9),
(266392, NULL, 'PF15140', NULL, NULL, 'Domain of unknown function (DUF4573)', NULL, 'DUF4573', NULL, NULL, 25976, 9),
(266393, NULL, 'PF18228', NULL, NULL, 'CdiI N-terminal domain', NULL, 'CdiI_N', NULL, NULL, 27911, 9),
(266394, NULL, 'PF00556', NULL, NULL, 'Antenna complex alpha/beta subunit', NULL, 'LHC', NULL, NULL, 2602, 9),
(266395, NULL, 'PF15019', NULL, NULL, 'C9orf72-like protein family', NULL, 'C9orf72-like', NULL, NULL, 22343, 9),
(266396, NULL, 'PF06224', NULL, NULL, 'Winged helix DNA-binding domain', NULL, 'HTH_42', NULL, NULL, 14094, 9),
(266397, NULL, 'PF18110', NULL, NULL, 'BRCC36 C-terminal helical domain', NULL, 'BRCC36_C', NULL, NULL, 28619, 9),
(266398, NULL, 'PF00351', NULL, NULL, 'Biopterin-dependent aromatic amino acid hydroxylase', NULL, 'Biopterin_H', NULL, NULL, 17063, 9),
(266399, NULL, 'PF02073', NULL, NULL, 'Thermophilic metalloprotease (M29)', NULL, 'Peptidase_M29', NULL, NULL, 4924, 9),
(266400, NULL, 'PF19515', NULL, NULL, 'Domain of unknown function (DUF6048)', NULL, 'DUF6048', NULL, NULL, 37101, 9),
(266401, NULL, 'PF03174', NULL, NULL, 'Chitobiase/beta-hexosaminidase C-terminal domain', NULL, 'CHB_HEX_C', NULL, NULL, 7093, 9),
(266402, NULL, 'PF10744', NULL, NULL, 'Mediator of RNA polymerase II transcription subunit 1', NULL, 'Med1', NULL, NULL, 19916, 9),
(266403, NULL, 'PF08905', NULL, NULL, 'Domain of unknown function (DUF1850)', NULL, 'DUF1850', NULL, NULL, 7991, 9),
(266404, NULL, 'PF19664', NULL, NULL, 'Family of unknown function (DUF6167)', NULL, 'DUF6167', NULL, NULL, 37110, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(266405, NULL, 'PF20360', NULL, NULL, 'Family of unknown function (DUF6655)', NULL, 'DUF6655', NULL, NULL, 33589, 9),
(266406, NULL, 'PF18580', NULL, NULL, 'SUN2 helix-turn-helix domain', NULL, 'HTH_SUN2', NULL, NULL, 28079, 9),
(266407, NULL, 'PF16979', NULL, NULL, 'SAPK-interacting protein 1 (Sin1), Pleckstrin-homology', NULL, 'SIN1_PH', NULL, NULL, 12774, 9),
(266408, NULL, 'PF06835', NULL, NULL, 'Lipopolysaccharide-assembly, LptC-related', NULL, 'LptC', NULL, NULL, 9373, 9),
(266409, NULL, 'PF12213', NULL, NULL, 'DNA polymerases epsilon N terminal', NULL, 'Dpoe2NT', NULL, NULL, 5801, 9),
(266410, NULL, 'PF08616', NULL, NULL, 'Stabilization of polarity axis', NULL, 'SPA', NULL, NULL, NULL, 9),
(266411, NULL, 'PF04521', NULL, NULL, 'ssRNA positive strand viral 18kD cysteine rich protein', NULL, 'Viral_P18', NULL, NULL, 2794, 9),
(266412, NULL, 'PF08848', NULL, NULL, 'Domain of unknown function (DUF1818)', NULL, 'DUF1818', NULL, NULL, 14016, 9),
(266413, NULL, 'PF10727', NULL, NULL, 'Rossmann-like domain', NULL, 'Rossmann-like', NULL, NULL, 20768, 9),
(266414, NULL, 'PF17336', NULL, NULL, 'Family of unknown function (DUF5368)', NULL, 'DUF5368', NULL, NULL, 32812, 9),
(266415, NULL, 'PF03838', NULL, NULL, 'Recombination protein U', NULL, 'RecU', NULL, NULL, 581, 9),
(266416, NULL, 'PF15105', NULL, NULL, 'TMEM61 protein family', NULL, 'TMEM61', NULL, NULL, 23595, 9),
(266417, NULL, 'PF17076', NULL, NULL, 'SBE2, cell-wall formation', NULL, 'SBE2', NULL, NULL, 23632, 9),
(266418, NULL, 'PF01722', NULL, NULL, 'BolA-like protein', NULL, 'BolA', NULL, NULL, 2652, 9),
(266419, NULL, 'PF01315', NULL, NULL, 'Aldehyde oxidase and xanthine dehydrogenase, a/b hammerhead domain', NULL, 'Ald_Xan_dh_C', NULL, NULL, 3645, 9),
(266420, NULL, 'PF19788', NULL, NULL, 'Family of unknown function (DUF6272)', NULL, 'DUF6272', NULL, NULL, 37117, 9),
(266421, NULL, 'PF03885', NULL, NULL, 'Protein of unknown function (DUF327)', NULL, 'DUF327', NULL, NULL, 1724, 9),
(266422, NULL, 'PF10336', NULL, NULL, 'Protein of unknown function (DUF2420)', NULL, 'DUF2420', NULL, NULL, 19704, 9),
(266423, NULL, 'PF12951', NULL, NULL, 'Passenger-associated-transport-repeat', NULL, 'PATR', NULL, NULL, 9349, 9),
(266424, NULL, 'PF11688', NULL, NULL, 'Protein of unknown function (DUF3285)', NULL, 'DUF3285', NULL, NULL, 19349, 9),
(266425, NULL, 'PF16711', NULL, NULL, 'Actin-binding domain of plant-specific actin-binding protein', NULL, 'SCAB-ABD', NULL, NULL, 24419, 9),
(266426, NULL, 'PF02357', NULL, NULL, 'Transcription termination factor nusG', NULL, 'NusG', NULL, NULL, 1494, 9),
(266427, NULL, 'PF09644', NULL, NULL, 'Mg296 protein', NULL, 'Mg296', NULL, NULL, 17964, 9),
(266428, NULL, 'PF10939', NULL, NULL, 'Protein of unknown function (DUF2631)', NULL, 'DUF2631', NULL, NULL, 26622, 9),
(266429, NULL, 'PF06959', NULL, NULL, 'RecQ helicase protein-like 5 (RecQ5)', NULL, 'RecQ5', NULL, NULL, 9838, 9),
(266430, NULL, 'PF05650', NULL, NULL, 'Domain of unknown function (DUF802)', NULL, 'DUF802', NULL, NULL, 13003, 9),
(266431, NULL, 'PF10926', NULL, NULL, 'Protein of unknown function (DUF2800)', NULL, 'DUF2800', NULL, NULL, 17967, 9),
(266432, NULL, 'PF18926', NULL, NULL, '2TM family of unknown function (DUF5676)', NULL, 'DUF5676', NULL, NULL, 34959, 9),
(266433, NULL, 'PF09612', NULL, NULL, 'Bacterial protein of unknown function (HtrL_YibB)', NULL, 'HtrL_YibB', NULL, NULL, 11911, 9),
(266434, NULL, 'PF02474', NULL, NULL, 'Nodulation protein A (NodA)', NULL, 'NodA', NULL, NULL, 6471, 9),
(266435, NULL, 'PF15479', NULL, NULL, 'Domain of unknown function (DUF4639)', NULL, 'DUF4639', NULL, NULL, 24642, 9),
(266436, NULL, 'PF02880', NULL, NULL, 'Phosphoglucomutase/phosphomannomutase, alpha/beta/alpha domain III', NULL, 'PGM_PMM_III', NULL, NULL, 5558, 9),
(266437, NULL, 'PF15233', NULL, NULL, 'Synaptonemal complex central element protein 1', NULL, 'SYCE1', NULL, NULL, 25876, 9),
(266438, NULL, 'PF14464', NULL, NULL, 'Prokaryotic homologs of the JAB domain', NULL, 'Prok-JAB', NULL, NULL, 26437, 9),
(266439, NULL, 'PF15540', NULL, NULL, 'Bacterial toxin 47', NULL, 'Ntox47', NULL, NULL, 25147, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(266440, NULL, 'PF09924', NULL, NULL, 'Phosphatidylglycerol lysyltransferase, C-terminal', NULL, 'LPG_synthase_C', NULL, NULL, 26695, 9),
(266441, NULL, 'PF13837', NULL, NULL, 'Myb/SANT-like DNA-binding domain', NULL, 'Myb_DNA-bind_4', NULL, NULL, 36363, 9),
(266442, NULL, 'PF04904', NULL, NULL, 'NAB conserved region 1 (NCD1)', NULL, 'NCD1', NULL, NULL, 5563, 9),
(266443, NULL, 'PF03915', NULL, NULL, 'Actin interacting protein 3', NULL, 'AIP3', NULL, NULL, 17254, 9),
(266444, NULL, 'PF12815', NULL, NULL, 'Spt5 C-terminal nonapeptide repeat binding Spt4', NULL, 'CTD', NULL, NULL, NULL, 9),
(266445, NULL, 'PF07964', NULL, NULL, 'Rec10 / Red1', NULL, 'Red1', NULL, NULL, 12810, 9),
(266446, NULL, 'PF13650', NULL, NULL, 'Aspartyl protease', NULL, 'Asp_protease_2', NULL, NULL, NULL, 9),
(266447, NULL, 'PF02689', NULL, NULL, 'Helicase', NULL, 'Herpes_Helicase', NULL, NULL, 3060, 9),
(266448, NULL, 'PF01020', NULL, NULL, 'Ribosomal L40e family', NULL, 'Ribosomal_L40e', NULL, NULL, 4452, 9),
(266449, NULL, 'PF11310', NULL, NULL, 'Protein of unknown function (DUF3113)', NULL, 'DUF3113', NULL, NULL, 18139, 9),
(266450, NULL, 'PF16466', NULL, NULL, 'Domain of unknown function (DUF5047)', NULL, 'DUF5047', NULL, NULL, 7844, 9),
(266451, NULL, 'PF06415', NULL, NULL, 'BPG-independent PGAM N-terminus (iPGM_N)', NULL, 'iPGM_N', NULL, NULL, 10335, 9),
(266452, NULL, 'PF09485', NULL, NULL, 'CRISPR-associated protein Cse2 (CRISPR_cse2)', NULL, 'CRISPR_Cse2', NULL, NULL, 11211, 9),
(266453, NULL, 'PF09514', NULL, NULL, 'SSXRD motif', NULL, 'SSXRD', NULL, NULL, 15879, 9),
(266454, NULL, 'PF11212', NULL, NULL, 'Protein of unknown function (DUF2999)', NULL, 'DUF2999', NULL, NULL, 18422, 9),
(266455, NULL, 'PF01922', NULL, NULL, 'SRP19 protein', NULL, 'SRP19', NULL, NULL, 4664, 9),
(266456, NULL, 'PF02736', NULL, NULL, 'Myosin N-terminal SH3-like domain', NULL, 'Myosin_N', NULL, NULL, 511, 9),
(266457, NULL, 'PF19360', NULL, NULL, 'TadB/TadC N-terminal domain', NULL, 'TadB_TadC_N', NULL, NULL, 36456, 9),
(266458, NULL, 'PF01132', NULL, NULL, 'Elongation factor P (EF-P) OB domain', NULL, 'EFP', NULL, NULL, 2162, 9),
(266459, NULL, 'PF03052', NULL, NULL, 'Adenoviral protein L1 52/55-kDa', NULL, 'Adeno_52K', NULL, NULL, 4577, 9),
(266460, NULL, 'PF14434', NULL, NULL, 'Immunity protein Imm6', NULL, 'Imm6', NULL, NULL, 24902, 9),
(266461, NULL, 'PF12585', NULL, NULL, 'Protein of unknown function (DUF3759)', NULL, 'DUF3759', NULL, NULL, 21072, 9),
(266462, NULL, 'PF16297', NULL, NULL, 'Domain of unknown function (DUF4939)', NULL, 'DUF4939', NULL, NULL, 25893, 9),
(266463, NULL, 'PF19722', NULL, NULL, 'Sentrin-specific protease 3/5 N-terminal', NULL, 'SENP3_5_N', NULL, NULL, 36385, 9),
(266464, NULL, 'PF19088', NULL, NULL, 'TUTase nucleotidyltransferase domain', NULL, 'TUTase', NULL, NULL, 35847, 9),
(266465, NULL, 'PF09424', NULL, NULL, 'Yqey-like protein', NULL, 'YqeY', NULL, NULL, 15650, 9),
(266466, NULL, 'PF09265', NULL, NULL, 'Cytokinin dehydrogenase 1, FAD and cytokinin binding', NULL, 'Cytokin-bind', NULL, NULL, 13089, 9),
(266467, NULL, 'PF01029', NULL, NULL, 'NusB family', NULL, 'NusB', NULL, NULL, 1118, 9),
(266468, NULL, 'PF12407', NULL, NULL, 'Homeobox protein', NULL, 'Abdominal-A', NULL, NULL, 20727, 9),
(266469, NULL, 'PF14117', NULL, NULL, 'Domain of unknown function (DUF4287)', NULL, 'DUF4287', NULL, NULL, 24919, 9),
(266470, NULL, 'PF04924', NULL, NULL, 'Poxvirus A6 protein', NULL, 'Pox_A6', NULL, NULL, 6944, 9),
(266471, NULL, 'PF14303', NULL, NULL, 'No apical meristem-associated C-terminal domain', NULL, 'NAM-associated', NULL, NULL, 26597, 9),
(266472, NULL, 'PF17299', NULL, NULL, 'Family of unknown function (DUF5350)', NULL, 'DUF5350', NULL, NULL, 28162, 9),
(266473, NULL, 'PF05293', NULL, NULL, 'African swine fever virus (ASFV) L11L protein', NULL, 'ASFV_L11L', NULL, NULL, 4262, 9),
(266474, NULL, 'PF14653', NULL, NULL, 'Insulin growth factor-like family', NULL, 'IGFL', NULL, NULL, 21512, 9),
(266475, NULL, 'PF17337', NULL, NULL, 'Galactose-inhibitable lectin 35 kDa subunit', NULL, 'Gal_GalNac_35kD', NULL, NULL, 32626, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(266476, NULL, 'PF03399', NULL, NULL, 'SAC3/GANP family', NULL, 'SAC3_GANP', NULL, NULL, 2081, 9),
(266477, NULL, 'PF12204', NULL, NULL, 'Domain of unknown function (DUF3598)', NULL, 'DUF3598', NULL, NULL, 20149, 9),
(266478, NULL, 'PF16534', NULL, NULL, 'Ubiquitin-like oligomerisation domain of SATB', NULL, 'ULD', NULL, NULL, 24421, 9),
(266479, NULL, 'PF13207', NULL, NULL, 'AAA domain', NULL, 'AAA_17', NULL, NULL, NULL, 9),
(266480, NULL, 'PF10692', NULL, NULL, 'Protein of unknown function (DUF2498)', NULL, 'DUF2498', NULL, NULL, 20533, 9),
(266481, NULL, 'PF01659', NULL, NULL, 'Luteovirus putative VPg genome linked protein', NULL, 'Luteo_Vpg', NULL, NULL, 4384, 9),
(266482, NULL, 'PF19661', NULL, NULL, 'Family of unknown function (DUF6164)', NULL, 'DUF6164', NULL, NULL, 37452, 9),
(266483, NULL, 'PF00599', NULL, NULL, 'Influenza Matrix protein (M2)', NULL, 'Flu_M2', NULL, NULL, 1449, 9),
(266484, NULL, 'PF13698', NULL, NULL, 'Domain of unknown function (DUF4156)', NULL, 'DUF4156', NULL, NULL, 23202, 9),
(266485, NULL, 'PF16612', NULL, NULL, 'C-terminal unstructured region of RGS12', NULL, 'RGS12_usC', NULL, NULL, NULL, 9),
(266486, NULL, 'PF18995', NULL, NULL, 'Proteolysis_6 C-terminal', NULL, 'PRT6_C', NULL, NULL, 35795, 9),
(266487, NULL, 'PF04808', NULL, NULL, 'Citrus tristeza virus (CTV) P23 protein', NULL, 'CTV_P23', NULL, NULL, 4877, 9),
(266488, NULL, 'PF04194', NULL, NULL, 'Programmed cell death protein 2, C-terminal putative domain', NULL, 'PDCD2_C', NULL, NULL, 4506, 9),
(266489, NULL, 'PF12566', NULL, NULL, 'Protein of unknown function (DUF3748)', NULL, 'DUF3748', NULL, NULL, 21390, 9),
(266490, NULL, 'PF12897', NULL, NULL, 'Aspartate amino-transferase', NULL, 'Asp_aminotransf', NULL, NULL, 26503, 9),
(266491, NULL, 'PF09037', NULL, NULL, 'Stf0 sulphotransferase', NULL, 'Sulphotransf', NULL, NULL, 3887, 9),
(266492, NULL, 'PF01872', NULL, NULL, 'RibD C-terminal domain', NULL, 'RibD_C', NULL, NULL, 3745, 9),
(266493, NULL, 'PF05068', NULL, NULL, 'Mannitol repressor', NULL, 'MtlR', NULL, NULL, 1326, 9),
(266494, NULL, 'PF03850', NULL, NULL, 'Transcription factor Tfb4', NULL, 'Tfb4', NULL, NULL, 922, 9),
(266495, NULL, 'PF01218', NULL, NULL, 'Coproporphyrinogen III oxidase', NULL, 'Coprogen_oxidas', NULL, NULL, 2460, 9),
(266496, NULL, 'PF04972', NULL, NULL, 'BON domain', NULL, 'BON', NULL, NULL, 6630, 9),
(266497, NULL, 'PF07541', NULL, NULL, 'Eukaryotic translation initiation factor 2 alpha subunit', NULL, 'EIF_2_alpha', NULL, NULL, 12620, 9),
(266498, NULL, 'PF11287', NULL, NULL, 'Protein of unknown function (DUF3088)', NULL, 'DUF3088', NULL, NULL, 18169, 9),
(266499, NULL, 'PF06422', NULL, NULL, 'CDR ABC transporter', NULL, 'PDR_CDR', NULL, NULL, 7548, 9),
(266500, NULL, 'PF14723', NULL, NULL, 'Sperm-specific antigen 2 C-terminus', NULL, 'SSFA2_C', NULL, NULL, 21929, 9),
(266501, NULL, 'PF16207', NULL, NULL, 'RAWUL domain RING finger- and  WD40-associated ubiquitin-like', NULL, 'RAWUL', NULL, NULL, 23755, 9),
(266502, NULL, 'PF14198', NULL, NULL, 'Transposon-encoded protein TnpV', NULL, 'TnpV', NULL, NULL, 25775, 9),
(266503, NULL, 'PF16291', NULL, NULL, 'Domain of unknown function (DUF4937', NULL, 'DUF4937', NULL, NULL, 21850, 9),
(266504, NULL, 'PF08430', NULL, NULL, 'Forkhead N-terminal region', NULL, 'Forkhead_N', NULL, NULL, 12501, 9),
(266505, NULL, 'PF18923', NULL, NULL, 'Domain of unknown function (DUF5673)', NULL, 'DUF5673', NULL, NULL, 35760, 9),
(266506, NULL, 'PF10702', NULL, NULL, 'Protein of unknown function (DUF2507)', NULL, 'DUF2507', NULL, NULL, 20912, 9),
(266507, NULL, 'PF15765', NULL, NULL, 'Domain of unknown function (DUF4694)', NULL, 'DUF4694', NULL, NULL, 26970, 9),
(266508, NULL, 'PF00674', NULL, NULL, 'DUP family', NULL, 'DUP', NULL, NULL, 2294, 9),
(266509, NULL, 'PF14187', NULL, NULL, 'Domain of unknown function (DUF4310)', NULL, 'DUF4310', NULL, NULL, 26201, 9),
(266510, NULL, 'PF00792', NULL, NULL, 'Phosphoinositide 3-kinase C2', NULL, 'PI3K_C2', NULL, NULL, 2903, 9),
(266511, NULL, 'PF07346', NULL, NULL, 'Protein of unknown function (DUF1477)', NULL, 'DUF1477', NULL, NULL, 8001, 9); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(266512, NULL, 'PF04448', NULL, NULL, 'Protein of unknown function (DUF551)', NULL, 'DUF551', NULL, NULL, 10567, 9),
(266513, NULL, 'PF07762', NULL, NULL, 'Protein of unknown function (DUF1618)', NULL, 'DUF1618', NULL, NULL, 10652, 9),
(266514, NULL, 'PF10453', NULL, NULL, 'Nuclear fragile X mental retardation-interacting protein 1 (NUFIP1)', NULL, 'NUFIP1', NULL, NULL, 18032, 9),
(266515, NULL, 'PF07671', NULL, NULL, 'Protein of unknown function (DUF1601)', NULL, 'DUF1601', NULL, NULL, 10505, 9),
(266516, NULL, 'PF09598', NULL, NULL, 'Stm1', NULL, 'Stm1_N', NULL, NULL, 16772, 9),
(266517, NULL, 'PF15338', NULL, NULL, 'p53-regulated apoptosis-inducing protein 1', NULL, 'TPIP1', NULL, NULL, 26002, 9),
(266518, NULL, 'PF19116', NULL, NULL, 'Domain of unknown function (DUF5801)', NULL, 'DUF5801', NULL, NULL, 35541, 9),
(266519, NULL, 'PF20488', NULL, NULL, 'Birnavirus RNA dependent RNA polymerase (VP1), thumb domain', NULL, 'Birna_VP1_thumb', NULL, NULL, 37711, 9),
(266520, NULL, 'PF05317', NULL, NULL, 'Thermopsin', NULL, 'Thermopsin', NULL, NULL, 4230, 9),
(266521, NULL, 'PF20469', NULL, NULL, 'Overcoming lysogenization defect protein-like, TOPRIM domain', NULL, 'OLD-like_TOPRIM', NULL, NULL, 27320, 9),
(266522, NULL, 'PF16050', NULL, NULL, 'Paf1 complex subunit CDC73 N-terminal', NULL, 'CDC73_N', NULL, NULL, 25843, 9),
(266523, NULL, 'PF04428', NULL, NULL, 'Choline kinase N terminus', NULL, 'Choline_kin_N', NULL, NULL, 10596, 9),
(266524, NULL, 'PF16223', NULL, NULL, 'Domain of unknown function (DUF4882)', NULL, 'DUF4882', NULL, NULL, 26274, 9),
(266525, NULL, 'PF06807', NULL, NULL, 'Pre-mRNA cleavage complex II protein Clp1', NULL, 'Clp1', NULL, NULL, 9456, 9),
(266526, NULL, 'PF07454', NULL, NULL, 'Stage II sporulation protein P (SpoIIP)', NULL, 'SpoIIP', NULL, NULL, 12117, 9),
(266527, NULL, 'PF05393', NULL, NULL, 'Human adenovirus early E3A glycoprotein', NULL, 'Hum_adeno_E3A', NULL, NULL, 12809, 9),
(266528, NULL, 'PF14272', NULL, NULL, 'Glycine-rich SFCGS', NULL, 'Gly_rich_SFCGS', NULL, NULL, 17710, 9),
(266529, NULL, 'PF04289', NULL, NULL, 'Protein of unknown function (DUF447)', NULL, 'DUF447', NULL, NULL, 6392, 9),
(266530, NULL, 'PF19963', NULL, NULL, 'vWA-MoxR associated protein middle region (VMAP-M) 1', NULL, 'VMAP-M1', NULL, NULL, 35931, 9),
(266531, NULL, 'PF15760', NULL, NULL, 'Leukemia-associated protein 7', NULL, 'DLEU7', NULL, NULL, 24602, 9),
(266532, NULL, 'PF16792', NULL, NULL, 'Phage tail base-plate attachment protein of Caudovirales ORF16', NULL, 'Caudo_bapla16', NULL, NULL, 26694, 9),
(266533, NULL, 'PF18845', NULL, NULL, 'Bacterial archaeo-eukaryotic release factor family 3', NULL, 'baeRF_family3', NULL, NULL, 29305, 9),
(266534, NULL, 'PF15161', NULL, NULL, 'Neuropeptide-like', NULL, 'Neuropep_like', NULL, NULL, 21599, 9),
(266535, NULL, 'PF15683', NULL, NULL, 'Testis development-related protein', NULL, 'TDRP', NULL, NULL, 25389, 9),
(266536, NULL, 'PF09550', NULL, NULL, 'Phage tail assembly chaperone protein, TAC', NULL, 'Phage_TAC_6', NULL, NULL, 16665, 9),
(266537, NULL, 'PF08673', NULL, NULL, 'Phosphoserine phosphatase RsbU, N-terminal domain', NULL, 'RsbU_N', NULL, NULL, 11190, 9),
(266538, NULL, 'PF19594', NULL, NULL, 'Family of unknown function (DUF6099)', NULL, 'DUF6099', NULL, NULL, 36733, 9),
(266539, NULL, 'PF00564', NULL, NULL, 'PB1 domain', NULL, 'PB1', NULL, NULL, 760, 9),
(266540, NULL, 'PF06378', NULL, NULL, 'Protein of unknown function (DUF1071)', NULL, 'DUF1071', NULL, NULL, 8200, 9),
(266541, NULL, 'PF09256', NULL, NULL, 'BAFF-R, TALL-1 binding', NULL, 'BaffR-Tall_bind', NULL, NULL, 13292, 9),
(266542, NULL, 'PF07514', NULL, NULL, 'Putative helicase', NULL, 'TraI_2', NULL, NULL, 11150, 9),
(266543, NULL, 'PF20494', NULL, NULL, 'Lipoprotein YfjS/YafY domain', NULL, 'YfjS_YafY', NULL, NULL, 35840, 9),
(266544, NULL, 'PF17368', NULL, NULL, 'Spore morphogenesis and germination YwcE', NULL, 'YwcE', NULL, NULL, 17895, 9),
(266545, NULL, 'PF02321', NULL, NULL, 'Outer membrane efflux protein', NULL, 'OEP', NULL, NULL, 5142, 9),
(266546, NULL, 'PF06404', NULL, NULL, 'Phytosulfokine precursor protein (PSK)', NULL, 'PSK', NULL, NULL, 8334, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(266547, NULL, 'PF19475', NULL, NULL, 'Family of unknown function (DUF6012)', NULL, 'DUF6012', NULL, NULL, 36501, 9),
(266548, NULL, 'PF17380', NULL, NULL, 'Family of unknown function (DUF5401)', NULL, 'DUF5401', NULL, NULL, NULL, 9),
(266549, NULL, 'PF13604', NULL, NULL, 'AAA domain', NULL, 'AAA_30', NULL, NULL, NULL, 9),
(266550, NULL, 'PF12846', NULL, NULL, 'AAA-like domain', NULL, 'AAA_10', NULL, NULL, NULL, 9),
(266551, NULL, 'PF09899', NULL, NULL, 'Putative amidoligase enzyme (DUF2126)', NULL, 'DUF2126', NULL, NULL, 16530, 9),
(266552, NULL, 'PF05839', NULL, NULL, 'Apc13p protein', NULL, 'Apc13p', NULL, NULL, 8950, 9),
(266553, NULL, 'PF04627', NULL, NULL, 'Mitochondrial ATP synthase epsilon chain', NULL, 'ATP-synt_Eps', NULL, NULL, 2449, 9),
(266554, NULL, 'PF13788', NULL, NULL, 'Domain of unknown function (DUF4180)', NULL, 'DUF4180', NULL, NULL, 22057, 9),
(266555, NULL, 'PF00402', NULL, NULL, 'Calponin family repeat', NULL, 'Calponin', NULL, NULL, 5785, 9),
(266556, NULL, 'PF11987', NULL, NULL, 'Translation-initiation factor 2', NULL, 'IF-2', NULL, NULL, 19555, 9),
(266557, NULL, 'PF13465', NULL, NULL, 'Zinc-finger double domain', NULL, 'zf-H2C2_2', NULL, NULL, NULL, 9),
(266558, NULL, 'PF20146', NULL, NULL, 'Nose resistant-to-fluoxetine protein, N-terminal domain', NULL, 'NRF', NULL, NULL, 1080, 9),
(266559, NULL, 'PF11125', NULL, NULL, 'Bacteriophage MS2, lysis protein', NULL, 'Phage_MS2_lysis', NULL, NULL, 16902, 9),
(266560, NULL, 'PF15364', NULL, NULL, 'PAXIP1-associated-protein-1 C term PTIP binding protein', NULL, 'PAXIP1_C', NULL, NULL, 22248, 9),
(266561, NULL, 'PF17541', NULL, NULL, 'Type VI secretion system, TssC, VipB', NULL, 'TssC', NULL, NULL, 33223, 9),
(266562, NULL, 'PF18576', NULL, NULL, 'Helix-turn-helix domain', NULL, 'HTH_52', NULL, NULL, 28714, 9),
(266563, NULL, 'PF12451', NULL, NULL, 'Vacuolar protein sorting protein 11 C terminal', NULL, 'VPS11_C', NULL, NULL, 14587, 9),
(266564, NULL, 'PF05681', NULL, NULL, 'Fumarate hydratase (Fumerase)', NULL, 'Fumerase', NULL, NULL, 2968, 9),
(266565, NULL, 'PF12851', NULL, NULL, 'Oxygenase domain of the 2OGFeDO superfamily', NULL, 'Tet_JBP', NULL, NULL, 16214, 9),
(266566, NULL, 'PF13352', NULL, NULL, 'Protein of unknown function (DUF4100)', NULL, 'DUF4100', NULL, NULL, 26171, 9),
(266567, NULL, 'PF13776', NULL, NULL, 'Domain of unknown function (DUF4172)', NULL, 'DUF4172', NULL, NULL, 23427, 9),
(266568, NULL, 'PF02671', NULL, NULL, 'Paired amphipathic helix repeat', NULL, 'PAH', NULL, NULL, 3234, 9),
(266569, NULL, 'PF15325', NULL, NULL, 'Modulator of retrovirus infection', NULL, 'MRI', NULL, NULL, 26619, 9),
(266570, NULL, 'PF15762', NULL, NULL, 'Domain of unknown function (DUF4691)', NULL, 'DUF4691', NULL, NULL, 26519, 9),
(266571, NULL, 'PF07314', NULL, NULL, 'Protein of unknown function (DUF1461)', NULL, 'DUF1461', NULL, NULL, 4091, 9),
(266572, NULL, 'PF18353', NULL, NULL, 'Phosphoglucose isomerase N-terminal domain', NULL, 'PG_isomerase_N', NULL, NULL, 29213, 9),
(266573, NULL, 'PF06488', NULL, NULL, 'Phage tail tube protein', NULL, 'L_lac_phage_MSP', NULL, NULL, 33575, 9),
(266574, NULL, 'PF09330', NULL, NULL, 'D-lactate dehydrogenase, membrane binding', NULL, 'Lact-deh-memb', NULL, NULL, 14109, 9),
(266575, NULL, 'PF00395', NULL, NULL, 'S-layer homology domain', NULL, 'SLH', NULL, NULL, 1311, 9),
(266576, NULL, 'PF03493', NULL, NULL, 'Calcium-activated BK potassium channel alpha subunit', NULL, 'BK_channel_a', NULL, NULL, 6107, 9),
(266577, NULL, 'PF11532', NULL, NULL, 'HnRNP M nuclear localisation signal', NULL, 'HnRNP_M_NLS', NULL, NULL, 5947, 9),
(266578, NULL, 'PF19035', NULL, NULL, 'CCN3 Nov like TSP1 domain', NULL, 'TSP1_CCN', NULL, NULL, 35465, 9),
(266579, NULL, 'PF09493', NULL, NULL, 'Tryptophan-rich protein (DUF2389)', NULL, 'DUF2389', NULL, NULL, 10981, 9),
(266580, NULL, 'PF10740', NULL, NULL, 'Domain of unknown function (DUF2529)', NULL, 'DUF2529', NULL, NULL, 19537, 9),
(266581, NULL, 'PF19573', NULL, NULL, 'Domain of unknown function (DUF6089)', NULL, 'DUF6089', NULL, NULL, 37180, 9),
(266582, NULL, 'PF00415', NULL, NULL, 'Regulator of chromosome condensation (RCC1) repeat', NULL, 'RCC1', NULL, NULL, 6861, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(266583, NULL, 'PF02370', NULL, NULL, 'M protein repeat', NULL, 'M', NULL, NULL, 4416, 9),
(266584, NULL, 'PF01770', NULL, NULL, 'Reduced folate carrier', NULL, 'Folate_carrier', NULL, NULL, 2897, 9),
(266585, NULL, 'PF03500', NULL, NULL, 'Cellulose synthase subunit D', NULL, 'Cellsynth_D', NULL, NULL, 17182, 9),
(266586, NULL, 'PF00869', NULL, NULL, 'Flavivirus glycoprotein, central and dimerisation domains', NULL, 'Flavi_glycoprot', NULL, NULL, 12134, 9),
(266587, NULL, 'PF16107', NULL, NULL, 'Domain of unknown function (DUF4825)', NULL, 'DUF4825', NULL, NULL, 22306, 9),
(266588, NULL, 'PF08675', NULL, NULL, 'RNA binding domain', NULL, 'RNA_bind', NULL, NULL, 11114, 9),
(266589, NULL, 'PF01715', NULL, NULL, 'IPP transferase', NULL, 'IPPT', NULL, NULL, NULL, 9),
(266590, NULL, 'PF16951', NULL, NULL, 'Putative methionine and alanine importer, small subunit', NULL, 'MaAIMP_sms', NULL, NULL, 22097, 9),
(266591, NULL, 'PF16491', NULL, NULL, 'CAAX prenyl protease N-terminal, five membrane helices', NULL, 'Peptidase_M48_N', NULL, NULL, 22628, 9),
(266592, NULL, 'PF14747', NULL, NULL, 'Domain of unknown function (DUF4473)', NULL, 'DUF4473', NULL, NULL, 23222, 9),
(266593, NULL, 'PF10060', NULL, NULL, 'Uncharacterized membrane protein (DUF2298)', NULL, 'DUF2298', NULL, NULL, 18266, 9),
(266594, NULL, 'PF00460', NULL, NULL, 'Flagella basal body rod protein', NULL, 'Flg_bb_rod', NULL, NULL, 6925, 9),
(266595, NULL, 'PF06178', NULL, NULL, 'Oligogalacturonate-specific porin protein (KdgM)', NULL, 'KdgM', NULL, NULL, 14438, 9),
(266596, NULL, 'PF18417', NULL, NULL, 'L-lysine epsilon oxidase C-terminal domain', NULL, 'LodA_C', NULL, NULL, 28985, 9),
(266597, NULL, 'PF18061', NULL, NULL, 'CRISPR-Cas9 WED domain', NULL, 'CRISPR_Cas9_WED', NULL, NULL, 28955, 9),
(266598, NULL, 'PF13110', NULL, NULL, 'Protein of unknown function (DUF3966)', NULL, 'DUF3966', NULL, NULL, 22697, 9),
(266599, NULL, 'PF19359', NULL, NULL, 'Family of unknown function (DUF5936)', NULL, 'DUF5936', NULL, NULL, 36822, 9),
(266600, NULL, 'PF16308', NULL, NULL, 'Domain of unknown function (DUF4950)', NULL, 'DUF4950', NULL, NULL, 25607, 9),
(266601, NULL, 'PF03501', NULL, NULL, 'Plectin/S10 domain', NULL, 'S10_plectin', NULL, NULL, 5863, 9),
(266602, NULL, 'PF05044', NULL, NULL, 'Homeo-prospero domain', NULL, 'HPD', NULL, NULL, 15434, 9),
(266603, NULL, 'PF08041', NULL, NULL, 'PetM family of cytochrome b6f complex subunit 7', NULL, 'PetM', NULL, NULL, 9282, 9),
(266604, NULL, 'PF17200', NULL, NULL, 'Single Cache domain 2', NULL, 'sCache_2', NULL, NULL, 33180, 9),
(266605, NULL, 'PF10197', NULL, NULL, 'N-terminal domain of CBF1 interacting co-repressor CIR', NULL, 'Cir_N', NULL, NULL, 15590, 9),
(266606, NULL, 'PF04114', NULL, NULL, 'Gaa1-like, GPI transamidase component', NULL, 'Gaa1', NULL, NULL, 6664, 9),
(266607, NULL, 'PF06326', NULL, NULL, 'Vesiculovirus matrix protein', NULL, 'Vesiculo_matrix', NULL, NULL, 8134, 9),
(266608, NULL, 'PF08320', NULL, NULL, 'PIG-X / PBN1', NULL, 'PIG-X', NULL, NULL, 12379, 9),
(266609, NULL, 'PF08165', NULL, NULL, 'FerA (NUC095) domain', NULL, 'FerA', NULL, NULL, 9301, 9),
(266610, NULL, 'PF20536', NULL, NULL, 'Family of unknown function (DUF6751)', NULL, 'DUF6751', NULL, NULL, 33774, 9),
(266611, NULL, 'PF11293', NULL, NULL, 'Protein of unknown function (DUF3094)', NULL, 'DUF3094', NULL, NULL, 18130, 9),
(266612, NULL, 'PF01570', NULL, NULL, 'Flavivirus polyprotein propeptide', NULL, 'Flavi_propep', NULL, NULL, 943, 9),
(266613, NULL, 'PF13087', NULL, NULL, 'AAA domain', NULL, 'AAA_12', NULL, NULL, 30150, 9),
(266614, NULL, 'PF06026', NULL, NULL, 'Ribose 5-phosphate isomerase A (phosphoriboisomerase A)', NULL, 'Rib_5-P_isom_A', NULL, NULL, 5031, 9),
(266615, NULL, 'PF16734', NULL, NULL, 'Type IV pilin-like G and H, putative', NULL, 'Pilin_GH', NULL, NULL, 24041, 9),
(266616, NULL, 'PF19609', NULL, NULL, 'Family of unknown function (DUF6114)', NULL, 'DUF6114', NULL, NULL, 36748, 9),
(266617, NULL, 'PF03513', NULL, NULL, 'Cloacin immunity protein', NULL, 'Cloacin_immun', NULL, NULL, 866, 9),
(266618, NULL, 'PF15066', NULL, NULL, 'Cancer-associated gene protein 1 family', NULL, 'CAGE1', NULL, NULL, 26227, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(266619, NULL, 'PF18792', NULL, NULL, 'Ubiquitous surface protein adhesin repeat', NULL, 'UspA1_rep', NULL, NULL, 28426, 9),
(266620, NULL, 'PF20189', NULL, NULL, 'Family of unknown function (DUF6552)', NULL, 'DUF6552', NULL, NULL, 37372, 9),
(266621, NULL, 'PF13372', NULL, NULL, 'Alginate export', NULL, 'Alginate_exp', NULL, NULL, 22384, 9),
(266622, NULL, 'PF15806', NULL, NULL, 'Domain of unknown function (DUF4707)', NULL, 'DUF4707', NULL, NULL, 26194, 9),
(266623, NULL, 'PF08284', NULL, NULL, 'Retroviral aspartyl protease', NULL, 'RVP_2', NULL, NULL, NULL, 9),
(266624, NULL, 'PF10856', NULL, NULL, 'Protein of unknown function (DUF2678)', NULL, 'DUF2678', NULL, NULL, 16221, 9),
(266625, NULL, 'PF04791', NULL, NULL, 'LMBR1-like membrane protein', NULL, 'LMBR1', NULL, NULL, 4594, 9),
(266626, NULL, 'PF16169', NULL, NULL, 'Domain of unknown function (DUF4872)', NULL, 'DUF4872', NULL, NULL, 24481, 9),
(266627, NULL, 'PF18603', NULL, NULL, 'L-amino acid ligase C-terminal domain 2', NULL, 'LAL_C2', NULL, NULL, 27814, 9),
(266628, NULL, 'PF18084', NULL, NULL, 'ARTD15 N-terminal domain', NULL, 'ARTD15_N', NULL, NULL, 29114, 9),
(266629, NULL, 'PF09813', NULL, NULL, 'Cytochrome c oxidase assembly factor 3', NULL, 'Coa3_cc', NULL, NULL, 16328, 9),
(266630, NULL, 'PF14756', NULL, NULL, 'Peptidase_C33-associated domain', NULL, 'Pdase_C33_assoc', NULL, NULL, 22389, 9),
(266631, NULL, 'PF03579', NULL, NULL, 'Small hydrophobic protein', NULL, 'SHP', NULL, NULL, 5718, 9),
(266632, NULL, 'PF02246', NULL, NULL, 'Protein L b1 domain', NULL, 'B1', NULL, NULL, 2692, 9),
(266633, NULL, 'PF08811', NULL, NULL, 'Protein of unknown function (DUF1800)', NULL, 'DUF1800', NULL, NULL, 13474, 9),
(266634, NULL, 'PF02271', NULL, NULL, 'Ubiquinol-cytochrome C reductase complex 14kD subunit', NULL, 'UCR_14kD', NULL, NULL, 3057, 9),
(266635, NULL, 'PF09164', NULL, NULL, 'Vitamin D binding protein, domain III', NULL, 'VitD-bind_III', NULL, NULL, 12156, 9),
(266636, NULL, 'PF09792', NULL, NULL, 'Ubiquitin 3 binding protein But2 C-terminal domain', NULL, 'But2', NULL, NULL, 16205, 9),
(266637, NULL, 'PF14249', NULL, NULL, 'Tocopherol cyclase', NULL, 'Tocopherol_cycl', NULL, NULL, 25557, 9),
(266638, NULL, 'PF11579', NULL, NULL, 'Protein of unknown function (DUF3238)', NULL, 'DUF3238', NULL, NULL, 18912, 9),
(266639, NULL, 'PF11284', NULL, NULL, 'Protein of unknown function (DUF3085)', NULL, 'DUF3085', NULL, NULL, 18077, 9),
(266640, NULL, 'PF14033', NULL, NULL, 'Protein of unknown function (DUF4246)', NULL, 'DUF4246', NULL, NULL, 22357, 9),
(266641, NULL, 'PF06151', NULL, NULL, 'Trehalose receptor', NULL, 'Trehalose_recp', NULL, NULL, 14131, 9),
(266642, NULL, 'PF06420', NULL, NULL, 'Mitochondrial genome maintenance MGM101', NULL, 'Mgm101p', NULL, NULL, 8249, 9),
(266643, NULL, 'PF14039', NULL, NULL, 'YusW-like protein', NULL, 'YusW', NULL, NULL, 24154, 9),
(266644, NULL, 'PF10635', NULL, NULL, 'DisA bacterial checkpoint controller linker region', NULL, 'DisA-linker', NULL, NULL, 20652, 9),
(266645, NULL, 'PF04343', NULL, NULL, 'Protein of unknown function, DUF488', NULL, 'DUF488', NULL, NULL, 4291, 9),
(266646, NULL, 'PF19848', NULL, NULL, 'Family of unknown function (DUF6323)', NULL, 'DUF6323', NULL, NULL, 37728, 9),
(266647, NULL, 'PF08514', NULL, NULL, 'STAG domain', NULL, 'STAG', NULL, NULL, 14355, 9),
(266648, NULL, 'PF06449', NULL, NULL, 'ATP synthase YMF19, C-terminal', NULL, 'YMF19_C', NULL, NULL, 9376, 9),
(266649, NULL, 'PF10435', NULL, NULL, 'Beta-galactosidase, domain 2', NULL, 'BetaGal_dom2', NULL, NULL, 16882, 9),
(266650, NULL, 'PF13341', NULL, NULL, 'RAG2 PHD domain', NULL, 'RAG2_PHD', NULL, NULL, 26287, 9),
(266651, NULL, 'PF16385', NULL, NULL, 'Domain of unknown function', NULL, 'DUF4994', NULL, NULL, NULL, 9),
(266652, NULL, 'PF03955', NULL, NULL, 'Adenovirus hexon-associated protein (IX)', NULL, 'Adeno_PIX', NULL, NULL, 2677, 9),
(266653, NULL, 'PF04151', NULL, NULL, 'Bacterial pre-peptidase C-terminal domain', NULL, 'PPC', NULL, NULL, 7010, 9),
(266654, NULL, 'PF18877', NULL, NULL, 'SSSPR-51 domain', NULL, 'SSSPR-51', NULL, NULL, 22106, 9); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(266655, NULL, 'PF19090', NULL, NULL, 'Family of unknown function (DUF5778)', NULL, 'DUF5778', NULL, NULL, 35364, 9),
(266656, NULL, 'PF03008', NULL, NULL, 'Archaea bacterial proteins of unknown function', NULL, 'DUF234', NULL, NULL, 3758, 9),
(266657, NULL, 'PF03344', NULL, NULL, 'Daxx N-terminal Rassf1C-interacting domain', NULL, 'Daxx', NULL, NULL, 21695, 9),
(266658, NULL, 'PF15650', NULL, NULL, 'Restriction endonuclease fold toxin 9', NULL, 'Tox-REase-9', NULL, NULL, 24869, 9),
(266659, NULL, 'PF11394', NULL, NULL, 'Protein of unknown function (DUF2875)', NULL, 'DUF2875', NULL, NULL, 18779, 9),
(266660, NULL, 'PF16807', NULL, NULL, 'Domain of unknown function (DUF5072)', NULL, 'DUF5072', NULL, NULL, NULL, 9),
(266661, NULL, 'PF08487', NULL, NULL, 'Vault protein inter-alpha-trypsin domain', NULL, 'VIT', NULL, NULL, 13773, 9),
(266662, NULL, 'PF02525', NULL, NULL, 'Flavodoxin-like fold', NULL, 'Flavodoxin_2', NULL, NULL, 1077, 9),
(266663, NULL, 'PF06469', NULL, NULL, 'Neurobeachin-like, DUF1088', NULL, 'DUF1088', NULL, NULL, 10331, 9),
(266664, NULL, 'PF18876', NULL, NULL, 'AF-4 proto-oncoprotein C-terminal region', NULL, 'AF-4_C', NULL, NULL, 35168, 9),
(266665, NULL, 'PF05587', NULL, NULL, 'Anthrax receptor extracellular domain', NULL, 'Anth_Ig', NULL, NULL, 8985, 9),
(266666, NULL, 'PF07782', NULL, NULL, 'DC-STAMP-like protein', NULL, 'DC_STAMP', NULL, NULL, 12076, 9),
(266667, NULL, 'PF03814', NULL, NULL, 'Potassium-transporting ATPase A subunit', NULL, 'KdpA', NULL, NULL, 2414, 9),
(266668, NULL, 'PF04820', NULL, NULL, 'Tryptophan halogenase', NULL, 'Trp_halogenase', NULL, NULL, 4919, 9),
(266669, NULL, 'PF03395', NULL, NULL, 'Poxvirus P4A protein', NULL, 'Pox_P4A', NULL, NULL, 2432, 9),
(266670, NULL, 'PF07953', NULL, NULL, 'Clostridium neurotoxin, N-terminal receptor binding', NULL, 'Toxin_R_bind_N', NULL, NULL, 7647, 9),
(266671, NULL, 'PF11082', NULL, NULL, 'Protein of unknown function (DUF2880)', NULL, 'DUF2880', NULL, NULL, 17808, 9),
(266672, NULL, 'PF20064', NULL, NULL, 'Family of unknown function (DUF6463)', NULL, 'DUF6463', NULL, NULL, 37145, 9),
(266673, NULL, 'PF20179', NULL, NULL, 'MSS51 C-terminal domain', NULL, 'MSS51_C', NULL, NULL, 33744, 9),
(266674, NULL, 'PF11024', NULL, NULL, 'Dispersed gene family protein 1 of Trypanosoma cruzi region 4', NULL, 'DGF-1_4', NULL, NULL, 14857, 9),
(266675, NULL, 'PF11266', NULL, NULL, 'Long-chain fatty aldehyde decarbonylase', NULL, 'Ald_deCOase', NULL, NULL, 16560, 9),
(266676, NULL, 'PF03889', NULL, NULL, 'Alternative ribosome-rescue factor A', NULL, 'ArfA', NULL, NULL, 2835, 9),
(266677, NULL, 'PF17557', NULL, NULL, 'I2-superfamily conotoxins', NULL, 'Conotoxin_I2', NULL, NULL, 21259, 9),
(266678, NULL, 'PF18721', NULL, NULL, 'CxC6 like cysteine cluster associated with KDZ transposases', NULL, 'CxC6', NULL, NULL, 32199, 9),
(266679, NULL, 'PF16684', NULL, NULL, 'Telomere resolvase', NULL, 'Telomere_res', NULL, NULL, 25054, 9),
(266680, NULL, 'PF15481', NULL, NULL, 'Chondroitin proteoglycan 4', NULL, 'CPG4', NULL, NULL, 25696, 9),
(266681, NULL, 'PF09137', NULL, NULL, 'Glucodextranase, domain N', NULL, 'Glucodextran_N', NULL, NULL, 10922, 9),
(266682, NULL, 'PF16101', NULL, NULL, 'Proline-rich membrane anchor 1', NULL, 'PRIMA1', NULL, NULL, NULL, 9),
(266683, NULL, 'PF08890', NULL, NULL, 'Phage XkdN-like tail assembly chaperone protein, TAC', NULL, 'Phage_TAC_5', NULL, NULL, 14445, 9),
(266684, NULL, 'PF03438', NULL, NULL, 'Pneumovirus NS1 protein', NULL, 'Pneumo_NS1', NULL, NULL, 10964, 9),
(266685, NULL, 'PF04592', NULL, NULL, 'Selenoprotein P, N terminal region', NULL, 'SelP_N', NULL, NULL, 561, 9),
(266686, NULL, 'PF18311', NULL, NULL, 'Exosome complex exonuclease Rrp40 N-terminal domain', NULL, 'Rrp40_N', NULL, NULL, 28744, 9),
(266687, NULL, 'PF06015', NULL, NULL, 'Chordopoxvirus A30L protein', NULL, 'Chordopox_A30L', NULL, NULL, 13820, 9),
(266688, NULL, 'PF16548', NULL, NULL, 'Flagellar assembly protein T, N-terminal domain', NULL, 'FlgT_N', NULL, NULL, 26771, 9),
(266689, NULL, 'PF06177', NULL, NULL, 'QueT transporter', NULL, 'QueT', NULL, NULL, 9317, 9); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(266690, NULL, 'PF02196', NULL, NULL, 'Raf-like Ras-binding domain', NULL, 'RBD', NULL, NULL, 2992, 9),
(266691, NULL, 'PF03648', NULL, NULL, 'Glycosyl hydrolase family 67 N-terminus', NULL, 'Glyco_hydro_67N', NULL, NULL, 4125, 9),
(266692, NULL, 'PF09589', NULL, NULL, 'HrpA pilus formation protein', NULL, 'HrpA_pilin', NULL, NULL, 15432, 9),
(266693, NULL, 'PF18700', NULL, NULL, 'Cytosolic arginine sensor for mTORC1 subunit 1 N-terminal domain', NULL, 'Castor1_N', NULL, NULL, 28391, 9),
(266694, NULL, 'PF17231', NULL, NULL, 'Family of unknown function (DUF5305)', NULL, 'DUF5305', NULL, NULL, 20025, 9),
(266695, NULL, 'PF02068', NULL, NULL, 'Plant PEC family metallothionein', NULL, 'Metallothio_PEC', NULL, NULL, 4515, 9),
(266696, NULL, 'PF18675', NULL, NULL, 'Heparinase II C-terminal domain', NULL, 'HepII_C', NULL, NULL, 27875, 9),
(266697, NULL, 'PF07094', NULL, NULL, 'Protein of unknown function (DUF1357)', NULL, 'DUF1357', NULL, NULL, 13121, 9),
(266698, NULL, 'PF08732', NULL, NULL, 'HIM1', NULL, 'HIM1', NULL, NULL, 11637, 9),
(266699, NULL, 'PF02833', NULL, NULL, 'DHHA2 domain', NULL, 'DHHA2', NULL, NULL, 1827, 9),
(266700, NULL, 'PF02421', NULL, NULL, 'Ferrous iron transport protein B', NULL, 'FeoB_N', NULL, NULL, 24738, 9),
(266701, NULL, 'PF06639', NULL, NULL, 'Basal layer antifungal peptide (BAP)', NULL, 'BAP', NULL, NULL, 10142, 9),
(266702, NULL, 'PF17037', NULL, NULL, 'Cellulose biosynthesis protein BcsO', NULL, 'CBP_BcsO', NULL, NULL, 22953, 9),
(266703, NULL, 'PF03891', NULL, NULL, 'Domain of unknown function (DUF333)', NULL, 'DUF333', NULL, NULL, 2556, 9),
(266704, NULL, 'PF05964', NULL, NULL, 'F/Y-rich N-terminus', NULL, 'FYRN', NULL, NULL, 4314, 9),
(266705, NULL, 'PF18560', NULL, NULL, 'Lectin like domain', NULL, 'Lectin_like', NULL, NULL, 31546, 9),
(266706, NULL, 'PF08840', NULL, NULL, 'BAAT / Acyl-CoA thioester hydrolase C terminal', NULL, 'BAAT_C', NULL, NULL, 14273, 9),
(266707, NULL, 'PF09777', NULL, NULL, 'Osteopetrosis-associated transmembrane protein 1 precursor', NULL, 'OSTMP1', NULL, NULL, 18423, 9),
(266708, NULL, 'PF05552', NULL, NULL, 'Conserved TM helix', NULL, 'TM_helix', NULL, NULL, 7786, 9),
(266709, NULL, 'PF04677', NULL, NULL, 'Protein similar to CwfJ C-terminus 1', NULL, 'CwfJ_C_1', NULL, NULL, 3031, 9),
(266710, NULL, 'PF05005', NULL, NULL, 'Janus/Ocnus family (Ocnus)', NULL, 'Ocnus', NULL, NULL, 1290, 9),
(266711, NULL, 'PF13406', NULL, NULL, 'Transglycosylase SLT domain', NULL, 'SLT_2', NULL, NULL, 21228, 9),
(266712, NULL, 'PF19393', NULL, NULL, 'Family of unknown function (DUF5968)', NULL, 'DUF5968', NULL, NULL, 34956, 9),
(266713, NULL, 'PF15317', NULL, NULL, 'Cardiac transcription factor regulator, Developmental protein', NULL, 'Lbh', NULL, NULL, 30556, 9),
(266714, NULL, 'PF18980', NULL, NULL, 'Family of unknown function (DUF5716) C-terminal', NULL, 'DUF5716_C', NULL, NULL, 35338, 9),
(266715, NULL, 'PF00960', NULL, NULL, 'Neocarzinostatin family', NULL, 'Neocarzinostat', NULL, NULL, 1273, 9),
(266716, NULL, 'PF07753', NULL, NULL, 'Protein of unknown function (DUF1609)', NULL, 'DUF1609', NULL, NULL, 10811, 9),
(266717, NULL, 'PF06035', NULL, NULL, 'Bacterial transglutaminase-like cysteine proteinase BTLCP', NULL, 'Peptidase_C93', NULL, NULL, 8870, 9),
(266718, NULL, 'PF09179', NULL, NULL, 'TilS substrate binding domain', NULL, 'TilS', NULL, NULL, 12409, 9),
(266719, NULL, 'PF17856', NULL, NULL, 'TIP49 AAA-lid domain', NULL, 'TIP49_C', NULL, NULL, 29510, 9),
(266720, NULL, 'PF18394', NULL, NULL, 'TANK-binding kinase 1 coiled-coil domain 1', NULL, 'TBK1_CCD1', NULL, NULL, 29737, 9),
(266721, NULL, 'PF04290', NULL, NULL, 'Tripartite ATP-independent periplasmic transporters, DctQ component', NULL, 'DctQ', NULL, NULL, 6317, 9),
(266722, NULL, 'PF10321', NULL, NULL, 'Serpentine type 7TM GPCR chemoreceptor Srt', NULL, '7TM_GPCR_Srt', NULL, NULL, 16630, 9),
(266723, NULL, 'PF08461', NULL, NULL, 'Ribonuclease R winged-helix domain', NULL, 'HTH_12', NULL, NULL, 13986, 9),
(266724, NULL, 'PF10281', NULL, NULL, 'Putative nuclear envelope organisation protein', NULL, 'Ish1', NULL, NULL, 19469, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(266725, NULL, 'PF12991', NULL, NULL, 'Domain of unknown function, B. Theta Gene description (DUF3875)', NULL, 'DUF3875', NULL, NULL, 24189, 9),
(266726, NULL, 'PF08733', NULL, NULL, 'PalH/RIM21', NULL, 'PalH', NULL, NULL, 11704, 9),
(266727, NULL, 'PF04326', NULL, NULL, 'Putative DNA-binding domain', NULL, 'AlbA_2', NULL, NULL, 3991, 9),
(266728, NULL, 'PF01737', NULL, NULL, 'YCF9', NULL, 'Ycf9', NULL, NULL, 2813, 9),
(266729, NULL, 'PF17487', NULL, NULL, 'Ribosomal protein S12', NULL, 'Ribosomal_S12', NULL, NULL, 9819, 9),
(266730, NULL, 'PF11545', NULL, NULL, 'Cell surface heme-binding protein Shp', NULL, 'HemeBinding_Shp', NULL, NULL, 15658, 9),
(266731, NULL, 'PF20396', NULL, NULL, 'Family of unknown function (DUF6689)', NULL, 'DUF6689', NULL, NULL, 37747, 9),
(266732, NULL, 'PF05711', NULL, NULL, 'Macrocin-O-methyltransferase (TylF)', NULL, 'TylF', NULL, NULL, 7863, 9),
(266733, NULL, 'PF17957', NULL, NULL, 'Bacterial Ig domain', NULL, 'Big_7', NULL, NULL, NULL, 9),
(266734, NULL, 'PF00832', NULL, NULL, 'Ribosomal L39 protein', NULL, 'Ribosomal_L39', NULL, NULL, 2661, 9),
(266735, NULL, 'PF13098', NULL, NULL, 'Thioredoxin-like domain', NULL, 'Thioredoxin_2', NULL, NULL, 7704, 9),
(266736, NULL, 'PF14416', NULL, NULL, 'PMR5 N terminal Domain', NULL, 'PMR5N', NULL, NULL, 24364, 9),
(266737, NULL, 'PF06455', NULL, NULL, 'NADH dehydrogenase subunit 5 C-terminus', NULL, 'NADH5_C', NULL, NULL, 7677, 9),
(266738, NULL, 'PF07261', NULL, NULL, 'Replication initiation and membrane attachment', NULL, 'DnaB_2', NULL, NULL, 4528, 9),
(266739, NULL, 'PF14609', NULL, NULL, 'gamma-Tubulin ring complex non-core subunit mod21', NULL, 'GCP5-Mod21', NULL, NULL, 21704, 9),
(266740, NULL, 'PF02281', NULL, NULL, 'Transposase Tn5 dimerisation domain', NULL, 'Dimer_Tnp_Tn5', NULL, NULL, 3068, 9),
(266741, NULL, 'PF15055', NULL, NULL, 'Domain of unknown function (DUF4536)', NULL, 'DUF4536', NULL, NULL, 23933, 9),
(266742, NULL, 'PF13050', NULL, NULL, 'Protein of unknown function (DUF3911)', NULL, 'DUF3911', NULL, NULL, 22540, 9),
(266743, NULL, 'PF05836', NULL, NULL, 'Chorion protein S16', NULL, 'Chorion_S16', NULL, NULL, 11698, 9),
(266744, NULL, 'PF18579', NULL, NULL, 'Rubisco accumulation factor 1 helix turn helix domain', NULL, 'Raf1_HTH', NULL, NULL, 28477, 9),
(266745, NULL, 'PF05685', NULL, NULL, 'Putative restriction endonuclease', NULL, 'Uma2', NULL, NULL, 13394, 9),
(266746, NULL, 'PF07606', NULL, NULL, 'Protein of unknown function (DUF1569)', NULL, 'DUF1569', NULL, NULL, 13606, 9),
(266747, NULL, 'PF15313', NULL, NULL, 'Hexamethylene bis-acetamide-inducible protein', NULL, 'HEXIM', NULL, NULL, 22241, 9),
(266748, NULL, 'PF06490', NULL, NULL, 'Flagellar regulatory protein FleQ', NULL, 'FleQ', NULL, NULL, 12214, 9),
(266749, NULL, 'PF01054', NULL, NULL, 'Mouse mammary tumour virus superantigen', NULL, 'MMTV_SAg', NULL, NULL, 1231, 9),
(266750, NULL, 'PF05560', NULL, NULL, 'Bacillus thuringiensis P21 molecular chaperone protein', NULL, 'Bt_P21', NULL, NULL, 8558, 9),
(266751, NULL, 'PF13832', NULL, NULL, 'PHD-zinc-finger like domain', NULL, 'zf-HC5HC2H_2', NULL, NULL, NULL, 9),
(266752, NULL, 'PF10884', NULL, NULL, 'Protein of unknown function (DUF2683)', NULL, 'DUF2683', NULL, NULL, 19066, 9),
(266753, NULL, 'PF01822', NULL, NULL, 'WSC domain', NULL, 'WSC', NULL, NULL, 5924, 9),
(266754, NULL, 'PF05508', NULL, NULL, 'RanGTP-binding protein', NULL, 'Ran-binding', NULL, NULL, 13936, 9),
(266755, NULL, 'PF08130', NULL, NULL, 'Type A lantibiotic family', NULL, 'Antimicrobial18', NULL, NULL, 12554, 9),
(266756, NULL, 'PF18071', NULL, NULL, 'HMW1C N-terminal', NULL, 'HMW1C_N', NULL, NULL, 29264, 9),
(266757, NULL, 'PF06003', NULL, NULL, 'Survival motor neuron protein (SMN)', NULL, 'SMN', NULL, NULL, 7588, 9),
(266758, NULL, 'PF15427', NULL, NULL, 'S100P-binding protein', NULL, 'S100PBPR', NULL, NULL, 25135, 9),
(266759, NULL, 'PF18747', NULL, NULL, 'P-loop Nucleotide Kinase2', NULL, 'Ploopntkinase2', NULL, NULL, 29449, 9),
(266760, NULL, 'PF12344', NULL, NULL, 'Ultra-violet resistance protein B', NULL, 'UvrB', NULL, NULL, 14619, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(266761, NULL, 'PF12608', NULL, NULL, 'Type IVb secretion, IcmS, effector-recruitment', NULL, 'T4bSS_IcmS', NULL, NULL, 21069, 9),
(266762, NULL, 'PF16887', NULL, NULL, 'Domain of unknown function (DUF5081)', NULL, 'DUF5081', NULL, NULL, 22520, 9),
(266763, NULL, 'PF11667', NULL, NULL, 'Putative zincin peptidase', NULL, 'DUF3267', NULL, NULL, 19375, 9),
(266764, NULL, 'PF05427', NULL, NULL, 'Acidic fibroblast growth factor binding (FIBP)', NULL, 'FIBP', NULL, NULL, 14271, 9),
(266765, NULL, 'PF10090', NULL, NULL, 'Histidine phosphotransferase C-terminal domain', NULL, 'HPTransfase', NULL, NULL, 18121, 9),
(266766, NULL, 'PF04537', NULL, NULL, 'Herpesvirus UL55 protein', NULL, 'Herpes_UL55', NULL, NULL, 2765, 9),
(266767, NULL, 'PF01522', NULL, NULL, 'Polysaccharide deacetylase', NULL, 'Polysacc_deac_1', NULL, NULL, 974, 9),
(266768, NULL, 'PF14006', NULL, NULL, 'YqzL-like protein', NULL, 'YqzL', NULL, NULL, 26127, 9),
(266769, NULL, 'PF12542', NULL, NULL, 'Pre-mRNA splicing factor', NULL, 'CWC25', NULL, NULL, 21127, 9),
(266770, NULL, 'PF03242', NULL, NULL, 'Late embryogenesis abundant protein', NULL, 'LEA_3', NULL, NULL, 1647, 9),
(266771, NULL, 'PF02599', NULL, NULL, 'Global regulator protein family', NULL, 'CsrA', NULL, NULL, 2339, 9),
(266772, NULL, 'PF14510', NULL, NULL, 'ABC-transporter N-terminal', NULL, 'ABC_trans_N', NULL, NULL, 23236, 9),
(266773, NULL, 'PF02772', NULL, NULL, 'S-adenosylmethionine synthetase, central domain', NULL, 'S-AdoMet_synt_M', NULL, NULL, 16746, 9),
(266774, NULL, 'PF19201', NULL, NULL, 'Family of unknown function (DUF5873)', NULL, 'DUF5873', NULL, NULL, 35829, 9),
(266775, NULL, 'PF12819', NULL, NULL, 'Malectin-like domain', NULL, 'Malectin_like', NULL, NULL, 23695, 9),
(266776, NULL, 'PF19586', NULL, NULL, 'Family of unknown function (DUF6093)', NULL, 'DUF6093', NULL, NULL, 36631, 9),
(266777, NULL, 'PF04068', NULL, NULL, 'Possible Fer4-like domain in RNase L inhibitor, RLI', NULL, 'RLI', NULL, NULL, 1107, 9),
(266778, NULL, 'PF09045', NULL, NULL, 'L27_2', NULL, 'L27_2', NULL, NULL, 9993, 9),
(266779, NULL, 'PF13561', NULL, NULL, 'Enoyl-(Acyl carrier protein) reductase', NULL, 'adh_short_C2', NULL, NULL, NULL, 9),
(266780, NULL, 'PF00777', NULL, NULL, 'Glycosyltransferase family 29 (sialyltransferase)', NULL, 'Glyco_transf_29', NULL, NULL, 3333, 9),
(266781, NULL, 'PF13429', NULL, NULL, 'Tetratricopeptide repeat', NULL, 'TPR_15', NULL, NULL, NULL, 9),
(266782, NULL, 'PF05346', NULL, NULL, 'Eukaryotic membrane protein family', NULL, 'DUF747', NULL, NULL, 5314, 9),
(266783, NULL, 'PF18279', NULL, NULL, 'Werner helicase-interacting protein 1 ubiquitin-binding domain', NULL, 'zf-WRNIP1_ubi', NULL, NULL, 27530, 9),
(266784, NULL, 'PF16323', NULL, NULL, 'Domain of unknown function (DUF4959)', NULL, 'DUF4959', NULL, NULL, 25155, 9),
(266785, NULL, 'PF00861', NULL, NULL, 'Ribosomal L18 of archaea, bacteria, mitoch. and chloroplast', NULL, 'Ribosomal_L18p', NULL, NULL, 910, 9),
(266786, NULL, 'PF02529', NULL, NULL, 'Cytochrome B6-F complex subunit 5', NULL, 'PetG', NULL, NULL, 1800, 9),
(266787, NULL, 'PF01591', NULL, NULL, '6-phosphofructo-2-kinase', NULL, '6PF2K', NULL, NULL, 11466, 9),
(266788, NULL, 'PF01146', NULL, NULL, 'Caveolin', NULL, 'Caveolin', NULL, NULL, 5330, 9),
(266789, NULL, 'PF14831', NULL, NULL, 'Domain of unknown function (DUF4484)', NULL, 'DUF4484', NULL, NULL, 24773, 9),
(266790, NULL, 'PF14788', NULL, NULL, 'EF hand', NULL, 'EF-hand_10', NULL, NULL, 31278, 9),
(266791, NULL, 'PF10580', NULL, NULL, 'Gap junction protein N-terminal region', NULL, 'Neuromodulin_N', NULL, NULL, 9384, 9),
(266792, NULL, 'PF16232', NULL, NULL, 'Domain of unknown function (DUF4891)', NULL, 'DUF4891', NULL, NULL, 25660, 9),
(266793, NULL, 'PF18313', NULL, NULL, 'Thiolase-like protein type 1 additional C-terminal domain', NULL, 'TLP1_add_C', NULL, NULL, 28720, 9),
(266794, NULL, 'PF17818', NULL, NULL, 'Keratinocyte-associated gene product', NULL, 'KCT2', NULL, NULL, NULL, 9),
(266795, NULL, 'PF07154', NULL, NULL, 'Protein of unknown function (DUF1392)', NULL, 'DUF1392', NULL, NULL, 13127, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(266796, NULL, 'PF07979', NULL, NULL, 'Intimin C-type lectin domain', NULL, 'Intimin_C', NULL, NULL, 18994, 9),
(266797, NULL, 'PF12059', NULL, NULL, 'Protein of unknown function (DUF3540)', NULL, 'DUF3540', NULL, NULL, 19764, 9),
(266798, NULL, 'PF16094', NULL, NULL, 'Proteasome assembly chaperone 4', NULL, 'PAC1', NULL, NULL, 17546, 9),
(266799, NULL, 'PF03521', NULL, NULL, 'Kv2 voltage-gated K+ channel', NULL, 'Kv2channel', NULL, NULL, 7144, 9),
(266800, NULL, 'PF17078', NULL, NULL, 'SWI5-dependent HO expression protein 3', NULL, 'SHE3', NULL, NULL, 23625, 9),
(266801, NULL, 'PF00660', NULL, NULL, 'Seripauperin and TIP1 family', NULL, 'SRP1_TIP1', NULL, NULL, 3220, 9),
(266802, NULL, 'PF08199', NULL, NULL, 'Bacteriophage E2-like protein', NULL, 'E2', NULL, NULL, 17061, 9),
(266803, NULL, 'PF16763', NULL, NULL, 'Major ampullate spidroin 1, spider silk protein 1, N-term', NULL, 'Spidroin_N', NULL, NULL, 22889, 9),
(266804, NULL, 'PF07821', NULL, NULL, 'Alpha-amylase C-terminal beta-sheet domain', NULL, 'Alpha-amyl_C2', NULL, NULL, 12090, 9),
(266805, NULL, 'PF09088', NULL, NULL, 'MIF4G like', NULL, 'MIF4G_like', NULL, NULL, 9844, 9),
(266806, NULL, 'PF07726', NULL, NULL, 'ATPase family associated with various cellular activities (AAA)', NULL, 'AAA_3', NULL, NULL, 8345, 9),
(266807, NULL, 'PF07167', NULL, NULL, 'Poly-beta-hydroxybutyrate polymerase (PhaC) N-terminus', NULL, 'PhaC_N', NULL, NULL, 7839, 9),
(266808, NULL, 'PF10246', NULL, NULL, 'Mitochondrial ribosomal protein MRP-S35', NULL, 'MRP-S35', NULL, NULL, 15571, 9),
(266809, NULL, 'PF02359', NULL, NULL, 'Cell division protein 48 (CDC48), N-terminal domain', NULL, 'CDC48_N', NULL, NULL, 4076, 9),
(266810, NULL, 'PF11262', NULL, NULL, 'Transcription factor/nuclear export subunit protein 2', NULL, 'Tho2', NULL, NULL, 18454, 9),
(266811, NULL, 'PF16003', NULL, NULL, 'Domain of unknown function (DUF4776)', NULL, 'DUF4776', NULL, NULL, 26947, 9),
(266812, NULL, 'PF08206', NULL, NULL, 'Ribonuclease B OB domain', NULL, 'OB_RNB', NULL, NULL, 12465, 9),
(266813, NULL, 'PF18701', NULL, NULL, 'Family of unknown function (DUF5641)', NULL, 'DUF5641', NULL, NULL, 28943, 9),
(266814, NULL, 'PF07377', NULL, NULL, 'Protein of unknown function (DUF1493)', NULL, 'DUF1493', NULL, NULL, 11700, 9),
(266815, NULL, 'PF02027', NULL, NULL, 'RolB/RolC glucosidase family', NULL, 'RolB_RolC', NULL, NULL, 2762, 9),
(266816, NULL, 'PF16293', NULL, NULL, 'C2H2 type zinc-finger (1 copy)', NULL, 'zf-C2H2_9', NULL, NULL, 21671, 9),
(266817, NULL, 'PF05706', NULL, NULL, 'Cyclin-dependent kinase inhibitor 3 (CDKN3)', NULL, 'CDKN3', NULL, NULL, 17321, 9),
(266818, NULL, 'PF06019', NULL, NULL, 'Phage GP30.8 protein', NULL, 'Phage_30_8', NULL, NULL, 13772, 9),
(266819, NULL, 'PF00702', NULL, NULL, 'haloacid dehalogenase-like hydrolase', NULL, 'Hydrolase', NULL, NULL, NULL, 9),
(266820, NULL, 'PF19642', NULL, NULL, 'Family of unknown function (DUF6145)', NULL, 'DUF6145', NULL, NULL, 37409, 9),
(266821, NULL, 'PF05096', NULL, NULL, 'Glutamine cyclotransferase', NULL, 'Glu_cyclase_2', NULL, NULL, 2044, 9),
(266822, NULL, 'PF00900', NULL, NULL, 'Ribosomal family S4e', NULL, 'Ribosomal_S4e', NULL, NULL, 11649, 9),
(266823, NULL, 'PF01652', NULL, NULL, 'Eukaryotic initiation factor 4E', NULL, 'IF4E', NULL, NULL, 1244, 9),
(266824, NULL, 'PF00228', NULL, NULL, 'Bowman-Birk serine protease inhibitor family', NULL, 'Bowman-Birk_leg', NULL, NULL, 59, 9),
(266825, NULL, 'PF03517', NULL, NULL, 'Regulator of volume decrease after cellular swelling', NULL, 'Voldacs', NULL, NULL, 30071, 9),
(266826, NULL, 'PF18732', NULL, NULL, 'HEPN like, Abia C-terminal domain', NULL, 'HEPN_AbiA_CTD', NULL, NULL, 28404, 9),
(266827, NULL, 'PF06088', NULL, NULL, 'Nucleopolyhedrovirus telokin-like protein-20 (TLP20)', NULL, 'TLP-20', NULL, NULL, 6345, 9),
(266828, NULL, 'PF11465', NULL, NULL, 'Natural killer cell receptor 2B4', NULL, 'Receptor_2B4', NULL, NULL, 15534, 9),
(266829, NULL, 'PF15606', NULL, NULL, 'Bacterial toxin 34', NULL, 'Ntox34', NULL, NULL, 24945, 9),
(266830, NULL, 'PF11828', NULL, NULL, 'Protein of unknown function (DUF3348)', NULL, 'DUF3348', NULL, NULL, 19461, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(266831, NULL, 'PF06883', NULL, NULL, 'RNA polymerase I, Rpa2 specific domain', NULL, 'RNA_pol_Rpa2_4', NULL, NULL, 11777, 9),
(266832, NULL, 'PF13727', NULL, NULL, 'CoA-binding domain', NULL, 'CoA_binding_3', NULL, NULL, NULL, 9),
(266833, NULL, 'PF19078', NULL, NULL, 'Bacterial Ig-like domain', NULL, 'Big_12', NULL, NULL, 35265, 9),
(266834, NULL, 'PF16707', NULL, NULL, 'Cag pathogenicity island protein S of Helicobacter pylori', NULL, 'CagS', NULL, NULL, 23263, 9),
(266835, NULL, 'PF10215', NULL, NULL, 'Oligosaccaryltransferase', NULL, 'Ost4', NULL, NULL, 14868, 9),
(266836, NULL, 'PF16150', NULL, NULL, 'Domain of unknown function (DUF4858)', NULL, 'DUF4858', NULL, NULL, 26411, 9),
(266837, NULL, 'PF01352', NULL, NULL, 'KRAB box', NULL, 'KRAB', NULL, NULL, 4346, 9),
(266838, NULL, 'PF17970', NULL, NULL, 'Bacterial Alpha-2-macroglobulin MG1 domain', NULL, 'bMG1', NULL, NULL, 28406, 9),
(266839, NULL, 'PF01095', NULL, NULL, 'Pectinesterase', NULL, 'Pectinesterase', NULL, NULL, 2734, 9),
(266840, NULL, 'PF17701', NULL, NULL, 'Family of unknown function (DUF5547)', NULL, 'DUF5547', NULL, NULL, 29277, 9),
(266841, NULL, 'PF04121', NULL, NULL, 'Nuclear pore protein 84 / 107', NULL, 'Nup84_Nup100', NULL, NULL, 6667, 9),
(266842, NULL, 'PF10735', NULL, NULL, 'Protein of unknown function (DUF2526)', NULL, 'DUF2526', NULL, NULL, 21258, 9),
(266843, NULL, 'PF17900', NULL, NULL, 'Peptidase M1 N-terminal domain', NULL, 'Peptidase_M1_N', NULL, NULL, 35055, 9),
(266844, NULL, 'PF04563', NULL, NULL, 'RNA polymerase beta subunit', NULL, 'RNA_pol_Rpb2_1', NULL, NULL, 2282, 9),
(266845, NULL, 'PF08646', NULL, NULL, 'Replication factor-A C terminal domain', NULL, 'Rep_fac-A_C', NULL, NULL, 7984, 9),
(266846, NULL, 'PF03700', NULL, NULL, 'Sorting nexin, N-terminal domain', NULL, 'Sorting_nexin', NULL, NULL, 5719, 9),
(266847, NULL, 'PF07083', NULL, NULL, 'Protein of unknown function (DUF1351)', NULL, 'DUF1351', NULL, NULL, 13430, 9),
(266848, NULL, 'PF16179', NULL, NULL, 'Rel homology dimerisation domain', NULL, 'RHD_dimer', NULL, NULL, 21642, 9),
(266849, NULL, 'PF04309', NULL, NULL, 'Glycerol-3-phosphate responsive antiterminator', NULL, 'G3P_antiterm', NULL, NULL, 2242, 9),
(266850, NULL, 'PF03355', NULL, NULL, 'Viral Trans-Activator Protein', NULL, 'Pox_TAP', NULL, NULL, 1225, 9),
(266851, NULL, 'PF07707', NULL, NULL, 'BTB And C-terminal Kelch', NULL, 'BACK', NULL, NULL, 8102, 9),
(266852, NULL, 'PF11971', NULL, NULL, 'CAMSAP CH domain', NULL, 'CAMSAP_CH', NULL, NULL, 16586, 9),
(266853, NULL, 'PF06426', NULL, NULL, 'Serine acetyltransferase, N-terminal', NULL, 'SATase_N', NULL, NULL, 10243, 9),
(266854, NULL, 'PF17643', NULL, NULL, 'Type VI secretion system, TssR', NULL, 'TssR', NULL, NULL, 31925, 9),
(266855, NULL, 'PF19511', NULL, NULL, 'Family of unknown function (DUF6045)', NULL, 'DUF6045', NULL, NULL, 37206, 9),
(266856, NULL, 'PF01434', NULL, NULL, 'Peptidase family M41', NULL, 'Peptidase_M41', NULL, NULL, 6777, 9),
(266857, NULL, 'PF01766', NULL, NULL, 'Birnavirus VP2 protein', NULL, 'Birna_VP2', NULL, NULL, 2817, 9),
(266858, NULL, 'PF02190', NULL, NULL, 'ATP-dependent protease La (LON) substrate-binding domain', NULL, 'LON_substr_bdg', NULL, NULL, 2619, 9),
(266859, NULL, 'PF05869', NULL, NULL, 'DNA N-6-adenine-methyltransferase (Dam)', NULL, 'Dam', NULL, NULL, 14205, 9),
(266860, NULL, 'PF11373', NULL, NULL, 'Protein of unknown function (DUF3175)', NULL, 'DUF3175', NULL, NULL, 18807, 9),
(266861, NULL, 'PF07778', NULL, NULL, 'Mis6', NULL, 'CENP-I', NULL, NULL, 11543, 9),
(266862, NULL, 'PF12645', NULL, NULL, 'Helix-turn-helix domain', NULL, 'HTH_16', NULL, NULL, 19138, 9),
(266863, NULL, 'PF19681', NULL, NULL, 'Family of unknown function (DUF6183)', NULL, 'DUF6183', NULL, NULL, 36259, 9),
(266864, NULL, 'PF10122', NULL, NULL, 'Mu-like prophage protein Com', NULL, 'Mu-like_Com', NULL, NULL, 19869, 9),
(266865, NULL, 'PF14556', NULL, NULL, 'AF2331-like', NULL, 'AF2331-like', NULL, NULL, 21961, 9),
(266866, NULL, 'PF14686', NULL, NULL, 'Polysaccharide lyase family 4, domain II', NULL, 'fn3_3', NULL, NULL, 21648, 9);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(266867, NULL, 'PF16443', NULL, NULL, 'Domain of unknown function (DUF5040)', NULL, 'DUF5040', NULL, NULL, 24292, 9),
(266868, NULL, 'PF04686', NULL, NULL, 'Streptomyces sporulation and cell division protein, SsgA', NULL, 'SsgA', NULL, NULL, 3072, 9),
(266869, NULL, 'PF07662', NULL, NULL, 'Na+ dependent nucleoside transporter C-terminus', NULL, 'Nucleos_tra2_C', NULL, NULL, 10549, 9),
(266870, NULL, 'PF08211', NULL, NULL, 'Cytidine and deoxycytidylate deaminase zinc-binding region', NULL, 'dCMP_cyt_deam_2', NULL, NULL, 8733, 9),
(266871, NULL, 'PF02526', NULL, NULL, 'Glycophorin-binding protein', NULL, 'GBP_repeat', NULL, NULL, 1553, 9),
(266872, NULL, 'PF00105', NULL, NULL, 'Zinc finger, C4 type (two domains)', NULL, 'zf-C4', NULL, NULL, 3273, 9),
(266873, NULL, 'PF13319', NULL, NULL, 'Protein of unknown function (DUF4090)', NULL, 'DUF4090', NULL, NULL, 23063, 9),
(266874, NULL, 'PF15102', NULL, NULL, 'TMEM154 protein family', NULL, 'TMEM154', NULL, NULL, 26649, 9),
(266875, NULL, 'PF16753', NULL, NULL, 'TNF-alpha-Inducing protein of Helicobacter', NULL, 'Tipalpha', NULL, NULL, 25522, 9),
(266876, NULL, 'PF01886', NULL, NULL, 'Protein of unknown function DUF61', NULL, 'DUF61', NULL, NULL, 3831, 9),
(266877, NULL, 'PF06541', NULL, NULL, 'Putative ABC-transporter type IV', NULL, 'ABC_trans_CmpB', NULL, NULL, 14127, 9),
(266878, NULL, 'PF14089', NULL, NULL, 'KinB-signalling pathway activation in sporulation', NULL, 'KbaA', NULL, NULL, 12778, 9),
(266879, NULL, 'PF16428', NULL, NULL, 'Domain of unknown function (DUF5025)', NULL, 'DUF5025', NULL, NULL, 24470, 9),
(266880, NULL, 'PF08622', NULL, NULL, 'Svf1-like N-terminal lipocalin domain', NULL, 'Svf1', NULL, NULL, 14095, 9),
(266881, NULL, 'PF05264', NULL, NULL, 'Choristoneura fumiferana antifreeze protein (CfAFP)', NULL, 'CfAFP', NULL, NULL, 3372, 9),
(266882, NULL, 'PF15092', NULL, NULL, 'Uncharacterised protein family UPF0728', NULL, 'UPF0728', NULL, NULL, 23723, 9),
(266883, NULL, 'PF20459', NULL, NULL, 'Family of unknown function (DUF6712)', NULL, 'DUF6712', NULL, NULL, 37675, 9),
(266884, NULL, 'PF09809', NULL, NULL, 'Mitochondrial ribosomal protein L27', NULL, 'MRP-L27', NULL, NULL, 18426, 9),
(266885, NULL, 'PF11781', NULL, NULL, 'Zinc-finger of RNA-polymerase I-specific TFIIB, Rrn7', NULL, 'zf-RRN7', NULL, NULL, 19199, 9),
(266886, NULL, 'PF06712', NULL, NULL, 'Protein of unknown function (DUF1199)', NULL, 'DUF1199', NULL, NULL, 1551, 9),
(266887, NULL, 'PF05461', NULL, NULL, 'Apolipoprotein L', NULL, 'ApoL', NULL, NULL, 8538, 9),
(266888, NULL, 'PF06645', NULL, NULL, 'Microsomal signal peptidase 12 kDa subunit (SPC12)', NULL, 'SPC12', NULL, NULL, 10299, 9),
(266889, NULL, 'PF14451', NULL, NULL, 'Mut7-C ubiquitin', NULL, 'Ub-Mut7C', NULL, NULL, 22606, 9),
(266890, NULL, 'PF15445', NULL, NULL, 'acidic terminal segments, variant surface antigen of PfEMP1', NULL, 'ATS', NULL, NULL, 26590, 9),
(266891, NULL, 'PF09009', NULL, NULL, 'Exotoxin A catalytic', NULL, 'Exotox-A_cataly', NULL, NULL, 8928, 9),
(266892, NULL, 'PF16519', NULL, NULL, 'Tetramerisation domain of TRPM', NULL, 'TRPM_tetra', NULL, NULL, 23054, 9),
(266893, NULL, 'PF00933', NULL, NULL, 'Glycosyl hydrolase family 3 N terminal domain', NULL, 'Glyco_hydro_3', NULL, NULL, 3088, 9),
(266894, NULL, 'PF19537', NULL, NULL, 'Family of unknown function (DUF6061)', NULL, 'DUF6061', NULL, NULL, 36083, 9),
(266895, NULL, 'PF01209', NULL, NULL, 'ubiE/COQ5 methyltransferase family', NULL, 'Ubie_methyltran', NULL, NULL, 838, 9),
(266896, NULL, 'PF09812', NULL, NULL, 'Mitochondrial ribosomal protein L28', NULL, 'MRP-L28', NULL, NULL, 18181, 9),
(266897, NULL, 'PF11466', NULL, NULL, 'Prion-like protein Doppel', NULL, 'Doppel', NULL, NULL, 18861, 9),
(266898, NULL, 'PF03087', NULL, NULL, 'Protein BPS1', NULL, 'BPS1', NULL, NULL, 4795, 9),
(266899, NULL, 'PF09657', NULL, NULL, 'CRISPR-associated protein Csx8 (Cas_Csx8)', NULL, 'Cas_Csx8', NULL, NULL, 10425, 9),
(266900, NULL, 'PF15623', NULL, NULL, 'Cancer/testis gene family 47', NULL, 'CT47', NULL, NULL, 25222, 9),
(266901, NULL, 'PF00635', NULL, NULL, 'MSP (Major sperm protein) domain', NULL, 'Motile_Sperm', NULL, NULL, 5913, 9);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(266902, NULL, 'PF11235', NULL, NULL, 'Mediator complex subunit 25 synapsin 1', NULL, 'Med25_SD1', NULL, NULL, 18044, 9),
(266903, NULL, 'PF13517', NULL, NULL, 'FG-GAP-like repeat', NULL, 'FG-GAP_3', NULL, NULL, 13796, 9),
(266904, NULL, 'PF17121', NULL, NULL, 'Zinc finger, C3HC4 type (RING finger)', NULL, 'zf-C3HC4_5', NULL, NULL, 4043, 9),
(266905, NULL, 'PF06280', NULL, NULL, 'Fn3-like domain', NULL, 'fn3_5', NULL, NULL, 9070, 9),
(266906, NULL, 'PF14855', NULL, NULL, 'Pilus-assembly fibrillin subunit, chaperone', NULL, 'PapJ', NULL, NULL, 26975, 9),
(266907, NULL, 'PF07155', NULL, NULL, 'ECF-type riboflavin transporter, S component', NULL, 'ECF-ribofla_trS', NULL, NULL, 13492, 9),
(266908, NULL, 'PF10418', NULL, NULL, 'Iron-sulfur cluster binding domain of dihydroorotate dehydrogenase B', NULL, 'DHODB_Fe-S_bind', NULL, NULL, 17250, 9),
(266909, NULL, 'PF15776', NULL, NULL, 'Proline-rich protein family 22', NULL, 'PRR22', NULL, NULL, 25991, 9),
(266910, NULL, 'PF18118', NULL, NULL, 'Polycomb repressive complex 2 tri-helical domain', NULL, 'PRC2_HTH_1', NULL, NULL, 29481, 9),
(266911, NULL, 'PF11008', NULL, NULL, 'Protein of unknown function (DUF2846)', NULL, 'DUF2846', NULL, NULL, 16266, 9),
(266912, NULL, 'PF07290', NULL, NULL, 'Protein of unknown function (DUF1449)', NULL, 'DUF1449', NULL, NULL, 11865, 9),
(266913, NULL, 'PF00238', NULL, NULL, 'Ribosomal protein L14p/L23e', NULL, 'Ribosomal_L14', NULL, NULL, 1825, 9),
(266914, NULL, 'PF17021', NULL, NULL, 'Putative double-strand recombination repair-like', NULL, 'Mei5_like', NULL, NULL, 22905, 9),
(266915, NULL, 'PF17404', NULL, NULL, 'Nrap protein domain 3', NULL, 'Nrap_D3', NULL, NULL, 30709, 9),
(266916, NULL, 'PF17409', NULL, NULL, 'MoaF C-terminal domain', NULL, 'MoaF_C', NULL, NULL, 30721, 9),
(266917, NULL, 'PF01564', NULL, NULL, 'Spermine/spermidine synthase domain', NULL, 'Spermine_synth', NULL, NULL, NULL, 9),
(266918, NULL, 'PF13891', NULL, NULL, 'Potential DNA-binding domain', NULL, 'zf-C3Hc3H', NULL, NULL, 23414, 9),
(266919, NULL, 'PF17162', NULL, NULL, 'Domain of unknown function (DUF5118)', NULL, 'DUF5118', NULL, NULL, 31252, 9),
(266920, NULL, 'PF08351', NULL, NULL, 'tRNA(Met) cytidine acetyltransferase TmcA, N-terminal', NULL, 'TmcA_N', NULL, NULL, 12626, 9),
(266921, NULL, 'PF06417', NULL, NULL, 'Protein of unknown function (DUF1077)', NULL, 'DUF1077', NULL, NULL, 8284, 9),
(266922, NULL, 'PF06451', NULL, NULL, 'Moricin', NULL, 'Moricin', NULL, NULL, 9233, 9),
(266923, NULL, 'PF10264', NULL, NULL, 'Winged helix Storkhead-box1 domain', NULL, 'Stork_head', NULL, NULL, 15936, 9),
(266924, NULL, 'PF05314', NULL, NULL, 'Baculovirus occlusion-derived virus envelope protein EC27', NULL, 'Baculo_ODV-E27', NULL, NULL, 4352, 9),
(266925, NULL, 'PF12138', NULL, NULL, 'Spherulation-specific family 4', NULL, 'Spherulin4', NULL, NULL, 20207, 9),
(266926, NULL, 'PF04880', NULL, NULL, 'NUDE protein, C-terminal conserved region', NULL, 'NUDE_C', NULL, NULL, 5779, 9),
(266927, NULL, 'PF00917', NULL, NULL, 'MATH domain', NULL, 'MATH', NULL, NULL, 1424, 9),
(266928, NULL, 'PF08232', NULL, NULL, 'Striatin family', NULL, 'Striatin', NULL, NULL, 13222, 9),
(266929, NULL, 'PF18133', NULL, NULL, 'Hydrogen maturase F tetramerization domain', NULL, 'HydF_tetramer', NULL, NULL, 28460, 9),
(266930, NULL, 'PF04572', NULL, NULL, 'Alpha 1,4-glycosyltransferase conserved region', NULL, 'Gb3_synth', NULL, NULL, 421, 9),
(266931, NULL, 'PF10459', NULL, NULL, 'Peptidase S46', NULL, 'Peptidase_S46', NULL, NULL, 18034, 9),
(266932, NULL, 'PF14808', NULL, NULL, 'TMEM164 family', NULL, 'TMEM164', NULL, NULL, 23490, 9),
(266933, NULL, 'PF02742', NULL, NULL, 'Iron dependent repressor, metal binding and dimerisation domain', NULL, 'Fe_dep_repr_C', NULL, NULL, 7412, 9),
(266934, NULL, 'PF18714', NULL, NULL, 'DNA polymerase II intein Domain IV', NULL, 'PI-TkoII_IV', NULL, NULL, 29500, 9),
(266935, NULL, 'PF19652', NULL, NULL, 'Family of unknown function (DUF6155)', NULL, 'DUF6155', NULL, NULL, 37116, 9),
(266936, NULL, 'PF19578', NULL, NULL, 'Family of unknown function (DUF6090)', NULL, 'DUF6090', NULL, NULL, 36249, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(266937, NULL, 'PF17857', NULL, NULL, 'AAA+ lid domain', NULL, 'AAA_lid_1', NULL, NULL, 30406, 9),
(266938, NULL, 'PF18691', NULL, NULL, 'Cell division control protein 13, OB2 domain', NULL, 'Cdc13_OB2', NULL, NULL, 28144, 9),
(266939, NULL, 'PF04658', NULL, NULL, 'TAFII55 protein conserved region', NULL, 'TAFII55_N', NULL, NULL, 2926, 9),
(266940, NULL, 'PF14507', NULL, NULL, 'CppA C-terminal', NULL, 'CppA_C', NULL, NULL, 21880, 9),
(266941, NULL, 'PF06325', NULL, NULL, 'Ribosomal protein L11 methyltransferase (PrmA)', NULL, 'PrmA', NULL, NULL, NULL, 9),
(266942, NULL, 'PF11651', NULL, NULL, 'P22 coat protein - gene protein 5', NULL, 'P22_CoatProtein', NULL, NULL, 19485, 9),
(266943, NULL, 'PF11900', NULL, NULL, 'Domain of unknown function (DUF3420)', NULL, 'DUF3420', NULL, NULL, 13213, 9),
(266944, NULL, 'PF13082', NULL, NULL, 'Protein of unknown function (DUF3931)', NULL, 'DUF3931', NULL, NULL, 22557, 9),
(266945, NULL, 'PF03770', NULL, NULL, 'Inositol polyphosphate kinase', NULL, 'IPK', NULL, NULL, 1795, 9),
(266946, NULL, 'PF05812', NULL, NULL, 'Herpesvirus BLRF2 protein', NULL, 'Herpes_BLRF2', NULL, NULL, 14461, 9),
(266947, NULL, 'PF05306', NULL, NULL, 'Protein of unknown function (DUF733)', NULL, 'DUF733', NULL, NULL, 4119, 9),
(266948, NULL, 'PF10210', NULL, NULL, 'Mitochondrial 28S ribosomal protein S32', NULL, 'MRP-S32', NULL, NULL, 15919, 9),
(266949, NULL, 'PF00255', NULL, NULL, 'Glutathione peroxidase', NULL, 'GSHPx', NULL, NULL, 4632, 9),
(266950, NULL, 'PF14184', NULL, NULL, 'Regulatory protein YrvL', NULL, 'YrvL', NULL, NULL, 23409, 9),
(266951, NULL, 'PF04473', NULL, NULL, 'Transglutaminase-like domain', NULL, 'DUF553', NULL, NULL, 1217, 9),
(266952, NULL, 'PF10753', NULL, NULL, 'Toxin GhoT_OrtT', NULL, 'Toxin_GhoT_OrtT', NULL, NULL, 20283, 9),
(266953, NULL, 'PF12706', NULL, NULL, 'Beta-lactamase superfamily domain', NULL, 'Lactamase_B_2', NULL, NULL, 2148, 9),
(266954, NULL, 'PF12785', NULL, NULL, 'Variant erythrocyte surface antigen-1', NULL, 'VESA1_N', NULL, NULL, 19874, 9),
(266955, NULL, 'PF19906', NULL, NULL, 'Domain of unknown function (DUF6379)', NULL, 'DUF6379', NULL, NULL, 36762, 9),
(266956, NULL, 'PF19333', NULL, NULL, 'Failed axon connections homolog N-terminus', NULL, 'FAXC_N', NULL, NULL, 36021, 9),
(266957, NULL, 'PF11277', NULL, NULL, 'Mediator complex subunit 24 N-terminal', NULL, 'Med24_N', NULL, NULL, 18004, 9),
(266958, NULL, 'PF09385', NULL, NULL, 'Histidine kinase N terminal', NULL, 'HisK_N', NULL, NULL, 15602, 9),
(266959, NULL, 'PF19817', NULL, NULL, 'Family of unknown function (DUF6300)', NULL, 'DUF6300', NULL, NULL, 37123, 9),
(266960, NULL, 'PF16692', NULL, NULL, 'Folliculin C-terminal domain', NULL, 'Folliculin_C', NULL, NULL, 23053, 9),
(266961, NULL, 'PF15280', NULL, NULL, 'Protein aurora borealis N-terminus', NULL, 'BORA_N', NULL, NULL, 10687, 9),
(266962, NULL, 'PF06540', NULL, NULL, 'Galanin message associated peptide (GMAP)', NULL, 'GMAP', NULL, NULL, 7121, 9),
(266963, NULL, 'PF19032', NULL, NULL, 'Intu longin-like domain 2', NULL, 'Intu_longin_2', NULL, NULL, 35503, 9),
(266964, NULL, 'PF10862', NULL, NULL, 'FcoT-like thioesterase domain', NULL, 'FcoT', NULL, NULL, 16962, 9),
(266965, NULL, 'PF14110', NULL, NULL, 'Domain of unknown function (DUF4282)', NULL, 'DUF4282', NULL, NULL, 23296, 9),
(266966, NULL, 'PF18237', NULL, NULL, 'Tk-SP N-propeptide domain', NULL, 'Tk-SP_N-pro', NULL, NULL, 30446, 9),
(266967, NULL, 'PF08410', NULL, NULL, 'Domain of unknown function (DUF1737)', NULL, 'DUF1737', NULL, NULL, 11382, 9),
(266968, NULL, 'PF02386', NULL, NULL, 'Cation transport protein', NULL, 'TrkH', NULL, NULL, 5195, 9),
(266969, NULL, 'PF03481', NULL, NULL, 'Threonylcarbamoyl-AMP synthase, C-terminal domain', NULL, 'Sua5_C', NULL, NULL, 4191, 9),
(266970, NULL, 'PF13409', NULL, NULL, 'Glutathione S-transferase, N-terminal domain', NULL, 'GST_N_2', NULL, NULL, 978, 9),
(266971, NULL, 'PF17020', NULL, NULL, 'Domain of unknown function (DUF5097)', NULL, 'DUF5097', NULL, NULL, 22687, 9),
(266972, NULL, 'PF02503', NULL, NULL, 'Polyphosphate kinase middle domain', NULL, 'PP_kinase', NULL, NULL, 26976, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(266973, NULL, 'PF13252', NULL, NULL, 'Protein of unknown function (DUF4043)', NULL, 'DUF4043', NULL, NULL, 25652, 9),
(266974, NULL, 'PF04687', NULL, NULL, 'Microvirus H protein (pilot protein)', NULL, 'Microvir_H', NULL, NULL, 3161, 9),
(266975, NULL, 'PF05573', NULL, NULL, 'NosL', NULL, 'NosL', NULL, NULL, 12338, 9),
(266976, NULL, 'PF17596', NULL, NULL, 'Family of unknown function (DUF5492)', NULL, 'DUF5492', NULL, NULL, 19132, 9),
(266977, NULL, 'PF00619', NULL, NULL, 'Caspase recruitment domain', NULL, 'CARD', NULL, NULL, 323, 9),
(266978, NULL, 'PF03426', NULL, NULL, 'Carbohydrate binding domain (family 15)', NULL, 'CBM_15', NULL, NULL, 10286, 9),
(266979, NULL, 'PF00918', NULL, NULL, 'Gastrin/cholecystokinin family', NULL, 'Gastrin', NULL, NULL, 5208, 9),
(266980, NULL, 'PF08585', NULL, NULL, 'RecQ mediated genome instability protein', NULL, 'RMI1_N', NULL, NULL, 17851, 9),
(266981, NULL, 'PF06624', NULL, NULL, 'Ribosome associated membrane protein RAMP4', NULL, 'RAMP4', NULL, NULL, 8492, 9),
(266982, NULL, 'PF05719', NULL, NULL, 'Golgi phosphoprotein 3 (GPP34)', NULL, 'GPP34', NULL, NULL, 14477, 9),
(266983, NULL, 'PF12365', NULL, NULL, 'Protein of unknown function (DUF3649)', NULL, 'DUF3649', NULL, NULL, 20931, 9),
(266984, NULL, 'PF12736', NULL, NULL, 'Cell-cycle sustaining, positive selection,', NULL, 'CABIT', NULL, NULL, 23989, 9),
(266985, NULL, 'PF18584', NULL, NULL, 'Synaptonemal complex 2 Spt16M-like domain', NULL, 'SYCP2_SLD', NULL, NULL, 27449, 9),
(266986, NULL, 'PF06872', NULL, NULL, 'EspG protein', NULL, 'EspG', NULL, NULL, 11699, 9),
(266987, NULL, 'PF11812', NULL, NULL, 'Domain of unknown function (DUF3333)', NULL, 'DUF3333', NULL, NULL, 21570, 9),
(266988, NULL, 'PF15888', NULL, NULL, 'Folded gastrulation N-terminus', NULL, 'FOG_N', NULL, NULL, 23903, 9),
(266989, NULL, 'PF19232', NULL, NULL, 'Family of unknown function (DUF5885)', NULL, 'DUF5885', NULL, NULL, 35528, 9),
(266990, NULL, 'PF11991', NULL, NULL, 'Tryptophan dimethylallyltransferase', NULL, 'Trp_DMAT', NULL, NULL, 19153, 9),
(266991, NULL, 'PF09292', NULL, NULL, 'Endonuclease VIII-like 1, DNA bind', NULL, 'Neil1-DNA_bind', NULL, NULL, 14190, 9),
(266992, NULL, 'PF06175', NULL, NULL, 'tRNA-(MS[2]IO[6]A)-hydroxylase (MiaE)', NULL, 'MiaE', NULL, NULL, 9264, 9),
(266993, NULL, 'PF09436', NULL, NULL, 'Domain of unknown function (DUF2016)', NULL, 'DUF2016', NULL, NULL, 15235, 9),
(266994, NULL, 'PF12293', NULL, NULL, 'Putative outer membrane core complex of type IVb secretion', NULL, 'T4BSS_DotH_IcmK', NULL, NULL, 20632, 9),
(266995, NULL, 'PF04023', NULL, NULL, 'FeoA domain', NULL, 'FeoA', NULL, NULL, 20, 9),
(266996, NULL, 'PF05250', NULL, NULL, 'Uncharacterised protein family (UPF0193)', NULL, 'UPF0193', NULL, NULL, 3307, 9),
(266997, NULL, 'PF19450', NULL, NULL, 'Family of unknown function (DUF5988)', NULL, 'DUF5988', NULL, NULL, 36823, 9),
(266998, NULL, 'PF13916', NULL, NULL, 'PP1-regulatory protein, Phostensin N-terminal', NULL, 'Phostensin_N', NULL, NULL, 22412, 9),
(266999, NULL, 'PF02668', NULL, NULL, 'Taurine catabolism dioxygenase TauD, TfdA family', NULL, 'TauD', NULL, NULL, 3208, 9),
(267000, NULL, 'PF16499', NULL, NULL, 'Alpha galactosidase A', NULL, 'Melibiase_2', NULL, NULL, 5507, 9),
(267001, NULL, 'PF19940', NULL, NULL, 'Family of unknown function (DUF6402)', NULL, 'DUF6402', NULL, NULL, 36462, 9),
(267002, NULL, 'PF17315', NULL, NULL, 'Found in mitochondrial proteome', NULL, 'FMP23', NULL, NULL, 31783, 9),
(267003, NULL, 'PF07245', NULL, NULL, 'Phlebovirus glycoprotein G2 fusion domain', NULL, 'Phlebovirus_G2', NULL, NULL, 14310, 9),
(267004, NULL, 'PF06646', NULL, NULL, 'Extracytoplasmic thiamine-binding lipoprotein', NULL, 'CypI', NULL, NULL, 8330, 9),
(267005, NULL, 'PF06778', NULL, NULL, 'Chlorite dismutase', NULL, 'Chlor_dismutase', NULL, NULL, 9267, 9),
(267006, NULL, 'PF20180', NULL, NULL, 'Complex III assembly factor UQCC2/CBP6', NULL, 'UQCC2_CBP6', NULL, NULL, 34409, 9),
(267007, NULL, 'PF03498', NULL, NULL, 'Cytolethal distending toxin A/C domain', NULL, 'CDtoxinA', NULL, NULL, 277, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(267008, NULL, 'PF13733', NULL, NULL, 'N-terminal region of glycosyl transferase group 7', NULL, 'Glyco_transf_7N', NULL, NULL, 23599, 9),
(267009, NULL, 'PF13306', NULL, NULL, 'BspA type Leucine rich repeat region (6 copies)', NULL, 'LRR_5', NULL, NULL, 26728, 9),
(267010, NULL, 'PF06993', NULL, NULL, 'Protein of unknown function (DUF1304)', NULL, 'DUF1304', NULL, NULL, 12461, 9),
(267011, NULL, 'PF03832', NULL, NULL, 'WSK motif', NULL, 'WSK', NULL, NULL, 5378, 9),
(267012, NULL, 'PF09852', NULL, NULL, 'Predicted membrane protein (DUF2079)', NULL, 'DUF2079', NULL, NULL, 16564, 9),
(267013, NULL, 'PF05880', NULL, NULL, 'Fijivirus 64 kDa capsid protein', NULL, 'Fiji_64_capsid', NULL, NULL, 14065, 9),
(267014, NULL, 'PF06588', NULL, NULL, 'Muskelin N-terminus', NULL, 'Muskelin_N', NULL, NULL, 8373, 9),
(267015, NULL, 'PF01462', NULL, NULL, 'Leucine rich repeat N-terminal domain', NULL, 'LRRNT', NULL, NULL, 4701, 9),
(267016, NULL, 'PF01021', NULL, NULL, 'Ty transposon capsid protein', NULL, 'TYA', NULL, NULL, 13797, 9),
(267017, NULL, 'PF04866', NULL, NULL, 'Rotavirus non-structural protein 6', NULL, 'Rota_NS6', NULL, NULL, 5686, 9),
(267018, NULL, 'PF13836', NULL, NULL, 'Domain of unknown function (DUF4195)', NULL, 'DUF4195', NULL, NULL, 23370, 9),
(267019, NULL, 'PF08011', NULL, NULL, 'PD-(D/E)XK nuclease superfamily', NULL, 'PDDEXK_9', NULL, NULL, 8990, 9),
(267020, NULL, 'PF15187', NULL, NULL, 'Oesophageal cancer-related gene 4', NULL, 'Augurin', NULL, NULL, 24843, 9),
(267021, NULL, 'PF05955', NULL, NULL, 'Equine herpesvirus glycoprotein gp2', NULL, 'Herpes_gp2', NULL, NULL, 7975, 9),
(267022, NULL, 'PF09586', NULL, NULL, 'Bacterial membrane protein YfhO', NULL, 'YfhO', NULL, NULL, 15240, 9),
(267023, NULL, 'PF15348', NULL, NULL, 'Gemini of Cajal bodies-associated protein 8', NULL, 'GEMIN8', NULL, NULL, 8717, 9),
(267024, NULL, 'PF11784', NULL, NULL, 'Protein of unknown function (DUF3320)', NULL, 'DUF3320', NULL, NULL, 19413, 9),
(267025, NULL, 'PF16928', NULL, NULL, 'DNA/protein translocase of phage P22 injectosome', NULL, 'Inj_translocase', NULL, NULL, 25174, 9),
(267026, NULL, 'PF01556', NULL, NULL, 'DnaJ C terminal domain', NULL, 'DnaJ_C', NULL, NULL, 6588, 9),
(267027, NULL, 'PF14623', NULL, NULL, 'Hint-domain', NULL, 'Vint', NULL, NULL, 33679, 9),
(267028, NULL, 'PF18440', NULL, NULL, 'Putative GlcNAc-1 phosphotransferase regulatory domain', NULL, 'GlcNAc-1_reg', NULL, NULL, 29675, 9),
(267029, NULL, 'PF20332', NULL, NULL, 'Family of unknown function (DUF6627)', NULL, 'DUF6627', NULL, NULL, 37473, 9),
(267030, NULL, 'PF14844', NULL, NULL, 'PH domain associated with Beige/BEACH', NULL, 'PH_BEACH', NULL, NULL, 19422, 9),
(267031, NULL, 'PF17698', NULL, NULL, 'Family of unknown function (DUF5544)', NULL, 'DUF5544', NULL, NULL, 29469, 9),
(267032, NULL, 'PF18387', NULL, NULL, 'Zinc-fingers and homeoboxes C2H2 finger domain', NULL, 'zf_C2H2_ZHX', NULL, NULL, 28691, 9),
(267033, NULL, 'PF19502', NULL, NULL, 'Nucleotidyltransferase of unknown function (DUF6036)', NULL, 'DUF6036', NULL, NULL, 36233, 9),
(267034, NULL, 'PF15677', NULL, NULL, 'Cell cycle exit and neuronal differentiation protein 1', NULL, 'CEND1', NULL, NULL, 13626, 9),
(267035, NULL, 'PF02380', NULL, NULL, 'T-antigen specific domain', NULL, 'Papo_T_antigen', NULL, NULL, 4238, 9),
(267036, NULL, 'PF00928', NULL, NULL, 'Adaptor complexes medium subunit family', NULL, 'Adap_comp_sub', NULL, NULL, 26369, 9),
(267037, NULL, 'PF08307', NULL, NULL, 'Glycosyl hydrolase family 98 C-terminal domain', NULL, 'Glyco_hydro_98C', NULL, NULL, 17053, 9),
(267038, NULL, 'PF12636', NULL, NULL, 'Protein of unknown function (DUF3781)', NULL, 'DUF3781', NULL, NULL, 11991, 9),
(267039, NULL, 'PF19286', NULL, NULL, 'Domain of unknown function (DUF5909)', NULL, 'DUF5909', NULL, NULL, 36453, 9),
(267040, NULL, 'PF00366', NULL, NULL, 'Ribosomal protein S17', NULL, 'Ribosomal_S17', NULL, NULL, 754, 9),
(267041, NULL, 'PF13616', NULL, NULL, 'PPIC-type PPIASE domain', NULL, 'Rotamase_3', NULL, NULL, NULL, 9),
(267042, NULL, 'PF05172', NULL, NULL, 'Nup53/35/40-type RNA recognition motif', NULL, 'Nup35_RRM', NULL, NULL, 2103, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(267043, NULL, 'PF18789', NULL, NULL, 'Defence against restriction A C-terminal', NULL, 'DarA_C', NULL, NULL, 29398, 9),
(267044, NULL, 'PF17714', NULL, NULL, 'Family of unknown function (DUF5559)', NULL, 'DUF5559', NULL, NULL, 27661, 9),
(267045, NULL, 'PF04296', NULL, NULL, 'Protein of unknown function (DUF448)', NULL, 'YlxR', NULL, NULL, 3691, 9),
(267046, NULL, 'PF12981', NULL, NULL, 'Domain of Unknown Function with PDB structure (DUF3865)', NULL, 'DUF3865', NULL, NULL, 22533, 9),
(267047, NULL, 'PF19655', NULL, NULL, 'Family of unknown function (DUF6158)', NULL, 'DUF6158', NULL, NULL, 37196, 9),
(267048, NULL, 'PF18972', NULL, NULL, 'Cns1/TTC4 Wheel domain', NULL, 'Wheel', NULL, NULL, 35362, 9),
(267049, NULL, 'PF13212', NULL, NULL, 'Domain of unknown function (DUF4020)', NULL, 'DUF4020', NULL, NULL, 22815, 9),
(267050, NULL, 'PF14225', NULL, NULL, 'Cell morphogenesis C-terminal', NULL, 'MOR2-PAG1_C', NULL, NULL, 26205, 9),
(267051, NULL, 'PF05259', NULL, NULL, 'Herpesvirus glycoprotein L', NULL, 'Herpes_UL1', NULL, NULL, 3341, 9),
(267052, NULL, 'PF11652', NULL, NULL, 'FAM167', NULL, 'FAM167', NULL, NULL, 8948, 9),
(267053, NULL, 'PF13930', NULL, NULL, 'DNA/RNA non-specific endonuclease', NULL, 'Endonuclea_NS_2', NULL, NULL, 36677, 9),
(267054, NULL, 'PF14418', NULL, NULL, 'OST-HTH Associated domain', NULL, 'OHA', NULL, NULL, 24757, 9),
(267055, NULL, 'PF03578', NULL, NULL, 'HGWP repeat', NULL, 'HGWP', NULL, NULL, 5291, 9),
(267056, NULL, 'PF04297', NULL, NULL, 'Putative helix-turn-helix protein, YlxM / p13 like', NULL, 'UPF0122', NULL, NULL, 3795, 9),
(267057, NULL, 'PF08021', NULL, NULL, 'Siderophore-interacting FAD-binding domain', NULL, 'FAD_binding_9', NULL, NULL, 18728, 9),
(267058, NULL, 'PF17728', NULL, NULL, 'BsuBI/PstI restriction endonuclease HTH domain', NULL, 'BsuBI_PstI_RE_N', NULL, NULL, 30217, 9),
(267059, NULL, 'PF00687', NULL, NULL, 'Ribosomal protein L1p/L10e family', NULL, 'Ribosomal_L1', NULL, NULL, 22316, 9),
(267060, NULL, 'PF05477', NULL, NULL, 'Surfeit locus protein 2 (SURF2)', NULL, 'SURF2', NULL, NULL, 13889, 9),
(267061, NULL, 'PF02986', NULL, NULL, 'Fibronectin binding repeat', NULL, 'Fn_bind', NULL, NULL, 3646, 9),
(267062, NULL, 'PF01323', NULL, NULL, 'DSBA-like thioredoxin domain', NULL, 'DSBA', NULL, NULL, 4445, 9),
(267063, NULL, 'PF06127', NULL, NULL, '2-hydroxy-palmitic acid dioxygenase Mpo1-like', NULL, 'Mpo1-like', NULL, NULL, 13663, 9),
(267064, NULL, 'PF08503', NULL, NULL, 'Tetrahydrodipicolinate succinyltransferase N-terminal', NULL, 'DapH_N', NULL, NULL, 13536, 9),
(267065, NULL, 'PF12732', NULL, NULL, 'YtxH-like protein', NULL, 'YtxH', NULL, NULL, 23642, 9),
(267066, NULL, 'PF18187', NULL, NULL, 'TbRIF5 SNase domain 1', NULL, 'RIF5_SNase_1', NULL, NULL, 28468, 9),
(267067, NULL, 'PF09912', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2141)', NULL, 'DUF2141', NULL, NULL, 17082, 9),
(267068, NULL, 'PF18439', NULL, NULL, 'Ubiquitin-Binding Zinc Finger', NULL, 'zf_UBZ', NULL, NULL, 29059, 9),
(267069, NULL, 'PF07920', NULL, NULL, 'Protein of unknown function (DUF1684)', NULL, 'DUF1684', NULL, NULL, 14402, 9),
(267070, NULL, 'PF15241', NULL, NULL, 'Cylicin N-terminus', NULL, 'Cylicin_N', NULL, NULL, 26418, 9),
(267071, NULL, 'PF02731', NULL, NULL, 'SKIP/SNW domain', NULL, 'SKIP_SNW', NULL, NULL, 558, 9),
(267072, NULL, 'PF03362', NULL, NULL, 'Herpesvirus UL47 protein', NULL, 'Herpes_UL47', NULL, NULL, 1056, 9),
(267073, NULL, 'PF01516', NULL, NULL, 'Orbivirus helicase VP6', NULL, 'Orbi_VP6', NULL, NULL, 7175, 9),
(267074, NULL, 'PF14136', NULL, NULL, 'Domain of unknown function (DUF4303)', NULL, 'DUF4303', NULL, NULL, 26074, 9),
(267075, NULL, 'PF02924', NULL, NULL, 'Bacteriophage lambda head decoration protein D', NULL, 'HDPD', NULL, NULL, 4316, 9),
(267076, NULL, 'PF02720', NULL, NULL, 'Domain of unknown function (DUF222)', NULL, 'DUF222', NULL, NULL, 6244, 9),
(267077, NULL, 'PF19677', NULL, NULL, 'Family of unknown function (DUF6179)', NULL, 'DUF6179', NULL, NULL, 36344, 9),
(267078, NULL, 'PF02790', NULL, NULL, 'Cytochrome C oxidase subunit II, transmembrane domain', NULL, 'COX2_TM', NULL, NULL, 8294, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(267079, NULL, 'PF09233', NULL, NULL, 'Restriction endonuclease EcoRV', NULL, 'Endonuc-EcoRV', NULL, NULL, 13156, 9),
(267080, NULL, 'PF13738', NULL, NULL, 'Pyridine nucleotide-disulphide oxidoreductase', NULL, 'Pyr_redox_3', NULL, NULL, NULL, 9),
(267081, NULL, 'PF15533', NULL, NULL, 'Bacterial toxin 33', NULL, 'Ntox33', NULL, NULL, 23563, 9),
(267082, NULL, 'PF15749', NULL, NULL, 'MRN-interacting protein', NULL, 'MRNIP', NULL, NULL, 21859, 9),
(267083, NULL, 'PF08075', NULL, NULL, 'NOPS (NUC059) domain', NULL, 'NOPS', NULL, NULL, 11970, 9),
(267084, NULL, 'PF08913', NULL, NULL, 'Vinculin Binding Site', NULL, 'VBS', NULL, NULL, 7540, 9),
(267085, NULL, 'PF01837', NULL, NULL, 'Homocysteine biosynthesis enzyme, sulfur-incorporation', NULL, 'HcyBio', NULL, NULL, 3844, 9),
(267086, NULL, 'PF11219', NULL, NULL, 'Protein of unknown function (DUF3014)', NULL, 'DUF3014', NULL, NULL, 18317, 9),
(267087, NULL, 'PF16070', NULL, NULL, 'Transmembrane protein family 132', NULL, 'TMEM132', NULL, NULL, 24330, 9),
(267088, NULL, 'PF16879', NULL, NULL, 'C-terminal domain of Sin3a protein', NULL, 'Sin3a_C', NULL, NULL, 24365, 9),
(267089, NULL, 'PF05144', NULL, NULL, 'Phage replication protein CRI', NULL, 'Phage_CRI', NULL, NULL, 14670, 9),
(267090, NULL, 'PF20292', NULL, NULL, 'ABC-three component (ABC-3C) system Middle Component 7', NULL, 'MC7', NULL, NULL, 33850, 9),
(267091, NULL, 'PF12027', NULL, NULL, 'Protein of unknown function (DUF3514)', NULL, 'DUF3514', NULL, NULL, 19837, 9),
(267092, NULL, 'PF02323', NULL, NULL, 'Egg-laying hormone precursor', NULL, 'ELH', NULL, NULL, 5476, 9),
(267093, NULL, 'PF04913', NULL, NULL, 'Baculovirus Y142 protein', NULL, 'Baculo_Y142', NULL, NULL, 6464, 9),
(267094, NULL, 'PF09754', NULL, NULL, 'PAC2 family', NULL, 'PAC2', NULL, NULL, 18232, 9),
(267095, NULL, 'PF14291', NULL, NULL, 'Domain of unknown function (DUF4371)', NULL, 'DUF4371', NULL, NULL, 21643, 9),
(267096, NULL, 'PF20576', NULL, NULL, 'HEWD domain', NULL, 'HEWD', NULL, NULL, 37664, 9),
(267097, NULL, 'PF06910', NULL, NULL, 'Male enhanced antigen 1 (MEA1)', NULL, 'MEA1', NULL, NULL, NULL, 9),
(267098, NULL, 'PF09588', NULL, NULL, 'YqaJ-like viral recombinase domain', NULL, 'YqaJ', NULL, NULL, 16915, 9),
(267099, NULL, 'PF06792', NULL, NULL, 'Uncharacterised protein family (UPF0261)', NULL, 'UPF0261', NULL, NULL, 35105, 9),
(267100, NULL, 'PF03360', NULL, NULL, 'Glycosyltransferase family 43', NULL, 'Glyco_transf_43', NULL, NULL, 1093, 9),
(267101, NULL, 'PF16446', NULL, NULL, 'Domain of unknown function (DUF5043)', NULL, 'DUF5043', NULL, NULL, 26804, 9),
(267102, NULL, 'PF20040', NULL, NULL, 'Family of unknown function (DUF6442)', NULL, 'DUF6442', NULL, NULL, 34131, 9),
(267103, NULL, 'PF13027', NULL, NULL, 'Protein of unknown function (DUF3888)', NULL, 'DUF3888', NULL, NULL, 22409, 9),
(267104, NULL, 'PF01276', NULL, NULL, 'Orn/Lys/Arg decarboxylase, major domain', NULL, 'OKR_DC_1', NULL, NULL, 817, 9),
(267105, NULL, 'PF01113', NULL, NULL, 'Dihydrodipicolinate reductase, N-terminus', NULL, 'DapB_N', NULL, NULL, 4963, 9),
(267106, NULL, 'PF16081', NULL, NULL, 'Mycobacterial 2 TMS Phage Holin (M2 Hol) Family', NULL, 'Phage_holin_7_1', NULL, NULL, 22855, 9),
(267107, NULL, 'PF01750', NULL, NULL, 'Hydrogenase maturation protease', NULL, 'HycI', NULL, NULL, 3724, 9),
(267108, NULL, 'PF01818', NULL, NULL, 'Bacteriophage translational regulator', NULL, 'Translat_reg', NULL, NULL, 3538, 9),
(267109, NULL, 'PF20111', NULL, NULL, 'Family of unknown function (DUF6501)', NULL, 'DUF6501', NULL, NULL, 37444, 9),
(267110, NULL, 'PF17202', NULL, NULL, 'Single cache domain 3', NULL, 'sCache_3_3', NULL, NULL, 27277, 9),
(267111, NULL, 'PF17730', NULL, NULL, 'Centrosomal C10orf90', NULL, 'Centro_C10orf90', NULL, NULL, 29407, 9),
(267112, NULL, 'PF02367', NULL, NULL, 'Threonylcarbamoyl adenosine biosynthesis protein TsaE', NULL, 'TsaE', NULL, NULL, 5056, 9),
(267113, NULL, 'PF18044', NULL, NULL, 'CCCH-type zinc finger', NULL, 'zf-CCCH_4', NULL, NULL, 29026, 9),
(267114, NULL, 'PF04136', NULL, NULL, 'Sec34-like family', NULL, 'Sec34', NULL, NULL, 6947, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(267115, NULL, 'PF07831', NULL, NULL, 'Pyrimidine nucleoside phosphorylase C-terminal domain', NULL, 'PYNP_C', NULL, NULL, 18795, 9),
(267116, NULL, 'PF11659', NULL, NULL, 'Protein of unknown function (DUF3261)', NULL, 'DUF3261', NULL, NULL, 18878, 9),
(267117, NULL, 'PF05661', NULL, NULL, 'Protein of unknown function (DUF808)', NULL, 'DUF808', NULL, NULL, 13482, 9),
(267118, NULL, 'PF04180', NULL, NULL, 'Low temperature viability protein', NULL, 'LTV', NULL, NULL, 4966, 9),
(267119, NULL, 'PF09867', NULL, NULL, 'TagF N-terminal domain, Type VI secretion system-associated', NULL, 'TagF_N', NULL, NULL, 18663, 9),
(267120, NULL, 'PF00271', NULL, NULL, 'Helicase conserved C-terminal domain', NULL, 'Helicase_C', NULL, NULL, 3282, 9),
(267121, NULL, 'PF08648', NULL, NULL, 'U4/U6.U5 small nuclear ribonucleoproteins', NULL, 'SNRNP27', NULL, NULL, 7761, 9),
(267122, NULL, 'PF20350', NULL, NULL, 'Family of unknown function (DUF6645)', NULL, 'DUF6645', NULL, NULL, 33873, 9),
(267123, NULL, 'PF11506', NULL, NULL, 'Protein of unknown function (DUF3217)', NULL, 'DUF3217', NULL, NULL, 24280, 9),
(267124, NULL, 'PF09669', NULL, NULL, 'Phage regulatory protein Rha (Phage_pRha)', NULL, 'Phage_pRha', NULL, NULL, 13332, 9),
(267125, NULL, 'PF00303', NULL, NULL, 'Thymidylate synthase', NULL, 'Thymidylat_synt', NULL, NULL, 16438, 9),
(267126, NULL, 'PF19235', NULL, NULL, 'Family of unknown function (DUF5888)', NULL, 'DUF5888', NULL, NULL, 35949, 9),
(267127, NULL, 'PF09430', NULL, NULL, 'ER membrane protein complex subunit 7, beta-sandwich domain', NULL, 'EMC7_beta-sandw', NULL, NULL, 15908, 9),
(267128, NULL, 'PF17810', NULL, NULL, 'Arginine decarboxylase helical bundle domain', NULL, 'Arg_decarb_HB', NULL, NULL, 28094, 9),
(267129, NULL, 'PF02225', NULL, NULL, 'PA domain', NULL, 'PA', NULL, NULL, 1694, 9),
(267130, NULL, 'PF01726', NULL, NULL, 'LexA DNA binding domain', NULL, 'LexA_DNA_bind', NULL, NULL, 11354, 9),
(267131, NULL, 'PF14297', NULL, NULL, 'Domain of unknown function (DUF4373)', NULL, 'DUF4373', NULL, NULL, 21891, 9),
(267132, NULL, 'PF10816', NULL, NULL, 'Domain of unknown function (DUF2760)', NULL, 'DUF2760', NULL, NULL, 17756, 9),
(267133, NULL, 'PF11001', NULL, NULL, 'Protein of unknown function (DUF2841)', NULL, 'DUF2841', NULL, NULL, 17866, 9),
(267134, NULL, 'PF10525', NULL, NULL, 'Engrailed homeobox C-terminal signature domain', NULL, 'Engrail_1_C_sig', NULL, NULL, 19385, 9),
(267135, NULL, 'PF16521', NULL, NULL, 'Myosin VI cargo binding domain', NULL, 'Myosin-VI_CBD', NULL, NULL, 23122, 9),
(267136, NULL, 'PF00235', NULL, NULL, 'Profilin', NULL, 'Profilin', NULL, NULL, 952, 9),
(267137, NULL, 'PF05847', NULL, NULL, 'Nucleopolyhedrovirus late expression factor 3 (LEF-3)', NULL, 'Baculo_LEF-3', NULL, NULL, 8813, 9),
(267138, NULL, 'PF12753', NULL, NULL, 'Nuclear pore complex subunit Nro1', NULL, 'Nro1', NULL, NULL, 26753, 9),
(267139, NULL, 'PF13583', NULL, NULL, 'Metallo-peptidase family M12B Reprolysin-like', NULL, 'Reprolysin_4', NULL, NULL, NULL, 9),
(267140, NULL, 'PF17042', NULL, NULL, 'Nucleotide-binding C-terminal domain', NULL, 'NBD_C', NULL, NULL, 22579, 9),
(267141, NULL, 'PF20043', NULL, NULL, 'Family of unknown function (DUF6445)', NULL, 'DUF6445', NULL, NULL, 34135, 9),
(267142, NULL, 'PF10710', NULL, NULL, 'Protein of unknown function (DUF2512)', NULL, 'DUF2512', NULL, NULL, 20854, 9),
(267143, NULL, 'PF13336', NULL, NULL, 'Acetyl-CoA hydrolase/transferase C-terminal domain', NULL, 'AcetylCoA_hyd_C', NULL, NULL, 26958, 9),
(267144, NULL, 'PF13129', NULL, NULL, 'Protein of unknown function (DUF3953)', NULL, 'DUF3953', NULL, NULL, 25994, 9),
(267145, NULL, 'PF07563', NULL, NULL, 'Protein of unknown function (DUF1541)', NULL, 'DUF1541', NULL, NULL, 13919, 9),
(267146, NULL, 'PF00535', NULL, NULL, 'Glycosyl transferase family 2', NULL, 'Glycos_transf_2', NULL, NULL, 1204, 9),
(267147, NULL, 'PF04209', NULL, NULL, 'Homogentisate 1,2-dioxygenase C-terminal', NULL, 'HgmA_C', NULL, NULL, 33815, 9),
(267148, NULL, 'PF07472', NULL, NULL, 'Fucose-binding lectin II (PA-IIL)', NULL, 'PA-IIL', NULL, NULL, 12889, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(267149, NULL, 'PF11589', NULL, NULL, 'Domain of unknown function (DUF3244)', NULL, 'DUF3244', NULL, NULL, 18836, 9),
(267150, NULL, 'PF02867', NULL, NULL, 'Ribonucleotide reductase, barrel domain', NULL, 'Ribonuc_red_lgC', NULL, NULL, 4655, 9),
(267151, NULL, 'PF02499', NULL, NULL, 'Probable DNA packing protein, C-terminus', NULL, 'DNA_pack_C', NULL, NULL, 6356, 9),
(267152, NULL, 'PF09110', NULL, NULL, 'HAND', NULL, 'HAND', NULL, NULL, 10801, 9),
(267153, NULL, 'PF01959', NULL, NULL, '3-dehydroquinate synthase II', NULL, 'DHQS', NULL, NULL, 4881, 9),
(267154, NULL, 'PF19121', NULL, NULL, 'Family of unknown function (DUF5805)', NULL, 'DUF5805', NULL, NULL, 34640, 9),
(267155, NULL, 'PF01304', NULL, NULL, 'Gas vesicles protein GVPc repeated domain', NULL, 'Gas_vesicle_C', NULL, NULL, 2045, 9),
(267156, NULL, 'PF19991', NULL, NULL, 'Heavy metal associated domain 2', NULL, 'HMA_2', NULL, NULL, NULL, 9),
(267157, NULL, 'PF10627', NULL, NULL, 'Curli assembly protein CsgE', NULL, 'CsgE', NULL, NULL, 20987, 9),
(267158, NULL, 'PF10845', NULL, NULL, 'Protein of unknown function (DUF2576)', NULL, 'DUF2576', NULL, NULL, 14890, 9),
(267159, NULL, 'PF04079', NULL, NULL, 'Segregation and condensation complex subunit ScpB', NULL, 'SMC_ScpB', NULL, NULL, 11445, 9),
(267160, NULL, 'PF08548', NULL, NULL, 'Peptidase M10 serralysin C terminal', NULL, 'Peptidase_M10_C', NULL, NULL, 9664, 9),
(267161, NULL, 'PF10935', NULL, NULL, 'Protein of unknown function (DUF2637)', NULL, 'DUF2637', NULL, NULL, 17654, 9),
(267162, NULL, 'PF07657', NULL, NULL, 'N terminus of Notch ligand C2-like domain', NULL, 'MNNL', NULL, NULL, 10591, 9),
(267163, NULL, 'PF03883', NULL, NULL, 'Peroxide stress protein YaaA', NULL, 'H2O2_YaaD', NULL, NULL, 1862, 9),
(267164, NULL, 'PF15132', NULL, NULL, 'Domain of unknown function (DUF4568)', NULL, 'DUF4568', NULL, NULL, 23448, 9),
(267165, NULL, 'PF16353', NULL, NULL, 'Beta-galactosidase, domain 4', NULL, 'LacZ_4', NULL, NULL, 25267, 9),
(267166, NULL, 'PF05555', NULL, NULL, 'Coxiella burnetii protein of unknown function (DUF762)', NULL, 'DUF762', NULL, NULL, 12148, 9),
(267167, NULL, 'PF01028', NULL, NULL, 'Eukaryotic DNA topoisomerase I, catalytic core', NULL, 'Topoisom_I', NULL, NULL, 11648, 9),
(267168, NULL, 'PF03219', NULL, NULL, 'TLC ATP/ADP transporter', NULL, 'TLC', NULL, NULL, 2967, 9),
(267169, NULL, 'PF01126', NULL, NULL, 'Heme oxygenase', NULL, 'Heme_oxygenase', NULL, NULL, 9305, 9),
(267170, NULL, 'PF08451', NULL, NULL, 'Adenosine/AMP deaminase N-terminal', NULL, 'A_deaminase_N', NULL, NULL, 12350, 9),
(267171, NULL, 'PF05054', NULL, NULL, 'Autographa californica nuclear polyhedrosis virus (AcMNPV) protein', NULL, 'AcMNPV_Ac109', NULL, NULL, 1160, 9),
(267172, NULL, 'PF20539', NULL, NULL, 'Domain of unknown function (DUF6754)', NULL, 'DUF6754', NULL, NULL, 33935, 9),
(267173, NULL, 'PF01505', NULL, NULL, 'Major Vault Protein repeat domain', NULL, 'Vault', NULL, NULL, 29208, 9),
(267174, NULL, 'PF08795', NULL, NULL, 'Putative papain-like cysteine peptidase (DUF1796)', NULL, 'DUF1796', NULL, NULL, 13101, 9),
(267175, NULL, 'PF06345', NULL, NULL, 'DRF Autoregulatory Domain', NULL, 'Drf_DAD', NULL, NULL, 10026, 9),
(267176, NULL, 'PF08481', NULL, NULL, 'GBS Bsp-like repeat', NULL, 'GBS_Bsp-like', NULL, NULL, 13586, 9),
(267177, NULL, 'PF19356', NULL, NULL, 'Domain of unknown function (DUF5933)', NULL, 'DUF5933', NULL, NULL, 36715, 9),
(267178, NULL, 'PF05318', NULL, NULL, 'Tombusvirus movement protein', NULL, 'Tombus_movement', NULL, NULL, 4138, 9),
(267179, NULL, 'PF16588', NULL, NULL, 'C2H2 zinc-finger', NULL, 'zf-C2H2_10', NULL, NULL, NULL, 9),
(267180, NULL, 'PF14888', NULL, NULL, 'Penicillin-binding protein Tp47 domain C', NULL, 'PBP-Tp47_c', NULL, NULL, 26854, 9),
(267181, NULL, 'PF12149', NULL, NULL, 'Herpes simplex virus virion protein 16 C terminal', NULL, 'HSV_VP16_C', NULL, NULL, 15129, 9),
(267182, NULL, 'PF00349', NULL, NULL, 'Hexokinase', NULL, 'Hexokinase_1', NULL, NULL, 16582, 9),
(267183, NULL, 'PF13187', NULL, NULL, '4Fe-4S dicluster domain', NULL, 'Fer4_9', NULL, NULL, 12567, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(267184, NULL, 'PF16592', NULL, NULL, 'REC lobe of CRISPR-associated endonuclease Cas9', NULL, 'Cas9_REC', NULL, NULL, 26742, 9),
(267185, NULL, 'PF13566', NULL, NULL, 'Domain of unknown function (DUF4130', NULL, 'DUF4130', NULL, NULL, 22362, 9),
(267186, NULL, 'PF13791', NULL, NULL, 'Sigma factor regulator C-terminal', NULL, 'Sigma_reg_C', NULL, NULL, 24096, 9),
(267187, NULL, 'PF17417', NULL, NULL, 'Herpesvirus Glycoprotein B PH-like domain', NULL, 'Glycoprot_B_PH2', NULL, NULL, 33365, 9),
(267188, NULL, 'PF10723', NULL, NULL, 'Replication regulatory protein RepB', NULL, 'RepB-RCR_reg', NULL, NULL, 20798, 9),
(267189, NULL, 'PF11313', NULL, NULL, 'Protein of unknown function (DUF3116)', NULL, 'DUF3116', NULL, NULL, 18057, 9),
(267190, NULL, 'PF17456', NULL, NULL, 'Toxin-coregulated pilus protein S', NULL, 'TcpS', NULL, NULL, 18677, 9),
(267191, NULL, 'PF17022', NULL, NULL, 'Polar tube protein 2 from Microsporidia', NULL, 'PTP2', NULL, NULL, 22621, 9),
(267192, NULL, 'PF17385', NULL, NULL, 'Lacto-N-biose phosphorylase central domain', NULL, 'LBP_M', NULL, NULL, 30917, 9),
(267193, NULL, 'PF15570', NULL, NULL, 'Immunity protein 43', NULL, 'Imm43', NULL, NULL, 25156, 9),
(267194, NULL, 'PF12150', NULL, NULL, 'Cytosolic motility protein', NULL, 'MFP2b', NULL, NULL, 15025, 9),
(267195, NULL, 'PF13518', NULL, NULL, 'Helix-turn-helix domain', NULL, 'HTH_28', NULL, NULL, NULL, 9),
(267196, NULL, 'PF19469', NULL, NULL, 'Family of unknown function (DUF6006)', NULL, 'DUF6006', NULL, NULL, 36753, 9),
(267197, NULL, 'PF02188', NULL, NULL, 'GoLoco motif', NULL, 'GoLoco', NULL, NULL, 2659, 9),
(267198, NULL, 'PF06821', NULL, NULL, 'Serine hydrolase', NULL, 'Ser_hydrolase', NULL, NULL, 9343, 9),
(267199, NULL, 'PF19134', NULL, NULL, 'Domain of unknown function (DUF5817)', NULL, 'DUF5817', NULL, NULL, 34729, 9),
(267200, NULL, 'PF19239', NULL, NULL, 'GIY-YIG domain-containing protein', NULL, 'GIY_YIG_domain', NULL, NULL, NULL, 9),
(267201, NULL, 'PF02402', NULL, NULL, 'Lysis protein', NULL, 'Lysis_col', NULL, NULL, 530, 9),
(267202, NULL, 'PF07702', NULL, NULL, 'UTRA domain', NULL, 'UTRA', NULL, NULL, 10929, 9),
(267203, NULL, 'PF01088', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase, family 1', NULL, 'Peptidase_C12', NULL, NULL, 3443, 9),
(267204, NULL, 'PF15473', NULL, NULL, 'PEST, proteolytic signal-containing nuclear protein family', NULL, 'PCNP', NULL, NULL, 26966, 9),
(267205, NULL, 'PF15041', NULL, NULL, 'Domain of unknown function (DUF4531)', NULL, 'DUF4531', NULL, NULL, 26632, 9),
(267206, NULL, 'PF10929', NULL, NULL, 'Protein of unknown function (DUF2811)', NULL, 'DUF2811', NULL, NULL, 17531, 9),
(267207, NULL, 'PF20079', NULL, NULL, 'Family of unknown function (DUF6474)', NULL, 'DUF6474', NULL, NULL, 37003, 9),
(267208, NULL, 'PF05904', NULL, NULL, 'Plant protein of unknown function (DUF863)', NULL, 'DUF863', NULL, NULL, 13667, 9),
(267209, NULL, 'PF18402', NULL, NULL, 'Thioredoxin-like domain', NULL, 'Thioredoxin_14', NULL, NULL, 28991, 9),
(267210, NULL, 'PF12205', NULL, NULL, 'G protein-coupled receptor kinase-interacting protein 1 C term', NULL, 'GIT1_C', NULL, NULL, 20064, 9),
(267211, NULL, 'PF11680', NULL, NULL, 'Protein of unknown function (DUF3276)', NULL, 'DUF3276', NULL, NULL, 19180, 9),
(267212, NULL, 'PF17684', NULL, NULL, 'PH domain of plant-specific actin-binding protein', NULL, 'SCAB-PH', NULL, NULL, 28756, 9),
(267213, NULL, 'PF16515', NULL, NULL, 'Clathrin-binding domain of Huntingtin-interacting protein 1', NULL, 'HIP1_clath_bdg', NULL, NULL, 23318, 9),
(267214, NULL, 'PF12758', NULL, NULL, 'Protein of unknown function (DUF3813)', NULL, 'DUF3813', NULL, NULL, 20576, 9),
(267215, NULL, 'PF12270', NULL, NULL, 'Cytochrome c oxidase subunit IV', NULL, 'Cyt_c_ox_IV', NULL, NULL, 15160, 9),
(267216, NULL, 'PF20588', NULL, NULL, 'Cyclin-D-binding Myb-like transcription factor 1 N-terminal', NULL, 'DMTF1_N', NULL, NULL, 33628, 9),
(267217, NULL, 'PF16102', NULL, NULL, 'ACTH-associated domain', NULL, 'ACTH_assoc', NULL, NULL, 23028, 9),
(267218, NULL, 'PF15141', NULL, NULL, 'Ubiquinol-cytochrome-c reductase complex assembly factor 3', NULL, 'UQCC3', NULL, NULL, 25961, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(267219, NULL, 'PF04956', NULL, NULL, 'TrbC/VIRB2 pilin', NULL, 'TrbC', NULL, NULL, 6889, 9),
(267220, NULL, 'PF02376', NULL, NULL, 'CUT domain', NULL, 'CUT', NULL, NULL, 4498, 9),
(267221, NULL, 'PF05165', NULL, NULL, 'GTP cyclohydrolase III', NULL, 'GCH_III', NULL, NULL, 2033, 9),
(267222, NULL, 'PF10487', NULL, NULL, 'Nucleoporin subcomplex protein binding to Pom34', NULL, 'Nup188', NULL, NULL, 20857, 9),
(267223, NULL, 'PF12057', NULL, NULL, 'BCL2-associated athanogene 6', NULL, 'BAG6', NULL, NULL, 19625, 9),
(267224, NULL, 'PF01735', NULL, NULL, 'Lysophospholipase catalytic domain', NULL, 'PLA2_B', NULL, NULL, 2614, 9),
(267225, NULL, 'PF06884', NULL, NULL, 'Protein of unknown function (DUF1264)', NULL, 'DUF1264', NULL, NULL, 9398, 9),
(267226, NULL, 'PF08219', NULL, NULL, 'Outer membrane protein TOM13', NULL, 'TOM13', NULL, NULL, 13463, 9),
(267227, NULL, 'PF16316', NULL, NULL, 'Domain of unknown function (DUF4956)', NULL, 'DUF4956', NULL, NULL, 25302, 9),
(267228, NULL, 'PF02533', NULL, NULL, 'Photosystem II 4 kDa reaction centre component', NULL, 'PsbK', NULL, NULL, 4449, 9),
(267229, NULL, 'PF17940', NULL, NULL, 'Tetracyclin repressor-like, C-terminal domain', NULL, 'TetR_C_31', NULL, NULL, 30140, 9),
(267230, NULL, 'PF04432', NULL, NULL, 'Coenzyme F420 hydrogenase/dehydrogenase, beta subunit C terminus', NULL, 'FrhB_FdhB_C', NULL, NULL, 10888, 9),
(267231, NULL, 'PF07324', NULL, NULL, 'DiGeorge syndrome critical region 6 (DGCR6) protein', NULL, 'DGCR6', NULL, NULL, 11787, 9),
(267232, NULL, 'PF08998', NULL, NULL, 'Bacterial epsilon antitoxin', NULL, 'Epsilon_antitox', NULL, NULL, 8823, 9),
(267233, NULL, 'PF13717', NULL, NULL, 'zinc-ribbon domain', NULL, 'zinc_ribbon_4', NULL, NULL, 10710, 9),
(267234, NULL, 'PF10808', NULL, NULL, 'Protein of unknown function (DUF2542)', NULL, 'DUF2542', NULL, NULL, 13514, 9),
(267235, NULL, 'PF10918', NULL, NULL, 'Protein of unknown function (DUF2718)', NULL, 'DUF2718', NULL, NULL, 19842, 9),
(267236, NULL, 'PF19980', NULL, NULL, 'Family of unknown function (DUF6416)', NULL, 'DUF6416', NULL, NULL, 37758, 9),
(267237, NULL, 'PF06591', NULL, NULL, 'T4-like phage nuclear disruption protein (Ndd)', NULL, 'Phage_T4_Ndd', NULL, NULL, 9269, 9),
(267238, NULL, 'PF00457', NULL, NULL, 'Glycosyl hydrolases family 11', NULL, 'Glyco_hydro_11', NULL, NULL, 33698, 9),
(267239, NULL, 'PF11380', NULL, NULL, 'Stealth protein CR2, conserved region 2', NULL, 'Stealth_CR2', NULL, NULL, 18788, 9),
(267240, NULL, 'PF15061', NULL, NULL, 'Domain of unknown function (DUF4538)', NULL, 'DUF4538', NULL, NULL, 23491, 9),
(267241, NULL, 'PF16641', NULL, NULL, 'CLIP1 zinc knuckle', NULL, 'CLIP1_ZNF', NULL, NULL, 22869, 9),
(267242, NULL, 'PF01235', NULL, NULL, 'Sodium:alanine symporter family', NULL, 'Na_Ala_symp', NULL, NULL, 3009, 9),
(267243, NULL, 'PF11201', NULL, NULL, 'Protein of unknown function (DUF2982)', NULL, 'DUF2982', NULL, NULL, 18070, 9),
(267244, NULL, 'PF01306', NULL, NULL, 'LacY proton/sugar symporter', NULL, 'LacY_symp', NULL, NULL, 5520, 9),
(267245, NULL, 'PF19172', NULL, NULL, 'Family of unknown function (DUF5854)', NULL, 'DUF5854', NULL, NULL, 34636, 9),
(267246, NULL, 'PF20440', NULL, NULL, 'GvpD basic region 2', NULL, 'GvpD_bR2', NULL, NULL, 37612, 9),
(267247, NULL, 'PF01371', NULL, NULL, 'Trp repressor protein', NULL, 'Trp_repressor', NULL, NULL, 4813, 9),
(267248, NULL, 'PF17607', NULL, NULL, 'Family of unknown function (DUF5503)', NULL, 'DUF5503', NULL, NULL, 21354, 9),
(267249, NULL, 'PF01713', NULL, NULL, 'Smr domain', NULL, 'Smr', NULL, NULL, 2517, 9),
(267250, NULL, 'PF07586', NULL, NULL, 'Protein of unknown function (DUF1552)', NULL, 'HXXSHH', NULL, NULL, 13729, 9),
(267251, NULL, 'PF17556', NULL, NULL, 'MIT-like atracotoxin family', NULL, 'MIT_LIKE_ACTX', NULL, NULL, 13972, 9),
(267252, NULL, 'PF08614', NULL, NULL, 'Autophagy protein 16 (ATG16)', NULL, 'ATG16', NULL, NULL, 14415, 9),
(267253, NULL, 'PF10275', NULL, NULL, 'Peptidase C65 Otubain', NULL, 'Peptidase_C65', NULL, NULL, 16974, 9),
(267254, NULL, 'PF17291', NULL, NULL, 'N-terminal domain of M60-like peptidases', NULL, 'M60-like_N', NULL, NULL, 31018, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(267255, NULL, 'PF00040', NULL, NULL, 'Fibronectin type II domain', NULL, 'fn2', NULL, NULL, 5841, 9),
(267256, NULL, 'PF13673', NULL, NULL, 'Acetyltransferase (GNAT) domain', NULL, 'Acetyltransf_10', NULL, NULL, 1841, 9),
(267257, NULL, 'PF05669', NULL, NULL, 'SOH1', NULL, 'Med31', NULL, NULL, 13542, 9),
(267258, NULL, 'PF02440', NULL, NULL, 'Adenovirus E3 region protein CR1', NULL, 'Adeno_E3_CR1', NULL, NULL, 6002, 9),
(267259, NULL, 'PF03272', NULL, NULL, 'Putative mucin or carbohydrate-binding module', NULL, 'Mucin_bdg', NULL, NULL, 2956, 9),
(267260, NULL, 'PF11470', NULL, NULL, 'TUG ubiquitin-like domain', NULL, 'TUG-UBL1', NULL, NULL, 18870, 9),
(267261, NULL, 'PF01459', NULL, NULL, 'Eukaryotic porin', NULL, 'Porin_3', NULL, NULL, 26752, 9),
(267262, NULL, 'PF09887', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2114)', NULL, 'DUF2114', NULL, NULL, 8825, 9),
(267263, NULL, 'PF20068', NULL, NULL, 'Amphi-Trp domain', NULL, 'Amphi-Trp', NULL, NULL, 23495, 9),
(267264, NULL, 'PF16925', NULL, NULL, 'Tetracyclin repressor-like, C-terminal domain', NULL, 'TetR_C_13', NULL, NULL, 10516, 9),
(267265, NULL, 'PF17449', NULL, NULL, 'Uncharacterized YrzK-like', NULL, 'YrzK', NULL, NULL, 33053, 9),
(267266, NULL, 'PF16620', NULL, NULL, 'Unstructured linker between I-set domains 2 and 3 on MYLCK', NULL, '23ISL', NULL, NULL, NULL, 9),
(267267, NULL, 'PF10711', NULL, NULL, 'Hypothetical protein (DUF2513)', NULL, 'DUF2513', NULL, NULL, 20851, 9),
(267268, NULL, 'PF09105', NULL, NULL, 'Elongation factor SelB, winged helix', NULL, 'SelB-wing_1', NULL, NULL, 10758, 9),
(267269, NULL, 'PF05010', NULL, NULL, 'Transforming acidic coiled-coil-containing protein (TACC), C-terminal', NULL, 'TACC_C', NULL, NULL, 1220, 9),
(267270, NULL, 'PF18317', NULL, NULL, 'Shikimate 5''-dehydrogenase C-terminal domain', NULL, 'SDH_C', NULL, NULL, 28833, 9),
(267271, NULL, 'PF14975', NULL, NULL, 'Domain of unknown function (DUF4512)', NULL, 'DUF4512', NULL, NULL, 25531, 9),
(267272, NULL, 'PF04430', NULL, NULL, 'Protein of unknown function (DUF498/DUF598)', NULL, 'DUF498', NULL, NULL, 10751, 9),
(267273, NULL, 'PF15651', NULL, NULL, 'Salivary glad secreted protein domain toxin', NULL, 'Tox-SGS', NULL, NULL, 24788, 9),
(267274, NULL, 'PF00325', NULL, NULL, 'Bacterial regulatory proteins, crp family', NULL, 'Crp', NULL, NULL, 11789, 9),
(267275, NULL, 'PF07572', NULL, NULL, 'Bucentaur or craniofacial development', NULL, 'BCNT', NULL, NULL, 13880, 9),
(267276, NULL, 'PF09183', NULL, NULL, 'Domain of unknown function (DUF1947)', NULL, 'DUF1947', NULL, NULL, 12430, 9),
(267277, NULL, 'PF12809', NULL, NULL, 'Eukaryotic metallothionein', NULL, 'Metallothi_Euk2', NULL, NULL, 30715, 9),
(267278, NULL, 'PF10366', NULL, NULL, 'Vacuolar sorting protein 39 domain 1', NULL, 'Vps39_1', NULL, NULL, 17333, 9),
(267279, NULL, 'PF18136', NULL, NULL, 'DNA mitochondrial polymerase exonuclease domain', NULL, 'DNApol_Exo', NULL, NULL, 29653, 9),
(267280, NULL, 'PF00695', NULL, NULL, 'Major surface antigen from hepadnavirus', NULL, 'vMSA', NULL, NULL, 4957, 9),
(267281, NULL, 'PF00594', NULL, NULL, 'Vitamin K-dependent carboxylation/gamma-carboxyglutamic (GLA) domain', NULL, 'Gla', NULL, NULL, 4995, 9),
(267282, NULL, 'PF19600', NULL, NULL, 'Family of unknown function (DUF6105)', NULL, 'DUF6105', NULL, NULL, 36926, 9),
(267283, NULL, 'PF09029', NULL, NULL, '5-aminolevulinate synthase presequence', NULL, 'Preseq_ALAS', NULL, NULL, 9833, 9),
(267284, NULL, 'PF09461', NULL, NULL, 'Phytotoxin PcF protein', NULL, 'PcF', NULL, NULL, 15083, 9),
(267285, NULL, 'PF09369', NULL, NULL, 'MrfA Zn-binding domain', NULL, 'MZB', NULL, NULL, 14668, 9),
(267286, NULL, 'PF10167', NULL, NULL, 'BLOC-1-related complex sub-unit 8', NULL, 'BORCS8', NULL, NULL, 14661, 9),
(267287, NULL, 'PF03108', NULL, NULL, 'MuDR family transposase', NULL, 'DBD_Tnp_Mut', NULL, NULL, 4872, 9),
(267288, NULL, 'PF17745', NULL, NULL, 'Ydr279p protein triple barrel domain', NULL, 'Ydr279_N', NULL, NULL, 28648, 9),
(267289, NULL, 'PF08859', NULL, NULL, 'DGC domain', NULL, 'DGC', NULL, NULL, 14099, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(267290, NULL, 'PF15156', NULL, NULL, 'Ceroid-lipofuscinosis neuronal protein 6', NULL, 'CLN6', NULL, NULL, 21605, 9),
(267291, NULL, 'PF18347', NULL, NULL, 'Domain of unknown function (DUF5606)', NULL, 'DUF5606', NULL, NULL, 28942, 9),
(267292, NULL, 'PF05149', NULL, NULL, 'Paraflagellar rod protein', NULL, 'Flagellar_rod', NULL, NULL, 2342, 9),
(267293, NULL, 'PF10851', NULL, NULL, 'Protein of unknown function (DUF2652)', NULL, 'DUF2652', NULL, NULL, 20256, 9),
(267294, NULL, 'PF12129', NULL, NULL, 'Homeodomain containing protein PHTF1/2, N-terminal', NULL, 'PHTF1-2_N', NULL, NULL, 20298, 9),
(267295, NULL, 'PF02443', NULL, NULL, 'Circovirus capsid protein', NULL, 'Circo_capsid', NULL, NULL, 4061, 9),
(267296, NULL, 'PF15404', NULL, NULL, 'Pleckstrin homology domain', NULL, 'PH_4', NULL, NULL, 33480, 9),
(267297, NULL, 'PF18919', NULL, NULL, 'Family of unknown function (DUF5670)', NULL, 'DUF5670', NULL, NULL, 34376, 9),
(267298, NULL, 'PF04278', NULL, NULL, 'Tic22-like family', NULL, 'Tic22', NULL, NULL, 5760, 9),
(267299, NULL, 'PF19163', NULL, NULL, 'Family of unknown function (DUF5845)', NULL, 'DUF5845', NULL, NULL, 34036, 9),
(267300, NULL, 'PF08867', NULL, NULL, 'FRG domain', NULL, 'FRG', NULL, NULL, 14035, 9),
(267301, NULL, 'PF02407', NULL, NULL, 'Putative viral replication protein', NULL, 'Viral_Rep', NULL, NULL, 4172, 9),
(267302, NULL, 'PF05120', NULL, NULL, 'Gas vesicle protein G', NULL, 'GvpG', NULL, NULL, 2488, 9),
(267303, NULL, 'PF07564', NULL, NULL, 'Domain of Unknown Function (DUF1542)', NULL, 'DUF1542', NULL, NULL, 13769, 9),
(267304, NULL, 'PF08220', NULL, NULL, 'DeoR-like helix-turn-helix domain', NULL, 'HTH_DeoR', NULL, NULL, 1253, 9),
(267305, NULL, 'PF10116', NULL, NULL, 'Protein required for attachment to host cells', NULL, 'Host_attach', NULL, NULL, 19909, 9),
(267306, NULL, 'PF14304', NULL, NULL, 'Transcription termination and cleavage factor C-terminal', NULL, 'CSTF_C', NULL, NULL, 26816, 9),
(267307, NULL, 'PF00004', NULL, NULL, 'ATPase family associated with various cellular activities (AAA)', NULL, 'AAA', NULL, NULL, 7026, 9),
(267308, NULL, 'PF04259', NULL, NULL, 'Small, acid-soluble spore protein, gamma-type', NULL, 'SASP_gamma', NULL, NULL, 4765, 9),
(267309, NULL, 'PF10170', NULL, NULL, 'Cysteine-rich domain', NULL, 'C6_DPF', NULL, NULL, 19037, 9),
(267310, NULL, 'PF11093', NULL, NULL, 'Mitochondrial export protein Som1', NULL, 'Mitochondr_Som1', NULL, NULL, 8969, 9),
(267311, NULL, 'PF00057', NULL, NULL, 'Low-density lipoprotein receptor domain class A', NULL, 'Ldl_recept_a', NULL, NULL, 5466, 9),
(267312, NULL, 'PF06163', NULL, NULL, 'Bacterial protein of unknown function (DUF977)', NULL, 'DUF977', NULL, NULL, 9350, 9),
(267313, NULL, 'PF03094', NULL, NULL, 'Mlo family', NULL, 'Mlo', NULL, NULL, 4998, 9),
(267314, NULL, 'PF03826', NULL, NULL, 'OAR motif', NULL, 'OAR', NULL, NULL, 1156, 9),
(267315, NULL, 'PF11296', NULL, NULL, 'Protein of unknown function (DUF3097)', NULL, 'DUF3097', NULL, NULL, 18105, 9),
(267316, NULL, 'PF12309', NULL, NULL, 'KIF-1 binding protein C terminal', NULL, 'KBP_C', NULL, NULL, 20868, 9),
(267317, NULL, 'PF19478', NULL, NULL, 'TrbL/VirB6 plasmid conjugal transfer like protein', NULL, 'TrbL_2', NULL, NULL, 36486, 9),
(267318, NULL, 'PF16504', NULL, NULL, 'Putative virion membrane protein of plant and insect virus', NULL, 'SP24', NULL, NULL, 22734, 9),
(267319, NULL, 'PF05742', NULL, NULL, 'Transport and Golgi organisation 2', NULL, 'TANGO2', NULL, NULL, 13230, 9),
(267320, NULL, 'PF00879', NULL, NULL, 'Defensin propeptide', NULL, 'Defensin_propep', NULL, NULL, 6468, 9),
(267321, NULL, 'PF13048', NULL, NULL, 'Protein of unknown function (DUF3908)', NULL, 'DUF3908', NULL, NULL, 22705, 9),
(267322, NULL, 'PF07359', NULL, NULL, 'Liver-expressed antimicrobial peptide 2 precursor (LEAP-2)', NULL, 'LEAP-2', NULL, NULL, 8449, 9),
(267323, NULL, 'PF15859', NULL, NULL, 'Deleted in esophageal cancer 1 family', NULL, 'DEC1', NULL, NULL, 25998, 9),
(267324, NULL, 'PF10801', NULL, NULL, 'Protein of unknown function (DUF2537)', NULL, 'DUF2537', NULL, NULL, 20229, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(267325, NULL, 'PF05943', NULL, NULL, 'EvpB/VC_A0108, tail sheath N-terminal domain', NULL, 'VipB', NULL, NULL, 35546, 9),
(267326, NULL, 'PF14822', NULL, NULL, 'Vasohibin', NULL, 'Vasohibin', NULL, NULL, 21847, 9),
(267327, NULL, 'PF06798', NULL, NULL, 'PrkA serine protein kinase C-terminal domain', NULL, 'PrkA', NULL, NULL, 9101, 9),
(267328, NULL, 'PF01759', NULL, NULL, 'UNC-6/NTR/C345C module', NULL, 'NTR', NULL, NULL, 9168, 9),
(267329, NULL, 'PF02061', NULL, NULL, 'Lambda Phage CIII', NULL, 'Lambda_CIII', NULL, NULL, 11038, 9),
(267330, NULL, 'PF18540', NULL, NULL, 'Domain of unknown function (DUF5626)', NULL, 'DUF5626', NULL, NULL, 27880, 9),
(267331, NULL, 'PF18069', NULL, NULL, 'DR2241 stabilising domain', NULL, 'DR2241', NULL, NULL, 29190, 9),
(267332, NULL, 'PF20606', NULL, NULL, 'Domain of unknown function (DUF6799)', NULL, 'DUF6799', NULL, NULL, 37608, 9),
(267333, NULL, 'PF20566', NULL, NULL, 'eIF4E-associated protein', NULL, 'Eap1', NULL, NULL, 33651, 9),
(267334, NULL, 'PF05090', NULL, NULL, 'Vitamin K-dependent gamma-carboxylase', NULL, 'VKG_Carbox', NULL, NULL, 1312, 9),
(267335, NULL, 'PF05624', NULL, NULL, 'Lipolysis stimulated receptor (LSR)', NULL, 'LSR', NULL, NULL, 12734, 9),
(267336, NULL, 'PF03419', NULL, NULL, 'Sporulation factor SpoIIGA', NULL, 'Peptidase_U4', NULL, NULL, 10245, 9),
(267337, NULL, 'PF08948', NULL, NULL, 'Bacteriophage PRD1, P5, spike N-terminal', NULL, 'PRD1_P5_spike_N', NULL, NULL, 7620, 9),
(267338, NULL, 'PF01986', NULL, NULL, 'Domain of unknown function DUF123', NULL, 'DUF123', NULL, NULL, 5119, 9),
(267339, NULL, 'PF14537', NULL, NULL, 'Cytochrome c3', NULL, 'Cytochrom_c3_2', NULL, NULL, 13163, 9),
(267340, NULL, 'PF04606', NULL, NULL, 'Ogr/Delta-like zinc finger', NULL, 'Ogr_Delta', NULL, NULL, 596, 9),
(267341, NULL, 'PF02327', NULL, NULL, 'Bacteriochlorophyll A protein', NULL, 'BChl_A', NULL, NULL, 5164, 9),
(267342, NULL, 'PF04987', NULL, NULL, 'Phosphatidylinositolglycan class N (PIG-N)', NULL, 'PigN', NULL, NULL, 12691, 9),
(267343, NULL, 'PF05195', NULL, NULL, 'Aminopeptidase P, N-terminal domain', NULL, 'AMP_N', NULL, NULL, 3270, 9),
(267344, NULL, 'PF04541', NULL, NULL, 'Herpesvirus virion protein U34', NULL, 'Herpes_U34', NULL, NULL, 2589, 9),
(267345, NULL, 'PF00668', NULL, NULL, 'Condensation domain', NULL, 'Condensation', NULL, NULL, 675, 9),
(267346, NULL, 'PF09344', NULL, NULL, 'CT1975-like protein', NULL, 'Cas_CT1975', NULL, NULL, 10592, 9),
(267347, NULL, 'PF04821', NULL, NULL, 'Timeless protein', NULL, 'TIMELESS', NULL, NULL, 4933, 9),
(267348, NULL, 'PF19646', NULL, NULL, 'Family of unknown function (DUF6149)', NULL, 'DUF6149', NULL, NULL, 37155, 9),
(267349, NULL, 'PF08865', NULL, NULL, 'Domain of unknown function (DUF1830)', NULL, 'DUF1830', NULL, NULL, 14436, 9),
(267350, NULL, 'PF12354', NULL, NULL, 'Bacterial adhesion/invasion protein N terminal', NULL, 'Internalin_N', NULL, NULL, 3567, 9),
(267351, NULL, 'PF06958', NULL, NULL, 'S-type Pyocin', NULL, 'Pyocin_S', NULL, NULL, 13938, 9),
(267352, NULL, 'PF08347', NULL, NULL, 'N-terminal CTNNB1 binding', NULL, 'CTNNB1_binding', NULL, NULL, 12689, 9),
(267353, NULL, 'PF12761', NULL, NULL, 'Actin cytoskeleton-regulatory complex protein END3', NULL, 'End3', NULL, NULL, 23029, 9),
(267354, NULL, 'PF02633', NULL, NULL, 'Creatinine amidohydrolase', NULL, 'Creatininase', NULL, NULL, 3155, 9),
(267355, NULL, 'PF06011', NULL, NULL, 'Transient receptor potential (TRP) ion channel', NULL, 'TRP', NULL, NULL, 8019, 9),
(267356, NULL, 'PF02466', NULL, NULL, 'Tim17/Tim22/Tim23/Pmp24 family', NULL, 'Tim17', NULL, NULL, NULL, 9),
(267357, NULL, 'PF09905', NULL, NULL, 'DNA-binding protein VF530', NULL, 'VF530', NULL, NULL, 17322, 9),
(267358, NULL, 'PF05947', NULL, NULL, 'Type VI secretion system, TssF', NULL, 'T6SS_TssF', NULL, NULL, 7743, 9),
(267359, NULL, 'PF06135', NULL, NULL, 'IreB regulatory phosphoprotein', NULL, 'IreB', NULL, NULL, 14210, 9),
(267360, NULL, 'PF18716', NULL, NULL, 'Vms1-associating treble clef domain', NULL, 'VATC', NULL, NULL, 29723, 9),
(267361, NULL, 'PF04199', NULL, NULL, 'Putative cyclase', NULL, 'Cyclase', NULL, NULL, 5016, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(267362, NULL, 'PF09724', NULL, NULL, 'Sister chromatid cohesion protein Dcc1', NULL, 'Dcc1', NULL, NULL, 17869, 9),
(267363, NULL, 'PF11897', NULL, NULL, 'Protein of unknown function (DUF3417)', NULL, 'DUF3417', NULL, NULL, 24710, 9),
(267364, NULL, 'PF04631', NULL, NULL, 'Per os infectivity factor 2', NULL, 'PIF2', NULL, NULL, 2451, 9),
(267365, NULL, 'PF02577', NULL, NULL, 'Bifunctional nuclease domain', NULL, 'BFN_dom', NULL, NULL, 6067, 9),
(267366, NULL, 'PF00234', NULL, NULL, 'Protease inhibitor/seed storage/LTP family', NULL, 'Tryp_alpha_amyl', NULL, NULL, 11347, 9),
(267367, NULL, 'PF03427', NULL, NULL, 'Carbohydrate binding domain (family 19)', NULL, 'CBM_19', NULL, NULL, 10310, 9),
(267368, NULL, 'PF15630', NULL, NULL, 'CENP-S protein', NULL, 'CENP-S', NULL, NULL, 24193, 9),
(267369, NULL, 'PF04566', NULL, NULL, 'RNA polymerase Rpb2, domain 4', NULL, 'RNA_pol_Rpb2_4', NULL, NULL, 294, 9),
(267370, NULL, 'PF09611', NULL, NULL, 'CRISPR-associated protein (Cas_Csy1)', NULL, 'Cas_Csy1', NULL, NULL, 11299, 9),
(267371, NULL, 'PF00300', NULL, NULL, 'Histidine phosphatase superfamily (branch 1)', NULL, 'His_Phos_1', NULL, NULL, 7475, 9),
(267372, NULL, 'PF05996', NULL, NULL, 'Ferredoxin-dependent bilin reductase', NULL, 'Fe_bilin_red', NULL, NULL, 13753, 9),
(267373, NULL, 'PF18472', NULL, NULL, 'HP1451 C-terminal domain', NULL, 'HP1451_C', NULL, NULL, 27887, 9),
(267374, NULL, 'PF13754', NULL, NULL, 'Domain of unknown function', NULL, 'Big_3_4', NULL, NULL, 20342, 9),
(267375, NULL, 'PF01582', NULL, NULL, 'TIR domain', NULL, 'TIR', NULL, NULL, 1854, 9),
(267376, NULL, 'PF12151', NULL, NULL, 'Mannan-binding protein', NULL, 'MVL', NULL, NULL, 20314, 9),
(267377, NULL, 'PF17533', NULL, NULL, 'Family of unknown function (DUF5452)', NULL, 'DUF5452', NULL, NULL, 15080, 9),
(267378, NULL, 'PF02452', NULL, NULL, 'PemK-like, MazF-like toxin of type II toxin-antitoxin system', NULL, 'PemK_toxin', NULL, NULL, 6378, 9),
(267379, NULL, 'PF15424', NULL, NULL, 'Odontogenic ameloblast-associated family', NULL, 'ODAM', NULL, NULL, 22364, 9),
(267380, NULL, 'PF17331', NULL, NULL, 'GFD1 mRNA transport factor', NULL, 'GFD1', NULL, NULL, 19334, 9),
(267381, NULL, 'PF10996', NULL, NULL, 'Beta-Casp domain', NULL, 'Beta-Casp', NULL, NULL, 16973, 9),
(267382, NULL, 'PF16421', NULL, NULL, 'E2F transcription factor CC-MB domain', NULL, 'E2F_CC-MB', NULL, NULL, 24165, 9),
(267383, NULL, 'PF13574', NULL, NULL, 'Metallo-peptidase family M12B Reprolysin-like', NULL, 'Reprolysin_2', NULL, NULL, NULL, 9),
(267384, NULL, 'PF15999', NULL, NULL, 'Domain of unknown function (DUF4774)', NULL, 'DUF4774', NULL, NULL, 25617, 9),
(267385, NULL, 'PF14909', NULL, NULL, 'Spermatogenesis-assoc protein 6', NULL, 'SPATA6', NULL, NULL, 26007, 9),
(267386, NULL, 'PF16190', NULL, NULL, 'Ubiquitin-activating enzyme E1 FCCH domain', NULL, 'E1_FCCH', NULL, NULL, 25200, 9),
(267387, NULL, 'PF17407', NULL, NULL, 'Nrap protein domain 6', NULL, 'Nrap_D6', NULL, NULL, 9607, 9),
(267388, NULL, 'PF13123', NULL, NULL, 'Protein of unknown function (DUF3978)', NULL, 'DUF3978', NULL, NULL, 25792, 9),
(267389, NULL, 'PF03668', NULL, NULL, 'P-loop ATPase protein family', NULL, 'ATP_bind_2', NULL, NULL, 6056, 9),
(267390, NULL, 'PF08996', NULL, NULL, 'DNA Polymerase alpha zinc finger', NULL, 'zf-DNA_Pol', NULL, NULL, 8647, 9),
(267391, NULL, 'PF10715', NULL, NULL, 'T4-page Endoribonuclease RegB', NULL, 'REGB_T4', NULL, NULL, 20903, 9),
(267392, NULL, 'PF06446', NULL, NULL, 'Hepcidin', NULL, 'Hepcidin', NULL, NULL, 10116, 9),
(267393, NULL, 'PF00719', NULL, NULL, 'Inorganic pyrophosphatase', NULL, 'Pyrophosphatase', NULL, NULL, 7463, 9),
(267394, NULL, 'PF16493', NULL, NULL, 'N-terminal of Homeobox Meis and PKNOX1', NULL, 'Meis_PKNOX_N', NULL, NULL, 24209, 9),
(267395, NULL, 'PF19798', NULL, NULL, 'Sulfotransferase domain', NULL, 'Sulfotransfer_5', NULL, NULL, NULL, 9),
(267396, NULL, 'PF15093', NULL, NULL, 'Domain of unknown function (DUF4555)', NULL, 'DUF4555', NULL, NULL, 23775, 9),
(267397, NULL, 'PF12104', NULL, NULL, 'T cell CD4 receptor C terminal region', NULL, 'Tcell_CD4_C', NULL, NULL, 20402, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(267398, NULL, 'PF09479', NULL, NULL, 'Listeria-Bacteroides repeat domain (List_Bact_rpt)', NULL, 'Flg_new', NULL, NULL, 11286, 9),
(267399, NULL, 'PF10984', NULL, NULL, 'Protein of unknown function (DUF2794)', NULL, 'DUF2794', NULL, NULL, 17673, 9),
(267400, NULL, 'PF14617', NULL, NULL, 'U3-containing 90S pre-ribosomal complex subunit', NULL, 'CMS1', NULL, NULL, 21641, 9),
(267401, NULL, 'PF05436', NULL, NULL, 'Mating factor alpha precursor N-terminus', NULL, 'MF_alpha_N', NULL, NULL, 12720, 9),
(267402, NULL, 'PF08912', NULL, NULL, 'Rho Binding', NULL, 'Rho_Binding', NULL, NULL, 7790, 9),
(267403, NULL, 'PF01349', NULL, NULL, 'Flavivirus non-structural protein NS4B', NULL, 'Flavi_NS4B', NULL, NULL, 5626, 9),
(267404, NULL, 'PF03784', NULL, NULL, 'Cyclotide family', NULL, 'Cyclotide', NULL, NULL, 1658, 9),
(267405, NULL, 'PF16771', NULL, NULL, 'Regulator of Ty1 transposition protein 107 BRCT domain', NULL, 'RTT107_BRCT_6', NULL, NULL, 22322, 9),
(267406, NULL, 'PF00183', NULL, NULL, 'Hsp90 protein', NULL, 'HSP90', NULL, NULL, 7377, 9),
(267407, NULL, 'PF11387', NULL, NULL, 'Protein of unknown function (DUF2795)', NULL, 'DUF2795', NULL, NULL, 18741, 9),
(267408, NULL, 'PF19726', NULL, NULL, 'Family of unknown function (DUF6218)', NULL, 'DUF6218', NULL, NULL, 37397, 9),
(267409, NULL, 'PF00176', NULL, NULL, 'SNF2-related domain', NULL, 'SNF2-rel_dom', NULL, NULL, 4793, 9),
(267410, NULL, 'PF15047', NULL, NULL, 'Protein of unknown function (DUF4533)', NULL, 'DUF4533', NULL, NULL, 25558, 9),
(267411, NULL, 'PF20005', NULL, NULL, 'FtsH ternary system domain X7', NULL, 'fvmX7', NULL, NULL, 34399, 9),
(267412, NULL, 'PF16437', NULL, NULL, 'Domain of unknown function (DUF5034)', NULL, 'DUF5034', NULL, NULL, 24066, 9),
(267413, NULL, 'PF07130', NULL, NULL, 'YebG protein', NULL, 'YebG', NULL, NULL, 13404, 9),
(267414, NULL, 'PF12855', NULL, NULL, 'ECL1/2/3 zinc binding proteins', NULL, 'Ecl1', NULL, NULL, 22528, 9),
(267415, NULL, 'PF10134', NULL, NULL, 'Replication initiator protein A', NULL, 'RPA', NULL, NULL, 19206, 9),
(267416, NULL, 'PF07002', NULL, NULL, 'Copine', NULL, 'Copine', NULL, NULL, 9710, 9),
(267417, NULL, 'PF00630', NULL, NULL, 'Filamin/ABP280 repeat', NULL, 'Filamin', NULL, NULL, 11400, 9),
(267418, NULL, 'PF20446', NULL, NULL, 'ATPase of the ABC class N-terminal', NULL, 'ABC_N', NULL, NULL, 37595, 9),
(267419, NULL, 'PF19859', NULL, NULL, 'Family of unknown function (DUF6333)', NULL, 'DUF6333', NULL, NULL, NULL, 9),
(267420, NULL, 'PF04663', NULL, NULL, 'Phenol hydroxylase conserved region', NULL, 'Phenol_monoox', NULL, NULL, 2532, 9),
(267421, NULL, 'PF19289', NULL, NULL, 'PmbA/TldA metallopeptidase C-terminal domain', NULL, 'PmbA_TldD_C', NULL, NULL, 36224, 9),
(267422, NULL, 'PF01286', NULL, NULL, 'XPA protein N-terminal', NULL, 'XPA_N', NULL, NULL, 16808, 9),
(267423, NULL, 'PF05123', NULL, NULL, 'S-layer like family, N-terminal region', NULL, 'S_layer_N', NULL, NULL, 16770, 9),
(267424, NULL, 'PF20341', NULL, NULL, 'Family of unknown function (DUF6636)', NULL, 'DUF6636', NULL, NULL, 33865, 9),
(267425, NULL, 'PF07499', NULL, NULL, 'RuvA, C-terminal domain', NULL, 'RuvA_C', NULL, NULL, 11453, 9),
(267426, NULL, 'PF12927', NULL, NULL, 'Domain of unknown function (DUF3835)', NULL, 'DUF3835', NULL, NULL, 26540, 9),
(267427, NULL, 'PF15950', NULL, NULL, 'Putative sperm flagellar membrane protein', NULL, 'DUF4758', NULL, NULL, 22107, 9),
(267428, NULL, 'PF14360', NULL, NULL, 'PAP2 superfamily C-terminal', NULL, 'PAP2_C', NULL, NULL, 22367, 9),
(267429, NULL, 'PF18216', NULL, NULL, 'N-formyltransferase dimerization C-terminal domain', NULL, 'N_formyltrans_C', NULL, NULL, 28751, 9),
(267430, NULL, 'PF20312', NULL, NULL, 'Family of unknown function (DUF6608)', NULL, 'DUF6608', NULL, NULL, 37458, 9),
(267431, NULL, 'PF14014', NULL, NULL, 'Protein of unknown function (DUF4230)', NULL, 'DUF4230', NULL, NULL, 22456, 9),
(267432, NULL, 'PF08389', NULL, NULL, 'Exportin 1-like protein', NULL, 'Xpo1', NULL, NULL, 11139, 9),
(267433, NULL, 'PF11663', NULL, NULL, 'Toxin with endonuclease activity, of toxin-antitoxin system', NULL, 'Toxin_YhaV', NULL, NULL, 19272, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(267434, NULL, 'PF16325', NULL, NULL, 'Peptidase family U32 C-terminal domain', NULL, 'Peptidase_U32_C', NULL, NULL, 26430, 9),
(267435, NULL, 'PF12026', NULL, NULL, 'Crk-Associated Substrate C-terminal domain', NULL, 'CAS_C', NULL, NULL, 19913, 9),
(267436, NULL, 'PF03893', NULL, NULL, 'Lipase 3 N-terminal region', NULL, 'Lipase3_N', NULL, NULL, 2629, 9),
(267437, NULL, 'PF14693', NULL, NULL, 'Ribosomal protein TL5, C-terminal domain', NULL, 'Ribosomal_TL5_C', NULL, NULL, 16135, 9),
(267438, NULL, 'PF01301', NULL, NULL, 'Glycosyl hydrolases family 35', NULL, 'Glyco_hydro_35', NULL, NULL, 16926, 9),
(267439, NULL, 'PF10131', NULL, NULL, '6-pyruvoyl-tetrahydropterin synthase related domain; membrane protein', NULL, 'PTPS_related', NULL, NULL, 19489, 9),
(267440, NULL, 'PF18282', NULL, NULL, 'RAP80 N-terminal ubiquitin interaction motif', NULL, 'RAP80_UIM', NULL, NULL, 27906, 9),
(267441, NULL, 'PF14656', NULL, NULL, 'Rab3 GTPase-activating protein regulatory subunit C-terminus', NULL, 'RAB3GAP2_C', NULL, NULL, 21894, 9),
(267442, NULL, 'PF20421', NULL, NULL, 'DHR-2, Lobe C', NULL, 'DHR-2_Lobe_C', NULL, NULL, 33952, 9),
(267443, NULL, 'PF01464', NULL, NULL, 'Transglycosylase SLT domain', NULL, 'SLT', NULL, NULL, 8903, 9),
(267444, NULL, 'PF03728', NULL, NULL, 'Viral DNA-binding protein, zinc binding domain', NULL, 'Viral_DNA_Zn_bi', NULL, NULL, 6073, 9),
(267445, NULL, 'PF14384', NULL, NULL, 'BrnA antitoxin of type II toxin-antitoxin system', NULL, 'BrnA_antitoxin', NULL, NULL, 26005, 9),
(267446, NULL, 'PF09263', NULL, NULL, 'Peroxisome biogenesis factor 1, N-terminal', NULL, 'PEX-2N', NULL, NULL, 13198, 9),
(267447, NULL, 'PF07369', NULL, NULL, 'Protein of unknown function (DUF1488)', NULL, 'DUF1488', NULL, NULL, 8034, 9),
(267448, NULL, 'PF14034', NULL, NULL, 'Sporulation protein YtrH', NULL, 'Spore_YtrH', NULL, NULL, 24834, 9),
(267449, NULL, 'PF17725', NULL, NULL, 'YAP binding domain', NULL, 'YBD', NULL, NULL, 29225, 9),
(267450, NULL, 'PF09664', NULL, NULL, 'Protein of unknown function C-terminus (DUF2399)', NULL, 'DUF2399', NULL, NULL, 21923, 9),
(267451, NULL, 'PF05641', NULL, NULL, 'Agenet domain', NULL, 'Agenet', NULL, NULL, 7927, 9),
(267452, NULL, 'PF07120', NULL, NULL, 'Protein of unknown function (DUF1376)', NULL, 'DUF1376', NULL, NULL, 10968, 9),
(267453, NULL, 'PF14541', NULL, NULL, 'Xylanase inhibitor C-terminal', NULL, 'TAXi_C', NULL, NULL, 22336, 9),
(267454, NULL, 'PF03695', NULL, NULL, 'Uncharacterised protein family (UPF0149)', NULL, 'UPF0149', NULL, NULL, 13124, 9),
(267455, NULL, 'PF13639', NULL, NULL, 'Ring finger domain', NULL, 'zf-RING_2', NULL, NULL, 4043, 9),
(267456, NULL, 'PF16903', NULL, NULL, 'Major capsid protein N-terminus', NULL, 'Capsid_N', NULL, NULL, 22995, 9),
(267457, NULL, 'PF06083', NULL, NULL, 'Interleukin-17', NULL, 'IL17', NULL, NULL, 8981, 9),
(267458, NULL, 'PF06726', NULL, NULL, 'Bladder cancer-related protein BC10', NULL, 'BC10', NULL, NULL, NULL, 9),
(267459, NULL, 'PF11849', NULL, NULL, 'Domain of unknown function (DUF3369)', NULL, 'DUF3369', NULL, NULL, 19336, 9),
(267460, NULL, 'PF12752', NULL, NULL, 'SUZ domain', NULL, 'SUZ', NULL, NULL, 15462, 9),
(267461, NULL, 'PF08377', NULL, NULL, 'MAP2/Tau projection domain', NULL, 'MAP2_projctn', NULL, NULL, 11816, 9),
(267462, NULL, 'PF10329', NULL, NULL, 'Region of unknown function (DUF2417)', NULL, 'DUF2417', NULL, NULL, 17347, 9),
(267463, NULL, 'PF20381', NULL, NULL, 'Family of unknown function (DUF6676)', NULL, 'DUF6676', NULL, NULL, 37554, 9),
(267464, NULL, 'PF02146', NULL, NULL, 'Sir2 family', NULL, 'SIR2', NULL, NULL, 7473, 9),
(267465, NULL, 'PF04844', NULL, NULL, 'Transcriptional repressor, ovate', NULL, 'Ovate', NULL, NULL, 6954, 9),
(267466, NULL, 'PF10045', NULL, NULL, 'Uncharacterized conserved protein (DUF2280)', NULL, 'DUF2280', NULL, NULL, 18295, 9),
(267467, NULL, 'PF10666', NULL, NULL, 'Phage tail assembly chaperone protein Gp14 ()A118', NULL, 'Phage_TAC_8', NULL, NULL, 14955, 9),
(267468, NULL, 'PF06282', NULL, NULL, 'Protein of unknown function (DUF1036)', NULL, 'DUF1036', NULL, NULL, 8342, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(267469, NULL, 'PF16584', NULL, NULL, 'Outer membrane lipoprotein carrier protein LolA', NULL, 'LolA_2', NULL, NULL, 617, 9),
(267470, NULL, 'PF07450', NULL, NULL, 'Formate hydrogenlyase maturation protein HycH', NULL, 'HycH', NULL, NULL, 8578, 9),
(267471, NULL, 'PF08298', NULL, NULL, 'PrkA AAA domain', NULL, 'AAA_PrkA', NULL, NULL, 8419, 9),
(267472, NULL, 'PF18889', NULL, NULL, 'Beta helix repeat', NULL, 'Beta_helix_3', NULL, NULL, NULL, 9),
(267473, NULL, 'PF14128', NULL, NULL, 'Domain of unknown function (DUF4295)', NULL, 'DUF4295', NULL, NULL, 26018, 9),
(267474, NULL, 'PF01123', NULL, NULL, 'Staphylococcal/Streptococcal toxin, OB-fold domain', NULL, 'Stap_Strp_toxin', NULL, NULL, 11279, 9),
(267475, NULL, 'PF11571', NULL, NULL, 'Mediator complex subunit 27', NULL, 'Med27', NULL, NULL, 18544, 9),
(267476, NULL, 'PF04889', NULL, NULL, 'Cwf15/Cwc15 cell cycle control protein', NULL, 'Cwf_Cwc_15', NULL, NULL, 5966, 9),
(267477, NULL, 'PF18774', NULL, NULL, 'APOBEC4-like -AID/APOBEC-deaminase', NULL, 'APOBEC4_like', NULL, NULL, 30576, 9),
(267478, NULL, 'PF04513', NULL, NULL, 'Baculovirus polyhedron envelope protein, PEP, C terminus', NULL, 'Baculo_PEP_C', NULL, NULL, 2755, 9),
(267479, NULL, 'PF20480', NULL, NULL, 'Family of unknown function (DUF6720)', NULL, 'DUF6720', NULL, NULL, 37603, 9),
(267480, NULL, 'PF13103', NULL, NULL, 'TonB C terminal', NULL, 'TonB_2', NULL, NULL, NULL, 9),
(267481, NULL, 'PF20573', NULL, NULL, 'Putative metallopeptidase family (DUF6782)', NULL, 'DUF6782', NULL, NULL, 37017, 9),
(267482, NULL, 'PF12179', NULL, NULL, 'I-kappa-kinase-beta NEMO binding domain', NULL, 'IKKbetaNEMObind', NULL, NULL, 20296, 9),
(267483, NULL, 'PF15983', NULL, NULL, 'Domain of unknown function (DUF4767)', NULL, 'DUF4767', NULL, NULL, 25873, 9),
(267484, NULL, 'PF05045', NULL, NULL, 'Rhamnan synthesis protein F', NULL, 'RgpF', NULL, NULL, 1064, 9),
(267485, NULL, 'PF15211', NULL, NULL, 'VEGF co-regulated chemokine 1', NULL, 'CXCL17', NULL, NULL, 21992, 9),
(267486, NULL, 'PF15193', NULL, NULL, 'FAM24 family', NULL, 'FAM24', NULL, NULL, 25946, 9),
(267487, NULL, 'PF05813', NULL, NULL, 'Orthopoxvirus F7 protein', NULL, 'Orthopox_F7', NULL, NULL, 12280, 9),
(267488, NULL, 'PF14792', NULL, NULL, 'DNA polymerase beta palm', NULL, 'DNA_pol_B_palm', NULL, NULL, 22109, 9),
(267489, NULL, 'PF15768', NULL, NULL, 'Coiled-coil domain-containing protein 190', NULL, 'CC190', NULL, NULL, 25120, 9),
(267490, NULL, 'PF17772', NULL, NULL, 'MYST family zinc finger domain', NULL, 'zf-MYST', NULL, NULL, 28179, 9),
(267491, NULL, 'PF08474', NULL, NULL, 'Myelin transcription factor 1', NULL, 'MYT1', NULL, NULL, 13743, 9),
(267492, NULL, 'PF17440', NULL, NULL, 'Thiol-activated cytolysin beta sandwich domain', NULL, 'Thiol_cytolys_C', NULL, NULL, 27003, 9),
(267493, NULL, 'PF11017', NULL, NULL, 'Protein of unknown function (DUF2855)', NULL, 'DUF2855', NULL, NULL, 17643, 9),
(267494, NULL, 'PF12488', NULL, NULL, 'Protein of unknown function (DUF3704)', NULL, 'DUF3704', NULL, NULL, 21299, 9),
(267495, NULL, 'PF04689', NULL, NULL, 'DNA binding protein S1FA', NULL, 'S1FA', NULL, NULL, 3168, 9),
(267496, NULL, 'PF17235', NULL, NULL, 'STD1/MTH1', NULL, 'STD1', NULL, NULL, 20189, 9),
(267497, NULL, 'PF00441', NULL, NULL, 'Acyl-CoA dehydrogenase, C-terminal domain', NULL, 'Acyl-CoA_dh_1', NULL, NULL, 6477, 9),
(267498, NULL, 'PF14017', NULL, NULL, 'Protein of unknown function (DUF4233)', NULL, 'DUF4233', NULL, NULL, 22368, 9),
(267499, NULL, 'PF11391', NULL, NULL, 'Protein of unknown function (DUF2798)', NULL, 'DUF2798', NULL, NULL, 18771, 9),
(267500, NULL, 'PF18082', NULL, NULL, 'N-acyltransferase N-terminal domain', NULL, 'NAT_N', NULL, NULL, 29631, 9),
(267501, NULL, 'PF05222', NULL, NULL, 'Alanine dehydrogenase/PNT, N-terminal domain', NULL, 'AlaDh_PNT_N', NULL, NULL, 3280, 9),
(267502, NULL, 'PF16263', NULL, NULL, 'Domain of unknown function (DUF4917)', NULL, 'DUF4917', NULL, NULL, 21990, 9),
(267503, NULL, 'PF11945', NULL, NULL, 'WAHD domain of WASH complex', NULL, 'WASH_WAHD', NULL, NULL, 19579, 9),
(267504, NULL, 'PF03413', NULL, NULL, 'Peptidase propeptide and YPEB domain', NULL, 'PepSY', NULL, NULL, 24812, 9);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(267505, NULL, 'PF18568', NULL, NULL, 'TRIM C-terminal subgroup One Signature domain', NULL, 'COS', NULL, NULL, 32988, 9),
(267506, NULL, 'PF16055', NULL, NULL, 'Domain of unknown function (DUF4798)', NULL, 'DUF4798', NULL, NULL, 22740, 9),
(267507, NULL, 'PF20320', NULL, NULL, 'Family of unknown function (DUF6615)', NULL, 'DUF6615', NULL, NULL, 37449, 9),
(267508, NULL, 'PF03217', NULL, NULL, 'Surface layer protein A domain', NULL, 'SlpA', NULL, NULL, 26458, 9),
(267509, NULL, 'PF12599', NULL, NULL, 'Protein of unknown function (DUF3768)', NULL, 'DUF3768', NULL, NULL, 21197, 9),
(267510, NULL, 'PF15845', NULL, NULL, 'Cysteine-rich C-terminal 1 family', NULL, 'NICE-1', NULL, NULL, 26098, 9),
(267511, NULL, 'PF07627', NULL, NULL, 'Protein of unknown function (DUF1588)', NULL, 'PSCyt3', NULL, NULL, 10486, 9),
(267512, NULL, 'PF00701', NULL, NULL, 'Dihydrodipicolinate synthetase family', NULL, 'DHDPS', NULL, NULL, 5807, 9),
(267513, NULL, 'PF04021', NULL, NULL, 'Class III signal peptide', NULL, 'Class_IIIsignal', NULL, NULL, 3, 9),
(267514, NULL, 'PF15926', NULL, NULL, 'E3 ubiquitin-protein ligase RNF220', NULL, 'RNF220', NULL, NULL, 22850, 9),
(267515, NULL, 'PF01852', NULL, NULL, 'START domain', NULL, 'START', NULL, NULL, 6155, 9),
(267516, NULL, 'PF07363', NULL, NULL, 'Protein of unknown function (DUF1484)', NULL, 'DUF1484', NULL, NULL, 8286, 9),
(267517, NULL, 'PF06719', NULL, NULL, 'AraC-type transcriptional regulator N-terminus', NULL, 'AraC_N', NULL, NULL, 1809, 9),
(267518, NULL, 'PF20160', NULL, NULL, 'C-JID domain', NULL, 'C-JID', NULL, NULL, 35390, 9),
(267519, NULL, 'PF01839', NULL, NULL, 'FG-GAP repeat', NULL, 'FG-GAP', NULL, NULL, 13796, 9),
(267520, NULL, 'PF13353', NULL, NULL, '4Fe-4S single cluster domain', NULL, 'Fer4_12', NULL, NULL, NULL, 9),
(267521, NULL, 'PF08012', NULL, NULL, 'Protein of unknown function (DUF1702)', NULL, 'DUF1702', NULL, NULL, 11741, 9),
(267522, NULL, 'PF00388', NULL, NULL, 'Phosphatidylinositol-specific phospholipase C, X domain', NULL, 'PI-PLC-X', NULL, NULL, 19, 9),
(267523, NULL, 'PF08276', NULL, NULL, 'PAN-like domain', NULL, 'PAN_2', NULL, NULL, 843, 9),
(267524, NULL, 'PF03974', NULL, NULL, 'Ecotin', NULL, 'Ecotin', NULL, NULL, 2860, 9),
(267525, NULL, 'PF00680', NULL, NULL, 'Viral RNA-dependent RNA polymerase', NULL, 'RdRP_1', NULL, NULL, 1296, 9),
(267526, NULL, 'PF03415', NULL, NULL, 'Clostripain family', NULL, 'Peptidase_C11', NULL, NULL, 10283, 9),
(267527, NULL, 'PF00437', NULL, NULL, 'Type II/IV secretion system protein', NULL, 'T2SSE', NULL, NULL, 3375, 9),
(267528, NULL, 'PF03845', NULL, NULL, 'Spore germination protein', NULL, 'Spore_permease', NULL, NULL, 5080, 9),
(267529, NULL, 'PF11832', NULL, NULL, 'Protein of unknown function (DUF3352)', NULL, 'DUF3352', NULL, NULL, 19092, 9),
(267530, NULL, 'PF09506', NULL, NULL, 'Glucosylglycerol-phosphate phosphatase (Salt_tol_Pase)', NULL, 'Salt_tol_Pase', NULL, NULL, 9693, 9),
(267531, NULL, 'PF03106', NULL, NULL, 'WRKY DNA -binding domain', NULL, 'WRKY', NULL, NULL, 1228, 9),
(267532, NULL, 'PF00740', NULL, NULL, 'Parvovirus coat protein VP2', NULL, 'Parvo_coat', NULL, NULL, 7066, 9),
(267533, NULL, 'PF02002', NULL, NULL, 'TFIIE alpha subunit', NULL, 'TFIIE_alpha', NULL, NULL, 24294, 9),
(267534, NULL, 'PF03782', NULL, NULL, 'AMOP domain', NULL, 'AMOP', NULL, NULL, 1745, 9),
(267535, NULL, 'PF18532', NULL, NULL, 'Domain of unknown function (DUF5621)', NULL, 'DUF5621', NULL, NULL, 29203, 9),
(267536, NULL, 'PF19381', NULL, NULL, 'Family of unknown function (DUF5956)', NULL, 'DUF5956', NULL, NULL, 36540, 9),
(267537, NULL, 'PF02540', NULL, NULL, 'NAD synthase', NULL, 'NAD_synthase', NULL, NULL, 15044, 9),
(267538, NULL, 'PF09391', NULL, NULL, 'Protein of unknown function (DUF2000)', NULL, 'DUF2000', NULL, NULL, 15719, 9),
(267539, NULL, 'PF06897', NULL, NULL, 'Protein of unknown function (DUF1269)', NULL, 'DUF1269', NULL, NULL, 10017, 9),
(267540, NULL, 'PF12667', NULL, NULL, 'NigD-like N-terminal OB domain', NULL, 'NigD_N', NULL, NULL, 20376, 9),
(267541, NULL, 'PF18757', NULL, NULL, 'Nucleotide modification associated domain 5', NULL, 'Nmad5', NULL, NULL, 32477, 9);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(267542, NULL, 'PF20384', NULL, NULL, 'Family of unknown function (DUF6679)', NULL, 'DUF6679', NULL, NULL, 37653, 9),
(267543, NULL, 'PF16476', NULL, NULL, 'Domain of unknown function (DUF5053)', NULL, 'DUF5053', NULL, NULL, 18091, 9),
(267544, NULL, 'PF16983', NULL, NULL, 'Molybdate transporter of MFS superfamily', NULL, 'MFS_MOT1', NULL, NULL, 23954, 9),
(267545, NULL, 'PF01906', NULL, NULL, 'Putative heavy-metal-binding', NULL, 'YbjQ_1', NULL, NULL, 4386, 9),
(267546, NULL, 'PF18559', NULL, NULL, 'Galactose-binding domain-like', NULL, 'Exop_C', NULL, NULL, 30152, 9),
(267547, NULL, 'PF18571', NULL, NULL, 'von Willebrand factor type A C-terminal domain', NULL, 'VWA_3_C', NULL, NULL, 28870, 9),
(267548, NULL, 'PF16404', NULL, NULL, 'Domain of unknown function (DUF5012)', NULL, 'DUF5012', NULL, NULL, 23659, 9),
(267549, NULL, 'PF20155', NULL, NULL, 'Tape measure protein', NULL, 'TMP_3', NULL, NULL, 10085, 9),
(267550, NULL, 'PF02785', NULL, NULL, 'Biotin carboxylase C-terminal domain', NULL, 'Biotin_carb_C', NULL, NULL, 654, 9),
(267551, NULL, 'PF09316', NULL, NULL, 'C-myb, C-terminal', NULL, 'Cmyb_C', NULL, NULL, 14007, 9),
(267552, NULL, 'PF16989', NULL, NULL, 'Type VI secretion, EvfE, EvfF, ImpA, BimE, VC_A0119, VasJ', NULL, 'T6SS_VasJ', NULL, NULL, 18024, 9),
(267553, NULL, 'PF09746', NULL, NULL, 'Tumour-associated protein', NULL, 'Membralin', NULL, NULL, 18224, 9),
(267554, NULL, 'PF15446', NULL, NULL, 'PHD/FYVE-zinc-finger like domain', NULL, 'zf-PHD-like', NULL, NULL, 30789, 9),
(267555, NULL, 'PF10634', NULL, NULL, 'Fe2+ transport protein', NULL, 'Iron_transport', NULL, NULL, 21335, 9),
(267556, NULL, 'PF15823', NULL, NULL, 'UPF0524 of C3orf70', NULL, 'UPF0524', NULL, NULL, 23751, 9),
(267557, NULL, 'PF02662', NULL, NULL, 'Methyl-viologen-reducing hydrogenase, delta subunit', NULL, 'FlpD', NULL, NULL, 3238, 9),
(267558, NULL, 'PF01895', NULL, NULL, 'PhoU domain', NULL, 'PhoU', NULL, NULL, 23811, 9),
(267559, NULL, 'PF19920', NULL, NULL, 'MoxR-vWA-beta-propeller ternary system domain bpX4', NULL, 'bpX4', NULL, NULL, 37263, 9),
(267560, NULL, 'PF16832', NULL, NULL, 'Erythroid krueppel-like transcription factor, transactivation 1', NULL, 'EKLF_TAD1', NULL, NULL, 22164, 9),
(267561, NULL, 'PF11406', NULL, NULL, 'Antimicrobial peptide tachystatin A', NULL, 'Tachystatin_A', NULL, NULL, 16819, 9),
(267562, NULL, 'PF15170', NULL, NULL, 'Calcium/calmodulin-dependent protein kinase II inhibitor', NULL, 'CaM-KIIN', NULL, NULL, 24195, 9),
(267563, NULL, 'PF06121', NULL, NULL, 'Domain of Unknown Function (DUF959)', NULL, 'DUF959', NULL, NULL, 8617, 9),
(267564, NULL, 'PF09312', NULL, NULL, 'SurA N-terminal domain', NULL, 'SurA_N', NULL, NULL, 14380, 9),
(267565, NULL, 'PF19643', NULL, NULL, 'Family of unknown function (DUF6146)', NULL, 'DUF6146', NULL, NULL, 37223, 9),
(267566, NULL, 'PF18050', NULL, NULL, 'Cyclophilin-like family', NULL, 'Cyclophil_like2', NULL, NULL, 28626, 9),
(267567, NULL, 'PF19008', NULL, NULL, 'Family of unknown function (DUF5737)', NULL, 'DUF5737', NULL, NULL, 35468, 9),
(267568, NULL, 'PF16452', NULL, NULL, 'Bacteriophage CI repressor C-terminal domain', NULL, 'Phage_CI_C', NULL, NULL, 22173, 9),
(267569, NULL, 'PF07303', NULL, NULL, 'Occludin homology domain', NULL, 'Occludin_ELL', NULL, NULL, 11958, 9),
(267570, NULL, 'PF16454', NULL, NULL, 'Phosphatidylinositol 3-kinase regulatory subunit P85 inter-SH2 domain', NULL, 'PI3K_P85_iSH2', NULL, NULL, 22317, 9),
(267571, NULL, 'PF10570', NULL, NULL, 'Myelin-PO cytoplasmic C-term p65 binding region', NULL, 'Myelin-PO_C', NULL, NULL, 19254, 9),
(267572, NULL, 'PF07011', NULL, NULL, 'Early Flowering 4 domain', NULL, 'Elf4', NULL, NULL, 12113, 9),
(267573, NULL, 'PF00089', NULL, NULL, 'Trypsin', NULL, 'Trypsin', NULL, NULL, 2102, 9),
(267574, NULL, 'PF18706', NULL, NULL, 'D-ribitol-5-phosphate cytidylyltransferase C-terminal domain', NULL, 'ISPD_C', NULL, NULL, 28045, 9),
(267575, NULL, 'PF02434', NULL, NULL, 'Fringe-like', NULL, 'Fringe', NULL, NULL, 4225, 9),
(267576, NULL, 'PF08149', NULL, NULL, 'BING4CT (NUC141) domain', NULL, 'BING4CT', NULL, NULL, 11552, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(267577, NULL, 'PF05920', NULL, NULL, 'Homeobox KN domain', NULL, 'Homeobox_KN', NULL, NULL, 1874, 9),
(267578, NULL, 'PF19364', NULL, NULL, 'Family of unknown function (DUF5940)', NULL, 'DUF5940', NULL, NULL, 36725, 9),
(267579, NULL, 'PF20168', NULL, NULL, 'Sister chromatid cohesion protein PDS5 protein', NULL, 'PDS5', NULL, NULL, NULL, 9),
(267580, NULL, 'PF18169', NULL, NULL, 'SMODS and SLOG-associating 2TM effector domain 6', NULL, 'SLATT_6', NULL, NULL, 28949, 9),
(267581, NULL, 'PF01017', NULL, NULL, 'STAT protein, all-alpha domain', NULL, 'STAT_alpha', NULL, NULL, 10649, 9),
(267582, NULL, 'PF03370', NULL, NULL, 'Carbohydrate/starch-binding module (family 21)', NULL, 'CBM_21', NULL, NULL, 2080, 9),
(267583, NULL, 'PF03626', NULL, NULL, 'Prokaryotic Cytochrome C oxidase subunit IV', NULL, 'COX4_pro', NULL, NULL, 4595, 9),
(267584, NULL, 'PF15428', NULL, NULL, 'Immunity protein 26', NULL, 'Imm26', NULL, NULL, 26156, 9),
(267585, NULL, 'PF01730', NULL, NULL, 'UreF', NULL, 'UreF', NULL, NULL, 2583, 9),
(267586, NULL, 'PF12100', NULL, NULL, 'Domain of unknown function (DUF3576)', NULL, 'DUF3576', NULL, NULL, 20479, 9),
(267587, NULL, 'PF09337', NULL, NULL, 'H2C2 zinc finger', NULL, 'zf-H2C2', NULL, NULL, 7231, 9),
(267588, NULL, 'PF11612', NULL, NULL, 'Type II secretion system (T2SS), protein J', NULL, 'T2SSJ', NULL, NULL, 5262, 9),
(267589, NULL, 'PF01608', NULL, NULL, 'I/LWEQ domain', NULL, 'I_LWEQ', NULL, NULL, 1690, 9),
(267590, NULL, 'PF09023', NULL, NULL, 'Staphostatin B', NULL, 'Staphostatin_B', NULL, NULL, 9677, 9),
(267591, NULL, 'PF09757', NULL, NULL, 'Arb2 domain', NULL, 'Arb2', NULL, NULL, 18099, 9),
(267592, NULL, 'PF19318', NULL, NULL, 'Family of unknown function (DUF5918)', NULL, 'DUF5918', NULL, NULL, 36037, 9),
(267593, NULL, 'PF18751', NULL, NULL, 'P-loop Nucleotide Kinase3', NULL, 'Ploopntkinase3', NULL, NULL, 28895, 9),
(267594, NULL, 'PF06228', NULL, NULL, 'Haem utilisation ChuX/HutX', NULL, 'ChuX_HutX', NULL, NULL, 9497, 9),
(267595, NULL, 'PF15536', NULL, NULL, 'Bacterial toxin 3', NULL, 'Ntox3', NULL, NULL, 23778, 9),
(267596, NULL, 'PF16290', NULL, NULL, 'Domain of unknown function (DUF4936)', NULL, 'DUF4936', NULL, NULL, 21749, 9),
(267597, NULL, 'PF03476', NULL, NULL, 'MOSC N-terminal beta barrel domain', NULL, 'MOSC_N', NULL, NULL, 5131, 9),
(267598, NULL, 'PF19585', NULL, NULL, 'Family of unknown function (DUF6092)', NULL, 'DUF6092', NULL, NULL, 36984, 9),
(267599, NULL, 'PF12985', NULL, NULL, 'Domain of unknown function (DUF3869)', NULL, 'DUF3869', NULL, NULL, 3391, 9),
(267600, NULL, 'PF07400', NULL, NULL, 'Interleukin 11', NULL, 'IL11', NULL, NULL, 20822, 9),
(267601, NULL, 'PF17056', NULL, NULL, 'Killer toxin-resistance protein 1', NULL, 'KRE1', NULL, NULL, 22893, 9),
(267602, NULL, 'PF18525', NULL, NULL, 'Cas9 C-terminal domain', NULL, 'Cas9_C', NULL, NULL, 29087, 9),
(267603, NULL, 'PF13732', NULL, NULL, 'Domain of unknown function (DUF4162)', NULL, 'DUF4162', NULL, NULL, 23125, 9),
(267604, NULL, 'PF14113', NULL, NULL, 'Type VI secretion system (T6SS), amidase effector protein 4', NULL, 'Tae4', NULL, NULL, 23281, 9),
(267605, NULL, 'PF14191', NULL, NULL, 'YodL-like', NULL, 'YodL', NULL, NULL, 24555, 9),
(267606, NULL, 'PF07925', NULL, NULL, 'Reovirus RNA-dependent RNA polymerase lambda 3', NULL, 'RdRP_5', NULL, NULL, 13447, 9),
(267607, NULL, 'PF03140', NULL, NULL, 'Plant protein of unknown function', NULL, 'DUF247', NULL, NULL, 2671, 9),
(267608, NULL, 'PF12275', NULL, NULL, 'Protein of unknown function (DUF3616)', NULL, 'DUF3616', NULL, NULL, 20765, 9),
(267609, NULL, 'PF08951', NULL, NULL, 'Enterocin A Immunity', NULL, 'EntA_Immun', NULL, NULL, 7852, 9),
(267610, NULL, 'PF04621', NULL, NULL, 'PEA3 subfamily ETS-domain transcription factor N terminal domain', NULL, 'ETS_PEA3_N', NULL, NULL, 2218, 9),
(267611, NULL, 'PF15147', NULL, NULL, 'Domain of unknown function (DUF4578)', NULL, 'DUF4578', NULL, NULL, 24897, 9),
(267612, NULL, 'PF05046', NULL, NULL, 'Mitochondrial large subunit ribosomal protein (Img2)', NULL, 'Img2', NULL, NULL, 1488, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(267613, NULL, 'PF13350', NULL, NULL, 'Tyrosine phosphatase family', NULL, 'Y_phosphatase3', NULL, NULL, 26861, 9),
(267614, NULL, 'PF08564', NULL, NULL, 'Cdc37 C terminal domain', NULL, 'CDC37_C', NULL, NULL, 9721, 9),
(267615, NULL, 'PF12304', NULL, NULL, 'Beta-casein like protein', NULL, 'BCLP', NULL, NULL, 15503, 9),
(267616, NULL, 'PF13104', NULL, NULL, 'Protein of unknown function (DUF3956)', NULL, 'DUF3956', NULL, NULL, 22178, 9),
(267617, NULL, 'PF02185', NULL, NULL, 'Hr1 repeat', NULL, 'HR1', NULL, NULL, 10484, 9),
(267618, NULL, 'PF16704', NULL, NULL, 'Rab binding domain', NULL, 'Rab_bind', NULL, NULL, 23117, 9),
(267619, NULL, 'PF16184', NULL, NULL, 'Cadherin-like', NULL, 'Cadherin_3', NULL, NULL, NULL, 9),
(267620, NULL, 'PF02137', NULL, NULL, 'Adenosine-deaminase (editase) domain', NULL, 'A_deamin', NULL, NULL, 6672, 9),
(267621, NULL, 'PF02214', NULL, NULL, 'BTB/POZ domain', NULL, 'BTB_2', NULL, NULL, 2935, 9),
(267622, NULL, 'PF08403', NULL, NULL, 'Amino acid permease N-terminal', NULL, 'AA_permease_N', NULL, NULL, 11275, 9),
(267623, NULL, 'PF06808', NULL, NULL, 'Tripartite ATP-independent periplasmic transporter, DctM component', NULL, 'DctM', NULL, NULL, 9208, 9),
(267624, NULL, 'PF02576', NULL, NULL, 'RimP N-terminal domain', NULL, 'RimP_N', NULL, NULL, 21769, 9),
(267625, NULL, 'PF14251', NULL, NULL, 'Domain of unknown function (DUF4346)', NULL, 'DUF4346', NULL, NULL, 26041, 9),
(267626, NULL, 'PF12969', NULL, NULL, 'Domain of Unknown Function with PDB structure (DUF3857)', NULL, 'DUF3857', NULL, NULL, 26944, 9),
(267627, NULL, 'PF20200', NULL, NULL, 'Family of unknown function (DUF6562)', NULL, 'DUF6562', NULL, NULL, 37337, 9),
(267628, NULL, 'PF13850', NULL, NULL, 'Endoplasmic Reticulum-Golgi Intermediate Compartment (ERGIC)', NULL, 'ERGIC_N', NULL, NULL, 33178, 9),
(267629, NULL, 'PF16201', NULL, NULL, 'Nucleolar pre-ribosomal-associated protein 1', NULL, 'NopRA1', NULL, NULL, 26447, 9),
(267630, NULL, 'PF05409', NULL, NULL, 'Coronavirus endopeptidase C30', NULL, 'Peptidase_C30', NULL, NULL, 12163, 9),
(267631, NULL, 'PF06529', NULL, NULL, 'Vertebrate interleukin-3 regulated transcription factor', NULL, 'Vert_IL3-reg_TF', NULL, NULL, 14029, 9),
(267632, NULL, 'PF13234', NULL, NULL, 'rRNA-processing arch domain', NULL, 'rRNA_proc-arch', NULL, NULL, 22963, 9),
(267633, NULL, 'PF02294', NULL, NULL, '7kD DNA-binding domain', NULL, '7kD_DNA_binding', NULL, NULL, 2091, 9),
(267634, NULL, 'PF15748', NULL, NULL, 'Centriole, cilia and spindle-associated', NULL, 'CCSAP', NULL, NULL, 23983, 9),
(267635, NULL, 'PF12253', NULL, NULL, 'Chromatin assembly factor 1 subunit A', NULL, 'CAF1A', NULL, NULL, 20429, 9),
(267636, NULL, 'PF13997', NULL, NULL, 'YqjK-like protein', NULL, 'YqjK', NULL, NULL, 26436, 9),
(267637, NULL, 'PF04830', NULL, NULL, 'Possible hemagglutinin (DUF637)', NULL, 'DUF637', NULL, NULL, 4878, 9),
(267638, NULL, 'PF15851', NULL, NULL, 'Domain of unknown function (DUF4723)', NULL, 'DUF4723', NULL, NULL, 21954, 9),
(267639, NULL, 'PF04639', NULL, NULL, 'Baculoviral E56 protein, specific to ODV envelope', NULL, 'Baculo_E56', NULL, NULL, 2609, 9),
(267640, NULL, 'PF14403', NULL, NULL, 'Circularly permuted ATP-grasp type 2', NULL, 'CP_ATPgrasp_2', NULL, NULL, 24484, 9),
(267641, NULL, 'PF15600', NULL, NULL, 'Immunity protein 64', NULL, 'Imm64', NULL, NULL, 24966, 9),
(267642, NULL, 'PF16240', NULL, NULL, 'Domain of unknown function (DUF4899)', NULL, 'DUF4899', NULL, NULL, 24359, 9),
(267643, NULL, 'PF15972', NULL, NULL, 'Unpaired protein', NULL, 'Unpaired', NULL, NULL, 25850, 9),
(267644, NULL, 'PF05849', NULL, NULL, 'Fibroin light chain (L-fibroin)', NULL, 'L-fibroin', NULL, NULL, 12833, 9),
(267645, NULL, 'PF11343', NULL, NULL, 'Protein of unknown function (DUF3145)', NULL, 'DUF3145', NULL, NULL, 18876, 9),
(267646, NULL, 'PF19629', NULL, NULL, 'Family of unknown function (DUF6133)', NULL, 'DUF6133', NULL, NULL, 34183, 9),
(267647, NULL, 'PF05823', NULL, NULL, 'Nematode fatty acid retinoid binding protein (Gp-FAR-1)', NULL, 'Gp-FAR-1', NULL, NULL, 14039, 9),
(267648, NULL, 'PF17675', NULL, NULL, 'Apg6 coiled-coil region', NULL, 'APG6_N', NULL, NULL, 30342, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(267649, NULL, 'PF14364', NULL, NULL, 'Domain of unknown function (DUF4408)', NULL, 'DUF4408', NULL, NULL, 26020, 9),
(267650, NULL, 'PF17301', NULL, NULL, 'Putative lipoprotein LpqV', NULL, 'LpqV', NULL, NULL, 19732, 9),
(267651, NULL, 'PF12410', NULL, NULL, 'Poxvirus DNA dependent RNA polymerase 30kDa subunit', NULL, 'rpo30_N', NULL, NULL, 22141, 9),
(267652, NULL, 'PF19279', NULL, NULL, 'YegS C-terminal NAD kinase beta sandwich-like domain', NULL, 'YegS_C', NULL, NULL, 37124, 9),
(267653, NULL, 'PF11544', NULL, NULL, 'Spindle pole body component Spc42p', NULL, 'Spc42p', NULL, NULL, 18702, 9),
(267654, NULL, 'PF01055', NULL, NULL, 'Glycosyl hydrolases family 31', NULL, 'Glyco_hydro_31', NULL, NULL, 567, 9),
(267655, NULL, 'PF05236', NULL, NULL, 'Transcription initiation factor TFIID component TAF4 family', NULL, 'TAF4', NULL, NULL, 3023, 9),
(267656, NULL, 'PF10057', NULL, NULL, 'Na+-translocating membrane potential-generating system (MpsC)', NULL, 'MpsC', NULL, NULL, 18381, 9),
(267657, NULL, 'PF01517', NULL, NULL, 'Hepatitis delta virus delta antigen', NULL, 'HDV_ag', NULL, NULL, 869, 9),
(267658, NULL, 'PF10608', NULL, NULL, 'Polyubiquitination (PEST) N-terminal domain of MAGUK', NULL, 'MAGUK_N_PEST', NULL, NULL, 20222, 9),
(267659, NULL, 'PF02055', NULL, NULL, 'Glycosyl hydrolase family 30 TIM-barrel domain', NULL, 'Glyco_hydro_30', NULL, NULL, 29381, 9),
(267660, NULL, 'PF00848', NULL, NULL, 'Ring hydroxylating alpha subunit (catalytic domain)', NULL, 'Ring_hydroxyl_A', NULL, NULL, 7218, 9),
(267661, NULL, 'PF01233', NULL, NULL, 'Myristoyl-CoA:protein N-myristoyltransferase, N-terminal domain', NULL, 'NMT', NULL, NULL, 16675, 9),
(267662, NULL, 'PF05741', NULL, NULL, 'Nanos RNA binding domain', NULL, 'zf-nanos', NULL, NULL, 9882, 9),
(267663, NULL, 'PF10330', NULL, NULL, 'Putative Sin3 binding protein', NULL, 'Stb3', NULL, NULL, 19726, 9),
(267664, NULL, 'PF10662', NULL, NULL, 'Ethanolamine utilisation - propanediol utilisation', NULL, 'PduV-EutP', NULL, NULL, 13116, 9),
(267665, NULL, 'PF13382', NULL, NULL, 'Adenine deaminase C-terminal domain', NULL, 'Adenine_deam_C', NULL, NULL, 26937, 9),
(267666, NULL, 'PF18528', NULL, NULL, 'RNA editing 3'' terminal uridylyl transferase 2 middle domain', NULL, 'Ret2_MD', NULL, NULL, 28820, 9),
(267667, NULL, 'PF20385', NULL, NULL, 'Family of unknown function (DUF6680)', NULL, 'DUF6680', NULL, NULL, 37686, 9),
(267668, NULL, 'PF09358', NULL, NULL, 'Ubiquitin fold domain', NULL, 'E1_UFD', NULL, NULL, 14993, 9),
(267669, NULL, 'PF20055', NULL, NULL, 'Family of unknown function (DUF6454)', NULL, 'DUF6454', NULL, NULL, NULL, 9),
(267670, NULL, 'PF06382', NULL, NULL, 'Protamine and protamine like', NULL, 'Protamine_like', NULL, NULL, 21620, 9),
(267671, NULL, 'PF18309', NULL, NULL, 'Argonaute PAZ domain', NULL, 'PAZ_3', NULL, NULL, 32158, 9),
(267672, NULL, 'PF20622', NULL, NULL, 'Bacterial Ig domain (Big_16)', NULL, 'Big_15', NULL, NULL, 37695, 9),
(267673, NULL, 'PF04530', NULL, NULL, 'Viral Beta C/D like family', NULL, 'Viral_Beta_CD', NULL, NULL, 2685, 9),
(267674, NULL, 'PF15159', NULL, NULL, 'Phosphatidylinositol N-acetylglucosaminyltransferase subunit Y', NULL, 'PIG-Y', NULL, NULL, 21543, 9),
(267675, NULL, 'PF03657', NULL, NULL, 'UPF0113 PUA domain', NULL, 'UPF0113', NULL, NULL, 4022, 9),
(267676, NULL, 'PF20176', NULL, NULL, 'Family of unknown function (DUF6541)', NULL, 'DUF6541', NULL, NULL, 37159, 9),
(267677, NULL, 'PF12605', NULL, NULL, 'Casein kinase 1 gamma C terminal', NULL, 'CK1gamma_C', NULL, NULL, 21237, 9),
(267678, NULL, 'PF14179', NULL, NULL, 'YppG-like protein', NULL, 'YppG', NULL, NULL, 24224, 9),
(267679, NULL, 'PF15454', NULL, NULL, 'Late endosomal/lysosomal adaptor and MAPK and MTOR activator', NULL, 'LAMTOR', NULL, NULL, 26894, 9),
(267680, NULL, 'PF12245', NULL, NULL, 'Bacterial Ig-like domain', NULL, 'Big_3_2', NULL, NULL, 20342, 9),
(267681, NULL, 'PF00605', NULL, NULL, 'Interferon regulatory factor transcription factor', NULL, 'IRF', NULL, NULL, 2349, 9),
(267682, NULL, 'PF00196', NULL, NULL, 'Bacterial regulatory proteins, luxR family', NULL, 'GerE', NULL, NULL, 6599, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(267683, NULL, 'PF01757', NULL, NULL, 'Acyltransferase family', NULL, 'Acyl_transf_3', NULL, NULL, 2793, 9),
(267684, NULL, 'PF12170', NULL, NULL, 'DNA polymerase III tau subunit V interacting with alpha', NULL, 'DNA_pol3_tau_5', NULL, NULL, 15234, 9),
(267685, NULL, 'PF19254', NULL, NULL, 'Family of unknown function (DUF5901)', NULL, 'DUF5901', NULL, NULL, 33868, 9),
(267686, NULL, 'PF01501', NULL, NULL, 'Glycosyl transferase family 8', NULL, 'Glyco_transf_8', NULL, NULL, 853, 9),
(267687, NULL, 'PF06125', NULL, NULL, 'Bacterial protein of unknown function (DUF961)', NULL, 'DUF961', NULL, NULL, 8530, 9),
(267688, NULL, 'PF14849', NULL, NULL, 'YidC periplasmic domain', NULL, 'YidC_periplas', NULL, NULL, 29798, 9),
(267689, NULL, 'PF11261', NULL, NULL, 'Interferon regulatory factor 2-binding protein zinc finger', NULL, 'IRF-2BP1_2', NULL, NULL, 17109, 9),
(267690, NULL, 'PF01135', NULL, NULL, 'Protein-L-isoaspartate(D-aspartate) O-methyltransferase (PCMT)', NULL, 'PCMT', NULL, NULL, NULL, 9),
(267691, NULL, 'PF20083', NULL, NULL, 'Family of unknown function (DUF6477)', NULL, 'DUF6477', NULL, NULL, 37128, 9),
(267692, NULL, 'PF02187', NULL, NULL, 'Growth-Arrest-Specific Protein 2 Domain', NULL, 'GAS2', NULL, NULL, 2733, 9),
(267693, NULL, 'PF00736', NULL, NULL, 'EF-1 guanine nucleotide exchange domain', NULL, 'EF1_GNE', NULL, NULL, 11032, 9),
(267694, NULL, 'PF16189', NULL, NULL, 'Creatinase/Prolidase N-terminal domain', NULL, 'Creatinase_N_2', NULL, NULL, NULL, 9),
(267695, NULL, 'PF16191', NULL, NULL, 'Ubiquitin-activating enzyme E1 four-helix bundle', NULL, 'E1_4HB', NULL, NULL, 25087, 9),
(267696, NULL, 'PF14512', NULL, NULL, 'Putative TM nitroreductase', NULL, 'TM1586_NiRdase', NULL, NULL, 23485, 9),
(267697, NULL, 'PF07780', NULL, NULL, 'Spb1 C-terminal domain', NULL, 'Spb1_C', NULL, NULL, 7971, 9),
(267698, NULL, 'PF00689', NULL, NULL, 'Cation transporting ATPase, C-terminus', NULL, 'Cation_ATPase_C', NULL, NULL, 2585, 9),
(267699, NULL, 'PF09360', NULL, NULL, 'Iron-binding zinc finger CDGSH type', NULL, 'zf-CDGSH', NULL, NULL, 14925, 9),
(267700, NULL, 'PF10437', NULL, NULL, 'Bacterial lipoate protein ligase C-terminus', NULL, 'Lip_prot_lig_C', NULL, NULL, 18365, 9),
(267701, NULL, 'PF03777', NULL, NULL, 'ChpA-C', NULL, 'ChpA-C', NULL, NULL, 1776, 9),
(267702, NULL, 'PF04338', NULL, NULL, 'Protein of unknown function, DUF481', NULL, 'DUF481', NULL, NULL, 3675, 9),
(267703, NULL, 'PF18396', NULL, NULL, 'TANK binding kinase 1 ubiquitin-like domain', NULL, 'TBK1_ULD', NULL, NULL, 29344, 9),
(267704, NULL, 'PF07843', NULL, NULL, 'Protein of unknown function (DUF1634)', NULL, 'DUF1634', NULL, NULL, 12197, 9),
(267705, NULL, 'PF12729', NULL, NULL, 'Four helix bundle sensory module for signal transduction', NULL, '4HB_MCP_1', NULL, NULL, 26561, 9),
(267706, NULL, 'PF13653', NULL, NULL, 'Glycerophosphoryl diester phosphodiesterase family', NULL, 'GDPD_2', NULL, NULL, NULL, 9),
(267707, NULL, 'PF11477', NULL, NULL, 'Sialyltransferase PMO188', NULL, 'PM0188', NULL, NULL, 18935, 9),
(267708, NULL, 'PF12117', NULL, NULL, 'Parvovirus non-structural protein 1, C-terminal', NULL, 'NS1_C', NULL, NULL, 20338, 9),
(267709, NULL, 'PF07803', NULL, NULL, 'GSG1-like protein', NULL, 'GSG-1', NULL, NULL, 11654, 9),
(267710, NULL, 'PF08427', NULL, NULL, 'Armadillo-like helical domain-containing protein 3, C-terminal', NULL, 'ARMH3_C', NULL, NULL, 11128, 9),
(267711, NULL, 'PF12469', NULL, NULL, 'CRISPR-associated protein Cmr2, N-terminal', NULL, 'Cmr2_N', NULL, NULL, 26588, 9),
(267712, NULL, 'PF18835', NULL, NULL, 'Beta helix repeat of Inulin fructotransferase', NULL, 'Beta_helix_2', NULL, NULL, 31629, 9),
(267713, NULL, 'PF20487', NULL, NULL, 'Family of unknown function (DUF6726)', NULL, 'DUF6726', NULL, NULL, 33718, 9),
(267714, NULL, 'PF01125', NULL, NULL, 'G10 protein', NULL, 'G10', NULL, NULL, 4598, 9),
(267715, NULL, 'PF17266', NULL, NULL, 'Family of unknown function (DUF5332)', NULL, 'DUF5332', NULL, NULL, 19646, 9),
(267716, NULL, 'PF18918', NULL, NULL, 'Family of unknown function (DUF5669)', NULL, 'DUF5669', NULL, NULL, 10255, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(267717, NULL, 'PF09692', NULL, NULL, 'Argonaute siRNA chaperone (ARC) complex subunit Arb1', NULL, 'Arb1', NULL, NULL, 16286, 9),
(267718, NULL, 'PF16549', NULL, NULL, 'Type II secretion system (T2SS) pilotin, S protein', NULL, 'T2SSS_2', NULL, NULL, 16329, 9),
(267719, NULL, 'PF07743', NULL, NULL, 'HSCB C-terminal oligomerisation domain', NULL, 'HSCB_C', NULL, NULL, 6296, 9),
(267720, NULL, 'PF13747', NULL, NULL, 'Domain of unknown function (DUF4164)', NULL, 'DUF4164', NULL, NULL, 22337, 9),
(267721, NULL, 'PF18263', NULL, NULL, 'MCM6 C-terminal winged-helix domain', NULL, 'MCM6_C', NULL, NULL, 28614, 9),
(267722, NULL, 'PF04772', NULL, NULL, 'Influenza B matrix protein 2 (BM2)', NULL, 'Flu_B_M2', NULL, NULL, 3935, 9),
(267723, NULL, 'PF10882', NULL, NULL, 'Bacterial PH domain', NULL, 'bPH_5', NULL, NULL, 26125, 9),
(267724, NULL, 'PF19902', NULL, NULL, 'Family of unknown function (DUF6375)', NULL, 'DUF6375', NULL, NULL, 36617, 9),
(267725, NULL, 'PF00625', NULL, NULL, 'Guanylate kinase', NULL, 'Guanylate_kin', NULL, NULL, 7453, 9),
(267726, NULL, 'PF14409', NULL, NULL, 'Ribosomally synthesized peptide in Herpetosiphon', NULL, 'Herpeto_peptide', NULL, NULL, 24071, 9),
(267727, NULL, 'PF06693', NULL, NULL, 'Protein of unknown function (DUF1190)', NULL, 'DUF1190', NULL, NULL, 725, 9),
(267728, NULL, 'PF11696', NULL, NULL, 'Protein of unknown function (DUF3292)', NULL, 'DUF3292', NULL, NULL, 19113, 9),
(267729, NULL, 'PF10718', NULL, NULL, 'Hypothetical chloroplast protein Ycf34', NULL, 'Ycf34', NULL, NULL, 20740, 9),
(267730, NULL, 'PF14256', NULL, NULL, 'YwiC-like protein', NULL, 'YwiC', NULL, NULL, 24337, 9),
(267731, NULL, 'PF07488', NULL, NULL, 'Glycosyl hydrolase family 67 middle domain', NULL, 'Glyco_hydro_67M', NULL, NULL, 11130, 9),
(267732, NULL, 'PF19545', NULL, NULL, 'Family of unknown function (DUF6069)', NULL, 'DUF6069', NULL, NULL, 37022, 9),
(267733, NULL, 'PF20159', NULL, NULL, 'YidB-like protein', NULL, 'YidB', NULL, NULL, 35642, 9),
(267734, NULL, 'PF12549', NULL, NULL, 'Tyrosine hydroxylase N terminal', NULL, 'TOH_N', NULL, NULL, 15249, 9),
(267735, NULL, 'PF20388', NULL, NULL, 'Family of unknown function (DUF6683)', NULL, 'DUF6683', NULL, NULL, 37770, 9),
(267736, NULL, 'PF09865', NULL, NULL, 'Predicted periplasmic protein (DUF2092)', NULL, 'DUF2092', NULL, NULL, 19024, 9),
(267737, NULL, 'PF12648', NULL, NULL, 'TcpE family', NULL, 'TcpE', NULL, NULL, 23360, 9),
(267738, NULL, 'PF19176', NULL, NULL, 'Family of unknown function (DUF5858)', NULL, 'DUF5858', NULL, NULL, 34832, 9),
(267739, NULL, 'PF08842', NULL, NULL, 'Fimbrillin-A associated anchor proteins Mfa1 and Mfa2', NULL, 'Mfa2', NULL, NULL, 14360, 9),
(267740, NULL, 'PF10140', NULL, NULL, 'WXG100 protein secretion system (Wss), protein YukC', NULL, 'YukC', NULL, NULL, 19090, 9),
(267741, NULL, 'PF01390', NULL, NULL, 'SEA domain', NULL, 'SEA', NULL, NULL, 2621, 9),
(267742, NULL, 'PF10340', NULL, NULL, 'Steryl acetyl hydrolase', NULL, 'Say1_Mug180', NULL, NULL, 17099, 9),
(267743, NULL, 'PF10465', NULL, NULL, 'PinA peptidase inhibitor', NULL, 'Inhibitor_I24', NULL, NULL, 18411, 9),
(267744, NULL, 'PF19193', NULL, NULL, 'Tectonin domain', NULL, 'Tectonin', NULL, NULL, 1427, 9),
(267745, NULL, 'PF06245', NULL, NULL, 'Protein of unknown function (DUF1015)', NULL, 'DUF1015', NULL, NULL, 7644, 9),
(267746, NULL, 'PF15261', NULL, NULL, 'Jhy protein', NULL, 'JHY', NULL, NULL, 24428, 9),
(267747, NULL, 'PF16909', NULL, NULL, 'Vacuolar-sorting-associated 13 protein C-terminal', NULL, 'VPS13_C', NULL, NULL, 21636, 9),
(267748, NULL, 'PF15531', NULL, NULL, 'Bacterial toxin 27', NULL, 'Ntox27', NULL, NULL, 23546, 9),
(267749, NULL, 'PF10825', NULL, NULL, 'Protein of unknown function (DUF2752)', NULL, 'DUF2752', NULL, NULL, 17956, 9),
(267750, NULL, 'PF14726', NULL, NULL, 'Rotatin, an armadillo repeat protein, centriole functioning', NULL, 'RTTN_N', NULL, NULL, 26723, 9),
(267751, NULL, 'PF02781', NULL, NULL, 'Glucose-6-phosphate dehydrogenase, C-terminal domain', NULL, 'G6PD_C', NULL, NULL, 16803, 9),
(267752, NULL, 'PF02284', NULL, NULL, 'Cytochrome c oxidase subunit Va', NULL, 'COX5A', NULL, NULL, 1933, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(267753, NULL, 'PF13310', NULL, NULL, 'Virulence protein RhuM family', NULL, 'Virulence_RhuM', NULL, NULL, 10876, 9),
(267754, NULL, 'PF18291', NULL, NULL, 'HU domain fused to wHTH, Ig, or Glycine-rich motif', NULL, 'HU-HIG', NULL, NULL, 30750, 9),
(267755, NULL, 'PF13498', NULL, NULL, 'Domain of unknown function (DUF4122)', NULL, 'DUF4122', NULL, NULL, 21205, 9),
(267756, NULL, 'PF20262', NULL, NULL, 'Protein UNC80 C-terminal region', NULL, 'UNC80_C', NULL, NULL, 33745, 9),
(267757, NULL, 'PF14949', NULL, NULL, 'ARF7 effector protein C-terminus', NULL, 'ARF7EP_C', NULL, NULL, 21513, 9),
(267758, NULL, 'PF16469', NULL, NULL, 'Nematode polyprotein allergen ABA-1', NULL, 'NPA', NULL, NULL, 22403, 9),
(267759, NULL, 'PF00656', NULL, NULL, 'Caspase domain', NULL, 'Peptidase_C14', NULL, NULL, NULL, 9),
(267760, NULL, 'PF03446', NULL, NULL, 'NAD binding domain of 6-phosphogluconate dehydrogenase', NULL, 'NAD_binding_2', NULL, NULL, 10172, 9),
(267761, NULL, 'PF15648', NULL, NULL, 'Restriction endonuclease fold toxin 5', NULL, 'Tox-REase-5', NULL, NULL, 24506, 9),
(267762, NULL, 'PF15520', NULL, NULL, 'Novel toxin 10', NULL, 'Ntox10', NULL, NULL, 23664, 9),
(267763, NULL, 'PF08569', NULL, NULL, 'Mo25-like', NULL, 'Mo25', NULL, NULL, 17702, 9),
(267764, NULL, 'PF13002', NULL, NULL, 'Arrestin_N terminal like', NULL, 'LDB19', NULL, NULL, 24383, 9),
(267765, NULL, 'PF01744', NULL, NULL, 'GLTT repeat (6 copies)', NULL, 'GLTT', NULL, NULL, 7479, 9),
(267766, NULL, 'PF00499', NULL, NULL, 'NADH-ubiquinone/plastoquinone oxidoreductase chain 6', NULL, 'Oxidored_q3', NULL, NULL, 3309, 9),
(267767, NULL, 'PF16656', NULL, NULL, 'Purple acid Phosphatase, N-terminal domain', NULL, 'Pur_ac_phosph_N', NULL, NULL, 8143, 9),
(267768, NULL, 'PF10860', NULL, NULL, 'Protein of unknown function (DUF2661)', NULL, 'DUF2661', NULL, NULL, 19236, 9),
(267769, NULL, 'PF03839', NULL, NULL, 'Translocation protein Sec62', NULL, 'Sec62', NULL, NULL, 3703, 9),
(267770, NULL, 'PF19576', NULL, NULL, 'Acyltransferase', NULL, 'Acyltransf_2', NULL, NULL, 36212, 9),
(267771, NULL, 'PF17040', NULL, NULL, 'Cellulose-complementing protein A', NULL, 'CBP_CCPA', NULL, NULL, 22901, 9),
(267772, NULL, 'PF15581', NULL, NULL, 'Immunity protein 58', NULL, 'Imm58', NULL, NULL, 24911, 9),
(267773, NULL, 'PF03412', NULL, NULL, 'Peptidase C39 family', NULL, 'Peptidase_C39', NULL, NULL, 10424, 9),
(267774, NULL, 'PF10982', NULL, NULL, 'Protein of unknown function (DUF2789)', NULL, 'DUF2789', NULL, NULL, 17931, 9),
(267775, NULL, 'PF13457', NULL, NULL, 'GW (Gly-Tryp) dipeptide domain', NULL, 'GW', NULL, NULL, 23359, 9),
(267776, NULL, 'PF10642', NULL, NULL, 'Mitochondrial import receptor subunit or translocase', NULL, 'Tom5', NULL, NULL, 20193, 9),
(267777, NULL, 'PF06869', NULL, NULL, 'Protein of unknown function (DUF1258)', NULL, 'DUF1258', NULL, NULL, 11817, 9),
(267778, NULL, 'PF07390', NULL, NULL, 'Mycoplasma P30 protein', NULL, 'P30', NULL, NULL, 8188, 9),
(267779, NULL, 'PF11138', NULL, NULL, 'Protein of unknown function (DUF2911)', NULL, 'DUF2911', NULL, NULL, 17698, 9),
(267780, NULL, 'PF14047', NULL, NULL, 'Dppa2/4 conserved region', NULL, 'DCR', NULL, NULL, 25701, 9),
(267781, NULL, 'PF09450', NULL, NULL, 'Domain of unknown function (DUF2019)', NULL, 'DUF2019', NULL, NULL, 15102, 9),
(267782, NULL, 'PF19434', NULL, NULL, 'Dynamin-like GTPase OPA1 C-terminal', NULL, 'OPA1_C', NULL, NULL, 36194, 9),
(267783, NULL, 'PF15993', NULL, NULL, 'Fuseless', NULL, 'Fuseless', NULL, NULL, 22137, 9),
(267784, NULL, 'PF18553', NULL, NULL, 'PheRS DNA binding domain 3', NULL, 'PheRS_DBD3', NULL, NULL, 29323, 9),
(267785, NULL, 'PF01493', NULL, NULL, 'GXGXG motif', NULL, 'GXGXG', NULL, NULL, 774, 9),
(267786, NULL, 'PF16765', NULL, NULL, 'Pesticin immunity protein', NULL, 'Pim', NULL, NULL, 22021, 9),
(267787, NULL, 'PF01264', NULL, NULL, 'Chorismate synthase', NULL, 'Chorismate_synt', NULL, NULL, 6508, 9),
(267788, NULL, 'PF17471', NULL, NULL, 'Gene product 63', NULL, 'GP63', NULL, NULL, 18940, 9),
(267789, NULL, 'PF04203', NULL, NULL, 'Sortase domain', NULL, 'Sortase', NULL, NULL, 4953, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(267790, NULL, 'PF03101', NULL, NULL, 'FAR1 DNA-binding domain', NULL, 'FAR1', NULL, NULL, 4713, 9),
(267791, NULL, 'PF06758', NULL, NULL, 'Olduvai domain', NULL, 'Olduvai', NULL, NULL, 9131, 9),
(267792, NULL, 'PF12394', NULL, NULL, 'Protein FAM135', NULL, 'DUF3657', NULL, NULL, 20890, 9),
(267793, NULL, 'PF02646', NULL, NULL, 'RmuC family', NULL, 'RmuC', NULL, NULL, 3425, 9),
(267794, NULL, 'PF13770', NULL, NULL, 'Domain of unknown function (DUF4169)', NULL, 'DUF4169', NULL, NULL, 23130, 9),
(267795, NULL, 'PF03262', NULL, NULL, 'Coronavirus 6B/7B protein', NULL, 'Corona_6B_7B', NULL, NULL, 1918, 9),
(267796, NULL, 'PF06600', NULL, NULL, 'Protein of unknown function (DUF1140)', NULL, 'DUF1140', NULL, NULL, 9885, 9),
(267797, NULL, 'PF13441', NULL, NULL, 'YMGG-like Gly-zipper', NULL, 'Gly-zipper_YMGG', NULL, NULL, 24398, 9),
(267798, NULL, 'PF00775', NULL, NULL, 'Dioxygenase', NULL, 'Dioxygenase_C', NULL, NULL, 5654, 9),
(267799, NULL, 'PF20143', NULL, NULL, 'ATP-NAD kinase C-terminal domain', NULL, 'NAD_kinase_C', NULL, NULL, NULL, 9),
(267800, NULL, 'PF12328', NULL, NULL, 'Rpp20 subunit of nuclear RNase MRP and P', NULL, 'Rpp20', NULL, NULL, 8341, 9),
(267801, NULL, 'PF15257', NULL, NULL, 'Domain of unknown function (DUF4590)', NULL, 'DUF4590', NULL, NULL, 24175, 9),
(267802, NULL, 'PF01729', NULL, NULL, 'Quinolinate phosphoribosyl transferase, C-terminal domain', NULL, 'QRPTase_C', NULL, NULL, 2789, 9),
(267803, NULL, 'PF00273', NULL, NULL, 'Serum albumin family', NULL, 'Serum_albumin', NULL, NULL, 12292, 9),
(267804, NULL, 'PF18174', NULL, NULL, 'CCDC81-like prokaryotic HU domain 1', NULL, 'HU-CCDC81_bac_1', NULL, NULL, 27810, 9),
(267805, NULL, 'PF01844', NULL, NULL, 'HNH endonuclease', NULL, 'HNH', NULL, NULL, 3738, 9),
(267806, NULL, 'PF00236', NULL, NULL, 'Glycoprotein hormone', NULL, 'Hormone_6', NULL, NULL, 5533, 9),
(267807, NULL, 'PF09138', NULL, NULL, 'Urm1 (Ubiquitin related modifier)', NULL, 'Urm1', NULL, NULL, 10531, 9),
(267808, NULL, 'PF00151', NULL, NULL, 'Lipase', NULL, 'Lipase', NULL, NULL, 7791, 9),
(267809, NULL, 'PF17518', NULL, NULL, 'Family of unknown function (DUF5443)', NULL, 'DUF5443', NULL, NULL, 8930, 9),
(267810, NULL, 'PF08568', NULL, NULL, 'Uncharacterised protein family, YAP/Alf4/glomulin', NULL, 'Kinetochor_Ybp2', NULL, NULL, 17850, 9),
(267811, NULL, 'PF00411', NULL, NULL, 'Ribosomal protein S11', NULL, 'Ribosomal_S11', NULL, NULL, 2246, 9),
(267812, NULL, 'PF00514', NULL, NULL, 'Armadillo/beta-catenin-like repeat', NULL, 'Arm', NULL, NULL, 3706, 9),
(267813, NULL, 'PF07704', NULL, NULL, 'Rv0623-like transcription factor', NULL, 'PSK_trans_fac', NULL, NULL, 10844, 9),
(267814, NULL, 'PF11403', NULL, NULL, 'Yeast metallothionein', NULL, 'Yeast_MT', NULL, NULL, 16536, 9),
(267815, NULL, 'PF17340', NULL, NULL, 'Family of unknown function (DUF5370)', NULL, 'DUF5370', NULL, NULL, 32758, 9),
(267816, NULL, 'PF14626', NULL, NULL, 'Zc3h12a-like Ribonuclease NYN domain', NULL, 'RNase_Zc3h12a_2', NULL, NULL, 23257, 9),
(267817, NULL, 'PF00970', NULL, NULL, 'Oxidoreductase FAD-binding domain', NULL, 'FAD_binding_6', NULL, NULL, 12202, 9),
(267818, NULL, 'PF13396', NULL, NULL, 'Phospholipase_D-nuclease N-terminal', NULL, 'PLDc_N', NULL, NULL, 24651, 9),
(267819, NULL, 'PF00267', NULL, NULL, 'Gram-negative porin', NULL, 'Porin_1', NULL, NULL, 3495, 9),
(267820, NULL, 'PF04575', NULL, NULL, 'Surface lipoprotein assembly modifier', NULL, 'SlipAM', NULL, NULL, 12, 9),
(267821, NULL, 'PF12764', NULL, NULL, 'Glycine-rich region of argonaut', NULL, 'Gly-rich_Ago1', NULL, NULL, 23657, 9),
(267822, NULL, 'PF08806', NULL, NULL, 'Sep15/SelM redox domain', NULL, 'Sep15_SelM', NULL, NULL, 13224, 9),
(267823, NULL, 'PF08861', NULL, NULL, 'Domain of unknown function DUF1828', NULL, 'DUF1828', NULL, NULL, 14444, 9),
(267824, NULL, 'PF14084', NULL, NULL, 'Protein of unknown function (DUF4264)', NULL, 'DUF4264', NULL, NULL, 12975, 9),
(267825, NULL, 'PF15033', NULL, NULL, 'Kinocilin protein', NULL, 'Kinocilin', NULL, NULL, 22398, 9),
(267826, NULL, 'PF05656', NULL, NULL, 'Protein of unknown function (DUF805)', NULL, 'DUF805', NULL, NULL, 13161, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(267827, NULL, 'PF14446', NULL, NULL, 'Prokaryotic RING finger family 1', NULL, 'Prok-RING_1', NULL, NULL, 32874, 9),
(267828, NULL, 'PF01606', NULL, NULL, 'Arterivirus envelope protein', NULL, 'Arteri_env', NULL, NULL, 1750, 9),
(267829, NULL, 'PF03629', NULL, NULL, 'Carbohydrate esterase, sialic acid-specific acetylesterase', NULL, 'SASA', NULL, NULL, 5297, 9),
(267830, NULL, 'PF06070', NULL, NULL, 'Herpesvirus large structural phosphoprotein UL32', NULL, 'Herpes_UL32', NULL, NULL, 8555, 9),
(267831, NULL, 'PF14883', NULL, NULL, 'Hypothetical glycosyl hydrolase family 13', NULL, 'GHL13', NULL, NULL, 22100, 9),
(267832, NULL, 'PF04767', NULL, NULL, 'DNA-binding 11 kDa phosphoprotein', NULL, 'Pox_F17', NULL, NULL, 3608, 9),
(267833, NULL, 'PF00264', NULL, NULL, 'Common central domain of tyrosinase', NULL, 'Tyrosinase', NULL, NULL, 289, 9),
(267834, NULL, 'PF01840', NULL, NULL, 'TCL1/MTCP1 family', NULL, 'TCL1_MTCP1', NULL, NULL, 4480, 9),
(267835, NULL, 'PF06615', NULL, NULL, 'Circovirus 2, Orf1', NULL, 'Circovir2_Orf1', NULL, NULL, 9890, 9),
(267836, NULL, 'PF00419', NULL, NULL, 'Fimbrial protein', NULL, 'Fimbrial', NULL, NULL, 4297, 9),
(267837, NULL, 'PF13743', NULL, NULL, 'Thioredoxin', NULL, 'Thioredoxin_5', NULL, NULL, NULL, 9),
(267838, NULL, 'PF16285', NULL, NULL, 'Domain of unknown function (DUF4931)', NULL, 'DUF4931', NULL, NULL, NULL, 9),
(267839, NULL, 'PF08179', NULL, NULL, 'Small acid-soluble spore protein P family', NULL, 'SspP', NULL, NULL, 9592, 9),
(267840, NULL, 'PF14533', NULL, NULL, 'Ubiquitin-specific protease C-terminal', NULL, 'USP7_C2', NULL, NULL, 23837, 9),
(267841, NULL, 'PF16993', NULL, NULL, 'Accessory Sec system protein Asp1', NULL, 'Asp1', NULL, NULL, 15268, 9),
(267842, NULL, 'PF17498', NULL, NULL, 'Family of unknown function (DUF5433)', NULL, 'DUF5433', NULL, NULL, 21141, 9),
(267843, NULL, 'PF05892', NULL, NULL, 'Trichovirus coat protein', NULL, 'Tricho_coat', NULL, NULL, 7977, 9),
(267844, NULL, 'PF01910', NULL, NULL, 'Thiamine-binding protein', NULL, 'Thiamine_BP', NULL, NULL, 4840, 9),
(267845, NULL, 'PF12529', NULL, NULL, 'Xylosyltransferase C terminal', NULL, 'Xylo_C', NULL, NULL, 22724, 9),
(267846, NULL, 'PF02494', NULL, NULL, 'HYR domain', NULL, 'HYR', NULL, NULL, 5188, 9),
(267847, NULL, 'PF12404', NULL, NULL, 'Peptidase', NULL, 'DUF3663', NULL, NULL, 7888, 9),
(267848, NULL, 'PF14462', NULL, NULL, 'Prokaryotic E2 family E', NULL, 'Prok-E2_E', NULL, NULL, 24512, 9),
(267849, NULL, 'PF08586', NULL, NULL, 'RSC complex, Rsc14/Ldb7 subunit', NULL, 'Rsc14', NULL, NULL, 17542, 9),
(267850, NULL, 'PF18867', NULL, NULL, 'HEPN-like integron domain', NULL, 'HEPN-like_int', NULL, NULL, 29248, 9),
(267851, NULL, 'PF19466', NULL, NULL, 'Family of unknown function (DUF6003)', NULL, 'DUF6003', NULL, NULL, 36650, 9),
(267852, NULL, 'PF15759', NULL, NULL, 'TMEM108 family', NULL, 'TMEM108', NULL, NULL, 24830, 9),
(267853, NULL, 'PF20229', NULL, NULL, 'Protein ChrB, N-terminal', NULL, 'ChrB_N', NULL, NULL, 33717, 9),
(267854, NULL, 'PF18238', NULL, NULL, 'LnmK N-terminal Hot Dog Fold domain', NULL, 'LnmK_N_HDF', NULL, NULL, 28620, 9),
(267855, NULL, 'PF05875', NULL, NULL, 'Ceramidase', NULL, 'Ceramidase', NULL, NULL, 7883, 9),
(267856, NULL, 'PF15273', NULL, NULL, 'NHS-like', NULL, 'NHS', NULL, NULL, 22111, 9),
(267857, NULL, 'PF12075', NULL, NULL, 'KN motif', NULL, 'KN_motif', NULL, NULL, 20377, 9),
(267858, NULL, 'PF02666', NULL, NULL, 'Phosphatidylserine decarboxylase', NULL, 'PS_Dcarbxylase', NULL, NULL, 3483, 9),
(267859, NULL, 'PF04617', NULL, NULL, 'Hox9 activation region', NULL, 'Hox9_act', NULL, NULL, 2291, 9),
(267860, NULL, 'PF06744', NULL, NULL, 'Type VI secretion protein IcmF C2-like domain', NULL, 'IcmF_C', NULL, NULL, 9004, 9),
(267861, NULL, 'PF02552', NULL, NULL, 'CO dehydrogenase beta subunit/acetyl-CoA synthase epsilon subunit', NULL, 'CO_dh', NULL, NULL, 2030, 9),
(267862, NULL, 'PF09571', NULL, NULL, 'XcyI restriction endonuclease', NULL, 'RE_XcyI', NULL, NULL, 16888, 9),
(267863, NULL, 'PF10086', NULL, NULL, 'YhfC intramembrane metalloprotease', NULL, 'YhfC', NULL, NULL, 7578, 9); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(267864, NULL, 'PF11071', NULL, NULL, 'Nucleoside 2-deoxyribosyltransferase YtoQ', NULL, 'Nuc_deoxyri_tr3', NULL, NULL, 18237, 9),
(267865, NULL, 'PF00852', NULL, NULL, 'Glycosyltransferase family 10 (fucosyltransferase) C-term', NULL, 'Glyco_transf_10', NULL, NULL, 6241, 9),
(267866, NULL, 'PF07107', NULL, NULL, 'Wound-induced protein WI12', NULL, 'WI12', NULL, NULL, 13331, 9),
(267867, NULL, 'PF17479', NULL, NULL, 'Protein of unknown function (DUF3048) C-terminal domain', NULL, 'DUF3048_C', NULL, NULL, 9972, 9),
(267868, NULL, 'PF00977', NULL, NULL, 'Histidine biosynthesis protein', NULL, 'His_biosynth', NULL, NULL, 2587, 9),
(267869, NULL, 'PF10829', NULL, NULL, 'Protein of unknown function (DUF2554)', NULL, 'DUF2554', NULL, NULL, 12965, 9),
(267870, NULL, 'PF18860', NULL, NULL, 'AbiJ N-terminal domain 3', NULL, 'AbiJ_NTD3', NULL, NULL, 29022, 9),
(267871, NULL, 'PF13598', NULL, NULL, 'Domain of unknown function (DUF4139)', NULL, 'DUF4139', NULL, NULL, 29747, 9),
(267872, NULL, 'PF13628', NULL, NULL, 'Domain of unknown function (DUF4142)', NULL, 'DUF4142', NULL, NULL, 22450, 9),
(267873, NULL, 'PF14688', NULL, NULL, 'Domain of unknown function (DUF4461)', NULL, 'DUF4461', NULL, NULL, 24826, 9),
(267874, NULL, 'PF08061', NULL, NULL, 'P68HR (NUC004) repeat', NULL, 'P68HR', NULL, NULL, 9228, 9),
(267875, NULL, 'PF04785', NULL, NULL, 'Rhabdovirus matrix protein M2', NULL, 'Rhabdo_M2', NULL, NULL, 4676, 9),
(267876, NULL, 'PF18767', NULL, NULL, 'Activation induced deaminase', NULL, 'AID', NULL, NULL, NULL, 9),
(267877, NULL, 'PF01834', NULL, NULL, 'XRCC1 N terminal domain', NULL, 'XRCC1_N', NULL, NULL, 3666, 9),
(267878, NULL, 'PF05019', NULL, NULL, 'Coenzyme Q (ubiquinone) biosynthesis protein Coq4', NULL, 'Coq4', NULL, NULL, 1046, 9),
(267879, NULL, 'PF17690', NULL, NULL, 'Family of unknown function (DUF5537)', NULL, 'DUF5537', NULL, NULL, 27660, 9),
(267880, NULL, 'PF06376', NULL, NULL, 'Arabinogalactan peptide', NULL, 'AGP', NULL, NULL, 8291, 9),
(267881, NULL, 'PF15814', NULL, NULL, 'Protein family FAM199X', NULL, 'FAM199X', NULL, NULL, 23966, 9),
(267882, NULL, 'PF11974', NULL, NULL, 'Bacterial alpha-2-macroglobulin MG3 domain', NULL, 'bMG3', NULL, NULL, 19593, 9),
(267883, NULL, 'PF20583', NULL, NULL, 'Family of unknown function (DUF6786)', NULL, 'DUF6786', NULL, NULL, 37356, 9),
(267884, NULL, 'PF09127', NULL, NULL, 'Leukotriene A4 hydrolase, C-terminal', NULL, 'Leuk-A4-hydro_C', NULL, NULL, 10976, 9),
(267885, NULL, 'PF15232', NULL, NULL, 'Domain of unknown function (DUF4585)', NULL, 'DUF4585', NULL, NULL, 26434, 9),
(267886, NULL, 'PF18153', NULL, NULL, 'SMODS-associating 2TM, beta-strand rich effector domain', NULL, 'S_2TMBeta', NULL, NULL, 28725, 9),
(267887, NULL, 'PF03425', NULL, NULL, 'Carbohydrate binding domain (family 11)', NULL, 'CBM_11', NULL, NULL, 10459, 9),
(267888, NULL, 'PF06299', NULL, NULL, 'Protein of unknown function (DUF1045)', NULL, 'DUF1045', NULL, NULL, 8167, 9),
(267889, NULL, 'PF01725', NULL, NULL, 'Ham1 family', NULL, 'Ham1p_like', NULL, NULL, 2878, 9),
(267890, NULL, 'PF16151', NULL, NULL, 'Domain of unknown function (DUF4859)', NULL, 'DUF4859', NULL, NULL, 26351, 9),
(267891, NULL, 'PF17840', NULL, NULL, 'Tethering Ubl4a to BAGS domain', NULL, 'Tugs', NULL, NULL, 30859, 9),
(267892, NULL, 'PF09721', NULL, NULL, 'Transmembrane exosortase (Exosortase_EpsH)', NULL, 'Exosortase_EpsH', NULL, NULL, 17758, 9),
(267893, NULL, 'PF09753', NULL, NULL, 'Membrane fusion protein Use1', NULL, 'Use1', NULL, NULL, 18248, 9),
(267894, NULL, 'PF18770', NULL, NULL, 'Armadillo tether-repeat of vescicular transport factor', NULL, 'Arm_vescicular', NULL, NULL, 28508, 9),
(267895, NULL, 'PF13985', NULL, NULL, 'YbgS-like protein', NULL, 'YbgS', NULL, NULL, 19636, 9),
(267896, NULL, 'PF10049', NULL, NULL, 'Protein of unknown function (DUF2283)', NULL, 'DUF2283', NULL, NULL, 19746, 9),
(267897, NULL, 'PF10120', NULL, NULL, 'Thiamine-phosphate synthase', NULL, 'ThiP_synth', NULL, NULL, 19818, 9),
(267898, NULL, 'PF16522', NULL, NULL, 'Flagellar FLiS export co-chaperone, HP1076', NULL, 'FliS_cochap', NULL, NULL, 25477, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(267899, NULL, 'PF04319', NULL, NULL, 'NifZ domain', NULL, 'NifZ', NULL, NULL, 3701, 9),
(267900, NULL, 'PF15825', NULL, NULL, 'FAM25 family', NULL, 'FAM25', NULL, NULL, 15822, 9),
(267901, NULL, 'PF09878', NULL, NULL, 'Predicted membrane protein (DUF2105)', NULL, 'DUF2105', NULL, NULL, 19104, 9),
(267902, NULL, 'PF02659', NULL, NULL, 'Putative manganese efflux pump', NULL, 'Mntp', NULL, NULL, 3411, 9),
(267903, NULL, 'PF13152', NULL, NULL, 'Protein of unknown function (DUF3967)', NULL, 'DUF3967', NULL, NULL, 22626, 9),
(267904, NULL, 'PF12620', NULL, NULL, 'Protein of unknown function (DUF3778)', NULL, 'DUF3778', NULL, NULL, 21090, 9),
(267905, NULL, 'PF08615', NULL, NULL, 'Ribonuclease H2 non-catalytic subunit (Ylr154p-like)', NULL, 'RNase_H2_suC', NULL, NULL, 14116, 9),
(267906, NULL, 'PF05579', NULL, NULL, 'Equine arteritis virus serine endopeptidase S32', NULL, 'Peptidase_S32', NULL, NULL, 12164, 9),
(267907, NULL, 'PF12539', NULL, NULL, 'Chromosome segregation protein Csm1/Pcs1', NULL, 'Csm1', NULL, NULL, 14544, 9),
(267908, NULL, 'PF04449', NULL, NULL, 'CS1 type fimbrial major subunit', NULL, 'Fimbrial_CS1', NULL, NULL, 10640, 9),
(267909, NULL, 'PF07549', NULL, NULL, 'SecD/SecF GG Motif', NULL, 'Sec_GG', NULL, NULL, 16861, 9),
(267910, NULL, 'PF08804', NULL, NULL, 'gp32 DNA binding protein like', NULL, 'gp32', NULL, NULL, 7576, 9),
(267911, NULL, 'PF01832', NULL, NULL, 'Mannosyl-glycoprotein endo-beta-N-acetylglucosaminidase', NULL, 'Glucosaminidase', NULL, NULL, 6308, 9),
(267912, NULL, 'PF00210', NULL, NULL, 'Ferritin-like domain', NULL, 'Ferritin', NULL, NULL, 12056, 9),
(267913, NULL, 'PF13428', NULL, NULL, 'Tetratricopeptide repeat', NULL, 'TPR_14', NULL, NULL, NULL, 9),
(267914, NULL, 'PF05826', NULL, NULL, 'Phospholipase A2', NULL, 'Phospholip_A2_2', NULL, NULL, 10230, 9),
(267915, NULL, 'PF03463', NULL, NULL, 'eRF1 domain 1', NULL, 'eRF1_1', NULL, NULL, 7034, 9),
(267916, NULL, 'PF18863', NULL, NULL, 'AbiJ N-terminal domain 4', NULL, 'AbiJ_NTD4', NULL, NULL, NULL, 9),
(267917, NULL, 'PF16655', NULL, NULL, 'PhoD-like phosphatase, N-terminal domain', NULL, 'PhoD_N', NULL, NULL, 22997, 9),
(267918, NULL, 'PF19101', NULL, NULL, 'Family of unknown function (DUF5788)', NULL, 'DUF5788', NULL, NULL, 34193, 9),
(267919, NULL, 'PF12680', NULL, NULL, 'SnoaL-like domain', NULL, 'SnoaL_2', NULL, NULL, 33283, 9),
(267920, NULL, 'PF14236', NULL, NULL, 'Domain of unknown function (DUF4338)', NULL, 'DUF4338', NULL, NULL, 24820, 9),
(267921, NULL, 'PF03623', NULL, NULL, 'Focal adhesion targeting region', NULL, 'Focal_AT', NULL, NULL, 5315, 9),
(267922, NULL, 'PF16609', NULL, NULL, 'SH3-RhoGEF linking unstructured region', NULL, 'SH3-RhoG_link', NULL, NULL, NULL, 9),
(267923, NULL, 'PF18946', NULL, NULL, 'GpV Apex motif', NULL, 'Apex', NULL, NULL, 35930, 9),
(267924, NULL, 'PF00179', NULL, NULL, 'Ubiquitin-conjugating enzyme', NULL, 'UQ_con', NULL, NULL, 5931, 9),
(267925, NULL, 'PF06341', NULL, NULL, 'Protein of unknown function (DUF1056)', NULL, 'DUF1056', NULL, NULL, 8165, 9),
(267926, NULL, 'PF11661', NULL, NULL, 'Protein of unknown function (DUF2986)', NULL, 'DUF2986', NULL, NULL, 18587, 9),
(267927, NULL, 'PF07122', NULL, NULL, 'Variable length PCR target protein (VLPT)', NULL, 'VLPT', NULL, NULL, 13067, 9),
(267928, NULL, 'PF15510', NULL, NULL, 'CENP-W protein', NULL, 'CENP-W', NULL, NULL, 25003, 9),
(267929, NULL, 'PF04057', NULL, NULL, 'Replication factor-A protein 1, N-terminal domain', NULL, 'Rep-A_N', NULL, NULL, 1384, 9),
(267930, NULL, 'PF14097', NULL, NULL, 'Stage V sporulation protein AE1', NULL, 'SpoVAE', NULL, NULL, 23462, 9),
(267931, NULL, 'PF19265', NULL, NULL, 'Family of unknown function (DUF5908)', NULL, 'DUF5908', NULL, NULL, 37437, 9),
(267932, NULL, 'PF14811', NULL, NULL, 'Protein of unknown function TPD sequence-motif', NULL, 'TPD', NULL, NULL, 24933, 9),
(267933, NULL, 'PF17492', NULL, NULL, 'Delta Ctenitoxins', NULL, 'D_CNTX', NULL, NULL, 21152, 9),
(267934, NULL, 'PF09737', NULL, NULL, 'De-etiolated protein 1 Det1', NULL, 'Det1', NULL, NULL, 17961, 9),
(267935, NULL, 'PF12450', NULL, NULL, 'von Willebrand factor', NULL, 'vWF_A', NULL, NULL, 20568, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(267936, NULL, 'PF08195', NULL, NULL, 'TRI9 protein', NULL, 'TRI9', NULL, NULL, 13270, 9),
(267937, NULL, 'PF20302', NULL, NULL, 'HisK-N-like globin domain of the ASK signalosome', NULL, 'HisK-N-like', NULL, NULL, 37656, 9),
(267938, NULL, 'PF04182', NULL, NULL, 'B-block binding subunit of TFIIIC', NULL, 'B-block_TFIIIC', NULL, NULL, 4941, 9),
(267939, NULL, 'PF08375', NULL, NULL, 'Proteasome regulatory subunit C-terminal', NULL, 'Rpn3_C', NULL, NULL, 11659, 9),
(267940, NULL, 'PF15529', NULL, NULL, 'Bacterial toxin 24', NULL, 'Ntox24', NULL, NULL, 24000, 9),
(267941, NULL, 'PF06961', NULL, NULL, 'Protein of unknown function (DUF1294)', NULL, 'DUF1294', NULL, NULL, 9746, 9),
(267942, NULL, 'PF11037', NULL, NULL, 'Insulin-resistance promoting peptide in skeletal muscle', NULL, 'Musclin', NULL, NULL, 15312, 9),
(267943, NULL, 'PF09966', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2200)', NULL, 'DUF2200', NULL, NULL, 8174, 9),
(267944, NULL, 'PF08978', NULL, NULL, 'Reoviridae VP9', NULL, 'Reoviridae_Vp9', NULL, NULL, 8568, 9),
(267945, NULL, 'PF06892', NULL, NULL, 'Phage regulatory protein CII (CP76)', NULL, 'Phage_CP76', NULL, NULL, 11605, 9),
(267946, NULL, 'PF17227', NULL, NULL, 'Family of unknown function (DUF5302)', NULL, 'DUF5302', NULL, NULL, 20152, 9),
(267947, NULL, 'PF12990', NULL, NULL, 'Domain of unknonw function from B. Theta Gene description (DUF3874)', NULL, 'DUF3874', NULL, NULL, 24480, 9),
(267948, NULL, 'PF07236', NULL, NULL, 'Phytoreovirus S7 protein', NULL, 'Phytoreo_S7', NULL, NULL, 14108, 9),
(267949, NULL, 'PF07733', NULL, NULL, 'Bacterial DNA polymerase III alpha NTPase domain', NULL, 'DNA_pol3_alpha', NULL, NULL, 8170, 9),
(267950, NULL, 'PF14203', NULL, NULL, 'Putative transposon-transfer assisting protein', NULL, 'TTRAP', NULL, NULL, 26158, 9),
(267951, NULL, 'PF10440', NULL, NULL, 'Ubiquitin-binding WIYLD domain', NULL, 'WIYLD', NULL, NULL, 20248, 9),
(267952, NULL, 'PF05649', NULL, NULL, 'Peptidase family M13', NULL, 'Peptidase_M13_N', NULL, NULL, 12240, 9),
(267953, NULL, 'PF07643', NULL, NULL, 'Protein of unknown function (DUF1598)', NULL, 'DUF1598', NULL, NULL, 12812, 9),
(267954, NULL, 'PF11236', NULL, NULL, 'Protein of unknown function (DUF3037)', NULL, 'DUF3037', NULL, NULL, 18187, 9),
(267955, NULL, 'PF06214', NULL, NULL, 'Signaling lymphocytic activation molecule (SLAM) protein', NULL, 'SLAM', NULL, NULL, 9126, 9),
(267956, NULL, 'PF06908', NULL, NULL, 'YspA SLOG family', NULL, 'YpsA', NULL, NULL, 9925, 9),
(267957, NULL, 'PF10074', NULL, NULL, 'Uncharacterized conserved protein (DUF2285)', NULL, 'DUF2285', NULL, NULL, 18156, 9),
(267958, NULL, 'PF19911', NULL, NULL, 'Family of unknown function (DUF6384)', NULL, 'DUF6384', NULL, NULL, 36716, 9),
(267959, NULL, 'PF13940', NULL, NULL, 'Toxin Ldr, type I toxin-antitoxin system', NULL, 'Ldr_toxin', NULL, NULL, 23276, 9),
(267960, NULL, 'PF16312', NULL, NULL, 'Coiled-coil region of Oberon', NULL, 'Oberon_cc', NULL, NULL, 25733, 9),
(267961, NULL, 'PF05514', NULL, NULL, 'HR-like lesion-inducing', NULL, 'HR_lesion', NULL, NULL, 14368, 9),
(267962, NULL, 'PF08731', NULL, NULL, 'Transcription factor AFT', NULL, 'AFT', NULL, NULL, 11657, 9),
(267963, NULL, 'PF13739', NULL, NULL, 'Deacetylase PdaC', NULL, 'PdaC', NULL, NULL, 23401, 9),
(267964, NULL, 'PF11075', NULL, NULL, 'Protein of unknown function VcgC/VcgE (DUF2780)', NULL, 'DUF2780', NULL, NULL, 17815, 9),
(267965, NULL, 'PF05203', NULL, NULL, 'Hom_end-associated Hint', NULL, 'Hom_end_hint', NULL, NULL, 3077, 9),
(267966, NULL, 'PF03444', NULL, NULL, 'Winged helix-turn-helix transcription repressor, HrcA DNA-binding', NULL, 'HrcA_DNA-bdg', NULL, NULL, 10834, 9),
(267967, NULL, 'PF05117', NULL, NULL, 'Family of unknown function (DUF695)', NULL, 'DUF695', NULL, NULL, 10723, 9),
(267968, NULL, 'PF02824', NULL, NULL, 'TGS domain', NULL, 'TGS', NULL, NULL, 1817, 9),
(267969, NULL, 'PF09003', NULL, NULL, 'Bacteriophage lambda integrase, Arm DNA-binding domain', NULL, 'Arm-DNA-bind_1', NULL, NULL, 8707, 9),
(267970, NULL, 'PF06286', NULL, NULL, 'Coleoptericin', NULL, 'Coleoptericin', NULL, NULL, 8296, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(267971, NULL, 'PF05737', NULL, NULL, 'Collagen binding domain', NULL, 'Collagen_bind', NULL, NULL, 12307, 9),
(267972, NULL, 'PF03717', NULL, NULL, 'Penicillin-binding Protein dimerisation domain', NULL, 'PBP_dimer', NULL, NULL, 5144, 9),
(267973, NULL, 'PF16457', NULL, NULL, 'Pleckstrin homology domain', NULL, 'PH_12', NULL, NULL, 1423, 9),
(267974, NULL, 'PF01936', NULL, NULL, 'NYN domain', NULL, 'NYN', NULL, NULL, 15228, 9),
(267975, NULL, 'PF06763', NULL, NULL, 'Prophage minor tail protein Z (GPZ)', NULL, 'Minor_tail_Z', NULL, NULL, 9469, 9),
(267976, NULL, 'PF08902', NULL, NULL, 'Domain of unknown function (DUF1848)', NULL, 'DUF1848', NULL, NULL, 7756, 9),
(267977, NULL, 'PF09338', NULL, NULL, 'Glycine/sarcosine/betaine reductase component B subunits', NULL, 'Gly_reductase', NULL, NULL, 7368, 9),
(267978, NULL, 'PF17850', NULL, NULL, 'CysA C-terminal regulatory domain', NULL, 'CysA_C_terminal', NULL, NULL, 28903, 9),
(267979, NULL, 'PF03201', NULL, NULL, 'H2-forming N5,N10-methylene-tetrahydromethanopterin dehydrogenase', NULL, 'HMD', NULL, NULL, 122, 9),
(267980, NULL, 'PF02012', NULL, NULL, 'BNR/Asp-box repeat', NULL, 'BNR', NULL, NULL, 5504, 9),
(267981, NULL, 'PF11600', NULL, NULL, 'Chromatin assembly factor 1 complex p150 subunit, N-terminal', NULL, 'CAF-1_p150', NULL, NULL, NULL, 9),
(267982, NULL, 'PF19797', NULL, NULL, 'Family of unknown function (DUF6281)', NULL, 'DUF6281', NULL, NULL, 37271, 9),
(267983, NULL, 'PF06848', NULL, NULL, 'Disaggregatase related repeat', NULL, 'Disaggr_repeat', NULL, NULL, 9393, 9),
(267984, NULL, 'PF15470', NULL, NULL, 'Domain of unknown function (DUF4637)', NULL, 'DUF4637', NULL, NULL, 26600, 9),
(267985, NULL, 'PF15942', NULL, NULL, 'Domain of unknown function (DUF4751)', NULL, 'DUF4751', NULL, NULL, 24903, 9),
(267986, NULL, 'PF06103', NULL, NULL, 'Bacterial protein of unknown function (DUF948)', NULL, 'DUF948', NULL, NULL, 13590, 9),
(267987, NULL, 'PF17210', NULL, NULL, 'SdrD B-like domain', NULL, 'SdrD_B', NULL, NULL, 28783, 9),
(267988, NULL, 'PF04932', NULL, NULL, 'O-Antigen ligase', NULL, 'Wzy_C', NULL, NULL, 6878, 9),
(267989, NULL, 'PF04247', NULL, NULL, 'Invasion gene expression up-regulator, SirB', NULL, 'SirB', NULL, NULL, 5810, 9),
(267990, NULL, 'PF13533', NULL, NULL, 'Biotin-lipoyl like', NULL, 'Biotin_lipoyl_2', NULL, NULL, 27363, 9),
(267991, NULL, 'PF09060', NULL, NULL, 'L27_N', NULL, 'L27_N', NULL, NULL, 9504, 9),
(267992, NULL, 'PF03004', NULL, NULL, 'Plant transposase (Ptta/En/Spm family)', NULL, 'Transposase_24', NULL, NULL, 3907, 9),
(267993, NULL, 'PF00048', NULL, NULL, 'Small cytokines (intecrine/chemokine), interleukin-8 like', NULL, 'IL8', NULL, NULL, 4008, 9),
(267994, NULL, 'PF06685', NULL, NULL, 'Protein of unknown function (DUF1186)', NULL, 'DUF1186', NULL, NULL, 8481, 9),
(267995, NULL, 'PF12609', NULL, NULL, 'Wound-induced protein', NULL, 'DUF3774', NULL, NULL, 21135, 9),
(267996, NULL, 'PF00947', NULL, NULL, 'Picornavirus core protein 2A', NULL, 'Pico_P2A', NULL, NULL, 2996, 9),
(267997, NULL, 'PF01121', NULL, NULL, 'Dephospho-CoA kinase', NULL, 'CoaE', NULL, NULL, 4095, 9),
(267998, NULL, 'PF14903', NULL, NULL, 'WG containing repeat', NULL, 'WG_beta_rep', NULL, NULL, 22462, 9),
(267999, NULL, 'PF19083', NULL, NULL, 'Family of unknown function (DUF5774)', NULL, 'DUF5774', NULL, NULL, 34771, 9),
(268000, NULL, 'PF02714', NULL, NULL, 'Calcium-dependent channel, 7TM region, putative phosphate', NULL, 'RSN1_7TM', NULL, NULL, 3378, 9),
(268001, NULL, 'PF08854', NULL, NULL, 'Domain of unknown function (DUF1824)', NULL, 'DUF1824', NULL, NULL, 14272, 9),
(268002, NULL, 'PF07577', NULL, NULL, 'Domain of Unknown Function (DUF1547)', NULL, 'DUF1547', NULL, NULL, 13851, 9),
(268003, NULL, 'PF03025', NULL, NULL, 'Papillomavirus E5', NULL, 'Papilloma_E5', NULL, NULL, 3582, 9),
(268004, NULL, 'PF16851', NULL, NULL, 'Stomagen', NULL, 'Stomagen', NULL, NULL, 36345, 9),
(268005, NULL, 'PF10585', NULL, NULL, 'Ubiquitin-activating enzyme, SCCH domain', NULL, 'UBA_E1_SCCH', NULL, NULL, 19387, 9),
(268006, NULL, 'PF04551', NULL, NULL, 'GcpE protein', NULL, 'GcpE', NULL, NULL, 883, 9); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(268007, NULL, 'PF19181', NULL, NULL, 'Family of unknown function (DUF5863)', NULL, 'DUF5863', NULL, NULL, 35090, 9),
(268008, NULL, 'PF18688', NULL, NULL, 'Family of unknown function (DUF5638)', NULL, 'DUF5638', NULL, NULL, 28459, 9),
(268009, NULL, 'PF20621', NULL, NULL, 'Family of unknown function (DUF6806)', NULL, 'DUF6806', NULL, NULL, 37743, 9),
(268010, NULL, 'PF00175', NULL, NULL, 'Oxidoreductase NAD-binding domain', NULL, 'NAD_binding_1', NULL, NULL, 6782, 9),
(268011, NULL, 'PF04650', NULL, NULL, 'YSIRK type signal peptide', NULL, 'YSIRK_signal', NULL, NULL, 6752, 9),
(268012, NULL, 'PF20376', NULL, NULL, 'Domain of unknown function (DUF6671)', NULL, 'DUF6671', NULL, NULL, 33903, 9),
(268013, NULL, 'PF06479', NULL, NULL, 'Ribonuclease 2-5A', NULL, 'Ribonuc_2-5A', NULL, NULL, 10446, 9),
(268014, NULL, 'PF08590', NULL, NULL, 'Domain of unknown function (DUF1771)', NULL, 'DUF1771', NULL, NULL, 17993, 9),
(268015, NULL, 'PF08706', NULL, NULL, 'D5 N terminal like', NULL, 'D5_N', NULL, NULL, 11548, 9),
(268016, NULL, 'PF02344', NULL, NULL, 'Myc leucine zipper domain', NULL, 'Myc-LZ', NULL, NULL, 4151, 9),
(268017, NULL, 'PF15366', NULL, NULL, 'Domain of unknown function (DUF4597)', NULL, 'DUF4597', NULL, NULL, 25679, 9),
(268018, NULL, 'PF16296', NULL, NULL, 'N-terminal of TM subunit in PBP-dependent ABC transporters', NULL, 'TM_PBP2_N', NULL, NULL, 25510, 9),
(268019, NULL, 'PF09853', NULL, NULL, 'Putative transposon-encoded protein (DUF2080)', NULL, 'DUF2080', NULL, NULL, 19067, 9),
(268020, NULL, 'PF06902', NULL, NULL, 'Divergent 4Fe-4S mono-cluster', NULL, 'Fer4_19', NULL, NULL, 9897, 9),
(268021, NULL, 'PF11558', NULL, NULL, 'Het-s 218-289', NULL, 'HET-s_218-289', NULL, NULL, 15116, 9),
(268022, NULL, 'PF07284', NULL, NULL, '2-vinyl bacteriochlorophyllide hydratase (BCHF)', NULL, 'BCHF', NULL, NULL, 14286, 9),
(268023, NULL, 'PF04848', NULL, NULL, 'Poxvirus A22 protein', NULL, 'Pox_A22', NULL, NULL, 5044, 9),
(268024, NULL, 'PF13000', NULL, NULL, 'Acetyl-coenzyme A transporter 1', NULL, 'Acatn', NULL, NULL, 23271, 9),
(268025, NULL, 'PF14976', NULL, NULL, 'FAM72 protein', NULL, 'FAM72', NULL, NULL, 24340, 9),
(268026, NULL, 'PF04595', NULL, NULL, 'Poxvirus I6-like family', NULL, 'Pox_I6', NULL, NULL, 767, 9),
(268027, NULL, 'PF19633', NULL, NULL, 'Protein SET DOMAIN GROUP 2 C-terminal', NULL, 'SDG2_C', NULL, NULL, 34043, 9),
(268028, NULL, 'PF10878', NULL, NULL, 'Protein of unknown function (DUF2672)', NULL, 'DUF2672', NULL, NULL, 16895, 9),
(268029, NULL, 'PF17494', NULL, NULL, 'Family of unknown function (DUF5429)', NULL, 'DUF5429', NULL, NULL, 21058, 9),
(268030, NULL, 'PF07816', NULL, NULL, 'Protein of unknown function (DUF1645)', NULL, 'DUF1645', NULL, NULL, 14163, 9),
(268031, NULL, 'PF15363', NULL, NULL, 'Domain of unknown function (DUF4596)', NULL, 'DUF4596', NULL, NULL, 23308, 9),
(268032, NULL, 'PF12247', NULL, NULL, 'Temperature dependent protein affecting M2 dsRNA replication', NULL, 'MKT1_N', NULL, NULL, 20081, 9),
(268033, NULL, 'PF15961', NULL, NULL, 'Domain of unknown function (DUF4764)', NULL, 'DUF4764', NULL, NULL, 26892, 9),
(268034, NULL, 'PF01090', NULL, NULL, 'Ribosomal protein S19e', NULL, 'Ribosomal_S19e', NULL, NULL, 187, 9),
(268035, NULL, 'PF11735', NULL, NULL, 'Cryptococcal mannosyltransferase 1', NULL, 'CAP59_mtransfer', NULL, NULL, 15209, 9),
(268036, NULL, 'PF17578', NULL, NULL, 'Family of unknown function (DUF5481)', NULL, 'DUF5481', NULL, NULL, 30982, 9),
(268037, NULL, 'PF20131', NULL, NULL, 'ABC-three component (ABC-3C) system Middle Component 3', NULL, 'MC3', NULL, NULL, 35891, 9),
(268038, NULL, 'PF14515', NULL, NULL, 'Haem-oxygenase-associated N-terminal helices', NULL, 'HOASN', NULL, NULL, 23486, 9),
(268039, NULL, 'PF00521', NULL, NULL, 'DNA gyrase/topoisomerase IV, subunit A', NULL, 'DNA_topoisoIV', NULL, NULL, 5957, 9),
(268040, NULL, 'PF01866', NULL, NULL, 'Putative diphthamide synthesis protein', NULL, 'Diphthamide_syn', NULL, NULL, 15307, 9),
(268041, NULL, 'PF03417', NULL, NULL, 'Acyl-coenzyme A:6-aminopenicillanic acid acyl-transferase', NULL, 'AAT', NULL, NULL, 10012, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(268042, NULL, 'PF16789', NULL, NULL, 'YscO-like protein', NULL, 'YscO-like', NULL, NULL, 26525, 9),
(268043, NULL, 'PF05621', NULL, NULL, 'Bacterial TniB protein', NULL, 'TniB', NULL, NULL, 7687, 9),
(268044, NULL, 'PF17604', NULL, NULL, 'Family of unknown function (DUF5500)', NULL, 'DUF5500', NULL, NULL, 20265, 9),
(268045, NULL, 'PF12949', NULL, NULL, 'HeH/LEM domain', NULL, 'HeH', NULL, NULL, 23239, 9),
(268046, NULL, 'PF02148', NULL, NULL, 'Zn-finger in ubiquitin-hydrolases and other protein', NULL, 'zf-UBP', NULL, NULL, 3441, 9),
(268047, NULL, 'PF17359', NULL, NULL, 'Family of unknown function (DUF5385)', NULL, 'DUF5385', NULL, NULL, 9553, 9),
(268048, NULL, 'PF19017', NULL, NULL, 'Domain of unknown function (DUF5746)', NULL, 'DUF5746', NULL, NULL, 35664, 9),
(268049, NULL, 'PF01981', NULL, NULL, 'Peptidyl-tRNA hydrolase PTH2', NULL, 'PTH2', NULL, NULL, 5407, 9),
(268050, NULL, 'PF15168', NULL, NULL, 'Triple QxxK/R motif-containing protein family', NULL, 'TRIQK', NULL, NULL, 22043, 9),
(268051, NULL, 'PF20075', NULL, NULL, 'Domain of unknown function (DUF6471)', NULL, 'DUF6471', NULL, NULL, 37416, 9),
(268052, NULL, 'PF05524', NULL, NULL, 'PEP-utilising enzyme, N-terminal', NULL, 'PEP-utilisers_N', NULL, NULL, 12017, 9),
(268053, NULL, 'PF11584', NULL, NULL, 'Proteinaceous host-selective toxin ToxA', NULL, 'Toxin_ToxA', NULL, NULL, 18632, 9),
(268054, NULL, 'PF19634', NULL, NULL, 'Family of unknown function (DUF6137)', NULL, 'DUF6137', NULL, NULL, 37087, 9),
(268055, NULL, 'PF00133', NULL, NULL, 'tRNA synthetases class I (I, L, M and V)', NULL, 'tRNA-synt_1', NULL, NULL, 6239, 9),
(268056, NULL, 'PF01710', NULL, NULL, 'Transposase', NULL, 'HTH_Tnp_IS630', NULL, NULL, 2788, 9),
(268057, NULL, 'PF16235', NULL, NULL, 'Domain of unknown function (DUF4894)', NULL, 'DUF4894', NULL, NULL, 25879, 9),
(268058, NULL, 'PF19105', NULL, NULL, 'Family of unknown function (DUF5792)', NULL, 'DUF5792', NULL, NULL, 35706, 9),
(268059, NULL, 'PF19309', NULL, NULL, 'Frem protein N-terminal domain', NULL, 'Frem_N', NULL, NULL, 36424, 9),
(268060, NULL, 'PF18466', NULL, NULL, 'Glutamate--tRNA ligase N-terminal domain', NULL, 'GluRS_N', NULL, NULL, 29196, 9),
(268061, NULL, 'PF13965', NULL, NULL, 'dsRNA-gated channel SID-1', NULL, 'SID-1_RNA_chan', NULL, NULL, 22696, 9),
(268062, NULL, 'PF14467', NULL, NULL, 'Domain of unknown function (DUF4426)', NULL, 'DUF4426', NULL, NULL, 25571, 9),
(268063, NULL, 'PF09322', NULL, NULL, 'Domain of unknown function (DUF1979)', NULL, 'DUF1979', NULL, NULL, 14484, 9),
(268064, NULL, 'PF01361', NULL, NULL, 'Tautomerase enzyme', NULL, 'Tautomerase', NULL, NULL, 5486, 9),
(268065, NULL, 'PF15671', NULL, NULL, 'Proline-rich protein family 18', NULL, 'PRR18', NULL, NULL, 25257, 9),
(268066, NULL, 'PF15078', NULL, NULL, 'Domain of unknown function (DUF4545)', NULL, 'DUF4545', NULL, NULL, 26278, 9),
(268067, NULL, 'PF18981', NULL, NULL, 'Internalin K domain (D3/D4)', NULL, 'InlK_D3', NULL, NULL, 35395, 9),
(268068, NULL, 'PF15238', NULL, NULL, 'FAM181', NULL, 'FAM181', NULL, NULL, 26203, 9),
(268069, NULL, 'PF07428', NULL, NULL, '15-O-acetyltransferase Tri3', NULL, 'Tri3', NULL, NULL, 8659, 9),
(268070, NULL, 'PF19557', NULL, NULL, 'Family of unknown function (DUF6079)', NULL, 'DUF6079', NULL, NULL, 34464, 9),
(268071, NULL, 'PF02390', NULL, NULL, 'Putative methyltransferase', NULL, 'Methyltransf_4', NULL, NULL, 4397, 9),
(268072, NULL, 'PF09193', NULL, NULL, 'Cholecystokinin A receptor, N-terminal', NULL, 'CholecysA-Rec_N', NULL, NULL, 12398, 9),
(268073, NULL, 'PF17705', NULL, NULL, 'Family of unknown function (DUF5551)', NULL, 'DUF5551', NULL, NULL, 32413, 9),
(268074, NULL, 'PF04144', NULL, NULL, 'SCAMP family', NULL, 'SCAMP', NULL, NULL, 7243, 9),
(268075, NULL, 'PF03503', NULL, NULL, 'Chlamydia cysteine-rich outer membrane protein 3', NULL, 'Chlam_OMP3', NULL, NULL, 6338, 9),
(268076, NULL, 'PF12561', NULL, NULL, 'ToxR activated gene A lipoprotein domain', NULL, 'TagA', NULL, NULL, 21396, 9),
(268077, NULL, 'PF04789', NULL, NULL, 'Protein of unknown function (DUF621)', NULL, 'DUF621', NULL, NULL, 4784, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(268078, NULL, 'PF11411', NULL, NULL, 'DNA ligase IV', NULL, 'DNA_ligase_IV', NULL, NULL, 18531, 9),
(268079, NULL, 'PF04472', NULL, NULL, 'Cell division protein SepF', NULL, 'SepF', NULL, NULL, 1148, 9),
(268080, NULL, 'PF09697', NULL, NULL, 'Protein of unknown function (Porph_ging)', NULL, 'Porph_ging', NULL, NULL, 6702, 9),
(268081, NULL, 'PF03298', NULL, NULL, 'Stanniocalcin family', NULL, 'Stanniocalcin', NULL, NULL, 834, 9),
(268082, NULL, 'PF02160', NULL, NULL, 'Cauliflower mosaic virus peptidase (A3)', NULL, 'Peptidase_A3', NULL, NULL, 5836, 9),
(268083, NULL, 'PF20255', NULL, NULL, 'Family of unknown function (DUF6606)', NULL, 'DUF6606', NULL, NULL, 37637, 9),
(268084, NULL, 'PF15056', NULL, NULL, 'Neuritin protein family', NULL, 'NRN1', NULL, NULL, 23192, 9),
(268085, NULL, 'PF18329', NULL, NULL, 'Surface glycan-binding protein B xyloglucan binding domain', NULL, 'SGBP_B_XBD', NULL, NULL, 27531, 9),
(268086, NULL, 'PF18900', NULL, NULL, 'Protein of unknown function (DUF5656)', NULL, 'DUF5656', NULL, NULL, 35947, 9),
(268087, NULL, 'PF16542', NULL, NULL, 'PNKP adenylyltransferase domain, ligase domain', NULL, 'PNKP_ligase', NULL, NULL, 25012, 9),
(268088, NULL, 'PF12686', NULL, NULL, 'Protein of unknown function (DUF3800)', NULL, 'DUF3800', NULL, NULL, 24617, 9),
(268089, NULL, 'PF15346', NULL, NULL, 'Arginine and glutamate-rich 1', NULL, 'ARGLU', NULL, NULL, 27818, 9),
(268090, NULL, 'PF00850', NULL, NULL, 'Histone deacetylase domain', NULL, 'Hist_deacetyl', NULL, NULL, 17834, 9),
(268091, NULL, 'PF09747', NULL, NULL, 'Coiled-coil domain containing protein 97-like, C-terminal', NULL, 'CCD97-like_C', NULL, NULL, 28808, 9),
(268092, NULL, 'PF00166', NULL, NULL, 'Chaperonin 10 Kd subunit', NULL, 'Cpn10', NULL, NULL, 14568, 9),
(268093, NULL, 'PF19372', NULL, NULL, 'Family of unknown function (DUF5947)', NULL, 'DUF5947', NULL, NULL, 36700, 9),
(268094, NULL, 'PF20372', NULL, NULL, 'Family of unknown function (DUF6667)', NULL, 'DUF6667', NULL, NULL, 33574, 9),
(268095, NULL, 'PF03740', NULL, NULL, 'Pyridoxal phosphate biosynthesis protein PdxJ', NULL, 'PdxJ', NULL, NULL, 730, 9),
(268096, NULL, 'PF07667', NULL, NULL, 'Protein of unknown function (DUF1600)', NULL, 'DUF1600', NULL, NULL, 10880, 9),
(268097, NULL, 'PF14519', NULL, NULL, 'Macro-like domain', NULL, 'Macro_2', NULL, NULL, 23091, 9),
(268098, NULL, 'PF05952', NULL, NULL, 'Bacillus competence pheromone ComX', NULL, 'ComX', NULL, NULL, 12807, 9),
(268099, NULL, 'PF09504', NULL, NULL, 'Bsp6I restriction endonuclease', NULL, 'RE_Bsp6I', NULL, NULL, 15677, 9),
(268100, NULL, 'PF00893', NULL, NULL, 'Small Multidrug Resistance protein', NULL, 'Multi_Drug_Res', NULL, NULL, 37007, 9),
(268101, NULL, 'PF09519', NULL, NULL, 'HindVP restriction endonuclease', NULL, 'RE_HindVP', NULL, NULL, 16608, 9),
(268102, NULL, 'PF10180', NULL, NULL, 'WKF domain', NULL, 'WKF', NULL, NULL, 14969, 9),
(268103, NULL, 'PF13866', NULL, NULL, 'SAP30 zinc-finger', NULL, 'zf-SAP30', NULL, NULL, 24768, 9),
(268104, NULL, 'PF10961', NULL, NULL, 'Selenoprotein SelK_SelG', NULL, 'SelK_SelG', NULL, NULL, 24498, 9),
(268105, NULL, 'PF12776', NULL, NULL, 'Myb/SANT-like DNA-binding domain', NULL, 'Myb_DNA-bind_3', NULL, NULL, 21176, 9),
(268106, NULL, 'PF05895', NULL, NULL, 'Siphovirus protein of unknown function (DUF859)', NULL, 'DUF859', NULL, NULL, 13808, 9),
(268107, NULL, 'PF15705', NULL, NULL, 'Mature oligodendrocyte transmembrane protein, TMEM132D, N-term', NULL, 'TMEM132D_N', NULL, NULL, 24040, 9),
(268108, NULL, 'PF10670', NULL, NULL, 'Domain of unknown function (DUF4198)', NULL, 'DUF4198', NULL, NULL, 20335, 9),
(268109, NULL, 'PF17662', NULL, NULL, 'Family of unknown function (DUF5524)', NULL, 'DUF5524', NULL, NULL, 31746, 9),
(268110, NULL, 'PF13840', NULL, NULL, 'ACT domain', NULL, 'ACT_7', NULL, NULL, 22719, 9),
(268111, NULL, 'PF09413', NULL, NULL, 'Putative prokaryotic signal transducing protein', NULL, 'DUF2007', NULL, NULL, 15343, 9),
(268112, NULL, 'PF03296', NULL, NULL, 'Poxvirus poly(A) polymerase nucleotidyltransferase domain', NULL, 'Pox_polyA_pol', NULL, NULL, 8609, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(268113, NULL, 'PF05385', NULL, NULL, 'Mastadenovirus early E4 13 kDa protein', NULL, 'Adeno_E4', NULL, NULL, 12604, 9),
(268114, NULL, 'PF16481', NULL, NULL, 'Domain of unknown function (DUF5058)', NULL, 'DUF5058', NULL, NULL, 18439, 9),
(268115, NULL, 'PF13861', NULL, NULL, 'FlgD Tudor-like domain', NULL, 'FLgD_tudor', NULL, NULL, 24158, 9),
(268116, NULL, 'PF19571', NULL, NULL, 'ACT domain pair', NULL, 'ACT_8', NULL, NULL, 34497, 9),
(268117, NULL, 'PF01590', NULL, NULL, 'GAF domain', NULL, 'GAF', NULL, NULL, 112, 9),
(268118, NULL, 'PF17300', NULL, NULL, 'Filaments in between nuclei protein-1', NULL, 'FIN1', NULL, NULL, 28326, 9),
(268119, NULL, 'PF05101', NULL, NULL, 'Type IV secretory pathway, VirB3-like protein', NULL, 'VirB3', NULL, NULL, 2041, 9),
(268120, NULL, 'PF19772', NULL, NULL, 'Family of unknown function (DUF6258)', NULL, 'DUF6258', NULL, NULL, 37150, 9),
(268121, NULL, 'PF04685', NULL, NULL, 'Glycosyl-hydrolase family 116, catalytic region', NULL, 'DUF608', NULL, NULL, 3381, 9),
(268122, NULL, 'PF14612', NULL, NULL, 'IEC3 subunit of the Ino80 complex, chromatin re-modelling', NULL, 'Ino80_Iec3', NULL, NULL, 21805, 9),
(268123, NULL, 'PF18741', NULL, NULL, 'REase_MTES_1575', NULL, 'MTES_1575', NULL, NULL, NULL, 9),
(268124, NULL, 'PF05704', NULL, NULL, 'Capsular polysaccharide synthesis protein', NULL, 'Caps_synth', NULL, NULL, 8843, 9),
(268125, NULL, 'PF04147', NULL, NULL, 'Nop14-like family', NULL, 'Nop14', NULL, NULL, 7209, 9),
(268126, NULL, 'PF04936', NULL, NULL, 'Protein of unknown function (DUF658)', NULL, 'DUF658', NULL, NULL, 6711, 9),
(268127, NULL, 'PF12936', NULL, NULL, 'KRI1-like family C-terminal', NULL, 'Kri1_C', NULL, NULL, 17473, 9),
(268128, NULL, 'PF20212', NULL, NULL, 'Family of unknown function (DUF6572)', NULL, 'DUF6572', NULL, NULL, 37014, 9),
(268129, NULL, 'PF02532', NULL, NULL, 'Photosystem II reaction centre I protein (PSII 4.8 kDa protein)', NULL, 'PsbI', NULL, NULL, 1606, 9),
(268130, NULL, 'PF18323', NULL, NULL, 'Cop9 signalosome subunit 5 C-terminal domain', NULL, 'CSN5_C', NULL, NULL, 28927, 9),
(268131, NULL, 'PF17881', NULL, NULL, 'Domain of unknown function (DUF5590)', NULL, 'DUF5590', NULL, NULL, 29371, 9),
(268132, NULL, 'PF18759', NULL, NULL, 'Plavaka transposase', NULL, 'Plavaka', NULL, NULL, 28891, 9),
(268133, NULL, 'PF02825', NULL, NULL, 'WWE domain', NULL, 'WWE', NULL, NULL, 2647, 9),
(268134, NULL, 'PF05512', NULL, NULL, 'AWPM-19-like family', NULL, 'AWPM-19', NULL, NULL, 7794, 9),
(268135, NULL, 'PF16083', NULL, NULL, 'LydA holin phage, holin superfamily III', NULL, 'Phage_holin_3_3', NULL, NULL, 22943, 9),
(268136, NULL, 'PF11171', NULL, NULL, 'Protein of unknown function (DUF2958)', NULL, 'DUF2958', NULL, NULL, 18464, 9),
(268137, NULL, 'PF09649', NULL, NULL, 'Histone chaperone domain CHZ', NULL, 'CHZ', NULL, NULL, 17639, 9),
(268138, NULL, 'PF00479', NULL, NULL, 'Glucose-6-phosphate dehydrogenase, NAD binding domain', NULL, 'G6PD_N', NULL, NULL, 16805, 9),
(268139, NULL, 'PF08098', NULL, NULL, 'Anemonia sulcata toxin III family', NULL, 'ATX_III', NULL, NULL, 12739, 9),
(268140, NULL, 'PF06736', NULL, NULL, 'Endosomal/lysosomal potassium channel TMEM175', NULL, 'TMEM175', NULL, NULL, 8410, 9),
(268141, NULL, 'PF18859', NULL, NULL, 'Actinobacteria/chloroflexi VLRF1 release factor', NULL, 'acVLRF1', NULL, NULL, 28393, 9),
(268142, NULL, 'PF10477', NULL, NULL, 'Nucleocytoplasmic shuttling protein for mRNA cap-binding EIF4E', NULL, 'EIF4E-T', NULL, NULL, 20561, 9),
(268143, NULL, 'PF02956', NULL, NULL, 'TT viral orf 1', NULL, 'TT_ORF1', NULL, NULL, 3789, 9),
(268144, NULL, 'PF09278', NULL, NULL, 'MerR, DNA binding', NULL, 'MerR-DNA-bind', NULL, NULL, 13633, 9),
(268145, NULL, 'PF08531', NULL, NULL, 'Alpha-L-rhamnosidase N-terminal domain', NULL, 'Bac_rhamnosid_N', NULL, NULL, 7848, 9),
(268146, NULL, 'PF05606', NULL, NULL, 'Borrelia burgdorferi protein of unknown function (DUF777)', NULL, 'DUF777', NULL, NULL, 12101, 9),
(268147, NULL, 'PF15114', NULL, NULL, 'Uncharacterised protein family UPF0640', NULL, 'UPF0640', NULL, NULL, 21730, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(268148, NULL, 'PF03798', NULL, NULL, 'TLC domain', NULL, 'TRAM_LAG1_CLN8', NULL, NULL, 1352, 9),
(268149, NULL, 'PF07556', NULL, NULL, 'Protein of unknown function (DUF1538)', NULL, 'DUF1538', NULL, NULL, 13657, 9),
(268150, NULL, 'PF00827', NULL, NULL, 'Ribosomal L15', NULL, 'Ribosomal_L15e', NULL, NULL, 6669, 9),
(268151, NULL, 'PF09582', NULL, NULL, 'Iron only nitrogenase protein AnfO (AnfO_nitrog)', NULL, 'AnfO_nitrog', NULL, NULL, 8550, 9),
(268152, NULL, 'PF08656', NULL, NULL, 'DASH complex subunit Dad3', NULL, 'DASH_Dad3', NULL, NULL, 7648, 9),
(268153, NULL, 'PF07342', NULL, NULL, 'Protein of unknown function (DUF1474)', NULL, 'DUF1474', NULL, NULL, 8285, 9),
(268154, NULL, 'PF18846', NULL, NULL, 'Bacterial archaeo-eukaryotic release factor family 5', NULL, 'baeRF_family5', NULL, NULL, 28026, 9),
(268155, NULL, 'PF00440', NULL, NULL, 'Bacterial regulatory proteins, tetR family', NULL, 'TetR_N', NULL, NULL, 3476, 9),
(268156, NULL, 'PF17074', NULL, NULL, 'Darcynin, domain of unknown function', NULL, 'Darcynin', NULL, NULL, 23793, 9),
(268157, NULL, 'PF18120', NULL, NULL, 'Domain of unknown function (DUF5597)', NULL, 'DUF5597', NULL, NULL, 28894, 9),
(268158, NULL, 'PF07471', NULL, NULL, 'Phage DNA packaging protein Nu1', NULL, 'Phage_Nu1', NULL, NULL, 12834, 9),
(268159, NULL, 'PF19390', NULL, NULL, 'Family of unknown function (DUF5965)', NULL, 'DUF5965', NULL, NULL, 36613, 9),
(268160, NULL, 'PF09831', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2058)', NULL, 'DUF2058', NULL, NULL, 16487, 9),
(268161, NULL, 'PF16142', NULL, NULL, 'Domain of unknown function (DUF4850)', NULL, 'DUF4850', NULL, NULL, 22568, 9),
(268162, NULL, 'PF11062', NULL, NULL, 'Protein of unknown function (DUF2863)', NULL, 'DUF2863', NULL, NULL, 17524, 9),
(268163, NULL, 'PF12166', NULL, NULL, 'Piezo non-specific cation channel, R-Ras-binding domain', NULL, 'Piezo_RRas_bdg', NULL, NULL, 24061, 9),
(268164, NULL, 'PF20354', NULL, NULL, 'Family of unknown function (DUF6649)', NULL, 'DUF6649', NULL, NULL, 33946, 9),
(268165, NULL, 'PF20532', NULL, NULL, 'Family of unknown function (DUF6747)', NULL, 'DUF6747', NULL, NULL, 33617, 9),
(268166, NULL, 'PF15027', NULL, NULL, 'Domain of unknown function (DUF4525)', NULL, 'DUF4525', NULL, NULL, 22285, 9),
(268167, NULL, 'PF15341', NULL, NULL, 'Ribosome biogenesis protein SLX9', NULL, 'SLX9', NULL, NULL, 23738, 9),
(268168, NULL, 'PF14022', NULL, NULL, 'Protein of unknown function (DUF4238)', NULL, 'DUF4238', NULL, NULL, 22323, 9),
(268169, NULL, 'PF16014', NULL, NULL, 'Histone deacetylase complex subunit SAP130 C-terminus', NULL, 'SAP130_C', NULL, NULL, 21741, 9),
(268170, NULL, 'PF03748', NULL, NULL, 'Flagellar basal body-associated protein FliL', NULL, 'FliL', NULL, NULL, 659, 9),
(268171, NULL, 'PF15077', NULL, NULL, 'Membrane-anchored junction protein', NULL, 'MAJIN', NULL, NULL, 21632, 9),
(268172, NULL, 'PF06587', NULL, NULL, 'Protein of unknown function (DUF1137)', NULL, 'DUF1137', NULL, NULL, 8195, 9),
(268173, NULL, 'PF12745', NULL, NULL, 'Anticodon binding domain of tRNAs', NULL, 'HGTP_anticodon2', NULL, NULL, 22863, 9),
(268174, NULL, 'PF05210', NULL, NULL, 'Sprouty protein (Spry)', NULL, 'Sprouty', NULL, NULL, 3158, 9),
(268175, NULL, 'PF06631', NULL, NULL, 'Protein of unknown function (DUF1154)', NULL, 'DUF1154', NULL, NULL, 10378, 9),
(268176, NULL, 'PF01246', NULL, NULL, 'Ribosomal protein L24e', NULL, 'Ribosomal_L24e', NULL, NULL, 42, 9),
(268177, NULL, 'PF00913', NULL, NULL, 'Trypanosome variant surface glycoprotein (A-type)', NULL, 'Trypan_glycop', NULL, NULL, 4687, 9),
(268178, NULL, 'PF07639', NULL, NULL, 'YTV', NULL, 'YTV', NULL, NULL, 12694, 9),
(268179, NULL, 'PF12062', NULL, NULL, 'heparan sulfate-N-deacetylase', NULL, 'HSNSD', NULL, NULL, 19629, 9),
(268180, NULL, 'PF15665', NULL, NULL, 'Family with sequence similarity 184, A and B', NULL, 'FAM184', NULL, NULL, 29000, 9),
(268181, NULL, 'PF06330', NULL, NULL, 'Trichodiene synthase (TRI5)', NULL, 'TRI5', NULL, NULL, 10521, 9),
(268182, NULL, 'PF14133', NULL, NULL, 'Domain of unknown function (DUF4300)', NULL, 'DUF4300', NULL, NULL, 26264, 9);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(268183, NULL, 'PF12070', NULL, NULL, 'Protein SCAI', NULL, 'SCAI', NULL, NULL, 16529, 9),
(268184, NULL, 'PF02496', NULL, NULL, 'ABA/WDS induced protein', NULL, 'ABA_WDS', NULL, NULL, 6242, 9),
(268185, NULL, 'PF00155', NULL, NULL, 'Aminotransferase class I and II', NULL, 'Aminotran_1_2', NULL, NULL, 4492, 9),
(268186, NULL, 'PF04552', NULL, NULL, 'Sigma-54, DNA binding domain', NULL, 'Sigma54_DBD', NULL, NULL, 2363, 9),
(268187, NULL, 'PF12901', NULL, NULL, 'SUZ-C motif', NULL, 'SUZ-C', NULL, NULL, 13935, 9),
(268188, NULL, 'PF13957', NULL, NULL, 'Toxin YafO, type II toxin-antitoxin system', NULL, 'YafO_toxin', NULL, NULL, 19902, 9),
(268189, NULL, 'PF14988', NULL, NULL, 'Domain of unknown function (DUF4515)', NULL, 'DUF4515', NULL, NULL, 22330, 9),
(268190, NULL, 'PF19776', NULL, NULL, 'Family of unknown function (DUF6262)', NULL, 'DUF6262', NULL, NULL, 37219, 9),
(268191, NULL, 'PF02586', NULL, NULL, 'SOS response associated peptidase (SRAP)', NULL, 'SRAP', NULL, NULL, 6091, 9),
(268192, NULL, 'PF11279', NULL, NULL, 'Protein of unknown function (DUF3080)', NULL, 'DUF3080', NULL, NULL, 18262, 9),
(268193, NULL, 'PF05550', NULL, NULL, 'Pestivirus Npro endopeptidase C53', NULL, 'Peptidase_C53', NULL, NULL, 12072, 9),
(268194, NULL, 'PF00772', NULL, NULL, 'DnaB-like helicase N terminal domain', NULL, 'DnaB', NULL, NULL, 1370, 9),
(268195, NULL, 'PF02300', NULL, NULL, 'Fumarate reductase subunit C', NULL, 'Fumarate_red_C', NULL, NULL, 6231, 9),
(268196, NULL, 'PF18802', NULL, NULL, 'CxC1 like cysteine cluster associated with KDZ transposases', NULL, 'CxC1', NULL, NULL, 29242, 9),
(268197, NULL, 'PF09255', NULL, NULL, 'Caf1 Capsule antigen', NULL, 'Antig_Caf1', NULL, NULL, 13322, 9),
(268198, NULL, 'PF09596', NULL, NULL, 'MamL-1 domain', NULL, 'MamL-1', NULL, NULL, 16930, 9),
(268199, NULL, 'PF05764', NULL, NULL, 'YL1 nuclear protein', NULL, 'YL1', NULL, NULL, 35770, 9),
(268200, NULL, 'PF05356', NULL, NULL, 'Inovirus Coat protein B', NULL, 'Phage_Coat_B', NULL, NULL, 5201, 9),
(268201, NULL, 'PF07828', NULL, NULL, 'PA-IL-like protein', NULL, 'PA-IL', NULL, NULL, 13044, 9),
(268202, NULL, 'PF13634', NULL, NULL, 'Nucleoporin FG repeat region', NULL, 'Nucleoporin_FG', NULL, NULL, 23658, 9),
(268203, NULL, 'PF04230', NULL, NULL, 'Polysaccharide pyruvyl transferase', NULL, 'PS_pyruv_trans', NULL, NULL, 5697, 9),
(268204, NULL, 'PF02117', NULL, NULL, 'Serpentine type 7TM GPCR chemoreceptor Sra', NULL, '7TM_GPCR_Sra', NULL, NULL, 266, 9),
(268205, NULL, 'PF09427', NULL, NULL, 'Domain of unknown function (DUF2014)', NULL, 'DUF2014', NULL, NULL, 15860, 9),
(268206, NULL, 'PF07014', NULL, NULL, 'Hs1pro-1 protein C-terminus', NULL, 'Hs1pro-1_C', NULL, NULL, 12140, 9),
(268207, NULL, 'PF12471', NULL, NULL, 'GTP cyclohydrolase N terminal', NULL, 'GTP_CH_N', NULL, NULL, 20705, 9),
(268208, NULL, 'PF14999', NULL, NULL, 'Shadow of prion protein, neuroprotective', NULL, 'Shadoo', NULL, NULL, 21796, 9),
(268209, NULL, 'PF01596', NULL, NULL, 'O-methyltransferase', NULL, 'Methyltransf_3', NULL, NULL, 6647, 9),
(268210, NULL, 'PF02536', NULL, NULL, 'mTERF', NULL, 'mTERF', NULL, NULL, 4579, 9),
(268211, NULL, 'PF09799', NULL, NULL, 'Predicted membrane protein', NULL, 'Transmemb_17', NULL, NULL, 18256, 9),
(268212, NULL, 'PF11485', NULL, NULL, 'Protein of unknown function (DUF3211)', NULL, 'DUF3211', NULL, NULL, 18533, 9),
(268213, NULL, 'PF18231', NULL, NULL, 'Domain of unknown function (DUF5603)', NULL, 'DUF5603', NULL, NULL, 28407, 9),
(268214, NULL, 'PF20114', NULL, NULL, 'Family of unknown function (DUF6504)', NULL, 'DUF6504', NULL, NULL, 37384, 9),
(268215, NULL, 'PF10169', NULL, NULL, 'Learning-associated protein', NULL, 'Laps', NULL, NULL, 19482, 9),
(268216, NULL, 'PF03271', NULL, NULL, 'EB1-like C-terminal motif', NULL, 'EB1', NULL, NULL, 2777, 9),
(268217, NULL, 'PF03811', NULL, NULL, 'InsA N-terminal domain', NULL, 'Zn_Tnp_IS1', NULL, NULL, 2889, 9),
(268218, NULL, 'PF17877', NULL, NULL, 'DIS3-like exonuclease 2 C terminal', NULL, 'Dis3l2_C_term', NULL, NULL, 28686, 9),
(268219, NULL, 'PF08025', NULL, NULL, 'Spider antimicrobial peptide', NULL, 'Antimicrobial_3', NULL, NULL, 12711, 9); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(268220, NULL, 'PF10486', NULL, NULL, 'Phosphoinositide 3-kinase gamma adapter protein p101 subunit', NULL, 'PI3K_1B_p101', NULL, NULL, 18149, 9),
(268221, NULL, 'PF05082', NULL, NULL, 'Rop-like', NULL, 'Rop-like', NULL, NULL, 1233, 9),
(268222, NULL, 'PF08169', NULL, NULL, 'RBB1NT (NUC162) domain', NULL, 'RBB1NT', NULL, NULL, 9645, 9),
(268223, NULL, 'PF18904', NULL, NULL, 'Domain of unknown function (DUF5660)', NULL, 'DUF5660', NULL, NULL, 35639, 9),
(268224, NULL, 'PF09258', NULL, NULL, 'Glycosyl transferase family 64 domain', NULL, 'Glyco_transf_64', NULL, NULL, 13395, 9),
(268225, NULL, 'PF02358', NULL, NULL, 'Trehalose-phosphatase', NULL, 'Trehalose_PPase', NULL, NULL, 4481, 9),
(268226, NULL, 'PF15841', NULL, NULL, 'Transmembrane protein 239 family', NULL, 'TMEM239', NULL, NULL, 26307, 9),
(268227, NULL, 'PF15135', NULL, NULL, 'Uncharacterised protein UPF0515', NULL, 'UPF0515', NULL, NULL, 22422, 9),
(268228, NULL, 'PF11925', NULL, NULL, 'Protein of unknown function (DUF3443)', NULL, 'DUF3443', NULL, NULL, 19788, 9),
(268229, NULL, 'PF10607', NULL, NULL, 'CTLH/CRA C-terminal to LisH motif domain', NULL, 'CTLH', NULL, NULL, 26483, 9),
(268230, NULL, 'PF12719', NULL, NULL, 'Nuclear condensing complex subunits, C-term domain', NULL, 'Cnd3', NULL, NULL, 22116, 9),
(268231, NULL, 'PF16349', NULL, NULL, 'Domain of unknown function (DUF4978)', NULL, 'DUF4978', NULL, NULL, 22072, 9),
(268232, NULL, 'PF07890', NULL, NULL, 'Rrp15p', NULL, 'Rrp15p', NULL, NULL, 14241, 9),
(268233, NULL, 'PF15437', NULL, NULL, 'Plasminogen-binding protein pgbA C-terminal', NULL, 'PGBA_C', NULL, NULL, 26174, 9),
(268234, NULL, 'PF10042', NULL, NULL, 'Uncharacterized conserved protein (DUF2278)', NULL, 'DUF2278', NULL, NULL, 19717, 9),
(268235, NULL, 'PF00113', NULL, NULL, 'Enolase, C-terminal TIM barrel domain', NULL, 'Enolase_C', NULL, NULL, 14717, 9),
(268236, NULL, 'PF17180', NULL, NULL, 'Zinc-binding domain', NULL, 'zf-3CxxC_2', NULL, NULL, 29426, 9),
(268237, NULL, 'PF20047', NULL, NULL, 'Domain of unknown function (DUF6449)', NULL, 'DUF6449', NULL, NULL, 34422, 9),
(268238, NULL, 'PF08385', NULL, NULL, 'Dynein heavy chain, N-terminal region 1', NULL, 'DHC_N1', NULL, NULL, 11961, 9),
(268239, NULL, 'PF08489', NULL, NULL, 'Domain of unknown function (DUF1743)', NULL, 'DUF1743', NULL, NULL, 13839, 9),
(268240, NULL, 'PF08360', NULL, NULL, 'QacR-like protein, C-terminal region', NULL, 'TetR_C_5', NULL, NULL, 12854, 9),
(268241, NULL, 'PF06243', NULL, NULL, 'Phenylacetic acid degradation B', NULL, 'PaaB', NULL, NULL, 14483, 9),
(268242, NULL, 'PF02872', NULL, NULL, '5''-nucleotidase, C-terminal domain', NULL, '5_nucleotid_C', NULL, NULL, 12395, 9),
(268243, NULL, 'PF11815', NULL, NULL, 'Domain of unknown function (DUF3336)', NULL, 'DUF3336', NULL, NULL, 19231, 9),
(268244, NULL, 'PF02981', NULL, NULL, 'FokI, recognition domain, subdomain 1', NULL, 'FokI_D1', NULL, NULL, 3814, 9),
(268245, NULL, 'PF11390', NULL, NULL, 'NADH-dependant formate dehydrogenase delta subunit FdsD', NULL, 'FdsD', NULL, NULL, 15309, 9),
(268246, NULL, 'PF18602', NULL, NULL, 'Rap1a immunity proteins', NULL, 'Rap1a', NULL, NULL, 30428, 9),
(268247, NULL, 'PF04511', NULL, NULL, 'Der1-like family', NULL, 'DER1', NULL, NULL, 2564, 9),
(268248, NULL, 'PF01145', NULL, NULL, 'SPFH domain / Band 7 family', NULL, 'Band_7', NULL, NULL, 1360, 9),
(268249, NULL, 'PF01745', NULL, NULL, 'Isopentenyl transferase', NULL, 'IPT', NULL, NULL, NULL, 9),
(268250, NULL, 'PF04088', NULL, NULL, 'Peroxin 13, N-terminal region', NULL, 'Peroxin-13_N', NULL, NULL, 6459, 9),
(268251, NULL, 'PF14562', NULL, NULL, 'Restriction endonuclease BglI', NULL, 'Endonuc_BglI', NULL, NULL, 13595, 9),
(268252, NULL, 'PF17884', NULL, NULL, 'Domain of unknown function (DUF5591)', NULL, 'DUF5591', NULL, NULL, 28375, 9),
(268253, NULL, 'PF19597', NULL, NULL, 'Family of unknown function (DUF6102)', NULL, 'DUF6102', NULL, NULL, 36960, 9),
(268254, NULL, 'PF13977', NULL, NULL, 'BetI-type transcriptional repressor, C-terminal', NULL, 'TetR_C_6', NULL, NULL, 33124, 9),
(268255, NULL, 'PF19689', NULL, NULL, 'Family of unknown function (DUF6190)', NULL, 'DUF6190', NULL, NULL, 34402, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(268256, NULL, 'PF12375', NULL, NULL, 'Phage protein', NULL, 'DUF3653', NULL, NULL, 15099, 9),
(268257, NULL, 'PF12299', NULL, NULL, 'Protein of unknown function (DUF3627)', NULL, 'DUF3627', NULL, NULL, 16075, 9),
(268258, NULL, 'PF02578', NULL, NULL, 'Multi-copper polyphenol oxidoreductase laccase', NULL, 'Cu-oxidase_4', NULL, NULL, 2018, 9),
(268259, NULL, 'PF18041', NULL, NULL, 'MapZ extracellular domain 1', NULL, 'MapZ_EC1', NULL, NULL, 29212, 9),
(268260, NULL, 'PF18810', NULL, NULL, 'phage-Barnase-EndoU-ColicinE5/D-RelE like nuclease2', NULL, 'PBECR2', NULL, NULL, 28685, 9),
(268261, NULL, 'PF19707', NULL, NULL, 'Family of unknown function (DUF6204)', NULL, 'DUF6204', NULL, NULL, 37353, 9),
(268262, NULL, 'PF19086', NULL, NULL, 'Terpene synthase family 2, C-terminal metal binding', NULL, 'Terpene_syn_C_2', NULL, NULL, NULL, 9),
(268263, NULL, 'PF02553', NULL, NULL, 'Cobalt transport protein component CbiN', NULL, 'CbiN', NULL, NULL, 6373, 9),
(268264, NULL, 'PF04443', NULL, NULL, 'Acyl-protein synthetase, LuxE', NULL, 'LuxE', NULL, NULL, 10639, 9),
(268265, NULL, 'PF06978', NULL, NULL, 'Ribonucleases P/MRP protein subunit POP1', NULL, 'POP1', NULL, NULL, 12378, 9),
(268266, NULL, 'PF09482', NULL, NULL, 'Bacterial type III secretion apparatus protein (OrgA_MxiK)', NULL, 'OrgA_MxiK', NULL, NULL, 11457, 9),
(268267, NULL, 'PF16183', NULL, NULL, 'Kinesin-associated', NULL, 'Kinesin_assoc', NULL, NULL, 25357, 9),
(268268, NULL, 'PF17070', NULL, NULL, '30S ribosomal protein Thx', NULL, 'Thx', NULL, NULL, 23985, 9),
(268269, NULL, 'PF12953', NULL, NULL, 'Domain of unknown function (DUF3842)', NULL, 'DUF3842', NULL, NULL, 11290, 9),
(268270, NULL, 'PF08814', NULL, NULL, 'XisH protein', NULL, 'XisH', NULL, NULL, 13385, 9),
(268271, NULL, 'PF11730', NULL, NULL, 'Protein of unknown function (DUF3297)', NULL, 'DUF3297', NULL, NULL, 19498, 9),
(268272, NULL, 'PF03285', NULL, NULL, 'Paralemmin', NULL, 'Paralemmin', NULL, NULL, 2580, 9),
(268273, NULL, 'PF07984', NULL, NULL, 'Nucleotidyltransferase', NULL, 'NTP_transf_7', NULL, NULL, 8460, 9),
(268274, NULL, 'PF16295', NULL, NULL, 'Tetracyclin repressor-like, C-terminal domain', NULL, 'TetR_C_10', NULL, NULL, 21613, 9),
(268275, NULL, 'PF15234', NULL, NULL, 'Linker for activation of T-cells', NULL, 'LAT', NULL, NULL, 7734, 9),
(268276, NULL, 'PF02799', NULL, NULL, 'Myristoyl-CoA:protein N-myristoyltransferase, C-terminal domain', NULL, 'NMT_C', NULL, NULL, 16644, 9),
(268277, NULL, 'PF01270', NULL, NULL, 'Glycosyl hydrolases family 8', NULL, 'Glyco_hydro_8', NULL, NULL, 5130, 9),
(268278, NULL, 'PF20132', NULL, NULL, 'Family of unknown function (DUF6522)', NULL, 'DUF6522', NULL, NULL, 35581, 9),
(268279, NULL, 'PF11368', NULL, NULL, 'Protein of unknown function (DUF3169)', NULL, 'DUF3169', NULL, NULL, 18992, 9),
(268280, NULL, 'PF16577', NULL, NULL, 'UBA domain', NULL, 'UBA_5', NULL, NULL, 30887, 9),
(268281, NULL, 'PF01071', NULL, NULL, 'Phosphoribosylglycinamide synthetase, ATP-grasp (A) domain', NULL, 'GARS_A', NULL, NULL, 14559, 9),
(268282, NULL, 'PF13756', NULL, NULL, 'Stimulus-sensing domain', NULL, 'Stimulus_sens_1', NULL, NULL, 23498, 9),
(268283, NULL, 'PF10638', NULL, NULL, 'Spindle body associated protein C-terminus', NULL, 'Sfi1_C', NULL, NULL, 20654, 9),
(268284, NULL, 'PF09371', NULL, NULL, 'Tex-like protein N-terminal domain', NULL, 'Tex_N', NULL, NULL, 14965, 9),
(268285, NULL, 'PF02654', NULL, NULL, 'Cobalamin-5-phosphate synthase', NULL, 'CobS', NULL, NULL, 3183, 9),
(268286, NULL, 'PF17549', NULL, NULL, 'Gene Product 17', NULL, 'Phage_Gp17', NULL, NULL, 32776, 9),
(268287, NULL, 'PF01111', NULL, NULL, 'Cyclin-dependent kinase regulatory subunit', NULL, 'CKS', NULL, NULL, 4563, 9),
(268288, NULL, 'PF14026', NULL, NULL, 'Protein of unknown function (DUF4242)', NULL, 'DUF4242', NULL, NULL, 22420, 9),
(268289, NULL, 'PF04546', NULL, NULL, 'Sigma-70, non-essential region', NULL, 'Sigma70_ner', NULL, NULL, 2371, 9),
(268290, NULL, 'PF12922', NULL, NULL, 'non-SMC mitotic condensation complex subunit 1, N-term', NULL, 'Cnd1_N', NULL, NULL, 24748, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(268291, NULL, 'PF15461', NULL, NULL, 'Beta-carotene 15,15''-dioxygenase', NULL, 'BCD', NULL, NULL, 15171, 9),
(268292, NULL, 'PF04895', NULL, NULL, 'Archaeal Nre, C-terminal', NULL, 'Nre_C', NULL, NULL, 5705, 9),
(268293, NULL, 'PF13359', NULL, NULL, 'DDE superfamily endonuclease', NULL, 'DDE_Tnp_4', NULL, NULL, 23591, 9),
(268294, NULL, 'PF12372', NULL, NULL, 'Huntingtin protein region', NULL, 'DUF3652', NULL, NULL, 26929, 9),
(268295, NULL, 'PF00270', NULL, NULL, 'DEAD/DEAH box helicase', NULL, 'DEAD', NULL, NULL, 11434, 9),
(268296, NULL, 'PF10551', NULL, NULL, 'MULE transposase domain', NULL, 'MULE', NULL, NULL, 19393, 9),
(268297, NULL, 'PF14264', NULL, NULL, 'Glucosyl transferase GtrII', NULL, 'Glucos_trans_II', NULL, NULL, 24761, 9),
(268298, NULL, 'PF16038', NULL, NULL, 'TMIE protein', NULL, 'TMIE', NULL, NULL, 25837, 9),
(268299, NULL, 'PF10811', NULL, NULL, 'Protein of unknown function (DUF2532)', NULL, 'DUF2532', NULL, NULL, 23817, 9),
(268300, NULL, 'PF11572', NULL, NULL, 'Protein of unknown function (DUF3234)', NULL, 'DUF3234', NULL, NULL, 18529, 9),
(268301, NULL, 'PF03168', NULL, NULL, 'Late embryogenesis abundant protein', NULL, 'LEA_2', NULL, NULL, 7285, 9),
(268302, NULL, 'PF16708', NULL, NULL, 'Lipoprotein confined to pathogenic Mycobacterium', NULL, 'LppA', NULL, NULL, 24363, 9),
(268303, NULL, 'PF00292', NULL, NULL, '''Paired box'' domain', NULL, 'PAX', NULL, NULL, 5743, 9),
(268304, NULL, 'PF17654', NULL, NULL, 'Selenocysteine tRNA 1 associated proteins', NULL, 'Trnau1ap', NULL, NULL, 28534, 9),
(268305, NULL, 'PF08137', NULL, NULL, 'DVL family', NULL, 'DVL', NULL, NULL, 8756, 9),
(268306, NULL, 'PF04308', NULL, NULL, 'Ribonuclease H-like', NULL, 'RNaseH_like', NULL, NULL, 3837, 9),
(268307, NULL, 'PF16425', NULL, NULL, 'Domain of unknown function (DUF5022)', NULL, 'DUF5022', NULL, NULL, 24104, 9),
(268308, NULL, 'PF04745', NULL, NULL, 'VITF-3 subunit protein', NULL, 'Pox_A8', NULL, NULL, 3513, 9),
(268309, NULL, 'PF03807', NULL, NULL, 'NADP oxidoreductase coenzyme F420-dependent', NULL, 'F420_oxidored', NULL, NULL, 23999, 9),
(268310, NULL, 'PF10905', NULL, NULL, 'Protein of unknown function (DUF2695)', NULL, 'DUF2695', NULL, NULL, 20420, 9),
(268311, NULL, 'PF00427', NULL, NULL, 'Phycobilisome Linker polypeptide', NULL, 'PBS_linker_poly', NULL, NULL, 5342, 9),
(268312, NULL, 'PF09554', NULL, NULL, 'HaeII restriction endonuclease', NULL, 'RE_HaeII', NULL, NULL, 16754, 9),
(268313, NULL, 'PF14666', NULL, NULL, 'Rapamycin-insensitive companion of mTOR, middle domain', NULL, 'RICTOR_M', NULL, NULL, 23667, 9),
(268314, NULL, 'PF14380', NULL, NULL, 'Wall-associated receptor kinase C-terminal', NULL, 'WAK_assoc', NULL, NULL, 23939, 9),
(268315, NULL, 'PF14305', NULL, NULL, 'TupA-like ATPgrasp', NULL, 'ATPgrasp_TupA', NULL, NULL, 26509, 9),
(268316, NULL, 'PF05659', NULL, NULL, 'Arabidopsis broad-spectrum mildew resistance protein RPW8', NULL, 'RPW8', NULL, NULL, 13548, 9),
(268317, NULL, 'PF12681', NULL, NULL, 'Glyoxalase-like domain', NULL, 'Glyoxalase_2', NULL, NULL, 25790, 9),
(268318, NULL, 'PF11605', NULL, NULL, 'Vacuolar protein sorting protein 36 Vps36', NULL, 'Vps36_ESCRT-II', NULL, NULL, 18713, 9),
(268319, NULL, 'PF13935', NULL, NULL, 'Ead/Ea22-like protein', NULL, 'Ead_Ea22', NULL, NULL, 26097, 9),
(268320, NULL, 'PF00140', NULL, NULL, 'Sigma-70 factor, region 1.2', NULL, 'Sigma70_r1_2', NULL, NULL, 12306, 9),
(268321, NULL, 'PF18307', NULL, NULL, 'Transcription factor Tfb2 (p52) C-terminal domain', NULL, 'Tfb2_C', NULL, NULL, 27775, 9),
(268322, NULL, 'PF17254', NULL, NULL, 'Family of unknown function (DUF5321)', NULL, 'DUF5321', NULL, NULL, 18319, 9),
(268323, NULL, 'PF08186', NULL, NULL, 'Wound-inducible basic protein family', NULL, 'Wound_ind', NULL, NULL, 10380, 9),
(268324, NULL, 'PF00570', NULL, NULL, 'HRDC domain', NULL, 'HRDC', NULL, NULL, 1441, 9),
(268325, NULL, 'PF03232', NULL, NULL, 'Ubiquinone biosynthesis protein COQ7', NULL, 'COQ7', NULL, NULL, NULL, 9),
(268326, NULL, 'PF13502', NULL, NULL, 'AsmA-like C-terminal region', NULL, 'AsmA_2', NULL, NULL, 26831, 9);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(268327, NULL, 'PF13524', NULL, NULL, 'Glycosyl transferases group 1', NULL, 'Glyco_trans_1_2', NULL, NULL, NULL, 9),
(268328, NULL, 'PF17615', NULL, NULL, 'Family of unknown function', NULL, 'C166', NULL, NULL, NULL, 9),
(268329, NULL, 'PF04761', NULL, NULL, 'Lactococcus bacteriophage putative transcription regulator', NULL, 'Phage_Treg', NULL, NULL, 3652, 9),
(268330, NULL, 'PF12934', NULL, NULL, 'FTO C-terminal domain', NULL, 'FTO_CTD', NULL, NULL, 22536, 9),
(268331, NULL, 'PF14757', NULL, NULL, 'Immunogenic region of nsp2 protein of arterivirus polyprotein', NULL, 'NSP2-B_epitope', NULL, NULL, 23006, 9),
(268332, NULL, 'PF01120', NULL, NULL, 'Alpha-L-fucosidase', NULL, 'Alpha_L_fucos', NULL, NULL, 3200, 9),
(268333, NULL, 'PF19550', NULL, NULL, 'Family of unknown function (DUF6073)', NULL, 'DUF6073', NULL, NULL, 34950, 9),
(268334, NULL, 'PF16717', NULL, NULL, 'Ribosome-associated complex head domain', NULL, 'RAC_head', NULL, NULL, 23233, 9),
(268335, NULL, 'PF00964', NULL, NULL, 'Elicitin', NULL, 'Elicitin', NULL, NULL, 206, 9),
(268336, NULL, 'PF08956', NULL, NULL, 'Domain of unknown function (DUF1869)', NULL, 'DUF1869', NULL, NULL, 8826, 9),
(268337, NULL, 'PF08887', NULL, NULL, 'GAD-like domain', NULL, 'GAD-like', NULL, NULL, 14096, 9),
(268338, NULL, 'PF14991', NULL, NULL, 'Protein melan-A', NULL, 'MLANA', NULL, NULL, 21653, 9),
(268339, NULL, 'PF08055', NULL, NULL, 'Tryptophan leader peptide', NULL, 'Trp_leader1', NULL, NULL, 10067, 9),
(268340, NULL, 'PF14736', NULL, NULL, 'Protein N-terminal asparagine amidohydrolase', NULL, 'N_Asn_amidohyd', NULL, NULL, 24262, 9),
(268341, NULL, 'PF18043', NULL, NULL, 'T4 RNA ligase 2 C-terminal', NULL, 'T4_Rnl2_C', NULL, NULL, 31977, 9),
(268342, NULL, 'PF04553', NULL, NULL, 'Tis11B like protein, N terminus', NULL, 'Tis11B_N', NULL, NULL, 2278, 9),
(268343, NULL, 'PF12943', NULL, NULL, 'Protein of unknown function (DUF3839)', NULL, 'DUF3839', NULL, NULL, 22723, 9),
(268344, NULL, 'PF16738', NULL, NULL, 'Starch-binding module 26', NULL, 'CBM26', NULL, NULL, 22519, 9),
(268345, NULL, 'PF03037', NULL, NULL, 'Kinetoplastid membrane protein 11', NULL, 'KMP11', NULL, NULL, 2877, 9),
(268346, NULL, 'PF00007', NULL, NULL, 'Cystine-knot domain', NULL, 'Cys_knot', NULL, NULL, 11387, 9),
(268347, NULL, 'PF01865', NULL, NULL, 'Protein of unknown function DUF47', NULL, 'PhoU_div', NULL, NULL, 21104, 9),
(268348, NULL, 'PF04081', NULL, NULL, 'DNA polymerase delta, subunit 4', NULL, 'DNA_pol_delta_4', NULL, NULL, 6274, 9),
(268349, NULL, 'PF15458', NULL, NULL, 'Nineteen complex-related protein 2', NULL, 'NTR2', NULL, NULL, NULL, 9),
(268350, NULL, 'PF01883', NULL, NULL, 'Iron-sulfur cluster assembly protein', NULL, 'FeS_assembly_P', NULL, NULL, 3635, 9),
(268351, NULL, 'PF11435', NULL, NULL, 'RNA binding protein She2p', NULL, 'She2p', NULL, NULL, 12195, 9),
(268352, NULL, 'PF07198', NULL, NULL, 'Protein of unknown function (DUF1410)', NULL, 'DUF1410', NULL, NULL, 13662, 9),
(268353, NULL, 'PF12337', NULL, NULL, 'Protein of unknown function (DUF3637)', NULL, 'DUF3637', NULL, NULL, 20853, 9),
(268354, NULL, 'PF02381', NULL, NULL, 'MraZ protein, putative antitoxin-like', NULL, 'MraZ', NULL, NULL, 20581, 9),
(268355, NULL, 'PF17033', NULL, NULL, 'Carboxypeptidase controlling helical cell shape catalytic', NULL, 'Peptidase_M99', NULL, NULL, 22748, 9),
(268356, NULL, 'PF13613', NULL, NULL, 'Helix-turn-helix of DDE superfamily endonuclease', NULL, 'HTH_Tnp_4', NULL, NULL, 23536, 9),
(268357, NULL, 'PF14965', NULL, NULL, 'Negative regulator of p53/TP53', NULL, 'BRI3BP', NULL, NULL, NULL, 9),
(268358, NULL, 'PF15696', NULL, NULL, 'RAD51 interacting motif', NULL, 'RAD51_interact', NULL, NULL, 25996, 9),
(268359, NULL, 'PF00553', NULL, NULL, 'Cellulose binding domain', NULL, 'CBM_2', NULL, NULL, 4103, 9),
(268360, NULL, 'PF13143', NULL, NULL, 'Protein of unknown function (DUF3986)', NULL, 'DUF3986', NULL, NULL, 22418, 9),
(268361, NULL, 'PF19072', NULL, NULL, 'Family of unknown function (DUF5768)', NULL, 'DUF5768', NULL, NULL, 35237, 9),
(268362, NULL, 'PF15770', NULL, NULL, 'Domain of unknown function (DUF4699)', NULL, 'DUF4699', NULL, NULL, 25324, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(268363, NULL, 'PF18608', NULL, NULL, 'XIAP-associated factor 1 C-terminal domain', NULL, 'XAF1_C', NULL, NULL, 29712, 9),
(268364, NULL, 'PF05658', NULL, NULL, 'YadA head domain repeat (2 copies)', NULL, 'YadA_head', NULL, NULL, 14151, 9),
(268365, NULL, 'PF06502', NULL, NULL, 'Equine infectious anaemia virus S2 protein', NULL, 'Equine_IAV_S2', NULL, NULL, 9204, 9),
(268366, NULL, 'PF08263', NULL, NULL, 'Leucine rich repeat N-terminal domain', NULL, 'LRRNT_2', NULL, NULL, 17453, 9),
(268367, NULL, 'PF12281', NULL, NULL, 'Nucleotidyltransferase', NULL, 'NTP_transf_8', NULL, NULL, 16447, 9),
(268368, NULL, 'PF14955', NULL, NULL, 'Mitochondrial ribosome subunit S24', NULL, 'MRP-S24', NULL, NULL, 22743, 9),
(268369, NULL, 'PF16777', NULL, NULL, 'Transcriptional regulator, RHH-like, CopG', NULL, 'RHH_7', NULL, NULL, 23923, 9),
(268370, NULL, 'PF11921', NULL, NULL, 'Domain of unknown function (DUF3439)', NULL, 'DUF3439', NULL, NULL, 26784, 9),
(268371, NULL, 'PF17508', NULL, NULL, 'Microcin V bacteriocin', NULL, 'MccV', NULL, NULL, 19277, 9),
(268372, NULL, 'PF06473', NULL, NULL, 'FGF binding protein 1 (FGF-BP1)', NULL, 'FGF-BP1', NULL, NULL, 10390, 9),
(268373, NULL, 'PF16551', NULL, NULL, 'Putative nuclear localisation signal of quaking', NULL, 'Quaking_NLS', NULL, NULL, 26856, 9),
(268374, NULL, 'PF02782', NULL, NULL, 'FGGY family of carbohydrate kinases, C-terminal domain', NULL, 'FGGY_C', NULL, NULL, 21133, 9),
(268375, NULL, 'PF14273', NULL, NULL, 'Domain of unknown function (DUF4360)', NULL, 'DUF4360', NULL, NULL, 24637, 9),
(268376, NULL, 'PF08522', NULL, NULL, 'Domain of unknown function (DUF1735)', NULL, 'DUF1735', NULL, NULL, 7899, 9),
(268377, NULL, 'PF05011', NULL, NULL, 'Lariat debranching enzyme, C-terminal domain', NULL, 'DBR1', NULL, NULL, 1036, 9),
(268378, NULL, 'PF12186', NULL, NULL, 'Acyl-CoA dehydrogenase C terminal', NULL, 'AcylCoA_dehyd_C', NULL, NULL, 14999, 9),
(268379, NULL, 'PF17648', NULL, NULL, 'Family of unknown function (DUF5519)', NULL, 'DUF5519', NULL, NULL, 32218, 9),
(268380, NULL, 'PF07575', NULL, NULL, 'Nup85 Nucleoporin', NULL, 'Nucleopor_Nup85', NULL, NULL, 12651, 9),
(268381, NULL, 'PF04726', NULL, NULL, 'Microvirus J protein', NULL, 'Microvir_J', NULL, NULL, 3811, 9),
(268382, NULL, 'PF04882', NULL, NULL, 'Peroxin-3', NULL, 'Peroxin-3', NULL, NULL, 5522, 9),
(268383, NULL, 'PF09026', NULL, NULL, 'Centromere protein B dimerisation domain', NULL, 'CENP-B_dimeris', NULL, NULL, 9919, 9),
(268384, NULL, 'PF09985', NULL, NULL, 'C-terminal binding-module, SLH-like, of glucodextranase', NULL, 'Glucodextran_C', NULL, NULL, 19829, 9),
(268385, NULL, 'PF17140', NULL, NULL, 'Domain of unknown function (DUF5113)', NULL, 'DUF5113', NULL, NULL, 32574, 9),
(268386, NULL, 'PF03409', NULL, NULL, 'Transmembrane glycoprotein', NULL, 'Glycoprotein', NULL, NULL, 10374, 9),
(268387, NULL, 'PF19109', NULL, NULL, 'Family of unknown function (DUF5796)', NULL, 'DUF5796', NULL, NULL, 35965, 9),
(268388, NULL, 'PF16978', NULL, NULL, 'SAPK-interacting protein 1 (Sin1), middle CRIM domain', NULL, 'CRIM', NULL, NULL, 24009, 9),
(268389, NULL, 'PF05241', NULL, NULL, 'EXPERA (EXPanded EBP superfamily)', NULL, 'EBP', NULL, NULL, NULL, 9),
(268390, NULL, 'PF09021', NULL, NULL, 'HutP', NULL, 'HutP', NULL, NULL, 9858, 9),
(268391, NULL, 'PF04347', NULL, NULL, 'Flagellar biosynthesis protein, FliO', NULL, 'FliO', NULL, NULL, 14938, 9),
(268392, NULL, 'PF00136', NULL, NULL, 'DNA polymerase family B', NULL, 'DNA_pol_B', NULL, NULL, 10254, 9),
(268393, NULL, 'PF04846', NULL, NULL, 'Herpesvirus pp38 phosphoprotein', NULL, 'Herpes_pp38', NULL, NULL, 5193, 9),
(268394, NULL, 'PF14063', NULL, NULL, 'Protein of unknown function (DUF4254)', NULL, 'DUF4254', NULL, NULL, 22744, 9),
(268395, NULL, 'PF04092', NULL, NULL, 'SRS domain', NULL, 'SAG', NULL, NULL, 6640, 9),
(268396, NULL, 'PF18006', NULL, NULL, 'O-phosphoseryl-tRNA synthetase C-terminal domain', NULL, 'SepRS_C', NULL, NULL, 29637, 9),
(268397, NULL, 'PF09476', NULL, NULL, 'Pilus biogenesis CpaD protein (pilus_cpaD)', NULL, 'Pilus_CpaD', NULL, NULL, 15584, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(268398, NULL, 'PF14146', NULL, NULL, 'Domain of unknown function (DUF4305)', NULL, 'DUF4305', NULL, NULL, 26204, 9),
(268399, NULL, 'PF06216', NULL, NULL, 'Rice tungro bacilliform virus P46 protein', NULL, 'RTBV_P46', NULL, NULL, 14023, 9),
(268400, NULL, 'PF09239', NULL, NULL, 'Topoisomerase VI B subunit, transducer', NULL, 'Topo-VIb_trans', NULL, NULL, 13079, 9),
(268401, NULL, 'PF15928', NULL, NULL, 'Domain of unknown function (DUF4746)', NULL, 'DUF4746', NULL, NULL, 25967, 9),
(268402, NULL, 'PF14704', NULL, NULL, 'Dermatopontin', NULL, 'DERM', NULL, NULL, 23640, 9),
(268403, NULL, 'PF15070', NULL, NULL, 'Putative golgin subfamily A member 2-like protein 5', NULL, 'GOLGA2L5', NULL, NULL, 35979, 9),
(268404, NULL, 'PF16767', NULL, NULL, 'Sensor domain of alginate biosynthesis sensor protein KinB', NULL, 'KinB_sensor', NULL, NULL, 22007, 9),
(268405, NULL, 'PF17319', NULL, NULL, 'Family of unknown function (DUF5362)', NULL, 'DUF5362', NULL, NULL, 31986, 9),
(268406, NULL, 'PF14948', NULL, NULL, 'RESP18 domain', NULL, 'RESP18', NULL, NULL, 23104, 9),
(268407, NULL, 'PF00127', NULL, NULL, 'Copper binding proteins, plastocyanin/azurin family', NULL, 'Copper-bind', NULL, NULL, 3259, 9),
(268408, NULL, 'PF02192', NULL, NULL, 'PI3-kinase family, p85-binding domain', NULL, 'PI3K_p85B', NULL, NULL, 1552, 9),
(268409, NULL, 'PF08191', NULL, NULL, 'LRR adjacent', NULL, 'LRR_adjacent', NULL, NULL, 9316, 9),
(268410, NULL, 'PF14430', NULL, NULL, 'Immunity protein Imm1', NULL, 'Imm1', NULL, NULL, 24859, 9),
(268411, NULL, 'PF15704', NULL, NULL, 'Mitochondrial ATP synthase subunit', NULL, 'Mt_ATP_synt', NULL, NULL, 24423, 9),
(268412, NULL, 'PF00867', NULL, NULL, 'XPG I-region', NULL, 'XPG_I', NULL, NULL, 2612, 9),
(268413, NULL, 'PF03250', NULL, NULL, 'Tropomodulin', NULL, 'Tropomodulin', NULL, NULL, 1514, 9),
(268414, NULL, 'PF09400', NULL, NULL, 'Protein of unknown function (DUF2002)', NULL, 'DUF2002', NULL, NULL, 15747, 9),
(268415, NULL, 'PF00784', NULL, NULL, 'MyTH4 domain', NULL, 'MyTH4', NULL, NULL, 4768, 9),
(268416, NULL, 'PF09641', NULL, NULL, 'Protein of unknown function (DUF2026)', NULL, 'DUF2026', NULL, NULL, 15672, 9),
(268417, NULL, 'PF11178', NULL, NULL, 'Protein of unknown function (DUF2963)', NULL, 'DUF2963', NULL, NULL, 18218, 9),
(268418, NULL, 'PF12425', NULL, NULL, 'Protein of unknown function (DUF3673)', NULL, 'DUF3673', NULL, NULL, 20625, 9),
(268419, NULL, 'PF08328', NULL, NULL, 'Adenylosuccinate lyase C-terminal', NULL, 'ASL_C', NULL, NULL, 12859, 9),
(268420, NULL, 'PF09266', NULL, NULL, 'Viral DNA topoisomerase I, N-terminal', NULL, 'VirDNA-topo-I_N', NULL, NULL, 13417, 9),
(268421, NULL, 'PF11547', NULL, NULL, 'E3 ubiquitin ligase EDD', NULL, 'E3_UbLigase_EDD', NULL, NULL, 1307, 9),
(268422, NULL, 'PF08788', NULL, NULL, 'NHR2 domain like', NULL, 'NHR2', NULL, NULL, 13152, 9),
(268423, NULL, 'PF19483', NULL, NULL, 'Family of unknown function (DUF6019)', NULL, 'DUF6019', NULL, NULL, 36750, 9),
(268424, NULL, 'PF10457', NULL, NULL, 'Cholesterol-capturing domain', NULL, 'MENTAL', NULL, NULL, 18107, 9),
(268425, NULL, 'PF05818', NULL, NULL, 'Enterobacterial TraT complement resistance protein', NULL, 'TraT', NULL, NULL, 7747, 9),
(268426, NULL, 'PF05843', NULL, NULL, 'Suppressor of forked protein (Suf)', NULL, 'Suf', NULL, NULL, 13678, 9),
(268427, NULL, 'PF17669', NULL, NULL, 'Family of unknown function (DUF5529)', NULL, 'DUF5529', NULL, NULL, 27314, 9),
(268428, NULL, 'PF00627', NULL, NULL, 'UBA/TS-N domain', NULL, 'UBA', NULL, NULL, 8210, 9),
(268429, NULL, 'PF19973', NULL, NULL, 'Ternary complex associated domain 7', NULL, 'TCAD7', NULL, NULL, 35591, 9),
(268430, NULL, 'PF03868', NULL, NULL, 'Ribosomal protein L6, N-terminal domain', NULL, 'Ribosomal_L6e_N', NULL, NULL, 1740, 9),
(268431, NULL, 'PF18052', NULL, NULL, 'Rx N-terminal domain', NULL, 'Rx_N', NULL, NULL, 28564, 9),
(268432, NULL, 'PF04256', NULL, NULL, 'Protein of unknown function (DUF434)', NULL, 'DUF434', NULL, NULL, 5679, 9),
(268433, NULL, 'PF19282', NULL, NULL, 'Exportin-T', NULL, 'Exportin-T', NULL, NULL, 36186, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(268434, NULL, 'PF12312', NULL, NULL, 'Nepovirus subgroup A polyprotein', NULL, 'NeA_P2', NULL, NULL, 16753, 9),
(268435, NULL, 'PF05253', NULL, NULL, 'U11-48K-like CHHC zinc finger', NULL, 'zf-U11-48K', NULL, NULL, 17363, 9),
(268436, NULL, 'PF01507', NULL, NULL, 'Phosphoadenosine phosphosulfate reductase family', NULL, 'PAPS_reduct', NULL, NULL, 600, 9),
(268437, NULL, 'PF15089', NULL, NULL, 'Domain of unknown function (DUF4552)', NULL, 'DUF4552', NULL, NULL, 23752, 9),
(268438, NULL, 'PF07607', NULL, NULL, 'Protein of unknown function (DUF1570)', NULL, 'DUF1570', NULL, NULL, 13511, 9),
(268439, NULL, 'PF08058', NULL, NULL, 'Nuclear pore complex component', NULL, 'NPCC', NULL, NULL, 9455, 9),
(268440, NULL, 'PF20296', NULL, NULL, 'Methylase-associated X1', NULL, 'MTaX1', NULL, NULL, 36841, 9),
(268441, NULL, 'PF00795', NULL, NULL, 'Carbon-nitrogen hydrolase', NULL, 'CN_hydrolase', NULL, NULL, 262, 9),
(268442, NULL, 'PF12066', NULL, NULL, 'SERRATE/Ars2, N-terminal domain', NULL, 'SERRATE_Ars2_N', NULL, NULL, 19725, 9),
(268443, NULL, 'PF20556', NULL, NULL, 'Family of unknown function (DUF6768)', NULL, 'DUF6768', NULL, NULL, 37380, 9),
(268444, NULL, 'PF04500', NULL, NULL, 'FLYWCH zinc finger domain', NULL, 'FLYWCH', NULL, NULL, 2592, 9),
(268445, NULL, 'PF16894', NULL, NULL, 'Domain of unknown function (DUF5084)', NULL, 'DUF5084', NULL, NULL, 22680, 9),
(268446, NULL, 'PF00033', NULL, NULL, 'Cytochrome b/b6/petB', NULL, 'Cytochrome_B', NULL, NULL, 5653, 9),
(268447, NULL, 'PF12346', NULL, NULL, 'Holliday junction recognition protein-associated repeat', NULL, 'HJURP_mid', NULL, NULL, 15270, 9),
(268448, NULL, 'PF05749', NULL, NULL, 'Rubella membrane glycoprotein E2', NULL, 'Rubella_E2', NULL, NULL, 13848, 9),
(268449, NULL, 'PF13812', NULL, NULL, 'Pentatricopeptide repeat domain', NULL, 'PPR_3', NULL, NULL, 5826, 9),
(268450, NULL, 'PF18116', NULL, NULL, 'Sorting Nexin 17 FERM C-terminal domain', NULL, 'SNX17_FERM_C', NULL, NULL, 32468, 9),
(268451, NULL, 'PF03925', NULL, NULL, 'SeqA protein C-terminal domain', NULL, 'SeqA', NULL, NULL, 25044, 9),
(268452, NULL, 'PF11746', NULL, NULL, 'Domain of unknown function (DUF3303)', NULL, 'DUF3303', NULL, NULL, 19497, 9),
(268453, NULL, 'PF09406', NULL, NULL, 'Protein of unknown function (DUF2004)', NULL, 'DUF2004', NULL, NULL, 15222, 9),
(268454, NULL, 'PF09774', NULL, NULL, 'Intermembrane space protein MIX23', NULL, 'MIX23', NULL, NULL, 18230, 9),
(268455, NULL, 'PF16697', NULL, NULL, 'Inner membrane component of T3SS, cytoplasmic domain', NULL, 'Yop-YscD_cpl', NULL, NULL, 23407, 9),
(268456, NULL, 'PF09569', NULL, NULL, 'ScaI restriction endonuclease', NULL, 'RE_ScaI', NULL, NULL, 16752, 9),
(268457, NULL, 'PF07259', NULL, NULL, 'ProSAAS precursor', NULL, 'ProSAAS', NULL, NULL, 11229, 9),
(268458, NULL, 'PF12784', NULL, NULL, 'PD-(D/E)XK nuclease family transposase', NULL, 'PDDEXK_2', NULL, NULL, NULL, 9),
(268459, NULL, 'PF01827', NULL, NULL, 'FTH domain', NULL, 'FTH', NULL, NULL, 6226, 9),
(268460, NULL, 'PF03898', NULL, NULL, 'Satellite tobacco necrosis virus coat protein', NULL, 'TNV_CP', NULL, NULL, 9120, 9),
(268461, NULL, 'PF05861', NULL, NULL, 'Bacterial phosphonate metabolism protein (PhnI)', NULL, 'PhnI', NULL, NULL, 12255, 9),
(268462, NULL, 'PF10957', NULL, NULL, 'Sporulation protein Cse60', NULL, 'Spore_Cse60', NULL, NULL, 20794, 9),
(268463, NULL, 'PF01312', NULL, NULL, 'FlhB HrpN YscU SpaS Family', NULL, 'Bac_export_2', NULL, NULL, 10034, 9),
(268464, NULL, 'PF01536', NULL, NULL, 'Adenosylmethionine decarboxylase', NULL, 'SAM_decarbox', NULL, NULL, 4703, 9),
(268465, NULL, 'PF02492', NULL, NULL, 'CobW/HypB/UreG, nucleotide-binding domain', NULL, 'cobW', NULL, NULL, 6253, 9),
(268466, NULL, 'PF05958', NULL, NULL, 'tRNA (Uracil-5-)-methyltransferase', NULL, 'tRNA_U5-meth_tr', NULL, NULL, 7630, 9),
(268467, NULL, 'PF00326', NULL, NULL, 'Prolyl oligopeptidase family', NULL, 'Peptidase_S9', NULL, NULL, 7150, 9),
(268468, NULL, 'PF18009', NULL, NULL, '4Fe-4S iron-sulfur cluster binding domain', NULL, 'Fer4_23', NULL, NULL, 29431, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(268469, NULL, 'PF20544', NULL, NULL, 'Family of unknown function (DUF6758)', NULL, 'DUF6758', NULL, NULL, 33553, 9),
(268470, NULL, 'PF07032', NULL, NULL, 'Protein of unknown function (DUF1322)', NULL, 'DUF1322', NULL, NULL, 12310, 9),
(268471, NULL, 'PF16417', NULL, NULL, 'CCR4-NOT transcription complex subunit 1 TTP binding domain', NULL, 'CNOT1_TTP_bind', NULL, NULL, 23597, 9),
(268472, NULL, 'PF20527', NULL, NULL, 'Domain of unknown function (DUF6742)', NULL, 'DUF6742', NULL, NULL, 33593, 9),
(268473, NULL, 'PF00182', NULL, NULL, 'Chitinase class I', NULL, 'Glyco_hydro_19', NULL, NULL, 7139, 9),
(268474, NULL, 'PF07239', NULL, NULL, 'Outer membrane protein OpcA', NULL, 'OpcA', NULL, NULL, 14187, 9),
(268475, NULL, 'PF14105', NULL, NULL, 'Domain of unknown function (DUF4278)', NULL, 'DUF4278', NULL, NULL, 22046, 9),
(268476, NULL, 'PF09981', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2218)', NULL, 'DUF2218', NULL, NULL, 12447, 9),
(268477, NULL, 'PF00768', NULL, NULL, 'D-alanyl-D-alanine carboxypeptidase', NULL, 'Peptidase_S11', NULL, NULL, 4364, 9),
(268478, NULL, 'PF07892', NULL, NULL, 'Protein of unknown function (DUF1667)', NULL, 'DUF1667', NULL, NULL, 14056, 9),
(268479, NULL, 'PF19326', NULL, NULL, 'AMP deaminase', NULL, 'AMP_deaminase', NULL, NULL, 4562, 9),
(268480, NULL, 'PF01851', NULL, NULL, 'Proteasome/cyclosome repeat', NULL, 'PC_rep', NULL, NULL, 4764, 9),
(268481, NULL, 'PF19268', NULL, NULL, 'Contractile injection system tape measure protein', NULL, 'CIS_TMP', NULL, NULL, 35532, 9),
(268482, NULL, 'PF06805', NULL, NULL, 'Bacteriophage lambda tail assembly protein I', NULL, 'Lambda_tail_I', NULL, NULL, 9252, 9),
(268483, NULL, 'PF16399', NULL, NULL, 'Intron-binding protein aquarius N-terminus', NULL, 'Aquarius_N', NULL, NULL, 23765, 9),
(268484, NULL, 'PF04850', NULL, NULL, 'Baculovirus E66 occlusion-derived virus envelope protein', NULL, 'Baculo_E66', NULL, NULL, 5960, 9),
(268485, NULL, 'PF07568', NULL, NULL, 'Histidine kinase', NULL, 'HisKA_2', NULL, NULL, 13000, 9),
(268486, NULL, 'PF10876', NULL, NULL, 'Phage tail assembly chaperone protein, TAC', NULL, 'Phage_TAC_9', NULL, NULL, 14852, 9),
(268487, NULL, 'PF00233', NULL, NULL, '3''5''-cyclic nucleotide phosphodiesterase', NULL, 'PDEase_I', NULL, NULL, 1100, 9),
(268488, NULL, 'PF15385', NULL, NULL, 'Specifically androgen-regulated gene protein', NULL, 'SARG', NULL, NULL, NULL, 9),
(268489, NULL, 'PF06907', NULL, NULL, 'Latexin', NULL, 'Latexin', NULL, NULL, 11678, 9),
(268490, NULL, 'PF15667', NULL, NULL, 'Protein of unknown function with motif GDWWSH', NULL, 'GDWWSH', NULL, NULL, 21782, 9),
(268491, NULL, 'PF03396', NULL, NULL, 'Poxvirus DNA-directed RNA polymerase, 35 kD subunit', NULL, 'Pox_RNA_pol_35', NULL, NULL, 2302, 9),
(268492, NULL, 'PF17339', NULL, NULL, 'PH domain', NULL, 'PH_15', NULL, NULL, 31279, 9),
(268493, NULL, 'PF10712', NULL, NULL, 'NAD-specific glutamate dehydrogenase', NULL, 'NAD-GH', NULL, NULL, 20858, 9),
(268494, NULL, 'PF13516', NULL, NULL, 'Leucine Rich repeat', NULL, 'LRR_6', NULL, NULL, 5227, 9),
(268495, NULL, 'PF17676', NULL, NULL, 'LD-carboxypeptidase C-terminal domain', NULL, 'Peptidase_S66C', NULL, NULL, 27508, 9),
(268496, NULL, 'PF04876', NULL, NULL, 'Tenuivirus major non-capsid protein', NULL, 'Tenui_NCP', NULL, NULL, 5831, 9),
(268497, NULL, 'PF05201', NULL, NULL, 'Glutamyl-tRNAGlu reductase, N-terminal domain', NULL, 'GlutR_N', NULL, NULL, 7725, 9),
(268498, NULL, 'PF00186', NULL, NULL, 'Dihydrofolate reductase', NULL, 'DHFR_1', NULL, NULL, 3084, 9),
(268499, NULL, 'PF12527', NULL, NULL, 'Protein of unknown function (DUF3727)', NULL, 'DUF3727', NULL, NULL, 21342, 9),
(268500, NULL, 'PF09118', NULL, NULL, 'Galactose oxidase-like, Early set domain', NULL, 'GO-like_E_set', NULL, NULL, 10871, 9),
(268501, NULL, 'PF16646', NULL, NULL, 'Axin-1 tankyrase binding domain', NULL, 'AXIN1_TNKS_BD', NULL, NULL, 22787, 9),
(268502, NULL, 'PF12962', NULL, NULL, 'Protein of unknown function (DUF3851)', NULL, 'DUF3851', NULL, NULL, 20618, 9),
(268503, NULL, 'PF08677', NULL, NULL, 'GP11 baseplate wedge protein', NULL, 'GP11', NULL, NULL, 11078, 9);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(268504, NULL, 'PF03990', NULL, NULL, 'G5-linked-Ubiquitin-like domain', NULL, 'DUF348', NULL, NULL, 309, 9),
(268505, NULL, 'PF13456', NULL, NULL, 'Reverse transcriptase-like', NULL, 'RVT_3', NULL, NULL, 285, 9),
(268506, NULL, 'PF13632', NULL, NULL, 'Glycosyl transferase family group 2', NULL, 'Glyco_trans_2_3', NULL, NULL, 1204, 9),
(268507, NULL, 'PF08494', NULL, NULL, 'DEAD/H associated', NULL, 'DEAD_assoc', NULL, NULL, 13685, 9),
(268508, NULL, 'PF05190', NULL, NULL, 'MutS family domain IV', NULL, 'MutS_IV', NULL, NULL, 3199, 9),
(268509, NULL, 'PF12251', NULL, NULL, 'snRNA-activating protein complex (SNAPc), subunit 3', NULL, 'SNAPC3', NULL, NULL, 20120, 9),
(268510, NULL, 'PF14346', NULL, NULL, 'Domain of unknown function (DUF4398)', NULL, 'DUF4398', NULL, NULL, 26283, 9),
(268511, NULL, 'PF06627', NULL, NULL, 'Protein of unknown function (DUF1153)', NULL, 'DUF1153', NULL, NULL, 10272, 9),
(268512, NULL, 'PF17941', NULL, NULL, 'Polyphosphate kinase C-terminal domain 1', NULL, 'PP_kinase_C_1', NULL, NULL, 28557, 9),
(268513, NULL, 'PF15868', NULL, NULL, 'Transcription activator MBF2', NULL, 'MBF2', NULL, NULL, 24133, 9),
(268514, NULL, 'PF17882', NULL, NULL, 'OAA-family lectin sugar binding domain', NULL, 'SBD', NULL, NULL, 28056, 9),
(268515, NULL, 'PF20506', NULL, NULL, 'Family of unknown function (DUF6732)', NULL, 'DUF6732', NULL, NULL, 33758, 9),
(268516, NULL, 'PF08850', NULL, NULL, 'Domain of unknown function (DUF1820)', NULL, 'DUF1820', NULL, NULL, 14398, 9),
(268517, NULL, 'PF01078', NULL, NULL, 'Magnesium chelatase, subunit ChlI', NULL, 'Mg_chelatase', NULL, NULL, 5878, 9),
(268518, NULL, 'PF18799', NULL, NULL, 'Large polyvalent protein-associated domain 5', NULL, 'LPD5', NULL, NULL, 28090, 9),
(268519, NULL, 'PF13303', NULL, NULL, 'Phosphotransferase system, EIIC', NULL, 'PTS_EIIC_2', NULL, NULL, 4404, 9),
(268520, NULL, 'PF15833', NULL, NULL, 'Domain of unknown function (DUF4714)', NULL, 'DUF4714', NULL, NULL, 25534, 9),
(268521, NULL, 'PF12790', NULL, NULL, 'Type VI secretion lipoprotein, VasD, EvfM, TssJ, VC_A0113', NULL, 'T6SS-SciN', NULL, NULL, 18316, 9),
(268522, NULL, 'PF12802', NULL, NULL, 'MarR family', NULL, 'MarR_2', NULL, NULL, 4925, 9),
(268523, NULL, 'PF07571', NULL, NULL, 'TAF6 C-terminal HEAT repeat domain', NULL, 'TAF6_C', NULL, NULL, 13902, 9),
(268524, NULL, 'PF17830', NULL, NULL, 'STI1 domain', NULL, 'STI1', NULL, NULL, 30090, 9),
(268525, NULL, 'PF09903', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2130)', NULL, 'DUF2130', NULL, NULL, 19011, 9),
(268526, NULL, 'PF17623', NULL, NULL, 'Domain of unknown function', NULL, 'B277', NULL, NULL, 17232, 9),
(268527, NULL, 'PF17636', NULL, NULL, 'Viral Unique Long protein 21a', NULL, 'UL21a', NULL, NULL, 29652, 9),
(268528, NULL, 'PF00610', NULL, NULL, 'Domain found in Dishevelled, Egl-10, and Pleckstrin (DEP)', NULL, 'DEP', NULL, NULL, 5781, 9),
(268529, NULL, 'PF07994', NULL, NULL, 'Myo-inositol-1-phosphate synthase', NULL, 'NAD_binding_5', NULL, NULL, 1907, 9),
(268530, NULL, 'PF02780', NULL, NULL, 'Transketolase, C-terminal domain', NULL, 'Transketolase_C', NULL, NULL, 29168, 9),
(268531, NULL, 'PF09980', NULL, NULL, 'Predicted membrane protein (DUF2214)', NULL, 'DUF2214', NULL, NULL, 17440, 9),
(268532, NULL, 'PF10324', NULL, NULL, 'Serpentine type 7TM GPCR chemoreceptor Srw', NULL, '7TM_GPCR_Srw', NULL, NULL, 17290, 9),
(268533, NULL, 'PF08502', NULL, NULL, 'LeuA allosteric (dimerisation) domain', NULL, 'LeuA_dimer', NULL, NULL, 13809, 9),
(268534, NULL, 'PF03072', NULL, NULL, 'Domain of unknown function (DUF237)', NULL, 'DUF237', NULL, NULL, 4629, 9),
(268535, NULL, 'PF06346', NULL, NULL, 'Formin Homology Region 1', NULL, 'Drf_FH1', NULL, NULL, NULL, 9),
(268536, NULL, 'PF03819', NULL, NULL, 'MazG nucleotide pyrophosphohydrolase domain', NULL, 'MazG', NULL, NULL, 1625, 9),
(268537, NULL, 'PF11761', NULL, NULL, 'Cobalamin biosynthesis central region', NULL, 'CbiG_mid', NULL, NULL, 19189, 9),
(268538, NULL, 'PF20123', NULL, NULL, 'Family of unknown function (DUF6513)', NULL, 'DUF6513', NULL, NULL, 35887, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(268539, NULL, 'PF11884', NULL, NULL, 'Domain of unknown function (DUF3404)', NULL, 'DUF3404', NULL, NULL, 19868, 9),
(268540, NULL, 'PF02306', NULL, NULL, 'Major spike protein (G protein)', NULL, 'Phage_G', NULL, NULL, 6252, 9),
(268541, NULL, 'PF03993', NULL, NULL, 'Domain of Unknown Function (DUF349)', NULL, 'DUF349', NULL, NULL, 491, 9),
(268542, NULL, 'PF18457', NULL, NULL, 'Up-Regulated in long-lived daf-2', NULL, 'PUD1_2', NULL, NULL, 28842, 9),
(268543, NULL, 'PF18935', NULL, NULL, 'Family of unknown function (DUF5683)', NULL, 'DUF5683', NULL, NULL, 34239, 9),
(268544, NULL, 'PF09458', NULL, NULL, 'H-type lectin domain', NULL, 'H_lectin', NULL, NULL, 15988, 9),
(268545, NULL, 'PF15175', NULL, NULL, 'Spermatogenesis-associated protein 24', NULL, 'SPATA24', NULL, NULL, 21830, 9),
(268546, NULL, 'PF10927', NULL, NULL, 'Protein of unknown function (DUF2738)', NULL, 'DUF2738', NULL, NULL, 23629, 9),
(268547, NULL, 'PF02706', NULL, NULL, 'Chain length determinant protein', NULL, 'Wzz', NULL, NULL, 3241, 9),
(268548, NULL, 'PF04055', NULL, NULL, 'Radical SAM superfamily', NULL, 'Radical_SAM', NULL, NULL, 1016, 9),
(268549, NULL, 'PF10665', NULL, NULL, 'Minor capsid protein', NULL, 'Minor_capsid_1', NULL, NULL, 20069, 9),
(268550, NULL, 'PF01716', NULL, NULL, 'Manganese-stabilising protein / photosystem II polypeptide', NULL, 'MSP', NULL, NULL, 2997, 9),
(268551, NULL, 'PF13990', NULL, NULL, 'YjcZ-like protein', NULL, 'YjcZ', NULL, NULL, 22800, 9),
(268552, NULL, 'PF11648', NULL, NULL, 'C-terminal domain of RIG-I', NULL, 'RIG-I_C-RD', NULL, NULL, 18993, 9),
(268553, NULL, 'PF14768', NULL, NULL, 'Replication protein A interacting C-terminal', NULL, 'RPA_interact_C', NULL, NULL, 23573, 9),
(268554, NULL, 'PF19536', NULL, NULL, 'POU domain, class 2, transcription factor 1 C-terminal', NULL, 'POU2F1_C', NULL, NULL, 36006, 9),
(268555, NULL, 'PF08394', NULL, NULL, 'Archaeal TRASH domain', NULL, 'Arc_trans_TRASH', NULL, NULL, 11187, 9),
(268556, NULL, 'PF04640', NULL, NULL, 'PLATZ transcription factor', NULL, 'PLATZ', NULL, NULL, 2941, 9),
(268557, NULL, 'PF11807', NULL, NULL, 'Mycotoxin biosynthesis protein UstYa', NULL, 'UstYa', NULL, NULL, 19262, 9),
(268558, NULL, 'PF15832', NULL, NULL, 'FAM27 D and E protein family', NULL, 'FAM27', NULL, NULL, 26325, 9),
(268559, NULL, 'PF16342', NULL, NULL, 'Domain of unknown function (DUF4972)', NULL, 'DUF4972', NULL, NULL, 21808, 9),
(268560, NULL, 'PF14580', NULL, NULL, 'Leucine-rich repeat', NULL, 'LRR_9', NULL, NULL, NULL, 9),
(268561, NULL, 'PF01576', NULL, NULL, 'Myosin tail', NULL, 'Myosin_tail_1', NULL, NULL, 6805, 9),
(268562, NULL, 'PF01632', NULL, NULL, 'Ribosomal protein L35', NULL, 'Ribosomal_L35p', NULL, NULL, 15422, 9),
(268563, NULL, 'PF20393', NULL, NULL, 'Putative carbonic anhydrase', NULL, 'Pro_CA_2', NULL, NULL, 34093, 9),
(268564, NULL, 'PF19673', NULL, NULL, 'Family of unknown function (DUF6176)', NULL, 'DUF6176', NULL, NULL, 37472, 9),
(268565, NULL, 'PF20034', NULL, NULL, 'Peptidase S80 family', NULL, 'Peptidase_S80', NULL, NULL, 35738, 9),
(268566, NULL, 'PF15979', NULL, NULL, 'Glycosyl hydrolase family 115', NULL, 'Glyco_hydro_115', NULL, NULL, 25899, 9),
(268567, NULL, 'PF02624', NULL, NULL, 'YcaO cyclodehydratase, ATP-ad Mg2+-binding', NULL, 'YcaO', NULL, NULL, 6262, 9),
(268568, NULL, 'PF11817', NULL, NULL, 'Foie gras liver health family 1', NULL, 'Foie-gras_1', NULL, NULL, 19105, 9),
(268569, NULL, 'PF13810', NULL, NULL, 'Domain of unknown function (DUF4185)', NULL, 'DUF4185', NULL, NULL, 22487, 9),
(268570, NULL, 'PF16067', NULL, NULL, 'Domain of unknown function (DUF4809)', NULL, 'DUF4809', NULL, NULL, 24214, 9),
(268571, NULL, 'PF05388', NULL, NULL, 'Carboxypeptidase Y pro-peptide', NULL, 'Carbpep_Y_N', NULL, NULL, 8583, 9),
(268572, NULL, 'PF03460', NULL, NULL, 'Nitrite/Sulfite reductase ferredoxin-like half domain', NULL, 'NIR_SIR_ferr', NULL, NULL, 10846, 9),
(268573, NULL, 'PF12296', NULL, NULL, 'Hydrophobic surface binding protein A', NULL, 'HsbA', NULL, NULL, 15206, 9),
(268574, NULL, 'PF06668', NULL, NULL, 'Inter-alpha-trypsin inhibitor heavy chain C-terminus', NULL, 'ITI_HC_C', NULL, NULL, 8206, 9); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(268575, NULL, 'PF04463', NULL, NULL, '2-thiouracil desulfurase', NULL, '2-thiour_desulf', NULL, NULL, 3516, 9),
(268576, NULL, 'PF05423', NULL, NULL, 'Mycobacterium membrane protein', NULL, 'Mycobact_memb', NULL, NULL, 13319, 9),
(268577, NULL, 'PF07583', NULL, NULL, 'Protein of unknown function (DUF1549)', NULL, 'PSCyt2', NULL, NULL, 13921, 9),
(268578, NULL, 'PF11378', NULL, NULL, 'Protein of unknown function (DUF3181)', NULL, 'DUF3181', NULL, NULL, 18583, 9),
(268579, NULL, 'PF16687', NULL, NULL, 'beta-propeller of ELYS nucleoporin', NULL, 'ELYS-bb', NULL, NULL, 25804, 9),
(268580, NULL, 'PF10901', NULL, NULL, 'Protein of unknown function (DUF2690)', NULL, 'DUF2690', NULL, NULL, 17775, 9),
(268581, NULL, 'PF06322', NULL, NULL, 'Phage NinH protein', NULL, 'Phage_NinH', NULL, NULL, 10455, 9),
(268582, NULL, 'PF03024', NULL, NULL, 'Folate receptor family', NULL, 'Folate_rec', NULL, NULL, 13943, 9),
(268583, NULL, 'PF14847', NULL, NULL, 'Ras-binding domain of Byr2', NULL, 'Ras_bdg_2', NULL, NULL, 25952, 9),
(268584, NULL, 'PF13829', NULL, NULL, 'Domain of unknown function (DUF4191)', NULL, 'DUF4191', NULL, NULL, 22068, 9),
(268585, NULL, 'PF08275', NULL, NULL, 'DNA primase catalytic core, N-terminal domain', NULL, 'Toprim_N', NULL, NULL, 13115, 9),
(268586, NULL, 'PF08251', NULL, NULL, 'Mastoparan peptide', NULL, 'Mastoparan_2', NULL, NULL, 17907, 9),
(268587, NULL, 'PF17451', NULL, NULL, 'Glycosyl hydrolase 101 beta sandwich domain', NULL, 'Glyco_hyd_101C', NULL, NULL, 32827, 9),
(268588, NULL, 'PF02744', NULL, NULL, 'Galactose-1-phosphate uridyl transferase, C-terminal domain', NULL, 'GalP_UDP_tr_C', NULL, NULL, 6939, 9),
(268589, NULL, 'PF14388', NULL, NULL, 'Domain of unknown function (DUF4419)', NULL, 'DUF4419', NULL, NULL, 26381, 9),
(268590, NULL, 'PF19738', NULL, NULL, 'Family of unknown function (DUF6227)', NULL, 'DUF6227', NULL, NULL, 37075, 9),
(268591, NULL, 'PF20163', NULL, NULL, 'Family of unknown function (DUF6536)', NULL, 'DUF6536', NULL, NULL, 33828, 9),
(268592, NULL, 'PF20582', NULL, NULL, 'UPF0758 N-terminal', NULL, 'UPF0758_N', NULL, NULL, 37580, 9),
(268593, NULL, 'PF20510', NULL, NULL, 'Homogentisate 1,2-dioxygenase N-terminal', NULL, 'HgmA_N', NULL, NULL, 33980, 9),
(268594, NULL, 'PF20600', NULL, NULL, 'Exodeoxyribonuclease X-like C-terminal', NULL, 'ExoX-like_C', NULL, NULL, 33825, 9),
(268595, NULL, 'PF05494', NULL, NULL, 'MlaC protein', NULL, 'MlaC', NULL, NULL, 7689, 9),
(268596, NULL, 'PF09044', NULL, NULL, 'Kp4', NULL, 'Kp4', NULL, NULL, 9949, 9),
(268597, NULL, 'PF02691', NULL, NULL, 'Vacuolating cyotoxin', NULL, 'VacA', NULL, NULL, 3336, 9),
(268598, NULL, 'PF14545', NULL, NULL, 'Dof, BCAP, and BANK (DBB) motif,', NULL, 'DBB', NULL, NULL, 2628, 9),
(268599, NULL, 'PF20523', NULL, NULL, 'Domain of unknown function (DUF6738)', NULL, 'DUF6738', NULL, NULL, 33680, 9),
(268600, NULL, 'PF02234', NULL, NULL, 'Cyclin-dependent kinase inhibitor', NULL, 'CDI', NULL, NULL, 1958, 9),
(268601, NULL, 'PF11637', NULL, NULL, 'UvsW.1 domain', NULL, 'UvsW-1', NULL, NULL, 14785, 9),
(268602, NULL, 'PF03736', NULL, NULL, 'EPTP domain', NULL, 'EPTP', NULL, NULL, 701, 9),
(268603, NULL, 'PF19944', NULL, NULL, 'Family of unknown function (DUF6406)', NULL, 'DUF6406', NULL, NULL, 36263, 9),
(268604, NULL, 'PF02941', NULL, NULL, 'Ferredoxin thioredoxin reductase variable alpha chain', NULL, 'FeThRed_A', NULL, NULL, 3693, 9),
(268605, NULL, 'PF19972', NULL, NULL, 'Ternary complex associated domain 3', NULL, 'TCAD3', NULL, NULL, 35873, 9),
(268606, NULL, 'PF18366', NULL, NULL, 'Zic proteins zinc finger domain', NULL, 'zf_ZIC', NULL, NULL, 29851, 9),
(268607, NULL, 'PF19185', NULL, NULL, 'Family of unknown function (DUF5867)', NULL, 'DUF5867', NULL, NULL, 35429, 9),
(268608, NULL, 'PF02329', NULL, NULL, 'Histidine carboxylase PI chain', NULL, 'HDC', NULL, NULL, 5098, 9),
(268609, NULL, 'PF06160', NULL, NULL, 'Septation ring formation regulator, EzrA', NULL, 'EzrA', NULL, NULL, 9389, 9),
(268610, NULL, 'PF01440', NULL, NULL, 'Geminivirus AL2 protein', NULL, 'Gemini_AL2', NULL, NULL, 476, 9);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(268611, NULL, 'PF15467', NULL, NULL, 'Secretogranin-3', NULL, 'SGIII', NULL, NULL, 25410, 9),
(268612, NULL, 'PF13435', NULL, NULL, 'Cytochrome c554 and c-prime', NULL, 'Cytochrome_C554', NULL, NULL, 15875, 9),
(268613, NULL, 'PF12349', NULL, NULL, 'Sterol-sensing domain of SREBP cleavage-activation', NULL, 'Sterol-sensing', NULL, NULL, 3723, 9),
(268614, NULL, 'PF06179', NULL, NULL, 'Surfeit locus protein 5 subunit 22 of Mediator complex', NULL, 'Med22', NULL, NULL, 14222, 9),
(268615, NULL, 'PF12005', NULL, NULL, 'Protein of unknown function (DUF3499)', NULL, 'DUF3499', NULL, NULL, 19894, 9),
(268616, NULL, 'PF13053', NULL, NULL, 'Protein of unknown function (DUF3914)', NULL, 'DUF3914', NULL, NULL, 22542, 9),
(268617, NULL, 'PF09290', NULL, NULL, 'Prokaryotic acetaldehyde dehydrogenase, dimerisation', NULL, 'AcetDehyd-dimer', NULL, NULL, 11672, 9),
(268618, NULL, 'PF01035', NULL, NULL, '6-O-methylguanine DNA methyltransferase, DNA binding domain', NULL, 'DNA_binding_1', NULL, NULL, 9653, 9),
(268619, NULL, 'PF15125', NULL, NULL, 'TMEM238 protein family', NULL, 'TMEM238', NULL, NULL, 26499, 9),
(268620, NULL, 'PF12453', NULL, NULL, 'Protein tyrosine phosphatase N terminal', NULL, 'PTP_N', NULL, NULL, 23078, 9),
(268621, NULL, 'PF16827', NULL, NULL, 'zinc-finger', NULL, 'zf-HC3', NULL, NULL, 25990, 9),
(268622, NULL, 'PF19966', NULL, NULL, 'vWA-MoxR associated protein middle region (VMAP-M) 4', NULL, 'VMAP-M4', NULL, NULL, 37222, 9),
(268623, NULL, 'PF19205', NULL, NULL, 'Family of unknown function (DUF5877)', NULL, 'DUF5877', NULL, NULL, 35279, 9),
(268624, NULL, 'PF05978', NULL, NULL, 'Ion channel regulatory protein UNC-93', NULL, 'UNC-93', NULL, NULL, 7926, 9),
(268625, NULL, 'PF10225', NULL, NULL, 'NEMP family', NULL, 'NEMP', NULL, NULL, 15902, 9),
(268626, NULL, 'PF11179', NULL, NULL, 'Protein of unknown function (DUF2967)', NULL, 'DUF2967', NULL, NULL, 18278, 9),
(268627, NULL, 'PF00268', NULL, NULL, 'Ribonucleotide reductase, small chain', NULL, 'Ribonuc_red_sm', NULL, NULL, 120, 9),
(268628, NULL, 'PF17545', NULL, NULL, 'Family of unknown function (DUF5461)', NULL, 'DUF5461', NULL, NULL, 20002, 9),
(268629, NULL, 'PF16400', NULL, NULL, 'Domain of unknown function (DUF5008)', NULL, 'DUF5008', NULL, NULL, 23756, 9),
(268630, NULL, 'PF10001', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2242)', NULL, 'DUF2242', NULL, NULL, 17098, 9),
(268631, NULL, 'PF07603', NULL, NULL, 'Protein of unknown function (DUF1566)', NULL, 'DUF1566', NULL, NULL, 13710, 9),
(268632, NULL, 'PF10776', NULL, NULL, 'Protein of unknown function (DUF2600)', NULL, 'DUF2600', NULL, NULL, 20951, 9),
(268633, NULL, 'PF18054', NULL, NULL, 'CEL-III C-terminal', NULL, 'CEL_III_C', NULL, NULL, 29331, 9),
(268634, NULL, 'PF10037', NULL, NULL, 'Mitochondrial 28S ribosomal protein S27', NULL, 'MRP-S27', NULL, NULL, 11281, 9),
(268635, NULL, 'PF00019', NULL, NULL, 'Transforming growth factor beta like domain', NULL, 'TGF_beta', NULL, NULL, 4200, 9),
(268636, NULL, 'PF14993', NULL, NULL, 'Neuropeptide S precursor protein', NULL, 'Neuropeptide_S', NULL, NULL, 25271, 9),
(268637, NULL, 'PF18099', NULL, NULL, 'DUF5010 C-terminal domain', NULL, 'DUF5010_C', NULL, NULL, 29050, 9),
(268638, NULL, 'PF15562', NULL, NULL, 'Immunity protein 17', NULL, 'Imm17', NULL, NULL, 25196, 9),
(268639, NULL, 'PF12994', NULL, NULL, 'Domain of unknown function, E. rectale Gene description (DUF3878)', NULL, 'DUF3878', NULL, NULL, 24543, 9),
(268640, NULL, 'PF18969', NULL, NULL, 'Family of unknown function (DUF5708)', NULL, 'DUF5708', NULL, NULL, 35263, 9),
(268641, NULL, 'PF01655', NULL, NULL, 'Ribosomal protein L32', NULL, 'Ribosomal_L32e', NULL, NULL, 6254, 9),
(268642, NULL, 'PF16912', NULL, NULL, 'Glucose dehydrogenase C-terminus', NULL, 'Glu_dehyd_C', NULL, NULL, 25158, 9),
(268643, NULL, 'PF12147', NULL, NULL, 'Putative methyltransferase', NULL, 'Methyltransf_20', NULL, NULL, 17328, 9),
(268644, NULL, 'PF10771', NULL, NULL, 'Winged helix-turn-helix domain (DUF2582)', NULL, 'DUF2582', NULL, NULL, 20863, 9),
(268645, NULL, 'PF11203', NULL, NULL, 'Putative type VII ESX secretion system translocon, EccE', NULL, 'EccE', NULL, NULL, 18257, 9);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(268646, NULL, 'PF18951', NULL, NULL, 'Family of unknown function (DUF5695)', NULL, 'DUF5695', NULL, NULL, 34067, 9),
(268647, NULL, 'PF00690', NULL, NULL, 'Cation transporter/ATPase, N-terminus', NULL, 'Cation_ATPase_N', NULL, NULL, 845, 9),
(268648, NULL, 'PF02793', NULL, NULL, 'Hormone receptor domain', NULL, 'HRM', NULL, NULL, 4113, 9),
(268649, NULL, 'PF02948', NULL, NULL, 'Amelogenin', NULL, 'Amelogenin', NULL, NULL, NULL, 9),
(268650, NULL, 'PF19700', NULL, NULL, 'Family of unknown function (DUF6198)', NULL, 'DUF6198', NULL, NULL, 36253, 9),
(268651, NULL, 'PF19266', NULL, NULL, 'Contractile injection system tube protein', NULL, 'CIS_tube', NULL, NULL, 37097, 9),
(268652, NULL, 'PF04234', NULL, NULL, 'CopC domain', NULL, 'CopC', NULL, NULL, 5676, 9),
(268653, NULL, 'PF04698', NULL, NULL, 'Rab effector MyRIP/melanophilin C-terminus', NULL, 'Rab_eff_C', NULL, NULL, 3342, 9),
(268654, NULL, 'PF04540', NULL, NULL, 'Herpesvirus UL51 protein', NULL, 'Herpes_UL51', NULL, NULL, 2942, 9),
(268655, NULL, 'PF02779', NULL, NULL, 'Transketolase, pyrimidine binding domain', NULL, 'Transket_pyr', NULL, NULL, 529, 9),
(268656, NULL, 'PF05754', NULL, NULL, 'Domain of unknown function (DUF834)', NULL, 'DUF834', NULL, NULL, 13150, 9),
(268657, NULL, 'PF12390', NULL, NULL, 'Selenocysteine synthase N terminal', NULL, 'Se-cys_synth_N', NULL, NULL, 25656, 9),
(268658, NULL, 'PF09366', NULL, NULL, 'Protein of unknown function (DUF1997)', NULL, 'DUF1997', NULL, NULL, 14690, 9),
(268659, NULL, 'PF07669', NULL, NULL, 'Eco57I restriction-modification methylase', NULL, 'Eco57I', NULL, NULL, 10706, 9),
(268660, NULL, 'PF06514', NULL, NULL, 'Photosystem II 12 kDa extrinsic protein (PsbU)', NULL, 'PsbU', NULL, NULL, 12339, 9),
(268661, NULL, 'PF18598', NULL, NULL, 'Tetracyclin repressor-like, C-terminal domain', NULL, 'TetR_C_36', NULL, NULL, 29253, 9),
(268662, NULL, 'PF20116', NULL, NULL, 'Family of unknown function (DUF6506)', NULL, 'DUF6506', NULL, NULL, 35673, 9),
(268663, NULL, 'PF08006', NULL, NULL, 'Protein of unknown function (DUF1700)', NULL, 'DUF1700', NULL, NULL, 11534, 9),
(268664, NULL, 'PF05300', NULL, NULL, 'MICOS complex subunit MIC19/MIC25', NULL, 'MIC19_MIC25', NULL, NULL, 4437, 9),
(268665, NULL, 'PF08862', NULL, NULL, 'Domain of unknown function DUF1829', NULL, 'DUF1829', NULL, NULL, 14235, 9),
(268666, NULL, 'PF17976', NULL, NULL, 'RING/Ubox like zinc-binding domain', NULL, 'zf-RING_12', NULL, NULL, 30277, 9),
(268667, NULL, 'PF16561', NULL, NULL, 'Glycogen recognition site of AMP-activated protein kinase', NULL, 'AMPK1_CBM', NULL, NULL, 21520, 9),
(268668, NULL, 'PF02312', NULL, NULL, 'Core binding factor beta subunit', NULL, 'CBF_beta', NULL, NULL, 5167, 9),
(268669, NULL, 'PF15743', NULL, NULL, 'Spermatogenesis-associated C-terminus', NULL, 'SPATA1_C', NULL, NULL, 22981, 9),
(268670, NULL, 'PF18499', NULL, NULL, 'Ubc7p-binding region of Cue1', NULL, 'Cue1_U7BR', NULL, NULL, 28803, 9),
(268671, NULL, 'PF03716', NULL, NULL, 'WCCH motif', NULL, 'WCCH', NULL, NULL, 4448, 9),
(268672, NULL, 'PF15742', NULL, NULL, 'Domain of unknown function (DUF4686)', NULL, 'DUF4686', NULL, NULL, 22624, 9),
(268673, NULL, 'PF18518', NULL, NULL, 'TcA receptor binding domain', NULL, 'TcA_RBD', NULL, NULL, 30550, 9),
(268674, NULL, 'PF06387', NULL, NULL, 'D1 dopamine receptor-interacting protein (calcyon)', NULL, 'Calcyon', NULL, NULL, 8438, 9),
(268675, NULL, 'PF11864', NULL, NULL, 'Domain of unknown function (DUF3384)', NULL, 'DUF3384', NULL, NULL, 26633, 9),
(268676, NULL, 'PF18674', NULL, NULL, 'TarS beta-glycosyltransferase C-terminal domain 1', NULL, 'TarS_C1', NULL, NULL, 29111, 9),
(268677, NULL, 'PF18538', NULL, NULL, 'Domain of unknown function (DUF5624)', NULL, 'DUF5624', NULL, NULL, 29287, 9),
(268678, NULL, 'PF08158', NULL, NULL, 'NUC130/3NT domain', NULL, 'NUC130_3NT', NULL, NULL, 11795, 9),
(268679, NULL, 'PF19059', NULL, NULL, 'Family of unknown function (DUF5755)', NULL, 'DUF5755', NULL, NULL, 35441, 9),
(268680, NULL, 'PF14494', NULL, NULL, 'Domain of unknown function (DUF4436)', NULL, 'DUF4436', NULL, NULL, 22780, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(268681, NULL, 'PF11619', NULL, NULL, 'Transcription factor P53 - C terminal domain', NULL, 'P53_C', NULL, NULL, 13761, 9),
(268682, NULL, 'PF07931', NULL, NULL, 'Chloramphenicol phosphotransferase-like protein', NULL, 'CPT', NULL, NULL, NULL, 9),
(268683, NULL, 'PF10705', NULL, NULL, 'Chloroplast protein precursor Ycf15 putative', NULL, 'Ycf15', NULL, NULL, 20737, 9),
(268684, NULL, 'PF00782', NULL, NULL, 'Dual specificity phosphatase, catalytic domain', NULL, 'DSPc', NULL, NULL, 307, 9),
(268685, NULL, 'PF01845', NULL, NULL, 'CcdB protein', NULL, 'CcdB', NULL, NULL, 3985, 9),
(268686, NULL, 'PF10156', NULL, NULL, 'Subunit 17 of Mediator complex', NULL, 'Med17', NULL, NULL, 14697, 9),
(268687, NULL, 'PF01625', NULL, NULL, 'Peptide methionine sulfoxide reductase', NULL, 'PMSR', NULL, NULL, 1834, 9),
(268688, NULL, 'PF08506', NULL, NULL, 'Cse1', NULL, 'Cse1', NULL, NULL, 14125, 9),
(268689, NULL, 'PF17784', NULL, NULL, 'Sulfotransferase domain', NULL, 'Sulfotransfer_4', NULL, NULL, 28111, 9),
(268690, NULL, 'PF18435', NULL, NULL, 'Esterase Ig-like N-terminal domain', NULL, 'EstA_Ig_like', NULL, NULL, 28729, 9),
(268691, NULL, 'PF19563', NULL, NULL, 'Family of unknown function (DUF6085)', NULL, 'DUF6085', NULL, NULL, 34132, 9),
(268692, NULL, 'PF05597', NULL, NULL, 'Poly(hydroxyalcanoate) granule associated protein (phasin)', NULL, 'Phasin', NULL, NULL, 12143, 9),
(268693, NULL, 'PF07283', NULL, NULL, 'Conjugal transfer protein TrbH', NULL, 'TrbH', NULL, NULL, 11753, 9),
(268694, NULL, 'PF10375', NULL, NULL, 'GRAB domain', NULL, 'GRAB', NULL, NULL, 17497, 9),
(268695, NULL, 'PF00026', NULL, NULL, 'Eukaryotic aspartyl protease', NULL, 'Asp', NULL, NULL, 30519, 9),
(268696, NULL, 'PF06989', NULL, NULL, 'BAALC N-terminus', NULL, 'BAALC_N', NULL, NULL, 12036, 9),
(268697, NULL, 'PF10367', NULL, NULL, 'Vacuolar sorting protein 39 domain 2', NULL, 'Vps39_2', NULL, NULL, 17102, 9),
(268698, NULL, 'PF03142', NULL, NULL, 'Chitin synthase', NULL, 'Chitin_synth_2', NULL, NULL, NULL, 9),
(268699, NULL, 'PF11117', NULL, NULL, 'Protein of unknown function (DUF2626)', NULL, 'DUF2626', NULL, NULL, 19417, 9),
(268700, NULL, 'PF01429', NULL, NULL, 'Methyl-CpG binding domain', NULL, 'MBD', NULL, NULL, 3352, 9),
(268701, NULL, 'PF03068', NULL, NULL, 'Protein-arginine deiminase (PAD)', NULL, 'PAD', NULL, NULL, 8856, 9),
(268702, NULL, 'PF04556', NULL, NULL, 'DpnII restriction endonuclease', NULL, 'DpnII', NULL, NULL, 2250, 9),
(268703, NULL, 'PF00562', NULL, NULL, 'RNA polymerase Rpb2, domain 6', NULL, 'RNA_pol_Rpb2_6', NULL, NULL, 1426, 9),
(268704, NULL, 'PF01687', NULL, NULL, 'Riboflavin kinase', NULL, 'Flavokinase', NULL, NULL, 12594, 9),
(268705, NULL, 'PF04355', NULL, NULL, 'SmpA / OmlA family', NULL, 'SmpA_OmlA', NULL, NULL, 4514, 9),
(268706, NULL, 'PF08039', NULL, NULL, 'Mitochondrial proteolipid', NULL, 'Mit_proteolip', NULL, NULL, 9299, 9),
(268707, NULL, 'PF08209', NULL, NULL, 'Sgf11 (transcriptional regulation protein)', NULL, 'Sgf11', NULL, NULL, 12839, 9),
(268708, NULL, 'PF18594', NULL, NULL, 'Sas6/XLF/XRCC4 coiled-coil domain', NULL, 'Sas6_CC', NULL, NULL, 29124, 9),
(268709, NULL, 'PF11783', NULL, NULL, 'Cytochrome c bacterial', NULL, 'Cytochrome_cB', NULL, NULL, 21188, 9),
(268710, NULL, 'PF17682', NULL, NULL, 'Tau95 Triple barrel domain', NULL, 'Tau95_N', NULL, NULL, 29968, 9),
(268711, NULL, 'PF19148', NULL, NULL, 'Family of unknown function (DUF5830)', NULL, 'DUF5830', NULL, NULL, 34168, 9),
(268712, NULL, 'PF13418', NULL, NULL, 'Galactose oxidase, central domain', NULL, 'Kelch_4', NULL, NULL, NULL, 9),
(268713, NULL, 'PF13043', NULL, NULL, 'Domain of unknown function (DUF3903)', NULL, 'DUF3903', NULL, NULL, 22969, 9),
(268714, NULL, 'PF03221', NULL, NULL, 'Tc5 transposase DNA-binding domain', NULL, 'HTH_Tnp_Tc5', NULL, NULL, 1032, 9),
(268715, NULL, 'PF11556', NULL, NULL, 'Erythrocyte binding antigen 175', NULL, 'EBA-175_VI', NULL, NULL, 18758, 9),
(268716, NULL, 'PF14209', NULL, NULL, 'Domain of unknown function (DUF4321)', NULL, 'DUF4321', NULL, NULL, 26260, 9),
(268717, NULL, 'PF07771', NULL, NULL, 'Tick salivary peptide group 1', NULL, 'TSGP1', NULL, NULL, 10645, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(268718, NULL, 'PF03416', NULL, NULL, 'Peptidase family C54', NULL, 'Peptidase_C54', NULL, NULL, 37609, 9),
(268719, NULL, 'PF08634', NULL, NULL, 'Mitochondrial protein Pet127', NULL, 'Pet127', NULL, NULL, 7561, 9),
(268720, NULL, 'PF19343', NULL, NULL, 'Family of unknown function (DUF5923)', NULL, 'DUF5923', NULL, NULL, 36820, 9),
(268721, NULL, 'PF15965', NULL, NULL, 'TRAF-like zinc-finger', NULL, 'zf-TRAF_2', NULL, NULL, 5428, 9),
(268722, NULL, 'PF04694', NULL, NULL, 'Coronavirus ORF3 protein', NULL, 'Corona_3', NULL, NULL, 3379, 9),
(268723, NULL, 'PF12531', NULL, NULL, 'DNA-K related protein', NULL, 'DUF3731', NULL, NULL, 15418, 9),
(268724, NULL, 'PF02029', NULL, NULL, 'Caldesmon', NULL, 'Caldesmon', NULL, NULL, 1208, 9),
(268725, NULL, 'PF07894', NULL, NULL, 'FAM83 A-H', NULL, 'FAM83', NULL, NULL, 14375, 9),
(268726, NULL, 'PF12606', NULL, NULL, 'Tumour necrosis factor receptor superfamily member 19', NULL, 'RELT', NULL, NULL, 21333, 9),
(268727, NULL, 'PF06047', NULL, NULL, 'NF-kappa-B-activating protein C-terminal domain', NULL, 'Nkap_C', NULL, NULL, 13722, 9),
(268728, NULL, 'PF15443', NULL, NULL, 'Domain of unknown function (DUF4630)', NULL, 'DUF4630', NULL, NULL, 25823, 9),
(268729, NULL, 'PF10337', NULL, NULL, 'Putative ER transporter, 6TM, N-terminal', NULL, 'ArAE_2_N', NULL, NULL, 19631, 9),
(268730, NULL, 'PF18864', NULL, NULL, 'AbiTii', NULL, 'AbiTii', NULL, NULL, 29689, 9),
(268731, NULL, 'PF19812', NULL, NULL, 'Family of unknown function (DUF6295)', NULL, 'DUF6295', NULL, NULL, 37491, 9),
(268732, NULL, 'PF09148', NULL, NULL, 'Domain of unknown function (DUF1934)', NULL, 'DUF1934', NULL, NULL, 10540, 9),
(268733, NULL, 'PF18063', NULL, NULL, 'Beta barrel Pore-forming domain', NULL, 'BB_PF', NULL, NULL, 27601, 9),
(268734, NULL, 'PF00287', NULL, NULL, 'Sodium / potassium ATPase beta chain', NULL, 'Na_K-ATPase', NULL, NULL, 4711, 9),
(268735, NULL, 'PF08856', NULL, NULL, 'Protein of unknown function (DUF1826)', NULL, 'DUF1826', NULL, NULL, 14500, 9),
(268736, NULL, 'PF09776', NULL, NULL, 'Mitochondrial ribosomal protein L55', NULL, 'Mitoc_L55', NULL, NULL, 16115, 9),
(268737, NULL, 'PF13884', NULL, NULL, 'Chaperone of endosialidase', NULL, 'Peptidase_S74', NULL, NULL, 26703, 9),
(268738, NULL, 'PF08685', NULL, NULL, 'GON domain', NULL, 'GON', NULL, NULL, 11915, 9),
(268739, NULL, 'PF12156', NULL, NULL, 'Putative metal-binding domain of cation transport ATPase', NULL, 'ATPase-cat_bd', NULL, NULL, 20398, 9),
(268740, NULL, 'PF07157', NULL, NULL, 'DNA circularisation protein N-terminus', NULL, 'DNA_circ_N', NULL, NULL, 13411, 9),
(268741, NULL, 'PF10864', NULL, NULL, 'Protein of unknown function (DUF2663)', NULL, 'DUF2663', NULL, NULL, 18894, 9),
(268742, NULL, 'PF14447', NULL, NULL, 'Prokaryotic RING finger family 4', NULL, 'Prok-RING_4', NULL, NULL, NULL, 9),
(268743, NULL, 'PF17288', NULL, NULL, 'Terminase RNAseH like domain', NULL, 'Terminase_3C', NULL, NULL, 16873, 9),
(268744, NULL, 'PF12818', NULL, NULL, 'dsDNA viral tegument protein', NULL, 'Tegument_dsDNA', NULL, NULL, 22195, 9),
(268745, NULL, 'PF13567', NULL, NULL, 'Domain of unknown function (DUF4131)', NULL, 'DUF4131', NULL, NULL, 22067, 9),
(268746, NULL, 'PF20442', NULL, NULL, 'BREX system Lon protease-like protein BrxL N-terminal', NULL, 'BrxL_N', NULL, NULL, 36771, 9),
(268747, NULL, 'PF17255', NULL, NULL, 'EbsA-like protein', NULL, 'EbsA', NULL, NULL, 18892, 9),
(268748, NULL, 'PF13159', NULL, NULL, 'Domain of unknown function (DUF3994)', NULL, 'DUF3994', NULL, NULL, 22831, 9),
(268749, NULL, 'PF16380', NULL, NULL, 'Domain of unknown function', NULL, 'DUF4990', NULL, NULL, 22461, 9),
(268750, NULL, 'PF08589', NULL, NULL, 'Autophagy receptor ATG43', NULL, 'ATG43', NULL, NULL, 17954, 9),
(268751, NULL, 'PF00585', NULL, NULL, 'C-terminal regulatory domain of Threonine dehydratase', NULL, 'Thr_dehydrat_C', NULL, NULL, 3173, 9),
(268752, NULL, 'PF00343', NULL, NULL, 'Carbohydrate phosphorylase', NULL, 'Phosphorylase', NULL, NULL, 4517, 9),
(268753, NULL, 'PF17691', NULL, NULL, 'Contingent replication of cDNA 4', NULL, 'Croc_4', NULL, NULL, 31762, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(268754, NULL, 'PF04336', NULL, NULL, 'Acyl carrier protein phosphodiesterase', NULL, 'ACP_PD', NULL, NULL, 3565, 9),
(268755, NULL, 'PF06515', NULL, NULL, 'Borna disease virus P10 protein', NULL, 'BDV_P10', NULL, NULL, 9459, 9),
(268756, NULL, 'PF03229', NULL, NULL, 'Alphavirus glycoprotein J', NULL, 'Alpha_GJ', NULL, NULL, 1877, 9),
(268757, NULL, 'PF03450', NULL, NULL, 'CO dehydrogenase flavoprotein C-terminal domain', NULL, 'CO_deh_flav_C', NULL, NULL, 10955, 9),
(268758, NULL, 'PF01599', NULL, NULL, 'Ribosomal protein S27a', NULL, 'Ribosomal_S27', NULL, NULL, 6034, 9),
(268759, NULL, 'PF01451', NULL, NULL, 'Low molecular weight phosphotyrosine protein phosphatase', NULL, 'LMWPc', NULL, NULL, 16967, 9),
(268760, NULL, 'PF14466', NULL, NULL, 'PLAT/LH2 and C2-like Ca2+-binding lipoprotein', NULL, 'PLCC', NULL, NULL, 25605, 9),
(268761, NULL, 'PF13323', NULL, NULL, 'N-terminal domain with HPIH motif', NULL, 'HPIH', NULL, NULL, 24524, 9),
(268762, NULL, 'PF16376', NULL, NULL, 'N-terminal domain of fragilysin', NULL, 'fragilysinNterm', NULL, NULL, 26441, 9),
(268763, NULL, 'PF11678', NULL, NULL, 'Protein of unknown function (DUF3274)', NULL, 'DUF3274', NULL, NULL, 19368, 9),
(268764, NULL, 'PF10795', NULL, NULL, 'Protein of unknown function (DUF2607)', NULL, 'DUF2607', NULL, NULL, 20722, 9),
(268765, NULL, 'PF19425', NULL, NULL, 'Csd3 second domain', NULL, 'Csd3_N2', NULL, NULL, 36272, 9),
(268766, NULL, 'PF02630', NULL, NULL, 'SCO1/SenC', NULL, 'SCO1-SenC', NULL, NULL, 3197, 9),
(268767, NULL, 'PF20283', NULL, NULL, 'C-terminal domain 7 of the ABC-three component (ABC-3C) systems', NULL, 'CTD7', NULL, NULL, 34152, 9),
(268768, NULL, 'PF05613', NULL, NULL, 'Human herpesvirus U15 protein', NULL, 'Herpes_U15', NULL, NULL, 14339, 9),
(268769, NULL, 'PF03619', NULL, NULL, 'Organic solute transporter Ostalpha', NULL, 'Solute_trans_a', NULL, NULL, 5265, 9),
(268770, NULL, 'PF10937', NULL, NULL, 'Ribosomal protein S36, mitochondrial', NULL, 'S36_mt', NULL, NULL, 19617, 9),
(268771, NULL, 'PF14131', NULL, NULL, 'Domain of unknown function (DUF4298)', NULL, 'DUF4298', NULL, NULL, 26485, 9),
(268772, NULL, 'PF08692', NULL, NULL, 'Mitochondrial protein Pet20', NULL, 'Pet20', NULL, NULL, 11967, 9),
(268773, NULL, 'PF01346', NULL, NULL, 'Domain amino terminal to FKBP-type peptidyl-prolyl isomerase', NULL, 'FKBP_N', NULL, NULL, 6682, 9),
(268774, NULL, 'PF11154', NULL, NULL, 'Protein of unknown function (DUF2934)', NULL, 'DUF2934', NULL, NULL, 17939, 9),
(268775, NULL, 'PF15249', NULL, NULL, 'Conserved region of unknown function on GLTSCR protein', NULL, 'GLTSCR1', NULL, NULL, 17946, 9),
(268776, NULL, 'PF01472', NULL, NULL, 'PUA domain', NULL, 'PUA', NULL, NULL, 658, 9),
(268777, NULL, 'PF03393', NULL, NULL, 'Pneumovirus matrix protein', NULL, 'Pneumo_matrix', NULL, NULL, 2258, 9),
(268778, NULL, 'PF13452', NULL, NULL, 'N-terminal half of MaoC dehydratase', NULL, 'MaoC_dehydrat_N', NULL, NULL, 27464, 9),
(268779, NULL, 'PF16419', NULL, NULL, 'CCR4-NOT transcription complex subunit 1 HEAT repeat', NULL, 'CNOT1_HEAT_N', NULL, NULL, 23812, 9),
(268780, NULL, 'PF13368', NULL, NULL, 'Topoisomerase C-terminal repeat', NULL, 'Toprim_C_rpt', NULL, NULL, 24718, 9),
(268781, NULL, 'PF13582', NULL, NULL, 'Metallo-peptidase family M12B Reprolysin-like', NULL, 'Reprolysin_3', NULL, NULL, NULL, 9),
(268782, NULL, 'PF04699', NULL, NULL, 'ARP2/3 complex 16 kDa subunit (p16-Arc)', NULL, 'P16-Arc', NULL, NULL, 3311, 9),
(268783, NULL, 'PF13958', NULL, NULL, 'Toxin ToxN, type III toxin-antitoxin system', NULL, 'ToxN_toxin', NULL, NULL, 23193, 9),
(268784, NULL, 'PF20165', NULL, NULL, 'KBTB, W-type LIR motif', NULL, 'KBTB_W-LIR', NULL, NULL, 33849, 9),
(268785, NULL, 'PF00819', NULL, NULL, 'Myotoxin, crotamine', NULL, 'Myotoxins', NULL, NULL, 4565, 9),
(268786, NULL, 'PF08027', NULL, NULL, 'Albumin I chain b', NULL, 'Albumin_I', NULL, NULL, 12690, 9),
(268787, NULL, 'PF04659', NULL, NULL, 'Archaeal flagella protein', NULL, 'Arch_fla_DE', NULL, NULL, 2747, 9),
(268788, NULL, 'PF05926', NULL, NULL, 'Phage head completion protein (GPL)', NULL, 'Phage_GPL', NULL, NULL, 12560, 9); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(268789, NULL, 'PF16062', NULL, NULL, 'Domain of unknown function (DUF4804)', NULL, 'DUF4804', NULL, NULL, 23611, 9),
(268790, NULL, 'PF17092', NULL, NULL, 'Penicillin-binding protein OB-like domain', NULL, 'PCB_OB', NULL, NULL, 24466, 9),
(268791, NULL, 'PF05325', NULL, NULL, 'Protein of unknown function (DUF730)', NULL, 'DUF730', NULL, NULL, 4016, 9),
(268792, NULL, 'PF04800', NULL, NULL, 'NADH dehydrogenase ubiquinone Fe-S protein 4', NULL, 'NDUS4', NULL, NULL, 4557, 9),
(268793, NULL, 'PF11241', NULL, NULL, 'Protein of unknown function (DUF3043)', NULL, 'DUF3043', NULL, NULL, 18488, 9),
(268794, NULL, 'PF10238', NULL, NULL, 'E2F-associated phosphoprotein', NULL, 'Eapp_C', NULL, NULL, 15918, 9),
(268795, NULL, 'PF14138', NULL, NULL, 'Cytochrome c oxidase assembly protein COX16', NULL, 'COX16', NULL, NULL, 13930, 9),
(268796, NULL, 'PF16572', NULL, NULL, 'Long alpha hairpin domain of cation efflux system protein, CusB', NULL, 'HlyD_D4', NULL, NULL, 25422, 9),
(268797, NULL, 'PF10051', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2286)', NULL, 'DUF2286', NULL, NULL, 18616, 9),
(268798, NULL, 'PF16471', NULL, NULL, 'JNK-interacting protein leucine zipper II', NULL, 'JIP_LZII', NULL, NULL, 22062, 9),
(268799, NULL, 'PF17277', NULL, NULL, 'Family of unknown function (DUF5342)', NULL, 'DUF5342', NULL, NULL, 16408, 9),
(268800, NULL, 'PF09951', NULL, NULL, 'Protein of unknown function (DUF2185)', NULL, 'DUF2185', NULL, NULL, 17013, 9),
(268801, NULL, 'PF01583', NULL, NULL, 'Adenylylsulphate kinase', NULL, 'APS_kinase', NULL, NULL, NULL, 9),
(268802, NULL, 'PF06614', NULL, NULL, 'Neuromodulin', NULL, 'Neuromodulin', NULL, NULL, 18797, 9),
(268803, NULL, 'PF17531', NULL, NULL, 'Spanin, outer lipoprotein subunit T7-like virus', NULL, 'O_Spanin_T7', NULL, NULL, 13507, 9),
(268804, NULL, 'PF13525', NULL, NULL, 'Outer membrane lipoprotein', NULL, 'YfiO', NULL, NULL, 33756, 9),
(268805, NULL, 'PF15343', NULL, NULL, 'Decidual protein induced by progesterone family', NULL, 'DEPP', NULL, NULL, 13899, 9),
(268806, NULL, 'PF00320', NULL, NULL, 'GATA zinc finger', NULL, 'GATA', NULL, NULL, 3606, 9),
(268807, NULL, 'PF15962', NULL, NULL, 'Domain of unknown function (DUF4765)', NULL, 'DUF4765', NULL, NULL, 26506, 9),
(268808, NULL, 'PF00573', NULL, NULL, 'Ribosomal protein L4/L1 family', NULL, 'Ribosomal_L4', NULL, NULL, 5421, 9),
(268809, NULL, 'PF07189', NULL, NULL, 'Splicing factor 3B subunit 10 (SF3b10)', NULL, 'SF3b10', NULL, NULL, 13211, 9),
(268810, NULL, 'PF12439', NULL, NULL, 'Glycogen debranching enzyme N terminal', NULL, 'GDE_N', NULL, NULL, 10478, 9),
(268811, NULL, 'PF09326', NULL, NULL, 'NADH-ubiquinone oxidoreductase subunit G, C-terminal', NULL, 'NADH_dhqG_C', NULL, NULL, 14044, 9),
(268812, NULL, 'PF19965', NULL, NULL, 'vWA-MoxR associated protein middle region (VMAP-M) 2', NULL, 'VMAP-M2', NULL, NULL, 37312, 9),
(268813, NULL, 'PF03304', NULL, NULL, 'Mlp lipoprotein family', NULL, 'Mlp', NULL, NULL, 936, 9),
(268814, NULL, 'PF07294', NULL, NULL, 'Fibroin P25', NULL, 'Fibroin_P25', NULL, NULL, 14399, 9),
(268815, NULL, 'PF15563', NULL, NULL, 'Immunity protein 19', NULL, 'Imm19', NULL, NULL, 25008, 9),
(268816, NULL, 'PF08080', NULL, NULL, 'RNPHF zinc finger', NULL, 'zf-RNPHF', NULL, NULL, 12126, 9),
(268817, NULL, 'PF01934', NULL, NULL, 'Ribonuclease HepT-like', NULL, 'HepT-like', NULL, NULL, 7255, 9),
(268818, NULL, 'PF14068', NULL, NULL, 'Putative membrane protein', NULL, 'YuiB', NULL, NULL, 23416, 9),
(268819, NULL, 'PF07114', NULL, NULL, 'Transmembrane protein 126', NULL, 'TMEM126', NULL, NULL, 13047, 9),
(268820, NULL, 'PF18404', NULL, NULL, 'Glucosyltransferase 24', NULL, 'Glyco_transf_24', NULL, NULL, 27929, 9),
(268821, NULL, 'PF19614', NULL, NULL, 'Family of unknown function (DUF6119)', NULL, 'DUF6119', NULL, NULL, 23174, 9),
(268822, NULL, 'PF02687', NULL, NULL, 'FtsX-like permease family', NULL, 'FtsX', NULL, NULL, 3152, 9),
(268823, NULL, 'PF12787', NULL, NULL, 'EcsC protein family', NULL, 'EcsC', NULL, NULL, 23542, 9),
(268824, NULL, 'PF06785', NULL, NULL, 'Uncharacterised protein family (UPF0242) N-terminus', NULL, 'UPF0242', NULL, NULL, 1669, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(268825, NULL, 'PF12746', NULL, NULL, 'GNAT acetyltransferase', NULL, 'GNAT_acetyltran', NULL, NULL, 24283, 9),
(268826, NULL, 'PF18049', NULL, NULL, 'DNA polymerase nu pseudo-exo', NULL, 'DNA_pol_P_Exo', NULL, NULL, 29143, 9),
(268827, NULL, 'PF20559', NULL, NULL, 'Family of unknown function (DUF6770)', NULL, 'DUF6770', NULL, NULL, 37311, 9),
(268828, NULL, 'PF16555', NULL, NULL, 'Gram-positive pilin subunit D1, N-terminal domain', NULL, 'GramPos_pilinD1', NULL, NULL, 26109, 9),
(268829, NULL, 'PF02433', NULL, NULL, 'Cytochrome C oxidase, mono-heme subunit/FixO', NULL, 'FixO', NULL, NULL, 6408, 9),
(268830, NULL, 'PF12171', NULL, NULL, 'Zinc-finger double-stranded RNA-binding', NULL, 'zf-C2H2_jaz', NULL, NULL, 17292, 9),
(268831, NULL, 'PF16267', NULL, NULL, 'Domain of unknown function (DUF4920)', NULL, 'DUF4920', NULL, NULL, 21930, 9),
(268832, NULL, 'PF14023', NULL, NULL, 'Protein of unknown function (DUF4239)', NULL, 'DUF4239', NULL, NULL, 22358, 9),
(268833, NULL, 'PF15229', NULL, NULL, 'POM121 family', NULL, 'POM121', NULL, NULL, NULL, 9),
(268834, NULL, 'PF16237', NULL, NULL, 'Domain of unknown function (DUF4896)', NULL, 'DUF4896', NULL, NULL, 24046, 9),
(268835, NULL, 'PF06043', NULL, NULL, 'Reovirus P9-like family', NULL, 'Reo_P9', NULL, NULL, 13669, 9),
(268836, NULL, 'PF06517', NULL, NULL, 'Orthopoxvirus A43R protein', NULL, 'Orthopox_A43R', NULL, NULL, 9418, 9),
(268837, NULL, 'PF11675', NULL, NULL, 'Protein of unknown function (DUF3271)', NULL, 'DUF3271', NULL, NULL, 19466, 9),
(268838, NULL, 'PF12710', NULL, NULL, 'haloacid dehalogenase-like hydrolase', NULL, 'HAD', NULL, NULL, NULL, 9),
(268839, NULL, 'PF09723', NULL, NULL, 'Zinc ribbon domain', NULL, 'Zn-ribbon_8', NULL, NULL, 9386, 9),
(268840, NULL, 'PF20610', NULL, NULL, 'Thioester domain', NULL, 'TED_2', NULL, NULL, 33759, 9),
(268841, NULL, 'PF20608', NULL, NULL, 'Phage tail tube protein C-terminal domain', NULL, 'Phage_tube_C', NULL, NULL, 33531, 9),
(268842, NULL, 'PF18022', NULL, NULL, 'Ricin-type beta-trefoil lectin C-terminal domain', NULL, 'Lectin_C_term', NULL, NULL, NULL, 9),
(268843, NULL, 'PF20541', NULL, NULL, 'Family of unknown function (DUF6756)', NULL, 'DUF6756', NULL, NULL, 33804, 9),
(268844, NULL, 'PF19143', NULL, NULL, 'OMP85 superfamily', NULL, 'Omp85_2', NULL, NULL, 34290, 9),
(268845, NULL, 'PF12132', NULL, NULL, 'Protein of unknown function (DUF3587)', NULL, 'DUF3587', NULL, NULL, 20450, 9),
(268846, NULL, 'PF00568', NULL, NULL, 'WH1 domain', NULL, 'WH1', NULL, NULL, 3602, 9),
(268847, NULL, 'PF11493', NULL, NULL, 'Thylakoid soluble phosphoprotein TSP9', NULL, 'TSP9', NULL, NULL, 18828, 9),
(268848, NULL, 'PF17126', NULL, NULL, 'RsmF rRNA methyltransferase first C-terminal domain', NULL, 'RsmF_methylt_CI', NULL, NULL, 26488, 9),
(268849, NULL, 'PF13495', NULL, NULL, 'Phage integrase, N-terminal SAM-like domain', NULL, 'Phage_int_SAM_4', NULL, NULL, 1799, 9),
(268850, NULL, 'PF09584', NULL, NULL, 'Phage shock protein PspD (Phageshock_PspD)', NULL, 'Phageshock_PspD', NULL, NULL, 9790, 9),
(268851, NULL, 'PF01117', NULL, NULL, 'Aerolysin toxin', NULL, 'Aerolysin', NULL, NULL, 5581, 9),
(268852, NULL, 'PF03485', NULL, NULL, 'Arginyl tRNA synthetase N terminal domain', NULL, 'Arg_tRNA_synt_N', NULL, NULL, 4226, 9),
(268853, NULL, 'PF00128', NULL, NULL, 'Alpha amylase, catalytic domain', NULL, 'Alpha-amylase', NULL, NULL, 2899, 9),
(268854, NULL, 'PF03021', NULL, NULL, 'Influenza C virus M2 protein', NULL, 'CM2', NULL, NULL, 3919, 9),
(268855, NULL, 'PF18819', NULL, NULL, 'Phage MuF-C-terminal domain', NULL, 'MuF_C', NULL, NULL, 28700, 9),
(268856, NULL, 'PF01557', NULL, NULL, 'Fumarylacetoacetate (FAA) hydrolase family', NULL, 'FAA_hydrolase', NULL, NULL, 18005, 9),
(268857, NULL, 'PF19735', NULL, NULL, 'Family of unknown function (DUF6225)', NULL, 'DUF6225', NULL, NULL, 34489, 9),
(268858, NULL, 'PF14837', NULL, NULL, 'Integrator complex subunit 5 N-terminus', NULL, 'INTS5_N', NULL, NULL, 26732, 9),
(268859, NULL, 'PF18192', NULL, NULL, 'DNTTIP1 dimerisation domain', NULL, 'DNTTIP1_dimer', NULL, NULL, 29198, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(268860, NULL, 'PF14114', NULL, NULL, 'Domain of unknown function (DUF4286)', NULL, 'DUF4286', NULL, NULL, 23243, 9),
(268861, NULL, 'PF19224', NULL, NULL, 'pATOM36 family', NULL, 'pATOM36', NULL, NULL, 35183, 9),
(268862, NULL, 'PF03044', NULL, NULL, 'Herpesvirus UL16/UL94 family', NULL, 'Herpes_UL16', NULL, NULL, 4915, 9),
(268863, NULL, 'PF16594', NULL, NULL, 'Putative AtpZ or ATP-synthase-associated', NULL, 'ATP-synt_Z', NULL, NULL, 26748, 9),
(268864, NULL, 'PF18511', NULL, NULL, 'F-box', NULL, 'F-box_5', NULL, NULL, 30144, 9),
(268865, NULL, 'PF14182', NULL, NULL, 'YgaB-like protein', NULL, 'YgaB', NULL, NULL, 24274, 9),
(268866, NULL, 'PF12338', NULL, NULL, 'Ribulose-1,5-bisphosphate carboxylase small subunit', NULL, 'RbcS', NULL, NULL, 21290, 9),
(268867, NULL, 'PF18643', NULL, NULL, 'BsaWI restriction endonuclease type 2', NULL, 'RE_BsaWI', NULL, NULL, 29916, 9),
(268868, NULL, 'PF04318', NULL, NULL, 'Protein of unknown function (DUF468)', NULL, 'DUF468', NULL, NULL, 3628, 9),
(268869, NULL, 'PF07881', NULL, NULL, 'L-fucose isomerase, first N-terminal domain', NULL, 'Fucose_iso_N1', NULL, NULL, 13066, 9),
(268870, NULL, 'PF17991', NULL, NULL, 'Thioredoxin like C-terminal domain', NULL, 'Thioredoxin_10', NULL, NULL, 31318, 9),
(268871, NULL, 'PF03761', NULL, NULL, 'Nematode trypsin-6-like family', NULL, 'DUF316', NULL, NULL, 1976, 9),
(268872, NULL, 'PF19187', NULL, NULL, 'PafC helix-turn-helix domain', NULL, 'HTH_PafC', NULL, NULL, 35081, 9),
(268873, NULL, 'PF19316', NULL, NULL, 'GPI ethanolamine phosphate transferase membrane region', NULL, 'PIGO_PIGG', NULL, NULL, 36104, 9),
(268874, NULL, 'PF00579', NULL, NULL, 'tRNA synthetases class I (W and Y)', NULL, 'tRNA-synt_1b', NULL, NULL, 6313, 9),
(268875, NULL, 'PF18986', NULL, NULL, 'Family of unknown function (DUF5719)', NULL, 'DUF5719', NULL, NULL, 35569, 9),
(268876, NULL, 'PF06373', NULL, NULL, 'Cocaine and amphetamine regulated transcript protein (CART)', NULL, 'CART', NULL, NULL, 7522, 9),
(268877, NULL, 'PF12926', NULL, NULL, 'Mitotic-spindle organizing gamma-tubulin ring associated', NULL, 'MOZART2', NULL, NULL, 24516, 9),
(268878, NULL, 'PF07243', NULL, NULL, 'Phlebovirus glycoprotein G1', NULL, 'Phlebovirus_G1', NULL, NULL, 11307, 9),
(268879, NULL, 'PF13335', NULL, NULL, 'Magnesium chelatase, subunit ChlI C-terminal', NULL, 'Mg_chelatase_C', NULL, NULL, 26085, 9),
(268880, NULL, 'PF13479', NULL, NULL, 'AAA domain', NULL, 'AAA_24', NULL, NULL, NULL, 9),
(268881, NULL, 'PF06762', NULL, NULL, 'Lipase maturation factor', NULL, 'LMF1', NULL, NULL, 1792, 9),
(268882, NULL, 'PF06849', NULL, NULL, 'Protein of unknown function (DUF1246)', NULL, 'DUF1246', NULL, NULL, 9256, 9),
(268883, NULL, 'PF07730', NULL, NULL, 'Histidine kinase', NULL, 'HisKA_3', NULL, NULL, 8277, 9),
(268884, NULL, 'PF20590', NULL, NULL, 'Domain of unknown function (DUF6791)', NULL, 'DUF6791', NULL, NULL, 37500, 9),
(268885, NULL, 'PF20206', NULL, NULL, 'Tra1 HEAT repeat ring region', NULL, 'Tra1_ring', NULL, NULL, 37604, 9),
(268886, NULL, 'PF02639', NULL, NULL, 'Uncharacterized BCR, YaiI/YqxD family COG1671', NULL, 'DUF188', NULL, NULL, 6168, 9),
(268887, NULL, 'PF07010', NULL, NULL, 'Endomucin', NULL, 'Endomucin', NULL, NULL, 9572, 9),
(268888, NULL, 'PF07091', NULL, NULL, 'Ribosomal RNA methyltransferase (FmrO)', NULL, 'FmrO', NULL, NULL, 24771, 9),
(268889, NULL, 'PF10888', NULL, NULL, 'Protein of unknown function (DUF2742)', NULL, 'DUF2742', NULL, NULL, 23694, 9),
(268890, NULL, 'PF12716', NULL, NULL, 'Nuclear pore assembly and biogenesis', NULL, 'Apq12', NULL, NULL, 26686, 9),
(268891, NULL, 'PF10983', NULL, NULL, 'Protein of unknown function (DUF2793)', NULL, 'DUF2793', NULL, NULL, 17765, 9),
(268892, NULL, 'PF06626', NULL, NULL, 'Protein of unknown function (DUF1152)', NULL, 'DUF1152', NULL, NULL, 8308, 9),
(268893, NULL, 'PF16133', NULL, NULL, 'Domain of unknown function (DUF4844)', NULL, 'DUF4844', NULL, NULL, 23349, 9),
(268894, NULL, 'PF07200', NULL, NULL, 'Modifier of rudimentary (Mod(r)) protein', NULL, 'Mod_r', NULL, NULL, 14315, 9),
(268895, NULL, 'PF04532', NULL, NULL, 'Protein of unknown function (DUF587)', NULL, 'DUF587', NULL, NULL, 2972, 9);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(268896, NULL, 'PF17183', NULL, NULL, 'Get5 carboxyl domain', NULL, 'Blt1_C', NULL, NULL, NULL, 9),
(268897, NULL, 'PF19033', NULL, NULL, 'Intu longin-like domain 3', NULL, 'Intu_longin_3', NULL, NULL, 35837, 9),
(268898, NULL, 'PF00742', NULL, NULL, 'Homoserine dehydrogenase', NULL, 'Homoserine_dh', NULL, NULL, 7208, 9),
(268899, NULL, 'PF19110', NULL, NULL, 'Family of unknown function (DUF5797)', NULL, 'DUF5797', NULL, NULL, 35777, 9),
(268900, NULL, 'PF02378', NULL, NULL, 'Phosphotransferase system, EIIC', NULL, 'PTS_EIIC', NULL, NULL, 4404, 9),
(268901, NULL, 'PF04901', NULL, NULL, 'Receptor activity modifying family', NULL, 'RAMP', NULL, NULL, 5620, 9),
(268902, NULL, 'PF05632', NULL, NULL, 'Borrelia burgdorferi protein of unknown function (DUF792)', NULL, 'DUF792', NULL, NULL, 12998, 9),
(268903, NULL, 'PF15948', NULL, NULL, 'Domain of unknown function (DUF4756)', NULL, 'DUF4756', NULL, NULL, 22415, 9),
(268904, NULL, 'PF08845', NULL, NULL, 'Toxin SymE, type I toxin-antitoxin system', NULL, 'SymE_toxin', NULL, NULL, 14093, 9),
(268905, NULL, 'PF19106', NULL, NULL, 'Family of unknown function (DUF5793)', NULL, 'DUF5793', NULL, NULL, 35812, 9),
(268906, NULL, 'PF12537', NULL, NULL, 'The Golgi pH Regulator (GPHR) Family N-terminal', NULL, 'GPHR_N', NULL, NULL, 14598, 9),
(268907, NULL, 'PF19858', NULL, NULL, 'Bacterial oxidoreductases, C-terminal', NULL, 'OxRdtase_C', NULL, NULL, 37135, 9),
(268908, NULL, 'PF00692', NULL, NULL, 'dUTPase', NULL, 'dUTPase', NULL, NULL, 21896, 9),
(268909, NULL, 'PF00770', NULL, NULL, 'Adenovirus endoprotease', NULL, 'Peptidase_C5', NULL, NULL, 444, 9),
(268910, NULL, 'PF07349', NULL, NULL, 'Protein of unknown function (DUF1478)', NULL, 'DUF1478', NULL, NULL, 8376, 9),
(268911, NULL, 'PF10126', NULL, NULL, 'Uncharacterized protein, homolog of nitrogen regulatory protein PII', NULL, 'Nit_Regul_Hom', NULL, NULL, 19993, 9),
(268912, NULL, 'PF08725', NULL, NULL, 'Integrin beta cytoplasmic domain', NULL, 'Integrin_b_cyt', NULL, NULL, 11835, 9),
(268913, NULL, 'PF01585', NULL, NULL, 'G-patch domain', NULL, 'G-patch', NULL, NULL, 6576, 9),
(268914, NULL, 'PF19155', NULL, NULL, 'Family of unknown function (DUF5837)', NULL, 'DUF5837', NULL, NULL, 35895, 9),
(268915, NULL, 'PF04352', NULL, NULL, 'ProQ/FINO family', NULL, 'ProQ', NULL, NULL, 11256, 9),
(268916, NULL, 'PF17455', NULL, NULL, 'Late transcription unit B', NULL, 'LtuB', NULL, NULL, 20051, 9),
(268917, NULL, 'PF05879', NULL, NULL, 'Root hair defective 3 GTP-binding protein (RHD3) GTPase domain', NULL, 'RHD3_GTPase', NULL, NULL, NULL, 9),
(268918, NULL, 'PF17888', NULL, NULL, 'Carmil pleckstrin homology domain', NULL, 'Carm_PH', NULL, NULL, 29170, 9),
(268919, NULL, 'PF02373', NULL, NULL, 'JmjC domain, hydroxylase', NULL, 'JmjC', NULL, NULL, 4389, 9),
(268920, NULL, 'PF07178', NULL, NULL, 'TraL protein', NULL, 'TraL', NULL, NULL, 13325, 9),
(268921, NULL, 'PF02366', NULL, NULL, 'Dolichyl-phosphate-mannose-protein mannosyltransferase', NULL, 'PMT', NULL, NULL, 4272, 9),
(268922, NULL, 'PF08620', NULL, NULL, 'RPAP1-like, C-terminal', NULL, 'RPAP1_C', NULL, NULL, 14022, 9),
(268923, NULL, 'PF18782', NULL, NULL, 'Novel AID APOBEC clade 2', NULL, 'NAD2', NULL, NULL, NULL, 9),
(268924, NULL, 'PF15224', NULL, NULL, 'Scrapie-responsive protein 1', NULL, 'SCRG1', NULL, NULL, 25442, 9),
(268925, NULL, 'PF12726', NULL, NULL, 'SEN1 N terminal', NULL, 'SEN1_N', NULL, NULL, 22776, 9),
(268926, NULL, 'PF18102', NULL, NULL, 'Deltex C-terminal domain', NULL, 'DTC', NULL, NULL, 33483, 9),
(268927, NULL, 'PF16626', NULL, NULL, 'Linking region between Kunitz_BPTI and I-set on papilin', NULL, 'Papilin_u7', NULL, NULL, NULL, 9),
(268928, NULL, 'PF06503', NULL, NULL, 'Protein of unknown function (DUF1101)', NULL, 'DUF1101', NULL, NULL, 12424, 9),
(268929, NULL, 'PF15304', NULL, NULL, 'A-kinase anchor protein 2 C-terminus', NULL, 'AKAP2_C', NULL, NULL, 24926, 9),
(268930, NULL, 'PF18121', NULL, NULL, 'TFA2 Winged helix domain 2', NULL, 'TFA2_Winged_2', NULL, NULL, 27790, 9),
(268931, NULL, 'PF02655', NULL, NULL, 'ATP-grasp domain', NULL, 'ATP-grasp_3', NULL, NULL, 6371, 9);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(268932, NULL, 'PF05166', NULL, NULL, 'YcgL domain', NULL, 'YcgL', NULL, NULL, 24202, 9),
(268933, NULL, 'PF11899', NULL, NULL, 'Protein of unknown function (DUF3419)', NULL, 'DUF3419', NULL, NULL, 19797, 9),
(268934, NULL, 'PF11325', NULL, NULL, 'Domain of unknown function (DUF3127)', NULL, 'DUF3127', NULL, NULL, 18003, 9),
(268935, NULL, 'PF09844', NULL, NULL, 'Uncharacterized conserved protein (COG2071)', NULL, 'DUF2071', NULL, NULL, 16818, 9),
(268936, NULL, 'PF18493', NULL, NULL, 'Domain of unknown function (DUF5617)', NULL, 'DUF5617', NULL, NULL, 29102, 9),
(268937, NULL, 'PF03211', NULL, NULL, 'Pectate lyase', NULL, 'Pectate_lyase', NULL, NULL, 1743, 9),
(268938, NULL, 'PF05748', NULL, NULL, 'Rubella membrane glycoprotein E1', NULL, 'Rubella_E1', NULL, NULL, 13554, 9),
(268939, NULL, 'PF12925', NULL, NULL, 'E2 domain of amyloid precursor protein', NULL, 'APP_E2', NULL, NULL, 24890, 9),
(268940, NULL, 'PF01537', NULL, NULL, 'Herpesvirus glycoprotein D/GG/GX domain', NULL, 'Herpes_glycop_D', NULL, NULL, 6424, 9),
(268941, NULL, 'PF11054', NULL, NULL, 'Sporozoite TA4 surface antigen', NULL, 'Surface_antigen', NULL, NULL, 17695, 9),
(268942, NULL, 'PF05856', NULL, NULL, 'ARP2/3 complex 20 kDa subunit (ARPC4)', NULL, 'ARPC4', NULL, NULL, 7598, 9),
(268943, NULL, 'PF08938', NULL, NULL, 'HBS1 N-terminus', NULL, 'HBS1_N', NULL, NULL, 7683, 9),
(268944, NULL, 'PF07986', NULL, NULL, 'Tubulin binding cofactor C', NULL, 'TBCC', NULL, NULL, 8038, 9),
(268945, NULL, 'PF12478', NULL, NULL, 'Ubiquitin-associated protein 2', NULL, 'DUF3697', NULL, NULL, 20914, 9),
(268946, NULL, 'PF16803', NULL, NULL, 'Fe-S cluster assembly protein DRE2 N-terminus', NULL, 'DRE2_N', NULL, NULL, 22010, 9),
(268947, NULL, 'PF02909', NULL, NULL, 'Tetracyclin repressor-like, C-terminal domain', NULL, 'TetR_C_1', NULL, NULL, 1688, 9),
(268948, NULL, 'PF08536', NULL, NULL, 'Whirly transcription factor', NULL, 'Whirly', NULL, NULL, 7946, 9),
(268949, NULL, 'PF20374', NULL, NULL, 'Family of unknown function (DUF6669)', NULL, 'DUF6669', NULL, NULL, 33647, 9),
(268950, NULL, 'PF09879', NULL, NULL, 'Predicted membrane protein (DUF2106)', NULL, 'DUF2106', NULL, NULL, 10228, 9),
(268951, NULL, 'PF11947', NULL, NULL, 'Photosynthesis affected mutant 68', NULL, 'DUF3464', NULL, NULL, 19978, 9),
(268952, NULL, 'PF17171', NULL, NULL, 'Glutathione S-transferase, C-terminal domain', NULL, 'GST_C_6', NULL, NULL, 28007, 9),
(268953, NULL, 'PF01052', NULL, NULL, 'Type III flagellar switch regulator (C-ring) FliN C-term', NULL, 'FliMN_C', NULL, NULL, 5627, 9),
(268954, NULL, 'PF13344', NULL, NULL, 'Haloacid dehalogenase-like hydrolase', NULL, 'Hydrolase_6', NULL, NULL, 4516, 9),
(268955, NULL, 'PF06155', NULL, NULL, 'Gamma-butyrobetaine hydroxylase-like, N-terminal', NULL, 'GBBH-like_N', NULL, NULL, 9378, 9),
(268956, NULL, 'PF06391', NULL, NULL, 'CDK-activating kinase assembly factor MAT1', NULL, 'MAT1', NULL, NULL, 7085, 9),
(268957, NULL, 'PF07725', NULL, NULL, 'Leucine Rich Repeat', NULL, 'LRR_3', NULL, NULL, 8385, 9),
(268958, NULL, 'PF00884', NULL, NULL, 'Sulfatase', NULL, 'Sulfatase', NULL, NULL, 3038, 9),
(268959, NULL, 'PF14338', NULL, NULL, 'Mrr N-terminal domain', NULL, 'Mrr_N', NULL, NULL, 22480, 9),
(268960, NULL, 'PF15090', NULL, NULL, 'Domain of unknown function (DUF4553)', NULL, 'DUF4553', NULL, NULL, 24662, 9),
(268961, NULL, 'PF16091', NULL, NULL, 'Domain of unknown function (DUF4820)', NULL, 'DUF4820', NULL, NULL, 26235, 9),
(268962, NULL, 'PF19320', NULL, NULL, 'Galactofuranosyltransferase-2, domain 3', NULL, 'GlfT2_domain3', NULL, NULL, 36494, 9),
(268963, NULL, 'PF04891', NULL, NULL, 'NifQ', NULL, 'NifQ', NULL, NULL, 5640, 9),
(268964, NULL, 'PF15388', NULL, NULL, 'Protein Family FAM117', NULL, 'FAM117', NULL, NULL, 23660, 9),
(268965, NULL, 'PF19365', NULL, NULL, 'Family of unknown function (DUF5941)', NULL, 'DUF5941', NULL, NULL, 36561, 9),
(268966, NULL, 'PF18321', NULL, NULL, '3-hydroxybutyryl-CoA dehydrogenase reduced Rossmann-fold domain', NULL, '3HCDH_RFF', NULL, NULL, 29228, 9),
(268967, NULL, 'PF20000', NULL, NULL, 'FtsH ternary system domain X2', NULL, 'fvmX2', NULL, NULL, 35714, 9);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(268968, NULL, 'PF04922', NULL, NULL, 'DIE2/ALG10 family', NULL, 'DIE2_ALG10', NULL, NULL, 17355, 9),
(268969, NULL, 'PF05290', NULL, NULL, 'Baculovirus immediate-early protein (IE-0)', NULL, 'Baculo_IE-1', NULL, NULL, 4289, 9),
(268970, NULL, 'PF17139', NULL, NULL, 'Domain of unknown function (DUF5112)', NULL, 'DUF5112', NULL, NULL, 32840, 9),
(268971, NULL, 'PF06663', NULL, NULL, 'Connector enhancer of kinase suppressor of ras 2/3 domain', NULL, 'CNK2_3_dom', NULL, NULL, 8432, 9),
(268972, NULL, 'PF18189', NULL, NULL, 'TbRIF5 SNase domain 2', NULL, 'RIF5_SNase_2', NULL, NULL, 31655, 9),
(268973, NULL, 'PF18977', NULL, NULL, 'Family of unknown function (DUF5713)', NULL, 'DUF5713', NULL, NULL, 35966, 9),
(268974, NULL, 'PF09295', NULL, NULL, 'ChAPs (Chs5p-Arf1p-binding proteins)', NULL, 'ChAPs', NULL, NULL, 14396, 9),
(268975, NULL, 'PF01080', NULL, NULL, 'Presenilin', NULL, 'Presenilin', NULL, NULL, 5281, 9),
(268976, NULL, 'PF11322', NULL, NULL, 'Protein of unknown function (DUF3124)', NULL, 'DUF3124', NULL, NULL, 18154, 9),
(268977, NULL, 'PF14530', NULL, NULL, 'Domain of unknown function (DUF4439)', NULL, 'DUF4439', NULL, NULL, 25999, 9),
(268978, NULL, 'PF20330', NULL, NULL, 'Family of unknown function (DUF6625)', NULL, 'DUF6625', NULL, NULL, 37121, 9),
(268979, NULL, 'PF09076', NULL, NULL, 'Beta/Gamma crystallin', NULL, 'Crystall_2', NULL, NULL, 9643, 9),
(268980, NULL, 'PF07918', NULL, NULL, 'CAP160 repeat', NULL, 'CAP160', NULL, NULL, 13429, 9),
(268981, NULL, 'PF09645', NULL, NULL, 'F-112 protein', NULL, 'F-112', NULL, NULL, 15589, 9),
(268982, NULL, 'PF03469', NULL, NULL, 'XH domain', NULL, 'XH', NULL, NULL, 6329, 9),
(268983, NULL, 'PF16582', NULL, NULL, 'Middle domain of thiamine pyrophosphate', NULL, 'TPP_enzyme_M_2', NULL, NULL, 24220, 9),
(268984, NULL, 'PF05417', NULL, NULL, 'Hepatitis E cysteine protease', NULL, 'Peptidase_C41', NULL, NULL, 12222, 9),
(268985, NULL, 'PF10384', NULL, NULL, 'Centromere protein Scm3', NULL, 'Scm3', NULL, NULL, 21233, 9),
(268986, NULL, 'PF08477', NULL, NULL, 'Ras of Complex, Roc, domain of DAPkinase', NULL, 'Roc', NULL, NULL, NULL, 9),
(268987, NULL, 'PF16231', NULL, NULL, 'Domain of unknown function (DUF4890)', NULL, 'DUF4890', NULL, NULL, 26131, 9),
(268988, NULL, 'PF03489', NULL, NULL, 'Saposin-like type B, region 2', NULL, 'SapB_2', NULL, NULL, 7147, 9),
(268989, NULL, 'PF04892', NULL, NULL, 'VanZ like family', NULL, 'VanZ', NULL, NULL, 5993, 9),
(268990, NULL, 'PF13795', NULL, NULL, 'HupE / UreJ protein', NULL, 'HupE_UreJ_2', NULL, NULL, 21942, 9),
(268991, NULL, 'PF18332', NULL, NULL, 'Exoribonuclease Xrn1 D1 domain', NULL, 'XRN1_D1', NULL, NULL, 28752, 9),
(268992, NULL, 'PF07082', NULL, NULL, 'Protein of unknown function (DUF1350)', NULL, 'DUF1350', NULL, NULL, 10718, 9),
(268993, NULL, 'PF05622', NULL, NULL, 'HOOK protein coiled-coil region', NULL, 'HOOK', NULL, NULL, 14038, 9),
(268994, NULL, 'PF17261', NULL, NULL, 'Family of unknown function (DUF5327)', NULL, 'DUF5327', NULL, NULL, 18962, 9),
(268995, NULL, 'PF19599', NULL, NULL, 'Family of unknown function (DUF6104)', NULL, 'DUF6104', NULL, NULL, 36602, 9),
(268996, NULL, 'PF08490', NULL, NULL, 'Domain of unknown function (DUF1744)', NULL, 'DUF1744', NULL, NULL, 13801, 9),
(268997, NULL, 'PF18250', NULL, NULL, 'Effector immunity protein Tgi2PP', NULL, 'Tgi2PP', NULL, NULL, 30133, 9),
(268998, NULL, 'PF03445', NULL, NULL, 'Putative nucleotidyltransferase DUF294', NULL, 'DUF294', NULL, NULL, 10866, 9),
(268999, NULL, 'PF17591', NULL, NULL, 'Herpesvirus UL41A', NULL, 'UL41A', NULL, NULL, 18838, 9),
(269000, NULL, 'PF03041', NULL, NULL, 'lef-2', NULL, 'Baculo_LEF-2', NULL, NULL, 4726, 9),
(269001, NULL, 'PF03200', NULL, NULL, 'Glycosyl hydrolase family 63 C-terminal domain', NULL, 'Glyco_hydro_63', NULL, NULL, 25669, 9),
(269002, NULL, 'PF14124', NULL, NULL, 'Domain of unknown function (DUF4291)', NULL, 'DUF4291', NULL, NULL, 24972, 9),
(269003, NULL, 'PF07389', NULL, NULL, 'Vaccinia B6 protein', NULL, 'Pox_B6', NULL, NULL, 8400, 9),
(269004, NULL, 'PF20519', NULL, NULL, 'Polycystin domain', NULL, 'Polycystin_dom', NULL, NULL, 33787, 9); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(269005, NULL, 'PF18056', NULL, NULL, 'Penicillin Binding Protein 3 Domain', NULL, 'PBP3', NULL, NULL, NULL, 9),
(269006, NULL, 'PF09624', NULL, NULL, 'Protein of unknown function (DUF2393)', NULL, 'DUF2393', NULL, NULL, 9052, 9),
(269007, NULL, 'PF19668', NULL, NULL, 'Family of unknown function (DUF6171)', NULL, 'DUF6171', NULL, NULL, 37166, 9),
(269008, NULL, 'PF16012', NULL, NULL, 'Domain of unknown function (DUF4780)', NULL, 'DUF4780', NULL, NULL, 21887, 9),
(269009, NULL, 'PF03007', NULL, NULL, 'Wax ester synthase-like Acyl-CoA acyltransferase domain', NULL, 'WES_acyltransf', NULL, NULL, 3517, 9),
(269010, NULL, 'PF12258', NULL, NULL, 'Microcephalin protein', NULL, 'Microcephalin', NULL, NULL, 25394, 9),
(269011, NULL, 'PF17178', NULL, NULL, 'Membrane-associated sensor', NULL, 'MASE5', NULL, NULL, 29368, 9),
(269012, NULL, 'PF18670', NULL, NULL, 'V-type ATPase subunit I, N-terminal domain', NULL, 'V_ATPase_I_N', NULL, NULL, 28531, 9),
(269013, NULL, 'PF03124', NULL, NULL, 'EXS family', NULL, 'EXS', NULL, NULL, 4691, 9),
(269014, NULL, 'PF09516', NULL, NULL, 'CfrBI restriction endonuclease', NULL, 'RE_CfrBI', NULL, NULL, 16865, 9),
(269015, NULL, 'PF10604', NULL, NULL, 'Polyketide cyclase / dehydrase and lipid transport', NULL, 'Polyketide_cyc2', NULL, NULL, 20287, 9),
(269016, NULL, 'PF18441', NULL, NULL, 'Hen1 La-motif C-terminal domain', NULL, 'Hen1_Lam_C', NULL, NULL, 29205, 9),
(269017, NULL, 'PF14806', NULL, NULL, 'Coatomer beta subunit appendage platform', NULL, 'Coatomer_b_Cpla', NULL, NULL, 26847, 9),
(269018, NULL, 'PF05985', NULL, NULL, 'Ethanolamine ammonia-lyase light chain (EutC)', NULL, 'EutC', NULL, NULL, 13604, 9),
(269019, NULL, 'PF09421', NULL, NULL, 'Frequency clock protein', NULL, 'FRQ', NULL, NULL, 15175, 9),
(269020, NULL, 'PF07096', NULL, NULL, 'Protein of unknown function (DUF1358)', NULL, 'DUF1358', NULL, NULL, 13064, 9),
(269021, NULL, 'PF12515', NULL, NULL, 'Ca2+-ATPase N terminal autoinhibitory domain', NULL, 'CaATP_NAI', NULL, NULL, 19956, 9),
(269022, NULL, 'PF09169', NULL, NULL, 'BRCA2, helical', NULL, 'BRCA-2_helical', NULL, NULL, 12417, 9),
(269023, NULL, 'PF08112', NULL, NULL, 'ATP synthase epsilon subunit', NULL, 'ATP-synt_E_2', NULL, NULL, 12986, 9),
(269024, NULL, 'PF01808', NULL, NULL, 'AICARFT/IMPCHase bienzyme', NULL, 'AICARFT_IMPCHas', NULL, NULL, 3950, 9),
(269025, NULL, 'PF12690', NULL, NULL, 'Intracellular proteinase inhibitor', NULL, 'BsuPI', NULL, NULL, 21119, 9),
(269026, NULL, 'PF17526', NULL, NULL, 'Family of unknown function (DUF5448)', NULL, 'DUF5448', NULL, NULL, 19507, 9),
(269027, NULL, 'PF00766', NULL, NULL, 'Electron transfer flavoprotein FAD-binding domain', NULL, 'ETF_alpha', NULL, NULL, 13434, 9),
(269028, NULL, 'PF02721', NULL, NULL, 'Domain of unknown function DUF223', NULL, 'DUF223', NULL, NULL, 4439, 9),
(269029, NULL, 'PF19659', NULL, NULL, 'Family of unknown function (DUF6162)', NULL, 'DUF6162', NULL, NULL, 37243, 9),
(269030, NULL, 'PF15449', NULL, NULL, 'Retinal protein', NULL, 'Retinal', NULL, NULL, 23211, 9),
(269031, NULL, 'PF18206', NULL, NULL, 'Porphyranase catalytic subdomain 1', NULL, 'Porphyrn_cat_1', NULL, NULL, 31757, 9),
(269032, NULL, 'PF19509', NULL, NULL, 'Family of unknown function (DUF6043)', NULL, 'DUF6043', NULL, NULL, 37050, 9),
(269033, NULL, 'PF16116', NULL, NULL, 'Domain of unknown function (DUF4832)', NULL, 'DUF4832', NULL, NULL, 26088, 9),
(269034, NULL, 'PF17555', NULL, NULL, 'Type VI secretion system, TssN', NULL, 'TssN', NULL, NULL, 32599, 9),
(269035, NULL, 'PF17642', NULL, NULL, 'Hemolysin coregulated protein Hcp (TssD)', NULL, 'TssD', NULL, NULL, 30076, 9),
(269036, NULL, 'PF20395', NULL, NULL, 'C-terminal domain 3 of the ABC-three component (ABC-3C) systems', NULL, 'CTD3', NULL, NULL, 34104, 9),
(269037, NULL, 'PF16021', NULL, NULL, 'Programmed cell death protein 7', NULL, 'PDCD7', NULL, NULL, 22583, 9),
(269038, NULL, 'PF09585', NULL, NULL, 'Conserved hypothetical protein (Lin0512_fam)', NULL, 'Lin0512_fam', NULL, NULL, 10607, 9),
(269039, NULL, 'PF07323', NULL, NULL, 'Protein of unknown function (DUF1465)', NULL, 'DUF1465', NULL, NULL, 11529, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(269040, NULL, 'PF12747', NULL, NULL, 'DdrB-like protein', NULL, 'DdrB', NULL, NULL, 20541, 9),
(269041, NULL, 'PF17986', NULL, NULL, 'EMP3-KAHRP-like N-terminal domain', NULL, 'EKAL', NULL, NULL, 29314, 9),
(269042, NULL, 'PF16865', NULL, NULL, 'Glutathione S-transferase, C-terminal domain', NULL, 'GST_C_5', NULL, NULL, 30181, 9),
(269043, NULL, 'PF18247', NULL, NULL, 'Flax-rust effector AvrM N-terminal domain', NULL, 'AvrM_N', NULL, NULL, 29008, 9),
(269044, NULL, 'PF03020', NULL, NULL, 'LEM domain', NULL, 'LEM', NULL, NULL, 4115, 9),
(269045, NULL, 'PF07784', NULL, NULL, 'Protein of unknown function (DUF1622)', NULL, 'DUF1622', NULL, NULL, 13174, 9),
(269046, NULL, 'PF12065', NULL, NULL, 'Protein of unknown function (DUF3545)', NULL, 'DUF3545', NULL, NULL, 19773, 9),
(269047, NULL, 'PF14601', NULL, NULL, 'DNA_binding protein, TFX, C-term', NULL, 'TFX_C', NULL, NULL, 26758, 9),
(269048, NULL, 'PF19915', NULL, NULL, 'MoxR-vWA-beta-propeller ternary system domain bpX0', NULL, 'bpX0', NULL, NULL, 37077, 9),
(269049, NULL, 'PF06611', NULL, NULL, 'Protein of unknown function (DUF1145)', NULL, 'DUF1145', NULL, NULL, 9941, 9),
(269050, NULL, 'PF14066', NULL, NULL, 'Protein of unknown function (DUF4256)', NULL, 'DUF4256', NULL, NULL, 22592, 9),
(269051, NULL, 'PF01210', NULL, NULL, 'NAD-dependent glycerol-3-phosphate dehydrogenase N-terminus', NULL, 'NAD_Gly3P_dh_N', NULL, NULL, 9757, 9),
(269052, NULL, 'PF13862', NULL, NULL, 'BCCIP', NULL, 'BCCIP', NULL, NULL, 24775, 9),
(269053, NULL, 'PF00578', NULL, NULL, 'AhpC/TSA family', NULL, 'AhpC-TSA', NULL, NULL, 615, 9),
(269054, NULL, 'PF14890', NULL, NULL, 'Intein splicing domain', NULL, 'Intein_splicing', NULL, NULL, NULL, 9),
(269055, NULL, 'PF08476', NULL, NULL, 'Viral D10 N-terminal', NULL, 'VD10_N', NULL, NULL, 13845, 9),
(269056, NULL, 'PF15714', NULL, NULL, 'Stage V sporulation protein T C-terminal, transcription factor', NULL, 'SpoVT_C', NULL, NULL, NULL, 9),
(269057, NULL, 'PF08612', NULL, NULL, 'TATA-binding related factor (TRF) of subunit 20 of Mediator complex', NULL, 'Med20', NULL, NULL, 14317, 9),
(269058, NULL, 'PF15849', NULL, NULL, 'Domain of unknown function (DUF4722)', NULL, 'DUF4722', NULL, NULL, 21794, 9),
(269059, NULL, 'PF01192', NULL, NULL, 'RNA polymerase Rpb6', NULL, 'RNA_pol_Rpb6', NULL, NULL, 10197, 9),
(269060, NULL, 'PF16575', NULL, NULL, 'mRNA cleavage and polyadenylation factor CLP1 P-loop', NULL, 'CLP1_P', NULL, NULL, 25238, 9),
(269061, NULL, 'PF04185', NULL, NULL, 'Phosphoesterase family', NULL, 'Phosphoesterase', NULL, NULL, 4828, 9),
(269062, NULL, 'PF07972', NULL, NULL, 'NrdI Flavodoxin like', NULL, 'Flavodoxin_NdrI', NULL, NULL, 7443, 9),
(269063, NULL, 'PF17068', NULL, NULL, 'Required for respiratory growth protein 8 mitochondrial', NULL, 'RRG8', NULL, NULL, 23693, 9),
(269064, NULL, 'PF11860', NULL, NULL, 'N-acetylmuramidase', NULL, 'Muramidase', NULL, NULL, 22350, 9),
(269065, NULL, 'PF14481', NULL, NULL, 'Type 4 fimbrial biogenesis protein PilY2', NULL, 'Fimbrial_PilY2', NULL, NULL, 23376, 9),
(269066, NULL, 'PF08584', NULL, NULL, 'Ribonuclease P 40kDa (Rpp40) subunit', NULL, 'Ribonuc_P_40', NULL, NULL, 17856, 9),
(269067, NULL, 'PF13186', NULL, NULL, 'Iron-sulfur cluster-binding domain', NULL, 'SPASM', NULL, NULL, 17795, 9),
(269068, NULL, 'PF18831', NULL, NULL, 'Leucine-rich repeat', NULL, 'LRR_11', NULL, NULL, 29501, 9),
(269069, NULL, 'PF02153', NULL, NULL, 'Prephenate dehydrogenase, nucleotide-binding domain', NULL, 'PDH_N', NULL, NULL, 34020, 9),
(269070, NULL, 'PF13687', NULL, NULL, 'Domain of unknown function (DUF4153)', NULL, 'DUF4153', NULL, NULL, 23284, 9),
(269071, NULL, 'PF17403', NULL, NULL, 'Nrap protein PAP/OAS-like domain', NULL, 'Nrap_D2', NULL, NULL, 30992, 9),
(269072, NULL, 'PF12162', NULL, NULL, 'STAT1 TAZ2 binding domain', NULL, 'STAT1_TAZ2bind', NULL, NULL, 17215, 9),
(269073, NULL, 'PF13814', NULL, NULL, 'Replication-relaxation', NULL, 'Replic_Relax', NULL, NULL, 24370, 9),
(269074, NULL, 'PF18024', NULL, NULL, 'Helix-turn-helix domain', NULL, 'HTH_50', NULL, NULL, 25035, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(269075, NULL, 'PF19808', NULL, NULL, 'Family of unknown function (DUF6291)', NULL, 'DUF6291', NULL, NULL, 37293, 9),
(269076, NULL, 'PF03573', NULL, NULL, 'outer membrane porin, OprD family', NULL, 'OprD', NULL, NULL, 5166, 9),
(269077, NULL, 'PF00764', NULL, NULL, 'Arginosuccinate synthase', NULL, 'Arginosuc_synth', NULL, NULL, 3432, 9),
(269078, NULL, 'PF10915', NULL, NULL, 'Protein of unknown function (DUF2709)', NULL, 'DUF2709', NULL, NULL, 24034, 9),
(269079, NULL, 'PF13041', NULL, NULL, 'PPR repeat family', NULL, 'PPR_2', NULL, NULL, 5826, 9),
(269080, NULL, 'PF03466', NULL, NULL, 'LysR substrate binding domain', NULL, 'LysR_substrate', NULL, NULL, 10664, 9),
(269081, NULL, 'PF13735', NULL, NULL, 'tRNA nucleotidyltransferase domain 2 putative', NULL, 'tRNA_NucTran2_2', NULL, NULL, 21797, 9),
(269082, NULL, 'PF10979', NULL, NULL, 'Protein of unknown function (DUF2786)', NULL, 'DUF2786', NULL, NULL, 24375, 9),
(269083, NULL, 'PF15462', NULL, NULL, 'Bartter syndrome, infantile, with sensorineural deafness (Barttin)', NULL, 'Barttin', NULL, NULL, 26507, 9),
(269084, NULL, 'PF14918', NULL, NULL, 'MDM2-binding', NULL, 'MTBP_N', NULL, NULL, 23759, 9),
(269085, NULL, 'PF01956', NULL, NULL, 'Integral membrane protein EMC3/TMCO1-like', NULL, 'EMC3_TMCO1', NULL, NULL, 4637, 9),
(269086, NULL, 'PF15357', NULL, NULL, 'Psoriasis susceptibility 1 candidate 1', NULL, 'SEEK1', NULL, NULL, 26734, 9),
(269087, NULL, 'PF15795', NULL, NULL, 'Ectodermal ciliogenesis protein', NULL, 'Spec3', NULL, NULL, 25578, 9),
(269088, NULL, 'PF11635', NULL, NULL, 'Mediator complex subunit 16', NULL, 'Med16', NULL, NULL, 18953, 9),
(269089, NULL, 'PF02362', NULL, NULL, 'B3 DNA binding domain', NULL, 'B3', NULL, NULL, 4130, 9),
(269090, NULL, 'PF05619', NULL, NULL, 'Borrelia burgdorferi protein of unknown function (DUF787)', NULL, 'DUF787', NULL, NULL, 12439, 9),
(269091, NULL, 'PF13188', NULL, NULL, 'PAS domain', NULL, 'PAS_8', NULL, NULL, 3787, 9),
(269092, NULL, 'PF09609', NULL, NULL, 'CRISPR-associated protein, GSU0054 family (Cas_GSU0054)', NULL, 'Cas_GSU0054', NULL, NULL, 16599, 9),
(269093, NULL, 'PF17700', NULL, NULL, 'Family of unknown function (DUF5546)', NULL, 'DUF5546', NULL, NULL, 28427, 9),
(269094, NULL, 'PF02881', NULL, NULL, 'SRP54-type protein, helical bundle domain', NULL, 'SRP54_N', NULL, NULL, 9380, 9),
(269095, NULL, 'PF02593', NULL, NULL, 'Domain of unknown function', NULL, 'DUF166', NULL, NULL, 2071, 9),
(269096, NULL, 'PF18543', NULL, NULL, 'Intracellular delivery domain', NULL, 'ID', NULL, NULL, 27309, 9),
(269097, NULL, 'PF16667', NULL, NULL, 'Unstructured region 10 on multiple PDZ protein', NULL, 'MPDZ_u10', NULL, NULL, 26362, 9),
(269098, NULL, 'PF04087', NULL, NULL, 'Domain of unknown function (DUF389)', NULL, 'DUF389', NULL, NULL, 11474, 9),
(269099, NULL, 'PF06064', NULL, NULL, 'Host-nuclease inhibitor protein Gam', NULL, 'Gam', NULL, NULL, 13923, 9),
(269100, NULL, 'PF18035', NULL, NULL, 'Bap31/Bap29 cytoplasmic coiled-coil domain', NULL, 'Bap31_Bap29_C', NULL, NULL, 30398, 9),
(269101, NULL, 'PF19607', NULL, NULL, 'Family of unknown function (DUF6112)', NULL, 'DUF6112', NULL, NULL, 36545, 9),
(269102, NULL, 'PF02626', NULL, NULL, 'Carboxyltransferase domain, subdomain A and B', NULL, 'CT_A_B', NULL, NULL, 3496, 9),
(269103, NULL, 'PF19132', NULL, NULL, 'Family of unknown function (DUF5815)', NULL, 'DUF5815', NULL, NULL, 34172, 9),
(269104, NULL, 'PF06206', NULL, NULL, 'CpeT/CpcT family (DUF1001)', NULL, 'CpeT', NULL, NULL, 9465, 9),
(269105, NULL, 'PF11495', NULL, NULL, 'Archaeal transcriptional regulator TrmB', NULL, 'Regulator_TrmB', NULL, NULL, 18825, 9),
(269106, NULL, 'PF07417', NULL, NULL, 'Sigma factor-binding transcriptional regulator Crl', NULL, 'Crl', NULL, NULL, 8250, 9),
(269107, NULL, 'PF03230', NULL, NULL, 'Antirestriction protein', NULL, 'Antirestrict', NULL, NULL, 1990, 9),
(269108, NULL, 'PF18244', NULL, NULL, 'Cellulose-binding protein CttA N-terminal domain', NULL, 'CttA_N', NULL, NULL, 28501, 9),
(269109, NULL, 'PF08445', NULL, NULL, 'FR47-like protein', NULL, 'FR47', NULL, NULL, 11573, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(269110, NULL, 'PF19539', NULL, NULL, 'Family of unknown function (DUF6063)', NULL, 'DUF6063', NULL, NULL, 36482, 9),
(269111, NULL, 'PF00262', NULL, NULL, 'Calreticulin family', NULL, 'Calreticulin', NULL, NULL, 3101, 9),
(269112, NULL, 'PF15858', NULL, NULL, 'Late cornified envelope protein 6A family', NULL, 'LCE6A', NULL, NULL, 25903, 9),
(269113, NULL, 'PF14826', NULL, NULL, 'FACT complex subunit SPT16 N-terminal lobe domain', NULL, 'FACT-Spt16_Nlob', NULL, NULL, 25863, 9),
(269114, NULL, 'PF15921', NULL, NULL, 'Coiled-coil domain-containing protein 158', NULL, 'CCDC158', NULL, NULL, 25602, 9),
(269115, NULL, 'PF02406', NULL, NULL, 'MmoB/DmpM family', NULL, 'MmoB_DmpM', NULL, NULL, 5329, 9),
(269116, NULL, 'PF05571', NULL, NULL, 'JNK1/MAPK8-associated membrane protein', NULL, 'JAMP', NULL, NULL, 12298, 9),
(269117, NULL, 'PF02316', NULL, NULL, 'Mu DNA-binding domain', NULL, 'HTH_Tnp_Mu_1', NULL, NULL, 4054, 9),
(269118, NULL, 'PF08769', NULL, NULL, 'Sporulation initiation factor Spo0A C terminal', NULL, 'Spo0A_C', NULL, NULL, 13022, 9),
(269119, NULL, 'PF20044', NULL, NULL, 'Family of unknown function (DUF6446)', NULL, 'DUF6446', NULL, NULL, 34427, 9),
(269120, NULL, 'PF08171', NULL, NULL, 'Mad3/BUB1 homology region 2', NULL, 'Mad3_BUB1_II', NULL, NULL, 9405, 9),
(269121, NULL, 'PF03788', NULL, NULL, 'LrgA family', NULL, 'LrgA', NULL, NULL, 1735, 9),
(269122, NULL, 'PF04833', NULL, NULL, 'COBRA-like protein', NULL, 'COBRA', NULL, NULL, 4903, 9),
(269123, NULL, 'PF09717', NULL, NULL, 'Plasmodium falciparum domain of unknown function (CPW_WPC)', NULL, 'CPW_WPC', NULL, NULL, 5501, 9),
(269124, NULL, 'PF02184', NULL, NULL, 'HAT (Half-A-TPR) repeat', NULL, 'HAT', NULL, NULL, 1301, 9),
(269125, NULL, 'PF01546', NULL, NULL, 'Peptidase family M20/M25/M40', NULL, 'Peptidase_M20', NULL, NULL, 6943, 9),
(269126, NULL, 'PF13206', NULL, NULL, 'Trypanosomal VSG domain', NULL, 'VSG_B', NULL, NULL, 24569, 9),
(269127, NULL, 'PF03970', NULL, NULL, 'Herpesvirus UL37 tegument protein', NULL, 'Herpes_UL37_1', NULL, NULL, 2529, 9),
(269128, NULL, 'PF11617', NULL, NULL, 'Putative metal-binding motif', NULL, 'Cu-binding_MopE', NULL, NULL, 18566, 9),
(269129, NULL, 'PF01784', NULL, NULL, 'NIF3 (NGG1p interacting factor 3)', NULL, 'NIF3', NULL, NULL, 2763, 9),
(269130, NULL, 'PF11456', NULL, NULL, 'Protein of unknown function (DUF3019)', NULL, 'DUF3019', NULL, NULL, 18872, 9),
(269131, NULL, 'PF16041', NULL, NULL, 'Domain of unknown function (DUF4793)', NULL, 'DUF4793', NULL, NULL, 25819, 9),
(269132, NULL, 'PF19907', NULL, NULL, 'Family of unknown function (DUF6380)', NULL, 'DUF6380', NULL, NULL, 36952, 9),
(269133, NULL, 'PF07853', NULL, NULL, 'Domain of unknown function (DUF1648)', NULL, 'DUF1648', NULL, NULL, 12297, 9),
(269134, NULL, 'PF08950', NULL, NULL, 'Protein of unknown function (DUF1861)', NULL, 'DUF1861', NULL, NULL, 7856, 9),
(269135, NULL, 'PF10061', NULL, NULL, 'Uncharacterized conserved protein (DUF2299)', NULL, 'DUF2299', NULL, NULL, 18408, 9),
(269136, NULL, 'PF18939', NULL, NULL, 'Family of unknown function (DUF5686)', NULL, 'DUF5686', NULL, NULL, 34160, 9),
(269137, NULL, 'PF06922', NULL, NULL, 'Citrus tristeza virus P13 protein', NULL, 'CTV_P13', NULL, NULL, 11955, 9),
(269138, NULL, 'PF07172', NULL, NULL, 'Glycine rich protein family', NULL, 'GRP', NULL, NULL, 10697, 9),
(269139, NULL, 'PF01257', NULL, NULL, 'Thioredoxin-like [2Fe-2S] ferredoxin', NULL, '2Fe-2S_thioredx', NULL, NULL, NULL, 9),
(269140, NULL, 'PF10719', NULL, NULL, 'Late competence development protein ComFB', NULL, 'ComFB', NULL, NULL, 20797, 9),
(269141, NULL, 'PF15118', NULL, NULL, 'Domain of unknown function (DUF4560)', NULL, 'DUF4560', NULL, NULL, 26460, 9),
(269142, NULL, 'PF02650', NULL, NULL, 'WhiA C-terminal HTH domain', NULL, 'HTH_WhiA', NULL, NULL, 15132, 9),
(269143, NULL, 'PF16372', NULL, NULL, 'Domain of unknown function (DUF4984)', NULL, 'DUF4984', NULL, NULL, 26247, 9),
(269144, NULL, 'PF08280', NULL, NULL, 'M protein trans-acting positive regulator (MGA) HTH domain', NULL, 'HTH_Mga', NULL, NULL, 17269, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(269145, NULL, 'PF00018', NULL, NULL, 'SH3 domain', NULL, 'SH3_1', NULL, NULL, 6232, 9),
(269146, NULL, 'PF02936', NULL, NULL, 'Cytochrome c oxidase subunit IV', NULL, 'COX4', NULL, NULL, 3000, 9),
(269147, NULL, 'PF16731', NULL, NULL, 'Glutamic acid/alanine-rich protein of Trypanosoma', NULL, 'GARP', NULL, NULL, 22868, 9),
(269148, NULL, 'PF15625', NULL, NULL, 'CC2D2A N-terminal C2 domain', NULL, 'CC2D2AN-C2', NULL, NULL, 25227, 9),
(269149, NULL, 'PF10431', NULL, NULL, 'C-terminal, D2-small domain, of ClpB protein', NULL, 'ClpB_D2-small', NULL, NULL, 18363, 9),
(269150, NULL, 'PF16775', NULL, NULL, 'Target recognition domain of lytic exoenzyme', NULL, 'ZoocinA_TRD', NULL, NULL, 23650, 9),
(269151, NULL, 'PF15771', NULL, NULL, 'Interactor of HORMAD1 protein 1', NULL, 'IHO1', NULL, NULL, 25243, 9),
(269152, NULL, 'PF18113', NULL, NULL, 'Rubredoxin binding C-terminal domain', NULL, 'Rbx_binding', NULL, NULL, 29473, 9),
(269153, NULL, 'PF06436', NULL, NULL, 'Pneumovirus matrix protein 2 (M2)', NULL, 'Pneumovirus_M2', NULL, NULL, 9402, 9),
(269154, NULL, 'PF12893', NULL, NULL, 'Putative lumazine-binding', NULL, 'Lumazine_bd_2', NULL, NULL, 33347, 9),
(269155, NULL, 'PF07511', NULL, NULL, 'Protein of unknown function (DUF1525)', NULL, 'DUF1525', NULL, NULL, 11107, 9),
(269156, NULL, 'PF04115', NULL, NULL, 'Ureidoglycolate lyase', NULL, 'Ureidogly_lyase', NULL, NULL, 6726, 9),
(269157, NULL, 'PF10995', NULL, NULL, 'Cellulose biosynthesis GIL', NULL, 'CBP_GIL', NULL, NULL, 18843, 9),
(269158, NULL, 'PF14266', NULL, NULL, 'Putative component of ''biosynthetic module''', NULL, 'YceG_bac', NULL, NULL, 24614, 9),
(269159, NULL, 'PF03792', NULL, NULL, 'PBC domain', NULL, 'PBC', NULL, NULL, 1748, 9),
(269160, NULL, 'PF01281', NULL, NULL, 'Ribosomal protein L9, N-terminal domain', NULL, 'Ribosomal_L9_N', NULL, NULL, 18697, 9),
(269161, NULL, 'PF11717', NULL, NULL, 'RNA binding activity-knot of a chromodomain', NULL, 'Tudor-knot', NULL, NULL, 17617, 9),
(269162, NULL, 'PF07350', NULL, NULL, 'Protein of unknown function (DUF1479)', NULL, 'DUF1479', NULL, NULL, 11616, 9),
(269163, NULL, 'PF11657', NULL, NULL, 'Transcriptional activator TraM', NULL, 'Activator-TraM', NULL, NULL, 21842, 9),
(269164, NULL, 'PF00435', NULL, NULL, 'Spectrin repeat', NULL, 'Spectrin', NULL, NULL, 2020, 9),
(269165, NULL, 'PF15642', NULL, NULL, 'Toxin in Odyssella and Amoebophilus', NULL, 'Tox-ODYAM1', NULL, NULL, 25292, 9),
(269166, NULL, 'PF03923', NULL, NULL, 'Uncharacterized lipoprotein', NULL, 'Lipoprotein_16', NULL, NULL, 2557, 9),
(269167, NULL, 'PF13444', NULL, NULL, 'Acetyltransferase (GNAT) domain', NULL, 'Acetyltransf_5', NULL, NULL, NULL, 9),
(269168, NULL, 'PF08086', NULL, NULL, 'Ergtoxin family', NULL, 'Toxin_17', NULL, NULL, 9601, 9),
(269169, NULL, 'PF14942', NULL, NULL, 'Organelle biogenesis, Muted-like protein', NULL, 'Muted', NULL, NULL, 15006, 9),
(269170, NULL, 'PF00923', NULL, NULL, 'Transaldolase/Fructose-6-phosphate aldolase', NULL, 'TAL_FSA', NULL, NULL, 3486, 9),
(269171, NULL, 'PF01718', NULL, NULL, 'Orbivirus non-structural protein NS1, or hydrophobic tubular protein', NULL, 'Orbi_NS1', NULL, NULL, 2951, 9),
(269172, NULL, 'PF02009', NULL, NULL, 'Rifin', NULL, 'RIFIN', NULL, NULL, 5515, 9),
(269173, NULL, 'PF12042', NULL, NULL, 'Tubuliform egg casing silk strands structural domain', NULL, 'RP1-2', NULL, NULL, 19821, 9),
(269174, NULL, 'PF19770', NULL, NULL, 'Family of unknown function (DUF6256)', NULL, 'DUF6256', NULL, NULL, 37129, 9),
(269175, NULL, 'PF03310', NULL, NULL, 'Caulimovirus DNA-binding protein', NULL, 'Cauli_DNA-bind', NULL, NULL, 794, 9),
(269176, NULL, 'PF02862', NULL, NULL, 'DDHD domain', NULL, 'DDHD', NULL, NULL, 2533, 9),
(269177, NULL, 'PF02868', NULL, NULL, 'Thermolysin metallopeptidase, alpha-helical domain', NULL, 'Peptidase_M4_C', NULL, NULL, 3252, 9),
(269178, NULL, 'PF06020', NULL, NULL, 'Drosophila roughex protein', NULL, 'Roughex', NULL, NULL, 13853, 9),
(269179, NULL, 'PF11599', NULL, NULL, 'RRNA methyltransferase AviRa', NULL, 'AviRa', NULL, NULL, 8793, 9),
(269180, NULL, 'PF18344', NULL, NULL, 'Carbohydrate binding module family 32', NULL, 'CBM32', NULL, NULL, NULL, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(269181, NULL, 'PF02259', NULL, NULL, 'FAT domain', NULL, 'FAT', NULL, NULL, 1598, 9),
(269182, NULL, 'PF03502', NULL, NULL, 'Nucleoside-specific channel-forming protein, Tsx', NULL, 'Channel_Tsx', NULL, NULL, 18071, 9),
(269183, NULL, 'PF16629', NULL, NULL, 'Armadillo-associated region on APC', NULL, 'Arm_APC_u3', NULL, NULL, NULL, 9),
(269184, NULL, 'PF20018', NULL, NULL, 'vWA-MoxR associated protein middle region (VMAP-M) 14', NULL, 'VMAP-M14', NULL, NULL, 35502, 9),
(269185, NULL, 'PF08464', NULL, NULL, 'Geminivirus AC4/5 conserved region', NULL, 'Gemini_AC4_5_2', NULL, NULL, 13583, 9),
(269186, NULL, 'PF10726', NULL, NULL, 'Protein of function (DUF2518)', NULL, 'DUF2518', NULL, NULL, 20599, 9),
(269187, NULL, 'PF17979', NULL, NULL, 'Cysteine rich domain with multizinc binding regions', NULL, 'zf-CRD', NULL, NULL, 28705, 9),
(269188, NULL, 'PF07670', NULL, NULL, 'Nucleoside recognition', NULL, 'Gate', NULL, NULL, 10532, 9),
(269189, NULL, 'PF09087', NULL, NULL, 'Cyclomaltodextrinase, N-terminal', NULL, 'Cyc-maltodext_N', NULL, NULL, 9932, 9),
(269190, NULL, 'PF02469', NULL, NULL, 'Fasciclin domain', NULL, 'Fasciclin', NULL, NULL, 4839, 9),
(269191, NULL, 'PF19167', NULL, NULL, 'Family of unknown function (DUF5849)', NULL, 'DUF5849', NULL, NULL, 34542, 9),
(269192, NULL, 'PF04760', NULL, NULL, 'Translation initiation factor IF-2, N-terminal region', NULL, 'IF2_N', NULL, NULL, 3557, 9),
(269193, NULL, 'PF13026', NULL, NULL, 'Protein of unknown function (DUF3887)', NULL, 'DUF3887', NULL, NULL, 22029, 9),
(269194, NULL, 'PF16108', NULL, NULL, 'Domain of unknown function (DUF4826)', NULL, 'DUF4826', NULL, NULL, 22278, 9),
(269195, NULL, 'PF03547', NULL, NULL, 'Membrane transport protein', NULL, 'Mem_trans', NULL, NULL, 5470, 9),
(269196, NULL, 'PF01179', NULL, NULL, 'Copper amine oxidase, enzyme domain', NULL, 'Cu_amine_oxid', NULL, NULL, 12869, 9),
(269197, NULL, 'PF00509', NULL, NULL, 'Haemagglutinin', NULL, 'Hemagglutinin', NULL, NULL, 2002, 9),
(269198, NULL, 'PF14210', NULL, NULL, 'Domain of unknown function (DUF4322)', NULL, 'DUF4322', NULL, NULL, 26095, 9),
(269199, NULL, 'PF19243', NULL, NULL, 'Family of unknown function (DUF5892)', NULL, 'DUF5892', NULL, NULL, 37160, 9),
(269200, NULL, 'PF08364', NULL, NULL, 'Bacterial translation initiation factor IF-2 associated region', NULL, 'IF2_assoc', NULL, NULL, 11827, 9),
(269201, NULL, 'PF19467', NULL, NULL, 'Family of unknown function (DUF6004)', NULL, 'DUF6004', NULL, NULL, 36996, 9),
(269202, NULL, 'PF07416', NULL, NULL, 'Crinivirus P26 protein', NULL, 'Crinivirus_P26', NULL, NULL, 8197, 9),
(269203, NULL, 'PF18455', NULL, NULL, 'Gamma-aminobutyric acid type B receptor subunit 2 coiled-coil domain', NULL, 'GBR2_CC', NULL, NULL, 30455, 9),
(269204, NULL, 'PF01927', NULL, NULL, 'Mut7-C RNAse domain', NULL, 'Mut7-C', NULL, NULL, 4798, 9),
(269205, NULL, 'PF03288', NULL, NULL, 'Poxvirus D5 protein-like', NULL, 'Pox_D5', NULL, NULL, 671, 9),
(269206, NULL, 'PF18083', NULL, NULL, 'Proline utilization A N-terminal domain', NULL, 'PutA_N', NULL, NULL, 29743, 9),
(269207, NULL, 'PF00439', NULL, NULL, 'Bromodomain', NULL, 'Bromodomain', NULL, NULL, 5971, 9),
(269208, NULL, 'PF05214', NULL, NULL, 'Baculovirus P33', NULL, 'Baculo_p33', NULL, NULL, 3428, 9),
(269209, NULL, 'PF07895', NULL, NULL, 'Protein of unknown function (DUF1673)', NULL, 'DUF1673', NULL, NULL, 12294, 9),
(269210, NULL, 'PF13440', NULL, NULL, 'Polysaccharide biosynthesis protein', NULL, 'Polysacc_synt_3', NULL, NULL, NULL, 9),
(269211, NULL, 'PF05707', NULL, NULL, 'Zonular occludens toxin (Zot)', NULL, 'Zot', NULL, NULL, 7695, 9),
(269212, NULL, 'PF19054', NULL, NULL, 'Domain of unknown function (DUF5753)', NULL, 'DUF5753', NULL, NULL, 35675, 9),
(269213, NULL, 'PF08826', NULL, NULL, 'DMPK coiled coil domain like', NULL, 'DMPK_coil', NULL, NULL, 14114, 9),
(269214, NULL, 'PF02369', NULL, NULL, 'Bacterial Ig-like domain (group 1)', NULL, 'Big_1', NULL, NULL, 4058, 9),
(269215, NULL, 'PF03063', NULL, NULL, 'Prismane/CO dehydrogenase family', NULL, 'Prismane', NULL, NULL, 2843, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(269216, NULL, 'PF08135', NULL, NULL, 'Major transforming protein E5 family', NULL, 'EPV_E5', NULL, NULL, 9176, 9),
(269217, NULL, 'PF09073', NULL, NULL, 'BUD22', NULL, 'BUD22', NULL, NULL, 9571, 9),
(269218, NULL, 'PF10897', NULL, NULL, 'Protein of unknown function (DUF2713)', NULL, 'DUF2713', NULL, NULL, 19308, 9),
(269219, NULL, 'PF13008', NULL, NULL, 'Zinc-binding domain of Paramyxoviridae V protein', NULL, 'zf-Paramyx-P', NULL, NULL, 12049, 9),
(269220, NULL, 'PF09808', NULL, NULL, 'Small nuclear RNA activating complex (SNAPc), subunit 1', NULL, 'SNAPC1', NULL, NULL, 18308, 9),
(269221, NULL, 'PF18085', NULL, NULL, 'Maltokinase N-terminal cap domain', NULL, 'Mak_N_cap', NULL, NULL, 28261, 9),
(269222, NULL, 'PF20589', NULL, NULL, 'Family of unknown function (DUF6790)', NULL, 'DUF6790', NULL, NULL, 37448, 9),
(269223, NULL, 'PF00696', NULL, NULL, 'Amino acid kinase family', NULL, 'AA_kinase', NULL, NULL, 2421, 9),
(269224, NULL, 'PF00525', NULL, NULL, 'Alpha crystallin A chain, N terminal', NULL, 'Crystallin', NULL, NULL, 810, 9),
(269225, NULL, 'PF01355', NULL, NULL, 'High potential iron-sulfur protein', NULL, 'HIPIP', NULL, NULL, 1772, 9),
(269226, NULL, 'PF02451', NULL, NULL, 'Nodulin', NULL, 'Nodulin', NULL, NULL, 4157, 9),
(269227, NULL, 'PF05387', NULL, NULL, 'Chorion family 3', NULL, 'Chorion_3', NULL, NULL, 8634, 9),
(269228, NULL, 'PF18870', NULL, NULL, 'HEPN/RES N-terminal domain 1', NULL, 'HEPN_RES_NTD1', NULL, NULL, 28524, 9),
(269229, NULL, 'PF04268', NULL, NULL, 'Sarcosine oxidase, gamma subunit family', NULL, 'SoxG', NULL, NULL, 5567, 9),
(269230, NULL, 'PF14166', NULL, NULL, 'YueH-like protein', NULL, 'YueH', NULL, NULL, 19002, 9),
(269231, NULL, 'PF11016', NULL, NULL, 'Protein of unknown function (DUF2854)', NULL, 'DUF2854', NULL, NULL, 17510, 9),
(269232, NULL, 'PF15559', NULL, NULL, 'Domain of unknown function (DUF4660)', NULL, 'DUF4660', NULL, NULL, 25334, 9),
(269233, NULL, 'PF16758', NULL, NULL, 'Herpes-like virus membrane glycoprotein UL141', NULL, 'UL141', NULL, NULL, 22562, 9),
(269234, NULL, 'PF19494', NULL, NULL, 'Family of unknown function (DUF6029)', NULL, 'DUF6029', NULL, NULL, 36660, 9),
(269235, NULL, 'PF14250', NULL, NULL, 'AbrB-like transcriptional regulator', NULL, 'AbrB-like', NULL, NULL, 24237, 9),
(269236, NULL, 'PF01106', NULL, NULL, 'NifU-like domain', NULL, 'NifU', NULL, NULL, 1286, 9),
(269237, NULL, 'PF17459', NULL, NULL, 'Family of unknown function (DUF5422)', NULL, 'DUF5422', NULL, NULL, 21079, 9),
(269238, NULL, 'PF19874', NULL, NULL, 'Family of unknown function (DUF6347)', NULL, 'DUF6347', NULL, NULL, 36670, 9),
(269239, NULL, 'PF06874', NULL, NULL, 'Firmicute fructose-1,6-bisphosphatase', NULL, 'FBPase_2', NULL, NULL, 9522, 9),
(269240, NULL, 'PF06951', NULL, NULL, 'Group XII secretory phospholipase A2 precursor (PLA2G12)', NULL, 'PLA2G12', NULL, NULL, 9752, 9),
(269241, NULL, 'PF09216', NULL, NULL, 'Pfg27', NULL, 'Pfg27', NULL, NULL, 12527, 9),
(269242, NULL, 'PF08578', NULL, NULL, 'Protein of unknown function (DUF1765)', NULL, 'DUF1765', NULL, NULL, 17952, 9),
(269243, NULL, 'PF09564', NULL, NULL, 'NgoBV restriction endonuclease', NULL, 'RE_NgoBV', NULL, NULL, 16612, 9),
(269244, NULL, 'PF05218', NULL, NULL, 'Protein of unknown function (DUF713)', NULL, 'DUF713', NULL, NULL, 3056, 9),
(269245, NULL, 'PF19715', NULL, NULL, 'Family of unknown function (DUF6210)', NULL, 'DUF6210', NULL, NULL, 37053, 9),
(269246, NULL, 'PF10295', NULL, NULL, 'Uncharacterised protein (DUF2406)', NULL, 'DUF2406', NULL, NULL, 19735, 9),
(269247, NULL, 'PF03864', NULL, NULL, 'Phage major capsid protein E', NULL, 'Phage_cap_E', NULL, NULL, 1811, 9),
(269248, NULL, 'PF01064', NULL, NULL, 'Activin types I and II receptor domain', NULL, 'Activin_recp', NULL, NULL, 5766, 9),
(269249, NULL, 'PF11723', NULL, NULL, 'Homotrimeric ring hydroxylase', NULL, 'Aromatic_hydrox', NULL, NULL, 15681, 9),
(269250, NULL, 'PF08849', NULL, NULL, 'BrxA', NULL, 'BrxA', NULL, NULL, 14408, 9),
(269251, NULL, 'PF09259', NULL, NULL, 'Fungal immunomodulatory protein Fve', NULL, 'Fve', NULL, NULL, 13324, 9);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(269252, NULL, 'PF14044', NULL, NULL, 'NETI protein', NULL, 'NETI', NULL, NULL, 23248, 9),
(269253, NULL, 'PF07449', NULL, NULL, 'Hydrogenase-1 expression protein HyaE', NULL, 'HyaE', NULL, NULL, 11986, 9),
(269254, NULL, 'PF05786', NULL, NULL, 'Condensin complex subunit 2', NULL, 'Cnd2', NULL, NULL, 15305, 9),
(269255, NULL, 'PF06482', NULL, NULL, 'Collagenase NC10 and Endostatin', NULL, 'Endostatin', NULL, NULL, 12441, 9),
(269256, NULL, 'PF05440', NULL, NULL, 'Tetrahydromethanopterin S-methyltransferase subunit B', NULL, 'MtrB', NULL, NULL, 13335, 9),
(269257, NULL, 'PF18449', NULL, NULL, 'Delta endotoxin', NULL, 'Endotoxin_C2', NULL, NULL, NULL, 9),
(269258, NULL, 'PF10228', NULL, NULL, 'Uncharacterised conserved protein (DUF2228)', NULL, 'DUF2228', NULL, NULL, 15685, 9),
(269259, NULL, 'PF01640', NULL, NULL, 'Peptidase C10 family', NULL, 'Peptidase_C10', NULL, NULL, 1484, 9),
(269260, NULL, 'PF04713', NULL, NULL, 'Poxvirus protein I5', NULL, 'Pox_I5', NULL, NULL, 3957, 9),
(269261, NULL, 'PF14463', NULL, NULL, 'E1 N-terminal domain', NULL, 'E1-N', NULL, NULL, 25642, 9),
(269262, NULL, 'PF07440', NULL, NULL, 'Caerin 1 protein', NULL, 'Caerin_1', NULL, NULL, 8716, 9),
(269263, NULL, 'PF14821', NULL, NULL, 'Threonine synthase N terminus', NULL, 'Thr_synth_N', NULL, NULL, 25818, 9),
(269264, NULL, 'PF03662', NULL, NULL, 'Glycosyl hydrolase family 79, N-terminal domain', NULL, 'Glyco_hydro_79n', NULL, NULL, 5015, 9),
(269265, NULL, 'PF18412', NULL, NULL, 'Outer-membrane lipoprotein Wza C-terminal domain', NULL, 'Wza_C', NULL, NULL, 27579, 9),
(269266, NULL, 'PF08361', NULL, NULL, 'MAATS-type transcriptional repressor, C-terminal region', NULL, 'TetR_C_2', NULL, NULL, 12878, 9),
(269267, NULL, 'PF09304', NULL, NULL, 'Cortexillin I, coiled coil', NULL, 'Cortex-I_coil', NULL, NULL, 14002, 9),
(269268, NULL, 'PF09579', NULL, NULL, 'Sporulation protein YtfJ (Spore_YtfJ)', NULL, 'Spore_YtfJ', NULL, NULL, 10841, 9),
(269269, NULL, 'PF03858', NULL, NULL, 'Crustacean neurohormone H', NULL, 'Crust_neuro_H', NULL, NULL, 1731, 9),
(269270, NULL, 'PF10576', NULL, NULL, 'Iron-sulfur binding domain of endonuclease III', NULL, 'EndIII_4Fe-2S', NULL, NULL, 1373, 9),
(269271, NULL, 'PF07361', NULL, NULL, 'Cytochrome b562', NULL, 'Cytochrom_B562', NULL, NULL, 9928, 9),
(269272, NULL, 'PF03615', NULL, NULL, 'GCM motif protein', NULL, 'GCM', NULL, NULL, 4224, 9),
(269273, NULL, 'PF07489', NULL, NULL, 'Translocated intimin receptor (Tir) C-terminus', NULL, 'Tir_receptor_C', NULL, NULL, 16494, 9),
(269274, NULL, 'PF01452', NULL, NULL, 'Rotavirus non structural protein', NULL, 'Rota_NSP4', NULL, NULL, 5054, 9),
(269275, NULL, 'PF13787', NULL, NULL, 'Protein of unknown function with HXXEE motif', NULL, 'HXXEE', NULL, NULL, 24260, 9),
(269276, NULL, 'PF01280', NULL, NULL, 'Ribosomal protein L19e', NULL, 'Ribosomal_L19e', NULL, NULL, 1105, 9),
(269277, NULL, 'PF10348', NULL, NULL, 'Domain of unknown function (DUF2427)', NULL, 'DUF2427', NULL, NULL, 19689, 9),
(269278, NULL, 'PF16430', NULL, NULL, 'Domain of unknown function (DUF5027)', NULL, 'DUF5027', NULL, NULL, 24309, 9),
(269279, NULL, 'PF01814', NULL, NULL, 'Hemerythrin HHE cation binding domain', NULL, 'Hemerythrin', NULL, NULL, 12059, 9),
(269280, NULL, 'PF09098', NULL, NULL, 'Quinohemoprotein amine dehydrogenase A, alpha subunit, haem binding', NULL, 'Dehyd-heme_bind', NULL, NULL, 10725, 9),
(269281, NULL, 'PF00372', NULL, NULL, 'Hemocyanin, copper containing domain', NULL, 'Hemocyanin_M', NULL, NULL, 3373, 9),
(269282, NULL, 'PF18966', NULL, NULL, 'Uncharacterised lipoprotein', NULL, 'Lipoprotein_23', NULL, NULL, 35757, 9),
(269283, NULL, 'PF16245', NULL, NULL, 'Domain of unknown function (DUF4902)', NULL, 'DUF4902', NULL, NULL, 24016, 9),
(269284, NULL, 'PF11434', NULL, NULL, 'Chemotaxis-inhibiting protein CHIPS', NULL, 'CHIPS', NULL, NULL, 15774, 9),
(269285, NULL, 'PF11527', NULL, NULL, 'The ARF-like 2 binding protein BART', NULL, 'ARL2_Bind_BART', NULL, NULL, 15933, 9),
(269286, NULL, 'PF08234', NULL, NULL, 'Chromosome segregation protein Spc25', NULL, 'Spindle_Spc25', NULL, NULL, 13103, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(269287, NULL, 'PF01654', NULL, NULL, 'Cytochrome bd terminal oxidase subunit I', NULL, 'Cyt_bd_oxida_I', NULL, NULL, 1608, 9),
(269288, NULL, 'PF10177', NULL, NULL, 'Uncharacterised conserved protein (DUF2371)', NULL, 'DUF2371', NULL, NULL, 19163, 9),
(269289, NULL, 'PF12947', NULL, NULL, 'EGF domain', NULL, 'EGF_3', NULL, NULL, 13516, 9),
(269290, NULL, 'PF06542', NULL, NULL, 'Regulator protein PHA-1', NULL, 'PHA-1', NULL, NULL, 9110, 9),
(269291, NULL, 'PF15984', NULL, NULL, 'Bacterial collagen, middle region', NULL, 'Collagen_mid', NULL, NULL, 25724, 9),
(269292, NULL, 'PF00093', NULL, NULL, 'von Willebrand factor type C domain', NULL, 'VWC', NULL, NULL, 2283, 9),
(269293, NULL, 'PF10265', NULL, NULL, 'Mitoguardin', NULL, 'Miga', NULL, NULL, 15894, 9),
(269294, NULL, 'PF14076', NULL, NULL, 'Domain of unknown function (DUF4258)', NULL, 'DUF4258', NULL, NULL, 22951, 9),
(269295, NULL, 'PF18993', NULL, NULL, 'Rv0078B-related antitoxin', NULL, 'Rv0078B', NULL, NULL, 35902, 9),
(269296, NULL, 'PF05133', NULL, NULL, 'Phage portal protein, SPP1 Gp6-like', NULL, 'Phage_prot_Gp6', NULL, NULL, 15271, 9),
(269297, NULL, 'PF05242', NULL, NULL, 'Glycosylation-dependent cell adhesion molecule 1 (GlyCAM-1)', NULL, 'GLYCAM-1', NULL, NULL, 3074, 9),
(269298, NULL, 'PF16574', NULL, NULL, 'Coiled-coil region of centrosome protein CE290', NULL, 'CEP209_CC5', NULL, NULL, 25387, 9),
(269299, NULL, 'PF18324', NULL, NULL, 'Hypothetical protein TT1725', NULL, 'TT1725', NULL, NULL, 28088, 9),
(269300, NULL, 'PF13366', NULL, NULL, 'PD-(D/E)XK nuclease superfamily', NULL, 'PDDEXK_3', NULL, NULL, 24750, 9),
(269301, NULL, 'PF17764', NULL, NULL, '3''DNA-binding domain (3''BD)', NULL, 'PriA_3primeBD', NULL, NULL, 29420, 9),
(269302, NULL, 'PF04700', NULL, NULL, 'Structural glycoprotein p40/gp41 conserved region', NULL, 'Baculo_gp41', NULL, NULL, 3257, 9),
(269303, NULL, 'PF04020', NULL, NULL, 'Mycobacterial 4 TMS phage holin, superfamily IV', NULL, 'Phage_holin_4_2', NULL, NULL, 203, 9),
(269304, NULL, 'PF07367', NULL, NULL, 'Fungal fruit body lectin', NULL, 'FB_lectin', NULL, NULL, 8157, 9),
(269305, NULL, 'PF12727', NULL, NULL, 'PBP superfamily domain', NULL, 'PBP_like', NULL, NULL, 23574, 9),
(269306, NULL, 'PF15423', NULL, NULL, 'FLYWCH-type zinc finger-containing protein', NULL, 'FLYWCH_N', NULL, NULL, 26229, 9),
(269307, NULL, 'PF03104', NULL, NULL, 'DNA polymerase family B, exonuclease domain', NULL, 'DNA_pol_B_exo1', NULL, NULL, 10412, 9),
(269308, NULL, 'PF04855', NULL, NULL, 'SNF5 / SMARCB1 / INI1', NULL, 'SNF5', NULL, NULL, 5690, 9),
(269309, NULL, 'PF16535', NULL, NULL, 'Type III cell invasion protein SipB', NULL, 'T3SSipB', NULL, NULL, 24129, 9),
(269310, NULL, 'PF00847', NULL, NULL, 'AP2 domain', NULL, 'AP2', NULL, NULL, 3180, 9),
(269311, NULL, 'PF09563', NULL, NULL, 'LlaJI restriction endonuclease', NULL, 'RE_LlaJI', NULL, NULL, 15049, 9),
(269312, NULL, 'PF14244', NULL, NULL, 'gag-polypeptide of LTR copia-type', NULL, 'Retrotran_gag_3', NULL, NULL, 26526, 9),
(269313, NULL, 'PF00243', NULL, NULL, 'Nerve growth factor family', NULL, 'NGF', NULL, NULL, 5242, 9),
(269314, NULL, 'PF14925', NULL, NULL, 'Domain of unknown function', NULL, 'HPHLAWLY', NULL, NULL, 25878, 9),
(269315, NULL, 'PF19834', NULL, NULL, 'Family of unknown function (DUF6314)', NULL, 'DUF6314', NULL, NULL, 37361, 9),
(269316, NULL, 'PF04077', NULL, NULL, 'DsrH like protein', NULL, 'DsrH', NULL, NULL, 6300, 9),
(269317, NULL, 'PF01300', NULL, NULL, 'Telomere recombination', NULL, 'Sua5_yciO_yrdC', NULL, NULL, 2837, 9),
(269318, NULL, 'PF07238', NULL, NULL, 'PilZ domain', NULL, 'PilZ', NULL, NULL, 14024, 9),
(269319, NULL, 'PF07941', NULL, NULL, 'Potassium channel Kv1.4 tandem inactivation domain', NULL, 'K_channel_TID', NULL, NULL, 13496, 9),
(269320, NULL, 'PF11238', NULL, NULL, 'Protein of unknown function (DUF3039)', NULL, 'DUF3039', NULL, NULL, 18074, 9),
(269321, NULL, 'PF15011', NULL, NULL, 'Casein Kinase 2 substrate', NULL, 'CK2S', NULL, NULL, 26530, 9),
(269322, NULL, 'PF15112', NULL, NULL, 'Domain of unknown function (DUF4559)', NULL, 'DUF4559', NULL, NULL, 24277, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(269323, NULL, 'PF12794', NULL, NULL, 'Mechanosensitive ion channel inner membrane domain 1', NULL, 'MscS_TM', NULL, NULL, 24934, 9),
(269324, NULL, 'PF00203', NULL, NULL, 'Ribosomal protein S19', NULL, 'Ribosomal_S19', NULL, NULL, 22, 9),
(269325, NULL, 'PF06844', NULL, NULL, 'Protein of unknown function (DUF1244)', NULL, 'DUF1244', NULL, NULL, 16468, 9),
(269326, NULL, 'PF00098', NULL, NULL, 'Zinc knuckle', NULL, 'zf-CCHC', NULL, NULL, 4426, 9),
(269327, NULL, 'PF05603', NULL, NULL, 'Protein of unknown function (DUF775)', NULL, 'DUF775', NULL, NULL, 12480, 9),
(269328, NULL, 'PF08710', NULL, NULL, 'Coronavirus replicase NSP9', NULL, 'CoV_NSP9', NULL, NULL, 11563, 9),
(269329, NULL, 'PF11687', NULL, NULL, 'Domain of unknown function (DUF3284)', NULL, 'DUF3284', NULL, NULL, 19366, 9),
(269330, NULL, 'PF18434', NULL, NULL, 'Kazal-type serine protease inhibitor domain', NULL, 'Kazal_3', NULL, NULL, 28118, 9),
(269331, NULL, 'PF17236', NULL, NULL, 'Family of unknown function (DUF5309)', NULL, 'DUF5309', NULL, NULL, 21212, 9),
(269332, NULL, 'PF06298', NULL, NULL, 'Photosystem II protein Y (PsbY)', NULL, 'PsbY', NULL, NULL, 8081, 9),
(269333, NULL, 'PF16746', NULL, NULL, 'BAR domain of APPL family', NULL, 'BAR_3', NULL, NULL, NULL, 9),
(269334, NULL, 'PF11288', NULL, NULL, 'Protein of unknown function (DUF3089)', NULL, 'DUF3089', NULL, NULL, 18265, 9),
(269335, NULL, 'PF18403', NULL, NULL, 'Thioredoxin-like domain', NULL, 'Thioredoxin_15', NULL, NULL, 31799, 9),
(269336, NULL, 'PF07381', NULL, NULL, 'Winged helix DNA-binding domain (DUF1495)', NULL, 'DUF1495', NULL, NULL, 11928, 9),
(269337, NULL, 'PF07660', NULL, NULL, 'Secretin and TonB N terminus short domain', NULL, 'STN', NULL, NULL, 10771, 9),
(269338, NULL, 'PF19400', NULL, NULL, 'Family of unknown function (DUF5975)', NULL, 'DUF5975', NULL, NULL, 36755, 9),
(269339, NULL, 'PF04205', NULL, NULL, 'FMN-binding domain', NULL, 'FMN_bind', NULL, NULL, 5389, 9),
(269340, NULL, 'PF09387', NULL, NULL, 'Mitochondrial RNA binding protein MRP', NULL, 'MRP', NULL, NULL, 26008, 9),
(269341, NULL, 'PF14604', NULL, NULL, 'Variant SH3 domain', NULL, 'SH3_9', NULL, NULL, 6232, 9),
(269342, NULL, 'PF01795', NULL, NULL, 'MraW methylase family', NULL, 'Methyltransf_5', NULL, NULL, 6127, 9),
(269343, NULL, 'PF05339', NULL, NULL, 'Protein of unknown function (DUF739)', NULL, 'DUF739', NULL, NULL, 5002, 9),
(269344, NULL, 'PF10823', NULL, NULL, 'Protein of unknown function (DUF2568)', NULL, 'DUF2568', NULL, NULL, 17786, 9),
(269345, NULL, 'PF17088', NULL, NULL, 'Uncharacterised protein family', NULL, 'YCF90', NULL, NULL, 24483, 9),
(269346, NULL, 'PF16019', NULL, NULL, 'Cysteine/serine-rich nuclear protein N-terminus', NULL, 'CSRNP_N', NULL, NULL, 22987, 9),
(269347, NULL, 'PF00978', NULL, NULL, 'RNA dependent RNA polymerase', NULL, 'RdRP_2', NULL, NULL, 4179, 9),
(269348, NULL, 'PF12209', NULL, NULL, 'Leucine permease transcriptional regulator helical domain', NULL, 'SAC3', NULL, NULL, 9161, 9),
(269349, NULL, 'PF16377', NULL, NULL, 'Domain of unknown function', NULL, 'DUF4987', NULL, NULL, 26067, 9),
(269350, NULL, 'PF18316', NULL, NULL, 'S-layer protein SbsC C-terminal domain', NULL, 'S-l_SbsC_C', NULL, NULL, 28940, 9),
(269351, NULL, 'PF02677', NULL, NULL, 'Epoxyqueuosine reductase QueH', NULL, 'QueH', NULL, NULL, 6275, 9),
(269352, NULL, 'PF08999', NULL, NULL, 'Surfactant protein C, N terminal propeptide', NULL, 'SP_C-Propep', NULL, NULL, 8992, 9),
(269353, NULL, 'PF09960', NULL, NULL, 'Uncharacterised protein conserved in bacteria (DUF2194)', NULL, 'DUF2194', NULL, NULL, 17201, 9),
(269354, NULL, 'PF14495', NULL, NULL, 'Cytochrome c-550 domain', NULL, 'Cytochrom_C550', NULL, NULL, 23083, 9),
(269355, NULL, 'PF01299', NULL, NULL, 'Lysosome-associated membrane glycoprotein (Lamp)', NULL, 'Lamp', NULL, NULL, 4671, 9),
(269356, NULL, 'PF13223', NULL, NULL, 'Protein of unknown function (DUF4031)', NULL, 'DUF4031', NULL, NULL, 22517, 9),
(269357, NULL, 'PF09203', NULL, NULL, 'MspA', NULL, 'MspA', NULL, NULL, 12481, 9),
(269358, NULL, 'PF03431', NULL, NULL, 'RNA replicase, beta-chain', NULL, 'RNA_replicase_B', NULL, NULL, 10195, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(269359, NULL, 'PF16136', NULL, NULL, 'Putative nuclear localisation signal', NULL, 'NINJA_B', NULL, NULL, 26298, 9),
(269360, NULL, 'PF20149', NULL, NULL, 'Domain of unknown function (DUF6532)', NULL, 'DUF6532', NULL, NULL, 37207, 9),
(269361, NULL, 'PF03239', NULL, NULL, 'Iron permease FTR1 family', NULL, 'FTR1', NULL, NULL, 1593, 9),
(269362, NULL, 'PF03941', NULL, NULL, 'Inner centromere protein, ARK binding region', NULL, 'INCENP_ARK-bind', NULL, NULL, 2618, 9),
(269363, NULL, 'PF13202', NULL, NULL, 'EF hand', NULL, 'EF-hand_5', NULL, NULL, 1368, 9),
(269364, NULL, 'PF02326', NULL, NULL, 'Plant ATP synthase F0', NULL, 'YMF19', NULL, NULL, 4392, 9),
(269365, NULL, 'PF05399', NULL, NULL, 'Ectropic viral integration site 2A protein (EVI2A)', NULL, 'EVI2A', NULL, NULL, 14277, 9),
(269366, NULL, 'PF18191', NULL, NULL, 'Hydroquinone 1,2-dioxygenase large subunit N-terminal', NULL, 'PnpCD_PnpD_N', NULL, NULL, 28559, 9),
(269367, NULL, 'PF02664', NULL, NULL, 'S-Ribosylhomocysteinase (LuxS)', NULL, 'LuxS', NULL, NULL, 3109, 9),
(269368, NULL, 'PF06307', NULL, NULL, 'Herpesvirus IR6 protein', NULL, 'Herpes_IR6', NULL, NULL, 10495, 9),
(269369, NULL, 'PF09055', NULL, NULL, 'Nickel-containing superoxide dismutase', NULL, 'Sod_Ni', NULL, NULL, 13649, 9),
(269370, NULL, 'PF16124', NULL, NULL, 'RecQ zinc-binding', NULL, 'RecQ_Zn_bind', NULL, NULL, 25014, 9),
(269371, NULL, 'PF12401', NULL, NULL, 'FhaA, N-terminal domain', NULL, 'FhaA_N', NULL, NULL, 20944, 9),
(269372, NULL, 'PF13100', NULL, NULL, 'OstA-like protein', NULL, 'OstA_2', NULL, NULL, 2743, 9),
(269373, NULL, 'PF05433', NULL, NULL, 'Glycine zipper 2TM domain', NULL, 'Rick_17kDa_Anti', NULL, NULL, 13960, 9),
(269374, NULL, 'PF19476', NULL, NULL, 'Family of unknown function (DUF6013)', NULL, 'DUF6013', NULL, NULL, 36896, 9),
(269375, NULL, 'PF05986', NULL, NULL, 'ADAM-TS Spacer 1', NULL, 'ADAMTS_spacer1', NULL, NULL, 7776, 9),
(269376, NULL, 'PF17842', NULL, NULL, 'Double-stranded RNA binding domain 2', NULL, 'dsRBD2', NULL, NULL, 28038, 9),
(269377, NULL, 'PF18813', NULL, NULL, 'phage-Barnase-EndoU-ColicinE5/D-RelE like nuclease4', NULL, 'PBECR4', NULL, NULL, 29302, 9),
(269378, NULL, 'PF14857', NULL, NULL, 'TMEM151 family', NULL, 'TMEM151', NULL, NULL, 24227, 9),
(269379, NULL, 'PF16686', NULL, NULL, 'ssDNA-binding domain of telomere protection protein', NULL, 'POT1PC', NULL, NULL, 25747, 9),
(269380, NULL, 'PF11524', NULL, NULL, 'Selenium binding protein', NULL, 'SeleniumBinding', NULL, NULL, 18817, 9),
(269381, NULL, 'PF07757', NULL, NULL, 'Predicted AdoMet-dependent methyltransferase', NULL, 'AdoMet_MTase', NULL, NULL, 10899, 9),
(269382, NULL, 'PF13272', NULL, NULL, 'Putative 2/3 transmembrane domain holin', NULL, 'Holin_2-3', NULL, NULL, 22838, 9),
(269383, NULL, 'PF07521', NULL, NULL, 'Zn-dependent metallo-hydrolase RNA specificity domain', NULL, 'RMMBL', NULL, NULL, 11099, 9),
(269384, NULL, 'PF01791', NULL, NULL, 'DeoC/LacD family aldolase', NULL, 'DeoC', NULL, NULL, 6080, 9),
(269385, NULL, 'PF03585', NULL, NULL, 'Herpesvirus ICP4-like protein C-terminal region', NULL, 'Herpes_ICP4_C', NULL, NULL, 6515, 9),
(269386, NULL, 'PF18371', NULL, NULL, 'Flavin adenine dinucleotide (FAD)-dependent sulfhydryl oxidase', NULL, 'FAD_SOX', NULL, NULL, 28975, 9),
(269387, NULL, 'PF15189', NULL, NULL, 'Meiosis-specific coiled-coil domain-containing protein MEIOC', NULL, 'MEIOC', NULL, NULL, 24339, 9),
(269388, NULL, 'PF08555', NULL, NULL, 'FAM32A', NULL, 'FAM32A', NULL, NULL, 9862, 9),
(269389, NULL, 'PF17912', NULL, NULL, 'MalK OB fold domain', NULL, 'OB_MalK', NULL, NULL, 27861, 9),
(269390, NULL, 'PF05564', NULL, NULL, 'Dormancy/auxin associated protein', NULL, 'Auxin_repressed', NULL, NULL, 8883, 9),
(269391, NULL, 'PF00323', NULL, NULL, 'Mammalian defensin', NULL, 'Defensin_1', NULL, NULL, 2857, 9),
(269392, NULL, 'PF00510', NULL, NULL, 'Cytochrome c oxidase subunit III', NULL, 'COX3', NULL, NULL, 642, 9),
(269393, NULL, 'PF11924', NULL, NULL, 'Inverse autotransporter, beta-domain', NULL, 'IAT_beta', NULL, NULL, 24535, 9),
(269394, NULL, 'PF03856', NULL, NULL, 'Beta-glucosidase (SUN family)', NULL, 'SUN', NULL, NULL, 1921, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(269395, NULL, 'PF18513', NULL, NULL, 'Prodomain subtilisin 2', NULL, 'Pro_sub2', NULL, NULL, 29139, 9),
(269396, NULL, 'PF02005', NULL, NULL, 'N2,N2-dimethylguanosine tRNA methyltransferase', NULL, 'TRM', NULL, NULL, 6289, 9),
(269397, NULL, 'PF15524', NULL, NULL, 'Novel toxin 17', NULL, 'Ntox17', NULL, NULL, 23730, 9),
(269398, NULL, 'PF19510', NULL, NULL, 'Protein of unknown function (DUF6044)', NULL, 'DUF6044', NULL, NULL, 37432, 9),
(269399, NULL, 'PF13283', NULL, NULL, 'Bacteriophage N adsorption protein A C-term', NULL, 'NfrA_C', NULL, NULL, 22171, 9),
(269400, NULL, 'PF06953', NULL, NULL, 'Arsenical resistance operon protein ArsD', NULL, 'ArsD', NULL, NULL, 9717, 9),
(269401, NULL, 'PF06013', NULL, NULL, 'Proteins of 100 residues with WXG', NULL, 'WXG100', NULL, NULL, 8074, 9),
(269402, NULL, 'PF08738', NULL, NULL, 'Gon7 family', NULL, 'Gon7', NULL, NULL, 11509, 9),
(269403, NULL, 'PF17209', NULL, NULL, 'Hfq protein', NULL, 'Hfq', NULL, NULL, 831, 9),
(269404, NULL, 'PF19023', NULL, NULL, 'Family of unknown function (DUF5749)', NULL, 'DUF5749', NULL, NULL, 35512, 9),
(269405, NULL, 'PF13167', NULL, NULL, 'GTP-binding GTPase N-terminal', NULL, 'GTP-bdg_N', NULL, NULL, 22260, 9),
(269406, NULL, 'PF08044', NULL, NULL, 'Domain of unknown function (DUF1707)', NULL, 'DUF1707', NULL, NULL, 8815, 9),
(269407, NULL, 'PF03449', NULL, NULL, 'Transcription elongation factor, N-terminal', NULL, 'GreA_GreB_N', NULL, NULL, 16513, 9),
(269408, NULL, 'PF17579', NULL, NULL, 'Family of unknown function (DUF5482)', NULL, 'DUF5482', NULL, NULL, 30686, 9),
(269409, NULL, 'PF13035', NULL, NULL, 'Protein of unknown function (DUF3896)', NULL, 'DUF3896', NULL, NULL, 22755, 9),
(269410, NULL, 'PF12418', NULL, NULL, 'Acyl-CoA dehydrogenase N terminal', NULL, 'AcylCoA_DH_N', NULL, NULL, 15541, 9),
(269411, NULL, 'PF10766', NULL, NULL, 'Multidrug efflux pump-associated protein AcrZ', NULL, 'AcrZ', NULL, NULL, 20211, 9),
(269412, NULL, 'PF03194', NULL, NULL, 'LUC7 N_terminus', NULL, 'LUC7', NULL, NULL, 7312, 9),
(269413, NULL, 'PF07980', NULL, NULL, 'SusD family', NULL, 'SusD_RagB', NULL, NULL, 8272, 9),
(269414, NULL, 'PF08020', NULL, NULL, 'Protein of unknown function (DUF1706)', NULL, 'DUF1706', NULL, NULL, 8612, 9),
(269415, NULL, 'PF18573', NULL, NULL, 'BclA C-terminal domain', NULL, 'BclA_C', NULL, NULL, 30344, 9),
(269416, NULL, 'PF01139', NULL, NULL, 'tRNA-splicing ligase RtcB', NULL, 'RtcB', NULL, NULL, 788, 9),
(269417, NULL, 'PF05655', NULL, NULL, 'Pseudomonas avirulence D protein (AvrD)', NULL, 'AvrD', NULL, NULL, 13994, 9),
(269418, NULL, 'PF04184', NULL, NULL, 'ST7 protein', NULL, 'ST7', NULL, NULL, 4585, 9),
(269419, NULL, 'PF00649', NULL, NULL, 'Copper fist DNA binding domain', NULL, 'Copper-fist', NULL, NULL, 2454, 9),
(269420, NULL, 'PF09996', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2237)', NULL, 'DUF2237', NULL, NULL, 17398, 9),
(269421, NULL, 'PF06281', NULL, NULL, 'Structural protein VP1/VP3', NULL, 'VP1_VP3', NULL, NULL, 8158, 9),
(269422, NULL, 'PF14807', NULL, NULL, 'Adaptin AP4 complex epsilon appendage platform', NULL, 'AP4E_app_platf', NULL, NULL, 26927, 9),
(269423, NULL, 'PF01693', NULL, NULL, 'Caulimovirus viroplasmin', NULL, 'Cauli_VI', NULL, NULL, 13051, 9),
(269424, NULL, 'PF04750', NULL, NULL, 'FAR-17a/AIG1-like protein', NULL, 'Far-17a_AIG1', NULL, NULL, 3564, 9),
(269425, NULL, 'PF15250', NULL, NULL, 'Raftlin', NULL, 'Raftlin', NULL, NULL, 24760, 9),
(269426, NULL, 'PF03234', NULL, NULL, 'Cdc37 N terminal kinase binding', NULL, 'CDC37_N', NULL, NULL, 18776, 9),
(269427, NULL, 'PF18817', NULL, NULL, 'Repeat of uncharacterized protein PH0542', NULL, 'HEAT_UF', NULL, NULL, 27675, 9),
(269428, NULL, 'PF07532', NULL, NULL, 'Bacterial Ig-like domain (group 4)', NULL, 'Big_4', NULL, NULL, 10588, 9),
(269429, NULL, 'PF20010', NULL, NULL, 'Collagen trimerization domain', NULL, 'Collagen_trimer', NULL, NULL, 37403, 9),
(269430, NULL, 'PF06340', NULL, NULL, 'Vibrio cholerae toxin co-regulated pilus biosynthesis protein F', NULL, 'TcpF', NULL, NULL, 8362, 9),
(269431, NULL, 'PF10162', NULL, NULL, 'G8 domain', NULL, 'G8', NULL, NULL, 14952, 9);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(269432, NULL, 'PF04032', NULL, NULL, 'RNAse P Rpr2/Rpp21/SNM1 subunit domain', NULL, 'Rpr2', NULL, NULL, 457, 9),
(269433, NULL, 'PF04133', NULL, NULL, 'Vacuolar protein sorting 55', NULL, 'Vps55', NULL, NULL, 6813, 9),
(269434, NULL, 'PF09119', NULL, NULL, 'SicP binding', NULL, 'SicP-binding', NULL, NULL, 10887, 9),
(269435, NULL, 'PF12154', NULL, NULL, 'Glycoprotein B N-terminal antigenic domain of HCMV', NULL, 'HCMVantigenic_N', NULL, NULL, 15315, 9),
(269436, NULL, 'PF13176', NULL, NULL, 'Tetratricopeptide repeat', NULL, 'TPR_7', NULL, NULL, 20936, 9),
(269437, NULL, 'PF10980', NULL, NULL, 'Protein of unknown function (DUF2787)', NULL, 'DUF2787', NULL, NULL, 17678, 9),
(269438, NULL, 'PF05311', NULL, NULL, 'Baculovirus 33KDa late protein (PP31)', NULL, 'Baculo_PP31', NULL, NULL, 4347, 9),
(269439, NULL, 'PF12278', NULL, NULL, 'Sex determination protein N terminal', NULL, 'SDP_N', NULL, NULL, 20881, 9),
(269440, NULL, 'PF09301', NULL, NULL, 'Domain of unknown function (DUF1970)', NULL, 'DUF1970', NULL, NULL, NULL, 9),
(269441, NULL, 'PF06365', NULL, NULL, 'CD34/Podocalyxin family', NULL, 'CD34_antigen', NULL, NULL, 17859, 9),
(269442, NULL, 'PF06733', NULL, NULL, 'DEAD_2', NULL, 'DEAD_2', NULL, NULL, 8360, 9),
(269443, NULL, 'PF09463', NULL, NULL, 'Opy2 protein', NULL, 'Opy2', NULL, NULL, 15374, 9),
(269444, NULL, 'PF10923', NULL, NULL, 'BREX system ATP-binding protein BrxC/D', NULL, 'BrxC_BrxD', NULL, NULL, 17662, 9),
(269445, NULL, 'PF10255', NULL, NULL, 'RNA polymerase I-associated factor PAF67', NULL, 'Paf67', NULL, NULL, 15711, 9),
(269446, NULL, 'PF08136', NULL, NULL, '30S ribosomal protein subunit S22 family', NULL, 'Ribosomal_S22', NULL, NULL, 9792, 9),
(269447, NULL, 'PF20222', NULL, NULL, 'Family of unknown function (DUF6581)', NULL, 'DUF6581', NULL, NULL, 37739, 9),
(269448, NULL, 'PF18479', NULL, NULL, 'PIN like domain', NULL, 'PIN_11', NULL, NULL, 29341, 9),
(269449, NULL, 'PF19098', NULL, NULL, 'Family of unknown function (DUF5785)', NULL, 'DUF5785', NULL, NULL, 34529, 9),
(269450, NULL, 'PF03828', NULL, NULL, 'Cid1 family poly A polymerase', NULL, 'PAP_assoc', NULL, NULL, 5113, 9),
(269451, NULL, 'PF14087', NULL, NULL, 'Domain of unknown function (DUF4267)', NULL, 'DUF4267', NULL, NULL, 22935, 9),
(269452, NULL, 'PF10789', NULL, NULL, 'Phage RNA polymerase binding, RpbA', NULL, 'Phage_RpbA', NULL, NULL, 20959, 9),
(269453, NULL, 'PF05503', NULL, NULL, 'Poxvirus G7-like', NULL, 'Pox_G7', NULL, NULL, 12138, 9),
(269454, NULL, 'PF09784', NULL, NULL, 'Mitochondrial ribosomal protein L31', NULL, 'L31', NULL, NULL, 20497, 9),
(269455, NULL, 'PF01983', NULL, NULL, 'Guanylyl transferase CofC like', NULL, 'CofC', NULL, NULL, 5110, 9),
(269456, NULL, 'PF10427', NULL, NULL, 'Argonaute hook', NULL, 'Ago_hook', NULL, NULL, 18114, 9),
(269457, NULL, 'PF13913', NULL, NULL, 'zinc-finger of a C2HC-type', NULL, 'zf-C2HC_2', NULL, NULL, NULL, 9),
(269458, NULL, 'PF18906', NULL, NULL, 'Phage tail tube protein', NULL, 'Phage_tube_2', NULL, NULL, 36219, 9),
(269459, NULL, 'PF00936', NULL, NULL, 'BMC domain', NULL, 'BMC', NULL, NULL, 1092, 9),
(269460, NULL, 'PF02866', NULL, NULL, 'lactate/malate dehydrogenase, alpha/beta C-terminal domain', NULL, 'Ldh_1_C', NULL, NULL, 15785, 9),
(269461, NULL, 'PF09375', NULL, NULL, 'Imelysin', NULL, 'Peptidase_M75', NULL, NULL, 14531, 9),
(269462, NULL, 'PF04062', NULL, NULL, 'ARP2/3 complex ARPC3 (21 kDa) subunit', NULL, 'P21-Arc', NULL, NULL, 1083, 9),
(269463, NULL, 'PF19883', NULL, NULL, 'Family of unknown function (DUF6356)', NULL, 'DUF6356', NULL, NULL, 36878, 9),
(269464, NULL, 'PF08173', NULL, NULL, 'Membrane bound YbgT-like protein', NULL, 'YbgT_YccB', NULL, NULL, 12469, 9),
(269465, NULL, 'PF14016', NULL, NULL, 'Protein of unknown function (DUF4232)', NULL, 'DUF4232', NULL, NULL, 22077, 9),
(269466, NULL, 'PF00837', NULL, NULL, 'Iodothyronine deiodinase', NULL, 'T4_deiodinase', NULL, NULL, 3863, 9),
(269467, NULL, 'PF19323', NULL, NULL, 'BTB/POZ domain-containing protein KCTD4 C-terminus', NULL, 'KCTD4_C', NULL, NULL, 34257, 9),
(269468, NULL, 'PF01203', NULL, NULL, 'Type II secretion system (T2SS), protein N', NULL, 'T2SSN', NULL, NULL, 14687, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(269469, NULL, 'PF08516', NULL, NULL, 'ADAM cysteine-rich', NULL, 'ADAM_CR', NULL, NULL, 347, 9),
(269470, NULL, 'PF13259', NULL, NULL, 'Protein of unknown function (DUF4050)', NULL, 'DUF4050', NULL, NULL, 22649, 9),
(269471, NULL, 'PF05180', NULL, NULL, 'DNL zinc finger', NULL, 'zf-DNL', NULL, NULL, 2173, 9),
(269472, NULL, 'PF06924', NULL, NULL, 'Protein of unknown function (DUF1281)', NULL, 'DUF1281', NULL, NULL, 11893, 9),
(269473, NULL, 'PF15397', NULL, NULL, 'Domain of unknown function (DUF4618)', NULL, 'DUF4618', NULL, NULL, 21835, 9),
(269474, NULL, 'PF20024', NULL, NULL, 'Family of unknown function (DUF6432)', NULL, 'DUF6432', NULL, NULL, 35889, 9),
(269475, NULL, 'PF19046', NULL, NULL, 'GM130 C-terminal binding motif', NULL, 'GM130_C', NULL, NULL, 35045, 9),
(269476, NULL, 'PF02610', NULL, NULL, 'L-arabinose isomerase', NULL, 'Arabinose_Isome', NULL, NULL, 6372, 9),
(269477, NULL, 'PF18639', NULL, NULL, 'Yeast longin domain', NULL, 'Longin_2', NULL, NULL, 28819, 9),
(269478, NULL, 'PF09313', NULL, NULL, 'Domain of unknown function (DUF1971)', NULL, 'DUF1971', NULL, NULL, 14207, 9),
(269479, NULL, 'PF12268', NULL, NULL, 'Protein of unknown function (DUF3612)', NULL, 'DUF3612', NULL, NULL, 20049, 9),
(269480, NULL, 'PF13297', NULL, NULL, 'Replication stress response SDE2 C-terminal', NULL, 'SDE2_2C', NULL, NULL, NULL, 9),
(269481, NULL, 'PF12200', NULL, NULL, 'Domain of unknown function (DUF3597)', NULL, 'DUF3597', NULL, NULL, 20484, 9),
(269482, NULL, 'PF00501', NULL, NULL, 'AMP-binding enzyme', NULL, 'AMP-binding', NULL, NULL, 4729, 9),
(269483, NULL, 'PF17505', NULL, NULL, 'Family of unknown function (DUF5437)', NULL, 'DUF5437', NULL, NULL, 32222, 9),
(269484, NULL, 'PF16408', NULL, NULL, 'Domain of unknown function (DUF5016)', NULL, 'DUF5016', NULL, NULL, 23950, 9),
(269485, NULL, 'PF03921', NULL, NULL, 'Intercellular adhesion molecule (ICAM), N-terminal domain', NULL, 'ICAM_N', NULL, NULL, 13306, 9),
(269486, NULL, 'PF15875', NULL, NULL, 'Domain of unknown function (DUF4731)', NULL, 'DUF4731', NULL, NULL, 23877, 9),
(269487, NULL, 'PF07797', NULL, NULL, 'Protein of unknown function (DUF1639)', NULL, 'DUF1639', NULL, NULL, 14041, 9),
(269488, NULL, 'PF11352', NULL, NULL, 'Protein of unknown function (DUF3155)', NULL, 'DUF3155', NULL, NULL, 18592, 9),
(269489, NULL, 'PF00154', NULL, NULL, 'recA bacterial DNA recombination protein', NULL, 'RecA', NULL, NULL, 7303, 9),
(269490, NULL, 'PF17809', NULL, NULL, 'UPA domain', NULL, 'UPA_2', NULL, NULL, 29432, 9),
(269491, NULL, 'PF01225', NULL, NULL, 'Mur ligase family, catalytic domain', NULL, 'Mur_ligase', NULL, NULL, 3997, 9),
(269492, NULL, 'PF06480', NULL, NULL, 'FtsH Extracellular', NULL, 'FtsH_ext', NULL, NULL, 7575, 9),
(269493, NULL, 'PF13968', NULL, NULL, 'Domain of unknown function (DUF4220)', NULL, 'DUF4220', NULL, NULL, 22186, 9),
(269494, NULL, 'PF00524', NULL, NULL, 'E1 Protein, N terminal domain', NULL, 'PPV_E1_N', NULL, NULL, 7016, 9),
(269495, NULL, 'PF12140', NULL, NULL, 'SLED domain', NULL, 'SLED', NULL, NULL, 20426, 9),
(269496, NULL, 'PF10967', NULL, NULL, 'Protein of unknown function (DUF2769)', NULL, 'DUF2769', NULL, NULL, 11720, 9),
(269497, NULL, 'PF01890', NULL, NULL, 'Cobalamin synthesis G C-terminus', NULL, 'CbiG_C', NULL, NULL, 3901, 9),
(269498, NULL, 'PF06443', NULL, NULL, 'SEF14-like adhesin', NULL, 'SEF14_adhesin', NULL, NULL, 10266, 9),
(269499, NULL, 'PF13737', NULL, NULL, 'Transposase DDE domain', NULL, 'DDE_Tnp_1_5', NULL, NULL, 24235, 9),
(269500, NULL, 'PF05155', NULL, NULL, 'Phage X family', NULL, 'Phage_X', NULL, NULL, 14982, 9),
(269501, NULL, 'PF15239', NULL, NULL, 'Domain of unknown function (DUF4586)', NULL, 'DUF4586', NULL, NULL, 26124, 9),
(269502, NULL, 'PF06050', NULL, NULL, '2-hydroxyglutaryl-CoA dehydratase, D-component', NULL, 'HGD-D', NULL, NULL, 8694, 9),
(269503, NULL, 'PF12673', NULL, NULL, 'Domain of unknown function (DUF3794)', NULL, 'DUF3794', NULL, NULL, 20564, 9),
(269504, NULL, 'PF18051', NULL, NULL, '26S proteasome non-ATPase regulatory subunit RPN1 C-terminal', NULL, 'RPN1_C', NULL, NULL, 29915, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(269505, NULL, 'PF08409', NULL, NULL, 'Protein O-mannosyl-transferase TMTC, DUF1736', NULL, 'TMTC_DUF1736', NULL, NULL, 11019, 9),
(269506, NULL, 'PF16631', NULL, NULL, 'Unstructured region 4 on terminal uridylyltransferase 7', NULL, 'TUTF7_u4', NULL, NULL, NULL, 9),
(269507, NULL, 'PF06078', NULL, NULL, 'Bacterial protein of unknown function (DUF937)', NULL, 'DUF937', NULL, NULL, 13642, 9),
(269508, NULL, 'PF13199', NULL, NULL, 'Glycosyl hydrolase family 66', NULL, 'Glyco_hydro_66', NULL, NULL, 22246, 9),
(269509, NULL, 'PF09730', NULL, NULL, 'Microtubule-associated protein Bicaudal-D', NULL, 'BicD', NULL, NULL, 21187, 9),
(269510, NULL, 'PF05721', NULL, NULL, 'Phytanoyl-CoA dioxygenase (PhyH)', NULL, 'PhyH', NULL, NULL, 12478, 9),
(269511, NULL, 'PF04437', NULL, NULL, 'RINT-1 / TIP-1 family', NULL, 'RINT1_TIP1', NULL, NULL, 10514, 9),
(269512, NULL, 'PF15573', NULL, NULL, 'Immunity protein 47', NULL, 'Imm47', NULL, NULL, 25170, 9),
(269513, NULL, 'PF05420', NULL, NULL, 'Cellulose synthase operon protein C C-terminus (BCSC_C)', NULL, 'BCSC_C', NULL, NULL, 8519, 9),
(269514, NULL, 'PF15670', NULL, NULL, 'Spermatid maturation protein 1', NULL, 'Spem1', NULL, NULL, 21538, 9),
(269515, NULL, 'PF18202', NULL, NULL, 'T-Q ester bond containing domain', NULL, 'TQ', NULL, NULL, 28610, 9),
(269516, NULL, 'PF17256', NULL, NULL, 'Anaphase-promoting complex, subunit 16', NULL, 'ANAPC16', NULL, NULL, 25810, 9),
(269517, NULL, 'PF03076', NULL, NULL, 'Equine arteritis virus GP3', NULL, 'GP3', NULL, NULL, 4617, 9),
(269518, NULL, 'PF00162', NULL, NULL, 'Phosphoglycerate kinase', NULL, 'PGK', NULL, NULL, 5397, 9),
(269519, NULL, 'PF00110', NULL, NULL, 'wnt family', NULL, 'wnt', NULL, NULL, 5688, 9),
(269520, NULL, 'PF15937', NULL, NULL, 'prlF antitoxin for toxin YhaV_toxin', NULL, 'PrlF_antitoxin', NULL, NULL, 25637, 9),
(269521, NULL, 'PF01385', NULL, NULL, 'Probable transposase', NULL, 'OrfB_IS605', NULL, NULL, 2228, 9),
(269522, NULL, 'PF04527', NULL, NULL, 'Drosophila Retinin like protein', NULL, 'Retinin_C', NULL, NULL, 2885, 9),
(269523, NULL, 'PF12432', NULL, NULL, 'Protein of unknown function (DUF3677)', NULL, 'DUF3677', NULL, NULL, 20886, 9),
(269524, NULL, 'PF07233', NULL, NULL, 'Protein of unknown function (DUF1425)', NULL, 'DUF1425', NULL, NULL, 10555, 9),
(269525, NULL, 'PF14290', NULL, NULL, 'Succinate dehydrogenase subunit 5, mitochondrial', NULL, 'SDH5_plant', NULL, NULL, 21755, 9),
(269526, NULL, 'PF18103', NULL, NULL, 'Retroviral integrase C-terminal SH3 domain', NULL, 'SH3_11', NULL, NULL, 33497, 9),
(269527, NULL, 'PF15701', NULL, NULL, 'Domain of unknown function (DUF4668)', NULL, 'DUF4668', NULL, NULL, 26610, 9),
(269528, NULL, 'PF17090', NULL, NULL, 'YtcA family', NULL, 'Ytca', NULL, NULL, 24368, 9),
(269529, NULL, 'PF14713', NULL, NULL, 'Domain of unknown function (DUF4464)', NULL, 'DUF4464', NULL, NULL, 25521, 9),
(269530, NULL, 'PF04380', NULL, NULL, 'Membrane fusogenic activity', NULL, 'BMFP', NULL, NULL, 2210, 9),
(269531, NULL, 'PF00394', NULL, NULL, 'Multicopper oxidase', NULL, 'Cu-oxidase', NULL, NULL, 1079, 9),
(269532, NULL, 'PF09234', NULL, NULL, 'Domain of unknown function (DUF1963)', NULL, 'DUF1963', NULL, NULL, 13246, 9),
(269533, NULL, 'PF08204', NULL, NULL, 'CD47 immunoglobulin-like domain', NULL, 'V-set_CD47', NULL, NULL, 13021, 9),
(269534, NULL, 'PF14315', NULL, NULL, 'Domain of unknown function (DUF4380)', NULL, 'DUF4380', NULL, NULL, 26353, 9),
(269535, NULL, 'PF17230', NULL, NULL, 'Family of unknown function (DUF5304)', NULL, 'DUF5304', NULL, NULL, 20179, 9),
(269536, NULL, 'PF10973', NULL, NULL, 'Protein of unknown function (DUF2799)', NULL, 'DUF2799', NULL, NULL, 17729, 9),
(269537, NULL, 'PF16034', NULL, NULL, 'JAKMIP CC3 domain', NULL, 'JAKMIP_CC3', NULL, NULL, 22654, 9),
(269538, NULL, 'PF08944', NULL, NULL, 'NADPH oxidase subunit p47Phox, C terminal domain', NULL, 'p47_phox_C', NULL, NULL, 7994, 9),
(269539, NULL, 'PF15097', NULL, NULL, 'Immunoglobulin J chain', NULL, 'Ig_J_chain', NULL, NULL, 9860, 9),
(269540, NULL, 'PF03846', NULL, NULL, 'Cell division inhibitor SulA', NULL, 'SulA', NULL, NULL, 858, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(269541, NULL, 'PF13800', NULL, NULL, 'Sigma factor regulator N-terminal', NULL, 'Sigma_reg_N', NULL, NULL, 24638, 9),
(269542, NULL, 'PF02445', NULL, NULL, 'Quinolinate synthetase A protein', NULL, 'NadA', NULL, NULL, 6047, 9),
(269543, NULL, 'PF04140', NULL, NULL, 'Isoprenylcysteine carboxyl methyltransferase (ICMT) family', NULL, 'ICMT', NULL, NULL, 7197, 9),
(269544, NULL, 'PF17387', NULL, NULL, 'Glycosyl hydrolase family 59 central domain', NULL, 'Glyco_hydro_59M', NULL, NULL, 14828, 9),
(269545, NULL, 'PF00983', NULL, NULL, 'Tymovirus coat protein', NULL, 'Tymo_coat', NULL, NULL, 5973, 9),
(269546, NULL, 'PF14870', NULL, NULL, 'Photosynthesis system II assembly factor YCF48', NULL, 'PSII_BNR', NULL, NULL, 22275, 9),
(269547, NULL, 'PF06029', NULL, NULL, 'AlkA N-terminal domain', NULL, 'AlkA_N', NULL, NULL, 8740, 9),
(269548, NULL, 'PF06677', NULL, NULL, 'Sjogren''s syndrome/scleroderma autoantigen 1 (Autoantigen p27)', NULL, 'Auto_anti-p27', NULL, NULL, 10490, 9),
(269549, NULL, 'PF02154', NULL, NULL, 'Flagellar motor switch protein FliM', NULL, 'FliM', NULL, NULL, 3202, 9),
(269550, NULL, 'PF18475', NULL, NULL, 'PIN domain', NULL, 'PIN7', NULL, NULL, 29797, 9),
(269551, NULL, 'PF12216', NULL, NULL, 'Immune evasion protein', NULL, 'm04gp34like', NULL, NULL, 20367, 9),
(269552, NULL, 'PF04547', NULL, NULL, 'Calcium-activated chloride channel', NULL, 'Anoctamin', NULL, NULL, 2075, 9),
(269553, NULL, 'PF12334', NULL, NULL, 'Rickettsia outer membrane protein B', NULL, 'rOmpB', NULL, NULL, 20908, 9),
(269554, NULL, 'PF04557', NULL, NULL, 'Glutaminyl-tRNA synthetase, non-specific RNA binding region part 2', NULL, 'tRNA_synt_1c_R2', NULL, NULL, 2113, 9),
(269555, NULL, 'PF07029', NULL, NULL, 'CryBP1 protein', NULL, 'CryBP1', NULL, NULL, 12385, 9),
(269556, NULL, 'PF07531', NULL, NULL, 'NHR1 homology to TAF', NULL, 'TAFH', NULL, NULL, 4074, 9),
(269557, NULL, 'PF18807', NULL, NULL, 'Tripartite Tc toxins repeat', NULL, 'TTc_toxin_rep', NULL, NULL, 30189, 9),
(269558, NULL, 'PF07491', NULL, NULL, 'Protein phosphatase inhibitor', NULL, 'PPI_Ypi1', NULL, NULL, 11332, 9),
(269559, NULL, 'PF11032', NULL, NULL, 'ApoM domain', NULL, 'ApoM', NULL, NULL, 16971, 9),
(269560, NULL, 'PF00327', NULL, NULL, 'Ribosomal protein L30p/L7e', NULL, 'Ribosomal_L30', NULL, NULL, 10152, 9),
(269561, NULL, 'PF16257', NULL, NULL, 'tagaturonate epimerase', NULL, 'UxaE', NULL, NULL, 21881, 9),
(269562, NULL, 'PF16442', NULL, NULL, 'Domain of unknown function (DUF5039)', NULL, 'DUF5039', NULL, NULL, 24205, 9),
(269563, NULL, 'PF11722', NULL, NULL, 'CCCH zinc finger in TRM13 protein', NULL, 'zf-TRM13_CCCH', NULL, NULL, 19087, 9),
(269564, NULL, 'PF14994', NULL, NULL, 'Testis-specific gene 13 protein', NULL, 'TSGA13', NULL, NULL, 21922, 9),
(269565, NULL, 'PF13608', NULL, NULL, 'Protein P3 of Potyviral polyprotein', NULL, 'Potyvirid-P3', NULL, NULL, 33737, 9),
(269566, NULL, 'PF12999', NULL, NULL, 'Glucosidase II beta subunit-like', NULL, 'PRKCSH-like', NULL, NULL, 21801, 9),
(269567, NULL, 'PF02007', NULL, NULL, 'Tetrahydromethanopterin S-methyltransferase MtrH subunit', NULL, 'MtrH', NULL, NULL, 16238, 9),
(269568, NULL, 'PF10611', NULL, NULL, 'Protein of unknown function (DUF2469)', NULL, 'DUF2469', NULL, NULL, 20122, 9),
(269569, NULL, 'PF05801', NULL, NULL, 'Lagovirus protein of unknown function (DUF840)', NULL, 'DUF840', NULL, NULL, 13356, 9),
(269570, NULL, 'PF14982', NULL, NULL, 'UPF0731 family', NULL, 'UPF0731', NULL, NULL, 21645, 9),
(269571, NULL, 'PF08126', NULL, NULL, 'Propeptide_C25', NULL, 'Propeptide_C25', NULL, NULL, 9179, 9),
(269572, NULL, 'PF13971', NULL, NULL, 'Meiosis-specific protein Mei4', NULL, 'Mei4', NULL, NULL, 24213, 9),
(269573, NULL, 'PF09327', NULL, NULL, 'Domain of unknown function (DUF1983)', NULL, 'DUF1983', NULL, NULL, 14062, 9),
(269574, NULL, 'PF06865', NULL, NULL, 'Pyrimidine/purine nucleoside phosphorylase', NULL, 'Ppnp', NULL, NULL, 11528, 9),
(269575, NULL, 'PF02560', NULL, NULL, 'Cyanate lyase C-terminal domain', NULL, 'Cyanate_lyase', NULL, NULL, 2161, 9),
(269576, NULL, 'PF08765', NULL, NULL, 'Mor transcription activator family', NULL, 'Mor', NULL, NULL, 13136, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(269577, NULL, 'PF18276', NULL, NULL, 'Tc toxin complex TcA C-terminal TcB-binding domain', NULL, 'TcA_TcB_BD', NULL, NULL, 32065, 9),
(269578, NULL, 'PF20329', NULL, NULL, 'Family of unknown function (DUF6624)', NULL, 'DUF6624', NULL, NULL, 37318, 9),
(269579, NULL, 'PF00147', NULL, NULL, 'Fibrinogen beta and gamma chains, C-terminal globular domain', NULL, 'Fibrinogen_C', NULL, NULL, 5941, 9),
(269580, NULL, 'PF10428', NULL, NULL, 'RAM signalling pathway protein', NULL, 'SOG2', NULL, NULL, 18440, 9),
(269581, NULL, 'PF05522', NULL, NULL, 'Metallothionein', NULL, 'Metallothio_6', NULL, NULL, 12806, 9),
(269582, NULL, 'PF16451', NULL, NULL, 'Betacoronavirus-like spike glycoprotein S1, N-terminal', NULL, 'bCoV_S1_N', NULL, NULL, 22356, 9),
(269583, NULL, 'PF18039', NULL, NULL, 'UBA-like domain', NULL, 'UBA_6', NULL, NULL, 27057, 9),
(269584, NULL, 'PF08970', NULL, NULL, 'Sporulation inhibitor A', NULL, 'Sda', NULL, NULL, 8996, 9),
(269585, NULL, 'PF08617', NULL, NULL, 'Kinase binding protein CGI-121', NULL, 'CGI-121', NULL, NULL, 14227, 9),
(269586, NULL, 'PF00886', NULL, NULL, 'Ribosomal protein S16', NULL, 'Ribosomal_S16', NULL, NULL, 923, 9),
(269587, NULL, 'PF10985', NULL, NULL, 'Protein of unknown function (DUF2805)', NULL, 'DUF2805', NULL, NULL, 18375, 9),
(269588, NULL, 'PF14754', NULL, NULL, 'Papain-like auto-proteinase', NULL, 'IFR3_antag', NULL, NULL, 26756, 9),
(269589, NULL, 'PF13468', NULL, NULL, 'Glyoxalase-like domain', NULL, 'Glyoxalase_3', NULL, NULL, 25790, 9),
(269590, NULL, 'PF01609', NULL, NULL, 'Transposase DDE domain', NULL, 'DDE_Tnp_1', NULL, NULL, 1974, 9),
(269591, NULL, 'PF09739', NULL, NULL, 'Mini-chromosome maintenance replisome factor', NULL, 'MCM_bind', NULL, NULL, 17727, 9),
(269592, NULL, 'PF01198', NULL, NULL, 'Ribosomal protein L31e', NULL, 'Ribosomal_L31e', NULL, NULL, 2781, 9),
(269593, NULL, 'PF17925', NULL, NULL, 'Tetracyclin repressor-like, C-terminal domain', NULL, 'TetR_C_20', NULL, NULL, 30097, 9),
(269594, NULL, 'PF00694', NULL, NULL, 'Aconitase C-terminal domain', NULL, 'Aconitase_C', NULL, NULL, 5872, 9),
(269595, NULL, 'PF02932', NULL, NULL, 'Neurotransmitter-gated ion-channel transmembrane region', NULL, 'Neur_chan_memb', NULL, NULL, 1297, 9),
(269596, NULL, 'PF05263', NULL, NULL, 'Protein of unknown function (DUF722)', NULL, 'DUF722', NULL, NULL, 3138, 9),
(269597, NULL, 'PF15315', NULL, NULL, 'Facioscapulohumeral muscular dystrophy candidate 2', NULL, 'FRG2', NULL, NULL, 21449, 9),
(269598, NULL, 'PF05135', NULL, NULL, 'Phage gp6-like head-tail connector protein', NULL, 'Phage_connect_1', NULL, NULL, 15145, 9),
(269599, NULL, 'PF07064', NULL, NULL, 'RIC1', NULL, 'RIC1', NULL, NULL, 12591, 9),
(269600, NULL, 'PF12218', NULL, NULL, 'N terminal extension of bacteriophage endosialidase', NULL, 'End_N_terminal', NULL, NULL, 26602, 9),
(269601, NULL, 'PF06240', NULL, NULL, 'Carbon monoxide dehydrogenase subunit G (CoxG)', NULL, 'COXG', NULL, NULL, 9220, 9),
(269602, NULL, 'PF17395', NULL, NULL, 'Family of unknown function (DUF5403)', NULL, 'DUF5403', NULL, NULL, 30815, 9),
(269603, NULL, 'PF14897', NULL, NULL, 'EpsG family', NULL, 'EpsG', NULL, NULL, NULL, 9),
(269604, NULL, 'PF12433', NULL, NULL, 'Parvovirus non-structural protein 1', NULL, 'PV_NSP1', NULL, NULL, 15439, 9),
(269605, NULL, 'PF10637', NULL, NULL, 'Oxoglutarate and iron-dependent oxygenase degradation C-term', NULL, 'Ofd1_CTDD', NULL, NULL, 20271, 9),
(269606, NULL, 'PF02777', NULL, NULL, 'Iron/manganese superoxide dismutases, C-terminal domain', NULL, 'Sod_Fe_C', NULL, NULL, 18352, 9),
(269607, NULL, 'PF04818', NULL, NULL, 'CID domain', NULL, 'CID', NULL, NULL, 264, 9),
(269608, NULL, 'PF10447', NULL, NULL, 'Exosome component EXOSC1/CSL4', NULL, 'EXOSC1', NULL, NULL, 18389, 9),
(269609, NULL, 'PF18359', NULL, NULL, 'Histone methyltransferase Tudor domain 1', NULL, 'Tudor_5', NULL, NULL, 29106, 9),
(269610, NULL, 'PF16289', NULL, NULL, 'PIN domain', NULL, 'PIN_12', NULL, NULL, 21524, 9),
(269611, NULL, 'PF09200', NULL, NULL, 'Monellin', NULL, 'Monellin', NULL, NULL, 12346, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(269612, NULL, 'PF08343', NULL, NULL, 'Ribonucleotide reductase N-terminal', NULL, 'RNR_N', NULL, NULL, 12966, 9),
(269613, NULL, 'PF07101', NULL, NULL, 'Protein of unknown function (DUF1363)', NULL, 'DUF1363', NULL, NULL, 13049, 9),
(269614, NULL, 'PF11497', NULL, NULL, 'NADH-quinone oxidoreductase chain 15', NULL, 'NADH_Oxid_Nqo15', NULL, NULL, 15184, 9),
(269615, NULL, 'PF15756', NULL, NULL, 'Small Novel Rich in Cartilage', NULL, 'DUF4690', NULL, NULL, 24899, 9),
(269616, NULL, 'PF08649', NULL, NULL, 'DASH complex subunit Dad1', NULL, 'DASH_Dad1', NULL, NULL, 7855, 9),
(269617, NULL, 'PF13367', NULL, NULL, 'PrsW family intramembrane metalloprotease', NULL, 'PrsW-protease', NULL, NULL, 26792, 9),
(269618, NULL, 'PF16222', NULL, NULL, 'Domain of unknown function (DUF4881)', NULL, 'DUF4881', NULL, NULL, 26128, 9),
(269619, NULL, 'PF15951', NULL, NULL, 'MITF/TFEB/TFEC/TFE3 N-terminus', NULL, 'MITF_TFEB_C_3_N', NULL, NULL, 22249, 9),
(269620, NULL, 'PF19368', NULL, NULL, 'AraR C-terminal winged HTH domain', NULL, 'AraR_C', NULL, NULL, 37278, 9),
(269621, NULL, 'PF09959', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2193)', NULL, 'DUF2193', NULL, NULL, 17464, 9),
(269622, NULL, 'PF11573', NULL, NULL, 'Mediator complex subunit 23', NULL, 'Med23', NULL, NULL, 18567, 9),
(269623, NULL, 'PF07939', NULL, NULL, 'Protein of unknown function (DUF1685)', NULL, 'DUF1685', NULL, NULL, 13471, 9),
(269624, NULL, 'PF00390', NULL, NULL, 'Malic enzyme, N-terminal domain', NULL, 'malic', NULL, NULL, 13077, 9),
(269625, NULL, 'PF01826', NULL, NULL, 'Trypsin Inhibitor like cysteine rich domain', NULL, 'TIL', NULL, NULL, 6146, 9),
(269626, NULL, 'PF15452', NULL, NULL, 'Neuronal tyrosine-phosphorylated phosphoinositide-3-kinase adapter', NULL, 'NYAP_C', NULL, NULL, 23147, 9),
(269627, NULL, 'PF15586', NULL, NULL, 'Immunity protein 8', NULL, 'Imm8', NULL, NULL, 24996, 9),
(269628, NULL, 'PF05209', NULL, NULL, 'Septum formation inhibitor MinC, N-terminal domain', NULL, 'MinC_N', NULL, NULL, 3073, 9),
(269629, NULL, 'PF11647', NULL, NULL, 'Membrane Localization Domain', NULL, 'MLD', NULL, NULL, 14534, 9),
(269630, NULL, 'PF08240', NULL, NULL, 'Alcohol dehydrogenase GroES-like domain', NULL, 'ADH_N', NULL, NULL, 8329, 9),
(269631, NULL, 'PF17441', NULL, NULL, 'Family of unknown function (DUF5419)', NULL, 'DUF5419', NULL, NULL, 33122, 9),
(269632, NULL, 'PF03625', NULL, NULL, 'Domain of unknown function DUF302', NULL, 'DUF302', NULL, NULL, 5377, 9),
(269633, NULL, 'PF04616', NULL, NULL, 'Glycosyl hydrolases family 43', NULL, 'Glyco_hydro_43', NULL, NULL, 2455, 9),
(269634, NULL, 'PF10615', NULL, NULL, 'Domain of unknown function (DUF2470)', NULL, 'DUF2470', NULL, NULL, 20208, 9),
(269635, NULL, 'PF10798', NULL, NULL, 'Biofilm development protein YmgB/AriR', NULL, 'YmgB', NULL, NULL, 19029, 9),
(269636, NULL, 'PF17968', NULL, NULL, 'Toll-like receptor 3 trans-membrane domain', NULL, 'Tlr3_TMD', NULL, NULL, 31416, 9),
(269637, NULL, 'PF12203', NULL, NULL, 'Glutamine rich N terminal domain of histone deacetylase 4', NULL, 'HDAC4_Gln', NULL, NULL, 4660, 9),
(269638, NULL, 'PF12777', NULL, NULL, 'Microtubule-binding stalk of dynein motor', NULL, 'MT', NULL, NULL, 12449, 9),
(269639, NULL, 'PF00907', NULL, NULL, 'T-box', NULL, 'T-box', NULL, NULL, 36881, 9),
(269640, NULL, 'PF07356', NULL, NULL, 'Protein of unknown function (DUF1481)', NULL, 'DUF1481', NULL, NULL, 11595, 9),
(269641, NULL, 'PF15518', NULL, NULL, 'L protein N-terminus', NULL, 'L_protein_N', NULL, NULL, 23596, 9),
(269642, NULL, 'PF03430', NULL, NULL, 'Trans-activating transcriptional regulator', NULL, 'TATR', NULL, NULL, 10482, 9),
(269643, NULL, 'PF04567', NULL, NULL, 'RNA polymerase Rpb2, domain 5', NULL, 'RNA_pol_Rpb2_5', NULL, NULL, 477, 9),
(269644, NULL, 'PF05422', NULL, NULL, 'Stress-activated map kinase interacting protein 1 (SIN1)', NULL, 'SIN1', NULL, NULL, 26045, 9),
(269645, NULL, 'PF06508', NULL, NULL, 'Queuosine biosynthesis protein QueC', NULL, 'QueC', NULL, NULL, 16631, 9),
(269646, NULL, 'PF14869', NULL, NULL, 'Domain of unknown function (DUF4488)', NULL, 'DUF4488', NULL, NULL, 24509, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(269647, NULL, 'PF15440', NULL, NULL, 'THRAP3/BCLAF1 family', NULL, 'THRAP3_BCLAF1', NULL, NULL, 26523, 9),
(269648, NULL, 'PF18331', NULL, NULL, 'PKHD-type hydroxylase C-terminal domain', NULL, 'PKHD_C', NULL, NULL, 29045, 9),
(269649, NULL, 'PF07116', NULL, NULL, 'Protein of unknown function (DUF1372)', NULL, 'DUF1372', NULL, NULL, 10661, 9),
(269650, NULL, 'PF12950', NULL, NULL, 'TaqI-like C-terminal specificity domain', NULL, 'TaqI_C', NULL, NULL, 24553, 9),
(269651, NULL, 'PF12895', NULL, NULL, 'Anaphase-promoting complex, cyclosome, subunit 3', NULL, 'ANAPC3', NULL, NULL, NULL, 9),
(269652, NULL, 'PF04495', NULL, NULL, 'GRASP55/65 PDZ-like domain', NULL, 'GRASP55_65', NULL, NULL, 23968, 9),
(269653, NULL, 'PF00857', NULL, NULL, 'Isochorismatase family', NULL, 'Isochorismatase', NULL, NULL, 222, 9),
(269654, NULL, 'PF12091', NULL, NULL, 'Protein of unknown function (DUF3567)', NULL, 'DUF3567', NULL, NULL, 20250, 9),
(269655, NULL, 'PF03402', NULL, NULL, 'Vomeronasal organ pheromone receptor family, V1R', NULL, 'V1R', NULL, NULL, 1741, 9),
(269656, NULL, 'PF12506', NULL, NULL, 'Protein of unknown function (DUF3713)', NULL, 'DUF3713', NULL, NULL, 21265, 9),
(269657, NULL, 'PF03712', NULL, NULL, 'Copper type II ascorbate-dependent monooxygenase, C-terminal domain', NULL, 'Cu2_monoox_C', NULL, NULL, 22914, 9),
(269658, NULL, 'PF16644', NULL, NULL, 'Regulatory region of Na+/H+ exchanger NHE binds to calmodulin', NULL, 'NEXCaM_BD', NULL, NULL, 22614, 9),
(269659, NULL, 'PF18940', NULL, NULL, 'Family of unknown function (DUF5687)', NULL, 'DUF5687', NULL, NULL, 34436, 9),
(269660, NULL, 'PF01656', NULL, NULL, 'CobQ/CobB/MinD/ParA nucleotide binding domain', NULL, 'CbiA', NULL, NULL, 1947, 9),
(269661, NULL, 'PF18261', NULL, NULL, 'Rpn9 C-terminal helix', NULL, 'Rpn9_C', NULL, NULL, 29427, 9),
(269662, NULL, 'PF01527', NULL, NULL, 'Transposase', NULL, 'HTH_Tnp_1', NULL, NULL, 666, 9),
(269663, NULL, 'PF03622', NULL, NULL, 'IBV 3B protein', NULL, 'IBV_3B', NULL, NULL, 5358, 9),
(269664, NULL, 'PF06266', NULL, NULL, 'HrpF protein', NULL, 'HrpF', NULL, NULL, 14486, 9),
(269665, NULL, 'PF04619', NULL, NULL, 'Dr-family adhesin', NULL, 'Adhesin_Dr', NULL, NULL, 2472, 9),
(269666, NULL, 'PF14716', NULL, NULL, 'Helix-hairpin-helix domain', NULL, 'HHH_8', NULL, NULL, 8929, 9),
(269667, NULL, 'PF05640', NULL, NULL, 'Na,K-Atpase Interacting protein', NULL, 'NKAIN', NULL, NULL, 12551, 9),
(269668, NULL, 'PF11161', NULL, NULL, 'Protein of unknown function (DUF2946)', NULL, 'DUF2944', NULL, NULL, 17873, 9),
(269669, NULL, 'PF04991', NULL, NULL, 'LicD family', NULL, 'LicD', NULL, NULL, 7495, 9),
(269670, NULL, 'PF09125', NULL, NULL, 'Cytochrome C oxidase subunit II, transmembrane', NULL, 'COX2-transmemb', NULL, NULL, 10848, 9),
(269671, NULL, 'PF09744', NULL, NULL, 'JNK_SAPK-associated protein-1', NULL, 'Jnk-SapK_ap_N', NULL, NULL, 18022, 9),
(269672, NULL, 'PF20011', NULL, NULL, 'JAB N-terminal domain', NULL, 'fvmJAB_N', NULL, NULL, 36245, 9),
(269673, NULL, 'PF18209', NULL, NULL, 'Embryo surrounding factor 1', NULL, 'ESF1', NULL, NULL, 29776, 9),
(269674, NULL, 'PF17085', NULL, NULL, 'Unique cartilage matrix associated protein', NULL, 'UCMA', NULL, NULL, 24435, 9),
(269675, NULL, 'PF08683', NULL, NULL, 'Microtubule-binding calmodulin-regulated spectrin-associated', NULL, 'CAMSAP_CKK', NULL, NULL, 11043, 9),
(269676, NULL, 'PF12352', NULL, NULL, 'Snare region anchored in the vesicle membrane C-terminus', NULL, 'V-SNARE_C', NULL, NULL, NULL, 9),
(269677, NULL, 'PF14830', NULL, NULL, 'Haemocyanin beta-sandwich', NULL, 'Haemocyan_bet_s', NULL, NULL, 26551, 9),
(269678, NULL, 'PF09280', NULL, NULL, 'XPC-binding domain', NULL, 'XPC-binding', NULL, NULL, 13699, 9),
(269679, NULL, 'PF13249', NULL, NULL, 'Squalene-hopene cyclase N-terminal domain', NULL, 'SQHop_cyclase_N', NULL, NULL, 26811, 9),
(269680, NULL, 'PF09392', NULL, NULL, 'Type III secretion needle MxiH, YscF, SsaG, EprI, PscF, EscF', NULL, 'T3SS_needle_F', NULL, NULL, 9359, 9),
(269681, NULL, 'PF11577', NULL, NULL, 'NF-kappa-B essential modulator NEMO', NULL, 'NEMO', NULL, NULL, 15161, 9);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(269682, NULL, 'PF16473', NULL, NULL, '3''-5'' exoribonuclease Rv2179c-like domain', NULL, 'Rv2179c-like', NULL, NULL, 28479, 9),
(269683, NULL, 'PF09053', NULL, NULL, 'CagZ', NULL, 'CagZ', NULL, NULL, 9619, 9),
(269684, NULL, 'PF13790', NULL, NULL, 'SR1 protein', NULL, 'SR1P', NULL, NULL, 23023, 9),
(269685, NULL, 'PF15871', NULL, NULL, 'Junction-mediating and -regulatory protein', NULL, 'JMY', NULL, NULL, 23815, 9),
(269686, NULL, 'PF09046', NULL, NULL, 'AvrPtoB E3 ubiquitin ligase', NULL, 'AvrPtoB-E3_ubiq', NULL, NULL, 9580, 9),
(269687, NULL, 'PF06389', NULL, NULL, 'Filovirus membrane-associated protein VP24', NULL, 'Filo_VP24', NULL, NULL, 8367, 9),
(269688, NULL, 'PF10119', NULL, NULL, 'Predicted methyltransferase regulatory domain', NULL, 'MethyTransf_Reg', NULL, NULL, 18061, 9),
(269689, NULL, 'PF12694', NULL, NULL, 'Circularly permutated YpsA SLOG family', NULL, 'cpYpsA', NULL, NULL, 25221, 9),
(269690, NULL, 'PF08642', NULL, NULL, 'Histone deacetylation protein Rxt3', NULL, 'Rxt3', NULL, NULL, 7988, 9),
(269691, NULL, 'PF01670', NULL, NULL, 'Glycosyl hydrolase family 12', NULL, 'Glyco_hydro_12', NULL, NULL, 1678, 9),
(269692, NULL, 'PF17626', NULL, NULL, 'Inclusion membrane protein F', NULL, 'IncF', NULL, NULL, 8370, 9),
(269693, NULL, 'PF04916', NULL, NULL, 'Phospholipase B', NULL, 'Phospholip_B', NULL, NULL, 6306, 9),
(269694, NULL, 'PF17108', NULL, NULL, 'N-terminal small S protein of HET, non-prionic', NULL, 'HET-S', NULL, NULL, 2757, 9),
(269695, NULL, 'PF02852', NULL, NULL, 'Pyridine nucleotide-disulphide oxidoreductase, dimerisation domain', NULL, 'Pyr_redox_dim', NULL, NULL, 1628, 9),
(269696, NULL, 'PF13471', NULL, NULL, 'Transglutaminase-like superfamily', NULL, 'Transglut_core3', NULL, NULL, 26819, 9),
(269697, NULL, 'PF20574', NULL, NULL, 'Family of unknown function (DUF6783)', NULL, 'DUF6783', NULL, NULL, 37467, 9),
(269698, NULL, 'PF03287', NULL, NULL, 'Poxvirus C7/F8A protein', NULL, 'Pox_C7_F8A', NULL, NULL, 2731, 9),
(269699, NULL, 'PF03358', NULL, NULL, 'NADPH-dependent FMN reductase', NULL, 'FMN_red', NULL, NULL, 1061, 9),
(269700, NULL, 'PF13093', NULL, NULL, 'Kinetochore complex Fta4 of Sim4 subunit, or CENP-50', NULL, 'FTA4', NULL, NULL, 21763, 9),
(269701, NULL, 'PF19252', NULL, NULL, 'HIND motif', NULL, 'HIND', NULL, NULL, 34691, 9),
(269702, NULL, 'PF00756', NULL, NULL, 'Putative esterase', NULL, 'Esterase', NULL, NULL, 4946, 9),
(269703, NULL, 'PF01082', NULL, NULL, 'Copper type II ascorbate-dependent monooxygenase, N-terminal domain', NULL, 'Cu2_monooxygen', NULL, NULL, 5000, 9),
(269704, NULL, 'PF18908', NULL, NULL, 'Protein of unknown function (DUF5663)', NULL, 'DUF5663', NULL, NULL, 35915, 9),
(269705, NULL, 'PF16846', NULL, NULL, 'Centromere DNA-binding protein complex CBF3 subunit B', NULL, 'Cep3', NULL, NULL, 22781, 9),
(269706, NULL, 'PF14755', NULL, NULL, 'Nsp2, transmembrane domain', NULL, 'Nsp2_AV', NULL, NULL, 22063, 9),
(269707, NULL, 'PF04045', NULL, NULL, 'Arp2/3 complex, 34 kD subunit p34-Arc', NULL, 'P34-Arc', NULL, NULL, 1057, 9),
(269708, NULL, 'PF18481', NULL, NULL, 'Domain of unknown function (DUF5616)', NULL, 'DUF5616', NULL, NULL, 30384, 9),
(269709, NULL, 'PF10144', NULL, NULL, 'Bacterial virulence factor haemolysin', NULL, 'SMP_2', NULL, NULL, 14580, 9),
(269710, NULL, 'PF14328', NULL, NULL, 'Domain of unknown function (DUF4385)', NULL, 'DUF4385', NULL, NULL, 26195, 9),
(269711, NULL, 'PF15847', NULL, NULL, 'Major keratinocyte cell envelope protein', NULL, 'Loricrin', NULL, NULL, 21638, 9),
(269712, NULL, 'PF09534', NULL, NULL, 'Tryptophan-associated transmembrane protein (Trp_oprn_chp)', NULL, 'Trp_oprn_chp', NULL, NULL, 16629, 9),
(269713, NULL, 'PF06998', NULL, NULL, 'Protein of unknown function (DUF1307)', NULL, 'DUF1307', NULL, NULL, 12205, 9),
(269714, NULL, 'PF11103', NULL, NULL, 'Protein of unknown function (DUF2887)', NULL, 'DUF2887', NULL, NULL, 16034, 9),
(269715, NULL, 'PF00800', NULL, NULL, 'Prephenate dehydratase', NULL, 'PDT', NULL, NULL, 4478, 9),
(269716, NULL, 'PF19493', NULL, NULL, 'Trypsin-co-occurring domain 1', NULL, 'Trypco1', NULL, NULL, 36240, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(269717, NULL, 'PF01428', NULL, NULL, 'AN1-like Zinc finger', NULL, 'zf-AN1', NULL, NULL, 3586, 9),
(269718, NULL, 'PF19345', NULL, NULL, 'Mycobacterial methylenetetrahydrofolate reductase', NULL, 'MTHFR_2', NULL, NULL, NULL, 9),
(269719, NULL, 'PF03515', NULL, NULL, 'Colicin-like bacteriocin tRNase domain', NULL, 'Cloacin', NULL, NULL, 13938, 9),
(269720, NULL, 'PF07220', NULL, NULL, 'Protein of unknown function (DUF1420)', NULL, 'DUF1420', NULL, NULL, 10577, 9),
(269721, NULL, 'PF16429', NULL, NULL, 'Domain of unknown function (DUF5026)', NULL, 'DUF5026', NULL, NULL, 24048, 9),
(269722, NULL, 'PF15217', NULL, NULL, 'TSC21 family', NULL, 'TSC21', NULL, NULL, 26314, 9),
(269723, NULL, 'PF02468', NULL, NULL, 'Photosystem II reaction centre N protein (psbN)', NULL, 'PsbN', NULL, NULL, 5449, 9),
(269724, NULL, 'PF07664', NULL, NULL, 'Ferrous iron transport protein B C terminus', NULL, 'FeoB_C', NULL, NULL, 10819, 9),
(269725, NULL, 'PF19727', NULL, NULL, 'Family of unknown function (DUF6219)', NULL, 'DUF6219', NULL, NULL, 37018, 9),
(269726, NULL, 'PF07043', NULL, NULL, 'Protein of unknown function (DUF1328)', NULL, 'DUF1328', NULL, NULL, 12368, 9),
(269727, NULL, 'PF10699', NULL, NULL, 'Male gamete fusion factor', NULL, 'HAP2-GCS1', NULL, NULL, 14693, 9),
(269728, NULL, 'PF08645', NULL, NULL, 'Polynucleotide kinase 3 phosphatase', NULL, 'PNK3P', NULL, NULL, 7771, 9),
(269729, NULL, 'PF17738', NULL, NULL, 'Family of unknown function (DUF5575)', NULL, 'DUF5575', NULL, NULL, 32752, 9),
(269730, NULL, 'PF17766', NULL, NULL, 'Fibronectin type-III domain', NULL, 'fn3_6', NULL, NULL, 29680, 9),
(269731, NULL, 'PF04223', NULL, NULL, 'Citrate lyase, alpha subunit (CitF)', NULL, 'CitF', NULL, NULL, 6450, 9),
(269732, NULL, 'PF05672', NULL, NULL, 'MAP7 (E-MAP-115) family', NULL, 'MAP7', NULL, NULL, 14003, 9),
(269733, NULL, 'PF13846', NULL, NULL, 'Domain of unknown function (DUF4196)', NULL, 'DUF4196', NULL, NULL, 23474, 9),
(269734, NULL, 'PF01940', NULL, NULL, 'Integral membrane protein DUF92', NULL, 'DUF92', NULL, NULL, 4852, 9),
(269735, NULL, 'PF16271', NULL, NULL, 'Domain of unknown function (DUF4924)', NULL, 'DUF4924', NULL, NULL, 21915, 9),
(269736, NULL, 'PF20276', NULL, NULL, 'C-terminal domain 1 of the ABC-three component (ABC-3C) systems', NULL, 'CTD1', NULL, NULL, 34426, 9),
(269737, NULL, 'PF10614', NULL, NULL, 'Type VIII secretion system (T8SS), CsgF protein', NULL, 'CsgF', NULL, NULL, 20530, 9),
(269738, NULL, 'PF16338', NULL, NULL, 'Alpha-glucosidase, N-terminal', NULL, 'AGL_N', NULL, NULL, 22499, 9),
(269739, NULL, 'PF07878', NULL, NULL, 'CopG-like RHH_1 or ribbon-helix-helix domain, RHH_5', NULL, 'RHH_5', NULL, NULL, 12089, 9),
(269740, NULL, 'PF03363', NULL, NULL, 'Herpesvirus leader protein', NULL, 'Herpes_LP', NULL, NULL, 1017, 9),
(269741, NULL, 'PF05918', NULL, NULL, 'Apoptosis inhibitory protein 5 (API5)', NULL, 'API5', NULL, NULL, 7656, 9),
(269742, NULL, 'PF12905', NULL, NULL, 'Endo-alpha-N-acetylgalactosaminidase', NULL, 'Glyco_hydro_101', NULL, NULL, 24577, 9),
(269743, NULL, 'PF07668', NULL, NULL, 'M penetrans paralogue family 1', NULL, 'MpPF1', NULL, NULL, 10829, 9),
(269744, NULL, 'PF12771', NULL, NULL, 'Starch-binding associating with outer membrane', NULL, 'SusD-like_2', NULL, NULL, 30768, 9),
(269745, NULL, 'PF15311', NULL, NULL, 'Hydrolethalus syndrome protein 1 C-terminus', NULL, 'HYLS1_C', NULL, NULL, 24900, 9),
(269746, NULL, 'PF15603', NULL, NULL, 'Immunity protein 74', NULL, 'Imm74', NULL, NULL, 21967, 9),
(269747, NULL, 'PF16438', NULL, NULL, 'Domain of unknown function (DUF5035)', NULL, 'DUF5035', NULL, NULL, 24328, 9),
(269748, NULL, 'PF02845', NULL, NULL, 'CUE domain', NULL, 'CUE', NULL, NULL, 4183, 9),
(269749, NULL, 'PF06291', NULL, NULL, 'Bor protein', NULL, 'Lambda_Bor', NULL, NULL, 9235, 9),
(269750, NULL, 'PF14102', NULL, NULL, 'Capsule biosynthesis CapC', NULL, 'Caps_synth_CapC', NULL, NULL, 7732, 9),
(269751, NULL, 'PF12214', NULL, NULL, 'Cell cycle regulated microtubule associated protein', NULL, 'TPX2_importin', NULL, NULL, 24520, 9),
(269752, NULL, 'PF02764', NULL, NULL, 'Diphtheria toxin, T domain', NULL, 'Diphtheria_T', NULL, NULL, 21356, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(269753, NULL, 'PF07433', NULL, NULL, 'Protein of unknown function (DUF1513)', NULL, 'DUF1513', NULL, NULL, 7506, 9),
(269754, NULL, 'PF00534', NULL, NULL, 'Glycosyl transferases group 1', NULL, 'Glycos_transf_1', NULL, NULL, 2019, 9),
(269755, NULL, 'PF09380', NULL, NULL, 'FERM C-terminal PH-like domain', NULL, 'FERM_C', NULL, NULL, 14977, 9),
(269756, NULL, 'PF01206', NULL, NULL, 'Sulfurtransferase TusA', NULL, 'TusA', NULL, NULL, 3217, 9),
(269757, NULL, 'PF11340', NULL, NULL, 'Protein of unknown function (DUF3142)', NULL, 'DUF3142', NULL, NULL, 18904, 9),
(269758, NULL, 'PF03047', NULL, NULL, 'COMC family', NULL, 'ComC', NULL, NULL, 4976, 9),
(269759, NULL, 'PF05981', NULL, NULL, 'CreA protein', NULL, 'CreA', NULL, NULL, 7944, 9),
(269760, NULL, 'PF00201', NULL, NULL, 'UDP-glucoronosyl and UDP-glucosyl transferase', NULL, 'UDPGT', NULL, NULL, 5549, 9),
(269761, NULL, 'PF01803', NULL, NULL, 'LIM-domain binding protein', NULL, 'LIM_bind', NULL, NULL, 26989, 9),
(269762, NULL, 'PF02961', NULL, NULL, 'Barrier to autointegration factor', NULL, 'BAF', NULL, NULL, 1899, 9),
(269763, NULL, 'PF07698', NULL, NULL, '7TM receptor with intracellular HD hydrolase', NULL, '7TM-7TMR_HD', NULL, NULL, 9968, 9),
(269764, NULL, 'PF11823', NULL, NULL, 'Putative Se/S carrier protein-like', NULL, 'Se_S_carrier', NULL, NULL, 19247, 9),
(269765, NULL, 'PF12974', NULL, NULL, 'ABC transporter, phosphonate, periplasmic substrate-binding protein', NULL, 'Phosphonate-bd', NULL, NULL, NULL, 9),
(269766, NULL, 'PF07328', NULL, NULL, 'T-DNA border endonuclease VirD1', NULL, 'VirD1', NULL, NULL, 8326, 9),
(269767, NULL, 'PF01341', NULL, NULL, 'Glycosyl hydrolases family 6', NULL, 'Glyco_hydro_6', NULL, NULL, 19678, 9),
(269768, NULL, 'PF16825', NULL, NULL, 'IGP family C-type lectin domain', NULL, 'DUF5075', NULL, NULL, 25846, 9),
(269769, NULL, 'PF12408', NULL, NULL, 'Ribose-5-phosphate isomerase', NULL, 'DUF3666', NULL, NULL, 20845, 9),
(269770, NULL, 'PF16917', NULL, NULL, 'Biotin/lipoate A/B protein ligase family', NULL, 'BPL_LplA_LipB_2', NULL, NULL, 2571, 9),
(269771, NULL, 'PF04542', NULL, NULL, 'Sigma-70 region 2', NULL, 'Sigma70_r2', NULL, NULL, 2199, 9),
(269772, NULL, 'PF14354', NULL, NULL, 'Restriction alleviation protein Lar', NULL, 'Lar_restr_allev', NULL, NULL, NULL, 9),
(269773, NULL, 'PF12592', NULL, NULL, 'ATPase, RavA, C-terminal', NULL, 'ATPase_RavA_C', NULL, NULL, 16185, 9),
(269774, NULL, 'PF01153', NULL, NULL, 'Glypican', NULL, 'Glypican', NULL, NULL, 4088, 9),
(269775, NULL, 'PF04361', NULL, NULL, 'Protein of unknown function (DUF494)', NULL, 'DUF494', NULL, NULL, 4653, 9),
(269776, NULL, 'PF11375', NULL, NULL, 'Protein of unknown function (DUF3177)', NULL, 'DUF3177', NULL, NULL, 18710, 9),
(269777, NULL, 'PF00322', NULL, NULL, 'Endothelin family', NULL, 'Endothelin', NULL, NULL, 4174, 9),
(269778, NULL, 'PF07102', NULL, NULL, 'Putative nuclease YbcO', NULL, 'YbcO', NULL, NULL, 10944, 9),
(269779, NULL, 'PF12313', NULL, NULL, 'NPR1/NIM1 like defence protein C terminal', NULL, 'NPR1_like_C', NULL, NULL, 15251, 9),
(269780, NULL, 'PF12756', NULL, NULL, 'C2H2 type zinc-finger (2 copies)', NULL, 'zf-C2H2_2', NULL, NULL, 30774, 9),
(269781, NULL, 'PF19141', NULL, NULL, 'Family of unknown function (DUF5824)', NULL, 'DUF5824', NULL, NULL, 34190, 9),
(269782, NULL, 'PF06409', NULL, NULL, 'Nuclear pore complex interacting protein (NPIP)', NULL, 'NPIP', NULL, NULL, 8024, 9),
(269783, NULL, 'PF11706', NULL, NULL, 'CGNR zinc finger', NULL, 'zf-CGNR', NULL, NULL, 14625, 9),
(269784, NULL, 'PF15744', NULL, NULL, 'Uncharacterized protein family UPF0492', NULL, 'UPF0492', NULL, NULL, 22532, 9),
(269785, NULL, 'PF18773', NULL, NULL, 'Importin 13 repeat', NULL, 'Importin_rep', NULL, NULL, 28072, 9),
(269786, NULL, 'PF05893', NULL, NULL, 'Acyl-CoA reductase (LuxC)', NULL, 'LuxC', NULL, NULL, 12737, 9),
(269787, NULL, 'PF14008', NULL, NULL, 'Iron/zinc purple acid phosphatase-like protein C', NULL, 'Metallophos_C', NULL, NULL, 22603, 9),
(269788, NULL, 'PF08541', NULL, NULL, '3-Oxoacyl-[acyl-carrier-protein (ACP)] synthase III C terminal', NULL, 'ACP_syn_III_C', NULL, NULL, 7895, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(269789, NULL, 'PF17394', NULL, NULL, 'Uncharacterized KleE stable inheritance protein', NULL, 'KleE', NULL, NULL, 30592, 9),
(269790, NULL, 'PF02554', NULL, NULL, 'Carbon starvation protein CstA', NULL, 'CstA', NULL, NULL, 2323, 9),
(269791, NULL, 'PF12037', NULL, NULL, 'ATPase family AAA domain-containing protein 3, N-terminal', NULL, 'ATAD3_N', NULL, NULL, 19627, 9),
(269792, NULL, 'PF04267', NULL, NULL, 'Sarcosine oxidase, delta subunit family', NULL, 'SoxD', NULL, NULL, 3812, 9),
(269793, NULL, 'PF20383', NULL, NULL, 'Family of unknown function (DUF6678)', NULL, 'DUF6678', NULL, NULL, 37581, 9),
(269794, NULL, 'PF00489', NULL, NULL, 'Interleukin-6/G-CSF/MGF family', NULL, 'IL6', NULL, NULL, 273, 9),
(269795, NULL, 'PF10254', NULL, NULL, 'PACS-1 cytosolic sorting protein', NULL, 'Pacs-1', NULL, NULL, 15823, 9),
(269796, NULL, 'PF11684', NULL, NULL, 'Protein of unknown function (DUF2380)', NULL, 'DUF3280', NULL, NULL, 19295, 9),
(269797, NULL, 'PF00013', NULL, NULL, 'KH domain', NULL, 'KH_1', NULL, NULL, 1895, 9),
(269798, NULL, 'PF16015', NULL, NULL, 'Promethin', NULL, 'Promethin', NULL, NULL, NULL, 9),
(269799, NULL, 'PF12655', NULL, NULL, 'Domain of unknown function (DUF3787)', NULL, 'DUF3787', NULL, NULL, 17111, 9),
(269800, NULL, 'PF00041', NULL, NULL, 'Fibronectin type III domain', NULL, 'fn3', NULL, NULL, 7389, 9),
(269801, NULL, 'PF04382', NULL, NULL, 'SAB domain', NULL, 'SAB', NULL, NULL, 2436, 9),
(269802, NULL, 'PF14529', NULL, NULL, 'Endonuclease-reverse transcriptase', NULL, 'Exo_endo_phos_2', NULL, NULL, 7323, 9),
(269803, NULL, 'PF01256', NULL, NULL, 'Carbohydrate kinase', NULL, 'Carb_kinase', NULL, NULL, 5788, 9),
(269804, NULL, 'PF07872', NULL, NULL, 'Protein of unknown function (DUF1659)', NULL, 'DUF1659', NULL, NULL, 14348, 9),
(269805, NULL, 'PF14664', NULL, NULL, 'Rapamycin-insensitive companion of mTOR, N-term', NULL, 'RICTOR_N', NULL, NULL, 23452, 9),
(269806, NULL, 'PF07079', NULL, NULL, 'Protein of unknown function (DUF1347)', NULL, 'DUF1347', NULL, NULL, 9729, 9),
(269807, NULL, 'PF18917', NULL, NULL, 'Domain of unknown function (DUF5668)', NULL, 'DUF5668', NULL, NULL, 34485, 9),
(269808, NULL, 'PF08770', NULL, NULL, 'Sulphur oxidation protein SoxZ', NULL, 'SoxZ', NULL, NULL, 13170, 9),
(269809, NULL, 'PF19660', NULL, NULL, 'Family of unknown function (DUF6163)', NULL, 'DUF6163', NULL, NULL, 37143, 9),
(269810, NULL, 'PF01970', NULL, NULL, 'Tripartite tricarboxylate transporter TctA family', NULL, 'TctA', NULL, NULL, 4937, 9),
(269811, NULL, 'PF03612', NULL, NULL, 'Sorbitol phosphotransferase enzyme II N-terminus', NULL, 'EIIBC-GUT_N', NULL, NULL, 10884, 9),
(269812, NULL, 'PF00788', NULL, NULL, 'Ras association (RalGDS/AF-6) domain', NULL, 'RA', NULL, NULL, 3992, 9),
(269813, NULL, 'PF12845', NULL, NULL, 'TBD domain', NULL, 'TBD', NULL, NULL, 23502, 9),
(269814, NULL, 'PF09245', NULL, NULL, 'Mycoplasma arthritidis-derived mitogen', NULL, 'MA-Mit', NULL, NULL, 13166, 9),
(269815, NULL, 'PF11583', NULL, NULL, 'P-aminobenzoate N-oxygenase AurF', NULL, 'AurF', NULL, NULL, 25766, 9),
(269816, NULL, 'PF18029', NULL, NULL, 'Glyoxalase-like domain', NULL, 'Glyoxalase_6', NULL, NULL, 30443, 9),
(269817, NULL, 'PF16381', NULL, NULL, 'Coatomer subunit gamma-1 C-terminal appendage platform', NULL, 'Coatomer_g_Cpla', NULL, NULL, 22477, 9),
(269818, NULL, 'PF01988', NULL, NULL, 'VIT family', NULL, 'VIT1', NULL, NULL, 535, 9),
(269819, NULL, 'PF03953', NULL, NULL, 'Tubulin C-terminal domain', NULL, 'Tubulin_C', NULL, NULL, 16934, 9),
(269820, NULL, 'PF03672', NULL, NULL, 'Uncharacterised protein family (UPF0154)', NULL, 'UPF0154', NULL, NULL, 6314, 9),
(269821, NULL, 'PF09715', NULL, NULL, 'Plasmodium protein of unknown function (Plasmod_dom_1)', NULL, 'Plasmod_dom_1', NULL, NULL, 5614, 9),
(269822, NULL, 'PF01743', NULL, NULL, 'Poly A polymerase head domain', NULL, 'PolyA_pol', NULL, NULL, 2749, 9),
(269823, NULL, 'PF04190', NULL, NULL, 'Golgi to ER traffic protein 4', NULL, 'GET4', NULL, NULL, 4907, 9),
(269824, NULL, 'PF13160', NULL, NULL, 'Protein of unknown function (DUF3995)', NULL, 'DUF3995', NULL, NULL, 22819, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(269825, NULL, 'PF09041', NULL, NULL, 'Aurora-A binding', NULL, 'Aurora-A_bind', NULL, NULL, 9554, 9),
(269826, NULL, 'PF06741', NULL, NULL, 'LsmAD domain', NULL, 'LsmAD', NULL, NULL, 1579, 9),
(269827, NULL, 'PF16735', NULL, NULL, 'Unconventional myosin-X coiled coil domain', NULL, 'MYO10_CC', NULL, NULL, 22151, 9),
(269828, NULL, 'PF17716', NULL, NULL, 'Family of unknown function (DUF5561)', NULL, 'DUF5561', NULL, NULL, 32868, 9),
(269829, NULL, 'PF08458', NULL, NULL, 'Plant pleckstrin homology-like region', NULL, 'PH_2', NULL, NULL, 13860, 9),
(269830, NULL, 'PF12235', NULL, NULL, 'Fragile X-related 1 protein core C terminal', NULL, 'FXMRP1_C_core', NULL, NULL, 20374, 9),
(269831, NULL, 'PF09888', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2115)', NULL, 'DUF2115', NULL, NULL, 19176, 9),
(269832, NULL, 'PF11986', NULL, NULL, 'Influenza A Proapoptotic protein', NULL, 'PB1-F2', NULL, NULL, 15208, 9),
(269833, NULL, 'PF19892', NULL, NULL, 'Family of unknown function (DUF6365)', NULL, 'DUF6365', NULL, NULL, 36709, 9),
(269834, NULL, 'PF08054', NULL, NULL, 'Leucine operon leader peptide', NULL, 'Leu_leader', NULL, NULL, 9023, 9),
(269835, NULL, 'PF15028', NULL, NULL, 'Pre-T-cell antigen receptor', NULL, 'PTCRA', NULL, NULL, 22009, 9),
(269836, NULL, 'PF20110', NULL, NULL, 'Family of unknown function (DUF6500)', NULL, 'DUF6500', NULL, NULL, 37175, 9),
(269837, NULL, 'PF03750', NULL, NULL, 'Csm2 Type III-A', NULL, 'Csm2_III-A', NULL, NULL, 10957, 9),
(269838, NULL, 'PF13420', NULL, NULL, 'Acetyltransferase (GNAT) domain', NULL, 'Acetyltransf_4', NULL, NULL, NULL, 9),
(269839, NULL, 'PF07661', NULL, NULL, 'MORN repeat variant', NULL, 'MORN_2', NULL, NULL, 10933, 9),
(269840, NULL, 'PF10930', NULL, NULL, 'Protein of unknown function (DUF2737)', NULL, 'DUF2737', NULL, NULL, 20835, 9),
(269841, NULL, 'PF10689', NULL, NULL, 'Protein of unknown function (DUF2496)', NULL, 'DUF2496', NULL, NULL, 20667, 9),
(269842, NULL, 'PF01746', NULL, NULL, 'tRNA (Guanine-1)-methyltransferase', NULL, 'tRNA_m1G_MT', NULL, NULL, 11033, 9),
(269843, NULL, 'PF05887', NULL, NULL, 'Procyclic acidic repetitive protein (PARP)', NULL, 'Trypan_PARP', NULL, NULL, 7507, 9),
(269844, NULL, 'PF13432', NULL, NULL, 'Tetratricopeptide repeat', NULL, 'TPR_16', NULL, NULL, NULL, 9),
(269845, NULL, 'PF08936', NULL, NULL, 'Carboxysome Shell Carbonic Anhydrase', NULL, 'CsoSCA', NULL, NULL, 13056, 9),
(269846, NULL, 'PF12191', NULL, NULL, 'Tumour necrosis factor receptor stn_TNFRSF12A_TNFR domain', NULL, 'stn_TNFRSF12A', NULL, NULL, 15723, 9),
(269847, NULL, 'PF20317', NULL, NULL, 'Helix-turn-helix domain', NULL, 'HTH_60', NULL, NULL, 34250, 9),
(269848, NULL, 'PF06760', NULL, NULL, 'Protein of unknown function (DUF1221)', NULL, 'DUF1221', NULL, NULL, 9296, 9),
(269849, NULL, 'PF11091', NULL, NULL, 'Tail-tube assembly protein', NULL, 'T4_tail_cap', NULL, NULL, 22226, 9),
(269850, NULL, 'PF11188', NULL, NULL, 'Protein of unknown function (DUF2975)', NULL, 'DUF2975', NULL, NULL, 18098, 9),
(269851, NULL, 'PF14712', NULL, NULL, 'Snapin/Pallidin', NULL, 'Snapin_Pallidin', NULL, NULL, 21885, 9),
(269852, NULL, 'PF17678', NULL, NULL, 'Glycosyl hydrolase family 92 N-terminal domain', NULL, 'Glyco_hydro_92N', NULL, NULL, 29128, 9),
(269853, NULL, 'PF08797', NULL, NULL, 'HIRAN domain', NULL, 'HIRAN', NULL, NULL, 13265, 9),
(269854, NULL, 'PF05337', NULL, NULL, 'Macrophage colony stimulating factor-1 (CSF-1)', NULL, 'CSF-1', NULL, NULL, 4075, 9),
(269855, NULL, 'PF15468', NULL, NULL, 'Domain of unknown function (DUF4636)', NULL, 'DUF4636', NULL, NULL, 23944, 9),
(269856, NULL, 'PF13705', NULL, NULL, 'TRC8 N-terminal domain', NULL, 'TRC8_N', NULL, NULL, 24961, 9),
(269857, NULL, 'PF06511', NULL, NULL, 'Type III secretion systems tip complex components', NULL, 'T3SS_TC', NULL, NULL, 9449, 9),
(269858, NULL, 'PF18339', NULL, NULL, 'RapA N-terminal Tudor like domain 1', NULL, 'Tudor_1_RapA', NULL, NULL, 27617, 9),
(269859, NULL, 'PF06711', NULL, NULL, 'Protein of unknown function (DUF1198)', NULL, 'DUF1198', NULL, NULL, 1547, 9);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(269860, NULL, 'PF10846', NULL, NULL, 'Protein of unknown function (DUF2722)', NULL, 'DUF2722', NULL, NULL, 17613, 9),
(269861, NULL, 'PF19540', NULL, NULL, 'Family of unknown function (DUF6064)', NULL, 'DUF6064', NULL, NULL, 36005, 9),
(269862, NULL, 'PF03332', NULL, NULL, 'Eukaryotic phosphomannomutase', NULL, 'PMM', NULL, NULL, 639, 9),
(269863, NULL, 'PF12285', NULL, NULL, 'Astroviridae polyprotein 1', NULL, 'Astrovir_pp_1', NULL, NULL, 20553, 9),
(269864, NULL, 'PF13946', NULL, NULL, 'Domain of unknown function (DUF4214)', NULL, 'DUF4214', NULL, NULL, 23367, 9),
(269865, NULL, 'PF15143', NULL, NULL, 'Domain of unknown function (DUF4575)', NULL, 'DUF4575', NULL, NULL, 26275, 9),
(269866, NULL, 'PF10947', NULL, NULL, 'Protein of unknown function (DUF2628)', NULL, 'DUF2628', NULL, NULL, 22058, 9),
(269867, NULL, 'PF06592', NULL, NULL, 'Protein of unknown function (DUF1138)', NULL, 'DUF1138', NULL, NULL, 9428, 9),
(269868, NULL, 'PF15895', NULL, NULL, 'CAAX box cerebral protein 1', NULL, 'CAAX_1', NULL, NULL, 25937, 9),
(269869, NULL, 'PF10786', NULL, NULL, 'Glucose-6-phosphate 1-dehydrogenase (EC 1.1.1.49)', NULL, 'G6PD_bact', NULL, NULL, 20551, 9),
(269870, NULL, 'PF06863', NULL, NULL, 'Protein of unknown function (DUF1254)', NULL, 'DUF1254', NULL, NULL, 9029, 9),
(269871, NULL, 'PF02208', NULL, NULL, 'Sorbin homologous domain', NULL, 'Sorb', NULL, NULL, 2516, 9),
(269872, NULL, 'PF04468', NULL, NULL, 'PSP1 C-terminal conserved region', NULL, 'PSP1', NULL, NULL, 3940, 9),
(269873, NULL, 'PF19164', NULL, NULL, 'Family of unknown function (DUF5846)', NULL, 'DUF5846', NULL, NULL, 34285, 9),
(269874, NULL, 'PF02128', NULL, NULL, 'Fungalysin metallopeptidase (M36)', NULL, 'Peptidase_M36', NULL, NULL, 4383, 9),
(269875, NULL, 'PF09590', NULL, NULL, 'Lentivirus surface glycoprotein', NULL, 'Env-gp36', NULL, NULL, 15185, 9),
(269876, NULL, 'PF10407', NULL, NULL, 'Cdc14 phosphatase binding protein N-terminus', NULL, 'Cytokin_check_N', NULL, NULL, 20329, 9),
(269877, NULL, 'PF07830', NULL, NULL, 'Protein serine/threonine phosphatase 2C, C-terminal domain', NULL, 'PP2C_C', NULL, NULL, 13057, 9),
(269878, NULL, 'PF13964', NULL, NULL, 'Kelch motif', NULL, 'Kelch_6', NULL, NULL, NULL, 9),
(269879, NULL, 'PF01673', NULL, NULL, 'Herpesvirus putative major envelope glycoprotein', NULL, 'Herpes_env', NULL, NULL, 1639, 9),
(269880, NULL, 'PF09451', NULL, NULL, 'Autophagy-related protein 27', NULL, 'ATG27', NULL, NULL, 9257, 9),
(269881, NULL, 'PF17966', NULL, NULL, 'Muc B2-like domain', NULL, 'Muc_B2', NULL, NULL, 29149, 9),
(269882, NULL, 'PF16680', NULL, NULL, 'T-cell surface glycoprotein CD3 delta chain', NULL, 'Ig_4', NULL, NULL, 25358, 9),
(269883, NULL, 'PF04657', NULL, NULL, 'Putative inner membrane exporter, YdcZ', NULL, 'DMT_YdcZ', NULL, NULL, 2938, 9),
(269884, NULL, 'PF18655', NULL, NULL, 'SHIRT domain', NULL, 'SHIRT', NULL, NULL, 28085, 9),
(269885, NULL, 'PF05977', NULL, NULL, 'Transmembrane secretion effector', NULL, 'MFS_3', NULL, NULL, 7922, 9),
(269886, NULL, 'PF05982', NULL, NULL, 'Na+-dependent bicarbonate transporter superfamily', NULL, 'Sbt_1', NULL, NULL, 7813, 9),
(269887, NULL, 'PF13505', NULL, NULL, 'Outer membrane protein beta-barrel domain', NULL, 'OMP_b-brl', NULL, NULL, 24891, 9),
(269888, NULL, 'PF18278', NULL, NULL, 'Receptor activator of the NF-KB cysteine-rich repeat domain 2', NULL, 'RANK_CRD_2', NULL, NULL, 30319, 9),
(269889, NULL, 'PF19211', NULL, NULL, 'Coronavirus replicase NSP2, N-terminal', NULL, 'CoV_NSP2_N', NULL, NULL, 34646, 9),
(269890, NULL, 'PF02456', NULL, NULL, 'Adenovirus IVa2 protein', NULL, 'Adeno_IVa2', NULL, NULL, 4353, 9),
(269891, NULL, 'PF08777', NULL, NULL, 'RNA binding motif', NULL, 'RRM_3', NULL, NULL, 13398, 9),
(269892, NULL, 'PF16722', NULL, NULL, 'Pathogenicity island protein gp6 in Staphylococcus', NULL, 'SAPIS-gp6', NULL, NULL, 23138, 9),
(269893, NULL, 'PF06945', NULL, NULL, 'Protein of unknown function (DUF1289)', NULL, 'DUF1289', NULL, NULL, 9615, 9),
(269894, NULL, 'PF00260', NULL, NULL, 'Protamine P1', NULL, 'Protamine_P1', NULL, NULL, 3514, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(269895, NULL, 'PF03526', NULL, NULL, 'Colicin E1 (microcin) immunity protein', NULL, 'Microcin', NULL, NULL, 6832, 9),
(269896, NULL, 'PF13214', NULL, NULL, 'Protein of unknown function (DUF4022)', NULL, 'DUF4022', NULL, NULL, 22672, 9),
(269897, NULL, 'PF00905', NULL, NULL, 'Penicillin binding protein transpeptidase domain', NULL, 'Transpeptidase', NULL, NULL, 3475, 9),
(269898, NULL, 'PF11334', NULL, NULL, 'Protein of unknown function (DUF3136)', NULL, 'DUF3136', NULL, NULL, 18171, 9),
(269899, NULL, 'PF13084', NULL, NULL, 'Domain of unknown function (DUF3943)', NULL, 'DUF3943', NULL, NULL, 22516, 9),
(269900, NULL, 'PF10259', NULL, NULL, 'Rogdi leucine zipper containing protein', NULL, 'Rogdi_lz', NULL, NULL, 21889, 9),
(269901, NULL, 'PF17203', NULL, NULL, 'Single cache domain 3', NULL, 'sCache_3_2', NULL, NULL, 27277, 9),
(269902, NULL, 'PF17548', NULL, NULL, 'Histone-like Protein p6', NULL, 'p6', NULL, NULL, 20400, 9),
(269903, NULL, 'PF09036', NULL, NULL, 'Bcr-Abl oncoprotein oligomerisation domain', NULL, 'Bcr-Abl_Oligo', NULL, NULL, 9947, 9),
(269904, NULL, 'PF20448', NULL, NULL, 'Family of unknown function (DUF6705)', NULL, 'DUF6705', NULL, NULL, 37565, 9),
(269905, NULL, 'PF11290', NULL, NULL, 'Protein of unknown function (DUF3090)', NULL, 'DUF3090', NULL, NULL, 18047, 9),
(269906, NULL, 'PF17474', NULL, NULL, 'Tegument protein UL11 homolog', NULL, 'U71', NULL, NULL, 13788, 9),
(269907, NULL, 'PF01887', NULL, NULL, 'SAM hydroxide adenosyltransferase N-terminal domain', NULL, 'SAM_HAT_N', NULL, NULL, 36607, 9),
(269908, NULL, 'PF19516', NULL, NULL, 'Family of unknown function (DUF6049)', NULL, 'DUF6049', NULL, NULL, 37339, 9),
(269909, NULL, 'PF17016', NULL, NULL, 'Domain of unknown function (DUF5095)', NULL, 'DUF5095', NULL, NULL, 22774, 9),
(269910, NULL, 'PF12973', NULL, NULL, 'ChrR Cupin-like domain', NULL, 'Cupin_7', NULL, NULL, 26672, 9),
(269911, NULL, 'PF01079', NULL, NULL, 'Hint module', NULL, 'Hint', NULL, NULL, 3137, 9),
(269912, NULL, 'PF16147', NULL, NULL, 'Domain of unknown function (DUF4855)', NULL, 'DUF4855', NULL, NULL, 22522, 9),
(269913, NULL, 'PF18840', NULL, NULL, 'Large polyvalent protein associated domain 25', NULL, 'LPD25', NULL, NULL, 29533, 9),
(269914, NULL, 'PF18916', NULL, NULL, 'Lycopene cyclase', NULL, 'Lycopene_cyc', NULL, NULL, 19703, 9),
(269915, NULL, 'PF12342', NULL, NULL, 'Protein of unknown function (DUF3640)', NULL, 'DUF3640', NULL, NULL, 20617, 9),
(269916, NULL, 'PF12822', NULL, NULL, 'ECF transporter, substrate-specific component', NULL, 'ECF_trnsprt', NULL, NULL, 24591, 9),
(269917, NULL, 'PF02864', NULL, NULL, 'STAT protein, DNA binding domain', NULL, 'STAT_bind', NULL, NULL, 8190, 9),
(269918, NULL, 'PF10645', NULL, NULL, 'Carbohydrate binding', NULL, 'Carb_bind', NULL, NULL, 20815, 9),
(269919, NULL, 'PF19202', NULL, NULL, 'Family of unknown function (DUF5874)', NULL, 'DUF5874', NULL, NULL, 35209, 9),
(269920, NULL, 'PF11940', NULL, NULL, 'Domain of unknown function (DUF3458) Ig-like fold', NULL, 'DUF3458', NULL, NULL, 17719, 9),
(269921, NULL, 'PF12388', NULL, NULL, 'Dual-action HEIGH metallo-peptidase', NULL, 'Peptidase_M57', NULL, NULL, 24648, 9),
(269922, NULL, 'PF18695', NULL, NULL, 'Cytosolic phospholipases A2 C2-domain', NULL, 'cPLA2_C2', NULL, NULL, 28454, 9),
(269923, NULL, 'PF14387', NULL, NULL, 'Domain of unknown function (DUF4418)', NULL, 'DUF4418', NULL, NULL, 26230, 9),
(269924, NULL, 'PF17271', NULL, NULL, 'TcfC Usher-like barrel domain', NULL, 'Usher_TcfC', NULL, NULL, 15013, 9),
(269925, NULL, 'PF16954', NULL, NULL, 'Haem-transporter, endosomal/lysosomal, haem-responsive gene', NULL, 'HRG', NULL, NULL, 26185, 9),
(269926, NULL, 'PF08056', NULL, NULL, 'Tryptophan operon leader peptide', NULL, 'Trp_leader2', NULL, NULL, 10475, 9),
(269927, NULL, 'PF14444', NULL, NULL, 'S1-like', NULL, 'S1-like', NULL, NULL, 25576, 9),
(269928, NULL, 'PF00520', NULL, NULL, 'Ion transport protein', NULL, 'Ion_trans', NULL, NULL, 5945, 9),
(269929, NULL, 'PF10005', NULL, NULL, 'zinc-ribbon domain', NULL, 'zinc-ribbon_6', NULL, NULL, 9796, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(269930, NULL, 'PF07834', NULL, NULL, 'RanGAP1 C-terminal domain', NULL, 'RanGAP1_C', NULL, NULL, 7896, 9),
(269931, NULL, 'PF16891', NULL, NULL, 'Serine-threonine protein phosphatase N-terminal domain', NULL, 'STPPase_N', NULL, NULL, 22777, 9),
(269932, NULL, 'PF07711', NULL, NULL, 'Rab geranylgeranyl transferase alpha-subunit, insert domain', NULL, 'RabGGT_insert', NULL, NULL, 6297, 9),
(269933, NULL, 'PF09383', NULL, NULL, 'NIL domain', NULL, 'NIL', NULL, NULL, 17107, 9),
(269934, NULL, 'PF10761', NULL, NULL, 'Protein of unknown function (DUF2590)', NULL, 'DUF2590', NULL, NULL, 20270, 9),
(269935, NULL, 'PF00367', NULL, NULL, 'phosphotransferase system, EIIB', NULL, 'PTS_EIIB', NULL, NULL, 944, 9),
(269936, NULL, 'PF14069', NULL, NULL, 'Stage VI sporulation protein F', NULL, 'SpoVIF', NULL, NULL, 24194, 9),
(269937, NULL, 'PF05558', NULL, NULL, 'DREPP plasma membrane polypeptide', NULL, 'DREPP', NULL, NULL, 12226, 9),
(269938, NULL, 'PF14587', NULL, NULL, 'O-Glycosyl hydrolase family 30', NULL, 'Glyco_hydr_30_2', NULL, NULL, 33627, 9),
(269939, NULL, 'PF08030', NULL, NULL, 'Ferric reductase NAD binding domain', NULL, 'NAD_binding_6', NULL, NULL, 18516, 9),
(269940, NULL, 'PF09510', NULL, NULL, 'Rtt102p-like transcription regulator protein', NULL, 'Rtt102p', NULL, NULL, 19543, 9),
(269941, NULL, 'PF17534', NULL, NULL, 'Family of unknown function (DUF5453)', NULL, 'DUF5453', NULL, NULL, 15280, 9),
(269942, NULL, 'PF15736', NULL, NULL, 'Domain of unknown function (DUF4684)', NULL, 'DUF4684', NULL, NULL, 25739, 9),
(269943, NULL, 'PF20063', NULL, NULL, 'Family of unknown function (DUF6462)', NULL, 'DUF6462', NULL, NULL, 37368, 9),
(269944, NULL, 'PF00559', NULL, NULL, 'Retroviral Vif (Viral infectivity) protein', NULL, 'Vif', NULL, NULL, 6553, 9),
(269945, NULL, 'PF03952', NULL, NULL, 'Enolase, N-terminal domain', NULL, 'Enolase_N', NULL, NULL, 14540, 9),
(269946, NULL, 'PF06119', NULL, NULL, 'Nidogen-like', NULL, 'NIDO', NULL, NULL, 4446, 9),
(269947, NULL, 'PF01094', NULL, NULL, 'Receptor family ligand binding region', NULL, 'ANF_receptor', NULL, NULL, 4341, 9),
(269948, NULL, 'PF14680', NULL, NULL, 'FANCI helical domain 2', NULL, 'FANCI_HD2', NULL, NULL, 26739, 9),
(269949, NULL, 'PF11814', NULL, NULL, 'Peptidase_C39 like family', NULL, 'DUF3335', NULL, NULL, 19364, 9),
(269950, NULL, 'PF02315', NULL, NULL, 'Methanol dehydrogenase beta subunit', NULL, 'MDH', NULL, NULL, 5211, 9),
(269951, NULL, 'PF13182', NULL, NULL, 'Protein of unknown function (DUF4007)', NULL, 'DUF4007', NULL, NULL, 25787, 9),
(269952, NULL, 'PF13475', NULL, NULL, 'Domain of unknown function (DUF4116)', NULL, 'DUF4116', NULL, NULL, 22607, 9),
(269953, NULL, 'PF14651', NULL, NULL, 'Lipocalin / cytosolic fatty-acid binding protein family', NULL, 'Lipocalin_7', NULL, NULL, NULL, 9),
(269954, NULL, 'PF15319', NULL, NULL, 'RAD9, RAD1, HUS1-interacting nuclear orphan protein', NULL, 'RHINO', NULL, NULL, 24682, 9),
(269955, NULL, 'PF09019', NULL, NULL, 'EcoRII C terminal', NULL, 'EcoRII-C', NULL, NULL, 9551, 9),
(269956, NULL, 'PF00662', NULL, NULL, 'NADH-Ubiquinone oxidoreductase (complex I), chain 5 N-terminus', NULL, 'Proton_antipo_N', NULL, NULL, 3389, 9),
(269957, NULL, 'PF01785', NULL, NULL, 'Closterovirus coat protein', NULL, 'Closter_coat', NULL, NULL, 2976, 9),
(269958, NULL, 'PF18042', NULL, NULL, 'ORF 12 gene product N-terminal', NULL, 'ORF_12_N', NULL, NULL, 32050, 9),
(269959, NULL, 'PF12112', NULL, NULL, 'Protein of unknown function (DUF3579)', NULL, 'DUF3579', NULL, NULL, 20101, 9),
(269960, NULL, 'PF17318', NULL, NULL, 'Family of unknown function (DUF5361)', NULL, 'DUF5361', NULL, NULL, 31694, 9),
(269961, NULL, 'PF12292', NULL, NULL, 'Protein of unknown function (DUF3624)', NULL, 'DUF3624', NULL, NULL, 20535, 9),
(269962, NULL, 'PF15297', NULL, NULL, 'Cytoskeleton-associated protein 2 C-terminus', NULL, 'CKAP2_C', NULL, NULL, 26978, 9),
(269963, NULL, 'PF07080', NULL, NULL, 'Protein of unknown function (DUF1348)', NULL, 'DUF1348', NULL, NULL, 13291, 9),
(269964, NULL, 'PF07538', NULL, NULL, 'Clostridial hydrophobic W', NULL, 'ChW', NULL, NULL, 1113, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(269965, NULL, 'PF04718', NULL, NULL, 'Mitochondrial ATP synthase g subunit', NULL, 'ATP-synt_G', NULL, NULL, 3866, 9),
(269966, NULL, 'PF09106', NULL, NULL, 'Elongation factor SelB, winged helix', NULL, 'SelB-wing_2', NULL, NULL, 10977, 9),
(269967, NULL, 'PF20346', NULL, NULL, 'Family of unknown function (DUF6641)', NULL, 'DUF6641', NULL, NULL, 33732, 9),
(269968, NULL, 'PF19899', NULL, NULL, 'Family of unknown function (DUF6372)', NULL, 'DUF6372', NULL, NULL, 36707, 9),
(269969, NULL, 'PF07960', NULL, NULL, 'CBP4', NULL, 'CBP4', NULL, NULL, 13497, 9),
(269970, NULL, 'PF12720', NULL, NULL, 'Protein of unknown function (DUF3807)', NULL, 'DUF3807', NULL, NULL, 24702, 9),
(269971, NULL, 'PF03804', NULL, NULL, 'Viral proteins of unknown function', NULL, 'DUF325', NULL, NULL, 2932, 9),
(269972, NULL, 'PF19640', NULL, NULL, 'Family of unknown function (DUF6143)', NULL, 'DUF6143', NULL, NULL, 37328, 9),
(269973, NULL, 'PF18769', NULL, NULL, 'APOBEC1', NULL, 'APOBEC1', NULL, NULL, NULL, 9),
(269974, NULL, 'PF09250', NULL, NULL, 'Bifunctional DNA primase/polymerase, N-terminal', NULL, 'Prim-Pol', NULL, NULL, 13500, 9),
(269975, NULL, 'PF12244', NULL, NULL, 'Protein of unknown function (DUF3606)', NULL, 'DUF3606', NULL, NULL, 20399, 9),
(269976, NULL, 'PF00755', NULL, NULL, 'Choline/Carnitine o-acyltransferase', NULL, 'Carn_acyltransf', NULL, NULL, 33639, 9),
(269977, NULL, 'PF12524', NULL, NULL, 'dsDNA virus glycoprotein L C terminal', NULL, 'GlyL_C', NULL, NULL, 21216, 9),
(269978, NULL, 'PF04276', NULL, NULL, 'Protein of unknown function (DUF443)', NULL, 'DUF443', NULL, NULL, 402, 9),
(269979, NULL, 'PF17671', NULL, NULL, 'Family of unknown function (DUF5531)', NULL, 'DUF5531', NULL, NULL, 32580, 9),
(269980, NULL, 'PF12584', NULL, NULL, 'Trafficking protein particle complex subunit 10, TRAPPC10', NULL, 'TRAPPC10', NULL, NULL, 21443, 9),
(269981, NULL, 'PF14190', NULL, NULL, 'Domain of unknown function (DUF4313)', NULL, 'DUF4313', NULL, NULL, 26279, 9),
(269982, NULL, 'PF00229', NULL, NULL, 'TNF(Tumour Necrosis Factor) family', NULL, 'TNF', NULL, NULL, 2809, 9),
(269983, NULL, 'PF11521', NULL, NULL, 'C-terminal general transcription factor TFIIE alpha', NULL, 'TFIIE-A_C', NULL, NULL, 18929, 9),
(269984, NULL, 'PF05035', NULL, NULL, '2-keto-3-deoxy-galactonokinase', NULL, 'DGOK', NULL, NULL, 1411, 9),
(269985, NULL, 'PF00515', NULL, NULL, 'Tetratricopeptide repeat', NULL, 'TPR_1', NULL, NULL, 6853, 9),
(269986, NULL, 'PF19415', NULL, NULL, 'Astrovirus transmembrane protein 1A', NULL, 'Astro_1A', NULL, NULL, 36236, 9),
(269987, NULL, 'PF12202', NULL, NULL, 'Oxidative-stress-responsive kinase 1 C-terminal domain', NULL, 'OSR1_C', NULL, NULL, 21294, 9),
(269988, NULL, 'PF19076', NULL, NULL, 'Surface adhesin CshA repetitive domain', NULL, 'CshA_repeat', NULL, NULL, 21296, 9),
(269989, NULL, 'PF19094', NULL, NULL, 'EMC6-arch', NULL, 'EMC6_arch', NULL, NULL, 35661, 9),
(269990, NULL, 'PF19443', NULL, NULL, 'DAHL domain', NULL, 'DAHL', NULL, NULL, 34465, 9),
(269991, NULL, 'PF07307', NULL, NULL, 'Heptaprenyl diphosphate synthase (HEPPP synthase) subunit 1', NULL, 'HEPPP_synt_1', NULL, NULL, 7872, 9),
(269992, NULL, 'PF06327', NULL, NULL, 'Adenylate cyclase, conserved domain', NULL, 'Adcy_cons_dom', NULL, NULL, 8085, 9),
(269993, NULL, 'PF10928', NULL, NULL, 'Protein of unknown function (DUF2810)', NULL, 'DUF2810', NULL, NULL, 17739, 9),
(269994, NULL, 'PF11559', NULL, NULL, 'Afadin- and alpha -actinin-Binding', NULL, 'ADIP', NULL, NULL, 18642, 9),
(269995, NULL, 'PF00641', NULL, NULL, 'Zn-finger in Ran binding protein and others', NULL, 'zf-RanBP', NULL, NULL, 5410, 9),
(269996, NULL, 'PF02413', NULL, NULL, 'Caudovirales tail fibre assembly protein, lambda gpK', NULL, 'Caudo_TAP', NULL, NULL, 5324, 9),
(269997, NULL, 'PF09736', NULL, NULL, 'Pre-mRNA-splicing factor of RES complex', NULL, 'Bud13', NULL, NULL, 16181, 9),
(269998, NULL, 'PF17865', NULL, NULL, 'Midasin AAA lid domain', NULL, 'AAA_lid_5', NULL, NULL, 29464, 9),
(269999, NULL, 'PF17473', NULL, NULL, 'Family of unknown function (DUF5426)', NULL, 'DUF5426', NULL, NULL, 18996, 9);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(270000, NULL, 'PF03356', NULL, NULL, 'Viral late protein H2', NULL, 'Pox_LP_H2', NULL, NULL, 1446, 9),
(270001, NULL, 'PF16836', NULL, NULL, 'Shu complex component Psy3, DNA-binding description', NULL, 'PSY3', NULL, NULL, 26123, 9),
(270002, NULL, 'PF11314', NULL, NULL, 'Protein of unknown function (DUF3117)', NULL, 'DUF3117', NULL, NULL, 18476, 9),
(270003, NULL, 'PF13542', NULL, NULL, 'Helix-turn-helix domain of transposase family ISL3', NULL, 'HTH_Tnp_ISL3', NULL, NULL, 24225, 9),
(270004, NULL, 'PF01099', NULL, NULL, 'Uteroglobin family', NULL, 'Uteroglobin', NULL, NULL, 11477, 9),
(270005, NULL, 'PF13061', NULL, NULL, 'Protein of unknown function (DUF3923)', NULL, 'DUF3923', NULL, NULL, 22934, 9),
(270006, NULL, 'PF20031', NULL, NULL, 'Family of unknown function (DUF6437)', NULL, 'DUF6437', NULL, NULL, 35834, 9),
(270007, NULL, 'PF12264', NULL, NULL, 'Waikavirus capsid protein 1', NULL, 'Waikav_capsid_1', NULL, NULL, 22333, 9),
(270008, NULL, 'PF10764', NULL, NULL, 'Inhibitor of sigma-G Gin', NULL, 'Gin', NULL, NULL, 20042, 9),
(270009, NULL, 'PF06963', NULL, NULL, 'Ferroportin1 (FPN1)', NULL, 'FPN1', NULL, NULL, 12349, 9),
(270010, NULL, 'PF06051', NULL, NULL, 'Domain of Unknown Function (DUF928)', NULL, 'DUF928', NULL, NULL, 8545, 9),
(270011, NULL, 'PF02342', NULL, NULL, 'TerD domain', NULL, 'TerD', NULL, NULL, 4284, 9),
(270012, NULL, 'PF01141', NULL, NULL, 'Gag polyprotein, inner coat protein p12', NULL, 'Gag_p12', NULL, NULL, 1336, 9),
(270013, NULL, 'PF04196', NULL, NULL, 'Bunyavirus RNA dependent RNA polymerase', NULL, 'Bunya_RdRp', NULL, NULL, 4501, 9),
(270014, NULL, 'PF18785', NULL, NULL, 'Invertebrate-AID/APOBEC-deaminase', NULL, 'Inv-AAD', NULL, NULL, NULL, 9),
(270015, NULL, 'PF03714', NULL, NULL, 'Bacterial pullanase-associated domain', NULL, 'PUD', NULL, NULL, 5524, 9),
(270016, NULL, 'PF10578', NULL, NULL, 'Seminal vesicle protein repeat', NULL, 'SVS_QK', NULL, NULL, 9082, 9),
(270017, NULL, 'PF05150', NULL, NULL, 'Legionella pneumophila major outer membrane protein precursor', NULL, 'Legionella_OMP', NULL, NULL, 2452, 9),
(270018, NULL, 'PF08257', NULL, NULL, 'Sulfakinin family', NULL, 'Sulfakinin', NULL, NULL, 13309, 9),
(270019, NULL, 'PF02776', NULL, NULL, 'Thiamine pyrophosphate enzyme, N-terminal TPP binding domain', NULL, 'TPP_enzyme_N', NULL, NULL, 7706, 9),
(270020, NULL, 'PF18090', NULL, NULL, 'Centromere-binding protein HTH domain', NULL, 'SoPB_HTH', NULL, NULL, 32319, 9),
(270021, NULL, 'PF10633', NULL, NULL, 'NPCBM-associated, NEW3 domain of alpha-galactosidase', NULL, 'NPCBM_assoc', NULL, NULL, 20532, 9),
(270022, NULL, 'PF09142', NULL, NULL, 'tRNA Pseudouridine synthase II, C terminal', NULL, 'TruB_C', NULL, NULL, 10769, 9),
(270023, NULL, 'PF11244', NULL, NULL, 'Mediator complex subunit 25 C-terminal NR box-containing', NULL, 'Med25_NR-box', NULL, NULL, 18078, 9),
(270024, NULL, 'PF13680', NULL, NULL, 'Protein of unknown function (DUF4152)', NULL, 'DUF4152', NULL, NULL, 21873, 9),
(270025, NULL, 'PF09592', NULL, NULL, 'Protein of unknown function (DUF2031)', NULL, 'DUF2031', NULL, NULL, 6490, 9),
(270026, NULL, 'PF00490', NULL, NULL, 'Delta-aminolevulinic acid dehydratase', NULL, 'ALAD', NULL, NULL, 3275, 9),
(270027, NULL, 'PF01807', NULL, NULL, 'CHC2 zinc finger', NULL, 'zf-CHC2', NULL, NULL, 3716, 9),
(270028, NULL, 'PF19405', NULL, NULL, 'Family of unknown function (DUF5978)', NULL, 'DUF5978', NULL, NULL, 36534, 9),
(270029, NULL, 'PF13156', NULL, NULL, 'Restriction endonuclease', NULL, 'Mrr_cat_2', NULL, NULL, 30733, 9),
(270030, NULL, 'PF05489', NULL, NULL, 'Phage Tail Protein X', NULL, 'Phage_tail_X', NULL, NULL, 13659, 9),
(270031, NULL, 'PF09241', NULL, NULL, 'Herpesviridae viral cyclin', NULL, 'Herp-Cyclin', NULL, NULL, 13348, 9),
(270032, NULL, 'PF02138', NULL, NULL, 'Beige/BEACH domain', NULL, 'Beach', NULL, NULL, 299, 9),
(270033, NULL, 'PF10933', NULL, NULL, 'Protein of unknown function (DUF2827)', NULL, 'DUF2827', NULL, NULL, 17715, 9),
(270034, NULL, 'PF13966', NULL, NULL, 'zinc-binding in reverse transcriptase', NULL, 'zf-RVT', NULL, NULL, 25554, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(270035, NULL, 'PF15490', NULL, NULL, 'Telomere-capping, CST complex subunit', NULL, 'Ten1_2', NULL, NULL, 23665, 9),
(270036, NULL, 'PF17878', NULL, NULL, 'Single-stranded DNA-binding protein', NULL, 'ssDBP', NULL, NULL, 28537, 9),
(270037, NULL, 'PF20520', NULL, NULL, 'V0 complex accessory subunit Ac45/VOA1 transmembrane domain', NULL, 'Ac45-VOA1_TM', NULL, NULL, 33925, 9),
(270038, NULL, 'PF14884', NULL, NULL, 'Type I membrane glycoproteins cell-cell fusogen', NULL, 'EFF-AFF', NULL, NULL, 26866, 9),
(270039, NULL, 'PF07587', NULL, NULL, 'Protein of unknown function (DUF1553)', NULL, 'PSD1', NULL, NULL, 16671, 9),
(270040, NULL, 'PF14336', NULL, NULL, 'Domain of unknown function (DUF4392)', NULL, 'DUF4392', NULL, NULL, 26130, 9),
(270041, NULL, 'PF19651', NULL, NULL, 'Family of unknown function (DUF6154)', NULL, 'DUF6154', NULL, NULL, 37303, 9),
(270042, NULL, 'PF00003', NULL, NULL, '7 transmembrane sweet-taste receptor of 3 GCPR', NULL, '7tm_3', NULL, NULL, 19080, 9),
(270043, NULL, 'PF07759', NULL, NULL, 'Protein of unknown function (DUF1615)', NULL, 'DUF1615', NULL, NULL, 10542, 9),
(270044, NULL, 'PF08813', NULL, NULL, 'Phage tail tube protein, TTP', NULL, 'Phage_tail_3', NULL, NULL, 13023, 9),
(270045, NULL, 'PF17204', NULL, NULL, 'Sid-5 family', NULL, 'Sid-5', NULL, NULL, 28668, 9),
(270046, NULL, 'PF19173', NULL, NULL, 'Family of unknown function (DUF5855)', NULL, 'DUF5855', NULL, NULL, 34212, 9),
(270047, NULL, 'PF13643', NULL, NULL, 'Domain of unknown function (DUF4145)', NULL, 'DUF4145', NULL, NULL, 23313, 9),
(270048, NULL, 'PF20404', NULL, NULL, 'Family of unknown function (DUF6694)', NULL, 'DUF6694', NULL, NULL, 37572, 9),
(270049, NULL, 'PF15254', NULL, NULL, 'Coiled-coil domain-containing protein 14', NULL, 'CCDC14', NULL, NULL, 23593, 9),
(270050, NULL, 'PF17111', NULL, NULL, 'Fungal N-terminal domain of STAND proteins', NULL, 'Helo_like_N', NULL, NULL, 26280, 9),
(270051, NULL, 'PF03401', NULL, NULL, 'Tripartite tricarboxylate transporter family receptor', NULL, 'TctC', NULL, NULL, 2263, 9),
(270052, NULL, 'PF07537', NULL, NULL, 'CamS sex pheromone cAM373 precursor', NULL, 'CamS', NULL, NULL, 13991, 9),
(270053, NULL, 'PF11339', NULL, NULL, 'Protein of unknown function (DUF3141)', NULL, 'DUF3141', NULL, NULL, 24090, 9),
(270054, NULL, 'PF13828', NULL, NULL, 'Domain of unknown function (DUF4190)', NULL, 'DUF4190', NULL, NULL, 23016, 9),
(270055, NULL, 'PF13149', NULL, NULL, 'Fimbrillin-like', NULL, 'Mfa_like_1', NULL, NULL, 22882, 9),
(270056, NULL, 'PF06973', NULL, NULL, 'Domain of unknown function (DUF1297)', NULL, 'DUF1297', NULL, NULL, 12084, 9),
(270057, NULL, 'PF07884', NULL, NULL, 'Vitamin K epoxide reductase family', NULL, 'VKOR', NULL, NULL, 8026, 9),
(270058, NULL, 'PF18079', NULL, NULL, 'Archaeal glycosylation protein B long peripheral domain', NULL, 'AglB_L1', NULL, NULL, 28763, 9),
(270059, NULL, 'PF10152', NULL, NULL, 'Subunit CCDC53 of WASH complex', NULL, 'CCDC53', NULL, NULL, 14570, 9),
(270060, NULL, 'PF01007', NULL, NULL, 'Inward rectifier potassium channel transmembrane domain', NULL, 'IRK', NULL, NULL, 27629, 9),
(270061, NULL, 'PF08159', NULL, NULL, 'NUC153 domain', NULL, 'NUC153', NULL, NULL, 9361, 9),
(270062, NULL, 'PF12374', NULL, NULL, 'Double-sex mab3 related transcription factor 1', NULL, 'Dmrt1', NULL, NULL, 20878, 9),
(270063, NULL, 'PF18589', NULL, NULL, 'Obesity receptor immunoglobulin like domain', NULL, 'ObR_Ig', NULL, NULL, 29005, 9),
(270064, NULL, 'PF04294', NULL, NULL, 'VanW like protein', NULL, 'VanW', NULL, NULL, 3939, 9),
(270065, NULL, 'PF07315', NULL, NULL, 'Protein of unknown function (DUF1462)', NULL, 'DUF1462', NULL, NULL, 9568, 9),
(270066, NULL, 'PF03817', NULL, NULL, 'Malonate transporter MadL subunit', NULL, 'MadL', NULL, NULL, 3128, 9),
(270067, NULL, 'PF15991', NULL, NULL, 'G-protein pathway suppressor', NULL, 'G_path_suppress', NULL, NULL, 25049, 9),
(270068, NULL, 'PF13390', NULL, NULL, 'Protein of unknown function (DUF4108)', NULL, 'DUF4108', NULL, NULL, 22916, 9),
(270069, NULL, 'PF09987', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2226)', NULL, 'DUF2226', NULL, NULL, 19741, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(270070, NULL, 'PF03825', NULL, NULL, 'Nucleoside H+ symporter', NULL, 'Nuc_H_symport', NULL, NULL, 5496, 9),
(270071, NULL, 'PF09206', NULL, NULL, 'Alpha-L-arabinofuranosidase B, catalytic', NULL, 'ArabFuran-catal', NULL, NULL, 12406, 9),
(270072, NULL, 'PF15214', NULL, NULL, 'Peroxisomal testis-specific protein 1', NULL, 'PXT1', NULL, NULL, 21689, 9),
(270073, NULL, 'PF19616', NULL, NULL, 'Family of unknown function (DUF6121)', NULL, 'DUF6121', NULL, NULL, 37345, 9),
(270074, NULL, 'PF04101', NULL, NULL, 'Glycosyltransferase family 28 C-terminal domain', NULL, 'Glyco_tran_28_C', NULL, NULL, 6786, 9),
(270075, NULL, 'PF11840', NULL, NULL, 'Protein of unknown function (DUF3360)', NULL, 'DUF3360', NULL, NULL, 19374, 9),
(270076, NULL, 'PF18601', NULL, NULL, 'EZH2 N-terminal domain', NULL, 'EZH2_N', NULL, NULL, 31610, 9),
(270077, NULL, 'PF10958', NULL, NULL, 'Protein of unknown function (DUF2759)', NULL, 'DUF2759', NULL, NULL, 24184, 9),
(270078, NULL, 'PF15080', NULL, NULL, 'Domain of unknown function (DUF4547)', NULL, 'DUF4547', NULL, NULL, 23955, 9),
(270079, NULL, 'PF19384', NULL, NULL, 'Family of unknown function (DUF5959)', NULL, 'DUF5959', NULL, NULL, 36576, 9),
(270080, NULL, 'PF15433', NULL, NULL, 'Mitochondrial 28S ribosomal protein S31', NULL, 'MRP-S31', NULL, NULL, 25604, 9),
(270081, NULL, 'PF16585', NULL, NULL, 'Lipocalin-like domain', NULL, 'Lipocalin_8', NULL, NULL, 22924, 9),
(270082, NULL, 'PF17269', NULL, NULL, 'Family of unknown function (DUF5335)', NULL, 'DUF5335', NULL, NULL, 18855, 9),
(270083, NULL, 'PF09796', NULL, NULL, 'Ubiquinol-cytochrome-c reductase complex subunit (QCR10)', NULL, 'QCR10', NULL, NULL, 18314, 9),
(270084, NULL, 'PF16690', NULL, NULL, 'Methylmalonic aciduria and homocystinuria type C family', NULL, 'MMACHC', NULL, NULL, 23342, 9),
(270085, NULL, 'PF04187', NULL, NULL, 'Haem-binding uptake, Tiki superfamily, ChaN', NULL, 'Cofac_haem_bdg', NULL, NULL, 4984, 9),
(270086, NULL, 'PF13731', NULL, NULL, 'WxL domain surface cell wall-binding', NULL, 'WxL', NULL, NULL, 23709, 9),
(270087, NULL, 'PF14536', NULL, NULL, 'Domain of unknown function (DUF4441)', NULL, 'DUF4441', NULL, NULL, 23523, 9),
(270088, NULL, 'PF01015', NULL, NULL, 'Ribosomal S3Ae family', NULL, 'Ribosomal_S3Ae', NULL, NULL, 5246, 9),
(270089, NULL, 'PF03199', NULL, NULL, 'Eukaryotic glutathione synthase', NULL, 'GSH_synthase', NULL, NULL, 135, 9),
(270090, NULL, 'PF00831', NULL, NULL, 'Ribosomal L29 protein', NULL, 'Ribosomal_L29', NULL, NULL, 4326, 9),
(270091, NULL, 'PF04317', NULL, NULL, 'YcjX-like family, DUF463', NULL, 'DUF463', NULL, NULL, 3643, 9),
(270092, NULL, 'PF18368', NULL, NULL, 'Exo-beta-D-glucosaminidase Ig-fold domain', NULL, 'Ig_GlcNase', NULL, NULL, 29412, 9),
(270093, NULL, 'PF06549', NULL, NULL, 'Protein of unknown function (DUF1118)', NULL, 'DUF1118', NULL, NULL, 9099, 9),
(270094, NULL, 'PF08965', NULL, NULL, 'Domain of unknown function (DUF1870)', NULL, 'DUF1870', NULL, NULL, 8851, 9),
(270095, NULL, 'PF16252', NULL, NULL, 'Domain of unknown function (DUF4908)', NULL, 'DUF4908', NULL, NULL, 23636, 9),
(270096, NULL, 'PF06619', NULL, NULL, 'Protein of unknown function (DUF1149)', NULL, 'DUF1149', NULL, NULL, 10112, 9),
(270097, NULL, 'PF19860', NULL, NULL, 'Family of unknown function (DUF6334)', NULL, 'DUF6334', NULL, NULL, 37697, 9),
(270098, NULL, 'PF14703', NULL, NULL, 'Cytosolic domain of 10TM putative phosphate transporter', NULL, 'PHM7_cyt', NULL, NULL, 22335, 9),
(270099, NULL, 'PF16490', NULL, NULL, 'Putative oxidoreductase C terminal domain', NULL, 'Oxidoreduct_C', NULL, NULL, 22570, 9),
(270100, NULL, 'PF00549', NULL, NULL, 'CoA-ligase', NULL, 'Ligase_CoA', NULL, NULL, 5834, 9),
(270101, NULL, 'PF17124', NULL, NULL, 'ThiJ/PfpI family-like', NULL, 'ThiJ_like', NULL, NULL, 21858, 9),
(270102, NULL, 'PF07814', NULL, NULL, 'Wings apart-like protein regulation of heterochromatin', NULL, 'WAPL', NULL, NULL, 11389, 9),
(270103, NULL, 'PF20392', NULL, NULL, 'Family of unknown function (DUF6687)', NULL, 'DUF6687', NULL, NULL, 37502, 9),
(270104, NULL, 'PF08308', NULL, NULL, 'PEGA domain', NULL, 'PEGA', NULL, NULL, 12420, 9);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(270105, NULL, 'PF18241', NULL, NULL, 'Flax-rust effector AvrM-A', NULL, 'AvrM-A', NULL, NULL, 31720, 9),
(270106, NULL, 'PF17220', NULL, NULL, 'Protein of unknown function (DUF5137)', NULL, 'DUF5137', NULL, NULL, 30360, 9),
(270107, NULL, 'PF01530', NULL, NULL, 'Zinc finger, C2HC type', NULL, 'zf-C2HC', NULL, NULL, 656, 9),
(270108, NULL, 'PF02159', NULL, NULL, 'Oestrogen receptor', NULL, 'Oest_recep', NULL, NULL, NULL, 9),
(270109, NULL, 'PF14650', NULL, NULL, 'FAM75 family', NULL, 'FAM75', NULL, NULL, 27454, 9),
(270110, NULL, 'PF01128', NULL, NULL, '2-C-methyl-D-erythritol 4-phosphate cytidylyltransferase', NULL, 'IspD', NULL, NULL, 18793, 9),
(270111, NULL, 'PF04753', NULL, NULL, 'Coronavirus non-structural protein NS12.7 family', NULL, 'Corona_NS12-7', NULL, NULL, 3793, 9),
(270112, NULL, 'PF14761', NULL, NULL, 'Hermansky-Pudlak syndrome 3', NULL, 'HPS3_N', NULL, NULL, 26528, 9),
(270113, NULL, 'PF04123', NULL, NULL, 'Domain of unknown function (DUF373)', NULL, 'DUF373', NULL, NULL, 6992, 9),
(270114, NULL, 'PF07149', NULL, NULL, 'Pes-10', NULL, 'Pes-10', NULL, NULL, 13014, 9),
(270115, NULL, 'PF05626', NULL, NULL, 'Protein of unknown function (DUF790)', NULL, 'DUF790', NULL, NULL, 12468, 9),
(270116, NULL, 'PF03698', NULL, NULL, 'Uncharacterised protein family (UPF0180)', NULL, 'UPF0180', NULL, NULL, 6133, 9),
(270117, NULL, 'PF12878', NULL, NULL, 'SICA extracellular beta domain', NULL, 'SICA_beta', NULL, NULL, 8712, 9),
(270118, NULL, 'PF19819', NULL, NULL, 'Family of unknown function (DUF6302)', NULL, 'DUF6302', NULL, NULL, 37405, 9),
(270119, NULL, 'PF02449', NULL, NULL, 'Beta-galactosidase', NULL, 'Glyco_hydro_42', NULL, NULL, 8741, 9),
(270120, NULL, 'PF09099', NULL, NULL, 'Quinohemoprotein amine dehydrogenase, alpha subunit domain III', NULL, 'Qn_am_d_aIII', NULL, NULL, 10817, 9),
(270121, NULL, 'PF19530', NULL, NULL, 'NAD(P)H-quinone oxidoreductase subunit 2 N-terminal', NULL, 'Ndh2_N', NULL, NULL, 36082, 9),
(270122, NULL, 'PF10251', NULL, NULL, 'Presenilin enhancer-2 subunit of gamma secretase', NULL, 'PEN-2', NULL, NULL, 15691, 9),
(270123, NULL, 'PF13376', NULL, NULL, 'Bacteriocin-protection, YdeI or OmpD-Associated', NULL, 'OmdA', NULL, NULL, NULL, 9),
(270124, NULL, 'PF03407', NULL, NULL, 'Nucleotide-diphospho-sugar transferase', NULL, 'Nucleotid_trans', NULL, NULL, 2474, 9),
(270125, NULL, 'PF11461', NULL, NULL, 'Rab interacting lysosomal protein', NULL, 'RILP', NULL, NULL, 18801, 9),
(270126, NULL, 'PF16972', NULL, NULL, 'Na+ channel auxiliary subunit TipE', NULL, 'TipE', NULL, NULL, 22206, 9),
(270127, NULL, 'PF07264', NULL, NULL, 'Etoposide-induced protein 2.4 (EI24)', NULL, 'EI24', NULL, NULL, NULL, 9),
(270128, NULL, 'PF13308', NULL, NULL, 'YARHG domain', NULL, 'YARHG', NULL, NULL, 24838, 9),
(270129, NULL, 'PF20607', NULL, NULL, 'Family of unknown function (DUF6800)', NULL, 'DUF6800', NULL, NULL, 37753, 9),
(270130, NULL, 'PF04217', NULL, NULL, 'Protein of unknown function, DUF412', NULL, 'DUF412', NULL, NULL, 5370, 9),
(270131, NULL, 'PF07332', NULL, NULL, 'Putative Actinobacterial Holin-X, holin superfamily III', NULL, 'Phage_holin_3_6', NULL, NULL, 8477, 9),
(270132, NULL, 'PF11297', NULL, NULL, 'Protein of unknown function (DUF3098)', NULL, 'DUF3098', NULL, NULL, 18441, 9),
(270133, NULL, 'PF20183', NULL, NULL, 'Family of unknown function (DUF6546)', NULL, 'DUF6546', NULL, NULL, 37064, 9),
(270134, NULL, 'PF08072', NULL, NULL, 'BDHCT (NUC031) domain', NULL, 'BDHCT', NULL, NULL, 12665, 9),
(270135, NULL, 'PF18677', NULL, NULL, 'Archaellum regulatory network B, C-terminal domain', NULL, 'ArnB_C', NULL, NULL, 27549, 9),
(270136, NULL, 'PF14534', NULL, NULL, 'Domain of unknown function (DUF4440)', NULL, 'DUF4440', NULL, NULL, 26063, 9),
(270137, NULL, 'PF18020', NULL, NULL, 'TIG domain found in plexin', NULL, 'TIG_2', NULL, NULL, 29453, 9),
(270138, NULL, 'PF02611', NULL, NULL, 'CDP-diacylglycerol pyrophosphatase', NULL, 'CDH', NULL, NULL, 2442, 9),
(270139, NULL, 'PF10364', NULL, NULL, 'Putative capsular polysaccharide synthesis protein', NULL, 'NKWYS', NULL, NULL, 20125, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(270140, NULL, 'PF14196', NULL, NULL, 'L-2-amino-thiazoline-4-carboxylic acid hydrolase', NULL, 'ATC_hydrolase', NULL, NULL, 23089, 9),
(270141, NULL, 'PF19995', NULL, NULL, 'inactive STAND', NULL, 'iSTAND', NULL, NULL, 35520, 9),
(270142, NULL, 'PF03252', NULL, NULL, 'Herpesvirus UL21', NULL, 'Herpes_UL21', NULL, NULL, 1915, 9),
(270143, NULL, 'PF07688', NULL, NULL, 'KaiA C-terminal domain', NULL, 'KaiA', NULL, NULL, 21402, 9),
(270144, NULL, 'PF16665', NULL, NULL, 'Unstructured region on nuclear receptor coactivator protein', NULL, 'NCOA_u2', NULL, NULL, NULL, 9),
(270145, NULL, 'PF20272', NULL, NULL, 'Cysteine-rich domain, C-terminal to E2 domain', NULL, 'E2-Crich', NULL, NULL, 33861, 9),
(270146, NULL, 'PF19228', NULL, NULL, 'Family of unknown function (DUF5881)', NULL, 'DUF5881', NULL, NULL, 37420, 9),
(270147, NULL, 'PF05919', NULL, NULL, 'Mitovirus RNA-dependent RNA polymerase', NULL, 'Mitovir_RNA_pol', NULL, NULL, 12686, 9),
(270148, NULL, 'PF08399', NULL, NULL, 'VWA N-terminal', NULL, 'VWA_N', NULL, NULL, 11305, 9),
(270149, NULL, 'PF00865', NULL, NULL, 'Osteopontin', NULL, 'Osteopontin', NULL, NULL, 2211, 9),
(270150, NULL, 'PF04845', NULL, NULL, 'PurA ssDNA and RNA-binding protein', NULL, 'PurA', NULL, NULL, 1090, 9),
(270151, NULL, 'PF03266', NULL, NULL, 'NTPase', NULL, 'NTPase_1', NULL, NULL, 2519, 9),
(270152, NULL, 'PF02527', NULL, NULL, 'rRNA small subunit methyltransferase G', NULL, 'GidB', NULL, NULL, 1890, 9),
(270153, NULL, 'PF03448', NULL, NULL, 'MgtE intracellular N domain', NULL, 'MgtE_N', NULL, NULL, 1908, 9),
(270154, NULL, 'PF05878', NULL, NULL, 'Phytoreovirus nonstructural protein Pns9/Pns10', NULL, 'Phyto_Pns9_10', NULL, NULL, 12100, 9),
(270155, NULL, 'PF07033', NULL, NULL, 'Orthopoxvirus B11R protein', NULL, 'Orthopox_B11R', NULL, NULL, 12438, 9),
(270156, NULL, 'PF04976', NULL, NULL, 'DMSO reductase anchor subunit (DmsC)', NULL, 'DmsC', NULL, NULL, 6854, 9),
(270157, NULL, 'PF15415', NULL, NULL, 'Fimbrillin-like', NULL, 'Mfa_like_2', NULL, NULL, 21988, 9),
(270158, NULL, 'PF15721', NULL, NULL, 'Annexin-2 receptor', NULL, 'ANXA2R', NULL, NULL, 24275, 9),
(270159, NULL, 'PF04554', NULL, NULL, 'Extensin-like region', NULL, 'Extensin_2', NULL, NULL, 2056, 9),
(270160, NULL, 'PF13401', NULL, NULL, 'AAA domain', NULL, 'AAA_22', NULL, NULL, 96, 9),
(270161, NULL, 'PF07168', NULL, NULL, 'Ureide permease', NULL, 'Ureide_permease', NULL, NULL, 13146, 9),
(270162, NULL, 'PF03184', NULL, NULL, 'DDE superfamily endonuclease', NULL, 'DDE_1', NULL, NULL, 7309, 9),
(270163, NULL, 'PF18037', NULL, NULL, 'Ubiquitin-like domain', NULL, 'Ubiquitin_5', NULL, NULL, 28810, 9),
(270164, NULL, 'PF19785', NULL, NULL, 'Family of unknown function (UPF0738)', NULL, 'UPF0738', NULL, NULL, NULL, 9),
(270165, NULL, 'PF04012', NULL, NULL, 'PspA/IM30 family', NULL, 'PspA_IM30', NULL, NULL, 30, 9),
(270166, NULL, 'PF04759', NULL, NULL, 'Protein of unknown function, DUF617', NULL, 'DUF617', NULL, NULL, 6990, 9),
(270167, NULL, 'PF10446', NULL, NULL, 'Protein of unknown function (DUF2457)', NULL, 'DUF2457', NULL, NULL, 20262, 9),
(270168, NULL, 'PF11835', NULL, NULL, 'RRM-like domain', NULL, 'RRM_8', NULL, NULL, 19409, 9),
(270169, NULL, 'PF14401', NULL, NULL, 'RimK-like ATPgrasp N-terminal domain', NULL, 'RLAN', NULL, NULL, 24243, 9),
(270170, NULL, 'PF06147', NULL, NULL, 'Protein of unknown function (DUF968)', NULL, 'DUF968', NULL, NULL, 9186, 9),
(270171, NULL, 'PF01894', NULL, NULL, 'Uncharacterised protein family UPF0047', NULL, 'UPF0047', NULL, NULL, 3185, 9),
(270172, NULL, 'PF19451', NULL, NULL, 'Family of unknown function (DUF5989)', NULL, 'DUF5989', NULL, NULL, 36682, 9),
(270173, NULL, 'PF15803', NULL, NULL, 'Zinc-finger of sodium channel modifier 1', NULL, 'zf-SCNM1', NULL, NULL, 26347, 9),
(270174, NULL, 'PF05677', NULL, NULL, 'Chlamydia CHLPS protein (DUF818)', NULL, 'DUF818', NULL, NULL, 13148, 9),
(270175, NULL, 'PF13392', NULL, NULL, 'HNH endonuclease', NULL, 'HNH_3', NULL, NULL, 848, 9),
(270176, NULL, 'PF12013', NULL, NULL, 'Orsellinic acid/F9775 biosynthesis cluster protein D', NULL, 'OrsD', NULL, NULL, 14833, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(270177, NULL, 'PF00507', NULL, NULL, 'NADH-ubiquinone/plastoquinone oxidoreductase, chain 3', NULL, 'Oxidored_q4', NULL, NULL, 5603, 9),
(270178, NULL, 'PF19697', NULL, NULL, 'Atg11 middle domain', NULL, 'Atg11_middle', NULL, NULL, 36265, 9),
(270179, NULL, 'PF11773', NULL, NULL, 'Type II secretory pathway pseudopilin', NULL, 'PulG', NULL, NULL, 19455, 9),
(270180, NULL, 'PF15854', NULL, NULL, 'G-protein coupled receptor ligand 15', NULL, 'GPR15L', NULL, NULL, 25538, 9),
(270181, NULL, 'PF14307', NULL, NULL, 'Glycosyltransferase WbsX', NULL, 'Glyco_tran_WbsX', NULL, NULL, 26934, 9),
(270182, NULL, 'PF06489', NULL, NULL, 'Orthopoxvirus A49R protein', NULL, 'Orthopox_A49R', NULL, NULL, 9409, 9),
(270183, NULL, 'PF05794', NULL, NULL, 'T-complex protein 11', NULL, 'Tcp11', NULL, NULL, 13607, 9),
(270184, NULL, 'PF09244', NULL, NULL, 'Domain of unknown function (DUF1964)', NULL, 'DUF1964', NULL, NULL, 13203, 9),
(270185, NULL, 'PF04019', NULL, NULL, 'Protein of unknown function (DUF359)', NULL, 'DUF359', NULL, NULL, 240, 9),
(270186, NULL, 'PF15990', NULL, NULL, 'UPF0767 family', NULL, 'UPF0767', NULL, NULL, 24916, 9),
(270187, NULL, 'PF18957', NULL, NULL, 'Long Rib domain', NULL, 'RibLong', NULL, NULL, 35828, 9),
(270188, NULL, 'PF00839', NULL, NULL, 'Cysteine rich repeat', NULL, 'Cys_rich_FGFR', NULL, NULL, 4369, 9),
(270189, NULL, 'PF08341', NULL, NULL, 'Thioester domain', NULL, 'TED', NULL, NULL, 12698, 9),
(270190, NULL, 'PF03747', NULL, NULL, 'ADP-ribosylglycohydrolase', NULL, 'ADP_ribosyl_GH', NULL, NULL, 510, 9),
(270191, NULL, 'PF05822', NULL, NULL, 'Pyrimidine 5''-nucleotidase (UMPH-1)', NULL, 'UMPH-1', NULL, NULL, 6960, 9),
(270192, NULL, 'PF13700', NULL, NULL, 'Domain of unknown function (DUF4158)', NULL, 'DUF4158', NULL, NULL, 23158, 9),
(270193, NULL, 'PF10423', NULL, NULL, 'Bacterial AMP nucleoside phosphorylase N-terminus', NULL, 'AMNp_N', NULL, NULL, 16912, 9),
(270194, NULL, 'PF07608', NULL, NULL, 'Protein of unknown function (DUF1571)', NULL, 'DUF1571', NULL, NULL, 13543, 9),
(270195, NULL, 'PF16695', NULL, NULL, 'Type VI secretion system (T6SS), amidase immunity protein', NULL, 'Tai4', NULL, NULL, 23471, 9),
(270196, NULL, 'PF12972', NULL, NULL, 'Alpha-N-acetylglucosaminidase (NAGLU) C-terminal domain', NULL, 'NAGLU_C', NULL, NULL, 26006, 9),
(270197, NULL, 'PF18093', NULL, NULL, 'tRNA methyltransferase 5 N-terminal domain', NULL, 'Trm5_N', NULL, NULL, 27644, 9),
(270198, NULL, 'PF01134', NULL, NULL, 'Glucose inhibited division protein A', NULL, 'GIDA', NULL, NULL, 27009, 9),
(270199, NULL, 'PF13685', NULL, NULL, 'Iron-containing alcohol dehydrogenase', NULL, 'Fe-ADH_2', NULL, NULL, 21986, 9),
(270200, NULL, 'PF08271', NULL, NULL, 'TFIIB zinc-binding', NULL, 'TF_Zn_Ribbon', NULL, NULL, 7653, 9),
(270201, NULL, 'PF16932', NULL, NULL, 'Type IV secretory system, conjugal DNA-protein transfer', NULL, 'T4SS_TraI', NULL, NULL, 25228, 9),
(270202, NULL, 'PF13180', NULL, NULL, 'PDZ domain', NULL, 'PDZ_2', NULL, NULL, 3119, 9),
(270203, NULL, 'PF03824', NULL, NULL, 'High-affinity nickel-transport protein', NULL, 'NicO', NULL, NULL, 12403, 9),
(270204, NULL, 'PF03996', NULL, NULL, 'Hemagglutinin esterase', NULL, 'Hema_esterase', NULL, NULL, 31, 9),
(270205, NULL, 'PF10433', NULL, NULL, 'Mono-functional DNA-alkylating methyl methanesulfonate N-term', NULL, 'MMS1_N', NULL, NULL, 20308, 9),
(270206, NULL, 'PF17196', NULL, NULL, 'Protein of unknown function (DUF5133)', NULL, 'DUF5133', NULL, NULL, 31026, 9),
(270207, NULL, 'PF12452', NULL, NULL, 'Protein of unknown function (DUF3685)', NULL, 'DUF3685', NULL, NULL, 16291, 9),
(270208, NULL, 'PF01457', NULL, NULL, 'Leishmanolysin', NULL, 'Peptidase_M8', NULL, NULL, 5367, 9),
(270209, NULL, 'PF17229', NULL, NULL, 'Serine/threonine-protein kinase SMG1 N-terminal', NULL, 'SMG1_N', NULL, NULL, 20389, 9),
(270210, NULL, 'PF02837', NULL, NULL, 'Glycosyl hydrolases family 2, sugar binding domain', NULL, 'Glyco_hydro_2_N', NULL, NULL, 10289, 9),
(270211, NULL, 'PF03773', NULL, NULL, 'Predicted permease', NULL, 'ArsP_1', NULL, NULL, 1746, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(270212, NULL, 'PF05162', NULL, NULL, 'Ribosomal protein L41', NULL, 'Ribosomal_L41', NULL, NULL, 2179, 9),
(270213, NULL, 'PF17335', NULL, NULL, 'Ino80 complex subunit 5', NULL, 'IES5', NULL, NULL, 19674, 9),
(270214, NULL, 'PF14845', NULL, NULL, 'beta-acetyl hexosaminidase like', NULL, 'Glycohydro_20b2', NULL, NULL, 23068, 9),
(270215, NULL, 'PF11887', NULL, NULL, 'Cholesterol uptake porter CUP1 of Mce4, putative', NULL, 'Mce4_CUP1', NULL, NULL, 24967, 9),
(270216, NULL, 'PF10342', NULL, NULL, 'Kre9/KNH-like N-terminal Ig-like domain', NULL, 'Kre9_KNH', NULL, NULL, 21169, 9),
(270217, NULL, 'PF17758', NULL, NULL, 'Proteasomal ATPase OB N-terminal domain', NULL, 'Prot_ATP_OB_N', NULL, NULL, 29718, 9),
(270218, NULL, 'PF19947', NULL, NULL, 'Family of unknown function (DUF6409)', NULL, 'DUF6409', NULL, NULL, 37240, 9),
(270219, NULL, 'PF03871', NULL, NULL, 'RNA polymerase Rpb5, N-terminal domain', NULL, 'RNA_pol_Rpb5_N', NULL, NULL, 1927, 9),
(270220, NULL, 'PF00693', NULL, NULL, 'Thymidine kinase from herpesvirus', NULL, 'Herpes_TK', NULL, NULL, 4232, 9),
(270221, NULL, 'PF06770', NULL, NULL, 'Actin-rearrangement-inducing factor (Arif-1)', NULL, 'Arif-1', NULL, NULL, 9130, 9),
(270222, NULL, 'PF09706', NULL, NULL, 'CRISPR-associated protein (Cas_CXXC_CXXC)', NULL, 'Cas_CXXC_CXXC', NULL, NULL, 17549, 9),
(270223, NULL, 'PF04982', NULL, NULL, 'HPP family', NULL, 'HPP', NULL, NULL, 6633, 9),
(270224, NULL, 'PF01182', NULL, NULL, 'Glucosamine-6-phosphate isomerases/6-phosphogluconolactonase', NULL, 'Glucosamine_iso', NULL, NULL, 11046, 9),
(270225, NULL, 'PF03223', NULL, NULL, 'V-ATPase subunit C', NULL, 'V-ATPase_C', NULL, NULL, 1904, 9),
(270226, NULL, 'PF19331', NULL, NULL, 'Methylcrotonoyl-CoA carboxylase subunit alpha BT domain', NULL, 'MCCA_BT', NULL, NULL, 34977, 9),
(270227, NULL, 'PF13076', NULL, NULL, 'Fur-regulated basic protein A', NULL, 'Fur_reg_FbpA', NULL, NULL, 22713, 9),
(270228, NULL, 'PF02106', NULL, NULL, 'Fanconi anaemia group C protein', NULL, 'Fanconi_C', NULL, NULL, 6917, 9),
(270229, NULL, 'PF09228', NULL, NULL, 'Prokaryotic Transcriptional repressor TraM', NULL, 'Prok-TraM', NULL, NULL, 13431, 9),
(270230, NULL, 'PF03733', NULL, NULL, 'Inner membrane component domain', NULL, 'YccF', NULL, NULL, 5079, 9),
(270231, NULL, 'PF05229', NULL, NULL, 'Spore Coat Protein U domain', NULL, 'SCPU', NULL, NULL, 3087, 9),
(270232, NULL, 'PF04398', NULL, NULL, 'Protein of unknown function, DUF538', NULL, 'DUF538', NULL, NULL, 10466, 9),
(270233, NULL, 'PF12713', NULL, NULL, 'Domain of unknown function (DUF3806)', NULL, 'DUF3806', NULL, NULL, 20111, 9),
(270234, NULL, 'PF12823', NULL, NULL, 'Domain of unknown function (DUF3817)', NULL, 'DUF3817', NULL, NULL, 16570, 9),
(270235, NULL, 'PF17663', NULL, NULL, 'Family of unknown function (DUF5525)', NULL, 'DUF5525', NULL, NULL, 32532, 9),
(270236, NULL, 'PF17762', NULL, NULL, 'HTH domain found in ParB protein', NULL, 'HTH_ParB', NULL, NULL, 29628, 9),
(270237, NULL, 'PF00379', NULL, NULL, 'Insect cuticle protein', NULL, 'Chitin_bind_4', NULL, NULL, 5789, 9),
(270238, NULL, 'PF15471', NULL, NULL, 'Transmembrane protein family 171', NULL, 'TMEM171', NULL, NULL, 26990, 9),
(270239, NULL, 'PF02939', NULL, NULL, 'UcrQ family', NULL, 'UcrQ', NULL, NULL, 3964, 9),
(270240, NULL, 'PF02882', NULL, NULL, 'Tetrahydrofolate dehydrogenase/cyclohydrolase, NAD(P)-binding domain', NULL, 'THF_DHG_CYH_C', NULL, NULL, 20202, 9),
(270241, NULL, 'PF20240', NULL, NULL, 'Domain of unknown function (DUF6597)', NULL, 'DUF6597', NULL, NULL, 37566, 9),
(270242, NULL, 'PF10432', NULL, NULL, 'Bacterial phospho-glucose isomerase C-terminal SIS domain', NULL, 'bact-PGI_C', NULL, NULL, 18379, 9),
(270243, NULL, 'PF17934', NULL, NULL, 'Tetracyclin repressor-like, C-terminal domain', NULL, 'TetR_C_26', NULL, NULL, 30520, 9),
(270244, NULL, 'PF17854', NULL, NULL, 'FtsK alpha domain', NULL, 'FtsK_alpha', NULL, NULL, 29443, 9),
(270245, NULL, 'PF16526', NULL, NULL, 'C-terminal leucine zipper domain of cyclic nucleotide-gated channels', NULL, 'CLZ', NULL, NULL, 25461, 9);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(270246, NULL, 'PF11965', NULL, NULL, 'Domain of unknown function (DUF3479)', NULL, 'DUF3479', NULL, NULL, 16361, 9),
(270247, NULL, 'PF18790', NULL, NULL, 'KfrB protein', NULL, 'KfrB', NULL, NULL, 28105, 9),
(270248, NULL, 'PF08358', NULL, NULL, 'Carlavirus coat', NULL, 'Flexi_CP_N', NULL, NULL, 12967, 9),
(270249, NULL, 'PF05771', NULL, NULL, 'Poxvirus A31 protein', NULL, 'Pox_A31', NULL, NULL, 12116, 9),
(270250, NULL, 'PF12107', NULL, NULL, 'Plasminogen (Pg) ligand in fibrinolytic pathway', NULL, 'VEK-30', NULL, NULL, 20022, 9),
(270251, NULL, 'PF10043', NULL, NULL, 'Predicted periplasmic lipoprotein (DUF2279)', NULL, 'DUF2279', NULL, NULL, 18445, 9),
(270252, NULL, 'PF18092', NULL, NULL, 'DraK Histidine Kinase N-terminal domain', NULL, 'DraK_HK_N', NULL, NULL, 28449, 9),
(270253, NULL, 'PF05561', NULL, NULL, 'Borrelia burgdorferi protein of unknown function (DUF764)', NULL, 'DUF764', NULL, NULL, 12487, 9),
(270254, NULL, 'PF06316', NULL, NULL, 'Enterobacterial Ail/Lom protein', NULL, 'Ail_Lom', NULL, NULL, 6988, 9),
(270255, NULL, 'PF03010', NULL, NULL, 'GP4', NULL, 'GP4', NULL, NULL, 3762, 9),
(270256, NULL, 'PF07959', NULL, NULL, 'L-fucokinase', NULL, 'Fucokinase', NULL, NULL, 13407, 9),
(270257, NULL, 'PF15534', NULL, NULL, 'Bacterial toxin 35', NULL, 'Ntox35', NULL, NULL, 23662, 9),
(270258, NULL, 'PF17478', NULL, NULL, 'Rotavirus VP4 helical domain', NULL, 'VP4_helical', NULL, NULL, 9782, 9),
(270259, NULL, 'PF11834', NULL, NULL, 'KHA, dimerisation domain of potassium ion channel', NULL, 'KHA', NULL, NULL, 19442, 9),
(270260, NULL, 'PF17238', NULL, NULL, 'Family of unknown function (DUF5311)', NULL, 'DUF5311', NULL, NULL, 20349, 9),
(270261, NULL, 'PF19093', NULL, NULL, 'Family of unknown function (DUF5781)', NULL, 'DUF5781', NULL, NULL, 35936, 9),
(270262, NULL, 'PF19833', NULL, NULL, 'ATP-dependent DNA helicase RecG, domain 3, C-terminal', NULL, 'RecG_dom3_C', NULL, NULL, 36207, 9),
(270263, NULL, 'PF18719', NULL, NULL, 'ArlS sensor domain', NULL, 'ArlS_N', NULL, NULL, 30847, 9),
(270264, NULL, 'PF16713', NULL, NULL, 'Enriched in aromatic and glycine Residues box', NULL, 'EAGR_box', NULL, NULL, 15543, 9),
(270265, NULL, 'PF02026', NULL, NULL, 'RyR domain', NULL, 'RyR', NULL, NULL, 370, 9),
(270266, NULL, 'PF04730', NULL, NULL, 'Agrobacterium VirD5 protein', NULL, 'Agro_virD5', NULL, NULL, 3818, 9),
(270267, NULL, 'PF09049', NULL, NULL, 'Stannin transmembrane', NULL, 'SNN_transmemb', NULL, NULL, 9599, 9),
(270268, NULL, 'PF12473', NULL, NULL, 'Kinesin protein', NULL, 'DUF3694', NULL, NULL, 20554, 9),
(270269, NULL, 'PF12800', NULL, NULL, '4Fe-4S binding domain', NULL, 'Fer4_4', NULL, NULL, 12567, 9),
(270270, NULL, 'PF07859', NULL, NULL, 'alpha/beta hydrolase fold', NULL, 'Abhydrolase_3', NULL, NULL, 18640, 9),
(270271, NULL, 'PF05984', NULL, NULL, 'Cytomegalovirus UL20A protein', NULL, 'Cytomega_UL20A', NULL, NULL, 13966, 9),
(270272, NULL, 'PF12481', NULL, NULL, 'Aluminium induced protein', NULL, 'DUF3700', NULL, NULL, 20444, 9),
(270273, NULL, 'PF17285', NULL, NULL, 'PRMT5 TIM barrel domain', NULL, 'PRMT5_TIM', NULL, NULL, 28424, 9),
(270274, NULL, 'PF04383', NULL, NULL, 'KilA-N domain', NULL, 'KilA-N', NULL, NULL, 19363, 9),
(270275, NULL, 'PF05911', NULL, NULL, 'Filament-like plant protein, long coiled-coil', NULL, 'FPP', NULL, NULL, 14195, 9),
(270276, NULL, 'PF13823', NULL, NULL, 'Alcohol dehydrogenase GroES-associated', NULL, 'ADH_N_assoc', NULL, NULL, 24885, 9),
(270277, NULL, 'PF00483', NULL, NULL, 'Nucleotidyl transferase', NULL, 'NTP_transferase', NULL, NULL, 5546, 9),
(270278, NULL, 'PF16447', NULL, NULL, 'Domain of unknown function (DUF5044)', NULL, 'DUF5044', NULL, NULL, 26604, 9),
(270279, NULL, 'PF10746', NULL, NULL, 'Phage holin T7 family, holin superfamily II', NULL, 'Phage_holin_2_2', NULL, NULL, 20435, 9),
(270280, NULL, 'PF18335', NULL, NULL, 'ATP-dependent RecD-like DNA helicase SH3 domain', NULL, 'SH3_13', NULL, NULL, 29085, 9),
(270281, NULL, 'PF08324', NULL, NULL, 'PUL domain', NULL, 'PUL', NULL, NULL, 12762, 9),
(270282, NULL, 'PF10077', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2314)', NULL, 'DUF2314', NULL, NULL, 18096, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(270283, NULL, 'PF02944', NULL, NULL, 'BESS motif', NULL, 'BESS', NULL, NULL, 3684, 9),
(270284, NULL, 'PF17065', NULL, NULL, 'Putative cytokine, C6ORF120', NULL, 'UPF0669', NULL, NULL, 26239, 9),
(270285, NULL, 'PF14341', NULL, NULL, 'PilX N-terminal', NULL, 'PilX_N', NULL, NULL, 22231, 9),
(270286, NULL, 'PF01815', NULL, NULL, 'Rop protein', NULL, 'Rop', NULL, NULL, 3617, 9),
(270287, NULL, 'PF08373', NULL, NULL, 'RAP domain', NULL, 'RAP', NULL, NULL, 11607, 9),
(270288, NULL, 'PF12986', NULL, NULL, 'Domain of unknown function (DUF3870)', NULL, 'DUF3870', NULL, NULL, 1242, 9),
(270289, NULL, 'PF08655', NULL, NULL, 'DASH complex subunit Ask1', NULL, 'DASH_Ask1', NULL, NULL, 7733, 9),
(270290, NULL, 'PF07482', NULL, NULL, 'Domain of Unknown Function (DUF1522)', NULL, 'DUF1522', NULL, NULL, 11175, 9),
(270291, NULL, 'PF12232', NULL, NULL, 'Myogenic determination factor 5', NULL, 'Myf5', NULL, NULL, 20291, 9),
(270292, NULL, 'PF17251', NULL, NULL, 'Protochlamydia outer membrane protein', NULL, 'Pom', NULL, NULL, 18877, 9),
(270293, NULL, 'PF04442', NULL, NULL, 'Cytochrome c oxidase assembly protein CtaG/Cox11', NULL, 'CtaG_Cox11', NULL, NULL, 10861, 9),
(270294, NULL, 'PF07579', NULL, NULL, 'Domain of Unknown Function (DUF1548)', NULL, 'DUF1548', NULL, NULL, 8125, 9),
(270295, NULL, 'PF10218', NULL, NULL, 'SREBP regulating gene protein', NULL, 'SPRING1', NULL, NULL, 15738, 9),
(270296, NULL, 'PF02088', NULL, NULL, 'Ornatin', NULL, 'Ornatin', NULL, NULL, 6820, 9),
(270297, NULL, 'PF19213', NULL, NULL, 'Coronavirus replicase NSP6', NULL, 'CoV_NSP6', NULL, NULL, 35385, 9),
(270298, NULL, 'PF05808', NULL, NULL, 'Podoplanin', NULL, 'Podoplanin', NULL, NULL, NULL, 9),
(270299, NULL, 'PF18684', NULL, NULL, 'Pleurotolysin B C-terminal domain', NULL, 'PlyB_C', NULL, NULL, 27839, 9),
(270300, NULL, 'PF18839', NULL, NULL, 'Large polyvalent protein associated domain 24', NULL, 'LPD24', NULL, NULL, 29410, 9),
(270301, NULL, 'PF00765', NULL, NULL, 'Autoinducer synthase', NULL, 'Autoind_synth', NULL, NULL, 3015, 9),
(270302, NULL, 'PF10253', NULL, NULL, 'Mitotic checkpoint regulator, MAD2B-interacting', NULL, 'PRCC', NULL, NULL, 19054, 9),
(270303, NULL, 'PF01763', NULL, NULL, 'Herpesvirus UL6 like', NULL, 'Herpes_UL6', NULL, NULL, 2766, 9),
(270304, NULL, 'PF19778', NULL, NULL, 'Endonuclease domain', NULL, 'RE_endonuc', NULL, NULL, 36222, 9),
(270305, NULL, 'PF12965', NULL, NULL, 'Domain of unknown function (DUF3854)', NULL, 'DUF3854', NULL, NULL, 23270, 9),
(270306, NULL, 'PF14926', NULL, NULL, 'Cilia- and flagella-associated protein 300', NULL, 'CFAP300', NULL, NULL, 23550, 9),
(270307, NULL, 'PF13834', NULL, NULL, 'Domain of unknown function (DUF4193)', NULL, 'DUF4193', NULL, NULL, 23418, 9),
(270308, NULL, 'PF18143', NULL, NULL, 'HAD domain in Swiss Army Knife RNA repair proteins', NULL, 'HAD_SAK_2', NULL, NULL, NULL, 9),
(270309, NULL, 'PF03471', NULL, NULL, 'Transporter associated domain', NULL, 'CorC_HlyC', NULL, NULL, 4889, 9),
(270310, NULL, 'PF19245', NULL, NULL, 'Family of unknown function (DUF5893)', NULL, 'DUF5893', NULL, NULL, 37350, 9),
(270311, NULL, 'PF00248', NULL, NULL, 'Aldo/keto reductase family', NULL, 'Aldo_ket_red', NULL, NULL, 15749, 9),
(270312, NULL, 'PF11072', NULL, NULL, 'Protein of unknown function (DUF2859)', NULL, 'DUF2859', NULL, NULL, 17696, 9),
(270313, NULL, 'PF08094', NULL, NULL, 'Conotoxin TVIIA/GS family', NULL, 'Toxin_24', NULL, NULL, 9971, 9),
(270314, NULL, 'PF11534', NULL, NULL, 'Hexameric tyrosine-coordinated heme protein (HTHP)', NULL, 'HTHP', NULL, NULL, 15441, 9),
(270315, NULL, 'PF06468', NULL, NULL, 'Spondin_N', NULL, 'Spond_N', NULL, NULL, 9100, 9),
(270316, NULL, 'PF18895', NULL, NULL, 'Type IV secretion system pilin', NULL, 'T4SS_pilin', NULL, NULL, 35924, 9),
(270317, NULL, 'PF11535', NULL, NULL, 'Calcium binding', NULL, 'Calci_bind_CcbP', NULL, NULL, 20645, 9),
(270318, NULL, 'PF00963', NULL, NULL, 'Cohesin domain', NULL, 'Cohesin', NULL, NULL, 4212, 9),
(270319, NULL, 'PF09683', NULL, NULL, 'Bacteriocin (Lactococcin_972)', NULL, 'Lactococcin_972', NULL, NULL, 62, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(270320, NULL, 'PF05605', NULL, NULL, 'Drought induced 19 protein (Di19), zinc-binding', NULL, 'zf-Di19', NULL, NULL, 14466, 9),
(270321, NULL, 'PF19523', NULL, NULL, 'Family of unknown function (DUF6053)', NULL, 'DUF6053', NULL, NULL, 37413, 9),
(270322, NULL, 'PF08838', NULL, NULL, 'Protein of unknown function (DUF1811)', NULL, 'DUF1811', NULL, NULL, 14353, 9),
(270323, NULL, 'PF07087', NULL, NULL, 'Protein of unknown function (DUF1353)', NULL, 'DUF1353', NULL, NULL, 10796, 9),
(270324, NULL, 'PF12056', NULL, NULL, 'Protein of unknown function (DUF3537)', NULL, 'DUF3537', NULL, NULL, 19964, 9),
(270325, NULL, 'PF20577', NULL, NULL, 'Phage ORF5 protein', NULL, 'Phage_ORF5', NULL, NULL, 37764, 9),
(270326, NULL, 'PF08823', NULL, NULL, 'Putative peptidoglycan binding domain', NULL, 'PG_binding_2', NULL, NULL, 14064, 9),
(270327, NULL, 'PF16685', NULL, NULL, 'zinc RING finger of MSL2', NULL, 'zf-RING_10', NULL, NULL, 25898, 9),
(270328, NULL, 'PF14679', NULL, NULL, 'FANCI helical domain 1', NULL, 'FANCI_HD1', NULL, NULL, 26916, 9),
(270329, NULL, 'PF15342', NULL, NULL, 'FAM212 family', NULL, 'FAM212', NULL, NULL, 26022, 9),
(270330, NULL, 'PF16849', NULL, NULL, 'Glycosyltransferase family 88', NULL, 'Glyco_transf_88', NULL, NULL, 22823, 9),
(270331, NULL, 'PF10838', NULL, NULL, 'Protein of unknown function (DUF2677)', NULL, 'DUF2677', NULL, NULL, 16223, 9),
(270332, NULL, 'PF13701', NULL, NULL, 'Transposase DDE domain group 1', NULL, 'DDE_Tnp_1_4', NULL, NULL, 24235, 9),
(270333, NULL, 'PF16666', NULL, NULL, 'Unstructured region on MAGI', NULL, 'MAGI_u5', NULL, NULL, NULL, 9),
(270334, NULL, 'PF02634', NULL, NULL, 'FdhD/NarQ family', NULL, 'FdhD-NarQ', NULL, NULL, 3222, 9),
(270335, NULL, 'PF15764', NULL, NULL, 'Domain of unknown function (DUF4693)', NULL, 'DUF4693', NULL, NULL, 26714, 9),
(270336, NULL, 'PF12578', NULL, NULL, 'Myotubularin-associated protein', NULL, '3-PAP', NULL, NULL, 17374, 9),
(270337, NULL, 'PF14177', NULL, NULL, 'YkyB-like protein', NULL, 'YkyB', NULL, NULL, 24431, 9),
(270338, NULL, 'PF14715', NULL, NULL, 'N-terminal domain of cytochrome oxidase-cbb3, FixP', NULL, 'FixP_N', NULL, NULL, 23172, 9),
(270339, NULL, 'PF10095', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2333)', NULL, 'DUF2333', NULL, NULL, 17928, 9),
(270340, NULL, 'PF18640', NULL, NULL, 'LepB N-terminal domain', NULL, 'LepB_N', NULL, NULL, 31622, 9),
(270341, NULL, 'PF06766', NULL, NULL, 'Fungal hydrophobin', NULL, 'Hydrophobin_2', NULL, NULL, 9083, 9),
(270342, NULL, 'PF05689', NULL, NULL, 'Adhesion domain', NULL, 'InvE_AD', NULL, NULL, 13462, 9),
(270343, NULL, 'PF12715', NULL, NULL, 'Abhydrolase family', NULL, 'Abhydrolase_7', NULL, NULL, 25506, 9),
(270344, NULL, 'PF19761', NULL, NULL, 'Family of unknown function (DUF6248)', NULL, 'DUF6248', NULL, NULL, 37367, 9),
(270345, NULL, 'PF19987', NULL, NULL, 'Family of unknown function (DUF6423)', NULL, 'DUF6423', NULL, NULL, 37546, 9),
(270346, NULL, 'PF15209', NULL, NULL, 'Interleukin 31', NULL, 'IL31', NULL, NULL, 25466, 9),
(270347, NULL, 'PF19592', NULL, NULL, 'Family of unknown function (DUF6097)', NULL, 'DUF6097', NULL, NULL, 36947, 9),
(270348, NULL, 'PF14025', NULL, NULL, 'Protein of unknown function (DUF4241)', NULL, 'DUF4241', NULL, NULL, 22313, 9),
(270349, NULL, 'PF05482', NULL, NULL, 'Serendipity locus alpha protein (SRY-A)', NULL, 'Serendipity_A', NULL, NULL, 13996, 9),
(270350, NULL, 'PF05631', NULL, NULL, 'Sugar-tranasporters, 12 TM', NULL, 'MFS_5', NULL, NULL, 12252, 9),
(270351, NULL, 'PF15855', NULL, NULL, 'Domain of unknown function (DUF4726)', NULL, 'DUF4726', NULL, NULL, 25729, 9),
(270352, NULL, 'PF19310', NULL, NULL, 'Neurolysin/Thimet oligopeptidase, N-terminal domain', NULL, 'TOP_N', NULL, NULL, 37410, 9),
(270353, NULL, 'PF15709', NULL, NULL, 'Domain of unknown function (DUF4670)', NULL, 'DUF4670', NULL, NULL, 25194, 9),
(270354, NULL, 'PF08805', NULL, NULL, 'PilS N terminal', NULL, 'PilS', NULL, NULL, 13054, 9),
(270355, NULL, 'PF18013', NULL, NULL, 'Phage tail lysozyme', NULL, 'Phage_lysozyme2', NULL, NULL, 29197, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(270356, NULL, 'PF07899', NULL, NULL, 'Frigida-like protein', NULL, 'Frigida', NULL, NULL, 14490, 9),
(270357, NULL, 'PF06918', NULL, NULL, 'Protein of unknown function (DUF1280)', NULL, 'DUF1280', NULL, NULL, 11935, 9),
(270358, NULL, 'PF00999', NULL, NULL, 'Sodium/hydrogen exchanger family', NULL, 'Na_H_Exchanger', NULL, NULL, 11152, 9),
(270359, NULL, 'PF08108', NULL, NULL, 'Halocidin family', NULL, 'Antimicrobial13', NULL, NULL, 12841, 9),
(270360, NULL, 'PF04959', NULL, NULL, 'Arsenite-resistance protein 2', NULL, 'ARS2', NULL, NULL, 6563, 9),
(270361, NULL, 'PF01047', NULL, NULL, 'MarR family', NULL, 'MarR', NULL, NULL, 4925, 9),
(270362, NULL, 'PF05532', NULL, NULL, 'CsbD-like', NULL, 'CsbD', NULL, NULL, 12258, 9),
(270363, NULL, 'PF06424', NULL, NULL, 'PRP1 splicing factor, N-terminal', NULL, 'PRP1_N', NULL, NULL, 10287, 9),
(270364, NULL, 'PF08537', NULL, NULL, 'Fungal Nap binding protein NBP1', NULL, 'NBP1', NULL, NULL, 7903, 9),
(270365, NULL, 'PF11097', NULL, NULL, 'Protein of unknown function (DUF2883)', NULL, 'DUF2883', NULL, NULL, 12532, 9),
(270366, NULL, 'PF06661', NULL, NULL, 'VirE3', NULL, 'VirE3', NULL, NULL, 10359, 9),
(270367, NULL, 'PF19851', NULL, NULL, 'Family of unknown function (DUF6326)', NULL, 'DUF6326', NULL, NULL, 37668, 9),
(270368, NULL, 'PF04909', NULL, NULL, 'Amidohydrolase', NULL, 'Amidohydro_2', NULL, NULL, 2359, 9),
(270369, NULL, 'PF09949', NULL, NULL, 'Phosphatidate phosphatase APP1, catalytic domain', NULL, 'APP1_cat', NULL, NULL, 19370, 9),
(270370, NULL, 'PF18762', NULL, NULL, 'Serine/Threonine/Tyrosine Kinase found in polyvalent proteins', NULL, 'Kinase-PolyVal', NULL, NULL, 28809, 9),
(270371, NULL, 'PF01888', NULL, NULL, 'CbiD', NULL, 'CbiD', NULL, NULL, 3670, 9),
(270372, NULL, 'PF18100', NULL, NULL, 'Phosphodiesterase 4 upstream conserved regions (UCR)', NULL, 'PDE4_UCR', NULL, NULL, 32391, 9),
(270373, NULL, 'PF15384', NULL, NULL, 'PAXX, PAralog of XRCC4 and XLF, also called C9orf142', NULL, 'PAXX', NULL, NULL, 25509, 9),
(270374, NULL, 'PF10118', NULL, NULL, 'Predicted metal-dependent hydrolase', NULL, 'Metal_hydrol', NULL, NULL, 16201, 9),
(270375, NULL, 'PF08751', NULL, NULL, 'TrwC relaxase', NULL, 'TrwC', NULL, NULL, 13301, 9),
(270376, NULL, 'PF13515', NULL, NULL, 'Fusaric acid resistance protein-like', NULL, 'FUSC_2', NULL, NULL, NULL, 9),
(270377, NULL, 'PF13789', NULL, NULL, 'Domain of unknown function (DUF4181)', NULL, 'DUF4181', NULL, NULL, 22377, 9),
(270378, NULL, 'PF20192', NULL, NULL, 'Family of unknown function (DUF6555)', NULL, 'DUF6555', NULL, NULL, 37201, 9),
(270379, NULL, 'PF09667', NULL, NULL, 'Domain of unknown function (DUF2028)', NULL, 'DUF2028', NULL, NULL, 17717, 9),
(270380, NULL, 'PF05679', NULL, NULL, 'Chondroitin N-acetylgalactosaminyltransferase', NULL, 'CHGN', NULL, NULL, 8845, 9),
(270381, NULL, 'PF02224', NULL, NULL, 'Cytidylate kinase', NULL, 'Cytidylate_kin', NULL, NULL, 10049, 9),
(270382, NULL, 'PF06718', NULL, NULL, 'Protein of unknown function (DUF1203)', NULL, 'DUF1203', NULL, NULL, 1989, 9),
(270383, NULL, 'PF18591', NULL, NULL, 'Immune Mapped Protein 2 (IMP2) C-terminal domain', NULL, 'IMP2_C', NULL, NULL, 28953, 9),
(270384, NULL, 'PF20458', NULL, NULL, 'Family of unknown function (DUF6711)', NULL, 'DUF6711', NULL, NULL, 37684, 9),
(270385, NULL, 'PF11153', NULL, NULL, 'Protein of unknown function (DUF2931)', NULL, 'DUF2931', NULL, NULL, 17627, 9),
(270386, NULL, 'PF08576', NULL, NULL, 'Eukaryotic protein of unknown function (DUF1764)', NULL, 'DUF1764', NULL, NULL, 17762, 9),
(270387, NULL, 'PF06941', NULL, NULL, '5'' nucleotidase, deoxy (Pyrimidine), cytosolic type C protein (NT5C)', NULL, 'NT5C', NULL, NULL, 9903, 9),
(270388, NULL, 'PF06269', NULL, NULL, 'Protein of unknown function (DUF1029)', NULL, 'DUF1029', NULL, NULL, 14231, 9),
(270389, NULL, 'PF06234', NULL, NULL, 'Toluene-4-monooxygenase system protein B (TmoB)', NULL, 'TmoB', NULL, NULL, 14494, 9),
(270390, NULL, 'PF16633', NULL, NULL, 'Unstructured region on APC between 1st two creatine-rich regions', NULL, 'APC_u9', NULL, NULL, NULL, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(270391, NULL, 'PF11164', NULL, NULL, 'Protein of unknown function (DUF2948)', NULL, 'DUF2948', NULL, NULL, 18292, 9),
(270392, NULL, 'PF03278', NULL, NULL, 'IpaB/EvcA family', NULL, 'IpaB_EvcA', NULL, NULL, 2778, 9),
(270393, NULL, 'PF07146', NULL, NULL, 'Protein of unknown function (DUF1389)', NULL, 'DUF1389', NULL, NULL, 10632, 9),
(270394, NULL, 'PF17468', NULL, NULL, 'Phage gene product 52', NULL, 'GP52', NULL, NULL, 18660, 9),
(270395, NULL, 'PF03771', NULL, NULL, 'Domain of unknown function (DUF317)', NULL, 'SPDY', NULL, NULL, 1749, 9),
(270396, NULL, 'PF10028', NULL, NULL, 'Predicted integral membrane protein (DUF2270)', NULL, 'DUF2270', NULL, NULL, 9749, 9),
(270397, NULL, 'PF09252', NULL, NULL, 'Allergen Fel d I-B chain', NULL, 'Feld-I_B', NULL, NULL, 13207, 9),
(270398, NULL, 'PF07750', NULL, NULL, 'GcrA cell cycle regulator', NULL, 'GcrA', NULL, NULL, 10738, 9),
(270399, NULL, 'PF12805', NULL, NULL, 'FUSC-like inner membrane protein yccS', NULL, 'FUSC-like', NULL, NULL, 26719, 9),
(270400, NULL, 'PF13023', NULL, NULL, 'HD domain', NULL, 'HD_3', NULL, NULL, 1789, 9),
(270401, NULL, 'PF03049', NULL, NULL, 'UL79 family', NULL, 'Herpes_UL79', NULL, NULL, 4892, 9),
(270402, NULL, 'PF14417', NULL, NULL, 'MEDS: MEthanogen/methylotroph, DcmR Sensory domain', NULL, 'MEDS', NULL, NULL, 24379, 9),
(270403, NULL, 'PF05745', NULL, NULL, 'Chlamydia 15 kDa cysteine-rich outer membrane protein (CRPA)', NULL, 'CRPA', NULL, NULL, 8966, 9),
(270404, NULL, 'PF15000', NULL, NULL, 'Tumour suppressor candidate 2', NULL, 'TUSC2', NULL, NULL, 23031, 9),
(270405, NULL, 'PF08892', NULL, NULL, 'YqcI/YcgG family', NULL, 'YqcI_YcgG', NULL, NULL, 7934, 9),
(270406, NULL, 'PF09787', NULL, NULL, 'Golgin subfamily A member 5', NULL, 'Golgin_A5', NULL, NULL, 18281, 9),
(270407, NULL, 'PF01383', NULL, NULL, 'CpcD/allophycocyanin linker domain', NULL, 'CpcD', NULL, NULL, 568, 9),
(270408, NULL, 'PF00298', NULL, NULL, 'Ribosomal protein L11, RNA binding domain', NULL, 'Ribosomal_L11', NULL, NULL, 21404, 9),
(270409, NULL, 'PF05554', NULL, NULL, 'Viral hemorrhagic septicemia virus non-virion protein', NULL, 'Novirhabdo_Nv', NULL, NULL, 12456, 9),
(270410, NULL, 'PF14408', NULL, NULL, 'Ribosomally synthesised peptide in actinomycetes', NULL, 'Actino_peptide', NULL, NULL, 24219, 9),
(270411, NULL, 'PF04474', NULL, NULL, 'Protein of unknown function (DUF554)', NULL, 'DUF554', NULL, NULL, 1864, 9),
(270412, NULL, 'PF17664', NULL, NULL, 'Cilia- and flagella-associated protein HOATZ-like', NULL, 'HOATZ-like', NULL, NULL, 28251, 9),
(270413, NULL, 'PF04393', NULL, NULL, 'Protein of unknown function (DUF535)', NULL, 'DUF535', NULL, NULL, 10002, 9),
(270414, NULL, 'PF16071', NULL, NULL, 'Domain of unknown function (DUF4812)', NULL, 'DUF4812', NULL, NULL, 24448, 9),
(270415, NULL, 'PF19005', NULL, NULL, 'Family of unknown function (DUF5734)', NULL, 'DUF5734', NULL, NULL, 35958, 9),
(270416, NULL, 'PF04573', NULL, NULL, 'Signal peptidase subunit', NULL, 'SPC22', NULL, NULL, 313, 9),
(270417, NULL, 'PF18593', NULL, NULL, 'CdiI immunity protein', NULL, 'CdiI_2', NULL, NULL, 28738, 9),
(270418, NULL, 'PF18620', NULL, NULL, 'Family of unknown function (DUF5627)', NULL, 'DUF5627', NULL, NULL, 28951, 9),
(270419, NULL, 'PF13257', NULL, NULL, 'Domain of unknown function (DUF4048)', NULL, 'DUF4048', NULL, NULL, 22765, 9),
(270420, NULL, 'PF17089', NULL, NULL, 'Uncharacterised protein family', NULL, 'YjbT', NULL, NULL, 24150, 9),
(270421, NULL, 'PF07331', NULL, NULL, 'Tripartite tricarboxylate transporter TctB family', NULL, 'TctB', NULL, NULL, 8478, 9),
(270422, NULL, 'PF09299', NULL, NULL, 'Mu transposase, C-terminal', NULL, 'Mu-transpos_C', NULL, NULL, 14336, 9),
(270423, NULL, 'PF14981', NULL, NULL, 'FAM165 family', NULL, 'FAM165', NULL, NULL, 33562, 9),
(270424, NULL, 'PF03345', NULL, NULL, 'Oligosaccharyltransferase 48 kDa subunit beta', NULL, 'DDOST_48kD', NULL, NULL, 942, 9),
(270425, NULL, 'PF06028', NULL, NULL, 'Alpha/beta hydrolase of unknown function (DUF915)', NULL, 'DUF915', NULL, NULL, 8562, 9),
(270426, NULL, 'PF11189', NULL, NULL, 'Protein of unknown function (DUF2973)', NULL, 'DUF2973', NULL, NULL, 18453, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(270427, NULL, 'PF16562', NULL, NULL, 'N-terminal domain of E3 ubiquitin-protein ligase HECW1 and 2', NULL, 'HECW_N', NULL, NULL, 26427, 9),
(270428, NULL, 'PF01356', NULL, NULL, 'Alpha amylase inhibitor', NULL, 'A_amylase_inhib', NULL, NULL, 4781, 9),
(270429, NULL, 'PF02897', NULL, NULL, 'Prolyl oligopeptidase, N-terminal beta-propeller domain', NULL, 'Peptidase_S9_N', NULL, NULL, 15853, 9),
(270430, NULL, 'PF03441', NULL, NULL, 'FAD binding domain of DNA photolyase', NULL, 'FAD_binding_7', NULL, NULL, 10947, 9),
(270431, NULL, 'PF12988', NULL, NULL, 'TraQ conjugal transfer protein', NULL, 'TraQ_transposon', NULL, NULL, 23417, 9),
(270432, NULL, 'PF03790', NULL, NULL, 'KNOX1 domain', NULL, 'KNOX1', NULL, NULL, 1730, 9),
(270433, NULL, 'PF13316', NULL, NULL, 'Protein of unknown function (DUF4087)', NULL, 'DUF4087', NULL, NULL, 22537, 9),
(270434, NULL, 'PF12284', NULL, NULL, 'Hox protein A13 N terminal', NULL, 'HoxA13_N', NULL, NULL, 20629, 9),
(270435, NULL, 'PF07744', NULL, NULL, 'SPOC domain', NULL, 'SPOC', NULL, NULL, 7772, 9),
(270436, NULL, 'PF10655', NULL, NULL, 'Hypothetical protein of unknown function (DUF2482)', NULL, 'DUF2482', NULL, NULL, 14991, 9),
(270437, NULL, 'PF19639', NULL, NULL, 'Family of unknown function (DUF6142)', NULL, 'DUF6142', NULL, NULL, 37436, 9),
(270438, NULL, 'PF01466', NULL, NULL, 'Skp1 family, dimerisation domain', NULL, 'Skp1', NULL, NULL, 10238, 9),
(270439, NULL, 'PF17370', NULL, NULL, 'Family of unknown function (DUF5392)', NULL, 'DUF5392', NULL, NULL, 17953, 9),
(270440, NULL, 'PF00012', NULL, NULL, 'Hsp70 protein', NULL, 'HSP70', NULL, NULL, 18743, 9),
(270441, NULL, 'PF14699', NULL, NULL, 'N-terminal domain from the human glycogen debranching enzyme', NULL, 'hGDE_N', NULL, NULL, 26839, 9),
(270442, NULL, 'PF07776', NULL, NULL, 'Zinc-finger associated domain (zf-AD)', NULL, 'zf-AD', NULL, NULL, 8116, 9),
(270443, NULL, 'PF01937', NULL, NULL, 'Damage-control phosphatase ARMT1-like domain', NULL, 'ARMT1-like_dom', NULL, NULL, 4759, 9),
(270444, NULL, 'PF04863', NULL, NULL, 'Alliinase EGF-like domain', NULL, 'EGF_alliinase', NULL, NULL, 5587, 9),
(270445, NULL, 'PF03706', NULL, NULL, 'Lysylphosphatidylglycerol synthase TM region', NULL, 'LPG_synthase_TM', NULL, NULL, 17051, 9),
(270446, NULL, 'PF08755', NULL, NULL, 'Hemimethylated DNA-binding protein YccV like', NULL, 'YccV-like', NULL, NULL, 10678, 9),
(270447, NULL, 'PF09941', NULL, NULL, 'Uncharacterized conserved protein (DUF2173)', NULL, 'DUF2173', NULL, NULL, 17388, 9),
(270448, NULL, 'PF20511', NULL, NULL, 'Phosphomannose isomerase type I, catalytic domain', NULL, 'PMI_typeI_cat', NULL, NULL, 35156, 9),
(270449, NULL, 'PF01033', NULL, NULL, 'Somatomedin B domain', NULL, 'Somatomedin_B', NULL, NULL, 1010, 9),
(270450, NULL, 'PF03799', NULL, NULL, 'Cell division protein FtsQ/DivIB, C-terminal', NULL, 'FtsQ_DivIB_C', NULL, NULL, 1518, 9),
(270451, NULL, 'PF00149', NULL, NULL, 'Calcineurin-like phosphoesterase', NULL, 'Metallophos', NULL, NULL, 4190, 9),
(270452, NULL, 'PF02318', NULL, NULL, 'FYVE-type zinc finger', NULL, 'FYVE_2', NULL, NULL, 29284, 9),
(270453, NULL, 'PF07949', NULL, NULL, 'YbbR-like protein', NULL, 'YbbR', NULL, NULL, 12547, 9),
(270454, NULL, 'PF16529', NULL, NULL, 'WD40 region of Ge1, enhancer of mRNA-decapping protein', NULL, 'Ge1_WD40', NULL, NULL, 25352, 9),
(270455, NULL, 'PF03988', NULL, NULL, 'Repeat of Unknown Function (DUF347)', NULL, 'DUF347', NULL, NULL, 83, 9),
(270456, NULL, 'PF02151', NULL, NULL, 'UvrB/uvrC motif', NULL, 'UVR', NULL, NULL, 2493, 9),
(270457, NULL, 'PF07760', NULL, NULL, 'Protein of unknown function (DUF1616)', NULL, 'DUF1616', NULL, NULL, 10948, 9),
(270458, NULL, 'PF04739', NULL, NULL, '5''-AMP-activated protein kinase beta subunit, interaction domain', NULL, 'AMPKBI', NULL, NULL, 3817, 9),
(270459, NULL, 'PF08441', NULL, NULL, 'Integrin alpha', NULL, 'Integrin_alpha2', NULL, NULL, 11887, 9),
(270460, NULL, 'PF09544', NULL, NULL, 'Protein of unknown function (DUF2381)', NULL, 'DUF2381', NULL, NULL, 11799, 9),
(270461, NULL, 'PF05147', NULL, NULL, 'Lanthionine synthetase C-like protein', NULL, 'LANC_like', NULL, NULL, 2439, 9);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(270462, NULL, 'PF07187', NULL, NULL, 'Protein of unknown function (DUF1405)', NULL, 'DUF1405', NULL, NULL, 13436, 9),
(270463, NULL, 'PF14668', NULL, NULL, 'Rapamycin-insensitive companion of mTOR, domain 5', NULL, 'RICTOR_V', NULL, NULL, 23742, 9),
(270464, NULL, 'PF18234', NULL, NULL, 'Violacein biosynthetic enzyme VioE', NULL, 'VioE', NULL, NULL, 32938, 9),
(270465, NULL, 'PF01330', NULL, NULL, 'RuvA N terminal domain', NULL, 'RuvA_N', NULL, NULL, 8349, 9),
(270466, NULL, 'PF18803', NULL, NULL, 'CxC2 like cysteine cluster associated with KDZ transposases', NULL, 'CxC2', NULL, NULL, 29879, 9),
(270467, NULL, 'PF03331', NULL, NULL, 'UDP-3-O-acyl N-acetylglycosamine deacetylase', NULL, 'LpxC', NULL, NULL, 7070, 9),
(270468, NULL, 'PF00899', NULL, NULL, 'ThiF family', NULL, 'ThiF', NULL, NULL, 5619, 9),
(270469, NULL, 'PF10564', NULL, NULL, 'Sialic-acid binding micronemal adhesive repeat', NULL, 'MAR_sialic_bdg', NULL, NULL, 19404, 9),
(270470, NULL, 'PF16260', NULL, NULL, 'Domain of unknown function (DUF4914)', NULL, 'DUF4914', NULL, NULL, 21552, 9),
(270471, NULL, 'PF11933', NULL, NULL, 'Cytoplasmic domain of voltage-gated Na+ ion channel', NULL, 'Na_trans_cytopl', NULL, NULL, 23772, 9),
(270472, NULL, 'PF15591', NULL, NULL, 'Immunity protein 31', NULL, 'Imm31', NULL, NULL, 26654, 9),
(270473, NULL, 'PF01954', NULL, NULL, 'AF2212-like', NULL, 'AF2212-like', NULL, NULL, 7236, 9),
(270474, NULL, 'PF16527', NULL, NULL, 'Two-component sensor protein CpxA, periplasmic domain', NULL, 'CpxA_peri', NULL, NULL, 25331, 9),
(270475, NULL, 'PF10743', NULL, NULL, 'Regulatory phage protein cox', NULL, 'Phage_Cox', NULL, NULL, 19905, 9),
(270476, NULL, 'PF01147', NULL, NULL, 'Crustacean CHH/MIH/GIH neurohormone family', NULL, 'Crust_neurohorm', NULL, NULL, 25273, 9),
(270477, NULL, 'PF06196', NULL, NULL, 'Protein of unknown function (DUF997)', NULL, 'DUF997', NULL, NULL, 9375, 9),
(270478, NULL, 'PF19051', NULL, NULL, 'Oxidoreductase family, C-terminal alpha/beta domain', NULL, 'GFO_IDH_MocA_C2', NULL, NULL, 35092, 9),
(270479, NULL, 'PF20355', NULL, NULL, 'Family of unknown function (DUF6650)', NULL, 'DUF6650', NULL, NULL, 33967, 9),
(270480, NULL, 'PF09416', NULL, NULL, 'RNA helicase (UPF2 interacting domain)', NULL, 'UPF1_Zn_bind', NULL, NULL, 15695, 9),
(270481, NULL, 'PF13772', NULL, NULL, 'AIG2-like family', NULL, 'AIG2_2', NULL, NULL, NULL, 9),
(270482, NULL, 'PF17422', NULL, NULL, 'Family of unknown function (DUF5410)', NULL, 'DUF5410', NULL, NULL, 13719, 9),
(270483, NULL, 'PF04174', NULL, NULL, 'A circularly permuted ATPgrasp', NULL, 'CP_ATPgrasp_1', NULL, NULL, 4513, 9),
(270484, NULL, 'PF12848', NULL, NULL, 'ABC transporter', NULL, 'ABC_tran_Xtn', NULL, NULL, 21624, 9),
(270485, NULL, 'PF02767', NULL, NULL, 'DNA polymerase III beta subunit, central domain', NULL, 'DNA_pol3_beta_2', NULL, NULL, 17315, 9),
(270486, NULL, 'PF17823', NULL, NULL, 'Family of unknown function (DUF5585)', NULL, 'DUF5585', NULL, NULL, 28549, 9),
(270487, NULL, 'PF07260', NULL, NULL, 'Progressive ankylosis protein (ANKH)', NULL, 'ANKH', NULL, NULL, 14356, 9),
(270488, NULL, 'PF03238', NULL, NULL, 'ESAG protein', NULL, 'ESAG1', NULL, NULL, 1830, 9),
(270489, NULL, 'PF05551', NULL, NULL, 'Zinc-binding loop region of homing endonuclease', NULL, 'zf-His_Me_endon', NULL, NULL, 13259, 9),
(270490, NULL, 'PF03440', NULL, NULL, 'Aerolysin/Pertussis toxin (APT) domain', NULL, 'APT', NULL, NULL, 7090, 9),
(270491, NULL, 'PF15188', NULL, NULL, 'Coiled-coil domain-containing protein 167', NULL, 'CCDC-167', NULL, NULL, 22281, 9),
(270492, NULL, 'PF10070', NULL, NULL, 'Probable inorganic carbon transporter subunit DabA', NULL, 'DabA', NULL, NULL, 18377, 9),
(270493, NULL, 'PF00898', NULL, NULL, 'Orbivirus outer capsid protein VP2', NULL, 'Orbi_VP2', NULL, NULL, 3437, 9),
(270494, NULL, 'PF19803', NULL, NULL, 'Family of unknown function (DUF6286)', NULL, 'DUF6286', NULL, NULL, 37151, 9),
(270495, NULL, 'PF04255', NULL, NULL, 'Protein of unknown function (DUF433)', NULL, 'DUF433', NULL, NULL, 5778, 9),
(270496, NULL, 'PF05803', NULL, NULL, 'Chordopoxvirus L2 protein', NULL, 'Chordopox_L2', NULL, NULL, 8728, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(270497, NULL, 'PF03039', NULL, NULL, 'Interleukin-12 alpha subunit', NULL, 'IL12', NULL, NULL, 4509, 9),
(270498, NULL, 'PF07218', NULL, NULL, 'Rhoptry-associated protein 1 (RAP-1)', NULL, 'RAP1', NULL, NULL, 14475, 9),
(270499, NULL, 'PF07729', NULL, NULL, 'FCD domain', NULL, 'FCD', NULL, NULL, 8093, 9),
(270500, NULL, 'PF09817', NULL, NULL, 'RZZ complex, subunit zwilch', NULL, 'Zwilch', NULL, NULL, 16020, 9),
(270501, NULL, 'PF19299', NULL, NULL, 'Domain of unknown function (DUF5914)', NULL, 'DUF5914', NULL, NULL, 34137, 9),
(270502, NULL, 'PF09572', NULL, NULL, 'XamI restriction endonuclease', NULL, 'RE_XamI', NULL, NULL, 16952, 9),
(270503, NULL, 'PF09561', NULL, NULL, 'HpaII restriction endonuclease', NULL, 'RE_HpaII', NULL, NULL, 16885, 9),
(270504, NULL, 'PF13635', NULL, NULL, 'Domain of unknown function (DUF4143)', NULL, 'DUF4143', NULL, NULL, 22402, 9),
(270505, NULL, 'PF03125', NULL, NULL, 'C. elegans Sre G protein-coupled chemoreceptor', NULL, 'Sre', NULL, NULL, 2913, 9),
(270506, NULL, 'PF03992', NULL, NULL, 'Antibiotic biosynthesis monooxygenase', NULL, 'ABM', NULL, NULL, 258, 9),
(270507, NULL, 'PF08504', NULL, NULL, 'Runx inhibition domain', NULL, 'RunxI', NULL, NULL, 13774, 9),
(270508, NULL, 'PF17892', NULL, NULL, 'Cadherin-like domain', NULL, 'Cadherin_5', NULL, NULL, 30444, 9),
(270509, NULL, 'PF17959', NULL, NULL, 'EF-hand domain', NULL, 'EF-hand_14', NULL, NULL, 29803, 9),
(270510, NULL, 'PF12316', NULL, NULL, 'Segment polarity protein dishevelled (Dsh) C terminal', NULL, 'Dsh_C', NULL, NULL, 23463, 9),
(270511, NULL, 'PF12169', NULL, NULL, 'DNA polymerase III subunits gamma and tau domain III', NULL, 'DNA_pol3_gamma3', NULL, NULL, 17441, 9),
(270512, NULL, 'PF09412', NULL, NULL, 'Endoribonuclease XendoU', NULL, 'XendoU', NULL, NULL, 15843, 9),
(270513, NULL, 'PF00475', NULL, NULL, 'Imidazoleglycerol-phosphate dehydratase', NULL, 'IGPD', NULL, NULL, 4708, 9),
(270514, NULL, 'PF09880', NULL, NULL, 'Predicted membrane protein (DUF2107)', NULL, 'DUF2107', NULL, NULL, 10326, 9),
(270515, NULL, 'PF13052', NULL, NULL, 'Protein of unknown function (DUF3913)', NULL, 'DUF3913', NULL, NULL, 22811, 9),
(270516, NULL, 'PF02118', NULL, NULL, 'Srg family chemoreceptor', NULL, 'Srg', NULL, NULL, 5835, 9),
(270517, NULL, 'PF12552', NULL, NULL, 'Protein of unknown function (DUF3741)', NULL, 'DUF3741', NULL, NULL, 21307, 9),
(270518, NULL, 'PF14917', NULL, NULL, 'Coiled coil protein 74, C terminal', NULL, 'CCDC74_C', NULL, NULL, 23917, 9),
(270519, NULL, 'PF01496', NULL, NULL, 'V-type ATPase 116kDa subunit family', NULL, 'V_ATPase_I', NULL, NULL, 687, 9),
(270520, NULL, 'PF12728', NULL, NULL, 'Helix-turn-helix domain', NULL, 'HTH_17', NULL, NULL, 30317, 9),
(270521, NULL, 'PF06648', NULL, NULL, 'Autographa californica nuclear polyhedrosis virus (AcMNPV), Ac75', NULL, 'AcMNPV_Ac75', NULL, NULL, 8236, 9),
(270522, NULL, 'PF00874', NULL, NULL, 'PRD domain', NULL, 'PRD', NULL, NULL, 8395, 9),
(270523, NULL, 'PF09156', NULL, NULL, 'Anthrax toxin lethal factor, middle domain', NULL, 'Anthrax-tox_M', NULL, NULL, 12004, 9),
(270524, NULL, 'PF09011', NULL, NULL, 'HMG-box domain', NULL, 'HMG_box_2', NULL, NULL, 6233, 9),
(270525, NULL, 'PF14535', NULL, NULL, 'AMP-binding enzyme C-terminal domain', NULL, 'AMP-binding_C_2', NULL, NULL, 23980, 9),
(270526, NULL, 'PF02890', NULL, NULL, 'Borrelia family of unknown function DUF226', NULL, 'DUF226', NULL, NULL, 2930, 9),
(270527, NULL, 'PF17572', NULL, NULL, 'Family of unknown function (DUF5478)', NULL, 'DUF5478', NULL, NULL, 17623, 9),
(270528, NULL, 'PF13718', NULL, NULL, 'GNAT acetyltransferase 2', NULL, 'GNAT_acetyltr_2', NULL, NULL, 1841, 9),
(270529, NULL, 'PF02832', NULL, NULL, 'Flavivirus glycoprotein, immunoglobulin-like domain', NULL, 'Flavi_glycop_C', NULL, NULL, 21382, 9),
(270530, NULL, 'PF12685', NULL, NULL, 'SpoIIIAH-like protein', NULL, 'SpoIIIAH', NULL, NULL, 17799, 9),
(270531, NULL, 'PF18519', NULL, NULL, 'SAGA-associated factor 11 N-terminal domain', NULL, 'Sgf11_N', NULL, NULL, 28702, 9),
(270532, NULL, 'PF14292', NULL, NULL, 'SusE outer membrane protein', NULL, 'SusE', NULL, NULL, 23460, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(270533, NULL, 'PF01285', NULL, NULL, 'TEA/ATTS domain', NULL, 'TEA', NULL, NULL, 4900, 9),
(270534, NULL, 'PF16810', NULL, NULL, 'RXLR phytopathogen effector protein, Avirulence activity', NULL, 'RXLR', NULL, NULL, 22310, 9),
(270535, NULL, 'PF18328', NULL, NULL, 'Fatty acid synthase subunit PfaD N-terminal domain', NULL, 'PfaD_N', NULL, NULL, 27983, 9),
(270536, NULL, 'PF19091', NULL, NULL, 'Family of unknown function (DUF5779)', NULL, 'DUF5779', NULL, NULL, 35964, 9),
(270537, NULL, 'PF17945', NULL, NULL, 'Beta/Gamma crystallin', NULL, 'Crystall_4', NULL, NULL, 27590, 9),
(270538, NULL, 'PF13155', NULL, NULL, 'Toprim-like', NULL, 'Toprim_2', NULL, NULL, NULL, 9),
(270539, NULL, 'PF06664', NULL, NULL, 'Wnt-binding factor required for Wnt secretion', NULL, 'MIG-14_Wnt-bd', NULL, NULL, NULL, 9),
(270540, NULL, 'PF14051', NULL, NULL, 'DPF1-3, N-terminal', NULL, 'DPF1-3_N', NULL, NULL, 25187, 9),
(270541, NULL, 'PF05864', NULL, NULL, 'Chordopoxvirus DNA-directed RNA polymerase 7 kDa polypeptide (RPO7)', NULL, 'Chordopox_RPO7', NULL, NULL, 8533, 9),
(270542, NULL, 'PF19068', NULL, NULL, 'Family of unknown function (DUF5764)', NULL, 'DUF5764', NULL, NULL, 35470, 9),
(270543, NULL, 'PF10559', NULL, NULL, 'Plug domain of Sec61p', NULL, 'Plug_translocon', NULL, NULL, 19252, 9),
(270544, NULL, 'PF16401', NULL, NULL, 'Domain of unknown function (DUF5009)', NULL, 'DUF5009', NULL, NULL, 23899, 9),
(270545, NULL, 'PF07528', NULL, NULL, 'DZF domain', NULL, 'DZF', NULL, NULL, 472, 9),
(270546, NULL, 'PF01373', NULL, NULL, 'Glycosyl hydrolase family 14', NULL, 'Glyco_hydro_14', NULL, NULL, 5992, 9),
(270547, NULL, 'PF18088', NULL, NULL, 'Glycoside Hydrolase 20C C-terminal domain', NULL, 'Glyco_H_20C_C', NULL, NULL, 28745, 9),
(270548, NULL, 'PF18671', NULL, NULL, '4-Hydroxyphenylacetate decarboxylase subunit gamma N-terminal', NULL, '4HPAD_g_N', NULL, NULL, 28775, 9),
(270549, NULL, 'PF15558', NULL, NULL, 'Domain of unknown function (DUF4659)', NULL, 'DUF4659', NULL, NULL, 25276, 9),
(270550, NULL, 'PF18367', NULL, NULL, 'Rv2175c C-terminal domain of unknown function', NULL, 'Rv2175c_C', NULL, NULL, 28902, 9),
(270551, NULL, 'PF04508', NULL, NULL, 'Viral A-type inclusion protein repeat', NULL, 'Pox_A_type_inc', NULL, NULL, 2988, 9),
(270552, NULL, 'PF16299', NULL, NULL, 'Domain of unknown function (DUF4941)', NULL, 'DUF4941', NULL, NULL, 25690, 9),
(270553, NULL, 'PF04406', NULL, NULL, 'Type IIB DNA topoisomerase', NULL, 'TP6A_N', NULL, NULL, 8476, 9),
(270554, NULL, 'PF08523', NULL, NULL, 'Multiprotein bridging factor 1', NULL, 'MBF1', NULL, NULL, 7879, 9),
(270555, NULL, 'PF14274', NULL, NULL, 'Domain of unknown function (DUF4361)', NULL, 'DUF4361', NULL, NULL, 21751, 9),
(270556, NULL, 'PF02741', NULL, NULL, 'FTR, proximal lobe', NULL, 'FTR_C', NULL, NULL, 4656, 9),
(270557, NULL, 'PF14474', NULL, NULL, 'RTC4-like domain', NULL, 'RTC4', NULL, NULL, 26472, 9),
(270558, NULL, 'PF14765', NULL, NULL, 'Polyketide synthase dehydratase', NULL, 'PS-DH', NULL, NULL, 19269, 9),
(270559, NULL, 'PF08521', NULL, NULL, 'Two-component sensor kinase N-terminal', NULL, '2CSK_N', NULL, NULL, 7511, 9),
(270560, NULL, 'PF11452', NULL, NULL, 'Protein of unknown function (DUF3000)', NULL, 'DUF3000', NULL, NULL, 18975, 9),
(270561, NULL, 'PF10631', NULL, NULL, 'Protein of unknown function (DUF2477)', NULL, 'DUF2477', NULL, NULL, 20937, 9),
(270562, NULL, 'PF12391', NULL, NULL, 'Protocatechuate 3,4-dioxygenase beta subunit N terminal', NULL, 'PCDO_beta_N', NULL, NULL, 19156, 9),
(270563, NULL, 'PF13389', NULL, NULL, 'Protein of unknown function (DUF4107)', NULL, 'DUF4107', NULL, NULL, 22814, 9),
(270564, NULL, 'PF00953', NULL, NULL, 'Glycosyl transferase family 4', NULL, 'Glycos_transf_4', NULL, NULL, 3918, 9),
(270565, NULL, 'PF19124', NULL, NULL, 'Family of unknown function (DUF5808)', NULL, 'DUF5808', NULL, NULL, 35748, 9),
(270566, NULL, 'PF08916', NULL, NULL, 'Phenylalanine zipper', NULL, 'Phe_ZIP', NULL, NULL, 7601, 9),
(270567, NULL, 'PF05862', NULL, NULL, 'Helicobacter pylori IceA2 protein', NULL, 'IceA2', NULL, NULL, 12523, 9);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(270568, NULL, 'PF00853', NULL, NULL, 'Runt domain', NULL, 'Runt', NULL, NULL, 7369, 9),
(270569, NULL, 'PF18448', NULL, NULL, 'Carbohydrate binding domain', NULL, 'CBM46', NULL, NULL, 29440, 9),
(270570, NULL, 'PF08052', NULL, NULL, 'PyrBI operon leader peptide', NULL, 'PyrBI_leader', NULL, NULL, 9387, 9),
(270571, NULL, 'PF12043', NULL, NULL, 'Domain of unknown function (DUF3527)', NULL, 'DUF3527', NULL, NULL, 19701, 9),
(270572, NULL, 'PF01396', NULL, NULL, 'Topoisomerase DNA binding C4 zinc finger', NULL, 'zf-C4_Topoisom', NULL, NULL, 10974, 9),
(270573, NULL, 'PF01661', NULL, NULL, 'Macro domain', NULL, 'Macro', NULL, NULL, 1943, 9),
(270574, NULL, 'PF18392', NULL, NULL, 'COP9 signalosome complex subunit 7a helix I domain', NULL, 'CSN7a_helixI', NULL, NULL, 29902, 9),
(270575, NULL, 'PF01623', NULL, NULL, 'Carlavirus putative nucleic acid binding protein', NULL, 'Carla_C4', NULL, NULL, 1951, 9),
(270576, NULL, 'PF05093', NULL, NULL, 'Cytokine-induced anti-apoptosis inhibitor 1, Fe-S biogenesis', NULL, 'CIAPIN1', NULL, NULL, 34982, 9),
(270577, NULL, 'PF02035', NULL, NULL, 'Coagulin', NULL, 'Coagulin', NULL, NULL, 882, 9),
(270578, NULL, 'PF10943', NULL, NULL, 'Protein of unknown function (DUF2632)', NULL, 'DUF2632', NULL, NULL, 20216, 9),
(270579, NULL, 'PF16200', NULL, NULL, 'C-terminal region of band_7', NULL, 'Band_7_C', NULL, NULL, 26032, 9),
(270580, NULL, 'PF02481', NULL, NULL, 'DNA recombination-mediator protein A', NULL, 'DNA_processg_A', NULL, NULL, 6413, 9),
(270581, NULL, 'PF11384', NULL, NULL, 'Protein of unknown function (DUF3188)', NULL, 'DUF3188', NULL, NULL, 18647, 9),
(270582, NULL, 'PF07723', NULL, NULL, 'Leucine Rich Repeat', NULL, 'LRR_2', NULL, NULL, 18864, 9),
(270583, NULL, 'PF07310', NULL, NULL, 'PAS domain', NULL, 'PAS_5', NULL, NULL, 8332, 9),
(270584, NULL, 'PF09178', NULL, NULL, '4-alpha-glucanotransferase, C-terminal', NULL, 'MGTA_C', NULL, NULL, 12174, 9),
(270585, NULL, 'PF07354', NULL, NULL, 'Zona-pellucida-binding protein (Sp38)', NULL, 'Sp38', NULL, NULL, 11655, 9),
(270586, NULL, 'PF17376', NULL, NULL, 'Family of unknown function (DUF5398)', NULL, 'DUF5398', NULL, NULL, 29805, 9),
(270587, NULL, 'PF01873', NULL, NULL, 'Domain found in IF2B/IF5', NULL, 'eIF-5_eIF-2B', NULL, NULL, 3718, 9),
(270588, NULL, 'PF05676', NULL, NULL, 'NADH-ubiquinone oxidoreductase B18 subunit (NDUFB7)', NULL, 'NDUF_B7', NULL, NULL, 13424, 9),
(270589, NULL, 'PF05271', NULL, NULL, 'Tobravirus 2B protein', NULL, 'Tobravirus_2B', NULL, NULL, 4409, 9),
(270590, NULL, 'PF06537', NULL, NULL, 'Di-haem oxidoreductase, putative peroxidase', NULL, 'DHOR', NULL, NULL, 14013, 9),
(270591, NULL, 'PF12600', NULL, NULL, 'Protein of unknown function (DUF3769)', NULL, 'DUF3769', NULL, NULL, 21436, 9),
(270592, NULL, 'PF18791', NULL, NULL, 'Transport inhibitor response 1 protein domain', NULL, 'Transp_inhibit', NULL, NULL, 29058, 9),
(270593, NULL, 'PF17827', NULL, NULL, 'PrmC N-terminal domain', NULL, 'PrmC_N', NULL, NULL, 28551, 9),
(270594, NULL, 'PF10661', NULL, NULL, 'WXG100 protein secretion system (Wss), protein EssA', NULL, 'EssA', NULL, NULL, 1980, 9),
(270595, NULL, 'PF02759', NULL, NULL, 'RUN domain', NULL, 'RUN', NULL, NULL, 548, 9),
(270596, NULL, 'PF00208', NULL, NULL, 'Glutamate/Leucine/Phenylalanine/Valine dehydrogenase', NULL, 'ELFV_dehydrog', NULL, NULL, 2666, 9),
(270597, NULL, 'PF13349', NULL, NULL, 'Putative adhesin', NULL, 'DUF4097', NULL, NULL, 26028, 9),
(270598, NULL, 'PF03592', NULL, NULL, 'Terminase small subunit', NULL, 'Terminase_2', NULL, NULL, 5840, 9),
(270599, NULL, 'PF10553', NULL, NULL, 'MSV199 domain', NULL, 'MSV199', NULL, NULL, 20901, 9),
(270600, NULL, 'PF15933', NULL, NULL, 'Antitoxin to bacterial toxin RNase LS or RnlA', NULL, 'RnlB_antitoxin', NULL, NULL, 25954, 9),
(270601, NULL, 'PF12792', NULL, NULL, 'CSS motif domain associated with EAL', NULL, 'CSS-motif', NULL, NULL, 17430, 9),
(270602, NULL, 'PF15738', NULL, NULL, 'Bacterial toxin of type II toxin-antitoxin system, YafQ', NULL, 'YafQ_toxin', NULL, NULL, 5589, 9),
(270603, NULL, 'PF19182', NULL, NULL, 'Family of unknown function (DUF5864)', NULL, 'DUF5864', NULL, NULL, 35838, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(270604, NULL, 'PF05961', NULL, NULL, 'Chordopoxvirus A13L protein', NULL, 'Chordopox_A13L', NULL, NULL, 12952, 9),
(270605, NULL, 'PF13385', NULL, NULL, 'Concanavalin A-like lectin/glucanases superfamily', NULL, 'Laminin_G_3', NULL, NULL, NULL, 9),
(270606, NULL, 'PF16523', NULL, NULL, 'betaPIX coiled coil', NULL, 'betaPIX_CC', NULL, NULL, 25372, 9),
(270607, NULL, 'PF16357', NULL, NULL, 'Putative PepSY_TM-like', NULL, 'PepSY_TM_like_2', NULL, NULL, 25127, 9),
(270608, NULL, 'PF10950', NULL, NULL, 'Organ specific protein', NULL, 'Organ_specific', NULL, NULL, 24047, 9),
(270609, NULL, 'PF08969', NULL, NULL, 'USP8 dimerisation domain', NULL, 'USP8_dimer', NULL, NULL, 8752, 9),
(270610, NULL, 'PF09838', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2065)', NULL, 'DUF2065', NULL, NULL, 19174, 9),
(270611, NULL, 'PF11230', NULL, NULL, 'Protein of unknown function (DUF3029)', NULL, 'DUF3029', NULL, NULL, 17379, 9),
(270612, NULL, 'PF11239', NULL, NULL, 'Protein of unknown function (DUF3040)', NULL, 'DUF3040', NULL, NULL, 18373, 9),
(270613, NULL, 'PF10229', NULL, NULL, 'Methylmalonic aciduria and homocystinuria type D protein', NULL, 'MMADHC', NULL, NULL, 15572, 9),
(270614, NULL, 'PF06358', NULL, NULL, 'Beet necrotic yellow vein virus, movement protein TGB3', NULL, 'BNYVV_TGB3', NULL, NULL, 10233, 9),
(270615, NULL, 'PF14046', NULL, NULL, 'Nuclear receptor repeat', NULL, 'NR_Repeat', NULL, NULL, 21906, 9),
(270616, NULL, 'PF14725', NULL, NULL, 'Domain of unknown function (DUF4466)', NULL, 'DUF4466', NULL, NULL, 23155, 9),
(270617, NULL, 'PF03587', NULL, NULL, 'EMG1/NEP1 methyltransferase', NULL, 'EMG1', NULL, NULL, 5319, 9),
(270618, NULL, 'PF08698', NULL, NULL, 'Fcf2 pre-rRNA processing', NULL, 'Fcf2', NULL, NULL, 11722, 9),
(270619, NULL, 'PF00667', NULL, NULL, 'FAD binding domain', NULL, 'FAD_binding_1', NULL, NULL, 1463, 9),
(270620, NULL, 'PF03830', NULL, NULL, 'PTS system sorbose subfamily IIB component', NULL, 'PTSIIB_sorb', NULL, NULL, 3329, 9),
(270621, NULL, 'PF17190', NULL, NULL, 'RecG N-terminal helical domain', NULL, 'RecG_N', NULL, NULL, 23457, 9),
(270622, NULL, 'PF02875', NULL, NULL, 'Mur ligase family, glutamate ligase domain', NULL, 'Mur_ligase_C', NULL, NULL, 1882, 9),
(270623, NULL, 'PF10157', NULL, NULL, 'BLOC-1-related complex sub-unit 6 C-terminal helix', NULL, 'BORCS6', NULL, NULL, 36941, 9),
(270624, NULL, 'PF04584', NULL, NULL, 'Poxvirus A28 family', NULL, 'Pox_A28', NULL, NULL, 13, 9),
(270625, NULL, 'PF08954', NULL, NULL, 'Trimerisation motif', NULL, 'Trimer_CC', NULL, NULL, 7853, 9),
(270626, NULL, 'PF04148', NULL, NULL, 'Transmembrane adaptor Erv26', NULL, 'Erv26', NULL, NULL, 7246, 9),
(270627, NULL, 'PF07992', NULL, NULL, 'Pyridine nucleotide-disulphide oxidoreductase', NULL, 'Pyr_redox_2', NULL, NULL, 14858, 9),
(270628, NULL, 'PF00001', NULL, NULL, '7 transmembrane receptor (rhodopsin family)', NULL, '7tm_1', NULL, NULL, 4866, 9),
(270629, NULL, 'PF17353', NULL, NULL, 'Family of unknown function (DUF5381)', NULL, 'DUF5381', NULL, NULL, 9997, 9),
(270630, NULL, 'PF11855', NULL, NULL, 'Protein of unknown function (DUF3375)', NULL, 'DUF3375', NULL, NULL, 19222, 9),
(270631, NULL, 'PF13716', NULL, NULL, 'Divergent CRAL/TRIO domain', NULL, 'CRAL_TRIO_2', NULL, NULL, 6774, 9),
(270632, NULL, 'PF15525', NULL, NULL, 'Domain of unknown function (DUF4652)', NULL, 'DUF4652', NULL, NULL, 24659, 9),
(270633, NULL, 'PF01127', NULL, NULL, 'Succinate dehydrogenase/Fumarate reductase transmembrane subunit', NULL, 'Sdh_cyt', NULL, NULL, 3510, 9),
(270634, NULL, 'PF04559', NULL, NULL, 'Herpesvirus UL17 protein', NULL, 'Herpes_UL17', NULL, NULL, 2433, 9),
(270635, NULL, 'PF02616', NULL, NULL, 'Segregation and condensation protein ScpA', NULL, 'SMC_ScpA', NULL, NULL, 6129, 9),
(270636, NULL, 'PF14486', NULL, NULL, 'Domain of unknown function (DUF4432)', NULL, 'DUF4432', NULL, NULL, 26341, 9),
(270637, NULL, 'PF15173', NULL, NULL, 'FAM180 family', NULL, 'FAM180', NULL, NULL, 21800, 9),
(270638, NULL, 'PF17412', NULL, NULL, 'Family of unknown function', NULL, 'VraX', NULL, NULL, 9847, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(270639, NULL, 'PF12536', NULL, NULL, 'Patatin phospholipase', NULL, 'DUF3734', NULL, NULL, 15137, 9),
(270640, NULL, 'PF17345', NULL, NULL, 'Family of unknown function (DUF5375)', NULL, 'DUF5375', NULL, NULL, 32940, 9),
(270641, NULL, 'PF08411', NULL, NULL, 'Exonuclease C-terminal', NULL, 'Exonuc_X-T_C', NULL, NULL, 11324, 9),
(270642, NULL, 'PF03884', NULL, NULL, 'DNA gyrase inhibitor YacG', NULL, 'YacG', NULL, NULL, 1829, 9),
(270643, NULL, 'PF10195', NULL, NULL, 'DNA-binding nuclear phosphoprotein p8', NULL, 'Phospho_p8', NULL, NULL, 19298, 9),
(270644, NULL, 'PF10377', NULL, NULL, 'Autophagy-related protein 11', NULL, 'ATG11', NULL, NULL, 17448, 9),
(270645, NULL, 'PF11305', NULL, NULL, 'Protein of unknown function (DUF3107)', NULL, 'DUF3107', NULL, NULL, 18322, 9),
(270646, NULL, 'PF20550', NULL, NULL, 'Family of unknown function (DUF6764)', NULL, 'DUF6764', NULL, NULL, 33772, 9),
(270647, NULL, 'PF00308', NULL, NULL, 'Bacterial dnaA  protein', NULL, 'Bac_DnaA', NULL, NULL, 13202, 9),
(270648, NULL, 'PF04339', NULL, NULL, 'Peptidogalycan biosysnthesis/recognition', NULL, 'FemAB_like', NULL, NULL, 3890, 9),
(270649, NULL, 'PF17129', NULL, NULL, 'C-terminal domain of metallo-carboxypeptidase', NULL, 'Peptidase_M99_C', NULL, NULL, 27585, 9),
(270650, NULL, 'PF00251', NULL, NULL, 'Glycosyl hydrolases family 32 N-terminal domain', NULL, 'Glyco_hydro_32N', NULL, NULL, 9438, 9),
(270651, NULL, 'PF09431', NULL, NULL, 'SPIN90/Ldb17, leucine-rich domain', NULL, 'SPIN90_LRD', NULL, NULL, 15491, 9),
(270652, NULL, 'PF13266', NULL, NULL, 'Protein of unknown function (DUF4057)', NULL, 'DUF4057', NULL, NULL, 22920, 9),
(270653, NULL, 'PF16415', NULL, NULL, 'CCR4-NOT transcription complex subunit 1 CAF1-binding domain', NULL, 'CNOT1_CAF1_bind', NULL, NULL, 23583, 9),
(270654, NULL, 'PF19763', NULL, NULL, 'Domain of unknown function (DUF6250)', NULL, 'DUF6250', NULL, NULL, 37475, 9),
(270655, NULL, 'PF02878', NULL, NULL, 'Phosphoglucomutase/phosphomannomutase, alpha/beta/alpha domain I', NULL, 'PGM_PMM_I', NULL, NULL, 5798, 9),
(270656, NULL, 'PF13527', NULL, NULL, 'Acetyltransferase (GNAT) domain', NULL, 'Acetyltransf_9', NULL, NULL, NULL, 9),
(270657, NULL, 'PF10906', NULL, NULL, 'MIOREX complex component 7', NULL, 'Mrx7', NULL, NULL, 21288, 9),
(270658, NULL, 'PF18536', NULL, NULL, 'Domain of unknown function (DUF5623)', NULL, 'DUF5623', NULL, NULL, 31649, 9),
(270659, NULL, 'PF06185', NULL, NULL, 'YecM protein', NULL, 'YecM', NULL, NULL, 9065, 9),
(270660, NULL, 'PF11770', NULL, NULL, 'GRB2-binding adapter (GAPT)', NULL, 'GAPT', NULL, NULL, 18026, 9),
(270661, NULL, 'PF08779', NULL, NULL, 'Betacoronavirus NS7A protein', NULL, 'bCoV_NS7A', NULL, NULL, 13360, 9),
(270662, NULL, 'PF19623', NULL, NULL, 'Family of unknown function (DUF6128)', NULL, 'DUF6128', NULL, NULL, 37499, 9),
(270663, NULL, 'PF00226', NULL, NULL, 'DnaJ domain', NULL, 'DnaJ', NULL, NULL, 1163, 9),
(270664, NULL, 'PF09335', NULL, NULL, 'SNARE associated Golgi protein', NULL, 'SNARE_assoc', NULL, NULL, 22169, 9),
(270665, NULL, 'PF04529', NULL, NULL, 'Herpesvirus U59 protein', NULL, 'Herpes_U59', NULL, NULL, 2636, 9),
(270666, NULL, 'PF18781', NULL, NULL, 'Phage spike trimer', NULL, 'Phage_spike_2', NULL, NULL, 29226, 9),
(270667, NULL, 'PF07945', NULL, NULL, 'Janus-atracotoxin', NULL, 'Toxin_16', NULL, NULL, 12705, 9),
(270668, NULL, 'PF02891', NULL, NULL, 'MIZ/SP-RING zinc finger', NULL, 'zf-MIZ', NULL, NULL, 2874, 9),
(270669, NULL, 'PF18546', NULL, NULL, 'Methanogen output domain 1', NULL, 'MetOD1', NULL, NULL, 29062, 9),
(270670, NULL, 'PF01474', NULL, NULL, 'Class-II DAHP synthetase family', NULL, 'DAHP_synth_2', NULL, NULL, 598, 9),
(270671, NULL, 'PF17182', NULL, NULL, 'OSK domain', NULL, 'OSK', NULL, NULL, 29165, 9),
(270672, NULL, 'PF09638', NULL, NULL, 'Ph1570 protein', NULL, 'Ph1570', NULL, NULL, 20774, 9),
(270673, NULL, 'PF03551', NULL, NULL, 'Transcriptional regulator PadR-like family', NULL, 'PadR', NULL, NULL, 4435, 9),
(270674, NULL, 'PF04407', NULL, NULL, 'Protein of unknown function (DUF531)', NULL, 'DUF531', NULL, NULL, 10311, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(270675, NULL, 'PF02843', NULL, NULL, 'Phosphoribosylglycinamide synthetase, C domain', NULL, 'GARS_C', NULL, NULL, 14743, 9),
(270676, NULL, 'PF15005', NULL, NULL, 'Izumo sperm-egg fusion, Ig domain-associated', NULL, 'IZUMO', NULL, NULL, 26380, 9),
(270677, NULL, 'PF17397', NULL, NULL, 'Family of unknown function (DUF5404)', NULL, 'DUF5404', NULL, NULL, 30764, 9),
(270678, NULL, 'PF03494', NULL, NULL, 'Beta-amyloid peptide (beta-APP)', NULL, 'Beta-APP', NULL, NULL, 9773, 9),
(270679, NULL, 'PF00718', NULL, NULL, 'Polyomavirus coat protein', NULL, 'Polyoma_coat', NULL, NULL, 6527, 9),
(270680, NULL, 'PF16503', NULL, NULL, 'Zinc-ribbon', NULL, 'zn-ribbon_14', NULL, NULL, 24191, 9),
(270681, NULL, 'PF01284', NULL, NULL, 'Membrane-associating domain', NULL, 'MARVEL', NULL, NULL, 6247, 9),
(270682, NULL, 'PF03275', NULL, NULL, 'UDP-galactopyranose mutase', NULL, 'GLF', NULL, NULL, 7820, 9),
(270683, NULL, 'PF01526', NULL, NULL, 'Tn3 transposase DDE domain', NULL, 'DDE_Tnp_Tn3', NULL, NULL, 504, 9),
(270684, NULL, 'PF16262', NULL, NULL, 'Domain of unknown function (DUF4916)', NULL, 'DUF4916', NULL, NULL, 21511, 9),
(270685, NULL, 'PF01446', NULL, NULL, 'Replication protein', NULL, 'Rep_1', NULL, NULL, 3020, 9),
(270686, NULL, 'PF02152', NULL, NULL, 'Dihydroneopterin aldolase', NULL, 'FolB', NULL, NULL, 10460, 9),
(270687, NULL, 'PF10382', NULL, NULL, 'Protein of unknown function (DUF2439)', NULL, 'DUF2439', NULL, NULL, 20451, 9),
(270688, NULL, 'PF09967', NULL, NULL, 'VWA-like domain (DUF2201)', NULL, 'DUF2201', NULL, NULL, 17411, 9),
(270689, NULL, 'PF16463', NULL, NULL, 'Phage tail tube protein family', NULL, 'Phage_TTP_13', NULL, NULL, 22033, 9),
(270690, NULL, 'PF04931', NULL, NULL, 'DNA polymerase phi', NULL, 'DNA_pol_phi', NULL, NULL, 6908, 9),
(270691, NULL, 'PF01050', NULL, NULL, 'Mannose-6-phosphate isomerase', NULL, 'MannoseP_isomer', NULL, NULL, 5311, 9),
(270692, NULL, 'PF12709', NULL, NULL, 'Fungal Transforming acidic coiled-coil (TACC) proteins', NULL, 'Fungal_TACC', NULL, NULL, 22818, 9),
(270693, NULL, 'PF00529', NULL, NULL, 'Cation efflux system protein CusB domain 1', NULL, 'CusB_dom_1', NULL, NULL, 35208, 9),
(270694, NULL, 'PF07525', NULL, NULL, 'SOCS box', NULL, 'SOCS_box', NULL, NULL, 3306, 9),
(270695, NULL, 'PF13765', NULL, NULL, 'SPRY-associated domain', NULL, 'PRY', NULL, NULL, 233, 9),
(270696, NULL, 'PF05321', NULL, NULL, 'Haemolysin expression modulating protein', NULL, 'HHA', NULL, NULL, 4390, 9),
(270697, NULL, 'PF05113', NULL, NULL, 'Protein of unknown function (DUF693)', NULL, 'DUF693', NULL, NULL, 2274, 9),
(270698, NULL, 'PF20142', NULL, NULL, 'Scaffold domain', NULL, 'Scaffold', NULL, NULL, 37362, 9),
(270699, NULL, 'PF08287', NULL, NULL, 'Spc19', NULL, 'DASH_Spc19', NULL, NULL, 13498, 9),
(270700, NULL, 'PF04126', NULL, NULL, 'Cyclophilin-like', NULL, 'Cyclophil_like', NULL, NULL, 23807, 9),
(270701, NULL, 'PF17872', NULL, NULL, 'AAA lid domain', NULL, 'AAA_lid_10', NULL, NULL, 29093, 9),
(270702, NULL, 'PF04279', NULL, NULL, 'Intracellular septation protein A', NULL, 'IspA', NULL, NULL, 1137, 9),
(270703, NULL, 'PF14786', NULL, NULL, 'Tube Death domain', NULL, 'Death_2', NULL, NULL, 24946, 9),
(270704, NULL, 'PF18961', NULL, NULL, 'Domain of unknown function (DUF5703)', NULL, 'DUF5703_N', NULL, NULL, 35842, 9),
(270705, NULL, 'PF09560', NULL, NULL, 'Sporulation protein YunB (Spo_YunB)', NULL, 'Spore_YunB', NULL, NULL, 8987, 9),
(270706, NULL, 'PF09662', NULL, NULL, 'Phenylphosphate carboxylase gamma subunit (Phenyl_P_gamma)', NULL, 'Phenyl_P_gamma', NULL, NULL, 14140, 9),
(270707, NULL, 'PF20061', NULL, NULL, 'Domain of unknown function (DUF6460)', NULL, 'DUF6460', NULL, NULL, 36261, 9),
(270708, NULL, 'PF07935', NULL, NULL, 'ORF D-335-like protein', NULL, 'SSV1_ORF_D-335', NULL, NULL, 7979, 9),
(270709, NULL, 'PF20239', NULL, NULL, 'Family of unknown function (DUF6596)', NULL, 'DUF6596', NULL, NULL, 37751, 9),
(270710, NULL, 'PF04746', NULL, NULL, 'Protein of unknown function (DUF575)', NULL, 'DUF575', NULL, NULL, 3690, 9),
(270711, NULL, 'PF02683', NULL, NULL, 'Cytochrome C biogenesis protein transmembrane region', NULL, 'DsbD', NULL, NULL, 3196, 9);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(270712, NULL, 'PF04145', NULL, NULL, 'Ctr copper transporter family', NULL, 'Ctr', NULL, NULL, 7411, 9),
(270713, NULL, 'PF10941', NULL, NULL, 'Protein of unknown function DUF2620', NULL, 'DUF2620', NULL, NULL, 17760, 9),
(270714, NULL, 'PF01288', NULL, NULL, '7,8-dihydro-6-hydroxymethylpterin-pyrophosphokinase (HPPK)', NULL, 'HPPK', NULL, NULL, 5865, 9),
(270715, NULL, 'PF01699', NULL, NULL, 'Sodium/calcium exchanger protein', NULL, 'Na_Ca_ex', NULL, NULL, 4142, 9),
(270716, NULL, 'PF08682', NULL, NULL, 'Putative endonuclease, protein of unknown function (DUF1780)', NULL, 'DUF1780', NULL, NULL, 11266, 9),
(270717, NULL, 'PF00745', NULL, NULL, 'Glutamyl-tRNAGlu reductase, dimerisation domain', NULL, 'GlutR_dimer', NULL, NULL, 7567, 9),
(270718, NULL, 'PF06464', NULL, NULL, 'DMAP1-binding Domain', NULL, 'DMAP_binding', NULL, NULL, 10361, 9),
(270719, NULL, 'PF06939', NULL, NULL, 'Protein of unknown function (DUF1286)', NULL, 'DUF1286', NULL, NULL, 11843, 9),
(270720, NULL, 'PF15899', NULL, NULL, 'BNR-Asp box repeat', NULL, 'BNR_6', NULL, NULL, 5504, 9),
(270721, NULL, 'PF01107', NULL, NULL, 'Viral movement protein (MP)', NULL, 'MP', NULL, NULL, 22334, 9),
(270722, NULL, 'PF02482', NULL, NULL, 'Sigma 54 modulation protein / S30EA ribosomal protein', NULL, 'Ribosomal_S30AE', NULL, NULL, 6480, 9),
(270723, NULL, 'PF02942', NULL, NULL, 'Influenza B non-structural protein (NS1)', NULL, 'Flu_B_NS1', NULL, NULL, 3725, 9),
(270724, NULL, 'PF13071', NULL, NULL, 'Protein of unknown function (DUF3935)', NULL, 'DUF3935', NULL, NULL, 21355, 9),
(270725, NULL, 'PF19687', NULL, NULL, 'MARF1 LOTUS domain', NULL, 'MARF1_LOTUS', NULL, NULL, 36204, 9),
(270726, NULL, 'PF15867', NULL, NULL, 'Dynein attachment factor N-terminus', NULL, 'Dynein_attach_N', NULL, NULL, 24405, 9),
(270727, NULL, 'PF19014', NULL, NULL, 'Family of unknown function (DUF5743)', NULL, 'DUF5743', NULL, NULL, 35861, 9),
(270728, NULL, 'PF12490', NULL, NULL, 'Breast carcinoma amplified sequence 3', NULL, 'BCAS3', NULL, NULL, 21461, 9),
(270729, NULL, 'PF14013', NULL, NULL, 'MT0933-like antitoxin protein', NULL, 'MT0933_antitox', NULL, NULL, 23328, 9),
(270730, NULL, 'PF14676', NULL, NULL, 'FANCI solenoid 2', NULL, 'FANCI_S2', NULL, NULL, 26684, 9),
(270731, NULL, 'PF05316', NULL, NULL, 'Mitochondrial ribosomal protein (VAR1)', NULL, 'VAR1', NULL, NULL, 4052, 9),
(270732, NULL, 'PF06724', NULL, NULL, 'Domain of Unknown Function (DUF1206)', NULL, 'DUF1206', NULL, NULL, 1986, 9),
(270733, NULL, 'PF02454', NULL, NULL, 'Sigma 1s protein', NULL, 'Sigma_1s', NULL, NULL, 6327, 9),
(270734, NULL, 'PF11740', NULL, NULL, 'Plasmid replication region DNA-binding N-term', NULL, 'KfrA_N', NULL, NULL, 18133, 9),
(270735, NULL, 'PF19348', NULL, NULL, 'Family of unknown function (DUF5926)', NULL, 'DUF5926', NULL, NULL, 36742, 9),
(270736, NULL, 'PF09189', NULL, NULL, 'Domain of unknown function (DUF1952)', NULL, 'DUF1952', NULL, NULL, 12169, 9),
(270737, NULL, 'PF00646', NULL, NULL, 'F-box domain', NULL, 'F-box', NULL, NULL, 4804, 9),
(270738, NULL, 'PF05352', NULL, NULL, 'Phage Connector (GP10)', NULL, 'Phage_connector', NULL, NULL, 5261, 9),
(270739, NULL, 'PF06444', NULL, NULL, 'NADH dehydrogenase subunit 2 C-terminus', NULL, 'NADH_dehy_S2_C', NULL, NULL, 7573, 9),
(270740, NULL, 'PF09752', NULL, NULL, 'Alpha/beta hydrolase domain containing 18', NULL, 'ABHD18', NULL, NULL, 18035, 9),
(270741, NULL, 'PF03015', NULL, NULL, 'Male sterility protein', NULL, 'Sterile', NULL, NULL, 30240, 9),
(270742, NULL, 'PF10539', NULL, NULL, 'Development and cell death domain', NULL, 'Dev_Cell_Death', NULL, NULL, 10281, 9),
(270743, NULL, 'PF13999', NULL, NULL, 'MarB protein', NULL, 'MarB', NULL, NULL, 22735, 9),
(270744, NULL, 'PF12545', NULL, NULL, 'Filamentous haemagglutinin family outer membrane protein', NULL, 'DUF3739', NULL, NULL, 15832, 9),
(270745, NULL, 'PF01245', NULL, NULL, 'Ribosomal protein L19', NULL, 'Ribosomal_L19', NULL, NULL, 4104, 9),
(270746, NULL, 'PF12362', NULL, NULL, 'DNA polymerase III gamma and tau subunits C terminal', NULL, 'DUF3646', NULL, NULL, 20687, 9);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(270747, NULL, 'PF04464', NULL, NULL, 'CDP-Glycerol:Poly(glycerophosphate) glycerophosphotransferase', NULL, 'Glyphos_transf', NULL, NULL, 3696, 9),
(270748, NULL, 'PF05361', NULL, NULL, 'PKC-activated protein phosphatase-1 inhibitor', NULL, 'PP1_inhibitor', NULL, NULL, 5294, 9),
(270749, NULL, 'PF06405', NULL, NULL, 'Red chlorophyll catabolite reductase (RCC reductase)', NULL, 'RCC_reductase', NULL, NULL, 8406, 9),
(270750, NULL, 'PF13438', NULL, NULL, 'Domain of unknown function (DUF4113)', NULL, 'DUF4113', NULL, NULL, 22930, 9),
(270751, NULL, 'PF19077', NULL, NULL, 'Bacterial Ig-like domain', NULL, 'Big_13', NULL, NULL, 35607, 9),
(270752, NULL, 'PF20170', NULL, NULL, 'Plexin cytoplasmic RhoGTPase-binding domain', NULL, 'Plexin_RBD', NULL, NULL, 35856, 9),
(270753, NULL, 'PF00939', NULL, NULL, 'Sodium:sulfate symporter transmembrane region', NULL, 'Na_sulph_symp', NULL, NULL, 2115, 9),
(270754, NULL, 'PF05611', NULL, NULL, 'Caenorhabditis elegans protein of unknown function (DUF780)', NULL, 'DUF780', NULL, NULL, 12453, 9),
(270755, NULL, 'PF07399', NULL, NULL, 'Putative Na+/H+ antiporter', NULL, 'Na_H_antiport_3', NULL, NULL, 8154, 9),
(270756, NULL, 'PF13480', NULL, NULL, 'Acetyltransferase (GNAT) domain', NULL, 'Acetyltransf_6', NULL, NULL, 32290, 9),
(270757, NULL, 'PF12099', NULL, NULL, 'Protein of unknown function (DUF3575)', NULL, 'DUF3575', NULL, NULL, 20020, 9),
(270758, NULL, 'PF17829', NULL, NULL, 'Gylcosyl hydrolase family 115 C-terminal domain', NULL, 'GH115_C', NULL, NULL, 29931, 9),
(270759, NULL, 'PF06198', NULL, NULL, 'Protein of unknown function (DUF999)', NULL, 'DUF999', NULL, NULL, 14290, 9),
(270760, NULL, 'PF13369', NULL, NULL, 'Transglutaminase-like superfamily', NULL, 'Transglut_core2', NULL, NULL, 26954, 9),
(270761, NULL, 'PF02865', NULL, NULL, 'STAT protein, protein interaction domain', NULL, 'STAT_int', NULL, NULL, 17704, 9),
(270762, NULL, 'PF13949', NULL, NULL, 'ALIX V-shaped domain binding to HIV', NULL, 'ALIX_LYPXL_bnd', NULL, NULL, 23358, 9),
(270763, NULL, 'PF18325', NULL, NULL, 'Fatty acid synthase subunit alpha Acyl carrier domain', NULL, 'Fas_alpha_ACP', NULL, NULL, 33265, 9),
(270764, NULL, 'PF02465', NULL, NULL, 'Flagellar hook-associated protein 2 N-terminus', NULL, 'FliD_N', NULL, NULL, 6409, 9),
(270765, NULL, 'PF04839', NULL, NULL, 'Plastid and cyanobacterial ribosomal protein (PSRP-3 / Ycf65)', NULL, 'PSRP-3_Ycf65', NULL, NULL, 4558, 9),
(270766, NULL, 'PF06607', NULL, NULL, 'Prokineticin', NULL, 'Prokineticin', NULL, NULL, 10231, 9),
(270767, NULL, 'PF00436', NULL, NULL, 'Single-strand binding protein family', NULL, 'SSB', NULL, NULL, 6581, 9),
(270768, NULL, 'PF14106', NULL, NULL, 'Domain of unknown function (DUF4279)', NULL, 'DUF4279', NULL, NULL, 22095, 9),
(270769, NULL, 'PF15801', NULL, NULL, 'zf-MYND-like zinc finger, mRNA-binding', NULL, 'zf-C6H2', NULL, NULL, 26196, 9),
(270770, NULL, 'PF06250', NULL, NULL, 'YhcG PDDEXK nuclease domain', NULL, 'YhcG_C', NULL, NULL, 14184, 9),
(270771, NULL, 'PF16125', NULL, NULL, 'Domain of unknown function (DUF4837)', NULL, 'DUF4837', NULL, NULL, 25470, 9),
(270772, NULL, 'PF14065', NULL, NULL, 'Pvc16 N-terminal domain', NULL, 'Pvc16_N', NULL, NULL, 22989, 9),
(270773, NULL, 'PF05111', NULL, NULL, 'Ameloblastin precursor (Amelin)', NULL, 'Amelin', NULL, NULL, 2123, 9),
(270774, NULL, 'PF03159', NULL, NULL, 'XRN 5''-3'' exonuclease N-terminus', NULL, 'XRN_N', NULL, NULL, 7057, 9),
(270775, NULL, 'PF12224', NULL, NULL, 'Putative amidoligase enzyme', NULL, 'Amidoligase_2', NULL, NULL, 20344, 9),
(270776, NULL, 'PF13679', NULL, NULL, 'Methyltransferase domain', NULL, 'Methyltransf_32', NULL, NULL, 24658, 9),
(270777, NULL, 'PF15453', NULL, NULL, 'Protein incorporated later into Tight Junctions', NULL, 'Pilt', NULL, NULL, 35888, 9),
(270778, NULL, 'PF05718', NULL, NULL, 'Poxvirus intermediate transcription factor', NULL, 'Pox_int_trans', NULL, NULL, 13985, 9),
(270779, NULL, 'PF11018', NULL, NULL, 'Pupal cuticle protein C1', NULL, 'Cuticle_3', NULL, NULL, 16708, 9),
(270780, NULL, 'PF03161', NULL, NULL, 'LAGLIDADG DNA endonuclease family', NULL, 'LAGLIDADG_2', NULL, NULL, 7401, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(270781, NULL, 'PF12937', NULL, NULL, 'F-box-like', NULL, 'F-box-like', NULL, NULL, 4804, 9),
(270782, NULL, 'PF15513', NULL, NULL, 'Domain of unknown function (DUF4651)', NULL, 'DUF4651', NULL, NULL, 24780, 9),
(270783, NULL, 'PF06703', NULL, NULL, 'Microsomal signal peptidase 25 kDa subunit (SPC25)', NULL, 'SPC25', NULL, NULL, 663, 9),
(270784, NULL, 'PF09828', NULL, NULL, 'Chromate resistance exported protein', NULL, 'Chrome_Resist', NULL, NULL, 16278, 9),
(270785, NULL, 'PF11555', NULL, NULL, 'EGFR receptor inhibitor Mig-6', NULL, 'Inhibitor_Mig-6', NULL, NULL, 18810, 9),
(270786, NULL, 'PF05465', NULL, NULL, 'Halobacterial gas vesicle protein C (GVPC) repeat', NULL, 'Halo_GVPC', NULL, NULL, 14323, 9),
(270787, NULL, 'PF11967', NULL, NULL, 'Recombination protein O N terminal', NULL, 'RecO_N', NULL, NULL, 16047, 9),
(270788, NULL, 'PF14893', NULL, NULL, 'PNMA', NULL, 'PNMA', NULL, NULL, 23038, 9),
(270789, NULL, 'PF01907', NULL, NULL, 'Ribosomal protein L37e', NULL, 'Ribosomal_L37e', NULL, NULL, 5209, 9),
(270790, NULL, 'PF19959', NULL, NULL, 'Effector-associated domain 4', NULL, 'EAD4', NULL, NULL, 37186, 9),
(270791, NULL, 'PF12730', NULL, NULL, 'ABC-2 family transporter protein', NULL, 'ABC2_membrane_4', NULL, NULL, NULL, 9),
(270792, NULL, 'PF20147', NULL, NULL, 'Crinkler effector protein N-terminal domain', NULL, 'Crinkler', NULL, NULL, 37274, 9),
(270793, NULL, 'PF13802', NULL, NULL, 'Galactose mutarotase-like', NULL, 'Gal_mutarotas_2', NULL, NULL, 24086, 9),
(270794, NULL, 'PF01032', NULL, NULL, 'FecCD transport family', NULL, 'FecCD', NULL, NULL, 5544, 9),
(270795, NULL, 'PF20409', NULL, NULL, 'SnoaL-like domain', NULL, 'SnoaL_5', NULL, NULL, 33603, 9),
(270796, NULL, 'PF00141', NULL, NULL, 'Peroxidase', NULL, 'peroxidase', NULL, NULL, 2145, 9),
(270797, NULL, 'PF09171', NULL, NULL, 'N-glycosylase/DNA lyase', NULL, 'AGOG', NULL, NULL, 12357, 9),
(270798, NULL, 'PF08570', NULL, NULL, 'Protein of unknown function (DUF1761)', NULL, 'DUF1761', NULL, NULL, 17706, 9),
(270799, NULL, 'PF09521', NULL, NULL, 'NgoPII restriction endonuclease', NULL, 'RE_NgoPII', NULL, NULL, 16747, 9),
(270800, NULL, 'PF10597', NULL, NULL, 'U5-snRNA binding site 2 of PrP8', NULL, 'U5_2-snRNA_bdg', NULL, NULL, 20268, 9),
(270801, NULL, 'PF14478', NULL, NULL, 'Domain of unknown function (DUF4430)', NULL, 'DUF4430', NULL, NULL, 24032, 9),
(270802, NULL, 'PF20101', NULL, NULL, 'Family of unknown function (DUF6491)', NULL, 'DUF6491', NULL, NULL, 37275, 9),
(270803, NULL, 'PF10572', NULL, NULL, 'UPF0556 domain', NULL, 'UPF0556', NULL, NULL, 20598, 9),
(270804, NULL, 'PF16230', NULL, NULL, 'Domain of unknown function (DUF4889)', NULL, 'DUF4889', NULL, NULL, 26265, 9),
(270805, NULL, 'PF14204', NULL, NULL, 'Ribosomal L18 C-terminal region', NULL, 'Ribosomal_L18_c', NULL, NULL, 25583, 9),
(270806, NULL, 'PF03906', NULL, NULL, 'Phage T7 tail fibre protein', NULL, 'Phage_T7_tail', NULL, NULL, 2536, 9),
(270807, NULL, 'PF07402', NULL, NULL, 'Human herpesvirus U26 protein', NULL, 'Herpes_U26', NULL, NULL, 8241, 9),
(270808, NULL, 'PF06485', NULL, NULL, 'RNA-binding protein Tab2/Atab2 N terminal', NULL, 'Tab2-like_N', NULL, NULL, 33795, 9),
(270809, NULL, 'PF11964', NULL, NULL, 'SpoIIAA-like', NULL, 'SpoIIAA-like', NULL, NULL, 19548, 9),
(270810, NULL, 'PF01891', NULL, NULL, 'Cobalt uptake substrate-specific transmembrane region', NULL, 'CbiM', NULL, NULL, 3720, 9),
(270811, NULL, 'PF10799', NULL, NULL, 'Biofilm formation protein (YliH/bssR)', NULL, 'YliH', NULL, NULL, 19568, 9),
(270812, NULL, 'PF14368', NULL, NULL, 'Probable lipid transfer', NULL, 'LTP_2', NULL, NULL, 11347, 9),
(270813, NULL, 'PF08139', NULL, NULL, 'Prokaryotic membrane lipoprotein lipid attachment site', NULL, 'LPAM_1', NULL, NULL, 10144, 9),
(270814, NULL, 'PF16138', NULL, NULL, 'Domain of unknown function (4846)', NULL, 'DUF4846', NULL, NULL, 26371, 9),
(270815, NULL, 'PF04228', NULL, NULL, 'Putative neutral zinc metallopeptidase', NULL, 'Zn_peptidase', NULL, NULL, 5817, 9),
(270816, NULL, 'PF09402', NULL, NULL, 'Man1-Src1p-C-terminal domain', NULL, 'MSC', NULL, NULL, 15816, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(270817, NULL, 'PF14283', NULL, NULL, 'Domain of unknown function (DUF4366)', NULL, 'DUF4366', NULL, NULL, 21600, 9),
(270818, NULL, 'PF10226', NULL, NULL, 'CCDC85 family', NULL, 'CCDC85', NULL, NULL, 15929, 9),
(270819, NULL, 'PF04076', NULL, NULL, 'Bacterial OB fold (BOF) protein', NULL, 'BOF', NULL, NULL, 11160, 9),
(270820, NULL, 'PF10054', NULL, NULL, 'Predicted periplasmic lipoprotein (DUF2291)', NULL, 'DUF2291', NULL, NULL, 8041, 9),
(270821, NULL, 'PF11307', NULL, NULL, 'Protein of unknown function (DUF3109)', NULL, 'DUF3109', NULL, NULL, 18489, 9),
(270822, NULL, 'PF05328', NULL, NULL, 'CybS, succinate dehydrogenase cytochrome B small subunit', NULL, 'CybS', NULL, NULL, NULL, 9),
(270823, NULL, 'PF00414', NULL, NULL, 'Neuraxin and MAP1B repeat', NULL, 'MAP1B_neuraxin', NULL, NULL, 3884, 9),
(270824, NULL, 'PF07177', NULL, NULL, 'Neuralized', NULL, 'Neuralized', NULL, NULL, 15, 9),
(270825, NULL, 'PF19458', NULL, NULL, 'Family of unknown function (DUF5995)', NULL, 'DUF5995', NULL, NULL, 36623, 9),
(270826, NULL, 'PF00126', NULL, NULL, 'Bacterial regulatory helix-turn-helix protein, lysR family', NULL, 'HTH_1', NULL, NULL, 221, 9),
(270827, NULL, 'PF19484', NULL, NULL, 'Family of unknown function (DUF6020)', NULL, 'DUF6020', NULL, NULL, 36529, 9),
(270828, NULL, 'PF02996', NULL, NULL, 'Prefoldin subunit', NULL, 'Prefoldin', NULL, NULL, 1814, 9),
(270829, NULL, 'PF05994', NULL, NULL, 'Cytoplasmic Fragile-X interacting family', NULL, 'FragX_IP', NULL, NULL, 6304, 9),
(270830, NULL, 'PF07071', NULL, NULL, 'KDGP aldolase', NULL, 'KDGP_aldolase', NULL, NULL, 9779, 9),
(270831, NULL, 'PF07158', NULL, NULL, 'Dicarboxylate carrier protein MatC N-terminus', NULL, 'MatC_N', NULL, NULL, 13072, 9),
(270832, NULL, 'PF12067', NULL, NULL, 'Sox 17/18 central domain', NULL, 'Sox17_18_mid', NULL, NULL, 27265, 9),
(270833, NULL, 'PF03293', NULL, NULL, 'Poxvirus DNA-directed RNA polymerase, 18 kD subunit', NULL, 'Pox_RNA_pol', NULL, NULL, 896, 9),
(270834, NULL, 'PF08348', NULL, NULL, 'YheO-like PAS domain', NULL, 'PAS_6', NULL, NULL, 12890, 9),
(270835, NULL, 'PF03367', NULL, NULL, 'ZPR1 zinc-finger domain', NULL, 'zf-ZPR1', NULL, NULL, 7129, 9),
(270836, NULL, 'PF03563', NULL, NULL, 'Bunyavirus glycoprotein G2', NULL, 'Bunya_G2', NULL, NULL, 4586, 9),
(270837, NULL, 'PF00244', NULL, NULL, '14-3-3 protein', NULL, '14-3-3', NULL, NULL, 16410, 9),
(270838, NULL, 'PF11575', NULL, NULL, 'FhuF 2Fe-2S C-terminal domain', NULL, 'FhuF_C', NULL, NULL, 5824, 9),
(270839, NULL, 'PF03744', NULL, NULL, '6-carboxyhexanoate--CoA ligase', NULL, 'BioW', NULL, NULL, 890, 9),
(270840, NULL, 'PF06431', NULL, NULL, 'Polyomavirus large T antigen C-terminus', NULL, 'Polyoma_lg_T_C', NULL, NULL, 7953, 9),
(270841, NULL, 'PF08368', NULL, NULL, 'FAST kinase-like protein, subdomain 2', NULL, 'FAST_2', NULL, NULL, 11979, 9),
(270842, NULL, 'PF18531', NULL, NULL, 'Polo box domain', NULL, 'Polo_box_2', NULL, NULL, 28241, 9),
(270843, NULL, 'PF12004', NULL, NULL, 'Domain of unknown function (DUF3498)', NULL, 'DUF3498', NULL, NULL, 19753, 9),
(270844, NULL, 'PF19184', NULL, NULL, 'Family of unknown function (DUF5866)', NULL, 'DUF5866', NULL, NULL, 35089, 9),
(270845, NULL, 'PF19325', NULL, NULL, 'E3 ubiquitin-protein ligase RNF152 C-terminus', NULL, 'RNF152_C', NULL, NULL, 36311, 9),
(270846, NULL, 'PF10566', NULL, NULL, 'Glycoside hydrolase 97', NULL, 'Glyco_hydro_97', NULL, NULL, 19155, 9),
(270847, NULL, 'PF13914', NULL, NULL, 'Phostensin PP1-binding and SH3-binding region', NULL, 'Phostensin', NULL, NULL, 22023, 9),
(270848, NULL, 'PF04937', NULL, NULL, 'Protein of unknown function (DUF 659)', NULL, 'DUF659', NULL, NULL, 6659, 9),
(270849, NULL, 'PF20321', NULL, NULL, 'Family of unknown function (DUF6616)', NULL, 'DUF6616', NULL, NULL, 37189, 9),
(270850, NULL, 'PF04176', NULL, NULL, 'TIP41-like family', NULL, 'TIP41', NULL, NULL, 4658, 9),
(270851, NULL, 'PF05244', NULL, NULL, 'Brucella outer membrane protein 2', NULL, 'Brucella_OMP2', NULL, NULL, 3371, 9),
(270852, NULL, 'PF02949', NULL, NULL, '7tm Odorant receptor', NULL, '7tm_6', NULL, NULL, 1629, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(270853, NULL, 'PF16010', NULL, NULL, 'Cytochrome domain of cellobiose dehydrogenase', NULL, 'CDH-cyt', NULL, NULL, 8454, 9),
(270854, NULL, 'PF18616', NULL, NULL, 'CDI immunity proteins', NULL, 'CdiI_3', NULL, NULL, 27018, 9),
(270855, NULL, 'PF15302', NULL, NULL, 'P33 mono-oxygenase', NULL, 'P33MONOX', NULL, NULL, 24353, 9),
(270856, NULL, 'PF12696', NULL, NULL, 'TraM recognition site of TraD and TraG', NULL, 'TraG-D_C', NULL, NULL, 26995, 9),
(270857, NULL, 'PF09873', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2100)', NULL, 'DUF2100', NULL, NULL, 21482, 9),
(270858, NULL, 'PF12586', NULL, NULL, 'Protein of unknown function (DUF3760)', NULL, 'DUF3760', NULL, NULL, 21298, 9),
(270859, NULL, 'PF13193', NULL, NULL, 'AMP-binding enzyme C-terminal domain', NULL, 'AMP-binding_C', NULL, NULL, 22199, 9),
(270860, NULL, 'PF03919', NULL, NULL, 'mRNA capping enzyme, C-terminal domain', NULL, 'mRNA_cap_C', NULL, NULL, 9443, 9),
(270861, NULL, 'PF03519', NULL, NULL, 'Invasion protein B family', NULL, 'Invas_SpaK', NULL, NULL, 857, 9),
(270862, NULL, 'PF15634', NULL, NULL, 'HYE1 signature containing ADP-ribosyltransferase', NULL, 'Tox-ART-HYE1', NULL, NULL, 25251, 9),
(270863, NULL, 'PF18949', NULL, NULL, 'Family of unknown function (DUF5693)', NULL, 'DUF5693', NULL, NULL, 35511, 9),
(270864, NULL, 'PF15172', NULL, NULL, 'Prolactin-releasing peptide', NULL, 'Prolactin_RP', NULL, NULL, 25025, 9),
(270865, NULL, 'PF18512', NULL, NULL, 'Benzylsuccinate synthase beta subunit', NULL, 'BssB_TutG', NULL, NULL, 27541, 9),
(270866, NULL, 'PF17641', NULL, NULL, 'Ancylostoma-associated secreted protein related', NULL, 'ASPRs', NULL, NULL, 29181, 9),
(270867, NULL, 'PF11111', NULL, NULL, 'Centromere protein M (CENP-M)', NULL, 'CENP-M', NULL, NULL, 20337, 9),
(270868, NULL, 'PF00595', NULL, NULL, 'PDZ domain', NULL, 'PDZ', NULL, NULL, 3119, 9),
(270869, NULL, 'PF03455', NULL, NULL, 'dDENN domain', NULL, 'dDENN', NULL, NULL, 10825, 9),
(270870, NULL, 'PF12879', NULL, NULL, 'SICA C-terminal inner membrane domain', NULL, 'SICA_C', NULL, NULL, 9104, 9),
(270871, NULL, 'PF01571', NULL, NULL, 'Aminomethyltransferase folate-binding domain', NULL, 'GCV_T', NULL, NULL, 11109, 9),
(270872, NULL, 'PF02618', NULL, NULL, 'YceG-like family', NULL, 'YceG', NULL, NULL, 2434, 9),
(270873, NULL, 'PF10020', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2262)', NULL, 'DUF2262', NULL, NULL, 19534, 9),
(270874, NULL, 'PF11160', NULL, NULL, 'Hypervirulence associated proteins TUDOR domain', NULL, 'Hva1_TUDOR', NULL, NULL, 17979, 9),
(270875, NULL, 'PF00825', NULL, NULL, 'Ribonuclease P', NULL, 'Ribonuclease_P', NULL, NULL, 3569, 9),
(270876, NULL, 'PF00082', NULL, NULL, 'Subtilase family', NULL, 'Peptidase_S8', NULL, NULL, 1183, 9),
(270877, NULL, 'PF02213', NULL, NULL, 'GYF domain', NULL, 'GYF', NULL, NULL, 1962, 9),
(270878, NULL, 'PF16933', NULL, NULL, 'Putative exopolysaccharide Exporter (EPS-E)', NULL, 'PelG', NULL, NULL, 25391, 9),
(270879, NULL, 'PF01723', NULL, NULL, 'Chorion protein', NULL, 'Chorion_1', NULL, NULL, 2713, 9),
(270880, NULL, 'PF14891', NULL, NULL, 'Effector protein', NULL, 'Peptidase_M91', NULL, NULL, 22193, 9),
(270881, NULL, 'PF18945', NULL, NULL, 'EvpB/VC_A0108, tail sheath gpW/gp25-like domain', NULL, 'VipB_2', NULL, NULL, 35785, 9),
(270882, NULL, 'PF04624', NULL, NULL, 'Dec-1 repeat', NULL, 'Dec-1', NULL, NULL, 2083, 9),
(270883, NULL, 'PF02024', NULL, NULL, 'Leptin', NULL, 'Leptin', NULL, NULL, 3616, 9),
(270884, NULL, 'PF08798', NULL, NULL, 'CRISPR associated protein', NULL, 'CRISPR_assoc', NULL, NULL, 4250, 9),
(270885, NULL, 'PF12915', NULL, NULL, 'Protein of unknown function (DUF3833)', NULL, 'DUF3833', NULL, NULL, 22110, 9),
(270886, NULL, 'PF07975', NULL, NULL, 'TFIIH C1-like domain', NULL, 'C1_4', NULL, NULL, 903, 9),
(270887, NULL, 'PF16343', NULL, NULL, 'Domain of unknown function (DUF4973)', NULL, 'DUF4973', NULL, NULL, 21809, 9),
(270888, NULL, 'PF07835', NULL, NULL, 'Bacterial aa3 type cytochrome c oxidase subunit IV', NULL, 'COX4_pro_2', NULL, NULL, 13267, 9);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(270889, NULL, 'PF19865', NULL, NULL, 'Family of unknown function (DUF6338)', NULL, 'DUF6338', NULL, NULL, 36758, 9),
(270890, NULL, 'PF15216', NULL, NULL, 'Thymic stromal lymphopoietin', NULL, 'TSLP', NULL, NULL, 21844, 9),
(270891, NULL, 'PF17270', NULL, NULL, 'Family of unknown function (DUF5336)', NULL, 'DUF5336', NULL, NULL, 18600, 9),
(270892, NULL, 'PF20524', NULL, NULL, 'Family of unknown function (DUF6739)', NULL, 'DUF6739', NULL, NULL, 33691, 9),
(270893, NULL, 'PF18491', NULL, NULL, 'SET and RING associated domain', NULL, 'SRA', NULL, NULL, 28466, 9),
(270894, NULL, 'PF17130', NULL, NULL, 'beta-barrel domain of carboxypeptidase M99', NULL, 'Peptidase_M99_m', NULL, NULL, 27772, 9),
(270895, NULL, 'PF03913', NULL, NULL, 'Ragweed group 5 pollen allergen', NULL, 'Ragweed_pollen', NULL, NULL, 2638, 9),
(270896, NULL, 'PF15514', NULL, NULL, 'Restriction endonuclease ThaI', NULL, 'ThaI', NULL, NULL, 23918, 9),
(270897, NULL, 'PF01789', NULL, NULL, 'PsbP', NULL, 'PsbP', NULL, NULL, 2653, 9),
(270898, NULL, 'PF05973', NULL, NULL, 'Phage derived protein Gp49-like (DUF891)', NULL, 'Gp49', NULL, NULL, 12985, 9),
(270899, NULL, 'PF08059', NULL, NULL, 'SEP domain', NULL, 'SEP', NULL, NULL, 12278, 9),
(270900, NULL, 'PF16858', NULL, NULL, 'Condensin II complex subunit CAP-H2 or CNDH2, C-term', NULL, 'CNDH2_C', NULL, NULL, 22822, 9),
(270901, NULL, 'PF03424', NULL, NULL, 'Carbohydrate binding domain (family 17/28)', NULL, 'CBM_17_28', NULL, NULL, 10494, 9),
(270902, NULL, 'PF15628', NULL, NULL, 'RRM in Demeter', NULL, 'RRM_DME', NULL, NULL, 25259, 9),
(270903, NULL, 'PF06045', NULL, NULL, 'Rhamnogalacturonate lyase family', NULL, 'Rhamnogal_lyase', NULL, NULL, 8543, 9),
(270904, NULL, 'PF13761', NULL, NULL, 'Domain of unknown function (DUF4166)', NULL, 'DUF4166', NULL, NULL, 22458, 9),
(270905, NULL, 'PF16123', NULL, NULL, 'Hydroxyacylglutathione hydrolase C-terminus', NULL, 'HAGH_C', NULL, NULL, 25493, 9),
(270906, NULL, 'PF00724', NULL, NULL, 'NADH:flavin oxidoreductase / NADH oxidase family', NULL, 'Oxidored_FMN', NULL, NULL, 1437, 9),
(270907, NULL, 'PF16073', NULL, NULL, 'Starter unit:ACP transacylase in aflatoxin biosynthesis', NULL, 'SAT', NULL, NULL, 23803, 9),
(270908, NULL, 'PF16706', NULL, NULL, 'Izumo-like Immunoglobulin domain', NULL, 'Izumo-Ig', NULL, NULL, 26262, 9),
(270909, NULL, 'PF01856', NULL, NULL, 'Helicobacter outer membrane protein', NULL, 'HP_OMP', NULL, NULL, 3903, 9),
(270910, NULL, 'PF08040', NULL, NULL, 'MNLL subunit', NULL, 'NADH_oxidored', NULL, NULL, 9283, 9),
(270911, NULL, 'PF02112', NULL, NULL, 'cAMP phosphodiesterases class-II', NULL, 'PDEase_II', NULL, NULL, 6535, 9),
(270912, NULL, 'PF06698', NULL, NULL, 'Protein of unknown function (DUF1192)', NULL, 'DUF1192', NULL, NULL, 560, 9),
(270913, NULL, 'PF08566', NULL, NULL, 'Mitochondrial import protein Pam17', NULL, 'Pam17', NULL, NULL, 9986, 9),
(270914, NULL, 'PF00031', NULL, NULL, 'Cystatin domain', NULL, 'Cystatin', NULL, NULL, 2507, 9),
(270915, NULL, 'PF16053', NULL, NULL, 'Mitochondrial 28S ribosomal protein S34', NULL, 'MRP-S34', NULL, NULL, 22922, 9),
(270916, NULL, 'PF09276', NULL, NULL, 'Pertussis toxin S5 subunit', NULL, 'Pertus-S5-tox', NULL, NULL, 13082, 9),
(270917, NULL, 'PF20602', NULL, NULL, 'Putative adhesive domain (group 8)', NULL, 'pAdhesive_8', NULL, NULL, 33781, 9),
(270918, NULL, 'PF04642', NULL, NULL, 'Protein of unknown function, DUF601', NULL, 'DUF601', NULL, NULL, 2769, 9),
(270919, NULL, 'PF12523', NULL, NULL, 'Protein of unknown function (DUF3725)', NULL, 'DUF3725', NULL, NULL, 21262, 9),
(270920, NULL, 'PF03539', NULL, NULL, 'Spumavirus aspartic protease (A9)', NULL, 'Spuma_A9PTase', NULL, NULL, 3575, 9),
(270921, NULL, 'PF07457', NULL, NULL, 'Protein of unknown function (DUF1516)', NULL, 'DUF1516', NULL, NULL, 12220, 9),
(270922, NULL, 'PF16757', NULL, NULL, 'Alpha-L-fucosidase C-terminal domain', NULL, 'Fucosidase_C', NULL, NULL, 22775, 9),
(270923, NULL, 'PF15165', NULL, NULL, 'Meiotic recombination protein REC114-like', NULL, 'REC114-like', NULL, NULL, 21919, 9),
(270924, NULL, 'PF08919', NULL, NULL, 'F-actin binding', NULL, 'F_actin_bind', NULL, NULL, 7827, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(270925, NULL, 'PF15728', NULL, NULL, 'Domain of unknown function (DUF4679)', NULL, 'DUF4679', NULL, NULL, 26030, 9),
(270926, NULL, 'PF09411', NULL, NULL, 'Lipid A 3-O-deacylase (PagL)', NULL, 'PagL', NULL, NULL, 15254, 9),
(270927, NULL, 'PF11246', NULL, NULL, 'Base plate wedge protein 53', NULL, 'Phage_gp53', NULL, NULL, 14826, 9),
(270928, NULL, 'PF18901', NULL, NULL, 'Family of unknown function (DUF5657)', NULL, 'DUF5657', NULL, NULL, 35540, 9),
(270929, NULL, 'PF11468', NULL, NULL, 'Aromatic prenyltransferase Orf2', NULL, 'PTase_Orf2', NULL, NULL, 15779, 9),
(270930, NULL, 'PF11915', NULL, NULL, 'Protein of unknown function (DUF3433)', NULL, 'DUF3433', NULL, NULL, 19876, 9),
(270931, NULL, 'PF13960', NULL, NULL, 'Domain of unknown function (DUF4218)', NULL, 'DUF4218', NULL, NULL, 22220, 9),
(270932, NULL, 'PF05527', NULL, NULL, 'Domain of unknown function (DUF758)', NULL, 'DUF758', NULL, NULL, 12459, 9),
(270933, NULL, 'PF16974', NULL, NULL, 'High-affinity nitrate transporter accessory, Ig-like domain', NULL, 'NAR2', NULL, NULL, 19347, 9),
(270934, NULL, 'PF19928', NULL, NULL, 'Domain of unknown function (DUF6391)', NULL, 'DUF6391', NULL, NULL, NULL, 9),
(270935, NULL, 'PF06917', NULL, NULL, 'Periplasmic pectate lyase', NULL, 'Pectate_lyase_2', NULL, NULL, 9849, 9),
(270936, NULL, 'PF08594', NULL, NULL, 'Uncharacterised protein family (UPF0300)', NULL, 'UPF0300', NULL, NULL, 17563, 9),
(270937, NULL, 'PF08775', NULL, NULL, 'ParB family', NULL, 'ParB', NULL, NULL, 13459, 9),
(270938, NULL, 'PF05179', NULL, NULL, 'RNA pol II accessory factor, Cdc73 family, C-terminal', NULL, 'CDC73_C', NULL, NULL, 25512, 9),
(270939, NULL, 'PF18139', NULL, NULL, 'SLOG in TRPM', NULL, 'LSDAT_euk', NULL, NULL, 29250, 9),
(270940, NULL, 'PF10479', NULL, NULL, 'Fragile site-associated protein C-terminus', NULL, 'FSA_C', NULL, NULL, 20536, 9),
(270941, NULL, 'PF16873', NULL, NULL, 'Putative abortive phage resistance protein AbiGii toxin', NULL, 'AbiGii_2', NULL, NULL, 24425, 9),
(270942, NULL, 'PF17786', NULL, NULL, 'Mannosidase Ig/CBM-like domain', NULL, 'Mannosidase_ig', NULL, NULL, 30180, 9),
(270943, NULL, 'PF19297', NULL, NULL, 'QcrA subunit N-terminal region', NULL, 'QcrA_N', NULL, NULL, 33502, 9),
(270944, NULL, 'PF10668', NULL, NULL, 'Phage terminase small subunit', NULL, 'Phage_terminase', NULL, NULL, 14943, 9),
(270945, NULL, 'PF10216', NULL, NULL, 'CO2 hydration protein (ChpXY)', NULL, 'ChpXY', NULL, NULL, 4144, 9),
(270946, NULL, 'PF00042', NULL, NULL, 'Globin', NULL, 'Globin', NULL, NULL, 3034, 9),
(270947, NULL, 'PF00198', NULL, NULL, '2-oxoacid dehydrogenases acyltransferase (catalytic domain)', NULL, '2-oxoacid_dh', NULL, NULL, 1400, 9),
(270948, NULL, 'PF19281', NULL, NULL, 'Phytanoyl-CoA hydroxylase-interacting protein C-terminus', NULL, 'PHYHIP_C', NULL, NULL, 37239, 9),
(270949, NULL, 'PF03631', NULL, NULL, 'Virulence factor BrkB', NULL, 'Virul_fac_BrkB', NULL, NULL, 18826, 9),
(270950, NULL, 'PF19160', NULL, NULL, 'SPARK', NULL, 'SPARK', NULL, NULL, 34994, 9),
(270951, NULL, 'PF06544', NULL, NULL, 'Protein of unknown function (DUF1115)', NULL, 'DUF1115', NULL, NULL, 14267, 9),
(270952, NULL, 'PF08077', NULL, NULL, 'Chloramphenicol resistance gene leader peptide', NULL, 'Cm_res_leader', NULL, NULL, 8897, 9),
(270953, NULL, 'PF06674', NULL, NULL, 'Protein of unknown function (DUF1176)', NULL, 'DUF1176', NULL, NULL, 10141, 9),
(270954, NULL, 'PF03496', NULL, NULL, 'ADP-ribosyltransferase exoenzyme', NULL, 'ADPrib_exo_Tox', NULL, NULL, 7172, 9),
(270955, NULL, 'PF06740', NULL, NULL, 'Protein of unknown function (DUF1213)', NULL, 'DUF1213', NULL, NULL, 1725, 9),
(270956, NULL, 'PF16420', NULL, NULL, 'Ubiquitin-like modifier-activating enzyme ATG7 N-terminus', NULL, 'ATG7_N', NULL, NULL, 24058, 9),
(270957, NULL, 'PF14628', NULL, NULL, 'Domain of unknown function (DUF4454)', NULL, 'DUF4454', NULL, NULL, 23015, 9),
(270958, NULL, 'PF17911', NULL, NULL, 'Ski2 N-terminal region', NULL, 'Ski2_N', NULL, NULL, 32245, 9),
(270959, NULL, 'PF20174', NULL, NULL, 'Family of unknown function (DUF6540)', NULL, 'DUF6540', NULL, NULL, 37325, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(270960, NULL, 'PF02537', NULL, NULL, 'CrcB-like protein, Camphor Resistance (CrcB)', NULL, 'CRCB', NULL, NULL, 1540, 9),
(270961, NULL, 'PF10002', NULL, NULL, 'Predicted membrane protein (DUF2243)', NULL, 'DUF2243', NULL, NULL, 17054, 9),
(270962, NULL, 'PF15098', NULL, NULL, 'TMEM89 protein family', NULL, 'TMEM89', NULL, NULL, 26798, 9),
(270963, NULL, 'PF03330', NULL, NULL, 'Lytic transglycolase', NULL, 'DPBB_1', NULL, NULL, 9544, 9),
(270964, NULL, 'PF03034', NULL, NULL, 'Phosphatidyl serine synthase', NULL, 'PSS', NULL, NULL, 4540, 9),
(270965, NULL, 'PF18934', NULL, NULL, 'Family of unknown function (DUF5682)', NULL, 'DUF5682', NULL, NULL, 34057, 9),
(270966, NULL, 'PF18723', NULL, NULL, 'alpha-glutamyl/putrescinyl thymine pyrophosphorylase clade 1', NULL, 'aGPT-Pplase1', NULL, NULL, 28543, 9),
(270967, NULL, 'PF03888', NULL, NULL, 'MucB/RseB N-terminal domain', NULL, 'MucB_RseB', NULL, NULL, 31999, 9),
(270968, NULL, 'PF17527', NULL, NULL, 'Phage ALC protein', NULL, 'ALC', NULL, NULL, 19367, 9),
(270969, NULL, 'PF16462', NULL, NULL, 'Phage tail assembly chaperone protein, TAC', NULL, 'Phage_TAC_14', NULL, NULL, 22399, 9),
(270970, NULL, 'PF07793', NULL, NULL, 'Protein of unknown function (DUF1631)', NULL, 'DUF1631', NULL, NULL, 14193, 9),
(270971, NULL, 'PF01308', NULL, NULL, 'Chlamydia major outer membrane protein', NULL, 'Chlam_OMP', NULL, NULL, 5536, 9),
(270972, NULL, 'PF06878', NULL, NULL, 'Pkip-1 protein', NULL, 'Pkip-1', NULL, NULL, 11774, 9),
(270973, NULL, 'PF02479', NULL, NULL, 'Herpesvirus immediate early protein', NULL, 'Herpes_IE68', NULL, NULL, 5138, 9),
(270974, NULL, 'PF02149', NULL, NULL, 'Kinase associated domain 1', NULL, 'KA1', NULL, NULL, 3326, 9),
(270975, NULL, 'PF17544', NULL, NULL, 'Family of unknown function (DUF5460)', NULL, 'DUF5460', NULL, NULL, 13715, 9),
(270976, NULL, 'PF18340', NULL, NULL, 'DNA relaxase TraI 2B/2B-like domain', NULL, 'TraI_2B', NULL, NULL, 28492, 9),
(270977, NULL, 'PF11264', NULL, NULL, 'Thylakoid formation protein', NULL, 'ThylakoidFormat', NULL, NULL, 20523, 9),
(270978, NULL, 'PF08141', NULL, NULL, 'Small acid-soluble spore protein H family', NULL, 'SspH', NULL, NULL, 9801, 9),
(270979, NULL, 'PF08729', NULL, NULL, 'HPC2 and ubinuclein domain', NULL, 'HUN', NULL, NULL, 11828, 9),
(270980, NULL, 'PF15826', NULL, NULL, 'Bcl-2-binding component 3, p53 upregulated modulator of apoptosis', NULL, 'PUMA', NULL, NULL, 26889, 9),
(270981, NULL, 'PF10944', NULL, NULL, 'Protein of unknown function (DUF2630)', NULL, 'DUF2630', NULL, NULL, 19340, 9),
(270982, NULL, 'PF12012', NULL, NULL, 'Domain of unknown function (DUF3504)', NULL, 'DUF3504', NULL, NULL, 19699, 9),
(270983, NULL, 'PF11907', NULL, NULL, 'Domain of unknown function (DUF3427)', NULL, 'DUF3427', NULL, NULL, 19970, 9),
(270984, NULL, 'PF16984', NULL, NULL, 'Group 7 allergen', NULL, 'Grp7_allergen', NULL, NULL, 21043, 9),
(270985, NULL, 'PF01996', NULL, NULL, 'F420-0:Gamma-glutamyl ligase', NULL, 'F420_ligase', NULL, NULL, 5909, 9),
(270986, NULL, 'PF13740', NULL, NULL, 'ACT domain', NULL, 'ACT_6', NULL, NULL, NULL, 9),
(270987, NULL, 'PF16259', NULL, NULL, 'Domain of unknown function (DUF4913)', NULL, 'DUF4913', NULL, NULL, 21810, 9),
(270988, NULL, 'PF02625', NULL, NULL, 'XdhC and CoxI family', NULL, 'XdhC_CoxI', NULL, NULL, 2694, 9),
(270989, NULL, 'PF08372', NULL, NULL, 'Plant phosphoribosyltransferase C-terminal', NULL, 'PRT_C', NULL, NULL, 11535, 9),
(270990, NULL, 'PF12956', NULL, NULL, 'Domain of Unknown Function with PDB structure', NULL, 'DUF3845', NULL, NULL, 26791, 9),
(270991, NULL, 'PF08825', NULL, NULL, 'E2 binding domain', NULL, 'E2_bind', NULL, NULL, 14462, 9),
(270992, NULL, 'PF15215', NULL, NULL, 'Follicular dendritic cell secreted peptide', NULL, 'FDC-SP', NULL, NULL, 21863, 9),
(270993, NULL, 'PF11603', NULL, NULL, 'Sir1, ORC-binding domain', NULL, 'Sir1', NULL, NULL, 18808, 9),
(270994, NULL, 'PF17052', NULL, NULL, 'Cap associated factor', NULL, 'CAF20', NULL, NULL, 26867, 9),
(270995, NULL, 'PF17903', NULL, NULL, 'Krr1 KH1 domain', NULL, 'KH_8', NULL, NULL, 28590, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(270996, NULL, 'PF19196', NULL, NULL, 'Family of unknown function (DUF5871)', NULL, 'DUF5871', NULL, NULL, 35075, 9),
(270997, NULL, 'PF01061', NULL, NULL, 'ABC-2 type transporter', NULL, 'ABC2_membrane', NULL, NULL, 8692, 9),
(270998, NULL, 'PF13696', NULL, NULL, 'Zinc knuckle', NULL, 'zf-CCHC_2', NULL, NULL, 24063, 9),
(270999, NULL, 'PF08092', NULL, NULL, 'Magi peptide toxin family', NULL, 'Toxin_22', NULL, NULL, 9896, 9),
(271000, NULL, 'PF15652', NULL, NULL, 'HNH/Endo VII superfamily toxin with a SHH signature', NULL, 'Tox-SHH', NULL, NULL, 24712, 9),
(271001, NULL, 'PF05105', NULL, NULL, 'Bacteriophage holin family', NULL, 'Phage_holin_4_1', NULL, NULL, 6454, 9),
(271002, NULL, 'PF11585', NULL, NULL, 'Insect antimicrobial peptide, stomoxyn', NULL, 'Stomoxyn', NULL, NULL, 15330, 9),
(271003, NULL, 'PF16812', NULL, NULL, 'C-terminal head domain of the fowl adenovirus type 1 long fibre', NULL, 'AdHead_fibreRBD', NULL, NULL, 22352, 9),
(271004, NULL, 'PF09675', NULL, NULL, 'Chlamydia-phage Chp2 scaffold (Chlamy_scaf)', NULL, 'Chlamy_scaf', NULL, NULL, 14419, 9),
(271005, NULL, 'PF02438', NULL, NULL, 'Late 100kD protein', NULL, 'Adeno_100', NULL, NULL, 4050, 9),
(271006, NULL, 'PF03342', NULL, NULL, 'Rhabdovirus M1 matrix protein (M1 polymerase-associated protein)', NULL, 'Rhabdo_M1', NULL, NULL, 680, 9),
(271007, NULL, 'PF12051', NULL, NULL, 'Protein of unknown function (DUF3533)', NULL, 'DUF3533', NULL, NULL, 16559, 9),
(271008, NULL, 'PF11889', NULL, NULL, 'Capsid protein C, pestivirus', NULL, 'Capsid_pestivir', NULL, NULL, 19832, 9),
(271009, NULL, 'PF14175', NULL, NULL, 'YaaC-like Protein', NULL, 'YaaC', NULL, NULL, 25614, 9),
(271010, NULL, 'PF00616', NULL, NULL, 'GTPase-activator protein for Ras-like GTPase', NULL, 'RasGAP', NULL, NULL, 2253, 9),
(271011, NULL, 'PF03175', NULL, NULL, 'DNA polymerase type B, organellar and viral', NULL, 'DNA_pol_B_2', NULL, NULL, 7346, 9),
(271012, NULL, 'PF00373', NULL, NULL, 'FERM central domain', NULL, 'FERM_M', NULL, NULL, 20805, 9),
(271013, NULL, 'PF16045', NULL, NULL, 'LisH', NULL, 'LisH_2', NULL, NULL, 1021, 9),
(271014, NULL, 'PF07125', NULL, NULL, 'Protein of unknown function (DUF1378)', NULL, 'DUF1378', NULL, NULL, 13113, 9),
(271015, NULL, 'PF04354', NULL, NULL, 'ZipA, C-terminal FtsZ-binding domain', NULL, 'ZipA_C', NULL, NULL, 4718, 9),
(271016, NULL, 'PF13446', NULL, NULL, 'A repeated domain in UCH-protein', NULL, 'RPT', NULL, NULL, 25682, 9),
(271017, NULL, 'PF13826', NULL, NULL, 'Domain of unknown function (DUF4188)', NULL, 'DUF4188', NULL, NULL, 22208, 9),
(271018, NULL, 'PF11417', NULL, NULL, 'Loader and inhibitor of phage G40P', NULL, 'Inhibitor_G39P', NULL, NULL, 22251, 9),
(271019, NULL, 'PF11890', NULL, NULL, 'Domain of unknown function (DUF3410)', NULL, 'DUF3410', NULL, NULL, 23431, 9),
(271020, NULL, 'PF19204', NULL, NULL, 'Family of unknown function (DUF5876)', NULL, 'DUF5876', NULL, NULL, 35545, 9),
(271021, NULL, 'PF01112', NULL, NULL, 'Asparaginase', NULL, 'Asparaginase_2', NULL, NULL, 4311, 9),
(271022, NULL, 'PF11377', NULL, NULL, 'Protein of unknown function (DUF3180)', NULL, 'DUF3180', NULL, NULL, 18910, 9),
(271023, NULL, 'PF01938', NULL, NULL, 'TRAM domain', NULL, 'TRAM', NULL, NULL, 4304, 9),
(271024, NULL, 'PF06058', NULL, NULL, 'Dcp1-like decapping family', NULL, 'DCP1', NULL, NULL, 8649, 9),
(271025, NULL, 'PF20247', NULL, NULL, 'Domain of unknown function (DUF6602)', NULL, 'DUF6602', NULL, NULL, 37549, 9),
(271026, NULL, 'PF01902', NULL, NULL, 'Diphthamide synthase', NULL, 'Diphthami_syn_2', NULL, NULL, 4123, 9),
(271027, NULL, 'PF19625', NULL, NULL, 'Family of unknown function (DUF6130)', NULL, 'DUF6130', NULL, NULL, 37481, 9),
(271028, NULL, 'PF17369', NULL, NULL, 'Family of unknown function (DUF5391)', NULL, 'DUF5391', NULL, NULL, 17687, 9),
(271029, NULL, 'PF02694', NULL, NULL, 'Uncharacterised BCR, YnfA/UPF0060 family', NULL, 'UPF0060', NULL, NULL, 3360, 9),
(271030, NULL, 'PF13948', NULL, NULL, 'Domain of unknown function (DUF4215)', NULL, 'DUF4215', NULL, NULL, 11439, 9),
(271031, NULL, 'PF16703', NULL, NULL, 'Domain of unknown function (DUF5064)', NULL, 'DUF5064', NULL, NULL, 23205, 9); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(271032, NULL, 'PF05979', NULL, NULL, 'Bacterial protein of unknown function (DUF896)', NULL, 'DUF896', NULL, NULL, 13978, 9),
(271033, NULL, 'PF14189', NULL, NULL, 'Domain of unknown function (DUF4312)', NULL, 'DUF4312', NULL, NULL, 17672, 9),
(271034, NULL, 'PF18115', NULL, NULL, 'DNA repair protein Crb2 Tudor domain', NULL, 'Tudor_3', NULL, NULL, 29419, 9),
(271035, NULL, 'PF03561', NULL, NULL, 'Allantoicase repeat', NULL, 'Allantoicase', NULL, NULL, 8462, 9),
(271036, NULL, 'PF02389', NULL, NULL, 'Cornifin (SPRR) family', NULL, 'Cornifin', NULL, NULL, NULL, 9),
(271037, NULL, 'PF16212', NULL, NULL, 'Phospholipid-translocating P-type ATPase C-terminal', NULL, 'PhoLip_ATPase_C', NULL, NULL, 21610, 9),
(271038, NULL, 'PF02928', NULL, NULL, 'C5HC2 zinc finger', NULL, 'zf-C5HC2', NULL, NULL, 2957, 9),
(271039, NULL, 'PF01569', NULL, NULL, 'PAP2 superfamily', NULL, 'PAP2', NULL, NULL, 4961, 9),
(271040, NULL, 'PF16220', NULL, NULL, 'Domain of unknown function (DUF4880)', NULL, 'DUF4880', NULL, NULL, 26159, 9),
(271041, NULL, 'PF18753', NULL, NULL, 'Nucleotide modification associated domain 2', NULL, 'Nmad2', NULL, NULL, 28660, 9),
(271042, NULL, 'PF14472', NULL, NULL, 'Domain of unknown function (DUF4429)', NULL, 'DUF4429', NULL, NULL, 25834, 9),
(271043, NULL, 'PF17667', NULL, NULL, 'Fungal protein kinase', NULL, 'Pkinase_fungal', NULL, NULL, 28226, 9),
(271044, NULL, 'PF18168', NULL, NULL, 'Prim-pol family 5', NULL, 'PPL5', NULL, NULL, 27100, 9),
(271045, NULL, 'PF02037', NULL, NULL, 'SAP domain', NULL, 'SAP', NULL, NULL, 71, 9),
(271046, NULL, 'PF15269', NULL, NULL, 'Zinc-finger', NULL, 'zf-C2H2_7', NULL, NULL, 32892, 9),
(271047, NULL, 'PF04777', NULL, NULL, 'Erv1 / Alr family', NULL, 'Evr1_Alr', NULL, NULL, 12622, 9),
(271048, NULL, 'PF14320', NULL, NULL, 'Phosphoprotein P region PNT disordered', NULL, 'Paramyxo_PNT', NULL, NULL, 19038, 9),
(271049, NULL, 'PF05003', NULL, NULL, 'Protein of unknown function (DUF668)', NULL, 'DUF668', NULL, NULL, 1496, 9),
(271050, NULL, 'PF11475', NULL, NULL, 'Virion protein N terminal domain', NULL, 'VP_N-CPKC', NULL, NULL, 18618, 9),
(271051, NULL, 'PF06999', NULL, NULL, 'Sucrase/ferredoxin-like', NULL, 'Suc_Fer-like', NULL, NULL, 12051, 9),
(271052, NULL, 'PF11127', NULL, NULL, 'Protein of unknown function (DUF2892)', NULL, 'DUF2892', NULL, NULL, 17731, 9),
(271053, NULL, 'PF09181', NULL, NULL, 'Prolyl-tRNA synthetase, C-terminal', NULL, 'ProRS-C_2', NULL, NULL, 12081, 9),
(271054, NULL, 'PF14176', NULL, NULL, 'YxiJ-like protein', NULL, 'YxiJ', NULL, NULL, 24311, 9),
(271055, NULL, 'PF15887', NULL, NULL, 'Putative zinc-binding metallo-peptidase', NULL, 'Peptidase_Mx', NULL, NULL, 21504, 9),
(271056, NULL, 'PF07566', NULL, NULL, 'Domain of Unknown Function (DUF1543)', NULL, 'DUF1543', NULL, NULL, 13677, 9),
(271057, NULL, 'PF18428', NULL, NULL, 'BRCA1 C Terminus (BRCT) domain', NULL, 'BRCT_3', NULL, NULL, NULL, 9),
(271058, NULL, 'PF17897', NULL, NULL, 'Vanadium chloroperoxidase N-terminal domain', NULL, 'VCPO_N', NULL, NULL, 28831, 9),
(271059, NULL, 'PF07901', NULL, NULL, 'Protein of unknown function (DUF1672)', NULL, 'DUF1672', NULL, NULL, 12160, 9),
(271060, NULL, 'PF05288', NULL, NULL, 'Poxvirus A3L Protein', NULL, 'Pox_A3L', NULL, NULL, 4021, 9),
(271061, NULL, 'PF00877', NULL, NULL, 'NlpC/P60 family', NULL, 'NLPC_P60', NULL, NULL, 2862, 9),
(271062, NULL, 'PF06940', NULL, NULL, 'Domain of unknown function (DUF1287)', NULL, 'DUF1287', NULL, NULL, 11688, 9),
(271063, NULL, 'PF19754', NULL, NULL, 'Family of unknown function (DUF6241)', NULL, 'DUF6241', NULL, NULL, 37394, 9),
(271064, NULL, 'PF07550', NULL, NULL, 'Protein of unknown function (DUF1533)', NULL, 'DUF1533', NULL, NULL, 13501, 9),
(271065, NULL, 'PF11519', NULL, NULL, 'Protein of unknown function (DUF3222)', NULL, 'DUF3222', NULL, NULL, 18722, 9),
(271066, NULL, 'PF06099', NULL, NULL, 'Phenol hydroxylase subunit', NULL, 'Phenol_hyd_sub', NULL, NULL, 8537, 9),
(271067, NULL, 'PF17008', NULL, NULL, 'Domain of unknown function (DUF5088)', NULL, 'DUF5088', NULL, NULL, 22262, 9),
(271068, NULL, 'PF02912', NULL, NULL, 'Aminoacyl tRNA synthetase class II, N-terminal domain', NULL, 'Phe_tRNA-synt_N', NULL, NULL, 2863, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(271069, NULL, 'PF17601', NULL, NULL, 'Family of unknown function (DUF5497)', NULL, 'DUF5497', NULL, NULL, 19205, 9),
(271070, NULL, 'PF07788', NULL, NULL, 'PD-(D/E)XK nuclease superfamily', NULL, 'PDDEXK_10', NULL, NULL, 13293, 9),
(271071, NULL, 'PF00115', NULL, NULL, 'Cytochrome C and Quinol oxidase polypeptide I', NULL, 'COX1', NULL, NULL, 456, 9),
(271072, NULL, 'PF07199', NULL, NULL, 'Protein of unknown function (DUF1411)', NULL, 'DUF1411', NULL, NULL, 13709, 9),
(271073, NULL, 'PF12547', NULL, NULL, 'Ataxin-1 like family', NULL, 'ATXN-1_C', NULL, NULL, 15457, 9),
(271074, NULL, 'PF20205', NULL, NULL, 'Family of unknown function (DUF6567)', NULL, 'DUF6567', NULL, NULL, 37244, 9),
(271075, NULL, 'PF01051', NULL, NULL, 'Initiator Replication protein', NULL, 'Rep_3', NULL, NULL, 5636, 9),
(271076, NULL, 'PF01602', NULL, NULL, 'Adaptin N terminal region', NULL, 'Adaptin_N', NULL, NULL, 1662, 9),
(271077, NULL, 'PF16017', NULL, NULL, 'BTB/POZ domain', NULL, 'BTB_3', NULL, NULL, 27217, 9),
(271078, NULL, 'PF10297', NULL, NULL, 'Minimal binding motif of Hap4 for binding to Hap2/3/5', NULL, 'Hap4_Hap_bind', NULL, NULL, 19653, 9),
(271079, NULL, 'PF01484', NULL, NULL, 'Nematode cuticle collagen N-terminal domain', NULL, 'Col_cuticle_N', NULL, NULL, 684, 9),
(271080, NULL, 'PF03875', NULL, NULL, 'Statherin', NULL, 'Statherin', NULL, NULL, 1519, 9),
(271081, NULL, 'PF14048', NULL, NULL, 'C-terminal domain of methyl-CpG binding protein 2 and 3', NULL, 'MBD_C', NULL, NULL, 23442, 9),
(271082, NULL, 'PF03060', NULL, NULL, 'Nitronate monooxygenase', NULL, 'NMO', NULL, NULL, 2775, 9),
(271083, NULL, 'PF02486', NULL, NULL, 'Replication initiation factor', NULL, 'Rep_trans', NULL, NULL, 6284, 9),
(271084, NULL, 'PF13991', NULL, NULL, 'BssS protein family', NULL, 'BssS', NULL, NULL, 22586, 9),
(271085, NULL, 'PF18590', NULL, NULL, 'Immune Mapped Protein 2 (IMP2) N-terminal domain', NULL, 'IMP2_N', NULL, NULL, 28755, 9),
(271086, NULL, 'PF07431', NULL, NULL, 'Protein of unknown function (DUF1512)', NULL, 'DUF1512', NULL, NULL, 8616, 9),
(271087, NULL, 'PF02750', NULL, NULL, 'Synapsin, ATP binding domain', NULL, 'Synapsin_C', NULL, NULL, 20566, 9),
(271088, NULL, 'PF19867', NULL, NULL, 'Family of unknown function (DUF6340)', NULL, 'DUF6340', NULL, NULL, 36548, 9),
(271089, NULL, 'PF20587', NULL, NULL, 'Family of unknown function (DUF6789)', NULL, 'DUF6789', NULL, NULL, 37136, 9),
(271090, NULL, 'PF06289', NULL, NULL, 'Flagellar and Swarming motility proteins', NULL, 'FlbD', NULL, NULL, 8450, 9),
(271091, NULL, 'PF16784', NULL, NULL, 'Putative HNHc nuclease', NULL, 'HNHc_6', NULL, NULL, 30350, 9),
(271092, NULL, 'PF04812', NULL, NULL, 'Hepatocyte nuclear factor 1 (HNF-1), beta isoform C terminus', NULL, 'HNF-1B_C', NULL, NULL, 4917, 9),
(271093, NULL, 'PF02388', NULL, NULL, 'FemAB family', NULL, 'FemAB', NULL, NULL, 5202, 9),
(271094, NULL, 'PF02971', NULL, NULL, 'Formiminotransferase domain', NULL, 'FTCD', NULL, NULL, 9780, 9),
(271095, NULL, 'PF18938', NULL, NULL, 'Atypical Rib domain', NULL, 'aRib', NULL, NULL, 35624, 9),
(271096, NULL, 'PF05017', NULL, NULL, 'TMP repeat', NULL, 'TMP', NULL, NULL, 1172, 9),
(271097, NULL, 'PF17580', NULL, NULL, 'Group B Rotavirus Non-structural protein 5', NULL, 'GBR_NSP5', NULL, NULL, 19102, 9),
(271098, NULL, 'PF18477', NULL, NULL, 'PIN like domain', NULL, 'PIN_9', NULL, NULL, 28892, 9),
(271099, NULL, 'PF17302', NULL, NULL, 'Family of unknown function (DUF5351)', NULL, 'DUF5351', NULL, NULL, 31621, 9),
(271100, NULL, 'PF06136', NULL, NULL, 'Protein SOSEKI, plant', NULL, 'SOK', NULL, NULL, 8896, 9),
(271101, NULL, 'PF07666', NULL, NULL, 'M penetrans paralogue family 26', NULL, 'MpPF26', NULL, NULL, 10989, 9),
(271102, NULL, 'PF10898', NULL, NULL, 'Protein of unknown function (DUF2716)', NULL, 'DUF2716', NULL, NULL, 19135, 9),
(271103, NULL, 'PF03231', NULL, NULL, 'Bunyavirus non-structural protein NS-S', NULL, 'Bunya_NS-S_2', NULL, NULL, 1618, 9),
(271104, NULL, 'PF18190', NULL, NULL, 'Polo-like Kinase 4 Polo Box 1', NULL, 'Plk4_PB1', NULL, NULL, 29785, 9),
(271105, NULL, 'PF20565', NULL, NULL, 'Probable metallopeptidase family (DUF6775)', NULL, 'DUF6775', NULL, NULL, 37015, 9);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(271106, NULL, 'PF05662', NULL, NULL, 'Coiled stalk of trimeric autotransporter adhesin', NULL, 'YadA_stalk', NULL, NULL, 14354, 9),
(271107, NULL, 'PF14195', NULL, NULL, 'Domain of unknown function (DUF4316)', NULL, 'DUF4316', NULL, NULL, 26317, 9),
(271108, NULL, 'PF07265', NULL, NULL, 'Tapetum specific protein TAP35/TAP44', NULL, 'TAP35_44', NULL, NULL, 14124, 9),
(271109, NULL, 'PF04220', NULL, NULL, 'Der GTPase activator (YihI)', NULL, 'YihI', NULL, NULL, 5444, 9),
(271110, NULL, 'PF09187', NULL, NULL, 'RNA-directed DNA methylation 1', NULL, 'RdDM_RDM1', NULL, NULL, 12410, 9),
(271111, NULL, 'PF16563', NULL, NULL, 'Coiled-coil and interaction region of P66A and P66B with MBD2', NULL, 'P66_CC', NULL, NULL, 26215, 9),
(271112, NULL, 'PF03129', NULL, NULL, 'Anticodon binding domain', NULL, 'HGTP_anticodon', NULL, NULL, 2642, 9),
(271113, NULL, 'PF18645', NULL, NULL, 'Family of unknown function (DUF5631)', NULL, 'DUF5631', NULL, NULL, 32427, 9),
(271114, NULL, 'PF16862', NULL, NULL, 'Glycosyl hydrolase family 79 C-terminal beta domain', NULL, 'Glyco_hydro_79C', NULL, NULL, 25673, 9),
(271115, NULL, 'PF08886', NULL, NULL, 'Glutamate-cysteine ligase', NULL, 'GshA', NULL, NULL, 10831, 9),
(271116, NULL, 'PF19777', NULL, NULL, 'Family of unknown function (DUF6263)', NULL, 'DUF6263', NULL, NULL, 37245, 9),
(271117, NULL, 'PF01949', NULL, NULL, 'Protein of unknown function DUF99', NULL, 'DUF99', NULL, NULL, 4738, 9),
(271118, NULL, 'PF07447', NULL, NULL, 'Matrix protein VP40', NULL, 'VP40', NULL, NULL, 9741, 9),
(271119, NULL, 'PF17110', NULL, NULL, 'Subunit 11 of the general transcription factor TFIIH', NULL, 'TFB6', NULL, NULL, 2643, 9),
(271120, NULL, 'PF01185', NULL, NULL, 'Fungal hydrophobin', NULL, 'Hydrophobin', NULL, NULL, 133, 9),
(271121, NULL, 'PF13607', NULL, NULL, 'Succinyl-CoA ligase like flavodoxin domain', NULL, 'Succ_CoA_lig', NULL, NULL, 24360, 9),
(271122, NULL, 'PF11061', NULL, NULL, 'Protein of unknown function (DUF2862)', NULL, 'DUF2862', NULL, NULL, 17959, 9),
(271123, NULL, 'PF19291', NULL, NULL, 'Trehalase-like, N-terminal', NULL, 'TREH_N', NULL, NULL, 37331, 9),
(271124, NULL, 'PF15919', NULL, NULL, 'HicB_like antitoxin of bacterial toxin-antitoxin system', NULL, 'HicB_lk_antitox', NULL, NULL, 21008, 9),
(271125, NULL, 'PF05041', NULL, NULL, 'Pecanex protein (C-terminus)', NULL, 'Pecanex_C', NULL, NULL, 1318, 9),
(271126, NULL, 'PF10104', NULL, NULL, 'Di-sulfide bridge nucleocytoplasmic transport domain', NULL, 'Brr6_like_C_C', NULL, NULL, 18064, 9),
(271127, NULL, 'PF14151', NULL, NULL, 'YfhD-like protein', NULL, 'YfhD', NULL, NULL, 26222, 9),
(271128, NULL, 'PF20249', NULL, NULL, 'VasX toxin N-terminal region', NULL, 'VasX_N', NULL, NULL, 34457, 9),
(271129, NULL, 'PF05354', NULL, NULL, 'Phage Head-Tail Attachment', NULL, 'Phage_attach', NULL, NULL, 5128, 9),
(271130, NULL, 'PF09339', NULL, NULL, 'IclR helix-turn-helix domain', NULL, 'HTH_IclR', NULL, NULL, 997, 9),
(271131, NULL, 'PF05775', NULL, NULL, 'Enterobacteria AfaD invasin protein', NULL, 'AfaD', NULL, NULL, 7765, 9),
(271132, NULL, 'PF13934', NULL, NULL, 'Nuclear pore complex assembly', NULL, 'ELYS', NULL, NULL, 26474, 9),
(271133, NULL, 'PF08577', NULL, NULL, 'PI31 proteasome regulator', NULL, 'PI31_Prot_C', NULL, NULL, 17657, 9),
(271134, NULL, 'PF07893', NULL, NULL, 'Protein of unknown function (DUF1668)', NULL, 'DUF1668', NULL, NULL, 12166, 9),
(271135, NULL, 'PF13725', NULL, NULL, 'Possible tRNA binding domain', NULL, 'tRNA_bind_2', NULL, NULL, 23623, 9),
(271136, NULL, 'PF05841', NULL, NULL, 'Apc15p protein', NULL, 'Apc15p', NULL, NULL, 8522, 9),
(271137, NULL, 'PF07913', NULL, NULL, 'Protein of unknown function (DUF1678)', NULL, 'DUF1678', NULL, NULL, 14067, 9),
(271138, NULL, 'PF11439', NULL, NULL, 'Type III secretion system filament chaperone CesA', NULL, 'T3SchapCesA', NULL, NULL, 18656, 9),
(271139, NULL, 'PF00482', NULL, NULL, 'Type II secretion system (T2SS), protein F', NULL, 'T2SSF', NULL, NULL, 13510, 9),
(271140, NULL, 'PF19421', NULL, NULL, 'Furry protein C-terminal', NULL, 'Fry_C', NULL, NULL, 36247, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(271141, NULL, 'PF09420', NULL, NULL, 'Ribosome biogenesis protein Nop16', NULL, 'Nop16', NULL, NULL, 15766, 9),
(271142, NULL, 'PF07023', NULL, NULL, 'Protein of unknown function (DUF1315)', NULL, 'DUF1315', NULL, NULL, 12492, 9),
(271143, NULL, 'PF14455', NULL, NULL, 'Predicted metal binding domain', NULL, 'Metal_CEHH', NULL, NULL, 25444, 9),
(271144, NULL, 'PF06039', NULL, NULL, 'Malate:quinone oxidoreductase (Mqo)', NULL, 'Mqo', NULL, NULL, 11342, 9),
(271145, NULL, 'PF01313', NULL, NULL, 'Bacterial export proteins, family 3', NULL, 'Bac_export_3', NULL, NULL, 5091, 9),
(271146, NULL, 'PF04149', NULL, NULL, 'Domain of unknown function (DUF397)', NULL, 'DUF397', NULL, NULL, 7359, 9),
(271147, NULL, 'PF07492', NULL, NULL, 'Neutral trehalase Ca2+ binding domain', NULL, 'Trehalase_Ca-bi', NULL, NULL, 11098, 9),
(271148, NULL, 'PF18722', NULL, NULL, 'MazG C-terminal domain', NULL, 'MazG_C', NULL, NULL, 29924, 9),
(271149, NULL, 'PF17157', NULL, NULL, 'Gammaproteobacterial periplasmic sensor domain', NULL, 'GAPES4', NULL, NULL, 31212, 9),
(271150, NULL, 'PF00565', NULL, NULL, 'Staphylococcal nuclease homologue', NULL, 'SNase', NULL, NULL, 10321, 9),
(271151, NULL, 'PF09356', NULL, NULL, 'Phage conserved hypothetical protein BR0599', NULL, 'Phage_BR0599', NULL, NULL, 14843, 9),
(271152, NULL, 'PF16866', NULL, NULL, 'PHD-finger', NULL, 'PHD_4', NULL, NULL, 14680, 9),
(271153, NULL, 'PF17618', NULL, NULL, 'Uncharacterized Strongylid L4 protein', NULL, 'SL4P', NULL, NULL, 28058, 9),
(271154, NULL, 'PF07153', NULL, NULL, 'Marek''s disease-like virus SORF3 protein', NULL, 'Marek_SORF3', NULL, NULL, 13220, 9),
(271155, NULL, 'PF05744', NULL, NULL, 'Benyvirus P25/P26 protein', NULL, 'Benyvirus_P25', NULL, NULL, 8587, 9),
(271156, NULL, 'PF13959', NULL, NULL, 'Domain of unknown function (DUF4217)', NULL, 'DUF4217', NULL, NULL, 22088, 9),
(271157, NULL, 'PF16966', NULL, NULL, 'Porin-like glycoporin RafY', NULL, 'Porin_8', NULL, NULL, 17876, 9),
(271158, NULL, 'PF04667', NULL, NULL, 'cAMP-regulated phosphoprotein/endosulfine conserved region', NULL, 'Endosulfine', NULL, NULL, 3229, 9),
(271159, NULL, 'PF08250', NULL, NULL, 'Sperm-activating peptides', NULL, 'Sperm_act_pep', NULL, NULL, 13468, 9),
(271160, NULL, 'PF14085', NULL, NULL, 'Domain of unknown function (DUF4265)', NULL, 'DUF4265', NULL, NULL, 22949, 9),
(271161, NULL, 'PF19060', NULL, NULL, 'DVNP family', NULL, 'DVNP', NULL, NULL, 35335, 9),
(271162, NULL, 'PF02253', NULL, NULL, 'Phospholipase A1', NULL, 'PLA1', NULL, NULL, 3435, 9),
(271163, NULL, 'PF00657', NULL, NULL, 'GDSL-like Lipase/Acylhydrolase', NULL, 'Lipase_GDSL', NULL, NULL, 4121, 9),
(271164, NULL, 'PF03892', NULL, NULL, 'Nitrate reductase cytochrome c-type subunit (NapB)', NULL, 'NapB', NULL, NULL, 2779, 9),
(271165, NULL, 'PF15087', NULL, NULL, 'Protein of unknown function (DUF4551)', NULL, 'DUF4551', NULL, NULL, 23873, 9),
(271166, NULL, 'PF04519', NULL, NULL, 'Polymer-forming cytoskeletal', NULL, 'Bactofilin', NULL, NULL, 2537, 9),
(271167, NULL, 'PF10146', NULL, NULL, 'Zinc finger-containing protein', NULL, 'zf-C4H2', NULL, NULL, 9422, 9),
(271168, NULL, 'PF10844', NULL, NULL, 'Protein of unknown function (DUF2577)', NULL, 'DUF2577', NULL, NULL, 14646, 9),
(271169, NULL, 'PF16410', NULL, NULL, 'Domain of unknown function (DUF5018)', NULL, 'DUF5018', NULL, NULL, 23515, 9),
(271170, NULL, 'PF19769', NULL, NULL, 'CPxCG-related zinc finger', NULL, 'CPxCG_zf', NULL, NULL, 11159, 9),
(271171, NULL, 'PF20066', NULL, NULL, 'Glyoxalase superfamily protein', NULL, 'Glyoxalase_8', NULL, NULL, 37290, 9),
(271172, NULL, 'PF16930', NULL, NULL, 'Putative porin', NULL, 'Porin_5', NULL, NULL, 21957, 9),
(271173, NULL, 'PF00097', NULL, NULL, 'Zinc finger, C3HC4 type (RING finger)', NULL, 'zf-C3HC4', NULL, NULL, 14618, 9),
(271174, NULL, 'PF03763', NULL, NULL, 'Remorin, C-terminal region', NULL, 'Remorin_C', NULL, NULL, 1577, 9),
(271175, NULL, 'PF03791', NULL, NULL, 'KNOX2 domain', NULL, 'KNOX2', NULL, NULL, 1937, 9),
(271176, NULL, 'PF01432', NULL, NULL, 'Peptidase family M3', NULL, 'Peptidase_M3', NULL, NULL, 3178, 9);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(271177, NULL, 'PF06113', NULL, NULL, 'Brain and reproductive organ-expressed protein (BRE)', NULL, 'BRE', NULL, NULL, 8877, 9),
(271178, NULL, 'PF07451', NULL, NULL, 'Stage V sporulation protein AD (SpoVAD)', NULL, 'SpoVAD', NULL, NULL, 12125, 9),
(271179, NULL, 'PF09968', NULL, NULL, 'Uncharacterized protein domain (DUF2202)', NULL, 'DUF2202', NULL, NULL, 19575, 9),
(271180, NULL, 'PF08192', NULL, NULL, 'Peptidase family S64', NULL, 'Peptidase_S64', NULL, NULL, 12216, 9),
(271181, NULL, 'PF05396', NULL, NULL, 'Phage T7 capsid assembly protein', NULL, 'Phage_T7_Capsid', NULL, NULL, 12384, 9),
(271182, NULL, 'PF15784', NULL, NULL, 'G-protein pathway suppressor 2-interacting domain', NULL, 'GPS2_interact', NULL, NULL, 23545, 9),
(271183, NULL, 'PF06550', NULL, NULL, 'Signal-peptide peptidase, presenilin aspartyl protease', NULL, 'SPP', NULL, NULL, 14304, 9),
(271184, NULL, 'PF03187', NULL, NULL, 'Corona nucleocapsid I protein', NULL, 'Corona_I', NULL, NULL, 7409, 9),
(271185, NULL, 'PF18171', NULL, NULL, 'SLOG in TRPM, prokaryote', NULL, 'LSDAT_prok', NULL, NULL, 29067, 9),
(271186, NULL, 'PF10664', NULL, NULL, 'Cyanobacterial and plastid NDH-1 subunit M', NULL, 'NdhM', NULL, NULL, 14831, 9),
(271187, NULL, 'PF08436', NULL, NULL, '1-deoxy-D-xylulose 5-phosphate reductoisomerase C-terminal domain', NULL, 'DXP_redisom_C', NULL, NULL, 12553, 9),
(271188, NULL, 'PF10082', NULL, NULL, 'Putative beta-barrel porin 2', NULL, 'BBP2_2', NULL, NULL, 18062, 9),
(271189, NULL, 'PF07280', NULL, NULL, 'Per os infectivity factor AC110', NULL, 'Ac110_PIF', NULL, NULL, 14298, 9),
(271190, NULL, 'PF11162', NULL, NULL, 'Protein of unknown function (DUF2946)', NULL, 'DUF2946', NULL, NULL, 17554, 9),
(271191, NULL, 'PF02237', NULL, NULL, 'Biotin protein ligase C terminal domain', NULL, 'BPL_C', NULL, NULL, 2949, 9),
(271192, NULL, 'PF05415', NULL, NULL, 'Beet necrotic yellow vein furovirus-type papain-like endopeptidase', NULL, 'Peptidase_C36', NULL, NULL, 12106, 9),
(271193, NULL, 'PF05449', NULL, NULL, 'Putative 3TM holin, Phage_holin_3', NULL, 'Phage_holin_3_7', NULL, NULL, 12425, 9),
(271194, NULL, 'PF19147', NULL, NULL, 'Family of unknown function (DUF5829)', NULL, 'DUF5829', NULL, NULL, 34362, 9),
(271195, NULL, 'PF06189', NULL, NULL, '5''-nucleotidase', NULL, '5-nucleotidase', NULL, NULL, 9266, 9),
(271196, NULL, 'PF09305', NULL, NULL, 'TACI, cysteine-rich domain', NULL, 'TACI-CRD2', NULL, NULL, 14334, 9),
(271197, NULL, 'PF13329', NULL, NULL, 'Autophagy-related protein 2 CAD motif', NULL, 'ATG2_CAD', NULL, NULL, 26770, 9),
(271198, NULL, 'PF17009', NULL, NULL, 'Domain of unknown function (DUF5090)', NULL, 'DUF5090', NULL, NULL, 22103, 9),
(271199, NULL, 'PF18806', NULL, NULL, 'Importin 13 repeat', NULL, 'Importin_rep_3', NULL, NULL, 31903, 9),
(271200, NULL, 'PF00144', NULL, NULL, 'Beta-lactamase', NULL, 'Beta-lactamase', NULL, NULL, 3046, 9),
(271201, NULL, 'PF02951', NULL, NULL, 'Prokaryotic glutathione synthetase, N-terminal domain', NULL, 'GSH-S_N', NULL, NULL, 3539, 9),
(271202, NULL, 'PF19866', NULL, NULL, 'Family of unknown function (DUF6339)', NULL, 'DUF6339', NULL, NULL, 36782, 9),
(271203, NULL, 'PF03260', NULL, NULL, 'Lepidopteran low molecular weight (30 kD) lipoprotein', NULL, 'Lipoprotein_11', NULL, NULL, 1613, 9),
(271204, NULL, 'PF17484', NULL, NULL, 'N-Lobe handle Tf-binding protein B', NULL, 'TbpB_A', NULL, NULL, 15666, 9),
(271205, NULL, 'PF12011', NULL, NULL, 'RNA helicase NPH-II', NULL, 'NPH-II', NULL, NULL, 19523, 9),
(271206, NULL, 'PF18381', NULL, NULL, 'YcaO cyclodehydratase C-terminal domain', NULL, 'YcaO_C', NULL, NULL, 28855, 9),
(271207, NULL, 'PF15012', NULL, NULL, 'Domain of unknown function (DUF4519)', NULL, 'DUF4519', NULL, NULL, 24203, 9),
(271208, NULL, 'PF13890', NULL, NULL, 'Rab3 GTPase-activating protein catalytic subunit', NULL, 'Rab3-GTPase_cat', NULL, NULL, 22524, 9),
(271209, NULL, 'PF02966', NULL, NULL, 'Mitosis protein DIM1', NULL, 'DIM1', NULL, NULL, 1589, 9),
(271210, NULL, 'PF02738', NULL, NULL, 'Molybdopterin cofactor-binding domain', NULL, 'MoCoBD_1', NULL, NULL, 6467, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(271211, NULL, 'PF05075', NULL, NULL, 'Protein of unknown function (DUF684)', NULL, 'DUF684', NULL, NULL, 1051, 9),
(271212, NULL, 'PF07921', NULL, NULL, 'Fibritin C-terminal region', NULL, 'Fibritin_C', NULL, NULL, 14321, 9),
(271213, NULL, 'PF17044', NULL, NULL, 'Borrelial persistence in ticks protein A', NULL, 'BPTA', NULL, NULL, 26774, 9),
(271214, NULL, 'PF20069', NULL, NULL, 'Family of unknown function (DUF6465)', NULL, 'DUF6465', NULL, NULL, 37633, 9),
(271215, NULL, 'PF12049', NULL, NULL, 'Protein of unknown function (DUF3531)', NULL, 'DUF3531', NULL, NULL, 19793, 9),
(271216, NULL, 'PF07117', NULL, NULL, 'Protein of unknown function (DUF1373)', NULL, 'DUF1373', NULL, NULL, 13413, 9),
(271217, NULL, 'PF15252', NULL, NULL, 'Domain of unknown function (DUF4589)', NULL, 'DUF4589', NULL, NULL, 24931, 9),
(271218, NULL, 'PF03522', NULL, NULL, 'Solute carrier family 12', NULL, 'SLC12', NULL, NULL, 14522, 9),
(271219, NULL, 'PF20505', NULL, NULL, 'Family of unknown function (DUF6731)', NULL, 'DUF6731', NULL, NULL, 33819, 9),
(271220, NULL, 'PF04288', NULL, NULL, 'MukE-like family', NULL, 'MukE', NULL, NULL, 6423, 9),
(271221, NULL, 'PF07386', NULL, NULL, 'Protein of unknown function (DUF1499)', NULL, 'DUF1499', NULL, NULL, 11706, 9),
(271222, NULL, 'PF19021', NULL, NULL, 'CRISPR system CMR subunit Cmr7 1', NULL, 'Cmr7A', NULL, NULL, 35504, 9),
(271223, NULL, 'PF18729', NULL, NULL, 'STY4199-like HEPN', NULL, 'HEPN_STY4199', NULL, NULL, 29019, 9),
(271224, NULL, 'PF19548', NULL, NULL, 'Chordin-like protein 1/2 C-terminal', NULL, 'CHRDL_1_2_C', NULL, NULL, 36366, 9),
(271225, NULL, 'PF09388', NULL, NULL, 'Spo0E like sporulation regulatory protein', NULL, 'SpoOE-like', NULL, NULL, 14633, 9),
(271226, NULL, 'PF16839', NULL, NULL, 'Nematode antimicrobial peptide', NULL, 'Antimicrobial25', NULL, NULL, 24162, 9),
(271227, NULL, 'PF00085', NULL, NULL, 'Thioredoxin', NULL, 'Thioredoxin', NULL, NULL, 10764, 9),
(271228, NULL, 'PF12484', NULL, NULL, 'PPE-SVP subfamily C-terminal region', NULL, 'PPE-SVP', NULL, NULL, 20952, 9),
(271229, NULL, 'PF02841', NULL, NULL, 'Guanylate-binding protein, C-terminal domain', NULL, 'GBP_C', NULL, NULL, 1538, 9),
(271230, NULL, 'PF02272', NULL, NULL, 'DHHA1 domain', NULL, 'DHHA1', NULL, NULL, 1569, 9),
(271231, NULL, 'PF03523', NULL, NULL, 'Macrophage scavenger receptor', NULL, 'Macscav_rec', NULL, NULL, 7487, 9),
(271232, NULL, 'PF20549', NULL, NULL, 'Family of unknown function (DUF6763)', NULL, 'DUF6763', NULL, NULL, 33650, 9),
(271233, NULL, 'PF20084', NULL, NULL, 'Conjugative transfer region protein TrbK', NULL, 'TrbK', NULL, NULL, 23059, 9),
(271234, NULL, 'PF16069', NULL, NULL, 'Domain of unknown function (DUF4811)', NULL, 'DUF4811', NULL, NULL, 24038, 9),
(271235, NULL, 'PF02010', NULL, NULL, 'REJ domain', NULL, 'REJ', NULL, NULL, 5974, 9),
(271236, NULL, 'PF10981', NULL, NULL, 'Protein of unknown function (DUF2788)', NULL, 'DUF2788', NULL, NULL, 17525, 9),
(271237, NULL, 'PF06790', NULL, NULL, 'Uncharacterised protein family (UPF0259)', NULL, 'UPF0259', NULL, NULL, NULL, 9),
(271238, NULL, 'PF18245', NULL, NULL, '5-3 exonuclease XRN1 DCP1-binding motif', NULL, 'XRN1_DBM', NULL, NULL, 27967, 9),
(271239, NULL, 'PF05989', NULL, NULL, 'Chordopoxvirus A35R protein', NULL, 'Chordopox_A35R', NULL, NULL, 13605, 9),
(271240, NULL, 'PF11291', NULL, NULL, 'Protein of unknown function (DUF3091)', NULL, 'DUF3091', NULL, NULL, 18368, 9),
(271241, NULL, 'PF12319', NULL, NULL, 'Tryptophan-Threonine-rich plasmodium antigen C terminal', NULL, 'TryThrA_C', NULL, NULL, 20572, 9),
(271242, NULL, 'PF04555', NULL, NULL, 'Restriction endonuclease XhoI', NULL, 'XhoI', NULL, NULL, 2303, 9),
(271243, NULL, 'PF02645', NULL, NULL, 'Uncharacterised protein, DegV family COG1307', NULL, 'DegV', NULL, NULL, 6042, 9),
(271244, NULL, 'PF05118', NULL, NULL, 'Aspartyl/Asparaginyl beta-hydroxylase', NULL, 'Asp_Arg_Hydrox', NULL, NULL, 2229, 9),
(271245, NULL, 'PF08659', NULL, NULL, 'KR domain', NULL, 'KR', NULL, NULL, 7836, 9),
(271246, NULL, 'PF18104', NULL, NULL, 'Jumonji domain-containing protein 2A Tudor domain', NULL, 'Tudor_2', NULL, NULL, 27894, 9);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(271247, NULL, 'PF02397', NULL, NULL, 'Bacterial sugar transferase', NULL, 'Bac_transf', NULL, NULL, 4271, 9),
(271248, NULL, 'PF13069', NULL, NULL, 'Protein of unknown function (DUF3933)', NULL, 'DUF3933', NULL, NULL, 21451, 9),
(271249, NULL, 'PF14964', NULL, NULL, 'Domain of unknown function (DUF4507)', NULL, 'DUF4507', NULL, NULL, 26111, 9),
(271250, NULL, 'PF18950', NULL, NULL, 'Family of unknown function (DUF5694)', NULL, 'DUF5694', NULL, NULL, 34128, 9),
(271251, NULL, 'PF19997', NULL, NULL, 'vWA domain found in the FtsH ternary systems', NULL, 'ivWA', NULL, NULL, 34744, 9),
(271252, NULL, 'PF01122', NULL, NULL, 'Eukaryotic cobalamin-binding protein', NULL, 'Cobalamin_bind', NULL, NULL, 465, 9),
(271253, NULL, 'PF13133', NULL, NULL, 'Protein of unknown function (DUF3949)', NULL, 'DUF3949', NULL, NULL, 25539, 9),
(271254, NULL, 'PF09518', NULL, NULL, 'HindIII restriction endonuclease', NULL, 'RE_HindIII', NULL, NULL, 16684, 9),
(271255, NULL, 'PF08491', NULL, NULL, 'Squalene epoxidase', NULL, 'SE', NULL, NULL, 13672, 9),
(271256, NULL, 'PF12675', NULL, NULL, 'Protein of unknown function (DUF3795)', NULL, 'DUF3795', NULL, NULL, 13131, 9),
(271257, NULL, 'PF04202', NULL, NULL, 'Foot protein 3', NULL, 'Mfp-3', NULL, NULL, 5042, 9),
(271258, NULL, 'PF04862', NULL, NULL, 'Protein of unknown function (DUF642)', NULL, 'DUF642', NULL, NULL, 5920, 9),
(271259, NULL, 'PF07659', NULL, NULL, 'Nucleotide modification associated domain 1', NULL, 'DUF1599', NULL, NULL, 10528, 9),
(271260, NULL, 'PF00459', NULL, NULL, 'Inositol monophosphatase family', NULL, 'Inositol_P', NULL, NULL, 3642, 9),
(271261, NULL, 'PF10850', NULL, NULL, 'Protein of unknown function (DUF2653)', NULL, 'DUF2653', NULL, NULL, 19026, 9),
(271262, NULL, 'PF01993', NULL, NULL, 'methylene-5,6,7,8-tetrahydromethanopterin dehydrogenase', NULL, 'MTD', NULL, NULL, 5526, 9),
(271263, NULL, 'PF03823', NULL, NULL, 'Neurokinin B', NULL, 'Neurokinin_B', NULL, NULL, 1222, 9),
(271264, NULL, 'PF14740', NULL, NULL, 'Domain of unknown function (DUF4471)', NULL, 'DUF4471', NULL, NULL, 22788, 9),
(271265, NULL, 'PF11775', NULL, NULL, 'Cobalamin biosynthesis protein CobT VWA domain', NULL, 'CobT_C', NULL, NULL, 25831, 9),
(271266, NULL, 'PF03340', NULL, NULL, 'Poxvirus rifampicin resistance protein', NULL, 'Pox_Rif', NULL, NULL, 716, 9),
(271267, NULL, 'PF06717', NULL, NULL, 'Protein of unknown function (DUF1202)', NULL, 'DUF1202', NULL, NULL, 1821, 9),
(271268, NULL, 'PF15694', NULL, NULL, 'Mediator complex subunit 26 middle domain', NULL, 'Med26_M', NULL, NULL, 25633, 9),
(271269, NULL, 'PF06292', NULL, NULL, 'MUN domain', NULL, 'MUN', NULL, NULL, 10480, 9),
(271270, NULL, 'PF20486', NULL, NULL, 'Family of unknown function (DUF6725)', NULL, 'DUF6725', NULL, NULL, 33857, 9),
(271271, NULL, 'PF05088', NULL, NULL, 'Bacterial NAD-glutamate dehydrogenase', NULL, 'Bac_GDH', NULL, NULL, 26673, 9),
(271272, NULL, 'PF19752', NULL, NULL, 'Family of unknown function (DUF6239)', NULL, 'DUF6239', NULL, NULL, 37213, 9),
(271273, NULL, 'PF10390', NULL, NULL, 'RNA polymerase II elongation factor ELL', NULL, 'ELL', NULL, NULL, 17096, 9),
(271274, NULL, 'PF00060', NULL, NULL, 'Ligand-gated ion channel', NULL, 'Lig_chan', NULL, NULL, 116, 9),
(271275, NULL, 'PF01644', NULL, NULL, 'Chitin synthase', NULL, 'Chitin_synth_1', NULL, NULL, 4454, 9),
(271276, NULL, 'PF03192', NULL, NULL, 'Pyrococcus protein of unknown function, DUF257', NULL, 'DUF257', NULL, NULL, 840, 9),
(271277, NULL, 'PF06226', NULL, NULL, 'Protein of unknown function (DUF1007)', NULL, 'DUF1007', NULL, NULL, 9239, 9),
(271278, NULL, 'PF16192', NULL, NULL, 'C-terminal four TMM region of protein-O-mannosyltransferase', NULL, 'PMT_4TMC', NULL, NULL, 25229, 9),
(271279, NULL, 'PF01409', NULL, NULL, 'tRNA synthetases class II core domain (F)', NULL, 'tRNA-synt_2d', NULL, NULL, 6105, 9),
(271280, NULL, 'PF11641', NULL, NULL, 'Glycosylphosphatidylinositol-anchored merozoite surface protein', NULL, 'Antigen_Bd37', NULL, NULL, 18844, 9),
(271281, NULL, 'PF00572', NULL, NULL, 'Ribosomal protein L13', NULL, 'Ribosomal_L13', NULL, NULL, 5885, 9);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(271282, NULL, 'PF16327', NULL, NULL, 'Cytochrome c-type biogenesis protein CcmF C-terminal', NULL, 'CcmF_C', NULL, NULL, 25140, 9),
(271283, NULL, 'PF11984', NULL, NULL, 'Protein of unknown function (DUF3485)', NULL, 'DUF3485', NULL, NULL, 11462, 9),
(271284, NULL, 'PF00942', NULL, NULL, 'Cellulose binding domain', NULL, 'CBM_3', NULL, NULL, 4062, 9),
(271285, NULL, 'PF07907', NULL, NULL, 'YibE/F-like protein', NULL, 'YibE_F', NULL, NULL, 12614, 9),
(271286, NULL, 'PF05844', NULL, NULL, 'YopD protein', NULL, 'YopD', NULL, NULL, 7912, 9),
(271287, NULL, 'PF00664', NULL, NULL, 'ABC transporter transmembrane region', NULL, 'ABC_membrane', NULL, NULL, 12367, 9),
(271288, NULL, 'PF13463', NULL, NULL, 'Winged helix DNA-binding domain', NULL, 'HTH_27', NULL, NULL, 4925, 9),
(271289, NULL, 'PF14377', NULL, NULL, 'Ubiquitin binding region', NULL, 'UBM', NULL, NULL, 26385, 9),
(271290, NULL, 'PF06535', NULL, NULL, 'Repulsive guidance molecule (RGM) N-terminus', NULL, 'RGM_N', NULL, NULL, 14194, 9),
(271291, NULL, 'PF05060', NULL, NULL, 'N-acetylglucosaminyltransferase II (MGAT2)', NULL, 'MGAT2', NULL, NULL, 1145, 9),
(271292, NULL, 'PF08908', NULL, NULL, 'Putative oxygenase MesX', NULL, 'MesX', NULL, NULL, 7692, 9),
(271293, NULL, 'PF03118', NULL, NULL, 'Bacterial RNA polymerase, alpha chain C terminal domain', NULL, 'RNA_pol_A_CTD', NULL, NULL, 9905, 9),
(271294, NULL, 'PF08177', NULL, NULL, 'Small acid-soluble spore protein N family', NULL, 'SspN', NULL, NULL, 9769, 9),
(271295, NULL, 'PF15412', NULL, NULL, 'Binding domain of Nse4/EID3 to Nse3-MAGE', NULL, 'Nse4-Nse3_bdg', NULL, NULL, 23052, 9),
(271296, NULL, 'PF07874', NULL, NULL, 'Prophage protein (DUF1660)', NULL, 'DUF1660', NULL, NULL, 14107, 9),
(271297, NULL, 'PF04589', NULL, NULL, 'RFX1 transcription activation region', NULL, 'RFX1_trans_act', NULL, NULL, 272, 9),
(271298, NULL, 'PF18913', NULL, NULL, 'Fructose-1-6-bisphosphatase, C-terminal domain', NULL, 'FBPase_C', NULL, NULL, 37555, 9),
(271299, NULL, 'PF03145', NULL, NULL, 'Seven in absentia protein family', NULL, 'Sina', NULL, NULL, 13593, 9),
(271300, NULL, 'PF14352', NULL, NULL, 'Domain of unknown function (DUF4402)', NULL, 'DUF4402', NULL, NULL, 26370, 9),
(271301, NULL, 'PF17629', NULL, NULL, 'Family of unknown function (DUF5510)', NULL, 'DUF5510', NULL, NULL, 8196, 9),
(271302, NULL, 'PF16394', NULL, NULL, 'Domain of unknown function (DUF5003)', NULL, 'DUF5003', NULL, NULL, 26352, 9),
(271303, NULL, 'PF17367', NULL, NULL, 'NiFe-hydrogenase-type-3 Eha complex subunit A', NULL, 'NiFe_hyd_3_EhaA', NULL, NULL, 10275, 9),
(271304, NULL, 'PF02641', NULL, NULL, 'Uncharacterized ACR, COG1993', NULL, 'DUF190', NULL, NULL, 3156, 9),
(271305, NULL, 'PF19349', NULL, NULL, 'Family of unknown function (DUF5927)', NULL, 'DUF5927', NULL, NULL, 36516, 9),
(271306, NULL, 'PF06320', NULL, NULL, 'GCN5-like protein 1 (GCN5L1)', NULL, 'GCN5L1', NULL, NULL, 8087, 9),
(271307, NULL, 'PF09300', NULL, NULL, 'Tectiviridae, minor capsid', NULL, 'Tecti-min-caps', NULL, NULL, 14045, 9),
(271308, NULL, 'PF10706', NULL, NULL, 'Aminoglycoside-2''''-adenylyltransferase', NULL, 'Aminoglyc_resit', NULL, NULL, 20508, 9),
(271309, NULL, 'PF12135', NULL, NULL, 'Plasmodium repeat family', NULL, 'Plasmo_rep', NULL, NULL, 20071, 9),
(271310, NULL, 'PF09418', NULL, NULL, 'Protein of unknown function (DUF2009)', NULL, 'DUF2009', NULL, NULL, 15445, 9),
(271311, NULL, 'PF02684', NULL, NULL, 'Lipid-A-disaccharide synthetase', NULL, 'LpxB', NULL, NULL, 3160, 9),
(271312, NULL, 'PF19914', NULL, NULL, 'Wolframin EF-hand domain', NULL, 'WEF-hand', NULL, NULL, 36350, 9),
(271313, NULL, 'PF03373', NULL, NULL, 'Octapeptide repeat', NULL, 'Octapeptide', NULL, NULL, 2053, 9),
(271314, NULL, 'PF17444', NULL, NULL, 'Uncharacterized YhdX-like', NULL, 'YhdX', NULL, NULL, 27625, 9),
(271315, NULL, 'PF06438', NULL, NULL, 'Heme-binding protein A (HasA)', NULL, 'HasA', NULL, NULL, 10157, 9),
(271316, NULL, 'PF03778', NULL, NULL, 'Protein of unknown function (DUF321)', NULL, 'DUF321', NULL, NULL, 1632, 9),
(271317, NULL, 'PF00291', NULL, NULL, 'Pyridoxal-phosphate dependent enzyme', NULL, 'PALP', NULL, NULL, 4355, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(271318, NULL, 'PF05152', NULL, NULL, 'Protein of unknown function (DUF705)', NULL, 'DUF705', NULL, NULL, 2152, 9),
(271319, NULL, 'PF18963', NULL, NULL, 'Family of unknown function (DUF5703)', NULL, 'DUF5703', NULL, NULL, 34853, 9),
(271320, NULL, 'PF17707', NULL, NULL, 'Family of unknown function (DUF5553)', NULL, 'DUF5553', NULL, NULL, 32676, 9),
(271321, NULL, 'PF03899', NULL, NULL, 'ATP synthase I chain', NULL, 'ATP-synt_I', NULL, NULL, 2833, 9),
(271322, NULL, 'PF08694', NULL, NULL, 'Ubiquitin-fold modifier-conjugating enzyme 1', NULL, 'UFC1', NULL, NULL, 11952, 9),
(271323, NULL, 'PF17398', NULL, NULL, 'Nodulation protein NolB', NULL, 'NolB', NULL, NULL, 15236, 9),
(271324, NULL, 'PF11067', NULL, NULL, 'Protein of unknown function (DUF2868)', NULL, 'DUF2868', NULL, NULL, 17811, 9),
(271325, NULL, 'PF03678', NULL, NULL, 'Hexon, adenovirus major coat protein, C-terminal domain', NULL, 'Adeno_hexon_C', NULL, NULL, 11231, 9),
(271326, NULL, 'PF01309', NULL, NULL, 'Equine arteritis virus small envelope glycoprotein', NULL, 'EAV_GS', NULL, NULL, 4432, 9),
(271327, NULL, 'PF04074', NULL, NULL, 'YhcH/YjgK/YiaL', NULL, 'DUF386', NULL, NULL, 5090, 9),
(271328, NULL, 'PF16794', NULL, NULL, 'Fibronectin-III type domain', NULL, 'fn3_4', NULL, NULL, 7389, 9),
(271329, NULL, 'PF17259', NULL, NULL, 'Family of unknown function (DUF5325)', NULL, 'DUF5325', NULL, NULL, 18334, 9),
(271330, NULL, 'PF07103', NULL, NULL, 'Protein of unknown function (DUF1365)', NULL, 'DUF1365', NULL, NULL, 10730, 9),
(271331, NULL, 'PF05404', NULL, NULL, 'Translocon-associated protein, delta subunit precursor (TRAP-delta)', NULL, 'TRAP-delta', NULL, NULL, 13807, 9),
(271332, NULL, 'PF08726', NULL, NULL, 'Ca2+ insensitive EF hand', NULL, 'EFhand_Ca_insen', NULL, NULL, 11667, 9),
(271333, NULL, 'PF06255', NULL, NULL, 'Neisseria toxin MafB', NULL, 'MafB', NULL, NULL, 6498, 9),
(271334, NULL, 'PF11518', NULL, NULL, 'Protein of unknown function (DUF3221)', NULL, 'DUF3221', NULL, NULL, 18523, 9),
(271335, NULL, 'PF01075', NULL, NULL, 'Glycosyltransferase family 9 (heptosyltransferase)', NULL, 'Glyco_transf_9', NULL, NULL, 336, 9),
(271336, NULL, 'PF15442', NULL, NULL, 'Domain of unknown function (DUF4629)', NULL, 'DUF4629', NULL, NULL, 24452, 9),
(271337, NULL, 'PF06312', NULL, NULL, 'Neurexophilin', NULL, 'Neurexophilin', NULL, NULL, 24840, 9),
(271338, NULL, 'PF17176', NULL, NULL, 'tRNA-binding domain', NULL, 'tRNA_bind_3', NULL, NULL, 29494, 9),
(271339, NULL, 'PF18476', NULL, NULL, 'PIN like domain', NULL, 'PIN_8', NULL, NULL, 30023, 9),
(271340, NULL, 'PF16033', NULL, NULL, 'Domain of unknown function (DUF4789)', NULL, 'DUF4789', NULL, NULL, 22999, 9),
(271341, NULL, 'PF00566', NULL, NULL, 'Rab-GTPase-TBC domain', NULL, 'RabGAP-TBC', NULL, NULL, 1351, 9),
(271342, NULL, 'PF06912', NULL, NULL, 'Protein of unknown function (DUF1275)', NULL, 'DUF1275', NULL, NULL, 9667, 9),
(271343, NULL, 'PF03806', NULL, NULL, 'AbgT putative transporter family', NULL, 'ABG_transport', NULL, NULL, 3219, 9),
(271344, NULL, 'PF14295', NULL, NULL, 'PAN domain', NULL, 'PAN_4', NULL, NULL, 843, 9),
(271345, NULL, 'PF01754', NULL, NULL, 'A20-like zinc finger', NULL, 'zf-A20', NULL, NULL, 2964, 9),
(271346, NULL, 'PF01965', NULL, NULL, 'DJ-1/PfpI family', NULL, 'DJ-1_PfpI', NULL, NULL, 4336, 9),
(271347, NULL, 'PF14150', NULL, NULL, 'YesK-like protein', NULL, 'YesK', NULL, NULL, 26421, 9),
(271348, NULL, 'PF20595', NULL, NULL, 'Putative adhesive domain (group 6)', NULL, 'pAdhesive_6', NULL, NULL, 33899, 9),
(271349, NULL, 'PF16005', NULL, NULL, 'KH-like RNA-binding domain', NULL, 'MOEP19', NULL, NULL, 26705, 9),
(271350, NULL, 'PF19374', NULL, NULL, 'Family of unknown function (DUF5949)', NULL, 'DUF5949', NULL, NULL, 36778, 9),
(271351, NULL, 'PF19737', NULL, NULL, 'Fukutin N-terminal', NULL, 'FKTN_N', NULL, NULL, 36317, 9),
(271352, NULL, 'PF03914', NULL, NULL, 'CBF/Mak21 family', NULL, 'CBF', NULL, NULL, 2871, 9),
(271353, NULL, 'PF14078', NULL, NULL, 'Domain of unknown function (DUF4259)', NULL, 'DUF4259', NULL, NULL, 22679, 9),
(271354, NULL, 'PF18764', NULL, NULL, 'Nitrous oxide reductase propeller repeat', NULL, 'nos_propeller', NULL, NULL, 28989, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(271355, NULL, 'PF01717', NULL, NULL, 'Cobalamin-independent synthase, Catalytic domain', NULL, 'Meth_synt_2', NULL, NULL, 2818, 9),
(271356, NULL, 'PF00904', NULL, NULL, 'Involucrin repeat', NULL, 'Involucrin', NULL, NULL, 279, 9),
(271357, NULL, 'PF08989', NULL, NULL, 'Domain of unknown function (DUF1896)', NULL, 'DUF1896', NULL, NULL, 8521, 9),
(271358, NULL, 'PF05798', NULL, NULL, 'Bacteriophage FRD3 protein', NULL, 'Phage_FRD3', NULL, NULL, 12170, 9),
(271359, NULL, 'PF06454', NULL, NULL, 'THH1/TOM1/TOM3 domain', NULL, 'THH1_TOM1-3_dom', NULL, NULL, 9467, 9),
(271360, NULL, 'PF18987', NULL, NULL, 'Family of unknown function (DUF5720)', NULL, 'DUF5720', NULL, NULL, 36446, 9),
(271361, NULL, 'PF01216', NULL, NULL, 'Calsequestrin', NULL, 'Calsequestrin', NULL, NULL, 6611, 9),
(271362, NULL, 'PF09538', NULL, NULL, 'Protein of unknown function (FYDLN_acid)', NULL, 'FYDLN_acid', NULL, NULL, 10001, 9),
(271363, NULL, 'PF16681', NULL, NULL, 'Ig-like domain on T-cell surface glycoprotein CD3 epsilon chain', NULL, 'Ig_5', NULL, NULL, NULL, 9),
(271364, NULL, 'PF13600', NULL, NULL, 'N-terminal domain of unknown function (DUF4140)', NULL, 'DUF4140', NULL, NULL, 23332, 9),
(271365, NULL, 'PF07378', NULL, NULL, 'Flagellar protein FlbT', NULL, 'FlbT', NULL, NULL, 8159, 9),
(271366, NULL, 'PF08990', NULL, NULL, 'Erythronolide synthase docking domain', NULL, 'Docking', NULL, NULL, 8727, 9),
(271367, NULL, 'PF15048', NULL, NULL, 'Organic solute transporter subunit beta protein', NULL, 'OSTbeta', NULL, NULL, 26490, 9),
(271368, NULL, 'PF01912', NULL, NULL, 'eIF-6 family', NULL, 'eIF-6', NULL, NULL, 4654, 9),
(271369, NULL, 'PF09851', NULL, NULL, 'Short C-terminal domain', NULL, 'SHOCT', NULL, NULL, 16680, 9),
(271370, NULL, 'PF15699', NULL, NULL, 'NPR1 interacting', NULL, 'NPR1_interact', NULL, NULL, 26286, 9),
(271371, NULL, 'PF20456', NULL, NULL, 'Family of unknown function (DUF6709)', NULL, 'DUF6709', NULL, NULL, 37620, 9),
(271372, NULL, 'PF01998', NULL, NULL, 'Protein of unknown function DUF131', NULL, 'DUF131', NULL, NULL, 5729, 9),
(271373, NULL, 'PF08667', NULL, NULL, 'BetR domain', NULL, 'BetR', NULL, NULL, 8000, 9),
(271374, NULL, 'PF06348', NULL, NULL, 'Protein of unknown function (DUF1059)', NULL, 'DUF1059', NULL, NULL, 8032, 9),
(271375, NULL, 'PF03589', NULL, NULL, 'Antitermination protein', NULL, 'Antiterm', NULL, NULL, 2985, 9),
(271376, NULL, 'PF20157', NULL, NULL, 'Glycosyltransferase Maf N-terminal domain', NULL, 'Maf_flag10_N', NULL, NULL, 36119, 9),
(271377, NULL, 'PF18965', NULL, NULL, 'Outer capsid protein VP3-like', NULL, 'VP3-like', NULL, NULL, 36786, 9),
(271378, NULL, 'PF12472', NULL, NULL, 'Phage related protein', NULL, 'DUF3693', NULL, NULL, 15105, 9),
(271379, NULL, 'PF00156', NULL, NULL, 'Phosphoribosyl transferase domain', NULL, 'Pribosyltran', NULL, NULL, 4518, 9),
(271380, NULL, 'PF11204', NULL, NULL, 'Protein of unknown function (DUF2985)', NULL, 'DUF2985', NULL, NULL, 18471, 9),
(271381, NULL, 'PF10076', NULL, NULL, 'Bacteriophage Mu-like, Gp48', NULL, 'Phage_Mu_Gp48', NULL, NULL, 18277, 9),
(271382, NULL, 'PF00574', NULL, NULL, 'Clp protease', NULL, 'CLP_protease', NULL, NULL, 10061, 9),
(271383, NULL, 'PF07952', NULL, NULL, 'Clostridium neurotoxin, Translocation domain', NULL, 'Toxin_trans', NULL, NULL, 12781, 9),
(271384, NULL, 'PF19795', NULL, NULL, 'Family of unknown function (DUF6279)', NULL, 'DUF6279', NULL, NULL, NULL, 9),
(271385, NULL, 'PF14930', NULL, NULL, 'Quinohemoprotein amine dehydrogenase, alpha subunit domain II', NULL, 'Qn_am_d_aII', NULL, NULL, 7909, 9),
(271386, NULL, 'PF08099', NULL, NULL, 'Scorpion calcine family', NULL, 'Toxin_27', NULL, NULL, 10396, 9),
(271387, NULL, 'PF12276', NULL, NULL, 'Protein of unknown function (DUF3617)', NULL, 'DUF3617', NULL, NULL, 20895, 9),
(271388, NULL, 'PF19591', NULL, NULL, 'Family of unknown function (DUF6096)', NULL, 'DUF6096', NULL, NULL, 36701, 9),
(271389, NULL, 'PF02398', NULL, NULL, 'Coronavirus protein 7', NULL, 'Corona_7', NULL, NULL, 5288, 9),
(271390, NULL, 'PF00829', NULL, NULL, 'Ribosomal prokaryotic L21 protein', NULL, 'Ribosomal_L21p', NULL, NULL, 24583, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(271391, NULL, 'PF15883', NULL, NULL, 'Domain of unknown function (DUF4736)', NULL, 'DUF4736', NULL, NULL, 25911, 9),
(271392, NULL, 'PF03927', NULL, NULL, 'NapD protein', NULL, 'NapD', NULL, NULL, 2641, 9),
(271393, NULL, 'PF09114', NULL, NULL, 'Transcription factor MotA, activation domain', NULL, 'MotA_activ', NULL, NULL, 10895, 9),
(271394, NULL, 'PF19315', NULL, NULL, 'Mesaconyl-CoA hydratase', NULL, 'MC_hydratase', NULL, NULL, 37459, 9),
(271395, NULL, 'PF08201', NULL, NULL, 'BssC/TutF protein', NULL, 'BssC_TutF', NULL, NULL, 8594, 9),
(271396, NULL, 'PF16565', NULL, NULL, 'Phospholipase D-like domain at C-terminus of MIT', NULL, 'MIT_C', NULL, NULL, 24097, 9),
(271397, NULL, 'PF16911', NULL, NULL, 'Phthiocerol/phthiodiolone dimycocerosyl transferase C-terminus', NULL, 'PapA_C', NULL, NULL, 25333, 9),
(271398, NULL, 'PF02811', NULL, NULL, 'PHP domain', NULL, 'PHP', NULL, NULL, 531, 9),
(271399, NULL, 'PF00294', NULL, NULL, 'pfkB family carbohydrate kinase', NULL, 'PfkB', NULL, NULL, 8292, 9),
(271400, NULL, 'PF12256', NULL, NULL, 'Insecticide toxin TcdB middle/N-terminal region', NULL, 'TcdB_toxin_midN', NULL, NULL, 20485, 9),
(271401, NULL, 'PF14093', NULL, NULL, 'Domain of unknown function (DUF4271)', NULL, 'DUF4271', NULL, NULL, 22991, 9),
(271402, NULL, 'PF14201', NULL, NULL, 'Domain of unknown function (DUF4318)', NULL, 'DUF4318', NULL, NULL, 26248, 9),
(271403, NULL, 'PF07037', NULL, NULL, 'Putative transcription regulator (DUF1323)', NULL, 'DUF1323', NULL, NULL, 9854, 9),
(271404, NULL, 'PF17972', NULL, NULL, 'Bacterial Alpha-2-macroglobulin MG5 domain', NULL, 'bMG5', NULL, NULL, 29167, 9),
(271405, NULL, 'PF02500', NULL, NULL, 'Probable DNA packing protein, N-terminus', NULL, 'DNA_pack_N', NULL, NULL, 6188, 9),
(271406, NULL, 'PF02638', NULL, NULL, 'Glycosyl hydrolase-like 10', NULL, 'GHL10', NULL, NULL, 6149, 9),
(271407, NULL, 'PF15617', NULL, NULL, 'C-C_Bond_Lyase of the TIM-Barrel fold', NULL, 'C-C_Bond_Lyase', NULL, NULL, 28960, 9),
(271408, NULL, 'PF09829', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2057)', NULL, 'DUF2057', NULL, NULL, 16071, 9),
(271409, NULL, 'PF11129', NULL, NULL, 'Rev protein of equine infectious anaemia virus', NULL, 'EIAV_Rev', NULL, NULL, 17608, 9),
(271410, NULL, 'PF06203', NULL, NULL, 'CCT motif', NULL, 'CCT', NULL, NULL, 9090, 9),
(271411, NULL, 'PF04351', NULL, NULL, 'Pilus assembly protein, PilP', NULL, 'PilP', NULL, NULL, 4697, 9),
(271412, NULL, 'PF04852', NULL, NULL, 'ALOG domain', NULL, 'ALOG_dom', NULL, NULL, 5578, 9),
(271413, NULL, 'PF08457', NULL, NULL, 'Sfi1 spindle body protein', NULL, 'Sfi1', NULL, NULL, 13817, 9),
(271414, NULL, 'PF10105', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2344)', NULL, 'DUF2344', NULL, NULL, 18479, 9),
(271415, NULL, 'PF04680', NULL, NULL, 'Opioid growth factor receptor repeat', NULL, 'OGFr_III', NULL, NULL, 3288, 9),
(271416, NULL, 'PF07301', NULL, NULL, 'CcdC protein', NULL, 'DUF1453', NULL, NULL, 25180, 9),
(271417, NULL, 'PF08015', NULL, NULL, 'Fungal mating-type pheromone', NULL, 'Pheromone', NULL, NULL, 9134, 9),
(271418, NULL, 'PF14603', NULL, NULL, 'Helically-extended SH3 domain', NULL, 'hSH3', NULL, NULL, 26733, 9),
(271419, NULL, 'PF20099', NULL, NULL, 'Family of unknown function (DUF6489)', NULL, 'DUF6489', NULL, NULL, 33694, 9),
(271420, NULL, 'PF03246', NULL, NULL, 'Pneumovirus nucleocapsid protein', NULL, 'Pneumo_ncap', NULL, NULL, 1999, 9),
(271421, NULL, 'PF19140', NULL, NULL, 'Family of unknown function (DUF5823)', NULL, 'DUF5823', NULL, NULL, 34079, 9),
(271422, NULL, 'PF08763', NULL, NULL, 'Voltage gated calcium channel IQ domain', NULL, 'Ca_chan_IQ', NULL, NULL, 13071, 9),
(271423, NULL, 'PF19260', NULL, NULL, 'Family of unknown function (DUF5903)', NULL, 'DUF5903', NULL, NULL, 35206, 9),
(271424, NULL, 'PF20557', NULL, NULL, 'Putative DnaT-like ssDNA binding protein', NULL, 'DnaT_2', NULL, NULL, 37737, 9),
(271425, NULL, 'PF09682', NULL, NULL, 'Bacteriophage holin of superfamily 6 (Holin_LLH)', NULL, 'Phage_holin_6_1', NULL, NULL, 5179, 9);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(271426, NULL, 'PF14697', NULL, NULL, '4Fe-4S dicluster domain', NULL, 'Fer4_21', NULL, NULL, NULL, 9),
(271427, NULL, 'PF17933', NULL, NULL, 'Tetracyclin repressor-like, C-terminal domain', NULL, 'TetR_C_25', NULL, NULL, 29006, 9),
(271428, NULL, 'PF15889', NULL, NULL, 'Domain of unknown function (DUF4738)', NULL, 'DUF4738', NULL, NULL, 23905, 9),
(271429, NULL, 'PF11882', NULL, NULL, 'Domain of unknown function (DUF3402)', NULL, 'DUF3402', NULL, NULL, 19683, 9),
(271430, NULL, 'PF09429', NULL, NULL, 'WW domain binding protein 11', NULL, 'Wbp11', NULL, NULL, 15958, 9),
(271431, NULL, 'PF17025', NULL, NULL, 'Domain of unknown function (DUF5099)', NULL, 'DUF5099', NULL, NULL, 22554, 9),
(271432, NULL, 'PF02176', NULL, NULL, 'TRAF-type zinc finger', NULL, 'zf-TRAF', NULL, NULL, 5428, 9),
(271433, NULL, 'PF15505', NULL, NULL, 'Vexin domain', NULL, 'Vexin', NULL, NULL, 24447, 9),
(271434, NULL, 'PF15228', NULL, NULL, 'Death-associated protein', NULL, 'DAP', NULL, NULL, 8299, 9),
(271435, NULL, 'PF08019', NULL, NULL, 'Phosphoethanolamine transferase EptA/EptB', NULL, 'EptA_B_N', NULL, NULL, 8914, 9),
(271436, NULL, 'PF20558', NULL, NULL, 'Family of unknown function (DUF6769)', NULL, 'DUF6769', NULL, NULL, 37069, 9),
(271437, NULL, 'PF09766', NULL, NULL, 'Fms-interacting protein/Thoc5', NULL, 'FmiP_Thoc5', NULL, NULL, 18010, 9),
(271438, NULL, 'PF10470', NULL, NULL, 'PKA-RI-RII subunit binding domain of A-kinase anchor protein', NULL, 'AKAP7_RIRII_bdg', NULL, NULL, 18346, 9),
(271439, NULL, 'PF10063', NULL, NULL, 'Uncharacterized integral membrane protein (DUF2301)', NULL, 'DUF2301', NULL, NULL, 19755, 9),
(271440, NULL, 'PF06784', NULL, NULL, 'Uncharacterised protein family (UPF0240)', NULL, 'UPF0240', NULL, NULL, 1686, 9),
(271441, NULL, 'PF20023', NULL, NULL, 'Wolframin Sel1-like repeat', NULL, 'WSLR', NULL, NULL, 35625, 9),
(271442, NULL, 'PF10680', NULL, NULL, 'RNA polymerase I specific transcription initiation factor', NULL, 'RRN9', NULL, NULL, 20882, 9),
(271443, NULL, 'PF06031', NULL, NULL, 'SERTA motif', NULL, 'SERTA', NULL, NULL, 13555, 9),
(271444, NULL, 'PF09061', NULL, NULL, 'Stirrup', NULL, 'Stirrup', NULL, NULL, 9850, 9),
(271445, NULL, 'PF13547', NULL, NULL, 'GTA TIM-barrel-like domain', NULL, 'GTA_TIM', NULL, NULL, 21683, 9),
(271446, NULL, 'PF18257', NULL, NULL, 'Disulfide isomerase DsbG N-terminal', NULL, 'DsbG_N', NULL, NULL, 30032, 9),
(271447, NULL, 'PF12464', NULL, NULL, 'Maltose acetyltransferase', NULL, 'Mac', NULL, NULL, 22049, 9),
(271448, NULL, 'PF10644', NULL, NULL, 'Misato Segment II tubulin-like domain', NULL, 'Misat_Tub_SegII', NULL, NULL, 20094, 9),
(271449, NULL, 'PF06824', NULL, NULL, 'Metal-independent alpha-mannosidase (GH125)', NULL, 'Glyco_hydro_125', NULL, NULL, 7502, 9),
(271450, NULL, 'PF13919', NULL, NULL, 'Asx homology domain', NULL, 'ASXH', NULL, NULL, 23424, 9),
(271451, NULL, 'PF15523', NULL, NULL, 'Novel toxin 16', NULL, 'Ntox16', NULL, NULL, 23531, 9),
(271452, NULL, 'PF16284', NULL, NULL, 'Domain of unknown function (DUF4930)', NULL, 'DUF4930', NULL, NULL, 21590, 9),
(271453, NULL, 'PF08065', NULL, NULL, 'KI67R (NUC007) repeat', NULL, 'KI67R', NULL, NULL, 9297, 9),
(271454, NULL, 'PF15340', NULL, NULL, 'Cooperator of PRMT5 family', NULL, 'COPR5', NULL, NULL, 24460, 9),
(271455, NULL, 'PF04412', NULL, NULL, 'Aconitase X', NULL, 'AcnX', NULL, NULL, 10135, 9),
(271456, NULL, 'PF18495', NULL, NULL, 'Antitoxin VbhA', NULL, 'VbhA', NULL, NULL, 30143, 9),
(271457, NULL, 'PF01003', NULL, NULL, 'Flavivirus capsid protein C', NULL, 'Flavi_capsid', NULL, NULL, 1720, 9),
(271458, NULL, 'PF06457', NULL, NULL, 'Ectatomin', NULL, 'Ectatomin', NULL, NULL, 9018, 9),
(271459, NULL, 'PF09790', NULL, NULL, 'Hyccin', NULL, 'Hyccin', NULL, NULL, 16375, 9),
(271460, NULL, 'PF16453', NULL, NULL, 'PH domain', NULL, 'IQ_SEC7_PH', NULL, NULL, 31697, 9),
(271461, NULL, 'PF11172', NULL, NULL, 'Protein of unknown function (DUF2959)', NULL, 'DUF2959', NULL, NULL, 18087, 9),
(271462, NULL, 'PF10052', NULL, NULL, 'Protein of unknown function (DUF2288)', NULL, 'DUF2288', NULL, NULL, 18046, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(271463, NULL, 'PF13424', NULL, NULL, 'Tetratricopeptide repeat', NULL, 'TPR_12', NULL, NULL, NULL, 9),
(271464, NULL, 'PF13488', NULL, NULL, 'Glycine zipper', NULL, 'Gly-zipper_Omp', NULL, NULL, 27324, 9),
(271465, NULL, 'PF19632', NULL, NULL, 'Family of unknown function (DUF6136)', NULL, 'DUF6136', NULL, NULL, 34163, 9),
(271466, NULL, 'PF04273', NULL, NULL, 'Beta-lactamase hydrolase-like protein, phosphatase-like domain', NULL, 'BLH_phosphatase', NULL, NULL, 110, 9),
(271467, NULL, 'PF10018', NULL, NULL, 'Vitamin-D-receptor interacting Mediator subunit 4', NULL, 'Med4', NULL, NULL, 19824, 9),
(271468, NULL, 'PF00202', NULL, NULL, 'Aminotransferase class-III', NULL, 'Aminotran_3', NULL, NULL, 5655, 9),
(271469, NULL, 'PF15751', NULL, NULL, 'FAAP20 FANCA interaction domain', NULL, 'FANCA_interact', NULL, NULL, 25469, 9),
(271470, NULL, 'PF14827', NULL, NULL, 'Double sensory domain of two-component sensor kinase', NULL, 'dCache_3', NULL, NULL, 25951, 9),
(271471, NULL, 'PF01565', NULL, NULL, 'FAD binding domain', NULL, 'FAD_binding_4', NULL, NULL, 2631, 9),
(271472, NULL, 'PF17069', NULL, NULL, 'Arginine/Serine-Rich protein 1', NULL, 'RSRP', NULL, NULL, NULL, 9),
(271473, NULL, 'PF03053', NULL, NULL, 'ORF3b coronavirus protein', NULL, 'Corona_NS3b', NULL, NULL, 4682, 9),
(271474, NULL, 'PF04170', NULL, NULL, 'NlpE N-terminal domain', NULL, 'NlpE', NULL, NULL, 151, 9),
(271475, NULL, 'PF18157', NULL, NULL, 'MID domain of pPIWI_RE', NULL, 'MID_pPIWI_RE', NULL, NULL, 27554, 9),
(271476, NULL, 'PF19730', NULL, NULL, 'Family of unknown function (DUF6221)', NULL, 'DUF6221', NULL, NULL, 37404, 9),
(271477, NULL, 'PF05231', NULL, NULL, 'MASE1', NULL, 'MASE1', NULL, NULL, 3194, 9),
(271478, NULL, 'PF00094', NULL, NULL, 'von Willebrand factor type D domain', NULL, 'VWD', NULL, NULL, 4402, 9),
(271479, NULL, 'PF03611', NULL, NULL, 'PTS system sugar-specific permease component', NULL, 'EIIC-GAT', NULL, NULL, 3184, 9),
(271480, NULL, 'PF13317', NULL, NULL, 'Protein of unknown function (DUF4088)', NULL, 'DUF4088', NULL, NULL, 22731, 9),
(271481, NULL, 'PF01515', NULL, NULL, 'Phosphate acetyl/butaryl transferase', NULL, 'PTA_PTB', NULL, NULL, 661, 9),
(271482, NULL, 'PF18032', NULL, NULL, 'Photoprotection regulator fluorescence recovery protein', NULL, 'FRP', NULL, NULL, 29632, 9),
(271483, NULL, 'PF09625', NULL, NULL, 'VP9 protein', NULL, 'VP9', NULL, NULL, 15765, 9),
(271484, NULL, 'PF00798', NULL, NULL, 'Arenavirus glycoprotein', NULL, 'Arena_glycoprot', NULL, NULL, 3403, 9),
(271485, NULL, 'PF19175', NULL, NULL, 'Family of unknown function (DUF5857)', NULL, 'DUF5857', NULL, NULL, 34047, 9),
(271486, NULL, 'PF05170', NULL, NULL, 'AsmA family', NULL, 'AsmA', NULL, NULL, 2066, 9),
(271487, NULL, 'PF06414', NULL, NULL, 'Zeta toxin', NULL, 'Zeta_toxin', NULL, NULL, 10434, 9),
(271488, NULL, 'PF07066', NULL, NULL, 'Lactococcus phage M3 protein', NULL, 'DUF3882', NULL, NULL, 12800, 9),
(271489, NULL, 'PF13034', NULL, NULL, 'Protein of unknown function (DUF3895)', NULL, 'DUF3895', NULL, NULL, 22525, 9),
(271490, NULL, 'PF02615', NULL, NULL, 'Malate/L-lactate dehydrogenase', NULL, 'Ldh_2', NULL, NULL, 2438, 9),
(271491, NULL, 'PF04781', NULL, NULL, 'Protein of unknown function (DUF627)', NULL, 'DUF627', NULL, NULL, 4197, 9),
(271492, NULL, 'PF18415', NULL, NULL, 'Histidine kinase receptor ArcB trans-membrane domain', NULL, 'HKR_ArcB_TM', NULL, NULL, 28141, 9),
(271493, NULL, 'PF13979', NULL, NULL, 'SopA-like catalytic domain', NULL, 'SopA_C', NULL, NULL, 22928, 9),
(271494, NULL, 'PF05953', NULL, NULL, 'Allatostatin', NULL, 'Allatostatin', NULL, NULL, 7779, 9),
(271495, NULL, 'PF17843', NULL, NULL, 'MycE methyltransferase N-terminal', NULL, 'MycE_N', NULL, NULL, 32232, 9),
(271496, NULL, 'PF13809', NULL, NULL, 'Tubulin like', NULL, 'Tubulin_2', NULL, NULL, 23021, 9),
(271497, NULL, 'PF18193', NULL, NULL, 'Fibrillin 1 unique N-terminal domain', NULL, 'Fibrillin_U_N', NULL, NULL, 28097, 9),
(271498, NULL, 'PF16205', NULL, NULL, 'Ribosomal_S17 N-terminal', NULL, 'Ribosomal_S17_N', NULL, NULL, 25159, 9),
(271499, NULL, 'PF10725', NULL, NULL, 'Protein of unknown function (DUF2517)', NULL, 'DUF2517', NULL, NULL, 20874, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(271500, NULL, 'PF12754', NULL, NULL, 'Blt1 N-terminal domain', NULL, 'Blt1', NULL, NULL, NULL, 9),
(271501, NULL, 'PF01620', NULL, NULL, 'Ribonuclease (pollen allergen)', NULL, 'Pollen_allerg_2', NULL, NULL, 6463, 9),
(271502, NULL, 'PF11737', NULL, NULL, 'Protein of unknown function (DUF3300)', NULL, 'DUF3300', NULL, NULL, 19039, 9),
(271503, NULL, 'PF06087', NULL, NULL, 'Tyrosyl-DNA phosphodiesterase', NULL, 'Tyr-DNA_phospho', NULL, NULL, 8807, 9),
(271504, NULL, 'PF17652', NULL, NULL, 'Glycosyl hydrolase family 81 C-terminal domain', NULL, 'Glyco_hydro81C', NULL, NULL, 27730, 9),
(271505, NULL, 'PF16778', NULL, NULL, 'Phage tail assembly chaperone protein', NULL, 'Phage_tail_APC', NULL, NULL, 23942, 9),
(271506, NULL, 'PF18865', NULL, NULL, 'AbiJ N-terminal domain 5', NULL, 'AbiJ_NTD5', NULL, NULL, 27607, 9),
(271507, NULL, 'PF19030', NULL, NULL, 'Thrombospondin type 1 domain', NULL, 'TSP1_ADAMTS', NULL, NULL, NULL, 9),
(271508, NULL, 'PF01972', NULL, NULL, 'Serine dehydrogenase proteinase', NULL, 'SDH_sah', NULL, NULL, 4599, 9),
(271509, NULL, 'PF06881', NULL, NULL, 'RNA polymerase II transcription factor SIII (Elongin) subunit A', NULL, 'Elongin_A', NULL, NULL, 9261, 9),
(271510, NULL, 'PF11504', NULL, NULL, 'Colicin Ia', NULL, 'Colicin_Ia', NULL, NULL, 12137, 9),
(271511, NULL, 'PF10097', NULL, NULL, 'Predicted membrane protein (DUF2335)', NULL, 'DUF2335', NULL, NULL, 19671, 9),
(271512, NULL, 'PF06696', NULL, NULL, 'Streptococcal surface antigen repeat', NULL, 'Strep_SA_rep', NULL, NULL, 514, 9),
(271513, NULL, 'PF11581', NULL, NULL, 'Antagonist of EGFR signalling, Argos', NULL, 'Argos', NULL, NULL, 18751, 9),
(271514, NULL, 'PF16607', NULL, NULL, 'Phosphorylation region of CYLD, unstructured', NULL, 'CYLD_phos_site', NULL, NULL, NULL, 9),
(271515, NULL, 'PF19019', NULL, NULL, 'Phlebovirus glycoprotein G2 C-terminal domain', NULL, 'Phlebo_G2_C', NULL, NULL, 35436, 9),
(271516, NULL, 'PF19275', NULL, NULL, 'HflX C-terminal domain', NULL, 'HflX_C', NULL, NULL, 37391, 9),
(271517, NULL, 'PF05585', NULL, NULL, 'Putative peptidase (DUF1758)', NULL, 'DUF1758', NULL, NULL, 12073, 9),
(271518, NULL, 'PF02290', NULL, NULL, 'Signal recognition particle 14kD protein', NULL, 'SRP14', NULL, NULL, 3459, 9),
(271519, NULL, 'PF16624', NULL, NULL, 'Unstructured region upstream of a zinc-finger', NULL, 'zf-C2H2_assoc2', NULL, NULL, NULL, 9),
(271520, NULL, 'PF02604', NULL, NULL, 'Antitoxin Phd_YefM, type II toxin-antitoxin system', NULL, 'PhdYeFM_antitox', NULL, NULL, 6826, 9),
(271521, NULL, 'PF15438', NULL, NULL, 'Antigenic membrane protein of phytoplasma', NULL, 'Phyto-Amp', NULL, NULL, 26635, 9),
(271522, NULL, 'PF05853', NULL, NULL, 'beta-keto acid cleavage enzyme', NULL, 'BKACE', NULL, NULL, 13093, 9),
(271523, NULL, 'PF14872', NULL, NULL, 'Hypothetical glycoside hydrolase 5', NULL, 'GHL5', NULL, NULL, 25956, 9),
(271524, NULL, 'PF01468', NULL, NULL, 'GA module', NULL, 'GA', NULL, NULL, 7199, 9),
(271525, NULL, 'PF04971', NULL, NULL, 'Bacteriophage P21 holin S', NULL, 'Phage_holin_2_1', NULL, NULL, 6566, 9),
(271526, NULL, 'PF04033', NULL, NULL, 'Domain of unknown function (DUF365)', NULL, 'DUF365', NULL, NULL, 825, 9),
(271527, NULL, 'PF06342', NULL, NULL, 'Alpha/beta hydrolase of unknown function (DUF1057)', NULL, 'DUF1057', NULL, NULL, 10416, 9),
(271528, NULL, 'PF19084', NULL, NULL, 'Family of unknown function (DUF5775)', NULL, 'DUF5775', NULL, NULL, 35234, 9),
(271529, NULL, 'PF02020', NULL, NULL, 'eIF4-gamma/eIF5/eIF2-epsilon', NULL, 'W2', NULL, NULL, 3794, 9),
(271530, NULL, 'PF17981', NULL, NULL, 'Cysteine Rich ADD domain', NULL, 'ADD_ATRX', NULL, NULL, 30503, 9),
(271531, NULL, 'PF03805', NULL, NULL, 'Cytoadherence-linked asexual protein', NULL, 'CLAG', NULL, NULL, 1604, 9),
(271532, NULL, 'PF20002', NULL, NULL, 'FtsH ternary system domain X3-analog', NULL, 'fvmX3-analog', NULL, NULL, 35865, 9),
(271533, NULL, 'PF11237', NULL, NULL, 'Protein of unknown function (DUF3038)', NULL, 'DUF3038', NULL, NULL, 18497, 9),
(271534, NULL, 'PF14589', NULL, NULL, 'Polysulfide reductase', NULL, 'NrfD_2', NULL, NULL, 21822, 9);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(271535, NULL, 'PF14024', NULL, NULL, 'Protein of unknown function (DUF4240)', NULL, 'DUF4240', NULL, NULL, 22150, 9),
(271536, NULL, 'PF14129', NULL, NULL, 'Domain of unknown function (DUF4296)', NULL, 'DUF4296', NULL, NULL, 26084, 9),
(271537, NULL, 'PF03709', NULL, NULL, 'Orn/Lys/Arg decarboxylase, N-terminal domain', NULL, 'OKR_DC_1_N', NULL, NULL, 5174, 9),
(271538, NULL, 'PF19166', NULL, NULL, 'Family of unknown function (DUF5848)', NULL, 'DUF5848', NULL, NULL, 34575, 9),
(271539, NULL, 'PF19721', NULL, NULL, 'Family of unknown function (DUF6215)', NULL, 'DUF6215', NULL, NULL, 37158, 9),
(271540, NULL, 'PF09881', NULL, NULL, 'Predicted membrane protein (DUF2108)', NULL, 'DUF2108', NULL, NULL, 19443, 9),
(271541, NULL, 'PF07298', NULL, NULL, 'NnrU protein', NULL, 'NnrU', NULL, NULL, 14499, 9),
(271542, NULL, 'PF00760', NULL, NULL, 'Cucumovirus coat protein', NULL, 'Cucumo_coat', NULL, NULL, 17580, 9),
(271543, NULL, 'PF14966', NULL, NULL, 'DNA repair REX1-B', NULL, 'DNA_repr_REX1B', NULL, NULL, 28841, 9),
(271544, NULL, 'PF01250', NULL, NULL, 'Ribosomal protein S6', NULL, 'Ribosomal_S6', NULL, NULL, 5523, 9),
(271545, NULL, 'PF13638', NULL, NULL, 'PIN domain', NULL, 'PIN_4', NULL, NULL, 3820, 9),
(271546, NULL, 'PF19908', NULL, NULL, 'Family of unknown function (DUF6381)', NULL, 'DUF6381', NULL, NULL, 36812, 9),
(271547, NULL, 'PF19199', NULL, NULL, 'Phage major coat protein, Gp8', NULL, 'Phage_coatGP8', NULL, NULL, 5201, 9),
(271548, NULL, 'PF10088', NULL, NULL, 'Uncharacterised protein conserved in bacteria (DUF2326)', NULL, 'DUF2326', NULL, NULL, 18374, 9),
(271549, NULL, 'PF16313', NULL, NULL, 'Met-zincin', NULL, 'DUF4953', NULL, NULL, 25603, 9),
(271550, NULL, 'PF02467', NULL, NULL, 'Transcription factor WhiB', NULL, 'Whib', NULL, NULL, 21607, 9),
(271551, NULL, 'PF08644', NULL, NULL, 'FACT complex subunit (SPT16/CDC68)', NULL, 'SPT16', NULL, NULL, 7589, 9),
(271552, NULL, 'PF19986', NULL, NULL, 'Family of unknown function (DUF6422)', NULL, 'DUF6422', NULL, NULL, 37654, 9),
(271553, NULL, 'PF09268', NULL, NULL, 'Clathrin, heavy-chain linker', NULL, 'Clathrin-link', NULL, NULL, 13262, 9),
(271554, NULL, 'PF09702', NULL, NULL, 'CRISPR-associated protein (Cas_Csa5)', NULL, 'Cas_Csa5', NULL, NULL, 10694, 9),
(271555, NULL, 'PF16854', NULL, NULL, 'Vacuolar protein sorting-associated protein 53 C-terminus', NULL, 'VPS53_C', NULL, NULL, 22589, 9),
(271556, NULL, 'PF14814', NULL, NULL, 'Bifunctional transglycosylase second domain', NULL, 'UB2H', NULL, NULL, 23771, 9),
(271557, NULL, 'PF19567', NULL, NULL, 'Capsular polysaccharide synthesis, CpsB/CapC', NULL, 'CpsB_CapC', NULL, NULL, 20378, 9),
(271558, NULL, 'PF00451', NULL, NULL, 'Scorpion short toxin, BmKK2', NULL, 'Toxin_2', NULL, NULL, 2205, 9),
(271559, NULL, 'PF08911', NULL, NULL, 'NUP50 (Nucleoporin 50 kDa)', NULL, 'NUP50', NULL, NULL, 7850, 9),
(271560, NULL, 'PF15133', NULL, NULL, 'TLR adaptor interacting with SLC15A4 on the lysosome', NULL, 'TASL', NULL, NULL, 25875, 9),
(271561, NULL, 'PF20162', NULL, NULL, 'Septation protein etd1', NULL, 'Etd1', NULL, NULL, 37221, 9),
(271562, NULL, 'PF02504', NULL, NULL, 'Fatty acid synthesis protein', NULL, 'FA_synthesis', NULL, NULL, 6006, 9),
(271563, NULL, 'PF10959', NULL, NULL, 'Protein of unknown function (DUF2761)', NULL, 'DUF2761', NULL, NULL, 20093, 9),
(271564, NULL, 'PF11232', NULL, NULL, 'Mediator complex subunit 25 PTOV activation and synapsin 2', NULL, 'Med25', NULL, NULL, 18147, 9),
(271565, NULL, 'PF16216', NULL, NULL, 'GxGYxY sequence motif in domain of unknown function N-terminal', NULL, 'GxGYxYP_N', NULL, NULL, 26420, 9),
(271566, NULL, 'PF01085', NULL, NULL, 'Hedgehog amino-terminal signalling domain', NULL, 'HH_signal', NULL, NULL, 824, 9),
(271567, NULL, 'PF02180', NULL, NULL, 'Bcl-2 homology region 4', NULL, 'BH4', NULL, NULL, 703, 9),
(271568, NULL, 'PF09000', NULL, NULL, 'Cytotoxic', NULL, 'Cytotoxic', NULL, NULL, 7759, 9),
(271569, NULL, 'PF19706', NULL, NULL, 'Family of unknown function (DUF6203)', NULL, 'DUF6203', NULL, NULL, 37305, 9),
(271570, NULL, 'PF17187', NULL, NULL, 'Svf1-like C-terminal lipocalin-like domain', NULL, 'Svf1_C', NULL, NULL, 27198, 9);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(271571, NULL, 'PF18484', NULL, NULL, 'Cadmium carbonic anhydrase repeat', NULL, 'CDCA', NULL, NULL, 28386, 9),
(271572, NULL, 'PF02263', NULL, NULL, 'Guanylate-binding protein, N-terminal domain', NULL, 'GBP', NULL, NULL, 7523, 9),
(271573, NULL, 'PF11272', NULL, NULL, 'Protein of unknown function (DUF3072)', NULL, 'DUF3072', NULL, NULL, 18184, 9),
(271574, NULL, 'PF20070', NULL, NULL, 'Family of unknown function (DUF6466)', NULL, 'DUF6466', NULL, NULL, 37662, 9),
(271575, NULL, 'PF03769', NULL, NULL, 'Attacin, C-terminal region', NULL, 'Attacin_C', NULL, NULL, 1942, 9),
(271576, NULL, 'PF00344', NULL, NULL, 'SecY', NULL, 'SecY', NULL, NULL, 58, 9),
(271577, NULL, 'PF00433', NULL, NULL, 'Protein kinase C terminal domain', NULL, 'Pkinase_C', NULL, NULL, 2683, 9),
(271578, NULL, 'PF03136', NULL, NULL, 'Pup-ligase protein', NULL, 'Pup_ligase', NULL, NULL, 5285, 9),
(271579, NULL, 'PF16090', NULL, NULL, 'Domain of unknown function (DUF4819)', NULL, 'DUF4819', NULL, NULL, 26012, 9),
(271580, NULL, 'PF09782', NULL, NULL, 'NADH:ubiquinone oxidoreductase, NDUFB6/B17 subunit', NULL, 'NDUF_B6', NULL, NULL, 18299, 9),
(271581, NULL, 'PF11112', NULL, NULL, 'Pyocin activator protein PrtN', NULL, 'PyocinActivator', NULL, NULL, 19324, 9),
(271582, NULL, 'PF14000', NULL, NULL, 'DNA packaging protein FI', NULL, 'Packaging_FI', NULL, NULL, 26255, 9),
(271583, NULL, 'PF07675', NULL, NULL, 'Cleaved Adhesin Domain', NULL, 'Cleaved_Adhesin', NULL, NULL, 10615, 9),
(271584, NULL, 'PF00620', NULL, NULL, 'RhoGAP domain', NULL, 'RhoGAP', NULL, NULL, 1407, 9),
(271585, NULL, 'PF14823', NULL, NULL, 'Sirohaem biosynthesis protein C-terminal', NULL, 'Sirohm_synth_C', NULL, NULL, 23624, 9),
(271586, NULL, 'PF18045', NULL, NULL, 'ISP3 C-terminal', NULL, 'ISP3_C', NULL, NULL, 29245, 9),
(271587, NULL, 'PF06037', NULL, NULL, 'Bacterial protein of unknown function (DUF922)', NULL, 'DUF922', NULL, NULL, 8810, 9),
(271588, NULL, 'PF13612', NULL, NULL, 'Transposase DDE domain', NULL, 'DDE_Tnp_1_3', NULL, NULL, 24235, 9),
(271589, NULL, 'PF04773', NULL, NULL, 'FecR protein', NULL, 'FecR', NULL, NULL, 3768, 9),
(271590, NULL, 'PF04998', NULL, NULL, 'RNA polymerase Rpb1, domain 5', NULL, 'RNA_pol_Rpb1_5', NULL, NULL, 78, 9),
(271591, NULL, 'PF01329', NULL, NULL, 'Pterin 4 alpha carbinolamine dehydratase', NULL, 'Pterin_4a', NULL, NULL, 5894, 9),
(271592, NULL, 'PF05815', NULL, NULL, 'Autographa californica nuclear polyhedrosis virus (AcMNPV), Orf101', NULL, 'AcMNPV_Orf101', NULL, NULL, 13480, 9),
(271593, NULL, 'PF00177', NULL, NULL, 'Ribosomal protein S7p/S5e', NULL, 'Ribosomal_S7', NULL, NULL, 17738, 9),
(271594, NULL, 'PF11962', NULL, NULL, 'Peptidase_G2, IMC autoproteolytic cleavage domain', NULL, 'Peptidase_G2', NULL, NULL, 19961, 9),
(271595, NULL, 'PF19221', NULL, NULL, 'MELT motif', NULL, 'MELT', NULL, NULL, 35124, 9),
(271596, NULL, 'PF17163', NULL, NULL, 'Domain of unknown function (DUF5125)', NULL, 'DUF5125', NULL, NULL, 32908, 9),
(271597, NULL, 'PF08038', NULL, NULL, 'TOM7 family', NULL, 'Tom7', NULL, NULL, 9921, 9),
(271598, NULL, 'PF13404', NULL, NULL, 'AsnC-type helix-turn-helix domain', NULL, 'HTH_AsnC-type', NULL, NULL, 6592, 9),
(271599, NULL, 'PF05335', NULL, NULL, 'Protein of unknown function (DUF745)', NULL, 'DUF745', NULL, NULL, 4287, 9),
(271600, NULL, 'PF16244', NULL, NULL, 'Domain of unknown function (DUF4901)', NULL, 'DUF4901', NULL, NULL, 24285, 9),
(271601, NULL, 'PF16990', NULL, NULL, 'Carbohydrate binding module (family 35)', NULL, 'CBM_35', NULL, NULL, 10191, 9),
(271602, NULL, 'PF00589', NULL, NULL, 'Phage integrase family', NULL, 'Phage_integrase', NULL, NULL, 1018, 9),
(271603, NULL, 'PF13898', NULL, NULL, 'Deubiquitinating enzyme MINDY-3/4, conserved domain', NULL, 'MINDY-3_4_CD', NULL, NULL, 23379, 9),
(271604, NULL, 'PF02222', NULL, NULL, 'ATP-grasp domain', NULL, 'ATP-grasp', NULL, NULL, 2801, 9),
(271605, NULL, 'PF09020', NULL, NULL, 'YopE, N terminal', NULL, 'YopE_N', NULL, NULL, 9867, 9),
(271606, NULL, 'PF10212', NULL, NULL, 'Predicted coiled-coil domain-containing protein', NULL, 'TTKRSYEDQ', NULL, NULL, 15798, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(271607, NULL, 'PF16509', NULL, NULL, 'TrfB plasmid transcriptional repressor', NULL, 'KORA', NULL, NULL, 25093, 9),
(271608, NULL, 'PF08189', NULL, NULL, 'Meleagrin/Cygnin family', NULL, 'Meleagrin', NULL, NULL, 9148, 9),
(271609, NULL, 'PF19056', NULL, NULL, 'WD40 repeated domain', NULL, 'WD40_2', NULL, NULL, NULL, 9),
(271610, NULL, 'PF14429', NULL, NULL, 'C2 domain in Dock180 and Zizimin proteins', NULL, 'DOCK-C2', NULL, NULL, 23833, 9),
(271611, NULL, 'PF16830', NULL, NULL, 'Nucleotide-Binding Domain 94 of RH', NULL, 'NBD94', NULL, NULL, 22138, 9),
(271612, NULL, 'PF11566', NULL, NULL, 'PI31 proteasome regulator N-terminal', NULL, 'PI31_Prot_N', NULL, NULL, 18759, 9),
(271613, NULL, 'PF12725', NULL, NULL, 'Protein of unknown function (DUF3810)', NULL, 'DUF3810', NULL, NULL, 13688, 9),
(271614, NULL, 'PF20356', NULL, NULL, 'Family of unknown function (DUF6651)', NULL, 'DUF6651', NULL, NULL, 33937, 9),
(271615, NULL, 'PF04332', NULL, NULL, 'Protein of unknown function (DUF475)', NULL, 'DUF475', NULL, NULL, 3980, 9),
(271616, NULL, 'PF01562', NULL, NULL, 'Reprolysin family propeptide', NULL, 'Pep_M12B_propep', NULL, NULL, 5888, 9),
(271617, NULL, 'PF02262', NULL, NULL, 'CBL proto-oncogene N-terminal domain 1', NULL, 'Cbl_N', NULL, NULL, 3477, 9),
(271618, NULL, 'PF20451', NULL, NULL, 'Calmodulin binding protein central domain', NULL, 'Calmod_bind_M', NULL, NULL, 34442, 9),
(271619, NULL, 'PF13606', NULL, NULL, 'Ankyrin repeat', NULL, 'Ank_3', NULL, NULL, 1485, 9),
(271620, NULL, 'PF18612', NULL, NULL, 'Bacterial Alpha amylase C-terminal domain', NULL, 'Bac_A_amyl_C', NULL, NULL, 29967, 9),
(271621, NULL, 'PF11695', NULL, NULL, 'Domain of unknown function (DUF3291)', NULL, 'DUF3291', NULL, NULL, 19239, 9),
(271622, NULL, 'PF11116', NULL, NULL, 'Protein of unknown function (DUF2624)', NULL, 'DUF2624', NULL, NULL, 19099, 9),
(271623, NULL, 'PF20231', NULL, NULL, 'Family of unknown function (DUF6589)', NULL, 'DUF6589', NULL, NULL, 37649, 9),
(271624, NULL, 'PF04926', NULL, NULL, 'Poly(A) polymerase predicted RNA binding domain', NULL, 'PAP_RNA-bind', NULL, NULL, 6650, 9),
(271625, NULL, 'PF16712', NULL, NULL, 'Coiled-coil regions of plant-specific actin-binding protein', NULL, 'SCAB_CC', NULL, NULL, 24314, 9),
(271626, NULL, 'PF03491', NULL, NULL, 'Serotonin (5-HT) neurotransmitter transporter, N-terminus', NULL, '5HT_transport_N', NULL, NULL, 7051, 9),
(271627, NULL, 'PF14642', NULL, NULL, 'FAM47 family', NULL, 'FAM47', NULL, NULL, 21541, 9),
(271628, NULL, 'PF04091', NULL, NULL, 'Exocyst complex subunit Sec15-like', NULL, 'Sec15', NULL, NULL, 34441, 9),
(271629, NULL, 'PF02244', NULL, NULL, 'Carboxypeptidase activation peptide', NULL, 'Propep_M14', NULL, NULL, 1769, 9),
(271630, NULL, 'PF08728', NULL, NULL, 'CRT10', NULL, 'CRT10', NULL, NULL, 11635, 9),
(271631, NULL, 'PF18535', NULL, NULL, 'Gal11 activator-binding domain (ABD1)', NULL, 'Gal11_ABD1', NULL, NULL, 31911, 9),
(271632, NULL, 'PF15221', NULL, NULL, 'Lens epithelial cell protein LEP503', NULL, 'LEP503', NULL, NULL, 21874, 9),
(271633, NULL, 'PF11254', NULL, NULL, 'Protein of unknown function (DUF3053)', NULL, 'DUF3053', NULL, NULL, 18072, 9),
(271634, NULL, 'PF12987', NULL, NULL, 'Domain of unknown function, B. Theta Gene description (DUF3871)', NULL, 'DUF3871', NULL, NULL, 23200, 9),
(271635, NULL, 'PF08872', NULL, NULL, 'KGK domain', NULL, 'KGK', NULL, NULL, 14322, 9),
(271636, NULL, 'PF12866', NULL, NULL, 'Protein of unknown function (DUF3823) N-terminal domain', NULL, 'DUF3823', NULL, NULL, 12414, 9),
(271637, NULL, 'PF14275', NULL, NULL, 'Domain of unknown function (DUF4362)', NULL, 'DUF4362', NULL, NULL, 21849, 9),
(271638, NULL, 'PF06612', NULL, NULL, 'Protein of unknown function (DUF1146)', NULL, 'DUF1146', NULL, NULL, 9739, 9),
(271639, NULL, 'PF14394', NULL, NULL, 'Domain of unknown function (DUF4423)', NULL, 'DUF4423', NULL, NULL, 26134, 9),
(271640, NULL, 'PF10346', NULL, NULL, 'Conidiation protein 6', NULL, 'Con-6', NULL, NULL, 19998, 9),
(271641, NULL, 'PF18744', NULL, NULL, 'Secreted Novel AID/APOBEC-like Deaminase 1', NULL, 'SNAD1', NULL, NULL, 28859, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(271642, NULL, 'PF13194', NULL, NULL, 'Domain of unknown function (DUF4010)', NULL, 'DUF4010', NULL, NULL, 22131, 9),
(271643, NULL, 'PF16096', NULL, NULL, 'Fragile X-related 1 protein C-terminal region 2', NULL, 'FXR_C1', NULL, NULL, 23564, 9),
(271644, NULL, 'PF05363', NULL, NULL, 'Herpesvirus US12 family', NULL, 'Herpes_US12', NULL, NULL, 5256, 9),
(271645, NULL, 'PF09349', NULL, NULL, 'OHCU decarboxylase', NULL, 'OHCU_decarbox', NULL, NULL, 12364, 9),
(271646, NULL, 'PF13114', NULL, NULL, 'RecO N terminal', NULL, 'RecO_N_2', NULL, NULL, 16047, 9),
(271647, NULL, 'PF12935', NULL, NULL, 'Vesicle coat trafficking protein Sec16 N-terminus', NULL, 'Sec16_N', NULL, NULL, 26709, 9),
(271648, NULL, 'PF10312', NULL, NULL, 'Conserved mid region of cactin', NULL, 'Cactin_mid', NULL, NULL, 19840, 9),
(271649, NULL, 'PF14075', NULL, NULL, 'Ubinuclein conserved middle domain', NULL, 'UBN_AB', NULL, NULL, 26612, 9),
(271650, NULL, 'PF17105', NULL, NULL, 'C-terminal domain of bromodomain protein 4', NULL, 'BRD4_CDT', NULL, NULL, 2657, 9),
(271651, NULL, 'PF17637', NULL, NULL, 'Family of unknown function (DUF5516)', NULL, 'DUF5516', NULL, NULL, 29342, 9),
(271652, NULL, 'PF16896', NULL, NULL, 'Phosphogluconate dehydrogenase (decarboxylating) C-term', NULL, 'PGDH_C', NULL, NULL, 22564, 9),
(271653, NULL, 'PF16828', NULL, NULL, 'GAG-binding domain on surface antigen', NULL, 'GAGBD', NULL, NULL, 22149, 9),
(271654, NULL, 'PF04970', NULL, NULL, 'Lecithin retinol acyltransferase', NULL, 'LRAT', NULL, NULL, 6651, 9),
(271655, NULL, 'PF13597', NULL, NULL, 'Anaerobic ribonucleoside-triphosphate reductase', NULL, 'NRDD', NULL, NULL, 12910, 9),
(271656, NULL, 'PF09627', NULL, NULL, 'PrgU-like protein', NULL, 'PrgU', NULL, NULL, 15566, 9),
(271657, NULL, 'PF06757', NULL, NULL, 'Insect allergen related repeat, nitrile-specifier detoxification', NULL, 'Ins_allergen_rp', NULL, NULL, 9237, 9),
(271658, NULL, 'PF02765', NULL, NULL, 'Telomeric single stranded DNA binding POT1/CDC13', NULL, 'POT1', NULL, NULL, 12218, 9),
(271659, NULL, 'PF07515', NULL, NULL, 'Putative conjugal transfer nickase/helicase TraI C-term', NULL, 'TraI_2_C', NULL, NULL, 11291, 9),
(271660, NULL, 'PF13904', NULL, NULL, 'Coiled-coil domain-containing protein 3', NULL, 'CCDC34', NULL, NULL, 23249, 9),
(271661, NULL, 'PF06277', NULL, NULL, 'Ethanolamine utilisation protein EutA', NULL, 'EutA', NULL, NULL, 14765, 9),
(271662, NULL, 'PF08654', NULL, NULL, 'DASH complex subunit Dad2', NULL, 'DASH_Dad2', NULL, NULL, 7720, 9),
(271663, NULL, 'PF10656', NULL, NULL, 'Hypothetical protein of unknown function (DUF2483)', NULL, 'DUF2483', NULL, NULL, 14616, 9),
(271664, NULL, 'PF06803', NULL, NULL, 'Protein of unknown function (DUF1232)', NULL, 'DUF1232', NULL, NULL, 9038, 9),
(271665, NULL, 'PF05518', NULL, NULL, 'Totivirus coat protein', NULL, 'Totivirus_coat', NULL, NULL, 7816, 9),
(271666, NULL, 'PF00306', NULL, NULL, 'ATP synthase alpha/beta chain, C terminal domain', NULL, 'ATP-synt_ab_C', NULL, NULL, 4623, 9),
(271667, NULL, 'PF07864', NULL, NULL, 'Protein of unknown function (DUF1651)', NULL, 'DUF1651', NULL, NULL, 14130, 9),
(271668, NULL, 'PF14366', NULL, NULL, 'Domain of unknown function (DUF4410)', NULL, 'DUF4410', NULL, NULL, 26282, 9),
(271669, NULL, 'PF10890', NULL, NULL, 'Cytochrome b-c1 complex subunit 8', NULL, 'Cyt_b-c1_8', NULL, NULL, 12719, 9),
(271670, NULL, 'PF00809', NULL, NULL, 'Pterin binding enzyme', NULL, 'Pterin_bind', NULL, NULL, 5583, 9),
(271671, NULL, 'PF12772', NULL, NULL, 'Growth hormone receptor binding', NULL, 'GHBP', NULL, NULL, 25806, 9),
(271672, NULL, 'PF07896', NULL, NULL, 'Protein of unknown function (DUF1674)', NULL, 'DUF1674', NULL, NULL, 12094, 9),
(271673, NULL, 'PF09655', NULL, NULL, 'Conserved nitrate reductase-associated protein (Nitr_red_assoc)', NULL, 'Nitr_red_assoc', NULL, NULL, 10472, 9),
(271674, NULL, 'PF03432', NULL, NULL, 'Relaxase/Mobilisation nuclease domain', NULL, 'Relaxase', NULL, NULL, 10248, 9),
(271675, NULL, 'PF08666', NULL, NULL, 'SAF domain', NULL, 'SAF', NULL, NULL, 7557, 9),
(271676, NULL, 'PF14061', NULL, NULL, 'Polycomb-like MTF2 factor 2', NULL, 'Mtf2_C', NULL, NULL, 25632, 9);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(271677, NULL, 'PF19061', NULL, NULL, 'Family of unknown function (DUF5757)', NULL, 'DUF5757', NULL, NULL, 35418, 9),
(271678, NULL, 'PF00237', NULL, NULL, 'Ribosomal protein L22p/L17e', NULL, 'Ribosomal_L22', NULL, NULL, 2301, 9),
(271679, NULL, 'PF14123', NULL, NULL, 'Domain of unknown function (DUF4290)', NULL, 'DUF4290', NULL, NULL, 24736, 9),
(271680, NULL, 'PF20092', NULL, NULL, 'Family of unknown function (DUF6483)', NULL, 'DUF6483', NULL, NULL, 37138, 9),
(271681, NULL, 'PF15375', NULL, NULL, 'Domain of unknown function (DUF4602)', NULL, 'DUF4602', NULL, NULL, 25283, 9),
(271682, NULL, 'PF03148', NULL, NULL, 'Tektin family', NULL, 'Tektin', NULL, NULL, NULL, 9),
(271683, NULL, 'PF17638', NULL, NULL, 'HCMV UL42', NULL, 'UL42', NULL, NULL, 29356, 9),
(271684, NULL, 'PF05460', NULL, NULL, 'Origin recognition complex subunit 6 (ORC6)', NULL, 'ORC6', NULL, NULL, 12429, 9),
(271685, NULL, 'PF01427', NULL, NULL, 'D-ala-D-ala dipeptidase', NULL, 'Peptidase_M15', NULL, NULL, 6750, 9),
(271686, NULL, 'PF04673', NULL, NULL, 'Polyketide synthesis cyclase', NULL, 'Cyclase_polyket', NULL, NULL, 3302, 9),
(271687, NULL, 'PF05159', NULL, NULL, 'Capsule polysaccharide biosynthesis protein', NULL, 'Capsule_synth', NULL, NULL, 2111, 9),
(271688, NULL, 'PF12436', NULL, NULL, 'ICP0-binding domain of Ubiquitin-specific protease 7', NULL, 'USP7_ICP0_bdg', NULL, NULL, 975, 9),
(271689, NULL, 'PF12098', NULL, NULL, 'Protein of unknown function (DUF3574)', NULL, 'DUF3574', NULL, NULL, 20410, 9),
(271690, NULL, 'PF14585', NULL, NULL, 'CagY type 1 repeat', NULL, 'CagY_I', NULL, NULL, 21007, 9),
(271691, NULL, 'PF15494', NULL, NULL, 'Scavenger receptor cysteine-rich domain', NULL, 'SRCR_2', NULL, NULL, 18501, 9),
(271692, NULL, 'PF16254', NULL, NULL, 'Domain of unknown function (DUF4910)', NULL, 'DUF4910', NULL, NULL, 23587, 9),
(271693, NULL, 'PF19006', NULL, NULL, 'Family of unknown function (DUF5735)', NULL, 'DUF5735', NULL, NULL, 35911, 9),
(271694, NULL, 'PF03040', NULL, NULL, 'CemA family', NULL, 'CemA', NULL, NULL, 4549, 9),
(271695, NULL, 'PF17867', NULL, NULL, 'Midasin AAA lid domain', NULL, 'AAA_lid_7', NULL, NULL, 32698, 9),
(271696, NULL, 'PF18697', NULL, NULL, 'Murine leukemia virus (MLV) integrase (IN) C-terminal domain', NULL, 'MLVIN_C', NULL, NULL, 28017, 9),
(271697, NULL, 'PF16524', NULL, NULL, 'Periplasmic domain of Sensor histidine kinase RisS', NULL, 'RisS_PPD', NULL, NULL, 25067, 9),
(271698, NULL, 'PF03916', NULL, NULL, 'Polysulphide reductase, NrfD', NULL, 'NrfD', NULL, NULL, 2906, 9),
(271699, NULL, 'PF01063', NULL, NULL, 'Amino-transferase class IV', NULL, 'Aminotran_4', NULL, NULL, 3079, 9),
(271700, NULL, 'PF14281', NULL, NULL, 'PD-(D/E)XK nuclease superfamily', NULL, 'PDDEXK_4', NULL, NULL, 26704, 9),
(271701, NULL, 'PF20013', NULL, NULL, 'GTPase-associated protein 1, N-terminal domain type 2', NULL, 'GAP1-N2', NULL, NULL, 35602, 9),
(271702, NULL, 'PF00153', NULL, NULL, 'Mitochondrial carrier protein', NULL, 'Mito_carr', NULL, NULL, 13675, 9),
(271703, NULL, 'PF10452', NULL, NULL, 'TORC1 subunit TCO89', NULL, 'TCO89', NULL, NULL, 20590, 9),
(271704, NULL, 'PF00885', NULL, NULL, '6,7-dimethyl-8-ribityllumazine synthase', NULL, 'DMRL_synthase', NULL, NULL, 1475, 9),
(271705, NULL, 'PF16273', NULL, NULL, 'Nuclear distribution C domain', NULL, 'NuDC', NULL, NULL, 21757, 9),
(271706, NULL, 'PF08896', NULL, NULL, 'Domain of unknown function (DUF1842)', NULL, 'DUF1842', NULL, NULL, 7610, 9),
(271707, NULL, 'PF06842', NULL, NULL, 'Protein of unknown function (DUF1242)', NULL, 'DUF1242', NULL, NULL, 11195, 9),
(271708, NULL, 'PF16211', NULL, NULL, 'C-terminus of histone H2A', NULL, 'Histone_H2A_C', NULL, NULL, 23645, 9),
(271709, NULL, 'PF02893', NULL, NULL, 'GRAM domain', NULL, 'GRAM', NULL, NULL, 2538, 9),
(271710, NULL, 'PF01401', NULL, NULL, 'Angiotensin-converting enzyme', NULL, 'Peptidase_M2', NULL, NULL, 3355, 9),
(271711, NULL, 'PF16761', NULL, NULL, 'Transcription-silencing protein, cryptic loci regulator Clr2', NULL, 'Clr2_transil', NULL, NULL, 22802, 9),
(271712, NULL, 'PF01786', NULL, NULL, 'Alternative oxidase', NULL, 'AOX', NULL, NULL, 2676, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(271713, NULL, 'PF15792', NULL, NULL, 'Lung adenoma susceptibility protein 2', NULL, 'LAS2', NULL, NULL, 23876, 9),
(271714, NULL, 'PF13710', NULL, NULL, 'ACT domain', NULL, 'ACT_5', NULL, NULL, NULL, 9),
(271715, NULL, 'PF13681', NULL, NULL, 'Type IV pilus assembly protein PilX C-term', NULL, 'PilX', NULL, NULL, 21767, 9),
(271716, NULL, 'PF03779', NULL, NULL, 'SPW repeat', NULL, 'SPW', NULL, NULL, 1714, 9),
(271717, NULL, 'PF09064', NULL, NULL, 'Thrombomodulin like fifth domain, EGF-like', NULL, 'Tme5_EGF_like', NULL, NULL, 9985, 9),
(271718, NULL, 'PF18505', NULL, NULL, 'Domain of unknown function (DUF5619)', NULL, 'DUF5619', NULL, NULL, 28976, 9),
(271719, NULL, 'PF13817', NULL, NULL, 'IS66 C-terminal element', NULL, 'DDE_Tnp_IS66_C', NULL, NULL, 33244, 9),
(271720, NULL, 'PF15793', NULL, NULL, 'Protein family FAM35, C-terminal', NULL, 'FAM35_C', NULL, NULL, 23746, 9),
(271721, NULL, 'PF06994', NULL, NULL, 'Involucrin', NULL, 'Involucrin2', NULL, NULL, 12190, 9),
(271722, NULL, 'PF06903', NULL, NULL, 'VirK protein', NULL, 'VirK', NULL, NULL, 9680, 9),
(271723, NULL, 'PF15316', NULL, NULL, 'MyoD family inhibitor', NULL, 'MDFI', NULL, NULL, 25986, 9),
(271724, NULL, 'PF19615', NULL, NULL, 'Family of unknown function (DUF6120)', NULL, 'DUF6120', NULL, NULL, 37090, 9),
(271725, NULL, 'PF04490', NULL, NULL, 'Poxvirus T4 protein, C terminus', NULL, 'Pox_T4_C', NULL, NULL, 1871, 9),
(271726, NULL, 'PF13724', NULL, NULL, 'DNA-binding domain', NULL, 'DNA_binding_2', NULL, NULL, 24089, 9),
(271727, NULL, 'PF16797', NULL, NULL, 'Fungal kinase associated-1 domain', NULL, 'Fungal_KA1', NULL, NULL, 24326, 9),
(271728, NULL, 'PF08434', NULL, NULL, 'Calcium-activated chloride channel N terminal', NULL, 'CLCA', NULL, NULL, 12919, 9),
(271729, NULL, 'PF14956', NULL, NULL, 'Domain of unknown function (DUF4505)', NULL, 'DUF4505', NULL, NULL, 24705, 9),
(271730, NULL, 'PF19131', NULL, NULL, 'Family of unknown function (DUF5814)', NULL, 'DUF5814', NULL, NULL, 34256, 9),
(271731, NULL, 'PF10093', NULL, NULL, 'Elongation-Factor P (EF-P) rhamnosyltransferase EarP', NULL, 'EarP', NULL, NULL, 19273, 9),
(271732, NULL, 'PF15698', NULL, NULL, 'Phosphatase', NULL, 'Phosphatase', NULL, NULL, 26443, 9),
(271733, NULL, 'PF13903', NULL, NULL, 'PMP-22/EMP/MP20/Claudin tight junction', NULL, 'Claudin_2', NULL, NULL, 590, 9),
(271734, NULL, 'PF02978', NULL, NULL, 'Signal peptide binding domain', NULL, 'SRP_SPB', NULL, NULL, 1778, 9),
(271735, NULL, 'PF15537', NULL, NULL, 'Bacterial toxin 43', NULL, 'Ntox43', NULL, NULL, 23559, 9),
(271736, NULL, 'PF19547', NULL, NULL, 'Family of unknown function (DUF6071)', NULL, 'DUF6071', NULL, NULL, 36138, 9),
(271737, NULL, 'PF02934', NULL, NULL, 'GatB/GatE catalytic domain', NULL, 'GatB_N', NULL, NULL, 10444, 9),
(271738, NULL, 'PF04856', NULL, NULL, 'Securin sister-chromatid separation inhibitor', NULL, 'Securin', NULL, NULL, 5746, 9),
(271739, NULL, 'PF08122', NULL, NULL, 'NADH-ubiquinone oxidoreductase B12 subunit family', NULL, 'NDUF_B12', NULL, NULL, 9289, 9),
(271740, NULL, 'PF11654', NULL, NULL, 'Non-classical export protein 1', NULL, 'NCE101', NULL, NULL, 20341, 9),
(271741, NULL, 'PF18761', NULL, NULL, 'Heliorhodopsin', NULL, 'Heliorhodopsin', NULL, NULL, 28878, 9),
(271742, NULL, 'PF08472', NULL, NULL, 'Sucrose-6-phosphate phosphohydrolase C-terminal', NULL, 'S6PP_C', NULL, NULL, 13771, 9),
(271743, NULL, 'PF06256', NULL, NULL, 'Nucleopolyhedrovirus LEF-12 protein', NULL, 'Nucleo_LEF-12', NULL, NULL, 14229, 9),
(271744, NULL, 'PF07295', NULL, NULL, 'Zinc-ribbon containing domain', NULL, 'DUF1451', NULL, NULL, 14237, 9),
(271745, NULL, 'PF05050', NULL, NULL, 'Methyltransferase FkbM domain', NULL, 'Methyltransf_21', NULL, NULL, 4939, 9),
(271746, NULL, 'PF06618', NULL, NULL, 'Protein of unknown function (DUF1148)', NULL, 'DUF1148', NULL, NULL, 10262, 9),
(271747, NULL, 'PF11856', NULL, NULL, 'Protein of unknown function (DUF3376)', NULL, 'DUF3376', NULL, NULL, 12070, 9),
(271748, NULL, 'PF11428', NULL, NULL, 'Protein of unknown function (DUF3196)', NULL, 'DUF3196', NULL, NULL, 24410, 9);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(271749, NULL, 'PF13116', NULL, NULL, 'Protein of unknown function', NULL, 'DUF3971', NULL, NULL, 25963, 9),
(271750, NULL, 'PF09997', NULL, NULL, 'Predicted membrane protein (DUF2238)', NULL, 'DUF2238', NULL, NULL, 11261, 9),
(271751, NULL, 'PF09150', NULL, NULL, 'Orange carotenoid protein, N-terminal', NULL, 'Carot_N', NULL, NULL, 10836, 9),
(271752, NULL, 'PF03808', NULL, NULL, 'Glycosyl transferase WecG/TagA/CpsF family', NULL, 'Glyco_tran_WecG', NULL, NULL, 2136, 9),
(271753, NULL, 'PF10179', NULL, NULL, 'Neuron-derived neurotrophic factor, first Fn(III) domain', NULL, 'NDNF', NULL, NULL, 14918, 9),
(271754, NULL, 'PF14200', NULL, NULL, 'Ricin-type beta-trefoil lectin domain-like', NULL, 'RicinB_lectin_2', NULL, NULL, 3959, 9),
(271755, NULL, 'PF14614', NULL, NULL, 'Domain of unknown function (DUF4450)', NULL, 'DUF4450', NULL, NULL, 23785, 9),
(271756, NULL, 'PF00392', NULL, NULL, 'Bacterial regulatory proteins, gntR family', NULL, 'GntR', NULL, NULL, 5800, 9),
(271757, NULL, 'PF01470', NULL, NULL, 'Pyroglutamyl peptidase', NULL, 'Peptidase_C15', NULL, NULL, 11413, 9),
(271758, NULL, 'PF11227', NULL, NULL, 'Protein of unknown function (DUF3025)', NULL, 'DUF3025', NULL, NULL, 18449, 9),
(271759, NULL, 'PF17813', NULL, NULL, 'RET Cadherin like domain 4', NULL, 'RET_CLD4', NULL, NULL, 30094, 9),
(271760, NULL, 'PF17507', NULL, NULL, 'Family of unknown function (DUF5439)', NULL, 'DUF5439', NULL, NULL, 12908, 9),
(271761, NULL, 'PF02729', NULL, NULL, 'Aspartate/ornithine carbamoyltransferase, carbamoyl-P binding domain', NULL, 'OTCace_N', NULL, NULL, 10467, 9),
(271762, NULL, 'PF00143', NULL, NULL, 'Interferon alpha/beta domain', NULL, 'Interferon', NULL, NULL, 5598, 9),
(271763, NULL, 'PF11500', NULL, NULL, 'Cut12 conserved domain', NULL, 'Cut12', NULL, NULL, 18586, 9),
(271764, NULL, 'PF16177', NULL, NULL, 'Acetyl-coenzyme A synthetase N-terminus', NULL, 'ACAS_N', NULL, NULL, 23171, 9),
(271765, NULL, 'PF04602', NULL, NULL, 'Mycobacterial cell wall arabinan synthesis protein', NULL, 'Arabinose_trans', NULL, NULL, 993, 9),
(271766, NULL, 'PF04031', NULL, NULL, 'Las1-like', NULL, 'Las1', NULL, NULL, 348, 9),
(271767, NULL, 'PF01669', NULL, NULL, 'Myelin basic protein', NULL, 'Myelin_MBP', NULL, NULL, 5901, 9),
(271768, NULL, 'PF01705', NULL, NULL, 'CX module', NULL, 'CX', NULL, NULL, 2802, 9),
(271769, NULL, 'PF18811', NULL, NULL, 'Dipeptidyl peptidase IV (DPP IV) low complexity region', NULL, 'DPPIV_rep', NULL, NULL, 31841, 9),
(271770, NULL, 'PF20533', NULL, NULL, 'Domain of unknown function (DUF6748)', NULL, 'DUF6748', NULL, NULL, 33633, 9),
(271771, NULL, 'PF05254', NULL, NULL, 'Uncharacterised protein family (UPF0203)', NULL, 'UPF0203', NULL, NULL, 3223, 9),
(271772, NULL, 'PF14243', NULL, NULL, 'ATP-grasp domain, R2K clade family 3', NULL, 'R2K_3', NULL, NULL, 24697, 9),
(271773, NULL, 'PF05310', NULL, NULL, 'Tenuivirus movement protein', NULL, 'Tenui_NS3', NULL, NULL, 4034, 9),
(271774, NULL, 'PF17513', NULL, NULL, 'Family of unknown function (DUF5441)', NULL, 'DUF5441', NULL, NULL, 16341, 9),
(271775, NULL, 'PF03212', NULL, NULL, 'Pertactin', NULL, 'Pertactin', NULL, NULL, 1888, 9),
(271776, NULL, 'PF19411', NULL, NULL, 'Cell cycle link protein Clink', NULL, 'Clink', NULL, NULL, 36134, 9),
(271777, NULL, 'PF00471', NULL, NULL, 'Ribosomal protein L33', NULL, 'Ribosomal_L33', NULL, NULL, 3058, 9),
(271778, NULL, 'PF06689', NULL, NULL, 'ClpX C4-type zinc finger', NULL, 'zf-C4_ClpX', NULL, NULL, 8146, 9),
(271779, NULL, 'PF20293', NULL, NULL, 'ABC-three component (ABC-3C) system Middle Component 6', NULL, 'MC6', NULL, NULL, 34120, 9),
(271780, NULL, 'PF14224', NULL, NULL, 'Domain of unknown function (DUF4331)', NULL, 'DUF4331', NULL, NULL, 23149, 9),
(271781, NULL, 'PF08488', NULL, NULL, 'Wall-associated kinase', NULL, 'WAK', NULL, NULL, 13751, 9),
(271782, NULL, 'PF19413', NULL, NULL, 'YaiO membrane beta barrel domain', NULL, 'YaiO', NULL, NULL, 22087, 9),
(271783, NULL, 'PF00717', NULL, NULL, 'Peptidase S24-like', NULL, 'Peptidase_S24', NULL, NULL, 8444, 9),
(271784, NULL, 'PF05830', NULL, NULL, 'Nodulation protein Z (NodZ)', NULL, 'NodZ', NULL, NULL, 13276, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(271785, NULL, 'PF12327', NULL, NULL, 'FtsZ family, C-terminal domain', NULL, 'FtsZ_C', NULL, NULL, 21131, 9),
(271786, NULL, 'PF08468', NULL, NULL, 'Methyltransferase small domain N-terminal', NULL, 'MTS_N', NULL, NULL, 13992, 9),
(271787, NULL, 'PF19156', NULL, NULL, 'Family of unknown function (DUF5838)', NULL, 'DUF5838', NULL, NULL, 26498, 9),
(271788, NULL, 'PF07217', NULL, NULL, 'Heterokaryon incompatibility protein Het-C', NULL, 'Het-C', NULL, NULL, 10707, 9),
(271789, NULL, 'PF07536', NULL, NULL, 'HWE histidine kinase', NULL, 'HWE_HK', NULL, NULL, 11050, 9),
(271790, NULL, 'PF00836', NULL, NULL, 'Stathmin family', NULL, 'Stathmin', NULL, NULL, 3445, 9),
(271791, NULL, 'PF08980', NULL, NULL, 'Domain of unknown function (DUF1883)', NULL, 'DUF1883', NULL, NULL, 8959, 9),
(271792, NULL, 'PF16360', NULL, NULL, 'GTP-binding GTPase Middle Region', NULL, 'GTP-bdg_M', NULL, NULL, 25320, 9),
(271793, NULL, 'PF16330', NULL, NULL, 'MukB hinge domain', NULL, 'MukB_hinge', NULL, NULL, 24785, 9),
(271794, NULL, 'PF04008', NULL, NULL, 'Adenosine specific kinase', NULL, 'Adenosine_kin', NULL, NULL, 267, 9),
(271795, NULL, 'PF08301', NULL, NULL, 'Hepatitis C virus non-structural 5a domain 1b', NULL, 'HCV_NS5a_1b', NULL, NULL, 17375, 9),
(271796, NULL, 'PF02447', NULL, NULL, 'GntP family permease', NULL, 'GntP_permease', NULL, NULL, 6292, 9),
(271797, NULL, 'PF03998', NULL, NULL, 'Utp11 protein', NULL, 'Utp11', NULL, NULL, 162, 9),
(271798, NULL, 'PF16675', NULL, NULL, 'KIX-binding domain of forkhead box O, CR2', NULL, 'FOXO_KIX_bdg', NULL, NULL, 26378, 9),
(271799, NULL, 'PF11622', NULL, NULL, 'Protein of unknown function (DUF3251)', NULL, 'DUF3251', NULL, NULL, 18646, 9),
(271800, NULL, 'PF16525', NULL, NULL, 'Haemophore, haem-binding', NULL, 'MHB', NULL, NULL, 25498, 9),
(271801, NULL, 'PF15947', NULL, NULL, 'Domain of unknown function (DUF4755)', NULL, 'DUF4755', NULL, NULL, 22012, 9),
(271802, NULL, 'PF12306', NULL, NULL, 'Inclusion body protein', NULL, 'PixA', NULL, NULL, 15147, 9),
(271803, NULL, 'PF19229', NULL, NULL, 'Family of unknown function (DUF5882)', NULL, 'DUF5882', NULL, NULL, 35259, 9),
(271804, NULL, 'PF17453', NULL, NULL, 'Sigma-M inhibitor', NULL, 'Sigma_M_inh', NULL, NULL, 20209, 9),
(271805, NULL, 'PF13078', NULL, NULL, 'Protein of unknown function (DUF3942)', NULL, 'DUF3942', NULL, NULL, 22956, 9),
(271806, NULL, 'PF00854', NULL, NULL, 'POT family', NULL, 'PTR2', NULL, NULL, 3533, 9),
(271807, NULL, 'PF16269', NULL, NULL, 'Domain of unknown function (DUF4922)', NULL, 'DUF4922', NULL, NULL, 37639, 9),
(271808, NULL, 'PF00921', NULL, NULL, 'Borrelia lipoprotein', NULL, 'Lipoprotein_2', NULL, NULL, 3644, 9),
(271809, NULL, 'PF01964', NULL, NULL, 'Radical SAM ThiC family', NULL, 'ThiC_Rad_SAM', NULL, NULL, 4807, 9),
(271810, NULL, 'PF09261', NULL, NULL, 'Alpha mannosidase middle domain', NULL, 'Alpha-mann_mid', NULL, NULL, 13160, 9),
(271811, NULL, 'PF07794', NULL, NULL, 'Protein of unknown function (DUF1633)', NULL, 'DUF1633', NULL, NULL, 14061, 9),
(271812, NULL, 'PF12480', NULL, NULL, 'Protein of unknown function (DUF3699)', NULL, 'DUF3699', NULL, NULL, 20511, 9),
(271813, NULL, 'PF00830', NULL, NULL, 'Ribosomal L28 family', NULL, 'Ribosomal_L28', NULL, NULL, 21734, 9),
(271814, NULL, 'PF15327', NULL, NULL, 'Tankyrase binding protein C terminal domain', NULL, 'Tankyrase_bdg_C', NULL, NULL, 22448, 9),
(271815, NULL, 'PF01366', NULL, NULL, 'Herpesvirus processing and transport protein', NULL, 'PRTP', NULL, NULL, 4293, 9),
(271816, NULL, 'PF07405', NULL, NULL, 'Protein of unknown function (DUF1506)', NULL, 'DUF1506', NULL, NULL, 11692, 9),
(271817, NULL, 'PF01835', NULL, NULL, 'MG2 domain', NULL, 'MG2', NULL, NULL, 5607, 9),
(271818, NULL, 'PF20615', NULL, NULL, 'Family of unknown function (DUF6802)', NULL, 'DUF6802', NULL, NULL, 37567, 9),
(271819, NULL, 'PF10863', NULL, NULL, 'Nucleolar protein 19', NULL, 'NOP19', NULL, NULL, 16961, 9),
(271820, NULL, 'PF00027', NULL, NULL, 'Cyclic nucleotide-binding domain', NULL, 'cNMP_binding', NULL, NULL, 5904, 9),
(271821, NULL, 'PF10653', NULL, NULL, 'Protein gp45 of Bacteriophage A118', NULL, 'Phage-A118_gp45', NULL, NULL, 14535, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(271822, NULL, 'PF10078', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2316)', NULL, 'DUF2316', NULL, NULL, 18095, 9),
(271823, NULL, 'PF13893', NULL, NULL, 'RNA recognition motif. (a.k.a. RRM, RBD, or RNP domain)', NULL, 'RRM_5', NULL, NULL, NULL, 9),
(271824, NULL, 'PF16365', NULL, NULL, 'Ethanolamine utilization protein EutK C-terminus', NULL, 'EutK_C', NULL, NULL, 23982, 9),
(271825, NULL, 'PF19684', NULL, NULL, 'Family of unknown function (DUF6186)', NULL, 'DUF6186', NULL, NULL, 37006, 9),
(271826, NULL, 'PF03428', NULL, NULL, 'Replication protein C N-terminal domain', NULL, 'RP-C', NULL, NULL, 10288, 9),
(271827, NULL, 'PF04997', NULL, NULL, 'RNA polymerase Rpb1, domain 1', NULL, 'RNA_pol_Rpb1_1', NULL, NULL, 168, 9),
(271828, NULL, 'PF11780', NULL, NULL, 'Protein of unknown function (DUF3318)', NULL, 'DUF3318', NULL, NULL, 19343, 9),
(271829, NULL, 'PF18941', NULL, NULL, 'Family of unknown function (DUF5688)', NULL, 'DUF5688', NULL, NULL, 35786, 9),
(271830, NULL, 'PF13627', NULL, NULL, 'Prokaryotic lipoprotein-attachment site', NULL, 'LPAM_2', NULL, NULL, 21758, 9),
(271831, NULL, 'PF19092', NULL, NULL, 'Family of unknown function (DUF5780)', NULL, 'DUF5780', NULL, NULL, 35596, 9),
(271832, NULL, 'PF05124', NULL, NULL, 'S-layer like family, C-terminal region', NULL, 'S_layer_C', NULL, NULL, 16533, 9),
(271833, NULL, 'PF17433', NULL, NULL, 'Glycosyl hydrolase family 49 N-terminal Ig-like domain', NULL, 'Glyco_hydro_49N', NULL, NULL, 13495, 9),
(271834, NULL, 'PF01154', NULL, NULL, 'Hydroxymethylglutaryl-coenzyme A synthase N terminal', NULL, 'HMG_CoA_synt_N', NULL, NULL, 8601, 9),
(271835, NULL, 'PF10841', NULL, NULL, 'Protein of unknown function (DUF2644)', NULL, 'DUF2644', NULL, NULL, 21344, 9),
(271836, NULL, 'PF15797', NULL, NULL, 'Domain of unknown function (DUF4706)', NULL, 'DUF4706', NULL, NULL, 25377, 9),
(271837, NULL, 'PF20504', NULL, NULL, 'Integrator complex subunit 14, alpha-helical domain', NULL, 'IntS14_C', NULL, NULL, 37744, 9),
(271838, NULL, 'PF11805', NULL, NULL, 'Protein of unknown function (DUF3326)', NULL, 'DUF3326', NULL, NULL, 19094, 9),
(271839, NULL, 'PF12873', NULL, NULL, 'Domain of unknown function (DUF3825)', NULL, 'DUF3825', NULL, NULL, 26642, 9),
(271840, NULL, 'PF04769', NULL, NULL, 'Mating-type protein MAT alpha 1 HMG-box', NULL, 'MATalpha_HMGbox', NULL, NULL, 3853, 9),
(271841, NULL, 'PF08828', NULL, NULL, 'Doublesex dimerisation domain', NULL, 'DSX_dimer', NULL, NULL, 14485, 9),
(271842, NULL, 'PF13878', NULL, NULL, 'zinc-finger of acetyl-transferase ESCO', NULL, 'zf-C2H2_3', NULL, NULL, 23365, 9),
(271843, NULL, 'PF19698', NULL, NULL, 'Family of unknown function (DUF6197)', NULL, 'DUF6197', NULL, NULL, 36127, 9),
(271844, NULL, 'PF18881', NULL, NULL, 'Family of unknown function (DUF5646)', NULL, 'DUF5646', NULL, NULL, 34073, 9),
(271845, NULL, 'PF04258', NULL, NULL, 'Signal peptide peptidase', NULL, 'Peptidase_A22B', NULL, NULL, 5771, 9),
(271846, NULL, 'PF13683', NULL, NULL, 'Integrase core domain', NULL, 'rve_3', NULL, NULL, 5041, 9),
(271847, NULL, 'PF06875', NULL, NULL, 'Plethodontid receptivity factor PRF', NULL, 'PRF', NULL, NULL, 9493, 9),
(271848, NULL, 'PF13436', NULL, NULL, 'Glycine-zipper domain', NULL, 'Gly-zipper_OmpA', NULL, NULL, 24552, 9),
(271849, NULL, 'PF15783', NULL, NULL, 'Fibrous sheath-interacting protein 2', NULL, 'FSIP2', NULL, NULL, 23947, 9),
(271850, NULL, 'PF14452', NULL, NULL, 'Multiubiquitin', NULL, 'Multi_ubiq', NULL, NULL, 23706, 9),
(271851, NULL, 'PF00129', NULL, NULL, 'Class I Histocompatibility antigen, domains alpha 1 and 2', NULL, 'MHC_I', NULL, NULL, 12526, 9),
(271852, NULL, 'PF00146', NULL, NULL, 'NADH dehydrogenase', NULL, 'NADHdh', NULL, NULL, 3295, 9),
(271853, NULL, 'PF05125', NULL, NULL, 'Phage major capsid protein, P2 family', NULL, 'Phage_cap_P2', NULL, NULL, 6753, 9),
(271854, NULL, 'PF18978', NULL, NULL, 'Family of unknown function (DUF5714)', NULL, 'DUF5714', NULL, NULL, 35801, 9),
(271855, NULL, 'PF13360', NULL, NULL, 'PQQ-like domain', NULL, 'PQQ_2', NULL, NULL, 6324, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(271856, NULL, 'PF08653', NULL, NULL, 'DASH complex subunit Dam1', NULL, 'DASH_Dam1', NULL, NULL, 7532, 9),
(271857, NULL, 'PF15345', NULL, NULL, 'Transmembrane protein 51', NULL, 'TMEM51', NULL, NULL, NULL, 9),
(271858, NULL, 'PF00909', NULL, NULL, 'Ammonium Transporter Family', NULL, 'Ammonium_transp', NULL, NULL, 18809, 9),
(271859, NULL, 'PF04424', NULL, NULL, 'MINDY deubiquitinase', NULL, 'MINDY_DUB', NULL, NULL, 25852, 9),
(271860, NULL, 'PF09733', NULL, NULL, 'VEFS-Box of polycomb protein', NULL, 'VEFS-Box', NULL, NULL, 17522, 9),
(271861, NULL, 'PF05069', NULL, NULL, 'Phage virion morphogenesis family', NULL, 'Phage_tail_S', NULL, NULL, 55, 9),
(271862, NULL, 'PF08968', NULL, NULL, 'Domain of unknown function (DUF1885)', NULL, 'DUF1885', NULL, NULL, 8795, 9),
(271863, NULL, 'PF11440', NULL, NULL, 'DNA alpha-glucosyltransferase', NULL, 'AGT', NULL, NULL, 17242, 9),
(271864, NULL, 'PF05598', NULL, NULL, 'Transposase domain (DUF772)', NULL, 'DUF772', NULL, NULL, 12250, 9),
(271865, NULL, 'PF01492', NULL, NULL, 'Geminivirus C4 protein', NULL, 'Gemini_C4', NULL, NULL, 892, 9),
(271866, NULL, 'PF15912', NULL, NULL, 'Virilizer, N-terminal', NULL, 'VIR_N', NULL, NULL, 24276, 9),
(271867, NULL, 'PF03642', NULL, NULL, 'MAP domain', NULL, 'MAP', NULL, NULL, 5013, 9),
(271868, NULL, 'PF04037', NULL, NULL, 'Domain of unknown function (DUF382)', NULL, 'DUF382', NULL, NULL, 707, 9),
(271869, NULL, 'PF17228', NULL, NULL, 'Sulphur globule protein', NULL, 'SGP', NULL, NULL, 20415, 9),
(271870, NULL, 'PF11282', NULL, NULL, 'Protein of unknown function (DUF3082)', NULL, 'DUF3082', NULL, NULL, 18192, 9),
(271871, NULL, 'PF19820', NULL, NULL, 'Family of unknown function (DUF6303)', NULL, 'DUF6303', NULL, NULL, 37415, 9),
(271872, NULL, 'PF02343', NULL, NULL, 'TRA-1 regulated protein R03H10.4', NULL, 'TRA-1_regulated', NULL, NULL, 4048, 9),
(271873, NULL, 'PF18358', NULL, NULL, 'Histone methyltransferase Tudor domain', NULL, 'Tudor_4', NULL, NULL, 29230, 9),
(271874, NULL, 'PF09307', NULL, NULL, 'CLIP, MHC2 interacting', NULL, 'MHC2-interact', NULL, NULL, 14230, 9),
(271875, NULL, 'PF02064', NULL, NULL, 'MAS20 protein import receptor', NULL, 'MAS20', NULL, NULL, 5326, 9),
(271876, NULL, 'PF00618', NULL, NULL, 'RasGEF N-terminal motif', NULL, 'RasGEF_N', NULL, NULL, 6675, 9),
(271877, NULL, 'PF16156', NULL, NULL, 'Domain of unknown function (DUF4864)', NULL, 'DUF4864', NULL, NULL, 24073, 9),
(271878, NULL, 'PF11903', NULL, NULL, 'ParD-like antitoxin of type II bacterial toxin-antitoxin system', NULL, 'ParD_like', NULL, NULL, 19768, 9),
(271879, NULL, 'PF00609', NULL, NULL, 'Diacylglycerol kinase accessory domain', NULL, 'DAGK_acc', NULL, NULL, 6575, 9),
(271880, NULL, 'PF13845', NULL, NULL, 'Septum formation', NULL, 'Septum_form', NULL, NULL, 23177, 9),
(271881, NULL, 'PF09311', NULL, NULL, 'Rabaptin-like protein', NULL, 'Rab5-bind', NULL, NULL, 14446, 9),
(271882, NULL, 'PF03997', NULL, NULL, 'VPS28 protein', NULL, 'VPS28', NULL, NULL, 37, 9),
(271883, NULL, 'PF12090', NULL, NULL, 'Spt20 family', NULL, 'Spt20', NULL, NULL, 37674, 9),
(271884, NULL, 'PF01775', NULL, NULL, 'Ribosomal proteins 50S-L18Ae/60S-L20/60S-L18A', NULL, 'Ribosomal_L18A', NULL, NULL, 18552, 9),
(271885, NULL, 'PF09700', NULL, NULL, 'CRISPR-associated protein (Cas_Cmr3)', NULL, 'Cas_Cmr3', NULL, NULL, 17664, 9),
(271886, NULL, 'PF05628', NULL, NULL, 'Borrelia membrane protein P13', NULL, 'Borrelia_P13', NULL, NULL, 8975, 9),
(271887, NULL, 'PF14867', NULL, NULL, 'Lantibiotic alpha', NULL, 'Lantibiotic_a', NULL, NULL, 26923, 9),
(271888, NULL, 'PF13010', NULL, NULL, 'Primase helical domain', NULL, 'pRN1_helical', NULL, NULL, 19339, 9),
(271889, NULL, 'PF16013', NULL, NULL, 'Domain of unknown function (DUF4781)', NULL, 'DUF4781', NULL, NULL, 21517, 9),
(271890, NULL, 'PF17195', NULL, NULL, 'Protein of unknown function (DUF5132)', NULL, 'DUF5132', NULL, NULL, 31326, 9),
(271891, NULL, 'PF14901', NULL, NULL, 'Cleavage inducing molecular chaperone', NULL, 'Jiv90', NULL, NULL, 22257, 9),
(271892, NULL, 'PF15538', NULL, NULL, 'Bacterial toxin 46', NULL, 'Ntox46', NULL, NULL, 21487, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(271893, NULL, 'PF07250', NULL, NULL, 'Glyoxal oxidase N-terminus', NULL, 'Glyoxal_oxid_N', NULL, NULL, 14303, 9),
(271894, NULL, 'PF16431', NULL, NULL, 'Domain of unknown function (DUF5028)', NULL, 'DUF5028', NULL, NULL, 24320, 9),
(271895, NULL, 'PF19875', NULL, NULL, 'Family of unknown function (DUF6348)', NULL, 'DUF6348', NULL, NULL, 36568, 9),
(271896, NULL, 'PF17493', NULL, NULL, 'Family of unknown function (DUF5428)', NULL, 'DUF5428', NULL, NULL, 21246, 9),
(271897, NULL, 'PF10115', NULL, NULL, 'Transcriptional activator HlyU', NULL, 'HlyU', NULL, NULL, 18178, 9),
(271898, NULL, 'PF17260', NULL, NULL, 'Family of unknown function (DUF5326)', NULL, 'DUF5326', NULL, NULL, 21475, 9),
(271899, NULL, 'PF07971', NULL, NULL, 'Glycosyl hydrolase family 92', NULL, 'Glyco_hydro_92', NULL, NULL, 8244, 9),
(271900, NULL, 'PF12741', NULL, NULL, 'Susd and RagB outer membrane lipoprotein', NULL, 'SusD-like', NULL, NULL, 20820, 9),
(271901, NULL, 'PF19139', NULL, NULL, 'Family of unknown function (DUF5822)', NULL, 'DUF5822', NULL, NULL, 34303, 9),
(271902, NULL, 'PF07467', NULL, NULL, 'Beta-lactamase inhibitor (BLIP)', NULL, 'BLIP', NULL, NULL, 7560, 9),
(271903, NULL, 'PF19916', NULL, NULL, 'vWA-MoxR associated protein middle region 0', NULL, 'VMAP-M0', NULL, NULL, 33586, 9),
(271904, NULL, 'PF13558', NULL, NULL, 'SbcC/RAD50-like, Walker B motif', NULL, 'SbcC_Walker_B', NULL, NULL, NULL, 9),
(271905, NULL, 'PF11676', NULL, NULL, 'Protein of unknown function (DUF3272)', NULL, 'DUF3272', NULL, NULL, 19395, 9),
(271906, NULL, 'PF00954', NULL, NULL, 'S-locus glycoprotein domain', NULL, 'S_locus_glycop', NULL, NULL, 3323, 9),
(271907, NULL, 'PF16305', NULL, NULL, 'Domain of unknown function (DUF4947)', NULL, 'DUF4947', NULL, NULL, 25615, 9),
(271908, NULL, 'PF09686', NULL, NULL, 'Plasmid protein of unknown function (Plasmid_RAQPRD)', NULL, 'Plasmid_RAQPRD', NULL, NULL, 17517, 9),
(271909, NULL, 'PF14661', NULL, NULL, 'HAUS augmin-like complex subunit 6 N-terminus', NULL, 'HAUS6_N', NULL, NULL, 23750, 9),
(271910, NULL, 'PF08660', NULL, NULL, 'Oligosaccharide biosynthesis protein Alg14 like', NULL, 'Alg14', NULL, NULL, 7784, 9),
(271911, NULL, 'PF07319', NULL, NULL, 'Primosomal protein DnaI N-terminus', NULL, 'DnaI_N', NULL, NULL, 8055, 9),
(271912, NULL, 'PF15111', NULL, NULL, 'TMEM101 protein family', NULL, 'TMEM101', NULL, NULL, 26473, 9),
(271913, NULL, 'PF01688', NULL, NULL, 'Alphaherpesvirus glycoprotein I', NULL, 'Herpes_gI', NULL, NULL, 5713, 9),
(271914, NULL, 'PF11790', NULL, NULL, 'Glycosyl hydrolase catalytic core', NULL, 'Glyco_hydro_cc', NULL, NULL, 24923, 9),
(271915, NULL, 'PF12778', NULL, NULL, 'PXPV repeat (3 copies)', NULL, 'PXPV', NULL, NULL, 24043, 9),
(271916, NULL, 'PF15572', NULL, NULL, 'Immunity protein 45', NULL, 'Imm45', NULL, NULL, 25236, 9),
(271917, NULL, 'PF05341', NULL, NULL, 'Per os infectivity factor 6', NULL, 'PIF6', NULL, NULL, 5068, 9),
(271918, NULL, 'PF05220', NULL, NULL, 'MgpC adhesin', NULL, 'MgpC', NULL, NULL, 3400, 9),
(271919, NULL, 'PF03834', NULL, NULL, 'Binding domain of DNA repair protein Ercc1 (rad10/Swi10)', NULL, 'Rad10', NULL, NULL, 629, 9),
(271920, NULL, 'PF20449', NULL, NULL, 'Family of unknown function (DUF6706)', NULL, 'DUF6706', NULL, NULL, 37575, 9),
(271921, NULL, 'PF05323', NULL, NULL, 'Poxvirus A21 Protein', NULL, 'Pox_A21', NULL, NULL, 4017, 9),
(271922, NULL, 'PF14950', NULL, NULL, 'Domain of unknown function (DUF4502)', NULL, 'DUF4502', NULL, NULL, 23825, 9),
(271923, NULL, 'PF18794', NULL, NULL, 'DNA mismatch repair protein HSM3, C terminal domain', NULL, 'HSM3_C', NULL, NULL, 28875, 9),
(271924, NULL, 'PF19517', NULL, NULL, 'Family of unknown function (DUF6050)', NULL, 'DUF6050', NULL, NULL, 37082, 9),
(271925, NULL, 'PF19744', NULL, NULL, 'Family of unknown function (DUF6232)', NULL, 'DUF6232', NULL, NULL, 37401, 9),
(271926, NULL, 'PF00398', NULL, NULL, 'Ribosomal RNA adenine dimethylase', NULL, 'RrnaAD', NULL, NULL, 3332, 9),
(271927, NULL, 'PF08014', NULL, NULL, 'Domain of unknown function (DUF1704)', NULL, 'DUF1704', NULL, NULL, 8595, 9);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(271928, NULL, 'PF04900', NULL, NULL, 'Fcf1', NULL, 'Fcf1', NULL, NULL, 5548, 9),
(271929, NULL, 'PF07815', NULL, NULL, 'Abl-interactor HHR', NULL, 'Abi_HHR', NULL, NULL, 12227, 9),
(271930, NULL, 'PF18221', NULL, NULL, 'Mutator 2 Fork head associated domain', NULL, 'MU2_FHA', NULL, NULL, 27998, 9),
(271931, NULL, 'PF16484', NULL, NULL, 'Carnitine O-palmitoyltransferase N-terminus', NULL, 'CPT_N', NULL, NULL, 17877, 9),
(271932, NULL, 'PF20297', NULL, NULL, 'MutS2 and Smr-associated SH3 domain', NULL, 'MSSS', NULL, NULL, 36539, 9),
(271933, NULL, 'PF09298', NULL, NULL, 'Fumarylacetoacetase N-terminal', NULL, 'FAA_hydrolase_N', NULL, NULL, 14302, 9),
(271934, NULL, 'PF00661', NULL, NULL, 'Viral matrix protein', NULL, 'Matrix', NULL, NULL, 3097, 9),
(271935, NULL, 'PF02256', NULL, NULL, 'Iron hydrogenase small subunit', NULL, 'Fe_hyd_SSU', NULL, NULL, 3349, 9),
(271936, NULL, 'PF20347', NULL, NULL, 'Family of unknown function (DUF6642)', NULL, 'DUF6642', NULL, NULL, 33841, 9),
(271937, NULL, 'PF16543', NULL, NULL, 'DRG Family Regulatory Proteins, Tma46', NULL, 'DFRP_C', NULL, NULL, 21860, 9),
(271938, NULL, 'PF09439', NULL, NULL, 'Signal recognition particle receptor beta subunit', NULL, 'SRPRB', NULL, NULL, 15698, 9),
(271939, NULL, 'PF19606', NULL, NULL, 'Family of unknown function (DUF6111)', NULL, 'DUF6111', NULL, NULL, 36861, 9),
(271940, NULL, 'PF08049', NULL, NULL, 'IlvB leader peptide', NULL, 'IlvB_leader', NULL, NULL, 9318, 9),
(271941, NULL, 'PF14499', NULL, NULL, 'Domain of unknown function (DUF4437)', NULL, 'DUF4437', NULL, NULL, 23716, 9),
(271942, NULL, 'PF19259', NULL, NULL, 'Ty3 transposon capsid-like protein', NULL, 'Ty3_capsid', NULL, NULL, 35384, 9),
(271943, NULL, 'PF18760', NULL, NULL, 'ADP-Ribosyltransferase in polyvalent proteins', NULL, 'ART-PolyVal', NULL, NULL, NULL, 9),
(271944, NULL, 'PF14330', NULL, NULL, 'Domain of unknown function (DUF4387)', NULL, 'DUF4387', NULL, NULL, 26082, 9),
(271945, NULL, 'PF07697', NULL, NULL, '7TM-HD extracellular', NULL, '7TMR-HDED', NULL, NULL, 9901, 9),
(271946, NULL, 'PF13889', NULL, NULL, 'Chromosome segregation during meiosis', NULL, 'Chromosome_seg', NULL, NULL, 27024, 9),
(271947, NULL, 'PF12978', NULL, NULL, 'Domain of Unknown Function with PDB structure (DUF3862)', NULL, 'DUF3862', NULL, NULL, 22146, 9),
(271948, NULL, 'PF01041', NULL, NULL, 'DegT/DnrJ/EryC1/StrS aminotransferase family', NULL, 'DegT_DnrJ_EryC1', NULL, NULL, 4124, 9),
(271949, NULL, 'PF09112', NULL, NULL, 'Peptide-N-glycosidase F, N terminal', NULL, 'N-glycanase_N', NULL, NULL, 10827, 9),
(271950, NULL, 'PF14980', NULL, NULL, 'TIP39 peptide', NULL, 'TIP39', NULL, NULL, 23039, 9),
(271951, NULL, 'PF16409', NULL, NULL, 'Domain of unknown function (DUF5017)', NULL, 'DUF5017', NULL, NULL, 23663, 9),
(271952, NULL, 'PF10150', NULL, NULL, 'Ribonuclease E/G family', NULL, 'RNase_E_G', NULL, NULL, 14979, 9),
(271953, NULL, 'PF12712', NULL, NULL, 'Domain of unknown function (DUF3805)', NULL, 'DUF3805', NULL, NULL, 26615, 9),
(271954, NULL, 'PF00353', NULL, NULL, 'RTX calcium-binding nonapeptide repeat (4 copies)', NULL, 'HemolysinCabind', NULL, NULL, 7193, 9),
(271955, NULL, 'PF11151', NULL, NULL, 'Protein of unknown function (DUF2929)', NULL, 'DUF2929', NULL, NULL, 17713, 9),
(271956, NULL, 'PF14036', NULL, NULL, 'YlaH-like protein', NULL, 'YlaH', NULL, NULL, 26401, 9),
(271957, NULL, 'PF09222', NULL, NULL, 'Fimbrial adhesin F17-AG, lectin domain', NULL, 'Fim-adh_lectin', NULL, NULL, 13260, 9),
(271958, NULL, 'PF17215', NULL, NULL, 'S1 domain', NULL, 'Rrp44_S1', NULL, NULL, 31753, 9),
(271959, NULL, 'PF15737', NULL, NULL, 'Domain of unknown function (DUF4685)', NULL, 'DUF4685', NULL, NULL, 22002, 9),
(271960, NULL, 'PF17127', NULL, NULL, 'Domain of unknown function (DUF5106)', NULL, 'DUF5106', NULL, NULL, 27909, 9),
(271961, NULL, 'PF07137', NULL, NULL, 'VDE lipocalin domain', NULL, 'VDE', NULL, NULL, 10961, 9),
(271962, NULL, 'PF16278', NULL, NULL, 'C2HE / C2H2 / C2HC zinc-binding finger', NULL, 'zf-C2HE', NULL, NULL, 21548, 9),
(271963, NULL, 'PF08254', NULL, NULL, 'Threonine leader peptide', NULL, 'Leader_Thr', NULL, NULL, 10938, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(271964, NULL, 'PF00383', NULL, NULL, 'Cytidine and deoxycytidylate deaminase zinc-binding region', NULL, 'dCMP_cyt_deam_1', NULL, NULL, 5096, 9),
(271965, NULL, 'PF08482', NULL, NULL, 'ATP-dependent helicase C-terminal', NULL, 'HrpB_C', NULL, NULL, 13708, 9),
(271966, NULL, 'PF08109', NULL, NULL, 'Lactocin 705 family', NULL, 'Antimicrobial14', NULL, NULL, 12945, 9),
(271967, NULL, 'PF19468', NULL, NULL, 'Family of unknown function (DUF6005)', NULL, 'DUF6005', NULL, NULL, 36626, 9),
(271968, NULL, 'PF03641', NULL, NULL, 'Possible lysine decarboxylase', NULL, 'Lysine_decarbox', NULL, NULL, 25197, 9),
(271969, NULL, 'PF02431', NULL, NULL, 'Chalcone-flavanone isomerase', NULL, 'Chalcone', NULL, NULL, 10041, 9),
(271970, NULL, 'PF05359', NULL, NULL, 'Domain of Unknown Function (DUF748)', NULL, 'DUF748', NULL, NULL, 5320, 9),
(271971, NULL, 'PF17283', NULL, NULL, 'SprT-like zinc ribbon domain', NULL, 'Zn_ribbon_SprT', NULL, NULL, 28352, 9),
(271972, NULL, 'PF06356', NULL, NULL, 'Protein of unknown function (DUF1064)', NULL, 'DUF1064', NULL, NULL, 8365, 9),
(271973, NULL, 'PF08421', NULL, NULL, 'Putative zinc binding domain', NULL, 'Methyltransf_13', NULL, NULL, 11329, 9),
(271974, NULL, 'PF13324', NULL, NULL, 'Grap2 and cyclin-D-interacting', NULL, 'GCIP', NULL, NULL, NULL, 9),
(271975, NULL, 'PF11015', NULL, NULL, 'Protein of unknown function (DUF2853)', NULL, 'DUF2853', NULL, NULL, 17932, 9),
(271976, NULL, 'PF12116', NULL, NULL, 'Stage III sporulation protein D', NULL, 'SpoIIID', NULL, NULL, 9471, 9),
(271977, NULL, 'PF19954', NULL, NULL, 'Effector-associated domain 10', NULL, 'EAD10', NULL, NULL, 37421, 9),
(271978, NULL, 'PF09065', NULL, NULL, 'Haemadin', NULL, 'Haemadin', NULL, NULL, 9954, 9),
(271979, NULL, 'PF09318', NULL, NULL, 'Glycosyl transferase 1 domain A', NULL, 'Glyco_trans_A_1', NULL, NULL, 14376, 9),
(271980, NULL, 'PF04155', NULL, NULL, 'Ground-like domain', NULL, 'Ground-like', NULL, NULL, 7043, 9),
(271981, NULL, 'PF09043', NULL, NULL, 'D-Lysine 5,6-aminomutase TIM-barrel domain of alpha subunit', NULL, 'Lys-AminoMut_A', NULL, NULL, 9750, 9),
(271982, NULL, 'PF13980', NULL, NULL, 'Uncharacterised protein family (UPF0370)', NULL, 'UPF0370', NULL, NULL, 14501, 9),
(271983, NULL, 'PF16475', NULL, NULL, 'Domain of unknown function (DUF5052)', NULL, 'DUF5052', NULL, NULL, 18355, 9),
(271984, NULL, 'PF10069', NULL, NULL, 'Sensory domain in DIguanylate Cyclases and Two-component system', NULL, 'DICT', NULL, NULL, 19635, 9),
(271985, NULL, 'PF08780', NULL, NULL, 'Nucleotidyltransferase substrate binding protein like', NULL, 'NTase_sub_bind', NULL, NULL, 4139, 9),
(271986, NULL, 'PF12032', NULL, NULL, 'Regulatory CLIP domain of proteinases', NULL, 'CLIP', NULL, NULL, 14835, 9),
(271987, NULL, 'PF04172', NULL, NULL, 'LrgB-like family', NULL, 'LrgB', NULL, NULL, 48, 9),
(271988, NULL, 'PF05531', NULL, NULL, 'Nucleopolyhedrovirus P10 protein', NULL, 'NPV_P10', NULL, NULL, 13033, 9),
(271989, NULL, 'PF10854', NULL, NULL, 'Protein of unknown function (DUF2649)', NULL, 'DUF2649', NULL, NULL, 17584, 9),
(271990, NULL, 'PF17674', NULL, NULL, 'HHH domain', NULL, 'HHH_9', NULL, NULL, 30321, 9),
(271991, NULL, 'PF03653', NULL, NULL, 'Uncharacterised protein family (UPF0093)', NULL, 'UPF0093', NULL, NULL, 4201, 9),
(271992, NULL, 'PF14197', NULL, NULL, 'Centrosome localisation domain of PPC89', NULL, 'Cep57_CLD_2', NULL, NULL, 21623, 9),
(271993, NULL, 'PF06042', NULL, NULL, 'Nucleotidyltransferase', NULL, 'NTP_transf_6', NULL, NULL, 13523, 9),
(271994, NULL, 'PF17465', NULL, NULL, 'Chemokine-like protein, HHV-6 U83 gene product', NULL, 'U83', NULL, NULL, 15746, 9),
(271995, NULL, 'PF20108', NULL, NULL, 'Family of unknown function (DUF6498)', NULL, 'DUF6498', NULL, NULL, 35951, 9),
(271996, NULL, 'PF11258', NULL, NULL, 'Protein of unknown function (DUF3048) N-terminal domain', NULL, 'DUF3048', NULL, NULL, 18419, 9),
(271997, NULL, 'PF07081', NULL, NULL, 'Protein of unknown function (DUF1349)', NULL, 'DUF1349', NULL, NULL, 13125, 9),
(271998, NULL, 'PF09122', NULL, NULL, 'Domain of unknown function (DUF1930)', NULL, 'DUF1930', NULL, NULL, 10520, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(271999, NULL, 'PF13326', NULL, NULL, 'Photosystem II Pbs27', NULL, 'PSII_Pbs27', NULL, NULL, 24774, 9),
(272000, NULL, 'PF10217', NULL, NULL, 'Uncharacterized conserved protein (DUF2039)', NULL, 'DUF2039', NULL, NULL, 15878, 9),
(272001, NULL, 'PF14448', NULL, NULL, 'Nuclease N terminal', NULL, 'Nuc_N', NULL, NULL, 23840, 9),
(272002, NULL, 'PF05730', NULL, NULL, 'CFEM domain', NULL, 'CFEM', NULL, NULL, 8574, 9),
(272003, NULL, 'PF17565', NULL, NULL, 'Family of unknown function (DUF5471)', NULL, 'DUF5471', NULL, NULL, 31219, 9),
(272004, NULL, 'PF05857', NULL, NULL, 'TraX protein', NULL, 'TraX', NULL, NULL, 7618, 9),
(272005, NULL, 'PF01979', NULL, NULL, 'Amidohydrolase family', NULL, 'Amidohydro_1', NULL, NULL, 2359, 9),
(272006, NULL, 'PF07364', NULL, NULL, 'Metallopeptidase family M81', NULL, 'DUF1485', NULL, NULL, 9434, 9),
(272007, NULL, 'PF12769', NULL, NULL, '4TM region of pyridine nucleotide transhydrogenase, mitoch', NULL, 'PNTB_4TM', NULL, NULL, 26546, 9),
(272008, NULL, 'PF18305', NULL, NULL, '3'' to 5'' exonuclease C-terminal domain', NULL, 'DNA_pol_A_exoN', NULL, NULL, 29934, 9),
(272009, NULL, 'PF03383', NULL, NULL, 'Caenorhabditis serpentine receptor-like protein, class xa', NULL, 'Serpentine_r_xa', NULL, NULL, 2397, 9),
(272010, NULL, 'PF01642', NULL, NULL, 'Methylmalonyl-CoA mutase', NULL, 'MM_CoA_mutase', NULL, NULL, 2540, 9),
(272011, NULL, 'PF16637', NULL, NULL, 'Putative zinc-finger between two C2H2 zinc-fingers on Patz', NULL, 'zf-C2H2_assoc3', NULL, NULL, NULL, 9),
(272012, NULL, 'PF14286', NULL, NULL, 'DHHW protein', NULL, 'DHHW', NULL, NULL, 23754, 9),
(272013, NULL, 'PF09637', NULL, NULL, 'Med18 protein', NULL, 'Med18', NULL, NULL, 17751, 9),
(272014, NULL, 'PF14477', NULL, NULL, 'Membrane-polarising domain of Mso1', NULL, 'Mso1_C', NULL, NULL, NULL, 9),
(272015, NULL, 'PF19728', NULL, NULL, 'Family of unknown function (DUF6220)', NULL, 'DUF6220', NULL, NULL, 37262, 9),
(272016, NULL, 'PF09539', NULL, NULL, 'Protein of unknown function (DUF2385)', NULL, 'DUF2385', NULL, NULL, 10008, 9),
(272017, NULL, 'PF02350', NULL, NULL, 'UDP-N-acetylglucosamine 2-epimerase', NULL, 'Epimerase_2', NULL, NULL, 4302, 9),
(272018, NULL, 'PF15350', NULL, NULL, 'Ewing''s tumour-associated antigen 1 homologue', NULL, 'ETAA1', NULL, NULL, 24654, 9),
(272019, NULL, 'PF06931', NULL, NULL, 'Mastadenovirus E4 ORF3 protein', NULL, 'Adeno_E4_ORF3', NULL, NULL, 11619, 9),
(272020, NULL, 'PF07961', NULL, NULL, 'MBA1-like protein', NULL, 'MBA1', NULL, NULL, 3552, 9),
(272021, NULL, 'PF20398', NULL, NULL, 'Family of unknown function (DUF6691)', NULL, 'DUF6691', NULL, NULL, 37524, 9),
(272022, NULL, 'PF03160', NULL, NULL, 'Calx-beta domain', NULL, 'Calx-beta', NULL, NULL, 1472, 9),
(272023, NULL, 'PF02461', NULL, NULL, 'Ammonia monooxygenase', NULL, 'AMO', NULL, NULL, 5198, 9),
(272024, NULL, 'PF02174', NULL, NULL, 'PTB domain (IRS-1 type)', NULL, 'IRS', NULL, NULL, 6975, 9),
(272025, NULL, 'PF11121', NULL, NULL, 'Protein of unknown function (DUF2639)', NULL, 'DUF2639', NULL, NULL, 16265, 9),
(272026, NULL, 'PF08650', NULL, NULL, 'DASH complex subunit Dad4', NULL, 'DASH_Dad4', NULL, NULL, 7935, 9),
(272027, NULL, 'PF16785', NULL, NULL, 'Small metal-binding protein', NULL, 'SMBP', NULL, NULL, 26829, 9),
(272028, NULL, 'PF18131', NULL, NULL, 'KN17 SH3-like C-terminal domain', NULL, 'KN17_SH3', NULL, NULL, 30532, 9),
(272029, NULL, 'PF14423', NULL, NULL, 'Immunity protein Imm5', NULL, 'Imm5', NULL, NULL, 24676, 9),
(272030, NULL, 'PF13508', NULL, NULL, 'Acetyltransferase (GNAT) domain', NULL, 'Acetyltransf_7', NULL, NULL, 1841, 9),
(272031, NULL, 'PF14028', NULL, NULL, 'Lantibiotic biosynthesis dehydratase C-term', NULL, 'Lant_dehydr_C', NULL, NULL, 12779, 9),
(272032, NULL, 'PF00157', NULL, NULL, 'Pou domain - N-terminal to homeobox domain', NULL, 'Pou', NULL, NULL, 985, 9),
(272033, NULL, 'PF07007', NULL, NULL, 'Lysozyme inhibitor LprI', NULL, 'LprI', NULL, NULL, 12012, 9),
(272034, NULL, 'PF17243', NULL, NULL, 'POTRA domain TamA domain 1', NULL, 'POTRA_TamA_1', NULL, NULL, 28223, 9),
(272035, NULL, 'PF07652', NULL, NULL, 'Flavivirus DEAD domain', NULL, 'Flavi_DEAD', NULL, NULL, 12537, 9);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(272036, NULL, 'PF11193', NULL, NULL, 'Protein of unknown function (DUF2812)', NULL, 'DUF2812', NULL, NULL, 18104, 9),
(272037, NULL, 'PF12607', NULL, NULL, 'Protein of unknown function (DUF3772)', NULL, 'DUF3772', NULL, NULL, 21406, 9),
(272038, NULL, 'PF16413', NULL, NULL, 'DNA mismatch repair protein Mlh1 C-terminus', NULL, 'Mlh1_C', NULL, NULL, 23713, 9),
(272039, NULL, 'PF12849', NULL, NULL, 'PBP superfamily domain', NULL, 'PBP_like_2', NULL, NULL, 23574, 9),
(272040, NULL, 'PF02894', NULL, NULL, 'Oxidoreductase family, C-terminal alpha/beta domain', NULL, 'GFO_IDH_MocA_C', NULL, NULL, 1840, 9),
(272041, NULL, 'PF00340', NULL, NULL, 'Interleukin-1 / 18', NULL, 'IL1', NULL, NULL, 3267, 9),
(272042, NULL, 'PF13331', NULL, NULL, 'Domain of unknown function (DUF4093)', NULL, 'DUF4093', NULL, NULL, 26339, 9),
(272043, NULL, 'PF12626', NULL, NULL, 'Polymerase A arginine-rich C-terminus', NULL, 'PolyA_pol_arg_C', NULL, NULL, 25973, 9),
(272044, NULL, 'PF10172', NULL, NULL, 'Det1 complexing ubiquitin ligase', NULL, 'DDA1', NULL, NULL, 8295, 9),
(272045, NULL, 'PF13623', NULL, NULL, 'SurA N-terminal domain', NULL, 'SurA_N_2', NULL, NULL, NULL, 9),
(272046, NULL, 'PF02399', NULL, NULL, 'Origin of replication binding protein', NULL, 'Herpes_ori_bp', NULL, NULL, 5224, 9),
(272047, NULL, 'PF09306', NULL, NULL, 'Bacteriophage, scaffolding protein', NULL, 'Phage-scaffold', NULL, NULL, 14370, 9),
(272048, NULL, 'PF07678', NULL, NULL, 'A-macroglobulin TED domain', NULL, 'TED_complement', NULL, NULL, 9556, 9),
(272049, NULL, 'PF08920', NULL, NULL, 'Splicing factor 3B subunit 1', NULL, 'SF3b1', NULL, NULL, 7660, 9),
(272050, NULL, 'PF01336', NULL, NULL, 'OB-fold nucleic acid binding domain', NULL, 'tRNA_anti-codon', NULL, NULL, 5457, 9),
(272051, NULL, 'PF15842', NULL, NULL, 'Domain of unknown function (DUF4718)', NULL, 'DUF4718', NULL, NULL, 26184, 9),
(272052, NULL, 'PF02820', NULL, NULL, 'mbt repeat', NULL, 'MBT', NULL, NULL, 1582, 9),
(272053, NULL, 'PF11998', NULL, NULL, 'Low psii accumulation1 / Rep27', NULL, 'DUF3493', NULL, NULL, 19969, 9),
(272054, NULL, 'PF02762', NULL, NULL, 'CBL proto-oncogene N-terminus, SH2-like domain', NULL, 'Cbl_N3', NULL, NULL, 14105, 9),
(272055, NULL, 'PF15753', NULL, NULL, 'Biogenesis of lysosome-related organelles complex 1 subunit 3', NULL, 'BLOC1S3', NULL, NULL, 15538, 9),
(272056, NULL, 'PF20107', NULL, NULL, 'Family of unknown function (DUF6497)', NULL, 'DUF6497', NULL, NULL, 33587, 9),
(272057, NULL, 'PF20029', NULL, NULL, 'Domain of unknown function (DUF6436)', NULL, 'DUF6436', NULL, NULL, 34849, 9),
(272058, NULL, 'PF01219', NULL, NULL, 'Prokaryotic diacylglycerol kinase', NULL, 'DAGK_prokar', NULL, NULL, 4561, 9),
(272059, NULL, 'PF03946', NULL, NULL, 'Ribosomal protein L11, N-terminal domain', NULL, 'Ribosomal_L11_N', NULL, NULL, 21210, 9),
(272060, NULL, 'PF01165', NULL, NULL, 'Ribosomal protein S21', NULL, 'Ribosomal_S21', NULL, NULL, 4023, 9),
(272061, NULL, 'PF01494', NULL, NULL, 'FAD binding domain', NULL, 'FAD_binding_3', NULL, NULL, 6612, 9),
(272062, NULL, 'PF03172', NULL, NULL, 'HSR domain', NULL, 'HSR', NULL, NULL, 7361, 9),
(272063, NULL, 'PF03841', NULL, NULL, 'L-seryl-tRNA selenium transferase', NULL, 'SelA', NULL, NULL, 8246, 9),
(272064, NULL, 'PF09976', NULL, NULL, 'Tetratricopeptide repeat-like domain', NULL, 'TPR_21', NULL, NULL, 17340, 9),
(272065, NULL, 'PF01896', NULL, NULL, 'DNA primase small subunit', NULL, 'DNA_primase_S', NULL, NULL, 3998, 9),
(272066, NULL, 'PF04692', NULL, NULL, 'Platelet-derived growth factor, N terminal region', NULL, 'PDGF_N', NULL, NULL, 3455, 9),
(272067, NULL, 'PF16441', NULL, NULL, 'Domain of unknown function (DUF5038)', NULL, 'DUF5038', NULL, NULL, 24138, 9),
(272068, NULL, 'PF03050', NULL, NULL, 'Transposase IS66 family', NULL, 'DDE_Tnp_IS66', NULL, NULL, 4911, 9),
(272069, NULL, 'PF08928', NULL, NULL, 'Domain of unknown function (DUF1910)', NULL, 'DUF1910', NULL, NULL, 7831, 9),
(272070, NULL, 'PF07073', NULL, NULL, 'Modulator of Rho-dependent transcription termination (ROF)', NULL, 'ROF', NULL, NULL, 12784, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(272071, NULL, 'PF11677', NULL, NULL, 'Protein of unknown function (DUF3273)', NULL, 'DUF3273', NULL, NULL, 19013, 9),
(272072, NULL, 'PF13017', NULL, NULL, 'piRNA pathway germ-plasm component', NULL, 'Maelstrom', NULL, NULL, 26046, 9),
(272073, NULL, 'PF17150', NULL, NULL, 'C-terminal domain of two-partite extracellular sensor domain', NULL, 'CHASE6_C', NULL, NULL, 29297, 9),
(272074, NULL, 'PF00822', NULL, NULL, 'PMP-22/EMP/MP20/Claudin family', NULL, 'PMP22_Claudin', NULL, NULL, 590, 9),
(272075, NULL, 'PF04872', NULL, NULL, 'Poxvirus L5 protein family', NULL, 'Pox_L5', NULL, NULL, 5942, 9),
(272076, NULL, 'PF13692', NULL, NULL, 'Glycosyl transferases group 1', NULL, 'Glyco_trans_1_4', NULL, NULL, NULL, 9),
(272077, NULL, 'PF17276', NULL, NULL, 'Family of unknown function (DUF5341)', NULL, 'DUF5341', NULL, NULL, 28385, 9),
(272078, NULL, 'PF03708', NULL, NULL, 'Avian retrovirus envelope protein, gp85', NULL, 'Avian_gp85', NULL, NULL, 4720, 9),
(272079, NULL, 'PF16185', NULL, NULL, 'Mitochondrial ABC-transporter N-terminal five TM region', NULL, 'MTABC_N', NULL, NULL, 25176, 9),
(272080, NULL, 'PF20300', NULL, NULL, 'Prokaryotic STING domain', NULL, 'prok_STING', NULL, NULL, 37507, 9),
(272081, NULL, 'PF20517', NULL, NULL, 'Transmembrane protein 127', NULL, 'TMEM127', NULL, NULL, 37089, 9),
(272082, NULL, 'PF06980', NULL, NULL, 'Protein of unknown function (DUF1302)', NULL, 'DUF1302', NULL, NULL, 9893, 9),
(272083, NULL, 'PF09566', NULL, NULL, 'SacI restriction endonuclease', NULL, 'RE_SacI', NULL, NULL, 16987, 9),
(272084, NULL, 'PF11904', NULL, NULL, 'GPCR-chaperone', NULL, 'GPCR_chapero_1', NULL, NULL, 19786, 9),
(272085, NULL, 'PF08212', NULL, NULL, 'Lipocalin-like domain', NULL, 'Lipocalin_2', NULL, NULL, 5799, 9),
(272086, NULL, 'PF02157', NULL, NULL, 'Mannose-6-phosphate receptor', NULL, 'Man-6-P_recep', NULL, NULL, 22287, 9),
(272087, NULL, 'PF19253', NULL, NULL, 'Family of unknown function (DUF5900)', NULL, 'DUF5900', NULL, NULL, 35868, 9),
(272088, NULL, 'PF14863', NULL, NULL, 'Alkyl sulfatase dimerisation', NULL, 'Alkyl_sulf_dimr', NULL, NULL, 26974, 9),
(272089, NULL, 'PF18894', NULL, NULL, 'Putative phage metallopeptidase', NULL, 'PhageMetallopep', NULL, NULL, 37378, 9),
(272090, NULL, 'PF17769', NULL, NULL, 'Phosphoribosylaminoimidazole carboxylase C-terminal domain', NULL, 'PurK_C', NULL, NULL, 28718, 9),
(272091, NULL, 'PF16432', NULL, NULL, 'Domain of unknown function (DUF5029)', NULL, 'DUF5029', NULL, NULL, 24362, 9),
(272092, NULL, 'PF11240', NULL, NULL, 'Protein of unknown function (DUF3042)', NULL, 'DUF3042', NULL, NULL, 18127, 9),
(272093, NULL, 'PF07557', NULL, NULL, 'Shugoshin C terminus', NULL, 'Shugoshin_C', NULL, NULL, 12611, 9),
(272094, NULL, 'PF11130', NULL, NULL, 'TraC protein', NULL, 'TraC_F_IV', NULL, NULL, 24823, 9),
(272095, NULL, 'PF15892', NULL, NULL, 'BNR repeat-containing family member', NULL, 'BNR_4', NULL, NULL, NULL, 9),
(272096, NULL, 'PF07469', NULL, NULL, 'Nuclear receptor coactivator, DUF1518', NULL, 'DUF1518', NULL, NULL, 8701, 9),
(272097, NULL, 'PF11670', NULL, NULL, 'Major surface protein 1a (MSP1a)', NULL, 'MSP1a', NULL, NULL, 19322, 9),
(272098, NULL, 'PF06418', NULL, NULL, 'CTP synthase N-terminus', NULL, 'CTP_synth_N', NULL, NULL, 18517, 9),
(272099, NULL, 'PF14551', NULL, NULL, 'MCM N-terminal domain', NULL, 'MCM_N', NULL, NULL, 24288, 9),
(272100, NULL, 'PF01347', NULL, NULL, 'Lipoprotein amino terminal region', NULL, 'Vitellogenin_N', NULL, NULL, 4990, 9),
(272101, NULL, 'PF15626', NULL, NULL, 'single CXXC unit', NULL, 'mono-CXXC', NULL, NULL, 28722, 9),
(272102, NULL, 'PF17595', NULL, NULL, 'Family of unknown function (DUF5491)', NULL, 'DUF5491', NULL, NULL, 19187, 9),
(272103, NULL, 'PF05430', NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferase', NULL, 'Methyltransf_30', NULL, NULL, 12301, 9),
(272104, NULL, 'PF16061', NULL, NULL, 'Domain of unknown function (DUF4803)', NULL, 'DUF4803', NULL, NULL, 23551, 9),
(272105, NULL, 'PF07584', NULL, NULL, 'Aerotolerance regulator N-terminal', NULL, 'BatA', NULL, NULL, 11491, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(272106, NULL, 'PF00582', NULL, NULL, 'Universal stress protein family', NULL, 'Usp', NULL, NULL, 1333, 9),
(272107, NULL, 'PF00511', NULL, NULL, 'E2 (early) protein, C terminal', NULL, 'PPV_E2_C', NULL, NULL, 4525, 9),
(272108, NULL, 'PF05391', NULL, NULL, 'Lsm interaction motif', NULL, 'Lsm_interact', NULL, NULL, 12618, 9),
(272109, NULL, 'PF16378', NULL, NULL, 'Domain of unknown function', NULL, 'DUF4988', NULL, NULL, 22291, 9),
(272110, NULL, 'PF18652', NULL, NULL, 'Adhesin P1 N-terminal domain', NULL, 'Adhesin_P1_N', NULL, NULL, 29338, 9),
(272111, NULL, 'PF15207', NULL, NULL, 'TMEM240 family', NULL, 'TMEM240', NULL, NULL, 24956, 9),
(272112, NULL, 'PF00513', NULL, NULL, 'Late Protein L2', NULL, 'Late_protein_L2', NULL, NULL, 4916, 9),
(272113, NULL, 'PF09668', NULL, NULL, 'Aspartyl protease', NULL, 'Asp_protease', NULL, NULL, 17511, 9),
(272114, NULL, 'PF17390', NULL, NULL, 'Bacterial alpha-L-rhamnosidase C-terminal domain', NULL, 'Bac_rhamnosid_C', NULL, NULL, 14642, 9),
(272115, NULL, 'PF16242', NULL, NULL, 'Pyridoxamine 5''-phosphate oxidase like', NULL, 'Pyrid_ox_like', NULL, NULL, 31581, 9),
(272116, NULL, 'PF17425', NULL, NULL, 'Arylsulfotransferase Ig-like domain', NULL, 'Arylsulfotran_N', NULL, NULL, 14876, 9),
(272117, NULL, 'PF12653', NULL, NULL, 'Protein of unknown function (DUF3785)', NULL, 'DUF3785', NULL, NULL, 17320, 9),
(272118, NULL, 'PF04919', NULL, NULL, 'Protein of unknown function (DUF655)', NULL, 'DUF655', NULL, NULL, 6307, 9),
(272119, NULL, 'PF20391', NULL, NULL, 'Family of unknown function (DUF6686)', NULL, 'DUF6686', NULL, NULL, 37718, 9),
(272120, NULL, 'PF06360', NULL, NULL, 'Euplotes raikovi mating pheromone', NULL, 'E_raikovi_mat', NULL, NULL, 6029, 9),
(272121, NULL, 'PF11453', NULL, NULL, 'Protein of unknown function (DUF2950)', NULL, 'DUF2950', NULL, NULL, 18914, 9),
(272122, NULL, 'PF08264', NULL, NULL, 'Anticodon-binding domain of tRNA ligase', NULL, 'Anticodon_1', NULL, NULL, 8472, 9),
(272123, NULL, 'PF04721', NULL, NULL, 'PNGase C-terminal domain, mannose-binding module PAW', NULL, 'PAW', NULL, NULL, 291, 9),
(272124, NULL, 'PF11865', NULL, NULL, 'Domain of unknown function (DUF3385)', NULL, 'DUF3385', NULL, NULL, 26956, 9),
(272125, NULL, 'PF17462', NULL, NULL, 'Family of unknown function (DUF5424)', NULL, 'DUF5424', NULL, NULL, 32178, 9),
(272126, NULL, 'PF04569', NULL, NULL, 'Protein of unknown function', NULL, 'DUF591', NULL, NULL, 169, 9),
(272127, NULL, 'PF10968', NULL, NULL, 'Protein of unknown function (DUF2770)', NULL, 'DUF2770', NULL, NULL, 24464, 9),
(272128, NULL, 'PF16949', NULL, NULL, 'Putative ATP-binding cassette', NULL, 'ABC_tran_2', NULL, NULL, 22707, 9),
(272129, NULL, 'PF18752', NULL, NULL, 'Dictyosteliid AID/APOBEC-like Deaminase', NULL, 'DAAD', NULL, NULL, 28577, 9),
(272130, NULL, 'PF09906', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2135)', NULL, 'DUF2135', NULL, NULL, 19118, 9),
(272131, NULL, 'PF06683', NULL, NULL, 'Protein of unknown function (DUF1184)', NULL, 'DUF1184', NULL, NULL, 931, 9),
(272132, NULL, 'PF05434', NULL, NULL, 'TMEM9', NULL, 'Tmemb_9', NULL, NULL, 13840, 9),
(272133, NULL, 'PF20382', NULL, NULL, 'Family of unknown function (DUF6677)', NULL, 'DUF6677', NULL, NULL, 37627, 9),
(272134, NULL, 'PF07580', NULL, NULL, 'M26 IgA1-specific Metallo-endopeptidase C-terminal region', NULL, 'Peptidase_M26_C', NULL, NULL, 12851, 9),
(272135, NULL, 'PF17977', NULL, NULL, 'RING/Ubox like zinc-binding domain', NULL, 'zf-RING_13', NULL, NULL, 29206, 9),
(272136, NULL, 'PF19993', NULL, NULL, 'Double-GTPase 2', NULL, 'DO-GTPase2', NULL, NULL, 35939, 9),
(272137, NULL, 'PF12795', NULL, NULL, 'Mechanosensitive ion channel porin domain', NULL, 'MscS_porin', NULL, NULL, 23385, 9),
(272138, NULL, 'PF16025', NULL, NULL, 'Calcium-dependent calmodulin binding', NULL, 'CaM_bind', NULL, NULL, NULL, 9),
(272139, NULL, 'PF00319', NULL, NULL, 'SRF-type transcription factor (DNA-binding and dimerisation domain)', NULL, 'SRF-TF', NULL, NULL, 1200, 9),
(272140, NULL, 'PF18065', NULL, NULL, 'PatG C-terminal', NULL, 'PatG_C', NULL, NULL, 28475, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(272141, NULL, 'PF02656', NULL, NULL, 'Domain of unknown function (DUF202)', NULL, 'DUF202', NULL, NULL, 3276, 9),
(272142, NULL, 'PF03397', NULL, NULL, 'Rhabdovirus matrix protein', NULL, 'Rhabdo_matrix', NULL, NULL, 2423, 9),
(272143, NULL, 'PF13247', NULL, NULL, '4Fe-4S dicluster domain', NULL, 'Fer4_11', NULL, NULL, 12567, 9),
(272144, NULL, 'PF12248', NULL, NULL, 'Farnesoic acid 0-methyl transferase', NULL, 'Methyltransf_FA', NULL, NULL, 20048, 9),
(272145, NULL, 'PF10148', NULL, NULL, 'Schwannomin-interacting protein 1', NULL, 'SCHIP-1', NULL, NULL, 17750, 9),
(272146, NULL, 'PF17521', NULL, NULL, 'Honey bee peptides', NULL, 'Secapin', NULL, NULL, 18654, 9),
(272147, NULL, 'PF10371', NULL, NULL, 'Domain of unknown function', NULL, 'EKR', NULL, NULL, 17384, 9),
(272148, NULL, 'PF13548', NULL, NULL, 'Domain of unknown function (DUF4126)', NULL, 'DUF4126', NULL, NULL, 21837, 9),
(272149, NULL, 'PF00024', NULL, NULL, 'PAN domain', NULL, 'PAN_1', NULL, NULL, 843, 9),
(272150, NULL, 'PF05034', NULL, NULL, 'Methylaspartate ammonia-lyase N-terminus', NULL, 'MAAL_N', NULL, NULL, 16677, 9),
(272151, NULL, 'PF15321', NULL, NULL, 'ATPase family AAA domain containing 4', NULL, 'ATAD4', NULL, NULL, 22656, 9),
(272152, NULL, 'PF01227', NULL, NULL, 'GTP cyclohydrolase I', NULL, 'GTP_cyclohydroI', NULL, NULL, 20648, 9),
(272153, NULL, 'PF00284', NULL, NULL, 'Lumenal portion of Cytochrome b559, alpha (gene psbE) subunit', NULL, 'Cytochrom_B559a', NULL, NULL, 9075, 9),
(272154, NULL, 'PF10257', NULL, NULL, 'Retinoic acid induced 16-like protein', NULL, 'RAI16-like', NULL, NULL, 15606, 9),
(272155, NULL, 'PF19648', NULL, NULL, 'Family of unknown function (DUF6151)', NULL, 'DUF6151', NULL, NULL, 37456, 9),
(272156, NULL, 'PF10880', NULL, NULL, 'Protein of unknown function (DUF2673)', NULL, 'DUF2673', NULL, NULL, 20129, 9),
(272157, NULL, 'PF11342', NULL, NULL, 'Protein of unknown function (DUF3144)', NULL, 'DUF3144', NULL, NULL, 18774, 9),
(272158, NULL, 'PF09775', NULL, NULL, 'Keratinocyte-associated protein 2', NULL, 'Keratin_assoc', NULL, NULL, 16450, 9),
(272159, NULL, 'PF11330', NULL, NULL, 'C-Terminal of 30K viral movement proteins', NULL, '30K_MP_C_Ter', NULL, NULL, 18359, 9),
(272160, NULL, 'PF03905', NULL, NULL, 'Coronavirus non-structural protein NS4', NULL, 'Corona_NS4', NULL, NULL, 2551, 9),
(272161, NULL, 'PF18304', NULL, NULL, 'SabA N-terminal extracellular adhesion domain', NULL, 'SabA_adhesion', NULL, NULL, 32386, 9),
(272162, NULL, 'PF06395', NULL, NULL, 'CDC24 Calponin', NULL, 'CDC24', NULL, NULL, 10381, 9),
(272163, NULL, 'PF12131', NULL, NULL, 'Protein of unknown function (DUF3586)', NULL, 'DUF3586', NULL, NULL, 20011, 9),
(272164, NULL, 'PF16537', NULL, NULL, 'Type II secretion system protein B', NULL, 'T2SSB', NULL, NULL, 24149, 9),
(272165, NULL, 'PF04106', NULL, NULL, 'Autophagy protein Apg5', NULL, 'APG5', NULL, NULL, 6970, 9),
(272166, NULL, 'PF01388', NULL, NULL, 'ARID/BRIGHT DNA binding domain', NULL, 'ARID', NULL, NULL, 5497, 9),
(272167, NULL, 'PF06822', NULL, NULL, 'Protein of unknown function (DUF1235)', NULL, 'DUF1235', NULL, NULL, 10578, 9),
(272168, NULL, 'PF13215', NULL, NULL, 'Protein of unknown function (DUF4023)', NULL, 'DUF4023', NULL, NULL, 22642, 9),
(272169, NULL, 'PF15354', NULL, NULL, 'Kidney-associated antigen 1', NULL, 'KAAG1', NULL, NULL, 24639, 9),
(272170, NULL, 'PF12688', NULL, NULL, 'Tetratrico peptide repeat', NULL, 'TPR_5', NULL, NULL, 30276, 9),
(272171, NULL, 'PF15447', NULL, NULL, 'N-terminal segments of PfEMP1', NULL, 'NTS', NULL, NULL, 26871, 9),
(272172, NULL, 'PF17806', NULL, NULL, 'Sarcosine oxidase A3 domain', NULL, 'SO_alpha_A3', NULL, NULL, 28682, 9),
(272173, NULL, 'PF03598', NULL, NULL, 'CO dehydrogenase/acetyl-CoA synthase complex beta subunit', NULL, 'CdhC', NULL, NULL, 7307, 9),
(272174, NULL, 'PF09673', NULL, NULL, 'Type-F conjugative transfer system pilin assembly protein', NULL, 'TrbC_Ftype', NULL, NULL, 17714, 9),
(272175, NULL, 'PF01174', NULL, NULL, 'SNO glutamine amidotransferase family', NULL, 'SNO', NULL, NULL, 5189, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(272176, NULL, 'PF03006', NULL, NULL, 'Haemolysin-III related', NULL, 'HlyIII', NULL, NULL, 3825, 9),
(272177, NULL, 'PF07145', NULL, NULL, 'Ataxin-2 C-terminal region', NULL, 'PAM2', NULL, NULL, 13241, 9),
(272178, NULL, 'PF04618', NULL, NULL, 'HD-ZIP protein N terminus', NULL, 'HD-ZIP_N', NULL, NULL, 2169, 9),
(272179, NULL, 'PF11715', NULL, NULL, 'Nucleoporin Nup120/160', NULL, 'Nup160', NULL, NULL, NULL, 9),
(272180, NULL, 'PF08174', NULL, NULL, 'Cell division protein anillin', NULL, 'Anillin', NULL, NULL, 11765, 9),
(272181, NULL, 'PF10541', NULL, NULL, 'Nuclear envelope localisation domain', NULL, 'KASH', NULL, NULL, 11905, 9),
(272182, NULL, 'PF13473', NULL, NULL, 'Cupredoxin-like domain', NULL, 'Cupredoxin_1', NULL, NULL, 24692, 9),
(272183, NULL, 'PF09890', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2117)', NULL, 'DUF2117', NULL, NULL, 10638, 9),
(272184, NULL, 'PF19556', NULL, NULL, 'PRTRC system protein E', NULL, 'PRTRC_E', NULL, NULL, 15156, 9),
(272185, NULL, 'PF11114', NULL, NULL, 'Minor capsid protein', NULL, 'Minor_capsid_2', NULL, NULL, 16898, 9),
(272186, NULL, 'PF02228', NULL, NULL, 'Major core protein p19', NULL, 'Gag_p19', NULL, NULL, 1925, 9),
(272187, NULL, 'PF09282', NULL, NULL, 'Mago binding', NULL, 'Mago-bind', NULL, NULL, 13711, 9),
(272188, NULL, 'PF14015', NULL, NULL, 'Protein of unknown function (DUF4231)', NULL, 'DUF4231', NULL, NULL, 22213, 9),
(272189, NULL, 'PF02216', NULL, NULL, 'B domain', NULL, 'B', NULL, NULL, 1781, 9),
(272190, NULL, 'PF14667', NULL, NULL, 'Polysaccharide biosynthesis C-terminal domain', NULL, 'Polysacc_synt_C', NULL, NULL, 26621, 9),
(272191, NULL, 'PF03311', NULL, NULL, 'Cornichon protein', NULL, 'Cornichon', NULL, NULL, 6405, 9),
(272192, NULL, 'PF07502', NULL, NULL, 'MANEC domain', NULL, 'MANEC', NULL, NULL, 11123, 9),
(272193, NULL, 'PF10071', NULL, NULL, 'Zn-ribbon-containing, possibly nucleic-acid-binding protein (DUF2310)', NULL, 'DUF2310', NULL, NULL, 17192, 9),
(272194, NULL, 'PF17013', NULL, NULL, 'Putative acetyl-transferase', NULL, 'Acetyltransf_15', NULL, NULL, 22560, 9),
(272195, NULL, 'PF19657', NULL, NULL, 'Family of unknown function (DUF6160)', NULL, 'DUF6160', NULL, NULL, 37313, 9),
(272196, NULL, 'PF04441', NULL, NULL, 'Poxvirus early transcription factor (VETF), large subunit', NULL, 'Pox_VERT_large', NULL, NULL, 10903, 9),
(272197, NULL, 'PF12632', NULL, NULL, 'Mysoin-binding motif of peroxisomes', NULL, 'Vezatin', NULL, NULL, 24716, 9),
(272198, NULL, 'PF14816', NULL, NULL, 'Coiled-coil and Nse Interacting (CANIN) domain', NULL, 'CANIN', NULL, NULL, 35914, 9),
(272199, NULL, 'PF12910', NULL, NULL, 'Antitoxin of toxin-antitoxin, RelE / RelB, TA system', NULL, 'PHD_like', NULL, NULL, 18463, 9),
(272200, NULL, 'PF13575', NULL, NULL, 'Domain of unknown function (DUF4135)', NULL, 'DUF4135', NULL, NULL, 22475, 9),
(272201, NULL, 'PF14770', NULL, NULL, 'Transmembrane protein 18', NULL, 'TMEM18', NULL, NULL, 21774, 9),
(272202, NULL, 'PF10421', NULL, NULL, '2''-5''-oligoadenylate synthetase 1, domain 2, C-terminus', NULL, 'OAS1_C', NULL, NULL, 16979, 9),
(272203, NULL, 'PF16219', NULL, NULL, 'Domain of unknown function (DUF4879)', NULL, 'DUF4879', NULL, NULL, 26236, 9),
(272204, NULL, 'PF09487', NULL, NULL, 'Bacterial type III secretion protein (HrpB2)', NULL, 'HrpB2', NULL, NULL, 11350, 9),
(272205, NULL, 'PF03458', NULL, NULL, 'Glycine transporter', NULL, 'Gly_transporter', NULL, NULL, 10962, 9),
(272206, NULL, 'PF18641', NULL, NULL, 'LidA long coiled-coil domain', NULL, 'LidA_Long_CC', NULL, NULL, 30425, 9),
(272207, NULL, 'PF02412', NULL, NULL, 'Thrombospondin type 3 repeat', NULL, 'TSP_3', NULL, NULL, 4377, 9),
(272208, NULL, 'PF19532', NULL, NULL, 'Transmembrane protein 131-like', NULL, 'TMEM131_like', NULL, NULL, 36118, 9),
(272209, NULL, 'PF14216', NULL, NULL, 'Domain of unknown function (DUF4326)', NULL, 'DUF4326', NULL, NULL, 26056, 9),
(272210, NULL, 'PF02028', NULL, NULL, 'BCCT, betaine/carnitine/choline family transporter', NULL, 'BCCT', NULL, NULL, 3667, 9),
(272211, NULL, 'PF11333', NULL, NULL, 'Protein of unknown function (DUF3135)', NULL, 'DUF3135', NULL, NULL, 18016, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(272212, NULL, 'PF20515', NULL, NULL, 'Tet-like 2OG-Fe(II) oxygenase superfamily', NULL, '2OG-FeII_Oxy_6', NULL, NULL, 33643, 9),
(272213, NULL, 'PF12479', NULL, NULL, 'Protein of unknown function (DUF3698)', NULL, 'DUF3698', NULL, NULL, 20977, 9),
(272214, NULL, 'PF04341', NULL, NULL, 'Protein of unknown function, DUF485', NULL, 'DUF485', NULL, NULL, 3748, 9),
(272215, NULL, 'PF17561', NULL, NULL, 'Type VI secretion system, TssO', NULL, 'TssO', NULL, NULL, 33174, 9),
(272216, NULL, 'PF16867', NULL, NULL, 'Dimethlysulfonioproprionate lyase', NULL, 'DMSP_lyase', NULL, NULL, 24126, 9),
(272217, NULL, 'PF17978', NULL, NULL, 'RING/Ubox like zinc-binding domain', NULL, 'zf-RING_14', NULL, NULL, 28835, 9),
(272218, NULL, 'PF15167', NULL, NULL, 'Domain of unknown function (DUF4581)', NULL, 'DUF4581', NULL, NULL, 25645, 9),
(272219, NULL, 'PF03581', NULL, NULL, 'Herpesvirus UL33-like protein', NULL, 'Herpes_UL33', NULL, NULL, 5438, 9),
(272220, NULL, 'PF17773', NULL, NULL, 'UPF0176 acylphosphatase like domain', NULL, 'UPF0176_N', NULL, NULL, 27855, 9),
(272221, NULL, 'PF20477', NULL, NULL, 'Family of unknown function (DUF6719)', NULL, 'DUF6719', NULL, NULL, 37538, 9),
(272222, NULL, 'PF07545', NULL, NULL, 'Vestigial/Tondu family', NULL, 'Vg_Tdu', NULL, NULL, 12635, 9),
(272223, NULL, 'PF18220', NULL, NULL, 'Adhesin BspA variable domain', NULL, 'BspA_v', NULL, NULL, 29478, 9),
(272224, NULL, 'PF16898', NULL, NULL, 'C-terminal associated domain of TOPRIM', NULL, 'TOPRIM_C', NULL, NULL, 22808, 9),
(272225, NULL, 'PF18059', NULL, NULL, 'Csd3 N-terminal', NULL, 'Csd3_N', NULL, NULL, 28013, 9),
(272226, NULL, 'PF02605', NULL, NULL, 'Photosystem I reaction centre subunit XI', NULL, 'PsaL', NULL, NULL, 2226, 9),
(272227, NULL, 'PF03894', NULL, NULL, 'D-xylulose 5-phosphate/D-fructose 6-phosphate phosphoketolase', NULL, 'XFP', NULL, NULL, 2786, 9),
(272228, NULL, 'PF06990', NULL, NULL, 'Galactose-3-O-sulfotransferase', NULL, 'Gal-3-0_sulfotr', NULL, NULL, 12033, 9),
(272229, NULL, 'PF10794', NULL, NULL, 'Protein of unknown function (DUF2606)', NULL, 'DUF2606', NULL, NULL, 20771, 9),
(272230, NULL, 'PF12167', NULL, NULL, 'Arm DNA-binding domain', NULL, 'Arm-DNA-bind_2', NULL, NULL, 20163, 9),
(272231, NULL, 'PF07387', NULL, NULL, 'Seadornavirus VP7', NULL, 'Seadorna_VP7', NULL, NULL, 8067, 9),
(272232, NULL, 'PF14990', NULL, NULL, 'Domain of unknown function (DUF4516)', NULL, 'DUF4516', NULL, NULL, 25811, 9),
(272233, NULL, 'PF20338', NULL, NULL, 'Family of unknown function (DUF6633)', NULL, 'DUF6633', NULL, NULL, 33794, 9),
(272234, NULL, 'PF12528', NULL, NULL, 'Type II secretion prepilin peptidase dependent protein C', NULL, 'T2SSppdC', NULL, NULL, 21303, 9),
(272235, NULL, 'PF08138', NULL, NULL, 'Sex peptide (SP) family', NULL, 'Sex_peptide', NULL, NULL, 9777, 9),
(272236, NULL, 'PF15025', NULL, NULL, 'Domain of unknown function (DUF4524)', NULL, 'DUF4524', NULL, NULL, 22318, 9),
(272237, NULL, 'PF00828', NULL, NULL, 'Ribosomal proteins 50S-L15, 50S-L18e, 60S-L27A', NULL, 'Ribosomal_L27A', NULL, NULL, 15313, 9),
(272238, NULL, 'PF18800', NULL, NULL, 'Attenuator of Hedgehog', NULL, 'Atthog', NULL, NULL, 32578, 9),
(272239, NULL, 'PF11765', NULL, NULL, 'Hyphally regulated cell wall protein N-terminal', NULL, 'Hyphal_reg_CWP', NULL, NULL, 15977, 9),
(272240, NULL, 'PF07811', NULL, NULL, 'TadE-like protein', NULL, 'TadE', NULL, NULL, 12679, 9),
(272241, NULL, 'PF20148', NULL, NULL, 'Domain of unknown function (DUF6531)', NULL, 'DUF6531', NULL, NULL, 34654, 9),
(272242, NULL, 'PF10370', NULL, NULL, 'Domain of unknown function (DUF2437)', NULL, 'DUF2437', NULL, NULL, 20433, 9),
(272243, NULL, 'PF14011', NULL, NULL, 'EspG family', NULL, 'ESX-1_EspG', NULL, NULL, 22739, 9),
(272244, NULL, 'PF15330', NULL, NULL, 'SHP2-interacting transmembrane adaptor protein, SIT', NULL, 'SIT', NULL, NULL, NULL, 9),
(272245, NULL, 'PF11351', NULL, NULL, 'Holin of 3TMs, for gene-transfer release', NULL, 'GTA_holin_3TM', NULL, NULL, 18670, 9),
(272246, NULL, 'PF16672', NULL, NULL, 'Ragulator complex protein LAMTOR5', NULL, 'LAMTOR5', NULL, NULL, 8270, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(272247, NULL, 'PF07909', NULL, NULL, 'Protein of unknown function (DUF1663)', NULL, 'DUF1663', NULL, NULL, 14447, 9),
(272248, NULL, 'PF14358', NULL, NULL, 'Domain of unknown function (DUF4405)', NULL, 'DUF4405', NULL, NULL, 26310, 9),
(272249, NULL, 'PF20441', NULL, NULL, 'Terminase large subunit, endonuclease domain', NULL, 'TerL_nuclease', NULL, NULL, 36587, 9),
(272250, NULL, 'PF18497', NULL, NULL, 'Ribonuclease III N-terminal domain', NULL, 'RNase_3_N', NULL, NULL, 27574, 9),
(272251, NULL, 'PF07292', NULL, NULL, 'Nmi/IFP 35 domain (NID)', NULL, 'NID', NULL, NULL, 14362, 9),
(272252, NULL, 'PF02265', NULL, NULL, 'S1/P1 Nuclease', NULL, 'S1-P1_nuclease', NULL, NULL, 1670, 9),
(272253, NULL, 'PF00360', NULL, NULL, 'Phytochrome region', NULL, 'PHY', NULL, NULL, 9525, 9),
(272254, NULL, 'PF06839', NULL, NULL, 'GRF zinc finger', NULL, 'zf-GRF', NULL, NULL, 9015, 9),
(272255, NULL, 'PF13647', NULL, NULL, 'Glycosyl hydrolase family 80 of chitosanase A', NULL, 'Glyco_hydro_80', NULL, NULL, 25401, 9),
(272256, NULL, 'PF13994', NULL, NULL, 'PgaD-like protein', NULL, 'PgaD', NULL, NULL, 17752, 9),
(272257, NULL, 'PF03058', NULL, NULL, 'Sar8.2 family', NULL, 'Sar8_2', NULL, NULL, 4873, 9),
(272258, NULL, 'PF17984', NULL, NULL, 'Telomerase reverse transcriptase thumb DNA binding domain', NULL, 'TERT_thumb', NULL, NULL, 29984, 9),
(272259, NULL, 'PF13844', NULL, NULL, 'Glycosyl transferase family 41', NULL, 'Glyco_transf_41', NULL, NULL, 26883, 9),
(272260, NULL, 'PF10969', NULL, NULL, 'Protein of unknown function (DUF2771)', NULL, 'DUF2771', NULL, NULL, 24182, 9),
(272261, NULL, 'PF09472', NULL, NULL, 'Tetrahydromethanopterin S-methyltransferase, F subunit (MtrF)', NULL, 'MtrF', NULL, NULL, 18813, 9),
(272262, NULL, 'PF10765', NULL, NULL, 'Bacteriophage P22, NinX', NULL, 'Phage_P22_NinX', NULL, NULL, 20368, 9),
(272263, NULL, 'PF16198', NULL, NULL, 'tRNA pseudouridylate synthase B C-terminal domain', NULL, 'TruB_C_2', NULL, NULL, 21629, 9),
(272264, NULL, 'PF02392', NULL, NULL, 'Ycf4', NULL, 'Ycf4', NULL, NULL, 4169, 9),
(272265, NULL, 'PF03434', NULL, NULL, 'DUF276', NULL, 'DUF276', NULL, NULL, 10453, 9),
(272266, NULL, 'PF03472', NULL, NULL, 'Autoinducer binding domain', NULL, 'Autoind_bind', NULL, NULL, 4193, 9),
(272267, NULL, 'PF17776', NULL, NULL, 'NLRC4 helical domain HD2', NULL, 'NLRC4_HD2', NULL, NULL, 29142, 9),
(272268, NULL, 'PF14525', NULL, NULL, 'AraC-binding-like domain', NULL, 'AraC_binding_2', NULL, NULL, 18042, 9),
(272269, NULL, 'PF06836', NULL, NULL, 'Protein of unknown function (DUF1240)', NULL, 'DUF1240', NULL, NULL, 9076, 9),
(272270, NULL, 'PF13560', NULL, NULL, 'Helix-turn-helix domain', NULL, 'HTH_31', NULL, NULL, NULL, 9),
(272271, NULL, 'PF10249', NULL, NULL, 'NADH-ubiquinone oxidoreductase subunit 10', NULL, 'NDUFB10', NULL, NULL, 15745, 9),
(272272, NULL, 'PF14868', NULL, NULL, 'Domain of unknown function (DUF4487)', NULL, 'DUF4487', NULL, NULL, 23226, 9),
(272273, NULL, 'PF10581', NULL, NULL, 'Synapsin N-terminal', NULL, 'Synapsin_N', NULL, NULL, 12633, 9),
(272274, NULL, 'PF06559', NULL, NULL, '2''-deoxycytidine 5''-triphosphate deaminase (DCD)', NULL, 'DCD', NULL, NULL, 8077, 9),
(272275, NULL, 'PF07351', NULL, NULL, 'Protein of unknown function (DUF1480)', NULL, 'DUF1480', NULL, NULL, 8455, 9),
(272276, NULL, 'PF11898', NULL, NULL, 'Domain of unknown function (DUF3418)', NULL, 'DUF3418', NULL, NULL, 26638, 9),
(272277, NULL, 'PF13941', NULL, NULL, 'MutL protein', NULL, 'MutL', NULL, NULL, 11071, 9),
(272278, NULL, 'PF00124', NULL, NULL, 'Photosynthetic reaction centre protein', NULL, 'Photo_RC', NULL, NULL, 5823, 9),
(272279, NULL, 'PF02989', NULL, NULL, 'Lyme disease proteins of unknown function', NULL, 'DUF228', NULL, NULL, 3920, 9),
(272280, NULL, 'PF07530', NULL, NULL, 'Associated with zinc fingers', NULL, 'PRE_C2HC', NULL, NULL, 228, 9),
(272281, NULL, 'PF12185', NULL, NULL, 'Nup358/RanBP2 E3 ligase domain', NULL, 'IR1-M', NULL, NULL, 20346, 9),
(272282, NULL, 'PF20223', NULL, NULL, 'Family of unknown function (DUF6582)', NULL, 'DUF6582', NULL, NULL, 37602, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(272283, NULL, 'PF11520', NULL, NULL, 'Chromatin protein Cren7', NULL, 'Cren7', NULL, NULL, 14872, 9),
(272284, NULL, 'PF11120', NULL, NULL, 'Cellulose biosynthesis protein BcsF', NULL, 'CBP_BcsF', NULL, NULL, 16779, 9),
(272285, NULL, 'PF19399', NULL, NULL, 'Family of unknown function (DUF5974)', NULL, 'DUF5974', NULL, NULL, 36919, 9),
(272286, NULL, 'PF00009', NULL, NULL, 'Elongation factor Tu GTP binding domain', NULL, 'GTP_EFTU', NULL, NULL, 6577, 9),
(272287, NULL, 'PF17325', NULL, NULL, 'Stationary phase protein 4', NULL, 'SPG4', NULL, NULL, 21083, 9),
(272288, NULL, 'PF08387', NULL, NULL, 'FBD', NULL, 'FBD', NULL, NULL, 470, 9),
(272289, NULL, 'PF20623', NULL, NULL, 'Sgo0707 N2 domain', NULL, 'Sgo0707_N2', NULL, NULL, 37616, 9),
(272290, NULL, 'PF03766', NULL, NULL, 'Remorin, N-terminal region', NULL, 'Remorin_N', NULL, NULL, 1878, 9),
(272291, NULL, 'PF14002', NULL, NULL, 'YniB-like protein', NULL, 'YniB', NULL, NULL, 23421, 9),
(272292, NULL, 'PF06523', NULL, NULL, 'Protein of unknown function (DUF1106)', NULL, 'DUF1106', NULL, NULL, 9284, 9),
(272293, NULL, 'PF19157', NULL, NULL, 'Family of unknown function (DUF5839)', NULL, 'DUF5839', NULL, NULL, 34913, 9),
(272294, NULL, 'PF09277', NULL, NULL, 'Erythronolide synthase, docking', NULL, 'Erythro-docking', NULL, NULL, 13730, 9),
(272295, NULL, 'PF05816', NULL, NULL, 'Toxic anion resistance protein (TelA)', NULL, 'TelA', NULL, NULL, 13726, 9),
(272296, NULL, 'PF16328', NULL, NULL, 'Domain of unknown function (DUF4961)', NULL, 'DUF4961', NULL, NULL, 24713, 9),
(272297, NULL, 'PF15673', NULL, NULL, 'Circadian-associated transcriptional repressor', NULL, 'Ciart', NULL, NULL, 25106, 9),
(272298, NULL, 'PF18910', NULL, NULL, 'Domain of unknown function (DUF5665)', NULL, 'DUF5665', NULL, NULL, 35881, 9),
(272299, NULL, 'PF11563', NULL, NULL, 'Protoglobin', NULL, 'Protoglobin', NULL, NULL, 36509, 9),
(272300, NULL, 'PF18647', NULL, NULL, 'Alpha-galactosyl-binding fungal lectin', NULL, 'Fungal_lectin_2', NULL, NULL, NULL, 9),
(272301, NULL, 'PF04672', NULL, NULL, 'S-adenosyl methyltransferase', NULL, 'Methyltransf_19', NULL, NULL, 3254, 9),
(272302, NULL, 'PF16268', NULL, NULL, 'Domain of unknown function (DUF4921)', NULL, 'DUF4921', NULL, NULL, 21973, 9),
(272303, NULL, 'PF18564', NULL, NULL, 'Glycoside hydrolase family 5 C-terminal domain', NULL, 'Glyco_hydro_5_C', NULL, NULL, 29129, 9),
(272304, NULL, 'PF05788', NULL, NULL, 'Orbivirus RNA-dependent RNA polymerase (VP1)', NULL, 'Orbi_VP1', NULL, NULL, 12152, 9),
(272305, NULL, 'PF03932', NULL, NULL, 'CutC family', NULL, 'CutC', NULL, NULL, 2572, 9),
(272306, NULL, 'PF12564', NULL, NULL, 'Type III restriction/modification enzyme methylation subunit', NULL, 'TypeIII_RM_meth', NULL, NULL, 21098, 9),
(272307, NULL, 'PF09500', NULL, NULL, 'Putative thioesterase (yiiD_Cterm)', NULL, 'YiiD_C', NULL, NULL, 10600, 9),
(272308, NULL, 'PF19099', NULL, NULL, 'Family of unknown function (DUF5786)', NULL, 'DUF5786', NULL, NULL, 34573, 9),
(272309, NULL, 'PF15488', NULL, NULL, 'Domain of unknown function (DUF4645)', NULL, 'DUF4645', NULL, NULL, 23700, 9),
(272310, NULL, 'PF00397', NULL, NULL, 'WW domain', NULL, 'WW', NULL, NULL, 1285, 9),
(272311, NULL, 'PF19292', NULL, NULL, 'Phosphorylase b kinase C-terminal domain', NULL, 'KPBB_C', NULL, NULL, 37482, 9),
(272312, NULL, 'PF16132', NULL, NULL, 'Domain of unknown function (DUF4843)', NULL, 'DUF4843', NULL, NULL, 23279, 9),
(272313, NULL, 'PF11028', NULL, NULL, 'Protein of unknown function (DUF2723)', NULL, 'DUF2723', NULL, NULL, 17507, 9),
(272314, NULL, 'PF05078', NULL, NULL, 'Protein of unknown function (DUF679)', NULL, 'DUF679', NULL, NULL, 1327, 9),
(272315, NULL, 'PF17699', NULL, NULL, 'Family of unknown function (DUF5545)', NULL, 'DUF5545', NULL, NULL, 29332, 9),
(272316, NULL, 'PF15134', NULL, NULL, 'Domain of unknown function (DUF4570)', NULL, 'DUF4570', NULL, NULL, 23932, 9),
(272317, NULL, 'PF00293', NULL, NULL, 'NUDIX domain', NULL, 'NUDIX', NULL, NULL, 2732, 9),
(272318, NULL, 'PF16547', NULL, NULL, 'Proteasome-substrate-size regulator, N-terminal', NULL, 'BLM10_N', NULL, NULL, 26722, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(272319, NULL, 'PF17913', NULL, NULL, 'FHA domain', NULL, 'FHA_2', NULL, NULL, 29430, 9),
(272320, NULL, 'PF05549', NULL, NULL, 'Allexivirus 40kDa protein', NULL, 'Allexi_40kDa', NULL, NULL, 7884, 9),
(272321, NULL, 'PF06181', NULL, NULL, 'Urate oxidase N-terminal', NULL, 'Urate_ox_N', NULL, NULL, 9496, 9),
(272322, NULL, 'PF06558', NULL, NULL, 'Secretion monitor precursor protein (SecM)', NULL, 'SecM', NULL, NULL, 9009, 9),
(272323, NULL, 'PF00846', NULL, NULL, 'Hantavirus nucleocapsid protein', NULL, 'Hanta_nucleocap', NULL, NULL, 405, 9),
(272324, NULL, 'PF09057', NULL, NULL, 'Second Mitochondria-derived Activator of Caspases', NULL, 'Smac_DIABLO', NULL, NULL, 9764, 9),
(272325, NULL, 'PF14622', NULL, NULL, 'Ribonuclease-III-like', NULL, 'Ribonucleas_3_3', NULL, NULL, 80, 9),
(272326, NULL, 'PF17205', NULL, NULL, 'Integrin plexin domain', NULL, 'PSI_integrin', NULL, NULL, 28941, 9),
(272327, NULL, 'PF08618', NULL, NULL, 'Transcription factor Opi1', NULL, 'Opi1', NULL, NULL, 14143, 9),
(272328, NULL, 'PF07749', NULL, NULL, 'Endoplasmic reticulum protein ERp29, C-terminal domain', NULL, 'ERp29', NULL, NULL, 10931, 9),
(272329, NULL, 'PF00242', NULL, NULL, 'DNA polymerase (viral) N-terminal domain', NULL, 'DNA_pol_viral_N', NULL, NULL, 3979, 9),
(272330, NULL, 'PF17316', NULL, NULL, 'Perilipin protein', NULL, 'Perilipin_2', NULL, NULL, NULL, 9),
(272331, NULL, 'PF08433', NULL, NULL, 'Chromatin associated protein KTI12', NULL, 'KTI12', NULL, NULL, 12963, 9),
(272332, NULL, 'PF14555', NULL, NULL, 'UBA-like domain', NULL, 'UBA_4', NULL, NULL, NULL, 9),
(272333, NULL, 'PF09199', NULL, NULL, 'Staphylococcal superantigen-like OB-fold domain', NULL, 'SSL_OB', NULL, NULL, 12322, 9),
(272334, NULL, 'PF07365', NULL, NULL, 'Alpha conotoxin precursor', NULL, 'Toxin_8', NULL, NULL, 8412, 9),
(272335, NULL, 'PF19555', NULL, NULL, 'Family of unknown function (DUF6078)', NULL, 'DUF6078', NULL, NULL, 34039, 9),
(272336, NULL, 'PF03647', NULL, NULL, 'Transmembrane proteins 14C', NULL, 'Tmemb_14', NULL, NULL, 6207, 9),
(272337, NULL, 'PF07882', NULL, NULL, 'L-fucose isomerase, second N-terminal domain', NULL, 'Fucose_iso_N2', NULL, NULL, 13438, 9),
(272338, NULL, 'PF16074', NULL, NULL, 'Type IV Pilus-assembly protein W', NULL, 'PilW', NULL, NULL, 24123, 9),
(272339, NULL, 'PF16725', NULL, NULL, 'Nucleolin binding domain', NULL, 'Nucleolin_bd', NULL, NULL, 23396, 9),
(272340, NULL, 'PF18091', NULL, NULL, 'E3 Ubiquitin Ligase RBR C-terminal domain', NULL, 'E3_UbLigase_RBR', NULL, NULL, 28323, 9),
(272341, NULL, 'PF07139', NULL, NULL, 'Protein of unknown function (DUF1387)', NULL, 'DUF1387', NULL, NULL, 13009, 9),
(272342, NULL, 'PF19736', NULL, NULL, 'Family of unknown function (DUF6226)', NULL, 'DUF6226', NULL, NULL, 34148, 9),
(272343, NULL, 'PF06335', NULL, NULL, 'Protein of unknown function (DUF1054)', NULL, 'DUF1054', NULL, NULL, 8436, 9),
(272344, NULL, 'PF09231', NULL, NULL, 'Rice dwarf virus p3', NULL, 'RDV-p3', NULL, NULL, 13011, 9),
(272345, NULL, 'PF12573', NULL, NULL, '2-oxoisovalerate dehydrogenase E1 alpha subunit N terminal', NULL, 'OxoDH_E1alpha_N', NULL, NULL, 16706, 9),
(272346, NULL, 'PF00753', NULL, NULL, 'Metallo-beta-lactamase superfamily', NULL, 'Lactamase_B', NULL, NULL, 2148, 9),
(272347, NULL, 'PF07044', NULL, NULL, 'Protein of unknown function (DUF1329)', NULL, 'DUF1329', NULL, NULL, 9958, 9),
(272348, NULL, 'PF18214', NULL, NULL, 'STATa Immunoglobulin-like domain', NULL, 'STATa_Ig', NULL, NULL, 30182, 9),
(272349, NULL, 'PF10012', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2255)', NULL, 'DUF2255', NULL, NULL, 16589, 9),
(272350, NULL, 'PF15985', NULL, NULL, 'KH domain', NULL, 'KH_6', NULL, NULL, 1895, 9),
(272351, NULL, 'PF03314', NULL, NULL, 'Protein of unknown function, DUF273', NULL, 'DUF273', NULL, NULL, 740, 9),
(272352, NULL, 'PF00161', NULL, NULL, 'Ribosome inactivating protein', NULL, 'RIP', NULL, NULL, 3122, 9),
(272353, NULL, 'PF17950', NULL, NULL, 'S-adenosylmethionine decarboxylase N -terminal', NULL, 'SpmSyn_N', NULL, NULL, 33486, 9),
(272354, NULL, 'PF11209', NULL, NULL, 'LmeA-like phospholipid-binding', NULL, 'LmeA', NULL, NULL, 18403, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(272355, NULL, 'PF05848', NULL, NULL, 'CtsR N-terminal HTH domain', NULL, 'CtsR', NULL, NULL, 28758, 9),
(272356, NULL, 'PF10643', NULL, NULL, 'Photosystem P840 reaction-centre cytochrome c-551', NULL, 'Cytochrome-c551', NULL, NULL, 20242, 9),
(272357, NULL, 'PF12262', NULL, NULL, 'Bacterial virulence factor lipase N-terminal', NULL, 'Lipase_bact_N', NULL, NULL, 23124, 9),
(272358, NULL, 'PF19226', NULL, NULL, 'DisA glycoprotein', NULL, 'DisA', NULL, NULL, 34688, 9),
(272359, NULL, 'PF14169', NULL, NULL, 'Cold-inducible protein YdjO', NULL, 'YdjO', NULL, NULL, 23027, 9),
(272360, NULL, 'PF04124', NULL, NULL, 'Dor1-like family', NULL, 'Dor1', NULL, NULL, 6720, 9),
(272361, NULL, 'PF11542', NULL, NULL, 'Mitochondrial division protein 1', NULL, 'Mdv1', NULL, NULL, 15321, 9),
(272362, NULL, 'PF02353', NULL, NULL, 'Mycolic acid cyclopropane synthetase', NULL, 'CMAS', NULL, NULL, NULL, 9),
(272363, NULL, 'PF09621', NULL, NULL, 'Type III secretion system regulator (LcrR)', NULL, 'LcrR', NULL, NULL, 17019, 9),
(272364, NULL, 'PF14746', NULL, NULL, 'WASH complex subunit 7, C-terminal', NULL, 'WASH-7_C', NULL, NULL, 26697, 9),
(272365, NULL, 'PF06236', NULL, NULL, 'Tyrosinase co-factor MelC1', NULL, 'MelC1', NULL, NULL, 7808, 9),
(272366, NULL, 'PF18478', NULL, NULL, 'PIN like domain', NULL, 'PIN_10', NULL, NULL, 29100, 9),
(272367, NULL, 'PF07825', NULL, NULL, 'Excisionase-like protein', NULL, 'Exc', NULL, NULL, 13272, 9),
(272368, NULL, 'PF18638', NULL, NULL, 'Cysteine-Rich Protective Antigen 6 bladed domain', NULL, 'CyRPA', NULL, NULL, 29202, 9),
(272369, NULL, 'PF06650', NULL, NULL, 'SHR-binding domain of vacuolar-sorting associated protein 13', NULL, 'SHR-BD', NULL, NULL, 10171, 9),
(272370, NULL, 'PF15515', NULL, NULL, 'MvaI/BcnI restriction endonuclease family', NULL, 'MvaI_BcnI', NULL, NULL, 23603, 9),
(272371, NULL, 'PF00941', NULL, NULL, 'FAD binding domain in molybdopterin dehydrogenase', NULL, 'FAD_binding_5', NULL, NULL, 6421, 9),
(272372, NULL, 'PF10087', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2325)', NULL, 'DUF2325', NULL, NULL, 15172, 9),
(272373, NULL, 'PF17943', NULL, NULL, 'Homeobox-cysteine loop-homeobox', NULL, 'HOCHOB', NULL, NULL, 28694, 9),
(272374, NULL, 'PF00995', NULL, NULL, 'Sec1 family', NULL, 'Sec1', NULL, NULL, 5203, 9),
(272375, NULL, 'PF08469', NULL, NULL, 'Nucleoside triphosphatase I C-terminal', NULL, 'NPHI_C', NULL, NULL, 13983, 9),
(272376, NULL, 'PF06617', NULL, NULL, 'M-phase inducer phosphatase', NULL, 'M-inducer_phosp', NULL, NULL, 4040, 9),
(272377, NULL, 'PF04702', NULL, NULL, 'Vicilin N terminal region', NULL, 'Vicilin_N', NULL, NULL, 3328, 9),
(272378, NULL, 'PF06938', NULL, NULL, 'Protein of unknown function (DUF1285)', NULL, 'DUF1285', NULL, NULL, 9963, 9),
(272379, NULL, 'PF17061', NULL, NULL, 'PARM', NULL, 'PARM', NULL, NULL, 26459, 9),
(272380, NULL, 'PF11142', NULL, NULL, 'Protein of unknown function (DUF2917)', NULL, 'DUF2917', NULL, NULL, 17757, 9),
(272381, NULL, 'PF06364', NULL, NULL, 'Protein of unknown function (DUF1068)', NULL, 'DUF1068', NULL, NULL, 10258, 9),
(272382, NULL, 'PF06023', NULL, NULL, 'CRISPR-associated exonuclease Csa1', NULL, 'Csa1', NULL, NULL, 13660, 9),
(272383, NULL, 'PF07193', NULL, NULL, 'Protein of unknown function (DUF1408)', NULL, 'DUF1408', NULL, NULL, 13956, 9),
(272384, NULL, 'PF08157', NULL, NULL, 'NUC129 domain', NULL, 'NUC129', NULL, NULL, 9295, 9),
(272385, NULL, 'PF10952', NULL, NULL, 'Protein of unknown function (DUF2753)', NULL, 'DUF2753', NULL, NULL, 18711, 9),
(272386, NULL, 'PF11199', NULL, NULL, 'Protein of unknown function (DUF2891)', NULL, 'DUF2891', NULL, NULL, 18198, 9),
(272387, NULL, 'PF17461', NULL, NULL, 'Family of unknown function (DUF5423)', NULL, 'DUF5423', NULL, NULL, 32458, 9),
(272388, NULL, 'PF05424', NULL, NULL, 'Duffy binding domain', NULL, 'Duffy_binding', NULL, NULL, 14452, 9),
(272389, NULL, 'PF18775', NULL, NULL, 'APOBEC4', NULL, 'APOBEC4', NULL, NULL, NULL, 9),
(272390, NULL, 'PF06370', NULL, NULL, 'Protein of unknown function (DUF1069)', NULL, 'DUF1069', NULL, NULL, 8497, 9);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(272391, NULL, 'PF20422', NULL, NULL, 'DHR-2, Lobe B', NULL, 'DHR-2_Lobe_B', NULL, NULL, 33972, 9),
(272392, NULL, 'PF16817', NULL, NULL, 'Domain of unknown function (DUF5073)', NULL, 'DUF5073', NULL, NULL, 22325, 9),
(272393, NULL, 'PF15925', NULL, NULL, 'SOSS complex subunit C', NULL, 'SOSSC', NULL, NULL, 22742, 9),
(272394, NULL, 'PF07438', NULL, NULL, 'Protein of unknown function (DUF1514)', NULL, 'DUF1514', NULL, NULL, 8922, 9),
(272395, NULL, 'PF16916', NULL, NULL, 'Dimerisation domain of Zinc Transporter', NULL, 'ZT_dimer', NULL, NULL, 24666, 9),
(272396, NULL, 'PF12633', NULL, NULL, 'Adenylate cyclase NT domain', NULL, 'Adenyl_cycl_N', NULL, NULL, 24519, 9),
(272397, NULL, 'PF04819', NULL, NULL, 'Family of unknown function (DUF716)', NULL, 'DUF716', NULL, NULL, 4967, 9),
(272398, NULL, 'PF04965', NULL, NULL, 'Baseplate wedge protein gp25', NULL, 'GPW_gp25', NULL, NULL, 6538, 9),
(272399, NULL, 'PF01068', NULL, NULL, 'ATP dependent DNA ligase domain', NULL, 'DNA_ligase_A_M', NULL, NULL, 12804, 9),
(272400, NULL, 'PF06220', NULL, NULL, 'U1 zinc finger', NULL, 'zf-U1', NULL, NULL, 7350, 9),
(272401, NULL, 'PF17929', NULL, NULL, 'Tetracyclin repressor-like, C-terminal domain', NULL, 'TetR_C_34', NULL, NULL, 29240, 9),
(272402, NULL, 'PF18108', NULL, NULL, 'QSOX Trx-like domain', NULL, 'QSOX_Trx1', NULL, NULL, 29834, 9),
(272403, NULL, 'PF20016', NULL, NULL, 'Domain of unknown function (DUF6430)', NULL, 'DUF6430', NULL, NULL, 35646, 9),
(272404, NULL, 'PF05307', NULL, NULL, 'Bundlin', NULL, 'Bundlin', NULL, NULL, 4351, 9),
(272405, NULL, 'PF15717', NULL, NULL, 'Pericentriolar material 1 C terminus', NULL, 'PCM1_C', NULL, NULL, 23787, 9),
(272406, NULL, 'PF08509', NULL, NULL, 'Adenylate cyclase G-alpha binding domain', NULL, 'Ad_cyc_g-alpha', NULL, NULL, 14403, 9),
(272407, NULL, 'PF14989', NULL, NULL, 'Coiled-coil domain containing 32', NULL, 'CCDC32', NULL, NULL, 21903, 9),
(272408, NULL, 'PF12789', NULL, NULL, 'Phage tail repeat like', NULL, 'PTR', NULL, NULL, NULL, 9),
(272409, NULL, 'PF01788', NULL, NULL, 'PsbJ', NULL, 'PsbJ', NULL, NULL, 2543, 9),
(272410, NULL, 'PF17883', NULL, NULL, 'MBG domain', NULL, 'MBG', NULL, NULL, 29541, 9),
(272411, NULL, 'PF06543', NULL, NULL, 'Lactococcus bacteriophage repressor', NULL, 'Lac_bphage_repr', NULL, NULL, 9278, 9),
(272412, NULL, 'PF08132', NULL, NULL, 'S-adenosyl-l-methionine decarboxylase leader peptide', NULL, 'AdoMetDC_leader', NULL, NULL, 12736, 9),
(272413, NULL, 'PF14399', NULL, NULL, 'Butirosin biosynthesis protein H, N-terminal', NULL, 'BtrH_N', NULL, NULL, 22984, 9),
(272414, NULL, 'PF07045', NULL, NULL, 'Domain of unknown function (DUF1330)', NULL, 'DUF1330', NULL, NULL, 9530, 9),
(272415, NULL, 'PF01049', NULL, NULL, 'Cadherin, Y-type LIR-motif', NULL, 'CADH_Y-type_LIR', NULL, NULL, 733, 9),
(272416, NULL, 'PF06771', NULL, NULL, 'Viral Desmoplakin N-terminus', NULL, 'Desmo_N', NULL, NULL, 1804, 9),
(272417, NULL, 'PF10021', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2263)', NULL, 'DUF2263', NULL, NULL, 19734, 9),
(272418, NULL, 'PF19165', NULL, NULL, 'Family of unknown function (DUF5847)', NULL, 'DUF5847', NULL, NULL, 34090, 9),
(272419, NULL, 'PF09262', NULL, NULL, 'Peroxisome biogenesis factor 1, N-terminal', NULL, 'PEX-1N', NULL, NULL, 13295, 9),
(272420, NULL, 'PF07012', NULL, NULL, 'Curlin associated repeat', NULL, 'Curlin_rpt', NULL, NULL, 12225, 9),
(272421, NULL, 'PF17906', NULL, NULL, 'HTH domain in Mos1 transposase', NULL, 'HTH_48', NULL, NULL, 30676, 9),
(272422, NULL, 'PF07617', NULL, NULL, 'Protein of unknown function (DUF1579)', NULL, 'DUF1579', NULL, NULL, 13875, 9),
(272423, NULL, 'PF20314', NULL, NULL, 'Family of unknown function (DUF6610)', NULL, 'DUF6610', NULL, NULL, 37191, 9),
(272424, NULL, 'PF03105', NULL, NULL, 'SPX domain', NULL, 'SPX', NULL, NULL, 4683, 9),
(272425, NULL, 'PF02556', NULL, NULL, 'Preprotein translocase subunit SecB', NULL, 'SecB', NULL, NULL, 2087, 9),
(272426, NULL, 'PF11000', NULL, NULL, 'Protein of unknown function (DUF2840)', NULL, 'DUF2840', NULL, NULL, 17529, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(272427, NULL, 'PF19849', NULL, NULL, 'Family of unknown function (DUF6324)', NULL, 'DUF6324', NULL, NULL, 37508, 9),
(272428, NULL, 'PF08839', NULL, NULL, 'DNA replication factor CDT1 like', NULL, 'CDT1', NULL, NULL, 14175, 9),
(272429, NULL, 'PF14791', NULL, NULL, 'DNA polymerase beta thumb', NULL, 'DNA_pol_B_thumb', NULL, NULL, 24995, 9),
(272430, NULL, 'PF19392', NULL, NULL, 'Family of unknown function (DUF5967)', NULL, 'DUF5967', NULL, NULL, 36596, 9),
(272431, NULL, 'PF08282', NULL, NULL, 'haloacid dehalogenase-like hydrolase', NULL, 'Hydrolase_3', NULL, NULL, NULL, 9),
(272432, NULL, 'PF07787', NULL, NULL, 'Transmembrane protein 43', NULL, 'TMEM43', NULL, NULL, 13189, 9),
(272433, NULL, 'PF05296', NULL, NULL, 'Taste receptor protein (TAS2R)', NULL, 'TAS2R', NULL, NULL, 4343, 9),
(272434, NULL, 'PF04874', NULL, NULL, 'Mak16 protein C-terminal region', NULL, 'Mak16', NULL, NULL, 5857, 9),
(272435, NULL, 'PF17418', NULL, NULL, 'Sporulation delaying protein SdpA', NULL, 'SdpA', NULL, NULL, 18301, 9),
(272436, NULL, 'PF18642', NULL, NULL, 'Immunomodulating metalloprotease helical domain', NULL, 'IMPa_helical', NULL, NULL, 30558, 9),
(272437, NULL, 'PF06702', NULL, NULL, 'Golgi casein kinase, C-terminal, Fam20', NULL, 'Fam20C', NULL, NULL, 509, 9),
(272438, NULL, 'PF20019', NULL, NULL, 'vWA-MoxR associated protein middle region 20', NULL, 'VMAP-M20', NULL, NULL, NULL, 9),
(272439, NULL, 'PF01056', NULL, NULL, 'Myc amino-terminal region', NULL, 'Myc_N', NULL, NULL, 7963, 9),
(272440, NULL, 'PF10279', NULL, NULL, 'Latarcin precursor', NULL, 'Latarcin', NULL, NULL, 19166, 9),
(272441, NULL, 'PF02163', NULL, NULL, 'Peptidase family M50', NULL, 'Peptidase_M50', NULL, NULL, 1837, 9),
(272442, NULL, 'PF16306', NULL, NULL, 'Domain of unknown function (DUF4948)', NULL, 'DUF4948', NULL, NULL, 25841, 9),
(272443, NULL, 'PF10268', NULL, NULL, 'Predicted transmembrane protein 161AB', NULL, 'Tmemb_161AB', NULL, NULL, 16540, 9),
(272444, NULL, 'PF16085', NULL, NULL, 'Bacteriophage holin Hol, superfamily III', NULL, 'Phage_holin_3_5', NULL, NULL, 22591, 9),
(272445, NULL, 'PF03384', NULL, NULL, 'Drosophila protein of unknown function, DUF287', NULL, 'DUF287', NULL, NULL, 2094, 9),
(272446, NULL, 'PF17382', NULL, NULL, 'Uncharacterized Ycf70-like', NULL, 'Ycf70', NULL, NULL, 29643, 9),
(272447, NULL, 'PF18492', NULL, NULL, 'Open reading frame 2 N-terminal domain', NULL, 'ORF_2_N', NULL, NULL, NULL, 9),
(272448, NULL, 'PF17311', NULL, NULL, 'Family of unknown function (DUF5358)', NULL, 'DUF5358', NULL, NULL, 31744, 9),
(272449, NULL, 'PF19357', NULL, NULL, 'Family of unknown function (DUF5934)', NULL, 'DUF5934', NULL, NULL, 36766, 9),
(272450, NULL, 'PF16166', NULL, NULL, 'Chloroplast import apparatus Tic20-like', NULL, 'TIC20', NULL, NULL, 3928, 9),
(272451, NULL, 'PF18030', NULL, NULL, 'RimK PreATP-grasp domain', NULL, 'Rimk_N', NULL, NULL, 28707, 9),
(272452, NULL, 'PF16040', NULL, NULL, 'Domain of unknown function (DUF4792)', NULL, 'DUF4792', NULL, NULL, 25563, 9),
(272453, NULL, 'PF19237', NULL, NULL, 'Family of unknown function (DUF5889)', NULL, 'DUF5889', NULL, NULL, 35636, 9),
(272454, NULL, 'PF12009', NULL, NULL, 'Telomerase ribonucleoprotein complex - RNA binding domain', NULL, 'Telomerase_RBD', NULL, NULL, 19618, 9),
(272455, NULL, 'PF18357', NULL, NULL, 'Diphteria toxin repressor SH3 domain', NULL, 'DtxR', NULL, NULL, 28409, 9),
(272456, NULL, 'PF12544', NULL, NULL, 'Lysine-2,3-aminomutase', NULL, 'LAM_C', NULL, NULL, 25855, 9),
(272457, NULL, 'PF05081', NULL, NULL, 'Autographa californica nuclear polyhedrosis virus (AcMNPV), P18', NULL, 'AcMNPV_P18', NULL, NULL, 1439, 9),
(272458, NULL, 'PF00614', NULL, NULL, 'Phospholipase D Active site motif', NULL, 'PLDc', NULL, NULL, 3059, 9),
(272459, NULL, 'PF13351', NULL, NULL, 'Protein of unknown function (DUF4099)', NULL, 'DUF4099', NULL, NULL, 22228, 9),
(272460, NULL, 'PF07373', NULL, NULL, 'CAMP factor (Cfa)', NULL, 'CAMP_factor', NULL, NULL, 11840, 9),
(272461, NULL, 'PF12263', NULL, NULL, 'Protein of unknown function (DUF3611)', NULL, 'DUF3611', NULL, NULL, 20008, 9); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(272462, NULL, 'PF04301', NULL, NULL, 'Protein of unknown function (DUF452)', NULL, 'DUF452', NULL, NULL, 3607, 9),
(272463, NULL, 'PF18897', NULL, NULL, 'Recombination directionality factor-like', NULL, 'Gp3-like', NULL, NULL, 37716, 9),
(272464, NULL, 'PF00072', NULL, NULL, 'Response regulator receiver domain', NULL, 'Response_reg', NULL, NULL, 3274, 9),
(272465, NULL, 'PF14772', NULL, NULL, 'Sperm tail', NULL, 'NYD-SP28', NULL, NULL, 31170, 9),
(272466, NULL, 'PF18748', NULL, NULL, 'P-loop Nucleotide Kinase1', NULL, 'Ploopntkinase1', NULL, NULL, 27848, 9),
(272467, NULL, 'PF00517', NULL, NULL, 'Retroviral envelope protein', NULL, 'GP41', NULL, NULL, 559, 9),
(272468, NULL, 'PF19344', NULL, NULL, 'Tetracyclin repressor-like, C-terminal domain', NULL, 'TetR_C_32', NULL, NULL, 37040, 9),
(272469, NULL, 'PF19584', NULL, NULL, 'MCAfunc domain', NULL, 'MCAfunc', NULL, NULL, 34462, 9),
(272470, NULL, 'PF01500', NULL, NULL, 'Keratin, high sulfur B2 protein', NULL, 'Keratin_B2', NULL, NULL, 885, 9),
(272471, NULL, 'PF08676', NULL, NULL, 'MutL C terminal dimerisation domain', NULL, 'MutL_C', NULL, NULL, 11309, 9),
(272472, NULL, 'PF19884', NULL, NULL, 'Family of unknown function (DUF6357)', NULL, 'DUF6357', NULL, NULL, 36776, 9),
(272473, NULL, 'PF07376', NULL, NULL, 'Prosystemin', NULL, 'Prosystemin', NULL, NULL, 8257, 9),
(272474, NULL, 'PF00103', NULL, NULL, 'Somatotropin hormone family', NULL, 'Hormone_1', NULL, NULL, 5388, 9),
(272475, NULL, 'PF04647', NULL, NULL, 'Accessory gene regulator B', NULL, 'AgrB', NULL, NULL, 2511, 9),
(272476, NULL, 'PF15800', NULL, NULL, 'Clock interacting protein circadian', NULL, 'CiPC', NULL, NULL, 25185, 9),
(272477, NULL, 'PF18844', NULL, NULL, 'Bacterial archaeo-eukaryotic release factor family 2', NULL, 'baeRF_family2', NULL, NULL, 27627, 9),
(272478, NULL, 'PF01195', NULL, NULL, 'Peptidyl-tRNA hydrolase', NULL, 'Pept_tRNA_hydro', NULL, NULL, 2443, 9),
(272479, NULL, 'PF01639', NULL, NULL, 'Viral family 110', NULL, 'v110', NULL, NULL, 6412, 9),
(272480, NULL, 'PF03745', NULL, NULL, 'Domain of unknown function (DUF309)', NULL, 'DUF309', NULL, NULL, 983, 9),
(272481, NULL, 'PF05389', NULL, NULL, 'Negative regulator of genetic competence (MecA)', NULL, 'MecA', NULL, NULL, 12898, 9),
(272482, NULL, 'PF18224', NULL, NULL, 'ToxB N-terminal domain', NULL, 'ToxB_N', NULL, NULL, 30245, 9),
(272483, NULL, 'PF10977', NULL, NULL, 'Protein of unknown function (DUF2797)', NULL, 'DUF2797', NULL, NULL, 17605, 9),
(272484, NULL, 'PF14681', NULL, NULL, 'Uracil phosphoribosyltransferase', NULL, 'UPRTase', NULL, NULL, NULL, 9),
(272485, NULL, 'PF01782', NULL, NULL, 'RimM N-terminal domain', NULL, 'RimM', NULL, NULL, 2980, 9),
(272486, NULL, 'PF04526', NULL, NULL, 'Protein of unknown function (DUF568)', NULL, 'DUF568', NULL, NULL, 37132, 9),
(272487, NULL, 'PF14528', NULL, NULL, 'LAGLIDADG-like domain', NULL, 'LAGLIDADG_3', NULL, NULL, 7401, 9),
(272488, NULL, 'PF00246', NULL, NULL, 'Zinc carboxypeptidase', NULL, 'Peptidase_M14', NULL, NULL, 211, 9),
(272489, NULL, 'PF10288', NULL, NULL, 'Cytoplasmic tRNA 2-thiolation protein 2', NULL, 'CTU2', NULL, NULL, 16750, 9),
(272490, NULL, 'PF13992', NULL, NULL, 'YecR-like lipoprotein', NULL, 'YecR', NULL, NULL, 22667, 9),
(272491, NULL, 'PF13576', NULL, NULL, 'Pentapeptide repeats (9 copies)', NULL, 'Pentapeptide_3', NULL, NULL, 5366, 9),
(272492, NULL, 'PF01417', NULL, NULL, 'ENTH domain', NULL, 'ENTH', NULL, NULL, 12524, 9),
(272493, NULL, 'PF01490', NULL, NULL, 'Transmembrane amino acid transporter protein', NULL, 'Aa_trans', NULL, NULL, 12248, 9),
(272494, NULL, 'PF11060', NULL, NULL, 'Protein of unknown function (DUF2861)', NULL, 'DUF2861', NULL, NULL, 17872, 9),
(272495, NULL, 'PF13631', NULL, NULL, 'Cytochrome b(N-terminal)/b6/petB', NULL, 'Cytochrom_B_N_2', NULL, NULL, 5653, 9),
(272496, NULL, 'PF10320', NULL, NULL, 'Serpentine type 7TM GPCR chemoreceptor Srsx', NULL, '7TM_GPCR_Srsx', NULL, NULL, 16635, 9),
(272497, NULL, 'PF02787', NULL, NULL, 'Carbamoyl-phosphate synthetase large chain, oligomerisation domain', NULL, 'CPSase_L_D3', NULL, NULL, 534, 9);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(272498, NULL, 'PF06932', NULL, NULL, 'Protein of unknown function (DUF1283)', NULL, 'DUF1283', NULL, NULL, 11890, 9),
(272499, NULL, 'PF00791', NULL, NULL, 'ZU5 domain', NULL, 'ZU5', NULL, NULL, 3277, 9),
(272500, NULL, 'PF15535', NULL, NULL, 'Bacterial toxin 37', NULL, 'Ntox37', NULL, NULL, 23547, 9),
(272501, NULL, 'PF04898', NULL, NULL, 'Glutamate synthase central domain', NULL, 'Glu_syn_central', NULL, NULL, 5736, 9),
(272502, NULL, 'PF00815', NULL, NULL, 'Histidinol dehydrogenase', NULL, 'Histidinol_dh', NULL, NULL, 13893, 9),
(272503, NULL, 'PF04328', NULL, NULL, 'Selenoprotein, putative', NULL, 'Sel_put', NULL, NULL, 3570, 9),
(272504, NULL, 'PF05950', NULL, NULL, 'Orthopoxvirus A36R protein', NULL, 'Orthopox_A36R', NULL, NULL, 7864, 9),
(272505, NULL, 'PF15039', NULL, NULL, 'Domain of unknown function (DUF4530)', NULL, 'DUF4530', NULL, NULL, 26875, 9),
(272506, NULL, 'PF08470', NULL, NULL, 'Nontoxic nonhaemagglutinin C-terminal', NULL, 'NTNH_C', NULL, NULL, 13599, 9),
(272507, NULL, 'PF04175', NULL, NULL, 'Protein of unknown function (DUF406)', NULL, 'DUF406', NULL, NULL, 4208, 9),
(272508, NULL, 'PF09897', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2124)', NULL, 'DUF2124', NULL, NULL, 9939, 9),
(272509, NULL, 'PF00405', NULL, NULL, 'Transferrin', NULL, 'Transferrin', NULL, NULL, 1470, 9),
(272510, NULL, 'PF14675', NULL, NULL, 'FANCI solenoid 1', NULL, 'FANCI_S1', NULL, NULL, 26522, 9),
(272511, NULL, 'PF20534', NULL, NULL, 'Domain of unknown function (DUF6749)', NULL, 'DUF6749', NULL, NULL, 33524, 9),
(272512, NULL, 'PF10481', NULL, NULL, 'Cenp-F N-terminal domain', NULL, 'CENP-F_N', NULL, NULL, 9388, 9),
(272513, NULL, 'PF12588', NULL, NULL, 'Phophatidylserine decarboxylase', NULL, 'PSDC', NULL, NULL, 21422, 9),
(272514, NULL, 'PF20243', NULL, NULL, 'MbnP', NULL, 'MbnP', NULL, NULL, 35551, 9),
(272515, NULL, 'PF10504', NULL, NULL, 'Protein of unknown function (DUF2452)', NULL, 'DUF2452', NULL, NULL, 19475, 9),
(272516, NULL, 'PF00290', NULL, NULL, 'Tryptophan synthase alpha chain', NULL, 'Trp_syntA', NULL, NULL, 5400, 9),
(272517, NULL, 'PF10138', NULL, NULL, 'vWA found in TerF C terminus', NULL, 'vWA-TerF-like', NULL, NULL, 14980, 9),
(272518, NULL, 'PF12900', NULL, NULL, 'Pyridoxamine 5''-phosphate oxidase', NULL, 'Pyridox_ox_2', NULL, NULL, 19004, 9),
(272519, NULL, 'PF13460', NULL, NULL, 'NAD(P)H-binding', NULL, 'NAD_binding_10', NULL, NULL, 12608, 9),
(272520, NULL, 'PF00922', NULL, NULL, 'Vesiculovirus phosphoprotein', NULL, 'Phosphoprotein', NULL, NULL, NULL, 9),
(272521, NULL, 'PF11396', NULL, NULL, 'Putative beta-lactamase-inhibitor-like, PepSY-like', NULL, 'PepSY_like', NULL, NULL, 18690, 9),
(272522, NULL, 'PF12383', NULL, NULL, 'Severe acute respiratory syndrome coronavirus 3b protein', NULL, 'SARS_3b', NULL, NULL, 20950, 9),
(272523, NULL, 'PF08226', NULL, NULL, 'Domain of unknown function (DUF1720)', NULL, 'DUF1720', NULL, NULL, 17297, 9),
(272524, NULL, 'PF01421', NULL, NULL, 'Reprolysin (M12B) family zinc metalloprotease', NULL, 'Reprolysin', NULL, NULL, 5126, 9),
(272525, NULL, 'PF18666', NULL, NULL, 'Carbohydrate-binding module 64', NULL, 'CBM64', NULL, NULL, 29765, 9),
(272526, NULL, 'PF15339', NULL, NULL, 'Acrosome formation-associated factor', NULL, 'Afaf', NULL, NULL, 26406, 9),
(272527, NULL, 'PF17142', NULL, NULL, 'Domain of unknown function (DUF5115)', NULL, 'DUF5115', NULL, NULL, 32747, 9),
(272528, NULL, 'PF01367', NULL, NULL, '5''-3'' exonuclease, C-terminal SAM fold', NULL, '5_3_exonuc', NULL, NULL, 15626, 9),
(272529, NULL, 'PF01739', NULL, NULL, 'CheR methyltransferase, SAM binding domain', NULL, 'CheR', NULL, NULL, 16739, 9),
(272530, NULL, 'PF19070', NULL, NULL, 'Family of unknown function (DUF5766)', NULL, 'DUF5766', NULL, NULL, 35463, 9),
(272531, NULL, 'PF03555', NULL, NULL, 'Influenza C non-structural protein (NS2)', NULL, 'Flu_C_NS2', NULL, NULL, 6176, 9),
(272532, NULL, 'PF04816', NULL, NULL, 'tRNA (adenine(22)-N(1))-methyltransferase', NULL, 'TrmK', NULL, NULL, 4534, 9),
(272533, NULL, 'PF12445', NULL, NULL, 'Flagellin protein', NULL, 'FliC', NULL, NULL, 21529, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(272534, NULL, 'PF12579', NULL, NULL, 'Protein of unknown function (DUF3755)', NULL, 'DUF3755', NULL, NULL, 21200, 9),
(272535, NULL, 'PF05923', NULL, NULL, 'APC repeat', NULL, 'APC_r', NULL, NULL, 12569, 9),
(272536, NULL, 'PF18610', NULL, NULL, 'Periplasmic binding protein domain', NULL, 'Peripla_BP_7', NULL, NULL, 28444, 9),
(272537, NULL, 'PF08761', NULL, NULL, 'dUTPase', NULL, 'dUTPase_2', NULL, NULL, 13038, 9),
(272538, NULL, 'PF09167', NULL, NULL, 'Domain of unknown function (DUF1942)', NULL, 'DUF1942', NULL, NULL, 12333, 9),
(272539, NULL, 'PF09961', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2195)', NULL, 'DUF2195', NULL, NULL, 17325, 9),
(272540, NULL, 'PF05444', NULL, NULL, 'Protein of unknown function (DUF753)', NULL, 'DUF753', NULL, NULL, 12063, 9),
(272541, NULL, 'PF13088', NULL, NULL, 'BNR repeat-like domain', NULL, 'BNR_2', NULL, NULL, 9464, 9),
(272542, NULL, 'PF01848', NULL, NULL, 'Hok/gef family', NULL, 'HOK_GEF', NULL, NULL, 2806, 9),
(272543, NULL, 'PF02839', NULL, NULL, 'Carbohydrate binding domain', NULL, 'CBM_5_12', NULL, NULL, 999, 9),
(272544, NULL, 'PF19683', NULL, NULL, 'Family of unknown function (DUF6185)', NULL, 'DUF6185', NULL, NULL, 37358, 9),
(272545, NULL, 'PF00307', NULL, NULL, 'Calponin homology (CH) domain', NULL, 'CH', NULL, NULL, 3399, 9),
(272546, NULL, 'PF03588', NULL, NULL, 'Leucyl/phenylalanyl-tRNA protein transferase', NULL, 'Leu_Phe_trans', NULL, NULL, 2216, 9),
(272547, NULL, 'PF17514', NULL, NULL, 'Family of unknown function (DUF5442)', NULL, 'DUF5442', NULL, NULL, 16021, 9),
(272548, NULL, 'PF03177', NULL, NULL, 'Non-repetitive/WGA-negative nucleoporin C-terminal', NULL, 'Nucleoporin_C', NULL, NULL, 1430, 9),
(272549, NULL, 'PF14174', NULL, NULL, 'YycC-like protein', NULL, 'YycC', NULL, NULL, 24186, 9),
(272550, NULL, 'PF11308', NULL, NULL, 'Glycosyl hydrolases related to GH101 family, GH129', NULL, 'Glyco_hydro_129', NULL, NULL, 18420, 9),
(272551, NULL, 'PF14900', NULL, NULL, 'Domain of unknown function (DUF4493)', NULL, 'DUF4493', NULL, NULL, 26495, 9),
(272552, NULL, 'PF14441', NULL, NULL, 'OTT_1508-like deaminase', NULL, 'OTT_1508_deam', NULL, NULL, 22507, 9),
(272553, NULL, 'PF01756', NULL, NULL, 'Acyl-CoA oxidase', NULL, 'ACOX', NULL, NULL, 2888, 9),
(272554, NULL, 'PF10544', NULL, NULL, 'T5orf172 domain', NULL, 'T5orf172', NULL, NULL, 8058, 9),
(272555, NULL, 'PF11385', NULL, NULL, 'Protein of unknown function (DUF3189)', NULL, 'DUF3189', NULL, NULL, 18510, 9),
(272556, NULL, 'PF14906', NULL, NULL, 'Domain of unknown function (DUF4495)', NULL, 'DUF4495', NULL, NULL, 24872, 9),
(272557, NULL, 'PF01342', NULL, NULL, 'SAND domain', NULL, 'SAND', NULL, NULL, 3994, 9),
(272558, NULL, 'PF07569', NULL, NULL, 'TUP1-like enhancer of split', NULL, 'Hira', NULL, NULL, 12681, 9),
(272559, NULL, 'PF20313', NULL, NULL, 'Family of unknown function (DUF6609)', NULL, 'DUF6609', NULL, NULL, 37193, 9),
(272560, NULL, 'PF10814', NULL, NULL, 'Cell wall synthesis protein CwsA', NULL, 'CwsA', NULL, NULL, 20418, 9),
(272561, NULL, 'PF16691', NULL, NULL, 'Domain of unknown function (DUF5062)', NULL, 'DUF5062', NULL, NULL, 23048, 9),
(272562, NULL, 'PF19112', NULL, NULL, 'Vanillate O-demethylase oxygenase C-terminal domain', NULL, 'VanA_C', NULL, NULL, 35300, 9),
(272563, NULL, 'PF15401', NULL, NULL, 'Tryptophan-ring motif of head of Trimeric autotransporter adhesin', NULL, 'TAA-Trp-ring', NULL, NULL, 22766, 9),
(272564, NULL, 'PF01864', NULL, NULL, 'CDP-archaeol synthase', NULL, 'CarS-like', NULL, NULL, 21575, 9),
(272565, NULL, 'PF13165', NULL, NULL, 'Six-cysteine peptide SCIFF', NULL, 'SCIFF', NULL, NULL, 11194, 9),
(272566, NULL, 'PF14043', NULL, NULL, 'WVELL protein', NULL, 'WVELL', NULL, NULL, 25824, 9),
(272567, NULL, 'PF03048', NULL, NULL, 'UL92 family', NULL, 'Herpes_UL92', NULL, NULL, 4980, 9),
(272568, NULL, 'PF06795', NULL, NULL, 'Erythrovirus X protein', NULL, 'Erythrovirus_X', NULL, NULL, 1584, 9),
(272569, NULL, 'PF12724', NULL, NULL, 'Flavodoxin domain', NULL, 'Flavodoxin_5', NULL, NULL, 22829, 9),
(272570, NULL, 'PF17148', NULL, NULL, 'Domain of unknown function (DUF5117)', NULL, 'DUF5117', NULL, NULL, 29364, 9);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(272571, NULL, 'PF01869', NULL, NULL, 'BadF/BadG/BcrA/BcrD ATPase family', NULL, 'BcrAD_BadFG', NULL, NULL, 3786, 9),
(272572, NULL, 'PF03115', NULL, NULL, 'Astrovirus capsid protein precursor', NULL, 'Astro_capsid_N', NULL, NULL, 4681, 9),
(272573, NULL, 'PF09837', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2064)', NULL, 'DUF2064', NULL, NULL, 16856, 9),
(272574, NULL, 'PF19409', NULL, NULL, 'Thiopeptide-type bacteriocin precursor', NULL, 'Thiopep_pre', NULL, NULL, NULL, 9),
(272575, NULL, 'PF12311', NULL, NULL, 'Protein of unknown function (DUF3632)', NULL, 'DUF3632', NULL, NULL, 20775, 9),
(272576, NULL, 'PF15587', NULL, NULL, 'Immunity protein 9', NULL, 'Imm9', NULL, NULL, 24629, 9),
(272577, NULL, 'PF18040', NULL, NULL, 'beta porphyranase A C-terminal', NULL, 'BPA_C', NULL, NULL, 29271, 9),
(272578, NULL, 'PF04711', NULL, NULL, 'Apolipoprotein A-II (ApoA-II)', NULL, 'ApoA-II', NULL, NULL, 3996, 9),
(272579, NULL, 'PF18646', NULL, NULL, 'Family of unknown function (DUF5632)', NULL, 'DUF5632', NULL, NULL, 31527, 9),
(272580, NULL, 'PF17731', NULL, NULL, 'Family of unknown function (DUF5570)', NULL, 'DUF5570', NULL, NULL, 29436, 9),
(272581, NULL, 'PF12380', NULL, NULL, 'Gill-associated viral 3C-like peptidase', NULL, 'Peptidase_C62', NULL, NULL, 22474, 9),
(272582, NULL, 'PF20238', NULL, NULL, 'Family of unknown function (DUF6595)', NULL, 'DUF6595', NULL, NULL, 37722, 9),
(272583, NULL, 'PF11685', NULL, NULL, 'Protein of unknown function (DUF3281)', NULL, 'DUF3281', NULL, NULL, 19304, 9),
(272584, NULL, 'PF15270', NULL, NULL, 'Metallo-carboxypeptidase inhibitor', NULL, 'ACI44', NULL, NULL, 22166, 9),
(272585, NULL, 'PF11430', NULL, NULL, 'Programmed cell death activator EGL-1', NULL, 'EGL-1', NULL, NULL, 18541, 9),
(272586, NULL, 'PF17870', NULL, NULL, 'Insulin receptor trans-membrane segment', NULL, 'Insulin_TMD', NULL, NULL, 28234, 9),
(272587, NULL, 'PF10482', NULL, NULL, 'Tumour-suppressor protein CtIP N-terminal domain', NULL, 'CtIP_N', NULL, NULL, 18388, 9),
(272588, NULL, 'PF13543', NULL, NULL, 'SAM like domain present in kinase suppressor RAS 1', NULL, 'SAM_KSR1', NULL, NULL, 23816, 9),
(272589, NULL, 'PF05969', NULL, NULL, 'Photosystem II complex subunit Ycf12', NULL, 'PSII_Ycf12', NULL, NULL, 7613, 9),
(272590, NULL, 'PF18979', NULL, NULL, 'Family of unknown function (DUF5715)', NULL, 'DUF5715', NULL, NULL, 35348, 9),
(272591, NULL, 'PF01575', NULL, NULL, 'MaoC like domain', NULL, 'MaoC_dehydratas', NULL, NULL, 913, 9),
(272592, NULL, 'PF15086', NULL, NULL, 'Uncharacterised protein family UPF0542', NULL, 'UPF0542', NULL, NULL, 23685, 9),
(272593, NULL, 'PF13611', NULL, NULL, 'Serine peptidase of plant viral polyprotein, P1', NULL, 'Peptidase_S76', NULL, NULL, 22011, 9),
(272594, NULL, 'PF14983', NULL, NULL, 'Domain of unknown function (DUF4513)', NULL, 'DUF4513', NULL, NULL, 24155, 9),
(272595, NULL, 'PF07498', NULL, NULL, 'Rho termination factor, N-terminal domain', NULL, 'Rho_N', NULL, NULL, 11069, 9),
(272596, NULL, 'PF12702', NULL, NULL, 'Lipocalin-like', NULL, 'Lipocalin_3', NULL, NULL, 22924, 9),
(272597, NULL, 'PF19459', NULL, NULL, 'Family of unknown function (DUF5996)', NULL, 'DUF5996', NULL, NULL, 36549, 9),
(272598, NULL, 'PF03086', NULL, NULL, 'Domain of unknown function (DUF240)', NULL, 'DUF240', NULL, NULL, 4667, 9),
(272599, NULL, 'PF13051', NULL, NULL, 'Protein of unknown function (DUF3912)', NULL, 'DUF3912', NULL, NULL, 22840, 9),
(272600, NULL, 'PF14954', NULL, NULL, 'Limb expression 1', NULL, 'LIX1', NULL, NULL, 21668, 9),
(272601, NULL, 'PF03279', NULL, NULL, 'Bacterial lipid A biosynthesis acyltransferase', NULL, 'Lip_A_acyltrans', NULL, NULL, 2780, 9),
(272602, NULL, 'PF09005', NULL, NULL, 'Domain of unknown function (DUF1897)', NULL, 'DUF1897', NULL, NULL, 8698, 9),
(272603, NULL, 'PF19996', NULL, NULL, 'N-terminal helical region fused to the FtsH ternary system vWA domain', NULL, 'ivWA-helical_N', NULL, NULL, 34561, 9),
(272604, NULL, 'PF20463', NULL, NULL, 'Prephenate dehydrogenase, dimerization domain', NULL, 'PDH_C', NULL, NULL, 33702, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(272605, NULL, 'PF01092', NULL, NULL, 'Ribosomal protein S6e', NULL, 'Ribosomal_S6e', NULL, NULL, 6808, 9),
(272606, NULL, 'PF15821', NULL, NULL, 'Domain of unknown function (DUF4709)', NULL, 'DUF4709', NULL, NULL, 25797, 9),
(272607, NULL, 'PF19802', NULL, NULL, 'Domain of unknown function (DUF6285)', NULL, 'DUF6285', NULL, NULL, 37272, 9),
(272608, NULL, 'PF01091', NULL, NULL, 'PTN/MK heparin-binding protein family, C-terminal domain', NULL, 'PTN_MK_C', NULL, NULL, 16279, 9),
(272609, NULL, 'PF08543', NULL, NULL, 'Phosphomethylpyrimidine kinase', NULL, 'Phos_pyr_kin', NULL, NULL, 7556, 9),
(272610, NULL, 'PF02030', NULL, NULL, 'Hypothetical lipoprotein (MG045 family)', NULL, 'Lipoprotein_8', NULL, NULL, NULL, 9),
(272611, NULL, 'PF03813', NULL, NULL, 'Nrap protein domain 1', NULL, 'Nrap', NULL, NULL, 7094, 9),
(272612, NULL, 'PF09357', NULL, NULL, 'RteC protein', NULL, 'RteC', NULL, NULL, 14588, 9),
(272613, NULL, 'PF17072', NULL, NULL, 'Torovirinae spike glycoprotein', NULL, 'Spike_torovirin', NULL, NULL, 23920, 9),
(272614, NULL, 'PF18597', NULL, NULL, 'Myosin X N-terminal SH3 domain', NULL, 'SH3_19', NULL, NULL, 28035, 9),
(272615, NULL, 'PF00575', NULL, NULL, 'S1 RNA binding domain', NULL, 'S1', NULL, NULL, 459, 9),
(272616, NULL, 'PF08051', NULL, NULL, 'Erythromycin resistance leader peptide', NULL, 'Ery_res_leader1', NULL, NULL, 9114, 9),
(272617, NULL, 'PF05513', NULL, NULL, 'TraA', NULL, 'TraA', NULL, NULL, 7933, 9),
(272618, NULL, 'PF13678', NULL, NULL, 'NFkB-p65-degrading zinc protease', NULL, 'Peptidase_M85', NULL, NULL, 21579, 9),
(272619, NULL, 'PF07785', NULL, NULL, 'Protein of unknown function (DUF1623)', NULL, 'DUF1623', NULL, NULL, 13329, 9),
(272620, NULL, 'PF19538', NULL, NULL, 'Family of unknown function (DUF6062)', NULL, 'DUF6062', NULL, NULL, 36276, 9),
(272621, NULL, 'PF03741', NULL, NULL, 'Integral membrane protein TerC family', NULL, 'TerC', NULL, NULL, 566, 9),
(272622, NULL, 'PF04877', NULL, NULL, 'HrpZ', NULL, 'Harpin', NULL, NULL, 5820, 9),
(272623, NULL, 'PF11255', NULL, NULL, 'Protein of unknown function (DUF3054)', NULL, 'DUF3054', NULL, NULL, 18311, 9),
(272624, NULL, 'PF07933', NULL, NULL, 'Protein of unknown function (DUF1681)', NULL, 'DUF1681', NULL, NULL, 14482, 9),
(272625, NULL, 'PF07463', NULL, NULL, 'NUMOD4 motif', NULL, 'NUMOD4', NULL, NULL, 12450, 9),
(272626, NULL, 'PF12734', NULL, NULL, 'Cysteine-rich TM module stress tolerance', NULL, 'CYSTM', NULL, NULL, 21911, 9),
(272627, NULL, 'PF14921', NULL, NULL, 'Adenomatosis polyposis coli down-regulated 1', NULL, 'APCDDC', NULL, NULL, 23064, 9),
(272628, NULL, 'PF03574', NULL, NULL, 'Peptidase family S48', NULL, 'Peptidase_S48', NULL, NULL, 5482, 9),
(272629, NULL, 'PF09615', NULL, NULL, 'CRISPR-associated protein (Cas_Csy3)', NULL, 'Cas_Csy3', NULL, NULL, 11034, 9),
(272630, NULL, 'PF17958', NULL, NULL, 'EF-hand domain', NULL, 'EF-hand_13', NULL, NULL, 30036, 9),
(272631, NULL, 'PF09694', NULL, NULL, 'Bacterial protein of unknown function (Gcw_chp)', NULL, 'Gcw_chp', NULL, NULL, 5272, 9),
(272632, NULL, 'PF05497', NULL, NULL, 'Destabilase', NULL, 'Destabilase', NULL, NULL, 14087, 9),
(272633, NULL, 'PF09522', NULL, NULL, 'R.Pab1 restriction endonuclease', NULL, 'RE_R_Pab1', NULL, NULL, 15174, 9),
(272634, NULL, 'PF16344', NULL, NULL, 'Domain of unknown function (DUF4974)', NULL, 'DUF4974', NULL, NULL, 21928, 9),
(272635, NULL, 'PF17997', NULL, NULL, 'Insecticidal delta-endotoxin CryIA(c) domain 5', NULL, 'Cry1Ac_D5', NULL, NULL, 29806, 9),
(272636, NULL, 'PF13821', NULL, NULL, 'Domain of unknown function (DUF4187)', NULL, 'DUF4187', NULL, NULL, 23433, 9),
(272637, NULL, 'PF20618', NULL, NULL, 'Bacterial GPD, NAD-dependent C-terminal', NULL, 'GPD_NAD_C_bact', NULL, NULL, NULL, 9),
(272638, NULL, 'PF11992', NULL, NULL, 'TgpA N-terminal domain', NULL, 'TgpA_N', NULL, NULL, 19721, 9),
(272639, NULL, 'PF16109', NULL, NULL, 'Domain of unknown function (DUF4827)', NULL, 'DUF4827', NULL, NULL, 22158, 9),
(272640, NULL, 'PF02252', NULL, NULL, 'Proteasome activator pa28 beta subunit', NULL, 'PA28_beta', NULL, NULL, 1721, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(272641, NULL, 'PF08639', NULL, NULL, 'DNA replication regulator SLD3', NULL, 'SLD3', NULL, NULL, 7596, 9),
(272642, NULL, 'PF13827', NULL, NULL, 'Domain of unknown function (DUF4189)', NULL, 'DUF4189', NULL, NULL, 23259, 9),
(272643, NULL, 'PF10922', NULL, NULL, 'Bacteriophage T7-like, gene 1.2', NULL, 'T7-like_gp12', NULL, NULL, 16535, 9),
(272644, NULL, 'PF15730', NULL, NULL, 'Domain of unknown function (DUF4680)', NULL, 'DUF4680', NULL, NULL, 25891, 9),
(272645, NULL, 'PF03567', NULL, NULL, 'Sulfotransferase family', NULL, 'Sulfotransfer_2', NULL, NULL, 6513, 9),
(272646, NULL, 'PF04504', NULL, NULL, 'Protein of unknown function, DUF573', NULL, 'DUF573', NULL, NULL, 2635, 9),
(272647, NULL, 'PF06653', NULL, NULL, 'Tight junction protein, Claudin-like', NULL, 'Claudin_3', NULL, NULL, 10309, 9),
(272648, NULL, 'PF13775', NULL, NULL, 'Domain of unknown function (DUF4171)', NULL, 'DUF4171', NULL, NULL, 23295, 9),
(272649, NULL, 'PF17538', NULL, NULL, 'DNA Binding Domain (C-terminal) Leafy/Floricaula', NULL, 'C_LFY_FLO', NULL, NULL, 34000, 9),
(272650, NULL, 'PF08921', NULL, NULL, 'Domain of unknown function (DUF1904)', NULL, 'DUF1904', NULL, NULL, 7760, 9),
(272651, NULL, 'PF04457', NULL, NULL, 'MJ1316 RNA cyclic group end recognition domain', NULL, 'MJ1316', NULL, NULL, 27696, 9),
(272652, NULL, 'PF19197', NULL, NULL, 'Family of unknown function (DUF5872)', NULL, 'DUF5872', NULL, NULL, 35264, 9),
(272653, NULL, 'PF17031', NULL, NULL, 'Domain of unknown function (DUF5101)', NULL, 'DUF5101', NULL, NULL, 22965, 9),
(272654, NULL, 'PF12628', NULL, NULL, 'Falstatin, cysteine peptidase inhibitor', NULL, 'Inhibitor_I71', NULL, NULL, 26859, 9),
(272655, NULL, 'PF10003', NULL, NULL, 'Integral membrane protein (DUF2244)', NULL, 'DUF2244', NULL, NULL, 19603, 9),
(272656, NULL, 'PF15943', NULL, NULL, 'Putative antitoxin of bacterial toxin-antitoxin system, YdaS/YdaT', NULL, 'YdaS_antitoxin', NULL, NULL, 24743, 9),
(272657, NULL, 'PF00581', NULL, NULL, 'Rhodanese-like domain', NULL, 'Rhodanese', NULL, NULL, 3448, 9),
(272658, NULL, 'PF12697', NULL, NULL, 'Alpha/beta hydrolase family', NULL, 'Abhydrolase_6', NULL, NULL, 3611, 9),
(272659, NULL, 'PF16386', NULL, NULL, 'Domain of unknown function', NULL, 'DUF4995', NULL, NULL, 22214, 9),
(272660, NULL, 'PF03257', NULL, NULL, 'Mycoplasma adhesin P1, C-terminal', NULL, 'Adhesin_P1_C', NULL, NULL, 1909, 9),
(272661, NULL, 'PF05505', NULL, NULL, 'Ebola nucleoprotein', NULL, 'Ebola_NP', NULL, NULL, 14133, 9),
(272662, NULL, 'PF16600', NULL, NULL, 'Caskin1 CASK-interaction domain', NULL, 'Caskin1-CID', NULL, NULL, 26661, 9),
(272663, NULL, 'PF06675', NULL, NULL, 'Protein of unknown function (DUF1177)', NULL, 'DUF1177', NULL, NULL, 10021, 9),
(272664, NULL, 'PF15809', NULL, NULL, 'Simian taste bud-specific gene product family', NULL, 'STG', NULL, NULL, 24680, 9),
(272665, NULL, 'PF18812', NULL, NULL, 'phage-Barnase-EndoU-ColicinE5/D-RelE like nuclease3', NULL, 'PBECR3', NULL, NULL, 29258, 9),
(272666, NULL, 'PF16727', NULL, NULL, 'DNA repair protein REV1 C-terminal domain', NULL, 'REV1_C', NULL, NULL, 22904, 9),
(272667, NULL, 'PF19580', NULL, NULL, 'Endonuclease/Exonuclease/phosphatase family', NULL, 'Exo_endo_phos_3', NULL, NULL, 7323, 9),
(272668, NULL, 'PF00814', NULL, NULL, 'tRNA N6-adenosine threonylcarbamoyltransferase', NULL, 'TsaD', NULL, NULL, 25, 9),
(272669, NULL, 'PF11447', NULL, NULL, 'Protein of unknown function (DUF3201)', NULL, 'DUF3201', NULL, NULL, 24037, 9),
(272670, NULL, 'PF03527', NULL, NULL, 'RHS protein', NULL, 'RHS', NULL, NULL, 4173, 9),
(272671, NULL, 'PF10779', NULL, NULL, 'Haemolysin XhlA', NULL, 'XhlA', NULL, NULL, 20715, 9),
(272672, NULL, 'PF09872', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2099)', NULL, 'DUF2099', NULL, NULL, 9961, 9),
(272673, NULL, 'PF05928', NULL, NULL, 'Zea mays MURB-like protein (MuDR)', NULL, 'Zea_mays_MuDR', NULL, NULL, 12718, 9),
(272674, NULL, 'PF14937', NULL, NULL, 'Domain of unknown function (DUF4500)', NULL, 'DUF4500', NULL, NULL, 25714, 9),
(272675, NULL, 'PF16270', NULL, NULL, 'Lipocalin-like domain (DUF4923)', NULL, 'DUF4923', NULL, NULL, 21878, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(272676, NULL, 'PF03099', NULL, NULL, 'Biotin/lipoate A/B protein ligase family', NULL, 'BPL_LplA_LipB', NULL, NULL, 2571, 9),
(272677, NULL, 'PF04478', NULL, NULL, 'Mid2 like cell wall stress sensor', NULL, 'Mid2', NULL, NULL, 1713, 9),
(272678, NULL, 'PF14440', NULL, NULL, 'Xanthomonas XOO_2897-like deaminase', NULL, 'XOO_2897-deam', NULL, NULL, 26795, 9),
(272679, NULL, 'PF03173', NULL, NULL, 'Putative carbohydrate binding domain', NULL, 'CHB_HEX', NULL, NULL, 7326, 9),
(272680, NULL, 'PF01629', NULL, NULL, 'Domain of unknown function DUF22', NULL, 'DUF22', NULL, NULL, 1938, 9),
(272681, NULL, 'PF03873', NULL, NULL, 'Anti sigma-E protein RseA, C-terminal domain', NULL, 'RseA_C', NULL, NULL, 1876, 9),
(272682, NULL, 'PF16748', NULL, NULL, 'Inscuteable LGN-binding domain', NULL, 'INSC_LBD', NULL, NULL, 22944, 9),
(272683, NULL, 'PF11698', NULL, NULL, 'V-ATPase subunit H', NULL, 'V-ATPase_H_C', NULL, NULL, 12911, 9),
(272684, NULL, 'PF14706', NULL, NULL, 'Transposase DNA-binding', NULL, 'Tnp_DNA_bind', NULL, NULL, 12242, 9),
(272685, NULL, 'PF01777', NULL, NULL, 'Ribosomal L27e protein family', NULL, 'Ribosomal_L27e', NULL, NULL, 1179, 9),
(272686, NULL, 'PF13158', NULL, NULL, 'Protein of unknown function (DUF3993)', NULL, 'DUF3993', NULL, NULL, 22967, 9),
(272687, NULL, 'PF07004', NULL, NULL, 'Sperm-tail PG-rich repeat', NULL, 'SHIPPO-rpt', NULL, NULL, 9812, 9),
(272688, NULL, 'PF17207', NULL, NULL, 'MCM OB domain', NULL, 'MCM_OB', NULL, NULL, 31653, 9),
(272689, NULL, 'PF04038', NULL, NULL, 'Dihydroneopterin aldolase', NULL, 'DHNA', NULL, NULL, 938, 9),
(272690, NULL, 'PF00981', NULL, NULL, 'Rotavirus RNA-binding Protein 53 (NS53)', NULL, 'Rota_NS53', NULL, NULL, 5282, 9),
(272691, NULL, 'PF08889', NULL, NULL, 'WbqC-like protein family', NULL, 'WbqC', NULL, NULL, 14455, 9),
(272692, NULL, 'PF09795', NULL, NULL, 'Autophagy-related protein 31', NULL, 'ATG31', NULL, NULL, 16381, 9),
(272693, NULL, 'PF00434', NULL, NULL, 'Glycoprotein VP7', NULL, 'VP7', NULL, NULL, 2125, 9),
(272694, NULL, 'PF18572', NULL, NULL, 'Trehalose-6-phosphate phosphatase N-terminal helical bundle domain', NULL, 'T6PP_N', NULL, NULL, 28713, 9),
(272695, NULL, 'PF01649', NULL, NULL, 'Ribosomal protein S20', NULL, 'Ribosomal_S20p', NULL, NULL, 1788, 9),
(272696, NULL, 'PF06161', NULL, NULL, 'Protein of unknown function (DUF975)', NULL, 'DUF975', NULL, NULL, 9188, 9),
(272697, NULL, 'PF03583', NULL, NULL, 'Secretory lipase', NULL, 'LIP', NULL, NULL, 4112, 9),
(272698, NULL, 'PF09423', NULL, NULL, 'PhoD-like phosphatase', NULL, 'PhoD', NULL, NULL, 9430, 9),
(272699, NULL, 'PF08110', NULL, NULL, 'Ocellatin family', NULL, 'Antimicrobial15', NULL, NULL, 12888, 9),
(272700, NULL, 'PF13251', NULL, NULL, 'Domain of unknown function (DUF4042)', NULL, 'DUF4042', NULL, NULL, 23254, 9),
(272701, NULL, 'PF08756', NULL, NULL, 'YfkB-like domain', NULL, 'YfkB', NULL, NULL, 13364, 9),
(272702, NULL, 'PF10521', NULL, NULL, 'Tti2 family', NULL, 'Tti2', NULL, NULL, 20925, 9),
(272703, NULL, 'PF12898', NULL, NULL, 'Stc1 domain', NULL, 'Stc1', NULL, NULL, 13965, 9),
(272704, NULL, 'PF11505', NULL, NULL, 'Protein of unknown function (DUF3216)', NULL, 'DUF3216', NULL, NULL, 20666, 9),
(272705, NULL, 'PF16039', NULL, NULL, 'Domain of unknown function (DUF4791)', NULL, 'DUF4791', NULL, NULL, 25970, 9),
(272706, NULL, 'PF13691', NULL, NULL, 'tRNase Z endonuclease', NULL, 'Lactamase_B_4', NULL, NULL, 22878, 9),
(272707, NULL, 'PF15429', NULL, NULL, 'Domain of unknown function (DUF4628)', NULL, 'DUF4628', NULL, NULL, 25643, 9),
(272708, NULL, 'PF15551', NULL, NULL, 'Domain of unknown function (DUF4656)', NULL, 'DUF4656', NULL, NULL, 23960, 9),
(272709, NULL, 'PF05827', NULL, NULL, 'V-type proton ATPase subunit S1, luminal domain', NULL, 'VAS1_LD', NULL, NULL, 33748, 9),
(272710, NULL, 'PF07166', NULL, NULL, 'Protein of unknown function (DUF1398)', NULL, 'DUF1398', NULL, NULL, 13499, 9),
(272711, NULL, 'PF08958', NULL, NULL, 'Domain of unknown function (DUF1871)', NULL, 'DUF1871', NULL, NULL, 8688, 9),
(272712, NULL, 'PF01097', NULL, NULL, 'Arthropod defensin', NULL, 'Defensin_2', NULL, NULL, 5829, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(272713, NULL, 'PF10714', NULL, NULL, 'Late embryogenesis abundant protein 18', NULL, 'LEA_6', NULL, NULL, 14913, 9),
(272714, NULL, 'PF10373', NULL, NULL, 'Est1 DNA/RNA binding domain', NULL, 'EST1_DNA_bind', NULL, NULL, 20311, 9),
(272715, NULL, 'PF15654', NULL, NULL, 'Toxin with a conserved tryptophan and TIP tripeptide motif', NULL, 'Tox-WTIP', NULL, NULL, 24581, 9),
(272716, NULL, 'PF15978', NULL, NULL, 'Tn7-like transposition protein D', NULL, 'TnsD', NULL, NULL, 22406, 9),
(272717, NULL, 'PF09773', NULL, NULL, 'Meckelin (Transmembrane protein 67)', NULL, 'Meckelin', NULL, NULL, 18386, 9),
(272718, NULL, 'PF07088', NULL, NULL, 'GvpD gas vesicle protein, P-loop domain', NULL, 'GvpD_P-loop', NULL, NULL, 13412, 9),
(272719, NULL, 'PF01320', NULL, NULL, 'Colicin immunity protein / pyocin immunity protein', NULL, 'Colicin_Pyocin', NULL, NULL, 4245, 9),
(272720, NULL, 'PF05176', NULL, NULL, 'ATP10 protein', NULL, 'ATP-synt_10', NULL, NULL, 2276, 9),
(272721, NULL, 'PF18173', NULL, NULL, 'Bacterial HORMA domain 2', NULL, 'bacHORMA_2', NULL, NULL, 28047, 9),
(272722, NULL, 'PF04357', NULL, NULL, 'TamB, inner membrane protein subunit of TAM complex', NULL, 'TamB', NULL, NULL, 4724, 9),
(272723, NULL, 'PF18146', NULL, NULL, 'Damage-inducible protein CinA KH domain', NULL, 'CinA_KH', NULL, NULL, 30888, 9),
(272724, NULL, 'PF09772', NULL, NULL, 'Transmembrane protein 26', NULL, 'Tmem26', NULL, NULL, 18412, 9),
(272725, NULL, 'PF12409', NULL, NULL, 'P5-type ATPase cation transporter', NULL, 'P5-ATPase', NULL, NULL, 460, 9),
(272726, NULL, 'PF18078', NULL, NULL, 'Thioredoxin-like SNTX domain', NULL, 'Thioredoxin_11', NULL, NULL, 28872, 9),
(272727, NULL, 'PF01096', NULL, NULL, 'Transcription factor S-II (TFIIS)', NULL, 'TFIIS_C', NULL, NULL, 2346, 9),
(272728, NULL, 'PF04107', NULL, NULL, 'Glutamate-cysteine ligase family 2(GCS2)', NULL, 'GCS2', NULL, NULL, 4862, 9),
(272729, NULL, 'PF09699', NULL, NULL, 'Doubled CXXCH motif (Paired_CXXCH_1)', NULL, 'Paired_CXXCH_1', NULL, NULL, 4013, 9),
(272730, NULL, 'PF12941', NULL, NULL, 'HCV NS5a protein C-terminal region', NULL, 'HCV_NS5a_C', NULL, NULL, 22038, 9),
(272731, NULL, 'PF02565', NULL, NULL, 'Recombination protein O C terminal', NULL, 'RecO_C', NULL, NULL, 2058, 9),
(272732, NULL, 'PF15994', NULL, NULL, 'Domain of unknown function (DUF4770)', NULL, 'DUF4770', NULL, NULL, 24615, 9),
(272733, NULL, 'PF10697', NULL, NULL, 'Protein of unknown function (DUF2502)', NULL, 'DUF2502', NULL, NULL, 20698, 9),
(272734, NULL, 'PF18293', NULL, NULL, 'Caprin-1 dimerization domain', NULL, 'Caprin-1_dimer', NULL, NULL, 29651, 9),
(272735, NULL, 'PF02375', NULL, NULL, 'jmjN domain', NULL, 'JmjN', NULL, NULL, 4496, 9),
(272736, NULL, 'PF08794', NULL, NULL, 'Lipoprotein GNA1870 C terminal like', NULL, 'Lipoprot_C', NULL, NULL, 13450, 9),
(272737, NULL, 'PF13388', NULL, NULL, 'Protein of unknown function (DUF4106)', NULL, 'DUF4106', NULL, NULL, 22769, 9),
(272738, NULL, 'PF18363', NULL, NULL, 'Phosphoinositide phosphatase insertion domain', NULL, 'PI_PP_I', NULL, NULL, 28822, 9),
(272739, NULL, 'PF03102', NULL, NULL, 'NeuB family', NULL, 'NeuB', NULL, NULL, 9061, 9),
(272740, NULL, 'PF06183', NULL, NULL, 'DinI-like family', NULL, 'DinI', NULL, NULL, 9028, 9),
(272741, NULL, 'PF07705', NULL, NULL, 'CARDB', NULL, 'CARDB', NULL, NULL, 10921, 9),
(272742, NULL, 'PF18229', NULL, NULL, 'N-acetyl-beta-D-glucosaminidase N-terminal domain', NULL, 'GcnA_N', NULL, NULL, 29919, 9),
(272743, NULL, 'PF19850', NULL, NULL, 'Family of unknown function (DUF6325)', NULL, 'DUF6325', NULL, NULL, 37709, 9),
(272744, NULL, 'PF00206', NULL, NULL, 'Lyase', NULL, 'Lyase_1', NULL, NULL, 142, 9),
(272745, NULL, 'PF00961', NULL, NULL, 'LAGLIDADG endonuclease', NULL, 'LAGLIDADG_1', NULL, NULL, 7401, 9),
(272746, NULL, 'PF20284', NULL, NULL, 'C-terminal domain 8 of the ABC-three component (ABC-3C) systems', NULL, 'CTD8', NULL, NULL, 34484, 9),
(272747, NULL, 'PF11464', NULL, NULL, 'Rabenosyn Rab binding domain', NULL, 'Rbsn', NULL, NULL, 18957, 9),
(272748, NULL, 'PF17252', NULL, NULL, 'Family of unknown function (DUF5319)', NULL, 'DUF5319', NULL, NULL, 18915, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(272749, NULL, 'PF03320', NULL, NULL, 'Bacterial fructose-1,6-bisphosphatase, glpX-encoded', NULL, 'FBPase_glpX', NULL, NULL, 7391, 9),
(272750, NULL, 'PF00329', NULL, NULL, 'Respiratory-chain NADH dehydrogenase, 30 Kd subunit', NULL, 'Complex1_30kDa', NULL, NULL, 320, 9),
(272751, NULL, 'PF12144', NULL, NULL, 'Eukaryotic Mediator 12 catenin-binding domain', NULL, 'Med12-PQL', NULL, NULL, 20054, 9),
(272752, NULL, 'PF16977', NULL, NULL, 'C-terminal domain of apextrin', NULL, 'ApeC', NULL, NULL, 26762, 9),
(272753, NULL, 'PF16011', NULL, NULL, 'Carbohydrate-binding family 9', NULL, 'CBM9_2', NULL, NULL, 10267, 9),
(272754, NULL, 'PF14492', NULL, NULL, 'Elongation Factor G, domain III', NULL, 'EFG_III', NULL, NULL, 28788, 9),
(272755, NULL, 'PF13025', NULL, NULL, 'Protein of unknown function (DUF3886)', NULL, 'DUF3886', NULL, NULL, 22216, 9),
(272756, NULL, 'PF09438', NULL, NULL, 'Domain of unknown function (DUF2017)', NULL, 'DUF2017', NULL, NULL, 15059, 9),
(272757, NULL, 'PF07062', NULL, NULL, 'Clc-like', NULL, 'Clc-like', NULL, NULL, 9976, 9),
(272758, NULL, 'PF14935', NULL, NULL, 'Transmembrane protein 138', NULL, 'TMEM138', NULL, NULL, 8011, 9),
(272759, NULL, 'PF03597', NULL, NULL, 'Cytochrome oxidase maturation protein cbb3-type', NULL, 'FixS', NULL, NULL, 3354, 9),
(272760, NULL, 'PF01712', NULL, NULL, 'Deoxynucleoside kinase', NULL, 'dNK', NULL, NULL, 24020, 9),
(272761, NULL, 'PF09652', NULL, NULL, 'Putative CRISPR-associated protein (Cas_VVA1548)', NULL, 'Cas_VVA1548', NULL, NULL, 9397, 9),
(272762, NULL, 'PF01867', NULL, NULL, 'CRISPR associated protein Cas1', NULL, 'Cas_Cas1', NULL, NULL, 3676, 9),
(272763, NULL, 'PF06098', NULL, NULL, 'Radial spoke protein 3', NULL, 'Radial_spoke_3', NULL, NULL, 13976, 9),
(272764, NULL, 'PF05616', NULL, NULL, 'Neisseria meningitidis TspB protein', NULL, 'Neisseria_TspB', NULL, NULL, 13419, 9),
(272765, NULL, 'PF02257', NULL, NULL, 'RFX DNA-binding domain', NULL, 'RFX_DNA_binding', NULL, NULL, 1859, 9),
(272766, NULL, 'PF06991', NULL, NULL, 'Microfibril-associated/Pre-mRNA processing', NULL, 'MFAP1', NULL, NULL, 12046, 9),
(272767, NULL, 'PF04792', NULL, NULL, 'V antigen (LcrV) protein', NULL, 'LcrV', NULL, NULL, 7225, 9),
(272768, NULL, 'PF05294', NULL, NULL, 'Scorpion short toxin', NULL, 'Toxin_5', NULL, NULL, 4412, 9),
(272769, NULL, 'PF11149', NULL, NULL, 'Protein of unknown function (DUF2924)', NULL, 'DUF2924', NULL, NULL, 17842, 9),
(272770, NULL, 'PF17156', NULL, NULL, 'Gammaproteobacterial periplasmic sensor domain', NULL, 'GAPES2', NULL, NULL, 31049, 9),
(272771, NULL, 'PF06331', NULL, NULL, 'Transcription factor TFIIH complex subunit Tfb5', NULL, 'Tfb5', NULL, NULL, 8320, 9),
(272772, NULL, 'PF13906', NULL, NULL, 'C-terminus of AA_permease', NULL, 'AA_permease_C', NULL, NULL, 26926, 9),
(272773, NULL, 'PF01149', NULL, NULL, 'Formamidopyrimidine-DNA glycosylase N-terminal domain', NULL, 'Fapy_DNA_glyco', NULL, NULL, 11684, 9),
(272774, NULL, 'PF08237', NULL, NULL, 'PE-PPE domain', NULL, 'PE-PPE', NULL, NULL, 12151, 9),
(272775, NULL, 'PF07445', NULL, NULL, 'Primosomal replication protein priC', NULL, 'PriC', NULL, NULL, 11621, 9),
(272776, NULL, 'PF00596', NULL, NULL, 'Class II Aldolase and Adducin N-terminal domain', NULL, 'Aldolase_II', NULL, NULL, 263, 9),
(272777, NULL, 'PF18418', NULL, NULL, 'Ankyrin ubiquitin-binding domain', NULL, 'AnkUBD', NULL, NULL, 29234, 9),
(272778, NULL, 'PF07719', NULL, NULL, 'Tetratricopeptide repeat', NULL, 'TPR_2', NULL, NULL, 18515, 9),
(272779, NULL, 'PF05338', NULL, NULL, 'Protein of unknown function (DUF717)', NULL, 'DUF717', NULL, NULL, 4207, 9),
(272780, NULL, 'PF00378', NULL, NULL, 'Enoyl-CoA hydratase/isomerase', NULL, 'ECH_1', NULL, NULL, 3063, 9),
(272781, NULL, 'PF12530', NULL, NULL, 'Focadhesin/RST1, DUF3730', NULL, 'DUF3730', NULL, NULL, 16492, 9),
(272782, NULL, 'PF18577', NULL, NULL, 'Astrotactin-2 C-terminal beta-hairpin domain', NULL, 'ASTN_2_hairpin', NULL, NULL, 27884, 9),
(272783, NULL, 'PF04824', NULL, NULL, 'Conserved region of Rad21 / Rec8 like protein', NULL, 'Rad21_Rec8', NULL, NULL, 4815, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(272784, NULL, 'PF19762', NULL, NULL, 'Domain of unknown function (DUF6249)', NULL, 'DUF6249', NULL, NULL, 37492, 9),
(272785, NULL, 'PF16456', NULL, NULL, 'YmgD protein', NULL, 'YmgD', NULL, NULL, 22161, 9),
(272786, NULL, 'PF01415', NULL, NULL, 'Interleukin 7', NULL, 'IL7', NULL, NULL, 1376, 9),
(272787, NULL, 'PF14086', NULL, NULL, 'Domain of unknown function (DUF4266)', NULL, 'DUF4266', NULL, NULL, 22917, 9),
(272788, NULL, 'PF17506', NULL, NULL, 'Family of unknown function (DUF5438)', NULL, 'DUF5438', NULL, NULL, 12709, 9),
(272789, NULL, 'PF05644', NULL, NULL, 'Mitochondrial and peroxisomal fission factor Mff', NULL, 'Miff', NULL, NULL, 33296, 9),
(272790, NULL, 'PF08633', NULL, NULL, 'Rox3 mediator complex subunit', NULL, 'Rox3', NULL, NULL, 7940, 9),
(272791, NULL, 'PF12360', NULL, NULL, 'Paired box protein 7', NULL, 'Pax7', NULL, NULL, 20528, 9),
(272792, NULL, 'PF10062', NULL, NULL, 'Predicted secreted protein (DUF2300)', NULL, 'DUF2300', NULL, NULL, 18002, 9),
(272793, NULL, 'PF14208', NULL, NULL, 'Domain of unknown function (DUF4320)', NULL, 'DUF4320', NULL, NULL, 26328, 9),
(272794, NULL, 'PF19452', NULL, NULL, 'Family of unknown function (DUF5990)', NULL, 'DUF5990', NULL, NULL, 36679, 9),
(272795, NULL, 'PF12565', NULL, NULL, 'Protein of unknown function (DUF3747)', NULL, 'DUF3747', NULL, NULL, 21018, 9),
(272796, NULL, 'PF05599', NULL, NULL, 'Deltaretrovirus Tax protein', NULL, 'Deltaretro_Tax', NULL, NULL, 14092, 9),
(272797, NULL, 'PF00645', NULL, NULL, 'Poly(ADP-ribose) polymerase and DNA-Ligase Zn-finger region', NULL, 'zf-PARP', NULL, NULL, 3246, 9),
(272798, NULL, 'PF11948', NULL, NULL, 'Protein of unknown function (DUF3465)', NULL, 'DUF3465', NULL, NULL, 19743, 9),
(272799, NULL, 'PF11787', NULL, NULL, 'Aft1 HRR domain', NULL, 'Aft1_HRR', NULL, NULL, 19060, 9),
(272800, NULL, 'PF17610', NULL, NULL, 'Family of unknown function (DUF5505)', NULL, 'DUF5505', NULL, NULL, 18778, 9),
(272801, NULL, 'PF18837', NULL, NULL, 'Leucine-rich repeat', NULL, 'LRR_12', NULL, NULL, 29049, 9),
(272802, NULL, 'PF18702', NULL, NULL, 'Domain of unknown function (DUF5642)', NULL, 'DUF5642', NULL, NULL, 29255, 9),
(272803, NULL, 'PF05604', NULL, NULL, 'Protein of unknown function (DUF776)', NULL, 'DUF776', NULL, NULL, 12396, 9),
(272804, NULL, 'PF01958', NULL, NULL, 'Aspartate dehydrogenase, C-terminal', NULL, 'Asp_DH_C', NULL, NULL, 4536, 9),
(272805, NULL, 'PF08750', NULL, NULL, 'CNP1-like family', NULL, 'CNP1', NULL, NULL, 13435, 9),
(272806, NULL, 'PF11803', NULL, NULL, 'UDP-glucuronate decarboxylase N-terminal', NULL, 'UXS1_N', NULL, NULL, 19467, 9),
(272807, NULL, 'PF16139', NULL, NULL, 'Domain of unknown function (DUF4847)', NULL, 'DUF4847', NULL, NULL, 26318, 9),
(272808, NULL, 'PF08327', NULL, NULL, 'Activator of Hsp90 ATPase homolog 1-like protein', NULL, 'AHSA1', NULL, NULL, 12571, 9),
(272809, NULL, 'PF17144', NULL, NULL, 'Ribosomal large subunit proteins 60S L5, and 50S L18', NULL, 'Ribosomal_L5e', NULL, NULL, 657, 9),
(272810, NULL, 'PF17724', NULL, NULL, 'Family of unknown function (DUF5568)', NULL, 'DUF5568', NULL, NULL, 28920, 9),
(272811, NULL, 'PF18742', NULL, NULL, 'REase_DpnII-MboI', NULL, 'DpnII-MboI', NULL, NULL, NULL, 9),
(272812, NULL, 'PF04865', NULL, NULL, 'Baseplate J-like protein', NULL, 'Baseplate_J', NULL, NULL, 5610, 9),
(272813, NULL, 'PF14055', NULL, NULL, 'NVEALA protein', NULL, 'NVEALA', NULL, NULL, 23395, 9),
(272814, NULL, 'PF17767', NULL, NULL, 'Nicotinate phosphoribosyltransferase (NAPRTase) N-terminal domain', NULL, 'NAPRTase_N', NULL, NULL, 28276, 9),
(272815, NULL, 'PF18861', NULL, NULL, 'TM proximal of protein tyrosine phosphatase, receptor type J', NULL, 'PTP_tm', NULL, NULL, 29084, 9),
(272816, NULL, 'PF12396', NULL, NULL, 'Protein of unknown function (DUF3659)', NULL, 'DUF3659', NULL, NULL, 20990, 9),
(272817, NULL, 'PF16781', NULL, NULL, 'Domain of unknown function (DUF5068)', NULL, 'DUF5068', NULL, NULL, 26959, 9),
(272818, NULL, 'PF04453', NULL, NULL, 'LPS transport system D', NULL, 'LptD', NULL, NULL, 10572, 9),
(272819, NULL, 'PF09933', NULL, NULL, 'Predicted small integral membrane protein (DUF2165)', NULL, 'DUF2165', NULL, NULL, 17468, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(272820, NULL, 'PF12416', NULL, NULL, 'Cep120 protein', NULL, 'DUF3668', NULL, NULL, 20513, 9),
(272821, NULL, 'PF18003', NULL, NULL, 'Domain of unknown function (DUF3823_C)', NULL, 'DUF3823_C', NULL, NULL, 29329, 9),
(272822, NULL, 'PF07410', NULL, NULL, 'Streptococcus thermophilus bacteriophage Gp111 protein', NULL, 'Phage_Gp111', NULL, NULL, 11954, 9),
(272823, NULL, 'PF10369', NULL, NULL, 'Small subunit of acetolactate synthase', NULL, 'ALS_ss_C', NULL, NULL, 17205, 9),
(272824, NULL, 'PF05565', NULL, NULL, 'Siphovirus Gp157', NULL, 'Sipho_Gp157', NULL, NULL, 13570, 9),
(272825, NULL, 'PF12903', NULL, NULL, 'Protein of unknown function (DUF3830)', NULL, 'DUF3830', NULL, NULL, 24536, 9),
(272826, NULL, 'PF00218', NULL, NULL, 'Indole-3-glycerol phosphate synthase', NULL, 'IGPS', NULL, NULL, 9165, 9),
(272827, NULL, 'PF04571', NULL, NULL, 'lipin, N-terminal conserved region', NULL, 'Lipin_N', NULL, NULL, 498, 9),
(272828, NULL, 'PF13932', NULL, NULL, 'tRNA modifying enzyme MnmG/GidA C-terminal domain', NULL, 'GIDA_C', NULL, NULL, 26931, 9),
(272829, NULL, 'PF16110', NULL, NULL, 'Domain of unknown function (DUF4828)', NULL, 'DUF4828', NULL, NULL, 23528, 9),
(272830, NULL, 'PF12652', NULL, NULL, 'CotJB protein', NULL, 'CotJB', NULL, NULL, 9735, 9),
(272831, NULL, 'PF00640', NULL, NULL, 'Phosphotyrosine interaction domain (PTB/PID)', NULL, 'PID', NULL, NULL, 1395, 9),
(272832, NULL, 'PF00789', NULL, NULL, 'UBX domain', NULL, 'UBX', NULL, NULL, 2131, 9),
(272833, NULL, 'PF01734', NULL, NULL, 'Patatin-like phospholipase', NULL, 'Patatin', NULL, NULL, 2959, 9),
(272834, NULL, 'PF01491', NULL, NULL, 'Frataxin-like domain', NULL, 'Frataxin_Cyay', NULL, NULL, 6348, 9),
(272835, NULL, 'PF00209', NULL, NULL, 'Sodium:neurotransmitter symporter family', NULL, 'SNF', NULL, NULL, 3769, 9),
(272836, NULL, 'PF19994', NULL, NULL, 'GTPase-associated system helical domain', NULL, 'GASH', NULL, NULL, 35526, 9),
(272837, NULL, 'PF15576', NULL, NULL, 'Domain of unknown function (DUF4661)', NULL, 'DUF4661', NULL, NULL, 25381, 9),
(272838, NULL, 'PF12219', NULL, NULL, 'Catalytic domain of bacteriophage endosialidase', NULL, 'End_tail_spike', NULL, NULL, 26897, 9),
(272839, NULL, 'PF11324', NULL, NULL, 'Protein of unknown function (DUF3126)', NULL, 'DUF3126', NULL, NULL, 18131, 9),
(272840, NULL, 'PF16314', NULL, NULL, 'Domain of unknown function (DUF4954)', NULL, 'DUF4954', NULL, NULL, 25859, 9),
(272841, NULL, 'PF02735', NULL, NULL, 'Ku70/Ku80 beta-barrel domain', NULL, 'Ku', NULL, NULL, 10324, 9),
(272842, NULL, 'PF18254', NULL, NULL, 'HMW1 domain 2', NULL, 'HMw1_D2', NULL, NULL, 27662, 9),
(272843, NULL, 'PF04993', NULL, NULL, 'TfoX N-terminal domain', NULL, 'TfoX_N', NULL, NULL, 7212, 9),
(272844, NULL, 'PF11273', NULL, NULL, 'Protein of unknown function (DUF3073)', NULL, 'DUF3073', NULL, NULL, 18251, 9),
(272845, NULL, 'PF12886', NULL, NULL, 'Transducer of regulated CREB activity, C terminus', NULL, 'TORC_C', NULL, NULL, 23941, 9),
(272846, NULL, 'PF17917', NULL, NULL, 'RNase H-like domain found in reverse transcriptase', NULL, 'RT_RNaseH', NULL, NULL, 29265, 9),
(272847, NULL, 'PF08255', NULL, NULL, 'Trp-operon Leader Peptide', NULL, 'Leader_Trp', NULL, NULL, 17469, 9),
(272848, NULL, 'PF17573', NULL, NULL, 'GA-like domain', NULL, 'GA-like', NULL, NULL, 32880, 9),
(272849, NULL, 'PF00734', NULL, NULL, 'Fungal cellulose binding domain', NULL, 'CBM_1', NULL, NULL, 4882, 9),
(272850, NULL, 'PF12551', NULL, NULL, 'Poly-beta-hydroxybutyrate polymerase N terminal', NULL, 'PHBC_N', NULL, NULL, 21076, 9),
(272851, NULL, 'PF04564', NULL, NULL, 'U-box domain', NULL, 'U-box', NULL, NULL, 1000, 9),
(272852, NULL, 'PF00935', NULL, NULL, 'Ribosomal protein L44', NULL, 'Ribosomal_L44', NULL, NULL, 5586, 9),
(272853, NULL, 'PF17218', NULL, NULL, 'CBX family C-terminal motif', NULL, 'CBX7_C', NULL, NULL, 28196, 9),
(272854, NULL, 'PF18373', NULL, NULL, 'Spectrin like domain', NULL, 'Spectrin_like', NULL, NULL, 30469, 9),
(272855, NULL, 'PF17996', NULL, NULL, 'Carbohydrate esterase 2 N-terminal', NULL, 'CE2_N', NULL, NULL, 32126, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(272856, NULL, 'PF00189', NULL, NULL, 'Ribosomal protein S3, C-terminal domain', NULL, 'Ribosomal_S3_C', NULL, NULL, 7281, 9),
(272857, NULL, 'PF07418', NULL, NULL, 'Acidic phosphoprotein precursor PCEMA1', NULL, 'PCEMA1', NULL, NULL, 11842, 9),
(272858, NULL, 'PF10053', NULL, NULL, 'Uncharacterized conserved protein (DUF2290)', NULL, 'DUF2290', NULL, NULL, 18469, 9),
(272859, NULL, 'PF00763', NULL, NULL, 'Tetrahydrofolate dehydrogenase/cyclohydrolase, catalytic domain', NULL, 'THF_DHG_CYH', NULL, NULL, 20352, 9),
(272860, NULL, 'PF05936', NULL, NULL, 'Bacterial Type VI secretion, VC_A0110, EvfL, ImpJ, VasE', NULL, 'T6SS_VasE', NULL, NULL, 7753, 9),
(272861, NULL, 'PF12629', NULL, NULL, 'Poxvirus poly(A) polymerase C-terminal domain', NULL, 'Pox_polyA_pol_C', NULL, NULL, 22227, 9),
(272862, NULL, 'PF17692', NULL, NULL, 'Family of unknown function (DUF5538)', NULL, 'DUF5538', NULL, NULL, 28102, 9),
(272863, NULL, 'PF18218', NULL, NULL, 'Lantibiotic immunity protein Spa1 C-terminal domain', NULL, 'Spa1_C', NULL, NULL, 33292, 9),
(272864, NULL, 'PF07819', NULL, NULL, 'PGAP1-like protein', NULL, 'PGAP1', NULL, NULL, 13359, 9),
(272865, NULL, 'PF10622', NULL, NULL, 'Energy-converting hydrogenase B subunit P (EhbP)', NULL, 'Ehbp', NULL, NULL, 20453, 9),
(272866, NULL, 'PF01118', NULL, NULL, 'Semialdehyde dehydrogenase, NAD binding domain', NULL, 'Semialdhyde_dh', NULL, NULL, 5944, 9),
(272867, NULL, 'PF03348', NULL, NULL, 'Serine incorporator (Serinc)', NULL, 'Serinc', NULL, NULL, 884, 9),
(272868, NULL, 'PF04981', NULL, NULL, 'NMD3 family', NULL, 'NMD3', NULL, NULL, 6574, 9),
(272869, NULL, 'PF02332', NULL, NULL, 'Methane/Phenol/Toluene Hydroxylase', NULL, 'Phenol_Hydrox', NULL, NULL, 5154, 9),
(272870, NULL, 'PF06564', NULL, NULL, 'Cellulose biosynthesis protein BcsQ', NULL, 'CBP_BcsQ', NULL, NULL, 18662, 9),
(272871, NULL, 'PF20253', NULL, NULL, 'Family of unknown function (DUF6604)', NULL, 'DUF6604', NULL, NULL, 37605, 9),
(272872, NULL, 'PF01921', NULL, NULL, 'tRNA synthetases class I (K)', NULL, 'tRNA-synt_1f', NULL, NULL, 6277, 9),
(272873, NULL, 'PF10756', NULL, NULL, 'Bacterial PH domain', NULL, 'bPH_6', NULL, NULL, 20312, 9),
(272874, NULL, 'PF12499', NULL, NULL, 'Pherophorin', NULL, 'DUF3707', NULL, NULL, 26601, 9),
(272875, NULL, 'PF04163', NULL, NULL, 'Tht1-like nuclear fusion protein', NULL, 'Tht1', NULL, NULL, 7123, 9),
(272876, NULL, 'PF19811', NULL, NULL, 'Family of unknown function (DUF6294)', NULL, 'DUF6294', NULL, NULL, 37469, 9),
(272877, NULL, 'PF07593', NULL, NULL, 'ASPIC and UnbV', NULL, 'UnbV_ASPIC', NULL, NULL, 12808, 9),
(272878, NULL, 'PF14523', NULL, NULL, 'Syntaxin-like protein', NULL, 'Syntaxin_2', NULL, NULL, 1071, 9),
(272879, NULL, 'PF10865', NULL, NULL, 'Domain of unknown function (DUF2703)', NULL, 'DUF2703', NULL, NULL, 17878, 9),
(272880, NULL, 'PF20191', NULL, NULL, 'Family of unknown function (DUF6554)', NULL, 'DUF6554', NULL, NULL, 37476, 9),
(272881, NULL, 'PF09350', NULL, NULL, 'DnaJ homologue, subfamily C, member 28, conserved domain', NULL, 'DJC28_CD', NULL, NULL, 14539, 9),
(272882, NULL, 'PF06191', NULL, NULL, 'Protein of unknown function (DUF995)', NULL, 'DUF995', NULL, NULL, 14424, 9),
(272883, NULL, 'PF13762', NULL, NULL, 'Mitochondrial splicing apparatus component', NULL, 'MNE1', NULL, NULL, 24502, 9),
(272884, NULL, 'PF16937', NULL, NULL, 'Type III secretion system translocator protein, HrpF', NULL, 'T3SS_HrpK1', NULL, NULL, 25210, 9),
(272885, NULL, 'PF06219', NULL, NULL, 'Protein of unknown function (DUF1005)', NULL, 'DUF1005', NULL, NULL, 9107, 9),
(272886, NULL, 'PF15201', NULL, NULL, 'Progressive rod-cone degeneration', NULL, 'Rod_cone_degen', NULL, NULL, 24827, 9),
(272887, NULL, 'PF20093', NULL, NULL, 'Domain of unknown function (DUF6484)', NULL, 'DUF6484', NULL, NULL, 37229, 9),
(272888, NULL, 'PF13270', NULL, NULL, 'Coiled-coil domain-containing protein 28', NULL, 'CCDC28', NULL, NULL, 25746, 9),
(272889, NULL, 'PF19123', NULL, NULL, 'Family of unknown function (DUF5807)', NULL, 'DUF5807', NULL, NULL, 35952, 9),
(272890, NULL, 'PF09742', NULL, NULL, 'Dyggve-Melchior-Clausen syndrome protein', NULL, 'Dymeclin', NULL, NULL, NULL, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(272891, NULL, 'PF13910', NULL, NULL, 'Domain of unknown function (DUF4209)', NULL, 'DUF4209', NULL, NULL, 21941, 9),
(272892, NULL, 'PF06081', NULL, NULL, 'Aromatic acid exporter family member 1', NULL, 'ArAE_1', NULL, NULL, 8682, 9),
(272893, NULL, 'PF17952', NULL, NULL, 'Cas6 N-terminal domain', NULL, 'Cas6_N', NULL, NULL, 28593, 9),
(272894, NULL, 'PF14168', NULL, NULL, 'YjzC-like protein', NULL, 'YjzC', NULL, NULL, 24122, 9),
(272895, NULL, 'PF05340', NULL, NULL, 'Protein of unknown function (DUF740)', NULL, 'DUF740', NULL, NULL, 5033, 9),
(272896, NULL, 'PF11176', NULL, NULL, 'Translation machinery-associated protein 16', NULL, 'Tma16', NULL, NULL, 18487, 9),
(272897, NULL, 'PF16501', NULL, NULL, 'S phase cyclin A-associated protein in the endoplasmic reticulum', NULL, 'SCAPER_N', NULL, NULL, 24249, 9),
(272898, NULL, 'PF18694', NULL, NULL, 'Transactive response DNA-binding protein N-terminal domain', NULL, 'TDP43_N', NULL, NULL, 28971, 9),
(272899, NULL, 'PF15886', NULL, NULL, 'Carbohydrate binding domain (family 32)', NULL, 'CBM39', NULL, NULL, 25827, 9),
(272900, NULL, 'PF16117', NULL, NULL, 'Domain of unknown function (DUF4833)', NULL, 'DUF4833', NULL, NULL, 26414, 9),
(272901, NULL, 'PF18838', NULL, NULL, 'Large polyvalent protein associated domain 23', NULL, 'LPD23', NULL, NULL, 28134, 9),
(272902, NULL, 'PF16769', NULL, NULL, 'MCM3AP domain of GANP', NULL, 'MCM3AP_GANP', NULL, NULL, 22309, 9),
(272903, NULL, 'PF19508', NULL, NULL, 'Family of unknown function (DUF6042)', NULL, 'DUF6042', NULL, NULL, 37098, 9),
(272904, NULL, 'PF16174', NULL, NULL, 'Intracellular hyaluronan-binding protein 4 N-terminal', NULL, 'IHABP4_N', NULL, NULL, 26338, 9),
(272905, NULL, 'PF02690', NULL, NULL, 'Na+/Pi-cotransporter', NULL, 'Na_Pi_cotrans', NULL, NULL, 3205, 9),
(272906, NULL, 'PF07879', NULL, NULL, 'PHB/PHA accumulation regulator DNA-binding domain', NULL, 'PHB_acc_N', NULL, NULL, 13205, 9),
(272907, NULL, 'PF18468', NULL, NULL, 'Phosphofructokinase N-terminal domain yeast', NULL, 'Pfk_N', NULL, NULL, 27976, 9),
(272908, NULL, 'PF19284', NULL, NULL, 'Arc MA domain', NULL, 'Arc_MA', NULL, NULL, 36069, 9),
(272909, NULL, 'PF11609', NULL, NULL, 'Protein of unknown function (DUF3248)', NULL, 'DUF3248', NULL, NULL, 18735, 9),
(272910, NULL, 'PF11789', NULL, NULL, 'Zinc-finger of the MIZ type in Nse subunit', NULL, 'zf-Nse', NULL, NULL, 2874, 9),
(272911, NULL, 'PF18204', NULL, NULL, 'PGF-CTERM motif', NULL, 'PGF-CTERM', NULL, NULL, NULL, 9),
(272912, NULL, 'PF19230', NULL, NULL, 'Family of unknown function (DUF5883)', NULL, 'DUF5883', NULL, NULL, 37301, 9),
(272913, NULL, 'PF18144', NULL, NULL, 'Second Messenger Oligonucleotide or Dinucleotide Synthetase domain', NULL, 'SMODS', NULL, NULL, NULL, 9),
(272914, NULL, 'PF06597', NULL, NULL, 'Clostridium P-47 protein', NULL, 'Clostridium_P47', NULL, NULL, 8448, 9),
(272915, NULL, 'PF14914', NULL, NULL, 'LRRC37A/B like protein 1 C-terminal domain', NULL, 'LRRC37AB_C', NULL, NULL, 23722, 9),
(272916, NULL, 'PF16650', NULL, NULL, 'Unstructured region on SPEG complex protein', NULL, 'SPEG_u2', NULL, NULL, NULL, 9),
(272917, NULL, 'PF01416', NULL, NULL, 'tRNA pseudouridine synthase', NULL, 'PseudoU_synth_1', NULL, NULL, 18782, 9),
(272918, NULL, 'PF01645', NULL, NULL, 'Conserved region in glutamate synthase', NULL, 'Glu_synthase', NULL, NULL, 6985, 9),
(272919, NULL, 'PF09143', NULL, NULL, 'AvrPphF-ORF-2', NULL, 'AvrPphF-ORF-2', NULL, NULL, 10558, 9),
(272920, NULL, 'PF11632', NULL, NULL, 'Lactococcin G-beta', NULL, 'LcnG-beta', NULL, NULL, 15294, 9),
(272921, NULL, 'PF01430', NULL, NULL, 'Hsp33 protein', NULL, 'HSP33', NULL, NULL, 4769, 9),
(272922, NULL, 'PF06278', NULL, NULL, 'Condensin II complex subunit CAP-H2 or CNDH2, N-terminal', NULL, 'CNDH2_N', NULL, NULL, 8171, 9),
(272923, NULL, 'PF14427', NULL, NULL, 'Pput_2613-like deaminase', NULL, 'Pput2613-deam', NULL, NULL, 25503, 9),
(272924, NULL, 'PF15124', NULL, NULL, 'FANCD2 opposite strand protein', NULL, 'FANCD2OS', NULL, NULL, 24169, 9),
(272925, NULL, 'PF01115', NULL, NULL, 'F-actin capping protein, beta subunit', NULL, 'F_actin_cap_B', NULL, NULL, 3177, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(272926, NULL, 'PF20331', NULL, NULL, 'Family of unknown function (DUF6626)', NULL, 'DUF6626', NULL, NULL, 37153, 9),
(272927, NULL, 'PF20134', NULL, NULL, 'Family of unknown function (DUF6524)', NULL, 'DUF6524', NULL, NULL, 35693, 9),
(272928, NULL, 'PF03911', NULL, NULL, 'Sec61beta family', NULL, 'Sec61_beta', NULL, NULL, 15165, 9),
(272929, NULL, 'PF18964', NULL, NULL, 'Family of unknown function (DUF5704)', NULL, 'DUF5704', NULL, NULL, 34958, 9),
(272930, NULL, 'PF06782', NULL, NULL, 'Uncharacterised protein family (UPF0236)', NULL, 'UPF0236', NULL, NULL, 1842, 9),
(272931, NULL, 'PF09990', NULL, NULL, 'Predicted membrane protein (DUF2231)', NULL, 'DUF2231', NULL, NULL, 19963, 9),
(272932, NULL, 'PF14485', NULL, NULL, 'Domain of unknown function (DUF4431)', NULL, 'DUF4431', NULL, NULL, 21964, 9),
(272933, NULL, 'PF07865', NULL, NULL, 'Protein of unknown function (DUF1652)', NULL, 'DUF1652', NULL, NULL, 14014, 9),
(272934, NULL, 'PF07159', NULL, NULL, 'CYRIA/CYRIB Rac1 binding domain', NULL, 'CYRIA-B_Rac1-bd', NULL, NULL, 13232, 9),
(272935, NULL, 'PF18888', NULL, NULL, 'Repeat of unknown function (DUF5650)', NULL, 'DUF5650', NULL, NULL, 34208, 9),
(272936, NULL, 'PF20263', NULL, NULL, 'LYR motif-containing protein 2-like', NULL, 'LYRM2-like', NULL, NULL, 34377, 9),
(272937, NULL, 'PF16550', NULL, NULL, 'UCH-binding domain', NULL, 'RPN13_C', NULL, NULL, 26921, 9),
(272938, NULL, 'PF13128', NULL, NULL, 'Protein of unknown function (DUF3954)', NULL, 'DUF3954', NULL, NULL, 25649, 9),
(272939, NULL, 'PF03157', NULL, NULL, 'High molecular weight glutenin subunit', NULL, 'Glutenin_hmw', NULL, NULL, 6686, 9),
(272940, NULL, 'PF10469', NULL, NULL, 'AKAP7 2''5'' RNA ligase-like domain', NULL, 'AKAP7_NLS', NULL, NULL, 18481, 9),
(272941, NULL, 'PF04661', NULL, NULL, 'Poxvirus I3 ssDNA-binding protein', NULL, 'Pox_I3', NULL, NULL, 2584, 9),
(272942, NULL, 'PF11457', NULL, NULL, 'Protein of unknown function (DUF3021)', NULL, 'DUF3021', NULL, NULL, 18644, 9),
(272943, NULL, 'PF15320', NULL, NULL, 'mRNA cap methylation, RNMT-activating mini protein', NULL, 'RAM', NULL, NULL, 26837, 9),
(272944, NULL, 'PF05308', NULL, NULL, 'Mitochondrial fission regulator', NULL, 'Mito_fiss_reg', NULL, NULL, 4038, 9),
(272945, NULL, 'PF06579', NULL, NULL, 'Caenorhabditis elegans ly-6-related protein', NULL, 'Ly-6_related', NULL, NULL, 8317, 9),
(272946, NULL, 'PF03934', NULL, NULL, 'Type II secretion system (T2SS), protein K', NULL, 'T2SSK', NULL, NULL, 2521, 9),
(272947, NULL, 'PF17134', NULL, NULL, 'Domain of unknown function (DUF5109)', NULL, 'DUF5109', NULL, NULL, 30280, 9),
(272948, NULL, 'PF02374', NULL, NULL, 'Anion-transporting ATPase', NULL, 'ArsA_ATPase', NULL, NULL, 23137, 9),
(272949, NULL, 'PF20485', NULL, NULL, 'Family of unknown function (DUF6724)', NULL, 'DUF6724', NULL, NULL, 33949, 9),
(272950, NULL, 'PF11686', NULL, NULL, 'Protein of unknown function (DUF3283)', NULL, 'DUF3283', NULL, NULL, 19019, 9),
(272951, NULL, 'PF00984', NULL, NULL, 'UDP-glucose/GDP-mannose dehydrogenase family, central domain', NULL, 'UDPG_MGDP_dh', NULL, NULL, 8853, 9),
(272952, NULL, 'PF02589', NULL, NULL, 'LUD domain', NULL, 'LUD_dom', NULL, NULL, 2007, 9),
(272953, NULL, 'PF09509', NULL, NULL, 'Protein of unknown function (Hypoth_ymh)', NULL, 'Hypoth_Ymh', NULL, NULL, 10471, 9),
(272954, NULL, 'PF04841', NULL, NULL, 'Vps16, N-terminal region', NULL, 'Vps16_N', NULL, NULL, 4741, 9),
(272955, NULL, 'PF05048', NULL, NULL, 'Periplasmic copper-binding protein (NosD)', NULL, 'NosD', NULL, NULL, 1391, 9),
(272956, NULL, 'PF02718', NULL, NULL, 'Herpesvirus UL31-like protein', NULL, 'Herpes_UL31', NULL, NULL, 15287, 9),
(272957, NULL, 'PF18841', NULL, NULL, 'Beta solenoid repeat from Dextranase', NULL, 'B_solenoid_dext', NULL, NULL, 29161, 9),
(272958, NULL, 'PF16489', NULL, NULL, 'GPCR-Autoproteolysis INducing (GAIN) domain', NULL, 'GAIN', NULL, NULL, 21580, 9),
(272959, NULL, 'PF06962', NULL, NULL, 'Putative rRNA methylase', NULL, 'rRNA_methylase', NULL, NULL, 9578, 9),
(272960, NULL, 'PF11711', NULL, NULL, 'Inner membrane protein import complex subunit Tim54', NULL, 'Tim54', NULL, NULL, 15098, 9);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(272961, NULL, 'PF13922', NULL, NULL, 'PHD domain of transcriptional enhancer, Asx', NULL, 'PHD_3', NULL, NULL, 26902, 9),
(272962, NULL, 'PF14619', NULL, NULL, 'Snf2-ATP coupling, chromatin remodelling complex', NULL, 'SnAC', NULL, NULL, 26848, 9),
(272963, NULL, 'PF03827', NULL, NULL, 'Orexin receptor type 2', NULL, 'Orexin_rec2', NULL, NULL, 594, 9),
(272964, NULL, 'PF01238', NULL, NULL, 'Phosphomannose isomerase type I C-terminal', NULL, 'PMI_typeI_C', NULL, NULL, 37594, 9),
(272965, NULL, 'PF06510', NULL, NULL, 'Protein of unknown function (DUF1102)', NULL, 'DUF1102', NULL, NULL, 9461, 9),
(272966, NULL, 'PF13493', NULL, NULL, 'Domain of unknown function (DUF4118)', NULL, 'DUF4118', NULL, NULL, 22577, 9),
(272967, NULL, 'PF19524', NULL, NULL, 'Family of unknown function (DUF6054)', NULL, 'DUF6054', NULL, NULL, 37102, 9),
(272968, NULL, 'PF00997', NULL, NULL, 'Kappa casein', NULL, 'Casein_kappa', NULL, NULL, 4056, 9),
(272969, NULL, 'PF15977', NULL, NULL, 'Winged helix-turn-helix DNA binding', NULL, 'HTH_46', NULL, NULL, 30809, 9),
(272970, NULL, 'PF19705', NULL, NULL, 'Family of unknown function (DUF6202)', NULL, 'DUF6202', NULL, NULL, 37434, 9),
(272971, NULL, 'PF17413', NULL, NULL, 'Outer membrane lipoprotein virB7', NULL, 'VirB7', NULL, NULL, 29025, 9),
(272972, NULL, 'PF11710', NULL, NULL, 'G protein-coupled glucose receptor regulating Gpa2', NULL, 'Git3', NULL, NULL, 8526, 9),
(272973, NULL, 'PF10940', NULL, NULL, 'Leader peptide SpeFL', NULL, 'SpeFL', NULL, NULL, 17917, 9),
(272974, NULL, 'PF17803', NULL, NULL, 'Bacterial cadherin-like domain', NULL, 'Cadherin_4', NULL, NULL, 32650, 9),
(272975, NULL, 'PF20045', NULL, NULL, 'Family of unknown function (DUF6447)', NULL, 'DUF6447', NULL, NULL, 34127, 9),
(272976, NULL, 'PF02014', NULL, NULL, 'Reeler domain', NULL, 'Reeler', NULL, NULL, 5561, 9),
(272977, NULL, 'PF04579', NULL, NULL, 'Keratin, high-sulphur matrix protein', NULL, 'Keratin_matx', NULL, NULL, 65, 9),
(272978, NULL, 'PF04484', NULL, NULL, 'QWRF family', NULL, 'QWRF', NULL, NULL, 1573, 9),
(272979, NULL, 'PF04708', NULL, NULL, 'Poxvirus F16 protein', NULL, 'Pox_F16', NULL, NULL, 3727, 9),
(272980, NULL, 'PF08424', NULL, NULL, 'NRDE-2, necessary for RNA interference', NULL, 'NRDE-2', NULL, NULL, 11277, 9),
(272981, NULL, 'PF03261', NULL, NULL, 'Cyclin-dependent kinase 5 activator protein', NULL, 'CDK5_activator', NULL, NULL, 1653, 9),
(272982, NULL, 'PF13086', NULL, NULL, 'AAA domain', NULL, 'AAA_11', NULL, NULL, 30185, 9),
(272983, NULL, 'PF18956', NULL, NULL, 'Family of unknown function (DUF5699)', NULL, 'DUF5699', NULL, NULL, 34463, 9),
(272984, NULL, 'PF06551', NULL, NULL, 'Protein of unknown function (DUF1120)', NULL, 'DUF1120', NULL, NULL, 14182, 9),
(272985, NULL, 'PF10419', NULL, NULL, 'TFIIIC subunit triple barrel domain', NULL, 'TFIIIC_sub6', NULL, NULL, 17450, 9),
(272986, NULL, 'PF15277', NULL, NULL, 'Exocyst complex component SEC3 N-terminal PIP2 binding PH', NULL, 'Sec3-PIP2_bind', NULL, NULL, 23073, 9),
(272987, NULL, 'PF09846', NULL, NULL, 'Uncharacterized protein conserved in archaea (DUF2073)', NULL, 'DUF2073', NULL, NULL, 10681, 9),
(272988, NULL, 'PF06557', NULL, NULL, 'Protein of unknown function (DUF1122)', NULL, 'DUF1122', NULL, NULL, 8941, 9),
(272989, NULL, 'PF07751', NULL, NULL, 'Abi-like protein', NULL, 'Abi_2', NULL, NULL, 10684, 9),
(272990, NULL, 'PF09097', NULL, NULL, 'Baseplate structural protein, domain 1', NULL, 'Phage-tail_1', NULL, NULL, 10772, 9),
(272991, NULL, 'PF07213', NULL, NULL, 'DAP10 membrane protein', NULL, 'DAP10', NULL, NULL, 14070, 9),
(272992, NULL, 'PF08712', NULL, NULL, 'Scaffold protein Nfu/NifU N terminal', NULL, 'Nfu_N', NULL, NULL, 11889, 9),
(272993, NULL, 'PF13783', NULL, NULL, 'Domain of unknown function (DUF4177)', NULL, 'DUF4177', NULL, NULL, 23326, 9),
(272994, NULL, 'PF05464', NULL, NULL, 'Phi-29-like late genes activator (early protein GP4)', NULL, 'Phi-29_GP4', NULL, NULL, 12365, 9),
(272995, NULL, 'PF10110', NULL, NULL, 'Membrane domain of glycerophosphoryl diester phosphodiesterase', NULL, 'GPDPase_memb', NULL, NULL, 21105, 9);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(272996, NULL, 'PF16210', NULL, NULL, 'Keratin type II cytoskeletal 1 tail', NULL, 'Keratin_2_tail', NULL, NULL, 23613, 9),
(272997, NULL, 'PF05829', NULL, NULL, 'Adenovirus late L2 mu core protein (Protein X)', NULL, 'Adeno_PX', NULL, NULL, 7973, 9),
(272998, NULL, 'PF11620', NULL, NULL, 'GA-binding protein alpha chain', NULL, 'GABP-alpha', NULL, NULL, 21103, 9),
(272999, NULL, 'PF11331', NULL, NULL, 'Probable zinc-ribbon domain', NULL, 'zinc_ribbon_12', NULL, NULL, 18094, 9),
(273000, NULL, 'PF10030', NULL, NULL, 'Uncharacterized protein conserved in bacteria (DUF2272)', NULL, 'DUF2272', NULL, NULL, 19729, 9),
(273001, NULL, 'PF16089', NULL, NULL, 'Domain of unknown function (DUF4818)', NULL, 'DUF4818', NULL, NULL, 26268, 9),
(273002, NULL, 'PF03127', NULL, NULL, 'GAT domain', NULL, 'GAT', NULL, NULL, 2798, 9),
(273003, NULL, 'PF12356', NULL, NULL, 'Baculoviral IAP repeat-containing protein 6', NULL, 'BIRC6', NULL, NULL, 20704, 9),
(273004, NULL, 'PF04766', NULL, NULL, 'Nucleopolyhedrovirus p26 protein', NULL, 'Baculo_p26', NULL, NULL, 3808, 9),
(273005, NULL, 'PF12647', NULL, NULL, 'RNHCP domain', NULL, 'RNHCP', NULL, NULL, 26860, 9),
(273006, NULL, 'PF05620', NULL, NULL, 'SRP-independent targeting protein 2/TMEM208', NULL, 'TMEM208_SND2', NULL, NULL, 12158, 9),
(273007, NULL, 'PF17434', NULL, NULL, 'Family of unknown function (DUF5413)', NULL, 'DUF5413', NULL, NULL, 28057, 9),
(273008, NULL, 'PF06625', NULL, NULL, 'Protein of unknown function (DUF1151)', NULL, 'DUF1151', NULL, NULL, 10107, 9),
(273009, NULL, 'PF16450', NULL, NULL, 'Proteasomal ATPase OB C-terminal domain', NULL, 'Prot_ATP_ID_OB', NULL, NULL, 22421, 9),
(273010, NULL, 'PF17303', NULL, NULL, 'Family of unknown function (DUF5352)', NULL, 'DUF5352', NULL, NULL, 31727, 9),
(273011, NULL, 'PF03273', NULL, NULL, 'Baculovirus gp64 envelope glycoprotein family', NULL, 'Baculo_gp64', NULL, NULL, 2810, 9),
(273012, NULL, 'PF01406', NULL, NULL, 'tRNA synthetases class I (C) catalytic domain', NULL, 'tRNA-synt_1e', NULL, NULL, 18055, 9),
(273013, NULL, 'PF09490', NULL, NULL, 'Probable cobalt transporter subunit (CbtA)', NULL, 'CbtA', NULL, NULL, 10543, 9),
(273014, NULL, 'PF00066', NULL, NULL, 'LNR domain', NULL, 'Notch', NULL, NULL, 6841, 9),
(273015, NULL, 'PF07322', NULL, NULL, 'Seadornavirus Vp10', NULL, 'Seadorna_Vp10', NULL, NULL, 8259, 9),
(273016, NULL, 'PF00280', NULL, NULL, 'Potato inhibitor I family', NULL, 'potato_inhibit', NULL, NULL, 422, 9),
(273017, NULL, 'PF13355', NULL, NULL, 'ARC6-like, IMS domain', NULL, 'ARC6-like_IMS', NULL, NULL, 22426, 9),
(273018, NULL, 'PF03608', NULL, NULL, 'PTS system enzyme II sorbitol-specific factor', NULL, 'EII-GUT', NULL, NULL, 3466, 9),
(273019, NULL, 'PF13865', NULL, NULL, 'C-terminal duplication domain of Friend of PRMT1', NULL, 'FoP_duplication', NULL, NULL, 24518, 9),
(273020, NULL, 'PF05602', NULL, NULL, 'Cleft lip and palate transmembrane protein 1 (CLPTM1)', NULL, 'CLPTM1', NULL, NULL, 8677, 9),
(273021, NULL, 'PF15477', NULL, NULL, 'Small acidic protein family', NULL, 'SMAP', NULL, NULL, 21888, 9),
(273022, NULL, 'PF12440', NULL, NULL, 'Melanoma associated antigen family N terminal', NULL, 'MAGE_N', NULL, NULL, 15244, 9),
(273023, NULL, 'PF12964', NULL, NULL, 'Protein of unknown function (DUF3853)', NULL, 'DUF3853', NULL, NULL, 23747, 9),
(273024, NULL, 'PF08016', NULL, NULL, 'Polycystin cation channel', NULL, 'PKD_channel', NULL, NULL, 18920, 9),
(273025, NULL, 'PF09581', NULL, NULL, 'Stage III sporulation protein AF (Spore_III_AF)', NULL, 'Spore_III_AF', NULL, NULL, 11054, 9),
(273026, NULL, 'PF11405', NULL, NULL, 'Bromelain inhibitor VI', NULL, 'Inhibitor_I67', NULL, NULL, 16716, 9),
(273027, NULL, 'PF08289', NULL, NULL, 'Influenza Matrix protein (M1) C-terminal domain', NULL, 'Flu_M1_C', NULL, NULL, 17261, 9),
(273028, NULL, 'PF02046', NULL, NULL, 'Cytochrome c oxidase subunit VIa', NULL, 'COX6A', NULL, NULL, 2116, 9),
(273029, NULL, 'PF16180', NULL, NULL, 'RelB leucine zipper', NULL, 'RelB_leu_zip', NULL, NULL, 21534, 9),
(273030, NULL, 'PF19151', NULL, NULL, 'Sublancin', NULL, 'Sublancin', NULL, NULL, 25002, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(273031, NULL, 'PF05197', NULL, NULL, 'TRIC channel', NULL, 'TRIC', NULL, NULL, 3028, 9),
(273032, NULL, 'PF06477', NULL, NULL, 'Protein of unknown function (DUF1091)', NULL, 'DUF1091', NULL, NULL, 10199, 9),
(273033, NULL, 'PF07687', NULL, NULL, 'Peptidase dimerisation domain', NULL, 'M20_dimer', NULL, NULL, 10734, 9),
(273034, NULL, 'PF08668', NULL, NULL, 'HDOD domain', NULL, 'HDOD', NULL, NULL, 7952, 9),
(273035, NULL, 'PF09765', NULL, NULL, 'FANCL UBC-like domain 1', NULL, 'FANCL_d1', NULL, NULL, 18108, 9),
(273036, NULL, 'PF13746', NULL, NULL, '4Fe-4S dicluster domain', NULL, 'Fer4_18', NULL, NULL, 12567, 9),
(273037, NULL, 'PF07745', NULL, NULL, 'Glycosyl hydrolase family 53', NULL, 'Glyco_hydro_53', NULL, NULL, 10618, 9),
(273038, NULL, 'PF20125', NULL, NULL, 'Family of unknown function (DUF6515)', NULL, 'DUF6515', NULL, NULL, 35655, 9),
(273039, NULL, 'PF09527', NULL, NULL, 'Putative F0F1-ATPase subunit Ca2+/Mg2+ transporter', NULL, 'ATPase_gene1', NULL, NULL, 25206, 9),
(273040, NULL, 'PF16275', NULL, NULL, 'Splicing factor 1 helix-hairpin domain', NULL, 'SF1-HH', NULL, NULL, 21545, 9),
(273041, NULL, 'PF05756', NULL, NULL, 'S-antigen protein', NULL, 'S-antigen', NULL, NULL, 13862, 9),
(273042, NULL, 'PF11490', NULL, NULL, 'DNA polymerase III polC-type N-terminus II', NULL, 'DNA_pol3_a_NII', NULL, NULL, 23051, 9),
(273043, NULL, 'PF06030', NULL, NULL, 'Bacterial protein of unknown function (DUF916)', NULL, 'DUF916', NULL, NULL, 8827, 9),
(273044, NULL, 'PF15767', NULL, NULL, 'Armadillo-like helical domain-containing protein 4', NULL, 'ARMH4', NULL, NULL, 26983, 9),
(273045, NULL, 'PF09630', NULL, NULL, 'Domain of unknown function (DUF2024)', NULL, 'DUF2024', NULL, NULL, 15611, 9),
(273046, NULL, 'PF11098', NULL, NULL, 'Chlorosome envelope protein C', NULL, 'Chlorosome_CsmC', NULL, NULL, 15301, 9),
(273047, NULL, 'PF20037', NULL, NULL, 'Family of unknown function (DUF6440)', NULL, 'DUF6440', NULL, NULL, 37233, 9),
(273048, NULL, 'PF09457', NULL, NULL, 'FIP domain', NULL, 'RBD-FIP', NULL, NULL, 15982, 9),
(273049, NULL, 'PF13986', NULL, NULL, 'Domain of unknown function (DUF4224)', NULL, 'DUF4224', NULL, NULL, 22344, 9),
(273050, NULL, 'PF00119', NULL, NULL, 'ATP synthase A chain', NULL, 'ATP-synt_A', NULL, NULL, 5815, 9),
(273051, NULL, 'PF11932', NULL, NULL, 'Protein of unknown function (DUF3450)', NULL, 'DUF3450', NULL, NULL, 16404, 9),
(273052, NULL, 'PF13258', NULL, NULL, 'Domain of unknown function (DUF4049)', NULL, 'DUF4049', NULL, NULL, 22718, 9),
(273053, NULL, 'PF11187', NULL, NULL, 'Mbeg1-like', NULL, 'Mbeg1-like', NULL, NULL, 24349, 9),
(273054, NULL, 'PF00974', NULL, NULL, 'Rhabdovirus spike glycoprotein', NULL, 'Rhabdo_glycop', NULL, NULL, 4210, 9),
(273055, NULL, 'PF07535', NULL, NULL, 'DBF zinc finger', NULL, 'zf-DBF', NULL, NULL, 419, 9),
(273056, NULL, 'PF08223', NULL, NULL, 'PaaX-like protein C-terminal domain', NULL, 'PaaX_C', NULL, NULL, 12058, 9),
(273057, NULL, 'PF01455', NULL, NULL, 'HupF/HypC family', NULL, 'HupF_HypC', NULL, NULL, 1282, 9),
(273058, NULL, 'PF16747', NULL, NULL, 'Surface-adhesin protein E', NULL, 'Adhesin_E', NULL, NULL, 22738, 9),
(273059, NULL, 'PF00150', NULL, NULL, 'Cellulase (glycosyl hydrolase family 5)', NULL, 'Cellulase', NULL, NULL, 5629, 9),
(273060, NULL, 'PF11045', NULL, NULL, 'Putative inner membrane protein of Enterobacteriaceae', NULL, 'YbjM', NULL, NULL, 19619, 9),
(273061, NULL, 'PF11914', NULL, NULL, 'Domain of unknown function (DUF3432)', NULL, 'DUF3432', NULL, NULL, 19943, 9),
(273062, NULL, 'PF16402', NULL, NULL, 'Domain of unknown function (DUF5010)', NULL, 'DUF5010', NULL, NULL, 23598, 9),
(273063, NULL, 'PF02309', NULL, NULL, 'AUX/IAA family', NULL, 'AUX_IAA', NULL, NULL, 30091, 9),
(273064, NULL, 'PF15416', NULL, NULL, 'Domain of unknown function (DUF4623)', NULL, 'DUF4623', NULL, NULL, 25501, 9),
(273065, NULL, 'PF20502', NULL, NULL, 'DNA-dependent protein kinase catalytic subunit, CC1/2', NULL, 'DNAPKcs_CC1-2', NULL, NULL, 37757, 9),
(273066, NULL, 'PF13584', NULL, NULL, 'BatD DUF11 like domain', NULL, 'BatD', NULL, NULL, 24935, 9);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(273067, NULL, 'PF16683', NULL, NULL, 'Transglutaminase elicitor', NULL, 'TGase_elicitor', NULL, NULL, 25073, 9),
(273068, NULL, 'PF10290', NULL, NULL, 'Cell wall protein YJL171C/Tos1, N-terminal', NULL, 'YJL171C_Tos1_N', NULL, NULL, 19160, 9),
(273069, NULL, 'PF12916', NULL, NULL, 'Protein of unknown function (DUF3834)', NULL, 'DUF3834', NULL, NULL, 24817, 9),
(273070, NULL, 'PF02460', NULL, NULL, 'Patched family', NULL, 'Patched', NULL, NULL, 5030, 9),
(273071, NULL, 'PF02911', NULL, NULL, 'Formyl transferase, C-terminal domain', NULL, 'Formyl_trans_C', NULL, NULL, 6616, 9),
(273072, NULL, 'PF03753', NULL, NULL, 'Human herpesvirus 6 immediate early protein', NULL, 'HHV6-IE', NULL, NULL, 745, 9),
(273073, NULL, 'PF06797', NULL, NULL, 'Protein of unknown function (DUF1229)', NULL, 'DUF1229', NULL, NULL, 1939, 9),
(273074, NULL, 'PF17574', NULL, NULL, 'Inhibitor of toxin/antitoxin system (Gp4.5)', NULL, 'TA_inhibitor', NULL, NULL, 32743, 9),
(273075, NULL, 'PF00612', NULL, NULL, 'IQ calmodulin-binding motif', NULL, 'IQ', NULL, NULL, 2708, 9),
(273076, NULL, 'PF19666', NULL, NULL, 'Family of unknown function (DUF6169)', NULL, 'DUF6169', NULL, NULL, 37463, 9),
(273077, NULL, 'PF09126', NULL, NULL, 'Restriction endonuclease NaeI', NULL, 'NaeI', NULL, NULL, 10877, 9),
(273078, NULL, 'PF04786', NULL, NULL, 'ssDNA binding protein', NULL, 'Baculo_DNA_bind', NULL, NULL, 4633, 9),
(273079, NULL, 'PF12277', NULL, NULL, 'Protein of unknown function (DUF3618)', NULL, 'DUF3618', NULL, NULL, 20525, 9),
(273080, NULL, 'PF14527', NULL, NULL, 'WhiA LAGLIDADG-like domain', NULL, 'LAGLIDADG_WhiA', NULL, NULL, 33179, 9),
(273081, NULL, 'PF04612', NULL, NULL, 'Type II secretion system (T2SS), protein M', NULL, 'T2SSM', NULL, NULL, 1375, 9),
(273082, NULL, 'PF16121', NULL, NULL, '40S ribosomal protein S4 C-terminus', NULL, '40S_S4_C', NULL, NULL, 26426, 9),
(273083, NULL, 'PF09079', NULL, NULL, 'CDC6, C terminal winged helix domain', NULL, 'Cdc6_C', NULL, NULL, 9714, 9),
(273084, NULL, 'PF11753', NULL, NULL, 'Protein of unknwon function (DUF3310)', NULL, 'DUF3310', NULL, NULL, 19402, 9),
(273085, NULL, 'PF17880', NULL, NULL, 'Yos9 dimerzation domain', NULL, 'Yos9_DD', NULL, NULL, 28412, 9),
(273086, NULL, 'PF04771', NULL, NULL, 'Chicken anaemia virus VP-3 protein', NULL, 'CAV_VP3', NULL, NULL, 3879, 9),
(273087, NULL, 'PF07653', NULL, NULL, 'Variant SH3 domain', NULL, 'SH3_2', NULL, NULL, 6232, 9),
(273088, NULL, 'PF12510', NULL, NULL, 'Smoothelin cytoskeleton protein', NULL, 'Smoothelin', NULL, NULL, 21065, 9),
(273089, NULL, 'PF05061', NULL, NULL, 'Poxvirus A11 Protein', NULL, 'Pox_A11', NULL, NULL, 1193, 9),
(273090, NULL, 'PF13094', NULL, NULL, 'CENP-Q, a CENPA-CAD centromere complex subunit', NULL, 'CENP-Q', NULL, NULL, 22349, 9),
(273091, NULL, 'PF13661', NULL, NULL, '2OG-Fe(II) oxygenase superfamily', NULL, '2OG-FeII_Oxy_4', NULL, NULL, 33113, 9),
(273092, NULL, 'PF00480', NULL, NULL, 'ROK family', NULL, 'ROK', NULL, NULL, 5948, 9),
(273093, NULL, 'PF03945', NULL, NULL, 'delta endotoxin, N-terminal domain', NULL, 'Endotoxin_N', NULL, NULL, 2893, 9),
(273094, NULL, 'PF10263', NULL, NULL, 'SprT-like family', NULL, 'SprT-like', NULL, NULL, 1176, 9),
(273095, NULL, 'PF01442', NULL, NULL, 'Apolipoprotein A1/A4/E domain', NULL, 'Apolipoprotein', NULL, NULL, 2740, 9),
(273096, NULL, 'PF04238', NULL, NULL, 'Protein of unknown function (DUF420)', NULL, 'DUF420', NULL, NULL, 5867, 9),
(273097, NULL, 'PF17990', NULL, NULL, 'L-Lysine epsilon oxidase N-terminal', NULL, 'LodA_N', NULL, NULL, 28793, 9),
(273098, NULL, 'PF19383', NULL, NULL, 'Family of unknown function (DUF5958)', NULL, 'DUF5958', NULL, NULL, 36678, 9),
(273099, NULL, 'PF02810', NULL, NULL, 'SEC-C motif', NULL, 'SEC-C', NULL, NULL, 911, 9),
(273100, NULL, 'PF01876', NULL, NULL, 'RNase P subunit p30', NULL, 'RNase_P_p30', NULL, NULL, 3874, 9),
(273101, NULL, 'PF07758', NULL, NULL, 'Protein of unknown function (DUF1614)', NULL, 'DUF1614', NULL, NULL, 10636, 9),
(273102, NULL, 'PF10698', NULL, NULL, 'Protein of unknown function (DUF2505)', NULL, 'DUF2505', NULL, NULL, 20983, 9); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(273103, NULL, 'PF11658', NULL, NULL, 'Cellulose biosynthesis protein BcsG', NULL, 'CBP_BcsG', NULL, NULL, 18851, 9),
(273104, NULL, 'PF18797', NULL, NULL, 'Adenomatous polyposis coli (APC) repeat', NULL, 'APC_rep', NULL, NULL, 29930, 9),
(273105, NULL, 'PF00632', NULL, NULL, 'HECT-domain (ubiquitin-transferase)', NULL, 'HECT', NULL, NULL, 5907, 9),
(273106, NULL, 'PF02341', NULL, NULL, 'RbcX protein', NULL, 'RbcX', NULL, NULL, 5362, 9),
(273107, NULL, 'PF10247', NULL, NULL, 'Reactive mitochondrial oxygen species modulator 1', NULL, 'Romo1', NULL, NULL, 9290, 9),
(273108, NULL, 'PF15391', NULL, NULL, 'Domain of unknown function (DUF4614)', NULL, 'DUF4614', NULL, NULL, 25835, 9),
(273109, NULL, 'PF16292', NULL, NULL, 'Domain of unknown function (DUF4938)', NULL, 'DUF4938', NULL, NULL, 21753, 9),
(273110, NULL, 'PF09709', NULL, NULL, 'CRISPR-associated protein (Cas_Csd1)', NULL, 'Cas_Csd1', NULL, NULL, 10862, 9),
(273111, NULL, 'PF19366', NULL, NULL, 'Domain of unknown function (DUF5942)', NULL, 'DUF5942', NULL, NULL, 36608, 9),
(273112, NULL, 'PF15798', NULL, NULL, 'Proline-rich AKT1 substrate 1', NULL, 'PRAS', NULL, NULL, 25697, 9),
(273113, NULL, 'PF02230', NULL, NULL, 'Phospholipase/Carboxylesterase', NULL, 'Abhydrolase_2', NULL, NULL, 1806, 9),
(273114, NULL, 'PF20246', NULL, NULL, 'Family of unknown function (DUF6601)', NULL, 'DUF6601', NULL, NULL, 37714, 9),
(273115, NULL, 'PF13794', NULL, NULL, 'tRNA-(MS[2]IO[6]A)-hydroxylase (MiaE)-like', NULL, 'MiaE_2', NULL, NULL, NULL, 9),
(273116, NULL, 'PF09376', NULL, NULL, 'NurA domain', NULL, 'NurA', NULL, NULL, 14871, 9),
(273117, NULL, 'PF16994', NULL, NULL, 'Glycosyl-transferase family 4', NULL, 'Glyco_trans_4_5', NULL, NULL, 30400, 9),
(273118, NULL, 'PF04709', NULL, NULL, 'Anti-Mullerian hormone, N terminal region', NULL, 'AMH_N', NULL, NULL, 3609, 9),
(273119, NULL, 'PF16164', NULL, NULL, 'VWA N-terminal', NULL, 'VWA_N2', NULL, NULL, 22759, 9),
(273120, NULL, 'PF11104', NULL, NULL, 'Type IV pilus assembly protein PilM;', NULL, 'PilM_2', NULL, NULL, 6703, 9),
(273121, NULL, 'PF05766', NULL, NULL, 'Bacteriophage Lambda NinG protein', NULL, 'NinG', NULL, NULL, 13346, 9),
(273122, NULL, 'PF00681', NULL, NULL, 'Plectin repeat', NULL, 'Plectin', NULL, NULL, 5121, 9),
(273123, NULL, 'PF04358', NULL, NULL, 'DsrC like protein', NULL, 'DsrC', NULL, NULL, 4858, 9),
(273124, NULL, 'PF18554', NULL, NULL, 'PheRS DNA binding domain 2', NULL, 'PheRS_DBD2', NULL, NULL, 28727, 9),
(273125, NULL, 'PF13670', NULL, NULL, 'Peptidase propeptide and YPEB domain', NULL, 'PepSY_2', NULL, NULL, 24812, 9),
(273126, NULL, 'PF10548', NULL, NULL, 'P22AR C-terminal domain', NULL, 'P22_AR_C', NULL, NULL, 20537, 9),
(273127, NULL, 'PF20156', NULL, NULL, 'Flagellin glycosyltransferase Maf helical bundle domain', NULL, 'Maf_C', NULL, NULL, 37450, 9),
(273128, NULL, 'PF03017', NULL, NULL, 'TNP1/EN/SPM transposase', NULL, 'Transposase_23', NULL, NULL, 3632, 9),
(273129, NULL, 'PF13721', NULL, NULL, 'SecD export protein N-terminal TM region', NULL, 'SecD-TM1', NULL, NULL, 24589, 9),
(273130, NULL, 'PF00527', NULL, NULL, 'E7 protein, Early protein', NULL, 'E7', NULL, NULL, 3941, 9),
(273131, NULL, 'PF05886', NULL, NULL, 'Orthopoxvirus F8 protein', NULL, 'Orthopox_F8', NULL, NULL, 12043, 9),
(273132, NULL, 'PF19930', NULL, NULL, 'Family of unknown function (DUF6393)', NULL, 'DUF6393', NULL, NULL, 36185, 9),
(273133, NULL, 'PF03829', NULL, NULL, 'PTS system glucitol/sorbitol-specific IIA component', NULL, 'PTSIIA_gutA', NULL, NULL, 3493, 9),
(273134, NULL, 'PF00269', NULL, NULL, 'Small, acid-soluble spore proteins, alpha/beta type', NULL, 'SASP', NULL, NULL, 3176, 9),
(273135, NULL, 'PF00512', NULL, NULL, 'His Kinase A (phospho-acceptor) domain', NULL, 'HisKA', NULL, NULL, 1082, 9),
(273136, NULL, 'PF17649', NULL, NULL, 'Vacuolar protein sorting 38', NULL, 'VPS38', NULL, NULL, 29361, 9),
(273137, NULL, 'PF02826', NULL, NULL, 'D-isomer specific 2-hydroxyacid dehydrogenase, NAD binding domain', NULL, '2-Hacid_dh_C', NULL, NULL, 10370, 9),
(273138, NULL, 'PF04935', NULL, NULL, 'Surfeit locus protein 6', NULL, 'SURF6', NULL, NULL, 26967, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(273139, NULL, 'PF12806', NULL, NULL, 'Acetyl-CoA dehydrogenase C-terminal like', NULL, 'Acyl-CoA_dh_C', NULL, NULL, 25833, 9),
(273140, NULL, 'PF19115', NULL, NULL, 'Family of unknown function (DUF5800)', NULL, 'DUF5800', NULL, NULL, 35800, 9),
(273141, NULL, 'PF14760', NULL, NULL, 'Rnk N-terminus', NULL, 'Rnk_N', NULL, NULL, 23042, 9),
(273142, NULL, 'PF10149', NULL, NULL, 'Transmembrane protein 231', NULL, 'TM231', NULL, NULL, 14622, 9),
(273143, NULL, 'PF09437', NULL, NULL, 'Pombe specific 5TM protein', NULL, 'Pombe_5TM', NULL, NULL, 19380, 9),
(273144, NULL, 'PF07051', NULL, NULL, 'Ovarian carcinoma immunoreactive antigen (OCIA)', NULL, 'OCIA', NULL, NULL, 12587, 9),
(273145, NULL, 'PF07609', NULL, NULL, 'Protein of unknown function (DUF1572)', NULL, 'DUF1572', NULL, NULL, 13738, 9),
(273146, NULL, 'PF16673', NULL, NULL, 'TNF receptor-associated factor BIRC3 binding domain', NULL, 'TRAF_BIRC3_bd', NULL, NULL, 26079, 9),
(273147, NULL, 'PF06002', NULL, NULL, 'Alpha-2,3-sialyltransferase (CST-I)', NULL, 'CST-I', NULL, NULL, 13744, 9),
(273148, NULL, 'PF14094', NULL, NULL, 'Domain of unknown function (DUF4272)', NULL, 'DUF4272', NULL, NULL, 22634, 9),
(273149, NULL, 'PF01378', NULL, NULL, 'B domain', NULL, 'IgG_binding_B', NULL, NULL, 3624, 9),
(273150, NULL, 'PF17066', NULL, NULL, 'RBPJ-interacting and tubulin associated protein', NULL, 'RITA', NULL, NULL, 26266, 9),
(273151, NULL, 'PF19922', NULL, NULL, 'MoxR-vWA-beta-propeller ternary system domain bpX6', NULL, 'bpX6', NULL, NULL, 37260, 9),
(273152, NULL, 'PF00843', NULL, NULL, 'Arenavirus nucleocapsid N-terminal domain', NULL, 'Arena_nucleocap', NULL, NULL, 7965, 9),
(273153, NULL, 'PF09755', NULL, NULL, 'Uncharacterized conserved protein H4 (DUF2046)', NULL, 'DUF2046', NULL, NULL, 18053, 9),
(273154, NULL, 'PF07996', NULL, NULL, 'Type IV secretion system proteins', NULL, 'T4SS', NULL, NULL, 14367, 9),
(273155, NULL, 'PF13920', NULL, NULL, 'Zinc finger, C3HC4 type (RING finger)', NULL, 'zf-C3HC4_3', NULL, NULL, NULL, 9),
(273156, NULL, 'PF15334', NULL, NULL, 'Aurora kinase A and ninein interacting protein', NULL, 'AIB', NULL, NULL, 26497, 9),
(273157, NULL, 'PF06788', NULL, NULL, 'Uncharacterised protein family (UPF0257)', NULL, 'UPF0257', NULL, NULL, 9178, 9),
(273158, NULL, 'PF01110', NULL, NULL, 'Ciliary neurotrophic factor', NULL, 'CNTF', NULL, NULL, 1783, 9),
(273159, NULL, 'PF03051', NULL, NULL, 'Peptidase C1-like family', NULL, 'Peptidase_C1_2', NULL, NULL, 2919, 9),
(273160, NULL, 'PF08818', NULL, NULL, 'Domain of unknown function (DU1801)', NULL, 'DUF1801', NULL, NULL, 14435, 9),
(273161, NULL, 'PF11829', NULL, NULL, 'Protein of unknown function (DUF3349)', NULL, 'DUF3349', NULL, NULL, 19164, 9),
(273162, NULL, 'PF17787', NULL, NULL, 'PH domain', NULL, 'PH_14', NULL, NULL, 31623, 9),
(273163, NULL, 'PF16881', NULL, NULL, 'N-terminal domain of lipoyl synthase of Radical_SAM family', NULL, 'LIAS_N', NULL, NULL, 24394, 9),
(273164, NULL, 'PF07084', NULL, NULL, 'Thyroid hormone-inducible hepatic protein Spot 14', NULL, 'Spot_14', NULL, NULL, 13250, 9),
(273165, NULL, 'PF07634', NULL, NULL, 'RtxA repeat', NULL, 'RtxA', NULL, NULL, 12682, 9),
(273166, NULL, 'PF13744', NULL, NULL, 'Helix-turn-helix domain', NULL, 'HTH_37', NULL, NULL, 32793, 9),
(273167, NULL, 'PF07461', NULL, NULL, 'Nicotine adenine dinucleotide glycohydrolase (NADase)', NULL, 'NADase_NGA', NULL, NULL, 12133, 9),
(273168, NULL, 'PF11397', NULL, NULL, 'Glycosyltransferase (GlcNAc)', NULL, 'GlcNAc', NULL, NULL, 15074, 9),
(273169, NULL, 'PF03315', NULL, NULL, 'Serine dehydratase beta chain', NULL, 'SDH_beta', NULL, NULL, 7364, 9),
(273170, NULL, 'PF12554', NULL, NULL, 'Mitotic-spindle organizing gamma-tubulin ring associated', NULL, 'MOZART1', NULL, NULL, 21450, 9),
(273171, NULL, 'PF00263', NULL, NULL, 'Bacterial type II and III secretion system protein', NULL, 'Secretin', NULL, NULL, 4914, 9),
(273172, NULL, 'PF00888', NULL, NULL, 'Cullin family', NULL, 'Cullin', NULL, NULL, 2382, 9),
(273173, NULL, 'PF13510', NULL, NULL, '2Fe-2S iron-sulfur cluster binding domain', NULL, 'Fer2_4', NULL, NULL, NULL, 9);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(273174, NULL, 'PF11745', NULL, NULL, 'Protein of unknown function (DUF3304)', NULL, 'DUF3304', NULL, NULL, 19275, 9),
(273175, NULL, 'PF12557', NULL, NULL, 'Cob(I)alamin adenosyltransferase N terminal', NULL, 'Co_AT_N', NULL, NULL, 24416, 9),
(273176, NULL, 'PF02669', NULL, NULL, 'K+-transporting ATPase, c chain', NULL, 'KdpC', NULL, NULL, 3260, 9),
(273177, NULL, 'PF12594', NULL, NULL, 'Protein of unknown function (DUF3764)', NULL, 'DUF3764', NULL, NULL, 21085, 9),
(273178, NULL, 'PF16530', NULL, NULL, 'Infectious hypodermal and haematopoietic necrosis virus, capsid', NULL, 'IHHNV_capsid', NULL, NULL, 25260, 9),
(273179, NULL, 'PF07887', NULL, NULL, 'Calmodulin binding protein-like N-terminal domain', NULL, 'Calmodulin_bind', NULL, NULL, 34500, 9),
(273180, NULL, 'PF14238', NULL, NULL, 'Domain of unknown function (DUF4340)', NULL, 'DUF4340', NULL, NULL, 24925, 9),
(273181, NULL, 'PF05806', NULL, NULL, 'Noggin', NULL, 'Noggin', NULL, NULL, NULL, 9),
(273182, NULL, 'PF17421', NULL, NULL, 'Family of unknown function (DUF5409)', NULL, 'DUF5409', NULL, NULL, 19825, 9),
(273183, NULL, 'PF08574', NULL, NULL, 'Transcription factor Iwr1', NULL, 'Iwr1', NULL, NULL, 17604, 9),
(273184, NULL, 'PF04963', NULL, NULL, 'Sigma-54 factor, core binding domain', NULL, 'Sigma54_CBD', NULL, NULL, 6901, 9),
(273185, NULL, 'PF01733', NULL, NULL, 'Nucleoside transporter', NULL, 'Nucleoside_tran', NULL, NULL, 5749, 9),
(273186, NULL, 'PF16783', NULL, NULL, 'FANCM to MHF binding domain', NULL, 'FANCM-MHF_bd', NULL, NULL, 26746, 9),
(273187, NULL, 'PF19460', NULL, NULL, 'Family of unknown function (DUF5997)', NULL, 'DUF5997', NULL, NULL, 36846, 9),
(273188, NULL, 'PF04415', NULL, NULL, 'Protein of unknown function (DUF515)', NULL, 'DUF515', NULL, NULL, 10928, 9),
(273189, NULL, 'PF14969', NULL, NULL, 'Domain of unknown function (DUF4508)', NULL, 'DUF4508', NULL, NULL, 21820, 9),
(273190, NULL, 'PF12634', NULL, NULL, 'Inheritance of peroxisomes protein 1', NULL, 'Inp1', NULL, NULL, 19454, 9),
(273191, NULL, 'PF13722', NULL, NULL, '5TM C-terminal transporter carbon starvation CstA', NULL, 'CstA_5TM', NULL, NULL, 23264, 9),
(273192, NULL, 'PF09308', NULL, NULL, 'LuxQ, periplasmic', NULL, 'LuxQ-periplasm', NULL, NULL, 14458, 9),
(273193, NULL, 'PF11847', NULL, NULL, 'Alpha-(1->3)-arabinofuranosyltransferase', NULL, 'DUF3367', NULL, NULL, 19192, 9),
(273194, NULL, 'PF09188', NULL, NULL, 'Domain of unknown function (DUF1951)', NULL, 'DUF1951', NULL, NULL, 12500, 9),
(273195, NULL, 'PF01508', NULL, NULL, 'Paramecium surface antigen domain', NULL, 'Paramecium_SA', NULL, NULL, 6204, 9),
(273196, NULL, 'PF00020', NULL, NULL, 'TNFR/NGFR cysteine-rich region', NULL, 'TNFR_c6', NULL, NULL, 2084, 9),
(273197, NULL, 'PF02060', NULL, NULL, 'Slow voltage-gated potassium channel', NULL, 'ISK_Channel', NULL, NULL, 458, 9),
(273198, NULL, 'PF11163', NULL, NULL, 'Protein of unknown function (DUF2947)', NULL, 'DUF2947', NULL, NULL, 17992, 9),
(273199, NULL, 'PF11349', NULL, NULL, 'Protein of unknown function (DUF3151)', NULL, 'DUF3151', NULL, NULL, 10341, 9),
(273200, NULL, 'PF10861', NULL, NULL, 'Protein of Unknown function (DUF2784)', NULL, 'DUF2784', NULL, NULL, 17603, 9),
(273201, NULL, 'PF16261', NULL, NULL, 'Domain of unknown function (DUF4915)', NULL, 'DUF4915', NULL, NULL, 20531, 9),
(273202, NULL, 'PF09393', NULL, NULL, 'Phage tail tube protein', NULL, 'DUF2001', NULL, NULL, 15504, 9),
(273203, NULL, 'PF13472', NULL, NULL, 'GDSL-like Lipase/Acylhydrolase family', NULL, 'Lipase_GDSL_2', NULL, NULL, 17735, 9),
(273204, NULL, 'PF10716', NULL, NULL, 'NADH dehydrogenase transmembrane subunit', NULL, 'NdhL', NULL, NULL, 20721, 9),
(273205, NULL, 'PF11089', NULL, NULL, 'Exopolysaccharide production repressor', NULL, 'SyrA', NULL, NULL, 20090, 9),
(273206, NULL, 'PF18194', NULL, NULL, 'Exoribonuclease 1 Domain-3', NULL, 'Xrn1_D3', NULL, NULL, 27611, 9),
(273207, NULL, 'PF18507', NULL, NULL, 'WW domain', NULL, 'WW_1', NULL, NULL, 1285, 9),
(273208, NULL, 'PF19641', NULL, NULL, 'Family of unknown function (DUF6144)', NULL, 'DUF6144', NULL, NULL, 37093, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(273209, NULL, 'PF03665', NULL, NULL, 'Uncharacterised protein family (UPF0172)', NULL, 'UPF0172', NULL, NULL, 6245, 9),
(273210, NULL, 'PF13688', NULL, NULL, 'Metallo-peptidase family M12', NULL, 'Reprolysin_5', NULL, NULL, NULL, 9),
(273211, NULL, 'PF14031', NULL, NULL, 'Putative serine dehydratase domain', NULL, 'D-ser_dehydrat', NULL, NULL, 25822, 9),
(273212, NULL, 'PF03991', NULL, NULL, 'Copper binding octapeptide repeat', NULL, 'Prion_octapep', NULL, NULL, 14972, 9),
(273213, NULL, 'PF04669', NULL, NULL, 'Polysaccharide biosynthesis', NULL, 'Polysacc_synt_4', NULL, NULL, 15247, 9),
(273214, NULL, 'PF12651', NULL, NULL, 'Ribbon-helix-helix domain', NULL, 'RHH_3', NULL, NULL, 29148, 9),
(273215, NULL, 'PF20543', NULL, NULL, 'N2-fixation sustaining protein CowN', NULL, 'CowN', NULL, NULL, 21816, 9),
(273216, NULL, 'PF18874', NULL, NULL, 'QPE domain', NULL, 'QPE', NULL, NULL, 35122, 9),
(273217, NULL, 'PF19624', NULL, NULL, 'Family of unknown function (DUF6129)', NULL, 'DUF6129', NULL, NULL, 37294, 9),
(273218, NULL, 'PF03123', NULL, NULL, 'CAT RNA binding domain', NULL, 'CAT_RBD', NULL, NULL, 4949, 9),
(273219, NULL, 'PF05175', NULL, NULL, 'Methyltransferase small domain', NULL, 'MTS', NULL, NULL, 2310, 9),
(273220, NULL, 'PF00462', NULL, NULL, 'Glutaredoxin', NULL, 'Glutaredoxin', NULL, NULL, 1483, 9),
(273221, NULL, 'PF14663', NULL, NULL, 'Rapamycin-insensitive companion of mTOR RasGEF_N domain', NULL, 'RasGEF_N_2', NULL, NULL, 23862, 9),
(273222, NULL, 'PF04084', NULL, NULL, 'Origin recognition complex subunit 2', NULL, 'ORC2', NULL, NULL, 6434, 9),
(273223, NULL, 'PF05569', NULL, NULL, 'BlaR1 peptidase M56', NULL, 'Peptidase_M56', NULL, NULL, 12444, 9),
(273224, NULL, 'PF06697', NULL, NULL, 'Protein of unknown function (DUF1191)', NULL, 'DUF1191', NULL, NULL, 8155, 9),
(273225, NULL, 'PF14386', NULL, NULL, 'Domain of unknown function (DUF4417)', NULL, 'DUF4417', NULL, NULL, 26450, 9),
(273226, NULL, 'PF04264', NULL, NULL, 'YceI-like domain', NULL, 'YceI', NULL, NULL, 5569, 9),
(273227, NULL, 'PF12996', NULL, NULL, 'DUF based on E. rectale Gene description (DUF3880)', NULL, 'DUF3880', NULL, NULL, 24938, 9),
(273228, NULL, 'PF08935', NULL, NULL, 'Viral protein VP4 subunit', NULL, 'VP4_2', NULL, NULL, 7807, 9),
(273229, NULL, 'PF07849', NULL, NULL, 'Protein of unknown function (DUF1641)', NULL, 'DUF1641', NULL, NULL, 14307, 9),
(273230, NULL, 'PF19729', NULL, NULL, 'F-box/LRR-repeat protein 18, LRR', NULL, 'FBXL18_LRR', NULL, NULL, 36257, 9),
(273231, NULL, 'PF03170', NULL, NULL, 'Bacterial cellulose synthase subunit', NULL, 'BcsB', NULL, NULL, 14839, 9),
(273232, NULL, 'PF09575', NULL, NULL, 'Small spore protein J (Spore_SspJ)', NULL, 'Spore_SspJ', NULL, NULL, 10855, 9),
(273233, NULL, 'PF18657', NULL, NULL, 'YDG domain', NULL, 'YDG', NULL, NULL, 29454, 9),
(273234, NULL, 'PF15856', NULL, NULL, 'Domain of unknown function (DUF4727)', NULL, 'DUF4727', NULL, NULL, 25919, 9),
(273235, NULL, 'PF02980', NULL, NULL, 'FokI, recognition domain, subdomain 2', NULL, 'FokI_dom_2', NULL, NULL, 3683, 9),
(273236, NULL, 'PF19946', NULL, NULL, 'Family of unknown function (DUF6408)', NULL, 'DUF6408', NULL, NULL, 37004, 9),
(273237, NULL, 'PF08326', NULL, NULL, 'Acetyl-CoA carboxylase, central region', NULL, 'ACC_central', NULL, NULL, 12896, 9),
(273238, NULL, 'PF02288', NULL, NULL, 'Dehydratase medium subunit', NULL, 'Dehydratase_MU', NULL, NULL, 2186, 9),
(273239, NULL, 'PF11376', NULL, NULL, 'Protein of unknown function (DUF3179)', NULL, 'DUF3179', NULL, NULL, 18967, 9),
(273240, NULL, 'PF14978', NULL, NULL, 'Mitochondrial ribosome protein 63', NULL, 'MRP-63', NULL, NULL, 18000, 9),
(273241, NULL, 'PF16168', NULL, NULL, 'Adhesin of bacterial autotransporter system, probable stalk', NULL, 'AIDA', NULL, NULL, 26294, 9),
(273242, NULL, 'PF19203', NULL, NULL, 'Family of unknown function (DUF5875)', NULL, 'DUF5875', NULL, NULL, 34830, 9),
(273243, NULL, 'PF08473', NULL, NULL, 'Neuronal voltage-dependent calcium channel alpha 2acd', NULL, 'VGCC_alpha2', NULL, NULL, 13552, 9),
(273244, NULL, 'PF11489', NULL, NULL, 'Altered inheritance of mitochondria protein 21', NULL, 'Aim21', NULL, NULL, 18669, 9);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(273245, NULL, 'PF09217', NULL, NULL, 'Restriction endonuclease EcoRII, N-terminal', NULL, 'EcoRII-N', NULL, NULL, 15854, 9),
(273246, NULL, 'PF15081', NULL, NULL, 'Domain of unknown function (DUF4548)', NULL, 'DUF4548', NULL, NULL, 26221, 9),
(273247, NULL, 'PF06227', NULL, NULL, 'Poxvirus Bcl-2-like proteins', NULL, 'Poxv_Bcl-2-like', NULL, NULL, 17004, 9),
(273248, NULL, 'PF02070', NULL, NULL, 'Neuromedin U', NULL, 'NMU', NULL, NULL, 7345, 9),
(273249, NULL, 'PF00652', NULL, NULL, 'Ricin-type beta-trefoil lectin domain', NULL, 'Ricin_B_lectin', NULL, NULL, 3959, 9),
(273250, NULL, 'PF11529', NULL, NULL, 'Melampsora lini avirulence protein AvrL567-A', NULL, 'AvrL567-A', NULL, NULL, 18520, 9),
(273251, NULL, 'PF17346', NULL, NULL, 'Family of unknown function (DUF5376)', NULL, 'DUF5376', NULL, NULL, 31454, 9),
(273252, NULL, 'PF04505', NULL, NULL, 'Interferon-induced transmembrane protein', NULL, 'CD225', NULL, NULL, 2830, 9),
(273253, NULL, 'PF15635', NULL, NULL, 'GHH signature containing HNH/Endo VII superfamily nuclease toxin  2', NULL, 'Tox-GHH2', NULL, NULL, 25160, 9),
(273254, NULL, 'PF02395', NULL, NULL, 'Immunoglobulin A1 protease', NULL, 'Peptidase_S6', NULL, NULL, 3761, 9),
(273255, NULL, 'PF06294', NULL, NULL, 'CH-like domain in sperm protein', NULL, 'CH_2', NULL, NULL, 10418, 9),
(273256, NULL, 'PF08550', NULL, NULL, 'Fungal protein of unknown function (DUF1752)', NULL, 'DUF1752', NULL, NULL, 9516, 9),
(273257, NULL, 'PF19419', NULL, NULL, 'Family of unknown function (DUF5983)', NULL, 'DUF5983', NULL, NULL, 36689, 9),
(273258, NULL, 'PF13333', NULL, NULL, 'Integrase core domain', NULL, 'rve_2', NULL, NULL, 5041, 9),
(273259, NULL, 'PF16395', NULL, NULL, 'Domain of unknown function (DUF5004)', NULL, 'DUF5004', NULL, NULL, 26220, 9),
(273260, NULL, 'PF05692', NULL, NULL, 'Mycoplasma haemagglutinin', NULL, 'Myco_haema', NULL, NULL, 13031, 9),
(273261, NULL, 'PF02773', NULL, NULL, 'S-adenosylmethionine synthetase, C-terminal domain', NULL, 'S-AdoMet_synt_C', NULL, NULL, 16617, 9),
(273262, NULL, 'PF17005', NULL, NULL, 'WD40-like domain', NULL, 'WD40_like', NULL, NULL, 24114, 9),
(273263, NULL, 'PF08910', NULL, NULL, 'Aida N-terminus', NULL, 'Aida_N', NULL, NULL, 16350, 9),
(273264, NULL, 'PF10524', NULL, NULL, 'Nuclear factor I protein pre-N-terminus', NULL, 'NfI_DNAbd_pre-N', NULL, NULL, 19095, 9),
(273265, NULL, 'PF18724', NULL, NULL, 'Alpha-glutamyl/putrescinyl thymine pyrophosphorylase clade 2', NULL, 'aGPT-Pplase2', NULL, NULL, 28229, 9),
(273266, NULL, 'PF11059', NULL, NULL, 'Protein of unknown function (DUF2860)', NULL, 'DUF2860', NULL, NULL, 16954, 9),
(273267, NULL, 'PF03575', NULL, NULL, 'Peptidase family S51', NULL, 'Peptidase_S51', NULL, NULL, 5884, 9),
(273268, NULL, 'PF11141', NULL, NULL, 'Protein of unknown function (DUF2914)', NULL, 'DUF2914', NULL, NULL, 14659, 9),
(273269, NULL, 'PF00611', NULL, NULL, 'Fes/CIP4, and EFC/F-BAR homology domain', NULL, 'FCH', NULL, NULL, 1418, 9),
(273270, NULL, 'PF02628', NULL, NULL, 'Cytochrome oxidase assembly protein', NULL, 'COX15-CtaA', NULL, NULL, 3237, 9),
(273271, NULL, 'PF06100', NULL, NULL, 'MCRA family', NULL, 'MCRA', NULL, NULL, 8743, 9),
(273272, NULL, 'PF02745', NULL, NULL, 'Methyl-coenzyme M reductase alpha subunit, N-terminal domain', NULL, 'MCR_alpha_N', NULL, NULL, 2563, 9),
(273273, NULL, 'PF02623', NULL, NULL, 'FliW protein', NULL, 'FliW', NULL, NULL, 6268, 9),
(273274, NULL, 'PF15275', NULL, NULL, 'PEHE domain', NULL, 'PEHE', NULL, NULL, 23566, 9),
(273275, NULL, 'PF10327', NULL, NULL, 'Serpentine type 7TM GPCR chemoreceptor Sri', NULL, '7TM_GPCR_Sri', NULL, NULL, 17196, 9),
(273276, NULL, 'PF19406', NULL, NULL, 'PKD-like domain', NULL, 'PKD_5', NULL, NULL, 33653, 9),
(273277, NULL, 'PF20322', NULL, NULL, 'Family of unknown function (DUF6617)', NULL, 'DUF6617', NULL, NULL, 37078, 9),
(273278, NULL, 'PF11714', NULL, NULL, 'Thrombin inhibitor Madanin', NULL, 'Inhibitor_I53', NULL, NULL, 19432, 9),
(273279, NULL, 'PF12454', NULL, NULL, 'GPI-anchored cell wall organization protein', NULL, 'Ecm33', NULL, NULL, NULL, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(273280, NULL, 'PF01694', NULL, NULL, 'Rhomboid family', NULL, 'Rhomboid', NULL, NULL, 20176, 9),
(273281, NULL, 'PF07974', NULL, NULL, 'EGF-like domain', NULL, 'EGF_2', NULL, NULL, 18617, 9),
(273282, NULL, 'PF19826', NULL, NULL, 'Family of unknown function (DUF6307)', NULL, 'DUF6307', NULL, NULL, 37574, 9),
(273283, NULL, 'PF18007', NULL, NULL, 'Domain of unknown function (DUF5593)', NULL, 'DUF5593', NULL, NULL, 29793, 9),
(273284, NULL, 'PF02789', NULL, NULL, 'Cytosol aminopeptidase family, N-terminal domain', NULL, 'Peptidase_M17_N', NULL, NULL, 9639, 9),
(273285, NULL, 'PF04198', NULL, NULL, 'Putative sugar-binding domain', NULL, 'Sugar-bind', NULL, NULL, 5447, 9),
(273286, NULL, 'PF16634', NULL, NULL, 'Unstructured region on APC between APC_crr and SAMP', NULL, 'APC_u13', NULL, NULL, NULL, 9),
(273287, NULL, 'PF02877', NULL, NULL, 'Poly(ADP-ribose) polymerase, regulatory domain', NULL, 'PARP_reg', NULL, NULL, 1609, 9),
(273288, NULL, 'PF04315', NULL, NULL, 'Elongation factor P hydroxylase', NULL, 'EpmC', NULL, NULL, 3921, 9),
(273289, NULL, 'PF01525', NULL, NULL, 'Rotavirus NS26', NULL, 'Rota_NS26', NULL, NULL, 976, 9),
(273290, NULL, 'PF09830', NULL, NULL, 'ATP adenylyltransferase C-terminal domain', NULL, 'ATP_transf', NULL, NULL, 19027, 9),
(273291, NULL, 'PF12657', NULL, NULL, 'Transcription factor IIIC subunit delta N-term', NULL, 'TFIIIC_delta', NULL, NULL, 19012, 9),
(273292, NULL, 'PF02873', NULL, NULL, 'UDP-N-acetylenolpyruvoylglucosamine reductase, C-terminal domain', NULL, 'MurB_C', NULL, NULL, 10388, 9),
(273293, NULL, 'PF11999', NULL, NULL, 'Ice-binding-like', NULL, 'Ice_binding', NULL, NULL, 19861, 9),
(273294, NULL, 'PF14005', NULL, NULL, 'YpjP-like protein', NULL, 'YpjP', NULL, NULL, 26077, 9),
(273295, NULL, 'PF19713', NULL, NULL, 'Family of unknown function (DUF6208)', NULL, 'DUF6208', NULL, NULL, 37429, 9),
(273296, NULL, 'PF02757', NULL, NULL, 'YLP motif', NULL, 'YLP', NULL, NULL, 972, 9),
(273297, NULL, 'PF09606', NULL, NULL, 'ARC105 or Med15 subunit of Mediator complex non-fungal', NULL, 'Med15', NULL, NULL, 16656, 9),
(273298, NULL, 'PF20471', NULL, NULL, 'Putative glycosyltransferase (DUF6716)', NULL, 'DUF6716', NULL, NULL, 37754, 9),
(273299, NULL, 'PF07720', NULL, NULL, 'Tetratricopeptide repeat', NULL, 'TPR_3', NULL, NULL, 8503, 9),
(273300, NULL, 'PF04438', NULL, NULL, 'HIT zinc finger', NULL, 'zf-HIT', NULL, NULL, 10943, 9),
(273301, NULL, 'PF18482', NULL, NULL, 'Fungal Pih1 CS domain', NULL, 'Pih1_fungal_CS', NULL, NULL, 29444, 9),
(273302, NULL, 'PF10758', NULL, NULL, 'Protein of unknown function (DUF2586)', NULL, 'DUF2586', NULL, NULL, 20212, 9),
(273303, NULL, 'PF16578', NULL, NULL, 'Interleukin 17 receptor D', NULL, 'IL17R_fnIII_D2', NULL, NULL, NULL, 9),
(273304, NULL, 'PF03731', NULL, NULL, 'Ku70/Ku80 N-terminal alpha/beta domain', NULL, 'Ku_N', NULL, NULL, 4292, 9),
(273305, NULL, 'PF19692', NULL, NULL, 'Family of unknown function (DUF6193)', NULL, 'DUF6193', NULL, NULL, 36163, 9),
(273306, NULL, 'PF07855', NULL, NULL, 'Autophagy-related protein 101', NULL, 'ATG101', NULL, NULL, 14469, 9),
(273307, NULL, 'PF16980', NULL, NULL, 'Putative citrate transport', NULL, 'CitMHS_2', NULL, NULL, 23735, 9),
(273308, NULL, 'PF00725', NULL, NULL, '3-hydroxyacyl-CoA dehydrogenase, C-terminal domain', NULL, '3HCDH', NULL, NULL, 10051, 9),
(273309, NULL, 'PF07123', NULL, NULL, 'Photosystem II reaction centre W protein (PsbW)', NULL, 'PsbW', NULL, NULL, 13210, 9),
(273310, NULL, 'PF01976', NULL, NULL, 'Protein of unknown function DUF116', NULL, 'DUF116', NULL, NULL, 5464, 9),
(273311, NULL, 'PF14771', NULL, NULL, 'Domain of unknown function (DUF4476)', NULL, 'DUF4476', NULL, NULL, 23744, 9),
(273312, NULL, 'PF07436', NULL, NULL, 'Curtovirus V3 protein', NULL, 'Curto_V3', NULL, NULL, 8676, 9),
(273313, NULL, 'PF07216', NULL, NULL, 'LcrG protein', NULL, 'LcrG', NULL, NULL, 14467, 9),
(273314, NULL, 'PF03789', NULL, NULL, 'ELK domain', NULL, 'ELK', NULL, NULL, 1922, 9),
(273315, NULL, 'PF08869', NULL, NULL, 'XisI protein', NULL, 'XisI', NULL, NULL, 14294, 9),
(273316, NULL, 'PF02663', NULL, NULL, 'FmdE, Molybdenum formylmethanofuran dehydrogenase operon', NULL, 'FmdE', NULL, NULL, 3201, 9);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(273317, NULL, 'PF06638', NULL, NULL, 'Strabismus protein', NULL, 'Strabismus', NULL, NULL, 10463, 9),
(273318, NULL, 'PF16352', NULL, NULL, 'Domain of unknown function (DUF4980)', NULL, 'DUF4980', NULL, NULL, 25133, 9),
(273319, NULL, 'PF02792', NULL, NULL, 'Mago nashi protein', NULL, 'Mago_nashi', NULL, NULL, 804, 9),
(273320, NULL, 'PF07610', NULL, NULL, 'Protein of unknown function (DUF1573)', NULL, 'DUF1573', NULL, NULL, 13750, 9),
(273321, NULL, 'PF03568', NULL, NULL, 'Peptidase family C50', NULL, 'Peptidase_C50', NULL, NULL, NULL, 9),
(273322, NULL, 'PF04628', NULL, NULL, 'Sedlin, N-terminal conserved region', NULL, 'Sedlin_N', NULL, NULL, 2166, 9),
(273323, NULL, 'PF15549', NULL, NULL, 'PGC7/Stella/Dppa3 domain', NULL, 'PGC7_Stella', NULL, NULL, 25476, 9),
(273324, NULL, 'PF00324', NULL, NULL, 'Amino acid permease', NULL, 'AA_permease', NULL, NULL, 4045, 9),
(273325, NULL, 'PF09517', NULL, NULL, 'Eco29kI restriction endonuclease', NULL, 'RE_Eco29kI', NULL, NULL, 15093, 9),
(273326, NULL, 'PF14376', NULL, NULL, 'Haem-binding domain', NULL, 'Haem_bd', NULL, NULL, 25979, 9),
(273327, NULL, 'PF19053', NULL, NULL, 'EccD-like transmembrane domain', NULL, 'EccD', NULL, NULL, 35523, 9),
(273328, NULL, 'PF11822', NULL, NULL, 'SANT and BTB domain regulator of CSR, BTB domain', NULL, 'SANBR_BTB', NULL, NULL, 19267, 9),
(273329, NULL, 'PF08008', NULL, NULL, 'Viral cysteine rich', NULL, 'Viral_cys_rich', NULL, NULL, 10205, 9),
(273330, NULL, 'PF08408', NULL, NULL, 'DNA polymerase family B viral insert', NULL, 'DNA_pol_B_3', NULL, NULL, 11306, 9),
(273331, NULL, 'PF04113', NULL, NULL, 'Gpi16 subunit, GPI transamidase component', NULL, 'Gpi16', NULL, NULL, 6501, 9),
(273332, NULL, 'PF03374', NULL, NULL, 'Phage antirepressor protein KilAC domain', NULL, 'ANT', NULL, NULL, 2386, 9),
(273333, NULL, 'PF16640', NULL, NULL, 'Bacterial Ig-like domain (group 3)', NULL, 'Big_3_5', NULL, NULL, 22940, 9),
(273334, NULL, 'PF09033', NULL, NULL, 'DNA Fragmentation factor 45kDa, C terminal domain', NULL, 'DFF-C', NULL, NULL, 9511, 9),
(273335, NULL, 'PF10640', NULL, NULL, 'mRNA capping enzyme N-terminal, ATPase and guanylyltransferase', NULL, 'Pox_ATPase-GT', NULL, NULL, 20448, 9),
(273336, NULL, 'PF18731', NULL, NULL, 'Swt1-like HEPN', NULL, 'HEPN_Swt1', NULL, NULL, 30234, 9),
(273337, NULL, 'PF03465', NULL, NULL, 'eRF1 domain 3', NULL, 'eRF1_3', NULL, NULL, 7009, 9),
(273338, NULL, 'PF02087', NULL, NULL, 'Nitrophorin', NULL, 'Nitrophorin', NULL, NULL, 6406, 9),
(273339, NULL, 'PF04704', NULL, NULL, 'Zfx / Zfy transcription activation region', NULL, 'Zfx_Zfy_act', NULL, NULL, 3490, 9),
(273340, NULL, 'PF09877', NULL, NULL, 'Energy-converting hydrogenase subunit EhaL', NULL, 'EhaL', NULL, NULL, 19470, 9),
(273341, NULL, 'PF02476', NULL, NULL, 'US2 family', NULL, 'US2', NULL, NULL, 6351, 9),
(273342, NULL, 'PF11510', NULL, NULL, 'Fanconi Anaemia group E protein FANCE', NULL, 'FA_FANCE', NULL, NULL, 15607, 9),
(273343, NULL, 'PF01053', NULL, NULL, 'Cys/Met metabolism PLP-dependent enzyme', NULL, 'Cys_Met_Meta_PP', NULL, NULL, 877, 9),
(273344, NULL, 'PF05732', NULL, NULL, 'Firmicute plasmid replication protein (RepL)', NULL, 'RepL', NULL, NULL, 13628, 9),
(273345, NULL, 'PF12291', NULL, NULL, 'Protein of unknown function (DUF3623)', NULL, 'DUF3623', NULL, NULL, 20729, 9),
(273346, NULL, 'PF11228', NULL, NULL, 'Protein of unknown function (DUF3027)', NULL, 'DUF3027', NULL, NULL, 18152, 9),
(273347, NULL, 'PF18925', NULL, NULL, 'Family of unknown function (DUF5675)', NULL, 'DUF5675', NULL, NULL, 35507, 9),
(273348, NULL, 'PF09180', NULL, NULL, 'Prolyl-tRNA synthetase, C-terminal', NULL, 'ProRS-C_1', NULL, NULL, 11775, 9),
(273349, NULL, 'PF03572', NULL, NULL, 'Peptidase family S41', NULL, 'Peptidase_S41', NULL, NULL, 4233, 9),
(273350, NULL, 'PF10492', NULL, NULL, 'Nrf1 activator activation site binding domain', NULL, 'Nrf1_activ_bdg', NULL, NULL, NULL, 9),
(273351, NULL, 'PF00716', NULL, NULL, 'Assemblin (Peptidase family S21)', NULL, 'Peptidase_S21', NULL, NULL, 4422, 9),
(273352, NULL, 'PF00945', NULL, NULL, 'Rhabdovirus nucleocapsid protein', NULL, 'Rhabdo_ncap', NULL, NULL, 6936, 9);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(273353, NULL, 'PF18625', NULL, NULL, 'ESX-1 secreted protein B PE domain', NULL, 'EspB_PE', NULL, NULL, 29954, 9),
(273354, NULL, 'PF13042', NULL, NULL, 'Protein of unknown function (DUF3902)', NULL, 'DUF3902', NULL, NULL, 22714, 9),
(273355, NULL, 'PF02973', NULL, NULL, 'Sialidase, N-terminal domain', NULL, 'Sialidase', NULL, NULL, 1824, 9),
(273356, NULL, 'PF02422', NULL, NULL, 'Keratin', NULL, 'Keratin', NULL, NULL, 5419, 9),
(273357, NULL, 'PF03606', NULL, NULL, 'C4-dicarboxylate anaerobic carrier', NULL, 'DcuC', NULL, NULL, 20310, 9),
(273358, NULL, 'PF06122', NULL, NULL, 'Conjugative relaxosome accessory transposon protein', NULL, 'TraH', NULL, NULL, 7521, 9),
(273359, NULL, 'PF14521', NULL, NULL, 'Lysine-specific metallo-endopeptidase', NULL, 'Aspzincin_M35', NULL, NULL, 23065, 9),
(273360, NULL, 'PF06008', NULL, NULL, 'Laminin Domain I', NULL, 'Laminin_I', NULL, NULL, 13897, 9),
(273361, NULL, 'PF17602', NULL, NULL, 'Family of unknown function (DUF5498)', NULL, 'DUF5498', NULL, NULL, 32262, 9),
(273362, NULL, 'PF00224', NULL, NULL, 'Pyruvate kinase, barrel domain', NULL, 'PK', NULL, NULL, 3204, 9),
(273363, NULL, 'PF10626', NULL, NULL, 'Conjugative transposon protein TraO', NULL, 'TraO', NULL, NULL, 20827, 9),
(273364, NULL, 'PF02519', NULL, NULL, 'Auxin responsive protein', NULL, 'Auxin_inducible', NULL, NULL, 6134, 9),
(273365, NULL, 'PF11247', NULL, NULL, 'Bacteriophage T7, gene 5.5', NULL, 'Phage_T7_55', NULL, NULL, 16616, 9),
(273366, NULL, 'PF16593', NULL, NULL, 'Bridge helix of CRISPR-associated endonuclease Cas9', NULL, 'Cas9-BH', NULL, NULL, 26651, 9),
(273367, NULL, 'PF18281', NULL, NULL, 'BILBO1 N-terminal domain', NULL, 'BILBO1_N', NULL, NULL, 29428, 9),
(273368, NULL, 'PF15235', NULL, NULL, 'G protein-regulated inducer of neurite outgrowth C-terminus', NULL, 'GRIN_C', NULL, NULL, 21867, 9),
(273369, NULL, 'PF08553', NULL, NULL, 'VID27 C-terminal WD40-like domain', NULL, 'VID27', NULL, NULL, 9656, 9),
(273370, NULL, 'PF12717', NULL, NULL, 'non-SMC mitotic condensation complex subunit 1', NULL, 'Cnd1', NULL, NULL, 26878, 9),
(273371, NULL, 'PF15310', NULL, NULL, 'Vitamin A-deficiency (VAD) rat model signalling', NULL, 'VAD1-2', NULL, NULL, 24901, 9),
(273372, NULL, 'PF19085', NULL, NULL, 'Choline-binding repeat', NULL, 'Choline_bind_2', NULL, NULL, 20480, 9),
(273373, NULL, 'PF18127', NULL, NULL, 'Nicotinamide phosphoribosyltransferase, N-terminal domain', NULL, 'NAMPT_N', NULL, NULL, 29995, 9),
(273374, NULL, 'PF11662', NULL, NULL, 'Protein of unknown function (DUF3263)', NULL, 'DUF3263', NULL, NULL, 19128, 9),
(273375, NULL, 'PF02427', NULL, NULL, 'Photosystem I reaction centre subunit IV / PsaE', NULL, 'PSI_PsaE', NULL, NULL, 4320, 9),
(273376, NULL, 'PF15018', NULL, NULL, 'TRP-interacting helix', NULL, 'InaF-motif', NULL, NULL, 26725, 9),
(273377, NULL, 'PF17737', NULL, NULL, 'Ig domain in C19orf38 (HIDE1)', NULL, 'Ig_C19orf38', NULL, NULL, 28618, 9),
(273378, NULL, 'PF06691', NULL, NULL, 'Protein of unknown function (DUF1189)', NULL, 'DUF1189', NULL, NULL, 583, 9),
(273379, NULL, 'PF13963', NULL, NULL, 'Transposase-associated domain', NULL, 'Transpos_assoc', NULL, NULL, 26636, 9),
(273380, NULL, 'PF10913', NULL, NULL, 'Protein of unknown function (DUF2706)', NULL, 'DUF2706', NULL, NULL, 22569, 9),
(273381, NULL, 'PF16602', NULL, NULL, 'Linker region of USP19 deubiquitinase', NULL, 'USP19_linker', NULL, NULL, NULL, 9),
(273382, NULL, 'PF17475', NULL, NULL, 'Clostridial binary toxin B/anthrax toxin PA domain 2', NULL, 'Binary_toxB_2', NULL, NULL, 25684, 9),
(273383, NULL, 'PF16590', NULL, NULL, 'Exocrine gland-secreting peptide', NULL, 'ESP', NULL, NULL, 24080, 9),
(273384, NULL, 'PF16835', NULL, NULL, 'Pre-mRNA-splicing factor SF3a complex subunit 2 (Prp11)', NULL, 'SF3A2', NULL, NULL, 26177, 9),
(273385, NULL, 'PF19117', NULL, NULL, 'Mitochondrial import 2', NULL, 'Mim2', NULL, NULL, 31244, 9),
(273386, NULL, 'PF20365', NULL, NULL, 'Family of unknown function (DUF6660)', NULL, 'DUF6660', NULL, NULL, 33968, 9),
(273387, NULL, 'PF06474', NULL, NULL, 'MltD lipid attachment motif', NULL, 'MLTD_N', NULL, NULL, 10139, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(273388, NULL, 'PF13956', NULL, NULL, 'Toxin Ibs, type I toxin-antitoxin system', NULL, 'Ibs_toxin', NULL, NULL, 25084, 9),
(273389, NULL, 'PF12691', NULL, NULL, 'Bacteriophage minor capsid protein', NULL, 'Minor_capsid_3', NULL, NULL, 22324, 9),
(273390, NULL, 'PF02331', NULL, NULL, 'Apoptosis preventing protein', NULL, 'P35', NULL, NULL, 5085, 9),
(273391, NULL, 'PF12850', NULL, NULL, 'Calcineurin-like phosphoesterase superfamily domain', NULL, 'Metallophos_2', NULL, NULL, 24706, 9),
(273392, NULL, 'PF18259', NULL, NULL, 'Carbohydrate binding module 65 domain 1', NULL, 'CBM65_1', NULL, NULL, 33132, 9),
(273393, NULL, 'PF10464', NULL, NULL, 'Peptidase U40', NULL, 'Peptidase_U40', NULL, NULL, 18466, 9),
(273394, NULL, 'PF18720', NULL, NULL, 'Tenascin EGF domain', NULL, 'EGF_Tenascin', NULL, NULL, 28633, 9),
(273395, NULL, 'PF11978', NULL, NULL, 'Shoulder domain', NULL, 'MVP_shoulder', NULL, NULL, 19940, 9),
(273396, NULL, 'PF15053', NULL, NULL, 'Mjmu-R1-like protein family', NULL, 'Njmu-R1', NULL, NULL, 26663, 9),
(273397, NULL, 'PF11173', NULL, NULL, 'Protein of unknown function (DUF2960)', NULL, 'DUF2960', NULL, NULL, 18330, 9),
(273398, NULL, 'PF06729', NULL, NULL, 'Kinetochore component, CENP-R', NULL, 'CENP-R', NULL, NULL, 1718, 9),
(273399, NULL, 'PF19069', NULL, NULL, 'Family of unknown function (DUF5765)', NULL, 'DUF5765', NULL, NULL, 35201, 9),
(273400, NULL, 'PF05322', NULL, NULL, 'NINE Protein', NULL, 'NinE', NULL, NULL, 4471, 9),
(273401, NULL, 'PF03452', NULL, NULL, 'Anp1', NULL, 'Anp1', NULL, NULL, NULL, 9),
(273402, NULL, 'PF20214', NULL, NULL, 'Family of unknown function (DUF6574)', NULL, 'DUF6574', NULL, NULL, 37590, 9),
(273403, NULL, 'PF17172', NULL, NULL, 'Glutathione S-transferase N-terminal domain', NULL, 'GST_N_4', NULL, NULL, 7704, 9),
(273404, NULL, 'PF16702', NULL, NULL, 'Domain of unknown function (DUF5063)', NULL, 'DUF5063', NULL, NULL, 23044, 9),
(273405, NULL, 'PF15272', NULL, NULL, 'Spindle pole body component BBP1, C-terminal', NULL, 'BBP1_C', NULL, NULL, 23712, 9),
(273406, NULL, 'PF20525', NULL, NULL, 'Family of unknown function (DUF6740)', NULL, 'DUF6740', NULL, NULL, 33839, 9),
(273407, NULL, 'PF01170', NULL, NULL, 'Putative RNA methylase family UPF0020', NULL, 'UPF0020', NULL, NULL, 4596, 9),
(273408, NULL, 'PF05814', NULL, NULL, 'Orf76 (Ac76)', NULL, 'Ac76', NULL, NULL, 13191, 9),
(273409, NULL, 'PF18319', NULL, NULL, 'PriA DNA helicase Cys-rich region (CRR) domain', NULL, 'PriA_CRR', NULL, NULL, 27750, 9),
(273410, NULL, 'PF19786', NULL, NULL, 'Family of unknown function (DUF6270)', NULL, 'DUF6270', NULL, NULL, 37468, 9),
(273411, NULL, 'PF03638', NULL, NULL, 'Tesmin/TSO1-like CXC domain, cysteine-rich domain', NULL, 'TCR', NULL, NULL, 4948, 9),
(273412, NULL, 'PF05357', NULL, NULL, 'Phage Coat Protein A', NULL, 'Phage_Coat_A', NULL, NULL, 5431, 9),
(273413, NULL, 'PF05874', NULL, NULL, 'Pheromone biosynthesis activating neuropeptide (PBAN)', NULL, 'PBAN', NULL, NULL, 12323, 9),
(273414, NULL, 'PF11799', NULL, NULL, 'impB/mucB/samB family C-terminal domain', NULL, 'IMS_C', NULL, NULL, 7074, 9),
(273415, NULL, 'PF00053', NULL, NULL, 'Laminin EGF domain', NULL, 'Laminin_EGF', NULL, NULL, 1303, 9),
(273416, NULL, 'PF12198', NULL, NULL, 'Tuberculin-active protein', NULL, 'Tuberculin', NULL, NULL, 20369, 9),
(273417, NULL, 'PF09710', NULL, NULL, 'Treponema clustered lipoprotein (Trep_dent_lipo)', NULL, 'Trep_dent_lipo', NULL, NULL, 2280, 9),
(273418, NULL, 'PF17855', NULL, NULL, 'MCM AAA-lid domain', NULL, 'MCM_lid', NULL, NULL, 30220, 9),
(273419, NULL, 'PF03000', NULL, NULL, 'NPH3 family', NULL, 'NPH3', NULL, NULL, 24230, 9),
(273420, NULL, 'PF15266', NULL, NULL, 'Domain of unknown function (DUF4594)', NULL, 'DUF4594', NULL, NULL, 23637, 9),
(273421, NULL, 'PF16653', NULL, NULL, 'Saccharopine dehydrogenase C-terminal domain', NULL, 'Sacchrp_dh_C', NULL, NULL, 22749, 9),
(273422, NULL, 'PF07888', NULL, NULL, 'Calcium binding and coiled-coil domain (CALCOCO1) like', NULL, 'CALCOCO1', NULL, NULL, 12162, 9),
(273423, NULL, 'PF07274', NULL, NULL, 'Protein of unknown function (DUF1440)', NULL, 'DUF1440', NULL, NULL, 14393, 9);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(273424, NULL, 'PF12598', NULL, NULL, 'T-box transcription factor', NULL, 'TBX', NULL, NULL, 16245, 9),
(273425, NULL, 'PF09643', NULL, NULL, 'YopX protein', NULL, 'YopX', NULL, NULL, 17861, 9),
(273426, NULL, 'PF11231', NULL, NULL, 'Protein of unknown function (DUF3034)', NULL, 'DUF3034', NULL, NULL, 18037, 9),
(273427, NULL, 'PF08513', NULL, NULL, 'LisH', NULL, 'LisH', NULL, NULL, 1021, 9),
(273428, NULL, 'PF18275', NULL, NULL, 'His-Me finger endonuclease beta4-alpha2 domain', NULL, 'His_Me_b4a2', NULL, NULL, 30273, 9),
(273429, NULL, 'PF03507', NULL, NULL, 'CagA exotoxin phosphopeptide substrate mimic region', NULL, 'CagA', NULL, NULL, 4519, 9),
(273430, NULL, 'PF04498', NULL, NULL, 'Poxvirus nucleic acid binding protein VP8/L4R', NULL, 'Pox_VP8_L4R', NULL, NULL, 2856, 9),
(273431, NULL, 'PF18622', NULL, NULL, 'RctB helix turn helix domain', NULL, 'HTH_55', NULL, NULL, 27710, 9),
(273432, NULL, 'PF07914', NULL, NULL, 'Uncharacterized oxidoreductase dhs-27', NULL, 'DUF1679', NULL, NULL, 12035, 9),
(273433, NULL, 'PF13506', NULL, NULL, 'Glycosyl transferase family 21', NULL, 'Glyco_transf_21', NULL, NULL, 25955, 9),
(273434, NULL, 'PF14037', NULL, NULL, 'YoqO-like protein', NULL, 'YoqO', NULL, NULL, 26415, 9),
(273435, NULL, 'PF18161', NULL, NULL, 'ISP1 C-terminal', NULL, 'ISP1_C', NULL, NULL, 29649, 9),
(273436, NULL, 'PF02907', NULL, NULL, 'Hepatitis C virus NS3 protease', NULL, 'Peptidase_S29', NULL, NULL, 1971, 9),
(273437, NULL, 'PF09347', NULL, NULL, 'Domain of unknown function (DUF1989)', NULL, 'DUF1989', NULL, NULL, 14504, 9),
(273438, NULL, 'PF13715', NULL, NULL, 'CarboxypepD_reg-like domain', NULL, 'CarbopepD_reg_2', NULL, NULL, NULL, 9),
(273439, NULL, 'PF06145', NULL, NULL, 'Coronavirus nonstructural protein NS1', NULL, 'Corona_NS1', NULL, NULL, 14219, 9),
(273440, NULL, 'PF19962', NULL, NULL, 'Effector-associated domain 9', NULL, 'EAD9', NULL, NULL, 37332, 9),
(273441, NULL, 'PF11724', NULL, NULL, 'YvbH-like oligomerisation region', NULL, 'YvbH_ext', NULL, NULL, 19284, 9),
(273442, NULL, 'PF14188', NULL, NULL, 'Domain of unknown function (DUF4311)', NULL, 'DUF4311', NULL, NULL, 17581, 9),
(273443, NULL, 'PF04586', NULL, NULL, 'Caudovirus prohead serine protease', NULL, 'Peptidase_S78', NULL, NULL, 6562, 9),
(273444, NULL, 'PF15920', NULL, NULL, 'N-terminal of Junction-mediating and WASP homolog-associated', NULL, 'WHAMM-JMY_N', NULL, NULL, 25756, 9),
(273445, NULL, 'PF03693', NULL, NULL, 'Bacterial antitoxin of ParD toxin-antitoxin type II system and RHH', NULL, 'ParD_antitoxin', NULL, NULL, 6361, 9),
(273446, NULL, 'PF06783', NULL, NULL, 'Uncharacterised protein family (UPF0239)', NULL, 'UPF0239', NULL, NULL, 1959, 9),
(273447, NULL, 'PF20551', NULL, NULL, 'Family of unknown function (DUF6765)', NULL, 'DUF6765', NULL, NULL, 37167, 9),
(273448, NULL, 'PF05576', NULL, NULL, 'PS-10 peptidase S37', NULL, 'Peptidase_S37', NULL, NULL, 12032, 9),
(273449, NULL, 'PF19107', NULL, NULL, 'Family of unknown function (DUF5794)', NULL, 'DUF5794', NULL, NULL, 35806, 9),
(273450, NULL, 'PF04254', NULL, NULL, 'Protein of unknown function (DUF432)', NULL, 'DUF432', NULL, NULL, 5905, 9),
(273451, NULL, 'PF07990', NULL, NULL, 'Nucleic acid binding protein NABP', NULL, 'NABP', NULL, NULL, 8044, 9),
(273452, NULL, 'PF08407', NULL, NULL, 'Chitin synthase N-terminal', NULL, 'Chitin_synth_1N', NULL, NULL, 11251, 9),
(273453, NULL, 'PF19015', NULL, NULL, 'Family of unknown function (DUF5744)', NULL, 'DUF5744', NULL, NULL, 35561, 9),
(273454, NULL, 'PF16100', NULL, NULL, 'RecQ-mediated genome instability protein 2', NULL, 'RMI2', NULL, NULL, 23241, 9),
(273455, NULL, 'PF04875', NULL, NULL, 'Protein of unknown function, DUF645', NULL, 'DUF645', NULL, NULL, 5837, 9),
(273456, NULL, 'PF05789', NULL, NULL, 'Baculovirus VP1054 protein', NULL, 'Baculo_VP1054', NULL, NULL, 8544, 9),
(273457, NULL, 'PF03354', NULL, NULL, 'Terminase large subunit, ATPase domain', NULL, 'TerL_ATPase', NULL, NULL, 36842, 9),
(273458, NULL, 'PF18727', NULL, NULL, 'Alstrom syndrome repeat', NULL, 'ALMS_repeat', NULL, NULL, 28068, 9);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(273459, NULL, 'PF01398', NULL, NULL, 'JAB1/Mov34/MPN/PAD-1 ubiquitin protease', NULL, 'JAB', NULL, NULL, 5596, 9),
(273460, NULL, 'PF10617', NULL, NULL, 'Protein of unknown function (DUF2474)', NULL, 'DUF2474', NULL, NULL, 20918, 9),
(273461, NULL, 'PF13490', NULL, NULL, 'Putative zinc-finger', NULL, 'zf-HC2', NULL, NULL, 24728, 9),
(273462, NULL, 'PF18818', NULL, NULL, 'Zincin-like metallopeptidase', NULL, 'MPTase-PolyVal', NULL, NULL, 29929, 9),
(273463, NULL, 'PF02559', NULL, NULL, 'CarD-like/TRCF domain', NULL, 'CarD_CdnL_TRCF', NULL, NULL, 2299, 9),
(273464, NULL, 'PF17352', NULL, NULL, 'Male Flower Specific protein 18', NULL, 'MFS18', NULL, NULL, 9548, 9),
(273465, NULL, 'PF09325', NULL, NULL, 'Vps5 C terminal like', NULL, 'Vps5', NULL, NULL, 14149, 9),
(273466, NULL, 'PF14998', NULL, NULL, 'Transcription Regulator', NULL, 'Ripply', NULL, NULL, 21519, 9),
(273467, NULL, 'PF00077', NULL, NULL, 'Retroviral aspartyl protease', NULL, 'RVP', NULL, NULL, 19315, 9),
(273468, NULL, 'PF13070', NULL, NULL, 'Protein of unknown function (DUF3934)', NULL, 'DUF3934', NULL, NULL, 21180, 9),
(273469, NULL, 'PF01296', NULL, NULL, 'Galanin', NULL, 'Galanin', NULL, NULL, 7237, 9),
(273470, NULL, 'PF17170', NULL, NULL, '6-bladed beta-propeller', NULL, 'DUF5128', NULL, NULL, NULL, 9),
(273471, NULL, 'PF20299', NULL, NULL, 'Nucleotidyltransferase-Associated Rossmannoid Fold', NULL, 'NARF', NULL, NULL, 37512, 9),
(273472, NULL, 'PF00396', NULL, NULL, 'Granulin', NULL, 'Granulin', NULL, NULL, 1709, 9),
(273473, NULL, 'PF04515', NULL, NULL, 'Plasma-membrane choline transporter', NULL, 'Choline_transpo', NULL, NULL, 2582, 9),
(273474, NULL, 'PF00561', NULL, NULL, 'alpha/beta hydrolase fold', NULL, 'Abhydrolase_1', NULL, NULL, 3611, 9),
(273475, NULL, 'PF03876', NULL, NULL, 'SHS2 domain found in N terminus of Rpb7p/Rpc25p/MJ0397', NULL, 'SHS2_Rpb7-N', NULL, NULL, 1975, 9),
(273476, NULL, 'PF12111', NULL, NULL, 'Polyribonucleotide phosphorylase C terminal', NULL, 'PNPase_C', NULL, NULL, 20191, 9),
(273477, NULL, 'PF16467', NULL, NULL, 'Domain of unknown function (DUF5048)', NULL, 'DUF5048', NULL, NULL, 7651, 9),
(273478, NULL, 'PF15493', NULL, NULL, 'Domain of unknown function, YrpD', NULL, 'YrpD', NULL, NULL, 23691, 9),
(273479, NULL, 'PF03719', NULL, NULL, 'Ribosomal protein S5, C-terminal domain', NULL, 'Ribosomal_S5_C', NULL, NULL, 5910, 9),
(273480, NULL, 'PF01016', NULL, NULL, 'Ribosomal L27 protein', NULL, 'Ribosomal_L27', NULL, NULL, 3236, 9),
(273481, NULL, 'PF01002', NULL, NULL, 'Flavivirus non-structural protein NS2B', NULL, 'Flavi_NS2B', NULL, NULL, 5534, 9),
(273482, NULL, 'PF16000', NULL, NULL, 'CARMIL C-terminus', NULL, 'CARMIL_C', NULL, NULL, 25595, 9),
(273483, NULL, 'PF17354', NULL, NULL, 'Family of unknown function (DUF5382)', NULL, 'DUF5382', NULL, NULL, 29987, 9),
(273484, NULL, 'PF05476', NULL, NULL, 'PET122', NULL, 'PET122', NULL, NULL, 12311, 9),
(273485, NULL, 'PF20498', NULL, NULL, 'Family of unknown function (DUF6728)', NULL, 'DUF6728', NULL, NULL, 33817, 9),
(273486, NULL, 'PF07072', NULL, NULL, 'Cell division protein', NULL, 'ZapD', NULL, NULL, 12942, 9),
(273487, NULL, 'PF12397', NULL, NULL, 'U3 small nucleolar RNA-associated protein 10', NULL, 'U3snoRNP10', NULL, NULL, 20650, 9),
(273488, NULL, 'PF09793', NULL, NULL, 'Anticodon-binding domain', NULL, 'AD', NULL, NULL, 18341, 9),
(273489, NULL, 'PF00967', NULL, NULL, 'Barwin family', NULL, 'Barwin', NULL, NULL, 1276, 9),
(273490, NULL, 'PF05553', NULL, NULL, 'Cotton fibre expressed protein', NULL, 'DUF761', NULL, NULL, 12295, 9),
(273491, NULL, 'PF01592', NULL, NULL, 'NifU-like N terminal domain', NULL, 'NifU_N', NULL, NULL, 5732, 9),
(273492, NULL, 'PF17630', NULL, NULL, 'Family of unknown function (DUF5511)', NULL, 'DUF5511', NULL, NULL, 14866, 9),
(273493, NULL, 'PF02211', NULL, NULL, 'Nitrile hydratase beta subunit', NULL, 'NHase_beta', NULL, NULL, 9945, 9),
(273494, NULL, 'PF00313', NULL, NULL, '''Cold-shock'' DNA-binding domain', NULL, 'CSD', NULL, NULL, 1455, 9),
(273495, NULL, 'PF00474', NULL, NULL, 'Sodium:solute symporter family', NULL, 'SSF', NULL, NULL, 5065, 9);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(273496, NULL, 'PF08480', NULL, NULL, 'Disaggregatase related', NULL, 'Disaggr_assoc', NULL, NULL, 13767, 9),
(273497, NULL, 'PF16253', NULL, NULL, 'Domain of unknown function (DUF4909)', NULL, 'DUF4909', NULL, NULL, 23896, 9),
(273498, NULL, 'PF10305', NULL, NULL, 'RNA pol II promoter Fmp27 protein domain', NULL, 'Fmp27_SW', NULL, NULL, 17000, 9),
(273499, NULL, 'PF16228', NULL, NULL, 'Domain of unknown function (DUF4887)', NULL, 'DUF4887', NULL, NULL, 26242, 9),
(273500, NULL, 'PF02218', NULL, NULL, 'Repeat in HS1/Cortactin', NULL, 'HS1_rep', NULL, NULL, 2604, 9),
(273501, NULL, 'PF04514', NULL, NULL, 'Bluetongue virus non-structural protein NS2', NULL, 'BTV_NS2', NULL, NULL, 2834, 9),
(273502, NULL, 'PF13150', NULL, NULL, 'Conjugative transposon protein TraL', NULL, 'TraL_transposon', NULL, NULL, 22960, 9),
(273503, NULL, 'PF16614', NULL, NULL, 'Unstructured region two on RhoGEF 6 and 7', NULL, 'RhoGEF67_u2', NULL, NULL, NULL, 9),
(273504, NULL, 'PF18948', NULL, NULL, 'Family of unknown function (DUF5692)', NULL, 'DUF5692', NULL, NULL, 35957, 9),
(273505, NULL, 'PF13192', NULL, NULL, 'Thioredoxin domain', NULL, 'Thioredoxin_3', NULL, NULL, 7704, 9),
(273506, NULL, 'PF16140', NULL, NULL, 'Domain of unknown function (DUF4848)', NULL, 'DUF4848', NULL, NULL, 26386, 9),
(273507, NULL, 'PF18416', NULL, NULL, 'N-acetylglucosamine binding protein domain 2', NULL, 'GbpA_2', NULL, NULL, 29401, 9),
(273508, NULL, 'PF04487', NULL, NULL, 'CITED', NULL, 'CITED', NULL, NULL, 1905, 9),
(273509, NULL, 'PF17011', NULL, NULL, 'Domain of unknown function (DUF5093)', NULL, 'DUF5093', NULL, NULL, 22567, 9),
(273510, NULL, 'PF09432', NULL, NULL, 'Tho complex subunit THP2', NULL, 'THP2', NULL, NULL, 15411, 9),
(273511, NULL, 'PF14473', NULL, NULL, 'RD3 protein', NULL, 'RD3', NULL, NULL, 26217, 9),
(273512, NULL, 'PF16921', NULL, NULL, 'Tex protein YqgF-like domain', NULL, 'Tex_YqgF', NULL, NULL, 21932, 9),
(273513, NULL, 'PF00938', NULL, NULL, 'Lipoprotein', NULL, 'Lipoprotein_3', NULL, NULL, 6828, 9),
(273514, NULL, 'PF16335', NULL, NULL, 'Domain of unknown function (DUF4965)', NULL, 'DUF4965', NULL, NULL, 22369, 9),
(273515, NULL, 'PF17831', NULL, NULL, 'Pyruvate dehydrogenase E1 component middle domain', NULL, 'PDH_E1_M', NULL, NULL, 29625, 9),
(273516, NULL, 'PF14895', NULL, NULL, 'Protein phosphatase 1 inhibitor', NULL, 'PPPI_inhib', NULL, NULL, 22982, 9),
(273517, NULL, 'PF00811', NULL, NULL, 'Ependymin', NULL, 'Ependymin', NULL, NULL, 571, 9),
(273518, NULL, 'PF09320', NULL, NULL, 'Domain of unknown function (DUF1977)', NULL, 'DUF1977', NULL, NULL, 14226, 9),
(273519, NULL, 'PF14107', NULL, NULL, 'Domain of unknown function (DUF4280)', NULL, 'DUF4280', NULL, NULL, 22400, 9),
(273520, NULL, 'PF08187', NULL, NULL, 'Myoactive tetradecapeptides family', NULL, 'Tetradecapep', NULL, NULL, 9969, 9),
(273521, NULL, 'PF08903', NULL, NULL, 'Domain of unknown function (DUF1846)', NULL, 'DUF1846', NULL, NULL, 7907, 9),
(273522, NULL, 'PF04654', NULL, NULL, 'Protein of unknown function, DUF599', NULL, 'DUF599', NULL, NULL, 2544, 9),
(273523, NULL, 'PF19244', NULL, NULL, 'Poly(A) polymerase catalytic subunit', NULL, 'Poly_A_pol_cat', NULL, NULL, 35061, 9),
(273524, NULL, 'PF03077', NULL, NULL, 'Putative vacuolating cytotoxin', NULL, 'VacA2', NULL, NULL, 4993, 9),
(273525, NULL, 'PF05834', NULL, NULL, 'Lycopene cyclase protein', NULL, 'Lycopene_cycl', NULL, NULL, NULL, 9),
(273526, NULL, 'PF05462', NULL, NULL, 'Slime mold cyclic AMP receptor', NULL, 'Dicty_CAR', NULL, NULL, NULL, 9),
(273527, NULL, 'PF15663', NULL, NULL, 'Zinc-finger containing family', NULL, 'zf-CCCH_3', NULL, NULL, 30707, 9),
(273528, NULL, 'PF00095', NULL, NULL, 'WAP-type (Whey Acidic Protein) ''four-disulfide core''', NULL, 'WAP', NULL, NULL, 7006, 9),
(273529, NULL, 'PF19485', NULL, NULL, 'Family of unknown function (DUF6021)', NULL, 'DUF6021', NULL, NULL, 36852, 9),
(273530, NULL, 'PF09511', NULL, NULL, 'RNA ligase', NULL, 'RNA_lig_T4_1', NULL, NULL, 15891, 9),
(273531, NULL, 'PF19564', NULL, NULL, 'Family of unknown function (DUF6086)', NULL, 'DUF6086', NULL, NULL, 34028, 9);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(273532, NULL, 'PF14267', NULL, NULL, 'Domain of unknown function (DUF4357)', NULL, 'DUF4357', NULL, NULL, 26140, 9),
(273533, NULL, 'PF14977', NULL, NULL, 'FAM194 protein', NULL, 'FAM194', NULL, NULL, 21038, 9),
(273534, NULL, 'PF12514', NULL, NULL, 'Protein of unknown function (DUF3718)', NULL, 'DUF3718', NULL, NULL, 21095, 9),
(273535, NULL, 'PF02484', NULL, NULL, 'Rhabdovirus Non-virion protein', NULL, 'Rhabdo_NV', NULL, NULL, 6365, 9),
(273536, NULL, 'PF00073', NULL, NULL, 'picornavirus capsid protein', NULL, 'Rhv', NULL, NULL, 3050, 9),
(273537, NULL, 'PF17824', NULL, NULL, 'Family of unknown function (DUF5586)', NULL, 'DUF5586', NULL, NULL, 28031, 9),
(273538, NULL, 'PF15627', NULL, NULL, 'CEP76 C2 domain', NULL, 'CEP76-C2', NULL, NULL, 25272, 9),
(273539, NULL, 'PF05390', NULL, NULL, 'Yeast cell wall synthesis protein KRE9/KNH1 C-terminal', NULL, 'Kre9_KNH1_C', NULL, NULL, 12625, 9),
(273540, NULL, 'PF13267', NULL, NULL, 'Protein of unknown function (DUF4058)', NULL, 'DUF4058', NULL, NULL, 22911, 9),
(273541, NULL, 'PF05559', NULL, NULL, 'Protein of unknown function (DUF763)', NULL, 'DUF763', NULL, NULL, 12337, 9),
(273542, NULL, 'PF18711', NULL, NULL, 'Toxoflavin-degrading enzyme', NULL, 'TxDE', NULL, NULL, 27155, 9),
(273543, NULL, 'PF15020', NULL, NULL, 'Cation channel sperm-associated protein subunit delta', NULL, 'CATSPERD', NULL, NULL, 23049, 9),
(273544, NULL, 'PF05944', NULL, NULL, 'Phage small terminase subunit', NULL, 'Phage_term_smal', NULL, NULL, 7825, 9),
(273545, NULL, 'PF11306', NULL, NULL, 'Protein of unknown function (DUF3108)', NULL, 'DUF3108', NULL, NULL, 18040, 9),
(273546, NULL, 'PF16474', NULL, NULL, 'Kinase non-catalytic C-lobe domain', NULL, 'KIND', NULL, NULL, 9008, 9),
(273547, NULL, 'PF05535', NULL, NULL, 'Chromadorea ALT protein', NULL, 'Chromadorea_ALT', NULL, NULL, 11841, 9),
(273548, NULL, 'PF00600', NULL, NULL, 'Influenza non-structural protein (NS1)', NULL, 'Flu_NS1', NULL, NULL, 4213, 9),
(273549, NULL, 'PF03780', NULL, NULL, 'Asp23 family, cell envelope-related function', NULL, 'Asp23', NULL, NULL, 1981, 9),
(273550, NULL, 'PF07497', NULL, NULL, 'Rho termination factor, RNA-binding domain', NULL, 'Rho_RNA_bind', NULL, NULL, 11297, 9),
(273551, NULL, 'PF12587', NULL, NULL, 'Protein of unknown function (DUF3761)', NULL, 'DUF3761', NULL, NULL, 21441, 9),
(273552, NULL, 'PF20298', NULL, NULL, 'Prokaryotic E2 domain', NULL, 'E2-ntca', NULL, NULL, 33516, 9),
(273553, NULL, 'PF13183', NULL, NULL, '4Fe-4S dicluster domain', NULL, 'Fer4_8', NULL, NULL, 12567, 9),
(273554, NULL, 'PF00673', NULL, NULL, 'ribosomal L5P family C-terminus', NULL, 'Ribosomal_L5_C', NULL, NULL, 25345, 9),
(273555, NULL, 'PF08193', NULL, NULL, 'INO80 complex subunit Ies4', NULL, 'INO80_Ies4', NULL, NULL, 17281, 9),
(273556, NULL, 'PF08757', NULL, NULL, 'CotH kinase protein', NULL, 'CotH', NULL, NULL, 13172, 9),
(273557, NULL, 'PF07968', NULL, NULL, 'Leukocidin/Hemolysin toxin family', NULL, 'Leukocidin', NULL, NULL, 11927, 9),
(273558, NULL, 'PF18255', NULL, NULL, 'DNA processing protein A sterile alpha motif domain', NULL, 'SAM_DrpA', NULL, NULL, 29037, 9),
(273559, NULL, 'PF16662', NULL, NULL, 'FLYWCH-type zinc finger-containing protein 1', NULL, 'FLYWCH_u', NULL, NULL, NULL, 9),
(273560, NULL, 'PF18683', NULL, NULL, 'Chitinase W immunoglobulin-like domain', NULL, 'ChiW_Ig_like', NULL, NULL, 29215, 9),
(273561, NULL, 'PF05221', NULL, NULL, 'S-adenosyl-L-homocysteine hydrolase', NULL, 'AdoHcyase', NULL, NULL, 3741, 9),
(273562, NULL, 'PF12955', NULL, NULL, 'Domain of unknown function (DUF3844)', NULL, 'DUF3844', NULL, NULL, 23348, 9),
(273563, NULL, 'PF16579', NULL, NULL, 'Adenylate sensor of SNF1-like protein kinase', NULL, 'AdenylateSensor', NULL, NULL, 26308, 9),
(273564, NULL, 'PF00121', NULL, NULL, 'Triosephosphate isomerase', NULL, 'TIM', NULL, NULL, 4335, 9),
(273565, NULL, 'PF00737', NULL, NULL, 'Photosystem II 10 kDa phosphoprotein', NULL, 'PsbH', NULL, NULL, 5078, 9),
(273566, NULL, 'PF05233', NULL, NULL, 'PHB accumulation regulatory domain', NULL, 'PHB_acc', NULL, NULL, 3247, 9);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(273567, NULL, 'PF08057', NULL, NULL, 'Erythromycin resistance leader peptide', NULL, 'Ery_res_leader2', NULL, NULL, 9244, 9),
(273568, NULL, 'PF05734', NULL, NULL, 'Herpesvirus protein of unknown function (DUF832)', NULL, 'DUF832', NULL, NULL, 13010, 9),
(273569, NULL, 'PF19350', NULL, NULL, 'Family of unknown function (DUF5928)', NULL, 'DUF5928', NULL, NULL, 36967, 9),
(273570, NULL, 'PF03216', NULL, NULL, 'Rhabdovirus nucleoprotein', NULL, 'Rhabdo_ncap_2', NULL, NULL, 1823, 9),
(273571, NULL, 'PF09197', NULL, NULL, 'Rap1, DNA-binding', NULL, 'Rap1-DNA-bind', NULL, NULL, 12332, 9),
(273572, NULL, 'PF16926', NULL, NULL, 'Archaeal 4TM region of histidine kinase', NULL, 'HisKA_4TM', NULL, NULL, 25487, 9),
(273573, NULL, 'PF11906', NULL, NULL, 'Protein of unknown function (DUF3426)', NULL, 'DUF3426', NULL, NULL, 19696, 9),
(273574, NULL, 'PF01394', NULL, NULL, 'Clathrin propeller repeat', NULL, 'Clathrin_propel', NULL, NULL, 21054, 9),
(273575, NULL, 'PF19900', NULL, NULL, 'Family of unknown function (DUF6373)', NULL, 'DUF6373', NULL, NULL, 36958, 9),
(273576, NULL, 'PF13089', NULL, NULL, 'Polyphosphate kinase N-terminal domain', NULL, 'PP_kinase_N', NULL, NULL, 21946, 9),
(273577, NULL, 'PF06168', NULL, NULL, 'Protein of unknown function (DUF981)', NULL, 'DUF981', NULL, NULL, 14119, 9),
(273578, NULL, 'PF05281', NULL, NULL, 'Neuroendocrine protein 7B2 precursor (Secretogranin V)', NULL, 'Secretogranin_V', NULL, NULL, 4181, 9),
(273579, NULL, 'PF10609', NULL, NULL, 'NUBPL iron-transfer P-loop NTPase', NULL, 'ParA', NULL, NULL, 28255, 9),
(273580, NULL, 'PF17268', NULL, NULL, 'Family of unknown function (DUF5334)', NULL, 'DUF5334', NULL, NULL, 19926, 9),
(273581, NULL, 'PF16914', NULL, NULL, 'Bacterial transcriptional repressor C-terminal', NULL, 'TetR_C_12', NULL, NULL, 10516, 9),
(273582, NULL, 'PF16545', NULL, NULL, 'Cerebral cavernous malformation protein, harmonin-homology', NULL, 'CCM2_C', NULL, NULL, 21739, 9),
(273583, NULL, 'PF06072', NULL, NULL, 'Alphaherpesvirus tegument protein US9', NULL, 'Herpes_US9', NULL, NULL, 13651, 9),
(273584, NULL, 'PF08812', NULL, NULL, 'YtxC-like family', NULL, 'YtxC', NULL, NULL, 9364, 9),
(273585, NULL, 'PF05965', NULL, NULL, 'F/Y rich C-terminus', NULL, 'FYRC', NULL, NULL, 4036, 9),
(273586, NULL, 'PF10351', NULL, NULL, 'Golgi-body localisation protein domain', NULL, 'Apt1', NULL, NULL, 17151, 9),
(273587, NULL, 'PF08843', NULL, NULL, 'Nucleotidyl transferase AbiEii toxin, Type IV TA system', NULL, 'AbiEii', NULL, NULL, 14357, 9),
(273588, NULL, 'PF01853', NULL, NULL, 'MOZ/SAS family', NULL, 'MOZ_SAS', NULL, NULL, 3734, 9),
(273589, NULL, 'PF02592', NULL, NULL, 'Putative vitamin uptake transporter', NULL, 'Vut_1', NULL, NULL, 2380, 9),
(273590, NULL, 'PF06092', NULL, NULL, 'Enterobacterial putative membrane protein (DUF943)', NULL, 'DUF943', NULL, NULL, 8785, 9),
(273591, NULL, 'PF14769', NULL, NULL, 'Flagellar C1a complex subunit C1a-32', NULL, 'CLAMP', NULL, NULL, 26160, 9),
(273592, NULL, 'PF13060', NULL, NULL, 'Protein of unknown function (DUF3921)', NULL, 'DUF3921', NULL, NULL, 22585, 9),
(273593, NULL, 'PF05273', NULL, NULL, 'Poxvirus RNA polymerase 22 kDa subunit', NULL, 'Pox_RNA_Pol_22', NULL, NULL, 4303, 9),
(273594, NULL, 'PF18902', NULL, NULL, 'Domain of unknown function (DUF5658)', NULL, 'DUF5658', NULL, NULL, 35858, 9),
(273595, NULL, 'PF19929', NULL, NULL, 'Family of unknown function (DUF6392)', NULL, 'DUF6392', NULL, NULL, 34378, 9),
(273596, NULL, 'PF05157', NULL, NULL, 'Type II secretion system (T2SS), protein E, N-terminal domain', NULL, 'T2SSE_N', NULL, NULL, 2013, 9),
(273597, NULL, 'PF04716', NULL, NULL, 'ETC complex I subunit conserved region', NULL, 'ETC_C1_NDUFA5', NULL, NULL, 3963, 9),
(273598, NULL, 'PF05804', NULL, NULL, 'Kinesin-associated protein (KAP)', NULL, 'KAP', NULL, NULL, NULL, 9),
(273599, NULL, 'PF08496', NULL, NULL, 'Peptidase family S49 N-terminal', NULL, 'Peptidase_S49_N', NULL, NULL, 13776, 9),
(273600, NULL, 'PF12034', NULL, NULL, 'Domain of unknown function (DUF3520)', NULL, 'DUF3520', NULL, NULL, 19594, 9);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(273601, NULL, 'PF13961', NULL, NULL, 'Domain of unknown function (DUF4219)', NULL, 'DUF4219', NULL, NULL, 22126, 9),
(273602, NULL, 'PF02977', NULL, NULL, 'Carboxypeptidase A inhibitor', NULL, 'CarbpepA_inh', NULL, NULL, 3579, 9),
(273603, NULL, 'PF20407', NULL, NULL, 'Domain of unknown function (DUF1583_N)', NULL, 'DUF1583_N', NULL, NULL, 37645, 9),
(273604, NULL, 'PF16840', NULL, NULL, 'Actin-like protein 7A N-terminus', NULL, 'ACTL7A_N', NULL, NULL, 24112, 9),
(273605, NULL, 'TRANSMEMBRANE', NULL, NULL, 'Region of a membrane-bound protein predicted to be embedded in the membrane.', NULL, 'Transmembrane region', NULL, NULL, NULL, 10),
(273606, NULL, 'SIGNAL_PEPTIDE_C_REGION', NULL, NULL, 'C-terminal region of a signal peptide.', NULL, 'Signal peptide C-region', NULL, NULL, NULL, 10),
(273607, NULL, 'SIGNAL_PEPTIDE_H_REGION', NULL, NULL, 'Hydrophobic region of a signal peptide.', NULL, 'Signal peptide H-region', NULL, NULL, NULL, 10),
(273608, NULL, 'NON_CYTOPLASMIC_DOMAIN', NULL, NULL, 'Region of a membrane-bound protein predicted to be outside the membrane, in the extracellular region.', NULL, 'Non cytoplasmic domain', NULL, NULL, NULL, 10),
(273609, NULL, 'SIGNAL_PEPTIDE_N_REGION', NULL, NULL, 'N-terminal region of a signal peptide.', NULL, 'Signal peptide N-region', NULL, NULL, NULL, 10),
(273610, NULL, 'SIGNAL_PEPTIDE', NULL, NULL, 'Signal peptide region', NULL, 'Signal Peptide', NULL, NULL, NULL, 10),
(273611, NULL, 'CYTOPLASMIC_DOMAIN', NULL, NULL, 'Region of a membrane-bound protein predicted to be outside the membrane, in the cytoplasm.', NULL, 'Cytoplasmic domain', NULL, NULL, NULL, 10),
(273612, NULL, 'PIRSF026508', NULL, NULL, NULL, NULL, 'TelA', NULL, NULL, 13726, 11),
(273613, NULL, 'PIRSF031737', NULL, NULL, NULL, NULL, 'TM_LytTR', NULL, NULL, 12958, 11),
(273614, NULL, 'PIRSF000354', NULL, NULL, NULL, NULL, 'Factors_V_VIII', NULL, NULL, 17527, 11),
(273615, NULL, 'PIRSF036958', NULL, NULL, NULL, NULL, 'mRNA_capping_HCE', NULL, NULL, 19924, 11),
(273616, NULL, 'PIRSF005227', NULL, NULL, NULL, NULL, 'Asp_dh_NAD_syn', NULL, NULL, 10704, 11),
(273617, NULL, 'PIRSF015736', NULL, NULL, NULL, NULL, 'MI', NULL, NULL, 24981, 11),
(273618, NULL, 'PIRSF002004', NULL, NULL, NULL, NULL, 'Leukocyte_common_antigen', NULL, NULL, 20320, 11),
(273619, NULL, 'PIRSF004633', NULL, NULL, NULL, NULL, 'UCP_PLP_oxd', NULL, NULL, 7666, 11),
(273620, NULL, 'PIRSF007663', NULL, NULL, NULL, NULL, 'UCP007663', NULL, NULL, 16031, 11),
(273621, NULL, 'PIRSF030092', NULL, NULL, NULL, NULL, 'UCP030092', NULL, NULL, 17611, 11),
(273622, NULL, 'PIRSF037647', NULL, NULL, NULL, NULL, 'LisH', NULL, NULL, 15845, 11),
(273623, NULL, 'PIRSF500139', NULL, NULL, NULL, NULL, 'AE', NULL, NULL, 34278, 11),
(273624, NULL, 'PIRSF028200', NULL, NULL, NULL, NULL, 'UCP028200', NULL, NULL, 16427, 11),
(273625, NULL, 'PIRSF036618', NULL, NULL, NULL, NULL, 'MobB_MoeA', NULL, NULL, 12850, 11),
(273626, NULL, 'PIRSF017932', NULL, NULL, NULL, NULL, 'Conjugal_TraB', NULL, NULL, 20323, 11),
(273627, NULL, 'PIRSF037266', NULL, NULL, NULL, NULL, 'UCP037266', NULL, NULL, 21034, 11),
(273628, NULL, 'PIRSF005590', NULL, NULL, NULL, NULL, 'RPL10a_RPL10e', NULL, NULL, 1491, 11),
(273629, NULL, 'PIRSF000490', NULL, NULL, NULL, NULL, 'Diphtheria_toxin', NULL, NULL, 4323, 11),
(273630, NULL, 'PIRSF001705', NULL, NULL, NULL, NULL, 'Myc_protein', NULL, NULL, 6983, 11),
(273631, NULL, 'PIRSF001199', NULL, NULL, NULL, NULL, 'BMP1', NULL, NULL, 8797, 11),
(273632, NULL, 'PIRSF015578', NULL, NULL, NULL, NULL, 'Myoinositol-ppht_synth', NULL, NULL, 1907, 11),
(273633, NULL, 'PIRSF003336', NULL, NULL, NULL, NULL, 'RadB', NULL, NULL, 11423, 11),
(273634, NULL, 'PIRSF005751', NULL, NULL, NULL, NULL, 'Acet_citr_lig', NULL, NULL, 10820, 11),
(273635, NULL, 'PIRSF037093', NULL, NULL, NULL, NULL, 'Gamma-COP', NULL, NULL, 20053, 11),
(273636, NULL, 'PIRSF006533', NULL, NULL, NULL, NULL, 'UCP006533', NULL, NULL, 240, 11),
(273637, NULL, 'PIRSF011355', NULL, NULL, NULL, NULL, 'VP24', NULL, NULL, 8367, 11),
(273638, NULL, 'PIRSF004323', NULL, NULL, NULL, NULL, 'Xis-Tn', NULL, NULL, 9632, 11);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(273639, NULL, 'PIRSF038120', NULL, NULL, NULL, NULL, 'Uch', NULL, NULL, 18380, 11),
(273640, NULL, 'PIRSF006591', NULL, NULL, NULL, NULL, 'UCP_CBS_MJ1004', NULL, NULL, 15188, 11),
(273641, NULL, 'PIRSF036613', NULL, NULL, NULL, NULL, 'LytTR', NULL, NULL, 12016, 11),
(273642, NULL, 'PIRSF015957', NULL, NULL, NULL, NULL, 'UCP015957', NULL, NULL, 1913, 11),
(273643, NULL, 'PIRSF009141', NULL, NULL, NULL, NULL, 'UCP009141', NULL, NULL, 13032, 11),
(273644, NULL, 'PIRSF006540', NULL, NULL, NULL, NULL, 'Nop17p', NULL, NULL, 6978, 11),
(273645, NULL, 'PIRSF000343', NULL, NULL, NULL, NULL, 'HMX1', NULL, NULL, 1294, 11),
(273646, NULL, 'PIRSF015852', NULL, NULL, NULL, NULL, 'RRNA_mtase_Grm', NULL, NULL, 10657, 11),
(273647, NULL, 'PIRSF019108', NULL, NULL, NULL, NULL, 'Txn_reg_CopG', NULL, NULL, 21218, 11),
(273648, NULL, 'PIRSF019422', NULL, NULL, NULL, NULL, 'MltA', NULL, NULL, 24413, 11),
(273649, NULL, 'PIRSF010340', NULL, NULL, NULL, NULL, 'Midasin', NULL, NULL, 12989, 11),
(273650, NULL, 'PIRSF013286', NULL, NULL, NULL, NULL, 'MED6_fungi', NULL, NULL, 19241, 11),
(273651, NULL, 'PIRSF003958', NULL, NULL, NULL, NULL, 'NS-S_TospoV', NULL, NULL, 1618, 11),
(273652, NULL, 'PIRSF028680', NULL, NULL, NULL, NULL, 'UCP028680', NULL, NULL, 16545, 11),
(273653, NULL, 'PIRSF020513', NULL, NULL, NULL, NULL, '6alphaFUT_NodZ', NULL, NULL, 13276, 11),
(273654, NULL, 'PIRSF029389', NULL, NULL, NULL, NULL, 'Subtilisin_rel_PA1242', NULL, NULL, 17303, 11),
(273655, NULL, 'PIRSF002191', NULL, NULL, NULL, NULL, 'Ribosomal_L19', NULL, NULL, 4104, 11),
(273656, NULL, 'PIRSF022993', NULL, NULL, NULL, NULL, 'Profilin_api', NULL, NULL, 15213, 11),
(273657, NULL, 'PIRSF012524', NULL, NULL, NULL, NULL, 'YitL_S1', NULL, NULL, 9514, 11),
(273658, NULL, 'PIRSF019251', NULL, NULL, NULL, NULL, 'Rv0465c', NULL, NULL, 22647, 11),
(273659, NULL, 'PIRSF001369', NULL, NULL, NULL, NULL, 'Citrate_synth', NULL, NULL, 12920, 11),
(273660, NULL, 'PIRSF033634', NULL, NULL, NULL, NULL, 'UCP033634', NULL, NULL, 18990, 11),
(273661, NULL, 'PIRSF036431', NULL, NULL, NULL, NULL, 'HK_DctB', NULL, NULL, 19626, 11),
(273662, NULL, 'PIRSF016394', NULL, NULL, NULL, NULL, 'Lsm2', NULL, NULL, 19567, 11),
(273663, NULL, 'PIRSF004548', NULL, NULL, NULL, NULL, 'CreD', NULL, NULL, 8821, 11),
(273664, NULL, 'PIRSF001340', NULL, NULL, NULL, NULL, 'AIRC', NULL, NULL, 19835, 11),
(273665, NULL, 'PIRSF037433', NULL, NULL, NULL, NULL, 'HK_STH3221', NULL, NULL, 14681, 11),
(273666, NULL, 'PIRSF036956', NULL, NULL, NULL, NULL, 'Hrs_Vps27', NULL, NULL, 19524, 11),
(273667, NULL, 'PIRSF035805', NULL, NULL, NULL, NULL, 'Tdk', NULL, NULL, 198, 11),
(273668, NULL, 'PIRSF001456', NULL, NULL, NULL, NULL, 'Chorismate_synth', NULL, NULL, 6508, 11),
(273669, NULL, 'PIRSF031854', NULL, NULL, NULL, NULL, 'UCP031854', NULL, NULL, 16447, 11),
(273670, NULL, 'PIRSF016660', NULL, NULL, NULL, NULL, 'YedI', NULL, NULL, 13482, 11),
(273671, NULL, 'PIRSF037001', NULL, NULL, NULL, NULL, 'RNA_ed_MP81', NULL, NULL, 19541, 11),
(273672, NULL, 'PIRSF003028', NULL, NULL, NULL, NULL, 'Txn_fact_GATA_4/5/6', NULL, NULL, 20187, 11),
(273673, NULL, 'PIRSF001620', NULL, NULL, NULL, NULL, 'TFPI', NULL, NULL, 8976, 11),
(273674, NULL, 'PIRSF500134', NULL, NULL, NULL, NULL, 'UDPglc_DH_bac', NULL, NULL, 26373, 11),
(273675, NULL, 'PIRSF037778', NULL, NULL, NULL, NULL, 'UCP037778_transp_RibU', NULL, NULL, 23102, 11),
(273676, NULL, 'PIRSF006779', NULL, NULL, NULL, NULL, 'UCP006779', NULL, NULL, 3576, 11),
(273677, NULL, 'PIRSF018357', NULL, NULL, NULL, NULL, 'Trans_reg_ArsR', NULL, NULL, 21418, 11),
(273678, NULL, 'PIRSF002026', NULL, NULL, NULL, NULL, 'Nematode_globin', NULL, NULL, 12581, 11),
(273679, NULL, 'PIRSF009120', NULL, NULL, NULL, NULL, 'UCP009120_prtse', NULL, NULL, 16431, 11),
(273680, NULL, 'PIRSF032806', NULL, NULL, NULL, NULL, 'UCP032806', NULL, NULL, 8251, 11),
(273681, NULL, 'PIRSF039085', NULL, NULL, NULL, NULL, 'ABC_ATPase_HisP', NULL, NULL, 25821, 11),
(273682, NULL, 'PIRSF001013', NULL, NULL, NULL, NULL, 'RNAse_Ba', NULL, NULL, 4247, 11),
(273683, NULL, 'PIRSF002181', NULL, NULL, NULL, NULL, 'RPL13p_RPL13Aa_RPL16e_RPL13o', NULL, NULL, 5885, 11);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(273684, NULL, 'PIRSF037714', NULL, NULL, NULL, NULL, 'TolR', NULL, NULL, 16267, 11),
(273685, NULL, 'PIRSF000187', NULL, NULL, NULL, NULL, 'GOGAT', NULL, NULL, 13742, 11),
(273686, NULL, 'PIRSF000887', NULL, NULL, NULL, NULL, 'Pesterase_MJ0037', NULL, NULL, 12758, 11),
(273687, NULL, 'PIRSF007212', NULL, NULL, NULL, NULL, 'Capsid_P70', NULL, NULL, 5345, 11),
(273688, NULL, 'PIRSF003169', NULL, NULL, NULL, NULL, 'HK_DegS', NULL, NULL, 21319, 11),
(273689, NULL, 'PIRSF018649', NULL, NULL, NULL, NULL, 'UCP018649', NULL, NULL, 21126, 11),
(273690, NULL, 'PIRSF006005', NULL, NULL, NULL, NULL, 'GalT_BS', NULL, NULL, 6770, 11),
(273691, NULL, 'PIRSF031773', NULL, NULL, NULL, NULL, 'ABC_31773', NULL, NULL, 6991, 11),
(273692, NULL, 'PIRSF036873', NULL, NULL, NULL, NULL, 'L_TenuV', NULL, NULL, 10357, 11),
(273693, NULL, 'PIRSF005713', NULL, NULL, NULL, NULL, 'P2X_purinoceptor', NULL, NULL, 6799, 11),
(273694, NULL, 'PIRSF029288', NULL, NULL, NULL, NULL, 'SciE_ImpE', NULL, NULL, 10352, 11),
(273695, NULL, 'PIRSF000235', NULL, NULL, NULL, NULL, 'GMP_reductase', NULL, NULL, 1330, 11),
(273696, NULL, 'PIRSF019311', NULL, NULL, NULL, NULL, 'Mb_md_hydr_PF0129', NULL, NULL, 21398, 11),
(273697, NULL, 'PIRSF002033', NULL, NULL, NULL, NULL, 'Hemerythrin_euk', NULL, NULL, 1104, 11),
(273698, NULL, 'PIRSF030013', NULL, NULL, NULL, NULL, 'ThuA_PalA', NULL, NULL, 8378, 11),
(273699, NULL, 'PIRSF029745', NULL, NULL, NULL, NULL, 'FhaC', NULL, NULL, 25981, 11),
(273700, NULL, 'PIRSF036538', NULL, NULL, NULL, NULL, 'EhaK', NULL, NULL, 10397, 11),
(273701, NULL, 'PIRSF027936', NULL, NULL, NULL, NULL, 'UCP027936', NULL, NULL, 16383, 11),
(273702, NULL, 'PIRSF001703', NULL, NULL, NULL, NULL, 'GABP_alpha', NULL, NULL, 19766, 11),
(273703, NULL, 'PIRSF028732', NULL, NULL, NULL, NULL, 'Alba', NULL, NULL, 9652, 11),
(273704, NULL, 'PIRSF017835', NULL, NULL, NULL, NULL, 'ATP-synth_g_mitoch_animal', NULL, NULL, 20147, 11),
(273705, NULL, 'PIRSF017292', NULL, NULL, NULL, NULL, 'UCP017292_zn', NULL, NULL, 20234, 11),
(273706, NULL, 'PIRSF000349', NULL, NULL, NULL, NULL, 'MnSOD_FeSOD', NULL, NULL, 1053, 11),
(273707, NULL, 'PIRSF002520', NULL, NULL, NULL, NULL, 'ALB', NULL, NULL, 19335, 11),
(273708, NULL, 'PIRSF036947', NULL, NULL, NULL, NULL, 'Spt6', NULL, NULL, 19610, 11),
(273709, NULL, 'PIRSF036639', NULL, NULL, NULL, NULL, 'PMK_anim', NULL, NULL, 395, 11),
(273710, NULL, 'PIRSF000378', NULL, NULL, NULL, NULL, 'Gly_radicl_YfiD', NULL, NULL, 10193, 11),
(273711, NULL, 'PIRSF012318', NULL, NULL, NULL, NULL, 'UCP012318', NULL, NULL, 9853, 11),
(273712, NULL, 'PIRSF038056', NULL, NULL, NULL, NULL, 'BP10_SPAN', NULL, NULL, 17700, 11),
(273713, NULL, 'PIRSF028135', NULL, NULL, NULL, NULL, 'UCP028135_HipA-like', NULL, NULL, 16109, 11),
(273714, NULL, 'PIRSF038171', NULL, NULL, NULL, NULL, 'MAPKKK8', NULL, NULL, 18093, 11),
(273715, NULL, 'PIRSF015278', NULL, NULL, NULL, NULL, 'UCP015278', NULL, NULL, 19125, 11),
(273716, NULL, 'PIRSF001866', NULL, NULL, NULL, NULL, 'Mating_factor_alpha', NULL, NULL, 20238, 11),
(273717, NULL, 'PIRSF037260', NULL, NULL, NULL, NULL, 'UCP037260', NULL, NULL, 3143, 11),
(273718, NULL, 'PIRSF001956', NULL, NULL, NULL, NULL, 'IL3R_beta_c', NULL, NULL, 14543, 11),
(273719, NULL, 'PIRSF018814', NULL, NULL, NULL, NULL, 'UCP018814', NULL, NULL, 21482, 11),
(273720, NULL, 'PIRSF001434', NULL, NULL, NULL, NULL, 'CGS', NULL, NULL, 877, 11),
(273721, NULL, 'PIRSF021898', NULL, NULL, NULL, NULL, 'UCP021898', NULL, NULL, 15380, 11),
(273722, NULL, 'PIRSF037402', NULL, NULL, NULL, NULL, 'Lefty', NULL, NULL, 7186, 11),
(273723, NULL, 'PIRSF002724', NULL, NULL, NULL, NULL, 'Actobindin', NULL, NULL, 20481, 11),
(273724, NULL, 'PIRSF019876', NULL, NULL, NULL, NULL, 'HasA', NULL, NULL, 10157, 11),
(273725, NULL, 'PIRSF006748', NULL, NULL, NULL, NULL, 'MDM_2/4', NULL, NULL, 16027, 11),
(273726, NULL, 'PIRSF020653', NULL, NULL, NULL, NULL, 'UCP020653', NULL, NULL, 14358, 11),
(273727, NULL, 'PIRSF000170', NULL, NULL, NULL, NULL, 'Succ_dh_cyt_b558', NULL, NULL, 9096, 11),
(273728, NULL, 'PIRSF002030', NULL, NULL, NULL, NULL, 'Globin_Protozoa_Cyanob', NULL, NULL, 20091, 11);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(273729, NULL, 'PIRSF020893', NULL, NULL, NULL, NULL, 'UCP020893', NULL, NULL, 15237, 11),
(273730, NULL, 'PIRSF038921', NULL, NULL, NULL, NULL, 'P14a', NULL, NULL, 11265, 11),
(273731, NULL, 'PIRSF036055', NULL, NULL, NULL, NULL, 'UCP036055', NULL, NULL, 19806, 11),
(273732, NULL, 'PIRSF032442', NULL, NULL, NULL, NULL, 'UCP032442', NULL, NULL, 18972, 11),
(273733, NULL, 'PIRSF028865', NULL, NULL, NULL, NULL, 'Membrin-2', NULL, NULL, 24179, 11),
(273734, NULL, 'PIRSF003509', NULL, NULL, NULL, NULL, 'UL45_HPV', NULL, NULL, 12805, 11),
(273735, NULL, 'PIRSF000676', NULL, NULL, NULL, NULL, 'Homoser_kin', NULL, NULL, 4502, 11),
(273736, NULL, 'PIRSF019072', NULL, NULL, NULL, NULL, 'UCP019072', NULL, NULL, 21063, 11),
(273737, NULL, 'PIRSF037980', NULL, NULL, NULL, NULL, 'Sarcos_oxid_alpha', NULL, NULL, 3906, 11),
(273738, NULL, 'PIRSF016408', NULL, NULL, NULL, NULL, 'PAGM', NULL, NULL, 19559, 11),
(273739, NULL, 'PIRSF002397', NULL, NULL, NULL, NULL, 'BRCA2', NULL, NULL, 8166, 11),
(273740, NULL, 'PIRSF011407', NULL, NULL, NULL, NULL, 'OmpS_Legionella', NULL, NULL, 2452, 11),
(273741, NULL, 'PIRSF016089', NULL, NULL, NULL, NULL, 'SPC3', NULL, NULL, 313, 11),
(273742, NULL, 'PIRSF027174', NULL, NULL, NULL, NULL, 'YMR209C', NULL, NULL, 16128, 11),
(273743, NULL, 'PIRSF036758', NULL, NULL, NULL, NULL, 'Aden_M_ParB', NULL, NULL, 10088, 11),
(273744, NULL, 'PIRSF034754', NULL, NULL, NULL, NULL, 'SigE', NULL, NULL, 18792, 11),
(273745, NULL, 'PIRSF029658', NULL, NULL, NULL, NULL, 'UCP029658_TPR', NULL, NULL, 17168, 11),
(273746, NULL, 'PIRSF034409', NULL, NULL, NULL, NULL, 'Oligosach_lyase', NULL, NULL, 12666, 11),
(273747, NULL, 'PIRSF016150', NULL, NULL, NULL, NULL, 'FucT_helico', NULL, NULL, 19920, 11),
(273748, NULL, 'PIRSF020514', NULL, NULL, NULL, NULL, 'NolB', NULL, NULL, 15236, 11),
(273749, NULL, 'PIRSF002686', NULL, NULL, NULL, NULL, 'SLG', NULL, NULL, 19670, 11),
(273750, NULL, 'PIRSF012611', NULL, NULL, NULL, NULL, 'UCP012611', NULL, NULL, 17960, 11),
(273751, NULL, 'PIRSF005651', NULL, NULL, NULL, NULL, 'HflC', NULL, NULL, 4374, 11),
(273752, NULL, 'PIRSF001111', NULL, NULL, NULL, NULL, 'Isochorismatase', NULL, NULL, 19885, 11),
(273753, NULL, 'PIRSF033913', NULL, NULL, NULL, NULL, 'S-S_format_DsbB', NULL, NULL, 13756, 11),
(273754, NULL, 'PIRSF000777', NULL, NULL, NULL, NULL, 'RNA_pol_RPC31', NULL, NULL, 21219, 11),
(273755, NULL, 'PIRSF037119', NULL, NULL, NULL, NULL, 'HK_PgtB', NULL, NULL, 20057, 11),
(273756, NULL, 'PIRSF018468', NULL, NULL, NULL, NULL, 'Rep_DICDI', NULL, NULL, 1099, 11),
(273757, NULL, 'PIRSF028139', NULL, NULL, NULL, NULL, 'DOPA-diox_rel_Mll2280', NULL, NULL, 14391, 11),
(273758, NULL, 'PIRSF037213', NULL, NULL, NULL, NULL, 'UCP037213', NULL, NULL, 20989, 11),
(273759, NULL, 'PIRSF000476', NULL, NULL, NULL, NULL, 'EGT', NULL, NULL, 17113, 11),
(273760, NULL, 'PIRSF005956', NULL, NULL, NULL, NULL, 'BtpA', NULL, NULL, 7446, 11),
(273761, NULL, 'PIRSF012563', NULL, NULL, NULL, NULL, 'YtxC', NULL, NULL, 9364, 11),
(273762, NULL, 'PIRSF003383', NULL, NULL, NULL, NULL, 'E1_PLV', NULL, NULL, 21114, 11),
(273763, NULL, 'PIRSF004803', NULL, NULL, NULL, NULL, 'RnjA', NULL, NULL, 23541, 11),
(273764, NULL, 'PIRSF021350', NULL, NULL, NULL, NULL, 'UCP021350', NULL, NULL, 8657, 11),
(273765, NULL, 'PIRSF014899', NULL, NULL, NULL, NULL, 'UCP014899', NULL, NULL, 10886, 11),
(273766, NULL, 'PIRSF022788', NULL, NULL, NULL, NULL, 'UCP022788', NULL, NULL, 15385, 11),
(273767, NULL, 'PIRSF037595', NULL, NULL, NULL, NULL, 'Toll-like_receptor', NULL, NULL, 15329, 11),
(273768, NULL, 'PIRSF002031', NULL, NULL, NULL, NULL, 'Poly_globin', NULL, NULL, 14674, 11),
(273769, NULL, 'PIRSF033318', NULL, NULL, NULL, NULL, 'GFA', NULL, NULL, 8557, 11),
(273770, NULL, 'PIRSF015696', NULL, NULL, NULL, NULL, 'VAC_E10R', NULL, NULL, 4865, 11),
(273771, NULL, 'PIRSF016400', NULL, NULL, NULL, NULL, 'TRAP-beta', NULL, NULL, 13798, 11),
(273772, NULL, 'PIRSF500687', NULL, NULL, NULL, NULL, 'MTase_demethylubiq_bact', NULL, NULL, 24600, 11),
(273773, NULL, 'PIRSF039099', NULL, NULL, NULL, NULL, 'APP-BP1', NULL, NULL, 25421, 11); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(273774, NULL, 'PIRSF038061', NULL, NULL, NULL, NULL, 'K(+)', NULL, NULL, 995, 11),
(273775, NULL, 'PIRSF001146', NULL, NULL, NULL, NULL, 'Factor_XII_HGFA', NULL, NULL, 7472, 11),
(273776, NULL, 'PIRSF032146', NULL, NULL, NULL, NULL, 'UCP032146', NULL, NULL, 7804, 11),
(273777, NULL, 'PIRSF006241', NULL, NULL, NULL, NULL, 'HyI', NULL, NULL, 24587, 11),
(273778, NULL, 'PIRSF019404', NULL, NULL, NULL, NULL, 'FliJ', NULL, NULL, 12623, 11),
(273779, NULL, 'PIRSF001143', NULL, NULL, NULL, NULL, 'Coagul_factor_X', NULL, NULL, 13882, 11),
(273780, NULL, 'PIRSF006530', NULL, NULL, NULL, NULL, 'MtrC', NULL, NULL, 6628, 11),
(273781, NULL, 'PIRSF015894', NULL, NULL, NULL, NULL, 'PRMT5', NULL, NULL, 3211, 11),
(273782, NULL, 'PIRSF017269', NULL, NULL, NULL, NULL, 'GCD14', NULL, NULL, 11881, 11),
(273783, NULL, 'PIRSF039090', NULL, NULL, NULL, NULL, 'Flis', NULL, NULL, 2413, 11),
(273784, NULL, 'PIRSF000551', NULL, NULL, NULL, NULL, 'PKC_delta', NULL, NULL, 12491, 11),
(273785, NULL, 'PIRSF004029', NULL, NULL, NULL, NULL, 'N_ArenaV', NULL, NULL, 987, 11),
(273786, NULL, 'PIRSF037755', NULL, NULL, NULL, NULL, 'Mettl2', NULL, NULL, 22478, 11),
(273787, NULL, 'PIRSF030042', NULL, NULL, NULL, NULL, 'UCP030042', NULL, NULL, 17806, 11),
(273788, NULL, 'PIRSF037442', NULL, NULL, NULL, NULL, 'UCP037442_abhydr', NULL, NULL, 15419, 11),
(273789, NULL, 'PIRSF026622', NULL, NULL, NULL, NULL, 'UCP026622_CAAX', NULL, NULL, 10044, 11),
(273790, NULL, 'PIRSF500682', NULL, NULL, NULL, NULL, 'Serotransferrin', NULL, NULL, 23910, 11),
(273791, NULL, 'PIRSF036200', NULL, NULL, NULL, NULL, 'UCP_TEII', NULL, NULL, 12612, 11),
(273792, NULL, 'PIRSF009343', NULL, NULL, NULL, NULL, 'SUV39_HMTase_SET', NULL, NULL, 14970, 11),
(273793, NULL, 'PIRSF021377', NULL, NULL, NULL, NULL, 'YtfJ', NULL, NULL, 10841, 11),
(273794, NULL, 'PIRSF027386', NULL, NULL, NULL, NULL, 'UCP027386_ABC_sbc_TM0202', NULL, NULL, 22051, 11),
(273795, NULL, 'PIRSF013212', NULL, NULL, NULL, NULL, 'PRDM1_SET', NULL, NULL, 19481, 11),
(273796, NULL, 'PIRSF037004', NULL, NULL, NULL, NULL, 'UCP037004', NULL, NULL, 19782, 11),
(273797, NULL, 'PIRSF500181', NULL, NULL, NULL, NULL, 'Complement_B', NULL, NULL, 22258, 11),
(273798, NULL, 'PIRSF037239', NULL, NULL, NULL, NULL, 'Exonuclease_Xrn2', NULL, NULL, 20915, 11),
(273799, NULL, 'PIRSF038881', NULL, NULL, NULL, NULL, 'RNAbp_HP1423', NULL, NULL, 23680, 11),
(273800, NULL, 'PIRSF012281', NULL, NULL, NULL, NULL, 'UCP012281', NULL, NULL, 10975, 11),
(273801, NULL, 'PIRSF025737', NULL, NULL, NULL, NULL, 'Cyco1', NULL, NULL, 11270, 11),
(273802, NULL, 'PIRSF000858', NULL, NULL, NULL, NULL, 'SCOT-t', NULL, NULL, 12068, 11),
(273803, NULL, 'PIRSF006287', NULL, NULL, NULL, NULL, 'UCP006287', NULL, NULL, 764, 11),
(273804, NULL, 'PIRSF015689', NULL, NULL, NULL, NULL, 'Actaldh_dh_actylatng', NULL, NULL, 4427, 11),
(273805, NULL, 'PIRSF037215', NULL, NULL, NULL, NULL, 'Peptidase_T', NULL, NULL, 10716, 11),
(273806, NULL, 'PIRSF037907', NULL, NULL, NULL, NULL, 'Subtilisin_rel_TK1689', NULL, NULL, 16760, 11),
(273807, NULL, 'PIRSF021700', NULL, NULL, NULL, NULL, '3-demethylubiquinone_Mtase', NULL, NULL, 12341, 11),
(273808, NULL, 'PIRSF036488', NULL, NULL, NULL, NULL, 'Myoglobin_tremt', NULL, NULL, 8245, 11),
(273809, NULL, 'PIRSF006603', NULL, NULL, NULL, NULL, 'DinF', NULL, NULL, 549, 11),
(273810, NULL, 'PIRSF000962', NULL, NULL, NULL, NULL, '3_5-cyc_nuc_Pdiesterase', NULL, NULL, 6535, 11),
(273811, NULL, 'PIRSF000617', NULL, NULL, NULL, NULL, 'TyrPK_HGF-R', NULL, NULL, 17062, 11),
(273812, NULL, 'PIRSF000939', NULL, NULL, NULL, NULL, 'MAPK_Ptase', NULL, NULL, 7749, 11),
(273813, NULL, 'PIRSF029775', NULL, NULL, NULL, NULL, 'Isochor_pyr_lyas', NULL, NULL, 738, 11),
(273814, NULL, 'PIRSF038005', NULL, NULL, NULL, NULL, 'MBD4', NULL, NULL, 17005, 11),
(273815, NULL, 'PIRSF006091', NULL, NULL, NULL, NULL, 'E_trnsport_RnfG', NULL, NULL, 4378, 11),
(273816, NULL, 'PIRSF039050', NULL, NULL, NULL, NULL, 'Ade_cyc', NULL, NULL, 26405, 11),
(273817, NULL, 'PIRSF029143', NULL, NULL, NULL, NULL, 'UCP029143', NULL, NULL, 7885, 11);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(273818, NULL, 'PIRSF029570', NULL, NULL, NULL, NULL, 'UCP029570', NULL, NULL, 17207, 11),
(273819, NULL, 'PIRSF001549', NULL, NULL, NULL, NULL, 'His-tRNA_synth', NULL, NULL, 1964, 11),
(273820, NULL, 'PIRSF020357', NULL, NULL, NULL, NULL, 'UCP020357', NULL, NULL, 8404, 11),
(273821, NULL, 'PIRSF038128', NULL, NULL, NULL, NULL, 'CORI1', NULL, NULL, 18103, 11),
(273822, NULL, 'PIRSF004930', NULL, NULL, NULL, NULL, 'Tln_factor_SUA5', NULL, NULL, 8849, 11),
(273823, NULL, 'PIRSF005883', NULL, NULL, NULL, NULL, 'Carbohydrate_ST', NULL, NULL, 15259, 11),
(273824, NULL, 'PIRSF037228', NULL, NULL, NULL, NULL, 'Lan_mod_RumM', NULL, NULL, 20589, 11),
(273825, NULL, 'PIRSF000477', NULL, NULL, NULL, NULL, 'PurNPase', NULL, NULL, 9806, 11),
(273826, NULL, 'PIRSF000543', NULL, NULL, NULL, NULL, 'NDUAA', NULL, NULL, 9973, 11),
(273827, NULL, 'PIRSF001341', NULL, NULL, NULL, NULL, 'His_decarboxylas', NULL, NULL, 5098, 11),
(273828, NULL, 'PIRSF000022', NULL, NULL, NULL, NULL, 'Bc1_14K', NULL, NULL, 3057, 11),
(273829, NULL, 'PIRSF016527', NULL, NULL, NULL, NULL, 'TNF_CD40', NULL, NULL, 2954, 11),
(273830, NULL, 'PIRSF034781', NULL, NULL, NULL, NULL, 'GEF_SopE', NULL, NULL, 7500, 11),
(273831, NULL, 'PIRSF026534', NULL, NULL, NULL, NULL, 'ABN', NULL, NULL, 16464, 11),
(273832, NULL, 'PIRSF028415', NULL, NULL, NULL, NULL, 'UCP028415', NULL, NULL, 12102, 11),
(273833, NULL, 'PIRSF000310', NULL, NULL, NULL, NULL, 'Upt_hd_small', NULL, NULL, 4482, 11),
(273834, NULL, 'PIRSF005276', NULL, NULL, NULL, NULL, 'SspB', NULL, NULL, 10356, 11),
(273835, NULL, 'PIRSF003137', NULL, NULL, NULL, NULL, 'CoM_red_McrC', NULL, NULL, 1103, 11),
(273836, NULL, 'PIRSF006337', NULL, NULL, NULL, NULL, 'Glycosyltrehalos_trehalohydrls', NULL, NULL, 9799, 11),
(273837, NULL, 'PIRSF038027', NULL, NULL, NULL, NULL, 'Ufm1', NULL, NULL, 6620, 11),
(273838, NULL, 'PIRSF004576', NULL, NULL, NULL, NULL, 'Resolvase_Rsv', NULL, NULL, 21014, 11),
(273839, NULL, 'PIRSF038455', NULL, NULL, NULL, NULL, 'SoxA', NULL, NULL, 26468, 11),
(273840, NULL, 'PIRSF006529', NULL, NULL, NULL, NULL, 'UCP006529_dinclt', NULL, NULL, 10868, 11),
(273841, NULL, 'PIRSF038980', NULL, NULL, NULL, NULL, 'A2M_bac', NULL, NULL, 22632, 11),
(273842, NULL, 'PIRSF038072', NULL, NULL, NULL, NULL, 'Na(+)/PI_cotransporter', NULL, NULL, 17958, 11),
(273843, NULL, 'PIRSF015692', NULL, NULL, NULL, NULL, 'VAC_E2L', NULL, NULL, 2911, 11),
(273844, NULL, 'PIRSF004952', NULL, NULL, NULL, NULL, 'RNase_P_2', NULL, NULL, 15038, 11),
(273845, NULL, 'PIRSF026546', NULL, NULL, NULL, NULL, 'UCP_CBS_YqzB', NULL, NULL, 16080, 11),
(273846, NULL, 'PIRSF012702', NULL, NULL, NULL, NULL, 'MlrC', NULL, NULL, 9789, 11),
(273847, NULL, 'PIRSF029342', NULL, NULL, NULL, NULL, 'UCP029342_Bll4150', NULL, NULL, 17101, 11),
(273848, NULL, 'PIRSF036542', NULL, NULL, NULL, NULL, 'SpmA_SpmB', NULL, NULL, 8164, 11),
(273849, NULL, 'PIRSF001021', NULL, NULL, NULL, NULL, 'Alph-amls_thrmst', NULL, NULL, 11067, 11),
(273850, NULL, 'PIRSF016533', NULL, NULL, NULL, NULL, 'Sp17', NULL, NULL, 12504, 11),
(273851, NULL, 'PIRSF019587', NULL, NULL, NULL, NULL, 'PGPase', NULL, NULL, 24560, 11),
(273852, NULL, 'PIRSF015162', NULL, NULL, NULL, NULL, 'IL-18', NULL, NULL, 8461, 11),
(273853, NULL, 'PIRSF028043', NULL, NULL, NULL, NULL, 'PP2A_B56', NULL, NULL, 1650, 11),
(273854, NULL, 'PIRSF025218', NULL, NULL, NULL, NULL, 'UCP025218', NULL, NULL, 1929, 11),
(273855, NULL, 'PIRSF018783', NULL, NULL, NULL, NULL, 'UCP018783', NULL, NULL, 21096, 11),
(273856, NULL, 'PIRSF004897', NULL, NULL, NULL, NULL, 'UCP004897_ACT', NULL, NULL, 7996, 11),
(273857, NULL, 'PIRSF036959', NULL, NULL, NULL, NULL, 'mRNA_cap_alpha', NULL, NULL, 19638, 11),
(273858, NULL, 'PIRSF000846', NULL, NULL, NULL, NULL, 'ATP_adenylyltr', NULL, NULL, 9502, 11),
(273859, NULL, 'PIRSF030811', NULL, NULL, NULL, NULL, 'UCP030811', NULL, NULL, 17503, 11),
(273860, NULL, 'PIRSF018148', NULL, NULL, NULL, NULL, 'UCP_CBS_YBR214w', NULL, NULL, 20462, 11),
(273861, NULL, 'PIRSF009160', NULL, NULL, NULL, NULL, 'UCP009160', NULL, NULL, 14098, 11),
(273862, NULL, 'PIRSF026587', NULL, NULL, NULL, NULL, 'Epsilon_toxin', NULL, NULL, 10323, 11);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(273863, NULL, 'PIRSF000309', NULL, NULL, NULL, NULL, 'HoxU', NULL, NULL, 17275, 11),
(273864, NULL, 'PIRSF037490', NULL, NULL, NULL, NULL, 'UCP037490_NIF3', NULL, NULL, 15144, 11),
(273865, NULL, 'PIRSF000370', NULL, NULL, NULL, NULL, 'QueE', NULL, NULL, 25541, 11),
(273866, NULL, 'PIRSF037799', NULL, NULL, NULL, NULL, 'Tautomer_YdcE', NULL, NULL, 16236, 11),
(273867, NULL, 'PIRSF500683', NULL, NULL, NULL, NULL, 'Lactotransferrin', NULL, NULL, 25343, 11),
(273868, NULL, 'PIRSF016719', NULL, NULL, NULL, NULL, 'UCP016719', NULL, NULL, 8610, 11),
(273869, NULL, 'PIRSF037863', NULL, NULL, NULL, NULL, 'SLP_lactobac', NULL, NULL, 1963, 11),
(273870, NULL, 'PIRSF001294', NULL, NULL, NULL, NULL, 'H/K_exch_ATPase_A', NULL, NULL, 2414, 11),
(273871, NULL, 'PIRSF036597', NULL, NULL, NULL, NULL, 'Protse_InhA_rel', NULL, NULL, 11017, 11),
(273872, NULL, 'PIRSF011409', NULL, NULL, NULL, NULL, '3HB_olig_hydr', NULL, NULL, 17594, 11),
(273873, NULL, 'PIRSF004789', NULL, NULL, NULL, NULL, 'DR1281', NULL, NULL, 11412, 11),
(273874, NULL, 'PIRSF016134', NULL, NULL, NULL, NULL, 'UCP016134', NULL, NULL, 19937, 11),
(273875, NULL, 'PIRSF015013', NULL, NULL, NULL, NULL, 'UCP015013', NULL, NULL, 19328, 11),
(273876, NULL, 'PIRSF006468', NULL, NULL, NULL, NULL, 'BCAT1', NULL, NULL, 5921, 11),
(273877, NULL, 'PIRSF031503', NULL, NULL, NULL, NULL, 'UCP031503_mp', NULL, NULL, 8358, 11),
(273878, NULL, 'PIRSF036684', NULL, NULL, NULL, NULL, 'ME_PTA', NULL, NULL, 12825, 11),
(273879, NULL, 'PIRSF037472', NULL, NULL, NULL, NULL, 'DHPS_Mtase', NULL, NULL, 15291, 11),
(273880, NULL, 'PIRSF000862', NULL, NULL, NULL, NULL, 'Steryl_ester_lip', NULL, NULL, 24287, 11),
(273881, NULL, 'PIRSF001522', NULL, NULL, NULL, NULL, 'OmpP', NULL, NULL, 2728, 11),
(273882, NULL, 'PIRSF028177', NULL, NULL, NULL, NULL, 'TcmP', NULL, NULL, 16036, 11),
(273883, NULL, 'PIRSF000806', NULL, NULL, NULL, NULL, 'UDPGP', NULL, NULL, 19925, 11),
(273884, NULL, 'PIRSF002211', NULL, NULL, NULL, NULL, 'RPL30p', NULL, NULL, 1445, 11),
(273885, NULL, 'PIRSF038321', NULL, NULL, NULL, NULL, 'PTS_glc_srb_IIC', NULL, NULL, 3466, 11),
(273886, NULL, 'PIRSF000410', NULL, NULL, NULL, NULL, 'CheR', NULL, NULL, 24947, 11),
(273887, NULL, 'PIRSF038092', NULL, NULL, NULL, NULL, 'NPSF_NPFF_NPAF', NULL, NULL, 5067, 11),
(273888, NULL, 'PIRSF002859', NULL, NULL, NULL, NULL, 'Lipo_traT', NULL, NULL, 7747, 11),
(273889, NULL, 'PIRSF001134', NULL, NULL, NULL, NULL, 'Streptogrisin', NULL, NULL, 2050, 11),
(273890, NULL, 'PIRSF028810', NULL, NULL, NULL, NULL, 'Alg10', NULL, NULL, 17355, 11),
(273891, NULL, 'PIRSF002574', NULL, NULL, NULL, NULL, 'SPRL1', NULL, NULL, 20469, 11),
(273892, NULL, 'PIRSF016094', NULL, NULL, NULL, NULL, 'VirC2', NULL, NULL, 13410, 11),
(273893, NULL, 'PIRSF007783', NULL, NULL, NULL, NULL, 'YHR121w', NULL, NULL, 16377, 11),
(273894, NULL, 'PIRSF003639', NULL, NULL, NULL, NULL, 'Capsid_P80/P87', NULL, NULL, 14384, 11),
(273895, NULL, 'PIRSF007951', NULL, NULL, NULL, NULL, 'Hemolysin_aeg', NULL, NULL, 8336, 11),
(273896, NULL, 'PIRSF037945', NULL, NULL, NULL, NULL, 'PGRP-S', NULL, NULL, 17392, 11),
(273897, NULL, 'PIRSF037748', NULL, NULL, NULL, NULL, 'RNase_HIII', NULL, NULL, 2176, 11),
(273898, NULL, 'PIRSF005449', NULL, NULL, NULL, NULL, 'TRAM', NULL, NULL, 15207, 11),
(273899, NULL, 'PIRSF018637', NULL, NULL, NULL, NULL, 'TrmK', NULL, NULL, 4534, 11),
(273900, NULL, 'PIRSF038017', NULL, NULL, NULL, NULL, 'GTP-BP_GEM', NULL, NULL, 17573, 11),
(273901, NULL, 'PIRSF005295', NULL, NULL, NULL, NULL, 'UCP005295_hydrolase', NULL, NULL, 10584, 11),
(273902, NULL, 'PIRSF036551', NULL, NULL, NULL, NULL, 'Chitosanase', NULL, NULL, 6621, 11),
(273903, NULL, 'PIRSF002023', NULL, NULL, NULL, NULL, 'PA2_inhib_alpha/gamma', NULL, NULL, 20106, 11),
(273904, NULL, 'PIRSF002162', NULL, NULL, NULL, NULL, 'RPL6p_RPL6a_RPL9e_RPL9o', NULL, NULL, 6759, 11),
(273905, NULL, 'PIRSF037949', NULL, NULL, NULL, NULL, 'Transl_init_eIF-3_RNA-bind', NULL, NULL, 17241, 11),
(273906, NULL, 'PIRSF000628', NULL, NULL, NULL, NULL, 'FGFR', NULL, NULL, 17323, 11),
(273907, NULL, 'PIRSF000422', NULL, NULL, NULL, NULL, 'NAT_A', NULL, NULL, 16679, 11);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(273908, NULL, 'PIRSF003688', NULL, NULL, NULL, NULL, 'VAC_PP', NULL, NULL, 3608, 11),
(273909, NULL, 'PIRSF005624', NULL, NULL, NULL, NULL, 'Ni-bind_GTPase', NULL, NULL, NULL, 11),
(273910, NULL, 'PIRSF020275', NULL, NULL, NULL, NULL, 'RadSAM_TM0948', NULL, NULL, 21455, 11),
(273911, NULL, 'PIRSF004117', NULL, NULL, NULL, NULL, 'Phage_coat_B', NULL, NULL, 5201, 11),
(273912, NULL, 'PIRSF005290', NULL, NULL, NULL, NULL, 'NOT_su_3_5', NULL, NULL, 12334, 11),
(273913, NULL, 'PIRSF015665', NULL, NULL, NULL, NULL, 'CHOPT', NULL, NULL, 9682, 11),
(273914, NULL, 'PIRSF001427', NULL, NULL, NULL, NULL, 'NHase_beta', NULL, NULL, 1993, 11),
(273915, NULL, 'PIRSF022909', NULL, NULL, NULL, NULL, 'UCP022909', NULL, NULL, 13934, 11),
(273916, NULL, 'PIRSF000497', NULL, NULL, NULL, NULL, 'MAT', NULL, NULL, 5293, 11),
(273917, NULL, 'PIRSF011860', NULL, NULL, NULL, NULL, 'NRIF3', NULL, NULL, 1718, 11),
(273918, NULL, 'PIRSF003085', NULL, NULL, NULL, NULL, 'CmaB', NULL, NULL, 4421, 11),
(273919, NULL, 'PIRSF009449', NULL, NULL, NULL, NULL, 'DNA_primase_large', NULL, NULL, 17802, 11),
(273920, NULL, 'PIRSF016439', NULL, NULL, NULL, NULL, 'UP2', NULL, NULL, 8384, 11),
(273921, NULL, 'PIRSF034300', NULL, NULL, NULL, NULL, 'UCP034300', NULL, NULL, 8447, 11),
(273922, NULL, 'PIRSF024051', NULL, NULL, NULL, NULL, 'UCP024051', NULL, NULL, 16700, 11),
(273923, NULL, 'PIRSF022704', NULL, NULL, NULL, NULL, 'UCP022704', NULL, NULL, 9177, 11),
(273924, NULL, 'PIRSF006392', NULL, NULL, NULL, NULL, 'IPGAM_arch', NULL, NULL, 7075, 11),
(273925, NULL, 'PIRSF037969', NULL, NULL, NULL, NULL, 'U1-C', NULL, NULL, 17094, 11),
(273926, NULL, 'PIRSF004878', NULL, NULL, NULL, NULL, 'RNase_P_4', NULL, NULL, 21048, 11),
(273927, NULL, 'PIRSF036289', NULL, NULL, NULL, NULL, 'Glycosyl_hydrolase_malt_phosph', NULL, NULL, 19606, 11),
(273928, NULL, 'PIRSF033905', NULL, NULL, NULL, NULL, 'UCP033905', NULL, NULL, 11377, 11),
(273929, NULL, 'PIRSF000149', NULL, NULL, NULL, NULL, 'GAPDH', NULL, NULL, 19323, 11),
(273930, NULL, 'PIRSF005719', NULL, NULL, NULL, NULL, 'SMC', NULL, NULL, 10879, 11),
(273931, NULL, 'PIRSF018636', NULL, NULL, NULL, NULL, 'CbiX_N-term', NULL, NULL, 13090, 11),
(273932, NULL, 'PIRSF005572', NULL, NULL, NULL, NULL, 'NifS', NULL, NULL, 15498, 11),
(273933, NULL, 'PIRSF003229', NULL, NULL, NULL, NULL, 'ROM', NULL, NULL, 3617, 11),
(273934, NULL, 'PIRSF005690', NULL, NULL, NULL, NULL, 'GerBA', NULL, NULL, 904, 11),
(273935, NULL, 'PIRSF036466', NULL, NULL, NULL, NULL, 'UCP036466', NULL, NULL, 12368, 11),
(273936, NULL, 'PIRSF000707', NULL, NULL, NULL, NULL, 'Hygromycin-B_kin', NULL, NULL, 19062, 11),
(273937, NULL, 'PIRSF000804', NULL, NULL, NULL, NULL, 'DNA_pol_III_b', NULL, NULL, 4499, 11),
(273938, NULL, 'PIRSF004699', NULL, NULL, NULL, NULL, 'UCP_CBS_ParB', NULL, NULL, 21480, 11),
(273939, NULL, 'PIRSF000026', NULL, NULL, NULL, NULL, 'Cytochrome_cc3', NULL, NULL, 14651, 11),
(273940, NULL, 'PIRSF018660', NULL, NULL, NULL, NULL, 'Archl_flaC', NULL, NULL, 10140, 11),
(273941, NULL, 'PIRSF500722', NULL, NULL, NULL, NULL, 'TEF-3', NULL, NULL, 24811, 11),
(273942, NULL, 'PIRSF004131', NULL, NULL, NULL, NULL, 'RNA_pol_P2', NULL, NULL, 21173, 11),
(273943, NULL, 'PIRSF019302', NULL, NULL, NULL, NULL, 'UCP019302', NULL, NULL, 21165, 11),
(273944, NULL, 'PIRSF038135', NULL, NULL, NULL, NULL, 'WD_rpt_23', NULL, NULL, 18370, 11),
(273945, NULL, 'PIRSF003944', NULL, NULL, NULL, NULL, 'M_poly_OrthobunV', NULL, NULL, 7868, 11),
(273946, NULL, 'PIRSF029063', NULL, NULL, NULL, NULL, 'IV_sec_VirJ', NULL, NULL, 10604, 11),
(273947, NULL, 'PIRSF005063', NULL, NULL, NULL, NULL, 'UCP_CBS_MJ1232', NULL, NULL, 15192, 11),
(273948, NULL, 'PIRSF020606', NULL, NULL, NULL, NULL, 'UCP020606', NULL, NULL, 11261, 11),
(273949, NULL, 'PIRSF016571', NULL, NULL, NULL, NULL, 'C/EBPzeta_CHOP_DDIT3', NULL, NULL, 20467, 11),
(273950, NULL, 'PIRSF016766', NULL, NULL, NULL, NULL, 'UCP016766_ATPgrasp', NULL, NULL, 12583, 11),
(273951, NULL, 'PIRSF019543', NULL, NULL, NULL, NULL, 'Clavaminate_syn', NULL, NULL, 10987, 11),
(273952, NULL, 'PIRSF007487', NULL, NULL, NULL, NULL, 'CoiA', NULL, NULL, 19063, 11);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(273953, NULL, 'PIRSF029548', NULL, NULL, NULL, NULL, 'UCP029548', NULL, NULL, 12455, 11),
(273954, NULL, 'PIRSF037798', NULL, NULL, NULL, NULL, 'Hsp31', NULL, NULL, 16225, 11),
(273955, NULL, 'PIRSF038934', NULL, NULL, NULL, NULL, 'HyaE_HupG', NULL, NULL, 11986, 11),
(273956, NULL, 'PIRSF008835', NULL, NULL, NULL, NULL, 'TPR_repeat_11_Fis1', NULL, NULL, 16418, 11),
(273957, NULL, 'PIRSF037469', NULL, NULL, NULL, NULL, 'Chc_related', NULL, NULL, 15120, 11),
(273958, NULL, 'PIRSF000114', NULL, NULL, NULL, NULL, 'Glycerol-3-P_dh', NULL, NULL, 10110, 11),
(273959, NULL, 'PIRSF002849', NULL, NULL, NULL, NULL, 'MoxR', NULL, NULL, NULL, 11),
(273960, NULL, 'PIRSF016396', NULL, NULL, NULL, NULL, 'Prefoldin_3', NULL, NULL, 19780, 11),
(273961, NULL, 'PIRSF004270', NULL, NULL, NULL, NULL, 'UCP004270', NULL, NULL, 21194, 11),
(273962, NULL, 'PIRSF037281', NULL, NULL, NULL, NULL, 'Wee1_like_PK', NULL, NULL, 21423, 11),
(273963, NULL, 'PIRSF002741', NULL, NULL, NULL, NULL, 'MppA', NULL, NULL, 26258, 11),
(273964, NULL, 'PIRSF004380', NULL, NULL, NULL, NULL, 'GroES_Gp31_phage', NULL, NULL, 21029, 11),
(273965, NULL, 'PIRSF037911', NULL, NULL, NULL, NULL, 'HDAC_II_euk', NULL, NULL, NULL, 11),
(273966, NULL, 'PIRSF002527', NULL, NULL, NULL, NULL, 'ER-like_NR', NULL, NULL, 13465, 11),
(273967, NULL, 'PIRSF016548', NULL, NULL, NULL, NULL, 'Rsd_AlgQ', NULL, NULL, 4803, 11),
(273968, NULL, 'PIRSF030210', NULL, NULL, NULL, NULL, 'UCP030210', NULL, NULL, 17635, 11),
(273969, NULL, 'PIRSF028175', NULL, NULL, NULL, NULL, 'UCP028175', NULL, NULL, 12215, 11),
(273970, NULL, 'PIRSF500154', NULL, NULL, NULL, NULL, 'RPB6', NULL, NULL, 26943, 11),
(273971, NULL, 'PIRSF009279', NULL, NULL, NULL, NULL, 'CRF-BP', NULL, NULL, 8954, 11),
(273972, NULL, 'PIRSF012939', NULL, NULL, NULL, NULL, 'NAR2', NULL, NULL, 19347, 11),
(273973, NULL, 'PIRSF029056', NULL, NULL, NULL, NULL, 'UCP029056', NULL, NULL, 3774, 11),
(273974, NULL, 'PIRSF036424', NULL, NULL, NULL, NULL, 'Transl_init_eIF3b', NULL, NULL, 7636, 11),
(273975, NULL, 'PIRSF036511', NULL, NULL, NULL, NULL, 'ATP_citrt_syn', NULL, NULL, 8269, 11),
(273976, NULL, 'PIRSF037309', NULL, NULL, NULL, NULL, 'PPA2_B55', NULL, NULL, 2578, 11),
(273977, NULL, 'PIRSF037961', NULL, NULL, NULL, NULL, 'FGF-19_FGF-21', NULL, NULL, 29755, 11),
(273978, NULL, 'PIRSF036427', NULL, NULL, NULL, NULL, 'Precrrn-2_mtase', NULL, NULL, 13310, 11),
(273979, NULL, 'PIRSF001400', NULL, NULL, NULL, NULL, 'Enolase', NULL, NULL, 3263, 11),
(273980, NULL, 'PIRSF037733', NULL, NULL, NULL, NULL, 'Txn_fact_FapR', NULL, NULL, 16455, 11),
(273981, NULL, 'PIRSF011362', NULL, NULL, NULL, NULL, 'DevR', NULL, NULL, 17556, 11),
(273982, NULL, 'PIRSF000495', NULL, NULL, NULL, NULL, 'Amidotransf_HisH', NULL, NULL, 10763, 11),
(273983, NULL, 'PIRSF038010', NULL, NULL, NULL, NULL, 'VASP', NULL, NULL, 17103, 11),
(273984, NULL, 'PIRSF018968', NULL, NULL, NULL, NULL, 'ABC_permease_BceB', NULL, NULL, 26935, 11),
(273985, NULL, 'PIRSF026426', NULL, NULL, NULL, NULL, 'UCP026426', NULL, NULL, 11706, 11),
(273986, NULL, 'PIRSF004499', NULL, NULL, NULL, NULL, 'Transl_init_SUI1_Euk', NULL, NULL, 6610, 11),
(273987, NULL, 'PIRSF005648', NULL, NULL, NULL, NULL, 'UCP005648_Ca_binding', NULL, NULL, 15452, 11),
(273988, NULL, 'PIRSF011789', NULL, NULL, NULL, NULL, 'tRNA_endo_SEN2', NULL, NULL, 17560, 11),
(273989, NULL, 'PIRSF002892', NULL, NULL, NULL, NULL, 'Flagellin_A', NULL, NULL, 20153, 11),
(273990, NULL, 'PIRSF018267', NULL, NULL, NULL, NULL, 'VSR_endonuc', NULL, NULL, 971, 11),
(273991, NULL, 'PIRSF039131', NULL, NULL, NULL, NULL, 'Parvin', NULL, NULL, 26785, 11),
(273992, NULL, 'PIRSF019262', NULL, NULL, NULL, NULL, 'UCP019262', NULL, NULL, 21479, 11),
(273993, NULL, 'PIRSF037274', NULL, NULL, NULL, NULL, 'PIP5K_plant', NULL, NULL, 21320, 11),
(273994, NULL, 'PIRSF002155', NULL, NULL, NULL, NULL, 'RPL1p_RPL1a_RPL10e_RPL1o', NULL, NULL, 5473, 11),
(273995, NULL, 'PIRSF029950', NULL, NULL, NULL, NULL, 'UCP029950', NULL, NULL, 10776, 11),
(273996, NULL, 'PIRSF039003', NULL, NULL, NULL, NULL, 'IscX', NULL, NULL, 10235, 11);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(273997, NULL, 'PIRSF000729', NULL, NULL, NULL, NULL, 'GK', NULL, NULL, 8416, 11),
(273998, NULL, 'PIRSF005989', NULL, NULL, NULL, NULL, 'Ectatomin', NULL, NULL, 9018, 11),
(273999, NULL, 'PIRSF027982', NULL, NULL, NULL, NULL, 'EryCV', NULL, NULL, 16180, 11),
(274000, NULL, 'PIRSF017393', NULL, NULL, NULL, NULL, 'MTase_SAV2177', NULL, NULL, 3254, 11),
(274001, NULL, 'PIRSF000238', NULL, NULL, NULL, NULL, 'AhpF', NULL, NULL, 12549, 11),
(274002, NULL, 'PIRSF036482', NULL, NULL, NULL, NULL, 'PPi_PFK_TM0289', NULL, NULL, 7508, 11),
(274003, NULL, 'PIRSF004362', NULL, NULL, NULL, NULL, 'Endo_II_phage_DenA', NULL, NULL, 21089, 11),
(274004, NULL, 'PIRSF005512', NULL, NULL, NULL, NULL, 'UCP005512', NULL, NULL, 7884, 11),
(274005, NULL, 'PIRSF034586', NULL, NULL, NULL, NULL, 'SfrC', NULL, NULL, 18908, 11),
(274006, NULL, 'PIRSF030771', NULL, NULL, NULL, NULL, 'UCP030771', NULL, NULL, 10924, 11),
(274007, NULL, 'PIRSF004950', NULL, NULL, NULL, NULL, 'Mmb_sulf_HI0842', NULL, NULL, 7394, 11),
(274008, NULL, 'PIRSF006421', NULL, NULL, NULL, NULL, 'UCP006421', NULL, NULL, 791, 11),
(274009, NULL, 'PIRSF036666', NULL, NULL, NULL, NULL, 'G6S', NULL, NULL, 11851, 11),
(274010, NULL, 'PIRSF000375', NULL, NULL, NULL, NULL, 'NifU', NULL, NULL, 17030, 11),
(274011, NULL, 'PIRSF004567', NULL, NULL, NULL, NULL, 'TnsE', NULL, NULL, 21144, 11),
(274012, NULL, 'PIRSF500138', NULL, NULL, NULL, NULL, 'GPI8', NULL, NULL, 26627, 11),
(274013, NULL, 'PIRSF001788', NULL, NULL, NULL, NULL, 'GMF-beta', NULL, NULL, 10598, 11),
(274014, NULL, 'PIRSF037382', NULL, NULL, NULL, NULL, 'CCT_LicC', NULL, NULL, 21314, 11),
(274015, NULL, 'PIRSF029766', NULL, NULL, NULL, NULL, 'UCP029766', NULL, NULL, 10761, 11),
(274016, NULL, 'PIRSF008210', NULL, NULL, NULL, NULL, 'UCP008210', NULL, NULL, 9803, 11),
(274017, NULL, 'PIRSF034110', NULL, NULL, NULL, NULL, 'UCP034110', NULL, NULL, 1989, 11),
(274018, NULL, 'PIRSF037637', NULL, NULL, NULL, NULL, 'SAP18', NULL, NULL, 15727, 11),
(274019, NULL, 'PIRSF011443', NULL, NULL, NULL, NULL, 'YgjV', NULL, NULL, 26313, 11),
(274020, NULL, 'PIRSF026610', NULL, NULL, NULL, NULL, 'UCP026610', NULL, NULL, 16038, 11),
(274021, NULL, 'PIRSF038996', NULL, NULL, NULL, NULL, 'FldA', NULL, NULL, 2392, 11),
(274022, NULL, 'PIRSF022699', NULL, NULL, NULL, NULL, 'MND2', NULL, NULL, 15475, 11),
(274023, NULL, 'PIRSF001500', NULL, NULL, NULL, NULL, 'Chor_mut_pdt_Ppr', NULL, NULL, 608, 11),
(274024, NULL, 'PIRSF001767', NULL, NULL, NULL, NULL, 'Cdc6', NULL, NULL, 19553, 11),
(274025, NULL, 'PIRSF006170', NULL, NULL, NULL, NULL, 'YfgM', NULL, NULL, 24824, 11),
(274026, NULL, 'PIRSF018063', NULL, NULL, NULL, NULL, 'Ferrtn_UCP018063', NULL, NULL, 10452, 11),
(274027, NULL, 'PIRSF019078', NULL, NULL, NULL, NULL, 'UCP019078', NULL, NULL, 21001, 11),
(274028, NULL, 'PIRSF011575', NULL, NULL, NULL, NULL, 'YabG', NULL, NULL, 12124, 11),
(274029, NULL, 'PIRSF038196', NULL, NULL, NULL, NULL, 'IRF-1_IRF-2', NULL, NULL, 18050, 11),
(274030, NULL, 'PIRSF004690', NULL, NULL, NULL, NULL, 'DmsD', NULL, NULL, 23217, 11),
(274031, NULL, 'PIRSF500947', NULL, NULL, NULL, NULL, 'CSF-1_receptor', NULL, NULL, 25118, 11),
(274032, NULL, 'PIRSF004539', NULL, NULL, NULL, NULL, 'Anaerob_C4-dicrbxlt_transp', NULL, NULL, 2820, 11),
(274033, NULL, 'PIRSF004810', NULL, NULL, NULL, NULL, 'ChrA', NULL, NULL, 9576, 11),
(274034, NULL, 'PIRSF003775', NULL, NULL, NULL, NULL, 'E3_ub_ligase_p28', NULL, NULL, 21432, 11),
(274035, NULL, 'PIRSF000848', NULL, NULL, NULL, NULL, 'CDP_diag_ino_3_P', NULL, NULL, 12419, 11),
(274036, NULL, 'PIRSF016325', NULL, NULL, NULL, NULL, 'PTPA', NULL, NULL, 4863, 11),
(274037, NULL, 'PIRSF500133', NULL, NULL, NULL, NULL, 'UDPglc_DH_euk', NULL, NULL, 26334, 11),
(274038, NULL, 'PIRSF005895', NULL, NULL, NULL, NULL, 'UCP005895_mtase', NULL, NULL, 7565, 11),
(274039, NULL, 'PIRSF037395', NULL, NULL, NULL, NULL, 'UCP037395_ABCper', NULL, NULL, 21149, 11),
(274040, NULL, 'PIRSF002379', NULL, NULL, NULL, NULL, 'Coagulogen', NULL, NULL, 882, 11),
(274041, NULL, 'PIRSF032676', NULL, NULL, NULL, NULL, 'PQQC_032676', NULL, NULL, 18629, 11);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(274042, NULL, 'PIRSF037861', NULL, NULL, NULL, NULL, 'Prion_URE2', NULL, NULL, 16814, 11),
(274043, NULL, 'PIRSF006386', NULL, NULL, NULL, NULL, 'HCCAis_GSTk', NULL, NULL, 7691, 11),
(274044, NULL, 'PIRSF000005', NULL, NULL, NULL, NULL, 'Cytochrome_c4', NULL, NULL, 12777, 11),
(274045, NULL, 'PIRSF028583', NULL, NULL, NULL, NULL, 'UCP028583', NULL, NULL, 16812, 11),
(274046, NULL, 'PIRSF019115', NULL, NULL, NULL, NULL, 'UCP019115', NULL, NULL, 19053, 11),
(274047, NULL, 'PIRSF000027', NULL, NULL, NULL, NULL, 'Cytochrome_c_prime', NULL, NULL, 13592, 11),
(274048, NULL, 'PIRSF012359', NULL, NULL, NULL, NULL, 'UCP012359', NULL, NULL, 17951, 11),
(274049, NULL, 'PIRSF036939', NULL, NULL, NULL, NULL, 'PanK_long', NULL, NULL, 10125, 11),
(274050, NULL, 'PIRSF001390', NULL, NULL, NULL, NULL, 'Dipicolinate_synth_subunit_B', NULL, NULL, 10504, 11),
(274051, NULL, 'PIRSF005962', NULL, NULL, NULL, NULL, 'Amidohydrol_AmhX', NULL, NULL, 18102, 11),
(274052, NULL, 'PIRSF500813', NULL, NULL, NULL, NULL, 'PP1_PTG', NULL, NULL, 25148, 11),
(274053, NULL, 'PIRSF004776', NULL, NULL, NULL, NULL, 'NadR_NMNAT/RNK', NULL, NULL, 21124, 11),
(274054, NULL, 'PIRSF006006', NULL, NULL, NULL, NULL, 'UCP006006', NULL, NULL, 10311, 11),
(274055, NULL, 'PIRSF018957', NULL, NULL, NULL, NULL, 'UCP018957', NULL, NULL, 8942, 11),
(274056, NULL, 'PIRSF021505', NULL, NULL, NULL, NULL, 'O_gly_hdrol', NULL, NULL, 11070, 11),
(274057, NULL, 'PIRSF031684', NULL, NULL, NULL, NULL, 'Txn_reg_031684', NULL, NULL, 17791, 11),
(274058, NULL, 'PIRSF037989', NULL, NULL, NULL, NULL, 'UCP037989', NULL, NULL, 17474, 11),
(274059, NULL, 'PIRSF034452', NULL, NULL, NULL, NULL, 'TIM-br_sig_trnsd', NULL, NULL, 10468, 11),
(274060, NULL, 'PIRSF006743', NULL, NULL, NULL, NULL, 'Exonuclease_Xnr1', NULL, NULL, 16028, 11),
(274061, NULL, 'PIRSF033143', NULL, NULL, NULL, NULL, 'LytTR_solo', NULL, NULL, 13176, 11),
(274062, NULL, 'PIRSF002903', NULL, NULL, NULL, NULL, 'CmsA/CmsE', NULL, NULL, 3398, 11),
(274063, NULL, 'PIRSF039088', NULL, NULL, NULL, NULL, 'F_ATPase_subunit_alpha', NULL, NULL, 4160, 11),
(274064, NULL, 'PIRSF034456', NULL, NULL, NULL, NULL, 'UCP034456', NULL, NULL, 18539, 11),
(274065, NULL, 'PIRSF017681', NULL, NULL, NULL, NULL, '3-HAO', NULL, NULL, 20062, 11),
(274066, NULL, 'PIRSF000980', NULL, NULL, NULL, NULL, 'RecC', NULL, NULL, 2394, 11),
(274067, NULL, 'PIRSF023956', NULL, NULL, NULL, NULL, 'TPMT', NULL, NULL, 23400, 11),
(274068, NULL, 'PIRSF001332', NULL, NULL, NULL, NULL, 'Acetolac_decarb', NULL, NULL, 7486, 11),
(274069, NULL, 'PIRSF026343', NULL, NULL, NULL, NULL, 'NlpB', NULL, NULL, 11316, 11),
(274070, NULL, 'PIRSF004925', NULL, NULL, NULL, NULL, 'HcaT', NULL, NULL, 23069, 11),
(274071, NULL, 'PIRSF001002', NULL, NULL, NULL, NULL, 'EcoRI', NULL, NULL, 18903, 11),
(274072, NULL, 'PIRSF037345', NULL, NULL, NULL, NULL, 'ALG8_EndoV', NULL, NULL, 19044, 11),
(274073, NULL, 'PIRSF038984', NULL, NULL, NULL, NULL, 'FAD_binding_protein', NULL, NULL, 2171, 11),
(274074, NULL, 'PIRSF006692', NULL, NULL, NULL, NULL, 'Txn_reg_HTH_AF0396', NULL, NULL, 16293, 11),
(274075, NULL, 'PIRSF000443', NULL, NULL, NULL, NULL, 'Homoser_Ac_trans', NULL, NULL, 886, 11),
(274076, NULL, 'PIRSF009414', NULL, NULL, NULL, NULL, 'LuxC', NULL, NULL, 12737, 11),
(274077, NULL, 'PIRSF002811', NULL, NULL, NULL, NULL, 'DnaG', NULL, NULL, 22500, 11),
(274078, NULL, 'PIRSF019549', NULL, NULL, NULL, NULL, 'Gpr', NULL, NULL, 10123, 11),
(274079, NULL, 'PIRSF000044', NULL, NULL, NULL, NULL, 'Cis_Diol_DH_RD', NULL, NULL, 4134, 11),
(274080, NULL, 'PIRSF015974', NULL, NULL, NULL, NULL, 'CLN3_BTN1', NULL, NULL, 21257, 11),
(274081, NULL, 'PIRSF015753', NULL, NULL, NULL, NULL, 'GST', NULL, NULL, 19076, 11),
(274082, NULL, 'PIRSF005303', NULL, NULL, NULL, NULL, 'Thiam_monoph_kin', NULL, NULL, 3742, 11),
(274083, NULL, 'PIRSF004006', NULL, NULL, NULL, NULL, 'Minor_cap_RTV', NULL, NULL, 976, 11),
(274084, NULL, 'PIRSF004509', NULL, NULL, NULL, NULL, 'UCP004509_Rem', NULL, NULL, 21361, 11),
(274085, NULL, 'PIRSF037347', NULL, NULL, NULL, NULL, 'HK_CHASE2_PAS', NULL, NULL, 21240, 11);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(274086, NULL, 'PIRSF037854', NULL, NULL, NULL, NULL, 'DhpA', NULL, NULL, 16715, 11),
(274087, NULL, 'PIRSF019254', NULL, NULL, NULL, NULL, 'CFP29', NULL, NULL, 3610, 11),
(274088, NULL, 'PIRSF004853', NULL, NULL, NULL, NULL, 'UCP004853', NULL, NULL, 5793, 11),
(274089, NULL, 'PIRSF037225', NULL, NULL, NULL, NULL, 'UCP037225', NULL, NULL, 20512, 11),
(274090, NULL, 'PIRSF006171', NULL, NULL, NULL, NULL, 'RR_citrat_malat', NULL, NULL, 13781, 11),
(274091, NULL, 'PIRSF036158', NULL, NULL, NULL, NULL, 'UCP036158_MarR', NULL, NULL, 8498, 11),
(274092, NULL, 'PIRSF006809', NULL, NULL, NULL, NULL, 'GTP-binding_hflX', NULL, NULL, 16478, 11),
(274093, NULL, 'PIRSF016495', NULL, NULL, NULL, NULL, 'UCP016495', NULL, NULL, 8616, 11),
(274094, NULL, 'PIRSF028431', NULL, NULL, NULL, NULL, 'UCP028431', NULL, NULL, 16958, 11),
(274095, NULL, 'PIRSF010372', NULL, NULL, NULL, NULL, 'PaiB', NULL, NULL, 3680, 11),
(274096, NULL, 'PIRSF000851', NULL, NULL, NULL, NULL, 'PcS', NULL, NULL, 24930, 11),
(274097, NULL, 'PIRSF011716', NULL, NULL, NULL, NULL, 'Endoprotease_Ssy5', NULL, NULL, 12216, 11),
(274098, NULL, 'PIRSF006181', NULL, NULL, NULL, NULL, 'EbsC_YbaK', NULL, NULL, 5348, 11),
(274099, NULL, 'PIRSF000745', NULL, NULL, NULL, NULL, 'VAC_RPO30', NULL, NULL, 9694, 11),
(274100, NULL, 'PIRSF037387', NULL, NULL, NULL, NULL, 'JP', NULL, NULL, 21253, 11),
(274101, NULL, 'PIRSF002450', NULL, NULL, NULL, NULL, 'K+_transpter_TRK', NULL, NULL, 8121, 11),
(274102, NULL, 'PIRSF037902', NULL, NULL, NULL, NULL, 'Subtilisin_rel_Ava_4226', NULL, NULL, 16892, 11),
(274103, NULL, 'PIRSF003726', NULL, NULL, NULL, NULL, 'Vaccinia_VP39', NULL, NULL, 23819, 11),
(274104, NULL, 'PIRSF007027', NULL, NULL, NULL, NULL, 'UCP007027', NULL, NULL, 16471, 11),
(274105, NULL, 'PIRSF037320', NULL, NULL, NULL, NULL, 'Sac3', NULL, NULL, 21019, 11),
(274106, NULL, 'PIRSF006755', NULL, NULL, NULL, NULL, 'DTB_synth', NULL, NULL, 7060, 11),
(274107, NULL, 'PIRSF005225', NULL, NULL, NULL, NULL, 'LAG1_LAC1', NULL, NULL, 15446, 11),
(274108, NULL, 'PIRSF037379', NULL, NULL, NULL, NULL, 'Urm1', NULL, NULL, 10531, 11),
(274109, NULL, 'PIRSF000241', NULL, NULL, NULL, NULL, 'Urate_oxidase', NULL, NULL, 1405, 11),
(274110, NULL, 'PIRSF000900', NULL, NULL, NULL, NULL, 'Acid_Ptase_Asper', NULL, NULL, 12474, 11),
(274111, NULL, 'PIRSF039097', NULL, NULL, NULL, NULL, 'MoSto_subunit', NULL, NULL, 25080, 11),
(274112, NULL, 'PIRSF037431', NULL, NULL, NULL, NULL, 'HK_LiaS', NULL, NULL, 14974, 11),
(274113, NULL, 'PIRSF003888', NULL, NULL, NULL, NULL, 'NCAP_CRV', NULL, NULL, 1067, 11),
(274114, NULL, 'PIRSF036365', NULL, NULL, NULL, NULL, 'Nematode_astacin', NULL, NULL, 19903, 11),
(274115, NULL, 'PIRSF007807', NULL, NULL, NULL, NULL, 'CDC123', NULL, NULL, 12802, 11),
(274116, NULL, 'PIRSF006806', NULL, NULL, NULL, NULL, '5_FTHF', NULL, NULL, 3771, 11),
(274117, NULL, 'PIRSF030780', NULL, NULL, NULL, NULL, 'Md_memb_hyd', NULL, NULL, 17638, 11),
(274118, NULL, 'PIRSF025624', NULL, NULL, NULL, NULL, 'ACT_PheB', NULL, NULL, 7962, 11),
(274119, NULL, 'PIRSF017875', NULL, NULL, NULL, NULL, 'Photosystem_II_Ycf48-like', NULL, NULL, 20317, 11),
(274120, NULL, 'PIRSF029692', NULL, NULL, NULL, NULL, 'UCP029692', NULL, NULL, 17870, 11),
(274121, NULL, 'PIRSF030840', NULL, NULL, NULL, NULL, 'ShuX', NULL, NULL, 9497, 11),
(274122, NULL, 'PIRSF500793', NULL, NULL, NULL, NULL, 'Folate_transporter_1', NULL, NULL, 26611, 11),
(274123, NULL, 'PIRSF008459', NULL, NULL, NULL, NULL, 'UCP008459', NULL, NULL, 16131, 11),
(274124, NULL, 'PIRSF022062', NULL, NULL, NULL, NULL, 'UCP022062', NULL, NULL, 15020, 11),
(274125, NULL, 'PIRSF032436', NULL, NULL, NULL, NULL, 'UCP032436', NULL, NULL, 18668, 11),
(274126, NULL, 'PIRSF018259', NULL, NULL, NULL, NULL, 'CAML', NULL, NULL, 21198, 11),
(274127, NULL, 'PIRSF004681', NULL, NULL, NULL, NULL, 'UCP004681', NULL, NULL, 3185, 11),
(274128, NULL, 'PIRSF012608', NULL, NULL, NULL, NULL, 'UCP012608', NULL, NULL, 9908, 11),
(274129, NULL, 'PIRSF036628', NULL, NULL, NULL, NULL, 'IolB', NULL, NULL, 13792, 11),
(274130, NULL, 'PIRSF500060', NULL, NULL, NULL, NULL, 'UCP500060', NULL, NULL, 25988, 11); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(274131, NULL, 'PIRSF000203', NULL, NULL, NULL, NULL, 'NADP_transhydrogenase_alpha', NULL, NULL, 24731, 11),
(274132, NULL, 'PIRSF038038', NULL, NULL, NULL, NULL, 'Gemin-2', NULL, NULL, 17583, 11),
(274133, NULL, 'PIRSF001438', NULL, NULL, NULL, NULL, 'PBGD', NULL, NULL, 3144, 11),
(274134, NULL, 'PIRSF029215', NULL, NULL, NULL, NULL, 'UCP029215', NULL, NULL, 17137, 11),
(274135, NULL, 'PIRSF027682', NULL, NULL, NULL, NULL, 'UCP027682_CUB_vWA', NULL, NULL, 16108, 11),
(274136, NULL, 'PIRSF036409', NULL, NULL, NULL, NULL, 'EutP_PduV', NULL, NULL, 13116, 11),
(274137, NULL, 'PIRSF011356', NULL, NULL, NULL, NULL, 'VP30_FiloV', NULL, NULL, 9719, 11),
(274138, NULL, 'PIRSF018567', NULL, NULL, NULL, NULL, 'AcoX', NULL, NULL, 14951, 11),
(274139, NULL, 'PIRSF004962', NULL, NULL, NULL, NULL, 'UCP004962', NULL, NULL, 9939, 11),
(274140, NULL, 'PIRSF007352', NULL, NULL, NULL, NULL, 'OapB', NULL, NULL, 12930, 11),
(274141, NULL, 'PIRSF007797', NULL, NULL, NULL, NULL, 'RSM22', NULL, NULL, 16250, 11),
(274142, NULL, 'PIRSF015614', NULL, NULL, NULL, NULL, 'TRAF', NULL, NULL, 13531, 11),
(274143, NULL, 'PIRSF038122', NULL, NULL, NULL, NULL, 'COBRA', NULL, NULL, 4903, 11),
(274144, NULL, 'PIRSF038100', NULL, NULL, NULL, NULL, 'TEX28', NULL, NULL, 18166, 11),
(274145, NULL, 'PIRSF037732', NULL, NULL, NULL, NULL, 'YlbP', NULL, NULL, 16124, 11),
(274146, NULL, 'PIRSF000103', NULL, NULL, NULL, NULL, 'HIBADH', NULL, NULL, 8356, 11),
(274147, NULL, 'PIRSF004417', NULL, NULL, NULL, NULL, 'Anti_term_Q', NULL, NULL, 10014, 11),
(274148, NULL, 'PIRSF028921', NULL, NULL, NULL, NULL, 'Vps41', NULL, NULL, 17314, 11),
(274149, NULL, 'PIRSF005814', NULL, NULL, NULL, NULL, 'MutS_YshD', NULL, NULL, 4909, 11),
(274150, NULL, 'PIRSF000169', NULL, NULL, NULL, NULL, 'SDH_D', NULL, NULL, 9937, 11),
(274151, NULL, 'PIRSF038051', NULL, NULL, NULL, NULL, 'Lys-Histone-de-mtase', NULL, NULL, 17803, 11),
(274152, NULL, 'PIRSF000741', NULL, NULL, NULL, NULL, 'FasBCD', NULL, NULL, 19500, 11),
(274153, NULL, 'PIRSF001491', NULL, NULL, NULL, NULL, 'Ppentomutase', NULL, NULL, 5455, 11),
(274154, NULL, 'PIRSF033563', NULL, NULL, NULL, NULL, 'UCP033563', NULL, NULL, 7644, 11),
(274155, NULL, 'PIRSF028704', NULL, NULL, NULL, NULL, 'UCP028704', NULL, NULL, 12223, 11),
(274156, NULL, 'PIRSF003259', NULL, NULL, NULL, NULL, 'TraL', NULL, NULL, 21147, 11),
(274157, NULL, 'PIRSF037242', NULL, NULL, NULL, NULL, 'CNDP_dipeptidase', NULL, NULL, 21274, 11),
(274158, NULL, 'PIRSF001251', NULL, NULL, NULL, NULL, 'AMP_deaminase', NULL, NULL, 4562, 11),
(274159, NULL, 'PIRSF005409', NULL, NULL, NULL, NULL, 'VAMP-5_synaptobrevin', NULL, NULL, 15311, 11),
(274160, NULL, 'PIRSF016202', NULL, NULL, NULL, NULL, 'PH1107', NULL, NULL, 574, 11),
(274161, NULL, 'PIRSF006595', NULL, NULL, NULL, NULL, 'UCP006595', NULL, NULL, 6355, 11),
(274162, NULL, 'PIRSF029827', NULL, NULL, NULL, NULL, 'Fe_traffic_YggX', NULL, NULL, 4621, 11),
(274163, NULL, 'PIRSF036805', NULL, NULL, NULL, NULL, '26S_protsm_s5a', NULL, NULL, 9748, 11),
(274164, NULL, 'PIRSF036392', NULL, NULL, NULL, NULL, 'RR_ARR_type-B', NULL, NULL, 19506, 11),
(274165, NULL, 'PIRSF037091', NULL, NULL, NULL, NULL, 'AP2_alpha', NULL, NULL, 20490, 11),
(274166, NULL, 'PIRSF500063', NULL, NULL, NULL, NULL, 'DHAPAT', NULL, NULL, 26376, 11),
(274167, NULL, 'PIRSF011515', NULL, NULL, NULL, NULL, 'EspG/VirA', NULL, NULL, 11699, 11),
(274168, NULL, 'PIRSF034445', NULL, NULL, NULL, NULL, 'CpxP_Spy', NULL, NULL, 13251, 11),
(274169, NULL, 'PIRSF002111', NULL, NULL, NULL, NULL, 'RpsA', NULL, NULL, 2974, 11),
(274170, NULL, 'PIRSF037226', NULL, NULL, NULL, NULL, 'Amidohydrolase_ACY1L2', NULL, NULL, 20593, 11),
(274171, NULL, 'PIRSF015883', NULL, NULL, NULL, NULL, 'ADP-Pfk_glckin', NULL, NULL, 9064, 11),
(274172, NULL, 'PIRSF015582', NULL, NULL, NULL, NULL, 'Cit_lyase_B', NULL, NULL, 10699, 11),
(274173, NULL, 'PIRSF037793', NULL, NULL, NULL, NULL, 'EsaB', NULL, NULL, 14137, 11),
(274174, NULL, 'PIRSF038601', NULL, NULL, NULL, NULL, 'UCP038601', NULL, NULL, 10165, 11),
(274175, NULL, 'PIRSF001028', NULL, NULL, NULL, NULL, 'Alpha-amylase_plant', NULL, NULL, 11497, 11);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(274176, NULL, 'PIRSF011911', NULL, NULL, NULL, NULL, 'Minor_capsid_gp61', NULL, NULL, 6512, 11),
(274177, NULL, 'PIRSF000498', NULL, NULL, NULL, NULL, 'Riboflavin_syn_A', NULL, NULL, 4430, 11),
(274178, NULL, 'PIRSF027893', NULL, NULL, NULL, NULL, 'UCP027893', NULL, NULL, 12303, 11),
(274179, NULL, 'PIRSF033541', NULL, NULL, NULL, NULL, 'ORF25P_Sir2', NULL, NULL, 8459, 11),
(274180, NULL, 'PIRSF006685', NULL, NULL, NULL, NULL, 'UCP_006685', NULL, NULL, 15304, 11),
(274181, NULL, 'PIRSF003913', NULL, NULL, NULL, NULL, 'M2_paramyxovir', NULL, NULL, 9402, 11),
(274182, NULL, 'PIRSF006865', NULL, NULL, NULL, NULL, 'Ecotin', NULL, NULL, 2860, 11),
(274183, NULL, 'PIRSF028099', NULL, NULL, NULL, NULL, 'Thiol_oxidored', NULL, NULL, 14013, 11),
(274184, NULL, 'PIRSF018507', NULL, NULL, NULL, NULL, 'Prpndl_dhdrts_lg', NULL, NULL, 2370, 11),
(274185, NULL, 'PIRSF016934', NULL, NULL, NULL, NULL, 'UCP016934', NULL, NULL, 1875, 11),
(274186, NULL, 'PIRSF015840', NULL, NULL, NULL, NULL, 'Lem3/Cdc50', NULL, NULL, 2479, 11),
(274187, NULL, 'PIRSF002131', NULL, NULL, NULL, NULL, 'RPS11p_RPS11a_RPS14e_RPS11o', NULL, NULL, 2246, 11),
(274188, NULL, 'PIRSF017207', NULL, NULL, NULL, NULL, 'UCP017207_Tmem85', NULL, NULL, 8284, 11),
(274189, NULL, 'PIRSF011649', NULL, NULL, NULL, NULL, 'MtTFB', NULL, NULL, 17692, 11),
(274190, NULL, 'PIRSF036912', NULL, NULL, NULL, NULL, 'Sac7', NULL, NULL, 2091, 11),
(274191, NULL, 'PIRSF016725', NULL, NULL, NULL, NULL, 'UCP016725', NULL, NULL, 6191, 11),
(274192, NULL, 'PIRSF015947', NULL, NULL, NULL, NULL, '26S_protsm_Rpn2', NULL, NULL, 19103, 11),
(274193, NULL, 'PIRSF014995', NULL, NULL, NULL, NULL, 'UCP014995', NULL, NULL, 9965, 11),
(274194, NULL, 'PIRSF006402', NULL, NULL, NULL, NULL, 'UCP006402_thioredoxin', NULL, NULL, 5833, 11),
(274195, NULL, 'PIRSF036484', NULL, NULL, NULL, NULL, 'PPi-PFK_SMc01852', NULL, NULL, 7951, 11),
(274196, NULL, 'PIRSF016599', NULL, NULL, NULL, NULL, 'Xaa-His_dipept', NULL, NULL, 1462, 11),
(274197, NULL, 'PIRSF039033', NULL, NULL, NULL, NULL, 'START_dom', NULL, NULL, 26985, 11),
(274198, NULL, 'PIRSF036226', NULL, NULL, NULL, NULL, 'UCP036226', NULL, NULL, 8262, 11),
(274199, NULL, 'PIRSF005901', NULL, NULL, NULL, NULL, 'EF-P', NULL, NULL, 20700, 11),
(274200, NULL, 'PIRSF006158', NULL, NULL, NULL, NULL, 'UCP006158_SH3', NULL, NULL, 15466, 11),
(274201, NULL, 'PIRSF000714', NULL, NULL, NULL, NULL, 'HIT', NULL, NULL, 24791, 11),
(274202, NULL, 'PIRSF009452', NULL, NULL, NULL, NULL, 'MtrA_MtxA', NULL, NULL, 26699, 11),
(274203, NULL, 'PIRSF037956', NULL, NULL, NULL, NULL, 'ZRANB2', NULL, NULL, 17351, 11),
(274204, NULL, 'PIRSF017962', NULL, NULL, NULL, NULL, 'UCP017962', NULL, NULL, 7268, 11),
(274205, NULL, 'PIRSF001658', NULL, NULL, NULL, NULL, 'Amylase_inhib', NULL, NULL, 4781, 11),
(274206, NULL, 'PIRSF005879', NULL, NULL, NULL, NULL, 'C/EBP', NULL, NULL, 15128, 11),
(274207, NULL, 'PIRSF001196', NULL, NULL, NULL, NULL, 'Meprin', NULL, NULL, 8683, 11),
(274208, NULL, 'PIRSF001828', NULL, NULL, NULL, NULL, 'Thymosin_beta', NULL, NULL, 1377, 11),
(274209, NULL, 'PIRSF031601', NULL, NULL, NULL, NULL, 'UCP031601', NULL, NULL, 17891, 11),
(274210, NULL, 'PIRSF000868', NULL, NULL, NULL, NULL, '14-3-3', NULL, NULL, 801, 11),
(274211, NULL, 'PIRSF017215', NULL, NULL, NULL, NULL, 'ESCRT2_Vps22', NULL, NULL, 20438, 11),
(274212, NULL, 'PIRSF036361', NULL, NULL, NULL, NULL, 'YunD', NULL, NULL, 10620, 11),
(274213, NULL, 'PIRSF021964', NULL, NULL, NULL, NULL, 'UCP921964', NULL, NULL, 11320, 11),
(274214, NULL, 'PIRSF000112', NULL, NULL, NULL, NULL, 'Glycerol_dh', NULL, NULL, 17489, 11),
(274215, NULL, 'PIRSF032756', NULL, NULL, NULL, NULL, 'UCP032756', NULL, NULL, 18616, 11),
(274216, NULL, 'PIRSF006598', NULL, NULL, NULL, NULL, 'UCP006598', NULL, NULL, 10638, 11),
(274217, NULL, 'PIRSF500166', NULL, NULL, NULL, NULL, 'HMDII_III', NULL, NULL, 6473, 11),
(274218, NULL, 'PIRSF010361', NULL, NULL, NULL, NULL, 'UCP010361', NULL, NULL, 17807, 11),
(274219, NULL, 'PIRSF007059', NULL, NULL, NULL, NULL, 'ComD', NULL, NULL, 16273, 11),
(274220, NULL, 'PIRSF028160', NULL, NULL, NULL, NULL, 'UCP028160', NULL, NULL, 16140, 11);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(274221, NULL, 'PIRSF029091', NULL, NULL, NULL, NULL, 'RstB1_B2', NULL, NULL, 8656, 11),
(274222, NULL, 'PIRSF021265', NULL, NULL, NULL, NULL, 'ManO', NULL, NULL, 8956, 11),
(274223, NULL, 'PIRSF027744', NULL, NULL, NULL, NULL, 'Snx9', NULL, NULL, 12069, 11),
(274224, NULL, 'PIRSF005637', NULL, NULL, NULL, NULL, 'UCP005637', NULL, NULL, 13290, 11),
(274225, NULL, 'PIRSF028762', NULL, NULL, NULL, NULL, 'ABD1', NULL, NULL, 17274, 11),
(274226, NULL, 'PIRSF032968', NULL, NULL, NULL, NULL, 'UCP032968', NULL, NULL, 18748, 11),
(274227, NULL, 'PIRSF001235', NULL, NULL, NULL, NULL, 'Amidase_hyd_carb', NULL, NULL, 10627, 11),
(274228, NULL, 'PIRSF034405', NULL, NULL, NULL, NULL, 'UCP034405', NULL, NULL, 18874, 11),
(274229, NULL, 'PIRSF037657', NULL, NULL, NULL, NULL, 'Lipopeptide_LppL', NULL, NULL, 15803, 11),
(274230, NULL, 'PIRSF005644', NULL, NULL, NULL, NULL, 'Hdrgns_mtr_HypE', NULL, NULL, 13712, 11),
(274231, NULL, 'PIRSF000609', NULL, NULL, NULL, NULL, 'STPK_YKL116c', NULL, NULL, 17401, 11),
(274232, NULL, 'PIRSF016937', NULL, NULL, NULL, NULL, 'UCP016937', NULL, NULL, 8825, 11),
(274233, NULL, 'PIRSF004161', NULL, NULL, NULL, NULL, 'DNA-bp_J_Microviridae', NULL, NULL, 3811, 11),
(274234, NULL, 'PIRSF028408', NULL, NULL, NULL, NULL, 'UCP028408', NULL, NULL, 12317, 11),
(274235, NULL, 'PIRSF009375', NULL, NULL, NULL, NULL, 'Retromer_Vps35', NULL, NULL, 6439, 11),
(274236, NULL, 'PIRSF016398', NULL, NULL, NULL, NULL, 'TFIIE-beta', NULL, NULL, 19642, 11),
(274237, NULL, 'PIRSF026986', NULL, NULL, NULL, NULL, 'MET_SET', NULL, NULL, 10700, 11),
(274238, NULL, 'PIRSF002816', NULL, NULL, NULL, NULL, 'AraF', NULL, NULL, 22639, 11),
(274239, NULL, 'PIRSF037289', NULL, NULL, NULL, NULL, 'SARA/endofin', NULL, NULL, 33493, 11),
(274240, NULL, 'PIRSF006846', NULL, NULL, NULL, NULL, 'UL5', NULL, NULL, 16209, 11),
(274241, NULL, 'PIRSF010130', NULL, NULL, NULL, NULL, 'PduL', NULL, NULL, 8577, 11),
(274242, NULL, 'PIRSF000116', NULL, NULL, NULL, NULL, 'IlvC_gammaproteo', NULL, NULL, 11207, 11),
(274243, NULL, 'PIRSF030802', NULL, NULL, NULL, NULL, 'UCP030802', NULL, NULL, 13735, 11),
(274244, NULL, 'PIRSF037730', NULL, NULL, NULL, NULL, 'CWA_LytH', NULL, NULL, 16152, 11),
(274245, NULL, 'PIRSF009867', NULL, NULL, NULL, NULL, 'Rrn10', NULL, NULL, 3082, 11),
(274246, NULL, 'PIRSF036920', NULL, NULL, NULL, NULL, 'X4Y4', NULL, NULL, 19597, 11),
(274247, NULL, 'PIRSF000119', NULL, NULL, NULL, NULL, 'Ilv5_fungal', NULL, NULL, 17140, 11),
(274248, NULL, 'PIRSF024851', NULL, NULL, NULL, NULL, 'SCD1', NULL, NULL, 3760, 11),
(274249, NULL, 'PIRSF036429', NULL, NULL, NULL, NULL, 'P5C_synthetase', NULL, NULL, 4778, 11),
(274250, NULL, 'PIRSF000331', NULL, NULL, NULL, NULL, 'HpaA_HpaB', NULL, NULL, 1914, 11),
(274251, NULL, 'PIRSF000927', NULL, NULL, NULL, NULL, 'PTPN3_PTPN4', NULL, NULL, 7005, 11),
(274252, NULL, 'PIRSF006281', NULL, NULL, NULL, NULL, 'MdoG', NULL, NULL, 7751, 11),
(274253, NULL, 'PIRSF016158', NULL, NULL, NULL, NULL, 'HMD', NULL, NULL, 13603, 11),
(274254, NULL, 'PIRSF038186', NULL, NULL, NULL, NULL, 'ITPK', NULL, NULL, 12792, 11),
(274255, NULL, 'PIRSF001467', NULL, NULL, NULL, NULL, 'Peptidylpro_ismrse', NULL, NULL, 16215, 11),
(274256, NULL, 'PIRSF002297', NULL, NULL, NULL, NULL, 'Spectrin_beta', NULL, NULL, 20246, 11),
(274257, NULL, 'PIRSF029477', NULL, NULL, NULL, NULL, 'UCP029477', NULL, NULL, 17273, 11),
(274258, NULL, 'PIRSF001640', NULL, NULL, NULL, NULL, 'Hirudin', NULL, NULL, 6656, 11),
(274259, NULL, 'PIRSF033132', NULL, NULL, NULL, NULL, 'UCP033132', NULL, NULL, 7907, 11),
(274260, NULL, 'PIRSF016907', NULL, NULL, NULL, NULL, 'Kin_ATP-NAD', NULL, NULL, 14988, 11),
(274261, NULL, 'PIRSF000431', NULL, NULL, NULL, NULL, 'G3POAT', NULL, NULL, 17308, 11),
(274262, NULL, 'PIRSF032522', NULL, NULL, NULL, NULL, 'TcaA', NULL, NULL, 16052, 11),
(274263, NULL, 'PIRSF002369', NULL, NULL, NULL, NULL, 'Apovitellenin_I', NULL, NULL, 8782, 11),
(274264, NULL, 'PIRSF036568', NULL, NULL, NULL, NULL, 'CYTH_CHAD_HD', NULL, NULL, 12437, 11),
(274265, NULL, 'PIRSF004793', NULL, NULL, NULL, NULL, 'UCP004793', NULL, NULL, 9593, 11);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(274266, NULL, 'PIRSF026544', NULL, NULL, NULL, NULL, 'DksA_homolog', NULL, NULL, 16169, 11),
(274267, NULL, 'PIRSF000743', NULL, NULL, NULL, NULL, 'RPO19', NULL, NULL, 4357, 11),
(274268, NULL, 'PIRSF034303', NULL, NULL, NULL, NULL, 'UCP034303', NULL, NULL, 8715, 11),
(274269, NULL, 'PIRSF034455', NULL, NULL, NULL, NULL, 'UCP034455', NULL, NULL, 8092, 11),
(274270, NULL, 'PIRSF003165', NULL, NULL, NULL, NULL, 'Chaper_prot_SicA', NULL, NULL, 21080, 11),
(274271, NULL, 'PIRSF028141', NULL, NULL, NULL, NULL, 'C-di-GMP_BP_PA4608', NULL, NULL, 26904, 11),
(274272, NULL, 'PIRSF006728', NULL, NULL, NULL, NULL, 'CinA', NULL, NULL, 6259, 11),
(274273, NULL, 'PIRSF018786', NULL, NULL, NULL, NULL, 'UCP018786', NULL, NULL, 1773, 11),
(274274, NULL, 'PIRSF004869', NULL, NULL, NULL, NULL, 'PflX', NULL, NULL, 21385, 11),
(274275, NULL, 'PIRSF017318', NULL, NULL, NULL, NULL, 'Chor_mut_AroQ_eu', NULL, NULL, 849, 11),
(274276, NULL, 'PIRSF038096', NULL, NULL, NULL, NULL, 'CD27BP', NULL, NULL, 11380, 11),
(274277, NULL, 'PIRSF036961', NULL, NULL, NULL, NULL, 'Kremen', NULL, NULL, 19988, 11),
(274278, NULL, 'PIRSF003867', NULL, NULL, NULL, NULL, 'Rev_lenti-OC', NULL, NULL, 21474, 11),
(274279, NULL, 'PIRSF014422', NULL, NULL, NULL, NULL, 'UCP014422', NULL, NULL, 19431, 11),
(274280, NULL, 'PIRSF016383', NULL, NULL, NULL, NULL, 'UCP016383', NULL, NULL, 13602, 11),
(274281, NULL, 'PIRSF001373', NULL, NULL, NULL, NULL, 'TrpE', NULL, NULL, 4411, 11),
(274282, NULL, 'PIRSF028458', NULL, NULL, NULL, NULL, 'UCP028458', NULL, NULL, 16999, 11),
(274283, NULL, 'PIRSF011791', NULL, NULL, NULL, NULL, 'Retromer_Vps17', NULL, NULL, 9871, 11),
(274284, NULL, 'PIRSF037270', NULL, NULL, NULL, NULL, 'MIS', NULL, NULL, 15744, 11),
(274285, NULL, 'PIRSF009407', NULL, NULL, NULL, NULL, 'IDH_monmr', NULL, NULL, 7114, 11),
(274286, NULL, 'PIRSF026671', NULL, NULL, NULL, NULL, 'AA_dipeptidase', NULL, NULL, 6750, 11),
(274287, NULL, 'PIRSF027833', NULL, NULL, NULL, NULL, 'MtTFB2', NULL, NULL, NULL, 11),
(274288, NULL, 'PIRSF034285', NULL, NULL, NULL, NULL, 'UCP034285', NULL, NULL, 18945, 11),
(274289, NULL, 'PIRSF003954', NULL, NULL, NULL, NULL, 'NS-S_OrthobunV', NULL, NULL, 6618, 11),
(274290, NULL, 'PIRSF032900', NULL, NULL, NULL, NULL, 'MALP', NULL, NULL, 6096, 11),
(274291, NULL, 'PIRSF037318', NULL, NULL, NULL, NULL, 'RfaP', NULL, NULL, 21053, 11),
(274292, NULL, 'PIRSF000647', NULL, NULL, NULL, NULL, 'STPK_SpkB', NULL, NULL, 17040, 11),
(274293, NULL, 'PIRSF017706', NULL, NULL, NULL, NULL, 'TFIP11', NULL, NULL, 21773, 11),
(274294, NULL, 'PIRSF001191', NULL, NULL, NULL, NULL, 'MMP_stromelysin', NULL, NULL, 15163, 11),
(274295, NULL, 'PIRSF036670', NULL, NULL, NULL, NULL, 'ATPase_UCP036670', NULL, NULL, 13584, 11),
(274296, NULL, 'PIRSF019554', NULL, NULL, NULL, NULL, 'LT-IIA', NULL, NULL, 10073, 11),
(274297, NULL, 'PIRSF000388', NULL, NULL, NULL, NULL, 'PanB', NULL, NULL, 2403, 11),
(274298, NULL, 'PIRSF005965', NULL, NULL, NULL, NULL, 'Chor_mut_AroH', NULL, NULL, 900, 11),
(274299, NULL, 'PIRSF010636', NULL, NULL, NULL, NULL, 'ANTAR_solo', NULL, NULL, 13747, 11),
(274300, NULL, 'PIRSF027807', NULL, NULL, NULL, NULL, 'Cerberus', NULL, NULL, 16049, 11),
(274301, NULL, 'PIRSF000456', NULL, NULL, NULL, NULL, 'UDP-GlcNAc_acltr', NULL, NULL, 10746, 11),
(274302, NULL, 'PIRSF037006', NULL, NULL, NULL, NULL, 'Wax_synthase', NULL, NULL, 19614, 11),
(274303, NULL, 'PIRSF028069', NULL, NULL, NULL, NULL, 'UCP028069', NULL, NULL, 16404, 11),
(274304, NULL, 'PIRSF006373', NULL, NULL, NULL, NULL, 'TFE_archaea', NULL, NULL, 15345, 11),
(274305, NULL, 'PIRSF004177', NULL, NULL, NULL, NULL, 'gp1_phi29', NULL, NULL, 21492, 11),
(274306, NULL, 'PIRSF017607', NULL, NULL, NULL, NULL, 'Numb_numb_like', NULL, NULL, 20413, 11),
(274307, NULL, 'PIRSF036989', NULL, NULL, NULL, NULL, 'Zeaxanthin_epoxidase', NULL, NULL, 19709, 11),
(274308, NULL, 'PIRSF000445', NULL, NULL, NULL, NULL, 'GluTR', NULL, NULL, 39, 11),
(274309, NULL, 'PIRSF002799', NULL, NULL, NULL, NULL, 'PBP1b', NULL, NULL, 13187, 11),
(274310, NULL, 'PIRSF001771', NULL, NULL, NULL, NULL, 'Cyclin_A_B_D_E', NULL, NULL, 33273, 11);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(274311, NULL, 'PIRSF019847', NULL, NULL, NULL, NULL, 'Tri6', NULL, NULL, 21099, 11),
(274312, NULL, 'PIRSF000177', NULL, NULL, NULL, NULL, 'Fumar_rd_cyt_b', NULL, NULL, 3824, 11),
(274313, NULL, 'PIRSF026673', NULL, NULL, NULL, NULL, 'UCP026673_ion_chan', NULL, NULL, 16188, 11),
(274314, NULL, 'PIRSF035427', NULL, NULL, NULL, NULL, 'All2852', NULL, NULL, 10536, 11),
(274315, NULL, 'PIRSF036561', NULL, NULL, NULL, NULL, 'ThTPase', NULL, NULL, 7151, 11),
(274316, NULL, 'PIRSF037785', NULL, NULL, NULL, NULL, 'RecU', NULL, NULL, 581, 11),
(274317, NULL, 'PIRSF016238', NULL, NULL, NULL, NULL, 'Gdnf', NULL, NULL, 19897, 11),
(274318, NULL, 'PIRSF001382', NULL, NULL, NULL, NULL, 'TrpG-trpC-trpF', NULL, NULL, 19576, 11),
(274319, NULL, 'PIRSF000905', NULL, NULL, NULL, NULL, 'G6Pase', NULL, NULL, 19791, 11),
(274320, NULL, 'PIRSF000414', NULL, NULL, NULL, NULL, 'PurH', NULL, NULL, 3950, 11),
(274321, NULL, 'PIRSF029008', NULL, NULL, NULL, NULL, 'MecA', NULL, NULL, 12898, 11),
(274322, NULL, 'PIRSF000208', NULL, NULL, NULL, NULL, 'P450R', NULL, NULL, 15804, 11),
(274323, NULL, 'PIRSF011521', NULL, NULL, NULL, NULL, 'VieB', NULL, NULL, 9877, 11),
(274324, NULL, 'PIRSF005261', NULL, NULL, NULL, NULL, 'HSP33', NULL, NULL, 4769, 11),
(274325, NULL, 'PIRSF000239', NULL, NULL, NULL, NULL, 'AHPC', NULL, NULL, 11399, 11),
(274326, NULL, 'PIRSF004602', NULL, NULL, NULL, NULL, 'ATPgrasp_PurP', NULL, NULL, 724, 11),
(274327, NULL, 'PIRSF031066', NULL, NULL, NULL, NULL, 'SPF45', NULL, NULL, 31390, 11),
(274328, NULL, 'PIRSF007778', NULL, NULL, NULL, NULL, 'UCP007778', NULL, NULL, 16435, 11),
(274329, NULL, 'PIRSF015750', NULL, NULL, NULL, NULL, 'Riboflv_synth_arch', NULL, NULL, 5748, 11),
(274330, NULL, 'PIRSF006324', NULL, NULL, NULL, NULL, 'LeuE', NULL, NULL, 1116, 11),
(274331, NULL, 'PIRSF013022', NULL, NULL, NULL, NULL, 'UCP013022', NULL, NULL, 19437, 11),
(274332, NULL, 'PIRSF016429', NULL, NULL, NULL, NULL, 'UPTG', NULL, NULL, 1894, 11),
(274333, NULL, 'PIRSF016184', NULL, NULL, NULL, NULL, 'Ismrse_PhzF', NULL, NULL, 2059, 11),
(274334, NULL, 'PIRSF015679', NULL, NULL, NULL, NULL, 'VAC_mptidase_G1L', NULL, NULL, 10090, 11),
(274335, NULL, 'PIRSF022996', NULL, NULL, NULL, NULL, 'SAG2', NULL, NULL, 15429, 11),
(274336, NULL, 'PIRSF013329', NULL, NULL, NULL, NULL, 'UCP013329', NULL, NULL, 19152, 11),
(274337, NULL, 'PIRSF036478', NULL, NULL, NULL, NULL, 'Uropor_mtas_plnt', NULL, NULL, 13414, 11),
(274338, NULL, 'PIRSF038127', NULL, NULL, NULL, NULL, 'UCP038127_LOB', NULL, NULL, 18233, 11),
(274339, NULL, 'PIRSF039012', NULL, NULL, NULL, NULL, 'ASP', NULL, NULL, 35054, 11),
(274340, NULL, 'PIRSF036428', NULL, NULL, NULL, NULL, 'CobL_MTase', NULL, NULL, 5932, 11),
(274341, NULL, 'PIRSF012443', NULL, NULL, NULL, NULL, 'UCP012443', NULL, NULL, 19024, 11),
(274342, NULL, 'PIRSF002486', NULL, NULL, NULL, NULL, 'CIP_VAC_C3L', NULL, NULL, 10619, 11),
(274343, NULL, 'PIRSF029720', NULL, NULL, NULL, NULL, 'UCP029720', NULL, NULL, 12184, 11),
(274344, NULL, 'PIRSF027133', NULL, NULL, NULL, NULL, 'Rrn11', NULL, NULL, 16193, 11),
(274345, NULL, 'PIRSF000385', NULL, NULL, NULL, NULL, 'Gly_N-mtase', NULL, NULL, 12467, 11),
(274346, NULL, 'PIRSF005784', NULL, NULL, NULL, NULL, 'RnfB', NULL, NULL, 15155, 11),
(274347, NULL, 'PIRSF002498', NULL, NULL, NULL, NULL, 'TF_factor_3', NULL, NULL, 1452, 11),
(274348, NULL, 'PIRSF000029', NULL, NULL, NULL, NULL, 'Cytochrome_b562', NULL, NULL, 9928, 11),
(274349, NULL, 'PIRSF036575', NULL, NULL, NULL, NULL, 'CM_nematode', NULL, NULL, NULL, 11),
(274350, NULL, 'PIRSF001486', NULL, NULL, NULL, NULL, 'CatC', NULL, NULL, 6058, 11),
(274351, NULL, 'PIRSF028137', NULL, NULL, NULL, NULL, 'UCP028137', NULL, NULL, 16327, 11),
(274352, NULL, 'PIRSF028744', NULL, NULL, NULL, NULL, 'UCP028744_Gp-49', NULL, NULL, 13055, 11),
(274353, NULL, 'PIRSF031804', NULL, NULL, NULL, NULL, 'UCP031804', NULL, NULL, 17740, 11),
(274354, NULL, 'PIRSF038165', NULL, NULL, NULL, NULL, 'MAPKKK12_MAPKKK13', NULL, NULL, 18329, 11),
(274355, NULL, 'PIRSF017804', NULL, NULL, NULL, NULL, 'Secretion_EccD1', NULL, NULL, 2410, 11);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(274356, NULL, 'PIRSF000744', NULL, NULL, NULL, NULL, 'RPO22', NULL, NULL, 4303, 11),
(274357, NULL, 'PIRSF037232', NULL, NULL, NULL, NULL, 'Tricalbin', NULL, NULL, 20731, 11),
(274358, NULL, 'PIRSF001174', NULL, NULL, NULL, NULL, 'Lon_proteas', NULL, NULL, 4385, 11),
(274359, NULL, 'PIRSF016616', NULL, NULL, NULL, NULL, 'HNMT', NULL, NULL, 20430, 11),
(274360, NULL, 'PIRSF021603', NULL, NULL, NULL, NULL, 'UCP21603_Ac_t', NULL, NULL, 15028, 11),
(274361, NULL, 'PIRSF500206', NULL, NULL, NULL, NULL, 'MtrH', NULL, NULL, 22104, 11),
(274362, NULL, 'PIRSF003841', NULL, NULL, NULL, NULL, 'Gypsy_env', NULL, NULL, 14473, 11),
(274363, NULL, 'PIRSF027124', NULL, NULL, NULL, NULL, 'HAT_Rtt109', NULL, NULL, 16331, 11),
(274364, NULL, 'PIRSF015647', NULL, NULL, NULL, NULL, 'FBPtase_archl', NULL, NULL, 4556, 11),
(274365, NULL, 'PIRSF036432', NULL, NULL, NULL, NULL, 'Diphthine_synth', NULL, NULL, 977, 11),
(274366, NULL, 'PIRSF020785', NULL, NULL, NULL, NULL, 'ComB', NULL, NULL, 15325, 11),
(274367, NULL, 'PIRSF036586', NULL, NULL, NULL, NULL, 'CDP-ribitol_syn', NULL, NULL, 12922, 11),
(274368, NULL, 'PIRSF016570', NULL, NULL, NULL, NULL, 'Ku80', NULL, NULL, 13630, 11),
(274369, NULL, 'PIRSF021424', NULL, NULL, NULL, NULL, 'RTP', NULL, NULL, 5028, 11),
(274370, NULL, 'PIRSF005646', NULL, NULL, NULL, NULL, 'FwdB', NULL, NULL, 15246, 11),
(274371, NULL, 'PIRSF036762', NULL, NULL, NULL, NULL, 'GAA1', NULL, NULL, 6664, 11),
(274372, NULL, 'PIRSF037432', NULL, NULL, NULL, NULL, 'HK_NreB', NULL, NULL, 14712, 11),
(274373, NULL, 'PIRSF037475', NULL, NULL, NULL, NULL, 'BLOC2_Hps5', NULL, NULL, 19794, 11),
(274374, NULL, 'PIRSF000459', NULL, NULL, NULL, NULL, 'TGM_EBP42', NULL, NULL, 16048, 11),
(274375, NULL, 'PIRSF036437', NULL, NULL, NULL, NULL, 'HK_TorS', NULL, NULL, 9900, 11),
(274376, NULL, 'PIRSF037512', NULL, NULL, NULL, NULL, 'PxSR', NULL, NULL, 15015, 11),
(274377, NULL, 'PIRSF016516', NULL, NULL, NULL, NULL, 'Allantoicase', NULL, NULL, 4645, 11),
(274378, NULL, 'PIRSF037506', NULL, NULL, NULL, NULL, 'NTP_gondii', NULL, NULL, 15451, 11),
(274379, NULL, 'PIRSF000447', NULL, NULL, NULL, NULL, 'KAS_II', NULL, NULL, 15110, 11),
(274380, NULL, 'PIRSF018293', NULL, NULL, NULL, NULL, 'TRAPP_1_Bet3', NULL, NULL, 21463, 11),
(274381, NULL, 'PIRSF004631', NULL, NULL, NULL, NULL, 'Retroelement_env', NULL, NULL, 10696, 11),
(274382, NULL, 'PIRSF037664', NULL, NULL, NULL, NULL, 'MmoD', NULL, NULL, 15548, 11),
(274383, NULL, 'PIRSF020479', NULL, NULL, NULL, NULL, 'UCP020479_CheW', NULL, NULL, 11301, 11),
(274384, NULL, 'PIRSF037504', NULL, NULL, NULL, NULL, 'GRA6', NULL, NULL, 6436, 11),
(274385, NULL, 'PIRSF004911', NULL, NULL, NULL, NULL, 'L-lysine_2_3-aminomutase', NULL, NULL, 2409, 11),
(274386, NULL, 'PIRSF000361', NULL, NULL, NULL, NULL, 'Frd-NADP+_RD', NULL, NULL, 11004, 11),
(274387, NULL, 'PIRSF000033', NULL, NULL, NULL, NULL, 'Cytochrome_b6f_IV', NULL, NULL, 6964, 11),
(274388, NULL, 'PIRSF036407', NULL, NULL, NULL, NULL, 'SelenoP_synth', NULL, NULL, 1501, 11),
(274389, NULL, 'PIRSF038133', NULL, NULL, NULL, NULL, 'EAF3_MRG15', NULL, NULL, 12860, 11),
(274390, NULL, 'PIRSF029271', NULL, NULL, NULL, NULL, 'Pdx1', NULL, NULL, 4143, 11),
(274391, NULL, 'PIRSF019265', NULL, NULL, NULL, NULL, 'UCP019265', NULL, NULL, 894, 11),
(274392, NULL, 'PIRSF000087', NULL, NULL, NULL, NULL, 'PYP', NULL, NULL, 13693, 11),
(274393, NULL, 'PIRSF000632', NULL, NULL, NULL, NULL, 'TyrPK_fps', NULL, NULL, 17318, 11),
(274394, NULL, 'PIRSF037201', NULL, NULL, NULL, NULL, 'Ub_ligase_E6AP', NULL, NULL, 20712, 11),
(274395, NULL, 'PIRSF003764', NULL, NULL, NULL, NULL, 'VAC_K7R', NULL, NULL, 9533, 11),
(274396, NULL, 'PIRSF028288', NULL, NULL, NULL, NULL, 'UCP028288', NULL, NULL, 16424, 11),
(274397, NULL, 'PIRSF001492', NULL, NULL, NULL, NULL, 'IPGAM', NULL, NULL, 1480, 11),
(274398, NULL, 'PIRSF007764', NULL, NULL, NULL, NULL, 'GINS_Sld5', NULL, NULL, 14206, 11),
(274399, NULL, 'PIRSF036363', NULL, NULL, NULL, NULL, 'STPPP_BSU1', NULL, NULL, 13271, 11),
(274400, NULL, 'PIRSF034565', NULL, NULL, NULL, NULL, 'UCP034565', NULL, NULL, 18822, 11);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(274401, NULL, 'PIRSF037847', NULL, NULL, NULL, NULL, 'NiaR', NULL, NULL, 25279, 11),
(274402, NULL, 'PIRSF027153', NULL, NULL, NULL, NULL, 'NNF1', NULL, NULL, 16416, 11),
(274403, NULL, 'PIRSF036490', NULL, NULL, NULL, NULL, 'Aldedh_dupl', NULL, NULL, 8325, 11),
(274404, NULL, 'PIRSF033736', NULL, NULL, NULL, NULL, 'UCP033763', NULL, NULL, 18625, 11),
(274405, NULL, 'PIRSF038925', NULL, NULL, NULL, NULL, 'AMP-prot_trans', NULL, NULL, 26548, 11),
(274406, NULL, 'PIRSF028226', NULL, NULL, NULL, NULL, 'PhaP', NULL, NULL, 8762, 11),
(274407, NULL, 'PIRSF001553', NULL, NULL, NULL, NULL, 'SucCS_alpha', NULL, NULL, 5670, 11),
(274408, NULL, 'PIRSF029171', NULL, NULL, NULL, NULL, 'Esterase_LipA', NULL, NULL, 4112, 11),
(274409, NULL, 'PIRSF015694', NULL, NULL, NULL, NULL, 'VAC_F15L', NULL, NULL, 544, 11),
(274410, NULL, 'PIRSF032582', NULL, NULL, NULL, NULL, 'Cas2', NULL, NULL, 10800, 11),
(274411, NULL, 'PIRSF016624', NULL, NULL, NULL, NULL, 'Mu_prophg_I', NULL, NULL, 12745, 11),
(274412, NULL, 'PIRSF039144', NULL, NULL, NULL, NULL, 'GlnB', NULL, NULL, 5890, 11),
(274413, NULL, 'PIRSF005763', NULL, NULL, NULL, NULL, 'Txn_reg_ModE', NULL, NULL, 15054, 11),
(274414, NULL, 'PIRSF000822', NULL, NULL, NULL, NULL, 'RdRPol_RDV', NULL, NULL, 12118, 11),
(274415, NULL, 'PIRSF000037', NULL, NULL, NULL, NULL, 'Cytochrome_PsbF', NULL, NULL, 3917, 11),
(274416, NULL, 'PIRSF002374', NULL, NULL, NULL, NULL, 'Kappa-casein', NULL, NULL, 4056, 11),
(274417, NULL, 'PIRSF038154', NULL, NULL, NULL, NULL, 'GTE6', NULL, NULL, 18048, 11),
(274418, NULL, 'PIRSF018427', NULL, NULL, NULL, NULL, 'Isopentenyldiphpt_isom', NULL, NULL, 14121, 11),
(274419, NULL, 'PIRSF000450', NULL, NULL, NULL, NULL, 'HTS', NULL, NULL, 30160, 11),
(274420, NULL, 'PIRSF029598', NULL, NULL, NULL, NULL, 'PsiE', NULL, NULL, 14330, 11),
(274421, NULL, 'PIRSF037492', NULL, NULL, NULL, NULL, 'UCP037492_HAD', NULL, NULL, 15141, 11),
(274422, NULL, 'PIRSF014669', NULL, NULL, NULL, NULL, 'UCP014669', NULL, NULL, 19226, 11),
(274423, NULL, 'PIRSF038931', NULL, NULL, NULL, NULL, 'GerQ', NULL, NULL, 14183, 11),
(274424, NULL, 'PIRSF038885', NULL, NULL, NULL, NULL, 'COB', NULL, NULL, 26922, 11),
(274425, NULL, 'PIRSF036461', NULL, NULL, NULL, NULL, 'Chmtx_methlestr', NULL, NULL, 10959, 11),
(274426, NULL, 'PIRSF009264', NULL, NULL, NULL, NULL, 'TagBP_ald_acces_AgaZ', NULL, NULL, 12329, 11),
(274427, NULL, 'PIRSF010076', NULL, NULL, NULL, NULL, 'PAC1', NULL, NULL, 17546, 11),
(274428, NULL, 'PIRSF032341', NULL, NULL, NULL, NULL, 'UCP032341_glycerophostrnsf', NULL, NULL, 18819, 11),
(274429, NULL, 'PIRSF016502', NULL, NULL, NULL, NULL, 'Urea_transporter', NULL, NULL, 1856, 11),
(274430, NULL, 'PIRSF001263', NULL, NULL, NULL, NULL, 'Cyanate_hydratas', NULL, NULL, 6040, 11),
(274431, NULL, 'PIRSF008955', NULL, NULL, NULL, NULL, 'AGOG', NULL, NULL, 16219, 11),
(274432, NULL, 'PIRSF000098', NULL, NULL, NULL, NULL, 'Homoser_dh', NULL, NULL, 17483, 11),
(274433, NULL, 'PIRSF000193', NULL, NULL, NULL, NULL, 'P5CR', NULL, NULL, 803, 11),
(274434, NULL, 'PIRSF500742', NULL, NULL, NULL, NULL, 'MAPKKK13', NULL, NULL, 5611, 11),
(274435, NULL, 'PIRSF001814', NULL, NULL, NULL, NULL, 'Somatostatin', NULL, NULL, 3990, 11),
(274436, NULL, 'PIRSF018100', NULL, NULL, NULL, NULL, 'CsgC', NULL, NULL, 10118, 11),
(274437, NULL, 'PIRSF036410', NULL, NULL, NULL, NULL, 'EutE_PduP', NULL, NULL, 13217, 11),
(274438, NULL, 'PIRSF000505', NULL, NULL, NULL, NULL, 'EPSPS', NULL, NULL, 3826, 11),
(274439, NULL, 'PIRSF003961', NULL, NULL, NULL, NULL, 'M_poly_PhleboV', NULL, NULL, 21011, 11),
(274440, NULL, 'PIRSF028035', NULL, NULL, NULL, NULL, 'UCP028035', NULL, NULL, 16485, 11),
(274441, NULL, 'PIRSF037710', NULL, NULL, NULL, NULL, 'COX7A2L', NULL, NULL, 16210, 11),
(274442, NULL, 'PIRSF000423', NULL, NULL, NULL, NULL, 'ArgA', NULL, NULL, 10556, 11),
(274443, NULL, 'PIRSF016308', NULL, NULL, NULL, NULL, 'UBP', NULL, NULL, 19654, 11),
(274444, NULL, 'PIRSF000538', NULL, NULL, NULL, NULL, 'GlpK', NULL, NULL, 5516, 11),
(274445, NULL, 'PIRSF011844', NULL, NULL, NULL, NULL, 'Sufu', NULL, NULL, 17571, 11);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(274446, NULL, 'PIRSF005536', NULL, NULL, NULL, NULL, 'Agal', NULL, NULL, 5692, 11),
(274447, NULL, 'PIRSF001439', NULL, NULL, NULL, NULL, 'CryM', NULL, NULL, 5153, 11),
(274448, NULL, 'PIRSF003153', NULL, NULL, NULL, NULL, 'ATF2_CRE-BP1', NULL, NULL, 21271, 11),
(274449, NULL, 'PIRSF005419', NULL, NULL, NULL, NULL, 'FlhA', NULL, NULL, 3422, 11),
(274450, NULL, 'PIRSF014979', NULL, NULL, NULL, NULL, 'UCP014979', NULL, NULL, 9762, 11),
(274451, NULL, 'PIRSF000013', NULL, NULL, NULL, NULL, '4_hem_cytochrm_NapC', NULL, NULL, 17632, 11),
(274452, NULL, 'PIRSF001458', NULL, NULL, NULL, NULL, 'MerB', NULL, NULL, 1675, 11),
(274453, NULL, 'PIRSF000566', NULL, NULL, NULL, NULL, 'STPK_Sbk1', NULL, NULL, 17350, 11),
(274454, NULL, 'PIRSF002017', NULL, NULL, NULL, NULL, 'CD14', NULL, NULL, 20482, 11),
(274455, NULL, 'PIRSF002291', NULL, NULL, NULL, NULL, 'Beta_adaptin', NULL, NULL, 20235, 11),
(274456, NULL, 'PIRSF006276', NULL, NULL, NULL, NULL, 'UspA', NULL, NULL, 1052, 11),
(274457, NULL, 'PIRSF001205', NULL, NULL, NULL, NULL, 'Serralysin', NULL, NULL, 19877, 11),
(274458, NULL, 'PIRSF036922', NULL, NULL, NULL, NULL, 'RNaseH_PGAM', NULL, NULL, 8020, 11),
(274459, NULL, 'PIRSF015695', NULL, NULL, NULL, NULL, 'STPK_F10L', NULL, NULL, 13545, 11),
(274460, NULL, 'PIRSF029505', NULL, NULL, NULL, NULL, 'UCP029505', NULL, NULL, 17135, 11),
(274461, NULL, 'PIRSF500125', NULL, NULL, NULL, NULL, '4_HPA_large', NULL, NULL, 21050, 11),
(274462, NULL, 'PIRSF011131', NULL, NULL, NULL, NULL, 'SAC', NULL, NULL, 17720, 11),
(274463, NULL, 'PIRSF001569', NULL, NULL, NULL, NULL, 'E3_ub_ligase_SMURF1', NULL, NULL, 16425, 11),
(274464, NULL, 'PIRSF020419', NULL, NULL, NULL, NULL, 'Fe_uptake_reg_CjrA', NULL, NULL, 15366, 11),
(274465, NULL, 'PIRSF000068', NULL, NULL, NULL, NULL, 'Zn_Fdx_Sulfol', NULL, NULL, 9962, 11),
(274466, NULL, 'PIRSF500231', NULL, NULL, NULL, NULL, 'Oat_dag', NULL, NULL, 24693, 11),
(274467, NULL, 'PIRSF036558', NULL, NULL, NULL, NULL, 'Ntrrd_NNDBI_PRT', NULL, NULL, 7339, 11),
(274468, NULL, 'PIRSF017085', NULL, NULL, NULL, NULL, 'Glycosyltransf_RedA', NULL, NULL, 20386, 11),
(274469, NULL, 'PIRSF029938', NULL, NULL, NULL, NULL, 'UCP029938', NULL, NULL, 10502, 11),
(274470, NULL, 'PIRSF005894', NULL, NULL, NULL, NULL, 'Monothiol_GRX', NULL, NULL, 7547, 11),
(274471, NULL, 'PIRSF022995', NULL, NULL, NULL, NULL, 'ROP2', NULL, NULL, 15371, 11),
(274472, NULL, 'PIRSF001363', NULL, NULL, NULL, NULL, 'Malate_synth', NULL, NULL, 3851, 11),
(274473, NULL, 'PIRSF000563', NULL, NULL, NULL, NULL, 'Homeobox_Pitx/Unc30', NULL, NULL, 17335, 11),
(274474, NULL, 'PIRSF038119', NULL, NULL, NULL, NULL, 'NUP53', NULL, NULL, 18446, 11),
(274475, NULL, 'PIRSF029611', NULL, NULL, NULL, NULL, 'UCP029611', NULL, NULL, 17479, 11),
(274476, NULL, 'PIRSF028841', NULL, NULL, NULL, NULL, 'APC10', NULL, NULL, 17362, 11),
(274477, NULL, 'PIRSF017184', NULL, NULL, NULL, NULL, 'Nnr', NULL, NULL, 26051, 11),
(274478, NULL, 'PIRSF037825', NULL, NULL, NULL, NULL, 'GMP-Pdiesterase_delta', NULL, NULL, 16423, 11),
(274479, NULL, 'PIRSF005700', NULL, NULL, NULL, NULL, 'PepC', NULL, NULL, 2919, 11),
(274480, NULL, 'PIRSF002736', NULL, NULL, NULL, NULL, 'Citrt_lyas_gamma', NULL, NULL, 6211, 11),
(274481, NULL, 'PIRSF500720', NULL, NULL, NULL, NULL, 'TEF-5', NULL, NULL, 24883, 11),
(274482, NULL, 'PIRSF009292', NULL, NULL, NULL, NULL, 'BLIP', NULL, NULL, 7560, 11),
(274483, NULL, 'PIRSF037394', NULL, NULL, NULL, NULL, 'ABC_permease_YkoE', NULL, NULL, 21301, 11),
(274484, NULL, 'PIRSF029254', NULL, NULL, NULL, NULL, 'MutS_C_archaeal', NULL, NULL, 13388, 11),
(274485, NULL, 'PIRSF003496', NULL, NULL, NULL, NULL, 'Myristoylat_tegument_UL11', NULL, NULL, 21122, 11),
(274486, NULL, 'PIRSF037497', NULL, NULL, NULL, NULL, 'MreD_Clostridium/Treponema', NULL, NULL, 15194, 11),
(274487, NULL, 'PIRSF037726', NULL, NULL, NULL, NULL, 'IL-22', NULL, NULL, 19682, 11),
(274488, NULL, 'PIRSF032899', NULL, NULL, NULL, NULL, 'UCP032899', NULL, NULL, 18794, 11),
(274489, NULL, 'PIRSF036458', NULL, NULL, NULL, NULL, 'Butyrate_kin', NULL, NULL, 10655, 11);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(274490, NULL, 'PIRSF000995', NULL, NULL, NULL, NULL, 'RE_EcoRV', NULL, NULL, 20560, 11),
(274491, NULL, 'PIRSF000556', NULL, NULL, NULL, NULL, 'MAPKKK9_MAPKKK10_MAPKKK11', NULL, NULL, 17437, 11),
(274492, NULL, 'PIRSF018296', NULL, NULL, NULL, NULL, 'Format_dh_formtn_FdhE', NULL, NULL, 6997, 11),
(274493, NULL, 'PIRSF000489', NULL, NULL, NULL, NULL, 'NAD_ADPRT', NULL, NULL, 8869, 11),
(274494, NULL, 'PIRSF004440', NULL, NULL, NULL, NULL, 'GpP', NULL, NULL, 24556, 11),
(274495, NULL, 'PIRSF037113', NULL, NULL, NULL, NULL, 'Yin_yang', NULL, NULL, 20383, 11),
(274496, NULL, 'PIRSF001338', NULL, NULL, NULL, NULL, 'AIR_carboxylase', NULL, NULL, 9724, 11),
(274497, NULL, 'PIRSF003267', NULL, NULL, NULL, NULL, 'TraJ_F', NULL, NULL, 21250, 11),
(274498, NULL, 'PIRSF037109', NULL, NULL, NULL, NULL, 'Hox9', NULL, NULL, 20489, 11),
(274499, NULL, 'PIRSF001109', NULL, NULL, NULL, NULL, 'SAHH', NULL, NULL, 3741, 11),
(274500, NULL, 'PIRSF037880', NULL, NULL, NULL, NULL, 'Parkin', NULL, NULL, 7240, 11),
(274501, NULL, 'PIRSF000724', NULL, NULL, NULL, NULL, 'Pgk', NULL, NULL, 5397, 11),
(274502, NULL, 'PIRSF017565', NULL, NULL, NULL, NULL, 'Kin_ATP-NAD_euk', NULL, NULL, 12646, 11),
(274503, NULL, 'PIRSF027081', NULL, NULL, NULL, NULL, 'RPP29', NULL, NULL, 16159, 11),
(274504, NULL, 'PIRSF038172', NULL, NULL, NULL, NULL, 'MAPKKKK', NULL, NULL, 1919, 11),
(274505, NULL, 'PIRSF001892', NULL, NULL, NULL, NULL, 'CyaE', NULL, NULL, 26542, 11),
(274506, NULL, 'PIRSF001554', NULL, NULL, NULL, NULL, 'SucCS_beta', NULL, NULL, 5660, 11),
(274507, NULL, 'PIRSF037167', NULL, NULL, NULL, NULL, 'Mtase_YfcB', NULL, NULL, 20730, 11),
(274508, NULL, 'PIRSF033725', NULL, NULL, NULL, NULL, 'UCP033725', NULL, NULL, 18709, 11),
(274509, NULL, 'PIRSF036685', NULL, NULL, NULL, NULL, 'BacLeuNPeptidase', NULL, NULL, 12994, 11),
(274510, NULL, 'PIRSF038093', NULL, NULL, NULL, NULL, 'ARPC1', NULL, NULL, 18213, 11),
(274511, NULL, 'PIRSF036946', NULL, NULL, NULL, NULL, 'Arg_N-mtase', NULL, NULL, 8495, 11),
(274512, NULL, 'PIRSF012755', NULL, NULL, NULL, NULL, 'UCP012755', NULL, NULL, 19242, 11),
(274513, NULL, 'PIRSF038146', NULL, NULL, NULL, NULL, 'STPK_RIO3', NULL, NULL, 18006, 11),
(274514, NULL, 'PIRSF002984', NULL, NULL, NULL, NULL, 'Opacity_prot', NULL, NULL, 20494, 11),
(274515, NULL, 'PIRSF037870', NULL, NULL, NULL, NULL, 'Doublin', NULL, NULL, 16939, 11),
(274516, NULL, 'PIRSF005096', NULL, NULL, NULL, NULL, 'GALM', NULL, NULL, 8999, 11),
(274517, NULL, 'PIRSF035261', NULL, NULL, NULL, NULL, 'UCP035261', NULL, NULL, 18905, 11),
(274518, NULL, 'PIRSF018774', NULL, NULL, NULL, NULL, 'GOGAT_lg_dom1', NULL, NULL, 13489, 11),
(274519, NULL, 'PIRSF037666', NULL, NULL, NULL, NULL, 'GerPD', NULL, NULL, 15536, 11),
(274520, NULL, 'PIRSF038085', NULL, NULL, NULL, NULL, 'ChM-II', NULL, NULL, 18110, 11),
(274521, NULL, 'PIRSF009445', NULL, NULL, NULL, NULL, 'Cyc_PG_syn', NULL, NULL, 17867, 11),
(274522, NULL, 'PIRSF036522', NULL, NULL, NULL, NULL, 'UCP036522_pph', NULL, NULL, 10407, 11),
(274523, NULL, 'PIRSF038075', NULL, NULL, NULL, NULL, 'Env_UL49A', NULL, NULL, 17908, 11),
(274524, NULL, 'PIRSF001222', NULL, NULL, NULL, NULL, 'Urease', NULL, NULL, 512, 11),
(274525, NULL, 'PIRSF015921', NULL, NULL, NULL, NULL, 'FA_sphingolip_des', NULL, NULL, 7200, 11),
(274526, NULL, 'PIRSF021980', NULL, NULL, NULL, NULL, 'UCP021980_RNA-bind', NULL, NULL, 15158, 11),
(274527, NULL, 'PIRSF000865', NULL, NULL, NULL, NULL, 'LPL_LIPH', NULL, NULL, 19651, 11),
(274528, NULL, 'PIRSF019711', NULL, NULL, NULL, NULL, 'Memb_prtease_arc', NULL, NULL, 21302, 11),
(274529, NULL, 'PIRSF022613', NULL, NULL, NULL, NULL, 'MBA1', NULL, NULL, 11962, 11),
(274530, NULL, 'PIRSF035905', NULL, NULL, NULL, NULL, 'UCP035905_mp', NULL, NULL, 8405, 11),
(274531, NULL, 'PIRSF007939', NULL, NULL, NULL, NULL, 'RRN6', NULL, NULL, 16309, 11),
(274532, NULL, 'PIRSF003182', NULL, NULL, NULL, NULL, 'HK_hybr_ArcB', NULL, NULL, 7690, 11),
(274533, NULL, 'PIRSF005632', NULL, NULL, NULL, NULL, 'Met_synth_catalytic', NULL, NULL, 15215, 11),
(274534, NULL, 'PIRSF002549', NULL, NULL, NULL, NULL, 'Transferrin', NULL, NULL, 20472, 11);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(274535, NULL, 'PIRSF000903', NULL, NULL, NULL, NULL, 'B5n-ttraPtase_sm', NULL, NULL, 2296, 11),
(274536, NULL, 'PIRSF016522', NULL, NULL, NULL, NULL, 'MOG', NULL, NULL, 20159, 11),
(274537, NULL, 'PIRSF036426', NULL, NULL, NULL, NULL, 'Sirohaem_synth', NULL, NULL, 13215, 11),
(274538, NULL, 'PIRSF000926', NULL, NULL, NULL, NULL, 'PTPN1_PTPN2', NULL, NULL, 12171, 11),
(274539, NULL, 'PIRSF039102', NULL, NULL, NULL, NULL, 'Ddl/VanB', NULL, NULL, 487, 11),
(274540, NULL, 'PIRSF015380', NULL, NULL, NULL, NULL, 'Site-sp_rcmb', NULL, NULL, 14691, 11),
(274541, NULL, 'PIRSF017632', NULL, NULL, NULL, NULL, 'Ceramidase', NULL, NULL, 20421, 11),
(274542, NULL, 'PIRSF022536', NULL, NULL, NULL, NULL, 'A612L_SET', NULL, NULL, 10479, 11),
(274543, NULL, 'PIRSF038207', NULL, NULL, NULL, NULL, 'PP1_GT_animal', NULL, NULL, 18956, 11),
(274544, NULL, 'PIRSF009416', NULL, NULL, NULL, NULL, 'LuxD', NULL, NULL, 1549, 11),
(274545, NULL, 'PIRSF003716', NULL, NULL, NULL, NULL, 'VAC_F3L', NULL, NULL, 13139, 11),
(274546, NULL, 'PIRSF017107', NULL, NULL, NULL, NULL, 'MAAL', NULL, NULL, 5706, 11),
(274547, NULL, 'PIRSF015952', NULL, NULL, NULL, NULL, 'U3snoRNP11', NULL, NULL, 162, 11),
(274548, NULL, 'PIRSF020588', NULL, NULL, NULL, NULL, 'Flk', NULL, NULL, 16252, 11),
(274549, NULL, 'PIRSF033303', NULL, NULL, NULL, NULL, 'UCP033303', NULL, NULL, 8205, 11),
(274550, NULL, 'PIRSF003960', NULL, NULL, NULL, NULL, 'M_poly_TospoV', NULL, NULL, 7832, 11),
(274551, NULL, 'PIRSF005727', NULL, NULL, NULL, NULL, 'Beta-COP', NULL, NULL, 15112, 11),
(274552, NULL, 'PIRSF004866', NULL, NULL, NULL, NULL, 'IMP_cclhdr_arch', NULL, NULL, 4180, 11),
(274553, NULL, 'PIRSF036950', NULL, NULL, NULL, NULL, 'UCP036950', NULL, NULL, 8139, 11),
(274554, NULL, 'PIRSF037656', NULL, NULL, NULL, NULL, 'UCP037656_ESAT_EsxN', NULL, NULL, 8323, 11),
(274555, NULL, 'PIRSF004764', NULL, NULL, NULL, NULL, 'YmfJ', NULL, NULL, 7534, 11),
(274556, NULL, 'PIRSF005215', NULL, NULL, NULL, NULL, 'TehB', NULL, NULL, 7512, 11),
(274557, NULL, 'PIRSF036688', NULL, NULL, NULL, NULL, 'CmuA', NULL, NULL, 10176, 11),
(274558, NULL, 'PIRSF006232', NULL, NULL, NULL, NULL, 'Pirin', NULL, NULL, 12696, 11),
(274559, NULL, 'PIRSF029703', NULL, NULL, NULL, NULL, 'Mig-14', NULL, NULL, 8305, 11),
(274560, NULL, 'PIRSF501104', NULL, NULL, NULL, NULL, 'Protein_kin_C_delta', NULL, NULL, 22467, 11),
(274561, NULL, 'PIRSF011474', NULL, NULL, NULL, NULL, 'GutM', NULL, NULL, 11730, 11),
(274562, NULL, 'PIRSF009360', NULL, NULL, NULL, NULL, 'UCP009360', NULL, NULL, 12955, 11),
(274563, NULL, 'PIRSF019364', NULL, NULL, NULL, NULL, 'RapGH', NULL, NULL, 21244, 11),
(274564, NULL, 'PIRSF002490', NULL, NULL, NULL, NULL, 'SLRP_I', NULL, NULL, 20412, 11),
(274565, NULL, 'PIRSF025926', NULL, NULL, NULL, NULL, 'UCP025926', NULL, NULL, 16015, 11),
(274566, NULL, 'PIRSF002882', NULL, NULL, NULL, NULL, 'VapD', NULL, NULL, 20082, 11),
(274567, NULL, 'PIRSF036535', NULL, NULL, NULL, NULL, 'EhaE', NULL, NULL, 10326, 11),
(274568, NULL, 'PIRSF037052', NULL, NULL, NULL, NULL, 'UCP037052', NULL, NULL, 20137, 11),
(274569, NULL, 'PIRSF037919', NULL, NULL, NULL, NULL, 'HDAC_II_yeast', NULL, NULL, 17389, 11),
(274570, NULL, 'PIRSF001948', NULL, NULL, NULL, NULL, 'MCSF', NULL, NULL, 4075, 11),
(274571, NULL, 'PIRSF004485', NULL, NULL, NULL, NULL, 'T7_18-5', NULL, NULL, 21391, 11),
(274572, NULL, 'PIRSF004960', NULL, NULL, NULL, NULL, 'MtrH_MtxH', NULL, NULL, 16238, 11),
(274573, NULL, 'PIRSF001327', NULL, NULL, NULL, NULL, 'ArsAB_ATPase', NULL, NULL, 26564, 11),
(274574, NULL, 'PIRSF037895', NULL, NULL, NULL, NULL, 'Subtilisin_rel_Sama_2696', NULL, NULL, 16520, 11),
(274575, NULL, 'PIRSF028774', NULL, NULL, NULL, NULL, 'UCP028774', NULL, NULL, 10893, 11),
(274576, NULL, 'PIRSF501032', NULL, NULL, NULL, NULL, 'C-ets-2', NULL, NULL, 25326, 11),
(274577, NULL, 'PIRSF006298', NULL, NULL, NULL, NULL, 'GtrA', NULL, NULL, 15062, 11),
(274578, NULL, 'PIRSF038071', NULL, NULL, NULL, NULL, 'GFR-alpha', NULL, NULL, 17541, 11),
(274579, NULL, 'PIRSF501176', NULL, NULL, NULL, NULL, 'DNApol_mu', NULL, NULL, 24539, 11);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(274580, NULL, 'PIRSF006425', NULL, NULL, NULL, NULL, 'UCP006425_WD40', NULL, NULL, 7593, 11),
(274581, NULL, 'PIRSF038959', NULL, NULL, NULL, NULL, 'SdpI', NULL, NULL, 24982, 11),
(274582, NULL, 'PIRSF017901', NULL, NULL, NULL, NULL, 'GCL', NULL, NULL, 29799, 11),
(274583, NULL, 'PIRSF028980', NULL, NULL, NULL, NULL, 'tRNAHis_guanlltr', NULL, NULL, 10518, 11),
(274584, NULL, 'PIRSF000296', NULL, NULL, NULL, NULL, 'SrpA', NULL, NULL, 12926, 11),
(274585, NULL, 'PIRSF011794', NULL, NULL, NULL, NULL, 'Rhamnogalacturonase_B', NULL, NULL, 17900, 11),
(274586, NULL, 'PIRSF000183', NULL, NULL, NULL, NULL, 'Alanine_dh', NULL, NULL, 7396, 11),
(274587, NULL, 'PIRSF038800', NULL, NULL, NULL, NULL, 'KYNU', NULL, NULL, 2098, 11),
(274588, NULL, 'PIRSF026326', NULL, NULL, NULL, NULL, 'InaA', NULL, NULL, 25866, 11),
(274589, NULL, 'PIRSF020738', NULL, NULL, NULL, NULL, 'InvJ', NULL, NULL, 6401, 11),
(274590, NULL, 'PIRSF037217', NULL, NULL, NULL, NULL, 'Carboxypeptdase_S', NULL, NULL, 20904, 11),
(274591, NULL, 'PIRSF000383', NULL, NULL, NULL, NULL, 'PEAMT', NULL, NULL, 17233, 11),
(274592, NULL, 'PIRSF017811', NULL, NULL, NULL, NULL, 'CKI_KRP_plant', NULL, NULL, 35002, 11),
(274593, NULL, 'PIRSF037548', NULL, NULL, NULL, NULL, 'L_Filoviridae', NULL, NULL, 15233, 11),
(274594, NULL, 'PIRSF001787', NULL, NULL, NULL, NULL, 'TGF-beta', NULL, NULL, 20172, 11),
(274595, NULL, 'PIRSF037579', NULL, NULL, NULL, NULL, 'MAPKK_SSK22', NULL, NULL, 15401, 11),
(274596, NULL, 'PIRSF000337', NULL, NULL, NULL, NULL, 'NTA_MOA', NULL, NULL, 17236, 11),
(274597, NULL, 'PIRSF028103', NULL, NULL, NULL, NULL, 'GcvR', NULL, NULL, 16101, 11),
(274598, NULL, 'PIRSF000799', NULL, NULL, NULL, NULL, 'DNA_pol_epsilon_2', NULL, NULL, 19598, 11),
(274599, NULL, 'PIRSF037850', NULL, NULL, NULL, NULL, 'Subtilase_Euglen', NULL, NULL, 16935, 11),
(274600, NULL, 'PIRSF009533', NULL, NULL, NULL, NULL, 'FlbT', NULL, NULL, 8159, 11),
(274601, NULL, 'PIRSF003377', NULL, NULL, NULL, NULL, 'VP2_VP3_PPV', NULL, NULL, 1250, 11),
(274602, NULL, 'PIRSF008153', NULL, NULL, NULL, NULL, 'CYFIP', NULL, NULL, 6304, 11),
(274603, NULL, 'PIRSF500103', NULL, NULL, NULL, NULL, 'EndoV', NULL, NULL, 15216, 11),
(274604, NULL, 'PIRSF037947', NULL, NULL, NULL, NULL, 'XRP2', NULL, NULL, 8038, 11),
(274605, NULL, 'PIRSF029122', NULL, NULL, NULL, NULL, 'UCP029122', NULL, NULL, 8308, 11),
(274606, NULL, 'PIRSF005412', NULL, NULL, NULL, NULL, 'UCP005412_abhydr', NULL, NULL, 15257, 11),
(274607, NULL, 'PIRSF037035', NULL, NULL, NULL, NULL, 'StpC', NULL, NULL, 19952, 11),
(274608, NULL, 'PIRSF036516', NULL, NULL, NULL, NULL, 'CDT_A', NULL, NULL, 8219, 11),
(274609, NULL, 'PIRSF006625', NULL, NULL, NULL, NULL, 'KduI', NULL, NULL, 6661, 11),
(274610, NULL, 'PIRSF027352', NULL, NULL, NULL, NULL, 'ERp29', NULL, NULL, 16281, 11),
(274611, NULL, 'PIRSF000389', NULL, NULL, NULL, NULL, 'DHFR-TS', NULL, NULL, 11620, 11),
(274612, NULL, 'PIRSF036767', NULL, NULL, NULL, NULL, 'ASM-like_Pdiesterase', NULL, NULL, 19852, 11),
(274613, NULL, 'PIRSF025414', NULL, NULL, NULL, NULL, 'Alpha-N-AFase', NULL, NULL, 15300, 11),
(274614, NULL, 'PIRSF013171', NULL, NULL, NULL, NULL, 'Pur_nuclsid_perm', NULL, NULL, 9034, 11),
(274615, NULL, 'PIRSF009393', NULL, NULL, NULL, NULL, 'Orn_decarb', NULL, NULL, 10867, 11),
(274616, NULL, 'PIRSF037227', NULL, NULL, NULL, NULL, 'AbgB', NULL, NULL, 20919, 11),
(274617, NULL, 'PIRSF000547', NULL, NULL, NULL, NULL, 'Prot_kinase_T7', NULL, NULL, 12141, 11),
(274618, NULL, 'PIRSF000727', NULL, NULL, NULL, NULL, 'ThrA', NULL, NULL, 10436, 11),
(274619, NULL, 'PIRSF029594', NULL, NULL, NULL, NULL, 'UCP029594', NULL, NULL, 17203, 11),
(274620, NULL, 'PIRSF036888', NULL, NULL, NULL, NULL, 'HDGYPm_UCP036888', NULL, NULL, 9550, 11),
(274621, NULL, 'PIRSF021290', NULL, NULL, NULL, NULL, 'UCP021290', NULL, NULL, 9925, 11),
(274622, NULL, 'PIRSF006630', NULL, NULL, NULL, NULL, 'NADS_GAT', NULL, NULL, 9881, 11),
(274623, NULL, 'PIRSF026649', NULL, NULL, NULL, NULL, 'MsbB', NULL, NULL, 2780, 11),
(274624, NULL, 'PIRSF038131', NULL, NULL, NULL, NULL, 'CX5C1', NULL, NULL, 8953, 11);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(274625, NULL, 'PIRSF036525', NULL, NULL, NULL, NULL, 'CobF', NULL, NULL, 11586, 11),
(274626, NULL, 'PIRSF017267', NULL, NULL, NULL, NULL, 'Sulfiredoxin', NULL, NULL, 20272, 11),
(274627, NULL, 'PIRSF000747', NULL, NULL, NULL, NULL, 'RPB5', NULL, NULL, 12210, 11),
(274628, NULL, 'PIRSF031551', NULL, NULL, NULL, NULL, 'UCP031551', NULL, NULL, 8612, 11),
(274629, NULL, 'PIRSF011368', NULL, NULL, NULL, NULL, 'LPP20', NULL, NULL, 74, 11),
(274630, NULL, 'PIRSF004491', NULL, NULL, NULL, NULL, 'RibF_RibC', NULL, NULL, 1522, 11),
(274631, NULL, 'PIRSF004982', NULL, NULL, NULL, NULL, 'SlP', NULL, NULL, 2884, 11),
(274632, NULL, 'PIRSF038025', NULL, NULL, NULL, NULL, 'PTEN', NULL, NULL, 17523, 11),
(274633, NULL, 'PIRSF027158', NULL, NULL, NULL, NULL, 'Lys_MTase_YDR198C', NULL, NULL, 16500, 11),
(274634, NULL, 'PIRSF022280', NULL, NULL, NULL, NULL, 'UCP022280', NULL, NULL, 15033, 11),
(274635, NULL, 'PIRSF004348', NULL, NULL, NULL, NULL, 'RNA_pol_inhibit', NULL, NULL, 21160, 11),
(274636, NULL, 'PIRSF035609', NULL, NULL, NULL, NULL, 'UCP035609_HNH_endo', NULL, NULL, 18605, 11),
(274637, NULL, 'PIRSF004611', NULL, NULL, NULL, NULL, 'CBP2', NULL, NULL, 21231, 11),
(274638, NULL, 'PIRSF013899', NULL, NULL, NULL, NULL, 'UCP013899', NULL, NULL, 19473, 11),
(274639, NULL, 'PIRSF010052', NULL, NULL, NULL, NULL, 'Polyub_prc_Npl4', NULL, NULL, 17818, 11),
(274640, NULL, 'PIRSF015892', NULL, NULL, NULL, NULL, 'N-myristl_transf', NULL, NULL, 3351, 11),
(274641, NULL, 'PIRSF016702', NULL, NULL, NULL, NULL, 'DNA_bp_PD1', NULL, NULL, 26033, 11),
(274642, NULL, 'PIRSF016477', NULL, NULL, NULL, NULL, 'Prefoldin_4', NULL, NULL, 20370, 11),
(274643, NULL, 'PIRSF036638', NULL, NULL, NULL, NULL, 'M_m6A_StsI', NULL, NULL, 12876, 11),
(274644, NULL, 'PIRSF008130', NULL, NULL, NULL, NULL, 'UCP008130', NULL, NULL, 8566, 11),
(274645, NULL, 'PIRSF037514', NULL, NULL, NULL, NULL, 'Rab_ger_ger_transf_A_fungal', NULL, NULL, 15180, 11),
(274646, NULL, 'PIRSF000141', NULL, NULL, NULL, NULL, 'Anaerobic_G3P_dh', NULL, NULL, 9827, 11),
(274647, NULL, 'PIRSF005642', NULL, NULL, NULL, NULL, 'UCP005642', NULL, NULL, 10608, 11),
(274648, NULL, 'PIRSF018454', NULL, NULL, NULL, NULL, 'TRL10', NULL, NULL, 13953, 11),
(274649, NULL, 'PIRSF003575', NULL, NULL, NULL, NULL, 'MSA-2', NULL, NULL, 1578, 11),
(274650, NULL, 'PIRSF020906', NULL, NULL, NULL, NULL, 'Anti_s_fact_PmgA', NULL, NULL, 15392, 11),
(274651, NULL, 'PIRSF037631', NULL, NULL, NULL, NULL, 'Snapin', NULL, NULL, 15783, 11),
(274652, NULL, 'PIRSF029904', NULL, NULL, NULL, NULL, 'UCP029904_pph', NULL, NULL, 12599, 11),
(274653, NULL, 'PIRSF028570', NULL, NULL, NULL, NULL, 'UCP028570', NULL, NULL, 16824, 11),
(274654, NULL, 'PIRSF006031', NULL, NULL, NULL, NULL, 'UCP006031', NULL, NULL, 825, 11),
(274655, NULL, 'PIRSF036555', NULL, NULL, NULL, NULL, 'SUMT_yeast', NULL, NULL, 12269, 11),
(274656, NULL, 'PIRSF000460', NULL, NULL, NULL, NULL, 'Glucan_phosphorylase_GlgP', NULL, NULL, 4517, 11),
(274657, NULL, 'PIRSF005859', NULL, NULL, NULL, NULL, 'PBR', NULL, NULL, 4649, 11),
(274658, NULL, 'PIRSF014972', NULL, NULL, NULL, NULL, 'FlK', NULL, NULL, 24141, 11),
(274659, NULL, 'PIRSF006621', NULL, NULL, NULL, NULL, 'Dus', NULL, NULL, 226, 11),
(274660, NULL, 'PIRSF000827', NULL, NULL, NULL, NULL, 'RdRPol_OMV', NULL, NULL, 3385, 11),
(274661, NULL, 'PIRSF032126', NULL, NULL, NULL, NULL, 'F0F1_ATP_synth_I', NULL, NULL, 18907, 11),
(274662, NULL, 'PIRSF015797', NULL, NULL, NULL, NULL, 'Virion_core', NULL, NULL, 10159, 11),
(274663, NULL, 'PIRSF001227', NULL, NULL, NULL, NULL, 'Pen_acylase', NULL, NULL, 7205, 11),
(274664, NULL, 'PIRSF019635', NULL, NULL, NULL, NULL, 'Cytochrome_b245_alpha', NULL, NULL, 1155, 11),
(274665, NULL, 'PIRSF030837', NULL, NULL, NULL, NULL, 'TerW', NULL, NULL, 10646, 11),
(274666, NULL, 'PIRSF000243', NULL, NULL, NULL, NULL, 'NrfA', NULL, NULL, 4438, 11),
(274667, NULL, 'PIRSF007828', NULL, NULL, NULL, NULL, 'Dipeptidyl-peptidase_III', NULL, NULL, 5115, 11),
(274668, NULL, 'PIRSF007138', NULL, NULL, NULL, NULL, 'FIG1', NULL, NULL, 16055, 11),
(274669, NULL, 'PIRSF008502', NULL, NULL, NULL, NULL, 'UCP008502', NULL, NULL, 8832, 11);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(274670, NULL, 'PIRSF039089', NULL, NULL, NULL, NULL, 'ATP_synthase_gamma', NULL, NULL, NULL, 11),
(274671, NULL, 'PIRSF001149', NULL, NULL, NULL, NULL, 'Thrombin', NULL, NULL, 7277, 11),
(274672, NULL, 'PIRSF005943', NULL, NULL, NULL, NULL, 'NMPRT', NULL, NULL, 15118, 11),
(274673, NULL, 'PIRSF037638', NULL, NULL, NULL, NULL, 'B144_protein', NULL, NULL, 1304, 11),
(274674, NULL, 'PIRSF005546', NULL, NULL, NULL, NULL, 'Ifb-2', NULL, NULL, 15170, 11),
(274675, NULL, 'PIRSF005604', NULL, NULL, NULL, NULL, 'EndGlu_transf', NULL, NULL, 15413, 11),
(274676, NULL, 'PIRSF016128', NULL, NULL, NULL, NULL, 'UCP016128', NULL, NULL, 9155, 11),
(274677, NULL, 'PIRSF029691', NULL, NULL, NULL, NULL, 'UCP029691', NULL, NULL, 17402, 11),
(274678, NULL, 'PIRSF004976', NULL, NULL, NULL, NULL, 'ATPase_YdaO', NULL, NULL, 8018, 11),
(274679, NULL, 'PIRSF026509', NULL, NULL, NULL, NULL, 'UCP026509', NULL, NULL, 7343, 11),
(274680, NULL, 'PIRSF036446', NULL, NULL, NULL, NULL, 'Phosphoesterase_HI0762', NULL, NULL, 19637, 11),
(274681, NULL, 'PIRSF006593', NULL, NULL, NULL, NULL, 'UCP006593', NULL, NULL, 8223, 11),
(274682, NULL, 'PIRSF007991', NULL, NULL, NULL, NULL, 'Vang-like', NULL, NULL, 10463, 11),
(274683, NULL, 'PIRSF000463', NULL, NULL, NULL, NULL, 'GlgB', NULL, NULL, 27484, 11),
(274684, NULL, 'PIRSF003268', NULL, NULL, NULL, NULL, 'TraJ_R1', NULL, NULL, 21123, 11),
(274685, NULL, 'PIRSF020623', NULL, NULL, NULL, NULL, 'PaaX', NULL, NULL, 11418, 11),
(274686, NULL, 'PIRSF033239', NULL, NULL, NULL, NULL, 'ExoD', NULL, NULL, 8980, 11),
(274687, NULL, 'PIRSF000156', NULL, NULL, NULL, NULL, 'Pyruvate_dh_E1', NULL, NULL, 2846, 11),
(274688, NULL, 'PIRSF037099', NULL, NULL, NULL, NULL, 'Stonin', NULL, NULL, 20018, 11),
(274689, NULL, 'PIRSF032840', NULL, NULL, NULL, NULL, 'UCP032840', NULL, NULL, 18588, 11),
(274690, NULL, 'PIRSF005647', NULL, NULL, NULL, NULL, 'CooC', NULL, NULL, 7867, 11),
(274691, NULL, 'PIRSF007542', NULL, NULL, NULL, NULL, 'UCP007542', NULL, NULL, 10719, 11),
(274692, NULL, 'PIRSF026802', NULL, NULL, NULL, NULL, 'UCP026802', NULL, NULL, 5689, 11),
(274693, NULL, 'PIRSF000124', NULL, NULL, NULL, NULL, 'UDPglc_GDPman_dh', NULL, NULL, 20538, 11),
(274694, NULL, 'PIRSF014753', NULL, NULL, NULL, NULL, 'UCP014753', NULL, NULL, 19358, 11),
(274695, NULL, 'PIRSF001225', NULL, NULL, NULL, NULL, 'Urease_gammabeta', NULL, NULL, 973, 11),
(274696, NULL, 'PIRSF037599', NULL, NULL, NULL, NULL, 'GDPMH', NULL, NULL, 30079, 11),
(274697, NULL, 'PIRSF038973', NULL, NULL, NULL, NULL, 'SpoIIM', NULL, NULL, 8652, 11),
(274698, NULL, 'PIRSF006549', NULL, NULL, NULL, NULL, 'PDH_arog_dh_reg', NULL, NULL, 8888, 11),
(274699, NULL, 'PIRSF001359', NULL, NULL, NULL, NULL, 'F_bP_aldolase_II', NULL, NULL, 6927, 11),
(274700, NULL, 'PIRSF002094', NULL, NULL, NULL, NULL, 'OMP26_Skp', NULL, NULL, 2735, 11),
(274701, NULL, 'PIRSF010260', NULL, NULL, NULL, NULL, 'UCP010260', NULL, NULL, 9567, 11),
(274702, NULL, 'PIRSF003956', NULL, NULL, NULL, NULL, 'NS-S_PhleboV', NULL, NULL, 22128, 11),
(274703, NULL, 'PIRSF016988', NULL, NULL, NULL, NULL, 'UCP016988', NULL, NULL, 11312, 11),
(274704, NULL, 'PIRSF028754', NULL, NULL, NULL, NULL, 'UCP028754', NULL, NULL, 12259, 11),
(274705, NULL, 'PIRSF001789', NULL, NULL, NULL, NULL, 'NGFB', NULL, NULL, 18556, 11),
(274706, NULL, 'PIRSF036881', NULL, NULL, NULL, NULL, 'PAT', NULL, NULL, 4523, 11),
(274707, NULL, 'PIRSF016817', NULL, NULL, NULL, NULL, 'UCP016817_carboligase', NULL, NULL, 20050, 11),
(274708, NULL, 'PIRSF501175', NULL, NULL, NULL, NULL, 'TDT', NULL, NULL, 23037, 11),
(274709, NULL, 'PIRSF020370', NULL, NULL, NULL, NULL, 'Oms28', NULL, NULL, 89, 11),
(274710, NULL, 'PIRSF002825', NULL, NULL, NULL, NULL, 'CfbpA', NULL, NULL, 21823, 11),
(274711, NULL, 'PIRSF037081', NULL, NULL, NULL, NULL, 'P-loop_All4644', NULL, NULL, 20243, 11),
(274712, NULL, 'PIRSF016302', NULL, NULL, NULL, NULL, 'Man_a_manosd', NULL, NULL, 9831, 11),
(274713, NULL, 'PIRSF000882', NULL, NULL, NULL, NULL, 'DSB_repair_MRE11', NULL, NULL, 2444, 11),
(274714, NULL, 'PIRSF006247', NULL, NULL, NULL, NULL, 'TrkH', NULL, NULL, 5212, 11);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(274715, NULL, 'PIRSF004884', NULL, NULL, NULL, NULL, 'Sugar_kin_arch', NULL, NULL, 7096, 11),
(274716, NULL, 'PIRSF000550', NULL, NULL, NULL, NULL, 'PKC_alpha', NULL, NULL, 12324, 11),
(274717, NULL, 'PIRSF019625', NULL, NULL, NULL, NULL, 'EVI2A', NULL, NULL, 14277, 11),
(274718, NULL, 'PIRSF001882', NULL, NULL, NULL, NULL, 'Insect_neurot_curtatoxin', NULL, NULL, 20157, 11),
(274719, NULL, 'PIRSF016557', NULL, NULL, NULL, NULL, 'CpsB', NULL, NULL, 20378, 11),
(274720, NULL, 'PIRSF037322', NULL, NULL, NULL, NULL, 'CDKN3', NULL, NULL, 8891, 11),
(274721, NULL, 'PIRSF000047', NULL, NULL, NULL, NULL, 'Cytochrome_CYPVIIA1', NULL, NULL, 13703, 11),
(274722, NULL, 'PIRSF006380', NULL, NULL, NULL, NULL, 'UCP006380', NULL, NULL, 4738, 11),
(274723, NULL, 'PIRSF017570', NULL, NULL, NULL, NULL, 'H3K79_H-MTase_fungal', NULL, NULL, 15436, 11),
(274724, NULL, 'PIRSF001100', NULL, NULL, NULL, NULL, 'Cellulase', NULL, NULL, 19678, 11),
(274725, NULL, 'PIRSF000941', NULL, NULL, NULL, NULL, 'DUSP12', NULL, NULL, 19540, 11),
(274726, NULL, 'PIRSF036456', NULL, NULL, NULL, NULL, 'ASAL_AGS', NULL, NULL, 10599, 11),
(274727, NULL, 'PIRSF000232', NULL, NULL, NULL, NULL, 'YdjA', NULL, NULL, 24580, 11),
(274728, NULL, 'PIRSF026584', NULL, NULL, NULL, NULL, 'Delta_tox', NULL, NULL, 10954, 11),
(274729, NULL, 'PIRSF032620', NULL, NULL, NULL, NULL, 'UCP032620', NULL, NULL, 8228, 11),
(274730, NULL, 'PIRSF022057', NULL, NULL, NULL, NULL, 'UCP022057', NULL, NULL, 11284, 11),
(274731, NULL, 'PIRSF029163', NULL, NULL, NULL, NULL, 'MDH2', NULL, NULL, 5211, 11),
(274732, NULL, 'PIRSF006581', NULL, NULL, NULL, NULL, 'EhaD', NULL, NULL, 10329, 11),
(274733, NULL, 'PIRSF006607', NULL, NULL, NULL, NULL, 'RNAmts_UCP006607', NULL, NULL, 15337, 11),
(274734, NULL, 'PIRSF038018', NULL, NULL, NULL, NULL, 'BIO', NULL, NULL, 10181, 11),
(274735, NULL, 'PIRSF016070', NULL, NULL, NULL, NULL, 'Vir_PGP3-D_Chlamydiae', NULL, NULL, 8860, 11),
(274736, NULL, 'PIRSF018005', NULL, NULL, NULL, NULL, 'UCP018005', NULL, NULL, 19460, 11),
(274737, NULL, 'PIRSF037682', NULL, NULL, NULL, NULL, 'Saliv_gland_allergen_Aed3', NULL, NULL, 16224, 11),
(274738, NULL, 'PIRSF000190', NULL, NULL, NULL, NULL, 'Pyd_amn-ph_oxd', NULL, NULL, 5899, 11),
(274739, NULL, 'PIRSF029636', NULL, NULL, NULL, NULL, 'UCP029636', NULL, NULL, 17221, 11),
(274740, NULL, 'PIRSF036440', NULL, NULL, NULL, NULL, 'ARG5-6', NULL, NULL, 10782, 11),
(274741, NULL, 'PIRSF036962', NULL, NULL, NULL, NULL, 'UCP036962_SignTr_Ycf55', NULL, NULL, 19757, 11),
(274742, NULL, 'PIRSF016183', NULL, NULL, NULL, NULL, 'UCP016183', NULL, NULL, 3689, 11),
(274743, NULL, 'PIRSF005514', NULL, NULL, NULL, NULL, 'Mitoh_ATP-synt_D', NULL, NULL, 13045, 11),
(274744, NULL, 'PIRSF039117', NULL, NULL, NULL, NULL, 'KaiC', NULL, NULL, 24969, 11),
(274745, NULL, 'PIRSF002889', NULL, NULL, NULL, NULL, 'Rod_FlgB', NULL, NULL, 4832, 11),
(274746, NULL, 'PIRSF000930', NULL, NULL, NULL, NULL, 'PTPN8_PTPN22', NULL, NULL, 19713, 11),
(274747, NULL, 'PIRSF037208', NULL, NULL, NULL, NULL, 'ATE_prok', NULL, NULL, 20506, 11),
(274748, NULL, 'PIRSF004015', NULL, NULL, NULL, NULL, 'LigT_rotavirus', NULL, NULL, 10967, 11),
(274749, NULL, 'PIRSF001558', NULL, NULL, NULL, NULL, 'GSHase', NULL, NULL, 2539, 11),
(274750, NULL, 'PIRSF019381', NULL, NULL, NULL, NULL, 'YcjX', NULL, NULL, 3643, 11),
(274751, NULL, 'PIRSF006553', NULL, NULL, NULL, NULL, 'TopoVI-B', NULL, NULL, 4838, 11),
(274752, NULL, 'PIRSF037464', NULL, NULL, NULL, NULL, 'UCP037464_APP1', NULL, NULL, 15352, 11),
(274753, NULL, 'PIRSF036401', NULL, NULL, NULL, NULL, 'Gcp_STYKS', NULL, NULL, 10485, 11),
(274754, NULL, 'PIRSF002595', NULL, NULL, NULL, NULL, 'RR_SKN7', NULL, NULL, 7367, 11),
(274755, NULL, 'PIRSF001399', NULL, NULL, NULL, NULL, 'DHQase_2', NULL, NULL, 4460, 11),
(274756, NULL, 'PIRSF004959', NULL, NULL, NULL, NULL, 'UCP004959', NULL, NULL, 19176, 11),
(274757, NULL, 'PIRSF006278', NULL, NULL, NULL, NULL, 'ACCD_DCysDesulf', NULL, NULL, 26478, 11),
(274758, NULL, 'PIRSF007892', NULL, NULL, NULL, NULL, 'NAGS_fungal', NULL, NULL, 11000, 11),
(274759, NULL, 'PIRSF038189', NULL, NULL, NULL, NULL, 'IRAK4', NULL, NULL, 18447, 11);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(274760, NULL, 'PIRSF038971', NULL, NULL, NULL, NULL, 'PhnM', NULL, NULL, 11539, 11),
(274761, NULL, 'PIRSF016578', NULL, NULL, NULL, NULL, 'PIGM', NULL, NULL, NULL, 11),
(274762, NULL, 'PIRSF016666', NULL, NULL, NULL, NULL, 'UCP016666', NULL, NULL, 20190, 11),
(274763, NULL, 'PIRSF005216', NULL, NULL, NULL, NULL, 'PvlArgDC', NULL, NULL, 3752, 11),
(274764, NULL, 'PIRSF012467', NULL, NULL, NULL, NULL, 'UCP012467', NULL, NULL, 17854, 11),
(274765, NULL, 'PIRSF037204', NULL, NULL, NULL, NULL, 'UCP037204', NULL, NULL, 20545, 11),
(274766, NULL, 'PIRSF029037', NULL, NULL, NULL, NULL, 'UCP029037_Zn_ribbon', NULL, NULL, 17192, 11),
(274767, NULL, 'PIRSF000728', NULL, NULL, NULL, NULL, 'NAGK', NULL, NULL, 2625, 11),
(274768, NULL, 'PIRSF000408', NULL, NULL, NULL, NULL, 'Alkyltransferas_AdaA', NULL, NULL, 17427, 11),
(274769, NULL, 'PIRSF031796', NULL, NULL, NULL, NULL, 'UCP031796', NULL, NULL, 8304, 11),
(274770, NULL, 'PIRSF001529', NULL, NULL, NULL, NULL, 'Ser-tRNA_ligase', NULL, NULL, 6055, 11),
(274771, NULL, 'PIRSF037032', NULL, NULL, NULL, NULL, 'BiliverdinRD_A', NULL, NULL, 19958, 11),
(274772, NULL, 'PIRSF006413', NULL, NULL, NULL, NULL, 'Transl_init_IF-6', NULL, NULL, 4654, 11),
(274773, NULL, 'PIRSF000824', NULL, NULL, NULL, NULL, 'L_OrthobunV', NULL, NULL, 12340, 11),
(274774, NULL, 'PIRSF000179', NULL, NULL, NULL, NULL, 'FrdD', NULL, NULL, 5171, 11),
(274775, NULL, 'PIRSF030829', NULL, NULL, NULL, NULL, 'DAG_kinase_plant', NULL, NULL, 17816, 11),
(274776, NULL, 'PIRSF035865', NULL, NULL, NULL, NULL, 'UCP035865', NULL, NULL, 8408, 11),
(274777, NULL, 'PIRSF019370', NULL, NULL, NULL, NULL, 'EhaR', NULL, NULL, 13950, 11),
(274778, NULL, 'PIRSF000168', NULL, NULL, NULL, NULL, 'Acyl-CoA_oxidase', NULL, NULL, 11956, 11),
(274779, NULL, 'PIRSF038073', NULL, NULL, NULL, NULL, 'B-acetylglucosaminyltrns_Rfng', NULL, NULL, 17847, 11),
(274780, NULL, 'PIRSF002854', NULL, NULL, NULL, NULL, 'MetQ', NULL, NULL, 7183, 11),
(274781, NULL, 'PIRSF020772', NULL, NULL, NULL, NULL, 'UCP020772', NULL, NULL, 15179, 11),
(274782, NULL, 'PIRSF017316', NULL, NULL, NULL, NULL, 'Pesterase_C1039', NULL, NULL, 10300, 11),
(274783, NULL, 'PIRSF017998', NULL, NULL, NULL, NULL, 'UCP017998', NULL, NULL, 8941, 11),
(274784, NULL, 'PIRSF002417', NULL, NULL, NULL, NULL, 'Lipid_binding_protein', NULL, NULL, 21821, 11),
(274785, NULL, 'PIRSF029886', NULL, NULL, NULL, NULL, 'KBAA', NULL, NULL, 12778, 11),
(274786, NULL, 'PIRSF018933', NULL, NULL, NULL, NULL, 'UCP018933', NULL, NULL, 21471, 11),
(274787, NULL, 'PIRSF007972', NULL, NULL, NULL, NULL, 'Gra2', NULL, NULL, 6340, 11),
(274788, NULL, 'PIRSF026713', NULL, NULL, NULL, NULL, 'PMI_Firm_long', NULL, NULL, 16217, 11),
(274789, NULL, 'PIRSF500175', NULL, NULL, NULL, NULL, 'Glu_ADT_D', NULL, NULL, 8511, 11),
(274790, NULL, 'PIRSF000509', NULL, NULL, NULL, NULL, 'Trp_DMAT', NULL, NULL, 7260, 11),
(274791, NULL, 'PIRSF037824', NULL, NULL, NULL, NULL, 'Orexin', NULL, NULL, 3130, 11),
(274792, NULL, 'PIRSF016275', NULL, NULL, NULL, NULL, 'DNA_pol_II_DP2', NULL, NULL, 7416, 11),
(274793, NULL, 'PIRSF032623', NULL, NULL, NULL, NULL, 'Protease_SSO2181', NULL, NULL, 18678, 11),
(274794, NULL, 'PIRSF036668', NULL, NULL, NULL, NULL, 'ATPase_UCP036668', NULL, NULL, 13968, 11),
(274795, NULL, 'PIRSF004966', NULL, NULL, NULL, NULL, 'Aconts_X_swiv', NULL, NULL, 10581, 11),
(274796, NULL, 'PIRSF006169', NULL, NULL, NULL, NULL, 'UCP006169', NULL, NULL, 9268, 11),
(274797, NULL, 'PIRSF037750', NULL, NULL, NULL, NULL, 'TIR_Tirap', NULL, NULL, 16228, 11),
(274798, NULL, 'PIRSF005384', NULL, NULL, NULL, NULL, 'RpiB_LacA_B', NULL, NULL, 6482, 11),
(274799, NULL, 'PIRSF033579', NULL, NULL, NULL, NULL, 'Anaer_Co_chel_CbiK', NULL, NULL, 9102, 11),
(274800, NULL, 'PIRSF001979', NULL, NULL, NULL, NULL, 'Alpha_1B_glycoprot', NULL, NULL, 20328, 11),
(274801, NULL, 'PIRSF004553', NULL, NULL, NULL, NULL, 'Methylase_YhhF', NULL, NULL, 5575, 11),
(274802, NULL, 'PIRSF037992', NULL, NULL, NULL, NULL, 'HnRNP_C_Raly', NULL, NULL, 17472, 11),
(274803, NULL, 'PIRSF001617', NULL, NULL, NULL, NULL, 'Alpha-AR', NULL, NULL, NULL, 11);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(274804, NULL, 'PIRSF037935', NULL, NULL, NULL, NULL, 'TMPRSS13', NULL, NULL, 17310, 11),
(274805, NULL, 'PIRSF008159', NULL, NULL, NULL, NULL, 'UCP008159_ABC', NULL, NULL, 16173, 11),
(274806, NULL, 'PIRSF002496', NULL, NULL, NULL, NULL, 'Chordin', NULL, NULL, 20218, 11),
(274807, NULL, 'PIRSF037882', NULL, NULL, NULL, NULL, 'Subtilisin_rel_fervidolysin', NULL, NULL, 16794, 11),
(274808, NULL, 'PIRSF006288', NULL, NULL, NULL, NULL, 'PII_uridyltransf', NULL, NULL, 5439, 11),
(274809, NULL, 'PIRSF000847', NULL, NULL, NULL, NULL, 'Phos_ph_gly_syn', NULL, NULL, 613, 11),
(274810, NULL, 'PIRSF000909', NULL, NULL, NULL, NULL, 'STPPPtase_PPZ', NULL, NULL, 10790, 11),
(274811, NULL, 'PIRSF000525', NULL, NULL, NULL, NULL, 'SerC', NULL, NULL, 15261, 11),
(274812, NULL, 'PIRSF016933', NULL, NULL, NULL, NULL, 'PrsW', NULL, NULL, 16002, 11),
(274813, NULL, 'PIRSF002855', NULL, NULL, NULL, NULL, 'Murein-lipo', NULL, NULL, 20264, 11),
(274814, NULL, 'PIRSF015792', NULL, NULL, NULL, NULL, 'VAC_F16L', NULL, NULL, 3727, 11),
(274815, NULL, 'PIRSF038886', NULL, NULL, NULL, NULL, 'Pellino', NULL, NULL, 3534, 11),
(274816, NULL, 'PIRSF018644', NULL, NULL, NULL, NULL, 'FAU-1', NULL, NULL, 21006, 11),
(274817, NULL, 'PIRSF033887', NULL, NULL, NULL, NULL, 'PduX', NULL, NULL, 12829, 11),
(274818, NULL, 'PIRSF017529', NULL, NULL, NULL, NULL, 'Aquaporin-11_12', NULL, NULL, 20427, 11),
(274819, NULL, 'PIRSF007050', NULL, NULL, NULL, NULL, 'UCP007050', NULL, NULL, 9772, 11),
(274820, NULL, 'PIRSF038145', NULL, NULL, NULL, NULL, 'STPK_citron', NULL, NULL, 18079, 11),
(274821, NULL, 'PIRSF037511', NULL, NULL, NULL, NULL, 'Transl_init_SUI1_prok', NULL, NULL, 6941, 11),
(274822, NULL, 'PIRSF004919', NULL, NULL, NULL, NULL, 'TldD', NULL, NULL, 24332, 11),
(274823, NULL, 'PIRSF020763', NULL, NULL, NULL, NULL, 'TcpF', NULL, NULL, 8362, 11),
(274824, NULL, 'PIRSF001741', NULL, NULL, NULL, NULL, 'MAGUK_DLGH', NULL, NULL, 19914, 11),
(274825, NULL, 'PIRSF000819', NULL, NULL, NULL, NULL, 'Streptomycin_3-adenylyltransf', NULL, NULL, 12997, 11),
(274826, NULL, 'PIRSF001223', NULL, NULL, NULL, NULL, 'Urease_gamma', NULL, NULL, 10548, 11),
(274827, NULL, 'PIRSF037676', NULL, NULL, NULL, NULL, 'UCP037676', NULL, NULL, 1233, 11),
(274828, NULL, 'PIRSF016498', NULL, NULL, NULL, NULL, 'UCP016498', NULL, NULL, 17377, 11),
(274829, NULL, 'PIRSF001365', NULL, NULL, NULL, NULL, 'DHDPS', NULL, NULL, 5807, 11),
(274830, NULL, 'PIRSF034247', NULL, NULL, NULL, NULL, 'RCAS1', NULL, NULL, 18622, 11),
(274831, NULL, 'PIRSF009285', NULL, NULL, NULL, NULL, 'GAMT', NULL, NULL, 17543, 11),
(274832, NULL, 'PIRSF028688', NULL, NULL, NULL, NULL, 'UCP028688', NULL, NULL, 12348, 11),
(274833, NULL, 'PIRSF500784', NULL, NULL, NULL, NULL, 'TAG1', NULL, NULL, 24914, 11),
(274834, NULL, 'PIRSF001594', NULL, NULL, NULL, NULL, 'PCB', NULL, NULL, 319, 11),
(274835, NULL, 'PIRSF001150', NULL, NULL, NULL, NULL, 'Plasmin', NULL, NULL, 17744, 11),
(274836, NULL, 'PIRSF000264', NULL, NULL, NULL, NULL, 'Meth_CoM_rd_gama', NULL, NULL, 2912, 11),
(274837, NULL, 'PIRSF015950', NULL, NULL, NULL, NULL, 'Mev_P_decrbx', NULL, NULL, 335, 11),
(274838, NULL, 'PIRSF033924', NULL, NULL, NULL, NULL, 'UCP033924', NULL, NULL, 7663, 11),
(274839, NULL, 'PIRSF028188', NULL, NULL, NULL, NULL, 'Amdntrnsf_FN0238', NULL, NULL, 12394, 11),
(274840, NULL, 'PIRSF500204', NULL, NULL, NULL, NULL, 'RBP_purpurin', NULL, NULL, 6779, 11),
(274841, NULL, 'PIRSF016632', NULL, NULL, NULL, NULL, 'PLD_actino_fungi', NULL, NULL, 20355, 11),
(274842, NULL, 'PIRSF017117', NULL, NULL, NULL, NULL, 'YscY', NULL, NULL, 20441, 11),
(274843, NULL, 'PIRSF009564', NULL, NULL, NULL, NULL, 'HdeA', NULL, NULL, 21657, 11),
(274844, NULL, 'PIRSF010044', NULL, NULL, NULL, NULL, 'UCP010044', NULL, NULL, 17801, 11),
(274845, NULL, 'PIRSF017324', NULL, NULL, NULL, NULL, 'UCP017324', NULL, NULL, 10882, 11),
(274846, NULL, 'PIRSF028983', NULL, NULL, NULL, NULL, 'BCP1', NULL, NULL, 24775, 11),
(274847, NULL, 'PIRSF000690', NULL, NULL, NULL, NULL, 'Phosphotransf_FPr', NULL, NULL, 19098, 11),
(274848, NULL, 'PIRSF001220', NULL, NULL, NULL, NULL, 'L-ASNase_gatD', NULL, NULL, 2746, 11);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(274849, NULL, 'PIRSF037546', NULL, NULL, NULL, NULL, 'RNA_pol_L_Rhabdo_sub', NULL, NULL, 15404, 11),
(274850, NULL, 'PIRSF037445', NULL, NULL, NULL, NULL, 'UCP037445_abhydr', NULL, NULL, 15342, 11),
(274851, NULL, 'PIRSF015040', NULL, NULL, NULL, NULL, 'ATPase_SAG2001', NULL, NULL, 19408, 11),
(274852, NULL, 'PIRSF000929', NULL, NULL, NULL, NULL, 'PTPN6_PTPN11', NULL, NULL, 7290, 11),
(274853, NULL, 'PIRSF039014', NULL, NULL, NULL, NULL, 'OTR_cyc', NULL, NULL, 21188, 11),
(274854, NULL, 'PIRSF001218', NULL, NULL, NULL, NULL, 'Protease_ADV', NULL, NULL, 444, 11),
(274855, NULL, 'PIRSF006187', NULL, NULL, NULL, NULL, 'UCP006187', NULL, NULL, 12205, 11),
(274856, NULL, 'PIRSF038981', NULL, NULL, NULL, NULL, 'GRP', NULL, NULL, 14131, 11),
(274857, NULL, 'PIRSF001060', NULL, NULL, NULL, NULL, 'Endochitinase', NULL, NULL, 19918, 11),
(274858, NULL, 'PIRSF001883', NULL, NULL, NULL, NULL, 'TxP_I', NULL, NULL, 20228, 11),
(274859, NULL, 'PIRSF015693', NULL, NULL, NULL, NULL, 'VAC-48L_nuct', NULL, NULL, 807, 11),
(274860, NULL, 'PIRSF003760', NULL, NULL, NULL, NULL, 'VAC_K3L_Serpin', NULL, NULL, 21293, 11),
(274861, NULL, 'PIRSF036444', NULL, NULL, NULL, NULL, 'Pesterase_YvnB', NULL, NULL, 7748, 11),
(274862, NULL, 'PIRSF501106', NULL, NULL, NULL, NULL, 'Protein_kin_C_epsilon', NULL, NULL, 25282, 11),
(274863, NULL, 'PIRSF024658', NULL, NULL, NULL, NULL, 'FlaF_archaea', NULL, NULL, 15229, 11),
(274864, NULL, 'PIRSF028335', NULL, NULL, NULL, NULL, 'OppA', NULL, NULL, 16466, 11),
(274865, NULL, 'PIRSF000549', NULL, NULL, NULL, NULL, 'Ser_prot_kin', NULL, NULL, 17452, 11),
(274866, NULL, 'PIRSF001716', NULL, NULL, NULL, NULL, 'Dorsal', NULL, NULL, 14855, 11),
(274867, NULL, 'PIRSF005669', NULL, NULL, NULL, NULL, 'HAT_Elp3', NULL, NULL, 32233, 11),
(274868, NULL, 'PIRSF000534', NULL, NULL, NULL, NULL, 'ATP_PFK_TP0108', NULL, NULL, 10062, 11),
(274869, NULL, 'PIRSF001939', NULL, NULL, NULL, NULL, 'IL-3', NULL, NULL, 1048, 11),
(274870, NULL, 'PIRSF021287', NULL, NULL, NULL, NULL, 'YmcA', NULL, NULL, 15138, 11),
(274871, NULL, 'PIRSF007165', NULL, NULL, NULL, NULL, 'UCP007165', NULL, NULL, 10786, 11),
(274872, NULL, 'PIRSF036978', NULL, NULL, NULL, NULL, 'UCP036978_PHPhdr', NULL, NULL, 19802, 11),
(274873, NULL, 'PIRSF500101', NULL, NULL, NULL, NULL, 'ER-a', NULL, NULL, 149, 11),
(274874, NULL, 'PIRSF028445', NULL, NULL, NULL, NULL, 'UCP028445', NULL, NULL, 16823, 11),
(274875, NULL, 'PIRSF005023', NULL, NULL, NULL, NULL, 'CODH', NULL, NULL, 5487, 11),
(274876, NULL, 'PIRSF009467', NULL, NULL, NULL, NULL, 'Urease_acces_UreF', NULL, NULL, 2583, 11),
(274877, NULL, 'PIRSF016939', NULL, NULL, NULL, NULL, 'ADP_ribosylarg_hydrolase', NULL, NULL, 12525, 11),
(274878, NULL, 'PIRSF027391', NULL, NULL, NULL, NULL, 'Hpre_diP_synt_I', NULL, NULL, 12327, 11),
(274879, NULL, 'PIRSF028477', NULL, NULL, NULL, NULL, 'UCP028477', NULL, NULL, 12300, 11),
(274880, NULL, 'PIRSF016323', NULL, NULL, NULL, NULL, 'tRNA_m1G_Mtase_euk', NULL, NULL, 19953, 11),
(274881, NULL, 'PIRSF038940', NULL, NULL, NULL, NULL, 'Low_specificity_LTA', NULL, NULL, 22892, 11),
(274882, NULL, 'PIRSF001906', NULL, NULL, NULL, NULL, 'ATX_III', NULL, NULL, 20059, 11),
(274883, NULL, 'PIRSF036603', NULL, NULL, NULL, NULL, 'DNA_pol_eta', NULL, NULL, NULL, 11),
(274884, NULL, 'PIRSF016573', NULL, NULL, NULL, NULL, 'Snapalysin', NULL, NULL, 2679, 11),
(274885, NULL, 'PIRSF036536', NULL, NULL, NULL, NULL, 'EhaH', NULL, NULL, 19796, 11),
(274886, NULL, 'PIRSF038919', NULL, NULL, NULL, NULL, 'NOG1', NULL, NULL, 22753, 11),
(274887, NULL, 'PIRSF030333', NULL, NULL, NULL, NULL, 'UCP030333_Alba', NULL, NULL, 12383, 11),
(274888, NULL, 'PIRSF001293', NULL, NULL, NULL, NULL, 'ATP6V0A1', NULL, NULL, 24896, 11),
(274889, NULL, 'PIRSF000428', NULL, NULL, NULL, NULL, 'P_Ac_trans', NULL, NULL, 7280, 11),
(274890, NULL, 'PIRSF039072', NULL, NULL, NULL, NULL, 'ATPase_subunit_beta', NULL, NULL, NULL, 11),
(274891, NULL, 'PIRSF020967', NULL, NULL, NULL, NULL, 'UCP020967', NULL, NULL, 10550, 11),
(274892, NULL, 'PIRSF017199', NULL, NULL, NULL, NULL, 'Dim1', NULL, NULL, 1589, 11);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(274893, NULL, 'PIRSF002744', NULL, NULL, NULL, NULL, 'Pur-cyt_permease', NULL, NULL, 26502, 11),
(274894, NULL, 'PIRSF009265', NULL, NULL, NULL, NULL, 'GCH3', NULL, NULL, 2033, 11),
(274895, NULL, 'PIRSF016441', NULL, NULL, NULL, NULL, 'GTF2I', NULL, NULL, 19609, 11),
(274896, NULL, 'PIRSF037404', NULL, NULL, NULL, NULL, 'DNMT1', NULL, NULL, 21459, 11),
(274897, NULL, 'PIRSF000105', NULL, NULL, NULL, NULL, 'HCDH', NULL, NULL, 14998, 11),
(274898, NULL, 'PIRSF006257', NULL, NULL, NULL, NULL, 'UCP006257', NULL, NULL, 5952, 11),
(274899, NULL, 'PIRSF029218', NULL, NULL, NULL, NULL, 'ParE', NULL, NULL, 21533, 11),
(274900, NULL, 'PIRSF037663', NULL, NULL, NULL, NULL, 'Acetyltransf_GNAT', NULL, NULL, 15777, 11),
(274901, NULL, 'PIRSF018586', NULL, NULL, NULL, NULL, 'FADD', NULL, NULL, 21270, 11),
(274902, NULL, 'PIRSF026396', NULL, NULL, NULL, NULL, 'UCP026396_dh', NULL, NULL, 16301, 11),
(274903, NULL, 'PIRSF500627', NULL, NULL, NULL, NULL, 'Cytochrome_CYP8B1', NULL, NULL, 23786, 11),
(274904, NULL, 'PIRSF501105', NULL, NULL, NULL, NULL, 'Protein_kin_C_theta', NULL, NULL, 22598, 11),
(274905, NULL, 'PIRSF019464', NULL, NULL, NULL, NULL, 'UCP019464', NULL, NULL, 21383, 11),
(274906, NULL, 'PIRSF003003', NULL, NULL, NULL, NULL, 'Colicin_imm', NULL, NULL, 1903, 11),
(274907, NULL, 'PIRSF007056', NULL, NULL, NULL, NULL, 'UCP007056', NULL, NULL, 10736, 11),
(274908, NULL, 'PIRSF037048', NULL, NULL, NULL, NULL, 'PNPOx_plant', NULL, NULL, 16955, 11),
(274909, NULL, 'PIRSF000188', NULL, NULL, NULL, NULL, 'Phe_leu_dh', NULL, NULL, 17341, 11),
(274910, NULL, 'PIRSF005378', NULL, NULL, NULL, NULL, 'RNA_3-term_P_cyclase', NULL, NULL, 1177, 11),
(274911, NULL, 'PIRSF021485', NULL, NULL, NULL, NULL, 'UCP021485', NULL, NULL, 11396, 11),
(274912, NULL, 'PIRSF000118', NULL, NULL, NULL, NULL, 'Ilv5_plant', NULL, NULL, 17141, 11),
(274913, NULL, 'PIRSF000605', NULL, NULL, NULL, NULL, 'RPS6_kin_1', NULL, NULL, 17294, 11),
(274914, NULL, 'PIRSF028291', NULL, NULL, NULL, NULL, 'UCP028291', NULL, NULL, 12447, 11),
(274915, NULL, 'PIRSF038006', NULL, NULL, NULL, NULL, 'MeCP2', NULL, NULL, 17104, 11),
(274916, NULL, 'PIRSF029557', NULL, NULL, NULL, NULL, 'UCP029557', NULL, NULL, 9963, 11),
(274917, NULL, 'PIRSF002190', NULL, NULL, NULL, NULL, 'Ribosomal_L18a', NULL, NULL, 15410, 11),
(274918, NULL, 'PIRSF006609', NULL, NULL, NULL, NULL, 'snRNP_SmF', NULL, NULL, NULL, 11),
(274919, NULL, 'PIRSF028440', NULL, NULL, NULL, NULL, 'UCP_LAB_N', NULL, NULL, 12462, 11),
(274920, NULL, 'PIRSF038130', NULL, NULL, NULL, NULL, 'WRKY_txn_fact_IIc', NULL, NULL, 18132, 11),
(274921, NULL, 'PIRSF036487', NULL, NULL, NULL, NULL, 'Hydroxylase_rubr', NULL, NULL, 8057, 11),
(274922, NULL, 'PIRSF036632', NULL, NULL, NULL, NULL, 'GOGAT_lg_1_3', NULL, NULL, 12254, 11),
(274923, NULL, 'PIRSF004929', NULL, NULL, NULL, NULL, 'UCP004929', NULL, NULL, 9961, 11),
(274924, NULL, 'PIRSF000502', NULL, NULL, NULL, NULL, 'Spermidine_synth', NULL, NULL, 26102, 11),
(274925, NULL, 'PIRSF006107', NULL, NULL, NULL, NULL, 'PTA_proteo', NULL, NULL, 15492, 11),
(274926, NULL, 'PIRSF037237', NULL, NULL, NULL, NULL, 'Peptidase_WD_repeats_DUG2', NULL, NULL, 20846, 11),
(274927, NULL, 'PIRSF017385', NULL, NULL, NULL, NULL, 'CtaF', NULL, NULL, 15160, 11),
(274928, NULL, 'PIRSF037671', NULL, NULL, NULL, NULL, 'Chloroquine_res_transporter', NULL, NULL, 15771, 11),
(274929, NULL, 'PIRSF000076', NULL, NULL, NULL, NULL, 'HCP', NULL, NULL, 5305, 11),
(274930, NULL, 'PIRSF029033', NULL, NULL, NULL, NULL, 'UCP029033', NULL, NULL, 17329, 11),
(274931, NULL, 'PIRSF032064', NULL, NULL, NULL, NULL, 'UCP032064', NULL, NULL, 8322, 11),
(274932, NULL, 'PIRSF029928', NULL, NULL, NULL, NULL, 'ComGC', NULL, NULL, 17538, 11),
(274933, NULL, 'PIRSF006639', NULL, NULL, NULL, NULL, 'UCP006639_pph', NULL, NULL, 14607, 11),
(274934, NULL, 'PIRSF000580', NULL, NULL, NULL, NULL, 'STPK_ULK1', NULL, NULL, 17495, 11),
(274935, NULL, 'PIRSF010751', NULL, NULL, NULL, NULL, 'HOP1_fungal', NULL, NULL, 17746, 11),
(274936, NULL, 'PIRSF037713', NULL, NULL, NULL, NULL, 'BT_exbB-like_prot_1', NULL, NULL, 16097, 11);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(274937, NULL, 'PIRSF001265', NULL, NULL, NULL, NULL, 'H+-PPtase', NULL, NULL, 2515, 11),
(274938, NULL, 'PIRSF003170', NULL, NULL, NULL, NULL, 'Pet18p', NULL, NULL, 24852, 11),
(274939, NULL, 'PIRSF028513', NULL, NULL, NULL, NULL, 'LptC', NULL, NULL, 21865, 11),
(274940, NULL, 'PIRSF036314', NULL, NULL, NULL, NULL, 'LDLR-rel_5_6', NULL, NULL, 19557, 11),
(274941, NULL, 'PIRSF033535', NULL, NULL, NULL, NULL, 'UCP033535_plp', NULL, NULL, 8041, 11),
(274942, NULL, 'PIRSF007747', NULL, NULL, NULL, NULL, 'RIT1', NULL, NULL, 4817, 11),
(274943, NULL, 'PIRSF037993', NULL, NULL, NULL, NULL, 'STPK_Pim-1', NULL, NULL, 17247, 11),
(274944, NULL, 'PIRSF006294', NULL, NULL, NULL, NULL, 'PEP_crbxkin', NULL, NULL, 5279, 11),
(274945, NULL, 'PIRSF004028', NULL, NULL, NULL, NULL, 'GPC_ArenaV', NULL, NULL, 3403, 11),
(274946, NULL, 'PIRSF031402', NULL, NULL, NULL, NULL, 'SYS1_homolog', NULL, NULL, 17986, 11),
(274947, NULL, 'PIRSF011444', NULL, NULL, NULL, NULL, 'UCP011444', NULL, NULL, 11688, 11),
(274948, NULL, 'PIRSF028770', NULL, NULL, NULL, NULL, 'UCP028770', NULL, NULL, 10580, 11),
(274949, NULL, 'PIRSF005822', NULL, NULL, NULL, NULL, 'NDUA2', NULL, NULL, 15058, 11),
(274950, NULL, 'PIRSF016550', NULL, NULL, NULL, NULL, 'Rab_ger_ger_transf_A_euk', NULL, NULL, 3491, 11),
(274951, NULL, 'PIRSF016580', NULL, NULL, NULL, NULL, 'Acylprotsyn_LuxE', NULL, NULL, 20384, 11),
(274952, NULL, 'PIRSF006004', NULL, NULL, NULL, NULL, 'Cfr', NULL, NULL, 5864, 11),
(274953, NULL, 'PIRSF015971', NULL, NULL, NULL, NULL, 'VAC_F1L', NULL, NULL, 10749, 11),
(274954, NULL, 'PIRSF019325', NULL, NULL, NULL, NULL, 'GPI', NULL, NULL, 21159, 11),
(274955, NULL, 'PIRSF017066', NULL, NULL, NULL, NULL, 'FlaD_arch', NULL, NULL, 20088, 11),
(274956, NULL, 'PIRSF015417', NULL, NULL, NULL, NULL, 'T31B5_30_vWA', NULL, NULL, 10965, 11),
(274957, NULL, 'PIRSF038958', NULL, NULL, NULL, NULL, 'PG_synth_SpoVB', NULL, NULL, 24943, 11),
(274958, NULL, 'PIRSF000852', NULL, NULL, NULL, NULL, 'Phosphatidylserin_synth_fung', NULL, NULL, 19698, 11),
(274959, NULL, 'PIRSF025479', NULL, NULL, NULL, NULL, 'UCP025479', NULL, NULL, 16319, 11),
(274960, NULL, 'PIRSF017849', NULL, NULL, NULL, NULL, 'TraD', NULL, NULL, 20239, 11),
(274961, NULL, 'PIRSF005019', NULL, NULL, NULL, NULL, 'EhaA', NULL, NULL, 10275, 11),
(274962, NULL, 'PIRSF028234', NULL, NULL, NULL, NULL, 'UCP028234', NULL, NULL, 16207, 11),
(274963, NULL, 'PIRSF005011', NULL, NULL, NULL, NULL, 'SanA', NULL, NULL, 16154, 11),
(274964, NULL, 'PIRSF036354', NULL, NULL, NULL, NULL, 'NosR', NULL, NULL, 7603, 11),
(274965, NULL, 'PIRSF016493', NULL, NULL, NULL, NULL, 'Glycyl_aminpptds', NULL, NULL, 13828, 11),
(274966, NULL, 'PIRSF011861', NULL, NULL, NULL, NULL, 'Biotinidase', NULL, NULL, 12960, 11),
(274967, NULL, 'PIRSF035042', NULL, NULL, NULL, NULL, 'UCP035042_thirdx', NULL, NULL, 8924, 11),
(274968, NULL, 'PIRSF037328', NULL, NULL, NULL, NULL, 'Inhibin_alpha', NULL, NULL, 21175, 11),
(274969, NULL, 'PIRSF037356', NULL, NULL, NULL, NULL, 'UCP037356', NULL, NULL, 13112, 11),
(274970, NULL, 'PIRSF016255', NULL, NULL, NULL, NULL, 'Transl_init_eIF3e', NULL, NULL, 19550, 11),
(274971, NULL, 'PIRSF029187', NULL, NULL, NULL, NULL, 'SHR3', NULL, NULL, 13314, 11),
(274972, NULL, 'PIRSF037984', NULL, NULL, NULL, NULL, 'Met_synth_TM0269', NULL, NULL, 17491, 11),
(274973, NULL, 'PIRSF002305', NULL, NULL, NULL, NULL, 'ERM', NULL, NULL, 10715, 11),
(274974, NULL, 'PIRSF003269', NULL, NULL, NULL, NULL, 'TrbA', NULL, NULL, 21358, 11),
(274975, NULL, 'PIRSF006280', NULL, NULL, NULL, NULL, 'YfiF', NULL, NULL, 15375, 11),
(274976, NULL, 'PIRSF001336', NULL, NULL, NULL, NULL, 'ARGDC', NULL, NULL, 7168, 11),
(274977, NULL, 'PIRSF037932', NULL, NULL, NULL, NULL, 'A2BP1', NULL, NULL, 17044, 11),
(274978, NULL, 'PIRSF005588', NULL, NULL, NULL, NULL, 'DAD1_Ost2', NULL, NULL, 29, 11),
(274979, NULL, 'PIRSF036313', NULL, NULL, NULL, NULL, 'Fibulin-1', NULL, NULL, 19804, 11),
(274980, NULL, 'PIRSF010244', NULL, NULL, NULL, NULL, 'UCP010244_imp', NULL, NULL, 9758, 11),
(274981, NULL, 'PIRSF037487', NULL, NULL, NULL, NULL, 'Sulfite_red_assimil', NULL, NULL, 15480, 11);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(274982, NULL, 'PIRSF006439', NULL, NULL, NULL, NULL, 'Indolepyruvate_ferr_oxidored', NULL, NULL, 17547, 11),
(274983, NULL, 'PIRSF029172', NULL, NULL, NULL, NULL, 'UCP029172_ABC_sbc_YnjB', NULL, NULL, 23520, 11),
(274984, NULL, 'PIRSF003696', NULL, NULL, NULL, NULL, 'VAC_C23L', NULL, NULL, 9686, 11),
(274985, NULL, 'PIRSF033101', NULL, NULL, NULL, NULL, 'UCP033101', NULL, NULL, 7578, 11),
(274986, NULL, 'PIRSF006320', NULL, NULL, NULL, NULL, 'Elb2', NULL, NULL, 24595, 11),
(274987, NULL, 'PIRSF029287', NULL, NULL, NULL, NULL, 'UCP029287', NULL, NULL, 18663, 11),
(274988, NULL, 'PIRSF006443', NULL, NULL, NULL, NULL, 'MoaB', NULL, NULL, 11204, 11),
(274989, NULL, 'PIRSF038170', NULL, NULL, NULL, NULL, 'TRM6', NULL, NULL, 18309, 11),
(274990, NULL, 'PIRSF006113', NULL, NULL, NULL, NULL, 'PTP_synth', NULL, NULL, 26, 11),
(274991, NULL, 'PIRSF037188', NULL, NULL, NULL, NULL, 'Lsm7', NULL, NULL, NULL, 11),
(274992, NULL, 'PIRSF004882', NULL, NULL, NULL, NULL, 'GTP_bind_MJ1339', NULL, NULL, 21306, 11),
(274993, NULL, 'PIRSF032184', NULL, NULL, NULL, NULL, 'V-ATP_synth_H', NULL, NULL, 1635, 11),
(274994, NULL, 'PIRSF010354', NULL, NULL, NULL, NULL, 'Trx_SET', NULL, NULL, 17718, 11),
(274995, NULL, 'PIRSF015268', NULL, NULL, NULL, NULL, 'Virulence_RhuM', NULL, NULL, 10876, 11),
(274996, NULL, 'PIRSF001837', NULL, NULL, NULL, NULL, 'Leptin', NULL, NULL, 3616, 11),
(274997, NULL, 'PIRSF006398', NULL, NULL, NULL, NULL, 'Sec61_beta', NULL, NULL, 22259, 11),
(274998, NULL, 'PIRSF036389', NULL, NULL, NULL, NULL, 'IOR_B', NULL, NULL, 12609, 11),
(274999, NULL, 'PIRSF016788', NULL, NULL, NULL, NULL, 'RR_Fis', NULL, NULL, 9810, 11),
(275000, NULL, 'PIRSF036594', NULL, NULL, NULL, NULL, 'MoaC_MogA', NULL, NULL, 11951, 11),
(275001, NULL, 'PIRSF002495', NULL, NULL, NULL, NULL, 'VWF', NULL, NULL, 27842, 11),
(275002, NULL, 'PIRSF017321', NULL, NULL, NULL, NULL, 'PIG-W', NULL, NULL, 8303, 11),
(275003, NULL, 'PIRSF009290', NULL, NULL, NULL, NULL, 'FrlB', NULL, NULL, 12598, 11),
(275004, NULL, 'PIRSF036495', NULL, NULL, NULL, NULL, 'IGFBP_rP_CNN', NULL, NULL, 13095, 11),
(275005, NULL, 'PIRSF000825', NULL, NULL, NULL, NULL, 'L_HantaV', NULL, NULL, 19850, 11),
(275006, NULL, 'PIRSF018297', NULL, NULL, NULL, NULL, 'Doc', NULL, NULL, 6646, 11),
(275007, NULL, 'PIRSF032862', NULL, NULL, NULL, NULL, 'UCP032862_Fe-S', NULL, NULL, 18917, 11),
(275008, NULL, 'PIRSF012508', NULL, NULL, NULL, NULL, 'YerC', NULL, NULL, 18852, 11),
(275009, NULL, 'PIRSF028655', NULL, NULL, NULL, NULL, 'NMP1', NULL, NULL, 8151, 11),
(275010, NULL, 'PIRSF007023', NULL, NULL, NULL, NULL, 'UDP-Galf_transf', NULL, NULL, NULL, 11),
(275011, NULL, 'PIRSF031780', NULL, NULL, NULL, NULL, 'UCP031780', NULL, NULL, 8261, 11),
(275012, NULL, 'PIRSF001875', NULL, NULL, NULL, NULL, 'Alpha_defensin', NULL, NULL, 20447, 11),
(275013, NULL, 'PIRSF025023', NULL, NULL, NULL, NULL, 'Spt4', NULL, NULL, 13822, 11),
(275014, NULL, 'PIRSF002096', NULL, NULL, NULL, NULL, 'HnS', NULL, NULL, 4251, 11),
(275015, NULL, 'PIRSF016958', NULL, NULL, NULL, NULL, 'Mtase_AD-003', NULL, NULL, 13883, 11),
(275016, NULL, 'PIRSF006577', NULL, NULL, NULL, NULL, 'UCP006577', NULL, NULL, 10864, 11),
(275017, NULL, 'PIRSF004761', NULL, NULL, NULL, NULL, 'Hydrgn_mat_HypA', NULL, NULL, 6785, 11),
(275018, NULL, 'PIRSF018506', NULL, NULL, NULL, NULL, 'Prpndl_dhdrts_md', NULL, NULL, 23962, 11),
(275019, NULL, 'PIRSF010611', NULL, NULL, NULL, NULL, 'UCP010611', NULL, NULL, 17857, 11),
(275020, NULL, 'PIRSF004008', NULL, NULL, NULL, NULL, 'VAC_E3L', NULL, NULL, 9980, 11),
(275021, NULL, 'PIRSF037162', NULL, NULL, NULL, NULL, 'PRDM', NULL, NULL, 20579, 11),
(275022, NULL, 'PIRSF004505', NULL, NULL, NULL, NULL, 'MT_bac', NULL, NULL, 4425, 11),
(275023, NULL, 'PIRSF018571', NULL, NULL, NULL, NULL, 'SpoIIGA', NULL, NULL, 10245, 11),
(275024, NULL, 'PIRSF003109', NULL, NULL, NULL, NULL, 'RE_McrC', NULL, NULL, 7700, 11),
(275025, NULL, 'PIRSF016315', NULL, NULL, NULL, NULL, 'p21-ARC', NULL, NULL, 1083, 11),
(275026, NULL, 'PIRSF001589', NULL, NULL, NULL, NULL, 'Asn_synthetase_glu-h', NULL, NULL, 6518, 11);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(275027, NULL, 'PIRSF037112', NULL, NULL, NULL, NULL, 'ArdC', NULL, NULL, 20280, 11),
(275028, NULL, 'PIRSF002845', NULL, NULL, NULL, NULL, 'Ttrprl_mtas_MazG', NULL, NULL, 13491, 11),
(275029, NULL, 'PIRSF036990', NULL, NULL, NULL, NULL, 'UCP_CBS_BON', NULL, NULL, 19724, 11),
(275030, NULL, 'PIRSF009324', NULL, NULL, NULL, NULL, 'Cdk5_activator', NULL, NULL, 1653, 11),
(275031, NULL, 'PIRSF006102', NULL, NULL, NULL, NULL, 'NQR_DE', NULL, NULL, 1320, 11),
(275032, NULL, 'PIRSF003135', NULL, NULL, NULL, NULL, 'Primosomal_n', NULL, NULL, 16241, 11),
(275033, NULL, 'PIRSF000381', NULL, NULL, NULL, NULL, 'Met_synth_MetH', NULL, NULL, 13937, 11),
(275034, NULL, 'PIRSF036376', NULL, NULL, NULL, NULL, 'Corin', NULL, NULL, 19560, 11),
(275035, NULL, 'PIRSF001043', NULL, NULL, NULL, NULL, 'EG-B', NULL, NULL, 19938, 11),
(275036, NULL, 'PIRSF031639', NULL, NULL, NULL, NULL, 'Ccs4', NULL, NULL, 17600, 11),
(275037, NULL, 'PIRSF037933', NULL, NULL, NULL, NULL, 'Polyserase-2', NULL, NULL, 17180, 11),
(275038, NULL, 'PIRSF005018', NULL, NULL, NULL, NULL, 'UCP005018', NULL, NULL, 10937, 11),
(275039, NULL, 'PIRSF005522', NULL, NULL, NULL, NULL, 'UCP005522', NULL, NULL, 15072, 11),
(275040, NULL, 'PIRSF030820', NULL, NULL, NULL, NULL, 'UCP030820', NULL, NULL, 7545, 11),
(275041, NULL, 'PIRSF038214', NULL, NULL, NULL, NULL, 'ESCRT1_Vps37_fungi', NULL, NULL, 18873, 11),
(275042, NULL, 'PIRSF031679', NULL, NULL, NULL, NULL, 'Mtase_Alr7345', NULL, NULL, 17796, 11),
(275043, NULL, 'PIRSF000127', NULL, NULL, NULL, NULL, 'Xanthine_dh', NULL, NULL, 17394, 11),
(275044, NULL, 'PIRSF000938', NULL, NULL, NULL, NULL, 'PTPN1_yeast', NULL, NULL, 19957, 11),
(275045, NULL, 'PIRSF000409', NULL, NULL, NULL, NULL, 'Ada', NULL, NULL, 17484, 11),
(275046, NULL, 'PIRSF029509', NULL, NULL, NULL, NULL, 'UCP029509', NULL, NULL, 17385, 11),
(275047, NULL, 'PIRSF037256', NULL, NULL, NULL, NULL, 'UCP037256', NULL, NULL, 21052, 11),
(275048, NULL, 'PIRSF004977', NULL, NULL, NULL, NULL, 'UCP004977', NULL, NULL, 10681, 11),
(275049, NULL, 'PIRSF015730', NULL, NULL, NULL, NULL, 'TFAR19', NULL, NULL, 5290, 11),
(275050, NULL, 'PIRSF016821', NULL, NULL, NULL, NULL, 'HSP15', NULL, NULL, 26011, 11),
(275051, NULL, 'PIRSF000282', NULL, NULL, NULL, NULL, 'COX7', NULL, NULL, 12400, 11),
(275052, NULL, 'PIRSF034934', NULL, NULL, NULL, NULL, 'AbiF_AbiD', NULL, NULL, 18970, 11),
(275053, NULL, 'PIRSF035859', NULL, NULL, NULL, NULL, 'ABC_tp_sb', NULL, NULL, 8347, 11),
(275054, NULL, 'PIRSF031900', NULL, NULL, NULL, NULL, 'UCP031900', NULL, NULL, 8211, 11),
(275055, NULL, 'PIRSF002457', NULL, NULL, NULL, NULL, 'DASS', NULL, NULL, 23866, 11),
(275056, NULL, 'PIRSF037943', NULL, NULL, NULL, NULL, 'SPAG7', NULL, NULL, 17463, 11),
(275057, NULL, 'PIRSF028937', NULL, NULL, NULL, NULL, 'Lg_Ch_AO', NULL, NULL, 13184, 11),
(275058, NULL, 'PIRSF039087', NULL, NULL, NULL, NULL, 'L10E', NULL, NULL, 25038, 11),
(275059, NULL, 'PIRSF002412', NULL, NULL, NULL, NULL, 'MA_DBI', NULL, NULL, 20316, 11),
(275060, NULL, 'PIRSF010309', NULL, NULL, NULL, NULL, 'Cyc-rich_prot', NULL, NULL, 17686, 11),
(275061, NULL, 'PIRSF006230', NULL, NULL, NULL, NULL, 'MG442', NULL, NULL, 15225, 11),
(275062, NULL, 'PIRSF021288', NULL, NULL, NULL, NULL, 'YmfK_ACT', NULL, NULL, 15198, 11),
(275063, NULL, 'PIRSF005240', NULL, NULL, NULL, NULL, 'CcmF', NULL, NULL, 302, 11),
(275064, NULL, 'PIRSF028438', NULL, NULL, NULL, NULL, 'UCP028438', NULL, NULL, 16637, 11),
(275065, NULL, 'PIRSF037692', NULL, NULL, NULL, NULL, 'UCP037692', NULL, NULL, 16408, 11),
(275066, NULL, 'PIRSF017205', NULL, NULL, NULL, NULL, 'ERO', NULL, NULL, 6565, 11),
(275067, NULL, 'PIRSF009151', NULL, NULL, NULL, NULL, 'UCP009151', NULL, NULL, 12047, 11),
(275068, NULL, 'PIRSF028153', NULL, NULL, NULL, NULL, 'MshI', NULL, NULL, 16147, 11),
(275069, NULL, 'PIRSF021292', NULL, NULL, NULL, NULL, 'ComGD', NULL, NULL, 15177, 11),
(275070, NULL, 'PIRSF007061', NULL, NULL, NULL, NULL, 'UCP007061', NULL, NULL, 16441, 11),
(275071, NULL, 'PIRSF036504', NULL, NULL, NULL, NULL, 'NDK_H5', NULL, NULL, 13037, 11),
(275072, NULL, 'PIRSF027887', NULL, NULL, NULL, NULL, 'Amidohyd_027887', NULL, NULL, 15055, 11);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(275073, NULL, 'PIRSF001430', NULL, NULL, NULL, NULL, 'PSU-A', NULL, NULL, 7190, 11),
(275074, NULL, 'PIRSF008881', NULL, NULL, NULL, NULL, 'Fhx_P25', NULL, NULL, 14399, 11),
(275075, NULL, 'PIRSF000138', NULL, NULL, NULL, NULL, 'Al-hdrx_acd_dh', NULL, NULL, 13758, 11),
(275076, NULL, 'PIRSF000094', NULL, NULL, NULL, NULL, 'Enoyl-ACP_rdct', NULL, NULL, 11154, 11),
(275077, NULL, 'PIRSF000071', NULL, NULL, NULL, NULL, 'Rubredoxin', NULL, NULL, 25639, 11),
(275078, NULL, 'PIRSF000294', NULL, NULL, NULL, NULL, 'Cytochrome-c_peroxidase', NULL, NULL, 22909, 11),
(275079, NULL, 'PIRSF003108', NULL, NULL, NULL, NULL, 'DinJ', NULL, NULL, 26375, 11),
(275080, NULL, 'PIRSF020196', NULL, NULL, NULL, NULL, 'NS2', NULL, NULL, 21028, 11),
(275081, NULL, 'PIRSF012150', NULL, NULL, NULL, NULL, 'UCP012150', NULL, NULL, 17838, 11),
(275082, NULL, 'PIRSF036893', NULL, NULL, NULL, NULL, 'Lipocalin_ApoD', NULL, NULL, 15048, 11),
(275083, NULL, 'PIRSF000897', NULL, NULL, NULL, NULL, 'Acid_Ptase_ClsA', NULL, NULL, 2024, 11),
(275084, NULL, 'PIRSF002590', NULL, NULL, NULL, NULL, 'HSP9_HSP12', NULL, NULL, 6835, 11),
(275085, NULL, 'PIRSF019217', NULL, NULL, NULL, NULL, 'AcxC', NULL, NULL, 21381, 11),
(275086, NULL, 'PIRSF000821', NULL, NULL, NULL, NULL, 'RdRPol', NULL, NULL, 12152, 11),
(275087, NULL, 'PIRSF018978', NULL, NULL, NULL, NULL, 'tRNA_m1G_Mtase_archaea', NULL, NULL, 21130, 11),
(275088, NULL, 'PIRSF037375', NULL, NULL, NULL, NULL, 'EstA', NULL, NULL, 21151, 11),
(275089, NULL, 'PIRSF006268', NULL, NULL, NULL, NULL, 'ApbE', NULL, NULL, 21855, 11),
(275090, NULL, 'PIRSF016080', NULL, NULL, NULL, NULL, 'RE_MboI', NULL, NULL, 15354, 11),
(275091, NULL, 'PIRSF024492', NULL, NULL, NULL, NULL, 'UCP024492', NULL, NULL, 11381, 11),
(275092, NULL, 'PIRSF028836', NULL, NULL, NULL, NULL, 'ISN1', NULL, NULL, 9173, 11),
(275093, NULL, 'PIRSF000636', NULL, NULL, NULL, NULL, 'TyrPK_Jak', NULL, NULL, 17339, 11),
(275094, NULL, 'PIRSF004395', NULL, NULL, NULL, NULL, 'Tail_Z', NULL, NULL, 9469, 11),
(275095, NULL, 'PIRSF004800', NULL, NULL, NULL, NULL, 'Hmw2', NULL, NULL, 21340, 11),
(275096, NULL, 'PIRSF030962', NULL, NULL, NULL, NULL, 'Dehydrase', NULL, NULL, 17949, 11),
(275097, NULL, 'PIRSF000994', NULL, NULL, NULL, NULL, 'RE_XhoI', NULL, NULL, 2303, 11),
(275098, NULL, 'PIRSF011561', NULL, NULL, NULL, NULL, 'PAD', NULL, NULL, 12207, 11),
(275099, NULL, 'PIRSF003948', NULL, NULL, NULL, NULL, 'N_TospoV', NULL, NULL, 796, 11),
(275100, NULL, 'PIRSF006643', NULL, NULL, NULL, NULL, 'NDUA6', NULL, NULL, 15050, 11),
(275101, NULL, 'PIRSF011503', NULL, NULL, NULL, NULL, 'DdrB_PduH', NULL, NULL, 9934, 11),
(275102, NULL, 'PIRSF006493', NULL, NULL, NULL, NULL, 'Prok_Ku', NULL, NULL, 9701, 11),
(275103, NULL, 'PIRSF002565', NULL, NULL, NULL, NULL, 'Statherin', NULL, NULL, 1519, 11),
(275104, NULL, 'PIRSF036514', NULL, NULL, NULL, NULL, 'Sm_HSP_B1', NULL, NULL, 5462, 11),
(275105, NULL, 'PIRSF006092', NULL, NULL, NULL, NULL, 'GreA_GreB', NULL, NULL, 16389, 11),
(275106, NULL, 'PIRSF016565', NULL, NULL, NULL, NULL, 'PucC', NULL, NULL, 23212, 11),
(275107, NULL, 'PIRSF032025', NULL, NULL, NULL, NULL, 'UCP032025', NULL, NULL, 7714, 11),
(275108, NULL, 'PIRSF038003', NULL, NULL, NULL, NULL, 'PINCH', NULL, NULL, 17037, 11),
(275109, NULL, 'PIRSF000660', NULL, NULL, NULL, NULL, 'STPK_GCN2', NULL, NULL, 17456, 11),
(275110, NULL, 'PIRSF003230', NULL, NULL, NULL, NULL, 'YbgC', NULL, NULL, 2319, 11),
(275111, NULL, 'PIRSF017689', NULL, NULL, NULL, NULL, 'SepSecS', NULL, NULL, 16850, 11),
(275112, NULL, 'PIRSF003767', NULL, NULL, NULL, NULL, 'VAC_I3L', NULL, NULL, 2584, 11),
(275113, NULL, 'PIRSF501177', NULL, NULL, NULL, NULL, 'BoxA', NULL, NULL, 16574, 11),
(275114, NULL, 'PIRSF036612', NULL, NULL, NULL, NULL, 'ABC_ATP_LytTR', NULL, NULL, 11198, 11),
(275115, NULL, 'PIRSF028520', NULL, NULL, NULL, NULL, 'UCP028520', NULL, NULL, 16832, 11),
(275116, NULL, 'PIRSF030748', NULL, NULL, NULL, NULL, 'Autotransporter_YhjY', NULL, NULL, 17987, 11),
(275117, NULL, 'PIRSF018781', NULL, NULL, NULL, NULL, 'UCP018781', NULL, NULL, 12814, 11),
(275118, NULL, 'PIRSF029416', NULL, NULL, NULL, NULL, 'UCP029416_PTP', NULL, NULL, 17186, 11);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(275119, NULL, 'PIRSF016013', NULL, NULL, NULL, NULL, 'AtER_Rer1p', NULL, NULL, 1588, 11),
(275120, NULL, 'PIRSF003265', NULL, NULL, NULL, NULL, 'TraQ', NULL, NULL, 13892, 11),
(275121, NULL, 'PIRSF016753', NULL, NULL, NULL, NULL, 'P_lipid/glycerol_ac_tran', NULL, NULL, 20336, 11),
(275122, NULL, 'PIRSF015415', NULL, NULL, NULL, NULL, 'COG8', NULL, NULL, 19264, 11),
(275123, NULL, 'PIRSF001475', NULL, NULL, NULL, NULL, 'Cyclophilin_E', NULL, NULL, 19686, 11),
(275124, NULL, 'PIRSF002421', NULL, NULL, NULL, NULL, 'L-selectin', NULL, NULL, 20240, 11),
(275125, NULL, 'PIRSF037430', NULL, NULL, NULL, NULL, 'Ribotoxin_alpha-sarcin', NULL, NULL, 2973, 11),
(275126, NULL, 'PIRSF037561', NULL, NULL, NULL, NULL, 'Pardaxin', NULL, NULL, 8738, 11),
(275127, NULL, 'PIRSF021171', NULL, NULL, NULL, NULL, 'UCP022271', NULL, NULL, 15293, 11),
(275128, NULL, 'PIRSF028756', NULL, NULL, NULL, NULL, 'PPK2', NULL, NULL, 16838, 11),
(275129, NULL, 'PIRSF011386', NULL, NULL, NULL, NULL, 'FixH', NULL, NULL, 12668, 11),
(275130, NULL, 'PIRSF500313', NULL, NULL, NULL, NULL, 'Bombyxin_B', NULL, NULL, 25905, 11),
(275131, NULL, 'PIRSF003249', NULL, NULL, NULL, NULL, 'PyrBI_leader_pep', NULL, NULL, 9387, 11),
(275132, NULL, 'PIRSF000767', NULL, NULL, NULL, NULL, 'Sigma_factor_SigC', NULL, NULL, 19227, 11),
(275133, NULL, 'PIRSF007798', NULL, NULL, NULL, NULL, 'UCP007798', NULL, NULL, 16268, 11),
(275134, NULL, 'PIRSF001221', NULL, NULL, NULL, NULL, 'Amidase_fungi', NULL, NULL, NULL, 11),
(275135, NULL, 'PIRSF006716', NULL, NULL, NULL, NULL, 'Spore_CotF', NULL, NULL, 16495, 11),
(275136, NULL, 'PIRSF017222', NULL, NULL, NULL, NULL, 'Transl_init_eIF2A', NULL, NULL, 14547, 11),
(275137, NULL, 'PIRSF006470', NULL, NULL, NULL, NULL, 'DctB', NULL, NULL, 3489, 11),
(275138, NULL, 'PIRSF026389', NULL, NULL, NULL, NULL, 'Ethylen_sen_hybr_HK', NULL, NULL, 11241, 11),
(275139, NULL, 'PIRSF020565', NULL, NULL, NULL, NULL, '3Ho_Ac_ACP_DH', NULL, NULL, 15423, 11),
(275140, NULL, 'PIRSF000260', NULL, NULL, NULL, NULL, 'FTRc', NULL, NULL, 12189, 11),
(275141, NULL, 'PIRSF005355', NULL, NULL, NULL, NULL, 'UBIAD1', NULL, NULL, 21752, 11),
(275142, NULL, 'PIRSF029047', NULL, NULL, NULL, NULL, 'KMTS', NULL, NULL, 15152, 11),
(275143, NULL, 'PIRSF037923', NULL, NULL, NULL, NULL, 'UCP037923', NULL, NULL, 10209, 11),
(275144, NULL, 'PIRSF002116', NULL, NULL, NULL, NULL, 'RPS4a_RPS4e', NULL, NULL, 4627, 11),
(275145, NULL, 'PIRSF037948', NULL, NULL, NULL, NULL, 'ZMYND10', NULL, NULL, 17429, 11),
(275146, NULL, 'PIRSF016509', NULL, NULL, NULL, NULL, 'MtrE', NULL, NULL, 5908, 11),
(275147, NULL, 'PIRSF011452', NULL, NULL, NULL, NULL, 'UCP011452_HNH', NULL, NULL, 17591, 11),
(275148, NULL, 'PIRSF017127', NULL, NULL, NULL, NULL, 'Condensin_D2', NULL, NULL, 505, 11),
(275149, NULL, 'PIRSF000574', NULL, NULL, NULL, NULL, 'STPK_PknK', NULL, NULL, 17428, 11),
(275150, NULL, 'PIRSF000615', NULL, NULL, NULL, NULL, 'TyrPK_CSF1-R', NULL, NULL, NULL, 11),
(275151, NULL, 'PIRSF006305', NULL, NULL, NULL, NULL, 'Maf', NULL, NULL, 2141, 11),
(275152, NULL, 'PIRSF015625', NULL, NULL, NULL, NULL, 'VAC_I1L', NULL, NULL, 766, 11),
(275153, NULL, 'PIRSF037900', NULL, NULL, NULL, NULL, 'Subtilisin_rel_PfSUB_1', NULL, NULL, 16911, 11),
(275154, NULL, 'PIRSF004546', NULL, NULL, NULL, NULL, 'UCP004546', NULL, NULL, 21324, 11),
(275155, NULL, 'PIRSF017209', NULL, NULL, NULL, NULL, 'Memb_At2g17000', NULL, NULL, 20233, 11),
(275156, NULL, 'PIRSF000797', NULL, NULL, NULL, NULL, 'DNA_pol_mitochondrial', NULL, NULL, 361, 11),
(275157, NULL, 'PIRSF005353', NULL, NULL, NULL, NULL, 'PbuG', NULL, NULL, 23169, 11),
(275158, NULL, 'PIRSF004857', NULL, NULL, NULL, NULL, 'Kin_aa_kin', NULL, NULL, 14963, 11),
(275159, NULL, 'PIRSF018168', NULL, NULL, NULL, NULL, 'Beta-mannanase', NULL, NULL, 20439, 11),
(275160, NULL, 'PIRSF037479', NULL, NULL, NULL, NULL, 'Pg_GlcNAc_deacet', NULL, NULL, 15108, 11),
(275161, NULL, 'PIRSF017190', NULL, NULL, NULL, NULL, 'NIP7', NULL, NULL, 20464, 11),
(275162, NULL, 'PIRSF500795', NULL, NULL, NULL, NULL, 'Thiamine_transporter_2', NULL, NULL, 26840, 11);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(275163, NULL, 'PIRSF017290', NULL, NULL, NULL, NULL, 'ROT1', NULL, NULL, 20640, 11),
(275164, NULL, 'PIRSF037844', NULL, NULL, NULL, NULL, 'Vpr-related_protease', NULL, NULL, 16200, 11),
(275165, NULL, 'PIRSF007936', NULL, NULL, NULL, NULL, 'SRB6', NULL, NULL, 16254, 11),
(275166, NULL, 'PIRSF030283', NULL, NULL, NULL, NULL, 'Small_HSP_plant', NULL, NULL, 17798, 11),
(275167, NULL, 'PIRSF012565', NULL, NULL, NULL, NULL, 'UCP012565', NULL, NULL, 14476, 11),
(275168, NULL, 'PIRSF034005', NULL, NULL, NULL, NULL, 'Omp19', NULL, NULL, 8118, 11),
(275169, NULL, 'PIRSF009437', NULL, NULL, NULL, NULL, 'NQR-1_subunit_C', NULL, NULL, 4170, 11),
(275170, NULL, 'PIRSF037196', NULL, NULL, NULL, NULL, 'PvcA', NULL, NULL, 20806, 11),
(275171, NULL, 'PIRSF002773', NULL, NULL, NULL, NULL, 'ABC_prm/ATPase_B', NULL, NULL, NULL, 11),
(275172, NULL, 'PIRSF000830', NULL, NULL, NULL, NULL, 'L_ParamyxoV', NULL, NULL, 19977, 11),
(275173, NULL, 'PIRSF005978', NULL, NULL, NULL, NULL, 'HTH_MJ0621', NULL, NULL, 15279, 11),
(275174, NULL, 'PIRSF006488', NULL, NULL, NULL, NULL, 'ExoVII_small', NULL, NULL, 2204, 11),
(275175, NULL, 'PIRSF036464', NULL, NULL, NULL, NULL, 'Ser_ala_racem', NULL, NULL, 10821, 11),
(275176, NULL, 'PIRSF022080', NULL, NULL, NULL, NULL, 'UCP022080', NULL, NULL, 15485, 11),
(275177, NULL, 'PIRSF002216', NULL, NULL, NULL, NULL, 'MRPL31', NULL, NULL, 20497, 11),
(275178, NULL, 'PIRSF038126', NULL, NULL, NULL, NULL, 'SWI_SNF', NULL, NULL, 18228, 11),
(275179, NULL, 'PIRSF007510', NULL, NULL, NULL, NULL, 'UCP007510', NULL, NULL, 4776, 11),
(275180, NULL, 'PIRSF500144', NULL, NULL, NULL, NULL, 'IODI_III', NULL, NULL, 21696, 11),
(275181, NULL, 'PIRSF027093', NULL, NULL, NULL, NULL, 'EndopolyPtase_N1', NULL, NULL, 12520, 11),
(275182, NULL, 'PIRSF007313', NULL, NULL, NULL, NULL, 'PhnI', NULL, NULL, 12255, 11),
(275183, NULL, 'PIRSF031982', NULL, NULL, NULL, NULL, 'UCP031982_abhydr', NULL, NULL, 17659, 11),
(275184, NULL, 'PIRSF015980', NULL, NULL, NULL, NULL, 'VAC_O1L', NULL, NULL, 2981, 11),
(275185, NULL, 'PIRSF037263', NULL, NULL, NULL, NULL, 'UCP037263', NULL, NULL, 13816, 11),
(275186, NULL, 'PIRSF000178', NULL, NULL, NULL, NULL, 'SDH_cyt_b560', NULL, NULL, 9540, 11),
(275187, NULL, 'PIRSF003950', NULL, NULL, NULL, NULL, 'N_NairoV', NULL, NULL, 6167, 11),
(275188, NULL, 'PIRSF036503', NULL, NULL, NULL, NULL, 'NDK7', NULL, NULL, 8309, 11),
(275189, NULL, 'PIRSF003953', NULL, NULL, NULL, NULL, 'N_PhelboV', NULL, NULL, 9481, 11),
(275190, NULL, 'PIRSF038034', NULL, NULL, NULL, NULL, 'RFXANK', NULL, NULL, 17846, 11),
(275191, NULL, 'PIRSF019239', NULL, NULL, NULL, NULL, 'MrpE', NULL, NULL, 4372, 11),
(275192, NULL, 'PIRSF000524', NULL, NULL, NULL, NULL, 'SPT', NULL, NULL, 12632, 11),
(275193, NULL, 'PIRSF037899', NULL, NULL, NULL, NULL, 'Subtilisin_rel_Moth_2364', NULL, NULL, 16697, 11),
(275194, NULL, 'PIRSF037037', NULL, NULL, NULL, NULL, 'Kelch_gigaxonin', NULL, NULL, 20488, 11),
(275195, NULL, 'PIRSF003027', NULL, NULL, NULL, NULL, 'Txn_fact_GATA-1/2/3', NULL, NULL, 20492, 11),
(275196, NULL, 'PIRSF005053', NULL, NULL, NULL, NULL, 'RNAP_F_arch', NULL, NULL, 8651, 11),
(275197, NULL, 'PIRSF000277', NULL, NULL, NULL, NULL, 'COX_VIa', NULL, NULL, 2116, 11),
(275198, NULL, 'PIRSF005250', NULL, NULL, NULL, NULL, 'UCP005250', NULL, NULL, 15437, 11),
(275199, NULL, 'PIRSF001587', NULL, NULL, NULL, NULL, 'FGAM_synthase_II', NULL, NULL, 2328, 11),
(275200, NULL, 'PIRSF018497', NULL, NULL, NULL, NULL, 'V-ATP_synth_D', NULL, NULL, 21497, 11),
(275201, NULL, 'PIRSF029407', NULL, NULL, NULL, NULL, 'UCP029407', NULL, NULL, 12122, 11),
(275202, NULL, 'PIRSF018300', NULL, NULL, NULL, NULL, 'DNA_pol_alpha_2', NULL, NULL, 21273, 11),
(275203, NULL, 'PIRSF034367', NULL, NULL, NULL, NULL, 'UCP034367', NULL, NULL, 7692, 11),
(275204, NULL, 'PIRSF006557', NULL, NULL, NULL, NULL, 'UCP006557_sign', NULL, NULL, 10990, 11),
(275205, NULL, 'PIRSF004338', NULL, NULL, NULL, NULL, 'Integrase', NULL, NULL, 7898, 11),
(275206, NULL, 'PIRSF038076', NULL, NULL, NULL, NULL, 'US8A', NULL, NULL, 17616, 11),
(275207, NULL, 'PIRSF020431', NULL, NULL, NULL, NULL, 'NapD_delta/epsilon', NULL, NULL, 2641, 11);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(275208, NULL, 'PIRSF037707', NULL, NULL, NULL, NULL, 'TOM20', NULL, NULL, 5326, 11),
(275209, NULL, 'PIRSF036578', NULL, NULL, NULL, NULL, 'RFC1', NULL, NULL, 7163, 11),
(275210, NULL, 'PIRSF000836', NULL, NULL, NULL, NULL, 'L_ArenaV', NULL, NULL, 10282, 11),
(275211, NULL, 'PIRSF039096', NULL, NULL, NULL, NULL, 'p16-ARC', NULL, NULL, 3311, 11),
(275212, NULL, 'PIRSF023577', NULL, NULL, NULL, NULL, 'NOSIP', NULL, NULL, 15183, 11),
(275213, NULL, 'PIRSF037210', NULL, NULL, NULL, NULL, 'TGM_prok', NULL, NULL, 9575, 11),
(275214, NULL, 'PIRSF009471', NULL, NULL, NULL, NULL, 'UCP009471', NULL, NULL, 10702, 11),
(275215, NULL, 'PIRSF017854', NULL, NULL, NULL, NULL, 'TrbD', NULL, NULL, 20440, 11),
(275216, NULL, 'PIRSF007319', NULL, NULL, NULL, NULL, 'UCP007319', NULL, NULL, 16164, 11),
(275217, NULL, 'PIRSF021328', NULL, NULL, NULL, NULL, 'UCP021328', NULL, NULL, 15113, 11),
(275218, NULL, 'PIRSF035009', NULL, NULL, NULL, NULL, 'UCP035009_HSDR_N', NULL, NULL, 18671, 11),
(275219, NULL, 'PIRSF037187', NULL, NULL, NULL, NULL, 'SmB_SmN', NULL, NULL, 20849, 11),
(275220, NULL, 'PIRSF038095', NULL, NULL, NULL, NULL, 'NDUA1', NULL, NULL, 18190, 11),
(275221, NULL, 'PIRSF038134', NULL, NULL, NULL, NULL, 'Toc33/toc34', NULL, NULL, 3562, 11),
(275222, NULL, 'PIRSF500814', NULL, NULL, NULL, NULL, 'PP1_GL', NULL, NULL, 24764, 11),
(275223, NULL, 'PIRSF036599', NULL, NULL, NULL, NULL, 'AtpPhos', NULL, NULL, 7116, 11),
(275224, NULL, 'PIRSF032079', NULL, NULL, NULL, NULL, 'UCP032079', NULL, NULL, 8156, 11),
(275225, NULL, 'PIRSF002603', NULL, NULL, NULL, NULL, 'TEF', NULL, NULL, 20387, 11),
(275226, NULL, 'PIRSF018193', NULL, NULL, NULL, NULL, 'UCP018193', NULL, NULL, 21345, 11),
(275227, NULL, 'PIRSF016553', NULL, NULL, NULL, NULL, 'BIGH3_OSF2', NULL, NULL, 20496, 11),
(275228, NULL, 'PIRSF017233', NULL, NULL, NULL, NULL, 'IKAP', NULL, NULL, 3521, 11),
(275229, NULL, 'PIRSF037118', NULL, NULL, NULL, NULL, 'TerA', NULL, NULL, 20117, 11),
(275230, NULL, 'PIRSF002279', NULL, NULL, NULL, NULL, 'Notch', NULL, NULL, 8902, 11),
(275231, NULL, 'PIRSF000144', NULL, NULL, NULL, NULL, 'CbbBc', NULL, NULL, NULL, 11),
(275232, NULL, 'PIRSF009158', NULL, NULL, NULL, NULL, 'UCP009158', NULL, NULL, 17763, 11),
(275233, NULL, 'PIRSF015868', NULL, NULL, NULL, NULL, 'HP0120', NULL, NULL, 14378, 11),
(275234, NULL, 'PIRSF037392', NULL, NULL, NULL, NULL, 'AMHRII', NULL, NULL, 12175, 11),
(275235, NULL, 'PIRSF037565', NULL, NULL, NULL, NULL, 'RRNA_m2G_Mtase_RsmD', NULL, NULL, 15370, 11),
(275236, NULL, 'PIRSF037249', NULL, NULL, NULL, NULL, 'Histone_Mtase_SET', NULL, NULL, 21191, 11),
(275237, NULL, 'PIRSF030823', NULL, NULL, NULL, NULL, 'UCP030823_PK_HhH', NULL, NULL, 17508, 11),
(275238, NULL, 'PIRSF001072', NULL, NULL, NULL, NULL, 'HN_paramyxo', NULL, NULL, 19624, 11),
(275239, NULL, 'PIRSF000932', NULL, NULL, NULL, NULL, 'PTPN12', NULL, NULL, 12347, 11),
(275240, NULL, 'PIRSF000083', NULL, NULL, NULL, NULL, 'Allophyco_linker', NULL, NULL, 10350, 11),
(275241, NULL, 'PIRSF037205', NULL, NULL, NULL, NULL, 'UCP037205', NULL, NULL, 20540, 11),
(275242, NULL, 'PIRSF037852', NULL, NULL, NULL, NULL, 'Subtilisin_rel_SAV5721', NULL, NULL, 16960, 11),
(275243, NULL, 'PIRSF033399', NULL, NULL, NULL, NULL, 'UCP033399', NULL, NULL, 11719, 11),
(275244, NULL, 'PIRSF038175', NULL, NULL, NULL, NULL, 'MAPKKK14', NULL, NULL, 18039, 11),
(275245, NULL, 'PIRSF002867', NULL, NULL, NULL, NULL, 'CheV', NULL, NULL, 13467, 11),
(275246, NULL, 'PIRSF000491', NULL, NULL, NULL, NULL, 'Alt_phage', NULL, NULL, 17263, 11),
(275247, NULL, 'PIRSF000471', NULL, NULL, NULL, NULL, 'Alpha_GT', NULL, NULL, 17242, 11),
(275248, NULL, 'PIRSF000102', NULL, NULL, NULL, NULL, 'Lac_mal_DH', NULL, NULL, 5752, 11),
(275249, NULL, 'PIRSF020467', NULL, NULL, NULL, NULL, 'RE_Tsp45I', NULL, NULL, 10106, 11),
(275250, NULL, 'PIRSF019260', NULL, NULL, NULL, NULL, 'PBSX_XkdE', NULL, NULL, 21013, 11),
(275251, NULL, 'PIRSF033722', NULL, NULL, NULL, NULL, 'DnaD_CA_C3587', NULL, NULL, 18680, 11),
(275252, NULL, 'PIRSF000025', NULL, NULL, NULL, NULL, 'Cytochrome_Bsub_c550', NULL, NULL, 13832, 11);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(275253, NULL, 'PIRSF002341', NULL, NULL, NULL, NULL, 'Dystrophin_utrophin', NULL, NULL, 33312, 11),
(275254, NULL, 'PIRSF036979', NULL, NULL, NULL, NULL, 'Arginase', NULL, NULL, 2546, 11),
(275255, NULL, 'PIRSF006606', NULL, NULL, NULL, NULL, 'UCP006606', NULL, NULL, 106, 11),
(275256, NULL, 'PIRSF037087', NULL, NULL, NULL, NULL, 'UCP037087', NULL, NULL, 20357, 11),
(275257, NULL, 'PIRSF016567', NULL, NULL, NULL, NULL, 'IFNAR1', NULL, NULL, 20079, 11),
(275258, NULL, 'PIRSF001024', NULL, NULL, NULL, NULL, 'Alph-amyl_fung', NULL, NULL, 11336, 11),
(275259, NULL, 'PIRSF005028', NULL, NULL, NULL, NULL, 'KhtT', NULL, NULL, 24994, 11),
(275260, NULL, 'PIRSF000732', NULL, NULL, NULL, NULL, 'PTS_enzyme_I', NULL, NULL, 9539, 11),
(275261, NULL, 'PIRSF037293', NULL, NULL, NULL, NULL, 'ERdj5', NULL, NULL, 15007, 11),
(275262, NULL, 'PIRSF000850', NULL, NULL, NULL, NULL, 'PLD_PSS', NULL, NULL, NULL, 11),
(275263, NULL, 'PIRSF004078', NULL, NULL, NULL, NULL, 'Coat_ilarvirus', NULL, NULL, 21116, 11),
(275264, NULL, 'PIRSF038928', NULL, NULL, NULL, NULL, 'Catalase_clade1-3', NULL, NULL, 587, 11),
(275265, NULL, 'PIRSF029394', NULL, NULL, NULL, NULL, 'UCP029394', NULL, NULL, 17115, 11),
(275266, NULL, 'PIRSF037314', NULL, NULL, NULL, NULL, 'HK_MctS', NULL, NULL, 21234, 11),
(275267, NULL, 'PIRSF037097', NULL, NULL, NULL, NULL, 'AP4_epsilon', NULL, NULL, 20095, 11),
(275268, NULL, 'PIRSF037744', NULL, NULL, NULL, NULL, 'TIR_Ticam', NULL, NULL, 16198, 11),
(275269, NULL, 'PIRSF028763', NULL, NULL, NULL, NULL, 'RNAP3_C34/C39', NULL, NULL, 2219, 11),
(275270, NULL, 'PIRSF002401', NULL, NULL, NULL, NULL, 'GTP-binding_obg', NULL, NULL, 14434, 11),
(275271, NULL, 'PIRSF022936', NULL, NULL, NULL, NULL, 'RAD59_fungi', NULL, NULL, 15365, 11),
(275272, NULL, 'PIRSF009325', NULL, NULL, NULL, NULL, 'PTPRC-associated_protein', NULL, NULL, 17660, 11),
(275273, NULL, 'PIRSF037816', NULL, NULL, NULL, NULL, 'Viral_cyclin', NULL, NULL, 16498, 11),
(275274, NULL, 'PIRSF006363', NULL, NULL, NULL, NULL, 'UCP006363_ACT', NULL, NULL, 9505, 11),
(275275, NULL, 'PIRSF036773', NULL, NULL, NULL, NULL, 'HIRIP5', NULL, NULL, 19545, 11),
(275276, NULL, 'PIRSF000384', NULL, NULL, NULL, NULL, 'PNMTase', NULL, NULL, 3408, 11),
(275277, NULL, 'PIRSF036406', NULL, NULL, NULL, NULL, 'Hept_kin', NULL, NULL, 8021, 11),
(275278, NULL, 'PIRSF015703', NULL, NULL, NULL, NULL, 'UCP015703', NULL, NULL, 9024, 11),
(275279, NULL, 'PIRSF011570', NULL, NULL, NULL, NULL, 'SpoVAD', NULL, NULL, 12125, 11),
(275280, NULL, 'PIRSF004862', NULL, NULL, NULL, NULL, 'FliF', NULL, NULL, 3891, 11),
(275281, NULL, 'PIRSF037332', NULL, NULL, NULL, NULL, 'FucT_metazoa', NULL, NULL, 21060, 11),
(275282, NULL, 'PIRSF000110', NULL, NULL, NULL, NULL, 'G6PD', NULL, NULL, 2174, 11),
(275283, NULL, 'PIRSF003107', NULL, NULL, NULL, NULL, 'PhoU', NULL, NULL, 21969, 11),
(275284, NULL, 'PIRSF005539', NULL, NULL, NULL, NULL, 'F1_peptds', NULL, NULL, 385, 11),
(275285, NULL, 'PIRSF038896', NULL, NULL, NULL, NULL, 'NAPE-PLD', NULL, NULL, 26655, 11),
(275286, NULL, 'PIRSF001361', NULL, NULL, NULL, NULL, 'DAHP_synthase', NULL, NULL, 11346, 11),
(275287, NULL, 'PIRSF018266', NULL, NULL, NULL, NULL, 'FecR', NULL, NULL, 13004, 11),
(275288, NULL, 'PIRSF002371', NULL, NULL, NULL, NULL, 'Alpha-s2-casein', NULL, NULL, 10602, 11),
(275289, NULL, 'PIRSF003376', NULL, NULL, NULL, NULL, 'VP1_PMV', NULL, NULL, 6527, 11),
(275290, NULL, 'PIRSF004749', NULL, NULL, NULL, NULL, 'Pep_def', NULL, NULL, 6229, 11),
(275291, NULL, 'PIRSF031057', NULL, NULL, NULL, NULL, 'TPK1', NULL, NULL, 17983, 11),
(275292, NULL, 'PIRSF036539', NULL, NULL, NULL, NULL, 'CmaT_thioesters', NULL, NULL, 8072, 11),
(275293, NULL, 'PIRSF036641', NULL, NULL, NULL, NULL, 'IMPase_NAD_kin', NULL, NULL, 19008, 11),
(275294, NULL, 'PIRSF000075', NULL, NULL, NULL, NULL, 'Desulforedoxin', NULL, NULL, 10183, 11),
(275295, NULL, 'PIRSF007004', NULL, NULL, NULL, NULL, 'UCP007004', NULL, NULL, 16046, 11),
(275296, NULL, 'PIRSF007635', NULL, NULL, NULL, NULL, 'Mmp_autolysin', NULL, NULL, 16166, 11),
(275297, NULL, 'PIRSF037898', NULL, NULL, NULL, NULL, 'Subtilisin_rel_Sputw3181_3341', NULL, NULL, 16994, 11);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(275298, NULL, 'PIRSF022145', NULL, NULL, NULL, NULL, 'Sulfocyanin', NULL, NULL, 14263, 11),
(275299, NULL, 'PIRSF007036', NULL, NULL, NULL, NULL, 'Elb1', NULL, NULL, 9923, 11),
(275300, NULL, 'PIRSF020408', NULL, NULL, NULL, NULL, 'UCP020408', NULL, NULL, 15172, 11),
(275301, NULL, 'PIRSF036557', NULL, NULL, NULL, NULL, 'XdhA_RC', NULL, NULL, 7476, 11),
(275302, NULL, 'PIRSF037834', NULL, NULL, NULL, NULL, 'PaaC', NULL, NULL, 8876, 11),
(275303, NULL, 'PIRSF009935', NULL, NULL, NULL, NULL, 'TCTA', NULL, NULL, 17548, 11),
(275304, NULL, 'PIRSF037354', NULL, NULL, NULL, NULL, 'RtcR', NULL, NULL, 21093, 11),
(275305, NULL, 'PIRSF009998', NULL, NULL, NULL, NULL, 'DLC7', NULL, NULL, 17741, 11),
(275306, NULL, 'PIRSF038151', NULL, NULL, NULL, NULL, 'TOM9-2_plant', NULL, NULL, 18142, 11),
(275307, NULL, 'PIRSF029895', NULL, NULL, NULL, NULL, 'SpoIV', NULL, NULL, 9446, 11),
(275308, NULL, 'PIRSF003097', NULL, NULL, NULL, NULL, 'FtsX', NULL, NULL, 1910, 11),
(275309, NULL, 'PIRSF000532', NULL, NULL, NULL, NULL, 'ATP_PFK_prok', NULL, NULL, 10382, 11),
(275310, NULL, 'PIRSF000036', NULL, NULL, NULL, NULL, 'Cytochrome_PsbE', NULL, NULL, 11484, 11),
(275311, NULL, 'PIRSF006291', NULL, NULL, NULL, NULL, 'GspM', NULL, NULL, 1375, 11),
(275312, NULL, 'PIRSF033860', NULL, NULL, NULL, NULL, 'UCP033860', NULL, NULL, 18667, 11),
(275313, NULL, 'PIRSF029727', NULL, NULL, NULL, NULL, 'UCP029727', NULL, NULL, 17974, 11),
(275314, NULL, 'PIRSF036636', NULL, NULL, NULL, NULL, 'QcrC', NULL, NULL, 11440, 11),
(275315, NULL, 'PIRSF005520', NULL, NULL, NULL, NULL, 'UCP005520', NULL, NULL, 720, 11),
(275316, NULL, 'PIRSF028840', NULL, NULL, NULL, NULL, 'MMP37', NULL, NULL, 10870, 11),
(275317, NULL, 'PIRSF029958', NULL, NULL, NULL, NULL, 'Necrosis-inducing_protein', NULL, NULL, 13440, 11),
(275318, NULL, 'PIRSF000894', NULL, NULL, NULL, NULL, 'Acid_Ptase', NULL, NULL, 19947, 11),
(275319, NULL, 'PIRSF009288', NULL, NULL, NULL, NULL, 'NDUB8', NULL, NULL, 17589, 11),
(275320, NULL, 'PIRSF011489', NULL, NULL, NULL, NULL, 'UCP011489', NULL, NULL, 3565, 11),
(275321, NULL, 'PIRSF003093', NULL, NULL, NULL, NULL, 'SulA', NULL, NULL, 858, 11),
(275322, NULL, 'PIRSF004555', NULL, NULL, NULL, NULL, 'UCP004555', NULL, NULL, 5991, 11),
(275323, NULL, 'PIRSF018867', NULL, NULL, NULL, NULL, 'Na_decarb_PF0672', NULL, NULL, 10634, 11),
(275324, NULL, 'PIRSF005198', NULL, NULL, NULL, NULL, 'SKI2', NULL, NULL, 15350, 11),
(275325, NULL, 'PIRSF003278', NULL, NULL, NULL, NULL, 'SopC', NULL, NULL, 21046, 11),
(275326, NULL, 'PIRSF016021', NULL, NULL, NULL, NULL, 'ESCAROLA', NULL, NULL, 9917, 11),
(275327, NULL, 'PIRSF038023', NULL, NULL, NULL, NULL, 'ANTXR2', NULL, NULL, 17699, 11),
(275328, NULL, 'PIRSF027019', NULL, NULL, NULL, NULL, 'Euk_LigT', NULL, NULL, 10375, 11),
(275329, NULL, 'PIRSF000184', NULL, NULL, NULL, NULL, 'GDH_NAD', NULL, NULL, 17492, 11),
(275330, NULL, 'PIRSF002356', NULL, NULL, NULL, NULL, 'Calreticulin', NULL, NULL, 9610, 11),
(275331, NULL, 'PIRSF018169', NULL, NULL, NULL, NULL, 'PAF_acetylhydrolase', NULL, NULL, 21016, 11),
(275332, NULL, 'PIRSF018503', NULL, NULL, NULL, NULL, 'BMOH_MMO_gamma', NULL, NULL, 3540, 11),
(275333, NULL, 'PIRSF000521', NULL, NULL, NULL, NULL, 'Transaminase_4ab_Lys_Orn', NULL, NULL, 5655, 11),
(275334, NULL, 'PIRSF016433', NULL, NULL, NULL, NULL, 'Viral_DNA_prim', NULL, NULL, 19895, 11),
(275335, NULL, 'PIRSF023925', NULL, NULL, NULL, NULL, 'G0S2', NULL, NULL, 15032, 11),
(275336, NULL, 'PIRSF028944', NULL, NULL, NULL, NULL, 'Beta_gluc_GBA2', NULL, NULL, 12427, 11),
(275337, NULL, 'PIRSF019663', NULL, NULL, NULL, NULL, 'Legumain', NULL, NULL, 1162, 11),
(275338, NULL, 'PIRSF038016', NULL, NULL, NULL, NULL, 'Pin2_TRF1', NULL, NULL, 17565, 11),
(275339, NULL, 'PIRSF000332', NULL, NULL, NULL, NULL, 'FMO', NULL, NULL, 199, 11),
(275340, NULL, 'PIRSF000363', NULL, NULL, NULL, NULL, 'Nitrogenase_iron', NULL, NULL, 4790, 11),
(275341, NULL, 'PIRSF006821', NULL, NULL, NULL, NULL, 'UCP006821', NULL, NULL, 17388, 11),
(275342, NULL, 'PIRSF011312', NULL, NULL, NULL, NULL, 'HUS1', NULL, NULL, 17890, 11);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(275343, NULL, 'PIRSF036983', NULL, NULL, NULL, NULL, 'UCP_2CBS_MJ1404', NULL, NULL, 8403, 11),
(275344, NULL, 'PIRSF002869', NULL, NULL, NULL, NULL, 'MviN', NULL, NULL, 3910, 11),
(275345, NULL, 'PIRSF018747', NULL, NULL, NULL, NULL, 'UCP018747', NULL, NULL, 21470, 11),
(275346, NULL, 'PIRSF028538', NULL, NULL, NULL, NULL, 'UCP028538', NULL, NULL, 14398, 11),
(275347, NULL, 'PIRSF002629', NULL, NULL, NULL, NULL, 'Txn_fact_POU_BRN', NULL, NULL, 20143, 11),
(275348, NULL, 'PIRSF017479', NULL, NULL, NULL, NULL, 'TRAPP_1_Trs31', NULL, NULL, 20363, 11),
(275349, NULL, 'PIRSF028758', NULL, NULL, NULL, NULL, 'Cyclin_C_H_G', NULL, NULL, NULL, 11),
(275350, NULL, 'PIRSF029129', NULL, NULL, NULL, NULL, 'UCP029129', NULL, NULL, 11849, 11),
(275351, NULL, 'PIRSF026568', NULL, NULL, NULL, NULL, 'UCP026568', NULL, NULL, 12074, 11),
(275352, NULL, 'PIRSF008765', NULL, NULL, NULL, NULL, 'PIG-P_GPI19', NULL, NULL, 16402, 11),
(275353, NULL, 'PIRSF020728', NULL, NULL, NULL, NULL, 'Fimbrin_SefA', NULL, NULL, 10266, 11),
(275354, NULL, 'PIRSF000209', NULL, NULL, NULL, NULL, 'Bifunctional_P450_P450R', NULL, NULL, 15839, 11),
(275355, NULL, 'PIRSF032370', NULL, NULL, NULL, NULL, 'VraR', NULL, NULL, 18543, 11),
(275356, NULL, 'PIRSF003338', NULL, NULL, NULL, NULL, 'MAT1', NULL, NULL, 855, 11),
(275357, NULL, 'PIRSF000654', NULL, NULL, NULL, NULL, 'ILK', NULL, NULL, NULL, 11),
(275358, NULL, 'PIRSF031653', NULL, NULL, NULL, NULL, 'UCP031653', NULL, NULL, 17645, 11),
(275359, NULL, 'PIRSF011544', NULL, NULL, NULL, NULL, 'NuiA', NULL, NULL, 12880, 11),
(275360, NULL, 'PIRSF026567', NULL, NULL, NULL, NULL, 'Adenine_mtase_bact', NULL, NULL, 16104, 11),
(275361, NULL, 'PIRSF009180', NULL, NULL, NULL, NULL, 'UCP009180', NULL, NULL, 17880, 11),
(275362, NULL, 'PIRSF015200', NULL, NULL, NULL, NULL, 'Cyclin_WDSV', NULL, NULL, 7178, 11),
(275363, NULL, 'PIRSF006600', NULL, NULL, NULL, NULL, 'UCP006600', NULL, NULL, 10552, 11),
(275364, NULL, 'PIRSF036633', NULL, NULL, NULL, NULL, 'FmdC_D', NULL, NULL, 11024, 11),
(275365, NULL, 'PIRSF006105', NULL, NULL, NULL, NULL, 'NapB', NULL, NULL, 2779, 11),
(275366, NULL, 'PIRSF037258', NULL, NULL, NULL, NULL, 'UCP037258', NULL, NULL, 14210, 11),
(275367, NULL, 'PIRSF002937', NULL, NULL, NULL, NULL, 'Res_reg_Spo0A', NULL, NULL, 11075, 11),
(275368, NULL, 'PIRSF000567', NULL, NULL, NULL, NULL, 'TYPK_Myt1', NULL, NULL, 17159, 11),
(275369, NULL, 'PIRSF003314', NULL, NULL, NULL, NULL, 'IPP_isomerase_FMN-dep', NULL, NULL, 10669, 11),
(275370, NULL, 'PIRSF000006', NULL, NULL, NULL, NULL, 'Cbb3-Cox_fixP', NULL, NULL, 3235, 11),
(275371, NULL, 'PIRSF038097', NULL, NULL, NULL, NULL, 'V-ATP_synth_e1/e2', NULL, NULL, 18367, 11),
(275372, NULL, 'PIRSF034217', NULL, NULL, NULL, NULL, 'UCP_Mll2898', NULL, NULL, 18918, 11),
(275373, NULL, 'PIRSF037299', NULL, NULL, NULL, NULL, 'CRH1', NULL, NULL, 21092, 11),
(275374, NULL, 'PIRSF021940', NULL, NULL, NULL, NULL, 'UCP021940', NULL, NULL, 11145, 11),
(275375, NULL, 'PIRSF013370', NULL, NULL, NULL, NULL, 'ACPS', NULL, NULL, 19400, 11),
(275376, NULL, 'PIRSF021361', NULL, NULL, NULL, NULL, 'UCP021361', NULL, NULL, 15239, 11),
(275377, NULL, 'PIRSF026166', NULL, NULL, NULL, NULL, 'UCP026166', NULL, NULL, 16378, 11),
(275378, NULL, 'PIRSF000032', NULL, NULL, NULL, NULL, 'Cytochrome_b6', NULL, NULL, NULL, 11),
(275379, NULL, 'PIRSF037903', NULL, NULL, NULL, NULL, 'Subtilisin_rel_GFO_2223', NULL, NULL, 16649, 11),
(275380, NULL, 'PIRSF001815', NULL, NULL, NULL, NULL, 'Vasopressin_oxytocin', NULL, NULL, 24, 11),
(275381, NULL, 'PIRSF005715', NULL, NULL, NULL, NULL, 'VPS45_Sec1', NULL, NULL, 5203, 11),
(275382, NULL, 'PIRSF029811', NULL, NULL, NULL, NULL, 'UCP029811', NULL, NULL, 24863, 11),
(275383, NULL, 'PIRSF006594', NULL, NULL, NULL, NULL, 'UCP006594', NULL, NULL, 5464, 11),
(275384, NULL, 'PIRSF001770', NULL, NULL, NULL, NULL, 'Cyclin_CLN', NULL, NULL, 7110, 11),
(275385, NULL, 'PIRSF018326', NULL, NULL, NULL, NULL, 'VP35_FiloV', NULL, NULL, 6557, 11),
(275386, NULL, 'PIRSF005211', NULL, NULL, NULL, NULL, 'Ab_hydro_YheT', NULL, NULL, 10973, 11);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(275387, NULL, 'PIRSF005586', NULL, NULL, NULL, NULL, 'RNApol_RpoM', NULL, NULL, 7498, 11),
(275388, NULL, 'PIRSF008455', NULL, NULL, NULL, NULL, 'UCP008455', NULL, NULL, 9863, 11),
(275389, NULL, 'PIRSF001355', NULL, NULL, NULL, NULL, 'SAM_decarbox_euk', NULL, NULL, 4703, 11),
(275390, NULL, 'PIRSF005052', NULL, NULL, NULL, NULL, 'P-loop_kin_YhbJ', NULL, NULL, 6056, 11),
(275391, NULL, 'PIRSF001959', NULL, NULL, NULL, NULL, 'EPO_receptor', NULL, NULL, 9712, 11),
(275392, NULL, 'PIRSF036960', NULL, NULL, NULL, NULL, 'Neuropilin', NULL, NULL, 8184, 11),
(275393, NULL, 'PIRSF036531', NULL, NULL, NULL, NULL, 'Tpp15', NULL, NULL, 19928, 11),
(275394, NULL, 'PIRSF037532', NULL, NULL, NULL, NULL, 'HK_NtrY', NULL, NULL, 15292, 11),
(275395, NULL, 'PIRSF000883', NULL, NULL, NULL, NULL, 'Pesterase_MJ0912', NULL, NULL, 10469, 11),
(275396, NULL, 'PIRSF003048', NULL, NULL, NULL, NULL, 'Hist_acetylase_PCAF', NULL, NULL, 20428, 11),
(275397, NULL, 'PIRSF017834', NULL, NULL, NULL, NULL, 'NDUC2', NULL, NULL, 8037, 11),
(275398, NULL, 'PIRSF003025', NULL, NULL, NULL, NULL, 'Transl_init_eIF5A', NULL, NULL, 4219, 11),
(275399, NULL, 'PIRSF037125', NULL, NULL, NULL, NULL, 'Nob1', NULL, NULL, 20019, 11),
(275400, NULL, 'PIRSF500939', NULL, NULL, NULL, NULL, 'ERR1-2-3', NULL, NULL, 26449, 11),
(275401, NULL, 'PIRSF038083', NULL, NULL, NULL, NULL, 'UCP038083_GIPC', NULL, NULL, 18177, 11),
(275402, NULL, 'PIRSF037403', NULL, NULL, NULL, NULL, 'BMP3/GDF10', NULL, NULL, 21454, 11),
(275403, NULL, 'PIRSF035823', NULL, NULL, NULL, NULL, 'VirD5_Agrobacterium', NULL, NULL, 3818, 11),
(275404, NULL, 'PIRSF026583', NULL, NULL, NULL, NULL, 'YybT', NULL, NULL, 12386, 11),
(275405, NULL, 'PIRSF038945', NULL, NULL, NULL, NULL, 'Thr_synthase', NULL, NULL, 26070, 11),
(275406, NULL, 'PIRSF016551', NULL, NULL, NULL, NULL, 'SAS5/TFIID_14', NULL, NULL, 20014, 11),
(275407, NULL, 'PIRSF033328', NULL, NULL, NULL, NULL, 'Phest_Mll4975', NULL, NULL, 8167, 11),
(275408, NULL, 'PIRSF006078', NULL, NULL, NULL, NULL, 'GlxK', NULL, NULL, 5633, 11),
(275409, NULL, 'PIRSF035836', NULL, NULL, NULL, NULL, 'UCP035836', NULL, NULL, 8483, 11),
(275410, NULL, 'PIRSF029693', NULL, NULL, NULL, NULL, 'UCP029693', NULL, NULL, 17928, 11),
(275411, NULL, 'PIRSF009310', NULL, NULL, NULL, NULL, 'Mtase_NodS', NULL, NULL, 14750, 11),
(275412, NULL, 'PIRSF005557', NULL, NULL, NULL, NULL, 'Sialyl_trans', NULL, NULL, 7064, 11),
(275413, NULL, 'PIRSF002674', NULL, NULL, NULL, NULL, 'VSP', NULL, NULL, 7233, 11),
(275414, NULL, 'PIRSF022207', NULL, NULL, NULL, NULL, 'UCP022207', NULL, NULL, 15393, 11),
(275415, NULL, 'PIRSF038193', NULL, NULL, NULL, NULL, 'Hyaluronidase', NULL, NULL, 13551, 11),
(275416, NULL, 'PIRSF004357', NULL, NULL, NULL, NULL, 'MCP_bIL170', NULL, NULL, 12145, 11),
(275417, NULL, 'PIRSF029256', NULL, NULL, NULL, NULL, 'SpoU_TrmH', NULL, NULL, 17296, 11),
(275418, NULL, 'PIRSF037677', NULL, NULL, NULL, NULL, 'Msh6', NULL, NULL, 16474, 11),
(275419, NULL, 'PIRSF019455', NULL, NULL, NULL, NULL, 'CopR_AtkY', NULL, NULL, 2883, 11),
(275420, NULL, 'PIRSF018417', NULL, NULL, NULL, NULL, 'FACC_protein', NULL, NULL, 6917, 11),
(275421, NULL, 'PIRSF005790', NULL, NULL, NULL, NULL, 'Nitrogenase_stabiliz_NifW', NULL, NULL, 349, 11),
(275422, NULL, 'PIRSF019307', NULL, NULL, NULL, NULL, 'UCP019307', NULL, NULL, 10648, 11),
(275423, NULL, 'PIRSF024534', NULL, NULL, NULL, NULL, 'ThiW', NULL, NULL, 10433, 11),
(275424, NULL, 'PIRSF004983', NULL, NULL, NULL, NULL, 'MenD', NULL, NULL, 7373, 11),
(275425, NULL, 'PIRSF026532', NULL, NULL, NULL, NULL, 'Mtx2_tox', NULL, NULL, 10353, 11),
(275426, NULL, 'PIRSF033729', NULL, NULL, NULL, NULL, 'UCP033729', NULL, NULL, 8443, 11),
(275427, NULL, 'PIRSF036918', NULL, NULL, NULL, NULL, 'Maltodextrin_glucosidase', NULL, NULL, 19519, 11),
(275428, NULL, 'PIRSF005091', NULL, NULL, NULL, NULL, 'Mmb_sulf_HI1246', NULL, NULL, 7464, 11),
(275429, NULL, 'PIRSF028788', NULL, NULL, NULL, NULL, 'TfoX_Sxy', NULL, NULL, 23389, 11),
(275430, NULL, 'PIRSF028973', NULL, NULL, NULL, NULL, 'DcpS', NULL, NULL, 14311, 11),
(275431, NULL, 'PIRSF032817', NULL, NULL, NULL, NULL, 'UCP032817', NULL, NULL, 18946, 11);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(275432, NULL, 'PIRSF003271', NULL, NULL, NULL, NULL, 'TrbF', NULL, NULL, 21321, 11),
(275433, NULL, 'PIRSF016210', NULL, NULL, NULL, NULL, 'UCP016210', NULL, NULL, 19072, 11),
(275434, NULL, 'PIRSF006223', NULL, NULL, NULL, NULL, 'DsrC_TusE', NULL, NULL, 4858, 11),
(275435, NULL, 'PIRSF000554', NULL, NULL, NULL, NULL, 'PKC_zeta', NULL, NULL, 13842, 11),
(275436, NULL, 'PIRSF009374', NULL, NULL, NULL, NULL, 'RUNX_CBFa', NULL, NULL, 17927, 11),
(275437, NULL, 'PIRSF005457', NULL, NULL, NULL, NULL, 'Glx', NULL, NULL, 19369, 11),
(275438, NULL, 'PIRSF001488', NULL, NULL, NULL, NULL, 'Tdi_protein', NULL, NULL, 15714, 11),
(275439, NULL, 'PIRSF003167', NULL, NULL, NULL, NULL, 'HK_NarX/NarQ', NULL, NULL, 21128, 11),
(275440, NULL, 'PIRSF018953', NULL, NULL, NULL, NULL, 'UCP018953', NULL, NULL, 21101, 11),
(275441, NULL, 'PIRSF000233', NULL, NULL, NULL, NULL, 'Nitr_rd_NADH', NULL, NULL, 13654, 11),
(275442, NULL, 'PIRSF014774', NULL, NULL, NULL, NULL, 'YdgH', NULL, NULL, 24102, 11),
(275443, NULL, 'PIRSF000779', NULL, NULL, NULL, NULL, 'RPB8', NULL, NULL, 1654, 11),
(275444, NULL, 'PIRSF024009', NULL, NULL, NULL, NULL, 'UCP024009', NULL, NULL, 12721, 11),
(275445, NULL, 'PIRSF001924', NULL, NULL, NULL, NULL, 'Shigella_toxin', NULL, NULL, 20390, 11),
(275446, NULL, 'PIRSF002583', NULL, NULL, NULL, NULL, 'HSP90_HTPG', NULL, NULL, 7377, 11),
(275447, NULL, 'PIRSF012293', NULL, NULL, NULL, NULL, 'EutA', NULL, NULL, 14765, 11),
(275448, NULL, 'PIRSF001092', NULL, NULL, NULL, NULL, 'Alpha-L-fucosidase', NULL, NULL, 19622, 11),
(275449, NULL, 'PIRSF018505', NULL, NULL, NULL, NULL, 'Prpndl_dhdrts_sm', NULL, NULL, 3318, 11),
(275450, NULL, 'PIRSF000657', NULL, NULL, NULL, NULL, 'STPK_ASFV', NULL, NULL, 17419, 11),
(275451, NULL, 'PIRSF037930', NULL, NULL, NULL, NULL, 'K_endopeptidase', NULL, NULL, 17074, 11),
(275452, NULL, 'PIRSF026169', NULL, NULL, NULL, NULL, 'UCP026169', NULL, NULL, 10440, 11),
(275453, NULL, 'PIRSF037875', NULL, NULL, NULL, NULL, 'EpiP_NisP_MutP', NULL, NULL, 7968, 11),
(275454, NULL, 'PIRSF036696', NULL, NULL, NULL, NULL, 'ACY-1', NULL, NULL, NULL, 11),
(275455, NULL, 'PIRSF000106', NULL, NULL, NULL, NULL, 'ME', NULL, NULL, 5376, 11),
(275456, NULL, 'PIRSF038157', NULL, NULL, NULL, NULL, 'Cpn21', NULL, NULL, 18338, 11),
(275457, NULL, 'PIRSF036105', NULL, NULL, NULL, NULL, 'VirE3_Rhizobiaceae', NULL, NULL, 10359, 11),
(275458, NULL, 'PIRSF000474', NULL, NULL, NULL, NULL, 'GM2_GD2_synthase', NULL, NULL, 10217, 11),
(275459, NULL, 'PIRSF030219', NULL, NULL, NULL, NULL, 'Heme_oxygenase_decyc_plant', NULL, NULL, 17828, 11),
(275460, NULL, 'PIRSF004954', NULL, NULL, NULL, NULL, 'Radical_SAM', NULL, NULL, 173, 11),
(275461, NULL, 'PIRSF005518', NULL, NULL, NULL, NULL, 'MtrB', NULL, NULL, 13335, 11),
(275462, NULL, 'PIRSF001604', NULL, NULL, NULL, NULL, 'LigA', NULL, NULL, 3390, 11),
(275463, NULL, 'PIRSF034077', NULL, NULL, NULL, NULL, 'UCP034077', NULL, NULL, 8175, 11),
(275464, NULL, 'PIRSF000007', NULL, NULL, NULL, NULL, 'Ubiq_cycred_cyc', NULL, NULL, 9785, 11),
(275465, NULL, 'PIRSF036565', NULL, NULL, NULL, NULL, 'Pyruvt_ip_decrb', NULL, NULL, 12713, 11),
(275466, NULL, 'PIRSF019709', NULL, NULL, NULL, NULL, 'MtxX', NULL, NULL, 21434, 11),
(275467, NULL, 'PIRSF038098', NULL, NULL, NULL, NULL, 'SOX-12/11/4a', NULL, NULL, 18223, 11),
(275468, NULL, 'PIRSF009226', NULL, NULL, NULL, NULL, 'UCP009226_DNArpr', NULL, NULL, 13660, 11),
(275469, NULL, 'PIRSF002148', NULL, NULL, NULL, NULL, 'RPS21e', NULL, NULL, 2160, 11),
(275470, NULL, 'PIRSF037756', NULL, NULL, NULL, NULL, 'MyD88', NULL, NULL, 16313, 11),
(275471, NULL, 'PIRSF005785', NULL, NULL, NULL, NULL, 'Zn-prot_arch', NULL, NULL, 12627, 11),
(275472, NULL, 'PIRSF009103', NULL, NULL, NULL, NULL, 'Ivy', NULL, NULL, 9743, 11),
(275473, NULL, 'PIRSF012622', NULL, NULL, NULL, NULL, 'UCP012622', NULL, NULL, 9627, 11),
(275474, NULL, 'PIRSF016481', NULL, NULL, NULL, NULL, 'PilP_PilQ', NULL, NULL, 4697, 11),
(275475, NULL, 'PIRSF018654', NULL, NULL, NULL, NULL, 'Fe-S_or_NB_arc', NULL, NULL, 10621, 11),
(275476, NULL, 'PIRSF033018', NULL, NULL, NULL, NULL, 'EspD', NULL, NULL, 8047, 11);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(275477, NULL, 'PIRSF038148', NULL, NULL, NULL, NULL, 'Rmt2', NULL, NULL, 18270, 11),
(275478, NULL, 'PIRSF036874', NULL, NULL, NULL, NULL, 'GPC_FiloV', NULL, NULL, 9948, 11),
(275479, NULL, 'PIRSF016195', NULL, NULL, NULL, NULL, 'UCP016195', NULL, NULL, 9866, 11),
(275480, NULL, 'PIRSF005413', NULL, NULL, NULL, NULL, 'COX11', NULL, NULL, 10861, 11),
(275481, NULL, 'PIRSF011859', NULL, NULL, NULL, NULL, 'TNFR_17_CD269', NULL, NULL, 15869, 11),
(275482, NULL, 'PIRSF000699', NULL, NULL, NULL, NULL, 'PTS_IILac_III', NULL, NULL, 3212, 11),
(275483, NULL, 'PIRSF001555', NULL, NULL, NULL, NULL, 'Asp_ammon_ligase', NULL, NULL, 2212, 11),
(275484, NULL, 'PIRSF000207', NULL, NULL, NULL, NULL, 'SiR-FP_CysJ', NULL, NULL, 4240, 11),
(275485, NULL, 'PIRSF003407', NULL, NULL, NULL, NULL, 'Trans_E7_PLV', NULL, NULL, 3941, 11),
(275486, NULL, 'PIRSF017434', NULL, NULL, NULL, NULL, 'NT5C2', NULL, NULL, 20186, 11),
(275487, NULL, 'PIRSF037473', NULL, NULL, NULL, NULL, 'BLOC2_Hps3', NULL, NULL, 15253, 11),
(275488, NULL, 'PIRSF037839', NULL, NULL, NULL, NULL, 'RNase_H', NULL, NULL, 16476, 11),
(275489, NULL, 'PIRSF037759', NULL, NULL, NULL, NULL, 'Asf1', NULL, NULL, 16072, 11),
(275490, NULL, 'PIRSF038927', NULL, NULL, NULL, NULL, 'Catalase_clade2', NULL, NULL, 816, 11),
(275491, NULL, 'PIRSF017029', NULL, NULL, NULL, NULL, 'SRP9', NULL, NULL, 13632, 11),
(275492, NULL, 'PIRSF023381', NULL, NULL, NULL, NULL, 'Mpdu1', NULL, NULL, 15455, 11),
(275493, NULL, 'PIRSF038153', NULL, NULL, NULL, NULL, 'WRKY_txn_fact_IIe', NULL, NULL, NULL, 11),
(275494, NULL, 'PIRSF001495', NULL, NULL, NULL, NULL, 'Met_asp_mut_epsi', NULL, NULL, 5556, 11),
(275495, NULL, 'PIRSF036402', NULL, NULL, NULL, NULL, 'Ureas_acces_UreE', NULL, NULL, 13315, 11),
(275496, NULL, 'PIRSF000077', NULL, NULL, NULL, NULL, 'Thioredoxin', NULL, NULL, 4997, 11),
(275497, NULL, 'PIRSF000972', NULL, NULL, NULL, NULL, 'Arylsulf_plant', NULL, NULL, 12661, 11),
(275498, NULL, 'PIRSF011237', NULL, NULL, NULL, NULL, 'GpU', NULL, NULL, 9979, 11),
(275499, NULL, 'PIRSF007312', NULL, NULL, NULL, NULL, 'Inner_mem_YidI', NULL, NULL, 16296, 11),
(275500, NULL, 'PIRSF036592', NULL, NULL, NULL, NULL, 'Methlestr_CheB', NULL, NULL, 12211, 11),
(275501, NULL, 'PIRSF004729', NULL, NULL, NULL, NULL, 'MutL', NULL, NULL, 11071, 11),
(275502, NULL, 'PIRSF001426', NULL, NULL, NULL, NULL, 'NHase_alpha', NULL, NULL, 18175, 11),
(275503, NULL, 'PIRSF032162', NULL, NULL, NULL, NULL, 'UCP032162_imp', NULL, NULL, 18882, 11),
(275504, NULL, 'PIRSF000009', NULL, NULL, NULL, NULL, 'Cytochrome_c551', NULL, NULL, 20242, 11),
(275505, NULL, 'PIRSF019454', NULL, NULL, NULL, NULL, 'UCP019454_CBS_PAB0389', NULL, NULL, 21199, 11),
(275506, NULL, 'PIRSF039073', NULL, NULL, NULL, NULL, 'BRR2', NULL, NULL, NULL, 11),
(275507, NULL, 'PIRSF003401', NULL, NULL, NULL, NULL, 'Trans_E5_PLV', NULL, NULL, 9176, 11),
(275508, NULL, 'PIRSF037149', NULL, NULL, NULL, NULL, 'NirB', NULL, NULL, 20414, 11),
(275509, NULL, 'PIRSF006334', NULL, NULL, NULL, NULL, 'Cdd_plus_pseudo', NULL, NULL, NULL, 11),
(275510, NULL, 'PIRSF008716', NULL, NULL, NULL, NULL, 'Ufc1', NULL, NULL, 11952, 11),
(275511, NULL, 'PIRSF031088', NULL, NULL, NULL, NULL, 'UCP031088_abhydr', NULL, NULL, 17830, 11),
(275512, NULL, 'PIRSF038995', NULL, NULL, NULL, NULL, 'SRP68', NULL, NULL, 26153, 11),
(275513, NULL, 'PIRSF005799', NULL, NULL, NULL, NULL, 'UDP-gal_transpt', NULL, NULL, 7432, 11),
(275514, NULL, 'PIRSF006503', NULL, NULL, NULL, NULL, 'UCP006503', NULL, NULL, 57, 11),
(275515, NULL, 'PIRSF005636', NULL, NULL, NULL, NULL, 'McrD', NULL, NULL, 4089, 11),
(275516, NULL, 'PIRSF037575', NULL, NULL, NULL, NULL, 'SBP', NULL, NULL, 15117, 11),
(275517, NULL, 'PIRSF000853', NULL, NULL, NULL, NULL, 'PPDK', NULL, NULL, 10902, 11),
(275518, NULL, 'PIRSF000774', NULL, NULL, NULL, NULL, 'RpoN', NULL, NULL, 4668, 11),
(275519, NULL, 'PIRSF006336', NULL, NULL, NULL, NULL, 'B-gal', NULL, NULL, 22709, 11),
(275520, NULL, 'PIRSF000803', NULL, NULL, NULL, NULL, 'DNA_pol_II_small_arch', NULL, NULL, 10206, 11),
(275521, NULL, 'PIRSF002133', NULL, NULL, NULL, NULL, 'RPS12p_RPS12a_RPS23e_RPS12o', NULL, NULL, 1086, 11);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(275522, NULL, 'PIRSF015558', NULL, NULL, NULL, NULL, 'Txn_reg_DeoR', NULL, NULL, 19440, 11),
(275523, NULL, 'PIRSF032656', NULL, NULL, NULL, NULL, 'Glycosylhydrolase_', NULL, NULL, 18526, 11),
(275524, NULL, 'PIRSF000157', NULL, NULL, NULL, NULL, 'Oxoglu_dh_E1', NULL, NULL, 11158, 11),
(275525, NULL, 'PIRSF015982', NULL, NULL, NULL, NULL, 'VAC_M2L', NULL, NULL, 5902, 11),
(275526, NULL, 'PIRSF006483', NULL, NULL, NULL, NULL, 'Membrane_protein_YitT', NULL, NULL, 2411, 11),
(275527, NULL, 'PIRSF006704', NULL, NULL, NULL, NULL, 'TFIIS', NULL, NULL, 8176, 11),
(275528, NULL, 'PIRSF011576', NULL, NULL, NULL, NULL, 'YabP', NULL, NULL, 12776, 11),
(275529, NULL, 'PIRSF036836', NULL, NULL, NULL, NULL, 'SBP1_RNase_bind', NULL, NULL, 19730, 11),
(275530, NULL, 'PIRSF009427', NULL, NULL, NULL, NULL, 'UCP009427_DNAmts', NULL, NULL, 9924, 11),
(275531, NULL, 'PIRSF036298', NULL, NULL, NULL, NULL, 'FDH_4Fe4S', NULL, NULL, 8193, 11),
(275532, NULL, 'PIRSF002572', NULL, NULL, NULL, NULL, 'PIP-GCDFP-15', NULL, NULL, 4216, 11),
(275533, NULL, 'PIRSF030150', NULL, NULL, NULL, NULL, 'SrtB', NULL, NULL, 9293, 11),
(275534, NULL, 'PIRSF000194', NULL, NULL, NULL, NULL, 'DHFR', NULL, NULL, 11718, 11),
(275535, NULL, 'PIRSF037369', NULL, NULL, NULL, NULL, 'STPK_unc51', NULL, NULL, 21338, 11),
(275536, NULL, 'PIRSF006614', NULL, NULL, NULL, NULL, 'Methylglyox_syn', NULL, NULL, 5073, 11),
(275537, NULL, 'PIRSF000196', NULL, NULL, NULL, NULL, 'Pro_dehydrog', NULL, NULL, 665, 11),
(275538, NULL, 'PIRSF001152', NULL, NULL, NULL, NULL, 'HGF_MST1', NULL, NULL, 12848, 11),
(275539, NULL, 'PIRSF022260', NULL, NULL, NULL, NULL, 'UCP022260', NULL, NULL, 15473, 11),
(275540, NULL, 'PIRSF000376', NULL, NULL, NULL, NULL, 'ACDS_gamma', NULL, NULL, 17425, 11),
(275541, NULL, 'PIRSF002756', NULL, NULL, NULL, NULL, 'PstS', NULL, NULL, 3523, 11),
(275542, NULL, 'PIRSF018249', NULL, NULL, NULL, NULL, 'MyrA', NULL, NULL, 21235, 11),
(275543, NULL, 'PIRSF011769', NULL, NULL, NULL, NULL, 'RAD17', NULL, NULL, 17606, 11),
(275544, NULL, 'PIRSF017349', NULL, NULL, NULL, NULL, 'UCP017349', NULL, NULL, 10341, 11),
(275545, NULL, 'PIRSF006118', NULL, NULL, NULL, NULL, 'KDO8-P_Ptase', NULL, NULL, 5088, 11),
(275546, NULL, 'PIRSF010631', NULL, NULL, NULL, NULL, 'A-rhamnsds', NULL, NULL, 9944, 11),
(275547, NULL, 'PIRSF005508', NULL, NULL, NULL, NULL, 'Arsen_res_ArsB', NULL, NULL, 3315, 11),
(275548, NULL, 'PIRSF036949', NULL, NULL, NULL, NULL, 'RPA32', NULL, NULL, 8258, 11),
(275549, NULL, 'PIRSF001786', NULL, NULL, NULL, NULL, 'StpA_StpB', NULL, NULL, 20391, 11),
(275550, NULL, 'PIRSF012943', NULL, NULL, NULL, NULL, 'UCP012943', NULL, NULL, 19418, 11),
(275551, NULL, 'PIRSF006453', NULL, NULL, NULL, NULL, 'FwdA', NULL, NULL, 10873, 11),
(275552, NULL, 'PIRSF028977', NULL, NULL, NULL, NULL, 'Noc3', NULL, NULL, 17360, 11),
(275553, NULL, 'PIRSF001997', NULL, NULL, NULL, NULL, 'PTPRR', NULL, NULL, 20052, 11),
(275554, NULL, 'PIRSF037254', NULL, NULL, NULL, NULL, 'Gremlin', NULL, NULL, 21495, 11),
(275555, NULL, 'PIRSF037712', NULL, NULL, NULL, NULL, 'TIP-1', NULL, NULL, 16246, 11),
(275556, NULL, 'PIRSF018982', NULL, NULL, NULL, NULL, 'EutC', NULL, NULL, 13604, 11),
(275557, NULL, 'PIRSF028345', NULL, NULL, NULL, NULL, 'UCP028345', NULL, NULL, 16733, 11),
(275558, NULL, 'PIRSF001653', NULL, NULL, NULL, NULL, 'API-B', NULL, NULL, 19890, 11),
(275559, NULL, 'PIRSF000705', NULL, NULL, NULL, NULL, 'DNK', NULL, NULL, 2632, 11),
(275560, NULL, 'PIRSF016104', NULL, NULL, NULL, NULL, 'PIG-C', NULL, NULL, 9048, 11),
(275561, NULL, 'PIRSF009400', NULL, NULL, NULL, NULL, 'Hedgehog', NULL, NULL, 5310, 11),
(275562, NULL, 'PIRSF012296', NULL, NULL, NULL, NULL, 'EutS_PduU', NULL, NULL, 13878, 11),
(275563, NULL, 'PIRSF029195', NULL, NULL, NULL, NULL, 'UCP029195_PTS_EIIA2', NULL, NULL, 17417, 11),
(275564, NULL, 'PIRSF037429', NULL, NULL, NULL, NULL, 'UCP037429', NULL, NULL, 14605, 11),
(275565, NULL, 'PIRSF017020', NULL, NULL, NULL, NULL, 'ASTE', NULL, NULL, 20010, 11),
(275566, NULL, 'PIRSF036704', NULL, NULL, NULL, NULL, 'UCP036704', NULL, NULL, 8836, 11);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(275567, NULL, 'PIRSF019205', NULL, NULL, NULL, NULL, 'UCP019205_transporter', NULL, NULL, 14111, 11),
(275568, NULL, 'PIRSF013684', NULL, NULL, NULL, NULL, 'BBS2', NULL, NULL, 19423, 11),
(275569, NULL, 'PIRSF035040', NULL, NULL, NULL, NULL, 'UCP_CBS_Lmo0553', NULL, NULL, 18730, 11),
(275570, NULL, 'PIRSF030791', NULL, NULL, NULL, NULL, 'UCP030791', NULL, NULL, 17707, 11),
(275571, NULL, 'PIRSF039026', NULL, NULL, NULL, NULL, 'SiaP', NULL, NULL, 24893, 11),
(275572, NULL, 'PIRSF006588', NULL, NULL, NULL, NULL, 'TyrRS_arch_euk', NULL, NULL, 7924, 11),
(275573, NULL, 'PIRSF012637', NULL, NULL, NULL, NULL, 'UCP012637', NULL, NULL, 17559, 11),
(275574, NULL, 'PIRSF017246', NULL, NULL, NULL, NULL, 'TFIID_TAF10', NULL, NULL, 6013, 11),
(275575, NULL, 'PIRSF004155', NULL, NULL, NULL, NULL, 'Phage_C', NULL, NULL, 21111, 11),
(275576, NULL, 'PIRSF001775', NULL, NULL, NULL, NULL, 'Thrombomodulin', NULL, NULL, NULL, 11),
(275577, NULL, 'PIRSF004532', NULL, NULL, NULL, NULL, 'GlpX', NULL, NULL, 7391, 11),
(275578, NULL, 'PIRSF000788', NULL, NULL, NULL, NULL, 'DNA_pol_ADV', NULL, NULL, 12355, 11),
(275579, NULL, 'PIRSF002551', NULL, NULL, NULL, NULL, 'Hemopexin', NULL, NULL, 20259, 11),
(275580, NULL, 'PIRSF037343', NULL, NULL, NULL, NULL, 'PTSIIBC_sugar', NULL, NULL, 21348, 11),
(275581, NULL, 'PIRSF036659', NULL, NULL, NULL, NULL, 'BdbC', NULL, NULL, 12821, 11),
(275582, NULL, 'PIRSF036687', NULL, NULL, NULL, NULL, 'AcnB', NULL, NULL, 5664, 11),
(275583, NULL, 'PIRSF005758', NULL, NULL, NULL, NULL, 'Shikimt_kin_arch', NULL, NULL, 4456, 11),
(275584, NULL, 'PIRSF001123', NULL, NULL, NULL, NULL, 'PepA_GA', NULL, NULL, 5178, 11),
(275585, NULL, 'PIRSF001213', NULL, NULL, NULL, NULL, 'MCP', NULL, NULL, 19987, 11),
(275586, NULL, 'PIRSF500216', NULL, NULL, NULL, NULL, 'DltB', NULL, NULL, 16057, 11),
(275587, NULL, 'PIRSF003962', NULL, NULL, NULL, NULL, 'M_poly_NairoV', NULL, NULL, 12752, 11),
(275588, NULL, 'PIRSF038992', NULL, NULL, NULL, NULL, 'Aldolase_Ia', NULL, NULL, 29842, 11),
(275589, NULL, 'PIRSF000611', NULL, NULL, NULL, NULL, 'STPK_MPS1', NULL, NULL, 17357, 11),
(275590, NULL, 'PIRSF011124', NULL, NULL, NULL, NULL, 'MRP63', NULL, NULL, 18000, 11),
(275591, NULL, 'PIRSF018327', NULL, NULL, NULL, NULL, 'VP40_FiloV', NULL, NULL, 9741, 11),
(275592, NULL, 'PIRSF002466', NULL, NULL, NULL, NULL, 'Glycophorin', NULL, NULL, 1317, 11),
(275593, NULL, 'PIRSF020634', NULL, NULL, NULL, NULL, 'TerY_vWA', NULL, NULL, 7774, 11),
(275594, NULL, 'PIRSF000185', NULL, NULL, NULL, NULL, 'Glu_DH', NULL, NULL, 11386, 11),
(275595, NULL, 'PIRSF005243', NULL, NULL, NULL, NULL, 'ROO', NULL, NULL, 15238, 11),
(275596, NULL, 'PIRSF015629', NULL, NULL, NULL, NULL, 'VAC_E6R', NULL, NULL, 2955, 11),
(275597, NULL, 'PIRSF005902', NULL, NULL, NULL, NULL, 'DNase_TatD', NULL, NULL, 1636, 11),
(275598, NULL, 'PIRSF023869', NULL, NULL, NULL, NULL, 'MED6_meta/plant', NULL, NULL, 15388, 11),
(275599, NULL, 'PIRSF003113', NULL, NULL, NULL, NULL, 'BolA', NULL, NULL, 2652, 11),
(275600, NULL, 'PIRSF038163', NULL, NULL, NULL, NULL, 'ITPK_unchar_domain', NULL, NULL, 12792, 11),
(275601, NULL, 'PIRSF019678', NULL, NULL, NULL, NULL, 'UCP019678', NULL, NULL, 9286, 11),
(275602, NULL, 'PIRSF000081', NULL, NULL, NULL, NULL, 'Phycocyanin', NULL, NULL, 13506, 11),
(275603, NULL, 'PIRSF004923', NULL, NULL, NULL, NULL, 'RseC', NULL, NULL, 22690, 11),
(275604, NULL, 'PIRSF016938', NULL, NULL, NULL, NULL, 'RseA', NULL, NULL, 22842, 11),
(275605, NULL, 'PIRSF036577', NULL, NULL, NULL, NULL, 'PDH_ADH_plant', NULL, NULL, 12193, 11),
(275606, NULL, 'PIRSF037350', NULL, NULL, NULL, NULL, 'Mtase_ZK1128', NULL, NULL, 21209, 11),
(275607, NULL, 'PIRSF003945', NULL, NULL, NULL, NULL, 'M_poly_HantaV', NULL, NULL, 21036, 11),
(275608, NULL, 'PIRSF003092', NULL, NULL, NULL, NULL, 'MinD', NULL, NULL, 24264, 11),
(275609, NULL, 'PIRSF018688', NULL, NULL, NULL, NULL, 'UCP018688', NULL, NULL, 21153, 11),
(275610, NULL, 'PIRSF008757', NULL, NULL, NULL, NULL, 'UCP008757', NULL, NULL, 8541, 11),
(275611, NULL, 'PIRSF000711', NULL, NULL, NULL, NULL, 'PFK27', NULL, NULL, 12219, 11);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(275612, NULL, 'PIRSF007858', NULL, NULL, NULL, NULL, 'ORC4', NULL, NULL, 16053, 11),
(275613, NULL, 'PIRSF038084', NULL, NULL, NULL, NULL, 'HAT1', NULL, NULL, 18282, 11),
(275614, NULL, 'PIRSF004572', NULL, NULL, NULL, NULL, 'SecM', NULL, NULL, 9009, 11),
(275615, NULL, 'PIRSF036951', NULL, NULL, NULL, NULL, 'Mas1', NULL, NULL, 10363, 11),
(275616, NULL, 'PIRSF019169', NULL, NULL, NULL, NULL, 'Tfp_PilM', NULL, NULL, 6703, 11),
(275617, NULL, 'PIRSF010386', NULL, NULL, NULL, NULL, 'RocB', NULL, NULL, 7030, 11),
(275618, NULL, 'PIRSF036572', NULL, NULL, NULL, NULL, 'RPP20', NULL, NULL, 8341, 11),
(275619, NULL, 'PIRSF000952', NULL, NULL, NULL, NULL, 'PLC-gamma', NULL, NULL, 19906, 11),
(275620, NULL, 'PIRSF012569', NULL, NULL, NULL, NULL, 'UCP012569', NULL, NULL, 17972, 11),
(275621, NULL, 'PIRSF500207', NULL, NULL, NULL, NULL, 'MtrA', NULL, NULL, 5513, 11),
(275622, NULL, 'PIRSF037881', NULL, NULL, NULL, NULL, 'Leupaxin', NULL, NULL, 16905, 11),
(275623, NULL, 'PIRSF000137', NULL, NULL, NULL, NULL, 'Alcohol_oxidase', NULL, NULL, 13573, 11),
(275624, NULL, 'PIRSF038001', NULL, NULL, NULL, NULL, 'Caspase_ICE', NULL, NULL, NULL, 11),
(275625, NULL, 'PIRSF005067', NULL, NULL, NULL, NULL, 'Tma_RNA-bind', NULL, NULL, 15097, 11),
(275626, NULL, 'PIRSF005788', NULL, NULL, NULL, NULL, 'NifK', NULL, NULL, 2782, 11),
(275627, NULL, 'PIRSF005229', NULL, NULL, NULL, NULL, 'AO', NULL, NULL, 2676, 11),
(275628, NULL, 'PIRSF015697', NULL, NULL, NULL, NULL, 'UCP015697', NULL, NULL, 19496, 11),
(275629, NULL, 'PIRSF000242', NULL, NULL, NULL, NULL, 'HAO', NULL, NULL, 13913, 11),
(275630, NULL, 'PIRSF037635', NULL, NULL, NULL, NULL, 'BID3', NULL, NULL, 15833, 11),
(275631, NULL, 'PIRSF002721', NULL, NULL, NULL, NULL, 'Surface_antigen_Rickettsia', NULL, NULL, 20192, 11),
(275632, NULL, 'PIRSF004094', NULL, NULL, NULL, NULL, 'Coat_SV', NULL, NULL, 2984, 11),
(275633, NULL, 'PIRSF000812', NULL, NULL, NULL, NULL, 'AAD', NULL, NULL, 10566, 11),
(275634, NULL, 'PIRSF001356', NULL, NULL, NULL, NULL, 'SAM_decarboxylas', NULL, NULL, 9744, 11),
(275635, NULL, 'PIRSF007580', NULL, NULL, NULL, NULL, 'UCP07580', NULL, NULL, 16201, 11),
(275636, NULL, 'PIRSF019574', NULL, NULL, NULL, NULL, 'Periplasmic_polyamine_BP', NULL, NULL, 1236, 11),
(275637, NULL, 'PIRSF005897', NULL, NULL, NULL, NULL, 'RR_PatA', NULL, NULL, 13629, 11),
(275638, NULL, 'PIRSF028304', NULL, NULL, NULL, NULL, 'UCP028304', NULL, NULL, 7743, 11),
(275639, NULL, 'PIRSF010521', NULL, NULL, NULL, NULL, 'Secr_Zn_protease', NULL, NULL, 8810, 11),
(275640, NULL, 'PIRSF027717', NULL, NULL, NULL, NULL, 'H4K20_HMTase', NULL, NULL, 16145, 11),
(275641, NULL, 'PIRSF014405', NULL, NULL, NULL, NULL, 'UCP014405', NULL, NULL, 13288, 11),
(275642, NULL, 'PIRSF000948', NULL, NULL, NULL, NULL, 'Sphingomyelin_Pdiesterase', NULL, NULL, 10594, 11),
(275643, NULL, 'PIRSF032437', NULL, NULL, NULL, NULL, 'UCP032437', NULL, NULL, 8271, 11),
(275644, NULL, 'PIRSF011468', NULL, NULL, NULL, NULL, 'PhnJ', NULL, NULL, 8263, 11),
(275645, NULL, 'PIRSF001257', NULL, NULL, NULL, NULL, 'HIS4', NULL, NULL, 19763, 11),
(275646, NULL, 'PIRSF015626', NULL, NULL, NULL, NULL, 'FdhD', NULL, NULL, 3222, 11),
(275647, NULL, 'PIRSF036585', NULL, NULL, NULL, NULL, 'EchD', NULL, NULL, 7015, 11),
(275648, NULL, 'PIRSF006523', NULL, NULL, NULL, NULL, 'MtrF', NULL, NULL, 10003, 11),
(275649, NULL, 'PIRSF038142', NULL, NULL, NULL, NULL, 'Rhodopsin_bac', NULL, NULL, 18242, 11),
(275650, NULL, 'PIRSF033271', NULL, NULL, NULL, NULL, 'UCP033271', NULL, NULL, 7958, 11),
(275651, NULL, 'PIRSF011572', NULL, NULL, NULL, NULL, 'CodY', NULL, NULL, 14459, 11),
(275652, NULL, 'PIRSF001455', NULL, NULL, NULL, NULL, '3dhq_synth', NULL, NULL, 24672, 11),
(275653, NULL, 'PIRSF036872', NULL, NULL, NULL, NULL, 'L_TospoV', NULL, NULL, 10011, 11),
(275654, NULL, 'PIRSF015592', NULL, NULL, NULL, NULL, 'Pyrrolidone-crbxlat_pptds', NULL, NULL, 6564, 11),
(275655, NULL, 'PIRSF006815', NULL, NULL, NULL, NULL, 'GcvPA', NULL, NULL, 15285, 11),
(275656, NULL, 'PIRSF038054', NULL, NULL, NULL, NULL, 'Nas7_nas8', NULL, NULL, 17656, 11);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(275657, NULL, 'PIRSF031802', NULL, NULL, NULL, NULL, 'UCP031802', NULL, NULL, 17768, 11),
(275658, NULL, 'PIRSF006066', NULL, NULL, NULL, NULL, 'HI0050', NULL, NULL, 3010, 11),
(275659, NULL, 'PIRSF005673', NULL, NULL, NULL, NULL, 'Importin_alpha', NULL, NULL, 21927, 11),
(275660, NULL, 'PIRSF000666', NULL, NULL, NULL, NULL, 'TyrPK_ephrin_receptor', NULL, NULL, 17486, 11),
(275661, NULL, 'PIRSF002697', NULL, NULL, NULL, NULL, 'AmbtV', NULL, NULL, 2638, 11),
(275662, NULL, 'PIRSF018412', NULL, NULL, NULL, NULL, 'TEBP_beta', NULL, NULL, 11794, 11),
(275663, NULL, 'PIRSF006351', NULL, NULL, NULL, NULL, 'PTS_EIIC-Cellobiose', NULL, NULL, 5430, 11),
(275664, NULL, 'PIRSF013232', NULL, NULL, NULL, NULL, 'UCP013232', NULL, NULL, 19392, 11),
(275665, NULL, 'PIRSF037002', NULL, NULL, NULL, NULL, 'RNA_ed_MP63', NULL, NULL, 19859, 11),
(275666, NULL, 'PIRSF005054', NULL, NULL, NULL, NULL, 'PF1131', NULL, NULL, 10582, 11),
(275667, NULL, 'PIRSF037000', NULL, NULL, NULL, NULL, 'RNA_ed_MP18', NULL, NULL, 19942, 11),
(275668, NULL, 'PIRSF037653', NULL, NULL, NULL, NULL, 'SRY', NULL, NULL, 15742, 11),
(275669, NULL, 'PIRSF037724', NULL, NULL, NULL, NULL, 'Txn_reg_HTH_MJ1545', NULL, NULL, 16251, 11),
(275670, NULL, 'PIRSF007531', NULL, NULL, NULL, NULL, 'CPT', NULL, NULL, 12011, 11),
(275671, NULL, 'PIRSF000719', NULL, NULL, NULL, NULL, 'AceK', NULL, NULL, 10307, 11),
(275672, NULL, 'PIRSF039114', NULL, NULL, NULL, NULL, 'V-ATPsynth_beta/V-ATPase_B', NULL, NULL, 17381, 11),
(275673, NULL, 'PIRSF500950', NULL, NULL, NULL, NULL, 'Alpha-PDGF_receptor', NULL, NULL, 22211, 11),
(275674, NULL, 'PIRSF037894', NULL, NULL, NULL, NULL, 'Subtilisin_rel_CspABC', NULL, NULL, 16741, 11),
(275675, NULL, 'PIRSF000535', NULL, NULL, NULL, NULL, '1PFK/6PFK/LacC', NULL, NULL, 15890, 11),
(275676, NULL, 'PIRSF009554', NULL, NULL, NULL, NULL, 'UCP009554', NULL, NULL, 10509, 11),
(275677, NULL, 'PIRSF037014', NULL, NULL, NULL, NULL, 'SNF1LK_vert', NULL, NULL, 19884, 11),
(275678, NULL, 'PIRSF037334', NULL, NULL, NULL, NULL, 'FucT_plant', NULL, NULL, 21467, 11),
(275679, NULL, 'PIRSF000084', NULL, NULL, NULL, NULL, 'Phytochrome_conventional', NULL, NULL, 13522, 11),
(275680, NULL, 'PIRSF000808', NULL, NULL, NULL, NULL, 'GalT', NULL, NULL, 4254, 11),
(275681, NULL, 'PIRSF001386', NULL, NULL, NULL, NULL, 'Trpase', NULL, NULL, 10906, 11),
(275682, NULL, 'PIRSF006173', NULL, NULL, NULL, NULL, 'UCP006173', NULL, NULL, 714, 11),
(275683, NULL, 'PIRSF036397', NULL, NULL, NULL, NULL, 'Bacteriophytochrome_rec', NULL, NULL, 10336, 11),
(275684, NULL, 'PIRSF036698', NULL, NULL, NULL, NULL, 'UCP036698', NULL, NULL, 12975, 11),
(275685, NULL, 'PIRSF022603', NULL, NULL, NULL, NULL, 'UCP022603', NULL, NULL, 15407, 11),
(275686, NULL, 'PIRSF010376', NULL, NULL, NULL, NULL, 'IspE', NULL, NULL, 7397, 11),
(275687, NULL, 'PIRSF038159', NULL, NULL, NULL, NULL, 'PP1_16AB', NULL, NULL, 18425, 11),
(275688, NULL, 'PIRSF000485', NULL, NULL, NULL, NULL, 'Pur1', NULL, NULL, 6710, 11),
(275689, NULL, 'PIRSF008142', NULL, NULL, NULL, NULL, 'SH3-bind_E-rich_L', NULL, NULL, 5868, 11),
(275690, NULL, 'PIRSF021573', NULL, NULL, NULL, NULL, 'UCP021573', NULL, NULL, 15373, 11),
(275691, NULL, 'PIRSF006993', NULL, NULL, NULL, NULL, 'UCP006993', NULL, NULL, 16332, 11),
(275692, NULL, 'PIRSF500185', NULL, NULL, NULL, NULL, 'MSP_HGFL', NULL, NULL, 34416, 11),
(275693, NULL, 'PIRSF006769', NULL, NULL, NULL, NULL, 'RibD', NULL, NULL, 5125, 11),
(275694, NULL, 'PIRSF006910', NULL, NULL, NULL, NULL, 'NA_bind_Rv2694c', NULL, NULL, 16357, 11),
(275695, NULL, 'PIRSF031043', NULL, NULL, NULL, NULL, 'UCP031043', NULL, NULL, 16771, 11),
(275696, NULL, 'PIRSF037290', NULL, NULL, NULL, NULL, 'UCP037290', NULL, NULL, 21352, 11),
(275697, NULL, 'PIRSF036899', NULL, NULL, NULL, NULL, 'AGP', NULL, NULL, 3450, 11),
(275698, NULL, 'PIRSF000039', NULL, NULL, NULL, NULL, 'Phenol_monooxy_K', NULL, NULL, 8537, 11),
(275699, NULL, 'PIRSF007519', NULL, NULL, NULL, NULL, 'Protease_InhA', NULL, NULL, 13895, 11),
(275700, NULL, 'PIRSF001103', NULL, NULL, NULL, NULL, 'Endo-b-N-acetylglucosaminidase', NULL, NULL, 19695, 11);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(275701, NULL, 'PIRSF001773', NULL, NULL, NULL, NULL, 'COX10', NULL, NULL, 19823, 11),
(275702, NULL, 'PIRSF009597', NULL, NULL, NULL, NULL, 'UCP009597', NULL, NULL, 17711, 11),
(275703, NULL, 'PIRSF500217', NULL, NULL, NULL, NULL, 'AlgI', NULL, NULL, 26669, 11),
(275704, NULL, 'PIRSF004846', NULL, NULL, NULL, NULL, 'ModA', NULL, NULL, 261, 11),
(275705, NULL, 'PIRSF027377', NULL, NULL, NULL, NULL, 'Nitrile_oxidored_QueF', NULL, NULL, 16179, 11),
(275706, NULL, 'PIRSF003783', NULL, NULL, NULL, NULL, 'VAC_C1L', NULL, NULL, 12463, 11),
(275707, NULL, 'PIRSF016020', NULL, NULL, NULL, NULL, 'PHexose_mutarotase', NULL, NULL, 23537, 11),
(275708, NULL, 'PIRSF018788', NULL, NULL, NULL, NULL, 'EutB', NULL, NULL, 9112, 11),
(275709, NULL, 'PIRSF006019', NULL, NULL, NULL, NULL, 'dCMP_deaminase', NULL, NULL, 15349, 11),
(275710, NULL, 'PIRSF002472', NULL, NULL, NULL, NULL, 'Amyloid_prot_SAA', NULL, NULL, 3847, 11),
(275711, NULL, 'PIRSF001357', NULL, NULL, NULL, NULL, 'DeoC', NULL, NULL, 8631, 11),
(275712, NULL, 'PIRSF004178', NULL, NULL, NULL, NULL, 'DNA_pol_Bac_phage', NULL, NULL, 7886, 11),
(275713, NULL, 'PIRSF031644', NULL, NULL, NULL, NULL, 'UCP031644', NULL, NULL, 7738, 11),
(275714, NULL, 'PIRSF005992', NULL, NULL, NULL, NULL, 'AP_complex_mu', NULL, NULL, 2225, 11),
(275715, NULL, 'PIRSF026991', NULL, NULL, NULL, NULL, 'MND1', NULL, NULL, 2715, 11),
(275716, NULL, 'PIRSF028846', NULL, NULL, NULL, NULL, 'UCP028846', NULL, NULL, 7502, 11),
(275717, NULL, 'PIRSF037158', NULL, NULL, NULL, NULL, 'UCP037158', NULL, NULL, 20333, 11),
(275718, NULL, 'PIRSF036399', NULL, NULL, NULL, NULL, 'Gal_kin_glcsltr', NULL, NULL, 12830, 11),
(275719, NULL, 'PIRSF000478', NULL, NULL, NULL, NULL, 'TP_PyNP', NULL, NULL, 3573, 11),
(275720, NULL, 'PIRSF002304', NULL, NULL, NULL, NULL, 'Band_41', NULL, NULL, NULL, 11),
(275721, NULL, 'PIRSF037632', NULL, NULL, NULL, NULL, 'Rep-8_protein', NULL, NULL, 15967, 11),
(275722, NULL, 'PIRSF038181', NULL, NULL, NULL, NULL, 'NCoA', NULL, NULL, 18241, 11),
(275723, NULL, 'PIRSF015855', NULL, NULL, NULL, NULL, 'TypeIII_Mtase_mKpnI', NULL, NULL, 5791, 11),
(275724, NULL, 'PIRSF000014', NULL, NULL, NULL, NULL, 'Cytochrome_c_torY_torC', NULL, NULL, 9942, 11),
(275725, NULL, 'PIRSF001667', NULL, NULL, NULL, NULL, 'PKI', NULL, NULL, 4249, 11),
(275726, NULL, 'PIRSF016478', NULL, NULL, NULL, NULL, 'Epsilon-COP', NULL, NULL, 3687, 11),
(275727, NULL, 'PIRSF029543', NULL, NULL, NULL, NULL, 'UCP029543', NULL, NULL, 17410, 11),
(275728, NULL, 'PIRSF012535', NULL, NULL, NULL, NULL, 'UCP012535', NULL, NULL, 9674, 11),
(275729, NULL, 'PIRSF021591', NULL, NULL, NULL, NULL, 'UCP021591', NULL, NULL, 15256, 11),
(275730, NULL, 'PIRSF008315', NULL, NULL, NULL, NULL, 'UCP008315', NULL, NULL, 16269, 11),
(275731, NULL, 'PIRSF014897', NULL, NULL, NULL, NULL, 'UCP014897', NULL, NULL, 19389, 11),
(275732, NULL, 'PIRSF036382', NULL, NULL, NULL, NULL, 'RR_antiterminator', NULL, NULL, 7942, 11),
(275733, NULL, 'PIRSF038144', NULL, NULL, NULL, NULL, 'Ladinin-1', NULL, NULL, 18398, 11),
(275734, NULL, 'PIRSF036852', NULL, NULL, NULL, NULL, 'RNase_H1_euk', NULL, NULL, 19960, 11),
(275735, NULL, 'PIRSF001415', NULL, NULL, NULL, NULL, 'Porphbilin_synth', NULL, NULL, 3275, 11),
(275736, NULL, 'PIRSF018432', NULL, NULL, NULL, NULL, 'WbeT', NULL, NULL, 21156, 11),
(275737, NULL, 'PIRSF037236', NULL, NULL, NULL, NULL, 'TaqI', NULL, NULL, 15191, 11),
(275738, NULL, 'PIRSF000915', NULL, NULL, NULL, NULL, 'PGP-type_phosphatase', NULL, NULL, 4516, 11),
(275739, NULL, 'PIRSF039101', NULL, NULL, NULL, NULL, 'LysRS2', NULL, NULL, 19873, 11),
(275740, NULL, 'PIRSF500824', NULL, NULL, NULL, NULL, 'TrpB_prok', NULL, NULL, 4646, 11),
(275741, NULL, 'PIRSF012509', NULL, NULL, NULL, NULL, 'CamS', NULL, NULL, 13991, 11),
(275742, NULL, 'PIRSF015848', NULL, NULL, NULL, NULL, 'TEBP_alpha', NULL, NULL, 5408, 11),
(275743, NULL, 'PIRSF036497', NULL, NULL, NULL, NULL, 'HDH_short', NULL, NULL, 16717, 11),
(275744, NULL, 'PIRSF037673', NULL, NULL, NULL, NULL, 'UCP037673', NULL, NULL, 16460, 11),
(275745, NULL, 'PIRSF020372', NULL, NULL, NULL, NULL, 'Rev_Borrelia', NULL, NULL, 132, 11);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(275746, NULL, 'PIRSF037031', NULL, NULL, NULL, NULL, 'Redox_disulf_2', NULL, NULL, 11040, 11),
(275747, NULL, 'PIRSF000970', NULL, NULL, NULL, NULL, '2_3-cyc_nuc_Pdiesterase', NULL, NULL, 8894, 11),
(275748, NULL, 'PIRSF002144', NULL, NULL, NULL, NULL, 'RPS19p_RPS19a_RPS15e_RPS19o', NULL, NULL, 22, 11),
(275749, NULL, 'PIRSF030786', NULL, NULL, NULL, NULL, 'Lysis_prot_S', NULL, NULL, 6566, 11),
(275750, NULL, 'PIRSF029208', NULL, NULL, NULL, NULL, 'Tail_GPU', NULL, NULL, 17436, 11),
(275751, NULL, 'PIRSF003180', NULL, NULL, NULL, NULL, 'DiGMP_Pdiesterase_YuxH', NULL, NULL, 7960, 11),
(275752, NULL, 'PIRSF030850', NULL, NULL, NULL, NULL, 'UCP030850', NULL, NULL, 7553, 11),
(275753, NULL, 'PIRSF036802', NULL, NULL, NULL, NULL, 'Tau55_TFC7', NULL, NULL, 9725, 11),
(275754, NULL, 'PIRSF000530', NULL, NULL, NULL, NULL, 'Galactokinase', NULL, NULL, 11047, 11),
(275755, NULL, 'PIRSF027202', NULL, NULL, NULL, NULL, 'Ced_4', NULL, NULL, 16303, 11),
(275756, NULL, 'PIRSF015945', NULL, NULL, NULL, NULL, 'V-ATP_synth_F', NULL, NULL, 4797, 11),
(275757, NULL, 'PIRSF019015', NULL, NULL, NULL, NULL, 'P60_peptidase_YkfC', NULL, NULL, 26895, 11),
(275758, NULL, 'PIRSF012159', NULL, NULL, NULL, NULL, 'Inh_gp21', NULL, NULL, 17761, 11),
(275759, NULL, 'PIRSF019714', NULL, NULL, NULL, NULL, 'NLBH', NULL, NULL, 3148, 11),
(275760, NULL, 'PIRSF001296', NULL, NULL, NULL, NULL, 'H/K_exch_ATPase_C', NULL, NULL, 3260, 11),
(275761, NULL, 'PIRSF017245', NULL, NULL, NULL, NULL, 'Phosphoketolase', NULL, NULL, 2786, 11),
(275762, NULL, 'PIRSF037950', NULL, NULL, NULL, NULL, 'E3_ub_ligase_RNF8', NULL, NULL, 17052, 11),
(275763, NULL, 'PIRSF037489', NULL, NULL, NULL, NULL, 'NIF3_YqfO', NULL, NULL, 15041, 11),
(275764, NULL, 'PIRSF037307', NULL, NULL, NULL, NULL, 'Lhr-like_helic', NULL, NULL, 21435, 11),
(275765, NULL, 'PIRSF013217', NULL, NULL, NULL, NULL, 'UCP013217_Opy1', NULL, NULL, 19249, 11),
(275766, NULL, 'PIRSF038079', NULL, NULL, NULL, NULL, 'Torsin-2A', NULL, NULL, 18349, 11),
(275767, NULL, 'PIRSF029681', NULL, NULL, NULL, NULL, 'PagL', NULL, NULL, 15254, 11),
(275768, NULL, 'PIRSF001942', NULL, NULL, NULL, NULL, 'IL-7', NULL, NULL, 1376, 11),
(275769, NULL, 'PIRSF001836', NULL, NULL, NULL, NULL, 'Neuroparsin', NULL, NULL, 11801, 11),
(275770, NULL, 'PIRSF019373', NULL, NULL, NULL, NULL, 'EhaF', NULL, NULL, 10228, 11),
(275771, NULL, 'PIRSF019548', NULL, NULL, NULL, NULL, 'TNF_CD30L', NULL, NULL, 16749, 11),
(275772, NULL, 'PIRSF007349', NULL, NULL, NULL, NULL, 'Tsp_L', NULL, NULL, 6549, 11),
(275773, NULL, 'PIRSF039123', NULL, NULL, NULL, NULL, 'Diphthamide_synthase', NULL, NULL, 24567, 11),
(275774, NULL, 'PIRSF022079', NULL, NULL, NULL, NULL, 'UCP022079', NULL, NULL, 11226, 11),
(275775, NULL, 'PIRSF025798', NULL, NULL, NULL, NULL, 'Cables', NULL, NULL, 13391, 11),
(275776, NULL, 'PIRSF016055', NULL, NULL, NULL, NULL, 'NqrB', NULL, NULL, 2054, 11),
(275777, NULL, 'PIRSF003095', NULL, NULL, NULL, NULL, 'Trigger_factor', NULL, NULL, 10949, 11),
(275778, NULL, 'PIRSF019466', NULL, NULL, NULL, NULL, 'EutH', NULL, NULL, 4901, 11),
(275779, NULL, 'PIRSF028470', NULL, NULL, NULL, NULL, 'UCP028470', NULL, NULL, 16572, 11),
(275780, NULL, 'PIRSF002431', NULL, NULL, NULL, NULL, 'Saposin', NULL, NULL, 15334, 11),
(275781, NULL, 'PIRSF001936', NULL, NULL, NULL, NULL, 'Interferon_gamma', NULL, NULL, 1035, 11),
(275782, NULL, 'PIRSF037610', NULL, NULL, NULL, NULL, 'BLOC-1_mut', NULL, NULL, 15006, 11),
(275783, NULL, 'PIRSF001238', NULL, NULL, NULL, NULL, 'IadA', NULL, NULL, 4493, 11),
(275784, NULL, 'PIRSF028111', NULL, NULL, NULL, NULL, 'UCP028111', NULL, NULL, 16415, 11),
(275785, NULL, 'PIRSF017126', NULL, NULL, NULL, NULL, 'Condensin_H', NULL, NULL, 15305, 11),
(275786, NULL, 'PIRSF027109', NULL, NULL, NULL, NULL, 'Golgi_SNARE', NULL, NULL, 16284, 11),
(275787, NULL, 'PIRSF036883', NULL, NULL, NULL, NULL, 'RR_HD-GYP_mod', NULL, NULL, 9740, 11),
(275788, NULL, 'PIRSF038991', NULL, NULL, NULL, NULL, 'Protein_AbrB', NULL, NULL, 2422, 11),
(275789, NULL, 'PIRSF026492', NULL, NULL, NULL, NULL, 'Dig_cycl_CHASE', NULL, NULL, 16177, 11);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(275790, NULL, 'PIRSF037559', NULL, NULL, NULL, NULL, 'Gly_redC_beta', NULL, NULL, 15134, 11),
(275791, NULL, 'PIRSF037259', NULL, NULL, NULL, NULL, 'ABC_permease_EcsB', NULL, NULL, 7966, 11),
(275792, NULL, 'PIRSF000906', NULL, NULL, NULL, NULL, 'FBPtase_Bacill', NULL, NULL, 9522, 11),
(275793, NULL, 'PIRSF006517', NULL, NULL, NULL, NULL, 'DNA_pol_mt_plasmid', NULL, NULL, 10431, 11),
(275794, NULL, 'PIRSF018863', NULL, NULL, NULL, NULL, 'UCP018863', NULL, NULL, 10783, 11),
(275795, NULL, 'PIRSF031279', NULL, NULL, NULL, NULL, 'UCP031279', NULL, NULL, 17771, 11),
(275796, NULL, 'PIRSF007802', NULL, NULL, NULL, NULL, 'ATG10', NULL, NULL, 16178, 11),
(275797, NULL, 'PIRSF029730', NULL, NULL, NULL, NULL, 'UCP029730', NULL, NULL, 10570, 11),
(275798, NULL, 'PIRSF031509', NULL, NULL, NULL, NULL, 'LiaF_YvqF', NULL, NULL, 17536, 11),
(275799, NULL, 'PIRSF030250', NULL, NULL, NULL, NULL, 'Ptase_At2g46880', NULL, NULL, 10617, 11),
(275800, NULL, 'PIRSF500136', NULL, NULL, NULL, NULL, 'UDP_ManNAc_DH', NULL, NULL, 26544, 11),
(275801, NULL, 'PIRSF021362', NULL, NULL, NULL, NULL, 'UCP021362_HAD', NULL, NULL, 10087, 11),
(275802, NULL, 'PIRSF012335', NULL, NULL, NULL, NULL, 'UCP012335', NULL, NULL, 17780, 11),
(275803, NULL, 'PIRSF011132', NULL, NULL, NULL, NULL, 'TIG1_latexin_ovocalyxin-32', NULL, NULL, 11678, 11),
(275804, NULL, 'PIRSF012560', NULL, NULL, NULL, NULL, 'UCP012560', NULL, NULL, 13305, 11),
(275805, NULL, 'PIRSF005087', NULL, NULL, NULL, NULL, 'NrdI', NULL, NULL, 7443, 11),
(275806, NULL, 'PIRSF017930', NULL, NULL, NULL, NULL, 'TraM', NULL, NULL, 13431, 11),
(275807, NULL, 'PIRSF036692', NULL, NULL, NULL, NULL, 'SDH_B', NULL, NULL, 2681, 11),
(275808, NULL, 'PIRSF005499', NULL, NULL, NULL, NULL, 'PNPase', NULL, NULL, 7490, 11),
(275809, NULL, 'PIRSF002383', NULL, NULL, NULL, NULL, 'NSG_calcyon', NULL, NULL, 8438, 11),
(275810, NULL, 'PIRSF001388', NULL, NULL, NULL, NULL, 'Trichodiene_synth', NULL, NULL, 10257, 11),
(275811, NULL, 'PIRSF038192', NULL, NULL, NULL, NULL, 'Txn_reg_BtrU', NULL, NULL, 18350, 11),
(275812, NULL, 'PIRSF005650', NULL, NULL, NULL, NULL, 'Uridylate_kin', NULL, NULL, 13143, 11),
(275813, NULL, 'PIRSF028498', NULL, NULL, NULL, NULL, 'UCP028498', NULL, NULL, 16589, 11),
(275814, NULL, 'PIRSF037038', NULL, NULL, NULL, NULL, 'Bombyxin', NULL, NULL, 20200, 11),
(275815, NULL, 'PIRSF005898', NULL, NULL, NULL, NULL, 'CpeC_CpcI', NULL, NULL, 15470, 11),
(275816, NULL, 'PIRSF006615', NULL, NULL, NULL, NULL, 'Zn_crbxpep_Taq', NULL, NULL, 438, 11),
(275817, NULL, 'PIRSF036752', NULL, NULL, NULL, NULL, 'TSase_MJ051', NULL, NULL, 9975, 11),
(275818, NULL, 'PIRSF000545', NULL, NULL, NULL, NULL, 'Pantothenate_kin', NULL, NULL, 736, 11),
(275819, NULL, 'PIRSF004160', NULL, NULL, NULL, NULL, 'Minor_spike_H', NULL, NULL, 3161, 11),
(275820, NULL, 'PIRSF006076', NULL, NULL, NULL, NULL, 'Omp85', NULL, NULL, 14914, 11),
(275821, NULL, 'PIRSF020555', NULL, NULL, NULL, NULL, 'UCP020555', NULL, NULL, 11333, 11),
(275822, NULL, 'PIRSF009451', NULL, NULL, NULL, NULL, 'Citrt_lyas_alpha', NULL, NULL, 6450, 11),
(275823, NULL, 'PIRSF034834', NULL, NULL, NULL, NULL, 'PduT', NULL, NULL, 10654, 11),
(275824, NULL, 'PIRSF021389', NULL, NULL, NULL, NULL, 'UCP021389', NULL, NULL, 15125, 11),
(275825, NULL, 'PIRSF030561', NULL, NULL, NULL, NULL, 'UCP030561', NULL, NULL, 7805, 11),
(275826, NULL, 'PIRSF001747', NULL, NULL, NULL, NULL, 'Red1', NULL, NULL, 12810, 11),
(275827, NULL, 'PIRSF501178', NULL, NULL, NULL, NULL, 'FNR-PetH', NULL, NULL, 29908, 11),
(275828, NULL, 'PIRSF006431', NULL, NULL, NULL, NULL, 'Pro_iminopeptidase', NULL, NULL, 138, 11),
(275829, NULL, 'PIRSF002264', NULL, NULL, NULL, NULL, 'Lamprin', NULL, NULL, 8338, 11),
(275830, NULL, 'PIRSF037567', NULL, NULL, NULL, NULL, 'Mtase_MttB', NULL, NULL, 9092, 11),
(275831, NULL, 'PIRSF001413', NULL, NULL, NULL, NULL, 'Trp_syn_beta', NULL, NULL, 15203, 11),
(275832, NULL, 'PIRSF002285', NULL, NULL, NULL, NULL, 'Op18_SCG10', NULL, NULL, 3445, 11),
(275833, NULL, 'PIRSF015897', NULL, NULL, NULL, NULL, 'PRIB5', NULL, NULL, 13484, 11),
(275834, NULL, 'PIRSF028739', NULL, NULL, NULL, NULL, 'Folate/thiamine_transporter', NULL, NULL, 2897, 11);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(275835, NULL, 'PIRSF000018', NULL, NULL, NULL, NULL, 'Mb_ADH_cytochrome_c', NULL, NULL, 11085, 11),
(275836, NULL, 'PIRSF001141', NULL, NULL, NULL, NULL, 'Acrosin', NULL, NULL, 12243, 11),
(275837, NULL, 'PIRSF029595', NULL, NULL, NULL, NULL, 'LecB', NULL, NULL, 17035, 11),
(275838, NULL, 'PIRSF036643', NULL, NULL, NULL, NULL, 'FDH_alpha', NULL, NULL, NULL, 11),
(275839, NULL, 'PIRSF037435', NULL, NULL, NULL, NULL, 'Hybr_HK_BC3207', NULL, NULL, 15067, 11),
(275840, NULL, 'PIRSF034515', NULL, NULL, NULL, NULL, 'Chondroitinase', NULL, NULL, 13610, 11),
(275841, NULL, 'PIRSF033096', NULL, NULL, NULL, NULL, 'PPPtase_5', NULL, NULL, NULL, 11),
(275842, NULL, 'PIRSF004985', NULL, NULL, NULL, NULL, 'Hlld_jn_rslvs_ar', NULL, NULL, 7574, 11),
(275843, NULL, 'PIRSF036569', NULL, NULL, NULL, NULL, 'Hml', NULL, NULL, 12751, 11),
(275844, NULL, 'PIRSF037016', NULL, NULL, NULL, NULL, 'Pseudouridin_synth_euk', NULL, NULL, 3207, 11),
(275845, NULL, 'PIRSF001619', NULL, NULL, NULL, NULL, 'Biotin_synth', NULL, NULL, 13344, 11),
(275846, NULL, 'PIRSF021513', NULL, NULL, NULL, NULL, 'GrhN_RubW', NULL, NULL, 15282, 11),
(275847, NULL, 'PIRSF006563', NULL, NULL, NULL, NULL, 'UCP006563', NULL, NULL, 10708, 11),
(275848, NULL, 'PIRSF002483', NULL, NULL, NULL, NULL, 'Plasminogen-related', NULL, NULL, 20058, 11),
(275849, NULL, 'PIRSF000319', NULL, NULL, NULL, NULL, 'Trp_2-mono_O2ase', NULL, NULL, 13959, 11),
(275850, NULL, 'PIRSF012876', NULL, NULL, NULL, NULL, 'Txn_rg_UCP012876', NULL, NULL, 9630, 11),
(275851, NULL, 'PIRSF037251', NULL, NULL, NULL, NULL, 'AADAC', NULL, NULL, 21431, 11),
(275852, NULL, 'PIRSF000192', NULL, NULL, NULL, NULL, 'Amine_dh_beta', NULL, NULL, 9959, 11),
(275853, NULL, 'PIRSF004916', NULL, NULL, NULL, NULL, 'UCP004916', NULL, NULL, 5843, 11),
(275854, NULL, 'PIRSF035652', NULL, NULL, NULL, NULL, 'UCP035652', NULL, NULL, 10099, 11),
(275855, NULL, 'PIRSF037116', NULL, NULL, NULL, NULL, 'PhnK', NULL, NULL, 11541, 11),
(275856, NULL, 'PIRSF001859', NULL, NULL, NULL, NULL, 'Eclosion_hormone', NULL, NULL, 3803, 11),
(275857, NULL, 'PIRSF002161', NULL, NULL, NULL, NULL, 'RPL5p_RPL5a_RPL11e_RPL5o', NULL, NULL, 1038, 11),
(275858, NULL, 'PIRSF001065', NULL, NULL, NULL, NULL, 'Lysozyme_g', NULL, NULL, 1128, 11),
(275859, NULL, 'PIRSF007945', NULL, NULL, NULL, NULL, 'SRB2', NULL, NULL, 16304, 11),
(275860, NULL, 'PIRSF002395', NULL, NULL, NULL, NULL, 'RIZ_SET', NULL, NULL, 9995, 11),
(275861, NULL, 'PIRSF005610', NULL, NULL, NULL, NULL, 'UCP005610', NULL, NULL, 5810, 11),
(275862, NULL, 'PIRSF015161', NULL, NULL, NULL, NULL, 'TAFI48', NULL, NULL, 19282, 11),
(275863, NULL, 'PIRSF036508', NULL, NULL, NULL, NULL, 'Condns_HCP-6', NULL, NULL, 13406, 11),
(275864, NULL, 'PIRSF037159', NULL, NULL, NULL, NULL, 'UCP037159', NULL, NULL, 20556, 11),
(275865, NULL, 'PIRSF025007', NULL, NULL, NULL, NULL, 'Sec15', NULL, NULL, 6884, 11),
(275866, NULL, 'PIRSF003354', NULL, NULL, NULL, NULL, 'Alpha-COP', NULL, NULL, 21189, 11),
(275867, NULL, 'PIRSF000151', NULL, NULL, NULL, NULL, 'GPR', NULL, NULL, 13782, 11),
(275868, NULL, 'PIRSF031853', NULL, NULL, NULL, NULL, 'UCP031853', NULL, NULL, 17636, 11),
(275869, NULL, 'PIRSF001432', NULL, NULL, NULL, NULL, 'Pect_lyase', NULL, NULL, 9849, 11),
(275870, NULL, 'PIRSF005264', NULL, NULL, NULL, NULL, 'UCP005264', NULL, NULL, 3831, 11),
(275871, NULL, 'PIRSF014735', NULL, NULL, NULL, NULL, 'UCP014735', NULL, NULL, 26076, 11),
(275872, NULL, 'PIRSF000350', NULL, NULL, NULL, NULL, 'Hg-II_reductase_MerA', NULL, NULL, 1033, 11),
(275873, NULL, 'PIRSF006648', NULL, NULL, NULL, NULL, 'DrrB', NULL, NULL, 4597, 11),
(275874, NULL, 'PIRSF006707', NULL, NULL, NULL, NULL, 'MJ1563', NULL, NULL, 22620, 11),
(275875, NULL, 'PIRSF006521', NULL, NULL, NULL, NULL, 'TEF-1-beta_archaea', NULL, NULL, 1782, 11),
(275876, NULL, 'PIRSF037672', NULL, NULL, NULL, NULL, 'UCP037672', NULL, NULL, 16000, 11),
(275877, NULL, 'PIRSF029764', NULL, NULL, NULL, NULL, 'RSM25', NULL, NULL, 17703, 11),
(275878, NULL, 'PIRSF036915', NULL, NULL, NULL, NULL, 'Trnald_Bac_Plnt', NULL, NULL, 3698, 11),
(275879, NULL, 'PIRSF006698', NULL, NULL, NULL, NULL, 'Septin', NULL, NULL, 16218, 11);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(275880, NULL, 'PIRSF018472', NULL, NULL, NULL, NULL, 'MreD_proteobac', NULL, NULL, 23101, 11),
(275881, NULL, 'PIRSF037303', NULL, NULL, NULL, NULL, 'APC4', NULL, NULL, 21239, 11),
(275882, NULL, 'PIRSF031074', NULL, NULL, NULL, NULL, 'UCP031074', NULL, NULL, 17526, 11),
(275883, NULL, 'PIRSF000263', NULL, NULL, NULL, NULL, 'Meth_CoM_rd_beta', NULL, NULL, 1955, 11),
(275884, NULL, 'PIRSF033091', NULL, NULL, NULL, NULL, 'Pesterase_YhaO', NULL, NULL, 8048, 11),
(275885, NULL, 'PIRSF000446', NULL, NULL, NULL, NULL, 'Mct', NULL, NULL, 21852, 11),
(275886, NULL, 'PIRSF001093', NULL, NULL, NULL, NULL, 'B-hxosamndse_ab_euk_', NULL, NULL, 26346, 11),
(275887, NULL, 'PIRSF002512', NULL, NULL, NULL, NULL, 'Integrin_B', NULL, NULL, 12563, 11),
(275888, NULL, 'PIRSF003692', NULL, NULL, NULL, NULL, 'VAC_C14L', NULL, NULL, 9957, 11),
(275889, NULL, 'PIRSF000216', NULL, NULL, NULL, NULL, 'NDH-1_E', NULL, NULL, 4560, 11),
(275890, NULL, 'PIRSF016838', NULL, NULL, NULL, NULL, 'PafC', NULL, NULL, 26578, 11),
(275891, NULL, 'PIRSF011271', NULL, NULL, NULL, NULL, 'SycE', NULL, NULL, 7073, 11),
(275892, NULL, 'PIRSF029347', NULL, NULL, NULL, NULL, 'RecF', NULL, NULL, 12442, 11),
(275893, NULL, 'PIRSF004377', NULL, NULL, NULL, NULL, 'Ph_proh_core', NULL, NULL, 21439, 11),
(275894, NULL, 'PIRSF006429', NULL, NULL, NULL, NULL, 'GOGAT_lg_2', NULL, NULL, 13784, 11),
(275895, NULL, 'PIRSF015658', NULL, NULL, NULL, NULL, 'MmdB_OadB', NULL, NULL, 3717, 11),
(275896, NULL, 'PIRSF001247', NULL, NULL, NULL, NULL, 'Prot-Arg_deiminase', NULL, NULL, 4814, 11),
(275897, NULL, 'PIRSF001863', NULL, NULL, NULL, NULL, 'MAT_Alpha1', NULL, NULL, 20130, 11),
(275898, NULL, 'PIRSF004953', NULL, NULL, NULL, NULL, 'EhaL', NULL, NULL, 10192, 11),
(275899, NULL, 'PIRSF037706', NULL, NULL, NULL, NULL, 'MRP10', NULL, NULL, 16458, 11),
(275900, NULL, 'PIRSF018077', NULL, NULL, NULL, NULL, 'UCP018077', NULL, NULL, 5285, 11),
(275901, NULL, 'PIRSF037840', NULL, NULL, NULL, NULL, 'Aldolase_YihT', NULL, NULL, 16335, 11),
(275902, NULL, 'PIRSF038155', NULL, NULL, NULL, NULL, 'AS2', NULL, NULL, 18401, 11),
(275903, NULL, 'PIRSF018282', NULL, NULL, NULL, NULL, 'MukF', NULL, NULL, 1523, 11),
(275904, NULL, 'PIRSF037135', NULL, NULL, NULL, NULL, 'Matriptase-2', NULL, NULL, 20276, 11),
(275905, NULL, 'PIRSF004669', NULL, NULL, NULL, NULL, 'FliQ', NULL, NULL, 5091, 11),
(275906, NULL, 'PIRSF032748', NULL, NULL, NULL, NULL, 'UCP032748', NULL, NULL, 18767, 11),
(275907, NULL, 'PIRSF019736', NULL, NULL, NULL, NULL, 'dTMP_TKRP1', NULL, NULL, 11487, 11),
(275908, NULL, 'PIRSF032543', NULL, NULL, NULL, NULL, 'UCP032543_ParB', NULL, NULL, 18812, 11),
(275909, NULL, 'PIRSF000346', NULL, NULL, NULL, NULL, 'Dlt9_acylACP_des', NULL, NULL, 2203, 11),
(275910, NULL, 'PIRSF031505', NULL, NULL, NULL, NULL, 'GalT_short', NULL, NULL, 12769, 11),
(275911, NULL, 'PIRSF039133', NULL, NULL, NULL, NULL, 'SUMO_E1B', NULL, NULL, 24548, 11),
(275912, NULL, 'PIRSF036408', NULL, NULL, NULL, NULL, 'PduS', NULL, NULL, 19775, 11),
(275913, NULL, 'PIRSF006356', NULL, NULL, NULL, NULL, 'ADI', NULL, NULL, 4408, 11),
(275914, NULL, 'PIRSF032441', NULL, NULL, NULL, NULL, 'UCP032441', NULL, NULL, 18658, 11),
(275915, NULL, 'PIRSF016379', NULL, NULL, NULL, NULL, 'ENT', NULL, NULL, 5749, 11),
(275916, NULL, 'PIRSF038147', NULL, NULL, NULL, NULL, 'STPK_RIO1', NULL, NULL, 18065, 11),
(275917, NULL, 'PIRSF006135', NULL, NULL, NULL, NULL, 'CobU', NULL, NULL, 3291, 11),
(275918, NULL, 'PIRSF006160', NULL, NULL, NULL, NULL, 'AI2', NULL, NULL, 3109, 11),
(275919, NULL, 'PIRSF029120', NULL, NULL, NULL, NULL, 'UCP029120', NULL, NULL, 10881, 11),
(275920, NULL, 'PIRSF032209', NULL, NULL, NULL, NULL, 'UCP032209', NULL, NULL, 18761, 11),
(275921, NULL, 'PIRSF036498', NULL, NULL, NULL, NULL, 'Kaurene_synth_fungi', NULL, NULL, 19795, 11),
(275922, NULL, 'PIRSF030175', NULL, NULL, NULL, NULL, 'UCP030175', NULL, NULL, 17677, 11),
(275923, NULL, 'PIRSF016636', NULL, NULL, NULL, NULL, 'AlgI_DltB', NULL, NULL, 13624, 11),
(275924, NULL, 'PIRSF500741', NULL, NULL, NULL, NULL, 'MAPKKK12', NULL, NULL, 5787, 11);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(275925, NULL, 'PIRSF004808', NULL, NULL, NULL, NULL, 'LasT', NULL, NULL, 5935, 11),
(275926, NULL, 'PIRSF018494', NULL, NULL, NULL, NULL, 'PBSX_VPQ', NULL, NULL, 23850, 11),
(275927, NULL, 'PIRSF016511', NULL, NULL, NULL, NULL, 'Cyclin_Pcl', NULL, NULL, 12970, 11),
(275928, NULL, 'PIRSF018239', NULL, NULL, NULL, NULL, 'IGFBP_rP_mac25', NULL, NULL, 14818, 11),
(275929, NULL, 'PIRSF029755', NULL, NULL, NULL, NULL, 'UCP029755', NULL, NULL, 17882, 11),
(275930, NULL, 'PIRSF000956', NULL, NULL, NULL, NULL, 'PLC-beta', NULL, NULL, 19860, 11),
(275931, NULL, 'PIRSF001461', NULL, NULL, NULL, NULL, 'RPE', NULL, NULL, 26404, 11),
(275932, NULL, 'PIRSF021320', NULL, NULL, NULL, NULL, 'UCP021320', NULL, NULL, 14245, 11),
(275933, NULL, 'PIRSF007320', NULL, NULL, NULL, NULL, 'Fimbrillin_MatB', NULL, NULL, 16488, 11),
(275934, NULL, 'PIRSF000382', NULL, NULL, NULL, NULL, 'Met_synth_MetE', NULL, NULL, 3772, 11),
(275935, NULL, 'PIRSF038286', NULL, NULL, NULL, NULL, 'PRAME', NULL, NULL, 22728, 11),
(275936, NULL, 'PIRSF002455', NULL, NULL, NULL, NULL, 'ATP_synth_F6', NULL, NULL, 7989, 11),
(275937, NULL, 'PIRSF031512', NULL, NULL, NULL, NULL, 'EpsL', NULL, NULL, 8144, 11),
(275938, NULL, 'PIRSF037476', NULL, NULL, NULL, NULL, 'BLOC2_Hps6', NULL, NULL, 15014, 11),
(275939, NULL, 'PIRSF021525', NULL, NULL, NULL, NULL, 'UCP021525', NULL, NULL, 11162, 11),
(275940, NULL, 'PIRSF000451', NULL, NULL, NULL, NULL, 'PKS_III', NULL, NULL, 10247, 11),
(275941, NULL, 'PIRSF009320', NULL, NULL, NULL, NULL, 'Nuc_binding_HP_1000', NULL, NULL, NULL, 11),
(275942, NULL, 'PIRSF030140', NULL, NULL, NULL, NULL, 'UCP030140', NULL, NULL, 17892, 11),
(275943, NULL, 'PIRSF013674', NULL, NULL, NULL, NULL, 'PXMP4', NULL, NULL, 19342, 11),
(275944, NULL, 'PIRSF003923', NULL, NULL, NULL, NULL, 'SH_protein_mumps', NULL, NULL, 6295, 11),
(275945, NULL, 'PIRSF038861', NULL, NULL, NULL, NULL, 'UCP038861', NULL, NULL, 9956, 11),
(275946, NULL, 'PIRSF005653', NULL, NULL, NULL, NULL, 'RpoN_RPB10', NULL, NULL, 593, 11),
(275947, NULL, 'PIRSF006221', NULL, NULL, NULL, NULL, 'KT3K', NULL, NULL, 15430, 11),
(275948, NULL, 'PIRSF036654', NULL, NULL, NULL, NULL, 'Fum_suc_asp_HD', NULL, NULL, 10082, 11),
(275949, NULL, 'PIRSF000034', NULL, NULL, NULL, NULL, 'Cytochrome_b6f_V/PetG', NULL, NULL, 1800, 11),
(275950, NULL, 'PIRSF000161', NULL, NULL, NULL, NULL, 'DHPR', NULL, NULL, 8465, 11),
(275951, NULL, 'PIRSF000548', NULL, NULL, NULL, NULL, 'PK_regulatory', NULL, NULL, 12828, 11),
(275952, NULL, 'PIRSF037094', NULL, NULL, NULL, NULL, 'AP1_gamma', NULL, NULL, 20131, 11),
(275953, NULL, 'PIRSF019164', NULL, NULL, NULL, NULL, 'UCP019164', NULL, NULL, 10180, 11),
(275954, NULL, 'PIRSF034961', NULL, NULL, NULL, NULL, 'UCP034961_SH3_2', NULL, NULL, 8359, 11),
(275955, NULL, 'PIRSF000770', NULL, NULL, NULL, NULL, 'SigK_SigE', NULL, NULL, 3449, 11),
(275956, NULL, 'PIRSF006060', NULL, NULL, NULL, NULL, 'AA_transporter', NULL, NULL, NULL, 11),
(275957, NULL, 'PIRSF021308', NULL, NULL, NULL, NULL, 'UCP021308', NULL, NULL, 15226, 11),
(275958, NULL, 'PIRSF020945', NULL, NULL, NULL, NULL, 'GGP', NULL, NULL, 9693, 11),
(275959, NULL, 'PIRSF000857', NULL, NULL, NULL, NULL, 'PAPS_reductase', NULL, NULL, 1912, 11),
(275960, NULL, 'PIRSF003938', NULL, NULL, NULL, NULL, 'NS1_influenza_B', NULL, NULL, 3725, 11),
(275961, NULL, 'PIRSF038065', NULL, NULL, NULL, NULL, 'TNFR_11B', NULL, NULL, 17648, 11),
(275962, NULL, 'PIRSF002764', NULL, NULL, NULL, NULL, 'CcmB', NULL, NULL, 23330, 11),
(275963, NULL, 'PIRSF033199', NULL, NULL, NULL, NULL, 'UCP033199', NULL, NULL, 8174, 11),
(275964, NULL, 'PIRSF020979', NULL, NULL, NULL, NULL, 'UCP020979', NULL, NULL, 10686, 11),
(275965, NULL, 'PIRSF015919', NULL, NULL, NULL, NULL, 'TFIIH_SSL1', NULL, NULL, 7103, 11),
(275966, NULL, 'PIRSF011018', NULL, NULL, NULL, NULL, 'Nicalin', NULL, NULL, 17622, 11),
(275967, NULL, 'PIRSF036417', NULL, NULL, NULL, NULL, 'Very_long_ch_3-ktacl-CoA_syn', NULL, NULL, 13352, 11),
(275968, NULL, 'PIRSF010045', NULL, NULL, NULL, NULL, 'TMP_111', NULL, NULL, 13475, 11),
(275969, NULL, 'PIRSF016123', NULL, NULL, NULL, NULL, 'UCP016123', NULL, NULL, 5635, 11);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(275970, NULL, 'PIRSF006834', NULL, NULL, NULL, NULL, 'UCP006834', NULL, NULL, 10880, 11),
(275971, NULL, 'PIRSF000726', NULL, NULL, NULL, NULL, 'Asp_kin', NULL, NULL, 4027, 11),
(275972, NULL, 'PIRSF003281', NULL, NULL, NULL, NULL, 'ExcA', NULL, NULL, 21204, 11),
(275973, NULL, 'PIRSF002912', NULL, NULL, NULL, NULL, 'PsaK', NULL, NULL, 20393, 11),
(275974, NULL, 'PIRSF005919', NULL, NULL, NULL, NULL, 'UCP005919', NULL, NULL, 19386, 11),
(275975, NULL, 'PIRSF000008', NULL, NULL, NULL, NULL, 'Cytochrome_c551i', NULL, NULL, 9564, 11),
(275976, NULL, 'PIRSF028991', NULL, NULL, NULL, NULL, 'Glycl_rad_HI0521', NULL, NULL, 17379, 11),
(275977, NULL, 'PIRSF037987', NULL, NULL, NULL, NULL, 'UCP037987', NULL, NULL, 17282, 11),
(275978, NULL, 'PIRSF005348', NULL, NULL, NULL, NULL, 'YxkH', NULL, NULL, 3141, 11),
(275979, NULL, 'PIRSF019029', NULL, NULL, NULL, NULL, 'Txn_fac_bZIP_E4BP4', NULL, NULL, 21254, 11),
(275980, NULL, 'PIRSF037235', NULL, NULL, NULL, NULL, 'Vps13_fungi', NULL, NULL, 20634, 11),
(275981, NULL, 'PIRSF016487', NULL, NULL, NULL, NULL, 'CYTH_UCP016487', NULL, NULL, 11039, 11),
(275982, NULL, 'PIRSF002786', NULL, NULL, NULL, NULL, 'XcpX', NULL, NULL, 2521, 11),
(275983, NULL, 'PIRSF006677', NULL, NULL, NULL, NULL, 'AtPEPC', NULL, NULL, 1687, 11),
(275984, NULL, 'PIRSF037905', NULL, NULL, NULL, NULL, 'Subtilisin_rel_CJE1557', NULL, NULL, 16504, 11),
(275985, NULL, 'PIRSF004179', NULL, NULL, NULL, NULL, 'DNAterm_GP3', NULL, NULL, 12256, 11),
(275986, NULL, 'PIRSF036510', NULL, NULL, NULL, NULL, 'PDH_fung', NULL, NULL, 13002, 11),
(275987, NULL, 'PIRSF030471', NULL, NULL, NULL, NULL, 'STR_Vng0742h', NULL, NULL, 17566, 11),
(275988, NULL, 'PIRSF033622', NULL, NULL, NULL, NULL, 'UCP033622_transglutaminase', NULL, NULL, 18603, 11),
(275989, NULL, 'PIRSF038143', NULL, NULL, NULL, NULL, 'Podoclyxn-like_1', NULL, NULL, 18470, 11),
(275990, NULL, 'PIRSF017250', NULL, NULL, NULL, NULL, 'tRNA_endo_SEN34', NULL, NULL, 20343, 11),
(275991, NULL, 'PIRSF012337', NULL, NULL, NULL, NULL, 'gp45', NULL, NULL, 9875, 11),
(275992, NULL, 'PIRSF015195', NULL, NULL, NULL, NULL, 'UCP015195', NULL, NULL, 14078, 11),
(275993, NULL, 'PIRSF015477', NULL, NULL, NULL, NULL, 'Bpr', NULL, NULL, 12868, 11),
(275994, NULL, 'PIRSF004649', NULL, NULL, NULL, NULL, 'MlaC', NULL, NULL, 7689, 11),
(275995, NULL, 'PIRSF000988', NULL, NULL, NULL, NULL, 'DNase_I', NULL, NULL, 12000, 11),
(275996, NULL, 'PIRSF019375', NULL, NULL, NULL, NULL, 'UCP019375', NULL, NULL, 21059, 11),
(275997, NULL, 'PIRSF032086', NULL, NULL, NULL, NULL, 'UCP032086', NULL, NULL, 17621, 11),
(275998, NULL, 'PIRSF037851', NULL, NULL, NULL, NULL, 'Subtilisin_cyano', NULL, NULL, 16870, 11),
(275999, NULL, 'PIRSF005496', NULL, NULL, NULL, NULL, 'ATP_hel_HrpB', NULL, NULL, 4281, 11),
(276000, NULL, 'PIRSF033367', NULL, NULL, NULL, NULL, 'UCP033367_VanZ', NULL, NULL, 18674, 11),
(276001, NULL, 'PIRSF004848', NULL, NULL, NULL, NULL, 'YBL036c_PLPDEIII', NULL, NULL, 9662, 11),
(276002, NULL, 'PIRSF003073', NULL, NULL, NULL, NULL, 'DNAC_TnpB_IstB', NULL, NULL, 26761, 11),
(276003, NULL, 'PIRSF002905', NULL, NULL, NULL, NULL, 'PSI_A', NULL, NULL, 2036, 11),
(276004, NULL, 'PIRSF021239', NULL, NULL, NULL, NULL, 'UCP021239', NULL, NULL, 3905, 11),
(276005, NULL, 'PIRSF015588', NULL, NULL, NULL, NULL, 'AP_complex_sigma', NULL, NULL, 19129, 11),
(276006, NULL, 'PIRSF030125', NULL, NULL, NULL, NULL, 'UCP030125', NULL, NULL, 17906, 11),
(276007, NULL, 'PIRSF037892', NULL, NULL, NULL, NULL, 'Subtilisin_rel_SRU_0565', NULL, NULL, 16701, 11),
(276008, NULL, 'PIRSF011588', NULL, NULL, NULL, NULL, 'Gly_sarc_betain_reduct_a_b', NULL, NULL, 17772, 11),
(276009, NULL, 'PIRSF037336', NULL, NULL, NULL, NULL, 'IspG_partdup', NULL, NULL, 21347, 11),
(276010, NULL, 'PIRSF019435', NULL, NULL, NULL, NULL, 'UCP019435', NULL, NULL, 12468, 11),
(276011, NULL, 'PIRSF017300', NULL, NULL, NULL, NULL, 'snoRNP_Mpp10', NULL, NULL, 7149, 11),
(276012, NULL, 'PIRSF000099', NULL, NULL, NULL, NULL, 'Histidinol_dh', NULL, NULL, 16600, 11),
(276013, NULL, 'PIRSF033595', NULL, NULL, NULL, NULL, 'UCP033595', NULL, NULL, 18525, 11);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(276014, NULL, 'PIRSF003326', NULL, NULL, NULL, NULL, 'PET111', NULL, NULL, 12311, 11),
(276015, NULL, 'PIRSF016154', NULL, NULL, NULL, NULL, 'Nucl_a_bind_PIN_PH0500', NULL, NULL, 19965, 11),
(276016, NULL, 'PIRSF038013', NULL, NULL, NULL, NULL, 'TNF10_TNF11', NULL, NULL, 17405, 11),
(276017, NULL, 'PIRSF036620', NULL, NULL, NULL, NULL, 'MPTbdFAD', NULL, NULL, 12683, 11),
(276018, NULL, 'PIRSF016496', NULL, NULL, NULL, NULL, 'Kin_FomA', NULL, NULL, 13724, 11),
(276019, NULL, 'PIRSF029502', NULL, NULL, NULL, NULL, 'UCP029502', NULL, NULL, 17373, 11),
(276020, NULL, 'PIRSF036054', NULL, NULL, NULL, NULL, 'UCP036054', NULL, NULL, 19711, 11),
(276021, NULL, 'PIRSF028205', NULL, NULL, NULL, NULL, 'UCP028205', NULL, NULL, 10897, 11),
(276022, NULL, 'PIRSF002599', NULL, NULL, NULL, NULL, 'Cold_shock_A', NULL, NULL, 7336, 11),
(276023, NULL, 'PIRSF000355', NULL, NULL, NULL, NULL, 'NrdB', NULL, NULL, 120, 11),
(276024, NULL, 'PIRSF004961', NULL, NULL, NULL, NULL, 'UCP004961_hydrolase', NULL, NULL, 11045, 11),
(276025, NULL, 'PIRSF037104', NULL, NULL, NULL, NULL, 'H3K4_HMTase_Set1_fungi', NULL, NULL, 20360, 11),
(276026, NULL, 'PIRSF006655', NULL, NULL, NULL, NULL, 'DHQS_altern', NULL, NULL, 4881, 11),
(276027, NULL, 'PIRSF021331', NULL, NULL, NULL, NULL, 'YkoF', NULL, NULL, 10117, 11),
(276028, NULL, 'PIRSF500156', NULL, NULL, NULL, NULL, 'GalT_Corynebac', NULL, NULL, 34274, 11),
(276029, NULL, 'PIRSF039110', NULL, NULL, NULL, NULL, 'IPP_transferase', NULL, NULL, 24957, 11),
(276030, NULL, 'PIRSF000778', NULL, NULL, NULL, NULL, 'RpoK/RPB6', NULL, NULL, 10354, 11),
(276031, NULL, 'PIRSF002808', NULL, NULL, NULL, NULL, 'Hexose_phosphate_transp', NULL, NULL, 4707, 11),
(276032, NULL, 'PIRSF001657', NULL, NULL, NULL, NULL, 'Alpha-amyl_inhib_seed_allergen', NULL, NULL, 10419, 11),
(276033, NULL, 'PIRSF038994', NULL, NULL, NULL, NULL, 'NagA', NULL, NULL, 2360, 11),
(276034, NULL, 'PIRSF038169', NULL, NULL, NULL, NULL, 'WD_rpt_55', NULL, NULL, 18462, 11),
(276035, NULL, 'PIRSF001418', NULL, NULL, NULL, NULL, 'ACN', NULL, NULL, 13858, 11),
(276036, NULL, 'PIRSF015849', NULL, NULL, NULL, NULL, 'TFIIF-beta', NULL, NULL, 3335, 11),
(276037, NULL, 'PIRSF016661', NULL, NULL, NULL, NULL, 'BioY', NULL, NULL, 3487, 11),
(276038, NULL, 'PIRSF037913', NULL, NULL, NULL, NULL, 'HDAC_I_euk', NULL, NULL, 539, 11),
(276039, NULL, 'PIRSF000977', NULL, NULL, NULL, NULL, 'Exodeoxyribonuclease_I', NULL, NULL, 16107, 11),
(276040, NULL, 'PIRSF020736', NULL, NULL, NULL, NULL, 'MiaE', NULL, NULL, 9264, 11),
(276041, NULL, 'PIRSF004523', NULL, NULL, NULL, NULL, 'ABC_peripl_P37', NULL, NULL, 8330, 11),
(276042, NULL, 'PIRSF001423', NULL, NULL, NULL, NULL, 'Urocanate_hydrat', NULL, NULL, 870, 11),
(276043, NULL, 'PIRSF000379', NULL, NULL, NULL, NULL, 'For_Ac_trans_1', NULL, NULL, NULL, 11),
(276044, NULL, 'PIRSF014728', NULL, NULL, NULL, NULL, 'PqaA', NULL, NULL, 9989, 11),
(276045, NULL, 'PIRSF020485', NULL, NULL, NULL, NULL, 'PA-IL', NULL, NULL, 13044, 11),
(276046, NULL, 'PIRSF037250', NULL, NULL, NULL, NULL, 'CcmM', NULL, NULL, 21399, 11),
(276047, NULL, 'PIRSF036177', NULL, NULL, NULL, NULL, 'HsdS', NULL, NULL, 19556, 11),
(276048, NULL, 'PIRSF037181', NULL, NULL, NULL, NULL, 'UCP037181', NULL, NULL, 14099, 11),
(276049, NULL, 'PIRSF035808', NULL, NULL, NULL, NULL, 'Pdiesterase_Brain_239', NULL, NULL, 13970, 11),
(276050, NULL, 'PIRSF038471', NULL, NULL, NULL, NULL, 'MreC', NULL, NULL, 6189, 11),
(276051, NULL, 'PIRSF004750', NULL, NULL, NULL, NULL, 'Nitrile_oxidored_YqcD', NULL, NULL, 21107, 11),
(276052, NULL, 'PIRSF037383', NULL, NULL, NULL, NULL, 'LicCA', NULL, NULL, 21166, 11),
(276053, NULL, 'PIRSF029285', NULL, NULL, NULL, NULL, 'Aminopept', NULL, NULL, 12352, 11),
(276054, NULL, 'PIRSF015604', NULL, NULL, NULL, NULL, 'OBP_PBP_Ditrysia', NULL, NULL, 2853, 11),
(276055, NULL, 'PIRSF036442', NULL, NULL, NULL, NULL, 'NAGS_animal', NULL, NULL, 10788, 11),
(276056, NULL, 'PIRSF015981', NULL, NULL, NULL, NULL, 'VAC_F11L', NULL, NULL, 6743, 11),
(276057, NULL, 'PIRSF037257', NULL, NULL, NULL, NULL, 'UCP037257_Veg', NULL, NULL, 14386, 11);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(276058, NULL, 'PIRSF009303', NULL, NULL, NULL, NULL, 'RAD9', NULL, NULL, 26228, 11),
(276059, NULL, 'PIRSF036625', NULL, NULL, NULL, NULL, 'GAF_ANTAR', NULL, NULL, 12397, 11),
(276060, NULL, 'PIRSF000262', NULL, NULL, NULL, NULL, 'MCR_alpha', NULL, NULL, 17212, 11),
(276061, NULL, 'PIRSF026631', NULL, NULL, NULL, NULL, 'UCP026631', NULL, NULL, 12039, 11),
(276062, NULL, 'PIRSF008756', NULL, NULL, NULL, NULL, 'P_tr_PHO88', NULL, NULL, 12529, 11),
(276063, NULL, 'PIRSF000189', NULL, NULL, NULL, NULL, 'D-aa_oxidase', NULL, NULL, 15949, 11),
(276064, NULL, 'PIRSF033094', NULL, NULL, NULL, NULL, 'Pesterase_CT488', NULL, NULL, 8089, 11),
(276065, NULL, 'PIRSF005963', NULL, NULL, NULL, NULL, 'Lipoyl_synth', NULL, NULL, 2415, 11),
(276066, NULL, 'PIRSF019317', NULL, NULL, NULL, NULL, 'UCP019317', NULL, NULL, 10647, 11),
(276067, NULL, 'PIRSF022348', NULL, NULL, NULL, NULL, 'UCP022348', NULL, NULL, 15464, 11),
(276068, NULL, 'PIRSF036999', NULL, NULL, NULL, NULL, 'RNA_ed_MP42', NULL, NULL, 19815, 11),
(276069, NULL, 'PIRSF003047', NULL, NULL, NULL, NULL, 'TFIID_TAF1_animal', NULL, NULL, 10557, 11),
(276070, NULL, 'PIRSF037185', NULL, NULL, NULL, NULL, 'Cetp', NULL, NULL, 20795, 11),
(276071, NULL, 'PIRSF006404', NULL, NULL, NULL, NULL, 'UCP_M50_CBS', NULL, NULL, 15486, 11),
(276072, NULL, 'PIRSF000199', NULL, NULL, NULL, NULL, 'Dhfr_type_II', NULL, NULL, 9600, 11),
(276073, NULL, 'PIRSF037995', NULL, NULL, NULL, NULL, 'CB-R', NULL, NULL, 6882, 11),
(276074, NULL, 'PIRSF027779', NULL, NULL, NULL, NULL, 'UCP207779', NULL, NULL, 16082, 11),
(276075, NULL, 'PIRSF002695', NULL, NULL, NULL, NULL, 'A-agglutinin', NULL, NULL, 7137, 11),
(276076, NULL, 'PIRSF002703', NULL, NULL, NULL, NULL, 'PR5', NULL, NULL, 2232, 11),
(276077, NULL, 'PIRSF006864', NULL, NULL, NULL, NULL, 'UCP006864', NULL, NULL, 16320, 11),
(276078, NULL, 'PIRSF003778', NULL, NULL, NULL, NULL, 'VAC_C8L', NULL, NULL, 9597, 11),
(276079, NULL, 'PIRSF026412', NULL, NULL, NULL, NULL, 'Streptogrm_lyase', NULL, NULL, 10717, 11),
(276080, NULL, 'PIRSF019853', NULL, NULL, NULL, NULL, 'UCP019853', NULL, NULL, 21074, 11),
(276081, NULL, 'PIRSF036917', NULL, NULL, NULL, NULL, 'Alph_amls_MalS', NULL, NULL, 8321, 11),
(276082, NULL, 'PIRSF015034', NULL, NULL, NULL, NULL, 'YacH', NULL, NULL, 24078, 11),
(276083, NULL, 'PIRSF036900', NULL, NULL, NULL, NULL, 'Rd_RNA_pol_NRV', NULL, NULL, 10303, 11),
(276084, NULL, 'PIRSF037186', NULL, NULL, NULL, NULL, 'LPLUNC', NULL, NULL, 15353, 11),
(276085, NULL, 'PIRSF004697', NULL, NULL, NULL, NULL, 'UCP_CBS_CP12', NULL, NULL, 7101, 11),
(276086, NULL, 'PIRSF031143', NULL, NULL, NULL, NULL, 'UCP031143', NULL, NULL, 17903, 11),
(276087, NULL, 'PIRSF001779', NULL, NULL, NULL, NULL, 'GF_C11R', NULL, NULL, 10680, 11),
(276088, NULL, 'PIRSF018156', NULL, NULL, NULL, NULL, 'MRPL51_fungal', NULL, NULL, 20327, 11),
(276089, NULL, 'PIRSF004305', NULL, NULL, NULL, NULL, 'Imm', NULL, NULL, 21215, 11),
(276090, NULL, 'PIRSF036500', NULL, NULL, NULL, NULL, 'GMP_red_Firmic', NULL, NULL, 1117, 11),
(276091, NULL, 'PIRSF005954', NULL, NULL, NULL, NULL, 'Thrmst_ogg', NULL, NULL, 12894, 11),
(276092, NULL, 'PIRSF034653', NULL, NULL, NULL, NULL, 'Mtase_yjhp', NULL, NULL, 18564, 11),
(276093, NULL, 'PIRSF000097', NULL, NULL, NULL, NULL, 'AKR', NULL, NULL, 19615, 11),
(276094, NULL, 'PIRSF008711', NULL, NULL, NULL, NULL, 'UCP008711', NULL, NULL, 13433, 11),
(276095, NULL, 'PIRSF001693', NULL, NULL, NULL, NULL, 'Txn_fact_GAMYB', NULL, NULL, 19716, 11),
(276096, NULL, 'PIRSF005925', NULL, NULL, NULL, NULL, 'Dos', NULL, NULL, 13942, 11),
(276097, NULL, 'PIRSF003101', NULL, NULL, NULL, NULL, 'FtsA', NULL, NULL, 20656, 11),
(276098, NULL, 'PIRSF010072', NULL, NULL, NULL, NULL, 'BBS5_fem-3', NULL, NULL, 22623, 11),
(276099, NULL, 'PIRSF037736', NULL, NULL, NULL, NULL, 'SCO1', NULL, NULL, 16420, 11),
(276100, NULL, 'PIRSF016482', NULL, NULL, NULL, NULL, 'PilO', NULL, NULL, 4958, 11),
(276101, NULL, 'PIRSF032762', NULL, NULL, NULL, NULL, 'UCP032762', NULL, NULL, 18865, 11),
(276102, NULL, 'PIRSF036301', NULL, NULL, NULL, NULL, 'Cripto_growth_factor', NULL, NULL, 19584, 11);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(276103, NULL, 'PIRSF000845', NULL, NULL, NULL, NULL, 'mRNA_capping_reovirus', NULL, NULL, 8589, 11),
(276104, NULL, 'PIRSF017818', NULL, NULL, NULL, NULL, 'Acid_Ptase_B', NULL, NULL, 5238, 11),
(276105, NULL, 'PIRSF011360', NULL, NULL, NULL, NULL, 'PVC2', NULL, NULL, 10451, 11),
(276106, NULL, 'PIRSF006205', NULL, NULL, NULL, NULL, 'Dxp_reductoisomrs', NULL, NULL, 3142, 11),
(276107, NULL, 'PIRSF000167', NULL, NULL, NULL, NULL, 'HemN', NULL, NULL, 4286, 11),
(276108, NULL, 'PIRSF004604', NULL, NULL, NULL, NULL, 'UCP004604', NULL, NULL, 7529, 11),
(276109, NULL, 'PIRSF037327', NULL, NULL, NULL, NULL, 'TFIIIB_Bdp1_fungal', NULL, NULL, 21211, 11),
(276110, NULL, 'PIRSF002900', NULL, NULL, NULL, NULL, 'LH-2', NULL, NULL, 6035, 11),
(276111, NULL, 'PIRSF031924', NULL, NULL, NULL, NULL, 'Pi-irrepressible_AP', NULL, NULL, 21898, 11),
(276112, NULL, 'PIRSF020079', NULL, NULL, NULL, NULL, 'UCP020079', NULL, NULL, 21403, 11),
(276113, NULL, 'PIRSF500126', NULL, NULL, NULL, NULL, 'Pgk_euglenozoa', NULL, NULL, 24836, 11),
(276114, NULL, 'PIRSF003161', NULL, NULL, NULL, NULL, 'FliG', NULL, NULL, 2510, 11),
(276115, NULL, 'PIRSF004374', NULL, NULL, NULL, NULL, 'Gp59', NULL, NULL, 8700, 11),
(276116, NULL, 'PIRSF038215', NULL, NULL, NULL, NULL, 'Cripto-3_rel', NULL, NULL, 18766, 11),
(276117, NULL, 'PIRSF037536', NULL, NULL, NULL, NULL, 'WD35', NULL, NULL, 15302, 11),
(276118, NULL, 'PIRSF000439', NULL, NULL, NULL, NULL, 'Oat_ACAT_DAG_ARE', NULL, NULL, 12239, 11),
(276119, NULL, 'PIRSF000934', NULL, NULL, NULL, NULL, 'PTPN14_PTPN21', NULL, NULL, 7282, 11),
(276120, NULL, 'PIRSF013220', NULL, NULL, NULL, NULL, 'UCP013220', NULL, NULL, 19478, 11),
(276121, NULL, 'PIRSF001137', NULL, NULL, NULL, NULL, 'Haptoglobin', NULL, NULL, 8900, 11),
(276122, NULL, 'PIRSF022941', NULL, NULL, NULL, NULL, 'ORC6_fungal', NULL, NULL, 15064, 11),
(276123, NULL, 'PIRSF014300', NULL, NULL, NULL, NULL, 'Protoglobin', NULL, NULL, 12941, 11),
(276124, NULL, 'PIRSF018269', NULL, NULL, NULL, NULL, 'CDP-DAG_synth_e', NULL, NULL, 21414, 11),
(276125, NULL, 'PIRSF007949', NULL, NULL, NULL, NULL, 'Vps16', NULL, NULL, 16229, 11),
(276126, NULL, 'PIRSF012294', NULL, NULL, NULL, NULL, 'ATR_EutT', NULL, NULL, 9512, 11),
(276127, NULL, 'PIRSF003796', NULL, NULL, NULL, NULL, 'M-T4_MXV', NULL, NULL, 21494, 11),
(276128, NULL, 'PIRSF006035', NULL, NULL, NULL, NULL, 'CO_dh_b_ACDS_e', NULL, NULL, 2030, 11),
(276129, NULL, 'PIRSF012526', NULL, NULL, NULL, NULL, 'CYTH_UCP012526', NULL, NULL, 9835, 11),
(276130, NULL, 'PIRSF036936', NULL, NULL, NULL, NULL, 'IGPS_HisHF', NULL, NULL, 8297, 11),
(276131, NULL, 'PIRSF037867', NULL, NULL, NULL, NULL, 'CD261_antigen', NULL, NULL, 18932, 11),
(276132, NULL, 'PIRSF009221', NULL, NULL, NULL, NULL, 'VAP_Rhodococcus_equi', NULL, NULL, 13873, 11),
(276133, NULL, 'PIRSF034852', NULL, NULL, NULL, NULL, 'UCP034852', NULL, NULL, 7530, 11),
(276134, NULL, 'PIRSF037891', NULL, NULL, NULL, NULL, 'Cycloviolacin', NULL, NULL, 1658, 11),
(276135, NULL, 'PIRSF006250', NULL, NULL, NULL, NULL, 'NadC_ModD', NULL, NULL, 26455, 11),
(276136, NULL, 'PIRSF008381', NULL, NULL, NULL, NULL, 'TP0020_vWA', NULL, NULL, 10658, 11),
(276137, NULL, 'PIRSF014470', NULL, NULL, NULL, NULL, 'UCP014470', NULL, NULL, 19202, 11),
(276138, NULL, 'PIRSF037630', NULL, NULL, NULL, NULL, 'Blos3', NULL, NULL, 15538, 11),
(276139, NULL, 'PIRSF016305', NULL, NULL, NULL, NULL, 'LCMT', NULL, NULL, 19705, 11),
(276140, NULL, 'PIRSF001790', NULL, NULL, NULL, NULL, 'TNF_C22L', NULL, NULL, 10824, 11),
(276141, NULL, 'PIRSF031878', NULL, NULL, NULL, NULL, 'UCP031878', NULL, NULL, 8332, 11),
(276142, NULL, 'PIRSF005444', NULL, NULL, NULL, NULL, 'PEMT_MPLS', NULL, NULL, 23961, 11),
(276143, NULL, 'PIRSF018425', NULL, NULL, NULL, NULL, 'PolyA_polymerase', NULL, NULL, 10437, 11),
(276144, NULL, 'PIRSF031890', NULL, NULL, NULL, NULL, 'UCP031890_transporter_Tim44', NULL, NULL, 17843, 11),
(276145, NULL, 'PIRSF037708', NULL, NULL, NULL, NULL, 'Protein_FYV7', NULL, NULL, 16039, 11),
(276146, NULL, 'PIRSF004762', NULL, NULL, NULL, NULL, 'COFH', NULL, NULL, NULL, 11);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(276147, NULL, 'PIRSF039100', NULL, NULL, NULL, NULL, 'ARPC4', NULL, NULL, 7598, 11),
(276148, NULL, 'PIRSF000139', NULL, NULL, NULL, NULL, 'Glc_ox_4Fe-4S', NULL, NULL, 11695, 11),
(276149, NULL, 'PIRSF005900', NULL, NULL, NULL, NULL, 'Dps', NULL, NULL, 488, 11),
(276150, NULL, 'PIRSF016896', NULL, NULL, NULL, NULL, 'GHMP_arc_MJ0969', NULL, NULL, 11094, 11),
(276151, NULL, 'PIRSF032908', NULL, NULL, NULL, NULL, 'UCP032908', NULL, NULL, 8439, 11),
(276152, NULL, 'PIRSF028784', NULL, NULL, NULL, NULL, 'MrpF', NULL, NULL, 1063, 11),
(276153, NULL, 'PIRSF014543', NULL, NULL, NULL, NULL, 'UCP014543', NULL, NULL, 19377, 11),
(276154, NULL, 'PIRSF004698', NULL, NULL, NULL, NULL, 'UCP_CBS_MJ0100', NULL, NULL, 21045, 11),
(276155, NULL, 'PIRSF001394', NULL, NULL, NULL, NULL, 'Fe_dep_fumar_hy', NULL, NULL, 10676, 11),
(276156, NULL, 'PIRSF007808', NULL, NULL, NULL, NULL, 'Mms22p', NULL, NULL, 12199, 11),
(276157, NULL, 'PIRSF014484', NULL, NULL, NULL, NULL, 'UCP014484', NULL, NULL, 9952, 11),
(276158, NULL, 'PIRSF031501', NULL, NULL, NULL, NULL, 'QueT', NULL, NULL, 9317, 11),
(276159, NULL, 'PIRSF038168', NULL, NULL, NULL, NULL, 'MAPKKK7', NULL, NULL, 18486, 11),
(276160, NULL, 'PIRSF002122', NULL, NULL, NULL, NULL, 'RPS7p_RPS7a_RPS5e_RPS7o', NULL, NULL, 4569, 11),
(276161, NULL, 'PIRSF005928', NULL, NULL, NULL, NULL, 'Nucleotidltrnsf', NULL, NULL, 9583, 11),
(276162, NULL, 'PIRSF036794', NULL, NULL, NULL, NULL, 'UCP_erythr_ester', NULL, NULL, 9788, 11),
(276163, NULL, 'PIRSF037240', NULL, NULL, NULL, NULL, 'MAF1', NULL, NULL, 12060, 11),
(276164, NULL, 'PIRSF008546', NULL, NULL, NULL, NULL, 'UCP008546', NULL, NULL, 14468, 11),
(276165, NULL, 'PIRSF007028', NULL, NULL, NULL, NULL, 'UCP007028', NULL, NULL, 14218, 11),
(276166, NULL, 'PIRSF010606', NULL, NULL, NULL, NULL, 'CotJB', NULL, NULL, 17722, 11),
(276167, NULL, 'PIRSF022950', NULL, NULL, NULL, NULL, 'Pptase_methylesteras', NULL, NULL, 15364, 11),
(276168, NULL, 'PIRSF007860', NULL, NULL, NULL, NULL, 'Vps11', NULL, NULL, 16168, 11),
(276169, NULL, 'PIRSF003779', NULL, NULL, NULL, NULL, 'VAC_C7L', NULL, NULL, 2731, 11),
(276170, NULL, 'PIRSF036517', NULL, NULL, NULL, NULL, 'Ext_hemo', NULL, NULL, 8014, 11),
(276171, NULL, 'PIRSF017259', NULL, NULL, NULL, NULL, 'tRNA_Mtase_TRM11', NULL, NULL, NULL, 11),
(276172, NULL, 'PIRSF028101', NULL, NULL, NULL, NULL, 'UCP028101', NULL, NULL, 7506, 11),
(276173, NULL, 'PIRSF031767', NULL, NULL, NULL, NULL, 'MHYE_LytTR', NULL, NULL, 13387, 11),
(276174, NULL, 'PIRSF037866', NULL, NULL, NULL, NULL, 'EBP50', NULL, NULL, 16678, 11),
(276175, NULL, 'PIRSF036540', NULL, NULL, NULL, NULL, 'UCP036540_AIR', NULL, NULL, 8451, 11),
(276176, NULL, 'PIRSF035170', NULL, NULL, NULL, NULL, 'HD_phosphohydro', NULL, NULL, 10334, 11),
(276177, NULL, 'PIRSF000813', NULL, NULL, NULL, NULL, 'CCA_bact', NULL, NULL, 10154, 11),
(276178, NULL, 'PIRSF038205', NULL, NULL, NULL, NULL, 'DRP2', NULL, NULL, 18285, 11),
(276179, NULL, 'PIRSF016792', NULL, NULL, NULL, NULL, 'UCP016792', NULL, NULL, 9506, 11),
(276180, NULL, 'PIRSF037938', NULL, NULL, NULL, NULL, 'SIR2_euk', NULL, NULL, 17163, 11),
(276181, NULL, 'PIRSF001941', NULL, NULL, NULL, NULL, 'IL-4', NULL, NULL, 6343, 11),
(276182, NULL, 'PIRSF037966', NULL, NULL, NULL, NULL, 'BZLF1', NULL, NULL, 17114, 11),
(276183, NULL, 'PIRSF023322', NULL, NULL, NULL, NULL, 'UCP023322_TM_coiled-coil', NULL, NULL, 13183, 11),
(276184, NULL, 'PIRSF005917', NULL, NULL, NULL, NULL, 'MTase_YraL', NULL, NULL, 7184, 11),
(276185, NULL, 'PIRSF015873', NULL, NULL, NULL, NULL, 'FwdD', NULL, NULL, 10840, 11),
(276186, NULL, 'PIRSF019401', NULL, NULL, NULL, NULL, 'SeqA', NULL, NULL, 2902, 11),
(276187, NULL, 'PIRSF005427', NULL, NULL, NULL, NULL, 'RseB', NULL, NULL, 1838, 11),
(276188, NULL, 'PIRSF031032', NULL, NULL, NULL, NULL, 'TMP_97', NULL, NULL, 17874, 11),
(276189, NULL, 'PIRSF001698', NULL, NULL, NULL, NULL, 'C-ETS', NULL, NULL, 19706, 11),
(276190, NULL, 'PIRSF037207', NULL, NULL, NULL, NULL, 'ATE1_euk', NULL, NULL, 20894, 11),
(276191, NULL, 'PIRSF037373', NULL, NULL, NULL, NULL, 'UCP037373_trxn_reg', NULL, NULL, 21161, 11);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(276192, NULL, 'PIRSF029883', NULL, NULL, NULL, NULL, 'KdgF', NULL, NULL, 23579, 11),
(276193, NULL, 'PIRSF021439', NULL, NULL, NULL, NULL, 'YabA', NULL, NULL, 9232, 11),
(276194, NULL, 'PIRSF031578', NULL, NULL, NULL, NULL, 'UCP0310578_VanZ', NULL, NULL, 15079, 11),
(276195, NULL, 'PIRSF037123', NULL, NULL, NULL, NULL, 'H3K79_HMTase_animal', NULL, NULL, 15204, 11),
(276196, NULL, 'PIRSF003959', NULL, NULL, NULL, NULL, 'NS-M_TospoV', NULL, NULL, 4730, 11),
(276197, NULL, 'PIRSF036626', NULL, NULL, NULL, NULL, 'MPTBd_MobAlike', NULL, NULL, 12506, 11),
(276198, NULL, 'PIRSF036940', NULL, NULL, NULL, NULL, 'PanK_bac_aCoA', NULL, NULL, 11103, 11),
(276199, NULL, 'PIRSF500951', NULL, NULL, NULL, NULL, 'SCGF_recepter', NULL, NULL, 25916, 11),
(276200, NULL, 'PIRSF000706', NULL, NULL, NULL, NULL, 'Kanamycin_kin', NULL, NULL, 12787, 11),
(276201, NULL, 'PIRSF004075', NULL, NULL, NULL, NULL, 'Coat_Flexivir', NULL, NULL, 7977, 11),
(276202, NULL, 'PIRSF016465', NULL, NULL, NULL, NULL, 'Kapp', NULL, NULL, 20113, 11),
(276203, NULL, 'PIRSF018579', NULL, NULL, NULL, NULL, 'Sbp', NULL, NULL, 11665, 11),
(276204, NULL, 'PIRSF036480', NULL, NULL, NULL, NULL, 'FormyFH4_hydr', NULL, NULL, NULL, 11),
(276205, NULL, 'PIRSF037846', NULL, NULL, NULL, NULL, 'Autolysin_YrvJ', NULL, NULL, 16368, 11),
(276206, NULL, 'PIRSF030066', NULL, NULL, NULL, NULL, 'UCP030066', NULL, NULL, 17935, 11),
(276207, NULL, 'PIRSF019634', NULL, NULL, NULL, NULL, 'tRNA_lig_yeast', NULL, NULL, 13209, 11),
(276208, NULL, 'PIRSF029826', NULL, NULL, NULL, NULL, 'UCP029826_pph', NULL, NULL, 25950, 11),
(276209, NULL, 'PIRSF031568', NULL, NULL, NULL, NULL, 'UCP031568', NULL, NULL, 10112, 11),
(276210, NULL, 'PIRSF038015', NULL, NULL, NULL, NULL, 'N-chimaerin', NULL, NULL, 17183, 11),
(276211, NULL, 'PIRSF004682', NULL, NULL, NULL, NULL, 'GmhB', NULL, NULL, 7080, 11),
(276212, NULL, 'PIRSF001112', NULL, NULL, NULL, NULL, 'Epoxide_hydro', NULL, NULL, 19649, 11),
(276213, NULL, 'PIRSF001155', NULL, NULL, NULL, NULL, 'C1r_C1s_MASP', NULL, NULL, 12956, 11),
(276214, NULL, 'PIRSF038901', NULL, NULL, NULL, NULL, 'AQR_cwf11', NULL, NULL, 22970, 11),
(276215, NULL, 'PIRSF006188', NULL, NULL, NULL, NULL, 'UCP006188', NULL, NULL, 14258, 11),
(276216, NULL, 'PIRSF030158', NULL, NULL, NULL, NULL, 'UCP030158', NULL, NULL, 12025, 11),
(276217, NULL, 'PIRSF028235', NULL, NULL, NULL, NULL, 'UCP028235', NULL, NULL, 16465, 11),
(276218, NULL, 'PIRSF020269', NULL, NULL, NULL, NULL, 'UCP020269', NULL, NULL, 9036, 11),
(276219, NULL, 'PIRSF030218', NULL, NULL, NULL, NULL, 'Mannosyltr_MA4085', NULL, NULL, 17855, 11),
(276220, NULL, 'PIRSF037378', NULL, NULL, NULL, NULL, 'EIN2', NULL, NULL, 21115, 11),
(276221, NULL, 'PIRSF006325', NULL, NULL, NULL, NULL, 'Mtase_YecO', NULL, NULL, 4131, 11),
(276222, NULL, 'PIRSF037942', NULL, NULL, NULL, NULL, 'MH2A1', NULL, NULL, 15484, 11),
(276223, NULL, 'PIRSF003159', NULL, NULL, NULL, NULL, 'FlhC', NULL, NULL, 4127, 11),
(276224, NULL, 'PIRSF037390', NULL, NULL, NULL, NULL, 'DoxA_doxD', NULL, NULL, 21440, 11),
(276225, NULL, 'PIRSF039004', NULL, NULL, NULL, NULL, 'ADE_EF_0837', NULL, NULL, 11589, 11),
(276226, NULL, 'PIRSF037163', NULL, NULL, NULL, NULL, 'PRDM12', NULL, NULL, 20601, 11),
(276227, NULL, 'PIRSF000283', NULL, NULL, NULL, NULL, 'COX9', NULL, NULL, 12320, 11),
(276228, NULL, 'PIRSF001031', NULL, NULL, NULL, NULL, 'Glu-a-glcsd_SBD', NULL, NULL, 8650, 11),
(276229, NULL, 'PIRSF003368', NULL, NULL, NULL, NULL, 'Large_T_antigen_PPV', NULL, NULL, 21300, 11),
(276230, NULL, 'PIRSF036615', NULL, NULL, NULL, NULL, 'MHYT_LytTR', NULL, NULL, 12371, 11),
(276231, NULL, 'PIRSF014677', NULL, NULL, NULL, NULL, 'UCP014677', NULL, NULL, 9855, 11),
(276232, NULL, 'PIRSF038150', NULL, NULL, NULL, NULL, 'Metaxin', NULL, NULL, 18092, 11),
(276233, NULL, 'PIRSF004640', NULL, NULL, NULL, NULL, 'IspG', NULL, NULL, 21174, 11),
(276234, NULL, 'PIRSF000454', NULL, NULL, NULL, NULL, 'FAS_yeast_alpha', NULL, NULL, 24707, 11),
(276235, NULL, 'PIRSF019073', NULL, NULL, NULL, NULL, 'UCP019073', NULL, NULL, 10547, 11),
(276236, NULL, 'PIRSF019225', NULL, NULL, NULL, NULL, 'Cyt_c1_Campylob', NULL, NULL, 15417, 11);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(276237, NULL, 'PIRSF000904', NULL, NULL, NULL, NULL, 'FBPtase_SBPase', NULL, NULL, 3945, 11),
(276238, NULL, 'PIRSF000484', NULL, NULL, NULL, NULL, 'NAPRT', NULL, NULL, 6673, 11),
(276239, NULL, 'PIRSF028170', NULL, NULL, NULL, NULL, 'UCP028170', NULL, NULL, 11193, 11),
(276240, NULL, 'PIRSF017179', NULL, NULL, NULL, NULL, 'RISC-Tudor-SN', NULL, NULL, 20224, 11),
(276241, NULL, 'PIRSF037818', NULL, NULL, NULL, NULL, 'Glucagon', NULL, NULL, NULL, 11),
(276242, NULL, 'PIRSF037023', NULL, NULL, NULL, NULL, 'Api_ROM4_ROM5', NULL, NULL, 19607, 11),
(276243, NULL, 'PIRSF005246', NULL, NULL, NULL, NULL, 'MukB', NULL, NULL, 12982, 11),
(276244, NULL, 'PIRSF016281', NULL, NULL, NULL, NULL, 'Transl_init_eIF3d', NULL, NULL, 2197, 11),
(276245, NULL, 'PIRSF031051', NULL, NULL, NULL, NULL, 'PLP_phosphatas_PHOSPHO2', NULL, NULL, 17732, 11),
(276246, NULL, 'PIRSF029038', NULL, NULL, NULL, NULL, 'Mtase_YbiN', NULL, NULL, 17184, 11),
(276247, NULL, 'PIRSF017016', NULL, NULL, NULL, NULL, 'NDUA8', NULL, NULL, 20100, 11),
(276248, NULL, 'PIRSF011771', NULL, NULL, NULL, NULL, 'RMS1_SET', NULL, NULL, 14601, 11),
(276249, NULL, 'PIRSF016662', NULL, NULL, NULL, NULL, 'UCP016662_Toprim', NULL, NULL, 9864, 11),
(276250, NULL, 'PIRSF000089', NULL, NULL, NULL, NULL, 'Electra_flavoP_a', NULL, NULL, 2127, 11),
(276251, NULL, 'PIRSF011484', NULL, NULL, NULL, NULL, 'YaeQ', NULL, NULL, 13416, 11),
(276252, NULL, 'PIRSF003698', NULL, NULL, NULL, NULL, 'VAC_C10L', NULL, NULL, 914, 11),
(276253, NULL, 'PIRSF022944', NULL, NULL, NULL, NULL, 'MRP8', NULL, NULL, 7624, 11),
(276254, NULL, 'PIRSF036996', NULL, NULL, NULL, NULL, 'RSM23', NULL, NULL, 19996, 11),
(276255, NULL, 'PIRSF038204', NULL, NULL, NULL, NULL, 'Distrobrevin', NULL, NULL, 18356, 11),
(276256, NULL, 'PIRSF010312', NULL, NULL, NULL, NULL, 'SoxY', NULL, NULL, 17971, 11),
(276257, NULL, 'PIRSF034081', NULL, NULL, NULL, NULL, 'ATPase_Atu1862', NULL, NULL, 8098, 11),
(276258, NULL, 'PIRSF037437', NULL, NULL, NULL, NULL, 'Atp22', NULL, NULL, 15121, 11),
(276259, NULL, 'PIRSF018136', NULL, NULL, NULL, NULL, 'L_lectin_yeast', NULL, NULL, 20164, 11),
(276260, NULL, 'PIRSF011773', NULL, NULL, NULL, NULL, 'RFA3_yeast', NULL, NULL, 17586, 11),
(276261, NULL, 'PIRSF018875', NULL, NULL, NULL, NULL, 'UCP018875_ABC_perm', NULL, NULL, 16976, 11),
(276262, NULL, 'PIRSF005047', NULL, NULL, NULL, NULL, 'UCP005047_PHP', NULL, NULL, 15999, 11),
(276263, NULL, 'PIRSF019236', NULL, NULL, NULL, NULL, 'UCP019236', NULL, NULL, 21208, 11),
(276264, NULL, 'PIRSF036665', NULL, NULL, NULL, NULL, 'Sulf1', NULL, NULL, 10216, 11),
(276265, NULL, 'PIRSF001563', NULL, NULL, NULL, NULL, 'Folylpolyglu_synth', NULL, NULL, 3125, 11),
(276266, NULL, 'PIRSF006485', NULL, NULL, NULL, NULL, 'EngA', NULL, NULL, 15435, 11),
(276267, NULL, 'PIRSF000606', NULL, NULL, NULL, NULL, 'RPS6_kin_2', NULL, NULL, 17043, 11),
(276268, NULL, 'PIRSF017903', NULL, NULL, NULL, NULL, 'CPDase_plant', NULL, NULL, 13018, 11),
(276269, NULL, 'PIRSF037988', NULL, NULL, NULL, NULL, 'UCP037988', NULL, NULL, 17228, 11),
(276270, NULL, 'PIRSF001110', NULL, NULL, NULL, NULL, 'ADOMetase', NULL, NULL, 19809, 11),
(276271, NULL, 'PIRSF009309', NULL, NULL, NULL, NULL, 'RE_BamHI', NULL, NULL, 2744, 11),
(276272, NULL, 'PIRSF031475', NULL, NULL, NULL, NULL, 'UCP031475', NULL, NULL, 17813, 11),
(276273, NULL, 'PIRSF000101', NULL, NULL, NULL, NULL, 'D-lactate_dh', NULL, NULL, 11760, 11),
(276274, NULL, 'PIRSF000517', NULL, NULL, NULL, NULL, 'Tyr_transaminase', NULL, NULL, 208, 11),
(276275, NULL, 'PIRSF016992', NULL, NULL, NULL, NULL, 'Txn_fac_GATA_plant', NULL, NULL, 20278, 11),
(276276, NULL, 'PIRSF000267', NULL, NULL, NULL, NULL, 'Cyt_oxidse_sub2', NULL, NULL, 4028, 11),
(276277, NULL, 'PIRSF000912', NULL, NULL, NULL, NULL, 'PPEF', NULL, NULL, 10918, 11),
(276278, NULL, 'PIRSF026633', NULL, NULL, NULL, NULL, 'UCP026633_TfuA-like', NULL, NULL, 16314, 11),
(276279, NULL, 'PIRSF022976', NULL, NULL, NULL, NULL, 'NADH_Oxi_21kDa', NULL, NULL, 15454, 11),
(276280, NULL, 'PIRSF029900', NULL, NULL, NULL, NULL, 'Alpha-glucuronds', NULL, NULL, 7764, 11); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(276281, NULL, 'PIRSF036541', NULL, NULL, NULL, NULL, 'UCP036541_AIR', NULL, NULL, 8279, 11),
(276282, NULL, 'PIRSF002541', NULL, NULL, NULL, NULL, 'SP_pAIF', NULL, NULL, 20118, 11),
(276283, NULL, 'PIRSF036750', NULL, NULL, NULL, NULL, 'dCMP_HMase', NULL, NULL, 10224, 11),
(276284, NULL, 'PIRSF002290', NULL, NULL, NULL, NULL, 'CHC', NULL, NULL, 20009, 11),
(276285, NULL, 'PIRSF005677', NULL, NULL, NULL, NULL, 'PPi_PFK_PfpB', NULL, NULL, 10691, 11),
(276286, NULL, 'PIRSF016951', NULL, NULL, NULL, NULL, 'MADP_ribosyltransf_Edin', NULL, NULL, 20396, 11),
(276287, NULL, 'PIRSF000437', NULL, NULL, NULL, NULL, 'GPAT_DHAPAT', NULL, NULL, 15078, 11),
(276288, NULL, 'PIRSF015596', NULL, NULL, NULL, NULL, '5_alpha-SR2', NULL, NULL, 19101, 11),
(276289, NULL, 'PIRSF032131', NULL, NULL, NULL, NULL, 'UCP032131', NULL, NULL, 10333, 11),
(276290, NULL, 'PIRSF000513', NULL, NULL, NULL, NULL, 'Thz_kinase', NULL, NULL, 6810, 11),
(276291, NULL, 'PIRSF500230', NULL, NULL, NULL, NULL, 'Sterol_acyltranf_ACAT', NULL, NULL, 25268, 11),
(276292, NULL, 'PIRSF000019', NULL, NULL, NULL, NULL, 'Bc1_11K', NULL, NULL, 5437, 11),
(276293, NULL, 'PIRSF019240', NULL, NULL, NULL, NULL, 'UCP019240_SpoVT/AbrB-related', NULL, NULL, 21469, 11),
(276294, NULL, 'PIRSF039020', NULL, NULL, NULL, NULL, 'EhpR', NULL, NULL, 22539, 11),
(276295, NULL, 'PIRSF018634', NULL, NULL, NULL, NULL, 'UCP018634', NULL, NULL, 8466, 11),
(276296, NULL, 'PIRSF016521', NULL, NULL, NULL, NULL, 'Acyl-CoA_hydro', NULL, NULL, 20123, 11),
(276297, NULL, 'PIRSF032675', NULL, NULL, NULL, NULL, 'UCP032675', NULL, NULL, 18661, 11),
(276298, NULL, 'PIRSF000501', NULL, NULL, NULL, NULL, 'DHPS_Campy', NULL, NULL, 17481, 11),
(276299, NULL, 'PIRSF016393', NULL, NULL, NULL, NULL, 'Enhancer_rudimentary', NULL, NULL, 6842, 11),
(276300, NULL, 'PIRSF008129', NULL, NULL, NULL, NULL, 'Noggin', NULL, NULL, 13453, 11),
(276301, NULL, 'PIRSF016897', NULL, NULL, NULL, NULL, 'GlpP', NULL, NULL, 2242, 11),
(276302, NULL, 'PIRSF018871', NULL, NULL, NULL, NULL, 'UCP018871', NULL, NULL, 21002, 11),
(276303, NULL, 'PIRSF037253', NULL, NULL, NULL, NULL, 'HTH_CBS', NULL, NULL, 21478, 11),
(276304, NULL, 'PIRSF000204', NULL, NULL, NULL, NULL, 'PNTB', NULL, NULL, 13793, 11),
(276305, NULL, 'PIRSF009562', NULL, NULL, NULL, NULL, 'PerB', NULL, NULL, 9302, 11),
(276306, NULL, 'PIRSF037828', NULL, NULL, NULL, NULL, 'SAP', NULL, NULL, 16318, 11),
(276307, NULL, 'PIRSF003900', NULL, NULL, NULL, NULL, 'N_FiloV', NULL, NULL, 14133, 11),
(276308, NULL, 'PIRSF006641', NULL, NULL, NULL, NULL, 'EngD', NULL, NULL, 5645, 11),
(276309, NULL, 'PIRSF029644', NULL, NULL, NULL, NULL, 'UCP029644', NULL, NULL, 17073, 11),
(276310, NULL, 'PIRSF005578', NULL, NULL, NULL, NULL, 'TlyA', NULL, NULL, 1699, 11),
(276311, NULL, 'PIRSF016839', NULL, NULL, NULL, NULL, 'PhP', NULL, NULL, 5123, 11),
(276312, NULL, 'PIRSF014439', NULL, NULL, NULL, NULL, 'APE1894_ACT', NULL, NULL, 19111, 11),
(276313, NULL, 'PIRSF028503', NULL, NULL, NULL, NULL, 'UCP028503', NULL, NULL, 16519, 11),
(276314, NULL, 'PIRSF021441', NULL, NULL, NULL, NULL, 'CcdC', NULL, NULL, 25180, 11),
(276315, NULL, 'PIRSF500700', NULL, NULL, NULL, NULL, 'MDM2', NULL, NULL, 26379, 11),
(276316, NULL, 'PIRSF006446', NULL, NULL, NULL, NULL, 'Cyt_quinol_oxidase_1', NULL, NULL, 1608, 11),
(276317, NULL, 'PIRSF000336', NULL, NULL, NULL, NULL, 'TH', NULL, NULL, 17376, 11),
(276318, NULL, 'PIRSF036521', NULL, NULL, NULL, NULL, 'UCP036521_pph', NULL, NULL, 8080, 11),
(276319, NULL, 'PIRSF002513', NULL, NULL, NULL, NULL, 'Integrin_B4', NULL, NULL, 10768, 11),
(276320, NULL, 'PIRSF000398', NULL, NULL, NULL, NULL, 'M_m6A_EcoRV', NULL, NULL, 11875, 11),
(276321, NULL, 'PIRSF022393', NULL, NULL, NULL, NULL, 'HAP', NULL, NULL, 1839, 11),
(276322, NULL, 'PIRSF036388', NULL, NULL, NULL, NULL, 'Ctsl_amnpptdse_B', NULL, NULL, 7888, 11),
(276323, NULL, 'PIRSF028687', NULL, NULL, NULL, NULL, 'UCP028687', NULL, NULL, 7109, 11),
(276324, NULL, 'PIRSF036934', NULL, NULL, NULL, NULL, 'TrpE-G', NULL, NULL, 2040, 11),
(276325, NULL, 'PIRSF000333', NULL, NULL, NULL, NULL, 'INOS', NULL, NULL, 7042, 11);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(276326, NULL, 'PIRSF011416', NULL, NULL, NULL, NULL, 'Ais-TraG-AfrS', NULL, NULL, 10210, 11),
(276327, NULL, 'PIRSF038039', NULL, NULL, NULL, NULL, 'UCP038039_Lin-7_homol', NULL, NULL, 17712, 11),
(276328, NULL, 'PIRSF007398', NULL, NULL, NULL, NULL, 'Sll0148_casp', NULL, NULL, 10675, 11),
(276329, NULL, 'PIRSF037871', NULL, NULL, NULL, NULL, 'TIM44', NULL, NULL, 16567, 11),
(276330, NULL, 'PIRSF036862', NULL, NULL, NULL, NULL, 'ERp72', NULL, NULL, 19845, 11),
(276331, NULL, 'PIRSF018748', NULL, NULL, NULL, NULL, 'UCP018748', NULL, NULL, 19846, 11),
(276332, NULL, 'PIRSF005627', NULL, NULL, NULL, NULL, 'MTD', NULL, NULL, 5526, 11),
(276333, NULL, 'PIRSF037393', NULL, NULL, NULL, NULL, 'TGFRII', NULL, NULL, 21483, 11),
(276334, NULL, 'PIRSF037505', NULL, NULL, NULL, NULL, 'BHMT', NULL, NULL, 15326, 11),
(276335, NULL, 'PIRSF035918', NULL, NULL, NULL, NULL, 'UCP035918', NULL, NULL, 18548, 11),
(276336, NULL, 'PIRSF016789', NULL, NULL, NULL, NULL, 'UCP016789', NULL, NULL, 3520, 11),
(276337, NULL, 'PIRSF005658', NULL, NULL, NULL, NULL, 'FwdF', NULL, NULL, 34068, 11),
(276338, NULL, 'PIRSF001473', NULL, NULL, NULL, NULL, 'FK506-bp_FPR3', NULL, NULL, 18168, 11),
(276339, NULL, 'PIRSF021524', NULL, NULL, NULL, NULL, 'MSH_acetyltransferase', NULL, NULL, 19182, 11),
(276340, NULL, 'PIRSF006054', NULL, NULL, NULL, NULL, 'UCP006054', NULL, NULL, 15467, 11),
(276341, NULL, 'PIRSF038972', NULL, NULL, NULL, NULL, 'Trm12', NULL, NULL, 24694, 11),
(276342, NULL, 'PIRSF037470', NULL, NULL, NULL, NULL, 'RRP', NULL, NULL, 15060, 11),
(276343, NULL, 'PIRSF009283', NULL, NULL, NULL, NULL, '4HPP_dioxygenase', NULL, NULL, 283, 11),
(276344, NULL, 'PIRSF000631', NULL, NULL, NULL, NULL, 'TyrPK_receptor_Ret', NULL, NULL, 17143, 11),
(276345, NULL, 'PIRSF035875', NULL, NULL, NULL, NULL, 'RNase_BN', NULL, NULL, 18826, 11),
(276346, NULL, 'PIRSF001832', NULL, NULL, NULL, NULL, 'PTH', NULL, NULL, 1329, 11),
(276347, NULL, 'PIRSF500061', NULL, NULL, NULL, NULL, 'GOGAT_lg2_archl', NULL, NULL, 33739, 11),
(276348, NULL, 'PIRSF028777', NULL, NULL, NULL, NULL, 'UCP028777', NULL, NULL, 24005, 11),
(276349, NULL, 'PIRSF036312', NULL, NULL, NULL, NULL, 'Fibrillin', NULL, NULL, NULL, 11),
(276350, NULL, 'PIRSF037010', NULL, NULL, NULL, NULL, 'SF3B5', NULL, NULL, 19690, 11),
(276351, NULL, 'PIRSF000401', NULL, NULL, NULL, NULL, 'RPL11_MTase', NULL, NULL, 1970, 11),
(276352, NULL, 'PIRSF019322', NULL, NULL, NULL, NULL, 'UCP019322', NULL, NULL, 21062, 11),
(276353, NULL, 'PIRSF002560', NULL, NULL, NULL, NULL, 'Bacterioferritin', NULL, NULL, 2463, 11),
(276354, NULL, 'PIRSF006500', NULL, NULL, NULL, NULL, 'MtrG', NULL, NULL, 6881, 11),
(276355, NULL, 'PIRSF028757', NULL, NULL, NULL, NULL, 'LD-carboxypeptidase', NULL, NULL, 6479, 11),
(276356, NULL, 'PIRSF500135', NULL, NULL, NULL, NULL, 'GDPman_DH', NULL, NULL, 26345, 11),
(276357, NULL, 'PIRSF037660', NULL, NULL, NULL, NULL, 'HA-17', NULL, NULL, 7625, 11),
(276358, NULL, 'PIRSF000148', NULL, NULL, NULL, NULL, 'ASA_dh', NULL, NULL, NULL, 11),
(276359, NULL, 'PIRSF000610', NULL, NULL, NULL, NULL, 'STPK_YKL171w', NULL, NULL, 17210, 11),
(276360, NULL, 'PIRSF036924', NULL, NULL, NULL, NULL, 'Snx5_Snx6', NULL, NULL, 8013, 11),
(276361, NULL, 'PIRSF007043', NULL, NULL, NULL, NULL, 'YopQ', NULL, NULL, 16353, 11),
(276362, NULL, 'PIRSF003174', NULL, NULL, NULL, NULL, 'CreA', NULL, NULL, 7944, 11),
(276363, NULL, 'PIRSF017340', NULL, NULL, NULL, NULL, 'Nudix_hydro', NULL, NULL, 13658, 11),
(276364, NULL, 'PIRSF037029', NULL, NULL, NULL, NULL, 'BAG_1', NULL, NULL, 19727, 11),
(276365, NULL, 'PIRSF036573', NULL, NULL, NULL, NULL, 'REV1', NULL, NULL, 12692, 11),
(276366, NULL, 'PIRSF005485', NULL, NULL, NULL, NULL, 'HrcA', NULL, NULL, 1793, 11),
(276367, NULL, 'PIRSF001822', NULL, NULL, NULL, NULL, 'Dermaseptin_prec', NULL, NULL, 20145, 11),
(276368, NULL, 'PIRSF007103', NULL, NULL, NULL, NULL, 'UCP007103', NULL, NULL, 16248, 11),
(276369, NULL, 'PIRSF000723', NULL, NULL, NULL, NULL, 'Carbamate_kin', NULL, NULL, 7437, 11),
(276370, NULL, 'PIRSF005357', NULL, NULL, NULL, NULL, 'UCP005357', NULL, NULL, 434, 11);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(276371, NULL, 'PIRSF000587', NULL, NULL, NULL, NULL, 'PI3K_Vps34', NULL, NULL, 8991, 11),
(276372, NULL, 'PIRSF038118', NULL, NULL, NULL, NULL, 'MBP_jacalin', NULL, NULL, 19208, 11),
(276373, NULL, 'PIRSF001843', NULL, NULL, NULL, NULL, 'NKB', NULL, NULL, 1222, 11),
(276374, NULL, 'PIRSF003890', NULL, NULL, NULL, NULL, 'LigT_coronavirus', NULL, NULL, 3255, 11),
(276375, NULL, 'PIRSF019271', NULL, NULL, NULL, NULL, 'Acid_Ptase_C', NULL, NULL, 6504, 11),
(276376, NULL, 'PIRSF019883', NULL, NULL, NULL, NULL, 'UCP019883', NULL, NULL, 21134, 11),
(276377, NULL, 'PIRSF033095', NULL, NULL, NULL, NULL, '5NTD_SA0022', NULL, NULL, 8132, 11),
(276378, NULL, 'PIRSF036421', NULL, NULL, NULL, NULL, 'Tricorn_protease', NULL, NULL, 13029, 11),
(276379, NULL, 'PIRSF001480', NULL, NULL, NULL, NULL, 'PMI', NULL, NULL, 19578, 11),
(276380, NULL, 'PIRSF030798', NULL, NULL, NULL, NULL, 'UCP030798', NULL, NULL, 17646, 11),
(276381, NULL, 'PIRSF002158', NULL, NULL, NULL, NULL, 'RPL2p_RPL2a_RPL8e_RPL2o', NULL, NULL, 210, 11),
(276382, NULL, 'PIRSF004944', NULL, NULL, NULL, NULL, 'UCP004944_hydrls', NULL, NULL, 7718, 11),
(276383, NULL, 'PIRSF000898', NULL, NULL, NULL, NULL, 'Acid_Ptase_5', NULL, NULL, 16440, 11),
(276384, NULL, 'PIRSF001084', NULL, NULL, NULL, NULL, 'B-galactosidase', NULL, NULL, 6496, 11),
(276385, NULL, 'PIRSF006456', NULL, NULL, NULL, NULL, 'UCP006456', NULL, NULL, 6916, 11),
(276386, NULL, 'PIRSF005562', NULL, NULL, NULL, NULL, 'FAS_yeast_beta', NULL, NULL, 15126, 11),
(276387, NULL, 'PIRSF037609', NULL, NULL, NULL, NULL, 'BLOC-1_pldn', NULL, NULL, 15205, 11),
(276388, NULL, 'PIRSF018461', NULL, NULL, NULL, NULL, 'Phage_rep_C1', NULL, NULL, 21088, 11),
(276389, NULL, 'PIRSF000386', NULL, NULL, NULL, NULL, 'tRNA_mtase', NULL, NULL, 2522, 11),
(276390, NULL, 'PIRSF032888', NULL, NULL, NULL, NULL, 'UCP032888', NULL, NULL, 18737, 11),
(276391, NULL, 'PIRSF036580', NULL, NULL, NULL, NULL, 'Cyclin_L', NULL, NULL, NULL, 11),
(276392, NULL, 'PIRSF000559', NULL, NULL, NULL, NULL, 'cGMP-dep_kinase', NULL, NULL, 6025, 11),
(276393, NULL, 'PIRSF036441', NULL, NULL, NULL, NULL, 'NAGK_DUF619', NULL, NULL, 10986, 11),
(276394, NULL, 'PIRSF003949', NULL, NULL, NULL, NULL, 'N_HantaV', NULL, NULL, 405, 11),
(276395, NULL, 'PIRSF007407', NULL, NULL, NULL, NULL, 'UCP007407_Abi', NULL, NULL, 16391, 11),
(276396, NULL, 'PIRSF037434', NULL, NULL, NULL, NULL, 'HK_ChrS', NULL, NULL, 15444, 11),
(276397, NULL, 'PIRSF037409', NULL, NULL, NULL, NULL, 'UCP037409_transporter', NULL, NULL, 14510, 11),
(276398, NULL, 'PIRSF001831', NULL, NULL, NULL, NULL, 'Thyroglobulin', NULL, NULL, 20281, 11),
(276399, NULL, 'PIRSF036370', NULL, NULL, NULL, NULL, 'ST14', NULL, NULL, 19535, 11),
(276400, NULL, 'PIRSF021332', NULL, NULL, NULL, NULL, 'UCP021332', NULL, NULL, 8436, 11),
(276401, NULL, 'PIRSF003196', NULL, NULL, NULL, NULL, 'Trp_repressor', NULL, NULL, 18602, 11),
(276402, NULL, 'PIRSF006318', NULL, NULL, NULL, NULL, 'YhcB', NULL, NULL, 8391, 11),
(276403, NULL, 'PIRSF037874', NULL, NULL, NULL, NULL, 'NCK', NULL, NULL, 16534, 11),
(276404, NULL, 'PIRSF037495', NULL, NULL, NULL, NULL, 'OoxA/HcnB', NULL, NULL, 15273, 11),
(276405, NULL, 'PIRSF026478', NULL, NULL, NULL, NULL, 'UCP026478_dh', NULL, NULL, 15024, 11),
(276406, NULL, 'PIRSF000017', NULL, NULL, NULL, NULL, 'RC_cytochrome', NULL, NULL, 3356, 11),
(276407, NULL, 'PIRSF001951', NULL, NULL, NULL, NULL, 'EPO', NULL, NULL, 7148, 11),
(276408, NULL, 'PIRSF006157', NULL, NULL, NULL, NULL, 'Doxgns_DODA', NULL, NULL, 7842, 11),
(276409, NULL, 'PIRSF009433', NULL, NULL, NULL, NULL, 'UCP009433', NULL, NULL, 8101, 11),
(276410, NULL, 'PIRSF029876', NULL, NULL, NULL, NULL, 'UCP029876', NULL, NULL, 7998, 11),
(276411, NULL, 'PIRSF037137', NULL, NULL, NULL, NULL, 'HPS_DMK', NULL, NULL, 20419, 11),
(276412, NULL, 'PIRSF000371', NULL, NULL, NULL, NULL, 'PFLA_YjjW', NULL, NULL, 12511, 11),
(276413, NULL, 'PIRSF006601', NULL, NULL, NULL, NULL, 'ATPase_UCP006601', NULL, NULL, 12992, 11),
(276414, NULL, 'PIRSF033093', NULL, NULL, NULL, NULL, 'UCP_ML1119', NULL, NULL, 8096, 11),
(276415, NULL, 'PIRSF001905', NULL, NULL, NULL, NULL, 'Sea_anemon_toxin', NULL, NULL, 3929, 11);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(276416, NULL, 'PIRSF036948', NULL, NULL, NULL, NULL, 'TOM1', NULL, NULL, 8084, 11),
(276417, NULL, 'PIRSF002134', NULL, NULL, NULL, NULL, 'RPS13p_RPS13a_RPS18e_RPS13o', NULL, NULL, 4401, 11),
(276418, NULL, 'PIRSF006578', NULL, NULL, NULL, NULL, 'FwdE', NULL, NULL, 26667, 11),
(276419, NULL, 'PIRSF031134', NULL, NULL, NULL, NULL, 'MTRK', NULL, NULL, 10470, 11),
(276420, NULL, 'PIRSF036543', NULL, NULL, NULL, NULL, 'YdrC_chlamyd', NULL, NULL, 8009, 11),
(276421, NULL, 'PIRSF037238', NULL, NULL, NULL, NULL, 'Carboxypeptidase_G2', NULL, NULL, 20713, 11),
(276422, NULL, 'PIRSF500773', NULL, NULL, NULL, NULL, 'Hyaluronidase_PH20_Hyal5', NULL, NULL, 3164, 11),
(276423, NULL, 'PIRSF037991', NULL, NULL, NULL, NULL, 'UCP037991_UBX_2_7', NULL, NULL, 17283, 11),
(276424, NULL, 'PIRSF028729', NULL, NULL, NULL, NULL, 'SCF_Skp', NULL, NULL, 16788, 11),
(276425, NULL, 'PIRSF028743', NULL, NULL, NULL, NULL, 'GvpO_protein', NULL, NULL, 14345, 11),
(276426, NULL, 'PIRSF019083', NULL, NULL, NULL, NULL, 'UCP019083_VanZ', NULL, NULL, 21121, 11),
(276427, NULL, 'PIRSF032178', NULL, NULL, NULL, NULL, 'UCP032178', NULL, NULL, 18549, 11),
(276428, NULL, 'PIRSF004638', NULL, NULL, NULL, NULL, 'UCP004638', NULL, NULL, 4201, 11),
(276429, NULL, 'PIRSF001348', NULL, NULL, NULL, NULL, 'PEP_carboxykin_GTP', NULL, NULL, 7480, 11),
(276430, NULL, 'PIRSF000111', NULL, NULL, NULL, NULL, 'ALDH_ADH', NULL, NULL, 12748, 11),
(276431, NULL, 'PIRSF001499', NULL, NULL, NULL, NULL, 'Chor_mut_pdh_Tpr', NULL, NULL, 702, 11),
(276432, NULL, 'PIRSF019693', NULL, NULL, NULL, NULL, 'VAMP_assoc_prot', NULL, NULL, 21334, 11),
(276433, NULL, 'PIRSF006272', NULL, NULL, NULL, NULL, 'UCP006272', NULL, NULL, 1556, 11),
(276434, NULL, 'PIRSF000933', NULL, NULL, NULL, NULL, 'PTPN13', NULL, NULL, 7439, 11),
(276435, NULL, 'PIRSF036470', NULL, NULL, NULL, NULL, 'PLD_plant', NULL, NULL, 7699, 11),
(276436, NULL, 'PIRSF016262', NULL, NULL, NULL, NULL, 'LPLase', NULL, NULL, 5986, 11),
(276437, NULL, 'PIRSF033053', NULL, NULL, NULL, NULL, 'UCP033503_fimbr', NULL, NULL, 18551, 11),
(276438, NULL, 'PIRSF012562', NULL, NULL, NULL, NULL, 'UCP012562', NULL, NULL, 11501, 11),
(276439, NULL, 'PIRSF037471', NULL, NULL, NULL, NULL, 'UCP037471', NULL, NULL, 15201, 11),
(276440, NULL, 'PIRSF000090', NULL, NULL, NULL, NULL, 'Beta-ETF', NULL, NULL, 11885, 11),
(276441, NULL, 'PIRSF037568', NULL, NULL, NULL, NULL, 'ROCK', NULL, NULL, 20708, 11),
(276442, NULL, 'PIRSF038036', NULL, NULL, NULL, NULL, 'Cdc42ep2', NULL, NULL, 17681, 11),
(276443, NULL, 'PIRSF038132', NULL, NULL, NULL, NULL, 'NUDIX_AtNUDT22', NULL, NULL, 26163, 11),
(276444, NULL, 'PIRSF010056', NULL, NULL, NULL, NULL, 'UCP010056', NULL, NULL, 17716, 11),
(276445, NULL, 'PIRSF032572', NULL, NULL, NULL, NULL, 'MUB', NULL, NULL, 18621, 11),
(276446, NULL, 'PIRSF016175', NULL, NULL, NULL, NULL, 'UCP016175', NULL, NULL, 19526, 11),
(276447, NULL, 'PIRSF500948', NULL, NULL, NULL, NULL, 'Beta-PDGF_receptor', NULL, NULL, 25816, 11),
(276448, NULL, 'PIRSF003854', NULL, NULL, NULL, NULL, 'Vif_BLV', NULL, NULL, 8059, 11),
(276449, NULL, 'PIRSF037931', NULL, NULL, NULL, NULL, 'TMPRSS9_polyserase-1', NULL, NULL, 17399, 11),
(276450, NULL, 'PIRSF007248', NULL, NULL, NULL, NULL, 'UCP007248', NULL, NULL, 16074, 11),
(276451, NULL, 'PIRSF000440', NULL, NULL, NULL, NULL, 'CAT', NULL, NULL, 3287, 11),
(276452, NULL, 'PIRSF015000', NULL, NULL, NULL, NULL, 'UCP01500', NULL, NULL, 9749, 11),
(276453, NULL, 'PIRSF038156', NULL, NULL, NULL, NULL, 'RNA_polymII_KELP', NULL, NULL, 18159, 11),
(276454, NULL, 'PIRSF036593', NULL, NULL, NULL, NULL, 'GrdD', NULL, NULL, 12589, 11),
(276455, NULL, 'PIRSF009404', NULL, NULL, NULL, NULL, 'Txn_factor_DP', NULL, NULL, 17693, 11),
(276456, NULL, 'PIRSF002129', NULL, NULL, NULL, NULL, 'RPS6e', NULL, NULL, 7337, 11),
(276457, NULL, 'PIRSF017388', NULL, NULL, NULL, NULL, 'Esterase_lipase', NULL, NULL, 12798, 11),
(276458, NULL, 'PIRSF028299', NULL, NULL, NULL, NULL, 'UCP028299', NULL, NULL, 16289, 11),
(276459, NULL, 'PIRSF037178', NULL, NULL, NULL, NULL, 'TTR-like', NULL, NULL, 20606, 11);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(276460, NULL, 'PIRSF000164', NULL, NULL, NULL, NULL, 'DHO_oxidase', NULL, NULL, 13961, 11),
(276461, NULL, 'PIRSF037136', NULL, NULL, NULL, NULL, 'RKM1', NULL, NULL, 20319, 11),
(276462, NULL, 'PIRSF031277', NULL, NULL, NULL, NULL, 'UCP031277', NULL, NULL, 17620, 11),
(276463, NULL, 'PIRSF038953', NULL, NULL, NULL, NULL, 'SigI', NULL, NULL, 11398, 11),
(276464, NULL, 'PIRSF000162', NULL, NULL, NULL, NULL, 'P_chlorophyll_rd', NULL, NULL, 1134, 11),
(276465, NULL, 'PIRSF038149', NULL, NULL, NULL, NULL, 'Pyruvate_Pi_dikinase_reg', NULL, NULL, 18193, 11),
(276466, NULL, 'PIRSF000303', NULL, NULL, NULL, NULL, 'Glutathion_perox', NULL, NULL, 4632, 11),
(276467, NULL, 'PIRSF023803', NULL, NULL, NULL, NULL, 'RNase_P', NULL, NULL, 15017, 11),
(276468, NULL, 'PIRSF039008', NULL, NULL, NULL, NULL, 'YjbJ', NULL, NULL, 25119, 11),
(276469, NULL, 'PIRSF037219', NULL, NULL, NULL, NULL, 'NOS_oxygenase', NULL, NULL, 20717, 11),
(276470, NULL, 'PIRSF001330', NULL, NULL, NULL, NULL, 'IOD', NULL, NULL, 3863, 11),
(276471, NULL, 'PIRSF007871', NULL, NULL, NULL, NULL, 'Cox20', NULL, NULL, 14798, 11),
(276472, NULL, 'PIRSF012320', NULL, NULL, NULL, NULL, 'Prplsmic_HI0178', NULL, NULL, 17501, 11),
(276473, NULL, 'PIRSF036911', NULL, NULL, NULL, NULL, 'CREG', NULL, NULL, 8209, 11),
(276474, NULL, 'PIRSF000533', NULL, NULL, NULL, NULL, 'ATP_PFK_euk', NULL, NULL, 9778, 11),
(276475, NULL, 'PIRSF010219', NULL, NULL, NULL, NULL, 'UCP010219', NULL, NULL, 17572, 11),
(276476, NULL, 'PIRSF017288', NULL, NULL, NULL, NULL, 'PMK_GHMP_euk', NULL, NULL, 9241, 11),
(276477, NULL, 'PIRSF016138', NULL, NULL, NULL, NULL, 'UCP016138', NULL, NULL, 8890, 11),
(276478, NULL, 'PIRSF029962', NULL, NULL, NULL, NULL, 'UCP029962', NULL, NULL, 17597, 11),
(276479, NULL, 'PIRSF028561', NULL, NULL, NULL, NULL, 'Ac_Trasf', NULL, NULL, 12213, 11),
(276480, NULL, 'PIRSF037955', NULL, NULL, NULL, NULL, 'Snurportin-1', NULL, NULL, 17039, 11),
(276481, NULL, 'PIRSF015875', NULL, NULL, NULL, NULL, 'UCP015875', NULL, NULL, 3671, 11),
(276482, NULL, 'PIRSF036548', NULL, NULL, NULL, NULL, 'Fdx_FixX', NULL, NULL, 13575, 11),
(276483, NULL, 'PIRSF037865', NULL, NULL, NULL, NULL, 'DFF_alpha', NULL, NULL, 16978, 11),
(276484, NULL, 'PIRSF000412', NULL, NULL, NULL, NULL, 'SHMT', NULL, NULL, 2430, 11),
(276485, NULL, 'PIRSF037971', NULL, NULL, NULL, NULL, 'TLX_CD46', NULL, NULL, 17370, 11),
(276486, NULL, 'PIRSF500808', NULL, NULL, NULL, NULL, 'PTPR_alpha', NULL, NULL, 26592, 11),
(276487, NULL, 'PIRSF011609', NULL, NULL, NULL, NULL, 'DRT102', NULL, NULL, 12704, 11),
(276488, NULL, 'PIRSF026434', NULL, NULL, NULL, NULL, 'RR_ycf55', NULL, NULL, 16171, 11),
(276489, NULL, 'PIRSF011282', NULL, NULL, NULL, NULL, 'Synaptogyrin', NULL, NULL, 17567, 11),
(276490, NULL, 'PIRSF037420', NULL, NULL, NULL, NULL, 'PqqE', NULL, NULL, 14799, 11),
(276491, NULL, 'PIRSF001665', NULL, NULL, NULL, NULL, 'PLB', NULL, NULL, 1257, 11),
(276492, NULL, 'PIRSF003766', NULL, NULL, NULL, NULL, 'VAC_I2L', NULL, NULL, 9935, 11),
(276493, NULL, 'PIRSF036630', NULL, NULL, NULL, NULL, 'Aconts_X_fused', NULL, NULL, 11304, 11),
(276494, NULL, 'PIRSF032067', NULL, NULL, NULL, NULL, 'Cyanophycinase', NULL, NULL, 13460, 11),
(276495, NULL, 'PIRSF000171', NULL, NULL, NULL, NULL, 'SDHA_APRA_LASPO', NULL, NULL, NULL, 11),
(276496, NULL, 'PIRSF017228', NULL, NULL, NULL, NULL, 'Sphnglp_dlt4_des', NULL, NULL, 14741, 11),
(276497, NULL, 'PIRSF012641', NULL, NULL, NULL, NULL, 'UCP012641', NULL, NULL, 21504, 11),
(276498, NULL, 'PIRSF000180', NULL, NULL, NULL, NULL, 'FrdC', NULL, NULL, 6231, 11),
(276499, NULL, 'PIRSF011091', NULL, NULL, NULL, NULL, 'BBS7', NULL, NULL, 17852, 11),
(276500, NULL, 'PIRSF037709', NULL, NULL, NULL, NULL, 'DOV-IR', NULL, NULL, 16056, 11),
(276501, NULL, 'PIRSF004030', NULL, NULL, NULL, NULL, 'Z_ArenaV', NULL, NULL, 13458, 11),
(276502, NULL, 'PIRSF008292', NULL, NULL, NULL, NULL, 'UCP008292', NULL, NULL, 16473, 11),
(276503, NULL, 'PIRSF006162', NULL, NULL, NULL, NULL, 'PgpA', NULL, NULL, 24835, 11),
(276504, NULL, 'PIRSF020217', NULL, NULL, NULL, NULL, 'UCP020217', NULL, NULL, 8050, 11);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(276505, NULL, 'PIRSF021719', NULL, NULL, NULL, NULL, 'UCP021719', NULL, NULL, 8474, 11),
(276506, NULL, 'PIRSF003669', NULL, NULL, NULL, NULL, 'Aden_E1A', NULL, NULL, 7838, 11),
(276507, NULL, 'PIRSF028609', NULL, NULL, NULL, NULL, 'UCP028609', NULL, NULL, 16802, 11),
(276508, NULL, 'PIRSF000181', NULL, NULL, NULL, NULL, 'Grc_selenoprot_A', NULL, NULL, 3806, 11),
(276509, NULL, 'PIRSF016095', NULL, NULL, NULL, NULL, 'VirD2', NULL, NULL, 19401, 11),
(276510, NULL, 'PIRSF005426', NULL, NULL, NULL, NULL, 'Frp', NULL, NULL, 15397, 11),
(276511, NULL, 'PIRSF026449', NULL, NULL, NULL, NULL, 'UCP026449', NULL, NULL, 16365, 11),
(276512, NULL, 'PIRSF037465', NULL, NULL, NULL, NULL, 'UCP037465_Zn', NULL, NULL, 15005, 11),
(276513, NULL, 'PIRSF020481', NULL, NULL, NULL, NULL, 'BAP', NULL, NULL, 11031, 11),
(276514, NULL, 'PIRSF500183', NULL, NULL, NULL, NULL, 'Hepatocyte_GF', NULL, NULL, 25753, 11),
(276515, NULL, 'PIRSF033909', NULL, NULL, NULL, NULL, 'UCP033909', NULL, NULL, 8012, 11),
(276516, NULL, 'PIRSF031715', NULL, NULL, NULL, NULL, 'CobT_chel', NULL, NULL, 115, 11),
(276517, NULL, 'PIRSF036945', NULL, NULL, NULL, NULL, 'Spt5', NULL, NULL, 19561, 11),
(276518, NULL, 'PIRSF028934', NULL, NULL, NULL, NULL, 'Cyclin_CG14939', NULL, NULL, 13096, 11),
(276519, NULL, 'PIRSF003768', NULL, NULL, NULL, NULL, 'VAC_I5L', NULL, NULL, 3957, 11),
(276520, NULL, 'PIRSF003784', NULL, NULL, NULL, NULL, 'VAC_N1L', NULL, NULL, 14091, 11),
(276521, NULL, 'PIRSF016552', NULL, NULL, NULL, NULL, 'MtrD', NULL, NULL, 5976, 11),
(276522, NULL, 'PIRSF028162', NULL, NULL, NULL, NULL, 'BcbE', NULL, NULL, 16060, 11),
(276523, NULL, 'PIRSF038021', NULL, NULL, NULL, NULL, 'UCP038021_RWDD2', NULL, NULL, 17624, 11),
(276524, NULL, 'PIRSF029225', NULL, NULL, NULL, NULL, 'DNA_pol_III_psi', NULL, NULL, 2362, 11),
(276525, NULL, 'PIRSF006661', NULL, NULL, NULL, NULL, 'UCP006661_PP-loop', NULL, NULL, 11267, 11),
(276526, NULL, 'PIRSF028065', NULL, NULL, NULL, NULL, 'UCP028065', NULL, NULL, 16240, 11),
(276527, NULL, 'PIRSF004574', NULL, NULL, NULL, NULL, 'RepA4', NULL, NULL, 21411, 11),
(276528, NULL, 'PIRSF000661', NULL, NULL, NULL, NULL, 'STPK_RAD53', NULL, NULL, 17029, 11),
(276529, NULL, 'PIRSF036489', NULL, NULL, NULL, NULL, '10-FTHFDH', NULL, NULL, 8053, 11),
(276530, NULL, 'PIRSF038922', NULL, NULL, NULL, NULL, 'SRP72', NULL, NULL, 22646, 11),
(276531, NULL, 'PIRSF001145', NULL, NULL, NULL, NULL, 'Tissue_plasm_act', NULL, NULL, 26741, 11),
(276532, NULL, 'PIRSF028773', NULL, NULL, NULL, NULL, 'UCP028773', NULL, NULL, 4689, 11),
(276533, NULL, 'PIRSF005813', NULL, NULL, NULL, NULL, 'MSH2', NULL, NULL, 10853, 11),
(276534, NULL, 'PIRSF011869', NULL, NULL, NULL, NULL, 'Nibrin_animal', NULL, NULL, 17628, 11),
(276535, NULL, 'PIRSF001237', NULL, NULL, NULL, NULL, 'Dihydroorotase', NULL, NULL, 3154, 11),
(276536, NULL, 'PIRSF000876', NULL, NULL, NULL, NULL, 'RR_chemtxs_CheB', NULL, NULL, 652, 11),
(276537, NULL, 'PIRSF500794', NULL, NULL, NULL, NULL, 'Thiamine_transporter_1', NULL, NULL, 26911, 11),
(276538, NULL, 'PIRSF030989', NULL, NULL, NULL, NULL, 'Glycoporin_RafY', NULL, NULL, 17876, 11),
(276539, NULL, 'PIRSF017535', NULL, NULL, NULL, NULL, 'ESCRT1_Vps28', NULL, NULL, 37, 11),
(276540, NULL, 'PIRSF038141', NULL, NULL, NULL, NULL, 'PP1_12ABC_vert', NULL, NULL, 18414, 11),
(276541, NULL, 'PIRSF017023', NULL, NULL, NULL, NULL, 'KNR4', NULL, NULL, 10149, 11),
(276542, NULL, 'PIRSF020818', NULL, NULL, NULL, NULL, 'PHB_depoly', NULL, NULL, 8672, 11),
(276543, NULL, 'PIRSF001273', NULL, NULL, NULL, NULL, 'CDH', NULL, NULL, 2442, 11),
(276544, NULL, 'PIRSF037578', NULL, NULL, NULL, NULL, 'MAPKKK_STE11_Cryp', NULL, NULL, 15298, 11),
(276545, NULL, 'PIRSF021497', NULL, NULL, NULL, NULL, 'Sulfotransf_LpsS', NULL, NULL, 9823, 11),
(276546, NULL, 'PIRSF036400', NULL, NULL, NULL, NULL, 'RR_Ctr_UCP036400', NULL, NULL, 8230, 11),
(276547, NULL, 'PIRSF037246', NULL, NULL, NULL, NULL, 'UCP037246', NULL, NULL, 21308, 11),
(276548, NULL, 'PIRSF001849', NULL, NULL, NULL, NULL, 'Guanylin', NULL, NULL, 4544, 11),
(276549, NULL, 'PIRSF005149', NULL, NULL, NULL, NULL, 'IPC-B_HD', NULL, NULL, 7841, 11);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(276550, NULL, 'PIRSF004654', NULL, NULL, NULL, NULL, 'NlpI', NULL, NULL, 16220, 11),
(276551, NULL, 'PIRSF005825', NULL, NULL, NULL, NULL, 'PufQ', NULL, NULL, 13714, 11),
(276552, NULL, 'PIRSF017371', NULL, NULL, NULL, NULL, 'UCP017371', NULL, NULL, 10070, 11),
(276553, NULL, 'PIRSF000040', NULL, NULL, NULL, NULL, 'MMOH_comp', NULL, NULL, 12014, 11),
(276554, NULL, 'PIRSF002070', NULL, NULL, NULL, NULL, 'SSB', NULL, NULL, 10569, 11),
(276555, NULL, 'PIRSF004955', NULL, NULL, NULL, NULL, 'HTH_arch', NULL, NULL, 10515, 11),
(276556, NULL, 'PIRSF026760', NULL, NULL, NULL, NULL, 'UCP026760', NULL, NULL, 10905, 11),
(276557, NULL, 'PIRSF024622', NULL, NULL, NULL, NULL, 'Tfp_FimT', NULL, NULL, 15166, 11),
(276558, NULL, 'PIRSF003059', NULL, NULL, NULL, NULL, 'GtfA', NULL, NULL, 20261, 11),
(276559, NULL, 'PIRSF000390', NULL, NULL, NULL, NULL, 'PLP_StrS', NULL, NULL, 4124, 11),
(276560, NULL, 'PIRSF003273', NULL, NULL, NULL, NULL, 'Mobilization_A', NULL, NULL, 21318, 11),
(276561, NULL, 'PIRSF011491', NULL, NULL, NULL, NULL, 'Mtase_YbcY', NULL, NULL, 17601, 11),
(276562, NULL, 'PIRSF026640', NULL, NULL, NULL, NULL, 'Peripl_chor_mut', NULL, NULL, 698, 11),
(276563, NULL, 'PIRSF009415', NULL, NULL, NULL, NULL, 'TFIIA_gamma_hum', NULL, NULL, 3086, 11),
(276564, NULL, 'PIRSF002936', NULL, NULL, NULL, NULL, 'SAT_2', NULL, NULL, 13281, 11),
(276565, NULL, 'PIRSF024608', NULL, NULL, NULL, NULL, 'UCP024608', NULL, NULL, 15002, 11),
(276566, NULL, 'PIRSF037646', NULL, NULL, NULL, NULL, 'Apaf_1', NULL, NULL, 15835, 11),
(276567, NULL, 'PIRSF001007', NULL, NULL, NULL, NULL, 'RusA', NULL, NULL, 19583, 11),
(276568, NULL, 'PIRSF000641', NULL, NULL, NULL, NULL, 'SRK', NULL, NULL, 12936, 11),
(276569, NULL, 'PIRSF034659', NULL, NULL, NULL, NULL, 'Vir_TviA', NULL, NULL, 18911, 11),
(276570, NULL, 'PIRSF037827', NULL, NULL, NULL, NULL, 'Bcl-2-like_11', NULL, NULL, 16467, 11),
(276571, NULL, 'PIRSF005856', NULL, NULL, NULL, NULL, 'Rad51', NULL, NULL, 15448, 11),
(276572, NULL, 'PIRSF025560', NULL, NULL, NULL, NULL, 'UCP025560', NULL, NULL, 8878, 11),
(276573, NULL, 'PIRSF000817', NULL, NULL, NULL, NULL, 'Nucleotidyltrnsf', NULL, NULL, 3347, 11),
(276574, NULL, 'PIRSF002884', NULL, NULL, NULL, NULL, 'CheZ', NULL, NULL, 4433, 11),
(276575, NULL, 'PIRSF018539', NULL, NULL, NULL, NULL, 'CDT_B', NULL, NULL, 7395, 11),
(276576, NULL, 'PIRSF009530', NULL, NULL, NULL, NULL, 'Nvp', NULL, NULL, 12456, 11),
(276577, NULL, 'PIRSF029393', NULL, NULL, NULL, NULL, 'UCP029393', NULL, NULL, 17130, 11),
(276578, NULL, 'PIRSF004692', NULL, NULL, NULL, NULL, 'KdsD_KpsF', NULL, NULL, 5990, 11),
(276579, NULL, 'PIRSF000624', NULL, NULL, NULL, NULL, 'TyrPK_TMrec_ROR', NULL, NULL, 17081, 11),
(276580, NULL, 'PIRSF001478', NULL, NULL, NULL, NULL, 'L-ara_isomerase', NULL, NULL, 6372, 11),
(276581, NULL, 'PIRSF005852', NULL, NULL, NULL, NULL, 'UCP005852', NULL, NULL, 15039, 11),
(276582, NULL, 'PIRSF003203', NULL, NULL, NULL, NULL, 'AzlD', NULL, NULL, 8889, 11),
(276583, NULL, 'PIRSF021774', NULL, NULL, NULL, NULL, 'UCP021774', NULL, NULL, 15331, 11),
(276584, NULL, 'PIRSF011221', NULL, NULL, NULL, NULL, 'Chloropl_CC', NULL, NULL, 17883, 11),
(276585, NULL, 'PIRSF001259', NULL, NULL, NULL, NULL, 'RibA', NULL, NULL, NULL, 11),
(276586, NULL, 'PIRSF005639', NULL, NULL, NULL, NULL, 'Glut_amidoT_SNO', NULL, NULL, 5189, 11),
(276587, NULL, 'PIRSF015965', NULL, NULL, NULL, NULL, '26S_protsm_Rpn1', NULL, NULL, 19049, 11),
(276588, NULL, 'PIRSF004486', NULL, NULL, NULL, NULL, 'MraW', NULL, NULL, 6127, 11),
(276589, NULL, 'PIRSF014872', NULL, NULL, NULL, NULL, 'UCP014872', NULL, NULL, 19476, 11),
(276590, NULL, 'PIRSF015853', NULL, NULL, NULL, NULL, 'Pep_DppA', NULL, NULL, 6717, 11),
(276591, NULL, 'PIRSF002888', NULL, NULL, NULL, NULL, 'FliM', NULL, NULL, 3202, 11),
(276592, NULL, 'PIRSF026579', NULL, NULL, NULL, NULL, 'SpoVT', NULL, NULL, 9335, 11),
(276593, NULL, 'PIRSF037338', NULL, NULL, NULL, NULL, 'Spastin', NULL, NULL, 14964, 11),
(276594, NULL, 'PIRSF033111', NULL, NULL, NULL, NULL, 'UCP033111', NULL, NULL, 10318, 11),
(276595, NULL, 'PIRSF010603', NULL, NULL, NULL, NULL, 'UCP010603', NULL, NULL, 9568, 11);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(276596, NULL, 'PIRSF017888', NULL, NULL, NULL, NULL, 'CPSF-25', NULL, NULL, 20474, 11),
(276597, NULL, 'PIRSF018250', NULL, NULL, NULL, NULL, 'Saccharopine_DH_Lys', NULL, NULL, 26321, 11),
(276598, NULL, 'PIRSF500625', NULL, NULL, NULL, NULL, 'Cytochrome_CYP7A1', NULL, NULL, 25594, 11),
(276599, NULL, 'PIRSF004967', NULL, NULL, NULL, NULL, 'DPH1', NULL, NULL, 29980, 11),
(276600, NULL, 'PIRSF009193', NULL, NULL, NULL, NULL, 'UCP009193', NULL, NULL, 17948, 11),
(276601, NULL, 'PIRSF006444', NULL, NULL, NULL, NULL, 'PaaK', NULL, NULL, 8911, 11),
(276602, NULL, 'PIRSF500165', NULL, NULL, NULL, NULL, 'HMDI', NULL, NULL, 6460, 11),
(276603, NULL, 'PIRSF020632', NULL, NULL, NULL, NULL, 'YeaR', NULL, NULL, 11499, 11),
(276604, NULL, 'PIRSF018234', NULL, NULL, NULL, NULL, 'Pp1_interacting', NULL, NULL, 21182, 11),
(276605, NULL, 'PIRSF038055', NULL, NULL, NULL, NULL, 'Nas9_nas10_nas11', NULL, NULL, 17787, 11),
(276606, NULL, 'PIRSF000292', NULL, NULL, NULL, NULL, 'Ubiqnol_oxid_II', NULL, NULL, 4823, 11),
(276607, NULL, 'PIRSF500064', NULL, NULL, NULL, NULL, 'GPAT', NULL, NULL, 26305, 11),
(276608, NULL, 'PIRSF037488', NULL, NULL, NULL, NULL, 'Miro', NULL, NULL, 15190, 11),
(276609, NULL, 'PIRSF036894', NULL, NULL, NULL, NULL, 'PMI_Firm_short', NULL, NULL, 8491, 11),
(276610, NULL, 'PIRSF013503', NULL, NULL, NULL, NULL, 'OTUB', NULL, NULL, 19047, 11),
(276611, NULL, 'PIRSF038941', NULL, NULL, NULL, NULL, 'NspC', NULL, NULL, 4650, 11),
(276612, NULL, 'PIRSF028998', NULL, NULL, NULL, NULL, 'GINS_PSF2', NULL, NULL, 6700, 11),
(276613, NULL, 'PIRSF000159', NULL, NULL, NULL, NULL, 'NifJ', NULL, NULL, 12361, 11),
(276614, NULL, 'PIRSF006816', NULL, NULL, NULL, NULL, 'Cyc3_hyd_g', NULL, NULL, 7471, 11),
(276615, NULL, 'PIRSF018072', NULL, NULL, NULL, NULL, 'UCP018072', NULL, NULL, 20068, 11),
(276616, NULL, 'PIRSF002746', NULL, NULL, NULL, NULL, 'Gluconate_transporter', NULL, NULL, 6292, 11),
(276617, NULL, 'PIRSF028340', NULL, NULL, NULL, NULL, 'UCP028340', NULL, NULL, 16531, 11),
(276618, NULL, 'PIRSF036506', NULL, NULL, NULL, NULL, 'MtRNA_frt_NDPSE', NULL, NULL, 15045, 11),
(276619, NULL, 'PIRSF033490', NULL, NULL, NULL, NULL, 'MazF', NULL, NULL, 6378, 11),
(276620, NULL, 'PIRSF000126', NULL, NULL, NULL, NULL, '11-beta-HSD1', NULL, NULL, NULL, 11),
(276621, NULL, 'PIRSF029669', NULL, NULL, NULL, NULL, 'UCP029669', NULL, NULL, 17387, 11),
(276622, NULL, 'PIRSF000108', NULL, NULL, NULL, NULL, 'IDH_NADP', NULL, NULL, 5480, 11),
(276623, NULL, 'PIRSF016602', NULL, NULL, NULL, NULL, 'CurC', NULL, NULL, 20112, 11),
(276624, NULL, 'PIRSF000722', NULL, NULL, NULL, NULL, 'Acetate_prop_kin', NULL, NULL, 5234, 11),
(276625, NULL, 'PIRSF007010', NULL, NULL, NULL, NULL, 'UCP007010', NULL, NULL, 16329, 11),
(276626, NULL, 'PIRSF005682', NULL, NULL, NULL, NULL, 'Fascin', NULL, NULL, 10585, 11),
(276627, NULL, 'PIRSF500699', NULL, NULL, NULL, NULL, 'MDM4', NULL, NULL, 8779, 11),
(276628, NULL, 'PIRSF037893', NULL, NULL, NULL, NULL, 'Subtilisin_rel_Maqu_2796', NULL, NULL, 16695, 11),
(276629, NULL, 'PIRSF039032', NULL, NULL, NULL, NULL, 'HigB-2', NULL, NULL, 8466, 11),
(276630, NULL, 'PIRSF006515', NULL, NULL, NULL, NULL, 'KRR1', NULL, NULL, 12972, 11),
(276631, NULL, 'PIRSF000552', NULL, NULL, NULL, NULL, 'PKC_mu_nu_D2', NULL, NULL, 11489, 11),
(276632, NULL, 'PIRSF000619', NULL, NULL, NULL, NULL, 'TyrPK_EGF-R', NULL, NULL, 17278, 11),
(276633, NULL, 'PIRSF004159', NULL, NULL, NULL, NULL, 'VGG', NULL, NULL, 6252, 11),
(276634, NULL, 'PIRSF036459', NULL, NULL, NULL, NULL, 'DAP_dec_asp_kin', NULL, NULL, 10601, 11),
(276635, NULL, 'PIRSF011396', NULL, NULL, NULL, NULL, 'Trp_halogenase', NULL, NULL, 33449, 11),
(276636, NULL, 'PIRSF003781', NULL, NULL, NULL, NULL, 'VAC_C5L', NULL, NULL, 9879, 11),
(276637, NULL, 'PIRSF000969', NULL, NULL, NULL, NULL, '3_5-cGMP_Pdiesterase_gamma', NULL, NULL, 5996, 11),
(276638, NULL, 'PIRSF001069', NULL, NULL, NULL, NULL, 'Lytic_enz_p15', NULL, NULL, 19520, 11),
(276639, NULL, 'PIRSF005567', NULL, NULL, NULL, NULL, 'Beta''-COP', NULL, NULL, 15290, 11),
(276640, NULL, 'PIRSF037053', NULL, NULL, NULL, NULL, 'UCP037053', NULL, NULL, 20041, 11);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(276641, NULL, 'PIRSF007466', NULL, NULL, NULL, NULL, 'SpoIVA', NULL, NULL, 9371, 11),
(276642, NULL, 'PIRSF017018', NULL, NULL, NULL, NULL, 'Tp34', NULL, NULL, 21335, 11),
(276643, NULL, 'PIRSF000507', NULL, NULL, NULL, NULL, 'IPT', NULL, NULL, 2724, 11),
(276644, NULL, 'PIRSF000514', NULL, NULL, NULL, NULL, 'Pentafunct_AroM', NULL, NULL, 8626, 11),
(276645, NULL, 'PIRSF000604', NULL, NULL, NULL, NULL, 'TyrPK_SYK', NULL, NULL, 13861, 11),
(276646, NULL, 'PIRSF006787', NULL, NULL, NULL, NULL, 'Hydrgn_mat_HoxX', NULL, NULL, 9883, 11),
(276647, NULL, 'PIRSF000368', NULL, NULL, NULL, NULL, 'Anaer_RNR_III_small', NULL, NULL, 12866, 11),
(276648, NULL, 'PIRSF002690', NULL, NULL, NULL, NULL, 'Plant_L_lectin', NULL, NULL, 20024, 11),
(276649, NULL, 'PIRSF021435', NULL, NULL, NULL, NULL, 'SpoIIIAB', NULL, NULL, 8799, 11),
(276650, NULL, 'PIRSF018147', NULL, NULL, NULL, NULL, 'ORM1', NULL, NULL, 1029, 11),
(276651, NULL, 'PIRSF018153', NULL, NULL, NULL, NULL, 'Glycolip_mannosyltransf_fung', NULL, NULL, 2725, 11),
(276652, NULL, 'PIRSF036411', NULL, NULL, NULL, NULL, 'ATR_PduO', NULL, NULL, 10064, 11),
(276653, NULL, 'PIRSF037090', NULL, NULL, NULL, NULL, 'IGluLR_plant', NULL, NULL, 20273, 11),
(276654, NULL, 'PIRSF008505', NULL, NULL, NULL, NULL, 'UCP008505', NULL, NULL, 16087, 11),
(276655, NULL, 'PIRSF036640', NULL, NULL, NULL, NULL, 'FPGT', NULL, NULL, 13540, 11),
(276656, NULL, 'PIRSF001362', NULL, NULL, NULL, NULL, 'ICL', NULL, NULL, 3922, 11),
(276657, NULL, 'PIRSF001586', NULL, NULL, NULL, NULL, 'FGAM_synth_I', NULL, NULL, 2154, 11),
(276658, NULL, 'PIRSF004932', NULL, NULL, NULL, NULL, 'DNA_bp_Tfx', NULL, NULL, 20394, 11),
(276659, NULL, 'PIRSF038057', NULL, NULL, NULL, NULL, 'Hatching_uvs2', NULL, NULL, 17688, 11),
(276660, NULL, 'PIRSF003299', NULL, NULL, NULL, NULL, 'VirB8_PtlE', NULL, NULL, 26151, 11),
(276661, NULL, 'PIRSF026782', NULL, NULL, NULL, NULL, 'CbiD', NULL, NULL, 3670, 11),
(276662, NULL, 'PIRSF028696', NULL, NULL, NULL, NULL, 'UCP028696', NULL, NULL, 16954, 11),
(276663, NULL, 'PIRSF001097', NULL, NULL, NULL, NULL, 'Agarase', NULL, NULL, 19628, 11),
(276664, NULL, 'PIRSF037738', NULL, NULL, NULL, NULL, 'UCP037738', NULL, NULL, 16061, 11),
(276665, NULL, 'PIRSF015793', NULL, NULL, NULL, NULL, 'VAC_EEV', NULL, NULL, 726, 11),
(276666, NULL, 'PIRSF009431', NULL, NULL, NULL, NULL, 'UCP009431', NULL, NULL, 9729, 11),
(276667, NULL, 'PIRSF012666', NULL, NULL, NULL, NULL, 'UCP012666', NULL, NULL, 17514, 11),
(276668, NULL, 'PIRSF021383', NULL, NULL, NULL, NULL, 'YunB', NULL, NULL, 8987, 11),
(276669, NULL, 'PIRSF001444', NULL, NULL, NULL, NULL, 'Adenylate_cycl', NULL, NULL, 4922, 11),
(276670, NULL, 'PIRSF002465', NULL, NULL, NULL, NULL, 'Phsphlp_syn_PlsX', NULL, NULL, 8475, 11),
(276671, NULL, 'PIRSF010256', NULL, NULL, NULL, NULL, 'CoxE_vWa', NULL, NULL, 10530, 11),
(276672, NULL, 'PIRSF021494', NULL, NULL, NULL, NULL, 'Rv0216', NULL, NULL, 15221, 11),
(276673, NULL, 'PIRSF032474', NULL, NULL, NULL, NULL, 'Rot', NULL, NULL, 18721, 11),
(276674, NULL, 'PIRSF000163', NULL, NULL, NULL, NULL, 'ChlB', NULL, NULL, 17117, 11),
(276675, NULL, 'PIRSF006519', NULL, NULL, NULL, NULL, 'GOGAT_dom3', NULL, NULL, 12085, 11),
(276676, NULL, 'PIRSF037161', NULL, NULL, NULL, NULL, 'PRDM4', NULL, NULL, 20932, 11),
(276677, NULL, 'PIRSF037262', NULL, NULL, NULL, NULL, 'UCP037262', NULL, NULL, 9160, 11),
(276678, NULL, 'PIRSF000278', NULL, NULL, NULL, NULL, 'COX_VIb', NULL, NULL, 2128, 11),
(276679, NULL, 'PIRSF500628', NULL, NULL, NULL, NULL, 'PTGIS', NULL, NULL, 25508, 11),
(276680, NULL, 'PIRSF020687', NULL, NULL, NULL, NULL, 'UCP020687', NULL, NULL, 14342, 11),
(276681, NULL, 'PIRSF018938', NULL, NULL, NULL, NULL, 'UCP018938', NULL, NULL, 21457, 11),
(276682, NULL, 'PIRSF015601', NULL, NULL, NULL, NULL, 'MTase_slr0722', NULL, NULL, 2492, 11),
(276683, NULL, 'PIRSF018431', NULL, NULL, NULL, NULL, 'Molluscan_insulin_rel_peptide', NULL, NULL, 21328, 11),
(276684, NULL, 'PIRSF005850', NULL, NULL, NULL, NULL, 'UCP005850', NULL, NULL, 19011, 11),
(276685, NULL, 'PIRSF037618', NULL, NULL, NULL, NULL, 'RNA_Mtase_bacterial', NULL, NULL, 15895, 11);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(276686, NULL, 'PIRSF015244', NULL, NULL, NULL, NULL, 'UCP015244', NULL, NULL, 12576, 11),
(276687, NULL, 'PIRSF500102', NULL, NULL, NULL, NULL, 'ER-b', NULL, NULL, 26091, 11),
(276688, NULL, 'PIRSF036537', NULL, NULL, NULL, NULL, 'EhaI', NULL, NULL, 10223, 11),
(276689, NULL, 'PIRSF019136', NULL, NULL, NULL, NULL, 'EhaG', NULL, NULL, 10097, 11),
(276690, NULL, 'PIRSF036436', NULL, NULL, NULL, NULL, 'UCP036436_permease', NULL, NULL, 13138, 11),
(276691, NULL, 'PIRSF006909', NULL, NULL, NULL, NULL, 'UCP006909', NULL, NULL, 9528, 11),
(276692, NULL, 'PIRSF037901', NULL, NULL, NULL, NULL, 'Subtilisin_rel_Nmul_A1891', NULL, NULL, 16853, 11),
(276693, NULL, 'PIRSF017617', NULL, NULL, NULL, NULL, 'Thr_aldolase', NULL, NULL, 16276, 11),
(276694, NULL, 'PIRSF000290', NULL, NULL, NULL, NULL, 'PPO_plant', NULL, NULL, 17267, 11),
(276695, NULL, 'PIRSF018162', NULL, NULL, NULL, NULL, 'TRAMP_AIR', NULL, NULL, 20034, 11),
(276696, NULL, 'PIRSF038895', NULL, NULL, NULL, NULL, 'FPGS', NULL, NULL, 16316, 11),
(276697, NULL, 'PIRSF009376', NULL, NULL, NULL, NULL, 'PLD_euk', NULL, NULL, 17579, 11),
(276698, NULL, 'PIRSF021697', NULL, NULL, NULL, NULL, 'UCP021697', NULL, NULL, 15400, 11),
(276699, NULL, 'PIRSF027923', NULL, NULL, NULL, NULL, 'Rubrer_027923', NULL, NULL, 10068, 11),
(276700, NULL, 'PIRSF007948', NULL, NULL, NULL, NULL, 'Wun1', NULL, NULL, 16283, 11),
(276701, NULL, 'PIRSF015557', NULL, NULL, NULL, NULL, 'UCP015557', NULL, NULL, 19273, 11),
(276702, NULL, 'PIRSF015283', NULL, NULL, NULL, NULL, 'RpfE', NULL, NULL, 19089, 11),
(276703, NULL, 'PIRSF038007', NULL, NULL, NULL, NULL, 'IL-12B', NULL, NULL, 8493, 11),
(276704, NULL, 'PIRSF016564', NULL, NULL, NULL, NULL, 'NDUS6', NULL, NULL, 20236, 11),
(276705, NULL, 'PIRSF029792', NULL, NULL, NULL, NULL, 'Pro_racemase', NULL, NULL, 13600, 11),
(276706, NULL, 'PIRSF028301', NULL, NULL, NULL, NULL, 'UCP028301', NULL, NULL, 7536, 11),
(276707, NULL, 'PIRSF005461', NULL, NULL, NULL, NULL, '23S_rRNA_mtase', NULL, NULL, 8392, 11),
(276708, NULL, 'PIRSF011502', NULL, NULL, NULL, NULL, 'DdrA_PduG', NULL, NULL, 9915, 11),
(276709, NULL, 'PIRSF020680', NULL, NULL, NULL, NULL, 'PhnH', NULL, NULL, 12173, 11),
(276710, NULL, 'PIRSF019423', NULL, NULL, NULL, NULL, 'NMN_biosyn', NULL, NULL, 10747, 11),
(276711, NULL, 'PIRSF002097', NULL, NULL, NULL, NULL, 'DNA-bp_Fis', NULL, NULL, 7106, 11),
(276712, NULL, 'PIRSF012290', NULL, NULL, NULL, NULL, 'EutL_PduB', NULL, NULL, 9911, 11),
(276713, NULL, 'PIRSF004525', NULL, NULL, NULL, NULL, 'Pilin_peptidase-dep_B', NULL, NULL, 21387, 11),
(276714, NULL, 'PIRSF032038', NULL, NULL, NULL, NULL, 'UCP023238', NULL, NULL, 17984, 11),
(276715, NULL, 'PIRSF036931', NULL, NULL, NULL, NULL, 'Doc2', NULL, NULL, 8435, 11),
(276716, NULL, 'PIRSF017302', NULL, NULL, NULL, NULL, 'Gltscr2', NULL, NULL, 10804, 11),
(276717, NULL, 'PIRSF018001', NULL, NULL, NULL, NULL, 'Aspartoacylase', NULL, NULL, 20165, 11),
(276718, NULL, 'PIRSF007159', NULL, NULL, NULL, NULL, 'Protease_ASVF', NULL, NULL, 16243, 11),
(276719, NULL, 'PIRSF020870', NULL, NULL, NULL, NULL, 'Radical_SAM_bac', NULL, NULL, 15500, 11),
(276720, NULL, 'PIRSF016049', NULL, NULL, NULL, NULL, 'Mann_dehydr_UxuA', NULL, NULL, 2373, 11),
(276721, NULL, 'PIRSF008109', NULL, NULL, NULL, NULL, 'RFamide_ACEP-1', NULL, NULL, 16253, 11),
(276722, NULL, 'PIRSF006487', NULL, NULL, NULL, NULL, 'GCST', NULL, NULL, NULL, 11),
(276723, NULL, 'PIRSF000452', NULL, NULL, NULL, NULL, '6-N-acetyltransf', NULL, NULL, 12948, 11),
(276724, NULL, 'PIRSF030200', NULL, NULL, NULL, NULL, 'PaaB', NULL, NULL, 14483, 11),
(276725, NULL, 'PIRSF018868', NULL, NULL, NULL, NULL, 'UCP018868', NULL, NULL, 21100, 11),
(276726, NULL, 'PIRSF003352', NULL, NULL, NULL, NULL, 'MAK16', NULL, NULL, 5857, 11),
(276727, NULL, 'PIRSF037291', NULL, NULL, NULL, NULL, 'UCP037291_gluthr', NULL, NULL, 21168, 11),
(276728, NULL, 'PIRSF002939', NULL, NULL, NULL, NULL, 'IF_sigma_H', NULL, NULL, 20027, 11),
(276729, NULL, 'PIRSF005285', NULL, NULL, NULL, NULL, 'tRNA_splic_endonuc_archaea', NULL, NULL, 15130, 11),
(276730, NULL, 'PIRSF018455', NULL, NULL, NULL, NULL, 'MepA', NULL, NULL, 10450, 11);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(276731, NULL, 'PIRSF003817', NULL, NULL, NULL, NULL, 'Gen_Poly_FLV', NULL, NULL, 7837, 11),
(276732, NULL, 'PIRSF000854', NULL, NULL, NULL, NULL, 'PEP_synthase', NULL, NULL, 4979, 11),
(276733, NULL, 'PIRSF000429', NULL, NULL, NULL, NULL, 'Ac-CoA_Ac_transf', NULL, NULL, 217, 11),
(276734, NULL, 'PIRSF031611', NULL, NULL, NULL, NULL, 'ComGF', NULL, NULL, 17827, 11),
(276735, NULL, 'PIRSF011560', NULL, NULL, NULL, NULL, 'ComK', NULL, NULL, 10129, 11),
(276736, NULL, 'PIRSF025725', NULL, NULL, NULL, NULL, 'UCP025725', NULL, NULL, 16398, 11),
(276737, NULL, 'PIRSF000512', NULL, NULL, NULL, NULL, 'TMP_PPase_Cyanobac', NULL, NULL, 17422, 11),
(276738, NULL, 'PIRSF001625', NULL, NULL, NULL, NULL, 'Prot_inhib_pacifastin', NULL, NULL, 19847, 11),
(276739, NULL, 'PIRSF000620', NULL, NULL, NULL, NULL, 'Insulin_receptor', NULL, NULL, 17444, 11),
(276740, NULL, 'PIRSF033949', NULL, NULL, NULL, NULL, 'Phosest_Mlr3352', NULL, NULL, 13238, 11),
(276741, NULL, 'PIRSF002394', NULL, NULL, NULL, NULL, 'GNBP_B', NULL, NULL, NULL, 11),
(276742, NULL, 'PIRSF004311', NULL, NULL, NULL, NULL, 'SSB_T7', NULL, NULL, 21375, 11),
(276743, NULL, 'PIRSF037941', NULL, NULL, NULL, NULL, 'TMPRSS11ABCDE', NULL, NULL, 17188, 11),
(276744, NULL, 'PIRSF010252', NULL, NULL, NULL, NULL, 'ZapC', NULL, NULL, 13197, 11),
(276745, NULL, 'PIRSF002530', NULL, NULL, NULL, NULL, 'FTZ-F1', NULL, NULL, 20299, 11),
(276746, NULL, 'PIRSF018557', NULL, NULL, NULL, NULL, 'DAN', NULL, NULL, 21453, 11),
(276747, NULL, 'PIRSF037634', NULL, NULL, NULL, NULL, 'HS1-bp', NULL, NULL, 15920, 11),
(276748, NULL, 'PIRSF019313', NULL, NULL, NULL, NULL, 'UCP019313', NULL, NULL, 13368, 11),
(276749, NULL, 'PIRSF003033', NULL, NULL, NULL, NULL, 'Ku70', NULL, NULL, 10320, 11),
(276750, NULL, 'PIRSF019202', NULL, NULL, NULL, NULL, 'UCP019202', NULL, NULL, 5905, 11),
(276751, NULL, 'PIRSF016919', NULL, NULL, NULL, NULL, 'HupE_UreJ', NULL, NULL, 6643, 11),
(276752, NULL, 'PIRSF000880', NULL, NULL, NULL, NULL, 'Eryth_est', NULL, NULL, 19551, 11),
(276753, NULL, 'PIRSF004108', NULL, NULL, NULL, NULL, 'Coat_Tenuivirus', NULL, NULL, 7563, 11),
(276754, NULL, 'PIRSF001138', NULL, NULL, NULL, NULL, 'Enteropeptidase', NULL, NULL, 10766, 11),
(276755, NULL, 'PIRSF034585', NULL, NULL, NULL, NULL, 'SrfB', NULL, NULL, 10177, 11),
(276756, NULL, 'PIRSF037096', NULL, NULL, NULL, NULL, 'AP3_beta', NULL, NULL, 25437, 11),
(276757, NULL, 'PIRSF037999', NULL, NULL, NULL, NULL, 'TNFR_3_LTBR', NULL, NULL, 17227, 11),
(276758, NULL, 'PIRSF005622', NULL, NULL, NULL, NULL, 'Hydrgn_mat_hypD', NULL, NULL, 4570, 11),
(276759, NULL, 'PIRSF015618', NULL, NULL, NULL, NULL, 'BHLH_neuroD', NULL, NULL, 19200, 11),
(276760, NULL, 'PIRSF017494', NULL, NULL, NULL, NULL, 'Thiazolinyl_imide_reduct_YbtU', NULL, NULL, 2120, 11),
(276761, NULL, 'PIRSF000130', NULL, NULL, NULL, NULL, 'IMPDH', NULL, NULL, 1005, 11),
(276762, NULL, 'PIRSF003078', NULL, NULL, NULL, NULL, 'GidB', NULL, NULL, 1890, 11),
(276763, NULL, 'PIRSF017306', NULL, NULL, NULL, NULL, 'Ureidoglycolate_hydrolase', NULL, NULL, 6726, 11),
(276764, NULL, 'PIRSF015589', NULL, NULL, NULL, NULL, 'PPK_bact', NULL, NULL, 5349, 11),
(276765, NULL, 'PIRSF015691', NULL, NULL, NULL, NULL, 'VAC_E5R', NULL, NULL, 4929, 11),
(276766, NULL, 'PIRSF001600', NULL, NULL, NULL, NULL, 'DNA_ligase_T3', NULL, NULL, 19723, 11),
(276767, NULL, 'PIRSF015877', NULL, NULL, NULL, NULL, 'UCP015877', NULL, NULL, 11159, 11),
(276768, NULL, 'PIRSF036778', NULL, NULL, NULL, NULL, 'UCP036778', NULL, NULL, 9738, 11),
(276769, NULL, 'PIRSF006346', NULL, NULL, NULL, NULL, 'Ni_metllenz_mat', NULL, NULL, 9904, 11),
(276770, NULL, 'PIRSF002368', NULL, NULL, NULL, NULL, 'Clusterin', NULL, NULL, 14120, 11),
(276771, NULL, 'PIRSF015901', NULL, NULL, NULL, NULL, 'NAC_alpha', NULL, NULL, 19425, 11),
(276772, NULL, 'PIRSF021438', NULL, NULL, NULL, NULL, 'DltD', NULL, NULL, 12191, 11),
(276773, NULL, 'PIRSF501107', NULL, NULL, NULL, NULL, 'Protein_kin_C_eta', NULL, NULL, 26166, 11),
(276774, NULL, 'PIRSF038166', NULL, NULL, NULL, NULL, 'DMRL_synth_chloropl', NULL, NULL, 18073, 11);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(276775, NULL, 'PIRSF024865', NULL, NULL, NULL, NULL, 'UCP024865', NULL, NULL, 22399, 11),
(276776, NULL, 'PIRSF030959', NULL, NULL, NULL, NULL, 'UCP030959', NULL, NULL, 12146, 11),
(276777, NULL, 'PIRSF004557', NULL, NULL, NULL, NULL, 'SecY_Sec61alpha', NULL, NULL, 58, 11),
(276778, NULL, 'PIRSF015690', NULL, NULL, NULL, NULL, 'VAC_E8R', NULL, NULL, 2165, 11),
(276779, NULL, 'PIRSF015761', NULL, NULL, NULL, NULL, 'Protein_L', NULL, NULL, 2206, 11),
(276780, NULL, 'PIRSF500176', NULL, NULL, NULL, NULL, 'L_ASNase', NULL, NULL, NULL, 11),
(276781, NULL, 'PIRSF004874', NULL, NULL, NULL, NULL, 'Prcrn_mtase_isom', NULL, NULL, 7923, 11),
(276782, NULL, 'PIRSF034789', NULL, NULL, NULL, NULL, 'Type_III_secr_syst_SsaM', NULL, NULL, 18988, 11),
(276783, NULL, 'PIRSF030365', NULL, NULL, NULL, NULL, 'UCP030365', NULL, NULL, 17532, 11),
(276784, NULL, 'PIRSF000826', NULL, NULL, NULL, NULL, 'L_PhleboV', NULL, NULL, 12336, 11),
(276785, NULL, 'PIRSF003217', NULL, NULL, NULL, NULL, 'Cro_protein', NULL, NULL, 4026, 11),
(276786, NULL, 'PIRSF037177', NULL, NULL, NULL, NULL, 'COMT_euk', NULL, NULL, 20695, 11),
(276787, NULL, 'PIRSF021278', NULL, NULL, NULL, NULL, 'AcuA', NULL, NULL, 13200, 11),
(276788, NULL, 'PIRSF039093', NULL, NULL, NULL, NULL, 'HslV', NULL, NULL, 15133, 11),
(276789, NULL, 'PIRSF017082', NULL, NULL, NULL, NULL, 'YflP', NULL, NULL, 2263, 11),
(276790, NULL, 'PIRSF001734', NULL, NULL, NULL, NULL, 'BRCA1', NULL, NULL, 21709, 11),
(276791, NULL, 'PIRSF037062', NULL, NULL, NULL, NULL, 'INSL6', NULL, NULL, 20074, 11),
(276792, NULL, 'PIRSF038019', NULL, NULL, NULL, NULL, 'Neurexophilin', NULL, NULL, 10422, 11),
(276793, NULL, 'PIRSF003947', NULL, NULL, NULL, NULL, 'N_OrthobunV', NULL, NULL, 4373, 11),
(276794, NULL, 'PIRSF015599', NULL, NULL, NULL, NULL, 'KIT_ligand_MCF', NULL, NULL, 5303, 11),
(276795, NULL, 'PIRSF032285', NULL, NULL, NULL, NULL, 'UCP032285', NULL, NULL, 10679, 11),
(276796, NULL, 'PIRSF000136', NULL, NULL, NULL, NULL, 'LGO_GLO', NULL, NULL, 5181, 11),
(276797, NULL, 'PIRSF025024', NULL, NULL, NULL, NULL, 'Txn_adaptor_ADA2', NULL, NULL, 15357, 11),
(276798, NULL, 'PIRSF033642', NULL, NULL, NULL, NULL, 'UCP033642', NULL, NULL, 13673, 11),
(276799, NULL, 'PIRSF005890', NULL, NULL, NULL, NULL, 'Phot_II_cyt_c550', NULL, NULL, 9484, 11),
(276800, NULL, 'PIRSF038139', NULL, NULL, NULL, NULL, 'EF-2_kin', NULL, NULL, 18245, 11),
(276801, NULL, 'PIRSF001435', NULL, NULL, NULL, NULL, 'Nth', NULL, NULL, NULL, 11),
(276802, NULL, 'PIRSF005739', NULL, NULL, NULL, NULL, 'O-mtase', NULL, NULL, 15440, 11),
(276803, NULL, 'PIRSF034981', NULL, NULL, NULL, NULL, 'Mtase_firmicutes', NULL, NULL, 18723, 11),
(276804, NULL, 'PIRSF001795', NULL, NULL, NULL, NULL, 'TRH', NULL, NULL, 13939, 11),
(276805, NULL, 'PIRSF002419', NULL, NULL, NULL, NULL, 'Tetraspanin', NULL, NULL, 880, 11),
(276806, NULL, 'PIRSF004990', NULL, NULL, NULL, NULL, 'UCP004990', NULL, NULL, 19274, 11),
(276807, NULL, 'PIRSF011668', NULL, NULL, NULL, NULL, 'Ccz1p', NULL, NULL, 17423, 11),
(276808, NULL, 'PIRSF036710', NULL, NULL, NULL, NULL, 'YphA_Bacsu', NULL, NULL, 10369, 11),
(276809, NULL, 'PIRSF038074', NULL, NULL, NULL, NULL, 'Peroxin-12', NULL, NULL, 17520, 11),
(276810, NULL, 'PIRSF025550', NULL, NULL, NULL, NULL, 'UCP025550_lpd_carrier', NULL, NULL, 16349, 11),
(276811, NULL, 'PIRSF037139', NULL, NULL, NULL, NULL, 'UCP037139', NULL, NULL, 19178, 11),
(276812, NULL, 'PIRSF036292', NULL, NULL, NULL, NULL, 'Prenylcysteine_oxidase', NULL, NULL, 19672, 11),
(276813, NULL, 'PIRSF005993', NULL, NULL, NULL, NULL, 'Occludin', NULL, NULL, 5385, 11),
(276814, NULL, 'PIRSF000441', NULL, NULL, NULL, NULL, 'CysE', NULL, NULL, 6797, 11),
(276815, NULL, 'PIRSF028451', NULL, NULL, NULL, NULL, 'UCP028451', NULL, NULL, 9424, 11),
(276816, NULL, 'PIRSF001992', NULL, NULL, NULL, NULL, 'CD74_antigen', NULL, NULL, 35254, 11),
(276817, NULL, 'PIRSF002967', NULL, NULL, NULL, NULL, 'Fimbr_prot_A', NULL, NULL, 20284, 11),
(276818, NULL, 'PIRSF009328', NULL, NULL, NULL, NULL, 'RMT_SET', NULL, NULL, 10511, 11),
(276819, NULL, 'PIRSF028589', NULL, NULL, NULL, NULL, 'UCP028589', NULL, NULL, 16674, 11);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(276820, NULL, 'PIRSF002372', NULL, NULL, NULL, NULL, 'Beta-casein', NULL, NULL, 20110, 11),
(276821, NULL, 'PIRSF001267', NULL, NULL, NULL, NULL, 'Pyrophosphatase_GppA_Ppx', NULL, NULL, 21908, 11),
(276822, NULL, 'PIRSF008633', NULL, NULL, NULL, NULL, 'BEX', NULL, NULL, 2603, 11),
(276823, NULL, 'PIRSF019075', NULL, NULL, NULL, NULL, 'UCP019075', NULL, NULL, 21118, 11),
(276824, NULL, 'PIRSF500312', NULL, NULL, NULL, NULL, 'Bombyxin_A', NULL, NULL, 25591, 11),
(276825, NULL, 'PIRSF010607', NULL, NULL, NULL, NULL, 'Txn_repr_CtsR', NULL, NULL, 12065, 11),
(276826, NULL, 'PIRSF026306', NULL, NULL, NULL, NULL, 'UCP026306', NULL, NULL, 16077, 11),
(276827, NULL, 'PIRSF036483', NULL, NULL, NULL, NULL, 'PFK_XF0274', NULL, NULL, 7572, 11),
(276828, NULL, 'PIRSF037214', NULL, NULL, NULL, NULL, 'UCP037214', NULL, NULL, 20706, 11),
(276829, NULL, 'PIRSF006293', NULL, NULL, NULL, NULL, 'ExsB', NULL, NULL, 16631, 11),
(276830, NULL, 'PIRSF000340', NULL, NULL, NULL, NULL, 'MPO_fungal', NULL, NULL, 17301, 11),
(276831, NULL, 'PIRSF037527', NULL, NULL, NULL, NULL, 'GTPase_Tem1', NULL, NULL, 15386, 11),
(276832, NULL, 'PIRSF006256', NULL, NULL, NULL, NULL, 'CMP_trnsf_HypF', NULL, NULL, 7284, 11),
(276833, NULL, 'PIRSF000362', NULL, NULL, NULL, NULL, 'FNR', NULL, NULL, 15167, 11),
(276834, NULL, 'PIRSF005465', NULL, NULL, NULL, NULL, 'GIRK_kir', NULL, NULL, 15421, 11),
(276835, NULL, 'PIRSF001935', NULL, NULL, NULL, NULL, 'IL-6', NULL, NULL, 24765, 11),
(276836, NULL, 'PIRSF036995', NULL, NULL, NULL, NULL, 'RSM24', NULL, NULL, 19872, 11),
(276837, NULL, 'PIRSF006304', NULL, NULL, NULL, NULL, 'GatC', NULL, NULL, 8194, 11),
(276838, NULL, 'PIRSF009136', NULL, NULL, NULL, NULL, 'MDUP_MalA', NULL, NULL, 16242, 11),
(276839, NULL, 'PIRSF026317', NULL, NULL, NULL, NULL, 'UCP026317_WGR', NULL, NULL, 16419, 11),
(276840, NULL, 'PIRSF012886', NULL, NULL, NULL, NULL, 'UCP012886', NULL, NULL, 19285, 11),
(276841, NULL, 'PIRSF500776', NULL, NULL, NULL, NULL, 'Hyaluronidase_3', NULL, NULL, 24643, 11),
(276842, NULL, 'PIRSF005335', NULL, NULL, NULL, NULL, 'CCA_arch', NULL, NULL, 673, 11),
(276843, NULL, 'PIRSF000472', NULL, NULL, NULL, NULL, 'Alpha1_6FUT_euk', NULL, NULL, 9654, 11),
(276844, NULL, 'PIRSF001000', NULL, NULL, NULL, NULL, 'PDG_ENDV', NULL, NULL, 3625, 11),
(276845, NULL, 'PIRSF006414', NULL, NULL, NULL, NULL, 'Ftr_formyl_trnsf', NULL, NULL, 18639, 11),
(276846, NULL, 'PIRSF018008', NULL, NULL, NULL, NULL, 'UCP018008', NULL, NULL, 8935, 11),
(276847, NULL, 'PIRSF000345', NULL, NULL, NULL, NULL, 'OLE1', NULL, NULL, 9766, 11),
(276848, NULL, 'PIRSF018671', NULL, NULL, NULL, NULL, 'UCP018671', NULL, NULL, 10792, 11),
(276849, NULL, 'PIRSF037092', NULL, NULL, NULL, NULL, 'AP3_delta', NULL, NULL, 20080, 11),
(276850, NULL, 'PIRSF000746', NULL, NULL, NULL, NULL, 'RPO35', NULL, NULL, 2302, 11),
(276851, NULL, 'PIRSF000095', NULL, NULL, NULL, NULL, '17beta-HSD', NULL, NULL, 14842, 11),
(276852, NULL, 'PIRSF030050', NULL, NULL, NULL, NULL, 'UCP030050_HTH', NULL, NULL, 17998, 11),
(276853, NULL, 'PIRSF000109', NULL, NULL, NULL, NULL, '6PGD', NULL, NULL, 10016, 11),
(276854, NULL, 'PIRSF001217', NULL, NULL, NULL, NULL, 'Protease_4_SppA', NULL, NULL, 2025, 11),
(276855, NULL, 'PIRSF036492', NULL, NULL, NULL, NULL, 'ALDH', NULL, NULL, 13383, 11),
(276856, NULL, 'PIRSF003128', NULL, NULL, NULL, NULL, 'RecN', NULL, NULL, 818, 11),
(276857, NULL, 'PIRSF016468', NULL, NULL, NULL, NULL, 'RDS3p', NULL, NULL, 6256, 11),
(276858, NULL, 'PIRSF028063', NULL, NULL, NULL, NULL, 'UCP028063', NULL, NULL, 12054, 11),
(276859, NULL, 'PIRSF000197', NULL, NULL, NULL, NULL, 'Bifunct_PutA', NULL, NULL, 24782, 11),
(276860, NULL, 'PIRSF025648', NULL, NULL, NULL, NULL, 'DDH', NULL, NULL, 4277, 11),
(276861, NULL, 'PIRSF036761', NULL, NULL, NULL, NULL, 'GDH_Mll4104', NULL, NULL, 1372, 11),
(276862, NULL, 'PIRSF000166', NULL, NULL, NULL, NULL, 'Coproporphyri_ox', NULL, NULL, 2460, 11),
(276863, NULL, 'PIRSF038123', NULL, NULL, NULL, NULL, 'PTI6', NULL, NULL, 18424, 11),
(276864, NULL, 'PIRSF500210', NULL, NULL, NULL, NULL, 'FBPtase', NULL, NULL, 22294, 11);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(276865, NULL, 'PIRSF036534', NULL, NULL, NULL, NULL, 'EhaC', NULL, NULL, 10032, 11),
(276866, NULL, 'PIRSF037221', NULL, NULL, NULL, NULL, 'UCP037221', NULL, NULL, 12387, 11),
(276867, NULL, 'PIRSF022632', NULL, NULL, NULL, NULL, 'UCP022632', NULL, NULL, 15084, 11),
(276868, NULL, 'PIRSF029688', NULL, NULL, NULL, NULL, 'UCP29688_pentapep', NULL, NULL, 17048, 11),
(276869, NULL, 'PIRSF016179', NULL, NULL, NULL, NULL, 'UCP016179', NULL, NULL, 4110, 11),
(276870, NULL, 'PIRSF032673', NULL, NULL, NULL, NULL, 'UCP032673', NULL, NULL, 8010, 11),
(276871, NULL, 'PIRSF006156', NULL, NULL, NULL, NULL, 'YafQ', NULL, NULL, 5589, 11),
(276872, NULL, 'PIRSF001154', NULL, NULL, NULL, NULL, 'Compl_C2_B', NULL, NULL, 14884, 11),
(276873, NULL, 'PIRSF027110', NULL, NULL, NULL, NULL, 'PREG', NULL, NULL, 13084, 11),
(276874, NULL, 'PIRSF001778', NULL, NULL, NULL, NULL, 'Pro-EGF', NULL, NULL, 20381, 11),
(276875, NULL, 'PIRSF036238', NULL, NULL, NULL, NULL, 'UCP036238', NULL, NULL, 19851, 11),
(276876, NULL, 'PIRSF029202', NULL, NULL, NULL, NULL, 'UCP029202', NULL, NULL, 17668, 11),
(276877, NULL, 'PIRSF006246', NULL, NULL, NULL, NULL, 'ADC', NULL, NULL, 1642, 11),
(276878, NULL, 'PIRSF034039', NULL, NULL, NULL, NULL, 'UCP034039', NULL, NULL, 18799, 11),
(276879, NULL, 'PIRSF037921', NULL, NULL, NULL, NULL, 'STPK_RIP2', NULL, NULL, 17161, 11),
(276880, NULL, 'PIRSF034890', NULL, NULL, NULL, NULL, 'Pesteras_lmo2642', NULL, NULL, 12844, 11),
(276881, NULL, 'PIRSF016642', NULL, NULL, NULL, NULL, 'UCP016642', NULL, NULL, 10055, 11),
(276882, NULL, 'PIRSF000709', NULL, NULL, NULL, NULL, '6PFK_fruc_bisph_Ptase', NULL, NULL, NULL, 11),
(276883, NULL, 'PIRSF001535', NULL, NULL, NULL, NULL, 'ProRS_1', NULL, NULL, 10053, 11),
(276884, NULL, 'PIRSF019706', NULL, NULL, NULL, NULL, 'EhaB', NULL, NULL, 10393, 11),
(276885, NULL, 'PIRSF002006', NULL, NULL, NULL, NULL, 'PTPR_alpha_epsilon', NULL, NULL, 20096, 11),
(276886, NULL, 'PIRSF019345', NULL, NULL, NULL, NULL, 'SCPB', NULL, NULL, 11445, 11),
(276887, NULL, 'PIRSF034888', NULL, NULL, NULL, NULL, 'P-loop_UCP034888', NULL, NULL, 8127, 11),
(276888, NULL, 'PIRSF039137', NULL, NULL, NULL, NULL, 'ABC_branched_ATPase', NULL, NULL, 24592, 11),
(276889, NULL, 'PIRSF005278', NULL, NULL, NULL, NULL, 'UCP005278', NULL, NULL, 10529, 11),
(276890, NULL, 'PIRSF015617', NULL, NULL, NULL, NULL, 'Adenosyltransferase_CobA', NULL, NULL, 6293, 11),
(276891, NULL, 'PIRSF024484', NULL, NULL, NULL, NULL, 'UCP024484', NULL, NULL, 12795, 11),
(276892, NULL, 'PIRSF005765', NULL, NULL, NULL, NULL, 'Fib-L', NULL, NULL, 12833, 11),
(276893, NULL, 'PIRSF003440', NULL, NULL, NULL, NULL, 'UCP003440', NULL, NULL, 21047, 11),
(276894, NULL, 'PIRSF037456', NULL, NULL, NULL, NULL, 'BAMBI', NULL, NULL, 14042, 11),
(276895, NULL, 'PIRSR004682-3', NULL, NULL, NULL, NULL, 'PIRSR004682-3', NULL, NULL, NULL, 12),
(276896, NULL, 'PIRSR628707-1', NULL, NULL, NULL, NULL, 'PIRSR628707-1', NULL, NULL, NULL, 12),
(276897, NULL, 'PIRSR000005-2', NULL, NULL, NULL, NULL, 'PIRSR000005-2', NULL, NULL, NULL, 12),
(276898, NULL, 'PIRSR005713-3', NULL, NULL, NULL, NULL, 'PIRSR005713-3', NULL, NULL, NULL, 12),
(276899, NULL, 'PIRSR036918-50', NULL, NULL, NULL, NULL, 'PIRSR036918-50', NULL, NULL, NULL, 12),
(276900, NULL, 'PIRSR015582-2', NULL, NULL, NULL, NULL, 'PIRSR015582-2', NULL, NULL, NULL, 12),
(276901, NULL, 'PIRSR038193-1', NULL, NULL, NULL, NULL, 'PIRSR038193-1', NULL, NULL, NULL, 12),
(276902, NULL, 'PIRSR001154-1', NULL, NULL, NULL, NULL, 'PIRSR001154-1', NULL, NULL, NULL, 12),
(276903, NULL, 'PIRSR001488-1', NULL, NULL, NULL, NULL, 'PIRSR001488-1', NULL, NULL, NULL, 12),
(276904, NULL, 'PIRSR000149-2', NULL, NULL, NULL, NULL, 'PIRSR000149-2', NULL, NULL, NULL, 12),
(276905, NULL, 'PIRSR039026-2', NULL, NULL, NULL, NULL, 'PIRSR039026-2', NULL, NULL, NULL, 12),
(276906, NULL, 'PIRSR000460-1', NULL, NULL, NULL, NULL, 'PIRSR000460-1', NULL, NULL, NULL, 12),
(276907, NULL, 'PIRSR606118-50', NULL, NULL, NULL, NULL, 'PIRSR606118-50', NULL, NULL, NULL, 12),
(276908, NULL, 'PIRSR000099-1', NULL, NULL, NULL, NULL, 'PIRSR000099-1', NULL, NULL, NULL, 12);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(276909, NULL, 'PIRSR633508-2', NULL, NULL, NULL, NULL, 'PIRSR633508-2', NULL, NULL, NULL, 12),
(276910, NULL, 'PIRSR028973-2', NULL, NULL, NULL, NULL, 'PIRSR028973-2', NULL, NULL, NULL, 12),
(276911, NULL, 'PIRSR000238-2', NULL, NULL, NULL, NULL, 'PIRSR000238-2', NULL, NULL, NULL, 12),
(276912, NULL, 'PIRSR000631-4', NULL, NULL, NULL, NULL, 'PIRSR000631-4', NULL, NULL, NULL, 12),
(276913, NULL, 'PIRSR605468-50', NULL, NULL, NULL, NULL, 'PIRSR605468-50', NULL, NULL, NULL, 12),
(276914, NULL, 'PIRSR629511-2', NULL, NULL, NULL, NULL, 'PIRSR629511-2', NULL, NULL, NULL, 12),
(276915, NULL, 'PIRSR039050-51', NULL, NULL, NULL, NULL, 'PIRSR039050-51', NULL, NULL, NULL, 12),
(276916, NULL, 'PIRSR001430-2', NULL, NULL, NULL, NULL, 'PIRSR001430-2', NULL, NULL, NULL, 12),
(276917, NULL, 'PIRSR634603-3', NULL, NULL, NULL, NULL, 'PIRSR634603-3', NULL, NULL, NULL, 12),
(276918, NULL, 'PIRSR028937-2', NULL, NULL, NULL, NULL, 'PIRSR028937-2', NULL, NULL, NULL, 12),
(276919, NULL, 'PIRSR000262-2', NULL, NULL, NULL, NULL, 'PIRSR000262-2', NULL, NULL, NULL, 12),
(276920, NULL, 'PIRSR001461-2', NULL, NULL, NULL, NULL, 'PIRSR001461-2', NULL, NULL, NULL, 12),
(276921, NULL, 'PIRSR016527-1', NULL, NULL, NULL, NULL, 'PIRSR016527-1', NULL, NULL, NULL, 12),
(276922, NULL, 'PIRSR024851-50', NULL, NULL, NULL, NULL, 'PIRSR024851-50', NULL, NULL, NULL, 12),
(276923, NULL, 'PIRSR037242-1', NULL, NULL, NULL, NULL, 'PIRSR037242-1', NULL, NULL, NULL, 12),
(276924, NULL, 'PIRSR000988-2', NULL, NULL, NULL, NULL, 'PIRSR000988-2', NULL, NULL, NULL, 12),
(276925, NULL, 'PIRSR037599-2', NULL, NULL, NULL, NULL, 'PIRSR037599-2', NULL, NULL, NULL, 12),
(276926, NULL, 'PIRSR633528-4', NULL, NULL, NULL, NULL, 'PIRSR633528-4', NULL, NULL, NULL, 12),
(276927, NULL, 'PIRSR602506-52', NULL, NULL, NULL, NULL, 'PIRSR602506-52', NULL, NULL, NULL, 12),
(276928, NULL, 'PIRSR002520-3', NULL, NULL, NULL, NULL, 'PIRSR002520-3', NULL, NULL, NULL, 12),
(276929, NULL, 'PIRSR005384-2', NULL, NULL, NULL, NULL, 'PIRSR005384-2', NULL, NULL, NULL, 12),
(276930, NULL, 'PIRSR500135-3', NULL, NULL, NULL, NULL, 'PIRSR500135-3', NULL, NULL, NULL, 12),
(276931, NULL, 'PIRSR617653-2', NULL, NULL, NULL, NULL, 'PIRSR617653-2', NULL, NULL, NULL, 12),
(276932, NULL, 'PIRSR036497-1', NULL, NULL, NULL, NULL, 'PIRSR036497-1', NULL, NULL, NULL, 12),
(276933, NULL, 'PIRSR038061-1', NULL, NULL, NULL, NULL, 'PIRSR038061-1', NULL, NULL, NULL, 12),
(276934, NULL, 'PIRSR628651-51', NULL, NULL, NULL, NULL, 'PIRSR628651-51', NULL, NULL, NULL, 12),
(276935, NULL, 'PIRSR038895-1', NULL, NULL, NULL, NULL, 'PIRSR038895-1', NULL, NULL, NULL, 12),
(276936, NULL, 'PIRSR003047-1', NULL, NULL, NULL, NULL, 'PIRSR003047-1', NULL, NULL, NULL, 12),
(276937, NULL, 'PIRSR618044-2', NULL, NULL, NULL, NULL, 'PIRSR618044-2', NULL, NULL, NULL, 12),
(276938, NULL, 'PIRSR002490-1', NULL, NULL, NULL, NULL, 'PIRSR002490-1', NULL, NULL, NULL, 12),
(276939, NULL, 'PIRSR037891-1', NULL, NULL, NULL, NULL, 'PIRSR037891-1', NULL, NULL, NULL, 12),
(276940, NULL, 'PIRSR036687-1', NULL, NULL, NULL, NULL, 'PIRSR036687-1', NULL, NULL, NULL, 12),
(276941, NULL, 'PIRSR037249-1', NULL, NULL, NULL, NULL, 'PIRSR037249-1', NULL, NULL, NULL, 12),
(276942, NULL, 'PIRSR000102-1', NULL, NULL, NULL, NULL, 'PIRSR000102-1', NULL, NULL, NULL, 12),
(276943, NULL, 'PIRSR037568-2', NULL, NULL, NULL, NULL, 'PIRSR037568-2', NULL, NULL, NULL, 12),
(276944, NULL, 'PIRSR631098-51', NULL, NULL, NULL, NULL, 'PIRSR631098-51', NULL, NULL, NULL, 12),
(276945, NULL, 'PIRSR000808-2', NULL, NULL, NULL, NULL, 'PIRSR000808-2', NULL, NULL, NULL, 12),
(276946, NULL, 'PIRSR600936-1', NULL, NULL, NULL, NULL, 'PIRSR600936-1', NULL, NULL, NULL, 12),
(276947, NULL, 'PIRSR000905-1', NULL, NULL, NULL, NULL, 'PIRSR000905-1', NULL, NULL, NULL, 12),
(276948, NULL, 'PIRSR001065-1', NULL, NULL, NULL, NULL, 'PIRSR001065-1', NULL, NULL, NULL, 12),
(276949, NULL, 'PIRSR000235-3', NULL, NULL, NULL, NULL, 'PIRSR000235-3', NULL, NULL, NULL, 12),
(276950, NULL, 'PIRSR001341-2', NULL, NULL, NULL, NULL, 'PIRSR001341-2', NULL, NULL, NULL, 12),
(276951, NULL, 'PIRSR617512-1', NULL, NULL, NULL, NULL, 'PIRSR617512-1', NULL, NULL, NULL, 12);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(276952, NULL, 'PIRSR621573-2', NULL, NULL, NULL, NULL, 'PIRSR621573-2', NULL, NULL, NULL, 12),
(276953, NULL, 'PIRSR001837-1', NULL, NULL, NULL, NULL, 'PIRSR001837-1', NULL, NULL, NULL, 12),
(276954, NULL, 'PIRSR036900-50', NULL, NULL, NULL, NULL, 'PIRSR036900-50', NULL, NULL, NULL, 12),
(276955, NULL, 'PIRSR037242-4', NULL, NULL, NULL, NULL, 'PIRSR037242-4', NULL, NULL, NULL, 12),
(276956, NULL, 'PIRSR000185-2', NULL, NULL, NULL, NULL, 'PIRSR000185-2', NULL, NULL, NULL, 12),
(276957, NULL, 'PIRSR628391-2', NULL, NULL, NULL, NULL, 'PIRSR628391-2', NULL, NULL, NULL, 12),
(276958, NULL, 'PIRSR602717-51', NULL, NULL, NULL, NULL, 'PIRSR602717-51', NULL, NULL, NULL, 12),
(276959, NULL, 'PIRSR004869-50', NULL, NULL, NULL, NULL, 'PIRSR004869-50', NULL, NULL, NULL, 12),
(276960, NULL, 'PIRSR026389-3', NULL, NULL, NULL, NULL, 'PIRSR026389-3', NULL, NULL, NULL, 12),
(276961, NULL, 'PIRSR037913-1', NULL, NULL, NULL, NULL, 'PIRSR037913-1', NULL, NULL, NULL, 12),
(276962, NULL, 'PIRSR500951-2', NULL, NULL, NULL, NULL, 'PIRSR500951-2', NULL, NULL, NULL, 12),
(276963, NULL, 'PIRSR605428-51', NULL, NULL, NULL, NULL, 'PIRSR605428-51', NULL, NULL, NULL, 12),
(276964, NULL, 'PIRSR633560-50', NULL, NULL, NULL, NULL, 'PIRSR633560-50', NULL, NULL, NULL, 12),
(276965, NULL, 'PIRSR000929-1', NULL, NULL, NULL, NULL, 'PIRSR000929-1', NULL, NULL, NULL, 12),
(276966, NULL, 'PIRSR003059-1', NULL, NULL, NULL, NULL, 'PIRSR003059-1', NULL, NULL, NULL, 12),
(276967, NULL, 'PIRSR000666-2', NULL, NULL, NULL, NULL, 'PIRSR000666-2', NULL, NULL, NULL, 12),
(276968, NULL, 'PIRSR036665-51', NULL, NULL, NULL, NULL, 'PIRSR036665-51', NULL, NULL, NULL, 12),
(276969, NULL, 'PIRSR000118-2', NULL, NULL, NULL, NULL, 'PIRSR000118-2', NULL, NULL, NULL, 12),
(276970, NULL, 'PIRSR001399-1', NULL, NULL, NULL, NULL, 'PIRSR001399-1', NULL, NULL, NULL, 12),
(276971, NULL, 'PIRSR038945-2', NULL, NULL, NULL, NULL, 'PIRSR038945-2', NULL, NULL, NULL, 12),
(276972, NULL, 'PIRSR018153-1', NULL, NULL, NULL, NULL, 'PIRSR018153-1', NULL, NULL, NULL, 12),
(276973, NULL, 'PIRSR622314-4', NULL, NULL, NULL, NULL, 'PIRSR622314-4', NULL, NULL, NULL, 12),
(276974, NULL, 'PIRSR006268-2', NULL, NULL, NULL, NULL, 'PIRSR006268-2', NULL, NULL, NULL, 12),
(276975, NULL, 'PIRSR000290-3', NULL, NULL, NULL, NULL, 'PIRSR000290-3', NULL, NULL, NULL, 12),
(276976, NULL, 'PIRSR633040-1', NULL, NULL, NULL, NULL, 'PIRSR633040-1', NULL, NULL, NULL, 12),
(276977, NULL, 'PIRSR000169-1', NULL, NULL, NULL, NULL, 'PIRSR000169-1', NULL, NULL, NULL, 12),
(276978, NULL, 'PIRSR036370-1', NULL, NULL, NULL, NULL, 'PIRSR036370-1', NULL, NULL, NULL, 12),
(276979, NULL, 'PIRSR611612-52', NULL, NULL, NULL, NULL, 'PIRSR611612-52', NULL, NULL, NULL, 12),
(276980, NULL, 'PIRSR631084-1', NULL, NULL, NULL, NULL, 'PIRSR631084-1', NULL, NULL, NULL, 12),
(276981, NULL, 'PIRSR000724-2', NULL, NULL, NULL, NULL, 'PIRSR000724-2', NULL, NULL, NULL, 12),
(276982, NULL, 'PIRSR001558-1', NULL, NULL, NULL, NULL, 'PIRSR001558-1', NULL, NULL, NULL, 12),
(276983, NULL, 'PIRSR038065-2', NULL, NULL, NULL, NULL, 'PIRSR038065-2', NULL, NULL, NULL, 12),
(276984, NULL, 'PIRSR036489-2', NULL, NULL, NULL, NULL, 'PIRSR036489-2', NULL, NULL, NULL, 12),
(276985, NULL, 'PIRSR005639-2', NULL, NULL, NULL, NULL, 'PIRSR005639-2', NULL, NULL, NULL, 12),
(276986, NULL, 'PIRSR610300-50', NULL, NULL, NULL, NULL, 'PIRSR610300-50', NULL, NULL, NULL, 12),
(276987, NULL, 'PIRSR001500-2', NULL, NULL, NULL, NULL, 'PIRSR001500-2', NULL, NULL, NULL, 12),
(276988, NULL, 'PIRSR000159-50', NULL, NULL, NULL, NULL, 'PIRSR000159-50', NULL, NULL, NULL, 12),
(276989, NULL, 'PIRSR018001-2', NULL, NULL, NULL, NULL, 'PIRSR018001-2', NULL, NULL, NULL, 12),
(276990, NULL, 'PIRSR001149-1', NULL, NULL, NULL, NULL, 'PIRSR001149-1', NULL, NULL, NULL, 12),
(276991, NULL, 'PIRSR000498-1', NULL, NULL, NULL, NULL, 'PIRSR000498-1', NULL, NULL, NULL, 12),
(276992, NULL, 'PIRSR038165-51', NULL, NULL, NULL, NULL, 'PIRSR038165-51', NULL, NULL, NULL, 12),
(276993, NULL, 'PIRSR000168-2', NULL, NULL, NULL, NULL, 'PIRSR000168-2', NULL, NULL, NULL, 12),
(276994, NULL, 'PIRSR038073-1', NULL, NULL, NULL, NULL, 'PIRSR038073-1', NULL, NULL, NULL, 12);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(276995, NULL, 'PIRSR005784-1', NULL, NULL, NULL, NULL, 'PIRSR005784-1', NULL, NULL, NULL, 12),
(276996, NULL, 'PIRSR033579-3', NULL, NULL, NULL, NULL, 'PIRSR033579-3', NULL, NULL, NULL, 12),
(276997, NULL, 'PIRSR037215-2', NULL, NULL, NULL, NULL, 'PIRSR037215-2', NULL, NULL, NULL, 12),
(276998, NULL, 'PIRSR605437-50', NULL, NULL, NULL, NULL, 'PIRSR605437-50', NULL, NULL, NULL, 12),
(276999, NULL, 'PIRSR001426-1', NULL, NULL, NULL, NULL, 'PIRSR001426-1', NULL, NULL, NULL, 12),
(277000, NULL, 'PIRSR000409-2', NULL, NULL, NULL, NULL, 'PIRSR000409-2', NULL, NULL, NULL, 12),
(277001, NULL, 'PIRSR001948-50', NULL, NULL, NULL, NULL, 'PIRSR001948-50', NULL, NULL, NULL, 12),
(277002, NULL, 'PIRSR001492-2', NULL, NULL, NULL, NULL, 'PIRSR001492-2', NULL, NULL, NULL, 12),
(277003, NULL, 'PIRSR036958-2', NULL, NULL, NULL, NULL, 'PIRSR036958-2', NULL, NULL, NULL, 12),
(277004, NULL, 'PIRSR622314-1', NULL, NULL, NULL, NULL, 'PIRSR622314-1', NULL, NULL, NULL, 12),
(277005, NULL, 'PIRSR006661-1', NULL, NULL, NULL, NULL, 'PIRSR006661-1', NULL, NULL, NULL, 12),
(277006, NULL, 'PIRSR001238-1', NULL, NULL, NULL, NULL, 'PIRSR001238-1', NULL, NULL, NULL, 12),
(277007, NULL, 'PIRSR617774-1', NULL, NULL, NULL, NULL, 'PIRSR617774-1', NULL, NULL, NULL, 12),
(277008, NULL, 'PIRSR000551-51', NULL, NULL, NULL, NULL, 'PIRSR000551-51', NULL, NULL, NULL, 12),
(277009, NULL, 'PIRSR006156-1', NULL, NULL, NULL, NULL, 'PIRSR006156-1', NULL, NULL, NULL, 12),
(277010, NULL, 'PIRSR004789-50', NULL, NULL, NULL, NULL, 'PIRSR004789-50', NULL, NULL, NULL, 12),
(277011, NULL, 'PIRSR006019-1', NULL, NULL, NULL, NULL, 'PIRSR006019-1', NULL, NULL, NULL, 12),
(277012, NULL, 'PIRSR036639-1', NULL, NULL, NULL, NULL, 'PIRSR036639-1', NULL, NULL, NULL, 12),
(277013, NULL, 'PIRSR037634-1', NULL, NULL, NULL, NULL, 'PIRSR037634-1', NULL, NULL, NULL, 12),
(277014, NULL, 'PIRSR001522-1', NULL, NULL, NULL, NULL, 'PIRSR001522-1', NULL, NULL, NULL, 12),
(277015, NULL, 'PIRSR621573-5', NULL, NULL, NULL, NULL, 'PIRSR621573-5', NULL, NULL, NULL, 12),
(277016, NULL, 'PIRSR000605-51', NULL, NULL, NULL, NULL, 'PIRSR000605-51', NULL, NULL, NULL, 12),
(277017, NULL, 'PIRSR002006-2', NULL, NULL, NULL, NULL, 'PIRSR002006-2', NULL, NULL, NULL, 12),
(277018, NULL, 'PIRSR037217-2', NULL, NULL, NULL, NULL, 'PIRSR037217-2', NULL, NULL, NULL, 12),
(277019, NULL, 'PIRSR037932-1', NULL, NULL, NULL, NULL, 'PIRSR037932-1', NULL, NULL, NULL, 12),
(277020, NULL, 'PIRSR635711-50', NULL, NULL, NULL, NULL, 'PIRSR635711-50', NULL, NULL, NULL, 12),
(277021, NULL, 'PIRSR009103-2', NULL, NULL, NULL, NULL, 'PIRSR009103-2', NULL, NULL, NULL, 12),
(277022, NULL, 'PIRSR000190-2', NULL, NULL, NULL, NULL, 'PIRSR000190-2', NULL, NULL, NULL, 12),
(277023, NULL, 'PIRSR000068-1', NULL, NULL, NULL, NULL, 'PIRSR000068-1', NULL, NULL, NULL, 12),
(277024, NULL, 'PIRSR036894-1', NULL, NULL, NULL, NULL, 'PIRSR036894-1', NULL, NULL, NULL, 12),
(277025, NULL, 'PIRSR622230-4', NULL, NULL, NULL, NULL, 'PIRSR622230-4', NULL, NULL, NULL, 12),
(277026, NULL, 'PIRSR000075-1', NULL, NULL, NULL, NULL, 'PIRSR000075-1', NULL, NULL, NULL, 12),
(277027, NULL, 'PIRSR005700-1', NULL, NULL, NULL, NULL, 'PIRSR005700-1', NULL, NULL, NULL, 12),
(277028, NULL, 'PIRSR633528-1', NULL, NULL, NULL, NULL, 'PIRSR633528-1', NULL, NULL, NULL, 12),
(277029, NULL, 'PIRSR017269-1', NULL, NULL, NULL, NULL, 'PIRSR017269-1', NULL, NULL, NULL, 12),
(277030, NULL, 'PIRSR000296-1', NULL, NULL, NULL, NULL, 'PIRSR000296-1', NULL, NULL, NULL, 12),
(277031, NULL, 'PIRSR001084-1', NULL, NULL, NULL, NULL, 'PIRSR001084-1', NULL, NULL, NULL, 12),
(277032, NULL, 'PIRSR500134-1', NULL, NULL, NULL, NULL, 'PIRSR500134-1', NULL, NULL, NULL, 12),
(277033, NULL, 'PIRSR006404-1', NULL, NULL, NULL, NULL, 'PIRSR006404-1', NULL, NULL, NULL, 12),
(277034, NULL, 'PIRSR631038-2', NULL, NULL, NULL, NULL, 'PIRSR631038-2', NULL, NULL, NULL, 12),
(277035, NULL, 'PIRSR030150-1', NULL, NULL, NULL, NULL, 'PIRSR030150-1', NULL, NULL, NULL, 12),
(277036, NULL, 'PIRSR000550-3', NULL, NULL, NULL, NULL, 'PIRSR000550-3', NULL, NULL, NULL, 12),
(277037, NULL, 'PIRSR000933-51', NULL, NULL, NULL, NULL, 'PIRSR000933-51', NULL, NULL, NULL, 12);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(277038, NULL, 'PIRSR039004-3', NULL, NULL, NULL, NULL, 'PIRSR039004-3', NULL, NULL, NULL, 12),
(277039, NULL, 'PIRSR000429-1', NULL, NULL, NULL, NULL, 'PIRSR000429-1', NULL, NULL, NULL, 12),
(277040, NULL, 'PIRSR630294-1', NULL, NULL, NULL, NULL, 'PIRSR630294-1', NULL, NULL, NULL, 12),
(277041, NULL, 'PIRSR028980-2', NULL, NULL, NULL, NULL, 'PIRSR028980-2', NULL, NULL, NULL, 12),
(277042, NULL, 'PIRSR625650-2', NULL, NULL, NULL, NULL, 'PIRSR625650-2', NULL, NULL, NULL, 12),
(277043, NULL, 'PIRSR038455-1', NULL, NULL, NULL, NULL, 'PIRSR038455-1', NULL, NULL, NULL, 12),
(277044, NULL, 'PIRSR038085-1', NULL, NULL, NULL, NULL, 'PIRSR038085-1', NULL, NULL, NULL, 12),
(277045, NULL, 'PIRSR000948-1', NULL, NULL, NULL, NULL, 'PIRSR000948-1', NULL, NULL, NULL, 12),
(277046, NULL, 'PIRSR001072-1', NULL, NULL, NULL, NULL, 'PIRSR001072-1', NULL, NULL, NULL, 12),
(277047, NULL, 'PIRSR002026-1', NULL, NULL, NULL, NULL, 'PIRSR002026-1', NULL, NULL, NULL, 12),
(277048, NULL, 'PIRSR002512-1', NULL, NULL, NULL, NULL, 'PIRSR002512-1', NULL, NULL, NULL, 12),
(277049, NULL, 'PIRSR001031-2', NULL, NULL, NULL, NULL, 'PIRSR001031-2', NULL, NULL, NULL, 12),
(277050, NULL, 'PIRSR005604-1', NULL, NULL, NULL, NULL, 'PIRSR005604-1', NULL, NULL, NULL, 12),
(277051, NULL, 'PIRSR038941-1', NULL, NULL, NULL, NULL, 'PIRSR038941-1', NULL, NULL, NULL, 12),
(277052, NULL, 'PIRSR000008-1', NULL, NULL, NULL, NULL, 'PIRSR000008-1', NULL, NULL, NULL, 12),
(277053, NULL, 'PIRSR633144-3', NULL, NULL, NULL, NULL, 'PIRSR633144-3', NULL, NULL, NULL, 12),
(277054, NULL, 'PIRSR001205-1', NULL, NULL, NULL, NULL, 'PIRSR001205-1', NULL, NULL, NULL, 12),
(277055, NULL, 'PIRSR000109-1', NULL, NULL, NULL, NULL, 'PIRSR000109-1', NULL, NULL, NULL, 12),
(277056, NULL, 'PIRSR604061-50', NULL, NULL, NULL, NULL, 'PIRSR604061-50', NULL, NULL, NULL, 12),
(277057, NULL, 'PIRSR000894-2', NULL, NULL, NULL, NULL, 'PIRSR000894-2', NULL, NULL, NULL, 12),
(277058, NULL, 'PIRSR001341-5', NULL, NULL, NULL, NULL, 'PIRSR001341-5', NULL, NULL, NULL, 12),
(277059, NULL, 'PIRSR629576-1', NULL, NULL, NULL, NULL, 'PIRSR629576-1', NULL, NULL, NULL, 12),
(277060, NULL, 'PIRSR037404-3', NULL, NULL, NULL, NULL, 'PIRSR037404-3', NULL, NULL, NULL, 12),
(277061, NULL, 'PIRSR000188-1', NULL, NULL, NULL, NULL, 'PIRSR000188-1', NULL, NULL, NULL, 12),
(277062, NULL, 'PIRSR031051-1', NULL, NULL, NULL, NULL, 'PIRSR031051-1', NULL, NULL, NULL, 12),
(277063, NULL, 'PIRSR029792-2', NULL, NULL, NULL, NULL, 'PIRSR029792-2', NULL, NULL, NULL, 12),
(277064, NULL, 'PIRSR036684-2', NULL, NULL, NULL, NULL, 'PIRSR036684-2', NULL, NULL, NULL, 12),
(277065, NULL, 'PIRSR000385-1', NULL, NULL, NULL, NULL, 'PIRSR000385-1', NULL, NULL, NULL, 12),
(277066, NULL, 'PIRSR005993-1', NULL, NULL, NULL, NULL, 'PIRSR005993-1', NULL, NULL, NULL, 12),
(277067, NULL, 'PIRSR000926-2', NULL, NULL, NULL, NULL, 'PIRSR000926-2', NULL, NULL, NULL, 12),
(277068, NULL, 'PIRSR037010-50', NULL, NULL, NULL, NULL, 'PIRSR037010-50', NULL, NULL, NULL, 12),
(277069, NULL, 'PIRSR605856-50', NULL, NULL, NULL, NULL, 'PIRSR605856-50', NULL, NULL, NULL, 12),
(277070, NULL, 'PIRSR038084-2', NULL, NULL, NULL, NULL, 'PIRSR038084-2', NULL, NULL, NULL, 12),
(277071, NULL, 'PIRSR001594-1', NULL, NULL, NULL, NULL, 'PIRSR001594-1', NULL, NULL, NULL, 12),
(277072, NULL, 'PIRSR604809-50', NULL, NULL, NULL, NULL, 'PIRSR604809-50', NULL, NULL, NULL, 12),
(277073, NULL, 'PIRSR600823-4', NULL, NULL, NULL, NULL, 'PIRSR600823-4', NULL, NULL, NULL, 12),
(277074, NULL, 'PIRSR000705-2', NULL, NULL, NULL, NULL, 'PIRSR000705-2', NULL, NULL, NULL, 12),
(277075, NULL, 'PIRSR001373-1', NULL, NULL, NULL, NULL, 'PIRSR001373-1', NULL, NULL, NULL, 12),
(277076, NULL, 'PIRSR036636-50', NULL, NULL, NULL, NULL, 'PIRSR036636-50', NULL, NULL, NULL, 12),
(277077, NULL, 'PIRSR036959-1', NULL, NULL, NULL, NULL, 'PIRSR036959-1', NULL, NULL, NULL, 12),
(277078, NULL, 'PIRSR000130-2', NULL, NULL, NULL, NULL, 'PIRSR000130-2', NULL, NULL, NULL, 12),
(277079, NULL, 'PIRSR037393-1', NULL, NULL, NULL, NULL, 'PIRSR037393-1', NULL, NULL, NULL, 12),
(277080, NULL, 'PIRSR016262-2', NULL, NULL, NULL, NULL, 'PIRSR016262-2', NULL, NULL, NULL, 12);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(277081, NULL, 'PIRSR018136-1', NULL, NULL, NULL, NULL, 'PIRSR018136-1', NULL, NULL, NULL, 12),
(277082, NULL, 'PIRSR000232-1', NULL, NULL, NULL, NULL, 'PIRSR000232-1', NULL, NULL, NULL, 12),
(277083, NULL, 'PIRSR620777-50', NULL, NULL, NULL, NULL, 'PIRSR620777-50', NULL, NULL, NULL, 12),
(277084, NULL, 'PIRSR001024-5', NULL, NULL, NULL, NULL, 'PIRSR001024-5', NULL, NULL, NULL, 12),
(277085, NULL, 'PIRSR036893-51', NULL, NULL, NULL, NULL, 'PIRSR036893-51', NULL, NULL, NULL, 12),
(277086, NULL, 'PIRSR006615-1', NULL, NULL, NULL, NULL, 'PIRSR006615-1', NULL, NULL, NULL, 12),
(277087, NULL, 'PIRSR017388-2', NULL, NULL, NULL, NULL, 'PIRSR017388-2', NULL, NULL, NULL, 12),
(277088, NULL, 'PIRSR038159-50', NULL, NULL, NULL, NULL, 'PIRSR038159-50', NULL, NULL, NULL, 12),
(277089, NULL, 'PIRSR000094-1', NULL, NULL, NULL, NULL, 'PIRSR000094-1', NULL, NULL, NULL, 12),
(277090, NULL, 'PIRSR000606-51', NULL, NULL, NULL, NULL, 'PIRSR000606-51', NULL, NULL, NULL, 12),
(277091, NULL, 'PIRSR620023-2', NULL, NULL, NULL, NULL, 'PIRSR620023-2', NULL, NULL, NULL, 12),
(277092, NULL, 'PIRSR036685-1', NULL, NULL, NULL, NULL, 'PIRSR036685-1', NULL, NULL, NULL, 12),
(277093, NULL, 'PIRSR031924-51', NULL, NULL, NULL, NULL, 'PIRSR031924-51', NULL, NULL, NULL, 12),
(277094, NULL, 'PIRSR036874-51', NULL, NULL, NULL, NULL, 'PIRSR036874-51', NULL, NULL, NULL, 12),
(277095, NULL, 'PIRSR015894-3', NULL, NULL, NULL, NULL, 'PIRSR015894-3', NULL, NULL, NULL, 12),
(277096, NULL, 'PIRSR039133-4', NULL, NULL, NULL, NULL, 'PIRSR039133-4', NULL, NULL, NULL, 12),
(277097, NULL, 'PIRSR601621-4', NULL, NULL, NULL, NULL, 'PIRSR601621-4', NULL, NULL, NULL, 12),
(277098, NULL, 'PIRSR000349-1', NULL, NULL, NULL, NULL, 'PIRSR000349-1', NULL, NULL, NULL, 12),
(277099, NULL, 'PIRSR001028-2', NULL, NULL, NULL, NULL, 'PIRSR001028-2', NULL, NULL, NULL, 12),
(277100, NULL, 'PIRSR002937-1', NULL, NULL, NULL, NULL, 'PIRSR002937-1', NULL, NULL, NULL, 12),
(277101, NULL, 'PIRSR600917-51', NULL, NULL, NULL, NULL, 'PIRSR600917-51', NULL, NULL, NULL, 12),
(277102, NULL, 'PIRSR000127-3', NULL, NULL, NULL, NULL, 'PIRSR000127-3', NULL, NULL, NULL, 12),
(277103, NULL, 'PIRSR626945-2', NULL, NULL, NULL, NULL, 'PIRSR626945-2', NULL, NULL, NULL, 12),
(277104, NULL, 'PIRSR000260-2', NULL, NULL, NULL, NULL, 'PIRSR000260-2', NULL, NULL, NULL, 12),
(277105, NULL, 'PIRSR006809-2', NULL, NULL, NULL, NULL, 'PIRSR006809-2', NULL, NULL, NULL, 12),
(277106, NULL, 'PIRSR006278-1', NULL, NULL, NULL, NULL, 'PIRSR006278-1', NULL, NULL, NULL, 12),
(277107, NULL, 'PIRSR017434-2', NULL, NULL, NULL, NULL, 'PIRSR017434-2', NULL, NULL, NULL, 12),
(277108, NULL, 'PIRSR036917-3', NULL, NULL, NULL, NULL, 'PIRSR036917-3', NULL, NULL, NULL, 12),
(277109, NULL, 'PIRSR622230-1', NULL, NULL, NULL, NULL, 'PIRSR622230-1', NULL, NULL, NULL, 12),
(277110, NULL, 'PIRSR629609-3', NULL, NULL, NULL, NULL, 'PIRSR629609-3', NULL, NULL, NULL, 12),
(277111, NULL, 'PIRSR000006-1', NULL, NULL, NULL, NULL, 'PIRSR000006-1', NULL, NULL, NULL, 12),
(277112, NULL, 'PIRSR017107-3', NULL, NULL, NULL, NULL, 'PIRSR017107-3', NULL, NULL, NULL, 12),
(277113, NULL, 'PIRSR629601-1', NULL, NULL, NULL, NULL, 'PIRSR629601-1', NULL, NULL, NULL, 12),
(277114, NULL, 'PIRSR021331-1', NULL, NULL, NULL, NULL, 'PIRSR021331-1', NULL, NULL, NULL, 12),
(277115, NULL, 'PIRSR001217-1', NULL, NULL, NULL, NULL, 'PIRSR001217-1', NULL, NULL, NULL, 12),
(277116, NULL, 'PIRSR629576-4', NULL, NULL, NULL, NULL, 'PIRSR629576-4', NULL, NULL, NULL, 12),
(277117, NULL, 'PIRSR026534-2', NULL, NULL, NULL, NULL, 'PIRSR026534-2', NULL, NULL, NULL, 12),
(277118, NULL, 'PIRSR632916-1', NULL, NULL, NULL, NULL, 'PIRSR632916-1', NULL, NULL, NULL, 12),
(277119, NULL, 'PIRSR602129-50', NULL, NULL, NULL, NULL, 'PIRSR602129-50', NULL, NULL, NULL, 12),
(277120, NULL, 'PIRSR000485-3', NULL, NULL, NULL, NULL, 'PIRSR000485-3', NULL, NULL, NULL, 12),
(277121, NULL, 'PIRSR500133-3', NULL, NULL, NULL, NULL, 'PIRSR500133-3', NULL, NULL, NULL, 12),
(277122, NULL, 'PIRSR003085-1', NULL, NULL, NULL, NULL, 'PIRSR003085-1', NULL, NULL, NULL, 12),
(277123, NULL, 'PIRSR038147-2', NULL, NULL, NULL, NULL, 'PIRSR038147-2', NULL, NULL, NULL, 12);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(277124, NULL, 'PIRSR000192-5', NULL, NULL, NULL, NULL, 'PIRSR000192-5', NULL, NULL, NULL, 12),
(277125, NULL, 'PIRSR634183-1', NULL, NULL, NULL, NULL, 'PIRSR634183-1', NULL, NULL, NULL, 12),
(277126, NULL, 'PIRSR036289-51', NULL, NULL, NULL, NULL, 'PIRSR036289-51', NULL, NULL, NULL, 12),
(277127, NULL, 'PIRSR001959-2', NULL, NULL, NULL, NULL, 'PIRSR001959-2', NULL, NULL, NULL, 12),
(277128, NULL, 'PIRSR000604-2', NULL, NULL, NULL, NULL, 'PIRSR000604-2', NULL, NULL, NULL, 12),
(277129, NULL, 'PIRSR003888-1', NULL, NULL, NULL, NULL, 'PIRSR003888-1', NULL, NULL, NULL, 12),
(277130, NULL, 'PIRSR000239-1', NULL, NULL, NULL, NULL, 'PIRSR000239-1', NULL, NULL, NULL, 12),
(277131, NULL, 'PIRSR003033-1', NULL, NULL, NULL, NULL, 'PIRSR003033-1', NULL, NULL, NULL, 12),
(277132, NULL, 'PIRSR000934-1', NULL, NULL, NULL, NULL, 'PIRSR000934-1', NULL, NULL, NULL, 12),
(277133, NULL, 'PIRSR037250-51', NULL, NULL, NULL, NULL, 'PIRSR037250-51', NULL, NULL, NULL, 12),
(277134, NULL, 'PIRSR037023-1', NULL, NULL, NULL, NULL, 'PIRSR037023-1', NULL, NULL, NULL, 12),
(277135, NULL, 'PIRSR017570-1', NULL, NULL, NULL, NULL, 'PIRSR017570-1', NULL, NULL, NULL, 12),
(277136, NULL, 'PIRSR002884-1', NULL, NULL, NULL, NULL, 'PIRSR002884-1', NULL, NULL, NULL, 12),
(277137, NULL, 'PIRSR629609-6', NULL, NULL, NULL, NULL, 'PIRSR629609-6', NULL, NULL, NULL, 12),
(277138, NULL, 'PIRSR000628-1', NULL, NULL, NULL, NULL, 'PIRSR000628-1', NULL, NULL, NULL, 12),
(277139, NULL, 'PIRSR039102-3', NULL, NULL, NULL, NULL, 'PIRSR039102-3', NULL, NULL, NULL, 12),
(277140, NULL, 'PIRSR005539-1', NULL, NULL, NULL, NULL, 'PIRSR005539-1', NULL, NULL, NULL, 12),
(277141, NULL, 'PIRSR038186-1', NULL, NULL, NULL, NULL, 'PIRSR038186-1', NULL, NULL, NULL, 12),
(277142, NULL, 'PIRSR006698-2', NULL, NULL, NULL, NULL, 'PIRSR006698-2', NULL, NULL, NULL, 12),
(277143, NULL, 'PIRSR037177-1', NULL, NULL, NULL, NULL, 'PIRSR037177-1', NULL, NULL, NULL, 12),
(277144, NULL, 'PIRSR603739-50', NULL, NULL, NULL, NULL, 'PIRSR603739-50', NULL, NULL, NULL, 12),
(277145, NULL, 'PIRSR000898-3', NULL, NULL, NULL, NULL, 'PIRSR000898-3', NULL, NULL, NULL, 12),
(277146, NULL, 'PIRSR001959-1', NULL, NULL, NULL, NULL, 'PIRSR001959-1', NULL, NULL, NULL, 12),
(277147, NULL, 'PIRSR005536-1', NULL, NULL, NULL, NULL, 'PIRSR005536-1', NULL, NULL, NULL, 12),
(277148, NULL, 'PIRSR634598-2', NULL, NULL, NULL, NULL, 'PIRSR634598-2', NULL, NULL, NULL, 12),
(277149, NULL, 'PIRSR000027-1', NULL, NULL, NULL, NULL, 'PIRSR000027-1', NULL, NULL, NULL, 12),
(277150, NULL, 'PIRSR036565-1', NULL, NULL, NULL, NULL, 'PIRSR036565-1', NULL, NULL, NULL, 12),
(277151, NULL, 'PIRSR039133-1', NULL, NULL, NULL, NULL, 'PIRSR039133-1', NULL, NULL, NULL, 12),
(277152, NULL, 'PIRSR000183-1', NULL, NULL, NULL, NULL, 'PIRSR000183-1', NULL, NULL, NULL, 12),
(277153, NULL, 'PIRSR037907-2', NULL, NULL, NULL, NULL, 'PIRSR037907-2', NULL, NULL, NULL, 12),
(277154, NULL, 'PIRSR640198-1', NULL, NULL, NULL, NULL, 'PIRSR640198-1', NULL, NULL, NULL, 12),
(277155, NULL, 'PIRSR001357-50', NULL, NULL, NULL, NULL, 'PIRSR001357-50', NULL, NULL, NULL, 12),
(277156, NULL, 'PIRSR018427-1', NULL, NULL, NULL, NULL, 'PIRSR018427-1', NULL, NULL, NULL, 12),
(277157, NULL, 'PIRSR021497-1', NULL, NULL, NULL, NULL, 'PIRSR021497-1', NULL, NULL, NULL, 12),
(277158, NULL, 'PIRSR600877-50', NULL, NULL, NULL, NULL, 'PIRSR600877-50', NULL, NULL, NULL, 12),
(277159, NULL, 'PIRSR002855-2', NULL, NULL, NULL, NULL, 'PIRSR002855-2', NULL, NULL, NULL, 12),
(277160, NULL, 'PIRSR000554-1', NULL, NULL, NULL, NULL, 'PIRSR000554-1', NULL, NULL, NULL, 12),
(277161, NULL, 'PIRSR016238-1', NULL, NULL, NULL, NULL, 'PIRSR016238-1', NULL, NULL, NULL, 12),
(277162, NULL, 'PIRSR007828-2', NULL, NULL, NULL, NULL, 'PIRSR007828-2', NULL, NULL, NULL, 12),
(277163, NULL, 'PIRSR004131-1', NULL, NULL, NULL, NULL, 'PIRSR004131-1', NULL, NULL, NULL, 12),
(277164, NULL, 'PIRSR000853-3', NULL, NULL, NULL, NULL, 'PIRSR000853-3', NULL, NULL, NULL, 12),
(277165, NULL, 'PIRSR002572-1', NULL, NULL, NULL, NULL, 'PIRSR002572-1', NULL, NULL, NULL, 12),
(277166, NULL, 'PIRSR633197-2', NULL, NULL, NULL, NULL, 'PIRSR633197-2', NULL, NULL, NULL, 12);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(277167, NULL, 'PIRSR001141-2', NULL, NULL, NULL, NULL, 'PIRSR001141-2', NULL, NULL, NULL, 12),
(277168, NULL, 'PIRSR006336-1', NULL, NULL, NULL, NULL, 'PIRSR006336-1', NULL, NULL, NULL, 12),
(277169, NULL, 'PIRSR029928-50', NULL, NULL, NULL, NULL, 'PIRSR029928-50', NULL, NULL, NULL, 12),
(277170, NULL, 'PIRSR016573-3', NULL, NULL, NULL, NULL, 'PIRSR016573-3', NULL, NULL, NULL, 12),
(277171, NULL, 'PIRSR000606-50', NULL, NULL, NULL, NULL, 'PIRSR000606-50', NULL, NULL, NULL, 12),
(277172, NULL, 'PIRSR000381-1', NULL, NULL, NULL, NULL, 'PIRSR000381-1', NULL, NULL, NULL, 12),
(277173, NULL, 'PIRSR000183-4', NULL, NULL, NULL, NULL, 'PIRSR000183-4', NULL, NULL, NULL, 12),
(277174, NULL, 'PIRSR000806-1', NULL, NULL, NULL, NULL, 'PIRSR000806-1', NULL, NULL, NULL, 12),
(277175, NULL, 'PIRSR000732-1', NULL, NULL, NULL, NULL, 'PIRSR000732-1', NULL, NULL, NULL, 12),
(277176, NULL, 'PIRSR002421-1', NULL, NULL, NULL, NULL, 'PIRSR002421-1', NULL, NULL, NULL, 12),
(277177, NULL, 'PIRSR025737-2', NULL, NULL, NULL, NULL, 'PIRSR025737-2', NULL, NULL, NULL, 12),
(277178, NULL, 'PIRSR000178-1', NULL, NULL, NULL, NULL, 'PIRSR000178-1', NULL, NULL, NULL, 12),
(277179, NULL, 'PIRSR011588-50', NULL, NULL, NULL, NULL, 'PIRSR011588-50', NULL, NULL, NULL, 12),
(277180, NULL, 'PIRSR001024-2', NULL, NULL, NULL, NULL, 'PIRSR001024-2', NULL, NULL, NULL, 12),
(277181, NULL, 'PIRSR006246-2', NULL, NULL, NULL, NULL, 'PIRSR006246-2', NULL, NULL, NULL, 12),
(277182, NULL, 'PIRSR600239-51', NULL, NULL, NULL, NULL, 'PIRSR600239-51', NULL, NULL, NULL, 12),
(277183, NULL, 'PIRSR608356-50', NULL, NULL, NULL, NULL, 'PIRSR608356-50', NULL, NULL, NULL, 12),
(277184, NULL, 'PIRSR001789-1', NULL, NULL, NULL, NULL, 'PIRSR001789-1', NULL, NULL, NULL, 12),
(277185, NULL, 'PIRSR600246-1', NULL, NULL, NULL, NULL, 'PIRSR600246-1', NULL, NULL, NULL, 12),
(277186, NULL, 'PIRSR600823-1', NULL, NULL, NULL, NULL, 'PIRSR600823-1', NULL, NULL, NULL, 12),
(277187, NULL, 'PIRSR000192-2', NULL, NULL, NULL, NULL, 'PIRSR000192-2', NULL, NULL, NULL, 12),
(277188, NULL, 'PIRSR627620-3', NULL, NULL, NULL, NULL, 'PIRSR627620-3', NULL, NULL, NULL, 12),
(277189, NULL, 'PIRSR640198-4', NULL, NULL, NULL, NULL, 'PIRSR640198-4', NULL, NULL, NULL, 12),
(277190, NULL, 'PIRSR000112-1', NULL, NULL, NULL, NULL, 'PIRSR000112-1', NULL, NULL, NULL, 12),
(277191, NULL, 'PIRSR001359-3', NULL, NULL, NULL, NULL, 'PIRSR001359-3', NULL, NULL, NULL, 12),
(277192, NULL, 'PIRSR000454-2', NULL, NULL, NULL, NULL, 'PIRSR000454-2', NULL, NULL, NULL, 12),
(277193, NULL, 'PIRSR001553-1', NULL, NULL, NULL, NULL, 'PIRSR001553-1', NULL, NULL, NULL, 12),
(277194, NULL, 'PIRSR000094-4', NULL, NULL, NULL, NULL, 'PIRSR000094-4', NULL, NULL, NULL, 12),
(277195, NULL, 'PIRSR036750-1', NULL, NULL, NULL, NULL, 'PIRSR036750-1', NULL, NULL, NULL, 12),
(277196, NULL, 'PIRSR000632-2', NULL, NULL, NULL, NULL, 'PIRSR000632-2', NULL, NULL, NULL, 12),
(277197, NULL, 'PIRSR500950-52', NULL, NULL, NULL, NULL, 'PIRSR500950-52', NULL, NULL, NULL, 12),
(277198, NULL, 'PIRSR629727-2', NULL, NULL, NULL, NULL, 'PIRSR629727-2', NULL, NULL, NULL, 12),
(277199, NULL, 'PIRSR037318-50', NULL, NULL, NULL, NULL, 'PIRSR037318-50', NULL, NULL, NULL, 12),
(277200, NULL, 'PIRSR606285-1', NULL, NULL, NULL, NULL, 'PIRSR606285-1', NULL, NULL, NULL, 12),
(277201, NULL, 'PIRSR617736-1', NULL, NULL, NULL, NULL, 'PIRSR617736-1', NULL, NULL, NULL, 12),
(277202, NULL, 'PIRSR001111-50', NULL, NULL, NULL, NULL, 'PIRSR001111-50', NULL, NULL, NULL, 12),
(277203, NULL, 'PIRSR006816-2', NULL, NULL, NULL, NULL, 'PIRSR006816-2', NULL, NULL, NULL, 12),
(277204, NULL, 'PIRSR018249-1', NULL, NULL, NULL, NULL, 'PIRSR018249-1', NULL, NULL, NULL, 12),
(277205, NULL, 'PIRSR015477-1', NULL, NULL, NULL, NULL, 'PIRSR015477-1', NULL, NULL, NULL, 12),
(277206, NULL, 'PIRSR634178-1', NULL, NULL, NULL, NULL, 'PIRSR634178-1', NULL, NULL, NULL, 12),
(277207, NULL, 'PIRSR000636-1', NULL, NULL, NULL, NULL, 'PIRSR000636-1', NULL, NULL, NULL, 12),
(277208, NULL, 'PIRSR630560-2', NULL, NULL, NULL, NULL, 'PIRSR630560-2', NULL, NULL, NULL, 12),
(277209, NULL, 'PIRSR006247-1', NULL, NULL, NULL, NULL, 'PIRSR006247-1', NULL, NULL, NULL, 12);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(277210, NULL, 'PIRSR006105-2', NULL, NULL, NULL, NULL, 'PIRSR006105-2', NULL, NULL, NULL, 12),
(277211, NULL, 'PIRSR610059-50', NULL, NULL, NULL, NULL, 'PIRSR610059-50', NULL, NULL, NULL, 12),
(277212, NULL, 'PIRSR013503-1', NULL, NULL, NULL, NULL, 'PIRSR013503-1', NULL, NULL, NULL, 12),
(277213, NULL, 'PIRSR630295-50', NULL, NULL, NULL, NULL, 'PIRSR630295-50', NULL, NULL, NULL, 12),
(277214, NULL, 'PIRSR037432-51', NULL, NULL, NULL, NULL, 'PIRSR037432-51', NULL, NULL, NULL, 12),
(277215, NULL, 'PIRSR015894-2', NULL, NULL, NULL, NULL, 'PIRSR015894-2', NULL, NULL, NULL, 12),
(277216, NULL, 'PIRSR634015-2', NULL, NULL, NULL, NULL, 'PIRSR634015-2', NULL, NULL, NULL, 12),
(277217, NULL, 'PIRSR620777-51', NULL, NULL, NULL, NULL, 'PIRSR620777-51', NULL, NULL, NULL, 12),
(277218, NULL, 'PIRSR000865-2', NULL, NULL, NULL, NULL, 'PIRSR000865-2', NULL, NULL, NULL, 12),
(277219, NULL, 'PIRSR034515-2', NULL, NULL, NULL, NULL, 'PIRSR034515-2', NULL, NULL, NULL, 12),
(277220, NULL, 'PIRSR039004-2', NULL, NULL, NULL, NULL, 'PIRSR039004-2', NULL, NULL, NULL, 12),
(277221, NULL, 'PIRSR000097-1', NULL, NULL, NULL, NULL, 'PIRSR000097-1', NULL, NULL, NULL, 12),
(277222, NULL, 'PIRSR001021-2', NULL, NULL, NULL, NULL, 'PIRSR001021-2', NULL, NULL, NULL, 12),
(277223, NULL, 'PIRSR028762-1', NULL, NULL, NULL, NULL, 'PIRSR028762-1', NULL, NULL, NULL, 12),
(277224, NULL, 'PIRSR000410-1', NULL, NULL, NULL, NULL, 'PIRSR000410-1', NULL, NULL, NULL, 12),
(277225, NULL, 'PIRSR005096-1', NULL, NULL, NULL, NULL, 'PIRSR005096-1', NULL, NULL, NULL, 12),
(277226, NULL, 'PIRSR038142-50', NULL, NULL, NULL, NULL, 'PIRSR038142-50', NULL, NULL, NULL, 12),
(277227, NULL, 'PIRSR038455-2', NULL, NULL, NULL, NULL, 'PIRSR038455-2', NULL, NULL, NULL, 12),
(277228, NULL, 'PIRSR601233-2', NULL, NULL, NULL, NULL, 'PIRSR601233-2', NULL, NULL, NULL, 12),
(277229, NULL, 'PIRSR617711-2', NULL, NULL, NULL, NULL, 'PIRSR617711-2', NULL, NULL, NULL, 12),
(277230, NULL, 'PIRSR007802-1', NULL, NULL, NULL, NULL, 'PIRSR007802-1', NULL, NULL, NULL, 12),
(277231, NULL, 'PIRSR600823-5', NULL, NULL, NULL, NULL, 'PIRSR600823-5', NULL, NULL, NULL, 12),
(277232, NULL, 'PIRSR036298-50', NULL, NULL, NULL, NULL, 'PIRSR036298-50', NULL, NULL, NULL, 12),
(277233, NULL, 'PIRSR036421-1', NULL, NULL, NULL, NULL, 'PIRSR036421-1', NULL, NULL, NULL, 12),
(277234, NULL, 'PIRSR037430-1', NULL, NULL, NULL, NULL, 'PIRSR037430-1', NULL, NULL, NULL, 12),
(277235, NULL, 'PIRSR002374-1', NULL, NULL, NULL, NULL, 'PIRSR002374-1', NULL, NULL, NULL, 12),
(277236, NULL, 'PIRSR601559-50', NULL, NULL, NULL, NULL, 'PIRSR601559-50', NULL, NULL, NULL, 12),
(277237, NULL, 'PIRSR016429-51', NULL, NULL, NULL, NULL, 'PIRSR016429-51', NULL, NULL, NULL, 12),
(277238, NULL, 'PIRSR006337-3', NULL, NULL, NULL, NULL, 'PIRSR006337-3', NULL, NULL, NULL, 12),
(277239, NULL, 'PIRSR623088-2', NULL, NULL, NULL, NULL, 'PIRSR623088-2', NULL, NULL, NULL, 12),
(277240, NULL, 'PIRSR621573-6', NULL, NULL, NULL, NULL, 'PIRSR621573-6', NULL, NULL, NULL, 12),
(277241, NULL, 'PIRSR000350-4', NULL, NULL, NULL, NULL, 'PIRSR000350-4', NULL, NULL, NULL, 12),
(277242, NULL, 'PIRSR029271-50', NULL, NULL, NULL, NULL, 'PIRSR029271-50', NULL, NULL, NULL, 12),
(277243, NULL, 'PIRSR037938-2', NULL, NULL, NULL, NULL, 'PIRSR037938-2', NULL, NULL, NULL, 12),
(277244, NULL, 'PIRSR038994-1', NULL, NULL, NULL, NULL, 'PIRSR038994-1', NULL, NULL, NULL, 12),
(277245, NULL, 'PIRSR000013-1', NULL, NULL, NULL, NULL, 'PIRSR000013-1', NULL, NULL, NULL, 12),
(277246, NULL, 'PIRSR036442-1', NULL, NULL, NULL, NULL, 'PIRSR036442-1', NULL, NULL, NULL, 12),
(277247, NULL, 'PIRSR001134-2', NULL, NULL, NULL, NULL, 'PIRSR001134-2', NULL, NULL, NULL, 12),
(277248, NULL, 'PIRSR001149-4', NULL, NULL, NULL, NULL, 'PIRSR001149-4', NULL, NULL, NULL, 12),
(277249, NULL, 'PIRSR500948-2', NULL, NULL, NULL, NULL, 'PIRSR500948-2', NULL, NULL, NULL, 12),
(277250, NULL, 'PIRSR001060-2', NULL, NULL, NULL, NULL, 'PIRSR001060-2', NULL, NULL, NULL, 12),
(277251, NULL, 'PIRSR039144-50', NULL, NULL, NULL, NULL, 'PIRSR039144-50', NULL, NULL, NULL, 12),
(277252, NULL, 'PIRSR629890-2', NULL, NULL, NULL, NULL, 'PIRSR629890-2', NULL, NULL, NULL, 12);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(277253, NULL, 'PIRSR004692-2', NULL, NULL, NULL, NULL, 'PIRSR004692-2', NULL, NULL, NULL, 12),
(277254, NULL, 'PIRSR631048-51', NULL, NULL, NULL, NULL, 'PIRSR631048-51', NULL, NULL, NULL, 12),
(277255, NULL, 'PIRSR000941-50', NULL, NULL, NULL, NULL, 'PIRSR000941-50', NULL, NULL, NULL, 12),
(277256, NULL, 'PIRSR005943-1', NULL, NULL, NULL, NULL, 'PIRSR005943-1', NULL, NULL, NULL, 12),
(277257, NULL, 'PIRSR038927-1', NULL, NULL, NULL, NULL, 'PIRSR038927-1', NULL, NULL, NULL, 12),
(277258, NULL, 'PIRSR628788-2', NULL, NULL, NULL, NULL, 'PIRSR628788-2', NULL, NULL, NULL, 12),
(277259, NULL, 'PIRSR016020-1', NULL, NULL, NULL, NULL, 'PIRSR016020-1', NULL, NULL, NULL, 12),
(277260, NULL, 'PIRSR006113-1', NULL, NULL, NULL, NULL, 'PIRSR006113-1', NULL, NULL, NULL, 12),
(277261, NULL, 'PIRSR627057-2', NULL, NULL, NULL, NULL, 'PIRSR627057-2', NULL, NULL, NULL, 12),
(277262, NULL, 'PIRSR037393-2', NULL, NULL, NULL, NULL, 'PIRSR037393-2', NULL, NULL, NULL, 12),
(277263, NULL, 'PIRSR627185-50', NULL, NULL, NULL, NULL, 'PIRSR627185-50', NULL, NULL, NULL, 12),
(277264, NULL, 'PIRSR006246-5', NULL, NULL, NULL, NULL, 'PIRSR006246-5', NULL, NULL, NULL, 12),
(277265, NULL, 'PIRSR018001-3', NULL, NULL, NULL, NULL, 'PIRSR018001-3', NULL, NULL, NULL, 12),
(277266, NULL, 'PIRSR025737-1', NULL, NULL, NULL, NULL, 'PIRSR025737-1', NULL, NULL, NULL, 12),
(277267, NULL, 'PIRSR006105-1', NULL, NULL, NULL, NULL, 'PIRSR006105-1', NULL, NULL, NULL, 12),
(277268, NULL, 'PIRSR006241-50', NULL, NULL, NULL, NULL, 'PIRSR006241-50', NULL, NULL, NULL, 12),
(277269, NULL, 'PIRSR037322-1', NULL, NULL, NULL, NULL, 'PIRSR037322-1', NULL, NULL, NULL, 12),
(277270, NULL, 'PIRSR606225-1', NULL, NULL, NULL, NULL, 'PIRSR606225-1', NULL, NULL, NULL, 12),
(277271, NULL, 'PIRSR031051-3', NULL, NULL, NULL, NULL, 'PIRSR031051-3', NULL, NULL, NULL, 12),
(277272, NULL, 'PIRSR001149-2', NULL, NULL, NULL, NULL, 'PIRSR001149-2', NULL, NULL, NULL, 12),
(277273, NULL, 'PIRSR000197-1', NULL, NULL, NULL, NULL, 'PIRSR000197-1', NULL, NULL, NULL, 12),
(277274, NULL, 'PIRSR000029-1', NULL, NULL, NULL, NULL, 'PIRSR000029-1', NULL, NULL, NULL, 12),
(277275, NULL, 'PIRSR015919-1', NULL, NULL, NULL, NULL, 'PIRSR015919-1', NULL, NULL, NULL, 12),
(277276, NULL, 'PIRSR006230-1', NULL, NULL, NULL, NULL, 'PIRSR006230-1', NULL, NULL, NULL, 12),
(277277, NULL, 'PIRSR016567-50', NULL, NULL, NULL, NULL, 'PIRSR016567-50', NULL, NULL, NULL, 12),
(277278, NULL, 'PIRSR613307-50', NULL, NULL, NULL, NULL, 'PIRSR613307-50', NULL, NULL, NULL, 12),
(277279, NULL, 'PIRSR001084-2', NULL, NULL, NULL, NULL, 'PIRSR001084-2', NULL, NULL, NULL, 12),
(277280, NULL, 'PIRSR017689-1', NULL, NULL, NULL, NULL, 'PIRSR017689-1', NULL, NULL, NULL, 12),
(277281, NULL, 'PIRSR002495-50', NULL, NULL, NULL, NULL, 'PIRSR002495-50', NULL, NULL, NULL, 12),
(277282, NULL, 'PIRSR000926-1', NULL, NULL, NULL, NULL, 'PIRSR000926-1', NULL, NULL, NULL, 12),
(277283, NULL, 'PIRSR036441-50', NULL, NULL, NULL, NULL, 'PIRSR036441-50', NULL, NULL, NULL, 12),
(277284, NULL, 'PIRSR037506-1', NULL, NULL, NULL, NULL, 'PIRSR037506-1', NULL, NULL, NULL, 12),
(277285, NULL, 'PIRSR018168-1', NULL, NULL, NULL, NULL, 'PIRSR018168-1', NULL, NULL, NULL, 12),
(277286, NULL, 'PIRSR002006-3', NULL, NULL, NULL, NULL, 'PIRSR002006-3', NULL, NULL, NULL, 12),
(277287, NULL, 'PIRSR017818-1', NULL, NULL, NULL, NULL, 'PIRSR017818-1', NULL, NULL, NULL, 12),
(277288, NULL, 'PIRSR622350-50', NULL, NULL, NULL, NULL, 'PIRSR622350-50', NULL, NULL, NULL, 12),
(277289, NULL, 'PIRSR634180-3', NULL, NULL, NULL, NULL, 'PIRSR634180-3', NULL, NULL, NULL, 12),
(277290, NULL, 'PIRSR038994-3', NULL, NULL, NULL, NULL, 'PIRSR038994-3', NULL, NULL, NULL, 12),
(277291, NULL, 'PIRSR001415-5', NULL, NULL, NULL, NULL, 'PIRSR001415-5', NULL, NULL, NULL, 12),
(277292, NULL, 'PIRSR000118-1', NULL, NULL, NULL, NULL, 'PIRSR000118-1', NULL, NULL, NULL, 12),
(277293, NULL, 'PIRSR018250-1', NULL, NULL, NULL, NULL, 'PIRSR018250-1', NULL, NULL, NULL, 12),
(277294, NULL, 'PIRSR631048-50', NULL, NULL, NULL, NULL, 'PIRSR631048-50', NULL, NULL, NULL, 12),
(277295, NULL, 'PIRSR000071-1', NULL, NULL, NULL, NULL, 'PIRSR000071-1', NULL, NULL, NULL, 12);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(277296, NULL, 'PIRSR000617-1', NULL, NULL, NULL, NULL, 'PIRSR000617-1', NULL, NULL, NULL, 12),
(277297, NULL, 'PIRSR006356-1', NULL, NULL, NULL, NULL, 'PIRSR006356-1', NULL, NULL, NULL, 12),
(277298, NULL, 'PIRSR001492-3', NULL, NULL, NULL, NULL, 'PIRSR001492-3', NULL, NULL, NULL, 12),
(277299, NULL, 'PIRSR002825-1', NULL, NULL, NULL, NULL, 'PIRSR002825-1', NULL, NULL, NULL, 12),
(277300, NULL, 'PIRSR025648-1', NULL, NULL, NULL, NULL, 'PIRSR025648-1', NULL, NULL, NULL, 12),
(277301, NULL, 'PIRSR000556-2', NULL, NULL, NULL, NULL, 'PIRSR000556-2', NULL, NULL, NULL, 12),
(277302, NULL, 'PIRSR622312-50', NULL, NULL, NULL, NULL, 'PIRSR622312-50', NULL, NULL, NULL, 12),
(277303, NULL, 'PIRSR604677-50', NULL, NULL, NULL, NULL, 'PIRSR604677-50', NULL, NULL, NULL, 12),
(277304, NULL, 'PIRSR001341-1', NULL, NULL, NULL, NULL, 'PIRSR001341-1', NULL, NULL, NULL, 12),
(277305, NULL, 'PIRSR037941-1', NULL, NULL, NULL, NULL, 'PIRSR037941-1', NULL, NULL, NULL, 12),
(277306, NULL, 'PIRSR002855-1', NULL, NULL, NULL, NULL, 'PIRSR002855-1', NULL, NULL, NULL, 12),
(277307, NULL, 'PIRSR005739-1', NULL, NULL, NULL, NULL, 'PIRSR005739-1', NULL, NULL, NULL, 12),
(277308, NULL, 'PIRSR038927-3', NULL, NULL, NULL, NULL, 'PIRSR038927-3', NULL, NULL, NULL, 12),
(277309, NULL, 'PIRSR036497-2', NULL, NULL, NULL, NULL, 'PIRSR036497-2', NULL, NULL, NULL, 12),
(277310, NULL, 'PIRSR001092-1', NULL, NULL, NULL, NULL, 'PIRSR001092-1', NULL, NULL, NULL, 12),
(277311, NULL, 'PIRSR038065-1', NULL, NULL, NULL, NULL, 'PIRSR038065-1', NULL, NULL, NULL, 12),
(277312, NULL, 'PIRSR600821-52', NULL, NULL, NULL, NULL, 'PIRSR600821-52', NULL, NULL, NULL, 12),
(277313, NULL, 'PIRSR001924-3', NULL, NULL, NULL, NULL, 'PIRSR001924-3', NULL, NULL, NULL, 12),
(277314, NULL, 'PIRSR000097-3', NULL, NULL, NULL, NULL, 'PIRSR000097-3', NULL, NULL, NULL, 12),
(277315, NULL, 'PIRSR036489-3', NULL, NULL, NULL, NULL, 'PIRSR036489-3', NULL, NULL, NULL, 12),
(277316, NULL, 'PIRSR000550-2', NULL, NULL, NULL, NULL, 'PIRSR000550-2', NULL, NULL, NULL, 12),
(277317, NULL, 'PIRSR000127-2', NULL, NULL, NULL, NULL, 'PIRSR000127-2', NULL, NULL, NULL, 12),
(277318, NULL, 'PIRSR634603-2', NULL, NULL, NULL, NULL, 'PIRSR634603-2', NULL, NULL, NULL, 12),
(277319, NULL, 'PIRSR001145-1', NULL, NULL, NULL, NULL, 'PIRSR001145-1', NULL, NULL, NULL, 12),
(277320, NULL, 'PIRSR000732-3', NULL, NULL, NULL, NULL, 'PIRSR000732-3', NULL, NULL, NULL, 12),
(277321, NULL, 'PIRSR622314-3', NULL, NULL, NULL, NULL, 'PIRSR622314-3', NULL, NULL, NULL, 12),
(277322, NULL, 'PIRSR000207-1', NULL, NULL, NULL, NULL, 'PIRSR000207-1', NULL, NULL, NULL, 12),
(277323, NULL, 'PIRSR000620-2', NULL, NULL, NULL, NULL, 'PIRSR000620-2', NULL, NULL, NULL, 12),
(277324, NULL, 'PIRSR036936-2', NULL, NULL, NULL, NULL, 'PIRSR036936-2', NULL, NULL, NULL, 12),
(277325, NULL, 'PIRSR629727-3', NULL, NULL, NULL, NULL, 'PIRSR629727-3', NULL, NULL, NULL, 12),
(277326, NULL, 'PIRSR003817-3', NULL, NULL, NULL, NULL, 'PIRSR003817-3', NULL, NULL, NULL, 12),
(277327, NULL, 'PIRSR000445-1', NULL, NULL, NULL, NULL, 'PIRSR000445-1', NULL, NULL, NULL, 12),
(277328, NULL, 'PIRSR000027-2', NULL, NULL, NULL, NULL, 'PIRSR000027-2', NULL, NULL, NULL, 12),
(277329, NULL, 'PIRSR617821-2', NULL, NULL, NULL, NULL, 'PIRSR617821-2', NULL, NULL, NULL, 12),
(277330, NULL, 'PIRSR036432-1', NULL, NULL, NULL, NULL, 'PIRSR036432-1', NULL, NULL, NULL, 12),
(277331, NULL, 'PIRSR001658-50', NULL, NULL, NULL, NULL, 'PIRSR001658-50', NULL, NULL, NULL, 12),
(277332, NULL, 'PIRSR005669-1', NULL, NULL, NULL, NULL, 'PIRSR005669-1', NULL, NULL, NULL, 12),
(277333, NULL, 'PIRSR000260-1', NULL, NULL, NULL, NULL, 'PIRSR000260-1', NULL, NULL, NULL, 12),
(277334, NULL, 'PIRSR633573-1', NULL, NULL, NULL, NULL, 'PIRSR633573-1', NULL, NULL, NULL, 12),
(277335, NULL, 'PIRSR008129-1', NULL, NULL, NULL, NULL, 'PIRSR008129-1', NULL, NULL, NULL, 12),
(277336, NULL, 'PIRSR016308-2', NULL, NULL, NULL, NULL, 'PIRSR016308-2', NULL, NULL, NULL, 12),
(277337, NULL, 'PIRSR600250-50', NULL, NULL, NULL, NULL, 'PIRSR600250-50', NULL, NULL, NULL, 12),
(277338, NULL, 'PIRSR000149-1', NULL, NULL, NULL, NULL, 'PIRSR000149-1', NULL, NULL, NULL, 12);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(277339, NULL, 'PIRSR036376-50', NULL, NULL, NULL, NULL, 'PIRSR036376-50', NULL, NULL, NULL, 12),
(277340, NULL, 'PIRSR029681-2', NULL, NULL, NULL, NULL, 'PIRSR029681-2', NULL, NULL, NULL, 12),
(277341, NULL, 'PIRSR004682-2', NULL, NULL, NULL, NULL, 'PIRSR004682-2', NULL, NULL, NULL, 12),
(277342, NULL, 'PIRSR000927-1', NULL, NULL, NULL, NULL, 'PIRSR000927-1', NULL, NULL, NULL, 12),
(277343, NULL, 'PIRSR037911-3', NULL, NULL, NULL, NULL, 'PIRSR037911-3', NULL, NULL, NULL, 12),
(277344, NULL, 'PIRSR631245-4', NULL, NULL, NULL, NULL, 'PIRSR631245-4', NULL, NULL, NULL, 12),
(277345, NULL, 'PIRSR000094-2', NULL, NULL, NULL, NULL, 'PIRSR000094-2', NULL, NULL, NULL, 12),
(277346, NULL, 'PIRSR000241-2', NULL, NULL, NULL, NULL, 'PIRSR000241-2', NULL, NULL, NULL, 12),
(277347, NULL, 'PIRSR038013-50', NULL, NULL, NULL, NULL, 'PIRSR038013-50', NULL, NULL, NULL, 12),
(277348, NULL, 'PIRSR001000-1', NULL, NULL, NULL, NULL, 'PIRSR001000-1', NULL, NULL, NULL, 12),
(277349, NULL, 'PIRSR000988-1', NULL, NULL, NULL, NULL, 'PIRSR000988-1', NULL, NULL, NULL, 12),
(277350, NULL, 'PIRSR001430-1', NULL, NULL, NULL, NULL, 'PIRSR001430-1', NULL, NULL, NULL, 12),
(277351, NULL, 'PIRSR011356-1', NULL, NULL, NULL, NULL, 'PIRSR011356-1', NULL, NULL, NULL, 12),
(277352, NULL, 'PIRSR000431-2', NULL, NULL, NULL, NULL, 'PIRSR000431-2', NULL, NULL, NULL, 12),
(277353, NULL, 'PIRSR019634-50', NULL, NULL, NULL, NULL, 'PIRSR019634-50', NULL, NULL, NULL, 12),
(277354, NULL, 'PIRSR005639-1', NULL, NULL, NULL, NULL, 'PIRSR005639-1', NULL, NULL, NULL, 12),
(277355, NULL, 'PIRSR000102-2', NULL, NULL, NULL, NULL, 'PIRSR000102-2', NULL, NULL, NULL, 12),
(277356, NULL, 'PIRSR001093-1', NULL, NULL, NULL, NULL, 'PIRSR001093-1', NULL, NULL, NULL, 12),
(277357, NULL, 'PIRSR002421-3', NULL, NULL, NULL, NULL, 'PIRSR002421-3', NULL, NULL, NULL, 12),
(277358, NULL, 'PIRSR037568-1', NULL, NULL, NULL, NULL, 'PIRSR037568-1', NULL, NULL, NULL, 12),
(277359, NULL, 'PIRSR500133-2', NULL, NULL, NULL, NULL, 'PIRSR500133-2', NULL, NULL, NULL, 12),
(277360, NULL, 'PIRSR001942-1', NULL, NULL, NULL, NULL, 'PIRSR001942-1', NULL, NULL, NULL, 12),
(277361, NULL, 'PIRSR005965-1', NULL, NULL, NULL, NULL, 'PIRSR005965-1', NULL, NULL, NULL, 12),
(277362, NULL, 'PIRSR024851-51', NULL, NULL, NULL, NULL, 'PIRSR024851-51', NULL, NULL, NULL, 12),
(277363, NULL, 'PIRSR000361-1', NULL, NULL, NULL, NULL, 'PIRSR000361-1', NULL, NULL, NULL, 12),
(277364, NULL, 'PIRSR633528-5', NULL, NULL, NULL, NULL, 'PIRSR633528-5', NULL, NULL, NULL, 12),
(277365, NULL, 'PIRSR037599-3', NULL, NULL, NULL, NULL, 'PIRSR037599-3', NULL, NULL, NULL, 12),
(277366, NULL, 'PIRSR629580-5', NULL, NULL, NULL, NULL, 'PIRSR629580-5', NULL, NULL, NULL, 12),
(277367, NULL, 'PIRSR002017-1', NULL, NULL, NULL, NULL, 'PIRSR002017-1', NULL, NULL, NULL, 12),
(277368, NULL, 'PIRSR633195-1', NULL, NULL, NULL, NULL, 'PIRSR633195-1', NULL, NULL, NULL, 12),
(277369, NULL, 'PIRSR018571-1', NULL, NULL, NULL, NULL, 'PIRSR018571-1', NULL, NULL, NULL, 12),
(277370, NULL, 'PIRSR019663-1', NULL, NULL, NULL, NULL, 'PIRSR019663-1', NULL, NULL, NULL, 12),
(277371, NULL, 'PIRSR038885-1', NULL, NULL, NULL, NULL, 'PIRSR038885-1', NULL, NULL, NULL, 12),
(277372, NULL, 'PIRSR001146-1', NULL, NULL, NULL, NULL, 'PIRSR001146-1', NULL, NULL, NULL, 12),
(277373, NULL, 'PIRSR633560-51', NULL, NULL, NULL, NULL, 'PIRSR633560-51', NULL, NULL, NULL, 12),
(277374, NULL, 'PIRSR000090-1', NULL, NULL, NULL, NULL, 'PIRSR000090-1', NULL, NULL, NULL, 12),
(277375, NULL, 'PIRSR036665-52', NULL, NULL, NULL, NULL, 'PIRSR036665-52', NULL, NULL, NULL, 12),
(277376, NULL, 'PIRSR000862-1', NULL, NULL, NULL, NULL, 'PIRSR000862-1', NULL, NULL, NULL, 12),
(277377, NULL, 'PIRSR500947-50', NULL, NULL, NULL, NULL, 'PIRSR500947-50', NULL, NULL, NULL, 12),
(277378, NULL, 'PIRSR600269-51', NULL, NULL, NULL, NULL, 'PIRSR600269-51', NULL, NULL, NULL, 12),
(277379, NULL, 'PIRSR011861-1', NULL, NULL, NULL, NULL, 'PIRSR011861-1', NULL, NULL, NULL, 12),
(277380, NULL, 'PIRSR001109-1', NULL, NULL, NULL, NULL, 'PIRSR001109-1', NULL, NULL, NULL, 12),
(277381, NULL, 'PIRSR005096-2', NULL, NULL, NULL, NULL, 'PIRSR005096-2', NULL, NULL, NULL, 12);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(277382, NULL, 'PIRSR005149-50', NULL, NULL, NULL, NULL, 'PIRSR005149-50', NULL, NULL, NULL, 12),
(277383, NULL, 'PIRSR037479-3', NULL, NULL, NULL, NULL, 'PIRSR037479-3', NULL, NULL, NULL, 12),
(277384, NULL, 'PIRSR015853-2', NULL, NULL, NULL, NULL, 'PIRSR015853-2', NULL, NULL, NULL, 12),
(277385, NULL, 'PIRSR001569-1', NULL, NULL, NULL, NULL, 'PIRSR001569-1', NULL, NULL, NULL, 12),
(277386, NULL, 'PIRSR037913-2', NULL, NULL, NULL, NULL, 'PIRSR037913-2', NULL, NULL, NULL, 12),
(277387, NULL, 'PIRSR611612-50', NULL, NULL, NULL, NULL, 'PIRSR611612-50', NULL, NULL, NULL, 12),
(277388, NULL, 'PIRSR036488-1', NULL, NULL, NULL, NULL, 'PIRSR036488-1', NULL, NULL, NULL, 12),
(277389, NULL, 'PIRSR617711-1', NULL, NULL, NULL, NULL, 'PIRSR617711-1', NULL, NULL, NULL, 12),
(277390, NULL, 'PIRSR010354-50', NULL, NULL, NULL, NULL, 'PIRSR010354-50', NULL, NULL, NULL, 12),
(277391, NULL, 'PIRSR001619-1', NULL, NULL, NULL, NULL, 'PIRSR001619-1', NULL, NULL, NULL, 12),
(277392, NULL, 'PIRSR037479-1', NULL, NULL, NULL, NULL, 'PIRSR037479-1', NULL, NULL, NULL, 12),
(277393, NULL, 'PIRSR627053-2', NULL, NULL, NULL, NULL, 'PIRSR627053-2', NULL, NULL, NULL, 12),
(277394, NULL, 'PIRSR000350-3', NULL, NULL, NULL, NULL, 'PIRSR000350-3', NULL, NULL, NULL, 12),
(277395, NULL, 'PIRSR000355-1', NULL, NULL, NULL, NULL, 'PIRSR000355-1', NULL, NULL, NULL, 12),
(277396, NULL, 'PIRSR026389-2', NULL, NULL, NULL, NULL, 'PIRSR026389-2', NULL, NULL, NULL, 12),
(277397, NULL, 'PIRSR000706-1', NULL, NULL, NULL, NULL, 'PIRSR000706-1', NULL, NULL, NULL, 12),
(277398, NULL, 'PIRSR002900-1', NULL, NULL, NULL, NULL, 'PIRSR002900-1', NULL, NULL, NULL, 12),
(277399, NULL, 'PIRSR000915-1', NULL, NULL, NULL, NULL, 'PIRSR000915-1', NULL, NULL, NULL, 12),
(277400, NULL, 'PIRSR000454-3', NULL, NULL, NULL, NULL, 'PIRSR000454-3', NULL, NULL, NULL, 12),
(277401, NULL, 'PIRSR028757-1', NULL, NULL, NULL, NULL, 'PIRSR028757-1', NULL, NULL, NULL, 12),
(277402, NULL, 'PIRSR611778-50', NULL, NULL, NULL, NULL, 'PIRSR611778-50', NULL, NULL, NULL, 12),
(277403, NULL, 'PIRSR000185-1', NULL, NULL, NULL, NULL, 'PIRSR000185-1', NULL, NULL, NULL, 12),
(277404, NULL, 'PIRSR001430-3', NULL, NULL, NULL, NULL, 'PIRSR001430-3', NULL, NULL, NULL, 12),
(277405, NULL, 'PIRSR006431-1', NULL, NULL, NULL, NULL, 'PIRSR006431-1', NULL, NULL, NULL, 12),
(277406, NULL, 'PIRSR037947-1', NULL, NULL, NULL, NULL, 'PIRSR037947-1', NULL, NULL, NULL, 12),
(277407, NULL, 'PIRSR000013-2', NULL, NULL, NULL, NULL, 'PIRSR000013-2', NULL, NULL, NULL, 12),
(277408, NULL, 'PIRSR000808-3', NULL, NULL, NULL, NULL, 'PIRSR000808-3', NULL, NULL, NULL, 12),
(277409, NULL, 'PIRSR000007-51', NULL, NULL, NULL, NULL, 'PIRSR000007-51', NULL, NULL, NULL, 12),
(277410, NULL, 'PIRSR000905-2', NULL, NULL, NULL, NULL, 'PIRSR000905-2', NULL, NULL, NULL, 12),
(277411, NULL, 'PIRSR016150-51', NULL, NULL, NULL, NULL, 'PIRSR016150-51', NULL, NULL, NULL, 12),
(277412, NULL, 'PIRSR629609-2', NULL, NULL, NULL, NULL, 'PIRSR629609-2', NULL, NULL, NULL, 12),
(277413, NULL, 'PIRSR018249-2', NULL, NULL, NULL, NULL, 'PIRSR018249-2', NULL, NULL, NULL, 12),
(277414, NULL, 'PIRSR006337-2', NULL, NULL, NULL, NULL, 'PIRSR006337-2', NULL, NULL, NULL, 12),
(277415, NULL, 'PIRSR026534-3', NULL, NULL, NULL, NULL, 'PIRSR026534-3', NULL, NULL, NULL, 12),
(277416, NULL, 'PIRSR000459-1', NULL, NULL, NULL, NULL, 'PIRSR000459-1', NULL, NULL, NULL, 12),
(277417, NULL, 'PIRSR001589-2', NULL, NULL, NULL, NULL, 'PIRSR001589-2', NULL, NULL, NULL, 12),
(277418, NULL, 'PIRSR001222-51', NULL, NULL, NULL, NULL, 'PIRSR001222-51', NULL, NULL, NULL, 12),
(277419, NULL, 'PIRSR001355-3', NULL, NULL, NULL, NULL, 'PIRSR001355-3', NULL, NULL, NULL, 12),
(277420, NULL, 'PIRSR002736-50', NULL, NULL, NULL, NULL, 'PIRSR002736-50', NULL, NULL, NULL, 12),
(277421, NULL, 'PIRSR037242-2', NULL, NULL, NULL, NULL, 'PIRSR037242-2', NULL, NULL, NULL, 12),
(277422, NULL, 'PIRSR628391-4', NULL, NULL, NULL, NULL, 'PIRSR628391-4', NULL, NULL, NULL, 12),
(277423, NULL, 'PIRSR001235-1', NULL, NULL, NULL, NULL, 'PIRSR001235-1', NULL, NULL, NULL, 12),
(277424, NULL, 'PIRSR601191-2', NULL, NULL, NULL, NULL, 'PIRSR601191-2', NULL, NULL, NULL, 12);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(277425, NULL, 'PIRSR028774-2', NULL, NULL, NULL, NULL, 'PIRSR028774-2', NULL, NULL, NULL, 12),
(277426, NULL, 'PIRSR635711-52', NULL, NULL, NULL, NULL, 'PIRSR635711-52', NULL, NULL, NULL, 12),
(277427, NULL, 'PIRSR036551-1', NULL, NULL, NULL, NULL, 'PIRSR036551-1', NULL, NULL, NULL, 12),
(277428, NULL, 'PIRSR000238-1', NULL, NULL, NULL, NULL, 'PIRSR000238-1', NULL, NULL, NULL, 12),
(277429, NULL, 'PIRSR004682-4', NULL, NULL, NULL, NULL, 'PIRSR004682-4', NULL, NULL, NULL, 12),
(277430, NULL, 'PIRSR016958-1', NULL, NULL, NULL, NULL, 'PIRSR016958-1', NULL, NULL, NULL, 12),
(277431, NULL, 'PIRSR000509-1', NULL, NULL, NULL, NULL, 'PIRSR000509-1', NULL, NULL, NULL, 12),
(277432, NULL, 'PIRSR000108-2', NULL, NULL, NULL, NULL, 'PIRSR000108-2', NULL, NULL, NULL, 12),
(277433, NULL, 'PIRSR600983-52', NULL, NULL, NULL, NULL, 'PIRSR600983-52', NULL, NULL, NULL, 12),
(277434, NULL, 'PIRSR000192-3', NULL, NULL, NULL, NULL, 'PIRSR000192-3', NULL, NULL, NULL, 12),
(277435, NULL, 'PIRSR005822-1', NULL, NULL, NULL, NULL, 'PIRSR005822-1', NULL, NULL, NULL, 12),
(277436, NULL, 'PIRSR037935-1', NULL, NULL, NULL, NULL, 'PIRSR037935-1', NULL, NULL, NULL, 12),
(277437, NULL, 'PIRSR006468-1', NULL, NULL, NULL, NULL, 'PIRSR006468-1', NULL, NULL, NULL, 12),
(277438, NULL, 'PIRSR631245-5', NULL, NULL, NULL, NULL, 'PIRSR631245-5', NULL, NULL, NULL, 12),
(277439, NULL, 'PIRSR037303-2', NULL, NULL, NULL, NULL, 'PIRSR037303-2', NULL, NULL, NULL, 12),
(277440, NULL, 'PIRSR608356-51', NULL, NULL, NULL, NULL, 'PIRSR608356-51', NULL, NULL, NULL, 12),
(277441, NULL, 'PIRSR633508-4', NULL, NULL, NULL, NULL, 'PIRSR633508-4', NULL, NULL, NULL, 12),
(277442, NULL, 'PIRSR000409-3', NULL, NULL, NULL, NULL, 'PIRSR000409-3', NULL, NULL, NULL, 12),
(277443, NULL, 'PIRSR000732-2', NULL, NULL, NULL, NULL, 'PIRSR000732-2', NULL, NULL, NULL, 12),
(277444, NULL, 'PIRSR001227-2', NULL, NULL, NULL, NULL, 'PIRSR001227-2', NULL, NULL, NULL, 12),
(277445, NULL, 'PIRSR017205-3', NULL, NULL, NULL, NULL, 'PIRSR017205-3', NULL, NULL, NULL, 12),
(277446, NULL, 'PIRSR002279-2', NULL, NULL, NULL, NULL, 'PIRSR002279-2', NULL, NULL, NULL, 12),
(277447, NULL, 'PIRSR000169-2', NULL, NULL, NULL, NULL, 'PIRSR000169-2', NULL, NULL, NULL, 12),
(277448, NULL, 'PIRSR002033-1', NULL, NULL, NULL, NULL, 'PIRSR002033-1', NULL, NULL, NULL, 12),
(277449, NULL, 'PIRSR634015-1', NULL, NULL, NULL, NULL, 'PIRSR634015-1', NULL, NULL, NULL, 12),
(277450, NULL, 'PIRSR623237-1', NULL, NULL, NULL, NULL, 'PIRSR623237-1', NULL, NULL, NULL, 12),
(277451, NULL, 'PIRSR017818-3', NULL, NULL, NULL, NULL, 'PIRSR017818-3', NULL, NULL, NULL, 12),
(277452, NULL, 'PIRSR018063-50', NULL, NULL, NULL, NULL, 'PIRSR018063-50', NULL, NULL, NULL, 12),
(277453, NULL, 'PIRSR009407-1', NULL, NULL, NULL, NULL, 'PIRSR009407-1', NULL, NULL, NULL, 12),
(277454, NULL, 'PIRSR017617-1', NULL, NULL, NULL, NULL, 'PIRSR017617-1', NULL, NULL, NULL, 12),
(277455, NULL, 'PIRSR628788-1', NULL, NULL, NULL, NULL, 'PIRSR628788-1', NULL, NULL, NULL, 12),
(277456, NULL, 'PIRSR003817-4', NULL, NULL, NULL, NULL, 'PIRSR003817-4', NULL, NULL, NULL, 12),
(277457, NULL, 'PIRSR000445-3', NULL, NULL, NULL, NULL, 'PIRSR000445-3', NULL, NULL, NULL, 12),
(277458, NULL, 'PIRSR005536-2', NULL, NULL, NULL, NULL, 'PIRSR005536-2', NULL, NULL, NULL, 12),
(277459, NULL, 'PIRSR602325-50', NULL, NULL, NULL, NULL, 'PIRSR602325-50', NULL, NULL, NULL, 12),
(277460, NULL, 'PIRSR009343-2', NULL, NULL, NULL, NULL, 'PIRSR009343-2', NULL, NULL, NULL, 12),
(277461, NULL, 'PIRSR006621-1', NULL, NULL, NULL, NULL, 'PIRSR006621-1', NULL, NULL, NULL, 12),
(277462, NULL, 'PIRSR009103-1', NULL, NULL, NULL, NULL, 'PIRSR009103-1', NULL, NULL, NULL, 12),
(277463, NULL, 'PIRSR012565-1', NULL, NULL, NULL, NULL, 'PIRSR012565-1', NULL, NULL, NULL, 12),
(277464, NULL, 'PIRSR623088-3', NULL, NULL, NULL, NULL, 'PIRSR623088-3', NULL, NULL, NULL, 12),
(277465, NULL, 'PIRSR038025-50', NULL, NULL, NULL, NULL, 'PIRSR038025-50', NULL, NULL, NULL, 12),
(277466, NULL, 'PIRSR038079-1', NULL, NULL, NULL, NULL, 'PIRSR038079-1', NULL, NULL, NULL, 12),
(277467, NULL, 'PIRSR001134-1', NULL, NULL, NULL, NULL, 'PIRSR001134-1', NULL, NULL, NULL, 12);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(277468, NULL, 'PIRSR006250-1', NULL, NULL, NULL, NULL, 'PIRSR006250-1', NULL, NULL, NULL, 12),
(277469, NULL, 'PIRSR016308-1', NULL, NULL, NULL, NULL, 'PIRSR016308-1', NULL, NULL, NULL, 12),
(277470, NULL, 'PIRSR600990-52', NULL, NULL, NULL, NULL, 'PIRSR600990-52', NULL, NULL, NULL, 12),
(277471, NULL, 'PIRSR639901-2', NULL, NULL, NULL, NULL, 'PIRSR639901-2', NULL, NULL, NULL, 12),
(277472, NULL, 'PIRSR000177-1', NULL, NULL, NULL, NULL, 'PIRSR000177-1', NULL, NULL, NULL, 12),
(277473, NULL, 'PIRSR001196-2', NULL, NULL, NULL, NULL, 'PIRSR001196-2', NULL, NULL, NULL, 12),
(277474, NULL, 'PIRSR011789-1', NULL, NULL, NULL, NULL, 'PIRSR011789-1', NULL, NULL, NULL, 12),
(277475, NULL, 'PIRSR621573-8', NULL, NULL, NULL, NULL, 'PIRSR621573-8', NULL, NULL, NULL, 12),
(277476, NULL, 'PIRSR600542-1', NULL, NULL, NULL, NULL, 'PIRSR600542-1', NULL, NULL, NULL, 12),
(277477, NULL, 'PIRSR006246-3', NULL, NULL, NULL, NULL, 'PIRSR006246-3', NULL, NULL, NULL, 12),
(277478, NULL, 'PIRSR000548-1', NULL, NULL, NULL, NULL, 'PIRSR000548-1', NULL, NULL, NULL, 12),
(277479, NULL, 'PIRSR023956-1', NULL, NULL, NULL, NULL, 'PIRSR023956-1', NULL, NULL, NULL, 12),
(277480, NULL, 'PIRSR038085-2', NULL, NULL, NULL, NULL, 'PIRSR038085-2', NULL, NULL, NULL, 12),
(277481, NULL, 'PIRSR037281-2', NULL, NULL, NULL, NULL, 'PIRSR037281-2', NULL, NULL, NULL, 12),
(277482, NULL, 'PIRSR038023-1', NULL, NULL, NULL, NULL, 'PIRSR038023-1', NULL, NULL, NULL, 12),
(277483, NULL, 'PIRSR630297-1', NULL, NULL, NULL, NULL, 'PIRSR630297-1', NULL, NULL, NULL, 12),
(277484, NULL, 'PIRSR000846-2', NULL, NULL, NULL, NULL, 'PIRSR000846-2', NULL, NULL, NULL, 12),
(277485, NULL, 'PIRSR001814-1', NULL, NULL, NULL, NULL, 'PIRSR001814-1', NULL, NULL, NULL, 12),
(277486, NULL, 'PIRSR621573-1', NULL, NULL, NULL, NULL, 'PIRSR621573-1', NULL, NULL, NULL, 12),
(277487, NULL, 'PIRSR001199-2', NULL, NULL, NULL, NULL, 'PIRSR001199-2', NULL, NULL, NULL, 12),
(277488, NULL, 'PIRSR600888-1', NULL, NULL, NULL, NULL, 'PIRSR600888-1', NULL, NULL, NULL, 12),
(277489, NULL, 'PIRSR016305-1', NULL, NULL, NULL, NULL, 'PIRSR016305-1', NULL, NULL, NULL, 12),
(277490, NULL, 'PIRSR002030-1', NULL, NULL, NULL, NULL, 'PIRSR002030-1', NULL, NULL, NULL, 12),
(277491, NULL, 'PIRSR037250-50', NULL, NULL, NULL, NULL, 'PIRSR037250-50', NULL, NULL, NULL, 12),
(277492, NULL, 'PIRSR000495-1', NULL, NULL, NULL, NULL, 'PIRSR000495-1', NULL, NULL, NULL, 12),
(277493, NULL, 'PIRSR633144-1', NULL, NULL, NULL, NULL, 'PIRSR633144-1', NULL, NULL, NULL, 12),
(277494, NULL, 'PIRSR000105-3', NULL, NULL, NULL, NULL, 'PIRSR000105-3', NULL, NULL, NULL, 12),
(277495, NULL, 'PIRSR001341-3', NULL, NULL, NULL, NULL, 'PIRSR001341-3', NULL, NULL, NULL, 12),
(277496, NULL, 'PIRSR001199-1', NULL, NULL, NULL, NULL, 'PIRSR001199-1', NULL, NULL, NULL, 12),
(277497, NULL, 'PIRSR001787-1', NULL, NULL, NULL, NULL, 'PIRSR001787-1', NULL, NULL, NULL, 12),
(277498, NULL, 'PIRSR611612-51', NULL, NULL, NULL, NULL, 'PIRSR611612-51', NULL, NULL, NULL, 12),
(277499, NULL, 'PIRSR000336-1', NULL, NULL, NULL, NULL, 'PIRSR000336-1', NULL, NULL, NULL, 12),
(277500, NULL, 'PIRSR036936-1', NULL, NULL, NULL, NULL, 'PIRSR036936-1', NULL, NULL, NULL, 12),
(277501, NULL, 'PIRSR001480-2', NULL, NULL, NULL, NULL, 'PIRSR001480-2', NULL, NULL, NULL, 12),
(277502, NULL, 'PIRSR018168-3', NULL, NULL, NULL, NULL, 'PIRSR018168-3', NULL, NULL, NULL, 12),
(277503, NULL, 'PIRSR601559-52', NULL, NULL, NULL, NULL, 'PIRSR601559-52', NULL, NULL, NULL, 12),
(277504, NULL, 'PIRSR005096-3', NULL, NULL, NULL, NULL, 'PIRSR005096-3', NULL, NULL, NULL, 12),
(277505, NULL, 'PIRSR001174-2', NULL, NULL, NULL, NULL, 'PIRSR001174-2', NULL, NULL, NULL, 12),
(277506, NULL, 'PIRSR000333-1', NULL, NULL, NULL, NULL, 'PIRSR000333-1', NULL, NULL, NULL, 12),
(277507, NULL, 'PIRSR001112-1', NULL, NULL, NULL, NULL, 'PIRSR001112-1', NULL, NULL, NULL, 12),
(277508, NULL, 'PIRSR606710-1', NULL, NULL, NULL, NULL, 'PIRSR606710-1', NULL, NULL, NULL, 12),
(277509, NULL, 'PIRSR001667-1', NULL, NULL, NULL, NULL, 'PIRSR001667-1', NULL, NULL, NULL, 12),
(277510, NULL, 'PIRSR001951-1', NULL, NULL, NULL, NULL, 'PIRSR001951-1', NULL, NULL, NULL, 12);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(277511, NULL, 'PIRSR634603-1', NULL, NULL, NULL, NULL, 'PIRSR634603-1', NULL, NULL, NULL, 12),
(277512, NULL, 'PIRSR000699-2', NULL, NULL, NULL, NULL, 'PIRSR000699-2', NULL, NULL, NULL, 12),
(277513, NULL, 'PIRSR002560-1', NULL, NULL, NULL, NULL, 'PIRSR002560-1', NULL, NULL, NULL, 12),
(277514, NULL, 'PIRSR015852-1', NULL, NULL, NULL, NULL, 'PIRSR015852-1', NULL, NULL, NULL, 12),
(277515, NULL, 'PIRSR016573-1', NULL, NULL, NULL, NULL, 'PIRSR016573-1', NULL, NULL, NULL, 12),
(277516, NULL, 'PIRSR000550-1', NULL, NULL, NULL, NULL, 'PIRSR000550-1', NULL, NULL, NULL, 12),
(277517, NULL, 'PIRSR001480-1', NULL, NULL, NULL, NULL, 'PIRSR001480-1', NULL, NULL, NULL, 12),
(277518, NULL, 'PIRSR037921-1', NULL, NULL, NULL, NULL, 'PIRSR037921-1', NULL, NULL, NULL, 12),
(277519, NULL, 'PIRSR037032-1', NULL, NULL, NULL, NULL, 'PIRSR037032-1', NULL, NULL, NULL, 12),
(277520, NULL, 'PIRSR603051-50', NULL, NULL, NULL, NULL, 'PIRSR603051-50', NULL, NULL, NULL, 12),
(277521, NULL, 'PIRSR000241-1', NULL, NULL, NULL, NULL, 'PIRSR000241-1', NULL, NULL, NULL, 12),
(277522, NULL, 'PIRSR018168-2', NULL, NULL, NULL, NULL, 'PIRSR018168-2', NULL, NULL, NULL, 12),
(277523, NULL, 'PIRSR037799-1', NULL, NULL, NULL, NULL, 'PIRSR037799-1', NULL, NULL, NULL, 12),
(277524, NULL, 'PIRSR002279-1', NULL, NULL, NULL, NULL, 'PIRSR002279-1', NULL, NULL, NULL, 12),
(277525, NULL, 'PIRSR633528-6', NULL, NULL, NULL, NULL, 'PIRSR633528-6', NULL, NULL, NULL, 12),
(277526, NULL, 'PIRSR037403-1', NULL, NULL, NULL, NULL, 'PIRSR037403-1', NULL, NULL, NULL, 12),
(277527, NULL, 'PIRSR037031-51', NULL, NULL, NULL, NULL, 'PIRSR037031-51', NULL, NULL, NULL, 12),
(277528, NULL, 'PIRSR605428-50', NULL, NULL, NULL, NULL, 'PIRSR605428-50', NULL, NULL, NULL, 12),
(277529, NULL, 'PIRSR037350-1', NULL, NULL, NULL, NULL, 'PIRSR037350-1', NULL, NULL, NULL, 12),
(277530, NULL, 'PIRSR001218-1', NULL, NULL, NULL, NULL, 'PIRSR001218-1', NULL, NULL, NULL, 12),
(277531, NULL, 'PIRSR000450-1', NULL, NULL, NULL, NULL, 'PIRSR000450-1', NULL, NULL, NULL, 12),
(277532, NULL, 'PIRSR609451-50', NULL, NULL, NULL, NULL, 'PIRSR609451-50', NULL, NULL, NULL, 12),
(277533, NULL, 'PIRSR000192-4', NULL, NULL, NULL, NULL, 'PIRSR000192-4', NULL, NULL, NULL, 12),
(277534, NULL, 'PIRSR015604-1', NULL, NULL, NULL, NULL, 'PIRSR015604-1', NULL, NULL, NULL, 12),
(277535, NULL, 'PIRSR002412-1', NULL, NULL, NULL, NULL, 'PIRSR002412-1', NULL, NULL, NULL, 12),
(277536, NULL, 'PIRSR006769-1', NULL, NULL, NULL, NULL, 'PIRSR006769-1', NULL, NULL, NULL, 12),
(277537, NULL, 'PIRSR000386-1', NULL, NULL, NULL, NULL, 'PIRSR000386-1', NULL, NULL, NULL, 12),
(277538, NULL, 'PIRSR037091-1', NULL, NULL, NULL, NULL, 'PIRSR037091-1', NULL, NULL, NULL, 12),
(277539, NULL, 'PIRSR038128-50', NULL, NULL, NULL, NULL, 'PIRSR038128-50', NULL, NULL, NULL, 12),
(277540, NULL, 'PIRSR028774-1', NULL, NULL, NULL, NULL, 'PIRSR028774-1', NULL, NULL, NULL, 12),
(277541, NULL, 'PIRSR015582-1', NULL, NULL, NULL, NULL, 'PIRSR015582-1', NULL, NULL, NULL, 12),
(277542, NULL, 'PIRSR000882-1', NULL, NULL, NULL, NULL, 'PIRSR000882-1', NULL, NULL, NULL, 12),
(277543, NULL, 'PIRSR031051-2', NULL, NULL, NULL, NULL, 'PIRSR031051-2', NULL, NULL, NULL, 12),
(277544, NULL, 'PIRSR007531-1', NULL, NULL, NULL, NULL, 'PIRSR007531-1', NULL, NULL, NULL, 12),
(277545, NULL, 'PIRSR022993-1', NULL, NULL, NULL, NULL, 'PIRSR022993-1', NULL, NULL, NULL, 12),
(277546, NULL, 'PIRSR019543-2', NULL, NULL, NULL, NULL, 'PIRSR019543-2', NULL, NULL, NULL, 12),
(277547, NULL, 'PIRSR000108-3', NULL, NULL, NULL, NULL, 'PIRSR000108-3', NULL, NULL, NULL, 12),
(277548, NULL, 'PIRSR037281-3', NULL, NULL, NULL, NULL, 'PIRSR037281-3', NULL, NULL, NULL, 12),
(277549, NULL, 'PIRSR001222-50', NULL, NULL, NULL, NULL, 'PIRSR001222-50', NULL, NULL, NULL, 12),
(277550, NULL, 'PIRSR604329-50', NULL, NULL, NULL, NULL, 'PIRSR604329-50', NULL, NULL, NULL, 12),
(277551, NULL, 'PIRSR001363-1', NULL, NULL, NULL, NULL, 'PIRSR001363-1', NULL, NULL, NULL, 12),
(277552, NULL, 'PIRSR634183-2', NULL, NULL, NULL, NULL, 'PIRSR634183-2', NULL, NULL, NULL, 12),
(277553, NULL, 'PIRSR000130-3', NULL, NULL, NULL, NULL, 'PIRSR000130-3', NULL, NULL, NULL, 12);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(277554, NULL, 'PIRSR001196-1', NULL, NULL, NULL, NULL, 'PIRSR001196-1', NULL, NULL, NULL, 12),
(277555, NULL, 'PIRSR001979-1', NULL, NULL, NULL, NULL, 'PIRSR001979-1', NULL, NULL, NULL, 12),
(277556, NULL, 'PIRSR003047-2', NULL, NULL, NULL, NULL, 'PIRSR003047-2', NULL, NULL, NULL, 12),
(277557, NULL, 'PIRSR001024-4', NULL, NULL, NULL, NULL, 'PIRSR001024-4', NULL, NULL, NULL, 12),
(277558, NULL, 'PIRSR033579-1', NULL, NULL, NULL, NULL, 'PIRSR033579-1', NULL, NULL, NULL, 12),
(277559, NULL, 'PIRSR000445-2', NULL, NULL, NULL, NULL, 'PIRSR000445-2', NULL, NULL, NULL, 12),
(277560, NULL, 'PIRSR617653-1', NULL, NULL, NULL, NULL, 'PIRSR617653-1', NULL, NULL, NULL, 12),
(277561, NULL, 'PIRSR000972-50', NULL, NULL, NULL, NULL, 'PIRSR000972-50', NULL, NULL, NULL, 12),
(277562, NULL, 'PIRSR600917-52', NULL, NULL, NULL, NULL, 'PIRSR600917-52', NULL, NULL, NULL, 12),
(277563, NULL, 'PIRSR036421-3', NULL, NULL, NULL, NULL, 'PIRSR036421-3', NULL, NULL, NULL, 12),
(277564, NULL, 'PIRSR039050-50', NULL, NULL, NULL, NULL, 'PIRSR039050-50', NULL, NULL, NULL, 12),
(277565, NULL, 'PIRSR629511-1', NULL, NULL, NULL, NULL, 'PIRSR629511-1', NULL, NULL, NULL, 12),
(277566, NULL, 'PIRSR617512-4', NULL, NULL, NULL, NULL, 'PIRSR617512-4', NULL, NULL, NULL, 12),
(277567, NULL, 'PIRSR634598-1', NULL, NULL, NULL, NULL, 'PIRSR634598-1', NULL, NULL, NULL, 12),
(277568, NULL, 'PIRSR001461-3', NULL, NULL, NULL, NULL, 'PIRSR001461-3', NULL, NULL, NULL, 12),
(277569, NULL, 'PIRSR604550-50', NULL, NULL, NULL, NULL, 'PIRSR604550-50', NULL, NULL, NULL, 12),
(277570, NULL, 'PIRSR000350-2', NULL, NULL, NULL, NULL, 'PIRSR000350-2', NULL, NULL, NULL, 12),
(277571, NULL, 'PIRSR002549-1', NULL, NULL, NULL, NULL, 'PIRSR002549-1', NULL, NULL, NULL, 12),
(277572, NULL, 'PIRSR627053-1', NULL, NULL, NULL, NULL, 'PIRSR627053-1', NULL, NULL, NULL, 12),
(277573, NULL, 'PIRSR000294-1', NULL, NULL, NULL, NULL, 'PIRSR000294-1', NULL, NULL, NULL, 12),
(277574, NULL, 'PIRSR006337-1', NULL, NULL, NULL, NULL, 'PIRSR006337-1', NULL, NULL, NULL, 12),
(277575, NULL, 'PIRSR009449-1', NULL, NULL, NULL, NULL, 'PIRSR009449-1', NULL, NULL, NULL, 12),
(277576, NULL, 'PIRSR036426-1', NULL, NULL, NULL, NULL, 'PIRSR036426-1', NULL, NULL, NULL, 12),
(277577, NULL, 'PIRSR609662-50', NULL, NULL, NULL, NULL, 'PIRSR609662-50', NULL, NULL, NULL, 12),
(277578, NULL, 'PIRSR038096-1', NULL, NULL, NULL, NULL, 'PIRSR038096-1', NULL, NULL, NULL, 12),
(277579, NULL, 'PIRSR000183-2', NULL, NULL, NULL, NULL, 'PIRSR000183-2', NULL, NULL, NULL, 12),
(277580, NULL, 'PIRSR011794-1', NULL, NULL, NULL, NULL, 'PIRSR011794-1', NULL, NULL, NULL, 12),
(277581, NULL, 'PIRSR036489-4', NULL, NULL, NULL, NULL, 'PIRSR036489-4', NULL, NULL, NULL, 12),
(277582, NULL, 'PIRSR005229-1', NULL, NULL, NULL, NULL, 'PIRSR005229-1', NULL, NULL, NULL, 12),
(277583, NULL, 'PIRSR000517-1', NULL, NULL, NULL, NULL, 'PIRSR000517-1', NULL, NULL, NULL, 12),
(277584, NULL, 'PIRSR000933-50', NULL, NULL, NULL, NULL, 'PIRSR000933-50', NULL, NULL, NULL, 12),
(277585, NULL, 'PIRSR037479-2', NULL, NULL, NULL, NULL, 'PIRSR037479-2', NULL, NULL, NULL, 12),
(277586, NULL, 'PIRSR015599-1', NULL, NULL, NULL, NULL, 'PIRSR015599-1', NULL, NULL, NULL, 12),
(277587, NULL, 'PIRSR037955-1', NULL, NULL, NULL, NULL, 'PIRSR037955-1', NULL, NULL, NULL, 12),
(277588, NULL, 'PIRSR011396-2', NULL, NULL, NULL, NULL, 'PIRSR011396-2', NULL, NULL, NULL, 12),
(277589, NULL, 'PIRSR032067-1', NULL, NULL, NULL, NULL, 'PIRSR032067-1', NULL, NULL, NULL, 12),
(277590, NULL, 'PIRSR006404-2', NULL, NULL, NULL, NULL, 'PIRSR006404-2', NULL, NULL, NULL, 12),
(277591, NULL, 'PIRSR602187-50', NULL, NULL, NULL, NULL, 'PIRSR602187-50', NULL, NULL, NULL, 12),
(277592, NULL, 'PIRSR000439-1', NULL, NULL, NULL, NULL, 'PIRSR000439-1', NULL, NULL, NULL, 12),
(277593, NULL, 'PIRSR028980-1', NULL, NULL, NULL, NULL, 'PIRSR028980-1', NULL, NULL, NULL, 12),
(277594, NULL, 'PIRSR027744-1', NULL, NULL, NULL, NULL, 'PIRSR027744-1', NULL, NULL, NULL, 12),
(277595, NULL, 'PIRSR000559-1', NULL, NULL, NULL, NULL, 'PIRSR000559-1', NULL, NULL, NULL, 12),
(277596, NULL, 'PIRSR016150-50', NULL, NULL, NULL, NULL, 'PIRSR016150-50', NULL, NULL, NULL, 12);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(277597, NULL, 'PIRSR037038-1', NULL, NULL, NULL, NULL, 'PIRSR037038-1', NULL, NULL, NULL, 12),
(277598, NULL, 'PIRSR001235-2', NULL, NULL, NULL, NULL, 'PIRSR001235-2', NULL, NULL, NULL, 12),
(277599, NULL, 'PIRSR001355-2', NULL, NULL, NULL, NULL, 'PIRSR001355-2', NULL, NULL, NULL, 12),
(277600, NULL, 'PIRSR622230-3', NULL, NULL, NULL, NULL, 'PIRSR622230-3', NULL, NULL, NULL, 12),
(277601, NULL, 'PIRSR500947-51', NULL, NULL, NULL, NULL, 'PIRSR500947-51', NULL, NULL, NULL, 12),
(277602, NULL, 'PIRSR600269-50', NULL, NULL, NULL, NULL, 'PIRSR600269-50', NULL, NULL, NULL, 12),
(277603, NULL, 'PIRSR000389-1', NULL, NULL, NULL, NULL, 'PIRSR000389-1', NULL, NULL, NULL, 12),
(277604, NULL, 'PIRSR036666-50', NULL, NULL, NULL, NULL, 'PIRSR036666-50', NULL, NULL, NULL, 12),
(277605, NULL, 'PIRSR000726-1', NULL, NULL, NULL, NULL, 'PIRSR000726-1', NULL, NULL, NULL, 12),
(277606, NULL, 'PIRSR037242-3', NULL, NULL, NULL, NULL, 'PIRSR037242-3', NULL, NULL, NULL, 12),
(277607, NULL, 'PIRSR001123-1', NULL, NULL, NULL, NULL, 'PIRSR001123-1', NULL, NULL, NULL, 12),
(277608, NULL, 'PIRSR038051-1', NULL, NULL, NULL, NULL, 'PIRSR038051-1', NULL, NULL, NULL, 12),
(277609, NULL, 'PIRSR017107-2', NULL, NULL, NULL, NULL, 'PIRSR017107-2', NULL, NULL, NULL, 12),
(277610, NULL, 'PIRSR001093-2', NULL, NULL, NULL, NULL, 'PIRSR001093-2', NULL, NULL, NULL, 12),
(277611, NULL, 'PIRSR001589-1', NULL, NULL, NULL, NULL, 'PIRSR001589-1', NULL, NULL, NULL, 12),
(277612, NULL, 'PIRSR000556-1', NULL, NULL, NULL, NULL, 'PIRSR000556-1', NULL, NULL, NULL, 12),
(277613, NULL, 'PIRSR006429-1', NULL, NULL, NULL, NULL, 'PIRSR006429-1', NULL, NULL, NULL, 12),
(277614, NULL, 'PIRSR000459-2', NULL, NULL, NULL, NULL, 'PIRSR000459-2', NULL, NULL, NULL, 12),
(277615, NULL, 'PIRSR038885-2', NULL, NULL, NULL, NULL, 'PIRSR038885-2', NULL, NULL, NULL, 12),
(277616, NULL, 'PIRSR000808-4', NULL, NULL, NULL, NULL, 'PIRSR000808-4', NULL, NULL, NULL, 12),
(277617, NULL, 'PIRSR036917-2', NULL, NULL, NULL, NULL, 'PIRSR036917-2', NULL, NULL, NULL, 12),
(277618, NULL, 'PIRSR037947-2', NULL, NULL, NULL, NULL, 'PIRSR037947-2', NULL, NULL, NULL, 12),
(277619, NULL, 'PIRSR629609-1', NULL, NULL, NULL, NULL, 'PIRSR629609-1', NULL, NULL, NULL, 12),
(277620, NULL, 'PIRSR634180-2', NULL, NULL, NULL, NULL, 'PIRSR634180-2', NULL, NULL, NULL, 12),
(277621, NULL, 'PIRSR629601-3', NULL, NULL, NULL, NULL, 'PIRSR629601-3', NULL, NULL, NULL, 12),
(277622, NULL, 'PIRSR000631-1', NULL, NULL, NULL, NULL, 'PIRSR000631-1', NULL, NULL, NULL, 12),
(277623, NULL, 'PIRSR017199-1', NULL, NULL, NULL, NULL, 'PIRSR017199-1', NULL, NULL, NULL, 12),
(277624, NULL, 'PIRSR028729-50', NULL, NULL, NULL, NULL, 'PIRSR028729-50', NULL, NULL, NULL, 12),
(277625, NULL, 'PIRSR500950-50', NULL, NULL, NULL, NULL, 'PIRSR500950-50', NULL, NULL, NULL, 12),
(277626, NULL, 'PIRSR000138-1', NULL, NULL, NULL, NULL, 'PIRSR000138-1', NULL, NULL, NULL, 12),
(277627, NULL, 'PIRSR000454-4', NULL, NULL, NULL, NULL, 'PIRSR000454-4', NULL, NULL, NULL, 12),
(277628, NULL, 'PIRSR001238-2', NULL, NULL, NULL, NULL, 'PIRSR001238-2', NULL, NULL, NULL, 12),
(277629, NULL, 'PIRSR001031-1', NULL, NULL, NULL, NULL, 'PIRSR001031-1', NULL, NULL, NULL, 12),
(277630, NULL, 'PIRSR607724-2', NULL, NULL, NULL, NULL, 'PIRSR607724-2', NULL, NULL, NULL, 12),
(277631, NULL, 'PIRSR629576-2', NULL, NULL, NULL, NULL, 'PIRSR629576-2', NULL, NULL, NULL, 12),
(277632, NULL, 'PIRSR000977-1', NULL, NULL, NULL, NULL, 'PIRSR000977-1', NULL, NULL, NULL, 12),
(277633, NULL, 'PIRSR001336-50', NULL, NULL, NULL, NULL, 'PIRSR001336-50', NULL, NULL, NULL, 12),
(277634, NULL, 'PIRSR001362-1', NULL, NULL, NULL, NULL, 'PIRSR001362-1', NULL, NULL, NULL, 12),
(277635, NULL, 'PIRSR500133-1', NULL, NULL, NULL, NULL, 'PIRSR500133-1', NULL, NULL, NULL, 12),
(277636, NULL, 'PIRSR017267-2', NULL, NULL, NULL, NULL, 'PIRSR017267-2', NULL, NULL, NULL, 12),
(277637, NULL, 'PIRSR600250-51', NULL, NULL, NULL, NULL, 'PIRSR600250-51', NULL, NULL, NULL, 12),
(277638, NULL, 'PIRSR618319-50', NULL, NULL, NULL, NULL, 'PIRSR618319-50', NULL, NULL, NULL, 12),
(277639, NULL, 'PIRSR029681-1', NULL, NULL, NULL, NULL, 'PIRSR029681-1', NULL, NULL, NULL, 12);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(277640, NULL, 'PIRSR600997-1', NULL, NULL, NULL, NULL, 'PIRSR600997-1', NULL, NULL, NULL, 12),
(277641, NULL, 'PIRSR016502-1', NULL, NULL, NULL, NULL, 'PIRSR016502-1', NULL, NULL, NULL, 12),
(277642, NULL, 'PIRSR000636-2', NULL, NULL, NULL, NULL, 'PIRSR000636-2', NULL, NULL, NULL, 12),
(277643, NULL, 'PIRSR013503-2', NULL, NULL, NULL, NULL, 'PIRSR013503-2', NULL, NULL, NULL, 12),
(277644, NULL, 'PIRSR016308-3', NULL, NULL, NULL, NULL, 'PIRSR016308-3', NULL, NULL, NULL, 12),
(277645, NULL, 'PIRSR016573-2', NULL, NULL, NULL, NULL, 'PIRSR016573-2', NULL, NULL, NULL, 12),
(277646, NULL, 'PIRSR631245-3', NULL, NULL, NULL, NULL, 'PIRSR631245-3', NULL, NULL, NULL, 12),
(277647, NULL, 'PIRSR002816-1', NULL, NULL, NULL, NULL, 'PIRSR002816-1', NULL, NULL, NULL, 12),
(277648, NULL, 'PIRSR617821-1', NULL, NULL, NULL, NULL, 'PIRSR617821-1', NULL, NULL, NULL, 12),
(277649, NULL, 'PIRSR036565-2', NULL, NULL, NULL, NULL, 'PIRSR036565-2', NULL, NULL, NULL, 12),
(277650, NULL, 'PIRSR620777-52', NULL, NULL, NULL, NULL, 'PIRSR620777-52', NULL, NULL, NULL, 12),
(277651, NULL, 'PIRSR037861-1', NULL, NULL, NULL, NULL, 'PIRSR037861-1', NULL, NULL, NULL, 12),
(277652, NULL, 'PIRSR000183-3', NULL, NULL, NULL, NULL, 'PIRSR000183-3', NULL, NULL, NULL, 12),
(277653, NULL, 'PIRSR000381-2', NULL, NULL, NULL, NULL, 'PIRSR000381-2', NULL, NULL, NULL, 12),
(277654, NULL, 'PIRSR015894-1', NULL, NULL, NULL, NULL, 'PIRSR015894-1', NULL, NULL, NULL, 12),
(277655, NULL, 'PIRSR037123-1', NULL, NULL, NULL, NULL, 'PIRSR037123-1', NULL, NULL, NULL, 12),
(277656, NULL, 'PIRSR601191-1', NULL, NULL, NULL, NULL, 'PIRSR601191-1', NULL, NULL, NULL, 12),
(277657, NULL, 'PIRSR623088-1', NULL, NULL, NULL, NULL, 'PIRSR623088-1', NULL, NULL, NULL, 12),
(277658, NULL, 'PIRSR601621-2', NULL, NULL, NULL, NULL, 'PIRSR601621-2', NULL, NULL, NULL, 12),
(277659, NULL, 'PIRSR607724-1', NULL, NULL, NULL, NULL, 'PIRSR607724-1', NULL, NULL, NULL, 12),
(277660, NULL, 'PIRSR037736-1', NULL, NULL, NULL, NULL, 'PIRSR037736-1', NULL, NULL, NULL, 12),
(277661, NULL, 'PIRSR633197-1', NULL, NULL, NULL, NULL, 'PIRSR633197-1', NULL, NULL, NULL, 12),
(277662, NULL, 'PIRSR037470-50', NULL, NULL, NULL, NULL, 'PIRSR037470-50', NULL, NULL, NULL, 12),
(277663, NULL, 'PIRSR001338-1', NULL, NULL, NULL, NULL, 'PIRSR001338-1', NULL, NULL, NULL, 12),
(277664, NULL, 'PIRSR037911-2', NULL, NULL, NULL, NULL, 'PIRSR037911-2', NULL, NULL, NULL, 12),
(277665, NULL, 'PIRSR000007-50', NULL, NULL, NULL, NULL, 'PIRSR000007-50', NULL, NULL, NULL, 12),
(277666, NULL, 'PIRSR037938-1', NULL, NULL, NULL, NULL, 'PIRSR037938-1', NULL, NULL, NULL, 12),
(277667, NULL, 'PIRSR000108-4', NULL, NULL, NULL, NULL, 'PIRSR000108-4', NULL, NULL, NULL, 12),
(277668, NULL, 'PIRSR004776-1', NULL, NULL, NULL, NULL, 'PIRSR004776-1', NULL, NULL, NULL, 12),
(277669, NULL, 'PIRSR000112-2', NULL, NULL, NULL, NULL, 'PIRSR000112-2', NULL, NULL, NULL, 12),
(277670, NULL, 'PIRSR000632-1', NULL, NULL, NULL, NULL, 'PIRSR000632-1', NULL, NULL, NULL, 12),
(277671, NULL, 'PIRSR000927-2', NULL, NULL, NULL, NULL, 'PIRSR000927-2', NULL, NULL, NULL, 12),
(277672, NULL, 'PIRSR640198-3', NULL, NULL, NULL, NULL, 'PIRSR640198-3', NULL, NULL, NULL, 12),
(277673, NULL, 'PIRSR000915-2', NULL, NULL, NULL, NULL, 'PIRSR000915-2', NULL, NULL, NULL, 12),
(277674, NULL, 'PIRSR001369-1', NULL, NULL, NULL, NULL, 'PIRSR001369-1', NULL, NULL, NULL, 12),
(277675, NULL, 'PIRSR001024-3', NULL, NULL, NULL, NULL, 'PIRSR001024-3', NULL, NULL, NULL, 12),
(277676, NULL, 'PIRSR009285-1', NULL, NULL, NULL, NULL, 'PIRSR009285-1', NULL, NULL, NULL, 12),
(277677, NULL, 'PIRSR000097-2', NULL, NULL, NULL, NULL, 'PIRSR000097-2', NULL, NULL, NULL, 12),
(277678, NULL, 'PIRSR601559-51', NULL, NULL, NULL, NULL, 'PIRSR601559-51', NULL, NULL, NULL, 12),
(277679, NULL, 'PIRSR038120-1', NULL, NULL, NULL, NULL, 'PIRSR038120-1', NULL, NULL, NULL, 12),
(277680, NULL, 'PIRSR002530-1', NULL, NULL, NULL, NULL, 'PIRSR002530-1', NULL, NULL, NULL, 12),
(277681, NULL, 'PIRSR038023-2', NULL, NULL, NULL, NULL, 'PIRSR038023-2', NULL, NULL, NULL, 12),
(277682, NULL, 'PIRSR000216-1', NULL, NULL, NULL, NULL, 'PIRSR000216-1', NULL, NULL, NULL, 12);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(277683, NULL, 'PIRSR000477-2', NULL, NULL, NULL, NULL, 'PIRSR000477-2', NULL, NULL, NULL, 12),
(277684, NULL, 'PIRSR600888-2', NULL, NULL, NULL, NULL, 'PIRSR600888-2', NULL, NULL, NULL, 12),
(277685, NULL, 'PIRSR037038-2', NULL, NULL, NULL, NULL, 'PIRSR037038-2', NULL, NULL, NULL, 12),
(277686, NULL, 'PIRSR001400-2', NULL, NULL, NULL, NULL, 'PIRSR001400-2', NULL, NULL, NULL, 12),
(277687, NULL, 'PIRSR037014-2', NULL, NULL, NULL, NULL, 'PIRSR037014-2', NULL, NULL, NULL, 12),
(277688, NULL, 'PIRSR617736-2', NULL, NULL, NULL, NULL, 'PIRSR617736-2', NULL, NULL, NULL, 12),
(277689, NULL, 'PIRSR601233-3', NULL, NULL, NULL, NULL, 'PIRSR601233-3', NULL, NULL, NULL, 12),
(277690, NULL, 'PIRSR001141-1', NULL, NULL, NULL, NULL, 'PIRSR001141-1', NULL, NULL, NULL, 12),
(277691, NULL, 'PIRSR017107-4', NULL, NULL, NULL, NULL, 'PIRSR017107-4', NULL, NULL, NULL, 12),
(277692, NULL, 'PIRSR003817-2', NULL, NULL, NULL, NULL, 'PIRSR003817-2', NULL, NULL, NULL, 12),
(277693, NULL, 'PIRSR000699-1', NULL, NULL, NULL, NULL, 'PIRSR000699-1', NULL, NULL, NULL, 12),
(277694, NULL, 'PIRSR000846-1', NULL, NULL, NULL, NULL, 'PIRSR000846-1', NULL, NULL, NULL, 12),
(277695, NULL, 'PIRSR629609-4', NULL, NULL, NULL, NULL, 'PIRSR629609-4', NULL, NULL, NULL, 12),
(277696, NULL, 'PIRSR009343-1', NULL, NULL, NULL, NULL, 'PIRSR009343-1', NULL, NULL, NULL, 12),
(277697, NULL, 'PIRSR000127-1', NULL, NULL, NULL, NULL, 'PIRSR000127-1', NULL, NULL, NULL, 12),
(277698, NULL, 'PIRSR039004-1', NULL, NULL, NULL, NULL, 'PIRSR039004-1', NULL, NULL, NULL, 12),
(277699, NULL, 'PIRSR037907-1', NULL, NULL, NULL, NULL, 'PIRSR037907-1', NULL, NULL, NULL, 12),
(277700, NULL, 'PIRSR629580-1', NULL, NULL, NULL, NULL, 'PIRSR629580-1', NULL, NULL, NULL, 12),
(277701, NULL, 'PIRSR036561-1', NULL, NULL, NULL, NULL, 'PIRSR036561-1', NULL, NULL, NULL, 12),
(277702, NULL, 'PIRSR001859-50', NULL, NULL, NULL, NULL, 'PIRSR001859-50', NULL, NULL, NULL, 12),
(277703, NULL, 'PIRSR039133-2', NULL, NULL, NULL, NULL, 'PIRSR039133-2', NULL, NULL, NULL, 12),
(277704, NULL, 'PIRSR629576-6', NULL, NULL, NULL, NULL, 'PIRSR629576-6', NULL, NULL, NULL, 12),
(277705, NULL, 'PIRSR003182-50', NULL, NULL, NULL, NULL, 'PIRSR003182-50', NULL, NULL, NULL, 12),
(277706, NULL, 'PIRSR000454-1', NULL, NULL, NULL, NULL, 'PIRSR000454-1', NULL, NULL, NULL, 12),
(277707, NULL, 'PIRSR000094-3', NULL, NULL, NULL, NULL, 'PIRSR000094-3', NULL, NULL, NULL, 12),
(277708, NULL, 'PIRSR006816-1', NULL, NULL, NULL, NULL, 'PIRSR006816-1', NULL, NULL, NULL, 12),
(277709, NULL, 'PIRSR627620-1', NULL, NULL, NULL, NULL, 'PIRSR627620-1', NULL, NULL, NULL, 12),
(277710, NULL, 'PIRSR037219-1', NULL, NULL, NULL, NULL, 'PIRSR037219-1', NULL, NULL, NULL, 12),
(277711, NULL, 'PIRSR627185-54', NULL, NULL, NULL, NULL, 'PIRSR627185-54', NULL, NULL, NULL, 12),
(277712, NULL, 'PIRSR002421-2', NULL, NULL, NULL, NULL, 'PIRSR002421-2', NULL, NULL, NULL, 12),
(277713, NULL, 'PIRSR004911-1', NULL, NULL, NULL, NULL, 'PIRSR004911-1', NULL, NULL, NULL, 12),
(277714, NULL, 'PIRSR017818-2', NULL, NULL, NULL, NULL, 'PIRSR017818-2', NULL, NULL, NULL, 12),
(277715, NULL, 'PIRSR625650-4', NULL, NULL, NULL, NULL, 'PIRSR625650-4', NULL, NULL, NULL, 12),
(277716, NULL, 'PIRSR000624-2', NULL, NULL, NULL, NULL, 'PIRSR000624-2', NULL, NULL, NULL, 12),
(277717, NULL, 'PIRSR605212-50', NULL, NULL, NULL, NULL, 'PIRSR605212-50', NULL, NULL, NULL, 12),
(277718, NULL, 'PIRSR617763-1', NULL, NULL, NULL, NULL, 'PIRSR617763-1', NULL, NULL, NULL, 12),
(277719, NULL, 'PIRSR006118-2', NULL, NULL, NULL, NULL, 'PIRSR006118-2', NULL, NULL, NULL, 12),
(277720, NULL, 'PIRSR000014-1', NULL, NULL, NULL, NULL, 'PIRSR000014-1', NULL, NULL, NULL, 12),
(277721, NULL, 'PIRSR001191-1', NULL, NULL, NULL, NULL, 'PIRSR001191-1', NULL, NULL, NULL, 12),
(277722, NULL, 'PIRSR620023-1', NULL, NULL, NULL, NULL, 'PIRSR620023-1', NULL, NULL, NULL, 12),
(277723, NULL, 'PIRSR000853-1', NULL, NULL, NULL, NULL, 'PIRSR000853-1', NULL, NULL, NULL, 12),
(277724, NULL, 'PIRSR037393-3', NULL, NULL, NULL, NULL, 'PIRSR037393-3', NULL, NULL, NULL, 12),
(277725, NULL, 'PIRSR500134-3', NULL, NULL, NULL, NULL, 'PIRSR500134-3', NULL, NULL, NULL, 12);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(277726, NULL, 'PIRSR630220-2', NULL, NULL, NULL, NULL, 'PIRSR630220-2', NULL, NULL, NULL, 12),
(277727, NULL, 'PIRSR036289-50', NULL, NULL, NULL, NULL, 'PIRSR036289-50', NULL, NULL, NULL, 12),
(277728, NULL, 'PIRSR009393-1', NULL, NULL, NULL, NULL, 'PIRSR009393-1', NULL, NULL, NULL, 12),
(277729, NULL, 'PIRSR016055-50', NULL, NULL, NULL, NULL, 'PIRSR016055-50', NULL, NULL, NULL, 12),
(277730, NULL, 'PIRSR001145-2', NULL, NULL, NULL, NULL, 'PIRSR001145-2', NULL, NULL, NULL, 12),
(277731, NULL, 'PIRSR629727-4', NULL, NULL, NULL, NULL, 'PIRSR629727-4', NULL, NULL, NULL, 12),
(277732, NULL, 'PIRSR002498-1', NULL, NULL, NULL, NULL, 'PIRSR002498-1', NULL, NULL, NULL, 12),
(277733, NULL, 'PIRSR600514-1', NULL, NULL, NULL, NULL, 'PIRSR600514-1', NULL, NULL, NULL, 12),
(277734, NULL, 'PIRSR600542-2', NULL, NULL, NULL, NULL, 'PIRSR600542-2', NULL, NULL, NULL, 12),
(277735, NULL, 'PIRSR038147-3', NULL, NULL, NULL, NULL, 'PIRSR038147-3', NULL, NULL, NULL, 12),
(277736, NULL, 'PIRSR001238-3', NULL, NULL, NULL, NULL, 'PIRSR001238-3', NULL, NULL, NULL, 12),
(277737, NULL, 'PIRSR000233-1', NULL, NULL, NULL, NULL, 'PIRSR000233-1', NULL, NULL, NULL, 12),
(277738, NULL, 'PIRSR621573-7', NULL, NULL, NULL, NULL, 'PIRSR621573-7', NULL, NULL, NULL, 12),
(277739, NULL, 'PIRSR000817-1', NULL, NULL, NULL, NULL, 'PIRSR000817-1', NULL, NULL, NULL, 12),
(277740, NULL, 'PIRSR002572-2', NULL, NULL, NULL, NULL, 'PIRSR002572-2', NULL, NULL, NULL, 12),
(277741, NULL, 'PIRSR026534-1', NULL, NULL, NULL, NULL, 'PIRSR026534-1', NULL, NULL, NULL, 12),
(277742, NULL, 'PIRSR038896-50', NULL, NULL, NULL, NULL, 'PIRSR038896-50', NULL, NULL, NULL, 12),
(277743, NULL, 'PIRSR604241-50', NULL, NULL, NULL, NULL, 'PIRSR604241-50', NULL, NULL, NULL, 12),
(277744, NULL, 'PIRSR038928-1', NULL, NULL, NULL, NULL, 'PIRSR038928-1', NULL, NULL, NULL, 12),
(277745, NULL, 'PIRSR000554-2', NULL, NULL, NULL, NULL, 'PIRSR000554-2', NULL, NULL, NULL, 12),
(277746, NULL, 'PIRSR001149-3', NULL, NULL, NULL, NULL, 'PIRSR001149-3', NULL, NULL, NULL, 12),
(277747, NULL, 'PIRSR000105-2', NULL, NULL, NULL, NULL, 'PIRSR000105-2', NULL, NULL, NULL, 12),
(277748, NULL, 'PIRSR000260-3', NULL, NULL, NULL, NULL, 'PIRSR000260-3', NULL, NULL, NULL, 12),
(277749, NULL, 'PIRSR017388-1', NULL, NULL, NULL, NULL, 'PIRSR017388-1', NULL, NULL, NULL, 12),
(277750, NULL, 'PIRSR022950-1', NULL, NULL, NULL, NULL, 'PIRSR022950-1', NULL, NULL, NULL, 12),
(277751, NULL, 'PIRSR628131-1', NULL, NULL, NULL, NULL, 'PIRSR628131-1', NULL, NULL, NULL, 12),
(277752, NULL, 'PIRSR000620-1', NULL, NULL, NULL, NULL, 'PIRSR000620-1', NULL, NULL, NULL, 12),
(277753, NULL, 'PIRSR009407-2', NULL, NULL, NULL, NULL, 'PIRSR009407-2', NULL, NULL, NULL, 12),
(277754, NULL, 'PIRSR016408-1', NULL, NULL, NULL, NULL, 'PIRSR016408-1', NULL, NULL, NULL, 12),
(277755, NULL, 'PIRSR037375-1', NULL, NULL, NULL, NULL, 'PIRSR037375-1', NULL, NULL, NULL, 12),
(277756, NULL, 'PIRSR000194-1', NULL, NULL, NULL, NULL, 'PIRSR000194-1', NULL, NULL, NULL, 12),
(277757, NULL, 'PIRSR000346-1', NULL, NULL, NULL, NULL, 'PIRSR000346-1', NULL, NULL, NULL, 12),
(277758, NULL, 'PIRSR038455-3', NULL, NULL, NULL, NULL, 'PIRSR038455-3', NULL, NULL, NULL, 12),
(277759, NULL, 'PIRSR000977-2', NULL, NULL, NULL, NULL, 'PIRSR000977-2', NULL, NULL, NULL, 12),
(277760, NULL, 'PIRSR006439-50', NULL, NULL, NULL, NULL, 'PIRSR006439-50', NULL, NULL, NULL, 12),
(277761, NULL, 'PIRSR500947-52', NULL, NULL, NULL, NULL, 'PIRSR500947-52', NULL, NULL, NULL, 12),
(277762, NULL, 'PIRSR001939-1', NULL, NULL, NULL, NULL, 'PIRSR001939-1', NULL, NULL, NULL, 12),
(277763, NULL, 'PIRSR037993-1', NULL, NULL, NULL, NULL, 'PIRSR037993-1', NULL, NULL, NULL, 12),
(277764, NULL, 'PIRSR038927-2', NULL, NULL, NULL, NULL, 'PIRSR038927-2', NULL, NULL, NULL, 12),
(277765, NULL, 'PIRSR000138-2', NULL, NULL, NULL, NULL, 'PIRSR000138-2', NULL, NULL, NULL, 12),
(277766, NULL, 'PIRSR036960-1', NULL, NULL, NULL, NULL, 'PIRSR036960-1', NULL, NULL, NULL, 12),
(277767, NULL, 'PIRSR002417-50', NULL, NULL, NULL, NULL, 'PIRSR002417-50', NULL, NULL, NULL, 12),
(277768, NULL, 'PIRSR016487-1', NULL, NULL, NULL, NULL, 'PIRSR016487-1', NULL, NULL, NULL, 12);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(277769, NULL, 'PIRSR011396-1', NULL, NULL, NULL, NULL, 'PIRSR011396-1', NULL, NULL, NULL, 12),
(277770, NULL, 'PIRSR029900-1', NULL, NULL, NULL, NULL, 'PIRSR029900-1', NULL, NULL, NULL, 12),
(277771, NULL, 'PIRSR629576-3', NULL, NULL, NULL, NULL, 'PIRSR629576-3', NULL, NULL, NULL, 12),
(277772, NULL, 'PIRSR036917-1', NULL, NULL, NULL, NULL, 'PIRSR036917-1', NULL, NULL, NULL, 12),
(277773, NULL, 'PIRSR629539-1', NULL, NULL, NULL, NULL, 'PIRSR629539-1', NULL, NULL, NULL, 12),
(277774, NULL, 'PIRSR006113-2', NULL, NULL, NULL, NULL, 'PIRSR006113-2', NULL, NULL, NULL, 12),
(277775, NULL, 'PIRSR000235-1', NULL, NULL, NULL, NULL, 'PIRSR000235-1', NULL, NULL, NULL, 12),
(277776, NULL, 'PIRSR000865-1', NULL, NULL, NULL, NULL, 'PIRSR000865-1', NULL, NULL, NULL, 12),
(277777, NULL, 'PIRSR000952-1', NULL, NULL, NULL, NULL, 'PIRSR000952-1', NULL, NULL, NULL, 12),
(277778, NULL, 'PIRSR034515-3', NULL, NULL, NULL, NULL, 'PIRSR034515-3', NULL, NULL, NULL, 12),
(277779, NULL, 'PIRSR037250-52', NULL, NULL, NULL, NULL, 'PIRSR037250-52', NULL, NULL, NULL, 12),
(277780, NULL, 'PIRSR627057-1', NULL, NULL, NULL, NULL, 'PIRSR627057-1', NULL, NULL, NULL, 12),
(277781, NULL, 'PIRSR037432-50', NULL, NULL, NULL, NULL, 'PIRSR037432-50', NULL, NULL, NULL, 12),
(277782, NULL, 'PIRSR000199-50', NULL, NULL, NULL, NULL, 'PIRSR000199-50', NULL, NULL, NULL, 12),
(277783, NULL, 'PIRSR001657-50', NULL, NULL, NULL, NULL, 'PIRSR001657-50', NULL, NULL, NULL, 12),
(277784, NULL, 'PIRSR500950-51', NULL, NULL, NULL, NULL, 'PIRSR500950-51', NULL, NULL, NULL, 12),
(277785, NULL, 'PIRSR634015-3', NULL, NULL, NULL, NULL, 'PIRSR634015-3', NULL, NULL, NULL, 12),
(277786, NULL, 'PIRSR634183-3', NULL, NULL, NULL, NULL, 'PIRSR634183-3', NULL, NULL, NULL, 12),
(277787, NULL, 'PIRSR001084-3', NULL, NULL, NULL, NULL, 'PIRSR001084-3', NULL, NULL, NULL, 12),
(277788, NULL, 'PIRSR038994-2', NULL, NULL, NULL, NULL, 'PIRSR038994-2', NULL, NULL, NULL, 12),
(277789, NULL, 'PIRSR500948-1', NULL, NULL, NULL, NULL, 'PIRSR500948-1', NULL, NULL, NULL, 12),
(277790, NULL, 'PIRSR000447-1', NULL, NULL, NULL, NULL, 'PIRSR000447-1', NULL, NULL, NULL, 12),
(277791, NULL, 'PIRSR001143-1', NULL, NULL, NULL, NULL, 'PIRSR001143-1', NULL, NULL, NULL, 12),
(277792, NULL, 'PIRSR016429-50', NULL, NULL, NULL, NULL, 'PIRSR016429-50', NULL, NULL, NULL, 12),
(277793, NULL, 'PIRSR629890-1', NULL, NULL, NULL, NULL, 'PIRSR629890-1', NULL, NULL, NULL, 12),
(277794, NULL, 'PIRSR634180-1', NULL, NULL, NULL, NULL, 'PIRSR634180-1', NULL, NULL, NULL, 12),
(277795, NULL, 'PIRSR000559-2', NULL, NULL, NULL, NULL, 'PIRSR000559-2', NULL, NULL, NULL, 12),
(277796, NULL, 'PIRSR006246-1', NULL, NULL, NULL, NULL, 'PIRSR006246-1', NULL, NULL, NULL, 12),
(277797, NULL, 'PIRSR007531-2', NULL, NULL, NULL, NULL, 'PIRSR007531-2', NULL, NULL, NULL, 12),
(277798, NULL, 'PIRSR017107-1', NULL, NULL, NULL, NULL, 'PIRSR017107-1', NULL, NULL, NULL, 12),
(277799, NULL, 'PIRSR629601-2', NULL, NULL, NULL, NULL, 'PIRSR629601-2', NULL, NULL, NULL, 12),
(277800, NULL, 'PIRSR004692-1', NULL, NULL, NULL, NULL, 'PIRSR004692-1', NULL, NULL, NULL, 12),
(277801, NULL, 'PIRSR029775-1', NULL, NULL, NULL, NULL, 'PIRSR029775-1', NULL, NULL, NULL, 12),
(277802, NULL, 'PIRSR009374-1', NULL, NULL, NULL, NULL, 'PIRSR009374-1', NULL, NULL, NULL, 12),
(277803, NULL, 'PIRSR605428-53', NULL, NULL, NULL, NULL, 'PIRSR605428-53', NULL, NULL, NULL, 12),
(277804, NULL, 'PIRSR004930-1', NULL, NULL, NULL, NULL, 'PIRSR004930-1', NULL, NULL, NULL, 12),
(277805, NULL, 'PIRSR002486-1', NULL, NULL, NULL, NULL, 'PIRSR002486-1', NULL, NULL, NULL, 12),
(277806, NULL, 'PIRSR637571-53', NULL, NULL, NULL, NULL, 'PIRSR637571-53', NULL, NULL, NULL, 12),
(277807, NULL, 'PIRSR002703-1', NULL, NULL, NULL, NULL, 'PIRSR002703-1', NULL, NULL, NULL, 12),
(277808, NULL, 'PIRSR002356-2', NULL, NULL, NULL, NULL, 'PIRSR002356-2', NULL, NULL, NULL, 12),
(277809, NULL, 'PIRSR000101-1', NULL, NULL, NULL, NULL, 'PIRSR000101-1', NULL, NULL, NULL, 12),
(277810, NULL, 'PIRSR006809-1', NULL, NULL, NULL, NULL, 'PIRSR006809-1', NULL, NULL, NULL, 12),
(277811, NULL, 'PIRSR603912-52', NULL, NULL, NULL, NULL, 'PIRSR603912-52', NULL, NULL, NULL, 12);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(277812, NULL, 'PIRSR001359-2', NULL, NULL, NULL, NULL, 'PIRSR001359-2', NULL, NULL, NULL, 12),
(277813, NULL, 'PIRSR037430-2', NULL, NULL, NULL, NULL, 'PIRSR037430-2', NULL, NULL, NULL, 12),
(277814, NULL, 'PIRSR036421-2', NULL, NULL, NULL, NULL, 'PIRSR036421-2', NULL, NULL, NULL, 12),
(277815, NULL, 'PIRSR000310-1', NULL, NULL, NULL, NULL, 'PIRSR000310-1', NULL, NULL, NULL, 12),
(277816, NULL, 'PIRSR004846-1', NULL, NULL, NULL, NULL, 'PIRSR004846-1', NULL, NULL, NULL, 12),
(277817, NULL, 'PIRSR622230-2', NULL, NULL, NULL, NULL, 'PIRSR622230-2', NULL, NULL, NULL, 12),
(277818, NULL, 'PIRSR627185-51', NULL, NULL, NULL, NULL, 'PIRSR627185-51', NULL, NULL, NULL, 12),
(277819, NULL, 'PIRSR038189-1', NULL, NULL, NULL, NULL, 'PIRSR038189-1', NULL, NULL, NULL, 12),
(277820, NULL, 'PIRSR008129-2', NULL, NULL, NULL, NULL, 'PIRSR008129-2', NULL, NULL, NULL, 12),
(277821, NULL, 'PIRSR004848-1', NULL, NULL, NULL, NULL, 'PIRSR004848-1', NULL, NULL, NULL, 12),
(277822, NULL, 'PIRSR036958-1', NULL, NULL, NULL, NULL, 'PIRSR036958-1', NULL, NULL, NULL, 12),
(277823, NULL, 'PIRSR002756-1', NULL, NULL, NULL, NULL, 'PIRSR002756-1', NULL, NULL, NULL, 12),
(277824, NULL, 'PIRSR002431-1', NULL, NULL, NULL, NULL, 'PIRSR002431-1', NULL, NULL, NULL, 12),
(277825, NULL, 'PIRSR038073-2', NULL, NULL, NULL, NULL, 'PIRSR038073-2', NULL, NULL, NULL, 12),
(277826, NULL, 'PIRSR607702-2', NULL, NULL, NULL, NULL, 'PIRSR607702-2', NULL, NULL, NULL, 12),
(277827, NULL, 'PIRSR000168-1', NULL, NULL, NULL, NULL, 'PIRSR000168-1', NULL, NULL, NULL, 12),
(277828, NULL, 'PIRSR001492-1', NULL, NULL, NULL, NULL, 'PIRSR001492-1', NULL, NULL, NULL, 12),
(277829, NULL, 'PIRSR627179-50', NULL, NULL, NULL, NULL, 'PIRSR627179-50', NULL, NULL, NULL, 12),
(277830, NULL, 'PIRSR630564-2', NULL, NULL, NULL, NULL, 'PIRSR630564-2', NULL, NULL, NULL, 12),
(277831, NULL, 'PIRSR019543-1', NULL, NULL, NULL, NULL, 'PIRSR019543-1', NULL, NULL, NULL, 12),
(277832, NULL, 'PIRSR000524-50', NULL, NULL, NULL, NULL, 'PIRSR000524-50', NULL, NULL, NULL, 12),
(277833, NULL, 'PIRSR000605-50', NULL, NULL, NULL, NULL, 'PIRSR000605-50', NULL, NULL, NULL, 12),
(277834, NULL, 'PIRSR000009-1', NULL, NULL, NULL, NULL, 'PIRSR000009-1', NULL, NULL, NULL, 12),
(277835, NULL, 'PIRSR005713-1', NULL, NULL, NULL, NULL, 'PIRSR005713-1', NULL, NULL, NULL, 12),
(277836, NULL, 'PIRSR014972-1', NULL, NULL, NULL, NULL, 'PIRSR014972-1', NULL, NULL, NULL, 12),
(277837, NULL, 'PIRSR001594-2', NULL, NULL, NULL, NULL, 'PIRSR001594-2', NULL, NULL, NULL, 12),
(277838, NULL, 'PIRSR002551-2', NULL, NULL, NULL, NULL, 'PIRSR002551-2', NULL, NULL, NULL, 12),
(277839, NULL, 'PIRSR036894-2', NULL, NULL, NULL, NULL, 'PIRSR036894-2', NULL, NULL, NULL, 12),
(277840, NULL, 'PIRSR000242-2', NULL, NULL, NULL, NULL, 'PIRSR000242-2', NULL, NULL, NULL, 12),
(277841, NULL, 'PIRSR000294-2', NULL, NULL, NULL, NULL, 'PIRSR000294-2', NULL, NULL, NULL, 12),
(277842, NULL, 'PIRSR001558-2', NULL, NULL, NULL, NULL, 'PIRSR001558-2', NULL, NULL, NULL, 12),
(277843, NULL, 'PIRSR037210-1', NULL, NULL, NULL, NULL, 'PIRSR037210-1', NULL, NULL, NULL, 12),
(277844, NULL, 'PIRSR005557-1', NULL, NULL, NULL, NULL, 'PIRSR005557-1', NULL, NULL, NULL, 12),
(277845, NULL, 'PIRSR629727-1', NULL, NULL, NULL, NULL, 'PIRSR629727-1', NULL, NULL, NULL, 12),
(277846, NULL, 'PIRSR635711-51', NULL, NULL, NULL, NULL, 'PIRSR635711-51', NULL, NULL, NULL, 12),
(277847, NULL, 'PIRSR036636-51', NULL, NULL, NULL, NULL, 'PIRSR036636-51', NULL, NULL, NULL, 12),
(277848, NULL, 'PIRSR630056-2', NULL, NULL, NULL, NULL, 'PIRSR630056-2', NULL, NULL, NULL, 12),
(277849, NULL, 'PIRSR016567-52', NULL, NULL, NULL, NULL, 'PIRSR016567-52', NULL, NULL, NULL, 12),
(277850, NULL, 'PIRSR617774-2', NULL, NULL, NULL, NULL, 'PIRSR617774-2', NULL, NULL, NULL, 12),
(277851, NULL, 'PIRSR002811-1', NULL, NULL, NULL, NULL, 'PIRSR002811-1', NULL, NULL, NULL, 12),
(277852, NULL, 'PIRSR001174-1', NULL, NULL, NULL, NULL, 'PIRSR001174-1', NULL, NULL, NULL, 12),
(277853, NULL, 'PIRSR000331-2', NULL, NULL, NULL, NULL, 'PIRSR000331-2', NULL, NULL, NULL, 12),
(277854, NULL, 'PIRSR006019-2', NULL, NULL, NULL, NULL, 'PIRSR006019-2', NULL, NULL, NULL, 12);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(277855, NULL, 'PIRSR035805-1', NULL, NULL, NULL, NULL, 'PIRSR035805-1', NULL, NULL, NULL, 12),
(277856, NULL, 'PIRSR001238-50', NULL, NULL, NULL, NULL, 'PIRSR001238-50', NULL, NULL, NULL, 12),
(277857, NULL, 'PIRSR037575-1', NULL, NULL, NULL, NULL, 'PIRSR037575-1', NULL, NULL, NULL, 12),
(277858, NULL, 'PIRSR500951-3', NULL, NULL, NULL, NULL, 'PIRSR500951-3', NULL, NULL, NULL, 12),
(277859, NULL, 'PIRSR000130-4', NULL, NULL, NULL, NULL, 'PIRSR000130-4', NULL, NULL, NULL, 12),
(277860, NULL, 'PIRSR001589-3', NULL, NULL, NULL, NULL, 'PIRSR001589-3', NULL, NULL, NULL, 12),
(277861, NULL, 'PIRSR015693-50', NULL, NULL, NULL, NULL, 'PIRSR015693-50', NULL, NULL, NULL, 12),
(277862, NULL, 'PIRSR622314-2', NULL, NULL, NULL, NULL, 'PIRSR622314-2', NULL, NULL, NULL, 12),
(277863, NULL, 'PIRSR633478-1', NULL, NULL, NULL, NULL, 'PIRSR633478-1', NULL, NULL, NULL, 12),
(277864, NULL, 'PIRSR000398-1', NULL, NULL, NULL, NULL, 'PIRSR000398-1', NULL, NULL, NULL, 12),
(277865, NULL, 'PIRSR627086-1', NULL, NULL, NULL, NULL, 'PIRSR627086-1', NULL, NULL, NULL, 12),
(277866, NULL, 'PIRSR600239-50', NULL, NULL, NULL, NULL, 'PIRSR600239-50', NULL, NULL, NULL, 12),
(277867, NULL, 'PIRSR000929-2', NULL, NULL, NULL, NULL, 'PIRSR000929-2', NULL, NULL, NULL, 12),
(277868, NULL, 'PIRSR001355-1', NULL, NULL, NULL, NULL, 'PIRSR001355-1', NULL, NULL, NULL, 12),
(277869, NULL, 'PIRSR001220-2', NULL, NULL, NULL, NULL, 'PIRSR001220-2', NULL, NULL, NULL, 12),
(277870, NULL, 'PIRSR026389-4', NULL, NULL, NULL, NULL, 'PIRSR026389-4', NULL, NULL, NULL, 12),
(277871, NULL, 'PIRSR633144-2', NULL, NULL, NULL, NULL, 'PIRSR633144-2', NULL, NULL, NULL, 12),
(277872, NULL, 'PIRSR001123-2', NULL, NULL, NULL, NULL, 'PIRSR001123-2', NULL, NULL, NULL, 12),
(277873, NULL, 'PIRSR006470-1', NULL, NULL, NULL, NULL, 'PIRSR006470-1', NULL, NULL, NULL, 12),
(277874, NULL, 'PIRSR000114-3', NULL, NULL, NULL, NULL, 'PIRSR000114-3', NULL, NULL, NULL, 12),
(277875, NULL, 'PIRSR001220-1', NULL, NULL, NULL, NULL, 'PIRSR001220-1', NULL, NULL, NULL, 12),
(277876, NULL, 'PIRSR037875-50', NULL, NULL, NULL, NULL, 'PIRSR037875-50', NULL, NULL, NULL, 12),
(277877, NULL, 'PIRSR000303-1', NULL, NULL, NULL, NULL, 'PIRSR000303-1', NULL, NULL, NULL, 12),
(277878, NULL, 'PIRSR005461-1', NULL, NULL, NULL, NULL, 'PIRSR005461-1', NULL, NULL, NULL, 12),
(277879, NULL, 'PIRSR000114-2', NULL, NULL, NULL, NULL, 'PIRSR000114-2', NULL, NULL, NULL, 12),
(277880, NULL, 'PIRSR617512-3', NULL, NULL, NULL, NULL, 'PIRSR617512-3', NULL, NULL, NULL, 12),
(277881, NULL, 'PIRSR000109-3', NULL, NULL, NULL, NULL, 'PIRSR000109-3', NULL, NULL, NULL, 12),
(277882, NULL, 'PIRSR000472-52', NULL, NULL, NULL, NULL, 'PIRSR000472-52', NULL, NULL, NULL, 12),
(277883, NULL, 'PIRSR037031-50', NULL, NULL, NULL, NULL, 'PIRSR037031-50', NULL, NULL, NULL, 12),
(277884, NULL, 'PIRSR600990-51', NULL, NULL, NULL, NULL, 'PIRSR600990-51', NULL, NULL, NULL, 12),
(277885, NULL, 'PIRSR019574-1', NULL, NULL, NULL, NULL, 'PIRSR019574-1', NULL, NULL, NULL, 12),
(277886, NULL, 'PIRSR001103-1', NULL, NULL, NULL, NULL, 'PIRSR001103-1', NULL, NULL, NULL, 12),
(277887, NULL, 'PIRSR001415-4', NULL, NULL, NULL, NULL, 'PIRSR001415-4', NULL, NULL, NULL, 12),
(277888, NULL, 'PIRSR001600-50', NULL, NULL, NULL, NULL, 'PIRSR001600-50', NULL, NULL, NULL, 12),
(277889, NULL, 'PIRSR037880-1', NULL, NULL, NULL, NULL, 'PIRSR037880-1', NULL, NULL, NULL, 12),
(277890, NULL, 'PIRSR001100-1', NULL, NULL, NULL, NULL, 'PIRSR001100-1', NULL, NULL, NULL, 12),
(277891, NULL, 'PIRSR003726-1', NULL, NULL, NULL, NULL, 'PIRSR003726-1', NULL, NULL, NULL, 12),
(277892, NULL, 'PIRSR000106-3', NULL, NULL, NULL, NULL, 'PIRSR000106-3', NULL, NULL, NULL, 12),
(277893, NULL, 'PIRSR600877-51', NULL, NULL, NULL, NULL, 'PIRSR600877-51', NULL, NULL, NULL, 12),
(277894, NULL, 'PIRSR631098-50', NULL, NULL, NULL, NULL, 'PIRSR631098-50', NULL, NULL, NULL, 12),
(277895, NULL, 'PIRSR011502-2', NULL, NULL, NULL, NULL, 'PIRSR011502-2', NULL, NULL, NULL, 12),
(277896, NULL, 'PIRSR005023-1', NULL, NULL, NULL, NULL, 'PIRSR005023-1', NULL, NULL, NULL, 12),
(277897, NULL, 'PIRSR003726-2', NULL, NULL, NULL, NULL, 'PIRSR003726-2', NULL, NULL, NULL, 12);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(277898, NULL, 'PIRSR006769-2', NULL, NULL, NULL, NULL, 'PIRSR006769-2', NULL, NULL, NULL, 12),
(277899, NULL, 'PIRSR617653-3', NULL, NULL, NULL, NULL, 'PIRSR617653-3', NULL, NULL, NULL, 12),
(277900, NULL, 'PIRSR002551-1', NULL, NULL, NULL, NULL, 'PIRSR002551-1', NULL, NULL, NULL, 12),
(277901, NULL, 'PIRSR000278-1', NULL, NULL, NULL, NULL, 'PIRSR000278-1', NULL, NULL, NULL, 12),
(277902, NULL, 'PIRSR001399-2', NULL, NULL, NULL, NULL, 'PIRSR001399-2', NULL, NULL, NULL, 12),
(277903, NULL, 'PIRSR004682-1', NULL, NULL, NULL, NULL, 'PIRSR004682-1', NULL, NULL, NULL, 12),
(277904, NULL, 'PIRSR037933-1', NULL, NULL, NULL, NULL, 'PIRSR037933-1', NULL, NULL, NULL, 12),
(277905, NULL, 'PIRSR000858-1', NULL, NULL, NULL, NULL, 'PIRSR000858-1', NULL, NULL, NULL, 12),
(277906, NULL, 'PIRSR037177-2', NULL, NULL, NULL, NULL, 'PIRSR037177-2', NULL, NULL, NULL, 12),
(277907, NULL, 'PIRSR017205-2', NULL, NULL, NULL, NULL, 'PIRSR017205-2', NULL, NULL, NULL, 12),
(277908, NULL, 'PIRSR036441-51', NULL, NULL, NULL, NULL, 'PIRSR036441-51', NULL, NULL, NULL, 12),
(277909, NULL, 'PIRSR001028-1', NULL, NULL, NULL, NULL, 'PIRSR001028-1', NULL, NULL, NULL, 12),
(277910, NULL, 'PIRSR033579-2', NULL, NULL, NULL, NULL, 'PIRSR033579-2', NULL, NULL, NULL, 12),
(277911, NULL, 'PIRSR005465-1', NULL, NULL, NULL, NULL, 'PIRSR005465-1', NULL, NULL, NULL, 12),
(277912, NULL, 'PIRSR038186-2', NULL, NULL, NULL, NULL, 'PIRSR038186-2', NULL, NULL, NULL, 12),
(277913, NULL, 'PIRSR017340-1', NULL, NULL, NULL, NULL, 'PIRSR017340-1', NULL, NULL, NULL, 12),
(277914, NULL, 'PIRSR000019-1', NULL, NULL, NULL, NULL, 'PIRSR000019-1', NULL, NULL, NULL, 12),
(277915, NULL, 'PIRSR005992-1', NULL, NULL, NULL, NULL, 'PIRSR005992-1', NULL, NULL, NULL, 12),
(277916, NULL, 'PIRSR637571-50', NULL, NULL, NULL, NULL, 'PIRSR637571-50', NULL, NULL, NULL, 12),
(277917, NULL, 'PIRSR002395-1', NULL, NULL, NULL, NULL, 'PIRSR002395-1', NULL, NULL, NULL, 12),
(277918, NULL, 'PIRSR036874-50', NULL, NULL, NULL, NULL, 'PIRSR036874-50', NULL, NULL, NULL, 12),
(277919, NULL, 'PIRSR610300-51', NULL, NULL, NULL, NULL, 'PIRSR610300-51', NULL, NULL, NULL, 12),
(277920, NULL, 'PIRSR000130-1', NULL, NULL, NULL, NULL, 'PIRSR000130-1', NULL, NULL, NULL, 12),
(277921, NULL, 'PIRSR000631-3', NULL, NULL, NULL, NULL, 'PIRSR000631-3', NULL, NULL, NULL, 12),
(277922, NULL, 'PIRSR036685-2', NULL, NULL, NULL, NULL, 'PIRSR036685-2', NULL, NULL, NULL, 12),
(277923, NULL, 'PIRSR630564-1', NULL, NULL, NULL, NULL, 'PIRSR630564-1', NULL, NULL, NULL, 12),
(277924, NULL, 'PIRSR628707-2', NULL, NULL, NULL, NULL, 'PIRSR628707-2', NULL, NULL, NULL, 12),
(277925, NULL, 'PIRSR016262-3', NULL, NULL, NULL, NULL, 'PIRSR016262-3', NULL, NULL, NULL, 12),
(277926, NULL, 'PIRSR038189-2', NULL, NULL, NULL, NULL, 'PIRSR038189-2', NULL, NULL, NULL, 12),
(277927, NULL, 'PIRSR001227-1', NULL, NULL, NULL, NULL, 'PIRSR001227-1', NULL, NULL, NULL, 12),
(277928, NULL, 'PIRSR000617-2', NULL, NULL, NULL, NULL, 'PIRSR000617-2', NULL, NULL, NULL, 12),
(277929, NULL, 'PIRSR000047-2', NULL, NULL, NULL, NULL, 'PIRSR000047-2', NULL, NULL, NULL, 12),
(277930, NULL, 'PIRSR006223-50', NULL, NULL, NULL, NULL, 'PIRSR006223-50', NULL, NULL, NULL, 12),
(277931, NULL, 'PIRSR038193-2', NULL, NULL, NULL, NULL, 'PIRSR038193-2', NULL, NULL, NULL, 12),
(277932, NULL, 'PIRSR630297-2', NULL, NULL, NULL, NULL, 'PIRSR630297-2', NULL, NULL, NULL, 12),
(277933, NULL, 'PIRSR000661-50', NULL, NULL, NULL, NULL, 'PIRSR000661-50', NULL, NULL, NULL, 12),
(277934, NULL, 'PIRSR000188-2', NULL, NULL, NULL, NULL, 'PIRSR000188-2', NULL, NULL, NULL, 12),
(277935, NULL, 'PIRSR029792-1', NULL, NULL, NULL, NULL, 'PIRSR029792-1', NULL, NULL, NULL, 12),
(277936, NULL, 'PIRSR000705-3', NULL, NULL, NULL, NULL, 'PIRSR000705-3', NULL, NULL, NULL, 12),
(277937, NULL, 'PIRSR627173-50', NULL, NULL, NULL, NULL, 'PIRSR627173-50', NULL, NULL, NULL, 12),
(277938, NULL, 'PIRSR036917-4', NULL, NULL, NULL, NULL, 'PIRSR036917-4', NULL, NULL, NULL, 12),
(277939, NULL, 'PIRSR037281-1', NULL, NULL, NULL, NULL, 'PIRSR037281-1', NULL, NULL, NULL, 12),
(277940, NULL, 'PIRSR000362-2', NULL, NULL, NULL, NULL, 'PIRSR000362-2', NULL, NULL, NULL, 12);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(277941, NULL, 'PIRSR606710-2', NULL, NULL, NULL, NULL, 'PIRSR606710-2', NULL, NULL, NULL, 12),
(277942, NULL, 'PIRSR000108-1', NULL, NULL, NULL, NULL, 'PIRSR000108-1', NULL, NULL, NULL, 12),
(277943, NULL, 'PIRSR608127-53', NULL, NULL, NULL, NULL, 'PIRSR608127-53', NULL, NULL, NULL, 12),
(277944, NULL, 'PIRSR630056-3', NULL, NULL, NULL, NULL, 'PIRSR630056-3', NULL, NULL, NULL, 12),
(277945, NULL, 'PIRSR602506-51', NULL, NULL, NULL, NULL, 'PIRSR602506-51', NULL, NULL, NULL, 12),
(277946, NULL, 'PIRSR036684-3', NULL, NULL, NULL, NULL, 'PIRSR036684-3', NULL, NULL, NULL, 12),
(277947, NULL, 'PIRSR016323-2', NULL, NULL, NULL, NULL, 'PIRSR016323-2', NULL, NULL, NULL, 12),
(277948, NULL, 'PIRSR605428-52', NULL, NULL, NULL, NULL, 'PIRSR605428-52', NULL, NULL, NULL, 12),
(277949, NULL, 'PIRSR037921-2', NULL, NULL, NULL, NULL, 'PIRSR037921-2', NULL, NULL, NULL, 12),
(277950, NULL, 'PIRSR016496-2', NULL, NULL, NULL, NULL, 'PIRSR016496-2', NULL, NULL, NULL, 12),
(277951, NULL, 'PIRSR001355-4', NULL, NULL, NULL, NULL, 'PIRSR001355-4', NULL, NULL, NULL, 12),
(277952, NULL, 'PIRSR000099-2', NULL, NULL, NULL, NULL, 'PIRSR000099-2', NULL, NULL, NULL, 12),
(277953, NULL, 'PIRSR626945-1', NULL, NULL, NULL, NULL, 'PIRSR626945-1', NULL, NULL, NULL, 12),
(277954, NULL, 'PIRSR001341-4', NULL, NULL, NULL, NULL, 'PIRSR001341-4', NULL, NULL, NULL, 12),
(277955, NULL, 'PIRSR000196-1', NULL, NULL, NULL, NULL, 'PIRSR000196-1', NULL, NULL, NULL, 12),
(277956, NULL, 'PIRSR633508-3', NULL, NULL, NULL, NULL, 'PIRSR633508-3', NULL, NULL, NULL, 12),
(277957, NULL, 'PIRSR000189-1', NULL, NULL, NULL, NULL, 'PIRSR000189-1', NULL, NULL, NULL, 12),
(277958, NULL, 'PIRSR000706-2', NULL, NULL, NULL, NULL, 'PIRSR000706-2', NULL, NULL, NULL, 12),
(277959, NULL, 'PIRSR006268-1', NULL, NULL, NULL, NULL, 'PIRSR006268-1', NULL, NULL, NULL, 12),
(277960, NULL, 'PIRSR036767-51', NULL, NULL, NULL, NULL, 'PIRSR036767-51', NULL, NULL, NULL, 12),
(277961, NULL, 'PIRSR001992-1', NULL, NULL, NULL, NULL, 'PIRSR001992-1', NULL, NULL, NULL, 12),
(277962, NULL, 'PIRSR629881-4', NULL, NULL, NULL, NULL, 'PIRSR629881-4', NULL, NULL, NULL, 12),
(277963, NULL, 'PIRSR038945-1', NULL, NULL, NULL, NULL, 'PIRSR038945-1', NULL, NULL, NULL, 12),
(277964, NULL, 'PIRSR623237-2', NULL, NULL, NULL, NULL, 'PIRSR623237-2', NULL, NULL, NULL, 12),
(277965, NULL, 'PIRSR037479-4', NULL, NULL, NULL, NULL, 'PIRSR037479-4', NULL, NULL, NULL, 12),
(277966, NULL, 'PIRSR037913-3', NULL, NULL, NULL, NULL, 'PIRSR037913-3', NULL, NULL, NULL, 12),
(277967, NULL, 'PIRSR630294-2', NULL, NULL, NULL, NULL, 'PIRSR630294-2', NULL, NULL, NULL, 12),
(277968, NULL, 'PIRSR005091-3', NULL, NULL, NULL, NULL, 'PIRSR005091-3', NULL, NULL, NULL, 12),
(277969, NULL, 'PIRSR037125-1', NULL, NULL, NULL, NULL, 'PIRSR037125-1', NULL, NULL, NULL, 12),
(277970, NULL, 'PIRSR038172-2', NULL, NULL, NULL, NULL, 'PIRSR038172-2', NULL, NULL, NULL, 12),
(277971, NULL, 'PIRSR030150-2', NULL, NULL, NULL, NULL, 'PIRSR030150-2', NULL, NULL, NULL, 12),
(277972, NULL, 'PIRSR621116-50', NULL, NULL, NULL, NULL, 'PIRSR621116-50', NULL, NULL, NULL, 12),
(277973, NULL, 'PIRSR625650-1', NULL, NULL, NULL, NULL, 'PIRSR625650-1', NULL, NULL, NULL, 12),
(277974, NULL, 'PIRSR000384-1', NULL, NULL, NULL, NULL, 'PIRSR000384-1', NULL, NULL, NULL, 12),
(277975, NULL, 'PIRSR605977-50', NULL, NULL, NULL, NULL, 'PIRSR605977-50', NULL, NULL, NULL, 12),
(277976, NULL, 'PIRSR003059-2', NULL, NULL, NULL, NULL, 'PIRSR003059-2', NULL, NULL, NULL, 12),
(277977, NULL, 'PIRSR001415-1', NULL, NULL, NULL, NULL, 'PIRSR001415-1', NULL, NULL, NULL, 12),
(277978, NULL, 'PIRSR639901-1', NULL, NULL, NULL, NULL, 'PIRSR639901-1', NULL, NULL, NULL, 12),
(277979, NULL, 'PIRSR000018-50', NULL, NULL, NULL, NULL, 'PIRSR000018-50', NULL, NULL, NULL, 12),
(277980, NULL, 'PIRSR000452-1', NULL, NULL, NULL, NULL, 'PIRSR000452-1', NULL, NULL, NULL, 12),
(277981, NULL, 'PIRSR628391-3', NULL, NULL, NULL, NULL, 'PIRSR628391-3', NULL, NULL, NULL, 12),
(277982, NULL, 'PIRSR000429-2', NULL, NULL, NULL, NULL, 'PIRSR000429-2', NULL, NULL, NULL, 12),
(277983, NULL, 'PIRSR015853-1', NULL, NULL, NULL, NULL, 'PIRSR015853-1', NULL, NULL, NULL, 12);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(277984, NULL, 'PIRSR627053-3', NULL, NULL, NULL, NULL, 'PIRSR627053-3', NULL, NULL, NULL, 12),
(277985, NULL, 'PIRSR633697-1', NULL, NULL, NULL, NULL, 'PIRSR633697-1', NULL, NULL, NULL, 12),
(277986, NULL, 'PIRSR029163-50', NULL, NULL, NULL, NULL, 'PIRSR029163-50', NULL, NULL, NULL, 12),
(277987, NULL, 'PIRSR006325-1', NULL, NULL, NULL, NULL, 'PIRSR006325-1', NULL, NULL, NULL, 12),
(277988, NULL, 'PIRSR619502-2', NULL, NULL, NULL, NULL, 'PIRSR619502-2', NULL, NULL, NULL, 12),
(277989, NULL, 'PIRSR003170-2', NULL, NULL, NULL, NULL, 'PIRSR003170-2', NULL, NULL, NULL, 12),
(277990, NULL, 'PIRSR038084-1', NULL, NULL, NULL, NULL, 'PIRSR038084-1', NULL, NULL, NULL, 12),
(277991, NULL, 'PIRSR038134-1', NULL, NULL, NULL, NULL, 'PIRSR038134-1', NULL, NULL, NULL, 12),
(277992, NULL, 'PIRSR036417-1', NULL, NULL, NULL, NULL, 'PIRSR036417-1', NULL, NULL, NULL, 12),
(277993, NULL, 'PIRSR036503-50', NULL, NULL, NULL, NULL, 'PIRSR036503-50', NULL, NULL, NULL, 12),
(277994, NULL, 'PIRSR001138-1', NULL, NULL, NULL, NULL, 'PIRSR001138-1', NULL, NULL, NULL, 12),
(277995, NULL, 'PIRSR005378-2', NULL, NULL, NULL, NULL, 'PIRSR005378-2', NULL, NULL, NULL, 12),
(277996, NULL, 'PIRSR002356-1', NULL, NULL, NULL, NULL, 'PIRSR002356-1', NULL, NULL, NULL, 12),
(277997, NULL, 'PIRSR618044-1', NULL, NULL, NULL, NULL, 'PIRSR618044-1', NULL, NULL, NULL, 12),
(277998, NULL, 'PIRSR001205-2', NULL, NULL, NULL, NULL, 'PIRSR001205-2', NULL, NULL, NULL, 12),
(277999, NULL, 'PIRSR629580-4', NULL, NULL, NULL, NULL, 'PIRSR629580-4', NULL, NULL, NULL, 12),
(278000, NULL, 'PIRSR037238-1', NULL, NULL, NULL, NULL, 'PIRSR037238-1', NULL, NULL, NULL, 12),
(278001, NULL, 'PIRSR037599-4', NULL, NULL, NULL, NULL, 'PIRSR037599-4', NULL, NULL, NULL, 12),
(278002, NULL, 'PIRSR000445-4', NULL, NULL, NULL, NULL, 'PIRSR000445-4', NULL, NULL, NULL, 12),
(278003, NULL, 'PIRSR000376-2', NULL, NULL, NULL, NULL, 'PIRSR000376-2', NULL, NULL, NULL, 12),
(278004, NULL, 'PIRSR000660-2', NULL, NULL, NULL, NULL, 'PIRSR000660-2', NULL, NULL, NULL, 12),
(278005, NULL, 'PIRSR000105-1', NULL, NULL, NULL, NULL, 'PIRSR000105-1', NULL, NULL, NULL, 12),
(278006, NULL, 'PIRSR000167-2', NULL, NULL, NULL, NULL, 'PIRSR000167-2', NULL, NULL, NULL, 12),
(278007, NULL, 'PIRSR039026-1', NULL, NULL, NULL, NULL, 'PIRSR039026-1', NULL, NULL, NULL, 12),
(278008, NULL, 'PIRSR010354-51', NULL, NULL, NULL, NULL, 'PIRSR010354-51', NULL, NULL, NULL, 12),
(278009, NULL, 'PIRSR001461-1', NULL, NULL, NULL, NULL, 'PIRSR001461-1', NULL, NULL, NULL, 12),
(278010, NULL, 'PIRSR000008-2', NULL, NULL, NULL, NULL, 'PIRSR000008-2', NULL, NULL, NULL, 12),
(278011, NULL, 'PIRSR002006-1', NULL, NULL, NULL, NULL, 'PIRSR002006-1', NULL, NULL, NULL, 12),
(278012, NULL, 'PIRSR500135-1', NULL, NULL, NULL, NULL, 'PIRSR500135-1', NULL, NULL, NULL, 12),
(278013, NULL, 'PIRSR000355-2', NULL, NULL, NULL, NULL, 'PIRSR000355-2', NULL, NULL, NULL, 12),
(278014, NULL, 'PIRSR002520-1', NULL, NULL, NULL, NULL, 'PIRSR002520-1', NULL, NULL, NULL, 12),
(278015, NULL, 'PIRSR037847-1', NULL, NULL, NULL, NULL, 'PIRSR037847-1', NULL, NULL, NULL, 12),
(278016, NULL, 'PIRSR037217-1', NULL, NULL, NULL, NULL, 'PIRSR037217-1', NULL, NULL, NULL, 12),
(278017, NULL, 'PIRSR038165-50', NULL, NULL, NULL, NULL, 'PIRSR038165-50', NULL, NULL, NULL, 12),
(278018, NULL, 'PIRSR000409-1', NULL, NULL, NULL, NULL, 'PIRSR000409-1', NULL, NULL, NULL, 12),
(278019, NULL, 'PIRSR000894-1', NULL, NULL, NULL, NULL, 'PIRSR000894-1', NULL, NULL, NULL, 12),
(278020, NULL, 'PIRSR026389-1', NULL, NULL, NULL, NULL, 'PIRSR026389-1', NULL, NULL, NULL, 12),
(278021, NULL, 'PIRSR005054-1', NULL, NULL, NULL, NULL, 'PIRSR005054-1', NULL, NULL, NULL, 12),
(278022, NULL, 'PIRSR002004-1', NULL, NULL, NULL, NULL, 'PIRSR002004-1', NULL, NULL, NULL, 12),
(278023, NULL, 'PIRSR000552-1', NULL, NULL, NULL, NULL, 'PIRSR000552-1', NULL, NULL, NULL, 12),
(278024, NULL, 'PIRSR600407-2', NULL, NULL, NULL, NULL, 'PIRSR600407-2', NULL, NULL, NULL, 12),
(278025, NULL, 'PIRSR001640-50', NULL, NULL, NULL, NULL, 'PIRSR001640-50', NULL, NULL, NULL, 12),
(278026, NULL, 'PIRSR006779-1', NULL, NULL, NULL, NULL, 'PIRSR006779-1', NULL, NULL, NULL, 12);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(278027, NULL, 'PIRSR000014-2', NULL, NULL, NULL, NULL, 'PIRSR000014-2', NULL, NULL, NULL, 12),
(278028, NULL, 'PIRSR015753-1', NULL, NULL, NULL, NULL, 'PIRSR015753-1', NULL, NULL, NULL, 12),
(278029, NULL, 'PIRSR017205-1', NULL, NULL, NULL, NULL, 'PIRSR017205-1', NULL, NULL, NULL, 12),
(278030, NULL, 'PIRSR637571-51', NULL, NULL, NULL, NULL, 'PIRSR637571-51', NULL, NULL, NULL, 12),
(278031, NULL, 'PIRSR603437-50', NULL, NULL, NULL, NULL, 'PIRSR603437-50', NULL, NULL, NULL, 12),
(278032, NULL, 'PIRSR000047-1', NULL, NULL, NULL, NULL, 'PIRSR000047-1', NULL, NULL, NULL, 12),
(278033, NULL, 'PIRSR002498-2', NULL, NULL, NULL, NULL, 'PIRSR002498-2', NULL, NULL, NULL, 12),
(278034, NULL, 'PIRSR001941-1', NULL, NULL, NULL, NULL, 'PIRSR001941-1', NULL, NULL, NULL, 12),
(278035, NULL, 'PIRSR009407-3', NULL, NULL, NULL, NULL, 'PIRSR009407-3', NULL, NULL, NULL, 12),
(278036, NULL, 'PIRSR011502-1', NULL, NULL, NULL, NULL, 'PIRSR011502-1', NULL, NULL, NULL, 12),
(278037, NULL, 'PIRSR000853-2', NULL, NULL, NULL, NULL, 'PIRSR000853-2', NULL, NULL, NULL, 12),
(278038, NULL, 'PIRSR500134-2', NULL, NULL, NULL, NULL, 'PIRSR500134-2', NULL, NULL, NULL, 12),
(278039, NULL, 'PIRSR007828-1', NULL, NULL, NULL, NULL, 'PIRSR007828-1', NULL, NULL, NULL, 12),
(278040, NULL, 'PIRSR001500-1', NULL, NULL, NULL, NULL, 'PIRSR001500-1', NULL, NULL, NULL, 12),
(278041, NULL, 'PIRSR608734-50', NULL, NULL, NULL, NULL, 'PIRSR608734-50', NULL, NULL, NULL, 12),
(278042, NULL, 'PIRSR605792-51', NULL, NULL, NULL, NULL, 'PIRSR605792-51', NULL, NULL, NULL, 12),
(278043, NULL, 'PIRSR633865-1', NULL, NULL, NULL, NULL, 'PIRSR633865-1', NULL, NULL, NULL, 12),
(278044, NULL, 'PIRSR638639-51', NULL, NULL, NULL, NULL, 'PIRSR638639-51', NULL, NULL, NULL, 12),
(278045, NULL, 'PIRSR003048-2', NULL, NULL, NULL, NULL, 'PIRSR003048-2', NULL, NULL, NULL, 12),
(278046, NULL, 'PIRSR000463-1', NULL, NULL, NULL, NULL, 'PIRSR000463-1', NULL, NULL, NULL, 12),
(278047, NULL, 'PIRSR000103-2', NULL, NULL, NULL, NULL, 'PIRSR000103-2', NULL, NULL, NULL, 12),
(278048, NULL, 'PIRSR000190-1', NULL, NULL, NULL, NULL, 'PIRSR000190-1', NULL, NULL, NULL, 12),
(278049, NULL, 'PIRSR000451-1', NULL, NULL, NULL, NULL, 'PIRSR000451-1', NULL, NULL, NULL, 12),
(278050, NULL, 'PIRSR000724-1', NULL, NULL, NULL, NULL, 'PIRSR000724-1', NULL, NULL, NULL, 12),
(278051, NULL, 'PIRSR623612-1', NULL, NULL, NULL, NULL, 'PIRSR623612-1', NULL, NULL, NULL, 12),
(278052, NULL, 'PIRSR037177-3', NULL, NULL, NULL, NULL, 'PIRSR037177-3', NULL, NULL, NULL, 12),
(278053, NULL, 'PIRSR000077-4', NULL, NULL, NULL, NULL, 'PIRSR000077-4', NULL, NULL, NULL, 12),
(278054, NULL, 'PIRSR611166-50', NULL, NULL, NULL, NULL, 'PIRSR611166-50', NULL, NULL, NULL, 12),
(278055, NULL, 'PIRSR629881-1', NULL, NULL, NULL, NULL, 'PIRSR629881-1', NULL, NULL, NULL, 12),
(278056, NULL, 'PIRSR001013-1', NULL, NULL, NULL, NULL, 'PIRSR001013-1', NULL, NULL, NULL, 12),
(278057, NULL, 'PIRSR000977-3', NULL, NULL, NULL, NULL, 'PIRSR000977-3', NULL, NULL, NULL, 12),
(278058, NULL, 'PIRSR001373-3', NULL, NULL, NULL, NULL, 'PIRSR001373-3', NULL, NULL, NULL, 12),
(278059, NULL, 'PIRSR000390-2', NULL, NULL, NULL, NULL, 'PIRSR000390-2', NULL, NULL, NULL, 12),
(278060, NULL, 'PIRSR005378-1', NULL, NULL, NULL, NULL, 'PIRSR005378-1', NULL, NULL, NULL, 12),
(278061, NULL, 'PIRSR001935-1', NULL, NULL, NULL, NULL, 'PIRSR001935-1', NULL, NULL, NULL, 12),
(278062, NULL, 'PIRSR601681-50', NULL, NULL, NULL, NULL, 'PIRSR601681-50', NULL, NULL, NULL, 12),
(278063, NULL, 'PIRSR600823-2', NULL, NULL, NULL, NULL, 'PIRSR600823-2', NULL, NULL, NULL, 12),
(278064, NULL, 'PIRSR628391-1', NULL, NULL, NULL, NULL, 'PIRSR628391-1', NULL, NULL, NULL, 12),
(278065, NULL, 'PIRSR619502-1', NULL, NULL, NULL, NULL, 'PIRSR619502-1', NULL, NULL, NULL, 12),
(278066, NULL, 'PIRSR500951-1', NULL, NULL, NULL, NULL, 'PIRSR500951-1', NULL, NULL, NULL, 12),
(278067, NULL, 'PIRSR000087-50', NULL, NULL, NULL, NULL, 'PIRSR000087-50', NULL, NULL, NULL, 12),
(278068, NULL, 'PIRSR600243-1', NULL, NULL, NULL, NULL, 'PIRSR600243-1', NULL, NULL, NULL, 12),
(278069, NULL, 'PIRSR018774-1', NULL, NULL, NULL, NULL, 'PIRSR018774-1', NULL, NULL, NULL, 12);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(278070, NULL, 'PIRSR617512-2', NULL, NULL, NULL, NULL, 'PIRSR617512-2', NULL, NULL, NULL, 12),
(278071, NULL, 'PIRSR621573-3', NULL, NULL, NULL, NULL, 'PIRSR621573-3', NULL, NULL, NULL, 12),
(278072, NULL, 'PIRSR001415-2', NULL, NULL, NULL, NULL, 'PIRSR001415-2', NULL, NULL, NULL, 12),
(278073, NULL, 'PIRSR000666-1', NULL, NULL, NULL, NULL, 'PIRSR000666-1', NULL, NULL, NULL, 12),
(278074, NULL, 'PIRSR038120-2', NULL, NULL, NULL, NULL, 'PIRSR038120-2', NULL, NULL, NULL, 12),
(278075, NULL, 'PIRSR600888-3', NULL, NULL, NULL, NULL, 'PIRSR600888-3', NULL, NULL, NULL, 12),
(278076, NULL, 'PIRSR608256-1', NULL, NULL, NULL, NULL, 'PIRSR608256-1', NULL, NULL, NULL, 12),
(278077, NULL, 'PIRSR625650-3', NULL, NULL, NULL, NULL, 'PIRSR625650-3', NULL, NULL, NULL, 12),
(278078, NULL, 'PIRSR006118-1', NULL, NULL, NULL, NULL, 'PIRSR006118-1', NULL, NULL, NULL, 12),
(278079, NULL, 'PIRSR038895-2', NULL, NULL, NULL, NULL, 'PIRSR038895-2', NULL, NULL, NULL, 12),
(278080, NULL, 'PIRSR000604-1', NULL, NULL, NULL, NULL, 'PIRSR000604-1', NULL, NULL, NULL, 12),
(278081, NULL, 'PIRSR017901-50', NULL, NULL, NULL, NULL, 'PIRSR017901-50', NULL, NULL, NULL, 12),
(278082, NULL, 'PIRSR001467-1', NULL, NULL, NULL, NULL, 'PIRSR001467-1', NULL, NULL, NULL, 12),
(278083, NULL, 'PIRSR005054-50', NULL, NULL, NULL, NULL, 'PIRSR005054-50', NULL, NULL, NULL, 12),
(278084, NULL, 'PIRSR016408-2', NULL, NULL, NULL, NULL, 'PIRSR016408-2', NULL, NULL, NULL, 12),
(278085, NULL, 'PIRSR029256-1', NULL, NULL, NULL, NULL, 'PIRSR029256-1', NULL, NULL, NULL, 12),
(278086, NULL, 'PIRSR631038-1', NULL, NULL, NULL, NULL, 'PIRSR631038-1', NULL, NULL, NULL, 12),
(278087, NULL, 'PIRSR038945-3', NULL, NULL, NULL, NULL, 'PIRSR038945-3', NULL, NULL, NULL, 12),
(278088, NULL, 'PIRSR000260-4', NULL, NULL, NULL, NULL, 'PIRSR000260-4', NULL, NULL, NULL, 12),
(278089, NULL, 'PIRSR002520-4', NULL, NULL, NULL, NULL, 'PIRSR002520-4', NULL, NULL, NULL, 12),
(278090, NULL, 'PIRSR605626-50', NULL, NULL, NULL, NULL, 'PIRSR605626-50', NULL, NULL, NULL, 12),
(278091, NULL, 'PIRSR620004-3', NULL, NULL, NULL, NULL, 'PIRSR620004-3', NULL, NULL, NULL, 12),
(278092, NULL, 'PIRSR006386-1', NULL, NULL, NULL, NULL, 'PIRSR006386-1', NULL, NULL, NULL, 12),
(278093, NULL, 'PIRSR000192-6', NULL, NULL, NULL, NULL, 'PIRSR000192-6', NULL, NULL, NULL, 12),
(278094, NULL, 'PIRSR036561-2', NULL, NULL, NULL, NULL, 'PIRSR036561-2', NULL, NULL, NULL, 12),
(278095, NULL, 'PIRSR607702-1', NULL, NULL, NULL, NULL, 'PIRSR607702-1', NULL, NULL, NULL, 12),
(278096, NULL, 'PIRSR000095-1', NULL, NULL, NULL, NULL, 'PIRSR000095-1', NULL, NULL, NULL, 12),
(278097, NULL, 'PIRSR000661-51', NULL, NULL, NULL, NULL, 'PIRSR000661-51', NULL, NULL, NULL, 12),
(278098, NULL, 'PIRSR002096-1', NULL, NULL, NULL, NULL, 'PIRSR002096-1', NULL, NULL, NULL, 12),
(278099, NULL, 'PIRSR038925-1', NULL, NULL, NULL, NULL, 'PIRSR038925-1', NULL, NULL, NULL, 12),
(278100, NULL, 'PIRSR629609-5', NULL, NULL, NULL, NULL, 'PIRSR629609-5', NULL, NULL, NULL, 12),
(278101, NULL, 'PIRSR001150-1', NULL, NULL, NULL, NULL, 'PIRSR001150-1', NULL, NULL, NULL, 12),
(278102, NULL, 'PIRSR037215-1', NULL, NULL, NULL, NULL, 'PIRSR037215-1', NULL, NULL, NULL, 12),
(278103, NULL, 'PIRSR000362-1', NULL, NULL, NULL, NULL, 'PIRSR000362-1', NULL, NULL, NULL, 12),
(278104, NULL, 'PIRSR028973-1', NULL, NULL, NULL, NULL, 'PIRSR028973-1', NULL, NULL, NULL, 12),
(278105, NULL, 'PIRSR600990-50', NULL, NULL, NULL, NULL, 'PIRSR600990-50', NULL, NULL, NULL, 12),
(278106, NULL, 'PIRSR006615-2', NULL, NULL, NULL, NULL, 'PIRSR006615-2', NULL, NULL, NULL, 12),
(278107, NULL, 'PIRSR017388-3', NULL, NULL, NULL, NULL, 'PIRSR017388-3', NULL, NULL, NULL, 12),
(278108, NULL, 'PIRSR037471-1', NULL, NULL, NULL, NULL, 'PIRSR037471-1', NULL, NULL, NULL, 12),
(278109, NULL, 'PIRSR000412-50', NULL, NULL, NULL, NULL, 'PIRSR000412-50', NULL, NULL, NULL, 12),
(278110, NULL, 'PIRSR038073-3', NULL, NULL, NULL, NULL, 'PIRSR038073-3', NULL, NULL, NULL, 12),
(278111, NULL, 'PIRSR000159-2', NULL, NULL, NULL, NULL, 'PIRSR000159-2', NULL, NULL, NULL, 12),
(278112, NULL, 'PIRSR036918-51', NULL, NULL, NULL, NULL, 'PIRSR036918-51', NULL, NULL, NULL, 12);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(278113, NULL, 'PIRSR005713-2', NULL, NULL, NULL, NULL, 'PIRSR005713-2', NULL, NULL, NULL, 12),
(278114, NULL, 'PIRSR601286-50', NULL, NULL, NULL, NULL, 'PIRSR601286-50', NULL, NULL, NULL, 12),
(278115, NULL, 'PIRSR009328-1', NULL, NULL, NULL, NULL, 'PIRSR009328-1', NULL, NULL, NULL, 12),
(278116, NULL, 'PIRSR600246-3', NULL, NULL, NULL, NULL, 'PIRSR600246-3', NULL, NULL, NULL, 12),
(278117, NULL, 'PIRSR621537-50', NULL, NULL, NULL, NULL, 'PIRSR621537-50', NULL, NULL, NULL, 12),
(278118, NULL, 'PIRSR017632-2', NULL, NULL, NULL, NULL, 'PIRSR017632-2', NULL, NULL, NULL, 12),
(278119, NULL, 'PIRSR000106-1', NULL, NULL, NULL, NULL, 'PIRSR000106-1', NULL, NULL, NULL, 12),
(278120, NULL, 'PIRSR001620-1', NULL, NULL, NULL, NULL, 'PIRSR001620-1', NULL, NULL, NULL, 12),
(278121, NULL, 'PIRSR038147-1', NULL, NULL, NULL, NULL, 'PIRSR038147-1', NULL, NULL, NULL, 12),
(278122, NULL, 'PIRSR000005-1', NULL, NULL, NULL, NULL, 'PIRSR000005-1', NULL, NULL, NULL, 12),
(278123, NULL, 'PIRSR037646-50', NULL, NULL, NULL, NULL, 'PIRSR037646-50', NULL, NULL, NULL, 12),
(278124, NULL, 'PIRSR001997-1', NULL, NULL, NULL, NULL, 'PIRSR001997-1', NULL, NULL, NULL, 12),
(278125, NULL, 'PIRSR634598-3', NULL, NULL, NULL, NULL, 'PIRSR634598-3', NULL, NULL, NULL, 12),
(278126, NULL, 'PIRSR006769-3', NULL, NULL, NULL, NULL, 'PIRSR006769-3', NULL, NULL, NULL, 12),
(278127, NULL, 'PIRSR003085-2', NULL, NULL, NULL, NULL, 'PIRSR003085-2', NULL, NULL, NULL, 12),
(278128, NULL, 'PIRSR000084-50', NULL, NULL, NULL, NULL, 'PIRSR000084-50', NULL, NULL, NULL, 12),
(278129, NULL, 'PIRSR000388-3', NULL, NULL, NULL, NULL, 'PIRSR000388-3', NULL, NULL, NULL, 12),
(278130, NULL, 'PIRSR006806-1', NULL, NULL, NULL, NULL, 'PIRSR006806-1', NULL, NULL, NULL, 12),
(278131, NULL, 'PIRSR002520-2', NULL, NULL, NULL, NULL, 'PIRSR002520-2', NULL, NULL, NULL, 12),
(278132, NULL, 'PIRSR037911-1', NULL, NULL, NULL, NULL, 'PIRSR037911-1', NULL, NULL, NULL, 12),
(278133, NULL, 'PIRSR016527-2', NULL, NULL, NULL, NULL, 'PIRSR016527-2', NULL, NULL, NULL, 12),
(278134, NULL, 'PIRSR628829-1', NULL, NULL, NULL, NULL, 'PIRSR628829-1', NULL, NULL, NULL, 12),
(278135, NULL, 'PIRSR000485-2', NULL, NULL, NULL, NULL, 'PIRSR000485-2', NULL, NULL, NULL, 12),
(278136, NULL, 'PIRSR000660-1', NULL, NULL, NULL, NULL, 'PIRSR000660-1', NULL, NULL, NULL, 12),
(278137, NULL, 'PIRSR500135-2', NULL, NULL, NULL, NULL, 'PIRSR500135-2', NULL, NULL, NULL, 12),
(278138, NULL, 'PIRSR000009-2', NULL, NULL, NULL, NULL, 'PIRSR000009-2', NULL, NULL, NULL, 12),
(278139, NULL, 'PIRSR006135-1', NULL, NULL, NULL, NULL, 'PIRSR006135-1', NULL, NULL, NULL, 12),
(278140, NULL, 'PIRSR000242-1', NULL, NULL, NULL, NULL, 'PIRSR000242-1', NULL, NULL, NULL, 12),
(278141, NULL, 'PIRSR006278-2', NULL, NULL, NULL, NULL, 'PIRSR006278-2', NULL, NULL, NULL, 12),
(278142, NULL, 'PIRSR004532-2', NULL, NULL, NULL, NULL, 'PIRSR004532-2', NULL, NULL, NULL, 12),
(278143, NULL, 'PIRSR038142-1', NULL, NULL, NULL, NULL, 'PIRSR038142-1', NULL, NULL, NULL, 12),
(278144, NULL, 'PIRSR627185-53', NULL, NULL, NULL, NULL, 'PIRSR627185-53', NULL, NULL, NULL, 12),
(278145, NULL, 'PIRSR001558-3', NULL, NULL, NULL, NULL, 'PIRSR001558-3', NULL, NULL, NULL, 12),
(278146, NULL, 'PIRSR004692-3', NULL, NULL, NULL, NULL, 'PIRSR004692-3', NULL, NULL, NULL, 12),
(278147, NULL, 'PIRSR005894-1', NULL, NULL, NULL, NULL, 'PIRSR005894-1', NULL, NULL, NULL, 12),
(278148, NULL, 'PIRSR036593-50', NULL, NULL, NULL, NULL, 'PIRSR036593-50', NULL, NULL, NULL, 12),
(278149, NULL, 'PIRSR601621-3', NULL, NULL, NULL, NULL, 'PIRSR601621-3', NULL, NULL, NULL, 12),
(278150, NULL, 'PIRSR000137-1', NULL, NULL, NULL, NULL, 'PIRSR000137-1', NULL, NULL, NULL, 12),
(278151, NULL, 'PIRSR001594-3', NULL, NULL, NULL, NULL, 'PIRSR001594-3', NULL, NULL, NULL, 12),
(278152, NULL, 'PIRSR037404-1', NULL, NULL, NULL, NULL, 'PIRSR037404-1', NULL, NULL, NULL, 12),
(278153, NULL, 'PIRSR036503-51', NULL, NULL, NULL, NULL, 'PIRSR036503-51', NULL, NULL, NULL, 12),
(278154, NULL, 'PIRSR039133-3', NULL, NULL, NULL, NULL, 'PIRSR039133-3', NULL, NULL, NULL, 12),
(278155, NULL, 'PIRSR627053-4', NULL, NULL, NULL, NULL, 'PIRSR627053-4', NULL, NULL, NULL, 12);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(278156, NULL, 'PIRSR037756-1', NULL, NULL, NULL, NULL, 'PIRSR037756-1', NULL, NULL, NULL, 12),
(278157, NULL, 'PIRSR038172-1', NULL, NULL, NULL, NULL, 'PIRSR038172-1', NULL, NULL, NULL, 12),
(278158, NULL, 'PIRSR000472-50', NULL, NULL, NULL, NULL, 'PIRSR000472-50', NULL, NULL, NULL, 12),
(278159, NULL, 'PIRSR004803-2', NULL, NULL, NULL, NULL, 'PIRSR004803-2', NULL, NULL, NULL, 12),
(278160, NULL, 'PIRSR026583-50', NULL, NULL, NULL, NULL, 'PIRSR026583-50', NULL, NULL, NULL, 12),
(278161, NULL, 'PIRSR630294-3', NULL, NULL, NULL, NULL, 'PIRSR630294-3', NULL, NULL, NULL, 12),
(278162, NULL, 'PIRSR016616-2', NULL, NULL, NULL, NULL, 'PIRSR016616-2', NULL, NULL, NULL, 12),
(278163, NULL, 'PIRSR018250-4', NULL, NULL, NULL, NULL, 'PIRSR018250-4', NULL, NULL, NULL, 12),
(278164, NULL, 'PIRSR001434-2', NULL, NULL, NULL, NULL, 'PIRSR001434-2', NULL, NULL, NULL, 12),
(278165, NULL, 'PIRSR034515-1', NULL, NULL, NULL, NULL, 'PIRSR034515-1', NULL, NULL, NULL, 12),
(278166, NULL, 'PIRSR630295-51', NULL, NULL, NULL, NULL, 'PIRSR630295-51', NULL, NULL, NULL, 12),
(278167, NULL, 'PIRSR037299-2', NULL, NULL, NULL, NULL, 'PIRSR037299-2', NULL, NULL, NULL, 12),
(278168, NULL, 'PIRSR601233-1', NULL, NULL, NULL, NULL, 'PIRSR601233-1', NULL, NULL, NULL, 12),
(278169, NULL, 'PIRSR036687-2', NULL, NULL, NULL, NULL, 'PIRSR036687-2', NULL, NULL, NULL, 12),
(278170, NULL, 'PIRSR000898-1', NULL, NULL, NULL, NULL, 'PIRSR000898-1', NULL, NULL, NULL, 12),
(278171, NULL, 'PIRSR001924-1', NULL, NULL, NULL, NULL, 'PIRSR001924-1', NULL, NULL, NULL, 12),
(278172, NULL, 'PIRSR016496-1', NULL, NULL, NULL, NULL, 'PIRSR016496-1', NULL, NULL, NULL, 12),
(278173, NULL, 'PIRSR036492-1', NULL, NULL, NULL, NULL, 'PIRSR036492-1', NULL, NULL, NULL, 12),
(278174, NULL, 'PIRSR000290-1', NULL, NULL, NULL, NULL, 'PIRSR000290-1', NULL, NULL, NULL, 12),
(278175, NULL, 'PIRSR000388-1', NULL, NULL, NULL, NULL, 'PIRSR000388-1', NULL, NULL, NULL, 12),
(278176, NULL, 'PIRSR037839-1', NULL, NULL, NULL, NULL, 'PIRSR037839-1', NULL, NULL, NULL, 12),
(278177, NULL, 'PIRSR005091-2', NULL, NULL, NULL, NULL, 'PIRSR005091-2', NULL, NULL, NULL, 12),
(278178, NULL, 'PIRSR620443-50', NULL, NULL, NULL, NULL, 'PIRSR620443-50', NULL, NULL, NULL, 12),
(278179, NULL, 'PIRSR629881-3', NULL, NULL, NULL, NULL, 'PIRSR629881-3', NULL, NULL, NULL, 12),
(278180, NULL, 'PIRSR631048-52', NULL, NULL, NULL, NULL, 'PIRSR631048-52', NULL, NULL, NULL, 12),
(278181, NULL, 'PIRSR029271-51', NULL, NULL, NULL, NULL, 'PIRSR029271-51', NULL, NULL, NULL, 12),
(278182, NULL, 'PIRSR037938-3', NULL, NULL, NULL, NULL, 'PIRSR037938-3', NULL, NULL, NULL, 12),
(278183, NULL, 'PIRSR000167-1', NULL, NULL, NULL, NULL, 'PIRSR000167-1', NULL, NULL, NULL, 12),
(278184, NULL, 'PIRSR633567-1', NULL, NULL, NULL, NULL, 'PIRSR633567-1', NULL, NULL, NULL, 12),
(278185, NULL, 'PIRSR000137-3', NULL, NULL, NULL, NULL, 'PIRSR000137-3', NULL, NULL, NULL, 12),
(278186, NULL, 'PIRSR000099-3', NULL, NULL, NULL, NULL, 'PIRSR000099-3', NULL, NULL, NULL, 12),
(278187, NULL, 'PIRSR000149-3', NULL, NULL, NULL, NULL, 'PIRSR000149-3', NULL, NULL, NULL, 12),
(278188, NULL, 'PIRSR005384-1', NULL, NULL, NULL, NULL, 'PIRSR005384-1', NULL, NULL, NULL, 12),
(278189, NULL, 'PIRSR629580-3', NULL, NULL, NULL, NULL, 'PIRSR629580-3', NULL, NULL, NULL, 12),
(278190, NULL, 'PIRSR633528-3', NULL, NULL, NULL, NULL, 'PIRSR633528-3', NULL, NULL, NULL, 12),
(278191, NULL, 'PIRSR000376-1', NULL, NULL, NULL, NULL, 'PIRSR000376-1', NULL, NULL, NULL, 12),
(278192, NULL, 'PIRSR604450-51', NULL, NULL, NULL, NULL, 'PIRSR604450-51', NULL, NULL, NULL, 12),
(278193, NULL, 'PIRSR001247-1', NULL, NULL, NULL, NULL, 'PIRSR001247-1', NULL, NULL, NULL, 12),
(278194, NULL, 'PIRSR000196-2', NULL, NULL, NULL, NULL, 'PIRSR000196-2', NULL, NULL, NULL, 12),
(278195, NULL, 'PIRSR000988-3', NULL, NULL, NULL, NULL, 'PIRSR000988-3', NULL, NULL, NULL, 12),
(278196, NULL, 'PIRSR017250-50', NULL, NULL, NULL, NULL, 'PIRSR017250-50', NULL, NULL, NULL, 12),
(278197, NULL, 'PIRSR003170-1', NULL, NULL, NULL, NULL, 'PIRSR003170-1', NULL, NULL, NULL, 12),
(278198, NULL, 'PIRSR018425-2', NULL, NULL, NULL, NULL, 'PIRSR018425-2', NULL, NULL, NULL, 12);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(278199, NULL, 'PIRSR038134-2', NULL, NULL, NULL, NULL, 'PIRSR038134-2', NULL, NULL, NULL, 12),
(278200, NULL, 'PIRSR639314-50', NULL, NULL, NULL, NULL, 'PIRSR639314-50', NULL, NULL, NULL, 12),
(278201, NULL, 'PIRSR000331-1', NULL, NULL, NULL, NULL, 'PIRSR000331-1', NULL, NULL, NULL, 12),
(278202, NULL, 'PIRSR000343-1', NULL, NULL, NULL, NULL, 'PIRSR000343-1', NULL, NULL, NULL, 12),
(278203, NULL, 'PIRSR028762-2', NULL, NULL, NULL, NULL, 'PIRSR028762-2', NULL, NULL, NULL, 12),
(278204, NULL, 'PIRSR002023-50', NULL, NULL, NULL, NULL, 'PIRSR002023-50', NULL, NULL, NULL, 12),
(278205, NULL, 'PIRSR608127-52', NULL, NULL, NULL, NULL, 'PIRSR608127-52', NULL, NULL, NULL, 12),
(278206, NULL, 'PIRSR628472-1', NULL, NULL, NULL, NULL, 'PIRSR628472-1', NULL, NULL, NULL, 12),
(278207, NULL, 'PIRSR633199-2', NULL, NULL, NULL, NULL, 'PIRSR633199-2', NULL, NULL, NULL, 12),
(278208, NULL, 'PIRSR617453-50', NULL, NULL, NULL, NULL, 'PIRSR617453-50', NULL, NULL, NULL, 12),
(278209, NULL, 'PIRSR601621-1', NULL, NULL, NULL, NULL, 'PIRSR601621-1', NULL, NULL, NULL, 12),
(278210, NULL, 'PIRSR000939-1', NULL, NULL, NULL, NULL, 'PIRSR000939-1', NULL, NULL, NULL, 12),
(278211, NULL, 'PIRSR000017-1', NULL, NULL, NULL, NULL, 'PIRSR000017-1', NULL, NULL, NULL, 12),
(278212, NULL, 'PIRSR000025-2', NULL, NULL, NULL, NULL, 'PIRSR000025-2', NULL, NULL, NULL, 12),
(278213, NULL, 'PIRSR630220-1', NULL, NULL, NULL, NULL, 'PIRSR630220-1', NULL, NULL, NULL, 12),
(278214, NULL, 'PIRSR620004-1', NULL, NULL, NULL, NULL, 'PIRSR620004-1', NULL, NULL, NULL, 12),
(278215, NULL, 'PIRSR618191-1', NULL, NULL, NULL, NULL, 'PIRSR618191-1', NULL, NULL, NULL, 12),
(278216, NULL, 'PIRSR000187-2', NULL, NULL, NULL, NULL, 'PIRSR000187-2', NULL, NULL, NULL, 12),
(278217, NULL, 'PIRSR011588-51', NULL, NULL, NULL, NULL, 'PIRSR011588-51', NULL, NULL, NULL, 12),
(278218, NULL, 'PIRSR605856-51', NULL, NULL, NULL, NULL, 'PIRSR605856-51', NULL, NULL, NULL, 12),
(278219, NULL, 'PIRSR017632-1', NULL, NULL, NULL, NULL, 'PIRSR017632-1', NULL, NULL, NULL, 12),
(278220, NULL, 'PIRSR000095-2', NULL, NULL, NULL, NULL, 'PIRSR000095-2', NULL, NULL, NULL, 12),
(278221, NULL, 'PIRSR001815-50', NULL, NULL, NULL, NULL, 'PIRSR001815-50', NULL, NULL, NULL, 12),
(278222, NULL, 'PIRSR002799-1', NULL, NULL, NULL, NULL, 'PIRSR002799-1', NULL, NULL, NULL, 12),
(278223, NULL, 'PIRSR036517-1', NULL, NULL, NULL, NULL, 'PIRSR036517-1', NULL, NULL, NULL, 12),
(278224, NULL, 'PIRSR600246-2', NULL, NULL, NULL, NULL, 'PIRSR600246-2', NULL, NULL, NULL, 12),
(278225, NULL, 'PIRSR000159-1', NULL, NULL, NULL, NULL, 'PIRSR000159-1', NULL, NULL, NULL, 12),
(278226, NULL, 'PIRSR018001-1', NULL, NULL, NULL, NULL, 'PIRSR018001-1', NULL, NULL, NULL, 12),
(278227, NULL, 'PIRSR001362-3', NULL, NULL, NULL, NULL, 'PIRSR001362-3', NULL, NULL, NULL, 12),
(278228, NULL, 'PIRSR000970-1', NULL, NULL, NULL, NULL, 'PIRSR000970-1', NULL, NULL, NULL, 12),
(278229, NULL, 'PIRSR001060-1', NULL, NULL, NULL, NULL, 'PIRSR001060-1', NULL, NULL, NULL, 12),
(278230, NULL, 'PIRSR627185-52', NULL, NULL, NULL, NULL, 'PIRSR627185-52', NULL, NULL, NULL, 12),
(278231, NULL, 'PIRSR004532-1', NULL, NULL, NULL, NULL, 'PIRSR004532-1', NULL, NULL, NULL, 12),
(278232, NULL, 'PIRSR015957-1', NULL, NULL, NULL, NULL, 'PIRSR015957-1', NULL, NULL, NULL, 12),
(278233, NULL, 'PIRSR610059-51', NULL, NULL, NULL, NULL, 'PIRSR610059-51', NULL, NULL, NULL, 12),
(278234, NULL, 'PIRSR015244-50', NULL, NULL, NULL, NULL, 'PIRSR015244-50', NULL, NULL, NULL, 12),
(278235, NULL, 'PIRSR016020-2', NULL, NULL, NULL, NULL, 'PIRSR016020-2', NULL, NULL, NULL, 12),
(278236, NULL, 'PIRSR000343-2', NULL, NULL, NULL, NULL, 'PIRSR000343-2', NULL, NULL, NULL, 12),
(278237, NULL, 'PIRSR000440-1', NULL, NULL, NULL, NULL, 'PIRSR000440-1', NULL, NULL, NULL, 12),
(278238, NULL, 'PIRSR631245-1', NULL, NULL, NULL, NULL, 'PIRSR631245-1', NULL, NULL, NULL, 12),
(278239, NULL, 'PIRSR633199-1', NULL, NULL, NULL, NULL, 'PIRSR633199-1', NULL, NULL, NULL, 12),
(278240, NULL, 'PIRSR001355-5', NULL, NULL, NULL, NULL, 'PIRSR001355-5', NULL, NULL, NULL, 12),
(278241, NULL, 'PIRSR002854-1', NULL, NULL, NULL, NULL, 'PIRSR002854-1', NULL, NULL, NULL, 12);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(278242, NULL, 'PIRSR629890-3', NULL, NULL, NULL, NULL, 'PIRSR629890-3', NULL, NULL, NULL, 12),
(278243, NULL, 'PIRSR021497-2', NULL, NULL, NULL, NULL, 'PIRSR021497-2', NULL, NULL, NULL, 12),
(278244, NULL, 'PIRSR016323-1', NULL, NULL, NULL, NULL, 'PIRSR016323-1', NULL, NULL, NULL, 12),
(278245, NULL, 'PIRSR621573-4', NULL, NULL, NULL, NULL, 'PIRSR621573-4', NULL, NULL, NULL, 12),
(278246, NULL, 'PIRSR000192-1', NULL, NULL, NULL, NULL, 'PIRSR000192-1', NULL, NULL, NULL, 12),
(278247, NULL, 'PIRSR630616-1', NULL, NULL, NULL, NULL, 'PIRSR630616-1', NULL, NULL, NULL, 12),
(278248, NULL, 'PIRSR633040-2', NULL, NULL, NULL, NULL, 'PIRSR633040-2', NULL, NULL, NULL, 12),
(278249, NULL, 'PIRSR627173-51', NULL, NULL, NULL, NULL, 'PIRSR627173-51', NULL, NULL, NULL, 12),
(278250, NULL, 'PIRSR000806-2', NULL, NULL, NULL, NULL, 'PIRSR000806-2', NULL, NULL, NULL, 12),
(278251, NULL, 'PIRSR008716-1', NULL, NULL, NULL, NULL, 'PIRSR008716-1', NULL, NULL, NULL, 12),
(278252, NULL, 'PIRSR627620-2', NULL, NULL, NULL, NULL, 'PIRSR627620-2', NULL, NULL, NULL, 12),
(278253, NULL, 'PIRSR000898-2', NULL, NULL, NULL, NULL, 'PIRSR000898-2', NULL, NULL, NULL, 12),
(278254, NULL, 'PIRSR038193-3', NULL, NULL, NULL, NULL, 'PIRSR038193-3', NULL, NULL, NULL, 12),
(278255, NULL, 'PIRSR629580-2', NULL, NULL, NULL, NULL, 'PIRSR629580-2', NULL, NULL, NULL, 12),
(278256, NULL, 'PIRSR036514-1', NULL, NULL, NULL, NULL, 'PIRSR036514-1', NULL, NULL, NULL, 12),
(278257, NULL, 'PIRSR001145-3', NULL, NULL, NULL, NULL, 'PIRSR001145-3', NULL, NULL, NULL, 12),
(278258, NULL, 'PIRSR009400-1', NULL, NULL, NULL, NULL, 'PIRSR009400-1', NULL, NULL, NULL, 12),
(278259, NULL, 'PIRSR039020-50', NULL, NULL, NULL, NULL, 'PIRSR039020-50', NULL, NULL, NULL, 12),
(278260, NULL, 'PIRSR000156-1', NULL, NULL, NULL, NULL, 'PIRSR000156-1', NULL, NULL, NULL, 12),
(278261, NULL, 'PIRSR000185-3', NULL, NULL, NULL, NULL, 'PIRSR000185-3', NULL, NULL, NULL, 12),
(278262, NULL, 'PIRSR602137-50', NULL, NULL, NULL, NULL, 'PIRSR602137-50', NULL, NULL, NULL, 12),
(278263, NULL, 'PIRSR000619-1', NULL, NULL, NULL, NULL, 'PIRSR000619-1', NULL, NULL, NULL, 12),
(278264, NULL, 'PIRSR001415-3', NULL, NULL, NULL, NULL, 'PIRSR001415-3', NULL, NULL, NULL, 12),
(278265, NULL, 'PIRSR620405-1', NULL, NULL, NULL, NULL, 'PIRSR620405-1', NULL, NULL, NULL, 12),
(278266, NULL, 'PIRSR000337-1', NULL, NULL, NULL, NULL, 'PIRSR000337-1', NULL, NULL, NULL, 12),
(278267, NULL, 'PIRSR037014-1', NULL, NULL, NULL, NULL, 'PIRSR037014-1', NULL, NULL, NULL, 12),
(278268, NULL, 'PIRSR000018-51', NULL, NULL, NULL, NULL, 'PIRSR000018-51', NULL, NULL, NULL, 12),
(278269, NULL, 'PIRSR001400-1', NULL, NULL, NULL, NULL, 'PIRSR001400-1', NULL, NULL, NULL, 12),
(278270, NULL, 'PIRSR001399-3', NULL, NULL, NULL, NULL, 'PIRSR001399-3', NULL, NULL, NULL, 12),
(278271, NULL, 'PIRSR037945-1', NULL, NULL, NULL, NULL, 'PIRSR037945-1', NULL, NULL, NULL, 12),
(278272, NULL, 'PIRSR000624-1', NULL, NULL, NULL, NULL, 'PIRSR000624-1', NULL, NULL, NULL, 12),
(278273, NULL, 'PIRSR000808-1', NULL, NULL, NULL, NULL, 'PIRSR000808-1', NULL, NULL, NULL, 12),
(278274, NULL, 'PIRSR000865-3', NULL, NULL, NULL, NULL, 'PIRSR000865-3', NULL, NULL, NULL, 12),
(278275, NULL, 'PIRSR036489-1', NULL, NULL, NULL, NULL, 'PIRSR036489-1', NULL, NULL, NULL, 12),
(278276, NULL, 'PIRSR037299-1', NULL, NULL, NULL, NULL, 'PIRSR037299-1', NULL, NULL, NULL, 12),
(278277, NULL, 'PIRSR005562-1', NULL, NULL, NULL, NULL, 'PIRSR005562-1', NULL, NULL, NULL, 12),
(278278, NULL, 'PIRSR627053-5', NULL, NULL, NULL, NULL, 'PIRSR627053-5', NULL, NULL, NULL, 12),
(278279, NULL, 'PIRSR000098-1', NULL, NULL, NULL, NULL, 'PIRSR000098-1', NULL, NULL, NULL, 12),
(278280, NULL, 'PIRSR001021-1', NULL, NULL, NULL, NULL, 'PIRSR001021-1', NULL, NULL, NULL, 12),
(278281, NULL, 'PIRSR633197-3', NULL, NULL, NULL, NULL, 'PIRSR633197-3', NULL, NULL, NULL, 12),
(278282, NULL, 'PIRSR001150-2', NULL, NULL, NULL, NULL, 'PIRSR001150-2', NULL, NULL, NULL, 12),
(278283, NULL, 'PIRSR037942-1', NULL, NULL, NULL, NULL, 'PIRSR037942-1', NULL, NULL, NULL, 12),
(278284, NULL, 'PIRSR005894-2', NULL, NULL, NULL, NULL, 'PIRSR005894-2', NULL, NULL, NULL, 12);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(278285, NULL, 'PIRSR006135-2', NULL, NULL, NULL, NULL, 'PIRSR006135-2', NULL, NULL, NULL, 12),
(278286, NULL, 'PIRSR629576-5', NULL, NULL, NULL, NULL, 'PIRSR629576-5', NULL, NULL, NULL, 12),
(278287, NULL, 'PIRSR000118-3', NULL, NULL, NULL, NULL, 'PIRSR000118-3', NULL, NULL, NULL, 12),
(278288, NULL, 'PIRSR000551-50', NULL, NULL, NULL, NULL, 'PIRSR000551-50', NULL, NULL, NULL, 12),
(278289, NULL, 'PIRSR006386-2', NULL, NULL, NULL, NULL, 'PIRSR006386-2', NULL, NULL, NULL, 12),
(278290, NULL, 'PIRSR630560-1', NULL, NULL, NULL, NULL, 'PIRSR630560-1', NULL, NULL, NULL, 12),
(278291, NULL, 'PIRSR038928-2', NULL, NULL, NULL, NULL, 'PIRSR038928-2', NULL, NULL, NULL, 12),
(278292, NULL, 'PIRSR036511-1', NULL, NULL, NULL, NULL, 'PIRSR036511-1', NULL, NULL, NULL, 12),
(278293, NULL, 'PIRSR001024-1', NULL, NULL, NULL, NULL, 'PIRSR001024-1', NULL, NULL, NULL, 12),
(278294, NULL, 'PIRSR619342-50', NULL, NULL, NULL, NULL, 'PIRSR619342-50', NULL, NULL, NULL, 12),
(278295, NULL, 'PIRSR000262-1', NULL, NULL, NULL, NULL, 'PIRSR000262-1', NULL, NULL, NULL, 12),
(278296, NULL, 'PIRSR016408-3', NULL, NULL, NULL, NULL, 'PIRSR016408-3', NULL, NULL, NULL, 12),
(278297, NULL, 'PIRSR000619-2', NULL, NULL, NULL, NULL, 'PIRSR000619-2', NULL, NULL, NULL, 12),
(278298, NULL, 'PIRSR001362-2', NULL, NULL, NULL, NULL, 'PIRSR001362-2', NULL, NULL, NULL, 12),
(278299, NULL, 'PIRSR637641-50', NULL, NULL, NULL, NULL, 'PIRSR637641-50', NULL, NULL, NULL, 12),
(278300, NULL, 'PIRSR000098-2', NULL, NULL, NULL, NULL, 'PIRSR000098-2', NULL, NULL, NULL, 12),
(278301, NULL, 'PIRSR018077-1', NULL, NULL, NULL, NULL, 'PIRSR018077-1', NULL, NULL, NULL, 12),
(278302, NULL, 'PIRSR000103-1', NULL, NULL, NULL, NULL, 'PIRSR000103-1', NULL, NULL, NULL, 12),
(278303, NULL, 'PIRSR036665-50', NULL, NULL, NULL, NULL, 'PIRSR036665-50', NULL, NULL, NULL, 12),
(278304, NULL, 'PIRSR605468-51', NULL, NULL, NULL, NULL, 'PIRSR605468-51', NULL, NULL, NULL, 12),
(278305, NULL, 'PIRSR000006-2', NULL, NULL, NULL, NULL, 'PIRSR000006-2', NULL, NULL, NULL, 12),
(278306, NULL, 'PIRSR628472-2', NULL, NULL, NULL, NULL, 'PIRSR628472-2', NULL, NULL, NULL, 12),
(278307, NULL, 'PIRSR000187-1', NULL, NULL, NULL, NULL, 'PIRSR000187-1', NULL, NULL, NULL, 12),
(278308, NULL, 'PIRSR016308-4', NULL, NULL, NULL, NULL, 'PIRSR016308-4', NULL, NULL, NULL, 12),
(278309, NULL, 'PIRSR000209-1', NULL, NULL, NULL, NULL, 'PIRSR000209-1', NULL, NULL, NULL, 12),
(278310, NULL, 'PIRSR036517-2', NULL, NULL, NULL, NULL, 'PIRSR036517-2', NULL, NULL, NULL, 12),
(278311, NULL, 'PIRSR000552-2', NULL, NULL, NULL, NULL, 'PIRSR000552-2', NULL, NULL, NULL, 12),
(278312, NULL, 'PIRSR009407-4', NULL, NULL, NULL, NULL, 'PIRSR009407-4', NULL, NULL, NULL, 12),
(278313, NULL, 'PIRSR017267-1', NULL, NULL, NULL, NULL, 'PIRSR017267-1', NULL, NULL, NULL, 12),
(278314, NULL, 'PIRSR036893-50', NULL, NULL, NULL, NULL, 'PIRSR036893-50', NULL, NULL, NULL, 12),
(278315, NULL, 'PIRSR002305-1', NULL, NULL, NULL, NULL, 'PIRSR002305-1', NULL, NULL, NULL, 12),
(278316, NULL, 'PIRSR031924-50', NULL, NULL, NULL, NULL, 'PIRSR031924-50', NULL, NULL, NULL, 12),
(278317, NULL, 'PIRSR014972-2', NULL, NULL, NULL, NULL, 'PIRSR014972-2', NULL, NULL, NULL, 12),
(278318, NULL, 'PIRSR620004-2', NULL, NULL, NULL, NULL, 'PIRSR620004-2', NULL, NULL, NULL, 12),
(278319, NULL, 'PIRSR001137-50', NULL, NULL, NULL, NULL, 'PIRSR001137-50', NULL, NULL, NULL, 12),
(278320, NULL, 'PIRSR600407-1', NULL, NULL, NULL, NULL, 'PIRSR600407-1', NULL, NULL, NULL, 12),
(278321, NULL, 'PIRSR016521-1', NULL, NULL, NULL, NULL, 'PIRSR016521-1', NULL, NULL, NULL, 12),
(278322, NULL, 'PIRSR640198-2', NULL, NULL, NULL, NULL, 'PIRSR640198-2', NULL, NULL, NULL, 12),
(278323, NULL, 'PIRSR000112-3', NULL, NULL, NULL, NULL, 'PIRSR000112-3', NULL, NULL, NULL, 12),
(278324, NULL, 'PIRSR016184-1', NULL, NULL, NULL, NULL, 'PIRSR016184-1', NULL, NULL, NULL, 12),
(278325, NULL, 'PIRSR000390-1', NULL, NULL, NULL, NULL, 'PIRSR000390-1', NULL, NULL, NULL, 12),
(278326, NULL, 'PIRSR629890-4', NULL, NULL, NULL, NULL, 'PIRSR629890-4', NULL, NULL, NULL, 12),
(278327, NULL, 'PIRSR639036-50', NULL, NULL, NULL, NULL, 'PIRSR639036-50', NULL, NULL, NULL, 12);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(278328, NULL, 'PIRSR018169-1', NULL, NULL, NULL, NULL, 'PIRSR018169-1', NULL, NULL, NULL, 12),
(278329, NULL, 'PIRSR009400-2', NULL, NULL, NULL, NULL, 'PIRSR009400-2', NULL, NULL, NULL, 12),
(278330, NULL, 'PIRSR000354-1', NULL, NULL, NULL, NULL, 'PIRSR000354-1', NULL, NULL, NULL, 12),
(278331, NULL, 'PIRSR037249-2', NULL, NULL, NULL, NULL, 'PIRSR037249-2', NULL, NULL, NULL, 12),
(278332, NULL, 'PIRSR001359-1', NULL, NULL, NULL, NULL, 'PIRSR001359-1', NULL, NULL, NULL, 12),
(278333, NULL, 'PIRSR001373-2', NULL, NULL, NULL, NULL, 'PIRSR001373-2', NULL, NULL, NULL, 12),
(278334, NULL, 'PIRSR000290-2', NULL, NULL, NULL, NULL, 'PIRSR000290-2', NULL, NULL, NULL, 12),
(278335, NULL, 'PIRSR017689-50', NULL, NULL, NULL, NULL, 'PIRSR017689-50', NULL, NULL, NULL, 12),
(278336, NULL, 'PIRSR601465-50', NULL, NULL, NULL, NULL, 'PIRSR601465-50', NULL, NULL, NULL, 12),
(278337, NULL, 'PIRSR017434-1', NULL, NULL, NULL, NULL, 'PIRSR017434-1', NULL, NULL, NULL, 12),
(278338, NULL, 'PIRSR037907-3', NULL, NULL, NULL, NULL, 'PIRSR037907-3', NULL, NULL, NULL, 12),
(278339, NULL, 'PIRSR009283-1', NULL, NULL, NULL, NULL, 'PIRSR009283-1', NULL, NULL, NULL, 12),
(278340, NULL, 'PIRSR600223-1', NULL, NULL, NULL, NULL, 'PIRSR600223-1', NULL, NULL, NULL, 12),
(278341, NULL, 'PIRSR000705-1', NULL, NULL, NULL, NULL, 'PIRSR000705-1', NULL, NULL, NULL, 12),
(278342, NULL, 'PIRSR000385-2', NULL, NULL, NULL, NULL, 'PIRSR000385-2', NULL, NULL, NULL, 12),
(278343, NULL, 'PIRSR600821-50', NULL, NULL, NULL, NULL, 'PIRSR600821-50', NULL, NULL, NULL, 12),
(278344, NULL, 'PIRSR614186-1', NULL, NULL, NULL, NULL, 'PIRSR614186-1', NULL, NULL, NULL, 12),
(278345, NULL, 'PIRSR620443-51', NULL, NULL, NULL, NULL, 'PIRSR620443-51', NULL, NULL, NULL, 12),
(278346, NULL, 'PIRSR003726-3', NULL, NULL, NULL, NULL, 'PIRSR003726-3', NULL, NULL, NULL, 12),
(278347, NULL, 'PIRSR004030-1', NULL, NULL, NULL, NULL, 'PIRSR004030-1', NULL, NULL, NULL, 12),
(278348, NULL, 'PIRSR003817-1', NULL, NULL, NULL, NULL, 'PIRSR003817-1', NULL, NULL, NULL, 12),
(278349, NULL, 'PIRSR005557-2', NULL, NULL, NULL, NULL, 'PIRSR005557-2', NULL, NULL, NULL, 12),
(278350, NULL, 'PIRSR000109-2', NULL, NULL, NULL, NULL, 'PIRSR000109-2', NULL, NULL, NULL, 12),
(278351, NULL, 'PIRSR000617-4', NULL, NULL, NULL, NULL, 'PIRSR000617-4', NULL, NULL, NULL, 12),
(278352, NULL, 'PIRSR631245-2', NULL, NULL, NULL, NULL, 'PIRSR631245-2', NULL, NULL, NULL, 12),
(278353, NULL, 'PIRSR005091-1', NULL, NULL, NULL, NULL, 'PIRSR005091-1', NULL, NULL, NULL, 12),
(278354, NULL, 'PIRSR037254-1', NULL, NULL, NULL, NULL, 'PIRSR037254-1', NULL, NULL, NULL, 12),
(278355, NULL, 'PIRSR002551-3', NULL, NULL, NULL, NULL, 'PIRSR002551-3', NULL, NULL, NULL, 12),
(278356, NULL, 'PIRSR000970-2', NULL, NULL, NULL, NULL, 'PIRSR000970-2', NULL, NULL, NULL, 12),
(278357, NULL, 'PIRSR000446-1', NULL, NULL, NULL, NULL, 'PIRSR000446-1', NULL, NULL, NULL, 12),
(278358, NULL, 'PIRSR000948-2', NULL, NULL, NULL, NULL, 'PIRSR000948-2', NULL, NULL, NULL, 12),
(278359, NULL, 'PIRSR036960-2', NULL, NULL, NULL, NULL, 'PIRSR036960-2', NULL, NULL, NULL, 12),
(278360, NULL, 'PIRSR037505-2', NULL, NULL, NULL, NULL, 'PIRSR037505-2', NULL, NULL, NULL, 12),
(278361, NULL, 'PIRSR604723-51', NULL, NULL, NULL, NULL, 'PIRSR604723-51', NULL, NULL, NULL, 12),
(278362, NULL, 'PIRSR037993-2', NULL, NULL, NULL, NULL, 'PIRSR037993-2', NULL, NULL, NULL, 12),
(278363, NULL, 'PIRSR037293-1', NULL, NULL, NULL, NULL, 'PIRSR037293-1', NULL, NULL, NULL, 12),
(278364, NULL, 'PIRSR000017-2', NULL, NULL, NULL, NULL, 'PIRSR000017-2', NULL, NULL, NULL, 12),
(278365, NULL, 'PIRSR633019-50', NULL, NULL, NULL, NULL, 'PIRSR633019-50', NULL, NULL, NULL, 12),
(278366, NULL, 'PIRSR628651-50', NULL, NULL, NULL, NULL, 'PIRSR628651-50', NULL, NULL, NULL, 12),
(278367, NULL, 'PIRSR019876-1', NULL, NULL, NULL, NULL, 'PIRSR019876-1', NULL, NULL, NULL, 12),
(278368, NULL, 'PIRSR000443-1', NULL, NULL, NULL, NULL, 'PIRSR000443-1', NULL, NULL, NULL, 12),
(278369, NULL, 'PIRSR000472-51', NULL, NULL, NULL, NULL, 'PIRSR000472-51', NULL, NULL, NULL, 12),
(278370, NULL, 'PIRSR018250-3', NULL, NULL, NULL, NULL, 'PIRSR018250-3', NULL, NULL, NULL, 12);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(278371, NULL, 'PIRSR633478-2', NULL, NULL, NULL, NULL, 'PIRSR633478-2', NULL, NULL, NULL, 12),
(278372, NULL, 'PIRSR633528-2', NULL, NULL, NULL, NULL, 'PIRSR633528-2', NULL, NULL, NULL, 12),
(278373, NULL, 'PIRSR000137-2', NULL, NULL, NULL, NULL, 'PIRSR000137-2', NULL, NULL, NULL, 12),
(278374, NULL, 'PIRSR004789-51', NULL, NULL, NULL, NULL, 'PIRSR004789-51', NULL, NULL, NULL, 12),
(278375, NULL, 'PIRSR633567-2', NULL, NULL, NULL, NULL, 'PIRSR633567-2', NULL, NULL, NULL, 12),
(278376, NULL, 'PIRSR000114-1', NULL, NULL, NULL, NULL, 'PIRSR000114-1', NULL, NULL, NULL, 12),
(278377, NULL, 'PIRSR002356-3', NULL, NULL, NULL, NULL, 'PIRSR002356-3', NULL, NULL, NULL, 12),
(278378, NULL, 'PIRSR608127-51', NULL, NULL, NULL, NULL, 'PIRSR608127-51', NULL, NULL, NULL, 12),
(278379, NULL, 'PIRSR018425-1', NULL, NULL, NULL, NULL, 'PIRSR018425-1', NULL, NULL, NULL, 12),
(278380, NULL, 'PIRSR000296-2', NULL, NULL, NULL, NULL, 'PIRSR000296-2', NULL, NULL, NULL, 12),
(278381, NULL, 'PIRSR000025-1', NULL, NULL, NULL, NULL, 'PIRSR000025-1', NULL, NULL, NULL, 12),
(278382, NULL, 'PIRSR038084-3', NULL, NULL, NULL, NULL, 'PIRSR038084-3', NULL, NULL, NULL, 12),
(278383, NULL, 'PIRSR600823-3', NULL, NULL, NULL, NULL, 'PIRSR600823-3', NULL, NULL, NULL, 12),
(278384, NULL, 'PIRSR001097-50', NULL, NULL, NULL, NULL, 'PIRSR001097-50', NULL, NULL, NULL, 12),
(278385, NULL, 'PIRSR000099-4', NULL, NULL, NULL, NULL, 'PIRSR000099-4', NULL, NULL, NULL, 12),
(278386, NULL, 'PIRSR000149-4', NULL, NULL, NULL, NULL, 'PIRSR000149-4', NULL, NULL, NULL, 12),
(278387, NULL, 'PIRSR028937-1', NULL, NULL, NULL, NULL, 'PIRSR028937-1', NULL, NULL, NULL, 12),
(278388, NULL, 'PIRSR006614-1', NULL, NULL, NULL, NULL, 'PIRSR006614-1', NULL, NULL, NULL, 12),
(278389, NULL, 'PIRSR004576-50', NULL, NULL, NULL, NULL, 'PIRSR004576-50', NULL, NULL, NULL, 12),
(278390, NULL, 'PIRSR036684-1', NULL, NULL, NULL, NULL, 'PIRSR036684-1', NULL, NULL, NULL, 12),
(278391, NULL, 'PIRSR629881-2', NULL, NULL, NULL, NULL, 'PIRSR629881-2', NULL, NULL, NULL, 12),
(278392, NULL, 'PIRSR000956-1', NULL, NULL, NULL, NULL, 'PIRSR000956-1', NULL, NULL, NULL, 12),
(278393, NULL, 'PIRSR037251-1', NULL, NULL, NULL, NULL, 'PIRSR037251-1', NULL, NULL, NULL, 12),
(278394, NULL, 'PIRSR000485-1', NULL, NULL, NULL, NULL, 'PIRSR000485-1', NULL, NULL, NULL, 12),
(278395, NULL, 'PIRSR036958-3', NULL, NULL, NULL, NULL, 'PIRSR036958-3', NULL, NULL, NULL, 12),
(278396, NULL, 'PIRSR037250-53', NULL, NULL, NULL, NULL, 'PIRSR037250-53', NULL, NULL, NULL, 12),
(278397, NULL, 'PIRSR005604-2', NULL, NULL, NULL, NULL, 'PIRSR005604-2', NULL, NULL, NULL, 12),
(278398, NULL, 'PIRSR638639-50', NULL, NULL, NULL, NULL, 'PIRSR638639-50', NULL, NULL, NULL, 12),
(278399, NULL, 'PIRSR633508-1', NULL, NULL, NULL, NULL, 'PIRSR633508-1', NULL, NULL, NULL, 12),
(278400, NULL, 'PIRSR000388-2', NULL, NULL, NULL, NULL, 'PIRSR000388-2', NULL, NULL, NULL, 12),
(278401, NULL, 'PIRSR003048-1', NULL, NULL, NULL, NULL, 'PIRSR003048-1', NULL, NULL, NULL, 12),
(278402, NULL, 'PIRSR630056-1', NULL, NULL, NULL, NULL, 'PIRSR630056-1', NULL, NULL, NULL, 12),
(278403, NULL, 'PIRSR016262-1', NULL, NULL, NULL, NULL, 'PIRSR016262-1', NULL, NULL, NULL, 12),
(278404, NULL, 'PIRSR016616-1', NULL, NULL, NULL, NULL, 'PIRSR016616-1', NULL, NULL, NULL, 12),
(278405, NULL, 'PR00316', NULL, NULL, 'Enterobacterial virulence outer membrane protein signature', NULL, 'ENTEROVIROMP', NULL, NULL, 6988, 13),
(278406, NULL, 'PR00148', NULL, NULL, 'Enolase signature', NULL, 'ENOLASE', NULL, NULL, 3263, 13),
(278407, NULL, 'PR00144', NULL, NULL, 'Delta-aminolevulinic acid dehydratase signature', NULL, 'DALDHYDRTASE', NULL, NULL, 3275, 13),
(278408, NULL, 'PR01852', NULL, NULL, 'Streptococcal non-M secreted SibA protein signature', NULL, 'SIBAPROTEIN', NULL, NULL, 10024, 13),
(278409, NULL, 'PR01749', NULL, NULL, 'Transcription factor AP-2 alpha signature', NULL, 'AP2ATNSCPFCT', NULL, NULL, 6184, 13),
(278410, NULL, 'PR00361', NULL, NULL, 'Calcitonin receptor signature', NULL, 'CALCITONINR', NULL, NULL, 3469, 13),
(278411, NULL, 'PR01984', NULL, NULL, 'Neurogenic locus Notch protein 1 signature', NULL, 'NOTCH1', NULL, NULL, 15693, 13);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(278412, NULL, 'PR01104', NULL, NULL, 'Anaphylatoxin chemotactic receptor signature', NULL, 'ANPHYLATOXNR', NULL, NULL, 5770, 13),
(278413, NULL, 'PR00843', NULL, NULL, 'Glycosyl hydrolase family 30 signature', NULL, 'GLHYDRLASE30', NULL, NULL, 1500, 13),
(278414, NULL, 'PR00152', NULL, NULL, 'RuBisCO small subunit signature', NULL, 'RUBISCOSMALL', NULL, NULL, 24793, 13),
(278415, NULL, 'PR02020', NULL, NULL, 'Aquaporin-8 signature', NULL, 'AQUAPORIN8', NULL, NULL, 17313, 13),
(278416, NULL, 'PR00506', NULL, NULL, 'D21 class N6 adenine-specific DNA methyltransferase signature', NULL, 'D21N6MTFRASE', NULL, NULL, 5791, 13),
(278417, NULL, 'PR01667', NULL, NULL, 'Voltage-gated Na+ channel alpha 8 subunit signature', NULL, 'NACHANNEL8', NULL, NULL, 5161, 13),
(278418, NULL, 'PR00060', NULL, NULL, 'Ribosomal protein L16 signature', NULL, 'RIBOSOMALL16', NULL, NULL, 2905, 13),
(278419, NULL, 'PR01918', NULL, NULL, 'Tumour necrosis factor receptor 1A signature', NULL, 'TNFACTORR1A', NULL, NULL, 20470, 13),
(278420, NULL, 'PR01270', NULL, NULL, 'Histone deacetylase superfamily signature', NULL, 'HDASUPER', NULL, NULL, 4811, 13),
(278421, NULL, 'PR02109', NULL, NULL, 'Mas-related G protein-coupled receptor A signature', NULL, 'MRGPCRA', NULL, NULL, 26853, 13),
(278422, NULL, 'PR01990', NULL, NULL, 'H-2 class II histocompatibility antigen gamma chain (CD74 antigen) signature', NULL, 'CD74ANTIGEN', NULL, NULL, 15699, 13),
(278423, NULL, 'PR01778', NULL, NULL, 'KIM-containing protein tyrosine phosphatase signature', NULL, 'KIMPTPASE', NULL, NULL, 7843, 13),
(278424, NULL, 'PR00717', NULL, NULL, 'GPCR kinase signature', NULL, 'GPCRKINASE', NULL, NULL, 735, 13),
(278425, NULL, 'PR01639', NULL, NULL, 'Mammal profilin signature', NULL, 'PROFILINMAML', NULL, NULL, 630, 13),
(278426, NULL, 'PR00725', NULL, NULL, 'D-Ala-D-Ala carboxypeptidase 1 (S11) family signature', NULL, 'DADACBPTASE1', NULL, NULL, 13867, 13),
(278427, NULL, 'PR01629', NULL, NULL, 'T-type voltage-dependent calcium channel alpha-1 subunit signature', NULL, 'TVDCCALPHA1', NULL, NULL, 390, 13),
(278428, NULL, 'PR00226', NULL, NULL, 'Geminivirus MSV 27kDa coat protein signature', NULL, 'GEMCOATMSV', NULL, NULL, 1566, 13),
(278429, NULL, 'PR00356', NULL, NULL, 'Type II antifreeze protein signature', NULL, 'ANTIFREEZEII', NULL, NULL, 6375, 13),
(278430, NULL, 'PR01178', NULL, NULL, 'Metabotropic gamma-aminobutyric acid type B2 receptor signature', NULL, 'GABAB2RECPTR', NULL, NULL, 5373, 13),
(278431, NULL, 'PR00018', NULL, NULL, 'Kringle domain signature', NULL, 'KRINGLE', NULL, NULL, NULL, 13),
(278432, NULL, 'PR00823', NULL, NULL, 'Pancreatic lipase signature', NULL, 'PANCLIPASE', NULL, NULL, 6069, 13),
(278433, NULL, 'PR01508', NULL, NULL, 'Kv1.1 voltage-gated K+ channel signature', NULL, 'KV11CHANNEL', NULL, NULL, 947, 13),
(278434, NULL, 'PR01444', NULL, NULL, 'Latrophilin receptor signature', NULL, 'LATROPHILIN', NULL, NULL, 6124, 13),
(278435, NULL, 'PR01229', NULL, NULL, 'Green fluorescent protein signature', NULL, 'GFLUORESCENT', NULL, NULL, 4554, 13),
(278436, NULL, 'PR02063', NULL, NULL, 'DNA damage checkpoint protein 1 signature', NULL, 'DNADAMAGECP1', NULL, NULL, 25825, 13),
(278437, NULL, 'PR01781', NULL, NULL, 'Linker for activation of T cells (LAT) signature', NULL, 'LATPROTEIN', NULL, NULL, 7734, 13),
(278438, NULL, 'PR00847', NULL, NULL, 'Bee venom hyaluronidase signature', NULL, 'HYALURONDASE', NULL, NULL, 384, 13),
(278439, NULL, 'PR01431', NULL, NULL, 'Tuberin signature', NULL, 'TUBERIN', NULL, NULL, 6425, 13),
(278440, NULL, 'PR00690', NULL, NULL, 'Adhesin family signature', NULL, 'ADHESNFAMILY', NULL, NULL, 10200, 13),
(278441, NULL, 'PR01119', NULL, NULL, 'CLC-K chloride channel family signature', NULL, 'CLCHANNELKDY', NULL, NULL, 5553, 13),
(278442, NULL, 'PR01500', NULL, NULL, 'Tropoelastin signature', NULL, 'TROPOELASTIN', NULL, NULL, NULL, 13),
(278443, NULL, 'PR00472', NULL, NULL, 'Casein kinase II regulatory subunit family signature', NULL, 'CASNKINASEII', NULL, NULL, 6522, 13),
(278444, NULL, 'PR00285', NULL, NULL, 'Scorpion toxin signature', NULL, 'SCORPNTOXIN', NULL, NULL, 17157, 13);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(278445, NULL, 'PR01535', NULL, NULL, 'Vomeronasal type 2 receptor family signature', NULL, 'VOMERONASL2R', NULL, NULL, 1564, 13),
(278446, NULL, 'PR00636', NULL, NULL, 'AT2 angiotensin II receptor signature', NULL, 'ANGIOTENSN2R', NULL, NULL, 1664, 13),
(278447, NULL, 'PR01596', NULL, NULL, 'Gram-negative bacterial type III secretion SycE chaperone signature', NULL, 'SYCECHAPRONE', NULL, NULL, 7073, 13),
(278448, NULL, 'PR00247', NULL, NULL, 'cAMP-type GPCR signature', NULL, 'GPCRCAMP', NULL, NULL, 4612, 13),
(278449, NULL, 'PR02057', NULL, NULL, 'Protein family FAM105B signature', NULL, 'PROTEINF105B', NULL, NULL, 15870, 13),
(278450, NULL, 'PR00786', NULL, NULL, 'Neprilysin metalloprotease (M13) family signature', NULL, 'NEPRILYSIN', NULL, NULL, 9470, 13),
(278451, NULL, 'PR01133', NULL, NULL, 'Gap junction alpha-3 protein signature', NULL, 'CONNEXINA3', NULL, NULL, 484, 13),
(278452, NULL, 'PR00702', NULL, NULL, 'Acriflavin resistance protein family signature', NULL, 'ACRIFLAVINRP', NULL, NULL, 2816, 13),
(278453, NULL, 'PR01003', NULL, NULL, 'Flagellar assembly protein FliH signature', NULL, 'FLGFLIH', NULL, NULL, 5764, 13),
(278454, NULL, 'PR01259', NULL, NULL, 'Na+/Ca2+ exchanger signature', NULL, 'NACAEXCHNGR', NULL, NULL, 4171, 13),
(278455, NULL, 'PR00991', NULL, NULL, '6-phosphofructo-2-kinase family signature', NULL, '6PFRUCTKNASE', NULL, NULL, 982, 13),
(278456, NULL, 'PR01677', NULL, NULL, 'Glycine receptor beta subunit signature', NULL, 'GLYRBETA', NULL, NULL, 5240, 13),
(278457, NULL, 'PR00405', NULL, NULL, 'HIV Rev interacting protein signature', NULL, 'REVINTRACTNG', NULL, NULL, 1120, 13),
(278458, NULL, 'PR01775', NULL, NULL, 'Bacterial glucose-fructose oxidoreductase signature', NULL, 'GLFROXRDTASE', NULL, NULL, 7686, 13),
(278459, NULL, 'PR00830', NULL, NULL, 'Endopeptidase La (Lon) serine protease (S16) signature', NULL, 'ENDOLAPTASE', NULL, NULL, NULL, 13),
(278460, NULL, 'PR00526', NULL, NULL, 'Formyl-methionyl peptide receptor signature', NULL, 'FMETLEUPHER', NULL, NULL, NULL, 13),
(278461, NULL, 'PR00781', NULL, NULL, 'Lipoprotein signal peptidase family (A8) signature', NULL, 'LIPOSIGPTASE', NULL, NULL, 4162, 13),
(278462, NULL, 'PR00320', NULL, NULL, 'G protein beta WD-40 repeat signature', NULL, 'GPROTEINBRPT', NULL, NULL, 19750, 13),
(278463, NULL, 'PR01000', NULL, NULL, 'Sterol regulatory element binding protein site 2 protease (M50) signature', NULL, 'SREBPS2PTASE', NULL, NULL, 1173, 13),
(278464, NULL, 'PR01583', NULL, NULL, 'Kv3.4 voltage-gated K+ channel signature', NULL, 'KV34CHANNEL', NULL, NULL, 7003, 13),
(278465, NULL, 'PR00206', NULL, NULL, 'Connexin signature', NULL, 'CONNEXIN', NULL, NULL, 6919, 13),
(278466, NULL, 'PR01329', NULL, NULL, 'Kir3.3 inward rectifier K+ channel signature', NULL, 'KIR33CHANNEL', NULL, NULL, 3331, 13),
(278467, NULL, 'PR00490', NULL, NULL, 'Secretin receptor signature', NULL, 'SECRETINR', NULL, NULL, 1003, 13),
(278468, NULL, 'PR01397', NULL, NULL, '2,3-dihydro-2,3-dihydroxybenzoate dehydrogenase signature', NULL, 'DHBDHDRGNASE', NULL, NULL, 117, 13),
(278469, NULL, 'PR01782', NULL, NULL, 'Mycobacterial cell entry (MCE) protein signature', NULL, 'MCEVIRFACTOR', NULL, NULL, 3621, 13),
(278470, NULL, 'PR01497', NULL, NULL, 'Shal voltage-gated K+ channel family signature', NULL, 'SHALCHANNEL', NULL, NULL, 7192, 13),
(278471, NULL, 'PR01017', NULL, NULL, 'Neuropeptide Y6 receptor signature', NULL, 'NRPEPTIDEY6R', NULL, NULL, 425, 13),
(278472, NULL, 'PR00009', NULL, NULL, 'Type I EGF signature', NULL, 'EGFTGF', NULL, NULL, NULL, 13),
(278473, NULL, 'PR00117', NULL, NULL, 'Barnase signature', NULL, 'BARNASE', NULL, NULL, 4247, 13),
(278474, NULL, 'PR00736', NULL, NULL, 'Glycosyl hydrolase family 15 signature', NULL, 'GLHYDRLASE15', NULL, NULL, 3536, 13),
(278475, NULL, 'PR00790', NULL, NULL, 'Peptidyl-glycine alpha-amidating monooxygenase signature', NULL, 'PAMONOXGNASE', NULL, NULL, 6946, 13),
(278476, NULL, 'PR00262', NULL, NULL, 'IL1/HBGF family signature', NULL, 'IL1HBGF', NULL, NULL, NULL, 13),
(278477, NULL, 'PR01313', NULL, NULL, 'P2X6 purinoceptor signature', NULL, 'P2X6RECEPTOR', NULL, NULL, 519, 13); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(278478, NULL, 'PR00454', NULL, NULL, 'ETS domain signature', NULL, 'ETSDOMAIN', NULL, NULL, 6517, 13),
(278479, NULL, 'PR00794', NULL, NULL, 'Pancreatic ribonuclease family signature', NULL, 'RIBONUCLEASE', NULL, NULL, 3396, 13),
(278480, NULL, 'PR00219', NULL, NULL, 'Synaptobrevin signature', NULL, 'SYNAPTOBREVN', NULL, NULL, 6773, 13),
(278481, NULL, 'PR00533', NULL, NULL, 'Mas oncogene signature', NULL, 'MASONCOGENE', NULL, NULL, 4640, 13),
(278482, NULL, 'PR01368', NULL, NULL, 'Synapsin signature', NULL, 'SYNAPSIN', NULL, NULL, 7358, 13),
(278483, NULL, 'PR00115', NULL, NULL, 'Fructose-1,6-bisphosphatase signature', NULL, 'F16BPHPHTASE', NULL, NULL, 22294, 13),
(278484, NULL, 'PR00276', NULL, NULL, 'Insulin family signature', NULL, 'INSULINFAMLY', NULL, NULL, 21289, 13),
(278485, NULL, 'PR00612', NULL, NULL, 'Alpha haemoglobin signature', NULL, 'ALPHAHAEM', NULL, NULL, 6121, 13),
(278486, NULL, 'PR00228', NULL, NULL, 'Geminivirus CLV AL1 coat protein signature', NULL, 'GEMCOATCLVL1', NULL, NULL, 284, 13),
(278487, NULL, 'PR00158', NULL, NULL, 'Rusticyanin signature', NULL, 'RUSTICYANIN', NULL, NULL, 563, 13),
(278488, NULL, 'PR01483', NULL, NULL, 'Fatty acid synthase signature', NULL, 'FASYNTHASE', NULL, NULL, 7371, 13),
(278489, NULL, 'PR00293', NULL, NULL, 'Squash serine protease inhibitor signature', NULL, 'SQUASHINHBTR', NULL, NULL, 6742, 13),
(278490, NULL, 'PR01170', NULL, NULL, 'Alcohol dehydrogenase related protein signature', NULL, 'ADHRELATED', NULL, NULL, 6818, 13),
(278491, NULL, 'PR01404', NULL, NULL, 'DATP pyrophosphohydrolase signature', NULL, 'NPPPHYDRLASE', NULL, NULL, 489, 13),
(278492, NULL, 'PR01938', NULL, NULL, 'Interleukin-34 signature', NULL, 'INTRLEUKIN34', NULL, NULL, 20277, 13),
(278493, NULL, 'PR01640', NULL, NULL, 'Plant profilin signature', NULL, 'PROFILINPLNT', NULL, NULL, 952, 13),
(278494, NULL, 'PR01055', NULL, NULL, 'Metabotropic glutamate receptor 5 signature', NULL, 'MTABOTROPC5R', NULL, NULL, 1476, 13),
(278495, NULL, 'PR00519', NULL, NULL, '5-hydroxytryptamine 5B receptor signature', NULL, '5HT5BRECEPTR', NULL, NULL, 6641, 13),
(278496, NULL, 'PR00750', NULL, NULL, 'Beta-amylase (glycosyl hydrolase family 14) signature', NULL, 'BETAAMYLASE', NULL, NULL, 5992, 13),
(278497, NULL, 'PR01147', NULL, NULL, 'GPR4 sphingosylphosphorylcholine and lysophosphatidylcholine receptor signature', NULL, 'GPR4RECEPTOR', NULL, NULL, 5946, 13),
(278498, NULL, 'PR00191', NULL, NULL, 'F-actin capping protein alpha subunit signature', NULL, 'FACTINCAPA', NULL, NULL, 143, 13),
(278499, NULL, 'PR01956', NULL, NULL, 'Tumour necrosis factor receptor 10 signature', NULL, 'TNFACTORR10', NULL, NULL, 18932, 13),
(278500, NULL, 'PR01635', NULL, NULL, 'Voltage-dependent L-type calcium channel alpha-1C subunit signature', NULL, 'LVDCCALPHA1C', NULL, NULL, 508, 13),
(278501, NULL, 'PR00039', NULL, NULL, 'LysR bacterial regulatory protein HTH signature', NULL, 'HTHLYSR', NULL, NULL, 221, 13),
(278502, NULL, 'PR01787', NULL, NULL, 'Paraoxonase 2 signature', NULL, 'PARAOXONASE2', NULL, NULL, 7835, 13),
(278503, NULL, 'PR01173', NULL, NULL, 'Odour binding protein signature', NULL, 'ODORANTBNDNG', NULL, NULL, 6580, 13),
(278504, NULL, 'PR01600', NULL, NULL, 'Zona occludens protein ZO-3 signature', NULL, 'ZONOCCLUDNS3', NULL, NULL, 7424, 13),
(278505, NULL, 'PR01647', NULL, NULL, 'Transient receptor potential channel 6 signature', NULL, 'TRPCHANNEL6', NULL, NULL, 992, 13),
(278506, NULL, 'PR00026', NULL, NULL, 'Engrailed homeodomain signature', NULL, 'ENGRAILED', NULL, NULL, 4908, 13),
(278507, NULL, 'PR01853', NULL, NULL, 'Bacterial YajC preprotein translocase signature', NULL, 'YAJCTRNLCASE', NULL, NULL, 3067, 13),
(278508, NULL, 'PR00199', NULL, NULL, 'Annexin type III signature', NULL, 'ANNEXINIII', NULL, NULL, 6068, 13),
(278509, NULL, 'PR00974', NULL, NULL, 'Ribosomal protein S18 family signature', NULL, 'RIBOSOMALS18', NULL, NULL, 5190, 13),
(278510, NULL, 'PR01454', NULL, NULL, 'Epithelial membrane protein EMP-1 signature', NULL, 'EPMEMPROT1', NULL, NULL, 6019, 13),
(278511, NULL, 'PR00377', NULL, NULL, 'Inositol monophosphatase superfamily signature', NULL, 'IMPHPHTASES', NULL, NULL, 3642, 13);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(278512, NULL, 'PR01516', NULL, NULL, 'Kv4.1 voltage-gated K+ channel signature', NULL, 'KV41CHANNEL', NULL, NULL, 813, 13),
(278513, NULL, 'PR00548', NULL, NULL, 'Hyperglycemic hormone type 1 signature', NULL, 'HYPRGLYCEMC1', NULL, NULL, 127, 13),
(278514, NULL, 'PR01605', NULL, NULL, 'KCNE voltage-gated K+ channel subfamily E2 signature', NULL, 'KCNE2CHANNEL', NULL, NULL, 364, 13),
(278515, NULL, 'PR01531', NULL, NULL, 'C-C chemokine receptor type 9 signature', NULL, 'CHEMOKINER9', NULL, NULL, 1960, 13),
(278516, NULL, 'PR00724', NULL, NULL, 'Carboxypeptidase C serine protease (S10) family signature', NULL, 'CRBOXYPTASEC', NULL, NULL, 5008, 13),
(278517, NULL, 'PR00534', NULL, NULL, 'Melanocortin receptor family signature', NULL, 'MCRFAMILY', NULL, NULL, 3492, 13),
(278518, NULL, 'PR00166', NULL, NULL, 'Aromatic amino acid permease signature', NULL, 'AROAAPRMEASE', NULL, NULL, 12262, 13),
(278519, NULL, 'PR00010', NULL, NULL, 'Type II EGF-like signature', NULL, 'EGFBLOOD', NULL, NULL, NULL, 13),
(278520, NULL, 'PR00238', NULL, NULL, 'Opsin signature', NULL, 'OPSIN', NULL, NULL, 3500, 13),
(278521, NULL, 'PR01116', NULL, NULL, 'CLC-5 chloride channel signature', NULL, 'CLCHANNEL5', NULL, NULL, 382, 13),
(278522, NULL, 'PR01238', NULL, NULL, 'CC24 mitochondrial P450 signature', NULL, 'MITP450CC24', NULL, NULL, 6897, 13),
(278523, NULL, 'PR01094', NULL, NULL, 'Sulphonylurea receptor type 2 family signature', NULL, 'SULFNYLUR2', NULL, NULL, 6370, 13),
(278524, NULL, 'PR00048', NULL, NULL, 'C2H2-type zinc finger signature', NULL, 'ZINCFINGER', NULL, NULL, NULL, 13),
(278525, NULL, 'PR00354', NULL, NULL, '7Fe ferredoxin signature', NULL, '7FE8SFRDOXIN', NULL, NULL, 4870, 13),
(278526, NULL, 'PR00593', NULL, NULL, 'Metabotropic glutamate receptor signature', NULL, 'MTABOTROPICR', NULL, NULL, 3965, 13),
(278527, NULL, 'PR01591', NULL, NULL, 'DNA-binding protein FIS signature', NULL, 'DNABINDNGFIS', NULL, NULL, 7106, 13),
(278528, NULL, 'PR00134', NULL, NULL, 'Glycosyl hydrolase family 10 signature', NULL, 'GLHYDRLASE10', NULL, NULL, 3006, 13),
(278529, NULL, 'PR01427', NULL, NULL, 'Transforming growth factor beta 4 precursor signature', NULL, 'TGFBETA4', NULL, NULL, 7186, 13),
(278530, NULL, 'PR00996', NULL, NULL, 'Glutamate methyltransferase family signature', NULL, 'CHERMTFRASE', NULL, NULL, 3977, 13),
(278531, NULL, 'PR00027', NULL, NULL, 'Paired box signature', NULL, 'PAIREDBOX', NULL, NULL, 5743, 13),
(278532, NULL, 'PR01110', NULL, NULL, 'C-C chemokine receptor type 5 signature', NULL, 'CHEMOKINER5', NULL, NULL, 398, 13),
(278533, NULL, 'PR00369', NULL, NULL, 'Flavodoxin signature', NULL, 'FLAVODOXIN', NULL, NULL, 1450, 13),
(278534, NULL, 'PR01965', NULL, NULL, 'Tumour necrosis factor receptor 14 signature', NULL, 'TNFACTORR14', NULL, NULL, 15731, 13),
(278535, NULL, 'PR00132', NULL, NULL, 'Glycosyl hydrolase family 2 signature', NULL, 'GLHYDRLASE2', NULL, NULL, 2795, 13),
(278536, NULL, 'PR00137', NULL, NULL, 'Lysozyme signature', NULL, 'LYSOZYME', NULL, NULL, 3093, 13),
(278537, NULL, 'PR01701', NULL, NULL, 'CD164 antigen signature', NULL, 'CD164ANTIGEN', NULL, NULL, 4312, 13),
(278538, NULL, 'PR00184', NULL, NULL, 'Neisseria sp. porin signature', NULL, 'NEISSPPORIN', NULL, NULL, 6022, 13),
(278539, NULL, 'PR01932', NULL, NULL, 'Interleukin-17 signature', NULL, 'INTRLEUKIN17', NULL, NULL, 20836, 13),
(278540, NULL, 'PR00734', NULL, NULL, 'Glycosyl hydrolase family 7 signature', NULL, 'GLHYDRLASE7', NULL, NULL, 3402, 13),
(278541, NULL, 'PR00602', NULL, NULL, 'Barwin domain signature', NULL, 'BARWIN', NULL, NULL, 1276, 13),
(278542, NULL, 'PR01181', NULL, NULL, 'Diaminopimelate decarboxylase signature', NULL, 'DAPDCRBXLASE', NULL, NULL, 7012, 13),
(278543, NULL, 'PR01390', NULL, NULL, 'Clostridial binary toxin A signature', NULL, 'BINARYTOXINA', NULL, NULL, 4215, 13),
(278544, NULL, 'PR00211', NULL, NULL, 'Glutelin signature', NULL, 'GLUTELIN', NULL, NULL, 6995, 13),
(278545, NULL, 'PR00764', NULL, NULL, 'Complement C9 signature', NULL, 'COMPLEMENTC9', NULL, NULL, 4305, 13),
(278546, NULL, 'PR01143', NULL, NULL, 'Follicle stimulating hormone receptor precursor signature', NULL, 'FSHRECEPTOR', NULL, NULL, 5327, 13);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(278547, NULL, 'PR00167', NULL, NULL, 'Calcium channel signature', NULL, 'CACHANNEL', NULL, NULL, 1152, 13),
(278548, NULL, 'PR01877', NULL, NULL, 'Myeloid transforming gene related protein-1 (MTGR1) family signature', NULL, 'MTGR1PROTEIN', NULL, NULL, 8628, 13),
(278549, NULL, 'PR00418', NULL, NULL, 'DNA topoisomerase II family signature', NULL, 'TPI2FAMILY', NULL, NULL, NULL, 13),
(278550, NULL, 'PR00450', NULL, NULL, 'Recoverin family signature', NULL, 'RECOVERIN', NULL, NULL, NULL, 13),
(278551, NULL, 'PR00856', NULL, NULL, 'Prostacyclin (prostanoid IP) receptor signature', NULL, 'PRSTNOIDIPR', NULL, NULL, 4745, 13),
(278552, NULL, 'PR01489', NULL, NULL, 'Gram-negative bacterial RTX toxin-activating protein C signature', NULL, 'RTXTOXINC', NULL, NULL, 513, 13),
(278553, NULL, 'PR01769', NULL, NULL, 'Vanilloid receptor-like 2 protein (VRL-2) family signature', NULL, 'VRL2RECEPTOR', NULL, NULL, 7712, 13),
(278554, NULL, 'PR01502', NULL, NULL, 'Ubiquitously expressed transcript protein signature', NULL, 'UXTPROTEIN', NULL, NULL, 934, 13),
(278555, NULL, 'PR00859', NULL, NULL, 'Prokaryote metallothionein signature', NULL, 'MTPROKARYOTE', NULL, NULL, 6847, 13),
(278556, NULL, 'PR01449', NULL, NULL, 'Calcium-activated BK potassium channel alpha subunit signature', NULL, 'BKCHANNELA', NULL, NULL, NULL, 13),
(278557, NULL, 'PR00884', NULL, NULL, 'Ribosomal protein HS6 signature', NULL, 'RIBOSOMALHS6', NULL, NULL, 3225, 13),
(278558, NULL, 'PR02102', NULL, NULL, 'Inhibitor of CDK interacting with cyclin A1 protein signature', NULL, 'PROTEININCA1', NULL, NULL, 24850, 13),
(278559, NULL, 'PR00977', NULL, NULL, 'Scytalidopepsin B aspartic protease (A4) signature', NULL, 'SCYTLDPTASE', NULL, NULL, 4604, 13),
(278560, NULL, 'PR01503', NULL, NULL, 'Treacher Collins syndrome protein Treacle signature', NULL, 'TREACLE', NULL, NULL, NULL, 13),
(278561, NULL, 'PR00796', NULL, NULL, 'Viral spike glycoprotein precursor signature', NULL, 'SPIKEPROTEIN', NULL, NULL, 2901, 13),
(278562, NULL, 'PR00710', NULL, NULL, 'Natriuretic peptide family signature', NULL, 'NATPEPTIDES', NULL, NULL, 5674, 13),
(278563, NULL, 'PR00567', NULL, NULL, 'Dopamine D2 receptor signature', NULL, 'DOPAMINED2R', NULL, NULL, 4136, 13),
(278564, NULL, 'PR00330', NULL, NULL, 'Haemagglutinin HA1 chain signature', NULL, 'HEMAGGLUTN1', NULL, NULL, 1847, 13),
(278565, NULL, 'PR01736', NULL, NULL, 'Phosphoenolpyruvate-protein phosphotransferase signature', NULL, 'PHPHTRNFRASE', NULL, NULL, NULL, 13),
(278566, NULL, 'PR02035', NULL, NULL, 'FPRL1/chemotaxis inhibitory protein signature', NULL, 'FLIPRCHIPS', NULL, NULL, 14465, 13),
(278567, NULL, 'PR01068', NULL, NULL, 'P2Y6 purinoceptor signature', NULL, 'P2Y6PRNOCPTR', NULL, NULL, 2486, 13),
(278568, NULL, 'PR01607', NULL, NULL, 'Apyrase family signature', NULL, 'APYRASEFAMLY', NULL, NULL, 11469, 13),
(278569, NULL, 'PR02030', NULL, NULL, 'Autophagy-related protein 14 signature', NULL, 'AUTOPHGYRP14', NULL, NULL, 19836, 13),
(278570, NULL, 'PR00015', NULL, NULL, 'Gram-positive coccus surface protein anchor signature', NULL, 'GPOSANCHOR', NULL, NULL, 15289, 13),
(278571, NULL, 'PR02100', NULL, NULL, 'Radiation-inducible immediate-early gene IEX-1 signature', NULL, 'GENEIEX1', NULL, NULL, 22234, 13),
(278572, NULL, 'PR00955', NULL, NULL, 'Flagellar motor switch protein FliM signature', NULL, 'FLGMOTORFLIM', NULL, NULL, 3202, 13),
(278573, NULL, 'PR00899', NULL, NULL, 'Fungal pheromone STE3 GPCR signature', NULL, 'GPCRSTE3', NULL, NULL, 6260, 13),
(278574, NULL, 'PR01062', NULL, NULL, 'Melanocortin 4 receptor signature', NULL, 'MELNOCORTN4R', NULL, NULL, 1560, 13),
(278575, NULL, 'PR00363', NULL, NULL, 'Cytochrome B5 signature', NULL, 'CYTOCHROMEB5', NULL, NULL, 1047, 13),
(278576, NULL, 'PR01363', NULL, NULL, 'Viral protein D9 signature', NULL, 'VD09PROTEIN', NULL, NULL, 3231, 13),
(278577, NULL, 'PR00957', NULL, NULL, 'Gene 66 (IR5) protein signature', NULL, 'GENE66', NULL, NULL, 3599, 13),
(278578, NULL, 'PR00778', NULL, NULL, 'Bacterial regulatory protein ArsR family signature', NULL, 'HTHARSR', NULL, NULL, 4484, 13);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(278579, NULL, 'PR00933', NULL, NULL, 'B-lytic metalloendopeptidase (M23) signature', NULL, 'BLYTICPTASE', NULL, NULL, 324, 13),
(278580, NULL, 'PR00326', NULL, NULL, 'GTP1/OBG GTP-binding protein family signature', NULL, 'GTP1OBG', NULL, NULL, 2562, 13),
(278581, NULL, 'PR01248', NULL, NULL, 'Type I keratin signature', NULL, 'TYPE1KERATIN', NULL, NULL, 6510, 13),
(278582, NULL, 'PR01340', NULL, NULL, 'Salmonella virulence plasmid 28.1kDa A protein signature', NULL, 'SALSPVAPROT', NULL, NULL, 6154, 13),
(278583, NULL, 'PR00909', NULL, NULL, 'Bacterial periplasmic spermidine/putrescine-binding protein signature', NULL, 'SPERMDNBNDNG', NULL, NULL, 1236, 13),
(278584, NULL, 'PR01476', NULL, NULL, 'Leukotriene B4 receptor signature', NULL, 'LTBRECEPTOR', NULL, NULL, 7456, 13),
(278585, NULL, 'PR01113', NULL, NULL, 'CLC-2 chloride channel signature', NULL, 'CLCHANNEL2', NULL, NULL, 91, 13),
(278586, NULL, 'PR01138', NULL, NULL, 'Gap junction beta-1 protein (Cx32) signature', NULL, 'CONNEXINB1', NULL, NULL, 6097, 13),
(278587, NULL, 'PR01661', NULL, NULL, 'Mini-chromosome maintenance (MCM) protein 5 signature', NULL, 'MCMPROTEIN5', NULL, NULL, 5277, 13),
(278588, NULL, 'PR01100', NULL, NULL, 'Shikimate kinase family signature', NULL, 'SHIKIMTKNASE', NULL, NULL, NULL, 13),
(278589, NULL, 'PR01527', NULL, NULL, 'Lysophosphatidic acid receptor family signature', NULL, 'LPARECEPTOR', NULL, NULL, 1926, 13),
(278590, NULL, 'PR00810', NULL, NULL, 'Bacterial general secretion pathway protein C signature', NULL, 'BCTERIALGSPC', NULL, NULL, 3988, 13),
(278591, NULL, 'PR01562', NULL, NULL, 'Fractalkine receptor signature', NULL, 'FRACTALKINER', NULL, NULL, 6883, 13),
(278592, NULL, 'PR00250', NULL, NULL, 'Fungal pheromone mating factor STE2 GPCR signature', NULL, 'GPCRSTE2', NULL, NULL, 462, 13),
(278593, NULL, 'PR01764', NULL, NULL, 'MAP kinase phosphatase signature', NULL, 'MAPKPHPHTASE', NULL, NULL, 7749, 13),
(278594, NULL, 'PR00894', NULL, NULL, 'Yeast Mrs6p protein signature', NULL, 'YEASTMRS6P', NULL, NULL, 15180, 13),
(278595, NULL, 'PR01168', NULL, NULL, 'Insect alcohol dehydrogenase signature', NULL, 'ALCDHDRGNASE', NULL, NULL, 6780, 13),
(278596, NULL, 'PR00146', NULL, NULL, 'Dihydrodipicolinate synthase signature', NULL, 'DHPICSNTHASE', NULL, NULL, 5807, 13),
(278597, NULL, 'PR00916', NULL, NULL, '2C endopeptidase (C24) cysteine protease family signature', NULL, '2CENDOPTASE', NULL, NULL, 4608, 13),
(278598, NULL, 'PR00196', NULL, NULL, 'Annexin family signature', NULL, 'ANNEXIN', NULL, NULL, 6368, 13),
(278599, NULL, 'PR00046', NULL, NULL, 'Major sigma-70 factor signature', NULL, 'SIGMA70FCT', NULL, NULL, 3449, 13),
(278600, NULL, 'PR01001', NULL, NULL, 'FAD-dependent glycerol-3-phosphate dehydrogenase family signature', NULL, 'FADG3PDH', NULL, NULL, 5998, 13),
(278601, NULL, 'PR00021', NULL, NULL, 'Small proline-rich protein signature', NULL, 'PRORICH', NULL, NULL, NULL, 13),
(278602, NULL, 'PR00738', NULL, NULL, 'Glycosyl hydrolase family 20 signature', NULL, 'GLHYDRLASE20', NULL, NULL, 26346, 13),
(278603, NULL, 'PR00805', NULL, NULL, 'Alpha-catenin signature', NULL, 'ALPHACATENIN', NULL, NULL, 2887, 13),
(278604, NULL, 'PR00349', NULL, NULL, 'Virion infectivity factor signature', NULL, 'VIRIONINFFCT', NULL, NULL, 6553, 13),
(278605, NULL, 'PR01434', NULL, NULL, 'NADH-ubiquinone oxidoreductase chain 5 signature', NULL, 'NADHDHGNASE5', NULL, NULL, NULL, 13),
(278606, NULL, 'PR00705', NULL, NULL, 'Papain cysteine protease (C1) family signature', NULL, 'PAPAIN', NULL, NULL, 5565, 13),
(278607, NULL, 'PR01487', NULL, NULL, 'Bacterial autoinducer-2 (AI-2) production protein LuxS signature', NULL, 'LUXSPROTEIN', NULL, NULL, 3109, 13),
(278608, NULL, 'PR01894', NULL, NULL, 'Wnt-14 protein signature', NULL, 'WNT14PROTEIN', NULL, NULL, 8637, 13),
(278609, NULL, 'PR01830', NULL, NULL, 'Trace amine receptor signature', NULL, 'TRACEAMINER', NULL, NULL, 10182, 13),
(278610, NULL, 'PR00699', NULL, NULL, 'C.elegans integral membrane protein Srb signature', NULL, 'TMPROTEINSRB', NULL, NULL, 5672, 13);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(278611, NULL, 'PR00787', NULL, NULL, 'Streptomyces extracellular neutral proteinase (M7) family signature', NULL, 'NEUTRALPTASE', NULL, NULL, 2679, 13),
(278612, NULL, 'PR01550', NULL, NULL, 'DNA topoisomerase VI subunit A family signature', NULL, 'TOP6AFAMILY', NULL, NULL, 4904, 13),
(278613, NULL, 'PR01844', NULL, NULL, 'Wnt-4 protein signature', NULL, 'WNT4PROTEIN', NULL, NULL, 10158, 13),
(278614, NULL, 'PR00992', NULL, NULL, 'Alanine racemase signature', NULL, 'ALARACEMASE', NULL, NULL, 4785, 13),
(278615, NULL, 'PR01424', NULL, NULL, 'Transforming growth factor beta 1 precursor signature', NULL, 'TGFBETA1', NULL, NULL, 7215, 13),
(278616, NULL, 'PR00253', NULL, NULL, 'Gamma-aminobutyric acid A (GABAA) receptor signature', NULL, 'GABAARECEPTR', NULL, NULL, 1169, 13),
(278617, NULL, 'PR00462', NULL, NULL, 'Fungal lignin peroxidase family signature', NULL, 'LIGNINASE', NULL, NULL, 5001, 13),
(278618, NULL, 'PR01225', NULL, NULL, 'Expansin/Lol pI family signature', NULL, 'EXPANSNFAMLY', NULL, NULL, 442, 13),
(278619, NULL, 'PR01187', NULL, NULL, 'Anion exchanger isoform 1 signature', NULL, 'ANIONEXHNGR1', NULL, NULL, 7049, 13),
(278620, NULL, 'PR01771', NULL, NULL, 'ERK3/4 MAP kinase signature', NULL, 'ERK3ERK4MAPK', NULL, NULL, 7681, 13),
(278621, NULL, 'PR01670', NULL, NULL, 'Gamma-aminobutyric-acid A (GABAA) receptor rho subunit signature', NULL, 'GABAARRHO', NULL, NULL, 5136, 13),
(278622, NULL, 'PR00618', NULL, NULL, 'DksA/TraR zinc finger signature', NULL, 'DKSAZNFINGER', NULL, NULL, 19480, 13),
(278623, NULL, 'PR02034', NULL, NULL, 'Liver X receptor signature', NULL, 'LIVERXRECPTR', NULL, NULL, 18784, 13),
(278624, NULL, 'PR01974', NULL, NULL, 'Tumour necrosis factor receptor 11A signature', NULL, 'TNFACTORR11A', NULL, NULL, 15523, 13),
(278625, NULL, 'PR01987', NULL, NULL, 'Neurogenic locus Notch protein 4 signature', NULL, 'NOTCH4', NULL, NULL, 15734, 13),
(278626, NULL, 'PR00617', NULL, NULL, 'Copper fist domain signature', NULL, 'COPPERFIST', NULL, NULL, 2454, 13),
(278627, NULL, 'PR00837', NULL, NULL, 'Allergen V5/Tpx-1 family signature', NULL, 'V5TPXLIKE', NULL, NULL, 111, 13),
(278628, NULL, 'PR00912', NULL, NULL, 'Luteovirus ORF5 VPG protein signature', NULL, 'LVIRUSORF5', NULL, NULL, 4384, 13),
(278629, NULL, 'PR01976', NULL, NULL, 'Insulin-like growth factor-binding protein family signature', NULL, 'IGFBPFAMILY', NULL, NULL, 15899, 13),
(278630, NULL, 'PR01106', NULL, NULL, 'C-C chemokine receptor type 1 signature', NULL, 'CHEMOKINER1', NULL, NULL, 278, 13),
(278631, NULL, 'PR01342', NULL, NULL, 'Salmonella virulence-associated 28kDa protein signature', NULL, 'SALVRPPROT', NULL, NULL, 6020, 13),
(278632, NULL, 'PR01522', NULL, NULL, 'Orexin receptor type 2 signature', NULL, 'OREXIN2R', NULL, NULL, 594, 13),
(278633, NULL, 'PR01247', NULL, NULL, 'Rec1 exonuclease signature', NULL, 'RECEXONCLASE', NULL, NULL, 227, 13),
(278634, NULL, 'PR00552', NULL, NULL, 'Adenosine A1 receptor signature', NULL, 'ADENOSINEA1R', NULL, NULL, 7380, 13),
(278635, NULL, 'PR00722', NULL, NULL, 'Chymotrypsin serine protease family (S1) signature', NULL, 'CHYMOTRYPSIN', NULL, NULL, 119, 13),
(278636, NULL, 'PR01579', NULL, NULL, 'KCNAB voltage-gated K+ channel beta-2 subunit signature', NULL, 'KCNAB2CHANEL', NULL, NULL, 7002, 13),
(278637, NULL, 'PR01102', NULL, NULL, '5-hydroxytryptamine 6 receptor signature', NULL, '5HT6RECEPTR', NULL, NULL, NULL, 13),
(278638, NULL, 'PR00806', NULL, NULL, 'Vinculin signature', NULL, 'VINCULIN', NULL, NULL, NULL, 13),
(278639, NULL, 'PR01687', NULL, NULL, 'CYP2E P450 family signature', NULL, 'EP450ICYP2E', NULL, NULL, 5317, 13),
(278640, NULL, 'PR01383', NULL, NULL, 'Claudin-10 signature', NULL, 'CLAUDIN10', NULL, NULL, 7105, 13),
(278641, NULL, 'PR01824', NULL, NULL, 'Janus kinase 1 (JAK1) signature', NULL, 'JANUSKINASE1', NULL, NULL, 20804, 13),
(278642, NULL, 'PR00149', NULL, NULL, 'Fumarate lyase superfamily signature', NULL, 'FUMRATELYASE', NULL, NULL, 186, 13),
(278643, NULL, 'PR01929', NULL, NULL, 'Interleukin-13 signature', NULL, 'INTRLEUKIN13', NULL, NULL, 19691, 13);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(278644, NULL, 'PR00124', NULL, NULL, 'ATP synthase C subunit signature', NULL, 'ATPASEC', NULL, NULL, 6579, 13),
(278645, NULL, 'PR00793', NULL, NULL, 'Prolyl aminopeptidase (S33) family signature', NULL, 'PROAMNOPTASE', NULL, NULL, 6358, 13),
(278646, NULL, 'PR00440', NULL, NULL, 'G protein alpha subunit group 12 signature', NULL, 'GPROTEINA12', NULL, NULL, 6895, 13),
(278647, NULL, 'PR02043', NULL, NULL, 'Cancer susceptibility candidate protein 1 signature', NULL, 'CANCERSCCP1', NULL, NULL, 15570, 13),
(278648, NULL, 'PR00907', NULL, NULL, 'Thrombomodulin signature', NULL, 'THRMBOMODULN', NULL, NULL, NULL, 13),
(278649, NULL, 'PR01046', NULL, NULL, 'Prolyl-tRNA synthetase signature', NULL, 'TRNASYNTHPRO', NULL, NULL, 6088, 13),
(278650, NULL, 'PR01765', NULL, NULL, 'Epithelial calcium channel (ECAC) family signature', NULL, 'ECACCHANNEL', NULL, NULL, 7682, 13),
(278651, NULL, 'PR00792', NULL, NULL, 'Pepsin (A1) aspartic protease family signature', NULL, 'PEPSIN', NULL, NULL, 6342, 13),
(278652, NULL, 'PR00673', NULL, NULL, 'Light harvesting protein A chain signature', NULL, 'LIGHTHARVSTA', NULL, NULL, 19501, 13),
(278653, NULL, 'PR01136', NULL, NULL, 'Gap junction alpha-6 protein (Cx45) signature', NULL, 'CONNEXINA6', NULL, NULL, 6280, 13),
(278654, NULL, 'PR00588', NULL, NULL, 'Somatostatin receptor type 2 signature', NULL, 'SOMATOSTTN2R', NULL, NULL, 5249, 13),
(278655, NULL, 'PR01803', NULL, NULL, 'Trypanosome sialidase signature', NULL, 'TCSIALIDASE', NULL, NULL, 7937, 13),
(278656, NULL, 'PR01553', NULL, NULL, 'Type IV secretion system CagA exotoxin signature', NULL, 'TYPE4SSCAGA', NULL, NULL, 5336, 13),
(278657, NULL, 'PR00340', NULL, NULL, 'P-II protein signature', NULL, 'PIIGLNB', NULL, NULL, 5890, 13),
(278658, NULL, 'PR00459', NULL, NULL, 'Plant ascorbate peroxidase signature', NULL, 'ASPEROXIDASE', NULL, NULL, 5582, 13),
(278659, NULL, 'PR01865', NULL, NULL, 'Bcl-W apoptosis regulator protein signature', NULL, 'APOPREGBCLW', NULL, NULL, 8687, 13),
(278660, NULL, 'PR01199', NULL, NULL, 'Creatine transporter signature', NULL, 'CRTTRANSPORT', NULL, NULL, 7451, 13),
(278661, NULL, 'PR00826', NULL, NULL, 'Fanconi anaemia group A protein signature', NULL, 'FANCONIAGENE', NULL, NULL, 6195, 13),
(278662, NULL, 'PR01019', NULL, NULL, 'LPP20 lipoprotein precursor signature', NULL, 'LIPOLPP20', NULL, NULL, 74, 13),
(278663, NULL, 'PR01906', NULL, NULL, 'Lamprey and hagfish globin signature', NULL, 'FISHGLOBIN', NULL, NULL, 8611, 13),
(278664, NULL, 'PR00557', NULL, NULL, 'Alpha-1A adrenergic receptor signature', NULL, 'ADRENRGCA1AR', NULL, NULL, 3358, 13),
(278665, NULL, 'PR01510', NULL, NULL, 'Kv1.3 voltage-gated K+ channel signature', NULL, 'KV13CHANNEL', NULL, NULL, 536, 13),
(278666, NULL, 'PR01805', NULL, NULL, 'VacJ lipoprotein signature', NULL, 'VACJLIPOPROT', NULL, NULL, 3927, 13),
(278667, NULL, 'PR01319', NULL, NULL, 'Glial cell line-derived neurotrophic factor receptor alpha 3 signature', NULL, 'GDNFRALPHA3', NULL, NULL, 6333, 13),
(278668, NULL, 'PR01797', NULL, NULL, 'Saposin signature', NULL, 'SAPOSIN', NULL, NULL, 7803, 13),
(278669, NULL, 'PR00052', NULL, NULL, 'Fibrillarin signature', NULL, 'FIBRILLARIN', NULL, NULL, 6978, 13),
(278670, NULL, 'PR00998', NULL, NULL, 'Carboxypeptidase Taq (M32) metallopeptidase signature', NULL, 'CRBOXYPTASET', NULL, NULL, 438, 13),
(278671, NULL, 'PR00772', NULL, NULL, 'Heat labile enterotoxin B chain signature', NULL, 'ENTEROTOXINB', NULL, NULL, 4300, 13),
(278672, NULL, 'PR00708', NULL, NULL, 'Alpha-1-acid glycoprotein signature', NULL, 'A1AGLPROTEIN', NULL, NULL, 3450, 13),
(278673, NULL, 'PR00135', NULL, NULL, 'Lysozyme/alpha-lactalbumin superfamily signature', NULL, 'LYZLACT', NULL, NULL, 4337, 13),
(278674, NULL, 'PR00642', NULL, NULL, 'EDG-1 sphingosine 1-phosphate receptor signature', NULL, 'EDG1RECEPTOR', NULL, NULL, NULL, 13),
(278675, NULL, 'PR01223', NULL, NULL, 'Bride of sevenless protein signature', NULL, 'BRIDEOF7LESS', NULL, NULL, 6837, 13),
(278676, NULL, 'PR02096', NULL, NULL, 'Hydroxyacyl-thioester dehydratase type 2 (mitochondrial) signature', NULL, 'HTDHYDRTASE2', NULL, NULL, 26180, 13);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(278677, NULL, 'PR01524', NULL, NULL, 'EDG-3 sphingosine 1-phosphate receptor signature', NULL, 'EDG3RECEPTOR', NULL, NULL, 966, 13),
(278678, NULL, 'PR00994', NULL, NULL, 'B2 bradykinin receptor signature', NULL, 'BRADYKINNB2R', NULL, NULL, 3317, 13),
(278679, NULL, 'PR02088', NULL, NULL, 'HAUS augmin-like complex subunit 2 signature', NULL, 'HAUSAUGMINL2', NULL, NULL, 24517, 13),
(278680, NULL, 'PR02008', NULL, NULL, 'RNA (C5-cytosine) methyltransferase signature', NULL, 'RCMTFAMILY', NULL, NULL, 14055, 13),
(278681, NULL, 'PR00742', NULL, NULL, 'Glycosyl hydrolase family 35 signature', NULL, 'GLHYDRLASE35', NULL, NULL, 4092, 13),
(278682, NULL, 'PR02098', NULL, NULL, 'Hydrolethalus syndrome protein 1 signature', NULL, 'HYLETHALUSS1', NULL, NULL, 26335, 13),
(278683, NULL, 'PR01332', NULL, NULL, 'Kir6.2 inward rectifier K+ channel signature', NULL, 'KIR62CHANNEL', NULL, NULL, 3407, 13),
(278684, NULL, 'PR01945', NULL, NULL, 'Interleukin-11A signature', NULL, 'IL11AFISH', NULL, NULL, 19025, 13),
(278685, NULL, 'PR01004', NULL, NULL, 'Flagellar FliJ protein signature', NULL, 'FLGFLIJ', NULL, NULL, 12623, 13),
(278686, NULL, 'PR00662', NULL, NULL, 'Glucose-6-phosphate isomerase signature', NULL, 'G6PISOMERASE', NULL, NULL, 3021, 13),
(278687, NULL, 'PR00086', NULL, NULL, 'L-lactate dehydrogenase signature', NULL, 'LLDHDRGNASE', NULL, NULL, 5752, 13),
(278688, NULL, 'PR00509', NULL, NULL, 'Phosphoglucomutase/phosphomannomutase family signature', NULL, 'PGMPMM', NULL, NULL, 5763, 13),
(278689, NULL, 'PR00815', NULL, NULL, 'Pi haemoglobin signature', NULL, 'PIHAEM', NULL, NULL, 6140, 13),
(278690, NULL, 'PR00164', NULL, NULL, 'ABC-2 type transport system membrane protein signature', NULL, 'ABC2TRNSPORT', NULL, NULL, 4597, 13),
(278691, NULL, 'PR00616', NULL, NULL, 'CCAAT-binding transcription factor subunit B signature', NULL, 'CCAATSUBUNTB', NULL, NULL, 2064, 13),
(278692, NULL, 'PR00473', NULL, NULL, 'Galactokinase signature', NULL, 'GALCTOKINASE', NULL, NULL, 3588, 13),
(278693, NULL, 'PR00883', NULL, NULL, 'High mobility group-like nuclear protein signature', NULL, 'NUCLEARHMG', NULL, NULL, 2814, 13),
(278694, NULL, 'PR01777', NULL, NULL, 'Interferon-gamma receptor alpha chain signature', NULL, 'INTERFERONGR', NULL, NULL, 7819, 13),
(278695, NULL, 'PR00343', NULL, NULL, 'Selectin superfamily complement-binding repeat signature', NULL, 'SELECTIN', NULL, NULL, 6520, 13),
(278696, NULL, 'PR00508', NULL, NULL, 'S21 class N4 adenine-specific DNA methyltransferase signature', NULL, 'S21N4MTFRASE', NULL, NULL, 5168, 13),
(278697, NULL, 'PR01264', NULL, NULL, 'Bacterial mechano-sensitive ion channel signature', NULL, 'MECHCHANNEL', NULL, NULL, 1354, 13),
(278698, NULL, 'PR00821', NULL, NULL, 'Triacylglycerol lipase family signature', NULL, 'TAGLIPASE', NULL, NULL, 3924, 13),
(278699, NULL, 'PR01341', NULL, NULL, 'Salmonella virulence plasmid 65kDa B protein signature', NULL, 'SALSPVBPROT', NULL, NULL, 3312, 13),
(278700, NULL, 'PR01741', NULL, NULL, 'Septin 3 signature', NULL, 'SEPTIN3', NULL, NULL, 6271, 13),
(278701, NULL, 'PR01546', NULL, NULL, 'Saccharomyces cerevisiae 73.5kDa hypothetical protein signature', NULL, 'YEAST73DUF', NULL, NULL, 5083, 13),
(278702, NULL, 'PR00784', NULL, NULL, 'Mitochondrial brown fat uncoupling protein signature', NULL, 'MTUNCOUPLING', NULL, NULL, 2478, 13),
(278703, NULL, 'PR00876', NULL, NULL, 'Nematode metallothionein signature', NULL, 'MTNEMATODE', NULL, NULL, 4634, 13),
(278704, NULL, 'PR02031', NULL, NULL, 'Cysteine/serine-rich nuclear protein (CSRNP) family signature', NULL, 'CYSSERRICHNP', NULL, NULL, 19719, 13),
(278705, NULL, 'PR00236', NULL, NULL, 'Herpesvirus capsid protein P40 signature', NULL, 'HSVCAPSIDP40', NULL, NULL, 4422, 13),
(278706, NULL, 'PR01779', NULL, NULL, 'Lantibiotic leader peptide processing protein signature', NULL, 'LANTIPROCESS', NULL, NULL, 7968, 13),
(278707, NULL, 'PR01652', NULL, NULL, 'Bacterial cell shape determinant MreB/Mbl protein signature', NULL, 'SHAPEPROTEIN', NULL, NULL, 5416, 13),
(278708, NULL, 'PR01841', NULL, NULL, 'Wnt-1 protein signature', NULL, 'WNT1PROTEIN', NULL, NULL, 10491, 13);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(278709, NULL, 'PR00731', NULL, NULL, 'Cauliflower mosaic virus peptidase (A3) signature', NULL, 'CAULIMOPTASE', NULL, NULL, 5836, 13),
(278710, NULL, 'PR01137', NULL, NULL, 'Gap junction alpha-8 protein (Cx50) signature', NULL, 'CONNEXINA8', NULL, NULL, 6172, 13),
(278711, NULL, 'PR01464', NULL, NULL, 'EAG potassium channel signature', NULL, 'EAGCHANNEL', NULL, NULL, 7087, 13),
(278712, NULL, 'PR01132', NULL, NULL, 'Gap junction alpha-1 protein (Cx43) signature', NULL, 'CONNEXINA1', NULL, NULL, 354, 13),
(278713, NULL, 'PR00693', NULL, NULL, 'Granulocyte-macrophage colony-stimulating factor signature', NULL, 'GMCSFACTOR', NULL, NULL, 6701, 13),
(278714, NULL, 'PR01324', NULL, NULL, 'Kir2.1 inward rectifier K+ channel signature', NULL, 'KIR21CHANNEL', NULL, NULL, 3032, 13),
(278715, NULL, 'PR01179', NULL, NULL, 'Ornithine/diaminopimelate/arginine (ODA) decarboxylase family signature', NULL, 'ODADCRBXLASE', NULL, NULL, 3750, 13),
(278716, NULL, 'PR01761', NULL, NULL, 'Dishevelled-1 protein signature', NULL, 'DISHEVELLED1', NULL, NULL, NULL, 13),
(278717, NULL, 'PR01618', NULL, NULL, 'Gamma-aminobutyric-acid A receptor alpha 5 subunit signature', NULL, 'GABAARALPHA5', NULL, NULL, 69, 13),
(278718, NULL, 'PR01254', NULL, NULL, 'Prostaglandin D synthase signature', NULL, 'PGNDSYNTHASE', NULL, NULL, NULL, 13),
(278719, NULL, 'PR00782', NULL, NULL, 'Leishmanolysin (M8) metalloprotease family signature', NULL, 'LSHMANOLYSIN', NULL, NULL, 5367, 13),
(278720, NULL, 'PR01625', NULL, NULL, 'Omega-class glutathione S-transferase signature', NULL, 'GSTRNSFRASEO', NULL, NULL, 446, 13),
(278721, NULL, 'PR00336', NULL, NULL, 'Lysosome-associated membrane glycoprotein signature', NULL, 'LYSASSOCTDMP', NULL, NULL, 4671, 13),
(278722, NULL, 'PR00396', NULL, NULL, 'Ribosome inactivating protein family signature', NULL, 'SHIGARICIN', NULL, NULL, 12712, 13),
(278723, NULL, 'PR02006', NULL, NULL, 'Insulin-like growth factor II signature', NULL, 'INSLNLIKEGF2', NULL, NULL, 15764, 13),
(278724, NULL, 'PR02078', NULL, NULL, 'GATS-like protein family signature', NULL, 'GATSLIKEFMLY', NULL, NULL, 21252, 13),
(278725, NULL, 'PR01969', NULL, NULL, 'Tumour necrosis factor receptor 19 signature', NULL, 'TNFACTORR19', NULL, NULL, 15583, 13),
(278726, NULL, 'PR00666', NULL, NULL, 'Pineal opsin signature', NULL, 'PINOPSIN', NULL, NULL, 424, 13),
(278727, NULL, 'PR01293', NULL, NULL, 'Nuclear receptor ROR family signature', NULL, 'RORNUCRECPTR', NULL, NULL, 6446, 13),
(278728, NULL, 'PR01288', NULL, NULL, 'Peroxisome proliferator-activated receptor (1C nuclear receptor) signature', NULL, 'PROXISOMEPAR', NULL, NULL, 828, 13),
(278729, NULL, 'PR01672', NULL, NULL, 'Gamma-aminobutyric-acid A (GABAA) receptor rho 2 subunit signature', NULL, 'GABAARRHO2', NULL, NULL, 5382, 13),
(278730, NULL, 'PR00812', NULL, NULL, 'Bacterial general secretion pathway protein F signature', NULL, 'BCTERIALGSPF', NULL, NULL, 7349, 13),
(278731, NULL, 'PR01505', NULL, NULL, 'Prothrombin signature', NULL, 'PROTHROMBIN', NULL, NULL, 7277, 13),
(278732, NULL, 'PR01669', NULL, NULL, 'Tapasin signature', NULL, 'TAPASIN', NULL, NULL, 5072, 13),
(278733, NULL, 'PR00359', NULL, NULL, 'B-class P450 signature', NULL, 'BP450', NULL, NULL, 6090, 13),
(278734, NULL, 'PR00938', NULL, NULL, 'Brachyury protein family signature', NULL, 'BRACHYURY', NULL, NULL, 5443, 13),
(278735, NULL, 'PR01678', NULL, NULL, 'Kir5 inward rectifier K+ channel signature', NULL, 'KIR5CHANNEL', NULL, NULL, 5340, 13),
(278736, NULL, 'PR01957', NULL, NULL, 'CYP2F P450 family signature', NULL, 'EP450ICYP2F', NULL, NULL, 19504, 13),
(278737, NULL, 'PR01079', NULL, NULL, 'Gamma-aminobutyric-acid A receptor alpha subunit signature', NULL, 'GABAARALPHA', NULL, NULL, 2150, 13),
(278738, NULL, 'PR00220', NULL, NULL, 'Synaptophysin/synaptoporin family signature', NULL, 'SYNAPTOPHYSN', NULL, NULL, 107, 13),
(278739, NULL, 'PR00573', NULL, NULL, 'Interleukin 8B receptor signature', NULL, 'INTRLEUKN8BR', NULL, NULL, 2577, 13),
(278740, NULL, 'PR02012', NULL, NULL, 'RNA (C5-cytosine) methyltransferase NOP2 subfamily signature', NULL, 'RCMTNOP2', NULL, NULL, 2038, 13);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(278741, NULL, 'PR01194', NULL, NULL, 'Fructose transporter (GLUT5) signature', NULL, 'GLUCTRSPORT5', NULL, NULL, 6544, 13),
(278742, NULL, 'PR02110', NULL, NULL, 'Mas-related G protein-coupled receptor D signature', NULL, 'MRGPCRD', NULL, NULL, 26850, 13),
(278743, NULL, 'PR01412', NULL, NULL, 'Cytochrome c-type biogenesis protein CcbS signature', NULL, 'CCBSBIOGNSIS', NULL, NULL, 302, 13),
(278744, NULL, 'PR00979', NULL, NULL, 'Tafazzin signature', NULL, 'TAFAZZIN', NULL, NULL, 4628, 13),
(278745, NULL, 'PR02007', NULL, NULL, 'Pheromone-binding protein Gp-9 signature', NULL, 'ODORANTBPGP9', NULL, NULL, 15599, 13),
(278746, NULL, 'PR00351', NULL, NULL, 'MAS20 (TOM20) import receptor subunit signature', NULL, 'OM20RECEPTOR', NULL, NULL, 5326, 13),
(278747, NULL, 'PR02013', NULL, NULL, 'Aquaporin-1 signature', NULL, 'AQUAPORIN1', NULL, NULL, 13553, 13),
(278748, NULL, 'PR00846', NULL, NULL, 'Glycosyl hydrolase family 56 signature', NULL, 'GLHYDRLASE56', NULL, NULL, 13551, 13),
(278749, NULL, 'PR00768', NULL, NULL, 'Deuterolysin metalloprotease (M35) family signature', NULL, 'DEUTEROLYSIN', NULL, NULL, 6678, 13),
(278750, NULL, 'PR01049', NULL, NULL, 'Phosphorylase kinase family signature', NULL, 'PHOSPHBKNASE', NULL, NULL, 5651, 13),
(278751, NULL, 'PR01848', NULL, NULL, 'U2 auxiliary factor small subunit signature', NULL, 'U2AUXFACTOR', NULL, NULL, 10269, 13),
(278752, NULL, 'PR01766', NULL, NULL, 'Epithelial calcium channel 1 (ECAC1) family signature', NULL, 'ECACCHANNEL1', NULL, NULL, 7602, 13),
(278753, NULL, 'PR00623', NULL, NULL, 'Histone H4 signature', NULL, 'HISTONEH4', NULL, NULL, 2275, 13),
(278754, NULL, 'PR01123', NULL, NULL, 'Flavin-containing monooxygenase (FMO) 3 signature', NULL, 'FMOXYGENASE3', NULL, NULL, 33, 13),
(278755, NULL, 'PR01488', NULL, NULL, 'Gram-negative bacterial RTX toxin determinant A family signature', NULL, 'RTXTOXINA', NULL, NULL, 612, 13),
(278756, NULL, 'PR02101', NULL, NULL, 'Immunogenic miracidial antigen 8I'' signature', NULL, 'A8IMIRACIDIA', NULL, NULL, 24970, 13),
(278757, NULL, 'PR01711', NULL, NULL, 'Autoimmune regulator (AIRE) signature', NULL, 'AIREGULATOR', NULL, NULL, 6044, 13),
(278758, NULL, 'PR01858', NULL, NULL, 'ADAM-TS1 protein signature', NULL, 'ADAMTS1', NULL, NULL, 8239, 13),
(278759, NULL, 'PR00848', NULL, NULL, 'Sperm surface protein PH20 signature', NULL, 'SPERMPH20', NULL, NULL, NULL, 13),
(278760, NULL, 'PR00309', NULL, NULL, 'Arrestin signature', NULL, 'ARRESTIN', NULL, NULL, 3860, 13),
(278761, NULL, 'PR02040', NULL, NULL, 'Cyclin-dependent kinase 2-interacting protein signature', NULL, 'CDK2IP', NULL, NULL, 8784, 13),
(278762, NULL, 'PR00120', NULL, NULL, 'H+-transporting ATPase (proton pump) signature', NULL, 'HATPASE', NULL, NULL, 3303, 13),
(278763, NULL, 'PR01035', NULL, NULL, 'Tetracycline resistance protein signature', NULL, 'TCRTETA', NULL, NULL, 2011, 13),
(278764, NULL, 'PR01355', NULL, NULL, 'Glucagon-like peptide 1 receptor signature', NULL, 'GLUCAGNLIKER', NULL, NULL, 3394, 13),
(278765, NULL, 'PR01443', NULL, NULL, 'Transcription initiation factor TFIID 23-30kDa subunit signature', NULL, 'TFIID30KDSUB', NULL, NULL, 6013, 13),
(278766, NULL, 'PR00012', NULL, NULL, 'Fibronectin type I repeat signature', NULL, 'FNTYPEI', NULL, NULL, NULL, 13),
(278767, NULL, 'PR00209', NULL, NULL, 'Alpha/beta gliadin family signature', NULL, 'GLIADIN', NULL, NULL, NULL, 13),
(278768, NULL, 'PR00595', NULL, NULL, 'P2Y1 purinoceptor signature', NULL, 'P2Y1PRNOCPTR', NULL, NULL, 1797, 13),
(278769, NULL, 'PR01995', NULL, NULL, 'UPF0595 uncharacterised protein signature', NULL, 'UPF0595', NULL, NULL, 19037, 13),
(278770, NULL, 'PR01584', NULL, NULL, 'TASK-1 K+ channel signature', NULL, 'TASK1CHANNEL', NULL, NULL, 7072, 13),
(278771, NULL, 'PR00761', NULL, NULL, 'Bindin precursor signature', NULL, 'BINDIN', NULL, NULL, 4065, 13),
(278772, NULL, 'PR02064', NULL, NULL, 'Downstream neighbour of Son (DONSON) protein signature', NULL, 'DONSON', NULL, NULL, 20791, 13),
(278773, NULL, 'PR00555', NULL, NULL, 'Adenosine A3 receptor signature', NULL, 'ADENOSINEA3R', NULL, NULL, 6784, 13);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(278774, NULL, 'PR01653', NULL, NULL, 'Translationally controlled tumour protein signature', NULL, 'TCTPROTEIN', NULL, NULL, 13732, 13),
(278775, NULL, 'PR00034', NULL, NULL, 'CRP bacterial regulatory protein HTH signature', NULL, 'HTHCRP', NULL, NULL, 11789, 13),
(278776, NULL, 'PR01075', NULL, NULL, 'C.elegans Sel-12 (presenilin) signature', NULL, 'PRESENILNSEL', NULL, NULL, 3365, 13),
(278777, NULL, 'PR01728', NULL, NULL, 'KiSS-1 peptide receptor signature', NULL, 'KISS1RECEPTR', NULL, NULL, 6175, 13),
(278778, NULL, 'PR00095', NULL, NULL, 'Anthranilate synthase component I signature', NULL, 'ANTSNTHASEI', NULL, NULL, 16676, 13),
(278779, NULL, 'PR01382', NULL, NULL, 'Claudin-9 signature', NULL, 'CLAUDIN9', NULL, NULL, 7351, 13),
(278780, NULL, 'PR00054', NULL, NULL, 'Fungal Zn-Cys binuclear cluster signature', NULL, 'FUNGALZNCYS', NULL, NULL, 19114, 13),
(278781, NULL, 'PR00769', NULL, NULL, 'Diphtheria toxin signature', NULL, 'DPTHRIATOXIN', NULL, NULL, 4323, 13),
(278782, NULL, 'PR01291', NULL, NULL, 'Peroxisome proliferator-activated receptor gamma signature', NULL, 'PROXISOMPAGR', NULL, NULL, 682, 13),
(278783, NULL, 'PR01091', NULL, NULL, 'Prepro-orexin signature', NULL, 'OREXINPP', NULL, NULL, 3130, 13),
(278784, NULL, 'PR00076', NULL, NULL, '6-phosphogluconate dehydrogenase signature', NULL, '6PGDHDRGNASE', NULL, NULL, 11177, 13),
(278785, NULL, 'PR01182', NULL, NULL, 'Ornithine decarboxylase signature', NULL, 'ORNDCRBXLASE', NULL, NULL, 6674, 13),
(278786, NULL, 'PR00817', NULL, NULL, 'Beta-type calcitonin signature', NULL, 'CALCITONINB', NULL, NULL, 8639, 13),
(278787, NULL, 'PR01493', NULL, NULL, 'Kv8 potassium channel alpha subunit signature', NULL, 'KV8CHANNEL', NULL, NULL, 7133, 13),
(278788, NULL, 'PR01730', NULL, NULL, 'Macrophage infectivity potentiator signature', NULL, 'INFPOTNTIATR', NULL, NULL, 6374, 13),
(278789, NULL, 'PR01192', NULL, NULL, 'Glucose transporter type 3 (GLUT3) signature', NULL, 'GLUCTRSPORT3', NULL, NULL, 6981, 13),
(278790, NULL, 'PR00580', NULL, NULL, 'Prostanoid EP1 receptor signature', NULL, 'PRSTNOIDEP1R', NULL, NULL, 6697, 13),
(278791, NULL, 'PR01760', NULL, NULL, 'Dishevelled protein signature', NULL, 'DISHEVELLED', NULL, NULL, 956, 13),
(278792, NULL, 'PR01021', NULL, NULL, 'OMPA domain signature', NULL, 'OMPADOMAIN', NULL, NULL, 1934, 13),
(278793, NULL, 'PR00126', NULL, NULL, 'ATP synthase gamma subunit signature', NULL, 'ATPASEGAMMA', NULL, NULL, 1624, 13),
(278794, NULL, 'PR00648', NULL, NULL, 'GPR3 orphan receptor signature', NULL, 'GPR3ORPHANR', NULL, NULL, 3471, 13),
(278795, NULL, 'PR00976', NULL, NULL, 'Ribosomal protein S21 family signature', NULL, 'RIBOSOMALS21', NULL, NULL, 4023, 13),
(278796, NULL, 'PR01705', NULL, NULL, 'Thrombospondin type 1 repeat signature', NULL, 'TSP1REPEAT', NULL, NULL, NULL, 13),
(278797, NULL, 'PR01882', NULL, NULL, 'Lysin signature', NULL, 'LYSIN', NULL, NULL, 6543, 13),
(278798, NULL, 'PR01810', NULL, NULL, 'Annexin type XI signature', NULL, 'ANNEXINXI', NULL, NULL, 9545, 13),
(278799, NULL, 'PR01389', NULL, NULL, 'Cytolethal distending toxin C signature', NULL, 'CDTOXINC', NULL, NULL, 255, 13),
(278800, NULL, 'PR01422', NULL, NULL, 'GPR56 orphan receptor signature', NULL, 'GPR56ORPHANR', NULL, NULL, 6003, 13),
(278801, NULL, 'PR01086', NULL, NULL, 'Na+/H+ exchanger isoform 2 (NHE2) signature', NULL, 'NAHEXCHNGR2', NULL, NULL, 2239, 13),
(278802, NULL, 'PR01460', NULL, NULL, 'KCNQ1 voltage-gated potassium channel signature', NULL, 'KCNQ1CHANNEL', NULL, NULL, 5780, 13),
(278803, NULL, 'PR01756', NULL, NULL, 'Yersinia outer membrane adhesin signature', NULL, 'OMADHESIN', NULL, NULL, 6116, 13),
(278804, NULL, 'PR00109', NULL, NULL, 'Tyrosine kinase catalytic domain signature', NULL, 'TYRKINASE', NULL, NULL, 792, 13),
(278805, NULL, 'PR01811', NULL, NULL, 'Annexin type XIII signature', NULL, 'ANNEXINXIII', NULL, NULL, 9635, 13),
(278806, NULL, 'PR00688', NULL, NULL, 'Xylose isomerase signature', NULL, 'XYLOSISMRASE', NULL, NULL, 2374, 13),
(278807, NULL, 'PR01272', NULL, NULL, 'Acetoin utilisation ACUC protein signature', NULL, 'ACUCPROTEIN', NULL, NULL, 948, 13);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(278808, NULL, 'PR01459', NULL, NULL, 'KCNQ voltage-gated potassium channel family signature', NULL, 'KCNQCHANNEL', NULL, NULL, 7086, 13),
(278809, NULL, 'PR01336', NULL, NULL, 'Chlamydia cysteine-rich outer membrane protein 6 signature', NULL, 'CHLAMIDIAOM6', NULL, NULL, 6499, 13),
(278810, NULL, 'PR00551', NULL, NULL, '2-S globulin family signature', NULL, '2SGLOBULIN', NULL, NULL, 3753, 13),
(278811, NULL, 'PR00503', NULL, NULL, 'Bromodomain signature', NULL, 'BROMODOMAIN', NULL, NULL, 5971, 13),
(278812, NULL, 'PR01052', NULL, NULL, 'Metabotropic glutamate receptor 2 signature', NULL, 'MTABOTROPC2R', NULL, NULL, 6430, 13),
(278813, NULL, 'PR01902', NULL, NULL, 'Cysteinyl leukotriene receptor 1 signature', NULL, 'CYSLT1RECPTR', NULL, NULL, 8619, 13),
(278814, NULL, 'PR01208', NULL, NULL, 'Na-K-Cl co-transporter 1 signature', NULL, 'NAKCLTRSPRT1', NULL, NULL, 6548, 13),
(278815, NULL, 'PR00594', NULL, NULL, 'P2Y2 purinoceptor signature', NULL, 'P2Y2PRNOCPTR', NULL, NULL, 4522, 13),
(278816, NULL, 'PR00387', NULL, NULL, '3''5''-cyclic nucleotide phosphodiesterase signature', NULL, 'PDIESTERASE1', NULL, NULL, 15674, 13),
(278817, NULL, 'PR01715', NULL, NULL, 'Ferrichrome-binding periplasmic protein signature', NULL, 'FERRIBNDNGPP', NULL, NULL, NULL, 13),
(278818, NULL, 'PR01249', NULL, NULL, 'Ribosomal protein L31 signature', NULL, 'RIBOSOMALL31', NULL, NULL, 5403, 13),
(278819, NULL, 'PR00867', NULL, NULL, 'DNA-polymerase gamma (family A) signature', NULL, 'DNAPOLG', NULL, NULL, 361, 13),
(278820, NULL, 'PR01041', NULL, NULL, 'Methionyl-tRNA synthetase signature', NULL, 'TRNASYNTHMET', NULL, NULL, 33402, 13),
(278821, NULL, 'PR01601', NULL, NULL, 'Voltage-dependent calcium channel gamma-1 subunit signature', NULL, 'VDCCGAMMA1', NULL, NULL, 7276, 13),
(278822, NULL, 'PR01780', NULL, NULL, 'Lantibiotic regulatory protein signature', NULL, 'LANTIREGPROT', NULL, NULL, 7783, 13),
(278823, NULL, 'PR01064', NULL, NULL, 'Orexin receptor signature', NULL, 'OREXINR', NULL, NULL, 1221, 13),
(278824, NULL, 'PR02111', NULL, NULL, 'Mas-related G protein-coupled receptor E signature', NULL, 'MRGPCRE', NULL, NULL, 26659, 13),
(278825, NULL, 'PR01186', NULL, NULL, 'Integrin beta subunit signature', NULL, 'INTEGRINB', NULL, NULL, 12563, 13),
(278826, NULL, 'PR01214', NULL, NULL, 'Gamma-synuclein signature', NULL, 'GSYNUCLEIN', NULL, NULL, 6796, 13),
(278827, NULL, 'PR01477', NULL, NULL, 'Leukotriene B4 type 1 receptor signature', NULL, 'LTB1RECEPTOR', NULL, NULL, 7492, 13),
(278828, NULL, 'PR00842', NULL, NULL, 'Plant beta-amylase signature', NULL, 'GLHYDLASE14B', NULL, NULL, 51, 13),
(278829, NULL, 'PR01724', NULL, NULL, 'Gamma-aminobutyric-acid A receptor pi subunit signature', NULL, 'GABAARPI', NULL, NULL, 6318, 13),
(278830, NULL, 'PR00545', NULL, NULL, 'Retinoid X receptor signature', NULL, 'RETINOIDXR', NULL, NULL, 2106, 13),
(278831, NULL, 'PR00319', NULL, NULL, 'Beta G protein (transducin) signature', NULL, 'GPROTEINB', NULL, NULL, 5076, 13),
(278832, NULL, 'PR00001', NULL, NULL, 'Coagulation factor GLA domain signature', NULL, 'GLABLOOD', NULL, NULL, 4995, 13),
(278833, NULL, 'PR00483', NULL, NULL, 'Bacterial acid phosphatase class A signature', NULL, 'BACPHPHTASE', NULL, NULL, 2024, 13),
(278834, NULL, 'PR00420', NULL, NULL, 'Aromatic-ring hydroxylase (flavoprotein monooxygenase) signature', NULL, 'RNGMNOXGNASE', NULL, NULL, NULL, 13),
(278835, NULL, 'PR01608', NULL, NULL, 'Salmonella/Shigella invasin protein C signature', NULL, 'BACINVASINC', NULL, NULL, NULL, 13),
(278836, NULL, 'PR01131', NULL, NULL, 'Connexin36 (Cx36) signature', NULL, 'CONNEXIN36', NULL, NULL, 397, 13),
(278837, NULL, 'PR00289', NULL, NULL, 'Disintegrin signature', NULL, 'DISINTEGRIN', NULL, NULL, 3118, 13),
(278838, NULL, 'PR00416', NULL, NULL, 'Eukaryotic DNA topoisomerase I signature', NULL, 'EUTPISMRASEI', NULL, NULL, 5351, 13),
(278839, NULL, 'PR00948', NULL, NULL, 'Elicitin signature', NULL, 'ELICITIN', NULL, NULL, 206, 13),
(278840, NULL, 'PR00607', NULL, NULL, 'Class IE cytochrome C signature', NULL, 'CYTCHROMECIE', NULL, NULL, 6016, 13); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(278841, NULL, 'PR00111', NULL, NULL, 'Alpha/beta hydrolase fold signature', NULL, 'ABHYDROLASE', NULL, NULL, 3611, 13),
(278842, NULL, 'PR01067', NULL, NULL, 'P2Y5 orphan receptor signature', NULL, 'P2Y5ORPHANR', NULL, NULL, NULL, 13),
(278843, NULL, 'PR00203', NULL, NULL, 'Amyloid A4 protein precursor signature', NULL, 'AMYLOIDA4', NULL, NULL, 7454, 13),
(278844, NULL, 'PR01994', NULL, NULL, 'Antirepressor protein ANT signature', NULL, 'ANTIREPRESSR', NULL, NULL, 20796, 13),
(278845, NULL, 'PR00334', NULL, NULL, 'HMW kininogen signature', NULL, 'KININOGEN', NULL, NULL, 6547, 13),
(278846, NULL, 'PR01619', NULL, NULL, 'Gamma-aminobutyric-acid A receptor alpha 6 subunit signature', NULL, 'GABAARALPHA6', NULL, NULL, 99, 13),
(278847, NULL, 'PR00414', NULL, NULL, 'Palmitoyl protein thioesterase signature', NULL, 'PPTHIESTRASE', NULL, NULL, 6708, 13),
(278848, NULL, 'PR01910', NULL, NULL, 'Atypical dual specificity phosphatase subfamily B signature', NULL, 'ADSPHPHTASEB', NULL, NULL, 18630, 13),
(278849, NULL, 'PR00621', NULL, NULL, 'Histone H2B signature', NULL, 'HISTONEH2B', NULL, NULL, 5842, 13),
(278850, NULL, 'PR01145', NULL, NULL, 'Thyrotropin receptor precursor signature', NULL, 'TSHRECEPTOR', NULL, NULL, 428, 13),
(278851, NULL, 'PR00888', NULL, NULL, 'Smooth muscle protein/calponin family signature', NULL, 'SM22CALPONIN', NULL, NULL, 893, 13),
(278852, NULL, 'PR00005', NULL, NULL, 'Apple domain signature', NULL, 'APPLEDOMAIN', NULL, NULL, 1620, 13),
(278853, NULL, 'PR00546', NULL, NULL, 'Thyroid hormone receptor (1D nuclear receptor) signature', NULL, 'THYROIDHORMR', NULL, NULL, 3393, 13),
(278854, NULL, 'PR00370', NULL, NULL, 'Flavin-containing monooxygenase (FMO) signature', NULL, 'FMOXYGENASE', NULL, NULL, 199, 13),
(278855, NULL, 'PR01008', NULL, NULL, 'Flagellar L-ring protein signature', NULL, 'FLGLRINGFLGH', NULL, NULL, 5637, 13),
(278856, NULL, 'PR00393', NULL, NULL, 'Parathyroid hormone receptor signature', NULL, 'PTRHORMONER', NULL, NULL, 5039, 13),
(278857, NULL, 'PR00701', NULL, NULL, '60kDa inner membrane protein signature', NULL, '60KDINNERMP', NULL, NULL, 3041, 13),
(278858, NULL, 'PR00954', NULL, NULL, 'Flagellar motor switch protein FliG signature', NULL, 'FLGMOTORFLIG', NULL, NULL, 2510, 13),
(278859, NULL, 'PR00159', NULL, NULL, '2Fe-2S ferredoxin signature', NULL, '2FE2SFRDOXIN', NULL, NULL, NULL, 13),
(278860, NULL, 'PR00327', NULL, NULL, 'Ice nucleation protein signature', NULL, 'ICENUCLEATN', NULL, NULL, 4622, 13),
(278861, NULL, 'PR00774', NULL, NULL, 'Guanylin precursor signature', NULL, 'GUANYLIN', NULL, NULL, 4544, 13),
(278862, NULL, 'PR00719', NULL, NULL, 'LMW phosphotyrosine protein phosphatase signature', NULL, 'LMWPTPASE', NULL, NULL, 11322, 13),
(278863, NULL, 'PR01164', NULL, NULL, 'Gamma-tubulin signature', NULL, 'GAMMATUBULIN', NULL, NULL, 6642, 13),
(278864, NULL, 'PR00476', NULL, NULL, 'ATP-dependent phosphofructokinase family signature', NULL, 'PHFRCTKINASE', NULL, NULL, 14940, 13),
(278865, NULL, 'PR01408', NULL, NULL, 'Macrophage scavenger receptor signature', NULL, 'MACSCAVRCPTR', NULL, NULL, 7487, 13),
(278866, NULL, 'PR00123', NULL, NULL, 'ATP synthase A subunit signature', NULL, 'ATPASEA', NULL, NULL, 5815, 13),
(278867, NULL, 'PR01361', NULL, NULL, 'Apical membrane antigen 1 signature', NULL, 'MEROZOITESA', NULL, NULL, 3240, 13),
(278868, NULL, 'PR00372', NULL, NULL, 'Biopterin-dependent aromatic amino acid hydroxylase signature', NULL, 'FYWHYDRXLASE', NULL, NULL, 17063, 13),
(278869, NULL, 'PR01833', NULL, NULL, 'Vascular endothelial growth factor receptor type 1 signature', NULL, 'VEGFRECEPTR1', NULL, NULL, 10151, 13),
(278870, NULL, 'PR00257', NULL, NULL, 'Plant photosystem I psaA and psaB protein signature', NULL, 'PHOTSYSPSAAB', NULL, NULL, 2036, 13),
(278871, NULL, 'PR01228', NULL, NULL, 'Eggshell protein signature', NULL, 'EGGSHELL', NULL, NULL, NULL, 13),
(278872, NULL, 'PR00919', NULL, NULL, 'Thermophilic metalloprotease (M29) signature', NULL, 'THERMOPTASE', NULL, NULL, 4924, 13),
(278873, NULL, 'PR01258', NULL, NULL, 'Occludin signature', NULL, 'OCCLUDIN', NULL, NULL, 5385, 13);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(278874, NULL, 'PR00051', NULL, NULL, 'Bacterial chromosomal replication initiator (DNAA) signature', NULL, 'DNAA', NULL, NULL, 20615, 13),
(278875, NULL, 'PR00328', NULL, NULL, 'GTP-binding SAR1 protein signature', NULL, 'SAR1GTPBP', NULL, NULL, 2330, 13),
(278876, NULL, 'PR01302', NULL, NULL, 'Type III secretion system inner membrane P protein family signature', NULL, 'TYPE3IMPPROT', NULL, NULL, 5727, 13),
(278877, NULL, 'PR00104', NULL, NULL, 'cGMP-dependent protein kinase signature', NULL, 'CGMPKINASE', NULL, NULL, 6025, 13),
(278878, NULL, 'PR00818', NULL, NULL, 'Islet amyloid protein (amylin) signature', NULL, 'ISLETAMYLOID', NULL, NULL, 5940, 13),
(278879, NULL, 'PR02042', NULL, NULL, 'Cattle cerebrum and skeletal muscle-specific protein 1 signature', NULL, 'CCSMST1', NULL, NULL, 15507, 13),
(278880, NULL, 'PR01099', NULL, NULL, 'Hydroxyethylthiazole kinase family signature', NULL, 'HYETHTZKNASE', NULL, NULL, 6810, 13),
(278881, NULL, 'PR01726', NULL, NULL, 'Histamine H4 receptor signature', NULL, 'HISTAMINEH4R', NULL, NULL, 6162, 13),
(278882, NULL, 'PR01232', NULL, NULL, 'Na+/HCO3- co-transporter signature', NULL, 'NAHCO3TRSPRT', NULL, NULL, 148, 13),
(278883, NULL, 'PR01762', NULL, NULL, 'Dishevelled-2 protein signature', NULL, 'DISHEVELLED2', NULL, NULL, 7763, 13),
(278884, NULL, 'PR01558', NULL, NULL, 'C-C chemokine receptor type 11 signature', NULL, 'CHEMOKINER11', NULL, NULL, 6559, 13),
(278885, NULL, 'PR00036', NULL, NULL, 'LacI bacterial regulatory protein HTH signature', NULL, 'HTHLACI', NULL, NULL, 411, 13),
(278886, NULL, 'PR01204', NULL, NULL, 'Glycine neurotransmitter transporter type 1 (GLYT-1) signature', NULL, 'GLY1TRNSPORT', NULL, NULL, 333, 13),
(278887, NULL, 'PR01301', NULL, NULL, 'Regulator of G protein signalling (RGS) protein signature', NULL, 'RGSPROTEIN', NULL, NULL, 11395, 13),
(278888, NULL, 'PR00415', NULL, NULL, 'Aconitase family signature', NULL, 'ACONITASE', NULL, NULL, 4217, 13),
(278889, NULL, 'PR00650', NULL, NULL, 'GPR12 orphan receptor signature', NULL, 'GPR12ORPHANR', NULL, NULL, 5576, 13),
(278890, NULL, 'PR01572', NULL, NULL, 'Type 2 neuropeptide FF receptor signature', NULL, 'NPFFRECEPTR2', NULL, NULL, 7414, 13),
(278891, NULL, 'PR01580', NULL, NULL, 'KCNAB voltage-gated K+ channel beta-3 subunit signature', NULL, 'KCNAB3CHANEL', NULL, NULL, 7120, 13),
(278892, NULL, 'PR00223', NULL, NULL, 'Geminivirus AR1/BR1 coat protein signature', NULL, 'GEMCOATARBR1', NULL, NULL, 4727, 13),
(278893, NULL, 'PR01815', NULL, NULL, 'Beta-site APP cleaving enzyme (BACE) family signature', NULL, 'BACEFAMILY', NULL, NULL, 10277, 13),
(278894, NULL, 'PR00496', NULL, NULL, 'Napin signature', NULL, 'NAPIN', NULL, NULL, 5887, 13),
(278895, NULL, 'PR00075', NULL, NULL, 'Fatty acid desaturase family 1 signature', NULL, 'FACDDSATRASE', NULL, NULL, 7445, 13),
(278896, NULL, 'PR01271', NULL, NULL, 'Histone deacetylase signature', NULL, 'HISDACETLASE', NULL, NULL, 539, 13),
(278897, NULL, 'PR00004', NULL, NULL, 'Anaphylatoxin domain signature', NULL, 'ANAPHYLATOXN', NULL, NULL, 4012, 13),
(278898, NULL, 'PR00003', NULL, NULL, '4-disulphide core signature', NULL, '4DISULPHCORE', NULL, NULL, 7006, 13),
(278899, NULL, 'PR00380', NULL, NULL, 'Kinesin heavy chain signature', NULL, 'KINESINHEAVY', NULL, NULL, 3230, 13),
(278900, NULL, 'PR02027', NULL, NULL, 'Activity-regulated cytoskeleton-associated protein signature', NULL, 'ARCARG31', NULL, NULL, 19948, 13),
(278901, NULL, 'PR00456', NULL, NULL, 'Ribosomal protein P2 signature', NULL, 'RIBOSOMALP2', NULL, NULL, 4122, 13),
(278902, NULL, 'PR00398', NULL, NULL, 'Steroid hormone receptor signature', NULL, 'STRDHORMONER', NULL, NULL, 5273, 13),
(278903, NULL, 'PR01651', NULL, NULL, 'Protein-export SecG membrane protein signature', NULL, 'SECGEXPORT', NULL, NULL, 3030, 13),
(278904, NULL, 'PR01691', NULL, NULL, 'TRAAK K+ channel signature', NULL, 'TRAAKCHANNEL', NULL, NULL, 6462, 13),
(278905, NULL, 'PR00480', NULL, NULL, 'Astacin family signature', NULL, 'ASTACIN', NULL, NULL, 4051, 13),
(278906, NULL, 'PR01442', NULL, NULL, 'Cellulose synthase subunit D signature', NULL, 'CELLSNTHASED', NULL, NULL, 17182, 13);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(278907, NULL, 'PR00765', NULL, NULL, 'Carboxypeptidase A metalloprotease (M14) family signature', NULL, 'CRBOXYPTASEA', NULL, NULL, 211, 13),
(278908, NULL, 'PR00345', NULL, NULL, 'Stathmin family signature', NULL, 'STATHMIN', NULL, NULL, 3445, 13),
(278909, NULL, 'PR00930', NULL, NULL, 'High mobility group protein (HMGY) signature', NULL, 'HIGHMOBLTYIY', NULL, NULL, 3800, 13),
(278910, NULL, 'PR00646', NULL, NULL, 'RDC1 orphan receptor signature', NULL, 'RDC1ORPHANR', NULL, NULL, 6953, 13),
(278911, NULL, 'PR02093', NULL, NULL, 'HDA1 complex subunit 3 signature', NULL, 'HDA1SUBUNIT3', NULL, NULL, 26057, 13),
(278912, NULL, 'PR01540', NULL, NULL, 'Interleukin-1 binding protein precursor signature', NULL, 'INTRLEUKN1BP', NULL, NULL, 1998, 13),
(278913, NULL, 'PR01961', NULL, NULL, 'Tumour necrosis factor receptor 11 signature', NULL, 'TNFACTORR11', NULL, NULL, 15553, 13),
(278914, NULL, 'PR00322', NULL, NULL, 'G10 protein signature', NULL, 'G10', NULL, NULL, 4598, 13),
(278915, NULL, 'PR00439', NULL, NULL, '11-S seed storage protein family signature', NULL, '11SGLOBULIN', NULL, NULL, 2568, 13),
(278916, NULL, 'PR00626', NULL, NULL, 'Calreticulin signature', NULL, 'CALRETICULIN', NULL, NULL, 3101, 13),
(278917, NULL, 'PR01367', NULL, NULL, 'Beta- and gamma-crystallin family signature', NULL, 'BGCRYSTALLIN', NULL, NULL, 2093, 13),
(278918, NULL, 'PR01410', NULL, NULL, 'Cytochrome c-type biogenesis protein signature', NULL, 'CCBIOGENESIS', NULL, NULL, 1, 13),
(278919, NULL, 'PR00541', NULL, NULL, 'Muscarinic M4 receptor signature', NULL, 'MUSCRINICM4R', NULL, NULL, 3395, 13),
(278920, NULL, 'PR01140', NULL, NULL, 'Gap junction beta-3 protein (Cx31) signature', NULL, 'CONNEXINB3', NULL, NULL, 6716, 13),
(278921, NULL, 'PR00098', NULL, NULL, 'Carbamoyl-phosphate synthase protein CPSase domain signature', NULL, 'CPSASE', NULL, NULL, 580, 13),
(278922, NULL, 'PR01630', NULL, NULL, 'L-type voltage-dependent calcium channel alpha-1 subunit signature', NULL, 'LVDCCALPHA1', NULL, NULL, 256, 13),
(278923, NULL, 'PR01751', NULL, NULL, 'Transcription factor AP-2 gamma signature', NULL, 'AP2CTNSCPFCT', NULL, NULL, 6415, 13),
(278924, NULL, 'PR00757', NULL, NULL, 'Flavin-containing amine oxidase signature', NULL, 'AMINEOXDASEF', NULL, NULL, 3465, 13),
(278925, NULL, 'PR00031', NULL, NULL, 'Lambda-repressor HTH signature', NULL, 'HTHREPRESSR', NULL, NULL, 2940, 13),
(278926, NULL, 'PR00482', NULL, NULL, 'Omptin serine protease signature', NULL, 'OMPTIN', NULL, NULL, 2728, 13),
(278927, NULL, 'PR00011', NULL, NULL, 'Type III EGF-like signature', NULL, 'EGFLAMININ', NULL, NULL, NULL, 13),
(278928, NULL, 'PR01195', NULL, NULL, 'GAT-1 GABA neurotransmitter transporter signature', NULL, 'GAT1TRNSPORT', NULL, NULL, 7242, 13),
(278929, NULL, 'PR01694', NULL, NULL, 'Brain-specific angiogenesis inhibitor precursor signature', NULL, 'BAIPRECURSOR', NULL, NULL, 6230, 13),
(278930, NULL, 'PR01392', NULL, NULL, 'Anthrax toxin LF subunit signature', NULL, 'ANTHRAXTOXNA', NULL, NULL, 7461, 13),
(278931, NULL, 'PR01873', NULL, NULL, 'Cytochrome c oxidase subunit IV signature', NULL, 'CYTCOXIDASE4', NULL, NULL, 8552, 13),
(278932, NULL, 'PR00475', NULL, NULL, 'Hexokinase family signature', NULL, 'HEXOKINASE', NULL, NULL, NULL, 13),
(278933, NULL, 'PR00712', NULL, NULL, 'Brain natriuretic peptide signature', NULL, 'BNATPEPTIDE', NULL, NULL, 5204, 13),
(278934, NULL, 'PR00435', NULL, NULL, 'Interleukin-7 signature', NULL, 'INTERLEUKIN7', NULL, NULL, 1376, 13),
(278935, NULL, 'PR01023', NULL, NULL, 'Sodium-type flagellar protein MotY precursor signature', NULL, 'NAFLGMOTY', NULL, NULL, NULL, 13),
(278936, NULL, 'PR01679', NULL, NULL, 'Kir7 inward rectifier K+ channel signature', NULL, 'KIR7CHANNEL', NULL, NULL, 5114, 13),
(278937, NULL, 'PR00886', NULL, NULL, 'High mobility group (HMG1/HMG2) protein signature', NULL, 'HIGHMOBLTY12', NULL, NULL, NULL, 13),
(278938, NULL, 'PR01485', NULL, NULL, 'Thrombopoietin signature', NULL, 'THROMBOPTN', NULL, NULL, 7410, 13),
(278939, NULL, 'PR01159', NULL, NULL, 'DNA gyrase subunit B signature', NULL, 'DNAGYRASEB', NULL, NULL, 5985, 13);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(278940, NULL, 'PR00866', NULL, NULL, 'RNA-dependent DNA-polymerase (msDNA) signature', NULL, 'RNADNAPOLMS', NULL, NULL, 1585, 13),
(278941, NULL, 'PR00831', NULL, NULL, 'Neurohypophysial hormone signature', NULL, 'NEUROPHYSIN', NULL, NULL, 24, 13),
(278942, NULL, 'PR00982', NULL, NULL, 'Lysyl-tRNA synthetase signature', NULL, 'TRNASYNTHLYS', NULL, NULL, 19875, 13),
(278943, NULL, 'PR00749', NULL, NULL, 'Lysozyme G signature', NULL, 'LYSOZYMEG', NULL, NULL, 1128, 13),
(278944, NULL, 'PR00325', NULL, NULL, 'Germin signature', NULL, 'GERMIN', NULL, NULL, 2147, 13),
(278945, NULL, 'PR01796', NULL, NULL, 'Voltage-dependent calcium channel gamma-8 subunit signature', NULL, 'VDCCGAMMA8', NULL, NULL, 7698, 13),
(278946, NULL, 'PR01160', NULL, NULL, 'Gamma-aminobutyric-acid A receptor beta subunit signature', NULL, 'GABAARBETA', NULL, NULL, 5663, 13),
(278947, NULL, 'PR01915', NULL, NULL, 'Neurotrophin-4 signature', NULL, 'NEUROTROPHN4', NULL, NULL, 18856, 13),
(278948, NULL, 'PR00464', NULL, NULL, 'Group II E-class P450 signature', NULL, 'EP450II', NULL, NULL, 6478, 13),
(278949, NULL, 'PR00987', NULL, NULL, 'Glutamyl-tRNA synthetase signature', NULL, 'TRNASYNTHGLU', NULL, NULL, 220, 13),
(278950, NULL, 'PR00896', NULL, NULL, 'Vasopressin receptor signature', NULL, 'VASOPRESSINR', NULL, NULL, 4855, 13),
(278951, NULL, 'PR02062', NULL, NULL, '78 kDa centrosomal protein signature', NULL, 'CENTROSOME78', NULL, NULL, 25731, 13),
(278952, NULL, 'PR01693', NULL, NULL, 'Cyanase signature', NULL, 'CYANASE', NULL, NULL, 6040, 13),
(278953, NULL, 'PR00507', NULL, NULL, 'N12 class N6 adenine-specific DNA methyltransferase signature', NULL, 'N12N6MTFRASE', NULL, NULL, NULL, 13),
(278954, NULL, 'PR01683', NULL, NULL, 'CYP1A P450 family signature', NULL, 'EP450ICYP1A', NULL, NULL, 5243, 13),
(278955, NULL, 'PR00441', NULL, NULL, 'G protein alpha subunit group I signature', NULL, 'GPROTEINAI', NULL, NULL, 7256, 13),
(278956, NULL, 'PR00100', NULL, NULL, 'Aspartate/ornithine carbamoyltransferase superfamily signature', NULL, 'AOTCASE', NULL, NULL, 10498, 13),
(278957, NULL, 'PR00249', NULL, NULL, 'Secretin-like GPCR superfamily signature', NULL, 'GPCRSECRETIN', NULL, NULL, 172, 13),
(278958, NULL, 'PR02104', NULL, NULL, 'Inheritance of peroxisomes protein 2 signature', NULL, 'INPROXISOME2', NULL, NULL, 26413, 13),
(278959, NULL, 'PR02107', NULL, NULL, 'Inositol 1,4,5-trisphosphate receptor-interacting protein signature', NULL, 'INOS145TPRIP', NULL, NULL, 24563, 13),
(278960, NULL, 'PR00275', NULL, NULL, 'Glucagon polypeptide hormone superfamily signature', NULL, 'GLUCAGON', NULL, NULL, 5895, 13),
(278961, NULL, 'PR01285', NULL, NULL, 'Orphan nuclear receptor HMR signature', NULL, 'HMRNUCRECPTR', NULL, NULL, 915, 13),
(278962, NULL, 'PR00680', NULL, NULL, 'P-type trefoil domain signature', NULL, 'PTREFOIL', NULL, NULL, 13806, 13),
(278963, NULL, 'PR00386', NULL, NULL, 'P53 tumour supressor signature', NULL, 'P53SUPPRESSR', NULL, NULL, 1310, 13),
(278964, NULL, 'PR01604', NULL, NULL, 'KCNE voltage-gated K+ channel subfamily E1 signature', NULL, 'KCNE1CHANNEL', NULL, NULL, 204, 13),
(278965, NULL, 'PR00373', NULL, NULL, 'Glycoprotein hormone receptor signature', NULL, 'GLYCHORMONER', NULL, NULL, 1493, 13),
(278966, NULL, 'PR00037', NULL, NULL, 'LacR bacterial regulatory protein HTH signature', NULL, 'HTHLACR', NULL, NULL, 1253, 13),
(278967, NULL, 'PR01864', NULL, NULL, 'Bcl-X apoptosis regulator protein signature', NULL, 'APOPREGBCLX', NULL, NULL, 8857, 13),
(278968, NULL, 'PR00234', NULL, NULL, 'HIV-1 matrix protein signature', NULL, 'HIV1MATRIX', NULL, NULL, 3662, 13),
(278969, NULL, 'PR01384', NULL, NULL, 'Claudin-11 signature', NULL, 'CLAUDIN11', NULL, NULL, 6281, 13),
(278970, NULL, 'PR01870', NULL, NULL, 'T-cell surface CD2 antigen signature', NULL, 'CD2ANTIGEN', NULL, NULL, 17923, 13),
(278971, NULL, 'PR01428', NULL, NULL, 'Protease activated receptor precursor signature', NULL, 'PROTEASEAR', NULL, NULL, 6158, 13),
(278972, NULL, 'PR01095', NULL, NULL, 'TASK K+ channel signature', NULL, 'TASKCHANNEL', NULL, NULL, 995, 13);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(278973, NULL, 'PR00040', NULL, NULL, 'MerR bacterial regulatory protein HTH signature', NULL, 'HTHMERR', NULL, NULL, 5889, 13),
(278974, NULL, 'PR02028', NULL, NULL, 'C-Myc-binding protein signature', NULL, 'CMYCBINDINGP', NULL, NULL, NULL, 13),
(278975, NULL, 'PR01480', NULL, NULL, 'Neurotensin type 1 receptor signature', NULL, 'NEUROTENSN1R', NULL, NULL, 7177, 13),
(278976, NULL, 'PR00583', NULL, NULL, 'Prostanoid EP3 receptor type 1 signature', NULL, 'PRSTNOIDE31R', NULL, NULL, 3859, 13),
(278977, NULL, 'PR00360', NULL, NULL, 'C2 domain signature', NULL, 'C2DOMAIN', NULL, NULL, 2719, 13),
(278978, NULL, 'PR01971', NULL, NULL, 'Tumour necrosis factor receptor 21 signature', NULL, 'TNFACTORR21', NULL, NULL, 15932, 13),
(278979, NULL, 'PR00358', NULL, NULL, 'Bombesin receptor signature', NULL, 'BOMBESINR', NULL, NULL, 5624, 13),
(278980, NULL, 'PR00433', NULL, NULL, 'Interleukin-6/G-CSF/MGF family signature', NULL, 'IL6GCSFMGF', NULL, NULL, 24765, 13),
(278981, NULL, 'PR00045', NULL, NULL, 'Sigma-54 factor signature', NULL, 'SIGMA54FCT', NULL, NULL, 4668, 13),
(278982, NULL, 'PR00687', NULL, NULL, 'Tryptophan RNA-binding attenuator protein signature', NULL, 'TRPRNAAP', NULL, NULL, 4841, 13),
(278983, NULL, 'PR01089', NULL, NULL, 'Neuregulin family signature', NULL, 'NEUREGULIN', NULL, NULL, 19992, 13),
(278984, NULL, 'PR00960', NULL, NULL, 'LmbP protein signature', NULL, 'LMBPPROTEIN', NULL, NULL, 1323, 13),
(278985, NULL, 'PR00047', NULL, NULL, 'C4-type steroid receptor zinc finger signature', NULL, 'STROIDFINGER', NULL, NULL, 3273, 13),
(278986, NULL, 'PR01520', NULL, NULL, 'Zeta-tubulin signature', NULL, 'ZETATUBULIN', NULL, NULL, 585, 13),
(278987, NULL, 'PR00068', NULL, NULL, 'Cu-Zn-superoxide dismutase family signature', NULL, 'CUZNDISMTASE', NULL, NULL, 3239, 13),
(278988, NULL, 'PR00980', NULL, NULL, 'Alanyl-tRNA synthetase signature', NULL, 'TRNASYNTHALA', NULL, NULL, 5853, 13),
(278989, NULL, 'PR01750', NULL, NULL, 'Transcription factor AP-2 beta signature', NULL, 'AP2BTNSCPFCT', NULL, NULL, 6387, 13),
(278990, NULL, 'PR00634', NULL, NULL, 'Major pollen allergen Bet V1 signature', NULL, 'BETALLERGEN', NULL, NULL, 24848, 13),
(278991, NULL, 'PR01754', NULL, NULL, 'Streptothricin acetyltransferase signature', NULL, 'SACTRNSFRASE', NULL, NULL, 6054, 13),
(278992, NULL, 'PR00255', NULL, NULL, 'Natriuretic peptide receptor signature', NULL, 'NATPEPTIDER', NULL, NULL, 1300, 13),
(278993, NULL, 'PR00744', NULL, NULL, 'Glycosyl hydrolase family 37 signature', NULL, 'GLHYDRLASE37', NULL, NULL, 3003, 13),
(278994, NULL, 'PR00692', NULL, NULL, 'T-cell surface glycoprotein CD4 signature', NULL, 'CD4TCANTIGEN', NULL, NULL, 3189, 13),
(278995, NULL, 'PR01831', NULL, NULL, 'Trace amine receptor 1 signature', NULL, 'TRACEAMINE1R', NULL, NULL, 10239, 13),
(278996, NULL, 'PR00669', NULL, NULL, 'Inhibin alpha chain signature', NULL, 'INHIBINA', NULL, NULL, NULL, 13),
(278997, NULL, 'PR01880', NULL, NULL, 'Fibritin signature', NULL, 'FIBRITIN', NULL, NULL, 14321, 13),
(278998, NULL, 'PR02090', NULL, NULL, 'HAUS augmin-like complex subunit 4 signature', NULL, 'HAUSAUGMINL4', NULL, NULL, 26034, 13),
(278999, NULL, 'PR01913', NULL, NULL, 'Nerve growth factor beta subunit signature', NULL, 'NGFBETA', NULL, NULL, 20128, 13),
(279000, NULL, 'PR00317', NULL, NULL, 'Ependymin signature', NULL, 'EPENDYMIN', NULL, NULL, 571, 13),
(279001, NULL, 'PR00804', NULL, NULL, 'Vitamin D-binding protein signature', NULL, 'VITAMNDBNDNG', NULL, NULL, 1755, 13),
(279002, NULL, 'PR00237', NULL, NULL, 'Rhodopsin-like GPCR superfamily signature', NULL, 'GPCRRHODOPSN', NULL, NULL, 4866, 13),
(279003, NULL, 'PR01244', NULL, NULL, 'Peropsin signature', NULL, 'PEROPSIN', NULL, NULL, 588, 13),
(279004, NULL, 'PR01111', NULL, NULL, 'CLC-0 chloride channel signature', NULL, 'CLCHANNEL0', NULL, NULL, 94, 13),
(279005, NULL, 'PR01212', NULL, NULL, 'Alpha-synuclein signature', NULL, 'ASYNUCLEIN', NULL, NULL, 6792, 13),
(279006, NULL, 'PR00242', NULL, NULL, 'Dopamine receptor signature', NULL, 'DOPAMINER', NULL, NULL, 4376, 13);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(279007, NULL, 'PR01386', NULL, NULL, 'Cytochrome c-type biogenesis protein CcmC signature', NULL, 'CCMCBIOGNSIS', NULL, NULL, 7, 13),
(279008, NULL, 'PR02051', NULL, NULL, 'Protein family FAM175 signature', NULL, 'PROTEINF175', NULL, NULL, 15851, 13),
(279009, NULL, 'PR01944', NULL, NULL, 'Fish interleukin-11 signature', NULL, 'INTLKN11FISH', NULL, NULL, 21157, 13),
(279010, NULL, 'PR00295', NULL, NULL, 'Stefin A signature', NULL, 'STEFINA', NULL, NULL, 3404, 13),
(279011, NULL, 'PR00891', NULL, NULL, 'Rab GDI/REP protein family signature', NULL, 'RABGDIREP', NULL, NULL, 19834, 13),
(279012, NULL, 'PR01620', NULL, NULL, 'Gamma-aminobutyric-acid A receptor gamma subunit signature', NULL, 'GABAARGAMMA', NULL, NULL, 236, 13),
(279013, NULL, 'PR00119', NULL, NULL, 'P-type cation-transporting ATPase superfamily signature', NULL, 'CATATPASE', NULL, NULL, NULL, 13),
(279014, NULL, 'PR01351', NULL, NULL, 'Calcitonin gene-related peptide type 1 receptor signature', NULL, 'CGRPRECEPTOR', NULL, NULL, 3281, 13),
(279015, NULL, 'PR01188', NULL, NULL, 'Anion exchanger isoform 2 signature', NULL, 'ANIONEXHNGR2', NULL, NULL, 7111, 13),
(279016, NULL, 'PR00972', NULL, NULL, 'Ribosomal protein S12E family signature', NULL, 'RIBSOMALS12E', NULL, NULL, 5896, 13),
(279017, NULL, 'PR01834', NULL, NULL, 'Vascular endothelial growth factor receptor type 2 signature', NULL, 'VEGFRECEPTR2', NULL, NULL, 10420, 13),
(279018, NULL, 'PR00922', NULL, NULL, 'D-Ala-D-Ala carboxypeptidase 3 (S13) family signature', NULL, 'DADACBPTASE3', NULL, NULL, 6756, 13),
(279019, NULL, 'PR00008', NULL, NULL, 'Diacylglycerol/phorbol-ester binding signature', NULL, 'DAGPEDOMAIN', NULL, NULL, 20604, 13),
(279020, NULL, 'PR00605', NULL, NULL, 'Class IC cytochrome C signature', NULL, 'CYTCHROMECIC', NULL, NULL, 7115, 13),
(279021, NULL, 'PR01642', NULL, NULL, 'Transient receptor potential channel 1 signature', NULL, 'TRPCHANNEL1', NULL, NULL, 694, 13),
(279022, NULL, 'PR01757', NULL, NULL, 'Amelogenin signature', NULL, 'AMELOGENIN', NULL, NULL, 1759, 13),
(279023, NULL, 'PR00072', NULL, NULL, 'Malic enzyme signature', NULL, 'MALOXRDTASE', NULL, NULL, 5376, 13),
(279024, NULL, 'PR01595', NULL, NULL, 'Gram-negative bacterial type III secretion SycD chaperone signature', NULL, 'SYCDCHAPRONE', NULL, NULL, 7440, 13),
(279025, NULL, 'PR00569', NULL, NULL, 'Dopamine D4 receptor signature', NULL, 'DOPAMINED4R', NULL, NULL, 1213, 13),
(279026, NULL, 'PR01673', NULL, NULL, 'Glycine receptor alpha subunit signature', NULL, 'GLYRALPHA', NULL, NULL, 6418, 13),
(279027, NULL, 'PR01826', NULL, NULL, 'Janus kinase 3 (JAK3) signature', NULL, 'JANUSKINASE3', NULL, NULL, 20673, 13),
(279028, NULL, 'PR02079', NULL, NULL, 'Probable serine/threonine-protein kinase GDT family signature', NULL, 'STKINASEGDT', NULL, NULL, 25101, 13),
(279029, NULL, 'PR00338', NULL, NULL, 'Transcription termination factor NUSG signature', NULL, 'NUSGTNSCPFCT', NULL, NULL, 1357, 13),
(279030, NULL, 'PR01450', NULL, NULL, 'Calcium-activated BK potassium channel beta subunit signature', NULL, 'BKCHANNELB', NULL, NULL, 6199, 13),
(279031, NULL, 'PR00779', NULL, NULL, 'Inositol 1,4,5-trisphosphate-binding protein receptor signature', NULL, 'INSP3RECEPTR', NULL, NULL, 5552, 13),
(279032, NULL, 'PR00613', NULL, NULL, 'Myoglobin signature', NULL, 'MYOGLOBIN', NULL, NULL, 6209, 13),
(279033, NULL, 'PR00408', NULL, NULL, 'Mitochondrial P450 clan signature', NULL, 'MITP450', NULL, NULL, 5361, 13),
(279034, NULL, 'PR02087', NULL, NULL, 'HAUS augmin-like complex subunit 1 signature', NULL, 'HAUSAUGMINL1', NULL, NULL, 24525, 13),
(279035, NULL, 'PR01469', NULL, NULL, 'Bacterial carbamate kinase signature', NULL, 'CARBMTKINASE', NULL, NULL, NULL, 13),
(279036, NULL, 'PR02053', NULL, NULL, 'BRISC complex subunit Abro1 signature', NULL, 'BRISCABRO1', NULL, NULL, 15600, 13),
(279037, NULL, 'PR01306', NULL, NULL, 'Salmonella invasion protein InvJ signature', NULL, 'SSPANPROTEIN', NULL, NULL, 6401, 13),
(279038, NULL, 'PR00685', NULL, NULL, 'Transcription initiation factor IIB signature', NULL, 'TIFACTORIIB', NULL, NULL, 6776, 13);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(279039, NULL, 'PR02095', NULL, NULL, 'Haem transporter HRG signature', NULL, 'TRNSPORTRHRG', NULL, NULL, 26185, 13),
(279040, NULL, 'PR02052', NULL, NULL, 'BRCA1-A complex subunit Abraxas signature', NULL, 'ABRAXAS', NULL, NULL, 15998, 13),
(279041, NULL, 'PR00881', NULL, NULL, 'Ribosomal protein L7A/RS6 family signature', NULL, 'L7ARS6FAMILY', NULL, NULL, 17110, 13),
(279042, NULL, 'PR02015', NULL, NULL, 'Aquaporin-3 signature', NULL, 'AQUAPORIN3', NULL, NULL, 17173, 13),
(279043, NULL, 'PR00070', NULL, NULL, 'Dihydrofolate reductase signature', NULL, 'DHFR', NULL, NULL, NULL, 13),
(279044, NULL, 'PR01759', NULL, NULL, 'Capsule biosynthesis protein CapC signature', NULL, 'CAPSULEPROTC', NULL, NULL, 7732, 13),
(279045, NULL, 'PR01885', NULL, NULL, 'Macromomycin family signature', NULL, 'MACROMOMYCIN', NULL, NULL, 1273, 13),
(279046, NULL, 'PR00654', NULL, NULL, 'Angiotensinogen signature', NULL, 'ANGIOTENSNGN', NULL, NULL, 1045, 13),
(279047, NULL, 'PR00096', NULL, NULL, 'Glutamine amidotransferase superfamily signature', NULL, 'GATASE', NULL, NULL, NULL, 13),
(279048, NULL, 'PR00494', NULL, NULL, 'Fanconi anaemia group C protein signature', NULL, 'FANCONICGENE', NULL, NULL, 6917, 13),
(279049, NULL, 'PR00537', NULL, NULL, 'Mu opioid receptor signature', NULL, 'MUOPIOIDR', NULL, NULL, 2527, 13),
(279050, NULL, 'PR01641', NULL, NULL, 'Pre-pro melanin-concentrating hormone signature', NULL, 'PROMCHFAMILY', NULL, NULL, 651, 13),
(279051, NULL, 'PR01967', NULL, NULL, 'Tumour necrosis factor receptor 17 signature', NULL, 'TNFACTORR17', NULL, NULL, 15869, 13),
(279052, NULL, 'PR01504', NULL, NULL, 'Pancreatitis-associated protein signature', NULL, 'PNCREATITSAP', NULL, NULL, NULL, 13),
(279053, NULL, 'PR00807', NULL, NULL, 'Pollen allergen Amb family signature', NULL, 'AMBALLERGEN', NULL, NULL, 13653, 13),
(279054, NULL, 'PR00700', NULL, NULL, 'Protein tyrosine phosphatase signature', NULL, 'PRTYPHPHTASE', NULL, NULL, 820, 13),
(279055, NULL, 'PR00434', NULL, NULL, 'Interleukin-6 signature', NULL, 'INTERLEUKIN6', NULL, NULL, NULL, 13),
(279056, NULL, 'PR00892', NULL, NULL, 'Rab GDI protein signature', NULL, 'RABGDI', NULL, NULL, 6848, 13),
(279057, NULL, 'PR01645', NULL, NULL, 'Transient receptor potential channel 4 signature', NULL, 'TRPCHANNEL4', NULL, NULL, 863, 13),
(279058, NULL, 'PR00485', NULL, NULL, 'Mealworm beetle B protein signature', NULL, 'MEALWORMBTLB', NULL, NULL, NULL, 13),
(279059, NULL, 'PR01396', NULL, NULL, 'Bordetella pertussis toxin B subunit signature', NULL, 'BORPETOXINB', NULL, NULL, 4358, 13),
(279060, NULL, 'PR00608', NULL, NULL, 'Class II cytochrome C signature', NULL, 'CYTCHROMECII', NULL, NULL, 9202, 13),
(279061, NULL, 'PR00873', NULL, NULL, 'Echinoidea (sea urchin) metallothionein signature', NULL, 'MTECHINOIDEA', NULL, NULL, 2220, 13),
(279062, NULL, 'PR01256', NULL, NULL, 'Otx1 transcription factor signature', NULL, 'OTX1HOMEOBOX', NULL, NULL, 365, 13),
(279063, NULL, 'PR01713', NULL, NULL, 'Nucleotide sugar epimerase signature', NULL, 'NUCEPIMERASE', NULL, NULL, NULL, 13),
(279064, NULL, 'PR00771', NULL, NULL, 'Heat-labile enterotoxin A chain signature', NULL, 'ENTEROTOXINA', NULL, NULL, 2338, 13),
(279065, NULL, 'PR01860', NULL, NULL, 'ADAM-TS5 protein signature', NULL, 'ADAMTS5', NULL, NULL, 8829, 13),
(279066, NULL, 'PR00270', NULL, NULL, 'Alpha-type calcitonin signature', NULL, 'CALCITONINA', NULL, NULL, 17258, 13),
(279067, NULL, 'PR00641', NULL, NULL, 'C-C chemokine receptor type 7 signature', NULL, 'CHEMOKINER7', NULL, NULL, 3244, 13),
(279068, NULL, 'PR01482', NULL, NULL, 'Pertactin signature', NULL, 'PERTACTIN', NULL, NULL, 7069, 13),
(279069, NULL, 'PR01868', NULL, NULL, 'ABC transporter family E signature', NULL, 'ABCEFAMILY', NULL, NULL, 8711, 13),
(279070, NULL, 'PR01092', NULL, NULL, 'Sulphonylurea receptor family signature', NULL, 'SULFNYLUREAR', NULL, NULL, 6584, 13),
(279071, NULL, 'PR01650', NULL, NULL, 'Bacterial translocase SecE signature', NULL, 'SECETRNLCASE', NULL, NULL, 5805, 13),
(279072, NULL, 'PR01845', NULL, NULL, 'Wnt-6 protein signature', NULL, 'WNT6PROTEIN', NULL, NULL, 10346, 13);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(279073, NULL, 'PR00153', NULL, NULL, 'Cyclophilin peptidyl-prolyl cis-trans isomerase signature', NULL, 'CSAPPISMRASE', NULL, NULL, 5233, 13),
(279074, NULL, 'PR01665', NULL, NULL, 'Voltage-gated Na+ channel alpha 4 subunit signature', NULL, 'NACHANNEL4', NULL, NULL, 5258, 13),
(279075, NULL, 'PR00872', NULL, NULL, 'Diptera (Drosophila) metallothionein signature', NULL, 'MTDIPTERA', NULL, NULL, 225, 13),
(279076, NULL, 'PR01316', NULL, NULL, 'Glial cell line-derived neurotrophic factor receptor family signature', NULL, 'GDNFRECEPTOR', NULL, NULL, 5387, 13),
(279077, NULL, 'PR01659', NULL, NULL, 'Mini-chromosome maintenance (MCM) protein 3 signature', NULL, 'MCMPROTEIN3', NULL, NULL, 5467, 13),
(279078, NULL, 'PR00732', NULL, NULL, 'Glycosyl hydrolase family 4 signature', NULL, 'GLHYDRLASE4', NULL, NULL, 2142, 13),
(279079, NULL, 'PR01284', NULL, NULL, 'Orphan nuclear receptor (4A nuclear receptor) family signature', NULL, 'NUCLEARECPTR', NULL, NULL, 712, 13),
(279080, NULL, 'PR00479', NULL, NULL, 'Prokaryotic zinc-dependent phospholipase C signature', NULL, 'PRPHPHLPASEC', NULL, NULL, 3136, 13),
(279081, NULL, 'PR00963', NULL, NULL, 'MARCKS family signature', NULL, 'MARCKS', NULL, NULL, 1309, 13),
(279082, NULL, 'PR01125', NULL, NULL, 'Flavin-containing monooxygenase (FMO) 5 signature', NULL, 'FMOXYGENASE5', NULL, NULL, 5691, 13),
(279083, NULL, 'PR00799', NULL, NULL, 'Aspartate aminotransferase signature', NULL, 'TRANSAMINASE', NULL, NULL, 4545, 13),
(279084, NULL, 'PR01517', NULL, NULL, 'Kv4.2 voltage-gated K+ channel signature', NULL, 'KV42CHANNEL', NULL, NULL, 862, 13),
(279085, NULL, 'PR00676', NULL, NULL, 'Maspin signature', NULL, 'MASPIN', NULL, NULL, 962, 13),
(279086, NULL, 'PR01399', NULL, NULL, 'Enterobactin synthetase component D signature', NULL, 'ENTSNTHTASED', NULL, NULL, 7048, 13),
(279087, NULL, 'PR00797', NULL, NULL, 'Streptopain (C10) cysteine protease family signature', NULL, 'STREPTOPAIN', NULL, NULL, 1484, 13),
(279088, NULL, 'PR01819', NULL, NULL, 'Desmoglein signature', NULL, 'DESMOGLEIN', NULL, NULL, 10401, 13),
(279089, NULL, 'PR01575', NULL, NULL, 'Formyltetrahydrofolate deformylase signature', NULL, 'FFH4HYDRLASE', NULL, NULL, 4457, 13),
(279090, NULL, 'PR01654', NULL, NULL, 'Thyrotropin-releasing hormone receptor 2 signature', NULL, 'TRHRECEPTOR2', NULL, NULL, 1406, 13),
(279091, NULL, 'PR01042', NULL, NULL, 'Aspartyl-tRNA synthetase signature', NULL, 'TRNASYNTHASP', NULL, NULL, 6383, 13),
(279092, NULL, 'PR01712', NULL, NULL, 'Alpha giardin signature', NULL, 'ALPHAGIARDIN', NULL, NULL, 6049, 13),
(279093, NULL, 'PR00307', NULL, NULL, 'Adenovirus fibre protein signature', NULL, 'ADENOVSFIBRE', NULL, NULL, 3214, 13),
(279094, NULL, 'PR01331', NULL, NULL, 'Kir6.1 inward rectifier K+ channel signature', NULL, 'KIR61CHANNEL', NULL, NULL, 6210, 13),
(279095, NULL, 'PR00477', NULL, NULL, 'Phosphoglycerate kinase family signature', NULL, 'PHGLYCKINASE', NULL, NULL, 5397, 13),
(279096, NULL, 'PR01871', NULL, NULL, 'Annexin type VII signature', NULL, 'ANNEXINVII', NULL, NULL, NULL, 13),
(279097, NULL, 'PR00800', NULL, NULL, 'Aromatic-L-amino-acid decarboxylase signature', NULL, 'YHDCRBOXLASE', NULL, NULL, 10081, 13),
(279098, NULL, 'PR00460', NULL, NULL, 'Bacterial haem catalase-peroxidase signature', NULL, 'BPEROXIDASE', NULL, NULL, 6933, 13),
(279099, NULL, 'PR01794', NULL, NULL, 'Voltage-dependent calcium channel gamma-6 subunit signature', NULL, 'VDCCGAMMA6', NULL, NULL, 7811, 13),
(279100, NULL, 'PR01511', NULL, NULL, 'Kv1.4 voltage-gated K+ channel signature', NULL, 'KV14CHANNEL', NULL, NULL, 20889, 13),
(279101, NULL, 'PR00082', NULL, NULL, 'Glutamate/leucine/phenylalanine/valine dehydrogenase signature', NULL, 'GLFDHDRGNASE', NULL, NULL, 10474, 13),
(279102, NULL, 'PR00966', NULL, NULL, 'Potyvirus nuclear inclusion A cysteine protease (C4) signature', NULL, 'NIAPOTYPTASE', NULL, NULL, 3075, 13),
(279103, NULL, 'PR00283', NULL, NULL, 'Myotoxin signature', NULL, 'MYOTOXIN', NULL, NULL, 4565, 13),
(279104, NULL, 'PR00176', NULL, NULL, 'Sodium/chloride neurotransmitter symporter signature', NULL, 'NANEUSMPORT', NULL, NULL, 3769, 13); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(279105, NULL, 'PR00504', NULL, NULL, 'Chromodomain signature', NULL, 'CHROMODOMAIN', NULL, NULL, 19009, 13),
(279106, NULL, 'PR01039', NULL, NULL, 'Tryptophanyl-tRNA synthetase signature', NULL, 'TRNASYNTHTRP', NULL, NULL, 5928, 13),
(279107, NULL, 'PR00180', NULL, NULL, 'Cellular retinaldehyde-binding protein signature', NULL, 'CRETINALDHBP', NULL, NULL, NULL, 13),
(279108, NULL, 'PR01281', NULL, NULL, 'Corticotropin releasing factor type 2 receptor signature', NULL, 'CRFRECEPTOR2', NULL, NULL, 6795, 13),
(279109, NULL, 'PR00875', NULL, NULL, 'Mollusc metallothionein signature', NULL, 'MTMOLLUSC', NULL, NULL, 2345, 13),
(279110, NULL, 'PR01381', NULL, NULL, 'Claudin-7 signature', NULL, 'CLAUDIN7', NULL, NULL, 7176, 13),
(279111, NULL, 'PR00988', NULL, NULL, 'Uridine kinase signature', NULL, 'URIDINKINASE', NULL, NULL, NULL, 13),
(279112, NULL, 'PR01564', NULL, NULL, 'OGR1 sphingosylphosphorylcholine receptor signature', NULL, 'OGR1RECEPTOR', NULL, NULL, 7449, 13),
(279113, NULL, 'PR01394', NULL, NULL, 'Clostridium enterotoxin signature', NULL, 'CLENTEROTOXN', NULL, NULL, 6059, 13),
(279114, NULL, 'PR01946', NULL, NULL, 'Interleukin-11B signature', NULL, 'IL11BFISH', NULL, NULL, 18507, 13),
(279115, NULL, 'PR00564', NULL, NULL, 'C-X-C chemokine receptor type 5 signature', NULL, 'CXCCHMKINER5', NULL, NULL, 2496, 13),
(279116, NULL, 'PR01613', NULL, NULL, 'Escherichia coli P pili tip fibrillum PapF protein signature', NULL, 'FIMBRIALPAPF', NULL, NULL, 374, 13),
(279117, NULL, 'PR00169', NULL, NULL, 'Potassium channel signature', NULL, 'KCHANNEL', NULL, NULL, NULL, 13),
(279118, NULL, 'PR00663', NULL, NULL, 'Galanin receptor signature', NULL, 'GALANINR', NULL, NULL, 6692, 13),
(279119, NULL, 'PR01986', NULL, NULL, 'Neurogenic locus Notch protein 3 signature', NULL, 'NOTCH3', NULL, NULL, 15873, 13),
(279120, NULL, 'PR00619', NULL, NULL, 'Transcription factor GATA zinc finger signature', NULL, 'GATAZNFINGER', NULL, NULL, 3606, 13),
(279121, NULL, 'PR01855', NULL, NULL, 'Neuropeptide W receptor family signature', NULL, 'NRPEPTIDEWR', NULL, NULL, 10297, 13),
(279122, NULL, 'PR01321', NULL, NULL, 'Kir1.1 inward rectifier K+ channel signature', NULL, 'KIR11CHANNEL', NULL, NULL, NULL, 13),
(279123, NULL, 'PR01266', NULL, NULL, 'Alpha-class glutathione S-transferase signature', NULL, 'GSTRNSFRASEA', NULL, NULL, 933, 13),
(279124, NULL, 'PR01398', NULL, NULL, 'Isochorismatase signature', NULL, 'ISCHRISMTASE', NULL, NULL, 19885, 13),
(279125, NULL, 'PR01277', NULL, NULL, 'Nucleoside-specific channel-forming protein Tsx signature', NULL, 'CHANNELTSX', NULL, NULL, 618, 13),
(279126, NULL, 'PR00753', NULL, NULL, '1-aminocyclopropane-1-carboxylate synthase signature', NULL, 'ACCSYNTHASE', NULL, NULL, NULL, 13),
(279127, NULL, 'PR01446', NULL, NULL, 'Claudin-8 signature', NULL, 'CLAUDIN8', NULL, NULL, NULL, 13),
(279128, NULL, 'PR00614', NULL, NULL, 'Ni-Fe hydrogenase small subunit signature', NULL, 'NIHGNASESMLL', NULL, NULL, NULL, 13),
(279129, NULL, 'PR01940', NULL, NULL, 'Neurotrophic tyrosine kinase receptor type 1 signature', NULL, 'NTKRECEPTOR1', NULL, NULL, 18763, 13),
(279130, NULL, 'PR01452', NULL, NULL, 'LIN-12/notch repeat (LNR) signature', NULL, 'LNOTCHREPEAT', NULL, NULL, 6841, 13),
(279131, NULL, 'PR01176', NULL, NULL, 'Metabotropic gamma-aminobutyric acid type B receptor signature', NULL, 'GABABRECEPTR', NULL, NULL, NULL, 13),
(279132, NULL, 'PR02077', NULL, NULL, 'Protein GAPT signature', NULL, 'PROTEINGAPT', NULL, NULL, 18026, 13),
(279133, NULL, 'PR00417', NULL, NULL, 'Prokaryotic DNA topoisomerase I signature', NULL, 'PRTPISMRASEI', NULL, NULL, 10698, 13),
(279134, NULL, 'PR01800', NULL, NULL, 'Staphylococcus aureus exotoxin signature', NULL, 'STAPHEXOTOXN', NULL, NULL, 7629, 13),
(279135, NULL, 'PR01753', NULL, NULL, 'Streptococcus streptokinase protein signature', NULL, 'STREPKINASE', NULL, NULL, 6163, 13),
(279136, NULL, 'PR00067', NULL, NULL, 'Catalase signature', NULL, 'CATALASE', NULL, NULL, 16920, 13),
(279137, NULL, 'PR01896', NULL, NULL, 'ABC transporter family B2 signature', NULL, 'TAP1PROTEIN', NULL, NULL, NULL, 13);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(279138, NULL, 'PR01850', NULL, NULL, 'Groucho/transducin-like enhancer protein signature', NULL, 'GROUCHOFAMLY', NULL, NULL, 10226, 13),
(279139, NULL, 'PR01958', NULL, NULL, 'Sedoheptulose-1,7-bisphosphatase family signature', NULL, 'S17BPHPHTASE', NULL, NULL, 15495, 13),
(279140, NULL, 'PR01026', NULL, NULL, 'Neurokinin NK3 receptor signature', NULL, 'NEUROKININ3R', NULL, NULL, 146, 13),
(279141, NULL, 'PR01441', NULL, NULL, 'Cellulose synthase subunit C signature', NULL, 'CELLSNTHASEC', NULL, NULL, 6060, 13),
(279142, NULL, 'PR01205', NULL, NULL, 'Inebriated neurotransmitter transporter signature', NULL, 'INEBRIATED', NULL, NULL, 6880, 13),
(279143, NULL, 'PR00578', NULL, NULL, 'Lateral eye opsin signature', NULL, 'OPSINLTRLEYE', NULL, NULL, 5063, 13),
(279144, NULL, 'PR01286', NULL, NULL, 'Orphan nuclear receptor NOR1 signature', NULL, 'NORNUCRECPTR', NULL, NULL, 827, 13),
(279145, NULL, 'PR01013', NULL, NULL, 'Neuropeptide Y1 receptor signature', NULL, 'NRPEPTIDEY1R', NULL, NULL, 79, 13),
(279146, NULL, 'PR00375', NULL, NULL, 'Huntingtin signature', NULL, 'HUNTINGTIN', NULL, NULL, 2845, 13),
(279147, NULL, 'PR01373', NULL, NULL, 'Yersinia serine/threonine protein kinase signature', NULL, 'YERSSTKINASE', NULL, NULL, 7415, 13),
(279148, NULL, 'PR01662', NULL, NULL, 'Mini-chromosome maintenance (MCM) protein 6 signature', NULL, 'MCMPROTEIN6', NULL, NULL, 5228, 13),
(279149, NULL, 'PR00425', NULL, NULL, 'Bradykinin receptor signature', NULL, 'BRADYKININR', NULL, NULL, 7418, 13),
(279150, NULL, 'PR01352', NULL, NULL, 'Growth hormone-releasing hormone receptor signature', NULL, 'GHRHRECEPTOR', NULL, NULL, 3316, 13),
(279151, NULL, 'PR01862', NULL, NULL, 'Bcl-2 apoptosis regulator protein family signature', NULL, 'BCL2FAMILY', NULL, NULL, 21508, 13),
(279152, NULL, 'PR01688', NULL, NULL, 'CYP2J P450 family signature', NULL, 'EP450ICYP2J', NULL, NULL, 6367, 13),
(279153, NULL, 'PR00861', NULL, NULL, 'Alpha-lytic endopeptidase serine protease (S2A) signature', NULL, 'ALYTICPTASE', NULL, NULL, 2050, 13),
(279154, NULL, 'PR00063', NULL, NULL, 'Ribosomal protein L27 signature', NULL, 'RIBOSOMALL27', NULL, NULL, 3236, 13),
(279155, NULL, 'PR00746', NULL, NULL, 'Glycosyl hydrolase family 41 signature', NULL, 'GLHYDRLASE41', NULL, NULL, 2596, 13),
(279156, NULL, 'PR01012', NULL, NULL, 'Neuropeptide Y receptor signature', NULL, 'NRPEPTIDEYR', NULL, NULL, 5593, 13),
(279157, NULL, 'PR01155', NULL, NULL, 'Vasoactive intestinal peptide receptor 2 signature', NULL, 'VIP2RECEPTOR', NULL, NULL, 5186, 13),
(279158, NULL, 'PR00093', NULL, NULL, 'Uricase signature', NULL, 'URICASE', NULL, NULL, 1405, 13),
(279159, NULL, 'PR01676', NULL, NULL, 'Glycine receptor alpha 3 subunit signature', NULL, 'GLYRALPHA3', NULL, NULL, 6117, 13),
(279160, NULL, 'PR00644', NULL, NULL, 'GPR orphan receptor signature', NULL, 'GPRORPHANR', NULL, NULL, 3751, 13),
(279161, NULL, 'PR00720', NULL, NULL, 'Mammalian LMW phosphotyrosine protein phosphatase signature', NULL, 'MAMMALPTPASE', NULL, NULL, 1422, 13),
(279162, NULL, 'PR00240', NULL, NULL, 'Alpha-1D adrenergic receptor signature', NULL, 'ADRENRGCA1DR', NULL, NULL, 32, 13),
(279163, NULL, 'PR00600', NULL, NULL, 'Protein phosphatase PP2A 55kDa regulatory subunit signature', NULL, 'PP2APR55', NULL, NULL, 2578, 13),
(279164, NULL, 'PR01265', NULL, NULL, 'Link module signature', NULL, 'LINKMODULE', NULL, NULL, 5528, 13),
(279165, NULL, 'PR00733', NULL, NULL, 'Glycosyl hydrolase family 6 signature', NULL, 'GLHYDRLASE6', NULL, NULL, 19678, 13),
(279166, NULL, 'PR01219', NULL, NULL, 'Apolipoprotein D signature', NULL, 'APOLIPOPROTD', NULL, NULL, 611, 13),
(279167, NULL, 'PR01813', NULL, NULL, 'Fungal annexin type XIV signature', NULL, 'ANNEXINFUNGI', NULL, NULL, 10056, 13),
(279168, NULL, 'PR01923', NULL, NULL, 'Tumour necrosis factor receptor 8 signature', NULL, 'TNFACTORR8', NULL, NULL, 20016, 13),
(279169, NULL, 'PR00213', NULL, NULL, 'Myelin P0 protein signature', NULL, 'MYELINP0', NULL, NULL, 430, 13),
(279170, NULL, 'PR02094', NULL, NULL, 'Protein HEXIM1/HEXIM2 family signature', NULL, 'HEXIMFAMILY', NULL, NULL, 22241, 13);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(279171, NULL, 'PR01992', NULL, NULL, 'GP153 7TM protein signature', NULL, 'GPR153', NULL, NULL, 15909, 13),
(279172, NULL, 'PR00059', NULL, NULL, 'Ribosomal protein L6 signature', NULL, 'RIBOSOMALL6', NULL, NULL, 11815, 13),
(279173, NULL, 'PR01242', NULL, NULL, 'Plant G protein alpha subunit signature', NULL, 'GPROTEINAPLT', NULL, NULL, 7154, 13),
(279174, NULL, 'PR01597', NULL, NULL, 'Zona occludens protein family signature', NULL, 'ZONOCCLUDNS', NULL, NULL, 7431, 13),
(279175, NULL, 'PR02097', NULL, NULL, 'HTLV-1 basic zipper factor signature', NULL, 'HTLV1ZIPPER', NULL, NULL, 26945, 13),
(279176, NULL, 'PR01892', NULL, NULL, 'Wnt-8 protein signature', NULL, 'WNT8PROTEIN', NULL, NULL, 8623, 13),
(279177, NULL, 'PR00713', NULL, NULL, 'C-type natriuretic peptide signature', NULL, 'CNATPEPTIDE', NULL, NULL, 6206, 13),
(279178, NULL, 'PR01953', NULL, NULL, 'Subtilin biosynthesis protein SpaC signature', NULL, 'SPACPROTEIN', NULL, NULL, 20841, 13),
(279179, NULL, 'PR00025', NULL, NULL, 'Homeotic antennapedia protein signature', NULL, 'ANTENNAPEDIA', NULL, NULL, 13768, 13),
(279180, NULL, 'PR00851', NULL, NULL, 'Xeroderma pigmentosum group B protein signature', NULL, 'XRODRMPGMNTB', NULL, NULL, NULL, 13),
(279181, NULL, 'PR02082', NULL, NULL, 'GLC7-interacting protein 4 signature', NULL, 'GLC7IP4', NULL, NULL, 25033, 13),
(279182, NULL, 'PR01103', NULL, NULL, 'Adrenergic receptor signature', NULL, 'ADRENERGICR', NULL, NULL, 480, 13),
(279183, NULL, 'PR00451', NULL, NULL, 'Chitin-binding domain signature', NULL, 'CHITINBINDNG', NULL, NULL, 3245, 13),
(279184, NULL, 'PR00421', NULL, NULL, 'Thioredoxin family signature', NULL, 'THIOREDOXIN', NULL, NULL, NULL, 13),
(279185, NULL, 'PR01162', NULL, NULL, 'Alpha-tubulin signature', NULL, 'ALPHATUBULIN', NULL, NULL, 5156, 13),
(279186, NULL, 'PR00647', NULL, NULL, 'Urotensin II receptor signature', NULL, 'UROTENSIN2R', NULL, NULL, 5969, 13),
(279187, NULL, 'PR00989', NULL, NULL, 'Adenosine kinase signature', NULL, 'ADENOKINASE', NULL, NULL, 4188, 13),
(279188, NULL, 'PR02032', NULL, NULL, 'Dexamethasone-induced protein signature', NULL, 'DEXMETHSNEIP', NULL, NULL, 18781, 13),
(279189, NULL, 'PR01742', NULL, NULL, 'Septin 7 signature', NULL, 'SEPTIN7', NULL, NULL, 6051, 13),
(279190, NULL, 'PR01298', NULL, NULL, 'Colicin E1 (microcin) immunity protein signature', NULL, 'MICROCIN', NULL, NULL, 6832, 13),
(279191, NULL, 'PR01120', NULL, NULL, 'Plant CLC chloride channel signature', NULL, 'CLCHANNELPLT', NULL, NULL, 136, 13),
(279192, NULL, 'PR00110', NULL, NULL, 'Alpha-amylase signature', NULL, 'ALPHAAMYLASE', NULL, NULL, 2663, 13),
(279193, NULL, 'PR01646', NULL, NULL, 'Transient receptor potential channel 5 signature', NULL, 'TRPCHANNEL5', NULL, NULL, 802, 13),
(279194, NULL, 'PR01458', NULL, NULL, 'Peripheral myelin protein PMP22 signature', NULL, 'PMYELIN22', NULL, NULL, 7404, 13),
(279195, NULL, 'PR01484', NULL, NULL, 'Pertactin virulence factor family signature', NULL, 'PRTACTNFAMLY', NULL, NULL, 7407, 13),
(279196, NULL, 'PR00902', NULL, NULL, 'VP6 blue-tongue virus inner capsid protein signature', NULL, 'VP6CAPSID', NULL, NULL, 7175, 13),
(279197, NULL, 'PR02047', NULL, NULL, 'Brefeldin A-sensitivity protein 4 signature', NULL, 'BREFELDNASP4', NULL, NULL, 15905, 13),
(279198, NULL, 'PR01838', NULL, NULL, 'Neural cell adhesion molecule signature', NULL, 'NCAMFAMILY', NULL, NULL, 10045, 13),
(279199, NULL, 'PR01997', NULL, NULL, 'Phage major tail protein 2 family signature', NULL, 'MTP2FAMILY', NULL, NULL, 15882, 13),
(279200, NULL, 'PR01085', NULL, NULL, 'Na+/H+ exchanger isoform 1 (NHE1) signature', NULL, 'NAHEXCHNGR1', NULL, NULL, 2375, 13),
(279201, NULL, 'PR01881', NULL, NULL, 'Limb-bud-and-heart protein signature', NULL, 'LBHPROTEIN', NULL, NULL, 8566, 13),
(279202, NULL, 'PR00939', NULL, NULL, 'C2HC-type zinc-finger signature', NULL, 'C2HCZNFINGER', NULL, NULL, NULL, 13),
(279203, NULL, 'PR01966', NULL, NULL, 'Tumour necrosis factor receptor 16 signature', NULL, 'TNFACTORR16', NULL, NULL, 15907, 13),
(279204, NULL, 'PR00133', NULL, NULL, 'Glycosyl hydrolase family 3 signature', NULL, 'GLHYDRLASE3', NULL, NULL, 3088, 13);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(279205, NULL, 'PR00638', NULL, NULL, 'Type 4 bombesin receptor signature', NULL, 'BOMBESIN4R', NULL, NULL, 4413, 13),
(279206, NULL, 'PR00057', NULL, NULL, 'Transcription factor NF-KB signature', NULL, 'NFKBTNSCPFCT', NULL, NULL, 6971, 13),
(279207, NULL, 'PR01656', NULL, NULL, 'Helicobacter pylori vacuolating cytotoxin signature', NULL, 'VACCYTOTOXIN', NULL, NULL, 3336, 13),
(279208, NULL, 'PR00529', NULL, NULL, 'Gonadotrophin releasing hormone receptor signature', NULL, 'GNADOTRPHINR', NULL, NULL, 3415, 13),
(279209, NULL, 'PR01196', NULL, NULL, 'GAT-2 GABA neurotransmitter transporter signature', NULL, 'GAT2TRNSPORT', NULL, NULL, 7125, 13),
(279210, NULL, 'PR00055', NULL, NULL, 'HIV TAT domain signature', NULL, 'HIVTATDOMAIN', NULL, NULL, 4441, 13),
(279211, NULL, 'PR01268', NULL, NULL, 'Pi-class glutathione S-transferase signature', NULL, 'GSTRNSFRASEP', NULL, NULL, 723, 13),
(279212, NULL, 'PR00374', NULL, NULL, 'High potential iron sulphur protein signature', NULL, 'HIPIPFRDOXIN', NULL, NULL, NULL, 13),
(279213, NULL, 'PR01210', NULL, NULL, 'Gamma-glutamyltranspeptidase signature', NULL, 'GGTRANSPTASE', NULL, NULL, NULL, 13),
(279214, NULL, 'PR01025', NULL, NULL, 'Neurokinin NK2 receptor signature', NULL, 'NEUROKININ2R', NULL, NULL, 3417, 13),
(279215, NULL, 'PR02075', NULL, NULL, 'Fibrous sheath-interacting protein 1 signature', NULL, 'FIBSHEATHIP1', NULL, NULL, 21225, 13),
(279216, NULL, 'PR02016', NULL, NULL, 'Aquaporin-4 signature', NULL, 'AQUAPORIN4', NULL, NULL, NULL, 13),
(279217, NULL, 'PR01666', NULL, NULL, 'Voltage-gated Na+ channel alpha 5 subunit signature', NULL, 'NACHANNEL5', NULL, NULL, 5134, 13),
(279218, NULL, 'PR01875', NULL, NULL, 'Eight-Twenty-One (ETO) family signature', NULL, 'ETOFAMILY', NULL, NULL, 8731, 13),
(279219, NULL, 'PR01172', NULL, NULL, 'Beta-lactoglobulin signature', NULL, 'BLCTOGLOBULN', NULL, NULL, 6636, 13),
(279220, NULL, 'PR01191', NULL, NULL, 'Glucose transporter type 2 (GLUT2) signature', NULL, 'GLUCTRSPORT2', NULL, NULL, 6951, 13),
(279221, NULL, 'PR00941', NULL, NULL, 'Cadmium-transporting ATPase signature', NULL, 'CDATPASE', NULL, NULL, 22572, 13),
(279222, NULL, 'PR00367', NULL, NULL, 'Ethylene responsive element binding protein signature', NULL, 'ETHRSPELEMNT', NULL, NULL, 3180, 13),
(279223, NULL, 'PR01437', NULL, NULL, 'NADH-ubiquinone oxidoreductase subunit 4 signature', NULL, 'NUOXDRDTASE4', NULL, NULL, 6389, 13),
(279224, NULL, 'PR01246', NULL, NULL, 'Rad1 repair protein signature', NULL, 'RAD1REPAIR', NULL, NULL, 7117, 13),
(279225, NULL, 'PR01545', NULL, NULL, 'Thermotoga maritima hypothetical protein TM1410 signature', NULL, 'THEMAYE10DUF', NULL, NULL, 10198, 13),
(279226, NULL, 'PR01972', NULL, NULL, 'Tumour necrosis factor receptor 25 signature', NULL, 'TNFACTORR25', NULL, NULL, 15550, 13),
(279227, NULL, 'PR00898', NULL, NULL, 'Vasopressin V2 receptor signature', NULL, 'VASOPRSNV2R', NULL, NULL, 1527, 13),
(279228, NULL, 'PR01612', NULL, NULL, 'Corticotropin-releasing factor family signature', NULL, 'CRFFAMILY', NULL, NULL, 844, 13),
(279229, NULL, 'PR00521', NULL, NULL, 'Androgen receptor (3C nuclear receptor) signature', NULL, 'ANDROGENR', NULL, NULL, 2484, 13),
(279230, NULL, 'PR01425', NULL, NULL, 'Transforming growth factor beta 2 precursor signature', NULL, 'TGFBETA2', NULL, NULL, 7357, 13),
(279231, NULL, 'PR00558', NULL, NULL, 'Alpha-2A adrenergic receptor signature', NULL, 'ADRENRGCA2AR', NULL, NULL, 4221, 13),
(279232, NULL, 'PR01184', NULL, NULL, 'Ornatin signature', NULL, 'ORNATIN', NULL, NULL, 6820, 13),
(279233, NULL, 'PR00773', NULL, NULL, 'GrpE protein signature', NULL, 'GRPEPROTEIN', NULL, NULL, 3633, 13),
(279234, NULL, 'PR00468', NULL, NULL, 'Plant lipoxygenase signature', NULL, 'PLTLPOXGNASE', NULL, NULL, 2029, 13),
(279235, NULL, 'PR01453', NULL, NULL, 'Epithelial membrane protein (EMP/PMP22/LMIP) family signature', NULL, 'EPMEMFAMILY', NULL, NULL, 823, 13),
(279236, NULL, 'PR01435', NULL, NULL, 'NADH-plastoquinone oxidoreductase chain 5 signature', NULL, 'NPOXDRDTASE5', NULL, NULL, NULL, 13),
(279237, NULL, 'PR00789', NULL, NULL, 'O-sialoglycoprotein endopeptidase (M22) metallo-protease family signature', NULL, 'OSIALOPTASE', NULL, NULL, 18859, 13);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(279238, NULL, 'PR00819', NULL, NULL, 'CbxX/CfqX superfamily signature', NULL, 'CBXCFQXSUPER', NULL, NULL, 3585, 13),
(279239, NULL, 'PR01692', NULL, NULL, 'Lipocalin-1 interacting membrane receptor signature', NULL, 'LIPOCALINIMR', NULL, NULL, 6453, 13),
(279240, NULL, 'PR01734', NULL, NULL, 'Type III secretion system outer membrane B protein family signature', NULL, 'TYPE3OMBPROT', NULL, NULL, 6221, 13),
(279241, NULL, 'PR01959', NULL, NULL, 'SuhB family inositol monophosphatase signature', NULL, 'SBIMPHPHTASE', NULL, NULL, 15652, 13),
(279242, NULL, 'PR00394', NULL, NULL, 'RHS protein signature', NULL, 'RHSPROTEIN', NULL, NULL, 4173, 13),
(279243, NULL, 'PR01235', NULL, NULL, 'Tumour necrosis factor alpha (cachectin) signature', NULL, 'TNFALPHA', NULL, NULL, 6789, 13),
(279244, NULL, 'PR01802', NULL, NULL, 'Synembryn family signature', NULL, 'SYNEMBRYN', NULL, NULL, 7722, 13),
(279245, NULL, 'PR00849', NULL, NULL, 'Glycosyl hydrolase family 58 signature', NULL, 'GLHYDRLASE58', NULL, NULL, 3163, 13),
(279246, NULL, 'PR01594', NULL, NULL, 'Bacterial protein-transport SecB chaperone protein signature', NULL, 'SECBCHAPRONE', NULL, NULL, 2087, 13),
(279247, NULL, 'PR01814', NULL, NULL, 'Plant annexin signature', NULL, 'ANNEXINPLANT', NULL, NULL, 10271, 13),
(279248, NULL, 'PR01018', NULL, NULL, 'Prolactin-releasing peptide receptor signature', NULL, 'PRPRECEPTOR', NULL, NULL, 3462, 13),
(279249, NULL, 'PR01663', NULL, NULL, 'Mini-chromosome maintenance (MCM) protein 7 signature', NULL, 'MCMPROTEIN7', NULL, NULL, 5283, 13),
(279250, NULL, 'PR00997', NULL, NULL, 'Fragilysin metallopeptidase (M10C) enterotoxin signature', NULL, 'FRAGILYSIN', NULL, NULL, 4486, 13),
(279251, NULL, 'PR00809', NULL, NULL, 'Rice seed allergenic protein RAG signature', NULL, 'RAGALLERGEN', NULL, NULL, 6729, 13),
(279252, NULL, 'PR00113', NULL, NULL, 'Alkaline phosphatase signature', NULL, 'ALKPHPHTASE', NULL, NULL, 2005, 13),
(279253, NULL, 'PR00915', NULL, NULL, 'Luteovirus group 1 coat protein signature', NULL, 'LUTEOGP1COAT', NULL, NULL, 6114, 13),
(279254, NULL, 'PR00102', NULL, NULL, 'Ornithine carbamoyltransferase signature', NULL, 'OTCASE', NULL, NULL, 180, 13),
(279255, NULL, 'PR01353', NULL, NULL, 'Glucagon family receptor signature', NULL, 'GLUCAGNFAMLY', NULL, NULL, 3337, 13),
(279256, NULL, 'PR01344', NULL, NULL, 'Salmonella/Shigella invasion protein E (InvE) signature', NULL, 'INVEPROTEIN', NULL, NULL, 6126, 13),
(279257, NULL, 'PR00118', NULL, NULL, 'Beta-lactamase class A signature', NULL, 'BLACTAMASEA', NULL, NULL, 165, 13),
(279258, NULL, 'PR00056', NULL, NULL, 'Heat shock factor (HSF) domain signature', NULL, 'HSFDOMAIN', NULL, NULL, 689, 13),
(279259, NULL, 'PR01255', NULL, NULL, 'Otx transcription factor signature', NULL, 'OTXHOMEOBOX', NULL, NULL, 265, 13),
(279260, NULL, 'PR02024', NULL, NULL, 'Aquaporin-11 signature', NULL, 'AQUAPORIN11', NULL, NULL, 20141, 13),
(279261, NULL, 'PR00315', NULL, NULL, 'GTP-binding elongation factor signature', NULL, 'ELONGATNFCT', NULL, NULL, 6577, 13),
(279262, NULL, 'PR01294', NULL, NULL, 'Interleukin-10 signature', NULL, 'INTRLEUKIN10', NULL, NULL, 3909, 13),
(279263, NULL, 'PR01788', NULL, NULL, 'Prostanoid receptor signature', NULL, 'PROSTANOIDR', NULL, NULL, 7730, 13),
(279264, NULL, 'PR01887', NULL, NULL, 'Spectrin alpha chain signature', NULL, 'SPECTRNALPHA', NULL, NULL, NULL, 13),
(279265, NULL, 'PR01009', NULL, NULL, 'Flagellar M-ring protein signature', NULL, 'FLGMRINGFLIF', NULL, NULL, 3891, 13),
(279266, NULL, 'PR00639', NULL, NULL, 'Neuromedin B receptor signature', NULL, 'NEUROMEDINBR', NULL, NULL, 3960, 13),
(279267, NULL, 'PR00382', NULL, NULL, 'Plant phospholipid transfer protein signature', NULL, 'LIPIDTRNSFER', NULL, NULL, 5625, 13),
(279268, NULL, 'PR00832', NULL, NULL, 'Paxillin signature', NULL, 'PAXILLIN', NULL, NULL, NULL, 13),
(279269, NULL, 'PR00983', NULL, NULL, 'Cysteinyl-tRNA synthetase signature', NULL, 'TRNASYNTHCYS', NULL, NULL, 14597, 13),
(279270, NULL, 'PR01954', NULL, NULL, 'Epidermin biosynthesis protein EpiC signature', NULL, 'EPICPROTEIN', NULL, NULL, 20107, 13);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(279271, NULL, 'PR01911', NULL, NULL, 'Plant and fungal dual specificity phosphatase signature', NULL, 'PFDSPHPHTASE', NULL, NULL, 20432, 13),
(279272, NULL, 'PR00181', NULL, NULL, 'Maltose binding protein signature', NULL, 'MALTOSEBP', NULL, NULL, 2637, 13),
(279273, NULL, 'PR01028', NULL, NULL, 'Opioid neuropeptide precursor signature', NULL, 'OPIOIDPRCRSR', NULL, NULL, 1075, 13),
(279274, NULL, 'PR01222', NULL, NULL, 'Atrophin signature', NULL, 'ATROPHIN', NULL, NULL, 12373, 13),
(279275, NULL, 'PR02106', NULL, NULL, 'Integrator complex subunit 10 signature', NULL, 'INTSUBUNIT10', NULL, NULL, 23229, 13),
(279276, NULL, 'PR01169', NULL, NULL, 'Ceratitis capitata alcohol dehydrogenase signature', NULL, 'CERATITISADH', NULL, NULL, 6609, 13),
(279277, NULL, 'PR00984', NULL, NULL, 'Isoleucyl-tRNA synthetase signature', NULL, 'TRNASYNTHILE', NULL, NULL, 6491, 13),
(279278, NULL, 'PR01643', NULL, NULL, 'Transient receptor potential channel 2 signature', NULL, 'TRPCHANNEL2', NULL, NULL, 765, 13),
(279279, NULL, 'PR01440', NULL, NULL, 'Cellulose synthase subunit B signature', NULL, 'CELLSNTHASEB', NULL, NULL, 6227, 13),
(279280, NULL, 'PR00448', NULL, NULL, 'NSF attachment protein signature', NULL, 'NSFATTACHMNT', NULL, NULL, 6737, 13),
(279281, NULL, 'PR01722', NULL, NULL, 'Gamma-aminobutyric-acid A receptor delta subunit signature', NULL, 'GABAARDELTA', NULL, NULL, 6487, 13),
(279282, NULL, 'PR00514', NULL, NULL, '5-hydroxytryptamine 1D receptor signature', NULL, '5HT1DRECEPTR', NULL, NULL, 6637, 13),
(279283, NULL, 'PR02113', NULL, NULL, 'Mas-related G protein-coupled receptor H signature', NULL, 'MRGPCRH', NULL, NULL, 26984, 13),
(279284, NULL, 'PR00999', NULL, NULL, 'Fungalysin metallopeptidase (M36) signature', NULL, 'FUNGALYSIN', NULL, NULL, 4383, 13),
(279285, NULL, 'PR00348', NULL, NULL, 'Ubiquitin signature', NULL, 'UBIQUITIN', NULL, NULL, 15378, 13),
(279286, NULL, 'PR01758', NULL, NULL, 'Capsule biosynthesis protein CapB signature', NULL, 'CAPSULEPROTB', NULL, NULL, 7928, 13),
(279287, NULL, 'PR01998', NULL, NULL, 'Staphylococcal phage major tail protein signature', NULL, 'MTP2STAPHYLO', NULL, NULL, NULL, 13),
(279288, NULL, 'PR00953', NULL, NULL, 'Type III secretion system inner membrane R protein family signature', NULL, 'TYPE3IMRPROT', NULL, NULL, 4685, 13),
(279289, NULL, 'PR01719', NULL, NULL, 'MHC class II transactivator signature', NULL, 'MHCIIACTVATR', NULL, NULL, 6157, 13),
(279290, NULL, 'PR02026', NULL, NULL, 'YtrC/YtrD probable ABC transporter permease signature', NULL, 'YTRCYTRDABC', NULL, NULL, 19516, 13),
(279291, NULL, 'PR01541', NULL, NULL, 'Gonadoliberin I precursor signature', NULL, 'GONADOLIBRNI', NULL, NULL, 1815, 13),
(279292, NULL, 'PR00854', NULL, NULL, 'Prostaglandin D receptor signature', NULL, 'PRSTNOIDDPR', NULL, NULL, 280, 13),
(279293, NULL, 'PR00002', NULL, NULL, 'Bone matrix GLA domain signature', NULL, 'GLABONE', NULL, NULL, 6326, 13),
(279294, NULL, 'PR00879', NULL, NULL, 'Fish acetylcholinesterase signature', NULL, 'ACHEFISH', NULL, NULL, 3377, 13),
(279295, NULL, 'PR00224', NULL, NULL, 'Geminivirus AR1 coat protein signature', NULL, 'GEMCOATAR1', NULL, NULL, 4146, 13),
(279296, NULL, 'PR00006', NULL, NULL, 'Cofilin/destrin family signature', NULL, 'COFILIN', NULL, NULL, 8375, 13),
(279297, NULL, 'PR00783', NULL, NULL, 'Major intrinsic protein family signature', NULL, 'MINTRINSICP', NULL, NULL, 4930, 13),
(279298, NULL, 'PR01861', NULL, NULL, 'ADAM-TS8 protein signature', NULL, 'ADAMTS8', NULL, NULL, 8802, 13),
(279299, NULL, 'PR01231', NULL, NULL, 'HCO3- transporter superfamily signature', NULL, 'HCO3TRNSPORT', NULL, NULL, 43, 13),
(279300, NULL, 'PR02080', NULL, NULL, 'Toxin Pg family signature', NULL, 'TOXINPGFAMLY', NULL, NULL, 26087, 13),
(279301, NULL, 'PR00079', NULL, NULL, 'Glucose-6-phosphate dehydrogenase signature', NULL, 'G6PDHDRGNASE', NULL, NULL, 2174, 13),
(279302, NULL, 'PR00077', NULL, NULL, 'NAD-dependent glycerol-3-phosphate dehydrogenase signature', NULL, 'GPDHDRGNASE', NULL, NULL, 10110, 13),
(279303, NULL, 'PR00474', NULL, NULL, 'Glutamate 5-kinase family signature', NULL, 'GLU5KINASE', NULL, NULL, 2314, 13);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(279304, NULL, 'PR00261', NULL, NULL, 'Low density lipoprotein (LDL) receptor signature', NULL, 'LDLRECEPTOR', NULL, NULL, 5466, 13),
(279305, NULL, 'PR00389', NULL, NULL, 'Phospholipase A2 signature', NULL, 'PHPHLIPASEA2', NULL, NULL, 1343, 13),
(279306, NULL, 'PR01466', NULL, NULL, 'Bacterial arginine deiminase signature', NULL, 'ARGDEIMINASE', NULL, NULL, 4408, 13),
(279307, NULL, 'PR01912', NULL, NULL, 'Brain derived neurotrophic factor signature', NULL, 'BDNFACTOR', NULL, NULL, 20792, 13),
(279308, NULL, 'PR02019', NULL, NULL, 'Aquaporin-7 signature', NULL, 'AQUAPORIN7', NULL, NULL, NULL, 13),
(279309, NULL, 'PR00517', NULL, NULL, '5-hydroxytryptamine 2C receptor signature', NULL, '5HT2CRECEPTR', NULL, NULL, 6864, 13),
(279310, NULL, 'PR00342', NULL, NULL, 'Rhesus blood group protein signature', NULL, 'RHESUSRHD', NULL, NULL, 676, 13),
(279311, NULL, 'PR00478', NULL, NULL, 'Phosphoribulokinase family signature', NULL, 'PHRIBLKINASE', NULL, NULL, 2865, 13),
(279312, NULL, 'PR01310', NULL, NULL, 'P2X3 purinoceptor signature', NULL, 'P2X3RECEPTOR', NULL, NULL, 579, 13),
(279313, NULL, 'PR00362', NULL, NULL, 'Cannabinoid receptor signature', NULL, 'CANNABINOIDR', NULL, NULL, 340, 13),
(279314, NULL, 'PR02037', NULL, NULL, 'FPRL1 inhibitory protein signature', NULL, 'FLIPR', NULL, NULL, 18960, 13),
(279315, NULL, 'PR01189', NULL, NULL, 'Anion exchanger isoform 3 signature', NULL, 'ANIONEXHNGR3', NULL, NULL, 7234, 13),
(279316, NULL, 'PR01407', NULL, NULL, 'Butyrophylin C-terminal DUF signature', NULL, 'BUTYPHLNCDUF', NULL, NULL, 4307, 13),
(279317, NULL, 'PR02089', NULL, NULL, 'HAUS augmin-like complex subunit 3 signature', NULL, 'HAUSAUGMINL3', NULL, NULL, 24678, 13),
(279318, NULL, 'PR00143', NULL, NULL, 'Citrate synthase signature', NULL, 'CITRTSNTHASE', NULL, NULL, 2482, 13),
(279319, NULL, 'PR00985', NULL, NULL, 'Leucyl-tRNA synthetase signature', NULL, 'TRNASYNTHLEU', NULL, NULL, 6442, 13),
(279320, NULL, 'PR00893', NULL, NULL, 'Rab escort (choroideraemia) protein signature', NULL, 'RABESCORT', NULL, NULL, 3491, 13),
(279321, NULL, 'PR01964', NULL, NULL, 'Tumour necrosis factor receptor 13C signature', NULL, 'TNFACTORR13C', NULL, NULL, 15608, 13),
(279322, NULL, 'PR01674', NULL, NULL, 'Glycine receptor alpha 1 subunit signature', NULL, 'GLYRALPHA1', NULL, NULL, 6079, 13),
(279323, NULL, 'PR00216', NULL, NULL, 'Osteopontin signature', NULL, 'OSTEOPONTIN', NULL, NULL, 2211, 13),
(279324, NULL, 'PR00324', NULL, NULL, 'Nisin signature', NULL, 'NISIN', NULL, NULL, 2674, 13),
(279325, NULL, 'PR00422', NULL, NULL, 'Transferrin signature', NULL, 'TRANSFERRIN', NULL, NULL, 1470, 13),
(279326, NULL, 'PR01221', NULL, NULL, 'Rodent urinary protein signature', NULL, 'MAJORURINARY', NULL, NULL, 7024, 13),
(279327, NULL, 'PR01739', NULL, NULL, 'Relaxin receptor family signature', NULL, 'RELAXINR', NULL, NULL, 6298, 13),
(279328, NULL, 'PR01783', NULL, NULL, 'Melanin-concentrating hormone receptor family signature', NULL, 'MCHRECEPTOR', NULL, NULL, 7716, 13),
(279329, NULL, 'PR01020', NULL, NULL, 'Lipopolysaccharide core biosynthesis protein signature', NULL, 'LPSBIOSNTHSS', NULL, NULL, 4360, 13),
(279330, NULL, 'PR00590', NULL, NULL, 'Somatostatin receptor type 4 signature', NULL, 'SOMATOSTTN4R', NULL, NULL, 6357, 13),
(279331, NULL, 'PR00743', NULL, NULL, 'Glycosyl hydrolase family 36 signature', NULL, 'GLHYDRLASE36', NULL, NULL, 5692, 13),
(279332, NULL, 'PR00523', NULL, NULL, 'Cannabinoid receptor type 2 signature', NULL, 'CANABINOID2R', NULL, NULL, 5566, 13),
(279333, NULL, 'PR00611', NULL, NULL, 'Erythrocruorin family signature', NULL, 'ERYTHCRUORIN', NULL, NULL, 6266, 13),
(279334, NULL, 'PR00020', NULL, NULL, 'MAM domain signature', NULL, 'MAMDOMAIN', NULL, NULL, 3140, 13),
(279335, NULL, 'PR01840', NULL, NULL, 'Bacterial Sec-independent translocation TatC protein family signature', NULL, 'TATCFAMILY', NULL, NULL, 5257, 13),
(279336, NULL, 'PR01996', NULL, NULL, 'Phage major tail protein 1 family signature', NULL, 'MTP1FAMILY', NULL, NULL, 15662, 13),
(279337, NULL, 'PR02044', NULL, NULL, 'Fibrosin-1-like protein family signature', NULL, 'FIBROSIN1LPF', NULL, NULL, 15715, 13);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(279338, NULL, 'PR00081', NULL, NULL, 'Glucose/ribitol dehydrogenase family signature', NULL, 'GDHRDH', NULL, NULL, 6085, 13),
(279339, NULL, 'PR00903', NULL, NULL, 'VP7 core protein signature', NULL, 'VP7CAPSID', NULL, NULL, 4252, 13),
(279340, NULL, 'PR01436', NULL, NULL, 'NADH-ubiquinone oxidoreductase chain 2 signature', NULL, 'NADHDHGNASE2', NULL, NULL, 6458, 13),
(279341, NULL, 'PR01999', NULL, NULL, 'Lactococcal phage major tail protein signature', NULL, 'MTP2LACTO', NULL, NULL, 17032, 13),
(279342, NULL, 'PR01058', NULL, NULL, 'Metabotropic glutamate receptor 8 signature', NULL, 'MTABOTROPC8R', NULL, NULL, 3634, 13),
(279343, NULL, 'PR02085', NULL, NULL, 'DNA-directed RNA polymerase II subunit GRINL1 signature', NULL, 'POLR2GRINL1', NULL, NULL, 26114, 13),
(279344, NULL, 'PR00233', NULL, NULL, 'Icosahedral viral capsid protein signature', NULL, 'ICOSAHEDRAL', NULL, NULL, 408, 13),
(279345, NULL, 'PR00366', NULL, NULL, 'Endothelin receptor signature', NULL, 'ENDOTHELINR', NULL, NULL, 6904, 13),
(279346, NULL, 'PR02055', NULL, NULL, 'Protein family FAM105 signature', NULL, 'PROTEINF105', NULL, NULL, 15517, 13),
(279347, NULL, 'PR01615', NULL, NULL, 'Gamma-aminobutyric-acid A receptor alpha 2 subunit signature', NULL, 'GABAARALPHA2', NULL, NULL, 54, 13),
(279348, NULL, 'PR01358', NULL, NULL, 'Interleukin-1 alpha precursor signature', NULL, 'INTRLEUKIN1A', NULL, NULL, 3025, 13),
(279349, NULL, 'PR00379', NULL, NULL, 'Intein signature', NULL, 'INTEIN', NULL, NULL, 10060, 13),
(279350, NULL, 'PR00880', NULL, NULL, 'Insect acetylcholinesterase signature', NULL, 'ACHEINSECT', NULL, NULL, 3054, 13),
(279351, NULL, 'PR01051', NULL, NULL, 'Metabotropic glutamate receptor 1 signature', NULL, 'MTABOTROPC1R', NULL, NULL, 2248, 13),
(279352, NULL, 'PR01776', NULL, NULL, 'Helicobacter pylori outer membrane protein family signature', NULL, 'HPOMPFAMILY', NULL, NULL, 3903, 13),
(279353, NULL, 'PR00298', NULL, NULL, '60kDa chaperonin signature', NULL, 'CHAPERONIN60', NULL, NULL, 4116, 13),
(279354, NULL, 'PR00629', NULL, NULL, 'SHC phosphotyrosine interaction domain signature', NULL, 'SHCPIDOMAIN', NULL, NULL, 1122, 13),
(279355, NULL, 'PR00971', NULL, NULL, 'Ribosomal protein S10 family signature', NULL, 'RIBOSOMALS10', NULL, NULL, 4264, 13),
(279356, NULL, 'PR00967', NULL, NULL, 'Acute myeloid leukemia 1 protein signature', NULL, 'ONCOGENEAML1', NULL, NULL, 2709, 13),
(279357, NULL, 'PR00409', NULL, NULL, 'Phthalate dioxygenase reductase family signature', NULL, 'PHDIOXRDTASE', NULL, NULL, NULL, 13),
(279358, NULL, 'PR00014', NULL, NULL, 'Fibronectin type III repeat signature', NULL, 'FNTYPEIII', NULL, NULL, NULL, 13),
(279359, NULL, 'PR00672', NULL, NULL, 'Inhibin beta C chain signature', NULL, 'INHIBINBC', NULL, NULL, 453, 13),
(279360, NULL, 'PR01515', NULL, NULL, 'Kv2.2 voltage-gated K+ channel signature', NULL, 'KV22CHANNEL', NULL, NULL, 5630, 13),
(279361, NULL, 'PR00696', NULL, NULL, 'Crossover junction endodeoxyribonuclease RUVC signature', NULL, 'RSOLVASERUVC', NULL, NULL, 5021, 13),
(279362, NULL, 'PR00157', NULL, NULL, 'Plastocyanin signature', NULL, 'PLASTOCYANIN', NULL, NULL, 6187, 13),
(279363, NULL, 'PR01529', NULL, NULL, 'C-C chemokine receptor type 6 signature', NULL, 'CHEMOKINER6', NULL, NULL, 1596, 13),
(279364, NULL, 'PR01816', NULL, NULL, 'Beta-site APP cleaving enzyme 1 (BACE1) signature', NULL, 'BACE1', NULL, NULL, NULL, 13),
(279365, NULL, 'PR01955', NULL, NULL, 'Frankia sp. LanC-like protein signature', NULL, 'LANCFRANKIA', NULL, NULL, NULL, 13),
(279366, NULL, 'PR00488', NULL, NULL, 'Five-lipoxygenase activating protein signature', NULL, '5LPOXGNASEAP', NULL, NULL, 6993, 13),
(279367, NULL, 'PR00814', NULL, NULL, 'Beta haemoglobin signature', NULL, 'BETAHAEM', NULL, NULL, 6461, 13),
(279368, NULL, 'PR00453', NULL, NULL, 'Von Willebrand factor type A domain signature', NULL, 'VWFADOMAIN', NULL, NULL, NULL, 13),
(279369, NULL, 'PR00565', NULL, NULL, 'Dopamine 1A receptor signature', NULL, 'DOPAMINED1AR', NULL, NULL, 6376, 13),
(279370, NULL, 'PR01943', NULL, NULL, 'Mammalian interleukin-11 signature', NULL, 'INTLKN11MAML', NULL, NULL, 20388, 13);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(279371, NULL, 'PR01167', NULL, NULL, 'Insect alcohol dehydrogenase family signature', NULL, 'INSADHFAMILY', NULL, NULL, NULL, 13),
(279372, NULL, 'PR00248', NULL, NULL, 'Metabotropic glutamate GPCR signature', NULL, 'GPCRMGR', NULL, NULL, 4850, 13),
(279373, NULL, 'PR00397', NULL, NULL, 'Sirohaem Fe-binding site signature', NULL, 'SIROHAEM', NULL, NULL, 2848, 13),
(279374, NULL, 'PR01874', NULL, NULL, 'DNA repair protein radA signature', NULL, 'DNAREPAIRADA', NULL, NULL, NULL, 13),
(279375, NULL, 'PR01034', NULL, NULL, 'Ribosomal protein S12 signature', NULL, 'RIBOSOMALS12', NULL, NULL, 1086, 13),
(279376, NULL, 'PR00287', NULL, NULL, 'Plant thionin signature', NULL, 'THIONIN', NULL, NULL, 2130, 13),
(279377, NULL, 'PR01738', NULL, NULL, 'RNA binding motif protein 8 family signature', NULL, 'RNABINDINGM8', NULL, NULL, 6153, 13),
(279378, NULL, 'PR01697', NULL, NULL, 'Parvalbumin signature', NULL, 'PARVALBUMIN', NULL, NULL, NULL, 13),
(279379, NULL, 'PR01467', NULL, NULL, 'Bacterial arginine repressor signature', NULL, 'ARGREPRESSOR', NULL, NULL, 5143, 13),
(279380, NULL, 'PR00834', NULL, NULL, 'HtrA/DegQ protease family signature', NULL, 'PROTEASES2C', NULL, NULL, 2435, 13),
(279381, NULL, 'PR00306', NULL, NULL, 'Serum amyloid A protein signature', NULL, 'SERUMAMYLOID', NULL, NULL, 3847, 13),
(279382, NULL, 'PR00714', NULL, NULL, 'Phosphomannose isomerase type I signature', NULL, 'MAN6PISMRASE', NULL, NULL, 19578, 13),
(279383, NULL, 'PR00801', NULL, NULL, 'Adrenomedullin signature', NULL, 'ADRENOMEDULN', NULL, NULL, 3248, 13),
(279384, NULL, 'PR00347', NULL, NULL, 'Pathogenesis-related protein signature', NULL, 'THAUMATIN', NULL, NULL, 2232, 13),
(279385, NULL, 'PR01372', NULL, NULL, 'Yersinia virulence determinant YopE protein signature', NULL, 'YERSINIAYOPE', NULL, NULL, 7291, 13),
(279386, NULL, 'PR00259', NULL, NULL, 'Transmembrane four family signature', NULL, 'TMFOUR', NULL, NULL, NULL, 13),
(279387, NULL, 'PR00284', NULL, NULL, 'Toxin signature', NULL, 'TOXIN', NULL, NULL, NULL, 13),
(279388, NULL, 'PR02076', NULL, NULL, 'Protein FYV8 signature', NULL, 'PROTEINFYV8', NULL, NULL, 25409, 13),
(279389, NULL, 'PR00449', NULL, NULL, 'Transforming protein P21 ras signature', NULL, 'RASTRNSFRMNG', NULL, NULL, NULL, 13),
(279390, NULL, 'PR02018', NULL, NULL, 'Aquaporin-6 signature', NULL, 'AQUAPORIN6', NULL, NULL, 19639, 13),
(279391, NULL, 'PR00549', NULL, NULL, 'Hyperglycemic hormone type 2 signature', NULL, 'HYPRGLYCEMC2', NULL, NULL, 2146, 13),
(279392, NULL, 'PR00728', NULL, NULL, 'Eukaryotic signal peptidase (S26B) family signature', NULL, 'SIGNALPTASE', NULL, NULL, 3357, 13),
(279393, NULL, 'PR00156', NULL, NULL, 'Type I copper blue protein family signature', NULL, 'COPPERBLUE', NULL, NULL, 779, 13),
(279394, NULL, 'PR00177', NULL, NULL, 'NMDA receptor signature', NULL, 'NMDARECEPTOR', NULL, NULL, 6328, 13),
(279395, NULL, 'PR01616', NULL, NULL, 'Gamma-aminobutyric-acid A receptor alpha 3 subunit signature', NULL, 'GABAARALPHA3', NULL, NULL, 61, 13),
(279396, NULL, 'PR00553', NULL, NULL, 'Adenosine A2A receptor signature', NULL, 'ADENOSINA2AR', NULL, NULL, 6053, 13),
(279397, NULL, 'PR01626', NULL, NULL, 'L-type calcium channel beta subunit signature', NULL, 'LCACHANNELB', NULL, NULL, 5682, 13),
(279398, NULL, 'PR00767', NULL, NULL, 'Dopamine-beta-monooxygenase signature', NULL, 'DBMONOXGNASE', NULL, NULL, 21615, 13),
(279399, NULL, 'PR01216', NULL, NULL, 'Adhesive plaque protein signature', NULL, 'ADHESIVEI', NULL, NULL, 582, 13),
(279400, NULL, 'PR00718', NULL, NULL, 'Phospholipase D signature', NULL, 'PHPHLIPASED', NULL, NULL, 2764, 13),
(279401, NULL, 'PR00222', NULL, NULL, 'Cucumovirus coat protein signature', NULL, 'CUCUMOCOAT', NULL, NULL, 667, 13),
(279402, NULL, 'PR00677', NULL, NULL, 'Phosducin signature', NULL, 'PHOSDUCIN', NULL, NULL, 1413, 13),
(279403, NULL, 'PR00499', NULL, NULL, 'Neutrophil cytosol factor 2 signature', NULL, 'P67PHOX', NULL, NULL, NULL, 13),
(279404, NULL, 'PR01721', NULL, NULL, 'Fractalkine/neurotactin precursor signature', NULL, 'FRACTALKINE', NULL, NULL, NULL, 13);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(279405, NULL, 'PR01716', NULL, NULL, 'Death associated protein 3 family signature', NULL, 'DEATHASSOCP3', NULL, NULL, 6219, 13),
(279406, NULL, 'PR01215', NULL, NULL, 'Alpha-1-microglobulin signature', NULL, 'A1MCGLOBULIN', NULL, NULL, 607, 13),
(279407, NULL, 'PR01556', NULL, NULL, 'Type IV secretion system CagX conjugation protein signature', NULL, 'TYPE4SSCAGX', NULL, NULL, 5075, 13),
(279408, NULL, 'PR02108', NULL, NULL, 'Mas-related G-protein coupled receptor family signature', NULL, 'MRGPCRFAMILY', NULL, NULL, 26664, 13),
(279409, NULL, 'PR01951', NULL, NULL, 'Eukaryotic LanC-like protein family signature', NULL, 'LANCEUKARYTE', NULL, NULL, 18959, 13),
(279410, NULL, 'PR00029', NULL, NULL, 'Octamer-binding transcription factor signature', NULL, 'OCTAMER', NULL, NULL, 3497, 13),
(279411, NULL, 'PR01278', NULL, NULL, 'CD97 protein signature', NULL, 'CD97PROTEIN', NULL, NULL, 623, 13),
(279412, NULL, 'PR01784', NULL, NULL, 'Melanin-concentrating hormone 2 receptor signature', NULL, 'MCH2RECEPTOR', NULL, NULL, 7939, 13),
(279413, NULL, 'PR01793', NULL, NULL, 'Voltage-dependent calcium channel gamma-5 subunit signature', NULL, 'VDCCGAMMA5', NULL, NULL, 7802, 13),
(279414, NULL, 'PR01157', NULL, NULL, 'P2Y purinoceptor signature', NULL, 'P2YPURNOCPTR', NULL, NULL, NULL, 13),
(279415, NULL, 'PR01773', NULL, NULL, 'P38 MAP kinase signature', NULL, 'P38MAPKINASE', NULL, NULL, 7978, 13),
(279416, NULL, 'PR00735', NULL, NULL, 'Glycosyl hydrolase family 8 signature', NULL, 'GLHYDRLASE8', NULL, NULL, 5130, 13),
(279417, NULL, 'PR00937', NULL, NULL, 'T-Box domain signature', NULL, 'TBOX', NULL, NULL, 36881, 13),
(279418, NULL, 'PR00484', NULL, NULL, 'Pheromone/general odorant binding protein signature', NULL, 'PBPGOBP', NULL, NULL, 2853, 13),
(279419, NULL, 'PR01884', NULL, NULL, 'Myelin and lymphocyte protein family', NULL, 'MALPROTEIN', NULL, NULL, 8744, 13),
(279420, NULL, 'PR00505', NULL, NULL, 'D12 class N6 adenine-specific DNA methyltransferase signature', NULL, 'D12N6MTFRASE', NULL, NULL, 11638, 13),
(279421, NULL, 'PR00649', NULL, NULL, 'GPR6 orphan receptor signature', NULL, 'GPR6ORPHANR', NULL, NULL, 1040, 13),
(279422, NULL, 'PR00935', NULL, NULL, 'Band 4.1 protein family signature', NULL, 'BAND41', NULL, NULL, 21000, 13),
(279423, NULL, 'PR00917', NULL, NULL, 'Small round structured virus (C37) cysteine protease family signature', NULL, 'SRSVCYSPTASE', NULL, NULL, 3146, 13),
(279424, NULL, 'PR00065', NULL, NULL, 'TEA domain signature', NULL, 'TEADOMAIN', NULL, NULL, 4900, 13),
(279425, NULL, 'PR01413', NULL, NULL, 'Cytochrome c-type biogenesis protein NrfE signature', NULL, 'NRFEBIOGNSIS', NULL, NULL, 360, 13),
(279426, NULL, 'PR01549', NULL, NULL, 'Autoinducer synthesis protein signature', NULL, 'AUTOINDCRSYN', NULL, NULL, 3015, 13),
(279427, NULL, 'PR01735', NULL, NULL, 'P2Y13 purinoceptor signature', NULL, 'P2Y13PRNCPTR', NULL, NULL, 6063, 13),
(279428, NULL, 'PR01280', NULL, NULL, 'Corticotropin releasing factor type 1 receptor signature', NULL, 'CRFRECEPTOR1', NULL, NULL, 521, 13),
(279429, NULL, 'PR01985', NULL, NULL, 'Neurogenic locus Notch protein 2 signature', NULL, 'NOTCH2', NULL, NULL, 15516, 13),
(279430, NULL, 'PR00308', NULL, NULL, 'Type I antifreeze protein signature', NULL, 'ANTIFREEZEI', NULL, NULL, 3773, 13),
(279431, NULL, 'PR01770', NULL, NULL, 'ERK1/2 MAP kinase signature', NULL, 'ERK1ERK2MAPK', NULL, NULL, 7796, 13),
(279432, NULL, 'PR01948', NULL, NULL, 'Avian interleukin-15 signature', NULL, 'INTLKN15BIRD', NULL, NULL, 20719, 13),
(279433, NULL, 'PR00691', NULL, NULL, 'Adhesin B signature', NULL, 'ADHESINB', NULL, NULL, 10013, 13),
(279434, NULL, 'PR01970', NULL, NULL, 'Tumour necrosis factor receptor 19-like signature', NULL, 'TNFACTORR19L', NULL, NULL, 15826, 13),
(279435, NULL, 'PR01426', NULL, NULL, 'Transforming growth factor beta 3 precursor signature', NULL, 'TGFBETA3', NULL, NULL, 17147, 13),
(279436, NULL, 'PR02025', NULL, NULL, 'Aquaporin-12 signature', NULL, 'AQUAPORIN12', NULL, NULL, 20401, 13),
(279437, NULL, 'PR01325', NULL, NULL, 'Kir2.2 inward rectifier K+ channel signature', NULL, 'KIR22CHANNEL', NULL, NULL, 3111, 13);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(279438, NULL, 'PR00195', NULL, NULL, 'Dynamin signature', NULL, 'DYNAMIN', NULL, NULL, 17225, 13),
(279439, NULL, 'PR00520', NULL, NULL, 'Adrenocorticotrophin receptor signature', NULL, 'ACTROPHINR', NULL, NULL, 1387, 13),
(279440, NULL, 'PR00926', NULL, NULL, 'Mitochondrial carrier protein signature', NULL, 'MITOCARRIER', NULL, NULL, 5489, 13),
(279441, NULL, 'PR01152', NULL, NULL, 'Protease activated receptor 2 precursor signature', NULL, 'PROTEASEAR2', NULL, NULL, 331, 13),
(279442, NULL, 'PR00671', NULL, NULL, 'Inhibin beta B chain signature', NULL, 'INHIBINBB', NULL, NULL, NULL, 13),
(279443, NULL, 'PR01829', NULL, NULL, 'Protachykinin 1 precursor signature', NULL, 'PROTACHYKNIN', NULL, NULL, 610, 13),
(279444, NULL, 'PR01495', NULL, NULL, 'Shab voltage-gated K+ channel family signature', NULL, 'SHABCHANNEL', NULL, NULL, 7144, 13),
(279445, NULL, 'PR01395', NULL, NULL, 'Bordetella pertussis toxin A subunit signature', NULL, 'BORPETOXINA', NULL, NULL, 4447, 13),
(279446, NULL, 'PR00868', NULL, NULL, 'DNA-polymerase family A (pol I) signature', NULL, 'DNAPOLI', NULL, NULL, 212, 13),
(279447, NULL, 'PR02021', NULL, NULL, 'Aquaporin-9 signature', NULL, 'AQUAPORIN9', NULL, NULL, 18009, 13),
(279448, NULL, 'PR01644', NULL, NULL, 'Transient receptor potential channel 3 signature', NULL, 'TRPCHANNEL3', NULL, NULL, 960, 13),
(279449, NULL, 'PR00853', NULL, NULL, 'Xeroderma pigmentosum group G/yeast RAD superfamily signature', NULL, 'XPGRADSUPER', NULL, NULL, 2855, 13),
(279450, NULL, 'PR00530', NULL, NULL, 'Histamine H1 receptor signature', NULL, 'HISTAMINEH1R', NULL, NULL, 3472, 13),
(279451, NULL, 'PR01925', NULL, NULL, 'Mammalian nerve growth factor beta subunit signature', NULL, 'MAMLNGFBETA', NULL, NULL, 18926, 13),
(279452, NULL, 'PR01856', NULL, NULL, 'Basigin signature', NULL, 'BASIGIN', NULL, NULL, NULL, 13),
(279453, NULL, 'PR00243', NULL, NULL, 'Muscarinic acetylcholine receptor signature', NULL, 'MUSCARINICR', NULL, NULL, 152, 13),
(279454, NULL, 'PR01731', NULL, NULL, 'Lymphotactin precursor signature', NULL, 'LYMPHOTACTIN', NULL, NULL, 6243, 13),
(279455, NULL, 'PR00066', NULL, NULL, 'Xeroderma pigmentosum group G protein signature', NULL, 'XRODRMPGMNTG', NULL, NULL, 2233, 13),
(279456, NULL, 'PR01423', NULL, NULL, 'Transforming growth factor beta precursor signature', NULL, 'TGFBETA', NULL, NULL, 20172, 13),
(279457, NULL, 'PR00044', NULL, NULL, 'Myc proto-oncogene signature', NULL, 'LEUZIPPRMYC', NULL, NULL, 6983, 13),
(279458, NULL, 'PR00516', NULL, NULL, '5-hydroxytryptamine 2A receptor signature', NULL, '5HT2ARECEPTR', NULL, NULL, 6629, 13),
(279459, NULL, 'PR00498', NULL, NULL, 'Neutrophil cytosol factor 1 signature', NULL, 'P47PHOX', NULL, NULL, 5180, 13),
(279460, NULL, 'PR01789', NULL, NULL, 'Nuclear factor of activated T cells (NFAT) signature', NULL, 'NUCFACTORATC', NULL, NULL, 7925, 13),
(279461, NULL, 'PR01346', NULL, NULL, 'Helicobacter neutrophil-activating protein A family signature', NULL, 'HELNAPAPROT', NULL, NULL, 488, 13),
(279462, NULL, 'PR01941', NULL, NULL, 'Neurotrophic tyrosine kinase receptor type 2 signature', NULL, 'NTKRECEPTOR2', NULL, NULL, 19931, 13),
(279463, NULL, 'PR00399', NULL, NULL, 'Synaptotagmin signature', NULL, 'SYNAPTOTAGMN', NULL, NULL, 5081, 13),
(279464, NULL, 'PR00225', NULL, NULL, 'Geminivirus BR1 coat protein signature', NULL, 'GEMCOATBR1', NULL, NULL, 5790, 13),
(279465, NULL, 'PR00141', NULL, NULL, 'Proteasome component signature', NULL, 'PROTEASOME', NULL, NULL, 4932, 13),
(279466, NULL, 'PR01786', NULL, NULL, 'Paraoxonase 1 signature', NULL, 'PARAOXONASE1', NULL, NULL, 7584, 13),
(279467, NULL, 'PR00501', NULL, NULL, 'Kelch repeat signature', NULL, 'KELCHREPEAT', NULL, NULL, NULL, 13),
(279468, NULL, 'PR01411', NULL, NULL, 'Cytochrome c-type biogenesis protein CcmF signature', NULL, 'CCMFBIOGNSIS', NULL, NULL, 249, 13),
(279469, NULL, 'PR00286', NULL, NULL, 'Charybdotoxin signature', NULL, 'CHARYBDTOXIN', NULL, NULL, 2205, 13),
(279470, NULL, 'PR01817', NULL, NULL, 'Beta-site APP cleaving enzyme 2 (BACE2) signature', NULL, 'BACE2', NULL, NULL, 10048, 13);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(279471, NULL, 'PR00395', NULL, NULL, 'Ribosomal protein S2 signature', NULL, 'RIBOSOMALS2', NULL, NULL, 4059, 13),
(279472, NULL, 'PR01348', NULL, NULL, 'Nucleotide-sensitive chloride conductance regulator (ICln) signature', NULL, 'ICLNCHANNEL', NULL, NULL, 6382, 13),
(279473, NULL, 'PR00920', NULL, NULL, 'Spumavirus aspartic protease (A9) signature', NULL, 'SPUMVIRPTASE', NULL, NULL, 3575, 13),
(279474, NULL, 'PR00383', NULL, NULL, 'Pro-opiomelanocortin signature', NULL, 'MELANOCORTIN', NULL, NULL, 2396, 13),
(279475, NULL, 'PR00833', NULL, NULL, 'Pollen allergen Poa pI signature', NULL, 'POAALLERGEN', NULL, NULL, NULL, 13),
(279476, NULL, 'PR01963', NULL, NULL, 'Tumour necrosis factor receptor 13B signature', NULL, 'TNFACTORR13B', NULL, NULL, 15896, 13),
(279477, NULL, 'PR00513', NULL, NULL, '5-hydroxytryptamine 1B receptor signature', NULL, '5HT1BRECEPTR', NULL, NULL, 1215, 13),
(279478, NULL, 'PR01129', NULL, NULL, 'Gastric inhibitory polypeptide receptor precursor signature', NULL, 'GIPRECEPTOR', NULL, NULL, 4954, 13),
(279479, NULL, 'PR01359', NULL, NULL, 'Interleukin-1 beta precursor signature', NULL, 'INTRLEUKIN1B', NULL, NULL, NULL, 13),
(279480, NULL, 'PR01631', NULL, NULL, 'N-type voltage-dependent calcium channel alpha-1 subunit signature', NULL, 'NVDCCALPHA1', NULL, NULL, 86, 13),
(279481, NULL, 'PR00535', NULL, NULL, 'Melanocortin receptor signature', NULL, 'MELNOCORTINR', NULL, NULL, 2286, 13),
(279482, NULL, 'PR00682', NULL, NULL, 'Isopenicillin N synthase signature', NULL, 'IPNSYNTHASE', NULL, NULL, NULL, 13),
(279483, NULL, 'PR01725', NULL, NULL, 'Gamma-aminobutyric-acid A receptor theta subunit signature', NULL, 'GABAARTHETA', NULL, NULL, 6309, 13),
(279484, NULL, 'PR00515', NULL, NULL, '5-hydroxytryptamine 1F receptor signature', NULL, '5HT1FRECEPTR', NULL, NULL, NULL, 13),
(279485, NULL, 'PR01038', NULL, NULL, 'Arginyl-tRNA synthetase signature', NULL, 'TRNASYNTHARG', NULL, NULL, 34, 13),
(279486, NULL, 'PR00798', NULL, NULL, 'Togavirin (S3) serine protease family signature', NULL, 'TOGAVIRIN', NULL, NULL, 3051, 13),
(279487, NULL, 'PR01010', NULL, NULL, 'Flagellar P-ring protein signature', NULL, 'FLGPRINGFLGI', NULL, NULL, 3457, 13),
(279488, NULL, 'PR00103', NULL, NULL, 'cAMP-dependent protein kinase signature', NULL, 'CAMPKINASE', NULL, NULL, NULL, 13),
(279489, NULL, 'PR00940', NULL, NULL, 'Cation-transporting P-type ATPase A signature', NULL, 'CATPATPASEA', NULL, NULL, 5658, 13),
(279490, NULL, 'PR02010', NULL, NULL, 'RNA (C5-cytosine) methyltransferase subfamily 9 signature', NULL, 'RCMT9', NULL, NULL, 14213, 13),
(279491, NULL, 'PR01767', NULL, NULL, 'Epithelial calcium channel 2 (ECAC2) family signature', NULL, 'ECACCHANNEL2', NULL, NULL, 7957, 13),
(279492, NULL, 'PR00512', NULL, NULL, '5-hydroxytryptamine 1A receptor signature', NULL, '5HT1ARECEPTR', NULL, NULL, 5714, 13),
(279493, NULL, 'PR00371', NULL, NULL, 'Flavoprotein pyridine nucleotide cytochrome reductase signature', NULL, 'FPNCR', NULL, NULL, 3484, 13),
(279494, NULL, 'PR00652', NULL, NULL, '5-hydroxytryptamine 7 receptor signature', NULL, '5HT7RECEPTR', NULL, NULL, 2336, 13),
(279495, NULL, 'PR00763', NULL, NULL, 'Coagulin signature', NULL, 'COAGULIN', NULL, NULL, 882, 13),
(279496, NULL, 'PR00172', NULL, NULL, 'Mammalian facilitated glucose transporter family signature', NULL, 'GLUCTRNSPORT', NULL, NULL, NULL, 13),
(279497, NULL, 'PR00950', NULL, NULL, 'Type III secretion system inner membrane S protein family signature', NULL, 'TYPE3IMSPROT', NULL, NULL, 10034, 13),
(279498, NULL, 'PR00838', NULL, NULL, 'Venom allergen 5 signature', NULL, 'V5ALLERGEN', NULL, NULL, 2739, 13),
(279499, NULL, 'PR02039', NULL, NULL, 'Pre-mRNA-splicing factor BRR1 signature', NULL, 'SPLICEFRBRR1', NULL, NULL, 9483, 13),
(279500, NULL, 'PR00670', NULL, NULL, 'Inhibin beta A chain signature', NULL, 'INHIBINBA', NULL, NULL, 5806, 13),
(279501, NULL, 'PR01263', NULL, NULL, 'Intracellular chloride (Cl-) channel signature', NULL, 'INTCLCHANNEL', NULL, NULL, 6632, 13),
(279502, NULL, 'PR00986', NULL, NULL, 'Valyl-tRNA synthetase signature', NULL, 'TRNASYNTHVAL', NULL, NULL, 4388, 13);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(279503, NULL, 'PR00087', NULL, NULL, 'Lipoxygenase signature', NULL, 'LIPOXYGENASE', NULL, NULL, 7731, 13),
(279504, NULL, 'PR01624', NULL, NULL, 'Preproghrelin peptide signature', NULL, 'GHRELIN', NULL, NULL, 77, 13),
(279505, NULL, 'PR01193', NULL, NULL, 'Glucose transporter type 4 (GLUT4) signature', NULL, 'GLUCTRSPORT4', NULL, NULL, 6767, 13),
(279506, NULL, 'PR01839', NULL, NULL, 'DNA repair protein Rad23 signature', NULL, 'RAD23PROTEIN', NULL, NULL, 4234, 13),
(279507, NULL, 'PR00353', NULL, NULL, '4Fe-4S ferredoxin signature', NULL, '4FE4SFRDOXIN', NULL, NULL, NULL, 13),
(279508, NULL, 'PR01059', NULL, NULL, '5-hydroxytryptamine 4 receptor signature', NULL, '5HT4RECEPTR', NULL, NULL, 6417, 13),
(279509, NULL, 'PR00756', NULL, NULL, 'Membrane alanyl dipeptidase (M1) family signature', NULL, 'ALADIPTASE', NULL, NULL, 4111, 13),
(279510, NULL, 'PR00788', NULL, NULL, 'Nitrophorin signature', NULL, 'NITROPHORIN', NULL, NULL, 6783, 13),
(279511, NULL, 'PR00760', NULL, NULL, 'Bontoxilysin signature', NULL, 'BONTOXILYSIN', NULL, NULL, 4153, 13),
(279512, NULL, 'PR01239', NULL, NULL, 'CYP52 P450 protein signature', NULL, 'EP450IICYP52', NULL, NULL, 7271, 13),
(279513, NULL, 'PR01334', NULL, NULL, 'Chlamydia major outer membrane protein signature', NULL, 'CHLAMIDIAOMP', NULL, NULL, 5536, 13),
(279514, NULL, 'PR01866', NULL, NULL, 'MCL1 (myeloid cell leukaemia 1) apoptosis regulator protein signature', NULL, 'APOPREGMCL1', NULL, NULL, 8774, 13),
(279515, NULL, 'PR01962', NULL, NULL, 'Tumour necrosis factor receptor 12 signature', NULL, 'TNFACTORR12', NULL, NULL, 15723, 13),
(279516, NULL, 'PR00741', NULL, NULL, 'Glycosyl hydrolase family 29 signature', NULL, 'GLHYDRLASE29', NULL, NULL, 19622, 13),
(279517, NULL, 'PR01415', NULL, NULL, 'Ankyrin repeat signature', NULL, 'ANKYRIN', NULL, NULL, 1485, 13),
(279518, NULL, 'PR01297', NULL, NULL, 'Colicin lysis protein signature', NULL, 'LYSISCOLICIN', NULL, NULL, 530, 13),
(279519, NULL, 'PR01924', NULL, NULL, 'Tumour necrosis factor receptor 9 signature', NULL, 'TNFACTORR9', NULL, NULL, 18891, 13),
(279520, NULL, 'PR00258', NULL, NULL, 'Speract receptor signature', NULL, 'SPERACTRCPTR', NULL, NULL, 1378, 13),
(279521, NULL, 'PR01362', NULL, NULL, 'Flagellar calcium-binding protein (calflagin) signature', NULL, 'CALFLAGIN', NULL, NULL, 3017, 13),
(279522, NULL, 'PR01617', NULL, NULL, 'Gamma-aminobutyric-acid A receptor alpha 4 subunit signature', NULL, 'GABAARALPHA4', NULL, NULL, 45, 13),
(279523, NULL, 'PR01989', NULL, NULL, 'Metazoan eukaryotic MAS20 (TOM20) import receptor subunit signature', NULL, 'EUOM20RECPTR', NULL, NULL, 15544, 13),
(279524, NULL, 'PR00658', NULL, NULL, 'CD44 antigen precursor signature', NULL, 'CD44', NULL, NULL, 946, 13),
(279525, NULL, 'PR00217', NULL, NULL, '43kDa postsynaptic protein signature', NULL, 'POSTSYNAPTIC', NULL, NULL, 5163, 13),
(279526, NULL, 'PR01376', NULL, NULL, 'Yersinia/Haemophilus virulence surface antigen signature', NULL, 'BACSURFANTGN', NULL, NULL, 7001, 13),
(279527, NULL, 'PR01569', NULL, NULL, 'P2Y12 purinoceptor signature', NULL, 'P2Y12PRNCPTR', NULL, NULL, 7348, 13),
(279528, NULL, 'PR00174', NULL, NULL, 'LacY proton/sugar symporter family signature', NULL, 'LACYSMPORT', NULL, NULL, 5520, 13),
(279529, NULL, 'PR00229', NULL, NULL, 'Geminivirus MSV AL1 coat protein signature', NULL, 'GEMCOATMSVL1', NULL, NULL, 2208, 13),
(279530, NULL, 'PR01066', NULL, NULL, 'P2Y4 purinoceptor signature', NULL, 'P2Y4PRNOCPTR', NULL, NULL, 2601, 13),
(279531, NULL, 'PR01559', NULL, NULL, 'Duffy antigen/chemokine receptor signature', NULL, 'DUFFYANTIGEN', NULL, NULL, NULL, 13),
(279532, NULL, 'PR00310', NULL, NULL, 'Anti-proliferative protein BTG1 family signature', NULL, 'ANTIPRLFBTG1', NULL, NULL, 1263, 13),
(279533, NULL, 'PR00272', NULL, NULL, 'Erythropoietin signature', NULL, 'ERYTHROPTN', NULL, NULL, 7148, 13),
(279534, NULL, 'PR01506', NULL, NULL, 'Bacterial sec-independent translocation TatB protein signature', NULL, 'TATBPROTEIN', NULL, NULL, NULL, 13),
(279535, NULL, 'PR00878', NULL, NULL, 'Cholinesterase signature', NULL, 'CHOLNESTRASE', NULL, NULL, 3345, 13);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(279536, NULL, 'PR00271', NULL, NULL, 'Defensin signature', NULL, 'DEFENSIN', NULL, NULL, 19144, 13),
(279537, NULL, 'PR00559', NULL, NULL, 'Alpha-2B adrenergic receptor signature', NULL, 'ADRENRGCA2BR', NULL, NULL, 7363, 13),
(279538, NULL, 'PR00538', NULL, NULL, 'Muscarinic M1 receptor signature', NULL, 'MUSCRINICM1R', NULL, NULL, 482, 13),
(279539, NULL, 'PR01897', NULL, NULL, 'ABC transporter family B3 signature', NULL, 'TAP2PROTEIN', NULL, NULL, 4152, 13),
(279540, NULL, 'PR01130', NULL, NULL, 'Delayed-early response protein/equilibrative nucleoside transporter signature', NULL, 'DERENTRNSPRT', NULL, NULL, 5749, 13),
(279541, NULL, 'PR01740', NULL, NULL, 'Septin 2 signature', NULL, 'SEPTIN2', NULL, NULL, 6106, 13),
(279542, NULL, 'PR01908', NULL, NULL, 'Atypical dual specificity phosphatase family signature', NULL, 'ADSPHPHTASE', NULL, NULL, NULL, 13),
(279543, NULL, 'PR00266', NULL, NULL, 'Interferon alpha and beta subunit signature', NULL, 'INTERFERONAB', NULL, NULL, 5598, 13),
(279544, NULL, 'PR01857', NULL, NULL, 'ADAM-TS family signature', NULL, 'ADAMTSFAMILY', NULL, NULL, 6957, 13),
(279545, NULL, 'PR01806', NULL, NULL, 'Virulence factor MviN signature', NULL, 'VIRFACTRMVIN', NULL, NULL, 3910, 13),
(279546, NULL, 'PR01703', NULL, NULL, 'Manganese superoxide dismutase signature', NULL, 'MNSODISMTASE', NULL, NULL, 1053, 13),
(279547, NULL, 'PR00825', NULL, NULL, 'Vespid venom allergen phospholipase A1 signature', NULL, 'DOLALLERGEN', NULL, NULL, 6395, 13),
(279548, NULL, 'PR00657', NULL, NULL, 'Chemokine receptor signature', NULL, 'CCCHEMOKINER', NULL, NULL, 392, 13),
(279549, NULL, 'PR01202', NULL, NULL, 'Dopamine neurotransmitter transporter signature', NULL, 'DOPTRANSPORT', NULL, NULL, 6827, 13),
(279550, NULL, 'PR00645', NULL, NULL, 'C-X-C chemokine receptor type 4 signature', NULL, 'CXCCHMKINER4', NULL, NULL, 1851, 13),
(279551, NULL, 'PR00813', NULL, NULL, 'Bacterial general secretion pathway protein G signature', NULL, 'BCTERIALGSPG', NULL, NULL, 281, 13),
(279552, NULL, 'PR01445', NULL, NULL, 'Claudin-6 signature', NULL, 'CLAUDIN6', NULL, NULL, 6404, 13),
(279553, NULL, 'PR01675', NULL, NULL, 'Glycine receptor alpha 2 subunit signature', NULL, 'GLYRALPHA2', NULL, NULL, 6183, 13),
(279554, NULL, 'PR00928', NULL, NULL, 'Graves disease carrier protein signature', NULL, 'GRAVESDC', NULL, NULL, 38, 13),
(279555, NULL, 'PR01354', NULL, NULL, 'Glucagon receptor signature', NULL, 'GLUCAGONR', NULL, NULL, 3024, 13),
(279556, NULL, 'PR00857', NULL, NULL, 'Melatonin receptor signature', NULL, 'MELATONINR', NULL, NULL, 2783, 13),
(279557, NULL, 'PR01576', NULL, NULL, 'Peptide deformylase signature', NULL, 'PDEFORMYLASE', NULL, NULL, 6229, 13),
(279558, NULL, 'PR00292', NULL, NULL, 'Potato inhibitor I signature', NULL, 'POTATOINHBTR', NULL, NULL, 422, 13),
(279559, NULL, 'PR01837', NULL, NULL, 'MgtC/SapB protein signature', NULL, 'MGTCSAPBPROT', NULL, NULL, 4094, 13),
(279560, NULL, 'PR00198', NULL, NULL, 'Annexin type II signature', NULL, 'ANNEXINII', NULL, NULL, 6918, 13),
(279561, NULL, 'PR01448', NULL, NULL, 'Claudin-18 signature', NULL, 'CLAUDIN18', NULL, NULL, 6497, 13),
(279562, NULL, 'PR01621', NULL, NULL, 'Gamma-aminobutyric-acid A receptor gamma 1 subunit signature', NULL, 'GABAARGAMMA1', NULL, NULL, 466, 13),
(279563, NULL, 'PR00887', NULL, NULL, 'Structure-specific recognition protein signature', NULL, 'SSRCOGNITION', NULL, NULL, 3070, 13),
(279564, NULL, 'PR02046', NULL, NULL, 'Retina-specific protein F379 family signature', NULL, 'FAM138ABCDF', NULL, NULL, 15609, 13),
(279565, NULL, 'PR01022', NULL, NULL, 'Outer membrane protein A signature', NULL, 'OUTRMMBRANEA', NULL, NULL, 6431, 13),
(279566, NULL, 'PR01555', NULL, NULL, 'Escherichia coli P pili tip fibrillum papE protein signature', NULL, 'FIMBRIALPAPE', NULL, NULL, 1747, 13),
(279567, NULL, 'PR01745', NULL, NULL, 'Dense granule Gra2 protein signature', NULL, 'DENSEGRNULE2', NULL, NULL, 6340, 13),
(279568, NULL, 'PR00841', NULL, NULL, 'Bacterial beta-amylase signature', NULL, 'GLHYDLASE14A', NULL, NULL, 1660, 13);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(279569, NULL, 'PR00466', NULL, NULL, 'Cytochrome B-245 heavy chain signature', NULL, 'GP91PHOX', NULL, NULL, 4443, 13),
(279570, NULL, 'PR01101', NULL, NULL, '5-hydroxytryptamine receptor signature', NULL, '5HTRECEPTOR', NULL, NULL, 403, 13),
(279571, NULL, 'PR01380', NULL, NULL, 'Claudin-5 signature', NULL, 'CLAUDIN5', NULL, NULL, 7491, 13),
(279572, NULL, 'PR00337', NULL, NULL, 'Leu/Ile/Val-binding protein family signature', NULL, 'LEUILEVALBP', NULL, NULL, 3832, 13),
(279573, NULL, 'PR00706', NULL, NULL, 'Pyroglutamyl peptidase I (C15) family signature', NULL, 'PYROGLUPTASE', NULL, NULL, 6564, 13),
(279574, NULL, 'PR01598', NULL, NULL, 'Zona occludens protein ZO-1 signature', NULL, 'ZONOCCLUDNS1', NULL, NULL, 7188, 13),
(279575, NULL, 'PR01790', NULL, NULL, 'Senescence marker protein-30 (SMP30) family signature', NULL, 'SMP30FAMILY', NULL, NULL, 821, 13),
(279576, NULL, 'PR01795', NULL, NULL, 'Voltage-dependent calcium channel gamma-7 subunit signature', NULL, 'VDCCGAMMA7', NULL, NULL, 7893, 13),
(279577, NULL, 'PR01072', NULL, NULL, 'Presenilin family signature', NULL, 'PRESENILIN', NULL, NULL, 5281, 13),
(279578, NULL, 'PR00908', NULL, NULL, 'Thrombin receptor signature', NULL, 'THROMBINR', NULL, NULL, 131, 13),
(279579, NULL, 'PR01257', NULL, NULL, 'Otx2 transcription factor signature', NULL, 'OTX2HOMEOBOX', NULL, NULL, 287, 13),
(279580, NULL, 'PR01973', NULL, NULL, 'Tumour necrosis factor receptor 27 signature', NULL, 'TNFACTORR27', NULL, NULL, 15978, 13),
(279581, NULL, 'PR00510', NULL, NULL, 'Nebulin signature', NULL, 'NEBULIN', NULL, NULL, 12564, 13),
(279582, NULL, 'PR01304', NULL, NULL, 'Norrie disease protein signature', NULL, 'NORRIEDSEASE', NULL, NULL, 6605, 13),
(279583, NULL, 'PR01827', NULL, NULL, 'Non-receptor tyrosine-protein kinase TYK2 signature', NULL, 'YKINASETYK2', NULL, NULL, 12950, 13),
(279584, NULL, 'PR00536', NULL, NULL, 'Melanocyte stimulating hormone receptor signature', NULL, 'MELNOCYTESHR', NULL, NULL, 6865, 13),
(279585, NULL, 'PR00727', NULL, NULL, 'Bacterial leader peptidase 1 (S26A) family signature', NULL, 'LEADERPTASE', NULL, NULL, 3507, 13),
(279586, NULL, 'PR00391', NULL, NULL, 'Phosphatidylinositol transfer protein signature', NULL, 'PITRANSFER', NULL, NULL, 5023, 13),
(279587, NULL, 'PR00042', NULL, NULL, 'Fos transforming protein signature', NULL, 'LEUZIPPRFOS', NULL, NULL, 178, 13),
(279588, NULL, 'PR01849', NULL, NULL, 'Ubiquitin-activating enzyme E1 signature', NULL, 'UBIQUITINACT', NULL, NULL, 2541, 13),
(279589, NULL, 'PR00355', NULL, NULL, 'Adrenodoxin signature', NULL, 'ADRENODOXIN', NULL, NULL, 2350, 13),
(279590, NULL, 'PR00210', NULL, NULL, 'High molecular weight glutenin signature', NULL, 'GLUTENIN', NULL, NULL, 6686, 13),
(279591, NULL, 'PR01592', NULL, NULL, 'Low calcium response V antigen signature', NULL, 'LCRVANTIGEN', NULL, NULL, 7225, 13),
(279592, NULL, 'PR01295', NULL, NULL, 'Cloacin signature', NULL, 'CLOACIN', NULL, NULL, 23267, 13),
(279593, NULL, 'PR02112', NULL, NULL, 'Mas-related G protein-coupled receptor F signature', NULL, 'MRGPCRF', NULL, NULL, 26914, 13),
(279594, NULL, 'PR02048', NULL, NULL, 'Protein family FAM25 signature', NULL, 'PROTEINF25', NULL, NULL, 15822, 13),
(279595, NULL, 'PR01657', NULL, NULL, 'Mini-chromosome maintenance (MCM) protein family signature', NULL, 'MCMFAMILY', NULL, NULL, 1088, 13),
(279596, NULL, 'PR00585', NULL, NULL, 'Prostanoid EP3 receptor type 3 signature', NULL, 'PRSTNOIDE33R', NULL, NULL, 1988, 13),
(279597, NULL, 'PR01942', NULL, NULL, 'Neurotrophic tyrosine kinase receptor type 3 signature', NULL, 'NTKRECEPTOR3', NULL, NULL, 20752, 13),
(279598, NULL, 'PR02067', NULL, NULL, 'Chromatin modification-related protein EAF5 signature', NULL, 'PROTEINEAF5', NULL, NULL, 25715, 13),
(279599, NULL, 'PR00827', NULL, NULL, 'Major allergen Fel Di signature', NULL, 'FELALLERGEN', NULL, NULL, 11090, 13),
(279600, NULL, 'PR00038', NULL, NULL, 'LuxR bacterial regulatory protein HTH signature', NULL, 'HTHLUXR', NULL, NULL, 6599, 13),
(279601, NULL, 'PR00952', NULL, NULL, 'Type III secretion system inner membrane Q protein family signature', NULL, 'TYPE3IMQPROT', NULL, NULL, 5091, 13);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(279602, NULL, 'PR00069', NULL, NULL, 'Aldo-keto reductase signature', NULL, 'ALDKETRDTASE', NULL, NULL, 19615, 13),
(279603, NULL, 'PR01082', NULL, NULL, 'K-Cl co-transporter type 1 (KCC1) signature', NULL, 'KCLTRNSPORT1', NULL, NULL, 5758, 13),
(279604, NULL, 'PR00542', NULL, NULL, 'Muscarinic M5 receptor signature', NULL, 'MUSCRINICM5R', NULL, NULL, 6822, 13),
(279605, NULL, 'PR02073', NULL, NULL, 'Folliculin-interacting protein 1 signature', NULL, 'FOLLICULNIP1', NULL, NULL, 22975, 13),
(279606, NULL, 'PR00822', NULL, NULL, 'Lipoprotein lipase signature', NULL, 'LIPOLIPASE', NULL, NULL, 6145, 13),
(279607, NULL, 'PR02105', NULL, NULL, 'Integrator complex subunit 2 signature', NULL, 'INTSUBUNIT2', NULL, NULL, 24978, 13),
(279608, NULL, 'PR00282', NULL, NULL, 'Snake cytotoxin signature', NULL, 'CYTOTOXIN', NULL, NULL, 461, 13),
(279609, NULL, 'PR01190', NULL, NULL, 'Glucose transporter type 1 (GLUT1) signature', NULL, 'GLUCTRSPORT1', NULL, NULL, 6984, 13),
(279610, NULL, 'PR00486', NULL, NULL, 'Uteroglobin signature', NULL, 'UTEROGLOBIN', NULL, NULL, 538, 13),
(279611, NULL, 'PR01960', NULL, NULL, 'Tumour necrosis factor receptor 7 signature', NULL, 'TNFACTORR7', NULL, NULL, 15618, 13),
(279612, NULL, 'PR01832', NULL, NULL, 'Vascular endothelial growth factor receptor signature', NULL, 'VEGFRECEPTOR', NULL, NULL, NULL, 13),
(279613, NULL, 'PR00586', NULL, NULL, 'Prostanoid EP4 receptor signature', NULL, 'PRSTNOIDEP4R', NULL, NULL, 5175, 13),
(279614, NULL, 'PR00263', NULL, NULL, 'Heparin binding growth factor family signature', NULL, 'HBGFFGF', NULL, NULL, 5967, 13),
(279615, NULL, 'PR00136', NULL, NULL, 'Lactalbumin signature', NULL, 'LACTALBUMIN', NULL, NULL, 5618, 13),
(279616, NULL, 'PR00869', NULL, NULL, 'DNA-polymerase family X signature', NULL, 'DNAPOLX', NULL, NULL, 15639, 13),
(279617, NULL, 'PR02086', NULL, NULL, 'Putative nuclease HARBI1 signature', NULL, 'PUTNUCHARBI1', NULL, NULL, 25926, 13),
(279618, NULL, 'PR00785', NULL, NULL, 'Nuclear translocator signature', NULL, 'NCTRNSLOCATR', NULL, NULL, 1340, 13),
(279619, NULL, 'PR02017', NULL, NULL, 'Aquaporin-5 signature', NULL, 'AQUAPORIN5', NULL, NULL, 17276, 13),
(279620, NULL, 'PR02000', NULL, NULL, 'Putative plant GPCR, GCR1, signature', NULL, 'GCR1PLANT', NULL, NULL, 15524, 13),
(279621, NULL, 'PR01774', NULL, NULL, 'Exfoliative toxin signature', NULL, 'EXFOLTOXIN', NULL, NULL, 7941, 13),
(279622, NULL, 'PR00901', NULL, NULL, 'Pheromone B alpha-1 receptor signature', NULL, 'PHEROMONEBAR', NULL, NULL, 6519, 13),
(279623, NULL, 'PR00651', NULL, NULL, '5-hydroxytryptamine 2B receptor signature', NULL, '5HT2BRECEPTR', NULL, NULL, 6900, 13),
(279624, NULL, 'PR00078', NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase signature', NULL, 'G3PDHDRGNASE', NULL, NULL, 19323, 13),
(279625, NULL, 'PR01475', NULL, NULL, 'Parkin signature', NULL, 'PARKIN', NULL, NULL, 7240, 13),
(279626, NULL, 'PR01200', NULL, NULL, 'Taurine transporter signature', NULL, 'TAUTRANSPORT', NULL, NULL, 6757, 13),
(279627, NULL, 'PR00403', NULL, NULL, 'WW domain signature', NULL, 'WWDOMAIN', NULL, NULL, NULL, 13),
(279628, NULL, 'PR00958', NULL, NULL, 'Homoserine kinase signature', NULL, 'HOMSERKINASE', NULL, NULL, NULL, 13),
(279629, NULL, 'PR00161', NULL, NULL, 'Nickel-dependent hydrogenase/B-type cytochrome signature', NULL, 'NIHGNASECYTB', NULL, NULL, 6762, 13),
(279630, NULL, 'PR00019', NULL, NULL, 'Leucine-rich repeat signature', NULL, 'LEURICHRPT', NULL, NULL, NULL, 13),
(279631, NULL, 'PR01491', NULL, NULL, 'Voltage-gated potassium channel family signature', NULL, 'KVCHANNEL', NULL, NULL, 7052, 13),
(279632, NULL, 'PR01936', NULL, NULL, 'Interleukin-22 signature', NULL, 'INTRLEUKIN22', NULL, NULL, 19682, 13),
(279633, NULL, 'PR01144', NULL, NULL, 'Lutropin-choriogonadotropic hormone receptor precursor signature', NULL, 'LSHRECEPTOR', NULL, NULL, 5983, 13),
(279634, NULL, 'PR01043', NULL, NULL, 'Glycyl-tRNA synthetase signature', NULL, 'TRNASYNTHGLY', NULL, NULL, NULL, 13),
(279635, NULL, 'PR01071', NULL, NULL, 'Acetyl-CoA biotin carboxyl carrier protein signature', NULL, 'ACOABIOTINCC', NULL, NULL, 2313, 13);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(279636, NULL, 'PR00589', NULL, NULL, 'Somatostatin receptor type 3 signature', NULL, 'SOMATOSTTN3R', NULL, NULL, 4468, 13),
(279637, NULL, 'PR01799', NULL, NULL, 'SF-assemblin signature', NULL, 'SFASSEMBLIN', NULL, NULL, 7869, 13),
(279638, NULL, 'PR00525', NULL, NULL, 'Delta opioid receptor signature', NULL, 'DELTAOPIOIDR', NULL, NULL, 4936, 13),
(279639, NULL, 'PR01011', NULL, NULL, 'Glutathione peroxidase family signature', NULL, 'GLUTPROXDASE', NULL, NULL, 4632, 13),
(279640, NULL, 'PR01755', NULL, NULL, 'Bacterial translocase SecF protein signature', NULL, 'SECFTRNLCASE', NULL, NULL, 16871, 13),
(279641, NULL, 'PR00624', NULL, NULL, 'Histone H5 signature', NULL, 'HISTONEH5', NULL, NULL, 5590, 13),
(279642, NULL, 'PR00235', NULL, NULL, 'Herpesvirus major capsid protein (MCP) signature', NULL, 'HSVCAPSIDMCP', NULL, NULL, 332, 13),
(279643, NULL, 'PR01655', NULL, NULL, 'UDP-glucose receptor signature', NULL, 'UDPGLUCOSER', NULL, NULL, 669, 13),
(279644, NULL, 'PR00911', NULL, NULL, 'Glycosyl hydrolase family 11 signature', NULL, 'GLHYDRLASE11', NULL, NULL, 1153, 13),
(279645, NULL, 'PR01537', NULL, NULL, 'Interleukin-1 receptor type I family signature', NULL, 'INTRLKN1R1F', NULL, NULL, NULL, 13),
(279646, NULL, 'PR01590', NULL, NULL, 'FIS bacterial regulatory protein HTH signature', NULL, 'HTHFIS', NULL, NULL, 103, 13),
(279647, NULL, 'PR01377', NULL, NULL, 'Claudin-1 signature', NULL, 'CLAUDIN1', NULL, NULL, 7333, 13),
(279648, NULL, 'PR00864', NULL, NULL, 'Type IV prepilin cysteine protease (C20) family signature', NULL, 'PREPILNPTASE', NULL, NULL, 9185, 13),
(279649, NULL, 'PR01217', NULL, NULL, 'Proline rich extensin signature', NULL, 'PRICHEXTENSN', NULL, NULL, NULL, 13),
(279650, NULL, 'PR00024', NULL, NULL, 'Homeobox signature', NULL, 'HOMEOBOX', NULL, NULL, 19405, 13),
(279651, NULL, 'PR01804', NULL, NULL, 'Ubiquitous surface protein signature', NULL, 'UBIQUITOUSSP', NULL, NULL, 7788, 13),
(279652, NULL, 'PR02059', NULL, NULL, 'Jagged/Serrate protein family signature', NULL, 'JAGGEDFAMILY', NULL, NULL, 25836, 13),
(279653, NULL, 'PR00990', NULL, NULL, 'Ribokinase signature', NULL, 'RIBOKINASE', NULL, NULL, 1084, 13),
(279654, NULL, 'PR01891', NULL, NULL, 'Wnt-7 protein signature', NULL, 'WNT7PROTEIN', NULL, NULL, 8943, 13),
(279655, NULL, 'PR01468', NULL, NULL, 'Staphylococcal bi-component toxin signature', NULL, 'BICOMPNTOXIN', NULL, NULL, 7156, 13),
(279656, NULL, 'PR00186', NULL, NULL, 'Hemerythrin signature', NULL, 'HEMERYTHRIN', NULL, NULL, 1104, 13),
(279657, NULL, 'PR01098', NULL, NULL, 'Topoisomerase IV subunit B signature', NULL, 'TOPISMRASE4B', NULL, NULL, 4547, 13),
(279658, NULL, 'PR01772', NULL, NULL, 'JNK MAP kinase signature', NULL, 'JNKMAPKINASE', NULL, NULL, 7551, 13),
(279659, NULL, 'PR01261', NULL, NULL, 'Tau protein signature', NULL, 'TAUPROTEIN', NULL, NULL, 6573, 13),
(279660, NULL, 'PR01869', NULL, NULL, 'Beta-catenin family signature', NULL, 'BCATNINFAMLY', NULL, NULL, 8697, 13),
(279661, NULL, 'PR01388', NULL, NULL, 'Cytolethal distending toxin B signature', NULL, 'CDTOXINB', NULL, NULL, 7395, 13),
(279662, NULL, 'PR00436', NULL, NULL, 'Interleukin-8 signature', NULL, 'INTERLEUKIN8', NULL, NULL, NULL, 13),
(279663, NULL, 'PR01567', NULL, NULL, 'Neuromedin U type 2 receptor signature', NULL, 'NEUROMEDNU2R', NULL, NULL, 7362, 13),
(279664, NULL, 'PR01714', NULL, NULL, 'Ferric iron reductase signature', NULL, '2FE2SRDCTASE', NULL, NULL, 6388, 13),
(279665, NULL, 'PR01401', NULL, NULL, 'Mutator MutT protein signature', NULL, 'MUTATORMUTT', NULL, NULL, 6075, 13),
(279666, NULL, 'PR00643', NULL, NULL, 'G10D orphan receptor signature', NULL, 'G10DORPHANR', NULL, NULL, 7352, 13),
(279667, NULL, 'PR01335', NULL, NULL, 'Chlamydia cysteine-rich outer membrane protein 3 signature', NULL, 'CHLAMIDIAOM3', NULL, NULL, 6338, 13),
(279668, NULL, 'PR00251', NULL, NULL, 'Bacterial opsin signature', NULL, 'BACTRLOPSIN', NULL, NULL, 6977, 13),
(279669, NULL, 'PR00860', NULL, NULL, 'Vertebrate metallothionein signature', NULL, 'MTVERTEBRATE', NULL, NULL, 2164, 13),
(279670, NULL, 'PR01207', NULL, NULL, 'Na-K-Cl co-transporter family signature', NULL, 'NAKCLTRNSPRT', NULL, NULL, 6688, 13);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(279671, NULL, 'PR00934', NULL, NULL, 'X-His dipeptidase (M25) signature', NULL, 'XHISDIPTASE', NULL, NULL, 1462, 13),
(279672, NULL, 'PR00346', NULL, NULL, 'Tissue factor signature', NULL, 'TISSUEFACTOR', NULL, NULL, 1452, 13),
(279673, NULL, 'PR00524', NULL, NULL, 'Cholecystokinin type A receptor signature', NULL, 'CCYSTOKNINAR', NULL, NULL, 4265, 13),
(279674, NULL, 'PR01681', NULL, NULL, 'Fas antigen ligand signature', NULL, 'FASLIGAND', NULL, NULL, 25745, 13),
(279675, NULL, 'PR01473', NULL, NULL, 'Intercellular adhesion molecule (ICAM) family signature', NULL, 'ICAM', NULL, NULL, 7028, 13),
(279676, NULL, 'PR00041', NULL, NULL, 'cAMP response element binding (CREB) protein signature', NULL, 'LEUZIPPRCREB', NULL, NULL, NULL, 13),
(279677, NULL, 'PR02050', NULL, NULL, 'Beta-1,4-galactosyltransferase family signature', NULL, 'B14GALTRFASE', NULL, NULL, 3033, 13),
(279678, NULL, 'PR00150', NULL, NULL, 'Phosphoenolpyruvate carboxylase signature', NULL, 'PEPCARBXLASE', NULL, NULL, 15264, 13),
(279679, NULL, 'PR02070', NULL, NULL, 'N-glycosylation protein EOS1 signature', NULL, 'NGLYCOSEOS1', NULL, NULL, 15057, 13),
(279680, NULL, 'PR01791', NULL, NULL, 'Regucalcin signature', NULL, 'REGUCALCIN', NULL, NULL, 7812, 13),
(279681, NULL, 'PR01472', NULL, NULL, 'Intercellular adhesion molecule/vascular cell adhesion molecule-1 signature', NULL, 'ICAMVCAM1', NULL, NULL, 7104, 13),
(279682, NULL, 'PR00889', NULL, NULL, 'Calponin signature', NULL, 'CALPONIN', NULL, NULL, 2277, 13),
(279683, NULL, 'PR01876', NULL, NULL, 'Myeloid transforming gene on chromosome 8 (MTG8) protein signature', NULL, 'MTG8PROTEIN', NULL, NULL, 8635, 13),
(279684, NULL, 'PR01752', NULL, NULL, 'Urea amidohydrolase (urease) protein signature', NULL, 'UREASE', NULL, NULL, 5851, 13),
(279685, NULL, 'PR00664', NULL, NULL, 'Octopamine receptor signature', NULL, 'OCTOPAMINER', NULL, NULL, 2483, 13),
(279686, NULL, 'PR00597', NULL, NULL, 'Gelsolin family signature', NULL, 'GELSOLIN', NULL, NULL, 315, 13),
(279687, NULL, 'PR01501', NULL, NULL, 'Staphylococcal toxic shock syndrome toxin signature', NULL, 'TOXICSSTOXIN', NULL, NULL, 8967, 13),
(279688, NULL, 'PR00147', NULL, NULL, 'DNA photolyase signature', NULL, 'DNAPHOTLYASE', NULL, NULL, 1245, 13),
(279689, NULL, 'PR01492', NULL, NULL, 'Kv6 potassium channel alpha subunit signature', NULL, 'KV6CHANNEL', NULL, NULL, 7385, 13),
(279690, NULL, 'PR00563', NULL, NULL, 'Beta-3 adrenergic receptor signature', NULL, 'ADRENRGCB3AR', NULL, NULL, 6801, 13),
(279691, NULL, 'PR02091', NULL, NULL, 'HAUS augmin-like complex subunit 5 signature', NULL, 'HAUSAUGMINL5', NULL, NULL, 26267, 13),
(279692, NULL, 'PR00339', NULL, NULL, 'Proliferating cell nuclear antigen (cyclin) signature', NULL, 'PCNACYCLIN', NULL, NULL, 6819, 13),
(279693, NULL, 'PR00267', NULL, NULL, 'Interferon regulatory factor signature', NULL, 'INTFRNREGFCT', NULL, NULL, 2349, 13),
(279694, NULL, 'PR01586', NULL, NULL, 'TWIK-1/TWIK-2 K+ channel family signature', NULL, 'TWIKCHANNEL', NULL, NULL, 7493, 13),
(279695, NULL, 'PR00560', NULL, NULL, 'Alpha-2C adrenergic receptor signature', NULL, 'ADRENRGCA2CR', NULL, NULL, 4398, 13),
(279696, NULL, 'PR00145', NULL, NULL, 'Argininosuccinate lyase family signature', NULL, 'ARGSUCLYASE', NULL, NULL, NULL, 13),
(279697, NULL, 'PR00125', NULL, NULL, 'ATP synthase delta subunit signature', NULL, 'ATPASEDELTA', NULL, NULL, 3968, 13),
(279698, NULL, 'PR00106', NULL, NULL, 'DNA-directed DNA-polymerase family B signature', NULL, 'DNAPOLB', NULL, NULL, 11262, 13),
(279699, NULL, 'PR00874', NULL, NULL, 'Fungi-IV metallothionein signature', NULL, 'MTFUNGIIV', NULL, NULL, 4611, 13),
(279700, NULL, 'PR00511', NULL, NULL, 'Tektin signature', NULL, 'TEKTIN', NULL, NULL, 6657, 13),
(279701, NULL, 'PR01084', NULL, NULL, 'Na+/H+ exchanger signature', NULL, 'NAHEXCHNGR', NULL, NULL, 3293, 13),
(279702, NULL, 'PR01234', NULL, NULL, 'Tumour necrosis factor family signature', NULL, 'TNECROSISFCT', NULL, NULL, 2852, 13),
(279703, NULL, 'PR01237', NULL, NULL, 'Tumour necrosis factor c (lymphotoxin-beta) signature', NULL, 'TNFC', NULL, NULL, 632, 13);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(279704, NULL, 'PR00432', NULL, NULL, 'Interleukin-5 signature', NULL, 'INTERLEUKIN5', NULL, NULL, 1866, 13),
(279705, NULL, 'PR00193', NULL, NULL, 'Myosin heavy chain signature', NULL, 'MYOSINHEAVY', NULL, NULL, 3265, 13),
(279706, NULL, 'PR01061', NULL, NULL, 'Melanocortin 3 receptor signature', NULL, 'MELNOCORTN3R', NULL, NULL, 1408, 13),
(279707, NULL, 'PR01044', NULL, NULL, 'Glycyl-tRNA synthetase alpha subunit signature', NULL, 'TRNASYNTHGA', NULL, NULL, 6021, 13),
(279708, NULL, 'PR00218', NULL, NULL, 'Peripherin (RDS)/ROM-1 family signature', NULL, 'PERIPHERNRDS', NULL, NULL, 414, 13),
(279709, NULL, 'PR01577', NULL, NULL, 'KCNAB voltage-gated K+ channel beta subunit family signature', NULL, 'KCNABCHANNEL', NULL, NULL, 7198, 13),
(279710, NULL, 'PR00302', NULL, NULL, 'Lupus La protein signature', NULL, 'LUPUSLA', NULL, NULL, 6270, 13),
(279711, NULL, 'PR00572', NULL, NULL, 'Interleukin 8A receptor signature', NULL, 'INTRLEUKN8AR', NULL, NULL, 7022, 13),
(279712, NULL, 'PR00502', NULL, NULL, 'NUDIX hydrolase family signature', NULL, 'NUDIXFAMILY', NULL, NULL, 19270, 13),
(279713, NULL, 'PR00162', NULL, NULL, 'Rieske 2Fe-2S subunit signature', NULL, 'RIESKE', NULL, NULL, 5733, 13),
(279714, NULL, 'PR01610', NULL, NULL, 'Adhesion molecule CD36 signature', NULL, 'CD36ANTIGEN', NULL, NULL, 102, 13),
(279715, NULL, 'PR01405', NULL, NULL, 'Bis(5''-nucleosyl)-tetraphosphatase signature', NULL, 'TETRPHPHTASE', NULL, NULL, 6038, 13),
(279716, NULL, 'PR00803', NULL, NULL, 'Alpha-fetoprotein signature', NULL, 'AFETOPROTEIN', NULL, NULL, 19335, 13),
(279717, NULL, 'PR00906', NULL, NULL, 'SecA protein signature', NULL, 'SECA', NULL, NULL, 1607, 13),
(279718, NULL, 'PR01835', NULL, NULL, 'Vascular endothelial growth factor receptor type 3 signature', NULL, 'VEGFRECEPTR3', NULL, NULL, NULL, 13),
(279719, NULL, 'PR00582', NULL, NULL, 'Prostanoid EP3 receptor signature', NULL, 'PRSTNOIDEP3R', NULL, NULL, 4309, 13),
(279720, NULL, 'PR00709', NULL, NULL, 'Avidin signature', NULL, 'AVIDIN', NULL, NULL, 711, 13),
(279721, NULL, 'PR00471', NULL, NULL, 'Acetate kinase family signature', NULL, 'ACETATEKNASE', NULL, NULL, 5, 13),
(279722, NULL, 'PR01198', NULL, NULL, 'Betaine transporter signature', NULL, 'BETTRANSPORT', NULL, NULL, 7283, 13),
(279723, NULL, 'PR02058', NULL, NULL, 'Vertebrate apolipoprotein D signature', NULL, 'APODVERTBRTE', NULL, NULL, 25765, 13),
(279724, NULL, 'PR00163', NULL, NULL, 'Rubredoxin signature', NULL, 'RUBREDOXIN', NULL, NULL, 15274, 13),
(279725, NULL, 'PR00446', NULL, NULL, 'Hydrogen uptake protein signature', NULL, 'HYDRGNUPTAKE', NULL, NULL, 3724, 13),
(279726, NULL, 'PR01983', NULL, NULL, 'Neurogenic locus Notch protein signature', NULL, 'NOTCH', NULL, NULL, NULL, 13),
(279727, NULL, 'PR01275', NULL, NULL, 'Neutrophil gelatinase lipocalin signature', NULL, 'NGELATINASE', NULL, NULL, 752, 13),
(279728, NULL, 'PR01292', NULL, NULL, 'Retinoic acid receptor (1B nuclear receptor) signature', NULL, 'RETNOICACIDR', NULL, NULL, 809, 13),
(279729, NULL, 'PR00314', NULL, NULL, 'Clathrin coat assembly protein signature', NULL, 'CLATHRINADPT', NULL, NULL, 2225, 13),
(279730, NULL, 'PR01478', NULL, NULL, 'Leukotriene B4 type 2 receptor signature', NULL, 'LTB2RECEPTOR', NULL, NULL, 7227, 13),
(279731, NULL, 'PR00155', NULL, NULL, 'Amicyanin family signature', NULL, 'AMICYANIN', NULL, NULL, 6214, 13),
(279732, NULL, 'PR01149', NULL, NULL, 'Melatonin 1A receptor signature', NULL, 'MELATONIN1AR', NULL, NULL, 5768, 13),
(279733, NULL, 'PR00627', NULL, NULL, 'GTP-binding nuclear protein Ran/Tc4 family signature', NULL, 'GTPRANTC4', NULL, NULL, 1350, 13),
(279734, NULL, 'PR00858', NULL, NULL, 'Crustacean metallothionein signature', NULL, 'MTCRUSTACEAN', NULL, NULL, 5418, 13),
(279735, NULL, 'PR01512', NULL, NULL, 'Kv1.5 voltage-gated K+ channel signature', NULL, 'KV15CHANNEL', NULL, NULL, 850, 13),
(279736, NULL, 'PR01543', NULL, NULL, 'Arylamine N-acetyltransferase signature', NULL, 'ANATRNSFRASE', NULL, NULL, 3105, 13),
(279737, NULL, 'PR01561', NULL, NULL, 'EDG-8 sphingosine 1-phosphate receptor signature', NULL, 'EDG8RECEPTOR', NULL, NULL, 6685, 13);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(279738, NULL, 'PR01127', NULL, NULL, 'Diuretic hormone receptor signature', NULL, 'DIUHORMONER', NULL, NULL, 2196, 13),
(279739, NULL, 'PR00231', NULL, NULL, 'Geminivirus AL3 coat protein signature', NULL, 'GEMCOATAL3', NULL, NULL, 4871, 13),
(279740, NULL, 'PR01690', NULL, NULL, 'TASK-5 K+ channel signature', NULL, 'TASK5CHANNEL', NULL, NULL, 6137, 13),
(279741, NULL, 'PR01949', NULL, NULL, 'Fish interleukin-15 signature', NULL, 'INTLKN15FISH', NULL, NULL, 20330, 13),
(279742, NULL, 'PR01801', NULL, NULL, 'Protozoan surface antigen signature', NULL, 'SURFCEANTIGN', NULL, NULL, 25958, 13),
(279743, NULL, 'PR01269', NULL, NULL, 'S-crystallin signature', NULL, 'SCRYSTALLIN', NULL, NULL, 928, 13),
(279744, NULL, 'PR00112', NULL, NULL, 'Acylphosphatase signature', NULL, 'ACYLPHPHTASE', NULL, NULL, 20982, 13),
(279745, NULL, 'PR00437', NULL, NULL, 'Small CXC cytokine family signature', NULL, 'SMALLCYTKCXC', NULL, NULL, 2287, 13),
(279746, NULL, 'PR01036', NULL, NULL, 'Tetracycline resistance protein TetB signature', NULL, 'TCRTETB', NULL, NULL, NULL, 13),
(279747, NULL, 'PR00332', NULL, NULL, 'Histidine triad family signature', NULL, 'HISTRIAD', NULL, NULL, 2385, 13),
(279748, NULL, 'PR00762', NULL, NULL, 'Chloride channel signature', NULL, 'CLCHANNEL', NULL, NULL, 4090, 13),
(279749, NULL, 'PR00378', NULL, NULL, 'Lithium-sensitive myo-inositol monophosphatase family signature', NULL, 'LIIMPHPHTASE', NULL, NULL, 21108, 13),
(279750, NULL, 'PR01658', NULL, NULL, 'Mini-chromosome maintenance (MCM) protein 2 signature', NULL, 'MCMPROTEIN2', NULL, NULL, 5456, 13),
(279751, NULL, 'PR02099', NULL, NULL, 'Protein IBD2 signature', NULL, 'PROTEINIBD2', NULL, NULL, 26361, 13),
(279752, NULL, 'PR00032', NULL, NULL, 'AraC bacterial regulatory protein HTH signature', NULL, 'HTHARAC', NULL, NULL, 20724, 13),
(279753, NULL, 'PR01548', NULL, NULL, 'Meiotic recombination protein rec114 signature', NULL, 'MEIOTICR114', NULL, NULL, 5483, 13),
(279754, NULL, 'PR00968', NULL, NULL, 'Outer surface protein signature', NULL, 'OUTRSURFACE', NULL, NULL, 4330, 13),
(279755, NULL, 'PR00304', NULL, NULL, 'Tailless complex polypeptide 1 (chaperone) signature', NULL, 'TCOMPLEXTCP1', NULL, NULL, 19266, 13),
(279756, NULL, 'PR00049', NULL, NULL, 'Wilm''s tumour protein signature', NULL, 'WILMSTUMOUR', NULL, NULL, NULL, 13),
(279757, NULL, 'PR00667', NULL, NULL, 'Retinal pigment epithelium-retinal GPCR signature', NULL, 'RPERETINALR', NULL, NULL, 5219, 13),
(279758, NULL, 'PR01585', NULL, NULL, 'TASK-3 K+ channel signature', NULL, 'TASK3CHANNEL', NULL, NULL, 721, 13),
(279759, NULL, 'PR01299', NULL, NULL, 'Colicin E2 (pyocin) immunity protein signature', NULL, 'PYOCIN', NULL, NULL, 4245, 13),
(279760, NULL, 'PR00264', NULL, NULL, 'Interleukin-1 precursor family signature', NULL, 'INTERLEUKIN1', NULL, NULL, 3267, 13),
(279761, NULL, 'PR01014', NULL, NULL, 'Neuropeptide Y2 receptor signature', NULL, 'NRPEPTIDEY2R', NULL, NULL, 2144, 13),
(279762, NULL, 'PR01185', NULL, NULL, 'Integrin alpha subunit signature', NULL, 'INTEGRINA', NULL, NULL, 4259, 13),
(279763, NULL, 'PR01614', NULL, NULL, 'Gamma-aminobutyric-acid A receptor alpha 1 subunit signature', NULL, 'GABAARALPHA1', NULL, NULL, 14, 13),
(279764, NULL, 'PR01030', NULL, NULL, 'Proenkephalin B precursor signature', NULL, 'PENKBPRCRSR', NULL, NULL, 4846, 13),
(279765, NULL, 'PR01560', NULL, NULL, 'EDG-7 lysophosphatidic acid receptor signature', NULL, 'EDG7RECEPTOR', NULL, NULL, 6973, 13),
(279766, NULL, 'PR01991', NULL, NULL, 'GP153/GP162 7TM protein family signature', NULL, 'GPR153GPR162', NULL, NULL, 15157, 13),
(279767, NULL, 'PR02029', NULL, NULL, 'Active regulator of SIRT1 signature', NULL, 'ACTREGSIRT1', NULL, NULL, 19697, 13),
(279768, NULL, 'PR00598', NULL, NULL, 'Bacterial regulatory protein MarR family signature', NULL, 'HTHMARR', NULL, NULL, 4925, 13),
(279769, NULL, 'PR00341', NULL, NULL, 'Prion protein signature', NULL, 'PRION', NULL, NULL, 4614, 13),
(279770, NULL, 'PR00944', NULL, NULL, 'Copper ion binding protein signature', NULL, 'CUEXPORT', NULL, NULL, 6963, 13); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(279771, NULL, 'PR01825', NULL, NULL, 'Janus kinase 2 (JAK2) signature', NULL, 'JANUSKINASE2', NULL, NULL, 21407, 13),
(279772, NULL, 'PR01686', NULL, NULL, 'CYP2D P450 family signature', NULL, 'EP450ICYP2D', NULL, NULL, 5350, 13),
(279773, NULL, 'PR00064', NULL, NULL, 'Ribosomal protein L35 signature', NULL, 'RIBOSOMALL35', NULL, NULL, 3300, 13),
(279774, NULL, 'PR01315', NULL, NULL, 'CLN3 Batten''s disease protein (battenin) signature', NULL, 'BATTENIN', NULL, NULL, 6043, 13),
(279775, NULL, 'PR00852', NULL, NULL, 'Xeroderma pigmentosum group D protein signature', NULL, 'XRODRMPGMNTD', NULL, NULL, 2500, 13),
(279776, NULL, 'PR01118', NULL, NULL, 'CLC-7 chloride channel signature', NULL, 'CLCHANNEL7', NULL, NULL, 399, 13),
(279777, NULL, 'PR00829', NULL, NULL, 'Major pollen allergen Lol pI signature', NULL, 'LOLP1ALLERGN', NULL, NULL, 5809, 13),
(279778, NULL, 'PR00970', NULL, NULL, 'Arginine ADP-ribosyltransferase signature', NULL, 'RIBTRNSFRASE', NULL, NULL, 6541, 13),
(279779, NULL, 'PR00160', NULL, NULL, 'Glutaredoxin signature', NULL, 'GLUTAREDOXIN', NULL, NULL, 13343, 13),
(279780, NULL, 'PR00871', NULL, NULL, 'DNA nucleotidylexotransferase (TDT) signature', NULL, 'DNAPOLXTDT', NULL, NULL, 3347, 13),
(279781, NULL, 'PR01379', NULL, NULL, 'Claudin-4 signature', NULL, 'CLAUDIN4', NULL, NULL, 6033, 13),
(279782, NULL, 'PR00661', NULL, NULL, 'ERM family signature', NULL, 'ERMFAMILY', NULL, NULL, 4643, 13),
(279783, NULL, 'PR00745', NULL, NULL, 'Glycosyl hydrolase family 39 signature', NULL, 'GLHYDRLASE39', NULL, NULL, 6735, 13),
(279784, NULL, 'PR00599', NULL, NULL, 'Methionine aminopeptidase-1 signature', NULL, 'MAPEPTIDASE', NULL, NULL, 3463, 13),
(279785, NULL, 'PR01565', NULL, NULL, 'Neuromedin U receptor family signature', NULL, 'NEUROMEDINUR', NULL, NULL, 7039, 13),
(279786, NULL, 'PR01696', NULL, NULL, 'L-type calcium channel beta-3 subunit signature', NULL, 'LCACHANNELB3', NULL, NULL, 6139, 13),
(279787, NULL, 'PR00344', NULL, NULL, 'Bacterial sensor protein C-terminal signature', NULL, 'BCTRLSENSOR', NULL, NULL, 5103, 13),
(279788, NULL, 'PR01409', NULL, NULL, 'T-cell surface glycoprotein CD5 signature', NULL, 'TCELLCD5', NULL, NULL, 435, 13),
(279789, NULL, 'PR01056', NULL, NULL, 'Metabotropic glutamate receptor 6 signature', NULL, 'MTABOTROPC6R', NULL, NULL, 3792, 13),
(279790, NULL, 'PR00544', NULL, NULL, 'Progesterone receptor (3C nuclear receptor) signature', NULL, 'PROGESTRONER', NULL, NULL, 3560, 13),
(279791, NULL, 'PR00737', NULL, NULL, 'Glycosyl hydrolase family 16 signature', NULL, 'GLHYDRLASE16', NULL, NULL, 8730, 13),
(279792, NULL, 'PR00400', NULL, NULL, 'Tetracycline repressor protein signature', NULL, 'TETREPRESSOR', NULL, NULL, 479, 13),
(279793, NULL, 'PR01374', NULL, NULL, 'Gram-negative bacterial tonB protein signature', NULL, 'TONBPROTEIN', NULL, NULL, 7482, 13),
(279794, NULL, 'PR01843', NULL, NULL, 'Wnt-3 protein signature', NULL, 'WNT3PROTEIN', NULL, NULL, 10108, 13),
(279795, NULL, 'PR01307', NULL, NULL, 'P2X purinoceptor family signature', NULL, 'P2XRECEPTOR', NULL, NULL, 6799, 13),
(279796, NULL, 'PR01201', NULL, NULL, 'Noradrenaline neurotransmitter transporter signature', NULL, 'NORTRANSPORT', NULL, NULL, 6570, 13),
(279797, NULL, 'PR01309', NULL, NULL, 'P2X2 purinoceptor signature', NULL, 'P2X2RECEPTOR', NULL, NULL, 638, 13),
(279798, NULL, 'PR01587', NULL, NULL, 'TWIK-2 K+ channel signature', NULL, 'TWIK2CHANNEL', NULL, NULL, 7386, 13),
(279799, NULL, 'PR01040', NULL, NULL, 'Tyrosyl-tRNA synthetase signature', NULL, 'TRNASYNTHTYR', NULL, NULL, 6265, 13),
(279800, NULL, 'PR00752', NULL, NULL, 'Vasopressin V1A receptor signature', NULL, 'VASOPRSNV1AR', NULL, NULL, 2028, 13),
(279801, NULL, 'PR01525', NULL, NULL, 'EDG-5 sphingosine 1-phosphate receptor signature', NULL, 'EDG5RECEPTOR', NULL, NULL, 743, 13),
(279802, NULL, 'PR01718', NULL, NULL, 'Claudin-15 signature', NULL, 'CLAUDIN15', NULL, NULL, 6062, 13),
(279803, NULL, 'PR00951', NULL, NULL, 'Flagellar biosynthetic protein FliP signature', NULL, 'FLGBIOSNFLIP', NULL, NULL, 5717, 13),
(279804, NULL, 'PR00084', NULL, NULL, 'Mannitol dehydrogenase signature', NULL, 'MTLDHDRGNASE', NULL, NULL, 6885, 13);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(279805, NULL, 'PR00455', NULL, NULL, 'TetR bacterial regulatory protein HTH signature', NULL, 'HTHTETR', NULL, NULL, 3476, 13),
(279806, NULL, 'PR00212', NULL, NULL, 'Myelin basic protein signature', NULL, 'MYELINMBP', NULL, NULL, 5901, 13),
(279807, NULL, 'PR01707', NULL, NULL, 'Rickettsia 56kDa type-specific antigen protein signature', NULL, '56KDTSANTIGN', NULL, NULL, 1742, 13),
(279808, NULL, 'PR00547', NULL, NULL, 'X opioid receptor signature', NULL, 'XOPIOIDR', NULL, NULL, 6749, 13),
(279809, NULL, 'PR00637', NULL, NULL, 'Type 3 bombesin receptor signature', NULL, 'BOMBESIN3R', NULL, NULL, 5333, 13),
(279810, NULL, 'PR01939', NULL, NULL, 'Neurotrophic tyrosine kinase receptor family signature', NULL, 'NTKRECEPTOR', NULL, NULL, 20603, 13),
(279811, NULL, 'PR00185', NULL, NULL, 'Eukaryotic porin signature', NULL, 'EUKARYTPORIN', NULL, NULL, 4260, 13),
(279812, NULL, 'PR01792', NULL, NULL, 'Voltage-dependent calcium channel gamma subunit signature', NULL, 'VDCCGAMMA', NULL, NULL, 7930, 13),
(279813, NULL, 'PR00239', NULL, NULL, 'Molluscan rhodopsin C-terminal tail signature', NULL, 'RHODOPSNTAIL', NULL, NULL, NULL, 13),
(279814, NULL, 'PR00116', NULL, NULL, 'Arginase signature', NULL, 'ARGINASE', NULL, NULL, 2546, 13),
(279815, NULL, 'PR00412', NULL, NULL, 'Epoxide hydrolase signature', NULL, 'EPOXHYDRLASE', NULL, NULL, 3862, 13),
(279816, NULL, 'PR00481', NULL, NULL, 'Cytosol aminopeptidase signature', NULL, 'LAMNOPPTDASE', NULL, NULL, 14647, 13),
(279817, NULL, 'PR01260', NULL, NULL, 'Na+/Ca2+ exchanger isoform 1 signature', NULL, 'NACAEXCHNGR1', NULL, NULL, 7308, 13),
(279818, NULL, 'PR01698', NULL, NULL, 'Cytoplasmic fragile X mental retardation protein interacting protein signature', NULL, 'CYTOFMRPINTP', NULL, NULL, 6304, 13),
(279819, NULL, 'PR00716', NULL, NULL, 'M-phase inducer phosphatase signature', NULL, 'MPIPHPHTASE', NULL, NULL, 4040, 13),
(279820, NULL, 'PR01846', NULL, NULL, 'Thyrotropin-releasing hormone receptor family signature', NULL, 'TRHRFAMILY', NULL, NULL, 1406, 13),
(279821, NULL, 'PR02074', NULL, NULL, 'Protein FRG2 signature', NULL, 'PROTEINFRG2', NULL, NULL, 21449, 13),
(279822, NULL, 'PR01320', NULL, NULL, 'Inward rectifier K+ channel superfamily signature', NULL, 'KIRCHANNEL', NULL, NULL, 15421, 13),
(279823, NULL, 'PR00088', NULL, NULL, 'Haem oxygenase signature', NULL, 'HAEMOXYGNASE', NULL, NULL, 1294, 13),
(279824, NULL, 'PR00107', NULL, NULL, 'Phosphocarrier protein signature', NULL, 'PHOSPHOCPHPR', NULL, NULL, 3439, 13),
(279825, NULL, 'PR01148', NULL, NULL, 'EDG-2 lysophosphatidic acid receptor signature', NULL, 'EDG2RECEPTOR', NULL, NULL, 191, 13),
(279826, NULL, 'PR01570', NULL, NULL, 'Neuropeptide FF receptor family signature', NULL, 'NPFFRECEPTOR', NULL, NULL, 7436, 13),
(279827, NULL, 'PR00368', NULL, NULL, 'FAD-dependent pyridine nucleotide reductase signature', NULL, 'FADPNR', NULL, NULL, NULL, 13),
(279828, NULL, 'PR00740', NULL, NULL, 'Glycosyl hydrolase family 27 signature', NULL, 'GLHYDRLASE27', NULL, NULL, 5507, 13),
(279829, NULL, 'PR00388', NULL, NULL, '3''5''-cyclic nucleotide class II phosphodiesterase signature', NULL, 'PDIESTERASE2', NULL, NULL, 6535, 13),
(279830, NULL, 'PR00587', NULL, NULL, 'Somatostatin receptor type 1 signature', NULL, 'SOMATOSTTN1R', NULL, NULL, 2107, 13),
(279831, NULL, 'PR01836', NULL, NULL, 'Magnesium-transporting ATPase signature', NULL, 'MGATPASE', NULL, NULL, 6676, 13),
(279832, NULL, 'PR02103', NULL, NULL, 'Inheritance of peroxisomes protein 1 signature', NULL, 'INPROXISOME1', NULL, NULL, 19454, 13),
(279833, NULL, 'PR00543', NULL, NULL, 'Oestrogen receptor signature', NULL, 'OESTROGENR', NULL, NULL, 149, 13),
(279834, NULL, 'PR01289', NULL, NULL, 'Peroxisome proliferator-activated receptor alpha signature', NULL, 'PROXISOMPAAR', NULL, NULL, 895, 13),
(279835, NULL, 'PR00419', NULL, NULL, 'Adrenodoxin reductase family signature', NULL, 'ADXRDTASE', NULL, NULL, NULL, 13),
(279836, NULL, 'PR01054', NULL, NULL, 'Metabotropic glutamate receptor 4 signature', NULL, 'MTABOTROPC4R', NULL, NULL, 4410, 13);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(279837, NULL, 'PR00918', NULL, NULL, 'Calicivirus non-structural polyprotein family signature', NULL, 'CALICVIRUSNS', NULL, NULL, 926, 13),
(279838, NULL, 'PR00173', NULL, NULL, 'Glutamate-aspartate symporter signature', NULL, 'EDTRNSPORT', NULL, NULL, NULL, 13),
(279839, NULL, 'PR00201', NULL, NULL, 'Annexin type V signature', NULL, 'ANNEXINV', NULL, NULL, 6493, 13),
(279840, NULL, 'PR00640', NULL, NULL, 'Gastrin-releasing peptide receptor signature', NULL, 'GASTRINRELPR', NULL, NULL, 4406, 13),
(279841, NULL, 'PR00073', NULL, NULL, 'Coprogen oxidase signature', NULL, 'COPRGNOXDASE', NULL, NULL, 2460, 13),
(279842, NULL, 'PR01699', NULL, NULL, 'Organomercurial lyase signature', NULL, 'ORGNOHGLYASE', NULL, NULL, 1675, 13),
(279843, NULL, 'PR01744', NULL, NULL, 'MIC1 microneme protein signature', NULL, 'MIC1MICRNEME', NULL, NULL, 6110, 13),
(279844, NULL, 'PR00895', NULL, NULL, 'Pentaxin signature', NULL, 'PENTAXIN', NULL, NULL, 3338, 13),
(279845, NULL, 'PR01602', NULL, NULL, 'Voltage-dependent calcium channel gamma-2 subunit signature', NULL, 'VDCCGAMMA2', NULL, NULL, 36, 13),
(279846, NULL, 'PR01391', NULL, NULL, 'Binary toxin B family signature', NULL, 'BINARYTOXINB', NULL, NULL, 4007, 13),
(279847, NULL, 'PR01213', NULL, NULL, 'Beta-synuclein signature', NULL, 'BSYNUCLEIN', NULL, NULL, 6907, 13),
(279848, NULL, 'PR01322', NULL, NULL, 'Kir1.2 inward rectifier K+ channel signature', NULL, 'KIR12CHANNEL', NULL, NULL, 3420, 13),
(279849, NULL, 'PR00244', NULL, NULL, 'Neurokinin receptor signature', NULL, 'NEUROKININR', NULL, NULL, 3149, 13),
(279850, NULL, 'PR01578', NULL, NULL, 'KCNAB voltage-gated K+ channel beta-1 subunit signature', NULL, 'KCNAB1CHANEL', NULL, NULL, 7153, 13),
(279851, NULL, 'PR01551', NULL, NULL, 'SPO11 homologue signature', NULL, 'SPO11HOMOLOG', NULL, NULL, 8445, 13),
(279852, NULL, 'PR00978', NULL, NULL, 'Steroidogenic acute regulatory protein signature', NULL, 'STARPROTEIN', NULL, NULL, 4712, 13),
(279853, NULL, 'PR00299', NULL, NULL, 'Alpha crystallin signature', NULL, 'ACRYSTALLIN', NULL, NULL, 5462, 13),
(279854, NULL, 'PR01333', NULL, NULL, 'Two pore domain K+ channel signature', NULL, '2POREKCHANEL', NULL, NULL, 3359, 13),
(279855, NULL, 'PR00254', NULL, NULL, 'Nicotinic acetylcholine receptor signature', NULL, 'NICOTINICR', NULL, NULL, 6255, 13),
(279856, NULL, 'PR00352', NULL, NULL, '3Fe-4S ferredoxin signature', NULL, '3FE4SFRDOXIN', NULL, NULL, 2255, 13),
(279857, NULL, 'PR01421', NULL, NULL, 'GPR37 orphan receptor signature', NULL, 'GPR37ORPHANR', NULL, NULL, 6301, 13),
(279858, NULL, 'PR00028', NULL, NULL, 'POU domain signature', NULL, 'POUDOMAIN', NULL, NULL, 8427, 13),
(279859, NULL, 'PR01432', NULL, NULL, 'Rabaptin signature', NULL, 'RABAPTIN', NULL, NULL, 6098, 13),
(279860, NULL, 'PR01919', NULL, NULL, 'Tumour necrosis factor receptor 1B signature', NULL, 'TNFACTORR1B', NULL, NULL, 18608, 13),
(279861, NULL, 'PR00568', NULL, NULL, 'Dopamine D3 receptor signature', NULL, 'DOPAMINED3R', NULL, NULL, 3004, 13),
(279862, NULL, 'PR00392', NULL, NULL, 'Profilin signature', NULL, 'PROFILIN', NULL, NULL, 952, 13),
(279863, NULL, 'PR01573', NULL, NULL, 'Tubby superfamily signature', NULL, 'SUPERTUBBY', NULL, NULL, 2061, 13),
(279864, NULL, 'PR01914', NULL, NULL, 'Neurotrophin-3 signature', NULL, 'NEUROTROPHN3', NULL, NULL, 9736, 13),
(279865, NULL, 'PR01709', NULL, NULL, '5-hydroxytryptamine 3 receptor A subunit signature', NULL, '5HT3ARECEPTR', NULL, NULL, 6250, 13),
(279866, NULL, 'PR01904', NULL, NULL, 'GPR40-related receptor family signature', NULL, 'GPR40FAMILY', NULL, NULL, 8685, 13),
(279867, NULL, 'PR01419', NULL, NULL, 'Galanin 2 receptor signature', NULL, 'GALANIN2R', NULL, NULL, 6202, 13),
(279868, NULL, 'PR01720', NULL, NULL, 'Cytotoxic T-lymphocyte antigen 4 signature', NULL, 'CTLANTIGEN4', NULL, NULL, 6194, 13),
(279869, NULL, 'PR00635', NULL, NULL, 'AT1 angiotensin II receptor signature', NULL, 'ANGIOTENSN1R', NULL, NULL, 1935, 13),
(279870, NULL, 'PR01514', NULL, NULL, 'Kv2.1 voltage-gated K+ channel signature', NULL, 'KV21CHANNEL', NULL, NULL, 5399, 13);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(279871, NULL, 'PR01462', NULL, NULL, 'KCNQ3 voltage-gated potassium channel signature', NULL, 'KCNQ3CHANNEL', NULL, NULL, 7477, 13),
(279872, NULL, 'PR02004', NULL, NULL, 'Relaxin signature', NULL, 'RELAXIN', NULL, NULL, 15671, 13),
(279873, NULL, 'PR00467', NULL, NULL, 'Mammalian lipoxygenase signature', NULL, 'MAMLPOXGNASE', NULL, NULL, 4069, 13),
(279874, NULL, 'PR00949', NULL, NULL, 'Type III secretion system inner membrane A protein family signature', NULL, 'TYPE3IMAPROT', NULL, NULL, 3422, 13),
(279875, NULL, 'PR00401', NULL, NULL, 'SH2 domain signature', NULL, 'SH2DOMAIN', NULL, NULL, 3268, 13),
(279876, NULL, 'PR01854', NULL, NULL, 'BR22 protein signature', NULL, 'BR22PROTEIN', NULL, NULL, 7675, 13),
(279877, NULL, 'PR01710', NULL, NULL, '5-hydroxytryptamine 3 receptor B subunit signature', NULL, '5HT3BRECEPTR', NULL, NULL, 6494, 13),
(279878, NULL, 'PR00561', NULL, NULL, 'Beta-1 adrenergic receptor signature', NULL, 'ADRENRGCB1AR', NULL, NULL, 6825, 13),
(279879, NULL, 'PR00844', NULL, NULL, 'Glycosyl hydrolase family 48 signature', NULL, 'GLHYDRLASE48', NULL, NULL, 5982, 13),
(279880, NULL, 'PR01124', NULL, NULL, 'Flavin-containing monooxygenase (FMO) 4 signature', NULL, 'FMOXYGENASE4', NULL, NULL, 5828, 13),
(279881, NULL, 'PR00022', NULL, NULL, 'Somatomedin B signature', NULL, 'SOMATOMEDINB', NULL, NULL, 20103, 13),
(279882, NULL, 'PR00890', NULL, NULL, 'Smooth muscle protein 22-alpha (transgelin) signature', NULL, 'TRANSGELIN', NULL, NULL, NULL, 13),
(279883, NULL, 'PR01872', NULL, NULL, 'Claudin-12 signature', NULL, 'CLAUDIN12', NULL, NULL, 8886, 13),
(279884, NULL, 'PR00426', NULL, NULL, 'C5A-anaphylatoxin receptor signature', NULL, 'C5ANPHYLTXNR', NULL, NULL, 5770, 13),
(279885, NULL, 'PR01141', NULL, NULL, 'Gap junction beta-4 protein (Cx31.1) signature', NULL, 'CONNEXINB4', NULL, NULL, 6598, 13),
(279886, NULL, 'PR01930', NULL, NULL, 'Interleukin-15 signature', NULL, 'INTRLEUKIN15', NULL, NULL, 18999, 13),
(279887, NULL, 'PR00214', NULL, NULL, 'Myelin proteolipid protein (PLP) signature', NULL, 'MYELINPLP', NULL, NULL, 5237, 13),
(279888, NULL, 'PR01403', NULL, NULL, '7,8-dihydro-8-oxoguanine triphosphatase signature', NULL, '8OXTPHPHTASE', NULL, NULL, 35, 13),
(279889, NULL, 'PR00424', NULL, NULL, 'Adenosine receptor signature', NULL, 'ADENOSINER', NULL, NULL, 5442, 13),
(279890, NULL, 'PR00775', NULL, NULL, '90kDa heat shock protein signature', NULL, 'HEATSHOCK90', NULL, NULL, 18648, 13),
(279891, NULL, 'PR01206', NULL, NULL, 'Orphan neurotransmitter transporter signature', NULL, 'ORPHTRNSPORT', NULL, NULL, 7040, 13),
(279892, NULL, 'PR01907', NULL, NULL, 'Worm globin signature', NULL, 'WORMGLOBIN', NULL, NULL, NULL, 13),
(279893, NULL, 'PR00575', NULL, NULL, 'Red/green-sensitive opsin signature', NULL, 'OPSINREDGRN', NULL, NULL, 6809, 13),
(279894, NULL, 'PR02092', NULL, NULL, 'Hepatitis B virus X-interacting protein signature', NULL, 'HEPBVIRUSXIP', NULL, NULL, 8270, 13),
(279895, NULL, 'PR00942', NULL, NULL, 'Copper-transporting ATPase 1 signature', NULL, 'CUATPASEI', NULL, NULL, NULL, 13),
(279896, NULL, 'PR01158', NULL, NULL, 'Topoisomerase II signature', NULL, 'TOPISMRASEII', NULL, NULL, 1042, 13),
(279897, NULL, 'PR00681', NULL, NULL, 'Ribosomal protein S1 signature', NULL, 'RIBOSOMALS1', NULL, NULL, 18727, 13),
(279898, NULL, 'PR01733', NULL, NULL, 'Mycoplasma P48 major surface lipoprotein signature', NULL, 'LIPPROTEIN48', NULL, NULL, 6096, 13),
(279899, NULL, 'PR01883', NULL, NULL, 'Leukaemia inhibitory factor signature', NULL, 'LEUKAEMIAIF', NULL, NULL, 523, 13),
(279900, NULL, 'PR01636', NULL, NULL, 'Voltage-dependent L-type calcium channel alpha-1D subunit signature', NULL, 'LVDCCALPHA1D', NULL, NULL, 889, 13),
(279901, NULL, 'PR01988', NULL, NULL, 'Putative bacilysin exporter bacE signature', NULL, 'EXPORTERBACE', NULL, NULL, 15706, 13),
(279902, NULL, 'PR00357', NULL, NULL, 'Type III antifreeze protein signature', NULL, 'ANTIFREEZIII', NULL, NULL, 1165, 13),
(279903, NULL, 'PR00493', NULL, NULL, 'Breast cancer type I susceptibility protein signature', NULL, 'BRSTCANCERI', NULL, NULL, 14591, 13);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(279904, NULL, 'PR00127', NULL, NULL, 'Clp protease catalytic subunit P signature', NULL, 'CLPPROTEASEP', NULL, NULL, 2293, 13),
(279905, NULL, 'PR00695', NULL, NULL, 'Copper containing nitrite reductase signature', NULL, 'CUNO2RDTASE', NULL, NULL, 244, 13),
(279906, NULL, 'PR00491', NULL, NULL, 'Vasoactive intestinal peptide receptor signature', NULL, 'VASOACTVEIPR', NULL, NULL, 3103, 13),
(279907, NULL, 'PR01547', NULL, NULL, 'Saccharomyces cerevisiae 175.8kDa hypothetical protein signature', NULL, 'YEAST176DUF', NULL, NULL, NULL, 13),
(279908, NULL, 'PR01470', NULL, NULL, 'ERG potassium channel family signature', NULL, 'ERGCHANNEL', NULL, NULL, 7161, 13),
(279909, NULL, 'PR01029', NULL, NULL, 'Proenkephalin A precursor signature', NULL, 'PENKAPRCRSR', NULL, NULL, 3731, 13),
(279910, NULL, 'PR00770', NULL, NULL, 'Eosinophil major basic protein signature', NULL, 'EMAJORBASICP', NULL, NULL, 6353, 13),
(279911, NULL, 'PR01867', NULL, NULL, 'Bcl-2-related protein A1 signature', NULL, 'BCL2RLATEDA1', NULL, NULL, 8598, 13),
(279912, NULL, 'PR01287', NULL, NULL, 'Orphan nuclear receptor NURR signature', NULL, 'NURRNUCRCPTR', NULL, NULL, 1240, 13),
(279913, NULL, 'PR02005', NULL, NULL, 'Insulin-like growth factor I signature', NULL, 'INSLNLIKEGF1', NULL, NULL, 15957, 13),
(279914, NULL, 'PR00058', NULL, NULL, 'Ribosomal protein L5 signature', NULL, 'RIBOSOMALL5', NULL, NULL, 657, 13),
(279915, NULL, 'PR00885', NULL, NULL, 'Bacterial general secretion pathway protein H signature', NULL, 'BCTERIALGSPH', NULL, NULL, 6705, 13),
(279916, NULL, 'PR01859', NULL, NULL, 'ADAM-TS2 protein signature', NULL, 'ADAMTS2', NULL, NULL, 4423, 13),
(279917, NULL, 'PR01563', NULL, NULL, 'G2A lysophosphatidylcholine receptor signature', NULL, 'G2ARECEPTOR', NULL, NULL, 6851, 13),
(279918, NULL, 'PR00445', NULL, NULL, 'HupF/HypC hydrogenase expression/synthesis family signature', NULL, 'HUPFHYPC', NULL, NULL, 1282, 13),
(279919, NULL, 'PR00182', NULL, NULL, 'E.coli/Neisseria porin superfamily signature', NULL, 'ECOLNEIPORIN', NULL, NULL, 3495, 13),
(279920, NULL, 'PR01076', NULL, NULL, 'Caldesmon signature', NULL, 'CALDESMON', NULL, NULL, 1490, 13),
(279921, NULL, 'PR01326', NULL, NULL, 'Kir2.3 inward rectifier K+ channel signature', NULL, 'KIR23CHANNEL', NULL, NULL, 3242, 13),
(279922, NULL, 'PR00194', NULL, NULL, 'Tropomyosin signature', NULL, 'TROPOMYOSIN', NULL, NULL, 5646, 13),
(279923, NULL, 'PR01823', NULL, NULL, 'Janus kinase family signature', NULL, 'JANUSKINASE', NULL, NULL, 17339, 13),
(279924, NULL, 'PR01016', NULL, NULL, 'Neuropeptide Y5 receptor signature', NULL, 'NRPEPTIDEY5R', NULL, NULL, 6722, 13),
(279925, NULL, 'PR00562', NULL, NULL, 'Beta-2 adrenergic receptor signature', NULL, 'ADRENRGCB2AR', NULL, NULL, 874, 13),
(279926, NULL, 'PR01886', NULL, NULL, 'Protein Associated with Small Stress protein 1 (PASS1) signature', NULL, 'PASS1', NULL, NULL, 8786, 13),
(279927, NULL, 'PR02033', NULL, NULL, 'Placentin signature', NULL, 'PLACENTIN', NULL, NULL, 18698, 13),
(279928, NULL, 'PR02014', NULL, NULL, 'Aquaporin-2 signature', NULL, 'AQUAPORIN2', NULL, NULL, NULL, 13),
(279929, NULL, 'PR00122', NULL, NULL, 'Vacuolar ATP synthase 16kDa subunit signature', NULL, 'VACATPASE', NULL, NULL, 4428, 13),
(279930, NULL, 'PR00628', NULL, NULL, 'Insulin receptor substrate-1 PTB domain signature', NULL, 'INSULINRSI', NULL, NULL, 6975, 13),
(279931, NULL, 'PR01851', NULL, NULL, 'Cystic fibrosis transmembrane conductance regulator signature', NULL, 'CYSFIBREGLTR', NULL, NULL, 10100, 13),
(279932, NULL, 'PR01311', NULL, NULL, 'P2X4 purinoceptor signature', NULL, 'P2X4RECEPTOR', NULL, NULL, 6969, 13),
(279933, NULL, 'PR02038', NULL, NULL, 'Aurora borealis protein signature', NULL, 'AURORABORA', NULL, NULL, 10687, 13),
(279934, NULL, 'PR00665', NULL, NULL, 'Oxytocin receptor signature', NULL, 'OXYTOCINR', NULL, NULL, 5247, 13),
(279935, NULL, 'PR01763', NULL, NULL, 'Dishevelled-3 protein signature', NULL, 'DISHEVELLED3', NULL, NULL, 7740, 13),
(279936, NULL, 'PR00946', NULL, NULL, 'Mercury scavenger protein signature', NULL, 'HGSCAVENGER', NULL, NULL, 3181, 13);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(279937, NULL, 'PR01648', NULL, NULL, 'Transient receptor potential channel 7 signature', NULL, 'TRPCHANNEL7', NULL, NULL, 646, 13),
(279938, NULL, 'PR00758', NULL, NULL, 'Arsenical pump membrane protein signature', NULL, 'ARSENICPUMP', NULL, NULL, 4458, 13),
(279939, NULL, 'PR01032', NULL, NULL, 'Gene IV protein signature', NULL, 'PHAGEIV', NULL, NULL, NULL, 13),
(279940, NULL, 'PR00839', NULL, NULL, 'V8 serine protease family signature', NULL, 'V8PROTEASE', NULL, NULL, 8904, 13),
(279941, NULL, 'PR00404', NULL, NULL, 'MADS domain signature', NULL, 'MADSDOMAIN', NULL, NULL, 1200, 13),
(279942, NULL, 'PR00428', NULL, NULL, 'Prostaglandin receptor signature', NULL, 'PROSTAGLNDNR', NULL, NULL, 2461, 13),
(279943, NULL, 'PR01069', NULL, NULL, 'Acetyl-CoA carboxylase carboxyl transferase alpha subunit signature', NULL, 'ACCCTRFRASEA', NULL, NULL, 2312, 13),
(279944, NULL, 'PR00190', NULL, NULL, 'Actin signature', NULL, 'ACTIN', NULL, NULL, 749, 13),
(279945, NULL, 'PR01276', NULL, NULL, 'Type II keratin signature', NULL, 'TYPE2KERATIN', NULL, NULL, 6724, 13),
(279946, NULL, 'PR00085', NULL, NULL, 'Tetrahydrofolate dehydrogenase/cyclohydrolase family signature', NULL, 'THFDHDRGNASE', NULL, NULL, 6568, 13),
(279947, NULL, 'PR00381', NULL, NULL, 'Kinesin light chain signature', NULL, 'KINESINLIGHT', NULL, NULL, 5141, 13),
(279948, NULL, 'PR00924', NULL, NULL, 'Alphaherpesvirus alkaline exonuclease signature', NULL, 'ALKEXNUCLASE', NULL, NULL, 5359, 13),
(279949, NULL, 'PR01112', NULL, NULL, 'CLC-1 chloride channel signature', NULL, 'CLCHANNEL1', NULL, NULL, 5693, 13),
(279950, NULL, 'PR00458', NULL, NULL, 'Haem peroxidase superfamily signature', NULL, 'PEROXIDASE', NULL, NULL, 2145, 13),
(279951, NULL, 'PR00579', NULL, NULL, 'Rhodopsin signature', NULL, 'RHODOPSIN', NULL, NULL, 3801, 13),
(279952, NULL, 'PR01627', NULL, NULL, 'L-type calcium channel beta-1 subunit signature', NULL, 'LCACHANNELB1', NULL, NULL, 166, 13),
(279953, NULL, 'PR00897', NULL, NULL, 'Vasopressin V1B receptor signature', NULL, 'VASOPRSNV1BR', NULL, NULL, 5737, 13),
(279954, NULL, 'PR01893', NULL, NULL, 'Wnt-10 protein signature', NULL, 'WNT10PROTEIN', NULL, NULL, 8852, 13),
(279955, NULL, 'PR00487', NULL, NULL, 'Filaggrin signature', NULL, 'FILAGGRIN', NULL, NULL, 3203, 13),
(279956, NULL, 'PR00766', NULL, NULL, 'Amiloride-sensitive amine oxidase signature', NULL, 'CUDAOXIDASE', NULL, NULL, 771, 13),
(279957, NULL, 'PR00850', NULL, NULL, 'Glycosyl hydrolase family 59 signature', NULL, 'GLHYDRLASE59', NULL, NULL, 2292, 13),
(279958, NULL, 'PR01523', NULL, NULL, 'Sphingosine 1-phosphate receptor family signature', NULL, 'S1PRECEPTOR', NULL, NULL, 932, 13),
(279959, NULL, 'PR00260', NULL, NULL, 'Bacterial chemotaxis sensory transducer signature', NULL, 'CHEMTRNSDUCR', NULL, NULL, 1872, 13),
(279960, NULL, 'PR00294', NULL, NULL, 'Streptomyces subtilisin inhibitor signature', NULL, 'SSBTLNINHBTR', NULL, NULL, 3559, 13),
(279961, NULL, 'PR00606', NULL, NULL, 'Class ID cytochrome C signature', NULL, 'CYTCHROMECID', NULL, NULL, 6420, 13),
(279962, NULL, 'PR01279', NULL, NULL, 'Corticotropin releasing factor receptor signature', NULL, 'CRFRECEPTOR', NULL, NULL, 6961, 13),
(279963, NULL, 'PR01593', NULL, NULL, 'Salmonella type III secretion SopE effector protein signature', NULL, 'SOPEPROTEIN', NULL, NULL, 7500, 13),
(279964, NULL, 'PR01937', NULL, NULL, 'Interleukin-24 signature', NULL, 'INTRLEUKIN24', NULL, NULL, 20920, 13),
(279965, NULL, 'PR00492', NULL, NULL, 'RHO protein GDP dissociation inhibitor signature', NULL, 'RHOGDI', NULL, NULL, 4782, 13),
(279966, NULL, 'PR00281', NULL, NULL, 'Hok/Gef cell toxic protein family signature', NULL, 'HOKGEFTOXIC', NULL, NULL, 2806, 13),
(279967, NULL, 'PR01031', NULL, NULL, 'Nociceptin precursor signature', NULL, 'ORPHNNPRCRSR', NULL, NULL, 5120, 13),
(279968, NULL, 'PR01078', NULL, NULL, 'Amiloride-sensitive sodium channel alpha-subunit signature', NULL, 'AMINACHANNEL', NULL, NULL, 4205, 13),
(279969, NULL, 'PR00489', NULL, NULL, 'Frizzled protein signature', NULL, 'FRIZZLED', NULL, NULL, 5949, 13);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(279970, NULL, 'PR01105', NULL, NULL, 'C-X-C chemokine receptor type 6 signature', NULL, 'CXCCHMKINER6', NULL, NULL, 144, 13),
(279971, NULL, 'PR01822', NULL, NULL, 'Cholecystokinin receptor family signature', NULL, 'CCYSTOKININR', NULL, NULL, 10263, 13),
(279972, NULL, 'PR00531', NULL, NULL, 'Histamine H2 receptor signature', NULL, 'HISTAMINEH2R', NULL, NULL, 6713, 13),
(279973, NULL, 'PR00615', NULL, NULL, 'CCAAT-binding transcription factor subunit A signature', NULL, 'CCAATSUBUNTA', NULL, NULL, NULL, 13),
(279974, NULL, 'PR00071', NULL, NULL, 'Hydroxymethylglutaryl-coenzyme A reductase signature', NULL, 'HMGCOARDTASE', NULL, NULL, 235, 13),
(279975, NULL, 'PR01093', NULL, NULL, 'Sulphonylurea receptor type 1 family signature', NULL, 'SULFNYLUR1', NULL, NULL, 4575, 13),
(279976, NULL, 'PR01250', NULL, NULL, 'Ribosomal protein L34 signature', NULL, 'RIBOSOMALL34', NULL, NULL, 7305, 13),
(279977, NULL, 'PR00816', NULL, NULL, 'Zeta haemoglobin signature', NULL, 'ZETAHAEM', NULL, NULL, 5217, 13),
(279978, NULL, 'PR01420', NULL, NULL, 'Galanin 3 receptor signature', NULL, 'GALANIN3R', NULL, NULL, 6347, 13),
(279979, NULL, 'PR01002', NULL, NULL, 'Flagellar protein FlgJ signature', NULL, 'FLGFLGJ', NULL, NULL, NULL, 13),
(279980, NULL, 'PR00318', NULL, NULL, 'Alpha G protein (transducin) signature', NULL, 'GPROTEINA', NULL, NULL, 5409, 13),
(279981, NULL, 'PR01743', NULL, NULL, 'Single-strand DNA-binding protein signature', NULL, 'SSDNABINDING', NULL, NULL, 6339, 13),
(279982, NULL, 'PR01863', NULL, NULL, 'Bcl-2 apoptosis regulator protein signature', NULL, 'APOPREGBCL2', NULL, NULL, 8695, 13),
(279983, NULL, 'PR00497', NULL, NULL, 'Neutrophil cytosol factor P40 signature', NULL, 'P40PHOX', NULL, NULL, 3279, 13),
(279984, NULL, 'PR00591', NULL, NULL, 'Somatostatin receptor type 5 signature', NULL, 'SOMATOSTTN5R', NULL, NULL, 1186, 13),
(279985, NULL, 'PR00033', NULL, NULL, 'AsnC bacterial regulatory protein HTH signature', NULL, 'HTHASNC', NULL, NULL, 6592, 13),
(279986, NULL, 'PR01660', NULL, NULL, 'Mini-chromosome maintenance (MCM) protein 4 signature', NULL, 'MCMPROTEIN4', NULL, NULL, 5046, 13),
(279987, NULL, 'PR00522', NULL, NULL, 'Cannabinoid receptor type 1 signature', NULL, 'CANABINOID1R', NULL, NULL, 6882, 13),
(279988, NULL, 'PR01798', NULL, NULL, 'Succinyl-CoA synthase signature', NULL, 'SCOASYNTHASE', NULL, NULL, NULL, 13),
(279989, NULL, 'PR00668', NULL, NULL, 'Glycoprotein C signature', NULL, 'GLYCPROTEINC', NULL, NULL, 1023, 13),
(279990, NULL, 'PR00577', NULL, NULL, 'Opsin RH3/RH4 signature', NULL, 'OPSINRH3RH4', NULL, NULL, 3500, 13),
(279991, NULL, 'PR00300', NULL, NULL, 'ATP-dependent Clp protease ATP-binding subunit signature', NULL, 'CLPPROTEASEA', NULL, NULL, 92, 13),
(279992, NULL, 'PR01414', NULL, NULL, 'Cytochrome c-type biogenesis protein CcmB signature', NULL, 'CCMBBIOGNSIS', NULL, NULL, NULL, 13),
(279993, NULL, 'PR01439', NULL, NULL, 'Cellulose synthase subunit A signature', NULL, 'CELLSNTHASEA', NULL, NULL, 6011, 13),
(279994, NULL, 'PR01968', NULL, NULL, 'Tumour necrosis factor receptor 18 signature', NULL, 'TNFACTORR18', NULL, NULL, 15849, 13),
(279995, NULL, 'PR00973', NULL, NULL, 'Ribosomal protein S17 family signature', NULL, 'RIBOSOMALS17', NULL, NULL, 754, 13),
(279996, NULL, 'PR00943', NULL, NULL, 'Copper-transporting ATPase signature', NULL, 'CUATPASE', NULL, NULL, NULL, 13),
(279997, NULL, 'PR00131', NULL, NULL, 'Glycosyl hydrolase family 1 signature', NULL, 'GLHYDRLASE1', NULL, NULL, 7273, 13),
(279998, NULL, 'PR01126', NULL, NULL, 'DEZ orphan receptor signature', NULL, 'DEZORPHANR', NULL, NULL, 352, 13),
(279999, NULL, 'PR00092', NULL, NULL, 'Tyrosinase copper-binding domain signature', NULL, 'TYROSINASE', NULL, NULL, 289, 13),
(280000, NULL, 'PR00877', NULL, NULL, 'Plant PEC family metallothionein signature', NULL, 'MTPLANTPEC', NULL, NULL, 4515, 13),
(280001, NULL, 'PR01087', NULL, NULL, 'Na+/H+ exchanger isoform 3 (NHE3) signature', NULL, 'NAHEXCHNGR3', NULL, NULL, 20613, 13),
(280002, NULL, 'PR01417', NULL, NULL, 'Growth hormone secretagogue receptor type 1 signature', NULL, 'GHSRECEPTOR', NULL, NULL, 6350, 13);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(280003, NULL, 'PR02060', NULL, NULL, 'Wolframin family signature', NULL, 'WOLFFAMILY', NULL, NULL, 25693, 13),
(280004, NULL, 'PR00965', NULL, NULL, 'Ocular albinism type 1 protein signature', NULL, 'OCULARALBNSM', NULL, NULL, 6144, 13),
(280005, NULL, 'PR01317', NULL, NULL, 'Glial cell line-derived neurotrophic factor receptor alpha 1 signature', NULL, 'GDNFRALPHA1', NULL, NULL, 6235, 13),
(280006, NULL, 'PR00959', NULL, NULL, 'Mevalonate kinase family signature', NULL, 'MEVGALKINASE', NULL, NULL, NULL, 13),
(280007, NULL, 'PR00138', NULL, NULL, 'Matrixin signature', NULL, 'MATRIXIN', NULL, NULL, 15163, 13),
(280008, NULL, 'PR01429', NULL, NULL, 'Protease activated receptor 3 precursor signature', NULL, 'PROTEASEAR3', NULL, NULL, 7189, 13),
(280009, NULL, 'PR01574', NULL, NULL, 'Tubby protein signature', NULL, 'TUBBYPROTEIN', NULL, NULL, 7259, 13),
(280010, NULL, 'PR01649', NULL, NULL, 'Psychosine receptor signature', NULL, 'PSYCHOSINER', NULL, NULL, 718, 13),
(280011, NULL, 'PR01290', NULL, NULL, 'Peroxisome proliferator-activated receptor beta signature', NULL, 'PROXISOMPABR', NULL, NULL, 722, 13),
(280012, NULL, 'PR01183', NULL, NULL, 'Ribonucleotide reductase large chain signature', NULL, 'RIBORDTASEM1', NULL, NULL, 4655, 13),
(280013, NULL, 'PR01300', NULL, NULL, 'Pyocin S killer protein signature', NULL, 'PYOCINKILLER', NULL, NULL, 6812, 13),
(280014, NULL, 'PR00904', NULL, NULL, 'Frataxin signature', NULL, 'FRATAXIN', NULL, NULL, 6348, 13),
(280015, NULL, 'PR01218', NULL, NULL, 'Pistil-specific extensin-like signature', NULL, 'PSTLEXTENSIN', NULL, NULL, 6362, 13),
(280016, NULL, 'PR01952', NULL, NULL, 'Nisin biosynthesis protein NisC signature', NULL, 'NISCPROTEIN', NULL, NULL, 19933, 13),
(280017, NULL, 'PR00721', NULL, NULL, 'Stomatin signature', NULL, 'STOMATIN', NULL, NULL, 2138, 13),
(280018, NULL, 'PR01150', NULL, NULL, 'Melatonin 1C receptor signature', NULL, 'MELATONIN1CR', NULL, NULL, 351, 13),
(280019, NULL, 'PR00707', NULL, NULL, 'Ubiquitin C-terminal hydrolase (C12) family signature', NULL, 'UBCTHYDRLASE', NULL, NULL, 3443, 13),
(280020, NULL, 'PR00323', NULL, NULL, 'Gallidermin signature', NULL, 'GALLIDERMIN', NULL, NULL, 2674, 13),
(280021, NULL, 'PR01568', NULL, NULL, 'Lymphotactin receptor signature', NULL, 'LYMPHOTACTNR', NULL, NULL, 7355, 13),
(280022, NULL, 'PR02083', NULL, NULL, 'G kinase-anchoring protein 1 signature', NULL, 'GKINASEAP1', NULL, NULL, 25309, 13),
(280023, NULL, 'PR00921', NULL, NULL, 'IgA-specific serine endopeptidase (S6) signature', NULL, 'IGASERPTASE', NULL, NULL, 3761, 13),
(280024, NULL, 'PR00443', NULL, NULL, 'G protein alpha subunit group S signature', NULL, 'GPROTEINAS', NULL, NULL, 4761, 13),
(280025, NULL, 'PR00030', NULL, NULL, 'Cro repressor HTH signature', NULL, 'HTHCRO', NULL, NULL, 4026, 13),
(280026, NULL, 'PR01057', NULL, NULL, 'Metabotropic glutamate receptor 7 signature', NULL, 'MTABOTROPC7R', NULL, NULL, 4476, 13),
(280027, NULL, 'PR02072', NULL, NULL, 'Four-jointed box protein 1 signature', NULL, '4JOINTEDBOX1', NULL, NULL, 22156, 13),
(280028, NULL, 'PR01542', NULL, NULL, 'Foot-and-mouth disease virus VP1 coat protein signature', NULL, 'FMDVP1COAT', NULL, NULL, 1780, 13),
(280029, NULL, 'PR01070', NULL, NULL, 'Acetyl-CoA carboxylase carboxyl transferase beta subunit signature', NULL, 'ACCCTRFRASEB', NULL, NULL, 5891, 13),
(280030, NULL, 'PR00609', NULL, NULL, 'Class III cytochrome C signature', NULL, 'CYTOCHROMEC3', NULL, NULL, 6419, 13),
(280031, NULL, 'PR01305', NULL, NULL, 'Invasion protein B family signature', NULL, 'SSPAKPROTEIN', NULL, NULL, 857, 13),
(280032, NULL, 'PR01097', NULL, NULL, 'Transient receptor potential family signature', NULL, 'TRNSRECEPTRP', NULL, NULL, 358, 13),
(280033, NULL, 'PR01171', NULL, NULL, 'Bacterial lipocalin signature', NULL, 'BCTLIPOCALIN', NULL, NULL, 6681, 13),
(280034, NULL, 'PR00101', NULL, NULL, 'Aspartate carbamoyltransferase signature', NULL, 'ATCASE', NULL, NULL, NULL, 13),
(280035, NULL, 'PR01628', NULL, NULL, 'L-type calcium channel beta-2 subunit signature', NULL, 'LCACHANNELB2', NULL, NULL, 387, 13);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(280036, NULL, 'PR01603', NULL, NULL, 'Voltage-dependent calcium channel gamma-4 subunit signature', NULL, 'VDCCGAMMA4', NULL, NULL, 464, 13),
(280037, NULL, 'PR00288', NULL, NULL, 'Purothionin signature', NULL, 'PUROTHIONIN', NULL, NULL, 7450, 13),
(280038, NULL, 'PR00074', NULL, NULL, 'Protein-lysine 6-oxidase precursor signature', NULL, 'LYSYLOXIDASE', NULL, NULL, 3414, 13),
(280039, NULL, 'PR00402', NULL, NULL, 'Tec/Btk domain signature', NULL, 'TECBTKDOMAIN', NULL, NULL, 5094, 13),
(280040, NULL, 'PR00927', NULL, NULL, 'Adenine nucleotide translocator signature', NULL, 'ADPTRNSLCASE', NULL, NULL, 1269, 13),
(280041, NULL, 'PR01330', NULL, NULL, 'Kir3.4 inward rectifier K+ channel signature', NULL, 'KIR34CHANNEL', NULL, NULL, 3314, 13),
(280042, NULL, 'PR00751', NULL, NULL, 'Thyrotrophin-releasing hormone receptor signature', NULL, 'THYROLIBRINR', NULL, NULL, 1406, 13),
(280043, NULL, 'PR00385', NULL, NULL, 'P450 superfamily signature', NULL, 'P450', NULL, NULL, 1203, 13),
(280044, NULL, 'PR01240', NULL, NULL, 'Filoviridae VP35 signature', NULL, 'FILOVP35', NULL, NULL, 6557, 13),
(280045, NULL, 'PR01230', NULL, NULL, 'Thiazide-sensitive Na-Cl co-transporter signature', NULL, 'NACLTRNSPORT', NULL, NULL, 6516, 13),
(280046, NULL, 'PR00291', NULL, NULL, 'Soybean trypsin inhibitor (Kunitz-type) signature', NULL, 'KUNITZINHBTR', NULL, NULL, 305, 13),
(280047, NULL, 'PR01507', NULL, NULL, 'Melanin-concentrating hormone 1 receptor signature', NULL, 'MCH1RECEPTOR', NULL, NULL, 693, 13),
(280048, NULL, 'PR01552', NULL, NULL, 'DNA topoisomerase VI subunit A (TOP6A) signature', NULL, 'TPISMRASE6A', NULL, NULL, 1723, 13),
(280049, NULL, 'PR01737', NULL, NULL, 'Porphyromonas gingivalis fimbrillin protein signature', NULL, 'FIMBRILLIN', NULL, NULL, 6426, 13),
(280050, NULL, 'PR01785', NULL, NULL, 'Paraoxonase family signature', NULL, 'PARAOXONASE', NULL, NULL, 2567, 13),
(280051, NULL, 'PR01060', NULL, NULL, 'C3A-anaphylatoxin receptor signature', NULL, 'C3ANPHYLTXNR', NULL, NULL, 3503, 13),
(280052, NULL, 'PR00678', NULL, NULL, 'PI3 kinase P85 regulatory subunit signature', NULL, 'PI3KINASEP85', NULL, NULL, NULL, 13),
(280053, NULL, 'PR00142', NULL, NULL, 'RecA protein signature', NULL, 'RECA', NULL, NULL, 7303, 13),
(280054, NULL, 'PR00170', NULL, NULL, 'Voltage-gated Na+ channel alpha subunit signature', NULL, 'NACHANNEL', NULL, NULL, 3447, 13),
(280055, NULL, 'PR00518', NULL, NULL, '5-hydroxytryptamine 5A receptor signature', NULL, '5HT5ARECEPTR', NULL, NULL, 7127, 13),
(280056, NULL, 'PR01114', NULL, NULL, 'CLC-3 chloride channel signature', NULL, 'CLCHANNEL3', NULL, NULL, 153, 13),
(280057, NULL, 'PR01065', NULL, NULL, 'P2Y3 purinoceptor signature', NULL, 'P2Y3PRNOCPTR', NULL, NULL, 44, 13),
(280058, NULL, 'PR00171', NULL, NULL, 'Sugar transporter signature', NULL, 'SUGRTRNSPORT', NULL, NULL, 1049, 13),
(280059, NULL, 'PR01283', NULL, NULL, 'Ecdysteroid receptor (1H nuclear receptor) signature', NULL, 'ECDYSTEROIDR', NULL, NULL, 545, 13),
(280060, NULL, 'PR01903', NULL, NULL, 'Cysteinyl leukotriene receptor 2 signature', NULL, 'CYSLT2RECPTR', NULL, NULL, 8599, 13),
(280061, NULL, 'PR00622', NULL, NULL, 'Histone H3 signature', NULL, 'HISTONEH3', NULL, NULL, 1526, 13),
(280062, NULL, 'PR00845', NULL, NULL, 'Glycosyl hydrolase family 52 signature', NULL, 'GLHYDRLASE52', NULL, NULL, 137, 13),
(280063, NULL, 'PR00431', NULL, NULL, 'Interleukin-4 signature', NULL, 'INTERLEUKIN4', NULL, NULL, 6343, 13),
(280064, NULL, 'PR00230', NULL, NULL, 'Geminivirus AL2 coat protein signature', NULL, 'GEMCOATAL2', NULL, NULL, 476, 13),
(280065, NULL, 'PR00232', NULL, NULL, 'Potex and carlavirus coat protein signature', NULL, 'POTXCARLCOAT', NULL, NULL, 2879, 13),
(280066, NULL, 'PR00365', NULL, NULL, 'Endothelin signature', NULL, 'ENDOTHELIN', NULL, NULL, 19232, 13),
(280067, NULL, 'PR00205', NULL, NULL, 'Cadherin signature', NULL, 'CADHERIN', NULL, NULL, 1262, 13),
(280068, NULL, 'PR00755', NULL, NULL, 'Aflatoxin biosynthesis regulatory protein signature', NULL, 'AFLATOXINBRP', NULL, NULL, NULL, 13),
(280069, NULL, 'PR01456', NULL, NULL, 'Epithelial membrane protein EMP-3 signature', NULL, 'EPMEMPROT3', NULL, NULL, 6258, 13);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(280070, NULL, 'PR00099', NULL, NULL, 'Carbamoyl-phosphate synthase protein GATase domain signature', NULL, 'CPSGATASE', NULL, NULL, NULL, 13),
(280071, NULL, 'PR01905', NULL, NULL, 'Fatty acid receptor GPR40 signature', NULL, 'FATTYACIDR', NULL, NULL, 8919, 13),
(280072, NULL, 'PR00603', NULL, NULL, 'Cytochrome C1 signature', NULL, 'CYTOCHROMEC1', NULL, NULL, 6349, 13),
(280073, NULL, 'PR01227', NULL, NULL, 'Salmonella surface presentation of antigen gene type M signature', NULL, 'SSPAMPROTEIN', NULL, NULL, 6768, 13),
(280074, NULL, 'PR00791', NULL, NULL, 'Peptidyl-dipeptidase A (M2) metalloprotease family signature', NULL, 'PEPDIPTASEA', NULL, NULL, 3355, 13),
(280075, NULL, 'PR00207', NULL, NULL, 'Flagellin signature', NULL, 'FLAGELLIN', NULL, NULL, 1435, 13),
(280076, NULL, 'PR01220', NULL, NULL, 'Tick histamine binding protein signature', NULL, 'HISBINDING', NULL, NULL, 6790, 13),
(280077, NULL, 'PR01108', NULL, NULL, 'C-C chemokine receptor type 3 signature', NULL, 'CHEMOKINER3', NULL, NULL, 50, 13),
(280078, NULL, 'PR00227', NULL, NULL, 'Geminivirus AL1 coat protein signature', NULL, 'GEMCOATAL1', NULL, NULL, 1248, 13),
(280079, NULL, 'PR00423', NULL, NULL, 'Cell division protein FtsZ signature', NULL, 'CELLDVISFTSZ', NULL, NULL, 7222, 13),
(280080, NULL, 'PR01314', NULL, NULL, 'P2X7 purinoceptor signature', NULL, 'P2X7RECEPTOR', NULL, NULL, 793, 13),
(280081, NULL, 'PR01387', NULL, NULL, 'Cytolethal distending toxin A signature', NULL, 'CDTOXINA', NULL, NULL, 8219, 13),
(280082, NULL, 'PR00698', NULL, NULL, 'C.elegans Srg family integral membrane protein signature', NULL, 'TMPROTEINSRG', NULL, NULL, 5835, 13),
(280083, NULL, 'PR01689', NULL, NULL, 'CYP3A P450 family signature', NULL, 'EP450IICYP3A', NULL, NULL, 6432, 13),
(280084, NULL, 'PR01671', NULL, NULL, 'Gamma-aminobutyric-acid A (GABAA) receptor rho 1 subunit signature', NULL, 'GABAARRHO1', NULL, NULL, 5484, 13),
(280085, NULL, 'PR01357', NULL, NULL, 'Interleukin-1 alpha/beta precursor family signature', NULL, 'INTRLEUKN1AB', NULL, NULL, NULL, 13),
(280086, NULL, 'PR00956', NULL, NULL, 'Flagellar motor switch protein FliN signature', NULL, 'FLGMOTORFLIN', NULL, NULL, 1465, 13),
(280087, NULL, 'PR01090', NULL, NULL, 'Neuroligin signature', NULL, 'NEUROLIGIN', NULL, NULL, 6624, 13),
(280088, NULL, 'PR01350', NULL, NULL, 'Calcitonin receptor family signature', NULL, 'CTRFAMILY', NULL, NULL, 3283, 13),
(280089, NULL, 'PR00183', NULL, NULL, 'E.coli/Salmonella-type porin signature', NULL, 'ECOLIPORIN', NULL, NULL, 2372, 13),
(280090, NULL, 'PR01418', NULL, NULL, 'Galanin 1 receptor signature', NULL, 'GALANIN1R', NULL, NULL, 6104, 13),
(280091, NULL, 'PR01122', NULL, NULL, 'Flavin-containing monooxygenase (FMO) 2 signature', NULL, 'FMOXYGENASE2', NULL, NULL, 5644, 13),
(280092, NULL, 'PR01328', NULL, NULL, 'Kir3.2 inward rectifier K+ channel signature', NULL, 'KIR32CHANNEL', NULL, NULL, 3037, 13),
(280093, NULL, 'PR01927', NULL, NULL, 'Interleukin-11 signature', NULL, 'INTRLEUKIN11', NULL, NULL, 20822, 13),
(280094, NULL, 'PR00905', NULL, NULL, 'Uncharacterised MG045 lipoprotein family signature', NULL, 'MG045FAMILY', NULL, NULL, 2842, 13),
(280095, NULL, 'PR01139', NULL, NULL, 'Gap junction beta-2 protein (Cx26) signature', NULL, 'CONNEXINB2', NULL, NULL, 6555, 13),
(280096, NULL, 'PR01747', NULL, NULL, 'Dense granule Gra7 protein signature', NULL, 'DENSEGRNULE7', NULL, NULL, 6171, 13),
(280097, NULL, 'PR01479', NULL, NULL, 'Neurotensin receptor signature', NULL, 'NEUROTENSINR', NULL, NULL, 7059, 13),
(280098, NULL, 'PR01582', NULL, NULL, 'Kv3.3 voltage-gated K+ channel signature', NULL, 'KV33CHANNEL', NULL, NULL, 7390, 13),
(280099, NULL, 'PR01209', NULL, NULL, 'Na-K-Cl co-transporter 2 signature', NULL, 'NAKCLTRSPRT2', NULL, NULL, 6913, 13),
(280100, NULL, 'PR02069', NULL, NULL, 'Endothelial cell-specific chemotaxis regulator signature', NULL, 'ECCREGULATOR', NULL, NULL, 24704, 13),
(280101, NULL, 'PR01347', NULL, NULL, 'Ephrin signature', NULL, 'EPHRIN', NULL, NULL, 3139, 13),
(280102, NULL, 'PR00554', NULL, NULL, 'Adenosine A2B receptor signature', NULL, 'ADENOSINA2BR', NULL, NULL, 6968, 13);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(280103, NULL, 'PR00969', NULL, NULL, 'Pili chaperone signature', NULL, 'CHAPERONPILI', NULL, NULL, 4198, 13),
(280104, NULL, 'PR01623', NULL, NULL, 'Gamma-aminobutyric-acid A receptor gamma 3 subunit signature', NULL, 'GABAARGAMMA3', NULL, NULL, 130, 13),
(280105, NULL, 'PR00303', NULL, NULL, 'Preprotein translocase SecY subunit signature', NULL, 'SECYTRNLCASE', NULL, NULL, NULL, 13),
(280106, NULL, 'PR01400', NULL, NULL, 'Bacterial thiol-activated pore-forming cytolysin signature', NULL, 'TACYTOLYSIN', NULL, NULL, 4318, 13),
(280107, NULL, 'PR00808', NULL, NULL, 'Cereal trypsin/alpha-amylase inhibitor family signature', NULL, 'AMLASEINHBTR', NULL, NULL, 10419, 13),
(280108, NULL, 'PR00931', NULL, NULL, 'Microbial collagenase metalloprotease (M9) signature', NULL, 'MICOLLPTASE', NULL, NULL, 497, 13),
(280109, NULL, 'PR00945', NULL, NULL, 'Mercuric reductase class II signature', NULL, 'HGRDTASE', NULL, NULL, NULL, 13),
(280110, NULL, 'PR01606', NULL, NULL, 'KCNE voltage-gated K+ channel subfamily E3 signature', NULL, 'KCNE3CHANNEL', NULL, NULL, 170, 13),
(280111, NULL, 'PR01498', NULL, NULL, 'Shaw voltage-gated K+ channel family signature', NULL, 'SHAWCHANNEL', NULL, NULL, 7485, 13),
(280112, NULL, 'PR01156', NULL, NULL, 'Pituitary adenylate cyclase activating polypeptide type 1 receptor signature', NULL, 'PACAPRECEPTR', NULL, NULL, 5871, 13),
(280113, NULL, 'PR01433', NULL, NULL, 'Polycystic kidney disease type 2 protein (PKD2) signature', NULL, 'POLYCYSTIN2', NULL, NULL, 6179, 13),
(280114, NULL, 'PR01490', NULL, NULL, 'Gram-negative bacterial RTX secretion protein D signature', NULL, 'RTXTOXIND', NULL, NULL, NULL, 13),
(280115, NULL, 'PR01571', NULL, NULL, 'Type 1 neuropeptide FF receptor signature', NULL, 'NPFFRECEPTR1', NULL, NULL, 7082, 13),
(280116, NULL, 'PR01589', NULL, NULL, 'Claudin-2 signature', NULL, 'CLAUDIN2', NULL, NULL, 7258, 13),
(280117, NULL, 'PR01634', NULL, NULL, 'Voltage-dependent L-type calcium channel alpha-1S subunit signature', NULL, 'LVDCCALPHA1S', NULL, NULL, 631, 13),
(280118, NULL, 'PR01081', NULL, NULL, 'K-Cl co-transporter signature', NULL, 'KCLTRNSPORT', NULL, NULL, 2962, 13),
(280119, NULL, 'PR01847', NULL, NULL, 'Viral fusion protein signature', NULL, 'VIRALFUSION', NULL, NULL, 5316, 13),
(280120, NULL, 'PR01536', NULL, NULL, 'Interleukin-1 receptor type I and type II family signature', NULL, 'INTRLKN1R12F', NULL, NULL, 1836, 13),
(280121, NULL, 'PR01267', NULL, NULL, 'Mu-class glutathione S-transferase signature', NULL, 'GSTRNSFRASEM', NULL, NULL, 717, 13),
(280122, NULL, 'PR00121', NULL, NULL, 'Sodium/potassium-transporting ATPase signature', NULL, 'NAKATPASE', NULL, NULL, NULL, 13),
(280123, NULL, 'PR00175', NULL, NULL, 'Sodium/alanine symporter signature', NULL, 'NAALASMPORT', NULL, NULL, 3009, 13),
(280124, NULL, 'PR00962', NULL, NULL, 'Lethal(2) giant larvae protein signature', NULL, 'LETHAL2GIANT', NULL, NULL, 5873, 13),
(280125, NULL, 'PR00197', NULL, NULL, 'Annexin type I signature', NULL, 'ANNEXINI', NULL, NULL, 6102, 13),
(280126, NULL, 'PR01360', NULL, NULL, 'Interleukin-1 receptor antagonist precursor IL-1RA signature', NULL, 'INTRLEUKIN1X', NULL, NULL, 3179, 13),
(280127, NULL, 'PR00407', NULL, NULL, 'Eukaryotic molybdopterin domain signature', NULL, 'EUMOPTERIN', NULL, NULL, 12302, 13),
(280128, NULL, 'PR00090', NULL, NULL, 'Ring hydroxylating dioxygenase alpha-subunit signature', NULL, 'RNGDIOXGNASE', NULL, NULL, 3090, 13),
(280129, NULL, 'PR01050', NULL, NULL, 'Pyruvate kinase family signature', NULL, 'PYRUVTKNASE', NULL, NULL, 3451, 13),
(280130, NULL, 'PR01928', NULL, NULL, 'Interleukin-12 beta subunit signature', NULL, 'INTRLEUKN12B', NULL, NULL, 8493, 13),
(280131, NULL, 'PR00168', NULL, NULL, 'KCNE voltage-gated K+ channel family E signature', NULL, 'KCNECHANNEL', NULL, NULL, 458, 13),
(280132, NULL, 'PR01153', NULL, NULL, 'Platelet activating factor receptor signature', NULL, 'PAFRECEPTOR', NULL, NULL, 5734, 13),
(280133, NULL, 'PR01241', NULL, NULL, 'Fungal G protein alpha subunit signature', NULL, 'GPROTEINAFNG', NULL, NULL, 7421, 13); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(280134, NULL, 'PR00674', NULL, NULL, 'Light harvesting protein B chain signature', NULL, 'LIGHTHARVSTB', NULL, NULL, 6035, 13),
(280135, NULL, 'PR01680', NULL, NULL, 'Tumour necrosis factor receptor 6 signature', NULL, 'TNFACTORR6', NULL, NULL, 5239, 13),
(280136, NULL, 'PR01343', NULL, NULL, 'Yeast eukaryotic release factor signature', NULL, 'YEASTERF', NULL, NULL, 3269, 13),
(280137, NULL, 'PR01809', NULL, NULL, 'Annexin type A10 signature', NULL, 'ANNEXINX', NULL, NULL, 9872, 13),
(280138, NULL, 'PR00442', NULL, NULL, 'G protein alpha subunit group Q signature', NULL, 'GPROTEINAQ', NULL, NULL, 6959, 13),
(280139, NULL, 'PR00265', NULL, NULL, 'Interleukin-2 signature', NULL, 'INTERLEUKIN2', NULL, NULL, 3542, 13),
(280140, NULL, 'PR00178', NULL, NULL, 'Fatty acid-binding protein signature', NULL, 'FATTYACIDBP', NULL, NULL, 5892, 13),
(280141, NULL, 'PR00632', NULL, NULL, 'Sonic hedgehog protein signature', NULL, 'SONICHHOG', NULL, NULL, 5310, 13),
(280142, NULL, 'PR00910', NULL, NULL, 'Luteovirus ORF6 protein signature', NULL, 'LVIRUSORF6', NULL, NULL, NULL, 13),
(280143, NULL, 'PR00280', NULL, NULL, 'Channel forming colicin signature', NULL, 'CHANLCOLICIN', NULL, NULL, 4747, 13),
(280144, NULL, 'PR02049', NULL, NULL, 'Protein family FAM36A signature', NULL, 'PROTEINF36A', NULL, NULL, 14798, 13),
(280145, NULL, 'PR00855', NULL, NULL, 'Prostaglandin F receptor signature', NULL, 'PRSTNOIDFPR', NULL, NULL, 3615, 13),
(280146, NULL, 'PR00780', NULL, NULL, 'Leuserpin 2 signature', NULL, 'LEUSERPINII', NULL, NULL, NULL, 13),
(280147, NULL, 'PR01532', NULL, NULL, 'C-X-C chemokine receptor type 3 signature', NULL, 'CXCCHMKINER3', NULL, NULL, 1536, 13),
(280148, NULL, 'PR01922', NULL, NULL, 'Tumour necrosis factor receptor 5 signature', NULL, 'TNFACTORR5', NULL, NULL, 20744, 13),
(280149, NULL, 'PR00333', NULL, NULL, 'Herpsevirus integral membrane protein signature', NULL, 'HSVINTEGRLMP', NULL, NULL, 4600, 13),
(280150, NULL, 'PR01063', NULL, NULL, 'Melanocortin 5 receptor signature', NULL, 'MELNOCORTN5R', NULL, NULL, 5783, 13),
(280151, NULL, 'PR01096', NULL, NULL, 'TWIK-1 K+ channel signature', NULL, 'TWIK1CHANNEL', NULL, NULL, 3123, 13),
(280152, NULL, 'PR01318', NULL, NULL, 'Glial cell line-derived neurotrophic factor receptor alpha 2 signature', NULL, 'GDNFRALPHA2', NULL, NULL, 6500, 13),
(280153, NULL, 'PR01378', NULL, NULL, 'Claudin-3 signature', NULL, 'CLAUDIN3', NULL, NULL, 7033, 13),
(280154, NULL, 'PR00252', NULL, NULL, 'Neurotransmitter-gated ion channel family signature', NULL, 'NRIONCHANNEL', NULL, NULL, 11483, 13),
(280155, NULL, 'PR01975', NULL, NULL, 'Tumour necrosis factor receptor 11B signature', NULL, 'TNFACTORR11B', NULL, NULL, 17648, 13),
(280156, NULL, 'PR00571', NULL, NULL, 'Endothelin-B receptor signature', NULL, 'ENDOTHELINBR', NULL, NULL, 2459, 13),
(280157, NULL, 'PR00256', NULL, NULL, 'Bacterial photosynthetic reaction centre signature', NULL, 'REACTNCENTRE', NULL, NULL, 5823, 13),
(280158, NULL, 'PR00470', NULL, NULL, 'Trypanothione reductase signature', NULL, 'TRYPANRDTASE', NULL, NULL, 4141, 13),
(280159, NULL, 'PR01599', NULL, NULL, 'Zona occludens protein ZO-2 signature', NULL, 'ZONOCCLUDNS2', NULL, NULL, 7327, 13),
(280160, NULL, 'PR01950', NULL, NULL, 'LanC-like protein superfamily signature', NULL, 'LANCSUPER', NULL, NULL, 2439, 13),
(280161, NULL, 'PR01430', NULL, NULL, 'Protease activated receptor 2 precursor signature', NULL, 'PROTEASEAR4', NULL, NULL, 7068, 13),
(280162, NULL, 'PR01345', NULL, NULL, 'C.elegans hypothetical protein (pol-like reverse transciptase) signature', NULL, 'CERVTRCPTASE', NULL, NULL, NULL, 13),
(280163, NULL, 'PR01180', NULL, NULL, 'Arginine decarboxylase signature', NULL, 'ARGDCRBXLASE', NULL, NULL, 7168, 13),
(280164, NULL, 'PR00204', NULL, NULL, 'Beta-amyloid peptide (beta-APP) signature', NULL, 'BETAAMYLOID', NULL, NULL, 9773, 13),
(280165, NULL, 'PR01496', NULL, NULL, 'Shaker voltage-gated K+ channel family signature', NULL, 'SHAKERCHANEL', NULL, NULL, 7113, 13),
(280166, NULL, 'PR00729', NULL, NULL, 'Cattle diarrhoea virus endopeptidase P80 (S31) signature', NULL, 'CDVENDOPTASE', NULL, NULL, 4533, 13);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(280167, NULL, 'PR01982', NULL, NULL, 'Insulin-like growth factor-binding protein 6 signature', NULL, 'IGFBPFAMILY6', NULL, NULL, 15637, 13),
(280168, NULL, 'PR00776', NULL, NULL, 'Hemoglobinase (C13) cysteine protease signature', NULL, 'HEMOGLOBNASE', NULL, NULL, 1162, 13),
(280169, NULL, 'PR01312', NULL, NULL, 'P2X5 purinoceptor signature', NULL, 'P2X5RECEPTOR', NULL, NULL, 963, 13),
(280170, NULL, 'PR00406', NULL, NULL, 'Cytochrome B5 reductase signature', NULL, 'CYTB5RDTASE', NULL, NULL, NULL, 13),
(280171, NULL, 'PR00748', NULL, NULL, 'Melibiase signature', NULL, 'MELIBIASE', NULL, NULL, 11362, 13),
(280172, NULL, 'PR00187', NULL, NULL, 'Arthropod haemocyanin signature', NULL, 'HAEMOCYANIN', NULL, NULL, 12518, 13),
(280173, NULL, 'PR01406', NULL, NULL, 'B-box zinc finger signature', NULL, 'BBOXZNFINGER', NULL, NULL, 19228, 13),
(280174, NULL, 'PR01175', NULL, NULL, 'Von Ebner''s gland protein signature', NULL, 'VNEBNERGLAND', NULL, NULL, 6534, 13),
(280175, NULL, 'PR01900', NULL, NULL, 'YidC translocation/secretion protein signature', NULL, 'YIDCPROTEIN', NULL, NULL, 3041, 13),
(280176, NULL, 'PR02009', NULL, NULL, 'Viridiplantae FMU-related RCMT signature', NULL, 'RCMTFMUVIRPL', NULL, NULL, 14134, 13),
(280177, NULL, 'PR02071', NULL, NULL, 'Pancreatic progenitor cell differentiation & proliferation factor signature', NULL, 'PPDPFACTOR', NULL, NULL, NULL, 13),
(280178, NULL, 'PR01934', NULL, NULL, 'Interleukin-19 signature', NULL, 'INTRLEUKIN19', NULL, NULL, 18575, 13),
(280179, NULL, 'PR00129', NULL, NULL, 'Cutinase signature', NULL, 'CUTINASE', NULL, NULL, 10313, 13),
(280180, NULL, 'PR01047', NULL, NULL, 'Threonyl-tRNA synthetase signature', NULL, 'TRNASYNTHTHR', NULL, NULL, 6103, 13),
(280181, NULL, 'PR02068', NULL, NULL, 'Vesicular, over-expressed in cancer, pro-survival protein 1 signature', NULL, 'VOPPROTEIN1', NULL, NULL, 25611, 13),
(280182, NULL, 'PR02045', NULL, NULL, 'FAM138 N-terminal domain signature', NULL, 'F138DOMAIN', NULL, NULL, NULL, 13),
(280183, NULL, 'PR00601', NULL, NULL, 'Bacterioferritin signature', NULL, 'BACFERRITIN', NULL, NULL, 2463, 13),
(280184, NULL, 'PR00080', NULL, NULL, 'Short-chain dehydrogenase/reductase (SDR) superfamily signature', NULL, 'SDRFAMILY', NULL, NULL, 6085, 13),
(280185, NULL, 'PR01006', NULL, NULL, 'Flagellar hook-basal body complex protein FliE signature', NULL, 'FLGHOOKFLIE', NULL, NULL, 3094, 13),
(280186, NULL, 'PR00711', NULL, NULL, 'Atrial natriuretic peptide signature', NULL, 'ANATPEPTIDE', NULL, NULL, 6950, 13),
(280187, NULL, 'PR00747', NULL, NULL, 'Glycosyl hydrolase family 47 signature', NULL, 'GLYHDRLASE47', NULL, NULL, 6619, 13),
(280188, NULL, 'PR01609', NULL, NULL, 'Adhesion molecule CD36 family signature', NULL, 'CD36FAMILY', NULL, NULL, 270, 13),
(280189, NULL, 'PR00659', NULL, NULL, 'Chromogranin signature', NULL, 'CHROMOGRANIN', NULL, NULL, 4237, 13),
(280190, NULL, 'PR00961', NULL, NULL, 'Paraneoplastic encephalomyelitis antigen family signature', NULL, 'HUDSXLRNA', NULL, NULL, 6399, 13),
(280191, NULL, 'PR00570', NULL, NULL, 'Endothelin-A receptor signature', NULL, 'ENDOTHELINAR', NULL, NULL, 5436, 13),
(280192, NULL, 'PR00929', NULL, NULL, 'AT-hook-like domain signature', NULL, 'ATHOOK', NULL, NULL, 14566, 13),
(280193, NULL, 'PR02041', NULL, NULL, 'Protein family FAM153 signature', NULL, 'PROTEINF153', NULL, NULL, 15581, 13),
(280194, NULL, 'PR00269', NULL, NULL, 'Pleiotrophin/midkine family signature', NULL, 'PTNMIDKINE', NULL, NULL, 4159, 13),
(280195, NULL, 'PR00795', NULL, NULL, 'Ryanodine receptor signature', NULL, 'RYANODINER', NULL, NULL, 13803, 13),
(280196, NULL, 'PR01557', NULL, NULL, 'C-C chemokine receptor type 10 signature', NULL, 'CHEMOKINER10', NULL, NULL, 6511, 13),
(280197, NULL, 'PR00364', NULL, NULL, 'Disease resistance protein signature', NULL, 'DISEASERSIST', NULL, NULL, NULL, 13),
(280198, NULL, 'PR00461', NULL, NULL, 'Plant peroxidase signature', NULL, 'PLPEROXIDASE', NULL, NULL, 4670, 13),
(280199, NULL, 'PR01706', NULL, NULL, 'Antistasin signature', NULL, 'ANTISTASIN', NULL, NULL, 6449, 13);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(280200, NULL, 'PR00447', NULL, NULL, 'Natural resistance-associated macrophage protein signature', NULL, 'NATRESASSCMP', NULL, NULL, 2110, 13),
(280201, NULL, 'PR01528', NULL, NULL, 'EDG-4 lysophosphatidic acid receptor signature', NULL, 'EDG4RECEPTOR', NULL, NULL, 1521, 13),
(280202, NULL, 'PR01611', NULL, NULL, 'Lysosome membrane protein II (LIMP II) signature', NULL, 'LIMPII', NULL, NULL, 223, 13),
(280203, NULL, 'PR00350', NULL, NULL, 'Vitamin D receptor signature', NULL, 'VITAMINDR', NULL, NULL, 708, 13),
(280204, NULL, 'PR01917', NULL, NULL, 'Venom nerve growth factor signature', NULL, 'VENOMNGF', NULL, NULL, 20636, 13),
(280205, NULL, 'PR01935', NULL, NULL, 'Interleukin-20 signature', NULL, 'INTRLEUKIN20', NULL, NULL, 18745, 13),
(280206, NULL, 'PR00914', NULL, NULL, 'Luteovirus (ORF3) RNA-directed RNA-polymerase signature', NULL, 'LVIRUSRNAPOL', NULL, NULL, 4365, 13),
(280207, NULL, 'PR00528', NULL, NULL, 'Glucocorticoid receptor (3C nuclear receptor) signature', NULL, 'GLCORTICOIDR', NULL, NULL, 3324, 13),
(280208, NULL, 'PR00566', NULL, NULL, 'Dopamine 1B receptor signature', NULL, 'DOPAMINED1BR', NULL, NULL, 5862, 13),
(280209, NULL, 'PR01274', NULL, NULL, 'Metalloprotease inhibitor signature', NULL, 'MPTASEINHBTR', NULL, NULL, 14821, 13),
(280210, NULL, 'PR00704', NULL, NULL, 'Calpain cysteine protease (C2) family signature', NULL, 'CALPAIN', NULL, NULL, 16603, 13),
(280211, NULL, 'PR00684', NULL, NULL, 'Phage T4 lysozyme signature', NULL, 'T4LYSOZYME', NULL, NULL, 1106, 13),
(280212, NULL, 'PR01077', NULL, NULL, 'Claudin family signature', NULL, 'CLAUDIN', NULL, NULL, NULL, 13),
(280213, NULL, 'PR02084', NULL, NULL, 'Golgi membrane protein 1/Cancer susceptibility candidate gene 4 signature', NULL, 'GOLM1CASC4', NULL, NULL, 23412, 13),
(280214, NULL, 'PR01818', NULL, NULL, 'Desmosomal cadherin signature', NULL, 'DESMOCADHERN', NULL, NULL, 10401, 13),
(280215, NULL, 'PR00200', NULL, NULL, 'Annexin type IV signature', NULL, 'ANNEXINIV', NULL, NULL, 5278, 13),
(280216, NULL, 'PR01727', NULL, NULL, 'Prokaryotic integration host factor signature', NULL, 'DNABINDINGHU', NULL, NULL, 1984, 13),
(280217, NULL, 'PR01349', NULL, NULL, 'Wnt protein signature', NULL, 'WNTPROTEIN', NULL, NULL, 5688, 13),
(280218, NULL, 'PR00824', NULL, NULL, 'Hepatic lipase signature', NULL, 'HEPLIPASE', NULL, NULL, 6332, 13),
(280219, NULL, 'PR02023', NULL, NULL, 'Invertebrate aquaporin-10 signature', NULL, 'AQUAPORIN10I', NULL, NULL, NULL, 13),
(280220, NULL, 'PR00811', NULL, NULL, 'Bacterial general secretion pathway protein D signature', NULL, 'BCTERIALGSPD', NULL, NULL, 3175, 13),
(280221, NULL, 'PR01438', NULL, NULL, 'Universal stress protein signature', NULL, 'UNVRSLSTRESS', NULL, NULL, 1052, 13),
(280222, NULL, 'PR00828', NULL, NULL, 'Formin signature', NULL, 'FORMIN', NULL, NULL, 350, 13),
(280223, NULL, 'PR00862', NULL, NULL, 'Prolyl oligopeptidase serine protease (S9A) signature', NULL, 'PROLIGOPTASE', NULL, NULL, 6506, 13),
(280224, NULL, 'PR02081', NULL, NULL, 'Protein GIGANTEA signature', NULL, 'GIGANTEA', NULL, NULL, 26481, 13),
(280225, NULL, 'PR00188', NULL, NULL, 'Plant globin signature', NULL, 'PLANTGLOBIN', NULL, NULL, NULL, 13),
(280226, NULL, 'PR01142', NULL, NULL, 'Gap junction beta-5 protein (Cx30.3) signature', NULL, 'CONNEXINB5', NULL, NULL, 5641, 13),
(280227, NULL, 'PR02011', NULL, NULL, 'RNA (C5-cytosine) methyltransferase NCL1 subfamily signature', NULL, 'RCMTNCL1', NULL, NULL, 14443, 13),
(280228, NULL, 'PR00241', NULL, NULL, 'Angiotensin II receptor signature', NULL, 'ANGIOTENSINR', NULL, NULL, 4631, 13),
(280229, NULL, 'PR01820', NULL, NULL, 'Desmocollin signature', NULL, 'DESMOCOLLIN', NULL, NULL, NULL, 13),
(280230, NULL, 'PR01451', NULL, NULL, 'Calcium-activated SK potassium channel signature', NULL, 'SKCHANNEL', NULL, NULL, 8648, 13),
(280231, NULL, 'PR00620', NULL, NULL, 'Histone H2A signature', NULL, 'HISTONEH2A', NULL, NULL, 1479, 13),
(280232, NULL, 'PR00305', NULL, NULL, '14-3-3 protein zeta signature', NULL, '1433ZETA', NULL, NULL, 801, 13),
(280233, NULL, 'PR00947', NULL, NULL, 'Insect cuticle protein signature', NULL, 'CUTICLE', NULL, NULL, 5789, 13);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(280234, NULL, 'PR01931', NULL, NULL, 'Interleukin-16 signature', NULL, 'INTRLEUKIN16', NULL, NULL, 20454, 13),
(280235, NULL, 'PR01356', NULL, NULL, 'Anti-sense to fibroblast growth factor protein GFG signature', NULL, 'GFGPROTEIN', NULL, NULL, 3473, 13),
(280236, NULL, 'PR01588', NULL, NULL, 'THIK K+ channel signature', NULL, 'THIKCHANNEL', NULL, NULL, 7143, 13),
(280237, NULL, 'PR01519', NULL, NULL, 'Epsilon-tubulin signature', NULL, 'EPSLNTUBULIN', NULL, NULL, 625, 13),
(280238, NULL, 'PR01979', NULL, NULL, 'Insulin-like growth factor-binding protein 3 signature', NULL, 'IGFBPFAMILY3', NULL, NULL, 13865, 13),
(280239, NULL, 'PR00726', NULL, NULL, 'Repressor LexA serine protease (S24) family signature', NULL, 'LEXASERPTASE', NULL, NULL, 11376, 13),
(280240, NULL, 'PR00290', NULL, NULL, 'Kazal-type serine protease inhibitor signature', NULL, 'KAZALINHBTR', NULL, NULL, 2158, 13),
(280241, NULL, 'PR01668', NULL, NULL, 'Neurotensin/neuromedin N precursor signature', NULL, 'NEUROTENSIN', NULL, NULL, 5158, 13),
(280242, NULL, 'PR01685', NULL, NULL, 'CYP2B P450 family signature', NULL, 'EP450ICYP2B', NULL, NULL, 5260, 13),
(280243, NULL, 'PR01174', NULL, NULL, 'Retinol binding protein signature', NULL, 'RETINOLBNDNG', NULL, NULL, 6779, 13),
(280244, NULL, 'PR01638', NULL, NULL, 'MHC class I signature', NULL, 'MHCCLASSI', NULL, NULL, 1055, 13),
(280245, NULL, 'PR01768', NULL, NULL, 'Vanilloid receptor (TRPV) family signature', NULL, 'TRPVRECEPTOR', NULL, NULL, 7967, 13),
(280246, NULL, 'PR00581', NULL, NULL, 'Prostanoid EP2 receptor signature', NULL, 'PRSTNOIDEP2R', NULL, NULL, 4165, 13),
(280247, NULL, 'PR00154', NULL, NULL, 'AMP-binding signature', NULL, 'AMPBINDING', NULL, NULL, 20596, 13),
(280248, NULL, 'PR01702', NULL, NULL, 'CD40 ligand/CD154 antigen signature', NULL, 'CD40LIGAND', NULL, NULL, 2954, 13),
(280249, NULL, 'PR00061', NULL, NULL, 'Ribosomal protein L19 signature', NULL, 'RIBOSOMALL19', NULL, NULL, 4104, 13),
(280250, NULL, 'PR00050', NULL, NULL, 'Cold shock protein signature', NULL, 'COLDSHOCK', NULL, NULL, 1455, 13),
(280251, NULL, 'PR00840', NULL, NULL, 'MG067/MG068/MG395 hypothetical protein family signature', NULL, 'Y06768FAMILY', NULL, NULL, 20665, 13),
(280252, NULL, 'PR00633', NULL, NULL, 'Chromosome condensation regulator RCC1 signature', NULL, 'RCCNDNSATION', NULL, NULL, 6861, 13),
(280253, NULL, 'PR00592', NULL, NULL, 'Extracellular calcium-sensing receptor signature', NULL, 'CASENSINGR', NULL, NULL, 3712, 13),
(280254, NULL, 'PR01509', NULL, NULL, 'Kv1.2 voltage-gated K+ channel signature', NULL, 'KV12CHANNEL', NULL, NULL, 644, 13),
(280255, NULL, 'PR01117', NULL, NULL, 'CLC-6 chloride channel signature', NULL, 'CLCHANNEL6', NULL, NULL, 5750, 13),
(280256, NULL, 'PR00313', NULL, NULL, 'NodO calcium binding signature', NULL, 'CABNDNGRPT', NULL, NULL, NULL, 13),
(280257, NULL, 'PR01474', NULL, NULL, 'Vascular cell adhesion molecule-1 (VCAM-1) signature', NULL, 'VCAM1', NULL, NULL, 7301, 13),
(280258, NULL, 'PR00975', NULL, NULL, 'Ribosomal protein S19 family signature', NULL, 'RIBOSOMALS19', NULL, NULL, 22, 13),
(280259, NULL, 'PR01128', NULL, NULL, 'EMR1 hormone receptor signature', NULL, 'EMR1HORMONER', NULL, NULL, 3262, 13),
(280260, NULL, 'PR01538', NULL, NULL, 'Interleukin-1 receptor type I precursor signature', NULL, 'INTRLEUKN1R1', NULL, NULL, 1865, 13),
(280261, NULL, 'PR00697', NULL, NULL, 'C.elegans Sra family integral membrane protein signature', NULL, 'TMPROTEINSRA', NULL, NULL, 266, 13),
(280262, NULL, 'PR01416', NULL, NULL, 'APJ receptor signature', NULL, 'APJRECEPTOR', NULL, NULL, 6360, 13),
(280263, NULL, 'PR01581', NULL, NULL, 'Kv3.1 voltage-gated K+ channel signature', NULL, 'KV31CHANNEL', NULL, NULL, 7018, 13),
(280264, NULL, 'PR01704', NULL, NULL, 'Fungal allergen ribonucleotoxin signature', NULL, 'FUNRIBOTOXIN', NULL, NULL, 912, 13),
(280265, NULL, 'PR00279', NULL, NULL, 'Bacterial toxin signature', NULL, 'BACTRLTOXIN', NULL, NULL, 11028, 13),
(280266, NULL, 'PR00923', NULL, NULL, 'Lactococcus X-Pro dipeptidyl-peptidase (S15) family signature', NULL, 'LACTOPTASE', NULL, NULL, 1813, 13);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(280267, NULL, 'PR01901', NULL, NULL, 'Wnt inhibitory factor (WIF)-1 protein signature', NULL, 'WIFPROTEIN', NULL, NULL, 8751, 13),
(280268, NULL, 'PR00463', NULL, NULL, 'E-class P450 group I signature', NULL, 'EP450I', NULL, NULL, 6291, 13),
(280269, NULL, 'PR01513', NULL, NULL, 'Kv1.6 voltage-gated K+ channel signature', NULL, 'KV16CHANNEL', NULL, NULL, 706, 13),
(280270, NULL, 'PR00192', NULL, NULL, 'F-actin capping protein beta subunit signature', NULL, 'FACTINCAPB', NULL, NULL, 3177, 13),
(280271, NULL, 'PR00410', NULL, NULL, 'Phenol hydroxylase reductase family signature', NULL, 'PHEHYDRXLASE', NULL, NULL, NULL, 13),
(280272, NULL, 'PR00013', NULL, NULL, 'Fibronectin type II repeat signature', NULL, 'FNTYPEII', NULL, NULL, NULL, 13),
(280273, NULL, 'PR00202', NULL, NULL, 'Annexin type VI signature', NULL, 'ANNEXINVI', NULL, NULL, 6509, 13),
(280274, NULL, 'PR00675', NULL, NULL, 'Marek''s disease glycoprotein A signature', NULL, 'MAREKSGPA', NULL, NULL, 3053, 13),
(280275, NULL, 'PR01828', NULL, NULL, 'Neurokinin B precursor signature', NULL, 'NEUROKININB', NULL, NULL, 1222, 13),
(280276, NULL, 'PR00035', NULL, NULL, 'GntR bacterial regulatory protein HTH signature', NULL, 'HTHGNTR', NULL, NULL, 5800, 13),
(280277, NULL, 'PR01622', NULL, NULL, 'Gamma-aminobutyric-acid A receptor gamma 2 subunit signature', NULL, 'GABAARGAMMA2', NULL, NULL, 452, 13),
(280278, NULL, 'PR00411', NULL, NULL, 'Pyridine nucleotide disulphide reductase class-I signature', NULL, 'PNDRDTASEI', NULL, NULL, NULL, 13),
(280279, NULL, 'PR02022', NULL, NULL, 'Mammalian aquaporin-10 signature', NULL, 'AQUAPORIN10M', NULL, NULL, 25336, 13),
(280280, NULL, 'PR00189', NULL, NULL, 'Transthyretin signature', NULL, 'TRNSTHYRETIN', NULL, NULL, 3147, 13),
(280281, NULL, 'PR01165', NULL, NULL, 'Cytochrome c oxidase subunit I signature', NULL, 'CYCOXIDASEI', NULL, NULL, 456, 13),
(280282, NULL, 'PR01251', NULL, NULL, 'Amphiphysin signature', NULL, 'AMPHIPHYSIN', NULL, NULL, 2, 13),
(280283, NULL, 'PR01481', NULL, NULL, 'Neurotensin type 2 receptor signature', NULL, 'NEUROTENSN2R', NULL, NULL, 7434, 13),
(280284, NULL, 'PR01526', NULL, NULL, 'EDG-6 sphingosine 1-phosphate receptor signature', NULL, 'EDG6RECEPTOR', NULL, NULL, 727, 13),
(280285, NULL, 'PR00429', NULL, NULL, 'Thromboxane receptor signature', NULL, 'THROMBOXANER', NULL, NULL, 2334, 13),
(280286, NULL, 'PR01370', NULL, NULL, 'Translocated intimin receptor (Tir) signature', NULL, 'TRNSINTIMINR', NULL, NULL, 16493, 13),
(280287, NULL, 'PR00277', NULL, NULL, 'Insulin signature', NULL, 'INSULIN', NULL, NULL, 4085, 13),
(280288, NULL, 'PR01980', NULL, NULL, 'Insulin-like growth factor-binding protein 4 signature', NULL, 'IGFBPFAMILY4', NULL, NULL, 15946, 13),
(280289, NULL, 'PR01916', NULL, NULL, 'Neurotrophin-6 signature', NULL, 'NEUROTROPHN6', NULL, NULL, 20154, 13),
(280290, NULL, 'PR00660', NULL, NULL, 'ER lumen protein retaining receptor signature', NULL, 'ERLUMENR', NULL, NULL, 3614, 13),
(280291, NULL, 'PR01729', NULL, NULL, 'Lactobacillus surface layer protein signature', NULL, 'SURFACELAYER', NULL, NULL, 1963, 13),
(280292, NULL, 'PR00465', NULL, NULL, 'E-class P450 group IV signature', NULL, 'EP450IV', NULL, NULL, 6902, 13),
(280293, NULL, 'PR00936', NULL, NULL, 'Lambda phage regulatory protein CIII signature', NULL, 'BPLRPCIII', NULL, NULL, 11038, 13),
(280294, NULL, 'PR01717', NULL, NULL, 'CD28 antigen signature', NULL, 'CD28ANTIGEN', NULL, NULL, 6441, 13),
(280295, NULL, 'PR00584', NULL, NULL, 'Prostanoid EP3 receptor type 2 signature', NULL, 'PRSTNOIDE32R', NULL, NULL, 6337, 13),
(280296, NULL, 'PR01109', NULL, NULL, 'C-C chemokine receptor type 4 signature', NULL, 'CHEMOKINER4', NULL, NULL, 5816, 13),
(280297, NULL, 'PR01842', NULL, NULL, 'Wnt-2 protein signature', NULL, 'WNT2PROTEIN', NULL, NULL, 10489, 13),
(280298, NULL, 'PR01920', NULL, NULL, 'Tumour necrosis factor receptor 3 signature', NULL, 'TNFACTORR3', NULL, NULL, 17227, 13),
(280299, NULL, 'PR01748', NULL, NULL, 'Transcription factor AP-2 signature', NULL, 'AP2TNSCPFCT', NULL, NULL, 11385, 13);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(280300, NULL, 'PR01993', NULL, NULL, 'GP162 7TM protein signature', NULL, 'GPR162', NULL, NULL, 15218, 13),
(280301, NULL, 'PR01544', NULL, NULL, 'Arabidopsis thaliana 130.7kDa hypothetical protein signature', NULL, 'ARATH130DUF', NULL, NULL, 1929, 13),
(280302, NULL, 'PR01465', NULL, NULL, 'ELK potassium channel family signature', NULL, 'ELKCHANNEL', NULL, NULL, 7287, 13),
(280303, NULL, 'PR01732', NULL, NULL, 'Neisseria meningitidis adhesin MafB signature', NULL, 'ADHESINMAFB', NULL, NULL, 6498, 13),
(280304, NULL, 'PR01898', NULL, NULL, 'Bacterial superantigen superfamily signature', NULL, 'SAGSUPRFAMLY', NULL, NULL, 8967, 13),
(280305, NULL, 'PR00653', NULL, NULL, 'Activin type II receptor signature', NULL, 'ACTIVIN2R', NULL, NULL, 4752, 13),
(280306, NULL, 'PR00723', NULL, NULL, 'Subtilisin serine protease family (S8) signature', NULL, 'SUBTILISIN', NULL, NULL, 8331, 13),
(280307, NULL, 'PR00094', NULL, NULL, 'Adenylate kinase signature', NULL, 'ADENYLTKNASE', NULL, NULL, 174, 13),
(280308, NULL, 'PR01253', NULL, NULL, 'Amphiphysin isoform 2 signature', NULL, 'AMPHIPHYSIN2', NULL, NULL, 11, 13),
(280309, NULL, 'PR01637', NULL, NULL, 'Pollen allergen Lol p2 signature', NULL, 'LOLP2ALLERGN', NULL, NULL, 700, 13),
(280310, NULL, 'PR00321', NULL, NULL, 'Gamma G protein (transducin) signature', NULL, 'GPROTEING', NULL, NULL, 5459, 13),
(280311, NULL, 'PR01074', NULL, NULL, 'Presenilin 2 signature', NULL, 'PRESENILIN2', NULL, NULL, 6272, 13),
(280312, NULL, 'PR01366', NULL, NULL, 'Major royal jelly protein family signature', NULL, 'ROYALJELLY', NULL, NULL, 19326, 13),
(280313, NULL, 'PR01024', NULL, NULL, 'Neurokinin NK1 receptor signature', NULL, 'NEUROKININ1R', NULL, NULL, 2895, 13),
(280314, NULL, 'PR01447', NULL, NULL, 'Claudin-16 signature', NULL, 'CLAUDIN16', NULL, NULL, 6141, 13),
(280315, NULL, 'PR01909', NULL, NULL, 'Atypical dual specificity phosphatase subfamily A signature', NULL, 'ADSPHPHTASEA', NULL, NULL, 18607, 13),
(280316, NULL, 'PR00820', NULL, NULL, 'CbxX/CfqX protein signature', NULL, 'CBXXCFQX', NULL, NULL, 6794, 13),
(280317, NULL, 'PR01533', NULL, NULL, 'Cysteinyl leukotriene receptor family signature', NULL, 'CYSLTRECPTR', NULL, NULL, 1807, 13),
(280318, NULL, 'PR00043', NULL, NULL, 'Jun transcription factor signature', NULL, 'LEUZIPPRJUN', NULL, NULL, 1181, 13),
(280319, NULL, 'PR01977', NULL, NULL, 'Insulin-like growth factor-binding protein 1 signature', NULL, 'IGFBPFAMILY1', NULL, NULL, 15663, 13),
(280320, NULL, 'PR00630', NULL, NULL, 'Monellin A chain signature', NULL, 'MONELLINA', NULL, NULL, 4609, 13),
(280321, NULL, 'PR00083', NULL, NULL, 'Histidinol dehydrogenase signature', NULL, 'HOLDHDRGNASE', NULL, NULL, 13893, 13),
(280322, NULL, 'PR00993', NULL, NULL, 'B1 bradykinin receptor signature', NULL, 'BRADYKINNB1R', NULL, NULL, 1353, 13),
(280323, NULL, 'PR01308', NULL, NULL, 'P2X1 purinoceptor signature', NULL, 'P2X1RECEPTOR', NULL, NULL, 6760, 13),
(280324, NULL, 'PR00655', NULL, NULL, 'Auxin binding protein signature', NULL, 'AUXINBINDNGP', NULL, NULL, 5698, 13),
(280325, NULL, 'PR00384', NULL, NULL, 'Opioid receptor signature', NULL, 'OPIOIDR', NULL, NULL, 6601, 13),
(280326, NULL, 'PR01632', NULL, NULL, 'P/Q-type voltage-dependent calcium channel alpha-1 subunit signature', NULL, 'PQVDCCALPHA1', NULL, NULL, 379, 13),
(280327, NULL, 'PR01371', NULL, NULL, 'Salmonella/Yersinia modular tyrosine phosphatase signature', NULL, 'BACYPHPHTASE', NULL, NULL, 7107, 13),
(280328, NULL, 'PR00730', NULL, NULL, 'Thermolysin metalloprotease (M4) family signature', NULL, 'THERMOLYSIN', NULL, NULL, 12157, 13),
(280329, NULL, 'PR01233', NULL, NULL, 'Josephin signature', NULL, 'JOSEPHIN', NULL, NULL, NULL, 13),
(280330, NULL, 'PR02061', NULL, NULL, 'Wolframin signature', NULL, 'WOLFRAMIN', NULL, NULL, 25796, 13),
(280331, NULL, 'PR00331', NULL, NULL, 'Haemagglutinin HA2 chain signature', NULL, 'HEMAGGLUTN2', NULL, NULL, 4709, 13),
(280332, NULL, 'PR00995', NULL, NULL, '36kDa capillovirus serine protease (S35) signature', NULL, 'CAPILLOPTASE', NULL, NULL, 4854, 13),
(280333, NULL, 'PR01027', NULL, NULL, 'OMS28 porin signature', NULL, 'OMS28PORIN', NULL, NULL, 89, 13);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(280334, NULL, 'PR00376', NULL, NULL, 'Interleukin-1B converting enzyme signature', NULL, 'IL1BCENZYME', NULL, NULL, 7166, 13),
(280335, NULL, 'PR01048', NULL, NULL, 'Hypothetical protein Y414 family signature', NULL, 'Y414FAMILY', NULL, NULL, 1154, 13),
(280336, NULL, 'PR01746', NULL, NULL, 'Dense granule Gra6 protein signature', NULL, 'DENSEGRNULE6', NULL, NULL, 6436, 13),
(280337, NULL, 'PR00532', NULL, NULL, 'Kappa opioid receptor signature', NULL, 'KAPPAOPIOIDR', NULL, NULL, 6948, 13),
(280338, NULL, 'PR00900', NULL, NULL, 'Pheromone A receptor signature', NULL, 'PHEROMONEAR', NULL, NULL, 5762, 13),
(280339, NULL, 'PR01463', NULL, NULL, 'EAG/ELK/ERG potassium channel family signature', NULL, 'EAGCHANLFMLY', NULL, NULL, 7360, 13),
(280340, NULL, 'PR01224', NULL, NULL, 'Delta-tubulin signature', NULL, 'DELTATUBULIN', NULL, NULL, 5027, 13),
(280341, NULL, 'PR00296', NULL, NULL, 'Cyclin-dependent kinase regulatory subunit signature', NULL, 'CYCLINKINASE', NULL, NULL, 4563, 13),
(280342, NULL, 'PR00836', NULL, NULL, 'Somatotropin hormone family signature', NULL, 'SOMATOTROPIN', NULL, NULL, 5388, 13),
(280343, NULL, 'PR01211', NULL, NULL, 'Synuclein signature', NULL, 'SYNUCLEIN', NULL, NULL, 2440, 13),
(280344, NULL, 'PR01146', NULL, NULL, 'GPR1 orphan receptor signature', NULL, 'GPR1ORPHANR', NULL, NULL, 157, 13),
(280345, NULL, 'PR00679', NULL, NULL, 'Prohibitin signature', NULL, 'PROHIBITIN', NULL, NULL, 1539, 13),
(280346, NULL, 'PR00329', NULL, NULL, 'Haemagglutinin HA1/HA2 chain signature', NULL, 'HEMAGGLUTN12', NULL, NULL, 2002, 13),
(280347, NULL, 'PR00215', NULL, NULL, 'Neuromodulin signature', NULL, 'NEUROMODULIN', NULL, NULL, 3364, 13),
(280348, NULL, 'PR00245', NULL, NULL, 'Olfactory receptor signature', NULL, 'OLFACTORYR', NULL, NULL, 6952, 13),
(280349, NULL, 'PR00469', NULL, NULL, 'Pyridine nucleotide disulphide reductase class-II signature', NULL, 'PNDRDTASEII', NULL, NULL, NULL, 13),
(280350, NULL, 'PR01323', NULL, NULL, 'Kir1.3 inward rectifer K+ channel signature', NULL, 'KIR13CHANNEL', NULL, NULL, 3482, 13),
(280351, NULL, 'PR01695', NULL, NULL, 'Ig-hepta receptor signature', NULL, 'IGHEPTARCPTR', NULL, NULL, 6380, 13),
(280352, NULL, 'PR01539', NULL, NULL, 'Interleukin-1 receptor type II precursor signature', NULL, 'INTRLEUKN1R2', NULL, NULL, 1762, 13),
(280353, NULL, 'PR01337', NULL, NULL, 'Type III secretion system outer membrane G protein family signature', NULL, 'TYPE3OMGPROT', NULL, NULL, 6223, 13),
(280354, NULL, 'PR01005', NULL, NULL, 'Flagellar hook-associated protein signature', NULL, 'FLGHOOKAP1', NULL, NULL, 6094, 13),
(280355, NULL, 'PR01521', NULL, NULL, 'Orexin receptor type 1 signature', NULL, 'OREXIN1R', NULL, NULL, 795, 13),
(280356, NULL, 'PR00062', NULL, NULL, 'Ribosomal protein L20 signature', NULL, 'RIBOSOMALL20', NULL, NULL, 5975, 13),
(280357, NULL, 'PR00139', NULL, NULL, 'Asparaginase/glutaminase family signature', NULL, 'ASNGLNASE', NULL, NULL, 2746, 13),
(280358, NULL, 'PR01364', NULL, NULL, 'Viral protein D10 signature', NULL, 'VD10PROTEIN', NULL, NULL, 3078, 13),
(280359, NULL, 'PR01895', NULL, NULL, 'Wnt-16 protein signature', NULL, 'WNT16PROTEIN', NULL, NULL, 8898, 13),
(280360, NULL, 'PR00925', NULL, NULL, 'Nonhistone chromosomal protein HMG17 family signature', NULL, 'NONHISHMG17', NULL, NULL, 2748, 13),
(280361, NULL, 'PR00335', NULL, NULL, 'TrkA potassium uptake protein signature', NULL, 'KUPTAKETRKA', NULL, NULL, 2705, 13),
(280362, NULL, 'PR00273', NULL, NULL, 'Galanin signature', NULL, 'GALANIN', NULL, NULL, 7237, 13),
(280363, NULL, 'PR01236', NULL, NULL, 'Tumour necrosis factor beta (lymphotoxin-alpha) signature', NULL, 'TNFBETA', NULL, NULL, 569, 13),
(280364, NULL, 'PR01807', NULL, NULL, 'Angiomotin family signature', NULL, 'ANGIOMOTIN', NULL, NULL, 10442, 13),
(280365, NULL, 'PR00835', NULL, NULL, 'Regulatory protein Rop signature', NULL, 'ROPREGULATRY', NULL, NULL, 3617, 13),
(280366, NULL, 'PR01486', NULL, NULL, 'Bacterial phospholipase A1 protein signature', NULL, 'PHPHLIPASEA1', NULL, NULL, 3435, 13),
(280367, NULL, 'PR01461', NULL, NULL, 'KCNQ2 voltage-gated potassium channel signature', NULL, 'KCNQ2CHANNEL', NULL, NULL, 7056, 13);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(280368, NULL, 'PR00091', NULL, NULL, 'Nitrogenase component II signature', NULL, 'NITROGNASEII', NULL, NULL, NULL, 13),
(280369, NULL, 'PR01045', NULL, NULL, 'Glycyl-tRNA synthetase beta subunit signature', NULL, 'TRNASYNTHGB', NULL, NULL, 8398, 13),
(280370, NULL, 'PR01033', NULL, NULL, 'Phytochrome signature', NULL, 'PHYTOCHROME', NULL, NULL, 921, 13),
(280371, NULL, 'PR01534', NULL, NULL, 'Vomeronasal type 1 receptor family signature', NULL, 'VOMERONASL1R', NULL, NULL, 1741, 13),
(280372, NULL, 'PR00539', NULL, NULL, 'Muscarinic M2 receptor signature', NULL, 'MUSCRINICM2R', NULL, NULL, 1201, 13),
(280373, NULL, 'PR01518', NULL, NULL, 'Kv4.3 voltage-gated K+ channel signature', NULL, 'KV43CHANNEL', NULL, NULL, 533, 13),
(280374, NULL, 'PR00686', NULL, NULL, 'Transcription initiation factor TFIID signature', NULL, 'TIFACTORIID', NULL, NULL, 4552, 13),
(280375, NULL, 'PR01402', NULL, NULL, 'Mutator MutX protein signature', NULL, 'MUTATORMUTX', NULL, NULL, 213, 13),
(280376, NULL, 'PR01166', NULL, NULL, 'Cytochrome c oxidase subunit II signature', NULL, 'CYCOXIDASEII', NULL, NULL, NULL, 13),
(280377, NULL, 'PR01821', NULL, NULL, 'DAPIT signature', NULL, 'DAPIT', NULL, NULL, 10063, 13),
(280378, NULL, 'PR00105', NULL, NULL, 'Cytosine-specific DNA methyltransferase signature', NULL, 'C5METTRFRASE', NULL, NULL, 5274, 13),
(280379, NULL, 'PR01151', NULL, NULL, 'Melatonin-related 1X receptor signature', NULL, 'MELATONIN1XR', NULL, NULL, 5775, 13),
(280380, NULL, 'PR00863', NULL, NULL, 'Nodavirus coat precursor endopeptidase (A6) aspartic protease signature', NULL, 'NODAVIRPTASE', NULL, NULL, 6644, 13),
(280381, NULL, 'PR01197', NULL, NULL, 'GAT-3 GABA neurotransmitter transporter signature', NULL, 'GAT3TRNSPORT', NULL, NULL, 7035, 13),
(280382, NULL, 'PR01161', NULL, NULL, 'Tubulin signature', NULL, 'TUBULIN', NULL, NULL, 1689, 13),
(280383, NULL, 'PR01554', NULL, NULL, 'Escherichia coli P pili regulatory PapB protein signature', NULL, 'FIMREGULATRY', NULL, NULL, 5286, 13),
(280384, NULL, 'PR00165', NULL, NULL, 'Anion exchanger family signature', NULL, 'ANIONEXCHNGR', NULL, NULL, 3368, 13),
(280385, NULL, 'PR01080', NULL, NULL, 'Hypoxia-inducible factor-1 alpha signature', NULL, 'HYPOXIAIF1A', NULL, NULL, 2399, 13),
(280386, NULL, 'PR02001', NULL, NULL, 'GCR1-cAMP receptor family signature', NULL, 'GCR1CAMPR', NULL, NULL, 15592, 13),
(280387, NULL, 'PR00278', NULL, NULL, 'Pancreatic hormone signature', NULL, 'PANCHORMONE', NULL, NULL, 2149, 13),
(280388, NULL, 'PR01252', NULL, NULL, 'Amphiphysin isoform 1 signature', NULL, 'AMPHIPHYSIN1', NULL, NULL, 455, 13),
(280389, NULL, 'PR00495', NULL, NULL, 'Obesity factor (leptin) signature', NULL, 'LEPTIN', NULL, NULL, 3616, 13),
(280390, NULL, 'PR00151', NULL, NULL, 'Porphobilinogen deaminase signature', NULL, 'PORPHBDMNASE', NULL, NULL, 3144, 13),
(280391, NULL, 'PR01664', NULL, NULL, 'Voltage-gated Na+ channel alpha 1 subunit signature', NULL, 'NACHANNEL1', NULL, NULL, 5223, 13),
(280392, NULL, 'PR00089', NULL, NULL, 'Bacterial luciferase signature', NULL, 'LUCIFERASE', NULL, NULL, 5124, 13),
(280393, NULL, 'PR00390', NULL, NULL, 'Phospholipase C signature', NULL, 'PHPHLIPASEC', NULL, NULL, 1363, 13),
(280394, NULL, 'PR01888', NULL, NULL, 'Neuropeptide B/W family signature', NULL, 'NROPEPTIDEBW', NULL, NULL, 8721, 13),
(280395, NULL, 'PR01889', NULL, NULL, 'Neuropeptide B precursor signature', NULL, 'PPNRPEPTIDEB', NULL, NULL, 8840, 13),
(280396, NULL, 'PR01203', NULL, NULL, 'Serotonin (5-HT) neurotransmitter transporter signature', NULL, '5HTTRANSPORT', NULL, NULL, 7051, 13),
(280397, NULL, 'PR01890', NULL, NULL, 'Neuropeptide W precursor signature', NULL, 'PPNRPEPTIDEW', NULL, NULL, 8632, 13),
(280398, NULL, 'PR01494', NULL, NULL, 'Kv9 potassium channel alpha subunit signature', NULL, 'KV9CHANNEL', NULL, NULL, 7132, 13),
(280399, NULL, 'PR01499', NULL, NULL, 'Trek K+ channel signature', NULL, 'TREKCHANNEL', NULL, NULL, 7481, 13),
(280400, NULL, 'PR00179', NULL, NULL, 'Lipocalin signature', NULL, 'LIPOCALIN', NULL, NULL, NULL, 13),
(280401, NULL, 'PR00114', NULL, NULL, 'Serine/threonine phosphatase family signature', NULL, 'STPHPHTASE', NULL, NULL, 11072, 13);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(280402, NULL, 'PR00500', NULL, NULL, 'Polycystic kidney disease type 1 protein (PKD1) signature', NULL, 'POLYCYSTIN1', NULL, NULL, 4688, 13),
(280403, NULL, 'PR01245', NULL, NULL, 'Repair protein Rad1/Rec1 family signature', NULL, 'RAD1REC1', NULL, NULL, 141, 13),
(280404, NULL, 'PR00932', NULL, NULL, 'Aminopeptidase I zinc metalloprotease (M18) signature', NULL, 'AMINO1PTASE', NULL, NULL, 4387, 13),
(280405, NULL, 'PR00128', NULL, NULL, 'Colipase signature', NULL, 'COLIPASE', NULL, NULL, 2227, 13),
(280406, NULL, 'PR01978', NULL, NULL, 'Insulin-like growth factor-binding protein 2 signature', NULL, 'IGFBPFAMILY2', NULL, NULL, 13556, 13),
(280407, NULL, 'PR01808', NULL, NULL, 'Annexin type VIII signature', NULL, 'ANNEXINVIII', NULL, NULL, 10201, 13),
(280408, NULL, 'PR01073', NULL, NULL, 'Presenilin 1 signature', NULL, 'PRESENILIN1', NULL, NULL, 2238, 13),
(280409, NULL, 'PR01154', NULL, NULL, 'Vasoactive intestinal peptide receptor 1 signature', NULL, 'VIP1RECEPTOR', NULL, NULL, 5077, 13),
(280410, NULL, 'PR01226', NULL, NULL, 'Expansin signature', NULL, 'EXPANSIN', NULL, NULL, 832, 13),
(280411, NULL, 'PR01088', NULL, NULL, 'Na+/H+ exchanger isoform 6 (NHE6) signature', NULL, 'NAHEXCHNGR6', NULL, NULL, 5384, 13),
(280412, NULL, 'PR00739', NULL, NULL, 'Glycosyl hydrolase family 26 signature', NULL, 'GLHYDRLASE26', NULL, NULL, 4991, 13),
(280413, NULL, 'PR01015', NULL, NULL, 'Neuropeptide Y4 receptor signature', NULL, 'NRPEPTIDEY4R', NULL, NULL, 2193, 13),
(280414, NULL, 'PR01135', NULL, NULL, 'Gap junction alpha-5 protein (Cx40) signature', NULL, 'CONNEXINA5', NULL, NULL, 6031, 13),
(280415, NULL, 'PR00413', NULL, NULL, 'Haloacid dehalogenase/epoxide hydrolase family signature', NULL, 'HADHALOGNASE', NULL, NULL, 6934, 13),
(280416, NULL, 'PR00097', NULL, NULL, 'Anthranilate synthase component II signature', NULL, 'ANTSNTHASEII', NULL, NULL, NULL, 13),
(280417, NULL, 'PR00130', NULL, NULL, 'DNase I signature', NULL, 'DNASEI', NULL, NULL, 12000, 13),
(280418, NULL, 'PR01682', NULL, NULL, 'FMRFamide-related peptide precursor signature', NULL, 'FMRFAMIDEPEP', NULL, NULL, 5067, 13),
(280419, NULL, 'PR01327', NULL, NULL, 'Kir3.1 inward rectifier K+ channel signature', NULL, 'KIR31CHANNEL', NULL, NULL, 3213, 13),
(280420, NULL, 'PR00913', NULL, NULL, 'Luteovirus ORF2 putative replicase 1 signature', NULL, 'LVIRUSORF2', NULL, NULL, 15522, 13),
(280421, NULL, 'PR02054', NULL, NULL, 'Plant protein family FAM175 signature', NULL, 'FAM175PLANT', NULL, NULL, 15994, 13),
(280422, NULL, 'PR00221', NULL, NULL, 'Caulimovirus coat protein signature', NULL, 'CAULIMOCOAT', NULL, NULL, 2214, 13),
(280423, NULL, 'PR01566', NULL, NULL, 'Neuromedin U type 1 receptor signature', NULL, 'NEUROMEDNU1R', NULL, NULL, 7319, 13),
(280424, NULL, 'PR01134', NULL, NULL, 'Gap junction alpha-4 protein (Connexin37) signature', NULL, 'CONNEXINA4', NULL, NULL, 5777, 13),
(280425, NULL, 'PR01338', NULL, NULL, 'Type III secretion system outer membrane K protein family signature', NULL, 'TYPE3OMKPROT', NULL, NULL, 3278, 13),
(280426, NULL, 'PR00882', NULL, NULL, 'Ribosomal protein L7A family signature', NULL, 'RIBOSOMALL7A', NULL, NULL, 4363, 13),
(280427, NULL, 'PR01879', NULL, NULL, 'Nervy protein signature', NULL, 'NERVYPROTEIN', NULL, NULL, 8720, 13),
(280428, NULL, 'PR00802', NULL, NULL, 'Serum albumin family signature', NULL, 'SERUMALBUMIN', NULL, NULL, 528, 13),
(280429, NULL, 'PR02056', NULL, NULL, 'Protein family FAM105A signature', NULL, 'PROTEINF105A', NULL, NULL, 15688, 13),
(280430, NULL, 'PR00870', NULL, NULL, 'DNA-polymerase family X pol beta-like signature', NULL, 'DNAPOLXBETA', NULL, NULL, 2070, 13),
(280431, NULL, 'PR00981', NULL, NULL, 'Seryl-tRNA synthetase signature', NULL, 'TRNASYNTHSER', NULL, NULL, 6055, 13),
(280432, NULL, 'PR01262', NULL, NULL, 'Innexin signature', NULL, 'INNEXIN', NULL, NULL, 3193, 13),
(280433, NULL, 'PR00777', NULL, NULL, 'Hirudin signature', NULL, 'HIRUDIN', NULL, NULL, 6656, 13),
(280434, NULL, 'PR01633', NULL, NULL, 'R-type voltage-dependent calcium channel alpha-1 subunit signature', NULL, 'RVDCCALPHA1', NULL, NULL, 867, 13);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(280435, NULL, 'PR01684', NULL, NULL, 'CYP2A P450 family signature', NULL, 'EP450ICYP2A', NULL, NULL, 5011, 13),
(280436, NULL, 'PR01375', NULL, NULL, 'Salmonella/Shigella invasin protein B signature', NULL, 'BACINVASINB', NULL, NULL, 7067, 13),
(280437, NULL, 'PR01339', NULL, NULL, 'Type III secretion system outer membrane O protein family signature', NULL, 'TYPE3OMOPROT', NULL, NULL, 3380, 13),
(280438, NULL, 'PR00715', NULL, NULL, 'Cation-dependent mannose-6-phosphate receptor signature', NULL, 'MAN6PRECEPTR', NULL, NULL, 601, 13),
(280439, NULL, 'PR00427', NULL, NULL, 'Interleukin-8 receptor signature', NULL, 'INTRLEUKIN8R', NULL, NULL, 3501, 13),
(280440, NULL, 'PR00311', NULL, NULL, 'Bleomycin resistance protein signature', NULL, 'BLEOMYCINRST', NULL, NULL, 647, 13),
(280441, NULL, 'PR00312', NULL, NULL, 'Calsequestrin signature', NULL, 'CALSEQUESTRN', NULL, NULL, NULL, 13),
(280442, NULL, 'PR00023', NULL, NULL, 'Zona pellucida sperm-binding protein signature', NULL, 'ZPELLUCIDA', NULL, NULL, 6041, 13),
(280443, NULL, 'PR00576', NULL, NULL, 'Opsin RH1/RH2 signature', NULL, 'OPSINRH1RH2', NULL, NULL, 3386, 13),
(280444, NULL, 'PR01365', NULL, NULL, 'Telomere reverse transcriptase signature', NULL, 'TELOMERASERT', NULL, NULL, 7065, 13),
(280445, NULL, 'PR01007', NULL, NULL, 'Flagellar hook-length control protein signature', NULL, 'FLGHOOKFLIK', NULL, NULL, 3256, 13),
(280446, NULL, 'PR00108', NULL, NULL, 'Thymidylate synthase family signature', NULL, 'THYMDSNTHASE', NULL, NULL, 6989, 13),
(280447, NULL, 'PR01273', NULL, NULL, 'Invertebrate colouration protein signature', NULL, 'INVTBRTCOLOR', NULL, NULL, 6652, 13),
(280448, NULL, 'PR01107', NULL, NULL, 'C-C chemokine receptor type 2 signature', NULL, 'CHEMOKINER2', NULL, NULL, 5979, 13),
(280449, NULL, 'PR01700', NULL, NULL, 'CD34 antigen signature', NULL, 'CD34ANTIGEN', NULL, NULL, 6161, 13),
(280450, NULL, 'PR01177', NULL, NULL, 'Metabotropic gamma-aminobutyric acid type B1 receptor signature', NULL, 'GABAB1RECPTR', NULL, NULL, NULL, 13),
(280451, NULL, 'PR01282', NULL, NULL, 'COUP transcription factor (2F nuclear receptor) family signature', NULL, 'COUPTNFACTOR', NULL, NULL, NULL, 13),
(280452, NULL, 'PR00610', NULL, NULL, 'Cytochrome F signature', NULL, 'CYTOCHROMEF', NULL, NULL, 6398, 13),
(280453, NULL, 'PR00656', NULL, NULL, 'Bacteriochlorophyll C binding protein signature', NULL, 'BCHLROPHYLLC', NULL, NULL, 3398, 13),
(280454, NULL, 'PR00208', NULL, NULL, 'Gliadin and LMW glutenin superfamily signature', NULL, 'GLIADGLUTEN', NULL, NULL, 4080, 13),
(280455, NULL, 'PR02036', NULL, NULL, 'Chemotaxis inhibitory protein signature', NULL, 'CHEMOTAXISIP', NULL, NULL, 15774, 13),
(280456, NULL, 'PR01457', NULL, NULL, 'Lens fibre membrane intrinsic protein (LMIP) signature', NULL, 'LENSMEMPROT', NULL, NULL, 7484, 13),
(280457, NULL, 'PR02066', NULL, NULL, 'Daughter-specific expression protein 2 signature', NULL, 'DSEPROTEIN2', NULL, NULL, 25648, 13),
(280458, NULL, 'PR01708', NULL, NULL, '5-hydroxytryptamine 3 receptor signature', NULL, '5HT3RECEPTOR', NULL, NULL, 6148, 13),
(280459, NULL, 'PR00631', NULL, NULL, 'Monellin B chain signature', NULL, 'MONELLINB', NULL, NULL, 1182, 13),
(280460, NULL, 'PR01037', NULL, NULL, 'Tetracycline resistance protein TetO/TetQ/TetM family signature', NULL, 'TCRTETOQM', NULL, NULL, NULL, 13),
(280461, NULL, 'PR00457', NULL, NULL, 'Animal haem peroxidase signature', NULL, 'ANPEROXIDASE', NULL, NULL, 17272, 13),
(280462, NULL, 'PR00452', NULL, NULL, 'SH3 domain signature', NULL, 'SH3DOMAIN', NULL, NULL, 6232, 13),
(280463, NULL, 'PR01878', NULL, NULL, 'Myeloid transforming gene on chromosome 16 (MTG16) protein signature', NULL, 'MTG16PROTEIN', NULL, NULL, 8671, 13),
(280464, NULL, 'PR01121', NULL, NULL, 'Flavin-containing monooxygenase (FMO) 1 signature', NULL, 'FMOXYGENASE1', NULL, NULL, 5248, 13),
(280465, NULL, 'PR00430', NULL, NULL, 'Interleukin-3 signature', NULL, 'INTERLEUKIN3', NULL, NULL, 1048, 13),
(280466, NULL, 'PR00301', NULL, NULL, '70kDa heat shock protein signature', NULL, 'HEATSHOCK70', NULL, NULL, NULL, 13);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(280467, NULL, 'PR00703', NULL, NULL, 'Adenovirus endopeptidase (C5) family signature', NULL, 'ADVENDOPTASE', NULL, NULL, 444, 13),
(280468, NULL, 'PR01947', NULL, NULL, 'Mammalian interleukin-15 signature', NULL, 'INTLKN15MAML', NULL, NULL, 19611, 13),
(280469, NULL, 'PR00438', NULL, NULL, 'Growth factor cystine knot domain signature', NULL, 'GFCYSKNOT', NULL, NULL, NULL, 13),
(280470, NULL, 'PR01933', NULL, NULL, 'Interleukin-18 signature', NULL, 'INTRLEUKIN18', NULL, NULL, 8461, 13),
(280471, NULL, 'PR01471', NULL, NULL, 'Histamine H3 receptor signature', NULL, 'HISTAMINEH3R', NULL, NULL, 7376, 13),
(280472, NULL, 'PR00865', NULL, NULL, 'Papillomavirus major capsid protein L1 signature', NULL, 'HPVCAPSIDL1', NULL, NULL, 239, 13),
(280473, NULL, 'PR00540', NULL, NULL, 'Muscarinic M3 receptor signature', NULL, 'MUSCRINICM3R', NULL, NULL, 1020, 13),
(280474, NULL, 'PR02065', NULL, NULL, 'Protein DPCD signature', NULL, 'PROTEINDPCD', NULL, NULL, 25580, 13),
(280475, NULL, 'PR00556', NULL, NULL, 'Alpha-1B adrenergic receptor signature', NULL, 'ADRENRGCA1BR', NULL, NULL, 1431, 13),
(280476, NULL, 'PR00683', NULL, NULL, 'Spectrin pleckstrin homology domain signature', NULL, 'SPECTRINPH', NULL, NULL, 5222, 13),
(280477, NULL, 'PR00625', NULL, NULL, 'DnaJ domain signature', NULL, 'JDOMAIN', NULL, NULL, 1163, 13),
(280478, NULL, 'PR01723', NULL, NULL, 'Gamma-aminobutyric-acid A receptor epsilon subunit signature', NULL, 'GABAAREPSLON', NULL, NULL, 6443, 13),
(280479, NULL, 'PR00246', NULL, NULL, 'Somatostatin receptor signature', NULL, 'SOMATOSTATNR', NULL, NULL, 4382, 13),
(280480, NULL, 'PR01083', NULL, NULL, 'Lymphocyte-specific protein signature', NULL, 'LYMPHSPCIFIC', NULL, NULL, 493, 13),
(280481, NULL, 'PR00550', NULL, NULL, 'Hyperglycemic hormone signature', NULL, 'HYPRGLYCEMIC', NULL, NULL, 1338, 13),
(280482, NULL, 'PR00007', NULL, NULL, 'Complement C1Q domain signature', NULL, 'COMPLEMNTC1Q', NULL, NULL, 2032, 13),
(280483, NULL, 'PR01981', NULL, NULL, 'Insulin-like growth factor-binding protein 5 signature', NULL, 'IGFBPFAMILY5', NULL, NULL, 13987, 13),
(280484, NULL, 'PR01812', NULL, NULL, 'Annexin type XXXI signature', NULL, 'ANNEXINXXXI', NULL, NULL, 10483, 13),
(280485, NULL, 'PR00754', NULL, NULL, 'Aerolysin signature', NULL, 'AEROLYSIN', NULL, NULL, 5581, 13),
(280486, NULL, 'PR01455', NULL, NULL, 'Epithelial membrane protein EMP-2 signature', NULL, 'EPMEMPROT2', NULL, NULL, 6009, 13),
(280487, NULL, 'PR01303', NULL, NULL, 'Plasmodium circumsporozoite protein signature', NULL, 'CRCMSPRZOITE', NULL, NULL, 650, 13),
(280488, NULL, 'PR01369', NULL, NULL, 'Intimin signature', NULL, 'INTIMIN', NULL, NULL, 7239, 13),
(280489, NULL, 'PR00274', NULL, NULL, 'Glycoprotein hormone alpha chain signature', NULL, 'GLYCOHORMONE', NULL, NULL, 5533, 13),
(280490, NULL, 'PR01163', NULL, NULL, 'Beta-tubulin signature', NULL, 'BETATUBULIN', NULL, NULL, 6587, 13),
(280491, NULL, 'PR00574', NULL, NULL, 'Blue-sensitive opsin signature', NULL, 'OPSINBLUE', NULL, NULL, 3474, 13),
(280492, NULL, 'PR01530', NULL, NULL, 'C-C chemokine receptor type 8 signature', NULL, 'CHEMOKINER8', NULL, NULL, 1561, 13),
(280493, NULL, 'PR00444', NULL, NULL, 'HIV R-ORF/X-ORF protein signature', NULL, 'HIVVPRVPX', NULL, NULL, 2929, 13),
(280494, NULL, 'PR01296', NULL, NULL, 'Cloacin immunity protein signature', NULL, 'CLOACNIMMNTY', NULL, NULL, 866, 13),
(280495, NULL, 'PR02003', NULL, NULL, 'Bombyxin signature', NULL, 'BOMBYXIN', NULL, NULL, 20200, 13),
(280496, NULL, 'PR00527', NULL, NULL, 'Gastrin receptor signature', NULL, 'GASTRINR', NULL, NULL, 731, 13),
(280497, NULL, 'PR00759', NULL, NULL, 'Basic protease (Kunitz-type) inhibitor family signature', NULL, 'BASICPTASE', NULL, NULL, 481, 13),
(280498, NULL, 'PR01921', NULL, NULL, 'Tumour necrosis factor receptor 4 signature', NULL, 'TNFACTORR4', NULL, NULL, 20083, 13),
(280499, NULL, 'PR00053', NULL, NULL, 'Fork head domain signature', NULL, 'FORKHEAD', NULL, NULL, 3039, 13),
(280500, NULL, 'PR00268', NULL, NULL, 'Nerve growth factor signature', NULL, 'NGF', NULL, NULL, 5242, 13);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(280501, NULL, 'PR00297', NULL, NULL, '10kDa chaperonin signature', NULL, 'CHAPERONIN10', NULL, NULL, 14568, 13),
(280502, NULL, 'PR01926', NULL, NULL, 'Interleukin-9 signature', NULL, 'INTERLEUKIN9', NULL, NULL, 20294, 13),
(280503, NULL, 'PR02002', NULL, NULL, 'Insulin-like growth factor signature', NULL, 'INSLNLIKEGF', NULL, NULL, 15641, 13),
(280504, NULL, 'PR01243', NULL, NULL, 'Nucleoside diphosphate kinase signature', NULL, 'NUCDPKINASE', NULL, NULL, 3427, 13),
(280505, NULL, 'PR00964', NULL, NULL, 'Movement protein signature', NULL, 'MOVEMENT', NULL, NULL, 1499, 13),
(280506, NULL, 'PR01115', NULL, NULL, 'CLC-4 chloride channel signature', NULL, 'CLCHANNEL4', NULL, NULL, 5616, 13),
(280507, NULL, 'PR00604', NULL, NULL, 'Class IA and IB cytochrome C signature', NULL, 'CYTCHRMECIAB', NULL, NULL, 6028, 13),
(280508, NULL, 'PR01053', NULL, NULL, 'Metabotropic glutamate receptor 3 signature', NULL, 'MTABOTROPC3R', NULL, NULL, 2311, 13),
(280509, NULL, 'PR00689', NULL, NULL, 'Acyl-coA-binding protein signature', NULL, 'ACOABINDINGP', NULL, NULL, 5595, 13),
(280510, NULL, 'PR01385', NULL, NULL, 'Claudin-14 signature', NULL, 'CLAUDIN14', NULL, NULL, NULL, 13),
(280511, NULL, 'PS00143', NULL, NULL, 'Insulinase family, zinc-binding region signature.', NULL, 'INSULINASE', NULL, NULL, 6552, 14),
(280512, NULL, 'PS01295', NULL, NULL, '4-diphosphocytidyl-2C-methyl-D-erythritol synthase signature.', NULL, 'ISPD', NULL, NULL, 16989, 14),
(280513, NULL, 'PS01173', NULL, NULL, 'Lipolytic enzymes "G-D-X-G" family, putative histidine active site.', NULL, 'LIPASE_GDXG_HIS', NULL, NULL, 5432, 14),
(280514, NULL, 'PS00128', NULL, NULL, 'Glycosyl hydrolases family 22 (GH22) domain signature.', NULL, 'GLYCOSYL_HYDROL_F22_1', NULL, NULL, 17085, 14),
(280515, NULL, 'PS00834', NULL, NULL, 'Aspartyl proteases, omptin family signature 1.', NULL, 'OMPTIN_1', NULL, NULL, 16043, 14),
(280516, NULL, 'PS00324', NULL, NULL, 'Aspartokinase signature.', NULL, 'ASPARTOKINASE', NULL, NULL, 19181, 14),
(280517, NULL, 'PS01144', NULL, NULL, 'Ribosomal protein L31e signature.', NULL, 'RIBOSOMAL_L31E', NULL, NULL, 15782, 14),
(280518, NULL, 'PS01084', NULL, NULL, 'DNA photolyases class 2 signature 2.', NULL, 'DNA_PHOTOLYASES_2_2', NULL, NULL, 21745, 14),
(280519, NULL, 'PS00761', NULL, NULL, 'Signal peptidases I signature 3.', NULL, 'SPASE_I_3', NULL, NULL, 20524, 14),
(280520, NULL, 'PS00026', NULL, NULL, 'Chitin recognition or binding domain signature.', NULL, 'CHIT_BIND_I_1', NULL, NULL, 20205, 14),
(280521, NULL, 'PS00321', NULL, NULL, 'recA signature.', NULL, 'RECA_1', NULL, NULL, 20668, 14),
(280522, NULL, 'PS00252', NULL, NULL, 'Interferon alpha, beta and delta family signature.', NULL, 'INTERFERON_A_B_D', NULL, NULL, 5598, 14),
(280523, NULL, 'PS00493', NULL, NULL, 'Clusterin signature 2.', NULL, 'CLUSTERIN_2', NULL, NULL, 24715, 14),
(280524, NULL, 'PS00633', NULL, NULL, 'Bromodomain signature.', NULL, 'BROMODOMAIN_1', NULL, NULL, 20161, 14),
(280525, NULL, 'PS00209', NULL, NULL, 'Arthropod hemocyanins / insect LSPs signature 1.', NULL, 'HEMOCYANIN_1', NULL, NULL, 12518, 14),
(280526, NULL, 'PS00787', NULL, NULL, 'Chorismate synthase signature 1.', NULL, 'CHORISMATE_SYNTHASE_1', NULL, NULL, 14521, 14),
(280527, NULL, 'PS00603', NULL, NULL, 'Thymidine kinase cellular-type signature.', NULL, 'TK_CELLULAR_TYPE', NULL, NULL, 19935, 14),
(280528, NULL, 'PS00907', NULL, NULL, 'Uroporphyrinogen decarboxylase signature 2.', NULL, 'UROD_2', NULL, NULL, 1252, 14),
(280529, NULL, 'PS00984', NULL, NULL, 'Urotensin II signature.', NULL, 'UROTENSIN_II', NULL, NULL, 6267, 14),
(280530, NULL, 'PS00162', NULL, NULL, 'Alpha-carbonic anhydrases signature.', NULL, 'ALPHA_CA_1', NULL, NULL, 8351, 14),
(280531, NULL, 'PS01277', NULL, NULL, 'Ribonuclease PH signature.', NULL, 'RIBONUCLEASE_PH', NULL, NULL, 20475, 14),
(280532, NULL, 'PS00630', NULL, NULL, 'Inositol monophosphatase family signature 2.', NULL, 'IMP_2', NULL, NULL, 21192, 14),
(280533, NULL, 'PS01332', NULL, NULL, 'Rrf2-type HTH domain signature.', NULL, 'HTH_RRF2_1', NULL, NULL, 26919, 14);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(280534, NULL, 'PS00168', NULL, NULL, 'Tryptophan synthase beta chain pyridoxal-phosphate attachment site.', NULL, 'TRP_SYNTHASE_BETA', NULL, NULL, 1081, 14),
(280535, NULL, 'PS00495', NULL, NULL, 'Apple domain.', NULL, 'APPLE', NULL, NULL, 1620, 14),
(280536, NULL, 'PS00579', NULL, NULL, 'Ribosomal protein L29 signature.', NULL, 'RIBOSOMAL_L29', NULL, NULL, 19941, 14),
(280537, NULL, 'PS01320', NULL, NULL, 'Uncharacterized protein family UPF0067 signature.', NULL, 'UPF0067', NULL, NULL, 5870, 14),
(280538, NULL, 'PS00827', NULL, NULL, 'MARCKS family phosphorylation site domain.', NULL, 'MARCKS_2', NULL, NULL, 1309, 14),
(280539, NULL, 'PS01003', NULL, NULL, 'Translationally controlled tumor protein (TCTP) domain signature 2.', NULL, 'TCTP_2', NULL, NULL, 13877, 14),
(280540, NULL, 'PS01139', NULL, NULL, 'Bacterial microcompartment (BMC) domain signature.', NULL, 'BMC_1', NULL, NULL, 21394, 14),
(280541, NULL, 'PS01153', NULL, NULL, 'NOL1/NOP2/sun family signature.', NULL, 'NOL1_NOP2_SUN', NULL, NULL, 8437, 14),
(280542, NULL, 'PS00318', NULL, NULL, 'Hydroxymethylglutaryl-coenzyme A reductases signature 2.', NULL, 'HMG_COA_REDUCTASE_2', NULL, NULL, 15019, 14),
(280543, NULL, 'PS00859', NULL, NULL, 'GTP cyclohydrolase I signature 1.', NULL, 'GTP_CYCLOHYDROL_1_1', NULL, NULL, 7604, 14),
(280544, NULL, 'PS00502', NULL, NULL, 'Polygalacturonase active site.', NULL, 'POLYGALACTURONASE', NULL, NULL, 3730, 14),
(280545, NULL, 'PS00868', NULL, NULL, 'Cys/Met metabolism enzymes pyridoxal-phosphate attachment site.', NULL, 'CYS_MET_METAB_PP', NULL, NULL, 877, 14),
(280546, NULL, 'PS60026', NULL, NULL, 'Ergtoxin family signature.', NULL, 'ERGTX', NULL, NULL, 9601, 14),
(280547, NULL, 'PS01056', NULL, NULL, 'NAD-dependent DNA ligase signature 2.', NULL, 'DNA_LIGASE_N2', NULL, NULL, 31487, 14),
(280548, NULL, 'PS01189', NULL, NULL, 'Ribosomal protein S12e signature.', NULL, 'RIBOSOMAL_S12E', NULL, NULL, 5896, 14),
(280549, NULL, 'PS00457', NULL, NULL, 'Sodium:solute symporter family signature 2.', NULL, 'NA_SOLUT_SYMP_2', NULL, NULL, 7726, 14),
(280550, NULL, 'PS00291', NULL, NULL, 'Prion protein signature 1.', NULL, 'PRION_1', NULL, NULL, 15819, 14),
(280551, NULL, 'PS01106', NULL, NULL, 'Ribosomal protein L18e signature.', NULL, 'RIBOSOMAL_L18E', NULL, NULL, 15447, 14),
(280552, NULL, 'PS00045', NULL, NULL, 'Bacterial histone-like DNA-binding proteins signature.', NULL, 'HISTONE_LIKE', NULL, NULL, 21297, 14),
(280553, NULL, 'PS00517', NULL, NULL, 'Ribonuclease III family signature.', NULL, 'RNASE_3_1', NULL, NULL, 80, 14),
(280554, NULL, 'PS00900', NULL, NULL, 'Bacteriophage-type RNA polymerase family active site signature 1.', NULL, 'RNA_POL_PHAGE_1', NULL, NULL, 5453, 14),
(280555, NULL, 'PS00112', NULL, NULL, 'Phosphagen kinase active site signature.', NULL, 'PHOSPHAGEN_KINASE', NULL, NULL, 15769, 14),
(280556, NULL, 'PS00077', NULL, NULL, 'Heme-copper oxidase catalytic subunit, copper B binding region signature.', NULL, 'COX1_CUB', NULL, NULL, 19700, 14),
(280557, NULL, 'PS00234', NULL, NULL, 'Gas vesicles protein GVPa signature 1.', NULL, 'GAS_VESICLE_A_1', NULL, NULL, 9480, 14),
(280558, NULL, 'PS00915', NULL, NULL, 'Phosphatidylinositol 3- and 4-kinases signature 1.', NULL, 'PI3_4_KINASE_1', NULL, NULL, 9400, 14),
(280559, NULL, 'PS01052', NULL, NULL, 'Calponin-like repeat signature.', NULL, 'CALPONIN_1', NULL, NULL, 5785, 14),
(280560, NULL, 'PS00354', NULL, NULL, 'HMG-I and HMG-Y DNA-binding domain (A+T-hook).', NULL, 'HMGI_Y', NULL, NULL, 3869, 14),
(280561, NULL, 'PS00267', NULL, NULL, 'Tachykinin family signature.', NULL, 'TACHYKININ', NULL, NULL, 7413, 14),
(280562, NULL, 'PS00956', NULL, NULL, 'Fungal hydrophobins signature.', NULL, 'HYDROPHOBIN', NULL, NULL, 19544, 14),
(280563, NULL, 'PS00539', NULL, NULL, 'Pyrokinins signature.', NULL, 'PYROKININ', NULL, NULL, 6092, 14),
(280564, NULL, 'PS00375', NULL, NULL, 'UDP-glycosyltransferases signature.', NULL, 'UDPGT', NULL, NULL, 31777, 14),
(280565, NULL, 'PS01205', NULL, NULL, 'Iodothyronine deiodinases active site.', NULL, 'T4_DEIODINASE', NULL, NULL, 8679, 14);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(280566, NULL, 'PS00120', NULL, NULL, 'Lipases, serine active site.', NULL, 'LIPASE_SER', NULL, NULL, NULL, 14),
(280567, NULL, 'PS00232', NULL, NULL, 'Cadherin domain signature.', NULL, 'CADHERIN_1', NULL, NULL, 19632, 14),
(280568, NULL, 'PS00822', NULL, NULL, 'Cytochrome c and c1 heme lyases signature 2.', NULL, 'CYTO_HEME_LYASE_2', NULL, NULL, 6567, 14),
(280569, NULL, 'PS00078', NULL, NULL, 'CO II and nitrous oxide reductase dinuclear copper centers signature.', NULL, 'COX2', NULL, NULL, 3108, 14),
(280570, NULL, 'PS00110', NULL, NULL, 'Pyruvate kinase active site signature.', NULL, 'PYRUVATE_KINASE', NULL, NULL, 7780, 14),
(280571, NULL, 'PS00451', NULL, NULL, 'Pathogenesis-related proteins Bet v I family signature.', NULL, 'PATHOGENESIS_BETVI', NULL, NULL, 24848, 14),
(280572, NULL, 'PS60016', NULL, NULL, 'Omega-atracotoxin (ACTX) type 1 family signature.', NULL, 'OMEGA_ACTX_1', NULL, NULL, 19949, 14),
(280573, NULL, 'PS00152', NULL, NULL, 'ATP synthase alpha and beta subunits signature.', NULL, 'ATPASE_ALPHA_BETA', NULL, NULL, 16797, 14),
(280574, NULL, 'PS00463', NULL, NULL, 'Zn(2)-C6 fungal-type DNA-binding domain signature.', NULL, 'ZN2_CY6_FUNGAL_1', NULL, NULL, 2419, 14),
(280575, NULL, 'PS00776', NULL, NULL, 'Glycosyl hydrolases family 11 (GH11) active site signature 1.', NULL, 'GH11_1', NULL, NULL, 7972, 14),
(280576, NULL, 'PS01013', NULL, NULL, 'Oxysterol-binding protein family signature.', NULL, 'OSBP', NULL, NULL, 9157, 14),
(280577, NULL, 'PS01025', NULL, NULL, 'Protein phosphatase 2A regulatory subunit PR55 signature 2.', NULL, 'PR55_2', NULL, NULL, 19233, 14),
(280578, NULL, 'PS01035', NULL, NULL, 'PTS EIIB domains cysteine phosphorylation site signature.', NULL, 'PTS_EIIB_TYPE_1_CYS', NULL, NULL, 944, 14),
(280579, NULL, 'PS00118', NULL, NULL, 'Phospholipase A2 histidine active site.', NULL, 'PA2_HIS', NULL, NULL, 29043, 14),
(280580, NULL, 'PS00367', NULL, NULL, 'Biopterin-dependent aromatic amino acid hydroxylases signature.', NULL, 'BH4_AAA_HYDROXYL_1', NULL, NULL, 16726, 14),
(280581, NULL, 'PS00348', NULL, NULL, 'p53 family signature.', NULL, 'P53', NULL, NULL, 1310, 14),
(280582, NULL, 'PS01333', NULL, NULL, 'Pyrrolidone-carboxylate peptidase glutamic acid active site.', NULL, 'PYRASE_GLU', NULL, NULL, 28033, 14),
(280583, NULL, 'PS00083', NULL, NULL, 'Intradiol ring-cleavage dioxygenases signature.', NULL, 'INTRADIOL_DIOXYGENAS', NULL, NULL, 5654, 14),
(280584, NULL, 'PS00380', NULL, NULL, 'Rhodanese signature 1.', NULL, 'RHODANESE_1', NULL, NULL, 308, 14),
(280585, NULL, 'PS00966', NULL, NULL, 'Phosphomannose isomerase type I signature 2.', NULL, 'PMI_I_2', NULL, NULL, 14614, 14),
(280586, NULL, 'PS00873', NULL, NULL, 'Sodium:alanine symporter family signature.', NULL, 'NA_ALANINE_SYMP', NULL, NULL, 3009, 14),
(280587, NULL, 'PS00739', NULL, NULL, 'S-adenosyl-L-homocysteine hydrolase signature 2.', NULL, 'ADOHCYASE_2', NULL, NULL, 16006, 14),
(280588, NULL, 'PS00547', NULL, NULL, 'Transglutaminases active site.', NULL, 'TRANSGLUTAMINASES', NULL, NULL, 7995, 14),
(280589, NULL, 'PS01263', NULL, NULL, 'Uncharacterized protein family UPF0021 signature.', NULL, 'UPF0021', NULL, NULL, 14514, 14),
(280590, NULL, 'PS00065', NULL, NULL, 'D-isomer specific 2-hydroxyacid dehydrogenases NAD-binding signature.', NULL, 'D_2_HYDROXYACID_DH_1', NULL, NULL, 25078, 14),
(280591, NULL, 'PS01077', NULL, NULL, 'Ribosomal protein L37e signature.', NULL, 'RIBOSOMAL_L37E', NULL, NULL, 19549, 14),
(280592, NULL, 'PS00131', NULL, NULL, 'Serine carboxypeptidases, serine active site.', NULL, 'CARBOXYPEPT_SER_SER', NULL, NULL, 7750, 14),
(280593, NULL, 'PS01142', NULL, NULL, 'Bacterial type II secretion system protein N signature.', NULL, 'T2SP_N', NULL, NULL, 6834, 14),
(280594, NULL, 'PS00756', NULL, NULL, 'Protein secY signature 2.', NULL, 'SECY_2', NULL, NULL, 23767, 14),
(280595, NULL, 'PS00802', NULL, NULL, 'Transketolase signature 2.', NULL, 'TRANSKETOLASE_2', NULL, NULL, 21428, 14),
(280596, NULL, 'PS00644', NULL, NULL, 'Respiratory-chain NADH dehydrogenase 51 Kd subunit signature 1.', NULL, 'COMPLEX1_51K_1', NULL, NULL, 2462, 14); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(280597, NULL, 'PS00327', NULL, NULL, 'Bacterial rhodopsins retinal binding site.', NULL, 'BACTERIAL_OPSIN_RET', NULL, NULL, 7911, 14),
(280598, NULL, 'PS00925', NULL, NULL, 'Pollen proteins Ole e I family signature.', NULL, 'OLEEI', NULL, NULL, 2924, 14),
(280599, NULL, 'PS01296', NULL, NULL, 'RsmI AdoMet-dependent methyltransferase protein family signature.', NULL, 'RSMI', NULL, NULL, 19522, 14),
(280600, NULL, 'PS01255', NULL, NULL, 'Fetuin family signature 2.', NULL, 'FETUIN_2', NULL, NULL, 7061, 14),
(280601, NULL, 'PS00158', NULL, NULL, 'Fructose-bisphosphate aldolase class-I active site.', NULL, 'ALDOLASE_CLASS_I', NULL, NULL, 25096, 14),
(280602, NULL, 'PS00170', NULL, NULL, 'Cyclophilin-type peptidyl-prolyl cis-trans isomerase signature.', NULL, 'CSA_PPIASE_1', NULL, NULL, 19799, 14),
(280603, NULL, 'PS00887', NULL, NULL, 'Dihydroxy-acid and 6-phosphogluconate dehydratases signature 2.', NULL, 'ILVD_EDD_2', NULL, NULL, 14834, 14),
(280604, NULL, 'PS00236', NULL, NULL, 'Neurotransmitter-gated ion-channels signature.', NULL, 'NEUROTR_ION_CHANNEL', NULL, NULL, 12637, 14),
(280605, NULL, 'PS01195', NULL, NULL, 'Peptidyl-tRNA hydrolase signature 1.', NULL, 'PEPT_TRNA_HYDROL_1', NULL, NULL, 11880, 14),
(280606, NULL, 'PS01269', NULL, NULL, 'Uncharacterized protein family UPF0025 signature.', NULL, 'UPF0025', NULL, NULL, 14978, 14),
(280607, NULL, 'PS00263', NULL, NULL, 'Natriuretic peptides signature.', NULL, 'NATRIURETIC_PEPTIDE', NULL, NULL, 23210, 14),
(280608, NULL, 'PS01081', NULL, NULL, 'TetR-type HTH domain signature.', NULL, 'HTH_TETR_1', NULL, NULL, 5685, 14),
(280609, NULL, 'PS00228', NULL, NULL, 'Tubulin-beta mRNA autoregulation signal.', NULL, 'TUBULIN_B_AUTOREG', NULL, NULL, 12756, 14),
(280610, NULL, 'PS00558', NULL, NULL, 'Eukaryotic mitochondrial porin signature.', NULL, 'EUKARYOTIC_PORIN', NULL, NULL, 4260, 14),
(280611, NULL, 'PS00238', NULL, NULL, 'Visual pigments (opsins) retinal binding site.', NULL, 'OPSIN', NULL, NULL, 25141, 14),
(280612, NULL, 'PS00548', NULL, NULL, 'Ribosomal protein S3 signature.', NULL, 'RIBOSOMAL_S3', NULL, NULL, 19907, 14),
(280613, NULL, 'PS00636', NULL, NULL, 'Nt-dnaJ domain signature.', NULL, 'DNAJ_1', NULL, NULL, 19814, 14),
(280614, NULL, 'PS00648', NULL, NULL, 'Bacterial ribonuclease P protein component signature.', NULL, 'RIBONUCLEASE_P', NULL, NULL, 14850, 14),
(280615, NULL, 'PS00872', NULL, NULL, 'Sodium:galactoside symporter family signature.', NULL, 'NA_GALACTOSIDE_SYMP', NULL, NULL, 19142, 14),
(280616, NULL, 'PS00329', NULL, NULL, 'Heat shock hsp70 proteins family signature 2.', NULL, 'HSP70_2', NULL, NULL, 7642, 14),
(280617, NULL, 'PS01108', NULL, NULL, 'Ribosomal protein L24 signature.', NULL, 'RIBOSOMAL_L24', NULL, NULL, 5649, 14),
(280618, NULL, 'PS01292', NULL, NULL, 'Uncharacterized protein family UPF0036 signature.', NULL, 'UPF0036', NULL, NULL, 3002, 14),
(280619, NULL, 'PS00302', NULL, NULL, 'Eukaryotic initiation factor 5A hypusine signature.', NULL, 'IF5A_HYPUSINE', NULL, NULL, 20896, 14),
(280620, NULL, 'PS00568', NULL, NULL, 'Myelin P0 protein signature.', NULL, 'MYELIN_P0', NULL, NULL, 12586, 14),
(280621, NULL, 'PS01310', NULL, NULL, 'FXYD family signature.', NULL, 'FXYD', NULL, NULL, 653, 14),
(280622, NULL, 'PS00146', NULL, NULL, 'Beta-lactamase class-A active site.', NULL, 'BETA_LACTAMASE_A', NULL, NULL, 501, 14),
(280623, NULL, 'PS00351', NULL, NULL, 'Transcription factor TFIID repeat signature.', NULL, 'TFIID', NULL, NULL, 21792, 14),
(280624, NULL, 'PS00590', NULL, NULL, 'LIF / OSM family signature.', NULL, 'LIF_OSM', NULL, NULL, 17287, 14),
(280625, NULL, 'PS00842', NULL, NULL, 'XPG protein signature 2.', NULL, 'XPG_2', NULL, NULL, 15610, 14),
(280626, NULL, 'PS00032', NULL, NULL, '''Homeobox'' antennapedia-type protein signature.', NULL, 'ANTENNAPEDIA', NULL, NULL, 4431, 14),
(280627, NULL, 'PS01152', NULL, NULL, 'Hypothetical hesB/yadR/yfhF family signature.', NULL, 'HESB', NULL, NULL, 12533, 14),
(280628, NULL, 'PS00950', NULL, NULL, 'Bacterial rhodopsins signature 1.', NULL, 'BACTERIAL_OPSIN_1', NULL, NULL, 7911, 14);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(280629, NULL, 'PS01023', NULL, NULL, 'PTR2 family proton/oligopeptide symporters signature 2.', NULL, 'PTR2_2', NULL, NULL, 9236, 14),
(280630, NULL, 'PS00184', NULL, NULL, 'Phosphoribosylglycinamide synthetase signature.', NULL, 'GARS', NULL, NULL, 14585, 14),
(280631, NULL, 'PS00141', NULL, NULL, 'Eukaryotic and viral aspartyl proteases active site.', NULL, 'ASP_PROTEASE', NULL, NULL, 2401, 14),
(280632, NULL, 'PS00991', NULL, NULL, 'Clathrin adaptor complexes medium chain signature 2.', NULL, 'CLAT_ADAPTOR_M_2', NULL, NULL, 8300, 14),
(280633, NULL, 'PS01207', NULL, NULL, 'Glypicans signature.', NULL, 'GLYPICAN', NULL, NULL, 17316, 14),
(280634, NULL, 'PS01094', NULL, NULL, 'Uncharacterized protein family UPF0076 signature.', NULL, 'UPF0076', NULL, NULL, 14677, 14),
(280635, NULL, 'PS00572', NULL, NULL, 'Glycosyl hydrolases family 1 active site.', NULL, 'GLYCOSYL_HYDROL_F1_1', NULL, NULL, 18931, 14),
(280636, NULL, 'PS00995', NULL, NULL, 'Chaperonins TCP-1 signature 3.', NULL, 'TCP1_3', NULL, NULL, 467, 14),
(280637, NULL, 'PS00081', NULL, NULL, 'Lipoxygenases iron-binding region signature 2.', NULL, 'LIPOXYGENASE_2', NULL, NULL, 20961, 14),
(280638, NULL, 'PS00185', NULL, NULL, 'Isopenicillin N synthase signature 1.', NULL, 'IPNS_1', NULL, NULL, 5127, 14),
(280639, NULL, 'PS00936', NULL, NULL, 'Ribosomal protein L35 signature.', NULL, 'RIBOSOMAL_L35', NULL, NULL, 19972, 14),
(280640, NULL, 'PS00917', NULL, NULL, 'Asparaginase / glutaminase active site signature 2.', NULL, 'ASN_GLN_ASE_2', NULL, NULL, 24741, 14),
(280641, NULL, 'PS01241', NULL, NULL, 'Link domain signature.', NULL, 'LINK_1', NULL, NULL, 5528, 14),
(280642, NULL, 'PS00981', NULL, NULL, 'G-protein coupled receptors family 3 signature 3.', NULL, 'G_PROTEIN_RECEP_F3_3', NULL, NULL, 19495, 14),
(280643, NULL, 'PS01235', NULL, NULL, 'PdxS/SNZ family signature.', NULL, 'PDXS_SNZ_1', NULL, NULL, 4143, 14),
(280644, NULL, 'PS01074', NULL, NULL, 'Terpene synthases signature.', NULL, 'TERPENE_SYNTHASES', NULL, NULL, 6282, 14),
(280645, NULL, 'PS01285', NULL, NULL, 'Coagulation factors 5/8 type C domain (FA58C) signature 1.', NULL, 'FA58C_1', NULL, NULL, 4934, 14),
(280646, NULL, 'PS00014', NULL, NULL, 'Endoplasmic reticulum targeting sequence.', NULL, 'ER_TARGET', NULL, NULL, NULL, 14),
(280647, NULL, 'PS00911', NULL, NULL, 'Dihydroorotate dehydrogenase signature 1.', NULL, 'DHODEHASE_1', NULL, NULL, 589, 14),
(280648, NULL, 'PS00116', NULL, NULL, 'DNA polymerase family B signature.', NULL, 'DNA_POLYMERASE_B', NULL, NULL, 7488, 14),
(280649, NULL, 'PS00989', NULL, NULL, 'Clathrin adaptor complexes small chain signature.', NULL, 'CLAT_ADAPTOR_S', NULL, NULL, 6666, 14),
(280650, NULL, 'PS00243', NULL, NULL, 'Integrins beta chain cysteine-rich domain signature.', NULL, 'INTEGRIN_BETA', NULL, NULL, 12563, 14),
(280651, NULL, 'PS00382', NULL, NULL, 'Endopeptidase Clp histidine active site.', NULL, 'CLP_PROTEASE_HIS', NULL, NULL, 28392, 14),
(280652, NULL, 'PS00564', NULL, NULL, 'Argininosuccinate synthase signature 1.', NULL, 'ARGININOSUCCIN_SYN_1', NULL, NULL, 7986, 14),
(280653, NULL, 'PS01297', NULL, NULL, 'FLAP/GST2/LTC4S family signature.', NULL, 'FLAP_GST2_LTC4S', NULL, NULL, 16901, 14),
(280654, NULL, 'PS60010', NULL, NULL, 'Assassin bug toxin signature.', NULL, 'ASSASSIN_BUG_TOXIN', NULL, NULL, 11664, 14),
(280655, NULL, 'PS01158', NULL, NULL, 'Macrophage migration inhibitory factor family signature.', NULL, 'MIF', NULL, NULL, 17067, 14),
(280656, NULL, 'PS00600', NULL, NULL, 'Aminotransferases class-III pyridoxal-phosphate attachment site.', NULL, 'AA_TRANSFER_CLASS_3', NULL, NULL, 5655, 14),
(280657, NULL, 'PS01226', NULL, NULL, 'Hydroxymethylglutaryl-coenzyme A synthase active site.', NULL, 'HMG_COA_SYNTHASE', NULL, NULL, 5953, 14),
(280658, NULL, 'PS00233', NULL, NULL, 'Chitin-binding type R&R domain signature.', NULL, 'CHIT_BIND_RR_1', NULL, NULL, 25142, 14),
(280659, NULL, 'PS00943', NULL, NULL, 'UbiA prenyltransferase family signature.', NULL, 'UBIA', NULL, NULL, 23928, 14),
(280660, NULL, 'PS00455', NULL, NULL, 'Putative AMP-binding domain signature.', NULL, 'AMP_BINDING', NULL, NULL, 20527, 14);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(280661, NULL, 'PS00154', NULL, NULL, 'E1-E2 ATPases phosphorylation site.', NULL, 'ATPASE_E1_E2', NULL, NULL, 16521, 14),
(280662, NULL, 'PS01166', NULL, NULL, 'RNA polymerases beta chain signature.', NULL, 'RNA_POL_BETA', NULL, NULL, 440, 14),
(280663, NULL, 'PS01093', NULL, NULL, 'Adenylate cyclase class-I signature 2.', NULL, 'ADENYLATE_CYCLASE_1_2', NULL, NULL, 24866, 14),
(280664, NULL, 'PS01304', NULL, NULL, 'ubiH/COQ6 monooxygenase family signature.', NULL, 'UBIH', NULL, NULL, 7824, 14),
(280665, NULL, 'PS00396', NULL, NULL, 'Prokaryotic DNA topoisomerase I active site.', NULL, 'TOPOISOMERASE_I_PROK', NULL, NULL, 16016, 14),
(280666, NULL, 'PS00746', NULL, NULL, 'NifH/frxC family signature 1.', NULL, 'NIFH_FRXC_1', NULL, NULL, 26924, 14),
(280667, NULL, 'PS60011', NULL, NULL, 'Plant C6 type antimicrobial peptide (AMP) signature.', NULL, 'PLANT_C6_AMP', NULL, NULL, 18684, 14),
(280668, NULL, 'PS00518', NULL, NULL, 'Zinc finger RING-type signature.', NULL, 'ZF_RING_1', NULL, NULL, 2514, 14),
(280669, NULL, 'PS00701', NULL, NULL, 'Ribosomal protein L16 signature 2.', NULL, 'RIBOSOMAL_L16_2', NULL, NULL, 20119, 14),
(280670, NULL, 'PS01336', NULL, NULL, 'S-adenosylmethionine decarboxylase signature.', NULL, 'ADOMETDC', NULL, NULL, 19785, 14),
(280671, NULL, 'PS00409', NULL, NULL, 'Prokaryotic N-terminal methylation site.', NULL, 'PROKAR_NTER_METHYL', NULL, NULL, 13342, 14),
(280672, NULL, 'PS01303', NULL, NULL, 'BCCT family of transporters signature.', NULL, 'BCCT', NULL, NULL, 20637, 14),
(280673, NULL, 'PS00588', NULL, NULL, 'Flagella basal body rod proteins signature.', NULL, 'FLAGELLA_BB_ROD', NULL, NULL, 19936, 14),
(280674, NULL, 'PS00114', NULL, NULL, 'Phosphoribosyl pyrophosphate synthase signature.', NULL, 'PRPP_SYNTHASE', NULL, NULL, 4503, 14),
(280675, NULL, 'PS00472', NULL, NULL, 'Small cytokines (intercrine/chemokine) C-C subfamily signature.', NULL, 'SMALL_CYTOKINES_CC', NULL, NULL, 369, 14),
(280676, NULL, 'PS00516', NULL, NULL, 'Alkylbase DNA glycosidases alkA family signature.', NULL, 'ALKYLBASE_DNA_GLYCOS', NULL, NULL, 3548, 14),
(280677, NULL, 'PS00920', NULL, NULL, 'Nitrilases / cyanide hydratase signature 1.', NULL, 'NITRIL_CHT_1', NULL, NULL, 1702, 14),
(280678, NULL, 'PS00631', NULL, NULL, 'Cytosol aminopeptidase signature.', NULL, 'CYTOSOL_AP', NULL, NULL, 311, 14),
(280679, NULL, 'PS00937', NULL, NULL, 'Ribosomal protein L20 signature.', NULL, 'RIBOSOMAL_L20', NULL, NULL, 5975, 14),
(280680, NULL, 'PS01150', NULL, NULL, 'Respiratory-chain NADH dehydrogenase 20 Kd subunit signature.', NULL, 'COMPLEX1_20K', NULL, NULL, 10454, 14),
(280681, NULL, 'PS00924', NULL, NULL, 'Aspartate and glutamate racemases signature 2.', NULL, 'ASP_GLU_RACEMASE_2', NULL, NULL, 27637, 14),
(280682, NULL, 'PS00670', NULL, NULL, 'D-isomer specific 2-hydroxyacid dehydrogenases signature 2.', NULL, 'D_2_HYDROXYACID_DH_2', NULL, NULL, 25496, 14),
(280683, NULL, 'PS00972', NULL, NULL, 'Ubiquitin specific protease (USP) domain signature 1.', NULL, 'USP_1', NULL, NULL, 14760, 14),
(280684, NULL, 'PS00437', NULL, NULL, 'Catalase proximal heme-ligand signature.', NULL, 'CATALASE_1', NULL, NULL, 155, 14),
(280685, NULL, 'PS01359', NULL, NULL, 'Zinc finger PHD-type signature.', NULL, 'ZF_PHD_1', NULL, NULL, 14631, 14),
(280686, NULL, 'PS00240', NULL, NULL, 'Receptor tyrosine kinase class III signature.', NULL, 'RECEPTOR_TYR_KIN_III', NULL, NULL, 4375, 14),
(280687, NULL, 'PS00947', NULL, NULL, 'Cathelicidins signature 2.', NULL, 'CATHELICIDINS_2', NULL, NULL, 7878, 14),
(280688, NULL, 'PS00531', NULL, NULL, 'Ribonuclease T2 family histidine active site 2.', NULL, 'RNASE_T2_2', NULL, NULL, 27647, 14),
(280689, NULL, 'PS00514', NULL, NULL, 'Fibrinogen C-terminal domain signature.', NULL, 'FIBRINOGEN_C_1', NULL, NULL, 20842, 14),
(280690, NULL, 'PS00553', NULL, NULL, 'Lambdoid phages regulatory protein CIII signature.', NULL, 'LAMBDA_PHAGE_CIII', NULL, NULL, 11038, 14),
(280691, NULL, 'PS01182', NULL, NULL, 'Glycosyl hydrolases family 35 putative active site.', NULL, 'GLYCOSYL_HYDROL_F35', NULL, NULL, 17307, 14);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(280692, NULL, 'PS00347', NULL, NULL, 'Poly(ADP-ribose) polymerase zinc finger domain signature.', NULL, 'PARP_ZN_FINGER_1', NULL, NULL, 3246, 14),
(280693, NULL, 'PS00361', NULL, NULL, 'Ribosomal protein S10 signature.', NULL, 'RIBOSOMAL_S10', NULL, NULL, 19758, 14),
(280694, NULL, 'PS00642', NULL, NULL, 'Respiratory-chain NADH dehydrogenase 75 Kd subunit signature 2.', NULL, 'COMPLEX1_75K_2', NULL, NULL, 622, 14),
(280695, NULL, 'PS01048', NULL, NULL, 'Ribosomal protein S6 signature.', NULL, 'RIBOSOMAL_S6', NULL, NULL, 21078, 14),
(280696, NULL, 'PS01128', NULL, NULL, 'Shikimate kinase signature.', NULL, 'SHIKIMATE_KINASE', NULL, NULL, 15053, 14),
(280697, NULL, 'PS00803', NULL, NULL, 'Calreticulin family signature 1.', NULL, 'CALRETICULIN_1', NULL, NULL, 18627, 14),
(280698, NULL, 'PS00977', NULL, NULL, 'FAD-dependent glycerol-3-phosphate dehydrogenase signature 1.', NULL, 'FAD_G3PDH_1', NULL, NULL, 5998, 14),
(280699, NULL, 'PS00298', NULL, NULL, 'Heat shock hsp90 proteins family signature.', NULL, 'HSP90', NULL, NULL, 17299, 14),
(280700, NULL, 'PS00016', NULL, NULL, 'Cell attachment sequence.', NULL, 'RGD', NULL, NULL, NULL, 14),
(280701, NULL, 'PS00161', NULL, NULL, 'Isocitrate lyase signature.', NULL, 'ISOCITRATE_LYASE', NULL, NULL, 19447, 14),
(280702, NULL, 'PS00406', NULL, NULL, 'Actins signature 1.', NULL, 'ACTINS_1', NULL, NULL, 772, 14),
(280703, NULL, 'PS00315', NULL, NULL, 'Dehydrins signature 1.', NULL, 'DEHYDRIN_1', NULL, NULL, 24844, 14),
(280704, NULL, 'PS00909', NULL, NULL, 'Mandelate racemase / muconate lactonizing enzyme family signature 2.', NULL, 'MR_MLE_2', NULL, NULL, 13681, 14),
(280705, NULL, 'PS01064', NULL, NULL, 'Pyridoxamine 5''-phosphate oxidase signature.', NULL, 'PYRIDOX_OXIDASE', NULL, NULL, 12946, 14),
(280706, NULL, 'PS01070', NULL, NULL, 'DNA/RNA non-specific endonucleases active site.', NULL, 'NUCLEASE_NON_SPEC', NULL, NULL, 19955, 14),
(280707, NULL, 'PS00619', NULL, NULL, 'PTN/MK heparin-binding protein family signature 1.', NULL, 'PTN_MK_1', NULL, NULL, 16226, 14),
(280708, NULL, 'PS01104', NULL, NULL, 'Ribosomal protein L13e signature.', NULL, 'RIBOSOMAL_L13E', NULL, NULL, 19612, 14),
(280709, NULL, 'PS00073', NULL, NULL, 'Acyl-CoA dehydrogenases signature 2.', NULL, 'ACYL_COA_DH_2', NULL, NULL, 2691, 14),
(280710, NULL, 'PS00962', NULL, NULL, 'Ribosomal protein S2 signature 1.', NULL, 'RIBOSOMAL_S2_1', NULL, NULL, 19613, 14),
(280711, NULL, 'PS00708', NULL, NULL, 'Prolyl endopeptidase family serine active site.', NULL, 'PRO_ENDOPEP_SER', NULL, NULL, 6714, 14),
(280712, NULL, 'PS01317', NULL, NULL, 'SsrA-binding protein.', NULL, 'SSRP', NULL, NULL, 16030, 14),
(280713, NULL, 'PS00665', NULL, NULL, 'Dihydrodipicolinate synthase signature 1.', NULL, 'DHDPS_1', NULL, NULL, 20483, 14),
(280714, NULL, 'PS00781', NULL, NULL, 'Phosphoenolpyruvate carboxylase active site 1.', NULL, 'PEPCASE_1', NULL, NULL, 12891, 14),
(280715, NULL, 'PS01041', NULL, NULL, 'Stathmin family signature 2.', NULL, 'STATHMIN_2', NULL, NULL, 24698, 14),
(280716, NULL, 'PS01271', NULL, NULL, 'Sodium:sulfate symporter family signature.', NULL, 'NA_SULFATE', NULL, NULL, 12680, 14),
(280717, NULL, 'PS00222', NULL, NULL, 'Insulin-like growth factor-binding protein (IGFBP) N-terminal domain signature.', NULL, 'IGFBP_N_1', NULL, NULL, 7737, 14),
(280718, NULL, 'PS00297', NULL, NULL, 'Heat shock hsp70 proteins family signature 1.', NULL, 'HSP70_1', NULL, NULL, 7642, 14),
(280719, NULL, 'PS00392', NULL, NULL, 'DDC / GAD / HDC / TyrDC pyridoxal-phosphate attachment site.', NULL, 'DDC_GAD_HDC_YDC', NULL, NULL, 19503, 14),
(280720, NULL, 'PS00422', NULL, NULL, 'Granins signature 1.', NULL, 'GRANINS_1', NULL, NULL, 19007, 14),
(280721, NULL, 'PS00139', NULL, NULL, 'Eukaryotic thiol (cysteine) proteases cysteine active site.', NULL, 'THIOL_PROTEASE_CYS', NULL, NULL, 3915, 14),
(280722, NULL, 'PS00140', NULL, NULL, 'Ubiquitin carboxyl-terminal hydrolase family 1 cysteine active-site.', NULL, 'UCH_1', NULL, NULL, 3443, 14),
(280723, NULL, 'PS00322', NULL, NULL, 'Histone H3 signature 1.', NULL, 'HISTONE_H3_1', NULL, NULL, 1526, 14);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(280724, NULL, 'PS00245', NULL, NULL, 'Phytochrome chromophore attachment site signature.', NULL, 'PHYTOCHROME_1', NULL, NULL, 9822, 14),
(280725, NULL, 'PS00639', NULL, NULL, 'Eukaryotic thiol (cysteine) proteases histidine active site.', NULL, 'THIOL_PROTEASE_HIS', NULL, NULL, 26409, 14),
(280726, NULL, 'PS00541', NULL, NULL, 'Nuclear transition protein 1 signature.', NULL, 'TP1', NULL, NULL, 17941, 14),
(280727, NULL, 'PS60022', NULL, NULL, 'Huwentoxin-2 family signature.', NULL, 'HWTX_2', NULL, NULL, 9700, 14),
(280728, NULL, 'PS01054', NULL, NULL, 'Transaldolase signature 1.', NULL, 'TRANSALDOLASE_1', NULL, NULL, 7782, 14),
(280729, NULL, 'PS00301', NULL, NULL, 'Translational (tr)-type guanine nucleotide-binding (G) domain signature.', NULL, 'G_TR_1', NULL, NULL, 25402, 14),
(280730, NULL, 'PS00919', NULL, NULL, 'Deoxyribonuclease I signature 1.', NULL, 'DNASE_I_1', NULL, NULL, 19812, 14),
(280731, NULL, 'PS00955', NULL, NULL, 'Imidazoleglycerol-phosphate dehydratase signature 2.', NULL, 'IGP_DEHYDRATASE_2', NULL, NULL, 18604, 14),
(280732, NULL, 'PS01212', NULL, NULL, 'ATP P2X receptors signature.', NULL, 'P2X_RECEPTOR', NULL, NULL, 6799, 14),
(280733, NULL, 'PS00757', NULL, NULL, 'Prokaryotic sulfate-binding proteins signature 2.', NULL, 'PROK_SULFATE_BIND_2', NULL, NULL, 32387, 14),
(280734, NULL, 'PS01086', NULL, NULL, 'Ribulose-phosphate 3-epimerase family signature 2.', NULL, 'RIBUL_P_3_EPIMER_2', NULL, NULL, 2990, 14),
(280735, NULL, 'PS01258', NULL, NULL, 'Apoptosis regulator, Bcl-2 family BH2 motif signature.', NULL, 'BH2', NULL, NULL, 19303, 14),
(280736, NULL, 'PS01063', NULL, NULL, 'Sigma-70 factors ECF subfamily signature.', NULL, 'SIGMA70_ECF', NULL, NULL, 4921, 14),
(280737, NULL, 'PS01185', NULL, NULL, 'C-terminal cystine knot signature.', NULL, 'CTCK_1', NULL, NULL, 11169, 14),
(280738, NULL, 'PS00119', NULL, NULL, 'Phospholipase A2 aspartic acid active site.', NULL, 'PA2_ASP', NULL, NULL, 29104, 14),
(280739, NULL, 'PS00885', NULL, NULL, 'EPSP synthase signature 2.', NULL, 'EPSP_SYNTHASE_2', NULL, NULL, 17426, 14),
(280740, NULL, 'PS01194', NULL, NULL, 'Ribosomal protein L15e signature.', NULL, 'RIBOSOMAL_L15E', NULL, NULL, 14553, 14),
(280741, NULL, 'PS00795', NULL, NULL, 'Involucrin signature.', NULL, 'INVOLUCRIN', NULL, NULL, 12559, 14),
(280742, NULL, 'PS00876', NULL, NULL, 'Indoleamine 2,3-dioxygenase signature 1.', NULL, 'IDO_1', NULL, NULL, 3043, 14),
(280743, NULL, 'PS00176', NULL, NULL, 'Eukaryotic DNA topoisomerase I active site.', NULL, 'TOPOISOMERASE_I_EUK', NULL, NULL, 19848, 14),
(280744, NULL, 'PS00330', NULL, NULL, 'Hemolysin-type calcium-binding region signature.', NULL, 'HEMOLYSIN_CALCIUM', NULL, NULL, 14738, 14),
(280745, NULL, 'PS00047', NULL, NULL, 'Histone H4 signature.', NULL, 'HISTONE_H4', NULL, NULL, 17042, 14),
(280746, NULL, 'PS00794', NULL, NULL, '7,8-dihydro-6-hydroxymethylpterin-pyrophosphokinase signature.', NULL, 'HPPK', NULL, NULL, 5865, 14),
(280747, NULL, 'PS00153', NULL, NULL, 'ATP synthase gamma subunit signature.', NULL, 'ATPASE_GAMMA', NULL, NULL, 16556, 14),
(280748, NULL, 'PS01208', NULL, NULL, 'VWFC domain signature.', NULL, 'VWFC_1', NULL, NULL, 2283, 14),
(280749, NULL, 'PS01125', NULL, NULL, 'ROK family signature.', NULL, 'ROK', NULL, NULL, 5948, 14),
(280750, NULL, 'PS00729', NULL, NULL, 'AP endonucleases family 2 signature 1.', NULL, 'AP_NUCLEASE_F2_1', NULL, NULL, 8256, 14),
(280751, NULL, 'PS60002', NULL, NULL, 'Phosphoketolase signature 1.', NULL, 'PHOSPHOKETOLASE_1', NULL, NULL, 17413, 14),
(280752, NULL, 'PS00021', NULL, NULL, 'Kringle domain signature.', NULL, 'KRINGLE_1', NULL, NULL, 13915, 14),
(280753, NULL, 'PS00060', NULL, NULL, 'Iron-containing alcohol dehydrogenases signature 2.', NULL, 'ADH_IRON_2', NULL, NULL, 7858, 14),
(280754, NULL, 'PS00709', NULL, NULL, 'Ribosomal protein L30e signature 1.', NULL, 'RIBOSOMAL_L30E_1', NULL, NULL, 15465, 14),
(280755, NULL, 'PS00082', NULL, NULL, 'Extradiol ring-cleavage dioxygenases signature.', NULL, 'EXTRADIOL_DIOXYGENAS', NULL, NULL, 6707, 14),
(280756, NULL, 'PS00393', NULL, NULL, 'Phosphoenolpyruvate carboxylase active site 2.', NULL, 'PEPCASE_2', NULL, NULL, 27924, 14);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(280757, NULL, 'PS01192', NULL, NULL, 'Hydroxymethylglutaryl-coenzyme A reductases signature 3.', NULL, 'HMG_COA_REDUCTASE_3', NULL, NULL, 15019, 14),
(280758, NULL, 'PS00017', NULL, NULL, 'ATP/GTP-binding site motif A (P-loop).', NULL, 'ATP_GTP_A', NULL, NULL, NULL, 14),
(280759, NULL, 'PS00231', NULL, NULL, 'F-actin capping protein beta subunit signature.', NULL, 'F_ACTIN_CAPPING_BETA', NULL, NULL, 17230, 14),
(280760, NULL, 'PS01057', NULL, NULL, 'SAICAR synthetase signature 1.', NULL, 'SAICAR_SYNTHETASE_1', NULL, NULL, 7982, 14),
(280761, NULL, 'PS00304', NULL, NULL, 'Small, acid-soluble spore proteins, alpha/beta type, signature 1.', NULL, 'SASP_1', NULL, NULL, 18823, 14),
(280762, NULL, 'PS00946', NULL, NULL, 'Cathelicidins signature 1.', NULL, 'CATHELICIDINS_1', NULL, NULL, 7878, 14),
(280763, NULL, 'PS00824', NULL, NULL, 'Elongation factor 1 beta/beta''/delta chain signature 1.', NULL, 'EF1BD_1', NULL, NULL, 2100, 14),
(280764, NULL, 'PS00608', NULL, NULL, 'Glycosyl hydrolases family 2 acid/base catalyst.', NULL, 'GLYCOSYL_HYDROL_F2_2', NULL, NULL, 15635, 14),
(280765, NULL, 'PS00928', NULL, NULL, 'Trehalase signature 2.', NULL, 'TREHALASE_2', NULL, NULL, 7992, 14),
(280766, NULL, 'PS60004', NULL, NULL, 'Omega-conotoxin family signature.', NULL, 'OMEGA_CONOTOXIN', NULL, NULL, 11829, 14),
(280767, NULL, 'PS00583', NULL, NULL, 'pfkB family of carbohydrate kinases signature 1.', NULL, 'PFKB_KINASES_1', NULL, NULL, 259, 14),
(280768, NULL, 'PS01045', NULL, NULL, 'Squalene and phytoene synthases signature 2.', NULL, 'SQUALEN_PHYTOEN_SYN_2', NULL, NULL, 18284, 14),
(280769, NULL, 'PS01291', NULL, NULL, 'NAD:arginine ADP-ribosyltransferases signature.', NULL, 'ART', NULL, NULL, 6541, 14),
(280770, NULL, 'PS00058', NULL, NULL, 'DNA mismatch repair proteins mutL / hexB / PMS1 signature.', NULL, 'DNA_MISMATCH_REPAIR_1', NULL, NULL, 12083, 14),
(280771, NULL, 'PS00099', NULL, NULL, 'Thiolases active site.', NULL, 'THIOLASE_3', NULL, NULL, 20379, 14),
(280772, NULL, 'PS00484', NULL, NULL, 'Thyroglobulin type-1 repeat signature.', NULL, 'THYROGLOBULIN_1_1', NULL, NULL, 6911, 14),
(280773, NULL, 'PS00356', NULL, NULL, 'LacI-type HTH domain signature.', NULL, 'HTH_LACI_1', NULL, NULL, NULL, 14),
(280774, NULL, 'PS00722', NULL, NULL, 'Formate--tetrahydrofolate ligase signature 2.', NULL, 'FTHFS_2', NULL, NULL, 20460, 14),
(280775, NULL, 'PS00247', NULL, NULL, 'HBGF/FGF family signature.', NULL, 'HBGF_FGF', NULL, NULL, 5967, 14),
(280776, NULL, 'PS00818', NULL, NULL, 'Dps protein family signature 1.', NULL, 'DPS_1', NULL, NULL, 8411, 14),
(280777, NULL, 'PS00474', NULL, NULL, 'Ribosomal protein L3 signature.', NULL, 'RIBOSOMAL_L3', NULL, NULL, 15459, 14),
(280778, NULL, 'PS01001', NULL, NULL, 'Succinate dehydrogenase cytochrome b subunit signature 2.', NULL, 'SDH_CYT_2', NULL, NULL, 9477, 14),
(280779, NULL, 'PS01313', NULL, NULL, 'Lipoate-protein ligase B signature.', NULL, 'LIPB', NULL, NULL, 19045, 14),
(280780, NULL, 'PS00306', NULL, NULL, 'Caseins alpha/beta signature.', NULL, 'CASEIN_ALPHA_BETA', NULL, NULL, 25913, 14),
(280781, NULL, 'PS00275', NULL, NULL, 'Shiga/ricin ribosomal inactivating toxins active site signature.', NULL, 'SHIGA_RICIN', NULL, NULL, 12723, 14),
(280782, NULL, 'PS00650', NULL, NULL, 'G-protein coupled receptors family 2 signature 2.', NULL, 'G_PROTEIN_RECEP_F2_2', NULL, NULL, 19312, 14),
(280783, NULL, 'PS01110', NULL, NULL, 'RNA polymerases H / 23 Kd subunits signature.', NULL, 'RNA_POL_H_23KD', NULL, NULL, 14739, 14),
(280784, NULL, 'PS01322', NULL, NULL, 'Phosphotriesterase family signature 1.', NULL, 'PHOSPHOTRIESTERASE_1', NULL, NULL, 7089, 14),
(280785, NULL, 'PS00765', NULL, NULL, 'Phosphoglucose isomerase signature 1.', NULL, 'P_GLUCOSE_ISOMERASE_1', NULL, NULL, 14793, 14),
(280786, NULL, 'PS00412', NULL, NULL, 'Neuromodulin (GAP-43) signature 1.', NULL, 'NEUROMODULIN_1', NULL, NULL, 8149, 14),
(280787, NULL, 'PS00806', NULL, NULL, 'Fructose-bisphosphate aldolase class-II signature 2.', NULL, 'ALDOLASE_CLASS_II_2', NULL, NULL, 6927, 14),
(280788, NULL, 'PS01331', NULL, NULL, 'Thymidylate kinase signature.', NULL, 'THYMIDYLATE_KINASE', NULL, NULL, 20816, 14);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(280789, NULL, 'PS01120', NULL, NULL, 'Urease nickel ligands signature.', NULL, 'UREASE_1', NULL, NULL, 25751, 14),
(280790, NULL, 'PS00090', NULL, NULL, 'Nitrogenases component 1 alpha and beta subunits signature 2.', NULL, 'NITROGENASE_1_2', NULL, NULL, 619, 14),
(280791, NULL, 'PS00580', NULL, NULL, 'Ribosomal protein L32e signature.', NULL, 'RIBOSOMAL_L32E', NULL, NULL, 19749, 14),
(280792, NULL, 'PS60027', NULL, NULL, 'Contryphan family signature.', NULL, 'CONTRYPHAN', NULL, NULL, 12831, 14),
(280793, NULL, 'PS00133', NULL, NULL, 'Zinc carboxypeptidases, zinc-binding region 2 signature.', NULL, 'CARBOXYPEPT_ZN_2', NULL, NULL, 211, 14),
(280794, NULL, 'PS00489', NULL, NULL, 'Bacteriophage-type RNA polymerase family active site signature 2.', NULL, 'RNA_POL_PHAGE_2', NULL, NULL, 5453, 14),
(280795, NULL, 'PS00659', NULL, NULL, 'Glycosyl hydrolases family 5 signature.', NULL, 'GLYCOSYL_HYDROL_F5', NULL, NULL, 13888, 14),
(280796, NULL, 'PS60008', NULL, NULL, 'Cyclotides bracelet subfamily signature.', NULL, 'CYCLOTIDE_BRACELET', NULL, NULL, 11583, 14),
(280797, NULL, 'PS01335', NULL, NULL, 'Methylglyoxal synthase active site.', NULL, 'METHYLGLYOXAL_SYNTH', NULL, NULL, 20800, 14),
(280798, NULL, 'PS00808', NULL, NULL, 'ADP-glucose pyrophosphorylase signature 1.', NULL, 'ADP_GLC_PYROPHOSPH_1', NULL, NULL, 5594, 14),
(280799, NULL, 'PS00934', NULL, NULL, 'Glyoxalase I signature 1.', NULL, 'GLYOXALASE_I_1', NULL, NULL, 20993, 14),
(280800, NULL, 'PS01082', NULL, NULL, 'Ribosomal protein L7Ae signature.', NULL, 'RIBOSOMAL_L7AE', NULL, NULL, 643, 14),
(280801, NULL, 'PS00905', NULL, NULL, 'GTP1/OBG family signature.', NULL, 'GTP1_OBG', NULL, NULL, 2650, 14),
(280802, NULL, 'PS01164', NULL, NULL, 'Copper amine oxidase topaquinone signature.', NULL, 'COPPER_AMINE_OXID_1', NULL, NULL, 771, 14),
(280803, NULL, 'PS01027', NULL, NULL, 'Glycosyl hydrolases family 39 active site.', NULL, 'GLYCOSYL_HYDROL_F39', NULL, NULL, 6735, 14),
(280804, NULL, 'PS00268', NULL, NULL, 'Cecropin family signature.', NULL, 'CECROPIN', NULL, NULL, NULL, 14),
(280805, NULL, 'PS01330', NULL, NULL, 'Polyamine biosynthesis (PABS) domain signature.', NULL, 'PABS_1', NULL, NULL, 21690, 14),
(280806, NULL, 'PS00615', NULL, NULL, 'C-type lectin domain signature.', NULL, 'C_TYPE_LECTIN_1', NULL, NULL, 20037, 14),
(280807, NULL, 'PS00390', NULL, NULL, 'Sodium and potassium ATPases beta subunits signature 1.', NULL, 'ATPASE_NA_K_BETA_1', NULL, NULL, 4711, 14),
(280808, NULL, 'PS00438', NULL, NULL, 'Catalase proximal active site signature.', NULL, 'CATALASE_2', NULL, NULL, 125, 14),
(280809, NULL, 'PS00445', NULL, NULL, 'FGGY family of carbohydrate kinases signature 2.', NULL, 'FGGY_KINASES_2', NULL, NULL, 21486, 14),
(280810, NULL, 'PS01109', NULL, NULL, 'Ribosomal protein L10 signature.', NULL, 'RIBOSOMAL_L10', NULL, NULL, 6249, 14),
(280811, NULL, 'PS00952', NULL, NULL, 'ER lumen protein retaining receptor signature 2.', NULL, 'ER_LUMEN_RECEPTOR_2', NULL, NULL, 3614, 14),
(280812, NULL, 'PS01065', NULL, NULL, 'Electron transfer flavoprotein beta-subunit signature.', NULL, 'ETF_BETA', NULL, NULL, 2977, 14),
(280813, NULL, 'PS01042', NULL, NULL, 'Homoserine dehydrogenase signature.', NULL, 'HOMOSER_DHGENASE', NULL, NULL, 17372, 14),
(280814, NULL, 'PS01112', NULL, NULL, 'RNA polymerases N / 8 Kd subunits signature.', NULL, 'RNA_POL_N_8KD', NULL, NULL, 14845, 14),
(280815, NULL, 'PS00546', NULL, NULL, 'Matrixins cysteine switch.', NULL, 'CYSTEINE_SWITCH', NULL, NULL, 16618, 14),
(280816, NULL, 'PS00753', NULL, NULL, 'XPA protein signature 2.', NULL, 'XPA_2', NULL, NULL, 16807, 14),
(280817, NULL, 'PS00771', NULL, NULL, 'Barwin domain signature 1.', NULL, 'BARWIN_1', NULL, NULL, 7552, 14),
(280818, NULL, 'PS00142', NULL, NULL, 'Neutral zinc metallopeptidases, zinc-binding region signature.', NULL, 'ZINC_PROTEASE', NULL, NULL, NULL, 14),
(280819, NULL, 'PS00718', NULL, NULL, 'Sigma-54 factors family signature 2.', NULL, 'SIGMA54_2', NULL, NULL, 4668, 14),
(280820, NULL, 'PS00507', NULL, NULL, 'Nickel-dependent hydrogenases large subunit signature 1.', NULL, 'NI_HGENASE_L_1', NULL, NULL, 14759, 14);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(280821, NULL, 'PS00610', NULL, NULL, 'Sodium:neurotransmitter symporter family signature 1.', NULL, 'NA_NEUROTRAN_SYMP_1', NULL, NULL, 3769, 14),
(280822, NULL, 'PS00762', NULL, NULL, 'WHEP-TRS domain signature.', NULL, 'WHEP_TRS_1', NULL, NULL, 3767, 14),
(280823, NULL, 'PS00836', NULL, NULL, 'Alanine dehydrogenase & pyridine nucleotide transhydrogenase signature 1.', NULL, 'ALADH_PNT_1', NULL, NULL, 7138, 14),
(280824, NULL, 'PS00586', NULL, NULL, 'Ribosomal protein L16 signature 1.', NULL, 'RIBOSOMAL_L16_1', NULL, NULL, 20119, 14),
(280825, NULL, 'PS01355', NULL, NULL, 'Short hematopoietin receptor family 1 signature.', NULL, 'HEMATOPO_REC_S_F1', NULL, NULL, 6806, 14),
(280826, NULL, 'PS00869', NULL, NULL, 'Renal dipeptidase active site.', NULL, 'RENAL_DIPEPTIDASE_1', NULL, NULL, 1621, 14),
(280827, NULL, 'PS00959', NULL, NULL, 'Histone H3 signature 2.', NULL, 'HISTONE_H3_2', NULL, NULL, 1526, 14),
(280828, NULL, 'PS00049', NULL, NULL, 'Ribosomal protein L14 signature.', NULL, 'RIBOSOMAL_L14', NULL, NULL, 15725, 14),
(280829, NULL, 'PS01006', NULL, NULL, 'Formate and nitrite transporters signature 2.', NULL, 'FORMATE_NITRITE_TP_2', NULL, NULL, 21456, 14),
(280830, NULL, 'PS00282', NULL, NULL, 'Kazal serine protease inhibitors family signature.', NULL, 'KAZAL_1', NULL, NULL, 6489, 14),
(280831, NULL, 'PS00657', NULL, NULL, 'Fork head domain signature 1.', NULL, 'FORK_HEAD_1', NULL, NULL, 18916, 14),
(280832, NULL, 'PS01114', NULL, NULL, 'GPR1/FUN34/yaaH family signature.', NULL, 'GPR1_FUN34_YAAH', NULL, NULL, 6839, 14),
(280833, NULL, 'PS00433', NULL, NULL, 'Phosphofructokinase signature.', NULL, 'PHOSPHOFRUCTOKINASE', NULL, NULL, 8198, 14),
(280834, NULL, 'PS00913', NULL, NULL, 'Iron-containing alcohol dehydrogenases signature 1.', NULL, 'ADH_IRON_1', NULL, NULL, 7858, 14),
(280835, NULL, 'PS01030', NULL, NULL, 'RNA polymerases M / 15 Kd subunits signature.', NULL, 'RNA_POL_M_15KD', NULL, NULL, 20779, 14),
(280836, NULL, 'PS00791', NULL, NULL, 'Receptor tyrosine kinase class V signature 2.', NULL, 'RECEPTOR_TYR_KIN_V_2', NULL, NULL, 5236, 14),
(280837, NULL, 'PS00850', NULL, NULL, 'Glycine radical domain signature.', NULL, 'GLY_RADICAL_1', NULL, NULL, 19889, 14),
(280838, NULL, 'PS00248', NULL, NULL, 'Nerve growth factor family signature.', NULL, 'NGF_1', NULL, NULL, 18887, 14),
(280839, NULL, 'PS00385', NULL, NULL, 'Alpha-L-fucosidase putative active site.', NULL, 'ALPHA_L_FUCOSIDASE', NULL, NULL, 19430, 14),
(280840, NULL, 'PS00106', NULL, NULL, 'Galactokinase signature.', NULL, 'GALACTOKINASE', NULL, NULL, 12884, 14),
(280841, NULL, 'PS00578', NULL, NULL, 'Ribosomal protein S6e signature.', NULL, 'RIBOSOMAL_S6E', NULL, NULL, 19816, 14),
(280842, NULL, 'PS01004', NULL, NULL, 'Myelin proteolipid protein signature 2.', NULL, 'MYELIN_PLP_2', NULL, NULL, 7509, 14),
(280843, NULL, 'PS00662', NULL, NULL, 'Bacterial type II secretion system protein E signature.', NULL, 'T2SP_E', NULL, NULL, 3375, 14),
(280844, NULL, 'PS00349', NULL, NULL, 'CTF/NF-I DNA-binding domain signature.', NULL, 'CTF_NFI_1', NULL, NULL, 12835, 14),
(280845, NULL, 'PS01216', NULL, NULL, 'ATP-citrate lyase / succinyl-CoA ligases family signature 1.', NULL, 'SUCCINYL_COA_LIG_1', NULL, NULL, 29187, 14),
(280846, NULL, 'PS01183', NULL, NULL, 'ubiE/COQ5 methyltransferase family signature 1.', NULL, 'UBIE_1', NULL, NULL, 16094, 14),
(280847, NULL, 'PS60032', NULL, NULL, 'Glycosyl hydrolases family 9 (GH9) active site signature 1.', NULL, 'GH9_1', NULL, NULL, NULL, 14),
(280848, NULL, 'PS00458', NULL, NULL, 'Natriuretic peptides receptors signature.', NULL, 'ANF_RECEPTORS', NULL, NULL, 1300, 14),
(280849, NULL, 'PS00560', NULL, NULL, 'Serine carboxypeptidases, histidine active site.', NULL, 'CARBOXYPEPT_SER_HIS', NULL, NULL, 32821, 14),
(280850, NULL, 'PS01275', NULL, NULL, 'Elongation factor P signature.', NULL, 'EFP', NULL, NULL, 11864, 14),
(280851, NULL, 'PS00372', NULL, NULL, 'PTS EIIA domains phosphorylation site signature 2.', NULL, 'PTS_EIIA_TYPE_2_HIS', NULL, NULL, 5869, 14),
(280852, NULL, 'PS00973', NULL, NULL, 'Ubiquitin specific protease (USP) domain signature 2.', NULL, 'USP_2', NULL, NULL, 14760, 14);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(280853, NULL, 'PS00323', NULL, NULL, 'Ribosomal protein S19 signature.', NULL, 'RIBOSOMAL_S19', NULL, NULL, 15139, 14),
(280854, NULL, 'PS00093', NULL, NULL, 'N-4 cytosine-specific DNA methylases signature.', NULL, 'N4_MTASE', NULL, NULL, 12796, 14),
(280855, NULL, 'PS00089', NULL, NULL, 'Ribonucleotide reductase large subunit signature.', NULL, 'RIBORED_LARGE', NULL, NULL, 4655, 14),
(280856, NULL, 'PS01011', NULL, NULL, 'Folylpolyglutamate synthase signature 1.', NULL, 'FOLYLPOLYGLU_SYNT_1', NULL, NULL, 13833, 14),
(280857, NULL, 'PS01058', NULL, NULL, 'SAICAR synthetase signature 2.', NULL, 'SAICAR_SYNTHETASE_2', NULL, NULL, 7982, 14),
(280858, NULL, 'PS00923', NULL, NULL, 'Aspartate and glutamate racemases signature 1.', NULL, 'ASP_GLU_RACEMASE_1', NULL, NULL, 14883, 14),
(280859, NULL, 'PS00064', NULL, NULL, 'L-lactate dehydrogenase active site.', NULL, 'L_LDH', NULL, NULL, 7668, 14),
(280860, NULL, 'PS01254', NULL, NULL, 'Fetuin family signature 1.', NULL, 'FETUIN_1', NULL, NULL, 7061, 14),
(280861, NULL, 'PS01257', NULL, NULL, 'Ribosomal protein L10e signature.', NULL, 'RIBOSOMAL_L10E', NULL, NULL, 19760, 14),
(280862, NULL, 'PS00703', NULL, NULL, 'Orn/Lys/Arg decarboxylases family 1 pyridoxal-P attachment site.', NULL, 'OKR_DC_1', NULL, NULL, 817, 14),
(280863, NULL, 'PS00004', NULL, NULL, 'cAMP- and cGMP-dependent protein kinase phosphorylation site.', NULL, 'CAMP_PHOSPHO_SITE', NULL, NULL, NULL, 14),
(280864, NULL, 'PS00401', NULL, NULL, 'Prokaryotic sulfate-binding proteins signature 1.', NULL, 'PROK_SULFATE_BIND_1', NULL, NULL, 500, 14),
(280865, NULL, 'PS00424', NULL, NULL, 'Interleukin-2 signature.', NULL, 'INTERLEUKIN_2', NULL, NULL, 25376, 14),
(280866, NULL, 'PS00244', NULL, NULL, 'Photosynthetic reaction center proteins signature.', NULL, 'REACTION_CENTER', NULL, NULL, 5823, 14),
(280867, NULL, 'PS00183', NULL, NULL, 'Ubiquitin-conjugating (UBC) active site signature.', NULL, 'UBC_1', NULL, NULL, 20562, 14),
(280868, NULL, 'PS00820', NULL, NULL, 'Glucoamylase active site region signature.', NULL, 'GLUCOAMYLASE', NULL, NULL, 3536, 14),
(280869, NULL, 'PS00312', NULL, NULL, 'Glycophorin A signature.', NULL, 'GLYCOPHORIN_A', NULL, NULL, 9115, 14),
(280870, NULL, 'PS00769', NULL, NULL, 'Transthyretin signature 2.', NULL, 'TRANSTHYRETIN_2', NULL, NULL, 16333, 14),
(280871, NULL, 'PS01220', NULL, NULL, 'Phosphatidylethanolamine-binding protein family signature.', NULL, 'PBP', NULL, NULL, 4222, 14),
(280872, NULL, 'PS01352', NULL, NULL, 'Long hematopoietin receptor, single chain family signature.', NULL, 'HEMATOPO_REC_L_F1', NULL, NULL, 6112, 14),
(280873, NULL, 'PS00838', NULL, NULL, 'Interleukins -4 and -13 signature.', NULL, 'INTERLEUKIN_4_13', NULL, NULL, 13813, 14),
(280874, NULL, 'PS00117', NULL, NULL, 'Galactose-1-phosphate uridyl transferase family 1 active site signature.', NULL, 'GAL_P_UDP_TRANSF_I', NULL, NULL, 19954, 14),
(280875, NULL, 'PS01283', NULL, NULL, 'T-box domain signature 1.', NULL, 'TBOX_1', NULL, NULL, 14898, 14),
(280876, NULL, 'PS00976', NULL, NULL, 'Myristoyl-CoA:protein N-myristoyltransferase signature 2.', NULL, 'NMT_2', NULL, NULL, 16537, 14),
(280877, NULL, 'PS00087', NULL, NULL, 'Copper/Zinc superoxide dismutase signature 1.', NULL, 'SOD_CU_ZN_1', NULL, NULL, 19133, 14),
(280878, NULL, 'PS00287', NULL, NULL, 'Cysteine proteases inhibitors signature.', NULL, 'CYSTATIN', NULL, NULL, 19096, 14),
(280879, NULL, 'PS01098', NULL, NULL, 'Lipolytic enzymes "G-D-S-L" family, serine active site.', NULL, 'LIPASE_GDSL_SER', NULL, NULL, 8884, 14),
(280880, NULL, 'PS01046', NULL, NULL, 'ATP-dependent serine proteases, lon family, serine active site.', NULL, 'LON_SER', NULL, NULL, 8708, 14),
(280881, NULL, 'PS00254', NULL, NULL, 'Interleukin-6 / G-CSF / MGF signature.', NULL, 'INTERLEUKIN_6', NULL, NULL, 24667, 14),
(280882, NULL, 'PS01026', NULL, NULL, 'Photosystem I psaG and psaK proteins signature.', NULL, 'PHOTOSYSTEM_I_PSAGK', NULL, NULL, 5845, 14),
(280883, NULL, 'PS01288', NULL, NULL, 'Uncharacterized protein family UPF0027 signature.', NULL, 'UPF0027', NULL, NULL, 788, 14); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(280884, NULL, 'PS00477', NULL, NULL, 'Alpha-2-macroglobulin family thiolester region signature.', NULL, 'ALPHA_2_MACROGLOBULIN', NULL, NULL, 12811, 14),
(280885, NULL, 'PS00690', NULL, NULL, 'DEAH-box subfamily ATP-dependent helicases signature.', NULL, 'DEAH_ATP_HELICASE', NULL, NULL, 6891, 14),
(280886, NULL, 'PS00167', NULL, NULL, 'Tryptophan synthase alpha chain signature.', NULL, 'TRP_SYNTHASE_ALPHA', NULL, NULL, 19518, 14),
(280887, NULL, 'PS01274', NULL, NULL, 'Coenzyme A transferases signature 2.', NULL, 'COA_TRANSF_2', NULL, NULL, 2983, 14),
(280888, NULL, 'PS00533', NULL, NULL, 'Porphobilinogen deaminase cofactor-binding site.', NULL, 'PORPHOBILINOGEN_DEAM', NULL, NULL, 15830, 14),
(280889, NULL, 'PS01174', NULL, NULL, 'Lipolytic enzymes "G-D-X-G" family, putative serine active site.', NULL, 'LIPASE_GDXG_SER', NULL, NULL, 30299, 14),
(280890, NULL, 'PS60028', NULL, NULL, 'Scorpion calcine family signature.', NULL, 'SCORPION_CALCINE', NULL, NULL, 10396, 14),
(280891, NULL, 'PS00075', NULL, NULL, 'Dihydrofolate reductase (DHFR) domain signature.', NULL, 'DHFR_1', NULL, NULL, 2730, 14),
(280892, NULL, 'PS00994', NULL, NULL, 'Bacterial export FHIPEP family signature.', NULL, 'FHIPEP', NULL, NULL, 24246, 14),
(280893, NULL, 'PS01047', NULL, NULL, 'Heavy-metal-associated domain.', NULL, 'HMA_1', NULL, NULL, 19294, 14),
(280894, NULL, 'PS00954', NULL, NULL, 'Imidazoleglycerol-phosphate dehydratase signature 1.', NULL, 'IGP_DEHYDRATASE_1', NULL, NULL, 18604, 14),
(280895, NULL, 'PS01162', NULL, NULL, 'Quinone oxidoreductase / zeta-crystallin signature.', NULL, 'QOR_ZETA_CRYSTAL', NULL, NULL, 6472, 14),
(280896, NULL, 'PS00515', NULL, NULL, 'Seminal vesicle protein II repeats signature.', NULL, 'SVP_II', NULL, NULL, 1095, 14),
(280897, NULL, 'PS00576', NULL, NULL, 'General diffusion Gram-negative porins signature.', NULL, 'GRAM_NEG_PORIN', NULL, NULL, 13063, 14),
(280898, NULL, 'PS01126', NULL, NULL, 'Elongation factor Ts signature 1.', NULL, 'EF_TS_1', NULL, NULL, 13505, 14),
(280899, NULL, 'PS01088', NULL, NULL, 'CAP protein signature 1.', NULL, 'CAP_1', NULL, NULL, 13981, 14),
(280900, NULL, 'PS00364', NULL, NULL, 'Bacterial quinoprotein dehydrogenases signature 2.', NULL, 'BACTERIAL_PQQ_2', NULL, NULL, 6403, 14),
(280901, NULL, 'PS01170', NULL, NULL, 'Ribosomal protein L6e signature.', NULL, 'RIBOSOMAL_L6E', NULL, NULL, 3066, 14),
(280902, NULL, 'PS01204', NULL, NULL, 'NF-kappa-B/Rel/dorsal domain signature.', NULL, 'REL_1', NULL, NULL, 21811, 14),
(280903, NULL, 'PS01016', NULL, NULL, 'Glycoprotease family signature.', NULL, 'GLYCOPROTEASE', NULL, NULL, 18952, 14),
(280904, NULL, 'PS01287', NULL, NULL, 'RNA 3''-terminal phosphate cyclase signature.', NULL, 'RTC', NULL, NULL, 20662, 14),
(280905, NULL, 'PS00369', NULL, NULL, 'PTS HPR domain histidine phosphorylation site signature.', NULL, 'PTS_HPR_HIS', NULL, NULL, 2004, 14),
(280906, NULL, 'PS00814', NULL, NULL, 'Adrenodoxin family, iron-sulfur binding region signature.', NULL, 'ADX', NULL, NULL, 16748, 14),
(280907, NULL, 'PS01357', NULL, NULL, 'Zinc finger ZZ-type signature.', NULL, 'ZF_ZZ_1', NULL, NULL, 4349, 14),
(280908, NULL, 'PS00151', NULL, NULL, 'Acylphosphatase signature 2.', NULL, 'ACYLPHOSPHATASE_2', NULL, NULL, 12801, 14),
(280909, NULL, 'PS00335', NULL, NULL, 'Parathyroid hormone family signature.', NULL, 'PARATHYROID', NULL, NULL, 6344, 14),
(280910, NULL, 'PS01156', NULL, NULL, 'TonB-dependent receptor proteins signature 2.', NULL, 'TONB_DEPENDENT_REC_2', NULL, NULL, 8689, 14),
(280911, NULL, 'PS01286', NULL, NULL, 'Coagulation factors 5/8 type C domain (FA58C) signature 2.', NULL, 'FA58C_2', NULL, NULL, 4934, 14),
(280912, NULL, 'PS00786', NULL, NULL, '5''-nucleotidase signature 2.', NULL, '5_NUCLEOTIDASE_2', NULL, NULL, 10072, 14),
(280913, NULL, 'PS00686', NULL, NULL, 'NF-YA/HAP2 subunit signature.', NULL, 'NFYA_HAP2_1', NULL, NULL, 20215, 14),
(280914, NULL, 'PS00754', NULL, NULL, 'Sodium:neurotransmitter symporter family signature 2.', NULL, 'NA_NEUROTRAN_SYMP_2', NULL, NULL, 3769, 14),
(280915, NULL, 'PS00725', NULL, NULL, 'Germin family signature.', NULL, 'GERMIN', NULL, NULL, 14710, 14);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(280916, NULL, 'PS00777', NULL, NULL, 'Glycosyl hydrolases family 11 (GH11) active site signature 2.', NULL, 'GH11_2', NULL, NULL, 28405, 14),
(280917, NULL, 'PS01231', NULL, NULL, 'RNA methyltransferase trmA family signature 2.', NULL, 'TRMA_2', NULL, NULL, 26715, 14),
(280918, NULL, 'PS00062', NULL, NULL, 'Aldo/keto reductase family signature 2.', NULL, 'ALDOKETO_REDUCTASE_2', NULL, NULL, 11896, 14),
(280919, NULL, 'PS00300', NULL, NULL, 'SRP54-type proteins GTP-binding domain signature.', NULL, 'SRP54', NULL, NULL, 260, 14),
(280920, NULL, 'PS00331', NULL, NULL, 'Malic enzymes signature.', NULL, 'MALIC_ENZYMES', NULL, NULL, 7220, 14),
(280921, NULL, 'PS00160', NULL, NULL, 'KDPG and KHG aldolases Schiff-base forming residue.', NULL, 'ALDOLASE_KDPG_KHG_2', NULL, NULL, 25980, 14),
(280922, NULL, 'PS00417', NULL, NULL, 'Synaptobrevin signature.', NULL, 'SYNAPTOBREVIN', NULL, NULL, 6773, 14),
(280923, NULL, 'PS00745', NULL, NULL, 'Prokaryotic-type class I peptide chain release factors signature.', NULL, 'RF_PROK_I', NULL, NULL, 47, 14),
(280924, NULL, 'PS00071', NULL, NULL, 'Glyceraldehyde 3-phosphate dehydrogenase active site.', NULL, 'GAPDH', NULL, NULL, 18739, 14),
(280925, NULL, 'PS00473', NULL, NULL, 'Gonadotropin-releasing hormones signature.', NULL, 'GNRH', NULL, NULL, 2140, 14),
(280926, NULL, 'PS00889', NULL, NULL, 'Cyclic nucleotide-binding domain signature 2.', NULL, 'CNMP_BINDING_2', NULL, NULL, 21313, 14),
(280927, NULL, 'PS00219', NULL, NULL, 'Anion exchangers family signature 1.', NULL, 'ANION_EXCHANGER_1', NULL, NULL, 8306, 14),
(280928, NULL, 'PS00613', NULL, NULL, 'Osteonectin domain signature 2.', NULL, 'OSTEONECTIN_2', NULL, NULL, 2104, 14),
(280929, NULL, 'PS01085', NULL, NULL, 'Ribulose-phosphate 3-epimerase family signature 1.', NULL, 'RIBUL_P_3_EPIMER_1', NULL, NULL, 2990, 14),
(280930, NULL, 'PS00875', NULL, NULL, 'Bacterial type II secretion system protein D signature.', NULL, 'T2SP_D', NULL, NULL, 4246, 14),
(280931, NULL, 'PS60017', NULL, NULL, 'Omega-atracotoxin (ACTX) type 2 family signature.', NULL, 'OMEGA_ACTX_2', NULL, NULL, 7595, 14),
(280932, NULL, 'PS00357', NULL, NULL, 'Histone H2B signature.', NULL, 'HISTONE_H2B', NULL, NULL, 5842, 14),
(280933, NULL, 'PS01036', NULL, NULL, 'Heat shock hsp70 proteins family signature 3.', NULL, 'HSP70_3', NULL, NULL, 7642, 14),
(280934, NULL, 'PS00816', NULL, NULL, 'Alpha-isopropylmalate and homocitrate synthases signature 2.', NULL, 'AIPM_HOMOCIT_SYNTH_2', NULL, NULL, 5275, 14),
(280935, NULL, 'PS00784', NULL, NULL, 'Ribosomal protein L34 signature.', NULL, 'RIBOSOMAL_L34', NULL, NULL, 14880, 14),
(280936, NULL, 'PS01290', NULL, NULL, 'Enhancer of rudimentary signature.', NULL, 'ER', NULL, NULL, 6842, 14),
(280937, NULL, 'PS00831', NULL, NULL, 'Ribosomal protein L27 signature.', NULL, 'RIBOSOMAL_L27', NULL, NULL, 19919, 14),
(280938, NULL, 'PS01029', NULL, NULL, 'Dehydroquinase class II signature.', NULL, 'DEHYDROQUINASE_II', NULL, NULL, 19117, 14),
(280939, NULL, 'PS00967', NULL, NULL, 'Neuromedin U signature.', NULL, 'NMU', NULL, NULL, 19605, 14),
(280940, NULL, 'PS00488', NULL, NULL, 'Phenylalanine and histidine ammonia-lyases signature.', NULL, 'PAL_HISTIDASE', NULL, NULL, 15852, 14),
(280941, NULL, 'PS00048', NULL, NULL, 'Protamine P1 signature.', NULL, 'PROTAMINE_P1', NULL, NULL, 3514, 14),
(280942, NULL, 'PS00986', NULL, NULL, 'Spermadhesins family signature 2.', NULL, 'SPERMADHESIN_2', NULL, NULL, 3729, 14),
(280943, NULL, 'PS01083', NULL, NULL, 'DNA photolyases class 2 signature 1.', NULL, 'DNA_PHOTOLYASES_2_1', NULL, NULL, 21745, 14),
(280944, NULL, 'PS00277', NULL, NULL, 'Staphylococcal enterotoxin/Streptococcal pyrogenic exotoxin signature 1.', NULL, 'STAPH_STREP_TOXIN_1', NULL, NULL, 10178, 14),
(280945, NULL, 'PS00799', NULL, NULL, 'Granulins signature.', NULL, 'GRANULINS', NULL, NULL, 1709, 14),
(280946, NULL, 'PS00996', NULL, NULL, 'Ribosomal protein S21e signature.', NULL, 'RIBOSOMAL_S21E', NULL, NULL, 19546, 14),
(280947, NULL, 'PS00121', NULL, NULL, 'Colipase signature.', NULL, 'COLIPASE_1', NULL, NULL, 18366, 14);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(280948, NULL, 'PS00801', NULL, NULL, 'Transketolase signature 1.', NULL, 'TRANSKETOLASE_1', NULL, NULL, 902, 14),
(280949, NULL, 'PS01267', NULL, NULL, 'Uncharacterized protein family UPF0023 signature.', NULL, 'UPF0023', NULL, NULL, 11537, 14),
(280950, NULL, 'PS00707', NULL, NULL, 'Glycosyl hydrolases family 31 signature 2.', NULL, 'GLYCOSYL_HYDROL_F31_2', NULL, NULL, 23726, 14),
(280951, NULL, 'PS00944', NULL, NULL, 'Cyclin-dependent kinases regulatory subunits signature 1.', NULL, 'CKS_1', NULL, NULL, 4563, 14),
(280952, NULL, 'PS00211', NULL, NULL, 'ABC transporters family signature.', NULL, 'ABC_TRANSPORTER_1', NULL, NULL, 12786, 14),
(280953, NULL, 'PS00338', NULL, NULL, 'Somatotropin, prolactin and related hormones signature 2.', NULL, 'SOMATOTROPIN_2', NULL, NULL, 18832, 14),
(280954, NULL, 'PS01055', NULL, NULL, 'NAD-dependent DNA ligase signature 1.', NULL, 'DNA_LIGASE_N1', NULL, NULL, 8381, 14),
(280955, NULL, 'PS00377', NULL, NULL, 'S-adenosylmethionine synthase signature 2.', NULL, 'ADOMET_SYNTHASE_2', NULL, NULL, 16576, 14),
(280956, NULL, 'PS00713', NULL, NULL, 'Sodium:dicarboxylate symporter family signature 1.', NULL, 'NA_DICARBOXYL_SYMP_1', NULL, NULL, 13643, 14),
(280957, NULL, 'PS00758', NULL, NULL, 'ArgE / dapE / ACY1 / CPG2 / yscS family signature 1.', NULL, 'ARGE_DAPE_CPG2_1', NULL, NULL, 1127, 14),
(280958, NULL, 'PS00125', NULL, NULL, 'Serine/threonine specific protein phosphatases signature.', NULL, 'SER_THR_PHOSPHATASE', NULL, NULL, 11072, 14),
(280959, NULL, 'PS01102', NULL, NULL, 'Prokaryotic dksA C4-type zinc finger.', NULL, 'ZF_DKSA_1', NULL, NULL, 18816, 14),
(280960, NULL, 'PS01154', NULL, NULL, 'RNA polymerases L / 13 to 16 Kd subunits signature.', NULL, 'RNA_POL_L_13KD', NULL, NULL, 7262, 14),
(280961, NULL, 'PS00581', NULL, NULL, 'Clathrin light chain signature 2.', NULL, 'CLATHRIN_LIGHT_CHN_2', NULL, NULL, 3001, 14),
(280962, NULL, 'PS00542', NULL, NULL, 'Respiratory chain NADH dehydrogenase 30 Kd subunit signature.', NULL, 'COMPLEX1_30K', NULL, NULL, 19858, 14),
(280963, NULL, 'PS01075', NULL, NULL, 'Acetate and butyrate kinases family signature 1.', NULL, 'ACETATE_KINASE_1', NULL, NULL, 8090, 14),
(280964, NULL, 'PS00373', NULL, NULL, 'Phosphoribosylglycinamide formyltransferase active site.', NULL, 'GART', NULL, NULL, 3191, 14),
(280965, NULL, 'PS00492', NULL, NULL, 'Clusterin signature 1.', NULL, 'CLUSTERIN_1', NULL, NULL, 24715, 14),
(280966, NULL, 'PS01101', NULL, NULL, 'Casein kinase II regulatory subunit signature.', NULL, 'CK2_BETA', NULL, NULL, 6522, 14),
(280967, NULL, 'PS00749', NULL, NULL, 'F-actin capping protein alpha subunit signature 2.', NULL, 'F_ACTIN_CAPPING_A_2', NULL, NULL, 18559, 14),
(280968, NULL, 'PS00587', NULL, NULL, 'Glycosyl hydrolases family 17 signature.', NULL, 'GLYCOSYL_HYDROL_F17', NULL, NULL, 5879, 14),
(280969, NULL, 'PS00641', NULL, NULL, 'Respiratory-chain NADH dehydrogenase 75 Kd subunit signature 1.', NULL, 'COMPLEX1_75K_1', NULL, NULL, 622, 14),
(280970, NULL, 'PS01329', NULL, NULL, 'Cytochrome c oxidase subunit VIa signature.', NULL, 'COX6A', NULL, NULL, 19318, 14),
(280971, NULL, 'PS00256', NULL, NULL, 'Adipokinetic hormone family signature.', NULL, 'AKH', NULL, NULL, 1410, 14),
(280972, NULL, 'PS00005', NULL, NULL, 'Protein kinase C phosphorylation site.', NULL, 'PKC_PHOSPHO_SITE', NULL, NULL, NULL, 14),
(280973, NULL, 'PS00812', NULL, NULL, 'Glycosyl hydrolases family 8 signature.', NULL, 'GLYCOSYL_HYDROL_F8', NULL, NULL, 15948, 14),
(280974, NULL, 'PS00050', NULL, NULL, 'Ribosomal protein L23 signature.', NULL, 'RIBOSOMAL_L23', NULL, NULL, 2097, 14),
(280975, NULL, 'PS00149', NULL, NULL, 'Sulfatases signature 2.', NULL, 'SULFATASE_2', NULL, NULL, 26550, 14),
(280976, NULL, 'PS00389', NULL, NULL, 'ATP synthase delta (OSCP) subunit signature.', NULL, 'ATPASE_DELTA', NULL, NULL, 20437, 14),
(280977, NULL, 'PS00832', NULL, NULL, '2''-5''-oligoadenylate synthases signature 1.', NULL, '25A_SYNTH_1', NULL, NULL, 35452, 14),
(280978, NULL, 'PS00535', NULL, NULL, 'Respiratory chain NADH dehydrogenase 49 Kd subunit signature.', NULL, 'COMPLEX1_49K', NULL, NULL, 18979, 14);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(280979, NULL, 'PS00775', NULL, NULL, 'Glycosyl hydrolases family 3 active site.', NULL, 'GLYCOSYL_HYDROL_F3', NULL, NULL, 17493, 14),
(280980, NULL, 'PS00519', NULL, NULL, 'AsnC-type HTH domain signature.', NULL, 'HTH_ASNC_1', NULL, NULL, 14949, 14),
(280981, NULL, 'PS01249', NULL, NULL, 'Hydrogenases expression/synthesis hypA family signature.', NULL, 'HYPA', NULL, NULL, 14621, 14),
(280982, NULL, 'PS00592', NULL, NULL, 'Glycosyl hydrolases family 9 (GH9) active site signature 2.', NULL, 'GH9_2', NULL, NULL, 7590, 14),
(280983, NULL, 'PS00883', NULL, NULL, 'Nickel-dependent hydrogenases b-type cytochrome subunit signature 2.', NULL, 'NI_HGENASE_CYTB_2', NULL, NULL, 6762, 14),
(280984, NULL, 'PS00525', NULL, NULL, 'Ribosomal protein L6 signature 1.', NULL, 'RIBOSOMAL_L6_1', NULL, NULL, 5162, 14),
(280985, NULL, 'PS00618', NULL, NULL, 'RecF protein signature 2.', NULL, 'RECF_2', NULL, NULL, 13689, 14),
(280986, NULL, 'PS00683', NULL, NULL, 'Rhodanese C-terminal signature.', NULL, 'RHODANESE_2', NULL, NULL, 308, 14),
(280987, NULL, 'PS00035', NULL, NULL, 'POU-specific (POUs) domain signature 1.', NULL, 'POU_1', NULL, NULL, 985, 14),
(280988, NULL, 'PS01266', NULL, NULL, 'Adenylosuccinate synthetase GTP-binding site.', NULL, 'ADENYLOSUCCIN_SYN_1', NULL, NULL, 7621, 14),
(280989, NULL, 'PS00863', NULL, NULL, 'Calsequestrin signature 1.', NULL, 'CALSEQUESTRIN_1', NULL, NULL, 7834, 14),
(280990, NULL, 'PS00135', NULL, NULL, 'Serine proteases, trypsin family, serine active site.', NULL, 'TRYPSIN_SER', NULL, NULL, 28974, 14),
(280991, NULL, 'PS00358', NULL, NULL, 'Ribosomal protein L5 signature.', NULL, 'RIBOSOMAL_L5', NULL, NULL, 14666, 14),
(280992, NULL, 'PS00346', NULL, NULL, 'Ets-domain signature 2.', NULL, 'ETS_DOMAIN_2', NULL, NULL, 6517, 14),
(280993, NULL, 'PS00418', NULL, NULL, 'Potexviruses and carlaviruses coat protein signature.', NULL, 'POTEX_CARLAVIRUS_COAT', NULL, NULL, 2879, 14),
(280994, NULL, 'PS00391', NULL, NULL, 'Sodium and potassium ATPases beta subunits signature 2.', NULL, 'ATPASE_NA_K_BETA_2', NULL, NULL, 4711, 14),
(280995, NULL, 'PS00677', NULL, NULL, 'D-amino acid oxidases signature.', NULL, 'DAO', NULL, NULL, 11272, 14),
(280996, NULL, 'PS00567', NULL, NULL, 'Phosphoribulokinase signature.', NULL, 'PHOSPHORIBULOKINASE', NULL, NULL, 2865, 14),
(280997, NULL, 'PS01201', NULL, NULL, 'Tub family signature 2.', NULL, 'TUB_2', NULL, NULL, 19471, 14),
(280998, NULL, 'PS01218', NULL, NULL, 'TatC family signature.', NULL, 'TATC', NULL, NULL, 15526, 14),
(280999, NULL, 'PS00508', NULL, NULL, 'Nickel-dependent hydrogenases large subunit signature 2.', NULL, 'NI_HGENASE_L_2', NULL, NULL, 14759, 14),
(281000, NULL, 'PS00825', NULL, NULL, 'Elongation factor 1 beta/beta''/delta chain signature 2.', NULL, 'EF1BD_2', NULL, NULL, 2100, 14),
(281001, NULL, 'PS00299', NULL, NULL, 'Ubiquitin domain signature.', NULL, 'UBIQUITIN_1', NULL, NULL, 15242, 14),
(281002, NULL, 'PS00311', NULL, NULL, 'LAMP glycoproteins transmembrane and cytoplasmic domain signature.', NULL, 'LAMP_2', NULL, NULL, 20504, 14),
(281003, NULL, 'PS00175', NULL, NULL, 'Phosphoglycerate mutase family phosphohistidine signature.', NULL, 'PG_MUTASE', NULL, NULL, 7050, 14),
(281004, NULL, 'PS01061', NULL, NULL, 'Flagella transport protein fliP family signature 2.', NULL, 'FLIP_2', NULL, NULL, 5727, 14),
(281005, NULL, 'PS00165', NULL, NULL, 'Serine/threonine dehydratases pyridoxal-phosphate attachment site.', NULL, 'DEHYDRATASE_SER_THR', NULL, NULL, 6585, 14),
(281006, NULL, 'PS01319', NULL, NULL, 'Ribosome-binding factor A signature.', NULL, 'RBFA', NULL, NULL, 15587, 14),
(281007, NULL, 'PS00237', NULL, NULL, 'G-protein coupled receptors family 1 signature.', NULL, 'G_PROTEIN_RECEP_F1_1', NULL, NULL, 4866, 14),
(281008, NULL, 'PS00684', NULL, NULL, 'Small, acid-soluble spore proteins, alpha/beta type, signature 2.', NULL, 'SASP_2', NULL, NULL, 18823, 14),
(281009, NULL, 'PS00819', NULL, NULL, 'Dps protein family signature 2.', NULL, 'DPS_2', NULL, NULL, 8411, 14),
(281010, NULL, 'PS01268', NULL, NULL, 'Uncharacterized protein family UPF0024 signature.', NULL, 'UPF0024', NULL, NULL, 12995, 14);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(281011, NULL, 'PS00164', NULL, NULL, 'Enolase signature.', NULL, 'ENOLASE', NULL, NULL, 14867, 14),
(281012, NULL, 'PS00985', NULL, NULL, 'Spermadhesins family signature 1.', NULL, 'SPERMADHESIN_1', NULL, NULL, 3729, 14),
(281013, NULL, 'PS00103', NULL, NULL, 'Purine/pyrimidine phosphoribosyl transferases signature.', NULL, 'PUR_PYR_PR_TRANSFER', NULL, NULL, NULL, 14),
(281014, NULL, 'PS00480', NULL, NULL, 'Citrate synthase signature.', NULL, 'CITRATE_SYNTHASE', NULL, NULL, 17012, 14),
(281015, NULL, 'PS01354', NULL, NULL, 'Long hematopoietin receptor, soluble alpha chains family signature.', NULL, 'HEMATOPO_REC_L_F3', NULL, NULL, 6915, 14),
(281016, NULL, 'PS00999', NULL, NULL, 'Streptomyces subtilisin-type inhibitors signature.', NULL, 'SSI', NULL, NULL, 16134, 14),
(281017, NULL, 'PS01314', NULL, NULL, 'Uncharacterized protein family UPF0047 signature.', NULL, 'UPF0047', NULL, NULL, 3185, 14),
(281018, NULL, 'PS00208', NULL, NULL, 'Plant hemoglobins signature.', NULL, 'PLANT_GLOBIN', NULL, NULL, 17076, 14),
(281019, NULL, 'PS60029', NULL, NULL, 'Spider toxin CSTX family signature.', NULL, 'SPIDER_CSTX', NULL, NULL, 12771, 14),
(281020, NULL, 'PS00399', NULL, NULL, 'ATP-citrate lyase / succinyl-CoA ligases family active site.', NULL, 'SUCCINYL_COA_LIG_2', NULL, NULL, 18715, 14),
(281021, NULL, 'PS00767', NULL, NULL, 'Tetrahydrofolate dehydrogenase/cyclohydrolase signature 2.', NULL, 'THF_DHG_CYH_2', NULL, NULL, 18936, 14),
(281022, NULL, 'PS00115', NULL, NULL, 'Eukaryotic RNA polymerase II heptapeptide repeat.', NULL, 'RNA_POL_II_REPEAT', NULL, NULL, 3926, 14),
(281023, NULL, 'PS00295', NULL, NULL, 'Arrestins signature.', NULL, 'ARRESTINS', NULL, NULL, 18503, 14),
(281024, NULL, 'PS00866', NULL, NULL, 'Carbamoyl-phosphate synthase subdomain signature 1.', NULL, 'CPSASE_1', NULL, NULL, 782, 14),
(281025, NULL, 'PS01131', NULL, NULL, 'Ribosomal RNA adenine dimethylases signature.', NULL, 'RRNA_A_DIMETH', NULL, NULL, 20501, 14),
(281026, NULL, 'PS00450', NULL, NULL, 'Aconitase family signature 1.', NULL, 'ACONITASE_1', NULL, NULL, 19648, 14),
(281027, NULL, 'PS00679', NULL, NULL, 'Beta-amylase active site 2.', NULL, 'BETA_AMYLASE_2', NULL, NULL, 8179, 14),
(281028, NULL, 'PS00813', NULL, NULL, 'Eukaryotic initiation factor 4E signature.', NULL, 'IF4E', NULL, NULL, 9147, 14),
(281029, NULL, 'PS00059', NULL, NULL, 'Zinc-containing alcohol dehydrogenases signature.', NULL, 'ADH_ZINC', NULL, NULL, 6177, 14),
(281030, NULL, 'PS01103', NULL, NULL, 'Aspartate-semialdehyde dehydrogenase signature.', NULL, 'ASD', NULL, NULL, 4719, 14),
(281031, NULL, 'PS00527', NULL, NULL, 'Ribosomal protein S14 signature.', NULL, 'RIBOSOMAL_S14', NULL, NULL, 19573, 14),
(281032, NULL, 'PS00926', NULL, NULL, 'Lysyl oxidase putative copper-binding region signature.', NULL, 'LYSYL_OXIDASE', NULL, NULL, 17179, 14),
(281033, NULL, 'PS00837', NULL, NULL, 'Alanine dehydrogenase & pyridine nucleotide transhydrogenase signature 2.', NULL, 'ALADH_PNT_2', NULL, NULL, 7054, 14),
(281034, NULL, 'PS00965', NULL, NULL, 'Phosphomannose isomerase type I signature 1.', NULL, 'PMI_I_1', NULL, NULL, 14614, 14),
(281035, NULL, 'PS00779', NULL, NULL, 'Glycoprotein hormones alpha chain signature 1.', NULL, 'GLYCO_HORMONE_ALPHA_1', NULL, NULL, 5533, 14),
(281036, NULL, 'PS01119', NULL, NULL, 'Copper-fist DNA-binding domain signature.', NULL, 'COPPER_FIST_1', NULL, NULL, 2454, 14),
(281037, NULL, 'PS01000', NULL, NULL, 'Succinate dehydrogenase cytochrome b subunit signature 1.', NULL, 'SDH_CYT_1', NULL, NULL, 9477, 14),
(281038, NULL, 'PS01089', NULL, NULL, 'CAP protein signature 2.', NULL, 'CAP_2', NULL, NULL, 21824, 14),
(281039, NULL, 'PS00810', NULL, NULL, 'ADP-glucose pyrophosphorylase signature 3.', NULL, 'ADP_GLC_PYROPHOSPH_3', NULL, NULL, 5594, 14),
(281040, NULL, 'PS00557', NULL, NULL, 'FMN-dependent alpha-hydroxy acid dehydrogenases active site.', NULL, 'FMN_HYDROXY_ACID_DH_1', NULL, NULL, 8512, 14),
(281041, NULL, 'PS01168', NULL, NULL, 'Ribosomal protein S27e signature.', NULL, 'RIBOSOMAL_S27E', NULL, NULL, 5666, 14),
(281042, NULL, 'PS01230', NULL, NULL, 'RNA methyltransferase trmA family signature 1.', NULL, 'TRMA_1', NULL, NULL, 25006, 14);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(281043, NULL, 'PS00601', NULL, NULL, 'IRF tryptophan pentad repeat DNA-binding domain signature.', NULL, 'IRF_1', NULL, NULL, 17198, 14),
(281044, NULL, 'PS01062', NULL, NULL, 'Hydroxymethylglutaryl-coenzyme A lyase active site.', NULL, 'HMG_COA_LYASE', NULL, NULL, 3598, 14),
(281045, NULL, 'PS00521', NULL, NULL, 'Delta 1-pyrroline-5-carboxylate reductase signature.', NULL, 'P5CR', NULL, NULL, 803, 14),
(281046, NULL, 'PS01141', NULL, NULL, 'Bacterial type II secretion system protein C signature.', NULL, 'T2SP_C', NULL, NULL, 3988, 14),
(281047, NULL, 'PS01224', NULL, NULL, 'N-acetyl-gamma-glutamyl-phosphate reductase active site.', NULL, 'ARGC', NULL, NULL, 15414, 14),
(281048, NULL, 'PS00933', NULL, NULL, 'FGGY family of carbohydrate kinases signature 1.', NULL, 'FGGY_KINASES_1', NULL, NULL, 21486, 14),
(281049, NULL, 'PS00717', NULL, NULL, 'Sigma-54 factors family signature 1.', NULL, 'SIGMA54_1', NULL, NULL, 4668, 14),
(281050, NULL, 'PS00792', NULL, NULL, 'Dihydropteroate synthase signature 1.', NULL, 'DHPS_1', NULL, NULL, 5583, 14),
(281051, NULL, 'PS00280', NULL, NULL, 'Pancreatic trypsin inhibitor (Kunitz) family signature.', NULL, 'BPTI_KUNITZ_1', NULL, NULL, 19159, 14),
(281052, NULL, 'PS01049', NULL, NULL, 'YjeF C-terminal domain signature 1.', NULL, 'YJEF_C_1', NULL, NULL, 1314, 14),
(281053, NULL, 'PS00466', NULL, NULL, 'Zinc finger TFIIS-type signature.', NULL, 'ZF_TFIIS_1', NULL, NULL, 2346, 14),
(281054, NULL, 'PS00066', NULL, NULL, 'Hydroxymethylglutaryl-coenzyme A reductases signature 1.', NULL, 'HMG_COA_REDUCTASE_1', NULL, NULL, 15019, 14),
(281055, NULL, 'PS00098', NULL, NULL, 'Thiolases acyl-enzyme intermediate signature.', NULL, 'THIOLASE_1', NULL, NULL, 19051, 14),
(281056, NULL, 'PS01159', NULL, NULL, 'WW/rsp5/WWP domain signature.', NULL, 'WW_DOMAIN_1', NULL, NULL, 1285, 14),
(281057, NULL, 'PS00938', NULL, NULL, 'Initiation factor 3 signature.', NULL, 'IF3', NULL, NULL, 17142, 14),
(281058, NULL, 'PS01349', NULL, NULL, 'Nodulation protein nodA signature.', NULL, 'NODA', NULL, NULL, 18682, 14),
(281059, NULL, 'PS00381', NULL, NULL, 'Endopeptidase Clp serine active site.', NULL, 'CLP_PROTEASE_SER', NULL, NULL, 7672, 14),
(281060, NULL, 'PS01242', NULL, NULL, 'Zinc finger FPG-type signature.', NULL, 'ZF_FPG_1', NULL, NULL, 7457, 14),
(281061, NULL, 'PS00635', NULL, NULL, 'Gram-negative pili assembly chaperone signature.', NULL, 'PILI_CHAPERONE', NULL, NULL, 14685, 14),
(281062, NULL, 'PS01252', NULL, NULL, 'Endogenous opioids neuropeptides precursors signature.', NULL, 'OPIOIDS_PRECURSOR', NULL, NULL, 1075, 14),
(281063, NULL, 'PS00629', NULL, NULL, 'Inositol monophosphatase family signature 1.', NULL, 'IMP_1', NULL, NULL, 20975, 14),
(281064, NULL, 'PS00726', NULL, NULL, 'AP endonucleases family 1 signature 1.', NULL, 'AP_NUCLEASE_F1_1', NULL, NULL, 20777, 14),
(281065, NULL, 'PS01148', NULL, NULL, 'Uncharacterized protein family UPF0033 signature.', NULL, 'UPF0033', NULL, NULL, 3217, 14),
(281066, NULL, 'PS00764', NULL, NULL, 'Endonuclease III iron-sulfur binding region signature.', NULL, 'ENDONUCLEASE_III_1', NULL, NULL, 811, 14),
(281067, NULL, 'PS00782', NULL, NULL, 'Transcription factor TFIIB repeat signature.', NULL, 'TFIIB', NULL, NULL, 16085, 14),
(281068, NULL, 'PS00407', NULL, NULL, 'Connexins signature 1.', NULL, 'CONNEXINS_1', NULL, NULL, 19115, 14),
(281069, NULL, 'PS00793', NULL, NULL, 'Dihydropteroate synthase signature 2.', NULL, 'DHPS_2', NULL, NULL, 5583, 14),
(281070, NULL, 'PS00932', NULL, NULL, 'Prokaryotic molybdopterin oxidoreductases signature 3.', NULL, 'MOLYBDOPTERIN_PROK_3', NULL, NULL, 1207, 14),
(281071, NULL, 'PS01351', NULL, NULL, 'MAP kinase signature.', NULL, 'MAPK', NULL, NULL, 6288, 14),
(281072, NULL, 'PS00416', NULL, NULL, 'Synapsins signature 2.', NULL, 'SYNAPSIN_2', NULL, NULL, 12983, 14),
(281073, NULL, 'PS00645', NULL, NULL, 'Respiratory-chain NADH dehydrogenase 51 Kd subunit signature 2.', NULL, 'COMPLEX1_51K_2', NULL, NULL, 2462, 14),
(281074, NULL, 'PS00612', NULL, NULL, 'Osteonectin domain signature 1.', NULL, 'OSTEONECTIN_1', NULL, NULL, 2104, 14);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(281075, NULL, 'PS01079', NULL, NULL, 'Molybdenum cofactor biosynthesis proteins signature 2.', NULL, 'MOCF_BIOSYNTHESIS_2', NULL, NULL, 9527, 14),
(281076, NULL, 'PS01337', NULL, NULL, 'Ornithine decarboxylase antizyme signature.', NULL, 'ODC_AZ', NULL, NULL, 7384, 14),
(281077, NULL, 'PS00916', NULL, NULL, 'Phosphatidylinositol 3- and 4-kinases signature 2.', NULL, 'PI3_4_KINASE_2', NULL, NULL, 9400, 14),
(281078, NULL, 'PS00993', NULL, NULL, 'Ribosomal protein L30e signature 2.', NULL, 'RIBOSOMAL_L30E_2', NULL, NULL, 15465, 14),
(281079, NULL, 'PS00706', NULL, NULL, 'Prion protein signature 2.', NULL, 'PRION_2', NULL, NULL, 15819, 14),
(281080, NULL, 'PS00124', NULL, NULL, 'Fructose-1-6-bisphosphatase active site.', NULL, 'FBPASE', NULL, NULL, 21429, 14),
(281081, NULL, 'PS00979', NULL, NULL, 'G-protein coupled receptors family 3 signature 1.', NULL, 'G_PROTEIN_RECEP_F3_1', NULL, NULL, 19495, 14),
(281082, NULL, 'PS00376', NULL, NULL, 'S-adenosylmethionine synthase signature 1.', NULL, 'ADOMET_SYNTHASE_1', NULL, NULL, 16576, 14),
(281083, NULL, 'PS00743', NULL, NULL, 'Beta-lactamases class B signature 1.', NULL, 'BETA_LACTAMASE_B_1', NULL, NULL, 345, 14),
(281084, NULL, 'PS00333', NULL, NULL, 'ATP-dependent DNA ligase signature 2.', NULL, 'DNA_LIGASE_A2', NULL, NULL, 18085, 14),
(281085, NULL, 'PS00371', NULL, NULL, 'PTS EIIA domains phosphorylation site signature 1.', NULL, 'PTS_EIIA_TYPE_1_HIS', NULL, NULL, 1944, 14),
(281086, NULL, 'PS01214', NULL, NULL, 'Uncharacterized protein family UPF0016 signature.', NULL, 'UPF0016', NULL, NULL, 3321, 14),
(281087, NULL, 'PS01151', NULL, NULL, 'Fimbrial biogenesis outer membrane usher protein signature.', NULL, 'FIMBRIAL_USHER', NULL, NULL, 19246, 14),
(281088, NULL, 'PS00007', NULL, NULL, 'Tyrosine kinase phosphorylation site 1.', NULL, 'TYR_PHOSPHO_SITE_1', NULL, NULL, NULL, 14),
(281089, NULL, 'PS00246', NULL, NULL, 'Wnt-1 family signature.', NULL, 'WNT1', NULL, NULL, 7634, 14),
(281090, NULL, 'PS00150', NULL, NULL, 'Acylphosphatase signature 1.', NULL, 'ACYLPHOSPHATASE_1', NULL, NULL, 12801, 14),
(281091, NULL, 'PS00258', NULL, NULL, 'Calcitonin / CGRP / IAPP family signature.', NULL, 'CALCITONIN', NULL, NULL, 20245, 14),
(281092, NULL, 'PS01203', NULL, NULL, 'BTG family signature 2.', NULL, 'BTG_2', NULL, NULL, 1263, 14),
(281093, NULL, 'PS60015', NULL, NULL, 'Mu-agatoxin family signature.', NULL, 'MU_AGATOXIN', NULL, NULL, 20157, 14),
(281094, NULL, 'PS00108', NULL, NULL, 'Serine/Threonine protein kinases active-site signature.', NULL, 'PROTEIN_KINASE_ST', NULL, NULL, 8906, 14),
(281095, NULL, 'PS00355', NULL, NULL, 'HMG14 and HMG17 signature.', NULL, 'HMG14_17', NULL, NULL, 2748, 14),
(281096, NULL, 'PS01130', NULL, NULL, 'SLC26A transporters signature.', NULL, 'SLC26A', NULL, NULL, 19301, 14),
(281097, NULL, 'PS00204', NULL, NULL, 'Ferritin iron-binding regions signature 2.', NULL, 'FERRITIN_2', NULL, NULL, 12655, 14),
(281098, NULL, 'PS00918', NULL, NULL, 'Deoxyribonuclease I signature 2.', NULL, 'DNASE_I_2', NULL, NULL, 32724, 14),
(281099, NULL, 'PS01306', NULL, NULL, 'Uncharacterized protein family UPF0054 signature.', NULL, 'UPF0054', NULL, NULL, 20755, 14),
(281100, NULL, 'PS00461', NULL, NULL, '6-phosphogluconate dehydrogenase signature.', NULL, '6PGD', NULL, NULL, 11064, 14),
(281101, NULL, 'PS00129', NULL, NULL, 'Glycosyl hydrolases family 31 active site.', NULL, 'GLYCOSYL_HYDROL_F31_1', NULL, NULL, 23760, 14),
(281102, NULL, 'PS00646', NULL, NULL, 'Ribosomal protein S13 signature.', NULL, 'RIBOSOMAL_S13_1', NULL, NULL, 19744, 14),
(281103, NULL, 'PS00897', NULL, NULL, 'LacY family proton/sugar symporters signature 2.', NULL, 'LACY_2', NULL, NULL, 15547, 14),
(281104, NULL, 'PS01327', NULL, NULL, 'Large-conductance mechanosensitive channels mscL family signature.', NULL, 'MSCL', NULL, NULL, 17170, 14),
(281105, NULL, 'PS00462', NULL, NULL, 'Gamma-glutamyltranspeptidase signature.', NULL, 'G_GLU_TRANSPEPTIDASE', NULL, NULL, 2662, 14),
(281106, NULL, 'PS00826', NULL, NULL, 'MARCKS family signature 1.', NULL, 'MARCKS_1', NULL, NULL, 1309, 14);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(281107, NULL, 'PS01122', NULL, NULL, 'Caspase family cysteine active site.', NULL, 'CASPASE_CYS', NULL, NULL, 30056, 14),
(281108, NULL, 'PS01099', NULL, NULL, 'Respiratory-chain NADH dehydrogenase 24 Kd subunit signature.', NULL, 'COMPLEX1_24K', NULL, NULL, 4560, 14),
(281109, NULL, 'PS01358', NULL, NULL, 'Zinc finger RanBP2-type signature.', NULL, 'ZF_RANBP2_1', NULL, NULL, 5410, 14),
(281110, NULL, 'PS00893', NULL, NULL, 'Nudix box signature.', NULL, 'NUDIX_BOX', NULL, NULL, 16352, 14),
(281111, NULL, 'PS00723', NULL, NULL, 'Polyprenyl synthases signature 1.', NULL, 'POLYPRENYL_SYNTHASE_1', NULL, NULL, 28231, 14),
(281112, NULL, 'PS00080', NULL, NULL, 'Multicopper oxidases signature 2.', NULL, 'MULTICOPPER_OXIDASE2', NULL, NULL, 6152, 14),
(281113, NULL, 'PS00778', NULL, NULL, 'Histidine acid phosphatases active site signature.', NULL, 'HIS_ACID_PHOSPHAT_2', NULL, NULL, 33054, 14),
(281114, NULL, 'PS01034', NULL, NULL, 'Glycosyl hydrolases family 16 active sites.', NULL, 'GH16_1', NULL, NULL, 8865, 14),
(281115, NULL, 'PS00345', NULL, NULL, 'Ets-domain signature 1.', NULL, 'ETS_DOMAIN_1', NULL, NULL, 6517, 14),
(281116, NULL, 'PS00877', NULL, NULL, 'Indoleamine 2,3-dioxygenase signature 2.', NULL, 'IDO_2', NULL, NULL, 3043, 14),
(281117, NULL, 'PS00930', NULL, NULL, 'Peripherin / rom-1 signature.', NULL, 'RDS_ROM1', NULL, NULL, 9140, 14),
(281118, NULL, 'PS01321', NULL, NULL, 'Crossover junction endodeoxyribonuclease ruvC signature.', NULL, 'RUVC', NULL, NULL, 18649, 14),
(281119, NULL, 'PS00556', NULL, NULL, 'Hok/gef family cell toxic proteins signature.', NULL, 'HOK_GEF', NULL, NULL, 20789, 14),
(281120, NULL, 'PS00823', NULL, NULL, 'Dehydrins signature 2.', NULL, 'DEHYDRIN_2', NULL, NULL, 24844, 14),
(281121, NULL, 'PS00210', NULL, NULL, 'Arthropod hemocyanins / insect LSPs signature 2.', NULL, 'HEMOCYANIN_2', NULL, NULL, 12518, 14),
(281122, NULL, 'PS00273', NULL, NULL, 'Heat-stable enterotoxins signature.', NULL, 'ENTEROTOXIN_H_STABLE', NULL, NULL, 17079, 14),
(281123, NULL, 'PS00475', NULL, NULL, 'Ribosomal protein L15 signature.', NULL, 'RIBOSOMAL_L15', NULL, NULL, 1256, 14),
(281124, NULL, 'PS00978', NULL, NULL, 'FAD-dependent glycerol-3-phosphate dehydrogenase signature 2.', NULL, 'FAD_G3PDH_2', NULL, NULL, NULL, 14),
(281125, NULL, 'PS01293', NULL, NULL, 'Nudix CoA signature.', NULL, 'NUDIX_COA', NULL, NULL, 2574, 14),
(281126, NULL, 'PS00213', NULL, NULL, 'Lipocalin signature.', NULL, 'LIPOCALIN', NULL, NULL, 15135, 14),
(281127, NULL, 'PS60020', NULL, NULL, 'Janus-faced atracotoxin (J-ACTX) family signature.', NULL, 'J_ACTX', NULL, NULL, 12705, 14),
(281128, NULL, 'PS01145', NULL, NULL, 'Ribosomal protein L34e signature.', NULL, 'RIBOSOMAL_L34E', NULL, NULL, 19808, 14),
(281129, NULL, 'PS00448', NULL, NULL, 'Clostridium cellulosome enzymes repeated domain signature.', NULL, 'CLOS_CELLULOSOME_RPT', NULL, NULL, 5420, 14),
(281130, NULL, 'PS00867', NULL, NULL, 'Carbamoyl-phosphate synthase subdomain signature 2.', NULL, 'CPSASE_2', NULL, NULL, 782, 14),
(281131, NULL, 'PS01353', NULL, NULL, 'Long hematopoietin receptor, gp130 family signature.', NULL, 'HEMATOPO_REC_L_F2', NULL, NULL, 6613, 14),
(281132, NULL, 'PS00214', NULL, NULL, 'Cytosolic fatty-acid binding proteins signature.', NULL, 'FABP', NULL, NULL, 5892, 14),
(281133, NULL, 'PS00174', NULL, NULL, 'Phosphoglucose isomerase signature 2.', NULL, 'P_GLUCOSE_ISOMERASE_2', NULL, NULL, 14793, 14),
(281134, NULL, 'PS00607', NULL, NULL, 'cAMP phosphodiesterases class-II signature.', NULL, 'PDEASE_II', NULL, NULL, 20555, 14),
(281135, NULL, 'PS00622', NULL, NULL, 'LuxR-type HTH domain signature.', NULL, 'HTH_LUXR_1', NULL, NULL, 6599, 14),
(281136, NULL, 'PS01344', NULL, NULL, 'Frataxin family signature.', NULL, 'FRATAXIN_1', NULL, NULL, 19538, 14),
(281137, NULL, 'PS00294', NULL, NULL, 'Prenyl group binding site (CAAX box).', NULL, 'PRENYLATION', NULL, NULL, NULL, 14),
(281138, NULL, 'PS00510', NULL, NULL, 'Malate synthase signature.', NULL, 'MALATE_SYNTHASE', NULL, NULL, 17167, 14),
(281139, NULL, 'PS00624', NULL, NULL, 'GMC oxidoreductases signature 2.', NULL, 'GMC_OXRED_2', NULL, NULL, 3867, 14);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(281140, NULL, 'PS00182', NULL, NULL, 'Glutamine synthetase class-I adenylation site.', NULL, 'GLNA_ADENYLATION', NULL, NULL, 3361, 14),
(281141, NULL, 'PS00319', NULL, NULL, 'Amyloid precursor protein (APP) copper-binding (CuBD) domain signature.', NULL, 'APP_CUBD', NULL, NULL, 12605, 14),
(281142, NULL, 'PS00405', NULL, NULL, '43 Kd postsynaptic protein signature.', NULL, '43_KD_POSTSYNAPTIC', NULL, NULL, 16774, 14),
(281143, NULL, 'PS00565', NULL, NULL, 'Argininosuccinate synthase signature 2.', NULL, 'ARGININOSUCCIN_SYN_2', NULL, NULL, 7986, 14),
(281144, NULL, 'PS00022', NULL, NULL, 'EGF-like domain signature 1.', NULL, 'EGF_1', NULL, NULL, 3525, 14),
(281145, NULL, 'PS00387', NULL, NULL, 'Inorganic pyrophosphatase signature.', NULL, 'PPASE', NULL, NULL, NULL, 14),
(281146, NULL, 'PS01138', NULL, NULL, 'Scorpion short toxins signature.', NULL, 'SCORP_SHORT_TOXIN', NULL, NULL, NULL, 14),
(281147, NULL, 'PS01345', NULL, NULL, 'COE family signature.', NULL, 'COE', NULL, NULL, 8485, 14),
(281148, NULL, 'PS00426', NULL, NULL, 'Cereal trypsin/alpha-amylase inhibitors family signature.', NULL, 'CEREAL_TRYP_AMYL_INH', NULL, NULL, 11414, 14),
(281149, NULL, 'PS00006', NULL, NULL, 'Casein kinase II phosphorylation site.', NULL, 'CK2_PHOSPHO_SITE', NULL, NULL, NULL, 14),
(281150, NULL, 'PS00122', NULL, NULL, 'Carboxylesterases type-B serine active site.', NULL, 'CARBOXYLESTERASE_B_1', NULL, NULL, 17070, 14),
(281151, NULL, 'PS01100', NULL, NULL, 'NNMT/PNMT/TEMT family of methyltransferases signature.', NULL, 'NNMT_PNMT_TEMT', NULL, NULL, 22392, 14),
(281152, NULL, 'PS00439', NULL, NULL, 'Acyltransferases ChoActase / COT / CPT family signature 1.', NULL, 'ACYLTRANSF_C_1', NULL, NULL, 4356, 14),
(281153, NULL, 'PS00748', NULL, NULL, 'F-actin capping protein alpha subunit signature 1.', NULL, 'F_ACTIN_CAPPING_A_1', NULL, NULL, 18559, 14),
(281154, NULL, 'PS01246', NULL, NULL, 'Uncharacterized protein family UPF0003 signature.', NULL, 'UPF0003', NULL, NULL, 2477, 14),
(281155, NULL, 'PS01339', NULL, NULL, 'SURF4 family signature.', NULL, 'SURF4', NULL, NULL, 7423, 14),
(281156, NULL, 'PS00856', NULL, NULL, 'Guanylate kinase-like signature.', NULL, 'GUANYLATE_KINASE_1', NULL, NULL, 20776, 14),
(281157, NULL, 'PS00034', NULL, NULL, 'Paired DNA-binding domain signature.', NULL, 'PAIRED_1', NULL, NULL, 37333, 14),
(281158, NULL, 'PS00434', NULL, NULL, 'HSF-type DNA-binding domain signature.', NULL, 'HSF_DOMAIN', NULL, NULL, 689, 14),
(281159, NULL, 'PS01157', NULL, NULL, 'Class A bacterial acid phosphatases signature.', NULL, 'ACID_PHOSPH_CL_A', NULL, NULL, 16707, 14),
(281160, NULL, 'PS01245', NULL, NULL, 'RIO1/ZK632.3/MJ0444 family signature.', NULL, 'RIO1', NULL, NULL, 9352, 14),
(281161, NULL, 'PS00235', NULL, NULL, 'Gas vesicles protein GVPc repeated domain signature.', NULL, 'GAS_VESICLE_C', NULL, NULL, 7622, 14),
(281162, NULL, 'PS00561', NULL, NULL, 'CBM2a (carbohydrate-binding type-2) domain signature.', NULL, 'CBM2_A', NULL, NULL, 20178, 14),
(281163, NULL, 'PS01328', NULL, NULL, '4-hydroxybenzoyl-CoA thioesterase family active site.', NULL, '4HBCOA_THIOESTERASE', NULL, NULL, 8516, 14),
(281164, NULL, 'PS00714', NULL, NULL, 'Sodium:dicarboxylate symporter family signature 2.', NULL, 'NA_DICARBOXYL_SYMP_2', NULL, NULL, 13643, 14),
(281165, NULL, 'PS01256', NULL, NULL, 'Cullin family signature.', NULL, 'CULLIN_1', NULL, NULL, 11593, 14),
(281166, NULL, 'PS00732', NULL, NULL, 'Ribosomal protein S16 signature.', NULL, 'RIBOSOMAL_S16', NULL, NULL, 20519, 14),
(281167, NULL, 'PS00864', NULL, NULL, 'Calsequestrin signature 2.', NULL, 'CALSEQUESTRIN_2', NULL, NULL, 7834, 14),
(281168, NULL, 'PS00990', NULL, NULL, 'Clathrin adaptor complexes medium chain signature 1.', NULL, 'CLAT_ADAPTOR_M_1', NULL, NULL, 8300, 14),
(281169, NULL, 'PS00020', NULL, NULL, 'Actinin-type actin-binding domain signature 2.', NULL, 'ACTININ_2', NULL, NULL, 3190, 14),
(281170, NULL, 'PS00914', NULL, NULL, 'Syntaxin / epimorphin family signature.', NULL, 'SYNTAXIN', NULL, NULL, 1178, 14),
(281171, NULL, 'PS00342', NULL, NULL, 'Microbodies C-terminal targeting signal.', NULL, 'MICROBODIES_CTER', NULL, NULL, NULL, 14);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(281172, NULL, 'PS00137', NULL, NULL, 'Serine proteases, subtilase family, histidine active site.', NULL, 'SUBTILASE_HIS', NULL, NULL, 14975, 14),
(281173, NULL, 'PS00284', NULL, NULL, 'Serpins signature.', NULL, 'SERPIN', NULL, NULL, 16743, 14),
(281174, NULL, 'PS00552', NULL, NULL, 'MerR-type HTH domain signature.', NULL, 'HTH_MERR_1', NULL, NULL, 5889, 14),
(281175, NULL, 'PS00845', NULL, NULL, 'CAP-Gly domain signature.', NULL, 'CAP_GLY_1', NULL, NULL, 3027, 14),
(281176, NULL, 'PS00912', NULL, NULL, 'Dihydroorotate dehydrogenase signature 2.', NULL, 'DHODEHASE_2', NULL, NULL, 589, 14),
(281177, NULL, 'PS01008', NULL, NULL, 'DnaA protein signature.', NULL, 'DNAA', NULL, NULL, 8354, 14),
(281178, NULL, 'PS00522', NULL, NULL, 'DNA polymerase family X signature.', NULL, 'DNA_POLYMERASE_X', NULL, NULL, 18052, 14),
(281179, NULL, 'PS01227', NULL, NULL, 'Uncharacterized protein family UPF0012 signature.', NULL, 'UPF0012', NULL, NULL, 2343, 14),
(281180, NULL, 'PS01278', NULL, NULL, 'Methylthiotransferase radical SAM domain signature.', NULL, 'MTTASE_RADICAL', NULL, NULL, 20373, 14),
(281181, NULL, 'PS00270', NULL, NULL, 'Endothelin family signature.', NULL, 'ENDOTHELIN', NULL, NULL, 20892, 14),
(281182, NULL, 'PS00668', NULL, NULL, 'Respiratory-chain NADH dehydrogenase subunit 1 signature 2.', NULL, 'COMPLEX1_ND1_2', NULL, NULL, 13868, 14),
(281183, NULL, 'PS00894', NULL, NULL, 'DeoR-type HTH domain signature.', NULL, 'HTH_DEOR_1', NULL, NULL, 20084, 14),
(281184, NULL, 'PS00352', NULL, NULL, 'Cold-shock (CSD) domain signature.', NULL, 'CSD_1', NULL, NULL, 18438, 14),
(281185, NULL, 'PS00467', NULL, NULL, 'Ribosomal protein L2 signature.', NULL, 'RIBOSOMAL_L2', NULL, NULL, 15142, 14),
(281186, NULL, 'PS01037', NULL, NULL, 'Bacterial extracellular solute-binding proteins, family 1 signature.', NULL, 'SBP_BACTERIAL_1', NULL, NULL, 2963, 14),
(281187, NULL, 'PS00649', NULL, NULL, 'G-protein coupled receptors family 2 signature 1.', NULL, 'G_PROTEIN_RECEP_F2_1', NULL, NULL, 19312, 14),
(281188, NULL, 'PS00638', NULL, NULL, 'P-II protein C-terminal region signature.', NULL, 'PII_GLNB_CTER', NULL, NULL, 12503, 14),
(281189, NULL, 'PS00260', NULL, NULL, 'Glucagon / GIP / secretin / VIP family signature.', NULL, 'GLUCAGON', NULL, NULL, 5895, 14),
(281190, NULL, 'PS00501', NULL, NULL, 'Signal peptidases I serine active site.', NULL, 'SPASE_I_1', NULL, NULL, 20552, 14),
(281191, NULL, 'PS00113', NULL, NULL, 'Adenylate kinase signature.', NULL, 'ADENYLATE_KINASE', NULL, NULL, 27986, 14),
(281192, NULL, 'PS00741', NULL, NULL, 'Dbl homology (DH) domain signature.', NULL, 'DH_1', NULL, NULL, 2470, 14),
(281193, NULL, 'PS00599', NULL, NULL, 'Aminotransferases class-II pyridoxal-phosphate attachment site.', NULL, 'AA_TRANSFER_CLASS_2', NULL, NULL, 5495, 14),
(281194, NULL, 'PS00265', NULL, NULL, 'Pancreatic hormone family signature.', NULL, 'PANCREATIC_HORMONE_1', NULL, NULL, 19751, 14),
(281195, NULL, 'PS00550', NULL, NULL, 'Hemerythrin family signature.', NULL, 'HEMERYTHRINS', NULL, NULL, 11404, 14),
(281196, NULL, 'PS00296', NULL, NULL, 'Chaperonins cpn60 signature.', NULL, 'CHAPERONINS_CPN60', NULL, NULL, 20150, 14),
(281197, NULL, 'PS00998', NULL, NULL, 'G10 protein signature 2.', NULL, 'G10_2', NULL, NULL, 7768, 14),
(281198, NULL, 'PS00095', NULL, NULL, 'C-5 cytosine-specific DNA methylases C-terminal signature.', NULL, 'C5_MTASE_2', NULL, NULL, 25275, 14),
(281199, NULL, 'PS00731', NULL, NULL, 'AP endonucleases family 2 signature 3.', NULL, 'AP_NUCLEASE_F2_3', NULL, NULL, 8256, 14),
(281200, NULL, 'PS00783', NULL, NULL, 'Ribosomal protein L13 signature.', NULL, 'RIBOSOMAL_L13', NULL, NULL, 10066, 14),
(281201, NULL, 'PS00896', NULL, NULL, 'LacY family proton/sugar symporters signature 1.', NULL, 'LACY_1', NULL, NULL, 15547, 14),
(281202, NULL, 'PS00395', NULL, NULL, 'Alanine racemase pyridoxal-phosphate attachment site.', NULL, 'ALANINE_RACEMASE', NULL, NULL, 20098, 14),
(281203, NULL, 'PS00253', NULL, NULL, 'Interleukin-1 signature.', NULL, 'INTERLEUKIN_1', NULL, NULL, 19554, 14),
(281204, NULL, 'PS00420', NULL, NULL, 'SRCR domain signature.', NULL, 'SRCR_1', NULL, NULL, 1378, 14);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(281205, NULL, 'PS00871', NULL, NULL, 'Chaperonins clpA/B signature 2.', NULL, 'CLPAB_2', NULL, NULL, 23707, 14),
(281206, NULL, 'PS00759', NULL, NULL, 'ArgE / dapE / ACY1 / CPG2 / yscS family signature 2.', NULL, 'ARGE_DAPE_CPG2_2', NULL, NULL, 1127, 14),
(281207, NULL, 'PS00009', NULL, NULL, 'Amidation site.', NULL, 'AMIDATION', NULL, NULL, NULL, 14),
(281208, NULL, 'PS01140', NULL, NULL, 'Glycosyl hydrolases family 45 active site.', NULL, 'GLYCOSYL_HYDROL_F45', NULL, NULL, 4762, 14),
(281209, NULL, 'PS00408', NULL, NULL, 'Connexins signature 2.', NULL, 'CONNEXINS_2', NULL, NULL, 19115, 14),
(281210, NULL, 'PS00969', NULL, NULL, 'Antenna complexes beta subunits signature.', NULL, 'ANTENNA_COMP_BETA', NULL, NULL, 12321, 14),
(281211, NULL, 'PS01087', NULL, NULL, 'Radical activating enzymes signature.', NULL, 'RADICAL_ACTIVATING', NULL, NULL, 2022, 14),
(281212, NULL, 'PS00532', NULL, NULL, 'Phosphoenolpyruvate carboxykinase (ATP) signature.', NULL, 'PEPCK_ATP', NULL, NULL, 9494, 14),
(281213, NULL, 'PS00229', NULL, NULL, 'Tau and MAP proteins tubulin-binding repeat signature.', NULL, 'TAU_MAP_1', NULL, NULL, 2304, 14),
(281214, NULL, 'PS00674', NULL, NULL, 'AAA-protein family signature.', NULL, 'AAA', NULL, NULL, 7458, 14),
(281215, NULL, 'PS00785', NULL, NULL, '5''-nucleotidase signature 1.', NULL, '5_NUCLEOTIDASE_1', NULL, NULL, 10072, 14),
(281216, NULL, 'PS00733', NULL, NULL, 'Ribosomal protein S26e signature.', NULL, 'RIBOSOMAL_S26E', NULL, NULL, 4610, 14),
(281217, NULL, 'PS00559', NULL, NULL, 'Eukaryotic molybdopterin oxidoreductases signature.', NULL, 'MOLYBDOPTERIN_EUK', NULL, NULL, 21291, 14),
(281218, NULL, 'PS00092', NULL, NULL, 'N-6 Adenine-specific DNA methylases signature.', NULL, 'N6_MTASE', NULL, NULL, 1013, 14),
(281219, NULL, 'PS00313', NULL, NULL, 'Seminal vesicle protein I repeats signature.', NULL, 'SVP_I', NULL, NULL, 1059, 14),
(281220, NULL, 'PS00528', NULL, NULL, 'Ribosomal protein S4e signature.', NULL, 'RIBOSOMAL_S4E', NULL, NULL, 20001, 14),
(281221, NULL, 'PS01169', NULL, NULL, 'Ribosomal protein L21 signature.', NULL, 'RIBOSOMAL_L21', NULL, NULL, 19712, 14),
(281222, NULL, 'PS01010', NULL, NULL, 'CRISP family signature 2.', NULL, 'CRISP_2', NULL, NULL, 8393, 14),
(281223, NULL, 'PS00138', NULL, NULL, 'Serine proteases, subtilase family, serine active site.', NULL, 'SUBTILASE_SER', NULL, NULL, 9698, 14),
(281224, NULL, 'PS00181', NULL, NULL, 'Glutamine synthetase putative ATP-binding region signature.', NULL, 'GLNA_ATP', NULL, NULL, 25533, 14),
(281225, NULL, 'PS00286', NULL, NULL, 'Squash family of serine protease inhibitors signature.', NULL, 'SQUASH_INHIBITOR', NULL, NULL, 6742, 14),
(281226, NULL, 'PS00109', NULL, NULL, 'Tyrosine protein kinases specific active-site signature.', NULL, 'PROTEIN_KINASE_TYR', NULL, NULL, 8524, 14),
(281227, NULL, 'PS00353', NULL, NULL, 'HMG box A DNA-binding domain signature.', NULL, 'HMG_BOX_1', NULL, NULL, 12539, 14),
(281228, NULL, 'PS00623', NULL, NULL, 'GMC oxidoreductases signature 1.', NULL, 'GMC_OXRED_1', NULL, NULL, 3867, 14),
(281229, NULL, 'PS00051', NULL, NULL, 'Ribosomal protein L39e signature.', NULL, 'RIBOSOMAL_L39E', NULL, NULL, 16340, 14),
(281230, NULL, 'PS00459', NULL, NULL, 'Myotoxins signature.', NULL, 'MYOTOXINS_1', NULL, NULL, 4565, 14),
(281231, NULL, 'PS00136', NULL, NULL, 'Serine proteases, subtilase family, aspartic acid active site.', NULL, 'SUBTILASE_ASP', NULL, NULL, 9507, 14),
(281232, NULL, 'PS00134', NULL, NULL, 'Serine proteases, trypsin family, histidine active site.', NULL, 'TRYPSIN_HIS', NULL, NULL, 13908, 14),
(281233, NULL, 'PS01078', NULL, NULL, 'Molybdenum cofactor biosynthesis proteins signature 1.', NULL, 'MOCF_BIOSYNTHESIS_1', NULL, NULL, 9527, 14),
(281234, NULL, 'PS00308', NULL, NULL, 'Legume lectins alpha-chain signature.', NULL, 'LECTIN_LEGUME_ALPHA', NULL, NULL, 3233, 14),
(281235, NULL, 'PS00332', NULL, NULL, 'Copper/Zinc superoxide dismutase signature 2.', NULL, 'SOD_CU_ZN_2', NULL, NULL, 19133, 14),
(281236, NULL, 'PS00449', NULL, NULL, 'ATP synthase a subunit signature.', NULL, 'ATPASE_A', NULL, NULL, 15096, 14);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(281237, NULL, 'PS00157', NULL, NULL, 'Ribulose bisphosphate carboxylase large chain active site.', NULL, 'RUBISCO_LARGE', NULL, NULL, 19984, 14),
(281238, NULL, 'PS00833', NULL, NULL, '2''-5''-oligoadenylate synthases signature 2.', NULL, '25A_SYNTH_2', NULL, NULL, 10187, 14),
(281239, NULL, 'PS60000', NULL, NULL, 'Chitosanases families 46 and 80 active sites signature.', NULL, 'CHITOSANASE_46_80', NULL, NULL, 6621, 14),
(281240, NULL, 'PS60003', NULL, NULL, 'Phosphoketolase signature 2.', NULL, 'PHOSPHOKETOLASE_2', NULL, NULL, 17260, 14),
(281241, NULL, 'PS00647', NULL, NULL, 'Thymidine and pyrimidine-nucleoside phosphorylases signature.', NULL, 'THYMID_PHOSPHORYLASE', NULL, NULL, 7478, 14),
(281242, NULL, 'PS00188', NULL, NULL, 'Biotin-requiring enzymes attachment site.', NULL, 'BIOTIN', NULL, NULL, 4487, 14),
(281243, NULL, 'PS01175', NULL, NULL, 'Ribonuclease II family signature.', NULL, 'RIBONUCLEASE_II', NULL, NULL, 15642, 14),
(281244, NULL, 'PS00899', NULL, NULL, 'Ependymins signature 2.', NULL, 'EPENDYMIN_2', NULL, NULL, 7715, 14),
(281245, NULL, 'PS00427', NULL, NULL, 'Disintegrins signature.', NULL, 'DISINTEGRIN_1', NULL, NULL, 20285, 14),
(281246, NULL, 'PS00107', NULL, NULL, 'Protein kinases ATP-binding region signature.', NULL, 'PROTEIN_KINASE_ATP', NULL, NULL, 11975, 14),
(281247, NULL, 'PS00378', NULL, NULL, 'Hexokinase domain signature.', NULL, 'HEXOKINASE_1', NULL, NULL, 17011, 14),
(281248, NULL, 'PS00724', NULL, NULL, 'Stress-induced proteins SRP1/TIP1 family signature.', NULL, 'SRP1_TIP1', NULL, NULL, 3220, 14),
(281249, NULL, 'PS00970', NULL, NULL, 'Nuclear transition protein 2 signature 1.', NULL, 'TP2_1', NULL, NULL, 3572, 14),
(281250, NULL, 'PS00259', NULL, NULL, 'Gastrin / cholecystokinin family signature.', NULL, 'GASTRIN', NULL, NULL, 6174, 14),
(281251, NULL, 'PS00545', NULL, NULL, 'Aldose 1-epimerase putative active site.', NULL, 'ALDOSE_1_EPIMERASE', NULL, NULL, 16956, 14),
(281252, NULL, 'PS60018', NULL, NULL, 'Delta-atracotoxin (ACTX) family signature.', NULL, 'DELTA_ACTX', NULL, NULL, 5383, 14),
(281253, NULL, 'PS01360', NULL, NULL, 'Zinc finger MYND-type signature.', NULL, 'ZF_MYND_1', NULL, NULL, 6032, 14),
(281254, NULL, 'PS00278', NULL, NULL, 'Staphyloccocal enterotoxin/Streptococcal pyrogenic exotoxin signature 2.', NULL, 'STAPH_STREP_TOXIN_2', NULL, NULL, 10178, 14),
(281255, NULL, 'PS00892', NULL, NULL, 'HIT domain signature.', NULL, 'HIT_1', NULL, NULL, 17243, 14),
(281256, NULL, 'PS01177', NULL, NULL, 'Anaphylatoxin domain signature.', NULL, 'ANAPHYLATOXIN_1', NULL, NULL, 2547, 14),
(281257, NULL, 'PS00397', NULL, NULL, 'Site-specific recombinases active site.', NULL, 'RECOMBINASES_1', NULL, NULL, 10188, 14),
(281258, NULL, 'PS00476', NULL, NULL, 'Fatty acid desaturases family 1 signature.', NULL, 'FATTY_ACID_DESATUR_1', NULL, NULL, 5803, 14),
(281259, NULL, 'PS00710', NULL, NULL, 'Phosphoglucomutase and phosphomannomutase phosphoserine signature.', NULL, 'PGM_PMM', NULL, NULL, 10325, 14),
(281260, NULL, 'PS00212', NULL, NULL, 'Albumin domain signature.', NULL, 'ALBUMIN_1', NULL, NULL, 21032, 14),
(281261, NULL, 'PS00964', NULL, NULL, 'Syndecans signature.', NULL, 'SYNDECAN', NULL, NULL, 23186, 14),
(281262, NULL, 'PS01244', NULL, NULL, 'Aconitase family signature 2.', NULL, 'ACONITASE_2', NULL, NULL, 19648, 14),
(281263, NULL, 'PS00719', NULL, NULL, 'Glycosyl hydrolases family 2 signature 1.', NULL, 'GLYCOSYL_HYDROL_F2_1', NULL, NULL, 15917, 14),
(281264, NULL, 'PS00239', NULL, NULL, 'Receptor tyrosine kinase class II signature.', NULL, 'RECEPTOR_TYR_KIN_II', NULL, NULL, 2270, 14),
(281265, NULL, 'PS00945', NULL, NULL, 'Cyclin-dependent kinases regulatory subunits signature 2.', NULL, 'CKS_2', NULL, NULL, 4563, 14),
(281266, NULL, 'PS01260', NULL, NULL, 'Apoptosis regulator, Bcl-2 family BH4 motif signature.', NULL, 'BH4_1', NULL, NULL, 19147, 14),
(281267, NULL, 'PS01012', NULL, NULL, 'Folylpolyglutamate synthase signature 2.', NULL, 'FOLYLPOLYGLU_SYNT_2', NULL, NULL, 13833, 14),
(281268, NULL, 'PS00643', NULL, NULL, 'Respiratory-chain NADH dehydrogenase 75 Kd subunit signature 3.', NULL, 'COMPLEX1_75K_3', NULL, NULL, 622, 14); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(281269, NULL, 'PS00798', NULL, NULL, 'Aldo/keto reductase family signature 1.', NULL, 'ALDOKETO_REDUCTASE_1', NULL, NULL, 11896, 14),
(281270, NULL, 'PS00012', NULL, NULL, 'Phosphopantetheine attachment site.', NULL, 'PHOSPHOPANTETHEINE', NULL, NULL, 10298, 14),
(281271, NULL, 'PS01060', NULL, NULL, 'Flagella transport protein fliP family signature 1.', NULL, 'FLIP_1', NULL, NULL, 5727, 14),
(281272, NULL, 'PS00250', NULL, NULL, 'TGF-beta family signature.', NULL, 'TGF_BETA_1', NULL, NULL, 2598, 14),
(281273, NULL, 'PS00383', NULL, NULL, 'Tyrosine specific protein phosphatases active site.', NULL, 'TYR_PHOSPHATASE_1', NULL, NULL, 11239, 14),
(281274, NULL, 'PS01253', NULL, NULL, 'Fibronectin type-I domain signature.', NULL, 'FN1_1', NULL, NULL, 3709, 14),
(281275, NULL, 'PS00468', NULL, NULL, 'Eukaryotic cobalamin-binding proteins signature.', NULL, 'COBALAMIN_BINDING', NULL, NULL, 465, 14),
(281276, NULL, 'PS00530', NULL, NULL, 'Ribonuclease T2 family histidine active site 1.', NULL, 'RNASE_T2_1', NULL, NULL, 14813, 14),
(281277, NULL, 'PS00673', NULL, NULL, 'Serine proteases, V8 family, serine active site.', NULL, 'V8_SER', NULL, NULL, 3711, 14),
(281278, NULL, 'PS00177', NULL, NULL, 'DNA topoisomerase II signature.', NULL, 'TOPOISOMERASE_II', NULL, NULL, 19720, 14),
(281279, NULL, 'PS00653', NULL, NULL, 'Glycosyl hydrolases family 1 N-terminal signature.', NULL, 'GLYCOSYL_HYDROL_F1_2', NULL, NULL, 27883, 14),
(281280, NULL, 'PS00908', NULL, NULL, 'Mandelate racemase / muconate lactonizing enzyme family signature 1.', NULL, 'MR_MLE_1', NULL, NULL, 13681, 14),
(281281, NULL, 'PS00790', NULL, NULL, 'Receptor tyrosine kinase class V signature 1.', NULL, 'RECEPTOR_TYR_KIN_V_1', NULL, NULL, 5236, 14),
(281282, NULL, 'PS00963', NULL, NULL, 'Ribosomal protein S2 signature 2.', NULL, 'RIBOSOMAL_S2_2', NULL, NULL, 19613, 14),
(281283, NULL, 'PS00337', NULL, NULL, 'Beta-lactamase class-D active site.', NULL, 'BETA_LACTAMASE_D', NULL, NULL, 1374, 14),
(281284, NULL, 'PS01184', NULL, NULL, 'ubiE/COQ5 methyltransferase family signature 2.', NULL, 'UBIE_2', NULL, NULL, 16094, 14),
(281285, NULL, 'PS00888', NULL, NULL, 'Cyclic nucleotide-binding domain signature 1.', NULL, 'CNMP_BINDING_1', NULL, NULL, 21313, 14),
(281286, NULL, 'PS00191', NULL, NULL, 'Cytochrome b5 family, heme-binding domain signature.', NULL, 'CYTOCHROME_B5_1', NULL, NULL, 19028, 14),
(281287, NULL, 'PS01305', NULL, NULL, 'moaA / nifB / pqqE family signature.', NULL, 'MOAA_NIFB_PQQE', NULL, NULL, 6680, 14),
(281288, NULL, 'PS01219', NULL, NULL, 'Ammonium transporters signature.', NULL, 'AMMONIUM_TRANSP', NULL, NULL, 14529, 14),
(281289, NULL, 'PS01284', NULL, NULL, 'Thermonuclease family signature 2.', NULL, 'TNASE_2', NULL, NULL, 1101, 14),
(281290, NULL, 'PS01040', NULL, NULL, 'Bacterial extracellular solute-binding proteins, family 5 signature.', NULL, 'SBP_BACTERIAL_5', NULL, NULL, 16950, 14),
(281291, NULL, 'PS00975', NULL, NULL, 'Myristoyl-CoA:protein N-myristoyltransferase signature 1.', NULL, 'NMT_1', NULL, NULL, 16537, 14),
(281292, NULL, 'PS00429', NULL, NULL, 'Staphylocoagulase repeat signature.', NULL, 'STAPHYLOCOAGULASE', NULL, NULL, 3215, 14),
(281293, NULL, 'PS00432', NULL, NULL, 'Actins signature 2.', NULL, 'ACTINS_2', NULL, NULL, 772, 14),
(281294, NULL, 'PS00054', NULL, NULL, 'Ribosomal protein S11 signature.', NULL, 'RIBOSOMAL_S11', NULL, NULL, 13979, 14),
(281295, NULL, 'PS00740', NULL, NULL, 'MAM domain signature.', NULL, 'MAM_1', NULL, NULL, 3140, 14),
(281296, NULL, 'PS00763', NULL, NULL, 'Glutathione peroxidases signature 2.', NULL, 'GLUTATHIONE_PEROXID_2', NULL, NULL, 24054, 14),
(281297, NULL, 'PS00189', NULL, NULL, '2-oxo acid dehydrogenases acyltransferase component lipoyl binding site.', NULL, 'LIPOYL', NULL, NULL, 184, 14),
(281298, NULL, 'PS00654', NULL, NULL, 'PRD domain signature.', NULL, 'PRD_1', NULL, NULL, 5325, 14),
(281299, NULL, 'PS00024', NULL, NULL, 'Hemopexin domain signature.', NULL, 'HEMOPEXIN', NULL, NULL, 21163, 14),
(281300, NULL, 'PS00384', NULL, NULL, 'Prokaryotic zinc-dependent phospholipase C signature.', NULL, 'PROKAR_ZN_DEPEND_PLPC_1', NULL, NULL, 3136, 14);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(281301, NULL, 'PS01091', NULL, NULL, 'TatD deoxyribonuclease family signature 3.', NULL, 'TATD_3', NULL, NULL, 7770, 14),
(281302, NULL, 'PS00839', NULL, NULL, 'Uroporphyrin-III C-methyltransferase signature 1.', NULL, 'SUMT_1', NULL, NULL, 822, 14),
(281303, NULL, 'PS00523', NULL, NULL, 'Sulfatases signature 1.', NULL, 'SULFATASE_1', NULL, NULL, 26550, 14),
(281304, NULL, 'PS00513', NULL, NULL, 'Adenylosuccinate synthetase active site.', NULL, 'ADENYLOSUCCIN_SYN_2', NULL, NULL, 32597, 14),
(281305, NULL, 'PS00272', NULL, NULL, 'Snake toxins signature.', NULL, 'SNAKE_TOXIN', NULL, NULL, 8186, 14),
(281306, NULL, 'PS00577', NULL, NULL, 'Avidin-like domain signature.', NULL, 'AVIDIN_1', NULL, NULL, 12538, 14),
(281307, NULL, 'PS00415', NULL, NULL, 'Synapsins signature 1.', NULL, 'SYNAPSIN_1', NULL, NULL, 12633, 14),
(281308, NULL, 'PS00500', NULL, NULL, 'Thymosin beta-4 family signature.', NULL, 'THYMOSIN_B4', NULL, NULL, 1377, 14),
(281309, NULL, 'PS00750', NULL, NULL, 'Chaperonins TCP-1 signature 1.', NULL, 'TCP1_1', NULL, NULL, 467, 14),
(281310, NULL, 'PS00197', NULL, NULL, '2Fe-2S ferredoxin-type iron-sulfur binding region signature.', NULL, '2FE2S_FER_1', NULL, NULL, 2545, 14),
(281311, NULL, 'PS00086', NULL, NULL, 'Cytochrome P450 cysteine heme-iron ligand signature.', NULL, 'CYTOCHROME_P450', NULL, NULL, 12870, 14),
(281312, NULL, 'PS01181', NULL, NULL, 'Ribosomal protein S21 signature.', NULL, 'RIBOSOMAL_S21', NULL, NULL, 19844, 14),
(281313, NULL, 'PS01188', NULL, NULL, 'ELO family signature.', NULL, 'ELO', NULL, NULL, 22492, 14),
(281314, NULL, 'PS01021', NULL, NULL, 'Coproporphyrinogen III oxidase signature.', NULL, 'COPROGEN_OXIDASE', NULL, NULL, 20257, 14),
(281315, NULL, 'PS00691', NULL, NULL, 'DNA photolyases class 1 signature 2.', NULL, 'DNA_PHOTOLYASES_1_2', NULL, NULL, 8199, 14),
(281316, NULL, 'PS00350', NULL, NULL, 'MADS-box domain signature.', NULL, 'MADS_BOX_1', NULL, NULL, 1200, 14),
(281317, NULL, 'PS00604', NULL, NULL, 'Synaptophysin / synaptoporin signature.', NULL, 'SYNAPTOP', NULL, NULL, 107, 14),
(281318, NULL, 'PS00884', NULL, NULL, 'Osteopontin signature.', NULL, 'OSTEOPONTIN', NULL, NULL, 14332, 14),
(281319, NULL, 'PS00627', NULL, NULL, 'GHMP kinases putative ATP-binding domain.', NULL, 'GHMP_KINASES_ATP', NULL, NULL, 11364, 14),
(281320, NULL, 'PS00666', NULL, NULL, 'Dihydrodipicolinate synthase signature 2.', NULL, 'DHDPS_2', NULL, NULL, 20313, 14),
(281321, NULL, 'PS00436', NULL, NULL, 'Peroxidases active site signature.', NULL, 'PEROXIDASE_2', NULL, NULL, 17174, 14),
(281322, NULL, 'PS00687', NULL, NULL, 'Aldehyde dehydrogenases glutamic acid active site.', NULL, 'ALDEHYDE_DEHYDR_GLU', NULL, NULL, 22411, 14),
(281323, NULL, 'PS00102', NULL, NULL, 'Phosphorylase pyridoxal-phosphate attachment site.', NULL, 'PHOSPHORYLASE', NULL, NULL, 9216, 14),
(281324, NULL, 'PS00441', NULL, NULL, 'Chalcone and stilbene synthases active site.', NULL, 'CHALCONE_SYNTH', NULL, NULL, 13576, 14),
(281325, NULL, 'PS00780', NULL, NULL, 'Glycoprotein hormones alpha chain signature 2.', NULL, 'GLYCO_HORMONE_ALPHA_2', NULL, NULL, 5533, 14),
(281326, NULL, 'PS01356', NULL, NULL, 'Short hematopoietin receptor family 2 signature.', NULL, 'HEMATOPO_REC_S_F2', NULL, NULL, 6614, 14),
(281327, NULL, 'PS00752', NULL, NULL, 'XPA protein signature 1.', NULL, 'XPA_1', NULL, NULL, 16808, 14),
(281328, NULL, 'PS00582', NULL, NULL, 'Ribosomal protein L33 signature.', NULL, 'RIBOSOMAL_L33', NULL, NULL, 19921, 14),
(281329, NULL, 'PS00447', NULL, NULL, 'DNA polymerase family A signature.', NULL, 'DNA_POLYMERASE_A', NULL, NULL, 20748, 14),
(281330, NULL, 'PS01129', NULL, NULL, 'Rlu family of pseudouridine synthase signature.', NULL, 'PSI_RLU', NULL, NULL, 11465, 14),
(281331, NULL, 'PS01105', NULL, NULL, 'Ribosomal protein L35Ae signature.', NULL, 'RIBOSOMAL_L35AE', NULL, NULL, 19807, 14),
(281332, NULL, 'PS00942', NULL, NULL, 'glpT family of transporters signature.', NULL, 'GLPT', NULL, NULL, 21378, 14),
(281333, NULL, 'PS00983', NULL, NULL, 'Ly-6 / u-PAR domain signature.', NULL, 'LY6_UPAR', NULL, NULL, 20225, 14); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(281334, NULL, 'PS00651', NULL, NULL, 'Ribosomal protein L9 signature.', NULL, 'RIBOSOMAL_L9', NULL, NULL, 18697, 14),
(281335, NULL, 'PS00036', NULL, NULL, 'Basic-leucine zipper (bZIP) domain signature.', NULL, 'BZIP_BASIC', NULL, NULL, 4006, 14),
(281336, NULL, 'PS00057', NULL, NULL, 'Ribosomal protein S18 signature.', NULL, 'RIBOSOMAL_S18', NULL, NULL, 19742, 14),
(281337, NULL, 'PS00483', NULL, NULL, 'Dihydroorotase signature 2.', NULL, 'DIHYDROOROTASE_2', NULL, NULL, 372, 14),
(281338, NULL, 'PS00951', NULL, NULL, 'ER lumen protein retaining receptor signature 1.', NULL, 'ER_LUMEN_RECEPTOR_1', NULL, NULL, 3614, 14),
(281339, NULL, 'PS00201', NULL, NULL, 'Flavodoxin signature.', NULL, 'FLAVODOXIN', NULL, NULL, 1135, 14),
(281340, NULL, 'PS01107', NULL, NULL, 'Ribosomal protein L27e signature.', NULL, 'RIBOSOMAL_L27E', NULL, NULL, 19591, 14),
(281341, NULL, 'PS60001', NULL, NULL, 'Nitric oxide synthase (NOS) signature.', NULL, 'NOS', NULL, NULL, 950, 14),
(281342, NULL, 'PS00554', NULL, NULL, 'TEA domain signature.', NULL, 'TEA_1', NULL, NULL, 4900, 14),
(281343, NULL, 'PS00902', NULL, NULL, 'Glutamate 5-kinase signature.', NULL, 'GLUTAMATE_5_KINASE', NULL, NULL, 17302, 14),
(281344, NULL, 'PS00948', NULL, NULL, 'Ribosomal protein S7e signature.', NULL, 'RIBOSOMAL_S7E', NULL, NULL, 5757, 14),
(281345, NULL, 'PS60007', NULL, NULL, 'Tyrosine kinase phosphorylation site 2.', NULL, 'TYR_PHOSPHO_SITE_2', NULL, NULL, NULL, 14),
(281346, NULL, 'PS00370', NULL, NULL, 'PEP-utilizing enzymes phosphorylation site signature.', NULL, 'PEP_ENZYMES_PHOS_SITE', NULL, NULL, 8213, 14),
(281347, NULL, 'PS00511', NULL, NULL, 'Corticotropin-releasing factor family signature.', NULL, 'CRF', NULL, NULL, 16720, 14),
(281348, NULL, 'PS00534', NULL, NULL, 'Ferrochelatase signature.', NULL, 'FERROCHELATASE', NULL, NULL, 17190, 14),
(281349, NULL, 'PS00085', NULL, NULL, 'Copper type II, ascorbate-dependent monooxygenases signature 2.', NULL, 'CU2_MONOOXYGENASE_2', NULL, NULL, 8504, 14),
(281350, NULL, 'PS00503', NULL, NULL, 'Pectinesterase signature 2.', NULL, 'PECTINESTERASE_2', NULL, NULL, 27692, 14),
(281351, NULL, 'PS00584', NULL, NULL, 'pfkB family of carbohydrate kinases signature 2.', NULL, 'PFKB_KINASES_2', NULL, NULL, 259, 14),
(281352, NULL, 'PS00283', NULL, NULL, 'Soybean trypsin inhibitor (Kunitz) protease inhibitors family signature.', NULL, 'SOYBEAN_KUNITZ', NULL, NULL, 305, 14),
(281353, NULL, 'PS00766', NULL, NULL, 'Tetrahydrofolate dehydrogenase/cyclohydrolase signature 1.', NULL, 'THF_DHG_CYH_1', NULL, NULL, 18936, 14),
(281354, NULL, 'PS00809', NULL, NULL, 'ADP-glucose pyrophosphorylase signature 2.', NULL, 'ADP_GLC_PYROPHOSPH_2', NULL, NULL, 5594, 14),
(281355, NULL, 'PS01334', NULL, NULL, 'Pyrrolidone-carboxylate peptidase cysteine active site.', NULL, 'PYRASE_CYS', NULL, NULL, 28295, 14),
(281356, NULL, 'PS00362', NULL, NULL, 'Ribosomal protein S15 signature.', NULL, 'RIBOSOMAL_S15', NULL, NULL, 5694, 14),
(281357, NULL, 'PS00755', NULL, NULL, 'Protein secY signature 1.', NULL, 'SECY_1', NULL, NULL, 23767, 14),
(281358, NULL, 'PS01222', NULL, NULL, 'PMP-22 / EMP / MP20 family signature 2.', NULL, 'PMP22_2', NULL, NULL, 823, 14),
(281359, NULL, 'PS60013', NULL, NULL, 'Mu-conotoxin family signature.', NULL, 'MU_CONOTOXIN', NULL, NULL, 5352, 14),
(281360, NULL, 'PS00326', NULL, NULL, 'Tropomyosins signature.', NULL, 'TROPOMYOSIN', NULL, NULL, 5646, 14),
(281361, NULL, 'PS00430', NULL, NULL, 'TonB-dependent receptor proteins signature 1.', NULL, 'TONB_DEPENDENT_REC_1', NULL, NULL, 10150, 14),
(281362, NULL, 'PS00046', NULL, NULL, 'Histone H2A signature.', NULL, 'HISTONE_H2A', NULL, NULL, 22798, 14),
(281363, NULL, 'PS00910', NULL, NULL, 'Uncharacterized protein family UPF0029 signature.', NULL, 'UPF0029', NULL, NULL, 18805, 14),
(281364, NULL, 'PS00716', NULL, NULL, 'Sigma-70 factors family signature 2.', NULL, 'SIGMA70_2', NULL, NULL, 3449, 14),
(281365, NULL, 'PS00901', NULL, NULL, 'Cysteine synthase/cystathionine beta-synthase P-phosphate attachment site.', NULL, 'CYS_SYNTHASE', NULL, NULL, 2481, 14);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(281366, NULL, 'PS00968', NULL, NULL, 'Antenna complexes alpha subunits signature.', NULL, 'ANTENNA_COMP_ALPHA', NULL, NULL, 6165, 14),
(281367, NULL, 'PS01361', NULL, NULL, 'Zinc finger Dof-type signature.', NULL, 'ZF_DOF_1', NULL, NULL, 3304, 14),
(281368, NULL, 'PS00196', NULL, NULL, 'Type-1 copper (blue) proteins signature.', NULL, 'COPPER_BLUE', NULL, NULL, 26101, 14),
(281369, NULL, 'PS01136', NULL, NULL, 'Uncharacterized protein family UPF0034 signature.', NULL, 'UPF0034', NULL, NULL, 19974, 14),
(281370, NULL, 'PS00257', NULL, NULL, 'Bombesin-like peptides family signature.', NULL, 'BOMBESIN', NULL, NULL, 76, 14),
(281371, NULL, 'PS01187', NULL, NULL, 'Calcium-binding EGF-like domain signature.', NULL, 'EGF_CA', NULL, NULL, 13534, 14),
(281372, NULL, 'PS00310', NULL, NULL, 'Lysosome-associated membrane glycoproteins duplicated domain signature.', NULL, 'LAMP_1', NULL, NULL, 20504, 14),
(281373, NULL, 'PS00440', NULL, NULL, 'Acyltransferases ChoActase / COT / CPT family signature 2.', NULL, 'ACYLTRANSF_C_2', NULL, NULL, 4356, 14),
(281374, NULL, 'PS00815', NULL, NULL, 'Alpha-isopropylmalate and homocitrate synthases signature 1.', NULL, 'AIPM_HOMOCIT_SYNTH_1', NULL, NULL, 5275, 14),
(281375, NULL, 'PS00828', NULL, NULL, 'Ribosomal protein L36 signature.', NULL, 'RIBOSOMAL_L36', NULL, NULL, 6769, 14),
(281376, NULL, 'PS01073', NULL, NULL, 'Ribosomal protein L24e signature.', NULL, 'RIBOSOMAL_L24E', NULL, NULL, 16483, 14),
(281377, NULL, 'PS00328', NULL, NULL, 'HCP repeats signature.', NULL, 'HCP', NULL, NULL, 1130, 14),
(281378, NULL, 'PS01022', NULL, NULL, 'PTR2 family proton/oligopeptide symporters signature 1.', NULL, 'PTR2_1', NULL, NULL, 9236, 14),
(281379, NULL, 'PS00744', NULL, NULL, 'Beta-lactamases class B signature 2.', NULL, 'BETA_LACTAMASE_B_2', NULL, NULL, 345, 14),
(281380, NULL, 'PS01281', NULL, NULL, 'Glucose inhibited division protein A family signature 2.', NULL, 'GIDA_2', NULL, NULL, 19733, 14),
(281381, NULL, 'PS00145', NULL, NULL, 'Urease active site.', NULL, 'UREASE_2', NULL, NULL, 2948, 14),
(281382, NULL, 'PS01276', NULL, NULL, 'Peptidase family U32 signature.', NULL, 'PEPTIDASE_U32', NULL, NULL, 5981, 14),
(281383, NULL, 'PS00374', NULL, NULL, 'Methylated-DNA--protein-cysteine methyltransferase active site.', NULL, 'MGMT', NULL, NULL, 3096, 14),
(281384, NULL, 'PS00921', NULL, NULL, 'Nitrilases / cyanide hydratase active site signature.', NULL, 'NITRIL_CHT_2', NULL, NULL, 1702, 14),
(281385, NULL, 'PS00692', NULL, NULL, 'NifH/frxC family signature 2.', NULL, 'NIFH_FRXC_2', NULL, NULL, 26924, 14),
(281386, NULL, 'PS00689', NULL, NULL, 'Glycoprotein hormones beta chain signature 2.', NULL, 'GLYCO_HORMONE_BETA_2', NULL, NULL, 8220, 14),
(281387, NULL, 'PS00509', NULL, NULL, 'Ras GTPase-activating proteins domain signature.', NULL, 'RAS_GTPASE_ACTIV_1', NULL, NULL, 15565, 14),
(281388, NULL, 'PS00479', NULL, NULL, 'Zinc finger phorbol-ester/DAG-type signature.', NULL, 'ZF_DAG_PE_1', NULL, NULL, 5392, 14),
(281389, NULL, 'PS00293', NULL, NULL, 'Proliferating cell nuclear antigen signature 2.', NULL, 'PCNA_2', NULL, NULL, 16724, 14),
(281390, NULL, 'PS00074', NULL, NULL, 'Glu / Leu / Phe / Val dehydrogenases active site.', NULL, 'GLFV_DEHYDROGENASE', NULL, NULL, 31150, 14),
(281391, NULL, 'PS00276', NULL, NULL, 'Channel forming colicins signature.', NULL, 'CHANNEL_COLICIN', NULL, NULL, 4747, 14),
(281392, NULL, 'PS01171', NULL, NULL, 'Ribosomal protein L21e signature.', NULL, 'RIBOSOMAL_L21E', NULL, NULL, 19917, 14),
(281393, NULL, 'PS01127', NULL, NULL, 'Elongation factor Ts signature 2.', NULL, 'EF_TS_2', NULL, NULL, 13505, 14),
(281394, NULL, 'PS00575', NULL, NULL, 'Myelin proteolipid protein signature 1.', NULL, 'MYELIN_PLP_1', NULL, NULL, 7509, 14),
(281395, NULL, 'PS00194', NULL, NULL, 'Thioredoxin family active site.', NULL, 'THIOREDOXIN_1', NULL, NULL, 18384, 14),
(281396, NULL, 'PS00549', NULL, NULL, 'Bacterioferritin signature.', NULL, 'BACTERIOFERRITIN', NULL, NULL, 2463, 14),
(281397, NULL, 'PS01243', NULL, NULL, 'Bax inhibitor-1 family signature.', NULL, 'BI1', NULL, NULL, 11218, 14);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(281398, NULL, 'PS01325', NULL, NULL, 'Lysyl hydroxylase signature.', NULL, 'LYS_HYDROXYLASE', NULL, NULL, 2008, 14),
(281399, NULL, 'PS00360', NULL, NULL, 'Ribosomal protein S9 signature.', NULL, 'RIBOSOMAL_S9', NULL, NULL, 18780, 14),
(281400, NULL, 'PS00570', NULL, NULL, 'Bacterial ring hydroxylating dioxygenases alpha-subunit signature.', NULL, 'RING_HYDROXYL_ALPHA', NULL, NULL, 11785, 14),
(281401, NULL, 'PS00070', NULL, NULL, 'Aldehyde dehydrogenases cysteine active site.', NULL, 'ALDEHYDE_DEHYDR_CYS', NULL, NULL, 11984, 14),
(281402, NULL, 'PS00505', NULL, NULL, 'Phosphoenolpyruvate carboxykinase (GTP) signature.', NULL, 'PEPCK_GTP', NULL, NULL, 19581, 14),
(281403, NULL, 'PS00033', NULL, NULL, '''Homeobox'' engrailed-type protein signature.', NULL, 'ENGRAILED', NULL, NULL, 12735, 14),
(281404, NULL, 'PS00290', NULL, NULL, 'Immunoglobulins and major histocompatibility complex proteins signature.', NULL, 'IG_MHC', NULL, NULL, 229, 14),
(281405, NULL, 'PS00464', NULL, NULL, 'Ribosomal protein L22 signature.', NULL, 'RIBOSOMAL_L22', NULL, NULL, 19871, 14),
(281406, NULL, 'PS00288', NULL, NULL, 'Tissue inhibitors of metalloproteinases signature.', NULL, 'TIMP', NULL, NULL, 26571, 14),
(281407, NULL, 'PS00274', NULL, NULL, 'Aerolysin type toxins signature.', NULL, 'AEROLYSIN', NULL, NULL, 5756, 14),
(281408, NULL, 'PS60030', NULL, NULL, 'Bacteriocin class IIa family signature.', NULL, 'BACTERIOCIN_IIA', NULL, NULL, 15556, 14),
(281409, NULL, 'PS00031', NULL, NULL, 'Nuclear hormones receptors DNA-binding region signature.', NULL, 'NUCLEAR_REC_DBD_1', NULL, NULL, 3273, 14),
(281410, NULL, 'PS01264', NULL, NULL, 'T-box domain signature 2.', NULL, 'TBOX_2', NULL, NULL, 14898, 14),
(281411, NULL, 'PS00498', NULL, NULL, 'Tyrosinase and hemocyanins CuB-binding region signature.', NULL, 'TYROSINASE_2', NULL, NULL, 289, 14),
(281412, NULL, 'PS01024', NULL, NULL, 'Protein phosphatase 2A regulatory subunit PR55 signature 1.', NULL, 'PR55_1', NULL, NULL, 19233, 14),
(281413, NULL, 'PS00940', NULL, NULL, 'Gamma-thionins family signature.', NULL, 'GAMMA_THIONIN', NULL, NULL, 7450, 14),
(281414, NULL, 'PS00091', NULL, NULL, 'Thymidylate synthase active site.', NULL, 'THYMIDYLATE_SYNTHASE', NULL, NULL, 14941, 14),
(281415, NULL, 'PS00696', NULL, NULL, 'Electron transfer flavoprotein alpha-subunit signature.', NULL, 'ETF_ALPHA', NULL, NULL, 7541, 14),
(281416, NULL, 'PS01028', NULL, NULL, 'Dehydroquinase class I active site.', NULL, 'DEHYDROQUINASE_I', NULL, NULL, 19001, 14),
(281417, NULL, 'PS00526', NULL, NULL, 'Ribosomal protein L19e signature.', NULL, 'RIBOSOMAL_L19E', NULL, NULL, 16323, 14),
(281418, NULL, 'PS00001', NULL, NULL, 'N-glycosylation site.', NULL, 'ASN_GLYCOSYLATION', NULL, NULL, NULL, 14),
(281419, NULL, 'PS00804', NULL, NULL, 'Calreticulin family signature 2.', NULL, 'CALRETICULIN_2', NULL, NULL, 18627, 14),
(281420, NULL, 'PS01282', NULL, NULL, 'BIR repeat.', NULL, 'BIR_REPEAT_1', NULL, NULL, 2021, 14),
(281421, NULL, 'PS00068', NULL, NULL, 'Malate dehydrogenase active site signature.', NULL, 'MDH', NULL, NULL, 2221, 14),
(281422, NULL, 'PS01318', NULL, NULL, 'TsaA-like domain signature.', NULL, 'TSAA_1', NULL, NULL, 15676, 14),
(281423, NULL, 'PS01302', NULL, NULL, 'Uncharacterized protein family UPF0758 signature.', NULL, 'UPF0758', NULL, NULL, 19286, 14),
(281424, NULL, 'PS00363', NULL, NULL, 'Bacterial quinoprotein dehydrogenases signature 1.', NULL, 'BACTERIAL_PQQ_1', NULL, NULL, 6403, 14),
(281425, NULL, 'PS00052', NULL, NULL, 'Ribosomal protein S7 signature.', NULL, 'RIBOSOMAL_S7', NULL, NULL, 19830, 14),
(281426, NULL, 'PS00490', NULL, NULL, 'Prokaryotic molybdopterin oxidoreductases signature 2.', NULL, 'MOLYBDOPTERIN_PROK_2', NULL, NULL, 1207, 14),
(281427, NULL, 'PS01123', NULL, NULL, 'Thermonuclease family signature 1.', NULL, 'TNASE_1', NULL, NULL, 1101, 14),
(281428, NULL, 'PS00854', NULL, NULL, 'Proteasome beta-type subunits signature.', NULL, 'PROTEASOME_BETA_1', NULL, NULL, 7728, 14),
(281429, NULL, 'PS00774', NULL, NULL, 'Chitinases family 19 signature 2.', NULL, 'CHITINASE_19_2', NULL, NULL, 7139, 14);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(281430, NULL, 'PS01221', NULL, NULL, 'PMP-22 / EMP / MP20 family signature 1.', NULL, 'PMP22_1', NULL, NULL, 823, 14),
(281431, NULL, 'PS00207', NULL, NULL, 'Transferrin-like domain signature 3.', NULL, 'TRANSFERRIN_LIKE_3', NULL, NULL, 14882, 14),
(281432, NULL, 'PS00218', NULL, NULL, 'Amino acid permeases signature.', NULL, 'AMINO_ACID_PERMEASE_1', NULL, NULL, 4268, 14),
(281433, NULL, 'PS01160', NULL, NULL, 'Kinesin light chain repeat.', NULL, 'KINESIN_LIGHT', NULL, NULL, 12540, 14),
(281434, NULL, 'PS00368', NULL, NULL, 'Ribonucleotide reductase small subunit signature.', NULL, 'RIBORED_SMALL', NULL, NULL, 21598, 14),
(281435, NULL, 'PS00796', NULL, NULL, '14-3-3 proteins signature 1.', NULL, '1433_1', NULL, NULL, 16356, 14),
(281436, NULL, 'PS00494', NULL, NULL, 'Bacterial luciferase subunits signature.', NULL, 'BACTERIAL_LUCIFERASE', NULL, NULL, 7758, 14),
(281437, NULL, 'PS00949', NULL, NULL, 'Autoinducer synthase family signature.', NULL, 'AUTOINDUCER_SYNTH_1', NULL, NULL, 8123, 14),
(281438, NULL, 'PS00230', NULL, NULL, 'Neuraxin and MAP1B proteins repeated region signature.', NULL, 'MAP1B_NEURAXIN', NULL, NULL, 3884, 14),
(281439, NULL, 'PS01307', NULL, NULL, 'Flagellar motor protein motA family signature.', NULL, 'MOTA', NULL, NULL, 5980, 14),
(281440, NULL, 'PS00303', NULL, NULL, 'S-100/ICaBP type calcium binding protein signature.', NULL, 'S100_CABP', NULL, NULL, 3327, 14),
(281441, NULL, 'PS00620', NULL, NULL, 'PTN/MK heparin-binding protein family signature 2.', NULL, 'PTN_MK_2', NULL, NULL, 16226, 14),
(281442, NULL, 'PS00621', NULL, NULL, 'Tissue factor signature.', NULL, 'TISSUE_FACTOR', NULL, NULL, 24862, 14),
(281443, NULL, 'PS00720', NULL, NULL, 'Ras Guanine-nucleotide exchange factors domain signature.', NULL, 'RASGEF', NULL, NULL, 17252, 14),
(281444, NULL, 'PS01209', NULL, NULL, 'LDL-receptor class A (LDLRA) domain signature.', NULL, 'LDLRA_1', NULL, NULL, 16202, 14),
(281445, NULL, 'PS00537', NULL, NULL, 'Cytochrome b559 subunits heme-binding site signature.', NULL, 'CYTOCHROME_B559', NULL, NULL, 11459, 14),
(281446, NULL, 'PS00617', NULL, NULL, 'RecF protein signature 1.', NULL, 'RECF_1', NULL, NULL, 13689, 14),
(281447, NULL, 'PS00800', NULL, NULL, 'Pectinesterase signature 1.', NULL, 'PECTINESTERASE_1', NULL, NULL, 13837, 14),
(281448, NULL, 'PS00512', NULL, NULL, 'Alpha-galactosidase signature.', NULL, 'ALPHA_GALACTOSIDASE', NULL, NULL, 2542, 14),
(281449, NULL, 'PS00063', NULL, NULL, 'Aldo/keto reductase family putative active site signature.', NULL, 'ALDOKETO_REDUCTASE_3', NULL, NULL, 11896, 14),
(281450, NULL, 'PS00571', NULL, NULL, 'Amidases signature.', NULL, 'AMIDASES', NULL, NULL, 18906, 14),
(281451, NULL, 'PS01161', NULL, NULL, 'Glucosamine/galactosamine-6-phosphate isomerases signature.', NULL, 'GLC_GALNAC_ISOMERASE', NULL, NULL, 8264, 14),
(281452, NULL, 'PS01200', NULL, NULL, 'Tub family signature 1.', NULL, 'TUB_1', NULL, NULL, 19471, 14),
(281453, NULL, 'PS00958', NULL, NULL, 'Transaldolase active site.', NULL, 'TRANSALDOLASE_2', NULL, NULL, 7782, 14),
(281454, NULL, 'PS60031', NULL, NULL, 'Glutamic acid-rich protein 2 (GARP2) signature.', NULL, 'GARP2', NULL, NULL, NULL, 14),
(281455, NULL, 'PS00988', NULL, NULL, '6-pyruvoyl tetrahydropterin synthase signature 2.', NULL, 'PTPS_2', NULL, NULL, 15922, 14),
(281456, NULL, 'PS01133', NULL, NULL, 'Uncharacterized protein family UPF0017 signature.', NULL, 'UPF0017', NULL, NULL, 175, 14),
(281457, NULL, 'PS00159', NULL, NULL, 'KDPG and KHG aldolases active site.', NULL, 'ALDOLASE_KDPG_KHG_1', NULL, NULL, 25680, 14),
(281458, NULL, 'PS00178', NULL, NULL, 'Aminoacyl-transfer RNA synthetases class-I signature.', NULL, 'AA_TRNA_LIGASE_I', NULL, NULL, 6836, 14),
(281459, NULL, 'PS00365', NULL, NULL, 'Nitrite and sulfite reductases iron-sulfur/siroheme-binding site.', NULL, 'NIR_SIR', NULL, NULL, 2848, 14),
(281460, NULL, 'PS00061', NULL, NULL, 'Short-chain dehydrogenases/reductases family signature.', NULL, 'ADH_SHORT', NULL, NULL, 20301, 14),
(281461, NULL, 'PS00166', NULL, NULL, 'Enoyl-CoA hydratase/isomerase signature.', NULL, 'ENOYL_COA_HYDRATASE', NULL, NULL, 20181, 14); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(281462, NULL, 'PS00879', NULL, NULL, 'Orn/DAP/Arg decarboxylases family 2 signature 2.', NULL, 'ODR_DC_2_2', NULL, NULL, 16791, 14),
(281463, NULL, 'PS01111', NULL, NULL, 'RNA polymerases K / 14 to 18 Kd subunits signature.', NULL, 'RNA_POL_K_14KD', NULL, NULL, 20976, 14),
(281464, NULL, 'PS01186', NULL, NULL, 'EGF-like domain signature 2.', NULL, 'EGF_2', NULL, NULL, 3525, 14),
(281465, NULL, 'PS00727', NULL, NULL, 'AP endonucleases family 1 signature 2.', NULL, 'AP_NUCLEASE_F1_2', NULL, NULL, 20917, 14),
(281466, NULL, 'PS01017', NULL, NULL, 'Sterol reductase family signature 1.', NULL, 'STEROL_REDUCT_1', NULL, NULL, 13906, 14),
(281467, NULL, 'PS00469', NULL, NULL, 'Nucleoside diphosphate kinases active site.', NULL, 'NDP_KINASES', NULL, NULL, 15076, 14),
(281468, NULL, 'PS00860', NULL, NULL, 'GTP cyclohydrolase I signature 2.', NULL, 'GTP_CYCLOHYDROL_1_2', NULL, NULL, 7604, 14),
(281469, NULL, 'PS01068', NULL, NULL, 'OmpA-like domain.', NULL, 'OMPA_1', NULL, NULL, 2133, 14),
(281470, NULL, 'PS00882', NULL, NULL, 'Nickel-dependent hydrogenases b-type cytochrome subunit signature 1.', NULL, 'NI_HGENASE_CYTB_1', NULL, NULL, 6762, 14),
(281471, NULL, 'PS01273', NULL, NULL, 'Coenzyme A transferases signature 1.', NULL, 'COA_TRANSF_1', NULL, NULL, 2854, 14),
(281472, NULL, 'PS00307', NULL, NULL, 'Legume lectins beta-chain signature.', NULL, 'LECTIN_LEGUME_BETA', NULL, NULL, 17418, 14),
(281473, NULL, 'PS00264', NULL, NULL, 'Neurohypophysial hormones signature.', NULL, 'NEUROHYPOPHYS_HORM', NULL, NULL, 21384, 14),
(281474, NULL, 'PS00594', NULL, NULL, 'Aromatic amino acids permeases signature.', NULL, 'AROMATIC_AA_PERMEASE_1', NULL, NULL, 7058, 14),
(281475, NULL, 'PS00953', NULL, NULL, 'Glycosyl hydrolases family 25 active site signature.', NULL, 'GLYCOSYL_HYDROL_F25_1', NULL, NULL, 8614, 14),
(281476, NULL, 'PS01076', NULL, NULL, 'Acetate and butyrate kinases family signature 2.', NULL, 'ACETATE_KINASE_2', NULL, NULL, 8090, 14),
(281477, NULL, 'PS60014', NULL, NULL, 'Alpha-conotoxin family signature.', NULL, 'ALPHA_CONOTOXIN', NULL, NULL, 19971, 14),
(281478, NULL, 'PS00830', NULL, NULL, 'Prokaryotic transcription elongation factors signature 2.', NULL, 'GREAB_2', NULL, NULL, 18633, 14),
(281479, NULL, 'PS01223', NULL, NULL, 'Gamma-glutamyl phosphate reductase signature.', NULL, 'PROA', NULL, NULL, 20793, 14),
(281480, NULL, 'PS00931', NULL, NULL, 'Cutinase, aspartate and histidine active sites.', NULL, 'CUTINASE_2', NULL, NULL, 35311, 14),
(281481, NULL, 'PS01206', NULL, NULL, 'Amiloride-sensitive sodium channels signature.', NULL, 'ASC', NULL, NULL, 19552, 14),
(281482, NULL, 'PS00456', NULL, NULL, 'Sodium:solute symporter family signature 1.', NULL, 'NA_SOLUT_SYMP_1', NULL, NULL, 7726, 14),
(281483, NULL, 'PS01199', NULL, NULL, 'Ribosomal protein L1 signature.', NULL, 'RIBOSOMAL_L1', NULL, NULL, 958, 14),
(281484, NULL, 'PS01191', NULL, NULL, 'Ribosomal protein S3Ae signature.', NULL, 'RIBOSOMAL_S3AE', NULL, NULL, 19853, 14),
(281485, NULL, 'PS60009', NULL, NULL, 'Cyclotides Moebius subfamily signature.', NULL, 'CYCLOTIDE_MOEBIUS', NULL, NULL, 11907, 14),
(281486, NULL, 'PS01032', NULL, NULL, 'PPM-type phosphatase domain signature.', NULL, 'PPM_1', NULL, NULL, 1757, 14),
(281487, NULL, 'PS01050', NULL, NULL, 'YjeF C-terminal domain signature 2.', NULL, 'YJEF_C_2', NULL, NULL, 1314, 14),
(281488, NULL, 'PS00660', NULL, NULL, 'FERM domain signature 1.', NULL, 'FERM_1', NULL, NULL, 20871, 14),
(281489, NULL, 'PS01092', NULL, NULL, 'Adenylate cyclase class-I signature 1.', NULL, 'ADENYLATE_CYCLASE_1_1', NULL, NULL, 24866, 14),
(281490, NULL, 'PS01117', NULL, NULL, 'MarR-type HTH domain signature.', NULL, 'HTH_MARR_1', NULL, NULL, 7591, 14),
(281491, NULL, 'PS00520', NULL, NULL, 'Interleukin-10 family signature.', NULL, 'INTERLEUKIN_10', NULL, NULL, 18866, 14),
(281492, NULL, 'PS01236', NULL, NULL, 'PdxT/SNO family family signature.', NULL, 'PDXT_SNO_1', NULL, NULL, 16136, 14),
(281493, NULL, 'PS01002', NULL, NULL, 'Translationally controlled tumor protein (TCTP) domain signature 1.', NULL, 'TCTP_1', NULL, NULL, 13877, 14);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(281494, NULL, 'PS00316', NULL, NULL, 'Thaumatin family signature.', NULL, 'THAUMATIN_1', NULL, NULL, 2745, 14),
(281495, NULL, 'PS00180', NULL, NULL, 'Glutamine synthetase signature 1.', NULL, 'GLNA_1', NULL, NULL, 25909, 14),
(281496, NULL, 'PS60024', NULL, NULL, 'Agouti domain signature.', NULL, 'AGOUTI_1', NULL, NULL, 24751, 14),
(281497, NULL, 'PS00292', NULL, NULL, 'Cyclins signature.', NULL, 'CYCLINS', NULL, NULL, 1845, 14),
(281498, NULL, 'PS00699', NULL, NULL, 'Nitrogenases component 1 alpha and beta subunits signature 1.', NULL, 'NITROGENASE_1_1', NULL, NULL, 619, 14),
(281499, NULL, 'PS00768', NULL, NULL, 'Transthyretin signature 1.', NULL, 'TRANSTHYRETIN_1', NULL, NULL, 16234, 14),
(281500, NULL, 'PS00841', NULL, NULL, 'XPG protein signature 1.', NULL, 'XPG_1', NULL, NULL, 15610, 14),
(281501, NULL, 'PS00652', NULL, NULL, 'TNFR/NGFR family cysteine-rich region signature.', NULL, 'TNFR_NGFR_1', NULL, NULL, 2084, 14),
(281502, NULL, 'PS00922', NULL, NULL, 'Prokaryotic transglycosylases signature.', NULL, 'TRANSGLYCOSYLASE', NULL, NULL, 1945, 14),
(281503, NULL, 'PS00435', NULL, NULL, 'Peroxidases proximal heme-ligand signature.', NULL, 'PEROXIDASE_1', NULL, NULL, 17065, 14),
(281504, NULL, 'PS00886', NULL, NULL, 'Dihydroxy-acid and 6-phosphogluconate dehydratases signature 1.', NULL, 'ILVD_EDD_1', NULL, NULL, 14834, 14),
(281505, NULL, 'PS00084', NULL, NULL, 'Copper type II, ascorbate-dependent monooxygenases signature 1.', NULL, 'CU2_MONOOXYGENASE_1', NULL, NULL, 20219, 14),
(281506, NULL, 'PS00155', NULL, NULL, 'Cutinase, serine active site.', NULL, 'CUTINASE_1', NULL, NULL, 35301, 14),
(281507, NULL, 'PS00223', NULL, NULL, 'Annexin repeat signature.', NULL, 'ANNEXIN_1', NULL, NULL, 19533, 14),
(281508, NULL, 'PS00008', NULL, NULL, 'N-myristoylation site.', NULL, 'MYRISTYL', NULL, NULL, NULL, 14),
(281509, NULL, 'PS00563', NULL, NULL, 'Stathmin family signature 1.', NULL, 'STATHMIN_1', NULL, NULL, 24698, 14),
(281510, NULL, 'PS00186', NULL, NULL, 'Isopenicillin N synthase signature 2.', NULL, 'IPNS_2', NULL, NULL, 5127, 14),
(281511, NULL, 'PS00861', NULL, NULL, 'Galanin signature.', NULL, 'GALANIN', NULL, NULL, 7237, 14),
(281512, NULL, 'PS01202', NULL, NULL, 'Methionine aminopeptidase subfamily 2 signature.', NULL, 'MAP_2', NULL, NULL, 8083, 14),
(281513, NULL, 'PS01196', NULL, NULL, 'Peptidyl-tRNA hydrolase signature 2.', NULL, 'PEPT_TRNA_HYDROL_2', NULL, NULL, 11880, 14),
(281514, NULL, 'PS01137', NULL, NULL, 'TatD deoxyribonuclease family signature 1.', NULL, 'TATD_1', NULL, NULL, 7770, 14),
(281515, NULL, 'PS00536', NULL, NULL, 'Ubiquitin-activating enzyme signature 1.', NULL, 'UBIQUITIN_ACTIVAT_1', NULL, NULL, 19018, 14),
(281516, NULL, 'PS00675', NULL, NULL, 'Sigma-54 interaction domain ATP-binding region A signature.', NULL, 'SIGMA54_INTERACT_1', NULL, NULL, 26096, 14),
(281517, NULL, 'PS00394', NULL, NULL, 'DNA photolyases class 1 signature 1.', NULL, 'DNA_PHOTOLYASES_1_1', NULL, NULL, 8199, 14),
(281518, NULL, 'PS00980', NULL, NULL, 'G-protein coupled receptors family 3 signature 2.', NULL, 'G_PROTEIN_RECEP_F3_2', NULL, NULL, 19495, 14),
(281519, NULL, 'PS00262', NULL, NULL, 'Insulin family signature.', NULL, 'INSULIN', NULL, NULL, 21224, 14),
(281520, NULL, 'PS00413', NULL, NULL, 'Neuromodulin (GAP-43) signature 2.', NULL, 'NEUROMODULIN_2', NULL, NULL, 31109, 14),
(281521, NULL, 'PS00605', NULL, NULL, 'ATP synthase c subunit signature.', NULL, 'ATPASE_C', NULL, NULL, 20811, 14),
(281522, NULL, 'PS00289', NULL, NULL, 'Pentraxin domain signature.', NULL, 'PTX_1', NULL, NULL, 25265, 14),
(281523, NULL, 'PS00742', NULL, NULL, 'PEP-utilizing enzymes signature 2.', NULL, 'PEP_ENZYMES_2', NULL, NULL, 15077, 14),
(281524, NULL, 'PS00079', NULL, NULL, 'Multicopper oxidases signature 1.', NULL, 'MULTICOPPER_OXIDASE1', NULL, NULL, 30200, 14),
(281525, NULL, 'PS01300', NULL, NULL, 'RecR protein signature.', NULL, 'RECR', NULL, NULL, 10145, 14),
(281526, NULL, 'PS00305', NULL, NULL, '11-S plant seed storage proteins signature.', NULL, '11S_SEED_STORAGE', NULL, NULL, 15966, 14);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(281527, NULL, 'PS00195', NULL, NULL, 'Glutaredoxin active site.', NULL, 'GLUTAREDOXIN_1', NULL, NULL, 10815, 14),
(281528, NULL, 'PS00419', NULL, NULL, 'Photosystem I psaA and psaB proteins signature.', NULL, 'PHOTOSYSTEM_I_PSAAB', NULL, NULL, 20214, 14),
(281529, NULL, 'PS01251', NULL, NULL, 'Proliferating cell nuclear antigen signature 1.', NULL, 'PCNA_1', NULL, NULL, 16724, 14),
(281530, NULL, 'PS00428', NULL, NULL, 'Cell cycle proteins ftsW / rodA / spoVE signature.', NULL, 'FTSW_RODA_SPOVE', NULL, NULL, 20032, 14),
(281531, NULL, 'PS00589', NULL, NULL, 'PTS HPR domain serine phosphorylation site signature.', NULL, 'PTS_HPR_SER', NULL, NULL, 3124, 14),
(281532, NULL, 'PS00598', NULL, NULL, 'Chromo domain signature.', NULL, 'CHROMO_1', NULL, NULL, 16642, 14),
(281533, NULL, 'PS00543', NULL, NULL, 'HlyD family secretion proteins signature.', NULL, 'HLYD_FAMILY', NULL, NULL, 10036, 14),
(281534, NULL, 'PS00927', NULL, NULL, 'Trehalase signature 1.', NULL, 'TREHALASE_1', NULL, NULL, 7992, 14),
(281535, NULL, 'PS00025', NULL, NULL, 'P-type ''Trefoil'' domain signature.', NULL, 'P_TREFOIL_1', NULL, NULL, 1362, 14),
(281536, NULL, 'PS00465', NULL, NULL, 'POU-specific (POUs) domain signature 2.', NULL, 'POU_2', NULL, NULL, 985, 14),
(281537, NULL, 'PS01326', NULL, NULL, 'Diaminopimelate epimerase signature.', NULL, 'DAP_EPIMERASE', NULL, NULL, 19444, 14),
(281538, NULL, 'PS00705', NULL, NULL, 'Prokaryotic-type carbonic anhydrases signature 2.', NULL, 'PROK_CO2_ANHYDRASE_2', NULL, NULL, 7546, 14),
(281539, NULL, 'PS00848', NULL, NULL, 'Cytochrome c oxidase subunit Vb, zinc binding region signature.', NULL, 'COX5B_1', NULL, NULL, NULL, 14),
(281540, NULL, 'PS01346', NULL, NULL, 'Claudin family signature.', NULL, 'CLAUDIN', NULL, NULL, 12659, 14),
(281541, NULL, 'PS00506', NULL, NULL, 'Beta-amylase active site 1.', NULL, 'BETA_AMYLASE_1', NULL, NULL, 8179, 14),
(281542, NULL, 'PS00855', NULL, NULL, 'Signal peptidases II signature.', NULL, 'SPASE_II', NULL, NULL, 4162, 14),
(281543, NULL, 'PS00320', NULL, NULL, 'Amyloid precursor protein (APP) intracellular domain signature.', NULL, 'APP_INTRA', NULL, NULL, 12515, 14),
(281544, NULL, 'PS01298', NULL, NULL, 'Dihydrodipicolinate reductase signature.', NULL, 'DAPB', NULL, NULL, 16592, 14),
(281545, NULL, 'PS60019', NULL, NULL, 'I-superfamily conotoxin signature.', NULL, 'I_CONOTOXIN', NULL, NULL, 7900, 14),
(281546, NULL, 'PS00544', NULL, NULL, 'Methylmalonyl-CoA mutase signature.', NULL, 'METMALONYL_COA_MUTASE', NULL, NULL, 2540, 14),
(281547, NULL, 'PS60021', NULL, NULL, 'Huwentoxin-1 family signature.', NULL, 'HWTX_1', NULL, NULL, 7908, 14),
(281548, NULL, 'PS00169', NULL, NULL, 'Delta-aminolevulinic acid dehydratase active site.', NULL, 'D_ALA_DEHYDRATASE', NULL, NULL, 23769, 14),
(281549, NULL, 'PS00251', NULL, NULL, 'TNF family signature.', NULL, 'TNF_1', NULL, NULL, 16887, 14),
(281550, NULL, 'PS00843', NULL, NULL, 'D-alanine--D-alanine ligase signature 1.', NULL, 'DALA_DALA_LIGASE_1', NULL, NULL, 606, 14),
(281551, NULL, 'PS00144', NULL, NULL, 'Asparaginase / glutaminase active site signature 1.', NULL, 'ASN_GLN_ASE_1', NULL, NULL, 18590, 14),
(281552, NULL, 'PS01238', NULL, NULL, 'GDA1/CD39 family of nucleoside phosphatases signature.', NULL, 'GDA1_CD39_NTPASE', NULL, NULL, 4996, 14),
(281553, NULL, 'PS00751', NULL, NULL, 'Chaperonins TCP-1 signature 2.', NULL, 'TCP1_2', NULL, NULL, 467, 14),
(281554, NULL, 'PS00738', NULL, NULL, 'S-adenosyl-L-homocysteine hydrolase signature 1.', NULL, 'ADOHCYASE_1', NULL, NULL, 16006, 14),
(281555, NULL, 'PS00821', NULL, NULL, 'Cytochrome c and c1 heme lyases signature 1.', NULL, 'CYTO_HEME_LYASE_1', NULL, NULL, 6567, 14),
(281556, NULL, 'PS01262', NULL, NULL, 'Eukaryotic initiation factor 1A signature.', NULL, 'IF1A', NULL, NULL, 13975, 14),
(281557, NULL, 'PS00611', NULL, NULL, 'Histidinol dehydrogenase signature.', NULL, 'HISOL_DEHYDROGENASE', NULL, NULL, 3498, 14),
(281558, NULL, 'PS00992', NULL, NULL, 'Serum amyloid A proteins signature.', NULL, 'SAA', NULL, NULL, 3847, 14),
(281559, NULL, 'PS01240', NULL, NULL, 'Purine and other phosphorylases family 2 signature.', NULL, 'PNP_MTAP_2', NULL, NULL, 13863, 14);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(281560, NULL, 'PS01095', NULL, NULL, 'Glycosyl hydrolases family 18 (GH18) active site signature.', NULL, 'GH18_1', NULL, NULL, 5112, 14),
(281561, NULL, 'PS00010', NULL, NULL, 'Aspartic acid and asparagine hydroxylation site.', NULL, 'ASX_HYDROXYL', NULL, NULL, 3946, 14),
(281562, NULL, 'PS00562', NULL, NULL, 'CBM1 (carbohydrate binding type-1) domain signature.', NULL, 'CBM1_1', NULL, NULL, 4882, 14),
(281563, NULL, 'PS01067', NULL, NULL, 'Protein secE/sec61-gamma signature.', NULL, 'SECE_SEC61G', NULL, NULL, 2105, 14),
(281564, NULL, 'PS00452', NULL, NULL, 'Guanylate cyclase signature.', NULL, 'GUANYLATE_CYCLASE_1', NULL, NULL, 16590, 14),
(281565, NULL, 'PS00961', NULL, NULL, 'Ribosomal protein S28e signature.', NULL, 'RIBOSOMAL_S28E', NULL, NULL, 22279, 14),
(281566, NULL, 'PS01116', NULL, NULL, 'Xanthine/uracil permeases family signature.', NULL, 'XANTH_URACIL_PERMASE', NULL, NULL, 2535, 14),
(281567, NULL, 'PS01090', NULL, NULL, 'TatD deoxyribonuclease family signature 2.', NULL, 'TATD_2', NULL, NULL, 7770, 14),
(281568, NULL, 'PS00271', NULL, NULL, 'Plant thionins signature.', NULL, 'THIONIN', NULL, NULL, 2130, 14),
(281569, NULL, 'PS00255', NULL, NULL, 'Interleukin-7 and -9 signature.', NULL, 'INTERLEUKIN_7_9', NULL, NULL, 14989, 14),
(281570, NULL, 'PS00971', NULL, NULL, 'Nuclear transition protein 2 signature 2.', NULL, 'TP2_2', NULL, NULL, 3572, 14),
(281571, NULL, 'PS00504', NULL, NULL, 'Fumarate reductase / succinate dehydrogenase FAD-binding site.', NULL, 'FRD_SDH_FAD_BINDING', NULL, NULL, 7425, 14),
(281572, NULL, 'PS01211', NULL, NULL, 'Uncharacterized protein family UPF0001 signature.', NULL, 'UPF0001', NULL, NULL, 9662, 14),
(281573, NULL, 'PS01167', NULL, NULL, 'Ribosomal protein L17 signature.', NULL, 'RIBOSOMAL_L17', NULL, NULL, 6840, 14),
(281574, NULL, 'PS01248', NULL, NULL, 'Laminin-type EGF-like (LE) domain signature.', NULL, 'EGF_LAM_1', NULL, NULL, 1303, 14),
(281575, NULL, 'PS00039', NULL, NULL, 'DEAD-box subfamily ATP-dependent helicases signature.', NULL, 'DEAD_ATP_HELICASE', NULL, NULL, 5761, 14),
(281576, NULL, 'PS00898', NULL, NULL, 'Ependymins signature 1.', NULL, 'EPENDYMIN_1', NULL, NULL, 7715, 14),
(281577, NULL, 'PS00616', NULL, NULL, 'Histidine acid phosphatases phosphohistidine signature.', NULL, 'HIS_ACID_PHOSPHAT_1', NULL, NULL, 33054, 14),
(281578, NULL, 'PS00634', NULL, NULL, 'Ribosomal protein L30 signature.', NULL, 'RIBOSOMAL_L30', NULL, NULL, 12937, 14),
(281579, NULL, 'PS01193', NULL, NULL, 'Ribosomal protein S8e signature.', NULL, 'RIBOSOMAL_S8E', NULL, NULL, 19973, 14),
(281580, NULL, 'PS01233', NULL, NULL, 'Urocanase signature.', NULL, 'UROCANASE', NULL, NULL, 688, 14),
(281581, NULL, 'PS00524', NULL, NULL, 'Somatomedin B domain (SMB) signature.', NULL, 'SMB_1', NULL, NULL, 1010, 14),
(281582, NULL, 'PS00632', NULL, NULL, 'Ribosomal protein S4 signature.', NULL, 'RIBOSOMAL_S4', NULL, NULL, 13800, 14),
(281583, NULL, 'PS00788', NULL, NULL, 'Chorismate synthase signature 2.', NULL, 'CHORISMATE_SYNTHASE_2', NULL, NULL, 14521, 14),
(281584, NULL, 'PS01340', NULL, NULL, 'Cornichon family signature.', NULL, 'CORNICHON', NULL, NULL, 27816, 14),
(281585, NULL, 'PS00529', NULL, NULL, 'Ribosomal protein S24e signature.', NULL, 'RIBOSOMAL_S24E', NULL, NULL, 13690, 14),
(281586, NULL, 'PS00997', NULL, NULL, 'G10 protein signature 1.', NULL, 'G10_1', NULL, NULL, 7768, 14),
(281587, NULL, 'PS00156', NULL, NULL, 'Orotidine 5''-phosphate decarboxylase active site.', NULL, 'OMPDECASE', NULL, NULL, 13518, 14),
(281588, NULL, 'PS00540', NULL, NULL, 'Ferritin iron-binding regions signature 1.', NULL, 'FERRITIN_1', NULL, NULL, 12655, 14),
(281589, NULL, 'PS01009', NULL, NULL, 'CRISP family signature 1.', NULL, 'CRISP_1', NULL, NULL, 8393, 14),
(281590, NULL, 'PS01311', NULL, NULL, 'Prolipoprotein diacylglyceryl transferase signature.', NULL, 'LGT', NULL, NULL, 3232, 14),
(281591, NULL, 'PS00835', NULL, NULL, 'Aspartyl proteases, omptin family signature 2.', NULL, 'OMPTIN_2', NULL, NULL, 16043, 14),
(281592, NULL, 'PS00829', NULL, NULL, 'Prokaryotic transcription elongation factors signature 1.', NULL, 'GREAB_1', NULL, NULL, 18633, 14);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(281593, NULL, 'PS01071', NULL, NULL, 'grpE protein signature.', NULL, 'GRPE', NULL, NULL, 3633, 14),
(281594, NULL, 'PS01217', NULL, NULL, 'ATP-citrate lyase / succinyl-CoA ligases family signature 3.', NULL, 'SUCCINYL_COA_LIG_3', NULL, NULL, 18635, 14),
(281595, NULL, 'PS00130', NULL, NULL, 'Uracil-DNA glycosylase signature.', NULL, 'U_DNA_GLYCOSYLASE', NULL, NULL, 13974, 14),
(281596, NULL, 'PS01299', NULL, NULL, 'Ephrin receptor-binding (ephrin RBD) domain signature.', NULL, 'EPHRIN_RBD_1', NULL, NULL, 20734, 14),
(281597, NULL, 'PS00398', NULL, NULL, 'Site-specific recombinases signature 2.', NULL, 'RECOMBINASES_2', NULL, NULL, 10188, 14),
(281598, NULL, 'PS00658', NULL, NULL, 'Fork head domain signature 2.', NULL, 'FORK_HEAD_2', NULL, NULL, 22200, 14),
(281599, NULL, 'PS00585', NULL, NULL, 'Ribosomal protein S5 signature.', NULL, 'RIBOSOMAL_S5', NULL, NULL, 20144, 14),
(281600, NULL, 'PS00747', NULL, NULL, 'Glutamyl-tRNA reductase signature.', NULL, 'GLUTR', NULL, NULL, 7520, 14),
(281601, NULL, 'PS00067', NULL, NULL, '3-hydroxyacyl-CoA dehydrogenase signature.', NULL, '3HCDH', NULL, NULL, 11285, 14),
(281602, NULL, 'PS00226', NULL, NULL, 'Intermediate filament (IF) rod domain signature.', NULL, 'IF_ROD_1', NULL, NULL, 19171, 14),
(281603, NULL, 'PS00487', NULL, NULL, 'IMP dehydrogenase / GMP reductase signature.', NULL, 'IMP_DH_GMP_RED', NULL, NULL, 14198, 14),
(281604, NULL, 'PS00711', NULL, NULL, 'Lipoxygenases iron-binding region signature 1.', NULL, 'LIPOXYGENASE_1', NULL, NULL, 20979, 14),
(281605, NULL, 'PS00041', NULL, NULL, 'Bacterial regulatory proteins, araC family signature.', NULL, 'HTH_ARAC_FAMILY_1', NULL, NULL, 13785, 14),
(281606, NULL, 'PS00715', NULL, NULL, 'Sigma-70 factors family signature 1.', NULL, 'SIGMA70_1', NULL, NULL, 3449, 14),
(281607, NULL, 'PS00101', NULL, NULL, 'Hexapeptide-repeat containing-transferases signature.', NULL, 'HEXAPEP_TRANSFERASES', NULL, NULL, 20003, 14),
(281608, NULL, 'PS00111', NULL, NULL, 'Phosphoglycerate kinase signature.', NULL, 'PGLYCERATE_KINASE', NULL, NULL, 8242, 14),
(281609, NULL, 'PS00205', NULL, NULL, 'Transferrin-like domain signature 1.', NULL, 'TRANSFERRIN_LIKE_1', NULL, NULL, 14882, 14),
(281610, NULL, 'PS60025', NULL, NULL, 'Conantokin family signature.', NULL, 'CONANTOKIN', NULL, NULL, 12673, 14),
(281611, NULL, 'PS00486', NULL, NULL, 'DNA mismatch repair proteins mutS family signature.', NULL, 'DNA_MISMATCH_REPAIR_2', NULL, NULL, 4830, 14),
(281612, NULL, 'PS00770', NULL, NULL, 'Aminotransferases class-IV signature.', NULL, 'AA_TRANSFER_CLASS_4', NULL, NULL, 16689, 14),
(281613, NULL, 'PS01096', NULL, NULL, 'PpiC-type peptidyl-prolyl cis-trans isomerase signature.', NULL, 'PPIC_PPIASE_1', NULL, NULL, 15037, 14),
(281614, NULL, 'PS00628', NULL, NULL, 'Ribosomal protein S19e signature.', NULL, 'RIBOSOMAL_S19E', NULL, NULL, 19621, 14),
(281615, NULL, 'PS01097', NULL, NULL, 'Hydrogenases expression/synthesis hupF/hypC family signature.', NULL, 'HUPF_HYPC', NULL, NULL, 17084, 14),
(281616, NULL, 'PS00019', NULL, NULL, 'Actinin-type actin-binding domain signature 1.', NULL, 'ACTININ_1', NULL, NULL, 3190, 14),
(281617, NULL, 'PS00929', NULL, NULL, 'Yeast PIR proteins repeats signature.', NULL, 'PIR_REPEAT_1', NULL, NULL, 4442, 14),
(281618, NULL, 'PS00285', NULL, NULL, 'Potato inhibitor I family signature.', NULL, 'POTATO_INHIBITOR', NULL, NULL, 422, 14),
(281619, NULL, 'PS00216', NULL, NULL, 'Sugar transport proteins signature 1.', NULL, 'SUGAR_TRANSPORT_1', NULL, NULL, 6940, 14),
(281620, NULL, 'PS00862', NULL, NULL, 'Oxygen oxidoreductases covalent FAD-binding site.', NULL, 'OX2_COVAL_FAD', NULL, NULL, 2526, 14),
(281621, NULL, 'PS01213', NULL, NULL, 'Protozoan/cyanobacterial globins signature.', NULL, 'GLOBIN_FAM_2', NULL, NULL, 17248, 14),
(281622, NULL, 'PS00470', NULL, NULL, 'Isocitrate and isopropylmalate dehydrogenases signature.', NULL, 'IDH_IMDH', NULL, NULL, 17371, 14),
(281623, NULL, 'PS01135', NULL, NULL, 'FtsZ protein signature 2.', NULL, 'FTSZ_2', NULL, NULL, 21438, 14),
(281624, NULL, 'PS01324', NULL, NULL, 'Glycosyl hydrolases family 4 signature.', NULL, 'GLYCOSYL_HYDROL_F4', NULL, NULL, 17172, 14);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(281625, NULL, 'PS00935', NULL, NULL, 'Glyoxalase I signature 2.', NULL, 'GLYOXALASE_I_2', NULL, NULL, 20993, 14),
(281626, NULL, 'PS00097', NULL, NULL, 'Aspartate and ornithine carbamoyltransferases signature.', NULL, 'CARBAMOYLTRANSFERASE', NULL, NULL, 10498, 14),
(281627, NULL, 'PS01239', NULL, NULL, 'Dynein light chain type 1 signature.', NULL, 'DYNEIN_LIGHT_1', NULL, NULL, 20733, 14),
(281628, NULL, 'PS01229', NULL, NULL, 'Hypothetical cof family signature 2.', NULL, 'COF_2', NULL, NULL, NULL, 14),
(281629, NULL, 'PS00027', NULL, NULL, '''Homeobox'' domain signature.', NULL, 'HOMEOBOX_1', NULL, NULL, 19173, 14),
(281630, NULL, 'PS00602', NULL, NULL, 'Fructose-bisphosphate aldolase class-II signature 1.', NULL, 'ALDOLASE_CLASS_II_1', NULL, NULL, 6927, 14),
(281631, NULL, 'PS00478', NULL, NULL, 'LIM zinc-binding domain signature.', NULL, 'LIM_DOMAIN_1', NULL, NULL, 4789, 14),
(281632, NULL, 'PS00625', NULL, NULL, 'Regulator of chromosome condensation (RCC1) signature 1.', NULL, 'RCC1_1', NULL, NULL, 6861, 14),
(281633, NULL, 'PS00695', NULL, NULL, 'Enterobacterial virulence outer membrane protein signature 2.', NULL, 'ENT_VIR_OMP_2', NULL, NULL, 6988, 14),
(281634, NULL, 'PS00681', NULL, NULL, 'Chaperonins cpn10 signature.', NULL, 'CHAPERONINS_CPN10', NULL, NULL, 20251, 14),
(281635, NULL, 'PS00496', NULL, NULL, 'P-II protein uridylation site.', NULL, 'PII_GLNB_UMP', NULL, NULL, 6213, 14),
(281636, NULL, 'PS00906', NULL, NULL, 'Uroporphyrinogen decarboxylase signature 1.', NULL, 'UROD_1', NULL, NULL, 1252, 14),
(281637, NULL, 'PS01005', NULL, NULL, 'Formate and nitrite transporters signature 1.', NULL, 'FORMATE_NITRITE_TP_1', NULL, NULL, 21456, 14),
(281638, NULL, 'PS00941', NULL, NULL, 'Carboxylesterases type-B signature 2.', NULL, 'CARBOXYLESTERASE_B_2', NULL, NULL, 15940, 14),
(281639, NULL, 'PS00018', NULL, NULL, 'EF-hand calcium-binding domain.', NULL, 'EF_HAND_1', NULL, NULL, 8022, 14),
(281640, NULL, 'PS00410', NULL, NULL, 'Dynamin-type guanine nucleotide-binding (G) domain signature.', NULL, 'G_DYNAMIN_1', NULL, NULL, 20660, 14),
(281641, NULL, 'PS01261', NULL, NULL, 'Uncharacterized protein family UPF0020 signature.', NULL, 'UPF0020', NULL, NULL, 4596, 14),
(281642, NULL, 'PS01347', NULL, NULL, 'MraY family signature 1.', NULL, 'MRAY_1', NULL, NULL, 9441, 14),
(281643, NULL, 'PS01069', NULL, NULL, 'Prokaryotic diacylglycerol kinase signature.', NULL, 'DAGK_PROKAR', NULL, NULL, 4561, 14),
(281644, NULL, 'PS01080', NULL, NULL, 'Apoptosis regulator, Bcl-2 family BH1 motif signature.', NULL, 'BH1', NULL, NULL, 19256, 14),
(281645, NULL, 'PS01165', NULL, NULL, 'Copper amine oxidase copper-binding site signature.', NULL, 'COPPER_AMINE_OXID_2', NULL, NULL, 771, 14),
(281646, NULL, 'PS00591', NULL, NULL, 'Glycosyl hydrolases family 10 (GH10) active site.', NULL, 'GH10_1', NULL, NULL, 25111, 14),
(281647, NULL, 'PS00606', NULL, NULL, 'Beta-ketoacyl synthases active site.', NULL, 'B_KETOACYL_SYNTHASE', NULL, NULL, 20065, 14),
(281648, NULL, 'PS00721', NULL, NULL, 'Formate--tetrahydrofolate ligase signature 1.', NULL, 'FTHFS_1', NULL, NULL, 20460, 14),
(281649, NULL, 'PS00772', NULL, NULL, 'Barwin domain signature 2.', NULL, 'BARWIN_2', NULL, NULL, 7552, 14),
(281650, NULL, 'PS00728', NULL, NULL, 'AP endonucleases family 1 signature 3.', NULL, 'AP_NUCLEASE_F1_3', NULL, NULL, 20917, 14),
(281651, NULL, 'PS01176', NULL, NULL, 'Initiation factor 2 signature.', NULL, 'IF2', NULL, NULL, 1737, 14),
(281652, NULL, 'PS00672', NULL, NULL, 'Serine proteases, V8 family, histidine active site.', NULL, 'V8_HIS', NULL, NULL, 21936, 14),
(281653, NULL, 'PS00011', NULL, NULL, 'Vitamin K-dependent carboxylation domain.', NULL, 'GLA_1', NULL, NULL, 4995, 14),
(281654, NULL, 'PS00242', NULL, NULL, 'Integrins alpha chain signature.', NULL, 'INTEGRIN_ALPHA', NULL, NULL, 7566, 14),
(281655, NULL, 'PS00664', NULL, NULL, 'Vinculin repeated domain signature.', NULL, 'VINCULIN_2', NULL, NULL, 5893, 14),
(281656, NULL, 'PS00104', NULL, NULL, 'EPSP synthase signature 1.', NULL, 'EPSP_SYNTHASE_1', NULL, NULL, 17426, 14);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(281657, NULL, 'PS00203', NULL, NULL, 'Vertebrate metallothioneins signature.', NULL, 'METALLOTHIONEIN_VRT', NULL, NULL, 19107, 14),
(281658, NULL, 'PS01143', NULL, NULL, 'Ribosomal protein L31 signature.', NULL, 'RIBOSOMAL_L31', NULL, NULL, 5403, 14),
(281659, NULL, 'PS01234', NULL, NULL, 'Glutamyl-tRNA(Gln) amidotransferase subunit B signature.', NULL, 'GATB', NULL, NULL, 4269, 14),
(281660, NULL, 'PS00817', NULL, NULL, 'Erythropoietin / thrombopoeitin signature.', NULL, 'EPO_TPO', NULL, NULL, 20544, 14),
(281661, NULL, 'PS00982', NULL, NULL, 'Bacterial-type phytoene dehydrogenase signature.', NULL, 'PHYTOENE_DH', NULL, NULL, 7426, 14),
(281662, NULL, 'PS00336', NULL, NULL, 'Beta-lactamase class-C active site.', NULL, 'BETA_LACTAMASE_C', NULL, NULL, 5441, 14),
(281663, NULL, 'PS00773', NULL, NULL, 'Chitinases family 19 signature 1.', NULL, 'CHITINASE_19_1', NULL, NULL, 7139, 14),
(281664, NULL, 'PS00269', NULL, NULL, 'Mammalian defensins signature.', NULL, 'DEFENSIN', NULL, NULL, 2857, 14),
(281665, NULL, 'PS00421', NULL, NULL, 'Transmembrane 4 family signature.', NULL, 'TM4_1', NULL, NULL, 17028, 14),
(281666, NULL, 'PS00206', NULL, NULL, 'Transferrin-like domain signature 2.', NULL, 'TRANSFERRIN_LIKE_2', NULL, NULL, 14882, 14),
(281667, NULL, 'PS00698', NULL, NULL, 'Glycosyl hydrolases family 9 (GH9) active site signature 3.', NULL, 'GH9_3', NULL, NULL, 32746, 14),
(281668, NULL, 'PS00344', NULL, NULL, 'GATA-type zinc finger domain.', NULL, 'GATA_ZN_FINGER_1', NULL, NULL, 3606, 14),
(281669, NULL, 'PS00846', NULL, NULL, 'Bacterial regulatory proteins, arsR family signature.', NULL, 'HTH_ARSR_1', NULL, NULL, 8431, 14),
(281670, NULL, 'PS00840', NULL, NULL, 'Uroporphyrin-III C-methyltransferase signature 2.', NULL, 'SUMT_2', NULL, NULL, 822, 14),
(281671, NULL, 'PS01247', NULL, NULL, 'Inosine-uridine preferring nucleoside hydrolase family signature.', NULL, 'IUNH', NULL, NULL, 8407, 14),
(281672, NULL, 'PS01039', NULL, NULL, 'Bacterial extracellular solute-binding proteins, family 3 signature.', NULL, 'SBP_BACTERIAL_3', NULL, NULL, 8340, 14),
(281673, NULL, 'PS00789', NULL, NULL, 'Chorismate synthase signature 3.', NULL, 'CHORISMATE_SYNTHASE_3', NULL, NULL, 14521, 14),
(281674, NULL, 'PS01163', NULL, NULL, 'Galactose-1-phosphate uridyl transferase family 2 signature.', NULL, 'GAL_P_UDP_TRANSF_II', NULL, NULL, 16308, 14),
(281675, NULL, 'PS00957', NULL, NULL, 'NAD-dependent glycerol-3-phosphate dehydrogenase signature.', NULL, 'NAD_G3PDH', NULL, NULL, 10110, 14),
(281676, NULL, 'PS00640', NULL, NULL, 'Eukaryotic thiol (cysteine) proteases asparagine active site.', NULL, 'THIOL_PROTEASE_ASN', NULL, NULL, 26253, 14),
(281677, NULL, 'PS01121', NULL, NULL, 'Caspase family histidine active site.', NULL, 'CASPASE_HIS', NULL, NULL, 11425, 14),
(281678, NULL, 'PS00566', NULL, NULL, 'Fibrillarin signature.', NULL, 'FIBRILLARIN', NULL, NULL, 14841, 14),
(281679, NULL, 'PS01155', NULL, NULL, 'Endonuclease III family signature.', NULL, 'ENDONUCLEASE_III_2', NULL, NULL, 990, 14),
(281680, NULL, 'PS00069', NULL, NULL, 'Glucose-6-phosphate dehydrogenase active site.', NULL, 'G6P_DEHYDROGENASE', NULL, NULL, 17036, 14),
(281681, NULL, 'PS00987', NULL, NULL, '6-pyruvoyl tetrahydropterin synthase signature 1.', NULL, 'PTPS_1', NULL, NULL, 15915, 14),
(281682, NULL, 'PS00132', NULL, NULL, 'Zinc carboxypeptidases, zinc-binding region 1 signature.', NULL, 'CARBOXYPEPT_ZN_1', NULL, NULL, 211, 14),
(281683, NULL, 'PS00865', NULL, NULL, 'Ubiquitin-activating enzyme active site.', NULL, 'UBIQUITIN_ACTIVAT_2', NULL, NULL, 32719, 14),
(281684, NULL, 'PS00805', NULL, NULL, 'Calreticulin family repeated motif signature.', NULL, 'CALRETICULIN_REPEAT', NULL, NULL, 18627, 14),
(281685, NULL, 'PS00053', NULL, NULL, 'Ribosomal protein S8 signature.', NULL, 'RIBOSOMAL_S8', NULL, NULL, 5531, 14),
(281686, NULL, 'PS00100', NULL, NULL, 'Chloramphenicol acetyltransferase active site.', NULL, 'CAT', NULL, NULL, 20362, 14),
(281687, NULL, 'PS00123', NULL, NULL, 'Alkaline phosphatase active site.', NULL, 'ALKALINE_PHOSPHATASE', NULL, NULL, 16561, 14);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(281688, NULL, 'PS00227', NULL, NULL, 'Tubulin subunits alpha, beta, and gamma signature.', NULL, 'TUBULIN', NULL, NULL, 12621, 14),
(281689, NULL, 'PS00023', NULL, NULL, 'Fibronectin type-II collagen-binding domain signature.', NULL, 'FN2_1', NULL, NULL, 5841, 14),
(281690, NULL, 'PS00858', NULL, NULL, 'Prephenate dehydratase signature 2.', NULL, 'PREPHENATE_DEHYDR_2', NULL, NULL, 9087, 14),
(281691, NULL, 'PS01265', NULL, NULL, 'Tpx family signature.', NULL, 'TPX', NULL, NULL, 17132, 14),
(281692, NULL, 'PS00055', NULL, NULL, 'Ribosomal protein S12 signature.', NULL, 'RIBOSOMAL_S12', NULL, NULL, 1086, 14),
(281693, NULL, 'PS01190', NULL, NULL, 'Ribosomal protein L36e signature.', NULL, 'RIBOSOMAL_L36E', NULL, NULL, 5592, 14),
(281694, NULL, 'PS00056', NULL, NULL, 'Ribosomal protein S17 signature.', NULL, 'RIBOSOMAL_S17', NULL, NULL, 11902, 14),
(281695, NULL, 'PS00661', NULL, NULL, 'FERM domain signature 2.', NULL, 'FERM_2', NULL, NULL, 20871, 14),
(281696, NULL, 'PS00669', NULL, NULL, 'Gas vesicles protein GVPa signature 2.', NULL, 'GAS_VESICLE_A_2', NULL, NULL, 9480, 14),
(281697, NULL, 'PS01014', NULL, NULL, 'Transcription termination factor nusG signature.', NULL, 'NUSG', NULL, NULL, 7374, 14),
(281698, NULL, 'PS01043', NULL, NULL, 'Transposases, IS30 family, signature.', NULL, 'TRANSPOSASE_IS30', NULL, NULL, 5058, 14),
(281699, NULL, 'PS01309', NULL, NULL, 'Uncharacterized protein family UPF0057 signature.', NULL, 'UPF0057', NULL, NULL, 5702, 14),
(281700, NULL, 'PS01250', NULL, NULL, 'Arthropod CHH/MIH/GIH neurohormones family signature.', NULL, 'CHH_MIH_GIH', NULL, NULL, 19666, 14),
(281701, NULL, 'PS40000', NULL, NULL, 'DM DNA-binding domain signature.', NULL, 'DM_1', NULL, NULL, 100, 14),
(281702, NULL, 'PS00279', NULL, NULL, 'Membrane attack complex/perforin (MACPF) domain signature.', NULL, 'MACPF_1', NULL, NULL, 20597, 14),
(281703, NULL, 'PS00482', NULL, NULL, 'Dihydroorotase signature 1.', NULL, 'DIHYDROOROTASE_1', NULL, NULL, 372, 14),
(281704, NULL, 'PS01272', NULL, NULL, 'Glucokinase regulatory protein family signature.', NULL, 'GCKR', NULL, NULL, 520, 14),
(281705, NULL, 'PS00797', NULL, NULL, '14-3-3 proteins signature 2.', NULL, '1433_2', NULL, NULL, 16356, 14),
(281706, NULL, 'PS00702', NULL, NULL, 'Granulocyte-macrophage colony-stimulating factor signature.', NULL, 'GM_CSF', NULL, NULL, 6701, 14),
(281707, NULL, 'PS00880', NULL, NULL, 'Acyl-CoA-binding (ACB) domain signature.', NULL, 'ACB_1', NULL, NULL, 21371, 14),
(281708, NULL, 'PS01210', NULL, NULL, 'Caveolins signature.', NULL, 'CAVEOLIN', NULL, NULL, 20456, 14),
(281709, NULL, 'PS00655', NULL, NULL, 'Glycosyl hydrolases family 6 signature 1.', NULL, 'GLYCOSYL_HYDROL_F6_1', NULL, NULL, 5216, 14),
(281710, NULL, 'PS00656', NULL, NULL, 'Glycosyl hydrolases family 6 signature 2.', NULL, 'GLYCOSYL_HYDROL_F6_2', NULL, NULL, 5216, 14),
(281711, NULL, 'PS00811', NULL, NULL, 'Oleosins signature.', NULL, 'OLEOSINS', NULL, NULL, 1548, 14),
(281712, NULL, 'PS00431', NULL, NULL, 'Small hydrophilic plant seed proteins signature.', NULL, 'SMALL_HYDR_PLANT_SEED', NULL, NULL, 15631, 14),
(281713, NULL, 'PS00844', NULL, NULL, 'D-alanine--D-alanine ligase signature 2.', NULL, 'DALA_DALA_LIGASE_2', NULL, NULL, 606, 14),
(281714, NULL, 'PS00680', NULL, NULL, 'Methionine aminopeptidase subfamily 1 signature.', NULL, 'MAP_1', NULL, NULL, 6896, 14),
(281715, NULL, 'PS00088', NULL, NULL, 'Manganese and iron superoxide dismutases signature.', NULL, 'SOD_MN', NULL, NULL, 18258, 14),
(281716, NULL, 'PS00423', NULL, NULL, 'Granins signature 2.', NULL, 'GRANINS_2', NULL, NULL, 19007, 14),
(281717, NULL, 'PS00939', NULL, NULL, 'Ribosomal protein L1e signature.', NULL, 'RIBOSOMAL_L1E', NULL, NULL, 11294, 14),
(281718, NULL, 'PS01066', NULL, NULL, 'Undecaprenyl pyrophosphate synthase family signature.', NULL, 'UPP_SYNTHASE', NULL, NULL, 19866, 14),
(281719, NULL, 'PS00595', NULL, NULL, 'Aminotransferases class-V pyridoxal-phosphate attachment site.', NULL, 'AA_TRANSFER_CLASS_5', NULL, NULL, 19341, 14),
(281720, NULL, 'PS00878', NULL, NULL, 'Orn/DAP/Arg decarboxylases family 2 pyridoxal-P attachment site.', NULL, 'ODR_DC_2_1', NULL, NULL, 16970, 14);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(281721, NULL, 'PS00202', NULL, NULL, 'Rubredoxin signature.', NULL, 'RUBREDOXIN', NULL, NULL, 19414, 14),
(281722, NULL, 'PS00870', NULL, NULL, 'Chaperonins clpA/B signature 1.', NULL, 'CLPAB_1', NULL, NULL, 20221, 14),
(281723, NULL, 'PS01018', NULL, NULL, 'Sterol reductase family signature 2.', NULL, 'STEROL_REDUCT_2', NULL, NULL, 13906, 14),
(281724, NULL, 'PS01007', NULL, NULL, 'Transposases, Mutator family, signature.', NULL, 'TRANSPOSASE_MUTATOR', NULL, NULL, 1429, 14),
(281725, NULL, 'PS00042', NULL, NULL, 'Crp-type HTH domain signature.', NULL, 'HTH_CRP_1', NULL, NULL, 8348, 14),
(281726, NULL, 'PS01350', NULL, NULL, '2C-methyl-D-erythritol 2,4-cyclodiphosphate synthase signature.', NULL, 'ISPF', NULL, NULL, 18862, 14),
(281727, NULL, 'PS01015', NULL, NULL, 'Ribosomal protein L19 signature.', NULL, 'RIBOSOMAL_L19', NULL, NULL, 19502, 14),
(281728, NULL, 'PS01312', NULL, NULL, 'SecA family signature.', NULL, 'SECA', NULL, NULL, 14503, 14),
(281729, NULL, 'PS00678', NULL, NULL, 'Trp-Asp (WD) repeats signature.', NULL, 'WD_REPEATS_1', NULL, NULL, 17126, 14),
(281730, NULL, 'PS00497', NULL, NULL, 'Tyrosinase CuA-binding region signature.', NULL, 'TYROSINASE_1', NULL, NULL, 289, 14),
(281731, NULL, 'PS00974', NULL, NULL, 'Mannitol dehydrogenases signature.', NULL, 'MANNITOL_DHGENASE', NULL, NULL, 15262, 14),
(281732, NULL, 'PS00597', NULL, NULL, 'Plant lipid transfer proteins signature.', NULL, 'PLANT_LTP', NULL, NULL, 5625, 14),
(281733, NULL, 'PS00895', NULL, NULL, '3-hydroxyisobutyrate dehydrogenase signature.', NULL, '3_HYDROXYISOBUT_DH', NULL, NULL, 5306, 14),
(281734, NULL, 'PS00126', NULL, NULL, '3''5''-cyclic nucleotide phosphodiesterase domain signature.', NULL, 'PDEASE_I_1', NULL, NULL, 8075, 14),
(281735, NULL, 'PS00171', NULL, NULL, 'Triosephosphate isomerase active site.', NULL, 'TIM_1', NULL, NULL, 20684, 14),
(281736, NULL, 'PS00960', NULL, NULL, 'BTG family signature 1.', NULL, 'BTG_1', NULL, NULL, 1263, 14),
(281737, NULL, 'PS00366', NULL, NULL, 'Uricase signature.', NULL, 'URICASE', NULL, NULL, 2640, 14),
(281738, NULL, 'PS01132', NULL, NULL, 'Actins and actin-related proteins signature.', NULL, 'ACTINS_ACT_LIKE', NULL, NULL, 19064, 14),
(281739, NULL, 'PS00029', NULL, NULL, 'Leucine zipper pattern.', NULL, 'LEUCINE_ZIPPER', NULL, NULL, NULL, 14),
(281740, NULL, 'PS00359', NULL, NULL, 'Ribosomal protein L11 signature.', NULL, 'RIBOSOMAL_L11', NULL, NULL, 21049, 14),
(281741, NULL, 'PS00676', NULL, NULL, 'Sigma-54 interaction domain ATP-binding region B signature.', NULL, 'SIGMA54_INTERACT_2', NULL, NULL, 21883, 14),
(281742, NULL, 'PS00551', NULL, NULL, 'Prokaryotic molybdopterin oxidoreductases signature 1.', NULL, 'MOLYBDOPTERIN_PROK_1', NULL, NULL, 23287, 14),
(281743, NULL, 'PS00874', NULL, NULL, 'Bacterial type II secretion system protein F signature.', NULL, 'T2SP_F', NULL, NULL, 4869, 14),
(281744, NULL, 'PS01044', NULL, NULL, 'Squalene and phytoene synthases signature 1.', NULL, 'SQUALEN_PHYTOEN_SYN_1', NULL, NULL, 18284, 14),
(281745, NULL, 'PS00444', NULL, NULL, 'Polyprenyl synthases signature 2.', NULL, 'POLYPRENYL_SYNTHASE_2', NULL, NULL, 28231, 14),
(281746, NULL, 'PS00688', NULL, NULL, 'Sigma-54 interaction domain C-terminal part signature.', NULL, 'SIGMA54_INTERACT_3', NULL, NULL, 21997, 14),
(281747, NULL, 'PS00555', NULL, NULL, 'Plant viruses icosahedral capsid proteins ''S'' region signature.', NULL, 'ICOSAH_VIR_COAT_S', NULL, NULL, NULL, 14),
(281748, NULL, 'PS00847', NULL, NULL, 'MCM family signature.', NULL, 'MCM_1', NULL, NULL, 19525, 14),
(281749, NULL, 'PS00096', NULL, NULL, 'Serine hydroxymethyltransferase pyridoxal-phosphate attachment site.', NULL, 'SHMT', NULL, NULL, 17465, 14),
(281750, NULL, 'PS00704', NULL, NULL, 'Prokaryotic-type carbonic anhydrases signature 1.', NULL, 'PROK_CO2_ANHYDRASE_1', NULL, NULL, 7546, 14),
(281751, NULL, 'PS00281', NULL, NULL, 'Bowman-Birk serine protease inhibitors family signature.', NULL, 'BOWMAN_BIRK', NULL, NULL, 59, 14),
(281752, NULL, 'PS00574', NULL, NULL, 'Fatty acid desaturases family 2 signature.', NULL, 'FATTY_ACID_DESATUR_2', NULL, NULL, 5819, 14);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(281753, NULL, 'PS00485', NULL, NULL, 'Adenosine and AMP deaminase signature.', NULL, 'A_DEAMINASE', NULL, NULL, 1062, 14),
(281754, NULL, 'PS00667', NULL, NULL, 'Respiratory-chain NADH dehydrogenase subunit 1 signature 1.', NULL, 'COMPLEX1_ND1_1', NULL, NULL, 13868, 14),
(281755, NULL, 'PS00388', NULL, NULL, 'Proteasome alpha-type subunits signature.', NULL, 'PROTEASOME_ALPHA_1', NULL, NULL, 6529, 14),
(281756, NULL, 'PS60023', NULL, NULL, 'Omega-agatoxin type II and III signature.', NULL, 'OMEGA_AGA_II_III', NULL, NULL, 12905, 14),
(281757, NULL, 'PS00737', NULL, NULL, 'Thiolases signature 2.', NULL, 'THIOLASE_2', NULL, NULL, 19106, 14),
(281758, NULL, 'PS00903', NULL, NULL, 'Cytidine and deoxycytidylate deaminases zinc-binding region signature.', NULL, 'CYT_DCMP_DEAMINASES_1', NULL, NULL, 18060, 14),
(281759, NULL, 'PS00094', NULL, NULL, 'C-5 cytosine-specific DNA methylases active site.', NULL, 'C5_MTASE_1', NULL, NULL, 18858, 14),
(281760, NULL, 'PS00471', NULL, NULL, 'Small cytokines (intercrine/chemokine) C-x-C subfamily signature.', NULL, 'SMALL_CYTOKINES_CXC', NULL, NULL, 14764, 14),
(281761, NULL, 'PS01237', NULL, NULL, 'Uncharacterized protein family UPF0028 signature.', NULL, 'UPF0028', NULL, NULL, 6982, 14),
(281762, NULL, 'PS00853', NULL, NULL, 'Beta-eliminating lyases pyridoxal-phosphate attachment site.', NULL, 'BETA_ELIM_LYASE', NULL, NULL, 7781, 14),
(281763, NULL, 'PS00682', NULL, NULL, 'ZP domain signature.', NULL, 'ZP_1', NULL, NULL, 12727, 14),
(281764, NULL, 'PS00685', NULL, NULL, 'NF-YB/HAP3 subunit signature.', NULL, 'NFYB_HAP3', NULL, NULL, 7405, 14),
(281765, NULL, 'PS00593', NULL, NULL, 'Heme oxygenase signature.', NULL, 'HEME_OXYGENASE', NULL, NULL, 19881, 14),
(281766, NULL, 'PS00671', NULL, NULL, 'D-isomer specific 2-hydroxyacid dehydrogenases signature 3.', NULL, 'D_2_HYDROXYACID_DH_3', NULL, NULL, 25496, 14),
(281767, NULL, 'PS00224', NULL, NULL, 'Clathrin light chain signature 1.', NULL, 'CLATHRIN_LIGHT_CHN_1', NULL, NULL, 3001, 14),
(281768, NULL, 'PS00614', NULL, NULL, 'Indole-3-glycerol phosphate synthase signature.', NULL, 'IGPS', NULL, NULL, 3258, 14),
(281769, NULL, 'PS00072', NULL, NULL, 'Acyl-CoA dehydrogenases signature 1.', NULL, 'ACYL_COA_DH_1', NULL, NULL, 2691, 14),
(281770, NULL, 'PS00266', NULL, NULL, 'Somatotropin, prolactin and related hormones signature 1.', NULL, 'SOMATOTROPIN_1', NULL, NULL, 18832, 14),
(281771, NULL, 'PS01270', NULL, NULL, 'Band 7 protein family signature.', NULL, 'BAND_7', NULL, NULL, 13612, 14),
(281772, NULL, 'PS00857', NULL, NULL, 'Prephenate dehydratase signature 1.', NULL, 'PREPHENATE_DEHYDR_1', NULL, NULL, 9087, 14),
(281773, NULL, 'PS01149', NULL, NULL, 'Rsu family of pseudouridine synthase signature.', NULL, 'PSI_RSU', NULL, NULL, 9310, 14),
(281774, NULL, 'PS01280', NULL, NULL, 'Glucose inhibited division protein A family signature 1.', NULL, 'GIDA_1', NULL, NULL, 19733, 14),
(281775, NULL, 'PS00730', NULL, NULL, 'AP endonucleases family 2 signature 2.', NULL, 'AP_NUCLEASE_F2_2', NULL, NULL, 8256, 14),
(281776, NULL, 'PS00127', NULL, NULL, 'Pancreatic ribonuclease family signature.', NULL, 'RNASE_PANCREATIC', NULL, NULL, 16376, 14),
(281777, NULL, 'PS00220', NULL, NULL, 'Anion exchangers family signature 2.', NULL, 'ANION_EXCHANGER_2', NULL, NULL, 8306, 14),
(281778, NULL, 'PS00400', NULL, NULL, 'LBP / BPI / CETP family signature.', NULL, 'LBP_BPI_CETP', NULL, NULL, 1074, 14),
(281779, NULL, 'PS00700', NULL, NULL, 'Ribosomal protein L6 signature 2.', NULL, 'RIBOSOMAL_L6_2', NULL, NULL, 6220, 14),
(281780, NULL, 'PS00314', NULL, NULL, 'Bacterial ice-nucleation proteins octamer repeat.', NULL, 'ICE_NUCLEATION', NULL, NULL, 4622, 14),
(281781, NULL, 'PS00694', NULL, NULL, 'Enterobacterial virulence outer membrane protein signature 1.', NULL, 'ENT_VIR_OMP_1', NULL, NULL, 6988, 14),
(281782, NULL, 'PS01215', NULL, NULL, 'Mrp family signature.', NULL, 'MRP', NULL, NULL, 6999, 14),
(281783, NULL, 'PS00760', NULL, NULL, 'Signal peptidases I lysine active site.', NULL, 'SPASE_I_2', NULL, NULL, 20577, 14),
(281784, NULL, 'PS01259', NULL, NULL, 'Apoptosis regulator, Bcl-2 family BH3 motif signature.', NULL, 'BH3', NULL, NULL, 19360, 14);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(281785, NULL, 'PS00481', NULL, NULL, 'Thiol-activated cytolysins signature.', NULL, 'THIOL_CYTOLYSINS', NULL, NULL, 4318, 14),
(281786, NULL, 'PS00712', NULL, NULL, 'Ribosomal protein S17e signature.', NULL, 'RIBOSOMAL_S17E', NULL, NULL, 19675, 14),
(281787, NULL, 'PS00379', NULL, NULL, 'CDP-alcohol phosphatidyltransferases signature.', NULL, 'CDP_ALCOHOL_P_TRANSF', NULL, NULL, 6617, 14),
(281788, NULL, 'PS00569', NULL, NULL, 'Myelin basic protein signature.', NULL, 'MYELIN_MBP', NULL, NULL, 5901, 14),
(281789, NULL, 'PS00076', NULL, NULL, 'Pyridine nucleotide-disulphide oxidoreductases class-I active site.', NULL, 'PYRIDINE_REDOX_1', NULL, NULL, 10039, 14),
(281790, NULL, 'PS00261', NULL, NULL, 'Glycoprotein hormones beta chain signature 1.', NULL, 'GLYCO_HORMONE_BETA_1', NULL, NULL, 8220, 14),
(281791, NULL, 'PS00460', NULL, NULL, 'Glutathione peroxidases active site.', NULL, 'GLUTATHIONE_PEROXID_1', NULL, NULL, 24232, 14),
(281792, NULL, 'PS00491', NULL, NULL, 'Aminopeptidase P and proline dipeptidase signature.', NULL, 'PROLINE_PEPTIDASE', NULL, NULL, 4039, 14),
(281793, NULL, 'PS01053', NULL, NULL, 'Arginase family signature.', NULL, 'ARGINASE_1', NULL, NULL, 21412, 14),
(281794, NULL, 'PS00217', NULL, NULL, 'Sugar transport proteins signature 2.', NULL, 'SUGAR_TRANSPORT_2', NULL, NULL, 6940, 14),
(281795, NULL, 'PS00538', NULL, NULL, 'Bacterial chemotaxis sensory transducers signature.', NULL, 'CHEMOTAXIS_TRANSDUC_1', NULL, NULL, 1550, 14),
(281796, NULL, 'PS01134', NULL, NULL, 'FtsZ protein signature 1.', NULL, 'FTSZ_1', NULL, NULL, 21438, 14),
(281797, NULL, 'PS00341', NULL, NULL, 'Surfactant associated polypeptide SP-C palmitoylation sites.', NULL, 'SURFACT_PALMITOYL', NULL, NULL, 14930, 14),
(281798, NULL, 'PS01316', NULL, NULL, 'ATP phosphoribosyltransferase signature.', NULL, 'ATP_P_PHORIBOSYLTR', NULL, NULL, 20500, 14),
(281799, NULL, 'PS00411', NULL, NULL, 'Kinesin motor domain signature.', NULL, 'KINESIN_MOTOR_1', NULL, NULL, 17336, 14),
(281800, NULL, 'PS60005', NULL, NULL, 'Delta-conotoxin family signature.', NULL, 'DELTA_CONOTOXIN', NULL, NULL, 11508, 14),
(281801, NULL, 'PS00198', NULL, NULL, '4Fe-4S ferredoxin-type iron-sulfur binding region signature.', NULL, '4FE4S_FER_1', NULL, NULL, 12991, 14),
(281802, NULL, 'PS00663', NULL, NULL, 'Vinculin family talin-binding region signature.', NULL, 'VINCULIN_1', NULL, NULL, 5893, 14),
(281803, NULL, 'PS01172', NULL, NULL, 'Ribosomal protein L44e signature.', NULL, 'RIBOSOMAL_L44E', NULL, NULL, 5586, 14),
(281804, NULL, 'PS01348', NULL, NULL, 'MraY family signature 2.', NULL, 'MRAY_2', NULL, NULL, 9441, 14),
(281805, NULL, 'PS00446', NULL, NULL, 'RNA polymerases D / 30 to 40 Kd subunits signature.', NULL, 'RNA_POL_D_30KD', NULL, NULL, 3374, 14),
(281806, NULL, 'PS00105', NULL, NULL, 'Aminotransferases class-I pyridoxal-phosphate attachment site.', NULL, 'AA_TRANSFER_CLASS_1', NULL, NULL, 4475, 14),
(281807, NULL, 'PS00573', NULL, NULL, 'Pyridine nucleotide-disulphide oxidoreductases class-II active site.', NULL, 'PYRIDINE_REDOX_2', NULL, NULL, 12431, 14),
(281808, NULL, 'PS00221', NULL, NULL, 'MIP family signature.', NULL, 'MIP', NULL, NULL, 15539, 14),
(281809, NULL, 'PS00609', NULL, NULL, 'Glycosyl hydrolases family 32 active site.', NULL, 'GLYCOSYL_HYDROL_F32', NULL, NULL, 14720, 14),
(281810, NULL, 'PS00163', NULL, NULL, 'Fumarate lyases signature.', NULL, 'FUMARATE_LYASES', NULL, NULL, 14634, 14),
(281811, NULL, 'PS01315', NULL, NULL, 'Phosphatidate cytidylyltransferase signature.', NULL, 'CDS', NULL, NULL, 87, 14),
(281812, NULL, 'PS01228', NULL, NULL, 'Hypothetical cof family signature 1.', NULL, 'COF_1', NULL, NULL, NULL, 14),
(281813, NULL, 'PS01232', NULL, NULL, 'Purine and other phosphorylases family 1 signature.', NULL, 'PNP_UDP_1', NULL, NULL, 16849, 14),
(281814, NULL, 'PS01279', NULL, NULL, 'Protein-L-isoaspartate(D-aspartate) O-methyltransferase signature.', NULL, 'PCMT', NULL, NULL, 6763, 14),
(281815, NULL, 'PS00414', NULL, NULL, 'Profilin signature.', NULL, 'PROFILIN', NULL, NULL, 24399, 14),
(281816, NULL, 'PS00249', NULL, NULL, 'Platelet-derived growth factor (PDGF) family signature.', NULL, 'PDGF_1', NULL, NULL, 20758, 14);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(281817, NULL, 'PS01289', NULL, NULL, 'TSC-22 / dip / bun family signature.', NULL, 'TSC22', NULL, NULL, 5606, 14),
(281818, NULL, 'PS00028', NULL, NULL, 'Zinc finger C2H2 type domain signature.', NULL, 'ZINC_FINGER_C2H2_1', NULL, NULL, 13910, 14),
(281819, NULL, 'PS00626', NULL, NULL, 'Regulator of chromosome condensation (RCC1) signature 2.', NULL, 'RCC1_2', NULL, NULL, 6861, 14),
(281820, NULL, 'PS00697', NULL, NULL, 'ATP-dependent DNA ligase AMP-binding site.', NULL, 'DNA_LIGASE_A1', NULL, NULL, 18085, 14),
(281821, NULL, 'PS00187', NULL, NULL, 'Thiamine pyrophosphate enzymes signature.', NULL, 'TPP_ENZYMES', NULL, NULL, 4686, 14),
(281822, NULL, 'PS51135', NULL, NULL, 'CIDE-N domain profile.', NULL, 'CIDE_N', NULL, NULL, 6264, 15),
(281823, NULL, 'PS51900', NULL, NULL, 'Core-binding (CB) domain profile.', NULL, 'CB', NULL, NULL, 36792, 15),
(281824, NULL, 'PS50929', NULL, NULL, 'ABC transporter integral membrane type-1 fused domain profile.', NULL, 'ABC_TM1F', NULL, NULL, 12367, 15),
(281825, NULL, 'PS51645', NULL, NULL, 'Photolyase/cryptochrome alpha/beta domain profile.', NULL, 'PHR_CRY_ALPHA_BETA', NULL, NULL, 2797, 15),
(281826, NULL, 'PS51223', NULL, NULL, 'MAP repeat profile.', NULL, 'MAP', NULL, NULL, 5013, 15),
(281827, NULL, 'PS51240', NULL, NULL, 'Nod factors export ATP-binding protein I nodI family profile.', NULL, 'NODI', NULL, NULL, NULL, 15),
(281828, NULL, 'PS51833', NULL, NULL, 'HD-related output (HDOD) domain profile.', NULL, 'HDOD', NULL, NULL, 7952, 15),
(281829, NULL, 'PS51297', NULL, NULL, 'K-box domain profile.', NULL, 'K_BOX', NULL, NULL, 748, 15),
(281830, NULL, 'PS51581', NULL, NULL, 'SAM-dependent methyltransferase gamma-tocopherol (gTMT)-type family profile.', NULL, 'SAM_GTMT', NULL, NULL, 22513, 15),
(281831, NULL, 'PS51642', NULL, NULL, 'Hemopexin repeat profile.', NULL, 'HEMOPEXIN_2', NULL, NULL, 21178, 15),
(281832, NULL, 'PS51438', NULL, NULL, 'Albumin domain profile.', NULL, 'ALBUMIN_2', NULL, NULL, 12292, 15),
(281833, NULL, 'PS50109', NULL, NULL, 'Histidine kinase domain profile.', NULL, 'HIS_KIN', NULL, NULL, 620, 15),
(281834, NULL, 'PS51290', NULL, NULL, 'CRIC domain profile.', NULL, 'CRIC', NULL, NULL, 18101, 15),
(281835, NULL, 'PS51763', NULL, NULL, 'CBM10 (carbohydrate-binding type-10) domain profile.', NULL, 'CBM10', NULL, NULL, 5623, 15),
(281836, NULL, 'PS50054', NULL, NULL, 'Dual specificity protein phosphatase domain profile.', NULL, 'TYR_PHOSPHATASE_DUAL', NULL, NULL, 18593, 15),
(281837, NULL, 'PS50062', NULL, NULL, 'BCL2-like apoptosis inhibitors family profile.', NULL, 'BCL2_FAMILY', NULL, NULL, 565, 15),
(281838, NULL, 'PS51366', NULL, NULL, 'MI domain profile.', NULL, 'MI', NULL, NULL, 6411, 15),
(281839, NULL, 'PS51145', NULL, NULL, 'ZU5 domain profile.', NULL, 'ZU5', NULL, NULL, 3277, 15),
(281840, NULL, 'PS51302', NULL, NULL, 'Single-minded C-terminal domain profile.', NULL, 'SIM_C', NULL, NULL, 8327, 15),
(281841, NULL, 'PS51718', NULL, NULL, 'Dynamin-type guanine nucleotide-binding (G) domain profile.', NULL, 'G_DYNAMIN_2', NULL, NULL, 23883, 15),
(281842, NULL, 'PS51401', NULL, NULL, 'CHORD domain profile.', NULL, 'CHORD', NULL, NULL, 6807, 15),
(281843, NULL, 'PS50283', NULL, NULL, 'Sodium:solute symporter family profile.', NULL, 'NA_SOLUT_SYMP_3', NULL, NULL, 5065, 15),
(281844, NULL, 'PS50089', NULL, NULL, 'Zinc finger RING-type profile.', NULL, 'ZF_RING_2', NULL, NULL, 4043, 15),
(281845, NULL, 'PS51096', NULL, NULL, 'PTS_EIIA type-4 domain profile.', NULL, 'PTS_EIIA_TYPE_4', NULL, NULL, 3085, 15),
(281846, NULL, 'PS51881', NULL, NULL, 'Obg C-terminal (OCT) domain profile.', NULL, 'OCT', NULL, NULL, 13354, 15),
(281847, NULL, 'PS01225', NULL, NULL, 'C-terminal cystine knot domain profile.', NULL, 'CTCK_2', NULL, NULL, 11169, 15),
(281848, NULL, 'PS51543', NULL, NULL, 'FYR domain FYRC motif profile.', NULL, 'FYRC', NULL, NULL, 4036, 15),
(281849, NULL, 'PS50957', NULL, NULL, 'Josephin domain profile.', NULL, 'JOSEPHIN', NULL, NULL, 10439, 15),
(281850, NULL, 'PS51192', NULL, NULL, 'Superfamilies 1 and 2 helicase ATP-binding type-1 domain profile.', NULL, 'HELICASE_ATP_BIND_1', NULL, NULL, 7954, 15);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(281851, NULL, 'PS50315', NULL, NULL, 'Glycine-rich region profile.', NULL, 'GLY_RICH', NULL, NULL, NULL, 15),
(281852, NULL, 'PS51562', NULL, NULL, 'mRNA (guanine-N(7)-)-methyltransferase (EC 2.1.1.56) domain profile.', NULL, 'RNA_CAP0_MT', NULL, NULL, 562, 15),
(281853, NULL, 'PS51746', NULL, NULL, 'PPM-type phosphatase domain profile.', NULL, 'PPM_2', NULL, NULL, 2124, 15),
(281854, NULL, 'PS50865', NULL, NULL, 'Zinc finger MYND-type profile.', NULL, 'ZF_MYND_2', NULL, NULL, 6032, 15),
(281855, NULL, 'PS51441', NULL, NULL, 'CpcD-like domain profile.', NULL, 'CPCD_LIKE', NULL, NULL, 568, 15),
(281856, NULL, 'PS51293', NULL, NULL, 'SANT domain profile.', NULL, 'SANT', NULL, NULL, 7619, 15),
(281857, NULL, 'PS51859', NULL, NULL, 'Rho-binding (RhoBD) domain profile.', NULL, 'RHO_BD', NULL, NULL, 7790, 15),
(281858, NULL, 'PS50821', NULL, NULL, 'PAZ domain profile.', NULL, 'PAZ', NULL, NULL, 1158, 15),
(281859, NULL, 'PS51902', NULL, NULL, 'ClpX zinc binding (ZB) domain profile.', NULL, 'CLPX_ZB', NULL, NULL, 8146, 15),
(281860, NULL, 'PS50949', NULL, NULL, 'GntR-type HTH domain profile.', NULL, 'HTH_GNTR', NULL, NULL, 5800, 15),
(281861, NULL, 'PS50068', NULL, NULL, 'LDL-receptor class A (LDLRA) domain profile.', NULL, 'LDLRA_2', NULL, NULL, 5466, 15),
(281862, NULL, 'PS51011', NULL, NULL, 'ARID domain profile.', NULL, 'ARID', NULL, NULL, 5497, 15),
(281863, NULL, 'PS51106', NULL, NULL, 'PTS_EIIC type-4 domain profile.', NULL, 'PTS_EIIC_TYPE_4', NULL, NULL, 3076, 15),
(281864, NULL, 'PS51876', NULL, NULL, 'Pestivirus N-terminal protease Npro domain profile.', NULL, 'PV_NPRO', NULL, NULL, 12072, 15),
(281865, NULL, 'PS50099', NULL, NULL, 'Proline-rich region profile.', NULL, 'PRO_RICH', NULL, NULL, NULL, 15),
(281866, NULL, 'PS50858', NULL, NULL, 'BSD domain profile.', NULL, 'BSD', NULL, NULL, 2915, 15),
(281867, NULL, 'PS50954', NULL, NULL, 'LEM domain profile.', NULL, 'LEM', NULL, NULL, 4115, 15),
(281868, NULL, 'PS51058', NULL, NULL, 'Zinc finger CXXC-type profile.', NULL, 'ZF_CXXC', NULL, NULL, 5579, 15),
(281869, NULL, 'PS50020', NULL, NULL, 'WW/rsp5/WWP domain profile.', NULL, 'WW_DOMAIN_2', NULL, NULL, 1285, 15),
(281870, NULL, 'PS50999', NULL, NULL, 'Cytochrome oxidase subunit II transmembrane region profile.', NULL, 'COX2_TM', NULL, NULL, 8294, 15),
(281871, NULL, 'PS51837', NULL, NULL, 'LITAF domain profile.', NULL, 'LITAF', NULL, NULL, 1034, 15),
(281872, NULL, 'PS51647', NULL, NULL, 'Kininogen-type cystatin domain profile.', NULL, 'CYSTATIN_KININOGEN', NULL, NULL, 24216, 15),
(281873, NULL, 'PS51213', NULL, NULL, 'ELK domain profile.', NULL, 'ELK', NULL, NULL, 1922, 15),
(281874, NULL, 'PS51698', NULL, NULL, 'U-box domain profile.', NULL, 'U_BOX', NULL, NULL, 1000, 15),
(281875, NULL, 'PS50844', NULL, NULL, 'Antifreeze protein-like domain profile.', NULL, 'AFP_LIKE', NULL, NULL, 11397, 15),
(281876, NULL, 'PS51012', NULL, NULL, 'ABC transporter integral membrane type-2 domain profile.', NULL, 'ABC_TM2', NULL, NULL, 4597, 15),
(281877, NULL, 'PS51176', NULL, NULL, 'Prephenate/arogenate dehydrogenase domain profile.', NULL, 'PDH_ADH', NULL, NULL, 1444, 15),
(281878, NULL, 'PS50007', NULL, NULL, 'Phosphatidylinositol-specific phospholipase X-box domain profile.', NULL, 'PIPLC_X_DOMAIN', NULL, NULL, NULL, 15),
(281879, NULL, 'PS50162', NULL, NULL, 'RecA family profile 1.', NULL, 'RECA_2', NULL, NULL, 20605, 15),
(281880, NULL, 'PS51592', NULL, NULL, 'mRNA (2''-O-methyladenosine-N(6)-)-methyltransferase-like (MT-A70-like) family profile.', NULL, 'SAM_MTA70L_2', NULL, NULL, NULL, 15),
(281881, NULL, 'PS51220', NULL, NULL, 'NIDO domain profile.', NULL, 'NIDO', NULL, NULL, 4446, 15),
(281882, NULL, 'PS51178', NULL, NULL, 'PASTA domain profile.', NULL, 'PASTA', NULL, NULL, 1695, 15),
(281883, NULL, 'PS51869', NULL, NULL, 'Amyloid precursor protein (APP) E1 domain profile.', NULL, 'APP_E1', NULL, NULL, 7019, 15),
(281884, NULL, 'PS51625', NULL, NULL, 'SAM-dependent methyltransferase TRMB-type domain profile.', NULL, 'SAM_MT_TRMB', NULL, NULL, 4397, 15),
(281885, NULL, 'PS51644', NULL, NULL, 'OST-type HTH domain profile.', NULL, 'HTH_OST', NULL, NULL, 23128, 15);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(281886, NULL, 'PS51258', NULL, NULL, 'Munc13-homology domain 1 (MHD1) profile.', NULL, 'MHD1', NULL, NULL, 11219, 15),
(281887, NULL, 'PS51710', NULL, NULL, 'OBG-type guanine nucleotide-binding (G) domain profile.', NULL, 'G_OBG', NULL, NULL, 23589, 15),
(281888, NULL, 'PS51608', NULL, NULL, 'UbiE family SAM-binding methyltransferase profile.', NULL, 'SAM_MT_UBIE', NULL, NULL, 838, 15),
(281889, NULL, 'PS51684', NULL, NULL, 'SAM-dependent methyltransferase TRM5/TYW2-type domain profile.', NULL, 'SAM_MT_TRM5_TYW2', NULL, NULL, 21609, 15),
(281890, NULL, 'PS51078', NULL, NULL, 'IclR effector binding domain profile.', NULL, 'ICLR_ED', NULL, NULL, 12488, 15),
(281891, NULL, 'PS51732', NULL, NULL, 'Asparaginase / glutaminase domain profile.', NULL, 'ASN_GLN_ASE_3', NULL, NULL, 2746, 15),
(281892, NULL, 'PS51570', NULL, NULL, 'Histone-lysine N-methyltransferase (EC 2.1.1.43) family profile.', NULL, 'SAM_MT43_SUVAR420_2', NULL, NULL, 22799, 15),
(281893, NULL, 'PS51492', NULL, NULL, 'Peptidase family C23 domain profile.', NULL, 'PEPTIDASE_C23', NULL, NULL, 5251, 15),
(281894, NULL, 'PS51866', NULL, NULL, 'Mop domain profile.', NULL, 'MOP', NULL, NULL, 888, 15),
(281895, NULL, 'PS50993', NULL, NULL, 'Nidogen G2 beta-barrel domain profile.', NULL, 'NIDOGEN_G2', NULL, NULL, 1394, 15),
(281896, NULL, 'PS50931', NULL, NULL, 'LysR-type HTH domain profile.', NULL, 'HTH_LYSR', NULL, NULL, 221, 15),
(281897, NULL, 'PS51379', NULL, NULL, '4Fe-4S ferredoxin-type iron-sulfur binding domain profile.', NULL, '4FE4S_FER_2', NULL, NULL, 12567, 15),
(281898, NULL, 'PS51316', NULL, NULL, 'Olduvai (ODV) domain profile.', NULL, 'ODV', NULL, NULL, 9131, 15),
(281899, NULL, 'PS51190', NULL, NULL, 'FATC domain profile.', NULL, 'FATC', NULL, NULL, 1879, 15),
(281900, NULL, 'PS51166', NULL, NULL, 'CBM20 (carbohydrate binding type-20) domain profile.', NULL, 'CBM20', NULL, NULL, 1274, 15),
(281901, NULL, 'PS50112', NULL, NULL, 'PAS repeat profile.', NULL, 'PAS', NULL, NULL, 3787, 15),
(281902, NULL, 'PS51068', NULL, NULL, 'Formamidopyrimidine-DNA glycosylase catalytic domain profile.', NULL, 'FPG_CAT', NULL, NULL, 11684, 15),
(281903, NULL, 'PS51386', NULL, NULL, 'RINT1/TIP20 domain profile.', NULL, 'RINT1_TIP20', NULL, NULL, 10514, 15),
(281904, NULL, 'PS50966', NULL, NULL, 'Zinc finger SWIM-type profile.', NULL, 'ZF_SWIM', NULL, NULL, 10705, 15),
(281905, NULL, 'PS50936', NULL, NULL, 'EngC GTPase domain profile.', NULL, 'ENGC_GTPASE', NULL, NULL, 5304, 15),
(281906, NULL, 'PS51984', NULL, NULL, 'Cryptic Polo-Box 1 (CPB1) domain profile.', NULL, 'CPB1', NULL, NULL, 29785, 15),
(281907, NULL, 'PS50207', NULL, NULL, 'Caspase family p10 domain profile.', NULL, 'CASPASE_P10', NULL, NULL, 5226, 15),
(281908, NULL, 'PS50905', NULL, NULL, 'Ferritin-like diiron domain profile.', NULL, 'FERRITIN_LIKE', NULL, NULL, 7915, 15),
(281909, NULL, 'PS51576', NULL, NULL, 'Histone-lysine N-methyltransferase (EC 2.1.1.43) family profile.', NULL, 'SAM_MT43_EZ', NULL, NULL, 23019, 15),
(281910, NULL, 'PS51685', NULL, NULL, 'SAM-dependent methyltransferase Erg6/SMT-type domain profile.', NULL, 'SAM_MT_ERG6_SMT', NULL, NULL, 21862, 15),
(281911, NULL, 'PS51567', NULL, NULL, 'Histone-lysine N-methyltransferase (EC 2.1.1.43) family profile.', NULL, 'SAM_MT43_SUVAR420_1', NULL, NULL, 24115, 15),
(281912, NULL, 'PS51800', NULL, NULL, 'Zinc finger CHHC U11-48K-type profile.', NULL, 'ZF_CHHC_U11_48K', NULL, NULL, 17363, 15),
(281913, NULL, 'PS51263', NULL, NULL, 'ADF-H domain profile.', NULL, 'ADF_H', NULL, NULL, 5363, 15),
(281914, NULL, 'PS50822', NULL, NULL, 'Piwi domain profile.', NULL, 'PIWI', NULL, NULL, 1545, 15),
(281915, NULL, 'PS51054', NULL, NULL, 'Orange domain profile.', NULL, 'ORANGE', NULL, NULL, 1404, 15),
(281916, NULL, 'PS51721', NULL, NULL, 'Circularly permuted (CP)-type guanine nucleotide-binding (G) domain profile.', NULL, 'G_CP', NULL, NULL, 26716, 15),
(281917, NULL, 'PS51277', NULL, NULL, 'BURP domain profile.', NULL, 'BURP', NULL, NULL, 7494, 15),
(281918, NULL, 'PS50901', NULL, NULL, 'FtsK domain profile.', NULL, 'FTSK', NULL, NULL, 1835, 15);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(281919, NULL, 'PS50968', NULL, NULL, 'Biotinyl/lipoyl domain profile.', NULL, 'BIOTINYL_LIPOYL', NULL, NULL, 2971, 15),
(281920, NULL, 'PS51666', NULL, NULL, 'QLQ domain profile.', NULL, 'QLQ', NULL, NULL, 14200, 15),
(281921, NULL, 'PS51530', NULL, NULL, 'Fetuin-B-type cystatin domain profile.', NULL, 'CYSTATIN_FETUIN_B', NULL, NULL, 23350, 15),
(281922, NULL, 'PS51891', NULL, NULL, 'CENP-V/GFA domain profile.', NULL, 'CENP_V_GFA', NULL, NULL, 4910, 15),
(281923, NULL, 'PS51554', NULL, NULL, 'Pyruvate formate-lyase domain profile.', NULL, 'PFL', NULL, NULL, 2761, 15),
(281924, NULL, 'PS51758', NULL, NULL, 'Letm1 ribosome-binding (RBD) domain profile.', NULL, 'LETM1_RBD', NULL, NULL, 29182, 15),
(281925, NULL, 'PS50906', NULL, NULL, 'Nitrate and nitrite sensing (NIT) domain profile.', NULL, 'NIT', NULL, NULL, 5169, 15),
(281926, NULL, 'PS51483', NULL, NULL, 'B5 domain profile.', NULL, 'B5', NULL, NULL, 4285, 15),
(281927, NULL, 'PS51880', NULL, NULL, 'TGS domain profile.', NULL, 'TGS', NULL, NULL, 1817, 15),
(281928, NULL, 'PS50302', NULL, NULL, 'Pumilio RNA-binding repeat profile.', NULL, 'PUM', NULL, NULL, 2315, 15),
(281929, NULL, 'PS51329', NULL, NULL, 'C-CAP/cofactor C-like domain profile.', NULL, 'C_CAP_COFACTOR_C', NULL, NULL, 12863, 15),
(281930, NULL, 'PS51635', NULL, NULL, 'Patatin-like phospholipase (PNPLA) domain profile.', NULL, 'PNPLA', NULL, NULL, 2959, 15),
(281931, NULL, 'PS50135', NULL, NULL, 'Zinc finger ZZ-type profile.', NULL, 'ZF_ZZ_2', NULL, NULL, 4349, 15),
(281932, NULL, 'PS50197', NULL, NULL, 'BEACH domain profile.', NULL, 'BEACH', NULL, NULL, 299, 15),
(281933, NULL, 'PS50948', NULL, NULL, 'PAN/Apple domain profile.', NULL, 'PAN', NULL, NULL, 843, 15),
(281934, NULL, 'PS51534', NULL, NULL, 'SEFIR domain profile.', NULL, 'SEFIR', NULL, NULL, 12507, 15),
(281935, NULL, 'PS51465', NULL, NULL, 'Kazal domain profile.', NULL, 'KAZAL_2', NULL, NULL, 6489, 15),
(281936, NULL, 'PS51790', NULL, NULL, 'Methionine-R-sulfoxide reductase (MsrB) domain profile.', NULL, 'MSRB', NULL, NULL, 1901, 15),
(281937, NULL, 'PS51688', NULL, NULL, 'Intramolecular chaperone auto-processing (ICA) domain profile.', NULL, 'ICA', NULL, NULL, 26703, 15),
(281938, NULL, 'PS51687', NULL, NULL, 'SAM-dependent methyltransferase RNA m(5)U-type domain profile.', NULL, 'SAM_MT_RNA_M5U', NULL, NULL, 7630, 15),
(281939, NULL, 'PS51432', NULL, NULL, 'AP endonucleases family 2 profile.', NULL, 'AP_NUCLEASE_F2_4', NULL, NULL, 3499, 15),
(281940, NULL, 'PS51745', NULL, NULL, 'PB1 domain profile.', NULL, 'PB1', NULL, NULL, 760, 15),
(281941, NULL, 'PS50184', NULL, NULL, 'VWFC domain profile.', NULL, 'VWFC_2', NULL, NULL, 2283, 15),
(281942, NULL, 'PS50190', NULL, NULL, 'SEC7 domain profile.', NULL, 'SEC7', NULL, NULL, 3401, 15),
(281943, NULL, 'PS51537', NULL, NULL, 'Norovirus 3C-like protease (NV 3CLpro) domain profile.', NULL, 'NV_3CL_PRO', NULL, NULL, 3146, 15),
(281944, NULL, 'PS51950', NULL, NULL, 'Coronavirus RNA-dependent RNA polymerase (RdRp) Nsp8 cofactor domain profile.', NULL, 'COV_NSP8', NULL, NULL, 11972, 15),
(281945, NULL, 'PS50841', NULL, NULL, 'DIX domain profile.', NULL, 'DIX', NULL, NULL, 1275, 15),
(281946, NULL, 'PS51656', NULL, NULL, '4Fe-4S domain profile.', NULL, '4FE4S', NULL, NULL, 1068, 15),
(281947, NULL, 'PS51743', NULL, NULL, 'Alphavirus-like methyltransferase (MT) domain profile.', NULL, 'ALPHAVIRUS_MT', NULL, NULL, 1531, 15),
(281948, NULL, 'PS51909', NULL, NULL, 'Invertebrate (I)-type lysozyme domain profile.', NULL, 'LYSOZYME_I', NULL, NULL, 14087, 15),
(281949, NULL, 'PS51723', NULL, NULL, 'Peptidase family M60 domain profile.', NULL, 'PEPTIDASE_M60', NULL, NULL, 25137, 15),
(281950, NULL, 'PS51839', NULL, NULL, 'His(Cys)3-ligated-type [4Fe-4S] domain profile.', NULL, '4FE4S_HC3', NULL, NULL, 20170, 15),
(281951, NULL, 'PS50118', NULL, NULL, 'HMG boxes A and B DNA-binding domains profile.', NULL, 'HMG_BOX_2', NULL, NULL, 6233, 15),
(281952, NULL, 'PS50914', NULL, NULL, 'BON domain profile.', NULL, 'BON', NULL, NULL, 6630, 15),
(281953, NULL, 'PS51466', NULL, NULL, 'PINIT domain profile.', NULL, 'PINIT', NULL, NULL, 18421, 15);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(281954, NULL, 'PS51420', NULL, NULL, 'small GTPase Rho family profile.', NULL, 'RHO', NULL, NULL, NULL, 15),
(281955, NULL, 'PS51340', NULL, NULL, 'MOSC domain profile.', NULL, 'MOSC', NULL, NULL, 5411, 15),
(281956, NULL, 'PS50830', NULL, NULL, 'Thermonuclease domain profile.', NULL, 'TNASE_3', NULL, NULL, 10321, 15),
(281957, NULL, 'PS51486', NULL, NULL, 'REKLES domain profile.', NULL, 'REKLES', NULL, NULL, 15578, 15),
(281958, NULL, 'PS51298', NULL, NULL, 'Zinc import ATP-binding protein znuC family profile.', NULL, 'ZNUC', NULL, NULL, NULL, 15),
(281959, NULL, 'PS51548', NULL, NULL, 'Birnavirus VP4 protease domain profile.', NULL, 'BIRNAVIRUS_VP4_PRO', NULL, NULL, 22476, 15),
(281960, NULL, 'PS51381', NULL, NULL, 'C2 B9-type domain profile.', NULL, 'C2_B9', NULL, NULL, 10891, 15),
(281961, NULL, 'PS51457', NULL, NULL, 'BEN domain profile.', NULL, 'BEN', NULL, NULL, 20443, 15),
(281962, NULL, 'PS51514', NULL, NULL, 'BRX domain profile.', NULL, 'BRX', NULL, NULL, 11946, 15),
(281963, NULL, 'PS51155', NULL, NULL, 'Chitin-binding type R&R domain profile.', NULL, 'CHIT_BIND_RR_2', NULL, NULL, 5789, 15),
(281964, NULL, 'PS50043', NULL, NULL, 'LuxR-type HTH domain profile.', NULL, 'HTH_LUXR_2', NULL, NULL, 6599, 15),
(281965, NULL, 'PS51933', NULL, NULL, 'EutK-Ctail domain profile.', NULL, 'EUTK_C', NULL, NULL, 23982, 15),
(281966, NULL, 'PS51389', NULL, NULL, 'Xin repeat profile.', NULL, 'XIN', NULL, NULL, 12629, 15),
(281967, NULL, 'PS51162', NULL, NULL, 'Thyroglobulin type-1 domain profile.', NULL, 'THYROGLOBULIN_1_2', NULL, NULL, 6911, 15),
(281968, NULL, 'PS50227', NULL, NULL, 'G-protein coupled receptors family 2 profile 1.', NULL, 'G_PROTEIN_RECEP_F2_3', NULL, NULL, 4113, 15),
(281969, NULL, 'PS01180', NULL, NULL, 'CUB domain profile.', NULL, 'CUB', NULL, NULL, 3339, 15),
(281970, NULL, 'PS51431', NULL, NULL, 'KaiA C-terminal domain profile.', NULL, 'KAIA_C', NULL, NULL, 21402, 15),
(281971, NULL, 'PS50256', NULL, NULL, 'Yeast PIR proteins repeats profile.', NULL, 'PIR_REPEAT_2', NULL, NULL, 4442, 15),
(281972, NULL, 'PS51081', NULL, NULL, 'Zinc finger SIAH-type profile.', NULL, 'ZF_SIAH', NULL, NULL, 18565, 15),
(281973, NULL, 'PS51121', NULL, NULL, 'NtA (N-terminal agrin) domain profile.', NULL, 'NTA', NULL, NULL, 7142, 15),
(281974, NULL, 'PS50846', NULL, NULL, 'Heavy-metal-associated domain profile.', NULL, 'HMA_2', NULL, NULL, 10473, 15),
(281975, NULL, 'PS51847', NULL, NULL, 'Synaptotagmin-like mitochondrial lipid-binding proteins (SMP) domain profile.', NULL, 'SMP', NULL, NULL, 26675, 15),
(281976, NULL, 'PS50986', NULL, NULL, 'MANSC domain profile.', NULL, 'MANSC', NULL, NULL, 9225, 15),
(281977, NULL, 'PS51885', NULL, NULL, 'Neprilysin-like (M13) protease domain profile.', NULL, 'NEPRILYSIN', NULL, NULL, 3756, 15),
(281978, NULL, 'PS50935', NULL, NULL, 'Single-strand binding (SSB) domain profile.', NULL, 'SSB', NULL, NULL, 6581, 15),
(281979, NULL, 'PS51175', NULL, NULL, 'CBM6 (carbohydrate binding type-6) domain profile.', NULL, 'CBM6', NULL, NULL, 10191, 15),
(281980, NULL, 'PS50033', NULL, NULL, 'UBX domain profile.', NULL, 'UBX', NULL, NULL, 2131, 15),
(281981, NULL, 'PS51437', NULL, NULL, 'CG-1 DNA-binding domain profile.', NULL, 'CG_1', NULL, NULL, 1663, 15),
(281982, NULL, 'PS51860', NULL, NULL, 'REM-1 domain profile.', NULL, 'REM_1', NULL, NULL, 10484, 15),
(281983, NULL, 'PS51821', NULL, NULL, 'Velvet domain profile.', NULL, 'VELVET', NULL, NULL, 27074, 15),
(281984, NULL, 'PS51057', NULL, NULL, 'Paired DNA-binding domain profile.', NULL, 'PAIRED_2', NULL, NULL, 5743, 15),
(281985, NULL, 'PS50908', NULL, NULL, 'RWD domain profile.', NULL, 'RWD', NULL, NULL, 268, 15),
(281986, NULL, 'PS51414', NULL, NULL, 'HSR domain profile.', NULL, 'HSR', NULL, NULL, 7361, 15),
(281987, NULL, 'PS50119', NULL, NULL, 'Zinc finger B-box type profile.', NULL, 'ZF_BBOX', NULL, NULL, 595, 15),
(281988, NULL, 'PS50145', NULL, NULL, 'Zinc finger TRAF-type profile.', NULL, 'ZF_TRAF', NULL, NULL, 5428, 15),
(281989, NULL, 'PS50177', NULL, NULL, 'Nuclear transport factor 2 domain profile.', NULL, 'NTF2_DOMAIN', NULL, NULL, 7597, 15);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(281990, NULL, 'PS51783', NULL, NULL, 'BEACH-type PH domain profile.', NULL, 'PH_BEACH', NULL, NULL, 19422, 15),
(281991, NULL, 'PS51168', NULL, NULL, 'Chorismate mutase domain profile.', NULL, 'CHORISMATE_MUT_2', NULL, NULL, 3840, 15),
(281992, NULL, 'PS51680', NULL, NULL, 'SAM-dependent methyltransferase DRM-type domain profile.', NULL, 'SAM_MT_DRM', NULL, NULL, 25462, 15),
(281993, NULL, 'PS51958', NULL, NULL, 'Nidoviral uridylate-specific endoribonuclease (NendoU) domain profile.', NULL, 'NENDOU', NULL, NULL, 35411, 15),
(281994, NULL, 'PS51301', NULL, NULL, 'KilA-N domain profile.', NULL, 'KILA_N', NULL, NULL, 18261, 15),
(281995, NULL, 'PS51025', NULL, NULL, 'PWI domain profile.', NULL, 'PWI', NULL, NULL, 868, 15),
(281996, NULL, 'PS51623', NULL, NULL, 'tRNA guanosine-2''-O-methyltransferase (EC 2.1.1.34) family profile.', NULL, 'SAM_MT_TRMH_1', NULL, NULL, 23739, 15),
(281997, NULL, 'PS51968', NULL, NULL, 'Grh/CP2 DNA-binding (DB) domain profile.', NULL, 'GRH_CP2_DB', NULL, NULL, 2678, 15),
(281998, NULL, 'PS51382', NULL, NULL, 'SPX domain profile.', NULL, 'SPX', NULL, NULL, 4683, 15),
(281999, NULL, 'PS51851', NULL, NULL, 'KARI C-terminal domain profile.', NULL, 'KARI_C', NULL, NULL, 5659, 15),
(282000, NULL, 'PS50828', NULL, NULL, 'Smr domain profile.', NULL, 'SMR', NULL, NULL, 2517, 15),
(282001, NULL, 'PS51650', NULL, NULL, 'C2 DOCK-type domain profile.', NULL, 'C2_DOCK', NULL, NULL, 23833, 15),
(282002, NULL, 'PS50903', NULL, NULL, 'Rubredoxin-like domain profile.', NULL, 'RUBREDOXIN_LIKE', NULL, NULL, 14936, 15),
(282003, NULL, 'PS50955', NULL, NULL, 'LEM-like domain profile.', NULL, 'LEM_LIKE', NULL, NULL, 5232, 15),
(282004, NULL, 'PS51422', NULL, NULL, 'small GTPase SAR1 family profile.', NULL, 'SAR1', NULL, NULL, NULL, 15),
(282005, NULL, 'PS51565', NULL, NULL, 'SETD3 actin-histidine N-methyltransferase (EC 2.1.1.85) family profile.', NULL, 'SAM_MT85_SETD3', NULL, NULL, 24449, 15),
(282006, NULL, 'PS51829', NULL, NULL, 'P/Homo B domain profile.', NULL, 'P_HOMO_B', NULL, NULL, 5511, 15),
(282007, NULL, 'PS51591', NULL, NULL, 'mRNA cap 0 and cap 1 methyltransferase (EC 2.1.1.56 and EC 2.1.1.57) domain profile.', NULL, 'RNA_CAP01_NS5_MT', NULL, NULL, 25117, 15),
(282008, NULL, 'PS51695', NULL, NULL, 'Sedolisin domain profile.', NULL, 'SEDOLISIN', NULL, NULL, 25139, 15),
(282009, NULL, 'PS50221', NULL, NULL, 'GPS domain profile.', NULL, 'GPS', NULL, NULL, 3639, 15),
(282010, NULL, 'PS50820', NULL, NULL, 'LCCL domain profile.', NULL, 'LCCL', NULL, NULL, 965, 15),
(282011, NULL, 'PS51691', NULL, NULL, 'Peptidase family S6 domain profile.', NULL, 'PEPTIDASE_S6', NULL, NULL, 25452, 15),
(282012, NULL, 'PS51516', NULL, NULL, 'Sox C-terminal domain profile.', NULL, 'SOX_C', NULL, NULL, 19662, 15),
(282013, NULL, 'PS51906', NULL, NULL, 'Zinc finger UBZ2-type profile.', NULL, 'ZF_UBZ2', NULL, NULL, 25116, 15),
(282014, NULL, 'PS50826', NULL, NULL, 'RUN domain profile.', NULL, 'RUN', NULL, NULL, 548, 15),
(282015, NULL, 'PS51390', NULL, NULL, 'WAP-type ''four-disulfide core'' domain profile.', NULL, 'WAP', NULL, NULL, 7006, 15),
(282016, NULL, 'PS50969', NULL, NULL, 'FCP1 homology domain profile.', NULL, 'FCP1', NULL, NULL, 4145, 15),
(282017, NULL, 'PS51073', NULL, NULL, 'RPEL repeat profile.', NULL, 'RPEL', NULL, NULL, 763, 15),
(282018, NULL, 'PS51550', NULL, NULL, 'Eph receptor ligand-binding domain profile.', NULL, 'EPH_LBD', NULL, NULL, 1425, 15),
(282019, NULL, 'PS50134', NULL, NULL, 'Zinc finger TAZ-type profile.', NULL, 'ZF_TAZ', NULL, NULL, 3995, 15),
(282020, NULL, 'PS51555', NULL, NULL, 'Methionine S-methyltransferase (EC 2.1.1.12) family profile.', NULL, 'SAM_MT12', NULL, NULL, 23012, 15),
(282021, NULL, 'PS51936', NULL, NULL, 'POU-specific (POUs) atypical domain profile.', NULL, 'POU_4', NULL, NULL, 36014, 15),
(282022, NULL, 'PS51988', NULL, NULL, 'Herpesviridae UL32 packaging protein family profile.', NULL, 'HERPESVIRUS_UL32', NULL, NULL, 1639, 15),
(282023, NULL, 'PS51214', NULL, NULL, 'IBB domain profile.', NULL, 'IBB', NULL, NULL, 2791, 15),
(282024, NULL, 'PS51285', NULL, NULL, 'AGC-kinase C-terminal domain profile.', NULL, 'AGC_KINASE_CTER', NULL, NULL, 3446, 15);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(282025, NULL, 'PS51784', NULL, NULL, 'Exonuclease I (ExoI) SH3-like domain profile.', NULL, 'EXOI_SH3', NULL, NULL, 30738, 15),
(282026, NULL, 'PS01178', NULL, NULL, 'Anaphylatoxin domain profile.', NULL, 'ANAPHYLATOXIN_2', NULL, NULL, 2547, 15),
(282027, NULL, 'PS50056', NULL, NULL, 'Tyrosine specific protein phosphatases domain profile.', NULL, 'TYR_PHOSPHATASE_2', NULL, NULL, 4796, 15),
(282028, NULL, 'PS51846', NULL, NULL, 'CNNM transmembrane domain profile.', NULL, 'CNNM', NULL, NULL, 1706, 15),
(282029, NULL, 'PS51871', NULL, NULL, 'Potyviridae P1 protease domain profile.', NULL, 'PV_P1_PRO', NULL, NULL, 1873, 15),
(282030, NULL, 'PS50032', NULL, NULL, 'Kinase associated domain 1 (KA1) profile.', NULL, 'KA1', NULL, NULL, 3326, 15),
(282031, NULL, 'PS51227', NULL, NULL, 'Sprouty (SPR) domain profile.', NULL, 'SPR', NULL, NULL, 3158, 15),
(282032, NULL, 'PS50258', NULL, NULL, 'LNR (Lin-12/Notch) repeat profile.', NULL, 'LNR', NULL, NULL, 6841, 15),
(282033, NULL, 'PS51419', NULL, NULL, 'small GTPase Rab1 family profile.', NULL, 'RAB', NULL, NULL, NULL, 15),
(282034, NULL, 'PS51399', NULL, NULL, 'SEP domain profile.', NULL, 'SEP', NULL, NULL, 12278, 15),
(282035, NULL, 'PS51076', NULL, NULL, 'MAD homology domain 2 (MH2) profile.', NULL, 'MH2', NULL, NULL, 1602, 15),
(282036, NULL, 'PS50212', NULL, NULL, 'Ras guanine-nucleotide exchange factors N-terminal domain profile.', NULL, 'RASGEF_NTER', NULL, NULL, 6675, 15),
(282037, NULL, 'PS50880', NULL, NULL, 'Toprim domain profile.', NULL, 'TOPRIM', NULL, NULL, 11269, 15),
(282038, NULL, 'PS51811', NULL, NULL, 'Zinc finger CCHC HIVEP-type profile.', NULL, 'ZF_CCHC_HIVEP', NULL, NULL, 29074, 15),
(282039, NULL, 'PS51396', NULL, NULL, 'PUL domain profile.', NULL, 'PUL', NULL, NULL, 12762, 15),
(282040, NULL, 'PS51612', NULL, NULL, 'Poxvirus/kinetoplastid-type ribose 2''-O-methyltransferase (EC 2.1.1.57) family profile.', NULL, 'SAM_MT_2O_PK', NULL, NULL, 23314, 15),
(282041, NULL, 'PS51622', NULL, NULL, 'tRNA (uracil-5-)-methyltransferase (EC 2.1.1.35) family profile.', NULL, 'SAM_MT_RNA_M5U_2', NULL, NULL, 23461, 15),
(282042, NULL, 'PS51863', NULL, NULL, 'LCN-type cysteine-stabilized alpha/beta (CS-alpha/beta) domain profile.', NULL, 'LCN_CSAB', NULL, NULL, 35767, 15),
(282043, NULL, 'PS50110', NULL, NULL, 'Response regulatory domain profile.', NULL, 'RESPONSE_REGULATORY', NULL, NULL, 3274, 15),
(282044, NULL, 'PS51963', NULL, NULL, 'Betacoronavirus (BetaCoV) Nsp1 C-terminal domain profile.', NULL, 'BCOV_NSP1_C', NULL, NULL, 33888, 15),
(282045, NULL, 'PS50884', NULL, NULL, 'Zinc finger Dof-type profile.', NULL, 'ZF_DOF_2', NULL, NULL, 3304, 15),
(282046, NULL, 'PS51773', NULL, NULL, 'Orange carotenoid protein (OCP) N-terminal domain profile.', NULL, 'OCP_N', NULL, NULL, 10836, 15),
(282047, NULL, 'PS51019', NULL, NULL, 'Reelin domain profile.', NULL, 'REELIN', NULL, NULL, 5561, 15),
(282048, NULL, 'PS50253', NULL, NULL, 'Heme-copper oxidase subunit III family profile.', NULL, 'COX3', NULL, NULL, 642, 15),
(282049, NULL, 'PS50827', NULL, NULL, 'DDT domain profile.', NULL, 'DDT', NULL, NULL, 14516, 15),
(282050, NULL, 'PS51174', NULL, NULL, 'Barwin domain profile.', NULL, 'BARWIN_3', NULL, NULL, 1276, 15),
(282051, NULL, 'PS50199', NULL, NULL, 'Zinc finger RanBP2 type profile.', NULL, 'ZF_RANBP2_2', NULL, NULL, 5410, 15),
(282052, NULL, 'PS51482', NULL, NULL, 'DegV domain profile.', NULL, 'DEGV', NULL, NULL, 6042, 15),
(282053, NULL, 'PS50215', NULL, NULL, 'ADAM type metalloprotease domain profile.', NULL, 'ADAM_MEPRO', NULL, NULL, 5126, 15),
(282054, NULL, 'PS51256', NULL, NULL, 'GS domain profile.', NULL, 'GS', NULL, NULL, 496, 15),
(282055, NULL, 'PS51415', NULL, NULL, 'Xylose isomerase family profile.', NULL, 'XYLOSE_ISOMERASE', NULL, NULL, 2374, 15),
(282056, NULL, 'PS50151', NULL, NULL, 'UVR domain profile.', NULL, 'UVR', NULL, NULL, 2493, 15),
(282057, NULL, 'PS51919', NULL, NULL, 'X4e domain profile.', NULL, 'X4E', NULL, NULL, 36495, 15),
(282058, NULL, 'PS51101', NULL, NULL, 'PTS_EIIB type-4 domain profile.', NULL, 'PTS_EIIB_TYPE_4', NULL, NULL, 3329, 15);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(282059, NULL, 'PS51830', NULL, NULL, 'FIIND domain profile.', NULL, 'FIIND', NULL, NULL, 25721, 15),
(282060, NULL, 'PS51969', NULL, NULL, 'CBM39 (carbohydrate binding type-39) domain profile.', NULL, 'CBM39', NULL, NULL, 25827, 15),
(282061, NULL, 'PS51172', NULL, NULL, 'CBM3 (carbohydrate binding type-3) domain profile.', NULL, 'CBM3', NULL, NULL, 4062, 15),
(282062, NULL, 'PS51410', NULL, NULL, 'Biopterin-dependent aromatic amino acid hydroxylase family profile.', NULL, 'BH4_AAA_HYDROXYL_2', NULL, NULL, 17063, 15),
(282063, NULL, 'PS51621', NULL, NULL, 'tRNA (uracil-5-)-methyltransferase (EC 2.1.1.35) family profile.', NULL, 'SAM_MT_RNA_M5U_1', NULL, NULL, 24082, 15),
(282064, NULL, 'PS50853', NULL, NULL, 'Fibronectin type-III domain profile.', NULL, 'FN3', NULL, NULL, 7389, 15),
(282065, NULL, 'PS51035', NULL, NULL, 'BAG domain profile.', NULL, 'BAG', NULL, NULL, 1471, 15),
(282066, NULL, 'PS51146', NULL, NULL, 'KaiC domain profile.', NULL, 'KAIC', NULL, NULL, 9408, 15),
(282067, NULL, 'PS51236', NULL, NULL, 'Thrombospondin C-terminal domain profile.', NULL, 'TSP_CTER', NULL, NULL, 13778, 15),
(282068, NULL, 'PS51232', NULL, NULL, 'Rho GTPase-binding/formin homology 3 (GBD/FH3) domain profile.', NULL, 'GBD_FH3', NULL, NULL, 11533, 15),
(282069, NULL, 'PS50888', NULL, NULL, 'Myc-type, basic helix-loop-helix (bHLH) domain profile.', NULL, 'BHLH', NULL, NULL, 8133, 15),
(282070, NULL, 'PS50011', NULL, NULL, 'Protein kinase domain profile.', NULL, 'PROTEIN_KINASE_DOM', NULL, NULL, 3595, 15),
(282071, NULL, 'PS51246', NULL, NULL, 'Cobalt import ATP-binding protein cbiO.', NULL, 'CBIO', NULL, NULL, NULL, 15),
(282072, NULL, 'PS51489', NULL, NULL, 'BUB1 N-terminal domain profile.', NULL, 'BUB1_N', NULL, NULL, 17779, 15),
(282073, NULL, 'PS50015', NULL, NULL, 'Saposin B type domain profile.', NULL, 'SAP_B', NULL, NULL, 7097, 15),
(282074, NULL, 'PS50106', NULL, NULL, 'PDZ domain profile.', NULL, 'PDZ', NULL, NULL, 3119, 15),
(282075, NULL, 'PS51831', NULL, NULL, 'HD domain profile.', NULL, 'HD', NULL, NULL, 1789, 15),
(282076, NULL, 'PS50093', NULL, NULL, 'Polycystic kidney disease (PKD) domain profile.', NULL, 'PKD', NULL, NULL, 5730, 15),
(282077, NULL, 'PS51683', NULL, NULL, 'SAM-dependent O-methyltransferase class II-type profile.', NULL, 'SAM_OMT_II', NULL, NULL, 15440, 15),
(282078, NULL, 'PS51791', NULL, NULL, 'hSac2 domain profile.', NULL, 'HSAC2', NULL, NULL, 8895, 15),
(282079, NULL, 'PS51436', NULL, NULL, 'Potyvirus NIa protease (NIa-pro) domain profile.', NULL, 'POTYVIRUS_NIA_PRO', NULL, NULL, 3075, 15),
(282080, NULL, 'PS51835', NULL, NULL, 'Tripartite DENN C9ORF72-type domain profile.', NULL, 'DENN_C9ORF72', NULL, NULL, 22343, 15),
(282081, NULL, 'PS50311', NULL, NULL, 'Cysteine-rich region profile.', NULL, 'CYS_RICH', NULL, NULL, NULL, 15),
(282082, NULL, 'PS51446', NULL, NULL, 'Pacifastin domain profile.', NULL, 'PACIFASTIN', NULL, NULL, 5135, 15),
(282083, NULL, 'PS51742', NULL, NULL, 'PPC domain profile profile.', NULL, 'PPC', NULL, NULL, 5145, 15),
(282084, NULL, 'PS51569', NULL, NULL, 'Histone-lysine N-methyltransferase DOT1 (EC 2.1.1.43) domain profile.', NULL, 'DOT1', NULL, NULL, 22662, 15),
(282085, NULL, 'PS51158', NULL, NULL, 'Alpha-type protein kinase domain profile.', NULL, 'ALPHA_KINASE', NULL, NULL, 2823, 15),
(282086, NULL, 'PS51196', NULL, NULL, 'SecA family profile.', NULL, 'SECA_MOTOR_DEAD', NULL, NULL, 9137, 15),
(282087, NULL, 'PS51434', NULL, NULL, 'NUP C-terminal domain profile.', NULL, 'NUP_C', NULL, NULL, 6903, 15),
(282088, NULL, 'PS51720', NULL, NULL, 'AIG1-type G domain profile.', NULL, 'G_AIG1', NULL, NULL, 2215, 15),
(282089, NULL, 'PS51733', NULL, NULL, 'Biotinyl protein ligase (BPL) and lipoyl protein ligase (LPL) catalytic domain profile.', NULL, 'BPL_LPL_CATALYTIC', NULL, NULL, 2571, 15),
(282090, NULL, 'PS51038', NULL, NULL, 'BAH domain profile.', NULL, 'BAH', NULL, NULL, 1219, 15),
(282091, NULL, 'PS51905', NULL, NULL, 'Zinc finger UBZ1-type profile.', NULL, 'ZF_UBZ1', NULL, NULL, 30161, 15),
(282092, NULL, 'PS51311', NULL, NULL, 'Secretoglobin (SCGB) family profile.', NULL, 'SCGB', NULL, NULL, 11477, 15);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(282093, NULL, 'PS51826', NULL, NULL, 'Peripheral subunit-binding (PSBD) domain profile.', NULL, 'PSBD', NULL, NULL, 2758, 15),
(282094, NULL, 'PS50171', NULL, NULL, 'Zinc finger matrin-type profile.', NULL, 'ZF_MATRIN', NULL, NULL, 6845, 15),
(282095, NULL, 'PS51864', NULL, NULL, 'Astacin-like domain profile.', NULL, 'ASTACIN', NULL, NULL, 4051, 15),
(282096, NULL, 'PS50046', NULL, NULL, 'Phytochrome chromophore attachment site domain profile.', NULL, 'PHYTOCHROME_2', NULL, NULL, 11168, 15),
(282097, NULL, 'PS51503', NULL, NULL, 'HIG1 domain profile.', NULL, 'HIG1', NULL, NULL, 292, 15),
(282098, NULL, 'PS50294', NULL, NULL, 'Trp-Asp (WD) repeats circular profile.', NULL, 'WD_REPEATS_REGION', NULL, NULL, NULL, 15),
(282099, NULL, 'PS51197', NULL, NULL, 'Rrf2-type HTH domain profile.', NULL, 'HTH_RRF2_2', NULL, NULL, 304, 15),
(282100, NULL, 'PS51268', NULL, NULL, 'Arabinose import ATP-binding protein araG family profile.', NULL, 'ARAG', NULL, NULL, NULL, 15),
(282101, NULL, 'PS51085', NULL, NULL, '2Fe-2S ferredoxin-type iron-sulfur binding domain profile.', NULL, '2FE2S_FER_2', NULL, NULL, 2014, 15),
(282102, NULL, 'PS51865', NULL, NULL, 'GRASP-type PDZ domain profile.', NULL, 'PDZ_GRASP', NULL, NULL, 23968, 15),
(282103, NULL, 'PS50856', NULL, NULL, 'AMOP domain profile.', NULL, 'AMOP', NULL, NULL, 1745, 15),
(282104, NULL, 'PS51854', NULL, NULL, 'CSPG repeat profile.', NULL, 'CSPG', NULL, NULL, 30896, 15),
(282105, NULL, 'PS51818', NULL, NULL, 'Homeo-Prospero domain profile.', NULL, 'HOMEO_PROSPERO', NULL, NULL, 15434, 15),
(282106, NULL, 'PS51093', NULL, NULL, 'PTS_EIIA type-1 domain profile.', NULL, 'PTS_EIIA_TYPE_1', NULL, NULL, 1944, 15),
(282107, NULL, 'PS50850', NULL, NULL, 'Major facilitator superfamily (MFS) profile.', NULL, 'MFS', NULL, NULL, 20655, 15),
(282108, NULL, 'PS51521', NULL, NULL, 'Herpesvirus tegument ubiquitin-specific protease (htUSP) domain profile.', NULL, 'HTUSP', NULL, NULL, 5006, 15),
(282109, NULL, 'PS51156', NULL, NULL, 'ELM2 domain profile.', NULL, 'ELM2', NULL, NULL, 3106, 15),
(282110, NULL, 'PS51375', NULL, NULL, 'Pentatricopeptide (PPR) repeat profile.', NULL, 'PPR', NULL, NULL, 5826, 15),
(282111, NULL, 'PS51136', NULL, NULL, 'WAC domain profile.', NULL, 'WAC', NULL, NULL, 7632, 15),
(282112, NULL, 'PS51947', NULL, NULL, 'Nidovirus RdRp-associated nucleotidyl transferase (NiRAN) domain profile.', NULL, 'NIRAN', NULL, NULL, 35446, 15),
(282113, NULL, 'PS50137', NULL, NULL, 'Double stranded RNA-binding domain (dsRBD) profile.', NULL, 'DS_RBD', NULL, NULL, 12874, 15),
(282114, NULL, 'PS51207', NULL, NULL, 'PXA domain profile.', NULL, 'PXA', NULL, NULL, 2701, 15),
(282115, NULL, 'PS51177', NULL, NULL, 'Riboflavin synthase alpha chain lumazine-binding repeat profile.', NULL, 'LUMAZINE_BIND', NULL, NULL, 25254, 15),
(282116, NULL, 'PS51318', NULL, NULL, 'Twin arginine translocation (Tat) signal profile.', NULL, 'TAT', NULL, NULL, 4913, 15),
(282117, NULL, 'PS51271', NULL, NULL, 'WAPL domain profile.', NULL, 'WAPL', NULL, NULL, 12754, 15),
(282118, NULL, 'PS51071', NULL, NULL, 'RpiR-type HTH domain profile.', NULL, 'HTH_RPIR', NULL, NULL, 989, 15),
(282119, NULL, 'PS51875', NULL, NULL, 'Hypovirus-associated virus (HAV) papain-like protease p48 domain profile.', NULL, 'HAV_P48_PRO', NULL, NULL, 5491, 15),
(282120, NULL, 'PS51590', NULL, NULL, 'Mononegavirus L protein 2''-O-ribose methyltransferase domain profile.', NULL, 'SAM_MT_MNV_L', NULL, NULL, 22417, 15),
(282121, NULL, 'PS51480', NULL, NULL, 'DhaL domain profile.', NULL, 'DHAL', NULL, NULL, 979, 15),
(282122, NULL, 'PS51253', NULL, NULL, 'CENPB-type HTH domain profile.', NULL, 'HTH_CENPB', NULL, NULL, 1032, 15),
(282123, NULL, 'PS51782', NULL, NULL, 'LysM domain profile.', NULL, 'LYSM', NULL, NULL, 8452, 15),
(282124, NULL, 'PS51003', NULL, NULL, 'Cytochrome b/b6 C-terminal region profile.', NULL, 'CYTB_CTER', NULL, NULL, 5662, 15),
(282125, NULL, 'PS51755', NULL, NULL, 'OmpR/PhoB-type DNA-binding domain profile.', NULL, 'OMPR_PHOB', NULL, NULL, 4108, 15),
(282126, NULL, 'PS50898', NULL, NULL, 'Ras-binding domain (RBD) profile.', NULL, 'RBD', NULL, NULL, 2992, 15);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(282127, NULL, 'PS51170', NULL, NULL, 'Cell wall-binding repeat profile.', NULL, 'CW', NULL, NULL, 20480, 15),
(282128, NULL, 'PS51309', NULL, NULL, 'Poly(A)-binding protein C-terminal (PABC) domain profile.', NULL, 'PABC', NULL, NULL, 4619, 15),
(282129, NULL, 'PS50014', NULL, NULL, 'Bromodomain profile.', NULL, 'BROMODOMAIN_2', NULL, NULL, 5971, 15),
(282130, NULL, 'PS51931', NULL, NULL, 'Bacterial microcompartment (BMC) circularly permuted domain profile.', NULL, 'BMC_CP', NULL, NULL, 36175, 15),
(282131, NULL, 'PS51788', NULL, NULL, 'CULT domain profile.', NULL, 'CULT', NULL, NULL, 29624, 15),
(282132, NULL, 'PS50262', NULL, NULL, 'G-protein coupled receptors family 1 profile.', NULL, 'G_PROTEIN_RECEP_F1_2', NULL, NULL, 18558, 15),
(282133, NULL, 'PS50943', NULL, NULL, 'Cro/C1-type HTH domain profile.', NULL, 'HTH_CROC1', NULL, NULL, 2217, 15),
(282134, NULL, 'PS50861', NULL, NULL, 'Heterodimeric glycyl-transfer RNA synthetases family profile.', NULL, 'AA_TRNA_LIGASE_II_GLYAB', NULL, NULL, 11369, 15),
(282135, NULL, 'PS51341', NULL, NULL, 'Zinc finger large T-antigen (T-ag) D1-type profile.', NULL, 'ZF_LTAG_D1', NULL, NULL, 18067, 15),
(282136, NULL, 'PS51464', NULL, NULL, 'SIS domain profile.', NULL, 'SIS', NULL, NULL, 7474, 15),
(282137, NULL, 'PS51962', NULL, NULL, 'Coronavirus (CoV) Nsp1 globular domain profile.', NULL, 'COV_NSP1', NULL, NULL, 33577, 15),
(282138, NULL, 'PS51257', NULL, NULL, 'Prokaryotic membrane lipoprotein lipid attachment site profile.', NULL, 'PROKAR_LIPOPROTEIN', NULL, NULL, NULL, 15),
(282139, NULL, 'PS51702', NULL, NULL, 'Mu-type HTH domain profile.', NULL, 'HTH_MU', NULL, NULL, 4054, 15),
(282140, NULL, 'PS50229', NULL, NULL, 'WH1 domain profile.', NULL, 'WH1', NULL, NULL, 3602, 15),
(282141, NULL, 'PS51216', NULL, NULL, 'Nebulin repeat profile.', NULL, 'NEBULIN', NULL, NULL, 3188, 15),
(282142, NULL, 'PS50017', NULL, NULL, 'Death domain profile.', NULL, 'DEATH_DOMAIN', NULL, NULL, 5848, 15),
(282143, NULL, 'PS51703', NULL, NULL, 'DZF domain profile.', NULL, 'DZF', NULL, NULL, 472, 15),
(282144, NULL, 'PS51050', NULL, NULL, 'Zinc finger CW-type profile.', NULL, 'ZF_CW', NULL, NULL, 11360, 15),
(282145, NULL, 'PS51980', NULL, NULL, 'Occludin/ELL (OCEL) domain profile.', NULL, 'OCEL', NULL, NULL, 11958, 15),
(282146, NULL, 'PS50326', NULL, NULL, 'Valine-rich region profile.', NULL, 'VAL_RICH', NULL, NULL, NULL, 15),
(282147, NULL, 'PS51171', NULL, NULL, 'Prephenate dehydratase domain profile.', NULL, 'PREPHENATE_DEHYDR_3', NULL, NULL, 4478, 15),
(282148, NULL, 'PS51462', NULL, NULL, 'Nudix hydrolase domain profile.', NULL, 'NUDIX', NULL, NULL, 2732, 15),
(282149, NULL, 'PS51713', NULL, NULL, 'Era-type guanine nucleotide-binding (G) domain profile.', NULL, 'G_ERA', NULL, NULL, 26957, 15),
(282150, NULL, 'PS51119', NULL, NULL, 'TAFH/NHR1 domain profile.', NULL, 'TAFH', NULL, NULL, 4074, 15),
(282151, NULL, 'PS51149', NULL, NULL, 'Glycine radical domain profile.', NULL, 'GLY_RADICAL_2', NULL, NULL, 2122, 15),
(282152, NULL, 'PS50061', NULL, NULL, 'Ets-domain profile.', NULL, 'ETS_DOMAIN_3', NULL, NULL, 6517, 15),
(282153, NULL, 'PS50305', NULL, NULL, 'Sirtuin catalytic domain profile.', NULL, 'SIRTUIN', NULL, NULL, 23018, 15),
(282154, NULL, 'PS50103', NULL, NULL, 'Zinc finger C3H1-type profile.', NULL, 'ZF_C3H1', NULL, NULL, 5631, 15),
(282155, NULL, 'PS50188', NULL, NULL, 'B30.2/SPRY domain profile.', NULL, 'B302_SPRY', NULL, NULL, 4253, 15),
(282156, NULL, 'PS51494', NULL, NULL, 'SpoIVB peptidase domain profile.', NULL, 'SPOIVB', NULL, NULL, 12309, 15),
(282157, NULL, 'PS51892', NULL, NULL, 'Serine proteases, subtilase domain profile.', NULL, 'SUBTILASE', NULL, NULL, NULL, 15),
(282158, NULL, 'PS51099', NULL, NULL, 'PTS_EIIB type-2 domain profile.', NULL, 'PTS_EIIB_TYPE_2', NULL, NULL, 18961, 15),
(282159, NULL, 'PS50891', NULL, NULL, 'LOB domain profile.', NULL, 'LOB', NULL, NULL, 7247, 15),
(282160, NULL, 'PS50889', NULL, NULL, 'S4 RNA-binding domain profile.', NULL, 'S4', NULL, NULL, NULL, 15),
(282161, NULL, 'PS51266', NULL, NULL, 'Zinc finger CHY-type profile.', NULL, 'ZF_CHY', NULL, NULL, 7851, 15);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(282162, NULL, 'PS50531', NULL, NULL, 'IS21 transposase-type HTH domain profile.', NULL, 'HTH_IS21', NULL, NULL, 8045, 15),
(282163, NULL, 'PS50817', NULL, NULL, 'Intein N-terminal splicing motif profile.', NULL, 'INTEIN_N_TER', NULL, NULL, 10376, 15),
(282164, NULL, 'PS51409', NULL, NULL, 'Arginase family profile.', NULL, 'ARGINASE_2', NULL, NULL, 2546, 15),
(282165, NULL, 'PS51903', NULL, NULL, 'Clp repeat (R) domain profile.', NULL, 'CLP_R', NULL, NULL, 2648, 15),
(282166, NULL, 'PS51260', NULL, NULL, 'Galactose/methyl galactoside import ATP-binding protein mglA family profile.', NULL, 'MGLA', NULL, NULL, NULL, 15),
(282167, NULL, 'PS51681', NULL, NULL, 'SAM-dependent methyltransferase NNMT/PNMT/TEMT-type profile.', NULL, 'SAM_MT_NNMT_PNMT_TEMT', NULL, NULL, 3408, 15),
(282168, NULL, 'PS51699', NULL, NULL, 'DG-type SEA domain profile.', NULL, 'SEA_DG', NULL, NULL, 21630, 15),
(282169, NULL, 'PS50524', NULL, NULL, 'RdRp of Birnaviridae dsRNA viruses catalytic domain profile.', NULL, 'RDRP_DSRNA_BIR', NULL, NULL, NULL, 15),
(282170, NULL, 'PS51313', NULL, NULL, 'VPS28 N-terminal domain profile.', NULL, 'VPS28_N', NULL, NULL, 7721, 15),
(282171, NULL, 'PS50984', NULL, NULL, 'TRUD domain profile.', NULL, 'TRUD', NULL, NULL, 11536, 15),
(282172, NULL, 'PS51153', NULL, NULL, 'RPW8 domain profile.', NULL, 'RPW8', NULL, NULL, 13548, 15),
(282173, NULL, 'PS51131', NULL, NULL, 'Rad50 zinc-hook domain profile.', NULL, 'ZN_HOOK', NULL, NULL, 7970, 15),
(282174, NULL, 'PS51142', NULL, NULL, 'Nicotianamine synthase (NAS)-like family profile.', NULL, 'NAS', NULL, NULL, 4714, 15),
(282175, NULL, 'PS51506', NULL, NULL, 'Cbl-type phosphotyrosine-binding (Cbl-PTB) domain profile.', NULL, 'CBL_PTB', NULL, NULL, 9781, 15),
(282176, NULL, 'PS51549', NULL, NULL, 'DM13 domain profile.', NULL, 'DM13', NULL, NULL, 19302, 15),
(282177, NULL, 'PS50278', NULL, NULL, 'Platelet-derived growth factor (PDGF) family profile.', NULL, 'PDGF_2', NULL, NULL, 2821, 15),
(282178, NULL, 'PS51270', NULL, NULL, 'Zinc finger CTCHY-type profile.', NULL, 'ZF_CTCHY', NULL, NULL, 2565, 15),
(282179, NULL, 'PS51597', NULL, NULL, 'Histamine N-methyltransferase (EC 2.1.1.8) family profile.', NULL, 'SAM_HNMT', NULL, NULL, 20430, 15),
(282180, NULL, 'PS50805', NULL, NULL, 'Krueppel-associated box (KRAB) profile.', NULL, 'KRAB', NULL, NULL, 4346, 15),
(282181, NULL, 'PS50809', NULL, NULL, 'DM DNA-binding domain profile.', NULL, 'DM_2', NULL, NULL, 100, 15),
(282182, NULL, 'PS51392', NULL, NULL, 'KEN domain profile.', NULL, 'KEN', NULL, NULL, 10446, 15),
(282183, NULL, 'PS50180', NULL, NULL, 'Gamma-adaptin ear (GAE) domain profile.', NULL, 'GAE', NULL, NULL, 7370, 15),
(282184, NULL, 'PS50189', NULL, NULL, 'NTR domain profile.', NULL, 'NTR', NULL, NULL, 1529, 15),
(282185, NULL, 'PS51039', NULL, NULL, 'Zinc finger AN1-type profile.', NULL, 'ZF_AN1', NULL, NULL, 3586, 15),
(282186, NULL, 'PS50203', NULL, NULL, 'Cysteine proteinase, calpain-type, catalytic domain profile.', NULL, 'CALPAIN_CAT', NULL, NULL, 2051, 15),
(282187, NULL, 'PS51055', NULL, NULL, 'ITAM motif mammalian type profile.', NULL, 'ITAM_1', NULL, NULL, 1495, 15),
(282188, NULL, 'PS51262', NULL, NULL, 'COS domain profile.', NULL, 'COS', NULL, NULL, 8138, 15),
(282189, NULL, 'PS51278', NULL, NULL, 'Glutamine amidotransferase type 2 domain profile.', NULL, 'GATASE_TYPE_2', NULL, NULL, 18854, 15),
(282190, NULL, 'PS50186', NULL, NULL, 'DEP domain profile.', NULL, 'DEP', NULL, NULL, 5781, 15),
(282191, NULL, 'PS51511', NULL, NULL, 'FIP-RBD domain profile.', NULL, 'FIP_RBD', NULL, NULL, 15982, 15),
(282192, NULL, 'PS51889', NULL, NULL, 'Rubella virus (RUBV) nonstructural (NS) protease domain profile.', NULL, 'RUBV_NS_PRO', NULL, NULL, 35928, 15),
(282193, NULL, 'PS51448', NULL, NULL, 'P-type ''Trefoil'' domain profile.', NULL, 'P_TREFOIL_2', NULL, NULL, 5964, 15),
(282194, NULL, 'PS50144', NULL, NULL, 'MATH/TRAF domain profile.', NULL, 'MATH', NULL, NULL, 1424, 15),
(282195, NULL, 'PS50816', NULL, NULL, 'NAF domain profile.', NULL, 'NAF', NULL, NULL, 17121, 15),
(282196, NULL, 'PS50216', NULL, NULL, 'DHHC domain profile.', NULL, 'DHHC', NULL, NULL, NULL, 15);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(282197, NULL, 'PS50990', NULL, NULL, 'Peptidase family C39 domain profile.', NULL, 'PEPTIDASE_C39', NULL, NULL, 10424, 15),
(282198, NULL, 'PS51517', NULL, NULL, 'NDT80 DNA-binding domain profile.', NULL, 'NDT80', NULL, NULL, 12127, 15),
(282199, NULL, 'PS51487', NULL, NULL, 'NBD domain profile.', NULL, 'NBD', NULL, NULL, 15563, 15),
(282200, NULL, 'PS51447', NULL, NULL, 'Ferredoxin-fold anticodon binding (FDX-ACB) domain profile.', NULL, 'FDX_ACB', NULL, NULL, 7470, 15),
(282201, NULL, 'PS51016', NULL, NULL, 'MyTH4 domain profile.', NULL, 'MYTH4', NULL, NULL, 4768, 15),
(282202, NULL, 'PS50847', NULL, NULL, 'Gram-positive cocci surface proteins LPxTG motif profile.', NULL, 'GRAM_POS_ANCHORING', NULL, NULL, 18280, 15),
(282203, NULL, 'PS51421', NULL, NULL, 'small GTPase Ras family profile.', NULL, 'RAS', NULL, NULL, 4843, 15),
(282204, NULL, 'PS51206', NULL, NULL, 'Superfamily 3 helicase of DNA viruses domain profile.', NULL, 'SF3_HELICASE_1', NULL, NULL, 9453, 15),
(282205, NULL, 'PS51291', NULL, NULL, 'Aliphatic sulfonate import ATP-binding protein ssuB family profile.', NULL, 'SSUB', NULL, NULL, NULL, 15),
(282206, NULL, 'PS51752', NULL, NULL, 'Jacalin-type lectin domain profile.', NULL, 'JACALIN_LECTIN', NULL, NULL, 945, 15),
(282207, NULL, 'PS51476', NULL, NULL, 'Proteasome beta-type subunit profile.', NULL, 'PROTEASOME_BETA_2', NULL, NULL, 15644, 15),
(282208, NULL, 'PS51949', NULL, NULL, 'Coronavirus RNA-dependent RNA polymerase (RdRp) Nsp7 cofactor domain profile.', NULL, 'COV_NSP7', NULL, NULL, 11943, 15),
(282209, NULL, 'PS50871', NULL, NULL, 'C1q domain profile.', NULL, 'C1Q', NULL, NULL, 2032, 15),
(282210, NULL, 'PS51218', NULL, NULL, 'Superfamily 3 helicase of positive ssRNA viruses domain profile.', NULL, 'SF3_HELICASE_2', NULL, NULL, 9841, 15),
(282211, NULL, 'PS51640', NULL, NULL, 'MRG domain profile.', NULL, 'MRG', NULL, NULL, 24527, 15),
(282212, NULL, 'PS50010', NULL, NULL, 'Dbl homology (DH) domain profile.', NULL, 'DH_2', NULL, NULL, 3790, 15),
(282213, NULL, 'PS51201', NULL, NULL, 'RCK N-terminal domain profile.', NULL, 'RCK_N', NULL, NULL, 1978, 15),
(282214, NULL, 'PS50839', NULL, NULL, 'CHASE domain profile.', NULL, 'CHASE', NULL, NULL, 11026, 15),
(282215, NULL, 'PS51339', NULL, NULL, 'Myotubularin phosphatase domain.', NULL, 'PPASE_MYOTUBULARIN', NULL, NULL, 8413, 15),
(282216, NULL, 'PS51544', NULL, NULL, 'Phosphatidylinositol 3-kinase adaptor-binding (PI3K ABD) domain profile.', NULL, 'PI3K_ABD', NULL, NULL, 1552, 15),
(282217, NULL, 'PS51805', NULL, NULL, 'Extended PHD (ePHD) domain profile.', NULL, 'EPHD', NULL, NULL, 29066, 15),
(282218, NULL, 'PS51770', NULL, NULL, 'Hotdog acyl-CoA thioesterase (ACOT)-type domain profile.', NULL, 'HOTDOG_ACOT', NULL, NULL, 30828, 15),
(282219, NULL, 'PS50975', NULL, NULL, 'ATP-grasp fold profile.', NULL, 'ATP_GRASP', NULL, NULL, 11761, 15),
(282220, NULL, 'PS51042', NULL, NULL, 'CUT domain profile.', NULL, 'CUT', NULL, NULL, 4498, 15),
(282221, NULL, 'PS51095', NULL, NULL, 'PTS_EIIA type-3 domain profile.', NULL, 'PTS_EIIA_TYPE_3', NULL, NULL, 3212, 15),
(282222, NULL, 'PS51331', NULL, NULL, 'Flavin-dependent thymidylate synthase (thyX) domain profile.', NULL, 'THYX', NULL, NULL, 1196, 15),
(282223, NULL, 'PS51072', NULL, NULL, 'Mu homology domain (MHD) profile.', NULL, 'MHD', NULL, NULL, 26369, 15),
(282224, NULL, 'PS51141', NULL, NULL, 'Zinc finger SBP-type profile.', NULL, 'ZF_SBP', NULL, NULL, 4825, 15),
(282225, NULL, 'PS50021', NULL, NULL, 'Calponin homology (CH) domain profile.', NULL, 'CH', NULL, NULL, 3399, 15),
(282226, NULL, 'PS50122', NULL, NULL, 'CheB-type methylesterase domain profile.', NULL, 'CHEB', NULL, NULL, 3971, 15),
(282227, NULL, 'PS50857', NULL, NULL, 'Cytochrome oxidase subunit II copper A binding domain profile.', NULL, 'COX2_CUA', NULL, NULL, 6856, 15),
(282228, NULL, 'PS51194', NULL, NULL, 'Superfamilies 1 and 2 helicase C-terminal domain profile.', NULL, 'HELICASE_CTER', NULL, NULL, 3282, 15),
(282229, NULL, 'PS51365', NULL, NULL, 'Renal dipeptidase family profile.', NULL, 'RENAL_DIPEPTIDASE_2', NULL, NULL, 8620, 15);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(282230, NULL, 'PS51418', NULL, NULL, 'small GTPase Ran family profile.', NULL, 'RAN', NULL, NULL, 1350, 15),
(282231, NULL, 'PS51330', NULL, NULL, 'Dihydrofolate reductase (DHFR) domain profile.', NULL, 'DHFR_2', NULL, NULL, 3084, 15),
(282232, NULL, 'PS50838', NULL, NULL, 'MAGE conserved domain profile.', NULL, 'MAGE', NULL, NULL, 88, 15),
(282233, NULL, 'PS51515', NULL, NULL, 'Bin3-type S-adenosyl-L-methionine (SAM) domain profile.', NULL, 'BIN3_SAM', NULL, NULL, 9776, 15),
(282234, NULL, 'PS51021', NULL, NULL, 'BAR domain profile.', NULL, 'BAR', NULL, NULL, 2866, 15),
(282235, NULL, 'PS51344', NULL, NULL, 'TFE/IIEalpha-type HTH domain profile.', NULL, 'HTH_TFE_IIE', NULL, NULL, 18546, 15),
(282236, NULL, 'PS51320', NULL, NULL, 'Tify domain profile.', NULL, 'TIFY', NULL, NULL, 9041, 15),
(282237, NULL, 'PS51712', NULL, NULL, 'EngA-type guanine nucleotide-binding (G) domain profile.', NULL, 'G_ENGA', NULL, NULL, 23945, 15),
(282238, NULL, 'PS51911', NULL, NULL, 'C2 Aida-type domain profile.', NULL, 'C2_AIDA', NULL, NULL, 23881, 15),
(282239, NULL, 'PS51987', NULL, NULL, 'Glutamine synthetase (GS) catalytic domain profile.', NULL, 'GS_CATALYTIC', NULL, NULL, 7238, 15),
(282240, NULL, 'PS51801', NULL, NULL, 'Zinc finger CCHC NOA-type profile.', NULL, 'ZF_CCHC_NOA', NULL, NULL, 15930, 15),
(282241, NULL, 'PS50320', NULL, NULL, 'Methionine-rich region profile.', NULL, 'MET_RICH', NULL, NULL, NULL, 15),
(282242, NULL, 'PS50173', NULL, NULL, 'UmuC domain profile.', NULL, 'UMUC', NULL, NULL, 1246, 15),
(282243, NULL, 'PS50507', NULL, NULL, 'RdRp of positive ssRNA viruses catalytic domain profile.', NULL, 'RDRP_SSRNA_POS', NULL, NULL, 108, 15),
(282244, NULL, 'PS50831', NULL, NULL, 'SoHo domain profile.', NULL, 'SOHO', NULL, NULL, 2516, 15),
(282245, NULL, 'PS50869', NULL, NULL, 'BRICHOS domain profile.', NULL, 'BRICHOS', NULL, NULL, 471, 15),
(282246, NULL, 'PS51413', NULL, NULL, 'DBINO domain profile.', NULL, 'DBINO', NULL, NULL, 20699, 15),
(282247, NULL, 'PS50960', NULL, NULL, 'Psq-type HTH domain profile.', NULL, 'HTH_PSQ', NULL, NULL, 3423, 15),
(282248, NULL, 'PS51546', NULL, NULL, 'Phosphatidylinositol 3-kinase Ras-binding (PI3K RBD) domain profile.', NULL, 'PI3K_RBD', NULL, NULL, 185, 15),
(282249, NULL, 'PS51729', NULL, NULL, 'Yjdj-type Gcn5-related N-acetyltransferase (GNAT) domain profile.', NULL, 'GNAT_YJDJ', NULL, NULL, 23854, 15),
(282250, NULL, 'PS51929', NULL, NULL, 'Coronavirus nucleocapsid (CoV N) protein C-terminal (CTD) domain profile.', NULL, 'COV_N_CTD', NULL, NULL, 33741, 15),
(282251, NULL, 'PS50842', NULL, NULL, 'Expansin, family-45 endoglucanase-like domain profile.', NULL, 'EXPANSIN_EG45', NULL, NULL, 328, 15),
(282252, NULL, 'PS51015', NULL, NULL, 'YDG domain profile.', NULL, 'YDG', NULL, NULL, 1260, 15),
(282253, NULL, 'PS50965', NULL, NULL, 'NERD domain profile.', NULL, 'NERD', NULL, NULL, 12490, 15),
(282254, NULL, 'PS51711', NULL, NULL, 'FeoB-type guanine nucleotide-binding (G) domain profile.', NULL, 'G_FEOB', NULL, NULL, 24738, 15),
(282255, NULL, 'PS51979', NULL, NULL, 'YebF/Cmi domain profile.', NULL, 'YEBF_CMI', NULL, NULL, 22682, 15),
(282256, NULL, 'PS51507', NULL, NULL, 'IRF tryptophan pentad repeat DNA-binding domain profile.', NULL, 'IRF_2', NULL, NULL, 2349, 15),
(282257, NULL, 'PS51053', NULL, NULL, 'SERTA domain profile.', NULL, 'SERTA', NULL, NULL, 13555, 15),
(282258, NULL, 'PS50526', NULL, NULL, 'RdRp of negative ssRNA viruses with non-segmented genomes catalytic domain profile.', NULL, 'RDRP_SSRNA_NEG_NONSEG', NULL, NULL, 13444, 15),
(282259, NULL, 'PS51417', NULL, NULL, 'small GTPase Arf family profile.', NULL, 'ARF', NULL, NULL, NULL, 15),
(282260, NULL, 'PS50912', NULL, NULL, 'EAR repeat profile.', NULL, 'EAR', NULL, NULL, 7528, 15),
(282261, NULL, 'PS50317', NULL, NULL, 'Isoleucine-rich region profile.', NULL, 'ILE_RICH', NULL, NULL, NULL, 15),
(282262, NULL, 'PS51556', NULL, NULL, 'Magnesium protoporphyrin IX methyltransferase (EC 2.1.1.11) family profile.', NULL, 'SAM_MT_MG_PIX', NULL, NULL, 5139, 15),
(282263, NULL, 'PS51754', NULL, NULL, 'OVATE domain profile.', NULL, 'OVATE', NULL, NULL, 6954, 15);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(282264, NULL, 'PS50323', NULL, NULL, 'Arginine-rich region profile.', NULL, 'ARG_RICH', NULL, NULL, NULL, 15),
(282265, NULL, 'PS51766', NULL, NULL, 'Dockerin domain profile.', NULL, 'DOCKERIN', NULL, NULL, 11263, 15),
(282266, NULL, 'PS51248', NULL, NULL, 'Nickel import ATP-binding protein nikE.', NULL, 'NIKE', NULL, NULL, NULL, 15),
(282267, NULL, 'PS50079', NULL, NULL, 'Bipartite nuclear localization signal profile.', NULL, 'NLS_BP', NULL, NULL, NULL, 15),
(282268, NULL, 'PS51624', NULL, NULL, 'RNA methyltransferase TRMH family profile.', NULL, 'SAM_MT_TRMH_2', NULL, NULL, 23372, 15),
(282269, NULL, 'PS51653', NULL, NULL, 'Coronaviridae zinc-binding (CV ZBD) domain profile.', NULL, 'CV_ZBD', NULL, NULL, 24222, 15),
(282270, NULL, 'PS50920', NULL, NULL, 'Solute carrier (Solcar) repeat profile.', NULL, 'SOLCAR', NULL, NULL, 13675, 15),
(282271, NULL, 'PS51738', NULL, NULL, 'Peptidase family C21 domain profile.', NULL, 'PEPTIDASE_C21', NULL, NULL, NULL, 15),
(282272, NULL, 'PS50176', NULL, NULL, 'Armadillo/plakoglobin ARM repeat profile.', NULL, 'ARM_REPEAT', NULL, NULL, 3706, 15),
(282273, NULL, 'PS50979', NULL, NULL, 'Biotin carboxylation domain profile.', NULL, 'BC', NULL, NULL, 11703, 15),
(282274, NULL, 'PS50927', NULL, NULL, 'Bulb-type lectin domain profile.', NULL, 'BULB_LECTIN', NULL, NULL, 3016, 15),
(282275, NULL, 'PS50835', NULL, NULL, 'Ig-like domain profile.', NULL, 'IG_LIKE', NULL, NULL, 401, 15),
(282276, NULL, 'PS51165', NULL, NULL, 'THUMP domain profile.', NULL, 'THUMP', NULL, NULL, 1542, 15),
(282277, NULL, 'PS51672', NULL, NULL, 'ACT-like domain profile.', NULL, 'ACT_LIKE', NULL, NULL, 3173, 15),
(282278, NULL, 'PS51678', NULL, NULL, 'SAM-dependent methyltransferase PRMT-type domain profile.', NULL, 'SAM_MT_PRMT', NULL, NULL, 22929, 15),
(282279, NULL, 'PS51932', NULL, NULL, 'Bacterial microcompartment vertex (BMV) domain profile.', NULL, 'BMV', NULL, NULL, 778, 15),
(282280, NULL, 'PS51938', NULL, NULL, 'SUZ-C domain profile.', NULL, 'SUZ_C', NULL, NULL, 13935, 15),
(282281, NULL, 'PS01179', NULL, NULL, 'Phosphotyrosine interaction domain (PID) profile.', NULL, 'PID', NULL, NULL, 1395, 15),
(282282, NULL, 'PS50886', NULL, NULL, 'tRNA-binding domain profile.', NULL, 'TRBD', NULL, NULL, 1796, 15),
(282283, NULL, 'PS51046', NULL, NULL, 'GON domain profile.', NULL, 'GON', NULL, NULL, 11915, 15),
(282284, NULL, 'PS51827', NULL, NULL, 'XRN2-binding (XTBD) domain profile.', NULL, 'XTBD', NULL, NULL, 19528, 15),
(282285, NULL, 'PS50217', NULL, NULL, 'Basic-leucine zipper (bZIP) domain profile.', NULL, 'BZIP', NULL, NULL, 4006, 15),
(282286, NULL, 'PS50937', NULL, NULL, 'MerR-type HTH domain profile.', NULL, 'HTH_MERR_2', NULL, NULL, 5889, 15),
(282287, NULL, 'PS50081', NULL, NULL, 'Zinc finger phorbol-ester/DAG-type profile.', NULL, 'ZF_DAG_PE_2', NULL, NULL, 5392, 15),
(282288, NULL, 'PS51682', NULL, NULL, 'SAM-dependent O-methyltransferase class I-type profile.', NULL, 'SAM_OMT_I', NULL, NULL, 6647, 15),
(282289, NULL, 'PS51844', NULL, NULL, 'Myosin N-terminal SH3-like domain profile.', NULL, 'SH3_LIKE', NULL, NULL, 511, 15),
(282290, NULL, 'PS51391', NULL, NULL, 'CID domain profile.', NULL, 'CID', NULL, NULL, 264, 15),
(282291, NULL, 'PS51526', NULL, NULL, 'RFX-type winged-helix DNA-binding domain profile.', NULL, 'RFX_DBD', NULL, NULL, 1859, 15),
(282292, NULL, 'PS51840', NULL, NULL, 'C2 NT-type domain profile.', NULL, 'C2_NT', NULL, NULL, 17298, 15),
(282293, NULL, 'PS50213', NULL, NULL, 'FAS1/BIgH3 domain profile.', NULL, 'FAS1', NULL, NULL, 4839, 15),
(282294, NULL, 'PS51536', NULL, NULL, 'TFG box profile.', NULL, 'TFG', NULL, NULL, 22427, 15),
(282295, NULL, 'PS51832', NULL, NULL, 'HD-GYP domain profile.', NULL, 'HD_GYP', NULL, NULL, 27271, 15),
(282296, NULL, 'PS51475', NULL, NULL, 'Proteasome alpha-type subunit profile.', NULL, 'PROTEASOME_ALPHA_2', NULL, NULL, 15659, 15),
(282297, NULL, 'PS51020', NULL, NULL, 'Spondin domain profile.', NULL, 'SPONDIN', NULL, NULL, 9100, 15),
(282298, NULL, 'PS51079', NULL, NULL, 'MBT repeat profile.', NULL, 'MBT', NULL, NULL, 1582, 15);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(282299, NULL, 'PS50002', NULL, NULL, 'Src homology 3 (SH3) domain profile.', NULL, 'SH3', NULL, NULL, 6232, 15),
(282300, NULL, 'PS50076', NULL, NULL, 'dnaJ domain profile.', NULL, 'DNAJ_2', NULL, NULL, 1163, 15),
(282301, NULL, 'PS51343', NULL, NULL, 'P-II protein family profile.', NULL, 'PII_GLNB_DOM', NULL, NULL, 5890, 15),
(282302, NULL, 'PS51626', NULL, NULL, 'Trm1 methyltransferase domain profile.', NULL, 'SAM_MT_TRM1', NULL, NULL, 6289, 15),
(282303, NULL, 'PS50063', NULL, NULL, 'Apoptosis regulator, Bcl-2 family BH4 motif profile.', NULL, 'BH4_2', NULL, NULL, 703, 15),
(282304, NULL, 'PS51895', NULL, NULL, 'Alt a 1 (AA1)-like domain profile.', NULL, 'AA1', NULL, NULL, 25058, 15),
(282305, NULL, 'PS50073', NULL, NULL, 'Copper-fist DNA-binding domain profile.', NULL, 'COPPER_FIST_2', NULL, NULL, 2454, 15),
(282306, NULL, 'PS51151', NULL, NULL, 'NAC A/B domain profile.', NULL, 'NAC_AB', NULL, NULL, 3518, 15),
(282307, NULL, 'PS51082', NULL, NULL, 'WH2 domain profile.', NULL, 'WH2', NULL, NULL, 1510, 15),
(282308, NULL, 'PS51663', NULL, NULL, 'Stathmin-like (SLD) domain profile.', NULL, 'STATHMIN_3', NULL, NULL, 3445, 15),
(282309, NULL, 'PS51749', NULL, NULL, 'Cas9-type HNH domain profile.', NULL, 'HNH_CAS9', NULL, NULL, 28528, 15),
(282310, NULL, 'PS50108', NULL, NULL, 'CRIB domain profile.', NULL, 'CRIB', NULL, NULL, 2548, 15),
(282311, NULL, 'PS51540', NULL, NULL, 'Arterivirus papain-like cysteine protease beta (PCPbeta) domain profile.', NULL, 'AV_PCP_BETA', NULL, NULL, 21631, 15),
(282312, NULL, 'PS51585', NULL, NULL, 'Thiopurine or thiol or thiocyanate S-methyltransferase (TPMT) family profile.', NULL, 'SAM_MT_TPMT', NULL, NULL, 13519, 15),
(282313, NULL, 'PS50878', NULL, NULL, 'Reverse transcriptase (RT) catalytic domain profile.', NULL, 'RT_POL', NULL, NULL, 6625, 15),
(282314, NULL, 'PS51416', NULL, NULL, 'MIB/HERC2 domain profile.', NULL, 'MIB_HERC2', NULL, NULL, 8433, 15),
(282315, NULL, 'PS51461', NULL, NULL, 'Fibrillar collagen C-terminal non-collagenous (NC1) domain profile.', NULL, 'NC1_FIB', NULL, NULL, 4698, 15),
(282316, NULL, 'PS50313', NULL, NULL, 'Glutamic acid-rich region profile.', NULL, 'GLU_RICH', NULL, NULL, NULL, 15),
(282317, NULL, 'PS51061', NULL, NULL, 'R3H domain profile.', NULL, 'R3H', NULL, NULL, 7141, 15),
(282318, NULL, 'PS51765', NULL, NULL, 'Zinc finger RAG1-type profile.', NULL, 'ZF_RAG1', NULL, NULL, 18211, 15),
(282319, NULL, 'PS50951', NULL, NULL, 'SARAH domain profile.', NULL, 'SARAH', NULL, NULL, 12078, 15),
(282320, NULL, 'PS51910', NULL, NULL, 'Glycosyl hydrolases family 18 (GH18) domain profile.', NULL, 'GH18_2', NULL, NULL, 1461, 15),
(282321, NULL, 'PS51852', NULL, NULL, 'pG1 pseudoGTPase domain profile.', NULL, 'PG1', NULL, NULL, 32699, 15),
(282322, NULL, 'PS50067', NULL, NULL, 'Kinesin motor domain profile.', NULL, 'KINESIN_MOTOR_2', NULL, NULL, 3230, 15),
(282323, NULL, 'PS51426', NULL, NULL, 'ABL domain profile.', NULL, 'ABL', NULL, NULL, 15573, 15),
(282324, NULL, 'PS51355', NULL, NULL, 'Glutathione peroxidase profile.', NULL, 'GLUTATHIONE_PEROXID_3', NULL, NULL, 4632, 15),
(282325, NULL, 'PS51751', NULL, NULL, 'EXPERA domain profile.', NULL, 'EXPERA', NULL, NULL, 30262, 15),
(282326, NULL, 'PS51481', NULL, NULL, 'DhaK domain profile.', NULL, 'DHAK', NULL, NULL, 750, 15),
(282327, NULL, 'PS50532', NULL, NULL, 'IS408 transposase-type HTH domain profile.', NULL, 'HTH_IS408', NULL, NULL, 12767, 15),
(282328, NULL, 'PS51116', NULL, NULL, 'Laminin IV type A domain profile.', NULL, 'LAMININ_IVB', NULL, NULL, 18896, 15),
(282329, NULL, 'PS51804', NULL, NULL, 'Zinc finger C2HC LYAR-type profile.', NULL, 'ZF_C2HC_LYAR', NULL, NULL, NULL, 15),
(282330, NULL, 'PS51184', NULL, NULL, 'JmjC domain profile.', NULL, 'JMJC', NULL, NULL, 4389, 15),
(282331, NULL, 'PS50115', NULL, NULL, 'ARF GTPase-activating proteins domain profile.', NULL, 'ARFGAP', NULL, NULL, 1120, 15),
(282332, NULL, 'PS51144', NULL, NULL, 'Alpha-carbonic anhydrases profile.', NULL, 'ALPHA_CA_2', NULL, NULL, 2404, 15),
(282333, NULL, 'PS51615', NULL, NULL, 'Putrescine N-methyltransferase (EC 2.1.1.53) family profile.', NULL, 'SAM_MT_PUTRESCINE', NULL, NULL, 23435, 15);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(282334, NULL, 'PS50172', NULL, NULL, 'BRCT domain profile.', NULL, 'BRCT', NULL, NULL, 7483, 15),
(282335, NULL, 'PS50982', NULL, NULL, 'Methyl-CpG-binding domain (MBD) profile.', NULL, 'MBD', NULL, NULL, 3352, 15),
(282336, NULL, 'PS51324', NULL, NULL, 'ERV/ALR sulfhydryl oxidase domain profile.', NULL, 'ERV_ALR', NULL, NULL, 12622, 15),
(282337, NULL, 'PS51281', NULL, NULL, 'TAP C-terminal (TAP-C) domain profile.', NULL, 'TAP_C', NULL, NULL, 2768, 15),
(282338, NULL, 'PS51727', NULL, NULL, 'CBP/p300-type histone acetyltransferase (HAT) domain profile.', NULL, 'CBP_P300_HAT', NULL, NULL, 21571, 15),
(282339, NULL, 'PS51519', NULL, NULL, 'RWP-RK domain profile.', NULL, 'RWP_RK', NULL, NULL, 23, 15),
(282340, NULL, 'PS51886', NULL, NULL, 'TLDc domain profile.', NULL, 'TLDC', NULL, NULL, 329, 15),
(282341, NULL, 'PS50051', NULL, NULL, 'MCM family domain profile.', NULL, 'MCM_2', NULL, NULL, 1088, 15),
(282342, NULL, 'PS51113', NULL, NULL, 'Zinc finger Btk-type profile.', NULL, 'ZF_BTK', NULL, NULL, 5094, 15),
(282343, NULL, 'PS51951', NULL, NULL, 'Coronavirus Nsp9 single-stranded RNA (ssRNA)-binding domain profile.', NULL, 'COV_NSP9_SSRNA_BD', NULL, NULL, 11563, 15),
(282344, NULL, 'PS50923', NULL, NULL, 'Sushi/CCP/SCR domain profile.', NULL, 'SUSHI', NULL, NULL, 6503, 15),
(282345, NULL, 'PS51241', NULL, NULL, 'Molybdenum import ATP-binding protein modC family profile.', NULL, 'MODC', NULL, NULL, NULL, 15),
(282346, NULL, 'PS50922', NULL, NULL, 'TLC domain profile.', NULL, 'TLC', NULL, NULL, 1352, 15),
(282347, NULL, 'PS50027', NULL, NULL, 'Laminin-type EGF-like (LE) domain profile.', NULL, 'EGF_LAM_2', NULL, NULL, 1303, 15),
(282348, NULL, 'PS51942', NULL, NULL, 'Betacoronavirus Nsp3c-C domain profile.', NULL, 'BCOV_NSP3C_C', NULL, NULL, 16879, 15),
(282349, NULL, 'PS50804', NULL, NULL, 'SCAN box profile.', NULL, 'SCAN_BOX', NULL, NULL, 1239, 15),
(282350, NULL, 'PS51319', NULL, NULL, 'TFIIS N-terminal domain profile.', NULL, 'TFIIS_N', NULL, NULL, 2622, 15),
(282351, NULL, 'PS51730', NULL, NULL, 'Alpha-tubulin Gcn5-related N-acetyltransferase (GNAT) domain profile.', NULL, 'GNAT_ATAT', NULL, NULL, 4497, 15),
(282352, NULL, 'PS51731', NULL, NULL, 'Vertebrate-like NAGS Gcn5-related N-acetyltransferase (GNAT) domain profile.', NULL, 'GNAT_NAGS', NULL, NULL, 3669, 15),
(282353, NULL, 'PS51307', NULL, NULL, 'ASD2 domain profile.', NULL, 'ASD2', NULL, NULL, 11451, 15),
(282354, NULL, 'PS51346', NULL, NULL, 'Prokaryotic zinc-dependent phospholipase C domain profile.', NULL, 'PROKAR_ZN_DEPEND_PLPC_2', NULL, NULL, 3136, 15),
(282355, NULL, 'PS51736', NULL, NULL, 'Resolvase/invertase-type recombinase catalytic domain profile.', NULL, 'RECOMBINASES_3', NULL, NULL, 10360, 15),
(282356, NULL, 'PS51460', NULL, NULL, 'GAR domain profile.', NULL, 'GAR', NULL, NULL, 2733, 15),
(282357, NULL, 'PS51185', NULL, NULL, 'WHEP-TRS domain profile.', NULL, 'WHEP_TRS_2', NULL, NULL, 3767, 15),
(282358, NULL, 'PS50940', NULL, NULL, 'Chitin-binding type-2 domain profile.', NULL, 'CHIT_BIND_II', NULL, NULL, 1623, 15),
(282359, NULL, 'PS51425', NULL, NULL, 'Stromalin conservative (SCD) domain profile.', NULL, 'SCD', NULL, NULL, 20940, 15),
(282360, NULL, 'PS51918', NULL, NULL, 'Radical SAM core domain profile.', NULL, 'RADICAL_SAM', NULL, NULL, 1016, 15),
(282361, NULL, 'PS51380', NULL, NULL, 'EXS domain profile.', NULL, 'EXS', NULL, NULL, 4691, 15),
(282362, NULL, 'PS51397', NULL, NULL, 'WLM domain profile.', NULL, 'WLM', NULL, NULL, 12593, 15),
(282363, NULL, 'PS51490', NULL, NULL, 'KHA domain profile.', NULL, 'KHA', NULL, NULL, 19442, 15),
(282364, NULL, 'PS51761', NULL, NULL, 'Glycosyl hydrolases family 11 (GH11) domain profile.', NULL, 'GH11_3', NULL, NULL, 33698, 15),
(282365, NULL, 'PS51250', NULL, NULL, 'Taurine import ATP-binding protein tauB.', NULL, 'TAUB', NULL, NULL, NULL, 15),
(282366, NULL, 'PS51923', NULL, NULL, 'Coronavirus spike (S) glycoprotein S2 subunit heptad repeat 1 (HR1) region profile.', NULL, 'COV_S2_HR1', NULL, NULL, 35456, 15),
(282367, NULL, 'PS50209', NULL, NULL, 'CARD caspase recruitment domain profile.', NULL, 'CARD', NULL, NULL, 323, 15);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(282368, NULL, 'PS51107', NULL, NULL, 'PTS_EIIC type-5 domain profile.', NULL, 'PTS_EIIC_TYPE_5', NULL, NULL, 3466, 15),
(282369, NULL, 'PS51139', NULL, NULL, 'GTF2I-like repeat profile.', NULL, 'GTF2I', NULL, NULL, 3855, 15),
(282370, NULL, 'PS50803', NULL, NULL, 'OAR domain profile.', NULL, 'OAR', NULL, NULL, 1156, 15),
(282371, NULL, 'PS51056', NULL, NULL, 'ITAM motif hantavirus type profile.', NULL, 'ITAM_2', NULL, NULL, 11567, 15),
(282372, NULL, 'PS51154', NULL, NULL, 'Macro domain profile.', NULL, 'MACRO', NULL, NULL, 1943, 15),
(282373, NULL, 'PS51946', NULL, NULL, 'Coronavirus Nsp4 C-terminal (Nsp4C) domain profile.', NULL, 'COV_NSP4C', NULL, NULL, 22378, 15),
(282374, NULL, 'PS51387', NULL, NULL, 'PCMH-type FAD-binding domain profile.', NULL, 'FAD_PCMH', NULL, NULL, 11634, 15),
(282375, NULL, 'PS50071', NULL, NULL, '''Homeobox'' domain profile.', NULL, 'HOMEOBOX_2', NULL, NULL, 7496, 15),
(282376, NULL, 'PS51288', NULL, NULL, 'Thiamine import ATP-binding protein thiQ family profile.', NULL, 'THIQ', NULL, NULL, NULL, 15),
(282377, NULL, 'PS51572', NULL, NULL, 'Histone-lysine N-methyltransferase (EC 2.1.1.43) family profile.', NULL, 'SAM_MT43_1', NULL, NULL, 20360, 15),
(282378, NULL, 'PS50159', NULL, NULL, 'Ribosomal protein S13 family profile.', NULL, 'RIBOSOMAL_S13_2', NULL, NULL, 4401, 15),
(282379, NULL, 'PS51917', NULL, NULL, 'Pru (pleckstrin-like receptor for ubiquitin) domain profile.', NULL, 'PRU', NULL, NULL, 36188, 15),
(282380, NULL, 'PS50075', NULL, NULL, 'Carrier protein (CP) domain profile.', NULL, 'CARRIER', NULL, NULL, 6159, 15),
(282381, NULL, 'PS50998', NULL, NULL, 'Gla domain profile.', NULL, 'GLA_2', NULL, NULL, 4995, 15),
(282382, NULL, 'PS51930', NULL, NULL, 'Bacterial microcompartment (BMC) domain profile.', NULL, 'BMC_2', NULL, NULL, 36415, 15),
(282383, NULL, 'PS51559', NULL, NULL, 'Arginine and arginine-like N-methyltransferase domain profile.', NULL, 'SAM_RMT2', NULL, NULL, 25485, 15),
(282384, NULL, 'PS50881', NULL, NULL, 'S5 double stranded RNA-binding domain profile.', NULL, 'S5_DSRBD', NULL, NULL, 18612, 15),
(282385, NULL, 'PS51376', NULL, NULL, 'DBB domain profile.', NULL, 'DBB', NULL, NULL, 2628, 15),
(282386, NULL, 'PS51598', NULL, NULL, 'Phosphatidylethanolamine N-methyltransferase (EC 2.1.1.17) family profile.', NULL, 'SAM_CHO2', NULL, NULL, 17233, 15),
(282387, NULL, 'PS51890', NULL, NULL, 'DAZ domain profile.', NULL, 'DAZ', NULL, NULL, 35501, 15),
(282388, NULL, 'PS51882', NULL, NULL, 'G-alpha domain profile.', NULL, 'G_ALPHA', NULL, NULL, 5409, 15),
(282389, NULL, 'PS50095', NULL, NULL, 'PLAT domain profile.', NULL, 'PLAT', NULL, NULL, 2447, 15),
(282390, NULL, 'PS51128', NULL, NULL, 'Prokaryotic dksA C4-type zinc finger profiles.', NULL, 'ZF_DKSA_2', NULL, NULL, 391, 15),
(282391, NULL, 'PS51315', NULL, NULL, 'sn-glycerol-3-phosphate import ATP-binding protein ugpC family profile.', NULL, 'UGPC', NULL, NULL, NULL, 15),
(282392, NULL, 'PS51094', NULL, NULL, 'PTS_EIIA type-2 domain profile.', NULL, 'PTS_EIIA_TYPE_2', NULL, NULL, 5869, 15),
(282393, NULL, 'PS51842', NULL, NULL, 'Intermediate filament (IF) rod domain profile.', NULL, 'IF_ROD_2', NULL, NULL, 27398, 15),
(282394, NULL, 'PS51921', NULL, NULL, 'Betacoronavirus spike (S) glycoprotein S1 subunit C-terminal (CTD) domain profile.', NULL, 'BCOV_S1_CTD', NULL, NULL, 15297, 15),
(282395, NULL, 'PS50045', NULL, NULL, 'Sigma-54 interaction domain profile.', NULL, 'SIGMA54_INTERACT_4', NULL, NULL, 5401, 15),
(282396, NULL, 'PS51022', NULL, NULL, 'L27 domain profile.', NULL, 'L27', NULL, NULL, 2920, 15),
(282397, NULL, 'PS51406', NULL, NULL, 'Fibrinogen C-terminal domain profile.', NULL, 'FIBRINOGEN_C_2', NULL, NULL, 5941, 15),
(282398, NULL, 'PS50900', NULL, NULL, 'PLAC domain profile.', NULL, 'PLAC', NULL, NULL, 5477, 15),
(282399, NULL, 'PS51306', NULL, NULL, 'ASD1 domain profile.', NULL, 'ASD1', NULL, NULL, 11100, 15),
(282400, NULL, 'PS51575', NULL, NULL, 'Histone-lysine N-methyltransferase (EC 2.1.1.43) family profile.', NULL, 'SAM_MT43_SUVAR39_2', NULL, NULL, 22827, 15),
(282401, NULL, 'PS51849', NULL, NULL, 'RsgI N-terminal anti-sigma domain profile.', NULL, 'RSGI_N', NULL, NULL, 24152, 15);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(282402, NULL, 'PS51700', NULL, NULL, 'SEPARIN core domain profile.', NULL, 'SEPARIN', NULL, NULL, 24146, 15),
(282403, NULL, 'PS51304', NULL, NULL, 'Galactoside-binding lectin (galectin) domain profile.', NULL, 'GALECTIN', NULL, NULL, 2387, 15),
(282404, NULL, 'PS50003', NULL, NULL, 'PH domain profile.', NULL, 'PH_DOMAIN', NULL, NULL, 1423, 15),
(282405, NULL, 'PS50953', NULL, NULL, 'KID domain profile.', NULL, 'KID', NULL, NULL, 4345, 15),
(282406, NULL, 'PS51087', NULL, NULL, 'ApaG domain profile.', NULL, 'APAG', NULL, NULL, 2182, 15),
(282407, NULL, 'PS51459', NULL, NULL, 'Fido domain profile.', NULL, 'FIDO', NULL, NULL, 3452, 15),
(282408, NULL, 'PS50303', NULL, NULL, 'Pumilio homology domain (PUM-HD) profile.', NULL, 'PUM_HD', NULL, NULL, 27502, 15),
(282409, NULL, 'PS51716', NULL, NULL, 'IRG-type guanine nucleotide-binding (G) domain profile.', NULL, 'G_IRG', NULL, NULL, 26713, 15),
(282410, NULL, 'PS51358', NULL, NULL, 'Nop domain profile.', NULL, 'NOP', NULL, NULL, 2917, 15),
(282411, NULL, 'PS51527', NULL, NULL, 'Flavivirus NS2B domain profile.', NULL, 'FLAVIVIRUS_NS2B', NULL, NULL, 5534, 15),
(282412, NULL, 'PS51756', NULL, NULL, 'LXG domain profile.', NULL, 'LXG', NULL, NULL, 3883, 15),
(282413, NULL, 'PS51841', NULL, NULL, 'Lamin-tail (LTD) domain profile.', NULL, 'LTD', NULL, NULL, 243, 15),
(282414, NULL, 'PS51573', NULL, NULL, 'Histone-lysine N-methyltransferase (EC 2.1.1.43) family profile.', NULL, 'SAM_MT43_SUVAR39_1', NULL, NULL, 22482, 15),
(282415, NULL, 'PS51098', NULL, NULL, 'PTS_EIIB type-1 domain profile.', NULL, 'PTS_EIIB_TYPE_1', NULL, NULL, 4845, 15),
(282416, NULL, 'PS51455', NULL, NULL, 'Phosphatidylinositol phosphate kinase (PIPK) domain profile.', NULL, 'PIPK', NULL, NULL, 614, 15),
(282417, NULL, 'PS51115', NULL, NULL, 'Laminin IV type A domain profile.', NULL, 'LAMININ_IVA', NULL, NULL, 2870, 15),
(282418, NULL, 'PS50096', NULL, NULL, 'IQ motif profile.', NULL, 'IQ', NULL, NULL, 2708, 15),
(282419, NULL, 'PS51915', NULL, NULL, 'ZAD domain profile.', NULL, 'ZAD', NULL, NULL, 8116, 15),
(282420, NULL, 'PS50322', NULL, NULL, 'Glutamine-rich region profile.', NULL, 'GLN_RICH', NULL, NULL, NULL, 15),
(282421, NULL, 'PS51443', NULL, NULL, 'Phytochelatin synthase (PCS) domain profile.', NULL, 'PCS', NULL, NULL, 1451, 15),
(282422, NULL, 'PS51806', NULL, NULL, 'DOG1 domain profile.', NULL, 'DOG1', NULL, NULL, 26272, 15),
(282423, NULL, 'PS51359', NULL, NULL, 'Cytochrome c oxidase subunit Vb, zinc binding domain profile.', NULL, 'COX5B_2', NULL, NULL, 5450, 15),
(282424, NULL, 'PS50892', NULL, NULL, 'v-SNARE coiled-coil homology domain profile.', NULL, 'V_SNARE', NULL, NULL, 35715, 15),
(282425, NULL, 'PS51883', NULL, NULL, 'Obg domain profile.', NULL, 'OBG', NULL, NULL, 10148, 15),
(282426, NULL, 'PS51133', NULL, NULL, 'Zinc finger TFIIS-type profile.', NULL, 'ZF_TFIIS_2', NULL, NULL, 2346, 15),
(282427, NULL, 'PS51937', NULL, NULL, 'HNF-1 dimerization (HNF-p1) domain profile.', NULL, 'HNF_P1', NULL, NULL, 35198, 15),
(282428, NULL, 'PS51518', NULL, NULL, 'SGF29 C-terminal domain profile.', NULL, 'SGF29_C', NULL, NULL, 9895, 15),
(282429, NULL, 'PS50058', NULL, NULL, 'G-protein gamma subunit domain profile.', NULL, 'G_PROTEIN_GAMMA', NULL, NULL, 7554, 15),
(282430, NULL, 'PS51748', NULL, NULL, 'Hexokinase domain profile.', NULL, 'HEXOKINASE_2', NULL, NULL, 317, 15),
(282431, NULL, 'PS50293', NULL, NULL, 'TPR repeat region circular profile.', NULL, 'TPR_REGION', NULL, NULL, NULL, 15),
(282432, NULL, 'PS50041', NULL, NULL, 'C-type lectin domain profile.', NULL, 'C_TYPE_LECTIN_2', NULL, NULL, 179, 15),
(282433, NULL, 'PS50280', NULL, NULL, 'SET domain profile.', NULL, 'SET', NULL, NULL, 2465, 15),
(282434, NULL, 'PS50138', NULL, NULL, 'BRCA2 repeat profile.', NULL, 'BRCA2_REPEAT', NULL, NULL, 1417, 15),
(282435, NULL, 'PS51894', NULL, NULL, 'Caliciviridae (CV) 3C-like protein profile.', NULL, 'CV_3CL_PRO', NULL, NULL, 4608, 15),
(282436, NULL, 'PS50202', NULL, NULL, 'Major sperm protein (MSP) domain profile.', NULL, 'MSP', NULL, NULL, 5913, 15),
(282437, NULL, 'PS51125', NULL, NULL, 'NHL repeat profile.', NULL, 'NHL', NULL, NULL, 2376, 15);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(282438, NULL, 'PS51780', NULL, NULL, 'GW domain profile.', NULL, 'GW', NULL, NULL, 23359, 15),
(282439, NULL, 'PS51722', NULL, NULL, 'Translational (tr)-type guanine nucleotide-binding (G) domain profile.', NULL, 'G_TR_2', NULL, NULL, 6577, 15),
(282440, NULL, 'PS51512', NULL, NULL, 'DFDF domain profile.', NULL, 'DFDF', NULL, NULL, 23340, 15),
(282441, NULL, 'PS51819', NULL, NULL, 'Vicinal oxygen chelate (VOC) domain profile.', NULL, 'VOC', NULL, NULL, 27318, 15),
(282442, NULL, 'PS51610', NULL, NULL, 'Calmodulin-lysine N-methyltransferase (EC 2.1.1.60) family profile.', NULL, 'SAM_CLNMT', NULL, NULL, 23118, 15),
(282443, NULL, 'PS51043', NULL, NULL, 'DDHD domain profile.', NULL, 'DDHD', NULL, NULL, 2533, 15),
(282444, NULL, 'PS51129', NULL, NULL, 'PdxS/SNZ family profile.', NULL, 'PDXS_SNZ_2', NULL, NULL, 4143, 15),
(282445, NULL, 'PS51473', NULL, NULL, 'Gnk2-homologous domain profile.', NULL, 'GNK2', NULL, NULL, 6005, 15),
(282446, NULL, 'PS51499', NULL, NULL, 'APO domain profile.', NULL, 'APO', NULL, NULL, 15604, 15),
(282447, NULL, 'PS51274', NULL, NULL, 'CobBQ-type GATase domain profile.', NULL, 'GATASE_COBBQ', NULL, NULL, NULL, 15),
(282448, NULL, 'PS51786', NULL, NULL, 'Lon proteolytic domain profile.', NULL, 'LON_PROTEOLYTIC', NULL, NULL, 8565, 15),
(282449, NULL, 'PS50219', NULL, NULL, 'Citron homology (CNH) domain profile.', NULL, 'CNH', NULL, NULL, 1114, 15),
(282450, NULL, 'PS50845', NULL, NULL, 'Reticulon domain profile.', NULL, 'RETICULON', NULL, NULL, 4105, 15),
(282451, NULL, 'PS50031', NULL, NULL, 'EH domain profile.', NULL, 'EH', NULL, NULL, 1264, 15),
(282452, NULL, 'PS51013', NULL, NULL, 'Pannexin family profile.', NULL, 'PANNEXIN', NULL, NULL, 3193, 15),
(282453, NULL, 'PS51706', NULL, NULL, 'EngB-type guanine nucleotide-binding (G) domain profile.', NULL, 'G_ENGB', NULL, NULL, 26176, 15),
(282454, NULL, 'PS50877', NULL, NULL, 'GoLoco/GPR motif profile.', NULL, 'GOLOCO', NULL, NULL, 2659, 15),
(282455, NULL, 'PS50038', NULL, NULL, 'Frizzled (fz) domain profile.', NULL, 'FZ', NULL, NULL, 18804, 15),
(282456, NULL, 'PS50318', NULL, NULL, 'Lysine-rich region profile.', NULL, 'LYS_RICH', NULL, NULL, NULL, 15),
(282457, NULL, 'PS51229', NULL, NULL, 'DCUN1 domain profile.', NULL, 'DCUN1', NULL, NULL, 5221, 15),
(282458, NULL, 'PS51259', NULL, NULL, 'Munc13-homology domain 2 (MHD2) profile.', NULL, 'MHD2', NULL, NULL, 11271, 15),
(282459, NULL, 'PS51578', NULL, NULL, 'Histone-lysine N-methyltransferase (EC 2.1.1.43) family profile.', NULL, 'SAM_MT43_SET2_2', NULL, NULL, 22906, 15),
(282460, NULL, 'PS51191', NULL, NULL, 'FemABX peptidyl transferase family profile.', NULL, 'FEMABX', NULL, NULL, 5202, 15),
(282461, NULL, 'PS51371', NULL, NULL, 'CBS domain profile.', NULL, 'CBS', NULL, NULL, 3944, 15),
(282462, NULL, 'PS51411', NULL, NULL, 'PSP1 C-terminal domain profile.', NULL, 'PSP1_C', NULL, NULL, 3940, 15),
(282463, NULL, 'PS51269', NULL, NULL, 'COMM domain profile.', NULL, 'COMM', NULL, NULL, 2800, 15),
(282464, NULL, 'PS51497', NULL, NULL, 'UMA domain profile.', NULL, 'UMA', NULL, NULL, 15567, 15),
(282465, NULL, 'PS51579', NULL, NULL, 'Histone-lysine N-methyltransferase (EC 2.1.1.43) family profile.', NULL, 'SAM_MT43_SUVAR39_3', NULL, NULL, 14970, 15),
(282466, NULL, 'PS51244', NULL, NULL, 'Lipoprotein release ATP-binding protein lolD family profile.', NULL, 'LOLD', NULL, NULL, NULL, 15),
(282467, NULL, 'PS50978', NULL, NULL, 'NEAT domain profile.', NULL, 'NEAT', NULL, NULL, 1008, 15),
(282468, NULL, 'PS51545', NULL, NULL, 'PIK helical domain profile.', NULL, 'PIK_HELICAL', NULL, NULL, 2267, 15),
(282469, NULL, 'PS50156', NULL, NULL, 'Sterol-sensing domain (SSD) profile.', NULL, 'SSD', NULL, NULL, 3723, 15),
(282470, NULL, 'PS50312', NULL, NULL, 'Aspartic acid-rich region profile.', NULL, 'ASP_RICH', NULL, NULL, NULL, 15),
(282471, NULL, 'PS51243', NULL, NULL, 'Cytochrome C biogenesis export ATP-binding protein ccmA family profile.', NULL, 'CCMA', NULL, NULL, NULL, 15),
(282472, NULL, 'PS51535', NULL, NULL, 'Pestivirus NS3 protease (NS3pro) domain profile.', NULL, 'PESTIVIRUS_NS3PRO', NULL, NULL, 4533, 15);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(282473, NULL, 'PS50974', NULL, NULL, 'AdoMet activation domain profile.', NULL, 'ADOMET_ACTIVATION', NULL, NULL, 3880, 15),
(282474, NULL, 'PS50196', NULL, NULL, 'Ran binding domain type 1 profile.', NULL, 'RANBD1', NULL, NULL, 1949, 15),
(282475, NULL, 'PS51471', NULL, NULL, 'Fe(2+) 2-oxoglutarate dioxygenase domain profile.', NULL, 'FE2OG_OXY', NULL, NULL, 7320, 15),
(282476, NULL, 'PS50276', NULL, NULL, 'Pancreatic hormone family profile.', NULL, 'PANCREATIC_HORMONE_2', NULL, NULL, 2149, 15),
(282477, NULL, 'PS50523', NULL, NULL, 'RdRp of Reoviridae dsRNA viruses catalytic domain profile.', NULL, 'RDRP_DSRNA_REO', NULL, NULL, 60, 15),
(282478, NULL, 'PS51468', NULL, NULL, 'VIT domain profile.', NULL, 'VIT', NULL, NULL, 13773, 15),
(282479, NULL, 'PS51504', NULL, NULL, 'Linker histone H1/H5 globular (H15) domain profile.', NULL, 'H15', NULL, NULL, 5977, 15),
(282480, NULL, 'PS51195', NULL, NULL, 'DEAD-box RNA helicase Q motif profile.', NULL, 'Q_MOTIF', NULL, NULL, 9442, 15),
(282481, NULL, 'PS51383', NULL, NULL, 'YjeF C-terminal domain profile.', NULL, 'YJEF_C_3', NULL, NULL, 5788, 15),
(282482, NULL, 'PS51734', NULL, NULL, 'MPBQ/MBSQ family SAM-binding methyltransferase profile.', NULL, 'SAM_MPBQ_MSBQ_MT', NULL, NULL, 25250, 15),
(282483, NULL, 'PS51648', NULL, NULL, 'YcgL domain profile.', NULL, 'YCGL', NULL, NULL, 24202, 15),
(282484, NULL, 'PS51228', NULL, NULL, 'Acyl-CoA-binding (ACB) domain profile.', NULL, 'ACB_2', NULL, NULL, 5595, 15),
(282485, NULL, 'PS51169', NULL, NULL, 'Chorismate mutase domain profile.', NULL, 'CHORISMATE_MUT_3', NULL, NULL, 849, 15),
(282486, NULL, 'PS50267', NULL, NULL, 'Sodium:neurotransmitter symporter family profile.', NULL, 'NA_NEUROTRAN_SYMP_3', NULL, NULL, 3769, 15),
(282487, NULL, 'PS50918', NULL, NULL, 'WWE domain profile.', NULL, 'WWE', NULL, NULL, 2647, 15),
(282488, NULL, 'PS51328', NULL, NULL, 'L-type lectin-like (leguminous) domain profile.', NULL, 'L_LECTIN_LIKE', NULL, NULL, 2445, 15),
(282489, NULL, 'PS51985', NULL, NULL, 'Cryptic Polo-Box 2 (CPB2) domain profile.', NULL, 'CPB2', NULL, NULL, 28109, 15),
(282490, NULL, 'PS51059', NULL, NULL, 'PARP catalytic domain profile.', NULL, 'PARP_CATALYTIC', NULL, NULL, 11770, 15),
(282491, NULL, 'PS50200', NULL, NULL, 'Ras-associating (RA) domain profile.', NULL, 'RA', NULL, NULL, 3992, 15),
(282492, NULL, 'PS50879', NULL, NULL, 'RNase H type-1 domain profile.', NULL, 'RNASE_H_1', NULL, NULL, 285, 15),
(282493, NULL, 'PS51254', NULL, NULL, 'Ribose import ATP-binding protein rbsA family profile.', NULL, 'RBSA', NULL, NULL, NULL, 15),
(282494, NULL, 'PS51861', NULL, NULL, 'Oxytoxin-type inhibitor cystine knot (ICK) domain profile.', NULL, 'OXYTX_ICK', NULL, NULL, 35543, 15),
(282495, NULL, 'PS50818', NULL, NULL, 'Intein C-terminal splicing motif profile.', NULL, 'INTEIN_C_TER', NULL, NULL, 21719, 15),
(282496, NULL, 'PS51983', NULL, NULL, 'CUT repeat-like (CUTL) domain profile.', NULL, 'CUTL', NULL, NULL, 26191, 15),
(282497, NULL, 'PS51493', NULL, NULL, 'Arterivirus nsp4 proteinase domain profile.', NULL, 'AV_NSP4_PRO', NULL, NULL, 15560, 15),
(282498, NULL, 'PS50009', NULL, NULL, 'Ras guanine-nucleotide exchange factors catalytic domain profile.', NULL, 'RASGEF_CAT', NULL, NULL, 2167, 15),
(282499, NULL, 'PS50240', NULL, NULL, 'Serine proteases, trypsin domain profile.', NULL, 'TRYPSIN_DOM', NULL, NULL, 2102, 15),
(282500, NULL, 'PS51760', NULL, NULL, 'Glycosyl hydrolases family 10 (GH10) domain profile.', NULL, 'GH10_2', NULL, NULL, 3006, 15),
(282501, NULL, 'PS50928', NULL, NULL, 'ABC transporter integral membrane type-1 domain profile.', NULL, 'ABC_TM1', NULL, NULL, 5588, 15),
(282502, NULL, 'PS51867', NULL, NULL, 'Gid-type RING finger profile.', NULL, 'ZF_RING_GID', NULL, NULL, 35730, 15),
(282503, NULL, 'PS51887', NULL, NULL, 'Aphthovirus leader protease (L(pro)) domain profile.', NULL, 'APHTHOVIRUS_LPRO', NULL, NULL, 12229, 15),
(282504, NULL, 'PS50866', NULL, NULL, 'GOLD domain profile.', NULL, 'GOLD', NULL, NULL, 7905, 15),
(282505, NULL, 'PS51568', NULL, NULL, 'Histone-lysine N-methyltransferase (EC 2.1.1.43) family profile.', NULL, 'SAM_MT43_SET2_1', NULL, NULL, 22643, 15);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(282506, NULL, 'PS50983', NULL, NULL, 'Iron siderophore/cobalamin periplasmic-binding domain profile.', NULL, 'FE_B12_PBP', NULL, NULL, 690, 15),
(282507, NULL, 'PS50214', NULL, NULL, 'Disintegrin domain profile.', NULL, 'DISINTEGRIN_2', NULL, NULL, 3118, 15),
(282508, NULL, 'PS51264', NULL, NULL, 'Methionine import ATP-binding protein metN family profile.', NULL, 'METN', NULL, NULL, NULL, 15),
(282509, NULL, 'PS50022', NULL, NULL, 'Coagulation factors 5/8 type C domain (FA58C) profile.', NULL, 'FA58C_3', NULL, NULL, 4934, 15),
(282510, NULL, 'PS51967', NULL, NULL, 'Coronavirus (CoV) 3a-like viroporin cytosolic (CD) domain profile.', NULL, 'COV_VIROPORIN_3A_CD', NULL, NULL, 37584, 15),
(282511, NULL, 'PS51222', NULL, NULL, 'DCD domain profile.', NULL, 'DCD', NULL, NULL, 10281, 15),
(282512, NULL, 'PS50250', NULL, NULL, 'PCI domain profile.', NULL, 'PCI', NULL, NULL, 6531, 15),
(282513, NULL, 'PS51117', NULL, NULL, 'Laminin N-terminal domain profile.', NULL, 'LAMININ_NTER', NULL, NULL, 7497, 15),
(282514, NULL, 'PS51912', NULL, NULL, 'DMAP1-binding domain profile.', NULL, 'DMAP1_BIND', NULL, NULL, 10361, 15),
(282515, NULL, 'PS51157', NULL, NULL, 'Zinc finger UBR-type profile.', NULL, 'ZF_UBR', NULL, NULL, 1655, 15),
(282516, NULL, 'PS51150', NULL, NULL, 'Agouti domain profile.', NULL, 'AGOUTI_2', NULL, NULL, 24751, 15),
(282517, NULL, 'PS51822', NULL, NULL, 'Hepacivirus/Pegivirus NS3 protease domain profile.', NULL, 'HV_PV_NS3_PRO', NULL, NULL, 1971, 15),
(282518, NULL, 'PS51676', NULL, NULL, 'FF domain profile.', NULL, 'FF', NULL, NULL, 3694, 15),
(282519, NULL, 'PS51792', NULL, NULL, 'Yippee domain profile.', NULL, 'YIPPEE', NULL, NULL, 30051, 15),
(282520, NULL, 'PS51007', NULL, NULL, 'Cytochrome c family profile.', NULL, 'CYTC', NULL, NULL, 6205, 15),
(282521, NULL, 'PS51775', NULL, NULL, 'GTD-binding domain profile.', NULL, 'GTD_BINDING', NULL, NULL, 427, 15),
(282522, NULL, 'PS50160', NULL, NULL, 'ATP-dependent DNA ligase family profile.', NULL, 'DNA_LIGASE_A3', NULL, NULL, 12804, 15),
(282523, NULL, 'PS51112', NULL, NULL, 'AMMECR1 domain profile.', NULL, 'AMMECR1', NULL, NULL, 3664, 15),
(282524, NULL, 'PS51345', NULL, NULL, 'Myotoxins family profile.', NULL, 'MYOTOXINS_2', NULL, NULL, NULL, 15),
(282525, NULL, 'PS51336', NULL, NULL, 'DM10 domain profile.', NULL, 'DM10', NULL, NULL, 1440, 15),
(282526, NULL, 'PS51982', NULL, NULL, 'Ubiquitin-like (ULD) domain profile.', NULL, 'ULD', NULL, NULL, 24421, 15),
(282527, NULL, 'PS51707', NULL, NULL, 'CYTH domain profile.', NULL, 'CYTH', NULL, NULL, 16550, 15),
(282528, NULL, 'PS51126', NULL, NULL, 'Dilute domain profile.', NULL, 'DILUTE', NULL, NULL, 3661, 15),
(282529, NULL, 'PS51317', NULL, NULL, 'Beta-(1-->2)glucan export ATP-binding/permease protein ndvA family profile.', NULL, 'NDVA', NULL, NULL, NULL, 15),
(282530, NULL, 'PS51778', NULL, NULL, 'VASt domain profile.', NULL, 'VAST', NULL, NULL, 22784, 15),
(282531, NULL, 'PS50018', NULL, NULL, 'Ras GTPase-activating proteins profile.', NULL, 'RAS_GTPASE_ACTIV_2', NULL, NULL, 2253, 15),
(282532, NULL, 'PS51966', NULL, NULL, 'Coronavirus (CoV) 3a-like viroporin trans-membrane (TM) domain profile.', NULL, 'COV_VIROPORIN_3A_TM', NULL, NULL, 35825, 15),
(282533, NULL, 'PS51472', NULL, NULL, 'RNA-recognition motif (RRM) Nup35-type domain profile.', NULL, 'RRM_NUP35', NULL, NULL, 2103, 15),
(282534, NULL, 'PS51899', NULL, NULL, 'Flp-type tyrosine recombinase domain profile.', NULL, 'TYR_RECOMBINASE_FLP', NULL, NULL, 2687, 15),
(282535, NULL, 'PS50825', NULL, NULL, 'HYR domain profile.', NULL, 'HYR', NULL, NULL, 5188, 15),
(282536, NULL, 'PS51280', NULL, NULL, 'Xylose import ATP-binding protein xylG family profile.', NULL, 'XYLG', NULL, NULL, NULL, 15),
(282537, NULL, 'PS51384', NULL, NULL, 'Ferredoxin reductase-type FAD binding domain profile.', NULL, 'FAD_FR', NULL, NULL, 18511, 15),
(282538, NULL, 'PS51188', NULL, NULL, 'Zinc finger CR-type profile.', NULL, 'ZF_CR', NULL, NULL, 188, 15),
(282539, NULL, 'PS51582', NULL, NULL, 'Phosphoethanolamine N-methyltransferase (PEAMT) (EC 2.1.1.103) family profile.', NULL, 'SAM_PEAMT', NULL, NULL, 23586, 15);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(282540, NULL, 'PS51862', NULL, NULL, 'BetaSPN-type cysteine-stabilized alpha/beta (CS-alpha/beta) domain profile.', NULL, 'BSPN_CSAB', NULL, NULL, 26891, 15),
(282541, NULL, 'PS50066', NULL, NULL, 'MADS-box domain profile.', NULL, 'MADS_BOX_2', NULL, NULL, 1200, 15),
(282542, NULL, 'PS50297', NULL, NULL, 'Ankyrin repeat region circular profile.', NULL, 'ANK_REP_REGION', NULL, NULL, NULL, 15),
(282543, NULL, 'PS50902', NULL, NULL, 'Flavodoxin-like domain profile.', NULL, 'FLAVODOXIN_LIKE', NULL, NULL, 1968, 15),
(282544, NULL, 'PS50942', NULL, NULL, 'ENTH domain profile.', NULL, 'ENTH', NULL, NULL, 12524, 15),
(282545, NULL, 'PS51924', NULL, NULL, 'Coronavirus spike (S) glycoprotein S2 subunit heptad repeat 2 (HR2) region profile.', NULL, 'COV_S2_HR2', NULL, NULL, 36108, 15),
(282546, NULL, 'PS51523', NULL, NULL, 'Zinc-finger ZF-HD dimerization-type profile.', NULL, 'ZF_HD_DIMER', NULL, NULL, 6857, 15),
(282547, NULL, 'PS51488', NULL, NULL, 'KBD domain profile.', NULL, 'KBD', NULL, NULL, 15840, 15),
(282548, NULL, 'PS50030', NULL, NULL, 'Ubiquitin-associated domain (UBA) profile.', NULL, 'UBA', NULL, NULL, 8210, 15),
(282549, NULL, 'PS51725', NULL, NULL, 'ABM domain profile.', NULL, 'ABM', NULL, NULL, 258, 15),
(282550, NULL, 'PS51037', NULL, NULL, 'YEATS domain profile.', NULL, 'YEATS', NULL, NULL, 1202, 15),
(282551, NULL, 'PS51102', NULL, NULL, 'PTS_EIIB type-5 domain profile.', NULL, 'PTS_EIIB_TYPE_5', NULL, NULL, 10884, 15),
(282552, NULL, 'PS50181', NULL, NULL, 'F-box domain profile.', NULL, 'FBOX', NULL, NULL, 4804, 15),
(282553, NULL, 'PS51182', NULL, NULL, 'C2 tensin-type domain profile.', NULL, 'C2_TENSIN', NULL, NULL, 9091, 15),
(282554, NULL, 'PS51412', NULL, NULL, 'Membrane attack complex/perforin (MACPF) domain profile.', NULL, 'MACPF_2', NULL, NULL, 20714, 15),
(282555, NULL, 'PS50211', NULL, NULL, 'Tripartite DENN domain profile.', NULL, 'DENN', NULL, NULL, 32778, 15),
(282556, NULL, 'PS51108', NULL, NULL, 'PTS_EIID domain profile.', NULL, 'PTS_EIID', NULL, NULL, 3008, 15),
(282557, NULL, 'PS51186', NULL, NULL, 'Gcn5-related N-acetyltransferase (GNAT) domain profile.', NULL, 'GNAT', NULL, NULL, 1841, 15),
(282558, NULL, 'PS50837', NULL, NULL, 'NACHT-NTPase domain profile.', NULL, 'NACHT', NULL, NULL, 296, 15),
(282559, NULL, 'PS51957', NULL, NULL, 'LIM interaction domain (LID) domain profile.', NULL, 'LID', NULL, NULL, 29076, 15),
(282560, NULL, 'PS50909', NULL, NULL, 'GAT domain profile.', NULL, 'GAT', NULL, NULL, 2798, 15),
(282561, NULL, 'PS50970', NULL, NULL, 'Homocysteine-binding domain profile.', NULL, 'HCY', NULL, NULL, 2089, 15),
(282562, NULL, 'PS51208', NULL, NULL, 'Autotransporter beta-domain profile.', NULL, 'AUTOTRANSPORTER', NULL, NULL, 1528, 15),
(282563, NULL, 'PS51083', NULL, NULL, 'Zinc finger HIT-type profile.', NULL, 'ZF_HIT', NULL, NULL, 10943, 15),
(282564, NULL, 'PS51502', NULL, NULL, 'Stress-response A/B barrel domain profile.', NULL, 'S_R_A_B_BARREL', NULL, NULL, 18948, 15),
(282565, NULL, 'PS51577', NULL, NULL, 'Histone-lysine N-methyltransferase (EC 2.1.1.43) family profile.', NULL, 'SAM_MT43_SET7', NULL, NULL, 21191, 15),
(282566, NULL, 'PS51901', NULL, NULL, 'Archaeal CBS proteins (ACP)-type metal binding (MB) domain profile.', NULL, 'ACP_MB', NULL, NULL, 35322, 15),
(282567, NULL, 'PS51926', NULL, NULL, 'Coronavirus envelope (CoV E) protein profile.', NULL, 'COV_E', NULL, NULL, 4239, 15),
(282568, NULL, 'PS51403', NULL, NULL, 'Collagen IV carboxyl-terminal non-collagenous (NC1) domain profile.', NULL, 'NC1_IV', NULL, NULL, 6626, 15),
(282569, NULL, 'PS51600', NULL, NULL, 'Glycine N-methyltransferase (EC 2.1.1.20 and EC 2.1.1.156) family profile.', NULL, 'SAM_GNMT', NULL, NULL, 12467, 15),
(282570, NULL, 'PS51338', NULL, NULL, 'IMD domain profile.', NULL, 'IMD', NULL, NULL, 11010, 15),
(282571, NULL, 'PS50225', NULL, NULL, 'SOCS box domain profile.', NULL, 'SOCS', NULL, NULL, 3306, 15),
(282572, NULL, 'PS51697', NULL, NULL, 'ALOG domain profile.', NULL, 'ALOG', NULL, NULL, 5578, 15),
(282573, NULL, 'PS50939', NULL, NULL, 'Cytochrome b561 domain profile.', NULL, 'CYTOCHROME_B561', NULL, NULL, 1136, 15);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(282574, NULL, 'PS51062', NULL, NULL, 'Runt domain profile.', NULL, 'RUNT', NULL, NULL, 7369, 15),
(282575, NULL, 'PS51928', NULL, NULL, 'Coronavirus nucleocapsid (CoV N) protein N-terminal (NTD) domain profile.', NULL, 'COV_N_NTD', NULL, NULL, 33609, 15),
(282576, NULL, 'PS51776', NULL, NULL, 'RH1 domain profile.', NULL, 'RH1', NULL, NULL, 8310, 15),
(282577, NULL, 'PS50324', NULL, NULL, 'Serine-rich region profile.', NULL, 'SER_RICH', NULL, NULL, NULL, 15),
(282578, NULL, 'PS50600', NULL, NULL, 'Ubiquitin-like protease family profile.', NULL, 'ULP_PROTEASE', NULL, NULL, 1497, 15),
(282579, NULL, 'PS51364', NULL, NULL, 'TGF-beta binding (TB) domain profile.', NULL, 'TB', NULL, NULL, 12674, 15),
(282580, NULL, 'PS51402', NULL, NULL, 'catalase family profile.', NULL, 'CATALASE_3', NULL, NULL, 16920, 15),
(282581, NULL, 'PS51574', NULL, NULL, 'Histone-lysine N-methyltransferase (EC 2.1.1.43) family profile.', NULL, 'SAM_MT43_2', NULL, NULL, 22432, 15),
(282582, NULL, 'PS50016', NULL, NULL, 'Zinc finger PHD-type profile.', NULL, 'ZF_PHD_2', NULL, NULL, 14680, 15),
(282583, NULL, 'PS51130', NULL, NULL, 'PdxT/SNO family profile.', NULL, 'PDXT_SNO_2', NULL, NULL, 5189, 15),
(282584, NULL, 'PS50404', NULL, NULL, 'Soluble glutathione S-transferase N-terminal domain profile.', NULL, 'GST_NTER', NULL, NULL, 978, 15),
(282585, NULL, 'PS51090', NULL, NULL, 'Cortactin repeat profile.', NULL, 'CORTACTIN', NULL, NULL, 2604, 15),
(282586, NULL, 'PS51122', NULL, NULL, 'Calponin-like repeat profile.', NULL, 'CALPONIN_2', NULL, NULL, 5785, 15),
(282587, NULL, 'PS51310', NULL, NULL, 'VPS28 C-terminal domain profile.', NULL, 'VPS28_C', NULL, NULL, 8316, 15),
(282588, NULL, 'PS50236', NULL, NULL, 'Clathrin heavy-chain (CHCR) repeat profile.', NULL, 'CHCR', NULL, NULL, 5639, 15),
(282589, NULL, 'PS50013', NULL, NULL, 'Chromo and chromo shadow domain profile.', NULL, 'CHROMO_2', NULL, NULL, 3340, 15),
(282590, NULL, 'PS51836', NULL, NULL, 'Tripartite DENN FNIP1/2-type domain profile.', NULL, 'DENN_FNIP12', NULL, NULL, 31228, 15),
(282591, NULL, 'PS50863', NULL, NULL, 'B3 DNA-binding domain profile.', NULL, 'B3', NULL, NULL, 4130, 15),
(282592, NULL, 'PS50972', NULL, NULL, 'Pterin-binding domain profile.', NULL, 'PTERIN_BINDING', NULL, NULL, 5583, 15),
(282593, NULL, 'PS50004', NULL, NULL, 'C2 domain profile.', NULL, 'C2', NULL, NULL, 2719, 15),
(282594, NULL, 'PS51943', NULL, NULL, 'Coronavirus Nsp3a Ubl domain profile.', NULL, 'COV_NSP3A_UBL', NULL, NULL, 35025, 15),
(282595, NULL, 'PS51934', NULL, NULL, 'LRAT domain profile.', NULL, 'LRAT', NULL, NULL, 6651, 15),
(282596, NULL, 'PS50934', NULL, NULL, 'SWIRM domain profile.', NULL, 'SWIRM', NULL, NULL, 10951, 15),
(282597, NULL, 'PS50141', NULL, NULL, 'Adenosine to inosine editase domain profile.', NULL, 'A_DEAMIN_EDITASE', NULL, NULL, 6672, 15),
(282598, NULL, 'PS51551', NULL, NULL, 'Ephrin receptor-binding (ephrin RBD) domain profile.', NULL, 'EPHRIN_RBD_2', NULL, NULL, 3139, 15),
(282599, NULL, 'PS50314', NULL, NULL, 'Phenylalanine-rich region profile.', NULL, 'PHE_RICH', NULL, NULL, NULL, 15),
(282600, NULL, 'PS51010', NULL, NULL, 'Cytochrome f family profile.', NULL, 'CYTF', NULL, NULL, 6398, 15),
(282601, NULL, 'PS50168', NULL, NULL, 'Death effector domain (DED) profile.', NULL, 'DED', NULL, NULL, 4371, 15),
(282602, NULL, 'PS50277', NULL, NULL, 'Glycoprotein hormones alpha chain family profile.', NULL, 'GLYCO_HORMONE_ALPHA_3', NULL, NULL, 5533, 15),
(282603, NULL, 'PS51542', NULL, NULL, 'FYR domain FYRN motif profile.', NULL, 'FYRN', NULL, NULL, 4314, 15),
(282604, NULL, 'PS50802', NULL, NULL, 'OTU domain profile.', NULL, 'OTU', NULL, NULL, 4490, 15),
(282605, NULL, 'PS51981', NULL, NULL, 'Zinc finger RZ-type profile.', NULL, 'ZF_RZ', NULL, NULL, 35749, 15),
(282606, NULL, 'PS51495', NULL, NULL, 'GLUE domain profile.', NULL, 'GLUE', NULL, NULL, 18713, 15),
(282607, NULL, 'PS51750', NULL, NULL, 'Bro-N domain profile.', NULL, 'BRO_N', NULL, NULL, 6156, 15),
(282608, NULL, 'PS51939', NULL, NULL, 'xRRM domain profile.', NULL, 'XRRM', NULL, NULL, 13398, 15);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(282609, NULL, 'PS50810', NULL, NULL, 'Frataxin family profile.', NULL, 'FRATAXIN_2', NULL, NULL, 6348, 15),
(282610, NULL, 'PS50885', NULL, NULL, 'HAMP domain profile.', NULL, 'HAMP', NULL, NULL, 1355, 15),
(282611, NULL, 'PS51671', NULL, NULL, 'ACT domain profile.', NULL, 'ACT', NULL, NULL, 6111, 15),
(282612, NULL, 'PS51913', NULL, NULL, 'HARE-type HTH domain profile.', NULL, 'HTH_HARE', NULL, NULL, 1379, 15),
(282613, NULL, 'PS51134', NULL, NULL, 'Zinc finger TFIIB-type profile.', NULL, 'ZF_TFIIB', NULL, NULL, 7653, 15),
(282614, NULL, 'PS51203', NULL, NULL, 'CS domain profile.', NULL, 'CS', NULL, NULL, 6502, 15),
(282615, NULL, 'PS51148', NULL, NULL, 'AXH domain profile.', NULL, 'AXH', NULL, NULL, 1481, 15),
(282616, NULL, 'PS50024', NULL, NULL, 'SEA domain profile.', NULL, 'SEA', NULL, NULL, 2621, 15),
(282617, NULL, 'PS50152', NULL, NULL, '2''-5''-oligoadenylate synthase N-terminal region profile.', NULL, '25A_SYNTH_3', NULL, NULL, NULL, 15),
(282618, NULL, 'PS51704', NULL, NULL, 'GP-PDE domain profile.', NULL, 'GP_PDE', NULL, NULL, 21882, 15),
(282619, NULL, 'PS51496', NULL, NULL, 'CVC domain profile.', NULL, 'CVC', NULL, NULL, 15801, 15),
(282620, NULL, 'PS51850', NULL, NULL, 'KARI N-terminal domain profile.', NULL, 'KARI_N', NULL, NULL, 18638, 15),
(282621, NULL, 'PS50987', NULL, NULL, 'ArsR-type HTH domain profile.', NULL, 'HTH_ARSR_2', NULL, NULL, 4484, 15),
(282622, NULL, 'PS51088', NULL, NULL, 'TEA domain profile.', NULL, 'TEA_2', NULL, NULL, 4900, 15),
(282623, NULL, 'PS51091', NULL, NULL, 'Fibronectin type-I domain profile.', NULL, 'FN1_2', NULL, NULL, 3709, 15),
(282624, NULL, 'PS01124', NULL, NULL, 'Bacterial regulatory proteins, araC family DNA-binding domain profile.', NULL, 'HTH_ARAC_FAMILY_2', NULL, NULL, 13648, 15),
(282625, NULL, 'PS50064', NULL, NULL, 'Poly(ADP-ribose) polymerase zinc finger domain profile.', NULL, 'PARP_ZN_FINGER_2', NULL, NULL, 3246, 15),
(282626, NULL, 'PS51063', NULL, NULL, 'Crp-type HTH domain profile.', NULL, 'HTH_CRP_2', NULL, NULL, 11789, 15),
(282627, NULL, 'PS51120', NULL, NULL, 'LDL-receptor class B (LDLRB) repeat profile.', NULL, 'LDLRB', NULL, NULL, 7219, 15),
(282628, NULL, 'PS50895', NULL, NULL, 'SURF1 family profile.', NULL, 'SURF1', NULL, NULL, 7455, 15),
(282629, NULL, 'PS51709', NULL, NULL, 'TrmE-type guanine nucleotide-binding (G) domain profile.', NULL, 'G_TRME', NULL, NULL, 25805, 15),
(282630, NULL, 'PS51757', NULL, NULL, 'Class I myosin tail homology (TH1) domain profile.', NULL, 'TH1', NULL, NULL, 7555, 15),
(282631, NULL, 'PS50191', NULL, NULL, 'CRAL-TRIO lipid binding domain profile.', NULL, 'CRAL_TRIO', NULL, NULL, 6774, 15),
(282632, NULL, 'PS51470', NULL, NULL, 'FG-GAP repeat profile.', NULL, 'FG_GAP', NULL, NULL, 9312, 15),
(282633, NULL, 'PS51111', NULL, NULL, 'REJ domain profile.', NULL, 'REJ', NULL, NULL, 7745, 15),
(282634, NULL, 'PS51828', NULL, NULL, 'Pentraxin (PTX) domain profile.', NULL, 'PTX_2', NULL, NULL, 3338, 15),
(282635, NULL, 'PS51152', NULL, NULL, 'NF-YA/HAP2 family profile.', NULL, 'NFYA_HAP2_2', NULL, NULL, 2064, 15),
(282636, NULL, 'PS50980', NULL, NULL, 'Acetyl-coenzyme A (CoA) carboxyltransferase N-terminal domain profile.', NULL, 'COA_CT_NTER', NULL, NULL, 11705, 15),
(282637, NULL, 'PS51407', NULL, NULL, 'Lysosome-associated membrane glycoprotein family profile.', NULL, 'LAMP_3', NULL, NULL, 4671, 15),
(282638, NULL, 'PS50862', NULL, NULL, 'Aminoacyl-transfer RNA synthetases class-II family profile.', NULL, 'AA_TRNA_LIGASE_II', NULL, NULL, 11096, 15),
(282639, NULL, 'PS51838', NULL, NULL, 'Hepatitis delta antigen (HDAg) domain profile.', NULL, 'HDAG', NULL, NULL, 33404, 15),
(282640, NULL, 'PS51074', NULL, NULL, 'DPH-type metal-binding (MB) domain profile.', NULL, 'DPH_MB', NULL, NULL, 3433, 15),
(282641, NULL, 'PS51634', NULL, NULL, 'CRC domain profile.', NULL, 'CRC', NULL, NULL, 4948, 15),
(282642, NULL, 'PS51217', NULL, NULL, 'UvrD-like DNA helicase C-terminal domain profile.', NULL, 'UVRD_HELICASE_CTER', NULL, NULL, 9187, 15),
(282643, NULL, 'PS50085', NULL, NULL, 'Rap GTPase activating proteins domain profile.', NULL, 'RAPGAP', NULL, NULL, 856, 15);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(282644, NULL, 'PS50157', NULL, NULL, 'Zinc finger C2H2 type domain profile.', NULL, 'ZINC_FINGER_C2H2_2', NULL, NULL, 13910, 15),
(282645, NULL, 'PS51104', NULL, NULL, 'PTS_EIIC type-2 domain profile.', NULL, 'PTS_EIIC_TYPE_2', NULL, NULL, 18983, 15),
(282646, NULL, 'PS51004', NULL, NULL, 'Sema domain profile.', NULL, 'SEMA', NULL, NULL, 5095, 15),
(282647, NULL, 'PS51484', NULL, NULL, 'G8 domain profile.', NULL, 'G8', NULL, NULL, 14952, 15),
(282648, NULL, 'PS50327', NULL, NULL, 'Tryptophan-rich region profile.', NULL, 'TRP_RICH', NULL, NULL, NULL, 15),
(282649, NULL, 'PS51267', NULL, NULL, 'Macrolide export ATP-binding/permease protein macB family profile.', NULL, 'MACB', NULL, NULL, NULL, 15),
(282650, NULL, 'PS51161', NULL, NULL, 'ATP-cone domain profile.', NULL, 'ATP_CONE', NULL, NULL, 4223, 15),
(282651, NULL, 'PS51796', NULL, NULL, 'MSS4 domain profile.', NULL, 'MSS4', NULL, NULL, 10774, 15),
(282652, NULL, 'PS51321', NULL, NULL, 'TFIIS central domain profile.', NULL, 'TFIIS_CENTRAL', NULL, NULL, 648, 15),
(282653, NULL, 'PS51858', NULL, NULL, 'PPPDE domain profile.', NULL, 'PPPDE', NULL, NULL, 13814, 15),
(282654, NULL, 'PS51485', NULL, NULL, 'Phytocyanin domain profile.', NULL, 'PHYTOCYANIN', NULL, NULL, 2699, 15),
(282655, NULL, 'PS51325', NULL, NULL, 'Alpha box DNA-binding domain profile.', NULL, 'ALPHA_BOX', NULL, NULL, 3853, 15),
(282656, NULL, 'PS51705', NULL, NULL, 'HflX-type guanine nucleotide-binding (G) domain profile.', NULL, 'G_HFLX', NULL, NULL, 21566, 15),
(282657, NULL, 'PS51941', NULL, NULL, 'Betacoronavirus Nsp3c-M domain profile.', NULL, 'BCOV_NSP3C_M', NULL, NULL, 22380, 15),
(282658, NULL, 'PS51668', NULL, NULL, 'TsaA-like domain profile.', NULL, 'TSAA_2', NULL, NULL, 15800, 15),
(282659, NULL, 'PS50026', NULL, NULL, 'EGF-like domain profile.', NULL, 'EGF_3', NULL, NULL, 3525, 15),
(282660, NULL, 'PS51893', NULL, NULL, 'A kinase-anchoring proteins AKAP-5 and AKAP-12 calmodulin (CaM)-binding motif profile.', NULL, 'AKAP_CAM_BD', NULL, NULL, 5378, 15),
(282661, NULL, 'PS51817', NULL, NULL, 'Peptidase family A3B domain profile.', NULL, 'PEPTIDASE_A3B', NULL, NULL, 29298, 15),
(282662, NULL, 'PS50882', NULL, NULL, 'YTH domain profile.', NULL, 'YTH', NULL, NULL, 7422, 15),
(282663, NULL, 'PS50958', NULL, NULL, 'Somatomedin B (SMB) domain profile.', NULL, 'SMB_2', NULL, NULL, 1010, 15),
(282664, NULL, 'PS50967', NULL, NULL, 'HRDC domain profile.', NULL, 'HRDC', NULL, NULL, 1441, 15),
(282665, NULL, 'PS51036', NULL, NULL, 'Zinc finger A20-type profile.', NULL, 'ZF_A20', NULL, NULL, 2964, 15),
(282666, NULL, 'PS51198', NULL, NULL, 'UvrD-like DNA helicase ATP-binding domain profile.', NULL, 'UVRD_HELICASE_ATP_BIND', NULL, NULL, 9452, 15),
(282667, NULL, 'PS51327', NULL, NULL, 'Dicer double-stranded RNA-binding fold domain profile.', NULL, 'DICER_DSRBF', NULL, NULL, 2241, 15),
(282668, NULL, 'PS51204', NULL, NULL, 'HSA domain profile.', NULL, 'HSA', NULL, NULL, 9069, 15),
(282669, NULL, 'PS51029', NULL, NULL, 'MADF domain profile.', NULL, 'MADF', NULL, NULL, 200, 15),
(282670, NULL, 'PS50078', NULL, NULL, 'POLO box domain profile.', NULL, 'POLO_BOX', NULL, NULL, 4067, 15),
(282671, NULL, 'PS50166', NULL, NULL, 'Importin-beta N-terminal domain profile.', NULL, 'IMPORTIN_B_NT', NULL, NULL, 3367, 15),
(282672, NULL, 'PS51314', NULL, NULL, 'VPS37 C-terminal domain profile.', NULL, 'VPS37_C', NULL, NULL, 14315, 15),
(282673, NULL, 'PS50146', NULL, NULL, 'DAG-kinase catalytic (DAGKc) domain profile.', NULL, 'DAGK', NULL, NULL, 4477, 15),
(282674, NULL, 'PS51273', NULL, NULL, 'Glutamine amidotransferase type 1 domain profile.', NULL, 'GATASE_TYPE_1', NULL, NULL, NULL, 15),
(282675, NULL, 'PS51449', NULL, NULL, 'Methylthiotransferase N-terminal domain profile.', NULL, 'MTTASE_N', NULL, NULL, 8095, 15),
(282676, NULL, 'PS50851', NULL, NULL, 'CheW-like domain profile.', NULL, 'CHEW', NULL, NULL, 1677, 15),
(282677, NULL, 'PS51230', NULL, NULL, 'EB1-C terminal (EB1-C) domain profile.', NULL, 'EB1_C', NULL, NULL, 2777, 15),
(282678, NULL, 'PS51794', NULL, NULL, 'Diadenylate cyclase (DAC) domain profile.', NULL, 'DAC', NULL, NULL, 4168, 15);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(282679, NULL, 'PS51408', NULL, NULL, 'Transferrin-like domain profile.', NULL, 'TRANSFERRIN_LIKE_4', NULL, NULL, 1470, 15),
(282680, NULL, 'PS50126', NULL, NULL, 'S1 domain profile.', NULL, 'S1', NULL, NULL, 459, 15),
(282681, NULL, 'PS51566', NULL, NULL, 'Histone-lysine N-methyltransferase (EC 2.1.1.43) family profile.', NULL, 'SAM_MT43_TRX_MLL', NULL, NULL, 24462, 15),
(282682, NULL, 'PS51008', NULL, NULL, 'Multiheme cytochrome c family profile.', NULL, 'MULTIHEME_CYTC', NULL, NULL, NULL, 15),
(282683, NULL, 'PS51948', NULL, NULL, 'Coronavirus Nsp12 RNA-dependent RNA polymerase (RdRp) domain profile.', NULL, 'COV_NSP12_RDRP', NULL, NULL, 35722, 15),
(282684, NULL, 'PS50405', NULL, NULL, 'Soluble glutathione S-transferase C-terminal domain profile.', NULL, 'GST_CTER', NULL, NULL, 8160, 15),
(282685, NULL, 'PS50055', NULL, NULL, 'PTP type protein phosphatase domain profile.', NULL, 'TYR_PHOSPHATASE_PTP', NULL, NULL, 820, 15),
(282686, NULL, 'PS51160', NULL, NULL, 'Acylphosphatase-like domain profile.', NULL, 'ACYLPHOSPHATASE_3', NULL, NULL, 4473, 15),
(282687, NULL, 'PS51215', NULL, NULL, 'AWS domain profile.', NULL, 'AWS', NULL, NULL, 375, 15),
(282688, NULL, 'PS50259', NULL, NULL, 'G-protein coupled receptors family 3 profile.', NULL, 'G_PROTEIN_RECEP_F3_4', NULL, NULL, 19080, 15),
(282689, NULL, 'PS51275', NULL, NULL, 'Gamma-glutamyl hydrolase domain profile.', NULL, 'PEPTIDASE_C26_GGH', NULL, NULL, 8318, 15),
(282690, NULL, 'PS50163', NULL, NULL, 'RecA family profile 2.', NULL, 'RECA_3', NULL, NULL, 20619, 15),
(282691, NULL, 'PS51183', NULL, NULL, 'JmjN domain profile.', NULL, 'JMJN', NULL, NULL, 4496, 15),
(282692, NULL, 'PS51856', NULL, NULL, 'Rho RNA-binding domain profile.', NULL, 'RHO_RNA_BD', NULL, NULL, 11297, 15),
(282693, NULL, 'PS50316', NULL, NULL, 'Histidine-rich region profile.', NULL, 'HIS_RICH', NULL, NULL, NULL, 15),
(282694, NULL, 'PS51349', NULL, NULL, 'FMN-dependent alpha-hydroxy acid dehydrogenase domain profile.', NULL, 'FMN_HYDROXY_ACID_DH_2', NULL, NULL, 29618, 15),
(282695, NULL, 'PS51211', NULL, NULL, 'Vitellogenin domain profile.', NULL, 'VITELLOGENIN', NULL, NULL, 4990, 15),
(282696, NULL, 'PS51651', NULL, NULL, 'DOCKER domain profile.', NULL, 'DOCKER', NULL, NULL, 26776, 15),
(282697, NULL, 'PS50072', NULL, NULL, 'Cyclophilin-type peptidyl-prolyl cis-trans isomerase domain profile.', NULL, 'CSA_PPIASE_2', NULL, NULL, 5233, 15),
(282698, NULL, 'PS50023', NULL, NULL, 'LIM domain profile.', NULL, 'LIM_DOMAIN_2', NULL, NULL, 4789, 15),
(282699, NULL, 'PS51717', NULL, NULL, 'Very large inducible GTPASE (VLIG)-type guanine nucleotide-binding (G) domain profile.', NULL, 'G_VLIG', NULL, NULL, 23806, 15),
(282700, NULL, 'PS51774', NULL, NULL, 'Networked (NET) actin-binding (NAB) domain profile.', NULL, 'NAB', NULL, NULL, 10616, 15),
(282701, NULL, 'PS50070', NULL, NULL, 'Kringle domain profile.', NULL, 'KRINGLE_2', NULL, NULL, 1643, 15),
(282702, NULL, 'PS51189', NULL, NULL, 'FAT domain profile.', NULL, 'FAT', NULL, NULL, 7652, 15),
(282703, NULL, 'PS51305', NULL, NULL, 'Spermidine/putrescine import ATP-binding protein potA family profile.', NULL, 'POTA', NULL, NULL, NULL, 15),
(282704, NULL, 'PS51233', NULL, NULL, 'VWFD domain profile.', NULL, 'VWFD', NULL, NULL, 4402, 15),
(282705, NULL, 'PS51265', NULL, NULL, 'Zinc finger DBF4-type profile.', NULL, 'ZF_DBF4', NULL, NULL, 419, 15),
(282706, NULL, 'PS51430', NULL, NULL, 'KaiA N-terminal domain profile.', NULL, 'KAIA_N', NULL, NULL, 20955, 15),
(282707, NULL, 'PS51744', NULL, NULL, 'Helper-component proteinase (HC-Pro) cysteine protease (CPD) domain profile.', NULL, 'HC_PRO_CPD', NULL, NULL, 22076, 15),
(282708, NULL, 'PS51873', NULL, NULL, 'TRIAD supradomain profile.', NULL, 'TRIAD', NULL, NULL, 35445, 15),
(282709, NULL, 'PS51326', NULL, NULL, 'Avidin-like domain profile.', NULL, 'AVIDIN_2', NULL, NULL, 552, 15),
(282710, NULL, 'PS50102', NULL, NULL, 'Eukaryotic RNA Recognition Motif (RRM) profile.', NULL, 'RRM', NULL, NULL, 5671, 15),
(282711, NULL, 'PS51353', NULL, NULL, 'ArsC family profile.', NULL, 'ARSC', NULL, NULL, 1555, 15);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(282712, NULL, 'PS50328', NULL, NULL, 'Tyrosine-rich region profile.', NULL, 'TYR_RICH', NULL, NULL, NULL, 15),
(282713, NULL, 'PS50873', NULL, NULL, 'Plant heme peroxidase family profile.', NULL, 'PEROXIDASE_4', NULL, NULL, 2145, 15),
(282714, NULL, 'PS51221', NULL, NULL, 'TTL domain profile.', NULL, 'TTL', NULL, NULL, 4887, 15),
(282715, NULL, 'PS51513', NULL, NULL, 'FFD box profile.', NULL, 'FFD', NULL, NULL, 23107, 15),
(282716, NULL, 'PS51547', NULL, NULL, 'C2 phosphatidylinositol 3-kinase (PI3K)-type domain profile.', NULL, 'C2_PI3K', NULL, NULL, 2903, 15),
(282717, NULL, 'PS50025', NULL, NULL, 'Laminin G domain profile.', NULL, 'LAM_G_DOMAIN', NULL, NULL, 3322, 15),
(282718, NULL, 'PS50330', NULL, NULL, 'Ubiquitin-interacting motif (UIM) domain profile.', NULL, 'UIM', NULL, NULL, 4073, 15),
(282719, NULL, 'PS50883', NULL, NULL, 'EAL domain profile.', NULL, 'EAL', NULL, NULL, 5479, 15),
(282720, NULL, 'PS51944', NULL, NULL, 'Coronavirus Nsp3d Ubl domain profile.', NULL, 'COV_NSP3D_UBL', NULL, NULL, 34481, 15),
(282721, NULL, 'PS51509', NULL, NULL, 'Phosphagen kinase N-terminal domain profile.', NULL, 'PHOSPHAGEN_KINASE_N', NULL, NULL, 15811, 15),
(282722, NULL, 'PS51925', NULL, NULL, 'SWIB/MDM2 domain profile.', NULL, 'SWIB_MDM2', NULL, NULL, 1503, 15),
(282723, NULL, 'PS50044', NULL, NULL, 'Sigma-54 factors family profile.', NULL, 'SIGMA54_3', NULL, NULL, NULL, 15),
(282724, NULL, 'PS50261', NULL, NULL, 'G-protein coupled receptors family 2 profile 2.', NULL, 'G_PROTEIN_RECEP_F2_4', NULL, NULL, 19761, 15),
(282725, NULL, 'PS50059', NULL, NULL, 'FKBP-type peptidyl-prolyl cis-trans isomerase domain profile.', NULL, 'FKBP_PPIASE', NULL, NULL, 1232, 15),
(282726, NULL, 'PS51247', NULL, NULL, 'Nickel import ATP-binding protein nikD.', NULL, 'NIKD', NULL, NULL, NULL, 15),
(282727, NULL, 'PS51299', NULL, NULL, 'APSES-type HTH DNA-binding domain profile.', NULL, 'HTH_APSES', NULL, NULL, 3289, 15),
(282728, NULL, 'PS51564', NULL, NULL, 'Protein-S-isoprenylcysteine O-methyltransferase (EC 2.1.1.100) family profile.', NULL, 'SAM_ICMT', NULL, NULL, 23925, 15),
(282729, NULL, 'PS51138', NULL, NULL, 'EMSY N-terminal (ENT) domain profile.', NULL, 'ENT', NULL, NULL, 879, 15),
(282730, NULL, 'PS51677', NULL, NULL, 'NodB homology domain profile.', NULL, 'NODB', NULL, NULL, 974, 15),
(282731, NULL, 'PS50097', NULL, NULL, 'BTB domain profile.', NULL, 'BTB', NULL, NULL, 1884, 15),
(282732, NULL, 'PS50919', NULL, NULL, 'MIR domain profile.', NULL, 'MIR', NULL, NULL, 13509, 15),
(282733, NULL, 'PS51296', NULL, NULL, 'Rieske [2Fe-2S] iron-sulfur domain profile.', NULL, 'RIESKE', NULL, NULL, 20630, 15),
(282734, NULL, 'PS51224', NULL, NULL, 'MVP (vault) repeat profile.', NULL, 'MVP', NULL, NULL, 839, 15),
(282735, NULL, 'PS51294', NULL, NULL, 'Myb-type HTH DNA-binding domain profile.', NULL, 'HTH_MYB', NULL, NULL, 20843, 15),
(282736, NULL, 'PS51164', NULL, NULL, 'CBM1 (carbohydrate binding type-1) domain profile.', NULL, 'CBM1_2', NULL, NULL, 4882, 15),
(282737, NULL, 'PS51354', NULL, NULL, 'Glutaredoxin domain profile.', NULL, 'GLUTAREDOXIN_2', NULL, NULL, NULL, 15),
(282738, NULL, 'PS50238', NULL, NULL, 'Rho GTPase-activating proteins domain profile.', NULL, 'RHOGAP', NULL, NULL, 1407, 15),
(282739, NULL, 'PS51231', NULL, NULL, 'Diaphanous autoregulatory domain (DAD) profile.', NULL, 'DAD', NULL, NULL, 11711, 15),
(282740, NULL, 'PS51080', NULL, NULL, 'CTF/NF-I DNA-binding domain profile.', NULL, 'CTF_NFI_2', NULL, NULL, 14863, 15),
(282741, NULL, 'PS50104', NULL, NULL, 'TIR domain profile.', NULL, 'TIR', NULL, NULL, 1854, 15),
(282742, NULL, 'PS51048', NULL, NULL, 'SGS domain profile.', NULL, 'SGS', NULL, NULL, 1249, 15),
(282743, NULL, 'PS51538', NULL, NULL, 'Arterivirus nsp2 cysteine protease (AV CP) domain profile.', NULL, 'AV_CP', NULL, NULL, 12180, 15),
(282744, NULL, 'PS51219', NULL, NULL, 'Dephospho-CoA kinase (DPCK) domain profile.', NULL, 'DPCK', NULL, NULL, 4095, 15),
(282745, NULL, 'PS51272', NULL, NULL, 'S-layer homology (SLH) domain profile.', NULL, 'SLH', NULL, NULL, 1311, 15),
(282746, NULL, 'PS51124', NULL, NULL, 'Peptidase family C16 domain profile.', NULL, 'PEPTIDASE_C16', NULL, NULL, 18949, 15);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(282747, NULL, 'PS51287', NULL, NULL, 'Large T-antigen (T-ag) origin-binding domain (OBD) profile.', NULL, 'T_AG_OBD', NULL, NULL, 1992, 15),
(282748, NULL, 'PS51922', NULL, NULL, 'Betacoronavirus spike (S) glycoprotein S1 subunit N-terminal (NTD) domain profile.', NULL, 'BCOV_S1_NTD', NULL, NULL, 22356, 15),
(282749, NULL, 'PS51014', NULL, NULL, 'Precorrin-6x reductase domain profile.', NULL, 'COBK_CBIJ', NULL, NULL, 2052, 15),
(282750, NULL, 'PS51210', NULL, NULL, 'PLA2c domain profile.', NULL, 'PLA2C', NULL, NULL, 2614, 15),
(282751, NULL, 'PS51498', NULL, NULL, 'MABP domain profile.', NULL, 'MABP', NULL, NULL, 15520, 15),
(282752, NULL, 'PS50977', NULL, NULL, 'TetR-type HTH domain profile.', NULL, 'HTH_TETR_2', NULL, NULL, 3476, 15),
(282753, NULL, 'PS51759', NULL, NULL, 'Carbohydrate-binding module 15 (CBM15) domain profile.', NULL, 'CBM15', NULL, NULL, 10286, 15),
(282754, NULL, 'PS50084', NULL, NULL, 'Type-1 KH domain profile.', NULL, 'KH_TYPE_1', NULL, NULL, NULL, 15),
(282755, NULL, 'PS51825', NULL, NULL, 'DIPSY domain profile.', NULL, 'DIPSY', NULL, NULL, 19214, 15),
(282756, NULL, 'PS51159', NULL, NULL, 'CBM21 (carbohydrate binding type-21) domain profile.', NULL, 'CBM21', NULL, NULL, 2080, 15),
(282757, NULL, 'PS50231', NULL, NULL, 'Lectin domain of ricin B chain profile.', NULL, 'RICIN_B_LECTIN', NULL, NULL, NULL, 15),
(282758, NULL, 'PS51002', NULL, NULL, 'Cytochrome b/b6 N-terminal region profile.', NULL, 'CYTB_NTER', NULL, NULL, 5653, 15),
(282759, NULL, 'PS50876', NULL, NULL, 'Zinc finger integrase-type profile.', NULL, 'ZF_INTEGRASE', NULL, NULL, 3600, 15),
(282760, NULL, 'PS51522', NULL, NULL, 'Zinc finger nanos-type profile.', NULL, 'ZF_NANOS', NULL, NULL, 9882, 15),
(282761, NULL, 'PS51456', NULL, NULL, 'Myosin motor domain profile.', NULL, 'MYOSIN_MOTOR', NULL, NULL, 3265, 15),
(282762, NULL, 'PS51005', NULL, NULL, 'NAC domain profile.', NULL, 'NAC', NULL, NULL, 5280, 15),
(282763, NULL, 'PS51052', NULL, NULL, 'Cyclotides profile.', NULL, 'CYCLOTIDE', NULL, NULL, 1658, 15),
(282764, NULL, 'PS50961', NULL, NULL, 'La-type HTH domain profile.', NULL, 'HTH_LA', NULL, NULL, 1268, 15),
(282765, NULL, 'PS51041', NULL, NULL, 'EMI domain profile.', NULL, 'EMI', NULL, NULL, 12641, 15),
(282766, NULL, 'PS51393', NULL, NULL, 'Lipoxygenase iron-binding catalytic domain profile.', NULL, 'LIPOXYGENASE_3', NULL, NULL, 7731, 15),
(282767, NULL, 'PS51690', NULL, NULL, 'Alphavirus core protein (CP) domain profile.', NULL, 'ALPHAVIRUS_CP', NULL, NULL, 3051, 15),
(282768, NULL, 'PS51361', NULL, NULL, 'Teneurin N-terminal domain profile.', NULL, 'TENEURIN_N', NULL, NULL, 9191, 15),
(282769, NULL, 'PS51463', NULL, NULL, 'Glucose-6-phosphate isomerase family profile.', NULL, 'P_GLUCOSE_ISOMERASE_3', NULL, NULL, 3021, 15),
(282770, NULL, 'PS51066', NULL, NULL, 'Zinc finger FPG-type profile.', NULL, 'ZF_FPG_2', NULL, NULL, 3899, 15),
(282771, NULL, 'PS50194', NULL, NULL, 'Filamin/ABP280 repeat profile.', NULL, 'FILAMIN_REPEAT', NULL, NULL, 11400, 15),
(282772, NULL, 'PS51300', NULL, NULL, 'NADH-nitrite reductase subunit D family profile.', NULL, 'NIRD', NULL, NULL, NULL, 15),
(282773, NULL, 'PS51714', NULL, NULL, 'Bms1-type guanine nucleotide-binding (G) domain profile.', NULL, 'G_BMS1', NULL, NULL, 26932, 15),
(282774, NULL, 'PS51735', NULL, NULL, 'Filoviruses VP35 interferon inhibitory domain profile.', NULL, 'VP35_IID', NULL, NULL, 25383, 15),
(282775, NULL, 'PS50234', NULL, NULL, 'VWFA domain profile.', NULL, 'VWFA', NULL, NULL, 2425, 15),
(282776, NULL, 'PS51560', NULL, NULL, 'Nicotinamide N-methyltransferase (EC 2.1.1.1) family profile.', NULL, 'SAM_MT_NNT1', NULL, NULL, 23150, 15),
(282777, NULL, 'PS51824', NULL, NULL, 'Flocculin 11 (Flo11) domain profile.', NULL, 'FLO11', NULL, NULL, 19384, 15),
(282778, NULL, 'PS50304', NULL, NULL, 'Tudor domain profile.', NULL, 'TUDOR', NULL, NULL, 7274, 15),
(282779, NULL, 'PS51659', NULL, NULL, 'Glycosyltransferase family 23 (GT23) domain profile.', NULL, 'GT23', NULL, NULL, 24347, 15),
(282780, NULL, 'PS51719', NULL, NULL, 'Septin-type guanine nucleotide-binding (G) domain profile.', NULL, 'G_SEPTIN', NULL, NULL, 26874, 15);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(282781, NULL, 'PS51212', NULL, NULL, 'WSC domain profile.', NULL, 'WSC', NULL, NULL, 5924, 15),
(282782, NULL, 'PS51242', NULL, NULL, 'Ferric cations import ATP-binding protein fbpC family profile.', NULL, 'FBPC', NULL, NULL, NULL, 15),
(282783, NULL, 'PS51652', NULL, NULL, 'Arteriviridae zinc-binding (AV ZBD) domain profile.', NULL, 'AV_ZBD', NULL, NULL, 26536, 15),
(282784, NULL, 'PS51348', NULL, NULL, 'Glycosyl hydrolases family 22 (GH22) domain profile.', NULL, 'GLYCOSYL_HYDROL_F22_2', NULL, NULL, 4337, 15),
(282785, NULL, 'PS51261', NULL, NULL, 'Hemin import ATP-Binding protein hmuV family profile.', NULL, 'HMUV', NULL, NULL, NULL, 15),
(282786, NULL, 'PS51225', NULL, NULL, 'MARVEL domain profile.', NULL, 'MARVEL', NULL, NULL, 6247, 15),
(282787, NULL, 'PS50127', NULL, NULL, 'Ubiquitin-conjugating (UBC) core domain profile.', NULL, 'UBC_2', NULL, NULL, 5931, 15),
(282788, NULL, 'PS51789', NULL, NULL, 'RIG-I-like receptor (RLR) C-terminal regulatory (CTR) domain profile.', NULL, 'RLR_CTR', NULL, NULL, 18993, 15),
(282789, NULL, 'PS51167', NULL, NULL, 'Chorismate mutase domain profile.', NULL, 'CHORISMATE_MUT_1', NULL, NULL, 900, 15),
(282790, NULL, 'PS51132', NULL, NULL, 'Olfactomedin-like domain profile.', NULL, 'OLF', NULL, NULL, 1595, 15),
(282791, NULL, 'PS51179', NULL, NULL, 'POU-specific (POUs) domain profile.', NULL, 'POU_3', NULL, NULL, 985, 15),
(282792, NULL, 'PS50057', NULL, NULL, 'FERM domain profile.', NULL, 'FERM_3', NULL, NULL, 4504, 15),
(282793, NULL, 'PS50296', NULL, NULL, 'Translation initiation factor SUI1 family profile.', NULL, 'SUI1', NULL, NULL, 4275, 15),
(282794, NULL, 'PS50271', NULL, NULL, 'Zinc finger UBP-type profile.', NULL, 'ZF_UBP', NULL, NULL, 3441, 15),
(282795, NULL, 'PS50208', NULL, NULL, 'Caspase family p20 domain profile.', NULL, 'CASPASE_P20', NULL, NULL, 454, 15),
(282796, NULL, 'PS51853', NULL, NULL, 'pG2 pseudoGTPase domain profile.', NULL, 'PG2', NULL, NULL, 30725, 15),
(282797, NULL, 'PS51940', NULL, NULL, 'Sarbecovirus Nsp3c-N domain profile.', NULL, 'SARS_NSP3C_N', NULL, NULL, 36165, 15),
(282798, NULL, 'PS51279', NULL, NULL, 'Bucentaur C-terminal (BCNT-C) domain profile.', NULL, 'BCNT_C', NULL, NULL, 13880, 15),
(282799, NULL, 'PS51388', NULL, NULL, 'GED domain profile.', NULL, 'GED', NULL, NULL, 19800, 15),
(282800, NULL, 'PS51026', NULL, NULL, 'NIFH_FRXC family profile.', NULL, 'NIFH_FRXC_3', NULL, NULL, 4790, 15),
(282801, NULL, 'PS51032', NULL, NULL, 'AP2/ERF domain profile.', NULL, 'AP2_ERF', NULL, NULL, 3180, 15),
(282802, NULL, 'PS50915', NULL, NULL, 'Crystallins beta and gamma ''Greek key'' motif profile.', NULL, 'CRYSTALLIN_BETA_GAMMA', NULL, NULL, 2093, 15),
(282803, NULL, 'PS51372', NULL, NULL, 'PRD domain profile.', NULL, 'PRD_2', NULL, NULL, 8395, 15),
(282804, NULL, 'PS51614', NULL, NULL, 'Adrift-type ribose 2''-O-methyltransferase (EC 2.1.1.-) domain profile.', NULL, 'SAM_MT_ADRIFT', NULL, NULL, 23103, 15),
(282805, NULL, 'PS51954', NULL, NULL, 'Coronavirus (CoV) guanine-N7-methyltransferase (N7-MTase) domain profile.', NULL, 'COV_N7_MTASE', NULL, NULL, 36600, 15),
(282806, NULL, 'PS50128', NULL, NULL, 'SURP motif repeat profile.', NULL, 'SURP', NULL, NULL, 2928, 15),
(282807, NULL, 'PS50989', NULL, NULL, 'Acetyl-coenzyme A (CoA) carboxyltransferase C-terminal domain profile.', NULL, 'COA_CT_CTER', NULL, NULL, 11612, 15),
(282808, NULL, 'PS51105', NULL, NULL, 'PTS_EIIC type-3 domain profile.', NULL, 'PTS_EIIC_TYPE_3', NULL, NULL, 1946, 15),
(282809, NULL, 'PS51884', NULL, NULL, 'Chaplin domain profile.', NULL, 'CHAPLIN', NULL, NULL, 1776, 15),
(282810, NULL, 'PS50812', NULL, NULL, 'PWWP domain profile.', NULL, 'PWWP', NULL, NULL, 927, 15),
(282811, NULL, 'PS51193', NULL, NULL, 'Superfamilies 1 and 2 helicase ATP-binding type-2 domain profile.', NULL, 'HELICASE_ATP_BIND_2', NULL, NULL, 9306, 15),
(282812, NULL, 'PS51611', NULL, NULL, '[Cytochrome c]-lysine N-methyltransferase (EC 2.1.1.59) family profile.', NULL, 'SAM_MT59', NULL, NULL, 22439, 15),
(282813, NULL, 'PS51797', NULL, NULL, 'Translationally controlled tumor protein (TCTP) domain profile.', NULL, 'TCTP_3', NULL, NULL, 15964, 15);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(282814, NULL, 'PS51118', NULL, NULL, 'HxlR-type HTH domain profile.', NULL, 'HTH_HXLR', NULL, NULL, 1576, 15),
(282815, NULL, 'PS50252', NULL, NULL, 'T-box domain profile.', NULL, 'TBOX_3', NULL, NULL, 36881, 15),
(282816, NULL, 'PS51450', NULL, NULL, 'Leucine-rich repeat profile.', NULL, 'LRR', NULL, NULL, 5227, 15),
(282817, NULL, 'PS51747', NULL, NULL, 'Cytidine and deoxycytidylate deaminases domain profile.', NULL, 'CYT_DCMP_DEAMINASES_2', NULL, NULL, 5096, 15),
(282818, NULL, 'PS51779', NULL, NULL, 'POTRA domain profile.', NULL, 'POTRA', NULL, NULL, 8212, 15),
(282819, NULL, 'PS50868', NULL, NULL, 'Post-SET domain profile.', NULL, 'POST_SET', NULL, NULL, 506, 15),
(282820, NULL, 'PS51879', NULL, NULL, 'RST domain profile.', NULL, 'RST', NULL, NULL, 20076, 15),
(282821, NULL, 'PS51065', NULL, NULL, 'Neuralized homology repeat (NHR) domain profile.', NULL, 'NHR', NULL, NULL, 15, 15),
(282822, NULL, 'PS50132', NULL, NULL, 'RGS domain profile.', NULL, 'RGS', NULL, NULL, 11395, 15),
(282823, NULL, 'PS50814', NULL, NULL, 'WIF domain profile.', NULL, 'WIF', NULL, NULL, 3678, 15),
(282824, NULL, 'PS50843', NULL, NULL, 'Expansin, Cellulose-binding-like domain profile.', NULL, 'EXPANSIN_CBD', NULL, NULL, 128, 15),
(282825, NULL, 'PS51205', NULL, NULL, 'VPS9 domain profile.', NULL, 'VPS9', NULL, NULL, 1850, 15),
(282826, NULL, 'PS51467', NULL, NULL, 'HARP domain profile.', NULL, 'HARP', NULL, NULL, 8660, 15),
(282827, NULL, 'PS51673', NULL, NULL, 'SUZ domain profile.', NULL, 'SUZ', NULL, NULL, 15462, 15),
(282828, NULL, 'PS50222', NULL, NULL, 'EF-hand calcium-binding domain profile.', NULL, 'EF_HAND_2', NULL, NULL, 1368, 15),
(282829, NULL, 'PS50195', NULL, NULL, 'PX domain profile.', NULL, 'PX', NULL, NULL, 3227, 15),
(282830, NULL, 'PS50001', NULL, NULL, 'Src homology 2 (SH2) domain profile.', NULL, 'SH2', NULL, NULL, 3268, 15),
(282831, NULL, 'PS51362', NULL, NULL, 'TGF-beta family profile.', NULL, 'TGF_BETA_2', NULL, NULL, 4200, 15),
(282832, NULL, 'PS51143', NULL, NULL, 'MT-A70-like family profile.', NULL, 'MT_A70', NULL, NULL, 1076, 15),
(282833, NULL, 'PS51877', NULL, NULL, 'Hypovirulence-associated virus (HAV) papain-like protease p29 domain profile.', NULL, 'HAV_P29_PRO', NULL, NULL, 3949, 15),
(282834, NULL, 'PS51251', NULL, NULL, 'Teichoic acids export ATP-binding protein tagH.', NULL, 'TAGH', NULL, NULL, NULL, 15),
(282835, NULL, 'PS51323', NULL, NULL, 'Insulin-like growth factor-binding protein (IGFBP) N-terminal domain profile.', NULL, 'IGFBP_N_2', NULL, NULL, 4626, 15),
(282836, NULL, 'PS51238', NULL, NULL, 'Phosphate import ATP-binding protein pstB family profile.', NULL, 'PSTB', NULL, NULL, NULL, 15),
(282837, NULL, 'PS51955', NULL, NULL, 'Nidovirus 2''-O-methyltransferase (2''-O-MTase) domain profile.', NULL, 'NIV_2_O_MTASE', NULL, NULL, 36661, 15),
(282838, NULL, 'PS51077', NULL, NULL, 'IclR-type HTH domain profile.', NULL, 'HTH_ICLR', NULL, NULL, 997, 15),
(282839, NULL, 'PS51961', NULL, NULL, 'Arterivirus Nsp11 N-terminal/coronavirus NSP15 middle (AV-Nsp11N/CoV-Nsp15M) domain profile.', NULL, 'AV_NSP11N_COV_NSP15M', NULL, NULL, 37543, 15),
(282840, NULL, 'PS51715', NULL, NULL, 'GB1/RHD3-type guanine nucleotide-binding (G) domain profile.', NULL, 'G_GB1_RHD3', NULL, NULL, 26645, 15),
(282841, NULL, 'PS51283', NULL, NULL, 'DUSP domain profile.', NULL, 'DUSP', NULL, NULL, 1168, 15),
(282842, NULL, 'PS51284', NULL, NULL, 'DOC domain profile.', NULL, 'DOC', NULL, NULL, 1898, 15),
(282843, NULL, 'PS51888', NULL, NULL, 'Clip domain profile.', NULL, 'CLIP', NULL, NULL, 14835, 15),
(282844, NULL, 'PS51532', NULL, NULL, 'PITH domain profile.', NULL, 'PITH', NULL, NULL, 9167, 15),
(282845, NULL, 'PS51741', NULL, NULL, 'F-BAR domain profile.', NULL, 'F_BAR', NULL, NULL, 22263, 15),
(282846, NULL, 'PS50832', NULL, NULL, 'S1 domain IF1 type profile.', NULL, 'S1_IF1_TYPE', NULL, NULL, 11367, 15),
(282847, NULL, 'PS51793', NULL, NULL, 'Mis18 domain profile.', NULL, 'MIS18', NULL, NULL, 30365, 15),
(282848, NULL, 'PS50069', NULL, NULL, 'Cullin family profile.', NULL, 'CULLIN_2', NULL, NULL, 11510, 15);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(282849, NULL, 'PS50930', NULL, NULL, 'LytTR-type HTH domain profile.', NULL, 'HTH_LYTTR', NULL, NULL, 10161, 15),
(282850, NULL, 'PS50950', NULL, NULL, 'Zinc finger THAP-type profile', NULL, 'ZF_THAP', NULL, NULL, 1288, 15),
(282851, NULL, 'PS51679', NULL, NULL, 'C-5 cytosine-specific DNA methylase (Dnmt) domain profile.', NULL, 'SAM_MT_C5', NULL, NULL, 5274, 15),
(282852, NULL, 'PS50833', NULL, NULL, 'Brix domain profile.', NULL, 'BRIX', NULL, NULL, 338, 15),
(282853, NULL, 'PS51802', NULL, NULL, 'Zinc finger CCHHC-type profile.', NULL, 'ZF_CCHHC', NULL, NULL, 656, 15),
(282854, NULL, 'PS51477', NULL, NULL, 'PAH domain profile.', NULL, 'PAH', NULL, NULL, 3234, 15),
(282855, NULL, 'PS51799', NULL, NULL, 'Zinc finger C2H2 AKAP95-type profile.', NULL, 'ZF_C2H2_AKAP95', NULL, NULL, 15914, 15),
(282856, NULL, 'PS51350', NULL, NULL, 'PTS HPR domain profile.', NULL, 'PTS_HPR_DOM', NULL, NULL, 3439, 15),
(282857, NULL, 'PS50206', NULL, NULL, 'Rhodanese domain profile.', NULL, 'RHODANESE_3', NULL, NULL, 3448, 15),
(282858, NULL, 'PS51444', NULL, NULL, 'Formin homology-2 (FH2) domain profile.', NULL, 'FH2', NULL, NULL, 7162, 15),
(282859, NULL, 'PS51669', NULL, NULL, 'Prokaryotic molybdopterin oxidoreductases 4Fe-4S domain profile.', NULL, '4FE4S_MOW_BIS_MGD', NULL, NULL, 5874, 15),
(282860, NULL, 'PS51787', NULL, NULL, 'Lon N-terminal domain profile.', NULL, 'LON_N', NULL, NULL, 2619, 15),
(282861, NULL, 'PS50105', NULL, NULL, 'SAM domain profile.', NULL, 'SAM_DOMAIN', NULL, NULL, 5007, 15),
(282862, NULL, 'PS50925', NULL, NULL, 'BLUF domain profile.', NULL, 'BLUF', NULL, NULL, 6906, 15),
(282863, NULL, 'PS51292', NULL, NULL, 'Zinc finger RING-CH-type profile.', NULL, 'ZF_RING_CH', NULL, NULL, 9214, 15),
(282864, NULL, 'PS51525', NULL, NULL, 'NET domain profile.', NULL, 'NET', NULL, NULL, 26118, 15),
(282865, NULL, 'PS51965', NULL, NULL, 'Streptococcus antigen I/II alanine-rich (Ag I/II A) repeat profile.', NULL, 'AG_I_II_AR', NULL, NULL, 514, 15),
(282866, NULL, 'PS50123', NULL, NULL, 'CheR-type methyltransferase domain profile.', NULL, 'CHER', NULL, NULL, 3977, 15),
(282867, NULL, 'PS51808', NULL, NULL, 'Coiled coil-helix-coiled coil-helix (CHCH) domain profile.', NULL, 'CHCH', NULL, NULL, NULL, 15),
(282868, NULL, 'PS51070', NULL, NULL, 'Stonin homology domain (SHD) profile.', NULL, 'SHD', NULL, NULL, 11932, 15),
(282869, NULL, 'PS51908', NULL, NULL, 'Zinc finger UBZ4-type profile.', NULL, 'ZF_UBZ4', NULL, NULL, 1386, 15),
(282870, NULL, 'PS50142', NULL, NULL, 'Ribonuclease III family domain profile.', NULL, 'RNASE_3_2', NULL, NULL, 80, 15),
(282871, NULL, 'PS51501', NULL, NULL, 'Zinc finger DNL-type profile.', NULL, 'ZF_DNL', NULL, NULL, 2173, 15),
(282872, NULL, 'PS51978', NULL, NULL, 'PBC domain profile.', NULL, 'PBC', NULL, NULL, 1748, 15),
(282873, NULL, 'PS51693', NULL, NULL, 'Hepacivirus nonstructural protein 2 (NS2) protease domain profile.', NULL, 'HCV_NS2_PRO', NULL, NULL, 998, 15),
(282874, NULL, 'PS50893', NULL, NULL, 'ATP-binding cassette, ABC transporter-type domain profile.', NULL, 'ABC_TRANSPORTER_2', NULL, NULL, 5360, 15),
(282875, NULL, 'PS01033', NULL, NULL, 'Globin family profile.', NULL, 'GLOBIN', NULL, NULL, 3034, 15),
(282876, NULL, 'PS51137', NULL, NULL, 'VM domain profile.', NULL, 'VM', NULL, NULL, 7823, 15),
(282877, NULL, 'PS51034', NULL, NULL, 'ZP domain profile.', NULL, 'ZP_2', NULL, NULL, 6041, 15),
(282878, NULL, 'PS51202', NULL, NULL, 'RCK C-terminal domain profile.', NULL, 'RCK_C', NULL, NULL, 2591, 15),
(282879, NULL, 'PS50065', NULL, NULL, 'Hydroxymethylglutaryl-coenzyme A reductases family profile.', NULL, 'HMG_COA_REDUCTASE_4', NULL, NULL, 235, 15),
(282880, NULL, 'PS51613', NULL, NULL, 'RrmJ-type ribose 2''-O-methyltransferase (EC 2.1.1.57) domain profile.', NULL, 'SAM_MT_RRMJ', NULL, NULL, 22252, 15),
(282881, NULL, 'PS50244', NULL, NULL, 'Steroid 5-alpha reductase C-terminal domain profile.', NULL, 'S5A_REDUCTASE', NULL, NULL, 1474, 15),
(282882, NULL, 'PS50917', NULL, NULL, 'SPOC domain profile.', NULL, 'SPOC', NULL, NULL, 5025, 15),
(282883, NULL, 'PS50321', NULL, NULL, 'Asparagine-rich region profile.', NULL, 'ASN_RICH', NULL, NULL, NULL, 15);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(282884, NULL, 'PS51377', NULL, NULL, 'KIND domain profile.', NULL, 'KIND', NULL, NULL, 9008, 15),
(282885, NULL, 'PS51006', NULL, NULL, 'Polyamine biosynthesis (PABS) domain profile.', NULL, 'PABS_2', NULL, NULL, 26772, 15),
(282886, NULL, 'PS50111', NULL, NULL, 'Bacterial chemotaxis sensory transducers domain profile.', NULL, 'CHEMOTAXIS_TRANSDUC_2', NULL, NULL, 1580, 15),
(282887, NULL, 'PS51351', NULL, NULL, 'TFIIE beta central core DNA-binding domain profile.', NULL, 'TFIIE_BETA_C', NULL, NULL, 1581, 15),
(282888, NULL, 'PS51986', NULL, NULL, 'Glutamine synthetase (GS) beta-grasp domain profile.', NULL, 'GS_BETA_GRASP', NULL, NULL, 7182, 15),
(282889, NULL, 'PS50039', NULL, NULL, 'Fork head domain profile.', NULL, 'FORK_HEAD_3', NULL, NULL, 3039, 15),
(282890, NULL, 'PS50985', NULL, NULL, 'GRAS family profile.', NULL, 'GRAS', NULL, NULL, 5269, 15),
(282891, NULL, 'PS51914', NULL, NULL, 'MRH domain profile.', NULL, 'MRH', NULL, NULL, 35431, 15),
(282892, NULL, 'PS50806', NULL, NULL, 'KRAB-related domain profile.', NULL, 'KRAB_RELATED', NULL, NULL, 1416, 15),
(282893, NULL, 'PS50913', NULL, NULL, 'GRIP domain profile.', NULL, 'GRIP', NULL, NULL, 672, 15),
(282894, NULL, 'PS50088', NULL, NULL, 'Ankyrin repeat profile.', NULL, 'ANK_REPEAT', NULL, NULL, 1485, 15),
(282895, NULL, 'PS50921', NULL, NULL, 'ANTAR domain profile.', NULL, 'ANTAR', NULL, NULL, 1537, 15),
(282896, NULL, 'PS50040', NULL, NULL, 'Elongation factor 1 (EF-1) gamma C-terminal domain profile.', NULL, 'EF1G_C', NULL, NULL, 5107, 15),
(282897, NULL, 'PS51945', NULL, NULL, 'Betacoronavirus Nsp3e nucleic acid-binding (NAB) domain profile.', NULL, 'BCOV_NSP3E_NAB', NULL, NULL, 23900, 15),
(282898, NULL, 'PS51728', NULL, NULL, 'Rtt109-type histone acetyltransferase (HAT) domain profile.', NULL, 'RTT109_HAT', NULL, NULL, 16331, 15),
(282899, NULL, 'PS51060', NULL, NULL, 'PARP alpha-helical domain profile.', NULL, 'PARP_ALPHA_HD', NULL, NULL, 1609, 15),
(282900, NULL, 'PS50815', NULL, NULL, 'HORMA domain profile.', NULL, 'HORMA', NULL, NULL, 6186, 15),
(282901, NULL, 'PS51857', NULL, NULL, 'Cold-shock (CSD) domain profile.', NULL, 'CSD_2', NULL, NULL, 1455, 15),
(282902, NULL, 'PS51508', NULL, NULL, 'CKK domain profile.', NULL, 'CKK', NULL, NULL, 11043, 15),
(282903, NULL, 'PS51670', NULL, NULL, 'ShKT domain profile.', NULL, 'SHKT', NULL, NULL, 327, 15),
(282904, NULL, 'PS51904', NULL, NULL, 'Glycosyl hydrolase family 25 (GH25) domain profile.', NULL, 'GLYCOSYL_HYDROL_F25_2', NULL, NULL, 5032, 15),
(282905, NULL, 'PS51686', NULL, NULL, 'SAM-dependent MTase RsmB/NOP-type domain profile.', NULL, 'SAM_MT_RSMB_NOP', NULL, NULL, 3297, 15),
(282906, NULL, 'PS51953', NULL, NULL, 'Nidovirus 3''-5'' exoribonuclease (ExoN) domain profile.', NULL, 'NIV_EXON', NULL, NULL, 36747, 15),
(282907, NULL, 'PS51332', NULL, NULL, 'B12-binding domain profile.', NULL, 'B12_BINDING', NULL, NULL, 10096, 15),
(282908, NULL, 'PS50956', NULL, NULL, 'AsnC-type HTH domain profile.', NULL, 'HTH_ASNC_2', NULL, NULL, 6592, 15),
(282909, NULL, 'PS51845', NULL, NULL, '3''5''-cyclic nucleotide phosphodiesterase domain profile.', NULL, 'PDEASE_I_2', NULL, NULL, 1100, 15),
(282910, NULL, 'PS50178', NULL, NULL, 'Zinc finger FYVE/FYVE-related type profile.', NULL, 'ZF_FYVE', NULL, NULL, 18798, 15),
(282911, NULL, 'PS50198', NULL, NULL, 'PpiC-type peptidyl-prolyl cis-trans isomerase family profile.', NULL, 'PPIC_PPIASE_2', NULL, NULL, 4912, 15),
(282912, NULL, 'PS51445', NULL, NULL, 'Phycobilisome (PBS) linker domain profile.', NULL, 'PBS_LINKER', NULL, NULL, 5342, 15),
(282913, NULL, 'PS50904', NULL, NULL, 'PRELI/MSF1 domain profile.', NULL, 'PRELI_MSF1', NULL, NULL, 3519, 15),
(282914, NULL, 'PS51226', NULL, NULL, 'TEP1 N-terminal repeat profile.', NULL, 'TEP1_N', NULL, NULL, 13636, 15),
(282915, NULL, 'PS51312', NULL, NULL, 'Steadiness box (SB) domain profile.', NULL, 'SB', NULL, NULL, 2718, 15),
(282916, NULL, 'PS51708', NULL, NULL, 'CHAD domain profile.', NULL, 'CHAD', NULL, NULL, 3387, 15),
(282917, NULL, 'PS51960', NULL, NULL, 'Coronavirus (CoV) Nsp15 N-terminal oligomerization domain profile.', NULL, 'COV_NSP15_NTD', NULL, NULL, 35373, 15);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(282918, NULL, 'PS51977', NULL, NULL, 'WGR domain profile.', NULL, 'WGR', NULL, NULL, 7662, 15),
(282919, NULL, 'PS51367', NULL, NULL, 'Thaumatin family profile.', NULL, 'THAUMATIN_2', NULL, NULL, 2232, 15),
(282920, NULL, 'PS51807', NULL, NULL, 'Zinc finger C2HC baculovirus (BV)-type profile.', NULL, 'ZF_C2HC_BV', NULL, NULL, 13614, 15),
(282921, NULL, 'PS51553', NULL, NULL, 'GMP synthetase ATP pyrophosphatase (GMPS ATP-PPase) domain profile.', NULL, 'GMPS_ATP_PPASE', NULL, NULL, 23343, 15),
(282922, NULL, 'PS51664', NULL, NULL, 'YcaO domain profile.', NULL, 'YCAO', NULL, NULL, 6262, 15),
(282923, NULL, 'PS50090', NULL, NULL, 'Myb-like domain profile.', NULL, 'MYB_LIKE', NULL, NULL, 4393, 15),
(282924, NULL, 'PS50823', NULL, NULL, 'Type-2 KH domain profile.', NULL, 'KH_TYPE_2', NULL, NULL, 967, 15),
(282925, NULL, 'PS51533', NULL, NULL, 'ADD domain profile.', NULL, 'ADD', NULL, NULL, 23191, 15),
(282926, NULL, 'PS50932', NULL, NULL, 'LacI-type HTH domain profile.', NULL, 'HTH_LACI_2', NULL, NULL, 411, 15),
(282927, NULL, 'PS50249', NULL, NULL, 'MPN domain profile.', NULL, 'MPN', NULL, NULL, 32541, 15),
(282928, NULL, 'PS50916', NULL, NULL, 'Rab-binding domain profile.', NULL, 'RABBD', NULL, NULL, 5010, 15),
(282929, NULL, 'PS51649', NULL, NULL, 'NPH3 domain profile.', NULL, 'NPH3', NULL, NULL, 24230, 15),
(282930, NULL, 'PS51199', NULL, NULL, 'Superfamily 4 helicase domain profile.', NULL, 'SF4_HELICASE', NULL, NULL, 1492, 15),
(282931, NULL, 'PS50924', NULL, NULL, 'MHYT domain profile.', NULL, 'MHYT', NULL, NULL, 5914, 15),
(282932, NULL, 'PS50143', NULL, NULL, 'BIR repeat profile.', NULL, 'BIR_REPEAT_2', NULL, NULL, 2021, 15),
(282933, NULL, 'PS51385', NULL, NULL, 'YjeF N-terminal domain profile.', NULL, 'YJEF_N', NULL, NULL, 7325, 15),
(282934, NULL, 'PS51633', NULL, NULL, 'CXC domain profile.', NULL, 'CXC', NULL, NULL, 23075, 15),
(282935, NULL, 'PS51753', NULL, NULL, 'HBM domain profile.', NULL, 'HBM', NULL, NULL, 24201, 15),
(282936, NULL, 'PS50834', NULL, NULL, 'HIN-200 A and B domains profile.', NULL, 'HIN_200', NULL, NULL, 875, 15),
(282937, NULL, 'PS51394', NULL, NULL, 'PFU domain profile.', NULL, 'PFU', NULL, NULL, 9705, 15),
(282938, NULL, 'PS50325', NULL, NULL, 'Threonine-rich region profile.', NULL, 'THR_RICH', NULL, NULL, NULL, 15),
(282939, NULL, 'PS51303', NULL, NULL, 'PET domain profile.', NULL, 'PET', NULL, NULL, 10240, 15),
(282940, NULL, 'PS51959', NULL, NULL, 'Eukaryotic uridylate-specific endoribonuclease (EndoU) domain profile.', NULL, 'ENDOU', NULL, NULL, 15843, 15),
(282941, NULL, 'PS51234', NULL, NULL, 'Thrombospondin type-3 (TSP3) repeat profile.', NULL, 'TSP3', NULL, NULL, 12654, 15),
(282942, NULL, 'PS51127', NULL, NULL, 'Big-1 (bacterial Ig-like domain 1) domain profile.', NULL, 'BIG1', NULL, NULL, 4058, 15),
(282943, NULL, 'PS50952', NULL, NULL, 'KIX domain profile.', NULL, 'KIX', NULL, NULL, 1110, 15),
(282944, NULL, 'PS51777', NULL, NULL, 'RH2 domain profile.', NULL, 'RH2', NULL, NULL, 8471, 15),
(282945, NULL, 'PS51898', NULL, NULL, 'Tyrosine recombinase domain profile.', NULL, 'TYR_RECOMBINASE', NULL, NULL, 1018, 15),
(282946, NULL, 'PS50235', NULL, NULL, 'Ubiquitin specific protease (USP) domain profile.', NULL, 'USP_3', NULL, NULL, 24301, 15),
(282947, NULL, 'PS51599', NULL, NULL, 'Phospholipid methyltransferases (EC 2.1.1.17 and EC=2.1.1.71) family profile.', NULL, 'SAM_PEMT_PEM2', NULL, NULL, 23961, 15),
(282948, NULL, 'PS51916', NULL, NULL, 'DEUBAD (DEUBiquitinase ADaptor) domain profile.', NULL, 'DEUBAD', NULL, NULL, 36171, 15),
(282949, NULL, 'PS51335', NULL, NULL, 'ELMO domain profile.', NULL, 'ELMO', NULL, NULL, 3870, 15),
(282950, NULL, 'PS51295', NULL, NULL, 'CRM domain profile.', NULL, 'CRM', NULL, NULL, 4467, 15),
(282951, NULL, 'PS51368', NULL, NULL, 'Urease domain profile.', NULL, 'UREASE_3', NULL, NULL, 592, 15),
(282952, NULL, 'PS50836', NULL, NULL, 'DOMON domain profile.', NULL, 'DOMON', NULL, NULL, 1212, 15),
(282953, NULL, 'PS50179', NULL, NULL, 'VHS domain profile.', NULL, 'VHS', NULL, NULL, 2068, 15),
(282954, NULL, 'PS50859', NULL, NULL, 'Longin domain profile.', NULL, 'LONGIN', NULL, NULL, 5394, 15);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(282955, NULL, 'PS50988', NULL, NULL, 'TROVE domain profile.', NULL, 'TROVE', NULL, NULL, 13855, 15),
(282956, NULL, 'PS51964', NULL, NULL, 'SARS ORF8 accessory protein immunoglobulin (Ig)-like domain profile.', NULL, 'SARS_ORF8_IG', NULL, NULL, 37540, 15),
(282957, NULL, 'PS51163', NULL, NULL, 'YrdC-like domain profile.', NULL, 'YRDC', NULL, NULL, 2837, 15),
(282958, NULL, 'PS50279', NULL, NULL, 'Pancreatic trypsin inhibitor (Kunitz) family profile.', NULL, 'BPTI_KUNITZ_2', NULL, NULL, 481, 15),
(282959, NULL, 'PS51109', NULL, NULL, 'G5 domain profile.', NULL, 'G5', NULL, NULL, 11020, 15),
(282960, NULL, 'PS51785', NULL, NULL, 'Exonuclease I (ExoI) C-terminal domain profile.', NULL, 'EXOI_C', NULL, NULL, 30702, 15),
(282961, NULL, 'PS51855', NULL, NULL, 'MGS-like domain profile.', NULL, 'MGS', NULL, NULL, 8426, 15),
(282962, NULL, 'PS51342', NULL, NULL, 'Colipase family profile.', NULL, 'COLIPASE_2', NULL, NULL, 2227, 15),
(282963, NULL, 'PS51689', NULL, NULL, 'rRNA adenine N(6)-methyltransferase family profile.', NULL, 'SAM_RNA_A_N6_MT', NULL, NULL, 3332, 15),
(282964, NULL, 'PS51520', NULL, NULL, 'Alphavirus nsp2 protease (nsp2pro) domain profile.', NULL, 'NSP2PRO', NULL, NULL, 2873, 15),
(282965, NULL, 'PS50092', NULL, NULL, 'Thrombospondin type-1 (TSP1) repeat profile.', NULL, 'TSP1', NULL, NULL, 4898, 15),
(282966, NULL, 'PS50911', NULL, NULL, 'CHAP domain profile.', NULL, 'CHAP', NULL, NULL, 3251, 15),
(282967, NULL, 'PS51252', NULL, NULL, 'Antistasin-like domain profile.', NULL, 'ANTISTASIN', NULL, NULL, 1961, 15),
(282968, NULL, 'PS51920', NULL, NULL, 'Sarbecovirus 9b domain profile.', NULL, 'SARS_9B', NULL, NULL, 14626, 15),
(282969, NULL, 'PS51927', NULL, NULL, 'Coronavirus membrane (Cov-M) protein profile.', NULL, 'COV_M', NULL, NULL, 1683, 15),
(282970, NULL, 'PS51049', NULL, NULL, 'KASH domain profile.', NULL, 'KASH', NULL, NULL, 11905, 15),
(282971, NULL, 'PS51874', NULL, NULL, 'Picornavirales 3C/3C-like protease domain profile.', NULL, 'PCV_3C_PRO', NULL, NULL, 34870, 15),
(282972, NULL, 'PS51563', NULL, NULL, 'mRNA (2''-O-methyladenosine-N(6)-)-methyltransferase (EC 2.1.1.62) family profile.', NULL, 'SAM_MTA70L_1', NULL, NULL, 23005, 15),
(282973, NULL, 'PS50887', NULL, NULL, 'GGDEF domain profile.', NULL, 'GGDEF', NULL, NULL, 1794, 15),
(282974, NULL, 'PS51069', NULL, NULL, 'GBP repeat profile.', NULL, 'GBP', NULL, NULL, 1553, 15),
(282975, NULL, 'PS50082', NULL, NULL, 'Trp-Asp (WD) repeats profile.', NULL, 'WD_REPEATS_2', NULL, NULL, 3012, 15),
(282976, NULL, 'PS51823', NULL, NULL, 'Clueless (Clu) domain profile.', NULL, 'CLU', NULL, NULL, 22615, 15),
(282977, NULL, 'PS50525', NULL, NULL, 'RdRp of negative ssRNA viruses with segmented genomes catalytic domain profile.', NULL, 'RDRP_SSRNA_NEG_SEG', NULL, NULL, 27, 15),
(282978, NULL, 'PS51479', NULL, NULL, 'RTR1-type zinc finger.', NULL, 'ZF_RTR1', NULL, NULL, 4792, 15),
(282979, NULL, 'PS51658', NULL, NULL, 'Bifunctional nuclease (BFN) domain profile.', NULL, 'BFN', NULL, NULL, 6067, 15),
(282980, NULL, 'PS50164', NULL, NULL, 'GIY-YIG domain profile.', NULL, 'GIY_YIG', NULL, NULL, 808, 15),
(282981, NULL, 'PS51024', NULL, NULL, 'Zinc finger FCS-type profile.', NULL, 'ZF_FCS', NULL, NULL, 11937, 15),
(282982, NULL, 'PS50867', NULL, NULL, 'Pre-SET domain profile.', NULL, 'PRE_SET', NULL, NULL, 1187, 15),
(282983, NULL, 'PS50290', NULL, NULL, 'Phosphatidylinositol 3- and 4-kinases catalytic domain profile.', NULL, 'PI3_4_KINASE_3', NULL, NULL, 4860, 15),
(282984, NULL, 'PS50807', NULL, NULL, 'GCM domain profile.', NULL, 'GCM', NULL, NULL, 4224, 15),
(282985, NULL, 'PS50268', NULL, NULL, 'Cadherins domain profile.', NULL, 'CADHERIN_2', NULL, NULL, 1262, 15),
(282986, NULL, 'PS50270', NULL, NULL, 'Nerve growth factor family profile.', NULL, 'NGF_2', NULL, NULL, NULL, 15),
(282987, NULL, 'PS50060', NULL, NULL, 'MAM domain profile.', NULL, 'MAM_2', NULL, NULL, 3140, 15),
(282988, NULL, 'PS50053', NULL, NULL, 'Ubiquitin domain profile.', NULL, 'UBIQUITIN_2', NULL, NULL, 4344, 15),
(282989, NULL, 'PS50005', NULL, NULL, 'TPR repeat profile.', NULL, 'TPR', NULL, NULL, 20936, 15);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(282990, NULL, 'PS50254', NULL, NULL, 'NF-kappa-B/Rel/dorsal domain profile.', NULL, 'REL_2', NULL, NULL, 7711, 15),
(282991, NULL, 'PS51097', NULL, NULL, 'PTS_EIIA type-5 domain profile.', NULL, 'PTS_EIIA_TYPE_5', NULL, NULL, 3493, 15),
(282992, NULL, 'PS51337', NULL, NULL, 'B12-binding N-terminal domain profile.', NULL, 'B12_BINDING_NTER', NULL, NULL, 2256, 15),
(282993, NULL, 'PS51870', NULL, NULL, 'Amyloid precursor protein (APP) E2 domain profile.', NULL, 'APP_E2', NULL, NULL, 24890, 15),
(282994, NULL, 'PS51084', NULL, NULL, 'HIT domain profile.', NULL, 'HIT_2', NULL, NULL, 9054, 15),
(282995, NULL, 'PS51334', NULL, NULL, 'PRONE domain profile.', NULL, 'PRONE', NULL, NULL, 859, 15),
(282996, NULL, 'PS51500', NULL, NULL, 'Sin domain profile.', NULL, 'SIN', NULL, NULL, 8114, 15),
(282997, NULL, 'PS51662', NULL, NULL, 'Beta-propeller phytase (BPP) domain profile.', NULL, 'BP_PHYTASE', NULL, NULL, 5481, 15),
(282998, NULL, 'PS51772', NULL, NULL, 'Actin cross-linking (ACD) domain profile.', NULL, 'ACD', NULL, NULL, 26493, 15),
(282999, NULL, 'PS50245', NULL, NULL, 'CAP-Gly domain profile.', NULL, 'CAP_GLY_2', NULL, NULL, 3027, 15),
(283000, NULL, 'PS51051', NULL, NULL, 'DSL domain profile.', NULL, 'DSL', NULL, NULL, 3456, 15),
(283001, NULL, 'PS51404', NULL, NULL, 'DyP-type peroxidase family.', NULL, 'DYP_PEROXIDASE', NULL, NULL, 4616, 15),
(283002, NULL, 'PS51187', NULL, NULL, 'Autoinducer synthase family profile.', NULL, 'AUTOINDUCER_SYNTH_2', NULL, NULL, 3015, 15),
(283003, NULL, 'PS51363', NULL, NULL, 'W2 domain profile.', NULL, 'W2', NULL, NULL, 3794, 15),
(283004, NULL, 'PS51737', NULL, NULL, 'DNA-binding recombinase domain profile.', NULL, 'RECOMBINASE_DNA_BIND', NULL, NULL, 11082, 15),
(283005, NULL, 'PS50077', NULL, NULL, 'HEAT repeat profile.', NULL, 'HEAT_REPEAT', NULL, NULL, 11571, 15),
(283006, NULL, 'PS50275', NULL, NULL, 'Sac phosphatase domain profile.', NULL, 'SAC', NULL, NULL, 4583, 15),
(283007, NULL, 'PS51571', NULL, NULL, 'Histone-lysine N-methyltransferase (EC 2.1.1.43) family profile.', NULL, 'SAM_MT43_PR_SET', NULL, NULL, 16145, 15),
(283008, NULL, 'PS50086', NULL, NULL, 'TBC/rab GAP domain profile.', NULL, 'TBC_RABGAP', NULL, NULL, 1351, 15),
(283009, NULL, 'PS50522', NULL, NULL, 'RdRp of RNA-containing bacteriophages catalytic domain profile.', NULL, 'RDRP_PHAGE', NULL, NULL, 341, 15),
(283010, NULL, 'PS51675', NULL, NULL, 'SAM-dependent methyltransferase TRM10-type domain profile.', NULL, 'SAM_MT_TRM10', NULL, NULL, 23525, 15),
(283011, NULL, 'PS50926', NULL, NULL, 'TRAM domain profile.', NULL, 'TRAM', NULL, NULL, 4304, 15),
(283012, NULL, 'PS50864', NULL, NULL, 'SAND domain profile.', NULL, 'SAND', NULL, NULL, 3994, 15),
(283013, NULL, 'PS50995', NULL, NULL, 'MarR-type HTH domain profile.', NULL, 'HTH_MARR_2', NULL, NULL, 4925, 15),
(283014, NULL, 'PS51064', NULL, NULL, 'IRS-type PTB domain profile.', NULL, 'IRS_PTB', NULL, NULL, 6975, 15),
(283015, NULL, 'PS51239', NULL, NULL, 'Lipid A export ATP-binding/permease protein msbA family profile.', NULL, 'MSBA', NULL, NULL, NULL, 15),
(283016, NULL, 'PS50848', NULL, NULL, 'START domain profile.', NULL, 'START', NULL, NULL, 6155, 15),
(283017, NULL, 'PS51092', NULL, NULL, 'Fibronectin type-II collagen-binding domain profile.', NULL, 'FN2_2', NULL, NULL, 5841, 15),
(283018, NULL, 'PS51282', NULL, NULL, 'DWNN domain profile.', NULL, 'DWNN', NULL, NULL, 13455, 15),
(283019, NULL, 'PS50263', NULL, NULL, 'Carbon-nitrogen hydrolase domain profile.', NULL, 'CN_HYDROLASE', NULL, NULL, 262, 15),
(283020, NULL, 'PS51701', NULL, NULL, '6-Cysteine (6-Cys) domain profile.', NULL, '6_CYS', NULL, NULL, 11613, 15),
(283021, NULL, 'PS51529', NULL, NULL, 'Fetuin-A-type cystatin domain profile.', NULL, 'CYSTATIN_FETUIN_A', NULL, NULL, 23167, 15),
(283022, NULL, 'PS51423', NULL, NULL, 'Miro domain profile.', NULL, 'MIRO', NULL, NULL, 20844, 15),
(283023, NULL, 'PS50012', NULL, NULL, 'Regulator of chromosome condensation (RCC1) repeat profile.', NULL, 'RCC1_3', NULL, NULL, 6861, 15),
(283024, NULL, 'PS50139', NULL, NULL, 'Z-binding domain profile.', NULL, 'Z_BINDING', NULL, NULL, 36645, 15);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(283025, NULL, 'PS50228', NULL, NULL, 'SUEL-type lectin domain profile.', NULL, 'SUEL_LECTIN', NULL, NULL, 247, 15),
(283026, NULL, 'PS50192', NULL, NULL, 't-SNARE coiled-coil homology domain profile.', NULL, 'T_SNARE', NULL, NULL, 6695, 15),
(283027, NULL, 'PS50910', NULL, NULL, 'HEPN domain profile.', NULL, 'HEPN', NULL, NULL, 2497, 15),
(283028, NULL, 'PS51245', NULL, NULL, 'Maltose/Maltodextrin import ATP-binding protein malK family profile.', NULL, 'MALK', NULL, NULL, NULL, 15),
(283029, NULL, 'PS50829', NULL, NULL, 'GYF domain profile.', NULL, 'GYF', NULL, NULL, 1962, 15),
(283030, NULL, 'PS51868', NULL, NULL, 'Peptidase family S39 domain profile.', NULL, 'PEPTIDASE_S39', NULL, NULL, 6679, 15),
(283031, NULL, 'PS51000', NULL, NULL, 'DeoR-type HTH domain profile.', NULL, 'HTH_DEOR_2', NULL, NULL, 1253, 15),
(283032, NULL, 'PS51641', NULL, NULL, 'Agenet-like domain profile.', NULL, 'AGENET_LIKE', NULL, NULL, 7927, 15),
(283033, NULL, 'PS51510', NULL, NULL, 'Phosphagen kinase C-terminal domain profile.', NULL, 'PHOSPHAGEN_KINASE_C', NULL, NULL, 15799, 15),
(283034, NULL, 'PS51322', NULL, NULL, 'UEV domain profile.', NULL, 'UEV', NULL, NULL, 7525, 15),
(283035, NULL, 'PS50255', NULL, NULL, 'Cytochrome b5 family, heme-binding domain profile.', NULL, 'CYTOCHROME_B5_2', NULL, NULL, 1047, 15),
(283036, NULL, 'PS51352', NULL, NULL, 'Thioredoxin domain profile.', NULL, 'THIOREDOXIN_2', NULL, NULL, 10764, 15),
(283037, NULL, 'PS51843', NULL, NULL, 'Nuclear receptor (NR) ligand-binding (LBD) domain profile.', NULL, 'NR_LBD', NULL, NULL, 5738, 15),
(283038, NULL, 'PS51180', NULL, NULL, 'BRO1 domain profile.', NULL, 'BRO1', NULL, NULL, 4977, 15),
(283039, NULL, 'PS51369', NULL, NULL, 'TCP domain profile.', NULL, 'TCP', NULL, NULL, 7382, 15),
(283040, NULL, 'PS50991', NULL, NULL, 'Pyruvate carboxyltransferase domain.', NULL, 'PYR_CT', NULL, NULL, 4733, 15),
(283041, NULL, 'PS51378', NULL, NULL, 'Invertebrate defensins family profile.', NULL, 'INVERT_DEFENSINS', NULL, NULL, 5829, 15),
(283042, NULL, 'PS51469', NULL, NULL, 'SUN domain profile.', NULL, 'SUN', NULL, NULL, 7983, 15),
(283043, NULL, 'PS51114', NULL, NULL, 'F-box-associated (FBA) domain profile.', NULL, 'FBA', NULL, NULL, 3584, 15),
(283044, NULL, 'PS50941', NULL, NULL, 'Chitin-binding type-1 domain profile.', NULL, 'CHIT_BIND_I_2', NULL, NULL, 3245, 15),
(283045, NULL, 'PS51781', NULL, NULL, 'SH3b domain profile.', NULL, 'SH3B', NULL, NULL, 1397, 15),
(283046, NULL, 'PS51100', NULL, NULL, 'PTS_EIIB type-3 domain profile.', NULL, 'PTS_EIIB_TYPE_3', NULL, NULL, 18687, 15),
(283047, NULL, 'PS51834', NULL, NULL, 'Tripartite DENN FLCN/SMCR8-type domain profile.', NULL, 'DENN_FLCN_SMCR8', NULL, NULL, 33248, 15),
(283048, NULL, 'PS50035', NULL, NULL, 'Phospholipase D phosphodiesterase active site profile.', NULL, 'PLD', NULL, NULL, 3059, 15),
(283049, NULL, 'PS51237', NULL, NULL, 'Sulfate/thiosulfate import ATP-binding protein cysA family profile.', NULL, 'CYSA', NULL, NULL, NULL, 15),
(283050, NULL, 'PS51276', NULL, NULL, 'PfpI endopeptidase domain profile.', NULL, 'PEPTIDASE_C56_PFPI', NULL, NULL, 3765, 15),
(283051, NULL, 'PS51589', NULL, NULL, 'Viral protein 3 containing mRNA (guanine-N(7)-)-methyltransferase family profile.', NULL, 'SAM_MT56_VP3', NULL, NULL, 10967, 15),
(283052, NULL, 'PS50894', NULL, NULL, 'Histidine-containing phosphotransfer (HPt) domain profile.', NULL, 'HPT', NULL, NULL, 7469, 15),
(283053, NULL, 'PS50896', NULL, NULL, 'LIS1 homology (LisH) motif profile.', NULL, 'LISH', NULL, NULL, 1021, 15),
(283054, NULL, 'PS51872', NULL, NULL, 'Zinc finger ZBR-type profile.', NULL, 'ZF_ZBR', NULL, NULL, 34595, 15),
(283055, NULL, 'PS51031', NULL, NULL, 'BESS domain profile.', NULL, 'BESS', NULL, NULL, 3684, 15),
(283056, NULL, 'PS51620', NULL, NULL, 'tRNA (adenine(57)-N(1)/adenine(58)-N(1) or adenine(58)-N(1)) (EC 2.1.1.219 or EC 2.1.1.220) family profile.', NULL, 'SAM_TRM61', NULL, NULL, 11881, 15),
(283057, NULL, 'PS50292', NULL, NULL, 'Animal heme peroxidase superfamily profile.', NULL, 'PEROXIDASE_3', NULL, NULL, 17272, 15);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(283058, NULL, 'PS51505', NULL, NULL, 'SCA7 domain profile.', NULL, 'SCA7', NULL, NULL, 12761, 15),
(283059, NULL, 'PS51089', NULL, NULL, 'Headpiece (HP) domain profile.', NULL, 'HP', NULL, NULL, 1700, 15),
(283060, NULL, 'PS51491', NULL, NULL, 'Tau and MAP proteins tubulin-binding repeat profile.', NULL, 'TAU_MAP_2', NULL, NULL, 2304, 15),
(283061, NULL, 'PS51370', NULL, NULL, 'R domain profile.', NULL, 'R', NULL, NULL, 7435, 15),
(283062, NULL, 'PS51667', NULL, NULL, 'WRC domain profile.', NULL, 'WRC', NULL, NULL, 14293, 15),
(283063, NULL, 'PS51373', NULL, NULL, 'High potential iron-sulfur proteins family profile.', NULL, 'HIPIP', NULL, NULL, 1772, 15),
(283064, NULL, 'PS50944', NULL, NULL, 'DtxR-type HTH domain profile.', NULL, 'HTH_DTXR', NULL, NULL, 16714, 15),
(283065, NULL, 'PS51657', NULL, NULL, '(+)RNA virus helicase core domain profile.', NULL, 'PSRV_HELICASE', NULL, NULL, 24465, 15),
(283066, NULL, 'PS51665', NULL, NULL, 'Enkurin domain profile.', NULL, 'ENKURIN', NULL, NULL, 24091, 15),
(283067, NULL, 'PS51044', NULL, NULL, 'Zinc finger SP-RING-type profile.', NULL, 'ZF_SP_RING', NULL, NULL, 2874, 15),
(283068, NULL, 'PS50049', NULL, NULL, 'TNF family profile.', NULL, 'TNF_2', NULL, NULL, 2809, 15),
(283069, NULL, 'PS51531', NULL, NULL, 'Foamy virus protease (FV PR) domain profile.', NULL, 'FV_PR', NULL, NULL, 3575, 15),
(283070, NULL, 'PS51935', NULL, NULL, 'NlpC/P60 domain profile.', NULL, 'NLPC_P60', NULL, NULL, 2862, 15),
(283071, NULL, 'PS50237', NULL, NULL, 'HECT domain profile.', NULL, 'HECT', NULL, NULL, 5907, 15),
(283072, NULL, 'PS51975', NULL, NULL, 'Ribonuclease (RNase) H type-2 domain profile.', NULL, 'RNASE_H_2', NULL, NULL, 21554, 15),
(283073, NULL, 'PS51123', NULL, NULL, 'OmpA-like domain profile.', NULL, 'OMPA_2', NULL, NULL, 1786, 15),
(283074, NULL, 'PS51740', NULL, NULL, 'SpoVT-AbrB domain profile.', NULL, 'SPOVT_ABRB', NULL, NULL, 46, 15),
(283075, NULL, 'PS50174', NULL, NULL, 'G-patch domain profile.', NULL, 'G_PATCH', NULL, NULL, 6576, 15),
(283076, NULL, 'PS50855', NULL, NULL, 'Cytochrome oxidase subunit I  profile.', NULL, 'COX1', NULL, NULL, 16106, 15),
(283077, NULL, 'PS50113', NULL, NULL, 'PAC domain profile.', NULL, 'PAC', NULL, NULL, 3651, 15),
(283078, NULL, 'PS50008', NULL, NULL, 'Phosphatidylinositol-specific phospholipase Y-box domain profile.', NULL, 'PIPLC_Y_DOMAIN', NULL, NULL, 3438, 15),
(283079, NULL, 'PS51405', NULL, NULL, 'Heme haloperoxidase family profile.', NULL, 'HEME_HALOPEROXIDASE', NULL, NULL, 3936, 15),
(283080, NULL, 'PS51424', NULL, NULL, 'Roc domain profile.', NULL, 'ROC', NULL, NULL, 20638, 15),
(283081, NULL, 'PS50808', NULL, NULL, 'Zinc finger BED-type profile.', NULL, 'ZF_BED', NULL, NULL, 1334, 15),
(283082, NULL, 'PS51820', NULL, NULL, 'PA14 domain profile.', NULL, 'PA14', NULL, NULL, 27067, 15),
(283083, NULL, 'PS51181', NULL, NULL, 'Phosphatase tensin-type domain profile.', NULL, 'PPASE_TENSIN', NULL, NULL, 26718, 15),
(283084, NULL, 'PS51580', NULL, NULL, 'Histone-lysine N-methyltransferase (EC 2.1.1.43) family profile.', NULL, 'SAM_MT43_3', NULL, NULL, 23132, 15),
(283085, NULL, 'PS51771', NULL, NULL, 'CGT/MARTX cysteine protease (CPD) domain profile.', NULL, 'CGT_MARTX_CPD', NULL, NULL, 14874, 15),
(283086, NULL, 'PS50309', NULL, NULL, 'Doublecortin domain profile.', NULL, 'DC', NULL, NULL, 6945, 15),
(283087, NULL, 'PS50310', NULL, NULL, 'Alanine-rich region profile.', NULL, 'ALA_RICH', NULL, NULL, NULL, 15),
(283088, NULL, 'PS51439', NULL, NULL, 'MENTAL domain profile.', NULL, 'MENTAL', NULL, NULL, 18107, 15),
(283089, NULL, 'PS50042', NULL, NULL, 'cAMP/cGMP binding motif profile.', NULL, 'CNMP_BINDING_3', NULL, NULL, 5904, 15),
(283090, NULL, 'PS50870', NULL, NULL, 'Arfaptin homology (AH) domain profile.', NULL, 'AH', NULL, NULL, 10372, 15),
(283091, NULL, 'PS51583', NULL, NULL, 'Plant LSMT protein-lysine methyltransferase family profile.', NULL, 'SAM_MT127', NULL, NULL, 10511, 15),
(283092, NULL, 'PS50824', NULL, NULL, 'DAPIN domain profile.', NULL, 'DAPIN', NULL, NULL, 996, 15),
(283093, NULL, 'PS50933', NULL, NULL, 'CHRD domain profile.', NULL, 'CHRD', NULL, NULL, 12460, 15);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(283094, NULL, 'PS51200', NULL, NULL, 'Scorpion short toxin chloride channel inhibitor subfamily profile.', NULL, 'SHORT_SCORPION_CHLORIDE', NULL, NULL, 4412, 15),
(283095, NULL, 'PS51286', NULL, NULL, 'RAP domain profile.', NULL, 'RAP', NULL, NULL, 11607, 15),
(283096, NULL, 'PS51030', NULL, NULL, 'Nuclear hormone receptors DNA-binding domain profile.', NULL, 'NUCLEAR_REC_DBD_2', NULL, NULL, 3273, 15),
(283097, NULL, 'PS51103', NULL, NULL, 'PTS_EIIC type-1 domain profile.', NULL, 'PTS_EIIC_TYPE_1', NULL, NULL, 18652, 15),
(283098, NULL, 'PS51347', NULL, NULL, 'Phosphotriesterase family profile.', NULL, 'PHOSPHOTRIESTERASE_2', NULL, NULL, 5123, 15),
(283099, NULL, 'PS50319', NULL, NULL, 'Leucine-rich region profile.', NULL, 'LEU_RICH', NULL, NULL, NULL, 15),
(283100, NULL, 'PS50994', NULL, NULL, 'Integrase catalytic domain profile.', NULL, 'INTEGRASE', NULL, NULL, 5041, 15),
(283101, NULL, 'PS51627', NULL, NULL, 'tRNA methyltransferase 11 (TRM11) (EC 2.1.1.-) family profile.', NULL, 'SAM_MT_TRM11', NULL, NULL, 20023, 15),
(283102, NULL, 'PS51795', NULL, NULL, 'Zinc finger FLZ-type profile.', NULL, 'ZF_FLZ', NULL, NULL, 49, 15),
(283103, NULL, 'PS50175', NULL, NULL, 'Aspartyl protease, retroviral-type family profile.', NULL, 'ASP_PROT_RETROV', NULL, NULL, 2458, 15),
(283104, NULL, 'PS50819', NULL, NULL, 'Intein DOD-type homing endonuclease domain profile.', NULL, 'INTEIN_ENDONUCLEASE', NULL, NULL, 570, 15),
(283105, NULL, 'PS51764', NULL, NULL, 'Glycosyl hydrolases family 26 (GH26) domain profile.', NULL, 'GH26', NULL, NULL, 14586, 15),
(283106, NULL, 'PS51027', NULL, NULL, 'Integrase DNA binding domain profile.', NULL, 'INTEGRASE_DBD', NULL, NULL, 1278, 15),
(283107, NULL, 'PS51440', NULL, NULL, 'Triosephosphate isomerase (TIM) family profile.', NULL, 'TIM_2', NULL, NULL, 4335, 15),
(283108, NULL, 'PS51694', NULL, NULL, 'Peptidase family M66 domain profile.', NULL, 'PEPTIDASE_M66', NULL, NULL, 18442, 15),
(283109, NULL, 'PS51952', NULL, NULL, 'Coronavirus (CoV) ExoN/MTase coactivator domain profile.', NULL, 'COV_EXON_MTASE_COACT', NULL, NULL, 15877, 15),
(283110, NULL, 'PS51140', NULL, NULL, 'CUE domain profile.', NULL, 'CUE', NULL, NULL, 4183, 15),
(283111, NULL, 'PS50052', NULL, NULL, 'Guanylate kinase-like domain profile.', NULL, 'GUANYLATE_KINASE_2', NULL, NULL, 7045, 15),
(283112, NULL, 'PS51433', NULL, NULL, 'Pointed (PNT) domain profile.', NULL, 'PNT', NULL, NULL, 2975, 15),
(283113, NULL, 'PS51249', NULL, NULL, 'Phosphonate import ATP-binding protein phnC.', NULL, 'PHNC', NULL, NULL, NULL, 15),
(283114, NULL, 'PS51803', NULL, NULL, 'Zinc finger C2HC RNF-type profile.', NULL, 'ZF_C2HC_RNF', NULL, NULL, 15248, 15),
(283115, NULL, 'PS51173', NULL, NULL, 'CBM2 (Carbohydrate-binding type-2) domain profile.', NULL, 'CBM2', NULL, NULL, 4103, 15),
(283116, NULL, 'PS51767', NULL, NULL, 'Peptidase family A1 domain profile.', NULL, 'PEPTIDASE_A1', NULL, NULL, 30519, 15),
(283117, NULL, 'PS51896', NULL, NULL, 'Zinc finger C4H2-type profile.', NULL, 'ZF_C4H2', NULL, NULL, 36884, 15),
(283118, NULL, 'PS51398', NULL, NULL, 'PAW domain profile.', NULL, 'PAW', NULL, NULL, 291, 15),
(283119, NULL, 'PS50048', NULL, NULL, 'Zn(2)-C6 fungal-type DNA-binding domain profile.', NULL, 'ZN2_CY6_FUNGAL_2', NULL, NULL, 2419, 15),
(283120, NULL, 'PS51435', NULL, NULL, 'AP endonucleases family 1 profile.', NULL, 'AP_NUCLEASE_F1_4', NULL, NULL, 4158, 15),
(283121, NULL, 'PS51075', NULL, NULL, 'MAD homology domain 1 (MH1) profile.', NULL, 'MH1', NULL, NULL, 11540, 15),
(283122, NULL, 'PS50287', NULL, NULL, 'SRCR domain profile.', NULL, 'SRCR_2', NULL, NULL, 1378, 15),
(283123, NULL, 'PS51810', NULL, NULL, 'Zinc finger CCHC FOG-type profile.', NULL, 'ZF_CCHC_FOG', NULL, NULL, 29437, 15),
(283124, NULL, 'PS50897', NULL, NULL, 'C-terminal to LisH (CTLH) motif profile.', NULL, 'CTLH', NULL, NULL, 1348, 15),
(283125, NULL, 'PS01031', NULL, NULL, 'Small heat shock protein (sHSP) domain profile.', NULL, 'SHSP', NULL, NULL, 5084, 15),
(283126, NULL, 'PS51289', NULL, NULL, 'Cysteine-rich GLG1 repeat profile.', NULL, 'GLG1_C_RICH', NULL, NULL, 18027, 15);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(283127, NULL, 'PS50945', NULL, NULL, 'I/LWEQ domain profile.', NULL, 'I_LWEQ', NULL, NULL, 1690, 15),
(283128, NULL, 'PS51692', NULL, NULL, 'Pestivirus nonstructural protein 2 (NS2) protease domain profile.', NULL, 'PESTIVIRUS_NS2_PRO', NULL, NULL, 24770, 15),
(283129, NULL, 'PS50114', NULL, NULL, 'GATA-type zinc finger domain profile.', NULL, 'GATA_ZN_FINGER_2', NULL, NULL, 3606, 15),
(283130, NULL, 'PS50158', NULL, NULL, 'Zinc finger CCHC-type profile.', NULL, 'ZF_CCHC', NULL, NULL, 4426, 15),
(283131, NULL, 'PS50811', NULL, NULL, 'WRKY domain profile.', NULL, 'WRKY', NULL, NULL, 1228, 15),
(283132, NULL, 'PS50801', NULL, NULL, 'STAS domain profile.', NULL, 'STAS', NULL, NULL, 2727, 15),
(283133, NULL, 'PS51724', NULL, NULL, 'SPOR domain profile.', NULL, 'SPOR', NULL, NULL, 1456, 15),
(283134, NULL, 'PS51009', NULL, NULL, 'Cytochrome c class II profile.', NULL, 'CYTCII', NULL, NULL, 6004, 15),
(283135, NULL, 'PS51360', NULL, NULL, 'Plus3 domain profile.', NULL, 'PLUS3', NULL, NULL, 4630, 15),
(283136, NULL, 'PS50165', NULL, NULL, 'UvrC family, homology region profile.', NULL, 'UVRC', NULL, NULL, 1277, 15),
(283137, NULL, 'PS51255', NULL, NULL, 'ADP-dependent kinase (ADPK) domain profile.', NULL, 'ADPK', NULL, NULL, 147, 15),
(283138, NULL, 'PS50006', NULL, NULL, 'Forkhead-associated (FHA) domain profile.', NULL, 'FHA_DOMAIN', NULL, NULL, 4899, 15),
(283139, NULL, 'PS50125', NULL, NULL, 'Guanylate cyclase domain profile.', NULL, 'GUANYLATE_CYCLASE_2', NULL, NULL, 1287, 15),
(283140, NULL, 'PS51539', NULL, NULL, 'Arterivirus papain-like cysteine protease alpha (PCPalpha) domain profile.', NULL, 'AV_PCP_ALPHA', NULL, NULL, 12188, 15),
(283141, NULL, 'PS51674', NULL, NULL, '4Fe-4S WhiB-like (Wbl)-type iron-sulfur binding domain profile.', NULL, '4FE4S_WBL', NULL, NULL, 21607, 15),
(283142, NULL, 'PS51643', NULL, NULL, 'HD Cas3-type domain profile.', NULL, 'HD_CAS3', NULL, NULL, 6120, 15),
(283143, NULL, 'PS50890', NULL, NULL, 'PUA domain profile.', NULL, 'PUA', NULL, NULL, NULL, 15),
(283144, NULL, 'PS51762', NULL, NULL, 'Glycosyl hydrolases family 16 (GH16) domain profile.', NULL, 'GH16_2', NULL, NULL, 3868, 15),
(283145, NULL, 'PS51442', NULL, NULL, 'Coronavirus main protease (M-pro) domain profile.', NULL, 'M_PRO', NULL, NULL, 12163, 15),
(283146, NULL, 'PS51017', NULL, NULL, 'CCT domain profile.', NULL, 'CCT', NULL, NULL, 9090, 15),
(283147, NULL, 'PS51147', NULL, NULL, 'Protein prenyltransferases alpha subunit repeat profile.', NULL, 'PFTA', NULL, NULL, 5009, 15),
(283148, NULL, 'PS51907', NULL, NULL, 'Zinc finger UBZ3-type profile.', NULL, 'ZF_UBZ3', NULL, NULL, 29059, 15),
(283149, NULL, 'PS50860', NULL, NULL, 'Alanyl-transfer RNA synthetases family profile.', NULL, 'AA_TRNA_LIGASE_II_ALA', NULL, NULL, 7918, 15),
(283150, NULL, 'PS51528', NULL, NULL, 'Flavivirus NS3 protease (NS3pro) domain profile.', NULL, 'FLAVIVIRUS_NS3PRO', NULL, NULL, 4185, 15),
(283151, NULL, 'PS51726', NULL, NULL, 'MYST-type histone acetyltransferase (HAT) domain profile.', NULL, 'MYST_HAT', NULL, NULL, 3734, 15),
(283152, NULL, 'PS51110', NULL, NULL, 'Saposin A-type domain profile.', NULL, 'SAP_A', NULL, NULL, 1591, 15),
(283153, NULL, 'PS50800', NULL, NULL, 'SAP motif profile.', NULL, 'SAP', NULL, NULL, 71, 15),
(283154, NULL, 'PS50050', NULL, NULL, 'TNFR/NGFR family cysteine-rich region domain profile.', NULL, 'TNFR_NGFR_2', NULL, NULL, 2084, 15),
(283155, NULL, 'PS50963', NULL, NULL, 'Link domain profile.', NULL, 'LINK_2', NULL, NULL, 5528, 15),
(283156, NULL, 'PS51848', NULL, NULL, 'bMERB domain profile.', NULL, 'BMERB', NULL, NULL, 14611, 15),
(283157, NULL, 'PS51897', NULL, NULL, 'Annexin repeat profile.', NULL, 'ANNEXIN_2', NULL, NULL, 9057, 15),
(283158, NULL, 'SFLDG01116', NULL, NULL, 'DesII-like', NULL, 'DesII-like', NULL, NULL, NULL, 16),
(283159, NULL, 'SFLDF00270', NULL, NULL, 'L-galactonate dehydratase', NULL, 'L-galactonate_dehydratase', NULL, NULL, NULL, 16),
(283160, NULL, 'SFLDF00111', NULL, NULL, 'L-fuconate dehydratase', NULL, 'L-fuconate_dehydratase', NULL, NULL, 11101, 16),
(283161, NULL, 'SFLDF00552', NULL, NULL, 'xylonate dehydratase 1', NULL, 'xylonate_dehydratase_1', NULL, NULL, NULL, 16);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(283162, NULL, 'SFLDS00057', NULL, NULL, 'Glutaminase/Asparaginase', NULL, 'Glutaminase/Asparaginase', NULL, NULL, NULL, 16),
(283163, NULL, 'SFLDG01091', NULL, NULL, 'uncharacterized CHP01210-like', NULL, 'uncharacterized_CHP01210-like', NULL, NULL, 473, 16),
(283164, NULL, 'SFLDF00516', NULL, NULL, 'thurincin H (ThnB-like)', NULL, 'thurincin_H_(ThnB-like)', NULL, NULL, NULL, 16),
(283165, NULL, 'SFLDF00412', NULL, NULL, 'spore photoproduct lyase 2', NULL, 'spore_photoproduct_lyase_2', NULL, NULL, 9861, 16),
(283166, NULL, 'SFLDF00562', NULL, NULL, 'HemN-like, clustered with heat shock genes', NULL, 'HemN-like,_clustered_with_hea', NULL, NULL, 696, 16),
(283167, NULL, 'SFLDF00379', NULL, NULL, 'Phosphonate metabolism (PhnJ)', NULL, 'Phosphonate_metabolism_(PhnJ)', NULL, NULL, 8263, 16),
(283168, NULL, 'SFLDF00445', NULL, NULL, 'alpha-phosphomannomutase', NULL, 'alpha-phosphomannomutase', NULL, NULL, 639, 16),
(283169, NULL, 'SFLDG01082', NULL, NULL, 'B12-binding domain containing', NULL, 'B12-binding_domain_containing', NULL, NULL, NULL, 16),
(283170, NULL, 'SFLDG00179', NULL, NULL, 'mandelate racemase', NULL, 'mandelate_racemase', NULL, NULL, NULL, 16),
(283171, NULL, 'SFLDG01143', NULL, NULL, 'C2.B.3: Phosphomannomutase Like', NULL, 'C2.B.3:_Phosphomannomutase_Li', NULL, NULL, NULL, 16),
(283172, NULL, 'SFLDG01201', NULL, NULL, 'SUF2.1', NULL, 'SUF2.1', NULL, NULL, NULL, 16),
(283173, NULL, 'SFLDG01084', NULL, NULL, 'Uncharacterised Radical SAM Subgroup 2', NULL, 'Uncharacterised_Radical_SAM_S', NULL, NULL, 28785, 16),
(283174, NULL, 'SFLDG01278', NULL, NULL, 'biotin synthase like', NULL, 'biotin_synthase_like', NULL, NULL, NULL, 16),
(283175, NULL, 'SFLDG01137', NULL, NULL, 'C1.6.1: Phosphoserine Phosphatase Like', NULL, 'C1.6.1:_Phosphoserine_Phospha', NULL, NULL, NULL, 16),
(283176, NULL, 'SFLDF00300', NULL, NULL, '7-carboxy-7-deazaguanine synthase, Cx3CxxC type', NULL, '7-carboxy-7-deazaguanine_synt', NULL, NULL, 18484, 16),
(283177, NULL, 'SFLDF00466', NULL, NULL, 'Pyruvoyl-dependent histidine decarboxylase', NULL, 'Pyruvoyl-dependent_histidine_', NULL, NULL, 5098, 16),
(283178, NULL, 'SFLDF00348', NULL, NULL, '[FeFe] hydrogenase maturase (HydE-like)', NULL, '[FeFe]_hydrogenase_maturase_(', NULL, NULL, 15082, 16),
(283179, NULL, 'SFLDS00070', NULL, NULL, 'SPOUT Methyltransferase', NULL, 'SPOUT_Methyltransferase', NULL, NULL, NULL, 16),
(283180, NULL, 'SFLDG01123', NULL, NULL, 'methyltransferase (Class B)', NULL, 'methyltransferase_(Class_B)', NULL, NULL, 20446, 16),
(283181, NULL, 'SFLDG01180', NULL, NULL, 'SUF1', NULL, 'SUF1', NULL, NULL, NULL, 16),
(283182, NULL, 'SFLDF00154', NULL, NULL, 'N-succinylamino acid racemase 2', NULL, 'N-succinylamino_acid_racemase', NULL, NULL, NULL, 16),
(283183, NULL, 'SFLDF00162', NULL, NULL, 'galactarate dehydratase 2', NULL, 'galactarate_dehydratase_2', NULL, NULL, 29403, 16),
(283184, NULL, 'SFLDG01144', NULL, NULL, 'C2.B.4: PGP Like', NULL, 'C2.B.4:_PGP_Like', NULL, NULL, NULL, 16),
(283185, NULL, 'SFLDG01388', NULL, NULL, '7,8-didemethyl-8-hydroxy-5-deazariboflavin synthase', NULL, '7,8-didemethyl-8-hydroxy-5-de', NULL, NULL, NULL, 16),
(283186, NULL, 'SFLDF00006', NULL, NULL, 'rhamnonate dehydratase', NULL, 'rhamnonate_dehydratase', NULL, NULL, 16222, 16),
(283187, NULL, 'SFLDS00001', NULL, NULL, 'Enolase', NULL, 'Enolase', NULL, NULL, NULL, 16),
(283188, NULL, 'SFLDF00407', NULL, NULL, 'phosphomethylpyrimidine synthase (ThiC)', NULL, 'phosphomethylpyrimidine_synth', NULL, NULL, 4807, 16),
(283189, NULL, 'SFLDF00553', NULL, NULL, 'galactarolactone cycloisomerase', NULL, 'galactarolactone_cycloisomera', NULL, NULL, 1347, 16),
(283190, NULL, 'SFLDF00276', NULL, NULL, 'cyclic pyranopterin phosphate synthase (MoaA-like)', NULL, 'cyclic_pyranopterin_phosphate', NULL, NULL, NULL, 16),
(283191, NULL, 'SFLDF00414', NULL, NULL, 'bacteriochlorophyll C12 methyltransferase', NULL, 'bacteriochlorophyll_C12_methy', NULL, NULL, 8661, 16),
(283192, NULL, 'SFLDG01142', NULL, NULL, 'C2.B.2: Mannosyl-3-phosphoglycerate Phosphatase Like', NULL, 'C2.B.2:_Mannosyl-3-phosphogly', NULL, NULL, 5994, 16); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(283193, NULL, 'SFLDG01387', NULL, NULL, 'BtrN-like SPASM domain containing', NULL, 'BtrN-like_SPASM_domain_contai', NULL, NULL, 30125, 16),
(283194, NULL, 'SFLDF00291', NULL, NULL, 'arginine 2,3-aminomutase', NULL, 'arginine_2,3-aminomutase', NULL, NULL, 25848, 16),
(283195, NULL, 'SFLDF00347', NULL, NULL, 'KxxxW cyclic peptide maturase (StrB-like)', NULL, 'KxxxW_cyclic_peptide_maturase', NULL, NULL, 11614, 16),
(283196, NULL, 'SFLDG01015', NULL, NULL, 'Prenyltransferase Like 1', NULL, 'Prenyltransferase_Like_1', NULL, NULL, NULL, 16),
(283197, NULL, 'SFLDG00055', NULL, NULL, 'glucarate dehydratase', NULL, 'glucarate_dehydratase', NULL, NULL, NULL, 16),
(283198, NULL, 'SFLDG01018', NULL, NULL, 'Squalene/Phytoene Synthase Like', NULL, 'Squalene/Phytoene_Synthase_Li', NULL, NULL, 5146, 16),
(283199, NULL, 'SFLDG01052', NULL, NULL, 'RuBisCO', NULL, 'RuBisCO', NULL, NULL, NULL, 16),
(283200, NULL, 'SFLDF00563', NULL, NULL, 'galactarate dehydratase 3', NULL, 'galactarate_dehydratase_3', NULL, NULL, 5715, 16),
(283201, NULL, 'SFLDG01130', NULL, NULL, 'C1.5.1: Epoxide Hydrolase Phosphatase Like', NULL, 'C1.5.1:_Epoxide_Hydrolase_Pho', NULL, NULL, NULL, 16),
(283202, NULL, 'SFLDG00301', NULL, NULL, 'RuBisCO-like proteins', NULL, 'RuBisCO-like_proteins', NULL, NULL, NULL, 16),
(283203, NULL, 'SFLDF00036', NULL, NULL, 'deoxy-d-mannose-octulosonate 8-phosphate phosphatase', NULL, 'deoxy-d-mannose-octulosonate_', NULL, NULL, NULL, 16),
(283204, NULL, 'SFLDF00555', NULL, NULL, 'cis-3-hydroxy-L-proline dehydratase', NULL, 'cis-3-hydroxy-L-proline_dehyd', NULL, NULL, 1224, 16),
(283205, NULL, 'SFLDF00438', NULL, NULL, 'pactamycin methyltransferase (PctO-like)', NULL, 'pactamycin_methyltransferase_', NULL, NULL, NULL, 16),
(283206, NULL, 'SFLDG01140', NULL, NULL, 'C2.B: Phosphomannomutase and Phosphatase Like', NULL, 'C2.B:_Phosphomannomutase_and_', NULL, NULL, NULL, 16),
(283207, NULL, 'SFLDG01203', NULL, NULL, 'Prostaglandin E synthase like.1', NULL, 'Prostaglandin_E_synthase_like', NULL, NULL, 20035, 16),
(283208, NULL, 'SFLDF00408', NULL, NULL, 'Diphthamide biosynthesis family (Dph2)', NULL, 'Diphthamide_biosynthesis_fami', NULL, NULL, NULL, 16),
(283209, NULL, 'SFLDF00556', NULL, NULL, '4R-hydroxyproline betaine 2-epimerase', NULL, '4R-hydroxyproline_betaine_2-e', NULL, NULL, 1758, 16),
(283210, NULL, 'SFLDF00557', NULL, NULL, '3,6-anhydro-alpha-L-galactonate cycloisomerase', NULL, '3,6-anhydro-alpha-L-galactona', NULL, NULL, 14363, 16),
(283211, NULL, 'SFLDG00358', NULL, NULL, 'Main (cytGST)', NULL, 'Main_(cytGST)', NULL, NULL, NULL, 16),
(283212, NULL, 'SFLDF00302', NULL, NULL, 'anaerobic magnesium-protoporphyrin-IX monomethyl ester cyclase', NULL, 'anaerobic_magnesium-protoporp', NULL, NULL, NULL, 16),
(283213, NULL, 'SFLDF00425', NULL, NULL, 'dTDP-4-amino-4,6-dideoxy-D-glucose ammonia-lyase (DesII-like)', NULL, 'dTDP-4-amino-4,6-dideoxy-D-gl', NULL, NULL, 16180, 16),
(283214, NULL, 'SFLDG00151', NULL, NULL, 'methylaspartate ammonia-lyase', NULL, 'methylaspartate_ammonia-lyase', NULL, NULL, NULL, 16),
(283215, NULL, 'SFLDG01063', NULL, NULL, 'activating enzymes, group 1', NULL, 'activating_enzymes,_group_1', NULL, NULL, NULL, 16),
(283216, NULL, 'SFLDF00430', NULL, NULL, 'OxsB-like', NULL, 'OxsB-like', NULL, NULL, 7046, 16),
(283217, NULL, 'SFLDF00342', NULL, NULL, 'cyclic dehypoxanthine futalosine synthase (mqnC-like)', NULL, 'cyclic_dehypoxanthine_futalos', NULL, NULL, NULL, 16),
(283218, NULL, 'SFLDG01135', NULL, NULL, 'C1.5.6: HAD, Beta-PGM, Phosphatase Like', NULL, 'C1.5.6:_HAD,_Beta-PGM,_Phosph', NULL, NULL, NULL, 16),
(283219, NULL, 'SFLDF00464', NULL, NULL, 'Ferric/cupric reductase', NULL, 'Ferric/cupric_reductase', NULL, NULL, NULL, 16),
(283220, NULL, 'SFLDG00180', NULL, NULL, 'muconate cycloisomerase', NULL, 'muconate_cycloisomerase', NULL, NULL, NULL, 16),
(283221, NULL, 'SFLDF00043', NULL, NULL, 'sucrose-phosphatase', NULL, 'sucrose-phosphatase', NULL, NULL, NULL, 16),
(283222, NULL, 'SFLDG01071', NULL, NULL, 'tRNA wybutosine-synthesizing', NULL, 'tRNA_wybutosine-synthesizing', NULL, NULL, NULL, 16);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(283223, NULL, 'SFLDG01170', NULL, NULL, 'Pyruvoyl-dependent arginine decarboxylase', NULL, 'Pyruvoyl-dependent_arginine_d', NULL, NULL, 3752, 16),
(283224, NULL, 'SFLDF00421', NULL, NULL, 'avilamycin epimerase', NULL, 'avilamycin_epimerase', NULL, NULL, 28520, 16),
(283225, NULL, 'SFLDG01107', NULL, NULL, 'Uncharacterised Radical SAM Subgroup 20', NULL, 'Uncharacterised_Radical_SAM_S', NULL, NULL, 15500, 16),
(283226, NULL, 'SFLDF00343', NULL, NULL, 'aminofutalosine synthase (mqnE-like)', NULL, 'aminofutalosine_synthase_(mqn', NULL, NULL, 11687, 16),
(283227, NULL, 'SFLDF00277', NULL, NULL, 'oxygen-independent coproporphyrinogen-III oxidase 1 (HemN-like)', NULL, 'oxygen-independent_coproporph', NULL, NULL, 4286, 16),
(283228, NULL, 'SFLDG01069', NULL, NULL, 'UPF0313', NULL, 'UPF0313', NULL, NULL, 14517, 16),
(283229, NULL, 'SFLDG01200', NULL, NULL, 'SUF1.1', NULL, 'SUF1.1', NULL, NULL, 26639, 16),
(283230, NULL, 'SFLDF00001', NULL, NULL, 'mannonate dehydratase', NULL, 'mannonate_dehydratase', NULL, NULL, 9723, 16),
(283231, NULL, 'SFLDG01171', NULL, NULL, 'Pyruvoyl-dependent histidine decarboxylase', NULL, 'Pyruvoyl-dependent_histidine_', NULL, NULL, NULL, 16),
(283232, NULL, 'SFLDF00158', NULL, NULL, '5-methylthio-D-ribulose 1-phosphate isomerase', NULL, '5-methylthio-D-ribulose_1-pho', NULL, NULL, NULL, 16),
(283233, NULL, 'SFLDF00517', NULL, NULL, 'cytosylglucuronate decarboxylase', NULL, 'cytosylglucuronate_decarboxyl', NULL, NULL, 25518, 16),
(283234, NULL, 'SFLDG01124', NULL, NULL, 'C0.1: RNA Pol CTD Phosphatase Like', NULL, 'C0.1:_RNA_Pol_CTD_Phosphatase', NULL, NULL, 31058, 16),
(283235, NULL, 'SFLDF00003', NULL, NULL, 'D-galactonate dehydratase', NULL, 'D-galactonate_dehydratase', NULL, NULL, 16422, 16),
(283236, NULL, 'SFLDF00004', NULL, NULL, 'mandelate racemase', NULL, 'mandelate_racemase', NULL, NULL, 17747, 16),
(283237, NULL, 'SFLDF00280', NULL, NULL, 'coenzyme PQQ synthesis protein E (PqqE-like)', NULL, 'coenzyme_PQQ_synthesis_protei', NULL, NULL, 13521, 16),
(283238, NULL, 'SFLDF00545', NULL, NULL, 'cyclopropanase', NULL, 'cyclopropanase', NULL, NULL, NULL, 16),
(283239, NULL, 'SFLDS00052', NULL, NULL, 'Ferric Reductase Domain', NULL, 'Ferric_Reductase_Domain', NULL, NULL, NULL, 16),
(283240, NULL, 'SFLDF00413', NULL, NULL, 'CDK5RAP1', NULL, 'CDK5RAP1', NULL, NULL, NULL, 16),
(283241, NULL, 'SFLDG01182', NULL, NULL, 'Prostaglandin E synthase like', NULL, 'Prostaglandin_E_synthase_like', NULL, NULL, NULL, 16),
(283242, NULL, 'SFLDF00542', NULL, NULL, 'alternative heme biosynthesis D (AhbD-like)', NULL, 'alternative_heme_biosynthesis', NULL, NULL, 25030, 16),
(283243, NULL, 'SFLDF00402', NULL, NULL, 'carbapenem intermediate methyltransferase (ThnP-like)', NULL, 'carbapenem_intermediate_methy', NULL, NULL, 28643, 16),
(283244, NULL, 'SFLDS00033', NULL, NULL, 'Radical SAM Phosphonate Metabolism', NULL, 'Radical_SAM_Phosphonate_Metab', NULL, NULL, NULL, 16),
(283245, NULL, 'SFLDG01100', NULL, NULL, 'methyltransferase (Class D)', NULL, 'methyltransferase_(Class_D)', NULL, NULL, 20458, 16),
(283246, NULL, 'SFLDF00008', NULL, NULL, 'gluconate dehydratase', NULL, 'gluconate_dehydratase', NULL, NULL, 9852, 16),
(283247, NULL, 'SFLDF00349', NULL, NULL, '3-methylornithine synthase (PylB-like)', NULL, '3-methylornithine_synthase_(P', NULL, NULL, 8225, 16),
(283248, NULL, 'SFLDG01067', NULL, NULL, 'SPASM/twitch domain containing', NULL, 'SPASM/twitch_domain_containin', NULL, NULL, NULL, 16),
(283249, NULL, 'SFLDF00423', NULL, NULL, 'chondrochloren A methyltransferase (CndI-like)', NULL, 'chondrochloren_A_methyltransf', NULL, NULL, 31188, 16),
(283250, NULL, 'SFLDS00014', NULL, NULL, 'RuBisCO', NULL, 'RuBisCO', NULL, NULL, 29493, 16),
(283251, NULL, 'SFLDS00003', NULL, NULL, 'Haloacid Dehalogenase', NULL, 'Haloacid_Dehalogenase', NULL, NULL, NULL, 16),
(283252, NULL, 'SFLDF00118', NULL, NULL, 'D-tartrate dehydratase', NULL, 'D-tartrate_dehydratase', NULL, NULL, 11490, 16),
(283253, NULL, 'SFLDF00403', NULL, NULL, 'phosphonoacetaldehyde methylase (fom3-like)', NULL, 'phosphonoacetaldehyde_methyla', NULL, NULL, 6734, 16);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(283254, NULL, 'SFLDG01095', NULL, NULL, 'Uncharacterised Radical SAM Subgroup 7', NULL, 'Uncharacterised_Radical_SAM_S', NULL, NULL, NULL, 16),
(283255, NULL, 'SFLDF00306', NULL, NULL, 'carbapenem intermediate methyltransferase (ThnL-like)', NULL, 'carbapenem_intermediate_methy', NULL, NULL, 29131, 16),
(283256, NULL, 'SFLDG01129', NULL, NULL, 'C1.5: HAD, Beta-PGM, Phosphatase Like', NULL, 'C1.5:_HAD,_Beta-PGM,_Phosphat', NULL, NULL, NULL, 16),
(283257, NULL, 'SFLDG01280', NULL, NULL, 'HydE/PylB-like', NULL, 'HydE/PylB-like', NULL, NULL, NULL, 16),
(283258, NULL, 'SFLDF00392', NULL, NULL, 'YjjI activase', NULL, 'YjjI_activase', NULL, NULL, 18066, 16),
(283259, NULL, 'SFLDG01146', NULL, NULL, 'C1.2.2', NULL, 'C1.2.2', NULL, NULL, NULL, 16),
(283260, NULL, 'SFLDF00404', NULL, NULL, 'hopanetetrol cyclitol ether synthase', NULL, 'hopanetetrol_cyclitol_ether_s', NULL, NULL, 19521, 16),
(283261, NULL, 'SFLDG01181', NULL, NULL, 'SUF2', NULL, 'SUF2', NULL, NULL, NULL, 16),
(283262, NULL, 'SFLDG00010', NULL, NULL, 'C1.8: polynucleotide 5''-hydroxyl-kinase c-terminal phosphatase like', NULL, 'C1.8:_polynucleotide_5''-hydro', NULL, NULL, 34560, 16),
(283263, NULL, 'SFLDF00424', NULL, NULL, '2-deoxy-scyllo-inosamine dehydrogenase (BtrN-like)', NULL, '2-deoxy-scyllo-inosamine_dehy', NULL, NULL, 31470, 16),
(283264, NULL, 'SFLDF00272', NULL, NULL, 'biotin synthase', NULL, 'biotin_synthase', NULL, NULL, 13344, 16),
(283265, NULL, 'SFLDG01102', NULL, NULL, 'Uncharacterised Radical SAM Subgroup 15', NULL, 'Uncharacterised_Radical_SAM_S', NULL, NULL, 16938, 16),
(283266, NULL, 'SFLDF00416', NULL, NULL, 'fortimicin-like methyltransferase', NULL, 'fortimicin-like_methyltransfe', NULL, NULL, NULL, 16),
(283267, NULL, 'SFLDG01061', NULL, NULL, 'methylthiotransferase', NULL, 'methylthiotransferase', NULL, NULL, 5825, 16),
(283268, NULL, 'SFLDF00157', NULL, NULL, '2,3-diketo-5-methylthiopentyl-1-phosphate enolase', NULL, '2,3-diketo-5-methylthiopentyl', NULL, NULL, 17555, 16),
(283269, NULL, 'SFLDF00285', NULL, NULL, 'anaerobic Ser-type sulfatase-maturating enzyme', NULL, 'anaerobic_Ser-type_sulfatase-', NULL, NULL, 8596, 16),
(283270, NULL, 'SFLDG01064', NULL, NULL, 'F420, menaquinone cofactor biosynthesis', NULL, 'F420,_menaquinone_cofactor_bi', NULL, NULL, NULL, 16),
(283271, NULL, 'SFLDG01019', NULL, NULL, 'Terpene Cyclase Like 1 C Terminal Domain', NULL, 'Terpene_Cyclase_Like_1_C_Term', NULL, NULL, 8060, 16),
(283272, NULL, 'SFLDS00113', NULL, NULL, 'Radical SAM Phosphomethylpyrimidine Synthase', NULL, 'Radical_SAM_Phosphomethylpyri', NULL, NULL, NULL, 16),
(283273, NULL, 'SFLDF00040', NULL, NULL, 'epoxide hydrolase n-terminal phosphatase', NULL, 'epoxide_hydrolase_n-terminal_', NULL, NULL, NULL, 16),
(283274, NULL, 'SFLDF00279', NULL, NULL, '4-hydroxyphenylacetate decarboxylase activase', NULL, '4-hydroxyphenylacetate_decarb', NULL, NULL, 6935, 16),
(283275, NULL, 'SFLDG01113', NULL, NULL, 'Uncharacterised Radical SAM Subgroup 4', NULL, 'Uncharacterised_Radical_SAM_S', NULL, NULL, NULL, 16),
(283276, NULL, 'SFLDF00045', NULL, NULL, '2-haloacid dehalogenase', NULL, '2-haloacid_dehalogenase', NULL, NULL, NULL, 16),
(283277, NULL, 'SFLDG01060', NULL, NULL, 'BATS domain containing', NULL, 'BATS_domain_containing', NULL, NULL, NULL, 16),
(283278, NULL, 'SFLDF00554', NULL, NULL, 'L-lyxonate dehydratase', NULL, 'L-lyxonate_dehydratase', NULL, NULL, 1015, 16),
(283279, NULL, 'SFLDG01110', NULL, NULL, 'Uncharacterised Radical SAM Subgroup 8', NULL, 'Uncharacterised_Radical_SAM_S', NULL, NULL, 31134, 16),
(283280, NULL, 'SFLDF00035', NULL, NULL, 'phosphoglycolate phosphatase', NULL, 'phosphoglycolate_phosphatase', NULL, NULL, NULL, 16),
(283281, NULL, 'SFLDG01058', NULL, NULL, 'lipoyl synthase like', NULL, 'lipoyl_synthase_like', NULL, NULL, NULL, 16),
(283282, NULL, 'SFLDF00284', NULL, NULL, 'tRNA wybutosine-synthesizing', NULL, 'tRNA_wybutosine-synthesizing', NULL, NULL, 9223, 16),
(283283, NULL, 'SFLDF00432', NULL, NULL, 'pyrimidine ring methyltransferase (bleomycin-like antibiotic biosynthesis)', NULL, 'pyrimidine_ring_methyltransfe', NULL, NULL, 72, 16);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(283284, NULL, 'SFLDF00329', NULL, NULL, 'gentamicin-like N-methyltransferase  (GntE-like)', NULL, 'gentamicin-like_N-methyltrans', NULL, NULL, 29317, 16),
(283285, NULL, 'SFLDF00546', NULL, NULL, 'neomycin C-like epimerase', NULL, 'neomycin_C-like_epimerase', NULL, NULL, NULL, 16),
(283286, NULL, 'SFLDF00365', NULL, NULL, 'thuricin CD (TrnCD-like)', NULL, 'thuricin_CD_(TrnCD-like)', NULL, NULL, NULL, 16),
(283287, NULL, 'SFLDF00439', NULL, NULL, 'methylation of yatakemycin (YTK)', NULL, 'methylation_of_yatakemycin_(Y', NULL, NULL, 7298, 16),
(283288, NULL, 'SFLDF00336', NULL, NULL, 'quinohemoprotein amine dehydrogenase maturation protein (QhpD-like)', NULL, 'quinohemoprotein_amine_dehydr', NULL, NULL, 18007, 16),
(283289, NULL, 'SFLDF00046', NULL, NULL, 'beta-phosphoglucomutase', NULL, 'beta-phosphoglucomutase', NULL, NULL, NULL, 16),
(283290, NULL, 'SFLDF00155', NULL, NULL, 'muconate cycloisomerase (anti)', NULL, 'muconate_cycloisomerase_(anti', NULL, NULL, 11981, 16),
(283291, NULL, 'SFLDG01114', NULL, NULL, 'phosphomethylpyrimidine synthase (ThiC)', NULL, 'phosphomethylpyrimidine_synth', NULL, NULL, NULL, 16),
(283292, NULL, 'SFLDG01072', NULL, NULL, 'dehydrogenase like', NULL, 'dehydrogenase_like', NULL, NULL, NULL, 16),
(283293, NULL, 'SFLDG01217', NULL, NULL, 'B12-binding methylthiotransferase like', NULL, 'B12-binding_methylthiotransfe', NULL, NULL, 11435, 16),
(283294, NULL, 'SFLDF00044', NULL, NULL, 'enolase-phosphatase', NULL, 'enolase-phosphatase', NULL, NULL, 10362, 16),
(283295, NULL, 'SFLDF00314', NULL, NULL, 'L-lysine 2,3-aminomutase (yjeK like)', NULL, 'L-lysine_2,3-aminomutase_(yje', NULL, NULL, 15575, 16),
(283296, NULL, 'SFLDF00116', NULL, NULL, 'N-succinylamino acid racemase', NULL, 'N-succinylamino_acid_racemase', NULL, NULL, NULL, 16),
(283297, NULL, 'SFLDF00463', NULL, NULL, 'AIM14', NULL, 'AIM14', NULL, NULL, NULL, 16),
(283298, NULL, 'SFLDG01099', NULL, NULL, 'Uncharacterised Radical SAM Subgroup 12', NULL, 'Uncharacterised_Radical_SAM_S', NULL, NULL, 28952, 16),
(283299, NULL, 'SFLDG01205', NULL, NULL, 'AMPS.1', NULL, 'AMPS.1', NULL, NULL, NULL, 16),
(283300, NULL, 'SFLDF00042', NULL, NULL, 'mannosyl-3-phosphoglycerate phosphatase', NULL, 'mannosyl-3-phosphoglycerate_p', NULL, NULL, NULL, 16),
(283301, NULL, 'SFLDG01122', NULL, NULL, 'methyltransferase (class C)', NULL, 'methyltransferase_(class_C)', NULL, NULL, NULL, 16),
(283302, NULL, 'SFLDF00429', NULL, NULL, 'UDP-N-acetyl-tunicamine-uracil synthase (TunB-like)', NULL, 'UDP-N-acetyl-tunicamine-uraci', NULL, NULL, 29495, 16),
(283303, NULL, 'SFLDG01109', NULL, NULL, 'Uncharacterised Radical SAM Subgroup 22', NULL, 'Uncharacterised_Radical_SAM_S', NULL, NULL, NULL, 16),
(283304, NULL, 'SFLDF00298', NULL, NULL, 'glycerol dehydratase activase', NULL, 'glycerol_dehydratase_activase', NULL, NULL, 28861, 16),
(283305, NULL, 'SFLDF00002', NULL, NULL, 'enolase', NULL, 'enolase', NULL, NULL, 3263, 16),
(283306, NULL, 'SFLDF00318', NULL, NULL, 'Viperin', NULL, 'Viperin', NULL, NULL, NULL, 16),
(283307, NULL, 'SFLDF00397', NULL, NULL, 'adenosyl-hopene transferase', NULL, 'adenosyl-hopene_transferase', NULL, NULL, 19945, 16),
(283308, NULL, 'SFLDG01103', NULL, NULL, 'Uncharacterised Radical SAM Subgroup 16', NULL, 'Uncharacterised_Radical_SAM_S', NULL, NULL, 8130, 16),
(283309, NULL, 'SFLDF00299', NULL, NULL, 'anaerobic ribonucleoside-triphosphate reductase activase', NULL, 'anaerobic_ribonucleoside-trip', NULL, NULL, 12866, 16),
(283310, NULL, 'SFLDF00446', NULL, NULL, 'phosphoglycolate phosphatase 3', NULL, 'phosphoglycolate_phosphatase_', NULL, NULL, NULL, 16),
(283311, NULL, 'SFLDF00271', NULL, NULL, 'lipoyl synthase', NULL, 'lipoyl_synthase', NULL, NULL, 2415, 16),
(283312, NULL, 'SFLDF00005', NULL, NULL, 'glucarate dehydratase', NULL, 'glucarate_dehydratase', NULL, NULL, 9508, 16),
(283313, NULL, 'SFLDG00178', NULL, NULL, 'enolase', NULL, 'enolase', NULL, NULL, NULL, 16),
(283314, NULL, 'SFLDG01145', NULL, NULL, 'C1.2.1', NULL, 'C1.2.1', NULL, NULL, NULL, 16),
(283315, NULL, 'SFLDF00281', NULL, NULL, 'FeMo cofactor biosynthesis protein (nifB-like)', NULL, 'FeMo_cofactor_biosynthesis_pr', NULL, NULL, NULL, 16);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(283316, NULL, 'SFLDF00434', NULL, NULL, '3-methyl-2-indolic acid methyltransferase (NocN/NosN like)', NULL, '3-methyl-2-indolic_acid_methy', NULL, NULL, 6397, 16),
(283317, NULL, 'SFLDF00565', NULL, NULL, 'hopanoid C3-methyltransferase (HpnR-like)', NULL, 'hopanoid_C3-methyltransferase', NULL, NULL, 23310, 16),
(283318, NULL, 'SFLDF00275', NULL, NULL, 'adenosine C2 methyltransferase (RlmN-like)', NULL, 'adenosine_C2_methyltransferas', NULL, NULL, 5864, 16),
(283319, NULL, 'SFLDF00418', NULL, NULL, 'pactamycin C-methyltransferase (PctN-like)', NULL, 'pactamycin_C-methyltransferas', NULL, NULL, NULL, 16),
(283320, NULL, 'SFLDG01020', NULL, NULL, 'Terpene Cyclase Like 2', NULL, 'Terpene_Cyclase_Like_2', NULL, NULL, 32334, 16),
(283321, NULL, 'SFLDF00303', NULL, NULL, 'hopanoid C2-methyltransferase (HpnP-like)', NULL, 'hopanoid_C2-methyltransferase', NULL, NULL, 6514, 16),
(283322, NULL, 'SFLDF00037', NULL, NULL, 'glycerol-3-phosphate phosphatase', NULL, 'glycerol-3-phosphate_phosphat', NULL, NULL, NULL, 16),
(283323, NULL, 'SFLDG01141', NULL, NULL, 'C2.B.1: Sucrose Phosphatase Like', NULL, 'C2.B.1:_Sucrose_Phosphatase_L', NULL, NULL, NULL, 16),
(283324, NULL, 'SFLDG00002', NULL, NULL, 'C1.7: P-type atpase like', NULL, 'C1.7:_P-type_atpase_like', NULL, NULL, NULL, 16),
(283325, NULL, 'SFLDG01125', NULL, NULL, 'C1.1: Acid Phosphatase Like', NULL, 'C1.1:_Acid_Phosphatase_Like', NULL, NULL, 6504, 16),
(283326, NULL, 'SFLDG01154', NULL, NULL, 'Main.5: Phi-like', NULL, 'Main.5:_Phi-like', NULL, NULL, NULL, 16),
(283327, NULL, 'SFLDF00009', NULL, NULL, 'o-succinylbenzoate synthase', NULL, 'o-succinylbenzoate_synthase', NULL, NULL, NULL, 16),
(283328, NULL, 'SFLDF00039', NULL, NULL, 'phosphoglycolate phosphatase 2', NULL, 'phosphoglycolate_phosphatase_', NULL, NULL, NULL, 16),
(283329, NULL, 'SFLDF00010', NULL, NULL, 'dipeptide epimerase', NULL, 'dipeptide_epimerase', NULL, NULL, 10541, 16),
(283330, NULL, 'SFLDF00344', NULL, NULL, 'ELP3-like', NULL, 'ELP3-like', NULL, NULL, 32233, 16),
(283331, NULL, 'SFLDG01062', NULL, NULL, 'methyltransferase (Class A)', NULL, 'methyltransferase_(Class_A)', NULL, NULL, NULL, 16),
(283332, NULL, 'SFLDG01153', NULL, NULL, 'Main.4: Theta-like', NULL, 'Main.4:_Theta-like', NULL, NULL, NULL, 16),
(283333, NULL, 'SFLDG01133', NULL, NULL, 'C1.5.4: Enolase-phosphatase Like', NULL, 'C1.5.4:_Enolase-phosphatase_L', NULL, NULL, NULL, 16),
(283334, NULL, 'SFLDF00420', NULL, NULL, 'spectinomycin biosynthesis (SpcY-like)', NULL, 'spectinomycin_biosynthesis_(S', NULL, NULL, NULL, 16),
(283335, NULL, 'SFLDG01169', NULL, NULL, 'NADPH oxidase subgroup (NOX)', NULL, 'NADPH_oxidase_subgroup_(NOX)', NULL, NULL, NULL, 16),
(283336, NULL, 'SFLDF00316', NULL, NULL, 'C-terminal tyrosine decarboxylase (MftC-like)', NULL, 'C-terminal_tyrosine_decarboxy', NULL, NULL, 18021, 16),
(283337, NULL, 'SFLDG01014', NULL, NULL, 'Terpene Cyclase Like 1 N-term', NULL, 'Terpene_Cyclase_Like_1_N-term', NULL, NULL, NULL, 16),
(283338, NULL, 'SFLDF00007', NULL, NULL, 'methylaspartate ammonia-lyase', NULL, 'methylaspartate_ammonia-lyase', NULL, NULL, 5706, 16),
(283339, NULL, 'SFLDS00029', NULL, NULL, 'Radical SAM', NULL, 'Radical_SAM', NULL, NULL, 1016, 16),
(283340, NULL, 'SFLDG00033', NULL, NULL, 'mannonate dehydratase', NULL, 'mannonate_dehydratase', NULL, NULL, 9818, 16),
(283341, NULL, 'SFLDF00296', NULL, NULL, 'adenosine C8 methyltransferase (Cfr-like)', NULL, 'adenosine_C8_methyltransferas', NULL, NULL, 17412, 16),
(283342, NULL, 'SFLDF00301', NULL, NULL, '2-iminoacetate synthase (ThiH)', NULL, '2-iminoacetate_synthase_(ThiH', NULL, NULL, 11514, 16),
(283343, NULL, 'SFLDG01127', NULL, NULL, 'C1.3: Acid Phosphatase Like', NULL, 'C1.3:_Acid_Phosphatase_Like', NULL, NULL, 5238, 16),
(283344, NULL, 'SFLDF00330', NULL, NULL, 'HMD cofactor maturase (HmdB-like)', NULL, 'HMD_cofactor_maturase_(HmdB-l', NULL, NULL, 17759, 16),
(283345, NULL, 'SFLDG01216', NULL, NULL, 'thioether bond formation requiring one auxiliary iron-sulfur cluster', NULL, 'thioether_bond_formation_requ', NULL, NULL, NULL, 16),
(283346, NULL, 'SFLDF00393', NULL, NULL, 'heme D1 biosynthesis (NirJ-like)', NULL, 'heme_D1_biosynthesis_(NirJ-li', NULL, NULL, 18413, 16);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(283347, NULL, 'SFLDF00385', NULL, NULL, '7,8-dihydro-6-hydroxymethylpterin dimethylase', NULL, '7,8-dihydro-6-hydroxymethylpt', NULL, NULL, 20213, 16),
(283348, NULL, 'SFLDG01131', NULL, NULL, 'C1.5.2: MDP Like', NULL, 'C1.5.2:_MDP_Like', NULL, NULL, NULL, 16),
(283349, NULL, 'SFLDG01163', NULL, NULL, 'II', NULL, 'II', NULL, NULL, 15779, 16),
(283350, NULL, 'SFLDF00376', NULL, NULL, '7-carboxy-7-deazaguanine synthase, Cx14CxxC type', NULL, '7-carboxy-7-deazaguanine_synt', NULL, NULL, 24004, 16),
(283351, NULL, 'SFLDG01139', NULL, NULL, 'C2.A: Pyridoxal Phosphate Phosphatase Like', NULL, 'C2.A:_Pyridoxal_Phosphate_Pho', NULL, NULL, NULL, 16),
(283352, NULL, 'SFLDF00422', NULL, NULL, 'valine cyclopropanase', NULL, 'valine_cyclopropanase', NULL, NULL, NULL, 16),
(283353, NULL, 'SFLDG01118', NULL, NULL, 'activating enzymes, group 2', NULL, 'activating_enzymes,_group_2', NULL, NULL, 31456, 16),
(283354, NULL, 'SFLDG01162', NULL, NULL, 'I', NULL, 'I_', NULL, NULL, NULL, 16),
(283355, NULL, 'SFLDG01212', NULL, NULL, 'Phytoene synthase like', NULL, 'Phytoene_synthase_like', NULL, NULL, 34449, 16),
(283356, NULL, 'SFLDF00543', NULL, NULL, 'alternative heme biosynthesis C (AhbC-like)', NULL, 'alternative_heme_biosynthesis', NULL, NULL, 20859, 16),
(283357, NULL, 'SFLDF00435', NULL, NULL, 'carbapenem intermediate methyltransferase (ThnK-like)', NULL, 'carbapenem_intermediate_methy', NULL, NULL, 29360, 16),
(283358, NULL, 'SFLDG01132', NULL, NULL, 'C1.5.3: 5''-Nucleotidase Like', NULL, 'C1.5.3:_5''-Nucleotidase_Like', NULL, NULL, 4003, 16),
(283359, NULL, 'SFLDS00032', NULL, NULL, 'Radical SAM 3-amino-3-carboxypropyl Radical Forming', NULL, 'Radical_SAM_3-amino-3-carboxy', NULL, NULL, 15307, 16),
(283360, NULL, 'SFLDG01081', NULL, NULL, 'cleavage of the Ca-Cb bond in aromatic amino acids', NULL, 'cleavage_of_the_Ca-Cb_bond_in', NULL, NULL, NULL, 16),
(283361, NULL, 'SFLDF00419', NULL, NULL, '3-methyl-2-indolic acid synthase (NosL)', NULL, '3-methyl-2-indolic_acid_synth', NULL, NULL, 21392, 16),
(283362, NULL, 'SFLDG01115', NULL, NULL, 'Phosphonate metabolism (PhnJ)', NULL, 'Phosphonate_metabolism_(PhnJ)', NULL, NULL, NULL, 16),
(283363, NULL, 'SFLDG01202', NULL, NULL, 'SUF2.2', NULL, 'SUF2.2', NULL, NULL, NULL, 16),
(283364, NULL, 'SFLDG01383', NULL, NULL, 'cyclic pyranopterin phosphate synthase (MoaA-like)', NULL, 'cyclic_pyranopterin_phosphate', NULL, NULL, NULL, 16),
(283365, NULL, 'SFLDF00283', NULL, NULL, 'L-lysine 2,3-aminomutase (LAM-like)', NULL, 'L-lysine_2,3-aminomutase_(LAM', NULL, NULL, 15545, 16),
(283366, NULL, 'SFLDG01121', NULL, NULL, 'Diphthamide biosynthesis', NULL, 'Diphthamide_biosynthesis', NULL, NULL, NULL, 16),
(283367, NULL, 'SFLDF00028', NULL, NULL, 'histidinol-phosphatase', NULL, 'histidinol-phosphatase', NULL, NULL, NULL, 16),
(283368, NULL, 'SFLDF00417', NULL, NULL, 'gentamicin C-6'' methyltransferase (GenK-like)', NULL, 'gentamicin_C-6''_methyltransfe', NULL, NULL, 31350, 16),
(283369, NULL, 'SFLDG01066', NULL, NULL, 'organic radical-activating enzymes', NULL, 'organic_radical-activating_en', NULL, NULL, NULL, 16),
(283370, NULL, 'SFLDG01098', NULL, NULL, 'Uncharacterised Radical SAM Subgroup 11', NULL, 'Uncharacterised_Radical_SAM_S', NULL, NULL, NULL, 16),
(283371, NULL, 'SFLDF00038', NULL, NULL, 'phosphonoacetaldehyde hydrolase', NULL, 'phosphonoacetaldehyde_hydrola', NULL, NULL, NULL, 16),
(283372, NULL, 'SFLDF00307', NULL, NULL, 'bacteriochlorophyll C8 methyltransferase', NULL, 'bacteriochlorophyll_C8_methyl', NULL, NULL, 8513, 16),
(283373, NULL, 'SFLDF00322', NULL, NULL, 'tryptophan 2-C-methyltransferase', NULL, 'tryptophan_2-C-methyltransfer', NULL, NULL, 25993, 16),
(283374, NULL, 'SFLDF00290', NULL, NULL, 'glutamate 2,3-aminomutase', NULL, 'glutamate_2,3-aminomutase', NULL, NULL, 26285, 16),
(283375, NULL, 'SFLDF00027', NULL, NULL, 'p-type atpase', NULL, 'p-type_atpase', NULL, NULL, 34603, 16),
(283376, NULL, 'SFLDG01168', NULL, NULL, 'Ferric reductase subgroup (FRE)', NULL, 'Ferric_reductase_subgroup_(FR', NULL, NULL, NULL, 16),
(283377, NULL, 'SFLDG01128', NULL, NULL, 'C1.4: 5''-Nucleotidase Like', NULL, 'C1.4:_5''-Nucleotidase_Like', NULL, NULL, 6960, 16);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(283378, NULL, 'SFLDG01386', NULL, NULL, 'main SPASM domain-containing', NULL, 'main_SPASM_domain-containing', NULL, NULL, NULL, 16),
(283379, NULL, 'SFLDG01150', NULL, NULL, 'Main.1: Beta-like', NULL, 'Main.1:_Beta-like', NULL, NULL, NULL, 16),
(283380, NULL, 'SFLDG01206', NULL, NULL, 'Xi.1', NULL, 'Xi.1', NULL, NULL, 19076, 16),
(283381, NULL, 'SFLDF00357', NULL, NULL, 'ExsD-like', NULL, 'ExsD-like', NULL, NULL, NULL, 16),
(283382, NULL, 'SFLDF00568', NULL, NULL, 'paromamine deoxygenase', NULL, 'paromamine_deoxygenase', NULL, NULL, NULL, 16),
(283383, NULL, 'SFLDF00041', NULL, NULL, 'mdp-1', NULL, 'mdp-1', NULL, NULL, NULL, 16),
(283384, NULL, 'SFLDG01017', NULL, NULL, 'Polyprenyl Transferase Like', NULL, 'Polyprenyl_Transferase_Like', NULL, NULL, NULL, 16),
(283385, NULL, 'SFLDF00317', NULL, NULL, 'thioacetal methlytransferase (Swb9-like)', NULL, 'thioacetal_methlytransferase_', NULL, NULL, NULL, 16),
(283386, NULL, 'SFLDG01021', NULL, NULL, 'Trichodiene Synthase Like', NULL, 'Trichodiene_Synthase_Like', NULL, NULL, 10521, 16),
(283387, NULL, 'SFLDF00295', NULL, NULL, 'threonylcarbamoyladenosine tRNA methylthiotransferase', NULL, 'threonylcarbamoyladenosine_tR', NULL, NULL, 9320, 16),
(283388, NULL, 'SFLDG01152', NULL, NULL, 'Main.3: Omega- and Tau-like', NULL, 'Main.3:_Omega-_and_Tau-like_', NULL, NULL, 35570, 16),
(283389, NULL, 'SFLDF00294', NULL, NULL, '7,8-didemethyl-8-hydroxy-5-deazariboflavin synthase (CofG-like)', NULL, '7,8-didemethyl-8-hydroxy-5-de', NULL, NULL, 18150, 16),
(283390, NULL, 'SFLDF00278', NULL, NULL, 'pyruvate formate-lyase activase', NULL, 'pyruvate_formate-lyase_activa', NULL, NULL, 30957, 16),
(283391, NULL, 'SFLDG01088', NULL, NULL, 'antiviral proteins', NULL, 'antiviral_proteins', NULL, NULL, NULL, 16),
(283392, NULL, 'SFLDG01385', NULL, NULL, 'heme carboxy lyase like', NULL, 'heme_carboxy_lyase_like', NULL, NULL, 20921, 16),
(283393, NULL, 'SFLDS00055', NULL, NULL, 'Pyruvoyl-Dependent Histidine/Arginine Decarboxylase', NULL, 'Pyruvoyl-Dependent_Histidine/', NULL, NULL, NULL, 16),
(283394, NULL, 'SFLDF00515', NULL, NULL, 'sporulation killing factor protein (SkfB-like)', NULL, 'sporulation_killing_factor_pr', NULL, NULL, 25560, 16),
(283395, NULL, 'SFLDF00415', NULL, NULL, 'ladderane biosynthesis', NULL, 'ladderane_biosynthesis', NULL, NULL, NULL, 16),
(283396, NULL, 'SFLDF00156', NULL, NULL, 'D-arabinonate dehydratase', NULL, 'D-arabinonate_dehydratase', NULL, NULL, NULL, 16),
(283397, NULL, 'SFLDG01104', NULL, NULL, 'Uncharacterised Radical SAM Subgroup 17', NULL, 'Uncharacterised_Radical_SAM_S', NULL, NULL, 8690, 16),
(283398, NULL, 'SFLDF00297', NULL, NULL, 'benzylsuccinate synthase activase', NULL, 'benzylsuccinate_synthase_acti', NULL, NULL, 30586, 16),
(283399, NULL, 'SFLDG01111', NULL, NULL, 'Uncharacterised Radical SAM Subgroup 5', NULL, 'Uncharacterised_Radical_SAM_S', NULL, NULL, 8739, 16),
(283400, NULL, 'SFLDG01101', NULL, NULL, 'Uncharacterised Radical SAM Subgroup 14', NULL, 'Uncharacterised_Radical_SAM_S', NULL, NULL, 26745, 16),
(283401, NULL, 'SFLDF00029', NULL, NULL, 'phosphoserine phosphatase', NULL, 'phosphoserine_phosphatase', NULL, NULL, 7217, 16),
(283402, NULL, 'SFLDG01148', NULL, NULL, 'Xi (cytGST)', NULL, 'Xi_(cytGST)', NULL, NULL, NULL, 16),
(283403, NULL, 'SFLDF00289', NULL, NULL, 'anaerobic Cys-type sulfatase-maturating enzyme', NULL, 'anaerobic_Cys-type_sulfatase-', NULL, NULL, 14699, 16),
(283404, NULL, 'SFLDF00031', NULL, NULL, '2-deoxyglucose-6-phosphatase', NULL, '2-deoxyglucose-6-phosphatase', NULL, NULL, NULL, 16),
(283405, NULL, 'SFLDF00569', NULL, NULL, 'pcfB-like', NULL, 'pcfB-like', NULL, NULL, NULL, 16),
(283406, NULL, 'SFLDS00019', NULL, NULL, 'Glutathione Transferase (cytosolic)', NULL, 'Glutathione_Transferase_(cyto', NULL, NULL, 27002, 16),
(283407, NULL, 'SFLDF00032', NULL, NULL, 'trehalose-phosphatase', NULL, 'trehalose-phosphatase', NULL, NULL, NULL, 16),
(283408, NULL, 'SFLDS00036', NULL, NULL, 'Aromatic Prenyltransferase', NULL, 'Aromatic_Prenyltransferase', NULL, NULL, 33388, 16),
(283409, NULL, 'SFLDF00273', NULL, NULL, '(dimethylallyl)adenosine tRNA methylthiotransferase (MiaB-like)', NULL, '(dimethylallyl)adenosine_tRNA', NULL, NULL, 4220, 16);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(283410, NULL, 'SFLDG01258', NULL, NULL, '(chloro)muconate cycloisomerase (syn) like', NULL, '(chloro)muconate_cycloisomera', NULL, NULL, 18631, 16),
(283411, NULL, 'SFLDG00309', NULL, NULL, 'galactarate dehydratase', NULL, 'galactarate_dehydratase', NULL, NULL, NULL, 16),
(283412, NULL, 'SFLDF00471', NULL, NULL, 'Pyruvoyl-dependent arginine decarboxylase', NULL, 'Pyruvoyl-dependent_arginine_d', NULL, NULL, NULL, 16),
(283413, NULL, 'SFLDG01384', NULL, NULL, 'thioether bond formation requiring two auxiliary iron-sulfur clusters', NULL, 'thioether_bond_formation_requ', NULL, NULL, 16896, 16),
(283414, NULL, 'SFLDF00319', NULL, NULL, '[Fe] hydrogenase maturase (HydG-like)', NULL, '[Fe]_hydrogenase_maturase_(Hy', NULL, NULL, 15865, 16),
(283415, NULL, 'SFLDG01065', NULL, NULL, 'anaerobic coproporphyrinogen-III oxidase like', NULL, 'anaerobic_coproporphyrinogen-', NULL, NULL, NULL, 16),
(283416, NULL, 'SFLDG01138', NULL, NULL, 'C1.6.2: Deoxy-d-mannose-octulosonate 8-phosphate Phosphatase Like', NULL, 'C1.6.2:_Deoxy-d-mannose-octul', NULL, NULL, 5088, 16),
(283417, NULL, 'SFLDF00274', NULL, NULL, 'ribosomal protein S12 methylthiotransferase (RimO-like)', NULL, 'ribosomal_protein_S12_methylt', NULL, NULL, 5917, 16),
(283418, NULL, 'SFLDG01097', NULL, NULL, 'Uncharacterised Radical SAM Subgroup 10', NULL, 'Uncharacterised_Radical_SAM_S', NULL, NULL, 25225, 16),
(283419, NULL, 'SFLDF00288', NULL, NULL, 'HemN-like, clustered with nucleoside-triphosphate RdgB', NULL, 'HemN-like,_clustered_with_nuc', NULL, NULL, NULL, 16),
(283420, NULL, 'SFLDF00326', NULL, NULL, '5''''-pyrrole methytransferase', NULL, '5''''-pyrrole_methytransferase', NULL, NULL, 23493, 16),
(283421, NULL, 'SFLDG01094', NULL, NULL, 'Uncharacterised Radical SAM Subgroup 6', NULL, 'Uncharacterised_Radical_SAM_S', NULL, NULL, 12619, 16),
(283422, NULL, 'SFLDG01108', NULL, NULL, 'Uncharacterised Radical SAM Subgroup 21', NULL, 'Uncharacterised_Radical_SAM_S', NULL, NULL, 28510, 16),
(283423, NULL, 'SFLDF00134', NULL, NULL, 'L-talarate/galactarate dehydratase', NULL, 'L-talarate/galactarate_dehydr', NULL, NULL, 29018, 16),
(283424, NULL, 'SFLDG01604', NULL, NULL, 'Terpene Cyclase Like 1 C Terminal Domain - Enzymatic', NULL, 'Terpene_Cyclase_Like_1_C_Term', NULL, NULL, NULL, 16),
(283425, NULL, 'SFLDG01605', NULL, NULL, 'Terpene Cyclase Like 1 N-term - Enzymatic', NULL, 'Terpene_Cyclase_Like_1_N-term', NULL, NULL, NULL, 16),
(283426, NULL, 'SFLDG01016', NULL, NULL, 'Prenyltransferase Like 2', NULL, 'Prenyltransferase_Like_2', NULL, NULL, 20195, 16),
(283427, NULL, 'SFLDG01079', NULL, NULL, 'spore photoproduct lyase like', NULL, 'spore_photoproduct_lyase_like', NULL, NULL, NULL, 16),
(283428, NULL, 'SFLDG01279', NULL, NULL, 'HMD cofactor maturase (HmdB-like)', NULL, 'HMD_cofactor_maturase_(HmdB-l', NULL, NULL, NULL, 16),
(283429, NULL, 'SFLDF00571', NULL, NULL, 'Tte1186a maturase', NULL, 'Tte1186a_maturase', NULL, NULL, 9285, 16),
(283430, NULL, 'SFLDG01389', NULL, NULL, 'menaquinone synthsis involved', NULL, 'menaquinone_synthsis_involved', NULL, NULL, NULL, 16),
(283431, NULL, 'SFLDS00028', NULL, NULL, 'Proline Racemase', NULL, 'Proline_Racemase', NULL, NULL, 13600, 16),
(283432, NULL, 'SFLDF00311', NULL, NULL, 'heme degradation proteins (HutW/ChuW-like)', NULL, 'heme_degradation_proteins_(Hu', NULL, NULL, 23111, 16),
(283433, NULL, 'SFLDF00292', NULL, NULL, 'spore photoproduct lyase 1', NULL, 'spore_photoproduct_lyase_1', NULL, NULL, 9874, 16),
(283434, NULL, 'SFLDG01117', NULL, NULL, 'AviX12-like', NULL, 'AviX12-like', NULL, NULL, NULL, 16),
(283435, NULL, 'SFLDG01183', NULL, NULL, 'Grx2-like', NULL, 'Grx2-like', NULL, NULL, NULL, 16),
(283436, NULL, 'SFLDG01126', NULL, NULL, 'C1.2: Nucleotidase Like', NULL, 'C1.2:_Nucleotidase_Like', NULL, NULL, NULL, 16),
(283437, NULL, 'SFLDF00570', NULL, NULL, 'tungsten cofactor oxidoreducase radical SAM maturase', NULL, 'tungsten_cofactor_oxidoreduca', NULL, NULL, 23304, 16),
(283438, NULL, 'SFLDS00005', NULL, NULL, 'Isoprenoid Synthase Type I', NULL, 'Isoprenoid_Synthase_Type_I', NULL, NULL, NULL, 16); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(283439, NULL, 'SFLDG01136', NULL, NULL, 'C1.6: Phosphoserine Phosphatase Like', NULL, 'C1.6:_Phosphoserine_Phosphata', NULL, NULL, NULL, 16),
(283440, NULL, 'SFLDG01086', NULL, NULL, 'elongater protein-like', NULL, 'elongater_protein-like', NULL, NULL, NULL, 16),
(283441, NULL, 'SFLDG01119', NULL, NULL, 'spectinomycin biosynthesis (SpcY-like)', NULL, 'spectinomycin_biosynthesis_(S', NULL, NULL, 29376, 16),
(283442, NULL, 'SFLDG01179', NULL, NULL, 'Complement C3/C4 Like', NULL, 'Complement_C3/C4_Like', NULL, NULL, NULL, 16),
(283443, NULL, 'SFLDG01151', NULL, NULL, 'Main.2: Nu-like', NULL, 'Main.2:_Nu-like', NULL, NULL, NULL, 16),
(283444, NULL, 'SFLDF00564', NULL, NULL, 'xylonate dehydratase 2', NULL, 'xylonate_dehydratase_2', NULL, NULL, 5903, 16),
(283445, NULL, 'SFLDG01070', NULL, NULL, 'PLP-dependent', NULL, 'PLP-dependent', NULL, NULL, 2409, 16),
(283446, NULL, 'SFLDG01134', NULL, NULL, 'C1.5.5: Heptose Bisphosphate Phosphatase Like', NULL, 'C1.5.5:_Heptose_Bisphosphate_', NULL, NULL, NULL, 16),
(283447, NULL, 'SFLDF00324', NULL, NULL, 'bacteriocin maturation', NULL, 'bacteriocin_maturation', NULL, NULL, 11366, 16),
(283448, NULL, 'SFLDG01068', NULL, NULL, 'FeMo cofactor biosynthesis protein', NULL, 'FeMo_cofactor_biosynthesis_pr', NULL, NULL, NULL, 16),
(283449, NULL, 'SFLDG01211', NULL, NULL, 'Competence Regulatory Protein ComQ', NULL, 'Competence_Regulatory_Protein', NULL, NULL, 31067, 16),
(283450, NULL, 'SFLDG00363', NULL, NULL, 'AMPS (cytGST): Alpha-, Mu-, Pi-, and Sigma-like', NULL, 'AMPS_(cytGST):_Alpha-,_Mu-,_P', NULL, NULL, NULL, 16),
(283451, NULL, 'SFLDG01083', NULL, NULL, 'Uncharacterised Radical SAM Subgroup 1', NULL, 'Uncharacterised_Radical_SAM_S', NULL, NULL, 28525, 16),
(283452, NULL, 'SFLDF00436', NULL, NULL, 'pactamycin C-methyltransferase (PctJ-like)', NULL, 'pactamycin_C-methyltransferas', NULL, NULL, NULL, 16),
(283453, NULL, 'SFLDF00310', NULL, NULL, 'oxygen-independent coproporphyrinogen-III oxidase 2 (HemZ-like)', NULL, 'oxygen-independent_coproporph', NULL, NULL, 18189, 16),
(283454, NULL, 'SFLDG01204', NULL, NULL, 'Grx2-like.1', NULL, 'Grx2-like.1', NULL, NULL, 12257, 16),
(283455, NULL, 'SFLDF00293', NULL, NULL, '((2,3,4,5-tetrahydroxypentyl)amino)dihydropyrimidine-2,4-dione synthase (CofH-like)', NULL, '((2,3,4,5-tetrahydroxypentyl)', NULL, NULL, 18397, 16),
(283456, NULL, 'SFLDF00315', NULL, NULL, 'antilisterial bacteriocin subtilosin biosynthesis protein (AlbA-like)', NULL, 'antilisterial_bacteriocin_sub', NULL, NULL, NULL, 16),
(283457, NULL, 'SignalP-TM', NULL, NULL, NULL, NULL, 'SignalP-TM', NULL, NULL, NULL, 17),
(283458, NULL, 'SignalP-noTM', NULL, NULL, NULL, NULL, 'SignalP-noTM', NULL, NULL, NULL, 17),
(283459, NULL, 'SignalP-TM', NULL, NULL, NULL, NULL, 'SignalP-TM', NULL, NULL, NULL, 18),
(283460, NULL, 'SignalP-noTM', NULL, NULL, NULL, NULL, 'SignalP-noTM', NULL, NULL, NULL, 18),
(283461, NULL, 'SignalP-TM', NULL, NULL, NULL, NULL, 'SignalP-TM', NULL, NULL, NULL, 19),
(283462, NULL, 'SignalP-noTM', NULL, NULL, NULL, NULL, 'SignalP-noTM', NULL, NULL, NULL, 19),
(283463, NULL, 'SM01346', NULL, NULL, NULL, NULL, 'DUF3385_3', NULL, NULL, 26956, 20),
(283464, NULL, 'SM00913', NULL, NULL, NULL, NULL, 'IBN_N_2', NULL, NULL, 3367, 20),
(283465, NULL, 'SM00551', NULL, NULL, NULL, NULL, 'TAZ_2', NULL, NULL, 3995, 20),
(283466, NULL, 'SM01255', NULL, NULL, NULL, NULL, 'KNOX1_2', NULL, NULL, 1730, 20),
(283467, NULL, 'SM00084', NULL, NULL, NULL, NULL, 'nmu2', NULL, NULL, 7345, 20),
(283468, NULL, 'SM00843', NULL, NULL, NULL, NULL, 'FtsK_gamma_2', NULL, NULL, 14576, 20),
(283469, NULL, 'SM01388', NULL, NULL, NULL, NULL, 'Mob1_phocein_2', NULL, NULL, 5469, 20),
(283470, NULL, 'SM00824', NULL, NULL, 'Thioesterase', NULL, 'PKS_TE', NULL, NULL, 21221, 20),
(283471, NULL, 'SM01314', NULL, NULL, NULL, NULL, 'SnAC_2', NULL, NULL, 26848, 20),
(283472, NULL, 'SM00548', NULL, NULL, NULL, NULL, 'irx_3', NULL, NULL, 4060, 20),
(283473, NULL, 'SM01115', NULL, NULL, NULL, NULL, 'cwf21_2', NULL, NULL, 8725, 20),
(283474, NULL, 'SM00085', NULL, NULL, NULL, NULL, 'PA-fin', NULL, NULL, 10230, 20);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(283475, NULL, 'SM00329', NULL, NULL, NULL, NULL, 'bpi2_2', NULL, NULL, 1966, 20),
(283476, NULL, 'SM01347', NULL, NULL, NULL, NULL, 'Mre11_DNA_bind_2', NULL, NULL, 7037, 20),
(283477, NULL, 'SM00998', NULL, NULL, NULL, NULL, 'ADSL_C_2', NULL, NULL, 17193, 20),
(283478, NULL, 'SM01084', NULL, NULL, NULL, NULL, 'CKS_2', NULL, NULL, 4563, 20),
(283479, NULL, 'SM00301', NULL, NULL, NULL, NULL, 'DM_3', NULL, NULL, 100, 20),
(283480, NULL, 'SM00733', NULL, NULL, NULL, NULL, 'mt_12', NULL, NULL, 4579, 20),
(283481, NULL, 'SM00297', NULL, NULL, NULL, NULL, 'bromo_6', NULL, NULL, 5971, 20),
(283482, NULL, 'SM00869', NULL, NULL, NULL, NULL, 'Autotransporter_2', NULL, NULL, 1528, 20),
(283483, NULL, 'SM00148', NULL, NULL, NULL, NULL, 'plcx_3', NULL, NULL, 19, 20),
(283484, NULL, 'SM00061', NULL, NULL, NULL, NULL, 'math_3', NULL, NULL, 1424, 20),
(283485, NULL, 'SM00976', NULL, NULL, NULL, NULL, 'Telo_bind_a_2', NULL, NULL, 12218, 20),
(283486, NULL, 'SM00279', NULL, NULL, NULL, NULL, 'HhH_4', NULL, NULL, 8556, 20),
(283487, NULL, 'SM00404', NULL, NULL, NULL, NULL, 'ptp_7', NULL, NULL, 253, 20),
(283488, NULL, 'SM00576', NULL, NULL, NULL, NULL, '17neu3', NULL, NULL, 182, 20),
(283489, NULL, 'SM00273', NULL, NULL, NULL, NULL, 'enth_2', NULL, NULL, 12524, 20),
(283490, NULL, 'SM00017', NULL, NULL, NULL, NULL, 'osteo', NULL, NULL, 2211, 20),
(283491, NULL, 'SM01304', NULL, NULL, NULL, NULL, 'Ras_bdg_2_2', NULL, NULL, 25952, 20),
(283492, NULL, 'SM00773', NULL, NULL, NULL, NULL, 'WGR_cls', NULL, NULL, 7662, 20),
(283493, NULL, 'SM01193', NULL, NULL, NULL, NULL, 'Enolase_N_3', NULL, NULL, 14540, 20),
(283494, NULL, 'SM00905', NULL, NULL, NULL, NULL, 'FolB_2', NULL, NULL, 10460, 20),
(283495, NULL, 'SM01124', NULL, NULL, NULL, NULL, 'DBR1_2', NULL, NULL, 1036, 20),
(283496, NULL, 'SM00105', NULL, NULL, NULL, NULL, 'arf_gap_3', NULL, NULL, 1120, 20),
(283497, NULL, 'SM01212', NULL, NULL, NULL, NULL, 'Fib_alpha_2', NULL, NULL, 13256, 20),
(283498, NULL, 'SM01404', NULL, NULL, NULL, NULL, 'CIMR_2', NULL, NULL, NULL, 20),
(283499, NULL, 'SM00214', NULL, NULL, NULL, NULL, 'vwc', NULL, NULL, 2283, 20),
(283500, NULL, 'SM00947', NULL, NULL, NULL, NULL, 'Pro_CA_2', NULL, NULL, 3319, 20),
(283501, NULL, 'SM01192', NULL, NULL, NULL, NULL, 'Enolase_C_3', NULL, NULL, 14717, 20),
(283502, NULL, 'SM00828', NULL, NULL, 'Methyltransferase  in polyketide synthase (PKS) enzymes.', NULL, 'PKS_MT', NULL, NULL, 21066, 20),
(283503, NULL, 'SM01089', NULL, NULL, NULL, NULL, 'Connexin_CCC_2', NULL, NULL, 19190, 20),
(283504, NULL, 'SM00228', NULL, NULL, NULL, NULL, 'pdz_new', NULL, NULL, 3119, 20),
(283505, NULL, 'SM00505', NULL, NULL, NULL, NULL, 'gth_4', NULL, NULL, 678, 20),
(283506, NULL, 'SM01003', NULL, NULL, NULL, NULL, 'AlaDh_PNT_N_2', NULL, NULL, 3280, 20),
(283507, NULL, 'SM01065', NULL, NULL, NULL, NULL, 'CBM_20_2', NULL, NULL, 1274, 20),
(283508, NULL, 'SM01219', NULL, NULL, NULL, NULL, 'Frataxin_Cyay_2', NULL, NULL, 6348, 20),
(283509, NULL, 'SM00870', NULL, NULL, NULL, NULL, 'Asparaginase_2', NULL, NULL, 2746, 20),
(283510, NULL, 'SM00164', NULL, NULL, NULL, NULL, 'tbc_4', NULL, NULL, 1351, 20),
(283511, NULL, 'SM01122', NULL, NULL, NULL, NULL, 'DBC1_2', NULL, NULL, 21715, 20),
(283512, NULL, 'SM00261', NULL, NULL, NULL, NULL, 'furin_3', NULL, NULL, 11201, 20),
(283513, NULL, 'SM01287', NULL, NULL, NULL, NULL, 'Rtt106_2', NULL, NULL, 14101, 20),
(283514, NULL, 'SM01129', NULL, NULL, NULL, NULL, 'DELLA_2', NULL, NULL, NULL, 20),
(283515, NULL, 'SM00149', NULL, NULL, NULL, NULL, 'plcy_3', NULL, NULL, 3438, 20),
(283516, NULL, 'SM00956', NULL, NULL, NULL, NULL, 'RQC_2', NULL, NULL, 15627, 20),
(283517, NULL, 'SM00991', NULL, NULL, NULL, NULL, 'WHEP_TRS_a_2_a_3_a', NULL, NULL, 3767, 20),
(283518, NULL, 'SM00961', NULL, NULL, NULL, NULL, 'RuBisCO_small_2_a', NULL, NULL, 3362, 20),
(283519, NULL, 'SM00695', NULL, NULL, NULL, NULL, 'dusp', NULL, NULL, 1168, 20),
(283520, NULL, 'SM01167', NULL, NULL, NULL, NULL, 'DUF1900_2', NULL, NULL, NULL, 20),
(283521, NULL, 'SM00546', NULL, NULL, NULL, NULL, 'cue_7', NULL, NULL, 4183, 20);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(283522, NULL, 'SM00568', NULL, NULL, NULL, NULL, 'gram2001c', NULL, NULL, 2538, 20),
(283523, NULL, 'SM00293', NULL, NULL, NULL, NULL, 'PWWP_4', NULL, NULL, 927, 20),
(283524, NULL, 'SM00951', NULL, NULL, NULL, NULL, 'QLQ_2', NULL, NULL, 14200, 20),
(283525, NULL, 'SM01191', NULL, NULL, NULL, NULL, 'ENT_2', NULL, NULL, 879, 20),
(283526, NULL, 'SM01214', NULL, NULL, NULL, NULL, 'Fmp27_GFWDK_2', NULL, NULL, 17476, 20),
(283527, NULL, 'SM01169', NULL, NULL, NULL, NULL, 'DUF1943_3', NULL, NULL, 12087, 20),
(283528, NULL, 'SM00365', NULL, NULL, NULL, NULL, 'LRR_sd22_2', NULL, NULL, NULL, 20),
(283529, NULL, 'SM01002', NULL, NULL, NULL, NULL, 'AlaDh_PNT_C_2', NULL, NULL, 1261, 20),
(283530, NULL, 'SM00768', NULL, NULL, NULL, NULL, 'X8_cls', NULL, NULL, 8169, 20),
(283531, NULL, 'SM01225', NULL, NULL, NULL, NULL, 'G8_2', NULL, NULL, 14952, 20),
(283532, NULL, 'SM00767', NULL, NULL, NULL, NULL, 'dcd', NULL, NULL, 10281, 20),
(283533, NULL, 'SM00744', NULL, NULL, NULL, NULL, 'ringv_2', NULL, NULL, 9214, 20),
(283534, NULL, 'SM00809', NULL, NULL, NULL, NULL, 'alpha_adaptinc2', NULL, NULL, 7062, 20),
(283535, NULL, 'SM00670', NULL, NULL, NULL, NULL, 'PIN_9', NULL, NULL, 3820, 20),
(283536, NULL, 'SM00506', NULL, NULL, NULL, NULL, 'YBR022w_8', NULL, NULL, 1943, 20),
(283537, NULL, 'SM01103', NULL, NULL, NULL, NULL, 'CRS1_YhbY_2', NULL, NULL, 4467, 20),
(283538, NULL, 'SM00478', NULL, NULL, NULL, NULL, 'endo3end', NULL, NULL, 3330, 20),
(283539, NULL, 'SM01231', NULL, NULL, NULL, NULL, 'H_kinase_dim_2', NULL, NULL, 1509, 20),
(283540, NULL, 'SM00706', NULL, NULL, NULL, NULL, 'tecpr', NULL, NULL, 1427, 20),
(283541, NULL, 'SM00174', NULL, NULL, NULL, NULL, 'rho_sub_3', NULL, NULL, 4843, 20),
(283542, NULL, 'SM00644', NULL, NULL, NULL, NULL, 'ami_2', NULL, NULL, 994, 20),
(283543, NULL, 'SM00904', NULL, NULL, NULL, NULL, 'Flavokinase_2', NULL, NULL, 12594, 20),
(283544, NULL, 'SM01286', NULL, NULL, NULL, NULL, 'SPT16_2', NULL, NULL, 7589, 20),
(283545, NULL, 'SM00604', NULL, NULL, NULL, NULL, 'md', NULL, NULL, 66, 20),
(283546, NULL, 'SM00448', NULL, NULL, NULL, NULL, 'REC_2', NULL, NULL, 3274, 20),
(283547, NULL, 'SM01120', NULL, NULL, NULL, NULL, 'Dak2_2', NULL, NULL, 979, 20),
(283548, NULL, 'SM00247', NULL, NULL, NULL, NULL, 'XTALbg_4', NULL, NULL, 2093, 20),
(283549, NULL, 'SM00115', NULL, NULL, NULL, NULL, 'caspase_2', NULL, NULL, 7166, 20),
(283550, NULL, 'SM01349', NULL, NULL, NULL, NULL, 'TOG_3', NULL, NULL, 23386, 20),
(283551, NULL, 'SM00575', NULL, NULL, NULL, NULL, '26again6', NULL, NULL, 257, 20),
(283552, NULL, 'SM01027', NULL, NULL, NULL, NULL, 'Beta_Casp_2', NULL, NULL, 16973, 20),
(283553, NULL, 'SM01320', NULL, NULL, NULL, NULL, 'TRP_N_2', NULL, NULL, 21926, 20),
(283554, NULL, 'SM01323', NULL, NULL, NULL, NULL, 'YajC_2', NULL, NULL, 3067, 20),
(283555, NULL, 'SM00995', NULL, NULL, NULL, NULL, 'AD_2', NULL, NULL, 18341, 20),
(283556, NULL, 'SM01101', NULL, NULL, NULL, NULL, 'CRISPR_assoc_2', NULL, NULL, 4250, 20),
(283557, NULL, 'SM01278', NULL, NULL, NULL, NULL, 'MAPKK1_Int_3', NULL, NULL, 7513, 20),
(283558, NULL, 'SM00664', NULL, NULL, NULL, NULL, 'DOMON_3', NULL, NULL, 1212, 20),
(283559, NULL, 'SM01411', NULL, NULL, NULL, NULL, 'GCC2_GCC3_2', NULL, NULL, NULL, 20),
(283560, NULL, 'SM00304', NULL, NULL, NULL, NULL, 'HAMP_11', NULL, NULL, 1355, 20),
(283561, NULL, 'SM00076', NULL, NULL, NULL, NULL, 'inter3_nr', NULL, NULL, 5598, 20),
(283562, NULL, 'SM00129', NULL, NULL, NULL, NULL, 'kinesin_4', NULL, NULL, 3230, 20),
(283563, NULL, 'SM01340', NULL, NULL, NULL, NULL, 'DNA_mis_repair_2', NULL, NULL, 7173, 20),
(283564, NULL, 'SM01150', NULL, NULL, NULL, NULL, 'DUF1338_2', NULL, NULL, 12816, 20),
(283565, NULL, 'SM00392', NULL, NULL, NULL, NULL, 'prof_2', NULL, NULL, 952, 20),
(283566, NULL, 'SM00763', NULL, NULL, NULL, NULL, 'aaa_prka2seq5', NULL, NULL, 8419, 20),
(283567, NULL, 'SM00685', NULL, NULL, NULL, NULL, 'dm14', NULL, NULL, 1180, 20),
(283568, NULL, 'SM01170', NULL, NULL, NULL, NULL, 'DUF1944_2', NULL, NULL, 12331, 20),
(283569, NULL, 'SM00573', NULL, NULL, NULL, NULL, 'bromneu2', NULL, NULL, 9069, 20);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(283570, NULL, 'SM00863', NULL, NULL, NULL, NULL, 'tRNA_SAD_4', NULL, NULL, 8233, 20),
(283571, NULL, 'SM00201', NULL, NULL, NULL, NULL, 'SO_2', NULL, NULL, 1010, 20),
(283572, NULL, 'SM01028', NULL, NULL, NULL, NULL, 'Beta-TrCP_D_2', NULL, NULL, 20425, 20),
(283573, NULL, 'SM00458', NULL, NULL, NULL, NULL, 'ricin_3', NULL, NULL, 3959, 20),
(283574, NULL, 'SM00142', NULL, NULL, NULL, NULL, 'pi3k_hr3_6', NULL, NULL, 2903, 20),
(283575, NULL, 'SM01351', NULL, NULL, NULL, NULL, 'Aspzincin_M35_2', NULL, NULL, 23065, 20),
(283576, NULL, 'SM01292', NULL, NULL, NULL, NULL, 'N1221_2', NULL, NULL, 11739, 20),
(283577, NULL, 'SM00417', NULL, NULL, NULL, NULL, 'h44', NULL, NULL, 2275, 20),
(283578, NULL, 'SM00910', NULL, NULL, NULL, NULL, 'HIRAN_2', NULL, NULL, 13265, 20),
(283579, NULL, 'SM00131', NULL, NULL, NULL, NULL, 'KU_2', NULL, NULL, 481, 20),
(283580, NULL, 'SM01157', NULL, NULL, NULL, NULL, 'DUF1719_2', NULL, NULL, 17382, 20),
(283581, NULL, 'SM00209', NULL, NULL, NULL, NULL, 'TSP1_2', NULL, NULL, 4898, 20),
(283582, NULL, 'SM00218', NULL, NULL, NULL, NULL, 'zu_1', NULL, NULL, 3277, 20),
(283583, NULL, 'SM00211', NULL, NULL, NULL, NULL, 'TY_2', NULL, NULL, 6911, 20),
(283584, NULL, 'SM01331', NULL, NULL, NULL, NULL, 'DUF3635_2', NULL, NULL, 26768, 20),
(283585, NULL, 'SM01202', NULL, NULL, NULL, NULL, 'FerI_2', NULL, NULL, 11776, 20),
(283586, NULL, 'SM00533', NULL, NULL, NULL, NULL, 'DNAend', NULL, NULL, 1396, 20),
(283587, NULL, 'SM01205', NULL, NULL, NULL, NULL, 'FKS1_dom1_2', NULL, NULL, 26583, 20),
(283588, NULL, 'SM01235', NULL, NULL, NULL, NULL, 'Haem_bd_2', NULL, NULL, 25979, 20),
(283589, NULL, 'SM01217', NULL, NULL, NULL, NULL, 'Fn3_like_2', NULL, NULL, 26773, 20),
(283590, NULL, 'SM00042', NULL, NULL, NULL, NULL, 'CUB_2', NULL, NULL, 3339, 20),
(283591, NULL, 'SM00419', NULL, NULL, NULL, NULL, 'crpmeuga4', NULL, NULL, 11789, 20),
(283592, NULL, 'SM00765', NULL, NULL, NULL, NULL, 'manec2seq9d', NULL, NULL, 11123, 20),
(283593, NULL, 'SM01334', NULL, NULL, NULL, NULL, 'DUF3454_2', NULL, NULL, 26641, 20),
(283594, NULL, 'SM00077', NULL, NULL, NULL, NULL, 'itam_5', NULL, NULL, 1495, 20),
(283595, NULL, 'SM00925', NULL, NULL, NULL, NULL, 'MltA_2', NULL, NULL, 5267, 20),
(283596, NULL, 'SM00613', NULL, NULL, NULL, NULL, 'cppneu5', NULL, NULL, 291, 20),
(283597, NULL, 'SM01220', NULL, NULL, NULL, NULL, 'FSA_C_2', NULL, NULL, 20536, 20),
(283598, NULL, 'SM01240', NULL, NULL, NULL, NULL, 'IMPDH_2', NULL, NULL, NULL, 20),
(283599, NULL, 'SM01415', NULL, NULL, NULL, NULL, 'DUF106_2', NULL, NULL, 4637, 20),
(283600, NULL, 'SM00503', NULL, NULL, NULL, NULL, 'SynN_4', NULL, NULL, 1071, 20),
(283601, NULL, 'SM00436', NULL, NULL, NULL, NULL, 'topIban2', NULL, NULL, 431, 20),
(283602, NULL, 'SM01353', NULL, NULL, NULL, NULL, 'AIF_C_2', NULL, NULL, NULL, 20),
(283603, NULL, 'SM00888', NULL, NULL, NULL, NULL, 'EF1_GNE_2', NULL, NULL, 11032, 20),
(283604, NULL, 'SM00398', NULL, NULL, NULL, NULL, 'hmgende2', NULL, NULL, 6233, 20),
(283605, NULL, 'SM00959', NULL, NULL, NULL, NULL, 'Rho_N_2_a', NULL, NULL, 11069, 20),
(283606, NULL, 'SM00574', NULL, NULL, NULL, NULL, 'prehox3', NULL, NULL, 194, 20),
(283607, NULL, 'SM01393', NULL, NULL, NULL, NULL, 'Ribosomal_L32e_2', NULL, NULL, 6254, 20),
(283608, NULL, 'SM00572', NULL, NULL, NULL, NULL, 'rich3', NULL, NULL, 472, 20),
(283609, NULL, 'SM00853', NULL, NULL, NULL, NULL, 'MutL_C_2', NULL, NULL, 11309, 20),
(283610, NULL, 'SM00491', NULL, NULL, NULL, NULL, 'Cxpdneu3', NULL, NULL, 195, 20),
(283611, NULL, 'SM01311', NULL, NULL, NULL, NULL, 'RPOL_N_2', NULL, NULL, 21890, 20),
(283612, NULL, 'SM00920', NULL, NULL, NULL, NULL, 'MHC_II_alpha_2', NULL, NULL, 362, 20),
(283613, NULL, 'SM00571', NULL, NULL, NULL, NULL, 'testlast3', NULL, NULL, 14516, 20),
(283614, NULL, 'SM01119', NULL, NULL, NULL, NULL, 'D_ser_dehydrat_2', NULL, NULL, 25822, 20),
(283615, NULL, 'SM01140', NULL, NULL, NULL, NULL, 'Drf_GBD_2', NULL, NULL, 10312, 20),
(283616, NULL, 'SM00429', NULL, NULL, NULL, NULL, 'iptmega2', NULL, NULL, 6185, 20),
(283617, NULL, 'SM00194', NULL, NULL, NULL, NULL, 'PTPc_3', NULL, NULL, 820, 20);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(283618, NULL, 'SM00743', NULL, NULL, NULL, NULL, 'agenet_At_2', NULL, NULL, 9846, 20),
(283619, NULL, 'SM01269', NULL, NULL, NULL, NULL, 'Lipid_DES_2', NULL, NULL, 9820, 20),
(283620, NULL, 'SM00756', NULL, NULL, NULL, NULL, 'vkor_5', NULL, NULL, 8026, 20),
(283621, NULL, 'SM01275', NULL, NULL, NULL, NULL, 'MamL_1_2', NULL, NULL, 16930, 20),
(283622, NULL, 'SM00825', NULL, NULL, 'Beta-ketoacyl synthase', NULL, 'PKS_KS', NULL, NULL, 14792, 20),
(283623, NULL, 'SM01029', NULL, NULL, NULL, NULL, 'BetaGal_dom2_2', NULL, NULL, 16882, 20),
(283624, NULL, 'SM01047', NULL, NULL, NULL, NULL, 'C1_4_2', NULL, NULL, 903, 20),
(283625, NULL, 'SM01321', NULL, NULL, NULL, NULL, 'Y1_Tnp_2', NULL, NULL, 2933, 20),
(283626, NULL, 'SM01237', NULL, NULL, NULL, NULL, 'ICA69_2', NULL, NULL, 2485, 20),
(283627, NULL, 'SM01256', NULL, NULL, NULL, NULL, 'KNOX2_2', NULL, NULL, 1937, 20),
(283628, NULL, 'SM00111', NULL, NULL, NULL, NULL, 'C4_2', NULL, NULL, 6626, 20),
(283629, NULL, 'SM01399', NULL, NULL, NULL, NULL, 'Sybindin_2', NULL, NULL, 6532, 20),
(283630, NULL, 'SM00264', NULL, NULL, NULL, NULL, 'BAG_1', NULL, NULL, 1471, 20),
(283631, NULL, 'SM00542', NULL, NULL, NULL, NULL, 'fyrc_3', NULL, NULL, 4036, 20),
(283632, NULL, 'SM00984', NULL, NULL, NULL, NULL, 'UDPG_MGDP_dh_C_a_2_a', NULL, NULL, 8527, 20),
(283633, NULL, 'SM00760', NULL, NULL, NULL, NULL, 'bac_dnaa_c7seqb', NULL, NULL, 8706, 20),
(283634, NULL, 'SM01049', NULL, NULL, NULL, NULL, 'Cache_2_2', NULL, NULL, 33180, 20),
(283635, NULL, 'SM00884', NULL, NULL, NULL, NULL, 'Cullin_Nedd8_2', NULL, NULL, 19309, 20),
(283636, NULL, 'SM00792', NULL, NULL, NULL, NULL, 'agouti', NULL, NULL, 1078, 20),
(283637, NULL, 'SM00703', NULL, NULL, NULL, NULL, 'nrf', NULL, NULL, 1080, 20),
(283638, NULL, 'SM01137', NULL, NULL, NULL, NULL, 'DMAP_binding_2', NULL, NULL, 10361, 20),
(283639, NULL, 'SM00396', NULL, NULL, NULL, NULL, 'push_1', NULL, NULL, 1655, 20),
(283640, NULL, 'SM01312', NULL, NULL, NULL, NULL, 'RTC4_2', NULL, NULL, 26472, 20),
(283641, NULL, 'SM00313', NULL, NULL, NULL, NULL, 'PXA_3', NULL, NULL, 2701, 20),
(283642, NULL, 'SM00928', NULL, NULL, NULL, NULL, 'NADH_4Fe_4S_2', NULL, NULL, 20468, 20),
(283643, NULL, 'SM00607', NULL, NULL, NULL, NULL, 'ftp', NULL, NULL, 67, 20),
(283644, NULL, 'SM00833', NULL, NULL, NULL, NULL, 'CobW_C_3', NULL, NULL, 10685, 20),
(283645, NULL, 'SM00182', NULL, NULL, NULL, NULL, 'cul_2', NULL, NULL, 11510, 20),
(283646, NULL, 'SM01109', NULL, NULL, NULL, NULL, 'CUT_2', NULL, NULL, 4498, 20),
(283647, NULL, 'SM00842', NULL, NULL, NULL, NULL, 'FtsA._2', NULL, NULL, 6312, 20),
(283648, NULL, 'SM00316', NULL, NULL, NULL, NULL, 'S1_6', NULL, NULL, 14959, 20),
(283649, NULL, 'SM00474', NULL, NULL, NULL, NULL, '35exoneu6', NULL, NULL, 6979, 20),
(283650, NULL, 'SM00816', NULL, NULL, NULL, NULL, 'amb_v_allergen', NULL, NULL, 2638, 20),
(283651, NULL, 'SM01131', NULL, NULL, NULL, NULL, 'DHHA2_2', NULL, NULL, 1827, 20),
(283652, NULL, 'SM01303', NULL, NULL, NULL, NULL, 'RasGEF_N_2_2', NULL, NULL, NULL, 20),
(283653, NULL, 'SM00595', NULL, NULL, NULL, NULL, '118neu2', NULL, NULL, 200, 20),
(283654, NULL, 'SM00323', NULL, NULL, NULL, NULL, 'RasGAP_2', NULL, NULL, 2253, 20),
(283655, NULL, 'SM00494', NULL, NULL, NULL, NULL, 'chi_10', NULL, NULL, 1623, 20),
(283656, NULL, 'SM00353', NULL, NULL, NULL, NULL, 'finulus', NULL, NULL, 8133, 20),
(283657, NULL, 'SM00987', NULL, NULL, NULL, NULL, 'UDG_2_a', NULL, NULL, NULL, 20),
(283658, NULL, 'SM00321', NULL, NULL, NULL, NULL, 'SLG_2', NULL, NULL, 5924, 20),
(283659, NULL, 'SM00499', NULL, NULL, NULL, NULL, 'aai_6', NULL, NULL, 11347, 20),
(283660, NULL, 'SM00748', NULL, NULL, NULL, NULL, '2HEPN', NULL, NULL, 2497, 20),
(283661, NULL, 'SM01024', NULL, NULL, NULL, NULL, 'BCS1_N_2', NULL, NULL, 11603, 20),
(283662, NULL, 'SM01043', NULL, NULL, NULL, NULL, 'BTAD_2', NULL, NULL, 4334, 20),
(283663, NULL, 'SM01025', NULL, NULL, NULL, NULL, 'BEN_2', NULL, NULL, 20443, 20),
(283664, NULL, 'SM00614', NULL, NULL, NULL, NULL, 'bed5', NULL, NULL, NULL, 20),
(283665, NULL, 'SM00896', NULL, NULL, NULL, NULL, 'FDX_ACB_2', NULL, NULL, 7470, 20);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(283666, NULL, 'SM00242', NULL, NULL, NULL, NULL, 'MYSc_2a', NULL, NULL, 3265, 20),
(283667, NULL, 'SM01012', NULL, NULL, NULL, NULL, 'ANTAR_2', NULL, NULL, 1537, 20),
(283668, NULL, 'SM00753', NULL, NULL, 'motif in proteasome subunits, Int-6, Nip-1 and TRIP-15', NULL, 'PINT', NULL, NULL, NULL, 20),
(283669, NULL, 'SM00040', NULL, NULL, NULL, NULL, 'CSF2_1', NULL, NULL, 6701, 20),
(283670, NULL, 'SM01077', NULL, NULL, NULL, NULL, 'Cg6151_P_2', NULL, NULL, 15660, 20),
(283671, NULL, 'SM00231', NULL, NULL, NULL, NULL, 'disc_4', NULL, NULL, 4934, 20),
(283672, NULL, 'SM01305', NULL, NULL, NULL, NULL, 'RESP18_2', NULL, NULL, NULL, 20),
(283673, NULL, 'SM00927', NULL, NULL, NULL, NULL, 'MutH_2', NULL, NULL, 13646, 20),
(283674, NULL, 'SM00230', NULL, NULL, NULL, NULL, 'cys_prot_2', NULL, NULL, 2051, 20),
(283675, NULL, 'SM01325', NULL, NULL, NULL, NULL, 'DUF3160_2', NULL, NULL, 16767, 20),
(283676, NULL, 'SM00865', NULL, NULL, NULL, NULL, 'Tubulin_C_4', NULL, NULL, 16934, 20),
(283677, NULL, 'SM00440', NULL, NULL, NULL, NULL, 'Cys4_2', NULL, NULL, 2346, 20),
(283678, NULL, 'SM00080', NULL, NULL, NULL, NULL, 'ultra', NULL, NULL, 5266, 20),
(283679, NULL, 'SM00993', NULL, NULL, NULL, NULL, 'YL1_C_2', NULL, NULL, 13490, 20),
(283680, NULL, 'SM01178', NULL, NULL, NULL, NULL, 'DUF4217_3', NULL, NULL, 22088, 20),
(283681, NULL, 'SM00801', NULL, NULL, NULL, NULL, 'dDENN_cls', NULL, NULL, 10825, 20),
(283682, NULL, 'SM00789', NULL, NULL, NULL, NULL, 'ad_cyc_g_alpha', NULL, NULL, 14403, 20),
(283683, NULL, 'SM00966', NULL, NULL, NULL, NULL, 'SpoVT_AbrB_2_a', NULL, NULL, 46, 20),
(283684, NULL, 'SM00140', NULL, NULL, NULL, NULL, 'NGF_2', NULL, NULL, 5242, 20),
(283685, NULL, 'SM00355', NULL, NULL, NULL, NULL, 'c2h2final6', NULL, NULL, 13910, 20),
(283686, NULL, 'SM00206', NULL, NULL, NULL, NULL, 'NTR_2', NULL, NULL, 4440, 20),
(283687, NULL, 'SM00558', NULL, NULL, NULL, NULL, 'cupin_9', NULL, NULL, 4389, 20),
(283688, NULL, 'SM00431', NULL, NULL, NULL, NULL, 'ler4', NULL, NULL, 1239, 20),
(283689, NULL, 'SM00525', NULL, NULL, NULL, NULL, 'ccc3', NULL, NULL, 1373, 20),
(283690, NULL, 'SM01020', NULL, NULL, NULL, NULL, 'B2_adapt_app_C_2', NULL, NULL, 9706, 20),
(283691, NULL, 'SM00836', NULL, NULL, NULL, NULL, 'dalr_1_4', NULL, NULL, 7600, 20),
(283692, NULL, 'SM01258', NULL, NULL, NULL, NULL, 'KRBA1_2', NULL, NULL, 24661, 20),
(283693, NULL, 'SM01175', NULL, NULL, NULL, NULL, 'DUF4206_2', NULL, NULL, 23140, 20),
(283694, NULL, 'SM00082', NULL, NULL, NULL, NULL, 'lrrct1', NULL, NULL, 5745, 20),
(283695, NULL, 'SM00335', NULL, NULL, NULL, NULL, 'annex3', NULL, NULL, 9057, 20),
(283696, NULL, 'SM00428', NULL, NULL, NULL, NULL, 'h35', NULL, NULL, 1526, 20),
(283697, NULL, 'SM00642', NULL, NULL, NULL, NULL, 'aamy', NULL, NULL, 2899, 20),
(283698, NULL, 'SM01377', NULL, NULL, NULL, NULL, 'Ribosomal_L40e_3', NULL, NULL, 4452, 20),
(283699, NULL, 'SM01189', NULL, NULL, NULL, NULL, 'ELM2_2', NULL, NULL, 3106, 20),
(283700, NULL, 'SM00348', NULL, NULL, NULL, NULL, 'irfvirus2', NULL, NULL, 2349, 20),
(283701, NULL, 'SM00933', NULL, NULL, NULL, NULL, 'NurA_2_a', NULL, NULL, 14871, 20),
(283702, NULL, 'SM01328', NULL, NULL, NULL, NULL, 'zf_3CxxC_2', NULL, NULL, 24012, 20),
(283703, NULL, 'SM00740', NULL, NULL, NULL, NULL, '2pasta', NULL, NULL, 1695, 20),
(283704, NULL, 'SM01056', NULL, NULL, NULL, NULL, 'Candida_ALS_N_2', NULL, NULL, 21311, 20),
(283705, NULL, 'SM00071', NULL, NULL, NULL, NULL, 'galanin', NULL, NULL, 7165, 20),
(283706, NULL, 'SM01384', NULL, NULL, NULL, NULL, 'Ribosomal_L15e_2', NULL, NULL, 6669, 20),
(283707, NULL, 'SM01013', NULL, NULL, NULL, NULL, 'APC2_2', NULL, NULL, 11182, 20),
(283708, NULL, 'SM00100', NULL, NULL, NULL, NULL, 'cnmp_10', NULL, NULL, 5904, 20),
(283709, NULL, 'SM00890', NULL, NULL, NULL, NULL, 'EKR_2', NULL, NULL, 17384, 20),
(283710, NULL, 'SM01051', NULL, NULL, NULL, NULL, 'CAMSAP_CKK_2', NULL, NULL, 11043, 20),
(283711, NULL, 'SM00710', NULL, NULL, NULL, NULL, 'pbh1', NULL, NULL, 1131, 20),
(283712, NULL, 'SM00766', NULL, NULL, NULL, NULL, 'dnag_dnab_bind_seq8d', NULL, NULL, 8982, 20);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(283713, NULL, 'SM00391', NULL, NULL, NULL, NULL, 'TAM_2', NULL, NULL, 3352, 20),
(283714, NULL, 'SM01291', NULL, NULL, NULL, NULL, 'N_SET_2', NULL, NULL, 18260, 20),
(283715, NULL, 'SM00466', NULL, NULL, NULL, NULL, 'G9a_1', NULL, NULL, 1260, 20),
(283716, NULL, 'SM01271', NULL, NULL, NULL, NULL, 'LSM14_2', NULL, NULL, 23373, 20),
(283717, NULL, 'SM01380', NULL, NULL, NULL, NULL, 'Ribosomal_L31e_2', NULL, NULL, 2781, 20),
(283718, NULL, 'SM01230', NULL, NULL, NULL, NULL, 'Gln_synt_C_2', NULL, NULL, 7238, 20),
(283719, NULL, 'SM00386', NULL, NULL, NULL, NULL, 'hat_new_1', NULL, NULL, 1301, 20),
(283720, NULL, 'SM00549', NULL, NULL, NULL, NULL, 'nervy_1', NULL, NULL, 4074, 20),
(283721, NULL, 'SM01022', NULL, NULL, NULL, NULL, 'ASCH_2', NULL, NULL, 5601, 20),
(283722, NULL, 'SM01413', NULL, NULL, NULL, NULL, 'Ribosomal_S19e_2', NULL, NULL, 187, 20),
(283723, NULL, 'SM00031', NULL, NULL, NULL, NULL, 'ded_6', NULL, NULL, 4371, 20),
(283724, NULL, 'SM00813', NULL, NULL, NULL, NULL, 'alpha_l_af_c', NULL, NULL, 9733, 20),
(283725, NULL, 'SM01050', NULL, NULL, NULL, NULL, 'CactinC_cactus_3', NULL, NULL, NULL, 20),
(283726, NULL, 'SM01173', NULL, NULL, NULL, NULL, 'DUF4187_2', NULL, NULL, 23433, 20),
(283727, NULL, 'SM01197', NULL, NULL, NULL, NULL, 'FANCL_C_2', NULL, NULL, NULL, 20),
(283728, NULL, 'SM01354', NULL, NULL, NULL, NULL, 'BLVR_2', NULL, NULL, 10114, 20),
(283729, NULL, 'SM00543', NULL, NULL, NULL, NULL, 'if4_15', NULL, NULL, 4100, 20),
(283730, NULL, 'SM00287', NULL, NULL, NULL, NULL, 'sh3_bac_9', NULL, NULL, 1397, 20),
(283731, NULL, 'SM00427', NULL, NULL, NULL, NULL, 'h2b3', NULL, NULL, 5842, 20),
(283732, NULL, 'SM00266', NULL, NULL, NULL, NULL, 'CAD_1', NULL, NULL, 6264, 20),
(283733, NULL, 'SM01093', NULL, NULL, NULL, NULL, 'CP12_2', NULL, NULL, 3171, 20),
(283734, NULL, 'SM00205', NULL, NULL, NULL, NULL, 'tha2', NULL, NULL, 2232, 20),
(283735, NULL, 'SM00382', NULL, NULL, NULL, NULL, 'AAA_5', NULL, NULL, 96, 20),
(283736, NULL, 'SM01125', NULL, NULL, NULL, NULL, 'DCP2_2', NULL, NULL, 1144, 20),
(283737, NULL, 'SM00430', NULL, NULL, NULL, NULL, 'holi', NULL, NULL, 5738, 20),
(283738, NULL, 'SM00577', NULL, NULL, NULL, NULL, 'forpap2', NULL, NULL, 4145, 20),
(283739, NULL, 'SM00692', NULL, NULL, NULL, NULL, 'dm3', NULL, NULL, 1288, 20),
(283740, NULL, 'SM00902', NULL, NULL, NULL, NULL, 'Fe_hyd_SSU_2', NULL, NULL, 3349, 20),
(283741, NULL, 'SM00895', NULL, NULL, NULL, NULL, 'FCD_2', NULL, NULL, 8093, 20),
(283742, NULL, 'SM00589', NULL, NULL, NULL, NULL, '2212neu4', NULL, NULL, 233, 20),
(283743, NULL, 'SM01204', NULL, NULL, NULL, NULL, 'FIST_C_2', NULL, NULL, 18276, 20),
(283744, NULL, 'SM00470', NULL, NULL, NULL, NULL, 'ParB_7', NULL, NULL, 1600, 20),
(283745, NULL, 'SM00086', NULL, NULL, NULL, NULL, 'pac_2', NULL, NULL, 5405, 20),
(283746, NULL, 'SM00063', NULL, NULL, NULL, NULL, 'FRI_4', NULL, NULL, 18804, 20),
(283747, NULL, 'SM00708', NULL, NULL, NULL, NULL, 'phbp', NULL, NULL, 10317, 20),
(283748, NULL, 'SM00449', NULL, NULL, NULL, NULL, 'SPRY_3', NULL, NULL, 6285, 20),
(283749, NULL, 'SM01366', NULL, NULL, NULL, NULL, 'c_clamp_2', NULL, NULL, NULL, 20),
(283750, NULL, 'SM00026', NULL, NULL, NULL, NULL, 'ependymin2', NULL, NULL, 571, 20),
(283751, NULL, 'SM00814', NULL, NULL, NULL, NULL, 'alpha_tif', NULL, NULL, 1852, 20),
(283752, NULL, 'SM00358', NULL, NULL, NULL, NULL, 'DRBM_3', NULL, NULL, 12874, 20),
(283753, NULL, 'SM01301', NULL, NULL, NULL, NULL, 'PTPlike_phytase_2', NULL, NULL, NULL, 20),
(283754, NULL, 'SM01336', NULL, NULL, NULL, NULL, 'zf_PARP_3', NULL, NULL, 3246, 20),
(283755, NULL, 'SM00225', NULL, NULL, NULL, NULL, 'BTB_4', NULL, NULL, 1884, 20),
(283756, NULL, 'SM00532', NULL, NULL, NULL, NULL, 'ligaN3', NULL, NULL, 12867, 20),
(283757, NULL, 'SM00879', NULL, NULL, NULL, NULL, 'Brix_2', NULL, NULL, 338, 20),
(283758, NULL, 'SM00343', NULL, NULL, NULL, NULL, 'c2hcfinal6', NULL, NULL, 4426, 20),
(283759, NULL, 'SM01186', NULL, NULL, NULL, NULL, 'eIF3_N_2', NULL, NULL, 15736, 20),
(283760, NULL, 'SM01289', NULL, NULL, NULL, NULL, 'PYRIN_2', NULL, NULL, 996, 20);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(283761, NULL, 'SM00222', NULL, NULL, NULL, NULL, 'sec7_5', NULL, NULL, 3401, 20),
(283762, NULL, 'SM00630', NULL, NULL, NULL, NULL, 'sema', NULL, NULL, 5095, 20),
(283763, NULL, 'SM00400', NULL, NULL, NULL, NULL, 'primzinc3', NULL, NULL, 3716, 20),
(283764, NULL, 'SM00778', NULL, NULL, NULL, NULL, 'prim_zn_ribbon', NULL, NULL, 12901, 20),
(283765, NULL, 'SM00667', NULL, NULL, NULL, NULL, 'Lish', NULL, NULL, 1021, 20),
(283766, NULL, 'SM00999', NULL, NULL, NULL, NULL, 'Aerolysin_2', NULL, NULL, 5581, 20),
(283767, NULL, 'SM00553', NULL, NULL, NULL, NULL, 'faf_3', NULL, NULL, 12278, 20),
(283768, NULL, 'SM00127', NULL, NULL, NULL, NULL, 'IL7_1', NULL, NULL, 1376, 20),
(283769, NULL, 'SM00437', NULL, NULL, NULL, NULL, 'topIaneu2', NULL, NULL, 219, 20),
(283770, NULL, 'SM00899', NULL, NULL, NULL, NULL, 'FeoA_2', NULL, NULL, 20, 20),
(283771, NULL, 'SM00349', NULL, NULL, NULL, NULL, 'krabfinus', NULL, NULL, 4346, 20),
(283772, NULL, 'SM00098', NULL, NULL, NULL, NULL, 'alk_phosph_2', NULL, NULL, 2005, 20),
(283773, NULL, 'SM00454', NULL, NULL, NULL, NULL, 'SAM_4', NULL, NULL, 5007, 20),
(283774, NULL, 'SM01216', NULL, NULL, NULL, NULL, 'Fmp27_WPPW_2', NULL, NULL, 17262, 20),
(283775, NULL, 'SM00883', NULL, NULL, NULL, NULL, 'Cpn10_2', NULL, NULL, 14568, 20),
(283776, NULL, 'SM00034', NULL, NULL, NULL, NULL, 'CLECT_2', NULL, NULL, 179, 20),
(283777, NULL, 'SM00715', NULL, NULL, NULL, NULL, 'la', NULL, NULL, 1268, 20),
(283778, NULL, 'SM00696', NULL, NULL, NULL, NULL, 'dm9', NULL, NULL, 1482, 20),
(283779, NULL, 'SM00903', NULL, NULL, NULL, NULL, 'Flavin_Reduct_2', NULL, NULL, 1941, 20),
(283780, NULL, 'SM00797', NULL, NULL, NULL, NULL, 'ahs2', NULL, NULL, 3496, 20),
(283781, NULL, 'SM00640', NULL, NULL, NULL, NULL, 'glyco_32', NULL, NULL, 7419, 20),
(283782, NULL, 'SM01272', NULL, NULL, NULL, NULL, 'LsmAD_2', NULL, NULL, 1579, 20),
(283783, NULL, 'SM00980', NULL, NULL, NULL, NULL, 'THAP_2', NULL, NULL, 1288, 20),
(283784, NULL, 'SM01257', NULL, NULL, NULL, NULL, 'KRAP_IP3R_bind_2', NULL, NULL, 21804, 20),
(283785, NULL, 'SM01085', NULL, NULL, NULL, NULL, 'CK_II_beta_2', NULL, NULL, 6522, 20),
(283786, NULL, 'SM01324', NULL, NULL, NULL, NULL, 'YARHG_2', NULL, NULL, 24838, 20),
(283787, NULL, 'SM00658', NULL, NULL, NULL, NULL, 'rpol8neu', NULL, NULL, 1654, 20),
(283788, NULL, 'SM00830', NULL, NULL, NULL, NULL, 'CM_2_4', NULL, NULL, 3840, 20),
(283789, NULL, 'SM00954', NULL, NULL, NULL, NULL, 'RelA_SpoT_2', NULL, NULL, 753, 20),
(283790, NULL, 'SM00914', NULL, NULL, NULL, NULL, 'IDEAL_2', NULL, NULL, 14214, 20),
(283791, NULL, 'SM01306', NULL, NULL, NULL, NULL, 'RFX5_DNA_bdg_2', NULL, NULL, 26909, 20),
(283792, NULL, 'SM00898', NULL, NULL, NULL, NULL, 'Fapy_DNA_glyco_2', NULL, NULL, 11684, 20),
(283793, NULL, 'SM00880', NULL, NULL, NULL, NULL, 'CHAD_3', NULL, NULL, 3387, 20),
(283794, NULL, 'SM00139', NULL, NULL, NULL, NULL, 'MyTH4_1', NULL, NULL, 4768, 20),
(283795, NULL, 'SM00095', NULL, NULL, NULL, NULL, 'transthy-fin', NULL, NULL, 16259, 20),
(283796, NULL, 'SM00656', NULL, NULL, NULL, NULL, 'amb_all', NULL, NULL, 5434, 20),
(283797, NULL, 'SM01385', NULL, NULL, NULL, NULL, 'DSS1_SEM1_2', NULL, NULL, 2191, 20),
(283798, NULL, 'SM00714', NULL, NULL, NULL, NULL, 'litaf', NULL, NULL, 1034, 20),
(283799, NULL, 'SM00725', NULL, NULL, NULL, NULL, 'neat', NULL, NULL, 1008, 20),
(283800, NULL, 'SM00146', NULL, NULL, NULL, NULL, 'pi3k_hr1_6', NULL, NULL, 4860, 20),
(283801, NULL, 'SM01149', NULL, NULL, NULL, NULL, 'DUF1237_2a', NULL, NULL, 7502, 20),
(283802, NULL, 'SM00539', NULL, NULL, NULL, NULL, 'ylk_9', NULL, NULL, 4446, 20),
(283803, NULL, 'SM00963', NULL, NULL, NULL, NULL, 'SRP54_N_2', NULL, NULL, 9380, 20),
(283804, NULL, 'SM00700', NULL, NULL, NULL, NULL, 'jhbp', NULL, NULL, 8192, 20),
(283805, NULL, 'SM00020', NULL, NULL, NULL, NULL, 'trypsin_2', NULL, NULL, 2102, 20),
(283806, NULL, 'SM01030', NULL, NULL, NULL, NULL, 'BHD_1_2', NULL, NULL, 17670, 20),
(283807, NULL, 'SM00949', NULL, NULL, NULL, NULL, 'PAZ_2_a_3', NULL, NULL, 1158, 20),
(283808, NULL, 'SM00407', NULL, NULL, NULL, NULL, 'igc1_4', NULL, NULL, 17, 20);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(283809, NULL, 'SM01005', NULL, NULL, NULL, NULL, 'Ala_racemase_C_2', NULL, NULL, 10319, 20),
(283810, NULL, 'SM01210', NULL, NULL, NULL, NULL, 'GARS_C_2', NULL, NULL, 14743, 20),
(283811, NULL, 'SM00541', NULL, NULL, NULL, NULL, 'fyrn_3', NULL, NULL, 4314, 20),
(283812, NULL, 'SM00662', NULL, NULL, NULL, NULL, 'rpoldneu2', NULL, NULL, 9816, 20),
(283813, NULL, 'SM00408', NULL, NULL, NULL, NULL, 'igc2_5', NULL, NULL, 439, 20),
(283814, NULL, 'SM00047', NULL, NULL, NULL, NULL, 'Lysozyme_4', NULL, NULL, 6308, 20),
(283815, NULL, 'SM00064', NULL, NULL, NULL, NULL, 'fyve_4', NULL, NULL, 705, 20),
(283816, NULL, 'SM00881', NULL, NULL, NULL, NULL, 'CoA_binding_2', NULL, NULL, 3353, 20),
(283817, NULL, 'SM01063', NULL, NULL, NULL, NULL, 'CBM49_2', NULL, NULL, 15617, 20),
(283818, NULL, 'SM00066', NULL, NULL, NULL, NULL, 'gal4_2', NULL, NULL, 2419, 20),
(283819, NULL, 'SM00240', NULL, NULL, NULL, NULL, 'FHA_2', NULL, NULL, 4899, 20),
(283820, NULL, 'SM00488', NULL, NULL, NULL, NULL, 'deadxpd', NULL, NULL, 63, 20),
(283821, NULL, 'SM00023', NULL, NULL, NULL, NULL, 'colipase2', NULL, NULL, 2227, 20),
(283822, NULL, 'SM01243', NULL, NULL, NULL, NULL, 'IRF_3_2', NULL, NULL, 17397, 20),
(283823, NULL, 'SM00091', NULL, NULL, NULL, NULL, 'pas_2', NULL, NULL, 3787, 20),
(283824, NULL, 'SM00456', NULL, NULL, NULL, NULL, 'ww_5', NULL, NULL, 1285, 20),
(283825, NULL, 'SM00893', NULL, NULL, NULL, NULL, 'ETF_2', NULL, NULL, 13087, 20),
(283826, NULL, 'SM00141', NULL, NULL, NULL, NULL, 'PDGF_2', NULL, NULL, 2821, 20),
(283827, NULL, 'SM00394', NULL, NULL, NULL, NULL, 'akam_3', NULL, NULL, 1715, 20),
(283828, NULL, 'SM00088', NULL, NULL, NULL, NULL, 'PINT_4', NULL, NULL, 6531, 20),
(283829, NULL, 'SM01375', NULL, NULL, NULL, NULL, 'Dynein_light_2', NULL, NULL, 463, 20),
(283830, NULL, 'SM00291', NULL, NULL, NULL, NULL, 'zz_5', NULL, NULL, 4349, 20),
(283831, NULL, 'SM01281', NULL, NULL, NULL, NULL, 'Med12_2', NULL, NULL, 15787, 20),
(283832, NULL, 'SM00193', NULL, NULL, NULL, NULL, 'PTN_2', NULL, NULL, 4159, 20),
(283833, NULL, 'SM01229', NULL, NULL, NULL, NULL, 'GluR_Homer_bdg_2', NULL, NULL, 20404, 20),
(283834, NULL, 'SM01144', NULL, NULL, NULL, NULL, 'DTW_2a', NULL, NULL, 2738, 20),
(283835, NULL, 'SM01280', NULL, NULL, NULL, NULL, 'Mcm10_2', NULL, NULL, 14480, 20),
(283836, NULL, 'SM00544', NULL, NULL, NULL, NULL, 'ma3_7', NULL, NULL, 6411, 20),
(283837, NULL, 'SM01339', NULL, NULL, NULL, NULL, 'NODP_2', NULL, NULL, 10798, 20),
(283838, NULL, 'SM00985', NULL, NULL, NULL, NULL, 'UBA_e1_C_a_2', NULL, NULL, 14993, 20),
(283839, NULL, 'SM01309', NULL, NULL, NULL, NULL, 'RICTOR_phospho_2', NULL, NULL, 21814, 20),
(283840, NULL, 'SM00320', NULL, NULL, NULL, NULL, 'WD40_4', NULL, NULL, 3012, 20),
(283841, NULL, 'SM01121', NULL, NULL, NULL, NULL, 'Dak1_2_2', NULL, NULL, 29046, 20),
(283842, NULL, 'SM00183', NULL, NULL, NULL, NULL, 'natb', NULL, NULL, 5674, 20),
(283843, NULL, 'SM00861', NULL, NULL, NULL, NULL, 'Transket_pyr_3', NULL, NULL, 529, 20),
(283844, NULL, 'SM00258', NULL, NULL, NULL, NULL, 'SAND_2', NULL, NULL, 3994, 20),
(283845, NULL, 'SM01294', NULL, NULL, NULL, NULL, '17clusters_betabranch_W', NULL, NULL, NULL, 20),
(283846, NULL, 'SM00022', NULL, NULL, NULL, NULL, 'pla2_6', NULL, NULL, 2614, 20),
(283847, NULL, 'SM00515', NULL, NULL, NULL, NULL, '542_3', NULL, NULL, 3794, 20),
(283848, NULL, 'SM00344', NULL, NULL, NULL, NULL, 'asnc', NULL, NULL, 14643, 20),
(283849, NULL, 'SM00299', NULL, NULL, NULL, NULL, 'CLH_2', NULL, NULL, 5639, 20),
(283850, NULL, 'SM00099', NULL, NULL, NULL, NULL, 'btg1_nr', NULL, NULL, 1263, 20),
(283851, NULL, 'SM00906', NULL, NULL, NULL, NULL, 'Fungal_trans_2', NULL, NULL, 6212, 20),
(283852, NULL, 'SM00357', NULL, NULL, NULL, NULL, 'csp_8', NULL, NULL, 9641, 20),
(283853, NULL, 'SM00523', NULL, NULL, NULL, NULL, 'dwAneu5', NULL, NULL, 503, 20),
(283854, NULL, 'SM00818', NULL, NULL, NULL, NULL, 'amelogenin', NULL, NULL, 1759, 20),
(283855, NULL, 'SM00281', NULL, NULL, NULL, NULL, 'LamB_3a', NULL, NULL, 2870, 20),
(283856, NULL, 'SM00785', NULL, NULL, NULL, NULL, 'aarp2cn2', NULL, NULL, 18857, 20); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(283857, NULL, 'SM01011', NULL, NULL, NULL, NULL, 'AMP_N_2', NULL, NULL, 3270, 20),
(283858, NULL, 'SM00495', NULL, NULL, NULL, NULL, 'chi_5', NULL, NULL, 999, 20),
(283859, NULL, 'SM01069', NULL, NULL, NULL, NULL, 'CDC37_C_2', NULL, NULL, 9721, 20),
(283860, NULL, 'SM00203', NULL, NULL, NULL, NULL, 'tach2_nr', NULL, NULL, 609, 20),
(283861, NULL, 'SM00606', NULL, NULL, NULL, NULL, 'cbd', NULL, NULL, 475, 20),
(283862, NULL, 'SM00750', NULL, NULL, NULL, NULL, 'kind', NULL, NULL, 9008, 20),
(283863, NULL, 'SM00810', NULL, NULL, NULL, NULL, 'alpha-amyl_c2', NULL, NULL, 12090, 20),
(283864, NULL, 'SM00444', NULL, NULL, NULL, NULL, 'gyf_5', NULL, NULL, 1962, 20),
(283865, NULL, 'SM01379', NULL, NULL, NULL, NULL, 'GAGE_2', NULL, NULL, 26330, 20),
(283866, NULL, 'SM00755', NULL, NULL, NULL, NULL, '1grip', NULL, NULL, 672, 20),
(283867, NULL, 'SM00415', NULL, NULL, NULL, NULL, 'hsfneu3', NULL, NULL, 689, 20),
(283868, NULL, 'SM00351', NULL, NULL, NULL, NULL, 'pax3', NULL, NULL, 5743, 20),
(283869, NULL, 'SM00199', NULL, NULL, NULL, NULL, 'SCY_2', NULL, NULL, 4008, 20),
(283870, NULL, 'SM00580', NULL, NULL, NULL, NULL, 'PGNneu', NULL, NULL, NULL, 20),
(283871, NULL, 'SM00186', NULL, NULL, NULL, NULL, 'FBG_2', NULL, NULL, 5941, 20),
(283872, NULL, 'SM00730', NULL, NULL, NULL, NULL, 'psh_8', NULL, NULL, 1159, 20),
(283873, NULL, 'SM00037', NULL, NULL, NULL, NULL, 'CNX_2', NULL, NULL, 8254, 20),
(283874, NULL, 'SM00941', NULL, NULL, NULL, NULL, 'PYNP_C_2', NULL, NULL, 18795, 20),
(283875, NULL, 'SM00314', NULL, NULL, NULL, NULL, 'RA_5', NULL, NULL, 3992, 20),
(283876, NULL, 'SM00770', NULL, NULL, NULL, NULL, 'Zn_dep_PLPC_cls', NULL, NULL, 3136, 20),
(283877, NULL, 'SM00807', NULL, NULL, NULL, NULL, 'akap_110', NULL, NULL, 21081, 20),
(283878, NULL, 'SM00401', NULL, NULL, NULL, NULL, 'GATA_3', NULL, NULL, 3606, 20),
(283879, NULL, 'SM00464', NULL, NULL, NULL, NULL, 'lon_5', NULL, NULL, 2619, 20),
(283880, NULL, 'SM01397', NULL, NULL, NULL, NULL, 'Ribosomal_S3Ae_2', NULL, NULL, 5246, 20),
(283881, NULL, 'SM00338', NULL, NULL, NULL, NULL, 'brlzneu', NULL, NULL, 4006, 20),
(283882, NULL, 'SM01259', NULL, NULL, NULL, NULL, 'LAB_N_2', NULL, NULL, 12873, 20),
(283883, NULL, 'SM00364', NULL, NULL, NULL, NULL, 'LRR_bac_2', NULL, NULL, NULL, 20),
(283884, NULL, 'SM00924', NULL, NULL, NULL, NULL, 'MgtE_N_2', NULL, NULL, 1908, 20),
(283885, NULL, 'SM00749', NULL, NULL, NULL, NULL, 'bon', NULL, NULL, 9095, 20),
(283886, NULL, 'SM00911', NULL, NULL, NULL, NULL, 'HWE_HK_2', NULL, NULL, 11050, 20),
(283887, NULL, 'SM01021', NULL, NULL, NULL, NULL, 'Bac_rhodopsin_2', NULL, NULL, 6977, 20),
(283888, NULL, 'SM00005', NULL, NULL, NULL, NULL, 'DEATH_4', NULL, NULL, 5848, 20),
(283889, NULL, 'SM00742', NULL, NULL, NULL, NULL, 'hr1_7', NULL, NULL, 10484, 20),
(283890, NULL, 'SM00341', NULL, NULL, NULL, NULL, 'hrdc7', NULL, NULL, 1441, 20),
(283891, NULL, 'SM00952', NULL, NULL, NULL, NULL, 'RAP_3', NULL, NULL, 11607, 20),
(283892, NULL, 'SM00520', NULL, NULL, NULL, NULL, 'basic', NULL, NULL, 1985, 20),
(283893, NULL, 'SM00945', NULL, NULL, NULL, NULL, 'ProQ_a_2', NULL, NULL, 11256, 20),
(283894, NULL, 'SM00265', NULL, NULL, NULL, NULL, 'bh4_2', NULL, NULL, 703, 20),
(283895, NULL, 'SM00516', NULL, NULL, NULL, NULL, 'sec14_4', NULL, NULL, 6774, 20),
(283896, NULL, 'SM01250', NULL, NULL, NULL, NULL, 'KAT11_2', NULL, NULL, 17050, 20),
(283897, NULL, 'SM00583', NULL, NULL, NULL, NULL, 'backtest2', NULL, NULL, 114, 20),
(283898, NULL, 'SM00097', NULL, NULL, NULL, NULL, 'wnt1_3', NULL, NULL, 5688, 20),
(283899, NULL, 'SM00502', NULL, NULL, NULL, NULL, 'RAD_5', NULL, NULL, 1428, 20),
(283900, NULL, 'SM00422', NULL, NULL, NULL, NULL, 'merrmega3', NULL, NULL, 5889, 20),
(283901, NULL, 'SM00136', NULL, NULL, NULL, NULL, 'LamNT_2', NULL, NULL, 7497, 20),
(283902, NULL, 'SM01358', NULL, NULL, NULL, NULL, 'HBM_sequencesselection_2', NULL, NULL, 24201, 20),
(283903, NULL, 'SM00858', NULL, NULL, NULL, NULL, 'SAF_3', NULL, NULL, 7557, 20),
(283904, NULL, 'SM00439', NULL, NULL, NULL, NULL, 'BAH_4', NULL, NULL, 1219, 20),
(283905, NULL, 'SM00094', NULL, NULL, NULL, NULL, 'transfer-fin', NULL, NULL, 1470, 20);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(283906, NULL, 'SM00188', NULL, NULL, NULL, NULL, 'int10', NULL, NULL, 18925, 20),
(283907, NULL, 'SM00450', NULL, NULL, NULL, NULL, 'rhod_4', NULL, NULL, 3448, 20),
(283908, NULL, 'SM01224', NULL, NULL, NULL, NULL, 'G_gamma_2', NULL, NULL, NULL, 20),
(283909, NULL, 'SM00657', NULL, NULL, NULL, NULL, 'rpol4neu2', NULL, NULL, 342, 20),
(283910, NULL, 'SM00289', NULL, NULL, NULL, NULL, 'WR1_2', NULL, NULL, 10278, 20),
(283911, NULL, 'SM01023', NULL, NULL, NULL, NULL, 'BAF_2', NULL, NULL, 1899, 20),
(283912, NULL, 'SM00215', NULL, NULL, NULL, NULL, 'vwc2', NULL, NULL, 2283, 20),
(283913, NULL, 'SM01096', NULL, NULL, NULL, NULL, 'CPSase_L_D3_2', NULL, NULL, 534, 20),
(283914, NULL, 'SM00596', NULL, NULL, NULL, NULL, '115neu5', NULL, NULL, 228, 20),
(283915, NULL, 'SM00460', NULL, NULL, NULL, NULL, 'TG_5', NULL, NULL, 6751, 20),
(283916, NULL, 'SM01008', NULL, NULL, NULL, NULL, 'Ald_Xan_dh_C_2', NULL, NULL, 3645, 20),
(283917, NULL, 'SM01044', NULL, NULL, NULL, NULL, 'Btz_2', NULL, NULL, 15087, 20),
(283918, NULL, 'SM00184', NULL, NULL, NULL, NULL, 'ring_2', NULL, NULL, 4043, 20),
(283919, NULL, 'SM00227', NULL, NULL, NULL, NULL, 'nebu_4', NULL, NULL, 3188, 20),
(283920, NULL, 'SM01161', NULL, NULL, NULL, NULL, 'DUF1767_2', NULL, NULL, 31001, 20),
(283921, NULL, 'SM01073', NULL, NULL, NULL, NULL, 'CDC48_N_2', NULL, NULL, 4076, 20),
(283922, NULL, 'SM00874', NULL, NULL, NULL, NULL, 'B5_2', NULL, NULL, 4285, 20),
(283923, NULL, 'SM00128', NULL, NULL, NULL, NULL, 'i5p_5', NULL, NULL, 4965, 20),
(283924, NULL, 'SM00823', NULL, NULL, 'Phosphopantetheine attachment site', NULL, 'PKS_PP', NULL, NULL, 19319, 20),
(283925, NULL, 'SM00524', NULL, NULL, NULL, NULL, 'dwBultra2', NULL, NULL, 1602, 20),
(283926, NULL, 'SM00359', NULL, NULL, NULL, NULL, 'pua_5', NULL, NULL, 658, 20),
(283927, NULL, 'SM00632', NULL, NULL, NULL, NULL, 'Aamy_c', NULL, NULL, 25748, 20),
(283928, NULL, 'SM01238', NULL, NULL, NULL, NULL, 'IGR_2', NULL, NULL, 16922, 20),
(283929, NULL, 'SM00562', NULL, NULL, NULL, NULL, 'ndk_5', NULL, NULL, 28480, 20),
(283930, NULL, 'SM00019', NULL, NULL, NULL, NULL, 'surpal', NULL, NULL, 3424, 20),
(283931, NULL, 'SM00442', NULL, NULL, NULL, NULL, 'FGF_2', NULL, NULL, 5967, 20),
(283932, NULL, 'SM00834', NULL, NULL, NULL, NULL, 'CxxC_CXXC_SSSS_2', NULL, NULL, 9386, 20),
(283933, NULL, 'SM00864', NULL, NULL, NULL, NULL, 'Tubulin_4', NULL, NULL, 7222, 20),
(283934, NULL, 'SM00540', NULL, NULL, NULL, NULL, 'lem_2', NULL, NULL, 4115, 20),
(283935, NULL, 'SM00354', NULL, NULL, NULL, NULL, 'laci3', NULL, NULL, 411, 20),
(283936, NULL, 'SM00950', NULL, NULL, NULL, NULL, 'Piwi_a_2', NULL, NULL, 1545, 20),
(283937, NULL, 'SM00253', NULL, NULL, NULL, NULL, 'socs_2', NULL, NULL, 3306, 20),
(283938, NULL, 'SM00940', NULL, NULL, NULL, NULL, 'PepX_N_2', NULL, NULL, 12098, 20),
(283939, NULL, 'SM00717', NULL, NULL, NULL, NULL, 'sant', NULL, NULL, 4393, 20),
(283940, NULL, 'SM01080', NULL, NULL, NULL, NULL, 'CHASE2_2', NULL, NULL, 3249, 20),
(283941, NULL, 'SM01006', NULL, NULL, NULL, NULL, 'AlcB_2', NULL, NULL, 17256, 20),
(283942, NULL, 'SM01187', NULL, NULL, NULL, NULL, 'Elicitin_2', NULL, NULL, 206, 20),
(283943, NULL, 'SM00459', NULL, NULL, NULL, NULL, 'sorbin_1', NULL, NULL, 2516, 20),
(283944, NULL, 'SM00424', NULL, NULL, NULL, NULL, 'ste', NULL, NULL, 2665, 20),
(283945, NULL, 'SM01282', NULL, NULL, NULL, NULL, 'DBB_2', NULL, NULL, 2628, 20),
(283946, NULL, 'SM01242', NULL, NULL, NULL, NULL, 'Integrin_B_tail_2', NULL, NULL, 13098, 20),
(283947, NULL, 'SM00288', NULL, NULL, NULL, NULL, 'VHS_2', NULL, NULL, 2068, 20),
(283948, NULL, 'SM00303', NULL, NULL, NULL, NULL, 'GPS_3', NULL, NULL, 3639, 20),
(283949, NULL, 'SM00108', NULL, NULL, NULL, NULL, 'blect_4', NULL, NULL, 3016, 20),
(283950, NULL, 'SM00179', NULL, NULL, NULL, NULL, 'egfca_6', NULL, NULL, 4350, 20),
(283951, NULL, 'SM00101', NULL, NULL, NULL, NULL, '1433_4', NULL, NULL, 16410, 20),
(283952, NULL, 'SM00684', NULL, NULL, NULL, NULL, 'dm15', NULL, NULL, 1218, 20),
(283953, NULL, 'SM00030', NULL, NULL, NULL, NULL, 'clus1b', NULL, NULL, 11003, 20);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(283954, NULL, 'SM01042', NULL, NULL, NULL, NULL, 'Brr6_like_C_C_2', NULL, NULL, 18064, 20),
(283955, NULL, 'SM00276', NULL, NULL, NULL, NULL, 'galectin_3', NULL, NULL, 2387, 20),
(283956, NULL, 'SM00079', NULL, NULL, NULL, NULL, 'GluR_14', NULL, NULL, 116, 20),
(283957, NULL, 'SM00560', NULL, NULL, NULL, NULL, 'LamGL_3', NULL, NULL, 383, 20),
(283958, NULL, 'SM01249', NULL, NULL, NULL, NULL, 'KASH_2', NULL, NULL, 11905, 20),
(283959, NULL, 'SM00509', NULL, NULL, NULL, NULL, 'TFS2_5', NULL, NULL, 603, 20),
(283960, NULL, 'SM00652', NULL, NULL, NULL, NULL, 'eIF1neu4', NULL, NULL, 624, 20),
(283961, NULL, 'SM01045', NULL, NULL, NULL, NULL, 'BURP_2', NULL, NULL, 7494, 20),
(283962, NULL, 'SM00526', NULL, NULL, NULL, NULL, 'h15plus2', NULL, NULL, 5977, 20),
(283963, NULL, 'SM00530', NULL, NULL, NULL, NULL, 'mbf_short4', NULL, NULL, 2217, 20),
(283964, NULL, 'SM01284', NULL, NULL, NULL, NULL, 'ECIST_Cterm_2', NULL, NULL, 21945, 20),
(283965, NULL, 'SM00978', NULL, NULL, NULL, NULL, 'Tim44_a_2', NULL, NULL, 5695, 20),
(283966, NULL, 'SM01370', NULL, NULL, NULL, NULL, 'TAFII55_N_2', NULL, NULL, 2926, 20),
(283967, NULL, 'SM01221', NULL, NULL, NULL, NULL, 'FTCD_2', NULL, NULL, 9780, 20),
(283968, NULL, 'SM00015', NULL, NULL, NULL, NULL, 'iq_5', NULL, NULL, 2708, 20),
(283969, NULL, 'SM01369', NULL, NULL, NULL, NULL, 'Rb_C_2', NULL, NULL, 7943, 20),
(283970, NULL, 'SM00339', NULL, NULL, NULL, NULL, 'forkneu4', NULL, NULL, 3039, 20),
(283971, NULL, 'SM01026', NULL, NULL, NULL, NULL, 'Beach_2', NULL, NULL, 299, 20),
(283972, NULL, 'SM01206', NULL, NULL, NULL, NULL, 'Fibrillarin_2', NULL, NULL, 6978, 20),
(283973, NULL, 'SM00412', NULL, NULL, NULL, NULL, 'copper1', NULL, NULL, 2454, 20),
(283974, NULL, 'SM00689', NULL, NULL, NULL, NULL, 'dm6', NULL, NULL, 1054, 20),
(283975, NULL, 'SM01326', NULL, NULL, NULL, NULL, 'PTEN_C2_2', NULL, NULL, 9091, 20),
(283976, NULL, 'SM00173', NULL, NULL, NULL, NULL, 'ras_sub_4', NULL, NULL, NULL, 20),
(283977, NULL, 'SM00676', NULL, NULL, NULL, NULL, 'dm10', NULL, NULL, 1440, 20),
(283978, NULL, 'SM00638', NULL, NULL, NULL, NULL, 'lpd_n', NULL, NULL, 4990, 20),
(283979, NULL, 'SM01048', NULL, NULL, NULL, NULL, 'C6_2', NULL, NULL, 1764, 20),
(283980, NULL, 'SM00728', NULL, NULL, NULL, NULL, 'chw', NULL, NULL, 1113, 20),
(283981, NULL, 'SM01067', NULL, NULL, NULL, NULL, 'CBM_3_2', NULL, NULL, 4062, 20),
(283982, NULL, 'SM01329', NULL, NULL, NULL, NULL, 'Iso_dh_2', NULL, NULL, 12312, 20),
(283983, NULL, 'SM01268', NULL, NULL, NULL, NULL, 'BTD_2', NULL, NULL, 13273, 20),
(283984, NULL, 'SM01060', NULL, NULL, NULL, NULL, 'Catalase_2', NULL, NULL, 12342, 20),
(283985, NULL, 'SM00534', NULL, NULL, NULL, NULL, 'mutATP5', NULL, NULL, 4830, 20),
(283986, NULL, 'SM00986', NULL, NULL, NULL, NULL, 'UDG_2', NULL, NULL, 7100, 20),
(283987, NULL, 'SM00935', NULL, NULL, NULL, NULL, 'OmpH_2', NULL, NULL, 2735, 20),
(283988, NULL, 'SM00310', NULL, NULL, NULL, NULL, 'PTBI_2', NULL, NULL, 6975, 20),
(283989, NULL, 'SM00216', NULL, NULL, NULL, NULL, 'VWD_2', NULL, NULL, 4402, 20),
(283990, NULL, 'SM01290', NULL, NULL, NULL, NULL, 'N_glycanase_N_2', NULL, NULL, 10827, 20),
(283991, NULL, 'SM01373', NULL, NULL, NULL, NULL, 'MAGE_2', NULL, NULL, 88, 20),
(283992, NULL, 'SM01001', NULL, NULL, NULL, NULL, 'AIRC_2', NULL, NULL, 3785, 20),
(283993, NULL, 'SM00132', NULL, NULL, NULL, NULL, 'lim_4', NULL, NULL, 4789, 20),
(283994, NULL, 'SM00777', NULL, NULL, NULL, NULL, 'mad3_bub1_i', NULL, NULL, 17779, 20),
(283995, NULL, 'SM00832', NULL, NULL, NULL, NULL, 'c8_a', NULL, NULL, 12393, 20),
(283996, NULL, 'SM00787', NULL, NULL, NULL, NULL, 'spc73', NULL, NULL, 13175, 20),
(283997, NULL, 'SM00028', NULL, NULL, NULL, NULL, 'tpr_5', NULL, NULL, 20936, 20),
(283998, NULL, 'SM00237', NULL, NULL, NULL, NULL, 'NIbeta_1', NULL, NULL, 1472, 20),
(283999, NULL, 'SM00762', NULL, NULL, NULL, NULL, 'cog4.2seq4', NULL, NULL, 8769, 20),
(284000, NULL, 'SM01416', NULL, NULL, NULL, NULL, 'Ribosomal_L19e_2', NULL, NULL, 1105, 20),
(284001, NULL, 'SM00282', NULL, NULL, NULL, NULL, 'LamG_3', NULL, NULL, 3322, 20);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(284002, NULL, 'SM00719', NULL, NULL, NULL, NULL, 'rtf1', NULL, NULL, 4630, 20),
(284003, NULL, 'SM00845', NULL, NULL, NULL, NULL, 'gatb_yqey_2', NULL, NULL, 16568, 20),
(284004, NULL, 'SM00327', NULL, NULL, NULL, NULL, 'VWA_4', NULL, NULL, 2425, 20),
(284005, NULL, 'SM01091', NULL, NULL, NULL, NULL, 'CorC_HlyC_2', NULL, NULL, 4889, 20),
(284006, NULL, 'SM01148', NULL, NULL, NULL, NULL, 'DUF1220_2', NULL, NULL, 9131, 20),
(284007, NULL, 'SM00582', NULL, NULL, NULL, NULL, '558neu5', NULL, NULL, 264, 20),
(284008, NULL, 'SM00075', NULL, NULL, NULL, NULL, 'hydro', NULL, NULL, 133, 20),
(284009, NULL, 'SM00936', NULL, NULL, NULL, NULL, 'PBP5_C_2', NULL, NULL, 13355, 20),
(284010, NULL, 'SM00693', NULL, NULL, NULL, NULL, 'dysfn', NULL, NULL, 1157, 20),
(284011, NULL, 'SM00250', NULL, NULL, NULL, NULL, 'plec_5', NULL, NULL, 5121, 20),
(284012, NULL, 'SM00213', NULL, NULL, NULL, NULL, 'ubq_7', NULL, NULL, 4344, 20),
(284013, NULL, 'SM00602', NULL, NULL, NULL, NULL, 'vps10', NULL, NULL, 282, 20),
(284014, NULL, 'SM00764', NULL, NULL, NULL, NULL, 'citrate_ly_lig5', NULL, NULL, 8850, 20),
(284015, NULL, 'SM01246', NULL, NULL, NULL, NULL, 'Josephin_2', NULL, NULL, 10439, 20),
(284016, NULL, 'SM00479', NULL, NULL, NULL, NULL, 'exoiiiendus', NULL, NULL, 5532, 20),
(284017, NULL, 'SM00815', NULL, NULL, NULL, NULL, 'ama_1', NULL, NULL, 3240, 20),
(284018, NULL, 'SM00979', NULL, NULL, NULL, NULL, 'tify_2', NULL, NULL, 9041, 20),
(284019, NULL, 'SM00390', NULL, NULL, NULL, NULL, 'LGN_4', NULL, NULL, 2659, 20),
(284020, NULL, 'SM00165', NULL, NULL, NULL, NULL, 'uba_6', NULL, NULL, 8210, 20),
(284021, NULL, 'SM00521', NULL, NULL, NULL, NULL, 'cbf3', NULL, NULL, 2064, 20),
(284022, NULL, 'SM00181', NULL, NULL, NULL, NULL, 'egf_5', NULL, NULL, 3525, 20),
(284023, NULL, 'SM01389', NULL, NULL, NULL, NULL, 'Spt4_2', NULL, NULL, 17345, 20),
(284024, NULL, 'SM00393', NULL, NULL, NULL, NULL, 'R3H_4', NULL, NULL, 7141, 20),
(284025, NULL, 'SM01163', NULL, NULL, NULL, NULL, 'DUF1785_2', NULL, NULL, 11503, 20),
(284026, NULL, 'SM00894', NULL, NULL, NULL, NULL, 'Excalibur_2', NULL, NULL, 14325, 20),
(284027, NULL, 'SM00812', NULL, NULL, NULL, NULL, 'alpha_l_fucos', NULL, NULL, 3200, 20),
(284028, NULL, 'SM00529', NULL, NULL, NULL, NULL, 'dtx3', NULL, NULL, 16985, 20),
(284029, NULL, 'SM00204', NULL, NULL, NULL, NULL, 'TGFB_2', NULL, NULL, 4200, 20),
(284030, NULL, 'SM01099', NULL, NULL, NULL, NULL, 'CPW_WPC_2', NULL, NULL, 5501, 20),
(284031, NULL, 'SM01174', NULL, NULL, NULL, NULL, 'DUF4205_3', NULL, NULL, 23379, 20),
(284032, NULL, 'SM00788', NULL, NULL, NULL, NULL, 'adenylsucc_synt', NULL, NULL, 1412, 20),
(284033, NULL, 'SM00328', NULL, NULL, NULL, NULL, 'bpi1_3', NULL, NULL, 19207, 20),
(284034, NULL, 'SM00286', NULL, NULL, NULL, NULL, 'PTI_1', NULL, NULL, NULL, 20),
(284035, NULL, 'SM00839', NULL, NULL, NULL, NULL, 'ELFV_dehydrog_3', NULL, NULL, 2666, 20),
(284036, NULL, 'SM00643', NULL, NULL, NULL, NULL, 'c345c', NULL, NULL, 9168, 20),
(284037, NULL, 'SM00432', NULL, NULL, NULL, NULL, 'madsneu2', NULL, NULL, 1200, 20),
(284038, NULL, 'SM01038', NULL, NULL, NULL, NULL, 'Bgal_small_N_2', NULL, NULL, 572, 20),
(284039, NULL, 'SM00156', NULL, NULL, NULL, NULL, 'pp2a_7', NULL, NULL, 11072, 20),
(284040, NULL, 'SM00930', NULL, NULL, NULL, NULL, 'NIL_2', NULL, NULL, 17107, 20),
(284041, NULL, 'SM01139', NULL, NULL, NULL, NULL, 'Drf_FH3_2', NULL, NULL, 10084, 20),
(284042, NULL, 'SM00471', NULL, NULL, NULL, NULL, 'hd_13', NULL, NULL, 668, 20),
(284043, NULL, 'SM00835', NULL, NULL, NULL, NULL, 'Cupin_1_3', NULL, NULL, 2717, 20),
(284044, NULL, 'SM00593', NULL, NULL, NULL, NULL, '893paper3', NULL, NULL, 548, 20),
(284045, NULL, 'SM01098', NULL, NULL, NULL, NULL, 'CPSF73_100_C_2', NULL, NULL, 19332, 20),
(284046, NULL, 'SM00312', NULL, NULL, NULL, NULL, 'PX_2', NULL, NULL, 3227, 20),
(284047, NULL, 'SM01203', NULL, NULL, NULL, NULL, 'DUF3585_4', NULL, NULL, NULL, 20),
(284048, NULL, 'SM01241', NULL, NULL, NULL, NULL, 'Integrin_b_cyt_2', NULL, NULL, 11835, 20),
(284049, NULL, 'SM01083', NULL, NULL, NULL, NULL, 'Cir_N_3', NULL, NULL, 15590, 20);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(284050, NULL, 'SM00679', NULL, NULL, NULL, NULL, 'ctns', NULL, NULL, 1019, 20),
(284051, NULL, 'SM00508', NULL, NULL, NULL, NULL, 'PostSET_3', NULL, NULL, 506, 20),
(284052, NULL, 'SM01061', NULL, NULL, NULL, NULL, 'CAT_RBD_2', NULL, NULL, 4949, 20),
(284053, NULL, 'SM01076', NULL, NULL, NULL, NULL, 'CG_1_2', NULL, NULL, 1663, 20),
(284054, NULL, 'SM01222', NULL, NULL, NULL, NULL, 'FTCD_N_2', NULL, NULL, 13420, 20),
(284055, NULL, 'SM00680', NULL, NULL, NULL, NULL, 'clip', NULL, NULL, 14835, 20),
(284056, NULL, 'SM01261', NULL, NULL, NULL, NULL, 'Thymopoietin_2', NULL, NULL, 5232, 20),
(284057, NULL, 'SM00587', NULL, NULL, NULL, NULL, '121neu2hmm', NULL, NULL, 7800, 20),
(284058, NULL, 'SM00536', NULL, NULL, NULL, NULL, 'toby4', NULL, NULL, 1481, 20),
(284059, NULL, 'SM00191', NULL, NULL, NULL, NULL, 'int_alpha_rpt', NULL, NULL, 9312, 20),
(284060, NULL, 'SM01414', NULL, NULL, NULL, NULL, 'P68HR_2', NULL, NULL, 9228, 20),
(284061, NULL, 'SM00827', NULL, NULL, 'Acyl transferase domain in polyketide synthase (PKS) enzymes.', NULL, 'PKS_AT', NULL, NULL, 9362, 20),
(284062, NULL, 'SM00418', NULL, NULL, NULL, NULL, 'arsrmega2', NULL, NULL, 4484, 20),
(284063, NULL, 'SM00665', NULL, NULL, NULL, NULL, '561_7', NULL, NULL, 1136, 20),
(284064, NULL, 'SM01359', NULL, NULL, NULL, NULL, 'A2M_N_2_2', NULL, NULL, 9666, 20),
(284065, NULL, 'SM01362', NULL, NULL, NULL, NULL, 'DUF663_2', NULL, NULL, 6684, 20),
(284066, NULL, 'SM00159', NULL, NULL, NULL, NULL, 'PTX_2', NULL, NULL, 3338, 20),
(284067, NULL, 'SM00513', NULL, NULL, NULL, NULL, 'sap_9', NULL, NULL, 71, 20),
(284068, NULL, 'SM00190', NULL, NULL, NULL, NULL, 'il4b_nr', NULL, NULL, 297, 20),
(284069, NULL, 'SM00256', NULL, NULL, NULL, NULL, 'fbox_2', NULL, NULL, 4804, 20),
(284070, NULL, 'SM01410', NULL, NULL, NULL, NULL, 'DIM1_2', NULL, NULL, 1589, 20),
(284071, NULL, 'SM01211', NULL, NULL, NULL, NULL, 'GATase_5_2', NULL, NULL, NULL, 20),
(284072, NULL, 'SM01134', NULL, NULL, NULL, NULL, 'DeoRC_2', NULL, NULL, NULL, 20),
(284073, NULL, 'SM00545', NULL, NULL, NULL, NULL, 'JmjN_1', NULL, NULL, 4496, 20),
(284074, NULL, 'SM01341', NULL, NULL, NULL, NULL, 'Tower_2', NULL, NULL, 10850, 20),
(284075, NULL, 'SM01218', NULL, NULL, NULL, NULL, 'FoP_duplication_2', NULL, NULL, 24518, 20),
(284076, NULL, 'SM00561', NULL, NULL, NULL, NULL, 'l3mbt_4', NULL, NULL, 1582, 20),
(284077, NULL, 'SM00875', NULL, NULL, NULL, NULL, 'BACK_2', NULL, NULL, 8102, 20),
(284078, NULL, 'SM00919', NULL, NULL, NULL, NULL, 'Malic_M_2', NULL, NULL, 13027, 20),
(284079, NULL, 'SM01371', NULL, NULL, NULL, NULL, 'TFIIA_2', NULL, NULL, 7318, 20),
(284080, NULL, 'SM00795', NULL, NULL, NULL, NULL, 'agro_vird5', NULL, NULL, 3818, 20),
(284081, NULL, 'SM00962', NULL, NULL, NULL, NULL, 'SRP54_3', NULL, NULL, 260, 20),
(284082, NULL, 'SM00817', NULL, NULL, NULL, NULL, 'amelin', NULL, NULL, 2123, 20),
(284083, NULL, 'SM00317', NULL, NULL, NULL, NULL, 'set_7', NULL, NULL, 2465, 20),
(284084, NULL, 'SM00942', NULL, NULL, NULL, NULL, 'PriCT_1_2', NULL, NULL, 11545, 20),
(284085, NULL, 'SM00897', NULL, NULL, NULL, NULL, 'FIST_2', NULL, NULL, 13752, 20),
(284086, NULL, 'SM01016', NULL, NULL, NULL, NULL, 'Arg_tRNA_synt_N_2', NULL, NULL, 4226, 20),
(284087, NULL, 'SM01017', NULL, NULL, NULL, NULL, 'Arrestin_C_2', NULL, NULL, 9460, 20),
(284088, NULL, 'SM00308', NULL, NULL, NULL, NULL, 'LH2_4', NULL, NULL, 2447, 20),
(284089, NULL, 'SM00876', NULL, NULL, NULL, NULL, 'BATS_2', NULL, NULL, 9809, 20),
(284090, NULL, 'SM00674', NULL, NULL, NULL, NULL, 'cenpb', NULL, NULL, 1032, 20),
(284091, NULL, 'SM01296', NULL, NULL, NULL, NULL, 'N2227_2', NULL, NULL, 13280, 20),
(284092, NULL, 'SM00212', NULL, NULL, NULL, NULL, 'ubc_7', NULL, NULL, NULL, 20),
(284093, NULL, 'SM00120', NULL, NULL, NULL, NULL, 'HX_rpt_3', NULL, NULL, 21178, 20),
(284094, NULL, 'SM01190', NULL, NULL, NULL, NULL, 'EMP24_GP25L_2', NULL, NULL, 7905, 20),
(284095, NULL, 'SM01151', NULL, NULL, NULL, NULL, 'DUF1518_2', NULL, NULL, 8701, 20),
(284096, NULL, 'SM00712', NULL, NULL, NULL, NULL, 'pur', NULL, NULL, 1090, 20),
(284097, NULL, 'SM00873', NULL, NULL, NULL, NULL, 'B3_4_2', NULL, NULL, 4057, 20);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(284098, NULL, 'SM00200', NULL, NULL, NULL, NULL, 'SEA_3', NULL, NULL, 2621, 20),
(284099, NULL, 'SM00294', NULL, NULL, NULL, NULL, '4.1m_4', NULL, NULL, 164, 20),
(284100, NULL, 'SM00274', NULL, NULL, NULL, NULL, 'FOLN_3', NULL, NULL, 1367, 20),
(284101, NULL, 'SM00841', NULL, NULL, NULL, NULL, 'Elong_fact_P_C_2', NULL, NULL, 13812, 20),
(284102, NULL, 'SM01316', NULL, NULL, NULL, NULL, 'Spo7_2_N_2', NULL, NULL, 26607, 20),
(284103, NULL, 'SM01177', NULL, NULL, NULL, NULL, 'DUF4210_2', NULL, NULL, 23013, 20),
(284104, NULL, 'SM00838', NULL, NULL, NULL, NULL, 'EFG_C_a', NULL, NULL, 3508, 20),
(284105, NULL, 'SM01355', NULL, NULL, NULL, NULL, 'AP3B1_C_2', NULL, NULL, 24620, 20),
(284106, NULL, 'SM00938', NULL, NULL, NULL, NULL, 'P_II_3', NULL, NULL, 5890, 20),
(284107, NULL, 'SM00569', NULL, NULL, NULL, NULL, 'L27_neu3', NULL, NULL, 2920, 20),
(284108, NULL, 'SM00350', NULL, NULL, NULL, NULL, 'mcm', NULL, NULL, 22230, 20),
(284109, NULL, 'SM00125', NULL, NULL, NULL, NULL, 'IL1_2', NULL, NULL, NULL, 20),
(284110, NULL, 'SM00732', NULL, NULL, NULL, NULL, 'rnase_8s', NULL, NULL, 1457, 20),
(284111, NULL, 'SM01390', NULL, NULL, NULL, NULL, 'Ribosomal_S4_2', NULL, NULL, 4109, 20),
(284112, NULL, 'SM00271', NULL, NULL, NULL, NULL, 'dnaj_3', NULL, NULL, 1163, 20),
(284113, NULL, 'SM01209', NULL, NULL, NULL, NULL, 'GARS_A_3', NULL, NULL, NULL, 20),
(284114, NULL, 'SM00759', NULL, NULL, NULL, NULL, 'flu_m1_c2seq2', NULL, NULL, 17261, 20),
(284115, NULL, 'SM00724', NULL, NULL, NULL, NULL, 'lag1_27', NULL, NULL, 1352, 20),
(284116, NULL, 'SM00322', NULL, NULL, NULL, NULL, 'kh_6', NULL, NULL, 1657, 20),
(284117, NULL, 'SM01407', NULL, NULL, NULL, NULL, 'NAC_2', NULL, NULL, 3518, 20),
(284118, NULL, 'SM01074', NULL, NULL, NULL, NULL, 'Cdc6_C_2', NULL, NULL, 9714, 20),
(284119, NULL, 'SM00550', NULL, NULL, NULL, NULL, '1qbj_4', NULL, NULL, 36645, 20),
(284120, NULL, 'SM00104', NULL, NULL, NULL, NULL, 'ANATO_2', NULL, NULL, 2547, 20),
(284121, NULL, 'SM00413', NULL, NULL, NULL, NULL, 'etsneu2', NULL, NULL, 6517, 20),
(284122, NULL, 'SM01285', NULL, NULL, NULL, NULL, 'FACT_Spt16_Nlob_2', NULL, NULL, 25863, 20),
(284123, NULL, 'SM00783', NULL, NULL, NULL, NULL, 'a_amylase_inhib2', NULL, NULL, 4781, 20),
(284124, NULL, 'SM01248', NULL, NULL, NULL, NULL, 'KaiB_2', NULL, NULL, 10807, 20),
(284125, NULL, 'SM00872', NULL, NULL, NULL, NULL, 'Alpha_mann_mid_2', NULL, NULL, 13160, 20),
(284126, NULL, 'SM00340', NULL, NULL, NULL, NULL, 'halz', NULL, NULL, 1383, 20),
(284127, NULL, 'SM00052', NULL, NULL, NULL, NULL, 'duf2_2', NULL, NULL, 5479, 20),
(284128, NULL, 'SM01055', NULL, NULL, NULL, NULL, 'Cadherin_pro_2', NULL, NULL, 13169, 20),
(284129, NULL, 'SM00487', NULL, NULL, NULL, NULL, 'ultradead3', NULL, NULL, 7954, 20),
(284130, NULL, 'SM00887', NULL, NULL, NULL, NULL, 'EB_dh_2', NULL, NULL, 15707, 20),
(284131, NULL, 'SM00697', NULL, NULL, NULL, NULL, 'dm8', NULL, NULL, 10199, 20),
(284132, NULL, 'SM01123', NULL, NULL, NULL, NULL, 'DBP10CT_2', NULL, NULL, 8615, 20),
(284133, NULL, 'SM00527', NULL, NULL, NULL, NULL, 'hmg17neu4', NULL, NULL, 2748, 20),
(284134, NULL, 'SM01215', NULL, NULL, NULL, NULL, 'Fmp27_SW_2', NULL, NULL, 17000, 20),
(284135, NULL, 'SM00636', NULL, NULL, NULL, NULL, '2g34', NULL, NULL, 10237, 20),
(284136, NULL, 'SM00921', NULL, NULL, NULL, NULL, 'MHC_II_beta_2', NULL, NULL, 4755, 20),
(284137, NULL, 'SM00217', NULL, NULL, NULL, NULL, 'wap2', NULL, NULL, 7006, 20),
(284138, NULL, 'SM00445', NULL, NULL, NULL, NULL, 'LINK_2', NULL, NULL, 5528, 20),
(284139, NULL, 'SM01234', NULL, NULL, NULL, NULL, 'Haemolytic_2', NULL, NULL, 3956, 20),
(284140, NULL, 'SM01386', NULL, NULL, NULL, NULL, 'Ribosomal_S13_N_2', NULL, NULL, 9756, 20),
(284141, NULL, 'SM00006', NULL, NULL, NULL, NULL, 'A4_EXTRA_3', NULL, NULL, 7019, 20),
(284142, NULL, 'SM00948', NULL, NULL, NULL, NULL, 'Proteasome_A_N_2', NULL, NULL, 6529, 20),
(284143, NULL, 'SM00698', NULL, NULL, NULL, NULL, 'morn', NULL, NULL, 5365, 20),
(284144, NULL, 'SM00688', NULL, NULL, NULL, NULL, 'dm7', NULL, NULL, 1192, 20),
(284145, NULL, 'SM00705', NULL, NULL, NULL, NULL, 'theg', NULL, NULL, 1237, 20);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(284146, NULL, 'SM00992', NULL, NULL, NULL, NULL, 'YccV_like_2_a', NULL, NULL, 10678, 20),
(284147, NULL, 'SM01279', NULL, NULL, NULL, NULL, 'Matrilin_ccoil_2', NULL, NULL, 17077, 20),
(284148, NULL, 'SM00798', NULL, NULL, NULL, NULL, 'aicarft_impchas', NULL, NULL, 3950, 20),
(284149, NULL, 'SM00485', NULL, NULL, NULL, NULL, 'xpgn3', NULL, NULL, 2851, 20),
(284150, NULL, 'SM00452', NULL, NULL, NULL, NULL, 'kul_2', NULL, NULL, 305, 20),
(284151, NULL, 'SM00255', NULL, NULL, NULL, NULL, 'till_3', NULL, NULL, 1854, 20),
(284152, NULL, 'SM00806', NULL, NULL, NULL, NULL, 'aip3', NULL, NULL, 2593, 20),
(284153, NULL, 'SM00050', NULL, NULL, NULL, NULL, 'DISIN_2', NULL, NULL, 3118, 20),
(284154, NULL, 'SM01394', NULL, NULL, NULL, NULL, 'S_100_2', NULL, NULL, 13194, 20),
(284155, NULL, 'SM00268', NULL, NULL, NULL, NULL, 'actin_3', NULL, NULL, 749, 20),
(284156, NULL, 'SM00994', NULL, NULL, NULL, NULL, 'zf_C4_ClpX_2', NULL, NULL, 8146, 20),
(284157, NULL, 'SM00848', NULL, NULL, NULL, NULL, 'Inhibitor_I29_2', NULL, NULL, 17416, 20),
(284158, NULL, 'SM01360', NULL, NULL, NULL, NULL, 'A2M_2', NULL, NULL, 5160, 20),
(284159, NULL, 'SM00065', NULL, NULL, NULL, NULL, 'gaf_1', NULL, NULL, 112, 20),
(284160, NULL, 'SM01273', NULL, NULL, NULL, NULL, 'Mago_bind_2', NULL, NULL, 13711, 20),
(284161, NULL, 'SM00780', NULL, NULL, NULL, NULL, 'pig_x_1', NULL, NULL, 12379, 20),
(284162, NULL, 'SM01082', NULL, NULL, NULL, NULL, 'CHZ_2', NULL, NULL, 17639, 20),
(284163, NULL, 'SM00363', NULL, NULL, NULL, NULL, 's4_6', NULL, NULL, 6765, 20),
(284164, NULL, 'SM00851', NULL, NULL, NULL, NULL, 'MGS_2a', NULL, NULL, 8426, 20),
(284165, NULL, 'SM00866', NULL, NULL, NULL, NULL, 'UTRA_2', NULL, NULL, 10929, 20),
(284166, NULL, 'SM01086', NULL, NULL, NULL, NULL, 'ClpB_D2_small_2', NULL, NULL, 18363, 20),
(284167, NULL, 'SM01196', NULL, NULL, NULL, NULL, 'FERM_C_3', NULL, NULL, 14977, 20),
(284168, NULL, 'SM00968', NULL, NULL, NULL, NULL, 'SMC_hinge_2', NULL, NULL, 7628, 20),
(284169, NULL, 'SM00473', NULL, NULL, NULL, NULL, 'ntp_6', NULL, NULL, 843, 20),
(284170, NULL, 'SM01295', NULL, NULL, NULL, NULL, 'K167R_2', NULL, NULL, 9297, 20),
(284171, NULL, 'SM00270', NULL, NULL, NULL, NULL, 'ChitinBD_3', NULL, NULL, 3245, 20),
(284172, NULL, 'SM01252', NULL, NULL, NULL, NULL, 'KilA_N_2', NULL, NULL, 19363, 20),
(284173, NULL, 'SM00041', NULL, NULL, NULL, NULL, 'CT_3', NULL, NULL, 11169, 20),
(284174, NULL, 'SM00799', NULL, NULL, NULL, NULL, 'DENN_cls', NULL, NULL, 1098, 20),
(284175, NULL, 'SM00232', NULL, NULL, NULL, NULL, 'pad1_6', NULL, NULL, 5596, 20),
(284176, NULL, 'SM01365', NULL, NULL, NULL, NULL, 'Op_neuropeptide_2', NULL, NULL, 12530, 20),
(284177, NULL, 'SM00707', NULL, NULL, NULL, NULL, 'rpel', NULL, NULL, 763, 20),
(284178, NULL, 'SM01207', NULL, NULL, NULL, NULL, 'G3P_acyltransf_2', NULL, NULL, 6290, 20),
(284179, NULL, 'SM00054', NULL, NULL, NULL, NULL, 'efh_1', NULL, NULL, 1368, 20),
(284180, NULL, 'SM00176', NULL, NULL, NULL, NULL, 'ran_sub_2', NULL, NULL, NULL, 20),
(284181, NULL, 'SM00049', NULL, NULL, NULL, NULL, 'DEP_3', NULL, NULL, 5781, 20),
(284182, NULL, 'SM00826', NULL, NULL, NULL, NULL, 'PKS_DH', NULL, NULL, 19269, 20),
(284183, NULL, 'SM00702', NULL, NULL, NULL, NULL, 'p4hc', NULL, NULL, 1238, 20),
(284184, NULL, 'SM00244', NULL, NULL, NULL, NULL, 'PHB_4', NULL, NULL, 1360, 20),
(284185, NULL, 'SM00711', NULL, NULL, NULL, NULL, 'tdu', NULL, NULL, 1380, 20),
(284186, NULL, 'SM00497', NULL, NULL, NULL, NULL, 'intein_16', NULL, NULL, 1291, 20),
(284187, NULL, 'SM01247', NULL, NULL, NULL, NULL, 'KaiA_2', NULL, NULL, 10641, 20),
(284188, NULL, 'SM00784', NULL, NULL, NULL, NULL, 'spt2', NULL, NULL, 13088, 20),
(284189, NULL, 'SM00208', NULL, NULL, NULL, NULL, 'TNFR_3', NULL, NULL, 2084, 20),
(284190, NULL, 'SM00185', NULL, NULL, NULL, NULL, 'arm_5', NULL, NULL, 3706, 20),
(284191, NULL, 'SM01078', NULL, NULL, NULL, NULL, 'CGGC_2', NULL, NULL, 14266, 20),
(284192, NULL, 'SM00713', NULL, NULL, NULL, NULL, 'gyr', NULL, NULL, 704, 20),
(284193, NULL, 'SM01368', NULL, NULL, NULL, NULL, 'RB_A_2', NULL, NULL, 3791, 20);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(284194, NULL, 'SM00157', NULL, NULL, NULL, NULL, 'PRP_2', NULL, NULL, 4614, 20),
(284195, NULL, 'SM00033', NULL, NULL, NULL, NULL, 'ch_5', NULL, NULL, 3399, 20),
(284196, NULL, 'SM00635', NULL, NULL, NULL, NULL, 'bid_2', NULL, NULL, 4199, 20),
(284197, NULL, 'SM01010', NULL, NULL, NULL, NULL, 'AMPKBI_2', NULL, NULL, 3817, 20),
(284198, NULL, 'SM00923', NULL, NULL, NULL, NULL, 'MbtH_2', NULL, NULL, 4081, 20),
(284199, NULL, 'SM00166', NULL, NULL, NULL, NULL, 'ubx_3', NULL, NULL, 2131, 20),
(284200, NULL, 'SM01036', NULL, NULL, NULL, NULL, 'BP28CT_2', NULL, NULL, 11779, 20),
(284201, NULL, 'SM01343', NULL, NULL, NULL, NULL, 'FATC_2', NULL, NULL, 1879, 20),
(284202, NULL, 'SM00057', NULL, NULL, NULL, NULL, 'fimac2', NULL, NULL, 4453, 20),
(284203, NULL, 'SM01094', NULL, NULL, NULL, NULL, 'CpcD_2', NULL, NULL, 568, 20),
(284204, NULL, 'SM00480', NULL, NULL, NULL, NULL, 'pol35', NULL, NULL, 4499, 20),
(284205, NULL, 'SM01357', NULL, NULL, NULL, NULL, 'Antimicrobial21_2', NULL, NULL, 26518, 20),
(284206, NULL, 'SM00973', NULL, NULL, NULL, NULL, 'Sec63_2', NULL, NULL, 2886, 20),
(284207, NULL, 'SM00958', NULL, NULL, NULL, NULL, 'SecA_PP_bind_2', NULL, NULL, 9839, 20),
(284208, NULL, 'SM01367', NULL, NULL, NULL, NULL, 'DUF3452_2', NULL, NULL, 26972, 20),
(284209, NULL, 'SM00347', NULL, NULL, NULL, NULL, 'marrlong4', NULL, NULL, 4925, 20),
(284210, NULL, 'SM00229', NULL, NULL, NULL, NULL, 'rasgefn_5', NULL, NULL, 6675, 20),
(284211, NULL, 'SM00877', NULL, NULL, NULL, NULL, 'BMC_2', NULL, NULL, 1092, 20),
(284212, NULL, 'SM00969', NULL, NULL, NULL, NULL, 'SOCS_box_2', NULL, NULL, 3306, 20),
(284213, NULL, 'SM00189', NULL, NULL, NULL, NULL, 'int2_nr', NULL, NULL, 3542, 20),
(284214, NULL, 'SM01141', NULL, NULL, NULL, NULL, 'DRY_EERY_2', NULL, NULL, 18174, 20),
(284215, NULL, 'SM00302', NULL, NULL, NULL, NULL, 'GED_2', NULL, NULL, 1682, 20),
(284216, NULL, 'SM00761', NULL, NULL, NULL, NULL, 'hdac_interact2seq4b', NULL, NULL, 17014, 20),
(284217, NULL, 'SM00178', NULL, NULL, NULL, NULL, 'sar_sub_1', NULL, NULL, 2330, 20),
(284218, NULL, 'SM00426', NULL, NULL, NULL, NULL, 'tea2', NULL, NULL, 4900, 20),
(284219, NULL, 'SM00223', NULL, NULL, NULL, NULL, 'APPLE_7', NULL, NULL, 1620, 20),
(284220, NULL, 'SM00013', NULL, NULL, NULL, NULL, 'lrrnt1', NULL, NULL, 4701, 20),
(284221, NULL, 'SM01133', NULL, NULL, NULL, NULL, 'DeoC_2', NULL, NULL, 6080, 20),
(284222, NULL, 'SM01227', NULL, NULL, NULL, NULL, 'GCK_2', NULL, NULL, 13379, 20),
(284223, NULL, 'SM00207', NULL, NULL, NULL, NULL, 'TNF_2', NULL, NULL, 2809, 20),
(284224, NULL, 'SM00160', NULL, NULL, NULL, NULL, 'ranbd_3', NULL, NULL, 1949, 20),
(284225, NULL, 'SM00552', NULL, NULL, NULL, NULL, 'adara_8', NULL, NULL, 6672, 20),
(284226, NULL, 'SM00110', NULL, NULL, NULL, NULL, 'C1Q_2', NULL, NULL, 2032, 20),
(284227, NULL, 'SM01068', NULL, NULL, NULL, NULL, 'CBM_X_2', NULL, NULL, 14057, 20),
(284228, NULL, 'SM00330', NULL, NULL, NULL, NULL, 'PIPK_2', NULL, NULL, 614, 20),
(284229, NULL, 'SM00518', NULL, NULL, NULL, NULL, 'ap2real3', NULL, NULL, 3499, 20),
(284230, NULL, 'SM00967', NULL, NULL, NULL, NULL, 'SpoU_sub_bind_2', NULL, NULL, 18757, 20),
(284231, NULL, 'SM01000', NULL, NULL, NULL, NULL, 'Aha1_N_2', NULL, NULL, 13052, 20),
(284232, NULL, 'SM00849', NULL, NULL, NULL, NULL, 'Lactamase_B_5a', NULL, NULL, 2148, 20),
(284233, NULL, 'SM00453', NULL, NULL, NULL, NULL, 'wsn_4', NULL, NULL, 2804, 20),
(284234, NULL, 'SM01172', NULL, NULL, NULL, NULL, 'DUF3700_2', NULL, NULL, 20444, 20),
(284235, NULL, 'SM00073', NULL, NULL, NULL, NULL, 'hpt_2', NULL, NULL, 7469, 20),
(284236, NULL, 'SM00559', NULL, NULL, NULL, NULL, 'ku_4', NULL, NULL, 10324, 20),
(284237, NULL, 'SM00234', NULL, NULL, NULL, NULL, 'START_1', NULL, NULL, 6155, 20),
(284238, NULL, 'SM00796', NULL, NULL, NULL, NULL, 'ahs1', NULL, NULL, 6066, 20),
(284239, NULL, 'SM01034', NULL, NULL, NULL, NULL, 'BLUF_2', NULL, NULL, 6906, 20),
(284240, NULL, 'SM01145', NULL, NULL, NULL, NULL, 'DUF1041_2a', NULL, NULL, 10480, 20),
(284241, NULL, 'SM01396', NULL, NULL, NULL, NULL, 'BC10_2', NULL, NULL, 1833, 20);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(284242, NULL, 'SM01266', NULL, NULL, NULL, NULL, 'Mac_2', NULL, NULL, 22049, 20),
(284243, NULL, 'SM00067', NULL, NULL, NULL, NULL, 'GHA_2', NULL, NULL, 5533, 20),
(284244, NULL, 'SM00425', NULL, NULL, NULL, NULL, 'tbox5', NULL, NULL, 36881, 20),
(284245, NULL, 'SM01188', NULL, NULL, NULL, NULL, 'ELK_2', NULL, NULL, 1922, 20),
(284246, NULL, 'SM00709', NULL, NULL, NULL, NULL, 'zpr1', NULL, NULL, 7129, 20),
(284247, NULL, 'SM01104', NULL, NULL, NULL, NULL, 'CTD_2', NULL, NULL, 23673, 20),
(284248, NULL, 'SM01180', NULL, NULL, NULL, NULL, 'DWNN_2', NULL, NULL, 13455, 20),
(284249, NULL, 'SM00399', NULL, NULL, NULL, NULL, 'c4gold', NULL, NULL, 3273, 20),
(284250, NULL, 'SM00121', NULL, NULL, NULL, NULL, 'IB_2', NULL, NULL, 4626, 20),
(284251, NULL, 'SM01015', NULL, NULL, NULL, NULL, 'Arfaptin_2', NULL, NULL, 10372, 20),
(284252, NULL, 'SM01052', NULL, NULL, NULL, NULL, 'CAP_GLY_2', NULL, NULL, 3027, 20),
(284253, NULL, 'SM00754', NULL, NULL, NULL, NULL, 'chrd_5', NULL, NULL, 12460, 20),
(284254, NULL, 'SM00069', NULL, NULL, NULL, NULL, 'gla_3', NULL, NULL, 4995, 20),
(284255, NULL, 'SM00352', NULL, NULL, NULL, NULL, 'pou', NULL, NULL, 985, 20),
(284256, NULL, 'SM00254', NULL, NULL, NULL, NULL, 'ShkT_1', NULL, NULL, 327, 20),
(284257, NULL, 'SM01126', NULL, NULL, NULL, NULL, 'DDE_Tnp_IS1595_2', NULL, NULL, 24178, 20),
(284258, NULL, 'SM01156', NULL, NULL, NULL, NULL, 'DUF1716_2', NULL, NULL, 17023, 20),
(284259, NULL, 'SM00283', NULL, NULL, NULL, NULL, 'MA_2', NULL, NULL, 1580, 20),
(284260, NULL, 'SM01412', NULL, NULL, NULL, NULL, 'Pro_rich_2', NULL, NULL, 24613, 20),
(284261, NULL, 'SM00720', NULL, NULL, NULL, NULL, '2cal', NULL, NULL, 16966, 20),
(284262, NULL, 'SM00970', NULL, NULL, NULL, NULL, 's48_45_2', NULL, NULL, 11613, 20),
(284263, NULL, 'SM01041', NULL, NULL, NULL, NULL, 'BRO1_2', NULL, NULL, 4977, 20),
(284264, NULL, 'SM00591', NULL, NULL, NULL, NULL, 'RWD2001b', NULL, NULL, 268, 20),
(284265, NULL, 'SM00555', NULL, NULL, NULL, NULL, 'spa2_6', NULL, NULL, 14347, 20),
(284266, NULL, 'SM00434', NULL, NULL, NULL, NULL, 'topIV4', NULL, NULL, 5957, 20),
(284267, NULL, 'SM00137', NULL, NULL, NULL, NULL, 'MAM_2', NULL, NULL, 3140, 20),
(284268, NULL, 'SM00144', NULL, NULL, NULL, NULL, 'pi3k_ras_2', NULL, NULL, 185, 20),
(284269, NULL, 'SM00406', NULL, NULL, NULL, NULL, 'igv1_8', NULL, NULL, 18504, 20),
(284270, NULL, 'SM01072', NULL, NULL, NULL, NULL, 'CDC48_2_2', NULL, NULL, 2925, 20),
(284271, NULL, 'SM00646', NULL, NULL, NULL, NULL, 'ami_3', NULL, NULL, 604, 20),
(284272, NULL, 'SM00269', NULL, NULL, NULL, NULL, 'BoBi_2', NULL, NULL, 59, 20),
(284273, NULL, 'SM00059', NULL, NULL, NULL, NULL, 'FN2_2', NULL, NULL, 5841, 20),
(284274, NULL, 'SM00387', NULL, NULL, NULL, NULL, 'HKATPase_4', NULL, NULL, 52, 20),
(284275, NULL, 'SM01040', NULL, NULL, NULL, NULL, 'Bro_N_2', NULL, NULL, 6156, 20),
(284276, NULL, 'SM00300', NULL, NULL, NULL, NULL, 'ChS_2', NULL, NULL, 683, 20),
(284277, NULL, 'SM00496', NULL, NULL, NULL, NULL, 'seet_6', NULL, NULL, 729, 20),
(284278, NULL, 'SM01337', NULL, NULL, NULL, NULL, 'APC10_2', NULL, NULL, 1898, 20),
(284279, NULL, 'SM00039', NULL, NULL, NULL, NULL, 'clf2', NULL, NULL, 3913, 20),
(284280, NULL, 'SM00044', NULL, NULL, NULL, NULL, 'cyc_6', NULL, NULL, 1287, 20),
(284281, NULL, 'SM01071', NULL, NULL, NULL, NULL, 'CDC37_N_2', NULL, NULL, 18776, 20),
(284282, NULL, 'SM00511', NULL, NULL, NULL, NULL, 'orange_5', NULL, NULL, 1404, 20),
(284283, NULL, 'SM00808', NULL, NULL, NULL, NULL, 'fabda', NULL, NULL, 7827, 20),
(284284, NULL, 'SM01095', NULL, NULL, NULL, NULL, 'Cpl_7_2', NULL, NULL, 8866, 20),
(284285, NULL, 'SM00603', NULL, NULL, NULL, NULL, 'lcc', NULL, NULL, 965, 20),
(284286, NULL, 'SM00752', NULL, NULL, NULL, NULL, 'EBI_submitted', NULL, NULL, 9042, 20),
(284287, NULL, 'SM00109', NULL, NULL, NULL, NULL, 'c1_12', NULL, NULL, 5392, 20),
(284288, NULL, 'SM00739', NULL, NULL, NULL, NULL, 'kow_9', NULL, NULL, 5911, 20),
(284289, NULL, 'SM00133', NULL, NULL, NULL, NULL, 'pkinase_C_6', NULL, NULL, 3446, 20),
(284290, NULL, 'SM00068', NULL, NULL, NULL, NULL, 'GHB_2', NULL, NULL, 3145, 20);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(284291, NULL, 'SM00922', NULL, NULL, NULL, NULL, 'MR_MLE_2', NULL, NULL, 14281, 20),
(284292, NULL, 'SM00477', NULL, NULL, NULL, NULL, 'endoplus', NULL, NULL, 20263, 20),
(284293, NULL, 'SM00195', NULL, NULL, NULL, NULL, 'dsp_5', NULL, NULL, 18593, 20),
(284294, NULL, 'SM00336', NULL, NULL, NULL, NULL, 'bboxneu5', NULL, NULL, 595, 20),
(284295, NULL, 'SM01376', NULL, NULL, NULL, NULL, 'eIF_5a_2', NULL, NULL, 17742, 20),
(284296, NULL, 'SM00113', NULL, NULL, NULL, NULL, 'calci3_nr', NULL, NULL, 3410, 20),
(284297, NULL, 'SM01244', NULL, NULL, NULL, NULL, 'IRS_2', NULL, NULL, NULL, 20),
(284298, NULL, 'SM00736', NULL, NULL, NULL, NULL, 'cadg_13', NULL, NULL, 1247, 20),
(284299, NULL, 'SM00484', NULL, NULL, NULL, NULL, 'xpgineu', NULL, NULL, 2612, 20),
(284300, NULL, 'SM00694', NULL, NULL, NULL, NULL, 'dysfc', NULL, NULL, 1157, 20),
(284301, NULL, 'SM00605', NULL, NULL, NULL, NULL, 'cw', NULL, NULL, 288, 20),
(284302, NULL, 'SM01199', NULL, NULL, NULL, NULL, 'FDF_2', NULL, NULL, 16713, 20),
(284303, NULL, 'SM01233', NULL, NULL, NULL, NULL, 'HABP4_PAI_RBP1_2', NULL, NULL, 3574, 20),
(284304, NULL, 'SM01267', NULL, NULL, NULL, NULL, 'LAG1_DNAbind_2', NULL, NULL, 13094, 20),
(284305, NULL, 'SM00145', NULL, NULL, NULL, NULL, 'pi3k_hr2_4', NULL, NULL, 2267, 20),
(284306, NULL, 'SM01075', NULL, NULL, NULL, NULL, 'CDT1_2', NULL, NULL, 14175, 20),
(284307, NULL, 'SM01251', NULL, NULL, NULL, NULL, 'KbaA_2', NULL, NULL, 12778, 20),
(284308, NULL, 'SM00003', NULL, NULL, NULL, NULL, 'NH_2', NULL, NULL, 24, 20),
(284309, NULL, 'SM00594', NULL, NULL, NULL, NULL, '45neu3', NULL, NULL, 216, 20),
(284310, NULL, 'SM00929', NULL, NULL, NULL, NULL, 'NADH_G_4Fe_4S_3_2', NULL, NULL, 20170, 20),
(284311, NULL, 'SM00953', NULL, NULL, NULL, NULL, 'RES_2', NULL, NULL, 13026, 20),
(284312, NULL, 'SM01307', NULL, NULL, NULL, NULL, 'RICTOR_M_2', NULL, NULL, 23667, 20),
(284313, NULL, 'SM00597', NULL, NULL, NULL, NULL, '2118neu4', NULL, NULL, 495, 20),
(284314, NULL, 'SM01391', NULL, NULL, NULL, NULL, 'Filament_2', NULL, NULL, 27398, 20),
(284315, NULL, 'SM00782', NULL, NULL, NULL, NULL, 'phnA_zn_ribbon', NULL, NULL, 10076, 20),
(284316, NULL, 'SM00972', NULL, NULL, NULL, NULL, 'SCPU_a_2_a', NULL, NULL, 3087, 20),
(284317, NULL, 'SM00462', NULL, NULL, NULL, NULL, 'PTB_9', NULL, NULL, 1395, 20),
(284318, NULL, 'SM00356', NULL, NULL, NULL, NULL, 'c3hfinal6', NULL, NULL, 5631, 20),
(284319, NULL, 'SM00134', NULL, NULL, NULL, NULL, 'LU_2', NULL, NULL, 9146, 20),
(284320, NULL, 'SM00988', NULL, NULL, NULL, NULL, 'UreE_n_2_a', NULL, NULL, 576, 20),
(284321, NULL, 'SM00641', NULL, NULL, NULL, NULL, 'glyco_25', NULL, NULL, 13504, 20),
(284322, NULL, 'SM00746', NULL, NULL, NULL, NULL, '4TRASH', NULL, NULL, 9081, 20),
(284323, NULL, 'SM00014', NULL, NULL, NULL, NULL, 'acid_phosph_2', NULL, NULL, 4961, 20),
(284324, NULL, 'SM01100', NULL, NULL, NULL, NULL, 'CRAL_TRIO_N_2', NULL, NULL, 10040, 20),
(284325, NULL, 'SM00187', NULL, NULL, NULL, NULL, 'INB_2', NULL, NULL, 6445, 20),
(284326, NULL, 'SM00236', NULL, NULL, NULL, NULL, 'fcbd_2', NULL, NULL, 4882, 20),
(284327, NULL, 'SM00180', NULL, NULL, NULL, NULL, 'lamegf_3', NULL, NULL, 1303, 20),
(284328, NULL, 'SM00647', NULL, NULL, NULL, NULL, 'ibrneu5', NULL, NULL, 5613, 20),
(284329, NULL, 'SM00721', NULL, NULL, NULL, NULL, '5bar', NULL, NULL, 2866, 20),
(284330, NULL, 'SM01058', NULL, NULL, NULL, NULL, 'CarD_TRCF_2', NULL, NULL, 2299, 20),
(284331, NULL, 'SM00055', NULL, NULL, NULL, NULL, 'fch_2', NULL, NULL, 1418, 20),
(284332, NULL, 'SM00944', NULL, NULL, NULL, NULL, 'Pro_kuma_activ_2', NULL, NULL, 14162, 20),
(284333, NULL, 'SM00802', NULL, NULL, NULL, NULL, 'UME_cls', NULL, NULL, 12375, 20),
(284334, NULL, 'SM00441', NULL, NULL, NULL, NULL, 'FF_2', NULL, NULL, 3694, 20),
(284335, NULL, 'SM01102', NULL, NULL, NULL, NULL, 'CRM1_C_2', NULL, NULL, 13108, 20),
(284336, NULL, 'SM01114', NULL, NULL, NULL, NULL, 'CXC_2', NULL, NULL, 28865, 20),
(284337, NULL, 'SM01182', NULL, NULL, NULL, NULL, 'EF-1_beta_acid_2', NULL, NULL, 9437, 20),
(284338, NULL, 'SM00130', NULL, NULL, NULL, NULL, 'KR_2', NULL, NULL, 1643, 20);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(284339, NULL, 'SM00346', NULL, NULL, NULL, NULL, 'iclrneu', NULL, NULL, 997, 20),
(284340, NULL, 'SM00025', NULL, NULL, NULL, NULL, 'pum_5', NULL, NULL, 2315, 20),
(284341, NULL, 'SM00878', NULL, NULL, NULL, NULL, 'Biotin_carb_C_2', NULL, NULL, 654, 20),
(284342, NULL, 'SM00915', NULL, NULL, NULL, NULL, 'Jacalin_2', NULL, NULL, 945, 20),
(284343, NULL, 'SM00734', NULL, NULL, NULL, NULL, 'c2hc_5', NULL, NULL, 1386, 20),
(284344, NULL, 'SM00538', NULL, NULL, NULL, NULL, 'pop4_2', NULL, NULL, 3554, 20),
(284345, NULL, 'SM01348', NULL, NULL, NULL, NULL, 'Nbs1_C_2', NULL, NULL, 17653, 20),
(284346, NULL, 'SM00649', NULL, NULL, NULL, NULL, 'rl11c', NULL, NULL, 337, 20),
(284347, NULL, 'SM01158', NULL, NULL, NULL, NULL, 'DUF1741_2', NULL, NULL, 11128, 20),
(284348, NULL, 'SM00389', NULL, NULL, NULL, NULL, 'HOX_1', NULL, NULL, 7496, 20),
(284349, NULL, 'SM01111', NULL, NULL, NULL, NULL, 'CVNH_2', NULL, NULL, 9270, 20),
(284350, NULL, 'SM00337', NULL, NULL, NULL, NULL, 'bclneu2', NULL, NULL, 36785, 20),
(284351, NULL, 'SM00666', NULL, NULL, NULL, NULL, 'PB1_new', NULL, NULL, 760, 20),
(284352, NULL, 'SM00326', NULL, NULL, NULL, NULL, 'SH3_2', NULL, NULL, 6232, 20),
(284353, NULL, 'SM01297', NULL, NULL, NULL, NULL, 'KAP_2', NULL, NULL, NULL, 20),
(284354, NULL, 'SM00510', NULL, NULL, NULL, NULL, 'mid_6', NULL, NULL, 648, 20),
(284355, NULL, 'SM00856', NULL, NULL, NULL, NULL, 'PMEI_2', NULL, NULL, 6731, 20),
(284356, NULL, 'SM00651', NULL, NULL, NULL, NULL, 'Sm3', NULL, NULL, 1109, 20),
(284357, NULL, 'SM00053', NULL, NULL, NULL, NULL, 'dynamin_3', NULL, NULL, 3135, 20),
(284358, NULL, 'SM01213', NULL, NULL, NULL, NULL, 'Flo11_2', NULL, NULL, 19384, 20),
(284359, NULL, 'SM00345', NULL, NULL, NULL, NULL, 'gntr3', NULL, NULL, 5800, 20),
(284360, NULL, 'SM00409', NULL, NULL, NULL, NULL, 'IG_3c', NULL, NULL, 378, 20),
(284361, NULL, 'SM00367', NULL, NULL, NULL, NULL, 'LRR_CC_2', NULL, NULL, 242, 20),
(284362, NULL, 'SM00043', NULL, NULL, NULL, NULL, 'CY_4', NULL, NULL, 2507, 20),
(284363, NULL, 'SM01153', NULL, NULL, NULL, NULL, 'DUF1693_2', NULL, NULL, 8460, 20),
(284364, NULL, 'SM00210', NULL, NULL, NULL, NULL, 'TSPN_2', NULL, NULL, 3322, 20),
(284365, NULL, 'SM00433', NULL, NULL, NULL, NULL, 'topII5', NULL, NULL, 540, 20),
(284366, NULL, 'SM01253', NULL, NULL, NULL, NULL, 'Kin17_mid_2', NULL, NULL, 17367, 20),
(284367, NULL, 'SM01116', NULL, NULL, NULL, NULL, 'Cyanate_lyase_2', NULL, NULL, 2161, 20),
(284368, NULL, 'SM01308', NULL, NULL, NULL, NULL, 'RICTOR_N_3', NULL, NULL, 23452, 20),
(284369, NULL, 'SM01232', NULL, NULL, NULL, NULL, 'H2TH_2', NULL, NULL, 7264, 20),
(284370, NULL, 'SM00032', NULL, NULL, NULL, NULL, 'CCP_2', NULL, NULL, 6503, 20),
(284371, NULL, 'SM00284', NULL, NULL, NULL, NULL, 'olf_2', NULL, NULL, 1595, 20),
(284372, NULL, 'SM00965', NULL, NULL, NULL, NULL, 'STN_2', NULL, NULL, 10771, 20),
(284373, NULL, 'SM01322', NULL, NULL, NULL, NULL, 'YaeQ_2', NULL, NULL, 13416, 20),
(284374, NULL, 'SM00476', NULL, NULL, NULL, NULL, 'dnai3', NULL, NULL, 12000, 20),
(284375, NULL, 'SM00885', NULL, NULL, NULL, NULL, 'D5_N_2', NULL, NULL, 11548, 20),
(284376, NULL, 'SM00002', NULL, NULL, NULL, NULL, 'myelin-fin', NULL, NULL, 5237, 20),
(284377, NULL, 'SM00038', NULL, NULL, NULL, NULL, 'COLFI_2', NULL, NULL, 4698, 20),
(284378, NULL, 'SM01166', NULL, NULL, NULL, NULL, 'DUF1899_3', NULL, NULL, 7535, 20),
(284379, NULL, 'SM00800', NULL, NULL, NULL, NULL, 'uDENN_cls', NULL, NULL, 10835, 20),
(284380, NULL, 'SM01059', NULL, NULL, NULL, NULL, 'CAT_2a', NULL, NULL, 3287, 20),
(284381, NULL, 'SM00257', NULL, NULL, NULL, NULL, 'LysM_2', NULL, NULL, 8452, 20),
(284382, NULL, 'SM00974', NULL, NULL, NULL, NULL, 'T5orf172_2', NULL, NULL, 8058, 20),
(284383, NULL, 'SM01228', NULL, NULL, NULL, NULL, 'GIDA_assoc_3_2', NULL, NULL, NULL, 20),
(284384, NULL, 'SM00438', NULL, NULL, NULL, NULL, 'znfxneu3', NULL, NULL, 3044, 20),
(284385, NULL, 'SM00369', NULL, NULL, NULL, NULL, 'LRR_typ_2', NULL, NULL, 201, 20),
(284386, NULL, 'SM00908', NULL, NULL, NULL, NULL, 'Gal_bind_lectin_2', NULL, NULL, 2387, 20),
(284387, NULL, 'SM00637', NULL, NULL, NULL, NULL, 'cbd_2', NULL, NULL, 4103, 20);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(284388, NULL, 'SM00295', NULL, NULL, NULL, NULL, 'B41_5', NULL, NULL, 21000, 20),
(284389, NULL, 'SM00547', NULL, NULL, NULL, NULL, 'zf_4', NULL, NULL, 5410, 20),
(284390, NULL, 'SM01097', NULL, NULL, NULL, NULL, 'CPSase_sm_chain_2', NULL, NULL, 5122, 20),
(284391, NULL, 'SM01092', NULL, NULL, NULL, NULL, 'CO_deh_flav_C_2', NULL, NULL, 10955, 20),
(284392, NULL, 'SM01313', NULL, NULL, NULL, NULL, 'Sec3_PIP2_bind_2', NULL, NULL, 23073, 20),
(284393, NULL, 'SM00769', NULL, NULL, NULL, NULL, 'why', NULL, NULL, 10020, 20),
(284394, NULL, 'SM00654', NULL, NULL, NULL, NULL, 'eIF6neu2', NULL, NULL, 4654, 20),
(284395, NULL, 'SM00468', NULL, NULL, NULL, NULL, 'preset_2', NULL, NULL, 1187, 20),
(284396, NULL, 'SM00790', NULL, NULL, NULL, NULL, 'afor_n', NULL, NULL, 12722, 20),
(284397, NULL, 'SM00143', NULL, NULL, NULL, NULL, 'pi3k_nt_2', NULL, NULL, 1552, 20),
(284398, NULL, 'SM00202', NULL, NULL, NULL, NULL, 'SR_3', NULL, NULL, 18501, 20),
(284399, NULL, 'SM01007', NULL, NULL, NULL, NULL, 'Aldolase_II_2', NULL, NULL, 263, 20),
(284400, NULL, 'SM01236', NULL, NULL, NULL, NULL, 'Haem_oxygenas_2_2', NULL, NULL, NULL, 20),
(284401, NULL, 'SM01277', NULL, NULL, NULL, NULL, 'MAGUK_N_PEST_2', NULL, NULL, 20222, 20),
(284402, NULL, 'SM01406', NULL, NULL, NULL, NULL, 'PAPA_1_2', NULL, NULL, 4524, 20),
(284403, NULL, 'SM00198', NULL, NULL, NULL, NULL, 'SCP_3', NULL, NULL, 9125, 20),
(284404, NULL, 'SM01319', NULL, NULL, NULL, NULL, 'Tankyrase_bdg_C_2', NULL, NULL, 22448, 20),
(284405, NULL, 'SM00704', NULL, NULL, NULL, NULL, 'znf_cdgsh', NULL, NULL, 14925, 20),
(284406, NULL, 'SM01162', NULL, NULL, NULL, NULL, 'DUF1771_2', NULL, NULL, 17993, 20),
(284407, NULL, 'SM01062', NULL, NULL, NULL, NULL, 'Ca_chan_IQ_2', NULL, NULL, 13071, 20),
(284408, NULL, 'SM00298', NULL, NULL, NULL, NULL, 'chromo_7', NULL, NULL, 3340, 20),
(284409, NULL, 'SM00331', NULL, NULL, NULL, NULL, 'PP2C_SIG_2', NULL, NULL, 2124, 20),
(284410, NULL, 'SM00368', NULL, NULL, NULL, NULL, 'LRR_RI_2', NULL, NULL, NULL, 20),
(284411, NULL, 'SM01372', NULL, NULL, NULL, NULL, 'E2F_TDP_2', NULL, NULL, 4128, 20),
(284412, NULL, 'SM01018', NULL, NULL, NULL, NULL, 'B12_binding_2_2', NULL, NULL, 2256, 20),
(284413, NULL, 'SM01283', NULL, NULL, NULL, NULL, 'Costars_2', NULL, NULL, 22494, 20),
(284414, NULL, 'SM00751', NULL, NULL, NULL, NULL, 'wurzfinal6', NULL, NULL, 2915, 20),
(284415, NULL, 'SM01037', NULL, NULL, NULL, NULL, 'Bet_v_1_2', NULL, NULL, 4348, 20),
(284416, NULL, 'SM01276', NULL, NULL, NULL, NULL, 'M60_like_2', NULL, NULL, 25137, 20),
(284417, NULL, 'SM01239', NULL, NULL, NULL, NULL, 'IKKbetaNEMObind_2', NULL, NULL, 20296, 20),
(284418, NULL, 'SM00975', NULL, NULL, NULL, NULL, 'Telomerase_RBD_2', NULL, NULL, 19618, 20),
(284419, NULL, 'SM00892', NULL, NULL, NULL, NULL, 'Endonuclease_NS_2', NULL, NULL, 3052, 20),
(284420, NULL, 'SM00238', NULL, NULL, NULL, NULL, 'bir_2', NULL, NULL, 2021, 20),
(284421, NULL, 'SM00029', NULL, NULL, NULL, NULL, 'gastr3', NULL, NULL, NULL, 20),
(284422, NULL, 'SM00996', NULL, NULL, NULL, NULL, 'AdoHcyase_2', NULL, NULL, 3741, 20),
(284423, NULL, 'SM00467', NULL, NULL, NULL, NULL, 'GS_4', NULL, NULL, 496, 20),
(284424, NULL, 'SM00926', NULL, NULL, NULL, NULL, 'Molybdop_Fe4S4_2', NULL, NULL, 5874, 20),
(284425, NULL, 'SM01402', NULL, NULL, NULL, NULL, 'Ribosomal_S27_2', NULL, NULL, 6034, 20),
(284426, NULL, 'SM00332', NULL, NULL, NULL, NULL, 'PP2C_4', NULL, NULL, 2124, 20),
(284427, NULL, 'SM00735', NULL, NULL, NULL, NULL, 'zasp_3', NULL, NULL, 1460, 20),
(284428, NULL, 'SM00249', NULL, NULL, NULL, NULL, 'PHD_3', NULL, NULL, 2441, 20),
(284429, NULL, 'SM00092', NULL, NULL, NULL, NULL, 'rnase-fin', NULL, NULL, 16390, 20),
(284430, NULL, 'SM00070', NULL, NULL, NULL, NULL, 'gluca', NULL, NULL, 5895, 20),
(284431, NULL, 'SM00062', NULL, NULL, NULL, NULL, 'AABind_6', NULL, NULL, 3186, 20),
(284432, NULL, 'SM01046', NULL, NULL, NULL, NULL, 'c_SKI_SMAD_bind_2', NULL, NULL, 13216, 20),
(284433, NULL, 'SM00251', NULL, NULL, NULL, NULL, 'SAM2_3', NULL, NULL, 2975, 20),
(284434, NULL, 'SM00731', NULL, NULL, NULL, NULL, 'sprt_6', NULL, NULL, 1176, 20);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(284435, NULL, 'SM01254', NULL, NULL, NULL, NULL, 'KLRAQ_2', NULL, NULL, 15880, 20),
(284436, NULL, 'SM01274', NULL, NULL, NULL, NULL, 'malic_2', NULL, NULL, 13077, 20),
(284437, NULL, 'SM01263', NULL, NULL, NULL, NULL, 'Leuk_A4_hydro_C_2', NULL, NULL, 10976, 20),
(284438, NULL, 'SM01260', NULL, NULL, NULL, NULL, 'LANC_like_2', NULL, NULL, 2439, 20),
(284439, NULL, 'SM00311', NULL, NULL, NULL, NULL, 'pwi_2', NULL, NULL, 868, 20),
(284440, NULL, 'SM00570', NULL, NULL, NULL, NULL, 'shorttest3', NULL, NULL, 375, 20),
(284441, NULL, 'SM00058', NULL, NULL, NULL, NULL, 'FN1_2', NULL, NULL, 3709, 20),
(284442, NULL, 'SM00588', NULL, NULL, NULL, NULL, '27b', NULL, NULL, 15, 20),
(284443, NULL, 'SM01299', NULL, NULL, NULL, NULL, 'PIP49_N_2', NULL, NULL, 26993, 20),
(284444, NULL, 'SM01264', NULL, NULL, NULL, NULL, 'M16C_assoc_2', NULL, NULL, 11853, 20),
(284445, NULL, 'SM00901', NULL, NULL, NULL, NULL, 'FRG_2', NULL, NULL, 14035, 20),
(284446, NULL, 'SM00272', NULL, NULL, NULL, NULL, 'END_2', NULL, NULL, 4174, 20),
(284447, NULL, 'SM00507', NULL, NULL, NULL, NULL, 'HNH_5', NULL, NULL, 848, 20),
(284448, NULL, 'SM01160', NULL, NULL, NULL, NULL, 'DUF1751_2', NULL, NULL, NULL, 20),
(284449, NULL, 'SM00119', NULL, NULL, NULL, NULL, 'hect_3', NULL, NULL, 5907, 20),
(284450, NULL, 'SM00112', NULL, NULL, NULL, NULL, 'CA_2', NULL, NULL, 1262, 20),
(284451, NULL, 'SM00793', NULL, NULL, NULL, NULL, 'agrb', NULL, NULL, 2511, 20),
(284452, NULL, 'SM01014', NULL, NULL, NULL, NULL, 'ARID_2', NULL, NULL, NULL, 20),
(284453, NULL, 'SM01327', NULL, NULL, NULL, NULL, 'Zds_C_2', NULL, NULL, 14381, 20),
(284454, NULL, 'SM01070', NULL, NULL, NULL, NULL, 'CDC37_M_2', NULL, NULL, 9802, 20),
(284455, NULL, 'SM00457', NULL, NULL, NULL, NULL, 'MACPF_8', NULL, NULL, 20714, 20),
(284456, NULL, 'SM00917', NULL, NULL, NULL, NULL, 'LeuA_dimer_2', NULL, NULL, 13809, 20),
(284457, NULL, 'SM00946', NULL, NULL, NULL, NULL, 'ProRS_C_1_2', NULL, NULL, 11775, 20),
(284458, NULL, 'SM00867', NULL, NULL, NULL, NULL, 'YceI_2', NULL, NULL, 5569, 20),
(284459, NULL, 'SM00414', NULL, NULL, NULL, NULL, 'h2a4', NULL, NULL, 1479, 20),
(284460, NULL, 'SM01293', NULL, NULL, NULL, NULL, 'DUF3402_2', NULL, NULL, 19683, 20),
(284461, NULL, 'SM00960', NULL, NULL, NULL, NULL, 'Robl_LC7_a_2', NULL, NULL, 1900, 20),
(284462, NULL, 'SM00757', NULL, NULL, NULL, NULL, 'toby_final6', NULL, NULL, 9321, 20),
(284463, NULL, 'SM01168', NULL, NULL, NULL, NULL, 'DUF1907_2', NULL, NULL, 7703, 20),
(284464, NULL, 'SM01117', NULL, NULL, NULL, NULL, 'Cyt_b5_2', NULL, NULL, 1047, 20),
(284465, NULL, 'SM01245', NULL, NULL, NULL, NULL, 'Jag_N_2', NULL, NULL, 22159, 20),
(284466, NULL, 'SM00446', NULL, NULL, NULL, NULL, 'LRRcap_2', NULL, NULL, 393, 20),
(284467, NULL, 'SM00455', NULL, NULL, NULL, NULL, 'RBD_5', NULL, NULL, 2992, 20),
(284468, NULL, 'SM01405', NULL, NULL, NULL, NULL, 'Ribosomal_S6e_2', NULL, NULL, 6808, 20),
(284469, NULL, 'SM00275', NULL, NULL, NULL, NULL, 'galpha_1', NULL, NULL, 5409, 20),
(284470, NULL, 'SM00319', NULL, NULL, NULL, NULL, 'TAR_3', NULL, NULL, 2649, 20),
(284471, NULL, 'SM01364', NULL, NULL, NULL, NULL, 'NPP_2', NULL, NULL, 11868, 20),
(284472, NULL, 'SM00219', NULL, NULL, NULL, NULL, 'tyrkin_6', NULL, NULL, 20230, 20),
(284473, NULL, 'SM00267', NULL, NULL, NULL, NULL, 'duf1_3', NULL, NULL, 1794, 20),
(284474, NULL, 'SM00786', NULL, NULL, NULL, NULL, 'shr3_chaperone2', NULL, NULL, 13314, 20),
(284475, NULL, 'SM00465', NULL, NULL, NULL, NULL, 'uri_9', NULL, NULL, 808, 20),
(284476, NULL, 'SM01179', NULL, NULL, NULL, NULL, 'DUF862_2a', NULL, NULL, 13814, 20),
(284477, NULL, 'SM00955', NULL, NULL, NULL, NULL, 'RNB_2', NULL, NULL, 2300, 20),
(284478, NULL, 'SM00932', NULL, NULL, NULL, NULL, 'Nfu_N_3a', NULL, NULL, 11889, 20),
(284479, NULL, 'SM00528', NULL, NULL, NULL, NULL, 'hnsneu2', NULL, NULL, 24763, 20),
(284480, NULL, 'SM00235', NULL, NULL, NULL, NULL, 'col_5', NULL, NULL, 1281, 20),
(284481, NULL, 'SM00263', NULL, NULL, NULL, NULL, 'lysozyme-fin', NULL, NULL, 4337, 20),
(284482, NULL, 'SM01265', NULL, NULL, NULL, NULL, 'Mab_21_2', NULL, NULL, 22042, 20);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(284483, NULL, 'SM00916', NULL, NULL, NULL, NULL, 'L51_S25_CI_B8_2', NULL, NULL, 1146, 20),
(284484, NULL, 'SM01300', NULL, NULL, NULL, NULL, 'PEHE_2', NULL, NULL, 23566, 20),
(284485, NULL, 'SM00615', NULL, NULL, NULL, NULL, 'eph', NULL, NULL, 1425, 20),
(284486, NULL, 'SM00648', NULL, NULL, NULL, NULL, 'surpneu2', NULL, NULL, 2928, 20),
(284487, NULL, 'SM00153', NULL, NULL, NULL, NULL, 'VHP_1', NULL, NULL, 1700, 20),
(284488, NULL, 'SM00690', NULL, NULL, NULL, NULL, 'dm5', NULL, NULL, 2606, 20),
(284489, NULL, 'SM01152', NULL, NULL, NULL, NULL, 'DUF167_2', NULL, NULL, 2129, 20),
(284490, NULL, 'SM00609', NULL, NULL, NULL, NULL, 'vit', NULL, NULL, 13773, 20),
(284491, NULL, 'SM01081', NULL, NULL, NULL, NULL, 'CHB_HEX_2', NULL, NULL, 7326, 20),
(284492, NULL, 'SM01201', NULL, NULL, NULL, NULL, 'FerB_2', NULL, NULL, 9019, 20),
(284493, NULL, 'SM00004', NULL, NULL, NULL, NULL, 'NL_2', NULL, NULL, 6841, 20),
(284494, NULL, 'SM01352', NULL, NULL, NULL, NULL, 'APCDDC_2', NULL, NULL, 23064, 20),
(284495, NULL, 'SM01262', NULL, NULL, NULL, NULL, 'LAMTOR_2', NULL, NULL, 26894, 20),
(284496, NULL, 'SM00220', NULL, NULL, NULL, NULL, 'serkin_6', NULL, NULL, 3595, 20),
(284497, NULL, 'SM00114', NULL, NULL, NULL, NULL, 'card_3', NULL, NULL, 323, 20),
(284498, NULL, 'SM00135', NULL, NULL, NULL, NULL, 'LY_2', NULL, NULL, 7219, 20),
(284499, NULL, 'SM00957', NULL, NULL, NULL, NULL, 'SecA_DEAD_2', NULL, NULL, 11242, 20),
(284500, NULL, 'SM00490', NULL, NULL, NULL, NULL, 'helicmild6', NULL, NULL, 3282, 20),
(284501, NULL, 'SM00862', NULL, NULL, NULL, NULL, 'Trans_reg_C_3', NULL, NULL, 4108, 20),
(284502, NULL, 'SM00889', NULL, NULL, NULL, NULL, 'EFG_IV_2', NULL, NULL, 1765, 20),
(284503, NULL, 'SM00776', NULL, NULL, NULL, NULL, 'npcbm', NULL, NULL, 12077, 20),
(284504, NULL, 'SM01088', NULL, NULL, NULL, NULL, 'Col_cuticle_N_2', NULL, NULL, 684, 20),
(284505, NULL, 'SM00361', NULL, NULL, NULL, NULL, 'rrm2_1', NULL, NULL, 7230, 20),
(284506, NULL, 'SM01395', NULL, NULL, NULL, NULL, 'Tbf5_2', NULL, NULL, 8320, 20),
(284507, NULL, 'SM00682', NULL, NULL, NULL, NULL, '1g2_nido', NULL, NULL, 1394, 20),
(284508, NULL, 'SM00093', NULL, NULL, NULL, NULL, 'serpin2', NULL, NULL, 16863, 20),
(284509, NULL, 'SM01039', NULL, NULL, NULL, NULL, 'BRICHOS_2', NULL, NULL, 471, 20),
(284510, NULL, 'SM01136', NULL, NULL, NULL, NULL, 'DKCLD_2', NULL, NULL, 11732, 20),
(284511, NULL, 'SM00147', NULL, NULL, NULL, NULL, 'RasGEF_3', NULL, NULL, 2167, 20),
(284512, NULL, 'SM00150', NULL, NULL, NULL, NULL, 'SPEC_4', NULL, NULL, 13944, 20),
(284513, NULL, 'SM00305', NULL, NULL, NULL, NULL, 'HINTC_6', NULL, NULL, 420, 20),
(284514, NULL, 'SM01164', NULL, NULL, NULL, NULL, 'DUF1856_2', NULL, NULL, 8621, 20),
(284515, NULL, 'SM00983', NULL, NULL, NULL, NULL, 'TPK_B1_binding_a_2_a', NULL, NULL, 5550, 20),
(284516, NULL, 'SM00891', NULL, NULL, NULL, NULL, 'ERCC4_2', NULL, NULL, 10492, 20),
(284517, NULL, 'SM01350', NULL, NULL, NULL, NULL, '6PGD_2', NULL, NULL, 10322, 20),
(284518, NULL, 'SM00831', NULL, NULL, NULL, NULL, 'Cation_ATPase_N_a_2', NULL, NULL, 845, 20),
(284519, NULL, 'SM01345', NULL, NULL, NULL, NULL, 'Rapamycin_bind_3', NULL, NULL, NULL, 20),
(284520, NULL, 'SM01335', NULL, NULL, NULL, NULL, 'PADR1_2', NULL, NULL, 12445, 20),
(284521, NULL, 'SM01317', NULL, NULL, NULL, NULL, 'SPOB_ab_2', NULL, NULL, 11493, 20),
(284522, NULL, 'SM00175', NULL, NULL, NULL, NULL, 'rab_sub_5', NULL, NULL, NULL, 20),
(284523, NULL, 'SM00829', NULL, NULL, NULL, NULL, 'PKS_ER_names_mod', NULL, NULL, 14536, 20),
(284524, NULL, 'SM00977', NULL, NULL, NULL, NULL, 'TilS_C_a_2_a', NULL, NULL, 9843, 20),
(284525, NULL, 'SM00096', NULL, NULL, NULL, NULL, 'utero2', NULL, NULL, NULL, 20),
(284526, NULL, 'SM01198', NULL, NULL, NULL, NULL, 'FBA_2', NULL, NULL, 3584, 20),
(284527, NULL, 'SM00990', NULL, NULL, NULL, NULL, 'VRR_NUC_a_2', NULL, NULL, 13149, 20),
(284528, NULL, 'SM01409', NULL, NULL, NULL, NULL, 'RNA_pol_Rpb6_2', NULL, NULL, 10197, 20),
(284529, NULL, 'SM00918', NULL, NULL, NULL, NULL, 'Lig_chan_Glu_bd_2', NULL, NULL, 20436, 20),
(284530, NULL, 'SM00486', NULL, NULL, NULL, NULL, 'polmehr3', NULL, NULL, 11262, 20);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(284531, NULL, 'SM00775', NULL, NULL, NULL, NULL, 'lns2', NULL, NULL, 12978, 20),
(284532, NULL, 'SM01208', NULL, NULL, NULL, NULL, 'G5_2', NULL, NULL, 11020, 20),
(284533, NULL, 'SM00278', NULL, NULL, NULL, NULL, 'HhH1_4', NULL, NULL, 16, 20),
(284534, NULL, 'SM00563', NULL, NULL, NULL, NULL, 'plsc_2', NULL, NULL, 1094, 20),
(284535, NULL, 'SM00738', NULL, NULL, NULL, NULL, 'nusgn_4', NULL, NULL, 1494, 20),
(284536, NULL, 'SM01387', NULL, NULL, NULL, NULL, 'Ribosomal_S15_2', NULL, NULL, 5694, 20),
(284537, NULL, 'SM01031', NULL, NULL, NULL, NULL, 'BHD_2_2', NULL, NULL, 17506, 20),
(284538, NULL, 'SM01035', NULL, NULL, NULL, NULL, 'BOP1NT_2', NULL, NULL, 11744, 20),
(284539, NULL, 'SM00036', NULL, NULL, NULL, NULL, 'nik_2', NULL, NULL, 1114, 20),
(284540, NULL, 'SM00557', NULL, NULL, NULL, NULL, 'flmn_3', NULL, NULL, 2326, 20),
(284541, NULL, 'SM01143', NULL, NULL, NULL, NULL, 'DSX_dimer_2', NULL, NULL, 14485, 20),
(284542, NULL, 'SM00850', NULL, NULL, NULL, NULL, 'LytTR_3', NULL, NULL, 10161, 20),
(284543, NULL, 'SM01223', NULL, NULL, NULL, NULL, 'FTO_NTD_2', NULL, NULL, 22804, 20),
(284544, NULL, 'SM01135', NULL, NULL, NULL, NULL, 'DIRP_2', NULL, NULL, 30207, 20),
(284545, NULL, 'SM00411', NULL, NULL, NULL, NULL, 'bhlneu', NULL, NULL, 1984, 20),
(284546, NULL, 'SM00745', NULL, NULL, NULL, NULL, 'smart', NULL, NULL, 5229, 20),
(284547, NULL, 'SM00469', NULL, NULL, NULL, NULL, 'WIF_1', NULL, NULL, 3678, 20),
(284548, NULL, 'SM00608', NULL, NULL, NULL, NULL, 'acr', NULL, NULL, 347, 20),
(284549, NULL, 'SM00027', NULL, NULL, NULL, NULL, 'eh_3', NULL, NULL, 1264, 20),
(284550, NULL, 'SM01057', NULL, NULL, NULL, NULL, 'Carb_anhydrase_2a', NULL, NULL, 2404, 20),
(284551, NULL, 'SM00197', NULL, NULL, NULL, NULL, 'SAA_2', NULL, NULL, 3847, 20),
(284552, NULL, 'SM00008', NULL, NULL, NULL, NULL, 'HormR_1', NULL, NULL, 4113, 20),
(284553, NULL, 'SM01344', NULL, NULL, NULL, NULL, 'NUC194_2', NULL, NULL, 9246, 20),
(284554, NULL, 'SM00794', NULL, NULL, NULL, NULL, 'agrd', NULL, NULL, 12733, 20),
(284555, NULL, 'SM01181', NULL, NULL, NULL, NULL, 'E2_bind_2', NULL, NULL, 14462, 20),
(284556, NULL, 'SM01128', NULL, NULL, NULL, NULL, 'DDRGK_2', NULL, NULL, 18418, 20),
(284557, NULL, 'SM00384', NULL, NULL, NULL, NULL, 'AT_hook_2', NULL, NULL, 14566, 20),
(284558, NULL, 'SM00579', NULL, NULL, NULL, NULL, '9598neu4hmm', NULL, NULL, 470, 20),
(284559, NULL, 'SM00260', NULL, NULL, NULL, NULL, 'chew_2', NULL, NULL, 1677, 20),
(284560, NULL, 'SM00982', NULL, NULL, NULL, NULL, 'TRCF_a_2_a', NULL, NULL, 10743, 20),
(284561, NULL, 'SM00192', NULL, NULL, NULL, NULL, 'LDLa_2', NULL, NULL, 5466, 20),
(284562, NULL, 'SM01079', NULL, NULL, NULL, NULL, 'CHASE_2', NULL, NULL, 11026, 20),
(284563, NULL, 'SM00882', NULL, NULL, NULL, NULL, 'CoA_trans_3', NULL, NULL, 2966, 20),
(284564, NULL, 'SM01066', NULL, NULL, NULL, NULL, 'CBM_25_3', NULL, NULL, 10355, 20),
(284565, NULL, 'SM00554', NULL, NULL, NULL, NULL, 'fasc_3', NULL, NULL, 4839, 20),
(284566, NULL, 'SM00668', NULL, NULL, NULL, NULL, 'ctlh', NULL, NULL, 1348, 20),
(284567, NULL, 'SM00672', NULL, NULL, NULL, NULL, 'cap10', NULL, NULL, 1004, 20),
(284568, NULL, 'SM00900', NULL, NULL, NULL, NULL, 'FMN_bind_2', NULL, NULL, 5389, 20),
(284569, NULL, 'SM00934', NULL, NULL, NULL, NULL, 'OMPdecase_2', NULL, NULL, 3413, 20),
(284570, NULL, 'SM00177', NULL, NULL, NULL, NULL, 'arf_sub_2', NULL, NULL, NULL, 20),
(284571, NULL, 'SM00421', NULL, NULL, NULL, NULL, 'luxrmega5', NULL, NULL, 6599, 20),
(284572, NULL, 'SM00997', NULL, NULL, NULL, NULL, 'AdoHcyase_NAD_2', NULL, NULL, 7164, 20),
(284573, NULL, 'SM00852', NULL, NULL, NULL, NULL, 'MoCF_biosynth_3a', NULL, NULL, 6278, 20),
(284574, NULL, 'SM00912', NULL, NULL, NULL, NULL, 'Haemagg_act_2a', NULL, NULL, 14010, 20),
(284575, NULL, 'SM00461', NULL, NULL, NULL, NULL, 'WH1_2', NULL, NULL, 3602, 20),
(284576, NULL, 'SM00584', NULL, NULL, NULL, NULL, '109ultra', NULL, NULL, 329, 20),
(284577, NULL, 'SM00758', NULL, NULL, NULL, NULL, 'pa14_novel', NULL, NULL, 10963, 20),
(284578, NULL, 'SM00663', NULL, NULL, NULL, NULL, 'rpolaneu7', NULL, NULL, 830, 20); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(284579, NULL, 'SM00482', NULL, NULL, NULL, NULL, 'polaultra3', NULL, NULL, 1069, 20),
(284580, NULL, 'SM00018', NULL, NULL, NULL, NULL, 'P_2', NULL, NULL, 5964, 20),
(284581, NULL, 'SM00451', NULL, NULL, NULL, NULL, 'ZnF_U1_5', NULL, NULL, 238, 20),
(284582, NULL, 'SM01019', NULL, NULL, NULL, NULL, 'B3_2', NULL, NULL, 4130, 20),
(284583, NULL, 'SM00774', NULL, NULL, NULL, NULL, 'WRKY_cls', NULL, NULL, 1228, 20),
(284584, NULL, 'SM00741', NULL, NULL, NULL, NULL, 'sapb_4', NULL, NULL, 7097, 20),
(284585, NULL, 'SM00634', NULL, NULL, NULL, NULL, 'big_1', NULL, NULL, 4058, 20),
(284586, NULL, 'SM00722', NULL, NULL, NULL, NULL, 'complete', NULL, NULL, 1002, 20),
(284587, NULL, 'SM00501', NULL, NULL, NULL, NULL, 'bright_3', NULL, NULL, 5497, 20),
(284588, NULL, 'SM01146', NULL, NULL, NULL, NULL, 'DUF1086_2', NULL, NULL, 9243, 20),
(284589, NULL, 'SM00675', NULL, NULL, NULL, NULL, 'dm11', NULL, NULL, 1467, 20),
(284590, NULL, 'SM00939', NULL, NULL, NULL, NULL, 'PepX_C_2', NULL, NULL, 7875, 20),
(284591, NULL, 'SM01142', NULL, NULL, NULL, NULL, 'DSHCT_2', NULL, NULL, 11724, 20),
(284592, NULL, 'SM00423', NULL, NULL, NULL, NULL, 'psinew7', NULL, NULL, 11903, 20),
(284593, NULL, 'SM01054', NULL, NULL, NULL, NULL, 'CaM_binding_2', NULL, NULL, 13425, 20),
(284594, NULL, 'SM00931', NULL, NULL, NULL, NULL, 'NOSIC_2', NULL, NULL, 11526, 20),
(284595, NULL, 'SM00306', NULL, NULL, NULL, NULL, 'hint_7', NULL, NULL, 234, 20),
(284596, NULL, 'SM00886', NULL, NULL, NULL, NULL, 'Dabb_2', NULL, NULL, 18948, 20),
(284597, NULL, 'SM00107', NULL, NULL, NULL, NULL, 'ph_extension_3', NULL, NULL, 5094, 20),
(284598, NULL, 'SM00126', NULL, NULL, NULL, NULL, 'IL6_2', NULL, NULL, 24765, 20),
(284599, NULL, 'SM00285', NULL, NULL, NULL, NULL, 'PBD_5', NULL, NULL, 2548, 20),
(284600, NULL, 'SM00804', NULL, NULL, NULL, NULL, 'TAP_C_cls', NULL, NULL, 2768, 20),
(284601, NULL, 'SM00971', NULL, NULL, NULL, NULL, 'SATase_N_2_a', NULL, NULL, 10243, 20),
(284602, NULL, 'SM00678', NULL, NULL, NULL, NULL, 'deltex', NULL, NULL, 13804, 20),
(284603, NULL, 'SM00388', NULL, NULL, NULL, NULL, 'HisKA_10', NULL, NULL, 1082, 20),
(284604, NULL, 'SM00493', NULL, NULL, NULL, NULL, 'toprim5', NULL, NULL, 11269, 20),
(284605, NULL, 'SM01127', NULL, NULL, NULL, NULL, 'DDHD_2a', NULL, NULL, 2533, 20),
(284606, NULL, 'SM01361', NULL, NULL, NULL, NULL, 'A2M_recep_2', NULL, NULL, 12486, 20),
(284607, NULL, 'SM01118', NULL, NULL, NULL, NULL, 'CYTH_2', NULL, NULL, 16550, 20),
(284608, NULL, 'SM00723', NULL, NULL, NULL, NULL, 'amop', NULL, NULL, 1745, 20),
(284609, NULL, 'SM00592', NULL, NULL, NULL, NULL, '122neu5', NULL, NULL, 41, 20),
(284610, NULL, 'SM00747', NULL, NULL, NULL, NULL, '2CFEM', NULL, NULL, 8574, 20),
(284611, NULL, 'SM00840', NULL, NULL, NULL, NULL, 'dalr_2_4', NULL, NULL, 12273, 20),
(284612, NULL, 'SM00907', NULL, NULL, NULL, NULL, 'GDNF_2', NULL, NULL, 14474, 20),
(284613, NULL, 'SM00262', NULL, NULL, NULL, NULL, 'VILL_6', NULL, NULL, 315, 20),
(284614, NULL, 'SM01310', NULL, NULL, NULL, NULL, 'RICTOR_V_2', NULL, NULL, 23742, 20),
(284615, NULL, 'SM00463', NULL, NULL, NULL, NULL, 'SMR_2', NULL, NULL, 2517, 20),
(284616, NULL, 'SM00822', NULL, NULL, 'This enzymatic domain is part of bacterial polyketide synthases and catalyses the first step in the reductive modification of the beta-carbonyl centres in the growing polyketide chain. It uses NADPH to reduce the keto group to a hydroxy group.', NULL, 'PKS_KR', NULL, NULL, NULL, 20),
(284617, NULL, 'SM00631', NULL, NULL, NULL, NULL, 'zn_carb', NULL, NULL, 211, 20),
(284618, NULL, 'SM01155', NULL, NULL, NULL, NULL, 'DUF1713_2', NULL, NULL, 17391, 20),
(284619, NULL, 'SM00847', NULL, NULL, NULL, NULL, 'ha2_5', NULL, NULL, 10395, 20),
(284620, NULL, 'SM00854', NULL, NULL, NULL, NULL, 'PGA_cap_3', NULL, NULL, 16886, 20),
(284621, NULL, 'SM01383', NULL, NULL, NULL, NULL, 'Ribosomal_L2_2', NULL, NULL, 210, 20),
(284622, NULL, 'SM01378', NULL, NULL, NULL, NULL, 'Romo1_2', NULL, NULL, 9290, 20),
(284623, NULL, 'SM00567', NULL, NULL, 'E-Z type HEAT repeats', NULL, 'EZ_HEAT', NULL, NULL, 2502, 20);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(284624, NULL, 'SM00309', NULL, NULL, NULL, NULL, 'PAH_1', NULL, NULL, 2149, 20),
(284625, NULL, 'SM00653', NULL, NULL, NULL, NULL, 'eIF2Bneu4', NULL, NULL, 3718, 20),
(284626, NULL, 'SM00981', NULL, NULL, NULL, NULL, 'THUMP_a_2', NULL, NULL, 1542, 20),
(284627, NULL, 'SM00380', NULL, NULL, NULL, NULL, 'rav1_2', NULL, NULL, 3180, 20),
(284628, NULL, 'SM01330', NULL, NULL, NULL, NULL, 'Frizzled_2', NULL, NULL, 5949, 20),
(284629, NULL, 'SM01338', NULL, NULL, NULL, NULL, 'NOD_2', NULL, NULL, 9262, 20),
(284630, NULL, 'SM00072', NULL, NULL, NULL, NULL, 'gk_7', NULL, NULL, 7453, 20),
(284631, NULL, 'SM00483', NULL, NULL, NULL, NULL, 'polxneu3', NULL, NULL, 1066, 20),
(284632, NULL, 'SM00154', NULL, NULL, NULL, NULL, 'AN1_Zf_4', NULL, NULL, 3586, 20),
(284633, NULL, 'SM01288', NULL, NULL, NULL, NULL, 'FISNA_2', NULL, NULL, 22435, 20),
(284634, NULL, 'SM01398', NULL, NULL, NULL, NULL, 'Cornichon_2', NULL, NULL, 6405, 20),
(284635, NULL, 'SM00639', NULL, NULL, NULL, NULL, 'psa', NULL, NULL, 6204, 20),
(284636, NULL, 'SM00500', NULL, NULL, NULL, NULL, 'pr04_2', NULL, NULL, 13229, 20),
(284637, NULL, 'SM00385', NULL, NULL, NULL, NULL, 'cyclin_7', NULL, NULL, 7606, 20),
(284638, NULL, 'SM00307', NULL, NULL, NULL, NULL, 'ILWEQ_1', NULL, NULL, 1690, 20),
(284639, NULL, 'SM00964', NULL, NULL, NULL, NULL, 'STAT_int_2', NULL, NULL, 17704, 20),
(284640, NULL, 'SM00233', NULL, NULL, NULL, NULL, 'PH_update', NULL, NULL, 1423, 20),
(284641, NULL, 'SM01270', NULL, NULL, NULL, NULL, 'Longin_2', NULL, NULL, 5394, 20),
(284642, NULL, 'SM00729', NULL, NULL, NULL, NULL, 'MiaB', NULL, NULL, 1197, 20),
(284643, NULL, 'SM00155', NULL, NULL, NULL, NULL, 'pld_4', NULL, NULL, 3059, 20),
(284644, NULL, 'SM00226', NULL, NULL, NULL, NULL, 'LMWPc_2', NULL, NULL, 16967, 20),
(284645, NULL, 'SM00252', NULL, NULL, NULL, NULL, 'SH2_5', NULL, NULL, 3268, 20),
(284646, NULL, 'SM00844', NULL, NULL, NULL, NULL, 'GA_2', NULL, NULL, 14885, 20),
(284647, NULL, 'SM00855', NULL, NULL, NULL, NULL, 'PGAM_5', NULL, NULL, 7475, 20),
(284648, NULL, 'SM00475', NULL, NULL, NULL, NULL, '53exo3', NULL, NULL, 2969, 20),
(284649, NULL, 'SM00683', NULL, NULL, NULL, NULL, 'dm16', NULL, NULL, 9447, 20),
(284650, NULL, 'SM00871', NULL, NULL, NULL, NULL, 'AraC_E_bind_2', NULL, NULL, 10445, 20),
(284651, NULL, 'SM01356', NULL, NULL, NULL, NULL, 'AP4E_app_platf_2', NULL, NULL, 26927, 20),
(284652, NULL, 'SM00045', NULL, NULL, NULL, NULL, 'dagk_c4b_2', NULL, NULL, 6575, 20),
(284653, NULL, 'SM01165', NULL, NULL, NULL, NULL, 'DUF1866_2', NULL, NULL, 7920, 20),
(284654, NULL, 'SM01298', NULL, NULL, NULL, NULL, 'KapB_2', NULL, NULL, 13253, 20),
(284655, NULL, 'SM00324', NULL, NULL, NULL, NULL, 'RhoGAP_3', NULL, NULL, 1407, 20),
(284656, NULL, 'SM00512', NULL, NULL, NULL, NULL, 'skp1_3', NULL, NULL, 551, 20),
(284657, NULL, 'SM00860', NULL, NULL, NULL, NULL, 'SMI1_KNR4_3', NULL, NULL, 14903, 20),
(284658, NULL, 'SM00718', NULL, NULL, NULL, NULL, 'dm4_12', NULL, NULL, 1124, 20),
(284659, NULL, 'SM00138', NULL, NULL, NULL, NULL, 'methyl_trans_3', NULL, NULL, 3977, 20),
(284660, NULL, 'SM01183', NULL, NULL, NULL, NULL, 'EF1G_2', NULL, NULL, 5107, 20),
(284661, NULL, 'SM00089', NULL, NULL, NULL, NULL, 'PKD_9', NULL, NULL, 21039, 20),
(284662, NULL, 'SM00241', NULL, NULL, NULL, NULL, 'zp_4', NULL, NULL, 6041, 20),
(284663, NULL, 'SM00859', NULL, NULL, NULL, NULL, 'Semialdhyde_dh_3', NULL, NULL, 5944, 20),
(284664, NULL, 'SM00245', NULL, NULL, NULL, NULL, 'tsp_4', NULL, NULL, 4233, 20),
(284665, NULL, 'SM00102', NULL, NULL, NULL, NULL, 'adf_2', NULL, NULL, 5363, 20),
(284666, NULL, 'SM00612', NULL, NULL, NULL, NULL, 'kelc_smart', NULL, NULL, 1361, 20),
(284667, NULL, 'SM01318', NULL, NULL, NULL, NULL, 'SVWC_2', NULL, NULL, 26432, 20),
(284668, NULL, 'SM01064', NULL, NULL, NULL, NULL, 'CBM_10_2', NULL, NULL, 9951, 20),
(284669, NULL, 'SM00701', NULL, NULL, NULL, NULL, 'pgrp', NULL, NULL, 1322, 20),
(284670, NULL, 'SM00078', NULL, NULL, NULL, NULL, 'IlGF_1', NULL, NULL, 11550, 20),
(284671, NULL, 'SM00726', NULL, NULL, NULL, NULL, 'uim', NULL, NULL, 4073, 20),
(284672, NULL, 'SM01302', NULL, NULL, NULL, NULL, 'Raptor_N_2', NULL, NULL, 23576, 20);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(284673, NULL, 'SM00650', NULL, NULL, NULL, NULL, 'rADcneu6', NULL, NULL, 20738, 20),
(284674, NULL, 'SM00686', NULL, NULL, NULL, NULL, 'dm13', NULL, NULL, 19302, 20),
(284675, NULL, 'SM01332', NULL, NULL, NULL, NULL, 'Cyclin_C_2', NULL, NULL, 5287, 20),
(284676, NULL, 'SM01138', NULL, NULL, NULL, NULL, 'DP_2', NULL, NULL, 13311, 20),
(284677, NULL, 'SM00259', NULL, NULL, NULL, NULL, 'A20_3', NULL, NULL, 2964, 20),
(284678, NULL, 'SM00342', NULL, NULL, NULL, NULL, 'aracneu4', NULL, NULL, 13648, 20),
(284679, NULL, 'SM00837', NULL, NULL, NULL, NULL, 'dpbb_1', NULL, NULL, 328, 20),
(284680, NULL, 'SM01132', NULL, NULL, NULL, NULL, 'DIL_2', NULL, NULL, 3661, 20),
(284681, NULL, 'SM00051', NULL, NULL, NULL, NULL, 'dsl11', NULL, NULL, 3456, 20),
(284682, NULL, 'SM00645', NULL, NULL, NULL, NULL, 'pept_c1', NULL, NULL, 5565, 20),
(284683, NULL, 'SM01401', NULL, NULL, NULL, NULL, 'Sds3_2', NULL, NULL, 17533, 20),
(284684, NULL, 'SM01110', NULL, NULL, NULL, NULL, 'Cutinase_3', NULL, NULL, 3972, 20),
(284685, NULL, 'SM00420', NULL, NULL, NULL, NULL, 'deor2', NULL, NULL, 1253, 20),
(284686, NULL, 'SM00315', NULL, NULL, NULL, NULL, 'RGS_3', NULL, NULL, 11395, 20),
(284687, NULL, 'SM00243', NULL, NULL, 'Growth-Arrest-Specific Protein 2 Domain', NULL, 'GAS2', NULL, NULL, 2733, 20),
(284688, NULL, 'SM00564', NULL, NULL, NULL, NULL, 'ire1_9', NULL, NULL, 19756, 20),
(284689, NULL, 'SM01087', NULL, NULL, NULL, NULL, 'COG6_2', NULL, NULL, 10337, 20),
(284690, NULL, 'SM00248', NULL, NULL, NULL, NULL, 'ANK_2a', NULL, NULL, 1485, 20),
(284691, NULL, 'SM00517', NULL, NULL, NULL, NULL, 'poly_2', NULL, NULL, 4619, 20),
(284692, NULL, 'SM00360', NULL, NULL, NULL, NULL, 'rrm1_1', NULL, NULL, 5671, 20),
(284693, NULL, 'SM00116', NULL, NULL, NULL, NULL, 'cbs_1', NULL, NULL, 3944, 20),
(284694, NULL, 'SM00087', NULL, NULL, NULL, NULL, 'para4', NULL, NULL, 6344, 20),
(284695, NULL, 'SM00397', NULL, NULL, NULL, NULL, 'tSNARE_6', NULL, NULL, 6695, 20),
(284696, NULL, 'SM00504', NULL, NULL, NULL, NULL, 'Ubox_2', NULL, NULL, 1000, 20),
(284697, NULL, 'SM00280', NULL, NULL, NULL, NULL, 'kazal_3', NULL, NULL, 6489, 20),
(284698, NULL, 'SM00737', NULL, NULL, NULL, NULL, 'pgtp_13', NULL, NULL, 1996, 20),
(284699, NULL, 'SM00498', NULL, NULL, NULL, NULL, 'it6_source', NULL, NULL, 7162, 20),
(284700, NULL, 'SM00989', NULL, NULL, NULL, NULL, 'V4R_2_a', NULL, NULL, 1543, 20),
(284701, NULL, 'SM00292', NULL, NULL, NULL, NULL, 'BRCT_7', NULL, NULL, 7483, 20),
(284702, NULL, 'SM00791', NULL, NULL, NULL, NULL, 'agglutinin', NULL, NULL, 9887, 20),
(284703, NULL, 'SM00318', NULL, NULL, NULL, NULL, 'SNASE_2', NULL, NULL, 10321, 20),
(284704, NULL, 'SM00103', NULL, NULL, NULL, NULL, 'albumin-fin', NULL, NULL, 12292, 20),
(284705, NULL, 'SM01004', NULL, NULL, NULL, NULL, 'ALAD_2', NULL, NULL, 3275, 20),
(284706, NULL, 'SM01342', NULL, NULL, NULL, NULL, 'TAN_2', NULL, NULL, 18863, 20),
(284707, NULL, 'SM01333', NULL, NULL, NULL, NULL, 'Tet_JBP_2', NULL, NULL, NULL, 20),
(284708, NULL, 'SM00162', NULL, NULL, NULL, NULL, 'sapA_2', NULL, NULL, 1591, 20),
(284709, NULL, 'SM00633', NULL, NULL, NULL, NULL, 'glyco_10', NULL, NULL, 3006, 20),
(284710, NULL, 'SM00035', NULL, NULL, NULL, NULL, 'clus1a', NULL, NULL, 13284, 20),
(284711, NULL, 'SM00246', NULL, NULL, NULL, NULL, 'wh2_8', NULL, NULL, 1510, 20),
(284712, NULL, 'SM01226', NULL, NULL, NULL, NULL, 'GAGA_bind_2', NULL, NULL, 9353, 20),
(284713, NULL, 'SM01154', NULL, NULL, NULL, NULL, 'DUF1704_2', NULL, NULL, 8595, 20),
(284714, NULL, 'SM01194', NULL, NULL, NULL, NULL, 'eRF1_1_2', NULL, NULL, 7034, 20),
(284715, NULL, 'SM01392', NULL, NULL, NULL, NULL, 'MAGE_N_2', NULL, NULL, 15244, 20),
(284716, NULL, 'SM00531', NULL, NULL, NULL, NULL, 'tfiie3', NULL, NULL, 5961, 20),
(284717, NULL, 'SM01195', NULL, NULL, NULL, NULL, 'FA_2', NULL, NULL, 11768, 20),
(284718, NULL, 'SM01200', NULL, NULL, NULL, NULL, 'FerA_2', NULL, NULL, 9301, 20),
(284719, NULL, 'SM00435', NULL, NULL, NULL, NULL, 'topeu', NULL, NULL, 7331, 20),
(284720, NULL, 'SM00805', NULL, NULL, NULL, NULL, 'agtrap2', NULL, NULL, 8027, 20);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(284721, NULL, 'SM00581', NULL, NULL, NULL, NULL, 'testneu', NULL, NULL, 8, 20),
(284722, NULL, 'SM00803', NULL, NULL, NULL, NULL, 'TAF_cls', NULL, NULL, 4037, 20),
(284723, NULL, 'SM00167', NULL, NULL, NULL, NULL, 'vps9_2', NULL, NULL, 1850, 20),
(284724, NULL, 'SM01159', NULL, NULL, NULL, NULL, 'DUF1744_2', NULL, NULL, 13801, 20),
(284725, NULL, 'SM00048', NULL, NULL, NULL, NULL, 'DEFSN_4', NULL, NULL, 2826, 20),
(284726, NULL, 'SM00661', NULL, NULL, NULL, NULL, 'rpol9cneu', NULL, NULL, 3296, 20),
(284727, NULL, 'SM00671', NULL, NULL, NULL, NULL, 'sel1', NULL, NULL, 1060, 20),
(284728, NULL, 'SM00046', NULL, NULL, NULL, NULL, 'dagk_c4a_7', NULL, NULL, 4477, 20),
(284729, NULL, 'SM00868', NULL, NULL, NULL, NULL, 'zf_AD_2', NULL, NULL, 8116, 20),
(284730, NULL, 'SM00277', NULL, NULL, NULL, NULL, 'GRAN_2', NULL, NULL, 1709, 20),
(284731, NULL, 'SM00481', NULL, NULL, NULL, NULL, 'npolultra', NULL, NULL, 2549, 20),
(284732, NULL, 'SM00937', NULL, NULL, NULL, NULL, 'PCRF_a_2', NULL, NULL, 7375, 20),
(284733, NULL, 'SM00021', NULL, NULL, NULL, NULL, 'dax_2', NULL, NULL, 1275, 20),
(284734, NULL, 'SM00771', NULL, NULL, NULL, NULL, 'ZipA_C_cls', NULL, NULL, 4718, 20),
(284735, NULL, 'SM00224', NULL, NULL, NULL, NULL, 'GGL_4', NULL, NULL, 7554, 20),
(284736, NULL, 'SM00673', NULL, NULL, NULL, NULL, 'carp', NULL, NULL, 1026, 20),
(284737, NULL, 'SM00443', NULL, NULL, NULL, NULL, 'G-patch_5', NULL, NULL, 6576, 20),
(284738, NULL, 'SM01408', NULL, NULL, NULL, NULL, 'ING_2', NULL, NULL, 22447, 20),
(284739, NULL, 'SM01315', NULL, NULL, NULL, NULL, 'Spc7_N_2', NULL, NULL, NULL, 20),
(284740, NULL, 'SM00290', NULL, NULL, NULL, NULL, 'Zf_UBP_1', NULL, NULL, 3441, 20),
(284741, NULL, 'SM01090', NULL, NULL, NULL, NULL, 'Copper_fist_2', NULL, NULL, 2454, 20),
(284742, NULL, 'SM00090', NULL, NULL, NULL, NULL, 'rio_2', NULL, NULL, 3612, 20),
(284743, NULL, 'SM01009', NULL, NULL, NULL, NULL, 'AlkA_N_2', NULL, NULL, 8740, 20),
(284744, NULL, 'SM00586', NULL, NULL, NULL, NULL, '3039neu', NULL, NULL, 419, 20),
(284745, NULL, 'SM01184', NULL, NULL, NULL, NULL, 'efhand_Ca_insen_2', NULL, NULL, NULL, 20),
(284746, NULL, 'SM01363', NULL, NULL, NULL, NULL, 'ACTH_domain_2', NULL, NULL, 12572, 20),
(284747, NULL, 'SM00846', NULL, NULL, NULL, NULL, 'gp_dh_n_7', NULL, NULL, 18716, 20),
(284748, NULL, 'SM01130', NULL, NULL, NULL, NULL, 'DHDPS_2', NULL, NULL, 5807, 20),
(284749, NULL, 'SM00537', NULL, NULL, NULL, NULL, 'doub1_11', NULL, NULL, 6945, 20),
(284750, NULL, 'SM01032', NULL, NULL, NULL, NULL, 'BHD_3_2', NULL, NULL, 19887, 20),
(284751, NULL, 'SM01033', NULL, NULL, NULL, NULL, 'BING4CT_2', NULL, NULL, 11552, 20),
(284752, NULL, 'SM01053', NULL, NULL, NULL, NULL, 'CaMBD_2', NULL, NULL, 2785, 20),
(284753, NULL, 'SM01147', NULL, NULL, NULL, NULL, 'DUF1087_2', NULL, NULL, 9226, 20),
(284754, NULL, 'SM00535', NULL, NULL, NULL, NULL, 'riboneu5', NULL, NULL, 80, 20),
(284755, NULL, 'SM00857', NULL, NULL, NULL, NULL, 'resolvase_6', NULL, NULL, 10360, 20),
(284756, NULL, 'SM00659', NULL, NULL, NULL, NULL, 'rpolcxc3', NULL, NULL, 961, 20),
(284757, NULL, 'SM00811', NULL, NULL, NULL, NULL, 'alpha_kinase', NULL, NULL, 2823, 20),
(284758, NULL, 'SM01382', NULL, NULL, NULL, NULL, 'Ribosomal_L2_C_2', NULL, NULL, 16785, 20),
(284759, NULL, 'SM00333', NULL, NULL, NULL, NULL, 'TUDOR_7', NULL, NULL, 7274, 20),
(284760, NULL, 'SM01176', NULL, NULL, NULL, NULL, 'DUF4208_2', NULL, NULL, 23289, 20),
(284761, NULL, 'SM00909', NULL, NULL, NULL, NULL, 'Germane_2', NULL, NULL, 20307, 20),
(284762, NULL, 'SM01374', NULL, NULL, NULL, NULL, 'Ribosomal_L14_2', NULL, NULL, 1825, 20),
(284763, NULL, 'SM00151', NULL, NULL, NULL, NULL, 'swib_2', NULL, NULL, 18313, 20),
(284764, NULL, 'SM00060', NULL, NULL, NULL, NULL, 'FN3_2', NULL, NULL, 7389, 20),
(284765, NULL, 'SM01381', NULL, NULL, NULL, NULL, '7TM_GPCR_Srsx_2', NULL, NULL, 4866, 20),
(284766, NULL, 'SM01400', NULL, NULL, NULL, NULL, 'Pribosyltran_N_2', NULL, NULL, NULL, 20),
(284767, NULL, 'SM00943', NULL, NULL, NULL, NULL, 'Prim_Pol_2_a', NULL, NULL, 13500, 20),
(284768, NULL, 'SM00727', NULL, NULL, NULL, NULL, 'CBM', NULL, NULL, 1210, 20);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(284769, NULL, 'SM01185', NULL, NULL, NULL, NULL, 'EFP_2', NULL, NULL, 2162, 20),
(284770, NULL, 'SM01403', NULL, NULL, NULL, NULL, 'Ribosomal_S10_2', NULL, NULL, 25515, 20),
(284771, NULL, 'SM00472', NULL, NULL, NULL, NULL, 'mir_2', NULL, NULL, 13509, 20),
(284772, NULL, 'SM00239', NULL, NULL, NULL, NULL, 'C2_3c', NULL, NULL, 2719, 20),
(284773, NULL, 'SM00325', NULL, NULL, NULL, NULL, 'RhoGEF_3', NULL, NULL, 3790, 20),
(284774, NULL, 'SM00152', NULL, NULL, NULL, NULL, 'THY_2', NULL, NULL, 1377, 20),
(284775, NULL, 'SSF58034', NULL, NULL, NULL, NULL, 'Multimerization domain of the phosphoprotein from sendai virus', NULL, NULL, NULL, 21),
(284776, NULL, 'SSF54197', NULL, NULL, NULL, NULL, 'HIT-like', NULL, NULL, 31944, 21),
(284777, NULL, 'SSF159936', NULL, NULL, NULL, NULL, 'NSP3A-like', NULL, NULL, 31147, 21),
(284778, NULL, 'SSF142897', NULL, NULL, NULL, NULL, 'TFB5-like', NULL, NULL, 13701, 21),
(284779, NULL, 'SSF160696', NULL, NULL, NULL, NULL, 'BTG domain-like', NULL, NULL, 32973, 21),
(284780, NULL, 'SSF52151', NULL, NULL, NULL, NULL, 'FabD/lysophospholipase-like', NULL, NULL, 12613, 21),
(284781, NULL, 'SSF103247', NULL, NULL, NULL, NULL, 'TT1751-like', NULL, NULL, 26533, 21),
(284782, NULL, 'SSF48557', NULL, NULL, NULL, NULL, 'L-aspartase-like', NULL, NULL, 8917, 21),
(284783, NULL, 'SSF103481', NULL, NULL, NULL, NULL, 'Multidrug resistance efflux transporter EmrE', NULL, NULL, NULL, 21),
(284784, NULL, 'SSF103431', NULL, NULL, NULL, NULL, 'Cytochrome f subunit of the cytochrome b6f complex, transmembrane anchor', NULL, NULL, 11302, 21),
(284785, NULL, 'SSF141099', NULL, NULL, NULL, NULL, 'Atu1913-like', NULL, NULL, 31090, 21),
(284786, NULL, 'SSF141734', NULL, NULL, NULL, NULL, 'HisI-like', NULL, NULL, 28313, 21),
(284787, NULL, 'SSF103565', NULL, NULL, NULL, NULL, 'Bubble protein', NULL, NULL, 27862, 21),
(284788, NULL, 'SSF89372', NULL, NULL, NULL, NULL, 'Fucose-specific lectin', NULL, NULL, NULL, 21),
(284789, NULL, 'SSF82671', NULL, NULL, NULL, NULL, 'SEA domain', NULL, NULL, 32789, 21),
(284790, NULL, 'SSF101215', NULL, NULL, NULL, NULL, 'KaiA/RbsU domain', NULL, NULL, 2799, 21),
(284791, NULL, 'SSF52733', NULL, NULL, NULL, NULL, 'Nicotinate mononucleotide:5,6-dimethylbenzimidazole phosphoribosyltransferase (CobT)', NULL, NULL, 32440, 21),
(284792, NULL, 'SSF63707', NULL, NULL, NULL, NULL, 'Ganglioside M2 (gm2) activator', NULL, NULL, 31886, 21),
(284793, NULL, 'SSF81548', NULL, NULL, NULL, NULL, 'Subunit XII of photosystem I reaction centre, PsaM', NULL, NULL, 31780, 21),
(284794, NULL, 'SSF57630', NULL, NULL, NULL, NULL, 'GLA-domain', NULL, NULL, 17997, 21),
(284795, NULL, 'SSF116846', NULL, NULL, NULL, NULL, 'MIT domain', NULL, NULL, 33155, 21),
(284796, NULL, 'SSF117289', NULL, NULL, NULL, NULL, 'Nucleoporin domain', NULL, NULL, NULL, 21),
(284797, NULL, 'SSF160113', NULL, NULL, NULL, NULL, 'YegP-like', NULL, NULL, 28513, 21),
(284798, NULL, 'SSF53137', NULL, NULL, NULL, NULL, 'Translational machinery components', NULL, NULL, NULL, 21),
(284799, NULL, 'SSF48613', NULL, NULL, NULL, NULL, 'Heme oxygenase-like', NULL, NULL, 9499, 21),
(284800, NULL, 'SSF140804', NULL, NULL, NULL, NULL, 'YidB-like', NULL, NULL, 26822, 21),
(284801, NULL, 'SSF53732', NULL, NULL, NULL, NULL, 'Aconitase iron-sulfur domain', NULL, NULL, 27915, 21),
(284802, NULL, 'SSF160920', NULL, NULL, NULL, NULL, 'PSTPO5379-like', NULL, NULL, 33489, 21),
(284803, NULL, 'SSF50331', NULL, NULL, NULL, NULL, 'MOP-like', NULL, NULL, 9981, 21),
(284804, NULL, 'SSF144232', NULL, NULL, NULL, NULL, 'HIT/MYND zinc finger-like', NULL, NULL, NULL, 21),
(284805, NULL, 'SSF159865', NULL, NULL, NULL, NULL, 'XkdW-like', NULL, NULL, 25057, 21),
(284806, NULL, 'SSF81343', NULL, NULL, NULL, NULL, 'Fumarate reductase respiratory complex transmembrane subunits', NULL, NULL, 31402, 21),
(284807, NULL, 'SSF158837', NULL, NULL, NULL, NULL, 'AGR C 984p-like', NULL, NULL, 15266, 21),
(284808, NULL, 'SSF140106', NULL, NULL, NULL, NULL, 'Calcyclin-binding protein-like', NULL, NULL, 27552, 21),
(284809, NULL, 'SSF158553', NULL, NULL, NULL, NULL, 'TAFH domain-like', NULL, NULL, 31530, 21);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(284810, NULL, 'SSF55298', NULL, NULL, NULL, NULL, 'YjgF-like', NULL, NULL, 19191, 21),
(284811, NULL, 'SSF102414', NULL, NULL, NULL, NULL, 'Alpha-2,3/8-sialyltransferase CstII', NULL, NULL, 32041, 21),
(284812, NULL, 'SSF54523', NULL, NULL, NULL, NULL, 'Pili subunits', NULL, NULL, 36147, 21),
(284813, NULL, 'SSF101082', NULL, NULL, NULL, NULL, 'Typo IV secretion system protein TraC', NULL, NULL, NULL, 21),
(284814, NULL, 'SSF101424', NULL, NULL, NULL, NULL, 'Hypothetical protein ST1625', NULL, NULL, 27597, 21),
(284815, NULL, 'SSF140482', NULL, NULL, NULL, NULL, 'MAST3 pre-PK domain-like', NULL, NULL, 13695, 21),
(284816, NULL, 'SSF103388', NULL, NULL, NULL, NULL, 'Virulence-associated V antigen', NULL, NULL, 28856, 21),
(284817, NULL, 'SSF50978', NULL, NULL, NULL, NULL, 'WD40 repeat-like', NULL, NULL, 28423, 21),
(284818, NULL, 'SSF140356', NULL, NULL, NULL, NULL, 'PPK N-terminal domain-like', NULL, NULL, 27813, 21),
(284819, NULL, 'SSF64234', NULL, NULL, NULL, NULL, 'Photosystem I subunit PsaD', NULL, NULL, 31025, 21),
(284820, NULL, 'SSF158544', NULL, NULL, NULL, NULL, 'GspK insert domain-like', NULL, NULL, 32610, 21),
(284821, NULL, 'SSF69754', NULL, NULL, NULL, NULL, 'Ribosome binding protein Y (YfiA homologue)', NULL, NULL, 31194, 21),
(284822, NULL, 'SSF69765', NULL, NULL, NULL, NULL, 'IpsF-like', NULL, NULL, 31207, 21),
(284823, NULL, 'SSF55904', NULL, NULL, NULL, NULL, 'Ornithine decarboxylase C-terminal domain', NULL, NULL, 28220, 21),
(284824, NULL, 'SSF81653', NULL, NULL, NULL, NULL, 'Calcium ATPase, transduction domain A', NULL, NULL, 775, 21),
(284825, NULL, 'SSF47005', NULL, NULL, NULL, NULL, 'Peripheral subunit-binding domain of 2-oxo acid dehydrogenase complex', NULL, NULL, 30971, 21),
(284826, NULL, 'SSF50784', NULL, NULL, NULL, NULL, 'Transcription factor IIA (TFIIA), beta-barrel domain', NULL, NULL, 6384, 21),
(284827, NULL, 'SSF46458', NULL, NULL, NULL, NULL, 'Globin-like', NULL, NULL, 6238, 21),
(284828, NULL, 'SSF47233', NULL, NULL, NULL, NULL, 'Bacterial GAP domain', NULL, NULL, 29642, 21),
(284829, NULL, 'SSF81427', NULL, NULL, NULL, NULL, 'Mitochondrial cytochrome c oxidase subunit VIIc (aka VIIIa)', NULL, NULL, 30830, 21),
(284830, NULL, 'SSF53213', NULL, NULL, NULL, NULL, 'LigB-like', NULL, NULL, NULL, 21),
(284831, NULL, 'SSF56849', NULL, NULL, NULL, NULL, 'delta-Endotoxin (insectocide), N-terminal domain', NULL, NULL, 31631, 21),
(284832, NULL, 'SSF53448', NULL, NULL, NULL, NULL, 'Nucleotide-diphospho-sugar transferases', NULL, NULL, 24008, 21),
(284833, NULL, 'SSF51092', NULL, NULL, NULL, NULL, 'Vitelline membrane outer protein-I (VMO-I)', NULL, NULL, 31612, 21),
(284834, NULL, 'SSF47040', NULL, NULL, NULL, NULL, 'Kix domain of CBP (creb binding protein)', NULL, NULL, 33227, 21),
(284835, NULL, 'SSF159034', NULL, NULL, NULL, NULL, 'Mib/herc2 domain-like', NULL, NULL, 33009, 21),
(284836, NULL, 'SSF82910', NULL, NULL, NULL, NULL, 'Apical membrane antigen 1', NULL, NULL, 12291, 21),
(284837, NULL, 'SSF103063', NULL, NULL, NULL, NULL, 'Hypothetical protein YoaG', NULL, NULL, 31407, 21),
(284838, NULL, 'SSF90002', NULL, NULL, NULL, NULL, 'Hypothetical protein YjiA, C-terminal domain', NULL, NULL, NULL, 21),
(284839, NULL, 'SSF49354', NULL, NULL, NULL, NULL, 'PapD-like', NULL, NULL, 8542, 21),
(284840, NULL, 'SSF54570', NULL, NULL, NULL, NULL, 'Ribosomal protein S19', NULL, NULL, 20334, 21),
(284841, NULL, 'SSF111430', NULL, NULL, NULL, NULL, 'YAP1 redox domain', NULL, NULL, 15812, 21),
(284842, NULL, 'SSF54621', NULL, NULL, NULL, NULL, 'Heme-binding protein A (HasA)', NULL, NULL, 28768, 21),
(284843, NULL, 'SSF111064', NULL, NULL, NULL, NULL, 'Hut operon positive regulatory protein HutP', NULL, NULL, 31267, 21),
(284844, NULL, 'SSF54001', NULL, NULL, NULL, NULL, 'Cysteine proteinases', NULL, NULL, 32476, 21),
(284845, NULL, 'SSF53271', NULL, NULL, NULL, NULL, 'PRTase-like', NULL, NULL, 24733, 21),
(284846, NULL, 'SSF103068', NULL, NULL, NULL, NULL, 'Nucleocapsid protein dimerization domain', NULL, NULL, 31616, 21),
(284847, NULL, 'SSF160930', NULL, NULL, NULL, NULL, 'FlhC-like', NULL, NULL, NULL, 21);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(284848, NULL, 'SSF90073', NULL, NULL, NULL, NULL, 'GCM domain', NULL, NULL, 32644, 21),
(284849, NULL, 'SSF82093', NULL, NULL, NULL, NULL, 'Heme chaperone CcmE', NULL, NULL, 33228, 21),
(284850, NULL, 'SSF81563', NULL, NULL, NULL, NULL, 'Photosystem I reaction center subunit X, PsaK', NULL, NULL, 31935, 21),
(284851, NULL, 'SSF52777', NULL, NULL, NULL, NULL, 'CoA-dependent acyltransferases', NULL, NULL, NULL, 21),
(284852, NULL, 'SSF49879', NULL, NULL, NULL, NULL, 'SMAD/FHA domain', NULL, NULL, 9633, 21),
(284853, NULL, 'SSF52821', NULL, NULL, NULL, NULL, 'Rhodanese/Cell cycle control phosphatase', NULL, NULL, 28463, 21),
(284854, NULL, 'SSF90183', NULL, NULL, NULL, NULL, 'Mollusk pheromone', NULL, NULL, 29640, 21),
(284855, NULL, 'SSF55724', NULL, NULL, NULL, NULL, 'Mog1p/PsbP-like', NULL, NULL, 11051, 21),
(284856, NULL, 'SSF56322', NULL, NULL, NULL, NULL, 'ADC synthase', NULL, NULL, 5661, 21),
(284857, NULL, 'SSF143113', NULL, NULL, NULL, NULL, 'NAP-like', NULL, NULL, 33293, 21),
(284858, NULL, 'SSF142019', NULL, NULL, NULL, NULL, 'Nqo1 FMN-binding domain-like', NULL, NULL, 29146, 21),
(284859, NULL, 'SSF56059', NULL, NULL, NULL, NULL, 'Glutathione synthetase ATP-binding domain-like', NULL, NULL, NULL, 21),
(284860, NULL, 'SSF81698', NULL, NULL, NULL, NULL, 'FF domain', NULL, NULL, 30030, 21),
(284861, NULL, 'SSF102220', NULL, NULL, NULL, NULL, 'DNA polymerase III psi subunit', NULL, NULL, 28743, 21),
(284862, NULL, 'SSF57440', NULL, NULL, NULL, NULL, 'Kringle-like', NULL, NULL, 7964, 21),
(284863, NULL, 'SSF160925', NULL, NULL, NULL, NULL, 'PG1388-like', NULL, NULL, NULL, 21),
(284864, NULL, 'SSF54893', NULL, NULL, NULL, NULL, 'Aspartate carbamoyltransferase, Regulatory-chain, N-terminal domain', NULL, NULL, 33089, 21),
(284865, NULL, 'SSF103007', NULL, NULL, NULL, NULL, 'Hypothetical protein TT1725', NULL, NULL, 27614, 21),
(284866, NULL, 'SSF50012', NULL, NULL, NULL, NULL, 'EV matrix protein', NULL, NULL, 32828, 21),
(284867, NULL, 'SSF55781', NULL, NULL, NULL, NULL, 'GAF domain-like', NULL, NULL, NULL, 21),
(284868, NULL, 'SSF56568', NULL, NULL, NULL, NULL, 'Non-globular alpha+beta subunits of globular proteins', NULL, NULL, 10128, 21),
(284869, NULL, 'SSF54695', NULL, NULL, NULL, NULL, 'POZ domain', NULL, NULL, 13762, 21),
(284870, NULL, 'SSF161055', NULL, NULL, NULL, NULL, 'PsbZ-like', NULL, NULL, 30368, 21),
(284871, NULL, 'SSF57598', NULL, NULL, NULL, NULL, 'Antifungal protein (AGAFP)', NULL, NULL, 21143, 21),
(284872, NULL, 'SSF55166', NULL, NULL, NULL, NULL, 'Hedgehog/DD-peptidase', NULL, NULL, 8571, 21),
(284873, NULL, 'SSF47862', NULL, NULL, NULL, NULL, 'Saposin', NULL, NULL, 8506, 21),
(284874, NULL, 'SSF56821', NULL, NULL, NULL, NULL, 'Prismane protein-like', NULL, NULL, 8835, 21),
(284875, NULL, 'SSF53335', NULL, NULL, NULL, NULL, 'S-adenosyl-L-methionine-dependent methyltransferases', NULL, NULL, 24808, 21),
(284876, NULL, 'SSF64383', NULL, NULL, NULL, NULL, 'Cell-division protein ZipA, C-terminal domain', NULL, NULL, 32100, 21),
(284877, NULL, 'SSF53223', NULL, NULL, NULL, NULL, 'Aminoacid dehydrogenase-like, N-terminal domain', NULL, NULL, 37622, 21),
(284878, NULL, 'SSF111326', NULL, NULL, NULL, NULL, 'Urocanase', NULL, NULL, 27221, 21),
(284879, NULL, 'SSF143548', NULL, NULL, NULL, NULL, 'Serine metabolism enzymes domain', NULL, NULL, 24105, 21),
(284880, NULL, 'SSF46561', NULL, NULL, NULL, NULL, 'Ribosomal protein L29 (L29p)', NULL, NULL, 32613, 21),
(284881, NULL, 'SSF117023', NULL, NULL, NULL, NULL, 'DNA primase DnaG, C-terminal domain', NULL, NULL, NULL, 21),
(284882, NULL, 'SSF64288', NULL, NULL, NULL, NULL, 'Chorismate lyase-like', NULL, NULL, 24113, 21),
(284883, NULL, 'SSF57647', NULL, NULL, NULL, NULL, 'HIV-1 VPU cytoplasmic domain', NULL, NULL, 9755, 21),
(284884, NULL, 'SSF47077', NULL, NULL, NULL, NULL, 'T4 endonuclease V', NULL, NULL, NULL, 21),
(284885, NULL, 'SSF47781', NULL, NULL, NULL, NULL, 'RuvA domain 2-like', NULL, NULL, 8938, 21),
(284886, NULL, 'SSF49835', NULL, NULL, NULL, NULL, 'Virus attachment protein globular domain', NULL, NULL, 9058, 21);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(284887, NULL, 'SSF140612', NULL, NULL, NULL, NULL, 'EB1 dimerisation domain-like', NULL, NULL, 33332, 21),
(284888, NULL, 'SSF51998', NULL, NULL, NULL, NULL, 'PFL-like glycyl radical enzymes', NULL, NULL, NULL, 21),
(284889, NULL, 'SSF46557', NULL, NULL, NULL, NULL, 'GreA transcript cleavage protein, N-terminal domain', NULL, NULL, 33459, 21),
(284890, NULL, 'SSF160582', NULL, NULL, NULL, NULL, 'MbtH-like', NULL, NULL, 28130, 21),
(284891, NULL, 'SSF52728', NULL, NULL, NULL, NULL, 'PTS IIb component', NULL, NULL, 28776, 21),
(284892, NULL, 'SSF52141', NULL, NULL, NULL, NULL, 'Uracil-DNA glycosylase-like', NULL, NULL, 28851, 21),
(284893, NULL, 'SSF51278', NULL, NULL, NULL, NULL, 'Urease, beta-subunit', NULL, NULL, 28395, 21),
(284894, NULL, 'SSF158855', NULL, NULL, NULL, NULL, 'Lipase chaperone-like', NULL, NULL, NULL, 21),
(284895, NULL, 'SSF117457', NULL, NULL, NULL, NULL, 'FumA C-terminal domain-like', NULL, NULL, 28882, 21),
(284896, NULL, 'SSF50242', NULL, NULL, NULL, NULL, 'TIMP-like', NULL, NULL, 9642, 21),
(284897, NULL, 'SSF54991', NULL, NULL, NULL, NULL, 'Anticodon-binding domain of PheRS', NULL, NULL, 31473, 21),
(284898, NULL, 'SSF63999', NULL, NULL, NULL, NULL, 'Thiamin pyrophosphokinase, catalytic domain', NULL, NULL, 32229, 21),
(284899, NULL, 'SSF75574', NULL, NULL, NULL, NULL, 'Rotavirus NSP2 fragment, N-terminal domain', NULL, NULL, 18951, 21),
(284900, NULL, 'SSF101283', NULL, NULL, NULL, NULL, 'GRIP domain', NULL, NULL, NULL, 21),
(284901, NULL, 'SSF55194', NULL, NULL, NULL, NULL, 'Ribosome recycling factor, RRF', NULL, NULL, 27038, 21),
(284902, NULL, 'SSF50129', NULL, NULL, NULL, NULL, 'GroES-like', NULL, NULL, 9098, 21),
(284903, NULL, 'SSF158442', NULL, NULL, NULL, NULL, 'DsbB-like', NULL, NULL, 15817, 21),
(284904, NULL, 'SSF52833', NULL, NULL, NULL, NULL, 'Thioredoxin-like', NULL, NULL, 29243, 21),
(284905, NULL, 'SSF50405', NULL, NULL, NULL, NULL, 'Actin-crosslinking proteins', NULL, NULL, 9569, 21),
(284906, NULL, 'SSF89232', NULL, NULL, NULL, NULL, 'Hypothetical protein TM1070', NULL, NULL, 29674, 21),
(284907, NULL, 'SSF52210', NULL, NULL, NULL, NULL, 'Succinyl-CoA synthetase domains', NULL, NULL, 11141, 21),
(284908, NULL, 'SSF89895', NULL, NULL, NULL, NULL, 'FYSH domain', NULL, NULL, 33136, 21),
(284909, NULL, 'SSF54814', NULL, NULL, NULL, NULL, 'Prokaryotic type KH domain (KH-domain type II)', NULL, NULL, 9581, 21),
(284910, NULL, 'SSF159283', NULL, NULL, NULL, NULL, 'Guanosine diphospho-D-mannose pyrophosphorylase/mannose-6-phosphate isomerase linker domain', NULL, NULL, NULL, 21),
(284911, NULL, 'SSF160631', NULL, NULL, NULL, NULL, 'SMI1/KNR4-like', NULL, NULL, 30563, 21),
(284912, NULL, 'SSF53036', NULL, NULL, NULL, NULL, 'Eukaryotic RPB5 N-terminal domain', NULL, NULL, 31540, 21),
(284913, NULL, 'SSF49367', NULL, NULL, NULL, NULL, 'Superoxide reductase-like', NULL, NULL, 32051, 21),
(284914, NULL, 'SSF110014', NULL, NULL, NULL, NULL, 'Her-1', NULL, NULL, 27980, 21),
(284915, NULL, 'SSF103107', NULL, NULL, NULL, NULL, 'Hypothetical protein c14orf129, hspc210', NULL, NULL, 9073, 21),
(284916, NULL, 'SSF55277', NULL, NULL, NULL, NULL, 'GYF domain', NULL, NULL, 19656, 21),
(284917, NULL, 'SSF52418', NULL, NULL, NULL, NULL, 'Nucleoside phosphorylase/phosphoribosyltransferase catalytic domain', NULL, NULL, 14454, 21),
(284918, NULL, 'SSF55073', NULL, NULL, NULL, NULL, 'Nucleotide cyclase', NULL, NULL, 25507, 21),
(284919, NULL, 'SSF47668', NULL, NULL, NULL, NULL, 'N-terminal domain of cbl (N-cbl)', NULL, NULL, 33251, 21),
(284920, NULL, 'SSF53681', NULL, NULL, NULL, NULL, 'Aspartate/glutamate racemase', NULL, NULL, 4203, 21),
(284921, NULL, 'SSF50882', NULL, NULL, NULL, NULL, 'beta-Barrel protease inhibitors', NULL, NULL, 10047, 21),
(284922, NULL, 'SSF143724', NULL, NULL, NULL, NULL, 'PHP14-like', NULL, NULL, NULL, 21),
(284923, NULL, 'SSF103256', NULL, NULL, NULL, NULL, 'Hypothetical protein TM0160', NULL, NULL, 33004, 21),
(284924, NULL, 'SSF144206', NULL, NULL, NULL, NULL, 'NOB1 zinc finger-like', NULL, NULL, 31607, 21),
(284925, NULL, 'SSF69903', NULL, NULL, NULL, NULL, 'NSP3 homodimer', NULL, NULL, 32450, 21);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(284926, NULL, 'SSF49441', NULL, NULL, NULL, NULL, 'Cytochrome f, large domain', NULL, NULL, 27904, 21),
(284927, NULL, 'SSF159238', NULL, NULL, NULL, NULL, 'SO1590-like', NULL, NULL, 15338, 21),
(284928, NULL, 'SSF63446', NULL, NULL, NULL, NULL, 'Type I dockerin domain', NULL, NULL, 31543, 21),
(284929, NULL, 'SSF69189', NULL, NULL, NULL, NULL, 'Penicillin-binding protein associated domain', NULL, NULL, 8368, 21),
(284930, NULL, 'SSF48056', NULL, NULL, NULL, NULL, 'Di-copper centre-containing domain', NULL, NULL, 8563, 21),
(284931, NULL, 'SSF102198', NULL, NULL, NULL, NULL, 'Putative cyclase', NULL, NULL, 33215, 21),
(284932, NULL, 'SSF56655', NULL, NULL, NULL, NULL, 'Carbohydrate phosphatase', NULL, NULL, NULL, 21),
(284933, NULL, 'SSF47912', NULL, NULL, NULL, NULL, 'Wiscott-Aldrich syndrome protein, WASP, C-terminal domain', NULL, NULL, 9336, 21),
(284934, NULL, 'SSF158949', NULL, NULL, NULL, NULL, 'Smr-associated domain-like', NULL, NULL, 33451, 21),
(284935, NULL, 'SSF63515', NULL, NULL, NULL, NULL, 'Outer surface protein C (OspC)', NULL, NULL, 28138, 21),
(284936, NULL, 'SSF56796', NULL, NULL, NULL, NULL, 'Dehydroquinate synthase-like', NULL, NULL, NULL, 21),
(284937, NULL, 'SSF48264', NULL, NULL, NULL, NULL, 'Cytochrome P450', NULL, NULL, 28905, 21),
(284938, NULL, 'SSF103111', NULL, NULL, NULL, NULL, 'Activator of Hsp90 ATPase, Aha1', NULL, NULL, 27584, 21),
(284939, NULL, 'SSF55418', NULL, NULL, NULL, NULL, 'eIF4e-like', NULL, NULL, 16121, 21),
(284940, NULL, 'SSF58091', NULL, NULL, NULL, NULL, 'Clostridium neurotoxins, "coiled-coil" domain', NULL, NULL, 29032, 21),
(284941, NULL, 'SSF101386', NULL, NULL, NULL, NULL, 'all-alpha NTP pyrophosphatases', NULL, NULL, NULL, 21),
(284942, NULL, 'SSF118116', NULL, NULL, NULL, NULL, 'DNA mismatch repair protein MutL', NULL, NULL, 32342, 21),
(284943, NULL, 'SSF55136', NULL, NULL, NULL, NULL, 'Probable bacterial effector-binding domain', NULL, NULL, 8993, 21),
(284944, NULL, 'SSF69737', NULL, NULL, NULL, NULL, 'Urease metallochaperone UreE, C-terminal domain', NULL, NULL, NULL, 21),
(284945, NULL, 'SSF81573', NULL, NULL, NULL, NULL, 'F1F0 ATP synthase subunit B, membrane domain', NULL, NULL, 26586, 21),
(284946, NULL, 'SSF110993', NULL, NULL, NULL, NULL, 'eIF-2-alpha, C-terminal domain', NULL, NULL, 12343, 21),
(284947, NULL, 'SSF46950', NULL, NULL, NULL, NULL, 'Double-stranded DNA-binding domain', NULL, NULL, 28862, 21),
(284948, NULL, 'SSF46589', NULL, NULL, NULL, NULL, 'tRNA-binding arm', NULL, NULL, 8056, 21),
(284949, NULL, 'SSF140670', NULL, NULL, NULL, NULL, 'YoaC-like', NULL, NULL, 32455, 21),
(284950, NULL, 'SSF89957', NULL, NULL, NULL, NULL, 'MTH1187/YkoF-like', NULL, NULL, 26209, 21),
(284951, NULL, 'SSF49265', NULL, NULL, NULL, NULL, 'Fibronectin type III', NULL, NULL, 32703, 21),
(284952, NULL, 'SSF103165', NULL, NULL, NULL, NULL, 'Ta1353-like', NULL, NULL, 31695, 21),
(284953, NULL, 'SSF56770', NULL, NULL, NULL, NULL, 'HydA/Nqo6-like', NULL, NULL, NULL, 21),
(284954, NULL, 'SSF46924', NULL, NULL, NULL, NULL, 'RNA polymerase subunit RPB10', NULL, NULL, 20759, 21),
(284955, NULL, 'SSF101262', NULL, NULL, NULL, NULL, 'Methenyltetrahydrofolate cyclohydrolase-like', NULL, NULL, 32909, 21),
(284956, NULL, 'SSF160935', NULL, NULL, NULL, NULL, 'VPA0735-like', NULL, NULL, NULL, 21),
(284957, NULL, 'SSF48619', NULL, NULL, NULL, NULL, 'Phospholipase A2, PLA2', NULL, NULL, 31577, 21),
(284958, NULL, 'SSF52047', NULL, NULL, NULL, NULL, 'RNI-like', NULL, NULL, NULL, 21),
(284959, NULL, 'SSF53328', NULL, NULL, NULL, NULL, 'Formyltransferase', NULL, NULL, 29867, 21),
(284960, NULL, 'SSF57615', NULL, NULL, NULL, NULL, 'Type X cellulose binding domain, CBDX', NULL, NULL, 33513, 21),
(284961, NULL, 'SSF69796', NULL, NULL, NULL, NULL, 'Thymidylate synthase-complementing protein Thy1', NULL, NULL, 27287, 21),
(284962, NULL, 'SSF81853', NULL, NULL, NULL, NULL, 'Family 10 polysaccharide lyase', NULL, NULL, NULL, 21),
(284963, NULL, 'SSF103661', NULL, NULL, NULL, NULL, 'Proline/betaine transporter ProP, C-terminal cytoplasmic domain', NULL, NULL, 31731, 21);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(284964, NULL, 'SSF55648', NULL, NULL, NULL, NULL, 'beta-lactamase-inhibitor protein, BLIP', NULL, NULL, 20550, 21),
(284965, NULL, 'SSF46911', NULL, NULL, NULL, NULL, 'Ribosomal protein S18', NULL, NULL, 28232, 21),
(284966, NULL, 'SSF111379', NULL, NULL, NULL, NULL, 'VP4 membrane interaction domain', NULL, NULL, 31914, 21),
(284967, NULL, 'SSF51989', NULL, NULL, NULL, NULL, 'Glycosyl hydrolases family 6, cellulases', NULL, NULL, 31509, 21),
(284968, NULL, 'SSF50044', NULL, NULL, NULL, NULL, 'SH3-domain', NULL, NULL, 27135, 21),
(284969, NULL, 'SSF57798', NULL, NULL, NULL, NULL, 'Casein kinase II beta subunit', NULL, NULL, 19644, 21),
(284970, NULL, 'SSF140478', NULL, NULL, NULL, NULL, 'LemA-like', NULL, NULL, 19126, 21),
(284971, NULL, 'SSF54358', NULL, NULL, NULL, NULL, 'Immunoglobulin-binding domains', NULL, NULL, NULL, 21),
(284972, NULL, 'SSF56194', NULL, NULL, NULL, NULL, 'Uridine diphospho-N-Acetylenolpyruvylglucosamine reductase, MurB, C-terminal domain', NULL, NULL, 27475, 21),
(284973, NULL, 'SSF51156', NULL, NULL, NULL, NULL, 'Insect cysteine-rich antifreeze protein', NULL, NULL, 11446, 21),
(284974, NULL, 'SSF54843', NULL, NULL, NULL, NULL, 'Ribosomal protein L22', NULL, NULL, 28781, 21),
(284975, NULL, 'SSF69635', NULL, NULL, NULL, NULL, 'Type III secretory system chaperone-like', NULL, NULL, NULL, 21),
(284976, NULL, 'SSF82708', NULL, NULL, NULL, NULL, 'R3H domain', NULL, NULL, 28192, 21),
(284977, NULL, 'SSF109755', NULL, NULL, NULL, NULL, 'PhoU-like', NULL, NULL, NULL, 21),
(284978, NULL, 'SSF48674', NULL, NULL, NULL, NULL, 'Fe-only hydrogenase smaller subunit', NULL, NULL, 8572, 21),
(284979, NULL, 'SSF103464', NULL, NULL, NULL, NULL, 'Oligosaccharyltransferase subunit ost4p', NULL, NULL, 28447, 21),
(284980, NULL, 'SSF101478', NULL, NULL, NULL, NULL, 'ADP-ribosylglycohydrolase', NULL, NULL, 31955, 21),
(284981, NULL, 'SSF160363', NULL, NULL, NULL, NULL, 'MTH889-like', NULL, NULL, 8742, 21),
(284982, NULL, 'SSF88798', NULL, NULL, NULL, NULL, 'N-terminal, heterodimerisation domain of RBP7 (RpoE)', NULL, NULL, 28760, 21),
(284983, NULL, 'SSF51730', NULL, NULL, NULL, NULL, 'FAD-linked oxidoreductase', NULL, NULL, 26593, 21),
(284984, NULL, 'SSF58014', NULL, NULL, NULL, NULL, 'Coiled-coil domain of nucleotide exchange factor GrpE', NULL, NULL, 7631, 21),
(284985, NULL, 'SSF57424', NULL, NULL, NULL, NULL, 'LDL receptor-like module', NULL, NULL, 32750, 21),
(284986, NULL, 'SSF53590', NULL, NULL, NULL, NULL, 'Nucleoside hydrolase', NULL, NULL, 28305, 21),
(284987, NULL, 'SSF161065', NULL, NULL, NULL, NULL, 'ATP synthase D chain-like', NULL, NULL, 28062, 21),
(284988, NULL, 'SSF143592', NULL, NULL, NULL, NULL, 'TTHA1528-like', NULL, NULL, 27838, 21),
(284989, NULL, 'SSF116726', NULL, NULL, NULL, NULL, 'TrkA C-terminal domain-like', NULL, NULL, 31823, 21),
(284990, NULL, 'SSF48445', NULL, NULL, NULL, NULL, '14-3-3 protein', NULL, NULL, 27866, 21),
(284991, NULL, 'SSF69989', NULL, NULL, NULL, NULL, 'C-terminal domain of PLC-beta', NULL, NULL, NULL, 21),
(284992, NULL, 'SSF81531', NULL, NULL, NULL, NULL, 'Non-heme 11 kDa protein of cytochrome bc1 complex (Ubiquinol-cytochrome c reductase)', NULL, NULL, 33397, 21),
(284993, NULL, 'SSF53182', NULL, NULL, NULL, NULL, 'Pyrrolidone carboxyl peptidase (pyroglutamate aminopeptidase)', NULL, NULL, 31639, 21),
(284994, NULL, 'SSF81514', NULL, NULL, NULL, NULL, 'Subunit X (non-heme 7 kDa protein) of cytochrome bc1 complex (Ubiquinol-cytochrome c reductase)', NULL, NULL, 29715, 21),
(284995, NULL, 'SSF82282', NULL, NULL, NULL, NULL, 'Homocysteine S-methyltransferase', NULL, NULL, 32917, 21),
(284996, NULL, 'SSF56931', NULL, NULL, NULL, NULL, 'Outer membrane phospholipase A (OMPLA)', NULL, NULL, 33097, 21),
(284997, NULL, 'SSF51735', NULL, NULL, NULL, NULL, 'NAD(P)-binding Rossmann-fold domains', NULL, NULL, 31471, 21),
(284998, NULL, 'SSF140111', NULL, NULL, NULL, NULL, 'Endosomal sorting complex assembly domain', NULL, NULL, 33253, 21),
(284999, NULL, 'SSF75620', NULL, NULL, NULL, NULL, 'Release factor', NULL, NULL, 36238, 21),
(285000, NULL, 'SSF50969', NULL, NULL, NULL, NULL, 'YVTN repeat-like/Quinoprotein amine dehydrogenase', NULL, NULL, 9451, 21);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(285001, NULL, 'SSF56601', NULL, NULL, NULL, NULL, 'beta-lactamase/transpeptidase-like', NULL, NULL, 7550, 21),
(285002, NULL, 'SSF117773', NULL, NULL, NULL, NULL, 'GTF2I-like repeat', NULL, NULL, 30660, 21),
(285003, NULL, 'SSF53743', NULL, NULL, NULL, NULL, 'FucI/AraA N-terminal and middle domains', NULL, NULL, 9598, 21),
(285004, NULL, 'SSF52161', NULL, NULL, NULL, NULL, 'Ribosomal protein L13', NULL, NULL, 28910, 21),
(285005, NULL, 'SSF88650', NULL, NULL, NULL, NULL, 'Satellite viruses', NULL, NULL, 29965, 21),
(285006, NULL, 'SSF160477', NULL, NULL, NULL, NULL, 'PA1123-like', NULL, NULL, 33366, 21),
(285007, NULL, 'SSF47380', NULL, NULL, NULL, NULL, 'ROP protein', NULL, NULL, 17561, 21),
(285008, NULL, 'SSF144091', NULL, NULL, NULL, NULL, 'Rhomboid-like', NULL, NULL, 25566, 21),
(285009, NULL, 'SSF117018', NULL, NULL, NULL, NULL, 'ATP-dependent DNA ligase DNA-binding domain', NULL, NULL, 32487, 21),
(285010, NULL, 'SSF55239', NULL, NULL, NULL, NULL, 'RuBisCO, small subunit', NULL, NULL, 32365, 21),
(285011, NULL, 'SSF52113', NULL, NULL, NULL, NULL, 'BRCT domain', NULL, NULL, 27639, 21),
(285012, NULL, 'SSF101332', NULL, NULL, NULL, NULL, 'Hypothetical protein MTH393', NULL, NULL, 32014, 21),
(285013, NULL, 'SSF101156', NULL, NULL, NULL, NULL, 'Nonstructural protein ns2, Nep, M1-binding domain', NULL, NULL, NULL, 21),
(285014, NULL, 'SSF58042', NULL, NULL, NULL, NULL, 'Outer membrane lipoprotein', NULL, NULL, NULL, 21),
(285015, NULL, 'SSF55347', NULL, NULL, NULL, NULL, 'Glyceraldehyde-3-phosphate dehydrogenase-like, C-terminal domain', NULL, NULL, NULL, 21),
(285016, NULL, 'SSF56645', NULL, NULL, NULL, NULL, 'Acyl-CoA dehydrogenase NM domain-like', NULL, NULL, 7626, 21),
(285017, NULL, 'SSF55604', NULL, NULL, NULL, NULL, 'Glucose permease domain IIB', NULL, NULL, 28039, 21),
(285018, NULL, 'SSF160374', NULL, NULL, NULL, NULL, 'RplX-like', NULL, NULL, NULL, 21),
(285019, NULL, 'SSF81585', NULL, NULL, NULL, NULL, 'PsbU/PolX domain-like', NULL, NULL, NULL, 21),
(285020, NULL, 'SSF69179', NULL, NULL, NULL, NULL, 'Integrin domains', NULL, NULL, 26843, 21),
(285021, NULL, 'SSF143870', NULL, NULL, NULL, NULL, 'PF0523-like', NULL, NULL, 31192, 21),
(285022, NULL, 'SSF47188', NULL, NULL, NULL, NULL, 'Hemerythrin-like', NULL, NULL, 14089, 21),
(285023, NULL, 'SSF63763', NULL, NULL, NULL, NULL, 'SAND domain-like', NULL, NULL, 10218, 21),
(285024, NULL, 'SSF55909', NULL, NULL, NULL, NULL, 'Pentein', NULL, NULL, NULL, 21),
(285025, NULL, 'SSF109635', NULL, NULL, NULL, NULL, 'DnaK suppressor protein DksA, alpha-hairpin domain', NULL, NULL, 31750, 21),
(285026, NULL, 'SSF53933', NULL, NULL, NULL, NULL, 'Microbial ribonucleases', NULL, NULL, 11512, 21),
(285027, NULL, 'SSF52009', NULL, NULL, NULL, NULL, 'Phosphohistidine domain', NULL, NULL, 28120, 21),
(285028, NULL, 'SSF89447', NULL, NULL, NULL, NULL, 'AbrB/MazE/MraZ-like', NULL, NULL, 29966, 21),
(285029, NULL, 'SSF82185', NULL, NULL, NULL, NULL, 'Histone H3 K4-specific methyltransferase SET7/9 N-terminal domain', NULL, NULL, NULL, 21),
(285030, NULL, 'SSF56634', NULL, NULL, NULL, NULL, 'Heme-dependent catalase-like', NULL, NULL, 20063, 21),
(285031, NULL, 'SSF55874', NULL, NULL, NULL, NULL, 'ATPase domain of HSP90 chaperone/DNA topoisomerase II/histidine kinase', NULL, NULL, 28922, 21),
(285032, NULL, 'SSF141091', NULL, NULL, NULL, NULL, 'L21p-like', NULL, NULL, 30831, 21),
(285033, NULL, 'SSF82653', NULL, NULL, NULL, NULL, 'Probable GTPase Der, C-terminal domain', NULL, NULL, NULL, 21),
(285034, NULL, 'SSF64268', NULL, NULL, NULL, NULL, 'PX domain', NULL, NULL, 28306, 21),
(285035, NULL, 'SSF52425', NULL, NULL, NULL, NULL, 'Cryptochrome/photolyase, N-terminal domain', NULL, NULL, 28804, 21),
(285036, NULL, 'SSF52309', NULL, NULL, NULL, NULL, 'N-(deoxy)ribosyltransferase-like', NULL, NULL, NULL, 21),
(285037, NULL, 'SSF88723', NULL, NULL, NULL, NULL, 'PIN domain-like', NULL, NULL, 24726, 21),
(285038, NULL, 'SSF55729', NULL, NULL, NULL, NULL, 'Acyl-CoA N-acyltransferases (Nat)', NULL, NULL, 11852, 21),
(285039, NULL, 'SSF81502', NULL, NULL, NULL, NULL, 'ISP transmembrane anchor', NULL, NULL, NULL, 21);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(285040, NULL, 'SSF56399', NULL, NULL, NULL, NULL, 'ADP-ribosylation', NULL, NULL, NULL, 21),
(285041, NULL, 'SSF141562', NULL, NULL, NULL, NULL, 'At5g01610-like', NULL, NULL, 27925, 21),
(285042, NULL, 'SSF54416', NULL, NULL, NULL, NULL, 'Amine oxidase N-terminal region', NULL, NULL, 11559, 21),
(285043, NULL, 'SSF89915', NULL, NULL, NULL, NULL, 'DNA-binding protein Tfx', NULL, NULL, 28734, 21),
(285044, NULL, 'SSF140860', NULL, NULL, NULL, NULL, 'Pseudo ankyrin repeat-like', NULL, NULL, NULL, 21),
(285045, NULL, 'SSF57953', NULL, NULL, NULL, NULL, 'Trimerization domain of TRAF', NULL, NULL, NULL, 21),
(285046, NULL, 'SSF101116', NULL, NULL, NULL, NULL, 'Flagellar export chaperone FliS', NULL, NULL, 32612, 21),
(285047, NULL, 'SSF82693', NULL, NULL, NULL, NULL, 'Multidrug efflux transporter AcrB pore domain; PN1, PN2, PC1 and PC2 subdomains', NULL, NULL, NULL, 21),
(285048, NULL, 'SSF81606', NULL, NULL, NULL, NULL, 'PP2C-like', NULL, NULL, 28092, 21),
(285049, NULL, 'SSF48050', NULL, NULL, NULL, NULL, 'Hemocyanin, N-terminal domain', NULL, NULL, 31803, 21),
(285050, NULL, 'SSF48537', NULL, NULL, NULL, NULL, 'Phospholipase C/P1 nuclease', NULL, NULL, 8509, 21),
(285051, NULL, 'SSF48647', NULL, NULL, NULL, NULL, 'Fungal elicitin', NULL, NULL, 29549, 21),
(285052, NULL, 'SSF46575', NULL, NULL, NULL, NULL, 'DNA polymerase III theta subunit-like', NULL, NULL, 27624, 21),
(285053, NULL, 'SSF47576', NULL, NULL, NULL, NULL, 'Calponin-homology domain, CH-domain', NULL, NULL, 28152, 21),
(285054, NULL, 'SSF48608', NULL, NULL, NULL, NULL, 'Peridinin-chlorophyll protein', NULL, NULL, 33287, 21),
(285055, NULL, 'SSF82856', NULL, NULL, NULL, NULL, 'L-A virus major coat protein', NULL, NULL, 27927, 21),
(285056, NULL, 'SSF143975', NULL, NULL, NULL, NULL, 'IlvD/EDD N-terminal domain-like', NULL, NULL, 32751, 21),
(285057, NULL, 'SSF100939', NULL, NULL, NULL, NULL, 'SPOC domain-like', NULL, NULL, 11694, 21),
(285058, NULL, 'SSF158715', NULL, NULL, NULL, NULL, 'MG296-like', NULL, NULL, 28489, 21),
(285059, NULL, 'SSF100934', NULL, NULL, NULL, NULL, 'Heat shock protein 70kD (HSP70), C-terminal subdomain', NULL, NULL, 25934, 21),
(285060, NULL, 'SSF90064', NULL, NULL, NULL, NULL, 'Hypothetical protein TM0875', NULL, NULL, 27777, 21),
(285061, NULL, 'SSF101936', NULL, NULL, NULL, NULL, 'DNA-binding pseudobarrel domain', NULL, NULL, 12943, 21),
(285062, NULL, 'SSF54117', NULL, NULL, NULL, NULL, 'Interleukin 8-like chemokines', NULL, NULL, 29982, 21),
(285063, NULL, 'SSF140591', NULL, NULL, NULL, NULL, 'Type III secretion system domain', NULL, NULL, NULL, 21),
(285064, NULL, 'SSF110783', NULL, NULL, NULL, NULL, 'Hypothetical protein MTH677', NULL, NULL, 26887, 21),
(285065, NULL, 'SSF48439', NULL, NULL, NULL, NULL, 'Protein prenylyltransferase', NULL, NULL, NULL, 21),
(285066, NULL, 'SSF48678', NULL, NULL, NULL, NULL, 'Moesin tail domain', NULL, NULL, 8901, 21),
(285067, NULL, 'SSF52507', NULL, NULL, NULL, NULL, 'Homo-oligomeric flavin-containing Cys decarboxylases, HFCD', NULL, NULL, 33108, 21),
(285068, NULL, 'SSF161111', NULL, NULL, NULL, NULL, 'Cation efflux protein transmembrane domain-like', NULL, NULL, 24858, 21),
(285069, NULL, 'SSF51445', NULL, NULL, NULL, NULL, '(Trans)glycosidases', NULL, NULL, 12987, 21),
(285070, NULL, 'SSF158702', NULL, NULL, NULL, NULL, 'Sec63 N-terminal domain-like', NULL, NULL, NULL, 21),
(285071, NULL, 'SSF52968', NULL, NULL, NULL, NULL, 'B12-dependent dehydatase associated subunit', NULL, NULL, 8963, 21),
(285072, NULL, 'SSF101697', NULL, NULL, NULL, NULL, 'Hypothetical protein YfhH', NULL, NULL, 31549, 21),
(285073, NULL, 'SSF48019', NULL, NULL, NULL, NULL, 'post-AAA+ oligomerization domain-like', NULL, NULL, 8653, 21),
(285074, NULL, 'SSF158366', NULL, NULL, NULL, NULL, 'Efb C-domain-like', NULL, NULL, 28547, 21),
(285075, NULL, 'SSF160766', NULL, NULL, NULL, NULL, 'NE1680-like', NULL, NULL, 16516, 21),
(285076, NULL, 'SSF49894', NULL, NULL, NULL, NULL, 'Baculovirus p35 protein', NULL, NULL, 33371, 21),
(285077, NULL, 'SSF143885', NULL, NULL, NULL, NULL, 'RGC domain-like', NULL, NULL, NULL, 21); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(285078, NULL, 'SSF56994', NULL, NULL, NULL, NULL, 'Insulin-like', NULL, NULL, 31842, 21),
(285079, NULL, 'SSF81982', NULL, NULL, NULL, NULL, 'Antigen MPT63/MPB63 (immunoprotective extracellular protein)', NULL, NULL, NULL, 21),
(285080, NULL, 'SSF143477', NULL, NULL, NULL, NULL, 'TM1622-like', NULL, NULL, 25393, 21),
(285081, NULL, 'SSF51197', NULL, NULL, NULL, NULL, 'Clavaminate synthase-like', NULL, NULL, NULL, 21),
(285082, NULL, 'SSF88946', NULL, NULL, NULL, NULL, 'Sigma2 domain of RNA polymerase sigma factors', NULL, NULL, 11115, 21),
(285083, NULL, 'SSF50916', NULL, NULL, NULL, NULL, 'Rap30/74 interaction domains', NULL, NULL, 9489, 21),
(285084, NULL, 'SSF160467', NULL, NULL, NULL, NULL, 'PH0987 N-terminal domain-like', NULL, NULL, NULL, 21),
(285085, NULL, 'SSF118173', NULL, NULL, NULL, NULL, 'Phosphoprotein M1, C-terminal domain', NULL, NULL, 33058, 21),
(285086, NULL, 'SSF103491', NULL, NULL, NULL, NULL, 'Preprotein translocase SecY subunit', NULL, NULL, 17309, 21),
(285087, NULL, 'SSF53784', NULL, NULL, NULL, NULL, 'Phosphofructokinase', NULL, NULL, 29818, 21),
(285088, NULL, 'SSF89000', NULL, NULL, NULL, NULL, 'post-HMGL domain-like', NULL, NULL, NULL, 21),
(285089, NULL, 'SSF110035', NULL, NULL, NULL, NULL, 'GDNF receptor-like', NULL, NULL, 33092, 21),
(285090, NULL, 'SSF144005', NULL, NULL, NULL, NULL, 'ORC1-binding domain', NULL, NULL, 27266, 21),
(285091, NULL, 'SSF50353', NULL, NULL, NULL, NULL, 'Cytokine', NULL, NULL, 9909, 21),
(285092, NULL, 'SSF55048', NULL, NULL, NULL, NULL, 'Probable ACP-binding domain of malonyl-CoA ACP transacylase', NULL, NULL, 12912, 21),
(285093, NULL, 'SSF57581', NULL, NULL, NULL, NULL, 'TB module/8-cys domain', NULL, NULL, 31628, 21),
(285094, NULL, 'SSF53032', NULL, NULL, NULL, NULL, 'tRNA-intron endonuclease catalytic domain-like', NULL, NULL, 30018, 21),
(285095, NULL, 'SSF56712', NULL, NULL, NULL, NULL, 'Prokaryotic type I DNA topoisomerase', NULL, NULL, 16013, 21),
(285096, NULL, 'SSF47857', NULL, NULL, NULL, NULL, 'Apolipophorin-III', NULL, NULL, NULL, 21),
(285097, NULL, 'SSF160379', NULL, NULL, NULL, NULL, 'SP0830-like', NULL, NULL, NULL, 21),
(285098, NULL, 'SSF54686', NULL, NULL, NULL, NULL, 'Ribosomal protein L16p/L10e', NULL, NULL, 32501, 21),
(285099, NULL, 'SSF52794', NULL, NULL, NULL, NULL, 'PTS system IIB component-like', NULL, NULL, 27210, 21),
(285100, NULL, 'SSF141488', NULL, NULL, NULL, NULL, 'YdhA-like', NULL, NULL, 28235, 21),
(285101, NULL, 'SSF51604', NULL, NULL, NULL, NULL, 'Enolase C-terminal domain-like', NULL, NULL, 31643, 21),
(285102, NULL, 'SSF47045', NULL, NULL, NULL, NULL, 'RAP domain-like', NULL, NULL, 27630, 21),
(285103, NULL, 'SSF160240', NULL, NULL, NULL, NULL, 'Cation efflux protein cytoplasmic domain-like', NULL, NULL, 27699, 21),
(285104, NULL, 'SSF160443', NULL, NULL, NULL, NULL, 'SMR domain-like', NULL, NULL, 29528, 21),
(285105, NULL, 'SSF101887', NULL, NULL, NULL, NULL, 'Apyrase', NULL, NULL, 29659, 21),
(285106, NULL, 'SSF144270', NULL, NULL, NULL, NULL, 'Eferin C-derminal domain-like', NULL, NULL, 31945, 21),
(285107, NULL, 'SSF100910', NULL, NULL, NULL, NULL, 'Chemosensory protein Csp2', NULL, NULL, 28945, 21),
(285108, NULL, 'SSF48140', NULL, NULL, NULL, NULL, 'Ribosomal protein L19 (L19e)', NULL, NULL, 26832, 21),
(285109, NULL, 'SSF53850', NULL, NULL, NULL, NULL, 'Periplasmic binding protein-like II', NULL, NULL, NULL, 21),
(285110, NULL, 'SSF143026', NULL, NULL, NULL, NULL, 'Kinetochore globular domain', NULL, NULL, 31453, 21),
(285111, NULL, 'SSF49695', NULL, NULL, NULL, NULL, 'gamma-Crystallin-like', NULL, NULL, 8361, 21),
(285112, NULL, 'SSF49384', NULL, NULL, NULL, NULL, 'Carbohydrate-binding domain', NULL, NULL, 8796, 21),
(285113, NULL, 'SSF53795', NULL, NULL, NULL, NULL, 'PEP carboxykinase-like', NULL, NULL, NULL, 21),
(285114, NULL, 'SSF49319', NULL, NULL, NULL, NULL, 'Actinoxanthin-like', NULL, NULL, 23705, 21),
(285115, NULL, 'SSF159709', NULL, NULL, NULL, NULL, 'PhnH-like', NULL, NULL, 32393, 21),
(285116, NULL, 'SSF158235', NULL, NULL, NULL, NULL, 'SOCS box-like', NULL, NULL, 27257, 21);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(285117, NULL, 'SSF116922', NULL, NULL, NULL, NULL, 'YugE-like', NULL, NULL, 15743, 21),
(285118, NULL, 'SSF103088', NULL, NULL, NULL, NULL, 'OmpA-like', NULL, NULL, 31662, 21),
(285119, NULL, 'SSF53756', NULL, NULL, NULL, NULL, 'UDP-Glycosyltransferase/glycogen phosphorylase', NULL, NULL, NULL, 21),
(285120, NULL, 'SSF47592', NULL, NULL, NULL, NULL, 'SWIB/MDM2 domain', NULL, NULL, 28635, 21),
(285121, NULL, 'SSF82919', NULL, NULL, NULL, NULL, 'Zn-finger domain of Sec23/24', NULL, NULL, 32797, 21),
(285122, NULL, 'SSF55315', NULL, NULL, NULL, NULL, 'L30e-like', NULL, NULL, 24892, 21),
(285123, NULL, 'SSF141457', NULL, NULL, NULL, NULL, 'BH3618-like', NULL, NULL, 11920, 21),
(285124, NULL, 'SSF56519', NULL, NULL, NULL, NULL, 'Penicillin binding protein dimerisation domain', NULL, NULL, 33403, 21),
(285125, NULL, 'SSF141447', NULL, NULL, NULL, NULL, 'PA2021-like', NULL, NULL, 31579, 21),
(285126, NULL, 'SSF52075', NULL, NULL, NULL, NULL, 'Outer arm dynein light chain 1', NULL, NULL, NULL, 21),
(285127, NULL, 'SSF48024', NULL, NULL, NULL, NULL, 'N-terminal domain of DnaB helicase', NULL, NULL, 33046, 21),
(285128, NULL, 'SSF64263', NULL, NULL, NULL, NULL, 'Prokaryotic ribosomal protein L17', NULL, NULL, 28238, 21),
(285129, NULL, 'SSF47459', NULL, NULL, NULL, NULL, 'HLH, helix-loop-helix DNA-binding domain', NULL, NULL, 27274, 21),
(285130, NULL, 'SSF140990', NULL, NULL, NULL, NULL, 'FtsH protease domain-like', NULL, NULL, 33266, 21),
(285131, NULL, 'SSF101257', NULL, NULL, NULL, NULL, 'Flavivirus capsid protein C', NULL, NULL, 31862, 21),
(285132, NULL, 'SSF75625', NULL, NULL, NULL, NULL, 'YebC-like', NULL, NULL, 24619, 21),
(285133, NULL, 'SSF47170', NULL, NULL, NULL, NULL, 'Aspartate receptor, ligand-binding domain', NULL, NULL, 31678, 21),
(285134, NULL, 'SSF101690', NULL, NULL, NULL, NULL, 'PAZ domain', NULL, NULL, 32210, 21),
(285135, NULL, 'SSF47598', NULL, NULL, NULL, NULL, 'Ribbon-helix-helix', NULL, NULL, 8002, 21),
(285136, NULL, 'SSF81419', NULL, NULL, NULL, NULL, 'Mitochondrial cytochrome c oxidase subunit VIIa', NULL, NULL, 33414, 21),
(285137, NULL, 'SSF140376', NULL, NULL, NULL, NULL, 'ChaB-like', NULL, NULL, 33407, 21),
(285138, NULL, 'SSF82689', NULL, NULL, NULL, NULL, 'Mechanosensitive channel protein MscS (YggB), C-terminal domain', NULL, NULL, 10029, 21),
(285139, NULL, 'SSF49313', NULL, NULL, NULL, NULL, 'Cadherin-like', NULL, NULL, 8224, 21),
(285140, NULL, 'SSF47752', NULL, NULL, NULL, NULL, 'Protein HNS-dependent expression A; HdeA', NULL, NULL, 27677, 21),
(285141, NULL, 'SSF110710', NULL, NULL, NULL, NULL, 'TTHA0583/YokD-like', NULL, NULL, 26942, 21),
(285142, NULL, 'SSF56219', NULL, NULL, NULL, NULL, 'DNase I-like', NULL, NULL, 31435, 21),
(285143, NULL, 'SSF118375', NULL, NULL, NULL, NULL, 'Synuclein', NULL, NULL, NULL, 21),
(285144, NULL, 'SSF63887', NULL, NULL, NULL, NULL, 'P-domain of calnexin/calreticulin', NULL, NULL, 9670, 21),
(285145, NULL, 'SSF50122', NULL, NULL, NULL, NULL, 'DNA-binding domain of retroviral integrase', NULL, NULL, 28098, 21),
(285146, NULL, 'SSF49854', NULL, NULL, NULL, NULL, 'Spermadhesin, CUB domain', NULL, NULL, 19210, 21),
(285147, NULL, 'SSF110083', NULL, NULL, NULL, NULL, 'Peptidylarginine deiminase Pad4, middle domain', NULL, NULL, 33342, 21),
(285148, NULL, 'SSF57625', NULL, NULL, NULL, NULL, 'Invertebrate chitin-binding proteins', NULL, NULL, 30493, 21),
(285149, NULL, 'SSF55797', NULL, NULL, NULL, NULL, 'PR-1-like', NULL, NULL, 7577, 21),
(285150, NULL, 'SSF49899', NULL, NULL, NULL, NULL, 'Concanavalin A-like lectins/glucanases', NULL, NULL, 11471, 21),
(285151, NULL, 'SSF55205', NULL, NULL, NULL, NULL, 'EPT/RTPC-like', NULL, NULL, 8214, 21),
(285152, NULL, 'SSF48013', NULL, NULL, NULL, NULL, 'NusB-like', NULL, NULL, 26251, 21),
(285153, NULL, 'SSF81383', NULL, NULL, NULL, NULL, 'F-box domain', NULL, NULL, 26671, 21),
(285154, NULL, 'SSF53323', NULL, NULL, NULL, NULL, 'Pyruvate-ferredoxin oxidoreductase, PFOR, domain III', NULL, NULL, 5755, 21),
(285155, NULL, 'SSF82046', NULL, NULL, NULL, NULL, 'Viral chemokine binding protein m3', NULL, NULL, 27646, 21);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(285156, NULL, 'SSF48168', NULL, NULL, NULL, NULL, 'R1 subunit of ribonucleotide reductase, N-terminal domain', NULL, NULL, 8788, 21),
(285157, NULL, 'SSF143100', NULL, NULL, NULL, NULL, 'TTHA1013/TTHA0281-like', NULL, NULL, 33766, 21),
(285158, NULL, 'SSF101821', NULL, NULL, NULL, NULL, 'Aminopeptidase/glucanase lid domain', NULL, NULL, NULL, 21),
(285159, NULL, 'SSF47672', NULL, NULL, NULL, NULL, 'Transferrin receptor-like dimerisation domain', NULL, NULL, 32034, 21),
(285160, NULL, 'SSF101941', NULL, NULL, NULL, NULL, 'NAC domain', NULL, NULL, 27238, 21),
(285161, NULL, 'SSF56235', NULL, NULL, NULL, NULL, 'N-terminal nucleophile aminohydrolases (Ntn hydrolases)', NULL, NULL, 24446, 21),
(285162, NULL, 'SSF47794', NULL, NULL, NULL, NULL, 'Rad51 N-terminal domain-like', NULL, NULL, 8505, 21),
(285163, NULL, 'SSF143865', NULL, NULL, NULL, NULL, 'CorA soluble domain-like', NULL, NULL, 33950, 21),
(285164, NULL, 'SSF57802', NULL, NULL, NULL, NULL, 'Rubredoxin-like', NULL, NULL, NULL, 21),
(285165, NULL, 'SSF102829', NULL, NULL, NULL, NULL, 'Cell division protein ZapA-like', NULL, NULL, 33400, 21),
(285166, NULL, 'SSF102645', NULL, NULL, NULL, NULL, 'CoaB-like', NULL, NULL, 21783, 21),
(285167, NULL, 'SSF56784', NULL, NULL, NULL, NULL, 'HAD-like', NULL, NULL, 33138, 21),
(285168, NULL, 'SSF54897', NULL, NULL, NULL, NULL, 'Protease propeptides/inhibitors', NULL, NULL, NULL, 21),
(285169, NULL, 'SSF55447', NULL, NULL, NULL, NULL, 'CO dehydrogenase flavoprotein C-terminal domain-like', NULL, NULL, 28570, 21),
(285170, NULL, 'SSF90112', NULL, NULL, NULL, NULL, 'Neurotransmitter-gated ion-channel transmembrane pore', NULL, NULL, 31997, 21),
(285171, NULL, 'SSF101744', NULL, NULL, NULL, NULL, 'Rof/RNase P subunit-like', NULL, NULL, 16992, 21),
(285172, NULL, 'SSF143602', NULL, NULL, NULL, NULL, 'STIV B116-like', NULL, NULL, 32803, 21),
(285173, NULL, 'SSF50891', NULL, NULL, NULL, NULL, 'Cyclophilin-like', NULL, NULL, 25776, 21),
(285174, NULL, 'SSF55154', NULL, NULL, NULL, NULL, 'CYTH-like phosphatases', NULL, NULL, 29028, 21),
(285175, NULL, 'SSF47203', NULL, NULL, NULL, NULL, 'Acyl-CoA dehydrogenase C-terminal domain-like', NULL, NULL, 29760, 21),
(285176, NULL, 'SSF69593', NULL, NULL, NULL, NULL, 'Glycerol-3-phosphate (1)-acyltransferase', NULL, NULL, NULL, 21),
(285177, NULL, 'SSF48034', NULL, NULL, NULL, NULL, 'Guanido kinase N-terminal domain', NULL, NULL, 33030, 21),
(285178, NULL, 'SSF161219', NULL, NULL, NULL, NULL, 'CHY zinc finger-like', NULL, NULL, 32782, 21),
(285179, NULL, 'SSF55681', NULL, NULL, NULL, NULL, 'Class II aaRS and biotin synthetases', NULL, NULL, 37340, 21),
(285180, NULL, 'SSF63418', NULL, NULL, NULL, NULL, 'MurE/MurF N-terminal domain', NULL, NULL, 11505, 21),
(285181, NULL, 'SSF144292', NULL, NULL, NULL, NULL, 'occludin/ELL-like', NULL, NULL, NULL, 21),
(285182, NULL, 'SSF102114', NULL, NULL, NULL, NULL, 'Radical SAM enzymes', NULL, NULL, NULL, 21),
(285183, NULL, 'SSF110916', NULL, NULL, NULL, NULL, 'Peptidyl-tRNA hydrolase domain-like', NULL, NULL, NULL, 21),
(285184, NULL, 'SSF48163', NULL, NULL, NULL, NULL, 'An anticodon-binding domain of class I aminoacyl-tRNA synthetases', NULL, NULL, 8881, 21),
(285185, NULL, 'SSF48173', NULL, NULL, NULL, NULL, 'Cryptochrome/photolyase FAD-binding domain', NULL, NULL, 33330, 21),
(285186, NULL, 'SSF81660', NULL, NULL, NULL, NULL, 'Metal cation-transporting ATPase, ATP-binding domain N', NULL, NULL, 14904, 21),
(285187, NULL, 'SSF141658', NULL, NULL, NULL, NULL, 'Bacteriophage trimeric proteins domain', NULL, NULL, NULL, 21),
(285188, NULL, 'SSF143081', NULL, NULL, NULL, NULL, 'BB1717-like', NULL, NULL, 32569, 21),
(285189, NULL, 'SSF52042', NULL, NULL, NULL, NULL, 'Ribosomal protein L32e', NULL, NULL, 27821, 21),
(285190, NULL, 'SSF55307', NULL, NULL, NULL, NULL, 'Tubulin C-terminal domain-like', NULL, NULL, 9753, 21),
(285191, NULL, 'SSF75471', NULL, NULL, NULL, NULL, 'YhbY-like', NULL, NULL, 24549, 21),
(285192, NULL, 'SSF160940', NULL, NULL, NULL, NULL, 'Api92-like', NULL, NULL, NULL, 21),
(285193, NULL, 'SSF55486', NULL, NULL, NULL, NULL, 'Metalloproteases ("zincins"), catalytic domain', NULL, NULL, NULL, 21);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(285194, NULL, 'SSF46988', NULL, NULL, NULL, NULL, 'Tubulin chaperone cofactor A', NULL, NULL, 33490, 21),
(285195, NULL, 'SSF48435', NULL, NULL, NULL, NULL, 'Bacterial muramidases', NULL, NULL, 8753, 21),
(285196, NULL, 'SSF110857', NULL, NULL, NULL, NULL, 'Gamma-glutamyl cyclotransferase-like', NULL, NULL, 31920, 21),
(285197, NULL, 'SSF81730', NULL, NULL, NULL, NULL, 'beta-catenin-interacting protein ICAT', NULL, NULL, 28836, 21),
(285198, NULL, 'SSF53659', NULL, NULL, NULL, NULL, 'Isocitrate/Isopropylmalate dehydrogenase-like', NULL, NULL, NULL, 21),
(285199, NULL, 'SSF100897', NULL, NULL, NULL, NULL, 'Plant proteinase inhibitors', NULL, NULL, NULL, 21),
(285200, NULL, 'SSF161266', NULL, NULL, NULL, NULL, 'Gam-like', NULL, NULL, NULL, 21),
(285201, NULL, 'SSF158639', NULL, NULL, NULL, NULL, 'ENT-like', NULL, NULL, 28565, 21),
(285202, NULL, 'SSF109998', NULL, NULL, NULL, NULL, 'Triger factor/SurA peptide-binding domain-like', NULL, NULL, 24430, 21),
(285203, NULL, 'SSF81736', NULL, NULL, NULL, NULL, 'Group V grass pollen allergen', NULL, NULL, 27509, 21),
(285204, NULL, 'SSF159121', NULL, NULL, NULL, NULL, 'BC4932-like', NULL, NULL, 30170, 21),
(285205, NULL, 'SSF49344', NULL, NULL, NULL, NULL, 'CBD9-like', NULL, NULL, NULL, 21),
(285206, NULL, 'SSF159006', NULL, NULL, NULL, NULL, 'YopX-like', NULL, NULL, NULL, 21),
(285207, NULL, 'SSF90148', NULL, NULL, NULL, NULL, 'DPY module', NULL, NULL, NULL, 21),
(285208, NULL, 'SSF141673', NULL, NULL, NULL, NULL, 'MOSC N-terminal domain-like', NULL, NULL, NULL, 21),
(285209, NULL, 'SSF47216', NULL, NULL, NULL, NULL, 'Proteasome activator', NULL, NULL, 29991, 21),
(285210, NULL, 'SSF88688', NULL, NULL, NULL, NULL, 'Families 57/38 glycoside transferase middle domain', NULL, NULL, 23366, 21),
(285211, NULL, 'SSF55221', NULL, NULL, NULL, NULL, 'Yeast killer toxins', NULL, NULL, 13916, 21),
(285212, NULL, 'SSF143579', NULL, NULL, NULL, NULL, 'GK1464-like', NULL, NULL, 21718, 21),
(285213, NULL, 'SSF57770', NULL, NULL, NULL, NULL, 'Methionyl-tRNA synthetase (MetRS), Zn-domain', NULL, NULL, 23678, 21),
(285214, NULL, 'SSF140753', NULL, NULL, NULL, NULL, 'PG0816-like', NULL, NULL, 31552, 21),
(285215, NULL, 'SSF56918', NULL, NULL, NULL, NULL, 'Light-harvesting complex subunits', NULL, NULL, 6800, 21),
(285216, NULL, 'SSF110455', NULL, NULL, NULL, NULL, 'Toprim domain', NULL, NULL, NULL, 21),
(285217, NULL, 'SSF55383', NULL, NULL, NULL, NULL, 'Copper amine oxidase, domain N', NULL, NULL, 29888, 21),
(285218, NULL, 'SSF74877', NULL, NULL, NULL, NULL, 'Major surface antigen p30, SAG1', NULL, NULL, 32080, 21),
(285219, NULL, 'SSF57783', NULL, NULL, NULL, NULL, 'Zinc beta-ribbon', NULL, NULL, NULL, 21),
(285220, NULL, 'SSF54648', NULL, NULL, NULL, NULL, 'DLC', NULL, NULL, 31668, 21),
(285221, NULL, 'SSF144276', NULL, NULL, NULL, NULL, 'Heterotrimerisation domain of extracellular hemoglobin linker subunits', NULL, NULL, 31589, 21),
(285222, NULL, 'SSF47798', NULL, NULL, NULL, NULL, 'Barrier-to-autointegration factor, BAF', NULL, NULL, 27588, 21),
(285223, NULL, 'SSF52440', NULL, NULL, NULL, NULL, 'PreATP-grasp domain', NULL, NULL, 11631, 21),
(285224, NULL, 'SSF49472', NULL, NULL, NULL, NULL, 'Transthyretin (synonym: prealbumin)', NULL, NULL, 27689, 21),
(285225, NULL, 'SSF143875', NULL, NULL, NULL, NULL, 'ERH-like', NULL, NULL, 18725, 21),
(285226, NULL, 'SSF53901', NULL, NULL, NULL, NULL, 'Thiolase-like', NULL, NULL, 12631, 21),
(285227, NULL, 'SSF57247', NULL, NULL, NULL, NULL, 'Bowman-Birk inhibitor, BBI', NULL, NULL, 16307, 21),
(285228, NULL, 'SSF46929', NULL, NULL, NULL, NULL, 'DNA helicase RuvA subunit, C-terminal domain', NULL, NULL, 31582, 21),
(285229, NULL, 'SSF57863', NULL, NULL, NULL, NULL, 'ArfGap/RecO-like zinc finger', NULL, NULL, 31788, 21),
(285230, NULL, 'SSF101353', NULL, NULL, NULL, NULL, 'Putative anticodon-binding domain of alanyl-tRNA synthetase (AlaRS)', NULL, NULL, 17938, 21),
(285231, NULL, 'SSF56854', NULL, NULL, NULL, NULL, 'Bcl-2 inhibitors of programmed cell death', NULL, NULL, 27815, 21),
(285232, NULL, 'SSF111278', NULL, NULL, NULL, NULL, 'SSo0622-like', NULL, NULL, 32533, 21);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(285233, NULL, 'SSF54995', NULL, NULL, NULL, NULL, 'Ribosomal protein S6', NULL, NULL, 31770, 21),
(285234, NULL, 'SSF118220', NULL, NULL, NULL, NULL, 'Connexin43', NULL, NULL, 4542, 21),
(285235, NULL, 'SSF63491', NULL, NULL, NULL, NULL, 'BAG domain', NULL, NULL, 33396, 21),
(285236, NULL, 'SSF51344', NULL, NULL, NULL, NULL, 'Epsilon subunit of F1F0-ATP synthase N-terminal domain', NULL, NULL, 33280, 21),
(285237, NULL, 'SSF142984', NULL, NULL, NULL, NULL, 'Nqo1 middle domain-like', NULL, NULL, NULL, 21),
(285238, NULL, 'SSF56747', NULL, NULL, NULL, NULL, 'Prim-pol domain', NULL, NULL, NULL, 21),
(285239, NULL, 'SSF68923', NULL, NULL, NULL, NULL, 'PEP carboxykinase N-terminal domain', NULL, NULL, 7029, 21),
(285240, NULL, 'SSF54529', NULL, NULL, NULL, NULL, 'Mitochondrial glycoprotein MAM33-like', NULL, NULL, 33429, 21),
(285241, NULL, 'SSF48690', NULL, NULL, NULL, NULL, 'Epsilon subunit of mitochondrial F1F0-ATP synthase', NULL, NULL, 31953, 21),
(285242, NULL, 'SSF55008', NULL, NULL, NULL, NULL, 'HMA, heavy metal-associated domain', NULL, NULL, 30008, 21),
(285243, NULL, 'SSF69572', NULL, NULL, NULL, NULL, 'Activating enzymes of the ubiquitin-like proteins', NULL, NULL, 31936, 21),
(285244, NULL, 'SSF69369', NULL, NULL, NULL, NULL, 'Cloacin translocation domain', NULL, NULL, 31324, 21),
(285245, NULL, 'SSF55608', NULL, NULL, NULL, NULL, 'Homing endonucleases', NULL, NULL, 24987, 21),
(285246, NULL, 'SSF47050', NULL, NULL, NULL, NULL, 'VHP, Villin headpiece domain', NULL, NULL, 28546, 21),
(285247, NULL, 'SSF103456', NULL, NULL, NULL, NULL, 'Preprotein translocase SecE subunit', NULL, NULL, 15991, 21),
(285248, NULL, 'SSF63592', NULL, NULL, NULL, NULL, 'Flagellar transcriptional activator FlhD', NULL, NULL, 29075, 21),
(285249, NULL, 'SSF52029', NULL, NULL, NULL, NULL, 'GroEL apical domain-like', NULL, NULL, 24719, 21),
(285250, NULL, 'SSF53649', NULL, NULL, NULL, NULL, 'Alkaline phosphatase-like', NULL, NULL, 20942, 21),
(285251, NULL, 'SSF143243', NULL, NULL, NULL, NULL, 'Nqo5-like', NULL, NULL, 27070, 21),
(285252, NULL, 'SSF144064', NULL, NULL, NULL, NULL, 'Heme iron utilization protein-like', NULL, NULL, NULL, 21),
(285253, NULL, 'SSF55545', NULL, NULL, NULL, NULL, 'beta-N-acetylhexosaminidase-like domain', NULL, NULL, 23403, 21),
(285254, NULL, 'SSF54999', NULL, NULL, NULL, NULL, 'Ribosomal protein S10', NULL, NULL, 27802, 21),
(285255, NULL, 'SSF89433', NULL, NULL, NULL, NULL, 'Baseplate structural protein gp8', NULL, NULL, 27921, 21),
(285256, NULL, 'SSF82317', NULL, NULL, NULL, NULL, 'Swiveling domain of dehydratase reactivase alpha subunit', NULL, NULL, 24350, 21),
(285257, NULL, 'SSF117782', NULL, NULL, NULL, NULL, 'YbjQ-like', NULL, NULL, 31835, 21),
(285258, NULL, 'SSF160387', NULL, NULL, NULL, NULL, 'NosL/MerB-like', NULL, NULL, NULL, 21),
(285259, NULL, 'SSF82936', NULL, NULL, NULL, NULL, 'Apolipoprotein A-II', NULL, NULL, 32911, 21),
(285260, NULL, 'SSF89392', NULL, NULL, NULL, NULL, 'Prokaryotic lipoproteins and lipoprotein localization factors', NULL, NULL, 25517, 21),
(285261, NULL, 'SSF158494', NULL, NULL, NULL, NULL, 'PG0775 C-terminal domain-like', NULL, NULL, 33416, 21),
(285262, NULL, 'SSF118251', NULL, NULL, NULL, NULL, 'Variant surface glycoprotein MITAT 1.2, VSG 221, C-terminal domain', NULL, NULL, 24800, 21),
(285263, NULL, 'SSF81301', NULL, NULL, NULL, NULL, 'Nucleotidyltransferase', NULL, NULL, 35189, 21),
(285264, NULL, 'SSF57879', NULL, NULL, NULL, NULL, 'Zinc domain conserved in yeast copper-regulated transcription factors', NULL, NULL, 28654, 21),
(285265, NULL, 'SSF47113', NULL, NULL, NULL, NULL, 'Histone-fold', NULL, NULL, 6064, 21),
(285266, NULL, 'SSF160148', NULL, NULL, NULL, NULL, 'CPE0013-like', NULL, NULL, 32403, 21),
(285267, NULL, 'SSF110304', NULL, NULL, NULL, NULL, 'Coronavirus RNA-binding domain', NULL, NULL, 33245, 21),
(285268, NULL, 'SSF56808', NULL, NULL, NULL, NULL, 'Ribosomal protein L1', NULL, NULL, 800, 21),
(285269, NULL, 'SSF51215', NULL, NULL, NULL, NULL, 'Regulatory protein AraC', NULL, NULL, 28829, 21),
(285270, NULL, 'SSF49482', NULL, NULL, NULL, NULL, 'Aromatic compound dioxygenase', NULL, NULL, 7098, 21);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(285271, NULL, 'SSF160800', NULL, NULL, NULL, NULL, 'Lp2179-like', NULL, NULL, 7814, 21),
(285272, NULL, 'SSF46938', NULL, NULL, NULL, NULL, 'CRAL/TRIO N-terminal domain', NULL, NULL, 31995, 21),
(285273, NULL, 'SSF55931', NULL, NULL, NULL, NULL, 'Glutamine synthetase/guanido kinase', NULL, NULL, 8423, 21),
(285274, NULL, 'SSF140427', NULL, NULL, NULL, NULL, 'VPS28 C-terminal domain-like', NULL, NULL, 33069, 21),
(285275, NULL, 'SSF56204', NULL, NULL, NULL, NULL, 'Hect, E3 ligase catalytic domain', NULL, NULL, 31854, 21),
(285276, NULL, 'SSF103647', NULL, NULL, NULL, NULL, 'TSP type-3 repeat', NULL, NULL, 26844, 21),
(285277, NULL, 'SSF110942', NULL, NULL, NULL, NULL, 'HSP90 C-terminal domain', NULL, NULL, 31888, 21),
(285278, NULL, 'SSF159664', NULL, NULL, NULL, NULL, 'CobE/GbiG C-terminal domain-like', NULL, NULL, 30147, 21),
(285279, NULL, 'SSF161021', NULL, NULL, NULL, NULL, 'Photosystem II reaction center protein J, PsbJ', NULL, NULL, 32509, 21),
(285280, NULL, 'SSF110221', NULL, NULL, NULL, NULL, 'AbfB domain', NULL, NULL, 33027, 21),
(285281, NULL, 'SSF160904', NULL, NULL, NULL, NULL, 'Jann2411-like', NULL, NULL, 15863, 21),
(285282, NULL, 'SSF89360', NULL, NULL, NULL, NULL, 'HesB-like domain', NULL, NULL, 7447, 21),
(285283, NULL, 'SSF49998', NULL, NULL, NULL, NULL, 'Amine oxidase catalytic domain', NULL, NULL, 31962, 21),
(285284, NULL, 'SSF55804', NULL, NULL, NULL, NULL, 'Phoshotransferase/anion transport protein', NULL, NULL, 11766, 21),
(285285, NULL, 'SSF56542', NULL, NULL, NULL, NULL, 'Substrate-binding domain of HMG-CoA reductase', NULL, NULL, 9824, 21),
(285286, NULL, 'SSF46984', NULL, NULL, NULL, NULL, 'Smac/diablo', NULL, NULL, 6447, 21),
(285287, NULL, 'SSF74748', NULL, NULL, NULL, NULL, 'Variable surface antigen VlsE', NULL, NULL, NULL, 21),
(285288, NULL, 'SSF52242', NULL, NULL, NULL, NULL, 'Cobalamin (vitamin B12)-binding domain', NULL, NULL, 31654, 21),
(285289, NULL, 'SSF48592', NULL, NULL, NULL, NULL, 'GroEL equatorial domain-like', NULL, NULL, 24734, 21),
(285290, NULL, 'SSF117778', NULL, NULL, NULL, NULL, 'D-lysine 5,6-aminomutase beta subunit KamE, N-terminal domain', NULL, NULL, 31614, 21),
(285291, NULL, 'SSF111474', NULL, NULL, NULL, NULL, 'Coronavirus S2 glycoprotein', NULL, NULL, 35344, 21),
(285292, NULL, 'SSF55394', NULL, NULL, NULL, NULL, 'Bactericidal permeability-increasing protein, BPI', NULL, NULL, 20567, 21),
(285293, NULL, 'SSF69336', NULL, NULL, NULL, NULL, 'Alpha subunit of glutamate synthase, C-terminal domain', NULL, NULL, 29998, 21),
(285294, NULL, 'SSF75005', NULL, NULL, NULL, NULL, 'Arabinanase/levansucrase/invertase', NULL, NULL, 15954, 21),
(285295, NULL, 'SSF144129', NULL, NULL, NULL, NULL, 'Vanabin-like', NULL, NULL, 31928, 21),
(285296, NULL, 'SSF56529', NULL, NULL, NULL, NULL, 'FAH', NULL, NULL, 31915, 21),
(285297, NULL, 'SSF54285', NULL, NULL, NULL, NULL, 'MoaD/ThiS', NULL, NULL, 11892, 21),
(285298, NULL, 'SSF75500', NULL, NULL, NULL, NULL, 'Putative transcriptional regulator TM1602, C-terminal domain', NULL, NULL, 26981, 21),
(285299, NULL, 'SSF50199', NULL, NULL, NULL, NULL, 'Staphylococcal nuclease', NULL, NULL, 31722, 21),
(285300, NULL, 'SSF51177', NULL, NULL, NULL, NULL, 'An insect antifreeze protein', NULL, NULL, 29942, 21),
(285301, NULL, 'SSF159468', NULL, NULL, NULL, NULL, 'AtpF-like', NULL, NULL, 33753, 21),
(285302, NULL, 'SSF52935', NULL, NULL, NULL, NULL, 'PK C-terminal domain-like', NULL, NULL, 32907, 21),
(285303, NULL, 'SSF140423', NULL, NULL, NULL, NULL, 'MW0975(SA0943)-like', NULL, NULL, 33134, 21),
(285304, NULL, 'SSF57593', NULL, NULL, NULL, NULL, 'Heparin-binding domain from vascular endothelial growth factor', NULL, NULL, 27602, 21),
(285305, NULL, 'SSF48305', NULL, NULL, NULL, NULL, 'Class II MHC-associated invariant chain ectoplasmic trimerization domain', NULL, NULL, 29892, 21),
(285306, NULL, 'SSF110399', NULL, NULL, NULL, NULL, 'ThiG-like', NULL, NULL, NULL, 21),
(285307, NULL, 'SSF81336', NULL, NULL, NULL, NULL, 'F1F0 ATP synthase subunit A', NULL, NULL, 11220, 21),
(285308, NULL, 'SSF64484', NULL, NULL, NULL, NULL, 'beta and beta-prime subunits of DNA dependent RNA-polymerase', NULL, NULL, NULL, 21);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(285309, NULL, 'SSF46894', NULL, NULL, NULL, NULL, 'C-terminal effector domain of the bipartite response regulators', NULL, NULL, 9159, 21),
(285310, NULL, 'SSF51101', NULL, NULL, NULL, NULL, 'Mannose-binding lectins', NULL, NULL, 31706, 21),
(285311, NULL, 'SSF57620', NULL, NULL, NULL, NULL, 'Carboxypeptidase inhibitor', NULL, NULL, 8097, 21),
(285312, NULL, 'SSF109880', NULL, NULL, NULL, NULL, 'A middle domain of Talin 1', NULL, NULL, 31333, 21),
(285313, NULL, 'SSF54768', NULL, NULL, NULL, NULL, 'dsRNA-binding domain-like', NULL, NULL, NULL, 21),
(285314, NULL, 'SSF54292', NULL, NULL, NULL, NULL, '2Fe-2S ferredoxin-like', NULL, NULL, 27977, 21),
(285315, NULL, 'SSF75516', NULL, NULL, NULL, NULL, 'Pheromone-binding domain of LuxR-like quorum-sensing transcription factors', NULL, NULL, 31748, 21),
(285316, NULL, 'SSF55785', NULL, NULL, NULL, NULL, 'PYP-like sensor domain (PAS domain)', NULL, NULL, 29971, 21),
(285317, NULL, 'SSF55620', NULL, NULL, NULL, NULL, 'Tetrahydrobiopterin biosynthesis enzymes-like', NULL, NULL, NULL, 21),
(285318, NULL, 'SSF51695', NULL, NULL, NULL, NULL, 'PLC-like phosphodiesterases', NULL, NULL, 19479, 21),
(285319, NULL, 'SSF51690', NULL, NULL, NULL, NULL, 'Nicotinate/Quinolinate PRTase C-terminal domain-like', NULL, NULL, 29858, 21),
(285320, NULL, 'SSF81665', NULL, NULL, NULL, NULL, 'Calcium ATPase, transmembrane domain M', NULL, NULL, 14645, 21),
(285321, NULL, 'SSF52540', NULL, NULL, NULL, NULL, 'P-loop containing nucleoside triphosphate hydrolases', NULL, NULL, 23652, 21),
(285322, NULL, 'SSF54616', NULL, NULL, NULL, NULL, 'DNA-binding domain of Mlu1-box binding protein MBP1', NULL, NULL, 28746, 21),
(285323, NULL, 'SSF81923', NULL, NULL, NULL, NULL, 'Double Clp-N motif', NULL, NULL, 30568, 21),
(285324, NULL, 'SSF49503', NULL, NULL, NULL, NULL, 'Cupredoxins', NULL, NULL, 9392, 21),
(285325, NULL, 'SSF58010', NULL, NULL, NULL, NULL, 'Fibrinogen coiled-coil and central regions', NULL, NULL, NULL, 21),
(285326, NULL, 'SSF55658', NULL, NULL, NULL, NULL, 'L9 N-domain-like', NULL, NULL, 9996, 21),
(285327, NULL, 'SSF47195', NULL, NULL, NULL, NULL, 'TMV-like viral coat proteins', NULL, NULL, 27943, 21),
(285328, NULL, 'SSF52964', NULL, NULL, NULL, NULL, 'TolB, N-terminal domain', NULL, NULL, NULL, 21),
(285329, NULL, 'SSF47807', NULL, NULL, NULL, NULL, '5'' to 3'' exonuclease, C-terminal subdomain', NULL, NULL, 27331, 21),
(285330, NULL, 'SSF56954', NULL, NULL, NULL, NULL, 'Outer membrane efflux proteins (OEP)', NULL, NULL, NULL, 21),
(285331, NULL, 'SSF51182', NULL, NULL, NULL, NULL, 'RmlC-like cupins', NULL, NULL, 9260, 21),
(285332, NULL, 'SSF69500', NULL, NULL, NULL, NULL, 'DTD-like', NULL, NULL, 16148, 21),
(285333, NULL, 'SSF81930', NULL, NULL, NULL, NULL, 'Orange carotenoid protein, N-terminal domain', NULL, NULL, 28980, 21),
(285334, NULL, 'SSF63712', NULL, NULL, NULL, NULL, 'Nicotinic receptor ligand binding domain-like', NULL, NULL, 31554, 21),
(285335, NULL, 'SSF53686', NULL, NULL, NULL, NULL, 'Tryptophan synthase beta subunit-like PLP-dependent enzymes', NULL, NULL, 32755, 21),
(285336, NULL, 'SSF118352', NULL, NULL, NULL, NULL, 'HSP33 redox switch-like', NULL, NULL, 11945, 21),
(285337, NULL, 'SSF82649', NULL, NULL, NULL, NULL, 'SufE/NifU', NULL, NULL, NULL, 21),
(285338, NULL, 'SSF159141', NULL, NULL, NULL, NULL, 'HIN-2000 domain-like', NULL, NULL, NULL, 21),
(285339, NULL, 'SSF69349', NULL, NULL, NULL, NULL, 'Phage fibre proteins', NULL, NULL, NULL, 21),
(285340, NULL, 'SSF48666', NULL, NULL, NULL, NULL, 'Methanol dehydrogenase subunit', NULL, NULL, 27545, 21),
(285341, NULL, 'SSF89796', NULL, NULL, NULL, NULL, 'CoA-transferase family III (CaiB/BaiF)', NULL, NULL, 16621, 21),
(285342, NULL, 'SSF57889', NULL, NULL, NULL, NULL, 'Cysteine-rich domain', NULL, NULL, 37669, 21),
(285343, NULL, 'SSF58113', NULL, NULL, NULL, NULL, 'Apolipoprotein A-I', NULL, NULL, NULL, 21),
(285344, NULL, 'SSF116734', NULL, NULL, NULL, NULL, 'DNA methylase specificity domain', NULL, NULL, NULL, 21),
(285345, NULL, 'SSF161037', NULL, NULL, NULL, NULL, 'Photosystem II reaction center protein K, PsbK', NULL, NULL, 32915, 21);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(285346, NULL, 'SSF52021', NULL, NULL, NULL, NULL, 'Carbamoyl phosphate synthetase, small subunit N-terminal domain', NULL, NULL, 29546, 21),
(285347, NULL, 'SSF82615', NULL, NULL, NULL, NULL, 'Polo-box domain', NULL, NULL, NULL, 21),
(285348, NULL, 'SSF140129', NULL, NULL, NULL, NULL, 'MxiH-like', NULL, NULL, 33289, 21),
(285349, NULL, 'SSF81296', NULL, NULL, NULL, NULL, 'E set domains', NULL, NULL, 8204, 21),
(285350, NULL, 'SSF47565', NULL, NULL, NULL, NULL, 'Insect pheromone/odorant-binding proteins', NULL, NULL, 31699, 21),
(285351, NULL, 'SSF51064', NULL, NULL, NULL, NULL, 'Head domain of nucleotide exchange factor GrpE', NULL, NULL, 9926, 21),
(285352, NULL, 'SSF75704', NULL, NULL, NULL, NULL, 'Mitotic arrest deficient-like 1, Mad1', NULL, NULL, NULL, 21),
(285353, NULL, 'SSF116965', NULL, NULL, NULL, NULL, 'Hypothetical protein MPN330', NULL, NULL, NULL, 21),
(285354, NULL, 'SSF48498', NULL, NULL, NULL, NULL, 'Tetracyclin repressor-like, C-terminal domain', NULL, NULL, 31959, 21),
(285355, NULL, 'SSF56978', NULL, NULL, NULL, NULL, 'Perfringolysin', NULL, NULL, 31686, 21),
(285356, NULL, 'SSF47789', NULL, NULL, NULL, NULL, 'C-terminal domain of RNA polymerase alpha subunit', NULL, NULL, NULL, 21),
(285357, NULL, 'SSF143447', NULL, NULL, NULL, NULL, 'AMMECR1-like', NULL, NULL, 27120, 21),
(285358, NULL, 'SSF54680', NULL, NULL, NULL, NULL, 'Pyrimidine nucleoside phosphorylase C-terminal domain', NULL, NULL, 31940, 21),
(285359, NULL, 'SSF141523', NULL, NULL, NULL, NULL, 'L,D-transpeptidase catalytic domain-like', NULL, NULL, 32567, 21),
(285360, NULL, 'SSF56563', NULL, NULL, NULL, NULL, 'Major capsid protein gp5', NULL, NULL, NULL, 21),
(285361, NULL, 'SSF82602', NULL, NULL, NULL, NULL, 'Nuclease A inhibitor (NuiA)', NULL, NULL, 32214, 21),
(285362, NULL, 'SSF159071', NULL, NULL, NULL, NULL, 'TrmB C-terminal domain-like', NULL, NULL, NULL, 21),
(285363, NULL, 'SSF50904', NULL, NULL, NULL, NULL, 'Oncogene products', NULL, NULL, 28747, 21),
(285364, NULL, 'SSF144217', NULL, NULL, NULL, NULL, 'CSL zinc finger', NULL, NULL, 29933, 21),
(285365, NULL, 'SSF161017', NULL, NULL, NULL, NULL, 'Photosystem II reaction center protein L, PsbL', NULL, NULL, 32974, 21),
(285366, NULL, 'SSF140741', NULL, NULL, NULL, NULL, 'RUN domain-like', NULL, NULL, 33420, 21),
(285367, NULL, 'SSF51338', NULL, NULL, NULL, NULL, 'Composite domain of metallo-dependent hydrolases', NULL, NULL, 9044, 21),
(285368, NULL, 'SSF49818', NULL, NULL, NULL, NULL, 'Viral protein domain', NULL, NULL, 9369, 21),
(285369, NULL, 'SSF48092', NULL, NULL, NULL, NULL, 'Transcription factor STAT-4 N-domain', NULL, NULL, 30478, 21),
(285370, NULL, 'SSF50998', NULL, NULL, NULL, NULL, 'Quinoprotein alcohol dehydrogenase-like', NULL, NULL, 9027, 21),
(285371, NULL, 'SSF51658', NULL, NULL, NULL, NULL, 'Xylose isomerase-like', NULL, NULL, 29756, 21),
(285372, NULL, 'SSF160574', NULL, NULL, NULL, NULL, 'BT0923-like', NULL, NULL, NULL, 21),
(285373, NULL, 'SSF90096', NULL, NULL, NULL, NULL, 'Subunits of heterodimeric actin filament capping protein Capz', NULL, NULL, 31604, 21),
(285374, NULL, 'SSF118359', NULL, NULL, NULL, NULL, 'Expressed protein At2g23090/F21P24.15', NULL, NULL, NULL, 21),
(285375, NULL, 'SSF144010', NULL, NULL, NULL, NULL, 'CofE-like', NULL, NULL, NULL, 21),
(285376, NULL, 'SSF56558', NULL, NULL, NULL, NULL, 'Baseplate structural protein gp11', NULL, NULL, 29729, 21),
(285377, NULL, 'SSF54160', NULL, NULL, NULL, NULL, 'Chromo domain-like', NULL, NULL, 11788, 21),
(285378, NULL, 'SSF54171', NULL, NULL, NULL, NULL, 'DNA-binding domain', NULL, NULL, 11547, 21),
(285379, NULL, 'SSF69012', NULL, NULL, NULL, NULL, 'alpha-ketoacid dehydrogenase kinase, N-terminal domain', NULL, NULL, 33277, 21),
(285380, NULL, 'SSF143567', NULL, NULL, NULL, NULL, 'YkuJ-like', NULL, NULL, 30969, 21),
(285381, NULL, 'SSF109801', NULL, NULL, NULL, NULL, 'Hypothetical protein D-63', NULL, NULL, 29766, 21),
(285382, NULL, 'SSF53150', NULL, NULL, NULL, NULL, 'DNA repair protein MutS, domain II', NULL, NULL, 29690, 21),
(285383, NULL, 'SSF48431', NULL, NULL, NULL, NULL, 'Lipovitellin-phosvitin complex, superhelical domain', NULL, NULL, 9193, 21);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(285384, NULL, 'SSF52121', NULL, NULL, NULL, NULL, 'Lumazine synthase', NULL, NULL, 29925, 21),
(285385, NULL, 'SSF160419', NULL, NULL, NULL, NULL, 'YdfO-like', NULL, NULL, 29545, 21),
(285386, NULL, 'SSF81597', NULL, NULL, NULL, NULL, 'Iron-sulfur subunit of formate dehydrogenase N, transmembrane anchor', NULL, NULL, NULL, 21),
(285387, NULL, 'SSF102405', NULL, NULL, NULL, NULL, 'MCP/YpsA-like', NULL, NULL, NULL, 21),
(285388, NULL, 'SSF64210', NULL, NULL, NULL, NULL, 'Head-to-tail joining protein W, gpW', NULL, NULL, 30606, 21),
(285389, NULL, 'SSF102875', NULL, NULL, NULL, NULL, 'Chromosomal protein MC1', NULL, NULL, 28371, 21),
(285390, NULL, 'SSF81624', NULL, NULL, NULL, NULL, 'N-terminal domain of MutM-like DNA repair proteins', NULL, NULL, 14103, 21),
(285391, NULL, 'SSF158745', NULL, NULL, NULL, NULL, 'LanC-like', NULL, NULL, NULL, 21),
(285392, NULL, 'SSF50993', NULL, NULL, NULL, NULL, 'Peptidase/esterase ''gauge'' domain', NULL, NULL, NULL, 21),
(285393, NULL, 'SSF75399', NULL, NULL, NULL, NULL, 'Plakin repeat', NULL, NULL, 18528, 21),
(285394, NULL, 'SSF52317', NULL, NULL, NULL, NULL, 'Class I glutamine amidotransferase-like', NULL, NULL, 24711, 21),
(285395, NULL, 'SSF140404', NULL, NULL, NULL, NULL, 'EF2458-like', NULL, NULL, 33242, 21),
(285396, NULL, 'SSF56491', NULL, NULL, NULL, NULL, 'A heparin-binding domain', NULL, NULL, 31661, 21),
(285397, NULL, 'SSF54791', NULL, NULL, NULL, NULL, 'Eukaryotic type KH-domain (KH-domain type I)', NULL, NULL, 30414, 21),
(285398, NULL, 'SSF89082', NULL, NULL, NULL, NULL, 'Antibiotic binding domain of TipA-like multidrug resistance regulators', NULL, NULL, 29957, 21),
(285399, NULL, 'SSF100895', NULL, NULL, NULL, NULL, 'Kazal-type serine protease inhibitors', NULL, NULL, 29229, 21),
(285400, NULL, 'SSF141322', NULL, NULL, NULL, NULL, 'NfeD domain-like', NULL, NULL, NULL, 21),
(285401, NULL, 'SSF47616', NULL, NULL, NULL, NULL, 'GST C-terminal domain-like', NULL, NULL, 31742, 21),
(285402, NULL, 'SSF69287', NULL, NULL, NULL, NULL, 'Urease metallochaperone UreE, N-terminal domain', NULL, NULL, 33447, 21),
(285403, NULL, 'SSF140125', NULL, NULL, NULL, NULL, 'Rabenosyn-5 Rab-binding domain-like', NULL, NULL, 30139, 21),
(285404, NULL, 'SSF53920', NULL, NULL, NULL, NULL, 'Fe-only hydrogenase', NULL, NULL, 9761, 21),
(285405, NULL, 'SSF69047', NULL, NULL, NULL, NULL, 'Hypothetical protein YjbJ', NULL, NULL, 28301, 21),
(285406, NULL, 'SSF111057', NULL, NULL, NULL, NULL, 'Hypothetical protein PF0899', NULL, NULL, 29801, 21),
(285407, NULL, 'SSF143034', NULL, NULL, NULL, NULL, 'L35p-like', NULL, NULL, 29154, 21),
(285408, NULL, 'SSF69786', NULL, NULL, NULL, NULL, 'YggU-like', NULL, NULL, 32994, 21),
(285409, NULL, 'SSF81568', NULL, NULL, NULL, NULL, 'Photosystem I reaction center subunit XI, PsaL', NULL, NULL, 32581, 21),
(285410, NULL, 'SSF49723', NULL, NULL, NULL, NULL, 'Lipase/lipooxygenase domain (PLAT/LH2 domain)', NULL, NULL, 28149, 21),
(285411, NULL, 'SSF158587', NULL, NULL, NULL, NULL, 'Jann4075-like', NULL, NULL, 15449, 21),
(285412, NULL, 'SSF81442', NULL, NULL, NULL, NULL, 'Cytochrome c oxidase subunit I-like', NULL, NULL, 32914, 21),
(285413, NULL, 'SSF54098', NULL, NULL, NULL, NULL, 'Prion-like', NULL, NULL, 32528, 21),
(285414, NULL, 'SSF101904', NULL, NULL, NULL, NULL, 'GyrA/ParC C-terminal domain-like', NULL, NULL, 31422, 21),
(285415, NULL, 'SSF101790', NULL, NULL, NULL, NULL, 'Aminomethyltransferase beta-barrel domain', NULL, NULL, 24272, 21),
(285416, NULL, 'SSF48686', NULL, NULL, NULL, NULL, 'Proteinase A inhibitor IA3', NULL, NULL, 8984, 21),
(285417, NULL, 'SSF49401', NULL, NULL, NULL, NULL, 'Bacterial adhesins', NULL, NULL, 8755, 21),
(285418, NULL, 'SSF103612', NULL, NULL, NULL, NULL, 'SBT domain', NULL, NULL, 28717, 21),
(285419, NULL, 'SSF48484', NULL, NULL, NULL, NULL, 'Lipoxigenase', NULL, NULL, 29592, 21),
(285420, NULL, 'SSF81340', NULL, NULL, NULL, NULL, 'Clc chloride channel', NULL, NULL, 12131, 21),
(285421, NULL, 'SSF57535', NULL, NULL, NULL, NULL, 'Complement control module/SCR domain', NULL, NULL, 19221, 21);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(285422, NULL, 'SSF47090', NULL, NULL, NULL, NULL, 'PGBD-like', NULL, NULL, 33379, 21),
(285423, NULL, 'SSF143842', NULL, NULL, NULL, NULL, 'YwmB-like', NULL, NULL, 31271, 21),
(285424, NULL, 'SSF64397', NULL, NULL, NULL, NULL, 'Hsp33 domain', NULL, NULL, 11549, 21),
(285425, NULL, 'SSF116738', NULL, NULL, NULL, NULL, 'NADH pyrophosphatase intervening domain', NULL, NULL, NULL, 21),
(285426, NULL, 'SSF158851', NULL, NULL, NULL, NULL, 'Lag-3 N-terminal region', NULL, NULL, NULL, 21),
(285427, NULL, 'SSF47370', NULL, NULL, NULL, NULL, 'Bromodomain', NULL, NULL, 28108, 21),
(285428, NULL, 'SSF100966', NULL, NULL, NULL, NULL, 'Translation initiation factor 2 beta, aIF2beta, N-terminal domain', NULL, NULL, 11523, 21),
(285429, NULL, 'SSF48425', NULL, NULL, NULL, NULL, 'Sec7 domain', NULL, NULL, 30490, 21),
(285430, NULL, 'SSF55120', NULL, NULL, NULL, NULL, 'Pseudouridine synthase', NULL, NULL, 18584, 21),
(285431, NULL, 'SSF82057', NULL, NULL, NULL, NULL, 'Prokaryotic SH3-related domain', NULL, NULL, NULL, 21),
(285432, NULL, 'SSF54919', NULL, NULL, NULL, NULL, 'Nucleoside diphosphate kinase, NDK', NULL, NULL, 31973, 21),
(285433, NULL, 'SSF142764', NULL, NULL, NULL, NULL, 'YgbK-like', NULL, NULL, NULL, 21),
(285434, NULL, 'SSF53067', NULL, NULL, NULL, NULL, 'Actin-like ATPase domain', NULL, NULL, 35367, 21),
(285435, NULL, 'SSF51045', NULL, NULL, NULL, NULL, 'WW domain', NULL, NULL, 27752, 21),
(285436, NULL, 'SSF75420', NULL, NULL, NULL, NULL, 'YhbC-like, N-terminal domain', NULL, NULL, 24144, 21),
(285437, NULL, 'SSF55399', NULL, NULL, NULL, NULL, 'Subtilisin inhibitor', NULL, NULL, 27548, 21),
(285438, NULL, 'SSF160537', NULL, NULL, NULL, NULL, 'SpoVG-like', NULL, NULL, 32060, 21),
(285439, NULL, 'SSF58050', NULL, NULL, NULL, NULL, 'N-terminal coiled coil domain from apc', NULL, NULL, 28657, 21),
(285440, NULL, 'SSF47401', NULL, NULL, NULL, NULL, 'Ectatomin subunits', NULL, NULL, 29865, 21),
(285441, NULL, 'SSF53178', NULL, NULL, NULL, NULL, 'Peptidyl-tRNA hydrolase-like', NULL, NULL, 27523, 21),
(285442, NULL, 'SSF55770', NULL, NULL, NULL, NULL, 'Profilin (actin-binding protein)', NULL, NULL, 28770, 21),
(285443, NULL, 'SSF52058', NULL, NULL, NULL, NULL, 'L domain-like', NULL, NULL, NULL, 21),
(285444, NULL, 'SSF48008', NULL, NULL, NULL, NULL, 'GntR ligand-binding domain-like', NULL, NULL, 8714, 21),
(285445, NULL, 'SSF116820', NULL, NULL, NULL, NULL, 'Rps17e-like', NULL, NULL, 31725, 21),
(285446, NULL, 'SSF143492', NULL, NULL, NULL, NULL, 'Prenyltransferase-like', NULL, NULL, 28762, 21),
(285447, NULL, 'SSF53613', NULL, NULL, NULL, NULL, 'Ribokinase-like', NULL, NULL, 24324, 21),
(285448, NULL, 'SSF57256', NULL, NULL, NULL, NULL, 'Elafin-like', NULL, NULL, 28044, 21),
(285449, NULL, 'SSF52943', NULL, NULL, NULL, NULL, 'ATP synthase (F1-ATPase), gamma subunit', NULL, NULL, 29645, 21),
(285450, NULL, 'SSF74650', NULL, NULL, NULL, NULL, 'Galactose mutarotase-like', NULL, NULL, 9334, 21),
(285451, NULL, 'SSF160481', NULL, NULL, NULL, NULL, 'BRK domain-like', NULL, NULL, 31672, 21),
(285452, NULL, 'SSF53671', NULL, NULL, NULL, NULL, 'Aspartate/ornithine carbamoyltransferase', NULL, NULL, 31611, 21),
(285453, NULL, 'SSF47928', NULL, NULL, NULL, NULL, 'N-terminal domain of the delta subunit of the F1F0-ATP synthase', NULL, NULL, 24699, 21),
(285454, NULL, 'SSF161240', NULL, NULL, NULL, NULL, 'T-antigen specific domain-like', NULL, NULL, 27033, 21),
(285455, NULL, 'SSF56266', NULL, NULL, NULL, NULL, 'DmpA/ArgJ-like', NULL, NULL, 11196, 21),
(285456, NULL, 'SSF81778', NULL, NULL, NULL, NULL, 'Crustacean CHH/MIH/GIH neurohormone', NULL, NULL, 32560, 21),
(285457, NULL, 'SSF158372', NULL, NULL, NULL, NULL, 'AF1782-like', NULL, NULL, 33107, 21),
(285458, NULL, 'SSF100985', NULL, NULL, NULL, NULL, 'Sporulation inhibitor Sda', NULL, NULL, 28582, 21),
(285459, NULL, 'SSF140319', NULL, NULL, NULL, NULL, 'IscX-like', NULL, NULL, 27694, 21),
(285460, NULL, 'SSF111337', NULL, NULL, NULL, NULL, 'QueA-like', NULL, NULL, 27046, 21),
(285461, NULL, 'SSF54928', NULL, NULL, NULL, NULL, 'RNA-binding domain, RBD', NULL, NULL, 19901, 21);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(285462, NULL, 'SSF50985', NULL, NULL, NULL, NULL, 'RCC1/BLIP-II', NULL, NULL, 6147, 21),
(285463, NULL, 'SSF56935', NULL, NULL, NULL, NULL, 'Porins', NULL, NULL, NULL, 21),
(285464, NULL, 'SSF140663', NULL, NULL, NULL, NULL, 'TTHA0068-like', NULL, NULL, 18455, 21),
(285465, NULL, 'SSF48113', NULL, NULL, NULL, NULL, 'Heme-dependent peroxidases', NULL, NULL, 8591, 21),
(285466, NULL, 'SSF160755', NULL, NULL, NULL, NULL, 'YugN-like', NULL, NULL, 31472, 21),
(285467, NULL, 'SSF158548', NULL, NULL, NULL, NULL, 'FLJ32549 domain-like', NULL, NULL, 30516, 21),
(285468, NULL, 'SSF49889', NULL, NULL, NULL, NULL, 'Soluble secreted chemokine inhibitor, VCCI', NULL, NULL, 33325, 21),
(285469, NULL, 'SSF81799', NULL, NULL, NULL, NULL, 'Putative methyltransferase TM0872, insert domain', NULL, NULL, 16401, 21),
(285470, NULL, 'SSF110009', NULL, NULL, NULL, NULL, 'Hypothetical protein MG354', NULL, NULL, 23921, 21),
(285471, NULL, 'SSF58046', NULL, NULL, NULL, NULL, 'Fibritin', NULL, NULL, NULL, 21),
(285472, NULL, 'SSF63862', NULL, NULL, NULL, NULL, 'Thiamin pyrophosphokinase, substrate-binding domain', NULL, NULL, 28946, 21),
(285473, NULL, 'SSF48652', NULL, NULL, NULL, NULL, 'Tetraspanin', NULL, NULL, 8745, 21),
(285474, NULL, 'SSF109715', NULL, NULL, NULL, NULL, 'DEK C-terminal domain', NULL, NULL, NULL, 21),
(285475, NULL, 'SSF51219', NULL, NULL, NULL, NULL, 'TRAP-like', NULL, NULL, 9224, 21),
(285476, NULL, 'SSF51306', NULL, NULL, NULL, NULL, 'LexA/Signal peptidase', NULL, NULL, 31089, 21),
(285477, NULL, 'SSF101908', NULL, NULL, NULL, NULL, 'Putative isomerase YbhE', NULL, NULL, NULL, 21),
(285478, NULL, 'SSF63697', NULL, NULL, NULL, NULL, 'Olfactory marker protein', NULL, NULL, 32145, 21),
(285479, NULL, 'SSF58018', NULL, NULL, NULL, NULL, 'Coiled-coil dimerization domain from cortexillin I', NULL, NULL, NULL, 21),
(285480, NULL, 'SSF51391', NULL, NULL, NULL, NULL, 'Thiamin phosphate synthase', NULL, NULL, 30335, 21),
(285481, NULL, 'SSF49447', NULL, NULL, NULL, NULL, 'Second domain of Mu2 adaptin subunit (ap50) of ap2 adaptor', NULL, NULL, 30646, 21),
(285482, NULL, 'SSF161245', NULL, NULL, NULL, NULL, 'Zinc hairpin stack', NULL, NULL, 32813, 21),
(285483, NULL, 'SSF159173', NULL, NULL, NULL, NULL, 'YkvR-like', NULL, NULL, 20582, 21),
(285484, NULL, 'SSF51206', NULL, NULL, NULL, NULL, 'cAMP-binding domain-like', NULL, NULL, 14790, 21),
(285485, NULL, 'SSF109779', NULL, NULL, NULL, NULL, 'Domain from hypothetical 2610208m17rik protein', NULL, NULL, 27851, 21),
(285486, NULL, 'SSF81832', NULL, NULL, NULL, NULL, 'SopE-like GEF domain', NULL, NULL, 24183, 21),
(285487, NULL, 'SSF90209', NULL, NULL, NULL, NULL, 'Ran binding protein zinc finger-like', NULL, NULL, 28397, 21),
(285488, NULL, 'SSF56574', NULL, NULL, NULL, NULL, 'Serpins', NULL, NULL, 26626, 21),
(285489, NULL, 'SSF103473', NULL, NULL, NULL, NULL, 'MFS general substrate transporter', NULL, NULL, 30757, 21),
(285490, NULL, 'SSF111347', NULL, NULL, NULL, NULL, 'Rap/Ran-GAP', NULL, NULL, 18179, 21),
(285491, NULL, 'SSF81901', NULL, NULL, NULL, NULL, 'HCP-like', NULL, NULL, NULL, 21),
(285492, NULL, 'SSF111148', NULL, NULL, NULL, NULL, 'YggX-like', NULL, NULL, 32378, 21),
(285493, NULL, 'SSF51327', NULL, NULL, NULL, NULL, 'Head-binding domain of phage P22 tailspike protein', NULL, NULL, 33240, 21),
(285494, NULL, 'SSF160897', NULL, NULL, NULL, NULL, 'Taf5 N-terminal domain-like', NULL, NULL, 31704, 21),
(285495, NULL, 'SSF49329', NULL, NULL, NULL, NULL, 'Cu,Zn superoxide dismutase-like', NULL, NULL, 27871, 21),
(285496, NULL, 'SSF111038', NULL, NULL, NULL, NULL, 'YjbQ-like', NULL, NULL, 24628, 21),
(285497, NULL, 'SSF47055', NULL, NULL, NULL, NULL, 'TAF(II)230 TBP-binding fragment', NULL, NULL, 27979, 21),
(285498, NULL, 'SSF142433', NULL, NULL, NULL, NULL, 'CinA-like', NULL, NULL, 29531, 21),
(285499, NULL, 'SSF161003', NULL, NULL, NULL, NULL, 'flu NP-like', NULL, NULL, NULL, 21),
(285500, NULL, 'SSF82697', NULL, NULL, NULL, NULL, 'PurS-like', NULL, NULL, 32729, 21),
(285501, NULL, 'SSF52166', NULL, NULL, NULL, NULL, 'Ribosomal protein L4', NULL, NULL, 18505, 21); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(285502, NULL, 'SSF158997', NULL, NULL, NULL, NULL, 'Trm112p-like', NULL, NULL, NULL, 21),
(285503, NULL, 'SSF74863', NULL, NULL, NULL, NULL, 'Thiol:disulfide interchange protein DsbD, N-terminal domain (DsbD-alpha)', NULL, NULL, 32766, 21),
(285504, NULL, 'SSF140415', NULL, NULL, NULL, NULL, 'YppE-like', NULL, NULL, 16640, 21),
(285505, NULL, 'SSF49417', NULL, NULL, NULL, NULL, 'p53-like transcription factors', NULL, NULL, 9403, 21),
(285506, NULL, 'SSF57987', NULL, NULL, NULL, NULL, 'Inovirus (filamentous phage) major coat protein', NULL, NULL, NULL, 21),
(285507, NULL, 'SSF56019', NULL, NULL, NULL, NULL, 'The spindle assembly checkpoint protein mad2', NULL, NULL, 31393, 21),
(285508, NULL, 'SSF111384', NULL, NULL, NULL, NULL, 'OmpH-like', NULL, NULL, 21699, 21),
(285509, NULL, 'SSF159871', NULL, NULL, NULL, NULL, 'YdgH-like', NULL, NULL, 31353, 21),
(285510, NULL, 'SSF143469', NULL, NULL, NULL, NULL, 'ImmE5-like', NULL, NULL, 29903, 21),
(285511, NULL, 'SSF47943', NULL, NULL, NULL, NULL, 'Retrovirus capsid protein, N-terminal core domain', NULL, NULL, 8814, 21),
(285512, NULL, 'SSF116915', NULL, NULL, NULL, NULL, 'Hypothetical protein YqbG', NULL, NULL, 33376, 21),
(285513, NULL, 'SSF103506', NULL, NULL, NULL, NULL, 'Mitochondrial carrier', NULL, NULL, 16096, 21),
(285514, NULL, 'SSF50090', NULL, NULL, NULL, NULL, 'Electron transport accessory proteins', NULL, NULL, 9726, 21),
(285515, NULL, 'SSF89942', NULL, NULL, NULL, NULL, 'eEF1-gamma domain', NULL, NULL, 28320, 21),
(285516, NULL, 'SSF158499', NULL, NULL, NULL, NULL, 'DnaD domain-like', NULL, NULL, 29014, 21),
(285517, NULL, 'SSF81891', NULL, NULL, NULL, NULL, 'Poly A polymerase C-terminal region-like', NULL, NULL, NULL, 21),
(285518, NULL, 'SSF69131', NULL, NULL, NULL, NULL, 'Quinohemoprotein amine dehydrogenase C chain', NULL, NULL, 31145, 21),
(285519, NULL, 'SSF50800', NULL, NULL, NULL, NULL, 'PK beta-barrel domain-like', NULL, NULL, 9281, 21),
(285520, NULL, 'SSF82199', NULL, NULL, NULL, NULL, 'SET domain', NULL, NULL, 37706, 21),
(285521, NULL, 'SSF55186', NULL, NULL, NULL, NULL, 'ThrRS/AlaRS common domain', NULL, NULL, 19737, 21),
(285522, NULL, 'SSF54565', NULL, NULL, NULL, NULL, 'Ribosomal protein S16', NULL, NULL, 17800, 21),
(285523, NULL, 'SSF81324', NULL, NULL, NULL, NULL, 'Voltage-gated potassium channels', NULL, NULL, NULL, 21),
(285524, NULL, 'SSF88645', NULL, NULL, NULL, NULL, 'ssDNA viruses', NULL, NULL, 11926, 21),
(285525, NULL, 'SSF101112', NULL, NULL, NULL, NULL, 'Oxygen-evolving enhancer protein 3,', NULL, NULL, 2398, 21),
(285526, NULL, 'SSF63867', NULL, NULL, NULL, NULL, 'MoeA C-terminal domain-like', NULL, NULL, 31013, 21),
(285527, NULL, 'SSF51332', NULL, NULL, NULL, NULL, 'E2 regulatory, transactivation domain', NULL, NULL, 32843, 21),
(285528, NULL, 'SSF82220', NULL, NULL, NULL, NULL, 'Tp47 lipoprotein, N-terminal domain', NULL, NULL, 28868, 21),
(285529, NULL, 'SSF158682', NULL, NULL, NULL, NULL, 'TerB-like', NULL, NULL, 21681, 21),
(285530, NULL, 'SSF55816', NULL, NULL, NULL, NULL, '5''-nucleotidase (syn. UDP-sugar hydrolase), C-terminal domain', NULL, NULL, 33599, 21),
(285531, NULL, 'SSF109604', NULL, NULL, NULL, NULL, 'HD-domain/PDEase-like', NULL, NULL, NULL, 21),
(285532, NULL, 'SSF160957', NULL, NULL, NULL, NULL, 'Poly(A) polymerase catalytic subunit-like', NULL, NULL, 32792, 21),
(285533, NULL, 'SSF47446', NULL, NULL, NULL, NULL, 'Signal peptide-binding domain', NULL, NULL, 28695, 21),
(285534, NULL, 'SSF160532', NULL, NULL, NULL, NULL, 'Ava3019-like', NULL, NULL, NULL, 21),
(285535, NULL, 'SSF51230', NULL, NULL, NULL, NULL, 'Single hybrid motif', NULL, NULL, 9046, 21),
(285536, NULL, 'SSF158615', NULL, NULL, NULL, NULL, 'RbcX-like', NULL, NULL, 29101, 21),
(285537, NULL, 'SSF47587', NULL, NULL, NULL, NULL, 'Domain of poly(ADP-ribose) polymerase', NULL, NULL, 27711, 21),
(285538, NULL, 'SSF111388', NULL, NULL, NULL, NULL, 'Pollen allergen ole e 6', NULL, NULL, 31401, 21),
(285539, NULL, 'SSF69008', NULL, NULL, NULL, NULL, 'RecG, N-terminal domain', NULL, NULL, 31848, 21),
(285540, NULL, 'SSF47571', NULL, NULL, NULL, NULL, 'Cloroperoxidase', NULL, NULL, 31822, 21);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(285541, NULL, 'SSF160515', NULL, NULL, NULL, NULL, 'YueI-like', NULL, NULL, NULL, 21),
(285542, NULL, 'SSF109905', NULL, NULL, NULL, NULL, 'Surp module (SWAP domain)', NULL, NULL, 29568, 21),
(285543, NULL, 'SSF56029', NULL, NULL, NULL, NULL, 'Monooxygenase (hydroxylase) regulatory protein', NULL, NULL, 28690, 21),
(285544, NULL, 'SSF57884', NULL, NULL, NULL, NULL, 'Ada DNA repair protein, N-terminal domain (N-Ada 10)', NULL, NULL, 20036, 21),
(285545, NULL, 'SSF49772', NULL, NULL, NULL, NULL, 'Ecotin, trypsin inhibitor', NULL, NULL, 29095, 21),
(285546, NULL, 'SSF46973', NULL, NULL, NULL, NULL, 'Enzyme IIa from lactose specific PTS, IIa-lac', NULL, NULL, 33422, 21),
(285547, NULL, 'SSF64043', NULL, NULL, NULL, NULL, 'Cell-division inhibitor MinC, N-terminal domain', NULL, NULL, NULL, 21),
(285548, NULL, 'SSF111423', NULL, NULL, NULL, NULL, 'Resistin', NULL, NULL, 29742, 21),
(285549, NULL, 'SSF54736', NULL, NULL, NULL, NULL, 'ClpS-like', NULL, NULL, 18977, 21),
(285550, NULL, 'SSF50923', NULL, NULL, NULL, NULL, 'Hemopexin-like domain', NULL, NULL, 32437, 21),
(285551, NULL, 'SSF54403', NULL, NULL, NULL, NULL, 'Cystatin/monellin', NULL, NULL, 37557, 21),
(285552, NULL, 'SSF63748', NULL, NULL, NULL, NULL, 'Tudor/PWWP/MBT', NULL, NULL, NULL, 21),
(285553, NULL, 'SSF52467', NULL, NULL, NULL, NULL, 'DHS-like NAD/FAD-binding domain', NULL, NULL, 24352, 21),
(285554, NULL, 'SSF118203', NULL, NULL, NULL, NULL, 'Vacuolar ATP synthase subunit C', NULL, NULL, 33230, 21),
(285555, NULL, 'SSF101094', NULL, NULL, NULL, NULL, 'Staphylocoagulase', NULL, NULL, NULL, 21),
(285556, NULL, 'SSF111364', NULL, NULL, NULL, NULL, 'Tsx-like channel', NULL, NULL, 31839, 21),
(285557, NULL, 'SSF159612', NULL, NULL, NULL, NULL, 'TBP-interacting protein-like', NULL, NULL, NULL, 21),
(285558, NULL, 'SSF56300', NULL, NULL, NULL, NULL, 'Metallo-dependent phosphatases', NULL, NULL, 24118, 21),
(285559, NULL, 'SSF56496', NULL, NULL, NULL, NULL, 'Fibrinogen C-terminal domain-like', NULL, NULL, 32525, 21),
(285560, NULL, 'SSF101498', NULL, NULL, NULL, NULL, 'Anti-sigma factor FlgM', NULL, NULL, 7286, 21),
(285561, NULL, 'SSF74914', NULL, NULL, NULL, NULL, 'V-region of surface antigen I/II (SA I/II, PAC)', NULL, NULL, 29782, 21),
(285562, NULL, 'SSF46548', NULL, NULL, NULL, NULL, 'alpha-helical ferredoxin', NULL, NULL, NULL, 21),
(285563, NULL, 'SSF160099', NULL, NULL, NULL, NULL, 'SARS Nsp1-like', NULL, NULL, 30295, 21),
(285564, NULL, 'SSF75689', NULL, NULL, NULL, NULL, 'Zinc-binding domain of translation initiation factor 2 beta', NULL, NULL, 11834, 21),
(285565, NULL, 'SSF159245', NULL, NULL, NULL, NULL, 'AttH-like', NULL, NULL, NULL, 21),
(285566, NULL, 'SSF158472', NULL, NULL, NULL, NULL, 'HAMP domain-like', NULL, NULL, NULL, 21),
(285567, NULL, 'SSF47973', NULL, NULL, NULL, NULL, 'Ribosomal protein S7', NULL, NULL, 27594, 21),
(285568, NULL, 'SSF141066', NULL, NULL, NULL, NULL, 'ICP-like', NULL, NULL, 28106, 21),
(285569, NULL, 'SSF47406', NULL, NULL, NULL, NULL, 'SinR repressor dimerisation domain-like', NULL, NULL, 31154, 21),
(285570, NULL, 'SSF50911', NULL, NULL, NULL, NULL, 'Mannose 6-phosphate receptor domain', NULL, NULL, 10000, 21),
(285571, NULL, 'SSF56968', NULL, NULL, NULL, NULL, 'Lipovitellin-phosvitin complex; beta-sheet shell regions', NULL, NULL, 12852, 21),
(285572, NULL, 'SSF140566', NULL, NULL, NULL, NULL, 'FlgN-like', NULL, NULL, 29768, 21),
(285573, NULL, 'SSF110069', NULL, NULL, NULL, NULL, 'ApaG-like', NULL, NULL, 27898, 21),
(285574, NULL, 'SSF89043', NULL, NULL, NULL, NULL, 'Soluble domain of poliovirus core protein 3a', NULL, NULL, 31348, 21),
(285575, NULL, 'SSF47144', NULL, NULL, NULL, NULL, 'HSC20 (HSCB), C-terminal oligomerisation domain', NULL, NULL, 32083, 21),
(285576, NULL, 'SSF140576', NULL, NULL, NULL, NULL, 'HIV integrase-binding domain', NULL, NULL, 33144, 21),
(285577, NULL, 'SSF160544', NULL, NULL, NULL, NULL, 'EscU C-terminal domain-like', NULL, NULL, 26881, 21),
(285578, NULL, 'SSF82109', NULL, NULL, NULL, NULL, 'MIR domain', NULL, NULL, 31344, 21),
(285579, NULL, 'SSF56349', NULL, NULL, NULL, NULL, 'DNA breaking-rejoining enzymes', NULL, NULL, 8579, 21);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(285580, NULL, 'SSF54328', NULL, NULL, NULL, NULL, 'Staphylokinase/streptokinase', NULL, NULL, 33103, 21),
(285581, NULL, 'SSF46997', NULL, NULL, NULL, NULL, 'Bacterial immunoglobulin/albumin-binding domains', NULL, NULL, 6400, 21),
(285582, NULL, 'SSF81601', NULL, NULL, NULL, NULL, 'Protein serine/threonine phosphatase 2C, C-terminal domain', NULL, NULL, 29789, 21),
(285583, NULL, 'SSF51679', NULL, NULL, NULL, NULL, 'Bacterial luciferase-like', NULL, NULL, 31956, 21),
(285584, NULL, 'SSF54611', NULL, NULL, NULL, NULL, 'SecB-like', NULL, NULL, 16822, 21),
(285585, NULL, 'SSF47694', NULL, NULL, NULL, NULL, 'Cytochrome c oxidase subunit h', NULL, NULL, 33102, 21),
(285586, NULL, 'SSF48295', NULL, NULL, NULL, NULL, 'TrpR-like', NULL, NULL, 10030, 21),
(285587, NULL, 'SSF48334', NULL, NULL, NULL, NULL, 'DNA repair protein MutS, domain III', NULL, NULL, 33327, 21),
(285588, NULL, 'SSF140864', NULL, NULL, NULL, NULL, 'TROVE domain-like', NULL, NULL, 31576, 21),
(285589, NULL, 'SSF51246', NULL, NULL, NULL, NULL, 'Rudiment single hybrid motif', NULL, NULL, 9462, 21),
(285590, NULL, 'SSF81508', NULL, NULL, NULL, NULL, 'Ubiquinone-binding protein QP-C of cytochrome bc1 complex (Ubiquinol-cytochrome c reductase)', NULL, NULL, 30560, 21),
(285591, NULL, 'SSF141371', NULL, NULL, NULL, NULL, 'PilZ domain-like', NULL, NULL, NULL, 21),
(285592, NULL, 'SSF55676', NULL, NULL, NULL, NULL, 'CytB endotoxin-like', NULL, NULL, 24109, 21),
(285593, NULL, 'SSF50151', NULL, NULL, NULL, NULL, 'SacY-like RNA-binding domain', NULL, NULL, 30538, 21),
(285594, NULL, 'SSF57546', NULL, NULL, NULL, NULL, 'Crisp domain-like', NULL, NULL, NULL, 21),
(285595, NULL, 'SSF101089', NULL, NULL, NULL, NULL, 'Phosphoprotein XD domain', NULL, NULL, 9156, 21),
(285596, NULL, 'SSF118010', NULL, NULL, NULL, NULL, 'TM1457-like', NULL, NULL, 32410, 21),
(285597, NULL, 'SSF49299', NULL, NULL, NULL, NULL, 'PKD domain', NULL, NULL, 31515, 21),
(285598, NULL, 'SSF57944', NULL, NULL, NULL, NULL, 'Triple coiled coil domain of C-type lectins', NULL, NULL, NULL, 21),
(285599, NULL, 'SSF81338', NULL, NULL, NULL, NULL, 'Aquaporin-like', NULL, NULL, 13680, 21),
(285600, NULL, 'SSF58059', NULL, NULL, NULL, NULL, 'Tetramerization domain of the Mnt repressor', NULL, NULL, NULL, 21),
(285601, NULL, 'SSF69742', NULL, NULL, NULL, NULL, 'Glutamyl tRNA-reductase catalytic, N-terminal domain', NULL, NULL, 28173, 21),
(285602, NULL, 'SSF47933', NULL, NULL, NULL, NULL, 'ERP29 C domain-like', NULL, NULL, 27741, 21),
(285603, NULL, 'SSF54690', NULL, NULL, NULL, NULL, 'Molybdopterin synthase subunit MoaE', NULL, NULL, 33044, 21),
(285604, NULL, 'SSF101238', NULL, NULL, NULL, NULL, 'XPC-binding domain', NULL, NULL, 28484, 21),
(285605, NULL, 'SSF56741', NULL, NULL, NULL, NULL, 'Eukaryotic DNA topoisomerase I, N-terminal DNA-binding fragment', NULL, NULL, 28122, 21),
(285606, NULL, 'SSF89807', NULL, NULL, NULL, NULL, 'Dodecin-like', NULL, NULL, 29974, 21),
(285607, NULL, 'SSF47060', NULL, NULL, NULL, NULL, 'S15/NS1 RNA-binding domain', NULL, NULL, 6437, 21),
(285608, NULL, 'SSF54957', NULL, NULL, NULL, NULL, 'Viral DNA-binding domain', NULL, NULL, 18969, 21),
(285609, NULL, 'SSF51569', NULL, NULL, NULL, NULL, 'Aldolase', NULL, NULL, NULL, 21),
(285610, NULL, 'SSF53155', NULL, NULL, NULL, NULL, 'Methylated DNA-protein cysteine methyltransferase domain', NULL, NULL, 28194, 21),
(285611, NULL, 'SSF143631', NULL, NULL, NULL, NULL, 'ApbE-like', NULL, NULL, 4299, 21),
(285612, NULL, 'SSF54857', NULL, NULL, NULL, NULL, 'DNA damage-inducible protein DinI', NULL, NULL, 32424, 21),
(285613, NULL, 'SSF54368', NULL, NULL, NULL, NULL, 'Glutamine synthetase, N-terminal domain', NULL, NULL, 29706, 21),
(285614, NULL, 'SSF57561', NULL, NULL, NULL, NULL, 'Methylamine dehydrogenase, L chain', NULL, NULL, 33361, 21),
(285615, NULL, 'SSF63877', NULL, NULL, NULL, NULL, 'Methuselah ectodomain', NULL, NULL, 33246, 21),
(285616, NULL, 'SSF54452', NULL, NULL, NULL, NULL, 'MHC antigen-recognition domain', NULL, NULL, 12570, 21),
(285617, NULL, 'SSF56507', NULL, NULL, NULL, NULL, 'Methionine synthase activation domain-like', NULL, NULL, 28117, 21);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(285618, NULL, 'SSF160191', NULL, NULL, NULL, NULL, 'YcgL-like', NULL, NULL, 31307, 21),
(285619, NULL, 'SSF49562', NULL, NULL, NULL, NULL, 'C2 domain (Calcium/lipid-binding domain, CaLB)', NULL, NULL, 6539, 21),
(285620, NULL, 'SSF50156', NULL, NULL, NULL, NULL, 'PDZ domain-like', NULL, NULL, 27069, 21),
(285621, NULL, 'SSF69065', NULL, NULL, NULL, NULL, 'RNase III domain-like', NULL, NULL, 28487, 21),
(285622, NULL, 'SSF69979', NULL, NULL, NULL, NULL, 'Eea1 homodimerisation domain', NULL, NULL, NULL, 21),
(285623, NULL, 'SSF89550', NULL, NULL, NULL, NULL, 'PHP domain-like', NULL, NULL, 11916, 21),
(285624, NULL, 'SSF63570', NULL, NULL, NULL, NULL, 'PABC (PABP) domain', NULL, NULL, 32959, 21),
(285625, NULL, 'SSF158694', NULL, NULL, NULL, NULL, 'UraD-Like', NULL, NULL, 33401, 21),
(285626, NULL, 'SSF158710', NULL, NULL, NULL, NULL, 'PSPTO4464-like', NULL, NULL, 15654, 21),
(285627, NULL, 'SSF161008', NULL, NULL, NULL, NULL, 'Viral glycoprotein ectodomain-like', NULL, NULL, NULL, 21),
(285628, NULL, 'SSF89124', NULL, NULL, NULL, NULL, 'Nop domain', NULL, NULL, 27076, 21),
(285629, NULL, 'SSF56037', NULL, NULL, NULL, NULL, 'PheT/TilS domain', NULL, NULL, NULL, 21),
(285630, NULL, 'SSF55267', NULL, NULL, NULL, NULL, 'tRNA-intron endonuclease N-terminal domain-like', NULL, NULL, 31905, 21),
(285631, NULL, 'SSF52156', NULL, NULL, NULL, NULL, 'Initiation factor IF2/eIF5b, domain 3', NULL, NULL, 32562, 21),
(285632, NULL, 'SSF53300', NULL, NULL, NULL, NULL, 'vWA-like', NULL, NULL, 29607, 21),
(285633, NULL, 'SSF69125', NULL, NULL, NULL, NULL, 'Nuclear receptor coactivator interlocking domain', NULL, NULL, 7897, 21),
(285634, NULL, 'SSF49363', NULL, NULL, NULL, NULL, 'Purple acid phosphatase, N-terminal domain', NULL, NULL, 8674, 21),
(285635, NULL, 'SSF54495', NULL, NULL, NULL, NULL, 'UBC-like', NULL, NULL, 11093, 21),
(285636, NULL, 'SSF101322', NULL, NULL, NULL, NULL, 'YcfC-like', NULL, NULL, 29559, 21),
(285637, NULL, 'SSF57392', NULL, NULL, NULL, NULL, 'Defensin-like', NULL, NULL, NULL, 21),
(285638, NULL, 'SSF103239', NULL, NULL, NULL, NULL, 'MoaD-related protein, C-terminal domain', NULL, NULL, 31383, 21),
(285639, NULL, 'SSF54747', NULL, NULL, NULL, NULL, 'Ribosomal L11/L12e N-terminal domain', NULL, NULL, 33007, 21),
(285640, NULL, 'SSF160975', NULL, NULL, NULL, NULL, 'AF1531-like', NULL, NULL, NULL, 21),
(285641, NULL, 'SSF111418', NULL, NULL, NULL, NULL, 'Hormone receptor domain', NULL, NULL, 28290, 21),
(285642, NULL, 'SSF140383', NULL, NULL, NULL, NULL, 'BSD domain-like', NULL, NULL, 25941, 21),
(285643, NULL, 'SSF54427', NULL, NULL, NULL, NULL, 'NTF2-like', NULL, NULL, 26539, 21),
(285644, NULL, 'SSF55261', NULL, NULL, NULL, NULL, 'GAD domain-like', NULL, NULL, 1940, 21),
(285645, NULL, 'SSF141571', NULL, NULL, NULL, NULL, 'Pentapeptide repeat-like', NULL, NULL, NULL, 21),
(285646, NULL, 'SSF53098', NULL, NULL, NULL, NULL, 'Ribonuclease H-like', NULL, NULL, 7661, 21),
(285647, NULL, 'SSF48695', NULL, NULL, NULL, NULL, 'Multiheme cytochromes', NULL, NULL, 31551, 21),
(285648, NULL, 'SSF47220', NULL, NULL, NULL, NULL, 'alpha-catenin/vinculin-like', NULL, NULL, 31553, 21),
(285649, NULL, 'SSF58038', NULL, NULL, NULL, NULL, 'SNARE fusion complex', NULL, NULL, NULL, 21),
(285650, NULL, 'SSF140506', NULL, NULL, NULL, NULL, 'FHV B2 protein-like', NULL, NULL, 33275, 21),
(285651, NULL, 'SSF53041', NULL, NULL, NULL, NULL, 'Resolvase-like', NULL, NULL, 30253, 21),
(285652, NULL, 'SSF54626', NULL, NULL, NULL, NULL, 'Chalcone isomerase', NULL, NULL, 31034, 21),
(285653, NULL, 'SSF158622', NULL, NULL, NULL, NULL, 'YheA/YmcA-like', NULL, NULL, 15761, 21),
(285654, NULL, 'SSF50677', NULL, NULL, NULL, NULL, 'ValRS/IleRS/LeuRS editing domain', NULL, NULL, 9808, 21),
(285655, NULL, 'SSF51289', NULL, NULL, NULL, NULL, 'Tlp20, baculovirus telokin-like protein', NULL, NULL, 33370, 21),
(285656, NULL, 'SSF101751', NULL, NULL, NULL, NULL, 'Hydrophobin II, HfbII', NULL, NULL, 32380, 21),
(285657, NULL, 'SSF81273', NULL, NULL, NULL, NULL, 'H-NS histone-like proteins', NULL, NULL, NULL, 21),
(285658, NULL, 'SSF143517', NULL, NULL, NULL, NULL, 'TRCF domain-like', NULL, NULL, 29614, 21);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(285659, NULL, 'SSF89733', NULL, NULL, NULL, NULL, 'L-sulfolactate dehydrogenase-like', NULL, NULL, 32555, 21),
(285660, NULL, 'SSF47741', NULL, NULL, NULL, NULL, 'CO dehydrogenase ISP C-domain like', NULL, NULL, 28999, 21),
(285661, NULL, 'SSF117281', NULL, NULL, NULL, NULL, 'Kelch motif', NULL, NULL, 7126, 21),
(285662, NULL, 'SSF102324', NULL, NULL, NULL, NULL, 'F420-dependent methylenetetrahydromethanopterin dehydrogenase (MTD)', NULL, NULL, 32285, 21),
(285663, NULL, 'SSF56512', NULL, NULL, NULL, NULL, 'Nitric oxide (NO) synthase oxygenase domain', NULL, NULL, 33239, 21),
(285664, NULL, 'SSF144122', NULL, NULL, NULL, NULL, 'Tim10-like', NULL, NULL, 19215, 21),
(285665, NULL, 'SSF47095', NULL, NULL, NULL, NULL, 'HMG-box', NULL, NULL, 28964, 21),
(285666, NULL, 'SSF50960', NULL, NULL, NULL, NULL, 'TolB, C-terminal domain', NULL, NULL, NULL, 21),
(285667, NULL, 'SSF109859', NULL, NULL, NULL, NULL, 'NblA-like', NULL, NULL, 31987, 21),
(285668, NULL, 'SSF109728', NULL, NULL, NULL, NULL, 'Hypothetical protein AF0491, middle domain', NULL, NULL, 29878, 21),
(285669, NULL, 'SSF140959', NULL, NULL, NULL, NULL, 'Indolic compounds 2,3-dioxygenase-like', NULL, NULL, 33478, 21),
(285670, NULL, 'SSF63840', NULL, NULL, NULL, NULL, 'Ribonuclease domain of colicin E3', NULL, NULL, 32235, 21),
(285671, NULL, 'SSF101601', NULL, NULL, NULL, NULL, 'Smp-1-like', NULL, NULL, 31972, 21),
(285672, NULL, 'SSF51556', NULL, NULL, NULL, NULL, 'Metallo-dependent hydrolases', NULL, NULL, 7611, 21),
(285673, NULL, 'SSF103359', NULL, NULL, NULL, NULL, 'Suppressor of Fused, N-terminal domain', NULL, NULL, 31802, 21),
(285674, NULL, 'SSF160945', NULL, NULL, NULL, NULL, 'PH0156-like', NULL, NULL, NULL, 21),
(285675, NULL, 'SSF55856', NULL, NULL, NULL, NULL, 'Cytochrome b5-like heme/steroid binding domain', NULL, NULL, 31703, 21),
(285676, NULL, 'SSF116768', NULL, NULL, NULL, NULL, 'DNA-binding domain of EIN3-like', NULL, NULL, 15732, 21),
(285677, NULL, 'SSF81593', NULL, NULL, NULL, NULL, 'Nucleotidyltransferase substrate binding subunit/domain', NULL, NULL, NULL, 21),
(285678, NULL, 'SSF103501', NULL, NULL, NULL, NULL, 'Respiratory nitrate reductase 1 gamma chain', NULL, NULL, 29083, 21),
(285679, NULL, 'SSF58006', NULL, NULL, NULL, NULL, 'Assembly domain of cartilage oligomeric matrix protein', NULL, NULL, NULL, 21),
(285680, NULL, 'SSF144210', NULL, NULL, NULL, NULL, 'Nop10-like SnoRNP', NULL, NULL, 32064, 21),
(285681, NULL, 'SSF53092', NULL, NULL, NULL, NULL, 'Creatinase/prolidase N-terminal domain', NULL, NULL, 25711, 21),
(285682, NULL, 'SSF50814', NULL, NULL, NULL, NULL, 'Lipocalins', NULL, NULL, 12031, 21),
(285683, NULL, 'SSF50974', NULL, NULL, NULL, NULL, 'Nitrous oxide reductase, N-terminal domain', NULL, NULL, 9127, 21),
(285684, NULL, 'SSF103575', NULL, NULL, NULL, NULL, 'Plexin repeat', NULL, NULL, NULL, 21),
(285685, NULL, 'SSF47364', NULL, NULL, NULL, NULL, 'Domain of the SRP/SRP receptor G-proteins', NULL, NULL, 29817, 21),
(285686, NULL, 'SSF56047', NULL, NULL, NULL, NULL, 'Ribosomal protein S8', NULL, NULL, 31745, 21),
(285687, NULL, 'SSF53383', NULL, NULL, NULL, NULL, 'PLP-dependent transferases', NULL, NULL, 7269, 21),
(285688, NULL, 'SSF117066', NULL, NULL, NULL, NULL, 'Accessory protein X4 (ORF8, ORF7a)', NULL, NULL, 31377, 21),
(285689, NULL, 'SSF53822', NULL, NULL, NULL, NULL, 'Periplasmic binding protein-like I', NULL, NULL, 24795, 21),
(285690, NULL, 'SSF55979', NULL, NULL, NULL, NULL, 'DNA clamp', NULL, NULL, NULL, 21),
(285691, NULL, 'SSF53720', NULL, NULL, NULL, NULL, 'ALDH-like', NULL, NULL, 11923, 21),
(285692, NULL, 'SSF82808', NULL, NULL, NULL, NULL, 'Replication modulator SeqA, C-terminal DNA-binding domain', NULL, NULL, 27580, 21),
(285693, NULL, 'SSF142887', NULL, NULL, NULL, NULL, 'PhtA domain-like', NULL, NULL, 29020, 21),
(285694, NULL, 'SSF111126', NULL, NULL, NULL, NULL, 'Ligand-binding domain in the NO signalling and Golgi transport', NULL, NULL, 18997, 21),
(285695, NULL, 'SSF140486', NULL, NULL, NULL, NULL, 'PA2201 N-terminal domain-like', NULL, NULL, 23268, 21),
(285696, NULL, 'SSF143587', NULL, NULL, NULL, NULL, 'SARS receptor-binding domain-like', NULL, NULL, 28128, 21);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(285697, NULL, 'SSF81490', NULL, NULL, NULL, NULL, 'Photosystem II reaction centre subunit H, transmembrane region', NULL, NULL, NULL, 21),
(285698, NULL, 'SSF101447', NULL, NULL, NULL, NULL, 'Formin homology 2 domain (FH2 domain)', NULL, NULL, NULL, 21),
(285699, NULL, 'SSF54211', NULL, NULL, NULL, NULL, 'Ribosomal protein S5 domain 2-like', NULL, NULL, 18987, 21),
(285700, NULL, 'SSF143791', NULL, NULL, NULL, NULL, 'DUSP-like', NULL, NULL, 26596, 21),
(285701, NULL, 'SSF57552', NULL, NULL, NULL, NULL, 'Blood coagulation inhibitor (disintegrin)', NULL, NULL, 28176, 21),
(285702, NULL, 'SSF46565', NULL, NULL, NULL, NULL, 'Chaperone J-domain', NULL, NULL, 28329, 21),
(285703, NULL, 'SSF89095', NULL, NULL, NULL, NULL, 'GatB/YqeY motif', NULL, NULL, 4417, 21),
(285704, NULL, 'SSF140693', NULL, NULL, NULL, NULL, 'IpaD-like', NULL, NULL, 33501, 21),
(285705, NULL, 'SSF52768', NULL, NULL, NULL, NULL, 'Arginase/deacetylase', NULL, NULL, 11931, 21),
(285706, NULL, 'SSF142913', NULL, NULL, NULL, NULL, 'YktB/PF0168-like', NULL, NULL, NULL, 21),
(285707, NULL, 'SSF58108', NULL, NULL, NULL, NULL, 'Oligomerization domain of hepatitis delta antigen', NULL, NULL, 24522, 21),
(285708, NULL, 'SSF64546', NULL, NULL, NULL, NULL, 'Satiety factor CART (cocaine and amphetamine regulated transcript)', NULL, NULL, 32469, 21),
(285709, NULL, 'SSF58054', NULL, NULL, NULL, NULL, 'Tetrabrachion', NULL, NULL, 32905, 21),
(285710, NULL, 'SSF58069', NULL, NULL, NULL, NULL, 'Virus ectodomain', NULL, NULL, NULL, 21),
(285711, NULL, 'SSF101059', NULL, NULL, NULL, NULL, 'B-form DNA mimic Ocr', NULL, NULL, 31234, 21),
(285712, NULL, 'SSF75445', NULL, NULL, NULL, NULL, 'D-ribose-5-phosphate isomerase (RpiA), lid domain', NULL, NULL, NULL, 21),
(285713, NULL, 'SSF103637', NULL, NULL, NULL, NULL, 'CCHHC domain', NULL, NULL, 29370, 21),
(285714, NULL, 'SSF55064', NULL, NULL, NULL, NULL, 'Translational regulator protein regA', NULL, NULL, 30069, 21),
(285715, NULL, 'SSF158651', NULL, NULL, NULL, NULL, 'YejL-like', NULL, NULL, 17187, 21),
(285716, NULL, 'SSF49863', NULL, NULL, NULL, NULL, 'Hyaluronate lyase-like, C-terminal domain', NULL, NULL, 10220, 21),
(285717, NULL, 'SSF109854', NULL, NULL, NULL, NULL, 'DinB/YfiT-like putative metalloenzymes', NULL, NULL, 7249, 21),
(285718, NULL, 'SSF52743', NULL, NULL, NULL, NULL, 'Subtilisin-like', NULL, NULL, 31887, 21),
(285719, NULL, 'SSF47148', NULL, NULL, NULL, NULL, 'Diol dehydratase, gamma subunit', NULL, NULL, 32109, 21),
(285720, NULL, 'SSF110217', NULL, NULL, NULL, NULL, 'DNA-binding protein LAG-1 (CSL)', NULL, NULL, 31975, 21),
(285721, NULL, 'SSF88874', NULL, NULL, NULL, NULL, 'Receptor-binding domain of short tail fibre protein gp12', NULL, NULL, NULL, 21),
(285722, NULL, 'SSF57868', NULL, NULL, NULL, NULL, 'Metallothionein', NULL, NULL, 12823, 21),
(285723, NULL, 'SSF54277', NULL, NULL, NULL, NULL, 'CAD & PB1 domains', NULL, NULL, NULL, 21),
(285724, NULL, 'SSF48225', NULL, NULL, NULL, NULL, 'Seven-hairpin glycosidases', NULL, NULL, 27125, 21),
(285725, NULL, 'SSF74788', NULL, NULL, NULL, NULL, 'Cullin repeat-like', NULL, NULL, 11527, 21),
(285726, NULL, 'SSF89837', NULL, NULL, NULL, NULL, 'Doublecortin (DC)', NULL, NULL, 31052, 21),
(285727, NULL, 'SSF57429', NULL, NULL, NULL, NULL, 'Crambin-like', NULL, NULL, 28087, 21),
(285728, NULL, 'SSF50341', NULL, NULL, NULL, NULL, 'CheW-like', NULL, NULL, 29223, 21),
(285729, NULL, 'SSF56436', NULL, NULL, NULL, NULL, 'C-type lectin-like', NULL, NULL, 11772, 21),
(285730, NULL, 'SSF55869', NULL, NULL, NULL, NULL, 'DNA topoisomerase I domain', NULL, NULL, 20167, 21),
(285731, NULL, 'SSF161033', NULL, NULL, NULL, NULL, 'Photosystem II reaction center protein M, PsbM', NULL, NULL, 32771, 21),
(285732, NULL, 'SSF82704', NULL, NULL, NULL, NULL, 'AlbA-like', NULL, NULL, 28569, 21),
(285733, NULL, 'SSF50956', NULL, NULL, NULL, NULL, 'Thermostable phytase (3-phytase)', NULL, NULL, NULL, 21),
(285734, NULL, 'SSF50610', NULL, NULL, NULL, NULL, 'mu transposase, C-terminal domain', NULL, NULL, 9880, 21),
(285735, NULL, 'SSF48145', NULL, NULL, NULL, NULL, 'Influenza virus matrix protein M1', NULL, NULL, 30101, 21);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(285736, NULL, 'SSF63829', NULL, NULL, NULL, NULL, 'Calcium-dependent phosphotriesterase', NULL, NULL, NULL, 21),
(285737, NULL, 'SSF143856', NULL, NULL, NULL, NULL, 'DeoB insert domain-like', NULL, NULL, 12458, 21),
(285738, NULL, 'SSF143430', NULL, NULL, NULL, NULL, 'TTP0101/SSO1404-like', NULL, NULL, NULL, 21),
(285739, NULL, 'SSF103652', NULL, NULL, NULL, NULL, 'G protein-binding domain', NULL, NULL, NULL, 21),
(285740, NULL, 'SSF49590', NULL, NULL, NULL, NULL, 'PHL pollen allergen', NULL, NULL, 32492, 21),
(285741, NULL, 'SSF103460', NULL, NULL, NULL, NULL, 'Sec-beta subunit', NULL, NULL, NULL, 21),
(285742, NULL, 'SSF88659', NULL, NULL, NULL, NULL, 'Sigma3 and sigma4 domains of RNA polymerase sigma factors', NULL, NULL, 11014, 21),
(285743, NULL, 'SSF89963', NULL, NULL, NULL, NULL, 'YajQ-like', NULL, NULL, 33003, 21),
(285744, NULL, 'SSF49303', NULL, NULL, NULL, NULL, 'beta-Galactosidase/glucuronidase domain', NULL, NULL, 30587, 21),
(285745, NULL, 'SSF54849', NULL, NULL, NULL, NULL, 'GroEL-intermediate domain like', NULL, NULL, 24832, 21),
(285746, NULL, 'SSF50084', NULL, NULL, NULL, NULL, 'Myosin S1 fragment, N-terminal domain', NULL, NULL, NULL, 21),
(285747, NULL, 'SSF159042', NULL, NULL, NULL, NULL, 'Plus3-like', NULL, NULL, 33225, 21),
(285748, NULL, 'SSF81558', NULL, NULL, NULL, NULL, 'Photosystem I subunits PsaA/PsaB', NULL, NULL, 31547, 21),
(285749, NULL, 'SSF47072', NULL, NULL, NULL, NULL, 'Cysteine alpha-hairpin motif', NULL, NULL, 6283, 21),
(285750, NULL, 'SSF57567', NULL, NULL, NULL, NULL, 'Serine protease inhibitors', NULL, NULL, 32272, 21),
(285751, NULL, 'SSF55021', NULL, NULL, NULL, NULL, 'ACT-like', NULL, NULL, 36023, 21),
(285752, NULL, 'SSF101606', NULL, NULL, NULL, NULL, 'Superantigen (mitogen) Ypm', NULL, NULL, 31216, 21),
(285753, NULL, 'SSF81761', NULL, NULL, NULL, NULL, 'X-Prolyl dipeptidyl aminopeptidase PepX, N-terminal domain', NULL, NULL, 31864, 21),
(285754, NULL, 'SSF102735', NULL, NULL, NULL, NULL, 'Trigger factor ribosome-binding domain', NULL, NULL, 28438, 21),
(285755, NULL, 'SSF161070', NULL, NULL, NULL, NULL, 'SNF-like', NULL, NULL, 32748, 21),
(285756, NULL, 'SSF57917', NULL, NULL, NULL, NULL, 'Zn-binding domains of ADDBP', NULL, NULL, 33093, 21),
(285757, NULL, 'SSF101756', NULL, NULL, NULL, NULL, 'Hypothetical protein YgiW', NULL, NULL, 31971, 21),
(285758, NULL, 'SSF50621', NULL, NULL, NULL, NULL, 'Alanine racemase C-terminal domain-like', NULL, NULL, 9821, 21),
(285759, NULL, 'SSF144083', NULL, NULL, NULL, NULL, 'Magnesium transport protein CorA, transmembrane region', NULL, NULL, 33962, 21),
(285760, NULL, 'SSF55826', NULL, NULL, NULL, NULL, 'YbaK/ProRS associated domain', NULL, NULL, 32254, 21),
(285761, NULL, 'SSF55003', NULL, NULL, NULL, NULL, 'PAP/Archaeal CCA-adding enzyme, C-terminal domain', NULL, NULL, 10348, 21),
(285762, NULL, 'SSF161098', NULL, NULL, NULL, NULL, 'MetI-like', NULL, NULL, 13815, 21),
(285763, NULL, 'SSF103039', NULL, NULL, NULL, NULL, 'CheC-like', NULL, NULL, 24427, 21),
(285764, NULL, 'SSF55895', NULL, NULL, NULL, NULL, 'Ribonuclease Rh-like', NULL, NULL, 28071, 21),
(285765, NULL, 'SSF101307', NULL, NULL, NULL, NULL, 'YutG-like', NULL, NULL, 29668, 21),
(285766, NULL, 'SSF56548', NULL, NULL, NULL, NULL, 'Conserved core of transcriptional regulatory protein vp16', NULL, NULL, 33250, 21),
(285767, NULL, 'SSF49380', NULL, NULL, NULL, NULL, 'Diphtheria toxin, C-terminal domain', NULL, NULL, 33267, 21),
(285768, NULL, 'SSF54060', NULL, NULL, NULL, NULL, 'His-Me finger endonucleases', NULL, NULL, 35633, 21),
(285769, NULL, 'SSF55326', NULL, NULL, NULL, NULL, 'PurM N-terminal domain-like', NULL, NULL, 32923, 21),
(285770, NULL, 'SSF117396', NULL, NULL, NULL, NULL, 'TM1631-like', NULL, NULL, 32629, 21),
(285771, NULL, 'SSF102215', NULL, NULL, NULL, NULL, 'Creatininase', NULL, NULL, 12129, 21),
(285772, NULL, 'SSF160950', NULL, NULL, NULL, NULL, 'YacF-like', NULL, NULL, 33177, 21),
(285773, NULL, 'SSF50182', NULL, NULL, NULL, NULL, 'Sm-like ribonucleoproteins', NULL, NULL, 10175, 21),
(285774, NULL, 'SSF58022', NULL, NULL, NULL, NULL, 'XRCC4, C-terminal oligomerization domain', NULL, NULL, NULL, 21);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(285775, NULL, 'SSF63501', NULL, NULL, NULL, NULL, 'Frizzled cysteine-rich domain', NULL, NULL, 33386, 21),
(285776, NULL, 'SSF140581', NULL, NULL, NULL, NULL, 'TraM-like', NULL, NULL, NULL, 21),
(285777, NULL, 'SSF56864', NULL, NULL, NULL, NULL, 'Exotoxin A, middle domain', NULL, NULL, 31065, 21),
(285778, NULL, 'SSF81298', NULL, NULL, NULL, NULL, 'Adenylylcyclase toxin (the edema factor)', NULL, NULL, 8046, 21),
(285779, NULL, 'SSF69055', NULL, NULL, NULL, NULL, '1-deoxy-D-xylulose-5-phosphate reductoisomerase, C-terminal domain', NULL, NULL, 31545, 21),
(285780, NULL, 'SSF161084', NULL, NULL, NULL, NULL, 'MAPEG domain-like', NULL, NULL, 19055, 21),
(285781, NULL, 'SSF118310', NULL, NULL, NULL, NULL, 'AN1-like Zinc finger', NULL, NULL, 4883, 21),
(285782, NULL, 'SSF101801', NULL, NULL, NULL, NULL, 'Surface presentation of antigens (SPOA)', NULL, NULL, 28278, 21),
(285783, NULL, 'SSF117991', NULL, NULL, NULL, NULL, 'YbeD/HP0495-like', NULL, NULL, 24574, 21),
(285784, NULL, 'SSF144015', NULL, NULL, NULL, NULL, 'Peptidoglycan deacetylase N-terminal noncatalytic region', NULL, NULL, NULL, 21),
(285785, NULL, 'SSF49785', NULL, NULL, NULL, NULL, 'Galactose-binding domain-like', NULL, NULL, 9006, 21),
(285786, NULL, 'SSF47661', NULL, NULL, NULL, NULL, 't-snare proteins', NULL, NULL, 8028, 21),
(285787, NULL, 'SSF160448', NULL, NULL, NULL, NULL, 'PG1857-like', NULL, NULL, 33474, 21),
(285788, NULL, 'SSF53790', NULL, NULL, NULL, NULL, 'Tetrapyrrole methylase', NULL, NULL, 30394, 21),
(285789, NULL, 'SSF53163', NULL, NULL, NULL, NULL, 'HybD-like', NULL, NULL, 16213, 21),
(285790, NULL, 'SSF50203', NULL, NULL, NULL, NULL, 'Bacterial enterotoxins', NULL, NULL, 9899, 21),
(285791, NULL, 'SSF47323', NULL, NULL, NULL, NULL, 'Anticodon-binding domain of a subclass of class I aminoacyl-tRNA synthetases', NULL, NULL, 6320, 21),
(285792, NULL, 'SSF140984', NULL, NULL, NULL, NULL, 'PTPA-like', NULL, NULL, 33156, 21),
(285793, NULL, 'SSF89260', NULL, NULL, NULL, NULL, 'Collagen-binding domain', NULL, NULL, NULL, 21),
(285794, NULL, 'SSF141452', NULL, NULL, NULL, NULL, 'Hcp1-like', NULL, NULL, 28284, 21),
(285795, NULL, 'SSF56420', NULL, NULL, NULL, NULL, 'Peptide deformylase', NULL, NULL, 27933, 21),
(285796, NULL, 'SSF64005', NULL, NULL, NULL, NULL, 'Undecaprenyl diphosphate synthase', NULL, NULL, 27551, 21),
(285797, NULL, 'SSF64496', NULL, NULL, NULL, NULL, 'DNA-binding domain of intron-encoded endonucleases', NULL, NULL, NULL, 21),
(285798, NULL, 'SSF69922', NULL, NULL, NULL, NULL, 'Head and neck region of the ectodomain of NDV fusion glycoprotein', NULL, NULL, NULL, 21),
(285799, NULL, 'SSF47336', NULL, NULL, NULL, NULL, 'ACP-like', NULL, NULL, 33014, 21),
(285800, NULL, 'SSF55040', NULL, NULL, NULL, NULL, 'Molybdenum cofactor biosynthesis protein C, MoaC', NULL, NULL, 32817, 21),
(285801, NULL, 'SSF117070', NULL, NULL, NULL, NULL, 'LEA14-like', NULL, NULL, NULL, 21),
(285802, NULL, 'SSF101489', NULL, NULL, NULL, NULL, 'Eukaryotic initiation factor 4f subunit eIF4g, eIF4e-binding domain', NULL, NULL, 32944, 21),
(285803, NULL, 'SSF89155', NULL, NULL, NULL, NULL, 'TorD-like', NULL, NULL, 32007, 21),
(285804, NULL, 'SSF57642', NULL, NULL, NULL, NULL, 'Cholecystokinin A receptor, N-domain', NULL, NULL, NULL, 21),
(285805, NULL, 'SSF140924', NULL, NULL, NULL, NULL, 'Duffy binding domain-like', NULL, NULL, NULL, 21),
(285806, NULL, 'SSF109751', NULL, NULL, NULL, NULL, 'Alpha-hemoglobin stabilizing protein AHSP', NULL, NULL, 31426, 21),
(285807, NULL, 'SSF63882', NULL, NULL, NULL, NULL, 'MoeA N-terminal region -like', NULL, NULL, 33100, 21),
(285808, NULL, 'SSF47681', NULL, NULL, NULL, NULL, 'C-terminal domain of B transposition protein', NULL, NULL, 33015, 21),
(285809, NULL, 'SSF89872', NULL, NULL, NULL, NULL, 'Inhibitor of vertebrate lysozyme, Ivy', NULL, NULL, 31185, 21),
(285810, NULL, 'SSF51316', NULL, NULL, NULL, NULL, 'Mss4-like', NULL, NULL, 9215, 21),
(285811, NULL, 'SSF68906', NULL, NULL, NULL, NULL, 'SAP domain', NULL, NULL, 32600, 21),
(285812, NULL, 'SSF48300', NULL, NULL, NULL, NULL, 'Ribosomal protein L7/12, oligomerisation (N-terminal) domain', NULL, NULL, 28253, 21);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(285813, NULL, 'SSF57821', NULL, NULL, NULL, NULL, 'Hypothetical protein MTH1184', NULL, NULL, 31517, 21),
(285814, NULL, 'SSF101173', NULL, NULL, NULL, NULL, 'Docking domain B of the erythromycin polyketide synthase (DEBS)', NULL, NULL, 32000, 21),
(285815, NULL, 'SSF110019', NULL, NULL, NULL, NULL, 'ERO1-like', NULL, NULL, 31591, 21),
(285816, NULL, 'SSF111171', NULL, NULL, NULL, NULL, 'Rbstp2229 protein', NULL, NULL, 31786, 21),
(285817, NULL, 'SSF64167', NULL, NULL, NULL, NULL, 'SurE-like', NULL, NULL, 32898, 21),
(285818, NULL, 'SSF47655', NULL, NULL, NULL, NULL, 'STAT', NULL, NULL, 9427, 21),
(285819, NULL, 'SSF103486', NULL, NULL, NULL, NULL, 'V-type ATP synthase subunit C', NULL, NULL, 32430, 21),
(285820, NULL, 'SSF159275', NULL, NULL, NULL, NULL, 'PA1994-like', NULL, NULL, NULL, 21),
(285821, NULL, 'SSF68912', NULL, NULL, NULL, NULL, 'Rho N-terminal domain-like', NULL, NULL, 31768, 21),
(285822, NULL, 'SSF160459', NULL, NULL, NULL, NULL, 'BLRF2-like', NULL, NULL, NULL, 21),
(285823, NULL, 'SSF69103', NULL, NULL, NULL, NULL, 'Arp2/3 complex 16 kDa subunit ARPC5', NULL, NULL, 31789, 21),
(285824, NULL, 'SSF55973', NULL, NULL, NULL, NULL, 'S-adenosylmethionine synthetase', NULL, NULL, 16826, 21),
(285825, NULL, 'SSF46977', NULL, NULL, NULL, NULL, 'Succinate dehydrogenase/fumarate reductase flavoprotein C-terminal domain', NULL, NULL, 32990, 21),
(285826, NULL, 'SSF141300', NULL, NULL, NULL, NULL, 'GatD N-terminal domain-like', NULL, NULL, 29221, 21),
(285827, NULL, 'SSF55052', NULL, NULL, NULL, NULL, 'CheY-binding domain of CheA', NULL, NULL, 7329, 21),
(285828, NULL, 'SSF57933', NULL, NULL, NULL, NULL, 'TAZ domain', NULL, NULL, 20075, 21),
(285829, NULL, 'SSF48201', NULL, NULL, NULL, NULL, 'Uteroglobin-like', NULL, NULL, 19291, 21),
(285830, NULL, 'SSF50475', NULL, NULL, NULL, NULL, 'FMN-binding split barrel', NULL, NULL, NULL, 21),
(285831, NULL, 'SSF103263', NULL, NULL, NULL, NULL, 'Chorismate synthase, AroC', NULL, NULL, 10625, 21),
(285832, NULL, 'SSF109770', NULL, NULL, NULL, NULL, 'Nickel-containing superoxide dismutase, NiSOD', NULL, NULL, 31300, 21),
(285833, NULL, 'SSF143555', NULL, NULL, NULL, NULL, 'FwdE-like', NULL, NULL, NULL, 21),
(285834, NULL, 'SSF109640', NULL, NULL, NULL, NULL, 'KRAB domain (Kruppel-associated box)', NULL, NULL, 32989, 21),
(285835, NULL, 'SSF118104', NULL, NULL, NULL, NULL, 'RalF, C-terminal domain', NULL, NULL, 30744, 21),
(285836, NULL, 'SSF54334', NULL, NULL, NULL, NULL, 'Superantigen toxins, C-terminal domain', NULL, NULL, 10232, 21),
(285837, NULL, 'SSF49348', NULL, NULL, NULL, NULL, 'Clathrin adaptor appendage domain', NULL, NULL, 14343, 21),
(285838, NULL, 'SSF82153', NULL, NULL, NULL, NULL, 'FAS1 domain', NULL, NULL, 32325, 21),
(285839, NULL, 'SSF109843', NULL, NULL, NULL, NULL, 'CAPPD, an extracellular domain of amyloid beta A4 protein', NULL, NULL, 31619, 21),
(285840, NULL, 'SSF57662', NULL, NULL, NULL, NULL, 'Ferredoxin thioredoxin reductase (FTR), catalytic beta chain', NULL, NULL, 30999, 21),
(285841, NULL, 'SSF143800', NULL, NULL, NULL, NULL, 'L28p-like', NULL, NULL, 33339, 21),
(285842, NULL, 'SSF101233', NULL, NULL, NULL, NULL, 'PWI domain', NULL, NULL, 29753, 21),
(285843, NULL, 'SSF140914', NULL, NULL, NULL, NULL, 'PriB N-terminal domain-like', NULL, NULL, NULL, 21),
(285844, NULL, 'SSF51419', NULL, NULL, NULL, NULL, 'PLP-binding barrel', NULL, NULL, 24949, 21),
(285845, NULL, 'SSF88802', NULL, NULL, NULL, NULL, 'Pre-PUA domain', NULL, NULL, NULL, 21),
(285846, NULL, 'SSF54511', NULL, NULL, NULL, NULL, 'GFP-like', NULL, NULL, 9913, 21),
(285847, NULL, 'SSF52413', NULL, NULL, NULL, NULL, 'UDP-glucose/GDP-mannose dehydrogenase C-terminal domain', NULL, NULL, 29763, 21),
(285848, NULL, 'SSF53706', NULL, NULL, NULL, NULL, 'Formate dehydrogenase/DMSO reductase, domains 1-3', NULL, NULL, NULL, 21),
(285849, NULL, 'SSF158560', NULL, NULL, NULL, NULL, 'BH3980-like', NULL, NULL, NULL, 21),
(285850, NULL, 'SSF81469', NULL, NULL, NULL, NULL, 'Bacterial aa3 type cytochrome c oxidase subunit IV', NULL, NULL, 32021, 21),
(285851, NULL, 'SSF81536', NULL, NULL, NULL, NULL, 'Subunit III of photosystem I reaction centre, PsaF', NULL, NULL, 31124, 21);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(285852, NULL, 'SSF81330', NULL, NULL, NULL, NULL, 'Gated mechanosensitive channel', NULL, NULL, 27945, 21),
(285853, NULL, 'SSF160892', NULL, NULL, NULL, NULL, 'Phosphoprotein oligomerization domain-like', NULL, NULL, 33425, 21),
(285854, NULL, 'SSF110004', NULL, NULL, NULL, NULL, 'Glycolipid transfer protein, GLTP', NULL, NULL, 31477, 21),
(285855, NULL, 'SSF142823', NULL, NULL, NULL, NULL, 'ComB-like', NULL, NULL, 31568, 21),
(285856, NULL, 'SSF103196', NULL, NULL, NULL, NULL, 'Roadblock/LC7 domain', NULL, NULL, NULL, 21),
(285857, NULL, 'SSF158430', NULL, NULL, NULL, NULL, 'Bacillus cereus metalloprotein-like', NULL, NULL, NULL, 21),
(285858, NULL, 'SSF47391', NULL, NULL, NULL, NULL, 'Dimerization-anchoring domain of cAMP-dependent PK regulatory subunit', NULL, NULL, NULL, 21),
(285859, NULL, 'SSF109910', NULL, NULL, NULL, NULL, 'YgfY-like', NULL, NULL, 31719, 21),
(285860, NULL, 'SSF56271', NULL, NULL, NULL, NULL, 'Pyruvoyl-dependent histidine and arginine decarboxylases', NULL, NULL, 11498, 21),
(285861, NULL, 'SSF54909', NULL, NULL, NULL, NULL, 'Dimeric alpha+beta barrel', NULL, NULL, 8838, 21),
(285862, NULL, 'SSF56752', NULL, NULL, NULL, NULL, 'D-aminoacid aminotransferase-like PLP-dependent enzymes', NULL, NULL, 27080, 21),
(285863, NULL, 'SSF111069', NULL, NULL, NULL, NULL, 'Hypothetical protein yfbM', NULL, NULL, 11315, 21),
(285864, NULL, 'SSF64182', NULL, NULL, NULL, NULL, 'DHH phosphoesterases', NULL, NULL, 32004, 21),
(285865, NULL, 'SSF81783', NULL, NULL, NULL, NULL, 'C-terminal domain of DFF45/ICAD (DFF-C domain)', NULL, NULL, 22770, 21),
(285866, NULL, 'SSF82549', NULL, NULL, NULL, NULL, 'DAK1/DegV-like', NULL, NULL, NULL, 21),
(285867, NULL, 'SSF48576', NULL, NULL, NULL, NULL, 'Terpenoid synthases', NULL, NULL, 8666, 21),
(285868, NULL, 'SSF46785', NULL, NULL, NULL, NULL, '"Winged helix" DNA-binding domain', NULL, NULL, 28096, 21),
(285869, NULL, 'SSF158752', NULL, NULL, NULL, NULL, 'HP0242-like', NULL, NULL, 8926, 21),
(285870, NULL, 'SSF56276', NULL, NULL, NULL, NULL, 'S-adenosylmethionine decarboxylase', NULL, NULL, 10304, 21),
(285871, NULL, 'SSF140979', NULL, NULL, NULL, NULL, 'Topoisomerase V catalytic domain-like', NULL, NULL, 8457, 21),
(285872, NULL, 'SSF52025', NULL, NULL, NULL, NULL, 'PA domain', NULL, NULL, 37614, 21),
(285873, NULL, 'SSF50386', NULL, NULL, NULL, NULL, 'STI-like', NULL, NULL, 10373, 21),
(285874, NULL, 'SSF49584', NULL, NULL, NULL, NULL, 'Periplasmic chaperone C-domain', NULL, NULL, 31476, 21),
(285875, NULL, 'SSF110849', NULL, NULL, NULL, NULL, 'ParB/Sulfiredoxin', NULL, NULL, 32205, 21),
(285876, NULL, 'SSF57603', NULL, NULL, NULL, NULL, 'FnI-like domain', NULL, NULL, NULL, 21),
(285877, NULL, 'SSF52799', NULL, NULL, NULL, NULL, '(Phosphotyrosine protein) phosphatases II', NULL, NULL, 26687, 21),
(285878, NULL, 'SSF57243', NULL, NULL, NULL, NULL, 'Bromelain inhibitor VI (cysteine protease inhibitor)', NULL, NULL, 32983, 21),
(285879, NULL, 'SSF160683', NULL, NULL, NULL, NULL, 'YNR034W-A-like', NULL, NULL, 8399, 21),
(285880, NULL, 'SSF46585', NULL, NULL, NULL, NULL, 'HR1 repeat', NULL, NULL, 31596, 21),
(285881, NULL, 'SSF57362', NULL, NULL, NULL, NULL, 'BPTI-like', NULL, NULL, 28419, 21),
(285882, NULL, 'SSF48208', NULL, NULL, NULL, NULL, 'Six-hairpin glycosidases', NULL, NULL, 8936, 21),
(285883, NULL, 'SSF53187', NULL, NULL, NULL, NULL, 'Zn-dependent exopeptidases', NULL, NULL, NULL, 21),
(285884, NULL, 'SSF75553', NULL, NULL, NULL, NULL, 'Smc hinge domain', NULL, NULL, 31387, 21),
(285885, NULL, 'SSF68993', NULL, NULL, NULL, NULL, 'FAT domain of focal adhesion kinase', NULL, NULL, 33079, 21),
(285886, NULL, 'SSF140683', NULL, NULL, NULL, NULL, 'SP0561-like', NULL, NULL, 33313, 21),
(285887, NULL, 'SSF54447', NULL, NULL, NULL, NULL, 'ssDNA-binding transcriptional regulator domain', NULL, NULL, 12413, 21),
(285888, NULL, 'SSF160088', NULL, NULL, NULL, NULL, 'NRDP1 C-terminal domain-like', NULL, NULL, 32212, 21),
(285889, NULL, 'SSF140688', NULL, NULL, NULL, NULL, 'YfmB-like', NULL, NULL, 27797, 21),
(285890, NULL, 'SSF47729', NULL, NULL, NULL, NULL, 'IHF-like DNA-binding proteins', NULL, NULL, 8222, 21);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(285891, NULL, 'SSF103511', NULL, NULL, NULL, NULL, 'Chlorophyll a-b binding protein', NULL, NULL, NULL, 21),
(285892, NULL, 'SSF50022', NULL, NULL, NULL, NULL, 'ISP domain', NULL, NULL, 32919, 21),
(285893, NULL, 'SSF50809', NULL, NULL, NULL, NULL, 'XRCC4, N-terminal domain', NULL, NULL, 6470, 21),
(285894, NULL, 'SSF55282', NULL, NULL, NULL, NULL, 'RL5-like', NULL, NULL, 14958, 21),
(285895, NULL, 'SSF48452', NULL, NULL, NULL, NULL, 'TPR-like', NULL, NULL, 12923, 21),
(285896, NULL, 'SSF54423', NULL, NULL, NULL, NULL, 'DsbC/DsbG N-terminal domain-like', NULL, NULL, 6070, 21),
(285897, NULL, 'SSF53633', NULL, NULL, NULL, NULL, 'Carbamate kinase-like', NULL, NULL, 28286, 21),
(285898, NULL, 'SSF75712', NULL, NULL, NULL, NULL, 'Rad50 coiled-coil Zn hook', NULL, NULL, NULL, 21),
(285899, NULL, 'SSF140726', NULL, NULL, NULL, NULL, 'AF0941-like', NULL, NULL, 31617, 21),
(285900, NULL, 'SSF52129', NULL, NULL, NULL, NULL, 'Caspase-like', NULL, NULL, 24068, 21),
(285901, NULL, 'SSF58087', NULL, NULL, NULL, NULL, 'Variant surface glycoprotein (N-terminal domain)', NULL, NULL, NULL, 21),
(285902, NULL, 'SSF54913', NULL, NULL, NULL, NULL, 'GlnB-like', NULL, NULL, 13790, 21),
(285903, NULL, 'SSF101898', NULL, NULL, NULL, NULL, 'NHL repeat', NULL, NULL, NULL, 21),
(285904, NULL, 'SSF56199', NULL, NULL, NULL, NULL, 'Methenyltetrahydromethanopterin cyclohydrolase', NULL, NULL, NULL, 21),
(285905, NULL, 'SSF143011', NULL, NULL, NULL, NULL, 'RelE-like', NULL, NULL, 27470, 21),
(285906, NULL, 'SSF69705', NULL, NULL, NULL, NULL, 'Transcription factor NusA, N-terminal domain', NULL, NULL, 33139, 21),
(285907, NULL, 'SSF55890', NULL, NULL, NULL, NULL, 'Sporulation response regulatory protein Spo0B', NULL, NULL, 11959, 21),
(285908, NULL, 'SSF63451', NULL, NULL, NULL, NULL, 'LEM domain', NULL, NULL, 9005, 21),
(285909, NULL, 'SSF81767', NULL, NULL, NULL, NULL, 'Pre-protein crosslinking domain of SecA', NULL, NULL, 31671, 21),
(285910, NULL, 'SSF57903', NULL, NULL, NULL, NULL, 'FYVE/PHD zinc finger', NULL, NULL, 8817, 21),
(285911, NULL, 'SSF159779', NULL, NULL, NULL, NULL, 'CdCA1 repeat-like', NULL, NULL, NULL, 21),
(285912, NULL, 'SSF82171', NULL, NULL, NULL, NULL, 'DPP6 N-terminal domain-like', NULL, NULL, NULL, 21),
(285913, NULL, 'SSF48340', NULL, NULL, NULL, NULL, 'Interferon-induced guanylate-binding protein 1 (GBP1), C-terminal domain', NULL, NULL, 33415, 21),
(285914, NULL, 'SSF118208', NULL, NULL, NULL, NULL, 'Viral ssDNA binding protein', NULL, NULL, 20602, 21),
(285915, NULL, 'SSF140652', NULL, NULL, NULL, NULL, 'YozE-like', NULL, NULL, 33216, 21),
(285916, NULL, 'SSF56731', NULL, NULL, NULL, NULL, 'DNA primase core', NULL, NULL, NULL, 21),
(285917, NULL, 'SSF144059', NULL, NULL, NULL, NULL, 'ImpE-like', NULL, NULL, NULL, 21),
(285918, NULL, 'SSF49842', NULL, NULL, NULL, NULL, 'TNF-like', NULL, NULL, 9966, 21),
(285919, NULL, 'SSF101931', NULL, NULL, NULL, NULL, 'Pym (Within the bgcn gene intron protein, WIBG), N-terminal domain', NULL, NULL, 28091, 21),
(285920, NULL, 'SSF52172', NULL, NULL, NULL, NULL, 'CheY-like', NULL, NULL, 8535, 21),
(285921, NULL, 'SSF54575', NULL, NULL, NULL, NULL, 'Ribosomal protein L31e', NULL, NULL, 8892, 21),
(285922, NULL, 'SSF48317', NULL, NULL, NULL, NULL, 'Acid phosphatase/Vanadium-dependent haloperoxidase', NULL, NULL, 28212, 21),
(285923, NULL, 'SSF47757', NULL, NULL, NULL, NULL, 'Chemotaxis receptor methyltransferase CheR, N-terminal domain', NULL, NULL, NULL, 21),
(285924, NULL, 'SSF49452', NULL, NULL, NULL, NULL, 'Starch-binding domain-like', NULL, NULL, 11249, 21),
(285925, NULL, 'SSF140736', NULL, NULL, NULL, NULL, 'Rv1873-like', NULL, NULL, 31561, 21),
(285926, NULL, 'SSF48150', NULL, NULL, NULL, NULL, 'DNA-glycosylase', NULL, NULL, 8933, 21),
(285927, NULL, 'SSF101874', NULL, NULL, NULL, NULL, 'YceI-like', NULL, NULL, 32091, 21),
(285928, NULL, 'SSF49764', NULL, NULL, NULL, NULL, 'HSP20-like chaperones', NULL, NULL, 9356, 21),
(285929, NULL, 'SSF90193', NULL, NULL, NULL, NULL, 'Notch domain', NULL, NULL, 14971, 21),
(285930, NULL, 'SSF57414', NULL, NULL, NULL, NULL, 'Hairpin loop containing domain-like', NULL, NULL, NULL, 21); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(285931, NULL, 'SSF48403', NULL, NULL, NULL, NULL, 'Ankyrin repeat', NULL, NULL, 33123, 21),
(285932, NULL, 'SSF109925', NULL, NULL, NULL, NULL, 'Lissencephaly-1 protein (Lis-1, PAF-AH alpha) N-terminal domain', NULL, NULL, 31505, 21),
(285933, NULL, 'SSF160996', NULL, NULL, NULL, NULL, 'HI0933 insert domain-like', NULL, NULL, NULL, 21),
(285934, NULL, 'SSF51096', NULL, NULL, NULL, NULL, 'delta-Endotoxin (insectocide), middle domain', NULL, NULL, 31712, 21),
(285935, NULL, 'SSF140459', NULL, NULL, NULL, NULL, 'PE/PPE dimer-like', NULL, NULL, NULL, 21),
(285936, NULL, 'SSF48065', NULL, NULL, NULL, NULL, 'DBL homology domain (DH-domain)', NULL, NULL, 20821, 21),
(285937, NULL, 'SSF55112', NULL, NULL, NULL, NULL, 'Formylmethanofuran:tetrahydromethanopterin formyltransferase', NULL, NULL, 16409, 21),
(285938, NULL, 'SSF158414', NULL, NULL, NULL, NULL, 'HP0062-like', NULL, NULL, 21843, 21),
(285939, NULL, 'SSF54076', NULL, NULL, NULL, NULL, 'RNase A-like', NULL, NULL, 27543, 21),
(285940, NULL, 'SSF58026', NULL, NULL, NULL, NULL, 'Delta-sleep-inducing peptide immunoreactive peptide', NULL, NULL, NULL, 21),
(285941, NULL, 'SSF75217', NULL, NULL, NULL, NULL, 'alpha/beta knot', NULL, NULL, 26857, 21),
(285942, NULL, 'SSF58002', NULL, NULL, NULL, NULL, 'Chicken cartilage matrix protein', NULL, NULL, 28310, 21),
(285943, NULL, 'SSF81473', NULL, NULL, NULL, NULL, 'Bacterial ba3 type cytochrome c oxidase subunit IIa', NULL, NULL, 31729, 21),
(285944, NULL, 'SSF55083', NULL, NULL, NULL, NULL, '6-hydroxymethyl-7,8-dihydropterin pyrophosphokinase, HPPK', NULL, NULL, 10878, 21),
(285945, NULL, 'SSF81382', NULL, NULL, NULL, NULL, 'Skp1 dimerisation domain-like', NULL, NULL, 31247, 21),
(285946, NULL, 'SSF111331', NULL, NULL, NULL, NULL, 'NAD kinase/diacylglycerol kinase-like', NULL, NULL, 10368, 21),
(285947, NULL, 'SSF53056', NULL, NULL, NULL, NULL, 'beta-carbonic anhydrase, cab', NULL, NULL, 28036, 21),
(285948, NULL, 'SSF49493', NULL, NULL, NULL, NULL, 'HSP40/DnaJ peptide-binding domain', NULL, NULL, 9258, 21),
(285949, NULL, 'SSF57997', NULL, NULL, NULL, NULL, 'Tropomyosin', NULL, NULL, NULL, 21),
(285950, NULL, 'SSF144052', NULL, NULL, NULL, NULL, 'Thermophilic metalloprotease-like', NULL, NULL, NULL, 21),
(285951, NULL, 'SSF56053', NULL, NULL, NULL, NULL, 'Ribosomal protein L6', NULL, NULL, 33163, 21),
(285952, NULL, 'SSF158388', NULL, NULL, NULL, NULL, 'YvfG-like', NULL, NULL, 31710, 21),
(285953, NULL, 'SSF111479', NULL, NULL, NULL, NULL, 'Fzo-like conserved region', NULL, NULL, NULL, 21),
(285954, NULL, 'SSF69322', NULL, NULL, NULL, NULL, 'Tricorn protease domain 2', NULL, NULL, NULL, 21),
(285955, NULL, 'SSF103451', NULL, NULL, NULL, NULL, 'PetN subunit of the cytochrome b6f complex', NULL, NULL, 28604, 21),
(285956, NULL, 'SSF143120', NULL, NULL, NULL, NULL, 'YefM-like', NULL, NULL, 30387, 21),
(285957, NULL, 'SSF81811', NULL, NULL, NULL, NULL, 'Helical domain of Sec23/24', NULL, NULL, 32520, 21),
(285958, NULL, 'SSF69848', NULL, NULL, NULL, NULL, 'LCCL domain', NULL, NULL, 30099, 21),
(285959, NULL, 'SSF109885', NULL, NULL, NULL, NULL, 'I/LWEQ domain', NULL, NULL, 29658, 21),
(285960, NULL, 'SSF49830', NULL, NULL, NULL, NULL, 'ENV polyprotein, receptor-binding domain', NULL, NULL, 9391, 21),
(285961, NULL, 'SSF140560', NULL, NULL, NULL, NULL, 'TM0693-like', NULL, NULL, 30810, 21),
(285962, NULL, 'SSF81935', NULL, NULL, NULL, NULL, 'N-terminal domain of bifunctional PutA protein', NULL, NULL, 9832, 21),
(285963, NULL, 'SSF158634', NULL, NULL, NULL, NULL, 'RPA2825-like', NULL, NULL, NULL, 21),
(285964, NULL, 'SSF81878', NULL, NULL, NULL, NULL, 'BRCA2 tower domain', NULL, NULL, NULL, 21),
(285965, NULL, 'SSF111369', NULL, NULL, NULL, NULL, 'HlyD-like secretion proteins', NULL, NULL, NULL, 21),
(285966, NULL, 'SSF69075', NULL, NULL, NULL, NULL, 'Glutamyl tRNA-reductase dimerization domain', NULL, NULL, 31578, 21),
(285967, NULL, 'SSF81540', NULL, NULL, NULL, NULL, 'Subunit VIII of photosystem I reaction centre, PsaI', NULL, NULL, 32860, 21),
(285968, NULL, 'SSF109993', NULL, NULL, NULL, NULL, 'VPS9 domain', NULL, NULL, 31952, 21);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(285969, NULL, 'SSF118196', NULL, NULL, NULL, NULL, 'YaeB-like', NULL, NULL, 33205, 21),
(285970, NULL, 'SSF53167', NULL, NULL, NULL, NULL, 'Purine and uridine phosphorylases', NULL, NULL, 16321, 21),
(285971, NULL, 'SSF140361', NULL, NULL, NULL, NULL, 'MIT domain-like', NULL, NULL, NULL, 21),
(285972, NULL, 'SSF58030', NULL, NULL, NULL, NULL, 'Rotavirus nonstructural proteins', NULL, NULL, NULL, 21),
(285973, NULL, 'SSF51713', NULL, NULL, NULL, NULL, 'tRNA-guanine transglycosylase', NULL, NULL, 30208, 21),
(285974, NULL, 'SSF144246', NULL, NULL, NULL, NULL, 'Coronavirus NSP10-like', NULL, NULL, 28319, 21),
(285975, NULL, 'SSF56327', NULL, NULL, NULL, NULL, 'LDH C-terminal domain-like', NULL, NULL, 8107, 21),
(285976, NULL, 'SSF159902', NULL, NULL, NULL, NULL, 'PH1570-like', NULL, NULL, NULL, 21),
(285977, NULL, 'SSF55159', NULL, NULL, NULL, NULL, 'eIF1-like', NULL, NULL, 28237, 21),
(285978, NULL, 'SSF140731', NULL, NULL, NULL, NULL, 'PA2201 C-terminal domain-like', NULL, NULL, 26562, 21),
(285979, NULL, 'SSF158911', NULL, NULL, NULL, NULL, 'NEAT domain-like', NULL, NULL, 28911, 21),
(285980, NULL, 'SSF49498', NULL, NULL, NULL, NULL, 'alpha-Amylase inhibitor tendamistat', NULL, NULL, 32123, 21),
(285981, NULL, 'SSF57095', NULL, NULL, NULL, NULL, 'Scorpion toxin-like', NULL, NULL, 31179, 21),
(285982, NULL, 'SSF158436', NULL, NULL, NULL, NULL, 'Ta0600-like', NULL, NULL, NULL, 21),
(285983, NULL, 'SSF160207', NULL, NULL, NULL, NULL, 'NMB0488-like', NULL, NULL, 32376, 21),
(285984, NULL, 'SSF90234', NULL, NULL, NULL, NULL, 'Zinc finger domain of DNA polymerase-alpha', NULL, NULL, NULL, 21),
(285985, NULL, 'SSF101344', NULL, NULL, NULL, NULL, 'Superantigen MAM', NULL, NULL, 27789, 21),
(285986, NULL, 'SSF144256', NULL, NULL, NULL, NULL, 'TSP9-like', NULL, NULL, 31942, 21),
(285987, NULL, 'SSF111283', NULL, NULL, NULL, NULL, 'Putative modulator of DNA gyrase, PmbA/TldD', NULL, NULL, 29162, 21),
(285988, NULL, 'SSF75138', NULL, NULL, NULL, NULL, 'HprK N-terminal domain-like', NULL, NULL, 24127, 21),
(285989, NULL, 'SSF143995', NULL, NULL, NULL, NULL, 'AF2331-like', NULL, NULL, 27801, 21),
(285990, NULL, 'SSF50118', NULL, NULL, NULL, NULL, 'Cell growth inhibitor/plasmid maintenance toxic component', NULL, NULL, NULL, 21),
(285991, NULL, 'SSF57016', NULL, NULL, NULL, NULL, 'Plant lectins/antimicrobial peptides', NULL, NULL, 28114, 21),
(285992, NULL, 'SSF54236', NULL, NULL, NULL, NULL, 'Ubiquitin-like', NULL, NULL, 26702, 21),
(285993, NULL, 'SSF81342', NULL, NULL, NULL, NULL, 'Transmembrane di-heme cytochromes', NULL, NULL, 7324, 21),
(285994, NULL, 'SSF54585', NULL, NULL, NULL, NULL, 'Cdc48 domain 2-like', NULL, NULL, 24576, 21),
(285995, NULL, 'SSF102705', NULL, NULL, NULL, NULL, 'NIF3 (NGG1p interacting factor 3)-like', NULL, NULL, 27310, 21),
(285996, NULL, 'SSF51351', NULL, NULL, NULL, NULL, 'Triosephosphate isomerase (TIM)', NULL, NULL, 19031, 21),
(285997, NULL, 'SSF56596', NULL, NULL, NULL, NULL, 'Replication terminator protein (Tus)', NULL, NULL, 32282, 21),
(285998, NULL, 'SSF141739', NULL, NULL, NULL, NULL, 'MFPT repeat-like', NULL, NULL, NULL, 21),
(285999, NULL, 'SSF49870', NULL, NULL, NULL, NULL, 'Osmotin, thaumatin-like protein', NULL, NULL, 33232, 21),
(286000, NULL, 'SSF57011', NULL, NULL, NULL, NULL, 'Neurotoxin B-IV', NULL, NULL, 32481, 21),
(286001, NULL, 'SSF57296', NULL, NULL, NULL, NULL, 'Amb V allergen', NULL, NULL, 31907, 21),
(286002, NULL, 'SSF82829', NULL, NULL, NULL, NULL, 'MesJ substrate recognition domain-like', NULL, NULL, NULL, 21),
(286003, NULL, 'SSF48508', NULL, NULL, NULL, NULL, 'Nuclear receptor ligand-binding domain', NULL, NULL, 29864, 21),
(286004, NULL, 'SSF81431', NULL, NULL, NULL, NULL, 'Mitochondrial cytochrome c oxidase subunit VIIIb (aka IX)', NULL, NULL, 33254, 21),
(286005, NULL, 'SSF57288', NULL, NULL, NULL, NULL, 'Midkine', NULL, NULL, 16275, 21),
(286006, NULL, 'SSF55455', NULL, NULL, NULL, NULL, 'SRF-like', NULL, NULL, 28178, 21),
(286007, NULL, 'SSF81321', NULL, NULL, NULL, NULL, 'Family A G protein-coupled receptor-like', NULL, NULL, NULL, 21);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(286008, NULL, 'SSF161077', NULL, NULL, NULL, NULL, 'Photosystem II antenna protein-like', NULL, NULL, 30418, 21),
(286009, NULL, 'SSF88633', NULL, NULL, NULL, NULL, 'Positive stranded ssRNA viruses', NULL, NULL, NULL, 21),
(286010, NULL, 'SSF56176', NULL, NULL, NULL, NULL, 'FAD-binding/transporter-associated domain-like', NULL, NULL, 31036, 21),
(286011, NULL, 'SSF82895', NULL, NULL, NULL, NULL, 'TSP-1 type 1 repeat', NULL, NULL, 32452, 21),
(286012, NULL, 'SSF143410', NULL, NULL, NULL, NULL, 'DOPA-like', NULL, NULL, 16776, 21),
(286013, NULL, 'SSF143456', NULL, NULL, NULL, NULL, 'VC0467-like', NULL, NULL, NULL, 21),
(286014, NULL, 'SSF47014', NULL, NULL, NULL, NULL, 'Protozoan pheromone proteins', NULL, NULL, 28473, 21),
(286015, NULL, 'SSF55056', NULL, NULL, NULL, NULL, 'Killer toxin KP6 alpha-subunit', NULL, NULL, NULL, 21),
(286016, NULL, 'SSF118215', NULL, NULL, NULL, NULL, 'Proton glutamate symport protein', NULL, NULL, 28161, 21),
(286017, NULL, 'SSF50723', NULL, NULL, NULL, NULL, 'Core binding factor beta, CBF', NULL, NULL, 33372, 21),
(286018, NULL, 'SSF55229', NULL, NULL, NULL, NULL, 'Cell division protein MinE topological specificity domain', NULL, NULL, 31584, 21),
(286019, NULL, 'SSF141318', NULL, NULL, NULL, NULL, 'TM0957-like', NULL, NULL, 29845, 21),
(286020, NULL, 'SSF51645', NULL, NULL, NULL, NULL, 'Malate synthase G', NULL, NULL, 10729, 21),
(286021, NULL, 'SSF69645', NULL, NULL, NULL, NULL, 'Arp2/3 complex subunits', NULL, NULL, 18765, 21),
(286022, NULL, 'SSF55671', NULL, NULL, NULL, NULL, 'Regulatory factor Nef', NULL, NULL, 24125, 21),
(286023, NULL, 'SSF47082', NULL, NULL, NULL, NULL, 'Fertilization protein', NULL, NULL, 12715, 21),
(286024, NULL, 'SSF82931', NULL, NULL, NULL, NULL, 'Tumor suppressor gene product Apc', NULL, NULL, 24655, 21),
(286025, NULL, 'SSF142338', NULL, NULL, NULL, NULL, 'CofD-like', NULL, NULL, 32043, 21),
(286026, NULL, 'SSF75632', NULL, NULL, NULL, NULL, 'Cullin homology domain', NULL, NULL, 31425, 21),
(286027, NULL, 'SSF100920', NULL, NULL, NULL, NULL, 'Heat shock protein 70kD (HSP70), peptide-binding domain', NULL, NULL, 25744, 21),
(286028, NULL, 'SSF51081', NULL, NULL, NULL, NULL, 'Bacteriochlorophyll A protein', NULL, NULL, 33314, 21),
(286029, NULL, 'SSF81411', NULL, NULL, NULL, NULL, 'Mitochondrial cytochrome c oxidase subunit VIa', NULL, NULL, 27704, 21),
(286030, NULL, 'SSF46600', NULL, NULL, NULL, NULL, 'C-terminal UvrC-binding domain of UvrB', NULL, NULL, 28357, 21),
(286031, NULL, 'SSF116942', NULL, NULL, NULL, NULL, 'RNA-binding protein She2p', NULL, NULL, 27698, 21),
(286032, NULL, 'SSF159713', NULL, NULL, NULL, NULL, 'Dhaf3308-like', NULL, NULL, NULL, 21),
(286033, NULL, 'SSF52091', NULL, NULL, NULL, NULL, 'SpoIIaa-like', NULL, NULL, 30454, 21),
(286034, NULL, 'SSF141493', NULL, NULL, NULL, NULL, 'Allene oxide cyclase-like', NULL, NULL, 31193, 21),
(286035, NULL, 'SSF56845', NULL, NULL, NULL, NULL, 'Diphtheria toxin, middle domain', NULL, NULL, 33471, 21),
(286036, NULL, 'SSF159774', NULL, NULL, NULL, NULL, 'YerB-like', NULL, NULL, 16639, 21),
(286037, NULL, 'SSF110296', NULL, NULL, NULL, NULL, 'Oligoxyloglucan reducing end-specific cellobiohydrolase', NULL, NULL, NULL, 21),
(286038, NULL, 'SSF109736', NULL, NULL, NULL, NULL, 'FGAM synthase PurL, linker domain', NULL, NULL, NULL, 21),
(286039, NULL, 'SSF52206', NULL, NULL, NULL, NULL, 'Hypothetical protein MTH538', NULL, NULL, 31332, 21),
(286040, NULL, 'SSF81986', NULL, NULL, NULL, NULL, 'Tp47 lipoprotein, middle and C-terminal domains', NULL, NULL, 33008, 21),
(286041, NULL, 'SSF82004', NULL, NULL, NULL, NULL, 'N-utilization substance G protein NusG, insert domain', NULL, NULL, NULL, 21),
(286042, NULL, 'SSF81271', NULL, NULL, NULL, NULL, 'TGS-like', NULL, NULL, 12041, 21),
(286043, NULL, 'SSF101960', NULL, NULL, NULL, NULL, 'Stabilizer of iron transporter SufD', NULL, NULL, 30570, 21),
(286044, NULL, 'SSF48097', NULL, NULL, NULL, NULL, 'Regulator of G-protein signaling, RGS', NULL, NULL, 31137, 21),
(286045, NULL, 'SSF101399', NULL, NULL, NULL, NULL, 'P40 nucleoprotein', NULL, NULL, 29837, 21);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(286046, NULL, 'SSF49758', NULL, NULL, NULL, NULL, 'Calpain large subunit, middle domain (domain III)', NULL, NULL, 32937, 21),
(286047, NULL, 'SSF81483', NULL, NULL, NULL, NULL, 'Bacterial photosystem II reaction centre, L and M subunits', NULL, NULL, 31567, 21),
(286048, NULL, 'SSF144284', NULL, NULL, NULL, NULL, 'Sec2 N-terminal region', NULL, NULL, NULL, 21),
(286049, NULL, 'SSF103623', NULL, NULL, NULL, NULL, 'Hypothetical protein Ta0289 C-terminal domain', NULL, NULL, 31949, 21),
(286050, NULL, 'SSF143597', NULL, NULL, NULL, NULL, 'YojJ-like', NULL, NULL, 28918, 21),
(286051, NULL, 'SSF81464', NULL, NULL, NULL, NULL, 'Cytochrome c oxidase subunit II-like, transmembrane region', NULL, NULL, 29468, 21),
(286052, NULL, 'SSF143503', NULL, NULL, NULL, NULL, 'PUG domain-like', NULL, NULL, 28297, 21),
(286053, NULL, 'SSF159127', NULL, NULL, NULL, NULL, 'HupF/HypC-like', NULL, NULL, NULL, 21),
(286054, NULL, 'SSF159270', NULL, NULL, NULL, NULL, 'YmcC-like', NULL, NULL, 15781, 21),
(286055, NULL, 'SSF74731', NULL, NULL, NULL, NULL, 'Ribosomal protein L20', NULL, NULL, 27528, 21),
(286056, NULL, 'SSF54593', NULL, NULL, NULL, NULL, 'Glyoxalase/Bleomycin resistance protein/Dihydroxybiphenyl dioxygenase', NULL, NULL, 24585, 21),
(286057, NULL, 'SSF143021', NULL, NULL, NULL, NULL, 'Ns1 effector domain-like', NULL, NULL, 29950, 21),
(286058, NULL, 'SSF111249', NULL, NULL, NULL, NULL, 'Sulfolobus fructose-1,6-bisphosphatase-like', NULL, NULL, 32093, 21),
(286059, NULL, 'SSF75098', NULL, NULL, NULL, NULL, 'Monomethylamine methyltransferase MtmB', NULL, NULL, 29615, 21),
(286060, NULL, 'SSF102848', NULL, NULL, NULL, NULL, 'NSFL1 (p97 ATPase) cofactor p47, SEP domain', NULL, NULL, 29736, 21),
(286061, NULL, 'SSF143985', NULL, NULL, NULL, NULL, 'L,D-transpeptidase pre-catalytic domain-like', NULL, NULL, 32315, 21),
(286062, NULL, 'SSF161187', NULL, NULL, NULL, NULL, 'YfgJ-like', NULL, NULL, NULL, 21),
(286063, NULL, 'SSF47212', NULL, NULL, NULL, NULL, 'FKBP12-rapamycin-binding domain of FKBP-rapamycin-associated protein (FRAP)', NULL, NULL, 33218, 21),
(286064, NULL, 'SSF111006', NULL, NULL, NULL, NULL, 'Dystroglycan, domain 2', NULL, NULL, 23588, 21),
(286065, NULL, 'SSF160909', NULL, NULL, NULL, NULL, 'ATP12-like', NULL, NULL, NULL, 21),
(286066, NULL, 'SSF140490', NULL, NULL, NULL, NULL, 'Nqo1C-terminal domain-like', NULL, NULL, 33164, 21),
(286067, NULL, 'SSF63965', NULL, NULL, NULL, NULL, 'Precorrin-8X methylmutase CbiC/CobH', NULL, NULL, 32998, 21),
(286068, NULL, 'SSF140718', NULL, NULL, NULL, NULL, 'Mediator hinge subcomplex-like', NULL, NULL, 27566, 21),
(286069, NULL, 'SSF103145', NULL, NULL, NULL, NULL, 'Tombusvirus P19 core protein, VP19', NULL, NULL, 33152, 21),
(286070, NULL, 'SSF55831', NULL, NULL, NULL, NULL, 'Thymidylate synthase/dCMP hydroxymethylase', NULL, NULL, 32684, 21),
(286071, NULL, 'SSF69025', NULL, NULL, NULL, NULL, 'Hypothetical protein MTH865', NULL, NULL, 27745, 21),
(286072, NULL, 'SSF69318', NULL, NULL, NULL, NULL, 'Integrin alpha N-terminal domain', NULL, NULL, 23792, 21),
(286073, NULL, 'SSF57262', NULL, NULL, NULL, NULL, 'Leech antihemostatic proteins', NULL, NULL, 9164, 21),
(286074, NULL, 'SSF140657', NULL, NULL, NULL, NULL, 'Hyaluronidase post-catalytic domain-like', NULL, NULL, NULL, 21),
(286075, NULL, 'SSF64586', NULL, NULL, NULL, NULL, 'C-terminal domain of ProRS', NULL, NULL, 18695, 21),
(286076, NULL, 'SSF89623', NULL, NULL, NULL, NULL, 'Ribose/Galactose isomerase RpiB/AlsB', NULL, NULL, 31256, 21),
(286077, NULL, 'SSF51055', NULL, NULL, NULL, NULL, 'Carbohydrate binding domain', NULL, NULL, 31328, 21),
(286078, NULL, 'SSF117143', NULL, NULL, NULL, NULL, 'Flagellar hook protein flgE', NULL, NULL, 32356, 21),
(286079, NULL, 'SSF161234', NULL, NULL, NULL, NULL, 'E7 C-terminal domain-like', NULL, NULL, NULL, 21),
(286080, NULL, 'SSF161148', NULL, NULL, NULL, NULL, 'VhTI-like', NULL, NULL, NULL, 21),
(286081, NULL, 'SSF49373', NULL, NULL, NULL, NULL, 'Invasin/intimin cell-adhesion fragments', NULL, NULL, 8582, 21),
(286082, NULL, 'SSF55637', NULL, NULL, NULL, NULL, 'Cell cycle regulatory proteins', NULL, NULL, 28174, 21);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(286083, NULL, 'SSF109920', NULL, NULL, NULL, NULL, 'Hypothetical protein At3g22680', NULL, NULL, 27960, 21),
(286084, NULL, 'SSF81518', NULL, NULL, NULL, NULL, 'Subunit XI (6.4 kDa protein) of cytochrome bc1 complex (Ubiquinol-cytochrome c reductase)', NULL, NULL, 21618, 21),
(286085, NULL, 'SSF55481', NULL, NULL, NULL, NULL, 'N-terminal domain of eukaryotic peptide chain release factor subunit 1, ERF1', NULL, NULL, 9254, 21),
(286086, NULL, 'SSF158504', NULL, NULL, NULL, NULL, 'BH2638-like', NULL, NULL, 15586, 21),
(286087, NULL, 'SSF64158', NULL, NULL, NULL, NULL, '2,3-Bisphosphoglycerate-independent phosphoglycerate mutase, substrate-binding domain', NULL, NULL, 29508, 21),
(286088, NULL, 'SSF47954', NULL, NULL, NULL, NULL, 'Cyclin-like', NULL, NULL, 28522, 21),
(286089, NULL, 'SSF81710', NULL, NULL, NULL, NULL, 'Plasmid maintenance system epsilon/zeta, antidote epsilon subunit', NULL, NULL, 27939, 21),
(286090, NULL, 'SSF82754', NULL, NULL, NULL, NULL, 'C-terminal, gelsolin-like domain of Sec23/24', NULL, NULL, 33413, 21),
(286091, NULL, 'SSF69687', NULL, NULL, NULL, NULL, 'Integrin beta tail domain', NULL, NULL, 27680, 21),
(286092, NULL, 'SSF89919', NULL, NULL, NULL, NULL, 'Ribosome-binding factor A, RbfA', NULL, NULL, 17981, 21),
(286093, NULL, 'SSF47686', NULL, NULL, NULL, NULL, 'Anaphylotoxins (complement system)', NULL, NULL, 20639, 21),
(286094, NULL, 'SSF50715', NULL, NULL, NULL, NULL, 'Ribosomal protein L25-like', NULL, NULL, 9116, 21),
(286095, NULL, 'SSF90257', NULL, NULL, NULL, NULL, 'Myosin rod fragments', NULL, NULL, NULL, 21),
(286096, NULL, 'SSF52016', NULL, NULL, NULL, NULL, 'LeuD/IlvD-like', NULL, NULL, NULL, 21),
(286097, NULL, 'SSF74924', NULL, NULL, NULL, NULL, 'Cap-Gly domain', NULL, NULL, 28322, 21),
(286098, NULL, 'SSF50685', NULL, NULL, NULL, NULL, 'Barwin-like endoglucanases', NULL, NULL, 28987, 21),
(286099, NULL, 'SSF110814', NULL, NULL, NULL, NULL, 'TmoB-like', NULL, NULL, 33944, 21),
(286100, NULL, 'SSF159234', NULL, NULL, NULL, NULL, 'FomD-like', NULL, NULL, 29540, 21),
(286101, NULL, 'SSF101494', NULL, NULL, NULL, NULL, 'Stathmin', NULL, NULL, 30192, 21),
(286102, NULL, 'SSF75001', NULL, NULL, NULL, NULL, 'Dipeptidyl peptidase I (cathepsin C), exclusion domain', NULL, NULL, 31485, 21),
(286103, NULL, 'SSF159894', NULL, NULL, NULL, NULL, 'YgaC/TfoX-N like', NULL, NULL, NULL, 21),
(286104, NULL, 'SSF69298', NULL, NULL, NULL, NULL, 'Quinohemoprotein amine dehydrogenase A chain, domain 3', NULL, NULL, 32236, 21),
(286105, NULL, 'SSF116842', NULL, NULL, NULL, NULL, 'XseB-like', NULL, NULL, 28037, 21),
(286106, NULL, 'SSF109732', NULL, NULL, NULL, NULL, 'HBS1-like domain', NULL, NULL, 31532, 21),
(286107, NULL, 'SSF48552', NULL, NULL, NULL, NULL, 'Serum albumin-like', NULL, NULL, 21349, 21),
(286108, NULL, 'SSF47869', NULL, NULL, NULL, NULL, 'Bacteriocin AS-48', NULL, NULL, NULL, 21),
(286109, NULL, 'SSF47819', NULL, NULL, NULL, NULL, 'HRDC-like', NULL, NULL, 8718, 21),
(286110, NULL, 'SSF160991', NULL, NULL, NULL, NULL, 'CV3147-like', NULL, NULL, NULL, 21),
(286111, NULL, 'SSF46946', NULL, NULL, NULL, NULL, 'S13-like H2TH domain', NULL, NULL, 8343, 21),
(286112, NULL, 'SSF50382', NULL, NULL, NULL, NULL, 'Agglutinin', NULL, NULL, 28347, 21),
(286113, NULL, 'SSF161029', NULL, NULL, NULL, NULL, 'Photosystem II reaction center protein T, PsbT', NULL, NULL, 32739, 21),
(286114, NULL, 'SSF49478', NULL, NULL, NULL, NULL, 'Cna protein B-type domain', NULL, NULL, NULL, 21),
(286115, NULL, 'SSF57845', NULL, NULL, NULL, NULL, 'B-box zinc-binding domain', NULL, NULL, NULL, 21),
(286116, NULL, 'SSF48345', NULL, NULL, NULL, NULL, 'A virus capsid protein alpha-helical domain', NULL, NULL, 8949, 21),
(286117, NULL, 'SSF46626', NULL, NULL, NULL, NULL, 'Cytochrome c', NULL, NULL, 28639, 21),
(286118, NULL, 'SSF57774', NULL, NULL, NULL, NULL, 'Microbial and mitochondrial ADK, insert "zinc finger" domain', NULL, NULL, 33392, 21),
(286119, NULL, 'SSF55405', NULL, NULL, NULL, NULL, 'RNA bacteriophage capsid protein', NULL, NULL, 8440, 21),
(286120, NULL, 'SSF47852', NULL, NULL, NULL, NULL, 'Hepatitis B viral capsid (hbcag)', NULL, NULL, 28355, 21); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(286121, NULL, 'SSF54665', NULL, NULL, NULL, NULL, 'CO dehydrogenase molybdoprotein N-domain-like', NULL, NULL, 28435, 21),
(286122, NULL, 'SSF102741', NULL, NULL, NULL, NULL, 'Obg GTP-binding protein C-terminal domain', NULL, NULL, 27759, 21),
(286123, NULL, 'SSF57055', NULL, NULL, NULL, NULL, 'Agouti-related protein', NULL, NULL, 27807, 21),
(286124, NULL, 'SSF140746', NULL, NULL, NULL, NULL, 'SipA N-terminal domain-like', NULL, NULL, 8240, 21),
(286125, NULL, 'SSF50249', NULL, NULL, NULL, NULL, 'Nucleic acid-binding proteins', NULL, NULL, 7999, 21),
(286126, NULL, 'SSF160761', NULL, NULL, NULL, NULL, 'TTHC002-like', NULL, NULL, 31850, 21),
(286127, NULL, 'SSF55945', NULL, NULL, NULL, NULL, 'TATA-box binding protein-like', NULL, NULL, NULL, 21),
(286128, NULL, 'SSF51395', NULL, NULL, NULL, NULL, 'FMN-linked oxidoreductases', NULL, NULL, NULL, 21),
(286129, NULL, 'SSF142535', NULL, NULL, NULL, NULL, 'AF0625-like', NULL, NULL, NULL, 21),
(286130, NULL, 'SSF160570', NULL, NULL, NULL, NULL, 'YonK-like', NULL, NULL, 31824, 21),
(286131, NULL, 'SSF101166', NULL, NULL, NULL, NULL, 'Docking domain A of the erythromycin polyketide synthase (DEBS)', NULL, NULL, 28019, 21),
(286132, NULL, 'SSF56366', NULL, NULL, NULL, NULL, 'SMAD MH1 domain', NULL, NULL, 29529, 21),
(286133, NULL, 'SSF103370', NULL, NULL, NULL, NULL, 'NinB', NULL, NULL, 28483, 21),
(286134, NULL, 'SSF56831', NULL, NULL, NULL, NULL, 'Reovirus inner layer core protein p3', NULL, NULL, 17944, 21),
(286135, NULL, 'SSF47769', NULL, NULL, NULL, NULL, 'SAM/Pointed domain', NULL, NULL, 7881, 21),
(286136, NULL, 'SSF116907', NULL, NULL, NULL, NULL, 'Hook domain', NULL, NULL, NULL, 21),
(286137, NULL, 'SSF101852', NULL, NULL, NULL, NULL, 'Bacterial fluorinating enzyme, C-terminal domain', NULL, NULL, 7299, 21),
(286138, NULL, 'SSF158757', NULL, NULL, NULL, NULL, 'SMc04008-like', NULL, NULL, 33305, 21),
(286139, NULL, 'SSF55200', NULL, NULL, NULL, NULL, 'Translation initiation factor IF3, C-terminal domain', NULL, NULL, 33104, 21),
(286140, NULL, 'SSF74982', NULL, NULL, NULL, NULL, 'Small protein B (SmpB)', NULL, NULL, 8364, 21),
(286141, NULL, 'SSF69964', NULL, NULL, NULL, NULL, 'Pheromone ER-23', NULL, NULL, 10497, 21),
(286142, NULL, 'SSF81995', NULL, NULL, NULL, NULL, 'beta-sandwich domain of Sec23/24', NULL, NULL, NULL, 21),
(286143, NULL, 'SSF53623', NULL, NULL, NULL, NULL, 'MurD-like peptide ligases, catalytic domain', NULL, NULL, 31792, 21),
(286144, NULL, 'SSF101546', NULL, NULL, NULL, NULL, 'ASF1-like', NULL, NULL, 32046, 21),
(286145, NULL, 'SSF158974', NULL, NULL, NULL, NULL, 'WSSV envelope protein-like', NULL, NULL, 33269, 21),
(286146, NULL, 'SSF63848', NULL, NULL, NULL, NULL, 'Cell-division inhibitor MinC, C-terminal domain', NULL, NULL, 28644, 21),
(286147, NULL, 'SSF143990', NULL, NULL, NULL, NULL, 'YbiA-like', NULL, NULL, 29582, 21),
(286148, NULL, 'SSF158379', NULL, NULL, NULL, NULL, 'YqgQ-like', NULL, NULL, 17330, 21),
(286149, NULL, 'SSF117125', NULL, NULL, NULL, NULL, 'Putative glucosidase YicI, C-terminal domain', NULL, NULL, NULL, 21),
(286150, NULL, 'SSF69985', NULL, NULL, NULL, NULL, 'Colicin E3 receptor domain', NULL, NULL, NULL, 21),
(286151, NULL, 'SSF51225', NULL, NULL, NULL, NULL, 'Fibre shaft of virus attachment proteins', NULL, NULL, 9967, 21),
(286152, NULL, 'SSF51726', NULL, NULL, NULL, NULL, 'UROD/MetE-like', NULL, NULL, 30612, 21),
(286153, NULL, 'SSF55594', NULL, NULL, NULL, NULL, 'HPr-like', NULL, NULL, 2153, 21),
(286154, NULL, 'SSF159659', NULL, NULL, NULL, NULL, 'Cgl1923-like', NULL, NULL, NULL, 21),
(286155, NULL, 'SSF69036', NULL, NULL, NULL, NULL, 'Bcr-Abl oncoprotein oligomerization domain', NULL, NULL, 31365, 21),
(286156, NULL, 'SSF54189', NULL, NULL, NULL, NULL, 'Ribosomal proteins S24e, L23 and L15e', NULL, NULL, 12316, 21),
(286157, NULL, 'SSF100909', NULL, NULL, NULL, NULL, 'IP3 receptor type 1 binding core, domain 2', NULL, NULL, 11558, 21),
(286158, NULL, 'SSF140367', NULL, NULL, NULL, NULL, 'Coronavirus NSP7-like', NULL, NULL, 33114, 21),
(286159, NULL, 'SSF49777', NULL, NULL, NULL, NULL, 'PEBP-like', NULL, NULL, 28201, 21);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(286160, NULL, 'SSF55088', NULL, NULL, NULL, NULL, 'Methyl-coenzyme M reductase subunits', NULL, NULL, 9916, 21),
(286161, NULL, 'SSF54111', NULL, NULL, NULL, NULL, 'Urease, gamma-subunit', NULL, NULL, 29890, 21),
(286162, NULL, 'SSF63433', NULL, NULL, NULL, NULL, 'Fumarylacetoacetate hydrolase, FAH, N-terminal domain', NULL, NULL, 31129, 21),
(286163, NULL, 'SSF142877', NULL, NULL, NULL, NULL, 'EndoU-like', NULL, NULL, 29115, 21),
(286164, NULL, 'SSF48670', NULL, NULL, NULL, NULL, 'Transducin (heterotrimeric G protein), gamma chain', NULL, NULL, 31493, 21),
(286165, NULL, 'SSF101152', NULL, NULL, NULL, NULL, 'Mob1/phocein', NULL, NULL, 31919, 21),
(286166, NULL, 'SSF158832', NULL, NULL, NULL, NULL, 'Tex N-terminal region-like', NULL, NULL, NULL, 21),
(286167, NULL, 'SSF57007', NULL, NULL, NULL, NULL, 'Heat-stable enterotoxin B', NULL, NULL, 31019, 21),
(286168, NULL, 'SSF56502', NULL, NULL, NULL, NULL, 'gp120 core', NULL, NULL, 32177, 21),
(286169, NULL, 'SSF141255', NULL, NULL, NULL, NULL, 'YccV-like', NULL, NULL, 28867, 21),
(286170, NULL, 'SSF56801', NULL, NULL, NULL, NULL, 'Acetyl-CoA synthetase-like', NULL, NULL, NULL, 21),
(286171, NULL, 'SSF116858', NULL, NULL, NULL, NULL, 'Hypothetical membrane protein Ta0354, soluble domain', NULL, NULL, 31795, 21),
(286172, NULL, 'SSF57840', NULL, NULL, NULL, NULL, 'Ribosomal protein L36', NULL, NULL, 33274, 21),
(286173, NULL, 'SSF111352', NULL, NULL, NULL, NULL, 'Ammonium transporter', NULL, NULL, NULL, 21),
(286174, NULL, 'SSF160424', NULL, NULL, NULL, NULL, 'BH3703-like', NULL, NULL, 32962, 21),
(286175, NULL, 'SSF81886', NULL, NULL, NULL, NULL, 'Helical scaffold and wing domains of SecA', NULL, NULL, 31989, 21),
(286176, NULL, 'SSF63992', NULL, NULL, NULL, NULL, 'Dipeptide transport protein', NULL, NULL, 32823, 21),
(286177, NULL, 'SSF161093', NULL, NULL, NULL, NULL, 'MgtE membrane domain-like', NULL, NULL, 31583, 21),
(286178, NULL, 'SSF52499', NULL, NULL, NULL, NULL, 'Isochorismatase-like hydrolases', NULL, NULL, 32439, 21),
(286179, NULL, 'SSF51087', NULL, NULL, NULL, NULL, 'Outer surface protein', NULL, NULL, 16543, 21),
(286180, NULL, 'SSF54821', NULL, NULL, NULL, NULL, 'Ribosomal protein S3 C-terminal domain', NULL, NULL, 27669, 21),
(286181, NULL, 'SSF52304', NULL, NULL, NULL, NULL, 'Type II 3-dehydroquinate dehydratase', NULL, NULL, 28163, 21),
(286182, NULL, 'SSF47724', NULL, NULL, NULL, NULL, 'Domain of early E2A DNA-binding protein, ADDBP', NULL, NULL, 32900, 21),
(286183, NULL, 'SSF69279', NULL, NULL, NULL, NULL, 'Phage tail proteins', NULL, NULL, NULL, 21),
(286184, NULL, 'SSF69060', NULL, NULL, NULL, NULL, 'Arp2/3 complex 21 kDa subunit ARPC3', NULL, NULL, 32219, 21),
(286185, NULL, 'SSF50886', NULL, NULL, NULL, NULL, 'D-aminopeptidase, middle and C-terminal domains', NULL, NULL, 26560, 21),
(286186, NULL, 'SSF81552', NULL, NULL, NULL, NULL, 'Subunit PsaX of photosystem I reaction centre', NULL, NULL, 29682, 21),
(286187, NULL, 'SSF54580', NULL, NULL, NULL, NULL, 'Allophycocyanin linker chain (domain)', NULL, NULL, 10432, 21),
(286188, NULL, 'SSF69761', NULL, NULL, NULL, NULL, 'GTP cyclohydrolase I feedback regulatory protein, GFRP', NULL, NULL, 32326, 21),
(286189, NULL, 'SSF81872', NULL, NULL, NULL, NULL, 'BRCA2 helical domain', NULL, NULL, 31772, 21),
(286190, NULL, 'SSF74853', NULL, NULL, NULL, NULL, 'Lamin A/C globular tail domain', NULL, NULL, 27914, 21),
(286191, NULL, 'SSF141678', NULL, NULL, NULL, NULL, 'MAL13P1.257-like', NULL, NULL, NULL, 21),
(286192, NULL, 'SSF110738', NULL, NULL, NULL, NULL, 'Glycerate kinase I', NULL, NULL, 33041, 21),
(286193, NULL, 'SSF49749', NULL, NULL, NULL, NULL, 'Group II dsDNA viruses VP', NULL, NULL, 11191, 21),
(286194, NULL, 'SSF63825', NULL, NULL, NULL, NULL, 'YWTD domain', NULL, NULL, NULL, 21),
(286195, NULL, 'SSF89562', NULL, NULL, NULL, NULL, 'RraA-like', NULL, NULL, 31790, 21),
(286196, NULL, 'SSF69652', NULL, NULL, NULL, NULL, 'DNA-binding C-terminal domain of the transcription factor MotA', NULL, NULL, 31098, 21),
(286197, NULL, 'SSF69908', NULL, NULL, NULL, NULL, 'Membrane penetration protein mu1', NULL, NULL, 29792, 21);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(286198, NULL, 'SSF47384', NULL, NULL, NULL, NULL, 'Homodimeric domain of signal transducing histidine kinase', NULL, NULL, 27281, 21),
(286199, NULL, 'SSF63380', NULL, NULL, NULL, NULL, 'Riboflavin synthase domain-like', NULL, NULL, 19317, 21),
(286200, NULL, 'SSF46955', NULL, NULL, NULL, NULL, 'Putative DNA-binding domain', NULL, NULL, 6095, 21),
(286201, NULL, 'SSF46942', NULL, NULL, NULL, NULL, 'Elongation factor TFIIS domain 2', NULL, NULL, 31299, 21),
(286202, NULL, 'SSF50017', NULL, NULL, NULL, NULL, 'gp9', NULL, NULL, 28116, 21),
(286203, NULL, 'SSF52283', NULL, NULL, NULL, NULL, 'Formate/glycerate dehydrogenase catalytic domain-like', NULL, NULL, NULL, 21),
(286204, NULL, 'SSF54786', NULL, NULL, NULL, NULL, 'YcfA/nrd intein domain', NULL, NULL, NULL, 21),
(286205, NULL, 'SSF56672', NULL, NULL, NULL, NULL, 'DNA/RNA polymerases', NULL, NULL, 35070, 21),
(286206, NULL, 'SSF53062', NULL, NULL, NULL, NULL, 'PTS system fructose IIA component-like', NULL, NULL, 28774, 21),
(286207, NULL, 'SSF140713', NULL, NULL, NULL, NULL, 'Phage replication organizer domain', NULL, NULL, 29772, 21),
(286208, NULL, 'SSF52518', NULL, NULL, NULL, NULL, 'Thiamin diphosphate-binding fold (THDP-binding)', NULL, NULL, 24789, 21),
(286209, NULL, 'SSF141000', NULL, NULL, NULL, NULL, 'Glu-tRNAGln amidotransferase C subunit', NULL, NULL, 32980, 21),
(286210, NULL, 'SSF51412', NULL, NULL, NULL, NULL, 'Inosine monophosphate dehydrogenase (IMPDH)', NULL, NULL, NULL, 21),
(286211, NULL, 'SSF158230', NULL, NULL, NULL, NULL, 'PRP4-like', NULL, NULL, 31846, 21),
(286212, NULL, 'SSF52343', NULL, NULL, NULL, NULL, 'Ferredoxin reductase-like, C-terminal NADP-linked domain', NULL, NULL, 33418, 21),
(286213, NULL, 'SSF160350', NULL, NULL, NULL, NULL, 'Rnp2-like', NULL, NULL, 31103, 21),
(286214, NULL, 'SSF101999', NULL, NULL, NULL, NULL, 'Trimeric adhesin', NULL, NULL, NULL, 21),
(286215, NULL, 'SSF55103', NULL, NULL, NULL, NULL, 'FAD-linked oxidases, C-terminal domain', NULL, NULL, 11516, 21),
(286216, NULL, 'SSF57924', NULL, NULL, NULL, NULL, 'Inhibitor of apoptosis (IAP) repeat', NULL, NULL, NULL, 21),
(286217, NULL, 'SSF55920', NULL, NULL, NULL, NULL, 'Creatinase/aminopeptidase', NULL, NULL, 30058, 21),
(286218, NULL, 'SSF82714', NULL, NULL, NULL, NULL, 'Multidrug efflux transporter AcrB TolC docking domain; DN and DC subdomains', NULL, NULL, 26581, 21),
(286219, NULL, 'SSF109797', NULL, NULL, NULL, NULL, 'Bacteriocin immunity protein-like', NULL, NULL, NULL, 21),
(286220, NULL, 'SSF47648', NULL, NULL, NULL, NULL, 'Nucleoside phosphorylase/phosphoribosyltransferase N-terminal domain', NULL, NULL, 28125, 21),
(286221, NULL, 'SSF47874', NULL, NULL, NULL, NULL, 'Annexin', NULL, NULL, 28029, 21),
(286222, NULL, 'SSF143847', NULL, NULL, NULL, NULL, 'XisI-like', NULL, NULL, 9537, 21),
(286223, NULL, 'SSF63737', NULL, NULL, NULL, NULL, 'Leukotriene A4 hydrolase N-terminal domain', NULL, NULL, 30731, 21),
(286224, NULL, 'SSF159941', NULL, NULL, NULL, NULL, 'MM3350-like', NULL, NULL, 11624, 21),
(286225, NULL, 'SSF57652', NULL, NULL, NULL, NULL, 'HIPIP (high potential iron protein)', NULL, NULL, 28279, 21),
(286226, NULL, 'SSF117892', NULL, NULL, NULL, NULL, 'Band 7/SPFH domain', NULL, NULL, 27501, 21),
(286227, NULL, 'SSF69721', NULL, NULL, NULL, NULL, 'DsrC, the gamma subunit of dissimilatory sulfite reductase', NULL, NULL, 24408, 21),
(286228, NULL, 'SSF103084', NULL, NULL, NULL, NULL, 'Holliday junction resolvase RusA', NULL, NULL, 28364, 21),
(286229, NULL, 'SSF52313', NULL, NULL, NULL, NULL, 'Ribosomal protein S2', NULL, NULL, 16585, 21),
(286230, NULL, 'SSF74778', NULL, NULL, NULL, NULL, 'Aconitase B, N-terminal domain', NULL, NULL, 31364, 21),
(286231, NULL, 'SSF54106', NULL, NULL, NULL, NULL, 'LysM domain', NULL, NULL, 33105, 21),
(286232, NULL, 'SSF47802', NULL, NULL, NULL, NULL, 'DNA polymerase beta, N-terminal domain-like', NULL, NULL, 25486, 21),
(286233, NULL, 'SSF140869', NULL, NULL, NULL, NULL, 'GUN4-like', NULL, NULL, 31687, 21),
(286234, NULL, 'SSF58100', NULL, NULL, NULL, NULL, 'Bacterial hemolysins', NULL, NULL, NULL, 21);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(286235, NULL, 'SSF56826', NULL, NULL, NULL, NULL, 'Upper collar protein gp10 (connector protein)', NULL, NULL, 28303, 21),
(286236, NULL, 'SSF143880', NULL, NULL, NULL, NULL, 'NE0471 N-terminal domain-like', NULL, NULL, 33090, 21),
(286237, NULL, 'SSF141251', NULL, NULL, NULL, NULL, 'Kinase-associated protein B-like', NULL, NULL, 31269, 21),
(286238, NULL, 'SSF56815', NULL, NULL, NULL, NULL, 'Sec1/munc18-like (SM) proteins', NULL, NULL, 32163, 21),
(286239, NULL, 'SSF143560', NULL, NULL, NULL, NULL, 'MK0786-like', NULL, NULL, 27974, 21),
(286240, NULL, 'SSF53697', NULL, NULL, NULL, NULL, 'SIS domain', NULL, NULL, 37721, 21),
(286241, NULL, 'SSF54373', NULL, NULL, NULL, NULL, 'FAD-linked reductases, C-terminal domain', NULL, NULL, NULL, 21),
(286242, NULL, 'SSF160651', NULL, NULL, NULL, NULL, 'FLJ32549 C-terminal domain-like', NULL, NULL, NULL, 21),
(286243, NULL, 'SSF47831', NULL, NULL, NULL, NULL, 'Enzyme I of the PEP:sugar phosphotransferase system HPr-binding (sub)domain', NULL, NULL, 28335, 21),
(286244, NULL, 'SSF69304', NULL, NULL, NULL, NULL, 'Tricorn protease N-terminal domain', NULL, NULL, NULL, 21),
(286245, NULL, 'SSF101912', NULL, NULL, NULL, NULL, 'Sema domain', NULL, NULL, 27512, 21),
(286246, NULL, 'SSF90250', NULL, NULL, NULL, NULL, 'Troponin coil-coiled subunits', NULL, NULL, 31556, 21),
(286247, NULL, 'SSF160519', NULL, NULL, NULL, NULL, 'BB2672-like', NULL, NULL, 14115, 21),
(286248, NULL, 'SSF101967', NULL, NULL, NULL, NULL, 'Adhesin YadA, collagen-binding domain', NULL, NULL, 9423, 21),
(286249, NULL, 'SSF56091', NULL, NULL, NULL, NULL, 'DNA ligase/mRNA capping enzyme, catalytic domain', NULL, NULL, NULL, 21),
(286250, NULL, 'SSF82026', NULL, NULL, NULL, NULL, 'Calcium-mediated lectin', NULL, NULL, 29591, 21),
(286251, NULL, 'SSF116854', NULL, NULL, NULL, NULL, 'Avirulence protein AvrPto', NULL, NULL, 30024, 21),
(286252, NULL, 'SSF89442', NULL, NULL, NULL, NULL, 'Hypothetical protein YojF', NULL, NULL, 31224, 21),
(286253, NULL, 'SSF54654', NULL, NULL, NULL, NULL, 'CI-2 family of serine protease inhibitors', NULL, NULL, 27714, 21),
(286254, NULL, 'SSF103417', NULL, NULL, NULL, NULL, 'Major capsid protein VP5', NULL, NULL, 8846, 21),
(286255, NULL, 'SSF103243', NULL, NULL, NULL, NULL, 'KA1-like', NULL, NULL, 24656, 21),
(286256, NULL, 'SSF140570', NULL, NULL, NULL, NULL, 'MukF C-terminal domain-like', NULL, NULL, 28571, 21),
(286257, NULL, 'SSF51110', NULL, NULL, NULL, NULL, 'alpha-D-mannose-specific plant lectins', NULL, NULL, 28486, 21),
(286258, NULL, 'SSF56534', NULL, NULL, NULL, NULL, 'Aromatic aminoacid monoxygenases, catalytic and oligomerization domains', NULL, NULL, 28267, 21),
(286259, NULL, 'SSF55469', NULL, NULL, NULL, NULL, 'FMN-dependent nitroreductase-like', NULL, NULL, 6830, 21),
(286260, NULL, 'SSF57701', NULL, NULL, NULL, NULL, 'Zn2/Cys6 DNA-binding domain', NULL, NULL, 28495, 21),
(286261, NULL, 'SSF57667', NULL, NULL, NULL, NULL, 'beta-beta-alpha zinc fingers', NULL, NULL, 29573, 21),
(286262, NULL, 'SSF53955', NULL, NULL, NULL, NULL, 'Lysozyme-like', NULL, NULL, 20575, 21),
(286263, NULL, 'SSF102886', NULL, NULL, NULL, NULL, 'Coproporphyrinogen III oxidase', NULL, NULL, 31558, 21),
(286264, NULL, 'SSF69118', NULL, NULL, NULL, NULL, 'AhpD-like', NULL, NULL, 23934, 21),
(286265, NULL, 'SSF110132', NULL, NULL, NULL, NULL, 'BTV NS2-like ssRNA-binding domain', NULL, NULL, 33235, 21),
(286266, NULL, 'SSF50952', NULL, NULL, NULL, NULL, 'Soluble quinoprotein glucose dehydrogenase', NULL, NULL, 9263, 21),
(286267, NULL, 'SSF103441', NULL, NULL, NULL, NULL, 'PetM subunit of the cytochrome b6f complex', NULL, NULL, NULL, 21),
(286268, NULL, 'SSF47923', NULL, NULL, NULL, NULL, 'Ypt/Rab-GAP domain of gyp1p', NULL, NULL, 26888, 21),
(286269, NULL, 'SSF143414', NULL, NULL, NULL, NULL, 'CcmK-like', NULL, NULL, 29526, 21),
(286270, NULL, 'SSF142795', NULL, NULL, NULL, NULL, 'CAC2185-like', NULL, NULL, 29073, 21),
(286271, NULL, 'SSF56553', NULL, NULL, NULL, NULL, 'Insert subdomain of RNA polymerase alpha subunit', NULL, NULL, 29552, 21),
(286272, NULL, 'SSF101327', NULL, NULL, NULL, NULL, 'YgfB-like', NULL, NULL, 29194, 21);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(286273, NULL, 'SSF57756', NULL, NULL, NULL, NULL, 'Retrovirus zinc finger-like domains', NULL, NULL, 28381, 21),
(286274, NULL, 'SSF54631', NULL, NULL, NULL, NULL, 'CBS-domain pair', NULL, NULL, 34341, 21),
(286275, NULL, 'SSF81837', NULL, NULL, NULL, NULL, 'BEACH domain', NULL, NULL, 28396, 21),
(286276, NULL, 'SSF64465', NULL, NULL, NULL, NULL, 'Outer capsid protein sigma 3', NULL, NULL, 16975, 21),
(286277, NULL, 'SSF47027', NULL, NULL, NULL, NULL, 'Acyl-CoA binding protein', NULL, NULL, 31743, 21),
(286278, NULL, 'SSF160369', NULL, NULL, NULL, NULL, 'Ribosomal protein L10-like', NULL, NULL, 34828, 21),
(286279, NULL, 'SSF110997', NULL, NULL, NULL, NULL, 'Sporulation related repeat', NULL, NULL, 29506, 21),
(286280, NULL, 'SSF50989', NULL, NULL, NULL, NULL, 'Clathrin heavy-chain terminal domain', NULL, NULL, 9139, 21),
(286281, NULL, 'SSF48662', NULL, NULL, NULL, NULL, 'Ribosomal protein L39e', NULL, NULL, 12079, 21),
(286282, NULL, 'SSF57038', NULL, NULL, NULL, NULL, 'Cyclotides', NULL, NULL, 28678, 21),
(286283, NULL, 'SSF47266', NULL, NULL, NULL, NULL, '4-helical cytokines', NULL, NULL, 6138, 21),
(286284, NULL, 'SSF55124', NULL, NULL, NULL, NULL, 'Nitrite/Sulfite reductase N-terminal domain-like', NULL, NULL, 33150, 21),
(286285, NULL, 'SSF89428', NULL, NULL, NULL, NULL, 'Adsorption protein p2', NULL, NULL, 27964, 21),
(286286, NULL, 'SSF142906', NULL, NULL, NULL, NULL, 'YjbR-like', NULL, NULL, 32106, 21),
(286287, NULL, 'SSF102816', NULL, NULL, NULL, NULL, 'Putative dsDNA mimic', NULL, NULL, 32436, 21),
(286288, NULL, 'SSF50324', NULL, NULL, NULL, NULL, 'Inorganic pyrophosphatase', NULL, NULL, 28009, 21),
(286289, NULL, 'SSF50346', NULL, NULL, NULL, NULL, 'PRC-barrel domain', NULL, NULL, 9205, 21),
(286290, NULL, 'SSF141072', NULL, NULL, NULL, NULL, 'CalX-like', NULL, NULL, 31711, 21),
(286291, NULL, 'SSF47162', NULL, NULL, NULL, NULL, 'Apolipoprotein', NULL, NULL, NULL, 21),
(286292, NULL, 'SSF47836', NULL, NULL, NULL, NULL, 'Retroviral matrix proteins', NULL, NULL, 8880, 21),
(286293, NULL, 'SSF141729', NULL, NULL, NULL, NULL, 'FimD N-terminal domain-like', NULL, NULL, 27708, 21),
(286294, NULL, 'SSF57190', NULL, NULL, NULL, NULL, 'Colipase-like', NULL, NULL, NULL, 21),
(286295, NULL, 'SSF46774', NULL, NULL, NULL, NULL, 'ARID-like', NULL, NULL, 28410, 21),
(286296, NULL, 'SSF159501', NULL, NULL, NULL, NULL, 'EreA/ChaN-like', NULL, NULL, NULL, 21),
(286297, NULL, 'SSF63817', NULL, NULL, NULL, NULL, 'Sortase', NULL, NULL, 20102, 21),
(286298, NULL, 'SSF100957', NULL, NULL, NULL, NULL, 'Dimerization cofactor of HNF-1 alpha', NULL, NULL, 1563, 21),
(286299, NULL, 'SSF81423', NULL, NULL, NULL, NULL, 'Mitochondrial cytochrome c oxidase subunit VIIb', NULL, NULL, 6798, 21),
(286300, NULL, 'SSF46966', NULL, NULL, NULL, NULL, 'Spectrin repeat', NULL, NULL, NULL, 21),
(286301, NULL, 'SSF103025', NULL, NULL, NULL, NULL, 'Folate-binding domain', NULL, NULL, NULL, 21),
(286302, NULL, 'SSF64449', NULL, NULL, NULL, NULL, 'YopH tyrosine phosphatase N-terminal domain', NULL, NULL, 31492, 21),
(286303, NULL, 'SSF50193', NULL, NULL, NULL, NULL, 'Ribosomal protein L14', NULL, NULL, 31701, 21),
(286304, NULL, 'SSF50876', NULL, NULL, NULL, NULL, 'Avidin/streptavidin', NULL, NULL, 28844, 21),
(286305, NULL, 'SSF52218', NULL, NULL, NULL, NULL, 'Flavoproteins', NULL, NULL, 24724, 21),
(286306, NULL, 'SSF54364', NULL, NULL, NULL, NULL, 'Translation initiation factor IF3, N-terminal domain', NULL, NULL, 33468, 21),
(286307, NULL, 'SSF69340', NULL, NULL, NULL, NULL, 'C-terminal domain of adenylylcyclase associated protein', NULL, NULL, 29709, 21),
(286308, NULL, 'SSF54810', NULL, NULL, NULL, NULL, 'GMP synthetase C-terminal dimerisation domain', NULL, NULL, NULL, 21),
(286309, NULL, 'SSF48239', NULL, NULL, NULL, NULL, 'Terpenoid cyclases/Protein prenyltransferases', NULL, NULL, 8932, 21),
(286310, NULL, 'SSF55234', NULL, NULL, NULL, NULL, 'Cyanase C-terminal domain', NULL, NULL, 31161, 21),
(286311, NULL, 'SSF159038', NULL, NULL, NULL, NULL, 'YorP-like', NULL, NULL, 32144, 21),
(286312, NULL, 'SSF159800', NULL, NULL, NULL, NULL, 'PrpR receptor domain-like', NULL, NULL, NULL, 21);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(286313, NULL, 'SSF160355', NULL, NULL, NULL, NULL, 'Bacterial polysaccharide co-polymerase-like', NULL, NULL, NULL, 21),
(286314, NULL, 'SSF49594', NULL, NULL, NULL, NULL, 'Rab geranylgeranyltransferase alpha-subunit, insert domain', NULL, NULL, 29786, 21),
(286315, NULL, 'SSF47175', NULL, NULL, NULL, NULL, 'Cytochromes', NULL, NULL, 8064, 21),
(286316, NULL, 'SSF56983', NULL, NULL, NULL, NULL, 'Viral glycoprotein, central and dimerisation domains', NULL, NULL, 29325, 21),
(286317, NULL, 'SSF53146', NULL, NULL, NULL, NULL, 'Nitrogenase accessory factor-like', NULL, NULL, 33383, 21),
(286318, NULL, 'SSF48076', NULL, NULL, NULL, NULL, 'LigA subunit of an aromatic-ring-opening dioxygenase LigAB', NULL, NULL, 28535, 21),
(286319, NULL, 'SSF50934', NULL, NULL, NULL, NULL, 'Tachylectin-2', NULL, NULL, 33024, 21),
(286320, NULL, 'SSF161256', NULL, NULL, NULL, NULL, 'RILP dimerisation region', NULL, NULL, NULL, 21),
(286321, NULL, 'SSF102891', NULL, NULL, NULL, NULL, 'Hypothetical protein Ta1206', NULL, NULL, 31312, 21),
(286322, NULL, 'SSF48371', NULL, NULL, NULL, NULL, 'ARM repeat', NULL, NULL, 10196, 21),
(286323, NULL, 'SSF111265', NULL, NULL, NULL, NULL, 'Hemolytic lectin CEL-III, C-terminal domain', NULL, NULL, 21947, 21),
(286324, NULL, 'SSF110111', NULL, NULL, NULL, NULL, 'Ctag/Cox11', NULL, NULL, 16064, 21),
(286325, NULL, 'SSF55424', NULL, NULL, NULL, NULL, 'FAD/NAD-linked reductases, dimerisation (C-terminal) domain', NULL, NULL, 11577, 21),
(286326, NULL, 'SSF102712', NULL, NULL, NULL, NULL, 'JAB1/MPN domain', NULL, NULL, NULL, 21),
(286327, NULL, 'SSF50176', NULL, NULL, NULL, NULL, 'N-terminal domains of the minor coat protein g3p', NULL, NULL, 28133, 21),
(286328, NULL, 'SSF141259', NULL, NULL, NULL, NULL, 'CarD-like', NULL, NULL, 27186, 21),
(286329, NULL, 'SSF56281', NULL, NULL, NULL, NULL, 'Metallo-hydrolase/oxidoreductase', NULL, NULL, 28436, 21),
(286330, NULL, 'SSF52402', NULL, NULL, NULL, NULL, 'Adenine nucleotide alpha hydrolases-like', NULL, NULL, NULL, 21),
(286331, NULL, 'SSF116878', NULL, NULL, NULL, NULL, 'TrmE connector domain', NULL, NULL, NULL, 21),
(286332, NULL, 'SSF51971', NULL, NULL, NULL, NULL, 'Nucleotide-binding domain', NULL, NULL, NULL, 21),
(286333, NULL, 'SSF141130', NULL, NULL, NULL, NULL, 'Acetamidase/Formamidase-like', NULL, NULL, NULL, 21),
(286334, NULL, 'SSF51621', NULL, NULL, NULL, NULL, 'Phosphoenolpyruvate/pyruvate domain', NULL, NULL, 8380, 21),
(286335, NULL, 'SSF64076', NULL, NULL, NULL, NULL, 'MTH938-like', NULL, NULL, 27872, 21),
(286336, NULL, 'SSF49468', NULL, NULL, NULL, NULL, 'VHL', NULL, NULL, 30114, 21),
(286337, NULL, 'SSF75304', NULL, NULL, NULL, NULL, 'Amidase signature (AS) enzymes', NULL, NULL, 32637, 21),
(286338, NULL, 'SSF89069', NULL, NULL, NULL, NULL, 'N-terminal, cytoplasmic domain of anti-sigmaE factor RseA', NULL, NULL, 28771, 21),
(286339, NULL, 'SSF56112', NULL, NULL, NULL, NULL, 'Protein kinase-like (PK-like)', NULL, NULL, 8918, 21),
(286340, NULL, 'SSF46604', NULL, NULL, NULL, NULL, 'Epsilon subunit of F1F0-ATP synthase C-terminal domain', NULL, NULL, 33310, 21),
(286341, NULL, 'SSF55464', NULL, NULL, NULL, NULL, 'Origin of replication-binding domain, RBD-like', NULL, NULL, NULL, 21),
(286342, NULL, 'SSF81406', NULL, NULL, NULL, NULL, 'Mitochondrial cytochrome c oxidase subunit IV', NULL, NULL, 30554, 21),
(286343, NULL, 'SSF57716', NULL, NULL, NULL, NULL, 'Glucocorticoid receptor-like (DNA-binding domain)', NULL, NULL, NULL, 21),
(286344, NULL, 'SSF48493', NULL, NULL, NULL, NULL, 'gene 59 helicase assembly protein', NULL, NULL, 15696, 21),
(286345, NULL, 'SSF102588', NULL, NULL, NULL, NULL, 'LmbE-like', NULL, NULL, 18518, 21),
(286346, NULL, 'SSF69695', NULL, NULL, NULL, NULL, 'SRP19', NULL, NULL, 32543, 21),
(286347, NULL, 'SSF64356', NULL, NULL, NULL, NULL, 'SNARE-like', NULL, NULL, 9292, 21),
(286348, NULL, 'SSF101816', NULL, NULL, NULL, NULL, 'Replicase NSP9', NULL, NULL, 31304, 21),
(286349, NULL, 'SSF54762', NULL, NULL, NULL, NULL, 'Signal recognition particle alu RNA binding heterodimer, SRP9/14', NULL, NULL, 9784, 21);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(286350, NULL, 'SSF144000', NULL, NULL, NULL, NULL, 'Oxysterol-binding protein-like', NULL, NULL, 29669, 21),
(286351, NULL, 'SSF57048', NULL, NULL, NULL, NULL, 'Gurmarin-like', NULL, NULL, 7846, 21),
(286352, NULL, 'SSF54713', NULL, NULL, NULL, NULL, 'Elongation factor Ts (EF-Ts), dimerisation domain', NULL, NULL, 29452, 21),
(286353, NULL, 'SSF117130', NULL, NULL, NULL, NULL, 'CsrA-like', NULL, NULL, 32680, 21),
(286354, NULL, 'SSF109839', NULL, NULL, NULL, NULL, 'Cag-Z', NULL, NULL, 31747, 21),
(286355, NULL, 'SSF53738', NULL, NULL, NULL, NULL, 'Phosphoglucomutase, first 3 domains', NULL, NULL, 10105, 21),
(286356, NULL, 'SSF55957', NULL, NULL, NULL, NULL, 'Phosphoglucomutase, C-terminal domain', NULL, NULL, 28778, 21),
(286357, NULL, 'SSF56371', NULL, NULL, NULL, NULL, 'Ribosome inactivating proteins (RIP)', NULL, NULL, 30188, 21),
(286358, NULL, 'SSF55718', NULL, NULL, NULL, NULL, 'SCP-like', NULL, NULL, 33258, 21),
(286359, NULL, 'SSF158675', NULL, NULL, NULL, NULL, 'Sama2622-like', NULL, NULL, 10127, 21),
(286360, NULL, 'SSF47345', NULL, NULL, NULL, NULL, 'Colicin E immunity proteins', NULL, NULL, 14966, 21),
(286361, NULL, 'SSF117987', NULL, NULL, NULL, NULL, 'CRISPR-associated protein', NULL, NULL, NULL, 21),
(286362, NULL, 'SSF55846', NULL, NULL, NULL, NULL, 'N-acetylmuramoyl-L-alanine amidase-like', NULL, NULL, 30377, 21),
(286363, NULL, 'SSF55257', NULL, NULL, NULL, NULL, 'RBP11-like subunits of RNA polymerase', NULL, NULL, 33789, 21),
(286364, NULL, 'SSF140496', NULL, NULL, NULL, NULL, 'HP1531-like', NULL, NULL, 32474, 21),
(286365, NULL, 'SSF52200', NULL, NULL, NULL, NULL, 'Toll/Interleukin receptor TIR domain', NULL, NULL, 10383, 21),
(286366, NULL, 'SSF89028', NULL, NULL, NULL, NULL, 'Cobalamin adenosyltransferase-like', NULL, NULL, 31600, 21),
(286367, NULL, 'SSF55031', NULL, NULL, NULL, NULL, 'Bacterial exopeptidase dimerisation domain', NULL, NULL, 31565, 21),
(286368, NULL, 'SSF51274', NULL, NULL, NULL, NULL, 'Head decoration protein D (gpD, major capsid protein D)', NULL, NULL, 30742, 21),
(286369, NULL, 'SSF46609', NULL, NULL, NULL, NULL, 'Fe,Mn superoxide dismutase (SOD), N-terminal domain', NULL, NULL, 28328, 21),
(286370, NULL, 'SSF158573', NULL, NULL, NULL, NULL, 'GINS helical bundle-like', NULL, NULL, 33005, 21),
(286371, NULL, 'SSF117916', NULL, NULL, NULL, NULL, 'Fe-S cluster assembly (FSCA) domain-like', NULL, NULL, 28053, 21),
(286372, NULL, 'SSF103446', NULL, NULL, NULL, NULL, 'PetG subunit of the cytochrome b6f complex', NULL, NULL, 27382, 21),
(286373, NULL, 'SSF52374', NULL, NULL, NULL, NULL, 'Nucleotidylyl transferase', NULL, NULL, NULL, 21),
(286374, NULL, 'SSF81415', NULL, NULL, NULL, NULL, 'Mitochondrial cytochrome c oxidase subunit VIc', NULL, NULL, 29555, 21),
(286375, NULL, 'SSF53474', NULL, NULL, NULL, NULL, 'alpha/beta-Hydrolases', NULL, NULL, 24739, 21),
(286376, NULL, 'SSF141868', NULL, NULL, NULL, NULL, 'EAL domain-like', NULL, NULL, 24870, 21),
(286377, NULL, 'SSF57180', NULL, NULL, NULL, NULL, 'Cellulose-binding domain', NULL, NULL, 16845, 21),
(286378, NULL, 'SSF144266', NULL, NULL, NULL, NULL, 'MPN010-like', NULL, NULL, NULL, 21),
(286379, NULL, 'SSF81333', NULL, NULL, NULL, NULL, 'F1F0 ATP synthase subunit C', NULL, NULL, 26425, 21),
(286380, NULL, 'SSF143749', NULL, NULL, NULL, NULL, 'Phage tail protein-like', NULL, NULL, 13829, 21),
(286381, NULL, 'SSF103515', NULL, NULL, NULL, NULL, 'Autotransporter', NULL, NULL, 31884, 21),
(286382, NULL, 'SSF101148', NULL, NULL, NULL, NULL, 'Plant invertase/pectin methylesterase inhibitor', NULL, NULL, 32270, 21),
(286383, NULL, 'SSF64593', NULL, NULL, NULL, NULL, 'Intermediate filament protein, coiled coil region', NULL, NULL, NULL, 21),
(286384, NULL, 'SSF48179', NULL, NULL, NULL, NULL, '6-phosphogluconate dehydrogenase C-terminal domain-like', NULL, NULL, 8546, 21),
(286385, NULL, 'SSF55387', NULL, NULL, NULL, NULL, 'Frataxin/Nqo15-like', NULL, NULL, 32790, 21),
(286386, NULL, 'SSF56959', NULL, NULL, NULL, NULL, 'Leukocidin-like', NULL, NULL, 31852, 21),
(286387, NULL, 'SSF64307', NULL, NULL, NULL, NULL, 'SirA-like', NULL, NULL, 28155, 21);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(286388, NULL, 'SSF64571', NULL, NULL, NULL, NULL, 'Cellulose docking domain, dockering', NULL, NULL, 9768, 21),
(286389, NULL, 'SSF50939', NULL, NULL, NULL, NULL, 'Sialidases', NULL, NULL, 31869, 21),
(286390, NULL, 'SSF158221', NULL, NULL, NULL, NULL, 'YnzC-like', NULL, NULL, NULL, 21),
(286391, NULL, 'SSF51126', NULL, NULL, NULL, NULL, 'Pectin lyase-like', NULL, NULL, 9272, 21),
(286392, NULL, 'SSF47699', NULL, NULL, NULL, NULL, 'Bifunctional inhibitor/lipid-transfer protein/seed storage 2S albumin', NULL, NULL, 31340, 21),
(286393, NULL, 'SSF54980', NULL, NULL, NULL, NULL, 'EF-G C-terminal domain-like', NULL, NULL, 32503, 21),
(286394, NULL, 'SSF116742', NULL, NULL, NULL, NULL, 'eIF2alpha middle domain-like', NULL, NULL, 12388, 21),
(286395, NULL, 'SSF46915', NULL, NULL, NULL, NULL, 'Polynucleotide phosphorylase/guanosine pentaphosphate synthase (PNPase/GPSI), domain 3', NULL, NULL, 31923, 21),
(286396, NULL, 'SSF160704', NULL, NULL, NULL, NULL, 'YehR-like', NULL, NULL, 29685, 21),
(286397, NULL, 'SSF141086', NULL, NULL, NULL, NULL, 'Agglutinin HPA-like', NULL, NULL, 29359, 21),
(286398, NULL, 'SSF161045', NULL, NULL, NULL, NULL, 'Cytochrome b559 subunits', NULL, NULL, NULL, 21),
(286399, NULL, 'SSF81277', NULL, NULL, NULL, NULL, 'C-terminal domain of mollusc hemocyanin', NULL, NULL, 31863, 21),
(286400, NULL, 'SSF51703', NULL, NULL, NULL, NULL, 'Cobalamin (vitamin B12)-dependent enzymes', NULL, NULL, 11630, 21),
(286401, NULL, 'SSF101596', NULL, NULL, NULL, NULL, 'Dextranase, N-terminal domain', NULL, NULL, 24343, 21),
(286402, NULL, 'SSF142921', NULL, NULL, NULL, NULL, 'WGR domain-like', NULL, NULL, 32869, 21),
(286403, NULL, 'SSF56425', NULL, NULL, NULL, NULL, 'Succinate dehydrogenase/fumarate reductase flavoprotein, catalytic domain', NULL, NULL, 24036, 21),
(286404, NULL, 'SSF103580', NULL, NULL, NULL, NULL, 'Necrosis inducing protein 1, NIP1', NULL, NULL, 31601, 21),
(286405, NULL, 'SSF57829', NULL, NULL, NULL, NULL, 'Zn-binding ribosomal proteins', NULL, NULL, 13802, 21),
(286406, NULL, 'SSF101576', NULL, NULL, NULL, NULL, 'Supernatant protein factor (SPF), C-terminal domain', NULL, NULL, 33827, 21),
(286407, NULL, 'SSF56719', NULL, NULL, NULL, NULL, 'Type II DNA topoisomerase', NULL, NULL, 7605, 21),
(286408, NULL, 'SSF140102', NULL, NULL, NULL, NULL, 'ISY1 domain-like', NULL, NULL, 27641, 21),
(286409, NULL, 'SSF63520', NULL, NULL, NULL, NULL, 'PTS-regulatory domain, PRD', NULL, NULL, 27073, 21),
(286410, NULL, 'SSF103642', NULL, NULL, NULL, NULL, 'Sec-C motif', NULL, NULL, NULL, 21),
(286411, NULL, 'SSF159222', NULL, NULL, NULL, NULL, 'YopT-like', NULL, NULL, NULL, 21),
(286412, NULL, 'SSF57283', NULL, NULL, NULL, NULL, 'PMP inhibitors', NULL, NULL, 28067, 21),
(286413, NULL, 'SSF88648', NULL, NULL, NULL, NULL, 'Group I dsDNA viruses', NULL, NULL, 18252, 21),
(286414, NULL, 'SSF53807', NULL, NULL, NULL, NULL, '"Helical backbone" metal receptor', NULL, NULL, NULL, 21),
(286415, NULL, 'SSF160104', NULL, NULL, NULL, NULL, 'Acetoacetate decarboxylase-like', NULL, NULL, 15871, 21),
(286416, NULL, 'SSF82544', NULL, NULL, NULL, NULL, 'GckA/TtuD-like', NULL, NULL, NULL, 21),
(286417, NULL, 'SSF82866', NULL, NULL, NULL, NULL, 'Multidrug efflux transporter AcrB transmembrane domain', NULL, NULL, NULL, 21),
(286418, NULL, 'SSF140121', NULL, NULL, NULL, NULL, 'SPy1572-like', NULL, NULL, 27114, 21),
(286419, NULL, 'SSF54752', NULL, NULL, NULL, NULL, 'RecA protein, C-terminal domain', NULL, NULL, 16014, 21),
(286420, NULL, 'SSF160713', NULL, NULL, NULL, NULL, 'YqaI-like', NULL, NULL, 14561, 21),
(286421, NULL, 'SSF56487', NULL, NULL, NULL, NULL, 'SRCR-like', NULL, NULL, 31520, 21),
(286422, NULL, 'SSF54862', NULL, NULL, NULL, NULL, '4Fe-4S ferredoxins', NULL, NULL, NULL, 21),
(286423, NULL, 'SSF55961', NULL, NULL, NULL, NULL, 'Bet v1-like', NULL, NULL, NULL, 21),
(286424, NULL, 'SSF158791', NULL, NULL, NULL, NULL, 'MgtE N-terminal domain-like', NULL, NULL, NULL, 21),
(286425, NULL, 'SSF63600', NULL, NULL, NULL, NULL, 'Telomeric repeat binding factor (TRF) dimerisation domain', NULL, NULL, 31023, 21);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(286426, NULL, 'SSF47676', NULL, NULL, NULL, NULL, 'Conserved domain common to transcription factors TFIIS, elongin A, CRSP70', NULL, NULL, 31778, 21),
(286427, NULL, 'SSF103409', NULL, NULL, NULL, NULL, '39 kda initiator binding protein, IBP39, C-terminal domains', NULL, NULL, 26628, 21),
(286428, NULL, 'SSF52913', NULL, NULL, NULL, NULL, 'RNA 3''-terminal phosphate cyclase, RPTC, insert domain', NULL, NULL, 30488, 21),
(286429, NULL, 'SSF140371', NULL, NULL, NULL, NULL, 'Vng1086c-like', NULL, NULL, 32713, 21),
(286430, NULL, 'SSF141004', NULL, NULL, NULL, NULL, 'RelB-like', NULL, NULL, NULL, 21),
(286431, NULL, 'SSF110836', NULL, NULL, NULL, NULL, 'Hypothetical protein SAV1430', NULL, NULL, 31480, 21),
(286432, NULL, 'SSF90246', NULL, NULL, NULL, NULL, 'Head morphogenesis protein gp7', NULL, NULL, 33182, 21),
(286433, NULL, 'SSF74784', NULL, NULL, NULL, NULL, 'Translin', NULL, NULL, 32022, 21),
(286434, NULL, 'SSF102031', NULL, NULL, NULL, NULL, 'AXH domain', NULL, NULL, 27043, 21),
(286435, NULL, 'SSF75181', NULL, NULL, NULL, NULL, 'Hypothetical protein MTH777 (MT0777)', NULL, NULL, 29554, 21),
(286436, NULL, 'SSF101738', NULL, NULL, NULL, NULL, 'SspB-like', NULL, NULL, 27729, 21),
(286437, NULL, 'SSF75169', NULL, NULL, NULL, NULL, 'DsrEFH-like', NULL, NULL, 24633, 21),
(286438, NULL, 'SSF51011', NULL, NULL, NULL, NULL, 'Glycosyl hydrolase domain', NULL, NULL, NULL, 21),
(286439, NULL, 'SSF64518', NULL, NULL, NULL, NULL, 'Phase 1 flagellin', NULL, NULL, NULL, 21),
(286440, NULL, 'SSF56042', NULL, NULL, NULL, NULL, 'PurM C-terminal domain-like', NULL, NULL, 29804, 21),
(286441, NULL, 'SSF159672', NULL, NULL, NULL, NULL, 'CbiG N-terminal domain-like', NULL, NULL, 28703, 21),
(286442, NULL, 'SSF51366', NULL, NULL, NULL, NULL, 'Ribulose-phoshate binding barrel', NULL, NULL, 9315, 21),
(286443, NULL, 'SSF158446', NULL, NULL, NULL, NULL, 'IVS-encoded protein-like', NULL, NULL, 29897, 21),
(286444, NULL, 'SSF110087', NULL, NULL, NULL, NULL, 'DR1885-like metal-binding protein', NULL, NULL, 33198, 21),
(286445, NULL, 'SSF49464', NULL, NULL, NULL, NULL, 'Carboxypeptidase regulatory domain-like', NULL, NULL, 9093, 21),
(286446, NULL, 'SSF55035', NULL, NULL, NULL, NULL, 'NAD-binding domain of HMG-CoA reductase', NULL, NULL, 9992, 21),
(286447, NULL, 'SSF52980', NULL, NULL, NULL, NULL, 'Restriction endonuclease-like', NULL, NULL, 13571, 21),
(286448, NULL, 'SSF82861', NULL, NULL, NULL, NULL, 'Mechanosensitive channel protein MscS (YggB), transmembrane region', NULL, NULL, 9055, 21),
(286449, NULL, 'SSF54782', NULL, NULL, NULL, NULL, 'Porphobilinogen deaminase (hydroxymethylbilane synthase), C-terminal domain', NULL, NULL, 33411, 21),
(286450, NULL, 'SSF159888', NULL, NULL, NULL, NULL, 'YdhG-like', NULL, NULL, NULL, 21),
(286451, NULL, 'SSF50494', NULL, NULL, NULL, NULL, 'Trypsin-like serine proteases', NULL, NULL, 9524, 21),
(286452, NULL, 'SSF55252', NULL, NULL, NULL, NULL, 'C-terminal domain of arginine repressor', NULL, NULL, 30695, 21),
(286453, NULL, 'SSF54556', NULL, NULL, NULL, NULL, 'Chitinase insertion domain', NULL, NULL, 24132, 21),
(286454, NULL, 'SSF101224', NULL, NULL, NULL, NULL, 'HAND domain of the nucleosome remodeling ATPase ISWI', NULL, NULL, 31922, 21),
(286455, NULL, 'SSF52972', NULL, NULL, NULL, NULL, 'ITPase-like', NULL, NULL, 24333, 21),
(286456, NULL, 'SSF48081', NULL, NULL, NULL, NULL, 'Methyl-coenzyme M reductase alpha and beta chain C-terminal domain', NULL, NULL, 8747, 21),
(286457, NULL, 'SSF47823', NULL, NULL, NULL, NULL, 'lambda integrase-like, N-terminal domain', NULL, NULL, NULL, 21),
(286458, NULL, 'SSF116927', NULL, NULL, NULL, NULL, 'EspA/CesA-like', NULL, NULL, 29808, 21),
(286459, NULL, 'SSF75708', NULL, NULL, NULL, NULL, 'Chemotaxis phosphatase CheZ', NULL, NULL, NULL, 21),
(286460, NULL, 'SSF54984', NULL, NULL, NULL, NULL, 'eEF-1beta-like', NULL, NULL, 29711, 21),
(286461, NULL, 'SSF90229', NULL, NULL, NULL, NULL, 'CCCH zinc finger', NULL, NULL, 28471, 21),
(286462, NULL, 'SSF118290', NULL, NULL, NULL, NULL, 'WRKY DNA-binding domain', NULL, NULL, 31292, 21);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(286463, NULL, 'SSF160214', NULL, NULL, NULL, NULL, 'FlaG-like', NULL, NULL, 23322, 21),
(286464, NULL, 'SSF53597', NULL, NULL, NULL, NULL, 'Dihydrofolate reductase-like', NULL, NULL, 18665, 21),
(286465, NULL, 'SSF54552', NULL, NULL, NULL, NULL, 'Colicin E3 immunity protein', NULL, NULL, 33176, 21),
(286466, NULL, 'SSF46596', NULL, NULL, NULL, NULL, 'Eukaryotic DNA topoisomerase I, dispensable insert domain', NULL, NULL, NULL, 21),
(286467, NULL, 'SSF47031', NULL, NULL, NULL, NULL, 'Second domain of FERM', NULL, NULL, 29543, 21),
(286468, NULL, 'SSF64438', NULL, NULL, NULL, NULL, 'CNF1/YfiH-like putative cysteine hydrolases', NULL, NULL, 13698, 21),
(286469, NULL, 'SSF52738', NULL, NULL, NULL, NULL, 'Methylesterase CheB, C-terminal domain', NULL, NULL, 11590, 21),
(286470, NULL, 'SSF57586', NULL, NULL, NULL, NULL, 'TNF receptor-like', NULL, NULL, NULL, 21),
(286471, NULL, 'SSF50447', NULL, NULL, NULL, NULL, 'Translation proteins', NULL, NULL, 9716, 21),
(286472, NULL, 'SSF50692', NULL, NULL, NULL, NULL, 'ADC-like', NULL, NULL, 9614, 21),
(286473, NULL, 'SSF51004', NULL, NULL, NULL, NULL, 'C-terminal (heme d1) domain of cytochrome cd1-nitrite reductase', NULL, NULL, 9079, 21),
(286474, NULL, 'SSF55068', NULL, NULL, NULL, NULL, 'Peptide methionine sulfoxide reductase', NULL, NULL, 30098, 21),
(286475, NULL, 'SSF69255', NULL, NULL, NULL, NULL, 'gp5 N-terminal domain-like', NULL, NULL, NULL, 21),
(286476, NULL, 'SSF50443', NULL, NULL, NULL, NULL, 'FucI/AraA C-terminal domain-like', NULL, NULL, 3596, 21),
(286477, NULL, 'SSF102462', NULL, NULL, NULL, NULL, 'Peptidyl-tRNA hydrolase II', NULL, NULL, 16300, 21),
(286478, NULL, 'SSF52266', NULL, NULL, NULL, NULL, 'SGNH hydrolase', NULL, NULL, NULL, 21),
(286479, NULL, 'SSF55271', NULL, NULL, NULL, NULL, 'DNA repair protein MutS, domain I', NULL, NULL, 11144, 21),
(286480, NULL, 'SSF52255', NULL, NULL, NULL, NULL, 'N5-CAIR mutase (phosphoribosylaminoimidazole carboxylase, PurE)', NULL, NULL, NULL, 21),
(286481, NULL, 'SSF57501', NULL, NULL, NULL, NULL, 'Cystine-knot cytokines', NULL, NULL, 23517, 21),
(286482, NULL, 'SSF82114', NULL, NULL, NULL, NULL, 'Riboflavin kinase-like', NULL, NULL, 16414, 21),
(286483, NULL, 'SSF54675', NULL, NULL, NULL, NULL, 'Nicotinate/Quinolinate PRTase N-terminal domain-like', NULL, NULL, NULL, 21),
(286484, NULL, 'SSF52922', NULL, NULL, NULL, NULL, 'TK C-terminal domain-like', NULL, NULL, 9687, 21),
(286485, NULL, 'SSF48366', NULL, NULL, NULL, NULL, 'Ras GEF', NULL, NULL, 20005, 21),
(286486, NULL, 'SSF161060', NULL, NULL, NULL, NULL, 'ATP synthase B chain-like', NULL, NULL, NULL, 21),
(286487, NULL, 'SSF47240', NULL, NULL, NULL, NULL, 'Ferritin-like', NULL, NULL, 6030, 21),
(286488, NULL, 'SSF117074', NULL, NULL, NULL, NULL, 'Hypothetical protein PA1324', NULL, NULL, NULL, 21),
(286489, NULL, 'SSF140809', NULL, NULL, NULL, NULL, 'Rhabdovirus nucleoprotein-like', NULL, NULL, 27450, 21),
(286490, NULL, 'SSF48350', NULL, NULL, NULL, NULL, 'GTPase activation domain, GAP', NULL, NULL, 8873, 21),
(286491, NULL, 'SSF90242', NULL, NULL, NULL, NULL, 'Dimerization motif of sir4', NULL, NULL, NULL, 21),
(286492, NULL, 'SSF50789', NULL, NULL, NULL, NULL, 'Herpes virus serine proteinase, assemblin', NULL, NULL, NULL, 21),
(286493, NULL, 'SSF103190', NULL, NULL, NULL, NULL, 'Sensory domain-like', NULL, NULL, 25895, 21),
(286494, NULL, 'SSF52279', NULL, NULL, NULL, NULL, 'Beta-D-glucan exohydrolase, C-terminal domain', NULL, NULL, 28576, 21),
(286495, NULL, 'SSF63411', NULL, NULL, NULL, NULL, 'LuxS/MPP-like metallohydrolase', NULL, NULL, 13069, 21),
(286496, NULL, 'SSF46689', NULL, NULL, NULL, NULL, 'Homeodomain-like', NULL, NULL, 6455, 21),
(286497, NULL, 'SSF141666', NULL, NULL, NULL, NULL, '''SARS ORF9b-like', NULL, NULL, 29157, 21),
(286498, NULL, 'SSF55821', NULL, NULL, NULL, NULL, 'YrdC/RibB', NULL, NULL, 2714, 21),
(286499, NULL, 'SSF117100', NULL, NULL, NULL, NULL, 'Beta-galactosidase LacA, domain 3', NULL, NULL, 27517, 21),
(286500, NULL, 'SSF50370', NULL, NULL, NULL, NULL, 'Ricin B-like lectins', NULL, NULL, 21458, 21);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(286501, NULL, 'SSF160059', NULL, NULL, NULL, NULL, 'PriA/YqbF domain', NULL, NULL, NULL, 21),
(286502, NULL, 'SSF56014', NULL, NULL, NULL, NULL, 'Nitrite and sulphite reductase 4Fe-4S domain-like', NULL, NULL, 33838, 21),
(286503, NULL, 'SSF144074', NULL, NULL, NULL, NULL, 'E2F-DP heterodimerization region', NULL, NULL, 31569, 21),
(286504, NULL, 'SSF100950', NULL, NULL, NULL, NULL, 'NagB/RpiA/CoA transferase-like', NULL, NULL, 31817, 21),
(286505, NULL, 'SSF46579', NULL, NULL, NULL, NULL, 'Prefoldin', NULL, NULL, NULL, 21),
(286506, NULL, 'SSF74942', NULL, NULL, NULL, NULL, 'YhbC-like, C-terminal domain', NULL, NULL, 31555, 21),
(286507, NULL, 'SSF56524', NULL, NULL, NULL, NULL, 'Oxidoreductase molybdopterin-binding domain', NULL, NULL, 28430, 21),
(286508, NULL, 'SSF53774', NULL, NULL, NULL, NULL, 'Glutaminase/Asparaginase', NULL, NULL, 28728, 21),
(286509, NULL, 'SSF82051', NULL, NULL, NULL, NULL, 'Obg GTP-binding protein N-terminal domain', NULL, NULL, 31592, 21),
(286510, NULL, 'SSF160472', NULL, NULL, NULL, NULL, 'NMB0513-like', NULL, NULL, 17266, 21),
(286511, NULL, 'SSF140919', NULL, NULL, NULL, NULL, 'DNA terminal protein', NULL, NULL, 31804, 21),
(286512, NULL, 'SSF111469', NULL, NULL, NULL, NULL, 'Geminin coiled-coil domain', NULL, NULL, NULL, 21),
(286513, NULL, 'SSF90188', NULL, NULL, NULL, NULL, 'Somatomedin B domain', NULL, NULL, 27264, 21),
(286514, NULL, 'SSF55116', NULL, NULL, NULL, NULL, 'Formiminotransferase domain of formiminotransferase-cyclodeaminase.', NULL, NULL, 15632, 21),
(286515, NULL, 'SSF82215', NULL, NULL, NULL, NULL, 'C-terminal autoproteolytic domain of nucleoporin nup98', NULL, NULL, 31901, 21),
(286516, NULL, 'SSF141480', NULL, NULL, NULL, NULL, 'Extracellular hemoglobin linker subunit, receptor domain', NULL, NULL, 28789, 21),
(286517, NULL, 'SSF102522', NULL, NULL, NULL, NULL, 'Bacterial fluorinating enzyme, N-terminal domain', NULL, NULL, 12315, 21),
(286518, NULL, 'SSF55331', NULL, NULL, NULL, NULL, 'Tautomerase/MIF', NULL, NULL, 12729, 21),
(286519, NULL, 'SSF49606', NULL, NULL, NULL, NULL, 'Neurophysin II', NULL, NULL, 27535, 21),
(286520, NULL, 'SSF50465', NULL, NULL, NULL, NULL, 'EF-Tu/eEF-1alpha/eIF2-gamma C-terminal domain', NULL, NULL, 9634, 21),
(286521, NULL, 'SSF109915', NULL, NULL, NULL, NULL, 'Hypothetical protein YhaI', NULL, NULL, 12204, 21),
(286522, NULL, 'SSF141694', NULL, NULL, NULL, NULL, 'AF2212/PG0164-like', NULL, NULL, NULL, 21),
(286523, NULL, 'SSF57938', NULL, NULL, NULL, NULL, 'DnaJ/Hsp40 cysteine-rich domain', NULL, NULL, 31740, 21),
(286524, NULL, 'SSF48479', NULL, NULL, NULL, NULL, 'Cytochrome c oxidase subunit E', NULL, NULL, 33106, 21),
(286525, NULL, 'SSF69070', NULL, NULL, NULL, NULL, 'Anti-sigma factor AsiA', NULL, NULL, 31366, 21),
(286526, NULL, 'SSF69360', NULL, NULL, NULL, NULL, 'Cell wall binding repeat', NULL, NULL, NULL, 21),
(286527, NULL, 'SSF48310', NULL, NULL, NULL, NULL, 'Aldehyde ferredoxin oxidoreductase, C-terminal domains', NULL, NULL, 32646, 21),
(286528, NULL, 'SSF64153', NULL, NULL, NULL, NULL, 'YjeF N-terminal domain-like', NULL, NULL, 28663, 21),
(286529, NULL, 'SSF89811', NULL, NULL, NULL, NULL, 'Amyloid beta a4 protein copper binding domain (domain 2)', NULL, NULL, 31939, 21),
(286530, NULL, 'SSF63724', NULL, NULL, NULL, NULL, 'Cytolysin/lectin', NULL, NULL, 8312, 21),
(286531, NULL, 'SSF143575', NULL, NULL, NULL, NULL, 'GAS2 domain-like', NULL, NULL, 33117, 21),
(286532, NULL, 'SSF55144', NULL, NULL, NULL, NULL, 'LigT-like', NULL, NULL, 14211, 21),
(286533, NULL, 'SSF110581', NULL, NULL, NULL, NULL, 'Indigoidine synthase A-like', NULL, NULL, 17149, 21),
(286534, NULL, 'SSF81790', NULL, NULL, NULL, NULL, 'Myosin phosphatase inhibitor 17kDa protein, CPI-17', NULL, NULL, 29823, 21),
(286535, NULL, 'SSF52087', NULL, NULL, NULL, NULL, 'CRAL/TRIO domain', NULL, NULL, 28268, 21),
(286536, NULL, 'SSF75347', NULL, NULL, NULL, NULL, 'Rotavirus NSP2 fragment, C-terminal domain', NULL, NULL, 18818, 21),
(286537, NULL, 'SSF143076', NULL, NULL, NULL, NULL, 'Coronavirus NSP8-like', NULL, NULL, 29079, 21);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(286538, NULL, 'SSF48256', NULL, NULL, NULL, NULL, 'Citrate synthase', NULL, NULL, 28504, 21),
(286539, NULL, 'SSF54719', NULL, NULL, NULL, NULL, 'Fe,Mn superoxide dismutase (SOD), C-terminal domain', NULL, NULL, 29322, 21),
(286540, NULL, 'SSF143968', NULL, NULL, NULL, NULL, 'UbiD C-terminal domain-like', NULL, NULL, NULL, 21),
(286541, NULL, 'SSF51069', NULL, NULL, NULL, NULL, 'Carbonic anhydrase', NULL, NULL, 31669, 21),
(286542, NULL, 'SSF52490', NULL, NULL, NULL, NULL, 'Tubulin nucleotide-binding domain-like', NULL, NULL, 32754, 21),
(286543, NULL, 'SSF75569', NULL, NULL, NULL, NULL, 'Archaeal IMP cyclohydrolase PurO', NULL, NULL, 33148, 21),
(286544, NULL, 'SSF48600', NULL, NULL, NULL, NULL, 'Chorismate mutase II', NULL, NULL, 30636, 21),
(286545, NULL, 'SSF56762', NULL, NULL, NULL, NULL, 'HydB/Nqo4-like', NULL, NULL, 21549, 21),
(286546, NULL, 'SSF90123', NULL, NULL, NULL, NULL, 'ABC transporter transmembrane region', NULL, NULL, 27004, 21),
(286547, NULL, 'SSF57959', NULL, NULL, NULL, NULL, 'Leucine zipper domain', NULL, NULL, 37556, 21),
(286548, NULL, 'SSF51322', NULL, NULL, NULL, NULL, 'Cyanovirin-N', NULL, NULL, 29673, 21),
(286549, NULL, 'SSF54806', NULL, NULL, NULL, NULL, 'Alpha-lytic protease prodomain', NULL, NULL, 29839, 21),
(286550, NULL, 'SSF52096', NULL, NULL, NULL, NULL, 'ClpP/crotonase', NULL, NULL, 24218, 21),
(286551, NULL, 'SSF69618', NULL, NULL, NULL, NULL, 'HemD-like', NULL, NULL, 32642, 21),
(286552, NULL, 'SSF54506', NULL, NULL, NULL, NULL, 'Diaminopimelate epimerase-like', NULL, NULL, NULL, 21),
(286553, NULL, 'SSF50615', NULL, NULL, NULL, NULL, 'N-terminal domain of alpha and beta subunits of F1 ATP synthase', NULL, NULL, 33252, 21),
(286554, NULL, 'SSF54637', NULL, NULL, NULL, NULL, 'Thioesterase/thiol ester dehydrase-isomerase', NULL, NULL, 24895, 21),
(286555, NULL, 'SSF54518', NULL, NULL, NULL, NULL, 'Tubby C-terminal domain-like', NULL, NULL, 23935, 21),
(286556, NULL, 'SSF116960', NULL, NULL, NULL, NULL, 'YfbU-like', NULL, NULL, NULL, 21),
(286557, NULL, 'SSF47979', NULL, NULL, NULL, NULL, 'Iron-dependent repressor protein, dimerization domain', NULL, NULL, 27747, 21),
(286558, NULL, 'SSF68930', NULL, NULL, NULL, NULL, 'Protein-L-isoaspartyl O-methyltransferase, C-terminal domain', NULL, NULL, 7655, 21),
(286559, NULL, 'SSF109709', NULL, NULL, NULL, NULL, 'KorB DNA-binding domain-like', NULL, NULL, NULL, 21),
(286560, NULL, 'SSF82771', NULL, NULL, NULL, NULL, 'GIY-YIG endonuclease', NULL, NULL, 13544, 21),
(286561, NULL, 'SSF57027', NULL, NULL, NULL, NULL, 'Plant inhibitors of proteinases and amylases', NULL, NULL, 9419, 21),
(286562, NULL, 'SSF54441', NULL, NULL, NULL, NULL, 'Uracil-DNA glycosylase inhibitor protein', NULL, NULL, 8162, 21),
(286563, NULL, 'SSF117856', NULL, NULL, NULL, NULL, 'AF0104/ALDC/Ptd012-like', NULL, NULL, NULL, 21),
(286564, NULL, 'SSF102824', NULL, NULL, NULL, NULL, 'Colicin D/E5 nuclease domain', NULL, NULL, 27296, 21),
(286565, NULL, 'SSF118370', NULL, NULL, NULL, NULL, 'Vasodilator-stimulated phosphoprotein, VASP, tetramerisation domain', NULL, NULL, 33607, 21),
(286566, NULL, 'SSF111304', NULL, NULL, NULL, NULL, 'Recombination protein RecR', NULL, NULL, 14864, 21),
(286567, NULL, 'SSF75615', NULL, NULL, NULL, NULL, 'Siroheme synthase middle domains-like', NULL, NULL, NULL, 21),
(286568, NULL, 'SSF56837', NULL, NULL, NULL, NULL, 'Colicin', NULL, NULL, NULL, 21),
(286569, NULL, 'SSF82607', NULL, NULL, NULL, NULL, 'YbaB-like', NULL, NULL, 28897, 21),
(286570, NULL, 'SSF109747', NULL, NULL, NULL, NULL, 'Glycogen synthesis protein GlgS', NULL, NULL, 31663, 21),
(286571, NULL, 'SSF103589', NULL, NULL, NULL, NULL, 'Mini-collagen I, C-terminal domain', NULL, NULL, 31656, 21),
(286572, NULL, 'SSF160980', NULL, NULL, NULL, NULL, 'SSO1389-like', NULL, NULL, NULL, 21),
(286573, NULL, 'SSF57825', NULL, NULL, NULL, NULL, 'Aspartate carbamoyltransferase, Regulatory-chain, C-terminal domain', NULL, NULL, 33405, 21),
(286574, NULL, 'SSF140453', NULL, NULL, NULL, NULL, 'EsxAB dimer-like', NULL, NULL, 32303, 21),
(286575, NULL, 'SSF51717', NULL, NULL, NULL, NULL, 'Dihydropteroate synthetase-like', NULL, NULL, 8630, 21);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(286576, NULL, 'SSF75011', NULL, NULL, NULL, NULL, '3-carboxy-cis,cis-mucoante lactonizing enzyme', NULL, NULL, NULL, 21),
(286577, NULL, 'SSF47938', NULL, NULL, NULL, NULL, 'Functional domain of the splicing factor Prp18', NULL, NULL, NULL, 21),
(286578, NULL, 'SSF56214', NULL, NULL, NULL, NULL, '4''-phosphopantetheinyl transferase', NULL, NULL, 28137, 21),
(286579, NULL, 'SSF159594', NULL, NULL, NULL, NULL, 'XCC0632-like', NULL, NULL, NULL, 21),
(286580, NULL, 'SSF51294', NULL, NULL, NULL, NULL, 'Hedgehog/intein (Hint) domain', NULL, NULL, 31856, 21),
(286581, NULL, 'SSF161270', NULL, NULL, NULL, NULL, 'PspA lactotransferrin-binding region', NULL, NULL, NULL, 21),
(286582, NULL, 'SSF55666', NULL, NULL, NULL, NULL, 'Ribonuclease PH domain 2-like', NULL, NULL, 28136, 21),
(286583, NULL, 'SSF141986', NULL, NULL, NULL, NULL, 'LD-carboxypeptidase A C-terminal domain-like', NULL, NULL, 24784, 21),
(286584, NULL, 'SSF47396', NULL, NULL, NULL, NULL, 'Transcription factor IIA (TFIIA), alpha-helical domain', NULL, NULL, NULL, 21),
(286585, NULL, 'SSF47152', NULL, NULL, NULL, NULL, 'Methane monooxygenase hydrolase, gamma subunit', NULL, NULL, 31478, 21),
(286586, NULL, 'SSF160246', NULL, NULL, NULL, NULL, 'EspE N-terminal domain-like', NULL, NULL, 32416, 21),
(286587, NULL, 'SSF51120', NULL, NULL, NULL, NULL, 'beta-Roll', NULL, NULL, 9423, 21),
(286588, NULL, 'SSF103277', NULL, NULL, NULL, NULL, 'Hypothetical protein HI1480', NULL, NULL, 31598, 21),
(286589, NULL, 'SSF82061', NULL, NULL, NULL, NULL, 'BAH domain', NULL, NULL, NULL, 21),
(286590, NULL, 'SSF68918', NULL, NULL, NULL, NULL, 'Recombination endonuclease VII, C-terminal and dimerization domains', NULL, NULL, 31632, 21),
(286591, NULL, 'SSF57302', NULL, NULL, NULL, NULL, 'Snake toxin-like', NULL, NULL, 34199, 21),
(286592, NULL, 'SSF51984', NULL, NULL, NULL, NULL, 'MurCD N-terminal domain', NULL, NULL, NULL, 21),
(286593, NULL, 'SSF101420', NULL, NULL, NULL, NULL, 'C-terminal domain of Ku80', NULL, NULL, 31308, 21),
(286594, NULL, 'SSF57850', NULL, NULL, NULL, NULL, 'RING/U-box', NULL, NULL, NULL, 21),
(286595, NULL, 'SSF56024', NULL, NULL, NULL, NULL, 'Phospholipase D/nuclease', NULL, NULL, NULL, 21),
(286596, NULL, 'SSF48108', NULL, NULL, NULL, NULL, 'Carbamoyl phosphate synthetase, large subunit connection domain', NULL, NULL, 28950, 21),
(286597, NULL, 'SSF158418', NULL, NULL, NULL, NULL, 'SO2669-like', NULL, NULL, NULL, 21),
(286598, NULL, 'SSF143422', NULL, NULL, NULL, NULL, 'Transposase IS200-like', NULL, NULL, 30215, 21),
(286599, NULL, 'SSF143744', NULL, NULL, NULL, NULL, 'GlcG-like', NULL, NULL, 31360, 21),
(286600, NULL, 'SSF53218', NULL, NULL, NULL, NULL, 'Molybdenum cofactor biosynthesis proteins', NULL, NULL, 27832, 21),
(286601, NULL, 'SSF47719', NULL, NULL, NULL, NULL, 'p53 tetramerization domain', NULL, NULL, 29578, 21),
(286602, NULL, 'SSF161229', NULL, NULL, NULL, NULL, 'E6 C-terminal domain-like', NULL, NULL, 32353, 21),
(286603, NULL, 'SSF109775', NULL, NULL, NULL, NULL, 'Mannose-6-phosphate receptor binding protein 1 (Tip47), C-terminal domain', NULL, NULL, NULL, 21),
(286604, NULL, 'SSF47353', NULL, NULL, NULL, NULL, 'Retrovirus capsid dimerization domain-like', NULL, NULL, NULL, 21),
(286605, NULL, 'SSF110391', NULL, NULL, NULL, NULL, 'GlpP-like', NULL, NULL, NULL, 21),
(286606, NULL, 'SSF58096', NULL, NULL, NULL, NULL, 'Colicin Ia, N-terminal domain', NULL, NULL, 12034, 21),
(286607, NULL, 'SSF50630', NULL, NULL, NULL, NULL, 'Acid proteases', NULL, NULL, 15382, 21),
(286608, NULL, 'SSF57492', NULL, NULL, NULL, NULL, 'Trefoil', NULL, NULL, 36039, 21),
(286609, NULL, 'SSF109631', NULL, NULL, NULL, NULL, 'Transcriptional repressor TraM', NULL, NULL, 27874, 21),
(286610, NULL, 'SSF55044', NULL, NULL, NULL, NULL, 'TRADD, N-terminal domain', NULL, NULL, 32444, 21),
(286611, NULL, 'SSF160719', NULL, NULL, NULL, NULL, 'gpW/gp25-like', NULL, NULL, NULL, 21),
(286612, NULL, 'SSF103436', NULL, NULL, NULL, NULL, 'PetL subunit of the cytochrome b6f complex', NULL, NULL, NULL, 21),
(286613, NULL, 'SSF56925', NULL, NULL, NULL, NULL, 'OMPA-like', NULL, NULL, 13245, 21);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(286614, NULL, 'SSF57196', NULL, NULL, NULL, NULL, 'EGF/Laminin', NULL, NULL, NULL, 21),
(286615, NULL, 'SSF48045', NULL, NULL, NULL, NULL, 'Scaffolding protein gpD of bacteriophage procapsid', NULL, NULL, 30523, 21),
(286616, NULL, 'SSF69917', NULL, NULL, NULL, NULL, 'OMPT-like', NULL, NULL, 16157, 21),
(286617, NULL, 'SSF101542', NULL, NULL, NULL, NULL, 'Fungal immunomodulatory protein, FIP', NULL, NULL, 27892, 21),
(286618, NULL, 'SSF52954', NULL, NULL, NULL, NULL, 'Class II aaRS ABD-related', NULL, NULL, NULL, 21),
(286619, NULL, 'SSF111342', NULL, NULL, NULL, NULL, 'CbiD-like', NULL, NULL, 32324, 21),
(286620, NULL, 'SSF53254', NULL, NULL, NULL, NULL, 'Phosphoglycerate mutase-like', NULL, NULL, 24454, 21),
(286621, NULL, 'SSF103657', NULL, NULL, NULL, NULL, 'BAR/IMD domain-like', NULL, NULL, 17289, 21),
(286622, NULL, 'SSF49742', NULL, NULL, NULL, NULL, 'PHM/PNGase F', NULL, NULL, 9189, 21),
(286623, NULL, 'SSF81452', NULL, NULL, NULL, NULL, 'Cytochrome c oxidase subunit III-like', NULL, NULL, 18477, 21),
(286624, NULL, 'SSF52788', NULL, NULL, NULL, NULL, 'Phosphotyrosine protein phosphatases I', NULL, NULL, 29334, 21),
(286625, NULL, 'SSF111074', NULL, NULL, NULL, NULL, 'Bacillus phage protein', NULL, NULL, 21705, 21),
(286626, NULL, 'SSF63393', NULL, NULL, NULL, NULL, 'RNA polymerase subunits', NULL, NULL, 24336, 21),
(286627, NULL, 'SSF161041', NULL, NULL, NULL, NULL, 'Photosystem II reaction center protein I, PsbI', NULL, NULL, 32886, 21),
(286628, NULL, 'SSF54534', NULL, NULL, NULL, NULL, 'FKBP-like', NULL, NULL, NULL, 21),
(286629, NULL, 'SSF143737', NULL, NULL, NULL, NULL, 'YeeU-like', NULL, NULL, 27234, 21),
(286630, NULL, 'SSF47986', NULL, NULL, NULL, NULL, 'DEATH domain', NULL, NULL, 9051, 21),
(286631, NULL, 'SSF53800', NULL, NULL, NULL, NULL, 'Chelatase', NULL, NULL, NULL, 21),
(286632, NULL, 'SSF158397', NULL, NULL, NULL, NULL, 'TM1646-like', NULL, NULL, 18789, 21),
(286633, NULL, 'SSF81631', NULL, NULL, NULL, NULL, 'PAP/OAS1 substrate-binding domain', NULL, NULL, NULL, 21),
(286634, NULL, 'SSF55811', NULL, NULL, NULL, NULL, 'Nudix', NULL, NULL, 12964, 21),
(286635, NULL, 'SSF48464', NULL, NULL, NULL, NULL, 'ENTH/VHS domain', NULL, NULL, 8986, 21),
(286636, NULL, 'SSF81648', NULL, NULL, NULL, NULL, 'a domain/subunit of cytochrome bc1 complex (Ubiquinol-cytochrome c reductase)', NULL, NULL, 28692, 21),
(286637, NULL, 'SSF103054', NULL, NULL, NULL, NULL, 'General secretion pathway protein M, EpsM', NULL, NULL, 8178, 21),
(286638, NULL, 'SSF82784', NULL, NULL, NULL, NULL, 'OsmC-like', NULL, NULL, 27132, 21),
(286639, NULL, 'SSF47413', NULL, NULL, NULL, NULL, 'lambda repressor-like DNA-binding domains', NULL, NULL, 8252, 21),
(286640, NULL, 'SSF161025', NULL, NULL, NULL, NULL, 'Photosystem II 10 kDa phosphoprotein PsbH', NULL, NULL, 28315, 21),
(286641, NULL, 'SSF58064', NULL, NULL, NULL, NULL, 'Influenza hemagglutinin (stalk)', NULL, NULL, NULL, 21),
(286642, NULL, 'SSF160453', NULL, NULL, NULL, NULL, 'PB2 C-terminal domain-like', NULL, NULL, 32404, 21),
(286643, NULL, 'SSF55287', NULL, NULL, NULL, NULL, 'RPB5-like RNA polymerase subunit', NULL, NULL, 19131, 21),
(286644, NULL, 'SSF101473', NULL, NULL, NULL, NULL, 'DhaL-like', NULL, NULL, 32800, 21),
(286645, NULL, 'SSF53927', NULL, NULL, NULL, NULL, 'Cytidine deaminase-like', NULL, NULL, 18141, 21),
(286646, NULL, 'SSF54184', NULL, NULL, NULL, NULL, 'Penicillin-binding protein 2x (pbp-2x), c-terminal domain', NULL, NULL, NULL, 21),
(286647, NULL, 'SSF53639', NULL, NULL, NULL, NULL, 'AraD/HMP-PK domain-like', NULL, NULL, 31700, 21),
(286648, NULL, 'SSF46767', NULL, NULL, NULL, NULL, 'Methylated DNA-protein cysteine methyltransferase, C-terminal domain', NULL, NULL, 29917, 21),
(286649, NULL, 'SSF102860', NULL, NULL, NULL, NULL, 'mRNA decapping enzyme DcpS N-terminal domain', NULL, NULL, 9172, 21),
(286650, NULL, 'SSF159203', NULL, NULL, NULL, NULL, 'NifT/FixU-like', NULL, NULL, 18964, 21),
(286651, NULL, 'SSF49599', NULL, NULL, NULL, NULL, 'TRAF domain-like', NULL, NULL, NULL, 21),
(286652, NULL, 'SSF110921', NULL, NULL, NULL, NULL, '2-isopropylmalate synthase LeuA, allosteric (dimerisation) domain', NULL, NULL, 29746, 21);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(286653, NULL, 'SSF48230', NULL, NULL, NULL, NULL, 'Chondroitin AC/alginate lyase', NULL, NULL, 8627, 21),
(286654, NULL, 'SSF69099', NULL, NULL, NULL, NULL, 'Ran-GTPase activating protein 1 (RanGAP1), C-terminal domain', NULL, NULL, 32243, 21),
(286655, NULL, 'SSF75404', NULL, NULL, NULL, NULL, 'VSV matrix protein', NULL, NULL, 33665, 21),
(286656, NULL, 'SSF56003', NULL, NULL, NULL, NULL, 'Molybdenum cofactor-binding domain', NULL, NULL, 29719, 21),
(286657, NULL, 'SSF81822', NULL, NULL, NULL, NULL, 'RuBisCo LSMT C-terminal, substrate-binding domain', NULL, NULL, 31276, 21),
(286658, NULL, 'SSF140856', NULL, NULL, NULL, NULL, 'USP8 N-terminal domain-like', NULL, NULL, NULL, 21),
(286659, NULL, 'SSF55190', NULL, NULL, NULL, NULL, 'Arginyl-tRNA synthetase (ArgRS), N-terminal ''additional'' domain', NULL, NULL, 31707, 21),
(286660, NULL, 'SSF82679', NULL, NULL, NULL, NULL, 'N-utilization substance G protein NusG, N-terminal domain', NULL, NULL, 31513, 21),
(286661, NULL, 'SSF53244', NULL, NULL, NULL, NULL, 'MurD-like peptide ligases, peptide-binding domain', NULL, NULL, 30009, 21),
(286662, NULL, 'SSF51261', NULL, NULL, NULL, NULL, 'Duplicated hybrid motif', NULL, NULL, 9063, 21),
(286663, NULL, 'SSF69203', NULL, NULL, NULL, NULL, 'Nucleoplasmin-like core domain', NULL, NULL, 27919, 21),
(286664, NULL, 'SSF140500', NULL, NULL, NULL, NULL, 'BAS1536-like', NULL, NULL, 33263, 21),
(286665, NULL, 'SSF88697', NULL, NULL, NULL, NULL, 'PUA domain-like', NULL, NULL, 8131, 21),
(286666, NULL, 'SSF101288', NULL, NULL, NULL, NULL, 'L27 domain', NULL, NULL, 28767, 21),
(286667, NULL, 'SSF142754', NULL, NULL, NULL, NULL, 'NadA-like', NULL, NULL, 27425, 21),
(286668, NULL, 'SSF46906', NULL, NULL, NULL, NULL, 'Ribosomal protein L11, C-terminal domain', NULL, NULL, 33276, 21),
(286669, NULL, 'SSF50965', NULL, NULL, NULL, NULL, 'Galactose oxidase, central domain', NULL, NULL, 9314, 21),
(286670, NULL, 'SSF55753', NULL, NULL, NULL, NULL, 'Actin depolymerizing proteins', NULL, NULL, NULL, 21),
(286671, NULL, 'SSF103365', NULL, NULL, NULL, NULL, 'Hypothetical protein PH1602', NULL, NULL, 27214, 21),
(286672, NULL, 'SSF48726', NULL, NULL, NULL, NULL, 'Immunoglobulin', NULL, NULL, 33243, 21),
(286673, NULL, 'SSF49410', NULL, NULL, NULL, NULL, 'Alpha-macroglobulin receptor domain', NULL, NULL, 33572, 21),
(286674, NULL, 'SSF81327', NULL, NULL, NULL, NULL, 'Small-conductance potassium channel', NULL, NULL, 31118, 21),
(286675, NULL, 'SSF54966', NULL, NULL, NULL, NULL, 'RuBisCO, large subunit, small (N-terminal) domain', NULL, NULL, 31386, 21),
(286676, NULL, 'SSF160527', NULL, NULL, NULL, NULL, 'V-type ATPase subunit E-like', NULL, NULL, NULL, 21),
(286677, NULL, 'SSF102110', NULL, NULL, NULL, NULL, '(2r)-phospho-3-sulfolactate synthase ComA', NULL, NULL, 32781, 21),
(286678, NULL, 'SSF158842', NULL, NULL, NULL, NULL, 'PMT central region-like', NULL, NULL, NULL, 21),
(286679, NULL, 'SSF47762', NULL, NULL, NULL, NULL, 'PAH2 domain', NULL, NULL, 32700, 21),
(286680, NULL, 'SSF64602', NULL, NULL, NULL, NULL, 'F1 ATPase inhibitor, IF1, C-terminal domain', NULL, NULL, NULL, 21),
(286681, NULL, 'SSF158668', NULL, NULL, NULL, NULL, 'MtlR-like', NULL, NULL, 31690, 21),
(286682, NULL, 'SSF109805', NULL, NULL, NULL, NULL, 'Phenylalanine zipper', NULL, NULL, 31665, 21),
(286683, NULL, 'SSF56973', NULL, NULL, NULL, NULL, 'Aerolisin/ETX pore-forming domain', NULL, NULL, NULL, 21),
(286684, NULL, 'SSF89975', NULL, NULL, NULL, NULL, 'Hypothetical protein Yml108w', NULL, NULL, 14967, 21),
(286685, NULL, 'SSF47157', NULL, NULL, NULL, NULL, 'Mitochondrial import receptor subunit Tom20', NULL, NULL, 15889, 21),
(286686, NULL, 'SSF50104', NULL, NULL, NULL, NULL, 'Translation proteins SH3-like domain', NULL, NULL, 9990, 21),
(286687, NULL, 'SSF55653', NULL, NULL, NULL, NULL, 'Ribosomal protein L9 C-domain', NULL, NULL, 33153, 21),
(286688, NULL, 'SSF158452', NULL, NULL, NULL, NULL, 'YqcC-like', NULL, NULL, 27591, 21),
(286689, NULL, 'SSF47226', NULL, NULL, NULL, NULL, 'Histidine-containing phosphotransfer domain, HPT domain', NULL, NULL, 28021, 21);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(286690, NULL, 'SSF143437', NULL, NULL, NULL, NULL, 'THUMP domain-like', NULL, NULL, NULL, 21),
(286691, NULL, 'SSF55149', NULL, NULL, NULL, NULL, 'Pepsin inhibitor-3', NULL, NULL, NULL, 21),
(286692, NULL, 'SSF111357', NULL, NULL, NULL, NULL, 'Mitochondrial ATP synthase coupling factor 6', NULL, NULL, 33662, 21),
(286693, NULL, 'SSF160964', NULL, NULL, NULL, NULL, 'MalF N-terminal region-like', NULL, NULL, NULL, 21),
(286694, NULL, 'SSF89946', NULL, NULL, NULL, NULL, 'Hypothetical protein VC0424', NULL, NULL, 29859, 21),
(286695, NULL, 'SSF158568', NULL, NULL, NULL, NULL, 'AF1862-like', NULL, NULL, 15755, 21),
(286696, NULL, 'SSF51161', NULL, NULL, NULL, NULL, 'Trimeric LpxA-like enzymes', NULL, NULL, 8816, 21),
(286697, NULL, 'SSF74653', NULL, NULL, NULL, NULL, 'TolA/TonB C-terminal domain', NULL, NULL, NULL, 21),
(286698, NULL, 'SSF69000', NULL, NULL, NULL, NULL, 'FAD-dependent thiol oxidase', NULL, NULL, 27162, 21),
(286699, NULL, 'SSF55711', NULL, NULL, NULL, NULL, 'Subdomain of clathrin and coatomer appendage domain', NULL, NULL, 9510, 21),
(286700, NULL, 'SSF69864', NULL, NULL, NULL, NULL, 'Argininosuccinate synthetase, C-terminal domain', NULL, NULL, 12370, 21),
(286701, NULL, 'SSF51269', NULL, NULL, NULL, NULL, 'AFP III-like domain', NULL, NULL, 31519, 21),
(286702, NULL, 'SSF51283', NULL, NULL, NULL, NULL, 'dUTPase-like', NULL, NULL, 30655, 21),
(286703, NULL, 'SSF57059', NULL, NULL, NULL, NULL, 'omega toxin-like', NULL, NULL, NULL, 21),
(286704, NULL, 'SSF110395', NULL, NULL, NULL, NULL, 'CutC-like', NULL, NULL, 27912, 21),
(286705, NULL, 'SSF49309', NULL, NULL, NULL, NULL, 'Transglutaminase, two C-terminal domains', NULL, NULL, 28296, 21),
(286706, NULL, 'SSF100879', NULL, NULL, NULL, NULL, 'Lesion bypass DNA polymerase (Y-family), little finger domain', NULL, NULL, 31791, 21),
(286707, NULL, 'SSF48657', NULL, NULL, NULL, NULL, 'FinO-like', NULL, NULL, 31870, 21),
(286708, NULL, 'SSF140996', NULL, NULL, NULL, NULL, 'Hermes dimerisation domain', NULL, NULL, NULL, 21),
(286709, NULL, 'SSF56209', NULL, NULL, NULL, NULL, 'Nitrile hydratase alpha chain', NULL, NULL, 30545, 21),
(286710, NULL, 'SSF52080', NULL, NULL, NULL, NULL, 'Ribosomal proteins L15p and L18e', NULL, NULL, 33022, 21),
(286711, NULL, 'SSF57277', NULL, NULL, NULL, NULL, 'Granulin repeat', NULL, NULL, NULL, 21),
(286712, NULL, 'SSF52038', NULL, NULL, NULL, NULL, 'Barstar-related', NULL, NULL, 11447, 21),
(286713, NULL, 'SSF88713', NULL, NULL, NULL, NULL, 'Glycoside hydrolase/deacetylase', NULL, NULL, 13786, 21),
(286714, NULL, 'SSF158212', NULL, NULL, NULL, NULL, 'Htr2 transmembrane domain-like', NULL, NULL, NULL, 21),
(286715, NULL, 'SSF101391', NULL, NULL, NULL, NULL, 'Hsp90 co-chaperone CDC37', NULL, NULL, NULL, 21),
(286716, NULL, 'SSF57184', NULL, NULL, NULL, NULL, 'Growth factor receptor domain', NULL, NULL, 9573, 21),
(286717, NULL, 'SSF55174', NULL, NULL, NULL, NULL, 'Alpha-L RNA-binding motif', NULL, NULL, NULL, 21),
(286718, NULL, 'SSF141530', NULL, NULL, NULL, NULL, 'PTSIIA/GutA-like', NULL, NULL, 28934, 21),
(286719, NULL, 'SSF51430', NULL, NULL, NULL, NULL, 'NAD(P)-linked oxidoreductase', NULL, NULL, 33295, 21),
(286720, NULL, 'SSF51649', NULL, NULL, NULL, NULL, 'RuBisCo, C-terminal domain', NULL, NULL, 32224, 21),
(286721, NULL, 'SSF56988', NULL, NULL, NULL, NULL, 'Anthrax protective antigen', NULL, NULL, NULL, 21),
(286722, NULL, 'SSF82657', NULL, NULL, NULL, NULL, 'BolA-like', NULL, NULL, 29811, 21),
(286723, NULL, 'SSF56104', NULL, NULL, NULL, NULL, 'SAICAR synthase-like', NULL, NULL, NULL, 21),
(286724, NULL, 'SSF89890', NULL, NULL, NULL, NULL, 'Proguanylin', NULL, NULL, 32312, 21),
(286725, NULL, 'SSF48029', NULL, NULL, NULL, NULL, 'FliG', NULL, NULL, 8547, 21),
(286726, NULL, 'SSF142695', NULL, NULL, NULL, NULL, 'RibA-like', NULL, NULL, 28568, 21),
(286727, NULL, 'SSF89817', NULL, NULL, NULL, NULL, 'Mago nashi protein', NULL, NULL, 32971, 21),
(286728, NULL, 'SSF81345', NULL, NULL, NULL, NULL, 'ABC transporter involved in vitamin B12 uptake, BtuC', NULL, NULL, 29894, 21),
(286729, NULL, 'SSF46992', NULL, NULL, NULL, NULL, 'Ribosomal protein S20', NULL, NULL, 30390, 21);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(286730, NULL, 'SSF102546', NULL, NULL, NULL, NULL, 'RbsD-like', NULL, NULL, 10633, 21),
(286731, NULL, 'SSF53748', NULL, NULL, NULL, NULL, 'Phosphoglycerate kinase', NULL, NULL, 32027, 21),
(286732, NULL, 'SSF101278', NULL, NULL, NULL, NULL, 'N-terminal domain of adenylylcyclase associated protein, CAP', NULL, NULL, 29881, 21),
(286733, NULL, 'SSF102400', NULL, NULL, NULL, NULL, 'DNA polymerase III chi subunit', NULL, NULL, 33492, 21),
(286734, NULL, 'SSF56317', NULL, NULL, NULL, NULL, 'Carbon-nitrogen hydrolase', NULL, NULL, 33384, 21),
(286735, NULL, 'SSF50486', NULL, NULL, NULL, NULL, 'FMT C-terminal domain-like', NULL, NULL, 9138, 21),
(286736, NULL, 'SSF160272', NULL, NULL, NULL, NULL, 'Shew3726-like', NULL, NULL, 29914, 21),
(286737, NULL, 'SSF50037', NULL, NULL, NULL, NULL, 'C-terminal domain of transcriptional repressors', NULL, NULL, 9938, 21),
(286738, NULL, 'SSF64376', NULL, NULL, NULL, NULL, 'YlxR-like', NULL, NULL, 29948, 21),
(286739, NULL, 'SSF101160', NULL, NULL, NULL, NULL, 'Dimerisation domain of CENP-B', NULL, NULL, 10109, 21),
(286740, NULL, 'SSF140607', NULL, NULL, NULL, NULL, 'EF2947-like', NULL, NULL, 33091, 21),
(286741, NULL, 'SSF47644', NULL, NULL, NULL, NULL, 'Methionine synthase domain', NULL, NULL, 32861, 21),
(286742, NULL, 'SSF118001', NULL, NULL, NULL, NULL, 'YehU-like', NULL, NULL, 29691, 21),
(286743, NULL, 'SSF160887', NULL, NULL, NULL, NULL, 'Rv2827c C-terminal domain-like', NULL, NULL, NULL, 21),
(286744, NULL, 'SSF81544', NULL, NULL, NULL, NULL, 'Subunit IX of photosystem I reaction centre, PsaJ', NULL, NULL, 29969, 21),
(286745, NULL, 'SSF159133', NULL, NULL, NULL, NULL, 'EutN/CcmL-like', NULL, NULL, 28998, 21),
(286746, NULL, 'SSF160219', NULL, NULL, NULL, NULL, 'AMPKBI-like', NULL, NULL, 32052, 21),
(286747, NULL, 'SSF143212', NULL, NULL, NULL, NULL, 'Rv2632c-like', NULL, NULL, 30804, 21),
(286748, NULL, 'SSF103383', NULL, NULL, NULL, NULL, 'Antivirulence factor', NULL, NULL, 28185, 21),
(286749, NULL, 'SSF140931', NULL, NULL, NULL, NULL, 'Fic-like', NULL, NULL, 32545, 21),
(286750, NULL, 'SSF111321', NULL, NULL, NULL, NULL, 'AF1104-like', NULL, NULL, 32132, 21),
(286751, NULL, 'SSF52949', NULL, NULL, NULL, NULL, 'Macro domain-like', NULL, NULL, 34548, 21),
(286752, NULL, 'SSF89064', NULL, NULL, NULL, NULL, 'Replisome organizer (g39p helicase loader/inhibitor protein)', NULL, NULL, 31809, 21),
(286753, NULL, 'SSF63562', NULL, NULL, NULL, NULL, 'RPB6/omega subunit-like', NULL, NULL, 30145, 21),
(286754, NULL, 'SSF58104', NULL, NULL, NULL, NULL, 'Methyl-accepting chemotaxis protein (MCP) signaling domain', NULL, NULL, NULL, 21),
(286755, NULL, 'SSF103378', NULL, NULL, NULL, NULL, '2-methylcitrate dehydratase PrpD', NULL, NULL, 28939, 21),
(286756, NULL, 'SSF46934', NULL, NULL, NULL, NULL, 'UBA-like', NULL, NULL, 6089, 21),
(286757, NULL, 'SSF101125', NULL, NULL, NULL, NULL, 'Colicin D immunity protein', NULL, NULL, 31311, 21),
(286758, NULL, 'SSF46919', NULL, NULL, NULL, NULL, 'N-terminal Zn binding domain of HIV integrase', NULL, NULL, 20546, 21),
(286759, NULL, 'SSF47895', NULL, NULL, NULL, NULL, 'Transducin (alpha subunit), insertion domain', NULL, NULL, 9151, 21),
(286760, NULL, 'SSF54975', NULL, NULL, NULL, NULL, 'Acylphosphatase/BLUF domain-like', NULL, NULL, 26964, 21),
(286761, NULL, 'SSF103032', NULL, NULL, NULL, NULL, 'Hypothetical protein YwqG', NULL, NULL, 24450, 21),
(286762, NULL, 'SSF117839', NULL, NULL, NULL, NULL, 'WWE domain', NULL, NULL, 32186, 21),
(286763, NULL, 'SSF47917', NULL, NULL, NULL, NULL, 'C-terminal domain of alpha and beta subunits of F1 ATP synthase', NULL, NULL, NULL, 21),
(286764, NULL, 'SSF110324', NULL, NULL, NULL, NULL, 'Ribosomal L27 protein-like', NULL, NULL, NULL, 21),
(286765, NULL, 'SSF51905', NULL, NULL, NULL, NULL, 'FAD/NAD(P)-binding domain', NULL, NULL, 27422, 21),
(286766, NULL, 'SSF57419', NULL, NULL, NULL, NULL, 'Neurotoxin III (ATX III)', NULL, NULL, 29346, 21),
(286767, NULL, 'SSF68989', NULL, NULL, NULL, NULL, 'Hemolysin expression modulating protein HHA', NULL, NULL, 29936, 21),
(286768, NULL, 'SSF56726', NULL, NULL, NULL, NULL, 'DNA topoisomerase IV, alpha subunit', NULL, NULL, 32011, 21);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(286769, NULL, 'SSF101312', NULL, NULL, NULL, NULL, 'Invasion protein A (SipA) , C-terminal actin binding domain', NULL, NULL, 8434, 21),
(286770, NULL, 'SSF69819', NULL, NULL, NULL, NULL, 'MTH1598-like', NULL, NULL, 28000, 21),
(286771, NULL, 'SSF75412', NULL, NULL, NULL, NULL, 'Hypothetical protein MTH1880', NULL, NULL, 29873, 21),
(286772, NULL, 'SSF144251', NULL, NULL, NULL, NULL, 'Viral leader polypeptide zinc finger', NULL, NULL, 31976, 21),
(286773, NULL, 'SSF55129', NULL, NULL, NULL, NULL, 'Ribosomal protein L30p/L7e', NULL, NULL, 32924, 21),
(286774, NULL, 'SSF52335', NULL, NULL, NULL, NULL, 'Methylglyoxal synthase-like', NULL, NULL, 28731, 21),
(286775, NULL, 'SSF56228', NULL, NULL, NULL, NULL, 'Aldehyde ferredoxin oxidoreductase, N-terminal domain', NULL, NULL, 31141, 21),
(286776, NULL, 'SSF55248', NULL, NULL, NULL, NULL, 'PCD-like', NULL, NULL, 28002, 21),
(286777, NULL, 'SSF47454', NULL, NULL, NULL, NULL, 'A DNA-binding domain in eukaryotic transcription factors', NULL, NULL, 8839, 21),
(286778, NULL, 'SSF158457', NULL, NULL, NULL, NULL, 'Orange domain-like', NULL, NULL, NULL, 21),
(286779, NULL, 'SSF81496', NULL, NULL, NULL, NULL, 'Cytochrome c1 subunit of cytochrome bc1 complex (Ubiquinol-cytochrome c reductase), transmembrane anchor', NULL, NULL, 15131, 21),
(286780, NULL, 'SSF50729', NULL, NULL, NULL, NULL, 'PH domain-like', NULL, NULL, NULL, 21),
(286781, NULL, 'SSF63892', NULL, NULL, NULL, NULL, 'Pyridoxine 5''-phosphate synthase', NULL, NULL, 33463, 21),
(286782, NULL, 'SSF89162', NULL, NULL, NULL, NULL, 'Gametocyte protein Pfg27', NULL, NULL, 31217, 21),
(286783, NULL, 'SSF140586', NULL, NULL, NULL, NULL, 'Dcp2 domain-like', NULL, NULL, 33352, 21),
(286784, NULL, 'SSF54826', NULL, NULL, NULL, NULL, 'Enolase N-terminal domain-like', NULL, NULL, 23143, 21),
(286785, NULL, 'SSF81524', NULL, NULL, NULL, NULL, '14 kDa protein of cytochrome bc1 complex (Ubiquinol-cytochrome c reductase)', NULL, NULL, 33457, 21),
(286786, NULL, 'SSF144020', NULL, NULL, NULL, NULL, 'FdhE-like', NULL, NULL, 12108, 21),
(286787, NULL, 'SSF82927', NULL, NULL, NULL, NULL, 'Cysteine-rich DNA binding domain, (DM domain)', NULL, NULL, 31691, 21),
(286788, NULL, 'SSF47473', NULL, NULL, NULL, NULL, 'EF-hand', NULL, NULL, 12984, 21),
(286789, NULL, 'SSF159065', NULL, NULL, NULL, NULL, 'Dom34/Pelota N-terminal domain-like', NULL, NULL, 32798, 21),
(286790, NULL, 'SSF57610', NULL, NULL, NULL, NULL, 'Thyroglobulin type-1 domain', NULL, NULL, 28476, 21),
(286791, NULL, 'SSF89009', NULL, NULL, NULL, NULL, 'GAT-like domain', NULL, NULL, NULL, 21),
(286792, NULL, 'SSF55550', NULL, NULL, NULL, NULL, 'SH2 domain', NULL, NULL, 28366, 21),
(286793, NULL, 'SSF55060', NULL, NULL, NULL, NULL, 'GHMP Kinase, C-terminal domain', NULL, NULL, 30062, 21),
(286794, NULL, 'TIGR03156', NULL, NULL, 'GTP_HflX: GTP-binding protein HflX', NULL, 'TIGR03156', NULL, NULL, 16478, 22),
(286795, NULL, 'TIGR00308', NULL, NULL, 'TRM1: N2,N2-dimethylguanosine tRNA methyltransferase', NULL, 'TIGR00308', NULL, NULL, 6289, 22),
(286796, NULL, 'TIGR03396', NULL, NULL, 'PC_PLC: phospholipase C, phosphocholine-specific', NULL, 'TIGR03396', NULL, NULL, 18958, 22),
(286797, NULL, 'TIGR02758', NULL, NULL, 'TraA_TIGR: type IV conjugative transfer system pilin TraA', NULL, 'TIGR02758', NULL, NULL, 7933, 22),
(286798, NULL, 'TIGR00595', NULL, NULL, 'priA: primosomal protein N''', NULL, 'TIGR00595', NULL, NULL, 4066, 22),
(286799, NULL, 'TIGR02621', NULL, NULL, 'cas3_GSU0051: CRISPR-associated helicase Cas3, subtype Dpsyc', NULL, 'TIGR02621', NULL, NULL, 9435, 22),
(286800, NULL, 'TIGR02518', NULL, NULL, 'EutH_ACDH: acetaldehyde dehydrogenase (acetylating)', NULL, 'TIGR02518', NULL, NULL, 18973, 22),
(286801, NULL, 'TIGR00115', NULL, NULL, 'tig: trigger factor', NULL, 'TIGR00115', NULL, NULL, 10949, 22),
(286802, NULL, 'TIGR03109', NULL, NULL, 'exosortase_1: exosortase A', NULL, 'TIGR03109', NULL, NULL, 14804, 22),
(286803, NULL, 'TIGR00891', NULL, NULL, '2A0112: MFS transporter, sialate:H+ symporter (SHS) family', NULL, 'TIGR00891', NULL, NULL, 5118, 22); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(286804, NULL, 'TIGR01186', NULL, NULL, 'proV: glycine betaine/L-proline transport ATP binding subunit', NULL, 'TIGR01186', NULL, NULL, 6706, 22),
(286805, NULL, 'TIGR02861', NULL, NULL, 'SASP_H: small acid-soluble spore protein, H-type', NULL, 'TIGR02861', NULL, NULL, 9801, 22),
(286806, NULL, 'TIGR03589', NULL, NULL, 'PseB: UDP-N-acetylglucosamine 4,6-dehydratase (inverting)', NULL, 'TIGR03589', NULL, NULL, 11850, 22),
(286807, NULL, 'TIGR00411', NULL, NULL, 'redox_disulf_1: redox-active disulfide protein 1', NULL, 'TIGR00411', NULL, NULL, 1931, 22),
(286808, NULL, 'TIGR02565', NULL, NULL, 'cas_Csy2: CRISPR type I-F/YPEST-associated protein Csy2', NULL, 'TIGR02565', NULL, NULL, 11327, 22),
(286809, NULL, 'TIGR04090', NULL, NULL, 'exp_by_SipW_IV: alternate signal-mediated exported protein, CPF_0494 family', NULL, 'TIGR04090', NULL, NULL, 15874, 22),
(286810, NULL, 'TIGR03212', NULL, NULL, 'uraD_N-term-dom: putative urate catabolism protein', NULL, 'TIGR03212', NULL, NULL, 16801, 22),
(286811, NULL, 'TIGR00788', NULL, NULL, 'fbt: folate/biopterin transporter', NULL, 'TIGR00788', NULL, NULL, 4970, 22),
(286812, NULL, 'TIGR01242', NULL, NULL, '26Sp45: 26S proteasome subunit P45 family', NULL, 'TIGR01242', NULL, NULL, 432, 22),
(286813, NULL, 'TIGR00059', NULL, NULL, 'L17: ribosomal protein bL17', NULL, 'TIGR00059', NULL, NULL, 6840, 22),
(286814, NULL, 'TIGR01734', NULL, NULL, 'D-ala-DACP-lig: D-alanine--poly(phosphoribitol) ligase, subunit 1', NULL, 'TIGR01734', NULL, NULL, 6100, 22),
(286815, NULL, 'TIGR03944', NULL, NULL, 'dehyd_SbnB_fam: 2,3-diaminopropionate biosynthesis protein SbnB', NULL, 'TIGR03944', NULL, NULL, 20078, 22),
(286816, NULL, 'TIGR00844', NULL, NULL, 'c_cpa1: sodium/hydrogen antiporter', NULL, 'TIGR00844', NULL, NULL, 25296, 22),
(286817, NULL, 'TIGR02132', NULL, NULL, 'phaR_Bmeg: polyhydroxyalkanoic acid synthase, PhaR subunit', NULL, 'TIGR02132', NULL, NULL, 11860, 22),
(286818, NULL, 'TIGR03692', NULL, NULL, 'ATP_dep_HslV: ATP-dependent protease HslVU, peptidase subunit', NULL, 'TIGR03692', NULL, NULL, 15133, 22),
(286819, NULL, 'TIGR01482', NULL, NULL, 'SPP-subfamily: sucrose-phosphate phosphatase subfamily', NULL, 'TIGR01482', NULL, NULL, NULL, 22),
(286820, NULL, 'TIGR00651', NULL, NULL, 'pta: phosphate acetyltransferase', NULL, 'TIGR00651', NULL, NULL, 2042, 22),
(286821, NULL, 'TIGR02325', NULL, NULL, 'C_P_lyase_phnF: phosphonate metabolism transcriptional regulator PhnF', NULL, 'TIGR02325', NULL, NULL, 11814, 22),
(286822, NULL, 'TIGR00903', NULL, NULL, '2A0129: major facilitator 4 family protein', NULL, 'TIGR00903', NULL, NULL, 4391, 22),
(286823, NULL, 'TIGR01678', NULL, NULL, 'FAD_lactone_ox: sugar 1,4-lactone oxidases', NULL, 'TIGR01678', NULL, NULL, 26089, 22),
(286824, NULL, 'TIGR01675', NULL, NULL, 'plant-AP: plant acid phosphatase', NULL, 'TIGR01675', NULL, NULL, 5245, 22),
(286825, NULL, 'TIGR03349', NULL, NULL, 'IV_VI_DotU: type IV/VI secretion system protein, DotU family', NULL, 'TIGR03349', NULL, NULL, 18145, 22),
(286826, NULL, 'TIGR02073', NULL, NULL, 'PBP_1c: penicillin-binding protein 1C', NULL, 'TIGR02073', NULL, NULL, 13283, 22),
(286827, NULL, 'TIGR01927', NULL, NULL, 'menC_gamma/gm+: o-succinylbenzoate synthase', NULL, 'TIGR01927', NULL, NULL, NULL, 22),
(286828, NULL, 'TIGR00950', NULL, NULL, '2A78: carboxylate/amino acid/amine transporter', NULL, 'TIGR00950', NULL, NULL, 5406, 22),
(286829, NULL, 'TIGR04286', NULL, NULL, 'MSEP-CTERM: MSEP-CTERM protein', NULL, 'TIGR04286', NULL, NULL, 26700, 22),
(286830, NULL, 'TIGR04476', NULL, NULL, 'exosort_XrtN: exosortase N', NULL, 'TIGR04476', NULL, NULL, 25298, 22),
(286831, NULL, 'TIGR03648', NULL, NULL, 'Na_symport_lg: probable sodium:solute symporter, VC_2705 subfamily', NULL, 'TIGR03648', NULL, NULL, 11652, 22),
(286832, NULL, 'TIGR01438', NULL, NULL, 'TGR: thioredoxin and glutathione reductase', NULL, 'TIGR01438', NULL, NULL, 4848, 22),
(286833, NULL, 'TIGR01628', NULL, NULL, 'PABP-1234: polyadenylate binding protein, human types 1, 2, 3, 4 family', NULL, 'TIGR01628', NULL, NULL, 6893, 22);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(286834, NULL, 'TIGR02076', NULL, NULL, 'pyrH_arch: putative uridylate kinase', NULL, 'TIGR02076', NULL, NULL, 13252, 22),
(286835, NULL, 'TIGR01301', NULL, NULL, 'GPH_sucrose: sucrose/H+ symporter', NULL, 'TIGR01301', NULL, NULL, 1454, 22),
(286836, NULL, 'TIGR02266', NULL, NULL, 'gmx_TIGR02266: Myxococcus xanthus paralogous domain TIGR02266', NULL, 'TIGR02266', NULL, NULL, 11636, 22),
(286837, NULL, 'TIGR03511', NULL, NULL, 'GldH_lipo: gliding motility-associated lipoprotein GldH', NULL, 'TIGR03511', NULL, NULL, 17588, 22),
(286838, NULL, 'TIGR03838', NULL, NULL, 'queuosine_YadB: glutamyl-queuosine tRNA(Asp) synthetase', NULL, 'TIGR03838', NULL, NULL, 15969, 22),
(286839, NULL, 'TIGR03701', NULL, NULL, 'mena_SCO4490: menaquinone biosynthesis decarboxylase, SCO4490 family', NULL, 'TIGR03701', NULL, NULL, 15700, 22),
(286840, NULL, 'TIGR01731', NULL, NULL, 'fil_hemag_20aa: adhesin HecA family 20-residue repeat (two copies)', NULL, 'TIGR01731', NULL, NULL, 6469, 22),
(286841, NULL, 'TIGR03405', NULL, NULL, 'Phn_Fe-ADH: phosphonate metabolism-associated iron-containing alcohol dehydrogenase', NULL, 'TIGR03405', NULL, NULL, 19372, 22),
(286842, NULL, 'TIGR04239', NULL, NULL, 'rhombo_GlpG: rhomboid family protease GlpG', NULL, 'TIGR04239', NULL, NULL, 641, 22),
(286843, NULL, 'TIGR04429', NULL, NULL, 'Phr_nterm: Phr family secreted Rap phosphatase inhibitor', NULL, 'TIGR04429', NULL, NULL, 25707, 22),
(286844, NULL, 'TIGR01541', NULL, NULL, 'tape_meas_lam_C: phage tail tape measure protein, lambda family', NULL, 'TIGR01541', NULL, NULL, 6528, 22),
(286845, NULL, 'TIGR03695', NULL, NULL, 'menH_SHCHC: 2-succinyl-6-hydroxy-2,4-cyclohexadiene-1-carboxylate synthase', NULL, 'TIGR03695', NULL, NULL, 16496, 22),
(286846, NULL, 'TIGR02920', NULL, NULL, 'acc_sec_Y2: accessory Sec system translocase SecY2', NULL, 'TIGR02920', NULL, NULL, 11237, 22),
(286847, NULL, 'TIGR00847', NULL, NULL, 'ccoS: cytochrome oxidase maturation protein, cbb3-type', NULL, 'TIGR00847', NULL, NULL, 3354, 22),
(286848, NULL, 'TIGR03885', NULL, NULL, 'flavin_revert: probable non-F420 flavinoid oxidoreductase', NULL, 'TIGR03885', NULL, NULL, 18499, 22),
(286849, NULL, 'TIGR00414', NULL, NULL, 'serS: serine--tRNA ligase', NULL, 'TIGR00414', NULL, NULL, 6055, 22),
(286850, NULL, 'TIGR00604', NULL, NULL, 'rad3: DNA repair helicase (rad3)', NULL, 'TIGR00604', NULL, NULL, 12662, 22),
(286851, NULL, 'TIGR01379', NULL, NULL, 'thiL: thiamine-phosphate kinase', NULL, 'TIGR01379', NULL, NULL, 3742, 22),
(286852, NULL, 'TIGR03452', NULL, NULL, 'mycothione_red: mycothione reductase', NULL, 'TIGR03452', NULL, NULL, 19068, 22),
(286853, NULL, 'TIGR00112', NULL, NULL, 'proC: pyrroline-5-carboxylate reductase', NULL, 'TIGR00112', NULL, NULL, 803, 22),
(286854, NULL, 'TIGR02624', NULL, NULL, 'rhamnu_1P_ald: rhamnulose-1-phosphate aldolase', NULL, 'TIGR02624', NULL, NULL, 9174, 22),
(286855, NULL, 'TIGR02814', NULL, NULL, 'pfaD_fam: PfaD family protein', NULL, 'TIGR02814', NULL, NULL, 8576, 22),
(286856, NULL, 'TIGR01189', NULL, NULL, 'ccmA: heme ABC exporter, ATP-binding protein CcmA', NULL, 'TIGR01189', NULL, NULL, 6931, 22),
(286857, NULL, 'TIGR04043', NULL, NULL, 'rSAM_MSMEG_0568: radical SAM protein, MSMEG_0568 family', NULL, 'TIGR04043', NULL, NULL, 15500, 22),
(286858, NULL, 'TIGR01974', NULL, NULL, 'NDH_I_L: proton-translocating NADH-quinone oxidoreductase, chain L', NULL, 'TIGR01974', NULL, NULL, 8337, 22),
(286859, NULL, 'TIGR04535', NULL, NULL, 'ferrit_encaps: ferritin-like protein', NULL, 'TIGR04535', NULL, NULL, 25189, 22),
(286860, NULL, 'TIGR01005', NULL, NULL, 'eps_transp_fam: exopolysaccharide transport protein family', NULL, 'TIGR01005', NULL, NULL, 3755, 22),
(286861, NULL, 'TIGR02998', NULL, NULL, 'RraA_entero: regulator of ribonuclease activity A', NULL, 'TIGR02998', NULL, NULL, 10119, 22),
(286862, NULL, 'TIGR00355', NULL, NULL, 'purH: phosphoribosylaminoimidazolecarboxamide formyltransferase/IMP cyclohydrolase', NULL, 'TIGR00355', NULL, NULL, 3950, 22),
(286863, NULL, 'TIGR04102', NULL, NULL, 'SWIM_PBPRA1643: SWIM/SEC-C metal-binding motif protein, PBPRA1643 family', NULL, 'TIGR04102', NULL, NULL, 23099, 22);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(286864, NULL, 'TIGR02219', NULL, NULL, 'phage_NlpC_fam: putative phage cell wall peptidase, NlpC/P60 family', NULL, 'TIGR02219', NULL, NULL, 11052, 22),
(286865, NULL, 'TIGR03393', NULL, NULL, 'indolpyr_decarb: indolepyruvate decarboxylase', NULL, 'TIGR03393', NULL, NULL, 18568, 22),
(286866, NULL, 'TIGR00296', NULL, NULL, 'TIGR00296: uncharacterized protein, PH0010 family', NULL, 'TIGR00296', NULL, NULL, 16023, 22),
(286867, NULL, 'TIGR03262', NULL, NULL, 'PhnU2: putative 2-aminoethylphosphonate ABC transporter, permease protein', NULL, 'TIGR03262', NULL, NULL, 17424, 22),
(286868, NULL, 'TIGR02029', NULL, NULL, 'AcsF: magnesium-protoporphyrin IX monomethyl ester aerobic oxidative cyclase', NULL, 'TIGR02029', NULL, NULL, 8937, 22),
(286869, NULL, 'TIGR03106', NULL, NULL, 'trio_M42_hydro: hydrolase, peptidase M42 family', NULL, 'TIGR03106', NULL, NULL, 14920, 22),
(286870, NULL, 'TIGR02328', NULL, NULL, 'TIGR02328: conserved hypothetical protein', NULL, 'TIGR02328', NULL, NULL, 10022, 22),
(286871, NULL, 'TIGR00545', NULL, NULL, 'lipoyltrans: lipoyltransferase and lipoate-protein ligase', NULL, 'TIGR00545', NULL, NULL, 876, 22),
(286872, NULL, 'TIGR03346', NULL, NULL, 'chaperone_ClpB: ATP-dependent chaperone protein ClpB', NULL, 'TIGR03346', NULL, NULL, 18180, 22),
(286873, NULL, 'TIGR02708', NULL, NULL, 'L_lactate_ox: L-lactate oxidase', NULL, 'TIGR02708', NULL, NULL, 14478, 22),
(286874, NULL, 'TIGR00785', NULL, NULL, 'dass: transporter, divalent anion:Na+ symporter (DASS) family', NULL, 'TIGR00785', NULL, NULL, 2115, 22),
(286875, NULL, 'TIGR03153', NULL, NULL, 'cytochr_NrfH: cytochrome c nitrite reductase, small subunit', NULL, 'TIGR03153', NULL, NULL, 15561, 22),
(286876, NULL, 'TIGR02671', NULL, NULL, 'cas_csx9: CRISPR-associated protein Cas8a2/Csx9, subtype I-A/APERN', NULL, 'TIGR02671', NULL, NULL, 10344, 22),
(286877, NULL, 'TIGR00221', NULL, NULL, 'nagA: N-acetylglucosamine-6-phosphate deacetylase', NULL, 'TIGR00221', NULL, NULL, 2360, 22),
(286878, NULL, 'TIGR02375', NULL, NULL, 'pseudoazurin: pseudoazurin', NULL, 'TIGR02375', NULL, NULL, 9338, 22),
(286879, NULL, 'TIGR01183', NULL, NULL, 'ntrB: nitrate ABC transporter, permease protein', NULL, 'TIGR01183', NULL, NULL, 6932, 22),
(286880, NULL, 'TIGR04105', NULL, NULL, 'FeFe_hydrog_B1: [FeFe] hydrogenase, group B1/B3', NULL, 'TIGR04105', NULL, NULL, 22908, 22),
(286881, NULL, 'TIGR01600', NULL, NULL, 'phage_tail_L: phage minor tail protein L', NULL, 'TIGR01600', NULL, NULL, 6201, 22),
(286882, NULL, 'TIGR01376', NULL, NULL, 'POMP_repeat: chlamydial polymorphic outer membrane protein repeat', NULL, 'TIGR01376', NULL, NULL, 4211, 22),
(286883, NULL, 'TIGR00601', NULL, NULL, 'rad23: UV excision repair protein Rad23', NULL, 'TIGR00601', NULL, NULL, 4234, 22),
(286884, NULL, 'TIGR02755', NULL, NULL, 'TraX_Ftype: type-F conjugative transfer system pilin acetylase TraX', NULL, 'TIGR02755', NULL, NULL, 13964, 22),
(286885, NULL, 'TIGR00906', NULL, NULL, '2A0303: cationic amino acid transport permease', NULL, 'TIGR00906', NULL, NULL, 5298, 22),
(286886, NULL, 'TIGR03882', NULL, NULL, 'cyclo_dehyd_2: bacteriocin biosynthesis cyclodehydratase domain', NULL, 'TIGR03882', NULL, NULL, 15403, 22),
(286887, NULL, 'TIGR02699', NULL, NULL, 'archaeo_AfpA: archaeoflavoprotein AfpA', NULL, 'TIGR02699', NULL, NULL, 13123, 22),
(286888, NULL, 'TIGR04280', NULL, NULL, 'geopep_mat_rSAM: putative geopeptide radical SAM maturase', NULL, 'TIGR04280', NULL, NULL, 25213, 22),
(286889, NULL, 'TIGR01544', NULL, NULL, 'HAD-SF-IE: HAD hydrolase, family IE', NULL, 'TIGR01544', NULL, NULL, 6960, 22),
(286890, NULL, 'TIGR00894', NULL, NULL, '2A0114euk: Na(+)-dependent inorganic phosphate cotransporter', NULL, 'TIGR00894', NULL, NULL, 5184, 22),
(286891, NULL, 'TIGR00009', NULL, NULL, 'L28: ribosomal protein bL28', NULL, 'TIGR00009', NULL, NULL, 2378, 22),
(286892, NULL, 'TIGR00249', NULL, NULL, 'sixA: phosphohistidine phosphatase SixA', NULL, 'TIGR00249', NULL, NULL, 7036, 22),
(286893, NULL, 'TIGR01924', NULL, NULL, 'rsbW_low_gc: anti-sigma B factor', NULL, 'TIGR01924', NULL, NULL, 4155, 22);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(286894, NULL, 'TIGR02135', NULL, NULL, 'phoU_full: phosphate transport system regulatory protein PhoU', NULL, 'TIGR02135', NULL, NULL, 21969, 22),
(286895, NULL, 'TIGR02515', NULL, NULL, 'IV_pilus_PilQ: type IV pilus secretin PilQ', NULL, 'TIGR02515', NULL, NULL, 18790, 22),
(286896, NULL, 'TIGR00592', NULL, NULL, 'pol2: DNA polymerase (pol2)', NULL, 'TIGR00592', NULL, NULL, NULL, 22),
(286897, NULL, 'TIGR01485', NULL, NULL, 'SPP_plant-cyano: sucrose phosphatase', NULL, 'TIGR01485', NULL, NULL, 7160, 22),
(286898, NULL, 'TIGR01737', NULL, NULL, 'FGAM_synth_I: phosphoribosylformylglycinamidine synthase I', NULL, 'TIGR01737', NULL, NULL, 2154, 22),
(286899, NULL, 'TIGR04046', NULL, NULL, 'MSMEG_0569_nitr: flavin-dependent oxidoreductase, MSMEG_0569 family', NULL, 'TIGR04046', NULL, NULL, 14805, 22),
(286900, NULL, 'TIGR04426', NULL, NULL, 'rSAM_desII: TDP-4-amino-4,6-dideoxy-D-glucose deaminase', NULL, 'TIGR04426', NULL, NULL, 16180, 22),
(286901, NULL, 'TIGR03408', NULL, NULL, 'urea_trans_UrtC: urea ABC transporter, permease protein UrtC', NULL, 'TIGR03408', NULL, NULL, 19091, 22),
(286902, NULL, 'TIGR01008', NULL, NULL, 'uS3_euk_arch: ribosomal protein uS3', NULL, 'TIGR01008', NULL, NULL, 3515, 22),
(286903, NULL, 'TIGR00710', NULL, NULL, 'efflux_Bcr_CflA: drug resistance transporter, Bcr/CflA subfamily', NULL, 'TIGR00710', NULL, NULL, 4032, 22),
(286904, NULL, 'TIGR01865', NULL, NULL, 'cas_Csn1: CRISPR subtype II RNA-guided endonuclease Cas9', NULL, 'TIGR01865', NULL, NULL, 25856, 22),
(286905, NULL, 'TIGR03094', NULL, NULL, 'sulfo_cyanin: sulfocyanin', NULL, 'TIGR03094', NULL, NULL, 14263, 22),
(286906, NULL, 'TIGR03941', NULL, NULL, 'tRNA_deam_assoc: putative tRNA adenosine deaminase-associated protein', NULL, 'TIGR03941', NULL, NULL, 16661, 22),
(286907, NULL, 'TIGR02923', NULL, NULL, 'AhaC: ATP synthase A1, C subunit', NULL, 'TIGR02923', NULL, NULL, 8640, 22),
(286908, NULL, 'TIGR02026', NULL, NULL, 'BchE: magnesium-protoporphyrin IX monomethyl ester anaerobic oxidative cyclase', NULL, 'TIGR02026', NULL, NULL, NULL, 22),
(286909, NULL, 'TIGR03991', NULL, NULL, 'alt_bact_glmU: UDP-N-acetylglucosamine diphosphorylase/glucosamine-1-phosphate N-acetyltransferase', NULL, 'TIGR03991', NULL, NULL, 18472, 22),
(286910, NULL, 'TIGR04093', NULL, NULL, 'cas1_CYANO: CRISPR-associated endonuclease Cas1, subtype CYANO', NULL, 'TIGR04093', NULL, NULL, 16709, 22),
(286911, NULL, 'TIGR04473', NULL, NULL, 'taxol_Phe_23mut: phenylalanine aminomutase (L-beta-phenylalanine forming)', NULL, 'TIGR04473', NULL, NULL, 25411, 22),
(286912, NULL, 'TIGR01055', NULL, NULL, 'parE_Gneg: DNA topoisomerase IV, B subunit', NULL, 'TIGR01055', NULL, NULL, 4547, 22),
(286913, NULL, 'TIGR03561', NULL, NULL, 'organ_hyd_perox: peroxiredoxin, Ohr subfamily', NULL, 'TIGR03561', NULL, NULL, 18344, 22),
(286914, NULL, 'TIGR02817', NULL, NULL, 'adh_fam_1: zinc-binding alcohol dehydrogenase family protein', NULL, 'TIGR02817', NULL, NULL, 8861, 22),
(286915, NULL, 'TIGR00056', NULL, NULL, 'TIGR00056: ABC transport permease subunit', NULL, 'TIGR00056', NULL, NULL, 5371, 22),
(286916, NULL, 'TIGR02269', NULL, NULL, 'TIGR02269: Myxococcus xanthus paralogous lipoprotein family TIGR02269', NULL, 'TIGR02269', NULL, NULL, 11978, 22),
(286917, NULL, 'TIGR01435', NULL, NULL, 'glu_cys_lig_rel: glutamate--cysteine ligase/glutathione synthase', NULL, 'TIGR01435', NULL, NULL, 4710, 22),
(286918, NULL, 'TIGR04532', NULL, NULL, 'PT_fungal_PKS: polyketide product template domain', NULL, 'TIGR04532', NULL, NULL, 23530, 22),
(286919, NULL, 'TIGR00679', NULL, NULL, 'hpr-ser: HPr(Ser) kinase/phosphatase', NULL, 'TIGR00679', NULL, NULL, 6246, 22),
(286920, NULL, 'TIGR02182', NULL, NULL, 'GRXB: glutaredoxin, GrxB family', NULL, 'TIGR02182', NULL, NULL, 12257, 22),
(286921, NULL, 'TIGR02562', NULL, NULL, 'cas3_yersinia: CRISPR-associated helicase Cas3, subtype I-F/YPEST', NULL, 'TIGR02562', NULL, NULL, 11170, 22),
(286922, NULL, 'TIGR00542', NULL, NULL, 'hxl6Piso_put: putative hexulose-6-phosphate isomerase', NULL, 'TIGR00542', NULL, NULL, 621, 22);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(286923, NULL, 'TIGR02864', NULL, NULL, 'spore_sspO: small, acid-soluble spore protein O', NULL, 'TIGR02864', NULL, NULL, 9707, 22),
(286924, NULL, 'TIGR04152', NULL, NULL, 'exosort_VPLPA: exosortase D, VPLPA-CTERM-specific', NULL, 'TIGR04152', NULL, NULL, 23361, 22),
(286925, NULL, 'TIGR04289', NULL, NULL, 'heavy_Cys: eight-cysteine-cluster domain', NULL, 'TIGR04289', NULL, NULL, 26893, 22),
(286926, NULL, 'TIGR01329', NULL, NULL, 'cysta_beta_ly_E: cystathionine beta-lyase', NULL, 'TIGR01329', NULL, NULL, 3577, 22),
(286927, NULL, 'TIGR00162', NULL, NULL, 'TIGR00162: TIGR00162 family protein', NULL, 'TIGR00162', NULL, NULL, 7365, 22),
(286928, NULL, 'TIGR00299', NULL, NULL, 'TIGR00299: TIGR00299 family protein', NULL, 'TIGR00299', NULL, NULL, 6495, 22),
(286929, NULL, 'TIGR03455', NULL, NULL, 'HisG_C-term: ATP phosphoribosyltransferase, C-terminal domain', NULL, 'TIGR03455', NULL, NULL, 18579, 22),
(286930, NULL, 'TIGR03835', NULL, NULL, 'termin_org_DnaJ: terminal organelle assembly protein TopJ', NULL, 'TIGR03835', NULL, NULL, 15649, 22),
(286931, NULL, 'TIGR01591', NULL, NULL, 'Fdh-alpha: formate dehydrogenase, alpha subunit', NULL, 'TIGR01591', NULL, NULL, 6248, 22),
(286932, NULL, 'TIGR03698', NULL, NULL, 'clan_AA_DTGF: clan AA aspartic protease, AF_0612 family', NULL, 'TIGR03698', NULL, NULL, 15104, 22),
(286933, NULL, 'TIGR00358', NULL, NULL, '3_prime_RNase: VacB and RNase II family 3''-5'' exoribonucleases', NULL, 'TIGR00358', NULL, NULL, 7338, 22),
(286934, NULL, 'TIGR01133', NULL, NULL, 'murG: undecaprenyldiphospho-muramoylpentapeptide beta-N-acetylglucosaminyltransferase', NULL, 'TIGR01133', NULL, NULL, 1266, 22),
(286935, NULL, 'TIGR03514', NULL, NULL, 'GldB_lipo: gliding motility-associated lipoprotein GldB', NULL, 'TIGR03514', NULL, NULL, 18161, 22),
(286936, NULL, 'TIGR00417', NULL, NULL, 'speE: spermidine synthase', NULL, 'TIGR00417', NULL, NULL, 2335, 22),
(286937, NULL, 'TIGR01971', NULL, NULL, 'NuoI: NADH-quinone oxidoreductase, chain I', NULL, 'TIGR01971', NULL, NULL, 4243, 22),
(286938, NULL, 'TIGR00738', NULL, NULL, 'rrf2_super: Rrf2 family protein', NULL, 'TIGR00738', NULL, NULL, 304, 22),
(286939, NULL, 'TIGR01890', NULL, NULL, 'N-Ac-Glu-synth: amino-acid N-acetyltransferase', NULL, 'TIGR01890', NULL, NULL, 10556, 22),
(286940, NULL, 'TIGR03776', NULL, NULL, 'RPE5: rickettsial palindromic element RPE5 domain', NULL, 'TIGR03776', NULL, NULL, 15667, 22),
(286941, NULL, 'TIGR03860', NULL, NULL, 'FMN_nitrolo: FMN-dependent oxidoreductase, nitrilotriacetate monooxygenase family', NULL, 'TIGR03860', NULL, NULL, 17236, 22),
(286942, NULL, 'TIGR00975', NULL, NULL, '3a0107s03: phosphate ABC transporter, phosphate-binding protein PstS', NULL, 'TIGR00975', NULL, NULL, 3523, 22),
(286943, NULL, 'TIGR03997', NULL, NULL, 'mycofact_OYE_2: mycofactocin system FadH/OYE family oxidoreductase 2', NULL, 'TIGR03997', NULL, NULL, 11081, 22),
(286944, NULL, 'TIGR03536', NULL, NULL, 'DapD_gpp: 2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-succinyltransferase', NULL, 'TIGR03536', NULL, NULL, 16742, 22),
(286945, NULL, 'TIGR03620', NULL, NULL, 'F420_MSMEG_4141: probable F420-dependent oxidoreductase, MSMEG_4141 family', NULL, 'TIGR03620', NULL, NULL, 14911, 22),
(286946, NULL, 'TIGR00735', NULL, NULL, 'hisF: imidazoleglycerol phosphate synthase, cyclase subunit', NULL, 'TIGR00735', NULL, NULL, 2673, 22),
(286947, NULL, 'TIGR01603', NULL, NULL, 'maj_tail_phi13: phage major tail protein, phi13 family', NULL, 'TIGR01603', NULL, NULL, 6198, 22),
(286948, NULL, 'TIGR02481', NULL, NULL, 'hemeryth_dom: hemerythrin-like metal-binding domain', NULL, 'TIGR02481', NULL, NULL, 12714, 22),
(286949, NULL, 'TIGR03757', NULL, NULL, 'conj_TIGR03757: integrating conjugative element protein, PFL_4709 family', NULL, 'TIGR03757', NULL, NULL, 11107, 22),
(286950, NULL, 'TIGR02185', NULL, NULL, 'Trep_Strep: putative ECF transporter S component, Trep_Strep family', NULL, 'TIGR02185', NULL, NULL, 11997, 22),
(286951, NULL, 'TIGR02945', NULL, NULL, 'SUF_assoc: FeS assembly SUF system protein', NULL, 'TIGR02945', NULL, NULL, 8584, 22);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(286952, NULL, 'TIGR00909', NULL, NULL, '2A0306: amino acid transporter', NULL, 'TIGR00909', NULL, NULL, 5498, 22),
(286953, NULL, 'TIGR04367', NULL, NULL, 'HpnR_B12_rSAM: hopanoid C-3 methylase HpnR', NULL, 'TIGR04367', NULL, NULL, 23310, 22),
(286954, NULL, 'TIGR04211', NULL, NULL, 'SH3_and_anchor: SH3 domain protein', NULL, 'TIGR04211', NULL, NULL, 15466, 22),
(286955, NULL, 'TIGR01566', NULL, NULL, 'ZF_HD_prot_N: ZF-HD homeobox protein Cys/His-rich dimerization domain', NULL, 'TIGR01566', NULL, NULL, 6857, 22),
(286956, NULL, 'TIGR00187', NULL, NULL, 'ribE: riboflavin synthase, alpha subunit', NULL, 'TIGR00187', NULL, NULL, 4430, 22),
(286957, NULL, 'TIGR02260', NULL, NULL, 'benz_CoA_red_B: benzoyl-CoA reductase, subunit B', NULL, 'TIGR02260', NULL, NULL, 11125, 22),
(286958, NULL, 'TIGR01354', NULL, NULL, 'cyt_deam_tetra: cytidine deaminase', NULL, 'TIGR01354', NULL, NULL, 3640, 22),
(286959, NULL, 'TIGR01862', NULL, NULL, 'N2-ase-Ialpha: nitrogenase component I, alpha chain', NULL, 'TIGR01862', NULL, NULL, 10939, 22),
(286960, NULL, 'TIGR00439', NULL, NULL, 'ftsX: putative protein insertion permease FtsX', NULL, 'TIGR00439', NULL, NULL, 1910, 22),
(286961, NULL, 'TIGR01999', NULL, NULL, 'iscU: FeS cluster assembly scaffold IscU', NULL, 'TIGR01999', NULL, NULL, 10859, 22),
(286962, NULL, 'TIGR03287', NULL, NULL, 'methan_mark_16: putative methanogenesis marker 16 metalloprotein', NULL, 'TIGR03287', NULL, NULL, 17607, 22),
(286963, NULL, 'TIGR01180', NULL, NULL, 'aman2_put: putative alpha-1,2-mannosidase', NULL, 'TIGR01180', NULL, NULL, 6660, 22),
(286964, NULL, 'TIGR02020', NULL, NULL, 'BchF: 2-vinyl bacteriochlorophyllide hydratase', NULL, 'TIGR02020', NULL, NULL, 14286, 22),
(286965, NULL, 'TIGR02397', NULL, NULL, 'dnaX_nterm: DNA polymerase III, subunit gamma and tau', NULL, 'TIGR02397', NULL, NULL, 9547, 22),
(286966, NULL, 'TIGR02705', NULL, NULL, 'nudix_YtkD: nucleoside triphosphatase YtkD', NULL, 'TIGR02705', NULL, NULL, 13097, 22),
(286967, NULL, 'TIGR00523', NULL, NULL, 'eIF-1A: translation initiation factor eIF-1A', NULL, 'TIGR00523', NULL, NULL, 624, 22),
(286968, NULL, 'TIGR02453', NULL, NULL, 'TIGR02453: TIGR02453 family protein', NULL, 'TIGR02453', NULL, NULL, 12502, 22),
(286969, NULL, 'TIGR04451', NULL, NULL, 'lanti_SCO0268: lantipeptide, SCO0268 family', NULL, 'TIGR04451', NULL, NULL, 26390, 22),
(286970, NULL, 'TIGR00520', NULL, NULL, 'asnASE_II: L-asparaginase, type II', NULL, 'TIGR00520', NULL, NULL, 737, 22),
(286971, NULL, 'TIGR04127', NULL, NULL, 'flavo_near_exo: exosortase F-associated protein', NULL, 'TIGR04127', NULL, NULL, 21201, 22),
(286972, NULL, 'TIGR03028', NULL, NULL, 'EpsE: polysaccharide export protein EpsE', NULL, 'TIGR03028', NULL, NULL, 20802, 22),
(286973, NULL, 'TIGR00897', NULL, NULL, '2A0118: polyol permease', NULL, 'TIGR00897', NULL, NULL, 5435, 22),
(286974, NULL, 'TIGR00760', NULL, NULL, 'araD: L-ribulose-5-phosphate 4-epimerase', NULL, 'TIGR00760', NULL, NULL, 2610, 22),
(286975, NULL, 'TIGR01058', NULL, NULL, 'parE_Gpos: DNA topoisomerase IV, B subunit', NULL, 'TIGR01058', NULL, NULL, 4920, 22),
(286976, NULL, 'TIGR01248', NULL, NULL, 'drrC: daunorubicin resistance protein C', NULL, 'TIGR01248', NULL, NULL, 426, 22),
(286977, NULL, 'TIGR00053', NULL, NULL, 'TIGR00053: addiction module toxin component, YafQ family', NULL, 'TIGR00053', NULL, NULL, 5589, 22),
(286978, NULL, 'TIGR01111', NULL, NULL, 'mtrA: tetrahydromethanopterin S-methyltransferase, subunit A', NULL, 'TIGR01111', NULL, NULL, 5513, 22),
(286979, NULL, 'TIGR02973', NULL, NULL, 'nitrate_rd_NapE: periplasmic nitrate reductase, NapE protein', NULL, 'TIGR02973', NULL, NULL, 12837, 22),
(286980, NULL, 'TIGR01351', NULL, NULL, 'adk: adenylate kinase', NULL, 'TIGR01351', NULL, NULL, 3601, 22),
(286981, NULL, 'TIGR01818', NULL, NULL, 'ntrC: nitrogen regulation protein NR(I)', NULL, 'TIGR01818', NULL, NULL, 10803, 22),
(286982, NULL, 'TIGR02730', NULL, NULL, 'carot_isom: carotene isomerase', NULL, 'TIGR02730', NULL, NULL, 14411, 22),
(286983, NULL, 'TIGR00467', NULL, NULL, 'lysS_arch: lysine--tRNA ligase', NULL, 'TIGR00467', NULL, NULL, 6277, 22);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(286984, NULL, 'TIGR00657', NULL, NULL, 'asp_kinases: aspartate kinase', NULL, 'TIGR00657', NULL, NULL, 7417, 22),
(286985, NULL, 'TIGR03458', NULL, NULL, 'YgfH_subfam: succinate CoA transferase', NULL, 'TIGR03458', NULL, NULL, 19162, 22),
(286986, NULL, 'TIGR02696', NULL, NULL, 'pppGpp_PNP: guanosine pentaphosphate synthetase I/polyribonucleotide nucleotidyltransferase', NULL, 'TIGR02696', NULL, NULL, 13145, 22),
(286987, NULL, 'TIGR00290', NULL, NULL, 'MJ0570_dom: MJ0570-related uncharacterized domain', NULL, 'TIGR00290', NULL, NULL, 4123, 22),
(286988, NULL, 'TIGR02023', NULL, NULL, 'BchP-ChlP: geranylgeranyl reductase', NULL, 'TIGR02023', NULL, NULL, 5446, 22),
(286989, NULL, 'TIGR03754', NULL, NULL, 'conj_TOL_TraD: conjugative coupling factor TraD, PFGI-1 class', NULL, 'TIGR03754', NULL, NULL, 16191, 22),
(286990, NULL, 'TIGR03564', NULL, NULL, 'F420_MSMEG_4879: F420-dependent oxidoreductase, MSMEG_4879 family', NULL, 'TIGR03564', NULL, NULL, 18405, 22),
(286991, NULL, 'TIGR00224', NULL, NULL, 'pckA: phosphoenolpyruvate carboxykinase (ATP)', NULL, 'TIGR00224', NULL, NULL, 5279, 22),
(286992, NULL, 'TIGR03072', NULL, NULL, 'release_prfH: putative peptide chain release factor H', NULL, 'TIGR03072', NULL, NULL, 21164, 22),
(286993, NULL, 'TIGR03832', NULL, NULL, 'Tyr_2_3_mutase: tyrosine 2,3-aminomutase', NULL, 'TIGR03832', NULL, NULL, 15989, 22),
(286994, NULL, 'TIGR03150', NULL, NULL, 'fabF: beta-ketoacyl-acyl-carrier-protein synthase II', NULL, 'TIGR03150', NULL, NULL, 15110, 22),
(286995, NULL, 'TIGR03779', NULL, NULL, 'Bac_Flav_CT_M: Bacteroides conjugative transposon TraM protein', NULL, 'TIGR03779', NULL, NULL, 21009, 22),
(286996, NULL, 'TIGR03969', NULL, NULL, 'mycofactocin: mycofactocin precursor', NULL, 'TIGR03969', NULL, NULL, 11334, 22),
(286997, NULL, 'TIGR01594', NULL, NULL, 'holin_lambda: phage holin, lambda family', NULL, 'TIGR01594', NULL, NULL, 6131, 22),
(286998, NULL, 'TIGR03642', NULL, NULL, 'cas_csx14: CRISPR-associated protein, Csx14 family', NULL, 'TIGR03642', NULL, NULL, 15668, 22),
(286999, NULL, 'TIGR00302', NULL, NULL, 'TIGR00302: phosphoribosylformylglycinamidine synthase, purS protein', NULL, 'TIGR00302', NULL, NULL, 3392, 22),
(287000, NULL, 'TIGR01784', NULL, NULL, 'T_den_put_tspse: conserved hypothetical protein', NULL, 'TIGR01784', NULL, NULL, 2354, 22),
(287001, NULL, 'TIGR01569', NULL, NULL, 'A_tha_TIGR01569: plant integral membrane protein TIGR01569', NULL, 'TIGR01569', NULL, NULL, 6754, 22),
(287002, NULL, 'TIGR02291', NULL, NULL, 'rimK_rel_E_lig: alpha-L-glutamate ligase homolog', NULL, 'TIGR02291', NULL, NULL, 11974, 22),
(287003, NULL, 'TIGR04345', NULL, NULL, 'ovoA_Cterm: putative 4-mercaptohistidine N1-methyltranferase', NULL, 'TIGR04345', NULL, NULL, 23204, 22),
(287004, NULL, 'TIGR04233', NULL, NULL, 'seadorna_VP8: seadornavirus VP8 protein', NULL, 'TIGR04233', NULL, NULL, 22514, 22),
(287005, NULL, 'TIGR04423', NULL, NULL, 'casT3_TIGR04423: CRISPR type III-associated protein, TIGR04423 family', NULL, 'TIGR04423', NULL, NULL, 24828, 22),
(287006, NULL, 'TIGR02867', NULL, NULL, 'spore_II_P: stage II sporulation protein P', NULL, 'TIGR02867', NULL, NULL, 12117, 22),
(287007, NULL, 'TIGR02409', NULL, NULL, 'carnitine_bodg: gamma-butyrobetaine hydroxylase', NULL, 'TIGR02409', NULL, NULL, 9696, 22),
(287008, NULL, 'TIGR04155', NULL, NULL, 'cyano_PEP: PEP-CTERM protein sorting domain, cyanobacterial subclass', NULL, 'TIGR04155', NULL, NULL, 23199, 22),
(287009, NULL, 'TIGR03321', NULL, NULL, 'alt_F1F0_F0_B: alternate F1F0 ATPase, F0 subunit B', NULL, 'TIGR03321', NULL, NULL, 17913, 22),
(287010, NULL, 'TIGR01902', NULL, NULL, 'dapE-lys-deAc: N-acetyl-ornithine/N-acetyl-lysine deacetylase', NULL, 'TIGR01902', NULL, NULL, 4015, 22),
(287011, NULL, 'TIGR01326', NULL, NULL, 'OAH_OAS_sulfhy: O-acetylhomoserine aminocarboxypropyltransferase/cysteine synthase', NULL, 'TIGR01326', NULL, NULL, 3885, 22),
(287012, NULL, 'TIGR01460', NULL, NULL, 'HAD-SF-IIA: HAD hydrolase, family IIA', NULL, 'TIGR01460', NULL, NULL, 4516, 22),
(287013, NULL, 'TIGR04021', NULL, NULL, 'LLM_DMSO2_sfnG: dimethyl sulfone monooxygenase SfnG', NULL, 'TIGR04021', NULL, NULL, 15202, 22);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287014, NULL, 'TIGR01136', NULL, NULL, 'cysKM: cysteine synthase', NULL, 'TIGR01136', NULL, NULL, 6693, 22),
(287015, NULL, 'TIGR01597', NULL, NULL, 'PYST-B: Plasmodium yoelii subtelomeric family PYST-B', NULL, 'TIGR01597', NULL, NULL, 6490, 22),
(287016, NULL, 'TIGR04158', NULL, NULL, 'rSAM_MIA_synth: 3-methyl-2-indolic acid synthase', NULL, 'TIGR04158', NULL, NULL, 21392, 22),
(287017, NULL, 'TIGR02948', NULL, NULL, 'SigW_bacill: RNA polymerase sigma-W factor', NULL, 'TIGR02948', NULL, NULL, 8780, 22),
(287018, NULL, 'TIGR00118', NULL, NULL, 'acolac_lg: acetolactate synthase, large subunit, biosynthetic type', NULL, 'TIGR00118', NULL, NULL, 7084, 22),
(287019, NULL, 'TIGR03430', NULL, NULL, 'trp_dimet_allyl: tryptophan dimethylallyltransferase', NULL, 'TIGR03430', NULL, NULL, 19320, 22),
(287020, NULL, 'TIGR00978', NULL, NULL, 'asd_EA: aspartate-semialdehyde dehydrogenase', NULL, 'TIGR00978', NULL, NULL, 3933, 22),
(287021, NULL, 'TIGR00184', NULL, NULL, 'purA: adenylosuccinate synthase', NULL, 'TIGR00184', NULL, NULL, 1412, 22),
(287022, NULL, 'TIGR00305', NULL, NULL, 'TIGR00305: putative toxin-antitoxin system toxin component, PIN family', NULL, 'TIGR00305', NULL, NULL, 5568, 22),
(287023, NULL, 'TIGR02051', NULL, NULL, 'MerR: Hg(II)-responsive transcriptional regulator', NULL, 'TIGR02051', NULL, NULL, 13361, 22),
(287024, NULL, 'TIGR04557', NULL, NULL, 'fuse_rel_SoxYZ: quinoprotein dehydrogenase-associated SoxYZ-like carrier', NULL, 'TIGR04557', NULL, NULL, 23986, 22),
(287025, NULL, 'TIGR03402', NULL, NULL, 'FeS_nifS: cysteine desulfurase NifS', NULL, 'TIGR03402', NULL, NULL, 18712, 22),
(287026, NULL, 'TIGR02976', NULL, NULL, 'phageshock_pspB: phage shock protein B', NULL, 'TIGR02976', NULL, NULL, 10430, 22),
(287027, NULL, 'TIGR00732', NULL, NULL, 'dprA: DNA protecting protein DprA', NULL, 'TIGR00732', NULL, NULL, 6413, 22),
(287028, NULL, 'TIGR01432', NULL, NULL, 'QOXA: cytochrome aa3 quinol oxidase, subunit II', NULL, 'TIGR01432', NULL, NULL, 4736, 22),
(287029, NULL, 'TIGR02587', NULL, NULL, 'TIGR02587: putative integral membrane protein TIGR02587', NULL, 'TIGR02587', NULL, NULL, 9245, 22),
(287030, NULL, 'TIGR03994', NULL, NULL, 'rSAM_HemZ: coproporphyrinogen dehydrogenase HemZ', NULL, 'TIGR03994', NULL, NULL, 18189, 22),
(287031, NULL, 'TIGR01672', NULL, NULL, 'AphA: HAD phosphatase, family IIIB', NULL, 'TIGR01672', NULL, NULL, 5238, 22),
(287032, NULL, 'TIGR02450', NULL, NULL, 'TIGR02450: tryptophan-rich conserved hypothetical protein', NULL, 'TIGR02450', NULL, NULL, 10981, 22),
(287033, NULL, 'TIGR00654', NULL, NULL, 'PhzF_family: phenazine biosynthesis protein, PhzF family', NULL, 'TIGR00654', NULL, NULL, 2059, 22),
(287034, NULL, 'TIGR02702', NULL, NULL, 'SufR_cyano: iron-sulfur cluster biosynthesis transcriptional regulator SufR', NULL, 'TIGR02702', NULL, NULL, 13338, 22),
(287035, NULL, 'TIGR04049', NULL, NULL, 'AIR_rel_sll0787: AIR synthase-related protein, sll0787 family', NULL, 'TIGR04049', NULL, NULL, 11663, 22),
(287036, NULL, 'TIGR03215', NULL, NULL, 'ac_ald_DH_ac: acetaldehyde dehydrogenase (acetylating)', NULL, 'TIGR03215', NULL, NULL, 4427, 22),
(287037, NULL, 'TIGR02839', NULL, NULL, 'spore_V_AE: stage V sporulation protein AE', NULL, 'TIGR02839', NULL, NULL, 9433, 22),
(287038, NULL, 'TIGR00841', NULL, NULL, 'bass: bile acid transporter', NULL, 'TIGR00841', NULL, NULL, 3461, 22),
(287039, NULL, 'TIGR00081', NULL, NULL, 'purC: phosphoribosylaminoimidazolesuccinocarboxamide synthase', NULL, 'TIGR00081', NULL, NULL, 3095, 22),
(287040, NULL, 'TIGR02263', NULL, NULL, 'benz_CoA_red_C: benzoyl-CoA reductase, subunit C', NULL, 'TIGR02263', NULL, NULL, 11421, 22),
(287041, NULL, 'TIGR03041', NULL, NULL, 'PS_antenn_a_b: chlorophyll a/b binding light-harvesting protein', NULL, 'TIGR03041', NULL, NULL, NULL, 22),
(287042, NULL, 'TIGR01996', NULL, NULL, 'PTS-II-BC-sucr: PTS system, sucrose-specific IIBC component', NULL, 'TIGR01996', NULL, NULL, 2039, 22),
(287043, NULL, 'TIGR03539', NULL, NULL, 'DapC_actino: succinyldiaminopimelate transaminase', NULL, 'TIGR03539', NULL, NULL, 16894, 22);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287044, NULL, 'TIGR02188', NULL, NULL, 'Ac_CoA_lig_AcsA: acetate--CoA ligase', NULL, 'TIGR02188', NULL, NULL, 12064, 22),
(287045, NULL, 'TIGR03097', NULL, NULL, 'PEP_O_lig_1: probable O-glycosylation ligase, exosortase A-associated', NULL, 'TIGR03097', NULL, NULL, 14506, 22),
(287046, NULL, 'TIGR03218', NULL, NULL, 'catechol_dmpH: 4-oxalocrotonate decarboxylase', NULL, 'TIGR03218', NULL, NULL, 16986, 22),
(287047, NULL, 'TIGR01606', NULL, NULL, 'holin_BlyA: holin, BlyA family', NULL, 'TIGR01606', NULL, NULL, 6466, 22),
(287048, NULL, 'TIGR04236', NULL, NULL, 'seadorna_VP2: seadornavirus VP2 protein', NULL, 'TIGR04236', NULL, NULL, 22973, 22),
(287049, NULL, 'TIGR03284', NULL, NULL, 'thym_sym: thymidylate synthase', NULL, 'TIGR03284', NULL, NULL, 6989, 22),
(287050, NULL, 'TIGR03888', NULL, NULL, 'nitrile_beta: nitrile hydratase, beta subunit', NULL, 'TIGR03888', NULL, NULL, 1993, 22),
(287051, NULL, 'TIGR02693', NULL, NULL, 'arsenite_ox_L: arsenite oxidase, large subunit', NULL, 'TIGR02693', NULL, NULL, 13337, 22),
(287052, NULL, 'TIGR01488', NULL, NULL, 'HAD-SF-IB: HAD phosphoserine phosphatase-like hydrolase, family IB', NULL, 'TIGR01488', NULL, NULL, NULL, 22),
(287053, NULL, 'TIGR03751', NULL, NULL, 'conj_TIGR03751: conjugative transfer region lipoprotein, TIGR03751 family', NULL, 'TIGR03751', NULL, NULL, 15569, 22),
(287054, NULL, 'TIGR00293', NULL, NULL, 'TIGR00293: prefoldin, alpha subunit', NULL, 'TIGR00293', NULL, NULL, 1814, 22),
(287055, NULL, 'TIGR00333', NULL, NULL, 'nrdI: nrdI protein', NULL, 'TIGR00333', NULL, NULL, 7443, 22),
(287056, NULL, 'TIGR02627', NULL, NULL, 'rhamnulo_kin: rhamnulokinase', NULL, 'TIGR02627', NULL, NULL, 9368, 22),
(287057, NULL, 'TIGR00763', NULL, NULL, 'lon: endopeptidase La', NULL, 'TIGR00763', NULL, NULL, 4385, 22),
(287058, NULL, 'TIGR04342', NULL, NULL, 'EXLDI: EXLDI protein', NULL, 'TIGR04342', NULL, NULL, 26553, 22),
(287059, NULL, 'TIGR01245', NULL, NULL, 'trpD: anthranilate phosphoribosyltransferase', NULL, 'TIGR01245', NULL, NULL, 449, 22),
(287060, NULL, 'TIGR02079', NULL, NULL, 'THD1: threonine dehydratase', NULL, 'TIGR02079', NULL, NULL, 13598, 22),
(287061, NULL, 'TIGR03390', NULL, NULL, 'ascorbOXfungal: L-ascorbate oxidase', NULL, 'TIGR03390', NULL, NULL, 18714, 22),
(287062, NULL, 'TIGR00869', NULL, NULL, 'sec62: protein translocation protein, Sec62 family', NULL, 'TIGR00869', NULL, NULL, 12485, 22),
(287063, NULL, 'TIGR02372', NULL, NULL, '4_coum_CoA_lig: 4-coumarate--CoA ligase', NULL, 'TIGR02372', NULL, NULL, 8517, 22),
(287064, NULL, 'TIGR00050', NULL, NULL, 'rRNA_methyl_1: RNA methyltransferase, TrmH family, group 1', NULL, 'TIGR00050', NULL, NULL, 5935, 22),
(287065, NULL, 'TIGR02294', NULL, NULL, 'nickel_nikA: nickel ABC transporter, nickel/metallophore periplasmic binding protein', NULL, 'TIGR02294', NULL, NULL, 13376, 22),
(287066, NULL, 'TIGR01002', NULL, NULL, 'hlyII: beta-channel forming cytolysin', NULL, 'TIGR01002', NULL, NULL, 7156, 22),
(287067, NULL, 'TIGR03324', NULL, NULL, 'alt_F1F0_F1_al: alternate F1F0 ATPase, F1 subunit alpha', NULL, 'TIGR03324', NULL, NULL, 17734, 22),
(287068, NULL, 'TIGR01139', NULL, NULL, 'cysK: cysteine synthase A', NULL, 'TIGR01139', NULL, NULL, 6732, 22),
(287069, NULL, 'TIGR04420', NULL, NULL, 'Sec_Non_Glob: Sec region non-globular protein', NULL, 'TIGR04420', NULL, NULL, 24825, 22),
(287070, NULL, 'TIGR02157', NULL, NULL, 'PA_CoA_Oxy2: phenylacetate-CoA oxygenase, PaaH subunit', NULL, 'TIGR02157', NULL, NULL, 14483, 22),
(287071, NULL, 'TIGR01323', NULL, NULL, 'nitrile_alph: nitrile hydratase, alpha subunit', NULL, 'TIGR01323', NULL, NULL, 19122, 22),
(287072, NULL, 'TIGR01781', NULL, NULL, 'Trep_dent_lipo: Treponema denticola clustered lipoprotein', NULL, 'TIGR01781', NULL, NULL, 2280, 22),
(287073, NULL, 'TIGR03567', NULL, NULL, 'FMN_reduc_SsuE: FMN reductase', NULL, 'TIGR03567', NULL, NULL, 11553, 22),
(287074, NULL, 'TIGR02733', NULL, NULL, 'desat_CrtD: C-3'',4'' desaturase CrtD', NULL, 'TIGR02733', NULL, NULL, 14389, 22),
(287075, NULL, 'TIGR00227', NULL, NULL, 'ribD_Cterm: riboflavin-specific deaminase C-terminal domain', NULL, 'TIGR00227', NULL, NULL, 7658, 22);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287076, NULL, 'TIGR03645', NULL, NULL, 'glyox_marine: lactoylglutathione lyase family protein', NULL, 'TIGR03645', NULL, NULL, 18417, 22),
(287077, NULL, 'TIGR02811', NULL, NULL, 'formate_TAT: formate dehydrogenase region TAT target', NULL, 'TIGR02811', NULL, NULL, 8836, 22),
(287078, NULL, 'TIGR03966', NULL, NULL, 'actino_HemFlav: heme/flavin dehydrogenase, mycofactocin system', NULL, 'TIGR03966', NULL, NULL, 11224, 22),
(287079, NULL, 'TIGR04479', NULL, NULL, 'bcpD_PhpK_rSAM: radical SAM P-methyltransferase, PhpK family', NULL, 'TIGR04479', NULL, NULL, 25239, 22),
(287080, NULL, 'TIGR00548', NULL, NULL, 'lolB: outer membrane lipoprotein LolB', NULL, 'TIGR00548', NULL, NULL, 577, 22),
(287081, NULL, 'TIGR00872', NULL, NULL, 'gnd_rel: 6-phosphogluconate dehydrogenase (decarboxylating)', NULL, 'TIGR00872', NULL, NULL, 6236, 22),
(287082, NULL, 'TIGR04314', NULL, NULL, 'methano7heme: methanogenesis multiheme c-type cytochrome', NULL, 'TIGR04314', NULL, NULL, 23094, 22),
(287083, NULL, 'TIGR00632', NULL, NULL, 'vsr: DNA mismatch endonuclease Vsr', NULL, 'TIGR00632', NULL, NULL, 971, 22),
(287084, NULL, 'TIGR03916', NULL, NULL, 'rSAM_link_UDG: putative DNA modification/repair radical SAM protein', NULL, 'TIGR03916', NULL, NULL, 16938, 22),
(287085, NULL, 'TIGR00769', NULL, NULL, 'AAA: ADP/ATP carrier protein family', NULL, 'TIGR00769', NULL, NULL, 2967, 22),
(287086, NULL, 'TIGR00134', NULL, NULL, 'gatE_arch: glutamyl-tRNA(Gln) amidotransferase, subunit E', NULL, 'TIGR00134', NULL, NULL, 7381, 22),
(287087, NULL, 'TIGR01753', NULL, NULL, 'flav_short: flavodoxin', NULL, 'TIGR01753', NULL, NULL, 2271, 22),
(287088, NULL, 'TIGR03480', NULL, NULL, 'HpnN: hopanoid biosynthesis associated RND transporter like protein HpnN', NULL, 'TIGR03480', NULL, NULL, 19765, 22),
(287089, NULL, 'TIGR00529', NULL, NULL, 'AF0261: integral membrane protein, TIGR00529 family', NULL, 'TIGR00529', NULL, NULL, 11212, 22),
(287090, NULL, 'TIGR00374', NULL, NULL, 'TIGR00374: TIGR00374 family protein', NULL, 'TIGR00374', NULL, NULL, 17051, 22),
(287091, NULL, 'TIGR01513', NULL, NULL, 'NAPRTase_put: nicotinate phosphoribosyltransferase', NULL, 'TIGR01513', NULL, NULL, 5866, 22),
(287092, NULL, 'TIGR03137', NULL, NULL, 'AhpC: peroxiredoxin', NULL, 'TIGR03137', NULL, NULL, 14721, 22),
(287093, NULL, 'TIGR03240', NULL, NULL, 'arg_catab_astD: succinylglutamate-semialdehyde dehydrogenase', NULL, 'TIGR03240', NULL, NULL, 17368, 22),
(287094, NULL, 'TIGR03433', NULL, NULL, 'padR_acidobact: transcriptional regulator, Acidobacterial, PadR-family', NULL, 'TIGR03433', NULL, NULL, 19213, 22),
(287095, NULL, 'TIGR04498', NULL, NULL, 'AbiV_defense: abortive infection protein, AbiV family', NULL, 'TIGR04498', NULL, NULL, 21678, 22),
(287096, NULL, 'TIGR04121', NULL, NULL, 'DEXH_lig_assoc: DEXH box helicase, DNA ligase-associated', NULL, 'TIGR04121', NULL, NULL, 23235, 22),
(287097, NULL, 'TIGR01908', NULL, NULL, 'cas_CXXC_CXXC: CRISPR-associated protein Cas8b1/Cst1, subtype I-B/TNEAP', NULL, 'TIGR01908', NULL, NULL, 4294, 22),
(287098, NULL, 'TIGR01416', NULL, NULL, 'Rieske_proteo: ubiquinol-cytochrome c reductase, iron-sulfur subunit', NULL, 'TIGR01416', NULL, NULL, 4773, 22),
(287099, NULL, 'TIGR02640', NULL, NULL, 'gas_vesic_GvpN: gas vesicle protein GvpN', NULL, 'TIGR02640', NULL, NULL, 9414, 22),
(287100, NULL, 'TIGR02777', NULL, NULL, 'LigD_PE_dom: DNA ligase D, 3''-phosphoesterase domain', NULL, 'TIGR02777', NULL, NULL, 14439, 22),
(287101, NULL, 'TIGR04516', NULL, NULL, 'glycosyl_450act: glycosyltransferase, activator-dependent family', NULL, 'TIGR04516', NULL, NULL, 25463, 22),
(287102, NULL, 'TIGR02054', NULL, NULL, 'MerD: mercuric resistence transcriptional repressor protein MerD', NULL, 'TIGR02054', NULL, NULL, 13015, 22),
(287103, NULL, 'TIGR02400', NULL, NULL, 'trehalose_OtsA: alpha,alpha-trehalose-phosphate synthase (UDP-forming)', NULL, 'TIGR02400', NULL, NULL, 9870, 22),
(287104, NULL, 'TIGR02306', NULL, NULL, 'RNA_lig_DRB0094: RNA ligase', NULL, 'TIGR02306', NULL, NULL, 10236, 22),
(287105, NULL, 'TIGR04264', NULL, NULL, 'hyperosmo_Ebh: hyperosmolarity resistance protein Ebh', NULL, 'TIGR04264', NULL, NULL, 24604, 22);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287106, NULL, 'TIGR01158', NULL, NULL, 'SUI1_rel: putative translation initiation factor SUI1', NULL, 'TIGR01158', NULL, NULL, 6941, 22),
(287107, NULL, 'TIGR00078', NULL, NULL, 'nadC: nicotinate-nucleotide diphosphorylase (carboxylating)', NULL, 'TIGR00078', NULL, NULL, 5540, 22),
(287108, NULL, 'TIGR04320', NULL, NULL, 'Surf_Exclu_PgrA: SEC10/PgrA surface exclusion domain', NULL, 'TIGR04320', NULL, NULL, 25451, 22),
(287109, NULL, 'TIGR04258', NULL, NULL, '4helix_suffix: four helix bundle suffix domain', NULL, 'TIGR04258', NULL, NULL, 24884, 22),
(287110, NULL, 'TIGR02584', NULL, NULL, 'cas_NE0113: CRISPR-associated protein, NE0113 family', NULL, 'TIGR02584', NULL, NULL, 9247, 22),
(287111, NULL, 'TIGR00140', NULL, NULL, 'hupD: hydrogenase expression/formation protein', NULL, 'TIGR00140', NULL, NULL, 7195, 22),
(287112, NULL, 'TIGR00576', NULL, NULL, 'dut: dUTP diphosphatase', NULL, 'TIGR00576', NULL, NULL, 7207, 22),
(287113, NULL, 'TIGR01560', NULL, NULL, 'put_DNA_pack: uncharacterized phage protein (possible DNA packaging)', NULL, 'TIGR01560', NULL, NULL, 6603, 22),
(287114, NULL, 'TIGR02836', NULL, NULL, 'spore_IV_A: stage IV sporulation protein A', NULL, 'TIGR02836', NULL, NULL, 9371, 22),
(287115, NULL, 'TIGR00190', NULL, NULL, 'thiC: phosphomethylpyrimidine synthase', NULL, 'TIGR00190', NULL, NULL, 4807, 22),
(287116, NULL, 'TIGR04062', NULL, NULL, 'dnd_assoc_4: dnd system-associated protein 4', NULL, 'TIGR04062', NULL, NULL, 11083, 22),
(287117, NULL, 'TIGR00087', NULL, NULL, 'surE: 5''/3''-nucleotidase SurE', NULL, 'TIGR00087', NULL, NULL, 5037, 22),
(287118, NULL, 'TIGR00433', NULL, NULL, 'bioB: biotin synthase', NULL, 'TIGR00433', NULL, NULL, 2832, 22),
(287119, NULL, 'TIGR03922', NULL, NULL, 'T7SS_EccA: type VII secretion AAA-ATPase EccA', NULL, 'TIGR03922', NULL, NULL, 16914, 22),
(287120, NULL, 'TIGR01071', NULL, NULL, 'rplO_bact: ribosomal protein uL15', NULL, 'TIGR01071', NULL, NULL, 4728, 22),
(287121, NULL, 'TIGR01609', NULL, NULL, 'PF_unchar_267: Plasmodium falciparum uncharacterized protein TIGR01609', NULL, 'TIGR01609', NULL, NULL, 6920, 22),
(287122, NULL, 'TIGR02783', NULL, NULL, 'TrbL_P: P-type conjugative transfer protein TrbL', NULL, 'TIGR02783', NULL, NULL, 14379, 22),
(287123, NULL, 'TIGR04267', NULL, NULL, 'mod_HExxH: HEXXH motif domain', NULL, 'TIGR04267', NULL, NULL, 24725, 22),
(287124, NULL, 'TIGR04457', NULL, NULL, 'lipo_LenA_lepto: lipoprotein LenA', NULL, 'TIGR04457', NULL, NULL, 25636, 22),
(287125, NULL, 'TIGR02593', NULL, NULL, 'CRISPR_cas5: CRISPR-associated protein Cas5', NULL, 'TIGR02593', NULL, NULL, 9479, 22),
(287126, NULL, 'TIGR01261', NULL, NULL, 'hisB_Nterm: histidinol-phosphatase', NULL, 'TIGR01261', NULL, NULL, 412, 22),
(287127, NULL, 'TIGR04560', NULL, NULL, 'ribo_THX: ribosomal small subunit protein bTHX', NULL, 'TIGR04560', NULL, NULL, 23938, 22),
(287128, NULL, 'TIGR03281', NULL, NULL, 'methan_mark_12: putative methanogenesis marker protein 12', NULL, 'TIGR03281', NULL, NULL, 21096, 22),
(287129, NULL, 'TIGR02303', NULL, NULL, 'HpaG-C-term: 4-hydroxyphenylacetate degradation bifunctional isomerase/decarboxylase, C-terminal subunit', NULL, 'TIGR02303', NULL, NULL, 11872, 22),
(287130, NULL, 'TIGR00277', NULL, NULL, 'HDIG: HDIG domain', NULL, 'TIGR00277', NULL, NULL, 1681, 22),
(287131, NULL, 'TIGR02113', NULL, NULL, 'coaC_strep: phosphopantothenoylcysteine decarboxylase', NULL, 'TIGR02113', NULL, NULL, 13717, 22),
(287132, NULL, 'TIGR03078', NULL, NULL, 'CH4_NH3mon_ox_C: methane monooxygenase/ammonia monooxygenase, subunit C', NULL, 'TIGR03078', NULL, NULL, 5812, 22),
(287133, NULL, 'TIGR00380', NULL, NULL, 'cobD: cobalamin biosynthesis protein CobD', NULL, 'TIGR00380', NULL, NULL, 1037, 22),
(287134, NULL, 'TIGR02736', NULL, NULL, 'cbb3_Q_epsi: cytochrome c oxidase, cbb3-type, CcoQ subunit', NULL, 'TIGR02736', NULL, NULL, 14422, 22),
(287135, NULL, 'TIGR01320', NULL, NULL, 'mal_quin_oxido: malate dehydrogenase (acceptor)', NULL, 'TIGR01320', NULL, NULL, 11342, 22),
(287136, NULL, 'TIGR02095', NULL, NULL, 'glgA: glycogen/starch synthase, ADP-glucose type', NULL, 'TIGR02095', NULL, NULL, 13535, 22);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287137, NULL, 'TIGR02285', NULL, NULL, 'TIGR02285: conserved hypothetical protein', NULL, 'TIGR02285', NULL, NULL, 11424, 22),
(287138, NULL, 'TIGR01457', NULL, NULL, 'HAD-SF-IIA-hyp2: HAD hydrolase, TIGR01457 family', NULL, 'TIGR01457', NULL, NULL, 4760, 22),
(287139, NULL, 'TIGR04018', NULL, NULL, 'Bthiol_YpdA: putative bacillithiol system oxidoreductase, YpdA family', NULL, 'TIGR04018', NULL, NULL, 8140, 22),
(287140, NULL, 'TIGR01949', NULL, NULL, 'AroFGH_arch: predicted phospho-2-dehydro-3-deoxyheptonate aldolase', NULL, 'TIGR01949', NULL, NULL, 4029, 22),
(287141, NULL, 'TIGR02107', NULL, NULL, 'PQQ_syn_pqqA: coenzyme PQQ precursor peptide PqqA', NULL, 'TIGR02107', NULL, NULL, 11585, 22),
(287142, NULL, 'TIGR01955', NULL, NULL, 'RfaH: transcription elongation factor/antiterminator RfaH', NULL, 'TIGR01955', NULL, NULL, 4399, 22),
(287143, NULL, 'TIGR03000', NULL, NULL, 'plancto_dom_1: Planctomycetes uncharacterized domain TIGR03000', NULL, 'TIGR03000', NULL, NULL, 19287, 22),
(287144, NULL, 'TIGR03629', NULL, NULL, 'uS13_arch: ribosomal protein uS13', NULL, 'TIGR03629', NULL, NULL, 11999, 22),
(287145, NULL, 'TIGR03819', NULL, NULL, 'heli_sec_ATPase: helicase/secretion neighborhood ATPase', NULL, 'TIGR03819', NULL, NULL, 15514, 22),
(287146, NULL, 'TIGR02101', NULL, NULL, 'IpaC_SipC: type III secretion target, IpaC/SipC family', NULL, 'TIGR02101', NULL, NULL, 197, 22),
(287147, NULL, 'TIGR01398', NULL, NULL, 'FlhA: flagellar biosynthesis protein FlhA', NULL, 'TIGR01398', NULL, NULL, 4835, 22),
(287148, NULL, 'TIGR03963', NULL, NULL, 'rSAM_QueE_Clost: putative 7-cyano-7-deazaguanosine (preQ0) biosynthesis protein QueE', NULL, 'TIGR03963', NULL, NULL, 18390, 22),
(287149, NULL, 'TIGR00623', NULL, NULL, 'sula: cell division inhibitor SulA', NULL, 'TIGR00623', NULL, NULL, 858, 22),
(287150, NULL, 'TIGR01896', NULL, NULL, 'cas_AF1879: CRISPR-associated protein Cas4/Csa1, subtype I-A/APERN', NULL, 'TIGR01896', NULL, NULL, 13660, 22),
(287151, NULL, 'TIGR00931', NULL, NULL, 'antiport_nhaC: Na+/H+ antiporter NhaC', NULL, 'TIGR00931', NULL, NULL, 5284, 22),
(287152, NULL, 'TIGR02605', NULL, NULL, 'CxxC_CxxC_SSSS: putative regulatory protein, FmdB family', NULL, 'TIGR02605', NULL, NULL, 9386, 22),
(287153, NULL, 'TIGR02880', NULL, NULL, 'cbbX_cfxQ: CbbX protein', NULL, 'TIGR02880', NULL, NULL, 6794, 22),
(287154, NULL, 'TIGR03726', NULL, NULL, 'strep_RK_lipo: putative cross-wall-targeting lipoprotein signal', NULL, 'TIGR03726', NULL, NULL, 16116, 22),
(287155, NULL, 'TIGR03290', NULL, NULL, 'CoB_CoM_SS_C: CoB--CoM heterodisulfide reductase, subunit C', NULL, 'TIGR03290', NULL, NULL, 17534, 22),
(287156, NULL, 'TIGR04504', NULL, NULL, 'SDR_subfam_2: SDR family mycofactocin-dependent oxidoreductase', NULL, 'TIGR04504', NULL, NULL, 24489, 22),
(287157, NULL, 'TIGR01220', NULL, NULL, 'Pmev_kin_Gr_pos: phosphomevalonate kinase', NULL, 'TIGR01220', NULL, NULL, 176, 22),
(287158, NULL, 'TIGR02789', NULL, NULL, 'nickel_nikB: nickel ABC transporter, permease subunit NikB', NULL, 'TIGR02789', NULL, NULL, 14159, 22),
(287159, NULL, 'TIGR00202', NULL, NULL, 'csrA: carbon storage regulator', NULL, 'TIGR00202', NULL, NULL, 2339, 22),
(287160, NULL, 'TIGR03670', NULL, NULL, 'rpoB_arch: DNA-directed RNA polymerase subunit B', NULL, 'TIGR03670', NULL, NULL, 15601, 22),
(287161, NULL, 'TIGR01357', NULL, NULL, 'aroB: 3-dehydroquinate synthase', NULL, 'TIGR01357', NULL, NULL, 17459, 22),
(287162, NULL, 'TIGR02652', NULL, NULL, 'TIGR02652: TIGR02652 family protein', NULL, 'TIGR02652', NULL, NULL, 10214, 22),
(287163, NULL, 'TIGR01117', NULL, NULL, 'mmdA: methylmalonyl-CoA decarboxylase alpha subunit', NULL, 'TIGR01117', NULL, NULL, 5886, 22),
(287164, NULL, 'TIGR02892', NULL, NULL, 'spore_yabP: sporulation protein YabP', NULL, 'TIGR02892', NULL, NULL, 12776, 22),
(287165, NULL, 'TIGR00339', NULL, NULL, 'sopT: sulfate adenylyltransferase', NULL, 'TIGR00339', NULL, NULL, 2952, 22),
(287166, NULL, 'TIGR03533', NULL, NULL, 'L3_gln_methyl: protein-(glutamine-N5) methyltransferase, ribosomal protein L3-specific', NULL, 'TIGR03533', NULL, NULL, 20730, 22);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287167, NULL, 'TIGR02238', NULL, NULL, 'recomb_DMC1: meiotic recombinase Dmc1', NULL, 'TIGR02238', NULL, NULL, 11470, 22),
(287168, NULL, 'TIGR00719', NULL, NULL, 'sda_beta: L-serine dehydratase, iron-sulfur-dependent, beta subunit', NULL, 'TIGR00719', NULL, NULL, 2681, 22),
(287169, NULL, 'TIGR02727', NULL, NULL, 'MTHFS_bact: 5-formyltetrahydrofolate cyclo-ligase', NULL, 'TIGR02727', NULL, NULL, 3771, 22),
(287170, NULL, 'TIGR03623', NULL, NULL, 'TIGR03623: probable DNA repair protein', NULL, 'TIGR03623', NULL, NULL, 15115, 22),
(287171, NULL, 'TIGR02154', NULL, NULL, 'PhoB: phosphate regulon transcriptional regulatory protein PhoB', NULL, 'TIGR02154', NULL, NULL, 8590, 22),
(287172, NULL, 'TIGR02845', NULL, NULL, 'spore_V_AD: stage V sporulation protein AD', NULL, 'TIGR02845', NULL, NULL, 12125, 22),
(287173, NULL, 'TIGR01718', NULL, NULL, 'Uridine-psphlse: uridine phosphorylase', NULL, 'TIGR01718', NULL, NULL, 6099, 22),
(287174, NULL, 'TIGR01466', NULL, NULL, 'cobJ_cbiH: precorrin-3B C17-methyltransferase', NULL, 'TIGR01466', NULL, NULL, 5656, 22),
(287175, NULL, 'TIGR04074', NULL, NULL, 'bacter_Hen1: 3'' terminal RNA ribose 2''-O-methyltransferase Hen1', NULL, 'TIGR04074', NULL, NULL, 19994, 22),
(287176, NULL, 'TIGR01027', NULL, NULL, 'proB: glutamate 5-kinase', NULL, 'TIGR01027', NULL, NULL, 3943, 22),
(287177, NULL, 'TIGR03365', NULL, NULL, 'Bsubt_queE: 7-cyano-7-deazaguanosine (preQ0) biosynthesis protein QueE', NULL, 'TIGR03365', NULL, NULL, 18484, 22),
(287178, NULL, 'TIGR02210', NULL, NULL, 'rodA_shape: rod shape-determining protein RodA', NULL, 'TIGR02210', NULL, NULL, 11318, 22),
(287179, NULL, 'TIGR03863', NULL, NULL, 'PQQ_ABC_bind: ABC transporter, substrate binding protein, PQQ-dependent alcohol dehydrogenase system', NULL, 'TIGR03863', NULL, NULL, 16247, 22),
(287180, NULL, 'TIGR01943', NULL, NULL, 'rnfA: electron transport complex, RnfABCDGE type, A subunit', NULL, 'TIGR01943', NULL, NULL, 10059, 22),
(287181, NULL, 'TIGR00972', NULL, NULL, '3a0107s01c2: phosphate ABC transporter, ATP-binding protein', NULL, 'TIGR00972', NULL, NULL, 3728, 22),
(287182, NULL, 'TIGR00828', NULL, NULL, 'EIID-AGA: PTS system, mannose/fructose/sorbose family, IID component', NULL, 'TIGR00828', NULL, NULL, 3008, 22),
(287183, NULL, 'TIGR03172', NULL, NULL, 'TIGR03172: putative selenium-dependent hydroxylase accessory protein YqeC', NULL, 'TIGR03172', NULL, NULL, 15952, 22),
(287184, NULL, 'TIGR01164', NULL, NULL, 'rplP_bact: ribosomal protein uL16', NULL, 'TIGR01164', NULL, NULL, 2905, 22),
(287185, NULL, 'TIGR02394', NULL, NULL, 'rpoS_proteo: RNA polymerase sigma factor RpoS', NULL, 'TIGR02394', NULL, NULL, 9851, 22),
(287186, NULL, 'TIGR00330', NULL, NULL, 'glpX: fructose-1,6-bisphosphatase, class II', NULL, 'TIGR00330', NULL, NULL, 7391, 22),
(287187, NULL, 'TIGR04199', NULL, NULL, 'exosort_xrtJ: exosortase J', NULL, 'TIGR04199', NULL, NULL, 25071, 22),
(287188, NULL, 'TIGR03424', NULL, NULL, 'urea_degr_1: urea carboxylase-associated protein 1', NULL, 'TIGR03424', NULL, NULL, 19438, 22),
(287189, NULL, 'TIGR03044', NULL, NULL, 'PS_II_psb27: photosystem II protein Psb27', NULL, 'TIGR03044', NULL, NULL, 20783, 22),
(287190, NULL, 'TIGR02406', NULL, NULL, 'ectoine_EctA: diaminobutyrate acetyltransferase', NULL, 'TIGR02406', NULL, NULL, 9644, 22),
(287191, NULL, 'TIGR00816', NULL, NULL, 'tdt: C4-dicarboxylate transporter/malic acid transport protein', NULL, 'TIGR00816', NULL, NULL, 8536, 22),
(287192, NULL, 'TIGR00483', NULL, NULL, 'EF-1_alpha: translation elongation factor EF-1, subunit alpha', NULL, 'TIGR00483', NULL, NULL, 1953, 22),
(287193, NULL, 'TIGR03972', NULL, NULL, 'rSAM_TYW1: wyosine biosynthesis protein TYW1', NULL, 'TIGR03972', NULL, NULL, 18399, 22),
(287194, NULL, 'TIGR00981', NULL, NULL, 'rpsL_bact: ribosomal protein uS12', NULL, 'TIGR00981', NULL, NULL, 3549, 22),
(287195, NULL, 'TIGR01348', NULL, NULL, 'PDHac_trf_long: dihydrolipoyllysine-residue acetyltransferase', NULL, 'TIGR01348', NULL, NULL, 3962, 22),
(287196, NULL, 'TIGR02904', NULL, NULL, 'spore_ysxE: spore coat protein YsxE', NULL, 'TIGR02904', NULL, NULL, 11298, 22);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287197, NULL, 'TIGR00025', NULL, NULL, 'Mtu_efflux: ABC transporter efflux protein, DrrB family', NULL, 'TIGR00025', NULL, NULL, 5999, 22),
(287198, NULL, 'TIGR00863', NULL, NULL, 'P2X: cation transporter protein', NULL, 'TIGR00863', NULL, NULL, 6799, 22),
(287199, NULL, 'TIGR03474', NULL, NULL, 'incFII_RepA: incFII family plasmid replication initiator RepA', NULL, 'TIGR03474', NULL, NULL, 19595, 22),
(287200, NULL, 'TIGR03854', NULL, NULL, 'F420_MSMEG_3544: probable F420-dependent oxidoreductase, MSMEG_3544 family', NULL, 'TIGR03854', NULL, NULL, 15684, 22),
(287201, NULL, 'TIGR03181', NULL, NULL, 'PDH_E1_alph_x: pyruvate dehydrogenase (acetyl-transferring) E1 component, alpha subunit', NULL, 'TIGR03181', NULL, NULL, 15653, 22),
(287202, NULL, 'TIGR01525', NULL, NULL, 'ATPase-IB_hvy: heavy metal translocating P-type ATPase', NULL, 'TIGR01525', NULL, NULL, 22572, 22),
(287203, NULL, 'TIGR03679', NULL, NULL, 'arCOG00187: arCOG00187 universal archaeal metal-binding-domain/4Fe-4S-binding-domain containing ABC transporter, ATP-binding protein', NULL, 'TIGR03679', NULL, NULL, 15670, 22),
(287204, NULL, 'TIGR01697', NULL, NULL, 'PNPH-PUNA-XAPA: inosine/guanosine/xanthosine phosphorylase family', NULL, 'TIGR01697', NULL, NULL, 9806, 22),
(287205, NULL, 'TIGR01846', NULL, NULL, 'type_I_sec_HlyB: type I secretion system ATPase', NULL, 'TIGR01846', NULL, NULL, 10507, 22),
(287206, NULL, 'TIGR01990', NULL, NULL, 'bPGM: beta-phosphoglucomutase', NULL, 'TIGR01990', NULL, NULL, 2305, 22),
(287207, NULL, 'TIGR02045', NULL, NULL, 'P_fruct_ADP: ADP-specific phosphofructokinase', NULL, 'TIGR02045', NULL, NULL, 13428, 22),
(287208, NULL, 'TIGR02347', NULL, NULL, 'chap_CCT_zeta: T-complex protein 1, zeta subunit', NULL, 'TIGR02347', NULL, NULL, 11950, 22),
(287209, NULL, 'TIGR01709', NULL, NULL, 'typeII_sec_gspL: type II secretion system protein L', NULL, 'TIGR01709', NULL, NULL, 2206, 22),
(287210, NULL, 'TIGR04171', NULL, NULL, 'RNR_1b_NrdF: ribonucleoside-diphosphate reductase, class 1b, beta subunit', NULL, 'TIGR04171', NULL, NULL, 23071, 22),
(287211, NULL, 'TIGR01211', NULL, NULL, 'ELP3: radical SAM enzyme/protein acetyltransferase, ELP3 family', NULL, 'TIGR01211', NULL, NULL, 32233, 22),
(287212, NULL, 'TIGR02543', NULL, NULL, 'List_Bact_rpt: repeat, TIGR02543 family', NULL, 'TIGR02543', NULL, NULL, 11286, 22),
(287213, NULL, 'TIGR03377', NULL, NULL, 'glycerol3P_GlpA: glycerol-3-phosphate dehydrogenase, anaerobic, A subunit', NULL, 'TIGR03377', NULL, NULL, 18827, 22),
(287214, NULL, 'TIGR04027', NULL, NULL, 'LLM_KPN_01858: putative FMN-dependent luciferase-like monooxygenase, KPN_01858 family', NULL, 'TIGR04027', NULL, NULL, 15937, 22),
(287215, NULL, 'TIGR00037', NULL, NULL, 'eIF_5A: translation elongation factor IF5A', NULL, 'TIGR00037', NULL, NULL, 4219, 22),
(287216, NULL, 'TIGR04551', NULL, NULL, 'TIGR04551: TIGR04551 family protein', NULL, 'TIGR04551', NULL, NULL, 25169, 22),
(287217, NULL, 'TIGR00181', NULL, NULL, 'pepF: oligoendopeptidase F', NULL, 'TIGR00181', NULL, NULL, 7011, 22),
(287218, NULL, 'TIGR04230', NULL, NULL, 'seadorna_VP11: seadornavirus VP11 protein', NULL, 'TIGR04230', NULL, NULL, 22580, 22),
(287219, NULL, 'TIGR01650', NULL, NULL, 'PD_CobS: cobaltochelatase, CobS subunit', NULL, 'TIGR01650', NULL, NULL, 274, 22),
(287220, NULL, 'TIGR04407', NULL, NULL, 'LptF_YjgP: LPS export ABC transporter permease LptF', NULL, 'TIGR04407', NULL, NULL, 23848, 22),
(287221, NULL, 'TIGR02163', NULL, NULL, 'napH_: ferredoxin-type protein, NapH/MauN family', NULL, 'TIGR02163', NULL, NULL, 8696, 22),
(287222, NULL, 'TIGR04492', NULL, NULL, 'VioB: iminophenyl-pyruvate dimer synthase VioB', NULL, 'TIGR04492', NULL, NULL, 21555, 22),
(287223, NULL, 'TIGR02484', NULL, NULL, 'CitB: CitB domain protein', NULL, 'TIGR02484', NULL, NULL, 12717, 22),
(287224, NULL, 'TIGR01049', NULL, NULL, 'rpsJ_bact: ribosomal protein uS10', NULL, 'TIGR01049', NULL, NULL, 4264, 22),
(287225, NULL, 'TIGR04348', NULL, NULL, 'TIGR04348: putative glycosyltransferase, TIGR04348 family', NULL, 'TIGR04348', NULL, NULL, 23859, 22);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287226, NULL, 'TIGR02462', NULL, NULL, 'pyranose_ox: pyranose oxidase', NULL, 'TIGR02462', NULL, NULL, 12573, 22),
(287227, NULL, 'TIGR04108', NULL, NULL, 'HutX: putative heme utilization carrier protein HutX', NULL, 'TIGR04108', NULL, NULL, 9497, 22),
(287228, NULL, 'TIGR00168', NULL, NULL, 'infC: translation initiation factor IF-3', NULL, 'TIGR00168', NULL, NULL, 373, 22),
(287229, NULL, 'TIGR01289', NULL, NULL, 'LPOR: light-dependent protochlorophyllide reductase', NULL, 'TIGR01289', NULL, NULL, 1041, 22),
(287230, NULL, 'TIGR01152', NULL, NULL, 'psbD: photosystem II D2 protein (photosystem q(a) protein)', NULL, 'TIGR01152', NULL, NULL, 6665, 22),
(287231, NULL, 'TIGR00994', NULL, NULL, '3a0901s05TIC20: chloroplast protein import component, Tic20 family', NULL, 'TIGR00994', NULL, NULL, 3928, 22),
(287232, NULL, 'TIGR01083', NULL, NULL, 'nth: endonuclease III', NULL, 'TIGR01083', NULL, NULL, 4783, 22),
(287233, NULL, 'TIGR03343', NULL, NULL, 'biphenyl_bphD: 2-hydroxy-6-oxo-6-phenylhexa-2,4-dienoate hydrolase', NULL, 'TIGR03343', NULL, NULL, 18340, 22),
(287234, NULL, 'TIGR01307', NULL, NULL, 'pgm_bpd_ind: phosphoglycerate mutase (2,3-diphosphoglycerate-independent)', NULL, 'TIGR01307', NULL, NULL, 1480, 22),
(287235, NULL, 'TIGR04395', NULL, NULL, 'cutC_activ_rSAM: choline TMA-lyase-activating enzyme', NULL, 'TIGR04395', NULL, NULL, 25420, 22),
(287236, NULL, 'TIGR00031', NULL, NULL, 'UDP-GALP_mutase: UDP-galactopyranose mutase', NULL, 'TIGR00031', NULL, NULL, 5916, 22),
(287237, NULL, 'TIGR03315', NULL, NULL, 'Se_ygfK: putative selenate reductase, YgfK subunit', NULL, 'TIGR03315', NULL, NULL, 17942, 22),
(287238, NULL, 'TIGR01410', NULL, NULL, 'tatB: twin arginine-targeting protein translocase TatB', NULL, 'TIGR01410', NULL, NULL, 16798, 22),
(287239, NULL, 'TIGR03813', NULL, NULL, 'put_Glu_GABA_T: putative glutamate/gamma-aminobutyrate antiporter', NULL, 'TIGR03813', NULL, NULL, 16363, 22),
(287240, NULL, 'TIGR01787', NULL, NULL, 'squalene_cyclas: squalene/oxidosqualene cyclases', NULL, 'TIGR01787', NULL, NULL, 20195, 22),
(287241, NULL, 'TIGR03795', NULL, NULL, 'RNP_Burkhold: ribosomal natural product, two-chain TOMM family', NULL, 'TIGR03795', NULL, NULL, 15923, 22),
(287242, NULL, 'TIGR02434', NULL, NULL, 'CobF: precorrin-6A synthase (deacetylating)', NULL, 'TIGR02434', NULL, NULL, 11586, 22),
(287243, NULL, 'TIGR01622', NULL, NULL, 'SF-CC1: splicing factor, CC1-like family', NULL, 'TIGR01622', NULL, NULL, 6888, 22),
(287244, NULL, 'TIGR03601', NULL, NULL, 'B_an_ocin: bacteriocin, heterocycloanthracin/sonorensin family', NULL, 'TIGR03601', NULL, NULL, 14613, 22),
(287245, NULL, 'TIGR03978', NULL, NULL, 'rSAM_paired_1: His-Xaa-Ser system radical SAM maturase HxsB', NULL, 'TIGR03978', NULL, NULL, 11546, 22),
(287246, NULL, 'TIGR00638', NULL, NULL, 'Mop: molybdenum-pterin binding domain', NULL, 'TIGR00638', NULL, NULL, 888, 22),
(287247, NULL, 'TIGR04470', NULL, NULL, 'rSAM_mob_pairB: radical SAM mobile pair protein B', NULL, 'TIGR04470', NULL, NULL, 25794, 22),
(287248, NULL, 'TIGR03738', NULL, NULL, 'PRTRC_C: PRTRC system protein C', NULL, 'TIGR03738', NULL, NULL, 15140, 22),
(287249, NULL, 'TIGR03807', NULL, NULL, 'RR_fam_repeat: putative cofactor-binding repeat', NULL, 'TIGR03807', NULL, NULL, 21323, 22),
(287250, NULL, 'TIGR00271', NULL, NULL, 'TIGR00271: uncharacterized hydrophobic domain', NULL, 'TIGR00271', NULL, NULL, NULL, 22),
(287251, NULL, 'TIGR00003', NULL, NULL, 'TIGR00003: copper ion binding protein', NULL, 'TIGR00003', NULL, NULL, 10101, 22),
(287252, NULL, 'TIGR03103', NULL, NULL, 'trio_acet_GNAT: GNAT-family acetyltransferase TIGR03103', NULL, 'TIGR03103', NULL, NULL, 14916, 22),
(287253, NULL, 'TIGR01547', NULL, NULL, 'phage_term_2: phage terminase, large subunit, PBSX family', NULL, 'TIGR01547', NULL, NULL, 6690, 22),
(287254, NULL, 'TIGR01295', NULL, NULL, 'PedC_BrcD: putative bacteriocin transport accessory protein', NULL, 'TIGR01295', NULL, NULL, 1289, 22),
(287255, NULL, 'TIGR01881', NULL, NULL, 'cas_Cmr5: CRISPR type III-B/RAMP module-associated protein Cmr5', NULL, 'TIGR01881', NULL, NULL, 10942, 22);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287256, NULL, 'TIGR03555', NULL, NULL, 'F420_mer: 5,10-methylenetetrahydromethanopterin reductase', NULL, 'TIGR03555', NULL, NULL, 18343, 22),
(287257, NULL, 'TIGR00196', NULL, NULL, 'yjeF_cterm: YjeF family C-terminal domain', NULL, 'TIGR00196', NULL, NULL, 5788, 22),
(287258, NULL, 'TIGR00782', NULL, NULL, 'ccoP: cytochrome c oxidase, cbb3-type, subunit III', NULL, 'TIGR00782', NULL, NULL, 3235, 22),
(287259, NULL, 'TIGR04442', NULL, NULL, 'TIGR04442: TIGR04442 family protein', NULL, 'TIGR04442', NULL, NULL, 26306, 22),
(287260, NULL, 'TIGR04252', NULL, NULL, 'SCM_precur_ScmA: SynChlorMet cassette protein ScmA', NULL, 'TIGR04252', NULL, NULL, NULL, 22),
(287261, NULL, 'TIGR00570', NULL, NULL, 'cdk7: CDK-activating kinase assembly factor MAT1', NULL, 'TIGR00570', NULL, NULL, 855, 22),
(287262, NULL, 'TIGR04149', NULL, NULL, 'GG_sam_targ_CFB: natural product precursor, GG-Bacteroidales family', NULL, 'TIGR04149', NULL, NULL, 21281, 22),
(287263, NULL, 'TIGR04012', NULL, NULL, 'poly_gGlu_PgsB: poly-gamma-glutamate synthase PgsB', NULL, 'TIGR04012', NULL, NULL, 7928, 22),
(287264, NULL, 'TIGR02456', NULL, NULL, 'treS_nterm: trehalose synthase', NULL, 'TIGR02456', NULL, NULL, 12914, 22),
(287265, NULL, 'TIGR00072', NULL, NULL, 'hydrog_prot: hydrogenase maturation protease', NULL, 'TIGR00072', NULL, NULL, 3724, 22),
(287266, NULL, 'TIGR00243', NULL, NULL, 'Dxr: 1-deoxy-D-xylulose 5-phosphate reductoisomerase', NULL, 'TIGR00243', NULL, NULL, 3142, 22),
(287267, NULL, 'TIGR03091', NULL, NULL, 'SASP_sspK: small, acid-soluble spore protein K', NULL, 'TIGR03091', NULL, NULL, 9770, 22),
(287268, NULL, 'TIGR01451', NULL, NULL, 'B_ant_repeat: conserved repeat domain', NULL, 'TIGR01451', NULL, NULL, 3026, 22),
(287269, NULL, 'TIGR00878', NULL, NULL, 'purM: phosphoribosylformylglycinamidine cyclo-ligase', NULL, 'TIGR00878', NULL, NULL, 3937, 22),
(287270, NULL, 'TIGR04326', NULL, NULL, 'O_ant_LIC13510: surface carbohydrate biosynthesis protein, LIC13510 family', NULL, 'TIGR04326', NULL, NULL, 23430, 22),
(287271, NULL, 'TIGR01921', NULL, NULL, 'DAP-DH: diaminopimelate dehydrogenase', NULL, 'TIGR01921', NULL, NULL, 4277, 22),
(287272, NULL, 'TIGR03268', NULL, NULL, 'methan_mark_3: putative methanogenesis marker protein 3', NULL, 'TIGR03268', NULL, NULL, 15039, 22),
(287273, NULL, 'TIGR04136', NULL, NULL, 'rSAM_FibroRumin: radical SAM peptide maturase, FibroRumin system', NULL, 'TIGR04136', NULL, NULL, 21305, 22),
(287274, NULL, 'TIGR02886', NULL, NULL, 'spore_II_AA: anti-sigma F factor antagonist', NULL, 'TIGR02886', NULL, NULL, 10587, 22),
(287275, NULL, 'TIGR03302', NULL, NULL, 'OM_YfiO: outer membrane assembly lipoprotein YfiO', NULL, 'TIGR03302', NULL, NULL, 17776, 22),
(287276, NULL, 'TIGR02926', NULL, NULL, 'AhaH: ATP synthase archaeal, H subunit', NULL, 'TIGR02926', NULL, NULL, 8554, 22),
(287277, NULL, 'TIGR01759', NULL, NULL, 'MalateDH-SF1: malate dehydrogenase', NULL, 'TIGR01759', NULL, NULL, 1965, 22),
(287278, NULL, 'TIGR01267', NULL, NULL, 'Phe4hydrox_mono: phenylalanine-4-hydroxylase', NULL, 'TIGR01267', NULL, NULL, 214, 22),
(287279, NULL, 'TIGR01130', NULL, NULL, 'ER_PDI_fam: protein disulfide isomerase', NULL, 'TIGR01130', NULL, NULL, 5699, 22),
(287280, NULL, 'TIGR02618', NULL, NULL, 'tyr_phenol_ly: tyrosine phenol-lyase', NULL, 'TIGR02618', NULL, NULL, 9059, 22),
(287281, NULL, 'TIGR02428', NULL, NULL, 'pcaJ_scoB_fam: 3-oxoacid CoA-transferase, B subunit', NULL, 'TIGR02428', NULL, NULL, 9659, 22),
(287282, NULL, 'TIGR01077', NULL, NULL, 'L13_A_E: ribosomal protein uL13', NULL, 'TIGR01077', NULL, NULL, 4944, 22),
(287283, NULL, 'TIGR03125', NULL, NULL, 'citrate_citG: triphosphoribosyl-dephospho-CoA synthase CitG', NULL, 'TIGR03125', NULL, NULL, 14575, 22),
(287284, NULL, 'TIGR01575', NULL, NULL, 'rimI: ribosomal-protein-alanine acetyltransferase', NULL, 'TIGR01575', NULL, NULL, 6180, 22),
(287285, NULL, 'TIGR01765', NULL, NULL, 'tspaseT_teng_N: transposase, putative, N-terminal domain', NULL, 'TIGR01765', NULL, NULL, 2037, 22),
(287286, NULL, 'TIGR03439', NULL, NULL, 'methyl_EasF: probable methyltransferase domain, EasF family', NULL, 'TIGR03439', NULL, NULL, 19154, 22);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287287, NULL, 'TIGR00754', NULL, NULL, 'bfr: bacterioferritin', NULL, 'TIGR00754', NULL, NULL, 2463, 22),
(287288, NULL, 'TIGR03773', NULL, NULL, 'anch_rpt_wall: putative ABC transporter-associated repeat protein', NULL, 'TIGR03773', NULL, NULL, 15721, 22),
(287289, NULL, 'TIGR01588', NULL, NULL, 'citE: citrate (pro-3S)-lyase, beta subunit', NULL, 'TIGR01588', NULL, NULL, 6287, 22),
(287290, NULL, 'TIGR02599', NULL, NULL, 'TIGR02599: Verru_Chthon cassette protein C', NULL, 'TIGR02599', NULL, NULL, 15615, 22),
(287291, NULL, 'TIGR03131', NULL, NULL, 'malonate_mdcH: malonate decarboxylase, epsilon subunit', NULL, 'TIGR03131', NULL, NULL, 14579, 22),
(287292, NULL, 'TIGR03583', NULL, NULL, 'EF_0837: putative amidohydrolase, EF_0837/AHA_3915 family', NULL, 'TIGR03583', NULL, NULL, 11589, 22),
(287293, NULL, 'TIGR04096', NULL, NULL, 'dnd_rel_methyl: DNA phosphorothioation-associated putative methyltransferase', NULL, 'TIGR04096', NULL, NULL, 15075, 22),
(287294, NULL, 'TIGR00741', NULL, NULL, 'yfiA: ribosomal subunit interface protein', NULL, 'TIGR00741', NULL, NULL, 6480, 22),
(287295, NULL, 'TIGR00324', NULL, NULL, 'endA: tRNA-intron lyase', NULL, 'TIGR00324', NULL, NULL, 1603, 22),
(287296, NULL, 'TIGR01342', NULL, NULL, 'acon_putative: putative aconitate hydratase', NULL, 'TIGR01342', NULL, NULL, 3975, 22),
(287297, NULL, 'TIGR00564', NULL, NULL, 'trpE_most: anthranilate synthase component I', NULL, 'TIGR00564', NULL, NULL, 4148, 22),
(287298, NULL, 'TIGR01479', NULL, NULL, 'GMP_PMI: mannose-1-phosphate guanylyltransferase/mannose-6-phosphate isomerase', NULL, 'TIGR01479', NULL, NULL, 5918, 22),
(287299, NULL, 'TIGR01703', NULL, NULL, 'hybrid_clust: hydroxylamine reductase', NULL, 'TIGR01703', NULL, NULL, 5305, 22),
(287300, NULL, 'TIGR00598', NULL, NULL, 'rad14: DNA repair protein', NULL, 'TIGR00598', NULL, NULL, 6723, 22),
(287301, NULL, 'TIGR02858', NULL, NULL, 'spore_III_AA: stage III sporulation protein AA', NULL, 'TIGR02858', NULL, NULL, 10759, 22),
(287302, NULL, 'TIGR03022', NULL, NULL, 'WbaP_sugtrans: undecaprenyl-phosphate galactose phosphotransferase WbaP', NULL, 'TIGR03022', NULL, NULL, 20939, 22),
(287303, NULL, 'TIGR03050', NULL, NULL, 'PS_I_psaK_plant: photosystem I reaction center PsaK', NULL, 'TIGR03050', NULL, NULL, 20971, 22),
(287304, NULL, 'TIGR00822', NULL, NULL, 'EII-Sor: PTS system, mannose/fructose/sorbose family, IIC component', NULL, 'TIGR00822', NULL, NULL, 3076, 22),
(287305, NULL, 'TIGR03399', NULL, NULL, 'RNA_3prim_cycl: RNA 3''-phosphate cyclase', NULL, 'TIGR03399', NULL, NULL, 18934, 22),
(287306, NULL, 'TIGR03985', NULL, NULL, 'TIGR03985: CRISPR-associated protein, TIGR03985 family', NULL, 'TIGR03985', NULL, NULL, 7585, 22),
(287307, NULL, 'TIGR04401', NULL, NULL, 'TAT_Cys_rich: twin-arginine translocation signal/Cys-rich four helix bundle protein', NULL, 'TIGR04401', NULL, NULL, 25915, 22),
(287308, NULL, 'TIGR02169', NULL, NULL, 'SMC_prok_A: chromosome segregation protein SMC', NULL, 'TIGR02169', NULL, NULL, 8540, 22),
(287309, NULL, 'TIGR01977', NULL, NULL, 'am_tr_V_EF2568: cysteine desulfurase family protein', NULL, 'TIGR01977', NULL, NULL, 2369, 22),
(287310, NULL, 'TIGR02830', NULL, NULL, 'spore_III_AG: stage III sporulation protein AG', NULL, 'TIGR02830', NULL, NULL, 8994, 22),
(287311, NULL, 'TIGR04177', NULL, NULL, 'exosort_XrtH: exosortase H, IPTLxxWG-CTERM-specific', NULL, 'TIGR04177', NULL, NULL, 23110, 22),
(287312, NULL, 'TIGR01226', NULL, NULL, 'phe_am_lyase: phenylalanine ammonia-lyase', NULL, 'TIGR01226', NULL, NULL, 70, 22),
(287313, NULL, 'TIGR01812', NULL, NULL, 'sdhA_frdA_Gneg: succinate dehydrogenase or fumarate reductase, flavoprotein subunit', NULL, 'TIGR01812', NULL, NULL, 11597, 22),
(287314, NULL, 'TIGR03296', NULL, NULL, 'M6dom_TIGR03296: M6 family metalloprotease domain', NULL, 'TIGR03296', NULL, NULL, 12231, 22),
(287315, NULL, 'TIGR03411', NULL, NULL, 'urea_trans_UrtD: urea ABC transporter, ATP-binding protein UrtD', NULL, 'TIGR03411', NULL, NULL, 19059, 22),
(287316, NULL, 'TIGR01370', NULL, NULL, 'TIGR01370: extracellular protein', NULL, 'TIGR01370', NULL, NULL, 10291, 22);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287317, NULL, 'TIGR02244', NULL, NULL, 'HAD-IG-Ncltidse: HAD superfamily (subfamily IG) hydrolase, 5''-nucleotidase', NULL, 'TIGR02244', NULL, NULL, 7587, 22),
(287318, NULL, 'TIGR03548', NULL, NULL, 'mutarot_permut: cyclically-permuted mutarotase family protein', NULL, 'TIGR03548', NULL, NULL, 18205, 22),
(287319, NULL, 'TIGR00215', NULL, NULL, 'lpxB: lipid-A-disaccharide synthase', NULL, 'TIGR00215', NULL, NULL, 3160, 22),
(287320, NULL, 'TIGR04566', NULL, NULL, 'myxo_TraA_Nterm: outer membrane exchange protein TraA, N-terminal region', NULL, 'TIGR04566', NULL, NULL, 23557, 22),
(287321, NULL, 'TIGR02004', NULL, NULL, 'PTS-IIBC-malX: PTS system, maltose and glucose-specific IIBC component', NULL, 'TIGR02004', NULL, NULL, 10122, 22),
(287322, NULL, 'TIGR00461', NULL, NULL, 'gcvP: glycine dehydrogenase', NULL, 'TIGR00461', NULL, NULL, 5225, 22),
(287323, NULL, 'TIGR02721', NULL, NULL, 'ycfN_thiK: thiamine kinase', NULL, 'TIGR02721', NULL, NULL, 14248, 22),
(287324, NULL, 'TIGR01868', NULL, NULL, 'casD_Cas5e: CRISPR-associated protein Cas5/CasD, subtype I-E/ECOLI', NULL, 'TIGR01868', NULL, NULL, 10932, 22),
(287325, NULL, 'TIGR04068', NULL, NULL, 'rSAM_ocin_clost: Cys-rich peptide radical SAM maturase CcpM', NULL, 'TIGR04068', NULL, NULL, 11832, 22),
(287326, NULL, 'TIGR04510', NULL, NULL, 'mod_pep_cyc: putative peptide modification system cyclase', NULL, 'TIGR04510', NULL, NULL, 25144, 22),
(287327, NULL, 'TIGR00713', NULL, NULL, 'hemL: glutamate-1-semialdehyde-2,1-aminomutase', NULL, 'TIGR00713', NULL, NULL, 2306, 22),
(287328, NULL, 'TIGR03732', NULL, NULL, 'lanti_perm_MutE: lantibiotic protection ABC transporter permease subunit, MutE/EpiE family', NULL, 'TIGR03732', NULL, NULL, 16120, 22),
(287329, NULL, 'TIGR03159', NULL, NULL, 'cas_Csc1: CRISPR type I-D/CYANO-associated protein Csc1', NULL, 'TIGR03159', NULL, NULL, 15535, 22),
(287330, NULL, 'TIGR01691', NULL, NULL, 'enolase-ppase: 2,3-diketo-5-methylthio-1-phosphopentane phosphatase', NULL, 'TIGR01691', NULL, NULL, 10362, 22),
(287331, NULL, 'TIGR00959', NULL, NULL, 'ffh: signal recognition particle protein', NULL, 'TIGR00959', NULL, NULL, 5093, 22),
(287332, NULL, 'TIGR02646', NULL, NULL, 'TIGR02646: TIGR02646 family protein', NULL, 'TIGR02646', NULL, NULL, 10155, 22),
(287333, NULL, 'TIGR02967', NULL, NULL, 'guan_deamin: guanine deaminase', NULL, 'TIGR02967', NULL, NULL, 9754, 22),
(287334, NULL, 'TIGR04389', NULL, NULL, 'Lepto_lipo_1: lipoprotein, tandem type', NULL, 'TIGR04389', NULL, NULL, 22433, 22),
(287335, NULL, 'TIGR02216', NULL, NULL, 'phage_TIGR02216: phage conserved hypothetical protein', NULL, 'TIGR02216', NULL, NULL, 11676, 22),
(287336, NULL, 'TIGR00673', NULL, NULL, 'cynS: cyanase', NULL, 'TIGR00673', NULL, NULL, 6040, 22),
(287337, NULL, 'TIGR03234', NULL, NULL, 'OH-pyruv-isom: hydroxypyruvate isomerase', NULL, 'TIGR03234', NULL, NULL, 16729, 22),
(287338, NULL, 'TIGR03371', NULL, NULL, 'cellulose_yhjQ: cellulose synthase operon protein YhjQ', NULL, 'TIGR03371', NULL, NULL, 18662, 22),
(287339, NULL, 'TIGR03869', NULL, NULL, 'F420-0_ABCperm: proposed F420-0 ABC transporter, permease protein', NULL, 'TIGR03869', NULL, NULL, 15528, 22),
(287340, NULL, 'TIGR02714', NULL, NULL, 'amido_AtzD_TrzD: ring-opening amidohydrolases', NULL, 'TIGR02714', NULL, NULL, 14274, 22),
(287341, NULL, 'TIGR00501', NULL, NULL, 'met_pdase_II: methionine aminopeptidase, type II', NULL, 'TIGR00501', NULL, NULL, 6844, 22),
(287342, NULL, 'TIGR01656', NULL, NULL, 'Histidinol-ppas: histidinol-phosphate phosphatase domain', NULL, 'TIGR01656', NULL, NULL, 441, 22),
(287343, NULL, 'TIGR01335', NULL, NULL, 'psaA: photosystem I core protein PsaA', NULL, 'TIGR01335', NULL, NULL, 3623, 22),
(287344, NULL, 'TIGR03664', NULL, NULL, 'fut_nucase: futalosine hydrolase', NULL, 'TIGR03664', NULL, NULL, 15557, 22),
(287345, NULL, 'TIGR00208', NULL, NULL, 'fliS: flagellar protein FliS', NULL, 'TIGR00208', NULL, NULL, 2413, 22),
(287346, NULL, 'TIGR00489', NULL, NULL, 'aEF-1_beta: translation elongation factor aEF-1 beta', NULL, 'TIGR00489', NULL, NULL, 1782, 22);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287347, NULL, 'TIGR02674', NULL, NULL, 'cas_cyan_RAMP_2: CRISPR-associated RAMP protein, Csx10 family', NULL, 'TIGR02674', NULL, NULL, 10035, 22),
(287348, NULL, 'TIGR02537', NULL, NULL, 'arch_flag_Nterm: archaeal flagellin N-terminal-like domain', NULL, 'TIGR02537', NULL, NULL, 11149, 22),
(287349, NULL, 'TIGR03841', NULL, NULL, 'F420_Rv3093c: probable F420-dependent oxidoreductase, Rv3093c family', NULL, 'TIGR03841', NULL, NULL, 16403, 22),
(287350, NULL, 'TIGR01519', NULL, NULL, 'plasmod_dom_1: Plasmodium falciparum uncharacterized domain', NULL, 'TIGR01519', NULL, NULL, 5614, 22),
(287351, NULL, 'TIGR03206', NULL, NULL, 'benzo_BadH: 2-hydroxycyclohexanecarboxyl-CoA dehydrogenase', NULL, 'TIGR03206', NULL, NULL, 16194, 22),
(287352, NULL, 'TIGR01021', NULL, NULL, 'rpsE_bact: ribosomal protein uS5', NULL, 'TIGR01021', NULL, NULL, 3942, 22),
(287353, NULL, 'TIGR02176', NULL, NULL, 'pyruv_ox_red: pyruvate:ferredoxin (flavodoxin) oxidoreductase', NULL, 'TIGR02176', NULL, NULL, 12361, 22),
(287354, NULL, 'TIGR04361', NULL, NULL, 'TrbK_Ti: entry exclusion protein TrbK', NULL, 'TIGR04361', NULL, NULL, 11977, 22),
(287355, NULL, 'TIGR02995', NULL, NULL, 'ectoine_ehuB: ectoine/hydroxyectoine ABC transporter solute-binding protein EhuB', NULL, 'TIGR02995', NULL, NULL, 10208, 22),
(287356, NULL, 'TIGR04040', NULL, NULL, 'glycyl_YjjI: glycine radical enzyme, YjjI family', NULL, 'TIGR04040', NULL, NULL, 17379, 22),
(287357, NULL, 'TIGR00987', NULL, NULL, 'himA: integration host factor, alpha subunit', NULL, 'TIGR00987', NULL, NULL, 3834, 22),
(287358, NULL, 'TIGR01840', NULL, NULL, 'esterase_phb: esterase, PHB depolymerase family', NULL, 'TIGR01840', NULL, NULL, 10586, 22),
(287359, NULL, 'TIGR03187', NULL, NULL, 'DGQHR: DGQHR domain', NULL, 'TIGR03187', NULL, NULL, 15993, 22),
(287360, NULL, 'TIGR04217', NULL, NULL, 'archae_ser_T: archaetidylserine synthase', NULL, 'TIGR04217', NULL, NULL, 25332, 22),
(287361, NULL, 'TIGR02353', NULL, NULL, 'NRPS_term_dom: non-ribosomal peptide synthetase terminal domain of unknown function', NULL, 'TIGR02353', NULL, NULL, 11674, 22),
(287362, NULL, 'TIGR02032', NULL, NULL, 'GG-red-SF: geranylgeranyl reductase family', NULL, 'TIGR02032', NULL, NULL, 13448, 22),
(287363, NULL, 'TIGR04538', NULL, NULL, 'P450_cycloAA_1: cytochrome P450, cyclodipeptide synthase-associated', NULL, 'TIGR04538', NULL, NULL, 25327, 22),
(287364, NULL, 'TIGR03704', NULL, NULL, 'PrmC_rel_meth: putative protein-(glutamine-N5) methyltransferase, unknown substrate-specific', NULL, 'TIGR03704', NULL, NULL, 21243, 22),
(287365, NULL, 'TIGR01429', NULL, NULL, 'AMP_deaminase: AMP deaminase', NULL, 'TIGR01429', NULL, NULL, 4562, 22),
(287366, NULL, 'TIGR03879', NULL, NULL, 'near_KaiC_dom: probable regulatory domain', NULL, 'TIGR03879', NULL, NULL, 21094, 22),
(287367, NULL, 'TIGR00806', NULL, NULL, 'rfc: reduced folate carrier', NULL, 'TIGR00806', NULL, NULL, 2897, 22),
(287368, NULL, 'TIGR04380', NULL, NULL, 'myo_inos_iolG: inositol 2-dehydrogenase', NULL, 'TIGR04380', NULL, NULL, 25278, 22),
(287369, NULL, 'TIGR01684', NULL, NULL, 'viral_ppase: viral phosphatase', NULL, 'TIGR01684', NULL, NULL, 2152, 22),
(287370, NULL, 'TIGR02170', NULL, NULL, 'thyX: thymidylate synthase, flavin-dependent', NULL, 'TIGR02170', NULL, NULL, 1196, 22),
(287371, NULL, 'TIGR03847', NULL, NULL, 'TIGR03847: conserved hypothetical protein', NULL, 'TIGR03847', NULL, NULL, 18047, 22),
(287372, NULL, 'TIGR04052', NULL, NULL, 'AZL_007920_fam: AZL_007920/MXAN_0976 family protein', NULL, 'TIGR04052', NULL, NULL, 11455, 22),
(287373, NULL, 'TIGR03742', NULL, NULL, 'PRTRC_F: PRTRC system protein F', NULL, 'TIGR03742', NULL, NULL, 15231, 22),
(287374, NULL, 'TIGR03710', NULL, NULL, 'OAFO_sf: 2-oxoacid:acceptor oxidoreductase, alpha subunit', NULL, 'TIGR03710', NULL, NULL, 17408, 22),
(287375, NULL, 'TIGR04189', NULL, NULL, 'surface_SprA: cell surface protein SprA', NULL, 'TIGR04189', NULL, NULL, 21315, 22),
(287376, NULL, 'TIGR01476', NULL, NULL, 'chlor_syn_BchG: bacteriochlorophyll/chlorophyll synthetase', NULL, 'TIGR01476', NULL, NULL, 5538, 22);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287377, NULL, 'TIGR01500', NULL, NULL, 'sepiapter_red: sepiapterin reductase', NULL, 'TIGR01500', NULL, NULL, 5652, 22),
(287378, NULL, 'TIGR02275', NULL, NULL, 'DHB_AMP_lig: (2,3-dihydroxybenzoyl)adenylate synthase', NULL, 'TIGR02275', NULL, NULL, 11086, 22),
(287379, NULL, 'TIGR00701', NULL, NULL, 'TIGR00701: TIGR00701 family protein', NULL, 'TIGR00701', NULL, NULL, 4201, 22),
(287380, NULL, 'TIGR00853', NULL, NULL, 'pts-lac: PTS system, lactose/cellobiose family IIB component', NULL, 'TIGR00853', NULL, NULL, 18687, 22),
(287381, NULL, 'TIGR01980', NULL, NULL, 'sufB: FeS assembly protein SufB', NULL, 'TIGR01980', NULL, NULL, 4035, 22),
(287382, NULL, 'TIGR02123', NULL, NULL, 'TRAP_fused: TRAP transporter, 4TM/12TM fusion protein', NULL, 'TIGR02123', NULL, NULL, 13591, 22),
(287383, NULL, 'TIGR01772', NULL, NULL, 'MDH_euk_gproteo: malate dehydrogenase, NAD-dependent', NULL, 'TIGR01772', NULL, NULL, 2499, 22),
(287384, NULL, 'TIGR04005', NULL, NULL, 'wcaL: colanic acid biosynthesis glycosyltransferase WcaL', NULL, 'TIGR04005', NULL, NULL, 10046, 22),
(287385, NULL, 'TIGR01148', NULL, NULL, 'mtrC: tetrahydromethanopterin S-methyltransferase, subunit C', NULL, 'TIGR01148', NULL, NULL, 6628, 22),
(287386, NULL, 'TIGR03598', NULL, NULL, 'GTPase_YsxC: ribosome biogenesis GTP-binding protein YsxC', NULL, 'TIGR03598', NULL, NULL, 11644, 22),
(287387, NULL, 'TIGR02571', NULL, NULL, 'ComEB: ComE operon protein 2', NULL, 'TIGR02571', NULL, NULL, 9309, 22),
(287388, NULL, 'TIGR00498', NULL, NULL, 'lexA: repressor LexA', NULL, 'TIGR00498', NULL, NULL, 11325, 22),
(287389, NULL, 'TIGR01043', NULL, NULL, 'ATP_syn_A_arch: ATP synthase archaeal, A subunit', NULL, 'TIGR01043', NULL, NULL, 4648, 22),
(287390, NULL, 'TIGR01933', NULL, NULL, 'hflK: HflK protein', NULL, 'TIGR01933', NULL, NULL, 4500, 22),
(287391, NULL, 'TIGR01491', NULL, NULL, 'HAD-SF-IB-PSPlk: phosphoserine phosphatase-like hydrolase, archaeal', NULL, 'TIGR01491', NULL, NULL, 5765, 22),
(287392, NULL, 'TIGR00153', NULL, NULL, 'TIGR00153: TIGR00153 family protein', NULL, 'TIGR00153', NULL, NULL, 3969, 22),
(287393, NULL, 'TIGR00645', NULL, NULL, 'HI0507: TIGR00645 family protein', NULL, 'TIGR00645', NULL, NULL, 20249, 22),
(287394, NULL, 'TIGR04084', NULL, NULL, 'rSAM_AF0577: putative peptide-modifying radical SAM enzyme, AF0577 family', NULL, 'TIGR04084', NULL, NULL, 8690, 22),
(287395, NULL, 'TIGR04526', NULL, NULL, 'predic_Ig_block: putative immunoglobulin-blocking virulence protein', NULL, 'TIGR04526', NULL, NULL, 25361, 22),
(287396, NULL, 'TIGR02767', NULL, NULL, 'TraG-Ti: Ti-type conjugative transfer system protein TraG', NULL, 'TIGR02767', NULL, NULL, 14145, 22),
(287397, NULL, 'TIGR02911', NULL, NULL, 'sulfite_red_B: sulfite reductase, subunit B', NULL, 'TIGR02911', NULL, NULL, 11106, 22),
(287398, NULL, 'TIGR00838', NULL, NULL, 'argH: argininosuccinate lyase', NULL, 'TIGR00838', NULL, NULL, 6393, 22),
(287399, NULL, 'TIGR04333', NULL, NULL, 'Clo7Bot_mod_Cys: Cys-rich peptide, Clo7bot family', NULL, 'TIGR04333', NULL, NULL, 26682, 22),
(287400, NULL, 'TIGR03414', NULL, NULL, 'ABC_choline_bnd: choline ABC transporter, periplasmic binding protein', NULL, 'TIGR03414', NULL, NULL, 19243, 22),
(287401, NULL, 'TIGR00317', NULL, NULL, 'cobS: cobalamin 5''-phosphate synthase', NULL, 'TIGR00317', NULL, NULL, 3183, 22),
(287402, NULL, 'TIGR01089', NULL, NULL, 'fucI: L-fucose isomerase', NULL, 'TIGR01089', NULL, NULL, 4897, 22),
(287403, NULL, 'TIGR04245', NULL, NULL, 'nodulat_NodA: N-acyltransferase NodA', NULL, 'TIGR04245', NULL, NULL, 6471, 22),
(287404, NULL, 'TIGR02764', NULL, NULL, 'spore_ybaN_pdaB: polysaccharide deacetylase family sporulation protein PdaB', NULL, 'TIGR02764', NULL, NULL, 14259, 22),
(287405, NULL, 'TIGR00212', NULL, NULL, 'hemC: hydroxymethylbilane synthase', NULL, 'TIGR00212', NULL, NULL, 3144, 22),
(287406, NULL, 'TIGR00314', NULL, NULL, 'cdhA: CO dehydrogenase/acetyl-CoA synthase complex, epsilon subunit', NULL, 'TIGR00314', NULL, NULL, 7265, 22),
(287407, NULL, 'TIGR02612', NULL, NULL, 'mob_myst_A: mobile mystery protein A', NULL, 'TIGR02612', NULL, NULL, 9490, 22);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287408, NULL, 'TIGR02717', NULL, NULL, 'AcCoA-syn-alpha: acetyl coenzyme A synthetase (ADP forming), alpha domain', NULL, 'TIGR02717', NULL, NULL, 14106, 22),
(287409, NULL, 'TIGR00794', NULL, NULL, 'kup: potassium uptake protein', NULL, 'TIGR00794', NULL, NULL, 3007, 22),
(287410, NULL, 'TIGR02749', NULL, NULL, 'prenyl_cyano: solanesyl diphosphate synthase', NULL, 'TIGR02749', NULL, NULL, NULL, 22),
(287411, NULL, 'TIGR03250', NULL, NULL, 'PhnAcAld_DH: putative phosphonoacetaldehyde dehydrogenase', NULL, 'TIGR03250', NULL, NULL, 17124, 22),
(287412, NULL, 'TIGR03355', NULL, NULL, 'VI_chp_2: type VI secretion protein, EvpB/VC_A0108 family', NULL, 'TIGR03355', NULL, NULL, 7871, 22),
(287413, NULL, 'TIGR00557', NULL, NULL, 'pdxA: 4-hydroxythreonine-4-phosphate dehydrogenase PdxA', NULL, 'TIGR00557', NULL, NULL, 11328, 22),
(287414, NULL, 'TIGR02630', NULL, NULL, 'xylose_isom_A: xylose isomerase', NULL, 'TIGR02630', NULL, NULL, 9313, 22),
(287415, NULL, 'TIGR01831', NULL, NULL, 'fabG_rel: putative 3-oxoacyl-(acyl-carrier-protein) reductase', NULL, 'TIGR01831', NULL, NULL, 10273, 22),
(287416, NULL, 'TIGR00642', NULL, NULL, 'mmCoA_mut_beta: methylmalonyl-CoA mutase, small subunit', NULL, 'TIGR00642', NULL, NULL, 527, 22),
(287417, NULL, 'TIGR00747', NULL, NULL, 'fabH: 3-oxoacyl-[acyl-carrier-protein] synthase III', NULL, 'TIGR00747', NULL, NULL, 2722, 22),
(287418, NULL, 'TIGR04529', NULL, NULL, 'MTB_hemophore: hemophore-related protein, Rv0203/Rv1174c family', NULL, 'TIGR04529', NULL, NULL, 25498, 22),
(287419, NULL, 'TIGR00885', NULL, NULL, 'fucP: L-fucose:H+ symporter permease', NULL, 'TIGR00885', NULL, NULL, 4031, 22),
(287420, NULL, 'TIGR02278', NULL, NULL, 'PaaN-DH: phenylacetic acid degradation protein paaN', NULL, 'TIGR02278', NULL, NULL, 11417, 22),
(287421, NULL, 'TIGR03903', NULL, NULL, 'TOMM_kin_cyc: TOMM system kinase/cyclase fusion protein', NULL, 'TIGR03903', NULL, NULL, 18361, 22),
(287422, NULL, 'TIGR01011', NULL, NULL, 'rpsB_bact: ribosomal protein uS2', NULL, 'TIGR01011', NULL, NULL, 3546, 22),
(287423, NULL, 'TIGR01503', NULL, NULL, 'MthylAspMut_E: methylaspartate mutase, E subunit', NULL, 'TIGR01503', NULL, NULL, 5556, 22),
(287424, NULL, 'TIGR01535', NULL, NULL, 'glucan_glucosid: glucan 1,4-alpha-glucosidase', NULL, 'TIGR01535', NULL, NULL, 6912, 22),
(287425, NULL, 'TIGR03891', NULL, NULL, 'thiopep_ocin: thiopeptide-type bacteriocin biosynthesis domain', NULL, 'TIGR03891', NULL, NULL, 12779, 22),
(287426, NULL, 'TIGR03446', NULL, NULL, 'mycothiol_Mca: mycothiol conjugate amidase Mca', NULL, 'TIGR03446', NULL, NULL, 19006, 22),
(287427, NULL, 'TIGR03059', NULL, NULL, 'psaOeuk: photosystem I protein PsaO', NULL, 'TIGR03059', NULL, NULL, 20799, 22),
(287428, NULL, 'TIGR01195', NULL, NULL, 'oadG_fam: sodium pump decarboxylases, gamma subunit', NULL, 'TIGR01195', NULL, NULL, 6583, 22),
(287429, NULL, 'TIGR00361', NULL, NULL, 'ComEC_Rec2: DNA internalization-related competence protein ComEC/Rec2', NULL, 'TIGR00361', NULL, NULL, 5357, 22),
(287430, NULL, 'TIGR04482', NULL, NULL, 'D_pro_red_PrdD: proline reductase cluster protein PrdD', NULL, 'TIGR04482', NULL, NULL, 25153, 22),
(287431, NULL, 'TIGR01280', NULL, NULL, 'xseB: exodeoxyribonuclease VII, small subunit', NULL, 'TIGR01280', NULL, NULL, 2204, 22),
(287432, NULL, 'TIGR02173', NULL, NULL, 'cyt_kin_arch: putative cytidylate kinase', NULL, 'TIGR02173', NULL, NULL, 8523, 22),
(287433, NULL, 'TIGR01444', NULL, NULL, 'fkbM_fam: methyltransferase, FkbM family', NULL, 'TIGR01444', NULL, NULL, 4939, 22),
(287434, NULL, 'TIGR03118', NULL, NULL, 'PEPCTERM_chp_1: TIGR03118 family protein', NULL, 'TIGR03118', NULL, NULL, 14525, 22),
(287435, NULL, 'TIGR00420', NULL, NULL, 'trmU: tRNA (5-methylaminomethyl-2-thiouridylate)-methyltransferase', NULL, 'TIGR00420', NULL, NULL, 1671, 22),
(287436, NULL, 'TIGR04037', NULL, NULL, 'LLM_duo_CE1759: LLM-partnered FMN reductase, CE1759 family', NULL, 'TIGR04037', NULL, NULL, 7901, 22),
(287437, NULL, 'TIGR04541', NULL, NULL, 'thiaminase_BcmE: thiamine pyridinylase', NULL, 'TIGR04541', NULL, NULL, 25473, 22);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287438, NULL, 'TIGR01968', NULL, NULL, 'minD_bact: septum site-determining protein MinD', NULL, 'TIGR01968', NULL, NULL, 4395, 22),
(287439, NULL, 'TIGR03203', NULL, NULL, 'pimD_small: pimeloyl-CoA dehydrogenase, small subunit', NULL, 'TIGR03203', NULL, NULL, 16288, 22),
(287440, NULL, 'TIGR03308', NULL, NULL, 'phn_thr-fam: phosphonate metabolim protein, transferase hexapeptide repeat family', NULL, 'TIGR03308', NULL, NULL, 17914, 22),
(287441, NULL, 'TIGR00856', NULL, NULL, 'pyrC_dimer: dihydroorotase, homodimeric type', NULL, 'TIGR00856', NULL, NULL, 3154, 22),
(287442, NULL, 'TIGR01874', NULL, NULL, 'cas_cas5a: CRISPR-associated protein Cas5, subtype I-A/APERN', NULL, 'TIGR01874', NULL, NULL, 10527, 22),
(287443, NULL, 'TIGR04435', NULL, NULL, 'restrict_AAA_1: restriction system-associated AAA family ATPase', NULL, 'TIGR04435', NULL, NULL, 25339, 22),
(287444, NULL, 'TIGR03464', NULL, NULL, 'HpnC: squalene synthase HpnC', NULL, 'TIGR03464', NULL, NULL, 19983, 22),
(287445, NULL, 'TIGR03792', NULL, NULL, 'TIGR03792: uncharacterized cyanobacterial protein, TIGR03792 family', NULL, 'TIGR03792', NULL, NULL, 16374, 22),
(287446, NULL, 'TIGR02017', NULL, NULL, 'hutG_amidohyd: N-formylglutamate deformylase', NULL, 'TIGR02017', NULL, NULL, 5425, 22),
(287447, NULL, 'TIGR00408', NULL, NULL, 'proS_fam_I: proline--tRNA ligase', NULL, 'TIGR00408', NULL, NULL, 1911, 22),
(287448, NULL, 'TIGR02873', NULL, NULL, 'spore_ylxY: probable sporulation protein, polysaccharide deacetylase family', NULL, 'TIGR02873', NULL, NULL, 10501, 22),
(287449, NULL, 'TIGR01582', NULL, NULL, 'FDH-beta: formate dehydrogenase, beta subunit', NULL, 'TIGR01582', NULL, NULL, 6196, 22),
(287450, NULL, 'TIGR03417', NULL, NULL, 'chol_sulfatase: choline-sulfatase', NULL, 'TIGR03417', NULL, NULL, 19426, 22),
(287451, NULL, 'TIGR03844', NULL, NULL, 'cysteate_syn: cysteate synthase', NULL, 'TIGR03844', NULL, NULL, 15716, 22),
(287452, NULL, 'TIGR02272', NULL, NULL, 'gentisate_1_2: gentisate 1,2-dioxygenase', NULL, 'TIGR02272', NULL, NULL, 11379, 22),
(287453, NULL, 'TIGR02064', NULL, NULL, 'dsrA: sulfite reductase, dissimilatory-type alpha subunit', NULL, 'TIGR02064', NULL, NULL, 13142, 22),
(287454, NULL, 'TIGR00287', NULL, NULL, 'cas1: CRISPR-associated endonuclease Cas1', NULL, 'TIGR00287', NULL, NULL, 3676, 22),
(287455, NULL, 'TIGR00455', NULL, NULL, 'apsK: adenylyl-sulfate kinase', NULL, 'TIGR00455', NULL, NULL, 6483, 22),
(287456, NULL, 'TIGR00448', NULL, NULL, 'rpoE: DNA-directed RNA polymerase', NULL, 'TIGR00448', NULL, NULL, 1587, 22),
(287457, NULL, 'TIGR00311', NULL, NULL, 'aIF-2beta: putative translation initiation factor aIF-2, beta subunit', NULL, 'TIGR00311', NULL, NULL, 7191, 22),
(287458, NULL, 'TIGR03191', NULL, NULL, 'benz_CoA_bzdO: benzoyl-CoA reductase, bzd-type, O subunit', NULL, 'TIGR03191', NULL, NULL, 15645, 22),
(287459, NULL, 'TIGR01086', NULL, NULL, 'fucA: L-fuculose phosphate aldolase', NULL, 'TIGR01086', NULL, NULL, 5475, 22),
(287460, NULL, 'TIGR00068', NULL, NULL, 'glyox_I: lactoylglutathione lyase', NULL, 'TIGR00068', NULL, NULL, 5140, 22),
(287461, NULL, 'TIGR01983', NULL, NULL, 'UbiG: 3-demethylubiquinone-9 3-O-methyltransferase', NULL, 'TIGR01983', NULL, NULL, 4324, 22),
(287462, NULL, 'TIGR00127', NULL, NULL, 'nadp_idh_euk: isocitrate dehydrogenase, NADP-dependent', NULL, 'TIGR00127', NULL, NULL, 5480, 22),
(287463, NULL, 'TIGR04143', NULL, NULL, 'VPxxxP_CTERM: VPXXXP-CTERM protein sorting domain', NULL, 'TIGR04143', NULL, NULL, 21359, 22),
(287464, NULL, 'TIGR00396', NULL, NULL, 'leuS_bact: leucine--tRNA ligase', NULL, 'TIGR00396', NULL, NULL, 6442, 22),
(287465, NULL, 'TIGR01046', NULL, NULL, 'uS10_euk_arch: ribosomal protein uS10', NULL, 'TIGR01046', NULL, NULL, 4763, 22),
(287466, NULL, 'TIGR03745', NULL, NULL, 'conj_TIGR03745: integrating conjugative element membrane protein, PFL_4702 family', NULL, 'TIGR03745', NULL, NULL, 18244, 22),
(287467, NULL, 'TIGR00150', NULL, NULL, 'T6A_YjeE: tRNA threonylcarbamoyl adenosine modification protein YjeE', NULL, 'TIGR00150', NULL, NULL, 5056, 22);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287468, NULL, 'TIGR02826', NULL, NULL, 'RNR_activ_nrdG3: anaerobic ribonucleoside-triphosphate reductase activating protein', NULL, 'TIGR02826', NULL, NULL, 8955, 22),
(287469, NULL, 'TIGR01426', NULL, NULL, 'MGT: glycosyltransferase, MGT family', NULL, 'TIGR01426', NULL, NULL, 4644, 22),
(287470, NULL, 'TIGR02319', NULL, NULL, 'CPEP_Pphonmut: carboxyvinyl-carboxyphosphonate phosphorylmutase', NULL, 'TIGR02319', NULL, NULL, 11820, 22),
(287471, NULL, 'TIGR03906', NULL, NULL, 'quino_hemo_SAM: quinohemoprotein amine dehydrogenase maturation protein', NULL, 'TIGR03906', NULL, NULL, 18007, 22),
(287472, NULL, 'TIGR00776', NULL, NULL, 'RhaT: RhaT L-rhamnose-proton symporter family protein', NULL, 'TIGR00776', NULL, NULL, NULL, 22),
(287473, NULL, 'TIGR03337', NULL, NULL, 'phnR: phosphonate utilization transcriptional regulator PhnR', NULL, 'TIGR03337', NULL, NULL, 18427, 22),
(287474, NULL, 'TIGR04544', NULL, NULL, '3metArgNH2trans: beta-methylarginine biosynthesis bifunctional aminotransferase', NULL, 'TIGR04544', NULL, NULL, 25063, 22),
(287475, NULL, 'TIGR03200', NULL, NULL, 'dearomat_oah: 6-oxocyclohex-1-ene-1-carbonyl-CoA hydrolase', NULL, 'TIGR03200', NULL, NULL, 16022, 22),
(287476, NULL, 'TIGR00346', NULL, NULL, 'azlC: azaleucine resistance protein AzlC', NULL, 'TIGR00346', NULL, NULL, 7202, 22),
(287477, NULL, 'TIGR01145', NULL, NULL, 'ATP_synt_delta: ATP synthase F1, delta subunit', NULL, 'TIGR01145', NULL, NULL, 3968, 22),
(287478, NULL, 'TIGR03009', NULL, NULL, 'plancto_dom_2: Planctomycetes uncharacterized domain TIGR03009', NULL, 'TIGR03009', NULL, NULL, 19255, 22),
(287479, NULL, 'TIGR01230', NULL, NULL, 'agmatinase: agmatinase', NULL, 'TIGR01230', NULL, NULL, 451, 22),
(287480, NULL, 'TIGR00018', NULL, NULL, 'panC: pantoate--beta-alanine ligase', NULL, 'TIGR00018', NULL, NULL, 2187, 22),
(287481, NULL, 'TIGR01093', NULL, NULL, 'aroD: 3-dehydroquinate dehydratase, type I', NULL, 'TIGR01093', NULL, NULL, 6658, 22),
(287482, NULL, 'TIGR00103', NULL, NULL, 'DNA_YbaB_EbfC: DNA-binding protein, YbaB/EbfC family', NULL, 'TIGR00103', NULL, NULL, 5991, 22),
(287483, NULL, 'TIGR00915', NULL, NULL, '2A0602: RND transporter, hydrophobe/amphiphile efflux-1 (HAE1) family', NULL, 'TIGR00915', NULL, NULL, 5047, 22),
(287484, NULL, 'TIGR02680', NULL, NULL, 'TIGR02680: TIGR02680 family protein', NULL, 'TIGR02680', NULL, NULL, 10429, 22),
(287485, NULL, 'TIGR03016', NULL, NULL, 'pepcterm_hypo_1: uncharacterized protein, PEP-CTERM system associated', NULL, 'TIGR03016', NULL, NULL, 20529, 22),
(287486, NULL, 'TIGR01473', NULL, NULL, 'cyoE_ctaB: protoheme IX farnesyltransferase', NULL, 'TIGR01473', NULL, NULL, 5512, 22),
(287487, NULL, 'TIGR04034', NULL, NULL, 'export_SdpA: antimicrobial peptide system protein, SdpA family', NULL, 'TIGR04034', NULL, NULL, 18301, 22),
(287488, NULL, 'TIGR00044', NULL, NULL, 'TIGR00044: pyridoxal phosphate enzyme, YggS family', NULL, 'TIGR00044', NULL, NULL, 9662, 22),
(287489, NULL, 'TIGR03953', NULL, NULL, 'rplD_bact: 50S ribosomal protein uL4', NULL, 'TIGR03953', NULL, NULL, 18869, 22),
(287490, NULL, 'TIGR03894', NULL, NULL, 'chp_P_marinus_1: conserved hypothetical protein, TIGR03894 family', NULL, 'TIGR03894', NULL, NULL, 14698, 22),
(287491, NULL, 'TIGR02447', NULL, NULL, 'yiiD_Cterm: putative thioesterase domain', NULL, 'TIGR02447', NULL, NULL, 10600, 22),
(287492, NULL, 'TIGR03499', NULL, NULL, 'FlhF: flagellar biosynthesis protein FlhF', NULL, 'TIGR03499', NULL, NULL, 16653, 22),
(287493, NULL, 'TIGR03362', NULL, NULL, 'VI_chp_7: type VI secretion-associated protein, VC_A0119 family', NULL, 'TIGR03362', NULL, NULL, 18024, 22),
(287494, NULL, 'TIGR02310', NULL, NULL, 'HpaB-2: 4-hydroxyphenylacetate 3-monooxygenase, oxygenase component', NULL, 'TIGR02310', NULL, NULL, 11544, 22),
(287495, NULL, 'TIGR04417', NULL, NULL, 'PFTS_polysacc: polysaccharide biosynthesis PFTS motif protein', NULL, 'TIGR04417', NULL, NULL, 26545, 22),
(287496, NULL, 'TIGR01824', NULL, NULL, 'PabB-clade2: aminodeoxychorismate synthase, component I', NULL, 'TIGR01824', NULL, NULL, 10910, 22);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287497, NULL, 'TIGR00252', NULL, NULL, 'TIGR00252: TIGR00252 family protein', NULL, 'TIGR00252', NULL, NULL, 6225, 22),
(287498, NULL, 'TIGR03034', NULL, NULL, 'TIGR03034: conserved hypothetical protein', NULL, 'TIGR03034', NULL, NULL, 20770, 22),
(287499, NULL, 'TIGR00389', NULL, NULL, 'glyS_dimeric: glycine--tRNA ligase', NULL, 'TIGR00389', NULL, NULL, 5577, 22),
(287500, NULL, 'TIGR00619', NULL, NULL, 'sbcd: exonuclease SbcCD, D subunit', NULL, 'TIGR00619', NULL, NULL, 517, 22),
(287501, NULL, 'TIGR01856', NULL, NULL, 'hisJ_fam: histidinol phosphate phosphatase, HisJ family', NULL, 'TIGR01856', NULL, NULL, 10994, 22),
(287502, NULL, 'TIGR02655', NULL, NULL, 'circ_KaiC: circadian clock protein KaiC', NULL, 'TIGR02655', NULL, NULL, 7433, 22),
(287503, NULL, 'TIGR00580', NULL, NULL, 'mfd: transcription-repair coupling factor', NULL, 'TIGR00580', NULL, NULL, 905, 22),
(287504, NULL, 'TIGR00685', NULL, NULL, 'T6PP: trehalose-phosphatase', NULL, 'TIGR00685', NULL, NULL, 4481, 22),
(287505, NULL, 'TIGR02829', NULL, NULL, 'spore_III_AE: stage III sporulation protein AE', NULL, 'TIGR02829', NULL, NULL, 8686, 22),
(287506, NULL, 'TIGR01096', NULL, NULL, '3A0103s03R: lysine-arginine-ornithine-binding periplasmic protein', NULL, 'TIGR01096', NULL, NULL, 4775, 22),
(287507, NULL, 'TIGR02771', NULL, NULL, 'TraF_Ti: conjugative transfer signal peptidase TraF', NULL, 'TIGR02771', NULL, NULL, 14204, 22),
(287508, NULL, 'TIGR03278', NULL, NULL, 'methan_mark_10: methanogenesis marker radical SAM protein', NULL, 'TIGR03278', NULL, NULL, 17160, 22),
(287509, NULL, 'TIGR04501', NULL, NULL, 'microcomp_PduB: microcompartment protein PduB', NULL, 'TIGR04501', NULL, NULL, 24065, 22),
(287510, NULL, 'TIGR00100', NULL, NULL, 'hypA: hydrogenase nickel insertion protein HypA', NULL, 'TIGR00100', NULL, NULL, 6785, 22),
(287511, NULL, 'TIGR01036', NULL, NULL, 'pyrD_sub2: dihydroorotate dehydrogenase (fumarate)', NULL, 'TIGR01036', NULL, NULL, 4859, 22),
(287512, NULL, 'TIGR04298', NULL, NULL, 'his_histam_anti: histidine-histamine antiporter', NULL, 'TIGR04298', NULL, NULL, 26587, 22),
(287513, NULL, 'TIGR01528', NULL, NULL, 'NMN_trans_PnuC: nicotinamide mononucleotide transporter PnuC', NULL, 'TIGR01528', NULL, NULL, 6860, 22),
(287514, NULL, 'TIGR02983', NULL, NULL, 'SigE-fam_strep: RNA polymerase sigma-70 factor, sigma-E family', NULL, 'TIGR02983', NULL, NULL, 9566, 22),
(287515, NULL, 'TIGR00091', NULL, NULL, 'TIGR00091: tRNA (guanine-N(7)-)-methyltransferase', NULL, 'TIGR00091', NULL, NULL, 4397, 22),
(287516, NULL, 'TIGR01171', NULL, NULL, 'rplB_bact: ribosomal protein uL2', NULL, 'TIGR01171', NULL, NULL, 6859, 22),
(287517, NULL, 'TIGR01940', NULL, NULL, 'nqrE: NADH:ubiquinone oxidoreductase, Na(+)-translocating, E subunit', NULL, 'TIGR01940', NULL, NULL, 2240, 22),
(287518, NULL, 'TIGR02951', NULL, NULL, 'DMSO_dmsB: dimethylsulfoxide reductase, chain B', NULL, 'TIGR02951', NULL, NULL, 9817, 22),
(287519, NULL, 'TIGR04193', NULL, NULL, 'SPASM_w_grasp: SPASM domain peptide maturase, grasp-with-spasm system', NULL, 'TIGR04193', NULL, NULL, 23408, 22),
(287520, NULL, 'TIGR02198', NULL, NULL, 'rfaE_dom_I: bifunctional protein RfaE, domain I', NULL, 'TIGR02198', NULL, NULL, 12209, 22),
(287521, NULL, 'TIGR01612', NULL, NULL, '235kDa-fam: rhoptry protein', NULL, 'TIGR01612', NULL, NULL, 6905, 22),
(287522, NULL, 'TIGR01364', NULL, NULL, 'serC_1: phosphoserine transaminase', NULL, 'TIGR01364', NULL, NULL, 15261, 22),
(287523, NULL, 'TIGR02119', NULL, NULL, 'panF: sodium/pantothenate symporter', NULL, 'TIGR02119', NULL, NULL, 13896, 22),
(287524, NULL, 'TIGR04271', NULL, NULL, 'ThiI_C_thiazole: thiazole biosynthesis domain', NULL, 'TIGR04271', NULL, NULL, 24601, 22),
(287525, NULL, 'TIGR02443', NULL, NULL, 'TIGR02443: conserved hypothetical protein', NULL, 'TIGR02443', NULL, NULL, 10244, 22),
(287526, NULL, 'TIGR03719', NULL, NULL, 'ABC_ABC_ChvD: ATP-binding cassette protein, ChvD family', NULL, 'TIGR03719', NULL, NULL, 15431, 22),
(287527, NULL, 'TIGR01105', NULL, NULL, 'galF: regulatory protein GalF', NULL, 'TIGR01105', NULL, NULL, 4700, 22);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287528, NULL, 'TIGR03804', NULL, NULL, 'para_beta_helix: parallel beta-helix repeat', NULL, 'TIGR03804', NULL, NULL, 15646, 22),
(287529, NULL, 'TIGR02232', NULL, NULL, 'myxo_disulf_rpt: Myxococcus cysteine-rich repeat', NULL, 'TIGR02232', NULL, NULL, 11439, 22),
(287530, NULL, 'TIGR02369', NULL, NULL, 'trimeth_pyl: trimethylamine:corrinoid methyltransferase', NULL, 'TIGR02369', NULL, NULL, 8874, 22),
(287531, NULL, 'TIGR03680', NULL, NULL, 'eif2g_arch: translation initiation factor 2, gamma subunit', NULL, 'TIGR03680', NULL, NULL, 15708, 22),
(287532, NULL, 'TIGR03956', NULL, NULL, 'rSAM_HydE: [FeFe] hydrogenase H-cluster radical SAM maturase HydE', NULL, 'TIGR03956', NULL, NULL, 15082, 22),
(287533, NULL, 'TIGR04077', NULL, NULL, 'expor_sig_YdyF: exported signaling peptide, YydF/SAG_2028 family', NULL, 'TIGR04077', NULL, NULL, 8191, 22),
(287534, NULL, 'TIGR00177', NULL, NULL, 'molyb_syn: molybdenum cofactor synthesis domain', NULL, 'TIGR00177', NULL, NULL, 6278, 22),
(287535, NULL, 'TIGR00965', NULL, NULL, 'dapD: 2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-succinyltransferase', NULL, 'TIGR00965', NULL, NULL, 3597, 22),
(287536, NULL, 'TIGR02200', NULL, NULL, 'GlrX_actino: glutaredoxin-like protein', NULL, 'TIGR02200', NULL, NULL, 12374, 22),
(287537, NULL, 'TIGR02986', NULL, NULL, 'restrict_Alw26I: type II restriction endonuclease, Alw26I/Eco31I/Esp3I family', NULL, 'TIGR02986', NULL, NULL, 9501, 22),
(287538, NULL, 'TIGR00262', NULL, NULL, 'trpA: tryptophan synthase, alpha subunit', NULL, 'TIGR00262', NULL, NULL, 5400, 22),
(287539, NULL, 'TIGR03785', NULL, NULL, 'marine_sort_HK: proteobacterial dedicated sortase system histidine kinase', NULL, 'TIGR03785', NULL, NULL, 16360, 22),
(287540, NULL, 'TIGR00729', NULL, NULL, 'TIGR00729: ribonuclease HII', NULL, 'TIGR00729', NULL, NULL, 2931, 22),
(287541, NULL, 'TIGR02665', NULL, NULL, 'molyb_mobA: molybdenum cofactor guanylyltransferase', NULL, 'TIGR02665', NULL, NULL, 10190, 22),
(287542, NULL, 'TIGR01746', NULL, NULL, 'Thioester-redct: thioester reductase domain', NULL, 'TIGR01746', NULL, NULL, 2457, 22),
(287543, NULL, 'TIGR02658', NULL, NULL, 'TTQ_MADH_Hv: methylamine dehydrogenase (amicyanin) heavy chain', NULL, 'TIGR02658', NULL, NULL, 10327, 22),
(287544, NULL, 'TIGR03910', NULL, NULL, 'pyrrolys_PylB: pyrrolysine biosynthesis radical SAM protein', NULL, 'TIGR03910', NULL, NULL, 8225, 22),
(287545, NULL, 'TIGR04161', NULL, NULL, 'VPEID-CTERM: VPEID-CTERM protein sorting domain', NULL, 'TIGR04161', NULL, NULL, 21283, 22),
(287546, NULL, 'TIGR02061', NULL, NULL, 'aprA: adenylylsulfate reductase, alpha subunit', NULL, 'TIGR02061', NULL, NULL, 13030, 22),
(287547, NULL, 'TIGR02553', NULL, NULL, 'SipD_IpaD_SspD: type III effector protein IpaD/SipD/SspD', NULL, 'TIGR02553', NULL, NULL, 9449, 22),
(287548, NULL, 'TIGR03066', NULL, NULL, 'Gem_osc_para_1: Gemmata obscuriglobus paralogous family TIGR03066', NULL, 'TIGR03066', NULL, NULL, NULL, 22),
(287549, NULL, 'TIGR00473', NULL, NULL, 'pssA: CDP-diacylglycerol-serine O-phosphatidyltransferase', NULL, 'TIGR00473', NULL, NULL, 1626, 22),
(287550, NULL, 'TIGR03570', NULL, NULL, 'NeuD_NnaD: sugar O-acyltransferase, sialic acid O-acetyltransferase NeuD family', NULL, 'TIGR03570', NULL, NULL, 11686, 22),
(287551, NULL, 'TIGR00040', NULL, NULL, 'yfcE: phosphodiesterase, MJ0936 family', NULL, 'TIGR00040', NULL, NULL, 3116, 22),
(287552, NULL, 'TIGR02337', NULL, NULL, 'HpaR: homoprotocatechuate degradation operon regulator, HpaR', NULL, 'TIGR02337', NULL, NULL, 11576, 22),
(287553, NULL, 'TIGR03144', NULL, NULL, 'cytochr_II_ccsB: cytochrome c-type biogenesis protein CcsB', NULL, 'TIGR03144', NULL, NULL, 15308, 22),
(287554, NULL, 'TIGR00813', NULL, NULL, 'sss: transporter, solute:sodium symporter (SSS) family', NULL, 'TIGR00813', NULL, NULL, 5065, 22),
(287555, NULL, 'TIGR00237', NULL, NULL, 'xseA: exodeoxyribonuclease VII, large subunit', NULL, 'TIGR00237', NULL, NULL, 2366, 22),
(287556, NULL, 'TIGR00682', NULL, NULL, 'lpxK: tetraacyldisaccharide 4''-kinase', NULL, 'TIGR00682', NULL, NULL, 2245, 22);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287557, NULL, 'TIGR03829', NULL, NULL, 'YokU_near_AblA: uncharacterized protein, YokU family', NULL, 'TIGR03829', NULL, NULL, 14995, 22),
(287558, NULL, 'TIGR03069', NULL, NULL, 'PS_II_S4: photosystem II S4 domain protein', NULL, 'TIGR03069', NULL, NULL, 21207, 22),
(287559, NULL, 'TIGR01859', NULL, NULL, 'fruc_bis_ald_: fructose-1,6-bisphosphate aldolase, class II', NULL, 'TIGR01859', NULL, NULL, 10015, 22),
(287560, NULL, 'TIGR00704', NULL, NULL, 'NaPi_cotrn_rel: Na/Pi-cotransporter II-related protein', NULL, 'TIGR00704', NULL, NULL, 2361, 22),
(287561, NULL, 'TIGR02225', NULL, NULL, 'recomb_XerD: tyrosine recombinase XerD', NULL, 'TIGR02225', NULL, NULL, 11374, 22),
(287562, NULL, 'TIGR02341', NULL, NULL, 'chap_CCT_beta: T-complex protein 1, beta subunit', NULL, 'TIGR02341', NULL, NULL, 11813, 22),
(287563, NULL, 'TIGR01207', NULL, NULL, 'rmlA: glucose-1-phosphate thymidylyltransferase', NULL, 'TIGR01207', NULL, NULL, 232, 22),
(287564, NULL, 'TIGR01273', NULL, NULL, 'speA: arginine decarboxylase', NULL, 'TIGR01273', NULL, NULL, 7168, 22),
(287565, NULL, 'TIGR03140', NULL, NULL, 'AhpF: alkyl hydroperoxide reductase subunit F', NULL, 'TIGR03140', NULL, NULL, 12549, 22),
(287566, NULL, 'TIGR02549', NULL, NULL, 'CRISPR_DxTHG: CRISPR-associated DxTHG motif protein', NULL, 'TIGR02549', NULL, NULL, 11432, 22),
(287567, NULL, 'TIGR04295', NULL, NULL, 'B12_rSAM_oligo: B12-binding domain/radical SAM domain protein, rhizo-twelve system', NULL, 'TIGR04295', NULL, NULL, 26573, 22),
(287568, NULL, 'TIGR04519', NULL, NULL, 'MoCo_extend_TAT: MoCo/4Fe-4S cofactor protein extended Tat translocation domain', NULL, 'TIGR04519', NULL, NULL, 25088, 22),
(287569, NULL, 'TIGR00043', NULL, NULL, 'TIGR00043: rRNA maturation RNase YbeY', NULL, 'TIGR00043', NULL, NULL, 2117, 22),
(287570, NULL, 'TIGR01821', NULL, NULL, '5aminolev_synth: 5-aminolevulinic acid synthase', NULL, 'TIGR01821', NULL, NULL, 2086, 22),
(287571, NULL, 'TIGR00912', NULL, NULL, '2A0309: spore germination protein (amino acid permease)', NULL, 'TIGR00912', NULL, NULL, 5080, 22),
(287572, NULL, 'TIGR02740', NULL, NULL, 'TraF-like: TraF-like protein', NULL, 'TIGR02740', NULL, NULL, 13696, 22),
(287573, NULL, 'TIGR04087', NULL, NULL, 'YqxM_for_SipW: YqxM protein', NULL, 'TIGR04087', NULL, NULL, 16906, 22),
(287574, NULL, 'TIGR00583', NULL, NULL, 'mre11: DNA repair protein (mre11)', NULL, 'TIGR00583', NULL, NULL, 2444, 22),
(287575, NULL, 'TIGR03031', NULL, NULL, 'cas_csx12: CRISPR system subtype II-B RNA-guided endonuclease Cas9/Csx12', NULL, 'TIGR03031', NULL, NULL, 10274, 22),
(287576, NULL, 'TIGR03676', NULL, NULL, 'aRF1/eRF1: peptide chain release factor 1, archaeal and eukaryotic forms', NULL, 'TIGR03676', NULL, NULL, 5970, 22),
(287577, NULL, 'TIGR03683', NULL, NULL, 'A-tRNA_syn_arch: alanine--tRNA ligase', NULL, 'TIGR03683', NULL, NULL, 15709, 22),
(287578, NULL, 'TIGR01613', NULL, NULL, 'primase_Cterm: phage/plasmid primase, P4 family, C-terminal domain', NULL, 'TIGR01613', NULL, NULL, 6942, 22),
(287579, NULL, 'TIGR02126', NULL, NULL, 'phgtail_TP901_1: phage major tail protein, TP901-1 family', NULL, 'TIGR02126', NULL, NULL, 13562, 22),
(287580, NULL, 'TIGR02521', NULL, NULL, 'type_IV_pilW: type IV pilus biogenesis/stability protein PilW', NULL, 'TIGR02521', NULL, NULL, 18582, 22),
(287581, NULL, 'TIGR03938', NULL, NULL, 'deacetyl_PgaB: poly-beta-1,6-N-acetyl-D-glucosamine N-deacetylase PgaB', NULL, 'TIGR03938', NULL, NULL, 11600, 22),
(287582, NULL, 'TIGR01170', NULL, NULL, 'rplA_mito: ribosomal protein uL1, mitochondrial', NULL, 'TIGR01170', NULL, NULL, 6802, 22),
(287583, NULL, 'TIGR03617', NULL, NULL, 'F420_MSMEG_2256: probable F420-dependent oxidoreductase, MSMEG_2256 family', NULL, 'TIGR03617', NULL, NULL, 14877, 22),
(287584, NULL, 'TIGR01108', NULL, NULL, 'oadA: oxaloacetate decarboxylase alpha subunit', NULL, 'TIGR01108', NULL, NULL, 4986, 22),
(287585, NULL, 'TIGR00916', NULL, NULL, '2A0604s01: protein-export membrane protein, SecD/SecF family', NULL, 'TIGR00916', NULL, NULL, 16871, 22),
(287586, NULL, 'TIGR00255', NULL, NULL, 'TIGR00255: TIGR00255 family protein', NULL, 'TIGR00255', NULL, NULL, 11216, 22);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287587, NULL, 'TIGR03496', NULL, NULL, 'FliI_clade1: flagellar protein export ATPase FliI', NULL, 'TIGR03496', NULL, NULL, 16907, 22),
(287588, NULL, 'TIGR04196', NULL, NULL, 'glycopep_SunS: glycopeptide, sublancin family', NULL, 'TIGR04196', NULL, NULL, 25002, 22),
(287589, NULL, 'TIGR00517', NULL, NULL, 'acyl_carrier: acyl carrier protein', NULL, 'TIGR00517', NULL, NULL, 2555, 22),
(287590, NULL, 'TIGR01930', NULL, NULL, 'AcCoA-C-Actrans: acetyl-CoA C-acyltransferase', NULL, 'TIGR01930', NULL, NULL, 217, 22),
(287591, NULL, 'TIGR03277', NULL, NULL, 'methan_mark_9: putative methanogenesis marker domain 9', NULL, 'TIGR03277', NULL, NULL, 17136, 22),
(287592, NULL, 'TIGR04307', NULL, NULL, 'ProTailRpt: proline-rich tail region repeat', NULL, 'TIGR04307', NULL, NULL, 22388, 22),
(287593, NULL, 'TIGR04186', NULL, NULL, 'GRASP_targ: putative ATP-grasp target RiPP', NULL, 'TIGR04186', NULL, NULL, 23317, 22),
(287594, NULL, 'TIGR03352', NULL, NULL, 'VI_chp_3: type VI secretion lipoprotein, VC_A0113 family', NULL, 'TIGR03352', NULL, NULL, 18316, 22),
(287595, NULL, 'TIGR01382', NULL, NULL, 'PfpI: intracellular protease, PfpI family', NULL, 'TIGR01382', NULL, NULL, 3765, 22),
(287596, NULL, 'TIGR00364', NULL, NULL, 'TIGR00364: queuosine biosynthesis protein QueC', NULL, 'TIGR00364', NULL, NULL, 16631, 22),
(287597, NULL, 'TIGR03782', NULL, NULL, 'Bac_Flav_CT_J: Bacteroides conjugative transposon TraJ protein', NULL, 'TIGR03782', NULL, NULL, 15683, 22),
(287598, NULL, 'TIGR02662', NULL, NULL, 'dinitro_DRAG: ADP-ribosyl-[dinitrogen reductase] hydrolase', NULL, 'TIGR02662', NULL, NULL, 10079, 22),
(287599, NULL, 'TIGR00399', NULL, NULL, 'metG_C_term: methionine--tRNA ligase, beta subunit', NULL, 'TIGR00399', NULL, NULL, 1185, 22),
(287600, NULL, 'TIGR01316', NULL, NULL, 'gltA: glutamate synthase (NADPH), homotetrameric', NULL, 'TIGR01316', NULL, NULL, 1306, 22),
(287601, NULL, 'TIGR01644', NULL, NULL, 'phage_P2_V: phage baseplate assembly protein V', NULL, 'TIGR01644', NULL, NULL, 8215, 22),
(287602, NULL, 'TIGR04373', NULL, NULL, 'egtB_X_signatur: EgtB-related enzyme signature domain', NULL, 'TIGR04373', NULL, NULL, 21655, 22),
(287603, NULL, 'TIGR02799', NULL, NULL, 'thio_ybgC: tol-pal system-associated acyl-CoA thioesterase', NULL, 'TIGR02799', NULL, NULL, 8828, 22),
(287604, NULL, 'TIGR04205', NULL, NULL, 'classIII_w_PIP: class III signal peptide protein, archaeosortase D/PIP-CTERM system', NULL, 'TIGR04205', NULL, NULL, 23482, 22),
(287605, NULL, 'TIGR03801', NULL, NULL, 'asp_4_decarbox: aspartate 4-decarboxylase', NULL, 'TIGR03801', NULL, NULL, 16011, 22),
(287606, NULL, 'TIGR00128', NULL, NULL, 'fabD: malonyl CoA-acyl carrier protein transacylase', NULL, 'TIGR00128', NULL, NULL, 5950, 22),
(287607, NULL, 'TIGR01715', NULL, NULL, 'phage_lam_T: phage tail assembly protein T', NULL, 'TIGR01715', NULL, NULL, 14288, 22),
(287608, NULL, 'TIGR01538', NULL, NULL, 'portal_SPP1: phage portal protein, SPP1 family', NULL, 'TIGR01538', NULL, NULL, 6746, 22),
(287609, NULL, 'TIGR00470', NULL, NULL, 'sepS: O-phosphoserine--tRNA ligase', NULL, 'TIGR00470', NULL, NULL, 11061, 22),
(287610, NULL, 'TIGR02334', NULL, NULL, 'prpF: probable AcnD-accessory protein PrpF', NULL, 'TIGR02334', NULL, NULL, 11900, 22),
(287611, NULL, 'TIGR03489', NULL, NULL, 'cas_csp1: CRISPR-associated protein Cas7/Csp1, subtype PGING', NULL, 'TIGR03489', NULL, NULL, 17615, 22),
(287612, NULL, 'TIGR03574', NULL, NULL, 'selen_PSTK: L-seryl-tRNA(Sec) kinase', NULL, 'TIGR03574', NULL, NULL, 17865, 22),
(287613, NULL, 'TIGR00791', NULL, NULL, 'gntP: transporter, gluconate:H+ symporter (GntP) family', NULL, 'TIGR00791', NULL, NULL, 6292, 22),
(287614, NULL, 'TIGR03253', NULL, NULL, 'oxalate_frc: formyl-CoA transferase', NULL, 'TIGR03253', NULL, NULL, 17317, 22),
(287615, NULL, 'TIGR00947', NULL, NULL, '2A73: putative bicarbonate transporter, IctB family', NULL, 'TIGR00947', NULL, NULL, 1241, 22),
(287616, NULL, 'TIGR00810', NULL, NULL, 'secG: preprotein translocase, SecG subunit', NULL, 'TIGR00810', NULL, NULL, 3030, 22),
(287617, NULL, 'TIGR02228', NULL, NULL, 'sigpep_I_arch: signal peptidase I', NULL, 'TIGR02228', NULL, NULL, 3357, 22);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287618, NULL, 'TIGR03168', NULL, NULL, '1-PFK: hexose kinase, 1-phosphofructokinase family', NULL, 'TIGR03168', NULL, NULL, 15890, 22),
(287619, NULL, 'TIGR01958', NULL, NULL, 'nuoE_fam: NADH-quinone oxidoreductase, E subunit', NULL, 'TIGR01958', NULL, NULL, 4560, 22),
(287620, NULL, 'TIGR03246', NULL, NULL, 'arg_catab_astC: succinylornithine transaminase family', NULL, 'TIGR03246', NULL, NULL, 17293, 22),
(287621, NULL, 'TIGR03461', NULL, NULL, 'pabC_Proteo: aminodeoxychorismate lyase', NULL, 'TIGR03461', NULL, NULL, 19439, 22),
(287622, NULL, 'TIGR01198', NULL, NULL, 'pgl: 6-phosphogluconolactonase', NULL, 'TIGR01198', NULL, NULL, 6691, 22),
(287623, NULL, 'TIGR02013', NULL, NULL, 'rpoB: DNA-directed RNA polymerase, beta subunit', NULL, 'TIGR02013', NULL, NULL, 5393, 22),
(287624, NULL, 'TIGR00803', NULL, NULL, 'nst: UDP-galactose transporter', NULL, 'TIGR00803', NULL, NULL, NULL, 22),
(287625, NULL, 'TIGR03508', NULL, NULL, 'decahem_SO: decaheme c-type cytochrome, DmsE family', NULL, 'TIGR03508', NULL, NULL, 17176, 22),
(287626, NULL, 'TIGR01061', NULL, NULL, 'parC_Gpos: DNA topoisomerase IV, A subunit', NULL, 'TIGR01061', NULL, NULL, 4690, 22),
(287627, NULL, 'TIGR01965', NULL, NULL, 'VCBS_repeat: VCBS repeat', NULL, 'TIGR01965', NULL, NULL, 4005, 22),
(287628, NULL, 'TIGR02478', NULL, NULL, '6PF1K_euk: 6-phosphofructokinase', NULL, 'TIGR02478', NULL, NULL, 9778, 22),
(287629, NULL, 'TIGR01401', NULL, NULL, 'fliR_like_III: type III secretion apparatus protein SpaR/YscT/HrcT', NULL, 'TIGR01401', NULL, NULL, 4959, 22),
(287630, NULL, 'TIGR02556', NULL, NULL, 'cas_TM1802: CRISPR-associated protein, TM1802 family', NULL, 'TIGR02556', NULL, NULL, 11185, 22),
(287631, NULL, 'TIGR02412', NULL, NULL, 'pepN_strep_liv: aminopeptidase N', NULL, 'TIGR02412', NULL, NULL, 9991, 22),
(287632, NULL, 'TIGR01637', NULL, NULL, 'phage_arpU: phage transcriptional regulator, ArpU family', NULL, 'TIGR01637', NULL, NULL, 161, 22),
(287633, NULL, 'TIGR02235', NULL, NULL, 'menA_cyano-plnt: 1,4-dihydroxy-2-naphthoate phytyltransferase', NULL, 'TIGR02235', NULL, NULL, 11353, 22),
(287634, NULL, 'TIGR01722', NULL, NULL, 'MMSDH: methylmalonate-semialdehyde dehydrogenase (acylating)', NULL, 'TIGR01722', NULL, NULL, 6151, 22),
(287635, NULL, 'TIGR02877', NULL, NULL, 'spore_yhbH: sporulation protein YhbH', NULL, 'TIGR02877', NULL, NULL, 10860, 22),
(287636, NULL, 'TIGR00692', NULL, NULL, 'tdh: L-threonine 3-dehydrogenase', NULL, 'TIGR00692', NULL, NULL, 2480, 22),
(287637, NULL, 'TIGR01721', NULL, NULL, 'AMN-like: putative AMP nucleosidase', NULL, 'TIGR01721', NULL, NULL, 1777, 22),
(287638, NULL, 'TIGR02827', NULL, NULL, 'RNR_anaer_Bdell: anaerobic ribonucleoside-triphosphate reductase', NULL, 'TIGR02827', NULL, NULL, 12910, 22),
(287639, NULL, 'TIGR01858', NULL, NULL, 'tag_bisphos_ald: class II aldolase, tagatose bisphosphate family', NULL, 'TIGR01858', NULL, NULL, 10121, 22),
(287640, NULL, 'TIGR01270', NULL, NULL, 'Trp_5_monoox: tryptophan 5-monooxygenase', NULL, 'TIGR01270', NULL, NULL, 237, 22),
(287641, NULL, 'TIGR02979', NULL, NULL, 'phageshock_pspD: phage shock protein PspD', NULL, 'TIGR02979', NULL, NULL, 9790, 22),
(287642, NULL, 'TIGR04419', NULL, NULL, 'no_iron_rSAM: HemN-related non-iron pseudo-SAM protein PsgB', NULL, 'TIGR04419', NULL, NULL, 26584, 22),
(287643, NULL, 'TIGR02391', NULL, NULL, 'hypoth_ymh: TIGR02391 family protein', NULL, 'TIGR02391', NULL, NULL, 10471, 22),
(287644, NULL, 'TIGR02842', NULL, NULL, 'CyoC: cytochrome o ubiquinol oxidase, subunit III', NULL, 'TIGR02842', NULL, NULL, 9425, 22),
(287645, NULL, 'TIGR00424', NULL, NULL, 'APS_reduc: 5''-adenylylsulfate reductase, thioredoxin-independent', NULL, 'TIGR00424', NULL, NULL, 1754, 22),
(287646, NULL, 'TIGR02048', NULL, NULL, 'gshA_cyano: putative glutamate--cysteine ligase', NULL, 'TIGR02048', NULL, NULL, 13171, 22),
(287647, NULL, 'TIGR03032', NULL, NULL, 'TIGR03032: TIGR03032 family protein', NULL, 'TIGR03032', NULL, NULL, 20531, 22),
(287648, NULL, 'TIGR01551', NULL, NULL, 'major_capsid_P2: phage major capsid protein, P2 family', NULL, 'TIGR01551', NULL, NULL, 6753, 22);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287649, NULL, 'TIGR02344', NULL, NULL, 'chap_CCT_gamma: T-complex protein 1, gamma subunit', NULL, 'TIGR02344', NULL, NULL, 11914, 22),
(287650, NULL, 'TIGR04249', NULL, NULL, 'SCM_chp_ScmC: SynChlorMet cassette protein ScmC', NULL, 'TIGR04249', NULL, NULL, 24618, 22),
(287651, NULL, 'TIGR00471', NULL, NULL, 'pheT_arch: phenylalanine--tRNA ligase, beta subunit', NULL, 'TIGR00471', NULL, NULL, 1738, 22),
(287652, NULL, 'TIGR00922', NULL, NULL, 'nusG: transcription termination/antitermination factor NusG', NULL, 'TIGR00922', NULL, NULL, 1357, 22),
(287653, NULL, 'TIGR03143', NULL, NULL, 'AhpF_homolog: putative alkyl hydroperoxide reductase F subunit', NULL, 'TIGR03143', NULL, NULL, 15094, 22),
(287654, NULL, 'TIGR00084', NULL, NULL, 'ruvA: Holliday junction DNA helicase RuvA', NULL, 'TIGR00084', NULL, NULL, 2934, 22),
(287655, NULL, 'TIGR02063', NULL, NULL, 'RNase_R: ribonuclease R', NULL, 'TIGR02063', NULL, NULL, 13106, 22),
(287656, NULL, 'TIGR02505', NULL, NULL, 'RTPR: ribonucleoside-triphosphate reductase, adenosylcobalamin-dependent', NULL, 'TIGR02505', NULL, NULL, 18802, 22),
(287657, NULL, 'TIGR01217', NULL, NULL, 'ac_ac_CoA_syn: acetoacetate-CoA ligase', NULL, 'TIGR01217', NULL, NULL, 230, 22),
(287658, NULL, 'TIGR03175', NULL, NULL, 'AllD: ureidoglycolate dehydrogenase', NULL, 'TIGR03175', NULL, NULL, 15692, 22),
(287659, NULL, 'TIGR00069', NULL, NULL, 'hisD: histidinol dehydrogenase', NULL, 'TIGR00069', NULL, NULL, 13893, 22),
(287660, NULL, 'TIGR03667', NULL, NULL, 'Rv3369: PPOX class probable F420-dependent enzyme, Rv3369 family', NULL, 'TIGR03667', NULL, NULL, 15559, 22),
(287661, NULL, 'TIGR00239', NULL, NULL, '2oxo_dh_E1: oxoglutarate dehydrogenase (succinyl-transferring), E1 component', NULL, 'TIGR00239', NULL, NULL, 11158, 22),
(287662, NULL, 'TIGR01223', NULL, NULL, 'Pmev_kin_anim: phosphomevalonate kinase', NULL, 'TIGR01223', NULL, NULL, 395, 22),
(287663, NULL, 'TIGR03339', NULL, NULL, 'phn_lysR: aminoethylphosphonate catabolism associated LysR family transcriptional regulator', NULL, 'TIGR03339', NULL, NULL, 18153, 22),
(287664, NULL, 'TIGR01688', NULL, NULL, 'dltC: D-alanine--poly(phosphoribitol) ligase, subunit 2', NULL, 'TIGR01688', NULL, NULL, 2501, 22),
(287665, NULL, 'TIGR00913', NULL, NULL, '2A0310: amino acid permease (yeast)', NULL, 'TIGR00913', NULL, NULL, 5341, 22),
(287666, NULL, 'TIGR03673', NULL, NULL, 'uL14_arch: 50S ribosomal protein uL14', NULL, 'TIGR03673', NULL, NULL, 15808, 22),
(287667, NULL, 'TIGR03169', NULL, NULL, 'Nterm_to_SelD: pyridine nucleotide-disulfide oxidoreductase family protein', NULL, 'TIGR03169', NULL, NULL, 15886, 22),
(287668, NULL, 'TIGR02335', NULL, NULL, 'hydr_PhnA: phosphonoacetate hydrolase', NULL, 'TIGR02335', NULL, NULL, 11520, 22),
(287669, NULL, 'TIGR01214', NULL, NULL, 'rmlD: dTDP-4-dehydrorhamnose reductase', NULL, 'TIGR01214', NULL, NULL, 75, 22),
(287670, NULL, 'TIGR01366', NULL, NULL, 'serC_3: putative phosphoserine aminotransferase', NULL, 'TIGR01366', NULL, NULL, 3873, 22),
(287671, NULL, 'TIGR01712', NULL, NULL, 'phage_N6A_met: phage N-6-adenine-methyltransferase', NULL, 'TIGR01712', NULL, NULL, 14205, 22),
(287672, NULL, 'TIGR02350', NULL, NULL, 'prok_dnaK: chaperone protein DnaK', NULL, 'TIGR02350', NULL, NULL, 11662, 22),
(287673, NULL, 'TIGR01849', NULL, NULL, 'PHB_depoly_PhaZ: polyhydroxyalkanoate depolymerase, intracellular', NULL, 'TIGR01849', NULL, NULL, 8672, 22),
(287674, NULL, 'TIGR01694', NULL, NULL, 'MTAP: methylthioadenosine phosphorylase', NULL, 'TIGR01694', NULL, NULL, 5106, 22),
(287675, NULL, 'TIGR02487', NULL, NULL, 'NrdD: anaerobic ribonucleoside-triphosphate reductase', NULL, 'TIGR02487', NULL, NULL, 12910, 22),
(287676, NULL, 'TIGR02833', NULL, NULL, 'spore_III_AB: stage III sporulation protein AB', NULL, 'TIGR02833', NULL, NULL, 8799, 22),
(287677, NULL, 'TIGR01419', NULL, NULL, 'nitro_reg_IIA: PTS IIA-like nitrogen-regulatory protein PtsN', NULL, 'TIGR01419', NULL, NULL, 4548, 22),
(287678, NULL, 'TIGR03471', NULL, NULL, 'HpnJ: hopanoid biosynthesis associated radical SAM protein HpnJ', NULL, 'TIGR03471', NULL, NULL, 19521, 22); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287679, NULL, 'TIGR03202', NULL, NULL, 'pucB: xanthine dehydrogenase accessory protein pucB', NULL, 'TIGR03202', NULL, NULL, 16176, 22),
(287680, NULL, 'TIGR01319', NULL, NULL, 'glmL_fam: conserved hypothetical protein', NULL, 'TIGR01319', NULL, NULL, 11071, 22),
(287681, NULL, 'TIGR02403', NULL, NULL, 'trehalose_treC: alpha,alpha-phosphotrehalase', NULL, 'TIGR02403', NULL, NULL, 9558, 22),
(287682, NULL, 'TIGR01196', NULL, NULL, 'edd: phosphogluconate dehydratase', NULL, 'TIGR01196', NULL, NULL, 5012, 22),
(287683, NULL, 'TIGR04370', NULL, NULL, 'glyco_rpt_poly: oligosaccharide repeat unit polymerase', NULL, 'TIGR04370', NULL, NULL, NULL, 22),
(287684, NULL, 'TIGR03682', NULL, NULL, 'arCOG04112: diphthamide biosynthesis enzyme Dph2', NULL, 'TIGR03682', NULL, NULL, 15883, 22),
(287685, NULL, 'TIGR03178', NULL, NULL, 'allantoinase: allantoinase', NULL, 'TIGR03178', NULL, NULL, 15512, 22),
(287686, NULL, 'TIGR01510', NULL, NULL, 'coaD_prev_kdtB: pantetheine-phosphate adenylyltransferase', NULL, 'TIGR01510', NULL, NULL, 4360, 22),
(287687, NULL, 'TIGR00963', NULL, NULL, 'secA: preprotein translocase, SecA subunit', NULL, 'TIGR00963', NULL, NULL, 1607, 22),
(287688, NULL, 'TIGR02546', NULL, NULL, 'III_secr_ATP: type III secretion apparatus H+-transporting two-sector ATPase', NULL, 'TIGR02546', NULL, NULL, 11280, 22),
(287689, NULL, 'TIGR03184', NULL, NULL, 'DNA_S_dndE: DNA sulfur modification protein DndE', NULL, 'TIGR03184', NULL, NULL, 14028, 22),
(287690, NULL, 'TIGR01149', NULL, NULL, 'mtrG: tetrahydromethanopterin S-methyltransferase, subunit G', NULL, 'TIGR01149', NULL, NULL, 6881, 22),
(287691, NULL, 'TIGR00152', NULL, NULL, 'TIGR00152: dephospho-CoA kinase', NULL, 'TIGR00152', NULL, NULL, 4095, 22),
(287692, NULL, 'TIGR03530', NULL, NULL, 'GldJ_short: gliding motility-associated lipoprotein GldJ', NULL, 'TIGR03530', NULL, NULL, 16777, 22),
(287693, NULL, 'TIGR01012', NULL, NULL, 'uS2_euk_arch: ribosomal protein uS2', NULL, 'TIGR01012', NULL, NULL, 3620, 22),
(287694, NULL, 'TIGR02874', NULL, NULL, 'spore_ytfJ: sporulation protein YtfJ', NULL, 'TIGR02874', NULL, NULL, 10841, 22),
(287695, NULL, 'TIGR01208', NULL, NULL, 'rmlA_long: glucose-1-phosphate thymidylyltransferase', NULL, 'TIGR01208', NULL, NULL, 121, 22),
(287696, NULL, 'TIGR03190', NULL, NULL, 'benz_CoA_bzdN: benzoyl-CoA reductase, bzd-type, N subunit', NULL, 'TIGR03190', NULL, NULL, 15898, 22),
(287697, NULL, 'TIGR02016', NULL, NULL, 'BchX: chlorophyllide reductase iron protein subunit X', NULL, 'TIGR02016', NULL, NULL, 5157, 22),
(287698, NULL, 'TIGR03524', NULL, NULL, 'GldJ: gliding motility-associated lipoprotein GldJ', NULL, 'TIGR03524', NULL, NULL, 16602, 22),
(287699, NULL, 'TIGR01706', NULL, NULL, 'NAPA: periplasmic nitrate reductase, large subunit', NULL, 'TIGR01706', NULL, NULL, 5064, 22),
(287700, NULL, 'TIGR01647', NULL, NULL, 'ATPase-IIIA_H: plasma-membrane proton-efflux P-type ATPase', NULL, 'TIGR01647', NULL, NULL, 269, 22),
(287701, NULL, 'TIGR02985', NULL, NULL, 'Sig70_bacteroi1: RNA polymerase sigma-70 factor, Bacteroides expansion family 1', NULL, 'TIGR02985', NULL, NULL, 9520, 22),
(287702, NULL, 'TIGR04364', NULL, NULL, 'methyltran_FxLD: methyltransferase, FxLD system', NULL, 'TIGR04364', NULL, NULL, 23112, 22),
(287703, NULL, 'TIGR03878', NULL, NULL, 'thermo_KaiC_2: KaiC domain protein, AF_0795 family', NULL, 'TIGR03878', NULL, NULL, 15542, 22),
(287704, NULL, 'TIGR03741', NULL, NULL, 'PRTRC_E: PRTRC system protein E', NULL, 'TIGR03741', NULL, NULL, 15156, 22),
(287705, NULL, 'TIGR02774', NULL, NULL, 'rexB_recomb: ATP-dependent nuclease subunit B', NULL, 'TIGR02774', NULL, NULL, 14394, 22),
(287706, NULL, 'TIGR01428', NULL, NULL, 'HAD_type_II: haloacid dehalogenase, type II', NULL, 'TIGR01428', NULL, NULL, 4526, 22),
(287707, NULL, 'TIGR01808', NULL, NULL, 'CM_M_hiGC-arch: chorismate mutase', NULL, 'TIGR01808', NULL, NULL, 2388, 22),
(287708, NULL, 'TIGR02446', NULL, NULL, 'FadI: acetyl-CoA C-acyltransferase FadI', NULL, 'TIGR02446', NULL, NULL, 12892, 22),
(287709, NULL, 'TIGR03913', NULL, NULL, 'rad_SAM_trio: Y_X(10)_GDL-associated radical SAM protein', NULL, 'TIGR03913', NULL, NULL, 8811, 22);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287710, NULL, 'TIGR00028', NULL, NULL, 'Mtu_PIN_fam: toxin-antitoxin system PIN domain toxin', NULL, 'TIGR00028', NULL, NULL, 11357, 22),
(287711, NULL, 'TIGR04036', NULL, NULL, 'LLM_CE1758_fam: putative luciferase-like monooxygenase, FMN-dependent, CE1758 family', NULL, 'TIGR04036', NULL, NULL, 7503, 22),
(287712, NULL, 'TIGR00289', NULL, NULL, 'TIGR00289: TIGR00289 family protein', NULL, 'TIGR00289', NULL, NULL, 11077, 22),
(287713, NULL, 'TIGR02444', NULL, NULL, 'TIGR02444: TIGR02444 family protein', NULL, 'TIGR02444', NULL, NULL, 10956, 22),
(287714, NULL, 'TIGR03599', NULL, NULL, 'YloV: DAK2 domain fusion protein YloV', NULL, 'TIGR03599', NULL, NULL, 11685, 22),
(287715, NULL, 'TIGR03243', NULL, NULL, 'arg_catab_AOST: arginine and ornithine succinyltransferase subunits', NULL, 'TIGR03243', NULL, NULL, 6868, 22),
(287716, NULL, 'TIGR01638', NULL, NULL, 'Atha_cystat_rel: Arabidopsis thaliana cystatin-related protein', NULL, 'TIGR01638', NULL, NULL, 254, 22),
(287717, NULL, 'TIGR01756', NULL, NULL, 'LDH_protist: lactate dehydrogenase', NULL, 'TIGR01756', NULL, NULL, 9718, 22),
(287718, NULL, 'TIGR03415', NULL, NULL, 'ABC_choXWV_ATP: choline ABC transporter, ATP-binding protein', NULL, 'TIGR03415', NULL, NULL, 15762, 22),
(287719, NULL, 'TIGR04398', NULL, NULL, 'SLAP_DUP: SLAP domain', NULL, 'TIGR04398', NULL, NULL, 21181, 22),
(287720, NULL, 'TIGR02493', NULL, NULL, 'PFLA: pyruvate formate-lyase 1-activating enzyme', NULL, 'TIGR02493', NULL, NULL, 12759, 22),
(287721, NULL, 'TIGR00075', NULL, NULL, 'hypD: hydrogenase expression/formation protein HypD', NULL, 'TIGR00075', NULL, NULL, 4570, 22),
(287722, NULL, 'TIGR00526', NULL, NULL, 'folB_dom: FolB domain', NULL, 'TIGR00526', NULL, NULL, 10460, 22),
(287723, NULL, 'TIGR00629', NULL, NULL, 'uvde: UV damage endonuclease UvdE', NULL, 'TIGR00629', NULL, NULL, 532, 22),
(287724, NULL, 'TIGR02555', NULL, NULL, 'OrgA_MxiK: type III secretion apparatus protein OrgA/MxiK', NULL, 'TIGR02555', NULL, NULL, 11457, 22),
(287725, NULL, 'TIGR01121', NULL, NULL, 'D_amino_aminoT: D-amino-acid transaminase', NULL, 'TIGR01121', NULL, NULL, 5728, 22),
(287726, NULL, 'TIGR03571', NULL, NULL, 'lucif_BA3436: luciferase-type oxidoreductase, BA3436 family', NULL, 'TIGR03571', NULL, NULL, 11856, 22),
(287727, NULL, 'TIGR02116', NULL, NULL, 'toxin_Txe_YoeB: addiction module toxin, Txe/YoeB family', NULL, 'TIGR02116', NULL, NULL, 1696, 22),
(287728, NULL, 'TIGR00193', NULL, NULL, 'urease_gam: urease, gamma subunit', NULL, 'TIGR00193', NULL, NULL, 5051, 22),
(287729, NULL, 'TIGR00854', NULL, NULL, 'pts-sorbose: PTS system, mannose/fructose/sorbose family, IIB component', NULL, 'TIGR00854', NULL, NULL, 17071, 22),
(287730, NULL, 'TIGR04317', NULL, NULL, 'W_rSAM_matur: tungsten cofactor oxidoreducase radical SAM maturase', NULL, 'TIGR04317', NULL, NULL, 23304, 22),
(287731, NULL, 'TIGR02276', NULL, NULL, 'beta_rpt_yvtn: 40-residue YVTN family beta-propeller repeat', NULL, 'TIGR02276', NULL, NULL, 11245, 22),
(287732, NULL, 'TIGR02057', NULL, NULL, 'PAPS_reductase: phosphoadenosine phosphosulfate reductase', NULL, 'TIGR02057', NULL, NULL, 13085, 22),
(287733, NULL, 'TIGR01917', NULL, NULL, 'gly_red_sel_B: glycine reductase, selenoprotein B', NULL, 'TIGR01917', NULL, NULL, 4241, 22),
(287734, NULL, 'TIGR04261', NULL, NULL, 'rSAM_GlyRichRpt: radical SAM/SPASM domain protein, GRRM system', NULL, 'TIGR04261', NULL, NULL, 24720, 22),
(287735, NULL, 'TIGR01475', NULL, NULL, 'ubiA_other: putative 4-hydroxybenzoate polyprenyltransferase', NULL, 'TIGR01475', NULL, NULL, 5542, 22),
(287736, NULL, 'TIGR01501', NULL, NULL, 'MthylAspMutase: methylaspartate mutase, S subunit', NULL, 'TIGR01501', NULL, NULL, 5647, 22),
(287737, NULL, 'TIGR01796', NULL, NULL, 'CM_mono_aroH: chorismate mutase', NULL, 'TIGR01796', NULL, NULL, 900, 22),
(287738, NULL, 'TIGR00641', NULL, NULL, 'acid_CoA_mut_N: methylmalonyl-CoA mutase N-terminal domain', NULL, 'TIGR00641', NULL, NULL, 2993, 22),
(287739, NULL, 'TIGR01317', NULL, NULL, 'GOGAT_sm_gam: glutamate synthase, NADH/NADPH, small subunit', NULL, 'TIGR01317', NULL, NULL, 1024, 22);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287740, NULL, 'TIGR01747', NULL, NULL, 'diampropi_NH3ly: diaminopropionate ammonia-lyase family', NULL, 'TIGR01747', NULL, NULL, 2332, 22),
(287741, NULL, 'TIGR01610', NULL, NULL, 'phage_O_Nterm: phage replication protein O, N-terminal domain', NULL, 'TIGR01610', NULL, NULL, 6974, 22),
(287742, NULL, 'TIGR00778', NULL, NULL, 'ahpD_dom: alkylhydroperoxidase AhpD family core domain', NULL, 'TIGR00778', NULL, NULL, 2600, 22),
(287743, NULL, 'TIGR02765', NULL, NULL, 'crypto_DASH: cryptochrome, DASH family', NULL, 'TIGR02765', NULL, NULL, 14084, 22),
(287744, NULL, 'TIGR01298', NULL, NULL, 'RNaseT: ribonuclease T', NULL, 'TIGR01298', NULL, NULL, 1039, 22),
(287745, NULL, 'TIGR02300', NULL, NULL, 'FYDLN_acid: TIGR02300 family protein', NULL, 'TIGR02300', NULL, NULL, 10001, 22),
(287746, NULL, 'TIGR02437', NULL, NULL, 'FadB: fatty oxidation complex, alpha subunit FadB', NULL, 'TIGR02437', NULL, NULL, 11982, 22),
(287747, NULL, 'TIGR02883', NULL, NULL, 'spore_cwlD: N-acetylmuramoyl-L-alanine amidase CwlD', NULL, 'TIGR02883', NULL, NULL, 10793, 22),
(287748, NULL, 'TIGR04270', NULL, NULL, 'Rama_corrin_act: methylamine methyltransferase corrinoid protein reductive activase', NULL, 'TIGR04270', NULL, NULL, 24993, 22),
(287749, NULL, 'TIGR02614', NULL, NULL, 'ftsW: cell division protein FtsW', NULL, 'TIGR02614', NULL, NULL, 9298, 22),
(287750, NULL, 'TIGR03075', NULL, NULL, 'PQQ_enz_alc_DH: PQQ-dependent dehydrogenase, methanol/ethanol family', NULL, 'TIGR03075', NULL, NULL, 21409, 22),
(287751, NULL, 'TIGR00143', NULL, NULL, 'hypF: carbamoyltransferase HypF', NULL, 'TIGR00143', NULL, NULL, 7284, 22),
(287752, NULL, 'TIGR00573', NULL, NULL, 'dnaq: exonuclease, DNA polymerase III, epsilon subunit family', NULL, 'TIGR00573', NULL, NULL, 2960, 22),
(287753, NULL, 'TIGR01815', NULL, NULL, 'TrpE-clade3: anthranilate synthase', NULL, 'TIGR01815', NULL, NULL, 2040, 22),
(287754, NULL, 'TIGR03389', NULL, NULL, 'laccase: laccase', NULL, 'TIGR03389', NULL, NULL, 18923, 22),
(287755, NULL, 'TIGR02007', NULL, NULL, 'fdx_isc: ferredoxin, 2Fe-2S type, ISC system', NULL, 'TIGR02007', NULL, NULL, 10726, 22),
(287756, NULL, 'TIGR00691', NULL, NULL, 'spoT_relA: RelA/SpoT family protein', NULL, 'TIGR00691', NULL, NULL, 4156, 22),
(287757, NULL, 'TIGR04308', NULL, NULL, 'repeat_SSSPR51: surface protein repeat SSSPR-51', NULL, 'TIGR04308', NULL, NULL, 22106, 22),
(287758, NULL, 'TIGR01114', NULL, NULL, 'mtrH: N5-methyltetrahydromethanopterin:coenzyme M methyltransferase subunit H', NULL, 'TIGR01114', NULL, NULL, 22104, 22),
(287759, NULL, 'TIGR03769', NULL, NULL, 'P_ac_wall_RPT: actinobacterial surface-anchored protein domain', NULL, 'TIGR03769', NULL, NULL, 15527, 22),
(287760, NULL, 'TIGR02385', NULL, NULL, 'RelE_StbE: addiction module toxin, RelE/StbE family', NULL, 'TIGR02385', NULL, NULL, 1111, 22),
(287761, NULL, 'TIGR02935', NULL, NULL, 'TIGR02935: probable nitrogen fixation protein', NULL, 'TIGR02935', NULL, NULL, 2782, 22),
(287762, NULL, 'TIGR03580', NULL, NULL, 'EF_0832: conserved hypothetical protein EF_0832/AHA_3913', NULL, 'TIGR03580', NULL, NULL, 17581, 22),
(287763, NULL, 'TIGR03960', NULL, NULL, 'rSAM_fuse_unch: radical SAM family uncharacterized protein', NULL, 'TIGR03960', NULL, NULL, 17539, 22),
(287764, NULL, 'TIGR01258', NULL, NULL, 'pgm_1: phosphoglycerate mutase 1 family', NULL, 'TIGR01258', NULL, NULL, 192, 22),
(287765, NULL, 'TIGR03134', NULL, NULL, 'malonate_gamma: biotin-independent malonate decarboxylase, gamma subunit', NULL, 'TIGR03134', NULL, NULL, 11326, 22),
(287766, NULL, 'TIGR03252', NULL, NULL, 'TIGR03252: uncharacterized HhH-GPD family protein', NULL, 'TIGR03252', NULL, NULL, 17016, 22),
(287767, NULL, 'TIGR03632', NULL, NULL, 'uS11_bact: ribosomal protein uS11', NULL, 'TIGR03632', NULL, NULL, 11861, 22),
(287768, NULL, 'TIGR01749', NULL, NULL, 'fabA: beta-hydroxyacyl-(acyl-carrier-protein) dehydratase FabA', NULL, 'TIGR01749', NULL, NULL, 2099, 22),
(287769, NULL, 'TIGR04296', NULL, NULL, 'PEFG-CTERM: PEFG-CTERM domain', NULL, 'TIGR04296', NULL, NULL, 26809, 22),
(287770, NULL, 'TIGR03462', NULL, NULL, 'CarR_dom_SF: lycopene cyclase domain', NULL, 'TIGR03462', NULL, NULL, 19703, 22);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287771, NULL, 'TIGR03141', NULL, NULL, 'cytochro_ccmD: heme exporter protein CcmD', NULL, 'TIGR03141', NULL, NULL, 7328, 22),
(287772, NULL, 'TIGR03573', NULL, NULL, 'WbuX: N-acetyl sugar amidotransferase', NULL, 'TIGR03573', NULL, NULL, 17655, 22),
(287773, NULL, 'TIGR04466', NULL, NULL, 'rSAM_BlsE: cytosylglucuronate decarboxylase', NULL, 'TIGR04466', NULL, NULL, 25518, 22),
(287774, NULL, 'TIGR03082', NULL, NULL, 'Gneg_AbrB_dup: membrane protein AbrB duplication', NULL, 'TIGR03082', NULL, NULL, 14919, 22),
(287775, NULL, 'TIGR04112', NULL, NULL, 'seleno_YedE: putative selenium metabolism protein, YedE family', NULL, 'TIGR04112', NULL, NULL, 23499, 22),
(287776, NULL, 'TIGR00703', NULL, NULL, 'TIGR00703: TIGR00703 family protein', NULL, 'TIGR00703', NULL, NULL, 4110, 22),
(287777, NULL, 'TIGR01809', NULL, NULL, 'Shik-DH-AROM: shikimate-5-dehydrogenase', NULL, 'TIGR01809', NULL, NULL, 2183, 22),
(287778, NULL, 'TIGR03845', NULL, NULL, 'sulfopyru_alph: sulfopyruvate decarboxylase, alpha subunit', NULL, 'TIGR03845', NULL, NULL, 16348, 22),
(287779, NULL, 'TIGR02724', NULL, NULL, 'phenyl_P_beta: phenylphosphate carboxylase, beta subunit', NULL, 'TIGR02724', NULL, NULL, 14054, 22),
(287780, NULL, 'TIGR02876', NULL, NULL, 'spore_yqfD: sporulation protein YqfD', NULL, 'TIGR02876', NULL, NULL, 9446, 22),
(287781, NULL, 'TIGR03791', NULL, NULL, 'TTQ_mauG: tryptophan tryptophylquinone biosynthesis enzyme MauG', NULL, 'TIGR03791', NULL, NULL, 15802, 22),
(287782, NULL, 'TIGR02378', NULL, NULL, 'nirD_assim_sml: nitrite reductase [NAD(P)H], small subunit', NULL, 'TIGR02378', NULL, NULL, 9884, 22),
(287783, NULL, 'TIGR01373', NULL, NULL, 'soxB: sarcosine oxidase, beta subunit family', NULL, 'TIGR01373', NULL, NULL, 3529, 22),
(287784, NULL, 'TIGR02241', NULL, NULL, 'TIGR02241: conserved hypothetical phage tail region protein', NULL, 'TIGR02241', NULL, NULL, 11747, 22),
(287785, NULL, 'TIGR01257', NULL, NULL, 'rim_protein: rim ABC transporter', NULL, 'TIGR01257', NULL, NULL, 469, 22),
(287786, NULL, 'TIGR01120', NULL, NULL, 'rpiB: ribose 5-phosphate isomerase B', NULL, 'TIGR01120', NULL, NULL, 5036, 22),
(287787, NULL, 'TIGR02226', NULL, NULL, 'two_anch: N-terminal double-transmembrane domain', NULL, 'TIGR02226', NULL, NULL, 11208, 22),
(287788, NULL, 'TIGR00804', NULL, NULL, 'nupC: nucleoside transporter, NupC family', NULL, 'TIGR00804', NULL, NULL, 8168, 22),
(287789, NULL, 'TIGR03517', NULL, NULL, 'GldM_gliding: gliding motility-associated protein GldM', NULL, 'TIGR03517', NULL, NULL, 16610, 22),
(287790, NULL, 'TIGR04432', NULL, NULL, 'rSAM_Cfr: 23S rRNA (adenine(2503)-C(8))-methyltransferase Cfr', NULL, 'TIGR04432', NULL, NULL, 17412, 22),
(287791, NULL, 'TIGR03019', NULL, NULL, 'pepcterm_femAB: FemAB-related protein, PEP-CTERM system-associated', NULL, 'TIGR03019', NULL, NULL, 20522, 22),
(287792, NULL, 'TIGR00205', NULL, NULL, 'fliE: flagellar hook-basal body complex protein FliE', NULL, 'TIGR00205', NULL, NULL, 3094, 22),
(287793, NULL, 'TIGR00321', NULL, NULL, 'dhys: deoxyhypusine synthase', NULL, 'TIGR00321', NULL, NULL, 4674, 22),
(287794, NULL, 'TIGR02172', NULL, NULL, 'Fb_sc_TIGR02172: fibrobacter succinogenes paralogous family TIGR02172', NULL, 'TIGR02172', NULL, NULL, 15866, 22),
(287795, NULL, 'TIGR03081', NULL, NULL, 'metmalonyl_epim: methylmalonyl-CoA epimerase', NULL, 'TIGR03081', NULL, NULL, 21120, 22),
(287796, NULL, 'TIGR03523', NULL, NULL, 'GldN: gliding motility associated protein GldN', NULL, 'TIGR03523', NULL, NULL, 14709, 22),
(287797, NULL, 'TIGR00533', NULL, NULL, 'HMG_CoA_R_NADP: hydroxymethylglutaryl-CoA reductase (NADPH)', NULL, 'TIGR00533', NULL, NULL, 699, 22),
(287798, NULL, 'TIGR00956', NULL, NULL, '3a01205: pleiotropic drug resistance family protein', NULL, 'TIGR00956', NULL, NULL, 4420, 22),
(287799, NULL, 'TIGR02649', NULL, NULL, 'true_RNase_BN: ribonuclease BN', NULL, 'TIGR02649', NULL, NULL, 10194, 22),
(287800, NULL, 'TIGR00464', NULL, NULL, 'gltX_bact: glutamate--tRNA ligase', NULL, 'TIGR00464', NULL, NULL, 1637, 22),
(287801, NULL, 'TIGR02512', NULL, NULL, 'FeFe_hydrog_A: [FeFe] hydrogenase, group A', NULL, 'TIGR02512', NULL, NULL, 18944, 22);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287802, NULL, 'TIGR00458', NULL, NULL, 'aspS_nondisc: aspartate--tRNA(Asn) ligase', NULL, 'TIGR00458', NULL, NULL, 1987, 22),
(287803, NULL, 'TIGR03025', NULL, NULL, 'EPS_sugtrans: exopolysaccharide biosynthesis polyprenyl glycosylphosphotransferase', NULL, 'TIGR03025', NULL, NULL, 20587, 22),
(287804, NULL, 'TIGR00792', NULL, NULL, 'gph: sugar (Glycoside-Pentoside-Hexuronide) transporter', NULL, 'TIGR00792', NULL, NULL, 5346, 22),
(287805, NULL, 'TIGR02718', NULL, NULL, 'sider_RhtX_FptX: siderophore transporter, RhtX/FptX family', NULL, 'TIGR02718', NULL, NULL, 14052, 22),
(287806, NULL, 'TIGR03293', NULL, NULL, 'PhnG_redo: phosphonate C-P lyase system protein PhnG', NULL, 'TIGR03293', NULL, NULL, 1507, 22),
(287807, NULL, 'TIGR04569', NULL, NULL, 'arch_SelU_Cterm: selenouridine synthase, SelU C-terminal-like subunit', NULL, 'TIGR04569', NULL, NULL, 23571, 22),
(287808, NULL, 'TIGR02014', NULL, NULL, 'BchZ: chlorophyllide reductase subunit Z', NULL, 'TIGR02014', NULL, NULL, 5499, 22),
(287809, NULL, 'TIGR03729', NULL, NULL, 'acc_ester: putative phosphoesterase', NULL, 'TIGR03729', NULL, NULL, 15850, 22),
(287810, NULL, 'TIGR00962', NULL, NULL, 'atpA: ATP synthase F1, alpha subunit', NULL, 'TIGR00962', NULL, NULL, 4160, 22),
(287811, NULL, 'TIGR00211', NULL, NULL, 'glyS: glycine--tRNA ligase, beta subunit', NULL, 'TIGR00211', NULL, NULL, 8398, 22),
(287812, NULL, 'TIGR03353', NULL, NULL, 'VI_chp_4: type VI secretion protein, VC_A0114 family', NULL, 'TIGR03353', NULL, NULL, 7753, 22),
(287813, NULL, 'TIGR01367', NULL, NULL, 'pyrE_Therm: orotate phosphoribosyltransferase', NULL, 'TIGR01367', NULL, NULL, 3550, 22),
(287814, NULL, 'TIGR02384', NULL, NULL, 'RelB_DinJ: addiction module antitoxin, RelB/DinJ family', NULL, 'TIGR02384', NULL, NULL, 5328, 22),
(287815, NULL, 'TIGR01469', NULL, NULL, 'cobA_cysG_Cterm: uroporphyrinogen-III C-methyltransferase', NULL, 'TIGR01469', NULL, NULL, 5506, 22),
(287816, NULL, 'TIGR01332', NULL, NULL, 'cyt_b559_alpha: cytochrome b559, alpha subunit', NULL, 'TIGR01332', NULL, NULL, 11484, 22),
(287817, NULL, 'TIGR00348', NULL, NULL, 'hsdR: type I site-specific deoxyribonuclease, HsdR family', NULL, 'TIGR00348', NULL, NULL, 7295, 22),
(287818, NULL, 'TIGR01161', NULL, NULL, 'purK: phosphoribosylaminoimidazole carboxylase, ATPase subunit', NULL, 'TIGR01161', NULL, NULL, 6890, 22),
(287819, NULL, 'TIGR03988', NULL, NULL, 'antisig_RsrA: mycothiol system anti-sigma-R factor', NULL, 'TIGR03988', NULL, NULL, 11532, 22),
(287820, NULL, 'TIGR00362', NULL, NULL, 'DnaA: chromosomal replication initiator protein DnaA', NULL, 'TIGR00362', NULL, NULL, 4459, 22),
(287821, NULL, 'TIGR04221', NULL, NULL, 'SecA2_Mycobac: accessory Sec system translocase SecA2', NULL, 'TIGR04221', NULL, NULL, 21331, 22),
(287822, NULL, 'TIGR01967', NULL, NULL, 'DEAH_box_HrpA: RNA helicase HrpA', NULL, 'TIGR01967', NULL, NULL, 4206, 22),
(287823, NULL, 'TIGR03558', NULL, NULL, 'oxido_grp_1: luciferase family oxidoreductase, group 1', NULL, 'TIGR03558', NULL, NULL, 18274, 22),
(287824, NULL, 'TIGR03237', NULL, NULL, 'dnd_assoc_2: DNA phosphorothioation-dependent restriction protein DptH', NULL, 'TIGR03237', NULL, NULL, 16509, 22),
(287825, NULL, 'TIGR04542', NULL, NULL, 'GMC_mycofac_2: GMC family mycofactocin-associated oxidreductase', NULL, 'TIGR04542', NULL, NULL, 25188, 22),
(287826, NULL, 'TIGR02506', NULL, NULL, 'NrdE_NrdA: ribonucleoside-diphosphate reductase, alpha subunit', NULL, 'TIGR02506', NULL, NULL, 18599, 22),
(287827, NULL, 'TIGR04357', NULL, NULL, 'CofD_rel_GAK: CofD-related protein, GAK system', NULL, 'TIGR04357', NULL, NULL, 23484, 22),
(287828, NULL, 'TIGR00041', NULL, NULL, 'DTMP_kinase: dTMP kinase', NULL, 'TIGR00041', NULL, NULL, 20548, 22),
(287829, NULL, 'TIGR01797', NULL, NULL, 'CM_P_1: chorismate mutase', NULL, 'TIGR01797', NULL, NULL, 1982, 22),
(287830, NULL, 'TIGR01039', NULL, NULL, 'atpD: ATP synthase F1, beta subunit', NULL, 'TIGR01039', NULL, NULL, 4559, 22),
(287831, NULL, 'TIGR01981', NULL, NULL, 'sufD: FeS assembly protein SufD', NULL, 'TIGR01981', NULL, NULL, 12144, 22);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287832, NULL, 'TIGR00034', NULL, NULL, 'aroFGH: 3-deoxy-7-phosphoheptulonate synthase', NULL, 'TIGR00034', NULL, NULL, 11346, 22),
(287833, NULL, 'TIGR02166', NULL, NULL, 'dmsA_ynfE: anaerobic dimethyl sulfoxide reductase, A subunit, DmsA/YnfE family', NULL, 'TIGR02166', NULL, NULL, 8622, 22),
(287834, NULL, 'TIGR00997', NULL, NULL, 'ispZ: intracellular septation protein A', NULL, 'TIGR00997', NULL, NULL, 1137, 22),
(287835, NULL, 'TIGR02992', NULL, NULL, 'ectoine_eutC: ectoine utilization protein EutC', NULL, 'TIGR02992', NULL, NULL, 10120, 22),
(287836, NULL, 'TIGR04187', NULL, NULL, 'GRASP_SAV_5884: ATP-grasp ribosomal peptide maturase, SAV_5884 family', NULL, 'TIGR04187', NULL, NULL, 23352, 22),
(287837, NULL, 'TIGR04050', NULL, NULL, 'MSMEG_0567_Cter: AIR synthase-related protein, MSMEG_0567 C-terminal family', NULL, 'TIGR04050', NULL, NULL, 8153, 22),
(287838, NULL, 'TIGR01529', NULL, NULL, 'argR_whole: arginine repressor', NULL, 'TIGR01529', NULL, NULL, 5143, 22),
(287839, NULL, 'TIGR04214', NULL, NULL, 'CSLREA_Nterm: CSLREA domain', NULL, 'TIGR04214', NULL, NULL, 23309, 22),
(287840, NULL, 'TIGR00532', NULL, NULL, 'HMG_CoA_R_NAD: hydroxymethylglutaryl-CoA reductase, degradative', NULL, 'TIGR00532', NULL, NULL, 739, 22),
(287841, NULL, 'TIGR01045', NULL, NULL, 'RPE1: rickettsial palindromic element RPE1 domain', NULL, 'TIGR01045', NULL, NULL, 4981, 22),
(287842, NULL, 'TIGR00669', NULL, NULL, 'asnA: aspartate--ammonia ligase', NULL, 'TIGR00669', NULL, NULL, 2212, 22),
(287843, NULL, 'TIGR04358', NULL, NULL, 'XXXCH_domain: XXXCH domain', NULL, 'TIGR04358', NULL, NULL, 23362, 22),
(287844, NULL, 'TIGR02494', NULL, NULL, 'PFLE_PFLC: glycyl-radical enzyme activating protein', NULL, 'TIGR02494', NULL, NULL, NULL, 22),
(287845, NULL, 'TIGR01830', NULL, NULL, '3oxo_ACP_reduc: 3-oxoacyl-[acyl-carrier-protein] reductase', NULL, 'TIGR01830', NULL, NULL, 10103, 22),
(287846, NULL, 'TIGR03851', NULL, NULL, 'chitin_NgcE: carbohydrate ABC transporter, N-acetylglucosamine/diacetylchitobiose-binding protein', NULL, 'TIGR03851', NULL, NULL, 15906, 22),
(287847, NULL, 'TIGR00499', NULL, NULL, 'lysS_bact: lysine--tRNA ligase', NULL, 'TIGR00499', NULL, NULL, 5673, 22),
(287848, NULL, 'TIGR04528', NULL, NULL, 'acido_non_PQQ: acido-empty-quinoprotein group A', NULL, 'TIGR04528', NULL, NULL, 25217, 22),
(287849, NULL, 'TIGR00676', NULL, NULL, 'fadh2: methylenetetrahydrofolate reductase [NAD(P)H]', NULL, 'TIGR00676', NULL, NULL, 2368, 22),
(287850, NULL, 'TIGR00178', NULL, NULL, 'monomer_idh: isocitrate dehydrogenase, NADP-dependent', NULL, 'TIGR00178', NULL, NULL, 7114, 22),
(287851, NULL, 'TIGR01660', NULL, NULL, 'narH: nitrate reductase, beta subunit', NULL, 'TIGR01660', NULL, NULL, 443, 22),
(287852, NULL, 'TIGR02664', NULL, NULL, 'nitr_red_assoc: conserved hypothetical protein', NULL, 'TIGR02664', NULL, NULL, 10472, 22),
(287853, NULL, 'TIGR04220', NULL, NULL, 'patB_acyB_mcaB: cyanobactin biosynthesis protein, PatB/AcyB/McaB family', NULL, 'TIGR04220', NULL, NULL, 25400, 22),
(287854, NULL, 'TIGR04330', NULL, NULL, 'cas_Cpf1: CRISPR-associated protein Cpf1, subtype PREFRAN', NULL, 'TIGR04330', NULL, NULL, 23488, 22),
(287855, NULL, 'TIGR03312', NULL, NULL, 'Se_sel_red_FAD: probable selenate reductase, FAD-binding subunit', NULL, 'TIGR03312', NULL, NULL, 17743, 22),
(287856, NULL, 'TIGR03449', NULL, NULL, 'mycothiol_MshA: D-inositol-3-phosphate glycosyltransferase', NULL, 'TIGR03449', NULL, NULL, 19355, 22),
(287857, NULL, 'TIGR04467', NULL, NULL, 'CGA_synthase: hydroxymethylcytosylglucuronate/cytosylglucuronate synthase', NULL, 'TIGR04467', NULL, NULL, 25874, 22),
(287858, NULL, 'TIGR00253', NULL, NULL, 'RNA_bind_YhbY: putative RNA-binding protein, YhbY family', NULL, 'TIGR00253', NULL, NULL, 20998, 22),
(287859, NULL, 'TIGR02929', NULL, NULL, 'anfG_nitrog: Fe-only nitrogenase, delta subunit', NULL, 'TIGR02929', NULL, NULL, 8736, 22),
(287860, NULL, 'TIGR01653', NULL, NULL, 'lactococcin_972: bacteriocin, lactococcin 972 family', NULL, 'TIGR01653', NULL, NULL, 62, 22),
(287861, NULL, 'TIGR03947', NULL, NULL, 'viomycin_VioD: capreomycidine synthase', NULL, 'TIGR03947', NULL, NULL, 10721, 22);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287862, NULL, 'TIGR01687', NULL, NULL, 'moaD_arch: MoaD family protein', NULL, 'TIGR01687', NULL, NULL, 5014, 22),
(287863, NULL, 'TIGR00888', NULL, NULL, 'guaA_Nterm: GMP synthase (glutamine-hydrolyzing), N-terminal domain', NULL, 'TIGR00888', NULL, NULL, 5271, 22),
(287864, NULL, 'TIGR01052', NULL, NULL, 'top6b: DNA topoisomerase VI, B subunit', NULL, 'TIGR01052', NULL, NULL, 4838, 22),
(287865, NULL, 'TIGR02070', NULL, NULL, 'mono_pep_trsgly: monofunctional biosynthetic peptidoglycan transglycosylase', NULL, 'TIGR02070', NULL, NULL, 13135, 22),
(287866, NULL, 'TIGR00137', NULL, NULL, 'gid_trmFO: tRNA:m(5)U-54 methyltransferase', NULL, 'TIGR00137', NULL, NULL, 7216, 22),
(287867, NULL, 'TIGR02901', NULL, NULL, 'QoxD: cytochrome aa3 quinol oxidase, subunit IV', NULL, 'TIGR02901', NULL, NULL, 11089, 22),
(287868, NULL, 'TIGR04248', NULL, NULL, 'SCM_PqqD_rel: SynChlorMet cassette protein ScmD', NULL, 'TIGR04248', NULL, NULL, 24992, 22),
(287869, NULL, 'TIGR04111', NULL, NULL, 'BcepMu_gp16: phage-associated protein, BcepMu gp16 family', NULL, 'TIGR04111', NULL, NULL, 23375, 22),
(287870, NULL, 'TIGR03100', NULL, NULL, 'hydr1_PEP: exosortase A system-associated hydrolase 1', NULL, 'TIGR03100', NULL, NULL, 14840, 22),
(287871, NULL, 'TIGR00860', NULL, NULL, 'LIC: cation transporter family protein', NULL, 'TIGR00860', NULL, NULL, 11483, 22),
(287872, NULL, 'TIGR04255', NULL, NULL, 'sporadTIGR04255: TIGR04255 family protein', NULL, 'TIGR04255', NULL, NULL, 24584, 22),
(287873, NULL, 'TIGR00635', NULL, NULL, 'ruvB: Holliday junction DNA helicase RuvB', NULL, 'TIGR00635', NULL, NULL, 939, 22),
(287874, NULL, 'TIGR01380', NULL, NULL, 'glut_syn: glutathione synthase', NULL, 'TIGR01380', NULL, NULL, 3545, 22),
(287875, NULL, 'TIGR04002', NULL, NULL, 'TIGR04002: TIGR04002 family protein', NULL, 'TIGR04002', NULL, NULL, 14565, 22),
(287876, NULL, 'TIGR03421', NULL, NULL, 'FeS_CyaY: iron donor protein CyaY', NULL, 'TIGR03421', NULL, NULL, 6348, 22),
(287877, NULL, 'TIGR01550', NULL, NULL, 'DOC_P1: death-on-curing family protein', NULL, 'TIGR01550', NULL, NULL, 6646, 22),
(287878, NULL, 'TIGR03810', NULL, NULL, 'arg_ornith_anti: arginine-ornithine antiporter', NULL, 'TIGR03810', NULL, NULL, 15842, 22),
(287879, NULL, 'TIGR03735', NULL, NULL, 'PRTRC_A: PRTRC system protein A', NULL, 'TIGR03735', NULL, NULL, 16098, 22),
(287880, NULL, 'TIGR00779', NULL, NULL, 'cad: cadmium resistance transporter family protein', NULL, 'TIGR00779', NULL, NULL, 3421, 22),
(287881, NULL, 'TIGR04500', NULL, NULL, 'PpiC_rel_mature: putative peptide maturation system protein', NULL, 'TIGR04500', NULL, NULL, 24163, 22),
(287882, NULL, 'TIGR04078', NULL, NULL, 'rSAM_yydG: peptide modification radical SAM enzyme, YydG family', NULL, 'TIGR04078', NULL, NULL, 18063, 22),
(287883, NULL, 'TIGR01762', NULL, NULL, 'chlorin-enz: chlorinating enzyme', NULL, 'TIGR01762', NULL, NULL, 2298, 22),
(287884, NULL, 'TIGR02780', NULL, NULL, 'TrbJ_Ti: P-type conjugative transfer protein TrbJ', NULL, 'TIGR02780', NULL, NULL, 14427, 22),
(287885, NULL, 'TIGR02282', NULL, NULL, 'MltB: lytic murein transglycosylase B', NULL, 'TIGR02282', NULL, NULL, 11913, 22),
(287886, NULL, 'TIGR04323', NULL, NULL, 'SpoChoClust_1: sporadic carbohydrate cluster protein, LIC12192 family', NULL, 'TIGR04323', NULL, NULL, 25431, 22),
(287887, NULL, 'TIGR01899', NULL, NULL, 'cas_TM1807_csm5: CRISPR type III-A/MTUBE-associated RAMP protein Csm5', NULL, 'TIGR01899', NULL, NULL, 10614, 22),
(287888, NULL, 'TIGR00744', NULL, NULL, 'ROK_glcA_fam: ROK family protein (putative glucokinase)', NULL, 'TIGR00744', NULL, NULL, 2509, 22),
(287889, NULL, 'TIGR03305', NULL, NULL, 'alt_F1F0_F1_bet: alternate F1F0 ATPase, F1 subunit beta', NULL, 'TIGR03305', NULL, NULL, 17649, 22),
(287890, NULL, 'TIGR03954', NULL, NULL, 'integ_memb_HG: integral membrane protein', NULL, 'TIGR03954', NULL, NULL, 16570, 22),
(287891, NULL, 'TIGR03633', NULL, NULL, 'arc_protsome_A: proteasome endopeptidase complex, archaeal, alpha subunit', NULL, 'TIGR03633', NULL, NULL, 11592, 22),
(287892, NULL, 'TIGR04146', NULL, NULL, 'GGGPS_Afulg: phosphoglycerol geranylgeranyltransferase', NULL, 'TIGR04146', NULL, NULL, 23368, 22);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287893, NULL, 'TIGR00246', NULL, NULL, 'tRNA_RlmH_YbeA: rRNA large subunit m3Psi methyltransferase RlmH', NULL, 'TIGR00246', NULL, NULL, 4425, 22),
(287894, NULL, 'TIGR01918', NULL, NULL, 'various_sel_PB: selenoprotein B, glycine/betaine/sarcosine/D-proline reductase family', NULL, 'TIGR01918', NULL, NULL, 4010, 22),
(287895, NULL, 'TIGR03803', NULL, NULL, 'Gloeo_Verruco: gloeo_Verruco repeat', NULL, 'TIGR03803', NULL, NULL, 16018, 22),
(287896, NULL, 'TIGR00567', NULL, NULL, '3mg: DNA-3-methyladenine glycosylase', NULL, 'TIGR00567', NULL, NULL, 2693, 22),
(287897, NULL, 'TIGR00430', NULL, NULL, 'Q_tRNA_tgt: tRNA-guanine transglycosylase', NULL, 'TIGR00430', NULL, NULL, 5703, 22),
(287898, NULL, 'TIGR02608', NULL, NULL, 'delta_60_rpt: delta-60 repeat domain', NULL, 'TIGR02608', NULL, NULL, 9053, 22),
(287899, NULL, 'TIGR02117', NULL, NULL, 'chp_urease_rgn: conserved hypothetical protein', NULL, 'TIGR02117', NULL, NULL, 11909, 22),
(287900, NULL, 'TIGR02596', NULL, NULL, 'TIGR02596: Verru_Chthon cassette protein D', NULL, 'TIGR02596', NULL, NULL, 14683, 22),
(287901, NULL, 'TIGR00423', NULL, NULL, 'TIGR00423: radical SAM domain protein, CofH subfamily', NULL, 'TIGR00423', NULL, NULL, 11687, 22),
(287902, NULL, 'TIGR00090', NULL, NULL, 'rsfS_iojap_ybeB: ribosome silencing factor', NULL, 'TIGR00090', NULL, NULL, 5605, 22),
(287903, NULL, 'TIGR01441', NULL, NULL, 'GPR: GPR endopeptidase', NULL, 'TIGR01441', NULL, NULL, 10123, 22),
(287904, NULL, 'TIGR01578', NULL, NULL, 'MiaB-like-B: MiaB-like tRNA modifying enzyme, archaeal-type', NULL, 'TIGR01578', NULL, NULL, 6181, 22),
(287905, NULL, 'TIGR03626', NULL, NULL, 'L3_arch: ribosomal protein uL3', NULL, 'TIGR03626', NULL, NULL, 15043, 22),
(287906, NULL, 'TIGR04139', NULL, NULL, 'CxxCx5CxxC_targ: putative peptide modification target, TIGR04139 family', NULL, 'TIGR04139', NULL, NULL, 23456, 22),
(287907, NULL, 'TIGR02098', NULL, NULL, 'MJ0042_CXXC: MJ0042 family finger-like domain', NULL, 'TIGR02098', NULL, NULL, 10710, 22),
(287908, NULL, 'TIGR02936', NULL, NULL, 'fdxN_nitrog: ferredoxin III, nif-specific', NULL, 'TIGR02936', NULL, NULL, 8559, 22),
(287909, NULL, 'TIGR01087', NULL, NULL, 'murD: UDP-N-acetylmuramoylalanine--D-glutamate ligase', NULL, 'TIGR01087', NULL, NULL, 4849, 22),
(287910, NULL, 'TIGR00751', NULL, NULL, 'menA: 1,4-dihydroxy-2-naphthoate octaprenyltransferase', NULL, 'TIGR00751', NULL, NULL, NULL, 22),
(287911, NULL, 'TIGR02615', NULL, NULL, 'spoVE: stage V sporulation protein E', NULL, 'TIGR02615', NULL, NULL, 9300, 22),
(287912, NULL, 'TIGR01264', NULL, NULL, 'tyr_amTase_E: tyrosine aminotransferase', NULL, 'TIGR01264', NULL, NULL, 160, 22),
(287913, NULL, 'TIGR03128', NULL, NULL, 'RuMP_HxlA: 3-hexulose-6-phosphate synthase', NULL, 'TIGR03128', NULL, NULL, 14983, 22),
(287914, NULL, 'TIGR03291', NULL, NULL, 'methan_mark_17: putative methanogenesis marker protein 17', NULL, 'TIGR03291', NULL, NULL, 21383, 22),
(287915, NULL, 'TIGR00323', NULL, NULL, 'eIF-6: putative translation initiation factor eIF-6', NULL, 'TIGR00323', NULL, NULL, 4654, 22),
(287916, NULL, 'TIGR02653', NULL, NULL, 'Lon_rel_chp: conserved hypothetical protein', NULL, 'TIGR02653', NULL, NULL, 10093, 22),
(287917, NULL, 'TIGR03171', NULL, NULL, 'soxL2: Rieske iron-sulfur protein SoxL2', NULL, 'TIGR03171', NULL, NULL, 15624, 22),
(287918, NULL, 'TIGR00443', NULL, NULL, 'hisZ_biosyn_reg: ATP phosphoribosyltransferase, regulatory subunit', NULL, 'TIGR00443', NULL, NULL, 1583, 22),
(287919, NULL, 'TIGR03051', NULL, NULL, 'PS_I_psaG_plant: photosystem I reaction center subunit V', NULL, 'TIGR03051', NULL, NULL, 20855, 22),
(287920, NULL, 'TIGR01081', NULL, NULL, 'mpl: UDP-N-acetylmuramate:L-alanyl-gamma-D-glutamyl-meso-diaminopimelate ligase', NULL, 'TIGR01081', NULL, NULL, 4532, 22),
(287921, NULL, 'TIGR04503', NULL, NULL, 'mft_etfB: electron transfer flavoprotein, mycofactocin-associated', NULL, 'TIGR04503', NULL, NULL, 24439, 22),
(287922, NULL, 'TIGR00563', NULL, NULL, 'rsmB: 16S rRNA (cytosine(967)-C(5))-methyltransferase', NULL, 'TIGR00563', NULL, NULL, 677, 22);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287923, NULL, 'TIGR02413', NULL, NULL, 'Bac_small_yrzI: Bacillus tandem small hypothetical protein', NULL, 'TIGR02413', NULL, NULL, 10189, 22),
(287924, NULL, 'TIGR02966', NULL, NULL, 'phoR_proteo: phosphate regulon sensor kinase PhoR', NULL, 'TIGR02966', NULL, NULL, 9681, 22),
(287925, NULL, 'TIGR01394', NULL, NULL, 'TypA_BipA: GTP-binding protein TypA/BipA', NULL, 'TIGR01394', NULL, NULL, 4974, 22),
(287926, NULL, 'TIGR00010', NULL, NULL, 'TIGR00010: hydrolase, TatD family', NULL, 'TIGR00010', NULL, NULL, 9213, 22),
(287927, NULL, 'TIGR00683', NULL, NULL, 'nanA: N-acetylneuraminate lyase', NULL, 'TIGR00683', NULL, NULL, 4396, 22),
(287928, NULL, 'TIGR01766', NULL, NULL, 'tspaseT_teng_C: transposase, IS605 OrfB family', NULL, 'TIGR01766', NULL, NULL, 2320, 22),
(287929, NULL, 'TIGR03677', NULL, NULL, 'eL8_ribo: ribosomal protein eL8', NULL, 'TIGR03677', NULL, NULL, 16118, 22),
(287930, NULL, 'TIGR03300', NULL, NULL, 'assembly_YfgL: outer membrane assembly lipoprotein YfgL', NULL, 'TIGR03300', NULL, NULL, 17754, 22),
(287931, NULL, 'TIGR01587', NULL, NULL, 'cas3_core: CRISPR-associated helicase Cas3', NULL, 'TIGR01587', NULL, NULL, 6215, 22),
(287932, NULL, 'TIGR01210', NULL, NULL, 'TIGR01210: radical SAM enzyme, TIGR01210 family', NULL, 'TIGR01210', NULL, NULL, 173, 22),
(287933, NULL, 'TIGR03856', NULL, NULL, 'F420_MSMEG_2906: probable F420-dependent oxidoreductase, MSMEG_2906 family', NULL, 'TIGR03856', NULL, NULL, 16139, 22),
(287934, NULL, 'TIGR04494', NULL, NULL, 'c550_PedF: cytochrome c-550 PedF', NULL, 'TIGR04494', NULL, NULL, 21963, 22),
(287935, NULL, 'TIGR00130', NULL, NULL, 'frhD: coenzyme F420-reducing hydrogenase, FrhD protein', NULL, 'TIGR00130', NULL, NULL, 5955, 22),
(287936, NULL, 'TIGR00949', NULL, NULL, '2A76: homoserine/Threonine efflux protein', NULL, 'TIGR00949', NULL, NULL, 5299, 22),
(287937, NULL, 'TIGR02846', NULL, NULL, 'spore_sigmaK: RNA polymerase sigma-K factor', NULL, 'TIGR02846', NULL, NULL, 9383, 22),
(287938, NULL, 'TIGR00756', NULL, NULL, 'PPR: pentatricopeptide repeat domain', NULL, 'TIGR00756', NULL, NULL, 5826, 22),
(287939, NULL, 'TIGR02220', NULL, NULL, 'phg_TIGR02220: phage conserved hypothetical protein, C-terminal domain', NULL, 'TIGR02220', NULL, NULL, 11987, 22),
(287940, NULL, 'TIGR03912', NULL, NULL, 'PylS_Nterm: pyrrolysine--tRNA ligase, N-terminal region', NULL, 'TIGR03912', NULL, NULL, 17833, 22),
(287941, NULL, 'TIGR02597', NULL, NULL, 'TIGR02597: TIGR02597 family protein', NULL, 'TIGR02597', NULL, NULL, 15821, 22),
(287942, NULL, 'TIGR04310', NULL, NULL, 'pantocin_A_pre: pantocin A family RiPP', NULL, 'TIGR04310', NULL, NULL, 22030, 22),
(287943, NULL, 'TIGR01822', NULL, NULL, '2am3keto_CoA: glycine C-acetyltransferase', NULL, 'TIGR01822', NULL, NULL, 10347, 22),
(287944, NULL, 'TIGR01333', NULL, NULL, 'cyt_b559_beta: cytochrome b559, beta subunit', NULL, 'TIGR01333', NULL, NULL, 3917, 22),
(287945, NULL, 'TIGR01523', NULL, NULL, 'ATPase-IID_K-Na: potassium/sodium efflux P-type ATPase, fungal-type', NULL, 'TIGR01523', NULL, NULL, 6838, 22),
(287946, NULL, 'TIGR03663', NULL, NULL, 'TIGR03663: TIGR03663 family protein', NULL, 'TIGR03663', NULL, NULL, 15846, 22),
(287947, NULL, 'TIGR01403', NULL, NULL, 'fliQ_rel_III: type III secretion protein, HrpO family', NULL, 'TIGR01403', NULL, NULL, 4927, 22),
(287948, NULL, 'TIGR02905', NULL, NULL, 'spore_yutH: spore coat protein YutH', NULL, 'TIGR02905', NULL, NULL, 11482, 22),
(287949, NULL, 'TIGR03733', NULL, NULL, 'lanti_perm_MutG: lantibiotic protection ABC transporter permease subunit, MutG family', NULL, 'TIGR03733', NULL, NULL, 15223, 22),
(287950, NULL, 'TIGR02161', NULL, NULL, 'napC_nirT: periplasmic nitrate (or nitrite) reductase c-type cytochrome, NapC/NirT family', NULL, 'TIGR02161', NULL, NULL, 8604, 22),
(287951, NULL, 'TIGR04181', NULL, NULL, 'NHT_00031: aminotransferase, LLPSF_NHT_00031 family', NULL, 'TIGR04181', NULL, NULL, 21015, 22),
(287952, NULL, 'TIGR04371', NULL, NULL, 'methyltran_NanM: putative sugar O-methyltransferase', NULL, 'TIGR04371', NULL, NULL, 21558, 22),
(287953, NULL, 'TIGR01693', NULL, NULL, 'UTase_glnD: protein-P-II uridylyltransferase', NULL, 'TIGR01693', NULL, NULL, 5439, 22);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287954, NULL, 'TIGR03543', NULL, NULL, 'divI1A_rptt_fam: DivIVA domain repeat protein', NULL, 'TIGR03543', NULL, NULL, 18385, 22),
(287955, NULL, 'TIGR04011', NULL, NULL, 'poly_gGlu_PgsC: poly-gamma-glutamate biosynthesis protein PgsC', NULL, 'TIGR04011', NULL, NULL, 7732, 22),
(287956, NULL, 'TIGR03806', NULL, NULL, 'chp_HNE_0200: conserved hypothetical protein, HNE_0200 family', NULL, 'TIGR03806', NULL, NULL, 15934, 22),
(287957, NULL, 'TIGR00742', NULL, NULL, 'yjbN: tRNA dihydrouridine synthase A', NULL, 'TIGR00742', NULL, NULL, 2684, 22),
(287958, NULL, 'TIGR00622', NULL, NULL, 'ssl1: transcription factor ssl1', NULL, 'TIGR00622', NULL, NULL, 7103, 22),
(287959, NULL, 'TIGR04444', NULL, NULL, 'chori_FkbO_Hyg5: chorismatase, FkbO/Hyg5 family', NULL, 'TIGR04444', NULL, NULL, 26289, 22),
(287960, NULL, 'TIGR04324', NULL, NULL, 'SpoChoClust_2: sporadic carbohydrate cluster 2OG-Fe(II) oxygenase', NULL, 'TIGR04324', NULL, NULL, 25280, 22),
(287961, NULL, 'TIGR01646', NULL, NULL, 'vgr_GE: Rhs element Vgr protein', NULL, 'TIGR01646', NULL, NULL, 490, 22),
(287962, NULL, 'TIGR00264', NULL, NULL, 'TIGR00264: alpha-NAC homolog', NULL, 'TIGR00264', NULL, NULL, 11236, 22),
(287963, NULL, 'TIGR03230', NULL, NULL, 'lipo_lipase: lipoprotein lipase', NULL, 'TIGR03230', NULL, NULL, 6145, 22),
(287964, NULL, 'TIGR03420', NULL, NULL, 'DnaA_homol_Hda: DnaA regulatory inactivator Hda', NULL, 'TIGR03420', NULL, NULL, 19321, 22),
(287965, NULL, 'TIGR01836', NULL, NULL, 'PHA_synth_III_C: poly(R)-hydroxyalkanoic acid synthase, class III, PhaC subunit', NULL, 'TIGR01836', NULL, NULL, 10849, 22),
(287966, NULL, 'TIGR02041', NULL, NULL, 'CysI: sulfite reductase (NADPH) hemoprotein, beta-component', NULL, 'TIGR02041', NULL, NULL, 13080, 22),
(287967, NULL, 'TIGR04195', NULL, NULL, 'S_glycosyl_SunS: peptide S-glycosyltransferase, SunS family', NULL, 'TIGR04195', NULL, NULL, 23266, 22),
(287968, NULL, 'TIGR03007', NULL, NULL, 'pepcterm_ChnLen: polysaccharide chain length determinant protein, PEP-CTERM locus subfamily', NULL, 'TIGR03007', NULL, NULL, 11337, 22),
(287969, NULL, 'TIGR00996', NULL, NULL, 'Mtu_fam_mce: virulence factor Mce family protein', NULL, 'TIGR00996', NULL, NULL, 3621, 22),
(287970, NULL, 'TIGR02100', NULL, NULL, 'glgX_debranch: glycogen debranching enzyme GlgX', NULL, 'TIGR02100', NULL, NULL, 13990, 22),
(287971, NULL, 'TIGR00027', NULL, NULL, 'mthyl_TIGR00027: methyltransferase, TIGR00027 family', NULL, 'TIGR00027', NULL, NULL, 8313, 22),
(287972, NULL, 'TIGR01274', NULL, NULL, 'ACC_deam: 1-aminocyclopropane-1-carboxylate deaminase', NULL, 'TIGR01274', NULL, NULL, 356, 22),
(287973, NULL, 'TIGR02776', NULL, NULL, 'NHEJ_ligase_prk: DNA ligase D', NULL, 'TIGR02776', NULL, NULL, 14043, 22),
(287974, NULL, 'TIGR01260', NULL, NULL, 'ATP_synt_c: ATP synthase F0, C subunit', NULL, 'TIGR01260', NULL, NULL, 371, 22),
(287975, NULL, 'TIGR00636', NULL, NULL, 'PduO_Nterm: ATP:cob(I)alamin adenosyltransferase', NULL, 'TIGR00636', NULL, NULL, 26821, 22),
(287976, NULL, 'TIGR04430', NULL, NULL, 'OM_asym_MlaD: outer membrane lipid asymmetry maintenance protein MlaD', NULL, 'TIGR04430', NULL, NULL, 25623, 22),
(287977, NULL, 'TIGR00250', NULL, NULL, 'RNAse_H_YqgF: putative transcription antitermination factor YqgF', NULL, 'TIGR00250', NULL, NULL, 11163, 22),
(287978, NULL, 'TIGR02284', NULL, NULL, 'TIGR02284: conserved hypothetical protein', NULL, 'TIGR02284', NULL, NULL, 11118, 22),
(287979, NULL, 'TIGR02474', NULL, NULL, 'pec_lyase: pectate lyase', NULL, 'TIGR02474', NULL, NULL, 12505, 22),
(287980, NULL, 'TIGR03498', NULL, NULL, 'FliI_clade3: flagellar protein export ATPase FliI', NULL, 'TIGR03498', NULL, NULL, 15555, 22),
(287981, NULL, 'TIGR03976', NULL, NULL, 'chp_LLNDYxLRE: His-Xaa-Ser system protein HxsD', NULL, 'TIGR03976', NULL, NULL, 11122, 22),
(287982, NULL, 'TIGR00191', NULL, NULL, 'thrB: homoserine kinase', NULL, 'TIGR00191', NULL, NULL, 4502, 22),
(287983, NULL, 'TIGR02533', NULL, NULL, 'type_II_gspE: type II secretion system protein E', NULL, 'TIGR02533', NULL, NULL, 18943, 22),
(287984, NULL, 'TIGR01825', NULL, NULL, 'gly_Cac_T_rel: putative pyridoxal phosphate-dependent acyltransferase', NULL, 'TIGR01825', NULL, NULL, 2325, 22);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(287985, NULL, 'TIGR02463', NULL, NULL, 'MPGP_rel: mannosyl-3-phosphoglycerate phosphatase homolog', NULL, 'TIGR02463', NULL, NULL, NULL, 22),
(287986, NULL, 'TIGR01945', NULL, NULL, 'rnfC: electron transport complex, RnfABCDGE type, C subunit', NULL, 'TIGR01945', NULL, NULL, 4333, 22),
(287987, NULL, 'TIGR02723', NULL, NULL, 'phenyl_P_alpha: phenylphosphate carboxylase, alpha subunit', NULL, 'TIGR02723', NULL, NULL, 14457, 22),
(287988, NULL, 'TIGR03915', NULL, NULL, 'SAM_7_link_chp: probable DNA metabolism protein', NULL, 'TIGR03915', NULL, NULL, 16527, 22),
(287989, NULL, 'TIGR01031', NULL, NULL, 'rpmF_bact: ribosomal protein bL32', NULL, 'TIGR01031', NULL, NULL, 2512, 22),
(287990, NULL, 'TIGR04553', NULL, NULL, 'ABC_peri_selen: putative selenate ABC transporter periplasmic binding protein', NULL, 'TIGR04553', NULL, NULL, 23863, 22),
(287991, NULL, 'TIGR03554', NULL, NULL, 'F420_G6P_DH: glucose-6-phosphate dehydrogenase (coenzyme-F420)', NULL, 'TIGR03554', NULL, NULL, 18351, 22),
(287992, NULL, 'TIGR02390', NULL, NULL, 'RNA_pol_rpoA1: DNA-directed RNA polymerase subunit A''', NULL, 'TIGR02390', NULL, NULL, 9691, 22),
(287993, NULL, 'TIGR03674', NULL, NULL, 'fen_arch: flap structure-specific endonuclease', NULL, 'TIGR03674', NULL, NULL, 15990, 22),
(287994, NULL, 'TIGR00577', NULL, NULL, 'fpg: DNA-formamidopyrimidine glycosylase', NULL, 'TIGR00577', NULL, NULL, 19827, 22),
(287995, NULL, 'TIGR00200', NULL, NULL, 'cinA_nterm: competence/damage-inducible protein CinA N-terminal domain', NULL, 'TIGR00200', NULL, NULL, 6259, 22),
(287996, NULL, 'TIGR01584', NULL, NULL, 'citF: citrate lyase, alpha subunit', NULL, 'TIGR01584', NULL, NULL, 6450, 22),
(287997, NULL, 'TIGR04360', NULL, NULL, 'other_trbK: conjugative transfer region protein TrbK', NULL, 'TIGR04360', NULL, NULL, 23059, 22),
(287998, NULL, 'TIGR01409', NULL, NULL, 'TAT_signal_seq: Tat (twin-arginine translocation) pathway signal sequence', NULL, 'TIGR01409', NULL, NULL, 19451, 22),
(287999, NULL, 'TIGR00493', NULL, NULL, 'clpP: ATP-dependent Clp endopeptidase, proteolytic subunit ClpP', NULL, 'TIGR00493', NULL, NULL, 2293, 22),
(288000, NULL, 'TIGR03294', NULL, NULL, 'FrhG: coenzyme F420 hydrogenase, subunit gamma', NULL, 'TIGR03294', NULL, NULL, 17782, 22),
(288001, NULL, 'TIGR02583', NULL, NULL, 'DevR_archaea: CRISPR-associated protein Cas7/Csa2, subtype I-A/APERN', NULL, 'TIGR02583', NULL, NULL, 4444, 22),
(288002, NULL, 'TIGR04072', NULL, NULL, 'rSAM_ladder_B12: lipid biosynthesis B12-binding/radical SAM protein', NULL, 'TIGR04072', NULL, NULL, 10538, 22),
(288003, NULL, 'TIGR03127', NULL, NULL, 'RuMP_HxlB: 6-phospho 3-hexuloisomerase', NULL, 'TIGR03127', NULL, NULL, 14897, 22),
(288004, NULL, 'TIGR04265', NULL, NULL, 'bac_cardiolipin: cardiolipin synthase', NULL, 'TIGR04265', NULL, NULL, 17264, 22),
(288005, NULL, 'TIGR03627', NULL, NULL, 'uS9_arch: ribosomal protein uS9', NULL, 'TIGR03627', NULL, NULL, 12648, 22),
(288006, NULL, 'TIGR01537', NULL, NULL, 'portal_HK97: phage portal protein, HK97 family', NULL, 'TIGR01537', NULL, NULL, 6972, 22),
(288007, NULL, 'TIGR02175', NULL, NULL, 'PorC_KorC: 2-oxoacid:acceptor oxidoreductase, gamma subunit, pyruvate/2-ketoisovalerate family', NULL, 'TIGR02175', NULL, NULL, 8633, 22),
(288008, NULL, 'TIGR01020', NULL, NULL, 'uS5_euk_arch: ribosomal protein uS5', NULL, 'TIGR01020', NULL, NULL, 3845, 22),
(288009, NULL, 'TIGR03110', NULL, NULL, 'exosort_Gpos: exosortase family protein XrtG', NULL, 'TIGR03110', NULL, NULL, 14609, 22),
(288010, NULL, 'TIGR04480', NULL, NULL, 'D_pro_red_PrdA: D-proline reductase (dithiol), PrdA proprotein', NULL, 'TIGR04480', NULL, NULL, 25500, 22),
(288011, NULL, 'TIGR03434', NULL, NULL, 'ADOP: acidobacterial duplicated orphan permease', NULL, 'TIGR03434', NULL, NULL, 19211, 22),
(288012, NULL, 'TIGR04192', NULL, NULL, 'GRASP_w_spasm: ATP-GRASP peptide maturase, grasp-with-spasm system', NULL, 'TIGR04192', NULL, NULL, 23061, 22),
(288013, NULL, 'TIGR03018', NULL, NULL, 'pepcterm_TyrKin: exopolysaccharide/PEP-CTERM locus tyrosine autokinase', NULL, 'TIGR03018', NULL, NULL, NULL, 22); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288014, NULL, 'TIGR00320', NULL, NULL, 'dfx_rbo: desulfoferrodoxin', NULL, 'TIGR00320', NULL, NULL, 5413, 22),
(288015, NULL, 'TIGR00946', NULL, NULL, '2a69: auxin efflux carrier', NULL, 'TIGR00946', NULL, NULL, 13221, 22),
(288016, NULL, 'TIGR03722', NULL, NULL, 'arch_KAE1: universal archaeal protein Kae1', NULL, 'TIGR03722', NULL, NULL, 21397, 22),
(288017, NULL, 'TIGR02047', NULL, NULL, 'CadR-PbrR: Cd(II)/Pb(II)-responsive transcriptional regulator', NULL, 'TIGR02047', NULL, NULL, 13141, 22),
(288018, NULL, 'TIGR02281', NULL, NULL, 'clan_AA_DTGA: clan AA aspartic protease, TIGR02281 family', NULL, 'TIGR02281', NULL, NULL, 11181, 22),
(288019, NULL, 'TIGR03783', NULL, NULL, 'Bac_Flav_CT_G: Bacteroides conjugation system ATPase, TraG family', NULL, 'TIGR03783', NULL, NULL, 16079, 22),
(288020, NULL, 'TIGR00745', NULL, NULL, 'apbA_panE: 2-dehydropantoate 2-reductase', NULL, 'TIGR00745', NULL, NULL, 2407, 22),
(288021, NULL, 'TIGR01643', NULL, NULL, 'YD_repeat_2x: YD repeat (two copies)', NULL, 'TIGR01643', NULL, NULL, 468, 22),
(288022, NULL, 'TIGR04251', NULL, NULL, 'SCM_rSAM_ScmF: SynChlorMet cassette radical SAM/SPASM protein ScmF', NULL, 'TIGR04251', NULL, NULL, 24727, 22),
(288023, NULL, 'TIGR02111', NULL, NULL, 'PQQ_syn_pqqC: coenzyme PQQ biosynthesis protein C', NULL, 'TIGR02111', NULL, NULL, 13925, 22),
(288024, NULL, 'TIGR01383', NULL, NULL, 'not_thiJ: DJ-1 family protein', NULL, 'TIGR01383', NULL, NULL, 3875, 22),
(288025, NULL, 'TIGR00398', NULL, NULL, 'metG: methionine--tRNA ligase', NULL, 'TIGR00398', NULL, NULL, 12288, 22),
(288026, NULL, 'TIGR02234', NULL, NULL, 'trp_oprn_chp: membrane protein, TIGR02234 family', NULL, 'TIGR02234', NULL, NULL, 11645, 22),
(288027, NULL, 'TIGR03736', NULL, NULL, 'PRTRC_ThiF: PRTRC system ThiF family protein', NULL, 'TIGR03736', NULL, NULL, 16274, 22),
(288028, NULL, 'TIGR02642', NULL, NULL, 'phage_xxxx: uncharacterized phage protein', NULL, 'TIGR02642', NULL, NULL, 10004, 22),
(288029, NULL, 'TIGR03797', NULL, NULL, 'NHLM_micro_ABC2: NHLM bacteriocin system ABC transporter, ATP-binding protein', NULL, 'TIGR03797', NULL, NULL, 16197, 22),
(288030, NULL, 'TIGR02354', NULL, NULL, 'thiF_fam2: thiamine biosynthesis protein ThiF', NULL, 'TIGR02354', NULL, NULL, 11830, 22),
(288031, NULL, 'TIGR04131', NULL, NULL, 'Bac_Flav_CTERM: gliding motility-associated C-terminal domain', NULL, 'TIGR04131', NULL, NULL, 23090, 22),
(288032, NULL, 'TIGR03613', NULL, NULL, 'RutR: pyrimidine utilization regulatory protein R', NULL, 'TIGR03613', NULL, NULL, 14672, 22),
(288033, NULL, 'TIGR01140', NULL, NULL, 'L_thr_O3P_dcar: threonine-phosphate decarboxylase', NULL, 'TIGR01140', NULL, NULL, 6687, 22),
(288034, NULL, 'TIGR02295', NULL, NULL, 'HpaD: 3,4-dihydroxyphenylacetate 2,3-dioxygenase', NULL, 'TIGR02295', NULL, NULL, 13016, 22),
(288035, NULL, 'TIGR01931', NULL, NULL, 'cysJ: sulfite reductase [NADPH] flavoprotein, alpha-component', NULL, 'TIGR01931', NULL, NULL, 4240, 22),
(288036, NULL, 'TIGR03495', NULL, NULL, 'phage_LysB: phage lysis regulatory protein, LysB family', NULL, 'TIGR03495', NULL, NULL, 16963, 22),
(288037, NULL, 'TIGR02857', NULL, NULL, 'CydD: thiol reductant ABC exporter, CydD subunit', NULL, 'TIGR02857', NULL, NULL, 10628, 22),
(288038, NULL, 'TIGR00384', NULL, NULL, 'dhsB: succinate dehydrogenase and fumarate reductase iron-sulfur protein', NULL, 'TIGR00384', NULL, NULL, 1293, 22),
(288039, NULL, 'TIGR02340', NULL, NULL, 'chap_CCT_alpha: T-complex protein 1, alpha subunit', NULL, 'TIGR02340', NULL, NULL, 11604, 22),
(288040, NULL, 'TIGR03842', NULL, NULL, 'F420_CPS_4043: F420-dependent oxidoreductase, CPS_4043 family', NULL, 'TIGR03842', NULL, NULL, 15705, 22),
(288041, NULL, 'TIGR01702', NULL, NULL, 'CO_DH_cata: carbon-monoxide dehydrogenase, catalytic subunit', NULL, 'TIGR01702', NULL, NULL, 5487, 22),
(288042, NULL, 'TIGR03160', NULL, NULL, 'cobT_DBIPRT: nicotinate-nucleotide--dimethylbenzimidazole phosphoribosyltransferase', NULL, 'TIGR03160', NULL, NULL, 12862, 22),
(288043, NULL, 'TIGR00686', NULL, NULL, 'phnA: putative alkylphosphonate utilization operon protein PhnA', NULL, 'TIGR00686', NULL, NULL, 2184, 22);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288044, NULL, 'TIGR02890', NULL, NULL, 'bacill_yteA: regulatory protein, yteA family', NULL, 'TIGR02890', NULL, NULL, 10690, 22),
(288045, NULL, 'TIGR04374', NULL, NULL, 'small_w_EgtBD: hercynine metabolism small protein', NULL, 'TIGR04374', NULL, NULL, 21714, 22),
(288046, NULL, 'TIGR00214', NULL, NULL, 'lipB: lipoyl(octanoyl) transferase', NULL, 'TIGR00214', NULL, NULL, 5986, 22),
(288047, NULL, 'TIGR00672', NULL, NULL, 'cdh: CDP-diacylglycerol diphosphatase', NULL, 'TIGR00672', NULL, NULL, 9119, 22),
(288048, NULL, 'TIGR01716', NULL, NULL, 'RGG_Cterm: transcriptional activator, Rgg/GadR/MutR family, C-terminal domain', NULL, 'TIGR01716', NULL, NULL, 5250, 22),
(288049, NULL, 'TIGR02916', NULL, NULL, 'PEP_his_kin: putative PEP-CTERM system histidine kinase', NULL, 'TIGR02916', NULL, NULL, 11296, 22),
(288050, NULL, 'TIGR04086', NULL, NULL, 'TIGR04086_membr: putative membrane protein, TIGR04086 family', NULL, 'TIGR04086', NULL, NULL, 11215, 22),
(288051, NULL, 'TIGR01657', NULL, NULL, 'P-ATPase-V: P-type ATPase of unknown pump specificity (type V)', NULL, 'TIGR01657', NULL, NULL, 460, 22),
(288052, NULL, 'TIGR01886', NULL, NULL, 'dipeptidase: dipeptidase PepV', NULL, 'TIGR01886', NULL, NULL, 10221, 22),
(288053, NULL, 'TIGR00502', NULL, NULL, 'nagB: glucosamine-6-phosphate deaminase', NULL, 'TIGR00502', NULL, NULL, 660, 22),
(288054, NULL, 'TIGR03311', NULL, NULL, 'Se_dep_XDH: selenium-dependent xanthine dehydrogenase', NULL, 'TIGR03311', NULL, NULL, 17904, 22),
(288055, NULL, 'TIGR04433', NULL, NULL, 'UrcA_uranyl: UrcA family protein', NULL, 'TIGR04433', NULL, NULL, 25077, 22),
(288056, NULL, 'TIGR01598', NULL, NULL, 'holin_phiLC3: holin, phage phi LC3 family', NULL, 'TIGR01598', NULL, NULL, 6173, 22),
(288057, NULL, 'TIGR01221', NULL, NULL, 'rmlC: dTDP-4-dehydrorhamnose 3,5-epimerase', NULL, 'TIGR01221', NULL, NULL, 353, 22),
(288058, NULL, 'TIGR01478', NULL, NULL, 'STEVOR: variant surface antigen, stevor family', NULL, 'TIGR01478', NULL, NULL, 5968, 22),
(288059, NULL, 'TIGR02393', NULL, NULL, 'RpoD_Cterm: RNA polymerase sigma factor RpoD', NULL, 'TIGR02393', NULL, NULL, 9834, 22),
(288060, NULL, 'TIGR01101', NULL, NULL, 'V_ATP_synt_F: V-type ATPase, F subunit', NULL, 'TIGR01101', NULL, NULL, 4797, 22),
(288061, NULL, 'TIGR01682', NULL, NULL, 'moaD: molybdopterin converting factor, subunit 1', NULL, 'TIGR01682', NULL, NULL, NULL, 22),
(288062, NULL, 'TIGR00082', NULL, NULL, 'rbfA: ribosome-binding factor A', NULL, 'TIGR00082', NULL, NULL, 4857, 22),
(288063, NULL, 'TIGR02097', NULL, NULL, 'yccV: hemimethylated DNA binding domain', NULL, 'TIGR02097', NULL, NULL, 10678, 22),
(288064, NULL, 'TIGR00647', NULL, NULL, 'DNA_bind_WhiA: DNA-binding protein WhiA', NULL, 'TIGR00647', NULL, NULL, 3133, 22),
(288065, NULL, 'TIGR03772', NULL, NULL, 'anch_rpt_subst: anchored repeat ABC transporter, substrate-binding protein', NULL, 'TIGR03772', NULL, NULL, 15648, 22),
(288066, NULL, 'TIGR02737', NULL, NULL, 'caa3_CtaG: cytochrome c oxidase assembly factor CtaG', NULL, 'TIGR02737', NULL, NULL, 14031, 22),
(288067, NULL, 'TIGR04483', NULL, NULL, 'D_pro_red_PrdB: D-proline reductase (dithiol), PrdB protein', NULL, 'TIGR04483', NULL, NULL, 14662, 22),
(288068, NULL, 'TIGR00851', NULL, NULL, 'mtlA: PTS system, mannitol-specific IIC component', NULL, 'TIGR00851', NULL, NULL, 3102, 22),
(288069, NULL, 'TIGR04215', NULL, NULL, 'choice_anch_A: choice-of-anchor A domain', NULL, 'TIGR04215', NULL, NULL, 26800, 22),
(288070, NULL, 'TIGR03549', NULL, NULL, 'TIGR03549: YcaO domain protein', NULL, 'TIGR03549', NULL, NULL, 18209, 22),
(288071, NULL, 'TIGR00209', NULL, NULL, 'galT_1: galactose-1-phosphate uridylyltransferase', NULL, 'TIGR00209', NULL, NULL, 4254, 22),
(288072, NULL, 'TIGR04455', NULL, NULL, 'lipo_MXAN_6521: probable lipoprotein, LA_1396/MXAN_6521 family', NULL, 'TIGR04455', NULL, NULL, 26016, 22),
(288073, NULL, 'TIGR00527', NULL, NULL, 'gcvH: glycine cleavage system H protein', NULL, 'TIGR00527', NULL, NULL, 18231, 22),
(288074, NULL, 'TIGR02701', NULL, NULL, 'shell_carb_anhy: carboxysome shell carbonic anhydrase', NULL, 'TIGR02701', NULL, NULL, 13056, 22);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288075, NULL, 'TIGR02365', NULL, NULL, 'dha_L_ycgS: dihydroxyacetone kinase, L subunit', NULL, 'TIGR02365', NULL, NULL, 8602, 22),
(288076, NULL, 'TIGR02522', NULL, NULL, 'pilus_cpaD: pilus (Caulobacter type) biogenesis lipoprotein CpaD', NULL, 'TIGR02522', NULL, NULL, 18968, 22),
(288077, NULL, 'TIGR00275', NULL, NULL, 'TIGR00275: flavoprotein, HI0933 family', NULL, 'TIGR00275', NULL, NULL, 5055, 22),
(288078, NULL, 'TIGR02617', NULL, NULL, 'tnaA_trp_ase: tryptophanase', NULL, 'TIGR02617', NULL, NULL, 9288, 22),
(288079, NULL, 'TIGR02941', NULL, NULL, 'Sigma_B: RNA polymerase sigma-B factor', NULL, 'TIGR02941', NULL, NULL, 8723, 22),
(288080, NULL, 'TIGR00432', NULL, NULL, 'arcsn_tRNA_tgt: tRNA-guanine(15) transglycosylase', NULL, 'TIGR00432', NULL, NULL, 5521, 22),
(288081, NULL, 'TIGR02125', NULL, NULL, 'CytB-hydogenase: Ni/Fe-hydrogenase, b-type cytochrome subunit', NULL, 'TIGR02125', NULL, NULL, 6762, 22),
(288082, NULL, 'TIGR03624', NULL, NULL, 'TIGR03624: putative hydrolase', NULL, 'TIGR03624', NULL, NULL, 18201, 22),
(288083, NULL, 'TIGR00016', NULL, NULL, 'ackA: acetate kinase', NULL, 'TIGR00016', NULL, NULL, 5234, 22),
(288084, NULL, 'TIGR03892', NULL, NULL, 'thiopep_precurs: thiazolylpeptide-type bacteriocin precursor', NULL, 'TIGR03892', NULL, NULL, 18321, 22),
(288085, NULL, 'TIGR01442', NULL, NULL, 'SASP_gamma: small, acid-soluble spore protein, gamma-type', NULL, 'TIGR01442', NULL, NULL, 4765, 22),
(288086, NULL, 'TIGR03182', NULL, NULL, 'PDH_E1_alph_y: pyruvate dehydrogenase (acetyl-transferring) E1 component, alpha subunit', NULL, 'TIGR03182', NULL, NULL, 15647, 22),
(288087, NULL, 'TIGR03532', NULL, NULL, 'DapD_Ac: 2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-acetyltransferase', NULL, 'TIGR03532', NULL, NULL, 16997, 22),
(288088, NULL, 'TIGR01092', NULL, NULL, 'P5CS: delta l-pyrroline-5-carboxylate synthetase', NULL, 'TIGR01092', NULL, NULL, 4778, 22),
(288089, NULL, 'TIGR01534', NULL, NULL, 'GAPDH-I: glyceraldehyde-3-phosphate dehydrogenase, type I', NULL, 'TIGR01534', NULL, NULL, 6766, 22),
(288090, NULL, 'TIGR03280', NULL, NULL, 'methan_mark_11: methanogenesis imperfect marker protein 11', NULL, 'TIGR03280', NULL, NULL, 17629, 22),
(288091, NULL, 'TIGR00887', NULL, NULL, '2A0109: phosphate:H+ symporter', NULL, 'TIGR00887', NULL, NULL, 5192, 22),
(288092, NULL, 'TIGR02835', NULL, NULL, 'spore_sigmaE: RNA polymerase sigma-E factor', NULL, 'TIGR02835', NULL, NULL, 9163, 22),
(288093, NULL, 'TIGR02231', NULL, NULL, 'TIGR02231: conserved hypothetical protein', NULL, 'TIGR02231', NULL, NULL, 11006, 22),
(288094, NULL, 'TIGR02488', NULL, NULL, 'flgG_G_neg: flagellar basal-body rod protein FlgG', NULL, 'TIGR02488', NULL, NULL, 12536, 22),
(288095, NULL, 'TIGR00865', NULL, NULL, 'bcl-2: apoptosis regulator', NULL, 'TIGR00865', NULL, NULL, 3865, 22),
(288096, NULL, 'TIGR00795', NULL, NULL, 'lctP: transporter, lactate permease (LctP) family', NULL, 'TIGR00795', NULL, NULL, 3157, 22),
(288097, NULL, 'TIGR00552', NULL, NULL, 'nadE: NAD+ synthetase', NULL, 'TIGR00552', NULL, NULL, 1517, 22),
(288098, NULL, 'TIGR01026', NULL, NULL, 'fliI_yscN: ATPase, FliI/YscN family', NULL, 'TIGR01026', NULL, NULL, 3872, 22),
(288099, NULL, 'TIGR01777', NULL, NULL, 'yfcH: TIGR01777 family protein', NULL, 'TIGR01777', NULL, NULL, 2017, 22),
(288100, NULL, 'TIGR00524', NULL, NULL, 'eIF-2B_rel: eIF-2B alpha/beta/delta-related uncharacterized proteins', NULL, 'TIGR00524', NULL, NULL, 11110, 22),
(288101, NULL, 'TIGR01897', NULL, NULL, 'cas_MJ1666: CRISPR-associated protein, MJ1666 family', NULL, 'TIGR01897', NULL, NULL, 10920, 22),
(288102, NULL, 'TIGR01934', NULL, NULL, 'MenG_MenH_UbiE: ubiquinone/menaquinone biosynthesis methyltransferase', NULL, 'TIGR01934', NULL, NULL, 838, 22),
(288103, NULL, 'TIGR04201', NULL, NULL, 'Myxo_Cys_RPT: Cys-rich repeat, Myxococcales-type', NULL, 'TIGR04201', NULL, NULL, 24346, 22),
(288104, NULL, 'TIGR03196', NULL, NULL, 'pucD: xanthine dehydrogenase D subunit', NULL, 'TIGR03196', NULL, NULL, 16161, 22),
(288105, NULL, 'TIGR00395', NULL, NULL, 'leuS_arch: leucine--tRNA ligase', NULL, 'TIGR00395', NULL, NULL, 1364, 22); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288106, NULL, 'TIGR03970', NULL, NULL, 'Rv0697: dehydrogenase, Rv0697 family', NULL, 'TIGR03970', NULL, NULL, 11437, 22),
(288107, NULL, 'TIGR02539', NULL, NULL, 'SepCysS: O-phospho-L-seryl-tRNA:Cys-tRNA synthase', NULL, 'TIGR02539', NULL, NULL, 11137, 22),
(288108, NULL, 'TIGR02781', NULL, NULL, 'VirB9: P-type conjugative transfer protein VirB9', NULL, 'TIGR02781', NULL, NULL, 14141, 22),
(288109, NULL, 'TIGR04509', NULL, NULL, 'mod_pep_NH_fam: putative modified peptide', NULL, 'TIGR04509', NULL, NULL, 24378, 22),
(288110, NULL, 'TIGR04017', NULL, NULL, 'WcaA: colanic acid biosynthesis glycosyltransferase WcaA', NULL, 'TIGR04017', NULL, NULL, 11980, 22),
(288111, NULL, 'TIGR04083', NULL, NULL, 'rSAM_pep_methan: putative peptide-modifying radical SAM enzyme, Mhun_1560 family', NULL, 'TIGR04083', NULL, NULL, 11908, 22),
(288112, NULL, 'TIGR03747', NULL, NULL, 'conj_TIGR03747: integrating conjugative element membrane protein, PFL_4697 family', NULL, 'TIGR03747', NULL, NULL, 15786, 22),
(288113, NULL, 'TIGR01235', NULL, NULL, 'pyruv_carbox: pyruvate carboxylase', NULL, 'TIGR01235', NULL, NULL, 319, 22),
(288114, NULL, 'TIGR00329', NULL, NULL, 'gcp_kae1: metallohydrolase, glycoprotease/Kae1 family', NULL, 'TIGR00329', NULL, NULL, 18859, 22),
(288115, NULL, 'TIGR01811', NULL, NULL, 'sdhA_Bsu: succinate dehydrogenase or fumarate reductase, flavoprotein subunit', NULL, 'TIGR01811', NULL, NULL, 10462, 22),
(288116, NULL, 'TIGR04240', NULL, NULL, 'flavi_E_stem: flavivirus envelope glycoprotein E, stem/anchor domain', NULL, 'TIGR04240', NULL, NULL, 25136, 22),
(288117, NULL, 'TIGR00767', NULL, NULL, 'rho: transcription termination factor Rho', NULL, 'TIGR00767', NULL, NULL, 2943, 22),
(288118, NULL, 'TIGR01464', NULL, NULL, 'hemE: uroporphyrinogen decarboxylase', NULL, 'TIGR01464', NULL, NULL, 5844, 22),
(288119, NULL, 'TIGR00060', NULL, NULL, 'L18_bact: ribosomal protein uL18', NULL, 'TIGR00060', NULL, NULL, 5796, 22),
(288120, NULL, 'TIGR01562', NULL, NULL, 'FdhE: formate dehydrogenase accessory protein FdhE', NULL, 'TIGR01562', NULL, NULL, 6997, 22),
(288121, NULL, 'TIGR03236', NULL, NULL, 'dnd_assoc_1: DNA phosphorothioation-dependent restriction protein DptG', NULL, 'TIGR03236', NULL, NULL, 16732, 22),
(288122, NULL, 'TIGR03504', NULL, NULL, 'FimV_Cterm: FimV C-terminal domain', NULL, 'TIGR03504', NULL, NULL, 16662, 22),
(288123, NULL, 'TIGR02821', NULL, NULL, 'fghA_ester_D: S-formylglutathione hydrolase', NULL, 'TIGR02821', NULL, NULL, 8761, 22),
(288124, NULL, 'TIGR00139', NULL, NULL, 'h_aconitase: homoaconitase', NULL, 'TIGR00139', NULL, NULL, 7402, 22),
(288125, NULL, 'TIGR03786', NULL, NULL, 'strep_pil_rpt: streptococcal pilin isopeptide linkage domain', NULL, 'TIGR03786', NULL, NULL, 15726, 22),
(288126, NULL, 'TIGR02245', NULL, NULL, 'HAD_IIID1: HAD hydrolase, family IIID', NULL, 'TIGR02245', NULL, NULL, 11174, 22),
(288127, NULL, 'TIGR01788', NULL, NULL, 'Glu-decarb-GAD: glutamate decarboxylase', NULL, 'TIGR01788', NULL, NULL, 2333, 22),
(288128, NULL, 'TIGR00513', NULL, NULL, 'accA: acetyl-CoA carboxylase, carboxyl transferase, alpha subunit', NULL, 'TIGR00513', NULL, NULL, 2312, 22),
(288129, NULL, 'TIGR03895', NULL, NULL, 'protease_PatA: cyanobactin maturation protease, PatA/PatG family', NULL, 'TIGR03895', NULL, NULL, 16953, 22),
(288130, NULL, 'TIGR01771', NULL, NULL, 'L-LDH-NAD: L-lactate dehydrogenase', NULL, 'TIGR01771', NULL, NULL, 10775, 22),
(288131, NULL, 'TIGR03758', NULL, NULL, 'conj_TIGR03758: integrating conjugative element protein, PFL_4701 family', NULL, 'TIGR03758', NULL, NULL, 18731, 22),
(288132, NULL, 'TIGR04469', NULL, NULL, 'CGA_synth_rel: CGA synthase-related protein', NULL, 'TIGR04469', NULL, NULL, 25847, 22),
(288133, NULL, 'TIGR02603', NULL, NULL, 'CxxCH_TIGR02603: putative heme-binding domain', NULL, 'TIGR02603', NULL, NULL, 9133, 22),
(288134, NULL, 'TIGR01668', NULL, NULL, 'YqeG_hyp_ppase: HAD phosphatase, family IIIA', NULL, 'TIGR01668', NULL, NULL, 5381, 22),
(288135, NULL, 'TIGR03314', NULL, NULL, 'Se_ssnA: putative selenium metabolism protein SsnA', NULL, 'TIGR03314', NULL, NULL, 17886, 22);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288136, NULL, 'TIGR03518', NULL, NULL, 'ABC_perm_GldF: gliding motility-associated ABC transporter permease protein GldF', NULL, 'TIGR03518', NULL, NULL, 16525, 22),
(288137, NULL, 'TIGR02379', NULL, NULL, 'ECA_wecE: TDP-4-keto-6-deoxy-D-glucose transaminase', NULL, 'TIGR02379', NULL, NULL, 9577, 22),
(288138, NULL, 'TIGR00940', NULL, NULL, '2a6301s01: monovalent cation:proton antiporter', NULL, 'TIGR00940', NULL, NULL, 4000, 22),
(288139, NULL, 'TIGR00180', NULL, NULL, 'parB_part: ParB/RepB/Spo0J family partition protein', NULL, 'TIGR00180', NULL, NULL, 7232, 22),
(288140, NULL, 'TIGR01224', NULL, NULL, 'hutI: imidazolonepropionase', NULL, 'TIGR01224', NULL, NULL, 9, 22),
(288141, NULL, 'TIGR00820', NULL, NULL, 'zip: ZIP zinc/iron transport family', NULL, 'TIGR00820', NULL, NULL, 3226, 22),
(288142, NULL, 'TIGR02270', NULL, NULL, 'TIGR02270: conserved hypothetical protein', NULL, 'TIGR02270', NULL, NULL, 11288, 22),
(288143, NULL, 'TIGR02910', NULL, NULL, 'sulfite_red_A: sulfite reductase, subunit A', NULL, 'TIGR02910', NULL, NULL, 11059, 22),
(288144, NULL, 'TIGR03638', NULL, NULL, 'cas1_ECOLI: CRISPR-associated endonuclease Cas1, subtype I-E/ECOLI', NULL, 'TIGR03638', NULL, NULL, 14846, 22),
(288145, NULL, 'TIGR02927', NULL, NULL, 'SucB_Actino: 2-oxoglutarate dehydrogenase, E2 component, dihydrolipoamide succinyltransferase', NULL, 'TIGR02927', NULL, NULL, 8514, 22),
(288146, NULL, 'TIGR04137', NULL, NULL, 'Chlam_Ver_rRNA: Chlam_Verruc_Plancto small basic protein', NULL, 'TIGR04137', NULL, NULL, 21068, 22),
(288147, NULL, 'TIGR01115', NULL, NULL, 'pufM: photosynthetic reaction center M subunit', NULL, 'TIGR01115', NULL, NULL, 5726, 22),
(288148, NULL, 'TIGR04120', NULL, NULL, 'DNA_lig_bact: DNA ligase, ATP-dependent, PP_1105 family', NULL, 'TIGR04120', NULL, NULL, 23227, 22),
(288149, NULL, 'TIGR01037', NULL, NULL, 'pyrD_sub1_fam: dihydroorotate dehydrogenase family protein', NULL, 'TIGR01037', NULL, NULL, 4512, 22),
(288150, NULL, 'TIGR03185', NULL, NULL, 'DNA_S_dndD: DNA sulfur modification protein DndD', NULL, 'TIGR03185', NULL, NULL, 15686, 22),
(288151, NULL, 'TIGR00661', NULL, NULL, 'MJ1255: conserved hypothetical protein', NULL, 'TIGR00661', NULL, NULL, 4020, 22),
(288152, NULL, 'TIGR02030', NULL, NULL, 'BchI-ChlI: magnesium chelatase ATPase subunit I', NULL, 'TIGR02030', NULL, NULL, 13134, 22),
(288153, NULL, 'TIGR03987', NULL, NULL, 'TIGR03987: TIGR03987 family protein', NULL, 'TIGR03987', NULL, NULL, 14754, 22),
(288154, NULL, 'TIGR02594', NULL, NULL, 'TIGR02594: TIGR02594 family protein', NULL, 'TIGR02594', NULL, NULL, 9367, 22),
(288155, NULL, 'TIGR02122', NULL, NULL, 'TRAP_TAXI: TRAP transporter solute receptor, TAXI family', NULL, 'TIGR02122', NULL, NULL, 13728, 22),
(288156, NULL, 'TIGR02528', NULL, NULL, 'EutP: ethanolamine utilization protein, EutP', NULL, 'TIGR02528', NULL, NULL, 13116, 22),
(288157, NULL, 'TIGR00985', NULL, NULL, '3a0801s04tom: mitochondrial import receptor subunit', NULL, 'TIGR00985', NULL, NULL, 5326, 22),
(288158, NULL, 'TIGR03359', NULL, NULL, 'VI_chp_6: type VI secretion protein, TIGR03359 family', NULL, 'TIGR03359', NULL, NULL, 7743, 22),
(288159, NULL, 'TIGR01920', NULL, NULL, 'Shik_kin_archae: shikimate kinase', NULL, 'TIGR01920', NULL, NULL, 4456, 22),
(288160, NULL, 'TIGR04212', NULL, NULL, 'GlyGly_RbtA: rhombotarget A', NULL, 'TIGR04212', NULL, NULL, 23196, 22),
(288161, NULL, 'TIGR01344', NULL, NULL, 'malate_syn_A: malate synthase A', NULL, 'TIGR01344', NULL, NULL, 3851, 22),
(288162, NULL, 'TIGR03090', NULL, NULL, 'SASP_tlp: small, acid-soluble spore protein tlp', NULL, 'TIGR03090', NULL, NULL, 14912, 22),
(288163, NULL, 'TIGR01269', NULL, NULL, 'Tyr_3_monoox: tyrosine 3-monooxygenase', NULL, 'TIGR01269', NULL, NULL, 286, 22),
(288164, NULL, 'TIGR02499', NULL, NULL, 'HrpE_YscL_not: type III secretion apparatus protein, HrpE/YscL family', NULL, 'TIGR02499', NULL, NULL, 12803, 22),
(288165, NULL, 'TIGR01453', NULL, NULL, 'grpIintron_endo: group I intron endonuclease', NULL, 'TIGR01453', NULL, NULL, 4809, 22),
(288166, NULL, 'TIGR02955', NULL, NULL, 'TMAO_TorT: TMAO reductase system periplasmic protein TorT', NULL, 'TIGR02955', NULL, NULL, 9665, 22);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288167, NULL, 'TIGR01573', NULL, NULL, 'cas2: CRISPR-associated endonuclease Cas2', NULL, 'TIGR01573', NULL, NULL, 10800, 22),
(288168, NULL, 'TIGR03423', NULL, NULL, 'pbp2_mrdA: penicillin-binding protein 2', NULL, 'TIGR03423', NULL, NULL, 19382, 22),
(288169, NULL, 'TIGR01800', NULL, NULL, 'cit_synth_II: 2-methylcitrate synthase/citrate synthase II', NULL, 'TIGR01800', NULL, NULL, 10027, 22),
(288170, NULL, 'TIGR00005', NULL, NULL, 'rluA_subfam: pseudouridine synthase, RluA family', NULL, 'TIGR00005', NULL, NULL, 11268, 22),
(288171, NULL, 'TIGR03076', NULL, NULL, 'near_not_gcvH: chlamydial GcvH-like protein upstream region protein', NULL, 'TIGR03076', NULL, NULL, 21419, 22),
(288172, NULL, 'TIGR04321', NULL, NULL, 'spiroSPASM: spiro-SPASM protein', NULL, 'TIGR04321', NULL, NULL, 25100, 22),
(288173, NULL, 'TIGR00071', NULL, NULL, 'hisT_truA: tRNA pseudouridine(38-40) synthase', NULL, 'TIGR00071', NULL, NULL, 7190, 22),
(288174, NULL, 'TIGR03116', NULL, NULL, 'cas5_csf3: CRISPR type IV/AFERR-associated protein Csf3', NULL, 'TIGR03116', NULL, NULL, 14906, 22),
(288175, NULL, 'TIGR00999', NULL, NULL, '8a0102: membrane fusion protein cluster 2 protein', NULL, 'TIGR00999', NULL, NULL, 3835, 22),
(288176, NULL, 'TIGR01880', NULL, NULL, 'Ac-peptdase-euk: N-acyl-L-amino-acid amidohydrolase', NULL, 'TIGR01880', NULL, NULL, 10656, 22),
(288177, NULL, 'TIGR02832', NULL, NULL, 'spo_yunB: sporulation protein YunB', NULL, 'TIGR02832', NULL, NULL, 8987, 22),
(288178, NULL, 'TIGR02712', NULL, NULL, 'urea_carbox: urea carboxylase', NULL, 'TIGR02712', NULL, NULL, 14148, 22),
(288179, NULL, 'TIGR03867', NULL, NULL, 'MprA_tail: MprA protease C-terminal rhombosortase-interaction domain', NULL, 'TIGR03867', NULL, NULL, 16235, 22),
(288180, NULL, 'TIGR02485', NULL, NULL, 'CobZ_N-term: precorrin 3B synthase CobZ', NULL, 'TIGR02485', NULL, NULL, 12893, 22),
(288181, NULL, 'TIGR00449', NULL, NULL, 'tgt_general: tRNA-guanine family transglycosylase', NULL, 'TIGR00449', NULL, NULL, 2876, 22),
(288182, NULL, 'TIGR00418', NULL, NULL, 'thrS: threonine--tRNA ligase', NULL, 'TIGR00418', NULL, NULL, 6103, 22),
(288183, NULL, 'TIGR01330', NULL, NULL, 'bisphos_HAL2: 3''(2''),5''-bisphosphate nucleotidase', NULL, 'TIGR01330', NULL, NULL, 3974, 22),
(288184, NULL, 'TIGR04028', NULL, NULL, 'SBP_KPN_01854: ABC transporter substrate binding protein, KPN_01854 family', NULL, 'TIGR04028', NULL, NULL, 18219, 22),
(288185, NULL, 'TIGR04335', NULL, NULL, 'AmmeMemoSam_A: AmmeMemoRadiSam system protein A', NULL, 'TIGR04335', NULL, NULL, 23492, 22),
(288186, NULL, 'TIGR00541', NULL, NULL, 'hisDCase_pyru: histidine decarboxylase, pyruvoyl type', NULL, 'TIGR00541', NULL, NULL, 5098, 22),
(288187, NULL, 'TIGR01696', NULL, NULL, 'deoB: phosphopentomutase', NULL, 'TIGR01696', NULL, NULL, 5455, 22),
(288188, NULL, 'TIGR03881', NULL, NULL, 'KaiC_arch_4: KaiC domain protein, PAE1156 family', NULL, 'TIGR03881', NULL, NULL, 15951, 22),
(288189, NULL, 'TIGR00876', NULL, NULL, 'tal_mycobact: transaldolase', NULL, 'TIGR00876', NULL, NULL, 3698, 22),
(288190, NULL, 'TIGR01389', NULL, NULL, 'recQ: ATP-dependent DNA helicase RecQ', NULL, 'TIGR01389', NULL, NULL, 3630, 22),
(288191, NULL, 'TIGR01906', NULL, NULL, 'integ_TIGR01906: integral membrane protein TIGR01906', NULL, 'TIGR01906', NULL, NULL, 4091, 22),
(288192, NULL, 'TIGR03239', NULL, NULL, 'GarL: 2-dehydro-3-deoxyglucarate aldolase', NULL, 'TIGR03239', NULL, NULL, 16860, 22),
(288193, NULL, 'TIGR02419', NULL, NULL, 'C4_traR_proteo: phage/conjugal plasmid C-4 type zinc finger protein, TraR family', NULL, 'TIGR02419', NULL, NULL, 9722, 22),
(288194, NULL, 'TIGR00194', NULL, NULL, 'uvrC: excinuclease ABC subunit C', NULL, 'TIGR00194', NULL, NULL, 5159, 22),
(288195, NULL, 'TIGR03652', NULL, NULL, 'FeS_repair_RIC: iron-sulfur cluster repair di-iron protein', NULL, 'TIGR03652', NULL, NULL, 11726, 22),
(288196, NULL, 'TIGR03062', NULL, NULL, 'pip_yhgE_Cterm: YhgE/Pip C-terminal domain', NULL, 'TIGR03062', NULL, NULL, 21374, 22),
(288197, NULL, 'TIGR04106', NULL, NULL, 'cas8c_GSU0052: CRISPR-associated protein GSU0052/csb3, Dpsyc system', NULL, 'TIGR04106', NULL, NULL, 22990, 22);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288198, NULL, 'TIGR04564', NULL, NULL, 'Synergist_CTERM: Synergist-CTERM protein sorting domain', NULL, 'TIGR04564', NULL, NULL, 23857, 22),
(288199, NULL, 'TIGR02726', NULL, NULL, 'phenyl_P_delta: phenylphosphate carboxylase, delta subunit', NULL, 'TIGR02726', NULL, NULL, 14080, 22),
(288200, NULL, 'TIGR02648', NULL, NULL, 'rep_term_tus: DNA replication terminus site-binding protein', NULL, 'TIGR02648', NULL, NULL, 7866, 22),
(288201, NULL, 'TIGR02150', NULL, NULL, 'IPP_isom_1: isopentenyl-diphosphate delta-isomerase', NULL, 'TIGR02150', NULL, NULL, 14121, 22),
(288202, NULL, 'TIGR01146', NULL, NULL, 'ATPsyn_F1gamma: ATP synthase F1, gamma subunit', NULL, 'TIGR01146', NULL, NULL, 1624, 22),
(288203, NULL, 'TIGR00633', NULL, NULL, 'xth: exodeoxyribonuclease III (xth)', NULL, 'TIGR00633', NULL, NULL, 4158, 22),
(288204, NULL, 'TIGR00286', NULL, NULL, 'TIGR00286: arginine decarboxylase, pyruvoyl-dependent', NULL, 'TIGR00286', NULL, NULL, 3752, 22),
(288205, NULL, 'TIGR01255', NULL, NULL, 'pyr_form_ly_1: formate acetyltransferase', NULL, 'TIGR01255', NULL, NULL, 386, 22),
(288206, NULL, 'TIGR02707', NULL, NULL, 'butyr_kinase: butyrate kinase', NULL, 'TIGR02707', NULL, NULL, 10655, 22),
(288207, NULL, 'TIGR03931', NULL, NULL, 'T7SS_Rv3446c: type VII secretion-associated protein, Rv3446c family', NULL, 'TIGR03931', NULL, NULL, 16768, 22),
(288208, NULL, 'TIGR00046', NULL, NULL, 'TIGR00046: RNA methyltransferase, RsmE family', NULL, 'TIGR00046', NULL, NULL, 2492, 22),
(288209, NULL, 'TIGR00617', NULL, NULL, 'rpa1: replication factor-a protein 1 (rpa1)', NULL, 'TIGR00617', NULL, NULL, 751, 22),
(288210, NULL, 'TIGR01841', NULL, NULL, 'phasin: phasin family protein', NULL, 'TIGR01841', NULL, NULL, 10874, 22),
(288211, NULL, 'TIGR00720', NULL, NULL, 'sda_mono: L-serine ammonia-lyase', NULL, 'TIGR00720', NULL, NULL, 2672, 22),
(288212, NULL, 'TIGR02256', NULL, NULL, 'ICE_VC0181: conserved hypothetical protein', NULL, 'TIGR02256', NULL, NULL, 11193, 22),
(288213, NULL, 'TIGR02810', NULL, NULL, 'agaZ_gatZ: D-tagatose-bisphosphate aldolase, class II, non-catalytic subunit', NULL, 'TIGR02810', NULL, NULL, 12329, 22),
(288214, NULL, 'TIGR04346', NULL, NULL, 'DotA_TraY: conjugal transfer/type IV secretion protein DotA/TraY', NULL, 'TIGR04346', NULL, NULL, 23522, 22),
(288215, NULL, 'TIGR00359', NULL, NULL, 'cello_pts_IIC: PTS system, cellobiose-specific IIC component', NULL, 'TIGR00359', NULL, NULL, 5430, 22),
(288216, NULL, 'TIGR02136', NULL, NULL, 'ptsS_2: phosphate binding protein', NULL, 'TIGR02136', NULL, NULL, 13748, 22),
(288217, NULL, 'TIGR03828', NULL, NULL, 'pfkB: 1-phosphofructokinase', NULL, 'TIGR03828', NULL, NULL, 15751, 22),
(288218, NULL, 'TIGR04539', NULL, NULL, 'tRNA_cyclodipep: tRNA-dependent cyclodipeptide synthase', NULL, 'TIGR04539', NULL, NULL, 25388, 22),
(288219, NULL, 'TIGR01425', NULL, NULL, 'SRP54_euk: signal recognition particle protein SRP54', NULL, 'TIGR01425', NULL, NULL, 4771, 22),
(288220, NULL, 'TIGR01738', NULL, NULL, 'bioH: pimelyl-[acyl-carrier protein] methyl ester esterase', NULL, 'TIGR01738', NULL, NULL, 2266, 22),
(288221, NULL, 'TIGR02449', NULL, NULL, 'TIGR02449: TIGR02449 family protein', NULL, 'TIGR02449', NULL, NULL, 10609, 22),
(288222, NULL, 'TIGR02994', NULL, NULL, 'ectoine_eutE: ectoine utilization protein EutE', NULL, 'TIGR02994', NULL, NULL, 10428, 22),
(288223, NULL, 'TIGR02279', NULL, NULL, 'PaaC-3OHAcCoADH: 3-hydroxyacyl-CoA dehydrogenase PaaC', NULL, 'TIGR02279', NULL, NULL, 11338, 22),
(288224, NULL, 'TIGR03761', NULL, NULL, 'ICE_PFL4669: integrating conjugative element protein, PFL_4669 family', NULL, 'TIGR03761', NULL, NULL, 7705, 22),
(288225, NULL, 'TIGR02578', NULL, NULL, 'cas_TM1811_Csm1: CRISPR-associated protein Cas10/Csm1, subtype III-A/MTUBE', NULL, 'TIGR02578', NULL, NULL, 9196, 22),
(288226, NULL, 'TIGR04369', NULL, NULL, 'fusion_not_SelD: oxidoreductase/SelD-related fusion protein', NULL, 'TIGR04369', NULL, NULL, 25264, 22),
(288227, NULL, 'TIGR01671', NULL, NULL, 'phage_TIGR01671: phage conserved hypothetical protein TIGR01671', NULL, 'TIGR01671', NULL, NULL, 5101, 22);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288228, NULL, 'TIGR02338', NULL, NULL, 'gimC_beta: prefoldin, beta subunit', NULL, 'TIGR02338', NULL, NULL, 11884, 22),
(288229, NULL, 'TIGR00488', NULL, NULL, 'TIGR00488: putative HD superfamily hydrolase', NULL, 'TIGR00488', NULL, NULL, 11252, 22),
(288230, NULL, 'TIGR04176', NULL, NULL, 'MarR_EPS: EPS-associated transcriptional regulator, MarR family', NULL, 'TIGR04176', NULL, NULL, 21102, 22),
(288231, NULL, 'TIGR02689', NULL, NULL, 'ars_reduc_gluta: arsenate reductase, glutathione/glutaredoxin type', NULL, 'TIGR02689', NULL, NULL, 13119, 22),
(288232, NULL, 'TIGR04428', NULL, NULL, 'B12_rSAM_trp_MT: tryptophan 2-C-methyltransferase', NULL, 'TIGR04428', NULL, NULL, 25993, 22),
(288233, NULL, 'TIGR03418', NULL, NULL, 'chol_sulf_TF: putative choline sulfate-utilization transcription factor', NULL, 'TIGR03418', NULL, NULL, 19148, 22),
(288234, NULL, 'TIGR01328', NULL, NULL, 'met_gam_lyase: methionine gamma-lyase', NULL, 'TIGR01328', NULL, NULL, 3888, 22),
(288235, NULL, 'TIGR02086', NULL, NULL, 'IPMI_arch: 3-isopropylmalate dehydratase, large subunit', NULL, 'TIGR02086', NULL, NULL, 13596, 22),
(288236, NULL, 'TIGR03336', NULL, NULL, 'IOR_alpha: indolepyruvate ferredoxin oxidoreductase, alpha subunit', NULL, 'TIGR03336', NULL, NULL, 17547, 22),
(288237, NULL, 'TIGR01246', NULL, NULL, 'dapE_proteo: succinyl-diaminopimelate desuccinylase', NULL, 'TIGR01246', NULL, NULL, 417, 22),
(288238, NULL, 'TIGR00304', NULL, NULL, 'TIGR00304: TIGR00304 family protein', NULL, 'TIGR00304', NULL, NULL, 5729, 22),
(288239, NULL, 'TIGR00599', NULL, NULL, 'rad18: DNA repair protein rad18', NULL, 'TIGR00599', NULL, NULL, 785, 22),
(288240, NULL, 'TIGR00125', NULL, NULL, 'cyt_tran_rel: cytidyltransferase-like domain', NULL, 'TIGR00125', NULL, NULL, 4469, 22),
(288241, NULL, 'TIGR01627', NULL, NULL, 'A_thal_3515: uncharacterized plant-specific domain TIGR01627', NULL, 'TIGR01627', NULL, NULL, 6980, 22),
(288242, NULL, 'TIGR02265', NULL, NULL, 'Mxa_TIGR02265: Myxococcales-restricted protein, TIGR02265 family', NULL, 'TIGR02265', NULL, NULL, 11870, 22),
(288243, NULL, 'TIGR03820', NULL, NULL, 'lys_2_3_AblA: lysine-2,3-aminomutase', NULL, 'TIGR03820', NULL, NULL, 15545, 22),
(288244, NULL, 'TIGR00728', NULL, NULL, 'OPT_sfam: oligopeptide transporter, OPT superfamily', NULL, 'TIGR00728', NULL, NULL, 4137, 22),
(288245, NULL, 'TIGR04115', NULL, NULL, 'rSAM_Cxxx_rpt: radical SAM peptide maturase, CXXX-repeat target family', NULL, 'TIGR04115', NULL, NULL, 21280, 22),
(288246, NULL, 'TIGR04305', NULL, NULL, 'fol_rel_CADD: putative folate metabolism protein, CADD family', NULL, 'TIGR04305', NULL, NULL, 23476, 22),
(288247, NULL, 'TIGR00761', NULL, NULL, 'argB: acetylglutamate kinase', NULL, 'TIGR00761', NULL, NULL, 2625, 22),
(288248, NULL, 'TIGR02748', NULL, NULL, 'GerC3_HepT: heptaprenyl diphosphate synthase component II', NULL, 'TIGR02748', NULL, NULL, 13585, 22),
(288249, NULL, 'TIGR03649', NULL, NULL, 'ergot_EASG: ergot alkaloid biosynthesis protein, AFUA_2G17970 family', NULL, 'TIGR03649', NULL, NULL, 11647, 22),
(288250, NULL, 'TIGR00951', NULL, NULL, '2A43: lysosomal Cystine Transporter', NULL, 'TIGR00951', NULL, NULL, 4117, 22),
(288251, NULL, 'TIGR02801', NULL, NULL, 'tolR: protein TolR', NULL, 'TIGR02801', NULL, NULL, 8882, 22),
(288252, NULL, 'TIGR02408', NULL, NULL, 'ectoine_ThpD: ectoine hydroxylase', NULL, 'TIGR02408', NULL, NULL, 9889, 22),
(288253, NULL, 'TIGR03752', NULL, NULL, 'conj_TIGR03752: integrating conjugative element protein, PFL_4705 family', NULL, 'TIGR03752', NULL, NULL, 15340, 22),
(288254, NULL, 'TIGR04287', NULL, NULL, 'exosort_XrtK: exosortase K', NULL, 'TIGR04287', NULL, NULL, 26877, 22),
(288255, NULL, 'TIGR02508', NULL, NULL, 'type_III_yscG: type III secretion protein, YscG family', NULL, 'TIGR02508', NULL, NULL, 18889, 22),
(288256, NULL, 'TIGR00105', NULL, NULL, 'L31: ribosomal protein bL31', NULL, 'TIGR00105', NULL, NULL, 5403, 22),
(288257, NULL, 'TIGR01006', NULL, NULL, 'polys_exp_MPA1: polysaccharide export protein, MPA1 family', NULL, 'TIGR01006', NULL, NULL, 3714, 22);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288258, NULL, 'TIGR00591', NULL, NULL, 'phr2: deoxyribodipyrimidine photolyase', NULL, 'TIGR00591', NULL, NULL, 7206, 22),
(288259, NULL, 'TIGR00781', NULL, NULL, 'ccoO: cytochrome c oxidase, cbb3-type, subunit II', NULL, 'TIGR00781', NULL, NULL, 6408, 22),
(288260, NULL, 'TIGR02435', NULL, NULL, 'CobG: precorrin-3B synthase', NULL, 'TIGR02435', NULL, NULL, 11879, 22),
(288261, NULL, 'TIGR01568', NULL, NULL, 'A_thal_3678: uncharacterized plant-specific domain TIGR01568', NULL, 'TIGR01568', NULL, NULL, 6954, 22),
(288262, NULL, 'TIGR03289', NULL, NULL, 'frhB: coenzyme F420 hydrogenase, subunit beta', NULL, 'TIGR03289', NULL, NULL, 17513, 22),
(288263, NULL, 'TIGR03479', NULL, NULL, 'DMSO_red_II_alp: DMSO reductase family type II enzyme, molybdopterin subunit', NULL, 'TIGR03479', NULL, NULL, 19570, 22),
(288264, NULL, 'TIGR04390', NULL, NULL, 'OMP_YaiO_dom: outer membrane protein, YaiO family', NULL, 'TIGR04390', NULL, NULL, 22087, 22),
(288265, NULL, 'TIGR03459', NULL, NULL, 'crt_membr: carotene biosynthesis associated membrane protein', NULL, 'TIGR03459', NULL, NULL, 19434, 22),
(288266, NULL, 'TIGR02631', NULL, NULL, 'xylA_Arthro: xylose isomerase', NULL, 'TIGR02631', NULL, NULL, 9379, 22),
(288267, NULL, 'TIGR00558', NULL, NULL, 'pdxH: pyridoxamine 5''-phosphate oxidase', NULL, 'TIGR00558', NULL, NULL, 5899, 22),
(288268, NULL, 'TIGR03105', NULL, NULL, 'gln_synth_III: glutamine synthetase, type III', NULL, 'TIGR03105', NULL, NULL, 14678, 22),
(288269, NULL, 'TIGR04299', NULL, NULL, 'antiport_PotE: putrescine-ornithine antiporter', NULL, 'TIGR04299', NULL, NULL, 23449, 22),
(288270, NULL, 'TIGR03275', NULL, NULL, 'methan_mark_8: putative methanogenesis marker protein 8', NULL, 'TIGR03275', NULL, NULL, 9961, 22),
(288271, NULL, 'TIGR03861', NULL, NULL, 'phenyl_ABC_PedC: alcohol ABC transporter, permease protein', NULL, 'TIGR03861', NULL, NULL, 15844, 22),
(288272, NULL, 'TIGR00427', NULL, NULL, 'TIGR00427: membrane protein, MarC family', NULL, 'TIGR00427', NULL, NULL, 4895, 22),
(288273, NULL, 'TIGR02066', NULL, NULL, 'dsrB: sulfite reductase, dissimilatory-type beta subunit', NULL, 'TIGR02066', NULL, NULL, 13086, 22),
(288274, NULL, 'TIGR02517', NULL, NULL, 'type_II_gspD: type II secretion system protein D', NULL, 'TIGR02517', NULL, NULL, 18928, 22),
(288275, NULL, 'TIGR00667', NULL, NULL, 'aat: leucyl/phenylalanyl-tRNA--protein transferase', NULL, 'TIGR00667', NULL, NULL, 2216, 22),
(288276, NULL, 'TIGR00910', NULL, NULL, '2A0307_GadC: glutamate:gamma-aminobutyrate antiporter', NULL, 'TIGR00910', NULL, NULL, 5019, 22),
(288277, NULL, 'TIGR01185', NULL, NULL, 'devC: ABC exporter transmembrane subunit, DevC protein', NULL, 'TIGR01185', NULL, NULL, 6991, 22),
(288278, NULL, 'TIGR03035', NULL, NULL, 'trp_arylform: arylformamidase', NULL, 'TIGR03035', NULL, NULL, 20897, 22),
(288279, NULL, 'TIGR00974', NULL, NULL, '3a0107s02c: phosphate ABC transporter, permease protein PstA', NULL, 'TIGR00974', NULL, NULL, 3871, 22),
(288280, NULL, 'TIGR03608', NULL, NULL, 'L_ocin_972_ABC: putative bacteriocin export ABC transporter, lactococcin 972 group', NULL, 'TIGR03608', NULL, NULL, 14796, 22),
(288281, NULL, 'TIGR03582', NULL, NULL, 'EF_0829: PRD domain protein, EF_0829/AHA_3910 family', NULL, 'TIGR03582', NULL, NULL, 17675, 22),
(288282, NULL, 'TIGR04246', NULL, NULL, 'nitrous_NosZ_Gp: nitrous-oxide reductase, Sec-dependent', NULL, 'TIGR04246', NULL, NULL, 25208, 22),
(288283, NULL, 'TIGR04416', NULL, NULL, 'group_II_RT_mat: group II intron reverse transcriptase/maturase', NULL, 'TIGR04416', NULL, NULL, 26683, 22),
(288284, NULL, 'TIGR01492', NULL, NULL, 'CPW_WPC: Plasmodium falciparum CPW-WPC domain', NULL, 'TIGR01492', NULL, NULL, 5501, 22),
(288285, NULL, 'TIGR02156', NULL, NULL, 'PA_CoA_Oxy1: phenylacetate-CoA oxygenase, PaaG subunit', NULL, 'TIGR02156', NULL, NULL, 8818, 22),
(288286, NULL, 'TIGR01378', NULL, NULL, 'thi_PPkinase: thiamine pyrophosphokinase', NULL, 'TIGR01378', NULL, NULL, 3914, 22),
(288287, NULL, 'TIGR02326', NULL, NULL, 'transamin_PhnW: 2-aminoethylphosphonate--pyruvate transaminase', NULL, 'TIGR02326', NULL, NULL, 11594, 22);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288288, NULL, 'TIGR03037', NULL, NULL, 'anthran_nbaC: 3-hydroxyanthranilate 3,4-dioxygenase', NULL, 'TIGR03037', NULL, NULL, 8899, 22),
(288289, NULL, 'TIGR01001', NULL, NULL, 'metA: homoserine O-succinyltransferase', NULL, 'TIGR01001', NULL, NULL, 3973, 22),
(288290, NULL, 'TIGR01548', NULL, NULL, 'HAD-SF-IA-hyp1: HAD hydrolase, TIGR01548 family', NULL, 'TIGR01548', NULL, NULL, 6922, 22),
(288291, NULL, 'TIGR00549', NULL, NULL, 'mevalon_kin: mevalonate kinase', NULL, 'TIGR00549', NULL, NULL, 11129, 22),
(288292, NULL, 'TIGR00837', NULL, NULL, 'araaP: aromatic amino acid transport protein', NULL, 'TIGR00837', NULL, NULL, 12262, 22),
(288293, NULL, 'TIGR03205', NULL, NULL, 'pimA: dicarboxylate--CoA ligase PimA', NULL, 'TIGR03205', NULL, NULL, 16127, 22),
(288294, NULL, 'TIGR03693', NULL, NULL, 'ocin_ThiF_like: putative thiazole-containing bacteriocin maturation protein', NULL, 'TIGR03693', NULL, NULL, 21087, 22),
(288295, NULL, 'TIGR01076', NULL, NULL, 'sortase_fam: sortase', NULL, 'TIGR01076', NULL, NULL, 4953, 22),
(288296, NULL, 'TIGR01900', NULL, NULL, 'dapE-gram_pos: succinyl-diaminopimelate desuccinylase', NULL, 'TIGR01900', NULL, NULL, 10843, 22),
(288297, NULL, 'TIGR01662', NULL, NULL, 'HAD-SF-IIIA: HAD hydrolase, family IIIA', NULL, 'TIGR01662', NULL, NULL, 486, 22),
(288298, NULL, 'TIGR01187', NULL, NULL, 'potA: polyamine ABC transporter, ATP-binding protein', NULL, 'TIGR01187', NULL, NULL, 6740, 22),
(288299, NULL, 'TIGR01518', NULL, NULL, 'g3p_cytidyltrns: glycerol-3-phosphate cytidylyltransferase', NULL, 'TIGR01518', NULL, NULL, 5735, 22),
(288300, NULL, 'TIGR00032', NULL, NULL, 'argG: argininosuccinate synthase', NULL, 'TIGR00032', NULL, NULL, 3432, 22),
(288301, NULL, 'TIGR01806', NULL, NULL, 'CM_mono2: putative chorismate mutase', NULL, 'TIGR01806', NULL, NULL, 698, 22),
(288302, NULL, 'TIGR04006', NULL, NULL, 'wcaK: colanic acid biosynthesis pyruvyl transferase WcaK', NULL, 'TIGR04006', NULL, NULL, 85, 22),
(288303, NULL, 'TIGR03951', NULL, NULL, 'Fe_III_red_FhuF: siderophore-iron reductase FhuF', NULL, 'TIGR03951', NULL, NULL, 6388, 22),
(288304, NULL, 'TIGR02980', NULL, NULL, 'SigBFG: RNA polymerase sigma-70 factor, sigma-B/F/G subfamily', NULL, 'TIGR02980', NULL, NULL, 9987, 22),
(288305, NULL, 'TIGR03146', NULL, NULL, 'cyt_nit_nrfB: cytochrome c nitrite reductase, pentaheme subunit', NULL, 'TIGR03146', NULL, NULL, 15040, 22),
(288306, NULL, 'TIGR00658', NULL, NULL, 'orni_carb_tr: ornithine carbamoyltransferase', NULL, 'TIGR00658', NULL, NULL, 180, 22),
(288307, NULL, 'TIGR01296', NULL, NULL, 'asd_B: aspartate-semialdehyde dehydrogenase', NULL, 'TIGR01296', NULL, NULL, 1234, 22),
(288308, NULL, 'TIGR02798', NULL, NULL, 'ligK_PcmE: 4-carboxy-4-hydroxy-2-oxoadipate aldolase/oxaloacetate decarboxylase', NULL, 'TIGR02798', NULL, NULL, 14172, 22),
(288309, NULL, 'TIGR02885', NULL, NULL, 'spore_sigF: RNA polymerase sigma-F factor', NULL, 'TIGR02885', NULL, NULL, 10991, 22),
(288310, NULL, 'TIGR03717', NULL, NULL, 'R_switched_YjbE: integral membrane protein, YjbE family', NULL, 'TIGR03717', NULL, NULL, 15702, 22),
(288311, NULL, 'TIGR01730', NULL, NULL, 'RND_mfp: efflux transporter, RND family, MFP subunit', NULL, 'TIGR01730', NULL, NULL, 10427, 22),
(288312, NULL, 'TIGR04237', NULL, NULL, 'seadorna_VP9: seadornavirus/coltivirus VP9 protein', NULL, 'TIGR04237', NULL, NULL, 8568, 22),
(288313, NULL, 'TIGR04355', NULL, NULL, 'HprK_rel_B: HprK-related kinase B', NULL, 'TIGR04355', NULL, NULL, 23151, 22),
(288314, NULL, 'TIGR02215', NULL, NULL, 'phage_chp_gp8: phage conserved hypothetical protein, phiE125 gp8 family', NULL, 'TIGR02215', NULL, NULL, 11587, 22),
(288315, NULL, 'TIGR00726', NULL, NULL, 'TIGR00726: YfiH family protein', NULL, 'TIGR00726', NULL, NULL, 2018, 22),
(288316, NULL, 'TIGR04478', NULL, NULL, 'rSAM_YfkAB: radical SAM/CxCxxxxC motif protein YfkAB', NULL, 'TIGR04478', NULL, NULL, 25225, 22),
(288317, NULL, 'TIGR00379', NULL, NULL, 'cobB: cobyrinic acid a,c-diamide synthase', NULL, 'TIGR00379', NULL, NULL, 1453, 22),
(288318, NULL, 'TIGR01780', NULL, NULL, 'SSADH: succinate-semialdehyde dehydrogenase', NULL, 'TIGR01780', NULL, NULL, 2260, 22);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288319, NULL, 'TIGR02871', NULL, NULL, 'spore_ylbJ: sporulation integral membrane protein YlbJ', NULL, 'TIGR02871', NULL, NULL, 10560, 22),
(288320, NULL, 'TIGR00318', NULL, NULL, 'cyaB: putative adenylyl cyclase CyaB', NULL, 'TIGR00318', NULL, NULL, 7134, 22),
(288321, NULL, 'TIGR03023', NULL, NULL, 'WcaJ_sugtrans: undecaprenyl-phosphate glucose phosphotransferase', NULL, 'TIGR03023', NULL, NULL, 20943, 22),
(288322, NULL, 'TIGR04525', NULL, NULL, 'prot_M_MG281: IgG-blocking protein M', NULL, 'TIGR04525', NULL, NULL, 25385, 22),
(288323, NULL, 'TIGR04067', NULL, NULL, 'oc_CLOSPO_01332: putative bacteriocin precursor, CLOSPO_01332 family', NULL, 'TIGR04067', NULL, NULL, 10568, 22),
(288324, NULL, 'TIGR02229', NULL, NULL, 'caa3_sub_IV: caa(3)-type oxidase, subunit IV', NULL, 'TIGR02229', NULL, NULL, 11743, 22),
(288325, NULL, 'TIGR04414', NULL, NULL, 'hepto_Aah_TibC: autotransporter strand-loop-strand O-heptosyltransferase', NULL, 'TIGR04414', NULL, NULL, 26037, 22),
(288326, NULL, 'TIGR01355', NULL, NULL, 'cyt_deam_dimer: cytidine deaminase', NULL, 'TIGR01355', NULL, NULL, 3590, 22),
(288327, NULL, 'TIGR02503', NULL, NULL, 'type_III_SycN: type III secretion chaperone SycN', NULL, 'TIGR02503', NULL, NULL, 12746, 22),
(288328, NULL, 'TIGR02982', NULL, NULL, 'heterocyst_DevA: ABC exporter ATP-binding subunit, DevA family', NULL, 'TIGR02982', NULL, NULL, 9715, 22),
(288329, NULL, 'TIGR03658', NULL, NULL, 'IsdH_HarA: haptoglobin-binding heme uptake protein HarA', NULL, 'TIGR03658', NULL, NULL, 18056, 22),
(288330, NULL, 'TIGR01369', NULL, NULL, 'CPSaseII_lrg: carbamoyl-phosphate synthase, large subunit', NULL, 'TIGR01369', NULL, NULL, 3896, 22),
(288331, NULL, 'TIGR02052', NULL, NULL, 'MerP: mercuric transport protein periplasmic component', NULL, 'TIGR02052', NULL, NULL, 13304, 22),
(288332, NULL, 'TIGR00155', NULL, NULL, 'pqiA_fam: integral membrane protein, PqiA family', NULL, 'TIGR00155', NULL, NULL, 11235, 22),
(288333, NULL, 'TIGR03691', NULL, NULL, '20S_bact_alpha: proteasome, alpha subunit', NULL, 'TIGR03691', NULL, NULL, 15399, 22),
(288334, NULL, 'TIGR01015', NULL, NULL, 'hmgA: homogentisate 1,2-dioxygenase', NULL, 'TIGR01015', NULL, NULL, 3838, 22),
(288335, NULL, 'TIGR03085', NULL, NULL, 'TIGR03085: TIGR03085 family protein', NULL, 'TIGR03085', NULL, NULL, 14757, 22),
(288336, NULL, 'TIGR03965', NULL, NULL, 'mycofact_glyco: mycofactocin system glycosyltransferase', NULL, 'TIGR03965', NULL, NULL, 11119, 22),
(288337, NULL, 'TIGR01929', NULL, NULL, 'menB: naphthoate synthase', NULL, 'TIGR01929', NULL, NULL, 4274, 22),
(288338, NULL, 'TIGR04142', NULL, NULL, 'PCisTranLspir: putative peptidyl-prolyl cis-trans isomerase, LIC12922 family', NULL, 'TIGR04142', NULL, NULL, 21292, 22),
(288339, NULL, 'TIGR01875', NULL, NULL, 'cas_MJ0381: CRISPR-associated autoregulator DevR family', NULL, 'TIGR01875', NULL, NULL, 10997, 22),
(288340, NULL, 'TIGR03568', NULL, NULL, 'NeuC_NnaA: UDP-N-acetyl-D-glucosamine 2-epimerase, UDP-hydrolysing', NULL, 'TIGR03568', NULL, NULL, 11874, 22),
(288341, NULL, 'TIGR00284', NULL, NULL, 'TIGR00284: dihydropteroate synthase-related protein', NULL, 'TIGR00284', NULL, NULL, 11178, 22),
(288342, NULL, 'TIGR00924', NULL, NULL, 'yjdL_sub1_fam: amino acid/peptide transporter (Peptide:H+ symporter)', NULL, 'TIGR00924', NULL, NULL, 4327, 22),
(288343, NULL, 'TIGR01240', NULL, NULL, 'mevDPdecarb: diphosphomevalonate decarboxylase', NULL, 'TIGR01240', NULL, NULL, 24482, 22),
(288344, NULL, 'TIGR02080', NULL, NULL, 'O_succ_thio_ly: O-succinylhomoserine (thiol)-lyase', NULL, 'TIGR02080', NULL, NULL, 13810, 22),
(288345, NULL, 'TIGR03901', NULL, NULL, 'MYXO-CTERM: MYXO-CTERM domain', NULL, 'TIGR03901', NULL, NULL, 11712, 22),
(288346, NULL, 'TIGR03330', NULL, NULL, 'SAM_DCase_Bsu: S-adenosylmethionine decarboxylase proenzyme', NULL, 'TIGR03330', NULL, NULL, 17570, 22),
(288347, NULL, 'TIGR01165', NULL, NULL, 'cbiN: cobalt transport protein', NULL, 'TIGR01165', NULL, NULL, 6373, 22),
(288348, NULL, 'TIGR03227', NULL, NULL, 'PhnS: 2-aminoethylphosphonate ABC transporter, 2-aminoethylphosphonate binding protein', NULL, 'TIGR03227', NULL, NULL, 16829, 22);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288349, NULL, 'TIGR04170', NULL, NULL, 'RNR_1b_NrdE: ribonucleoside-diphosphate reductase, class 1b, alpha subunit', NULL, 'TIGR04170', NULL, NULL, 23353, 22),
(288350, NULL, 'TIGR01137', NULL, NULL, 'cysta_beta: cystathionine beta-synthase', NULL, 'TIGR01137', NULL, NULL, 6850, 22),
(288351, NULL, 'TIGR01219', NULL, NULL, 'Pmev_kin_ERG8: phosphomevalonate kinase', NULL, 'TIGR01219', NULL, NULL, 9241, 22),
(288352, NULL, 'TIGR03309', NULL, NULL, 'matur_yqeB: selenium-dependent molybdenum hydroxylase system protein, YqeB family', NULL, 'TIGR03309', NULL, NULL, 17737, 22),
(288353, NULL, 'TIGR03057', NULL, NULL, 'xxxLxxG_by_4: X-X-X-Leu-X-X-Gly heptad repeats', NULL, 'TIGR03057', NULL, NULL, 18247, 22),
(288354, NULL, 'TIGR00611', NULL, NULL, 'recf: DNA replication and repair protein RecF', NULL, 'TIGR00611', NULL, NULL, 814, 22),
(288355, NULL, 'TIGR03883', NULL, NULL, 'DUF2342_F420: uncharacterized protein, coenzyme F420 biosynthesis associated', NULL, 'TIGR03883', NULL, NULL, 15796, 22),
(288356, NULL, 'TIGR01423', NULL, NULL, 'trypano_reduc: trypanothione-disulfide reductase', NULL, 'TIGR01423', NULL, NULL, 4141, 22),
(288357, NULL, 'TIGR01553', NULL, NULL, 'formate-DH-alph: formate dehydrogenase-N alpha subunit', NULL, 'TIGR01553', NULL, NULL, 6747, 22),
(288358, NULL, 'TIGR02816', NULL, NULL, 'pfaB_fam: PfaB family protein', NULL, 'TIGR02816', NULL, NULL, 8691, 22),
(288359, NULL, 'TIGR03643', NULL, NULL, 'TIGR03643: TIGR03643 family protein', NULL, 'TIGR03643', NULL, NULL, 18375, 22),
(288360, NULL, 'TIGR01793', NULL, NULL, 'cit_synth_euk: citrate (Si)-synthase, eukaryotic', NULL, 'TIGR01793', NULL, NULL, 2192, 22),
(288361, NULL, 'TIGR01950', NULL, NULL, 'SoxR: redox-sensitive transcriptional activator SoxR', NULL, 'TIGR01950', NULL, NULL, 4175, 22),
(288362, NULL, 'TIGR02250', NULL, NULL, 'FCP1_euk: FCP1-like phosphatase, phosphatase domain', NULL, 'TIGR02250', NULL, NULL, 11209, 22),
(288363, NULL, 'TIGR02374', NULL, NULL, 'nitri_red_nirB: nitrite reductase [NAD(P)H], large subunit', NULL, 'TIGR02374', NULL, NULL, 8629, 22),
(288364, NULL, 'TIGR00870', NULL, NULL, 'trp: transient-receptor-potential calcium channel protein', NULL, 'TIGR00870', NULL, NULL, NULL, 22),
(288365, NULL, 'TIGR01629', NULL, NULL, 'rep_II_X: phage/plasmid replication protein, gene II/X family', NULL, 'TIGR01629', NULL, NULL, 6623, 22),
(288366, NULL, 'TIGR03398', NULL, NULL, 'plc_access_R: phospholipase C accessory protein PlcR', NULL, 'TIGR03398', NULL, NULL, 18893, 22),
(288367, NULL, 'TIGR04464', NULL, NULL, 'chaper_lep: LipL41-expression chaperone Lep', NULL, 'TIGR04464', NULL, NULL, 25552, 22),
(288368, NULL, 'TIGR02106', NULL, NULL, 'cyd_oper_ybgT: cyd operon protein YbgT', NULL, 'TIGR02106', NULL, NULL, 10692, 22),
(288369, NULL, 'TIGR02960', NULL, NULL, 'SigX5: RNA polymerase sigma-70 factor, TIGR02960 family', NULL, 'TIGR02960', NULL, NULL, 9586, 22),
(288370, NULL, 'TIGR01459', NULL, NULL, 'HAD-SF-IIA-hyp4: HAD hydrolase, TIGR01459 family', NULL, 'TIGR01459', NULL, NULL, 4983, 22),
(288371, NULL, 'TIGR02790', NULL, NULL, 'nickel_nikC: nickel ABC transporter, permease subunit NikC', NULL, 'TIGR02790', NULL, NULL, 14371, 22),
(288372, NULL, 'TIGR03473', NULL, NULL, 'HpnK: hopanoid biosynthesis associated protein HpnK', NULL, 'TIGR03473', NULL, NULL, 19790, 22),
(288373, NULL, 'TIGR01437', NULL, NULL, 'selA_rel: uncharacterized pyridoxal phosphate-dependent enzyme', NULL, 'TIGR01437', NULL, NULL, 4572, 22),
(288374, NULL, 'TIGR03767', NULL, NULL, 'P_acnes_RR: metallophosphoesterase, PPA1498 family', NULL, 'TIGR03767', NULL, NULL, 16372, 22),
(288375, NULL, 'TIGR02939', NULL, NULL, 'RpoE_Sigma70: RNA polymerase sigma factor RpoE', NULL, 'TIGR02939', NULL, NULL, 8593, 22),
(288376, NULL, 'TIGR01110', NULL, NULL, 'mdcA: malonate decarboxylase, alpha subunit', NULL, 'TIGR01110', NULL, NULL, 4876, 22),
(288377, NULL, 'TIGR04095', NULL, NULL, 'dnd_restrict_1: DNA phosphorothioation system restriction enzyme', NULL, 'TIGR04095', NULL, NULL, 15564, 22),
(288378, NULL, 'TIGR02558', NULL, NULL, 'HrpB2: type III secretion protein HrpB2', NULL, 'TIGR02558', NULL, NULL, 11350, 22); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288379, NULL, 'TIGR04101', NULL, NULL, 'CCGSCS: CCGSCS motif protein', NULL, 'TIGR04101', NULL, NULL, 23301, 22),
(288380, NULL, 'TIGR01070', NULL, NULL, 'mutS1: DNA mismatch repair protein MutS', NULL, 'TIGR01070', NULL, NULL, 4837, 22),
(288381, NULL, 'TIGR01124', NULL, NULL, 'ilvA_2Cterm: threonine ammonia-lyase, biosynthetic', NULL, 'TIGR01124', NULL, NULL, 5927, 22),
(288382, NULL, 'TIGR03132', NULL, NULL, 'malonate_mdcB: triphosphoribosyl-dephospho-CoA synthase MdcB', NULL, 'TIGR03132', NULL, NULL, 14610, 22),
(288383, NULL, 'TIGR00454', NULL, NULL, 'TIGR00454: TIGR00454 family protein', NULL, 'TIGR00454', NULL, NULL, 11314, 22),
(288384, NULL, 'TIGR01607', NULL, NULL, 'PST-A: Plasmodium subtelomeric family', NULL, 'TIGR01607', NULL, NULL, 6072, 22),
(288385, NULL, 'TIGR04319', NULL, NULL, 'SerAla_Lrha_rpt: surface protein repeat Ser-Ala-175', NULL, 'TIGR04319', NULL, NULL, 25086, 22),
(288386, NULL, 'TIGR03098', NULL, NULL, 'ligase_PEP_1: acyl-CoA ligase (AMP-forming), exosortase A-associated', NULL, 'TIGR03098', NULL, NULL, 14533, 22),
(288387, NULL, 'TIGR00892', NULL, NULL, '2A0113: monocarboxylate transporter', NULL, 'TIGR00892', NULL, NULL, 5295, 22),
(288388, NULL, 'TIGR03255', NULL, NULL, 'PhnV: 2-aminoethylphosphonate ABC transport system, membrane component PhnV', NULL, 'TIGR03255', NULL, NULL, 17344, 22),
(288389, NULL, 'TIGR00413', NULL, NULL, 'rlpA: rare lipoprotein A', NULL, 'TIGR00413', NULL, NULL, 8255, 22),
(288390, NULL, 'TIGR01621', NULL, NULL, 'RluA-like: pseudouridine synthase Rlu family protein, TIGR01621', NULL, 'TIGR01621', NULL, NULL, 7140, 22),
(288391, NULL, 'TIGR03937', NULL, NULL, 'PgaC_IcaA: poly-beta-1,6 N-acetyl-D-glucosamine synthase', NULL, 'TIGR03937', NULL, NULL, 11651, 22),
(288392, NULL, 'TIGR03445', NULL, NULL, 'mycothiol_MshB: N-acetyl-1-D-myo-inositol-2-amino-2-deoxy-alpha-D-glucopyranoside deacetylase', NULL, 'TIGR03445', NULL, NULL, 19265, 22),
(288393, NULL, 'TIGR02134', NULL, NULL, 'transald_staph: transaldolase', NULL, 'TIGR02134', NULL, NULL, 13609, 22),
(288394, NULL, 'TIGR01915', NULL, NULL, 'npdG: NADPH-dependent F420 reductase', NULL, 'TIGR01915', NULL, NULL, 4256, 22),
(288395, NULL, 'TIGR02932', NULL, NULL, 'vnfK_nitrog: V-containing nitrogenase, beta subunit', NULL, 'TIGR02932', NULL, NULL, 8812, 22),
(288396, NULL, 'TIGR03602', NULL, NULL, 'streptolysinS: bacteriocin protoxin, streptolysin S family', NULL, 'TIGR03602', NULL, NULL, 14808, 22),
(288397, NULL, 'TIGR01752', NULL, NULL, 'flav_long: flavodoxin', NULL, 'TIGR01752', NULL, NULL, 2392, 22),
(288398, NULL, 'TIGR02572', NULL, NULL, 'LcrR: type III secretion system regulator LcrR', NULL, 'TIGR02572', NULL, NULL, 9482, 22),
(288399, NULL, 'TIGR01922', NULL, NULL, 'purO_arch: IMP cyclohydrolase', NULL, 'TIGR01922', NULL, NULL, 4180, 22),
(288400, NULL, 'TIGR02304', NULL, NULL, 'aden_form_hyp: putative adenylate-forming enzyme', NULL, 'TIGR02304', NULL, NULL, 11933, 22),
(288401, NULL, 'TIGR02762', NULL, NULL, 'TraL_TIGR: type IV conjugative transfer system protein TraL', NULL, 'TIGR02762', NULL, NULL, 13325, 22),
(288402, NULL, 'TIGR02088', NULL, NULL, 'LEU3_arch: isopropylmalate/isohomocitrate dehydrogenases', NULL, 'TIGR02088', NULL, NULL, 13567, 22),
(288403, NULL, 'TIGR01151', NULL, NULL, 'psbA: photosystem II q(b) protein', NULL, 'TIGR01151', NULL, NULL, 6523, 22),
(288404, NULL, 'TIGR01205', NULL, NULL, 'D_ala_D_alaTIGR: D-alanine--D-alanine ligase', NULL, 'TIGR01205', NULL, NULL, 487, 22),
(288405, NULL, 'TIGR00236', NULL, NULL, 'wecB: UDP-N-acetylglucosamine 2-epimerase', NULL, 'TIGR00236', NULL, NULL, 23720, 22),
(288406, NULL, 'TIGR02497', NULL, NULL, 'yscI_hrpB_dom: type III secretion apparatus protein, YscI/HrpB, C-terminal domain', NULL, 'TIGR02497', NULL, NULL, 12765, 22),
(288407, NULL, 'TIGR00373', NULL, NULL, 'TIGR00373: transcription factor E', NULL, 'TIGR00373', NULL, NULL, 15345, 22),
(288408, NULL, 'TIGR04210', NULL, NULL, 'bunya_NSm: bunyavirus nonstructural protein NSm', NULL, 'TIGR04210', NULL, NULL, 21012, 22),
(288409, NULL, 'TIGR03001', NULL, NULL, 'Sig-70_gmx1: RNA polymerase sigma-70 factor, Myxococcales family 1', NULL, 'TIGR03001', NULL, NULL, 11942, 22);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288410, NULL, 'TIGR04396', NULL, NULL, 'surf_polysacc: surface carbohydrate biosynthesis protein', NULL, 'TIGR04396', NULL, NULL, 25460, 22),
(288411, NULL, 'TIGR02946', NULL, NULL, 'acyl_WS_DGAT: acyltransferase, WS/DGAT/MGAT', NULL, 'TIGR02946', NULL, NULL, 8585, 22),
(288412, NULL, 'TIGR03241', NULL, NULL, 'arg_catab_astB: succinylarginine dihydrolase', NULL, 'TIGR03241', NULL, NULL, 394, 22),
(288413, NULL, 'TIGR04156', NULL, NULL, 'cyanoexo_CrtB: cyanoexosortase B', NULL, 'TIGR04156', NULL, NULL, 23022, 22),
(288414, NULL, 'TIGR03897', NULL, NULL, 'lanti_2_LanM: type 2 lantibiotic biosynthesis protein LanM', NULL, 'TIGR03897', NULL, NULL, 20589, 22),
(288415, NULL, 'TIGR03520', NULL, NULL, 'GldE: gliding motility-associated protein GldE', NULL, 'TIGR03520', NULL, NULL, 16541, 22),
(288416, NULL, 'TIGR02742', NULL, NULL, 'TrbC_Ftype: type-F conjugative transfer system pilin assembly protein TrbC', NULL, 'TIGR02742', NULL, NULL, 13763, 22),
(288417, NULL, 'TIGR01512', NULL, NULL, 'ATPase-IB2_Cd: cadmium-translocating P-type ATPase', NULL, 'TIGR01512', NULL, NULL, NULL, 22),
(288418, NULL, 'TIGR02639', NULL, NULL, 'ClpA: ATP-dependent Clp protease ATP-binding subunit ClpA', NULL, 'TIGR02639', NULL, NULL, 9410, 22),
(288419, NULL, 'TIGR03711', NULL, NULL, 'acc_sec_asp3: accessory Sec system protein Asp3', NULL, 'TIGR03711', NULL, NULL, 15687, 22),
(288420, NULL, 'TIGR03636', NULL, NULL, 'uL23_arch: ribosomal protein uL23', NULL, 'TIGR03636', NULL, NULL, 17498, 22),
(288421, NULL, 'TIGR00652', NULL, NULL, 'DapF: diaminopimelate epimerase', NULL, 'TIGR00652', NULL, NULL, 11041, 22),
(288422, NULL, 'TIGR00066', NULL, NULL, 'g_glut_trans: gamma-glutamyltransferase', NULL, 'TIGR00066', NULL, NULL, 2662, 22),
(288423, NULL, 'TIGR00706', NULL, NULL, 'SppA_dom: signal peptide peptidase SppA, 36K type', NULL, 'TIGR00706', NULL, NULL, 2259, 22),
(288424, NULL, 'TIGR04231', NULL, NULL, 'seadorna_VP5: seadornavirus VP5 protein', NULL, 'TIGR04231', NULL, NULL, 24700, 22),
(288425, NULL, 'TIGR02141', NULL, NULL, 'modB_ABC: molybdate ABC transporter, permease protein', NULL, 'TIGR02141', NULL, NULL, 13687, 22),
(288426, NULL, 'TIGR01861', NULL, NULL, 'ANFD: nitrogenase iron-iron protein, alpha chain', NULL, 'TIGR01861', NULL, NULL, 10389, 22),
(288427, NULL, 'TIGR01956', NULL, NULL, 'NusG_myco: NusG family protein', NULL, 'TIGR01956', NULL, NULL, 4242, 22),
(288428, NULL, 'TIGR02381', NULL, NULL, 'cspD: cold shock domain protein CspD', NULL, 'TIGR02381', NULL, NULL, 9536, 22),
(288429, NULL, 'TIGR03071', NULL, NULL, 'couple_hipA: HipA N-terminal domain', NULL, 'TIGR03071', NULL, NULL, 21238, 22),
(288430, NULL, 'TIGR01233', NULL, NULL, 'lacG: 6-phospho-beta-galactosidase', NULL, 'TIGR01233', NULL, NULL, 312, 22),
(288431, NULL, 'TIGR02469', NULL, NULL, 'CbiT: precorrin-6Y C5,15-methyltransferase (decarboxylating), CbiT subunit', NULL, 'TIGR02469', NULL, NULL, 17568, 22),
(288432, NULL, 'TIGR00801', NULL, NULL, 'ncs2: uracil-xanthine permease', NULL, 'TIGR00801', NULL, NULL, 2535, 22),
(288433, NULL, 'TIGR00298', NULL, NULL, 'TIGR00298: 2-phosphosulfolactate phosphatase', NULL, 'TIGR00298', NULL, NULL, 24894, 22),
(288434, NULL, 'TIGR01314', NULL, NULL, 'gntK_FGGY: gluconate kinase', NULL, 'TIGR01314', NULL, NULL, 1280, 22),
(288435, NULL, 'TIGR04559', NULL, NULL, 'SoxH_rel_PQQ_2: quinoprotein relay system zinc metallohydrolase 2', NULL, 'TIGR04559', NULL, NULL, 23820, 22),
(288436, NULL, 'TIGR02011', NULL, NULL, 'IscA: iron-sulfur cluster assembly protein IscA', NULL, 'TIGR02011', NULL, NULL, 10006, 22),
(288437, NULL, 'TIGR03166', NULL, NULL, 'alt_F1F0_F1_eps: alternate F1F0 ATPase, F1 subunit epsilon', NULL, 'TIGR03166', NULL, NULL, 11910, 22),
(288438, NULL, 'TIGR02388', NULL, NULL, 'rpoC2_cyan: DNA-directed RNA polymerase, beta'''' subunit', NULL, 'TIGR02388', NULL, NULL, 9603, 22),
(288439, NULL, 'TIGR03404', NULL, NULL, 'bicupin_oxalic: bicupin, oxalate decarboxylase family', NULL, 'TIGR03404', NULL, NULL, 19130, 22),
(288440, NULL, 'TIGR03876', NULL, NULL, 'cas_csaX: CRISPR type I-A/APERN-associated protein CsaX', NULL, 'TIGR03876', NULL, NULL, 21140, 22);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288441, NULL, 'TIGR00291', NULL, NULL, 'RNA_SBDS: rRNA metabolism protein, SBDS family', NULL, 'TIGR00291', NULL, NULL, 5214, 22),
(288442, NULL, 'TIGR01786', NULL, NULL, 'TonB-hemlactrns: TonB-dependent hemoglobin/transferrin/lactoferrin receptor family protein', NULL, 'TIGR01786', NULL, NULL, 1615, 22),
(288443, NULL, 'TIGR00543', NULL, NULL, 'isochor_syn: isochorismate synthase', NULL, 'TIGR00543', NULL, NULL, 984, 22),
(288444, NULL, 'TIGR01056', NULL, NULL, 'topB: DNA topoisomerase III', NULL, 'TIGR01056', NULL, NULL, 4588, 22),
(288445, NULL, 'TIGR00468', NULL, NULL, 'pheS: phenylalanine--tRNA ligase, alpha subunit', NULL, 'TIGR00468', NULL, NULL, 1617, 22),
(288446, NULL, 'TIGR02851', NULL, NULL, 'spore_V_T: stage V sporulation protein T', NULL, 'TIGR02851', NULL, NULL, 9335, 22),
(288447, NULL, 'TIGR00175', NULL, NULL, 'mito_nad_idh: isocitrate dehydrogenase, NAD-dependent', NULL, 'TIGR00175', NULL, NULL, 7275, 22),
(288448, NULL, 'TIGR02025', NULL, NULL, 'BchH: magnesium chelatase, H subunit', NULL, 'TIGR02025', NULL, NULL, 13378, 22),
(288449, NULL, 'TIGR00815', NULL, NULL, 'sulP: sulfate permease', NULL, 'TIGR00815', NULL, NULL, 2264, 22),
(288450, NULL, 'TIGR00522', NULL, NULL, 'dph5: diphthine synthase', NULL, 'TIGR00522', NULL, NULL, 977, 22),
(288451, NULL, 'TIGR04061', NULL, NULL, 'AZL_007950_fam: AZL_007950 family protein', NULL, 'TIGR04061', NULL, NULL, 11030, 22),
(288452, NULL, 'TIGR01677', NULL, NULL, 'pln_FAD_oxido: plant-specific FAD-dependent oxidoreductase', NULL, 'TIGR01677', NULL, NULL, 5207, 22),
(288453, NULL, 'TIGR03527', NULL, NULL, 'selenium_YedF: selenium metabolism protein YedF', NULL, 'TIGR03527', NULL, NULL, 16632, 22),
(288454, NULL, 'TIGR04340', NULL, NULL, 'rSAM_ACGX: radical SAM/SPASM domain protein, ACGX system', NULL, 'TIGR04340', NULL, NULL, 26731, 22),
(288455, NULL, 'TIGR00482', NULL, NULL, 'TIGR00482: nicotinate (nicotinamide) nucleotide adenylyltransferase', NULL, 'TIGR00482', NULL, NULL, 11102, 22),
(288456, NULL, 'TIGR00536', NULL, NULL, 'hemK_fam: methyltransferase, HemK family', NULL, 'TIGR00536', NULL, NULL, 954, 22),
(288457, NULL, 'TIGR02197', NULL, NULL, 'heptose_epim: ADP-glyceromanno-heptose 6-epimerase', NULL, 'TIGR02197', NULL, NULL, 12165, 22),
(288458, NULL, 'TIGR03699', NULL, NULL, 'menaquin_MqnC: dehypoxanthine futalosine cyclase', NULL, 'TIGR03699', NULL, NULL, 15775, 22),
(288459, NULL, 'TIGR01042', NULL, NULL, 'V-ATPase_V1_A: V-type ATPase, A subunit', NULL, 'TIGR01042', NULL, NULL, 4601, 22),
(288460, NULL, 'TIGR02544', NULL, NULL, 'III_secr_YscJ: type III secretion apparatus lipoprotein, YscJ/HrcJ family', NULL, 'TIGR02544', NULL, NULL, 3278, 22),
(288461, NULL, 'TIGR00189', NULL, NULL, 'tesB: acyl-CoA thioesterase II', NULL, 'TIGR00189', NULL, NULL, 2268, 22),
(288462, NULL, 'TIGR03194', NULL, NULL, '4hydrxCoA_A: 4-hydroxybenzoyl-CoA reductase, alpha subunit', NULL, 'TIGR03194', NULL, NULL, 16449, 22),
(288463, NULL, 'TIGR03513', NULL, NULL, 'GldL_gliding: gliding motility-associated protein GldL', NULL, 'TIGR03513', NULL, NULL, 18208, 22),
(288464, NULL, 'TIGR01970', NULL, NULL, 'DEAH_box_HrpB: ATP-dependent helicase HrpB', NULL, 'TIGR01970', NULL, NULL, 4281, 22),
(288465, NULL, 'TIGR00508', NULL, NULL, 'bioA: adenosylmethionine-8-amino-7-oxononanoate transaminase', NULL, 'TIGR00508', NULL, NULL, 5680, 22),
(288466, NULL, 'TIGR04033', NULL, NULL, 'export_SdpB: antimicrobial peptide system protein, SdpB family', NULL, 'TIGR04033', NULL, NULL, 16532, 22),
(288467, NULL, 'TIGR02681', NULL, NULL, 'phage_pRha: phage regulatory protein, Rha family', NULL, 'TIGR02681', NULL, NULL, 13332, 22),
(288468, NULL, 'TIGR01028', NULL, NULL, 'uS7_euk_arch: ribosomal protein uS7', NULL, 'TIGR01028', NULL, NULL, 3566, 22),
(288469, NULL, 'TIGR02667', NULL, NULL, 'moaB_proteo: molybdenum cofactor biosynthesis protein B', NULL, 'TIGR02667', NULL, NULL, 10343, 22),
(288470, NULL, 'TIGR03350', NULL, NULL, 'type_VI_ompA: type VI secretion system peptidoglycan-associated domain', NULL, 'TIGR03350', NULL, NULL, 18332, 22),
(288471, NULL, 'TIGR04224', NULL, NULL, 'ser_adhes_Nterm: serine-rich repeat adhesion glycoprotein', NULL, 'TIGR04224', NULL, NULL, 25231, 22);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288472, NULL, 'TIGR02490', NULL, NULL, 'flgF: flagellar basal-body rod protein FlgF', NULL, 'TIGR02490', NULL, NULL, 12574, 22),
(288473, NULL, 'TIGR03364', NULL, NULL, 'HpnW_proposed: FAD dependent oxidoreductase TIGR03364', NULL, 'TIGR03364', NULL, NULL, 18025, 22),
(288474, NULL, 'TIGR01847', NULL, NULL, 'bacteriocin_sig: bacteriocin-type signal sequence', NULL, 'TIGR01847', NULL, NULL, 10935, 22),
(288475, NULL, 'TIGR03992', NULL, NULL, 'Arch_glmU: UDP-N-acetylglucosamine diphosphorylase/glucosamine-1-phosphate N-acetyltransferase', NULL, 'TIGR03992', NULL, NULL, 18360, 22),
(288476, NULL, 'TIGR01984', NULL, NULL, 'UbiH: 2-polyprenyl-6-methoxyphenol 4-hydroxylase', NULL, 'TIGR01984', NULL, NULL, 10078, 22),
(288477, NULL, 'TIGR03534', NULL, NULL, 'RF_mod_PrmC: protein-(glutamine-N5) methyltransferase, release factor-specific', NULL, 'TIGR03534', NULL, NULL, 16594, 22),
(288478, NULL, 'TIGR04047', NULL, NULL, 'MSMEG_0565_glyc: glycosyltransferase, MSMEG_0565 family', NULL, 'TIGR04047', NULL, NULL, 11025, 22),
(288479, NULL, 'TIGR03999', NULL, NULL, 'thiol_BshA: N-acetyl-alpha-D-glucosaminyl L-malate synthase BshA', NULL, 'TIGR03999', NULL, NULL, 9697, 22),
(288480, NULL, 'TIGR00345', NULL, NULL, 'GET3_arsA_TRC40: transport-energizing ATPase, TRC40/GET3/ArsA family', NULL, 'TIGR00345', NULL, NULL, 19641, 22),
(288481, NULL, 'TIGR03502', NULL, NULL, 'lipase_Pla1_cef: extracellular lipase, Pla-1/cef family', NULL, 'TIGR03502', NULL, NULL, 16891, 22),
(288482, NULL, 'TIGR04140', NULL, NULL, 'chp_AF_0576: TIGR04140 family protein', NULL, 'TIGR04140', NULL, NULL, 23293, 22),
(288483, NULL, 'TIGR03622', NULL, NULL, 'urea_t_UrtB_arc: urea ABC transporter, permease protein UrtB', NULL, 'TIGR03622', NULL, NULL, 15420, 22),
(288484, NULL, 'TIGR04020', NULL, NULL, 'seco_metab_LLM: natural product biosynthesis luciferase-like monooxygenase domain', NULL, 'TIGR04020', NULL, NULL, 11725, 22),
(288485, NULL, 'TIGR01412', NULL, NULL, 'tat_substr_1: Tat-translocated enzyme', NULL, 'TIGR01412', NULL, NULL, 4587, 22),
(288486, NULL, 'TIGR01564', NULL, NULL, 'S_layer_MJ: S-layer protein', NULL, 'TIGR01564', NULL, NULL, 6597, 22),
(288487, NULL, 'TIGR00926', NULL, NULL, '2A1704: oligopeptide transporter, peptide:H+ symporter', NULL, 'TIGR00926', NULL, NULL, 5070, 22),
(288488, NULL, 'TIGR01532', NULL, NULL, 'E4PD_g-proteo: erythrose-4-phosphate dehydrogenase', NULL, 'TIGR01532', NULL, NULL, 6843, 22),
(288489, NULL, 'TIGR04292', NULL, NULL, 'heavy_Cys_CGP: heavy-Cys/CGP-CTERM domain protein', NULL, 'TIGR04292', NULL, NULL, 26982, 22),
(288490, NULL, 'TIGR02395', NULL, NULL, 'rpoN_sigma: RNA polymerase sigma-54 factor', NULL, 'TIGR02395', NULL, NULL, 4668, 22),
(288491, NULL, 'TIGR01877', NULL, NULL, 'cas_cas6: CRISPR-associated endoribonuclease Cas6', NULL, 'TIGR01877', NULL, NULL, 10582, 22),
(288492, NULL, 'TIGR04485', NULL, NULL, 'thiosulf_SoxX: sulfur oxidation c-type cytochrome SoxX', NULL, 'TIGR04485', NULL, NULL, 21974, 22),
(288493, NULL, 'TIGR03654', NULL, NULL, 'L6_bact: ribosomal protein uL6', NULL, 'TIGR03654', NULL, NULL, 11815, 22),
(288494, NULL, 'TIGR04172', NULL, NULL, 'DGQHR_dnd_1: DNA phosphorothioation-associated DGQHR protein 1', NULL, 'TIGR04172', NULL, NULL, 23286, 22),
(288495, NULL, 'TIGR03967', NULL, NULL, 'mycofact_MftB: putative mycofactocin binding protein MftB', NULL, 'TIGR03967', NULL, NULL, 16833, 22),
(288496, NULL, 'TIGR02082', NULL, NULL, 'metH: methionine synthase', NULL, 'TIGR02082', NULL, NULL, 13937, 22),
(288497, NULL, 'TIGR00765', NULL, NULL, 'yihY_not_rbn: YihY family inner membrane protein', NULL, 'TIGR00765', NULL, NULL, 18826, 22),
(288498, NULL, 'TIGR04421', NULL, NULL, 'FemAB_IMCC1989: FemAB family protein', NULL, 'TIGR04421', NULL, NULL, 24714, 22),
(288499, NULL, 'TIGR00393', NULL, NULL, 'kpsF: sugar isomerase, KpsF/GutQ family', NULL, 'TIGR00393', NULL, NULL, 5990, 22),
(288500, NULL, 'TIGR03221', NULL, NULL, 'muco_delta: muconolactone delta-isomerase', NULL, 'TIGR03221', NULL, NULL, 6058, 22),
(288501, NULL, 'TIGR04301', NULL, NULL, 'ODC_inducible: ornithine decarboxylase SpeF', NULL, 'TIGR04301', NULL, NULL, 23086, 22);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288502, NULL, 'TIGR02331', NULL, NULL, 'rib_alpha: Rib/alpha/Esp surface antigen repeat', NULL, 'TIGR02331', NULL, NULL, 11808, 22),
(288503, NULL, 'TIGR02483', NULL, NULL, 'PFK_mixed: phosphofructokinase', NULL, 'TIGR02483', NULL, NULL, 12951, 22),
(288504, NULL, 'TIGR02855', NULL, NULL, 'spore_yabG: sporulation peptidase YabG', NULL, 'TIGR02855', NULL, NULL, 12124, 22),
(288505, NULL, 'TIGR02823', NULL, NULL, 'oxido_YhdH: putative quinone oxidoreductase, YhdH/YhfP family', NULL, 'TIGR02823', NULL, NULL, 8645, 22),
(288506, NULL, 'TIGR02211', NULL, NULL, 'LolD_lipo_ex: lipoprotein releasing system, ATP-binding protein', NULL, 'TIGR02211', NULL, NULL, 11073, 22),
(288507, NULL, 'TIGR00121', NULL, NULL, 'birA_ligase: biotin--[acetyl-CoA-carboxylase] ligase', NULL, 'TIGR00121', NULL, NULL, 5951, 22),
(288508, NULL, 'TIGR02735', NULL, NULL, 'purC_vibrio: phosphoribosylaminoimidazole-succinocarboxamide synthase', NULL, 'TIGR02735', NULL, NULL, 14215, 22),
(288509, NULL, 'TIGR01596', NULL, NULL, 'cas3_HD: CRISPR-associated endonuclease Cas3-HD', NULL, 'TIGR01596', NULL, NULL, 6120, 22),
(288510, NULL, 'TIGR00586', NULL, NULL, 'mutt: mutator mutT protein', NULL, 'TIGR00586', NULL, NULL, 6075, 22),
(288511, NULL, 'TIGR03686', NULL, NULL, 'pupylate_PafA: Pup--protein ligase', NULL, 'TIGR03686', NULL, NULL, 15497, 22),
(288512, NULL, 'TIGR03935', NULL, NULL, 'fragilysin: fragilysin', NULL, 'TIGR03935', NULL, NULL, 4486, 22),
(288513, NULL, 'TIGR00733', NULL, NULL, 'TIGR00733: oligopeptide transporter, OPT family', NULL, 'TIGR00733', NULL, NULL, 4403, 22),
(288514, NULL, 'TIGR01904', NULL, NULL, 'GSu_C4xC__C2xCH: Geobacter sulfurreducens CxxxxCH...CXXCH domain', NULL, 'TIGR01904', NULL, NULL, 4049, 22),
(288515, NULL, 'TIGR03162', NULL, NULL, 'ribazole_cobC: alpha-ribazole phosphatase', NULL, 'TIGR03162', NULL, NULL, 15568, 22),
(288516, NULL, 'TIGR03493', NULL, NULL, 'cellullose_BcsF: celllulose biosynthesis operon protein BcsF/YhjT', NULL, 'TIGR03493', NULL, NULL, 16779, 22),
(288517, NULL, 'TIGR02050', NULL, NULL, 'gshA_cyan_rel: carboxylate-amine ligase, YbdK family', NULL, 'TIGR02050', NULL, NULL, 13350, 22),
(288518, NULL, 'TIGR01131', NULL, NULL, 'ATP_synt_6_or_A: ATP synthase F0, A subunit', NULL, 'TIGR01131', NULL, NULL, 5815, 22),
(288519, NULL, 'TIGR01845', NULL, NULL, 'outer_NodT: efflux transporter, outer membrane factor (OMF) lipoprotein, NodT family', NULL, 'TIGR01845', NULL, NULL, 10534, 22),
(288520, NULL, 'TIGR03130', NULL, NULL, 'malonate_delta: malonate decarboxylase acyl carrier protein', NULL, 'TIGR03130', NULL, NULL, 11810, 22),
(288521, NULL, 'TIGR03060', NULL, NULL, 'PS_II_psb29: photosystem II biogenesis protein Psp29', NULL, 'TIGR03060', NULL, NULL, 20523, 22),
(288522, NULL, 'TIGR00434', NULL, NULL, 'cysH: phosophoadenylyl-sulfate reductase', NULL, 'TIGR00434', NULL, NULL, 1912, 22),
(288523, NULL, 'TIGR01072', NULL, NULL, 'murA: UDP-N-acetylglucosamine 1-carboxyvinyltransferase', NULL, 'TIGR01072', NULL, NULL, 4695, 22),
(288524, NULL, 'TIGR03092', NULL, NULL, 'SASP_sspI: small, acid-soluble spore protein I', NULL, 'TIGR03092', NULL, NULL, 14562, 22),
(288525, NULL, 'TIGR03282', NULL, NULL, 'methan_mark_13: putative methanogenesis marker 13 metalloprotein', NULL, 'TIGR03282', NULL, NULL, 17551, 22),
(288526, NULL, 'TIGR02422', NULL, NULL, 'protocat_beta: protocatechuate 3,4-dioxygenase, beta subunit', NULL, 'TIGR02422', NULL, NULL, 9955, 22),
(288527, NULL, 'TIGR00899', NULL, NULL, '2A0120: sugar efflux transporter', NULL, 'TIGR00899', NULL, NULL, 5355, 22),
(288528, NULL, 'TIGR02644', NULL, NULL, 'Y_phosphoryl: pyrimidine-nucleoside phosphorylase', NULL, 'TIGR02644', NULL, NULL, 20991, 22),
(288529, NULL, 'TIGR03595', NULL, NULL, 'Obg_CgtA_exten: Obg family GTPase CgtA, C-terminal extension', NULL, 'TIGR03595', NULL, NULL, 13354, 22),
(288530, NULL, 'TIGR02925', NULL, NULL, 'cis_trans_EpsD: peptidyl-prolyl cis-trans isomerase, EpsD family', NULL, 'TIGR02925', NULL, NULL, 8624, 22),
(288531, NULL, 'TIGR00452', NULL, NULL, 'TIGR00452: tRNA (mo5U34)-methyltransferase', NULL, 'TIGR00452', NULL, NULL, 5500, 22);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288532, NULL, 'TIGR01936', NULL, NULL, 'nqrA: NADH:ubiquinone oxidoreductase, Na(+)-translocating, A subunit', NULL, 'TIGR01936', NULL, NULL, 13060, 22),
(288533, NULL, 'TIGR02796', NULL, NULL, 'tolQ: protein TolQ', NULL, 'TIGR02796', NULL, NULL, 14460, 22),
(288534, NULL, 'TIGR03713', NULL, NULL, 'acc_sec_asp1: accessory Sec system protein Asp1', NULL, 'TIGR03713', NULL, NULL, 15268, 22),
(288535, NULL, 'TIGR01353', NULL, NULL, 'dGTP_triPase: putative dGTPase', NULL, 'TIGR01353', NULL, NULL, 3739, 22),
(288536, NULL, 'TIGR04351', NULL, NULL, 'TOMM_nitrile_2: putative TOMM peptide', NULL, 'TIGR04351', NULL, NULL, 22998, 22),
(288537, NULL, 'TIGR03341', NULL, NULL, 'YhgI_GntY: IscR-regulated protein YhgI', NULL, 'TIGR03341', NULL, NULL, 18160, 22),
(288538, NULL, 'TIGR02363', NULL, NULL, 'dhaK1: dihydroxyacetone kinase, DhaK subunit', NULL, 'TIGR02363', NULL, NULL, 11643, 22),
(288539, NULL, 'TIGR02703', NULL, NULL, 'carboxysome_A: carboxysome peptide A', NULL, 'TIGR02703', NULL, NULL, 13294, 22),
(288540, NULL, 'TIGR03373', NULL, NULL, 'VI_minor_4: type VI secretion-associated protein, BMA_A0400 family', NULL, 'TIGR03373', NULL, NULL, 18663, 22),
(288541, NULL, 'TIGR00171', NULL, NULL, 'leuD: 3-isopropylmalate dehydratase, small subunit', NULL, 'TIGR00171', NULL, NULL, 7146, 22),
(288542, NULL, 'TIGR01725', NULL, NULL, 'phge_HK97_gp10: phage protein, HK97 gp10 family', NULL, 'TIGR01725', NULL, NULL, 6150, 22),
(288543, NULL, 'TIGR03865', NULL, NULL, 'PQQ_CXXCW: PQQ-dependent catabolism-associated CXXCW motif protein', NULL, 'TIGR03865', NULL, NULL, 14545, 22),
(288544, NULL, 'TIGR01201', NULL, NULL, 'HU_rel: putative DNA-binding protein', NULL, 'TIGR01201', NULL, NULL, 6558, 22),
(288545, NULL, 'TIGR01385', NULL, NULL, 'TFSII: transcription elongation factor S-II', NULL, 'TIGR01385', NULL, NULL, 3686, 22),
(288546, NULL, 'TIGR02887', NULL, NULL, 'spore_ger_x_C: germination protein, Ger(x)C family', NULL, 'TIGR02887', NULL, NULL, 13838, 22),
(288547, NULL, 'TIGR04122', NULL, NULL, 'Xnuc_lig_assoc: putative exonuclease, DNA ligase-associated', NULL, 'TIGR04122', NULL, NULL, 23450, 22),
(288548, NULL, 'TIGR00944', NULL, NULL, '2a6301s04: multicomponent K+:H+antiporter', NULL, 'TIGR00944', NULL, NULL, 5194, 22),
(288549, NULL, 'TIGR01090', NULL, NULL, 'apt: adenine phosphoribosyltransferase', NULL, 'TIGR01090', NULL, NULL, 4928, 22),
(288550, NULL, 'TIGR00715', NULL, NULL, 'precor6x_red: precorrin-6x reductase', NULL, 'TIGR00715', NULL, NULL, 2052, 22),
(288551, NULL, 'TIGR02000', NULL, NULL, 'NifU_proper: Fe-S cluster assembly protein NifU', NULL, 'TIGR02000', NULL, NULL, 5301, 22),
(288552, NULL, 'TIGR01239', NULL, NULL, 'galT_2: galactose-1-phosphate uridylyltransferase', NULL, 'TIGR01239', NULL, NULL, 6770, 22),
(288553, NULL, 'TIGR02120', NULL, NULL, 'GspF: type II secretion system protein F', NULL, 'TIGR02120', NULL, NULL, 13886, 22),
(288554, NULL, 'TIGR04070', NULL, NULL, 'photo_TT_lyase: spore photoproduct lyase', NULL, 'TIGR04070', NULL, NULL, 12271, 22),
(288555, NULL, 'TIGR01119', NULL, NULL, 'lacB: galactose-6-phosphate isomerase, LacB subunit', NULL, 'TIGR01119', NULL, NULL, 5082, 22),
(288556, NULL, 'TIGR01494', NULL, NULL, 'ATPase_P-type: HAD ATPase, P-type, family IC', NULL, 'TIGR01494', NULL, NULL, 3303, 22),
(288557, NULL, 'TIGR04190', NULL, NULL, 'B12_SAM_Ta0216: B12-binding domain/radical SAM domain protein, Ta0216 family', NULL, 'TIGR04190', NULL, NULL, 23493, 22),
(288558, NULL, 'TIGR03552', NULL, NULL, 'F420_cofC: 2-phospho-L-lactate guanylyltransferase', NULL, 'TIGR03552', NULL, NULL, 5110, 22),
(288559, NULL, 'TIGR00976', NULL, NULL, '/NonD: hydrolase CocE/NonD family protein', NULL, 'TIGR00976', NULL, NULL, 3970, 22),
(288560, NULL, 'TIGR01634', NULL, NULL, 'tail_P2_I: phage tail protein I', NULL, 'TIGR01634', NULL, NULL, 366, 22),
(288561, NULL, 'TIGR03724', NULL, NULL, 'arch_bud32: Kae1-associated kinase Bud32', NULL, 'TIGR03724', NULL, NULL, 16317, 22),
(288562, NULL, 'TIGR02914', NULL, NULL, 'EpsI_fam: EpsI family protein', NULL, 'TIGR02914', NULL, NULL, 11462, 22);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288563, NULL, 'TIGR00030', NULL, NULL, 'S21p: ribosomal protein bS21', NULL, 'TIGR00030', NULL, NULL, 4023, 22),
(288564, NULL, 'TIGR02585', NULL, NULL, 'cas_Cst2_DevR: CRISPR-associated protein Cas7/Cst2/DevR, subtype I-B/TNEAP', NULL, 'TIGR02585', NULL, NULL, 9406, 22),
(288565, NULL, 'TIGR01310', NULL, NULL, 'uL30_euk: 60S ribosomal protein uL30', NULL, 'TIGR01310', NULL, NULL, 1489, 22),
(288566, NULL, 'TIGR01666', NULL, NULL, 'YCCS: TIGR01666 family membrane protein', NULL, 'TIGR01666', NULL, NULL, 5478, 22),
(288567, NULL, 'TIGR00094', NULL, NULL, 'tRNA_TruD_broad: tRNA pseudouridine synthase, TruD family', NULL, 'TIGR00094', NULL, NULL, 3207, 22),
(288568, NULL, 'TIGR00375', NULL, NULL, 'TIGR00375: TIGR00375 family protein', NULL, 'TIGR00375', NULL, NULL, 4354, 22),
(288569, NULL, 'TIGR04242', NULL, NULL, 'nodulat_NodC: chitooligosaccharide synthase NodC', NULL, 'TIGR04242', NULL, NULL, 25249, 22),
(288570, NULL, 'TIGR00495', NULL, NULL, 'crvDNA_42K: DNA-binding protein, 42 kDa', NULL, 'TIGR00495', NULL, NULL, 878, 22),
(288571, NULL, 'TIGR02465', NULL, NULL, 'chlorocat_1_2: chlorocatechol 1,2-dioxygenase', NULL, 'TIGR02465', NULL, NULL, 12684, 22),
(288572, NULL, 'TIGR01430', NULL, NULL, 'aden_deam: adenosine deaminase', NULL, 'TIGR01430', NULL, NULL, 4550, 22),
(288573, NULL, 'TIGR04383', NULL, NULL, 'acidic_w_LPXTA: processed acidic surface protein', NULL, 'TIGR04383', NULL, NULL, 23904, 22),
(288574, NULL, 'TIGR00223', NULL, NULL, 'panD: aspartate 1-decarboxylase', NULL, 'TIGR00223', NULL, NULL, 1642, 22),
(288575, NULL, 'TIGR04128', NULL, NULL, 'exoso_Fjoh_1448: exosortase family protein XrtF', NULL, 'TIGR04128', NULL, NULL, 25121, 22),
(288576, NULL, 'TIGR00511', NULL, NULL, 'ribulose_e2b2: ribose-1,5-bisphosphate isomerase, e2b2 family', NULL, 'TIGR00511', NULL, NULL, 11184, 22),
(288577, NULL, 'TIGR03271', NULL, NULL, 'methan_mark_5: putative methanogenesis marker protein 5', NULL, 'TIGR03271', NULL, NULL, 12814, 22),
(288578, NULL, 'TIGR02038', NULL, NULL, 'protease_degS: periplasmic serine peptidase DegS', NULL, 'TIGR02038', NULL, NULL, 13102, 22),
(288579, NULL, 'TIGR03209', NULL, NULL, 'P21_Cbot: transcriptional regulator BotR, P-21', NULL, 'TIGR03209', NULL, NULL, 16227, 22),
(288580, NULL, 'TIGR01895', NULL, NULL, 'cas_Cas5t: CRISPR-associated protein Cas5, subtype I-B/TNEAP', NULL, 'TIGR01895', NULL, NULL, 12931, 22),
(288581, NULL, 'TIGR00835', NULL, NULL, 'agcS: amino acid carrier protein', NULL, 'TIGR00835', NULL, NULL, 3009, 22),
(288582, NULL, 'TIGR02293', NULL, NULL, 'TAS_TIGR02293: putative toxin-antitoxin system antitoxin component, TIGR02293 family', NULL, 'TIGR02293', NULL, NULL, 13074, 22),
(288583, NULL, 'TIGR03788', NULL, NULL, 'marine_srt_targ: marine proteobacterial sortase target protein', NULL, 'TIGR03788', NULL, NULL, 15921, 22),
(288584, NULL, 'TIGR03264', NULL, NULL, 'met_CoM_red_C: methyl-coenzyme M reductase I operon protein C', NULL, 'TIGR03264', NULL, NULL, 1103, 22),
(288585, NULL, 'TIGR03391', NULL, NULL, 'FeS_syn_CsdE: cysteine desulfurase, sulfur acceptor subunit CsdE', NULL, 'TIGR03391', NULL, NULL, 18754, 22),
(288586, NULL, 'TIGR03833', NULL, NULL, 'TIGR03833: conserved hypothetical protein', NULL, 'TIGR03833', NULL, NULL, 19280, 22),
(288587, NULL, 'TIGR03323', NULL, NULL, 'alt_F1F0_F1_gam: alternate F1F0 ATPase, F1 subunit gamma', NULL, 'TIGR03323', NULL, NULL, 17685, 22),
(288588, NULL, 'TIGR02184', NULL, NULL, 'Myco_arth_vir_N: Mycoplasma virulence family signal region', NULL, 'TIGR02184', NULL, NULL, 11778, 22),
(288589, NULL, 'TIGR01947', NULL, NULL, 'rnfG: electron transport complex, RnfABCDGE type, G subunit', NULL, 'TIGR01947', NULL, NULL, 4378, 22),
(288590, NULL, 'TIGR03604', NULL, NULL, 'TOMM_cyclo_SagD: thiazole/oxazole-forming peptide maturase, SagD family component', NULL, 'TIGR03604', NULL, NULL, 22751, 22),
(288591, NULL, 'TIGR02633', NULL, NULL, 'xylG: D-xylose ABC transporter, ATP-binding protein', NULL, 'TIGR02633', NULL, NULL, 9331, 22),
(288592, NULL, 'TIGR02574', NULL, NULL, 'stabl_TIGR02574: putative addiction module component, TIGR02574 family', NULL, 'TIGR02574', NULL, NULL, 9230, 22);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288593, NULL, 'TIGR04523', NULL, NULL, 'Mplasa_alph_rch: helix-rich protein', NULL, 'TIGR04523', NULL, NULL, 25270, 22),
(288594, NULL, 'TIGR00039', NULL, NULL, '6PTHBS: 6-pyruvoyl tetrahydropterin synthase/QueD family protein', NULL, 'TIGR00039', NULL, NULL, 26, 22),
(288595, NULL, 'TIGR04081', NULL, NULL, 'selen_ocin: radical SAM modification target peptide, selenobiotic family', NULL, 'TIGR04081', NULL, NULL, 10756, 22),
(288596, NULL, 'TIGR00554', NULL, NULL, 'panK_bact: pantothenate kinase', NULL, 'TIGR00554', NULL, NULL, 736, 22),
(288597, NULL, 'TIGR01192', NULL, NULL, 'chvA: glucan exporter ATP-binding protein', NULL, 'TIGR01192', NULL, NULL, 6704, 22),
(288598, NULL, 'TIGR00332', NULL, NULL, 'neela_ferrous: desulfoferrodoxin ferrous iron-binding domain', NULL, 'TIGR00332', NULL, NULL, 3681, 22),
(288599, NULL, 'TIGR01022', NULL, NULL, 'rpmJ_bact: ribosomal protein bL36', NULL, 'TIGR01022', NULL, NULL, 6769, 22),
(288600, NULL, 'TIGR01834', NULL, NULL, 'PHA_synth_III_E: poly(R)-hydroxyalkanoic acid synthase, class III, PhaE subunit', NULL, 'TIGR01834', NULL, NULL, 10950, 22),
(288601, NULL, 'TIGR02472', NULL, NULL, 'sucr_P_syn_N: sucrose-phosphate synthase, putative, glycosyltransferase domain', NULL, 'TIGR02472', NULL, NULL, 12949, 22),
(288602, NULL, 'TIGR01487', NULL, NULL, 'Pglycolate_arch: phosphoglycolate phosphatase, TA0175-type', NULL, 'TIGR01487', NULL, NULL, NULL, 22),
(288603, NULL, 'TIGR02989', NULL, NULL, 'Sig-70_gvs1: RNA polymerase sigma-70 factor, Rhodopirellula/Verrucomicrobium family', NULL, 'TIGR02989', NULL, NULL, 10086, 22),
(288604, NULL, 'TIGR02694', NULL, NULL, 'arsenite_ox_S: arsenite oxidase, small subunit', NULL, 'TIGR02694', NULL, NULL, 13132, 22),
(288605, NULL, 'TIGR04183', NULL, NULL, 'Por_Secre_tail: Por secretion system C-terminal sorting domain', NULL, 'TIGR04183', NULL, NULL, 23496, 22),
(288606, NULL, 'TIGR03731', NULL, NULL, 'lantibio_gallid: lantibiotic, gallidermin/nisin family', NULL, 'TIGR03731', NULL, NULL, 2674, 22),
(288607, NULL, 'TIGR04530', NULL, NULL, 'hemophoreRv0203: hemophore', NULL, 'TIGR04530', NULL, NULL, 25479, 22),
(288608, NULL, 'TIGR02524', NULL, NULL, 'dot_icm_DotB: Dot/Icm secretion system ATPase DotB', NULL, 'TIGR02524', NULL, NULL, 18762, 22),
(288609, NULL, 'TIGR03443', NULL, NULL, 'alpha_am_amid: L-aminoadipate-semialdehyde dehydrogenase', NULL, 'TIGR03443', NULL, NULL, 7014, 22),
(288610, NULL, 'TIGR03384', NULL, NULL, 'betaine_BetI: transcriptional repressor BetI', NULL, 'TIGR03384', NULL, NULL, 18885, 22),
(288611, NULL, 'TIGR00273', NULL, NULL, 'TIGR00273: iron-sulfur cluster-binding protein', NULL, 'TIGR00273', NULL, NULL, 7462, 22),
(288612, NULL, 'TIGR01768', NULL, NULL, 'GGGP-family: geranylgeranylglyceryl phosphate synthase family protein', NULL, 'TIGR01768', NULL, NULL, 7128, 22),
(288613, NULL, 'TIGR00613', NULL, NULL, 'reco: DNA repair protein RecO', NULL, 'TIGR00613', NULL, NULL, 2058, 22),
(288614, NULL, 'TIGR00842', NULL, NULL, 'bcct: transporter, betaine/carnitine/choline transporter (BCCT) family', NULL, 'TIGR00842', NULL, NULL, 3667, 22),
(288615, NULL, 'TIGR02753', NULL, NULL, 'sodN: superoxide dismutase, Ni', NULL, 'TIGR02753', NULL, NULL, 13649, 22),
(288616, NULL, 'TIGR04008', NULL, NULL, 'WcaF: colanic acid biosynthesis acetyltransferase WcaF', NULL, 'TIGR04008', NULL, NULL, 15938, 22),
(288617, NULL, 'TIGR01997', NULL, NULL, 'sufA_proteo: FeS assembly scaffold SufA', NULL, 'TIGR01997', NULL, NULL, 10256, 22),
(288618, NULL, 'TIGR01251', NULL, NULL, 'ribP_PPkin: ribose-phosphate diphosphokinase', NULL, 'TIGR01251', NULL, NULL, 231, 22),
(288619, NULL, 'TIGR01827', NULL, NULL, 'gatC_rel: putative Asp-tRNA(Asn)/Glu-tRNA(Gln) amidotransferase, subunit C', NULL, 'TIGR01827', NULL, NULL, 10978, 22),
(288620, NULL, 'TIGR02805', NULL, NULL, 'exbB2: tonB-system energizer ExbB', NULL, 'TIGR02805', NULL, NULL, 8939, 22),
(288621, NULL, 'TIGR02222', NULL, NULL, 'chap_CsaA: export-related chaperone protein CsaA', NULL, 'TIGR02222', NULL, NULL, 543, 22),
(288622, NULL, 'TIGR00797', NULL, NULL, 'matE: MATE efflux family protein', NULL, 'TIGR00797', NULL, NULL, 549, 22);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288623, NULL, 'TIGR02746', NULL, NULL, 'TraC-F-type: type-IV secretion system protein TraC', NULL, 'TIGR02746', NULL, NULL, 13565, 22),
(288624, NULL, 'TIGR01303', NULL, NULL, 'IMP_DH_rel_1: IMP dehydrogenase family protein', NULL, 'TIGR01303', NULL, NULL, 1401, 22),
(288625, NULL, 'TIGR02996', NULL, NULL, 'rpt_mate_G_obs: repeat-companion domain TIGR02996', NULL, 'TIGR02996', NULL, NULL, 10227, 22),
(288626, NULL, 'TIGR02687', NULL, NULL, 'TIGR02687: TIGR02687 family protein', NULL, 'TIGR02687', NULL, NULL, 13059, 22),
(288627, NULL, 'TIGR02567', NULL, NULL, 'YscW: type III secretion system chaperone YscW', NULL, 'TIGR02567', NULL, NULL, NULL, 22),
(288628, NULL, 'TIGR03482', NULL, NULL, 'DMSO_red_II_cha: DMSO reductase family type II enzyme chaperone', NULL, 'TIGR03482', NULL, NULL, 19604, 22),
(288629, NULL, 'TIGR00012', NULL, NULL, 'L29: ribosomal protein uL29', NULL, 'TIGR00012', NULL, NULL, 4326, 22),
(288630, NULL, 'TIGR00597', NULL, NULL, 'rad10: DNA repair protein rad10', NULL, 'TIGR00597', NULL, NULL, 629, 22),
(288631, NULL, 'TIGR01392', NULL, NULL, 'homoserO_Ac_trn: homoserine O-acetyltransferase', NULL, 'TIGR01392', NULL, NULL, 886, 22),
(288632, NULL, 'TIGR02102', NULL, NULL, 'pullulan_Gpos: pullulanase, extracellular', NULL, 'TIGR02102', NULL, NULL, 13634, 22),
(288633, NULL, 'TIGR00722', NULL, NULL, 'ttdA_fumA_fumB: hydrolyase, tartrate alpha subunit/fumarate domain protein, Fe-S type', NULL, 'TIGR00722', NULL, NULL, 2968, 22),
(288634, NULL, 'TIGR01736', NULL, NULL, 'FGAM_synth_II: phosphoribosylformylglycinamidine synthase II', NULL, 'TIGR01736', NULL, NULL, 2328, 22),
(288635, NULL, 'TIGR02683', NULL, NULL, 'upstrm_HI1419: putative addiction module killer protein', NULL, 'TIGR02683', NULL, NULL, 13055, 22),
(288636, NULL, 'TIGR00477', NULL, NULL, 'tehB: tellurite resistance protein TehB', NULL, 'TIGR00477', NULL, NULL, 1828, 22),
(288637, NULL, 'TIGR03826', NULL, NULL, 'YvyF: flagellar operon protein TIGR03826', NULL, 'TIGR03826', NULL, NULL, 15168, 22),
(288638, NULL, 'TIGR00593', NULL, NULL, 'pola: DNA polymerase I', NULL, 'TIGR00593', NULL, NULL, 8387, 22),
(288639, NULL, 'TIGR03486', NULL, NULL, 'cas_csx13_C: CRISPR-associated protein Cas8a1/Csx13, MYXAN subtype, C-terminal region', NULL, 'TIGR03486', NULL, NULL, 21940, 22),
(288640, NULL, 'TIGR04376', NULL, NULL, 'TIGR04376: TIGR04376 family protein', NULL, 'TIGR04376', NULL, NULL, 23187, 22),
(288641, NULL, 'TIGR03366', NULL, NULL, 'HpnZ_proposed: putative phosphonate catabolism associated alcohol dehydrogenase', NULL, 'TIGR03366', NULL, NULL, 18707, 22),
(288642, NULL, 'TIGR01276', NULL, NULL, 'thiB: thiamin/thiamin pyrophosphate ABC transporter, thiamin/thiamin pyrophospate-binding protein', NULL, 'TIGR01276', NULL, NULL, 10, 22),
(288643, NULL, 'TIGR04281', NULL, NULL, 'peripla_PGF_1: putative ABC transporter PGF-CTERM-modified substrate-binding protein', NULL, 'TIGR04281', NULL, NULL, 25066, 22),
(288644, NULL, 'TIGR01396', NULL, NULL, 'FlgB: flagellar basal-body rod protein FlgB', NULL, 'TIGR01396', NULL, NULL, 4832, 22),
(288645, NULL, 'TIGR03706', NULL, NULL, 'exo_poly_only: exopolyphosphatase', NULL, 'TIGR03706', NULL, NULL, 15402, 22),
(288646, NULL, 'TIGR01852', NULL, NULL, 'lipid_A_lpxA: acyl-[acyl-carrier-protein]-UDP-N-acetylglucosamine O-acyltransferase', NULL, 'TIGR01852', NULL, NULL, 10746, 22),
(288647, NULL, 'TIGR03214', NULL, NULL, 'ura-cupin: putative allantoin catabolism protein', NULL, 'TIGR03214', NULL, NULL, 16505, 22),
(288648, NULL, 'TIGR03611', NULL, NULL, 'RutD: pyrimidine utilization protein D', NULL, 'TIGR03611', NULL, NULL, 14894, 22),
(288649, NULL, 'TIGR00445', NULL, NULL, 'mraY: phospho-N-acetylmuramoyl-pentapeptide-transferase', NULL, 'TIGR00445', NULL, NULL, 6217, 22),
(288650, NULL, 'TIGR03450', NULL, NULL, 'mycothiol_INO1: inositol 1-phosphate synthase', NULL, 'TIGR03450', NULL, NULL, 19021, 22),
(288651, NULL, 'TIGR02531', NULL, NULL, 'yecD_yerC: TrpR homolog YerC/YecD', NULL, 'TIGR02531', NULL, NULL, 18852, 22),
(288652, NULL, 'TIGR01521', NULL, NULL, 'FruBisAldo_II_B: fructose-bisphosphate aldolase, class II, Calvin cycle subtype', NULL, 'TIGR01521', NULL, NULL, 5710, 22);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288653, NULL, 'TIGR02093', NULL, NULL, 'P_ylase: glycogen/starch/alpha-glucan phosphorylases', NULL, 'TIGR02093', NULL, NULL, 13568, 22),
(288654, NULL, 'TIGR02535', NULL, NULL, 'hyp_Hser_kinase: proposed homoserine kinase', NULL, 'TIGR02535', NULL, NULL, 906, 22),
(288655, NULL, 'TIGR01616', NULL, NULL, 'nitro_assoc: nitrogenase-associated protein', NULL, 'TIGR01616', NULL, NULL, 6741, 22),
(288656, NULL, 'TIGR03021', NULL, NULL, 'pilP_fam: type IV pilus biogenesis protein PilP', NULL, 'TIGR03021', NULL, NULL, 17421, 22),
(288657, NULL, 'TIGR02191', NULL, NULL, 'RNaseIII: ribonuclease III', NULL, 'TIGR02191', NULL, NULL, 12015, 22),
(288658, NULL, 'TIGR01986', NULL, NULL, 'glut_syn_euk: glutathione synthetase', NULL, 'TIGR01986', NULL, NULL, 2539, 22),
(288659, NULL, 'TIGR02075', NULL, NULL, 'pyrH_bact: UMP kinase', NULL, 'TIGR02075', NULL, NULL, 8973, 22),
(288660, NULL, 'TIGR03577', NULL, NULL, 'EF_0830: conserved hypothetical protein EF_0830/AHA_3911', NULL, 'TIGR03577', NULL, NULL, 17710, 22),
(288661, NULL, 'TIGR03924', NULL, NULL, 'T7SS_EccC_a: type VII secretion protein EccCa', NULL, 'TIGR03924', NULL, NULL, 16652, 22),
(288662, NULL, 'TIGR04339', NULL, NULL, 'PQQ_MSMEG_3727: PQQ system protein', NULL, 'TIGR04339', NULL, NULL, 26624, 22),
(288663, NULL, 'TIGR04117', NULL, NULL, 'Syntroph_Cxxx: Cys-Xaa-Xaa-Xaa repeat radical SAM target protein', NULL, 'TIGR04117', NULL, NULL, 23096, 22),
(288664, NULL, 'TIGR01142', NULL, NULL, 'purT: phosphoribosylglycinamide formyltransferase 2', NULL, 'TIGR01142', NULL, NULL, 6949, 22),
(288665, NULL, 'TIGR03990', NULL, NULL, 'Arch_GlmM: phosphoglucosamine mutase', NULL, 'TIGR03990', NULL, NULL, 12002, 22),
(288666, NULL, 'TIGR04219', NULL, NULL, 'OMP_w_GlyGly: outer membrane protein', NULL, 'TIGR04219', NULL, NULL, 21263, 22),
(288667, NULL, 'TIGR03799', NULL, NULL, 'NOD_PanD_pyr: putative pyridoxal-dependent aspartate 1-decarboxylase', NULL, 'TIGR03799', NULL, NULL, 16260, 22),
(288668, NULL, 'TIGR00159', NULL, NULL, 'TIGR00159: TIGR00159 family protein', NULL, 'TIGR00159', NULL, NULL, 30851, 22),
(288669, NULL, 'TIGR01884', NULL, NULL, 'cas_HTH: CRISPR locus-related DNA-binding protein', NULL, 'TIGR01884', NULL, NULL, 10589, 22),
(288670, NULL, 'TIGR01405', NULL, NULL, 'polC_Gram_pos: DNA polymerase III, alpha subunit, Gram-positive type', NULL, 'TIGR01405', NULL, NULL, 4956, 22),
(288671, NULL, 'TIGR00937', NULL, NULL, '2A51: chromate efflux transporter', NULL, 'TIGR00937', NULL, NULL, 9576, 22),
(288672, NULL, 'TIGR03112', NULL, NULL, '6_pyr_pter_rel: 6-pyruvoyl tetrahydropterin synthase-related domain', NULL, 'TIGR03112', NULL, NULL, 14781, 22),
(288673, NULL, 'TIGR00382', NULL, NULL, 'clpX: ATP-dependent Clp protease, ATP-binding subunit ClpX', NULL, 'TIGR00382', NULL, NULL, 1044, 22),
(288674, NULL, 'TIGR01294', NULL, NULL, 'P_lamban: phospholamban', NULL, 'TIGR01294', NULL, NULL, 1257, 22),
(288675, NULL, 'TIGR03942', NULL, NULL, 'sulfatase_rSAM: anaerobic sulfatase maturase', NULL, 'TIGR03942', NULL, NULL, NULL, 22),
(288676, NULL, 'TIGR02907', NULL, NULL, 'spore_VI_D: stage VI sporulation protein D', NULL, 'TIGR02907', NULL, NULL, 11155, 22),
(288677, NULL, 'TIGR00688', NULL, NULL, 'rarD: protein RarD', NULL, 'TIGR00688', NULL, NULL, 2317, 22),
(288678, NULL, 'TIGR01954', NULL, NULL, 'nusA_Cterm_rpt: transcription termination factor NusA, C-terminal duplication', NULL, 'TIGR01954', NULL, NULL, 4072, 22),
(288679, NULL, 'TIGR03870', NULL, NULL, 'ABC_MoxJ: methanol oxidation system protein MoxJ', NULL, 'TIGR03870', NULL, NULL, 15805, 22),
(288680, NULL, 'TIGR01641', NULL, NULL, 'phageSPP1_gp7: phage head morphogenesis protein, SPP1 gp7 family', NULL, 'TIGR01641', NULL, NULL, 357, 22),
(288681, NULL, 'TIGR04031', NULL, NULL, 'Htur_1727_fam: rSAM-partnered protein, Htur_1727 family', NULL, 'TIGR04031', NULL, NULL, 11021, 22),
(288682, NULL, 'TIGR04285', NULL, NULL, 'nucleoid_noc: nucleoid occlusion protein', NULL, 'TIGR04285', NULL, NULL, 16203, 22),
(288683, NULL, 'TIGR04496', NULL, NULL, 'rSAM_XyeB: radical SAM/SPASM domain peptide maturase, XyeB family', NULL, 'TIGR04496', NULL, NULL, 21679, 22);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288684, NULL, 'TIGR02324', NULL, NULL, 'CP_lyasePhnL: phosphonate C-P lyase system protein PhnL', NULL, 'TIGR02324', NULL, NULL, 11717, 22),
(288685, NULL, 'TIGR00695', NULL, NULL, 'uxuA: mannonate dehydratase', NULL, 'TIGR00695', NULL, NULL, 2373, 22),
(288686, NULL, 'TIGR00230', NULL, NULL, 'sfsA: sugar fermentation stimulation protein', NULL, 'TIGR00230', NULL, NULL, 11383, 22),
(288687, NULL, 'TIGR02147', NULL, NULL, 'Fsuc_second: TIGR02147 family protein', NULL, 'TIGR02147', NULL, NULL, 14283, 22),
(288688, NULL, 'TIGR02651', NULL, NULL, 'RNase_Z: ribonuclease Z', NULL, 'TIGR02651', NULL, NULL, 10166, 22),
(288689, NULL, 'TIGR02415', NULL, NULL, '23BDH: acetoin reductases', NULL, 'TIGR02415', NULL, NULL, 11632, 22),
(288690, NULL, 'TIGR03380', NULL, NULL, 'agmatine_aguA: agmatine deiminase', NULL, 'TIGR03380', NULL, NULL, 18848, 22),
(288691, NULL, 'TIGR04063', NULL, NULL, 'stp3: PEP-CTERM/exosortase A-associated glycosyltransferase, Daro_2409 family', NULL, 'TIGR04063', NULL, NULL, 21316, 22),
(288692, NULL, 'TIGR03334', NULL, NULL, 'IOR_beta: indolepyruvate ferredoxin oxidoreductase, beta subunit', NULL, 'TIGR03334', NULL, NULL, 17797, 22),
(288693, NULL, 'TIGR04410', NULL, NULL, 'Spiro_T2SS_lipo: type II secretion system-associated lipoprotein', NULL, 'TIGR04410', NULL, NULL, 24026, 22),
(288694, NULL, 'TIGR01732', NULL, NULL, 'tiny_TM_bacill: conserved hypothetical protein', NULL, 'TIGR01732', NULL, NULL, 8371, 22),
(288695, NULL, 'TIGR01228', NULL, NULL, 'hutU: urocanate hydratase', NULL, 'TIGR01228', NULL, NULL, 870, 22),
(288696, NULL, 'TIGR03917', NULL, NULL, 'Frankia_40_dom: Frankia-40 domain', NULL, 'TIGR03917', NULL, NULL, 7929, 22),
(288697, NULL, 'TIGR00132', NULL, NULL, 'gatA: aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase, A subunit', NULL, 'TIGR00132', NULL, NULL, 5915, 22),
(288698, NULL, 'TIGR03189', NULL, NULL, 'dienoyl_CoA_hyt: cyclohexa-1,5-dienecarbonyl-CoA hydratase', NULL, 'TIGR03189', NULL, NULL, 15941, 22),
(288699, NULL, 'TIGR00699', NULL, NULL, 'GABAtrns_euk: 4-aminobutyrate aminotransferase', NULL, 'TIGR00699', NULL, NULL, 2261, 22),
(288700, NULL, 'TIGR01099', NULL, NULL, 'galU: UTP--glucose-1-phosphate uridylyltransferase', NULL, 'TIGR01099', NULL, NULL, 4867, 22),
(288701, NULL, 'TIGR03003', NULL, NULL, 'ectoine_ehuD: ectoine/hydroxyectoine ABC transporter, permease protein EhuD', NULL, 'TIGR03003', NULL, NULL, 11202, 22),
(288702, NULL, 'TIGR03123', NULL, NULL, 'one_C_unchar_1: probable H4MPT-linked C1 transfer pathway protein', NULL, 'TIGR03123', NULL, NULL, 3649, 22),
(288703, NULL, 'TIGR03584', NULL, NULL, 'PseF: pseudaminic acid cytidylyltransferase', NULL, 'TIGR03584', NULL, NULL, 11809, 22),
(288704, NULL, 'TIGR02860', NULL, NULL, 'spore_IV_B: stage IV sporulation protein B', NULL, 'TIGR02860', NULL, NULL, 10875, 22),
(288705, NULL, 'TIGR01514', NULL, NULL, 'NAPRTase: nicotinate phosphoribosyltransferase', NULL, 'TIGR01514', NULL, NULL, 5827, 22),
(288706, NULL, 'TIGR01979', NULL, NULL, 'sufS: cysteine desulfurase, SufS family', NULL, 'TIGR01979', NULL, NULL, 2389, 22),
(288707, NULL, 'TIGR00770', NULL, NULL, 'Dcu: transporter, anaerobic C4-dicarboxylate uptake (Dcu) family', NULL, 'TIGR00770', NULL, NULL, 2820, 22),
(288708, NULL, 'TIGR00491', NULL, NULL, 'aIF-2: translation initiation factor aIF-2', NULL, 'TIGR00491', NULL, NULL, 941, 22),
(288709, NULL, 'TIGR04403', NULL, NULL, 'rSAM_skfB: sporulation killing factor system radical SAM maturase', NULL, 'TIGR04403', NULL, NULL, 25560, 22),
(288710, NULL, 'TIGR03468', NULL, NULL, 'HpnG: hopanoid-associated phosphorylase', NULL, 'TIGR03468', NULL, NULL, 19803, 22),
(288711, NULL, 'TIGR00824', NULL, NULL, 'EIIA-man: PTS system, mannose/fructose/sorbose family, IIA component', NULL, 'TIGR00824', NULL, NULL, 11845, 22),
(288712, NULL, 'TIGR02313', NULL, NULL, 'HpaI-NOT-DapA: 2,4-dihydroxyhept-2-ene-1,7-dioic acid aldolase', NULL, 'TIGR02313', NULL, NULL, 11735, 22),
(288713, NULL, 'TIGR01181', NULL, NULL, 'dTDP_gluc_dehyt: dTDP-glucose 4,6-dehydratase', NULL, 'TIGR01181', NULL, NULL, 6694, 22);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288714, NULL, 'TIGR02894', NULL, NULL, 'DNA_bind_RsfA: transcription factor, RsfA family', NULL, 'TIGR02894', NULL, NULL, 10544, 22),
(288715, NULL, 'TIGR01750', NULL, NULL, 'fabZ: beta-hydroxyacyl-(acyl-carrier-protein) dehydratase FabZ', NULL, 'TIGR01750', NULL, NULL, 2074, 22),
(288716, NULL, 'TIGR03928', NULL, NULL, 'T7_EssCb_Firm: type VII secretion protein EssC', NULL, 'TIGR03928', NULL, NULL, 16526, 22),
(288717, NULL, 'TIGR00343', NULL, NULL, 'TIGR00343: pyridoxal 5''-phosphate synthase, synthase subunit Pdx1', NULL, 'TIGR00343', NULL, NULL, 4143, 22),
(288718, NULL, 'TIGR03048', NULL, NULL, 'PS_I_psaC: photosystem I iron-sulfur protein PsaC', NULL, 'TIGR03048', NULL, NULL, 20592, 22),
(288719, NULL, 'TIGR03808', NULL, NULL, 'RR_plus_rpt_1: twin-arg-translocated uncharacterized repeat protein', NULL, 'TIGR03808', NULL, NULL, 15754, 22),
(288720, NULL, 'TIGR01498', NULL, NULL, 'folK: 2-amino-4-hydroxy-6-hydroxymethyldihydropteridine diphosphokinase', NULL, 'TIGR01498', NULL, NULL, 5865, 22),
(288721, NULL, 'TIGR01838', NULL, NULL, 'PHA_synth_I: poly(R)-hydroxyalkanoic acid synthase, class I', NULL, 'TIGR01838', NULL, NULL, 2143, 22),
(288722, NULL, 'TIGR01743', NULL, NULL, 'purR_Bsub: pur operon repressor PurR', NULL, 'TIGR01743', NULL, NULL, 2400, 22),
(288723, NULL, 'TIGR00350', NULL, NULL, 'lytR_cpsA_psr: cell envelope-related function transcriptional attenuator common domain', NULL, 'TIGR00350', NULL, NULL, 7467, 22),
(288724, NULL, 'TIGR04274', NULL, NULL, 'hypoxanDNAglyco: DNA-deoxyinosine glycosylase', NULL, 'TIGR04274', NULL, NULL, 23381, 22),
(288725, NULL, 'TIGR02440', NULL, NULL, 'FadJ: fatty oxidation complex, alpha subunit FadJ', NULL, 'TIGR02440', NULL, NULL, 12882, 22),
(288726, NULL, 'TIGR02898', NULL, NULL, 'spore_YhcN_YlaJ: sporulation lipoprotein, YhcN/YlaJ family', NULL, 'TIGR02898', NULL, NULL, 11368, 22),
(288727, NULL, 'TIGR01174', NULL, NULL, 'ftsA: cell division protein FtsA', NULL, 'TIGR01174', NULL, NULL, 20656, 22),
(288728, NULL, 'TIGR02358', NULL, NULL, 'thia_cytX: putative hydroxymethylpyrimidine transporter CytX', NULL, 'TIGR02358', NULL, NULL, 11930, 22),
(288729, NULL, 'TIGR02669', NULL, NULL, 'SpoIID_LytB: SpoIID/LytB domain', NULL, 'TIGR02669', NULL, NULL, 10477, 22),
(288730, NULL, 'TIGR01439', NULL, NULL, 'lp_hng_hel_AbrB: transcriptional regulator, AbrB family', NULL, 'TIGR01439', NULL, NULL, 46, 22),
(288731, NULL, 'TIGR02204', NULL, NULL, 'MsbA_rel: ABC transporter, permease/ATP-binding protein', NULL, 'TIGR02204', NULL, NULL, 11463, 22),
(288732, NULL, 'TIGR02433', NULL, NULL, 'lysidine_TilS_C: tRNA(Ile)-lysidine synthetase, C-terminal domain', NULL, 'TIGR02433', NULL, NULL, 9843, 22),
(288733, NULL, 'TIGR04448', NULL, NULL, 'creatininase: creatininase', NULL, 'TIGR04448', NULL, NULL, 26040, 22),
(288734, NULL, 'TIGR03529', NULL, NULL, 'GldK_short: gliding motility-associated lipoprotein GldK', NULL, 'TIGR03529', NULL, NULL, 16598, 22),
(288735, NULL, 'TIGR01033', NULL, NULL, 'TIGR01033: DNA-binding regulatory protein, YebC/PmpR family', NULL, 'TIGR01033', NULL, NULL, 5846, 22),
(288736, NULL, 'TIGR00114', NULL, NULL, 'lumazine-synth: 6,7-dimethyl-8-ribityllumazine synthase', NULL, 'TIGR00114', NULL, NULL, 14502, 22),
(288737, NULL, 'TIGR03588', NULL, NULL, 'PseC: UDP-4-amino-4,6-dideoxy-N-acetyl-beta-L-altrosamine transaminase', NULL, 'TIGR03588', NULL, NULL, 11912, 22),
(288738, NULL, 'TIGR00831', NULL, NULL, 'a_cpa1: Na+/H+ antiporter', NULL, 'TIGR00831', NULL, NULL, 3112, 22),
(288739, NULL, 'TIGR00890', NULL, NULL, '2A0111: oxalate/formate antiporter family transporter', NULL, 'TIGR00890', NULL, NULL, 5040, 22),
(288740, NULL, 'TIGR00484', NULL, NULL, 'EF-G: translation elongation factor G', NULL, 'TIGR00484', NULL, NULL, 1630, 22),
(288741, NULL, 'TIGR02249', NULL, NULL, 'integrase_gron: integron integrase', NULL, 'TIGR02249', NULL, NULL, 11217, 22),
(288742, NULL, 'TIGR02129', NULL, NULL, 'hisA_euk: phosphoribosylformimino-5-aminoimidazole carboxamide ribotide isomerase', NULL, 'TIGR02129', NULL, NULL, 13549, 22),
(288743, NULL, 'TIGR02195', NULL, NULL, 'heptsyl_trn_II: lipopolysaccharide heptosyltransferase II', NULL, 'TIGR02195', NULL, NULL, 12286, 22);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288744, NULL, 'TIGR03010', NULL, NULL, 'sulf_tusC_dsrF: sulfur relay protein TusC/DsrF', NULL, 'TIGR03010', NULL, NULL, 20607, 22),
(288745, NULL, 'TIGR03697', NULL, NULL, 'NtcA_cyano: global nitrogen regulator NtcA', NULL, 'TIGR03697', NULL, NULL, 15122, 22),
(288746, NULL, 'TIGR04512', NULL, NULL, 'Mycopla_NOT_gsn: STREFT protein', NULL, 'TIGR04512', NULL, NULL, 25004, 22),
(288747, NULL, 'TIGR01040', NULL, NULL, 'V-ATPase_V1_B: V-type ATPase, B subunit', NULL, 'TIGR01040', NULL, NULL, 4861, 22),
(288748, NULL, 'TIGR02027', NULL, NULL, 'rpoA: DNA-directed RNA polymerase, alpha subunit', NULL, 'TIGR02027', NULL, NULL, 13362, 22),
(288749, NULL, 'TIGR04165', NULL, NULL, 'methano_modCys: Cys-rich peptide, TIGR04165 family', NULL, 'TIGR04165', NULL, NULL, 23251, 22),
(288750, NULL, 'TIGR03232', NULL, NULL, 'benzo_1_2_benB: benzoate 1,2-dioxygenase, small subunit', NULL, 'TIGR03232', NULL, NULL, 16836, 22),
(288751, NULL, 'TIGR04387', NULL, NULL, 'capsid_maj_N4: major capsid protein, N4-gp56 family', NULL, 'TIGR04387', NULL, NULL, NULL, 22),
(288752, NULL, 'TIGR00933', NULL, NULL, '2a38: potassium uptake protein, TrkH family', NULL, 'TIGR00933', NULL, NULL, 5212, 22),
(288753, NULL, 'TIGR00817', NULL, NULL, 'tpt: Tpt phosphate/phosphoenolpyruvate translocator', NULL, 'TIGR00817', NULL, NULL, 3419, 22),
(288754, NULL, 'TIGR00241', NULL, NULL, 'CoA_E_activ: putative CoA-substrate-specific enzyme activase', NULL, 'TIGR00241', NULL, NULL, 6074, 22),
(288755, NULL, 'TIGR01623', NULL, NULL, 'put_zinc_LRP1: putative zinc finger domain, LRP1 type', NULL, 'TIGR01623', NULL, NULL, 6593, 22),
(288756, NULL, 'TIGR02778', NULL, NULL, 'ligD_pol: DNA ligase D, polymerase domain', NULL, 'TIGR02778', NULL, NULL, 14487, 22),
(288757, NULL, 'TIGR02542', NULL, NULL, 'T_forsyth_147: TANFOR domain', NULL, 'TIGR02542', NULL, NULL, NULL, 22),
(288758, NULL, 'TIGR01507', NULL, NULL, 'hopene_cyclase: squalene-hopene cyclase', NULL, 'TIGR01507', NULL, NULL, 5510, 22),
(288759, NULL, 'TIGR01630', NULL, NULL, 'psiM2_ORF9: phage uncharacterized protein, C-terminal domain', NULL, 'TIGR01630', NULL, NULL, 6986, 22),
(288760, NULL, 'TIGR01283', NULL, NULL, 'nifE: nitrogenase MoFe cofactor biosynthesis protein NifE', NULL, 'TIGR01283', NULL, NULL, 1022, 22),
(288761, NULL, 'TIGR02785', NULL, NULL, 'addA_Gpos: helicase-exonuclease AddAB, AddA subunit', NULL, 'TIGR02785', NULL, NULL, 14223, 22),
(288762, NULL, 'TIGR02792', NULL, NULL, 'PCA_ligA: protocatechuate 4,5-dioxygenase, alpha subunit', NULL, 'TIGR02792', NULL, NULL, 14068, 22),
(288763, NULL, 'TIGR03815', NULL, NULL, 'CpaE_hom_Actino: helicase/secretion neighborhood CpaE-like protein', NULL, 'TIGR03815', NULL, NULL, 16112, 22),
(288764, NULL, 'TIGR00234', NULL, NULL, 'tyrS: tyrosine--tRNA ligase', NULL, 'TIGR00234', NULL, NULL, 6265, 22),
(288765, NULL, 'TIGR04328', NULL, NULL, 'cas4_PREFRAN: CRISPR-associated protein Cas4, subtype PREFRAN', NULL, 'TIGR04328', NULL, NULL, 23190, 22),
(288766, NULL, 'TIGR00057', NULL, NULL, 'TIGR00057: tRNA threonylcarbamoyl adenosine modification protein, Sua5/YciO/YrdC/YwlC family', NULL, 'TIGR00057', NULL, NULL, 2837, 22),
(288767, NULL, 'TIGR02320', NULL, NULL, 'PEP_mutase: phosphoenolpyruvate mutase', NULL, 'TIGR02320', NULL, NULL, 11748, 22),
(288768, NULL, 'TIGR03822', NULL, NULL, 'AblA_like_2: lysine-2,3-aminomutase-related protein', NULL, 'TIGR03822', NULL, NULL, 21145, 22),
(288769, NULL, 'TIGR01559', NULL, NULL, 'squal_synth: farnesyl-diphosphate farnesyltransferase', NULL, 'TIGR01559', NULL, NULL, 6923, 22),
(288770, NULL, 'TIGR04394', NULL, NULL, 'choline_CutC: choline trimethylamine-lyase', NULL, 'TIGR04394', NULL, NULL, 25380, 22),
(288771, NULL, 'TIGR04505', NULL, NULL, 'PtsS_plasma: phosphate ABC transporter substrate-binding protein', NULL, 'TIGR04505', NULL, NULL, 24018, 22),
(288772, NULL, 'TIGR01290', NULL, NULL, 'nifB: nitrogenase cofactor biosynthesis protein NifB', NULL, 'TIGR01290', NULL, NULL, 1065, 22),
(288773, NULL, 'TIGR02962', NULL, NULL, 'hdxy_isourate: hydroxyisourate hydrolase', NULL, 'TIGR02962', NULL, NULL, 9709, 22);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288774, NULL, 'TIGR03475', NULL, NULL, 'tap_IncFII_lead: RepA leader peptide Tap', NULL, 'TIGR03475', NULL, NULL, 9546, 22),
(288775, NULL, 'TIGR01135', NULL, NULL, 'glmS: glutamine-fructose-6-phosphate transaminase (isomerizing)', NULL, 'TIGR01135', NULL, NULL, 6572, 22),
(288776, NULL, 'TIGR02104', NULL, NULL, 'pulA_typeI: pullulanase, type I', NULL, 'TIGR02104', NULL, NULL, 13666, 22),
(288777, NULL, 'TIGR01961', NULL, NULL, 'NuoC_fam: NADH (or F420H2) dehydrogenase, subunit C', NULL, 'TIGR01961', NULL, NULL, 4063, 22),
(288778, NULL, 'TIGR00014', NULL, NULL, 'arsC: arsenate reductase (glutaredoxin)', NULL, 'TIGR00014', NULL, NULL, 1779, 22),
(288779, NULL, 'TIGR00166', NULL, NULL, 'S6: ribosomal protein bS6', NULL, 'TIGR00166', NULL, NULL, 5523, 22),
(288780, NULL, 'TIGR01993', NULL, NULL, 'Pyr-5-nucltdase: pyrimidine 5''-nucleotidase', NULL, 'TIGR01993', NULL, NULL, 4003, 22),
(288781, NULL, 'TIGR03225', NULL, NULL, 'benzo_boxB: benzoyl-CoA oxygenase, B subunit', NULL, 'TIGR03225', NULL, NULL, 16663, 22),
(288782, NULL, 'TIGR03708', NULL, NULL, 'poly_P_AMP_trns: polyphosphate:AMP phosphotransferase', NULL, 'TIGR03708', NULL, NULL, 16042, 22),
(288783, NULL, 'TIGR01167', NULL, NULL, 'LPXTG_anchor: LPXTG cell wall anchor domain', NULL, 'TIGR01167', NULL, NULL, NULL, 22),
(288784, NULL, 'TIGR01618', NULL, NULL, 'phage_P_loop: phage nucleotide-binding protein', NULL, 'TIGR01618', NULL, NULL, 7322, 22),
(288785, NULL, 'TIGR00992', NULL, NULL, '3a0901s03IAP75: chloroplast envelope protein translocase, IAP75 family', NULL, 'TIGR00992', NULL, NULL, 3766, 22),
(288786, NULL, 'TIGR03538', NULL, NULL, 'DapC_gpp: succinyldiaminopimelate transaminase', NULL, 'TIGR03538', NULL, NULL, 16921, 22),
(288787, NULL, 'TIGR02739', NULL, NULL, 'TraF: type-F conjugative transfer system pilin assembly protein TraF', NULL, 'TIGR02739', NULL, NULL, 13929, 22),
(288788, NULL, 'TIGR01448', NULL, NULL, 'recD_rel: helicase, RecD/TraA family', NULL, 'TIGR01448', NULL, NULL, 4774, 22),
(288789, NULL, 'TIGR04056', NULL, NULL, 'OMP_RagA_SusC: TonB-linked outer membrane protein, SusC/RagA family', NULL, 'TIGR04056', NULL, NULL, 18109, 22),
(288790, NULL, 'TIGR00649', NULL, NULL, 'MG423: beta-CASP ribonuclease, RNase J family', NULL, 'TIGR00649', NULL, NULL, 2344, 22),
(288791, NULL, 'TIGR02930', NULL, NULL, 'vnfG_nitrog: V-containing nitrogenase, delta subunit', NULL, 'TIGR02930', NULL, NULL, 8988, 22),
(288792, NULL, 'TIGR00840', NULL, NULL, 'b_cpa1: sodium/hydrogen exchanger 3', NULL, 'TIGR00840', NULL, NULL, 3293, 22),
(288793, NULL, 'TIGR00336', NULL, NULL, 'pyrE: orotate phosphoribosyltransferase', NULL, 'TIGR00336', NULL, NULL, 7448, 22),
(288794, NULL, 'TIGR03055', NULL, NULL, 'photo_alph_chp2: putative photosynthetic complex assembly protein 2', NULL, 'TIGR03055', NULL, NULL, 20729, 22),
(288795, NULL, 'TIGR04226', NULL, NULL, 'RrgB_K2N_iso_D2: fimbrial isopeptide formation D2 domain', NULL, 'TIGR04226', NULL, NULL, 25464, 22),
(288796, NULL, 'TIGR02760', NULL, NULL, 'TraI_TIGR: conjugative transfer relaxase protein TraI', NULL, 'TIGR02760', NULL, NULL, 13740, 22),
(288797, NULL, 'TIGR01305', NULL, NULL, 'GMP_reduct_1: guanosine monophosphate reductase', NULL, 'TIGR01305', NULL, NULL, 1330, 22),
(288798, NULL, 'TIGR00670', NULL, NULL, 'asp_carb_tr: aspartate carbamoyltransferase', NULL, 'TIGR00670', NULL, NULL, 1251, 22),
(288799, NULL, 'TIGR01337', NULL, NULL, 'apcB: allophycocyanin, beta subunit', NULL, 'TIGR01337', NULL, NULL, 3657, 22),
(288800, NULL, 'TIGR03427', NULL, NULL, 'ABC_peri_uca: ABC transporter periplasmic binding protein, urea carboxylase region', NULL, 'TIGR03427', NULL, NULL, 19168, 22),
(288801, NULL, 'TIGR04337', NULL, NULL, 'AmmeMemoSam_rS: AmmeMemoRadiSam system radical SAM enzyme', NULL, 'TIGR04337', NULL, NULL, 26745, 22),
(288802, NULL, 'TIGR03257', NULL, NULL, 'met_CoM_red_bet: methyl-coenzyme M reductase, beta subunit', NULL, 'TIGR03257', NULL, NULL, 1955, 22),
(288803, NULL, 'TIGR02247', NULL, NULL, 'HAD-1A3-hyp: epoxide hydrolase N-terminal domain-like phosphatase', NULL, 'TIGR02247', NULL, NULL, 11401, 22);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288804, NULL, 'TIGR04065', NULL, NULL, 'ocin_CLI_3235: putative bacteriocin precursor, CLI_3235 family', NULL, 'TIGR04065', NULL, NULL, 10748, 22),
(288805, NULL, 'TIGR00157', NULL, NULL, 'TIGR00157: ribosome small subunit-dependent GTPase A', NULL, 'TIGR00157', NULL, NULL, 7245, 22),
(288806, NULL, 'TIGR04507', NULL, NULL, 'fluorinase: adenosyl-fluoride synthase', NULL, 'TIGR04507', NULL, NULL, 24099, 22),
(288807, NULL, 'TIGR02417', NULL, NULL, 'fruct_sucro_rep: D-fructose-responsive transcription factor', NULL, 'TIGR02417', NULL, NULL, 9974, 22),
(288808, NULL, 'TIGR00327', NULL, NULL, 'secE_euk_arch: protein translocase SEC61 complex gamma subunit, archaeal and eukaryotic', NULL, 'TIGR00327', NULL, NULL, 7226, 22),
(288809, NULL, 'TIGR03087', NULL, NULL, 'stp1: sugar transferase, PEP-CTERM/EpsH1 system associated', NULL, 'TIGR03087', NULL, NULL, 14926, 22),
(288810, NULL, 'TIGR00538', NULL, NULL, 'hemN: oxygen-independent coproporphyrinogen III oxidase', NULL, 'TIGR00538', NULL, NULL, 4286, 22),
(288811, NULL, 'TIGR02971', NULL, NULL, 'heterocyst_DevB: ABC exporter membrane fusion protein, DevB family', NULL, 'TIGR02971', NULL, NULL, 9513, 22),
(288812, NULL, 'TIGR00055', NULL, NULL, 'uppS: di-trans,poly-cis-decaprenylcistransferase', NULL, 'TIGR00055', NULL, NULL, 3313, 22),
(288813, NULL, 'TIGR00506', NULL, NULL, 'ribB: 3,4-dihydroxy-2-butanone-4-phosphate synthase', NULL, 'TIGR00506', NULL, NULL, 6525, 22),
(288814, NULL, 'TIGR03198', NULL, NULL, 'pucE: xanthine dehydrogenase E subunit', NULL, 'TIGR03198', NULL, NULL, 16054, 22),
(288815, NULL, 'TIGR01850', NULL, NULL, 'argC: N-acetyl-gamma-glutamyl-phosphate reductase', NULL, 'TIGR01850', NULL, NULL, 6715, 22),
(288816, NULL, 'TIGR02297', NULL, NULL, 'HpaA: 4-hydroxyphenylacetate catabolism regulatory protein HpaA', NULL, 'TIGR02297', NULL, NULL, 13075, 22),
(288817, NULL, 'TIGR00983', NULL, NULL, '3a0801s02tim23: mitochondrial import inner membrane translocase subunit', NULL, 'TIGR00983', NULL, NULL, 3989, 22),
(288818, NULL, 'TIGR01176', NULL, NULL, 'fum_red_Fp: fumarate reductase (quinol), flavoprotein subunit', NULL, 'TIGR01176', NULL, NULL, 6540, 22),
(288819, NULL, 'TIGR01659', NULL, NULL, 'sex-lethal: sex-lethal family splicing factor', NULL, 'TIGR01659', NULL, NULL, 118, 22),
(288820, NULL, 'TIGR03872', NULL, NULL, 'cytochrome_MoxG: cytochrome c(L), periplasmic', NULL, 'TIGR03872', NULL, NULL, 9564, 22),
(288821, NULL, 'TIGR03368', NULL, NULL, 'cellulose_yhjU: cellulose synthase operon protein YhjU', NULL, 'TIGR03368', NULL, NULL, 18851, 22),
(288822, NULL, 'TIGR04167', NULL, NULL, 'rSAM_SeCys: radical SAM/Cys-rich domain protein', NULL, 'TIGR04167', NULL, NULL, 23017, 22),
(288823, NULL, 'TIGR01489', NULL, NULL, 'DKMTPPase-SF: 2,3-diketo-5-methylthio-1-phosphopentane phosphatase', NULL, 'TIGR01489', NULL, NULL, 5740, 22),
(288824, NULL, 'TIGR00819', NULL, NULL, 'ydaH: AbgT transporter family', NULL, 'TIGR00819', NULL, NULL, 10163, 22),
(288825, NULL, 'TIGR01024', NULL, NULL, 'rplS_bact: ribosomal protein bL19', NULL, 'TIGR01024', NULL, NULL, 4104, 22),
(288826, NULL, 'TIGR01791', NULL, NULL, 'CM_archaeal: chorismate mutase', NULL, 'TIGR01791', NULL, NULL, 1506, 22),
(288827, NULL, 'TIGR00708', NULL, NULL, 'cobA: cob(I)yrinic acid a,c-diamide adenosyltransferase', NULL, 'TIGR00708', NULL, NULL, 6293, 22),
(288828, NULL, 'TIGR02690', NULL, NULL, 'resist_ArsH: arsenical resistance protein ArsH', NULL, 'TIGR02690', NULL, NULL, 13006, 22),
(288829, NULL, 'TIGR03720', NULL, NULL, 'exospor_lead: exosporium leader peptide', NULL, 'TIGR03720', NULL, NULL, 16287, 22),
(288830, NULL, 'TIGR01346', NULL, NULL, 'isocit_lyase: isocitrate lyase', NULL, 'TIGR01346', NULL, NULL, 3922, 22),
(288831, NULL, 'TIGR04024', NULL, NULL, 'F420_NP1902A: coenzyme F420-dependent oxidoreductase, NP1902A family', NULL, 'TIGR04024', NULL, NULL, 18191, 22),
(288832, NULL, 'TIGR00479', NULL, NULL, 'rumA: 23S rRNA (uracil-5-)-methyltransferase RumA', NULL, 'TIGR00479', NULL, NULL, NULL, 22),
(288833, NULL, 'TIGR01680', NULL, NULL, 'Veg_Stor_Prot: vegetative storage protein', NULL, 'TIGR01680', NULL, NULL, 9797, 22);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288834, NULL, 'TIGR04378', NULL, NULL, 'myo_inos_iolB: 5-deoxy-glucuronate isomerase', NULL, 'TIGR04378', NULL, NULL, 13792, 22),
(288835, NULL, 'TIGR03046', NULL, NULL, 'PS_II_psbV2: photosystem II cytochrome PsbV2', NULL, 'TIGR03046', NULL, NULL, 20757, 22),
(288836, NULL, 'TIGR04548', NULL, NULL, 'DnaD_Mollicutes: DnaD family protein', NULL, 'TIGR04548', NULL, NULL, 25295, 22),
(288837, NULL, 'TIGR00198', NULL, NULL, 'cat_per_HPI: catalase/peroxidase HPI', NULL, 'TIGR00198', NULL, NULL, 6933, 22),
(288838, NULL, 'TIGR03216', NULL, NULL, 'OH_muco_semi_DH: 2-hydroxymuconic semialdehyde dehydrogenase', NULL, 'TIGR03216', NULL, NULL, 16751, 22),
(288839, NULL, 'TIGR00368', NULL, NULL, 'TIGR00368: Mg chelatase-like protein', NULL, 'TIGR00368', NULL, NULL, 7083, 22),
(288840, NULL, 'TIGR04489', NULL, NULL, 'exosort_XrtO: exosortase O', NULL, 'TIGR04489', NULL, NULL, 21870, 22),
(288841, NULL, 'TIGR03550', NULL, NULL, 'F420_cofG: 7,8-didemethyl-8-hydroxy-5-deazariboflavin synthase, CofG subunit', NULL, 'TIGR03550', NULL, NULL, 18150, 22),
(288842, NULL, 'TIGR00096', NULL, NULL, 'TIGR00096: 16S rRNA (cytidine(1402)-2''-O)-methyltransferase', NULL, 'TIGR00096', NULL, NULL, 7184, 22),
(288843, NULL, 'TIGR02637', NULL, NULL, 'RhaS: rhamnose ABC transporter, rhamnose-binding protein', NULL, 'TIGR02637', NULL, NULL, 9049, 22),
(288844, NULL, 'TIGR03155', NULL, NULL, 'sulfolob_CbsB: cytochrome b558/566, subunit B', NULL, 'TIGR03155', NULL, NULL, 15818, 22),
(288845, NULL, 'TIGR03606', NULL, NULL, 'non_repeat_PQQ: dehydrogenase, PQQ-dependent, s-GDH family', NULL, 'TIGR03606', NULL, NULL, 14718, 22),
(288846, NULL, 'TIGR03981', NULL, NULL, 'SAM_quin_mod: His-Xaa-Ser system putative quinone modification maturase', NULL, 'TIGR03981', NULL, NULL, 8113, 22),
(288847, NULL, 'TIGR02186', NULL, NULL, 'alph_Pro_TM: conserved hypothetical protein', NULL, 'TIGR02186', NULL, NULL, 16786, 22),
(288848, NULL, 'TIGR00547', NULL, NULL, 'lolA: outer membrane lipoprotein carrier protein LolA', NULL, 'TIGR00547', NULL, NULL, 17516, 22),
(288849, NULL, 'TIGR01891', NULL, NULL, 'amidohydrolases: amidohydrolase', NULL, 'TIGR01891', NULL, NULL, 18102, 22),
(288850, NULL, 'TIGR02206', NULL, NULL, 'intg_mem_TP0381: conserved hypothetical integral membrane protein TIGR02206', NULL, 'TIGR02206', NULL, NULL, 11759, 22),
(288851, NULL, 'TIGR02581', NULL, NULL, 'cas_cyan_RAMP: CRISPR-associated RAMP protein, SSO1426 family', NULL, 'TIGR02581', NULL, NULL, 9485, 22),
(288852, NULL, 'TIGR02519', NULL, NULL, 'pilus_MshL: pilus (MSHA type) biogenesis protein MshL', NULL, 'TIGR02519', NULL, NULL, 18535, 22),
(288853, NULL, 'TIGR03157', NULL, NULL, 'cas_Csc2: CRISPR type I-D/CYANO-associated protein Csc2', NULL, 'TIGR03157', NULL, NULL, 15841, 22),
(288854, NULL, 'TIGR04124', NULL, NULL, 'archaeo_artE: archaeosortase family protein ArtE', NULL, 'TIGR04124', NULL, NULL, 23258, 22),
(288855, NULL, 'TIGR02036', NULL, NULL, 'dsdC: D-serine deaminase transcriptional activator', NULL, 'TIGR02036', NULL, NULL, 13494, 22),
(288856, NULL, 'TIGR02002', NULL, NULL, 'PTS-II-BC-glcB: PTS system, glucose-specific IIBC component', NULL, 'TIGR02002', NULL, NULL, 10280, 22),
(288857, NULL, 'TIGR01067', NULL, NULL, 'rplN_bact: ribosomal protein uL14', NULL, 'TIGR01067', NULL, NULL, 4938, 22),
(288858, NULL, 'TIGR04126', NULL, NULL, 'PGF_CTERM: PGF-CTERM archaeal protein-sorting signal', NULL, 'TIGR04126', NULL, NULL, 23209, 22),
(288859, NULL, 'TIGR03327', NULL, NULL, 'AMP_phos: AMP phosphorylase', NULL, 'TIGR03327', NULL, NULL, 17723, 22),
(288860, NULL, 'TIGR02467', NULL, NULL, 'CbiE: precorrin-6y C5,15-methyltransferase (decarboxylating), CbiE subunit', NULL, 'TIGR02467', NULL, NULL, 12697, 22),
(288861, NULL, 'TIGR01237', NULL, NULL, 'D1pyr5carbox2: putative delta-1-pyrroline-5-carboxylate dehydrogenase', NULL, 'TIGR01237', NULL, NULL, 218, 22),
(288862, NULL, 'TIGR01065', NULL, NULL, 'hlyIII: channel protein, hemolysin III family', NULL, 'TIGR01065', NULL, NULL, 4590, 22),
(288863, NULL, 'TIGR00377', NULL, NULL, 'ant_ant_sig: anti-anti-sigma factor', NULL, 'TIGR00377', NULL, NULL, 1012, 22);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288864, NULL, 'TIGR01829', NULL, NULL, 'AcAcCoA_reduct: acetoacetyl-CoA reductase', NULL, 'TIGR01829', NULL, NULL, 10461, 22),
(288865, NULL, 'TIGR04405', NULL, NULL, 'SkfF: sporulation killing factor system integral membrane protein', NULL, 'TIGR04405', NULL, NULL, 22952, 22),
(288866, NULL, 'TIGR00717', NULL, NULL, 'rpsA: ribosomal protein bS1', NULL, 'TIGR00717', NULL, NULL, 2974, 22),
(288867, NULL, 'TIGR02751', NULL, NULL, 'PEPCase_arch: phosphoenolpyruvate carboxylase', NULL, 'TIGR02751', NULL, NULL, 1687, 22),
(288868, NULL, 'TIGR02807', NULL, NULL, 'cas6_cmx6: CRISPR-associated protein Cas6, subtype MYXAN', NULL, 'TIGR02807', NULL, NULL, 8772, 22),
(288869, NULL, 'TIGR00438', NULL, NULL, 'rrmJ: ribosomal RNA large subunit methyltransferase J', NULL, 'TIGR00438', NULL, NULL, 1896, 22),
(288870, NULL, 'TIGR02692', NULL, NULL, 'tRNA_CCA_actino: CCA tRNA nucleotidyltransferase', NULL, 'TIGR02692', NULL, NULL, 13179, 22),
(288871, NULL, 'TIGR00268', NULL, NULL, 'TIGR00268: TIGR00268 family protein', NULL, 'TIGR00268', NULL, NULL, 11267, 22),
(288872, NULL, 'TIGR02862', NULL, NULL, 'spore_BofA: pro-sigmaK processing inhibitor BofA', NULL, 'TIGR02862', NULL, NULL, 8588, 22),
(288873, NULL, 'TIGR04235', NULL, NULL, 'seadorna_VP4: seadornavirus VP4 protein', NULL, 'TIGR04235', NULL, NULL, 22836, 22),
(288874, NULL, 'TIGR00901', NULL, NULL, '2A0125: AmpG-like permease', NULL, 'TIGR00901', NULL, NULL, NULL, 22),
(288875, NULL, 'TIGR02921', NULL, NULL, 'PEP_integral: PEP-CTERM family integral membrane protein', NULL, 'TIGR02921', NULL, NULL, 11127, 22),
(288876, NULL, 'TIGR01952', NULL, NULL, 'nusA_arch: NusA family KH domain protein, archaeal', NULL, 'TIGR01952', NULL, NULL, 4064, 22),
(288877, NULL, 'TIGR02590', NULL, NULL, 'cas_Csh2: CRISPR-associated protein Cas7/Csh2, subtype I-B/HMARI', NULL, 'TIGR02590', NULL, NULL, 9345, 22),
(288878, NULL, 'TIGR00608', NULL, NULL, 'radc: DNA repair protein RadC', NULL, 'TIGR00608', NULL, NULL, 3412, 22),
(288879, NULL, 'TIGR03974', NULL, NULL, 'rSAM_six_Cys: SCIFF radical SAM maturase', NULL, 'TIGR03974', NULL, NULL, 11938, 22),
(288880, NULL, 'TIGR01126', NULL, NULL, 'pdi_dom: protein disulfide-isomerase domain', NULL, 'TIGR01126', NULL, NULL, 5502, 22),
(288881, NULL, 'TIGR03266', NULL, NULL, 'methan_mark_1: putative methanogenesis marker protein 1', NULL, 'TIGR03266', NULL, NULL, 17288, 22),
(288882, NULL, 'TIGR03148', NULL, NULL, 'cyt_nit_nrfD: cytochrome c nitrite reductase, NrfD subunit', NULL, 'TIGR03148', NULL, NULL, 15260, 22),
(288883, NULL, 'TIGR00450', NULL, NULL, 'mnmE_trmE_thdF: tRNA modification GTPase TrmE', NULL, 'TIGR00450', NULL, NULL, 1679, 22),
(288884, NULL, 'TIGR04133', NULL, NULL, 'rSAM_w_lipo: radical SAM enzyme, rSAM/lipoprotein system', NULL, 'TIGR04133', NULL, NULL, 21365, 22),
(288885, NULL, 'TIGR04015', NULL, NULL, 'WcaC: colanic acid biosynthesis glycosyltransferase WcaC', NULL, 'TIGR04015', NULL, NULL, 18465, 22),
(288886, NULL, 'TIGR00606', NULL, NULL, 'rad50: rad50', NULL, 'TIGR00606', NULL, NULL, 564, 22),
(288887, NULL, 'TIGR00259', NULL, NULL, 'thylakoid_BtpA: membrane complex biogenesis protein, BtpA family', NULL, 'TIGR00259', NULL, NULL, 7446, 22),
(288888, NULL, 'TIGR04303', NULL, NULL, 'GeoRSP_rSAM: GeoRSP system radical SAM/SPASM protein', NULL, 'TIGR04303', NULL, NULL, 23170, 22),
(288889, NULL, 'TIGR00280', NULL, NULL, 'eL43_euk_arch: ribosomal protein eL43', NULL, 'TIGR00280', NULL, NULL, 2773, 22),
(288890, NULL, 'TIGR01407', NULL, NULL, 'dinG_rel: putative DnaQ family exonuclease/DinG family helicase', NULL, 'TIGR01407', NULL, NULL, 4635, 22),
(288891, NULL, 'TIGR01782', NULL, NULL, 'TonB-Xanth-Caul: TonB-dependent receptor', NULL, 'TIGR01782', NULL, NULL, 2085, 22),
(288892, NULL, 'TIGR02909', NULL, NULL, 'spore_YkwD: uncharacterized protein, YkwD family', NULL, 'TIGR02909', NULL, NULL, 11153, 22),
(288893, NULL, 'TIGR00436', NULL, NULL, 'era: GTP-binding protein Era', NULL, 'TIGR00436', NULL, NULL, 3580, 22),
(288894, NULL, 'TIGR03096', NULL, NULL, 'nitroso_cyanin: nitrosocyanin', NULL, 'TIGR03096', NULL, NULL, 14892, 22); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288895, NULL, 'TIGR00089', NULL, NULL, 'TIGR00089: radical SAM methylthiotransferase, MiaB/RimO family', NULL, 'TIGR00089', NULL, NULL, 5825, 22),
(288896, NULL, 'TIGR01879', NULL, NULL, 'hydantase: amidase, hydantoinase/carbamoylase family', NULL, 'TIGR01879', NULL, NULL, 10627, 22),
(288897, NULL, 'TIGR03325', NULL, NULL, 'BphB_TodD: cis-2,3-dihydrobiphenyl-2,3-diol dehydrogenase', NULL, 'TIGR03325', NULL, NULL, 17915, 22),
(288898, NULL, 'TIGR00731', NULL, NULL, 'bL25_bact_ctc: ribosomal protein bL25, Ctc-form', NULL, 'TIGR00731', NULL, NULL, 2289, 22),
(288899, NULL, 'TIGR03429', NULL, NULL, 'arom_pren_DMATS: aromatic prenyltransferase, DMATS type', NULL, 'TIGR03429', NULL, NULL, 19153, 22),
(288900, NULL, 'TIGR01893', NULL, NULL, 'aa-his-dipept: Xaa-His dipeptidase', NULL, 'TIGR01893', NULL, NULL, 1462, 22),
(288901, NULL, 'TIGR00266', NULL, NULL, 'TIGR00266: TIGR00266 family protein', NULL, 'TIGR00266', NULL, NULL, 5448, 22),
(288902, NULL, 'TIGR03436', NULL, NULL, 'acidobact_VWFA: VWFA-related Acidobacterial domain', NULL, 'TIGR03436', NULL, NULL, 19445, 22),
(288903, NULL, 'TIGR01414', NULL, NULL, 'autotrans_barl: outer membrane autotransporter barrel domain', NULL, 'TIGR01414', NULL, NULL, 4642, 22),
(288904, NULL, 'TIGR02288', NULL, NULL, 'PaaN_2: phenylacetic acid degradation protein paaN', NULL, 'TIGR02288', NULL, NULL, 11117, 22),
(288905, NULL, 'TIGR02569', NULL, NULL, 'TIGR02569_actnb: TIGR02569 family protein', NULL, 'TIGR02569', NULL, NULL, 11228, 22),
(288906, NULL, 'TIGR01244', NULL, NULL, 'TIGR01244: TIGR01244 family protein', NULL, 'TIGR01244', NULL, NULL, 110, 22),
(288907, NULL, 'TIGR00561', NULL, NULL, 'pntA: NAD(P)(+) transhydrogenase (AB-specific), alpha subunit', NULL, 'TIGR00561', NULL, NULL, 24731, 22),
(288908, NULL, 'TIGR03318', NULL, NULL, 'YdfZ_fam: putative selenium-binding protein YdfZ', NULL, 'TIGR03318', NULL, NULL, 17733, 22),
(288909, NULL, 'TIGR01074', NULL, NULL, 'rep: ATP-dependent DNA helicase Rep', NULL, 'TIGR01074', NULL, NULL, 4842, 22),
(288910, NULL, 'TIGR02628', NULL, NULL, 'fuculo_kin_coli: L-fuculokinase', NULL, 'TIGR02628', NULL, NULL, 9074, 22),
(288911, NULL, 'TIGR02399', NULL, NULL, 'salt_tol_Pase: glucosylglycerol 3-phosphatase', NULL, 'TIGR02399', NULL, NULL, 9693, 22),
(288912, NULL, 'TIGR02458', NULL, NULL, 'CbtA: cobalt transporter subunit CbtA (proposed)', NULL, 'TIGR02458', NULL, NULL, 10543, 22),
(288913, NULL, 'TIGR03259', NULL, NULL, 'met_CoM_red_gam: methyl-coenzyme M reductase, gamma subunit', NULL, 'TIGR03259', NULL, NULL, 2912, 22),
(288914, NULL, 'TIGR04228', NULL, NULL, 'isopep_sspB_C2: adhesin isopeptide-forming adherence domain', NULL, 'TIGR04228', NULL, NULL, 23290, 22),
(288915, NULL, 'TIGR01169', NULL, NULL, 'rplA_bact: ribosomal protein uL1', NULL, 'TIGR01169', NULL, NULL, 6683, 22),
(288916, NULL, 'TIGR02138', NULL, NULL, 'phosphate_pstC: phosphate ABC transporter, permease protein PstC', NULL, 'TIGR02138', NULL, NULL, 13951, 22),
(288917, NULL, 'TIGR02084', NULL, NULL, 'leud: 3-isopropylmalate dehydratase, small subunit', NULL, 'TIGR02084', NULL, NULL, 13533, 22),
(288918, NULL, 'TIGR02964', NULL, NULL, 'xanthine_xdhC: xanthine dehydrogenase accessory protein XdhC', NULL, 'TIGR02964', NULL, NULL, 9684, 22),
(288919, NULL, 'TIGR01530', NULL, NULL, 'nadN: NAD nucleotidase', NULL, 'TIGR01530', NULL, NULL, 6591, 22),
(288920, NULL, 'TIGR03053', NULL, NULL, 'PS_I_psaM: photosystem I reaction center subunit XII', NULL, 'TIGR03053', NULL, NULL, 8858, 22),
(288921, NULL, 'TIGR01017', NULL, NULL, 'rpsD_bact: ribosomal protein uS4', NULL, 'TIGR01017', NULL, NULL, 3978, 22),
(288922, NULL, 'TIGR03107', NULL, NULL, 'glu_aminopep: glutamyl aminopeptidase', NULL, 'TIGR03107', NULL, NULL, 14772, 22),
(288923, NULL, 'TIGR04174', NULL, NULL, 'IPTL_CTERM: IPTL-CTERM protein sorting domain', NULL, 'TIGR04174', NULL, NULL, 23224, 22),
(288924, NULL, 'TIGR00164', NULL, NULL, 'PS_decarb_rel: phosphatidylserine decarboxylase homolog', NULL, 'TIGR00164', NULL, NULL, 29584, 22),
(288925, NULL, 'TIGR02812', NULL, NULL, 'fadR_gamma: fatty acid metabolism transcriptional regulator FadR', NULL, 'TIGR02812', NULL, NULL, 8507, 22);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288926, NULL, 'TIGR00218', NULL, NULL, 'manA: mannose-6-phosphate isomerase, class I', NULL, 'TIGR00218', NULL, NULL, 5150, 22),
(288927, NULL, 'TIGR01995', NULL, NULL, 'PTS-II-ABC-beta: PTS system, beta-glucoside-specific IIABC component', NULL, 'TIGR01995', NULL, NULL, 10215, 22),
(288928, NULL, 'TIGR04344', NULL, NULL, 'ovoA_Nterm: 5-histidylcysteine sulfoxide synthase', NULL, 'TIGR04344', NULL, NULL, 26793, 22),
(288929, NULL, 'TIGR00048', NULL, NULL, 'rRNA_mod_RlmN: 23S rRNA (adenine(2503)-C(2))-methyltransferase', NULL, 'TIGR00048', NULL, NULL, 21654, 22),
(288930, NULL, 'TIGR02308', NULL, NULL, 'RNA_lig_T4_1: RNA ligase, T4 RnlA family', NULL, 'TIGR02308', NULL, NULL, 10435, 22),
(288931, NULL, 'TIGR02254', NULL, NULL, 'YjjG/YfnB: noncanonical pyrimidine nucleotidase, YjjG family', NULL, 'TIGR02254', NULL, NULL, 11426, 22),
(288932, NULL, 'TIGR01700', NULL, NULL, 'PNPH: purine nucleoside phosphorylase I, inosine and guanosine-specific', NULL, 'TIGR01700', NULL, NULL, 9605, 22),
(288933, NULL, 'TIGR00799', NULL, NULL, 'mtp: Golgi 4-transmembrane spanning transporter', NULL, 'TIGR00799', NULL, NULL, 19981, 22),
(288934, NULL, 'TIGR03817', NULL, NULL, 'DECH_helic: helicase/secretion neighborhood putative DEAH-box helicase', NULL, 'TIGR03817', NULL, NULL, 14168, 22),
(288935, NULL, 'TIGR02794', NULL, NULL, 'tolA_full: protein TolA', NULL, 'TIGR02794', NULL, NULL, 14216, 22),
(288936, NULL, 'TIGR01727', NULL, NULL, 'oligo_HPY: oligopeptide/dipeptide ABC transporter, ATP-binding protein, C-terminal domain', NULL, 'TIGR01727', NULL, NULL, 12957, 22),
(288937, NULL, 'TIGR04487', NULL, NULL, 'SoxY_para_1: SoxY-related AACIE arm protein', NULL, 'TIGR04487', NULL, NULL, 21825, 22),
(288938, NULL, 'TIGR00334', NULL, NULL, '5S_RNA_mat_M5: ribonuclease M5', NULL, 'TIGR00334', NULL, NULL, 7007, 22),
(288939, NULL, 'TIGR04290', NULL, NULL, 'meth_Rta_06860: methyltransferase, Rta_06860 family', NULL, 'TIGR04290', NULL, NULL, 26836, 22),
(288940, NULL, 'TIGR04058', NULL, NULL, 'AcACP_reductase: long-chain fatty acyl-ACP reductase (aldehyde-forming)', NULL, 'TIGR04058', NULL, NULL, 16301, 22),
(288941, NULL, 'TIGR02889', NULL, NULL, 'spore_YpeB: germination protein YpeB', NULL, 'TIGR02889', NULL, NULL, 10722, 22),
(288942, NULL, 'TIGR01190', NULL, NULL, 'ccmB: heme exporter protein CcmB', NULL, 'TIGR01190', NULL, NULL, 23330, 22),
(288943, NULL, 'TIGR01360', NULL, NULL, 'aden_kin_iso1: adenylate kinase', NULL, 'TIGR01360', NULL, NULL, 3839, 22),
(288944, NULL, 'TIGR00874', NULL, NULL, 'talAB: transaldolase', NULL, 'TIGR00874', NULL, NULL, 3526, 22),
(288945, NULL, 'TIGR01285', NULL, NULL, 'nifN: nitrogenase molybdenum-iron cofactor biosynthesis protein NifN', NULL, 'TIGR01285', NULL, NULL, 1085, 22),
(288946, NULL, 'TIGR00969', NULL, NULL, '3a0106s02: sulfate ABC transporter, permease protein', NULL, 'TIGR00969', NULL, NULL, 3591, 22),
(288947, NULL, 'TIGR03375', NULL, NULL, 'type_I_sec_LssB: type I secretion system ATPase', NULL, 'TIGR03375', NULL, NULL, 18699, 22),
(288948, NULL, 'TIGR04022', NULL, NULL, 'sulfur_SfnB: sulfur acquisition oxidoreductase, SfnB family', NULL, 'TIGR04022', NULL, NULL, 8115, 22),
(288949, NULL, 'TIGR00021', NULL, NULL, 'rpiA: ribose 5-phosphate isomerase A', NULL, 'TIGR00021', NULL, NULL, 5031, 22),
(288950, NULL, 'TIGR02179', NULL, NULL, 'PorD_KorD: 2-oxoacid:acceptor oxidoreductase, delta subunit, pyruvate/2-ketoisovalerate family', NULL, 'TIGR02179', NULL, NULL, 12026, 22),
(288951, NULL, 'TIGR03647', NULL, NULL, 'Na_symport_sm: putative solute:sodium symporter small subunit', NULL, 'TIGR03647', NULL, NULL, 18372, 22),
(288952, NULL, 'TIGR04562', NULL, NULL, 'TIGR04562: TIGR04562 family protein', NULL, 'TIGR04562', NULL, NULL, 23609, 22),
(288953, NULL, 'TIGR02526', NULL, NULL, 'eut_PduT: PduT-like ethanolamine utilization protein', NULL, 'TIGR02526', NULL, NULL, 11468, 22),
(288954, NULL, 'TIGR02678', NULL, NULL, 'TIGR02678: TIGR02678 family protein', NULL, 'TIGR02678', NULL, NULL, 10234, 22),
(288955, NULL, 'TIGR02540', NULL, NULL, 'gpx7: putative glutathione peroxidase Gpx7', NULL, 'TIGR02540', NULL, NULL, 11340, 22); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288956, NULL, 'TIGR00504', NULL, NULL, 'pyro_pdase: pyroglutamyl-peptidase I', NULL, 'TIGR00504', NULL, NULL, 24735, 22),
(288957, NULL, 'TIGR02043', NULL, NULL, 'ZntR: Zn(II)-responsive transcriptional regulator', NULL, 'TIGR02043', NULL, NULL, 13308, 22),
(288958, NULL, 'TIGR03545', NULL, NULL, 'TIGR03545: TIGR03545 family protein', NULL, 'TIGR03545', NULL, NULL, 18410, 22),
(288959, NULL, 'TIGR03661', NULL, NULL, 'T1SS_VCA0849: type I secretion C-terminal target domain (VC_A0849 subclass)', NULL, 'TIGR03661', NULL, NULL, 15406, 22),
(288960, NULL, 'TIGR02213', NULL, NULL, 'lolE_release: lipoprotein releasing system, transmembrane protein LolE', NULL, 'TIGR02213', NULL, NULL, 11124, 22),
(288961, NULL, 'TIGR03715', NULL, NULL, 'KxYKxGKxW: KxYKxGKxW signal peptide', NULL, 'TIGR03715', NULL, NULL, 15493, 22),
(288962, NULL, 'TIGR01509', NULL, NULL, 'HAD-SF-IA-v3: HAD hydrolase, family IA, variant 3', NULL, 'TIGR01509', NULL, NULL, 6934, 22),
(288963, NULL, 'TIGR03012', NULL, NULL, 'sulf_tusD_dsrE: sulfur relay protein TusD/DsrE', NULL, 'TIGR03012', NULL, NULL, 20547, 22),
(288964, NULL, 'TIGR02349', NULL, NULL, 'DnaJ_bact: chaperone protein DnaJ', NULL, 'TIGR02349', NULL, NULL, 11588, 22),
(288965, NULL, 'TIGR00007', NULL, NULL, 'TIGR00007: 1-(5-phosphoribosyl)-5-[(5-phosphoribosylamino)methylideneamino]imidazole-4-carboxamide isomerase', NULL, 'TIGR00007', NULL, NULL, 2999, 22),
(288966, NULL, 'TIGR02370', NULL, NULL, 'pyl_corrinoid: methyltransferase cognate corrinoid proteins, Methanosarcina family', NULL, 'TIGR02370', NULL, NULL, 8710, 22),
(288967, NULL, 'TIGR04514', NULL, NULL, 'GWxTD_dom: GWxTD domain', NULL, 'TIGR04514', NULL, NULL, 25215, 22),
(288968, NULL, 'TIGR02356', NULL, NULL, 'adenyl_thiF: thiazole biosynthesis adenylyltransferase ThiF', NULL, 'TIGR02356', NULL, NULL, 11596, 22),
(288969, NULL, 'TIGR03858', NULL, NULL, 'LLM_2I7G: probable oxidoreductase, LLM family', NULL, 'TIGR03858', NULL, NULL, 15318, 22),
(288970, NULL, 'TIGR01339', NULL, NULL, 'phycocy_beta: phycocyanin, beta subunit', NULL, 'TIGR01339', NULL, NULL, 3629, 22),
(288971, NULL, 'TIGR00826', NULL, NULL, 'EIIB_glc: PTS system, glucose-like IIB component', NULL, 'TIGR00826', NULL, NULL, 4845, 22),
(288972, NULL, 'TIGR00663', NULL, NULL, 'dnan: DNA polymerase III, beta subunit', NULL, 'TIGR00663', NULL, NULL, 4499, 22),
(288973, NULL, 'TIGR02710', NULL, NULL, 'TIGR02710: CRISPR-associated protein, TIGR02710 family', NULL, 'TIGR02710', NULL, NULL, 14179, 22),
(288974, NULL, 'TIGR02848', NULL, NULL, 'spore_III_AC: stage III sporulation protein AC', NULL, 'TIGR02848', NULL, NULL, 929, 22),
(288975, NULL, 'TIGR00833', NULL, NULL, 'actII: transport protein', NULL, 'TIGR00833', NULL, NULL, 3299, 22),
(288976, NULL, 'TIGR00486', NULL, NULL, 'YbgI_SA1388: dinuclear metal center protein, YbgI/SA1388 family', NULL, 'TIGR00486', NULL, NULL, 2763, 22),
(288977, NULL, 'TIGR00656', NULL, NULL, 'asp_kin_monofn: aspartate kinase, monofunctional class', NULL, 'TIGR00656', NULL, NULL, 4027, 22),
(288978, NULL, 'TIGR03223', NULL, NULL, 'Phn_opern_protn: putative phosphonate metabolism protein', NULL, 'TIGR03223', NULL, NULL, 8167, 22),
(288979, NULL, 'TIGR01843', NULL, NULL, 'type_I_hlyD: type I secretion membrane fusion protein, HlyD family', NULL, 'TIGR01843', NULL, NULL, 10842, 22),
(288980, NULL, 'TIGR00990', NULL, NULL, '3a0801s09: mitochondrial precursor proteins import receptor', NULL, 'TIGR00990', NULL, NULL, 3673, 22),
(288981, NULL, 'TIGR03491', NULL, NULL, 'TIGR03491: putative RecB family nuclease, TM0106 family', NULL, 'TIGR03491', NULL, NULL, 17106, 22),
(288982, NULL, 'TIGR01673', NULL, NULL, 'holin_LLH: phage holin, LL-H family', NULL, 'TIGR01673', NULL, NULL, 5179, 22),
(288983, NULL, 'TIGR03688', NULL, NULL, 'pupylate_PafA2: proteasome accessory factor PafA2', NULL, 'TIGR03688', NULL, NULL, 21427, 22),
(288984, NULL, 'TIGR01911', NULL, NULL, 'HesB_rel_seleno: HesB-like selenoprotein', NULL, 'TIGR01911', NULL, NULL, 2048, 22),
(288985, NULL, 'TIGR00116', NULL, NULL, 'tsf: translation elongation factor Ts', NULL, 'TIGR00116', NULL, NULL, 4418, 22);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(288986, NULL, 'TIGR02152', NULL, NULL, 'D_ribokin_bact: ribokinase', NULL, 'TIGR02152', NULL, NULL, 14352, 22),
(288987, NULL, 'TIGR03586', NULL, NULL, 'PseI: pseudaminic acid synthase', NULL, 'TIGR03586', NULL, NULL, 11736, 22),
(288988, NULL, 'TIGR04521', NULL, NULL, 'ECF_ATPase_2: energy-coupling factor transporter ATPase', NULL, 'TIGR04521', NULL, NULL, 25105, 22),
(288989, NULL, 'TIGR00062', NULL, NULL, 'L27: ribosomal protein bL27', NULL, 'TIGR00062', NULL, NULL, 3236, 22),
(288990, NULL, 'TIGR00942', NULL, NULL, '2a6301s05: multicomponent Na+:H+ antiporter', NULL, 'TIGR00942', NULL, NULL, 6391, 22),
(288991, NULL, 'TIGR02431', NULL, NULL, 'pcaR_pcaU: beta-ketoadipate pathway transcriptional regulators, PcaR/PcaU/PobR family', NULL, 'TIGR02431', NULL, NULL, 9690, 22),
(288992, NULL, 'TIGR03400', NULL, NULL, '18S_RNA_Rcl1p: 18S rRNA biogenesis protein RCL1', NULL, 'TIGR03400', NULL, NULL, 15415, 22),
(288993, NULL, 'TIGR03756', NULL, NULL, 'conj_TIGR03756: integrating conjugative element protein, PFL_4710 family', NULL, 'TIGR03756', NULL, NULL, 26259, 22),
(288994, NULL, 'TIGR02601', NULL, NULL, 'autotrns_rpt: autotransporter-associated beta strand repeat', NULL, 'TIGR02601', NULL, NULL, 9349, 22),
(288995, NULL, 'TIGR03831', NULL, NULL, 'YgiT_finger: YgiT-type zinc finger domain', NULL, 'TIGR03831', NULL, NULL, 14832, 22),
(288996, NULL, 'TIGR02896', NULL, NULL, 'spore_III_AF: stage III sporulation protein AF', NULL, 'TIGR02896', NULL, NULL, 11054, 22),
(288997, NULL, 'TIGR04555', NULL, NULL, 'sulfite_DH_soxC: sulfite dehydrogenase', NULL, 'TIGR04555', NULL, NULL, 23998, 22),
(288998, NULL, 'TIGR01741', NULL, NULL, 'staph_tand_hypo: conserved hypothetical protein', NULL, 'TIGR01741', NULL, NULL, 2190, 22),
(288999, NULL, 'TIGR00232', NULL, NULL, 'tktlase_bact: transketolase', NULL, 'TIGR00232', NULL, NULL, 518, 22),
(289000, NULL, 'TIGR02315', NULL, NULL, 'ABC_phnC: phosphonate ABC transporter, ATP-binding protein', NULL, 'TIGR02315', NULL, NULL, 11803, 22),
(289001, NULL, 'TIGR04392', NULL, NULL, 'haoB_nitrify: hydroxylamine oxidation protein HaoB', NULL, 'TIGR04392', NULL, NULL, 22253, 22),
(289002, NULL, 'TIGR02322', NULL, NULL, 'phosphon_PhnN: phosphonate metabolism protein/1,5-bisphosphokinase (PRPP-forming) PhnN', NULL, 'TIGR02322', NULL, NULL, 11883, 22),
(289003, NULL, 'TIGR04385', NULL, NULL, 'B12_rSAM_cofa1: putative variant cofactor biosynthesis B12-binding domain/radical SAM domain protein 1', NULL, 'TIGR04385', NULL, NULL, 25294, 22),
(289004, NULL, 'TIGR01387', NULL, NULL, 'cztR_silR_copR: heavy metal response regulator', NULL, 'TIGR01387', NULL, NULL, 3788, 22),
(289005, NULL, 'TIGR00225', NULL, NULL, 'prc: C-terminal processing peptidase', NULL, 'TIGR00225', NULL, NULL, 7091, 22),
(289006, NULL, 'TIGR03919', NULL, NULL, 'T7SS_EccB: type VII secretion protein EccB', NULL, 'TIGR03919', NULL, NULL, 2237, 22),
(289007, NULL, 'TIGR03477', NULL, NULL, 'DMSO_red_II_gam: DMSO reductase family type II enzyme, heme b subunit', NULL, 'TIGR03477', NULL, NULL, 19880, 22),
(289008, NULL, 'TIGR00867', NULL, NULL, 'deg-1: degenerin', NULL, 'TIGR00867', NULL, NULL, 3593, 22),
(289009, NULL, 'TIGR01292', NULL, NULL, 'TRX_reduct: thioredoxin-disulfide reductase', NULL, 'TIGR01292', NULL, NULL, 1139, 22),
(289010, NULL, 'TIGR02957', NULL, NULL, 'SigX4: RNA polymerase sigma-70 factor, TIGR02957 family', NULL, 'TIGR02957', NULL, NULL, 9650, 22),
(289011, NULL, 'TIGR01632', NULL, NULL, 'L11_bact: ribosomal protein uL11', NULL, 'TIGR01632', NULL, NULL, 306, 22),
(289012, NULL, 'TIGR01802', NULL, NULL, 'CM_pl-yst: chorismate mutase', NULL, 'TIGR01802', NULL, NULL, 849, 22),
(289013, NULL, 'TIGR00697', NULL, NULL, 'TIGR00697: conserved hypothetical integral membrane protein', NULL, 'TIGR00697', NULL, NULL, 2380, 22),
(289014, NULL, 'TIGR01462', NULL, NULL, 'greA: transcription elongation factor GreA', NULL, 'TIGR01462', NULL, NULL, 5665, 22),
(289015, NULL, 'TIGR00402', NULL, NULL, 'napF: ferredoxin-type protein NapF', NULL, 'TIGR00402', NULL, NULL, 1870, 22),
(289016, NULL, 'TIGR01557', NULL, NULL, 'myb_SHAQKYF: myb-like DNA-binding domain, SHAQKYF class', NULL, 'TIGR01557', NULL, NULL, 6886, 22);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289017, NULL, 'TIGR02787', NULL, NULL, 'codY_Gpos: GTP-sensing transcriptional pleiotropic repressor CodY', NULL, 'TIGR02787', NULL, NULL, 14459, 22),
(289018, NULL, 'TIGR03005', NULL, NULL, 'ectoine_ehuA: ectoine/hydroxyectoine ABC transporter, ATP-binding protein EhuA', NULL, 'TIGR03005', NULL, NULL, 11116, 22),
(289019, NULL, 'TIGR00109', NULL, NULL, 'hemH: ferrochelatase', NULL, 'TIGR00109', NULL, NULL, 2295, 22),
(289020, NULL, 'TIGR03114', NULL, NULL, 'cas8u_csf1: CRISPR type AFERR-associated protein Csf1', NULL, 'TIGR03114', NULL, NULL, 14773, 22),
(289021, NULL, 'TIGR00588', NULL, NULL, 'ogg: 8-oxoguanine DNA-glycosylase (ogg)', NULL, 'TIGR00588', NULL, NULL, 542, 22),
(289022, NULL, 'TIGR02145', NULL, NULL, 'Fib_succ_major: fibrobacter succinogenes major paralogous domain', NULL, 'TIGR02145', NULL, NULL, 14481, 22),
(289023, NULL, 'TIGR00935', NULL, NULL, '2a45: arsenite/antimonite efflux pump membrane protein', NULL, 'TIGR00935', NULL, NULL, 4458, 22),
(289024, NULL, 'TIGR03593', NULL, NULL, 'yidC_nterm: membrane protein insertase, YidC/Oxa1 family, N-terminal domain', NULL, 'TIGR03593', NULL, NULL, 25735, 22),
(289025, NULL, 'TIGR04269', NULL, NULL, 'SAM_SPASM_FxsB: radical SAM/SPASM domain protein, FxsB family', NULL, 'TIGR04269', NULL, NULL, 24998, 22),
(289026, NULL, 'TIGR01571', NULL, NULL, 'A_thal_Cys_rich: uncharacterized Cys-rich domain', NULL, 'TIGR01571', NULL, NULL, 6654, 22),
(289027, NULL, 'TIGR03940', NULL, NULL, 'PGA_PgaD: poly-beta-1,6-N-acetyl-D-glucosamine biosynthesis protein PgaD', NULL, 'TIGR03940', NULL, NULL, 17752, 22),
(289028, NULL, 'TIGR01455', NULL, NULL, 'glmM: phosphoglucosamine mutase', NULL, 'TIGR01455', NULL, NULL, 4722, 22),
(289029, NULL, 'TIGR01278', NULL, NULL, 'DPOR_BchB: light-independent protochlorophyllide reductase, B subunit', NULL, 'TIGR01278', NULL, NULL, 1409, 22),
(289030, NULL, 'TIGR02424', NULL, NULL, 'TF_pcaQ: pca operon transcription factor PcaQ', NULL, 'TIGR02424', NULL, NULL, 9994, 22),
(289031, NULL, 'TIGR03926', NULL, NULL, 'T7_EssB: type VII secretion protein EssB', NULL, 'TIGR03926', NULL, NULL, 19090, 22),
(289032, NULL, 'TIGR04283', NULL, NULL, 'glyco_like_mftF: transferase 2, rSAM/selenodomain-associated', NULL, 'TIGR04283', NULL, NULL, 25198, 22),
(289033, NULL, 'TIGR00300', NULL, NULL, 'TIGR00300: TIGR00300 family protein', NULL, 'TIGR00300', NULL, NULL, 11476, 22),
(289034, NULL, 'TIGR02077', NULL, NULL, 'thr_lead_pep: thr operon leader peptide', NULL, 'TIGR02077', NULL, NULL, 10938, 22),
(289035, NULL, 'TIGR03579', NULL, NULL, 'EF_0833: conserved hypothetical protein EF_0833/AHA_3914', NULL, 'TIGR03579', NULL, NULL, 26201, 22),
(289036, NULL, 'TIGR03749', NULL, NULL, 'conj_TIGR03749: integrating conjugative element protein, PFL_4704 family', NULL, 'TIGR03749', NULL, NULL, 19910, 22),
(289037, NULL, 'TIGR04460', NULL, NULL, 'endura_MppR: enduracididine biosynthesis enzyme MppR', NULL, 'TIGR04460', NULL, NULL, 25977, 22),
(289038, NULL, 'TIGR01625', NULL, NULL, 'YidE_YbjL_dupl: AspT/YidE/YbjL antiporter duplication domain', NULL, 'TIGR01625', NULL, NULL, 6725, 22),
(289039, NULL, 'TIGR00881', NULL, NULL, '2A0104: phosphoglycerate transporter family protein', NULL, 'TIGR00881', NULL, NULL, NULL, 22),
(289040, NULL, 'TIGR00123', NULL, NULL, 'cbiM: cobalamin biosynthesis protein CbiM', NULL, 'TIGR00123', NULL, NULL, 11565, 22),
(289041, NULL, 'TIGR04439', NULL, NULL, 'histamin_N_OH: putative histamine N-monooxygenase', NULL, 'TIGR04439', NULL, NULL, 26261, 22),
(289042, NULL, 'TIGR03770', NULL, NULL, 'anch_rpt_perm: anchored repeat-type ABC transporter, permease subunit', NULL, 'TIGR03770', NULL, NULL, 15807, 22),
(289043, NULL, 'TIGR04446', NULL, NULL, 'pren_cyc_PirE: prenylated cyclic peptide, anacyclamide/piricyclamide family', NULL, 'TIGR04446', NULL, NULL, 26271, 22),
(289044, NULL, 'TIGR02261', NULL, NULL, 'benz_CoA_red_D: benzoyl-CoA reductase, subunit D', NULL, 'TIGR02261', NULL, NULL, 11485, 22),
(289045, NULL, 'TIGR04099', NULL, NULL, 'biosn_Pnap_2097: probable biosynthetic protein, Pnap_2097 family', NULL, 'TIGR04099', NULL, NULL, NULL, 22);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289046, NULL, 'TIGR00758', NULL, NULL, 'UDG_fam4: uracil-DNA glycosylase, family 4', NULL, 'TIGR00758', NULL, NULL, 4042, 22),
(289047, NULL, 'TIGR04453', NULL, NULL, 'Lepto_8Cys: Cys-rich protein, LA_1312 family', NULL, 'TIGR04453', NULL, NULL, 26354, 22),
(289048, NULL, 'TIGR03933', NULL, NULL, 'PIA_icaB: intercellular adhesin biosynthesis polysaccharide N-deacetylase', NULL, 'TIGR03933', NULL, NULL, 16919, 22),
(289049, NULL, 'TIGR03121', NULL, NULL, 'one_C_dehyd_A: formylmethanofuran dehydrogenase subunit A', NULL, 'TIGR03121', NULL, NULL, 10873, 22),
(289050, NULL, 'TIGR00928', NULL, NULL, 'purB: adenylosuccinate lyase', NULL, 'TIGR00928', NULL, NULL, 5050, 22),
(289051, NULL, 'TIGR02091', NULL, NULL, 'glgC: glucose-1-phosphate adenylyltransferase', NULL, 'TIGR02091', NULL, NULL, 13890, 22),
(289052, NULL, 'TIGR03763', NULL, NULL, 'cyanoexo_CrtA: cyanoexosortase A', NULL, 'TIGR03763', NULL, NULL, 16305, 22),
(289053, NULL, 'TIGR04276', NULL, NULL, 'FxsC_Cterm: FxsC C-terminal domain', NULL, 'TIGR04276', NULL, NULL, 24557, 22),
(289054, NULL, 'TIGR03036', NULL, NULL, 'trp_2_3_diox: tryptophan 2,3-dioxygenase', NULL, 'TIGR03036', NULL, NULL, 20521, 22),
(289055, NULL, 'TIGR01910', NULL, NULL, 'DapE-ArgE: peptidase, ArgE/DapE family', NULL, 'TIGR01910', NULL, NULL, 4071, 22),
(289056, NULL, 'TIGR00668', NULL, NULL, 'apaH: bis(5''-nucleosyl)-tetraphosphatase (symmetrical)', NULL, 'TIGR00668', NULL, NULL, 2296, 22),
(289057, NULL, 'TIGR00531', NULL, NULL, 'BCCP: acetyl-CoA carboxylase, biotin carboxyl carrier protein', NULL, 'TIGR00531', NULL, NULL, 2313, 22),
(289058, NULL, 'TIGR01807', NULL, NULL, 'CM_P2: chorismate mutase', NULL, 'TIGR01807', NULL, NULL, 2109, 22),
(289059, NULL, 'TIGR02685', NULL, NULL, 'pter_reduc_Leis: pteridine reductase', NULL, 'TIGR02685', NULL, NULL, 13100, 22),
(289060, NULL, 'TIGR02981', NULL, NULL, 'phageshock_pspE: phage shock operon rhodanese PspE', NULL, 'TIGR02981', NULL, NULL, 9673, 22),
(289061, NULL, 'TIGR00771', NULL, NULL, 'DcuC: transporter, anaerobic C4-dicarboxylate uptake C (DcuC) family', NULL, 'TIGR00771', NULL, NULL, 2937, 22),
(289062, NULL, 'TIGR03083', NULL, NULL, 'TIGR03083: uncharacterized Actinobacterial protein TIGR03083', NULL, 'TIGR03083', NULL, NULL, 14667, 22),
(289063, NULL, 'TIGR02205', NULL, NULL, 'septum_zipA: cell division protein ZipA', NULL, 'TIGR02205', NULL, NULL, 11171, 22),
(289064, NULL, 'TIGR00475', NULL, NULL, 'selB: selenocysteine-specific translation elongation factor', NULL, 'TIGR00475', NULL, NULL, 1693, 22),
(289065, NULL, 'TIGR02501', NULL, NULL, 'type_III_yscE: type III secretion system protein, YseE family', NULL, 'TIGR02501', NULL, NULL, 12630, 22),
(289066, NULL, 'TIGR00282', NULL, NULL, 'TIGR00282: metallophosphoesterase, MG_246/BB_0505 family', NULL, 'TIGR00282', NULL, NULL, 11412, 22),
(289067, NULL, 'TIGR03276', NULL, NULL, 'Phn-HD: phosphonate degradation operons associated HDIG domain protein', NULL, 'TIGR03276', NULL, NULL, 17383, 22),
(289068, NULL, 'TIGR02878', NULL, NULL, 'spore_ypjB: sporulation protein YpjB', NULL, 'TIGR02878', NULL, NULL, 10695, 22),
(289069, NULL, 'TIGR01854', NULL, NULL, 'lipid_A_lpxH: UDP-2,3-diacylglucosamine diphosphatase', NULL, 'TIGR01854', NULL, NULL, 10662, 22),
(289070, NULL, 'TIGR01499', NULL, NULL, 'folC: bifunctional protein FolC', NULL, 'TIGR01499', NULL, NULL, 3125, 22),
(289071, NULL, 'TIGR02934', NULL, NULL, 'nifT_nitrog: probable nitrogen fixation protein FixT', NULL, 'TIGR02934', NULL, NULL, 12159, 22),
(289072, NULL, 'TIGR03572', NULL, NULL, 'WbuZ: glycosyl amidation-associated protein WbuZ', NULL, 'TIGR03572', NULL, NULL, 17535, 22),
(289073, NULL, 'TIGR01122', NULL, NULL, 'ilvE_I: branched-chain amino acid aminotransferase', NULL, 'TIGR01122', NULL, NULL, 5753, 22),
(289074, NULL, 'TIGR02492', NULL, NULL, 'flgK_ends: flagellar hook-associated protein FlgK', NULL, 'TIGR02492', NULL, NULL, 6094, 22),
(289075, NULL, 'TIGR01259', NULL, NULL, 'comE: comEA protein', NULL, 'TIGR01259', NULL, NULL, 5087, 22),
(289076, NULL, 'TIGR02149', NULL, NULL, 'glgA_Coryne: glycogen synthase, Corynebacterium family', NULL, 'TIGR02149', NULL, NULL, 14156, 22);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289077, NULL, 'TIGR04222', NULL, NULL, 'near_uncomplex: TIGR04222 domain', NULL, 'TIGR04222', NULL, NULL, 25404, 22),
(289078, NULL, 'TIGR03332', NULL, NULL, 'salvage_mtnW: 2,3-diketo-5-methylthiopentyl-1-phosphate enolase', NULL, 'TIGR03332', NULL, NULL, 17555, 22),
(289079, NULL, 'TIGR03824', NULL, NULL, 'FlgM_jcvi: flagellar biosynthesis anti-sigma factor FlgM', NULL, 'TIGR03824', NULL, NULL, 3627, 22),
(289080, NULL, 'TIGR04163', NULL, NULL, 'rSAM_cobopep: peptide-modifying radical SAM enzyme CbpB', NULL, 'TIGR04163', NULL, NULL, 21055, 22),
(289081, NULL, 'TIGR03765', NULL, NULL, 'ICE_PFL_4695: integrating conjugative element protein, PFL_4695 family', NULL, 'TIGR03765', NULL, NULL, 17696, 22),
(289082, NULL, 'TIGR00235', NULL, NULL, 'udk: uridine kinase', NULL, 'TIGR00235', NULL, NULL, 3563, 22),
(289083, NULL, 'TIGR02741', NULL, NULL, 'TraQ: type-F conjugative transfer system pilin chaperone TraQ', NULL, 'TIGR02741', NULL, NULL, 13892, 22),
(289084, NULL, 'TIGR03768', NULL, NULL, 'RPA4764: metallophosphoesterase, RPA4764 family', NULL, 'TIGR03768', NULL, NULL, 16315, 22),
(289085, NULL, 'TIGR01066', NULL, NULL, 'rplM_bact: ribosomal protein uL13', NULL, 'TIGR01066', NULL, NULL, 6730, 22),
(289086, NULL, 'TIGR04415', NULL, NULL, 'O_hepto_targRPT: autotransporter passenger strand-loop-strand repeat', NULL, 'TIGR04415', NULL, NULL, 26294, 22),
(289087, NULL, 'TIGR00042', NULL, NULL, 'TIGR00042: non-canonical purine NTP pyrophosphatase, RdgB/HAM1 family', NULL, 'TIGR00042', NULL, NULL, 2878, 22),
(289088, NULL, 'TIGR01318', NULL, NULL, 'gltD_gamma_fam: glutamate synthase, small subunit', NULL, 'TIGR01318', NULL, NULL, 1420, 22),
(289089, NULL, 'TIGR04116', NULL, NULL, 'CXXX_rpt_assoc: CXXX repeat peptide modification system protein', NULL, 'TIGR04116', NULL, NULL, 21037, 22),
(289090, NULL, 'TIGR01555', NULL, NULL, 'phge_rel_HI1409: phage-associated protein, HI1409 family', NULL, 'TIGR01555', NULL, NULL, 6892, 22),
(289091, NULL, 'TIGR02800', NULL, NULL, 'propeller_TolB: Tol-Pal system beta propeller repeat protein TolB', NULL, 'TIGR02800', NULL, NULL, 8560, 22),
(289092, NULL, 'TIGR00727', NULL, NULL, 'ISP4_OPT: small oligopeptide transporter, OPT family', NULL, 'TIGR00727', NULL, NULL, 2900, 22),
(289093, NULL, 'TIGR01365', NULL, NULL, 'serC_2: phosphoserine aminotransferase', NULL, 'TIGR01365', NULL, NULL, 3736, 22),
(289094, NULL, 'TIGR02193', NULL, NULL, 'heptsyl_trn_I: lipopolysaccharide heptosyltransferase I', NULL, 'TIGR02193', NULL, NULL, 12412, 22),
(289095, NULL, 'TIGR01661', NULL, NULL, 'ELAV_HUD_SF: ELAV/HuD family splicing factor', NULL, 'TIGR01661', NULL, NULL, 183, 22),
(289096, NULL, 'TIGR01851', NULL, NULL, 'argC_other: N-acetyl-gamma-glutamyl-phosphate reductase', NULL, 'TIGR01851', NULL, NULL, 10760, 22),
(289097, NULL, 'TIGR03335', NULL, NULL, 'F390_ftsA: coenzyme F390 synthetase', NULL, 'TIGR03335', NULL, NULL, 17697, 22),
(289098, NULL, 'TIGR03525', NULL, NULL, 'GldK: gliding motility-associated lipoprotein GldK', NULL, 'TIGR03525', NULL, NULL, 16766, 22),
(289099, NULL, 'TIGR00917', NULL, NULL, '2A060601: Niemann-Pick C type protein family', NULL, 'TIGR00917', NULL, NULL, 5109, 22),
(289100, NULL, 'TIGR04359', NULL, NULL, 'TrbK_RP4: entry exclusion lipoprotein TrbK', NULL, 'TIGR04359', NULL, NULL, 23312, 22),
(289101, NULL, 'TIGR02146', NULL, NULL, 'LysS_fung_arch: homocitrate synthase', NULL, 'TIGR02146', NULL, NULL, 14228, 22),
(289102, NULL, 'TIGR00179', NULL, NULL, 'murB: UDP-N-acetylenolpyruvoylglucosamine reductase', NULL, 'TIGR00179', NULL, NULL, 1983, 22),
(289103, NULL, 'TIGR01614', NULL, NULL, 'PME_inhib: pectinesterase inhibitor domain', NULL, 'TIGR01614', NULL, NULL, 6731, 22),
(289104, NULL, 'TIGR01804', NULL, NULL, 'BADH: betaine-aldehyde dehydrogenase', NULL, 'TIGR01804', NULL, NULL, 11319, 22),
(289105, NULL, 'TIGR02442', NULL, NULL, 'Cob-chelat-sub: cobaltochelatase subunit', NULL, 'TIGR02442', NULL, NULL, 12724, 22),
(289106, NULL, 'TIGR02389', NULL, NULL, 'RNA_pol_rpoA2: DNA-directed RNA polymerase, subunit A''''', NULL, 'TIGR02389', NULL, NULL, 9663, 22);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289107, NULL, 'TIGR02579', NULL, NULL, 'cas_csx3: CRISPR-associated protein, Csx3 family', NULL, 'TIGR02579', NULL, NULL, 9344, 22),
(289108, NULL, 'TIGR00472', NULL, NULL, 'pheT_bact: phenylalanine--tRNA ligase, beta subunit', NULL, 'TIGR00472', NULL, NULL, 1763, 22),
(289109, NULL, 'TIGR00964', NULL, NULL, 'secE_bact: preprotein translocase, SecE subunit', NULL, 'TIGR00964', NULL, NULL, 5805, 22),
(289110, NULL, 'TIGR02252', NULL, NULL, 'DREG-2: HAD hydrolase, REG-2-like, family IA', NULL, 'TIGR02252', NULL, NULL, 11164, 22),
(289111, NULL, 'TIGR01019', NULL, NULL, 'sucCoAalpha: succinate-CoA ligase, alpha subunit', NULL, 'TIGR01019', NULL, NULL, 5670, 22),
(289112, NULL, 'TIGR03229', NULL, NULL, 'benzo_1_2_benA: benzoate 1,2-dioxygenase, large subunit', NULL, 'TIGR03229', NULL, NULL, 16990, 22),
(289113, NULL, 'TIGR04462', NULL, NULL, 'endura_MppP: enduracididine biosynthesis enzyme MppP', NULL, 'TIGR04462', NULL, NULL, 25574, 22),
(289114, NULL, 'TIGR01988', NULL, NULL, 'Ubi-OHases: ubiquinone biosynthesis hydroxylase, UbiH/UbiF/VisC/COQ6 family', NULL, 'TIGR01988', NULL, NULL, 2269, 22),
(289115, NULL, 'TIGR01798', NULL, NULL, 'cit_synth_I: citrate (Si)-synthase', NULL, 'TIGR01798', NULL, NULL, 1810, 22),
(289116, NULL, 'TIGR03033', NULL, NULL, 'phage_rel_nuc: putative phage-type endonuclease', NULL, 'TIGR03033', NULL, NULL, 20790, 22),
(289117, NULL, 'TIGR00774', NULL, NULL, 'NhaB: Na+/H+ antiporter NhaB', NULL, 'TIGR00774', NULL, NULL, 2742, 22),
(289118, NULL, 'TIGR02448', NULL, NULL, 'TIGR02448: conserverd hypothetical protein', NULL, 'TIGR02448', NULL, NULL, 10660, 22),
(289119, NULL, 'TIGR03871', NULL, NULL, 'ABC_peri_MoxJ_2: quinoprotein dehydrogenase-associated probable ABC transporter substrate-binding protein', NULL, 'TIGR03871', NULL, NULL, 15924, 22),
(289120, NULL, 'TIGR02638', NULL, NULL, 'lactal_redase: lactaldehyde reductase', NULL, 'TIGR02638', NULL, NULL, 9355, 22),
(289121, NULL, 'TIGR03226', NULL, NULL, 'PhnU: 2-aminoethylphosphonate ABC transporter, permease protein', NULL, 'TIGR03226', NULL, NULL, 16993, 22),
(289122, NULL, 'TIGR02208', NULL, NULL, 'lipid_A_msbB: lipid A biosynthesis (KDO)2-(lauroyl)-lipid IVA acyltransferase', NULL, 'TIGR02208', NULL, NULL, 11415, 22),
(289123, NULL, 'TIGR00618', NULL, NULL, 'sbcc: exonuclease SbcC', NULL, 'TIGR00618', NULL, NULL, 812, 22),
(289124, NULL, 'TIGR01256', NULL, NULL, 'modA: molybdate ABC transporter, periplasmic molybdate-binding protein', NULL, 'TIGR01256', NULL, NULL, 261, 22),
(289125, NULL, 'TIGR00285', NULL, NULL, 'TIGR00285: DNA-binding protein Alba', NULL, 'TIGR00285', NULL, NULL, 9652, 22),
(289126, NULL, 'TIGR00858', NULL, NULL, 'bioF: 8-amino-7-oxononanoate synthase', NULL, 'TIGR00858', NULL, NULL, 3047, 22),
(289127, NULL, 'TIGR01496', NULL, NULL, 'DHPS: dihydropteroate synthase', NULL, 'TIGR01496', NULL, NULL, 5535, 22),
(289128, NULL, 'TIGR02635', NULL, NULL, 'RhaI_grampos: L-rhamnose isomerase', NULL, 'TIGR02635', NULL, NULL, 9342, 22),
(289129, NULL, 'TIGR02791', NULL, NULL, 'VirB5: P-type DNA transfer protein VirB5', NULL, 'TIGR02791', NULL, NULL, 14367, 22),
(289130, NULL, 'TIGR00341', NULL, NULL, 'TIGR00341: TIGR00341 family protein', NULL, 'TIGR00341', NULL, NULL, NULL, 22),
(289131, NULL, 'TIGR01617', NULL, NULL, 'arsC_related: transcriptional regulator, Spx/MgsR family', NULL, 'TIGR01617', NULL, NULL, 7340, 22),
(289132, NULL, 'TIGR03039', NULL, NULL, 'PS_II_CP47: photosystem II chlorophyll-binding protein CP47', NULL, 'TIGR03039', NULL, NULL, 20689, 22),
(289133, NULL, 'TIGR01209', NULL, NULL, 'TIGR01209: RNA ligase, Pab1020 family', NULL, 'TIGR01209', NULL, NULL, 1154, 22),
(289134, NULL, 'TIGR00238', NULL, NULL, 'TIGR00238: KamA family protein', NULL, 'TIGR00238', NULL, NULL, 2409, 22),
(289135, NULL, 'TIGR00665', NULL, NULL, 'DnaB: replicative DNA helicase', NULL, 'TIGR00665', NULL, NULL, 1325, 22),
(289136, NULL, 'TIGR01312', NULL, NULL, 'XylB: xylulokinase', NULL, 'TIGR01312', NULL, NULL, 1194, 22),
(289137, NULL, 'TIGR03382', NULL, NULL, 'GC_trans_RRR: Myxococcales GC_trans_RRR domain', NULL, 'TIGR03382', NULL, NULL, 18628, 22);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289138, NULL, 'TIGR03762', NULL, NULL, 'archaeo_artC: archaeosortase C', NULL, 'TIGR03762', NULL, NULL, 16019, 22),
(289139, NULL, 'TIGR02744', NULL, NULL, 'TrbI_Ftype: type-F conjugative transfer system protein TrbI', NULL, 'TIGR02744', NULL, NULL, 13759, 22),
(289140, NULL, 'TIGR02087', NULL, NULL, 'LEUD_arch: 3-isopropylmalate dehydratase, small subunit', NULL, 'TIGR02087', NULL, NULL, 13969, 22),
(289141, NULL, 'TIGR01069', NULL, NULL, 'mutS2: MutS2 family protein', NULL, 'TIGR01069', NULL, NULL, 4909, 22),
(289142, NULL, 'TIGR02984', NULL, NULL, 'Sig-70_plancto1: RNA polymerase sigma-70 factor, Planctomycetaceae-specific subfamily 1', NULL, 'TIGR02984', NULL, NULL, 9584, 22),
(289143, NULL, 'TIGR01792', NULL, NULL, 'urease_alph: urease, alpha subunit', NULL, 'TIGR01792', NULL, NULL, 5851, 22),
(289144, NULL, 'TIGR03899', NULL, NULL, 'TIGR03899: TIGR03899 family protein', NULL, 'TIGR03899', NULL, NULL, 17676, 22),
(289145, NULL, 'TIGR03080', NULL, NULL, 'CH4_NH3mon_ox_A: methane monooxygenase/ammonia monooxygenase, subunit A', NULL, 'TIGR03080', NULL, NULL, 5198, 22),
(289146, NULL, 'TIGR04412', NULL, NULL, 'T2SS_GspM_XcpZ: type II secretion system protein M', NULL, 'TIGR04412', NULL, NULL, 26416, 22),
(289147, NULL, 'TIGR04549', NULL, NULL, 'LP_HExxH_w_tonB: substrate import-associated zinc metallohydrolase lipoprotein', NULL, 'TIGR04549', NULL, NULL, 25244, 22),
(289148, NULL, 'TIGR03634', NULL, NULL, 'arc_protsome_B: proteasome endopeptidase complex, archaeal, beta subunit', NULL, 'TIGR03634', NULL, NULL, 11582, 22),
(289149, NULL, 'TIGR03575', NULL, NULL, 'selen_PSTK_euk: L-seryl-tRNA(Sec) kinase', NULL, 'TIGR03575', NULL, NULL, 17612, 22),
(289150, NULL, 'TIGR00478', NULL, NULL, 'tly: TlyA family rRNA methyltransferase/putative hemolysin', NULL, 'TIGR00478', NULL, NULL, 1699, 22),
(289151, NULL, 'TIGR04225', NULL, NULL, 'CshA_fibril_rpt: CshA-type fibril repeat', NULL, 'TIGR04225', NULL, NULL, 21296, 22),
(289152, NULL, 'TIGR00101', NULL, NULL, 'ureG: urease accessory protein UreG', NULL, 'TIGR00101', NULL, NULL, 5747, 22),
(289153, NULL, 'TIGR04353', NULL, NULL, 'PqqD_rel_X: PqqD family protein, HPr-rel-A system', NULL, 'TIGR04353', NULL, NULL, 23387, 22),
(289154, NULL, 'TIGR04032', NULL, NULL, 'toxin_SdpC: antimicrobial peptide, SdpC family', NULL, 'TIGR04032', NULL, NULL, 17755, 22),
(289155, NULL, 'TIGR01128', NULL, NULL, 'holA: DNA polymerase III, delta subunit', NULL, 'TIGR01128', NULL, NULL, 5585, 22),
(289156, NULL, 'TIGR01508', NULL, NULL, 'rib_reduct_arch: diaminohydroxyphosphoribosylaminopyrimidine reductase', NULL, 'TIGR01508', NULL, NULL, 5518, 22),
(289157, NULL, 'TIGR02803', NULL, NULL, 'ExbD_1: TonB system transport protein ExbD', NULL, 'TIGR02803', NULL, NULL, 8699, 22),
(289158, NULL, 'TIGR01449', NULL, NULL, 'PGP_bact: phosphoglycolate phosphatase, bacterial', NULL, 'TIGR01449', NULL, NULL, 4971, 22),
(289159, NULL, 'TIGR02682', NULL, NULL, 'cas_csx11: CRISPR-associated protein, Csx11 family', NULL, 'TIGR02682', NULL, NULL, 13282, 22),
(289160, NULL, 'TIGR03958', NULL, NULL, 'monoFe_hyd_HmdC: 5,10-methenyltetrahydromethanopterin hydrogenase cofactor biosynthesis protein HmdC', NULL, 'TIGR03958', NULL, NULL, 21059, 22),
(289161, NULL, 'TIGR04166', NULL, NULL, 'methano_MtrB: tetrahydromethanopterin S-methyltransferase, subunit B', NULL, 'TIGR04166', NULL, NULL, 13335, 22),
(289162, NULL, 'TIGR04546', NULL, NULL, 'rSAM_ahbC_deAc: 12,18-didecarboxysiroheme deacetylase', NULL, 'TIGR04546', NULL, NULL, 25207, 22),
(289163, NULL, 'TIGR03528', NULL, NULL, '2_3_DAP_am_ly: diaminopropionate ammonia-lyase', NULL, 'TIGR03528', NULL, NULL, 16837, 22),
(289164, NULL, 'TIGR00830', NULL, NULL, 'PTBA: PTS system, glucose subfamily, IIA component', NULL, 'TIGR00830', NULL, NULL, 1944, 22),
(289165, NULL, 'TIGR00967', NULL, NULL, '3a0501s007: preprotein translocase, SecY subunit', NULL, 'TIGR00967', NULL, NULL, 58, 22),
(289166, NULL, 'TIGR02987', NULL, NULL, 'met_A_Alw26: type II restriction m6 adenine DNA methyltransferase, Alw26I/Eco31I/Esp3I family', NULL, 'TIGR02987', NULL, NULL, 9842, 22);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289167, NULL, 'TIGR01938', NULL, NULL, 'nqrC: NADH:ubiquinone oxidoreductase, Na(+)-translocating, C subunit', NULL, 'TIGR01938', NULL, NULL, 4170, 22),
(289168, NULL, 'TIGR02850', NULL, NULL, 'spore_sigG: RNA polymerase sigma-G factor', NULL, 'TIGR02850', NULL, NULL, 9122, 22),
(289169, NULL, 'TIGR00176', NULL, NULL, 'mobB: molybdopterin-guanine dinucleotide biosynthesis protein B', NULL, 'TIGR00176', NULL, NULL, 7330, 22),
(289170, NULL, 'TIGR01801', NULL, NULL, 'CM_A: chorismate mutase', NULL, 'TIGR01801', NULL, NULL, 1717, 22),
(289171, NULL, 'TIGR01315', NULL, NULL, '5C_CHO_kinase: FGGY-family pentulose kinase', NULL, 'TIGR01315', NULL, NULL, 1151, 22),
(289172, NULL, 'TIGR02937', NULL, NULL, 'sigma70-ECF: RNA polymerase sigma factor, sigma-70 family', NULL, 'TIGR02937', NULL, NULL, 8673, 22),
(289173, NULL, 'TIGR03441', NULL, NULL, 'urea_trans_yut: urea transporter', NULL, 'TIGR03441', NULL, NULL, 19052, 22),
(289174, NULL, 'TIGR02529', NULL, NULL, 'EutJ: ethanolamine utilization protein EutJ family protein', NULL, 'TIGR02529', NULL, NULL, 18591, 22),
(289175, NULL, 'TIGR03821', NULL, NULL, 'EFP_modif_epmB: EF-P beta-lysylation protein EpmB', NULL, 'TIGR03821', NULL, NULL, 15575, 22),
(289176, NULL, 'TIGR01558', NULL, NULL, 'sm_term_P27: putative phage terminase, small subunit, P27 family', NULL, 'TIGR01558', NULL, NULL, 6689, 22),
(289177, NULL, 'TIGR01985', NULL, NULL, 'phasin_2: phasin', NULL, 'TIGR01985', NULL, NULL, 4332, 22),
(289178, NULL, 'TIGR03908', NULL, NULL, 'QH_alpha: quinohemoprotein amine dehydrogenase, alpha subunit', NULL, 'TIGR03908', NULL, NULL, 17858, 22),
(289179, NULL, 'TIGR01060', NULL, NULL, 'eno: phosphopyruvate hydratase', NULL, 'TIGR01060', NULL, NULL, 3263, 22),
(289180, NULL, 'TIGR00724', NULL, NULL, 'urea_amlyse_rel: biotin-dependent carboxylase uncharacterized domain', NULL, 'TIGR00724', NULL, NULL, 3496, 22),
(289181, NULL, 'TIGR01664', NULL, NULL, 'DNA-3''-Pase: DNA 3''-phosphatase', NULL, 'TIGR01664', NULL, NULL, 126, 22),
(289182, NULL, 'TIGR03030', NULL, NULL, 'CelA: cellulose synthase catalytic subunit (UDP-forming)', NULL, 'TIGR03030', NULL, NULL, 6011, 22),
(289183, NULL, 'TIGR03089', NULL, NULL, 'TIGR03089: TIGR03089 family protein', NULL, 'TIGR03089', NULL, NULL, 14703, 22),
(289184, NULL, 'TIGR03167', NULL, NULL, 'tRNA_sel_U_synt: tRNA 2-selenouridine synthase', NULL, 'TIGR03167', NULL, NULL, 15620, 22),
(289185, NULL, 'TIGR02012', NULL, NULL, 'tigrfam_recA: protein RecA', NULL, 'TIGR02012', NULL, NULL, 7303, 22),
(289186, NULL, 'TIGR02314', NULL, NULL, 'ABC_MetN: D-methionine ABC transporter, ATP-binding protein', NULL, 'TIGR02314', NULL, NULL, 11691, 22),
(289187, NULL, 'TIGR03469', NULL, NULL, 'HpnB: hopene-associated glycosyltransferase HpnB', NULL, 'TIGR03469', NULL, NULL, 19586, 22),
(289188, NULL, 'TIGR00391', NULL, NULL, 'hydA: hydrogenase (NiFe) small subunit (hydA)', NULL, 'TIGR00391', NULL, NULL, 4482, 22),
(289189, NULL, 'TIGR04119', NULL, NULL, 'CXXX_matur: CXXX repeat peptide maturase', NULL, 'TIGR04119', NULL, NULL, 22955, 22),
(289190, NULL, 'TIGR01421', NULL, NULL, 'gluta_reduc_1: glutathione-disulfide reductase', NULL, 'TIGR01421', NULL, NULL, 4885, 22),
(289191, NULL, 'TIGR00129', NULL, NULL, 'fdhD_narQ: formate dehydrogenase family accessory protein FdhD', NULL, 'TIGR00129', NULL, NULL, 3222, 22),
(289192, NULL, 'TIGR01362', NULL, NULL, 'KDO8P_synth: 3-deoxy-8-phosphooctulonate synthase', NULL, 'TIGR01362', NULL, NULL, 3925, 22),
(289193, NULL, 'TIGR02196', NULL, NULL, 'GlrX_YruB: glutaredoxin-like protein, YruB-family', NULL, 'TIGR02196', NULL, NULL, 12027, 22),
(289194, NULL, 'TIGR01206', NULL, NULL, 'lysW: lysine biosynthesis protein LysW', NULL, 'TIGR01206', NULL, NULL, 436, 22),
(289195, NULL, 'TIGR03980', NULL, NULL, 'prismane_assoc: hybrid cluster protein-associated redox disulfide domain', NULL, 'TIGR03980', NULL, NULL, 17785, 22),
(289196, NULL, 'TIGR01446', NULL, NULL, 'DnaD_dom: DnaD domain protein', NULL, 'TIGR01446', NULL, NULL, 4528, 22),
(289197, NULL, 'TIGR04571', NULL, NULL, 'LmtA_Leptospira: lipid A Kdo2 1-phosphate O-methyltransferase', NULL, 'TIGR04571', NULL, NULL, 26218, 22);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289198, NULL, 'TIGR01686', NULL, NULL, 'FkbH: FkbH domain', NULL, 'TIGR01686', NULL, NULL, 5105, 22),
(289199, NULL, 'TIGR04468', NULL, NULL, 'arg_2_3_am_muta: arginine 2,3-aminomutase', NULL, 'TIGR04468', NULL, NULL, 25848, 22),
(289200, NULL, 'TIGR00095', NULL, NULL, 'TIGR00095: 16S rRNA (guanine(966)-N(2))-methyltransferase RsmD', NULL, 'TIGR00095', NULL, NULL, 5575, 22),
(289201, NULL, 'TIGR01770', NULL, NULL, 'NDH_I_N: proton-translocating NADH-quinone oxidoreductase, chain N', NULL, 'TIGR01770', NULL, NULL, 2288, 22),
(289202, NULL, 'TIGR04331', NULL, NULL, 'o_ant_LIC12162: putative transferase, LIC12162 family', NULL, 'TIGR04331', NULL, NULL, 26717, 22),
(289203, NULL, 'TIGR04007', NULL, NULL, 'wcaI: colanic acid biosynthesis glycosyltransferase WcaI', NULL, 'TIGR04007', NULL, NULL, 18020, 22),
(289204, NULL, 'TIGR04275', NULL, NULL, 'beta_prop_Msarc: beta propeller repeat', NULL, 'TIGR04275', NULL, NULL, 22851, 22),
(289205, NULL, 'TIGR02825', NULL, NULL, 'B4_12hDH: leukotriene B4 12-hydroxydehydrogenase/15-oxo-prostaglandin 13-reductase', NULL, 'TIGR02825', NULL, NULL, 8771, 22),
(289206, NULL, 'TIGR00855', NULL, NULL, 'L12: ribosomal protein bL12', NULL, 'TIGR00855', NULL, NULL, 3982, 22),
(289207, NULL, 'TIGR03656', NULL, NULL, 'IsdC: heme uptake protein IsdC', NULL, 'TIGR03656', NULL, NULL, 11781, 22),
(289208, NULL, 'TIGR02498', NULL, NULL, 'type_III_ssaH: type III secretion system protein, SsaH family', NULL, 'TIGR02498', NULL, NULL, 9450, 22),
(289209, NULL, 'TIGR02277', NULL, NULL, 'PaaX_trns_reg: phenylacetic acid degradation operon negative regulatory protein PaaX', NULL, 'TIGR02277', NULL, NULL, 11418, 22),
(289210, NULL, 'TIGR03877', NULL, NULL, 'thermo_KaiC_1: KaiC domain protein, Ph0284 family', NULL, 'TIGR03877', NULL, NULL, 15970, 22),
(289211, NULL, 'TIGR03192', NULL, NULL, 'benz_CoA_bzdQ: benzoyl-CoA reductase, bzd-type, Q subunit', NULL, 'TIGR03192', NULL, NULL, 16206, 22),
(289212, NULL, 'TIGR03952', NULL, NULL, 'metzin_BF0631: zinc-dependent metalloproteinase lipoprotein, BF0631 family', NULL, 'TIGR03952', NULL, NULL, 16668, 22),
(289213, NULL, 'TIGR00422', NULL, NULL, 'valS: valine--tRNA ligase', NULL, 'TIGR00422', NULL, NULL, 4388, 22),
(289214, NULL, 'TIGR03270', NULL, NULL, 'methan_mark_4: putative methanogen marker protein 4', NULL, 'TIGR03270', NULL, NULL, 21434, 22),
(289215, NULL, 'TIGR00344', NULL, NULL, 'alaS: alanine--tRNA ligase', NULL, 'TIGR00344', NULL, NULL, 5853, 22),
(289216, NULL, 'TIGR03712', NULL, NULL, 'acc_sec_asp2: accessory Sec system protein Asp2', NULL, 'TIGR03712', NULL, NULL, 15881, 22),
(289217, NULL, 'TIGR03444', NULL, NULL, 'EgtA_Cys_ligase: ergothioneine biosynthesis glutamate--cysteine ligase EgtA', NULL, 'TIGR03444', NULL, NULL, 19109, 22),
(289218, NULL, 'TIGR00104', NULL, NULL, 'tRNA_TsaA: tRNA-Thr(GGU) m(6)t(6)A37 methyltransferase TsaA', NULL, 'TIGR00104', NULL, NULL, 15800, 22),
(289219, NULL, 'TIGR00559', NULL, NULL, 'pdxJ: pyridoxine 5''-phosphate synthase', NULL, 'TIGR00559', NULL, NULL, 730, 22),
(289220, NULL, 'TIGR01982', NULL, NULL, 'UbiB: 2-polyprenylphenol 6-hydroxylase', NULL, 'TIGR01982', NULL, NULL, 4381, 22),
(289221, NULL, 'TIGR04110', NULL, NULL, 'heme_HutZ: heme utilization protein HutZ', NULL, 'TIGR04110', NULL, NULL, 7666, 22),
(289222, NULL, 'TIGR00170', NULL, NULL, 'leuC: 3-isopropylmalate dehydratase, large subunit', NULL, 'TIGR00170', NULL, NULL, 7408, 22),
(289223, NULL, 'TIGR01013', NULL, NULL, '2a58: sodium-dependent inorganic phosphate (Pi) transporter', NULL, 'TIGR01013', NULL, NULL, 3205, 22),
(289224, NULL, 'TIGR04543', NULL, NULL, 'ketoArg_3Met: 2-ketoarginine methyltransferase', NULL, 'TIGR04543', NULL, NULL, 25203, 22),
(289225, NULL, 'TIGR04035', NULL, NULL, 'glucan_65_rpt: glucan-binding repeat', NULL, 'TIGR04035', NULL, NULL, 23306, 22),
(289226, NULL, 'TIGR02610', NULL, NULL, 'PHA_gran_rgn: putative polyhydroxyalkanoic acid system protein', NULL, 'TIGR02610', NULL, NULL, 9183, 22),
(289227, NULL, 'TIGR02613', NULL, NULL, 'mob_myst_B: mobile mystery protein B', NULL, 'TIGR02613', NULL, NULL, 9001, 22);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289228, NULL, 'TIGR02037', NULL, NULL, 'degP_htrA_DO: peptidase Do', NULL, 'TIGR02037', NULL, NULL, 13339, 22),
(289229, NULL, 'TIGR00615', NULL, NULL, 'recR: recombination protein RecR', NULL, 'TIGR00615', NULL, NULL, 2576, 22),
(289230, NULL, 'TIGR02361', NULL, NULL, 'dak_ATP: dihydroxyacetone kinase', NULL, 'TIGR02361', NULL, NULL, 11818, 22),
(289231, NULL, 'TIGR00880', NULL, NULL, '2_A_01_02: multidrug resistance protein', NULL, 'TIGR00880', NULL, NULL, 3930, 22),
(289232, NULL, 'TIGR03164', NULL, NULL, 'UHCUDC: OHCU decarboxylase', NULL, 'TIGR03164', NULL, NULL, 15888, 22),
(289233, NULL, 'TIGR00316', NULL, NULL, 'cdhC: CO dehydrogenase/CO-methylating acetyl-CoA synthase complex, beta subunit', NULL, 'TIGR00316', NULL, NULL, 7307, 22),
(289234, NULL, 'TIGR03578', NULL, NULL, 'EF_0831: conserved hypothetical protein EF_0831/AHA_3912', NULL, 'TIGR03578', NULL, NULL, 17672, 22),
(289235, NULL, 'TIGR00210', NULL, NULL, 'gltS: sodium/glutamate symporter', NULL, 'TIGR00210', NULL, NULL, 7406, 22),
(289236, NULL, 'TIGR00400', NULL, NULL, 'mgtE: magnesium transporter', NULL, 'TIGR00400', NULL, NULL, 1848, 22),
(289237, NULL, 'TIGR00347', NULL, NULL, 'bioD: dethiobiotin synthase', NULL, 'TIGR00347', NULL, NULL, 7060, 22),
(289238, NULL, 'TIGR01194', NULL, NULL, 'cyc_pep_trnsptr: cyclic peptide transporter', NULL, 'TIGR01194', NULL, NULL, 6530, 22),
(289239, NULL, 'TIGR03955', NULL, NULL, 'rSAM_HydG: [FeFe] hydrogenase H-cluster radical SAM maturase HydG', NULL, 'TIGR03955', NULL, NULL, 15865, 22),
(289240, NULL, 'TIGR00537', NULL, NULL, 'hemK_rel_arch: putative methylase', NULL, 'TIGR00537', NULL, NULL, 887, 22),
(289241, NULL, 'TIGR02853', NULL, NULL, 'spore_dpaA: dipicolinic acid synthetase, A subunit', NULL, 'TIGR02853', NULL, NULL, 10677, 22),
(289242, NULL, 'TIGR02383', NULL, NULL, 'Hfq: RNA chaperone Hfq', NULL, 'TIGR02383', NULL, NULL, 831, 22),
(289243, NULL, 'TIGR02573', NULL, NULL, 'LcrG_PcrG: type III secretion protein LcrG', NULL, 'TIGR02573', NULL, NULL, 14467, 22),
(289244, NULL, 'TIGR00107', NULL, NULL, 'deoD: purine nucleoside phosphorylase', NULL, 'TIGR00107', NULL, NULL, 5573, 22),
(289245, NULL, 'TIGR03204', NULL, NULL, 'pimC_large: pimeloyl-CoA dehydrogenase, large subunit', NULL, 'TIGR03204', NULL, NULL, 16486, 22),
(289246, NULL, 'TIGR04169', NULL, NULL, 'perox_w_seleSAM: alkylhydroperoxidase/carboxymuconolactone decarboxylase family protein', NULL, 'TIGR04169', NULL, NULL, 23315, 22),
(289247, NULL, 'TIGR01234', NULL, NULL, 'L-ribulokinase: ribulokinase', NULL, 'TIGR01234', NULL, NULL, 140, 22),
(289248, NULL, 'TIGR01726', NULL, NULL, 'HEQRo_perm_3TM: amino ABC transporter, permease protein, 3-TM region, His/Glu/Gln/Arg/opine family', NULL, 'TIGR01726', NULL, NULL, 6465, 22),
(289249, NULL, 'TIGR01916', NULL, NULL, 'F420_cofE: coenzyme F420-0:L-glutamate ligase', NULL, 'TIGR01916', NULL, NULL, 955, 22),
(289250, NULL, 'TIGR02062', NULL, NULL, 'RNase_B: exoribonuclease II', NULL, 'TIGR02062', NULL, NULL, 13199, 22),
(289251, NULL, 'TIGR00067', NULL, NULL, 'glut_race: glutamate racemase', NULL, 'TIGR00067', NULL, NULL, 5839, 22),
(289252, NULL, 'TIGR00852', NULL, NULL, 'pts-Glc: PTS system, maltose and glucose-specific subfamily, IIC component', NULL, 'TIGR00852', NULL, NULL, 3113, 22),
(289253, NULL, 'TIGR02199', NULL, NULL, 'rfaE_dom_II: bifunctional protein RfaE, domain II', NULL, 'TIGR02199', NULL, NULL, 12290, 22),
(289254, NULL, 'TIGR04247', NULL, NULL, 'NosD_copper_fam: nitrous oxide reductase family maturation protein NosD', NULL, 'TIGR04247', NULL, NULL, 25113, 22),
(289255, NULL, 'TIGR03413', NULL, NULL, 'GSH_gloB: hydroxyacylglutathione hydrolase', NULL, 'TIGR03413', NULL, NULL, 19369, 22),
(289256, NULL, 'TIGR03419', NULL, NULL, 'NifU_clost: FeS cluster assembly scaffold protein NifU', NULL, 'TIGR03419', NULL, NULL, 19268, 22),
(289257, NULL, 'TIGR02507', NULL, NULL, 'MtrF: tetrahydromethanopterin S-methyltransferase, F subunit', NULL, 'TIGR02507', NULL, NULL, 18813, 22),
(289258, NULL, 'TIGR00643', NULL, NULL, 'recG: ATP-dependent DNA helicase RecG', NULL, 'TIGR00643', NULL, NULL, 873, 22);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289259, NULL, 'TIGR02317', NULL, NULL, 'prpB: methylisocitrate lyase', NULL, 'TIGR02317', NULL, NULL, 11960, 22),
(289260, NULL, 'TIGR00721', NULL, NULL, 'tfx: DNA-binding protein, Tfx family', NULL, 'TIGR00721', NULL, NULL, 2624, 22),
(289261, NULL, 'TIGR02828', NULL, NULL, 'TIGR02828: putative membrane fusion protein', NULL, 'TIGR02828', NULL, NULL, 8525, 22),
(289262, NULL, 'TIGR03740', NULL, NULL, 'galliderm_ABC: lantibiotic protection ABC transporter, ATP-binding subunit', NULL, 'TIGR03740', NULL, NULL, 16089, 22),
(289263, NULL, 'TIGR02959', NULL, NULL, 'SigZ: RNA polymerase sigma factor, SigZ family', NULL, 'TIGR02959', NULL, NULL, 9902, 22),
(289264, NULL, 'TIGR04004', NULL, NULL, 'WcaM: colanic acid biosynthesis protein WcaM', NULL, 'TIGR04004', NULL, NULL, 9611, 22),
(289265, NULL, 'TIGR02140', NULL, NULL, 'permease_CysW: sulfate ABC transporter, permease protein CysW', NULL, 'TIGR02140', NULL, NULL, 13909, 22),
(289266, NULL, 'TIGR04038', NULL, NULL, 'tatD_link_rSAM: radical SAM protein, TatD family-associated', NULL, 'TIGR04038', NULL, NULL, 8739, 22),
(289267, NULL, 'TIGR01580', NULL, NULL, 'narG: nitrate reductase, alpha subunit', NULL, 'TIGR01580', NULL, NULL, 6369, 22),
(289268, NULL, 'TIGR01016', NULL, NULL, 'sucCoAbeta: succinate-CoA ligase, beta subunit', NULL, 'TIGR01016', NULL, NULL, 5660, 22),
(289269, NULL, 'TIGR02034', NULL, NULL, 'CysN: sulfate adenylyltransferase, large subunit', NULL, 'TIGR02034', NULL, NULL, 13320, 22),
(289270, NULL, 'TIGR04278', NULL, NULL, 'viperin: antiviral radical SAM protein viperin', NULL, 'TIGR04278', NULL, NULL, NULL, 22),
(289271, NULL, 'TIGR01340', NULL, NULL, 'aconitase_mito: aconitate hydratase, mitochondrial', NULL, 'TIGR01340', NULL, NULL, 3568, 22),
(289272, NULL, 'TIGR03086', NULL, NULL, 'TIGR03086: TIGR03086 family protein', NULL, 'TIGR03086', NULL, NULL, 14878, 22),
(289273, NULL, 'TIGR03846', NULL, NULL, 'sulfopy_beta: sulfopyruvate decarboxylase, beta subunit', NULL, 'TIGR03846', NULL, NULL, 16439, 22),
(289274, NULL, 'TIGR02495', NULL, NULL, 'NrdG2: anaerobic ribonucleoside-triphosphate reductase activating protein', NULL, 'TIGR02495', NULL, NULL, 12619, 22),
(289275, NULL, 'TIGR04141', NULL, NULL, 'TIGR04141: sporadically distributed protein, TIGR04141 family', NULL, 'TIGR04141', NULL, NULL, 23174, 22),
(289276, NULL, 'TIGR04465', NULL, NULL, 'ArgArg_F420: TAT-translocated F420-dependent dehydrogenase, FGD2 family', NULL, 'TIGR04465', NULL, NULL, 25612, 22),
(289277, NULL, 'TIGR03310', NULL, NULL, 'matur_MocA_YgfJ: molybdenum cofactor cytidylyltransferase', NULL, 'TIGR03310', NULL, NULL, 17978, 22),
(289278, NULL, 'TIGR01913', NULL, NULL, 'bet_lambda: phage recombination protein Bet', NULL, 'TIGR01913', NULL, NULL, 4339, 22),
(289279, NULL, 'TIGR04437', NULL, NULL, 'WaaZ_KDO_III: 3-deoxy-D-manno-oct-2-ulosonate III transferase WaaZ', NULL, 'TIGR04437', NULL, NULL, 26224, 22),
(289280, NULL, 'TIGR00064', NULL, NULL, 'ftsY: signal recognition particle-docking protein FtsY', NULL, 'TIGR00064', NULL, NULL, 5505, 22),
(289281, NULL, 'TIGR03983', NULL, NULL, 'cas1_MYXAN: CRISPR-associated endonuclease Cas1, subtype MYXAN', NULL, 'TIGR03983', NULL, NULL, 16843, 22),
(289282, NULL, 'TIGR00886', NULL, NULL, '2A0108: nitrite transporter', NULL, 'TIGR00886', NULL, NULL, 3904, 22),
(289283, NULL, 'TIGR04540', NULL, NULL, 'CLB_0814_fam: conserved hypothetical protein', NULL, 'TIGR04540', NULL, NULL, 25430, 22),
(289284, NULL, 'TIGR01443', NULL, NULL, 'intein_Cterm: intein C-terminal splicing region', NULL, 'TIGR01443', NULL, NULL, 21719, 22),
(289285, NULL, 'TIGR03687', NULL, NULL, 'pupylate_cterm: ubiquitin-like protein Pup', NULL, 'TIGR03687', NULL, NULL, 12747, 22),
(289286, NULL, 'TIGR00092', NULL, NULL, 'TIGR00092: GTP-binding protein YchF', NULL, 'TIGR00092', NULL, NULL, 5645, 22),
(289287, NULL, 'TIGR00612', NULL, NULL, 'ispG_gcpE: 4-hydroxy-3-methylbut-2-en-1-yl diphosphate synthase', NULL, 'TIGR00612', NULL, NULL, 883, 22),
(289288, NULL, 'TIGR02570', NULL, NULL, 'cas7_GSU0053: CRISPR-associated protein GSU0053/csb1, Dpsyc system', NULL, 'TIGR02570', NULL, NULL, 11278, 22);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289289, NULL, 'TIGR02856', NULL, NULL, 'spore_yqfC: sporulation protein YqfC', NULL, 'TIGR02856', NULL, NULL, 15903, 22),
(289290, NULL, 'TIGR00749', NULL, NULL, 'glk: glucokinase', NULL, 'TIGR00749', NULL, NULL, 3388, 22),
(289291, NULL, 'TIGR03522', NULL, NULL, 'GldA_ABC_ATP: gliding motility-associated ABC transporter ATP-binding subunit GldA', NULL, 'TIGR03522', NULL, NULL, 16553, 22),
(289292, NULL, 'TIGR00989', NULL, NULL, '3a0801s07tom40: mitochondrial import receptor subunit', NULL, 'TIGR00989', NULL, NULL, 3636, 22),
(289293, NULL, 'TIGR01203', NULL, NULL, 'HGPRTase: hypoxanthine phosphoribosyltransferase', NULL, 'TIGR01203', NULL, NULL, 6870, 22),
(289294, NULL, 'TIGR03447', NULL, NULL, 'mycothiol_MshC: cysteine--1-D-myo-inosityl 2-amino-2-deoxy-alpha-D-glucopyranoside ligase', NULL, 'TIGR03447', NULL, NULL, 19428, 22),
(289295, NULL, 'TIGR01125', NULL, NULL, 'TIGR01125: ribosomal protein S12 methylthiotransferase RimO', NULL, 'TIGR01125', NULL, NULL, 5917, 22),
(289296, NULL, 'TIGR00425', NULL, NULL, 'CBF5: putative rRNA pseudouridine synthase', NULL, 'TIGR00425', NULL, NULL, 5628, 22),
(289297, NULL, 'TIGR02171', NULL, NULL, 'Fb_sc_TIGR02171: fibrobacter succinogenes paralogous family TIGR02171', NULL, 'TIGR02171', NULL, NULL, 15426, 22),
(289298, NULL, 'TIGR02931', NULL, NULL, 'anfK_nitrog: Fe-only nitrogenase, beta subunit', NULL, 'TIGR02931', NULL, NULL, 8804, 22),
(289299, NULL, 'TIGR04300', NULL, NULL, 'exosort_XrtM: exosortase family protein XrtM', NULL, 'TIGR04300', NULL, NULL, 23218, 22),
(289300, NULL, 'TIGR00173', NULL, NULL, 'menD: 2-succinyl-5-enolpyruvyl-6-hydroxy-3-cyclohexene-1-carboxylic-acid synthase', NULL, 'TIGR00173', NULL, NULL, 7373, 22),
(289301, NULL, 'TIGR00640', NULL, NULL, 'acid_CoA_mut_C: methylmalonyl-CoA mutase C-terminal domain', NULL, 'TIGR00640', NULL, NULL, 10384, 22),
(289302, NULL, 'TIGR01795', NULL, NULL, 'CM_mono_cladeE: chorismate mutase', NULL, 'TIGR01795', NULL, NULL, 1599, 22),
(289303, NULL, 'TIGR04356', NULL, NULL, 'grasp_GAK: ATP-grasp enzyme, GAK system', NULL, 'TIGR04356', NULL, NULL, 23356, 22),
(289304, NULL, 'TIGR03201', NULL, NULL, 'dearomat_had: 6-hydroxycyclohex-1-ene-1-carbonyl-CoA dehydrogenase', NULL, 'TIGR03201', NULL, NULL, 16144, 22),
(289305, NULL, 'TIGR00777', NULL, NULL, 'ahpD: alkylhydroperoxidase, AhpD family', NULL, 'TIGR00777', NULL, NULL, 2850, 22),
(289306, NULL, 'TIGR03338', NULL, NULL, 'phnR_burk: phosphonate utilization associated transcriptional regulator', NULL, 'TIGR03338', NULL, NULL, 18483, 22),
(289307, NULL, 'TIGR03161', NULL, NULL, 'ribazole_CobZ: alpha-ribazole phosphatase CobZ', NULL, 'TIGR03161', NULL, NULL, 15630, 22),
(289308, NULL, 'TIGR02747', NULL, NULL, 'TraV: type IV conjugative transfer system protein TraV', NULL, 'TIGR02747', NULL, NULL, 13739, 22),
(289309, NULL, 'TIGR00883', NULL, NULL, '2A0106: MFS transporter, metabolite:H+ symporter (MHS) family protein', NULL, 'TIGR00883', NULL, NULL, 3934, 22),
(289310, NULL, 'TIGR02719', NULL, NULL, 'repress_PhaQ: poly-beta-hydroxybutyrate-responsive repressor', NULL, 'TIGR02719', NULL, NULL, 14359, 22),
(289311, NULL, 'TIGR03631', NULL, NULL, 'uS13_bact: ribosomal protein uS13', NULL, 'TIGR03631', NULL, NULL, 11683, 22),
(289312, NULL, 'TIGR01191', NULL, NULL, 'ccmC: heme exporter protein CcmC', NULL, 'TIGR01191', NULL, NULL, 7, 22),
(289313, NULL, 'TIGR04113', NULL, NULL, 'cas_csx17: CRISPR-associated protein Csx17, subtype Dpsyc', NULL, 'TIGR04113', NULL, NULL, 23383, 22),
(289314, NULL, 'TIGR00213', NULL, NULL, 'GmhB_yaeD: D,D-heptose 1,7-bisphosphate phosphatase', NULL, 'TIGR00213', NULL, NULL, 7080, 22),
(289315, NULL, 'TIGR01368', NULL, NULL, 'CPSaseIIsmall: carbamoyl-phosphate synthase, small subunit', NULL, 'TIGR01368', NULL, NULL, 3551, 22),
(289316, NULL, 'TIGR00534', NULL, NULL, 'OpcA: glucose-6-phosphate dehydrogenase assembly protein OpcA', NULL, 'TIGR00534', NULL, NULL, 783, 22),
(289317, NULL, 'TIGR01689', NULL, NULL, 'EcbF-BcbF: capsule biosynthesis phosphatase', NULL, 'TIGR01689', NULL, NULL, 5460, 22),
(289318, NULL, 'TIGR03874', NULL, NULL, '4cys_cytochr: c-type cytochrome, methanol metabolism-related', NULL, 'TIGR03874', NULL, NULL, 15757, 22);              
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289319, NULL, 'TIGR01552', NULL, NULL, 'phd_fam: prevent-host-death family protein', NULL, 'TIGR01552', NULL, NULL, NULL, 22),
(289320, NULL, 'TIGR01474', NULL, NULL, 'ubiA_proteo: 4-hydroxybenzoate polyprenyl transferase', NULL, 'TIGR01474', NULL, NULL, 5847, 22),
(289321, NULL, 'TIGR03659', NULL, NULL, 'IsdE: heme ABC transporter, heme-binding protein isdE', NULL, 'TIGR03659', NULL, NULL, 15482, 22),
(289322, NULL, 'TIGR02504', NULL, NULL, 'NrdJ_Z: ribonucleoside-diphosphate reductase, adenosylcobalamin-dependent', NULL, 'TIGR02504', NULL, NULL, 18995, 22),
(289323, NULL, 'TIGR02143', NULL, NULL, 'trmA_only: tRNA (uracil(54)-C(5))-methyltransferase', NULL, 'TIGR02143', NULL, NULL, 13787, 22),
(289324, NULL, 'TIGR02065', NULL, NULL, 'ECX1: exosome complex exonuclease 1', NULL, 'TIGR02065', NULL, NULL, 13078, 22),
(289325, NULL, 'TIGR03298', NULL, NULL, 'argP: transcriptional regulator, ArgP family', NULL, 'TIGR03298', NULL, NULL, 17812, 22),
(289326, NULL, 'TIGR01873', NULL, NULL, 'cas_CT1978: CRISPR-associated endoribonuclease Cas2, subtype I-E/ECOLI', NULL, 'TIGR01873', NULL, NULL, 10992, 22),
(289327, NULL, 'TIGR02386', NULL, NULL, 'rpoC_TIGR: DNA-directed RNA polymerase, beta'' subunit', NULL, 'TIGR02386', NULL, NULL, 9563, 22),
(289328, NULL, 'TIGR00319', NULL, NULL, 'desulf_FeS4: desulfoferrodoxin FeS4 iron-binding domain', NULL, 'TIGR00319', NULL, NULL, 7250, 22),
(289329, NULL, 'TIGR01231', NULL, NULL, 'lacC: tagatose-6-phosphate kinase', NULL, 'TIGR01231', NULL, NULL, 429, 22),
(289330, NULL, 'TIGR01729', NULL, NULL, 'taurine_ABC_bnd: taurine ABC transporter, periplasmic binding protein', NULL, 'TIGR01729', NULL, NULL, 6364, 22),
(289331, NULL, 'TIGR03416', NULL, NULL, 'ABC_choXWV_perm: choline ABC transporter, permease protein', NULL, 'TIGR03416', NULL, NULL, 19139, 22),
(289332, NULL, 'TIGR04434', NULL, NULL, 'rSAM_Pput_1520: B12-binding domain/radical SAM domain protein', NULL, 'TIGR04434', NULL, NULL, 25126, 22),
(289333, NULL, 'TIGR04088', NULL, NULL, 'cognate_SipW: SipW-cognate class signal peptide', NULL, 'TIGR04088', NULL, NULL, 16835, 22),
(289334, NULL, 'TIGR01390', NULL, NULL, 'CycNucDiestase: 2'',3''-cyclic-nucleotide 2''-phosphodiesterase', NULL, 'TIGR01390', NULL, NULL, 3882, 22),
(289335, NULL, 'TIGR01826', NULL, NULL, 'CofD_related: conserved hypothetical protein', NULL, 'TIGR01826', NULL, NULL, 10984, 22),
(289336, NULL, 'TIGR02464', NULL, NULL, 'ribofla_fusion: conserved hypothetical protein', NULL, 'TIGR02464', NULL, NULL, 12703, 22),
(289337, NULL, 'TIGR01103', NULL, NULL, 'fliP: flagellar biosynthetic protein FliP', NULL, 'TIGR01103', NULL, NULL, 5717, 22),
(289338, NULL, 'TIGR04191', NULL, NULL, 'YphP_YqiW: putative bacilliredoxin, YphP/YqiW family', NULL, 'TIGR04191', NULL, NULL, 9265, 22),
(289339, NULL, 'TIGR02224', NULL, NULL, 'recomb_XerC: tyrosine recombinase XerC', NULL, 'TIGR02224', NULL, NULL, 11016, 22),
(289340, NULL, 'TIGR02031', NULL, NULL, 'BchD-ChlD: magnesium chelatase ATPase subunit D', NULL, 'TIGR02031', NULL, NULL, 13269, 22),
(289341, NULL, 'TIGR03603', NULL, NULL, 'cyclo_dehy_ocin: thiazole/oxazole-forming peptide maturase, SagC family component', NULL, 'TIGR03603', NULL, NULL, 14981, 22),
(289342, NULL, 'TIGR03793', NULL, NULL, 'TOMM_pelo: NHLP leader peptide domain', NULL, 'TIGR03793', NULL, NULL, 16162, 22),
(289343, NULL, 'TIGR01343', NULL, NULL, 'hacA_fam: homoaconitate hydratase family protein', NULL, 'TIGR01343', NULL, NULL, 3981, 22),
(289344, NULL, 'TIGR02619', NULL, NULL, 'TIGR02619: putative CRISPR-associated protein, APE2256 family', NULL, 'TIGR02619', NULL, NULL, 9429, 22),
(289345, NULL, 'TIGR02722', NULL, NULL, 'lp_: uncharacterized lipoprotein', NULL, 'TIGR02722', NULL, NULL, 14414, 22),
(289346, NULL, 'TIGR01150', NULL, NULL, 'puhA: photosynthetic reaction center H subunit', NULL, 'TIGR01150', NULL, NULL, 2586, 22),
(289347, NULL, 'TIGR04144', NULL, NULL, 'archaeo_VPXXXP: archaeosortase B', NULL, 'TIGR04144', NULL, NULL, 21493, 22),
(289348, NULL, 'TIGR00945', NULL, NULL, 'tatC: twin arginine-targeting protein translocase TatC', NULL, 'TIGR00945', NULL, NULL, 5257, 22);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289349, NULL, 'TIGR00310', NULL, NULL, 'ZPR1_znf: ZPR1 zinc finger domain', NULL, 'TIGR00310', NULL, NULL, 7129, 22),
(289350, NULL, 'TIGR00216', NULL, NULL, 'ispH_lytB: 4-hydroxy-3-methylbut-2-enyl diphosphate reductase', NULL, 'TIGR00216', NULL, NULL, 5344, 22),
(289351, NULL, 'TIGR00802', NULL, NULL, 'nico: transition metal uptake transporter, Ni2+-Co2+ transporter (NiCoT) family', NULL, 'TIGR00802', NULL, NULL, 3019, 22),
(289352, NULL, 'TIGR00687', NULL, NULL, 'pyridox_kin: pyridoxal kinase', NULL, 'TIGR00687', NULL, NULL, 2078, 22),
(289353, NULL, 'TIGR02426', NULL, NULL, 'protocat_pcaB: 3-carboxy-cis,cis-muconate cycloisomerase', NULL, 'TIGR02426', NULL, NULL, 9774, 22),
(289354, NULL, 'TIGR03650', NULL, NULL, 'violacein_E: violacein biosynthesis enzyme VioE', NULL, 'TIGR03650', NULL, NULL, 11609, 22),
(289355, NULL, 'TIGR00550', NULL, NULL, 'nadA: quinolinate synthetase complex, A subunit', NULL, 'TIGR00550', NULL, NULL, 6047, 22),
(289356, NULL, 'TIGR02666', NULL, NULL, 'moaA: molybdenum cofactor biosynthesis protein A', NULL, 'TIGR02666', NULL, NULL, 10365, 22),
(289357, NULL, 'TIGR03248', NULL, NULL, 'galactar-dH20: galactarate dehydratase', NULL, 'TIGR03248', NULL, NULL, 17046, 22),
(289358, NULL, 'TIGR01085', NULL, NULL, 'murE: UDP-N-acetylmuramyl-tripeptide synthetase', NULL, 'TIGR01085', NULL, NULL, 4749, 22),
(289359, NULL, 'TIGR00939', NULL, NULL, '2a57: nucleoside Transporter', NULL, 'TIGR00939', NULL, NULL, 17728, 22),
(289360, NULL, 'TIGR03008', NULL, NULL, 'pepcterm_CAAX: CAAX prenyl protease-related protein', NULL, 'TIGR03008', NULL, NULL, 11238, 22),
(289361, NULL, 'TIGR01583', NULL, NULL, 'formate-DH-gamm: formate dehydrogenase, gamma subunit', NULL, 'TIGR01583', NULL, NULL, 6017, 22),
(289362, NULL, 'TIGR02168', NULL, NULL, 'SMC_prok_B: chromosome segregation protein SMC', NULL, 'TIGR02168', NULL, NULL, 8540, 22),
(289363, NULL, 'TIGR02859', NULL, NULL, 'spore_sigH: RNA polymerase sigma-H factor', NULL, 'TIGR02859', NULL, NULL, 10787, 22),
(289364, NULL, 'TIGR00746', NULL, NULL, 'arcC: carbamate kinase', NULL, 'TIGR00746', NULL, NULL, 7437, 22),
(289365, NULL, 'TIGR03591', NULL, NULL, 'polynuc_phos: polyribonucleotide nucleotidyltransferase', NULL, 'TIGR03591', NULL, NULL, 7490, 22),
(289366, NULL, 'TIGR03064', NULL, NULL, 'sortase_srtB: sortase, SrtB family', NULL, 'TIGR03064', NULL, NULL, 13386, 22),
(289367, NULL, 'TIGR02230', NULL, NULL, 'ATPase_gene1: putative F0F1-ATPase subunit', NULL, 'TIGR02230', NULL, NULL, 11924, 22),
(289368, NULL, 'TIGR03506', NULL, NULL, 'FlgEFG_subfam: flagellar hook-basal body protein', NULL, 'TIGR03506', NULL, NULL, 17034, 22),
(289369, NULL, 'TIGR01334', NULL, NULL, 'modD: modD protein', NULL, 'TIGR01334', NULL, NULL, 3692, 22),
(289370, NULL, 'TIGR01882', NULL, NULL, 'peptidase-T: peptidase T', NULL, 'TIGR01882', NULL, NULL, 10716, 22),
(289371, NULL, 'TIGR04490', NULL, NULL, 'SoxZ_true: thiosulfate oxidation carrier complex protein SoxZ', NULL, 'TIGR04490', NULL, NULL, 21766, 22),
(289372, NULL, 'TIGR03805', NULL, NULL, 'beta_helix_1: parallel beta-helix repeat-containing protein', NULL, 'TIGR03805', NULL, NULL, 15552, 22),
(289373, NULL, 'TIGR01144', NULL, NULL, 'ATP_synt_b: ATP synthase F0, B subunit', NULL, 'TIGR01144', NULL, NULL, 6787, 22),
(289374, NULL, 'TIGR02906', NULL, NULL, 'spore_CotS: spore coat protein, CotS family', NULL, 'TIGR02906', NULL, NULL, 11183, 22),
(289375, NULL, 'TIGR01091', NULL, NULL, 'upp: uracil phosphoribosyltransferase', NULL, 'TIGR01091', NULL, NULL, 4940, 22),
(289376, NULL, 'TIGR03307', NULL, NULL, 'PhnP: phosphonate metabolism protein PhnP', NULL, 'TIGR03307', NULL, NULL, 17860, 22),
(289377, NULL, 'TIGR01384', NULL, NULL, 'TFS_arch: transcription factor S', NULL, 'TIGR01384', NULL, NULL, 3506, 22),
(289378, NULL, 'TIGR01779', NULL, NULL, 'TonB-B12: TonB-dependent vitamin B12 receptor', NULL, 'TIGR01779', NULL, NULL, 2381, 22),
(289379, NULL, 'TIGR01969', NULL, NULL, 'minD_arch: cell division ATPase MinD', NULL, 'TIGR01969', NULL, NULL, 4414, 22),
(289380, NULL, 'TIGR01574', NULL, NULL, 'miaB-methiolase: tRNA-i(6)A37 thiotransferase enzyme MiaB', NULL, 'TIGR01574', NULL, NULL, NULL, 22);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289381, NULL, 'TIGR03787', NULL, NULL, 'marine_sort_RR: proteobacterial dedicated sortase system response regulator', NULL, 'TIGR03787', NULL, NULL, 14209, 22),
(289382, NULL, 'TIGR02763', NULL, NULL, 'chlamy_scaf: scaffolding protein', NULL, 'TIGR02763', NULL, NULL, 14419, 22),
(289383, NULL, 'TIGR02953', NULL, NULL, 'penta_MxKDx: pentapeptide MXKDX repeat protein', NULL, 'TIGR02953', NULL, NULL, 9542, 22),
(289384, NULL, 'TIGR03014', NULL, NULL, 'EpsL: exopolysaccharide biosynthesis operon protein EpsL', NULL, 'TIGR03014', NULL, NULL, 20716, 22),
(289385, NULL, 'TIGR00257', NULL, NULL, 'IMPACT_YIGZ: uncharacterized protein, YigZ family', NULL, 'TIGR00257', NULL, NULL, 12846, 22),
(289386, NULL, 'TIGR03746', NULL, NULL, 'conj_TIGR03746: integrating conjugative element protein, PFL_4703 family', NULL, 'TIGR03746', NULL, NULL, 18752, 22),
(289387, NULL, 'TIGR03890', NULL, NULL, 'nif11_cupin: nif11 domain/cupin domain protein', NULL, 'TIGR03890', NULL, NULL, 7762, 22),
(289388, NULL, 'TIGR00447', NULL, NULL, 'pth: aminoacyl-tRNA hydrolase', NULL, 'TIGR00447', NULL, NULL, 2443, 22),
(289389, NULL, 'TIGR00263', NULL, NULL, 'trpB: tryptophan synthase, beta subunit', NULL, 'TIGR00263', NULL, NULL, 1206, 22),
(289390, NULL, 'TIGR00453', NULL, NULL, 'ispD: 2-C-methyl-D-erythritol 4-phosphate cytidylyltransferase', NULL, 'TIGR00453', NULL, NULL, 790, 22),
(289391, NULL, 'TIGR02127', NULL, NULL, 'pyrF_sub2: orotidine 5''-phosphate decarboxylase', NULL, 'TIGR02127', NULL, NULL, 12206, 22),
(289392, NULL, 'TIGR04135', NULL, NULL, 'FibroRuminTarg: Cys-rich radical SAM target, FibroRumin family', NULL, 'TIGR04135', NULL, NULL, 21444, 22),
(289393, NULL, 'TIGR00388', NULL, NULL, 'glyQ: glycine--tRNA ligase, alpha subunit', NULL, 'TIGR00388', NULL, NULL, 6021, 22),
(289394, NULL, 'TIGR01876', NULL, NULL, 'cas_Cas5d: CRISPR-associated protein Cas5, subtype I-C/DVULG', NULL, 'TIGR01876', NULL, NULL, 10776, 22),
(289395, NULL, 'TIGR03111', NULL, NULL, 'glyc2_xrt_Gpos1: putative glycosyltransferase, exosortase G-associated', NULL, 'TIGR03111', NULL, NULL, 14546, 22),
(289396, NULL, 'TIGR01287', NULL, NULL, 'nifH: nitrogenase iron protein', NULL, 'TIGR01287', NULL, NULL, 1464, 22),
(289397, NULL, 'TIGR04443', NULL, NULL, 'F420_CofF: coenzyme gamma-F420-2:alpha-L-glutamate ligase', NULL, 'TIGR04443', NULL, NULL, 26355, 22),
(289398, NULL, 'TIGR03295', NULL, NULL, 'frhA: coenzyme F420 hydrogenase, subunit alpha', NULL, 'TIGR03295', NULL, NULL, 17665, 22),
(289399, NULL, 'TIGR02271', NULL, NULL, 'TIGR02271: conserved domain', NULL, 'TIGR02271', NULL, NULL, 16548, 22),
(289400, NULL, 'TIGR02461', NULL, NULL, 'osmo_MPG_phos: mannosyl-3-phosphoglycerate phosphatase', NULL, 'TIGR02461', NULL, NULL, 24007, 22),
(289401, NULL, 'TIGR04244', NULL, NULL, 'nitrous_NosZ_RR: nitrous-oxide reductase, TAT-dependent', NULL, 'TIGR04244', NULL, NULL, 16337, 22),
(289402, NULL, 'TIGR02654', NULL, NULL, 'circ_KaiB: circadian clock protein KaiB', NULL, 'TIGR02654', NULL, NULL, 10379, 22),
(289403, NULL, 'TIGR01636', NULL, NULL, 'phage_rinA: phage transcriptional regulator, RinA family', NULL, 'TIGR01636', NULL, NULL, 97, 22),
(289404, NULL, 'TIGR02068', NULL, NULL, 'cya_phycin_syn: cyanophycin synthetase', NULL, 'TIGR02068', NULL, NULL, 13486, 22),
(289405, NULL, 'TIGR03363', NULL, NULL, 'VI_chp_8: type VI secretion-associated protein, ImpA family', NULL, 'TIGR03363', NULL, NULL, 18097, 22),
(289406, NULL, 'TIGR04381', NULL, NULL, 'HTH_TypR: TyrR family helix-turn-helix domain', NULL, 'TIGR04381', NULL, NULL, 25035, 22),
(289407, NULL, 'TIGR00148', NULL, NULL, 'TIGR00148: decarboxylase, UbiD family', NULL, 'TIGR00148', NULL, NULL, 5300, 22),
(289408, NULL, 'TIGR00755', NULL, NULL, 'ksgA: ribosomal RNA small subunit methyltransferase A', NULL, 'TIGR00755', NULL, NULL, 8518, 22),
(289409, NULL, 'TIGR03207', NULL, NULL, 'cyc_hxne_CoA_dh: cyclohexanecarboxyl-CoA dehydrogenase', NULL, 'TIGR03207', NULL, NULL, 16083, 22),
(289410, NULL, 'TIGR04334', NULL, NULL, 'rSAM_Clo7bot: radical SAM/SPASM domain Clo7bot peptide maturase', NULL, 'TIGR04334', NULL, NULL, 23176, 22);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289411, NULL, 'TIGR03556', NULL, NULL, 'photolyase_8HDF: deoxyribodipyrimidine photo-lyase, 8-HDF type', NULL, 'TIGR03556', NULL, NULL, 18215, 22),
(289412, NULL, 'TIGR00120', NULL, NULL, 'ArgJ: glutamate N-acetyltransferase/amino-acid acetyltransferase', NULL, 'TIGR00120', NULL, NULL, 4625, 22),
(289413, NULL, 'TIGR00500', NULL, NULL, 'met_pdase_I: methionine aminopeptidase, type I', NULL, 'TIGR00500', NULL, NULL, 6896, 22),
(289414, NULL, 'TIGR02918', NULL, NULL, 'TIGR02918: accessory Sec system glycosylation protein GtfA', NULL, 'TIGR02918', NULL, NULL, 11289, 22),
(289415, NULL, 'TIGR03254', NULL, NULL, 'oxalate_oxc: oxalyl-CoA decarboxylase', NULL, 'TIGR03254', NULL, NULL, 17008, 22),
(289416, NULL, 'TIGR02822', NULL, NULL, 'adh_fam_2: zinc-binding alcohol dehydrogenase family protein', NULL, 'TIGR02822', NULL, NULL, 8830, 22),
(289417, NULL, 'TIGR00740', NULL, NULL, 'TIGR00740: tRNA (cmo5U34)-methyltransferase', NULL, 'TIGR00740', NULL, NULL, 4131, 22),
(289418, NULL, 'TIGR03977', NULL, NULL, 'rSAM_pair_HxsC: His-Xaa-Ser system radical SAM maturase HxsC', NULL, 'TIGR03977', NULL, NULL, 8130, 22),
(289419, NULL, 'TIGR00877', NULL, NULL, 'purD: phosphoribosylamine--glycine ligase', NULL, 'TIGR00877', NULL, NULL, 3823, 22),
(289420, NULL, 'TIGR03840', NULL, NULL, 'TMPT_Se_Te: thiopurine S-methyltransferase, Se/Te detoxification family', NULL, 'TIGR03840', NULL, NULL, 15656, 22),
(289421, NULL, 'TIGR01527', NULL, NULL, 'arch_NMN_Atrans: nicotinamide-nucleotide adenylyltransferase', NULL, 'TIGR01527', NULL, NULL, 6696, 22),
(289422, NULL, 'TIGR00360', NULL, NULL, 'ComEC_N-term: ComEC/Rec2-related protein', NULL, 'TIGR00360', NULL, NULL, 7400, 22),
(289423, NULL, 'TIGR01275', NULL, NULL, 'ACC_deam_rel: pyridoxal phosphate-dependent enzymes, D-cysteine desulfhydrase family', NULL, 'TIGR01275', NULL, NULL, 301, 22),
(289424, NULL, 'TIGR00497', NULL, NULL, 'hsdM: type I restriction-modification system, M subunit', NULL, 'TIGR00497', NULL, NULL, 935, 22),
(289425, NULL, 'TIGR03058', NULL, NULL, 'rpt_csmH: chlorosome envelope protein H', NULL, 'TIGR03058', NULL, NULL, 12707, 22),
(289426, NULL, 'TIGR00556', NULL, NULL, 'pantethn_trn: phosphopantetheine--protein transferase domain', NULL, 'TIGR00556', NULL, NULL, 635, 22),
(289427, NULL, 'TIGR02040', NULL, NULL, 'PpsR-CrtJ: transcriptional regulator PpsR', NULL, 'TIGR02040', NULL, NULL, 13472, 22),
(289428, NULL, 'TIGR02420', NULL, NULL, 'dksA: RNA polymerase-binding protein DksA', NULL, 'TIGR02420', NULL, NULL, 9657, 22),
(289429, NULL, 'TIGR03316', NULL, NULL, 'ygeW: knotted carbamoyltransferase YgeW', NULL, 'TIGR03316', NULL, NULL, 17633, 22),
(289430, NULL, 'TIGR03195', NULL, NULL, '4hydrxCoA_B: 4-hydroxybenzoyl-CoA reductase, beta subunit', NULL, 'TIGR03195', NULL, NULL, 16366, 22),
(289431, NULL, 'TIGR03781', NULL, NULL, 'Bac_Flav_CT_K: Bacteroides conjugative transposon TraK protein', NULL, 'TIGR03781', NULL, NULL, 15336, 22),
(289432, NULL, 'TIGR00995', NULL, NULL, '3a0901s06TIC22: chloroplast protein import component, Tic22 family', NULL, 'TIGR00995', NULL, NULL, 3715, 22),
(289433, NULL, 'TIGR01773', NULL, NULL, 'GABAperm: GABA permease', NULL, 'TIGR01773', NULL, NULL, 8221, 22),
(289434, NULL, 'TIGR03460', NULL, NULL, 'crt_membr_arch: carotene biosynthesis associated membrane protein', NULL, 'TIGR03460', NULL, NULL, 19353, 22),
(289435, NULL, 'TIGR02059', NULL, NULL, 'swm_rep_I: cyanobacterial long protein repeat', NULL, 'TIGR02059', NULL, NULL, 13377, 22),
(289436, NULL, 'TIGR01832', NULL, NULL, 'kduD: 2-deoxy-D-gluconate 3-dehydrogenase', NULL, 'TIGR01832', NULL, NULL, 10415, 22),
(289437, NULL, 'TIGR04060', NULL, NULL, 'formate_focA: formate transporter FocA', NULL, 'TIGR04060', NULL, NULL, 18933, 22),
(289438, NULL, 'TIGR03351', NULL, NULL, 'PhnX-like: phosphonatase-like hydrolase', NULL, 'TIGR03351', NULL, NULL, 15947, 22),
(289439, NULL, 'TIGR04197', NULL, NULL, 'T7SS_SACOL2603: type VII secretion effector, TIGR04197 family', NULL, 'TIGR04197', NULL, NULL, 18325, 22),
(289440, NULL, 'TIGR00023', NULL, NULL, 'TIGR00023: acyl-phosphate glycerol 3-phosphate acyltransferase', NULL, 'TIGR00023', NULL, NULL, 6290, 22);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289441, NULL, 'TIGR00693', NULL, NULL, 'thiE: thiamine-phosphate diphosphorylase', NULL, 'TIGR00693', NULL, NULL, 14563, 22),
(289442, NULL, 'TIGR02177', NULL, NULL, 'PorB_KorB: 2-oxoacid:acceptor oxidoreductase, beta subunit, pyruvate/2-ketoisovalerate family', NULL, 'TIGR02177', NULL, NULL, 12061, 22),
(289443, NULL, 'TIGR04185', NULL, NULL, 'ATPgraspMvdC: ATP-grasp ribosomal peptide maturase, MvdC family', NULL, 'TIGR04185', NULL, NULL, 23250, 22),
(289444, NULL, 'TIGR01178', NULL, NULL, 'ade: adenine deaminase', NULL, 'TIGR01178', NULL, NULL, 1736, 22),
(289445, NULL, 'TIGR02470', NULL, NULL, 'sucr_synth: sucrose synthase', NULL, 'TIGR02470', NULL, NULL, 12782, 22),
(289446, NULL, 'TIGR04565', NULL, NULL, 'OMP_myx_plus: outer membrane beta-barrel protein', NULL, 'TIGR04565', NULL, NULL, 23971, 22),
(289447, NULL, 'TIGR02968', NULL, NULL, 'succ_dehyd_anc: succinate dehydrogenase, hydrophobic membrane anchor protein', NULL, 'TIGR02968', NULL, NULL, 9937, 22),
(289448, NULL, 'TIGR04013', NULL, NULL, 'B12_SAM_MJ_1487: B12-binding domain/radical SAM domain protein, MJ_1487 family', NULL, 'TIGR04013', NULL, NULL, 11140, 22),
(289449, NULL, 'TIGR02557', NULL, NULL, 'HpaP: type III secretion protein HpaP', NULL, 'TIGR02557', NULL, NULL, 11029, 22),
(289450, NULL, 'TIGR02236', NULL, NULL, 'recomb_radA: DNA repair and recombination protein RadA', NULL, 'TIGR02236', NULL, NULL, 11371, 22),
(289451, NULL, 'TIGR03410', NULL, NULL, 'urea_trans_UrtE: urea ABC transporter, ATP-binding protein UrtE', NULL, 'TIGR03410', NULL, NULL, 19356, 22),
(289452, NULL, 'TIGR00986', NULL, NULL, '3a0801s05tom22: mitochondrial import receptor subunit', NULL, 'TIGR00986', NULL, NULL, 15953, 22),
(289453, NULL, 'TIGR01402', NULL, NULL, 'fliQ: flagellar biosynthetic protein FliQ', NULL, 'TIGR01402', NULL, NULL, 4982, 22),
(289454, NULL, 'TIGR00195', NULL, NULL, 'exoDNase_III: exodeoxyribonuclease III', NULL, 'TIGR00195', NULL, NULL, NULL, 22),
(289455, NULL, 'TIGR01820', NULL, NULL, 'TrpE-arch: anthranilate synthase component I', NULL, 'TIGR01820', NULL, NULL, 10663, 22),
(289456, NULL, 'TIGR03684', NULL, NULL, 'arCOG00985: arCOG04150 universal archaeal PUA-domain protein', NULL, 'TIGR03684', NULL, NULL, 15595, 22),
(289457, NULL, 'TIGR00646', NULL, NULL, 'MG010: DNA primase-like protein', NULL, 'TIGR00646', NULL, NULL, 756, 22),
(289458, NULL, 'TIGR03849', NULL, NULL, 'arch_ComA: phosphosulfolactate synthase', NULL, 'TIGR03849', NULL, NULL, 15521, 22),
(289459, NULL, 'TIGR00509', NULL, NULL, 'bisC_fam: molybdopterin guanine dinucleotide-containing S/N-oxide reductases', NULL, 'TIGR00509', NULL, NULL, 1102, 22),
(289460, NULL, 'TIGR03986', NULL, NULL, 'TIGR03986: CRISPR-associated protein', NULL, 'TIGR03986', NULL, NULL, 9688, 22),
(289461, NULL, 'TIGR00207', NULL, NULL, 'fliG: flagellar motor switch protein FliG', NULL, 'TIGR00207', NULL, NULL, 2510, 22),
(289462, NULL, 'TIGR04518', NULL, NULL, 'ECF_S_folT_fam: ECF transporter S component, folate family', NULL, 'TIGR04518', NULL, NULL, 25384, 22),
(289463, NULL, 'TIGR02333', NULL, NULL, '2met_isocit_dHY: 2-methylisocitrate dehydratase, Fe/S-dependent', NULL, 'TIGR02333', NULL, NULL, 11995, 22),
(289464, NULL, 'TIGR02713', NULL, NULL, 'allophanate_hyd: allophanate hydrolase', NULL, 'TIGR02713', NULL, NULL, 14196, 22),
(289465, NULL, 'TIGR00705', NULL, NULL, 'SppA_67K: signal peptide peptidase SppA, 67K type', NULL, 'TIGR00705', NULL, NULL, 2025, 22),
(289466, NULL, 'TIGR00325', NULL, NULL, 'lpxC: UDP-3-O-[3-hydroxymyristoyl] N-acetylglucosamine deacetylase', NULL, 'TIGR00325', NULL, NULL, 7070, 22),
(289467, NULL, 'TIGR00011', NULL, NULL, 'YbaK_EbsC: Cys-tRNA(Pro) deacylase', NULL, 'TIGR00011', NULL, NULL, 5348, 22),
(289468, NULL, 'TIGR03488', NULL, NULL, 'cas_Cas5p: CRISPR-associated protein Cas5, subtype PGING', NULL, 'TIGR03488', NULL, NULL, 17922, 22),
(289469, NULL, 'TIGR00790', NULL, NULL, 'fnt: formate/nitrite transporter', NULL, 'TIGR00790', NULL, NULL, 525, 22),
(289470, NULL, 'TIGR03547', NULL, NULL, 'muta_rot_YjhT: mutatrotase, YjhT family', NULL, 'TIGR03547', NULL, NULL, 18303, 22);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289471, NULL, 'TIGR01683', NULL, NULL, 'thiS: thiamine biosynthesis protein ThiS', NULL, 'TIGR01683', NULL, NULL, 5177, 22),
(289472, NULL, 'TIGR02831', NULL, NULL, 'spo_II_M: stage II sporulation protein M', NULL, 'TIGR02831', NULL, NULL, 8652, 22),
(289473, NULL, 'TIGR01041', NULL, NULL, 'ATP_syn_B_arch: ATP synthase archaeal, B subunit', NULL, 'TIGR01041', NULL, NULL, 4787, 22),
(289474, NULL, 'TIGR01539', NULL, NULL, 'portal_lambda: phage portal protein, lambda family', NULL, 'TIGR01539', NULL, NULL, 6793, 22),
(289475, NULL, 'TIGR04054', NULL, NULL, 'rSAM_NirJ1: putative heme d1 biosynthesis radical SAM protein NirJ1', NULL, 'TIGR04054', NULL, NULL, 8119, 22),
(289476, NULL, 'TIGR00372', NULL, NULL, 'cas4: CRISPR-associated protein Cas4', NULL, 'TIGR00372', NULL, NULL, 11769, 22),
(289477, NULL, 'TIGR02018', NULL, NULL, 'his_ut_repres: histidine utilization repressor', NULL, 'TIGR02018', NULL, NULL, 5133, 22),
(289478, NULL, 'TIGR02258', NULL, NULL, '2_5_ligase: 2''-5'' RNA ligase', NULL, 'TIGR02258', NULL, NULL, 2689, 22),
(289479, NULL, 'TIGR02604', NULL, NULL, 'Piru_Ver_Nterm: putative membrane-bound dehydrogenase domain', NULL, 'TIGR02604', NULL, NULL, 9407, 22),
(289480, NULL, 'TIGR00808', NULL, NULL, 'malonate_madM: malonate transporter, MadM subunit', NULL, 'TIGR00808', NULL, NULL, 3470, 22),
(289481, NULL, 'TIGR04552', NULL, NULL, 'TIGR04552: TIGR04552 family protein', NULL, 'TIGR04552', NULL, NULL, NULL, 22),
(289482, NULL, 'TIGR00578', NULL, NULL, 'ku70: ATP-dependent DNA helicase II, 70 kDa subunit (ku70)', NULL, 'TIGR00578', NULL, NULL, 10320, 22),
(289483, NULL, 'TIGR03139', NULL, NULL, 'QueF-II: 7-cyano-7-deazaguanine reductase', NULL, 'TIGR03139', NULL, NULL, 16179, 22),
(289484, NULL, 'TIGR00441', NULL, NULL, 'gmhA: phosphoheptose isomerase', NULL, 'TIGR00441', NULL, NULL, 1711, 22),
(289485, NULL, 'TIGR03002', NULL, NULL, 'outer_YhbN_LptA: lipopolysaccharide transport periplasmic protein LptA', NULL, 'TIGR03002', NULL, NULL, 11121, 22),
(289486, NULL, 'TIGR00338', NULL, NULL, 'serB: phosphoserine phosphatase SerB', NULL, 'TIGR00338', NULL, NULL, 7217, 22),
(289487, NULL, 'TIGR04449', NULL, NULL, 'halocin_C8_dom: halocin C8-like bacteriocin domain', NULL, 'TIGR04449', NULL, NULL, 26372, 22),
(289488, NULL, 'TIGR03173', NULL, NULL, 'pbuX: xanthine permease', NULL, 'TIGR03173', NULL, NULL, 15828, 22),
(289489, NULL, 'TIGR01253', NULL, NULL, 'thiP: thiamine/thiamine pyrophosphate ABC transporter, permease protein', NULL, 'TIGR01253', NULL, NULL, 359, 22),
(289490, NULL, 'TIGR02121', NULL, NULL, 'Na_Pro_sym: sodium/proline symporter', NULL, 'TIGR02121', NULL, NULL, 13834, 22),
(289491, NULL, 'TIGR04524', NULL, NULL, 'mycoplas_M_dom: IgG-blocking virulence domain', NULL, 'TIGR04524', NULL, NULL, 25418, 22),
(289492, NULL, 'TIGR01723', NULL, NULL, 'hmd_TIGR: 5,10-methenyltetrahydromethanopterin hydrogenase', NULL, 'TIGR01723', NULL, NULL, 6460, 22),
(289493, NULL, 'TIGR03500', NULL, NULL, 'FliO_TIGR: flagellar biosynthetic protein FliO', NULL, 'TIGR03500', NULL, NULL, 14938, 22),
(289494, NULL, 'TIGR02728', NULL, NULL, 'spore_gerQ: spore coat protein GerQ', NULL, 'TIGR02728', NULL, NULL, 14183, 22),
(289495, NULL, 'TIGR01957', NULL, NULL, 'nuoB_fam: NADH-quinone oxidoreductase, B subunit', NULL, 'TIGR01957', NULL, NULL, 10454, 22),
(289496, NULL, 'TIGR02380', NULL, NULL, 'ECA_wecA: undecaprenyl-phosphate alpha-N-acetylglucosaminyl 1-phosphatetransferase', NULL, 'TIGR02380', NULL, NULL, 9579, 22),
(289497, NULL, 'TIGR02872', NULL, NULL, 'spore_ytvI: sporulation integral membrane protein YtvI', NULL, 'TIGR02872', NULL, NULL, 10780, 22),
(289498, NULL, 'TIGR01465', NULL, NULL, 'cobM_cbiF: precorrin-4 C11-methyltransferase', NULL, 'TIGR01465', NULL, NULL, 5602, 22),
(289499, NULL, 'TIGR01888', NULL, NULL, 'cas_cmr3: CRISPR type III-B/RAMP module-associated protein Cmr3', NULL, 'TIGR01888', NULL, NULL, 10643, 22),
(289500, NULL, 'TIGR04026', NULL, NULL, 'PPOX_FMN_cyano: PPOX class probable FMN-dependent enzyme, alr4036 family', NULL, 'TIGR04026', NULL, NULL, 15996, 22),
(289501, NULL, 'TIGR01717', NULL, NULL, 'AMP-nucleosdse: AMP nucleosidase', NULL, 'TIGR01717', NULL, NULL, 9612, 22);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289502, NULL, 'TIGR01963', NULL, NULL, 'PHB_DH: 3-hydroxybutyrate dehydrogenase', NULL, 'TIGR01963', NULL, NULL, 10295, 22),
(289503, NULL, 'TIGR03637', NULL, NULL, 'cas1_YPEST: CRISPR-associated endonuclease Cas1, subtype I-F/YPEST', NULL, 'TIGR03637', NULL, NULL, 14847, 22),
(289504, NULL, 'TIGR03971', NULL, NULL, 'SDR_subfam_1: SDR family mycofactocin-dependent oxidoreductase', NULL, 'TIGR03971', NULL, NULL, 11233, 22),
(289505, NULL, 'TIGR03896', NULL, NULL, 'cyc_nuc_ocin: bacteriocin-type transport-associated protein', NULL, 'TIGR03896', NULL, NULL, 18495, 22),
(289506, NULL, 'TIGR03385', NULL, NULL, 'CoA_CoA_reduc: CoA-disulfide reductase', NULL, 'TIGR03385', NULL, NULL, 18921, 22),
(289507, NULL, 'TIGR04294', NULL, NULL, 'pre_pil_HX9DG: prepilin-type processing-associated H-X9-DG domain', NULL, 'TIGR04294', NULL, NULL, 26835, 22),
(289508, NULL, 'TIGR01452', NULL, NULL, 'PGP_euk: phosphoglycolate/pyridoxal phosphate phosphatase family', NULL, 'TIGR01452', NULL, NULL, 4750, 22),
(289509, NULL, 'TIGR02286', NULL, NULL, 'PaaD: phenylacetic acid degradation protein PaaD', NULL, 'TIGR02286', NULL, NULL, 11496, 22),
(289510, NULL, 'TIGR00864', NULL, NULL, 'PCC: polycystin cation channel protein', NULL, 'TIGR00864', NULL, NULL, 11264, 22),
(289511, NULL, 'TIGR02299', NULL, NULL, 'HpaE: 5-carboxymethyl-2-hydroxymuconate semialdehyde dehydrogenase', NULL, 'TIGR02299', NULL, NULL, 13374, 22),
(289512, NULL, 'TIGR04306', NULL, NULL, 'salvage_TenA: thiaminase II', NULL, 'TIGR04306', NULL, NULL, 23469, 22),
(289513, NULL, 'TIGR00126', NULL, NULL, 'deoC: deoxyribose-phosphate aldolase', NULL, 'TIGR00126', NULL, NULL, 8631, 22),
(289514, NULL, 'TIGR00086', NULL, NULL, 'smpB: SsrA-binding protein', NULL, 'TIGR00086', NULL, NULL, 2703, 22),
(289515, NULL, 'TIGR01281', NULL, NULL, 'DPOR_bchL: light-independent protochlorophyllide reductase, iron-sulfur ATP-binding protein', NULL, 'TIGR01281', NULL, NULL, 1447, 22),
(289516, NULL, 'TIGR03145', NULL, NULL, 'cyt_nit_nrfE: cytochrome c nitrate reductase biogenesis protein NrfE', NULL, 'TIGR03145', NULL, NULL, 15176, 22),
(289517, NULL, 'TIGR01109', NULL, NULL, 'Na_pump_decarbB: sodium ion-translocating decarboxylase, beta subunit', NULL, 'TIGR01109', NULL, NULL, 3717, 22),
(289518, NULL, 'TIGR03117', NULL, NULL, 'cas_csf4: CRISPR type AFERR-associated DEAD/DEAH-box helicase Csf4', NULL, 'TIGR03117', NULL, NULL, 14653, 22),
(289519, NULL, 'TIGR03438', NULL, NULL, 'egtD_ergothio: dimethylhistidine N-methyltransferase', NULL, 'TIGR03438', NULL, NULL, 15944, 22),
(289520, NULL, 'TIGR03425', NULL, NULL, 'urea_degr_2: urea carboxylase-associated protein 2', NULL, 'TIGR03425', NULL, NULL, 19244, 22),
(289521, NULL, 'TIGR03615', NULL, NULL, 'RutF: pyrimidine utilization flavin reductase protein F', NULL, 'TIGR03615', NULL, NULL, 18234, 22),
(289522, NULL, 'TIGR01589', NULL, NULL, 'A_thal_3526: uncharacterized plant-specific domain TIGR01589', NULL, 'TIGR01589', NULL, NULL, 6335, 22),
(289523, NULL, 'TIGR00624', NULL, NULL, 'tag: DNA-3-methyladenine glycosylase I', NULL, 'TIGR00624', NULL, NULL, 937, 22),
(289524, NULL, 'TIGR03597', NULL, NULL, 'GTPase_YqeH: ribosome biogenesis GTPase YqeH', NULL, 'TIGR03597', NULL, NULL, 11707, 22),
(289525, NULL, 'TIGR02632', NULL, NULL, 'RhaD_aldol-ADH: rhamnulose-1-phosphate aldolase/alcohol dehydrogenase', NULL, 'TIGR02632', NULL, NULL, 9341, 22),
(289526, NULL, 'TIGR01424', NULL, NULL, 'gluta_reduc_2: glutathione-disulfide reductase', NULL, 'TIGR01424', NULL, NULL, 4564, 22),
(289527, NULL, 'TIGR04082', NULL, NULL, 'rSAM_for_selen: selenobiotic family peptide radical SAM maturase', NULL, 'TIGR04082', NULL, NULL, 12871, 22),
(289528, NULL, 'TIGR04272', NULL, NULL, 'cxxc_cxxc_Mbark: CxxC-x17-CxxC domain', NULL, 'TIGR04272', NULL, NULL, 24538, 22),
(289529, NULL, 'TIGR03936', NULL, NULL, 'sam_1_link_chp: radical SAM-linked protein', NULL, 'TIGR03936', NULL, NULL, 18479, 22),
(289530, NULL, 'TIGR01751', NULL, NULL, 'crot-CoA-red: crotonyl-CoA carboxylase/reductase', NULL, 'TIGR01751', NULL, NULL, 2090, 22),
(289531, NULL, 'TIGR03609', NULL, NULL, 'S_layer_CsaB: polysaccharide pyruvyl transferase CsaB', NULL, 'TIGR03609', NULL, NULL, 14836, 22);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289532, NULL, 'TIGR00073', NULL, NULL, 'hypB: hydrogenase accessory protein HypB', NULL, 'TIGR00073', NULL, NULL, 5621, 22),
(289533, NULL, 'TIGR02081', NULL, NULL, 'metW: methionine biosynthesis protein MetW', NULL, 'TIGR02081', NULL, NULL, 9589, 22),
(289534, NULL, 'TIGR03301', NULL, NULL, 'PhnW-AepZ: 2-aminoethylphosphonate aminotransferase', NULL, 'TIGR03301', NULL, NULL, 11594, 22),
(289535, NULL, 'TIGR01745', NULL, NULL, 'asd_gamma: aspartate-semialdehyde dehydrogenase', NULL, 'TIGR01745', NULL, NULL, 10808, 22),
(289536, NULL, 'TIGR04266', NULL, NULL, 'NDMA_methanol: NDMA-dependent methanol dehydrogenase', NULL, 'TIGR04266', NULL, NULL, 24537, 22),
(289537, NULL, 'TIGR04312', NULL, NULL, 'choice_anch_B: choice-of-anchor B domain', NULL, 'TIGR04312', NULL, NULL, 23135, 22),
(289538, NULL, 'TIGR00911', NULL, NULL, '2A0308: L-type amino acid transporter', NULL, 'TIGR00911', NULL, NULL, 5494, 22),
(289539, NULL, 'TIGR03930', NULL, NULL, 'WXG100_ESAT6: WXG100 family type VII secretion target', NULL, 'TIGR03930', NULL, NULL, 8074, 22),
(289540, NULL, 'TIGR01097', NULL, NULL, 'PhnE: phosphonate ABC transporter, permease protein PhnE', NULL, 'TIGR01097', NULL, NULL, 4662, 22),
(289541, NULL, 'TIGR01935', NULL, NULL, 'NOT-MenG: RraA family', NULL, 'TIGR01935', NULL, NULL, 4186, 22),
(289542, NULL, 'TIGR00394', NULL, NULL, 'lac_pts_IIC: PTS system, lactose-specific IIC component', NULL, 'TIGR00394', NULL, NULL, 5529, 22),
(289543, NULL, 'TIGR02769', NULL, NULL, 'nickel_nikE: nickel import ATP-binding protein NikE', NULL, 'TIGR02769', NULL, NULL, 14085, 22),
(289544, NULL, 'TIGR02592', NULL, NULL, 'cas_Cas5h: CRISPR-associated protein Cas5, subtype I-B/HMARI', NULL, 'TIGR02592', NULL, NULL, 9143, 22),
(289545, NULL, 'TIGR00584', NULL, NULL, 'mug: mismatch-specific thymine-DNA glycosylate (mug)', NULL, 'TIGR00584', NULL, NULL, 3665, 22),
(289546, NULL, 'TIGR03569', NULL, NULL, 'NeuB_NnaB: N-acetylneuraminate synthase', NULL, 'TIGR03569', NULL, NULL, 11681, 22),
(289547, NULL, 'TIGR02414', NULL, NULL, 'pepN_proteo: aminopeptidase N', NULL, 'TIGR02414', NULL, NULL, 9560, 22),
(289548, NULL, 'TIGR04484', NULL, NULL, 'thiosulf_SoxA: sulfur oxidation c-type cytochrome SoxA', NULL, 'TIGR04484', NULL, NULL, 26468, 22),
(289549, NULL, 'TIGR00871', NULL, NULL, 'zwf: glucose-6-phosphate dehydrogenase', NULL, 'TIGR00871', NULL, NULL, 2174, 22),
(289550, NULL, 'TIGR03432', NULL, NULL, 'yjhG_yagF: putative dehydratase, YjhG/YagF family', NULL, 'TIGR03432', NULL, NULL, 19030, 22),
(289551, NULL, 'TIGR00631', NULL, NULL, 'uvrb: excinuclease ABC subunit B', NULL, 'TIGR00631', NULL, NULL, 4298, 22),
(289552, NULL, 'TIGR00768', NULL, NULL, 'rimK_fam: alpha-L-glutamate ligase, RimK family', NULL, 'TIGR00768', NULL, NULL, 2620, 22),
(289553, NULL, 'TIGR03329', NULL, NULL, 'Phn_aa_oxid: putative aminophosphonate oxidoreductase', NULL, 'TIGR03329', NULL, NULL, 17666, 22),
(289554, NULL, 'TIGR00045', NULL, NULL, 'TIGR00045: glycerate kinase', NULL, 'TIGR00045', NULL, NULL, 5633, 22),
(289555, NULL, 'TIGR03964', NULL, NULL, 'mycofact_creat: mycofactocin system creatininase family protein', NULL, 'TIGR03964', NULL, NULL, 18383, 22),
(289556, NULL, 'TIGR04259', NULL, NULL, 'oxa_formateAnti: oxalate/formate antiporter', NULL, 'TIGR04259', NULL, NULL, 24960, 22),
(289557, NULL, 'TIGR01533', NULL, NULL, 'lipo_e_P4: 5''-nucleotidase, lipoprotein e(P4) family', NULL, 'TIGR01533', NULL, NULL, 6504, 22),
(289558, NULL, 'TIGR02809', NULL, NULL, 'phasin_3: phasin family protein', NULL, 'TIGR02809', NULL, NULL, 8762, 22),
(289559, NULL, 'TIGR01063', NULL, NULL, 'gyrA: DNA gyrase, A subunit', NULL, 'TIGR01063', NULL, NULL, NULL, 22),
(289560, NULL, 'TIGR02912', NULL, NULL, 'sulfite_red_C: sulfite reductase, subunit C', NULL, 'TIGR02912', NULL, NULL, 11057, 22),
(289561, NULL, 'TIGR01561', NULL, NULL, 'gde_arch: putative glycogen debranching enzyme, archaeal type', NULL, 'TIGR01561', NULL, NULL, 6571, 22),
(289562, NULL, 'TIGR02311', NULL, NULL, 'HpaI: 2,4-dihydroxyhept-2-ene-1,7-dioic acid aldolase', NULL, 'TIGR02311', NULL, NULL, 11584, 22);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289563, NULL, 'TIGR03466', NULL, NULL, 'HpnA: hopanoid-associated sugar epimerase', NULL, 'TIGR03466', NULL, NULL, 19660, 22),
(289564, NULL, 'TIGR00182', NULL, NULL, 'plsX: fatty acid/phospholipid synthesis protein PlsX', NULL, 'TIGR00182', NULL, NULL, 8475, 22),
(289565, NULL, 'TIGR01458', NULL, NULL, 'HAD-SF-IIA-hyp3: HAD hydrolase, TIGR01458 family', NULL, 'TIGR01458', NULL, NULL, 4732, 22),
(289566, NULL, 'TIGR02688', NULL, NULL, 'TIGR02688: TIGR02688 family protein', NULL, 'TIGR02688', NULL, NULL, 13212, 22),
(289567, NULL, 'TIGR00406', NULL, NULL, 'prmA: ribosomal protein L11 methyltransferase', NULL, 'TIGR00406', NULL, NULL, 1970, 22),
(289568, NULL, 'TIGR02476', NULL, NULL, 'BluB: 5,6-dimethylbenzimidazole synthase', NULL, 'TIGR02476', NULL, NULL, 12858, 22),
(289569, NULL, 'TIGR00154', NULL, NULL, 'ispE: 4-(cytidine 5''-diphospho)-2-C-methyl-D-erythritol kinase', NULL, 'TIGR00154', NULL, NULL, 7397, 22),
(289570, NULL, 'TIGR02053', NULL, NULL, 'MerA: mercury(II) reductase', NULL, 'TIGR02053', NULL, NULL, 19145, 22),
(289571, NULL, 'TIGR02339', NULL, NULL, 'thermosome_arch: thermosome, various subunits, archaeal', NULL, 'TIGR02339', NULL, NULL, 11675, 22),
(289572, NULL, 'TIGR03827', NULL, NULL, 'GNAT_ablB: putative beta-lysine N-acetyltransferase', NULL, 'TIGR03827', NULL, NULL, 16090, 22),
(289573, NULL, 'TIGR02797', NULL, NULL, 'exbB: tonB-system energizer ExbB', NULL, 'TIGR02797', NULL, NULL, 14297, 22),
(289574, NULL, 'TIGR01642', NULL, NULL, 'U2AF_lg: U2 snRNP auxilliary factor, large subunit, splicing factor', NULL, 'TIGR01642', NULL, NULL, 158, 22),
(289575, NULL, 'TIGR01698', NULL, NULL, 'PUNP: purine nucleotide phosphorylase', NULL, 'TIGR01698', NULL, NULL, 9561, 22),
(289576, NULL, 'TIGR04019', NULL, NULL, 'B_thiol_YtxJ: bacillithiol system protein YtxJ', NULL, 'TIGR04019', NULL, NULL, 16482, 22),
(289577, NULL, 'TIGR01321', NULL, NULL, 'TrpR: trp operon repressor', NULL, 'TIGR01321', NULL, NULL, 18602, 22),
(289578, NULL, 'TIGR02551', NULL, NULL, 'SpaO_YscQ: type III secretion apparatus protein, YscQ/HrcQ family', NULL, 'TIGR02551', NULL, NULL, 11011, 22),
(289579, NULL, 'TIGR03902', NULL, NULL, 'rhom_GG_sort: rhombosortase', NULL, 'TIGR03902', NULL, NULL, 9676, 22),
(289580, NULL, 'TIGR03718', NULL, NULL, 'R_switched_Alx: integral membrane protein, TerC family', NULL, 'TIGR03718', NULL, NULL, 17337, 22),
(289581, NULL, 'TIGR02162', NULL, NULL, 'torC: trimethylamine-N-oxide reductase c-type cytochrome TorC', NULL, 'TIGR02162', NULL, NULL, 9942, 22),
(289582, NULL, 'TIGR02660', NULL, NULL, 'nifV_homocitr: homocitrate synthase', NULL, 'TIGR02660', NULL, NULL, 10411, 22),
(289583, NULL, 'TIGR00366', NULL, NULL, 'TIGR00366: TIGR00366 family protein', NULL, 'TIGR00366', NULL, NULL, 10387, 22),
(289584, NULL, 'TIGR00796', NULL, NULL, 'livcs: branched-chain amino acid transport system II carrier protein', NULL, 'TIGR00796', NULL, NULL, 3192, 22),
(289585, NULL, 'TIGR03541', NULL, NULL, 'reg_near_HchA: LuxR family transcriptional regulatory, chaperone HchA-associated', NULL, 'TIGR03541', NULL, NULL, 18298, 22),
(289586, NULL, 'TIGR01505', NULL, NULL, 'tartro_sem_red: 2-hydroxy-3-oxopropionate reductase', NULL, 'TIGR01505', NULL, NULL, 5782, 22),
(289587, NULL, 'TIGR02837', NULL, NULL, 'spore_II_R: stage II sporulation protein R', NULL, 'TIGR02837', NULL, NULL, 9071, 22),
(289588, NULL, 'TIGR04375', NULL, NULL, 'cyano_w_EgtBD: hercynine metabolism protein', NULL, 'TIGR04375', NULL, NULL, 21807, 22),
(289589, NULL, 'TIGR03220', NULL, NULL, 'catechol_dmpE: 2-oxopent-4-enoate hydratase', NULL, 'TIGR03220', NULL, NULL, 16731, 22),
(289590, NULL, 'TIGR01212', NULL, NULL, 'TIGR01212: radical SAM protein, TIGR01212 family', NULL, 'TIGR01212', NULL, NULL, 473, 22),
(289591, NULL, 'TIGR04203', NULL, NULL, 'RPT_S_cricet: Streptococcal surface-anchored protein repeat, S. criceti family', NULL, 'TIGR04203', NULL, NULL, 21017, 22),
(289592, NULL, 'TIGR02367', NULL, NULL, 'PylS_Cterm: pyrrolysine--tRNA ligase, C-terminal region', NULL, 'TIGR02367', NULL, NULL, 17826, 22),
(289593, NULL, 'TIGR02190', NULL, NULL, 'GlrX-dom: glutaredoxin-family domain', NULL, 'TIGR02190', NULL, NULL, 12452, 22);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289594, NULL, 'TIGR01172', NULL, NULL, 'cysE: serine O-acetyltransferase', NULL, 'TIGR01172', NULL, NULL, 6797, 22),
(289595, NULL, 'TIGR02046', NULL, NULL, 'sdhC_b558_fam: succinate dehydrogenase (or fumarate reductase) cytochrome b subunit, b558 family', NULL, 'TIGR02046', NULL, NULL, 10250, 22),
(289596, NULL, 'TIGR00836', NULL, NULL, 'amt: ammonium transporter', NULL, 'TIGR00836', NULL, NULL, 5244, 22),
(289597, NULL, 'TIGR00017', NULL, NULL, 'cmk: cytidylate kinase', NULL, 'TIGR00017', NULL, NULL, 1936, 22),
(289598, NULL, 'TIGR03494', NULL, NULL, 'salicyl_syn: salicylate synthase', NULL, 'TIGR03494', NULL, NULL, 16869, 22),
(289599, NULL, 'TIGR02202', NULL, NULL, 'Ehrlichia_rpt: Ehrlichia chaffeensis immunodominant surface protein repeat', NULL, 'TIGR02202', NULL, NULL, 11622, 22),
(289600, NULL, 'TIGR01035', NULL, NULL, 'hemA: glutamyl-tRNA reductase', NULL, 'TIGR01035', NULL, NULL, 39, 22),
(289601, NULL, 'TIGR01991', NULL, NULL, 'HscA: Fe-S protein assembly chaperone HscA', NULL, 'TIGR01991', NULL, NULL, 4126, 22),
(289602, NULL, 'TIGR01356', NULL, NULL, 'aroA: 3-phosphoshikimate 1-carboxyvinyltransferase', NULL, 'TIGR01356', NULL, NULL, 3826, 22),
(289603, NULL, 'TIGR02523', NULL, NULL, 'type_IV_pilV: type IV pilus modification protein PilV', NULL, 'TIGR02523', NULL, NULL, 18645, 22),
(289604, NULL, 'TIGR00201', NULL, NULL, 'comF: comF family protein', NULL, 'TIGR00201', NULL, NULL, 11419, 22),
(289605, NULL, 'TIGR03678', NULL, NULL, 'het_cyc_patell: bacteriocin leader peptide, microcyclamide/patellamide family', NULL, 'TIGR03678', NULL, NULL, 15501, 22),
(289606, NULL, 'TIGR03855', NULL, NULL, 'NAD_NadX: aspartate dehydrogenase', NULL, 'TIGR03855', NULL, NULL, 16165, 22),
(289607, NULL, 'TIGR00515', NULL, NULL, 'accD: acetyl-CoA carboxylase, carboxyl transferase, beta subunit', NULL, 'TIGR00515', NULL, NULL, 5891, 22),
(289608, NULL, 'TIGR01349', NULL, NULL, 'PDHac_trf_mito: pyruvate dehydrogenase complex dihydrolipoamide acetyltransferase', NULL, 'TIGR01349', NULL, NULL, 3958, 22),
(289609, NULL, 'TIGR02700', NULL, NULL, 'flavo_MJ0208: archaeoflavoprotein, MJ0208 family', NULL, 'TIGR02700', NULL, NULL, 13485, 22),
(289610, NULL, 'TIGR00980', NULL, NULL, '3a0801so1tim17: mitochondrial import inner membrane translocase subunit tim17', NULL, 'TIGR00980', NULL, NULL, 3547, 22),
(289611, NULL, 'TIGR03357', NULL, NULL, 'VI_zyme: type VI secretion system lysozyme-like protein', NULL, 'TIGR03357', NULL, NULL, 18320, 22),
(289612, NULL, 'TIGR01493', NULL, NULL, 'HAD-SF-IA-v2: HAD hydrolase, family IA, variant 2', NULL, 'TIGR01493', NULL, NULL, 6934, 22),
(289613, NULL, 'TIGR02844', NULL, NULL, 'spore_III_D: sporulation transcriptional regulator SpoIIID', NULL, 'TIGR02844', NULL, NULL, 9471, 22),
(289614, NULL, 'TIGR03180', NULL, NULL, 'UraD_2: OHCU decarboxylase', NULL, 'TIGR03180', NULL, NULL, 15756, 22),
(289615, NULL, 'TIGR04397', NULL, NULL, 'SecA2_Bac_anthr: accessory Sec system translocase SecA2', NULL, 'TIGR04397', NULL, NULL, 25335, 22),
(289616, NULL, 'TIGR03519', NULL, NULL, 'T9SS_PorP_fam: type IX secretion system membrane protein, PorP/SprF family', NULL, 'TIGR03519', NULL, NULL, 16721, 22),
(289617, NULL, 'TIGR04260', NULL, NULL, 'Cyano_gly_rpt: rSAM-associated Gly-rich repeat protein', NULL, 'TIGR04260', NULL, NULL, 24754, 22),
(289618, NULL, 'TIGR01789', NULL, NULL, 'lycopene_cycl: lycopene cyclase', NULL, 'TIGR01789', NULL, NULL, 12178, 22),
(289619, NULL, 'TIGR01324', NULL, NULL, 'cysta_beta_ly_B: cystathionine beta-lyase', NULL, 'TIGR01324', NULL, NULL, 3206, 22),
(289620, NULL, 'TIGR01652', NULL, NULL, 'ATPase-Plipid: phospholipid-translocating P-type ATPase, flippase', NULL, 'TIGR01652', NULL, NULL, 355, 22),
(289621, NULL, 'TIGR02099', NULL, NULL, 'TIGR02099: TIGR02099 family protein', NULL, 'TIGR02099', NULL, NULL, 13720, 22),
(289622, NULL, 'TIGR03774', NULL, NULL, 'RPE2: rickettsial palindromic element RPE2 domain', NULL, 'TIGR03774', NULL, NULL, 15675, 22),
(289623, NULL, 'TIGR00080', NULL, NULL, 'pimt: protein-L-isoaspartate O-methyltransferase', NULL, 'TIGR00080', NULL, NULL, 6763, 22);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289624, NULL, 'TIGR04069', NULL, NULL, 'ocin_ACP_rel: peptide maturation system acyl carrier-related protein', NULL, 'TIGR04069', NULL, NULL, 11464, 22),
(289625, NULL, 'TIGR01620', NULL, NULL, 'hyp_HI0043: TIGR01620 family protein', NULL, 'TIGR01620', NULL, NULL, 7354, 22),
(289626, NULL, 'TIGR00958', NULL, NULL, '3a01208: antigen peptide transporter 2', NULL, 'TIGR00958', NULL, NULL, 8764, 22),
(289627, NULL, 'TIGR03566', NULL, NULL, 'FMN_reduc_MsuE: FMN reductase', NULL, 'TIGR03566', NULL, NULL, 18019, 22),
(289628, NULL, 'TIGR00973', NULL, NULL, 'leuA_bact: 2-isopropylmalate synthase', NULL, 'TIGR00973', NULL, NULL, 3819, 22),
(289629, NULL, 'TIGR04213', NULL, NULL, 'PGF_pre_PGF: PGF-pre-PGF domain', NULL, 'TIGR04213', NULL, NULL, 23464, 22),
(289630, NULL, 'TIGR04365', NULL, NULL, 'spare_glycyl: autonomous glycyl radical cofactor GrcA', NULL, 'TIGR04365', NULL, NULL, 10193, 22),
(289631, NULL, 'TIGR02290', NULL, NULL, 'M3_fam_3: oligoendopeptidase, pepF/M3 family', NULL, 'TIGR02290', NULL, NULL, 13144, 22),
(289632, NULL, 'TIGR01371', NULL, NULL, 'met_syn_B12ind: 5-methyltetrahydropteroyltriglutamate--homocysteine S-methyltransferase', NULL, 'TIGR01371', NULL, NULL, 3772, 22),
(289633, NULL, 'TIGR01605', NULL, NULL, 'PYST-D: Plasmodium yoelii subtelomeric family PYST-D', NULL, 'TIGR01605', NULL, NULL, 6390, 22),
(289634, NULL, 'TIGR02943', NULL, NULL, 'Sig70_famx1: RNA polymerase sigma-70 factor, TIGR02943 family', NULL, 'TIGR02943', NULL, NULL, 8608, 22),
(289635, NULL, 'TIGR00033', NULL, NULL, 'aroC: chorismate synthase', NULL, 'TIGR00033', NULL, NULL, 6508, 22),
(289636, NULL, 'TIGR01309', NULL, NULL, 'uL30_arch: ribosomal protein uL30', NULL, 'TIGR01309', NULL, NULL, 1392, 22),
(289637, NULL, 'TIGR02588', NULL, NULL, 'TIGR02588: TIGR02588 family protein', NULL, 'TIGR02588', NULL, NULL, 9052, 22),
(289638, NULL, 'TIGR03581', NULL, NULL, 'EF_0839: conserved hypothetical protein EF_0839/AHA_3917', NULL, 'TIGR03581', NULL, NULL, 9779, 22),
(289639, NULL, 'TIGR02243', NULL, NULL, 'TIGR02243: putative baseplate assembly protein', NULL, 'TIGR02243', NULL, NULL, 11876, 22),
(289640, NULL, 'TIGR02990', NULL, NULL, 'ectoine_eutA: ectoine utilization protein EutA', NULL, 'TIGR02990', NULL, NULL, 10399, 22),
(289641, NULL, 'TIGR00677', NULL, NULL, 'fadh2_euk: methylenetetrahydrofolate reductase', NULL, 'TIGR00677', NULL, NULL, 2431, 22),
(289642, NULL, 'TIGR03133', NULL, NULL, 'malonate_beta: biotin-independent malonate decarboxylase, beta subunit', NULL, 'TIGR03133', NULL, NULL, 14992, 22),
(289643, NULL, 'TIGR03238', NULL, NULL, 'dnd_assoc_3: DNA phosphorothioation-dependent restriction protein DptF', NULL, 'TIGR03238', NULL, NULL, 16908, 22),
(289644, NULL, 'TIGR00540', NULL, NULL, 'TPR_hemY_coli: heme biosynthesis-associated TPR protein', NULL, 'TIGR00540', NULL, NULL, 11313, 22),
(289645, NULL, 'TIGR01757', NULL, NULL, 'Malate-DH_plant: malate dehydrogenase, NADP-dependent', NULL, 'TIGR01757', NULL, NULL, 9606, 22),
(289646, NULL, 'TIGR00481', NULL, NULL, 'TIGR00481: Raf kinase inhibitor-like protein, YbhB/YbcL family', NULL, 'TIGR00481', NULL, NULL, 11363, 22),
(289647, NULL, 'TIGR02928', NULL, NULL, 'TIGR02928: orc1/cdc6 family replication initiation protein', NULL, 'TIGR02928', NULL, NULL, 8995, 22),
(289648, NULL, 'TIGR00821', NULL, NULL, 'EII-GUT: PTS system, glucitol/sorbitol-specific, IIC component', NULL, 'TIGR00821', NULL, NULL, 3466, 22),
(289649, NULL, 'TIGR03074', NULL, NULL, 'PQQ_membr_DH: membrane-bound PQQ-dependent dehydrogenase, glucose/quinate/shikimate family', NULL, 'TIGR03074', NULL, NULL, 21227, 22),
(289650, NULL, 'TIGR00229', NULL, NULL, 'sensory_box: PAS domain S-box protein', NULL, 'TIGR00229', NULL, NULL, 3787, 22),
(289651, NULL, 'TIGR00244', NULL, NULL, 'TIGR00244: transcriptional regulator NrdR', NULL, 'TIGR00244', NULL, NULL, 3117, 22),
(289652, NULL, 'TIGR00419', NULL, NULL, 'tim: triose-phosphate isomerase', NULL, 'TIGR00419', NULL, NULL, 4335, 22),
(289653, NULL, 'TIGR03027', NULL, NULL, 'pepcterm_export: putative polysaccharide export protein, PEP-CTERM sytem-associated', NULL, 'TIGR03027', NULL, NULL, 20762, 22);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289654, NULL, 'TIGR04409', NULL, NULL, 'LptC_YrbK: LPS export ABC transporter periplasmic protein LptC', NULL, 'TIGR04409', NULL, NULL, 21865, 22),
(289655, NULL, 'TIGR02454', NULL, NULL, 'ECF_T_CbiQ: cobalt ECF transporter T component CbiQ', NULL, 'TIGR02454', NULL, NULL, 12546, 22),
(289656, NULL, 'TIGR01816', NULL, NULL, 'sdhA_forward: succinate dehydrogenase, flavoprotein subunit', NULL, 'TIGR01816', NULL, NULL, 10007, 22),
(289657, NULL, 'TIGR01711', NULL, NULL, 'gspJ: type II secretion system protein J', NULL, 'TIGR01711', NULL, NULL, 5262, 22),
(289658, NULL, 'TIGR02436', NULL, NULL, 'TIGR02436: four helix bundle protein', NULL, 'TIGR02436', NULL, NULL, 10099, 22),
(289659, NULL, 'TIGR02940', NULL, NULL, 'anfO_nitrog: Fe-only nitrogenase accessory protein AnfO', NULL, 'TIGR02940', NULL, NULL, 8550, 22),
(289660, NULL, 'TIGR03235', NULL, NULL, 'DNA_S_dndA: cysteine desulfurase DndA', NULL, 'TIGR03235', NULL, NULL, 16762, 22),
(289661, NULL, 'TIGR00138', NULL, NULL, 'rsmG_gidB: 16S rRNA (guanine(527)-N(7))-methyltransferase RsmG', NULL, 'TIGR00138', NULL, NULL, 1890, 22),
(289662, NULL, 'TIGR04424', NULL, NULL, 'metallo_McbB: McbB family protein', NULL, 'TIGR04424', NULL, NULL, 24989, 22),
(289663, NULL, 'TIGR03668', NULL, NULL, 'Rv0121_F420: PPOX class probable F420-dependent enzyme, Rv0121 family', NULL, 'TIGR03668', NULL, NULL, 15657, 22),
(289664, NULL, 'TIGR01163', NULL, NULL, 'rpe: ribulose-phosphate 3-epimerase', NULL, 'TIGR01163', NULL, NULL, 26404, 22),
(289665, NULL, 'TIGR00970', NULL, NULL, 'leuA_yeast: 2-isopropylmalate synthase', NULL, 'TIGR00970', NULL, NULL, 3702, 22),
(289666, NULL, 'TIGR04318', NULL, NULL, 'lacto_ODC_hypo: putative ornithine decarboxylase', NULL, 'TIGR04318', NULL, NULL, 25355, 22),
(289667, NULL, 'TIGR03531', NULL, NULL, 'selenium_SpcS: O-phosphoseryl-tRNA(Sec) selenium transferase', NULL, 'TIGR03531', NULL, NULL, 16850, 22),
(289668, NULL, 'TIGR03563', NULL, NULL, 'perox_SACOL1771: peroxiredoxin, SACOL1771 subfamily', NULL, 'TIGR03563', NULL, NULL, 18362, 22),
(289669, NULL, 'TIGR01116', NULL, NULL, 'ATPase-IIA1_Ca: calcium-translocating P-type ATPase, SERCA-type', NULL, 'TIGR01116', NULL, NULL, 5937, 22),
(289670, NULL, 'TIGR02108', NULL, NULL, 'PQQ_syn_pqqB: coenzyme PQQ biosynthesis protein B', NULL, 'TIGR02108', NULL, NULL, 13737, 22),
(289671, NULL, 'TIGR00185', NULL, NULL, 'tRNA_yibK_trmL: tRNA (cytidine(34)-2''-O)-methyltransferase', NULL, 'TIGR00185', NULL, NULL, 17296, 22),
(289672, NULL, 'TIGR03996', NULL, NULL, 'mycofact_OYE_1: mycofactocin system FadH/OYE family oxidoreductase 1', NULL, 'TIGR03996', NULL, NULL, 10854, 22),
(289673, NULL, 'TIGR02049', NULL, NULL, 'gshA_ferroox: glutamate--cysteine ligase', NULL, 'TIGR02049', NULL, NULL, 10831, 22),
(289674, NULL, 'TIGR00466', NULL, NULL, 'kdsB: 3-deoxy-D-manno-octulosonate cytidylyltransferase', NULL, 'TIGR00466', NULL, NULL, 1570, 22),
(289675, NULL, 'TIGR02782', NULL, NULL, 'TrbB_P: P-type conjugative transfer ATPase TrbB', NULL, 'TIGR02782', NULL, NULL, 14314, 22),
(289676, NULL, 'TIGR03727', NULL, NULL, 'urea_t_UrtC_arc: urea ABC transporter, permease protein UrtC', NULL, 'TIGR03727', NULL, NULL, 16345, 22),
(289677, NULL, 'TIGR00001', NULL, NULL, 'rpmI_bact: ribosomal protein bL35', NULL, 'TIGR00001', NULL, NULL, 3300, 22),
(289678, NULL, 'TIGR00525', NULL, NULL, 'folB: dihydroneopterin aldolase', NULL, 'TIGR00525', NULL, NULL, 10371, 22),
(289679, NULL, 'TIGR01359', NULL, NULL, 'UMP_CMP_kin_fam: UMP-CMP kinase family', NULL, 'TIGR01359', NULL, NULL, 3660, 22),
(289680, NULL, 'TIGR01863', NULL, NULL, 'cas_Csd1: CRISPR-associated protein Cas8c/Csd1, subtype I-C/DVULG', NULL, 'TIGR01863', NULL, NULL, 10862, 22),
(289681, NULL, 'TIGR00736', NULL, NULL, 'nifR3_rel_arch: putative TIM-barrel protein', NULL, 'TIGR00736', NULL, NULL, 4394, 22),
(289682, NULL, 'TIGR02392', NULL, NULL, 'rpoH_proteo: alternative sigma factor RpoH', NULL, 'TIGR02392', NULL, NULL, 9931, 22),
(289683, NULL, 'TIGR01754', NULL, NULL, 'flav_RNR: putative ribonucleotide reductase-associated flavodoxin', NULL, 'TIGR01754', NULL, NULL, 2168, 22);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289684, NULL, 'TIGR04315', NULL, NULL, 'octaheme_Shew: octaheme c-type cytochrome, tetrathionate reductase family', NULL, 'TIGR04315', NULL, NULL, 21188, 22),
(289685, NULL, 'TIGR04107', NULL, NULL, 'rSAM_HutW: putative heme utilization radical SAM enzyme HutW', NULL, 'TIGR04107', NULL, NULL, 23111, 22),
(289686, NULL, 'TIGR01374', NULL, NULL, 'soxD: sarcosine oxidase, delta subunit family', NULL, 'TIGR01374', NULL, NULL, 3812, 22),
(289687, NULL, 'TIGR00528', NULL, NULL, 'gcvT: glycine cleavage system T protein', NULL, 'TIGR00528', NULL, NULL, 11049, 22),
(289688, NULL, 'TIGR00783', NULL, NULL, 'ccs: citrate carrier protein, CCS family', NULL, 'TIGR00783', NULL, NULL, 11751, 22),
(289689, NULL, 'TIGR01546', NULL, NULL, 'GAPDH-II_archae: glyceraldehyde-3-phosphate dehydrogenase, type II', NULL, 'TIGR01546', NULL, NULL, 6546, 22),
(289690, NULL, 'TIGR01707', NULL, NULL, 'gspI: type II secretion system protein I', NULL, 'TIGR01707', NULL, NULL, 5276, 22),
(289691, NULL, 'TIGR04362', NULL, NULL, 'choice_anch_C: choice-of-anchor C domain', NULL, 'TIGR04362', NULL, NULL, 23483, 22),
(289692, NULL, 'TIGR04154', NULL, NULL, 'archaeo_STT3: oligosaccharyl transferase, archaeosortase A system-associated', NULL, 'TIGR04154', NULL, NULL, 21245, 22),
(289693, NULL, 'TIGR00079', NULL, NULL, 'pept_deformyl: peptide deformylase', NULL, 'TIGR00079', NULL, NULL, 6229, 22),
(289694, NULL, 'TIGR03672', NULL, NULL, 'rpl4p_arch: 50S ribosomal protein uL4', NULL, 'TIGR03672', NULL, NULL, 15956, 22),
(289695, NULL, 'TIGR02673', NULL, NULL, 'FtsE: cell division ATP-binding protein FtsE', NULL, 'TIGR02673', NULL, NULL, 4279, 22),
(289696, NULL, 'TIGR01327', NULL, NULL, 'PGDH: phosphoglycerate dehydrogenase', NULL, 'TIGR01327', NULL, NULL, 3987, 22),
(289697, NULL, 'TIGR00955', NULL, NULL, '3a01204: pigment precursor permease', NULL, 'TIGR00955', NULL, NULL, 4407, 22),
(289698, NULL, 'TIGR02158', NULL, NULL, 'PA_CoA_Oxy3: phenylacetate-CoA oxygenase, PaaI subunit', NULL, 'TIGR02158', NULL, NULL, 8876, 22),
(289699, NULL, 'TIGR02538', NULL, NULL, 'type_IV_pilB: type IV-A pilus assembly ATPase PilB', NULL, 'TIGR02538', NULL, NULL, 11092, 22),
(289700, NULL, 'TIGR02021', NULL, NULL, 'BchM-ChlM: magnesium protoporphyrin O-methyltransferase', NULL, 'TIGR02021', NULL, NULL, 5139, 22),
(289701, NULL, 'TIGR02401', NULL, NULL, 'trehalose_TreY: malto-oligosyltrehalose synthase', NULL, 'TIGR02401', NULL, NULL, 9910, 22),
(289702, NULL, 'TIGR01593', NULL, NULL, 'holin_tox_secr: toxin secretion/phage lysis holin', NULL, 'TIGR01593', NULL, NULL, 6454, 22),
(289703, NULL, 'TIGR01655', NULL, NULL, 'yxeA_fam: conserved hypothetical protein', NULL, 'TIGR01655', NULL, NULL, 363, 22),
(289704, NULL, 'TIGR04216', NULL, NULL, 'halo_surf_glyco: major cell surface glycoprotein', NULL, 'TIGR04216', NULL, NULL, 23465, 22),
(289705, NULL, 'TIGR03176', NULL, NULL, 'AllC: allantoate amidohydrolase', NULL, 'TIGR03176', NULL, NULL, 15689, 22),
(289706, NULL, 'TIGR00431', NULL, NULL, 'TruB: tRNA pseudouridine(55) synthase', NULL, 'TIGR00431', NULL, NULL, 8750, 22),
(289707, NULL, 'TIGR04471', NULL, NULL, 'rSAM_mob_pairA: radical SAM mobile pair protein A', NULL, 'TIGR04471', NULL, NULL, 25813, 22),
(289708, NULL, 'TIGR02486', NULL, NULL, 'RDH: reductive dehalogenase', NULL, 'TIGR02486', NULL, NULL, 12913, 22),
(289709, NULL, 'TIGR02345', NULL, NULL, 'chap_CCT_eta: T-complex protein 1, eta subunit', NULL, 'TIGR02345', NULL, NULL, 11551, 22),
(289710, NULL, 'TIGR02217', NULL, NULL, 'chp_TIGR02217: TIGR02217 family protein', NULL, 'TIGR02217', NULL, NULL, 11929, 22),
(289711, NULL, 'TIGR03136', NULL, NULL, 'malonate_biotin: Na+-transporting malonate decarboxylase, carboxybiotin decarboxylase subunit', NULL, 'TIGR03136', NULL, NULL, 14770, 22),
(289712, NULL, 'TIGR03516', NULL, NULL, 'ppisom_GldI: peptidyl-prolyl isomerase, gliding motility-associated', NULL, 'TIGR03516', NULL, NULL, 16933, 22),
(289713, NULL, 'TIGR02869', NULL, NULL, 'spore_SleB: spore cortex-lytic enzyme', NULL, 'TIGR02869', NULL, NULL, 10894, 22),
(289714, NULL, 'TIGR01714', NULL, NULL, 'phage_rep_org_N: phage replisome organizer, putative, N-terminal region', NULL, 'TIGR01714', NULL, NULL, 5289, 22);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289715, NULL, 'TIGR03457', NULL, NULL, 'sulphoacet_xsc: sulfoacetaldehyde acetyltransferase', NULL, 'TIGR03457', NULL, NULL, 19223, 22),
(289716, NULL, 'TIGR00674', NULL, NULL, 'dapA: 4-hydroxy-tetrahydrodipicolinate synthase', NULL, 'TIGR00674', NULL, NULL, 4098, 22),
(289717, NULL, 'TIGR02439', NULL, NULL, 'catechol_proteo: catechol 1,2-dioxygenase', NULL, 'TIGR02439', NULL, NULL, 12677, 22),
(289718, NULL, 'TIGR02819', NULL, NULL, 'fdhA_non_GSH: formaldehyde dehydrogenase, glutathione-independent', NULL, 'TIGR02819', NULL, NULL, 8977, 22),
(289719, NULL, 'TIGR00294', NULL, NULL, 'TIGR00294: GTP cyclohydrolase', NULL, 'TIGR00294', NULL, NULL, 3453, 22),
(289720, NULL, 'TIGR02302', NULL, NULL, 'aProt_lowcomp: TIGR02302 family protein', NULL, 'TIGR02302', NULL, NULL, 11701, 22),
(289721, NULL, 'TIGR04459', NULL, NULL, 'TisB_tox: type I toxin-antitoxin system toxin TisB', NULL, 'TIGR04459', NULL, NULL, 21831, 22),
(289722, NULL, 'TIGR03077', NULL, NULL, 'not_gcvH: glycine cleavage protein H-like protein', NULL, 'TIGR03077', NULL, NULL, 21097, 22),
(289723, NULL, 'TIGR00712', NULL, NULL, 'glpT: glycerol-3-phosphate transporter', NULL, 'TIGR00712', NULL, NULL, 4001, 22),
(289724, NULL, 'TIGR02404', NULL, NULL, 'trehalos_R_Bsub: trehalose operon repressor', NULL, 'TIGR02404', NULL, NULL, 9751, 22),
(289725, NULL, 'TIGR01898', NULL, NULL, 'cas_TM1791_cmr6: CRISPR type III-B/RAMP module RAMP protein Cmr6', NULL, 'TIGR01898', NULL, NULL, 10642, 22),
(289726, NULL, 'TIGR00849', NULL, NULL, 'gutA: PTS system, glucitol/sorbitol-specific IIA component', NULL, 'TIGR00849', NULL, NULL, 9030, 22),
(289727, NULL, 'TIGR01761', NULL, NULL, 'thiaz-red: thiazolinyl imide reductase', NULL, 'TIGR01761', NULL, NULL, 2120, 22),
(289728, NULL, 'TIGR04322', NULL, NULL, 'rSAM_QueE_Ecoli: putative 7-cyano-7-deazaguanosine (preQ0) biosynthesis protein QueE', NULL, 'TIGR04322', NULL, NULL, 25483, 22),
(289729, NULL, 'TIGR01265', NULL, NULL, 'tyr_nico_aTase: tyrosine/nicotianamine family aminotransferase', NULL, 'TIGR01265', NULL, NULL, 208, 22),
(289730, NULL, 'TIGR01848', NULL, NULL, 'PHA_reg_PhaR: polyhydroxyalkanoate synthesis repressor PhaR', NULL, 'TIGR01848', NULL, NULL, 10673, 22),
(289731, NULL, 'TIGR01695', NULL, NULL, 'murJ_mviN: murein biosynthesis integral membrane protein MurJ', NULL, 'TIGR01695', NULL, NULL, 3910, 22),
(289732, NULL, 'TIGR03042', NULL, NULL, 'PS_II_psbQ_bact: photosystem II protein PsbQ', NULL, 'TIGR03042', NULL, NULL, 20785, 22),
(289733, NULL, 'TIGR00110', NULL, NULL, 'ilvD: dihydroxy-acid dehydratase', NULL, 'TIGR00110', NULL, NULL, 5923, 22),
(289734, NULL, 'TIGR00920', NULL, NULL, '2A060605: 3-hydroxy-3-methylglutaryl-coenzyme A reductase', NULL, 'TIGR00920', NULL, NULL, 4282, 22),
(289735, NULL, 'TIGR03129', NULL, NULL, 'one_C_dehyd_B: formylmethanofuran dehydrogenase subunit B', NULL, 'TIGR03129', NULL, NULL, 15246, 22),
(289736, NULL, 'TIGR00051', NULL, NULL, 'TIGR00051: acyl-CoA thioester hydrolase, YbgC/YbaW family', NULL, 'TIGR00051', NULL, NULL, 2319, 22),
(289737, NULL, 'TIGR02352', NULL, NULL, 'thiamin_ThiO: glycine oxidase ThiO', NULL, 'TIGR02352', NULL, NULL, 11998, 22),
(289738, NULL, 'TIGR02732', NULL, NULL, 'zeta_caro_desat: 9,9''-di-cis-zeta-carotene desaturase', NULL, 'TIGR02732', NULL, NULL, 14260, 22),
(289739, NULL, 'TIGR03993', NULL, NULL, 'hydrog_HybE: [NiFe] hydrogenase assembly chaperone, HybE family', NULL, 'TIGR03993', NULL, NULL, 18468, 22),
(289740, NULL, 'TIGR00896', NULL, NULL, 'CynX: cyanate transporter', NULL, 'TIGR00896', NULL, NULL, 5372, 22),
(289741, NULL, 'TIGR02647', NULL, NULL, 'DNA: TIGR02647 family protein', NULL, 'TIGR02647', NULL, NULL, 10255, 22),
(289742, NULL, 'TIGR01813', NULL, NULL, 'flavo_cyto_c: flavocytochrome c', NULL, 'TIGR01813', NULL, NULL, 2395, 22),
(289743, NULL, 'TIGR00575', NULL, NULL, 'dnlj: DNA ligase, NAD-dependent', NULL, 'TIGR00575', NULL, NULL, 3390, 22),
(289744, NULL, 'TIGR04178', NULL, NULL, 'exo_archaeo: exosortase/archaeosortase family protein', NULL, 'TIGR04178', NULL, NULL, 21278, 22),
(289745, NULL, 'TIGR01218', NULL, NULL, 'Gpos_tandem_5TM: tandem five-TM protein', NULL, 'TIGR01218', NULL, NULL, 402, 22);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289746, NULL, 'TIGR00568', NULL, NULL, 'alkb: alkylated DNA repair protein AlkB', NULL, 'TIGR00568', NULL, NULL, 835, 22),
(289747, NULL, 'TIGR02975', NULL, NULL, 'phageshock_pspG: phage shock protein G', NULL, 'TIGR02975', NULL, NULL, 9760, 22),
(289748, NULL, 'TIGR01225', NULL, NULL, 'hutH: histidine ammonia-lyase', NULL, 'TIGR01225', NULL, NULL, 105, 22),
(289749, NULL, 'TIGR02071', NULL, NULL, 'PBP_1b: penicillin-binding protein 1B', NULL, 'TIGR02071', NULL, NULL, 13187, 22),
(289750, NULL, 'TIGR03625', NULL, NULL, 'L3_bact: 50S ribosomal protein uL3', NULL, 'TIGR03625', NULL, NULL, 15086, 22),
(289751, NULL, 'TIGR04256', NULL, NULL, 'GxxExxY: GxxExxY protein', NULL, 'TIGR04256', NULL, NULL, 24750, 22),
(289752, NULL, 'TIGR03946', NULL, NULL, 'viomycin_VioC: arginine beta-hydroxylase, Fe(II)/alpha-ketoglutarate-dependent', NULL, 'TIGR03946', NULL, NULL, 10672, 22),
(289753, NULL, 'TIGR03101', NULL, NULL, 'hydr2_PEP: exosortase A system-associated hydrolase 2', NULL, 'TIGR03101', NULL, NULL, 14595, 22),
(289754, NULL, 'TIGR00247', NULL, NULL, 'TIGR00247: conserved hypothetical protein, YceG family', NULL, 'TIGR00247', NULL, NULL, 2434, 22),
(289755, NULL, 'TIGR00627', NULL, NULL, 'tfb4: transcription factor tfb4', NULL, 'TIGR00627', NULL, NULL, 922, 22),
(289756, NULL, 'TIGR00908', NULL, NULL, '2A0305: ethanolamine permease', NULL, 'TIGR00908', NULL, NULL, 5018, 22),
(289757, NULL, 'TIGR02510', NULL, NULL, 'NrdE-prime: ribonucleoside-diphosphate reductase, alpha chain', NULL, 'TIGR02510', NULL, NULL, 18547, 22),
(289758, NULL, 'TIGR04499', NULL, NULL, 'abortive_AbiA: abortive infection protein, AbiA family', NULL, 'TIGR04499', NULL, NULL, 21723, 22),
(289759, NULL, 'TIGR03665', NULL, NULL, 'arCOG04150: arCOG04150 universal archaeal KH domain protein', NULL, 'TIGR03665', NULL, NULL, 15594, 22),
(289760, NULL, 'TIGR04263', NULL, NULL, 'SasC_Mrp_aggreg: SasC/Mrp/FmtB intercellular aggregation domain', NULL, 'TIGR04263', NULL, NULL, 24652, 22),
(289761, NULL, 'TIGR01480', NULL, NULL, 'copper_res_A: copper-resistance protein, CopA family', NULL, 'TIGR01480', NULL, NULL, 5503, 22),
(289762, NULL, 'TIGR02451', NULL, NULL, 'anti_sig_ChrR: anti-sigma factor, putative, ChrR family', NULL, 'TIGR02451', NULL, NULL, 12519, 22),
(289763, NULL, 'TIGR03344', NULL, NULL, 'VI_effect_Hcp1: type VI secretion system effector, Hcp1 family', NULL, 'TIGR03344', NULL, NULL, 12716, 22),
(289764, NULL, 'TIGR03285', NULL, NULL, 'methan_mark_14: putative methanogenesis marker protein 14', NULL, 'TIGR03285', NULL, NULL, 8825, 22),
(289765, NULL, 'TIGR03370', NULL, NULL, 'VPLPA-CTERM: VPLPA-CTERM protein sorting domain', NULL, 'TIGR03370', NULL, NULL, 15718, 22),
(289766, NULL, 'TIGR00188', NULL, NULL, 'rnpA: ribonuclease P protein component', NULL, 'TIGR00188', NULL, NULL, 3569, 22),
(289767, NULL, 'TIGR03379', NULL, NULL, 'glycerol3P_GlpC: glycerol-3-phosphate dehydrogenase, anaerobic, C subunit', NULL, 'TIGR03379', NULL, NULL, 18717, 22),
(289768, NULL, 'TIGR02327', NULL, NULL, 'int_mem_ywzB: conserved hypothetical integral membrane protein', NULL, 'TIGR02327', NULL, NULL, 9739, 22),
(289769, NULL, 'TIGR04400', NULL, NULL, 'RK_trnsloc_Pase: Arg-Lys translocation region protein phosphatase', NULL, 'TIGR04400', NULL, NULL, 21183, 22),
(289770, NULL, 'TIGR03242', NULL, NULL, 'arg_catab_astE: succinylglutamate desuccinylase', NULL, 'TIGR03242', NULL, NULL, 20010, 22),
(289771, NULL, 'TIGR04537', NULL, NULL, 'encap_target: encapsulation C-terminal sorting signal', NULL, 'TIGR04537', NULL, NULL, NULL, 22),
(289772, NULL, 'TIGR02891', NULL, NULL, 'CtaD_CoxA: cytochrome c oxidase, subunit I', NULL, 'TIGR02891', NULL, NULL, 10958, 22),
(289773, NULL, 'TIGR00681', NULL, NULL, 'kdpC: K+-transporting ATPase, C subunit', NULL, 'TIGR00681', NULL, NULL, 3260, 22),
(289774, NULL, 'TIGR00220', NULL, NULL, 'mscL: large conductance mechanosensitive channel protein', NULL, 'TIGR00220', NULL, NULL, 1354, 22),
(289775, NULL, 'TIGR00357', NULL, NULL, 'TIGR00357: methionine-R-sulfoxide reductase', NULL, 'TIGR00357', NULL, NULL, 1901, 22);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289776, NULL, 'TIGR03914', NULL, NULL, 'UDG_fam_dom: uracil-DNA glycosylase family domain', NULL, 'TIGR03914', NULL, NULL, 4042, 22),
(289777, NULL, 'TIGR02775', NULL, NULL, 'TrbG_Ti: P-type conjugative transfer protein TrbG', NULL, 'TIGR02775', NULL, NULL, 14180, 22),
(289778, NULL, 'TIGR00739', NULL, NULL, 'yajC: preprotein translocase, YajC subunit', NULL, 'TIGR00739', NULL, NULL, 3067, 22),
(289779, NULL, 'TIGR00565', NULL, NULL, 'trpE_proteo: anthranilate synthase component I', NULL, 'TIGR00565', NULL, NULL, 4411, 22),
(289780, NULL, 'TIGR02709', NULL, NULL, 'branched_ptb: branched-chain phosphotransacylase', NULL, 'TIGR02709', NULL, NULL, 14004, 22),
(289781, NULL, 'TIGR01188', NULL, NULL, 'drrA: daunorubicin resistance ABC transporter, ATP-binding protein', NULL, 'TIGR01188', NULL, NULL, 6761, 22),
(289782, NULL, 'TIGR03394', NULL, NULL, 'indol_phenyl_DC: indolepyruvate/phenylpyruvate decarboxylase', NULL, 'TIGR03394', NULL, NULL, 18720, 22),
(289783, NULL, 'TIGR03186', NULL, NULL, 'AKGDH_not_PDH: alpha-ketoglutarate dehydrogenase', NULL, 'TIGR03186', NULL, NULL, 15622, 22),
(289784, NULL, 'TIGR03690', NULL, NULL, '20S_bact_beta: proteasome, beta subunit', NULL, 'TIGR03690', NULL, NULL, 16444, 22),
(289785, NULL, 'TIGR04041', NULL, NULL, 'activase_YjjW: glycine radical enzyme activase, YjjW family', NULL, 'TIGR04041', NULL, NULL, 18066, 22),
(289786, NULL, 'TIGR04533', NULL, NULL, 'cyanosortB_assc: cyanoexosortase B-associated protein', NULL, 'TIGR04533', NULL, NULL, 23677, 22),
(289787, NULL, 'TIGR01648', NULL, NULL, 'hnRNP-R-Q: hnRNP-R, Q splicing factor family', NULL, 'TIGR01648', NULL, NULL, 196, 22),
(289788, NULL, 'TIGR01511', NULL, NULL, 'ATPase-IB1_Cu: copper-translocating P-type ATPase', NULL, 'TIGR01511', NULL, NULL, NULL, 22),
(289789, NULL, 'TIGR03618', NULL, NULL, 'Rv1155_F420: PPOX class probable F420-dependent enzyme', NULL, 'TIGR03618', NULL, NULL, 14629, 22),
(289790, NULL, 'TIGR01433', NULL, NULL, 'CyoA: ubiquinol oxidase, subunit II', NULL, 'TIGR01433', NULL, NULL, 4823, 22),
(289791, NULL, 'TIGR03126', NULL, NULL, 'one_C_fae: formaldehyde-activating enzyme', NULL, 'TIGR03126', NULL, NULL, 11825, 22),
(289792, NULL, 'TIGR00893', NULL, NULL, '2A0114: D-galactonate transporter', NULL, 'TIGR00893', NULL, NULL, NULL, 22),
(289793, NULL, 'TIGR04288', NULL, NULL, 'CGP_CTERM: CGP-CTERM domain', NULL, 'TIGR04288', NULL, NULL, 26616, 22),
(289794, NULL, 'TIGR03454', NULL, NULL, 'partition_RepB: plasmid partitioning protein RepB', NULL, 'TIGR03454', NULL, NULL, 19449, 22),
(289795, NULL, 'TIGR03702', NULL, NULL, 'lip_kinase_YegS: lipid kinase YegS', NULL, 'TIGR03702', NULL, NULL, 15717, 22),
(289796, NULL, 'TIGR01976', NULL, NULL, 'am_tr_V_VC1184: cysteine desulfurase family protein', NULL, 'TIGR01976', NULL, NULL, 8775, 22),
(289797, NULL, 'TIGR00602', NULL, NULL, 'rad24: checkpoint protein rad24', NULL, 'TIGR00602', NULL, NULL, 17724, 22),
(289798, NULL, 'TIGR00029', NULL, NULL, 'S20: ribosomal protein bS20', NULL, 'TIGR00029', NULL, NULL, 1788, 22),
(289799, NULL, 'TIGR00160', NULL, NULL, 'MGSA: methylglyoxal synthase', NULL, 'TIGR00160', NULL, NULL, 5073, 22),
(289800, NULL, 'TIGR02623', NULL, NULL, 'G1P_cyt_trans: glucose-1-phosphate cytidylyltransferase', NULL, 'TIGR02623', NULL, NULL, 9248, 22),
(289801, NULL, 'TIGR01272', NULL, NULL, 'gluP: glucose/galactose transporter WARNING', NULL, 'TIGR01272', NULL, NULL, 98, 22),
(289802, NULL, 'TIGR01704', NULL, NULL, 'MTA/SAH-Nsdase: MTA/SAH nucleosidase', NULL, 'TIGR01704', NULL, NULL, 5440, 22),
(289803, NULL, 'TIGR00353', NULL, NULL, 'nrfE: cytochrome c-type biogenesis protein CcmF', NULL, 'TIGR00353', NULL, NULL, 249, 22),
(289804, NULL, 'TIGR02024', NULL, NULL, 'FtcD: glutamate formiminotransferase', NULL, 'TIGR02024', NULL, NULL, 3827, 22),
(289805, NULL, 'TIGR04045', NULL, NULL, 'MSMEG_0567_GNAT: putative N-acetyltransferase, MSMEG_0567 N-terminal domain family', NULL, 'TIGR04045', NULL, NULL, 18879, 22),
(289806, NULL, 'TIGR04209', NULL, NULL, 'sarcinarray: sarcinarray family protein', NULL, 'TIGR04209', NULL, NULL, 25425, 22);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289807, NULL, 'TIGR02181', NULL, NULL, 'GRX_bact: glutaredoxin 3', NULL, 'TIGR02181', NULL, NULL, 12228, 22),
(289808, NULL, 'TIGR01692', NULL, NULL, 'HIBADH: 3-hydroxyisobutyrate dehydrogenase', NULL, 'TIGR01692', NULL, NULL, 8237, 22),
(289809, NULL, 'TIGR01262', NULL, NULL, 'maiA: maleylacetoacetate isomerase', NULL, 'TIGR01262', NULL, NULL, 485, 22),
(289810, NULL, 'TIGR02489', NULL, NULL, 'flgE_epsilon: flagellar hook protein FlgE', NULL, 'TIGR02489', NULL, NULL, 12552, 22),
(289811, NULL, 'TIGR01399', NULL, NULL, 'hrcV: type III secretion protein, HrcV family', NULL, 'TIGR01399', NULL, NULL, 4636, 22),
(289812, NULL, 'TIGR01436', NULL, NULL, 'glu_cys_lig_pln: glutamate--cysteine ligase', NULL, 'TIGR01436', NULL, NULL, 8702, 22),
(289813, NULL, 'TIGR03472', NULL, NULL, 'HpnI: hopanoid biosynthesis associated glycosyl transferase protein HpnI', NULL, 'TIGR03472', NULL, NULL, 19748, 22),
(289814, NULL, 'TIGR02009', NULL, NULL, 'PGMB-YQAB-SF: beta-phosphoglucomutase family hydrolase', NULL, 'TIGR02009', NULL, NULL, 2170, 22),
(289815, NULL, 'TIGR03734', NULL, NULL, 'PRTRC_parB: PRTRC system ParB family protein', NULL, 'TIGR03734', NULL, NULL, 15773, 22),
(289816, NULL, 'TIGR03839', NULL, NULL, 'termin_org_P1: adhesin P1', NULL, 'TIGR03839', NULL, NULL, 15740, 22),
(289817, NULL, 'TIGR02283', NULL, NULL, 'MltB_2: lytic murein transglycosylase', NULL, 'TIGR02283', NULL, NULL, 11065, 22),
(289818, NULL, 'TIGR02866', NULL, NULL, 'CoxB: cytochrome c oxidase, subunit II', NULL, 'TIGR02866', NULL, NULL, 10551, 22),
(289819, NULL, 'TIGR01484', NULL, NULL, 'HAD-SF-IIB: HAD hydrolase, family IIB', NULL, 'TIGR01484', NULL, NULL, 5557, 22),
(289820, NULL, 'TIGR00297', NULL, NULL, 'TIGR00297: TIGR00297 family protein', NULL, 'TIGR00297', NULL, NULL, 4852, 22),
(289821, NULL, 'TIGR00845', NULL, NULL, 'caca: sodium/calcium exchanger 1', NULL, 'TIGR00845', NULL, NULL, 4171, 22),
(289822, NULL, 'TIGR02115', NULL, NULL, 'potass_kdpF: K+-transporting ATPase, F subunit', NULL, 'TIGR02115', NULL, NULL, 11804, 22),
(289823, NULL, 'TIGR02881', NULL, NULL, 'spore_V_K: stage V sporulation protein K', NULL, 'TIGR02881', NULL, NULL, 10731, 22),
(289824, NULL, 'TIGR03628', NULL, NULL, 'arch_S11P: ribosomal protein uS11', NULL, 'TIGR03628', NULL, NULL, 12706, 22),
(289825, NULL, 'TIGR00814', NULL, NULL, 'stp: serine transporter', NULL, 'TIGR00814', NULL, NULL, 3285, 22),
(289826, NULL, 'TIGR02560', NULL, NULL, 'HrpB4: type III secretion protein HrpB4', NULL, 'TIGR02560', NULL, NULL, 11458, 22),
(289827, NULL, 'TIGR00930', NULL, NULL, '2a30: K-Cl cotransporter', NULL, 'TIGR00930', NULL, NULL, 4266, 22),
(289828, NULL, 'TIGR01764', NULL, NULL, 'excise: DNA binding domain, excisionase family', NULL, 'TIGR01764', NULL, NULL, 2284, 22),
(289829, NULL, 'TIGR03288', NULL, NULL, 'CoB_CoM_SS_B: CoB--CoM heterodisulfide reductase, subunit B', NULL, 'TIGR03288', NULL, NULL, 17862, 22),
(289830, NULL, 'TIGR00637', NULL, NULL, 'ModE_repress: ModE molybdate transport repressor domain', NULL, 'TIGR00637', NULL, NULL, 2235, 22),
(289831, NULL, 'TIGR01156', NULL, NULL, 'cytb6/f_IV: cytb6/f complex subunit IV', NULL, 'TIGR01156', NULL, NULL, 6964, 22),
(289832, NULL, 'TIGR00145', NULL, NULL, 'TIGR00145: FTR1 family protein', NULL, 'TIGR00145', NULL, NULL, 11062, 22),
(289833, NULL, 'TIGR00905', NULL, NULL, '2A0302: transporter, basic amino acid/polyamine antiporter (APA) family', NULL, 'TIGR00905', NULL, NULL, 5210, 22),
(289834, NULL, 'TIGR01078', NULL, NULL, 'arcA: arginine deiminase', NULL, 'TIGR01078', NULL, NULL, 4408, 22),
(289835, NULL, 'TIGR01941', NULL, NULL, 'nqrF: NADH:ubiquinone oxidoreductase, Na(+)-translocating, F subunit', NULL, 'TIGR01941', NULL, NULL, 4134, 22),
(289836, NULL, 'TIGR04076', NULL, NULL, 'TIGR04076: TIGR04076 family protein', NULL, 'TIGR04076', NULL, NULL, 14814, 22),
(289837, NULL, 'TIGR02900', NULL, NULL, 'spore_V_B: stage V sporulation protein B', NULL, 'TIGR02900', NULL, NULL, 11176, 22),
(289838, NULL, 'TIGR00590', NULL, NULL, 'pcna: proliferating cell nuclear antigen (pcna)', NULL, 'TIGR00590', NULL, NULL, 6819, 22); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289839, NULL, 'TIGR03151', NULL, NULL, 'enACPred_II: putative enoyl-[acyl-carrier-protein] reductase II', NULL, 'TIGR03151', NULL, NULL, 15335, 22),
(289840, NULL, 'TIGR00309', NULL, NULL, 'V_ATPase_subD: V-type ATPase, D subunit', NULL, 'TIGR00309', NULL, NULL, 3948, 22),
(289841, NULL, 'TIGR04502', NULL, NULL, 'microcomp_EutL: microcompartment protein EutL', NULL, 'TIGR04502', NULL, NULL, 24055, 22),
(289842, NULL, 'TIGR03406', NULL, NULL, 'FeS_long_SufT: probable FeS assembly SUF system protein SufT', NULL, 'TIGR03406', NULL, NULL, 19225, 22),
(289843, NULL, 'TIGR01418', NULL, NULL, 'PEP_synth: phosphoenolpyruvate synthase', NULL, 'TIGR01418', NULL, NULL, 4979, 22),
(289844, NULL, 'TIGR04253', NULL, NULL, 'mesacon_CoA_iso: mesaconyl-CoA isomerase', NULL, 'TIGR04253', NULL, NULL, 24997, 22),
(289845, NULL, 'TIGR01051', NULL, NULL, 'topA_bact: DNA topoisomerase I', NULL, 'TIGR01051', NULL, NULL, 4673, 22),
(289846, NULL, 'TIGR00322', NULL, NULL, 'diphth2_R: diphthamide biosynthesis enzyme Dph1/Dph2 domain', NULL, 'TIGR00322', NULL, NULL, 15307, 22),
(289847, NULL, 'TIGR02697', NULL, NULL, 'WPE_wolbac: Wolbachia palindromic element domain', NULL, 'TIGR02697', NULL, NULL, 13165, 22),
(289848, NULL, 'TIGR03812', NULL, NULL, 'tyr_de_CO2_Arch: tyrosine decarboxylase MnfA', NULL, 'TIGR03812', NULL, NULL, 14811, 22),
(289849, NULL, 'TIGR04325', NULL, NULL, 'MTase_LIC12133: putative methyltransferase, LIC12133 family', NULL, 'TIGR04325', NULL, NULL, 23093, 22),
(289850, NULL, 'TIGR03949', NULL, NULL, 'bact_IIb_cerein: class IIb bacteriocin, lactobin A/cerein 7B family', NULL, 'TIGR03949', NULL, NULL, 12568, 22),
(289851, NULL, 'TIGR02757', NULL, NULL, 'TIGR02757: TIGR02757 family protein', NULL, 'TIGR02757', NULL, NULL, 13524, 22),
(289852, NULL, 'TIGR01602', NULL, NULL, 'PY-rept-46: Plasmodium yoelii repeat of length 46', NULL, 'TIGR01602', NULL, NULL, 6018, 22),
(289853, NULL, 'TIGR01739', NULL, NULL, 'tegu_FGAM_synt: herpesvirus tegument protein/v-FGAM-synthase', NULL, 'TIGR01739', NULL, NULL, 2408, 22),
(289854, NULL, 'TIGR00251', NULL, NULL, 'TIGR00251: TIGR00251 family protein', NULL, 'TIGR00251', NULL, NULL, 11287, 22),
(289855, NULL, 'TIGR02620', NULL, NULL, 'cas_VVA1548: putative CRISPR-associated protein, VVA1548 family', NULL, 'TIGR02620', NULL, NULL, 9397, 22),
(289856, NULL, 'TIGR00135', NULL, NULL, 'gatC: aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase, C subunit', NULL, 'TIGR00135', NULL, NULL, 3098, 22),
(289857, NULL, 'TIGR00354', NULL, NULL, 'polC: DNA polymerase II, large subunit DP2', NULL, 'TIGR00354', NULL, NULL, 7416, 22),
(289858, NULL, 'TIGR03348', NULL, NULL, 'VI_IcmF: type VI secretion protein IcmF', NULL, 'TIGR03348', NULL, NULL, 18195, 22),
(289859, NULL, 'TIGR01153', NULL, NULL, 'psbC: photosystem II 44 kDa subunit reaction center protein', NULL, 'TIGR01153', NULL, NULL, 6871, 22),
(289860, NULL, 'TIGR02429', NULL, NULL, 'pcaI_scoA_fam: 3-oxoacid CoA-transferase, A subunit', NULL, 'TIGR02429', NULL, NULL, 9856, 22),
(289861, NULL, 'TIGR03397', NULL, NULL, 'acid_phos_Burk: acid phosphatase, Burkholderia-type', NULL, 'TIGR03397', NULL, NULL, 18606, 22),
(289862, NULL, 'TIGR01975', NULL, NULL, 'isoAsp_dipep: beta-aspartyl peptidase', NULL, 'TIGR01975', NULL, NULL, 4493, 22),
(289863, NULL, 'TIGR02598', NULL, NULL, 'TIGR02598: Verru_Chthon cassette protein B', NULL, 'TIGR02598', NULL, NULL, 15820, 22),
(289864, NULL, 'TIGR00026', NULL, NULL, 'hi_GC_TIGR00026: deazaflavin-dependent oxidoreductase, nitroreductase family', NULL, 'TIGR00026', NULL, NULL, 5683, 22),
(289865, NULL, 'TIGR01481', NULL, NULL, 'ccpA: catabolite control protein A', NULL, 'TIGR01481', NULL, NULL, 5725, 22),
(289866, NULL, 'TIGR02096', NULL, NULL, 'TIGR02096: conserved hypothetical protein', NULL, 'TIGR02096', NULL, NULL, 10610, 22),
(289867, NULL, 'TIGR04179', NULL, NULL, 'rhombo_lipo: rhombotail lipoprotein', NULL, 'TIGR04179', NULL, NULL, 23095, 22),
(289868, NULL, 'TIGR03945', NULL, NULL, 'PLP_SbnA_fam: 2,3-diaminopropionate biosynthesis protein SbnA', NULL, 'TIGR03945', NULL, NULL, 6457, 22);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289869, NULL, 'TIGR03024', NULL, NULL, 'arch_PEF_CTERM: PEF-CTERM protein sorting domain', NULL, 'TIGR03024', NULL, NULL, 20949, 22),
(289870, NULL, 'TIGR04042', NULL, NULL, 'MSMEG_0570_fam: MSMEG_0570 family protein', NULL, 'TIGR04042', NULL, NULL, 16859, 22),
(289871, NULL, 'TIGR00036', NULL, NULL, 'dapB: 4-hydroxy-tetrahydrodipicolinate reductase', NULL, 'TIGR00036', NULL, NULL, 8465, 22),
(289872, NULL, 'TIGR03260', NULL, NULL, 'met_CoM_red_D: methyl-coenzyme M reductase operon protein D', NULL, 'TIGR03260', NULL, NULL, 4089, 22),
(289873, NULL, 'TIGR03211', NULL, NULL, 'catechol_2_3: catechol 2,3 dioxygenase', NULL, 'TIGR03211', NULL, NULL, 16923, 22),
(289874, NULL, 'TIGR02993', NULL, NULL, 'ectoine_eutD: ectoine utilization protein EutD', NULL, 'TIGR02993', NULL, NULL, 10052, 22),
(289875, NULL, 'TIGR04536', NULL, NULL, 'geobac_encap: encapsulated protein', NULL, 'TIGR04536', NULL, NULL, 25237, 22),
(289876, NULL, 'TIGR00711', NULL, NULL, 'efflux_EmrB: drug resistance MFS transporter, drug:H+ antiporter-2 (14 Spanner) (DHA2) family', NULL, 'TIGR00711', NULL, NULL, 2069, 22),
(289877, NULL, 'TIGR02884', NULL, NULL, 'spore_pdaA: delta-lactam-biosynthetic de-N-acetylase', NULL, 'TIGR02884', NULL, NULL, 10830, 22),
(289878, NULL, 'TIGR00848', NULL, NULL, 'fruA: PTS system, fructose subfamily, IIA component', NULL, 'TIGR00848', NULL, NULL, 3209, 22),
(289879, NULL, 'TIGR01297', NULL, NULL, 'CDF: cation diffusion facilitator family transporter', NULL, 'TIGR01297', NULL, NULL, 691, 22),
(289880, NULL, 'TIGR01160', NULL, NULL, 'SUI1_MOF2: translation initiation factor SUI1', NULL, 'TIGR01160', NULL, NULL, 6610, 22),
(289881, NULL, 'TIGR03409', NULL, NULL, 'urea_trans_UrtB: urea ABC transporter, permease protein UrtB', NULL, 'TIGR03409', NULL, NULL, 19065, 22),
(289882, NULL, 'TIGR04094', NULL, NULL, 'adjacent_YSIRK: YSIRK-targeted surface antigen transcriptional regulator', NULL, 'TIGR04094', NULL, NULL, 15710, 22),
(289883, NULL, 'TIGR01590', NULL, NULL, 'yir-bir-cir_Pla: yir/bir/cir-family of variant antigens', NULL, 'TIGR01590', NULL, NULL, 6130, 22),
(289884, NULL, 'TIGR01866', NULL, NULL, 'cas_Csn2: CRISPR type II-A/NMEMI-associated protein Csn2', NULL, 'TIGR01866', NULL, NULL, 10713, 22),
(289885, NULL, 'TIGR04427', NULL, NULL, 'PLP_DesI: dTDP-4-dehydro-6-deoxyglucose aminotransferase', NULL, 'TIGR04427', NULL, NULL, 25882, 22),
(289886, NULL, 'TIGR03921', NULL, NULL, 'T7SS_mycosin: type VII secretion-associated serine protease mycosin', NULL, 'TIGR03921', NULL, NULL, 16658, 22),
(289887, NULL, 'TIGR02072', NULL, NULL, 'BioC: malonyl-acyl carrier protein O-methyltransferase BioC', NULL, 'TIGR02072', NULL, NULL, 13278, 22),
(289888, NULL, 'TIGR01972', NULL, NULL, 'NDH_I_M: proton-translocating NADH-quinone oxidoreductase, chain M', NULL, 'TIGR01972', NULL, NULL, 4461, 22),
(289889, NULL, 'TIGR03836', NULL, NULL, 'termin_org_HMW1: cytadherence high molecular weight protein 1 N-terminal region', NULL, 'TIGR03836', NULL, NULL, 16026, 22),
(289890, NULL, 'TIGR00279', NULL, NULL, 'uL16_euk_arch: ribosomal protein uL16', NULL, 'TIGR00279', NULL, NULL, 1491, 22),
(289891, NULL, 'TIGR03600', NULL, NULL, 'phage_DnaB: phage replicative helicase, DnaB family', NULL, 'TIGR03600', NULL, NULL, 14900, 22),
(289892, NULL, 'TIGR02280', NULL, NULL, 'PaaB1: phenylacetate degradation probable enoyl-CoA hydratase PaaB', NULL, 'TIGR02280', NULL, NULL, 11206, 22),
(289893, NULL, 'TIGR00463', NULL, NULL, 'gltX_arch: glutamate--tRNA ligase', NULL, 'TIGR00463', NULL, NULL, 1513, 22),
(289894, NULL, 'TIGR02563', NULL, NULL, 'cas_Csy4: CRISPR-associated endoribonuclease Cas6/Csy4, subtype I-F/YPEST', NULL, 'TIGR02563', NULL, NULL, 11056, 22),
(289895, NULL, 'TIGR04151', NULL, NULL, 'exosort_VPDSG: exosortase C, VPDSG-CTERM-specific', NULL, 'TIGR04151', NULL, NULL, 23234, 22),
(289896, NULL, 'TIGR00456', NULL, NULL, 'argS: arginine--tRNA ligase', NULL, 'TIGR00456', NULL, NULL, 34, 22),
(289897, NULL, 'TIGR03017', NULL, NULL, 'EpsF: chain length determinant protein EpsF', NULL, 'TIGR03017', NULL, NULL, 20742, 22);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289898, NULL, 'TIGR02903', NULL, NULL, 'spore_lon_C: ATP-dependent protease, Lon family', NULL, 'TIGR02903', NULL, NULL, 11066, 22),
(289899, NULL, 'TIGR01054', NULL, NULL, 'rgy: reverse gyrase', NULL, 'TIGR01054', NULL, NULL, 4786, 22),
(289900, NULL, 'TIGR00784', NULL, NULL, 'citMHS: citrate transporter', NULL, 'TIGR00784', NULL, NULL, 14123, 22),
(289901, NULL, 'TIGR00142', NULL, NULL, 'hycI: hydrogenase maturation peptidase HycI', NULL, 'TIGR00142', NULL, NULL, 7306, 22),
(289902, NULL, 'TIGR02006', NULL, NULL, 'IscS: cysteine desulfurase IscS', NULL, 'TIGR02006', NULL, NULL, 5424, 22),
(289903, NULL, 'TIGR03737', NULL, NULL, 'PRTRC_B: PRTRC system protein B', NULL, 'TIGR03737', NULL, NULL, 15384, 22),
(289904, NULL, 'TIGR02818', NULL, NULL, 'adh_III_F_hyde: S-(hydroxymethyl)glutathione dehydrogenase/class III alcohol dehydrogenase', NULL, 'TIGR02818', NULL, NULL, 8972, 22),
(289905, NULL, 'TIGR00752', NULL, NULL, 'slp: outer membrane lipoprotein, Slp family', NULL, 'TIGR00752', NULL, NULL, 2884, 22),
(289906, NULL, 'TIGR00737', NULL, NULL, 'nifR3_yhdG: putative TIM-barrel protein, nifR3 family', NULL, 'TIGR00737', NULL, NULL, 2927, 22),
(289907, NULL, 'TIGR01375', NULL, NULL, 'soxG: sarcosine oxidase, gamma subunit family', NULL, 'TIGR01375', NULL, NULL, 3589, 22),
(289908, NULL, 'TIGR03811', NULL, NULL, 'tyr_de_CO2_Ent: tyrosine decarboxylase', NULL, 'TIGR03811', NULL, NULL, 15636, 22),
(289909, NULL, 'TIGR00889', NULL, NULL, '2A0110: nucleoside transporter', NULL, 'TIGR00889', NULL, NULL, 5496, 22),
(289910, NULL, 'TIGR03345', NULL, NULL, 'VI_ClpV1: type VI secretion ATPase, ClpV1 family', NULL, 'TIGR03345', NULL, NULL, 18075, 22),
(289911, NULL, 'TIGR03948', NULL, NULL, 'butyr_acet_CoA: butyryl-CoA:acetate CoA-transferase', NULL, 'TIGR03948', NULL, NULL, 12577, 22),
(289912, NULL, 'TIGR03313', NULL, NULL, 'Se_sel_red_Mo: probable selenate reductase, molybdenum-binding subunit', NULL, 'TIGR03313', NULL, NULL, 17829, 22),
(289913, NULL, 'TIGR02329', NULL, NULL, 'propionate_PrpR: propionate catabolism operon regulatory protein PrpR', NULL, 'TIGR02329', NULL, NULL, 11709, 22),
(289914, NULL, 'TIGR04481', NULL, NULL, 'PR_assoc_PrdC: proline reductase-associated electron transfer protein PrdC', NULL, 'TIGR04481', NULL, NULL, 25013, 22),
(289915, NULL, 'TIGR02514', NULL, NULL, 'type_III_yscP: type III secretion system needle length determinant', NULL, 'TIGR02514', NULL, NULL, 18786, 22),
(289916, NULL, 'TIGR03497', NULL, NULL, 'FliI_clade2: flagellar protein export ATPase FliI', NULL, 'TIGR03497', NULL, NULL, 15580, 22),
(289917, NULL, 'TIGR03995', NULL, NULL, 'target_X_rSAM: putative rSAM target protein, CGCGG family', NULL, 'TIGR03995', NULL, NULL, 18015, 22),
(289918, NULL, 'TIGR00254', NULL, NULL, 'GGDEF: diguanylate cyclase (GGDEF) domain', NULL, 'TIGR00254', NULL, NULL, 1794, 22),
(289919, NULL, 'TIGR03641', NULL, NULL, 'cas1_HMARI: CRISPR-associated endonuclease Cas1, subtype I-B/HMARI/TNEAP', NULL, 'TIGR03641', NULL, NULL, 14711, 22),
(289920, NULL, 'TIGR01047', NULL, NULL, 'nspC: carboxynorspermidine decarboxylase', NULL, 'TIGR01047', NULL, NULL, 4650, 22),
(289921, NULL, 'TIGR03515', NULL, NULL, 'GldC: gliding motility-associated protein GldC', NULL, 'TIGR03515', NULL, NULL, 18200, 22),
(289922, NULL, 'TIGR02174', NULL, NULL, 'CXXU_selWTH: selT/selW/selH selenoprotein domain', NULL, 'TIGR02174', NULL, NULL, 8837, 22),
(289923, NULL, 'TIGR04153', NULL, NULL, 'cyanosortA_assc: cyanosortase A-associated protein', NULL, 'TIGR04153', NULL, NULL, 21336, 22),
(289924, NULL, 'TIGR01577', NULL, NULL, 'oligosac_amyl: oligosaccharide amylase', NULL, 'TIGR01577', NULL, NULL, 6427, 22),
(289925, NULL, 'TIGR02561', NULL, NULL, 'HrpB1_HrpK: type III secretion protein HrpB1/HrpK', NULL, 'TIGR02561', NULL, NULL, 11449, 22),
(289926, NULL, 'TIGR02159', NULL, NULL, 'PA_CoA_Oxy4: phenylacetate-CoA oxygenase, PaaJ subunit', NULL, 'TIGR02159', NULL, NULL, 8979, 22),
(289927, NULL, 'TIGR00415', NULL, NULL, 'serS_MJ: serine--tRNA ligase', NULL, 'TIGR00415', NULL, NULL, 1634, 22),
(289928, NULL, 'TIGR00907', NULL, NULL, '2A0304: amino acid permease', NULL, 'TIGR00907', NULL, NULL, 5061, 22);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289929, NULL, 'TIGR01053', NULL, NULL, 'LSD1: zinc finger domain, LSD1 subclass', NULL, 'TIGR01053', NULL, NULL, 4923, 22),
(289930, NULL, 'TIGR01249', NULL, NULL, 'pro_imino_pep_1: prolyl aminopeptidase', NULL, 'TIGR01249', NULL, NULL, 138, 22),
(289931, NULL, 'TIGR02672', NULL, NULL, 'cas_csm6: CRISPR type III-A/MTUBE-associated protein Csm6', NULL, 'TIGR02672', NULL, NULL, 10146, 22),
(289932, NULL, 'TIGR03843', NULL, NULL, 'TIGR03843: conserved hypothetical protein', NULL, 'TIGR03843', NULL, NULL, 15494, 22),
(289933, NULL, 'TIGR01079', NULL, NULL, 'rplX_bact: ribosomal protein uL24', NULL, 'TIGR01079', NULL, NULL, 2995, 22),
(289934, NULL, 'TIGR04425', NULL, NULL, 'P_lya_rel_AroB: putative sugar phosphate phospholyase (cyclizing)', NULL, 'TIGR04425', NULL, NULL, 24708, 22),
(289935, NULL, 'TIGR00409', NULL, NULL, 'proS_fam_II: proline--tRNA ligase', NULL, 'TIGR00409', NULL, NULL, 1684, 22),
(289936, NULL, 'TIGR03778', NULL, NULL, 'VPDSG_CTERM: VPDSG-CTERM protein sorting domain', NULL, 'TIGR03778', NULL, NULL, 15332, 22),
(289937, NULL, 'TIGR01817', NULL, NULL, 'nifA: Nif-specific regulatory protein', NULL, 'TIGR01817', NULL, NULL, 2155, 22),
(289938, NULL, 'TIGR03700', NULL, NULL, 'mena_SCO4494: putative menaquinone biosynthesis radical SAM enzyme, SCO4494 family', NULL, 'TIGR03700', NULL, NULL, 15790, 22),
(289939, NULL, 'TIGR04475', NULL, NULL, 'Phe_D_beta_mut: phenylalanine aminomutase (D-beta-phenylalanine forming)', NULL, 'TIGR04475', NULL, NULL, 25214, 22),
(289940, NULL, 'TIGR00245', NULL, NULL, 'TIGR00245: TIGR00245 family protein', NULL, 'TIGR00245', NULL, NULL, 11253, 22),
(289941, NULL, 'TIGR00793', NULL, NULL, 'kdgT: 2-keto-3-deoxygluconate transporter', NULL, 'TIGR00793', NULL, NULL, 19951, 22),
(289942, NULL, 'TIGR03354', NULL, NULL, 'VI_FHA: type VI secretion system FHA domain protein', NULL, 'TIGR03354', NULL, NULL, 18480, 22),
(289943, NULL, 'TIGR03837', NULL, NULL, 'efp_adjacent_2: conserved hypothetical protein, PP_1857 family', NULL, 'TIGR03837', NULL, NULL, 19273, 22),
(289944, NULL, 'TIGR02716', NULL, NULL, 'C20_methyl_CrtF: C-20 methyltransferase BchU', NULL, 'TIGR02716', NULL, NULL, 14058, 22),
(289945, NULL, 'TIGR03026', NULL, NULL, 'NDP-sugDHase: nucleotide sugar dehydrogenase', NULL, 'TIGR03026', NULL, NULL, 20538, 22),
(289946, NULL, 'TIGR02218', NULL, NULL, 'phg_TIGR02218: phage conserved hypothetical protein BR0599', NULL, 'TIGR02218', NULL, NULL, 11112, 22),
(289947, NULL, 'TIGR04010', NULL, NULL, 'WcaD: putative colanic acid polymerase WcaD', NULL, 'TIGR04010', NULL, NULL, 11673, 22),
(289948, NULL, 'TIGR01679', NULL, NULL, 'bact_FAD_ox: FAD-linked oxidoreductase', NULL, 'TIGR01679', NULL, NULL, NULL, 22),
(289949, NULL, 'TIGR02180', NULL, NULL, 'GRX_euk: glutaredoxin', NULL, 'TIGR02180', NULL, NULL, 12149, 22),
(289950, NULL, 'TIGR02663', NULL, NULL, 'nifX: nitrogen fixation protein NifX', NULL, 'TIGR02663', NULL, NULL, 10225, 22),
(289951, NULL, 'TIGR02698', NULL, NULL, 'CopY_TcrY: copper transport repressor, CopY/TcrY family', NULL, 'TIGR02698', NULL, NULL, 13266, 22),
(289952, NULL, 'TIGR03852', NULL, NULL, 'sucrose_gtfA: sucrose phosphorylase', NULL, 'TIGR03852', NULL, NULL, 16272, 22),
(289953, NULL, 'TIGR00295', NULL, NULL, 'TIGR00295: TIGR00295 family protein', NULL, 'TIGR00295', NULL, NULL, 7302, 22),
(289954, NULL, 'TIGR02868', NULL, NULL, 'CydC: thiol reductant ABC exporter, CydC subunit', NULL, 'TIGR02868', NULL, NULL, 10629, 22),
(289955, NULL, 'TIGR03073', NULL, NULL, 'release_rtcB: release factor H-coupled RctB family protein', NULL, 'TIGR03073', NULL, NULL, 21005, 22),
(289956, NULL, 'TIGR04103', NULL, NULL, 'rSAM_nif11_3: nif11-class peptide radical SAM maturase 3', NULL, 'TIGR04103', NULL, NULL, 23165, 22),
(289957, NULL, 'TIGR01044', NULL, NULL, 'rplV_bact: ribosomal protein uL22', NULL, 'TIGR01044', NULL, NULL, 4926, 22),
(289958, NULL, 'TIGR01536', NULL, NULL, 'asn_synth_AEB: asparagine synthase (glutamine-hydrolyzing)', NULL, 'TIGR01536', NULL, NULL, 6518, 22),
(289959, NULL, 'TIGR04194', NULL, NULL, 'grasp_w_spasm_A: grasp-with-spasm leader A domain', NULL, 'TIGR04194', NULL, NULL, 23426, 22);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289960, NULL, 'TIGR01870', NULL, NULL, 'cas_TM1810_Csm2: CRISPR type III-A/MTUBE-associated protein Csm2', NULL, 'TIGR01870', NULL, NULL, 10957, 22),
(289961, NULL, 'TIGR02520', NULL, NULL, 'pilus_B_mal_scr: type IVB pilus formation outer membrane protein, R64 PilN family', NULL, 'TIGR02520', NULL, NULL, 18554, 22),
(289962, NULL, 'TIGR02657', NULL, NULL, 'amicyanin: amicyanin', NULL, 'TIGR02657', NULL, NULL, 10104, 22),
(289963, NULL, 'TIGR04568', NULL, NULL, 'arch_SelU_Nterm: selenouridine synthase, SelU N-terminal-like subunit', NULL, 'TIGR04568', NULL, NULL, 23822, 22),
(289964, NULL, 'TIGR02991', NULL, NULL, 'ectoine_eutB: ectoine utilization protein EutB', NULL, 'TIGR02991', NULL, NULL, 10265, 22),
(289965, NULL, 'TIGR01372', NULL, NULL, 'soxA: sarcosine oxidase, alpha subunit family', NULL, 'TIGR01372', NULL, NULL, 3906, 22),
(289966, NULL, 'TIGR03989', NULL, NULL, 'Rxyl_3153: NDMA-dependent alcohol dehydrogenase, Rxyl_3153 family', NULL, 'TIGR03989', NULL, NULL, 18008, 22),
(289967, NULL, 'TIGR01477', NULL, NULL, 'RIFIN: variant surface antigen, rifin family', NULL, 'TIGR01477', NULL, NULL, 5515, 22),
(289968, NULL, 'TIGR03360', NULL, NULL, 'VI_minor_1: type VI secretion-associated protein, VC_A0118 family', NULL, 'TIGR03360', NULL, NULL, 18406, 22),
(289969, NULL, 'TIGR00787', NULL, NULL, 'dctP: TRAP transporter solute receptor, DctP family', NULL, 'TIGR00787', NULL, NULL, 3489, 22),
(289970, NULL, 'TIGR02022', NULL, NULL, 'hutF: formiminoglutamate deiminase', NULL, 'TIGR02022', NULL, NULL, 5426, 22),
(289971, NULL, 'TIGR02376', NULL, NULL, 'Cu_nitrite_red: nitrite reductase, copper-containing', NULL, 'TIGR02376', NULL, NULL, 244, 22),
(289972, NULL, 'TIGR01038', NULL, NULL, 'uL22_arch_euk: ribosomal protein uL22', NULL, 'TIGR01038', NULL, NULL, 4780, 22),
(289973, NULL, 'TIGR01542', NULL, NULL, 'A118_put_portal: phage portal protein, putative, A118 family', NULL, 'TIGR01542', NULL, NULL, 6512, 22),
(289974, NULL, 'TIGR00839', NULL, NULL, 'aspA: aspartate ammonia-lyase', NULL, 'TIGR00839', NULL, NULL, 3132, 22),
(289975, NULL, 'TIGR02274', NULL, NULL, 'dCTP_deam: deoxycytidine triphosphate deaminase', NULL, 'TIGR02274', NULL, NULL, 11416, 22),
(289976, NULL, 'TIGR03292', NULL, NULL, 'PhnH_redo: phosphonate C-P lyase system protein PhnH', NULL, 'TIGR03292', NULL, NULL, 12173, 22),
(289977, NULL, 'TIGR03743', NULL, NULL, 'SXT_TraD: conjugative coupling factor TraD, SXT/TOL subfamily', NULL, 'TIGR03743', NULL, NULL, 15752, 22),
(289978, NULL, 'TIGR02725', NULL, NULL, 'phenyl_P_gamma: phenylphosphate carboxylase, gamma subunit', NULL, 'TIGR02725', NULL, NULL, 14140, 22),
(289979, NULL, 'TIGR01926', NULL, NULL, 'peroxid_rel: uncharacterized peroxidase-related enzyme', NULL, 'TIGR01926', NULL, NULL, 4331, 22),
(289980, NULL, 'TIGR02118', NULL, NULL, 'TIGR02118: conserved hypothetical protein', NULL, 'TIGR02118', NULL, NULL, 13130, 22),
(289981, NULL, 'TIGR00459', NULL, NULL, 'aspS_bact: aspartate--tRNA ligase', NULL, 'TIGR00459', NULL, NULL, 1774, 22),
(289982, NULL, 'TIGR03245', NULL, NULL, 'arg_AOST_alph: arginine/ornithine succinyltransferase, alpha subunit', NULL, 'TIGR03245', NULL, NULL, 17045, 22),
(289983, NULL, 'TIGR03790', NULL, NULL, 'TIGR03790: TIGR03790 family protein', NULL, 'TIGR03790', NULL, NULL, 15613, 22),
(289984, NULL, 'TIGR03911', NULL, NULL, 'pyrrolys_PylD: pyrrolysine biosynthesis protein PylD', NULL, 'TIGR03911', NULL, NULL, 8202, 22),
(289985, NULL, 'TIGR01973', NULL, NULL, 'NuoG: NADH dehydrogenase (quinone), G subunit', NULL, 'TIGR01973', NULL, NULL, 4101, 22),
(289986, NULL, 'TIGR04091', NULL, NULL, 'LTA_dltB: D-alanyl-lipoteichoic acid biosynthesis protein DltB', NULL, 'TIGR04091', NULL, NULL, 16057, 22),
(289987, NULL, 'TIGR01010', NULL, NULL, 'BexC_CtrB_KpsE: polysaccharide export inner-membrane protein, BexC/CtrB/KpsE family', NULL, 'TIGR01010', NULL, NULL, 3744, 22),
(289988, NULL, 'TIGR01966', NULL, NULL, 'RNasePH: ribonuclease PH', NULL, 'TIGR01966', NULL, NULL, 6590, 22),
(289989, NULL, 'TIGR02165', NULL, NULL, 'cas5_6_GSU0054: CRISPR-associated protein GSU0054/csb2, Dpsyc system', NULL, 'TIGR02165', NULL, NULL, 16599, 22);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(289990, NULL, 'TIGR02616', NULL, NULL, 'tnaC_leader: tryptophanase leader peptide', NULL, 'TIGR02616', NULL, NULL, 9526, 22),
(289991, NULL, 'TIGR02109', NULL, NULL, 'PQQ_syn_pqqE: coenzyme PQQ biosynthesis enzyme PqqE', NULL, 'TIGR02109', NULL, NULL, 13521, 22),
(289992, NULL, 'TIGR00811', NULL, NULL, 'sit: silicon transporter', NULL, 'TIGR00811', NULL, NULL, 20701, 22),
(289993, NULL, 'TIGR04206', NULL, NULL, 'near_ArtA: TIGR04206 family protein', NULL, 'TIGR04206', NULL, NULL, 24134, 22),
(289994, NULL, 'TIGR00186', NULL, NULL, 'rRNA_methyl_3: RNA methyltransferase, TrmH family, group 3', NULL, 'TIGR00186', NULL, NULL, 7179, 22),
(289995, NULL, 'TIGR01586', NULL, NULL, 'yopT_cys_prot: cysteine protease domain, YopT-type', NULL, 'TIGR01586', NULL, NULL, 6045, 22),
(289996, NULL, 'TIGR04051', NULL, NULL, 'rSAM_NirJ: heme d1 biosynthesis radical SAM protein NirJ', NULL, 'TIGR04051', NULL, NULL, 18413, 22),
(289997, NULL, 'TIGR01003', NULL, NULL, 'PTS_HPr_family: phosphocarrier, HPr family', NULL, 'TIGR01003', NULL, NULL, 3439, 22),
(289998, NULL, 'TIGR03509', NULL, NULL, 'OMP_MtrB_PioB: decaheme-associated outer membrane protein, MtrB/PioB family', NULL, 'TIGR03509', NULL, NULL, 17926, 22),
(289999, NULL, 'TIGR00684', NULL, NULL, 'narJ: nitrate reductase molybdenum cofactor assembly chaperone', NULL, 'TIGR00684', NULL, NULL, 2487, 22),
(290000, NULL, 'TIGR04147', NULL, NULL, 'GGGPS_Halobact: phosphoglycerol geranylgeranyltransferase, putative', NULL, 'TIGR04147', NULL, NULL, 21185, 22),
(290001, NULL, 'TIGR01645', NULL, NULL, 'half-pint: poly-U binding splicing factor, half-pint family', NULL, 'TIGR01645', NULL, NULL, 380, 22),
(290002, NULL, 'TIGR04431', NULL, NULL, 'N6_acetyl_AAC6: aminoglycoside N(6'')-acetyltransferase, AacA4 family', NULL, 'TIGR04431', NULL, NULL, 25565, 22),
(290003, NULL, 'TIGR01331', NULL, NULL, 'bisphos_cysQ: 3''(2''),5''-bisphosphate nucleotidase', NULL, 'TIGR01331', NULL, NULL, 3821, 22),
(290004, NULL, 'TIGR02607', NULL, NULL, 'antidote_HigA: addiction module antidote protein, HigA family', NULL, 'TIGR02607', NULL, NULL, 9106, 22),
(290005, NULL, 'TIGR04029', NULL, NULL, 'CMD_Avi_7170: CMD domain protein, Avi_7170 family', NULL, 'TIGR04029', NULL, NULL, 11323, 22),
(290006, NULL, 'TIGR02944', NULL, NULL, 'suf_reg_Xantho: FeS assembly SUF system regulator', NULL, 'TIGR02944', NULL, NULL, 8964, 22),
(290007, NULL, 'TIGR02227', NULL, NULL, 'sigpep_I_bact: signal peptidase I', NULL, 'TIGR02227', NULL, NULL, 3507, 22),
(290008, NULL, 'TIGR03304', NULL, NULL, 'OMP85_target: outer membrane insertion C-terminal signal', NULL, 'TIGR03304', NULL, NULL, 17788, 22),
(290009, NULL, 'TIGR04079', NULL, NULL, 'phero_cyc_pep: KxxxW-cyclized secreted peptide', NULL, 'TIGR04079', NULL, NULL, 18146, 22),
(290010, NULL, 'TIGR03750', NULL, NULL, 'conj_TIGR03750: conjugative transfer region protein, TIGR03750 family', NULL, 'TIGR03750', NULL, NULL, 19601, 22),
(290011, NULL, 'TIGR03887', NULL, NULL, 'thiocyan_alph: thiocyanate hydrolase, gamma subunit', NULL, 'TIGR03887', NULL, NULL, 18051, 22),
(290012, NULL, 'TIGR00743', NULL, NULL, 'TIGR00743: conserved hypothetical protein', NULL, 'TIGR00743', NULL, NULL, 4208, 22),
(290013, NULL, 'TIGR03422', NULL, NULL, 'mito_frataxin: frataxin', NULL, 'TIGR03422', NULL, NULL, 19034, 22),
(290014, NULL, 'TIGR03559', NULL, NULL, 'F420_Rv3520c: probable F420-dependent oxidoreductase, Rv3520c family', NULL, 'TIGR03559', NULL, NULL, 18286, 22),
(290015, NULL, 'TIGR01088', NULL, NULL, 'aroQ: 3-dehydroquinate dehydratase, type II', NULL, 'TIGR01088', NULL, NULL, 4460, 22),
(290016, NULL, 'TIGR01112', NULL, NULL, 'mtrD: tetrahydromethanopterin S-methyltransferase, subunit D', NULL, 'TIGR01112', NULL, NULL, 5976, 22),
(290017, NULL, 'TIGR04440', NULL, NULL, 'glyco_TIGR04440: glycosyltransferase domain', NULL, 'TIGR04440', NULL, NULL, 26150, 22),
(290018, NULL, 'TIGR02267', NULL, NULL, 'TIGR02267: DUSAM domain', NULL, 'TIGR02267', NULL, NULL, 11837, 22),
(290019, NULL, 'TIGR01381', NULL, NULL, 'E1_like_apg7: E1-like protein-activating enzyme Gsa7p/Apg7p', NULL, 'TIGR01381', NULL, NULL, 3833, 22);          
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290020, NULL, 'TIGR03939', NULL, NULL, 'PGA_TPR_OMP: poly-beta-1,6 N-acetyl-D-glucosamine export porin PgaA', NULL, 'TIGR03939', NULL, NULL, 16995, 22),
(290021, NULL, 'TIGR01147', NULL, NULL, 'V_ATP_synt_G: V-type ATPase, G subunit', NULL, 'TIGR01147', NULL, NULL, 7438, 22),
(290022, NULL, 'TIGR00313', NULL, NULL, 'cobQ: cobyric acid synthase CobQ', NULL, 'TIGR00313', NULL, NULL, 7278, 22),
(290023, NULL, 'TIGR01440', NULL, NULL, 'TIGR01440: TIGR01440 family protein', NULL, 'TIGR01440', NULL, NULL, 4776, 22),
(290024, NULL, 'TIGR04001', NULL, NULL, 'thiol_BshB1: bacillithiol biosynthesis deacetylase BshB1', NULL, 'TIGR04001', NULL, NULL, 16581, 22),
(290025, NULL, 'TIGR04138', NULL, NULL, 'Plancto_Ver_chp: Verruc_Plancto-restricted protein', NULL, 'TIGR04138', NULL, NULL, 21366, 22),
(290026, NULL, 'TIGR00948', NULL, NULL, '2a75: L-lysine exporter', NULL, 'TIGR00948', NULL, NULL, 5414, 22),
(290027, NULL, 'TIGR02595', NULL, NULL, 'PEP_exosort: PEP-CTERM protein-sorting domain', NULL, 'TIGR02595', NULL, NULL, 9500, 22),
(290028, NULL, 'TIGR02130', NULL, NULL, 'dapB_plant: dihydrodipicolinate reductase', NULL, 'TIGR02130', NULL, NULL, 13582, 22),
(290029, NULL, 'TIGR01919', NULL, NULL, 'hisA-trpF: bifunctional HisA/TrpF protein', NULL, 'TIGR01919', NULL, NULL, 4196, 22),
(290030, NULL, 'TIGR03802', NULL, NULL, 'Asp_Ala_antiprt: aspartate-alanine antiporter', NULL, 'TIGR03802', NULL, NULL, 15827, 22),
(290031, NULL, 'TIGR03920', NULL, NULL, 'T7SS_EccD: type VII secretion integral membrane protein EccD', NULL, 'TIGR03920', NULL, NULL, 2410, 22),
(290032, NULL, 'TIGR02772', NULL, NULL, 'Ku_bact: Ku protein', NULL, 'TIGR02772', NULL, NULL, 9701, 22),
(290033, NULL, 'TIGR00786', NULL, NULL, 'dctM: TRAP transporter, DctM subunit', NULL, 'TIGR00786', NULL, NULL, 3010, 22),
(290034, NULL, 'TIGR02342', NULL, NULL, 'chap_CCT_delta: T-complex protein 1, delta subunit', NULL, 'TIGR02342', NULL, NULL, 11554, 22),
(290035, NULL, 'TIGR02670', NULL, NULL, 'cas_csx8: CRISPR-associated protein Cas8a1/Csx8, subtype I', NULL, 'TIGR02670', NULL, NULL, 10425, 22),
(290036, NULL, 'TIGR00306', NULL, NULL, 'apgM: phosphoglycerate mutase (2,3-diphosphoglycerate-independent), archaeal form', NULL, 'TIGR00306', NULL, NULL, 7075, 22),
(290037, NULL, 'TIGR02479', NULL, NULL, 'FliA_WhiG: RNA polymerase sigma factor, FliA/WhiG family', NULL, 'TIGR02479', NULL, NULL, 7131, 22),
(290038, NULL, 'TIGR03347', NULL, NULL, 'VI_chp_1: type VI secretion protein, VC_A0111 family', NULL, 'TIGR03347', NULL, NULL, 9807, 22),
(290039, NULL, 'TIGR03463', NULL, NULL, 'osq_cycl: 2,3-oxidosqualene cyclase', NULL, 'TIGR03463', NULL, NULL, 19849, 22),
(290040, NULL, 'TIGR02411', NULL, NULL, 'leuko_A4_hydro: leukotriene A-4 hydrolase/aminopeptidase', NULL, 'TIGR02411', NULL, NULL, 9732, 22),
(290041, NULL, 'TIGR04262', NULL, NULL, 'orph_peri_GRRM: extracellular substrate-binding orphan protein, GRRM family', NULL, 'TIGR04262', NULL, NULL, 24504, 22),
(290042, NULL, 'TIGR01427', NULL, NULL, 'PTS_IIC_fructo: PTS system, Fru family, IIC component', NULL, 'TIGR01427', NULL, NULL, 4800, 22),
(290043, NULL, 'TIGR00136', NULL, NULL, 'gidA: tRNA uridine 5-carboxymethylaminomethyl modification enzyme GidA', NULL, 'TIGR00136', NULL, NULL, 7194, 22),
(290044, NULL, 'TIGR02840', NULL, NULL, 'spore_YtaF: putative sporulation protein YtaF', NULL, 'TIGR02840', NULL, NULL, 9031, 22),
(290045, NULL, 'TIGR03210', NULL, NULL, 'badI: 2-ketocyclohexanecarboxyl-CoA hydrolase', NULL, 'TIGR03210', NULL, NULL, 16549, 22),
(290046, NULL, 'TIGR00151', NULL, NULL, 'ispF: 2-C-methyl-D-erythritol 2,4-cyclodiphosphate synthase', NULL, 'TIGR00151', NULL, NULL, 6440, 22),
(290047, NULL, 'TIGR00634', NULL, NULL, 'recN: DNA repair protein RecN', NULL, 'TIGR00634', NULL, NULL, 818, 22),
(290048, NULL, 'TIGR04316', NULL, NULL, 'dhbA_paeA: 2,3-dihydro-2,3-dihydroxybenzoate dehydrogenase', NULL, 'TIGR04316', NULL, NULL, 117, 22),
(290049, NULL, 'TIGR02554', NULL, NULL, 'PrgH: type III secretion apparatus protein PrgH/EprH', NULL, 'TIGR02554', NULL, NULL, 11330, 22),
(290050, NULL, 'TIGR01197', NULL, NULL, 'nramp: metal ion transporter, metal ion (Mn2+/Fe2+) transporter (Nramp) family', NULL, 'TIGR01197', NULL, NULL, 2110, 22); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290051, NULL, 'TIGR00035', NULL, NULL, 'asp_race: aspartate racemase', NULL, 'TIGR00035', NULL, NULL, 5712, 22),
(290052, NULL, 'TIGR01004', NULL, NULL, 'PulS_OutS: lipoprotein, PulS/OutS family', NULL, 'TIGR01004', NULL, NULL, 3656, 22),
(290053, NULL, 'TIGR00628', NULL, NULL, 'ung: uracil-DNA glycosylase', NULL, 'TIGR00628', NULL, NULL, 1399, 22),
(290054, NULL, 'TIGR00861', NULL, NULL, 'MIP: MIP family channel proteins', NULL, 'TIGR00861', NULL, NULL, 4930, 22),
(290055, NULL, 'TIGR00998', NULL, NULL, '8a0101: efflux pump membrane protein', NULL, 'TIGR00998', NULL, NULL, 3967, 22),
(290056, NULL, 'TIGR03905', NULL, NULL, 'TIGR03905_4_Cys: uncharacterized protein TIGR03905', NULL, 'TIGR03905', NULL, NULL, 12557, 22),
(290057, NULL, 'TIGR02882', NULL, NULL, 'QoxB: cytochrome aa3 quinol oxidase, subunit I', NULL, 'TIGR02882', NULL, NULL, 10784, 22),
(290058, NULL, 'TIGR00288', NULL, NULL, 'TIGR00288: TIGR00288 family protein', NULL, 'TIGR00288', NULL, NULL, 4748, 22),
(290059, NULL, 'TIGR00363', NULL, NULL, 'TIGR00363: lipoprotein, YaeC family', NULL, 'TIGR00363', NULL, NULL, 7183, 22),
(290060, NULL, 'TIGR04474', NULL, NULL, 'tcm_partner: three-Cys-motif partner protein', NULL, 'TIGR04474', NULL, NULL, 25793, 22),
(290061, NULL, 'TIGR02977', NULL, NULL, 'phageshock_pspA: phage shock protein A', NULL, 'TIGR02977', NULL, NULL, 9557, 22),
(290062, NULL, 'TIGR01639', NULL, NULL, 'P_fal_TIGR01639: Plasmodium falciparum uncharacterized domain TIGR01639', NULL, 'TIGR01639', NULL, NULL, 276, 22),
(290063, NULL, 'TIGR04104', NULL, NULL, 'cxxc_20_cxxc: cxxc_20_cxxc protein', NULL, 'TIGR04104', NULL, NULL, 23076, 22),
(290064, NULL, 'TIGR04399', NULL, NULL, 'acc_Sec_SLAP: accessory Sec system S-layer assembly protein', NULL, 'TIGR04399', NULL, NULL, 21464, 22),
(290065, NULL, 'TIGR02548', NULL, NULL, 'casB_cse2: CRISPR type I-E/ECOLI-associated protein CasB/Cse2', NULL, 'TIGR02548', NULL, NULL, 11211, 22),
(290066, NULL, 'TIGR03961', NULL, NULL, 'rSAM_PTO1314: archaeal radical SAM protein, PTO1314 family', NULL, 'TIGR03961', NULL, NULL, 17537, 22),
(290067, NULL, 'TIGR01713', NULL, NULL, 'typeII_sec_gspC: type II secretion system protein C', NULL, 'TIGR01713', NULL, NULL, 3988, 22),
(290068, NULL, 'TIGR00690', NULL, NULL, 'rpoZ: DNA-directed RNA polymerase, omega subunit', NULL, 'TIGR00690', NULL, NULL, 2383, 22),
(290069, NULL, 'TIGR02336', NULL, NULL, 'TIGR02336: 1,3-beta-galactosyl-N-acetylhexosamine phosphorylase', NULL, 'TIGR02336', NULL, NULL, 11656, 22),
(290070, NULL, 'TIGR03388', NULL, NULL, 'ascorbase: L-ascorbate oxidase', NULL, 'TIGR03388', NULL, NULL, 18519, 22),
(290071, NULL, 'TIGR02834', NULL, NULL, 'spo_ytxC: putative sporulation protein YtxC', NULL, 'TIGR02834', NULL, NULL, 9364, 22),
(290072, NULL, 'TIGR01215', NULL, NULL, 'minE: cell division topological specificity factor MinE', NULL, 'TIGR01215', NULL, NULL, 1808, 22),
(290073, NULL, 'TIGR04372', NULL, NULL, 'glycosyl_04372: putative glycosyltransferase, TIGR04372 family', NULL, 'TIGR04372', NULL, NULL, 21691, 22),
(290074, NULL, 'TIGR02008', NULL, NULL, 'fdx_plant: ferredoxin [2Fe-2S]', NULL, 'TIGR02008', NULL, NULL, 5374, 22),
(290075, NULL, 'TIGR04527', NULL, NULL, 'mycoplas_twoTM: two transmembrane protein', NULL, 'TIGR04527', NULL, NULL, 25285, 22),
(290076, NULL, 'TIGR01299', NULL, NULL, 'synapt_SV2: synaptic vesicle protein SV2', NULL, 'TIGR01299', NULL, NULL, 15973, 22),
(290077, NULL, 'TIGR04044', NULL, NULL, 'MSMEG_0572_fam: MSMEG_0572 family protein', NULL, 'TIGR04044', NULL, NULL, 16799, 22),
(290078, NULL, 'TIGR00192', NULL, NULL, 'urease_beta: urease, beta subunit', NULL, 'TIGR00192', NULL, NULL, 2157, 22),
(290079, NULL, 'TIGR01543', NULL, NULL, 'proheadase_HK97: phage prohead protease, HK97 family', NULL, 'TIGR01543', NULL, NULL, 6562, 22),
(290080, NULL, 'TIGR02056', NULL, NULL, 'ChlG: chlorophyll synthase ChlG', NULL, 'TIGR02056', NULL, NULL, 13110, 22),
(290081, NULL, 'TIGR03407', NULL, NULL, 'urea_ABC_UrtA: urea ABC transporter, urea binding protein', NULL, 'TIGR03407', NULL, NULL, 19281, 22),
(290082, NULL, 'TIGR01502', NULL, NULL, 'B_methylAsp_ase: methylaspartate ammonia-lyase', NULL, 'TIGR01502', NULL, NULL, 5706, 22); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290083, NULL, 'TIGR00518', NULL, NULL, 'alaDH: alanine dehydrogenase', NULL, 'TIGR00518', NULL, NULL, 7396, 22),
(290084, NULL, 'TIGR04534', NULL, NULL, 'ELWxxDGT_rpt: ELWxxDGT repeat', NULL, 'TIGR04534', NULL, NULL, 23951, 22),
(290085, NULL, 'TIGR03183', NULL, NULL, 'DNA_S_dndC: putative sulfurtransferase DndC', NULL, 'TIGR03183', NULL, NULL, 15963, 22),
(290086, NULL, 'TIGR03675', NULL, NULL, 'arCOG00543: arCOG00543 universal archaeal KH-domain/beta-lactamase-domain protein', NULL, 'TIGR03675', NULL, NULL, 15554, 22),
(290087, NULL, 'TIGR02513', NULL, NULL, 'type_III_yscB: type III secretion system chaperone, YscB family', NULL, 'TIGR02513', NULL, NULL, 18521, 22),
(290088, NULL, 'TIGR01490', NULL, NULL, 'HAD-SF-IB-hyp1: HAD hydrolase, family IB', NULL, 'TIGR01490', NULL, NULL, 5876, 22),
(290089, NULL, 'TIGR02841', NULL, NULL, 'spore_YyaC: putative sporulation protein YyaC', NULL, 'TIGR02841', NULL, NULL, 11708, 22),
(290090, NULL, 'TIGR04188', NULL, NULL, 'methyltr_grsp: methyltransferase, ATP-grasp peptide maturase system', NULL, 'TIGR04188', NULL, NULL, 23141, 22),
(290091, NULL, 'TIGR01162', NULL, NULL, 'purE: phosphoribosylaminoimidazole carboxylase, catalytic subunit', NULL, 'TIGR01162', NULL, NULL, 3785, 22),
(290092, NULL, 'TIGR00204', NULL, NULL, 'dxs: 1-deoxy-D-xylulose-5-phosphate synthase', NULL, 'TIGR00204', NULL, NULL, 786, 22),
(290093, NULL, 'TIGR03177', NULL, NULL, 'pilus_cpaB: Flp pilus assembly protein CpaB', NULL, 'TIGR03177', NULL, NULL, 15519, 22),
(290094, NULL, 'TIGR00846', NULL, NULL, 'caca2: calcium/proton exchanger', NULL, 'TIGR00846', NULL, NULL, NULL, 22),
(290095, NULL, 'TIGR01325', NULL, NULL, 'O_suc_HS_sulf: O-succinylhomoserine sulfhydrylase', NULL, 'TIGR01325', NULL, NULL, 3655, 22),
(290096, NULL, 'TIGR04418', NULL, NULL, 'PriB_gamma: primosomal replication protein PriB', NULL, 'TIGR04418', NULL, NULL, 16241, 22),
(290097, NULL, 'TIGR00307', NULL, NULL, 'eS8: ribosomal protein eS8', NULL, 'TIGR00307', NULL, NULL, 2062, 22),
(290098, NULL, 'TIGR02377', NULL, NULL, 'MocE_fam_FeS: Rieske [2Fe-2S] domain protein, MocE subfamily', NULL, 'TIGR02377', NULL, NULL, 9366, 22),
(290099, NULL, 'TIGR01271', NULL, NULL, 'CFTR_protein: cystic fibrosis transmembrane conductor regulator (CFTR)', NULL, 'TIGR01271', NULL, NULL, 10100, 22),
(290100, NULL, 'TIGR02343', NULL, NULL, 'chap_CCT_epsi: T-complex protein 1, epsilon subunit', NULL, 'TIGR02343', NULL, NULL, 11564, 22),
(290101, NULL, 'TIGR02240', NULL, NULL, 'PHA_depoly_arom: poly(3-hydroxyalkanoate) depolymerase', NULL, 'TIGR02240', NULL, NULL, 11429, 22),
(290102, NULL, 'TIGR03395', NULL, NULL, 'sphingomy: sphingomyelin phosphodiesterase', NULL, 'TIGR03395', NULL, NULL, 18749, 22),
(290103, NULL, 'TIGR01857', NULL, NULL, 'FGAM-synthase: phosphoribosylformylglycinamidine synthase', NULL, 'TIGR01857', NULL, NULL, 10941, 22),
(290104, NULL, 'TIGR00702', NULL, NULL, 'TIGR00702: YcaO-type kinase domain', NULL, 'TIGR00702', NULL, NULL, 6262, 22),
(290105, NULL, 'TIGR02875', NULL, NULL, 'spore_0_A: sporulation transcription factor Spo0A', NULL, 'TIGR02875', NULL, NULL, 11075, 22),
(290106, NULL, 'TIGR01720', NULL, NULL, 'NRPS-para261: non-ribosomal peptide synthase domain TIGR01720', NULL, 'TIGR01720', NULL, NULL, 6311, 22),
(290107, NULL, 'TIGR03067', NULL, NULL, 'Planc_TIGR03067: Planctomycetes uncharacterized domain TIGR03067', NULL, 'TIGR03067', NULL, NULL, 21477, 22),
(290108, NULL, 'TIGR02622', NULL, NULL, 'CDP_4_6_dhtase: CDP-glucose 4,6-dehydratase', NULL, 'TIGR02622', NULL, NULL, 9182, 22),
(290109, NULL, 'TIGR03728', NULL, NULL, 'glyco_access_1: glycosyltransferase, SP_1767 family', NULL, 'TIGR03728', NULL, NULL, 13318, 22),
(290110, NULL, 'TIGR04085', NULL, NULL, 'rSAM_more_4Fe4S: radical SAM additional 4Fe4S-binding SPASM domain', NULL, 'TIGR04085', NULL, NULL, 17795, 22),
(290111, NULL, 'TIGR02015', NULL, NULL, 'BchY: chlorophyllide reductase subunit Y', NULL, 'TIGR02015', NULL, NULL, 5020, 22),
(290112, NULL, 'TIGR03777', NULL, NULL, 'RPE4: rickettsial palindromic element RPE4 domain', NULL, 'TIGR03777', NULL, NULL, 15897, 22);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290113, NULL, 'TIGR01823', NULL, NULL, 'PabB-fungal: aminodeoxychorismate synthase', NULL, 'TIGR01823', NULL, NULL, 10818, 22),
(290114, NULL, 'TIGR02978', NULL, NULL, 'phageshock_pspC: phage shock protein C', NULL, 'TIGR02978', NULL, NULL, 9658, 22),
(290115, NULL, 'TIGR03893', NULL, NULL, 'lant_SP_1948: type 2 lantibiotic, SP_1948 family', NULL, 'TIGR03893', NULL, NULL, 23692, 22),
(290116, NULL, 'TIGR02547', NULL, NULL, 'casA_cse1: CRISPR type I-E/ECOLI-associated protein CasA/Cse1', NULL, 'TIGR02547', NULL, NULL, 11060, 22),
(290117, NULL, 'TIGR01222', NULL, NULL, 'minC: septum site-determining protein MinC', NULL, 'TIGR01222', NULL, NULL, 12628, 22),
(290118, NULL, 'TIGR02950', NULL, NULL, 'SigM_subfam: RNA polymerase sigma factor, SigM family', NULL, 'TIGR02950', NULL, NULL, 9661, 22),
(290119, NULL, 'TIGR04297', NULL, NULL, 'thauma_sortase: thaumarchaeosortase', NULL, 'TIGR04297', NULL, NULL, 26814, 22),
(290120, NULL, 'TIGR04160', NULL, NULL, 'methbact_MbnC: methanobactin biosynthesis cassette protein MbnC', NULL, 'TIGR04160', NULL, NULL, NULL, 22),
(290121, NULL, 'TIGR00465', NULL, NULL, 'ilvC: ketol-acid reductoisomerase', NULL, 'TIGR00465', NULL, NULL, 12939, 22),
(290122, NULL, 'TIGR03142', NULL, NULL, 'cytochro_ccmI: cytochrome c-type biogenesis protein CcmI', NULL, 'TIGR03142', NULL, NULL, 14581, 22),
(290123, NULL, 'TIGR00144', NULL, NULL, 'beta_RFAP_syn: beta-ribofuranosylaminobenzene 5''-phosphate synthase family', NULL, 'TIGR00144', NULL, NULL, 7096, 22),
(290124, NULL, 'TIGR03640', NULL, NULL, 'cas1_DVULG: CRISPR-associated endonuclease Cas1, subtype I-C/DVULG', NULL, 'TIGR03640', NULL, NULL, 14986, 22),
(290125, NULL, 'TIGR03470', NULL, NULL, 'HpnH: hopanoid biosynthesis associated radical SAM protein HpnH', NULL, 'TIGR03470', NULL, NULL, 19945, 22),
(290126, NULL, 'TIGR02410', NULL, NULL, 'carnitine_TMLD: trimethyllysine dioxygenase', NULL, 'TIGR02410', NULL, NULL, 9613, 22),
(290127, NULL, 'TIGR03886', NULL, NULL, 'lyase_spl_fam: spore photoproduct lyase family protein', NULL, 'TIGR03886', NULL, NULL, 12541, 22),
(290128, NULL, 'TIGR00805', NULL, NULL, 'oat: sodium-independent organic anion transporter', NULL, 'TIGR00805', NULL, NULL, 2982, 22),
(290129, NULL, 'TIGR03565', NULL, NULL, 'alk_sulf_monoox: alkanesulfonate monooxygenase, FMNH(2)-dependent', NULL, 'TIGR03565', NULL, NULL, 18083, 22),
(290130, NULL, 'TIGR02731', NULL, NULL, 'phytoene_desat: phytoene desaturase', NULL, 'TIGR02731', NULL, NULL, 14449, 22),
(290131, NULL, 'TIGR02301', NULL, NULL, 'TIGR02301: TIGR02301 family protein', NULL, 'TIGR02301', NULL, NULL, 10008, 22),
(290132, NULL, 'TIGR03784', NULL, NULL, 'marine_sortase: sortase, marine proteobacterial type', NULL, 'TIGR03784', NULL, NULL, 21286, 22),
(290133, NULL, 'TIGR02438', NULL, NULL, 'catachol_actin: catechol 1,2-dioxygenase', NULL, 'TIGR02438', NULL, NULL, 12725, 22),
(290134, NULL, 'TIGR02766', NULL, NULL, 'crypt_chrom_pln: cryptochrome, plant family', NULL, 'TIGR02766', NULL, NULL, 14361, 22),
(290135, NULL, 'TIGR03251', NULL, NULL, 'LAT_fam: L-lysine 6-transaminase', NULL, 'TIGR03251', NULL, NULL, 17152, 22),
(290136, NULL, 'TIGR00397', NULL, NULL, 'mauM_napG: MauM/NapG family ferredoxin-type protein', NULL, 'TIGR00397', NULL, NULL, 1058, 22),
(290137, NULL, 'TIGR00260', NULL, NULL, 'thrC: threonine synthase', NULL, 'TIGR00260', NULL, NULL, 7004, 22),
(290138, NULL, 'TIGR00416', NULL, NULL, 'sms: DNA repair protein RadA', NULL, 'TIGR00416', NULL, NULL, 1831, 22),
(290139, NULL, 'TIGR01748', NULL, NULL, 'rhaA: L-rhamnose isomerase', NULL, 'TIGR01748', NULL, NULL, 13924, 22),
(290140, NULL, 'TIGR01592', NULL, NULL, 'holin_SPP1: holin, SPP1 family', NULL, 'TIGR01592', NULL, NULL, 6359, 22),
(290141, NULL, 'TIGR03286', NULL, NULL, 'methan_mark_15: putative methanogenesis marker protein 15', NULL, 'TIGR03286', NULL, NULL, 17973, 22),
(290142, NULL, 'TIGR02452', NULL, NULL, 'TIGR02452: TIGR02452 family protein', NULL, 'TIGR02452', NULL, NULL, 10886, 22),
(290143, NULL, 'TIGR02131', NULL, NULL, 'phaP_Bmeg: polyhydroxyalkanoic acid inclusion protein PhaP', NULL, 'TIGR02131', NULL, NULL, 11660, 22); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290144, NULL, 'TIGR01106', NULL, NULL, 'ATPase-IIC_X-K: Na,H/K antiporter P-type ATPase, alpha subunit', NULL, 'TIGR01106', NULL, NULL, 4810, 22),
(290145, NULL, 'TIGR01932', NULL, NULL, 'hflC: HflC protein', NULL, 'TIGR01932', NULL, NULL, 4374, 22),
(290146, NULL, 'TIGR03619', NULL, NULL, 'F420_Rv2161c: probable F420-dependent oxidoreductase, Rv2161c family', NULL, 'TIGR03619', NULL, NULL, 14589, 22),
(290147, NULL, 'TIGR02124', NULL, NULL, 'hypE: hydrogenase expression/formation protein HypE', NULL, 'TIGR02124', NULL, NULL, 13712, 22),
(290148, NULL, 'TIGR00574', NULL, NULL, 'dnl1: DNA ligase I, ATP-dependent (dnl1)', NULL, 'TIGR00574', NULL, NULL, 325, 22),
(290149, NULL, 'TIGR03135', NULL, NULL, 'malonate_mdcG: malonate decarboxylase holo-[acyl-carrier-protein] synthase', NULL, 'TIGR03135', NULL, NULL, 14713, 22),
(290150, NULL, 'TIGR00914', NULL, NULL, '2A0601: heavy metal efflux pump, CzcA family', NULL, 'TIGR00914', NULL, NULL, 5429, 22),
(290151, NULL, 'TIGR01925', NULL, NULL, 'spIIAB: anti-sigma F factor', NULL, 'TIGR01925', NULL, NULL, 4030, 22),
(290152, NULL, 'TIGR03279', NULL, NULL, 'cyano_FeS_chp: putative radical SAM enzyme, TIGR03279 family', NULL, 'TIGR03279', NULL, NULL, 17557, 22),
(290153, NULL, 'TIGR04092', NULL, NULL, 'LTA_DltD: D-alanyl-lipoteichoic acid biosynthesis protein DltD', NULL, 'TIGR04092', NULL, NULL, 12191, 22),
(290154, NULL, 'TIGR00581', NULL, NULL, 'moaC: molybdenum cofactor biosynthesis protein C', NULL, 'TIGR00581', NULL, NULL, 15016, 22),
(290155, NULL, 'TIGR00895', NULL, NULL, '2A0115: MFS transporter, aromatic acid:H+ symporter (AAHS) family', NULL, 'TIGR00895', NULL, NULL, 5369, 22),
(290156, NULL, 'TIGR01604', NULL, NULL, 'PYST-C2: Plasmodium yoelii subtelomeric domain PYST-C2', NULL, 'TIGR01604', NULL, NULL, 6182, 22),
(290157, NULL, 'TIGR02445', NULL, NULL, 'fadA: acetyl-CoA C-acyltransferase FadA', NULL, 'TIGR02445', NULL, NULL, 12743, 22),
(290158, NULL, 'TIGR01611', NULL, NULL, 'tail_tube: phage major tail tube protein', NULL, 'TIGR01611', NULL, NULL, 6699, 22),
(290159, NULL, 'TIGR02759', NULL, NULL, 'TraD_Ftype: type IV conjugative transfer system coupling protein TraD', NULL, 'TIGR02759', NULL, NULL, 13911, 22),
(290160, NULL, 'TIGR04309', NULL, NULL, 'amanitin: amanitin/phalloidin family toxin', NULL, 'TIGR04309', NULL, NULL, 22473, 22),
(290161, NULL, 'TIGR00600', NULL, NULL, 'rad2: DNA excision repair protein (rad2)', NULL, 'TIGR00600', NULL, NULL, 2233, 22),
(290162, NULL, 'TIGR01113', NULL, NULL, 'mtrE: tetrahydromethanopterin S-methyltransferase, subunit E', NULL, 'TIGR01113', NULL, NULL, 5908, 22),
(290163, NULL, 'TIGR00921', NULL, NULL, '2A067: efflux transporter, putative, hydrophobe/amphiphile efflux-3 (HAE3) family', NULL, 'TIGR00921', NULL, NULL, 5465, 22),
(290164, NULL, 'TIGR01755', NULL, NULL, 'flav_wrbA: NAD(P)H:quinone oxidoreductase, type IV', NULL, 'TIGR01755', NULL, NULL, 2132, 22),
(290165, NULL, 'TIGR01434', NULL, NULL, 'glu_cys_ligase: glutamate--cysteine ligase', NULL, 'TIGR01434', NULL, NULL, 4551, 22),
(290166, NULL, 'TIGR02268', NULL, NULL, 'TIGR02268: Myxococcus xanthus paralogous family TIGR02268', NULL, 'TIGR02268', NULL, NULL, 11799, 22),
(290167, NULL, 'TIGR00083', NULL, NULL, 'ribF: riboflavin biosynthesis protein RibF', NULL, 'TIGR00083', NULL, NULL, 1522, 22),
(290168, NULL, 'TIGR02589', NULL, NULL, 'cas_Csd2: CRISPR-associated protein Cas7/Csd2, subtype I-C/DVULG', NULL, 'TIGR02589', NULL, NULL, 9016, 22),
(290169, NULL, 'TIGR01098', NULL, NULL, '3A0109s03R: phosphate/phosphite/phosphonate ABC transporter, periplasmic binding protein', NULL, 'TIGR01098', NULL, NULL, 4553, 22),
(290170, NULL, 'TIGR02773', NULL, NULL, 'addB_Gpos: helicase-exonuclease AddAB, AddB subunit', NULL, 'TIGR02773', NULL, NULL, 14001, 22),
(290171, NULL, 'TIGR02893', NULL, NULL, 'spore_yabQ: spore cortex biosynthesis protein YabQ', NULL, 'TIGR02893', NULL, NULL, 10865, 22),
(290172, NULL, 'TIGR03188', NULL, NULL, 'histidine_hisI: phosphoribosyl-ATP diphosphatase', NULL, 'TIGR03188', NULL, NULL, 7130, 22),
(290173, NULL, 'TIGR00203', NULL, NULL, 'cydB: cytochrome d ubiquinol oxidase, subunit II', NULL, 'TIGR00203', NULL, NULL, 4028, 22);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290174, NULL, 'TIGR03068', NULL, NULL, 'srtB_sig_NPQTN: sortase B signal domain, NPQTN class', NULL, 'TIGR03068', NULL, NULL, 21448, 22),
(290175, NULL, 'TIGR01942', NULL, NULL, 'pcnB: poly(A) polymerase', NULL, 'TIGR01942', NULL, NULL, 4002, 22),
(290176, NULL, 'TIGR02606', NULL, NULL, 'antidote_CC2985: putative addiction module antidote protein, CC2985 family', NULL, 'TIGR02606', NULL, NULL, 6361, 22),
(290177, NULL, 'TIGR00387', NULL, NULL, 'glcD: glycolate oxidase, subunit GlcD', NULL, 'TIGR00387', NULL, NULL, 1382, 22),
(290178, NULL, 'TIGR03124', NULL, NULL, 'citrate_citX: holo-ACP synthase CitX', NULL, 'TIGR03124', NULL, NULL, 1586, 22),
(290179, NULL, 'TIGR00490', NULL, NULL, 'aEF-2: translation elongation factor aEF-2', NULL, 'TIGR00490', NULL, NULL, 918, 22),
(290180, NULL, 'TIGR03004', NULL, NULL, 'ectoine_ehuC: ectoine/hydroxyectoine ABC transporter, permease protein EhuC', NULL, 'TIGR03004', NULL, NULL, 11494, 22),
(290181, NULL, 'TIGR00370', NULL, NULL, 'TIGR00370: sensor histidine kinase inhibitor, KipI family', NULL, 'TIGR00370', NULL, NULL, 5206, 22),
(290182, NULL, 'TIGR01034', NULL, NULL, 'metK: methionine adenosyltransferase', NULL, 'TIGR01034', NULL, NULL, 5293, 22),
(290183, NULL, 'TIGR04550', NULL, NULL, 'sMetMonox_MmoD: soluble methane monooxygenase-binding protein MmoD', NULL, 'TIGR04550', NULL, NULL, 15548, 22),
(290184, NULL, 'TIGR01959', NULL, NULL, 'nuoF_fam: NADH oxidoreductase (quinone), F subunit', NULL, 'TIGR01959', NULL, NULL, 7775, 22),
(290185, NULL, 'TIGR00516', NULL, NULL, 'acpS: holo-[acyl-carrier-protein] synthase', NULL, 'TIGR00516', NULL, NULL, 1707, 22),
(290186, NULL, 'TIGR02460', NULL, NULL, 'osmo_MPGsynth: mannosyl-3-phosphoglycerate synthase', NULL, 'TIGR02460', NULL, NULL, 12794, 22),
(290187, NULL, 'TIGR04327', NULL, NULL, 'OMP_LA_2444: outer membrane protein, LA_2444/LA_4059 family', NULL, 'TIGR04327', NULL, NULL, 23220, 22),
(290188, NULL, 'TIGR02237', NULL, NULL, 'recomb_radB: DNA repair and recombination protein RadB', NULL, 'TIGR02237', NULL, NULL, 11423, 22),
(290189, NULL, 'TIGR01347', NULL, NULL, 'sucB: dihydrolipoyllysine-residue succinyltransferase, E2 component of oxoglutarate dehydrogenase (succinyl-transferring) complex', NULL, 'TIGR01347', NULL, NULL, 3685, 22),
(290190, NULL, 'TIGR01839', NULL, NULL, 'PHA_synth_II: poly(R)-hydroxyalkanoic acid synthase, class II', NULL, 'TIGR01839', NULL, NULL, 10345, 22),
(290191, NULL, 'TIGR03437', NULL, NULL, 'Soli_cterm: Solibacter uncharacterized C-terminal domain', NULL, 'TIGR03437', NULL, NULL, 19035, 22),
(290192, NULL, 'TIGR03929', NULL, NULL, 'T7_esaA_Nterm: type VII secretion protein EsaA', NULL, 'TIGR03929', NULL, NULL, 16624, 22),
(290193, NULL, 'TIGR02580', NULL, NULL, 'cas_RAMP_Cmr4: CRISPR type III-B/RAMP module RAMP protein Cmr4', NULL, 'TIGR02580', NULL, NULL, 9198, 22),
(290194, NULL, 'TIGR04075', NULL, NULL, 'bacter_Pnkp: polynucleotide kinase-phosphatase', NULL, 'TIGR04075', NULL, NULL, 11988, 22),
(290195, NULL, 'TIGR01570', NULL, NULL, 'A_thal_3588: uncharacterized plant-specific domain TIGR01570', NULL, 'TIGR01570', NULL, NULL, 6990, 22),
(290196, NULL, 'TIGR03244', NULL, NULL, 'arg_catab_AstA: arginine N-succinyltransferase', NULL, 'TIGR03244', NULL, NULL, 17462, 22),
(290197, NULL, 'TIGR01406', NULL, NULL, 'dnaQ_proteo: DNA polymerase III, epsilon subunit', NULL, 'TIGR01406', NULL, NULL, 4675, 22),
(290198, NULL, 'TIGR03660', NULL, NULL, 'T1SS_rpt_143: T1SS-143 repeat domain', NULL, 'TIGR03660', NULL, NULL, 15433, 22),
(290199, NULL, 'TIGR04268', NULL, NULL, 'FxSxx-COOH: FXSXX-COOH protein', NULL, 'TIGR04268', NULL, NULL, 24528, 22),
(290200, NULL, 'TIGR02178', NULL, NULL, 'yeiP: elongation factor P-like protein YeiP', NULL, 'TIGR02178', NULL, NULL, 12415, 22),
(290201, NULL, 'TIGR00147', NULL, NULL, 'TIGR00147: lipid kinase, YegS/Rv2252/BmrU family', NULL, 'TIGR00147', NULL, NULL, 11151, 22),
(290202, NULL, 'TIGR00088', NULL, NULL, 'trmD: tRNA (guanine(37)-N(1))-methyltransferase', NULL, 'TIGR00088', NULL, NULL, 2522, 22),
(290203, NULL, 'TIGR03853', NULL, NULL, 'matur_matur: putative metal-binding protein', NULL, 'TIGR03853', NULL, NULL, 20138, 22); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290204, NULL, 'TIGR01883', NULL, NULL, 'PepT-like: peptidase T-like protein', NULL, 'TIGR01883', NULL, NULL, 10985, 22),
(290205, NULL, 'TIGR04148', NULL, NULL, 'GG_samocin_CFB: radical SAM peptide maturase, GG-Bacteroidales family', NULL, 'TIGR04148', NULL, NULL, 21051, 22),
(290206, NULL, 'TIGR02298', NULL, NULL, 'HpaD_Fe: 3,4-dihydroxyphenylacetate 2,3-dioxygenase', NULL, 'TIGR02298', NULL, NULL, 13327, 22),
(290207, NULL, 'TIGR00932', NULL, NULL, '2a37: transporter, monovalent cation:proton antiporter-2 (CPA2) family', NULL, 'TIGR00932', NULL, NULL, 5059, 22),
(290208, NULL, 'TIGR03780', NULL, NULL, 'Bac_Flav_CT_N: Bacteroides conjugative transposon TraN protein', NULL, 'TIGR03780', NULL, NULL, 21364, 22),
(290209, NULL, 'TIGR04134', NULL, NULL, 'lipo_with_rSAM: putative lipoprotein, rSAM/lipoprotein system', NULL, 'TIGR04134', NULL, NULL, 21139, 22),
(290210, NULL, 'TIGR03590', NULL, NULL, 'PseG: UDP-2,4-diacetamido-2,4,6-trideoxy-beta-L-altropyranose hydrolase', NULL, 'TIGR03590', NULL, NULL, 11666, 22),
(290211, NULL, 'TIGR04254', NULL, NULL, 'OpituPEPCTERM_1: putative globular PEP-CTERM protein', NULL, 'TIGR04254', NULL, NULL, 24709, 22),
(290212, NULL, 'TIGR00074', NULL, NULL, 'hypC_hupF: hydrogenase assembly chaperone HypC/HupF', NULL, 'TIGR00074', NULL, NULL, 1282, 22),
(290213, NULL, 'TIGR01227', NULL, NULL, 'hutG: formimidoylglutamase', NULL, 'TIGR01227', NULL, NULL, 205, 22),
(290214, NULL, 'TIGR02729', NULL, NULL, 'Obg_CgtA: Obg family GTPase CgtA', NULL, 'TIGR02729', NULL, NULL, 14434, 22),
(290215, NULL, 'TIGR03065', NULL, NULL, 'srtB_sig_QVPTGV: sortase B signal domain, QVPTGV class', NULL, 'TIGR03065', NULL, NULL, 21030, 22),
(290216, NULL, 'TIGR02919', NULL, NULL, 'TIGR02919: accessory Sec system glycosyltransferase GtfB', NULL, 'TIGR02919', NULL, NULL, 11391, 22),
(290217, NULL, 'TIGR02357', NULL, NULL, 'ECF_ThiT_YuaJ: energy-coupled thiamine transporter ThiT', NULL, 'TIGR02357', NULL, NULL, 10203, 22),
(290218, NULL, 'TIGR04207', NULL, NULL, 'halo_sig_pep: surface glycoprotein signal peptide', NULL, 'TIGR04207', NULL, NULL, 23223, 22),
(290219, NULL, 'TIGR00519', NULL, NULL, 'asnASE_I: L-asparaginase, type I', NULL, 'TIGR00519', NULL, NULL, 2914, 22),
(290220, NULL, 'TIGR00709', NULL, NULL, 'dat: 2,4-diaminobutyrate 4-transaminase', NULL, 'TIGR00709', NULL, NULL, 2466, 22),
(290221, NULL, 'TIGR00217', NULL, NULL, 'malQ: 4-alpha-glucanotransferase', NULL, 'TIGR00217', NULL, NULL, 4483, 22),
(290222, NULL, 'TIGR00446', NULL, NULL, 'nop2p: NOL1/NOP2/sun family putative RNA methylase', NULL, 'TIGR00446', NULL, NULL, 12749, 22),
(290223, NULL, 'TIGR04567', NULL, NULL, 'RNAP_delt_lowGC: DNA-directed RNA polymerase delta subunit', NULL, 'TIGR04567', NULL, NULL, 25575, 22),
(290224, NULL, 'TIGR01450', NULL, NULL, 'recC: exodeoxyribonuclease V, gamma subunit', NULL, 'TIGR01450', NULL, NULL, 2394, 22),
(290225, NULL, 'TIGR02952', NULL, NULL, 'Sig70_famx2: RNA polymerase sigma-70 factor, TIGR02952 family', NULL, 'TIGR02952', NULL, NULL, 9943, 22),
(290226, NULL, 'TIGR00440', NULL, NULL, 'glnS: glutamine--tRNA ligase', NULL, 'TIGR00440', NULL, NULL, 1572, 22),
(290227, NULL, 'TIGR00879', NULL, NULL, 'SP: MFS transporter, sugar porter (SP) family', NULL, 'TIGR00879', NULL, NULL, 1049, 22),
(290228, NULL, 'TIGR02114', NULL, NULL, 'coaB_strep: phosphopantothenate--cysteine ligase', NULL, 'TIGR02114', NULL, NULL, 13901, 22),
(290229, NULL, 'TIGR03616', NULL, NULL, 'RutG: pyrimidine utilization transport protein G', NULL, 'TIGR03616', NULL, NULL, 14644, 22),
(290230, NULL, 'TIGR03138', NULL, NULL, 'QueF: queuine synthase', NULL, 'TIGR03138', NULL, NULL, 21107, 22),
(290231, NULL, 'TIGR01084', NULL, NULL, 'mutY: A/G-specific adenine glycosylase', NULL, 'TIGR01084', NULL, NULL, 4699, 22),
(290232, NULL, 'TIGR01719', NULL, NULL, 'euk_UDPppase: uridine phosphorylase', NULL, 'TIGR01719', NULL, NULL, 6190, 22),
(290233, NULL, 'TIGR03557', NULL, NULL, 'F420_G6P_family: F420-dependent oxidoreductase, G6PDH family', NULL, 'TIGR03557', NULL, NULL, 18342, 22),
(290234, NULL, 'TIGR03367', NULL, NULL, 'queuosine_QueD: queuosine biosynthesis protein QueD', NULL, 'TIGR03367', NULL, NULL, 26, 22);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290235, NULL, 'TIGR01909', NULL, NULL, 'C_GCAxxG_C_C: C_GCAxxG_C_C family protein', NULL, 'TIGR01909', NULL, NULL, 4046, 22),
(290236, NULL, 'TIGR03481', NULL, NULL, 'HpnM: hopanoid biosynthesis associated membrane protein HpnM', NULL, 'TIGR03481', NULL, NULL, 19810, 22),
(290237, NULL, 'TIGR02843', NULL, NULL, 'CyoB: cytochrome o ubiquinol oxidase, subunit I', NULL, 'TIGR02843', NULL, NULL, 9050, 22),
(290238, NULL, 'TIGR00013', NULL, NULL, 'taut: 4-oxalocrotonate tautomerase family enzyme', NULL, 'TIGR00013', NULL, NULL, 19253, 22),
(290239, NULL, 'TIGR01168', NULL, NULL, 'YSIRK_signal: gram-positive signal peptide, YSIRK family', NULL, 'TIGR01168', NULL, NULL, 6752, 22),
(290240, NULL, 'TIGR02963', NULL, NULL, 'xanthine_xdhA: xanthine dehydrogenase, small subunit', NULL, 'TIGR02963', NULL, NULL, 9532, 22),
(290241, NULL, 'TIGR04313', NULL, NULL, 'aro_clust_Mycop: aromatic cluster surface protein', NULL, 'TIGR04313', NULL, NULL, 23195, 22),
(290242, NULL, 'TIGR00993', NULL, NULL, '3a0901s04IAP86: chloroplast protein import component Toc86/159, G and M domains', NULL, 'TIGR00993', NULL, NULL, 3592, 22),
(290243, NULL, 'TIGR01992', NULL, NULL, 'PTS-IIBC-Tre: PTS system, trehalose-specific IIBC component', NULL, 'TIGR01992', NULL, NULL, 10481, 22),
(290244, NULL, 'TIGR02416', NULL, NULL, 'CO_dehy_Mo_lg: carbon-monoxide dehydrogenase, large subunit', NULL, 'TIGR02416', NULL, NULL, 9638, 22),
(290245, NULL, 'TIGR03962', NULL, NULL, 'mycofact_rSAM: mycofactocin radical SAM maturase', NULL, 'TIGR03962', NULL, NULL, 18021, 22),
(290246, NULL, 'TIGR00457', NULL, NULL, 'asnS: asparagine--tRNA ligase', NULL, 'TIGR00457', NULL, NULL, 1805, 22),
(290247, NULL, 'TIGR00873', NULL, NULL, 'gnd: 6-phosphogluconate dehydrogenase (decarboxylating)', NULL, 'TIGR00873', NULL, NULL, 10016, 22),
(290248, NULL, 'TIGR04506', NULL, NULL, 'F_threo_transal: fluorothreonine transaldolase', NULL, 'TIGR04506', NULL, NULL, 24388, 22),
(290249, NULL, 'TIGR00197', NULL, NULL, 'yjeF_nterm: YjeF family N-terminal domain', NULL, 'TIGR00197', NULL, NULL, 7325, 22),
(290250, NULL, 'TIGR03361', NULL, NULL, 'VI_Rhs_Vgr: type VI secretion system Vgr family protein', NULL, 'TIGR03361', NULL, NULL, 12895, 22),
(290251, NULL, 'TIGR03859', NULL, NULL, 'PQQ_PqqD: coenzyme PQQ biosynthesis protein PqqD', NULL, 'TIGR03859', NULL, NULL, 16261, 22),
(290252, NULL, 'TIGR02427', NULL, NULL, 'protocat_pcaD: 3-oxoadipate enol-lactonase', NULL, 'TIGR02427', NULL, NULL, 25220, 22),
(290253, NULL, 'TIGR01157', NULL, NULL, 'pufL: photosynthetic reaction center L subunit', NULL, 'TIGR01157', NULL, NULL, 6803, 22),
(290254, NULL, 'TIGR01400', NULL, NULL, 'fliR: flagellar biosynthetic protein FliR', NULL, 'TIGR01400', NULL, NULL, 4584, 22),
(290255, NULL, 'TIGR01456', NULL, NULL, 'CECR5: HAD hydrolase, TIGR01456 family', NULL, 'TIGR01456', NULL, NULL, 4715, 22),
(290256, NULL, 'TIGR01397', NULL, NULL, 'fliM_switch: flagellar motor switch protein FliM', NULL, 'TIGR01397', NULL, NULL, 3202, 22),
(290257, NULL, 'TIGR03247', NULL, NULL, 'glucar-dehydr: glucarate dehydratase', NULL, 'TIGR03247', NULL, NULL, 17049, 22),
(290258, NULL, 'TIGR00759', NULL, NULL, 'aceE: pyruvate dehydrogenase (acetyl-transferring), homodimeric type', NULL, 'TIGR00759', NULL, NULL, 2846, 22),
(290259, NULL, 'TIGR01216', NULL, NULL, 'ATP_synt_epsi: ATP synthase F1, epsilon subunit', NULL, 'TIGR01216', NULL, NULL, 6132, 22),
(290260, NULL, 'TIGR04025', NULL, NULL, 'PPOX_FMN_DR2398: pyridoxamine 5''-phosphate oxidase, FMN-binding family', NULL, 'TIGR04025', NULL, NULL, 11646, 22),
(290261, NULL, 'TIGR03054', NULL, NULL, 'photo_alph_chp1: putative photosynthetic complex assembly protein', NULL, 'TIGR03054', NULL, NULL, 20754, 22),
(290262, NULL, 'TIGR02770', NULL, NULL, 'nickel_nikD: nickel import ATP-binding protein NikD', NULL, 'TIGR02770', NULL, NULL, 14383, 22),
(290263, NULL, 'TIGR03306', NULL, NULL, 'altF1_A: alternate F1F0 ATPase, F0 subunit A', NULL, 'TIGR03306', NULL, NULL, 17840, 22),
(290264, NULL, 'TIGR00337', NULL, NULL, 'PyrG: CTP synthase', NULL, 'TIGR00337', NULL, NULL, 7211, 22);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290265, NULL, 'TIGR00566', NULL, NULL, 'trpG_papA: glutamine amidotransferase of anthranilate synthase or aminodeoxychorismate synthase', NULL, 'TIGR00566', NULL, NULL, 11310, 22),
(290266, NULL, 'TIGR02368', NULL, NULL, 'dimeth_PyL: dimethylamine:corrinoid methyltransferase', NULL, 'TIGR02368', NULL, NULL, 10092, 22),
(290267, NULL, 'TIGR04497', NULL, NULL, 'GRASP_targ_2: putative ATP-grasp target RiPP', NULL, 'TIGR04497', NULL, NULL, 21980, 22),
(290268, NULL, 'TIGR02656', NULL, NULL, 'cyanin_plasto: plastocyanin', NULL, 'TIGR02656', NULL, NULL, 6187, 22),
(290269, NULL, 'TIGR01213', NULL, NULL, 'pseudo_Pus10arc: tRNA pseudouridine(54/55) synthase', NULL, 'TIGR01213', NULL, NULL, 407, 22),
(290270, NULL, 'TIGR00625', NULL, NULL, 'tfb2: transcription factor Tfb2', NULL, 'TIGR00625', NULL, NULL, 692, 22),
(290271, NULL, 'TIGR01763', NULL, NULL, 'MalateDH_bact: malate dehydrogenase, NAD-dependent', NULL, 'TIGR01763', NULL, NULL, 10124, 22),
(290272, NULL, 'TIGR02248', NULL, NULL, 'mutH_TIGR: DNA mismatch repair endonuclease MutH', NULL, 'TIGR02248', NULL, NULL, 3659, 22),
(290273, NULL, 'TIGR04388', NULL, NULL, 'Lepto_longest: putative large structural protein', NULL, 'TIGR04388', NULL, NULL, 22040, 22),
(290274, NULL, 'TIGR00261', NULL, NULL, 'traB: TraB family protein', NULL, 'TIGR00261', NULL, NULL, 11370, 22),
(290275, NULL, 'TIGR03233', NULL, NULL, 'DNA_S_dndB: DNA sulfur modification protein DndB', NULL, 'TIGR03233', NULL, NULL, 16577, 22),
(290276, NULL, 'TIGR04218', NULL, NULL, 'TOMM_plantaz: ribosomal natural product, plantazolicin-class', NULL, 'TIGR04218', NULL, NULL, 25166, 22),
(290277, NULL, 'TIGR01520', NULL, NULL, 'FruBisAldo_II_A: fructose-bisphosphate aldolase, class II', NULL, 'TIGR01520', NULL, NULL, 5608, 22),
(290278, NULL, 'TIGR01690', NULL, NULL, 'ICE_RAQPRD: integrative conjugative element protein, RAQPRD family', NULL, 'TIGR01690', NULL, NULL, 17517, 22),
(290279, NULL, 'TIGR02902', NULL, NULL, 'spore_lonB: ATP-dependent protease LonB', NULL, 'TIGR02902', NULL, NULL, 11091, 22),
(290280, NULL, 'TIGR01263', NULL, NULL, '4HPPD: 4-hydroxyphenylpyruvate dioxygenase', NULL, 'TIGR01263', NULL, NULL, 283, 22),
(290281, NULL, 'TIGR00639', NULL, NULL, 'PurN: phosphoribosylglycinamide formyltransferase', NULL, 'TIGR00639', NULL, NULL, 957, 22),
(290282, NULL, 'TIGR04145', NULL, NULL, 'Firmicu_CTERM: Firmicu-CTERM domain', NULL, 'TIGR04145', NULL, NULL, 21417, 22),
(290283, NULL, 'TIGR03507', NULL, NULL, 'decahem_SO1788: decaheme c-type cytochrome, OmcA/MtrC family', NULL, 'TIGR03507', NULL, NULL, 17229, 22),
(290284, NULL, 'TIGR04447', NULL, NULL, 'PatC_TenC_TruC: cyanobactin cluster PatC/TenC/TruC protein', NULL, 'TIGR04447', NULL, NULL, 26389, 22),
(290285, NULL, 'TIGR01107', NULL, NULL, 'Na_K_ATPase_bet: Na+/K+ ATPase, beta subunit', NULL, 'TIGR01107', NULL, NULL, 4711, 22),
(290286, NULL, 'TIGR02307', NULL, NULL, 'RNA_lig_RNL2: RNA ligase, Rnl2 family', NULL, 'TIGR02307', NULL, NULL, 10184, 22),
(290287, NULL, 'TIGR02477', NULL, NULL, 'PFKA_PPi: diphosphate--fructose-6-phosphate 1-phosphotransferase', NULL, 'TIGR02477', NULL, NULL, 10691, 22),
(290288, NULL, 'TIGR03979', NULL, NULL, 'His_Ser_Rich: His-Xaa-Ser repeat protein HxsA', NULL, 'TIGR03979', NULL, NULL, 17663, 22),
(290289, NULL, 'TIGR02720', NULL, NULL, 'pyruv_oxi_spxB: pyruvate oxidase', NULL, 'TIGR02720', NULL, NULL, 14088, 22),
(290290, NULL, 'TIGR00077', NULL, NULL, 'lspA: signal peptidase II', NULL, 'TIGR00077', NULL, NULL, 4162, 22),
(290291, NULL, 'TIGR02609', NULL, NULL, 'doc_partner: putative addiction module antidote', NULL, 'TIGR02609', NULL, NULL, 9454, 22),
(290292, NULL, 'TIGR02536', NULL, NULL, 'eut_hyp: ethanolamine utilization protein', NULL, 'TIGR02536', NULL, NULL, 18723, 22),
(290293, NULL, 'TIGR03174', NULL, NULL, 'cas_Csc3: CRISPR type I-D/CYANO-associated protein Csc3/Cas10d', NULL, 'TIGR03174', NULL, NULL, 15809, 22),
(290294, NULL, 'TIGR03540', NULL, NULL, 'DapC_direct: LL-diaminopimelate aminotransferase', NULL, 'TIGR03540', NULL, NULL, 16597, 22),
(290295, NULL, 'TIGR04204', NULL, NULL, 'MAST_ArtA_sort: MAST domain', NULL, 'TIGR04204', NULL, NULL, 23355, 22);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290296, NULL, 'TIGR01277', NULL, NULL, 'thiQ: thiamine ABC transporter, ATP-binding protein', NULL, 'TIGR01277', NULL, NULL, 1279, 22),
(290297, NULL, 'TIGR01048', NULL, NULL, 'lysA: diaminopimelate decarboxylase', NULL, 'TIGR01048', NULL, NULL, 7012, 22),
(290298, NULL, 'TIGR02779', NULL, NULL, 'NHEJ_ligase_lig: DNA ligase D, ligase domain', NULL, 'TIGR02779', NULL, NULL, 14117, 22),
(290299, NULL, 'TIGR01336', NULL, NULL, 'psaB: photosystem I core protein PsaB', NULL, 'TIGR01336', NULL, NULL, 3799, 22),
(290300, NULL, 'TIGR03809', NULL, NULL, 'TIGR03809: TIGR03809 family protein', NULL, 'TIGR03809', NULL, NULL, 15143, 22),
(290301, NULL, 'TIGR01341', NULL, NULL, 'aconitase_1: aconitate hydratase 1', NULL, 'TIGR01341', NULL, NULL, 3829, 22),
(290302, NULL, 'TIGR02273', NULL, NULL, '16S_RimM: 16S rRNA processing protein RimM', NULL, 'TIGR02273', NULL, NULL, 11433, 22),
(290303, NULL, 'TIGR00823', NULL, NULL, 'EIIA-LAC: PTS system, lactose-specific IIa component', NULL, 'TIGR00823', NULL, NULL, 3212, 22),
(290304, NULL, 'TIGR00943', NULL, NULL, '2a6301s02: monovalent cation:proton antiporter', NULL, 'TIGR00943', NULL, NULL, 4306, 22),
(290305, NULL, 'TIGR01358', NULL, NULL, 'DAHP_synth_II: 3-deoxy-7-phosphoheptulonate synthase', NULL, 'TIGR01358', NULL, NULL, 598, 22),
(290306, NULL, 'TIGR02033', NULL, NULL, 'D-hydantoinase: dihydropyrimidinase', NULL, 'TIGR02033', NULL, NULL, 13185, 22),
(290307, NULL, 'TIGR01238', NULL, NULL, 'D1pyr5carbox3: delta-1-pyrroline-5-carboxylate dehydrogenase', NULL, 'TIGR01238', NULL, NULL, 109, 22),
(290308, NULL, 'TIGR02153', NULL, NULL, 'gatD_arch: glutamyl-tRNA(Gln) amidotransferase, subunit D', NULL, 'TIGR02153', NULL, NULL, 8511, 22),
(290309, NULL, 'TIGR02913', NULL, NULL, 'HAF_rpt: probable extracellular repeat, HAF family', NULL, 'TIGR02913', NULL, NULL, 11035, 22),
(290310, NULL, 'TIGR01118', NULL, NULL, 'lacA: galactose-6-phosphate isomerase, LacA subunit', NULL, 'TIGR01118', NULL, NULL, 5182, 22),
(290311, NULL, 'TIGR04123', NULL, NULL, 'P_estr_lig_assc: metallophosphoesterase, DNA ligase-associated', NULL, 'TIGR04123', NULL, NULL, 23333, 22),
(290312, NULL, 'TIGR03328', NULL, NULL, 'salvage_mtnB: methylthioribulose-1-phosphate dehydratase', NULL, 'TIGR03328', NULL, NULL, 17821, 22),
(290313, NULL, 'TIGR04039', NULL, NULL, 'MXAN_0977_Heme2: di-heme enzyme, MXAN_0977 family', NULL, 'TIGR04039', NULL, NULL, 7549, 22),
(290314, NULL, 'TIGR04363', NULL, NULL, 'LD_lanti_pre: FxLD family lantipeptide', NULL, 'TIGR04363', NULL, NULL, 23231, 22),
(290315, NULL, 'TIGR02189', NULL, NULL, 'GlrX-like_plant: glutaredoxin-like family', NULL, 'TIGR02189', NULL, NULL, 12443, 22),
(290316, NULL, 'TIGR00750', NULL, NULL, 'lao: LAO/AO transport system ATPase', NULL, 'TIGR00750', NULL, NULL, 7253, 22),
(290317, NULL, 'TIGR03918', NULL, NULL, 'GTP_HydF: [FeFe] hydrogenase H-cluster maturation GTPase HydF', NULL, 'TIGR03918', NULL, NULL, 16916, 22),
(290318, NULL, 'TIGR00099', NULL, NULL, 'Cof-subfamily: Cof-like hydrolase', NULL, 'TIGR00099', NULL, NULL, 3976, 22),
(290319, NULL, 'TIGR01579', NULL, NULL, 'MiaB-like-C: MiaB-like tRNA modifying enzyme', NULL, 'TIGR01579', NULL, NULL, 6330, 22),
(290320, NULL, 'TIGR03864', NULL, NULL, 'PQQ_ABC_ATP: ABC transporter, ATP-binding subunit, PQQ-dependent alcohol dehydrogenase system', NULL, 'TIGR03864', NULL, NULL, 15943, 22),
(290321, NULL, 'TIGR01699', NULL, NULL, 'XAPA: xanthosine phosphorylase', NULL, 'TIGR01699', NULL, NULL, 1651, 22),
(290322, NULL, 'TIGR02069', NULL, NULL, 'cyanophycinase: cyanophycinase', NULL, 'TIGR02069', NULL, NULL, 13460, 22),
(290323, NULL, 'TIGR03744', NULL, NULL, 'traC_PFL_4706: conjugative transfer ATPase, PFL_4706 family', NULL, 'TIGR03744', NULL, NULL, 15810, 22),
(290324, NULL, 'TIGR04003', NULL, NULL, 'rSAM_BssD: [benzylsuccinate synthase]-activating enzyme', NULL, 'TIGR04003', NULL, NULL, 12615, 22),
(290325, NULL, 'TIGR01774', NULL, NULL, 'PFL2-3: glycyl radical enzyme, PFL2/glycerol dehydratase family', NULL, 'TIGR01774', NULL, NULL, 2201, 22),
(290326, NULL, 'TIGR03448', NULL, NULL, 'mycothiol_MshD: mycothiol synthase', NULL, 'TIGR03448', NULL, NULL, 19182, 22);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290327, NULL, 'TIGR03669', NULL, NULL, 'urea_ABC_arch: urea ABC transporter, substrate-binding protein', NULL, 'TIGR03669', NULL, NULL, 15901, 22),
(290328, NULL, 'TIGR01828', NULL, NULL, 'pyru_phos_dikin: pyruvate, phosphate dikinase', NULL, 'TIGR01828', NULL, NULL, 10902, 22),
(290329, NULL, 'TIGR00988', NULL, NULL, 'hip: integration host factor, beta subunit', NULL, 'TIGR00988', NULL, NULL, 3798, 22),
(290330, NULL, 'TIGR01894', NULL, NULL, 'cas_TM1795_cmr1: CRISPR type III-B/RAMP module RAMP protein Cmr1', NULL, 'TIGR01894', NULL, NULL, 10744, 22),
(290331, NULL, 'TIGR02659', NULL, NULL, 'TTQ_MADH_Lt: methylamine dehydrogenase (amicyanin) light chain', NULL, 'TIGR02659', NULL, NULL, 3719, 22),
(290332, NULL, 'TIGR00569', NULL, NULL, 'ccl1: cyclin ccl1', NULL, 'TIGR00569', NULL, NULL, 25888, 22),
(290333, NULL, 'TIGR01266', NULL, NULL, 'fum_ac_acetase: fumarylacetoacetase', NULL, 'TIGR01266', NULL, NULL, 303, 22),
(290334, NULL, 'TIGR01708', NULL, NULL, 'typeII_sec_gspH: type II secretion system protein H', NULL, 'TIGR01708', NULL, NULL, 6705, 22),
(290335, NULL, 'TIGR03208', NULL, NULL, 'cyc_hxne_CoA_lg: cyclohexanecarboxylate-CoA ligase', NULL, 'TIGR03208', NULL, NULL, 16334, 22),
(290336, NULL, 'TIGR02600', NULL, NULL, 'Verru_Chthon_A: Verru_Chthon cassette protein A', NULL, 'TIGR02600', NULL, NULL, 15792, 22),
(290337, NULL, 'TIGR00183', NULL, NULL, 'prok_nadp_idh: isocitrate dehydrogenase, NADP-dependent', NULL, 'TIGR00183', NULL, NULL, 7459, 22),
(290338, NULL, 'TIGR03984', NULL, NULL, 'TIGR03984: CRISPR-associated protein, TIGR03984 family', NULL, 'TIGR03984', NULL, NULL, 14849, 22),
(290339, NULL, 'TIGR00510', NULL, NULL, 'lipA: lipoyl synthase', NULL, 'TIGR00510', NULL, NULL, 2415, 22),
(290340, NULL, 'TIGR03113', NULL, NULL, 'exosortase_2: exosortase B', NULL, 'TIGR03113', NULL, NULL, 14901, 22),
(290341, NULL, 'TIGR00435', NULL, NULL, 'cysS: cysteine--tRNA ligase', NULL, 'TIGR00435', NULL, NULL, 12788, 22),
(290342, NULL, 'TIGR01143', NULL, NULL, 'murF: UDP-N-acetylmuramoyl-tripeptide--D-alanyl-D-alanine ligase', NULL, 'TIGR01143', NULL, NULL, 6755, 22),
(290343, NULL, 'TIGR01903', NULL, NULL, 'cas5_csm4: CRISPR type III-A/MTUBE-associated RAMP protein Csm4', NULL, 'TIGR01903', NULL, NULL, 833, 22),
(290344, NULL, 'TIGR02645', NULL, NULL, 'ARCH_P_rylase: putative thymidine phosphorylase', NULL, 'TIGR02645', NULL, NULL, 10456, 22),
(290345, NULL, 'TIGR00315', NULL, NULL, 'cdhB: CO dehydrogenase/acetyl-CoA synthase complex, epsilon subunit', NULL, 'TIGR00315', NULL, NULL, 2030, 22),
(290346, NULL, 'TIGR02525', NULL, NULL, 'plasmid_TraJ: plasmid transfer ATPase TraJ', NULL, 'TIGR02525', NULL, NULL, 18686, 22),
(290347, NULL, 'TIGR02591', NULL, NULL, 'cas_Csh1: CRISPR-associated protein Cas8b/Csh1, subtype I-B/HMARI', NULL, 'TIGR02591', NULL, NULL, 9047, 22),
(290348, NULL, 'TIGR02715', NULL, NULL, 'amido_AtzE: amidohydrolase, AtzE family', NULL, 'TIGR02715', NULL, NULL, 14426, 22),
(290349, NULL, 'TIGR02351', NULL, NULL, 'thiH: thiazole biosynthesis protein ThiH', NULL, 'TIGR02351', NULL, NULL, 11514, 22),
(290350, NULL, 'TIGR04561', NULL, NULL, 'membra_charge: integral membrane protein', NULL, 'TIGR04561', NULL, NULL, 23827, 22),
(290351, NULL, 'TIGR00002', NULL, NULL, 'S16: ribosomal protein bS16', NULL, 'TIGR00002', NULL, NULL, 923, 22),
(290352, NULL, 'TIGR01386', NULL, NULL, 'cztS_silS_copS: heavy metal sensor kinase', NULL, 'TIGR01386', NULL, NULL, 3749, 22),
(290353, NULL, 'TIGR00675', NULL, NULL, 'dcm: DNA (cytosine-5-)-methyltransferase', NULL, 'TIGR00675', NULL, NULL, 5274, 22),
(290354, NULL, 'TIGR03492', NULL, NULL, 'TIGR03492: conserved hypothetical protein', NULL, 'TIGR03492', NULL, NULL, 16626, 22),
(290355, NULL, 'TIGR00971', NULL, NULL, '3a0106s03: sulfate ABC transporter, sulfate-binding protein', NULL, 'TIGR00971', NULL, NULL, 3688, 22),
(290356, NULL, 'TIGR04377', NULL, NULL, 'myo_inos_iolD: 3,5/4-trihydroxycyclohexa-1,2-dione hydrolase', NULL, 'TIGR04377', NULL, NULL, 23487, 22),
(290357, NULL, 'TIGR00407', NULL, NULL, 'proA: glutamate-5-semialdehyde dehydrogenase', NULL, 'TIGR00407', NULL, NULL, 241, 22);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290358, NULL, 'TIGR03904', NULL, NULL, 'SAM_YgiQ: uncharacterized radical SAM protein YgiQ', NULL, 'TIGR03904', NULL, NULL, 14517, 22),
(290359, NULL, 'TIGR01654', NULL, NULL, 'bact_immun_7tm: bacteriocin-associated integral membrane protein', NULL, 'TIGR01654', NULL, NULL, 483, 22),
(290360, NULL, 'TIGR01948', NULL, NULL, 'rnfE: electron transport complex, RnfABCDGE type, E subunit', NULL, 'TIGR01948', NULL, NULL, 2475, 22),
(290361, NULL, 'TIGR02167', NULL, NULL, 'Liste_lipo_26: bacterial surface protein 26-residue repeat', NULL, 'TIGR02167', NULL, NULL, 8580, 22),
(290362, NULL, 'TIGR02396', NULL, NULL, 'diverge_rpsU: rpsU-divergently transcribed protein', NULL, 'TIGR02396', NULL, NULL, 9585, 22),
(290363, NULL, 'TIGR03412', NULL, NULL, 'iscX_yfhJ: FeS assembly protein IscX', NULL, 'TIGR03412', NULL, NULL, 10235, 22),
(290364, NULL, 'TIGR00957', NULL, NULL, 'MRP_assoc_pro: multi drug resistance-associated protein (MRP)', NULL, 'TIGR00957', NULL, NULL, 4329, 22),
(290365, NULL, 'TIGR00630', NULL, NULL, 'uvra: excinuclease ABC subunit A', NULL, 'TIGR00630', NULL, NULL, 909, 22),
(290366, NULL, 'TIGR03426', NULL, NULL, 'shape_MreD: rod shape-determining protein MreD', NULL, 'TIGR03426', NULL, NULL, 6855, 22),
(290367, NULL, 'TIGR04338', NULL, NULL, 'HEXXH_Rv0185: putative metallohydrolase, TIGR04338 family', NULL, 'TIGR04338', NULL, NULL, 26589, 22),
(290368, NULL, 'TIGR01640', NULL, NULL, 'F_box_assoc_1: F-box protein interaction domain', NULL, 'TIGR01640', NULL, NULL, 18634, 22),
(290369, NULL, 'TIGR02402', NULL, NULL, 'trehalose_TreZ: malto-oligosyltrehalose trehalohydrolase', NULL, 'TIGR02402', NULL, NULL, 9799, 22),
(290370, NULL, 'TIGR00381', NULL, NULL, 'cdhD: CO dehydrogenase/acetyl-CoA synthase, delta subunit', NULL, 'TIGR00381', NULL, NULL, 1421, 22),
(290371, NULL, 'TIGR02055', NULL, NULL, 'APS_reductase: adenylylsulfate reductase, thioredoxin dependent', NULL, 'TIGR02055', NULL, NULL, 13469, 22),
(290372, NULL, 'TIGR03079', NULL, NULL, 'CH4_NH3mon_ox_B: methane monooxygenase/ammonia monooxygenase, subunit B', NULL, 'TIGR03079', NULL, NULL, 3916, 22),
(290373, NULL, 'TIGR01411', NULL, NULL, 'tatAE: twin arginine-targeting protein translocase, TatA/E family', NULL, 'TIGR01411', NULL, NULL, 4802, 22),
(290374, NULL, 'TIGR00689', NULL, NULL, 'rpiB_lacA_lacB: sugar-phosphate isomerase, RpiB/LacA/LacB family', NULL, 'TIGR00689', NULL, NULL, 6482, 22),
(290375, NULL, 'TIGR01531', NULL, NULL, 'glyc_debranch: glycogen debranching enzyme', NULL, 'TIGR01531', NULL, NULL, 6966, 22),
(290376, NULL, 'TIGR03775', NULL, NULL, 'RPE3: rickettsial palindromic element RPE3 domain', NULL, 'TIGR03775', NULL, NULL, 15981, 22),
(290377, NULL, 'TIGR01651', NULL, NULL, 'CobT: cobaltochelatase, CobT subunit', NULL, 'TIGR01651', NULL, NULL, 115, 22),
(290378, NULL, 'TIGR03621', NULL, NULL, 'F420_MSMEG_2516: probable F420-dependent oxidoreductase, MSMEG_2516 family', NULL, 'TIGR03621', NULL, NULL, 15068, 22),
(290379, NULL, 'TIGR00753', NULL, NULL, 'undec_PP_bacA: undecaprenyl-diphosphatase UppP', NULL, 'TIGR00753', NULL, NULL, 3431, 22),
(290380, NULL, 'TIGR04229', NULL, NULL, 'geopeptide: putative radical SAM-modified peptide', NULL, 'TIGR04229', NULL, NULL, 22961, 22),
(290381, NULL, 'TIGR01104', NULL, NULL, 'V_PPase: V-type H(+)-translocating pyrophosphatase', NULL, 'TIGR01104', NULL, NULL, 2515, 22),
(290382, NULL, 'TIGR02259', NULL, NULL, 'benz_CoA_red_A: benzoyl-CoA reductase, subunit A', NULL, 'TIGR02259', NULL, NULL, 11120, 22),
(290383, NULL, 'TIGR00326', NULL, NULL, 'eubact_ribD: riboflavin biosynthesis protein RibD', NULL, 'TIGR00326', NULL, NULL, 5125, 22),
(290384, NULL, 'TIGR00272', NULL, NULL, 'DPH2: diphthamide biosynthesis protein 2', NULL, 'TIGR00272', NULL, NULL, 5445, 22),
(290385, NULL, 'TIGR02287', NULL, NULL, 'PaaY: phenylacetic acid degradation protein PaaY', NULL, 'TIGR02287', NULL, NULL, 11438, 22),
(290386, NULL, 'TIGR04349', NULL, NULL, 'rSAM_QueE_gams: putative 7-cyano-7-deazaguanosine (preQ0) biosynthesis protein QueE', NULL, 'TIGR04349', NULL, NULL, 23764, 22),
(290387, NULL, 'TIGR01132', NULL, NULL, 'pgm: phosphoglucomutase, alpha-D-glucose phosphate-specific', NULL, 'TIGR01132', NULL, NULL, 6594, 22);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290388, NULL, 'TIGR02362', NULL, NULL, 'dhaK1b: probable dihydroxyacetone kinase DhaK1b subunit', NULL, 'TIGR02362', NULL, NULL, 11859, 22),
(290389, NULL, 'TIGR03119', NULL, NULL, 'one_C_fhcD: formylmethanofuran--tetrahydromethanopterin N-formyltransferase', NULL, 'TIGR03119', NULL, NULL, 18639, 22),
(290390, NULL, 'TIGR01705', NULL, NULL, 'MTA/SAH-nuc-hyp: putative 5''-methylthioadenosine/S-adenosylhomocysteine nucleosidase', NULL, 'TIGR01705', NULL, NULL, 5049, 22),
(290391, NULL, 'TIGR00798', NULL, NULL, 'mtc: tricarboxylate carrier', NULL, 'TIGR00798', NULL, NULL, 3167, 22),
(290392, NULL, 'TIGR02849', NULL, NULL, 'spore_III_AD: stage III sporulation protein AD', NULL, 'TIGR02849', NULL, NULL, 9346, 22),
(290393, NULL, 'TIGR03610', NULL, NULL, 'RutC: pyrimidine utilization protein C', NULL, 'TIGR03610', NULL, NULL, 14788, 22),
(290394, NULL, 'TIGR00019', NULL, NULL, 'prfA: peptide chain release factor 1', NULL, 'TIGR00019', NULL, NULL, 5097, 22),
(290395, NULL, 'TIGR00678', NULL, NULL, 'holB: DNA polymerase III, delta'' subunit', NULL, 'TIGR00678', NULL, NULL, 2055, 22),
(290396, NULL, 'TIGR03850', NULL, NULL, 'bind_CPR_0540: carbohydrate ABC transporter substrate-binding protein, CPR_0540 family', NULL, 'TIGR03850', NULL, NULL, 15855, 22),
(290397, NULL, 'TIGR00392', NULL, NULL, 'ileS: isoleucine--tRNA ligase', NULL, 'TIGR00392', NULL, NULL, 6491, 22),
(290398, NULL, 'TIGR01760', NULL, NULL, 'tape_meas_TP901: phage tail tape measure protein, TP901 family, core region', NULL, 'TIGR01760', NULL, NULL, 2023, 22),
(290399, NULL, 'TIGR04366', NULL, NULL, 'cupin_WbuC: cupin fold metalloprotein, WbuC family', NULL, 'TIGR04366', NULL, NULL, 23405, 22),
(290400, NULL, 'TIGR01252', NULL, NULL, 'acetolac_decarb: alpha-acetolactate decarboxylase', NULL, 'TIGR01252', NULL, NULL, 7486, 22),
(290401, NULL, 'TIGR00982', NULL, NULL, 'uS12_E_A: ribosomal protein uS12', NULL, 'TIGR00982', NULL, NULL, 3722, 22),
(290402, NULL, 'TIGR00206', NULL, NULL, 'fliF: flagellar M-ring protein FliF', NULL, 'TIGR00206', NULL, NULL, 3891, 22),
(290403, NULL, 'TIGR04458', NULL, NULL, 'CYP450_TxtE: 4-nitrotryptophan synthase', NULL, 'TIGR04458', NULL, NULL, 25505, 22),
(290404, NULL, 'TIGR03303', NULL, NULL, 'OM_YaeT: outer membrane protein assembly complex, YaeT protein', NULL, 'TIGR03303', NULL, NULL, 14914, 22),
(290405, NULL, 'TIGR04441', NULL, NULL, 'lept_O_ant_chp1: surface carbohydrate biosynthesis protein', NULL, 'TIGR04441', NULL, NULL, 26234, 22),
(290406, NULL, 'TIGR02471', NULL, NULL, 'sucr_syn_bact_C: sucrose-phosphate synthase, sucrose phosphatase-like domain', NULL, 'TIGR02471', NULL, NULL, 12580, 22),
(290407, NULL, 'TIGR01023', NULL, NULL, 'rpmG_bact: ribosomal protein bL33', NULL, 'TIGR01023', NULL, NULL, 3058, 22),
(290408, NULL, 'TIGR03907', NULL, NULL, 'QH_beta: quinohemoprotein amine dehydrogenase, beta subunit', NULL, 'TIGR03907', NULL, NULL, 9625, 22),
(290409, NULL, 'TIGR01937', NULL, NULL, 'nqrB: NADH:ubiquinone oxidoreductase, Na(+)-translocating, B subunit', NULL, 'TIGR01937', NULL, NULL, 2054, 22),
(290410, NULL, 'TIGR02058', NULL, NULL, 'lin0512_fam: conserved hypothetical protein', NULL, 'TIGR02058', NULL, NULL, 10607, 22),
(290411, NULL, 'TIGR02405', NULL, NULL, 'trehalos_R_Ecol: trehalose operon repressor', NULL, 'TIGR02405', NULL, NULL, 9912, 22),
(290412, NULL, 'TIGR00555', NULL, NULL, 'panK_eukar: pantothenate kinase', NULL, 'TIGR00555', NULL, NULL, 784, 22),
(290413, NULL, 'TIGR03973', NULL, NULL, 'six_Cys_in_45: six-cysteine peptide SCIFF', NULL, 'TIGR03973', NULL, NULL, 11194, 22),
(290414, NULL, 'TIGR01009', NULL, NULL, 'rpsC_bact: ribosomal protein uS3', NULL, 'TIGR01009', NULL, NULL, 3509, 22),
(290415, NULL, 'TIGR04080', NULL, NULL, 'rSAM_pep_cyc: KxxxW cyclic peptide radical SAM maturase', NULL, 'TIGR04080', NULL, NULL, 11614, 22),
(290416, NULL, 'TIGR02044', NULL, NULL, 'CueR: Cu(I)-responsive transcriptional regulator', NULL, 'TIGR02044', NULL, NULL, 13137, 22),
(290417, NULL, 'TIGR02804', NULL, NULL, 'ExbD_2: TonB system transport protein ExbD', NULL, 'TIGR02804', NULL, NULL, 8921, 22);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290418, NULL, 'TIGR02164', NULL, NULL, 'torA: trimethylamine-N-oxide reductase TorA', NULL, 'TIGR02164', NULL, NULL, 8842, 22),
(290419, NULL, 'TIGR03199', NULL, NULL, 'pucC: xanthine dehydrogenase C subunit', NULL, 'TIGR03199', NULL, NULL, 16499, 22),
(290420, NULL, 'TIGR03666', NULL, NULL, 'Rv2061_F420: PPOX class probable F420-dependent enzyme, Rv2061 family', NULL, 'TIGR03666', NULL, NULL, 15793, 22),
(290421, NULL, 'TIGR02511', NULL, NULL, 'type_III_tyeA: type III secretion effector delivery regulator, TyeA family', NULL, 'TIGR02511', NULL, NULL, 18692, 22),
(290422, NULL, 'TIGR03546', NULL, NULL, 'TIGR03546: TIGR03546 family protein', NULL, 'TIGR03546', NULL, NULL, 18339, 22),
(290423, NULL, 'TIGR03317', NULL, NULL, 'ygfZ_signature: folate-binding protein YgfZ', NULL, 'TIGR03317', NULL, NULL, 17837, 22),
(290424, NULL, 'TIGR03102', NULL, NULL, 'halo_cynanin: halocyanin domain', NULL, 'TIGR03102', NULL, NULL, 14923, 22),
(290425, NULL, 'TIGR04000', NULL, NULL, 'thiol_BshB2: bacillithiol biosynthesis deacetylase BshB2', NULL, 'TIGR04000', NULL, NULL, 16852, 22),
(290426, NULL, 'TIGR04257', NULL, NULL, 'nanowire_3heme: c(7)-type cytochrome triheme domain', NULL, 'TIGR04257', NULL, NULL, 24610, 22),
(290427, NULL, 'TIGR01545', NULL, NULL, 'YfhB_g-proteo: HAD hydrolase, family IF', NULL, 'TIGR01545', NULL, NULL, 6778, 22),
(290428, NULL, 'TIGR03789', NULL, NULL, 'pdsO: proteobacterial sortase system peptidoglycan-associated protein', NULL, 'TIGR03789', NULL, NULL, 16387, 22),
(290429, NULL, 'TIGR04472', NULL, NULL, 'reg_rSAM_mob: mobile rSAM pair MarR family regulator', NULL, 'TIGR04472', NULL, NULL, 25654, 22),
(290430, NULL, 'TIGR02242', NULL, NULL, 'tail_TIGR02242: phage tail protein domain', NULL, 'TIGR02242', NULL, NULL, 11641, 22),
(290431, NULL, 'TIGR04486', NULL, NULL, 'thiosulf_SoxB: thiosulfohydrolase SoxB', NULL, 'TIGR04486', NULL, NULL, 21716, 22),
(290432, NULL, 'TIGR01814', NULL, NULL, 'kynureninase: kynureninase', NULL, 'TIGR01814', NULL, NULL, 2098, 22),
(290433, NULL, 'TIGR00862', NULL, NULL, 'O-ClC: intracellular chloride channel protein', NULL, 'TIGR00862', NULL, NULL, 6632, 22),
(290434, NULL, 'TIGR02969', NULL, NULL, 'mam_aldehyde_ox: aldehyde oxidase', NULL, 'TIGR02969', NULL, NULL, 9815, 22),
(290435, NULL, 'TIGR00954', NULL, NULL, '3a01203: peroxysomal long chain fatty acyl transporter', NULL, 'TIGR00954', NULL, NULL, 4462, 22),
(290436, NULL, 'TIGR03501', NULL, NULL, 'GlyGly_CTERM: GlyGly-CTERM domain', NULL, 'TIGR03501', NULL, NULL, 16704, 22),
(290437, NULL, 'TIGR03730', NULL, NULL, 'tungstate_WtpA: tungstate ABC transporter binding protein WtpA', NULL, 'TIGR03730', NULL, NULL, 16040, 22),
(290438, NULL, 'TIGR04014', NULL, NULL, 'B12_SAM_MJ_0865: B12-binding domain/radical SAM domain protein, MJ_0865 family', NULL, 'TIGR04014', NULL, NULL, 11435, 22),
(290439, NULL, 'TIGR04243', NULL, NULL, 'nodulat_NodB: chitooligosaccharide deacetylase NodB', NULL, 'TIGR04243', NULL, NULL, 21276, 22),
(290440, NULL, 'TIGR00312', NULL, NULL, 'cbiD: cobalamin biosynthesis protein CbiD', NULL, 'TIGR00312', NULL, NULL, 3670, 22),
(290441, NULL, 'TIGR01467', NULL, NULL, 'cobI_cbiL: precorrin-2 C(20)-methyltransferase', NULL, 'TIGR01467', NULL, NULL, 5926, 22),
(290442, NULL, 'TIGR01978', NULL, NULL, 'sufC: FeS assembly ATPase SufC', NULL, 'TIGR01978', NULL, NULL, 4082, 22),
(290443, NULL, 'TIGR01601', NULL, NULL, 'PYST-C1: Plasmodium yoelii subtelomeric domain PYST-C1', NULL, 'TIGR01601', NULL, NULL, 6216, 22),
(290444, NULL, 'TIGR03465', NULL, NULL, 'HpnD: squalene synthase HpnD', NULL, 'TIGR03465', NULL, NULL, 19514, 22),
(290445, NULL, 'TIGR00857', NULL, NULL, 'pyrC_multi: dihydroorotase, multifunctional complex type', NULL, 'TIGR00857', NULL, NULL, NULL, 22),
(290446, NULL, 'TIGR02947', NULL, NULL, 'SigH_actino: RNA polymerase sigma-70 factor, TIGR02947 family', NULL, 'TIGR02947', NULL, NULL, 8864, 22),
(290447, NULL, 'TIGR00544', NULL, NULL, 'lgt: prolipoprotein diacylglyceryl transferase', NULL, 'TIGR00544', NULL, NULL, 3232, 22),
(290448, NULL, 'TIGR02634', NULL, NULL, 'xylF: D-xylose ABC transporter, D-xylose-binding protein', NULL, 'TIGR02634', NULL, NULL, 9025, 22);      
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290449, NULL, 'TIGR03392', NULL, NULL, 'FeS_syn_CsdA: cysteine desulfurase, catalytic subunit CsdA', NULL, 'TIGR03392', NULL, NULL, 15770, 22),
(290450, NULL, 'TIGR02552', NULL, NULL, 'LcrH_SycD: type III secretion low calcium response chaperone LcrH/SycD', NULL, 'TIGR02552', NULL, NULL, 7440, 22),
(290451, NULL, 'TIGR00462', NULL, NULL, 'genX: EF-P lysine aminoacylase GenX', NULL, 'TIGR00462', NULL, NULL, 1729, 22),
(290452, NULL, 'TIGR03263', NULL, NULL, 'guanyl_kin: guanylate kinase', NULL, 'TIGR03263', NULL, NULL, 17438, 22),
(290453, NULL, 'TIGR00111', NULL, NULL, 'pelota: mRNA surveillance protein pelota', NULL, 'TIGR00111', NULL, NULL, 5554, 22),
(290454, NULL, 'TIGR02865', NULL, NULL, 'spore_II_E: stage II sporulation protein E', NULL, 'TIGR02865', NULL, NULL, 10925, 22),
(290455, NULL, 'TIGR03152', NULL, NULL, 'cyto_c552_HCOOH: formate-dependent cytochrome c nitrite reductase, c552 subunit', NULL, 'TIGR03152', NULL, NULL, 15697, 22),
(290456, NULL, 'TIGR01472', NULL, NULL, 'gmd: GDP-mannose 4,6-dehydratase', NULL, 'TIGR01472', NULL, NULL, 5537, 22),
(290457, NULL, 'TIGR01923', NULL, NULL, 'menE: O-succinylbenzoate-CoA ligase', NULL, 'TIGR01923', NULL, NULL, 4319, 22),
(290458, NULL, 'TIGR02142', NULL, NULL, 'modC_ABC: molybdate ABC transporter, ATP-binding protein', NULL, 'TIGR02142', NULL, NULL, 13980, 22),
(290459, NULL, 'TIGR02201', NULL, NULL, 'heptsyl_trn_III: putative lipopolysaccharide heptosyltransferase III', NULL, 'TIGR02201', NULL, NULL, 12119, 22),
(290460, NULL, 'TIGR01062', NULL, NULL, 'parC_Gneg: DNA topoisomerase IV, A subunit', NULL, 'TIGR01062', NULL, NULL, NULL, 22),
(290461, NULL, 'TIGR03562', NULL, NULL, 'osmo_induc_OsmC: peroxiredoxin, OsmC subfamily', NULL, 'TIGR03562', NULL, NULL, 18467, 22),
(290462, NULL, 'TIGR04232', NULL, NULL, 'seadorna_VP3: seadornavirus VP3 protein', NULL, 'TIGR04232', NULL, NULL, 22782, 22),
(290463, NULL, 'TIGR01504', NULL, NULL, 'glyox_carbo_lig: glyoxylate carboligase', NULL, 'TIGR01504', NULL, NULL, 5794, 22),
(290464, NULL, 'TIGR03070', NULL, NULL, 'couple_hipB: transcriptional regulator, y4mF family', NULL, 'TIGR03070', NULL, NULL, 21236, 22),
(290465, NULL, 'TIGR02754', NULL, NULL, 'sod_Ni_protease: nickel-type superoxide dismutase maturation protease', NULL, 'TIGR02754', NULL, NULL, 13811, 22),
(290466, NULL, 'TIGR02312', NULL, NULL, 'HpaH: 2-oxo-hepta-3-ene-1,7-dioic acid hydratase', NULL, 'TIGR02312', NULL, NULL, 11798, 22),
(290467, NULL, 'TIGR02924', NULL, NULL, 'ICDH_alpha: isocitrate dehydrogenase', NULL, 'TIGR02924', NULL, NULL, 8532, 22),
(290468, NULL, 'TIGR01914', NULL, NULL, 'cas_Csa4: CRISPR-associated protein Cas8a2/Csa4, subtype I-A/APERN', NULL, 'TIGR01914', NULL, NULL, 4011, 22),
(290469, NULL, 'TIGR00052', NULL, NULL, 'TIGR00052: nudix-type nucleoside diphosphatase, YffH/AdpP family', NULL, 'TIGR00052', NULL, NULL, 5677, 22),
(290470, NULL, 'TIGR04402', NULL, NULL, 'mob_CxxC_CxxC: mobilome CxxCx(11)CxxC protein', NULL, 'TIGR04402', NULL, NULL, 25826, 22),
(290471, NULL, 'TIGR00222', NULL, NULL, 'panB: 3-methyl-2-oxobutanoate hydroxymethyltransferase', NULL, 'TIGR00222', NULL, NULL, 2403, 22),
(290472, NULL, 'TIGR03093', NULL, NULL, 'SASP_sspL: small, acid-soluble spore protein L', NULL, 'TIGR03093', NULL, NULL, 14538, 22),
(290473, NULL, 'TIGR02455', NULL, NULL, 'TreS_stutzeri: trehalose synthase', NULL, 'TIGR02455', NULL, NULL, 10838, 22),
(290474, NULL, 'TIGR03957', NULL, NULL, 'rSAM_HmdB: 5,10-methenyltetrahydromethanopterin hydrogenase cofactor biosynthesis protein HmdB', NULL, 'TIGR03957', NULL, NULL, 17759, 22),
(290475, NULL, 'TIGR00898', NULL, NULL, '2A0119: cation transport protein', NULL, 'TIGR00898', NULL, NULL, 5151, 22),
(290476, NULL, 'TIGR03576', NULL, NULL, 'pyridox_MJ0158: pyridoxal phosphate enzyme, MJ0158 family', NULL, 'TIGR03576', NULL, NULL, 17599, 22),
(290477, NULL, 'TIGR02611', NULL, NULL, 'TIGR02611: TIGR02611 family protein', NULL, 'TIGR02611', NULL, NULL, 9181, 22),
(290478, NULL, 'TIGR03512', NULL, NULL, 'GldD_lipo: gliding motility-associated lipoprotein GldD', NULL, 'TIGR03512', NULL, NULL, 18269, 22);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290479, NULL, 'TIGR02938', NULL, NULL, 'nifL_nitrog: nitrogen fixation negative regulator NifL', NULL, 'TIGR02938', NULL, NULL, 8605, 22),
(290480, NULL, 'TIGR00585', NULL, NULL, 'mutl: DNA mismatch repair protein MutL', NULL, 'TIGR00585', NULL, NULL, 5253, 22),
(290481, NULL, 'TIGR03322', NULL, NULL, 'alt_F1F0_F0_C: alternate F1F0 ATPase, F0 subunit C', NULL, 'TIGR03322', NULL, NULL, 17805, 22),
(290482, NULL, 'TIGR01744', NULL, NULL, 'XPRTase: xanthine phosphoribosyltransferase', NULL, 'TIGR01744', NULL, NULL, 2329, 22),
(290483, NULL, 'TIGR00775', NULL, NULL, 'NhaD: Na+/H+ antiporter, NhaD family', NULL, 'TIGR00775', NULL, NULL, 2651, 22),
(290484, NULL, 'TIGR02768', NULL, NULL, 'TraA_Ti: Ti-type conjugative transfer relaxase TraA', NULL, 'TIGR02768', NULL, NULL, 14165, 22),
(290485, NULL, 'TIGR04162', NULL, NULL, 'exo_VPEID: exosortase E/protease, VPEID-CTERM system', NULL, 'TIGR04162', NULL, NULL, 21109, 22),
(290486, NULL, 'TIGR02089', NULL, NULL, 'TTC: tartrate dehydrogenase', NULL, 'TIGR02089', NULL, NULL, 13914, 22),
(290487, NULL, 'TIGR00421', NULL, NULL, 'ubiX_pad: polyprenyl P-hydroxybenzoate and phenylacrylic acid decarboxylases', NULL, 'TIGR00421', NULL, NULL, 1820, 22),
(290488, NULL, 'TIGR00714', NULL, NULL, 'hscB: Fe-S protein assembly co-chaperone HscB', NULL, 'TIGR00714', NULL, NULL, 2252, 22),
(290489, NULL, 'TIGR00904', NULL, NULL, 'mreB: cell shape determining protein, MreB/Mrl family', NULL, 'TIGR00904', NULL, NULL, 5416, 22),
(290490, NULL, 'TIGR01129', NULL, NULL, 'secD: protein-export membrane protein SecD', NULL, 'TIGR01129', NULL, NULL, 5772, 22),
(290491, NULL, 'TIGR04129', NULL, NULL, 'CxxH_BA5709: CxxH/CxxC protein, BA_5709 family', NULL, 'TIGR04129', NULL, NULL, 24053, 22),
(290492, NULL, 'TIGR04463', NULL, NULL, 'rSAM_vs_C_rich: radical SAM/SPASM domain protein maturase', NULL, 'TIGR04463', NULL, NULL, 25975, 22),
(290493, NULL, 'TIGR02133', NULL, NULL, 'RPI_actino: ribose 5-phosphate isomerase', NULL, 'TIGR02133', NULL, NULL, 13601, 22),
(290494, NULL, 'TIGR02625', NULL, NULL, 'YiiL_rotase: L-rhamnose mutarotase', NULL, 'TIGR02625', NULL, NULL, 9128, 22),
(290495, NULL, 'TIGR01241', NULL, NULL, 'FtsH_fam: ATP-dependent metallopeptidase HflB', NULL, 'TIGR01241', NULL, NULL, 448, 22),
(290496, NULL, 'TIGR02441', NULL, NULL, 'fa_ox_alpha_mit: fatty acid oxidation complex, alpha subunit, mitochondrial', NULL, 'TIGR02441', NULL, NULL, 12595, 22),
(290497, NULL, 'TIGR00603', NULL, NULL, 'rad25: DNA repair helicase rad25', NULL, 'TIGR00603', NULL, NULL, 1265, 22),
(290498, NULL, 'TIGR01431', NULL, NULL, 'adm_rel: adenosine deaminase-related growth factor', NULL, 'TIGR01431', NULL, NULL, 4624, 22),
(290499, NULL, 'TIGR02933', NULL, NULL, 'nifM_nitrog: nitrogen fixation protein NifM', NULL, 'TIGR02933', NULL, NULL, 8909, 22),
(290500, NULL, 'TIGR03898', NULL, NULL, 'lanti_MRSA_kill: type 2 lantibiotic, mersacidin/lichenicidin family', NULL, 'TIGR03898', NULL, NULL, 23703, 22),
(290501, NULL, 'TIGR03635', NULL, NULL, 'uS17_bact: ribosomal protein uS17', NULL, 'TIGR03635', NULL, NULL, 17291, 22),
(290502, NULL, 'TIGR04273', NULL, NULL, 'Y_sulf_Ax21: sulfation-dependent quorum factor, Ax21 family', NULL, 'TIGR04273', NULL, NULL, 24786, 22),
(290503, NULL, 'TIGR01785', NULL, NULL, 'TonB-hemin: TonB-dependent heme/hemoglobin receptor family protein', NULL, 'TIGR01785', NULL, NULL, 10253, 22),
(290504, NULL, 'TIGR02382', NULL, NULL, 'wecD_rffC: TDP-D-fucosamine acetyltransferase', NULL, 'TIGR02382', NULL, NULL, 9565, 22),
(290505, NULL, 'TIGR00093', NULL, NULL, 'TIGR00093: pseudouridine synthase', NULL, 'TIGR00093', NULL, NULL, 4684, 22),
(290506, NULL, 'TIGR00283', NULL, NULL, 'arch_pth2: peptidyl-tRNA hydrolase', NULL, 'TIGR00283', NULL, NULL, 5407, 22),
(290507, NULL, 'TIGR00119', NULL, NULL, 'acolac_sm: acetolactate synthase, small subunit', NULL, 'TIGR00119', NULL, NULL, 5100, 22),
(290508, NULL, 'TIGR03884', NULL, NULL, 'sel_bind_Methan: selenium-binding protein', NULL, 'TIGR03884', NULL, NULL, 18817, 22),
(290509, NULL, 'TIGR02566', NULL, NULL, 'cas_Csy3: CRISPR type I-F/YPEST-associated protein Csy3', NULL, 'TIGR02566', NULL, NULL, 11034, 22);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290510, NULL, 'TIGR04109', NULL, NULL, 'heme_ox_HugZ: heme oxygenase, HugZ family', NULL, 'TIGR04109', NULL, NULL, 25281, 22),
(290511, NULL, 'TIGR00476', NULL, NULL, 'selD: selenide, water dikinase', NULL, 'TIGR00476', NULL, NULL, 1501, 22),
(290512, NULL, 'TIGR00807', NULL, NULL, 'malonate_madL: malonate transporter, MadL subunit', NULL, 'TIGR00807', NULL, NULL, 3128, 22),
(290513, NULL, 'TIGR01928', NULL, NULL, 'menC_lowGC/arch: o-succinylbenzoate synthase', NULL, 'TIGR01928', NULL, NULL, 4278, 22),
(290514, NULL, 'TIGR01445', NULL, NULL, 'intein_Nterm: intein N-terminal splicing region', NULL, 'TIGR01445', NULL, NULL, 10376, 22),
(290515, NULL, 'TIGR03998', NULL, NULL, 'thiol_BshC: bacillithiol biosynthesis cysteine-adding enzyme BshC', NULL, 'TIGR03998', NULL, NULL, 9674, 22),
(290516, NULL, 'TIGR04053', NULL, NULL, 'sam_11: radical SAM protein, BA_1875 family', NULL, 'TIGR04053', NULL, NULL, NULL, 22),
(290517, NULL, 'TIGR00530', NULL, NULL, 'AGP_acyltrn: 1-acylglycerol-3-phosphate O-acyltransferases', NULL, 'TIGR00530', NULL, NULL, 591, 22),
(290518, NULL, 'TIGR03084', NULL, NULL, 'TIGR03084: TIGR03084 family protein', NULL, 'TIGR03084', NULL, NULL, 14590, 22),
(290519, NULL, 'TIGR01685', NULL, NULL, 'MDP-1: magnesium-dependent phosphatase-1', NULL, 'TIGR01685', NULL, NULL, 5183, 22),
(290520, NULL, 'TIGR03535', NULL, NULL, 'DapD_actino: 2,3,4,5-tetrahydropyridine-2,6-dicarboxylate N-succinyltransferase', NULL, 'TIGR03535', NULL, NULL, 16723, 22),
(290521, NULL, 'TIGR04332', NULL, NULL, 'gamma_Glu_sys: poly-gamma-glutamate system protein', NULL, 'TIGR04332', NULL, NULL, 26841, 22),
(290522, NULL, 'TIGR00169', NULL, NULL, 'leuB: 3-isopropylmalate dehydrogenase', NULL, 'TIGR00169', NULL, NULL, 7334, 22),
(290523, NULL, 'TIGR01029', NULL, NULL, 'rpsG_bact: ribosomal protein uS7', NULL, 'TIGR01029', NULL, NULL, 4693, 22),
(290524, NULL, 'TIGR01615', NULL, NULL, 'A_thal_3542: uncharacterized plant-specific domain TIGR01615', NULL, 'TIGR01615', NULL, NULL, 6928, 22),
(290525, NULL, 'TIGR01050', NULL, NULL, 'rpsS_bact: ribosomal protein uS19', NULL, 'TIGR01050', NULL, NULL, 4593, 22),
(290526, NULL, 'TIGR03705', NULL, NULL, 'poly_P_kin: polyphosphate kinase 1', NULL, 'TIGR03705', NULL, NULL, 5349, 22),
(290527, NULL, 'TIGR03453', NULL, NULL, 'partition_RepA: plasmid partitioning protein RepA', NULL, 'TIGR03453', NULL, NULL, 19198, 22),
(290528, NULL, 'TIGR02675', NULL, NULL, 'tape_meas_nterm: tape measure domain', NULL, 'TIGR02675', NULL, NULL, 10085, 22),
(290529, NULL, 'TIGR02482', NULL, NULL, 'PFKA_ATP: 6-phosphofructokinase', NULL, 'TIGR02482', NULL, NULL, 12744, 22),
(290530, NULL, 'TIGR00644', NULL, NULL, 'recJ: single-stranded-DNA-specific exonuclease RecJ', NULL, 'TIGR00644', NULL, NULL, 515, 22),
(290531, NULL, 'TIGR03644', NULL, NULL, 'marine_trans_1: probable ammonium transporter, marine subtype', NULL, 'TIGR03644', NULL, NULL, 18394, 22),
(290532, NULL, 'TIGR01799', NULL, NULL, 'CM_T: chorismate mutase', NULL, 'TIGR01799', NULL, NULL, 10315, 22),
(290533, NULL, 'TIGR00884', NULL, NULL, 'guaA_Cterm: GMP synthase (glutamine-hydrolyzing), C-terminal domain', NULL, 'TIGR00884', NULL, NULL, 3100, 22),
(290534, NULL, 'TIGR02734', NULL, NULL, 'crtI_fam: phytoene desaturase', NULL, 'TIGR02734', NULL, NULL, 14450, 22),
(290535, NULL, 'TIGR03814', NULL, NULL, 'Gln_ase: glutaminase A', NULL, 'TIGR03814', NULL, NULL, 13674, 22),
(290536, NULL, 'TIGR03889', NULL, NULL, 'nitrile_acc: nitrile hydratase accessory protein', NULL, 'TIGR03889', NULL, NULL, 12590, 22),
(290537, NULL, 'TIGR03372', NULL, NULL, 'putres_am_tran: putrescine aminotransferase', NULL, 'TIGR03372', NULL, NULL, 18576, 22),
(290538, NULL, 'TIGR04150', NULL, NULL, 'pseudo_rSAM_GG: pseudo-rSAM protein, GG-Bacteroidales system', NULL, 'TIGR04150', NULL, NULL, 21472, 22),
(290539, NULL, 'TIGR00242', NULL, NULL, 'TIGR00242: division/cell wall cluster transcriptional repressor MraZ', NULL, 'TIGR00242', NULL, NULL, 5375, 22),
(290540, NULL, 'TIGR00474', NULL, NULL, 'selA: L-seryl-tRNA(Sec) selenium transferase', NULL, 'TIGR00474', NULL, NULL, 1855, 22);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290541, NULL, 'TIGR02564', NULL, NULL, 'cas_Csy1: CRISPR type I-F/YPEST-associated protein Csy1', NULL, 'TIGR02564', NULL, NULL, 11299, 22),
(290542, NULL, 'TIGR03342', NULL, NULL, 'dsrC_tusE_dsvC: sulfur relay protein, TusE/DsrC/DsvC family', NULL, 'TIGR03342', NULL, NULL, 4858, 22),
(290543, NULL, 'TIGR01282', NULL, NULL, 'nifD: nitrogenase molybdenum-iron protein alpha chain', NULL, 'TIGR01282', NULL, NULL, 1389, 22),
(290544, NULL, 'TIGR03228', NULL, NULL, 'anthran_1_2_A: anthranilate 1,2-dioxygenase, large subunit', NULL, 'TIGR03228', NULL, NULL, 16821, 22),
(290545, NULL, 'TIGR01308', NULL, NULL, 'rpmD_bact: ribosomal protein uL30', NULL, 'TIGR01308', NULL, NULL, 1445, 22),
(290546, NULL, 'TIGR01855', NULL, NULL, 'IMP_synth_hisH: imidazole glycerol phosphate synthase, glutamine amidotransferase subunit', NULL, 'TIGR01855', NULL, NULL, 10763, 22),
(290547, NULL, 'TIGR00412', NULL, NULL, 'redox_disulf_2: redox-active disulfide protein 2', NULL, 'TIGR00412', NULL, NULL, 11040, 22),
(290548, NULL, 'TIGR01138', NULL, NULL, 'cysM: cysteine synthase B', NULL, 'TIGR01138', NULL, NULL, 6962, 22),
(290549, NULL, 'TIGR00700', NULL, NULL, 'GABAtrnsam: 4-aminobutyrate transaminase', NULL, 'TIGR00700', NULL, NULL, 2285, 22),
(290550, NULL, 'TIGR00521', NULL, NULL, 'coaBC_dfp: phosphopantothenoylcysteine decarboxylase / phosphopantothenate--cysteine ligase', NULL, 'TIGR00521', NULL, NULL, 11359, 22),
(290551, NULL, 'TIGR02661', NULL, NULL, 'MauD: methylamine dehydrogenase accessory protein MauD', NULL, 'TIGR02661', NULL, NULL, 10031, 22),
(290552, NULL, 'TIGR01676', NULL, NULL, 'GLDHase: galactonolactone dehydrogenase', NULL, 'TIGR01676', NULL, NULL, 5034, 22),
(290553, NULL, 'TIGR04100', NULL, NULL, 'rSAM_pair_X: radical SAM enzyme, TIGR04100 family', NULL, 'TIGR04100', NULL, NULL, 9998, 22),
(290554, NULL, 'TIGR04511', NULL, NULL, 'SagB_rel_DH_2: putative peptide maturation dehydrogenase', NULL, 'TIGR04511', NULL, NULL, 25293, 22),
(290555, NULL, 'TIGR03526', NULL, NULL, 'selenium_YgeY: putative selenium metabolism hydrolase', NULL, 'TIGR03526', NULL, NULL, 17587, 22),
(290556, NULL, 'TIGR00365', NULL, NULL, 'TIGR00365: monothiol glutaredoxin, Grx4 family', NULL, 'TIGR00365', NULL, NULL, 7251, 22),
(290557, NULL, 'TIGR02387', NULL, NULL, 'rpoC1_cyan: DNA-directed RNA polymerase, gamma subunit', NULL, 'TIGR02387', NULL, NULL, 9970, 22),
(290558, NULL, 'TIGR03356', NULL, NULL, 'BGL: beta-galactosidase', NULL, 'TIGR03356', NULL, NULL, 18068, 22),
(290559, NULL, 'TIGR00292', NULL, NULL, 'TIGR00292: thiazole biosynthesis enzyme', NULL, 'TIGR00292', NULL, NULL, 6879, 22),
(290560, NULL, 'TIGR03703', NULL, NULL, 'plsB: glycerol-3-phosphate O-acyltransferase', NULL, 'TIGR03703', NULL, NULL, 26305, 22),
(290561, NULL, 'TIGR04164', NULL, NULL, 'cobo_pep: modified peptide precursor CbpA', NULL, 'TIGR04164', NULL, NULL, 21437, 22),
(290562, NULL, 'TIGR00058', NULL, NULL, 'Hemerythrin: hemerythrin family non-heme iron protein', NULL, 'TIGR00058', NULL, NULL, 1104, 22),
(290563, NULL, 'TIGR01232', NULL, NULL, 'lacD: tagatose 1,6-diphosphate aldolase', NULL, 'TIGR01232', NULL, NULL, 224, 22),
(290564, NULL, 'TIGR03219', NULL, NULL, 'salicylate_mono: salicylate 1-monooxygenase', NULL, 'TIGR03219', NULL, NULL, 16875, 22),
(290565, NULL, 'TIGR01173', NULL, NULL, 'glmU: UDP-N-acetylglucosamine diphosphorylase/glucosamine-1-phosphate N-acetyltransferase', NULL, 'TIGR01173', NULL, NULL, 6653, 22),
(290566, NULL, 'TIGR00228', NULL, NULL, 'ruvC: crossover junction endodeoxyribonuclease RuvC', NULL, 'TIGR00228', NULL, NULL, 5021, 22),
(290567, NULL, 'TIGR00653', NULL, NULL, 'GlnA: glutamine synthetase, type I', NULL, 'TIGR00653', NULL, NULL, 4120, 22),
(290568, NULL, 'TIGR02203', NULL, NULL, 'MsbA_lipidA: lipid A export permease/ATP-binding protein MsbA', NULL, 'TIGR02203', NULL, NULL, 12055, 22),
(290569, NULL, 'TIGR01853', NULL, NULL, 'lipid_A_lpxD: UDP-3-O-[3-hydroxymyristoyl] glucosamine N-acyltransferase LpxD', NULL, 'TIGR01853', NULL, NULL, 1402, 22),
(290570, NULL, 'TIGR02491', NULL, NULL, 'NrdG: anaerobic ribonucleoside-triphosphate reductase activating protein', NULL, 'TIGR02491', NULL, NULL, 12866, 22);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290571, NULL, 'TIGR01964', NULL, NULL, 'chpXY: CO2 hydration protein', NULL, 'TIGR01964', NULL, NULL, 4144, 22),
(290572, NULL, 'TIGR02373', NULL, NULL, 'photo_yellow: photoactive yellow protein', NULL, 'TIGR02373', NULL, NULL, 13693, 22),
(290573, NULL, 'TIGR03875', NULL, NULL, 'RNA_lig_partner: RNA ligase partner, MJ_0950 family', NULL, 'TIGR03875', NULL, NULL, 13186, 22),
(290574, NULL, 'TIGR03193', NULL, NULL, '4hydroxCoAred: 4-hydroxybenzoyl-CoA reductase, gamma subunit', NULL, 'TIGR03193', NULL, NULL, 16141, 22),
(290575, NULL, 'TIGR02824', NULL, NULL, 'quinone_pig3: putative NAD(P)H quinone oxidoreductase, PIG3 family', NULL, 'TIGR02824', NULL, NULL, 8618, 22),
(290576, NULL, 'TIGR03049', NULL, NULL, 'PS_I_psaK: photosystem I reaction center subunit PsaK', NULL, 'TIGR03049', NULL, NULL, 20526, 22),
(290577, NULL, 'TIGR00351', NULL, NULL, 'narI: respiratory nitrate reductase, gamma subunit', NULL, 'TIGR00351', NULL, NULL, 3366, 22),
(290578, NULL, 'TIGR03521', NULL, NULL, 'GldG: gliding-associated putative ABC transporter substrate-binding component GldG', NULL, 'TIGR03521', NULL, NULL, 16518, 22),
(290579, NULL, 'TIGR04223', NULL, NULL, 'quorum_AgrD: cyclic lactone autoinducer peptide', NULL, 'TIGR04223', NULL, NULL, 12733, 22),
(290580, NULL, 'TIGR02838', NULL, NULL, 'spore_V_AC: stage V sporulation protein AC', NULL, 'TIGR02838', NULL, NULL, 9227, 22),
(290581, NULL, 'TIGR04341', NULL, NULL, 'target_ACGX: ACGX-repeat peptide', NULL, 'TIGR04341', NULL, NULL, 26900, 22),
(290582, NULL, 'TIGR02019', NULL, NULL, 'BchJ: bacteriochlorophyll 4-vinyl reductase', NULL, 'TIGR02019', NULL, NULL, 5191, 22),
(290583, NULL, 'TIGR00535', NULL, NULL, 'SAM_DCase: S-adenosylmethionine decarboxylase proenzyme', NULL, 'TIGR00535', NULL, NULL, 4703, 22),
(290584, NULL, 'TIGR00666', NULL, NULL, 'PBP4: D-alanyl-D-alanine carboxypeptidase/D-alanyl-D-alanine-endopeptidase', NULL, 'TIGR00666', NULL, NULL, 6756, 22),
(290585, NULL, 'TIGR03671', NULL, NULL, 'cca_archaeal: CCA-adding enzyme', NULL, 'TIGR03671', NULL, NULL, 673, 22),
(290586, NULL, 'TIGR01635', NULL, NULL, 'tail_comp_S: phage virion morphogenesis protein', NULL, 'TIGR01635', NULL, NULL, 55, 22),
(290587, NULL, 'TIGR02756', NULL, NULL, 'TraK_Ftype: type-F conjugative transfer system secretin TraK', NULL, 'TIGR02756', NULL, NULL, 13512, 22),
(290588, NULL, 'TIGR03431', NULL, NULL, 'PhnD: phosphonate ABC transporter, periplasmic phosphonate binding protein', NULL, 'TIGR03431', NULL, NULL, 19100, 22),
(290589, NULL, 'TIGR01581', NULL, NULL, 'Mo_ABC_porter: NifC-like ABC-type porter', NULL, 'TIGR01581', NULL, NULL, 6012, 22),
(290590, NULL, 'TIGR03725', NULL, NULL, 'T6A_YeaZ: tRNA threonylcarbamoyl adenosine modification protein YeaZ', NULL, 'TIGR03725', NULL, NULL, 16132, 22),
(290591, NULL, 'TIGR04436', NULL, NULL, 'SpoChoClust_3: putative 2OG-Fe(II) oxygenase', NULL, 'TIGR04436', NULL, NULL, 25337, 22),
(290592, NULL, 'TIGR04279', NULL, NULL, 'TIGR04279: TIGR04279 domain', NULL, 'TIGR04279', NULL, NULL, 23497, 22),
(290593, NULL, 'TIGR02346', NULL, NULL, 'chap_CCT_theta: T-complex protein 1, theta subunit', NULL, 'TIGR02346', NULL, NULL, 11578, 22),
(290594, NULL, 'TIGR01322', NULL, NULL, 'scrB_fam: sucrose-6-phosphate hydrolase', NULL, 'TIGR01322', NULL, NULL, 11068, 22),
(290595, NULL, 'TIGR00256', NULL, NULL, 'TIGR00256: D-tyrosyl-tRNA(Tyr) deacylase', NULL, 'TIGR00256', NULL, NULL, 2046, 22),
(290596, NULL, 'TIGR01805', NULL, NULL, 'CM_mono_grmpos: chorismate mutase', NULL, 'TIGR01805', NULL, NULL, 10050, 22),
(290597, NULL, 'TIGR02550', NULL, NULL, 'flagell_flgL: flagellar hook-associated protein 3', NULL, 'TIGR02550', NULL, NULL, 11227, 22),
(290598, NULL, 'TIGR02516', NULL, NULL, 'type_III_yscC: type III secretion outer membrane pore, YscC/HrcC family', NULL, 'TIGR02516', NULL, NULL, 6223, 22),
(290599, NULL, 'TIGR03261', NULL, NULL, 'phnS2: putative 2-aminoethylphosphonate ABC transporter, periplasmic 2-aminoethylphosphonate-binding protein', NULL, 'TIGR03261', NULL, NULL, 17499, 22),
(290600, NULL, 'TIGR00426', NULL, NULL, 'TIGR00426: competence protein ComEA helix-hairpin-helix repeat region', NULL, 'TIGR00426', NULL, NULL, 1826, 22); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290601, NULL, 'TIGR03015', NULL, NULL, 'pepcterm_ATPase: putative secretion ATPase, PEP-CTERM locus subfamily', NULL, 'TIGR03015', NULL, NULL, 20852, 22),
(290602, NULL, 'TIGR02005', NULL, NULL, 'PTS-IIBC-alpha: PTS system, alpha-glucoside-specific IIBC component', NULL, 'TIGR02005', NULL, NULL, 2309, 22),
(290603, NULL, 'TIGR00694', NULL, NULL, 'thiM: hydroxyethylthiazole kinase', NULL, 'TIGR00694', NULL, NULL, 6810, 22),
(290604, NULL, 'TIGR03297', NULL, NULL, 'Ppyr-DeCO2ase: phosphonopyruvate decarboxylase', NULL, 'TIGR03297', NULL, NULL, 17783, 22),
(290605, NULL, 'TIGR02292', NULL, NULL, 'ygfB_yecA: yecA family protein', NULL, 'TIGR02292', NULL, NULL, 13124, 22),
(290606, NULL, 'TIGR02784', NULL, NULL, 'addA_alphas: double-strand break repair helicase AddA', NULL, 'TIGR02784', NULL, NULL, 14416, 22),
(290607, NULL, 'TIGR03800', NULL, NULL, 'PLP_synth_Pdx2: pyridoxal 5''-phosphate synthase, glutaminase subunit Pdx2', NULL, 'TIGR03800', NULL, NULL, 5189, 22),
(290608, NULL, 'TIGR01377', NULL, NULL, 'soxA_mon: sarcosine oxidase, monomeric form', NULL, 'TIGR01377', NULL, NULL, 3931, 22),
(290609, NULL, 'TIGR04382', NULL, NULL, 'myo_inos_iolC_N: 5-dehydro-2-deoxygluconokinase', NULL, 'TIGR04382', NULL, NULL, 23543, 22),
(290610, NULL, 'TIGR00952', NULL, NULL, 'S15_bact: ribosomal protein uS15', NULL, 'TIGR00952', NULL, NULL, 4167, 22),
(290611, NULL, 'TIGR03467', NULL, NULL, 'HpnE: squalene-associated FAD-dependent desaturase', NULL, 'TIGR03467', NULL, NULL, 19888, 22),
(290612, NULL, 'TIGR04114', NULL, NULL, 'tSAM_targ_Cxxx: modification target Cys-rich repeat', NULL, 'TIGR04114', NULL, NULL, 22726, 22),
(290613, NULL, 'TIGR01000', NULL, NULL, 'bacteriocin_acc: bacteriocin secretion accessory protein', NULL, 'TIGR01000', NULL, NULL, 3759, 22),
(290614, NULL, 'TIGR00278', NULL, NULL, 'TIGR00278: putative membrane protein insertion efficiency factor', NULL, 'TIGR00278', NULL, NULL, 3956, 22),
(290615, NULL, 'TIGR03283', NULL, NULL, 'thy_syn_methano: thymidylate synthase, methanogen type', NULL, 'TIGR03283', NULL, NULL, 9975, 22),
(290616, NULL, 'TIGR02421', NULL, NULL, 'QEGLA: conserved hypothetical protein', NULL, 'TIGR02421', NULL, NULL, 10457, 22),
(290617, NULL, 'TIGR00571', NULL, NULL, 'dam: DNA adenine methylase', NULL, 'TIGR00571', NULL, NULL, 11638, 22),
(290618, NULL, 'TIGR01247', NULL, NULL, 'drrB: daunorubicin resistance ABC transporter membrane protein', NULL, 'TIGR01247', NULL, NULL, 245, 22),
(290619, NULL, 'TIGR02264', NULL, NULL, 'gmx_para_CXXCG: Myxococcus xanthus double-CXXCG motif paralogous family', NULL, 'TIGR02264', NULL, NULL, 11574, 22),
(290620, NULL, 'TIGR02802', NULL, NULL, 'Pal_lipo: peptidoglycan-associated lipoprotein', NULL, 'TIGR02802', NULL, NULL, 8704, 22),
(290621, NULL, 'TIGR03630', NULL, NULL, 'uS17_arch: ribosomal protein uS17', NULL, 'TIGR03630', NULL, NULL, 21735, 22),
(290622, NULL, 'TIGR04477', NULL, NULL, 'sorted_by_XrtN: XrtN system VIT domain protein', NULL, 'TIGR04477', NULL, NULL, 25011, 22),
(290623, NULL, 'TIGR03923', NULL, NULL, 'T7SS_EccE: type VII secretion protein EccE', NULL, 'TIGR03923', NULL, NULL, 18257, 22),
(290624, NULL, 'TIGR03766', NULL, NULL, 'TIGR03766: conserved hypothetical integral membrane protein', NULL, 'TIGR03766', NULL, NULL, 16037, 22),
(290625, NULL, 'TIGR01300', NULL, NULL, 'CPA3_mnhG_phaG: monovalent cation/proton antiporter, MnhG/PhaG subunit', NULL, 'TIGR01300', NULL, NULL, 7013, 22),
(290626, NULL, 'TIGR02148', NULL, NULL, 'Fibro_Slime: fibro-slime domain', NULL, 'TIGR02148', NULL, NULL, 14083, 22),
(290627, NULL, 'TIGR02899', NULL, NULL, 'spore_safA: spore coat assembly protein SafA', NULL, 'TIGR02899', NULL, NULL, 11042, 22),
(290628, NULL, 'TIGR02074', NULL, NULL, 'PBP_1a_fam: penicillin-binding protein, 1A family', NULL, 'TIGR02074', NULL, NULL, NULL, 22),
(290629, NULL, 'TIGR02318', NULL, NULL, 'phosphono_phnM: phosphonate metabolism protein PhnM', NULL, 'TIGR02318', NULL, NULL, 11539, 22),
(290630, NULL, 'TIGR01417', NULL, NULL, 'PTS_I_fam: phosphoenolpyruvate-protein phosphotransferase', NULL, 'TIGR01417', NULL, NULL, 4874, 22);               
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290631, NULL, 'TIGR02128', NULL, NULL, 'G6PI_arch: bifunctional phosphoglucose/phosphomannose isomerase', NULL, 'TIGR02128', NULL, NULL, NULL, 22),
(290632, NULL, 'TIGR00113', NULL, NULL, 'queA: S-adenosylmethionine:tRNA ribosyltransferase-isomerase', NULL, 'TIGR00113', NULL, NULL, 6366, 22),
(290633, NULL, 'TIGR01758', NULL, NULL, 'MDH_euk_cyt: malate dehydrogenase, NAD-dependent', NULL, 'TIGR01758', NULL, NULL, 9648, 22),
(290634, NULL, 'TIGR03099', NULL, NULL, 'dCO2ase_PEP1: pyridoxal-dependent decarboxylase, exosortase A system-associated', NULL, 'TIGR03099', NULL, NULL, 14984, 22),
(290635, NULL, 'TIGR00938', NULL, NULL, 'thrB_alt: homoserine kinase', NULL, 'TIGR00938', NULL, NULL, 4258, 22),
(290636, NULL, 'TIGR02251', NULL, NULL, 'HIF-SF_euk: dullard-like phosphatase domain', NULL, 'TIGR02251', NULL, NULL, 11293, 22),
(290637, NULL, 'TIGR01595', NULL, NULL, 'cas_CT1132: CRISPR-associated protein, CT1132 family', NULL, 'TIGR01595', NULL, NULL, 6331, 22),
(290638, NULL, 'TIGR02094', NULL, NULL, 'more_P_ylases: alpha-glucan phosphorylases', NULL, 'TIGR02094', NULL, NULL, 13706, 22),
(290639, NULL, 'TIGR02586', NULL, NULL, 'cas5_cmx5_devS: CRISPR-associated protein Cas5/DevS, subtype MYXAN', NULL, 'TIGR02586', NULL, NULL, 9144, 22),
(290640, NULL, 'TIGR03269', NULL, NULL, 'met_CoM_red_A2: methyl coenzyme M reductase system, component A2', NULL, 'TIGR03269', NULL, NULL, 17342, 22),
(290641, NULL, 'TIGR03596', NULL, NULL, 'GTPase_YlqF: ribosome biogenesis GTP-binding protein YlqF', NULL, 'TIGR03596', NULL, NULL, 11615, 22),
(290642, NULL, 'TIGR00748', NULL, NULL, 'HMG_CoA_syn_Arc: putative hydroxymethylglutaryl-CoA synthase', NULL, 'TIGR00748', NULL, NULL, 2756, 22),
(290643, NULL, 'TIGR03753', NULL, NULL, 'blh_monoox: beta-carotene 15,15''-monooxygenase, Brp/Blh family', NULL, 'TIGR03753', NULL, NULL, 15171, 22),
(290644, NULL, 'TIGR03943', NULL, NULL, 'TIGR03943: TIGR03943 family protein', NULL, 'TIGR03943', NULL, NULL, 14075, 22),
(290645, NULL, 'TIGR00918', NULL, NULL, '2A060602: transmembrane receptor Patched', NULL, 'TIGR00918', NULL, NULL, 5323, 22),
(290646, NULL, 'TIGR01123', NULL, NULL, 'ilvE_II: branched-chain amino acid aminotransferase', NULL, 'TIGR01123', NULL, NULL, 5921, 22),
(290647, NULL, 'TIGR01254', NULL, NULL, 'sfuA: ABC transporter periplasmic binding protein, thiB subfamily', NULL, 'TIGR01254', NULL, NULL, 207, 22),
(290648, NULL, 'TIGR00133', NULL, NULL, 'gatB: aspartyl/glutamyl-tRNA(Asn/Gln) amidotransferase, B subunit', NULL, 'TIGR00133', NULL, NULL, 5859, 22),
(290649, NULL, 'TIGR04293', NULL, NULL, 'archaeo_artF: archaeosortase family protein ArtF', NULL, 'TIGR04293', NULL, NULL, 26563, 22),
(290650, NULL, 'TIGR04347', NULL, NULL, 'pseudo_SAM_Halo: pseudo-rSAM protein/SPASM domain protein', NULL, 'TIGR04347', NULL, NULL, 22796, 22),
(290651, NULL, 'TIGR02223', NULL, NULL, 'ftsN: cell division protein FtsN', NULL, 'TIGR02223', NULL, NULL, 11166, 22),
(290652, NULL, 'TIGR02360', NULL, NULL, 'pbenz_hydroxyl: 4-hydroxybenzoate 3-monooxygenase', NULL, 'TIGR02360', NULL, NULL, 11806, 22),
(290653, NULL, 'TIGR01288', NULL, NULL, 'nodI: nodulation ABC transporter NodI', NULL, 'TIGR01288', NULL, NULL, 1170, 22),
(290654, NULL, 'TIGR03378', NULL, NULL, 'glycerol3P_GlpB: glycerol-3-phosphate dehydrogenase, anaerobic, B subunit', NULL, 'TIGR03378', NULL, NULL, 9827, 22),
(290655, NULL, 'TIGR00270', NULL, NULL, 'TIGR00270: TIGR00270 family protein', NULL, 'TIGR00270', NULL, NULL, 7442, 22),
(290656, NULL, 'TIGR04089', NULL, NULL, 'exp_by_SipW_III: alternate signal-mediated exported protein, RER_14450 family', NULL, 'TIGR04089', NULL, NULL, 15680, 22),
(290657, NULL, 'TIGR01391', NULL, NULL, 'dnaG: DNA primase', NULL, 'TIGR01391', NULL, NULL, 3713, 22),
(290658, NULL, 'TIGR00680', NULL, NULL, 'kdpA: K+-transporting ATPase, A subunit', NULL, 'TIGR00680', NULL, NULL, 2414, 22),
(290659, NULL, 'TIGR00734', NULL, NULL, 'hisAF_rel: hisA/hisF family protein', NULL, 'TIGR00734', NULL, NULL, 2634, 22),
(290660, NULL, 'TIGR01889', NULL, NULL, 'Staph_reg_Sar: staphylococcal accessory regulator family', NULL, 'TIGR01889', NULL, NULL, 10590, 22);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290661, NULL, 'TIGR00303', NULL, NULL, 'TIGR00303: TIGR00303 family protein', NULL, 'TIGR00303', NULL, NULL, 4994, 22),
(290662, NULL, 'TIGR03104', NULL, NULL, 'trio_amidotrans: asparagine synthase family amidotransferase', NULL, 'TIGR03104', NULL, NULL, 14530, 22),
(290663, NULL, 'TIGR04517', NULL, NULL, 'rSAM_PoyD: radical SAM family RiPP maturation amino acid epimerase', NULL, 'TIGR04517', NULL, NULL, 25074, 22),
(290664, NULL, 'TIGR03487', NULL, NULL, 'cas_csp2: CRISPR-associated protein Cas8c/Csp2, subtype PGING', NULL, 'TIGR03487', NULL, NULL, 17582, 22),
(290665, NULL, 'TIGR04422', NULL, NULL, 'PLP_IMCC1989: putative PLP-dependent aminotransferase', NULL, 'TIGR04422', NULL, NULL, 24683, 22),
(290666, NULL, 'TIGR02974', NULL, NULL, 'phageshock_pspF: psp operon transcriptional activator', NULL, 'TIGR02974', NULL, NULL, 9509, 22),
(290667, NULL, 'TIGR03739', NULL, NULL, 'PRTRC_D: PRTRC system protein D', NULL, 'TIGR03739', NULL, NULL, 15679, 22),
(290668, NULL, 'TIGR01554', NULL, NULL, 'major_cap_HK97: phage major capsid protein, HK97 family', NULL, 'TIGR01554', NULL, NULL, 21899, 22),
(290669, NULL, 'TIGR02332', NULL, NULL, 'HpaX: 4-hydroxyphenylacetate permease', NULL, 'TIGR02332', NULL, NULL, 11653, 22),
(290670, NULL, 'TIGR01724', NULL, NULL, 'hmd_rel: H2-forming N(5),N(10)-methenyltetrahydromethanopterin dehydrogenase-related protein', NULL, 'TIGR01724', NULL, NULL, 6473, 22),
(290671, NULL, 'TIGR03657', NULL, NULL, 'IsdB: heme uptake protein IsdB', NULL, 'TIGR03657', NULL, NULL, 18172, 22),
(290672, NULL, 'TIGR01649', NULL, NULL, 'hnRNP-L_PTB: hnRNP-L/PTB/hephaestus splicing factor family', NULL, 'TIGR01649', NULL, NULL, 21, 22),
(290673, NULL, 'TIGR02060', NULL, NULL, 'aprB: adenylylsulfate reductase, beta subunit', NULL, 'TIGR02060', NULL, NULL, 13239, 22),
(290674, NULL, 'TIGR03794', NULL, NULL, 'NHLM_micro_HlyD: NHLM bacteriocin system secretion protein', NULL, 'TIGR03794', NULL, NULL, 15004, 22),
(290675, NULL, 'TIGR02502', NULL, NULL, 'type_III_YscX: type III secretion protein, YscX family', NULL, 'TIGR02502', NULL, NULL, 12575, 22),
(290676, NULL, 'TIGR00789', NULL, NULL, 'flhB_rel: FlhB domain protein', NULL, 'TIGR00789', NULL, NULL, 3162, 22),
(290677, NULL, 'TIGR03909', NULL, NULL, 'pyrrolys_PylC: pyrrolysine biosynthesis protein PylC', NULL, 'TIGR03909', NULL, NULL, 8397, 22),
(290678, NULL, 'TIGR01819', NULL, NULL, 'F420_cofD: 2-phospho-L-lactate transferase', NULL, 'TIGR01819', NULL, NULL, 10733, 22),
(290679, NULL, 'TIGR00331', NULL, NULL, 'hrcA: heat-inducible transcription repressor HrcA', NULL, 'TIGR00331', NULL, NULL, 1793, 22),
(290680, NULL, 'TIGR01833', NULL, NULL, 'HMG-CoA-S_euk: hydroxymethylglutaryl-CoA synthase', NULL, 'TIGR01833', NULL, NULL, 10526, 22),
(290681, NULL, 'TIGR02509', NULL, NULL, 'type_III_yopR: type III secretion effector, YopR family', NULL, 'TIGR02509', NULL, NULL, 18884, 22),
(290682, NULL, 'TIGR04491', NULL, NULL, 'reactive_PduG: diol dehydratase reactivase alpha subunit', NULL, 'TIGR04491', NULL, NULL, 9915, 22),
(290683, NULL, 'TIGR00038', NULL, NULL, 'efp: translation elongation factor P', NULL, 'TIGR00038', NULL, NULL, 10038, 22),
(290684, NULL, 'TIGR04545', NULL, NULL, 'rSAM_ahbD_hemeb: heme b synthase', NULL, 'TIGR04545', NULL, NULL, 25030, 22),
(290685, NULL, 'TIGR01007', NULL, NULL, 'eps_fam: capsular exopolysaccharide family', NULL, 'TIGR01007', NULL, NULL, 3527, 22),
(290686, NULL, 'TIGR02695', NULL, NULL, 'azurin: azurin', NULL, 'TIGR02695', NULL, NULL, 13155, 22),
(290687, NULL, 'TIGR01486', NULL, NULL, 'HAD-SF-IIB-MPGP: mannosyl-3-phosphoglycerate phosphatase family', NULL, 'TIGR01486', NULL, NULL, 5994, 22),
(290688, NULL, 'TIGR04198', NULL, NULL, 'paramyx_RNAcap: mRNA capping enzyme', NULL, 'TIGR04198', NULL, NULL, 27670, 22),
(290689, NULL, 'TIGR00659', NULL, NULL, 'TIGR00659: TIGR00659 family protein', NULL, 'TIGR00659', NULL, NULL, 4466, 22),
(290690, NULL, 'TIGR04354', NULL, NULL, 'amphi-Trp: amphi-Trp domain', NULL, 'TIGR04354', NULL, NULL, 23495, 22),
(290691, NULL, 'TIGR01540', NULL, NULL, 'portal_PBSX: phage portal protein, PBSX family', NULL, 'TIGR01540', NULL, NULL, 6668, 22);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290692, NULL, 'TIGR00966', NULL, NULL, '3a0501s07: protein-export membrane protein SecF', NULL, 'TIGR00966', NULL, NULL, 3809, 22),
(290693, NULL, 'TIGR01193', NULL, NULL, 'bacteriocin_ABC: ABC-type bacteriocin transporter', NULL, 'TIGR01193', NULL, NULL, 6877, 22),
(290694, NULL, 'TIGR03043', NULL, NULL, 'PS_II_psbZ: photosystem II core protein PsbZ', NULL, 'TIGR03043', NULL, NULL, 2813, 22),
(290695, NULL, 'TIGR04238', NULL, NULL, 'seadorna_dsRNA: seadornavirus double-stranded RNA-binding protein', NULL, 'TIGR04238', NULL, NULL, 22546, 22),
(290696, NULL, 'TIGR02988', NULL, NULL, 'YaaA_near_RecF: S4 domain protein YaaA', NULL, 'TIGR02988', NULL, NULL, 10033, 22),
(290697, NULL, 'TIGR01710', NULL, NULL, 'typeII_sec_gspG: type II secretion system protein G', NULL, 'TIGR01710', NULL, NULL, 5173, 22),
(290698, NULL, 'TIGR03834', NULL, NULL, 'EAGR_box: EAGR box', NULL, 'TIGR03834', NULL, NULL, 15543, 22),
(290699, NULL, 'TIGR04408', NULL, NULL, 'LptG_lptG: LPS export ABC transporter permease LptG', NULL, 'TIGR04408', NULL, NULL, 24329, 22),
(290700, NULL, 'TIGR03029', NULL, NULL, 'EpsG: chain length determinant protein tyrosine kinase EpsG', NULL, 'TIGR03029', NULL, NULL, 20873, 22),
(290701, NULL, 'TIGR01363', NULL, NULL, 'strep_his_triad: streptococcal histidine triad protein', NULL, 'TIGR01363', NULL, NULL, 17792, 22),
(290702, NULL, 'TIGR00829', NULL, NULL, 'FRU: PTS system, Fru family, IIB component', NULL, 'TIGR00829', NULL, NULL, 4429, 22),
(290703, NULL, 'TIGR03213', NULL, NULL, '23dbph12diox: 2,3-dihydroxybiphenyl 1,2-dioxygenase', NULL, 'TIGR03213', NULL, NULL, 16511, 22),
(290704, NULL, 'TIGR01663', NULL, NULL, 'PNK-3''Pase: polynucleotide kinase 3''-phosphatase', NULL, 'TIGR01663', NULL, NULL, 181, 22),
(290705, NULL, 'TIGR02039', NULL, NULL, 'CysD: sulfate adenylyltransferase, small subunit', NULL, 'TIGR02039', NULL, NULL, 13281, 22),
(290706, NULL, 'TIGR04368', NULL, NULL, 'Glu_2_3_NH3_mut: glutamate 2,3-aminomutase', NULL, 'TIGR04368', NULL, NULL, 26285, 22),
(290707, NULL, 'TIGR02183', NULL, NULL, 'GRXA: glutaredoxin, GrxA family', NULL, 'TIGR02183', NULL, NULL, 12150, 22),
(290708, NULL, 'TIGR03685', NULL, NULL, 'ribo_P1_arch: 50S ribosomal protein P1', NULL, 'TIGR03685', NULL, NULL, 15073, 22),
(290709, NULL, 'TIGR00496', NULL, NULL, 'frr: ribosome recycling factor', NULL, 'TIGR00496', NULL, NULL, 2767, 22),
(290710, NULL, 'TIGR01670', NULL, NULL, 'KdsC-phosphatas: 3-deoxy-D-manno-octulosonate 8-phosphate phosphatase, YrbI family', NULL, 'TIGR01670', NULL, NULL, 5088, 22),
(290711, NULL, 'TIGR01998', NULL, NULL, 'PTS-II-BC-nag: PTS system, N-acetylglucosamine-specific IIBC component', NULL, 'TIGR01998', NULL, NULL, 2456, 22),
(290712, NULL, 'TIGR00161', NULL, NULL, 'TIGR00161: TIGR00161 family protein', NULL, 'TIGR00161', NULL, NULL, 7430, 22),
(290713, NULL, 'TIGR00843', NULL, NULL, 'benE: benzoate transporter', NULL, 'TIGR00843', NULL, NULL, 3429, 22),
(290714, NULL, 'TIGR02530', NULL, NULL, 'flg_new: flagellar operon protein', NULL, 'TIGR02530', NULL, NULL, 18955, 22),
(290715, NULL, 'TIGR01179', NULL, NULL, 'galE: UDP-glucose 4-epimerase GalE', NULL, 'TIGR01179', NULL, NULL, 6595, 22),
(290716, NULL, 'TIGR04184', NULL, NULL, 'ATPgraspMvdD: ATP-grasp ribosomal peptide maturase, MvdD family', NULL, 'TIGR04184', NULL, NULL, 23121, 22),
(290717, NULL, 'TIGR03848', NULL, NULL, 'MSMEG_4193: probable phosphomutase, MSMEG_4193 family', NULL, 'TIGR03848', NULL, NULL, 16153, 22),
(290718, NULL, 'TIGR01526', NULL, NULL, 'nadR_NMN_Atrans: nicotinamide-nucleotide adenylyltransferase', NULL, 'TIGR01526', NULL, NULL, 6748, 22),
(290719, NULL, 'TIGR04531', NULL, NULL, 'nonproteo_OH: putative nonproteinogenic amino acid hydroxylase', NULL, 'TIGR04531', NULL, NULL, 25429, 22),
(290720, NULL, 'TIGR02209', NULL, NULL, 'ftsL_broad: cell division protein FtsL', NULL, 'TIGR02209', NULL, NULL, 11308, 22),
(290721, NULL, 'TIGR00024', NULL, NULL, 'SbcD_rel_arch: putative phosphoesterase', NULL, 'TIGR00024', NULL, NULL, 5642, 22),
(290722, NULL, 'TIGR02067', NULL, NULL, 'his_9_HisN: histidinol-phosphatase', NULL, 'TIGR02067', NULL, NULL, 13180, 22); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290723, NULL, 'TIGR03759', NULL, NULL, 'conj_TIGR03759: integrating conjugative element protein, PFL_4693 family', NULL, 'TIGR03759', NULL, NULL, 15034, 22),
(290724, NULL, 'TIGR04277', NULL, NULL, 'squa_tetra_cyc: tetrahymanol synthase', NULL, 'TIGR04277', NULL, NULL, 24759, 22),
(290725, NULL, 'TIGR01549', NULL, NULL, 'HAD-SF-IA-v1: HAD hydrolase, family IA, variant 1', NULL, 'TIGR01549', NULL, NULL, 6934, 22),
(290726, NULL, 'TIGR01669', NULL, NULL, 'phage_XkdX: phage uncharacterized protein, XkdX family', NULL, 'TIGR01669', NULL, NULL, 5338, 22),
(290727, NULL, 'TIGR03639', NULL, NULL, 'cas1_NMENI: CRISPR-associated endonuclease Cas1, subtype II/NMENI', NULL, 'TIGR03639', NULL, NULL, 14624, 22),
(290728, NULL, 'TIGR00941', NULL, NULL, '2a6301s03: multicomponent Na+:H+ antiporter, MnhC subunit', NULL, 'TIGR00941', NULL, NULL, 1692, 22),
(290729, NULL, 'TIGR03607', NULL, NULL, 'TIGR03607: patatin-related protein', NULL, 'TIGR03607', NULL, NULL, 14791, 22),
(290730, NULL, 'TIGR03982', NULL, NULL, 'TIGR03982: His-Xaa-Ser system protein, TIGR03982 family', NULL, 'TIGR03982', NULL, NULL, 14755, 22),
(290731, NULL, 'TIGR04125', NULL, NULL, 'exosort_PGF_TRM: archaeosortase A', NULL, 'TIGR04125', NULL, NULL, 11270, 22),
(290732, NULL, 'TIGR04157', NULL, NULL, 'glyco_rSAM_CFB: glycosyltransferase, GG-Bacteroidales peptide system', NULL, 'TIGR04157', NULL, NULL, 21376, 22),
(290733, NULL, 'TIGR01892', NULL, NULL, 'AcOrn-deacetyl: acetylornithine deacetylase (ArgE)', NULL, 'TIGR01892', NULL, NULL, 10727, 22),
(290734, NULL, 'TIGR02035', NULL, NULL, 'D_Ser_am_lyase: D-serine ammonia-lyase', NULL, 'TIGR02035', NULL, NULL, 13225, 22),
(290735, NULL, 'TIGR03950', NULL, NULL, 'sidero_Fe_reduc: siderophore ferric iron reductase, AHA_1954 family', NULL, 'TIGR03950', NULL, NULL, 18111, 22),
(290736, NULL, 'TIGR01517', NULL, NULL, 'ATPase-IIB_Ca: calcium-translocating P-type ATPase, PMCA-type', NULL, 'TIGR01517', NULL, NULL, 5881, 22),
(290737, NULL, 'TIGR00097', NULL, NULL, 'HMP-P_kinase: hydroxymethylpyrimidine kinase/phosphomethylpyrimidine kinase', NULL, 'TIGR00097', NULL, NULL, 5731, 22),
(290738, NULL, 'TIGR01204', NULL, NULL, 'bioW: 6-carboxyhexanoate--CoA ligase', NULL, 'TIGR01204', NULL, NULL, 890, 22),
(290739, NULL, 'TIGR02187', NULL, NULL, 'GlrX_arch: glutaredoxin-like domain protein', NULL, 'TIGR02187', NULL, NULL, 12112, 22),
(290740, NULL, 'TIGR03862', NULL, NULL, 'flavo_PP4765: flavoprotein, TIGR03862 family', NULL, 'TIGR03862', NULL, NULL, 15959, 22),
(290741, NULL, 'TIGR02348', NULL, NULL, 'GroEL: chaperonin GroL', NULL, 'TIGR02348', NULL, NULL, 4116, 22),
(290742, NULL, 'TIGR04438', NULL, NULL, 'small_Trp_rich: small Trp-rich protein', NULL, 'TIGR04438', NULL, NULL, 26149, 22),
(290743, NULL, 'TIGR00405', NULL, NULL, 'KOW_elon_Spt5: transcription elongation factor Spt5', NULL, 'TIGR00405', NULL, NULL, 11365, 22),
(290744, NULL, 'TIGR00258', NULL, NULL, 'TIGR00258: inosine/xanthosine triphosphatase', NULL, 'TIGR00258', NULL, NULL, 4641, 22),
(290745, NULL, 'TIGR03830', NULL, NULL, 'CxxCG_CxxCG_HTH: putative zinc finger/helix-turn-helix protein, YgiT family', NULL, 'TIGR03830', NULL, NULL, 14648, 22),
(290746, NULL, 'TIGR00065', NULL, NULL, 'ftsZ: cell division protein FtsZ', NULL, 'TIGR00065', NULL, NULL, 1534, 22),
(290747, NULL, 'TIGR00589', NULL, NULL, 'ogt: methylated-DNA--[protein]-cysteine S-methyltransferase', NULL, 'TIGR00589', NULL, NULL, 9653, 22),
(290748, NULL, 'TIGR03326', NULL, NULL, 'rubisco_III: ribulose bisphosphate carboxylase, type III', NULL, 'TIGR03326', NULL, NULL, 17920, 22),
(290749, NULL, 'TIGR02407', NULL, NULL, 'ectoine_ectB: diaminobutyrate--2-oxoglutarate aminotransferase', NULL, 'TIGR02407', NULL, NULL, 9771, 22),
(290750, NULL, 'TIGR02155', NULL, NULL, 'PA_CoA_ligase: phenylacetate-CoA ligase', NULL, 'TIGR02155', NULL, NULL, 8911, 22),
(290751, NULL, 'TIGR02679', NULL, NULL, 'TIGR02679: TIGR02679 family protein', NULL, 'TIGR02679', NULL, NULL, 10438, 22),
(290752, NULL, 'TIGR01236', NULL, NULL, 'D1pyr5carbox1: 1-pyrroline-5-carboxylate dehydrogenase', NULL, 'TIGR01236', NULL, NULL, 368, 22);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290753, NULL, 'TIGR01740', NULL, NULL, 'pyrF: orotidine 5''-phosphate decarboxylase', NULL, 'TIGR01740', NULL, NULL, 9132, 22),
(290754, NULL, 'TIGR03197', NULL, NULL, 'MnmC_Cterm: tRNA U-34 5-methylaminomethyl-2-thiouridine biosynthesis protein MnmC, C-terminal domain', NULL, 'TIGR03197', NULL, NULL, 16354, 22),
(290755, NULL, 'TIGR01057', NULL, NULL, 'topA_arch: DNA topoisomerase I', NULL, 'TIGR01057', NULL, NULL, 4821, 22),
(290756, NULL, 'TIGR02559', NULL, NULL, 'HrpB7: type III secretion protein HrpB7', NULL, 'TIGR02559', NULL, NULL, 11186, 22),
(290757, NULL, 'TIGR00539', NULL, NULL, 'hemN_rel: putative oxygen-independent coproporphyrinogen III oxidase', NULL, 'TIGR00539', NULL, NULL, 696, 22),
(290758, NULL, 'TIGR01177', NULL, NULL, 'TIGR01177: putative methyltransferase, TIGR01177 family', NULL, 'TIGR01177', NULL, NULL, 6600, 22),
(290759, NULL, 'TIGR03165', NULL, NULL, 'F1F0_chp_2: F1/F0 ATPase, Methanosarcina type, subunit 2', NULL, 'TIGR03165', NULL, NULL, 15713, 22),
(290760, NULL, 'TIGR03490', NULL, NULL, 'Mycoplas_LppA: mycoides cluster lipoprotein, LppA/P72 family', NULL, 'TIGR03490', NULL, NULL, 15066, 22),
(290761, NULL, 'TIGR00762', NULL, NULL, 'DegV: EDD domain protein, DegV family', NULL, 'TIGR00762', NULL, NULL, 6042, 22),
(290762, NULL, 'TIGR02527', NULL, NULL, 'dot_icm_IcmQ: Dot/Icm secretion system protein IcmQ', NULL, 'TIGR02527', NULL, NULL, 18791, 22),
(290763, NULL, 'TIGR01901', NULL, NULL, 'adhes_NPXG: filamentous hemagglutinin family N-terminal domain', NULL, 'TIGR01901', NULL, NULL, 14010, 22),
(290764, NULL, 'TIGR02246', NULL, NULL, 'TIGR02246: conserved hypothetical protein', NULL, 'TIGR02246', NULL, NULL, 11274, 22),
(290765, NULL, 'TIGR02750', NULL, NULL, 'TraN_Ftype: type-F conjugative transfer system mating-pair stabilization protein TraN', NULL, 'TIGR02750', NULL, NULL, 13566, 22),
(290766, NULL, 'TIGR02316', NULL, NULL, 'propion_prpE: propionate--CoA ligase', NULL, 'TIGR02316', NULL, NULL, 11792, 22),
(290767, NULL, 'TIGR02820', NULL, NULL, 'formald_GSH: S-(hydroxymethyl)glutathione synthase', NULL, 'TIGR02820', NULL, NULL, 8557, 22),
(290768, NULL, 'TIGR03045', NULL, NULL, 'PS_II_C550: cytochrome c-550', NULL, 'TIGR03045', NULL, NULL, 13608, 22),
(290769, NULL, 'TIGR02691', NULL, NULL, 'arsC_pI258_fam: arsenate reductase (thioredoxin)', NULL, 'TIGR02691', NULL, NULL, 13423, 22),
(290770, NULL, 'TIGR03818', NULL, NULL, 'MotA1: flagellar motor stator protein MotA', NULL, 'TIGR03818', NULL, NULL, 16110, 22),
(290771, NULL, 'TIGR03478', NULL, NULL, 'DMSO_red_II_bet: DMSO reductase family type II enzyme, iron-sulfur subunit', NULL, 'TIGR03478', NULL, NULL, 19950, 22),
(290772, NULL, 'TIGR01268', NULL, NULL, 'Phe4hydrox_tetr: phenylalanine-4-hydroxylase', NULL, 'TIGR01268', NULL, NULL, 343, 22),
(290773, NULL, 'TIGR02468', NULL, NULL, 'sucrsPsyn_pln: sucrose phosphate synthase', NULL, 'TIGR02468', NULL, NULL, 12822, 22),
(290774, NULL, 'TIGR00780', NULL, NULL, 'ccoN: cytochrome c oxidase, cbb3-type, subunit I', NULL, 'TIGR00780', NULL, NULL, 3261, 22),
(290775, NULL, 'TIGR02003', NULL, NULL, 'PTS-II-BC-unk1: PTS system, IIBC component', NULL, 'TIGR02003', NULL, NULL, 10132, 22),
(290776, NULL, 'TIGR01306', NULL, NULL, 'GMP_reduct_2: guanosine monophosphate reductase', NULL, 'TIGR01306', NULL, NULL, 1117, 22),
(290777, NULL, 'TIGR03760', NULL, NULL, 'ICE_TraI_Pfluor: integrating conjugative element relaxase, PFGI-1 class', NULL, 'TIGR03760', NULL, NULL, 15847, 22),
(290778, NULL, 'TIGR00276', NULL, NULL, 'TIGR00276: epoxyqueuosine reductase', NULL, 'TIGR00276', NULL, NULL, 7038, 22),
(290779, NULL, 'TIGR03013', NULL, NULL, 'EpsB_2: sugar transferase, PEP-CTERM system associated', NULL, 'TIGR03013', NULL, NULL, 20736, 22),
(290780, NULL, 'TIGR01608', NULL, NULL, 'citD: citrate lyase acyl carrier protein', NULL, 'TIGR01608', NULL, NULL, 6211, 22),
(290781, NULL, 'TIGR02972', NULL, NULL, 'TMAO_torE: trimethylamine N-oxide reductase system, TorE protein', NULL, 'TIGR02972', NULL, NULL, 9933, 22),
(290782, NULL, 'TIGR01025', NULL, NULL, 'uS19_arch: ribosomal protein uS19', NULL, 'TIGR01025', NULL, NULL, 3893, 22); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290783, NULL, 'TIGR02808', NULL, NULL, 'short_TIGR02808: TIGR02808 family protein', NULL, 'TIGR02808', NULL, NULL, 8658, 22),
(290784, NULL, 'TIGR03537', NULL, NULL, 'DapC: succinyldiaminopimelate transaminase', NULL, 'TIGR03537', NULL, NULL, 16580, 22),
(290785, NULL, 'TIGR04227', NULL, NULL, 'zmp_18_rpt: zinc metalloproteinase 18-residue repeat', NULL, 'TIGR04227', NULL, NULL, 25362, 22),
(290786, NULL, 'TIGR04456', NULL, NULL, 'LruC_dom: LruC domain', NULL, 'TIGR04456', NULL, NULL, 25830, 22),
(290787, NULL, 'TIGR00106', NULL, NULL, 'TIGR00106: uncharacterized protein, MTH1187 family', NULL, 'TIGR00106', NULL, NULL, 4840, 22),
(290788, NULL, 'TIGR02257', NULL, NULL, 'cobalto_cobN: cobaltochelatase, CobN subunit', NULL, 'TIGR02257', NULL, NULL, 11409, 22),
(290789, NULL, 'TIGR01619', NULL, NULL, 'hyp_HI0040: TIGR01619 family protein', NULL, 'TIGR01619', NULL, NULL, 7268, 22),
(290790, NULL, 'TIGR01994', NULL, NULL, 'SUF_scaf_2: SUF system FeS assembly protein, NifU family', NULL, 'TIGR01994', NULL, NULL, NULL, 22),
(290791, NULL, 'TIGR04450', NULL, NULL, 'Gpos_C8_like: putative immunity protein/bacteriocin', NULL, 'TIGR04450', NULL, NULL, 26249, 22),
(290792, NULL, 'TIGR00991', NULL, NULL, '3a0901s02IAP34: GTP-binding protein', NULL, 'TIGR00991', NULL, NULL, 3562, 22),
(290793, NULL, 'TIGR03689', NULL, NULL, 'pup_AAA: proteasome ATPase', NULL, 'TIGR03689', NULL, NULL, 16256, 22),
(290794, NULL, 'TIGR03932', NULL, NULL, 'PIA_icaD: intracellular adhesion protein D', NULL, 'TIGR03932', NULL, NULL, 20139, 22),
(290795, NULL, 'TIGR04570', NULL, NULL, 'mollicut_2TM: small integral membrane protein', NULL, 'TIGR04570', NULL, NULL, 23688, 22),
(290796, NULL, 'TIGR00167', NULL, NULL, 'cbbA: ketose-bisphosphate aldolase', NULL, 'TIGR00167', NULL, NULL, 6927, 22),
(290797, NULL, 'TIGR03224', NULL, NULL, 'benzo_boxA: benzoyl-CoA oxygenase/reductase, BoxA protein', NULL, 'TIGR03224', NULL, NULL, 16574, 22),
(290798, NULL, 'TIGR01102', NULL, NULL, 'yscR: type III secretion apparatus protein, YscR/HrcR family', NULL, 'TIGR01102', NULL, NULL, 4696, 22),
(290799, NULL, 'TIGR02085', NULL, NULL, 'meth_trns_rumB: 23S rRNA (uracil-5-)-methyltransferase RumB', NULL, 'TIGR02085', NULL, NULL, 13734, 22),
(290800, NULL, 'TIGR00809', NULL, NULL, 'secB: protein-export chaperone SecB', NULL, 'TIGR00809', NULL, NULL, 2087, 22),
(290801, NULL, 'TIGR01286', NULL, NULL, 'nifK: nitrogenase molybdenum-iron protein beta chain', NULL, 'TIGR01286', NULL, NULL, 1284, 22),
(290802, NULL, 'TIGR03505', NULL, NULL, 'FimV_core: FimV N-terminal domain', NULL, 'TIGR03505', NULL, NULL, 17027, 22),
(290803, NULL, 'TIGR00929', NULL, NULL, 'VirB4_CagE: type IV secretion/conjugal transfer ATPase, VirB4 family', NULL, 'TIGR00929', NULL, NULL, 5111, 22),
(290804, NULL, 'TIGR02706', NULL, NULL, 'P_butyryltrans: phosphate butyryltransferase', NULL, 'TIGR02706', NULL, NULL, 14157, 22),
(290805, NULL, 'TIGR02961', NULL, NULL, 'allantoicase: allantoicase', NULL, 'TIGR02961', NULL, NULL, 4645, 22),
(290806, NULL, 'TIGR03880', NULL, NULL, 'KaiC_arch_3: KaiC domain protein, AF_0351 family', NULL, 'TIGR03880', NULL, NULL, 15623, 22),
(290807, NULL, 'TIGR01962', NULL, NULL, 'NuoD: NADH dehydrogenase (quinone), D subunit', NULL, 'TIGR01962', NULL, NULL, 14853, 22),
(290808, NULL, 'TIGR01338', NULL, NULL, 'phycocy_alpha: phycocyanin, alpha subunit', NULL, 'TIGR01338', NULL, NULL, 3908, 22),
(290809, NULL, 'TIGR04336', NULL, NULL, 'AmmeMemoSam_B: AmmeMemoRadiSam system protein B', NULL, 'TIGR04336', NULL, NULL, NULL, 22),
(290810, NULL, 'TIGR01907', NULL, NULL, 'casE_Cse3: CRISPR-associated protein Cas6/Cse3/CasE, subtype I-E/ECOLI', NULL, 'TIGR01907', NULL, NULL, 4250, 22),
(290811, NULL, 'TIGR02305', NULL, NULL, 'HpaG-N-term: 4-hydroxyphenylacetate degradation bifunctional isomerase/decarboxylase, N-terminal subunit', NULL, 'TIGR02305', NULL, NULL, 11757, 22),
(290812, NULL, 'TIGR02793', NULL, NULL, 'nikR: nickel-responsive transcriptional regulator NikR', NULL, 'TIGR02793', NULL, NULL, 14429, 22),
(290813, NULL, 'TIGR01567', NULL, NULL, 'S_layer_rel_Mac: S-layer family duplication domain', NULL, 'TIGR01567', NULL, NULL, 6607, 22);  
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290814, NULL, 'TIGR00507', NULL, NULL, 'aroE: shikimate dehydrogenase', NULL, 'TIGR00507', NULL, NULL, 8758, 22),
(290815, NULL, 'TIGR04098', NULL, NULL, 'biosyn_clust_1: biosynthesis cluster domain', NULL, 'TIGR04098', NULL, NULL, NULL, 22),
(290816, NULL, 'TIGR04379', NULL, NULL, 'myo_inos_iolE: myo-inosose-2 dehydratase', NULL, 'TIGR04379', NULL, NULL, 25068, 22),
(290817, NULL, 'TIGR01681', NULL, NULL, 'HAD-SF-IIIC: HAD phosphatase, family IIIC', NULL, 'TIGR01681', NULL, NULL, 5396, 22),
(290818, NULL, 'TIGR01279', NULL, NULL, 'DPOR_bchN: light-independent protochlorophyllide reductase, N subunit', NULL, 'TIGR01279', NULL, NULL, 1134, 22),
(290819, NULL, 'TIGR04055', NULL, NULL, 'rSAM_NirJ2: putative heme d1 biosynthesis radical SAM protein NirJ2', NULL, 'TIGR04055', NULL, NULL, 23136, 22),
(290820, NULL, 'TIGR00124', NULL, NULL, 'cit_ly_ligase: [citrate (pro-3S)-lyase] ligase', NULL, 'TIGR00124', NULL, NULL, 10820, 22),
(290821, NULL, 'TIGR03771', NULL, NULL, 'anch_rpt_ABC: anchored repeat-type ABC transporter, ATP-binding subunit', NULL, 'TIGR03771', NULL, NULL, 16044, 22),
(290822, NULL, 'TIGR00648', NULL, NULL, 'recU: recombination protein U', NULL, 'TIGR00648', NULL, NULL, 581, 22),
(290823, NULL, 'TIGR00174', NULL, NULL, 'miaA: tRNA dimethylallyltransferase', NULL, 'TIGR00174', NULL, NULL, 16702, 22),
(290824, NULL, 'TIGR02954', NULL, NULL, 'Sig70_famx3: RNA polymerase sigma-70 factor, TIGR02954 family', NULL, 'TIGR02954', NULL, NULL, 9702, 22),
(290825, NULL, 'TIGR00469', NULL, NULL, 'pheS_mito: phenylalanine--tRNA ligase', NULL, 'TIGR00469', NULL, NULL, 1656, 22),
(290826, NULL, 'TIGR00004', NULL, NULL, 'TIGR00004: reactive intermediate/imine deaminase', NULL, 'TIGR00004', NULL, NULL, 2639, 22),
(290827, NULL, 'TIGR02144', NULL, NULL, 'LysX_arch: lysine biosynthesis enzyme LysX', NULL, 'TIGR02144', NULL, NULL, 14313, 22),
(290828, NULL, 'TIGR02852', NULL, NULL, 'spore_dpaB: dipicolinic acid synthetase, B subunit', NULL, 'TIGR02852', NULL, NULL, 10504, 22),
(290829, NULL, 'TIGR01159', NULL, NULL, 'DRP1: density-regulated protein DRP1', NULL, 'TIGR01159', NULL, NULL, 6967, 22),
(290830, NULL, 'TIGR03115', NULL, NULL, 'cas7_csf2: CRISPR type IV/AFERR-associated protein Csf2', NULL, 'TIGR03115', NULL, NULL, 14728, 22),
(290831, NULL, 'TIGR01350', NULL, NULL, 'lipoamide_DH: dihydrolipoyl dehydrogenase', NULL, 'TIGR01350', NULL, NULL, 3778, 22),
(290832, NULL, 'TIGR04048', NULL, NULL, 'nitrile_sll0784: putative nitrilase, sll0784 family', NULL, 'TIGR04048', NULL, NULL, 8458, 22),
(290833, NULL, 'TIGR01728', NULL, NULL, 'SsuA_fam: ABC transporter, substrate-binding protein, aliphatic sulfonates family', NULL, 'TIGR01728', NULL, NULL, 6396, 22),
(290834, NULL, 'TIGR03299', NULL, NULL, 'LGT_TIGR03299: phage/plasmid-like protein TIGR03299', NULL, 'TIGR03299', NULL, NULL, 17985, 22),
(290835, NULL, 'TIGR03063', NULL, NULL, 'srtB_target: sortase B cell surface sorting signal', NULL, 'TIGR03063', NULL, NULL, 21317, 22),
(290836, NULL, 'TIGR03592', NULL, NULL, 'yidC_oxa1_cterm: membrane protein insertase, YidC/Oxa1 family', NULL, 'TIGR03592', NULL, NULL, 25700, 22),
(290837, NULL, 'TIGR03358', NULL, NULL, 'VI_chp_5: type VI secretion protein, VC_A0107 family', NULL, 'TIGR03358', NULL, NULL, 7536, 22),
(290838, NULL, 'TIGR03403', NULL, NULL, 'nifS_epsilon: cysteine desulfurase, NifS family', NULL, 'TIGR03403', NULL, NULL, 18688, 22),
(290839, NULL, 'TIGR04558', NULL, NULL, 'SoxH_rel_PQQ_1: quinoprotein relay system zinc metallohydrolase 1', NULL, 'TIGR04558', NULL, NULL, 24474, 22),
(290840, NULL, 'TIGR03056', NULL, NULL, 'bchO_mg_che_rel: putative magnesium chelatase accessory protein', NULL, 'TIGR03056', NULL, NULL, 20653, 22),
(290841, NULL, 'TIGR03651', NULL, NULL, 'circ_ocin_uber: circular bacteriocin, circularin A/uberolysin family', NULL, 'TIGR03651', NULL, NULL, 17804, 22),
(290842, NULL, 'TIGR02418', NULL, NULL, 'acolac_catab: acetolactate synthase, catabolic', NULL, 'TIGR02418', NULL, NULL, 9622, 22),
(290843, NULL, 'TIGR01631', NULL, NULL, 'Trypano_RHS: trypanosome RHS family', NULL, 'TIGR01631', NULL, NULL, 150, 22); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290844, NULL, 'TIGR01388', NULL, NULL, 'rnd: ribonuclease D', NULL, 'TIGR01388', NULL, NULL, 3816, 22),
(290845, NULL, 'TIGR01860', NULL, NULL, 'VNFD: nitrogenase vanadium-iron protein, alpha chain', NULL, 'TIGR01860', NULL, NULL, 10911, 22),
(290846, NULL, 'TIGR00882', NULL, NULL, '2A0105: oligosaccharide:H+ symporter', NULL, 'TIGR00882', NULL, NULL, 5520, 22),
(290847, NULL, 'TIGR01166', NULL, NULL, 'cbiO: cobalt ABC transporter, ATP-binding protein', NULL, 'TIGR01166', NULL, NULL, 6924, 22),
(290848, NULL, 'TIGR01447', NULL, NULL, 'recD: exodeoxyribonuclease V, alpha subunit', NULL, 'TIGR01447', NULL, NULL, 4702, 22),
(290849, NULL, 'TIGR02949', NULL, NULL, 'anti_SigH_actin: anti-sigma factor, TIGR02949 family', NULL, 'TIGR02949', NULL, NULL, 8790, 22),
(290850, NULL, 'TIGR02078', NULL, NULL, 'AspKin_pair: putative Pyrococcus aspartate kinase subunit', NULL, 'TIGR02078', NULL, NULL, 13948, 22),
(290851, NULL, 'TIGR02366', NULL, NULL, 'DHAK_reg: probable dihydroxyacetone kinase regulator', NULL, 'TIGR02366', NULL, NULL, 8778, 22),
(290852, NULL, 'TIGR02425', NULL, NULL, 'decarb_PcaC: 4-carboxymuconolactone decarboxylase', NULL, 'TIGR02425', NULL, NULL, 9518, 22),
(290853, NULL, 'TIGR01506', NULL, NULL, 'ribC_arch: riboflavin synthase', NULL, 'TIGR01506', NULL, NULL, 5748, 22),
(290854, NULL, 'TIGR02137', NULL, NULL, 'HSK-PSP: phosphoserine phosphatase/homoserine phosphotransferase bifunctional protein', NULL, 'TIGR02137', NULL, NULL, 13623, 22),
(290855, NULL, 'TIGR03868', NULL, NULL, 'F420-O_ABCperi: proposed F420-0 ABC transporter, periplasmic F420-0 binding protein', NULL, 'TIGR03868', NULL, NULL, 21416, 22),
(290856, NULL, 'TIGR00117', NULL, NULL, 'acnB: aconitate hydratase 2', NULL, 'TIGR00117', NULL, NULL, 5664, 22),
(290857, NULL, 'TIGR03122', NULL, NULL, 'one_C_dehyd_C: formylmethanofuran dehydrogenase subunit C', NULL, 'TIGR03122', NULL, NULL, 14800, 22),
(290858, NULL, 'TIGR02430', NULL, NULL, 'pcaF: 3-oxoadipyl-CoA thiolase', NULL, 'TIGR02430', NULL, NULL, 9529, 22),
(290859, NULL, 'TIGR00514', NULL, NULL, 'accC: acetyl-CoA carboxylase, biotin carboxylase subunit', NULL, 'TIGR00514', NULL, NULL, 968, 22),
(290860, NULL, 'TIGR03274', NULL, NULL, 'methan_mark_7: putative methanogenesis marker protein 7', NULL, 'TIGR03274', NULL, NULL, 10180, 22),
(290861, NULL, 'TIGR00149', NULL, NULL, 'TIGR00149_YjbQ: secondary thiamine-phosphate synthase enzyme', NULL, 'TIGR00149', NULL, NULL, 3185, 22),
(290862, NULL, 'TIGR02207', NULL, NULL, 'lipid_A_htrB: lipid A biosynthesis lauroyl (or palmitoleoyl) acyltransferase', NULL, 'TIGR02207', NULL, NULL, 11079, 22),
(290863, NULL, 'TIGR01184', NULL, NULL, 'ntrCD: nitrate ABC transporter, ATP-binding proteins C and D', NULL, 'TIGR01184', NULL, NULL, 6858, 22),
(290864, NULL, 'TIGR02239', NULL, NULL, 'recomb_RAD51: DNA repair protein RAD51', NULL, 'TIGR02239', NULL, NULL, 11095, 22),
(290865, NULL, 'TIGR02668', NULL, NULL, 'moaA_archaeal: probable molybdenum cofactor biosynthesis protein A', NULL, 'TIGR02668', NULL, NULL, 10126, 22),
(290866, NULL, 'TIGR03158', NULL, NULL, 'cas3_cyano: CRISPR-associated helicase Cas3, subtype CYANO', NULL, 'TIGR03158', NULL, NULL, 15505, 22),
(290867, NULL, 'TIGR02788', NULL, NULL, 'VirB11: P-type DNA transfer ATPase VirB11', NULL, 'TIGR02788', NULL, NULL, 14495, 22),
(290868, NULL, 'TIGR00460', NULL, NULL, 'fmt: methionyl-tRNA formyltransferase', NULL, 'TIGR00460', NULL, NULL, 6728, 22),
(290869, NULL, 'TIGR03587', NULL, NULL, 'Pse_Me-ase: pseudaminic acid biosynthesis-associated methylase', NULL, 'TIGR03587', NULL, NULL, 11821, 22),
(290870, NULL, 'TIGR00269', NULL, NULL, 'TIGR00269: TIGR00269 family protein', NULL, 'TIGR00269', NULL, NULL, 5615, 22),
(290871, NULL, 'TIGR02917', NULL, NULL, 'PEP_TPR_lipo: putative PEP-CTERM system TPR-repeat lipoprotein', NULL, 'TIGR02917', NULL, NULL, 11022, 22),
(290872, NULL, 'TIGR03006', NULL, NULL, 'pepcterm_polyde: polysaccharide deacetylase family protein, PEP-CTERM locus subfamily', NULL, 'TIGR03006', NULL, NULL, 11283, 22),
(290873, NULL, 'TIGR02359', NULL, NULL, 'thiW: energy coupling factor transporter S component ThiW', NULL, 'TIGR02359', NULL, NULL, 10433, 22);     
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290874, NULL, 'TIGR02863', NULL, NULL, 'spore_sspJ: small, acid-soluble spore protein, SspJ family', NULL, 'TIGR02863', NULL, NULL, 10855, 22),
(290875, NULL, 'TIGR01944', NULL, NULL, 'rnfB: electron transport complex, RnfABCDGE type, B subunit', NULL, 'TIGR01944', NULL, NULL, 4464, 22),
(290876, NULL, 'TIGR00773', NULL, NULL, 'NhaA: Na+/H+ antiporter NhaA', NULL, 'TIGR00773', NULL, NULL, 2613, 22),
(290877, NULL, 'TIGR00707', NULL, NULL, 'argD: transaminase, acetylornithine/succinylornithine family', NULL, 'TIGR00707', NULL, NULL, 2412, 22),
(290878, NULL, 'TIGR02355', NULL, NULL, 'moeB: molybdopterin synthase sulfurylase MoeB', NULL, 'TIGR02355', NULL, NULL, 11517, 22),
(290879, NULL, 'TIGR03748', NULL, NULL, 'conj_PilL: integrating conjugative element protein PilL, PFGI-1 class', NULL, 'TIGR03748', NULL, NULL, 15212, 22),
(290880, NULL, 'TIGR01989', NULL, NULL, 'COQ6: ubiquinone biosynthesis monooxygenase COQ6', NULL, 'TIGR01989', NULL, NULL, 3802, 22),
(290881, NULL, 'TIGR04445', NULL, NULL, 'preny_LynF_TruF: peptide O-prenyltransferase, LynF/TruF/PatF family', NULL, 'TIGR04445', NULL, NULL, 26498, 22),
(290882, NULL, 'TIGR03038', NULL, NULL, 'PS_II_psbM: photosystem II reaction center protein PsbM', NULL, 'TIGR03038', NULL, NULL, 2262, 22),
(290883, NULL, 'TIGR00979', NULL, NULL, 'fumC_II: fumarate hydratase, class II', NULL, 'TIGR00979', NULL, NULL, 3732, 22),
(290884, NULL, 'TIGR00340', NULL, NULL, 'zpr1_rel: zinc finger protein ZPR1 homolog', NULL, 'TIGR00340', NULL, NULL, 7460, 22),
(290885, NULL, 'TIGR01524', NULL, NULL, 'ATPase-IIIB_Mg: magnesium-translocating P-type ATPase', NULL, 'TIGR01524', NULL, NULL, 6676, 22),
(290886, NULL, 'TIGR03542', NULL, NULL, 'DAPAT_plant: LL-diaminopimelate aminotransferase', NULL, 'TIGR03542', NULL, NULL, 18151, 22),
(290887, NULL, 'TIGR04202', NULL, NULL, 'capSnatchArena: RNA endonuclease, cap-snatching', NULL, 'TIGR04202', NULL, NULL, NULL, 22),
(290888, NULL, 'TIGR02895', NULL, NULL, 'spore_sigI: RNA polymerase sigma-I factor', NULL, 'TIGR02895', NULL, NULL, 11398, 22),
(290889, NULL, 'TIGR03614', NULL, NULL, 'RutB: pyrimidine utilization protein B', NULL, 'TIGR03614', NULL, NULL, 14725, 22),
(290890, NULL, 'TIGR00609', NULL, NULL, 'recB: exodeoxyribonuclease V, beta subunit', NULL, 'TIGR00609', NULL, NULL, 556, 22),
(290891, NULL, 'TIGR03440', NULL, NULL, 'egtB_TIGR03440: ergothioneine biosynthesis protein EgtB', NULL, 'TIGR03440', NULL, NULL, 19121, 22),
(290892, NULL, 'TIGR01404', NULL, NULL, 'FlhB_rel_III: type III secretion protein, YscU/HrpY family', NULL, 'TIGR01404', NULL, NULL, 4507, 22),
(290893, NULL, 'TIGR01556', NULL, NULL, 'rhamnosyltran: rhamnosyltransferase', NULL, 'TIGR01556', NULL, NULL, 6521, 22),
(290894, NULL, 'TIGR03662', NULL, NULL, 'Chlor_Arch_YYY: chlor_Arch_YYY domain', NULL, 'TIGR03662', NULL, NULL, 18266, 22),
(290895, NULL, 'TIGR00022', NULL, NULL, 'TIGR00022: YhcH/YjgK/YiaL family protein', NULL, 'TIGR00022', NULL, NULL, 5090, 22),
(290896, NULL, 'TIGR01626', NULL, NULL, 'ytfJ_HI0045: conserved hypothetical protein YtfJ-family, TIGR01626', NULL, 'TIGR01626', NULL, NULL, 6533, 22),
(290897, NULL, 'TIGR00054', NULL, NULL, 'TIGR00054: RIP metalloprotease RseP', NULL, 'TIGR00054', NULL, NULL, 5792, 22),
(290898, NULL, 'TIGR00487', NULL, NULL, 'IF-2: translation initiation factor IF-2', NULL, 'TIGR00487', NULL, NULL, 1737, 22),
(290899, NULL, 'TIGR00367', NULL, NULL, 'TIGR00367: K+-dependent Na+/Ca+ exchanger homolog', NULL, 'TIGR00367', NULL, NULL, 7420, 22),
(290900, NULL, 'TIGR02010', NULL, NULL, 'IscR: iron-sulfur cluster assembly transcription factor IscR', NULL, 'TIGR02010', NULL, NULL, 5337, 22),
(290901, NULL, 'TIGR04547', NULL, NULL, 'Mollicu_LP: MOLPALP family lipoprotein', NULL, 'TIGR04547', NULL, NULL, 25193, 22),
(290902, NULL, 'TIGR02475', NULL, NULL, 'CobW: cobalamin biosynthesis protein CobW', NULL, 'TIGR02475', NULL, NULL, 12962, 22),
(290903, NULL, 'TIGR01869', NULL, NULL, 'casC_Cse4: CRISPR-associated protein Cas7/Cse4/CasC, subtype I-E/ECOLI', NULL, 'TIGR01869', NULL, NULL, 10592, 22),
(290904, NULL, 'TIGR01313', NULL, NULL, 'therm_gnt_kin: carbohydrate kinase, thermoresistant glucokinase family', NULL, 'TIGR01313', NULL, NULL, 1419, 22);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290905, NULL, 'TIGR00827', NULL, NULL, 'EIIC-GAT: PTS system, galactitol-specific IIC component', NULL, 'TIGR00827', NULL, NULL, 8194, 22),
(290906, NULL, 'TIGR03485', NULL, NULL, 'cas_csx13_N: CRISPR-associated protein Cas8a1/Csx13, MYXAN subtype', NULL, 'TIGR03485', NULL, NULL, 15164, 22),
(290907, NULL, 'TIGR04391', NULL, NULL, 'CcmD_alt_fam: CcmD family protein', NULL, 'TIGR04391', NULL, NULL, 22363, 22),
(290908, NULL, 'TIGR04508', NULL, NULL, 'queE_Cx14CxxC: 7-carboxy-7-deazaguanine synthase', NULL, 'TIGR04508', NULL, NULL, 24004, 22),
(290909, NULL, 'TIGR02323', NULL, NULL, 'CP_lyasePhnK: phosphonate C-P lyase system protein PhnK', NULL, 'TIGR02323', NULL, NULL, 11541, 22),
(290910, NULL, 'TIGR02815', NULL, NULL, 'agaS_fam: putative sugar isomerase, AgaS family', NULL, 'TIGR02815', NULL, NULL, 8801, 22),
(290911, NULL, 'TIGR02743', NULL, NULL, 'TraW: type-F conjugative transfer system protein TraW', NULL, 'TIGR02743', NULL, NULL, 13963, 22),
(290912, NULL, 'TIGR01810', NULL, NULL, 'betA: choline dehydrogenase', NULL, 'TIGR01810', NULL, NULL, 8925, 22),
(290913, NULL, 'TIGR03256', NULL, NULL, 'met_CoM_red_alp: methyl-coenzyme M reductase, alpha subunit', NULL, 'TIGR03256', NULL, NULL, 17212, 22),
(290914, NULL, 'TIGR04168', NULL, NULL, 'TIGR04168: TIGR04168 family protein', NULL, 'TIGR04168', NULL, NULL, 22548, 22),
(290915, NULL, 'TIGR03249', NULL, NULL, 'KdgD: 5-dehydro-4-deoxyglucarate dehydratase', NULL, 'TIGR03249', NULL, NULL, 17400, 22),
(290916, NULL, 'TIGR01778', NULL, NULL, 'TonB-copper: TonB-dependent copper receptor', NULL, 'TIGR01778', NULL, NULL, 2001, 22),
(290917, NULL, 'TIGR03694', NULL, NULL, 'exosort_acyl: N-acyl amino acid synthase, PEP-CTERM/exosortase system-associated', NULL, 'TIGR03694', NULL, NULL, 16277, 22),
(290918, NULL, 'TIGR04515', NULL, NULL, 'P450_rel_GT_act: P450-derived glycosyltranferase activator', NULL, 'TIGR04515', NULL, NULL, 25266, 22),
(290919, NULL, 'TIGR00800', NULL, NULL, 'ncs1: NCS1 nucleoside transporter family', NULL, 'TIGR00800', NULL, NULL, 10098, 22),
(290920, NULL, 'TIGR00859', NULL, NULL, 'ENaC: sodium channel transporter', NULL, 'TIGR00859', NULL, NULL, 3535, 22),
(290921, NULL, 'TIGR01470', NULL, NULL, 'cysG_Nterm: siroheme synthase, N-terminal domain', NULL, 'TIGR01470', NULL, NULL, 5723, 22),
(290922, NULL, 'TIGR00551', NULL, NULL, 'nadB: L-aspartate oxidase', NULL, 'TIGR00551', NULL, NULL, 4276, 22),
(290923, NULL, 'TIGR01064', NULL, NULL, 'pyruv_kin: pyruvate kinase', NULL, 'TIGR01064', NULL, NULL, 3451, 22),
(290924, NULL, 'TIGR02686', NULL, NULL, 'relax_trwC: conjugative relaxase domain', NULL, 'TIGR02686', NULL, NULL, 13366, 22),
(290925, NULL, 'TIGR03709', NULL, NULL, 'PPK2_rel_1: polyphosphate:nucleotide phosphotransferase, PPK2 family', NULL, 'TIGR03709', NULL, NULL, 15789, 22),
(290926, NULL, 'TIGR00442', NULL, NULL, 'hisS: histidine--tRNA ligase', NULL, 'TIGR00442', NULL, NULL, 12773, 22),
(290927, NULL, 'TIGR00562', NULL, NULL, 'proto_IX_ox: protoporphyrinogen oxidase', NULL, 'TIGR00562', NULL, NULL, 780, 22),
(290928, NULL, 'TIGR01842', NULL, NULL, 'type_I_sec_PrtD: type I secretion system ATPase', NULL, 'TIGR01842', NULL, NULL, 10908, 22),
(290929, NULL, 'TIGR04175', NULL, NULL, 'archaeo_artD: archaeosortase D', NULL, 'TIGR04175', NULL, NULL, 21004, 22),
(290930, NULL, 'TIGR03020', NULL, NULL, 'EpsA: transcriptional regulator EpsA', NULL, 'TIGR03020', NULL, NULL, 20621, 22),
(290931, NULL, 'TIGR02997', NULL, NULL, 'Sig70-cyanoRpoD: RNA polymerase sigma factor, cyanobacterial RpoD-like family', NULL, 'TIGR02997', NULL, NULL, 18840, 22),
(290932, NULL, 'TIGR03052', NULL, NULL, 'PS_I_psaI: photosystem I reaction center subunit VIII', NULL, 'TIGR03052', NULL, NULL, 104, 22),
(290933, NULL, 'TIGR02221', NULL, NULL, 'cas_TM1812: CRISPR-associated protein, TM1812 family', NULL, 'TIGR02221', NULL, NULL, 11833, 22),
(290934, NULL, 'TIGR02105', NULL, NULL, 'III_needle: type III secretion apparatus needle protein', NULL, 'TIGR02105', NULL, NULL, 13995, 22),
(290935, NULL, 'TIGR02532', NULL, NULL, 'IV_pilin_GFxxxE: prepilin-type N-terminal cleavage/methylation domain', NULL, 'TIGR02532', NULL, NULL, 13342, 22);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290936, NULL, 'TIGR04311', NULL, NULL, 'rSAM_Geo_metal: putative metalloenzyme radical SAM/SPASM domain maturase', NULL, 'TIGR04311', NULL, NULL, 22408, 22),
(290937, NULL, 'TIGR00616', NULL, NULL, 'rect: recombinase, phage RecT family', NULL, 'TIGR00616', NULL, NULL, 871, 22),
(290938, NULL, 'TIGR03376', NULL, NULL, 'glycerol3P_DH: glycerol-3-phosphate dehydrogenase (NAD(+))', NULL, 'TIGR03376', NULL, NULL, 18824, 22),
(290939, NULL, 'TIGR03451', NULL, NULL, 'mycoS_dep_FDH: S-(hydroxymethyl)mycothiol dehydrogenase', NULL, 'TIGR03451', NULL, NULL, 19248, 22),
(290940, NULL, 'TIGR01887', NULL, NULL, 'dipeptidaselike: putative dipeptidase', NULL, 'TIGR01887', NULL, NULL, 2437, 22),
(290941, NULL, 'TIGR01361', NULL, NULL, 'DAHP_synth_Bsub: 3-deoxy-7-phosphoheptulonate synthase', NULL, 'TIGR01361', NULL, NULL, 3923, 22),
(290942, NULL, 'TIGR01701', NULL, NULL, 'Fdhalpha-like: oxidoreductase alpha (molybdopterin) subunit', NULL, 'TIGR01701', NULL, NULL, 5307, 22),
(290943, NULL, 'TIGR00605', NULL, NULL, 'rad4: DNA repair protein rad4', NULL, 'TIGR00605', NULL, NULL, 11925, 22),
(290944, NULL, 'TIGR04059', NULL, NULL, 'Ald_deCOase: long-chain fatty aldehyde decarbonylase', NULL, 'TIGR04059', NULL, NULL, 16560, 22),
(290945, NULL, 'TIGR02761', NULL, NULL, 'TraE_TIGR: type IV conjugative transfer system protein TraE', NULL, 'TIGR02761', NULL, NULL, 4187, 22),
(290946, NULL, 'TIGR03857', NULL, NULL, 'F420_MSMEG_2249: probable F420-dependent oxidoreductase, MSMEG_2249 family', NULL, 'TIGR03857', NULL, NULL, 15768, 22),
(290947, NULL, 'TIGR00671', NULL, NULL, 'baf: pantothenate kinase, type III', NULL, 'TIGR00671', NULL, NULL, 2249, 22),
(290948, NULL, 'TIGR01767', NULL, NULL, 'MTRK: S-methyl-5-thioribose kinase', NULL, 'TIGR01767', NULL, NULL, 10470, 22),
(290949, NULL, 'TIGR04304', NULL, NULL, 'GeoRSP_SPASM: GeoRSP system SPASM domain protein', NULL, 'TIGR04304', NULL, NULL, 23168, 22),
(290950, NULL, 'TIGR03369', NULL, NULL, 'cellulose_bcsE: cellulose biosynthesis protein BcsE', NULL, 'TIGR03369', NULL, NULL, 18843, 22),
(290951, NULL, 'TIGR00163', NULL, NULL, 'PS_decarb: phosphatidylserine decarboxylase', NULL, 'TIGR00163', NULL, NULL, 29783, 22),
(290952, NULL, 'TIGR02214', NULL, NULL, 'spoVD_pbp: stage V sporulation protein D', NULL, 'TIGR02214', NULL, NULL, 11448, 22),
(290953, NULL, 'TIGR01082', NULL, NULL, 'murC: UDP-N-acetylmuramate--L-alanine ligase', NULL, 'TIGR01082', NULL, NULL, 4705, 22),
(290954, NULL, 'TIGR04130', NULL, NULL, 'FnlA: UDP-N-acetylglucosamine 4,6-dehydratase/5-epimerase', NULL, 'TIGR04130', NULL, NULL, 21353, 22),
(290955, NULL, 'TIGR00968', NULL, NULL, '3a0106s01: sulfate ABC transporter, ATP-binding protein', NULL, 'TIGR00968', NULL, NULL, 3740, 22),
(290956, NULL, 'TIGR03267', NULL, NULL, 'methan_mark_2: putative methanogenesis marker protein 2', NULL, 'TIGR03267', NULL, NULL, 17409, 22),
(290957, NULL, 'TIGR03147', NULL, NULL, 'cyt_nit_nrfF: cytochrome c nitrite reductase, accessory protein NrfF', NULL, 'TIGR03147', NULL, NULL, 15111, 22),
(290958, NULL, 'TIGR03560', NULL, NULL, 'F420_Rv1855c: probable F420-dependent oxidoreductase, Rv1855c family', NULL, 'TIGR03560', NULL, NULL, 18335, 22),
(290959, NULL, 'TIGR02112', NULL, NULL, 'cyd_oper_ybgE: cyd operon protein YbgE', NULL, 'TIGR02112', NULL, NULL, 13661, 22),
(290960, NULL, 'TIGR00902', NULL, NULL, '2A0127: MFS transporter, phenyl propionate permease (PPP) family', NULL, 'TIGR00902', NULL, NULL, 23069, 22),
(290961, NULL, 'TIGR01951', NULL, NULL, 'nusB: transcription antitermination factor NusB', NULL, 'TIGR01951', NULL, NULL, 11454, 22),
(290962, NULL, 'TIGR04250', NULL, NULL, 'SCM_rSAM_ScmE: SynChlorMet cassette radical SAM/SPASM protein ScmE', NULL, 'TIGR04250', NULL, NULL, 24623, 22),
(290963, NULL, 'TIGR03716', NULL, NULL, 'R_switched_YkoY: integral membrane protein, YkoY family', NULL, 'TIGR03716', NULL, NULL, 16093, 22),
(290964, NULL, 'TIGR01075', NULL, NULL, 'uvrD: DNA helicase II', NULL, 'TIGR01075', NULL, NULL, 4799, 22),
(290965, NULL, 'TIGR02577', NULL, NULL, 'cas_TM1794_Cmr2: CRISPR-associated protein Cas10/Cmr2, subtype III-B', NULL, 'TIGR02577', NULL, NULL, 9332, 22);            
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290966, NULL, 'TIGR00156', NULL, NULL, 'TIGR00156: TIGR00156 family protein', NULL, 'TIGR00156', NULL, NULL, 9439, 22),
(290967, NULL, 'TIGR01302', NULL, NULL, 'IMP_dehydrog: inosine-5''-monophosphate dehydrogenase', NULL, 'TIGR01302', NULL, NULL, 1005, 22),
(290968, NULL, 'TIGR01658', NULL, NULL, 'EYA-cons_domain: EYA conserved domain', NULL, 'TIGR01658', NULL, NULL, 445, 22),
(290969, NULL, 'TIGR02457', NULL, NULL, 'TreS_Cterm: putative maltokinase', NULL, 'TIGR02457', NULL, NULL, 12610, 22),
(290970, NULL, 'TIGR03959', NULL, NULL, 'hyd_TM1266: putative iron-only hydrogenase system regulator', NULL, 'TIGR03959', NULL, NULL, 17619, 22),
(290971, NULL, 'TIGR01422', NULL, NULL, 'phosphonatase: phosphonoacetaldehyde hydrolase', NULL, 'TIGR01422', NULL, NULL, 4746, 22),
(290972, NULL, 'TIGR04493', NULL, NULL, 'microcomp_PduM: microcompartment protein PduM', NULL, 'TIGR04493', NULL, NULL, 21652, 22),
(290973, NULL, 'TIGR00503', NULL, NULL, 'prfC: peptide chain release factor 3', NULL, 'TIGR00503', NULL, NULL, 747, 22),
(290974, NULL, 'TIGR04406', NULL, NULL, 'LPS_export_lptB: LPS export ABC transporter ATP-binding protein', NULL, 'TIGR04406', NULL, NULL, 22801, 22),
(290975, NULL, 'TIGR00385', NULL, NULL, 'dsbE: periplasmic protein thiol:disulfide oxidoreductases, DsbE subfamily', NULL, 'TIGR00385', NULL, NULL, 5600, 22),
(290976, NULL, 'TIGR03796', NULL, NULL, 'NHLM_micro_ABC1: NHLM bacteriocin system ABC transporter, peptidase/ATP-binding protein', NULL, 'TIGR03796', NULL, NULL, 16454, 22),
(290977, NULL, 'TIGR04413', NULL, NULL, 'MYXAN_cmx8: CRISPR type MYXAN-associated protein Cmx8', NULL, 'TIGR04413', NULL, NULL, 26491, 22),
(290978, NULL, 'TIGR03383', NULL, NULL, 'urate_oxi: urate oxidase', NULL, 'TIGR03383', NULL, NULL, 1405, 22),
(290979, NULL, 'TIGR01415', NULL, NULL, 'trpB_rel: pyridoxal-phosphate dependent TrpB-like enzyme', NULL, 'TIGR01415', NULL, NULL, 4646, 22),
(290980, NULL, 'TIGR04066', NULL, NULL, 'nat_prod_clost: peptide maturation system protein, TIGR04066 family', NULL, 'TIGR04066', NULL, NULL, 9918, 22),
(290981, NULL, 'TIGR03331', NULL, NULL, 'SAM_DCase_Eco: S-adenosylmethionine decarboxylase proenzyme', NULL, 'TIGR03331', NULL, NULL, 9744, 22),
(290982, NULL, 'TIGR01068', NULL, NULL, 'thioredoxin: thioredoxin', NULL, 'TIGR01068', NULL, NULL, 4997, 22),
(290983, NULL, 'TIGR00718', NULL, NULL, 'sda_alpha: L-serine dehydratase, iron-sulfur-dependent, alpha subunit', NULL, 'TIGR00718', NULL, NULL, 2617, 22),
(290984, NULL, 'TIGR03900', NULL, NULL, 'prc_long_Delta: putative carboxyl-terminal-processing protease, deltaproteobacterial', NULL, 'TIGR03900', NULL, NULL, 16657, 22),
(290985, NULL, 'TIGR00725', NULL, NULL, 'TIGR00725: TIGR00725 family protein', NULL, 'TIGR00725', NULL, NULL, 4315, 22),
(290986, NULL, 'TIGR02870', NULL, NULL, 'spore_II_D: stage II sporulation protein D', NULL, 'TIGR02870', NULL, NULL, 10869, 22),
(290987, NULL, 'TIGR04073', NULL, NULL, 'exo_TIGR04073: putative exosortase-associated protein, TIGR04073 family', NULL, 'TIGR04073', NULL, NULL, 9608, 22),
(290988, NULL, 'TIGR00378', NULL, NULL, 'cax: calcium/proton exchanger', NULL, 'TIGR00378', NULL, NULL, 5205, 22),
(290989, NULL, 'TIGR02641', NULL, NULL, 'gvpC_cyan_rpt: gas vesicle protein GvpC repeat', NULL, 'TIGR02641', NULL, NULL, 2045, 22),
(290990, NULL, 'TIGR01408', NULL, NULL, 'Ube1: ubiquitin-activating enzyme E1', NULL, 'TIGR01408', NULL, NULL, 19260, 22),
(290991, NULL, 'TIGR03154', NULL, NULL, 'sulfolob_CbsA: cytochrome b558/566, subunit A', NULL, 'TIGR03154', NULL, NULL, 15619, 22),
(290992, NULL, 'TIGR03585', NULL, NULL, 'PseH: UDP-4-amino-4,6-dideoxy-N-acetyl-beta-L-altrosamine N-acetyltransferase', NULL, 'TIGR03585', NULL, NULL, 11754, 22),
(290993, NULL, 'TIGR00512', NULL, NULL, 'salvage_mtnA: S-methyl-5-thioribose-1-phosphate isomerase', NULL, 'TIGR00512', NULL, NULL, 11351, 22),
(290994, NULL, 'TIGR01495', NULL, NULL, 'ETRAMP: early transcribed membrane protein (ETRAMP) family', NULL, 'TIGR01495', NULL, NULL, 5954, 22),
(290995, NULL, 'TIGR04554', NULL, NULL, '3TM_mycoplas: three transmembrane helix protein', NULL, 'TIGR04554', NULL, NULL, 25318, 22);
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(290996, NULL, 'TIGR01030', NULL, NULL, 'rpmH_bact: ribosomal protein bL34', NULL, 'TIGR01030', NULL, NULL, 872, 22),
(290997, NULL, 'TIGR02602', NULL, NULL, '8TM_EpsH: exosortase', NULL, 'TIGR02602', NULL, NULL, 9291, 22),
(290998, NULL, 'TIGR02915', NULL, NULL, 'PEP_resp_reg: PEP-CTERM-box response regulator transcription factor', NULL, 'TIGR02915', NULL, NULL, 11259, 22),
(290999, NULL, 'TIGR03553', NULL, NULL, 'F420_FbiB_CTERM: F420 biosynthesis protein FbiB, C-terminal domain', NULL, 'TIGR03553', NULL, NULL, 18033, 22),
(291000, NULL, 'TIGR01463', NULL, NULL, 'mtaA_cmuA: methyltransferase, MtaA/CmuA family', NULL, 'TIGR01463', NULL, NULL, 5559, 22),
(291001, NULL, 'TIGR03723', NULL, NULL, 'T6A_TsaD_YgjD: tRNA threonylcarbamoyl adenosine modification protein TsaD', NULL, 'TIGR03723', NULL, NULL, 21322, 22),
(291002, NULL, 'TIGR02432', NULL, NULL, 'lysidine_TilS_N: tRNA(Ile)-lysidine synthetase', NULL, 'TIGR02432', NULL, NULL, 9892, 22),
(291003, NULL, 'TIGR02151', NULL, NULL, 'IPP_isom_2: isopentenyl-diphosphate delta-isomerase, type 2', NULL, 'TIGR02151', NULL, NULL, 10669, 22),
(291004, NULL, 'TIGR04522', NULL, NULL, 'EcfS_MSC_0063: putative energy coupling factor transporter S component', NULL, 'TIGR04522', NULL, NULL, 25449, 22),
(291005, NULL, 'TIGR00061', NULL, NULL, 'L21: ribosomal protein bL21', NULL, 'TIGR00061', NULL, NULL, 4280, 22),
(291006, NULL, 'TIGR01946', NULL, NULL, 'rnfD: electron transport complex, RnfABCDGE type, D subunit', NULL, 'TIGR01946', NULL, NULL, 12021, 22),
(291007, NULL, 'TIGR03120', NULL, NULL, 'one_C_mch: methenyltetrahydromethanopterin cyclohydrolase', NULL, 'TIGR03120', NULL, NULL, 2202, 22),
(291008, NULL, 'TIGR01633', NULL, NULL, 'phi3626_gp14_N: putative phage tail component, N-terminal domain', NULL, 'TIGR01633', NULL, NULL, 190, 22),
(291009, NULL, 'TIGR04393', NULL, NULL, 'rpt_T5SS_PEPC: T5SS/PEP-CTERM-associated repeat', NULL, 'TIGR04393', NULL, NULL, 22041, 22),
(291010, NULL, 'TIGR03866', NULL, NULL, 'PQQ_ABC_repeats: PQQ-dependent catabolism-associated beta-propeller protein', NULL, 'TIGR03866', NULL, NULL, 15729, 22),
(291011, NULL, 'TIGR01200', NULL, NULL, 'GLPGLI: GLPGLI family protein', NULL, 'TIGR01200', NULL, NULL, 6702, 22),
(291012, NULL, 'TIGR04009', NULL, NULL, 'wcaE: colanic acid biosynthesis glycosyltransferase WcaE', NULL, 'TIGR04009', NULL, NULL, 11710, 22),
(291013, NULL, 'TIGR04241', NULL, NULL, 'adenoE3CR1rpt: mastadenovirus E3 CR1-alpha-1', NULL, 'TIGR04241', NULL, NULL, 25274, 22),
(291014, NULL, 'TIGR01776', NULL, NULL, 'TonB-tbp-lbp: TonB-dependent lactoferrin and transferrin receptors', NULL, 'TIGR01776', NULL, NULL, 1649, 22),
(291015, NULL, 'TIGR00383', NULL, NULL, 'corA: magnesium and cobalt transport protein CorA', NULL, 'TIGR00383', NULL, NULL, 1473, 22),
(291016, NULL, 'TIGR00834', NULL, NULL, 'ae: anion exchange protein', NULL, 'TIGR00834', NULL, NULL, 43, 22),
(291017, NULL, 'TIGR00825', NULL, NULL, 'EIIBC-GUT: PTS system, glucitol/sorbitol-specific, IIBC component', NULL, 'TIGR00825', NULL, NULL, 3348, 22),
(291018, NULL, 'TIGR01141', NULL, NULL, 'hisC: histidinol-phosphate transaminase', NULL, 'TIGR01141', NULL, NULL, 6815, 22),
(291019, NULL, 'TIGR03231', NULL, NULL, 'anthran_1_2_B: anthranilate 1,2-dioxygenase, small subunit', NULL, 'TIGR03231', NULL, NULL, 16925, 22),
(291020, NULL, 'TIGR00664', NULL, NULL, 'DNA_III_psi: DNA polymerase III, psi subunit', NULL, 'TIGR00664', NULL, NULL, 20004, 22),
(291021, NULL, 'TIGR01835', NULL, NULL, 'HMG-CoA-S_prok: hydroxymethylglutaryl-CoA synthase', NULL, 'TIGR01835', NULL, NULL, 10583, 22),
(291022, NULL, 'TIGR01311', NULL, NULL, 'glycerol_kin: glycerol kinase', NULL, 'TIGR01311', NULL, NULL, 1235, 22),
(291023, NULL, 'TIGR04071', NULL, NULL, 'methanobac_OB3b: methanobactin precursor, Mb-OB3b family', NULL, 'TIGR04071', NULL, NULL, 10689, 22),
(291024, NULL, 'TIGR03755', NULL, NULL, 'conj_TIGR03755: integrating conjugative element protein, PFL_4711 family', NULL, 'TIGR03755', NULL, NULL, 16280, 22),
(291025, NULL, 'TIGR03925', NULL, NULL, 'T7SS_EccC_b: type VII secretion protein EccCb', NULL, 'TIGR03925', NULL, NULL, 16868, 22);       
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(291026, NULL, 'TIGR03696', NULL, NULL, 'Rhs_assc_core: RHS repeat-associated core domain', NULL, 'TIGR03696', NULL, NULL, 15925, 22),
(291027, NULL, 'TIGR00494', NULL, NULL, 'crcB: protein CrcB', NULL, 'TIGR00494', NULL, NULL, 1540, 22),
(291028, NULL, 'TIGR01665', NULL, NULL, 'put_anti_recept: phage minor structural protein, N-terminal region', NULL, 'TIGR01665', NULL, NULL, 95, 22),
(291029, NULL, 'TIGR03401', NULL, NULL, 'cyanamide_fam: HD domain protein, cyanamide hydratase family', NULL, 'TIGR03401', NULL, NULL, 18562, 22),
(291030, NULL, 'TIGR04182', NULL, NULL, 'glyco_TIGR04182: glycosyltransferase, TIGR04182 family', NULL, 'TIGR04182', NULL, NULL, 23156, 22),
(291031, NULL, 'TIGR00401', NULL, NULL, 'msrA: peptide-methionine (S)-S-oxide reductase', NULL, 'TIGR00401', NULL, NULL, 1834, 22),
(291032, NULL, 'TIGR01987', NULL, NULL, 'HI0074: nucleotidyltransferase substrate binding protein, HI0074 family', NULL, 'TIGR01987', NULL, NULL, 4139, 22),
(291033, NULL, 'TIGR00020', NULL, NULL, 'prfB: peptide chain release factor 2', NULL, 'TIGR00020', NULL, NULL, 5116, 22),
(291034, NULL, 'TIGR01522', NULL, NULL, 'ATPase-IIA2_Ca: calcium-transporting P-type ATPase, PMR1-type', NULL, 'TIGR01522', NULL, NULL, 6873, 22),
(291035, NULL, 'TIGR02160', NULL, NULL, 'PA_CoA_Oxy5: phenylacetate-CoA oxygenase/reductase, PaaK subunit', NULL, 'TIGR02160', NULL, NULL, 8670, 22),
(291036, NULL, 'TIGR02423', NULL, NULL, 'protocat_alph: protocatechuate 3,4-dioxygenase, alpha subunit', NULL, 'TIGR02423', NULL, NULL, 9624, 22),
(291037, NULL, 'TIGR03544', NULL, NULL, 'DivI1A_domain: DivIVA domain', NULL, 'TIGR03544', NULL, NULL, 18333, 22),
(291038, NULL, 'TIGR00172', NULL, NULL, 'maf: septum formation protein Maf', NULL, 'TIGR00172', NULL, NULL, 2141, 22),
(291039, NULL, 'TIGR02192', NULL, NULL, 'HtrL_YibB: protein YibB', NULL, 'TIGR02192', NULL, NULL, 11911, 22),
(291040, NULL, 'TIGR02473', NULL, NULL, 'flagell_FliJ: flagellar export protein FliJ', NULL, 'TIGR02473', NULL, NULL, 12981, 22),
(291041, NULL, 'TIGR00655', NULL, NULL, 'PurU: formyltetrahydrofolate deformylase', NULL, 'TIGR00655', NULL, NULL, 4457, 22),
(291042, NULL, 'TIGR04411', NULL, NULL, 'T2SS_GspN_Lepto: type II secretion system protein N', NULL, 'TIGR04411', NULL, NULL, 24389, 22),
(291043, NULL, 'TIGR04352', NULL, NULL, 'HprK_rel_A: HprK-related kinase A', NULL, 'TIGR04352', NULL, NULL, 23297, 22),
(291044, NULL, 'TIGR01803', NULL, NULL, 'CM-like: chorismate mutase related enzymes', NULL, 'TIGR01803', NULL, NULL, 738, 22),
(291045, NULL, 'TIGR01674', NULL, NULL, 'phage_lambda_G: phage minor tail protein G', NULL, 'TIGR01674', NULL, NULL, 5395, 22),
(291046, NULL, 'TIGR00231', NULL, NULL, 'small_GTP: small GTP-binding protein domain', NULL, 'TIGR00231', NULL, NULL, 11013, 22),
(291047, NULL, 'TIGR00485', NULL, NULL, 'EF-Tu: translation elongation factor Tu', NULL, 'TIGR00485', NULL, NULL, 1868, 22),
(291048, NULL, 'TIGR03374', NULL, NULL, 'ABALDH: 1-pyrroline dehydrogenase', NULL, 'TIGR03374', NULL, NULL, 18542, 22),
(291049, NULL, 'TIGR03825', NULL, NULL, 'FliH_bacil: flagellar assembly protein FliH', NULL, 'TIGR03825', NULL, NULL, 16456, 22),
(291050, NULL, 'TIGR02330', NULL, NULL, 'prpD: 2-methylcitrate dehydratase', NULL, 'TIGR02330', NULL, NULL, 11919, 22),
(291051, NULL, 'TIGR03222', NULL, NULL, 'benzo_boxC: benzoyl-CoA-dihydrodiol lyase', NULL, 'TIGR03222', NULL, NULL, 16775, 22),
(291052, NULL, 'TIGR00696', NULL, NULL, 'wecG_tagA_cpsF: glycosyltransferase, WecB/TagA/CpsF family', NULL, 'TIGR00696', NULL, NULL, 2136, 22),
(291053, NULL, 'TIGR01293', NULL, NULL, 'Kv_beta: voltage-dependent potassium channel beta subunit', NULL, 'TIGR01293', NULL, NULL, 1115, 22),
(291054, NULL, 'TIGR00342', NULL, NULL, 'TIGR00342: tRNA sulfurtransferase ThiI', NULL, 'TIGR00342', NULL, NULL, 2095, 22),
(291055, NULL, 'TIGR01018', NULL, NULL, 'uS4_arch: ribosomal protein uS4', NULL, 'TIGR01018', NULL, NULL, 3705, 22),
(291056, NULL, 'TIGR04495', NULL, NULL, 'RiPP_XyeA: putative rSAM-modified RiPP, XyeA family', NULL, 'TIGR04495', NULL, NULL, 21886, 22);        
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(291057, NULL, 'TIGR01182', NULL, NULL, 'eda: 2-dehydro-3-deoxyphosphogluconate aldolase/4-hydroxy-2-oxoglutarate aldolase', NULL, 'TIGR01182', NULL, NULL, 4580, 22),
(291058, NULL, 'TIGR02965', NULL, NULL, 'xanthine_xdhB: xanthine dehydrogenase, molybdopterin binding subunit', NULL, 'TIGR02965', NULL, NULL, 9604, 22),
(291059, NULL, 'TIGR04200', NULL, NULL, 'targ_of_XrtJ: XrtJ-associated TM-motif-TM protein', NULL, 'TIGR04200', NULL, NULL, 25308, 22),
(291060, NULL, 'TIGR04030', NULL, NULL, 'perox_Avi_7169: alkylhydroperoxidase domain protein, Avi_7169 family', NULL, 'TIGR04030', NULL, NULL, 18217, 22),
(291061, NULL, 'TIGR01352', NULL, NULL, 'tonB_Cterm: TonB family C-terminal domain', NULL, 'TIGR01352', NULL, NULL, 3828, 22),
(291062, NULL, 'TIGR00008', NULL, NULL, 'infA: translation initiation factor IF-1', NULL, 'TIGR00008', NULL, NULL, 5451, 22),
(291063, NULL, 'TIGR00977', NULL, NULL, 'citramal_synth: citramalate synthase', NULL, 'TIGR00977', NULL, NULL, 3672, 22),
(291064, NULL, 'TIGR03714', NULL, NULL, 'secA2: accessory Sec system translocase SecA2', NULL, 'TIGR03714', NULL, NULL, 16338, 22),
(291065, NULL, 'TIGR02795', NULL, NULL, 'tol_pal_ybgF: tol-pal system protein YbgF', NULL, 'TIGR02795', NULL, NULL, 14212, 22),
(291066, NULL, 'TIGR03655', NULL, NULL, 'anti_R_Lar: restriction alleviation protein, Lar family', NULL, 'TIGR03655', NULL, NULL, 11721, 22),
(291067, NULL, 'TIGR04384', NULL, NULL, 'putr_carbamoyl: putrescine carbamoyltransferase', NULL, 'TIGR04384', NULL, NULL, 21635, 22),
(291068, NULL, 'TIGR02083', NULL, NULL, 'LEU2: 3-isopropylmalate dehydratase, large subunit', NULL, 'TIGR02083', NULL, NULL, 13683, 22),
(291069, NULL, 'TIGR02500', NULL, NULL, 'type_III_yscD: type III secretion apparatus protein, YscD/HrpQ family', NULL, 'TIGR02500', NULL, NULL, 12929, 22),
(291070, NULL, 'TIGR01565', NULL, NULL, 'homeo_ZF_HD: homeobox domain, ZF-HD class', NULL, 'TIGR01565', NULL, NULL, 6994, 22),
(291071, NULL, 'TIGR02534', NULL, NULL, 'mucon_cyclo: muconate and chloromuconate cycloisomerases', NULL, 'TIGR02534', NULL, NULL, 18631, 22),
(291072, NULL, 'TIGR04173', NULL, NULL, 'PIP_CTERM: PIP-CTERM protein sorting domain', NULL, 'TIGR04173', NULL, NULL, 23388, 22),
(291073, NULL, 'TIGR00410', NULL, NULL, 'lacE: PTS system, lactose/cellobiose family IIC component', NULL, 'TIGR00410', NULL, NULL, 1946, 22),
(291074, NULL, 'TIGR00596', NULL, NULL, 'rad1: DNA repair protein (rad1)', NULL, 'TIGR00596', NULL, NULL, 10251, 22),
(291075, NULL, 'TIGR01563', NULL, NULL, 'gp16_SPP1: putative phage head-tail adaptor', NULL, 'TIGR01563', NULL, NULL, 12153, 22),
(291076, NULL, 'TIGR04291', NULL, NULL, 'arsen_driv_ArsA: arsenical pump-driving ATPase', NULL, 'TIGR04291', NULL, NULL, 26564, 22),
(291077, NULL, 'TIGR03934', NULL, NULL, 'TQXA_dom: TQXA domain', NULL, 'TIGR03934', NULL, NULL, 16880, 22),
(291078, NULL, 'TIGR02999', NULL, NULL, 'Sig-70_X6: RNA polymerase sigma factor, TIGR02999 family', NULL, 'TIGR02999', NULL, NULL, 12636, 22),
(291079, NULL, 'TIGR00131', NULL, NULL, 'gal_kin: galactokinase', NULL, 'TIGR00131', NULL, NULL, 3588, 22),
(291080, NULL, 'TIGR01844', NULL, NULL, 'type_I_sec_TolC: type I secretion outer membrane protein, TolC family', NULL, 'TIGR01844', NULL, NULL, 10682, 22),
(291081, NULL, 'TIGR04452', NULL, NULL, 'Lepto_Lipo_YY_C: small lipoprotein, LA_3946 family', NULL, 'TIGR04452', NULL, NULL, 26172, 22),
(291082, NULL, 'TIGR02704', NULL, NULL, 'carboxysome_B: carboxysome peptide B', NULL, 'TIGR02704', NULL, NULL, 13227, 22),
(291083, NULL, 'TIGR00927', NULL, NULL, '2A1904: K+-dependent Na+/Ca+ exchanger', NULL, 'TIGR00927', NULL, NULL, 4263, 22),
(291084, NULL, 'TIGR02364', NULL, NULL, 'dha_pts: dihydroxyacetone kinase, phosphotransfer subunit', NULL, 'TIGR02364', NULL, NULL, 7119, 22),
(291085, NULL, 'TIGR04343', NULL, NULL, 'egtE_PLP_lyase: ergothioneine biosynthesis PLP-dependent enzyme EgtE', NULL, 'TIGR04343', NULL, NULL, 26640, 22),
(291086, NULL, 'TIGR00766', NULL, NULL, 'TIGR00766: inner membrane protein YhjD', NULL, 'TIGR00766', NULL, NULL, 4367, 22);           
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(291087, NULL, 'TIGR01733', NULL, NULL, 'AA-adenyl-dom: amino acid adenylation domain', NULL, 'TIGR01733', NULL, NULL, 6237, 22),
(291088, NULL, 'TIGR02888', NULL, NULL, 'spore_YlmC_YmxH: sporulation protein, YlmC/YmxH family', NULL, 'TIGR02888', NULL, NULL, 10885, 22),
(291089, NULL, 'TIGR03823', NULL, NULL, 'FliZ: flagellar regulatory protein FliZ', NULL, 'TIGR03823', NULL, NULL, 16073, 22),
(291090, NULL, 'TIGR04454', NULL, NULL, 'Lepto_4Cys: small lipoprotein, LB_250 family', NULL, 'TIGR04454', NULL, NULL, 26073, 22),
(291091, NULL, 'TIGR00049', NULL, NULL, 'TIGR00049: iron-sulfur cluster assembly accessory protein', NULL, 'TIGR00049', NULL, NULL, 13721, 22),
(291092, NULL, 'TIGR02309', NULL, NULL, 'HpaB-1: 4-hydroxyphenylacetate 3-monooxygenase, oxygenase component', NULL, 'TIGR02309', NULL, NULL, 11702, 22),
(291093, NULL, 'TIGR03653', NULL, NULL, 'uL6_arch: ribosomal protein uL6', NULL, 'TIGR03653', NULL, NULL, 11800, 22),
(291094, NULL, 'TIGR02139', NULL, NULL, 'permease_CysT: sulfate ABC transporter, permease protein CysT', NULL, 'TIGR02139', NULL, NULL, 13718, 22),
(291095, NULL, 'TIGR01393', NULL, NULL, 'lepA: elongation factor 4', NULL, 'TIGR01393', NULL, NULL, 4538, 22),
(291096, NULL, 'TIGR04461', NULL, NULL, 'endura_MppQ: enduracididine biosynthesis enzyme MppQ', NULL, 'TIGR04461', NULL, NULL, 25809, 22),
(291097, NULL, 'TIGR04284', NULL, NULL, 'aldehy_Rv0768: aldehyde dehydrogenase, Rv0768 family', NULL, 'TIGR04284', NULL, NULL, 25233, 22),
(291098, NULL, 'TIGR02253', NULL, NULL, 'CTE7: HAD hydrolase, TIGR02253 family', NULL, 'TIGR02253', NULL, NULL, 11076, 22),
(291099, NULL, 'TIGR02371', NULL, NULL, 'ala_DH_arch: alanine dehydrogenase', NULL, 'TIGR02371', NULL, NULL, 8983, 22),
(291100, NULL, 'TIGR00219', NULL, NULL, 'mreC: rod shape-determining protein MreC', NULL, 'TIGR00219', NULL, NULL, 6189, 22),
(291101, NULL, 'TIGR03483', NULL, NULL, 'FtsZ_alphas_C: cell division protein FtsZ, alphaProteobacterial C-terminal extension', NULL, 'TIGR03483', NULL, NULL, 19710, 22),
(291102, NULL, 'TIGR00936', NULL, NULL, 'ahcY: adenosylhomocysteinase', NULL, 'TIGR00936', NULL, NULL, 3741, 22),
(291103, NULL, 'TIGR00934', NULL, NULL, '2a38euk: potassium uptake protein, Trk family', NULL, 'TIGR00934', NULL, NULL, 5218, 22),
(291104, NULL, 'TIGR00070', NULL, NULL, 'hisG: ATP phosphoribosyltransferase', NULL, 'TIGR00070', NULL, NULL, 13700, 22),
(291105, NULL, 'TIGR04513', NULL, NULL, 'VPAMP_CTERM: VPAMP-CTERM protein sorting domain', NULL, 'TIGR04513', NULL, NULL, 25045, 22),
(291106, NULL, 'TIGR03594', NULL, NULL, 'GTPase_EngA: ribosome-associated GTPase EngA', NULL, 'TIGR03594', NULL, NULL, 15435, 22),
(291107, NULL, 'TIGR01454', NULL, NULL, 'AHBA_synth_RP: AHBA synthesis associated protein', NULL, 'TIGR01454', NULL, NULL, 4576, 22),
(291108, NULL, 'TIGR02956', NULL, NULL, 'TMAO_torS: TMAO reductase sytem sensor TorS', NULL, 'TIGR02956', NULL, NULL, 9900, 22),
(291109, NULL, 'TIGR01572', NULL, NULL, 'A_thl_para_3677: Arabidopsis paralogous family TIGR01572', NULL, 'TIGR01572', NULL, NULL, 6639, 22),
(291110, NULL, 'TIGR03011', NULL, NULL, 'sulf_tusB_dsrH: sulfur relay protein TusB/DsrH', NULL, 'TIGR03011', NULL, NULL, 6300, 22),
(291111, NULL, 'TIGR03061', NULL, NULL, 'pip_yhgE_Nterm: YhgE/Pip N-terminal domain', NULL, 'TIGR03061', NULL, NULL, 20885, 22),
(291112, NULL, 'TIGR00587', NULL, NULL, 'nfo: apurinic endonuclease (APN1)', NULL, 'TIGR00587', NULL, NULL, 3499, 22),
(291113, NULL, 'TIGR03476', NULL, NULL, 'HpnL: putative membrane protein', NULL, 'TIGR03476', NULL, NULL, NULL, 22),
(291114, NULL, 'TIGR01905', NULL, NULL, 'paired_CXXCH_1: doubled CXXCH domain', NULL, 'TIGR01905', NULL, NULL, 4013, 22),
(291115, NULL, 'TIGR03764', NULL, NULL, 'ICE_PFGI_1_parB: integrating conjugative element, PFGI_1 class, ParB family protein', NULL, 'TIGR03764', NULL, NULL, 15562, 22),
(291116, NULL, 'TIGR04563', NULL, NULL, 'TIGR04563: MXAN_4361/MXAN_4362 family small protein', NULL, 'TIGR04563', NULL, NULL, 23984, 22),
(291117, NULL, 'TIGR02092', NULL, NULL, 'glgD: glucose-1-phosphate adenylyltransferase, GlgD subunit', NULL, 'TIGR02092', NULL, NULL, 13616, 22);    
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(291118, NULL, 'TIGR03646', NULL, NULL, 'YtoQ_fam: YtoQ family protein', NULL, 'TIGR03646', NULL, NULL, 18237, 22),
(291119, NULL, 'TIGR02321', NULL, NULL, 'Pphn_pyruv_hyd: phosphonopyruvate hydrolase', NULL, 'TIGR02321', NULL, NULL, 10005, 22),
(291120, NULL, 'TIGR02090', NULL, NULL, 'LEU1_arch: isopropylmalate/citramalate/homocitrate synthases', NULL, 'TIGR02090', NULL, NULL, 13557, 22),
(291121, NULL, 'TIGR00403', NULL, NULL, 'ndhI: NADH-plastoquinone oxidoreductase, I subunit', NULL, 'TIGR00403', NULL, NULL, 1857, 22),
(291122, NULL, 'TIGR02262', NULL, NULL, 'benz_CoA_lig: benzoate-CoA ligase family', NULL, 'TIGR02262', NULL, NULL, 11200, 22),
(291123, NULL, 'TIGR00757', NULL, NULL, 'RNaseEG: ribonuclease, Rne/Rng family', NULL, 'TIGR00757', NULL, NULL, 2525, 22),
(291124, NULL, 'TIGR01395', NULL, NULL, 'FlgC: flagellar basal-body rod protein FlgC', NULL, 'TIGR01395', NULL, NULL, 4978, 22),
(291125, NULL, 'TIGR02897', NULL, NULL, 'QoxC: cytochrome aa3 quinol oxidase, subunit III', NULL, 'TIGR02897', NULL, NULL, 11138, 22),
(291126, NULL, 'TIGR02786', NULL, NULL, 'addB_alphas: double-strand break repair protein AddB', NULL, 'TIGR02786', NULL, NULL, 14296, 22),
(291127, NULL, 'TIGR03816', NULL, NULL, 'tadE_like_DECH: helicase/secretion neighborhood TadE-like protein', NULL, 'TIGR03816', NULL, NULL, 16189, 22),
(291128, NULL, 'TIGR01742', NULL, NULL, 'SA_tandem_lipo: Staphylococcus tandem lipoproteins', NULL, 'TIGR01742', NULL, NULL, 2953, 22),
(291129, NULL, 'TIGR00233', NULL, NULL, 'trpS: tryptophan--tRNA ligase', NULL, 'TIGR00233', NULL, NULL, 5928, 22),
(291130, NULL, 'TIGR01735', NULL, NULL, 'FGAM_synt: phosphoribosylformylglycinamidine synthase', NULL, 'TIGR01735', NULL, NULL, 2156, 22),
(291131, NULL, 'TIGR00875', NULL, NULL, 'fsa_talC_mipB: fructose-6-phosphate aldolase', NULL, 'TIGR00875', NULL, NULL, 3571, 22),
(291132, NULL, 'TIGR01284', NULL, NULL, 'alt_nitrog_alph: nitrogenase alpha chain', NULL, 'TIGR01284', NULL, NULL, 1308, 22),
(291133, NULL, 'TIGR04282', NULL, NULL, 'glyco_like_cofC: transferase 1, rSAM/selenodomain-associated', NULL, 'TIGR04282', NULL, NULL, 16856, 22),
(291134, NULL, 'TIGR00122', NULL, NULL, 'birA_repr_reg: biotin operon repressor', NULL, 'TIGR00122', NULL, NULL, 5830, 22),
(291135, NULL, 'TIGR00594', NULL, NULL, 'polc: DNA polymerase III, alpha subunit', NULL, 'TIGR00594', NULL, NULL, 4370, 22),
(291136, NULL, 'TIGR03108', NULL, NULL, 'eps_aminotran_1: exosortase A system-associated amidotransferase 1', NULL, 'TIGR03108', NULL, NULL, 14744, 22),
(291137, NULL, 'TIGR03927', NULL, NULL, 'T7SS_EssA_Firm: type VII secretion protein EssA', NULL, 'TIGR03927', NULL, NULL, 14801, 22),
(291138, NULL, 'TIGR00764', NULL, NULL, 'lon_rel: putative ATP-dependent protease', NULL, 'TIGR00764', NULL, NULL, 2656, 22),
(291139, NULL, 'TIGR01100', NULL, NULL, 'V_ATP_synt_C: V-type ATPase, C subunit', NULL, 'TIGR01100', NULL, NULL, 12212, 22),
(291140, NULL, 'TIGR01624', NULL, NULL, 'LRP1_Cterm: LRP1 C-terminal domain', NULL, 'TIGR01624', NULL, NULL, 6556, 22),
(291141, NULL, 'TIGR00240', NULL, NULL, 'ATCase_reg: aspartate carbamoyltransferase, regulatory subunit', NULL, 'TIGR00240', NULL, NULL, 4679, 22),
(291142, NULL, 'TIGR01912', NULL, NULL, 'TatC-Arch: Sec-independent protein translocase TatC', NULL, 'TIGR01912', NULL, NULL, 8735, 22),
(291143, NULL, 'TIGR01515', NULL, NULL, 'branching_enzym: 1,4-alpha-glucan branching enzyme', NULL, 'TIGR01515', NULL, NULL, 5584, 22),
(291144, NULL, 'TIGR04520', NULL, NULL, 'ECF_ATPase_1: energy-coupling factor transporter ATPase', NULL, 'TIGR04520', NULL, NULL, 25226, 22),
(291145, NULL, 'TIGR00492', NULL, NULL, 'alr: alanine racemase', NULL, 'TIGR00492', NULL, NULL, 4785, 22),
(291146, NULL, 'TIGR03551', NULL, NULL, 'F420_cofH: 7,8-didemethyl-8-hydroxy-5-deazariboflavin synthase, CofH subunit', NULL, 'TIGR03551', NULL, NULL, 18397, 22),
(291147, NULL, 'TIGR02582', NULL, NULL, 'cas7_TM1809: CRISPR type III-A/MTUBE-associated RAMP protein Csm3', NULL, 'TIGR02582', NULL, NULL, 9279, 22),
(291148, NULL, 'TIGR02001', NULL, NULL, 'gcw_chp: conserved hypothetical protein', NULL, 'TIGR02001', NULL, NULL, 5272, 22);         
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(291149, NULL, 'TIGR01667', NULL, NULL, 'YCCS_YHJK: integral membrane protein, YccS/YhfK family', NULL, 'TIGR01667', NULL, NULL, 5390, 22),
(291150, NULL, 'TIGR02636', NULL, NULL, 'galM_Leloir: galactose mutarotase', NULL, 'TIGR02636', NULL, NULL, 9231, 22),
(291151, NULL, 'TIGR00063', NULL, NULL, 'folE: GTP cyclohydrolase I', NULL, 'TIGR00063', NULL, NULL, 3218, 22),
(291152, NULL, 'TIGR00546', NULL, NULL, 'lnt: apolipoprotein N-acyltransferase', NULL, 'TIGR00546', NULL, NULL, 768, 22),
(291153, NULL, 'TIGR04329', NULL, NULL, 'cas1_PREFRAN: CRISPR-associated endonuclease Cas1, subtype PREFRAN', NULL, 'TIGR04329', NULL, NULL, 23397, 22),
(291154, NULL, 'TIGR01497', NULL, NULL, 'kdpB: K+-transporting ATPase, B subunit', NULL, 'TIGR01497', NULL, NULL, 5958, 22),
(291155, NULL, 'TIGR03435', NULL, NULL, 'Soli_TIGR03435: soil-associated protein, TIGR03435 family', NULL, 'TIGR03435', NULL, NULL, 19289, 22),
(291156, NULL, 'TIGR04159', NULL, NULL, 'methbact_MbnB: methanobactin biosynthesis cassette protein MbnB', NULL, 'TIGR04159', NULL, NULL, 21372, 22),
(291157, NULL, 'TIGR01345', NULL, NULL, 'malate_syn_G: malate synthase G', NULL, 'TIGR01345', NULL, NULL, 3775, 22),
(291158, NULL, 'TIGR01032', NULL, NULL, 'rplT_bact: ribosomal protein bL20', NULL, 'TIGR01032', NULL, NULL, 5975, 22),
(291159, NULL, 'TIGR00698', NULL, NULL, 'TIGR00698: conserved hypothetical protein', NULL, 'TIGR00698', NULL, NULL, 2163, 22),
(291160, NULL, 'TIGR01461', NULL, NULL, 'greB: transcription elongation factor GreB', NULL, 'TIGR01461', NULL, NULL, 5898, 22),
(291161, NULL, 'TIGR03605', NULL, NULL, 'antibiot_sagB: SagB-type dehydrogenase domain', NULL, 'TIGR03605', NULL, NULL, 17977, 22),
(291162, NULL, 'TIGR02806', NULL, NULL, 'clostrip: clostripain', NULL, 'TIGR02806', NULL, NULL, 8952, 22),
(291163, NULL, 'TIGR01291', NULL, NULL, 'nodJ: ABC-2 type transporter, NodJ family', NULL, 'TIGR01291', NULL, NULL, 1195, 22),
(291164, NULL, 'TIGR00716', NULL, NULL, 'rnhC: ribonuclease HIII', NULL, 'TIGR00716', NULL, NULL, 2176, 22),
(291165, NULL, 'TIGR00868', NULL, NULL, 'hCaCC: calcium-activated chloride channel protein 1', NULL, 'TIGR00868', NULL, NULL, 3524, 22),
(291166, NULL, 'TIGR01783', NULL, NULL, 'TonB-siderophor: TonB-dependent siderophore receptor', NULL, 'TIGR01783', NULL, NULL, 2471, 22),
(291167, NULL, 'TIGR04350', NULL, NULL, 'C_S_lyase_PatB: putative C-S lyase', NULL, 'TIGR04350', NULL, NULL, 23800, 22),
(291168, NULL, 'TIGR00621', NULL, NULL, 'ssb: single-stranded DNA-binding protein', NULL, 'TIGR00621', NULL, NULL, 10569, 22),
(291169, NULL, 'TIGR04016', NULL, NULL, 'WcaB: colanic acid biosynthesis acetyltransferase WcaB', NULL, 'TIGR04016', NULL, NULL, 11780, 22),
(291170, NULL, 'TIGR03381', NULL, NULL, 'agmatine_aguB: N-carbamoylputrescine amidase', NULL, 'TIGR03381', NULL, NULL, 18596, 22),
(291171, NULL, 'TIGR03873', NULL, NULL, 'F420-0_ABC_ATP: proposed F420-0 ABC transporter, ATP-binding protein', NULL, 'TIGR03873', NULL, NULL, 21400, 22),
(291172, NULL, 'TIGR02711', NULL, NULL, 'symport_actP: cation/acetate symporter ActP', NULL, 'TIGR02711', NULL, NULL, 14122, 22),
(291173, NULL, 'TIGR02296', NULL, NULL, 'HpaC: 4-hydroxyphenylacetate 3-monooxygenase, reductase component', NULL, 'TIGR02296', NULL, NULL, 13392, 22),
(291174, NULL, 'TIGR04556', NULL, NULL, 'PKS_assoc: polyketide synthase-associated domain', NULL, 'TIGR04556', NULL, NULL, 23886, 22),
(291175, NULL, 'TIGR04386', NULL, NULL, 'ThiC_like_1: ThiC-like protein 1', NULL, 'TIGR04386', NULL, NULL, NULL, 22),
(291176, NULL, 'TIGR00376', NULL, NULL, 'TIGR00376: putative DNA helicase', NULL, 'TIGR00376', NULL, NULL, 1166, 22),
(291177, NULL, 'TIGR00006', NULL, NULL, 'TIGR00006: 16S rRNA (cytosine(1402)-N(4))-methyltransferase', NULL, 'TIGR00006', NULL, NULL, 6127, 22),
(291178, NULL, 'TIGR01953', NULL, NULL, 'NusA: transcription termination factor NusA', NULL, 'TIGR01953', NULL, NULL, 4164, 22),
(291179, NULL, 'TIGR02970', NULL, NULL, 'succ_dehyd_cytB: succinate dehydrogenase, cytochrome b556 subunit', NULL, 'TIGR02970', NULL, NULL, 9540, 22);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(291180, NULL, 'TIGR02466', NULL, NULL, 'TIGR02466: conserved hypothetical protein', NULL, 'TIGR02466', NULL, NULL, 12996, 22),
(291181, NULL, 'TIGR00505', NULL, NULL, 'ribA: GTP cyclohydrolase II', NULL, 'TIGR00505', NULL, NULL, 3494, 22),
(291182, NULL, 'TIGR03510', NULL, NULL, 'XapX: XapX domain', NULL, 'TIGR03510', NULL, NULL, 17910, 22),
(291183, NULL, 'TIGR00158', NULL, NULL, 'L9: ribosomal protein bL9', NULL, 'TIGR00158', NULL, NULL, 20688, 22),
(291184, NULL, 'TIGR00984', NULL, NULL, '3a0801s03tim44: mitochondrial import inner membrane, translocase subunit', NULL, 'TIGR00984', NULL, NULL, 16567, 22),
(291185, NULL, 'TIGR02541', NULL, NULL, 'flagell_FlgJ: flagellar rod assembly protein/muramidase FlgJ', NULL, 'TIGR02541', NULL, NULL, 11108, 22),
(291186, NULL, 'TIGR02042', NULL, NULL, 'sir: sulfite reductase, ferredoxin dependent', NULL, 'TIGR02042', NULL, NULL, 13347, 22),
(291187, NULL, 'TIGR02194', NULL, NULL, 'GlrX_NrdH: glutaredoxin-like protein NrdH', NULL, 'TIGR02194', NULL, NULL, 12330, 22),
(291188, NULL, 'TIGR01175', NULL, NULL, 'pilM: type IV pilus assembly protein PilM', NULL, 'TIGR01175', NULL, NULL, 6703, 22),
(291189, NULL, 'TIGR02677', NULL, NULL, 'TIGR02677: TIGR02677 family protein', NULL, 'TIGR02677', NULL, NULL, 10410, 22),
(291190, NULL, 'TIGR01059', NULL, NULL, 'gyrB: DNA gyrase, B subunit', NULL, 'TIGR01059', NULL, NULL, 8382, 22),
(291191, NULL, 'TIGR02028', NULL, NULL, 'ChlP: geranylgeranyl reductase', NULL, 'TIGR02028', NULL, NULL, 13099, 22),
(291192, NULL, 'TIGR03975', NULL, NULL, 'rSAM_ocin_1: ribosomal peptide maturation radical SAM protein 1', NULL, 'TIGR03975', NULL, NULL, 11366, 22),
(291193, NULL, 'TIGR04064', NULL, NULL, 'rSAM_nif11: nif11-like peptide radical SAM maturase', NULL, 'TIGR04064', NULL, NULL, 11749, 22),
(291194, NULL, 'TIGR01229', NULL, NULL, 'rocF_arginase: arginase', NULL, 'TIGR01229', NULL, NULL, 9390, 22),
(291195, NULL, 'TIGR04234', NULL, NULL, 'seadorna_RNAP: RNA-directed RNA polymerase', NULL, 'TIGR04234', NULL, NULL, 22853, 22),
(291196, NULL, 'TIGR00832', NULL, NULL, 'acr3: arsenical-resistance protein', NULL, 'TIGR00832', NULL, NULL, 3315, 22),
(291197, NULL, 'TIGR03047', NULL, NULL, 'PS_II_psb28: photosystem II reaction center protein Psb28', NULL, 'TIGR03047', NULL, NULL, 2611, 22),
(291198, NULL, 'TIGR03217', NULL, NULL, '4OH_2_O_val_ald: 4-hydroxy-2-oxovalerate aldolase', NULL, 'TIGR03217', NULL, NULL, 16764, 22),
(291199, NULL, 'TIGR04180', NULL, NULL, 'EDH_00030: NAD dependent epimerase/dehydratase, LLPSF_EDH_00030 family', NULL, 'TIGR04180', NULL, NULL, 21284, 22),
(291200, NULL, 'TIGR00328', NULL, NULL, 'flhB: flagellar biosynthetic protein FlhB', NULL, 'TIGR00328', NULL, NULL, 10162, 22),
(291201, NULL, 'TIGR03721', NULL, NULL, 'exospore_TM: BclB C-terminal domain', NULL, 'TIGR03721', NULL, NULL, 15398, 22),
(291202, NULL, 'TIGR00335', NULL, NULL, 'primase_sml: putative DNA primase, eukaryotic-type, small subunit', NULL, 'TIGR00335', NULL, NULL, 9089, 22),
(291203, NULL, 'TIGR04404', NULL, NULL, 'RiPP_SkfA: sporulation killing factor', NULL, 'TIGR04404', NULL, NULL, 26000, 22),
(291204, NULL, 'TIGR01202', NULL, NULL, 'bchC: chlorophyll synthesis pathway protein BchC', NULL, 'TIGR01202', NULL, NULL, 6582, 22),
(291205, NULL, 'TIGR02847', NULL, NULL, 'CyoD: cytochrome o ubiquinol oxidase subunit IV', NULL, 'TIGR02847', NULL, NULL, 9184, 22),
(291206, NULL, 'TIGR03340', NULL, NULL, 'phn_DUF6: phosphonate utilization associated putative membrane protein', NULL, 'TIGR03340', NULL, NULL, 18076, 22),
(291207, NULL, 'TIGR04057', NULL, NULL, 'SusC_RagA_signa: TonB-dependent outer membrane receptor, SusC/RagA subfamily, signature region', NULL, 'TIGR04057', NULL, NULL, 18263, 22),
(291208, NULL, 'TIGR03707', NULL, NULL, 'PPK2_P_aer: polyphosphate kinase 2', NULL, 'TIGR03707', NULL, NULL, 16032, 22),
(291209, NULL, 'TIGR02684', NULL, NULL, 'dnstrm_HI1420: probable addiction module antidote protein', NULL, 'TIGR02684', NULL, NULL, 13296, 22),
(291210, NULL, 'TIGR00165', NULL, NULL, 'S18: ribosomal protein bS18', NULL, 'TIGR00165', NULL, NULL, 5190, 22);             
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(291211, NULL, 'TIGR02212', NULL, NULL, 'lolCE: lipoprotein releasing system, transmembrane protein, LolC/E family', NULL, 'TIGR02212', NULL, NULL, 11126, 22),
(291212, NULL, 'TIGR01837', NULL, NULL, 'PHA_granule_1: poly(hydroxyalkanoate) granule-associated protein', NULL, 'TIGR01837', NULL, NULL, 12143, 22),
(291213, NULL, 'TIGR02854', NULL, NULL, 'spore_II_GA: sigma-E processing peptidase SpoIIGA', NULL, 'TIGR02854', NULL, NULL, 10245, 22),
(291214, NULL, 'TIGR01960', NULL, NULL, 'ndhF3_CO2: NAD(P)H dehydrogenase, subunit NdhF3 family', NULL, 'TIGR01960', NULL, NULL, 4154, 22),
(291215, NULL, 'TIGR02103', NULL, NULL, 'pullul_strch: alpha-1,6-glucosidases, pullulanase-type', NULL, 'TIGR02103', NULL, NULL, 13857, 22),
(291216, NULL, 'TIGR02480', NULL, NULL, 'fliN: flagellar motor switch protein FliN', NULL, 'TIGR02480', NULL, NULL, 12944, 22),
(291217, NULL, 'TIGR03170', NULL, NULL, 'flgA_cterm: flagella basal body P-ring formation protein FlgA', NULL, 'TIGR03170', NULL, NULL, 15900, 22),
(291218, NULL, 'TIGR01134', NULL, NULL, 'purF: amidophosphoribosyltransferase', NULL, 'TIGR01134', NULL, NULL, 6710, 22),
(291219, NULL, 'TIGR02568', NULL, NULL, 'LcrE: type III secretion regulator YopN/LcrE/InvE/MxiC', NULL, 'TIGR02568', NULL, NULL, 11214, 22),
(291220, NULL, 'TIGR00199', NULL, NULL, 'PncC_domain: amidohydrolase, PncC family', NULL, 'TIGR00199', NULL, NULL, 6429, 22),
(291221, NULL, 'TIGR01080', NULL, NULL, 'rplX_A_E: ribosomal protein uL24', NULL, 'TIGR01080', NULL, NULL, 4891, 22),
(291222, NULL, 'TIGR02289', NULL, NULL, 'M3_not_pepF: oligoendopeptidase, M3 family', NULL, 'TIGR02289', NULL, NULL, 13118, 22),
(291223, NULL, 'TIGR03503', NULL, NULL, 'TIGR03503: TIGR03503 family protein', NULL, 'TIGR03503', NULL, NULL, 16782, 22),
(291224, NULL, 'TIGR00560', NULL, NULL, 'pgsA: CDP-diacylglycerol--glycerol-3-phosphate 3-phosphatidyltransferase', NULL, 'TIGR00560', NULL, NULL, 613, 22),
(291225, NULL, 'TIGR04023', NULL, NULL, 'PPOX_MSMEG_5819: PPOX class F420-dependent enzyme, MSMEG_5819/OxyR family', NULL, 'TIGR04023', NULL, NULL, 11581, 22),
(291226, NULL, 'TIGR01769', NULL, NULL, 'GGGP: phosphoglycerol geranylgeranyltransferase', NULL, 'TIGR01769', NULL, NULL, 1973, 22),
(291227, NULL, 'TIGR00390', NULL, NULL, 'hslU: ATP-dependent protease HslVU, ATPase subunit', NULL, 'TIGR00390', NULL, NULL, 1315, 22),
(291228, NULL, 'TIGR00614', NULL, NULL, 'recQ_fam: ATP-dependent DNA helicase, RecQ family', NULL, 'TIGR00614', NULL, NULL, 841, 22),
(291229, NULL, 'TIGR03258', NULL, NULL, 'PhnT: 2-aminoethylphosphonate ABC transport system, ATP-binding component PhnT', NULL, 'TIGR03258', NULL, NULL, 17090, 22),
(291230, NULL, 'TIGR01790', NULL, NULL, 'carotene-cycl: lycopene cyclase family protein', NULL, 'TIGR01790', NULL, NULL, 2088, 22),
(291231, NULL, 'TIGR01599', NULL, NULL, 'PYST-A: Plasmodium yoelii subtelomeric family PYST-A', NULL, 'TIGR01599', NULL, NULL, 6416, 22),
(291232, NULL, 'TIGR03088', NULL, NULL, 'stp2: sugar transferase, PEP-CTERM/EpsH1 system associated', NULL, 'TIGR03088', NULL, NULL, 14702, 22),
(291233, NULL, 'TIGR02650', NULL, NULL, 'RNase_Z_T_toga: ribonuclease Z, Thermotoga type', NULL, 'TIGR02650', NULL, NULL, 10168, 22),
(291234, NULL, 'TIGR00444', NULL, NULL, 'mazG: MazG family protein', NULL, 'TIGR00444', NULL, NULL, 10169, 22),
(291235, NULL, 'TIGR00369', NULL, NULL, 'unchar_dom_1: uncharacterized domain 1', NULL, 'TIGR00369', NULL, NULL, 6036, 22),
(291236, NULL, 'TIGR04488', NULL, NULL, 'SoxY_true_GGCGG: thiosulfate oxidation carrier protein SoxY', NULL, 'TIGR04488', NULL, NULL, 17971, 22),
(291237, NULL, 'TIGR01304', NULL, NULL, 'IMP_DH_rel_2: IMP dehydrogenase family protein', NULL, 'TIGR01304', NULL, NULL, 1255, 22),
(291238, NULL, 'TIGR02398', NULL, NULL, 'gluc_glyc_Psyn: glucosylglycerol-phosphate synthase', NULL, 'TIGR02398', NULL, NULL, 9621, 22),
(291239, NULL, 'TIGR00274', NULL, NULL, 'TIGR00274: N-acetylmuramic acid 6-phosphate etherase', NULL, 'TIGR00274', NULL, NULL, 602, 22),
(291240, NULL, 'TIGR02459', NULL, NULL, 'CbtB: cobalt transporter subunit CbtB (proposed)', NULL, 'TIGR02459', NULL, NULL, 12927, 22); 
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(291241, NULL, 'TIGR03333', NULL, NULL, 'salvage_mtnX: 2-hydroxy-3-keto-5-methylthiopentenyl-1-phosphate phosphatase', NULL, 'TIGR03333', NULL, NULL, 17864, 22),
(291242, NULL, 'TIGR00730', NULL, NULL, 'TIGR00730: TIGR00730 family protein', NULL, 'TIGR00730', NULL, NULL, 4400, 22),
(291243, NULL, 'TIGR01243', NULL, NULL, 'CDC48: AAA family ATPase, CDC48 subfamily', NULL, 'TIGR01243', NULL, NULL, 334, 22),
(291244, NULL, 'TIGR03428', NULL, NULL, 'ureacarb_perm: permease, urea carboxylase system', NULL, 'TIGR03428', NULL, NULL, 19399, 22),
(291245, NULL, 'TIGR03798', NULL, NULL, 'ocin_TIGR03798: nif11-like leader peptide domain', NULL, 'TIGR03798', NULL, NULL, 16183, 22),
(291246, NULL, 'TIGR02908', NULL, NULL, 'CoxD_Bacillus: cytochrome c oxidase, subunit IVB', NULL, 'TIGR02908', NULL, NULL, 11142, 22),
(291247, NULL, 'TIGR02643', NULL, NULL, 'T_phosphoryl: thymidine phosphorylase', NULL, 'TIGR02643', NULL, NULL, 10207, 22),
(291248, NULL, 'TIGR01413', NULL, NULL, 'Dyp_perox_fam: Dyp-type peroxidase family', NULL, 'TIGR01413', NULL, NULL, 4616, 22),
(291249, NULL, 'TIGR02738', NULL, NULL, 'TrbB: type-F conjugative transfer system pilin assembly thiol-disulfide isomerase TrbB', NULL, 'TIGR02738', NULL, NULL, 14369, 22),
(291250, NULL, 'TIGR03968', NULL, NULL, 'mycofact_TetR: mycofactocin system transcriptional regulator', NULL, 'TIGR03968', NULL, NULL, 16828, 22),
(291251, NULL, 'TIGR00553', NULL, NULL, 'pabB: aminodeoxychorismate synthase, component I', NULL, 'TIGR00553', NULL, NULL, 5519, 22),
(291252, NULL, 'TIGR02813', NULL, NULL, 'omega_3_PfaA: polyketide-type polyunsaturated fatty acid synthase PfaA', NULL, 'TIGR02813', NULL, NULL, 12917, 22),
(291253, NULL, 'TIGR00723', NULL, NULL, 'ttdB_fumA_fumB: hydrolyase, tartrate beta subunit/fumarate domain protein, Fe-S type', NULL, 'TIGR00723', NULL, NULL, 2922, 22),
(291254, NULL, 'TIGR01878', NULL, NULL, 'cas_Csa5: CRISPR type I-A/APERN-associated protein Csa5', NULL, 'TIGR01878', NULL, NULL, 10694, 22),
(291255, NULL, 'TIGR00281', NULL, NULL, 'TIGR00281: segregation and condensation protein B', NULL, 'TIGR00281', NULL, NULL, 11445, 22),
(291256, NULL, 'TIGR02629', NULL, NULL, 'L_rham_iso_rhiz: L-rhamnose catabolism isomerase', NULL, 'TIGR02629', NULL, NULL, 9478, 22),
(291257, NULL, 'TIGR04132', NULL, NULL, 'intra_fol_E_lig: putative folate metabolism gamma-glutamate ligase', NULL, 'TIGR04132', NULL, NULL, 21242, 22),
(291258, NULL, 'TIGR01073', NULL, NULL, 'pcrA: ATP-dependent DNA helicase PcrA', NULL, 'TIGR01073', NULL, NULL, 4851, 22),
(291259, NULL, 'TIGR00451', NULL, NULL, 'unchar_dom_2: uncharacterized domain 2', NULL, 'TIGR00451', NULL, NULL, 1685, 22),
(291260, NULL, 'TIGR02922', NULL, NULL, 'TIGR02922: TIGR02922 family protein', NULL, 'TIGR02922', NULL, NULL, 11355, 22),
(291261, NULL, 'TIGR01127', NULL, NULL, 'ilvA_1Cterm: threonine ammonia-lyase', NULL, 'TIGR01127', NULL, NULL, 5877, 22),
(291262, NULL, 'TIGR03149', NULL, NULL, 'cyt_nit_nrfC: cytochrome c nitrite reductase, Fe-S protein', NULL, 'TIGR03149', NULL, NULL, 15018, 22),
(291263, NULL, 'TIGR00900', NULL, NULL, '2A0121: H+ Antiporter protein', NULL, 'TIGR00900', NULL, NULL, 5334, 22),
(291264, NULL, 'TIGR02110', NULL, NULL, 'PQQ_syn_pqqF: coenzyme PQQ biosynthesis protein PqqF', NULL, 'TIGR02110', NULL, NULL, 13723, 22),
(291265, NULL, 'TIGR03265', NULL, NULL, 'PhnT2: putative 2-aminoethylphosphonate ABC transporter, ATP-binding protein', NULL, 'TIGR03265', NULL, NULL, 17343, 22),
(291266, NULL, 'TIGR01939', NULL, NULL, 'nqrD: NADH:ubiquinone oxidoreductase, Na(+)-translocating, D subunit', NULL, 'TIGR01939', NULL, NULL, 10143, 22),
(291267, NULL, 'TIGR03319', NULL, NULL, 'RNase_Y: ribonuclease Y', NULL, 'TIGR03319', NULL, NULL, 17848, 22),
(291268, NULL, 'TIGR01885', NULL, NULL, 'Orn_aminotrans: ornithine--oxo-acid transaminase', NULL, 'TIGR01885', NULL, NULL, 10635, 22),
(291269, NULL, 'TIGR02745', NULL, NULL, 'ccoG_rdxA_fixG: cytochrome c oxidase accessory protein CcoG', NULL, 'TIGR02745', NULL, NULL, 13588, 22),
(291270, NULL, 'TIGR04118', NULL, NULL, 'Cxxx_AC3_0185: modification target Cys-rich peptide, AC3_0185 family', NULL, 'TIGR04118', NULL, NULL, 21026, 22);   
INSERT INTO "PUBLIC"."SIGNATURE" VALUES
(291271, NULL, 'TIGR01420', NULL, NULL, 'pilT_fam: twitching motility protein', NULL, 'TIGR01420', NULL, NULL, 4985, 22),
(291272, NULL, 'TIGR01250', NULL, NULL, 'pro_imino_pep_2: proline-specific peptidase', NULL, 'TIGR01250', NULL, NULL, 385, 22),
(291273, NULL, 'TIGR02752', NULL, NULL, 'MenG_heptapren: demethylmenaquinone methyltransferase', NULL, 'TIGR02752', NULL, NULL, 13621, 22),
(291274, NULL, 'TIGR00267', NULL, NULL, 'TIGR00267: TIGR00267 family protein', NULL, 'TIGR00267', NULL, NULL, 2453, 22),
(291275, NULL, 'TIGR00437', NULL, NULL, 'feoB: ferrous iron transport protein B', NULL, 'TIGR00437', NULL, NULL, 4004, 22),
(291276, NULL, 'TIGR03442', NULL, NULL, 'TIGR03442: ergothioneine biosynthesis protein EgtC', NULL, 'TIGR03442', NULL, NULL, 19464, 22),
(291277, NULL, 'TIGR03272', NULL, NULL, 'methan_mark_6: putative methanogenesis marker protein 6', NULL, 'TIGR03272', NULL, NULL, 10608, 22),
(291278, NULL, 'TIGR03095', NULL, NULL, 'rusti_cyanin: rusticyanin', NULL, 'TIGR03095', NULL, NULL, 563, 22),
(291279, NULL, 'TIGR03612', NULL, NULL, 'RutA: pyrimidine utilization protein A', NULL, 'TIGR03612', NULL, NULL, 14946, 22),
(291280, NULL, 'TIGR04302', NULL, NULL, 'geo_PqqD_fam: GeoRSP system PqqD family protein', NULL, 'TIGR04302', NULL, NULL, 23050, 22),
(291281, NULL, 'TIGR00607', NULL, NULL, 'rad52: recombination protein rad52', NULL, 'TIGR00607', NULL, NULL, 546, 22),
(291282, NULL, 'inside', NULL, NULL, 'inside cell region', NULL, NULL, NULL, NULL, NULL, 23),
(291283, NULL, 'outside', NULL, NULL, 'outside cell region', NULL, NULL, NULL, NULL, NULL, 23),
(291284, NULL, 'TMhelix', NULL, NULL, 'Region of a membrane-bound protein predicted to be embedded in the membrane.', NULL, NULL, NULL, NULL, NULL, 23),
(291285, NULL, 'O', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 23);              
CREATE INDEX "PUBLIC"."SIGNATURE_AC_IDX" ON "PUBLIC"."SIGNATURE"("ACCESSION"); 
CREATE INDEX "PUBLIC"."SIGNATURE_NAME_IDX" ON "PUBLIC"."SIGNATURE"("SIG_NAME");
CREATE INDEX "PUBLIC"."SIGNATURE_TYPE_IDX" ON "PUBLIC"."SIGNATURE"("TYPE");    
CREATE INDEX "PUBLIC"."SIGNATURE_MD5_IDX" ON "PUBLIC"."SIGNATURE"("MD5");      
CREATE CACHED TABLE "PUBLIC"."SIGNATURE_ABSTRACT_CHUNK"(
    "SIGNATURE_ID" BIGINT NOT NULL,
    "ABSTRACT_CHUNK" VARCHAR(4000),
    "CHUNK_INDEX" INTEGER NOT NULL
);         
ALTER TABLE "PUBLIC"."SIGNATURE_ABSTRACT_CHUNK" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_D4" PRIMARY KEY("SIGNATURE_ID", "CHUNK_INDEX");            
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.SIGNATURE_ABSTRACT_CHUNK; 
CREATE CACHED TABLE "PUBLIC"."SIGNATURE_DEPRECATED_ACS"(
    "SIGNATURE_ID" BIGINT NOT NULL,
    "DEPRECATED_ACCESSIONS" VARCHAR(255)
);       
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.SIGNATURE_DEPRECATED_ACS; 
CREATE CACHED TABLE "PUBLIC"."SIGNATURE_DESCRIPTION_CHUNK"(
    "SIGNATURE_ID" BIGINT NOT NULL,
    "DESCRIPTION_CHUNKS" VARCHAR(4000),
    "CHUNK_INDEX" INTEGER NOT NULL
);  
ALTER TABLE "PUBLIC"."SIGNATURE_DESCRIPTION_CHUNK" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_24" PRIMARY KEY("SIGNATURE_ID", "CHUNK_INDEX");         
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.SIGNATURE_DESCRIPTION_CHUNK;              
CREATE CACHED TABLE "PUBLIC"."SIGNATURE_LIBRARY_RELEASE"(
    "ID" BIGINT NOT NULL,
    "LIBRARY" VARCHAR(255) NOT NULL,
    "VERSION" VARCHAR(255) NOT NULL
);
ALTER TABLE "PUBLIC"."SIGNATURE_LIBRARY_RELEASE" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_CB" PRIMARY KEY("ID");    
-- 23 +/- SELECT COUNT(*) FROM PUBLIC.SIGNATURE_LIBRARY_RELEASE;               
INSERT INTO "PUBLIC"."SIGNATURE_LIBRARY_RELEASE" VALUES
(1, 'ANTIFAM', '7.0'),
(2, 'CDD', '3.18'),
(3, 'COILS', '2.2.1'),
(4, 'FUNFAM', '4.3.0'),
(5, 'GENE3D', '4.3.0'),
(6, 'MOBIDB_LITE', '2.0'),
(7, 'HAMAP', '2021_04'),
(8, 'PANTHER', '17.0'),
(9, 'PFAM', '35.0'),
(10, 'PHOBIUS', '1.01'),
(11, 'PIRSF', '3.10'),
(12, 'PIRSR', '2021_05'),
(13, 'PRINTS', '42.0'),
(14, 'PROSITE_PATTERNS', '2022_01'),
(15, 'PROSITE_PROFILES', '2022_01'),
(16, 'SFLD', '4'),
(17, 'SIGNALP_EUK', '4.1'),
(18, 'SIGNALP_GRAM_NEGATIVE', '4.1'),
(19, 'SIGNALP_GRAM_POSITIVE', '4.1'),
(20, 'SMART', '7.1'),
(21, 'SUPERFAMILY', '1.75'),
(22, 'TIGRFAM', '15.0'),
(23, 'TMHMM', '2.0c');           
CREATE CACHED TABLE "PUBLIC"."SIGNATURE_XREF"(
    "ID" BIGINT NOT NULL,
    "DATABASE_NAME" VARCHAR(255),
    "IDENTIFIER" VARCHAR(255) NOT NULL,
    "NAME" VARCHAR(255),
    "SIGNATURE_ID" BIGINT NOT NULL
);              
ALTER TABLE "PUBLIC"."SIGNATURE_XREF" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_55" PRIMARY KEY("ID");               
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.SIGNATURE_XREF;           
CREATE INDEX "PUBLIC"."IDX83S1WBLRUSMDTUP0G6Q7QIRGD" ON "PUBLIC"."SIGNATURE_XREF"("IDENTIFIER");               
CREATE CACHED TABLE "PUBLIC"."SMART_RAW_MATCH"(
    "ID" BIGINT NOT NULL,
    "LOC_FRAGMENT_DCS_TATUS" VARCHAR(255),
    "LOCATION_END" INTEGER,
    "LOCATION_START" INTEGER,
    "MODEL_ID" VARCHAR(255),
    "NUMERIC_SEQUENCE_ID" BIGINT,
    "SEQUENCE_ID" VARCHAR(255),
    "SIGNATURE_LIBRARY" VARCHAR(255),
    "SIG_LIB_RELEASE" VARCHAR(255),
    "EVALUE" DOUBLE NOT NULL,
    "HMM_BOUNDS" VARCHAR(2),
    "HMM_END" INTEGER NOT NULL,
    "HMM_START" INTEGER NOT NULL,
    "LOCATION_SCORE" DOUBLE NOT NULL,
    "SCORE" DOUBLE NOT NULL,
    "LOCATION_EVALUE" DOUBLE
);        
ALTER TABLE "PUBLIC"."SMART_RAW_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_19" PRIMARY KEY("ID");              
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.SMART_RAW_MATCH;          
CREATE INDEX "PUBLIC"."SMART_RW_SEQ_IDX" ON "PUBLIC"."SMART_RAW_MATCH"("SEQUENCE_ID");         
CREATE INDEX "PUBLIC"."SMART_RW_NUM_SEQ_IDX" ON "PUBLIC"."SMART_RAW_MATCH"("NUMERIC_SEQUENCE_ID");             
CREATE INDEX "PUBLIC"."SMART_RW_MODEL_IDX" ON "PUBLIC"."SMART_RAW_MATCH"("MODEL_ID");          
CREATE INDEX "PUBLIC"."SMART_RW_SIGLIB_IDX" ON "PUBLIC"."SMART_RAW_MATCH"("SIGNATURE_LIBRARY");
CREATE INDEX "PUBLIC"."SMART_RW_SIGLIB_REL_IDX" ON "PUBLIC"."SMART_RAW_MATCH"("SIG_LIB_RELEASE");              
CREATE CACHED TABLE "PUBLIC"."STEP_EXECUTION"(
    "ID" BIGINT NOT NULL,
    "TIME_COMPLETED" TIMESTAMP,
    "TIME_CREATED" TIMESTAMP,
    "EXCEPTION_FIRST_CHUNK" VARCHAR(4000),
    "PROPORTION_COMPLETED" DOUBLE,
    "TIME_STARTED_RUNNING" TIMESTAMP,
    "STATE" VARCHAR(255),
    "TIME_SUBMITTED" TIMESTAMP,
    "STEP_INSTANCE_ID" BIGINT NOT NULL
); 
ALTER TABLE "PUBLIC"."STEP_EXECUTION" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_249" PRIMARY KEY("ID");              
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.STEP_EXECUTION;           
CREATE CACHED TABLE "PUBLIC"."STEP_INSTANCE"(
    "ID" BIGINT NOT NULL,
    "BOTTOM_MODEL" BIGINT,
    "BOTTOM_PROTEIN" BIGINT,
    "STEP_ID" VARCHAR(255) NOT NULL,
    "TIME_CREATED" TIMESTAMP NOT NULL,
    "TOP_MODEL" BIGINT,
    "TOP_PROTEIN" BIGINT
);
ALTER TABLE "PUBLIC"."STEP_INSTANCE" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_A8" PRIMARY KEY("ID");
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.STEP_INSTANCE;            
CREATE CACHED TABLE "PUBLIC"."STEP_INSTANCE_PARAMETERS"(
    "STEP_INSTANCE_ID" BIGINT NOT NULL,
    "PARAMETERS" VARCHAR(350),
    "PARAMETERS_KEY" VARCHAR(255) NOT NULL
);  
ALTER TABLE "PUBLIC"."STEP_INSTANCE_PARAMETERS" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_83" PRIMARY KEY("STEP_INSTANCE_ID", "PARAMETERS_KEY");     
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.STEP_INSTANCE_PARAMETERS; 
CREATE CACHED TABLE "PUBLIC"."STEP_INSTANCE_STEP_INSTANCE"(
    "STEP_INSTANCE_ID" BIGINT NOT NULL,
    "DEPENDS_UPON_ID" BIGINT NOT NULL
);   
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.STEP_INSTANCE_STEP_INSTANCE;              
CREATE CACHED TABLE "PUBLIC"."SUPERFAM_LOCATION_FRAGMENT"(
    "ID" BIGINT NOT NULL,
    "DC_STATUS" VARCHAR(255) NOT NULL,
    "LOC_END" INTEGER NOT NULL,
    "LOC_START" INTEGER NOT NULL,
    "LOCATION_ID" BIGINT NOT NULL
);             
ALTER TABLE "PUBLIC"."SUPERFAM_LOCATION_FRAGMENT" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_77" PRIMARY KEY("ID");   
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.SUPERFAM_LOCATION_FRAGMENT;               
CREATE CACHED TABLE "PUBLIC"."SUPERFAMILYHMMER3_LOCATION"(
    "ID" BIGINT NOT NULL,
    "LOC_END" INTEGER NOT NULL,
    "LOC_START" INTEGER NOT NULL,
    "MATCH_ID" BIGINT NOT NULL,
    "HMM_LENGTH" INTEGER NOT NULL
);    
ALTER TABLE "PUBLIC"."SUPERFAMILYHMMER3_LOCATION" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_E5" PRIMARY KEY("ID");   
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.SUPERFAMILYHMMER3_LOCATION;               
CREATE CACHED TABLE "PUBLIC"."SUPER_FAMILY_HMMER3MATCH"(
    "ID" BIGINT NOT NULL,
    "SIGNATURE_MODELS" VARCHAR(255),
    "PROTEIN_ID" BIGINT NOT NULL,
    "SIGNATURE_ID" BIGINT NOT NULL,
    "EVALUE" DOUBLE NOT NULL
);  
ALTER TABLE "PUBLIC"."SUPER_FAMILY_HMMER3MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_11A" PRIMARY KEY("ID");    
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.SUPER_FAMILY_HMMER3MATCH; 
CREATE CACHED TABLE "PUBLIC"."TIGRFAM_H2_RAW_MATCH"(
    "ID" BIGINT NOT NULL,
    "LOC_FRAGMENT_DCS_TATUS" VARCHAR(255),
    "LOCATION_END" INTEGER,
    "LOCATION_START" INTEGER,
    "MODEL_ID" VARCHAR(255),
    "NUMERIC_SEQUENCE_ID" BIGINT,
    "SEQUENCE_ID" VARCHAR(255),
    "SIGNATURE_LIBRARY" VARCHAR(255),
    "SIG_LIB_RELEASE" VARCHAR(255),
    "EVALUE" DOUBLE NOT NULL,
    "HMM_BOUNDS" VARCHAR(2),
    "HMM_END" INTEGER NOT NULL,
    "HMM_START" INTEGER NOT NULL,
    "LOCATION_SCORE" DOUBLE NOT NULL,
    "SCORE" DOUBLE NOT NULL,
    "LOCATION_EVALUE" DOUBLE
);   
ALTER TABLE "PUBLIC"."TIGRFAM_H2_RAW_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_572" PRIMARY KEY("ID");        
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.TIGRFAM_H2_RAW_MATCH;     
CREATE INDEX "PUBLIC"."TIGRFAM2_RW_SEQ_IDX" ON "PUBLIC"."TIGRFAM_H2_RAW_MATCH"("SEQUENCE_ID"); 
CREATE INDEX "PUBLIC"."TIGRFAM2_RW_NUM_SEQ_IDX" ON "PUBLIC"."TIGRFAM_H2_RAW_MATCH"("NUMERIC_SEQUENCE_ID");     
CREATE INDEX "PUBLIC"."TIGRFAM2_RW_MODEL_IDX" ON "PUBLIC"."TIGRFAM_H2_RAW_MATCH"("MODEL_ID");  
CREATE INDEX "PUBLIC"."TIGRFAM2_RW_SIGLIB_IDX" ON "PUBLIC"."TIGRFAM_H2_RAW_MATCH"("SIGNATURE_LIBRARY");        
CREATE INDEX "PUBLIC"."TIGRFAM2_RW_SIGLIB_REL_IDX" ON "PUBLIC"."TIGRFAM_H2_RAW_MATCH"("SIG_LIB_RELEASE");      
CREATE CACHED TABLE "PUBLIC"."TIGRFAM_HMMER3_RAW_MATCH"(
    "ID" BIGINT NOT NULL,
    "LOC_FRAGMENT_DCS_TATUS" VARCHAR(255),
    "LOCATION_END" INTEGER,
    "LOCATION_START" INTEGER,
    "MODEL_ID" VARCHAR(255),
    "NUMERIC_SEQUENCE_ID" BIGINT,
    "SEQUENCE_ID" VARCHAR(255),
    "SIGNATURE_LIBRARY" VARCHAR(255),
    "SIG_LIB_RELEASE" VARCHAR(255),
    "EVALUE" DOUBLE NOT NULL,
    "HMM_BOUNDS" VARCHAR(2),
    "HMM_END" INTEGER NOT NULL,
    "HMM_START" INTEGER NOT NULL,
    "LOCATION_SCORE" DOUBLE NOT NULL,
    "SCORE" DOUBLE NOT NULL,
    "DOMAIN_BIAS" DOUBLE NOT NULL,
    "DOMAIN_CE_VALUE" DOUBLE NOT NULL,
    "DOMAIN_IE_VALUE" DOUBLE NOT NULL,
    "ENVELOPE_END" INTEGER NOT NULL,
    "ENVELOPE_START" INTEGER NOT NULL,
    "EXPECTED_ACCURACY" DOUBLE NOT NULL,
    "FULL_SEQUENCE_BIAS" DOUBLE NOT NULL,
    "SPLIT_GROUP" BINARY
);   
ALTER TABLE "PUBLIC"."TIGRFAM_HMMER3_RAW_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_C5" PRIMARY KEY("ID");     
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.TIGRFAM_HMMER3_RAW_MATCH; 
CREATE INDEX "PUBLIC"."TIGR3_RW_SEQ_IDX" ON "PUBLIC"."TIGRFAM_HMMER3_RAW_MATCH"("SEQUENCE_ID");
CREATE INDEX "PUBLIC"."TIGR3_RW_NUM_SEQ_IDX" ON "PUBLIC"."TIGRFAM_HMMER3_RAW_MATCH"("NUMERIC_SEQUENCE_ID");    
CREATE INDEX "PUBLIC"."TIGR3_RW_MODEL_IDX" ON "PUBLIC"."TIGRFAM_HMMER3_RAW_MATCH"("MODEL_ID"); 
CREATE INDEX "PUBLIC"."TIGR3_RW_SIGLIB_IDX" ON "PUBLIC"."TIGRFAM_HMMER3_RAW_MATCH"("SIGNATURE_LIBRARY");       
CREATE INDEX "PUBLIC"."TIGR3_RW_SIGLIB_REL_IDX" ON "PUBLIC"."TIGRFAM_HMMER3_RAW_MATCH"("SIG_LIB_RELEASE");     
CREATE CACHED TABLE "PUBLIC"."TMHMM_LOCATION"(
    "ID" BIGINT NOT NULL,
    "LOC_END" INTEGER NOT NULL,
    "LOC_START" INTEGER NOT NULL,
    "MATCH_ID" BIGINT NOT NULL,
    "PREDICTION" VARCHAR(255),
    "SCORE" FLOAT
); 
ALTER TABLE "PUBLIC"."TMHMM_LOCATION" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_EC" PRIMARY KEY("ID");               
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.TMHMM_LOCATION;           
CREATE CACHED TABLE "PUBLIC"."TMHMM_LOCATION_FRAGMENT"(
    "ID" BIGINT NOT NULL,
    "DC_STATUS" VARCHAR(255) NOT NULL,
    "LOC_END" INTEGER NOT NULL,
    "LOC_START" INTEGER NOT NULL,
    "LOCATION_ID" BIGINT NOT NULL
);
ALTER TABLE "PUBLIC"."TMHMM_LOCATION_FRAGMENT" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_E7" PRIMARY KEY("ID");      
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.TMHMM_LOCATION_FRAGMENT;  
CREATE CACHED TABLE "PUBLIC"."TMHMM_MATCH"(
    "ID" BIGINT NOT NULL,
    "SIGNATURE_MODELS" VARCHAR(255),
    "PROTEIN_ID" BIGINT NOT NULL,
    "SIGNATURE_ID" BIGINT NOT NULL
);             
ALTER TABLE "PUBLIC"."TMHMM_MATCH" ADD CONSTRAINT "PUBLIC"."CONSTRAINT_D6" PRIMARY KEY("ID");  
-- 0 +/- SELECT COUNT(*) FROM PUBLIC.TMHMM_MATCH;              
ALTER TABLE "PUBLIC"."NUCLEOTIDE_SEQUENCE" ADD CONSTRAINT "PUBLIC"."UK_BJPFWXIJX26IXPSQTW4J80RMF" UNIQUE("MD5");               
ALTER TABLE "PUBLIC"."SIGNATURE_LIBRARY_RELEASE" ADD CONSTRAINT "PUBLIC"."UKH154M142AEKJT4QSFNDXVDWHX" UNIQUE("LIBRARY", "VERSION");           
ALTER TABLE "PUBLIC"."PROTEIN" ADD CONSTRAINT "PUBLIC"."UK_KB52DIMA7HWK72OPG5KD6H7YE" UNIQUE("MD5");           
ALTER TABLE "PUBLIC"."RELEASE" ADD CONSTRAINT "PUBLIC"."UKPJVE3O33IH6X53P0YH3KX8COH" UNIQUE("VERSION");        
ALTER TABLE "PUBLIC"."PANTHER_MATCH_GO_XREF" ADD CONSTRAINT "PUBLIC"."UK_PTXMO8LBDABIEJDC1OHM47W81" UNIQUE("GO_XREFS_ID");     
ALTER TABLE "PUBLIC"."FINGER_PRINTS_MATCH" ADD CONSTRAINT "PUBLIC"."FK_S99KMAPM5O1OMBJOFS25PODCH" FOREIGN KEY("PROTEIN_ID") REFERENCES "PUBLIC"."PROTEIN"("ID") NOCHECK;       
ALTER TABLE "PUBLIC"."SIGNATURE" ADD CONSTRAINT "PUBLIC"."FK41SQ1S3WA827CS95W6GKHITVM" FOREIGN KEY("ENTRY_ID") REFERENCES "PUBLIC"."ENTRY"("ID") NOCHECK;      
ALTER TABLE "PUBLIC"."RPSBLAST_MATCH" ADD CONSTRAINT "PUBLIC"."FK_IK9OVF90SJQHQKIY4FETVNIHQ" FOREIGN KEY("PROTEIN_ID") REFERENCES "PUBLIC"."PROTEIN"("ID") NOCHECK;            
ALTER TABLE "PUBLIC"."STEP_INSTANCE_PARAMETERS" ADD CONSTRAINT "PUBLIC"."FKDW0CU4ODRTIGS643ACBG7GDQA" FOREIGN KEY("STEP_INSTANCE_ID") REFERENCES "PUBLIC"."STEP_INSTANCE"("ID") NOCHECK;       
ALTER TABLE "PUBLIC"."ENTRY_RELEASE" ADD CONSTRAINT "PUBLIC"."FKPF7GALRBP4G9SYSUEEANH3JDX" FOREIGN KEY("RELEASE_ID") REFERENCES "PUBLIC"."RELEASE"("ID") NOCHECK;              
ALTER TABLE "PUBLIC"."PANTHER_MATCH_GO_XREF" ADD CONSTRAINT "PUBLIC"."FKWUDUHSRVEUNG80ICFKYAK4H2" FOREIGN KEY("PANTHER_MATCH_ID") REFERENCES "PUBLIC"."PANTHER_MATCH"("ID") NOCHECK;           
ALTER TABLE "PUBLIC"."STEP_EXECUTION" ADD CONSTRAINT "PUBLIC"."FKHYJGNS1LEWEFLG9OHT13MMJR8" FOREIGN KEY("STEP_INSTANCE_ID") REFERENCES "PUBLIC"."STEP_INSTANCE"("ID") NOCHECK; 
ALTER TABLE "PUBLIC"."PANTHER_MATCH_GO_XREF" ADD CONSTRAINT "PUBLIC"."FK7OEQSSAT24V71OU1UXVJWF67X" FOREIGN KEY("GO_XREFS_ID") REFERENCES "PUBLIC"."GO_XREF"("ID") NOCHECK;     
ALTER TABLE "PUBLIC"."ENTRY_GO_XREF" ADD CONSTRAINT "PUBLIC"."FKG911E11L18VQYCKJ1QRMPVQF8" FOREIGN KEY("ENTRY_ID") REFERENCES "PUBLIC"."ENTRY"("ID") NOCHECK;  
ALTER TABLE "PUBLIC"."TMHMM_MATCH" ADD CONSTRAINT "PUBLIC"."FK_IU65NIRIHXOJU81R5D4GTOGDG" FOREIGN KEY("PROTEIN_ID") REFERENCES "PUBLIC"."PROTEIN"("ID") NOCHECK;               
ALTER TABLE "PUBLIC"."STEP_INSTANCE_STEP_INSTANCE" ADD CONSTRAINT "PUBLIC"."FK950E0QCTMBGBLD80UR7JH8TQE" FOREIGN KEY("DEPENDS_UPON_ID") REFERENCES "PUBLIC"."STEP_INSTANCE"("ID") NOCHECK;     
ALTER TABLE "PUBLIC"."HMMER2_MATCH" ADD CONSTRAINT "PUBLIC"."FK_7G6V8TXLX7SBPNGLJO4KL9UIA" FOREIGN KEY("PROTEIN_ID") REFERENCES "PUBLIC"."PROTEIN"("ID") NOCHECK;              
ALTER TABLE "PUBLIC"."STEP_INSTANCE_STEP_INSTANCE" ADD CONSTRAINT "PUBLIC"."FKOH4Y45AFRQFFXSKCFK8BNA3SX" FOREIGN KEY("STEP_INSTANCE_ID") REFERENCES "PUBLIC"."STEP_INSTANCE"("ID") NOCHECK;    
ALTER TABLE "PUBLIC"."HMMER3_MATCH" ADD CONSTRAINT "PUBLIC"."FK_CL5CHKUXF7KI3CSRYBHRX9PIM" FOREIGN KEY("SIGNATURE_ID") REFERENCES "PUBLIC"."SIGNATURE"("ID") NOCHECK;          
ALTER TABLE "PUBLIC"."TMHMM_MATCH" ADD CONSTRAINT "PUBLIC"."FK_SYTPCFECL4BJ2QLPEH6WRJDYF" FOREIGN KEY("SIGNATURE_ID") REFERENCES "PUBLIC"."SIGNATURE"("ID") NOCHECK;           
ALTER TABLE "PUBLIC"."PANTHER_MATCH" ADD CONSTRAINT "PUBLIC"."FK_EG4L76EU7APMTSLGW25SNEUTD" FOREIGN KEY("PROTEIN_ID") REFERENCES "PUBLIC"."PROTEIN"("ID") NOCHECK;             
ALTER TABLE "PUBLIC"."PROTEIN_XREF" ADD CONSTRAINT "PUBLIC"."FKRTRD2Y2HA2J2E4EBS45A0BU41" FOREIGN KEY("PROTEIN_ID") REFERENCES "PUBLIC"."PROTEIN"("ID") NOCHECK;               
ALTER TABLE "PUBLIC"."HMMER3_MATCH" ADD CONSTRAINT "PUBLIC"."FK_DEY7VKLEDNNBKXCAJ3EMH1NXQ" FOREIGN KEY("PROTEIN_ID") REFERENCES "PUBLIC"."PROTEIN"("ID") NOCHECK;              
ALTER TABLE "PUBLIC"."PANTHER_MATCH" ADD CONSTRAINT "PUBLIC"."FK_39VYVC342FYTJ1J59RQREBBVE" FOREIGN KEY("SIGNATURE_ID") REFERENCES "PUBLIC"."SIGNATURE"("ID") NOCHECK;         
ALTER TABLE "PUBLIC"."HMMER3_MATCH_WITH_SITES" ADD CONSTRAINT "PUBLIC"."FK_HDSNUE38JKBS20FU0D6CL1OIF" FOREIGN KEY("PROTEIN_ID") REFERENCES "PUBLIC"."PROTEIN"("ID") NOCHECK;   
ALTER TABLE "PUBLIC"."SIGNALP_MATCH" ADD CONSTRAINT "PUBLIC"."FK_QAAUJYE15KT19RU5G9TDRPM4" FOREIGN KEY("SIGNATURE_ID") REFERENCES "PUBLIC"."SIGNATURE"("ID") NOCHECK;          
ALTER TABLE "PUBLIC"."COILS_MATCH" ADD CONSTRAINT "PUBLIC"."FK_M4SSXJXUA113GM90NR5YXOWO4" FOREIGN KEY("SIGNATURE_ID") REFERENCES "PUBLIC"."SIGNATURE"("ID") NOCHECK;           
ALTER TABLE "PUBLIC"."BLAST_PRODOM_MATCH" ADD CONSTRAINT "PUBLIC"."FK_SB3WTQQ94CWVKOG753LG4QCOF" FOREIGN KEY("SIGNATURE_ID") REFERENCES "PUBLIC"."SIGNATURE"("ID") NOCHECK;    
ALTER TABLE "PUBLIC"."SIGNATURE_DEPRECATED_ACS" ADD CONSTRAINT "PUBLIC"."FKOEIK352GN5HKYTW1C050FBCWU" FOREIGN KEY("SIGNATURE_ID") REFERENCES "PUBLIC"."SIGNATURE"("ID") NOCHECK;               
ALTER TABLE "PUBLIC"."FINGER_PRINTS_MATCH" ADD CONSTRAINT "PUBLIC"."FK_MW7SDTO7JAU7P0HPL98WI6VN0" FOREIGN KEY("SIGNATURE_ID") REFERENCES "PUBLIC"."SIGNATURE"("ID") NOCHECK;   
ALTER TABLE "PUBLIC"."SIGNALP_MATCH" ADD CONSTRAINT "PUBLIC"."FK_E74DWI926E0PWLYF9ODC5M7U5" FOREIGN KEY("PROTEIN_ID") REFERENCES "PUBLIC"."PROTEIN"("ID") NOCHECK;             
ALTER TABLE "PUBLIC"."ENTRY_PATHWAY_XREF" ADD CONSTRAINT "PUBLIC"."FKMY1NMNIDILT45FM4I5Q59M1HL" FOREIGN KEY("PATHWAY_XREF_ID") REFERENCES "PUBLIC"."PATHWAY_XREF"("ID") NOCHECK;               
ALTER TABLE "PUBLIC"."NUCLEOTIDE_SEQUENCE_XREF" ADD CONSTRAINT "PUBLIC"."FK7M1I2LDBPFR3KNOXXS753931B" FOREIGN KEY("SEQUENCE_ID") REFERENCES "PUBLIC"."NUCLEOTIDE_SEQUENCE"("ID") NOCHECK;      
ALTER TABLE "PUBLIC"."SIGNATURE_DESCRIPTION_CHUNK" ADD CONSTRAINT "PUBLIC"."FKELB4KTEIG17YBHHK63LRN1CJS" FOREIGN KEY("SIGNATURE_ID") REFERENCES "PUBLIC"."SIGNATURE"("ID") NOCHECK;            
ALTER TABLE "PUBLIC"."ENTRY_GO_XREF" ADD CONSTRAINT "PUBLIC"."FK4SR25UQXYHSJGI6T854VJCVP6" FOREIGN KEY("GO_XREF_ID") REFERENCES "PUBLIC"."GO_XREF"("ID") NOCHECK;              
ALTER TABLE "PUBLIC"."MODEL_DEFINITION_CHUNK" ADD CONSTRAINT "PUBLIC"."FKFWK0V0WMFW9G1GIMC9DX83QBH" FOREIGN KEY("MODEL_ID") REFERENCES "PUBLIC"."MODEL"("ID") NOCHECK;         
ALTER TABLE "PUBLIC"."PROFILE_SCAN_MATCH" ADD CONSTRAINT "PUBLIC"."FK_EWQ9WFI8MVE1D8MSGESJMN91D" FOREIGN KEY("PROTEIN_ID") REFERENCES "PUBLIC"."PROTEIN"("ID") NOCHECK;        
ALTER TABLE "PUBLIC"."PROFILE_SCAN_MATCH" ADD CONSTRAINT "PUBLIC"."FK_GWBDHU2JMG7H5U2LIPJSCJ4MP" FOREIGN KEY("SIGNATURE_ID") REFERENCES "PUBLIC"."SIGNATURE"("ID") NOCHECK;    
ALTER TABLE "PUBLIC"."ENTRY_PATHWAY_XREF" ADD CONSTRAINT "PUBLIC"."FKOAAGH156KSF76V1PL09T85ESH" FOREIGN KEY("ENTRY_ID") REFERENCES "PUBLIC"."ENTRY"("ID") NOCHECK;             
ALTER TABLE "PUBLIC"."MOBIDB_MATCH" ADD CONSTRAINT "PUBLIC"."FK_26BI5S8AKAMGJMYU6E342LIOP" FOREIGN KEY("SIGNATURE_ID") REFERENCES "PUBLIC"."SIGNATURE"("ID") NOCHECK;          
ALTER TABLE "PUBLIC"."ENTRY_ABSTRACT_CHUNK" ADD CONSTRAINT "PUBLIC"."FKQIICRKOQ4TAMHUF4GTT4E0TTS" FOREIGN KEY("ENTRY_ID") REFERENCES "PUBLIC"."ENTRY"("ID") NOCHECK;           
ALTER TABLE "PUBLIC"."SIGNATURE_XREF" ADD CONSTRAINT "PUBLIC"."FKKQCD8SQ1HOSY480CTUOK5W8WY" FOREIGN KEY("SIGNATURE_ID") REFERENCES "PUBLIC"."SIGNATURE"("ID") NOCHECK;         
ALTER TABLE "PUBLIC"."HMMER2_MATCH" ADD CONSTRAINT "PUBLIC"."FK_S8CAJES95CYDNF3S8M2GAXYFX" FOREIGN KEY("SIGNATURE_ID") REFERENCES "PUBLIC"."SIGNATURE"("ID") NOCHECK;          
ALTER TABLE "PUBLIC"."SIGNATURE_ABSTRACT_CHUNK" ADD CONSTRAINT "PUBLIC"."FK1FLJWPGJQVFVBGT3YQ680U24X" FOREIGN KEY("SIGNATURE_ID") REFERENCES "PUBLIC"."SIGNATURE"("ID") NOCHECK;               
ALTER TABLE "PUBLIC"."PATTERN_SCAN_MATCH" ADD CONSTRAINT "PUBLIC"."FK_DI7UCK58XF2VOI75QYTBQHUOR" FOREIGN KEY("SIGNATURE_ID") REFERENCES "PUBLIC"."SIGNATURE"("ID") NOCHECK;    
ALTER TABLE "PUBLIC"."SIGNATURE" ADD CONSTRAINT "PUBLIC"."FKGMIL1JMKO8P0CGEX3X8UPT26K" FOREIGN KEY("SIGNATURE_LIBRARY_RELEASE_ID") REFERENCES "PUBLIC"."SIGNATURE_LIBRARY_RELEASE"("ID") NOCHECK;              
ALTER TABLE "PUBLIC"."MODEL" ADD CONSTRAINT "PUBLIC"."FKSAXHGS684RT5EC1YKD91P4QIK" FOREIGN KEY("SIGNATURE_ID") REFERENCES "PUBLIC"."SIGNATURE"("ID") NOCHECK;  
ALTER TABLE "PUBLIC"."BLAST_PRODOM_MATCH" ADD CONSTRAINT "PUBLIC"."FK_6JA2KQ18P305Q4PRW8JJ6KWU6" FOREIGN KEY("PROTEIN_ID") REFERENCES "PUBLIC"."PROTEIN"("ID") NOCHECK;        
ALTER TABLE "PUBLIC"."SUPER_FAMILY_HMMER3MATCH" ADD CONSTRAINT "PUBLIC"."FK_5DP4R1PG8KSJSV7HTUO1Q88VP" FOREIGN KEY("SIGNATURE_ID") REFERENCES "PUBLIC"."SIGNATURE"("ID") NOCHECK;              
ALTER TABLE "PUBLIC"."MODEL_DESCRIPTION_CHUNK" ADD CONSTRAINT "PUBLIC"."FKLW3Y3GON5IYBLJS1W0CGBN8H9" FOREIGN KEY("MODEL_ID") REFERENCES "PUBLIC"."MODEL"("ID") NOCHECK;        
ALTER TABLE "PUBLIC"."SUPER_FAMILY_HMMER3MATCH" ADD CONSTRAINT "PUBLIC"."FK_8KG45L55WLY27K3DIFYLDFLBS" FOREIGN KEY("PROTEIN_ID") REFERENCES "PUBLIC"."PROTEIN"("ID") NOCHECK;  
ALTER TABLE "PUBLIC"."OPEN_READING_FRAME" ADD CONSTRAINT "PUBLIC"."FK95PMNU6UB0LW2MPRRMBD25YIY" FOREIGN KEY("PROTEIN_ID") REFERENCES "PUBLIC"."PROTEIN"("ID") NOCHECK;         
ALTER TABLE "PUBLIC"."RPSBLAST_MATCH" ADD CONSTRAINT "PUBLIC"."FK_SAQ2H7G9ACMMJ2HVYFA1L65IQ" FOREIGN KEY("SIGNATURE_ID") REFERENCES "PUBLIC"."SIGNATURE"("ID") NOCHECK;        
ALTER TABLE "PUBLIC"."HMMER3_MATCH_WITH_SITES" ADD CONSTRAINT "PUBLIC"."FK_51VT1LUACD879FOQQFINKTY64" FOREIGN KEY("SIGNATURE_ID") REFERENCES "PUBLIC"."SIGNATURE"("ID") NOCHECK;               
ALTER TABLE "PUBLIC"."ENTRY_RELEASE" ADD CONSTRAINT "PUBLIC"."FKMCUONXPV0K0O5JEMOGJTTAWYK" FOREIGN KEY("ENTRY_ID") REFERENCES "PUBLIC"."ENTRY"("ID") NOCHECK;  
ALTER TABLE "PUBLIC"."ENTRY_DESCRIPTION_CHUNK" ADD CONSTRAINT "PUBLIC"."FKNPDB6A4UU2CXREHVEH1VHQ5V8" FOREIGN KEY("ENTRY_ID") REFERENCES "PUBLIC"."ENTRY"("ID") NOCHECK;        
ALTER TABLE "PUBLIC"."NUCLEOTIDE_SEQUENCE_CHUNK" ADD CONSTRAINT "PUBLIC"."FK25V14MIM0TIKA6GRJ60CQGR20" FOREIGN KEY("NUCLEOTIDE_SEQUENCE_ID") REFERENCES "PUBLIC"."NUCLEOTIDE_SEQUENCE"("ID") NOCHECK;          
ALTER TABLE "PUBLIC"."PHOBIUS_MATCH" ADD CONSTRAINT "PUBLIC"."FK_OOJJ9YOWJYWYLMB9K813KWDGU" FOREIGN KEY("PROTEIN_ID") REFERENCES "PUBLIC"."PROTEIN"("ID") NOCHECK;             
ALTER TABLE "PUBLIC"."EXCEPTION_CHUNK" ADD CONSTRAINT "PUBLIC"."FK53IN2U6Y43982K7OQ3PE8AM88" FOREIGN KEY("STEP_EXECUTION_ID") REFERENCES "PUBLIC"."STEP_EXECUTION"("ID") NOCHECK;              
ALTER TABLE "PUBLIC"."OPEN_READING_FRAME" ADD CONSTRAINT "PUBLIC"."FKQIHQOHSNSIXKK9ONWPD0PGX69" FOREIGN KEY("NUCLEOTIDE_SEQUENCE_ID") REFERENCES "PUBLIC"."NUCLEOTIDE_SEQUENCE"("ID") NOCHECK; 
ALTER TABLE "PUBLIC"."MOBIDB_MATCH" ADD CONSTRAINT "PUBLIC"."FK_93R7QLTFYYT4BLDM0CB0FX368" FOREIGN KEY("PROTEIN_ID") REFERENCES "PUBLIC"."PROTEIN"("ID") NOCHECK;              
ALTER TABLE "PUBLIC"."PHOBIUS_MATCH" ADD CONSTRAINT "PUBLIC"."FK_GJF616074S865QQL79E0FJRUY" FOREIGN KEY("SIGNATURE_ID") REFERENCES "PUBLIC"."SIGNATURE"("ID") NOCHECK;         
ALTER TABLE "PUBLIC"."PROTEIN_SEQUENCE_CHUNK" ADD CONSTRAINT "PUBLIC"."FK2ODTCS4P2RG91P4L5YN9OC6K2" FOREIGN KEY("PROTEIN_ID") REFERENCES "PUBLIC"."PROTEIN"("ID") NOCHECK;     
ALTER TABLE "PUBLIC"."PATTERN_SCAN_MATCH" ADD CONSTRAINT "PUBLIC"."FK_8HJL2L27JFMH2IGU0BNI9G7X7" FOREIGN KEY("PROTEIN_ID") REFERENCES "PUBLIC"."PROTEIN"("ID") NOCHECK;        
ALTER TABLE "PUBLIC"."COILS_MATCH" ADD CONSTRAINT "PUBLIC"."FK_S8UPCXE4YWOJ8EKQSCUXWPM8W" FOREIGN KEY("PROTEIN_ID") REFERENCES "PUBLIC"."PROTEIN"("ID") NOCHECK;               
